--# -path=.:alltenses

-- This dictionary is derived from SALDO, see:
--
--   Borin, Lars, Markus Forsberg and Lennart Lönngren 2008.
--   The hunting of the BLARK - SALDO, a freely available lexical database for
--   Swedish language technology. Resourceful language technology.
--   Festschrift in honor of Anna Sågvall Hein, ed. by Joakim Nivre,
--   Mats Dahllöf and Bea¡ta Megyesi.
--   Acta Universitatis Upsaliensis: Studia Linguistica Upsaliensia 7. 21-32.
--   <http://spraakbanken.gu.se/personal/lars/pblctns/ash-fs-080605.pdf>
--
-- Imported to GF by Malin Ahlberg
--
-- This resource is distributed under the free software license LGPL 3.0 or
-- Creative Commons Attribution-Share Alike 2.5 Generic.
concrete OldDictSwe of OldDictSweAbs = CatSwe ** open ParadigmsSwe in {

flags
  optimize=values ; coding=utf8 ;

lin
  vaexa_oever_vbm_1_1_V2 = dirV2 (partV (mkV "växa" "växer" "växa" "växte" "vuxit" "vuxen")"över") ;
  vaexa_ur_vbm_1_1_V2 = dirV2 (partV (mkV "växa" "växer" "växa" "växte" "vuxit" "vuxen")"ur") ;
  vaexa_ifraan_vbm_1_1_V2 = dirV2 (partV (mkV "växa" "växer" "växa" "växte" "vuxit" "vuxen")"ifrån") ;
  vaexa_i_vbm_1_1_V2 = dirV2 (partV (mkV "växa" "växer" "växa" "växte" "vuxit" "vuxen")"i") ;
  vaexa_fraan_vbm_1_1_V2 = dirV2 (partV (mkV "växa" "växer" "växa" "växte" "vuxit" "vuxen")"från") ;
  vaexa_vb_1_1_V = mkV "växa" "växer" "växa" "växte" "vuxit" "vuxen" ;
  varda_vb_1_V = mkV "varda" "varder" "varda" "varde" "vart" "vorden" ;
  utloepa_vb_1_1_V = mkV "utlöpa" "utlöper" "utlöp" "utlöpte" "utlöpt" "utlupen" ;
  uppvaexa_vb_1_1_V = mkV "uppväxa" "uppväxer" "uppväxa" "uppväxte" "uppvuxit" "uppvuxen" ;
  traeda_vb_2_1_V = mkV "träda" "träder" "träd" "trädade" "trädat" "trädd" ;
  tillvaexa_vb_1_1_V = mkV "tillväxa" "tillväxer" "tillväxa" "tillväxte" "tillvuxit" "tillvuxen" ;
  ta_ut_vbm_1_V2 = dirV2 (partV (mkV "ta" "tar" "ta" "tog" "tagit" "tagen")"ut") ;
  ta_ur_vbm_1_V2 = dirV2 (partV (mkV "ta" "tar" "ta" "tog" "tagit" "tagen")"ur") ;
  ta_in_vbm_1_V2 = dirV2 (partV (mkV "ta" "tar" "ta" "tog" "tagit" "tagen")"in") ;
  ta_av_vbm_1_V2 = dirV2 (partV (mkV "ta" "tar" "ta" "tog" "tagit" "tagen")"av") ;
  svaelta_vb_2_1_V = mkV "svälta" "svälter" "svält" "svalt" "svultit" "svält" ;
  spae_ut_vbm_1_1_V2 = dirV2 (partV (mkV "späda" "spär" "spä" "spädde" "spätt" "spädd")"ut") ;
  spae_paa_vbm_1_1_V2 = dirV2 (partV (mkV "späda" "spär" "spä" "spädde" "spätt" "spädd")"på") ;
  snusmala_vb_1_V = mkV "snusmala" "snusmal" "snusmal" "snusmalde" "snusmalt" "snusmald" ;
  skvaetta_vb_1_1_V = mkV "skvätta" "skvätter" "skvätt" "skvatt" "skvätt" "skvättad" ;
  oppvaexa_vb_1_1_V = mkV "oppväxa" "oppväxer" "oppväxa" "oppväxte" "oppvuxit" "oppvuxen" ;
  nypa_till_vbm_1_V2 = dirV2 (partV (mkV "nypa" "nyper" "nyp" "nöp" "nypt" "nypt")"till") ;
  nypa_av_vbm_1_V2 = dirV2 (partV (mkV "nypa" "nyper" "nyp" "nöp" "nypt" "nypt")"av") ;
  nypa_vb_1_V = mkV "nypa" "nyper" "nyp" "nöp" "nypt" "nypt" ;
  klae_ut_vbm_1_1_V2 = dirV2 (partV (mkV "kläda" "klär" "klä" "klädde" "klätt" "klädd")"ut") ;
  klae_paa_vbm_1_1_V2 = dirV2 (partV (mkV "kläda" "klär" "klä" "klädde" "klätt" "klädd")"på") ;
  klae_om_vbm_1_1_V2 = dirV2 (partV (mkV "kläda" "klär" "klä" "klädde" "klätt" "klädd")"om") ;
  klae_av_vbm_1_1_V2 = dirV2 (partV (mkV "kläda" "klär" "klä" "klädde" "klätt" "klädd")"av") ;
  gaa_aat_vbm_1_1_V2 = dirV2 (partV (mkV "gå" "går" "gå" "gick" "gått" "gången")"åt") ;
  gaa_ut_vbm_1_1_V2 = dirV2 (partV (mkV "gå" "går" "gå" "gick" "gått" "gången")"ut") ;
  gaa_paa_vbm_2_1_V2 = dirV2 (partV (mkV "gå" "går" "gå" "gick" "gått" "gången")"på") ;
  gaa_in_vbm_1_1_V2 = dirV2 (partV (mkV "gå" "går" "gå" "gick" "gått" "gången")"in") ;
  gaa_igenom_vbm_1_1_V2 = dirV2 (partV (mkV "gå" "går" "gå" "gick" "gått" "gången")"igenom") ;
  framvaexa_vb_1_1_V = mkV "framväxa" "framväxer" "framväxa" "framväxte" "framvuxit" "framvuxen" ;
  dra_oever_vbm_1_1_V2 = dirV2 (partV (mkV "dra" "drar" "dra" "drog" "dragit" "dragen")"över") ;
  dra_aat_vbm_1_1_V2 = dirV2 (partV (mkV "dra" "drar" "dra" "drog" "dragit" "dragen")"åt") ;
  dra_ut_vbm_1_V2 = dirV2 (partV (mkV "dra" "drar" "dra" "drog" "dragit" "dragen")"ut") ;
  dra_in_vbm_1_V2 = dirV2 (partV (mkV "dra" "drar" "dra" "drog" "dragit" "dragen")"in") ;
  dra_ifraan_vbm_1_1_V2 = dirV2 (partV (mkV "dra" "drar" "dra" "drog" "dragit" "dragen")"ifrån") ;
  dra_av_vbm_1_V2 = dirV2 (partV (mkV "dra" "drar" "dra" "drog" "dragit" "dragen")"av") ;
  ansluta_sig_vbm_1_VR = dirV2 (reflV (mkV "ansluta" "anslöt" "anslutit")) ;
  avhaalla_sig_vbm_1_1_VR = dirV2 (reflV (mkV "avhålla" "avhöll" "avhållit")) ;
  avsvaerja_vb_1_1_V = mkV "avsvärja" "avsvor" "avsvurit" ;
  avsaega_sig_vbm_1_1_VR = dirV2 (reflV (mkV "avsäga" "avsade" "avsagt")) ;
  avvika_vb_1_V = mkV "avvika" "avvek" "avvikit" ;
  befinna_sig_vbm_1_VR = dirV2 (reflV (mkV "befinna" "befann" "befunnit")) ;
  bege_sig_vbm_1_VR = dirV2 (reflV (mkV "bege" "begav" "begett")) ;
  beloepa_sig_vbm_1_1_VR = dirV2 (reflV (mkV "belöpa" "belöpte" "belupit")) ;
  bestrida_vb_1_V = mkV "bestrida" "bestred" "bestritt" ;
  besvaerja_vb_1_1_V = mkV "besvärja" "besvor" "besvurit" ;
  bete_sig_vbm_1_VR = dirV2 (reflV (mkV "bete" "betedde" "betett")) ;
  bli_av_vbm_1_V2 = dirV2 (partV (mkV "bli" "blev" "blivit")"av") ;
  bli_efter_vbm_1_V2 = dirV2 (partV (mkV "bli" "blev" "blivit")"efter") ;
  bli_med_vbm_1_V2 = dirV2 (partV (mkV "bli" "blev" "blivit")"med") ;
  bli_till_vbm_1_V2 = dirV2 (partV (mkV "bli" "blev" "blivit")"till") ;
  bli_utan_vbm_1_V2 = dirV2 (partV (mkV "bli" "blev" "blivit")"utan") ;
  bli_oever_vbm_1_1_V2 = dirV2 (partV (mkV "bli" "blev" "blivit")"över") ;
  bosaetta_sig_vbm_1_1_VR = dirV2 (reflV (mkV "bosätta" "bosatte" "bosatt")) ;
  bre_vb_1_V = mkV "breda" "bredde" "brett" ;
  baera_sig_vbm_1_1_VR = dirV2 (reflV (mkV "bära" "bar" "burit")) ;
  drypa_vb_1_V = mkV "drypa" "dröp" "drupit" ;
  duga_vb_1_V = mkV "duga" "dög" "dugt" ;
  doe_ut_vbm_1_1_V2 = dirV2 (partV (mkV "dö" "dog" "dött")"ut") ;
  finna_sig_vbm_1_VR = dirV2 (reflV (mkV "finna" "fann" "funnit")) ;
  frambesvaerja_vb_1_1_V = mkV "frambesvärja" "frambesvor" "frambesvurit" ;
  fraansaega_sig_vbm_1_1_VR = dirV2 (reflV (mkV "frånsäga" "frånsade" "frånsagt")) ;
  faesta_sig_vbm_1_1_VR = dirV2 (reflV (mkV "fästa" "fäste" "fäst")) ;
  faa_till_vbm_1_1_V2 = dirV2 (partV (mkV "få" "fick" "fått")"till") ;
  foerbinda_sig_vbm_1_1_VR = dirV2 (reflV (mkV "förbinda" "förband" "förbundit")) ;
  foerbryta_sig_vbm_1_1_VR = dirV2 (reflV (mkV "förbryta" "förbröt" "förbrutit")) ;
  foeresaetta_sig_vbm_1_1_VR = dirV2 (reflV (mkV "föresätta" "föresatte" "föresatt")) ;
  foergripa_sig_vbm_1_1_VR = dirV2 (reflV (mkV "förgripa" "förgrep" "förgripit")) ;
  foergaa_sig_vbm_1_1_VR = dirV2 (reflV (mkV "förgå" "förgick" "förgått")) ;
  foerhaalla_sig_vbm_1_1_VR = dirV2 (reflV (mkV "förhålla" "förhöll" "förhållit")) ;
  foerlyfta_sig_vbm_1_1_VR = dirV2 (reflV (mkV "förlyfta" "förlyfte" "förlyft")) ;
  foerse_vb_1_1_V = mkV "förse" "försåg" "försett" ;
  foerskriva_sig_vbm_1_1_VR = dirV2 (reflV (mkV "förskriva" "förskrev" "förskrivit")) ;
  foersova_sig_vbm_1_1_VR = dirV2 (reflV (mkV "försova" "försov" "försovit")) ;
  foersvaerja_vb_1_1_V = mkV "försvärja" "försvor" "försvurit" ;
  foersvaerja_sig_vbm_1_1_VR = dirV2 (reflV (mkV "försvärja" "försvor" "försvurit")) ;
  foersaega_sig_vbm_1_1_VR = dirV2 (reflV (mkV "försäga" "försade" "försagt")) ;
  foertaelja_vb_1_1_V = mkV "förtälja" "förtäljde" "förtäljt" ;
  ge_sig_vbm_1_VR = dirV2 (reflV (mkV "ge" "gav" "gett")) ;
  gifta_sig_vbm_1_VR = dirV2 (reflV (mkV "gifta" "gifte" "gift")) ;
  gaa_an_vbm_1_1_V2 = dirV2 (partV (mkV "gå" "gick" "gått")"an") ;
  gaa_efter_vbm_1_1_V2 = dirV2 (partV (mkV "gå" "gick" "gått")"efter") ;
  gaa_foere_vbm_1_1_V2 = dirV2 (partV (mkV "gå" "gick" "gått")"före") ;
  gaa_igenom_vbm_2_1_V2 = dirV2 (partV (mkV "gå" "gick" "gått")"igenom") ;
  gaa_in_vbm_2_1_V2 = dirV2 (partV (mkV "gå" "gick" "gått")"in") ;
  gaa_med_vbm_1_1_V2 = dirV2 (partV (mkV "gå" "gick" "gått")"med") ;
  gaa_paa_vbm_1_1_V2 = dirV2 (partV (mkV "gå" "gick" "gått")"på") ;
  gaa_till_vbm_1_1_V2 = dirV2 (partV (mkV "gå" "gick" "gått")"till") ;
  gaa_under_vbm_1_1_V2 = dirV2 (partV (mkV "gå" "gick" "gått")"under") ;
  gaa_oever_vbm_1_1_V2 = dirV2 (partV (mkV "gå" "gick" "gått")"över") ;
  goera_sig_vbm_1_1_VR = dirV2 (reflV (mkV "göra" "gjorde" "gjort")) ;
  heta_vb_1_V = mkV "heta" "hette" "hetat" ;
  hopvika_vb_1_V = mkV "hopvika" "hopvek" "hopvikit" ;
  haenge_sig_vbm_1_1_VR = dirV2 (reflV (mkV "hänge" "hängav" "hängett")) ;
  haalla_sig_vbm_1_1_VR = dirV2 (reflV (mkV "hålla" "höll" "hållit")) ;
  hoeja_sig_vbm_1_1_VR = dirV2 (reflV (mkV "höja" "höjde" "höjt")) ;
  ifoera_sig_vbm_1_1_VR = dirV2 (reflV (mkV "iföra" "iförde" "ifört")) ;
  infinna_sig_vbm_1_VR = dirV2 (reflV (mkV "infinna" "infann" "infunnit")) ;
  inlaata_sig_vbm_1_1_VR = dirV2 (reflV (mkV "inlåta" "inlät" "inlåtit")) ;
  klyva_vb_1_V = mkV "klyva" "klöv" "kluvit" ;
  komma_an_vbm_1_V2 = dirV2 (partV (mkV "komma" "kom" "kommit")"an") ;
  komma_foer_vbm_1_1_V2 = dirV2 (partV (mkV "komma" "kom" "kommit")"för") ;
  komma_ifraan_vbm_1_1_V2 = dirV2 (partV (mkV "komma" "kom" "kommit")"ifrån") ;
  komma_sig_vbm_1_VR = dirV2 (reflV (mkV "komma" "kom" "kommit")) ;
  komma_till_vbm_2_V2 = dirV2 (partV (mkV "komma" "kom" "kommit")"till") ;
  komma_vid_vbm_1_V2 = dirV2 (partV (mkV "komma" "kom" "kommit")"vid") ;
  kvida_vb_1_V = mkV "kvida" "kved" "kvidit" ;
  kvaeda_vb_1_1_V = mkV "kväda" "kvad" "kvädit" ;
  kaenna_sig_vbm_1_1_VR = dirV2 (reflV (mkV "känna" "kände" "känt")) ;
  livnaera_sig_vbm_1_1_VR = dirV2 (reflV (mkV "livnära" "livnärde" "livnärt")) ;
  lyda_vb_1_V = mkV "lyda" "lydde" "lytt" ;
  lyfta_sig_vbm_1_VR = dirV2 (reflV (mkV "lyfta" "lyfte" "lyft")) ;
  laegga_sig_vbm_1_1_VR = dirV2 (reflV (mkV "lägga" "lade" "lagt")) ;
  laera_sig_vbm_1_1_VR = dirV2 (reflV (mkV "lära" "lärde" "lärt")) ;
  missminna_sig_vbm_1_VR = dirV2 (reflV (mkV "missminna" "missminde" "missmint")) ;
  motsaetta_sig_vbm_1_1_VR = dirV2 (reflV (mkV "motsätta" "motsatte" "motsatt")) ;
  nedlaata_sig_vbm_1_1_VR = dirV2 (reflV (mkV "nedlåta" "nedlät" "nedlåtit")) ;
  nerlaata_sig_vbm_1_1_VR = dirV2 (reflV (mkV "nerlåta" "nerlät" "nerlåtit")) ;
  noeja_sig_vbm_1_1_VR = dirV2 (reflV (mkV "nöja" "nöjde" "nöjt")) ;
  ondgoera_sig_vbm_1_1_VR = dirV2 (reflV (mkV "ondgöra" "ondgjorde" "ondgjort")) ;
  reda_sig_vbm_1_VR = dirV2 (reflV (mkV "reda" "redde" "rett")) ;
  roera_sig_vbm_1_1_VR = dirV2 (reflV (mkV "röra" "rörde" "rört")) ;
  sammansvaerja_sig_vbm_1_1_VR = dirV2 (reflV (mkV "sammansvärja" "sammansvor" "sammansvurit")) ;
  se_efter_vbm_1_V2 = dirV2 (partV (mkV "se" "såg" "sett")"efter") ;
  se_om_vbm_1_V2 = dirV2 (partV (mkV "se" "såg" "sett")"om") ;
  se_till_vbm_1_V2 = dirV2 (partV (mkV "se" "såg" "sett")"till") ;
  se_ut_vbm_1_V2 = dirV2 (partV (mkV "se" "såg" "sett")"ut") ;
  skaelva_vb_1_1_V = mkV "skälva" "skalv" "skälv" ;
  skaera_sig_vbm_1_1_VR = dirV2 (reflV (mkV "skära" "skar" "skurit")) ;
  slita_sig_vbm_1_VR = dirV2 (reflV (mkV "slita" "slet" "slitit")) ;
  sluta_sig_vbm_1_VR = dirV2 (reflV (mkV "sluta" "slöt" "slutit")) ;
  slaa_an_vbm_1_1_V2 = dirV2 (partV (mkV "slå" "slog" "slagit")"an") ;
  slaa_an_vbm_2_1_V2 = dirV2 (partV (mkV "slå" "slog" "slagit")"an") ;
  slaa_av_vbm_1_1_V2 = dirV2 (partV (mkV "slå" "slog" "slagit")"av") ;
  slaa_fraan_vbm_1_1_V2 = dirV2 (partV (mkV "slå" "slog" "slagit")"från") ;
  slaa_ifraan_vbm_1_1_V2 = dirV2 (partV (mkV "slå" "slog" "slagit")"ifrån") ;
  slaa_igenom_vbm_1_1_V2 = dirV2 (partV (mkV "slå" "slog" "slagit")"igenom") ;
  slaa_in_vbm_1_1_V2 = dirV2 (partV (mkV "slå" "slog" "slagit")"in") ;
  slaa_in_vbm_2_1_V2 = dirV2 (partV (mkV "slå" "slog" "slagit")"in") ;
  slaa_om_vbm_1_1_V2 = dirV2 (partV (mkV "slå" "slog" "slagit")"om") ;
  slaa_paa_vbm_1_1_V2 = dirV2 (partV (mkV "slå" "slog" "slagit")"på") ;
  slaa_runt_vbm_1_1_V2 = dirV2 (partV (mkV "slå" "slog" "slagit")"runt") ;
  slaa_sig_vbm_1_1_VR = dirV2 (reflV (mkV "slå" "slog" "slagit")) ;
  slaa_till_vbm_1_1_V2 = dirV2 (partV (mkV "slå" "slog" "slagit")"till") ;
  slaa_ut_vbm_1_1_V2 = dirV2 (partV (mkV "slå" "slog" "slagit")"ut") ;
  slaa_oever_vbm_1_1_V2 = dirV2 (partV (mkV "slå" "slog" "slagit")"över") ;
  smaella_vb_2_1_V = mkV "smälla" "small" "smäll" ;
  smaella_av_vbm_1_1_V2 = dirV2 (partV (mkV "smälla" "small" "smäll")"av") ;
  smaelta_vb_1_1_V = mkV "smälta" "smalt" "smultit" ;
  snyta_sig_vbm_1_VR = dirV2 (reflV (mkV "snyta" "snöt" "snutit")) ;
  sova_ut_vbm_2_V2 = dirV2 (partV (mkV "sova" "sov" "sovit")"ut") ;
  sova_oever_vbm_1_1_V2 = dirV2 (partV (mkV "sova" "sov" "sovit")"över") ;
  sprida_vb_1_V = mkV "sprida" "spred" "spritt" ;
  sprida_sig_vbm_1_VR = dirV2 (reflV (mkV "sprida" "spred" "spritt")) ;
  sprida_ut_vbm_1_V2 = dirV2 (partV (mkV "sprida" "spred" "spritt")"ut") ;
  spaenna_sig_vbm_1_1_VR = dirV2 (reflV (mkV "spänna" "spände" "spänt")) ;
  strida_vb_1_V = mkV "strida" "stridde" "stritt" ;
  staa_paa_vbm_1_1_V2 = dirV2 (partV (mkV "stå" "stod" "stått")"på") ;
  staa_sig_vbm_1_1_VR = dirV2 (reflV (mkV "stå" "stod" "stått")) ;
  staa_till_vbm_1_1_V2 = dirV2 (partV (mkV "stå" "stod" "stått")"till") ;
  staa_ut_vbm_1_1_V2 = dirV2 (partV (mkV "stå" "stod" "stådd")"ut") ;
  staa_ut_vbm_2_1_V2 = dirV2 (partV (mkV "stå" "stod" "stått")"ut") ;
  staa_oever_vbm_1_1_V2 = dirV2 (partV (mkV "stå" "stod" "stått")"över") ;
  staalsaetta_sig_vbm_1_1_VR = dirV2 (reflV (mkV "stålsätta" "stålsatte" "stålsatt")) ;
  saega_sig_vbm_1_1_VR = dirV2 (reflV (mkV "säga" "sade" "sagt")) ;
  saelja_sig_vbm_1_1_VR = dirV2 (reflV (mkV "sälja" "sålde" "sålt")) ;
  saetta_sig_vbm_1_1_VR = dirV2 (reflV (mkV "sätta" "satte" "satt")) ;
  te_sig_vbm_1_VR = dirV2 (reflV (mkV "te" "tedde" "tett")) ;
  tillgodogoera_sig_vbm_1_1_VR = dirV2 (reflV (mkV "tillgodogöra" "tillgodogjorde" "tillgodogjort")) ;
  tillvinna_sig_vbm_1_VR = dirV2 (reflV (mkV "tillvinna" "tillvann" "tillvunnit")) ;
  taelja_vb_2_1_V = mkV "tälja" "täljde" "täljt" ;
  undanbe_sig_vbm_1_VR = dirV2 (reflV (mkV "undanbe" "undanbad" "undanbett")) ;
  underlaegga_sig_vbm_1_1_VR = dirV2 (reflV (mkV "underlägga" "underlade" "underlagt")) ;
  understaa_sig_vbm_1_1_VR = dirV2 (reflV (mkV "understå" "understod" "understått")) ;
  uppehaalla_sig_vbm_1_1_VR = dirV2 (reflV (mkV "uppehålla" "uppehöll" "uppehållit")) ;
  uppfoera_sig_vbm_1_1_VR = dirV2 (reflV (mkV "uppföra" "uppförde" "uppfört")) ;
  utbe_sig_vbm_1_VR = dirV2 (reflV (mkV "utbe" "utbad" "utbett")) ;
  utbre_vb_1_V = mkV "utbreda" "utbredde" "utbrett" ;
  utfaesta_sig_vbm_1_1_VR = dirV2 (reflV (mkV "utfästa" "utfäste" "utfäst")) ;
  utge_sig_vbm_1_VR = dirV2 (reflV (mkV "utge" "utgav" "utgett")) ;
  utgjuta_sig_vbm_1_VR = dirV2 (reflV (mkV "utgjuta" "utgöt" "utgjutit")) ;
  utlaata_sig_vbm_1_1_VR = dirV2 (reflV (mkV "utlåta" "utlät" "utlåtit")) ;
  utspinna_sig_vbm_1_VR = dirV2 (reflV (mkV "utspinna" "utspann" "utspunnit")) ;
  utsprida_vb_1_V = mkV "utsprida" "utspred" "utspritt" ;
  vika_vb_1_V = mkV "vika" "vek" "vikit" ;
  vinnlaegga_sig_vbm_1_1_VR = dirV2 (reflV (mkV "vinnlägga" "vinnlade" "vinnlagt")) ;
  vrida_sig_vbm_1_VR = dirV2 (reflV (mkV "vrida" "vred" "vridit")) ;
  vaenja_sig_vbm_1_1_VR = dirV2 (reflV (mkV "vänja" "vande" "vant")) ;
  vaaldfoera_sig_vbm_1_1_VR = dirV2 (reflV (mkV "våldföra" "våldförde" "våldfört")) ;
  aatlyda_vb_1_1_V = mkV "åtlyda" "åtlydde" "åtlytt" ;
  aatnoeja_sig_vbm_1_1_VR = dirV2 (reflV (mkV "åtnöja" "åtnöjde" "åtnöjt")) ;
  agera_ut_vbm_1_V2 = dirV2 (partV (mkV "agerar")"ut") ;
  akta_sig_vbm_1_VR = dirV2 (reflV (mkV "aktar")) ;
  anbringa_vb_1_V = mkV "anbringar" ;
  anmaela_sig_vbm_1_1_VR = dirV2 (reflV (mkV "anmäler")) ;
  anpassa_sig_vbm_1_VR = dirV2 (reflV (mkV "anpassar")) ;
  anstraenga_sig_vbm_1_1_VR = dirV2 (reflV (mkV "anstränger")) ;
  apa_efter_vbm_1_V2 = dirV2 (partV (mkV "apar")"efter") ;
  apa_runt_vbm_1_V2 = dirV2 (partV (mkV "apar")"runt") ;
  apa_sig_vbm_1_VR = dirV2 (reflV (mkV "apar")) ;
  armbaaga_sig_vbm_1_1_VR = dirV2 (reflV (mkV "armbågar")) ;
  arta_sig_vbm_1_VR = dirV2 (reflV (mkV "artar")) ;
  avboerda_sig_vbm_1_1_VR = dirV2 (reflV (mkV "avbördar")) ;
  avklae_vb_1_1_V = mkV "avklär" ;
  avkoena_sig_vbm_1_1_VR = dirV2 (reflV (mkV "avkönar")) ;
  avlaegsna_sig_vbm_1_1_VR = dirV2 (reflV (mkV "avlägsnar")) ;
  avreagera_sig_vbm_1_VR = dirV2 (reflV (mkV "avreagerar")) ;
  avteckna_sig_vbm_1_VR = dirV2 (reflV (mkV "avtecknar")) ;
  avtvinga_vb_1_V = mkV "avtvingar" ;
  avtvaa_vb_1_1_V = mkV "avtvår" ;
  avvara_vb_1_V = mkV "avvarar" ;
  backa_ur_vbm_1_V2 = dirV2 (partV (mkV "backar")"ur") ;
  barka_av_vbm_1_V2 = dirV2 (partV (mkV "barkar")"av") ;
  beblanda_sig_vbm_1_VR = dirV2 (reflV (mkV "beblandar")) ;
  becka_sig_vbm_1_VR = dirV2 (reflV (mkV "beckar")) ;
  befatta_sig_vbm_1_VR = dirV2 (reflV (mkV "befattar")) ;
  beflita_sig_vbm_1_VR = dirV2 (reflV (mkV "beflitar")) ;
  begrava_vb_1_V = mkV "begraver" ;
  behaerska_sig_vbm_1_1_VR = dirV2 (reflV (mkV "behärskar")) ;
  beklaga_sig_vbm_1_VR = dirV2 (reflV (mkV "beklagar")) ;
  beklae_vb_1_1_V = mkV "beklär" ;
  bekvaema_sig_vbm_1_1_VR = dirV2 (reflV (mkV "bekvämar")) ;
  bekymra_sig_vbm_1_VR = dirV2 (reflV (mkV "bekymrar")) ;
  bemaektiga_sig_vbm_1_1_VR = dirV2 (reflV (mkV "bemäktigar")) ;
  bemoeda_sig_vbm_1_1_VR = dirV2 (reflV (mkV "bemödar")) ;
  bero_paa_vbm_1_1_V2 = dirV2 (partV (mkV "beror")"på") ;
  berusa_sig_vbm_1_VR = dirV2 (reflV (mkV "berusar")) ;
  besinna_sig_vbm_1_VR = dirV2 (reflV (mkV "besinnar")) ;
  beskaerma_sig_vbm_1_1_VR = dirV2 (reflV (mkV "beskärmar")) ;
  besluta_vb_1_V = mkV "beslutar" ;
  bespetsa_sig_vbm_1_VR = dirV2 (reflV (mkV "bespetsar")) ;
  bestaemma_sig_vbm_1_1_VR = dirV2 (reflV (mkV "bestämmer")) ;
  besvaera_sig_vbm_1_1_VR = dirV2 (reflV (mkV "besvärar")) ;
  betacka_sig_vbm_1_VR = dirV2 (reflV (mkV "betackar")) ;
  betala_vb_1_V = mkV "betalar" ;
  betala_sig_vbm_1_VR = dirV2 (reflV (mkV "betalar")) ;
  betvinga_vb_1_V = mkV "betvingar" ;
  betaenka_sig_vbm_1_1_VR = dirV2 (reflV (mkV "betänker")) ;
  beveka_vb_1_V = mkV "bevekar" ;
  bibringa_vb_1_V = mkV "bibringar" ;
  bikta_sig_vbm_1_VR = dirV2 (reflV (mkV "biktar")) ;
  bistra_till_vbm_1_V2 = dirV2 (partV (mkV "bistrar")"till") ;
  blamera_sig_vbm_1_VR = dirV2 (reflV (mkV "blamerar")) ;
  blomma_ut_vbm_1_V2 = dirV2 (partV (mkV "blommar")"ut") ;
  blotta_sig_vbm_1_VR = dirV2 (reflV (mkV "blottar")) ;
  blusa_sig_vbm_1_VR = dirV2 (reflV (mkV "blusar")) ;
  blaasa_av_vbm_1_1_V2 = dirV2 (partV (mkV "blåser")"av") ;
  bo_oever_vbm_1_1_V2 = dirV2 (partV (mkV "bor")"över") ;
  bocka_sig_vbm_1_VR = dirV2 (reflV (mkV "bockar")) ;
  bringa_vb_1_V = mkV "bringar" ;
  bry_sig_vbm_1_VR = dirV2 (reflV (mkV "bryr")) ;
  braedbeklae_vb_1_1_V = mkV "brädbeklär" ;
  broesta_sig_vbm_1_1_VR = dirV2 (reflV (mkV "bröstar")) ;
  buga_sig_vbm_1_VR = dirV2 (reflV (mkV "bugar")) ;
  baenka_sig_vbm_1_1_VR = dirV2 (reflV (mkV "bänkar")) ;
  baerga_sig_vbm_1_1_VR = dirV2 (reflV (mkV "bärgar")) ;
  baettra_sig_vbm_1_1_VR = dirV2 (reflV (mkV "bättrar")) ;
  boerja_om_vbm_1_1_V2 = dirV2 (partV (mkV "börjar")"om") ;
  chosa_sig_vbm_1_VR = dirV2 (reflV (mkV "chosar")) ;
  dabba_sig_vbm_1_VR = dirV2 (reflV (mkV "dabbar")) ;
  dela_sig_vbm_1_VR = dirV2 (reflV (mkV "delar")) ;
  dra_sig_vbm_1_VR = dirV2 (reflV (mkV "dra")) ;
  drista_sig_vbm_1_VR = dirV2 (reflV (mkV "dristar")) ;
  droga_sig_vbm_1_VR = dirV2 (reflV (mkV "drogar")) ;
  droesa_vb_1_1_V = mkV "dröser" ;
  dumma_sig_vbm_1_VR = dirV2 (reflV (mkV "dummar")) ;
  dyka_vb_1_V = mkV "dyker" ;
  dystra_till_vbm_1_V2 = dirV2 (partV (mkV "dystrar")"till") ;
  doema_ut_vbm_1_1_V2 = dirV2 (partV (mkV "dömer")"ut") ;
  fega_sig_vbm_1_VR = dirV2 (reflV (mkV "fegar")) ;
  fega_ur_vbm_1_V2 = dirV2 (partV (mkV "fegar")"ur") ;
  fjompa_sig_vbm_1_VR = dirV2 (reflV (mkV "fjompar")) ;
  fjaedra_sig_vbm_1_1_VR = dirV2 (reflV (mkV "fjädrar")) ;
  flisa_sig_vbm_1_VR = dirV2 (reflV (mkV "flisar")) ;
  flocka_sig_vbm_1_VR = dirV2 (reflV (mkV "flockar")) ;
  flottyrkoka_vb_1_V = mkV "flottyrkokar" ;
  flytta_sig_vbm_1_VR = dirV2 (reflV (mkV "flyttar")) ;
  flaeka_sig_vbm_1_1_VR = dirV2 (reflV (mkV "fläker")) ;
  floeda_till_vbm_1_1_V2 = dirV2 (partV (mkV "flödar")"till") ;
  floeda_ut_vbm_1_1_V2 = dirV2 (partV (mkV "flödar")"ut") ;
  foga_sig_vbm_1_VR = dirV2 (reflV (mkV "fogar")) ;
  forta_sig_vbm_1_VR = dirV2 (reflV (mkV "fortar")) ;
  fortbilda_sig_vbm_1_VR = dirV2 (reflV (mkV "fortbildar")) ;
  fortplanta_sig_vbm_1_VR = dirV2 (reflV (mkV "fortplantar")) ;
  fortvara_vb_1_V = mkV "fortvarar" ;
  frambringa_vb_1_V = mkV "frambringar" ;
  framtvinga_vb_1_V = mkV "framtvingar" ;
  friska_i_vbm_1_V2 = dirV2 (partV (mkV "friskar")"i") ;
  frottera_sig_vbm_1_VR = dirV2 (reflV (mkV "frotterar")) ;
  fraaga_sig_vbm_1_1_VR = dirV2 (reflV (mkV "frågar")) ;
  froejda_sig_vbm_1_1_VR = dirV2 (reflV (mkV "fröjdar")) ;
  fylka_sig_vbm_1_VR = dirV2 (reflV (mkV "fylkar")) ;
  fyra_av_vbm_1_V2 = dirV2 (partV (mkV "fyrar")"av") ;
  faana_sig_vbm_1_1_VR = dirV2 (reflV (mkV "fånar")) ;
  foerbarma_sig_vbm_1_1_VR = dirV2 (reflV (mkV "förbarmar")) ;
  foerbena_sig_vbm_1_1_VR = dirV2 (reflV (mkV "förbenar")) ;
  foerdjupa_sig_vbm_1_1_VR = dirV2 (reflV (mkV "fördjupar")) ;
  foerestaella_sig_vbm_1_1_VR = dirV2 (reflV (mkV "föreställer")) ;
  foerfasa_sig_vbm_1_1_VR = dirV2 (reflV (mkV "förfasar")) ;
  foerflytta_sig_vbm_1_1_VR = dirV2 (reflV (mkV "förflyttar")) ;
  foerfoga_sig_vbm_1_1_VR = dirV2 (reflV (mkV "förfogar")) ;
  foerfriska_sig_vbm_1_1_VR = dirV2 (reflV (mkV "förfriskar")) ;
  foerfraaga_sig_vbm_1_1_VR = dirV2 (reflV (mkV "förfrågar")) ;
  foergapa_sig_vbm_1_1_VR = dirV2 (reflV (mkV "förgapar")) ;
  foergrena_sig_vbm_1_1_VR = dirV2 (reflV (mkV "förgrenar")) ;
  foerhasta_sig_vbm_1_1_VR = dirV2 (reflV (mkV "förhastar")) ;
  foerhaerda_sig_vbm_1_1_VR = dirV2 (reflV (mkV "förhärdar")) ;
  foerhaeva_sig_vbm_1_1_VR = dirV2 (reflV (mkV "förhäver")) ;
  foerirra_sig_vbm_1_1_VR = dirV2 (reflV (mkV "förirrar")) ;
  foerivra_sig_vbm_1_1_VR = dirV2 (reflV (mkV "förivrar")) ;
  foerkasta_sig_vbm_1_1_VR = dirV2 (reflV (mkV "förkastar")) ;
  foerklistra_sig_vbm_1_1_VR = dirV2 (reflV (mkV "förklistrar")) ;
  foerkovra_sig_vbm_1_1_VR = dirV2 (reflV (mkV "förkovrar")) ;
  foerkyla_sig_vbm_1_1_VR = dirV2 (reflV (mkV "förkyler")) ;
  foerkoepa_sig_vbm_1_1_VR = dirV2 (reflV (mkV "förköper")) ;
  foerlika_sig_vbm_1_1_VR = dirV2 (reflV (mkV "förlikar")) ;
  foerlita_sig_vbm_1_1_VR = dirV2 (reflV (mkV "förlitar")) ;
  foerlora_sig_vbm_1_1_VR = dirV2 (reflV (mkV "förlorar")) ;
  foerlova_sig_vbm_1_1_VR = dirV2 (reflV (mkV "förlovar")) ;
  foerlusta_sig_vbm_1_1_VR = dirV2 (reflV (mkV "förlustar")) ;
  foerlaesa_sig_vbm_1_1_VR = dirV2 (reflV (mkV "förläser")) ;
  foerloepa_vb_1_1_V = mkV "förlöper" ;
  foerloepa_sig_vbm_1_1_VR = dirV2 (reflV (mkV "förlöper")) ;
  foermena_vb_2_1_V = mkV "förmenar" ;
  foermaela_vb_2_1_V = mkV "förmäler" ;
  foermaela_sig_vbm_1_1_VR = dirV2 (reflV (mkV "förmäler")) ;
  foermaa_sig_vbm_1_1_VR = dirV2 (reflV (mkV "förmår")) ;
  foerneka_sig_vbm_1_1_VR = dirV2 (reflV (mkV "förnekar")) ;
  foerskansa_sig_vbm_1_1_VR = dirV2 (reflV (mkV "förskansar")) ;
  foerstaella_sig_vbm_1_1_VR = dirV2 (reflV (mkV "förställer")) ;
  foersynda_sig_vbm_1_1_VR = dirV2 (reflV (mkV "försyndar")) ;
  foersaekra_sig_vbm_1_1_VR = dirV2 (reflV (mkV "försäkrar")) ;
  foervaenta_sig_vbm_1_1_VR = dirV2 (reflV (mkV "förväntar")) ;
  foeraelska_sig_vbm_1_1_VR = dirV2 (reflV (mkV "förälskar")) ;
  foeroeka_sig_vbm_1_1_VR = dirV2 (reflV (mkV "förökar")) ;
  gloedbaka_vb_1_1_V = mkV "glödbakar" ;
  gona_sig_vbm_1_VR = dirV2 (reflV (mkV "gonar")) ;
  gosa_sig_vbm_1_VR = dirV2 (reflV (mkV "gosar")) ;
  gotta_sig_vbm_1_VR = dirV2 (reflV (mkV "gottar")) ;
  grena_sig_vbm_1_VR = dirV2 (reflV (mkV "grenar")) ;
  graema_sig_vbm_1_1_VR = dirV2 (reflV (mkV "grämer")) ;
  gaelda_vb_1_1_V = mkV "gäldar" ;
  gaella_vb_2_1_V = mkV "gäller" ;
  gaenga_sig_vbm_1_1_VR = dirV2 (reflV (mkV "gängar")) ;
  habilitera_sig_vbm_1_VR = dirV2 (reflV (mkV "habiliterar")) ;
  haja_till_vbm_1_V2 = dirV2 (partV (mkV "hajar")"till") ;
  hanka_sig_vbm_1_VR = dirV2 (reflV (mkV "hankar")) ;
  himla_sig_vbm_1_VR = dirV2 (reflV (mkV "himlar")) ;
  hopbringa_vb_1_V = mkV "hopbringar" ;
  hovera_sig_vbm_1_VR = dirV2 (reflV (mkV "hoverar")) ;
  huka_sig_vbm_1_VR = dirV2 (reflV (mkV "hukar")) ;
  haemna_sig_vbm_1_1_VR = dirV2 (reflV (mkV "hämnar")) ;
  haemta_sig_vbm_1_1_VR = dirV2 (reflV (mkV "hämtar")) ;
  haenga_sig_vbm_1_1_VR = dirV2 (reflV (mkV "hänger")) ;
  haenvaenda_sig_vbm_1_1_VR = dirV2 (reflV (mkV "hänvänder")) ;
  haerskna_till_vbm_1_1_V2 = dirV2 (partV (mkV "härsknar")"till") ;
  haevda_sig_vbm_1_1_VR = dirV2 (reflV (mkV "hävdar")) ;
  iklae_vb_1_1_V = mkV "iklär" ;
  ila_igenom_vbm_1_V2 = dirV2 (partV (mkV "ilar")"igenom") ;
  inbetala_vb_1_V = mkV "inbetalar" ;
  inbilla_sig_vbm_1_VR = dirV2 (reflV (mkV "inbillar")) ;
  inbringa_vb_1_V = mkV "inbringar" ;
  inkoka_vb_1_V = mkV "inkokar" ;
  inrikta_sig_vbm_1_VR = dirV2 (reflV (mkV "inriktar")) ;
  instaella_sig_vbm_1_1_VR = dirV2 (reflV (mkV "inställer")) ;
  intala_sig_vbm_1_VR = dirV2 (reflV (mkV "intalar")) ;
  intressera_sig_vbm_1_VR = dirV2 (reflV (mkV "intresserar")) ;
  irritera_sig_vbm_1_VR = dirV2 (reflV (mkV "irriterar")) ;
  jaemra_sig_vbm_1_1_VR = dirV2 (reflV (mkV "jämrar")) ;
  joensa_sig_vbm_1_1_VR = dirV2 (reflV (mkV "jönsar")) ;
  kasta_sig_vbm_1_VR = dirV2 (reflV (mkV "kastar")) ;
  kila_in_vbm_2_V2 = dirV2 (partV (mkV "kilar")"in") ;
  klanta_sig_vbm_1_VR = dirV2 (reflV (mkV "klantar")) ;
  klara_sig_vbm_1_VR = dirV2 (reflV (mkV "klarar")) ;
  klinga_vb_1_V = mkV "klingar" ;
  klippa_sig_vbm_1_VR = dirV2 (reflV (mkV "klipper")) ;
  klumpa_sig_vbm_1_VR = dirV2 (reflV (mkV "klumpar")) ;
  klyfta_sig_vbm_1_VR = dirV2 (reflV (mkV "klyftar")) ;
  klae_vb_1_1_V = mkV "klär" ;
  knottra_sig_vbm_1_VR = dirV2 (reflV (mkV "knottrar")) ;
  knulla_runt_vbm_1_V2 = dirV2 (partV (mkV "knullar")"runt") ;
  knoela_sig_vbm_1_1_VR = dirV2 (reflV (mkV "knölar")) ;
  koda_av_vbm_1_V2 = dirV2 (partV (mkV "kodar")"av") ;
  koka_vb_1_V = mkV "kokar" ;
  koka_in_vbm_1_V2 = dirV2 (partV (mkV "kokar")"in") ;
  koka_oever_vbm_1_1_V2 = dirV2 (partV (mkV "kokar")"över") ;
  koncentrera_sig_vbm_1_VR = dirV2 (reflV (mkV "koncentrerar")) ;
  konformera_sig_vbm_1_VR = dirV2 (reflV (mkV "konformerar")) ;
  koppla_av_vbm_1_V2 = dirV2 (partV (mkV "kopplar")"av") ;
  korsa_sig_vbm_1_VR = dirV2 (reflV (mkV "korsar")) ;
  korva_sig_vbm_1_VR = dirV2 (reflV (mkV "korvar")) ;
  kosta_paa_vbm_1_1_V2 = dirV2 (partV (mkV "kostar")"på") ;
  krumma_sig_vbm_1_VR = dirV2 (reflV (mkV "krummar")) ;
  kraama_sig_vbm_1_1_VR = dirV2 (reflV (mkV "kråmar")) ;
  kraangla_in_vbm_1_1_V2 = dirV2 (partV (mkV "krånglar")"in") ;
  kuska_runt_vbm_1_V2 = dirV2 (partV (mkV "kuskar")"runt") ;
  kvarvara_vb_1_V = mkV "kvarvarar" ;
  lagra_sig_vbm_1_VR = dirV2 (reflV (mkV "lagrar")) ;
  laka_ur_vbm_1_V2 = dirV2 (partV (mkV "lakar")"ur") ;
  larva_sig_vbm_1_VR = dirV2 (reflV (mkV "larvar")) ;
  lassa_av_vbm_1_V2 = dirV2 (partV (mkV "lassar")"av") ;
  lassa_paa_vbm_1_1_V2 = dirV2 (partV (mkV "lassar")"på") ;
  lata_sig_vbm_1_VR = dirV2 (reflV (mkV "latar")) ;
  legitimera_sig_vbm_1_VR = dirV2 (reflV (mkV "legitimerar")) ;
  levra_sig_vbm_1_VR = dirV2 (reflV (mkV "levrar")) ;
  lokalisera_sig_vbm_1_VR = dirV2 (reflV (mkV "lokaliserar")) ;
  lugga_sig_vbm_1_VR = dirV2 (reflV (mkV "luggar")) ;
  lugna_sig_vbm_1_VR = dirV2 (reflV (mkV "lugnar")) ;
  lura_till_vbm_1_V2 = dirV2 (partV (mkV "lurar")"till") ;
  laegra_sig_vbm_1_1_VR = dirV2 (reflV (mkV "lägrar")) ;
  laemna_av_vbm_1_1_V2 = dirV2 (partV (mkV "lämnar")"av") ;
  laemna_in_vbm_1_1_V2 = dirV2 (partV (mkV "lämnar")"in") ;
  laemna_oever_vbm_1_1_V2 = dirV2 (partV (mkV "lämnar")"över") ;
  laempa_sig_vbm_1_1_VR = dirV2 (reflV (mkV "lämpar")) ;
  laesa_av_vbm_1_1_V2 = dirV2 (partV (mkV "läser")"av") ;
  laesa_in_vbm_1_1_V2 = dirV2 (partV (mkV "läser")"in") ;
  laesa_paa_vbm_1_1_V2 = dirV2 (partV (mkV "läser")"på") ;
  laesa_ut_vbm_1_1_V2 = dirV2 (partV (mkV "läser")"ut") ;
  laasa_in_vbm_1_1_V2 = dirV2 (partV (mkV "låser")"in") ;
  loeda_vb_1_1_V = mkV "lödar" ;
  loejla_sig_vbm_1_1_VR = dirV2 (reflV (mkV "löjlar")) ;
  loena_sig_vbm_1_1_VR = dirV2 (reflV (mkV "lönar")) ;
  loepa_vb_1_1_V = mkV "löper" ;
  loesa_ut_vbm_1_1_V2 = dirV2 (partV (mkV "löser")"ut") ;
  mala_vb_1_V = mkV "maler" ;
  malla_sig_vbm_1_VR = dirV2 (reflV (mkV "mallar")) ;
  marschera_an_vbm_1_V2 = dirV2 (partV (mkV "marscherar")"an") ;
  marschera_av_vbm_1_V2 = dirV2 (partV (mkV "marscherar")"av") ;
  marschera_in_vbm_1_V2 = dirV2 (partV (mkV "marscherar")"in") ;
  marschera_ut_vbm_1_V2 = dirV2 (partV (mkV "marscherar")"ut") ;
  masa_sig_vbm_1_VR = dirV2 (reflV (mkV "masar")) ;
  medbringa_vb_1_V = mkV "medbringar" ;
  mena_vb_1_V = mkV "menar" ;
  missklae_vb_1_1_V = mkV "missklär" ;
  misskunda_sig_vbm_1_VR = dirV2 (reflV (mkV "misskundar")) ;
  missraekna_sig_vbm_1_1_VR = dirV2 (reflV (mkV "missräknar")) ;
  mjoela_sig_vbm_1_1_VR = dirV2 (reflV (mkV "mjölar")) ;
  mopsa_sig_vbm_1_VR = dirV2 (reflV (mkV "mopsar")) ;
  morgna_sig_vbm_1_VR = dirV2 (reflV (mkV "morgnar")) ;
  morna_sig_vbm_1_VR = dirV2 (reflV (mkV "mornar")) ;
  morska_sig_vbm_1_VR = dirV2 (reflV (mkV "morskar")) ;
  morskna_till_vbm_1_V2 = dirV2 (partV (mkV "morsknar")"till") ;
  muppa_sig_vbm_1_VR = dirV2 (reflV (mkV "muppar")) ;
  moeda_sig_vbm_1_1_VR = dirV2 (reflV (mkV "mödar")) ;
  nalka_sig_vbm_1_VR = dirV2 (reflV (mkV "nalkar")) ;
  nedbringa_vb_1_V = mkV "nedbringar" ;
  nerbringa_vb_1_V = mkV "nerbringar" ;
  noppa_sig_vbm_1_VR = dirV2 (reflV (mkV "noppar")) ;
  noppra_sig_vbm_1_VR = dirV2 (reflV (mkV "nopprar")) ;
  nosa_sig_vbm_1_VR = dirV2 (reflV (mkV "nosar")) ;
  nysa_vb_1_V = mkV "nyser" ;
  naerma_sig_vbm_1_1_VR = dirV2 (reflV (mkV "närmar")) ;
  naervara_vb_1_1_V = mkV "närvarar" ;
  naesta_vb_1_1_V = mkV "nästar" ;
  omaka_sig_vbm_1_VR = dirV2 (reflV (mkV "omakar")) ;
  omfoermaela_vb_1_1_V = mkV "omförmäler" ;
  omklae_vb_1_1_V = mkV "omklär" ;
  opphaeva_vb_2_1_V = mkV "opphäver" ;
  orientera_sig_vbm_1_VR = dirV2 (reflV (mkV "orienterar")) ;
  orka_med_vbm_1_V2 = dirV2 (partV (mkV "orkar")"med") ;
  oroa_sig_vbm_1_VR = dirV2 (reflV (mkV "oroar")) ;
  osta_sig_vbm_1_VR = dirV2 (reflV (mkV "ostar")) ;
  pallra_sig_vbm_1_VR = dirV2 (reflV (mkV "pallrar")) ;
  para_sig_vbm_1_VR = dirV2 (reflV (mkV "parar")) ;
  passa_paa_vbm_1_1_V2 = dirV2 (partV (mkV "passar")"på") ;
  passa_sig_vbm_1_VR = dirV2 (reflV (mkV "passar")) ;
  prova_paa_vbm_1_1_V2 = dirV2 (partV (mkV "provar")"på") ;
  praangla_ut_vbm_1_1_V2 = dirV2 (partV (mkV "prånglar")"ut") ;
  proeva_paa_vbm_1_1_V2 = dirV2 (partV (mkV "prövar")"på") ;
  paelsa_paa_vbm_1_1_V2 = dirV2 (partV (mkV "pälsar")"på") ;
  paaspae_vb_1_1_V = mkV "påspär" ;
  paatvinga_vb_1_1_V = mkV "påtvingar" ;
  raka_sig_vbm_1_VR = dirV2 (reflV (mkV "rakar")) ;
  rappa_paa_vbm_1_1_V2 = dirV2 (partV (mkV "rappar")"på") ;
  raska_paa_vbm_1_1_V2 = dirV2 (partV (mkV "raskar")"på") ;
  rekreera_sig_vbm_1_VR = dirV2 (reflV (mkV "rekreerar")) ;
  repa_sig_vbm_1_VR = dirV2 (reflV (mkV "repar")) ;
  reservera_sig_vbm_1_VR = dirV2 (reflV (mkV "reserverar")) ;
  reta_sig_vbm_1_VR = dirV2 (reflV (mkV "retar")) ;
  revanschera_sig_vbm_1_VR = dirV2 (reflV (mkV "revanscherar")) ;
  rikta_in_vbm_1_V2 = dirV2 (partV (mkV "riktar")"in") ;
  roa_sig_vbm_1_VR = dirV2 (reflV (mkV "roar")) ;
  ropa_till_vbm_1_V2 = dirV2 (partV (mkV "ropar")"till") ;
  rota_sig_vbm_1_VR = dirV2 (reflV (mkV "rotar")) ;
  rusa_in_vbm_1_V2 = dirV2 (partV (mkV "rusar")"in") ;
  rusa_ut_vbm_1_V2 = dirV2 (partV (mkV "rusar")"ut") ;
  ryka_vb_1_V = mkV "ryker" ;
  raekna_med_vbm_1_1_V2 = dirV2 (partV (mkV "räknar")"med") ;
  raenta_sig_vbm_1_1_VR = dirV2 (reflV (mkV "räntar")) ;
  raetta_sig_vbm_1_1_VR = dirV2 (reflV (mkV "rättar")) ;
  raa_vb_1_1_V = mkV "rår" ;
  raa_foer_vbm_1_1_V2 = dirV2 (partV (mkV "rår")"för") ;
  raa_om_vbm_1_1_V2 = dirV2 (partV (mkV "rår")"om") ;
  sacka_efter_vbm_1_V2 = dirV2 (partV (mkV "sackar")"efter") ;
  safta_i_vbm_1_V2 = dirV2 (partV (mkV "saftar")"i") ;
  safta_paa_vbm_1_1_V2 = dirV2 (partV (mkV "saftar")"på") ;
  safta_sig_vbm_1_VR = dirV2 (reflV (mkV "saftar")) ;
  safta_till_vbm_1_V2 = dirV2 (partV (mkV "saftar")"till") ;
  sakta_av_vbm_1_V2 = dirV2 (partV (mkV "saktar")"av") ;
  sakta_sig_vbm_1_VR = dirV2 (reflV (mkV "saktar")) ;
  samla_sig_vbm_1_VR = dirV2 (reflV (mkV "samlar")) ;
  sammangadda_sig_vbm_1_VR = dirV2 (reflV (mkV "sammangaddar")) ;
  sansa_sig_vbm_1_VR = dirV2 (reflV (mkV "sansar")) ;
  sega_sig_vbm_1_VR = dirV2 (reflV (mkV "segar")) ;
  simma_vb_1_V = mkV "simmar" ;
  sippra_ut_vbm_1_V2 = dirV2 (partV (mkV "sipprar")"ut") ;
  sjaelvsaa_sig_vbm_1_1_VR = dirV2 (reflV (mkV "självsår")) ;
  sjaapa_sig_vbm_1_1_VR = dirV2 (reflV (mkV "sjåpar")) ;
  skaffa_sig_vbm_1_VR = dirV2 (reflV (mkV "skaffar")) ;
  skiffra_sig_vbm_1_VR = dirV2 (reflV (mkV "skiffrar")) ;
  skikta_sig_vbm_1_VR = dirV2 (reflV (mkV "skiktar")) ;
  skilja_av_vbm_1_V2 = dirV2 (partV (mkV "skilja")"av") ;
  skilja_sig_vbm_1_VR = dirV2 (reflV (mkV "skilja")) ;
  skilja_aat_vbm_1_1_V2 = dirV2 (partV (mkV "skilja")"åt") ;
  skimra_igenom_vbm_1_V2 = dirV2 (partV (mkV "skimrar")"igenom") ;
  skinna_sig_vbm_1_VR = dirV2 (reflV (mkV "skinnar")) ;
  sko_sig_vbm_1_VR = dirV2 (reflV (mkV "skor")) ;
  skocka_sig_vbm_1_VR = dirV2 (reflV (mkV "skockar")) ;
  skrifta_sig_vbm_1_VR = dirV2 (reflV (mkV "skriftar")) ;
  skrota_sig_vbm_1_VR = dirV2 (reflV (mkV "skrotar")) ;
  skruva_sig_vbm_1_VR = dirV2 (reflV (mkV "skruvar")) ;
  skumma_av_vbm_1_V2 = dirV2 (partV (mkV "skummar")"av") ;
  skaemma_ut_vbm_1_1_V2 = dirV2 (partV (mkV "skämmer")"ut") ;
  skaerpa_sig_vbm_1_1_VR = dirV2 (reflV (mkV "skärper")) ;
  skoeta_sig_vbm_1_1_VR = dirV2 (reflV (mkV "sköter")) ;
  slappna_av_vbm_1_V2 = dirV2 (partV (mkV "slappnar")"av") ;
  sluka_vb_1_V = mkV "slukar" ;
  slumpa_sig_vbm_1_VR = dirV2 (reflV (mkV "slumpar")) ;
  slumra_in_vbm_1_V2 = dirV2 (partV (mkV "slumrar")"in") ;
  slumra_till_vbm_1_V2 = dirV2 (partV (mkV "slumrar")"till") ;
  slaenga_sig_vbm_1_1_VR = dirV2 (reflV (mkV "slänger")) ;
  slaenga_ut_vbm_1_1_V2 = dirV2 (partV (mkV "slänga")"ut") ;
  slaepa_efter_vbm_1_1_V2 = dirV2 (partV (mkV "släpar")"efter") ;
  slaeppa_sig_vbm_1_1_VR = dirV2 (reflV (mkV "släpper")) ;
  smula_sig_vbm_1_VR = dirV2 (reflV (mkV "smular")) ;
  smussla_in_vbm_1_V2 = dirV2 (partV (mkV "smusslar")"in") ;
  snabba_paa_vbm_1_1_V2 = dirV2 (partV (mkV "snabbar")"på") ;
  snabba_sig_vbm_1_VR = dirV2 (reflV (mkV "snabbar")) ;
  snoppa_av_vbm_1_V2 = dirV2 (partV (mkV "snoppar")"av") ;
  snaesa_av_vbm_1_1_V2 = dirV2 (partV (mkV "snäser")"av") ;
  solidarisera_sig_vbm_1_VR = dirV2 (reflV (mkV "solidariserar")) ;
  sopa_till_vbm_1_V2 = dirV2 (partV (mkV "sopar")"till") ;
  spela_vb_1_V = mkV "spelar" ;
  spela_in_vbm_1_V2 = dirV2 (partV (mkV "spelar")"in") ;
  spae_vb_1_1_V = mkV "spär" ;
  staka_sig_vbm_1_VR = dirV2 (reflV (mkV "stakar")) ;
  stocka_sig_vbm_1_VR = dirV2 (reflV (mkV "stockar")) ;
  straffa_sig_vbm_1_VR = dirV2 (reflV (mkV "straffar")) ;
  strypa_vb_1_V = mkV "stryper" ;
  straecka_sig_vbm_1_1_VR = dirV2 (reflV (mkV "sträcker")) ;
  stroemma_in_vbm_1_1_V2 = dirV2 (partV (mkV "strömmar")"in") ;
  stroemma_oever_vbm_1_1_V2 = dirV2 (partV (mkV "strömmar")"över") ;
  stupa_vb_1_V = mkV "stupar" ;
  stygga_sig_vbm_1_VR = dirV2 (reflV (mkV "styggar")) ;
  staella_sig_vbm_1_1_VR = dirV2 (reflV (mkV "ställer")) ;
  stoeka_om_vbm_1_1_V2 = dirV2 (partV (mkV "stökar")"om") ;
  stoeta_sig_vbm_1_1_VR = dirV2 (reflV (mkV "stöter")) ;
  svinga_sig_vbm_1_VR = dirV2 (reflV (mkV "svingar")) ;
  svaenga_sig_vbm_1_1_VR = dirV2 (reflV (mkV "svänger")) ;
  sy_in_vbm_1_V2 = dirV2 (partV (mkV "syr")"in") ;
  saella_sig_vbm_1_1_VR = dirV2 (reflV (mkV "sällar")) ;
  saenda_efter_vbm_1_1_V2 = dirV2 (partV (mkV "sänder")"efter") ;
  soeka_sig_vbm_1_1_VR = dirV2 (reflV (mkV "söker")) ;
  tala_vb_1_V = mkV "talar" ;
  tala_om_vbm_1_V2 = dirV2 (partV (mkV "talar")"om") ;
  tillbringa_vb_1_V = mkV "tillbringar" ;
  tillhandla_sig_vbm_1_VR = dirV2 (reflV (mkV "tillhandlar")) ;
  tillkaempa_sig_vbm_1_1_VR = dirV2 (reflV (mkV "tillkämpar")) ;
  tillskansa_sig_vbm_1_VR = dirV2 (reflV (mkV "tillskansar")) ;
  tilltvinga_sig_vbm_1_VR = dirV2 (reflV (mkV "tilltvingar")) ;
  tillvaegabringa_vb_1_1_V = mkV "tillvägabringar" ;
  tillvaella_sig_vbm_1_1_VR = dirV2 (reflV (mkV "tillvällar")) ;
  tillaegna_sig_vbm_1_1_VR = dirV2 (reflV (mkV "tillägnar")) ;
  tingsmeritera_sig_vbm_1_VR = dirV2 (reflV (mkV "tingsmeriterar")) ;
  tjusa_vb_1_V = mkV "tjusar" ;
  tjaena_av_vbm_1_1_V2 = dirV2 (partV (mkV "tjänar")"av") ;
  tjaena_ut_vbm_1_1_V2 = dirV2 (partV (mkV "tjänar")"ut") ;
  toka_sig_vbm_1_VR = dirV2 (reflV (mkV "tokar")) ;
  torrkoka_vb_1_V = mkV "torrkokar" ;
  tova_sig_vbm_1_VR = dirV2 (reflV (mkV "tovar")) ;
  trilskna_till_vbm_1_V2 = dirV2 (partV (mkV "trilsknar")"till") ;
  trubba_av_vbm_1_V2 = dirV2 (partV (mkV "trubbar")"av") ;
  trumpna_till_vbm_1_V2 = dirV2 (partV (mkV "trumpnar")"till") ;
  trae_vb_1_1_V = mkV "trär" ;
  traenga_sig_vbm_1_1_VR = dirV2 (reflV (mkV "tränger")) ;
  troetta_ut_vbm_1_1_V2 = dirV2 (partV (mkV "tröttar")"ut") ;
  tuva_sig_vbm_1_VR = dirV2 (reflV (mkV "tuvar")) ;
  tvinga_vb_1_V = mkV "tvingar" ;
  tvaa_vb_1_1_V = mkV "tvår" ;
  ty_sig_vbm_1_VR = dirV2 (reflV (mkV "tyr")) ;
  taenda_paa_vbm_1_1_V2 = dirV2 (partV (mkV "tänder")"på") ;
  taenka_sig_vbm_1_1_VR = dirV2 (reflV (mkV "tänker")) ;
  taara_sig_vbm_1_1_VR = dirV2 (reflV (mkV "tårar")) ;
  ugnskoka_vb_1_V = mkV "ugnskokar" ;
  undanhaalla_sig_vbm_1_1_VR = dirV2 (reflV (mkV "undanhålla")) ;
  underbetala_vb_1_V = mkV "underbetalar" ;
  underkasta_sig_vbm_1_VR = dirV2 (reflV (mkV "underkastar")) ;
  undfalla_sig_vbm_1_VR = dirV2 (reflV (mkV "undfalla")) ;
  undvara_vb_1_V = mkV "undvarar" ;
  upphaeva_vb_2_1_V = mkV "upphäver" ;
  uppoffra_sig_vbm_1_VR = dirV2 (reflV (mkV "uppoffrar")) ;
  ursaekta_sig_vbm_1_1_VR = dirV2 (reflV (mkV "ursäktar")) ;
  utbetala_vb_1_V = mkV "utbetalar" ;
  utbringa_vb_1_V = mkV "utbringar" ;
  utmaerka_sig_vbm_1_1_VR = dirV2 (reflV (mkV "utmärker")) ;
  utspela_sig_vbm_1_VR = dirV2 (reflV (mkV "utspelar")) ;
  uttala_sig_vbm_1_VR = dirV2 (reflV (mkV "uttalar")) ;
  utveckla_sig_vbm_1_VR = dirV2 (reflV (mkV "utvecklar")) ;
  valsa_ut_vbm_1_V2 = dirV2 (partV (mkV "valsar")"ut") ;
  vara_sig_vbm_1_VR = dirV2 (reflV (mkV "varar")) ;
  varkunna_sig_vbm_1_VR = dirV2 (reflV (mkV "varkunnar")) ;
  vassla_sig_vbm_1_VR = dirV2 (reflV (mkV "vasslar")) ;
  vikta_sig_vbm_1_VR = dirV2 (reflV (mkV "viktar")) ;
  vila_ut_vbm_1_V2 = dirV2 (partV (mkV "vilar")"ut") ;
  vinda_av_vbm_1_V2 = dirV2 (partV (mkV "vindar")"av") ;
  vira_in_vbm_1_V2 = dirV2 (partV (mkV "virar")"in") ;
  vira_om_vbm_1_V2 = dirV2 (partV (mkV "virar")"om") ;
  visa_in_vbm_1_V2 = dirV2 (partV (mkV "visar")"in") ;
  visa_sig_vbm_1_VR = dirV2 (reflV (mkV "visar")) ;
  voja_sig_vbm_1_VR = dirV2 (reflV (mkV "vojar")) ;
  votera_ut_vbm_1_V2 = dirV2 (partV (mkV "voterar")"ut") ;
  vraeka_sig_vbm_1_1_VR = dirV2 (reflV (mkV "vräker")) ;
  vaeltra_av_vbm_1_1_V2 = dirV2 (partV (mkV "vältrar")"av") ;
  vaeltra_sig_vbm_1_1_VR = dirV2 (reflV (mkV "vältrar")) ;
  vaelva_sig_vbm_1_1_VR = dirV2 (reflV (mkV "välver")) ;
  vaenda_sig_vbm_1_1_VR = dirV2 (reflV (mkV "vänder")) ;
  vaenta_sig_vbm_1_1_VR = dirV2 (reflV (mkV "väntar")) ;
  vaenta_ut_vbm_1_1_V2 = dirV2 (partV (mkV "väntar")"ut") ;
  vaerma_paa_vbm_1_1_V2 = dirV2 (partV (mkV "värmer")"på") ;
  vaetska_sig_vbm_1_1_VR = dirV2 (reflV (mkV "vätskar")) ;
  vaexla_av_vbm_1_1_V2 = dirV2 (partV (mkV "växlar")"av") ;
  vaexla_in_vbm_1_1_V2 = dirV2 (partV (mkV "växlar")"in") ;
  vaaga_sig_vbm_1_1_VR = dirV2 (reflV (mkV "vågar")) ;
  ysta_sig_vbm_1_VR = dirV2 (reflV (mkV "ystar")) ;
  yttra_sig_vbm_1_VR = dirV2 (reflV (mkV "yttrar")) ;
  yva_sig_vbm_1_VR = dirV2 (reflV (mkV "yvar")) ;
  yxa_till_vbm_1_V2 = dirV2 (partV (mkV "yxar")"till") ;
  aegna_sig_vbm_1_1_VR = dirV2 (reflV (mkV "ägnar")) ;
  aendra_sig_vbm_1_1_VR = dirV2 (reflV (mkV "ändrar")) ;
  aengsla_sig_vbm_1_1_VR = dirV2 (reflV (mkV "ängslar")) ;
  aerra_sig_vbm_1_1_VR = dirV2 (reflV (mkV "ärrar")) ;
  aaberopa_sig_vbm_1_1_VR = dirV2 (reflV (mkV "åberopar")) ;
  aabaeka_sig_vbm_1_1_VR = dirV2 (reflV (mkV "åbäkar")) ;
  aama_sig_vbm_1_1_VR = dirV2 (reflV (mkV "åmar")) ;
  aangkoka_vb_1_1_V = mkV "ångkokar" ;
  aangra_sig_vbm_1_1_VR = dirV2 (reflV (mkV "ångrar")) ;
  aaterbetala_vb_1_1_V = mkV "återbetalar" ;
  aaterhaemta_sig_vbm_1_1_VR = dirV2 (reflV (mkV "återhämtar")) ;
  aavaegabringa_vb_1_1_V = mkV "åvägabringar" ;
  oedmjuka_sig_vbm_1_1_VR = dirV2 (reflV (mkV "ödmjukar")) ;
  oegna_igenom_vbm_1_1_V2 = dirV2 (partV (mkV "ögnar")"igenom") ;
  oeka_paa_vbm_1_1_V2 = dirV2 (partV (mkV "ökar")"på") ;
  oeka_till_vbm_1_1_V2 = dirV2 (partV (mkV "ökar")"till") ;
  oemka_sig_vbm_1_1_VR = dirV2 (reflV (mkV "ömkar")) ;
  oeverbringa_vb_1_1_V = mkV "överbringar" ;
  oeverila_sig_vbm_1_1_VR = dirV2 (reflV (mkV "överilar")) ;
  oevervara_vb_1_1_V = mkV "övervarar" ;
  oeverta_vb_1_1_V = mkV "överta" "övertar" "överta" "övertog" "övertagit" "övertagen" ;
  oeversaetta_vb_1_1_V = mkV "översätta" "översätter" "översätt" "översatte" "översatt" "översatt" ;
  oeverge_vb_1_1_V = mkV "överge" "överger" "överge" "övergav" "övergett" "övergiven" ;
  oeverdra_vb_1_1_V = mkV "överdra" "överdrar" "överdra" "överdrog" "överdragit" "överdragen" ;
  aatgaa_vb_1_1_V = mkV "åtgå" "åtgår" "åtgå" "åtgick" "åtgått" "åtgången" ;
  aateruppta_vb_1_1_V = mkV "återuppta" "återupptar" "återuppta" "återupptog" "återupptagit" "återupptagen" ;
  aateruppstaa_vb_1_1_V = mkV "återuppstå" "återuppstår" "återuppstå" "återuppstod" "återuppstått" "återuppstånden" ;
  aaterta_vb_1_1_V = mkV "återta" "återtar" "återta" "återtog" "återtagit" "återtagen" ;
  aaterinsaetta_vb_1_1_V = mkV "återinsätta" "återinsätter" "återinsätt" "återinsatte" "återinsatt" "återinsatt" ;
  aatergaa_vb_1_1_V = mkV "återgå" "återgår" "återgå" "återgick" "återgått" "återgången" ;
  aaterge_vb_1_1_V = mkV "återge" "återger" "återge" "återgav" "återgett" "återgiven" ;
  aasaetta_vb_1_1_V = mkV "åsätta" "åsätter" "åsätt" "åsatte" "åsatt" "åsatt" ;
  aasidosaetta_vb_1_1_V = mkV "åsidosätta" "åsidosätter" "åsidosätt" "åsidosatte" "åsidosatt" "åsidosatt" ;
  aadra_vb_1_1_V = mkV "ådra" "ådrar" "ådra" "ådrog" "ådragit" "ådragen" ;
  vaaldta_vb_1_1_V = mkV "våldta" "våldtar" "våldta" "våldtog" "våldtagit" "våldtagen" ;
  vaerdesaetta_vb_1_1_V = mkV "värdesätta" "värdesätter" "värdesätt" "värdesatte" "värdesatt" "värdesatt" ;
  vaelta_vb_1_1_V = mkV "välta" "välter" "vält" "välte" "vält" "vält" ;
  vidta_vb_1_V = mkV "vidta" "vidtar" "vidta" "vidtog" "vidtagit" "vidtagen" ;
  vakantsaetta_vb_1_1_V = mkV "vakantsätta" "vakantsätter" "vakantsätt" "vakantsatte" "vakantsatt" "vakantsatt" ;
  vakanssaetta_vb_1_1_V = mkV "vakanssätta" "vakanssätter" "vakanssätt" "vakanssatte" "vakanssatt" "vakanssatt" ;
  utsaetta_vb_1_1_V = mkV "utsätta" "utsätter" "utsätt" "utsatte" "utsatt" "utsatt" ;
  utstaa_vb_1_1_V = mkV "utstå" "utstår" "utstå" "utstod" "utstått" "utstånden" ;
  utroena_vb_1_1_V = mkV "utröna" "utröner" "utrön" "utrönte" "utrönt" "utrönt" ;
  utgaa_vb_1_1_V = mkV "utgå" "utgår" "utgå" "utgick" "utgått" "utgången" ;
  utge_vb_1_V = mkV "utge" "utger" "utge" "utgav" "utgett" "utgiven" ;
  utfaesta_vb_1_1_V = mkV "utfästa" "utfäster" "utfäst" "utfäste" "utfäst" "utfäst" ;
  utdra_vb_1_V = mkV "utdra" "utdrar" "utdra" "utdrog" "utdragit" "utdragen" ;
  uppta_vb_1_V = mkV "uppta" "upptar" "uppta" "upptog" "upptagit" "upptagen" ;
  uppsaetta_vb_1_1_V = mkV "uppsätta" "uppsätter" "uppsätt" "uppsatte" "uppsatt" "uppsatt" ;
  uppstaa_vb_1_1_V = mkV "uppstå" "uppstår" "uppstå" "uppstod" "uppstått" "uppstånden" ;
  uppgaa_vb_1_1_V = mkV "uppgå" "uppgår" "uppgå" "uppgick" "uppgått" "uppgången" ;
  uppge_vb_1_V = mkV "uppge" "uppger" "uppge" "uppgav" "uppgett" "uppgiven" ;
  uppdra_vb_1_V = mkV "uppdra" "uppdrar" "uppdra" "uppdrog" "uppdragit" "uppdragen" ;
  undsaetta_vb_1_1_V = mkV "undsätta" "undsätter" "undsätt" "undsatte" "undsatt" "undsatt" ;
  undergaa_vb_1_1_V = mkV "undergå" "undergår" "undergå" "undergick" "undergått" "undergången" ;
  undanta_vb_1_V = mkV "undanta" "undantar" "undanta" "undantog" "undantagit" "undantagen" ;
  taala_vb_1_1_V = mkV "tåla" "tål" "tål" "tålde" "tålt" "tåld" ;
  tonsaetta_vb_1_1_V = mkV "tonsätta" "tonsätter" "tonsätt" "tonsatte" "tonsatt" "tonsatt" ;
  tillvarata_vb_1_V = mkV "tillvarata" "tillvaratar" "tillvarata" "tillvaratog" "tillvaratagit" "tillvaratagen" ;
  tillta_vb_1_V = mkV "tillta" "tilltar" "tillta" "tilltog" "tilltagit" "tilltagen" ;
  tillsaetta_vb_1_1_V = mkV "tillsätta" "tillsätter" "tillsätt" "tillsatte" "tillsatt" "tillsatt" ;
  tillstaedja_vb_1_1_V = mkV "tillstädja" "tillstädjer" "tillstäd" "tillstadde" "tillstatt" "tillstadd" ;
  tillspilloge_vb_1_V = mkV "tillspilloge" "tillspilloger" "tillspilloge" "tillspillogav" "tillspillogett" "tillspillogiven" ;
  tillkaennage_vb_1_1_V = mkV "tillkännage" "tillkännager" "tillkännage" "tillkännagav" "tillkännagett" "tillkännagiven" ;
  tillge_vb_1_V = mkV "tillge" "tillger" "tillge" "tillgav" "tillgett" "tillgiven" ;
  tillfaangata_vb_1_1_V = mkV "tillfångata" "tillfångatar" "tillfångata" "tillfångatog" "tillfångatagit" "tillfångatagen" ;
  tidfaesta_vb_1_1_V = mkV "tidfästa" "tidfäster" "tidfäst" "tidfäste" "tidfäst" "tidfäst" ;
  ta_vb_1_V = mkV "ta" "tar" "ta" "tog" "tagit" "tagen" ;
  saetta_vb_1_1_V = mkV "sätta" "sätter" "sätt" "satte" "satt" "satt" ;
  sysselsaetta_vb_1_1_V = mkV "sysselsätta" "sysselsätter" "sysselsätt" "sysselsatte" "sysselsatt" "sysselsatt" ;
  syrsaetta_vb_1_1_V = mkV "syrsätta" "syrsätter" "syrsätt" "syrsatte" "syrsatt" "syrsatt" ;
  staedja_vb_1_1_V = mkV "städja" "städjer" "städ" "stadde" "statt" "stadd" ;
  strandsaetta_vb_1_1_V = mkV "strandsätta" "strandsätter" "strandsätt" "strandsatte" "strandsatt" "strandsatt" ;
  stjaela_vb_1_1_V = mkV "stjäla" "stjäl" "stjäl" "stal" "stulit" "stulen" ;
  stadfaesta_vb_1_1_V = mkV "stadfästa" "stadfäster" "stadfäst" "stadfäste" "stadfäst" "stadfäst" ;
  spraetta_vb_1_1_V = mkV "sprätta" "sprätter" "sprätt" "sprätte" "sprätt" "sprätt" ;
  smaetta_vb_1_1_V = mkV "smätta" "smätter" "smätt" "smätte" "smätt" "smätt" ;
  smaelta_vb_2_1_V = mkV "smälta" "smälter" "smält" "smälte" "smält" "smält" ;
  smaksaetta_vb_1_1_V = mkV "smaksätta" "smaksätter" "smaksätt" "smaksatte" "smaksatt" "smaksatt" ;
  skvaetta_vb_2_1_V = mkV "skvätta" "skvätter" "skvätt" "skvätte" "skvätt" "skvätt" ;
  skuldsaetta_vb_1_1_V = mkV "skuldsätta" "skuldsätter" "skuldsätt" "skuldsatte" "skuldsatt" "skuldsatt" ;
  sjoesaetta_vb_1_1_V = mkV "sjösätta" "sjösätter" "sjösätt" "sjösatte" "sjösatt" "sjösatt" ;
  segdra_vb_1_V = mkV "segdra" "segdrar" "segdra" "segdrog" "segdragit" "segdragen" ;
  sammansaetta_vb_1_1_V = mkV "sammansätta" "sammansätter" "sammansätt" "sammansatte" "sammansatt" "sammansatt" ;
  sammansmaelta_vb_1_1_V = mkV "sammansmälta" "sammansmälter" "sammansmält" "sammansmälte" "sammansmält" "sammansmält" ;
  sammangaa_vb_1_1_V = mkV "sammangå" "sammangår" "sammangå" "sammangick" "sammangått" "sammangången" ;
  sammandra_vb_1_V = mkV "sammandra" "sammandrar" "sammandra" "sammandrog" "sammandragit" "sammandragen" ;
  samgaa_vb_1_1_V = mkV "samgå" "samgår" "samgå" "samgick" "samgått" "samgången" ;
  roena_vb_1_1_V = mkV "röna" "röner" "rön" "rönte" "rönt" "rönt" ;
  rollbesaetta_vb_1_1_V = mkV "rollbesätta" "rollbesätter" "rollbesätt" "rollbesatte" "rollbesatt" "rollbesatt" ;
  rista_vb_2_V = mkV "rista" "rister" "rist" "ristade" "rist" "ristad" ;
  paata_vb_1_1_V = mkV "påta" "påtar" "påta" "påtog" "påtagit" "påtagen" ;
  prissaetta_vb_1_1_V = mkV "prissätta" "prissätter" "prissätt" "prissatte" "prissatt" "prissatt" ;
  prisge_vb_1_V = mkV "prisge" "prisger" "prisge" "prisgav" "prisgett" "prisgiven" ;
  pantsaetta_vb_1_1_V = mkV "pantsätta" "pantsätter" "pantsätt" "pantsatte" "pantsatt" "pantsatt" ;
  ordinariesaetta_vb_1_1_V = mkV "ordinariesätta" "ordinariesätter" "ordinariesätt" "ordinariesatte" "ordinariesatt" "ordinariesatt" ;
  oppta_vb_1_V = mkV "oppta" "opptar" "oppta" "opptog" "opptagit" "opptagen" ;
  oppsaetta_vb_1_1_V = mkV "oppsätta" "oppsätter" "oppsätt" "oppsatte" "oppsatt" "oppsatt" ;
  oppge_vb_1_V = mkV "oppge" "oppger" "oppge" "oppgav" "oppgett" "oppgiven" ;
  omta_vb_1_V = mkV "omta" "omtar" "omta" "omtog" "omtagit" "omtagen" ;
  omsaetta_vb_1_1_V = mkV "omsätta" "omsätter" "omsätt" "omsatte" "omsatt" "omsatt" ;
  omhaenderta_vb_1_1_V = mkV "omhänderta" "omhändertar" "omhänderta" "omhändertog" "omhändertagit" "omhändertagen" ;
  omge_vb_1_V = mkV "omge" "omger" "omge" "omgav" "omgett" "omgiven" ;
  nersaetta_vb_1_1_V = mkV "nersätta" "nersätter" "nersätt" "nersatte" "nersatt" "nersatt" ;
  nedsaetta_vb_1_1_V = mkV "nedsätta" "nedsätter" "nedsätt" "nedsatte" "nedsatt" "nedsatt" ;
  namnge_vb_1_V = mkV "namnge" "namnger" "namnge" "namngav" "namngett" "namngiven" ;
  namnfaesta_vb_1_1_V = mkV "namnfästa" "namnfäster" "namnfäst" "namnfäste" "namnfäst" "namnfäst" ;
  motta_vb_1_V = mkV "motta" "mottar" "motta" "mottog" "mottagit" "mottagen" ;
  mista_vb_1_V = mkV "mista" "mister" "mist" "mistade" "mist" "mistad" ;
  missta_vb_1_V = mkV "missta" "misstar" "missta" "misstog" "misstagit" "misstagen" ;
  medta_vb_1_V = mkV "medta" "medtar" "medta" "medtog" "medtagit" "medtagen" ;
  medge_vb_1_V = mkV "medge" "medger" "medge" "medgav" "medgett" "medgiven" ;
  lyfta_vb_1_V = mkV "lyfta" "lyfter" "lyft" "lyfte" "lyft" "lyft" ;
  luftlandsaetta_vb_1_1_V = mkV "luftlandsätta" "luftlandsätter" "luftlandsätt" "luftlandsatte" "luftlandsatt" "luftlandsatt" ;
  ljudsaetta_vb_1_1_V = mkV "ljudsätta" "ljudsätter" "ljudsätt" "ljudsatte" "ljudsatt" "ljudsatt" ;
  landsaetta_vb_1_1_V = mkV "landsätta" "landsätter" "landsätt" "landsatte" "landsatt" "landsatt" ;
  lagfaesta_vb_1_1_V = mkV "lagfästa" "lagfäster" "lagfäst" "lagfäste" "lagfäst" "lagfäst" ;
  lagerkroena_vb_1_1_V = mkV "lagerkröna" "lagerkröner" "lagerkrön" "lagerkrönte" "lagerkrönt" "lagerkrönt" ;
  kroena_vb_1_1_V = mkV "kröna" "kröner" "krön" "krönte" "krönt" "krönt" ;
  kringgaa_vb_1_1_V = mkV "kringgå" "kringgår" "kringgå" "kringgick" "kringgått" "kringgången" ;
  korsfaesta_vb_1_1_V = mkV "korsfästa" "korsfäster" "korsfäst" "korsfäste" "korsfäst" "korsfäst" ;
  knaesaetta_vb_1_1_V = mkV "knäsätta" "knäsätter" "knäsätt" "knäsatte" "knäsatt" "knäsatt" ;
  kalldra_vb_1_V = mkV "kalldra" "kalldrar" "kalldra" "kalldrog" "kalldragit" "kalldragen" ;
  jordfaesta_vb_1_1_V = mkV "jordfästa" "jordfäster" "jordfäst" "jordfäste" "jordfäst" "jordfäst" ;
  istaandsaetta_vb_1_1_V = mkV "iståndsätta" "iståndsätter" "iståndsätt" "iståndsatte" "iståndsatt" "iståndsatt" ;
  iscensaetta_vb_1_1_V = mkV "iscensätta" "iscensätter" "iscensätt" "iscensatte" "iscensatt" "iscensatt" ;
  inta_vb_1_V = mkV "inta" "intar" "inta" "intog" "intagit" "intagen" ;
  insaetta_vb_1_1_V = mkV "insätta" "insätter" "insätt" "insatte" "insatt" "insatt" ;
  insmaelta_vb_1_1_V = mkV "insmälta" "insmälter" "insmält" "insmälte" "insmält" "insmält" ;
  ingaa_vb_2_1_V = mkV "ingå" "ingår" "ingå" "ingick" "ingått" "ingången" ;
  inge_vb_1_V = mkV "inge" "inger" "inge" "ingav" "ingett" "ingiven" ;
  indra_vb_1_V = mkV "indra" "indrar" "indra" "indrog" "indragit" "indragen" ;
  ilandsaetta_vb_1_1_V = mkV "ilandsätta" "ilandsätter" "ilandsätt" "ilandsatte" "ilandsatt" "ilandsatt" ;
  igaangsaetta_vb_1_1_V = mkV "igångsätta" "igångsätter" "igångsätt" "igångsatte" "igångsatt" "igångsatt" ;
  igensaetta_vb_1_1_V = mkV "igensätta" "igensätter" "igensätt" "igensatte" "igensatt" "igensatt" ;
  ifraagasaetta_vb_1_1_V = mkV "ifrågasätta" "ifrågasätter" "ifrågasätt" "ifrågasatte" "ifrågasatt" "ifrågasatt" ;
  iaktta_vb_1_V = mkV "iaktta" "iakttar" "iaktta" "iakttog" "iakttagit" "iakttagen" ;
  hoetta_vb_1_1_V = mkV "hötta" "hötter" "hött" "höttade" "hött" "höttad" ;
  haardra_vb_1_1_V = mkV "hårdra" "hårdrar" "hårdra" "hårdrog" "hårdragit" "hårdragen" ;
  haarddra_vb_1_1_V = mkV "hårddra" "hårddrar" "hårddra" "hårddrog" "hårddragit" "hårddragen" ;
  hytta_vb_1_V = mkV "hytta" "hytter" "hytt" "hyttade" "hytt" "hyttad" ;
  hugfaesta_vb_1_1_V = mkV "hugfästa" "hugfäster" "hugfäst" "hugfäste" "hugfäst" "hugfäst" ;
  gaa_vb_1_1_V = mkV "gå" "går" "gå" "gick" "gått" "gången" ;
  gravsaetta_vb_1_1_V = mkV "gravsätta" "gravsätter" "gravsätt" "gravsatte" "gravsatt" "gravsatt" ;
  godta_vb_1_V = mkV "godta" "godtar" "godta" "godtog" "godtagit" "godtagen" ;
  genta_vb_1_V = mkV "genta" "gentar" "genta" "gentog" "gentagit" "gentagen" ;
  genomgaa_vb_1_1_V = mkV "genomgå" "genomgår" "genomgå" "genomgick" "genomgått" "genomgången" ;
  ge_vb_1_V = mkV "ge" "ger" "ge" "gav" "gett" "given" ;
  foerutsaetta_vb_1_1_V = mkV "förutsätta" "förutsätter" "förutsätt" "förutsatte" "förutsatt" "förutsatt" ;
  foerta_vb_1_1_V = mkV "förta" "förtar" "förta" "förtog" "förtagit" "förtagen" ;
  foersaetta_vb_1_1_V = mkV "försätta" "försätter" "försätt" "försatte" "försatt" "försatt" ;
  foersiggaa_vb_1_1_V = mkV "försiggå" "försiggår" "försiggå" "försiggick" "försiggått" "försiggången" ;
  foergaa_vb_1_1_V = mkV "förgå" "förgår" "förgå" "förgick" "förgått" "förgången" ;
  foereta_vb_1_1_V = mkV "företa" "företar" "företa" "företog" "företagit" "företagen" ;
  foeregaa_vb_1_1_V = mkV "föregå" "föregår" "föregå" "föregick" "föregått" "föregången" ;
  foerege_vb_1_1_V = mkV "förege" "föreger" "förege" "föregav" "föregett" "föregiven" ;
  foeredra_vb_1_1_V = mkV "föredra" "föredrar" "föredra" "föredrog" "föredragit" "föredragen" ;
  foerdra_vb_1_1_V = mkV "fördra" "fördrar" "fördra" "fördrog" "fördragit" "fördragen" ;
  foerbigaa_vb_1_1_V = mkV "förbigå" "förbigår" "förbigå" "förbigick" "förbigått" "förbigången" ;
  faesta_vb_1_1_V = mkV "fästa" "fäster" "fäst" "fäste" "fäst" "fäst" ;
  fraanta_vb_1_1_V = mkV "frånta" "fråntar" "frånta" "fråntog" "fråntagit" "fråntagen" ;
  frita_vb_1_V = mkV "frita" "fritar" "frita" "fritog" "fritagit" "fritagen" ;
  frisaetta_vb_1_1_V = mkV "frisätta" "frisätter" "frisätt" "frisatte" "frisatt" "frisatt" ;
  frige_vb_1_V = mkV "frige" "friger" "frige" "frigav" "frigett" "frigiven" ;
  framgaa_vb_1_1_V = mkV "framgå" "framgår" "framgå" "framgick" "framgått" "framgången" ;
  fortsaetta_vb_1_1_V = mkV "fortsätta" "fortsätter" "fortsätt" "fortsatte" "fortsatt" "fortsatt" ;
  formge_vb_1_V = mkV "formge" "formger" "formge" "formgav" "formgett" "formgiven" ;
  fastta_vb_1_V = mkV "fastta" "fasttar" "fastta" "fasttog" "fasttagit" "fasttagen" ;
  fastsaetta_vb_1_1_V = mkV "fastsätta" "fastsätter" "fastsätt" "fastsatte" "fastsatt" "fastsatt" ;
  ersaetta_vb_1_1_V = mkV "ersätta" "ersätter" "ersätt" "ersatte" "ersatt" "ersatt" ;
  emotta_vb_1_V = mkV "emotta" "emottar" "emotta" "emottog" "emottagit" "emottagen" ;
  emotstaa_vb_1_1_V = mkV "emotstå" "emotstår" "emotstå" "emotstod" "emotstått" "emotstånden" ;
  eftersaetta_vb_1_1_V = mkV "eftersätta" "eftersätter" "eftersätt" "eftersatte" "eftersatt" "eftersatt" ;
  efterge_vb_1_V = mkV "efterge" "efterger" "efterge" "eftergav" "eftergett" "eftergiven" ;
  edfaesta_vb_1_1_V = mkV "edfästa" "edfäster" "edfäst" "edfäste" "edfäst" "edfäst" ;
  dra_vb_1_V = mkV "dra" "drar" "dra" "drog" "dragit" "dragen" ;
  delta_vb_1_V = mkV "delta" "deltar" "delta" "deltog" "deltagit" "deltagen" ;
  delge_vb_1_V = mkV "delge" "delger" "delge" "delgav" "delgett" "delgiven" ;
  bysaetta_vb_1_1_V = mkV "bysätta" "bysätter" "bysätt" "bysatte" "bysatt" "bysatt" ;
  bryna_vb_1_V = mkV "bryna" "bryner" "bryn" "brynte" "brynt" "brynt" ;
  bortta_vb_1_V = mkV "bortta" "borttar" "bortta" "borttog" "borttagit" "borttagen" ;
  bisaetta_vb_1_1_V = mkV "bisätta" "bisätter" "bisätt" "bisatte" "bisatt" "bisatt" ;
  bidra_vb_1_V = mkV "bidra" "bidrar" "bidra" "bidrog" "bidragit" "bidragen" ;
  betygsaetta_vb_1_1_V = mkV "betygsätta" "betygsätter" "betygsätt" "betygsatte" "betygsatt" "betygsatt" ;
  betygssaetta_vb_1_1_V = mkV "betygssätta" "betygssätter" "betygssätt" "betygssatte" "betygssatt" "betygssatt" ;
  beta_vb_2_V = mkV "beta" "betar" "beta" "betog" "betagit" "betagen" ;
  besaetta_vb_1_1_V = mkV "besätta" "besätter" "besätt" "besatte" "besatt" "besatt" ;
  bestjaela_vb_1_1_V = mkV "bestjäla" "bestjäl" "bestjäl" "bestal" "bestulit" "bestulen" ;
  beslagta_vb_1_V = mkV "beslagta" "beslagtar" "beslagta" "beslagtog" "beslagtagit" "beslagtagen" ;
  bekroena_vb_1_1_V = mkV "bekröna" "bekröner" "bekrön" "bekrönte" "bekrönt" "bekrönt" ;
  begaa_vb_1_1_V = mkV "begå" "begår" "begå" "begick" "begått" "begången" ;
  befaesta_vb_1_1_V = mkV "befästa" "befäster" "befäst" "befäste" "befäst" "befäst" ;
  bedra_vb_1_V = mkV "bedra" "bedrar" "bedra" "bedrog" "bedragit" "bedragen" ;
  avta_vb_1_V = mkV "avta" "avtar" "avta" "avtog" "avtagit" "avtagen" ;
  avsaetta_vb_1_1_V = mkV "avsätta" "avsätter" "avsätt" "avsatte" "avsatt" "avsatt" ;
  avgaa_vb_1_1_V = mkV "avgå" "avgår" "avgå" "avgick" "avgått" "avgången" ;
  avge_vb_1_V = mkV "avge" "avger" "avge" "avgav" "avgett" "avgiven" ;
  avdagata_vb_1_V = mkV "avdagata" "avdagatar" "avdagata" "avdagatog" "avdagatagit" "avdagatagen" ;
  anta_vb_1_V = mkV "anta" "antar" "anta" "antog" "antagit" "antagen" ;
  ansaetta_vb_1_1_V = mkV "ansätta" "ansätter" "ansätt" "ansatte" "ansatt" "ansatt" ;
  ange_vb_1_V = mkV "ange" "anger" "ange" "angav" "angett" "angiven" ;
  andra_vb_1_V = mkV "andra" "andrar" "andra" "androg" "andragit" "andragen" ;
  anfalla_vb_1_V = mkV "anfalla" "anföll" "anfallit" ;
  anfoera_vb_1_1_V = mkV "anföra" "anförde" "anfört" ;
  angripa_vb_1_V = mkV "angripa" "angrep" "angripit" ;
  angaa_vb_1_1_V = mkV "angå" "angick" "angått" ;
  angoera_vb_1_1_V = mkV "angöra" "angjorde" "angjort" ;
  anhaalla_vb_1_1_V = mkV "anhålla" "anhöll" "anhållit" ;
  anknyta_vb_1_V = mkV "anknyta" "anknöt" "anknutit" ;
  anligga_vb_1_V = mkV "anligga" "anlåg" "anlegat" ;
  anlaegga_vb_1_1_V = mkV "anlägga" "anlade" "anlagt" ;
  anse_vb_1_V = mkV "anse" "ansåg" "ansett" ;
  ansluta_vb_1_V = mkV "ansluta" "anslöt" "anslutit" ;
  anslaa_vb_1_1_V = mkV "anslå" "anslog" "anslagit" ;
  anstryka_vb_1_V = mkV "anstryka" "anströk" "anstrukit" ;
  anstaa_vb_1_1_V = mkV "anstå" "anstod" "anstått" ;
  antraeda_vb_1_1_V = mkV "anträda" "anträdde" "anträtt" ;
  antyda_vb_1_V = mkV "antyda" "antydde" "antytt" ;
  avbinda_vb_1_V = mkV "avbinda" "avband" "avbundit" ;
  avbryta_vb_1_V = mkV "avbryta" "avbröt" "avbrutit" ;
  avboeja_vb_1_1_V = mkV "avböja" "avböjde" "avböjt" ;
  avboeja_vb_2_1_V = mkV "avböja" "avböjde" "avböjt" ;
  avdriva_vb_1_V = mkV "avdriva" "avdrev" "avdrivit" ;
  avfalla_vb_1_V = mkV "avfalla" "avföll" "avfallit" ;
  avfoera_vb_1_1_V = mkV "avföra" "avförde" "avfört" ;
  avgiftsbelaegga_vb_1_1_V = mkV "avgiftsbelägga" "avgiftsbelade" "avgiftsbelagt" ;
  avgoera_vb_1_1_V = mkV "avgöra" "avgjorde" "avgjort" ;
  avhaalla_vb_1_1_V = mkV "avhålla" "avhöll" "avhållit" ;
  avhoera_vb_1_1_V = mkV "avhöra" "avhörde" "avhört" ;
  avkaenna_vb_1_1_V = mkV "avkänna" "avkände" "avkänt" ;
  avleda_vb_1_V = mkV "avleda" "avledde" "avlett" ;
  avlida_vb_1_V = mkV "avlida" "avled" "avlidit" ;
  avlaegga_vb_1_1_V = mkV "avlägga" "avlade" "avlagt" ;
  avlaata_vb_1_1_V = mkV "avlåta" "avlät" "avlåtit" ;
  avnjuta_vb_1_V = mkV "avnjuta" "avnjöt" "avnjutit" ;
  avreda_vb_1_V = mkV "avreda" "avredde" "avrett" ;
  avrinna_vb_1_V = mkV "avrinna" "avrann" "avrunnit" ;
  avraada_vb_1_1_V = mkV "avråda" "avrådde" "avrått" ;
  avse_vb_1_V = mkV "avse" "avsåg" "avsett" ;
  avsjunga_vb_1_V = mkV "avsjunga" "avsjöng" "avsjungit" ;
  avskilja_vb_1_V = mkV "avskilja" "avskilde" "avskilt" ;
  avskjuta_vb_1_V = mkV "avskjuta" "avsköt" "avskjutit" ;
  avskriva_vb_1_V = mkV "avskriva" "avskrev" "avskrivit" ;
  avskraeda_vb_1_1_V = mkV "avskräda" "avskrädde" "avskrätt" ;
  avskaera_vb_1_1_V = mkV "avskära" "avskar" "avskurit" ;
  avslita_vb_1_V = mkV "avslita" "avslet" "avslitit" ;
  avslaa_vb_1_1_V = mkV "avslå" "avslog" "avslagit" ;
  avsnoera_vb_1_1_V = mkV "avsnöra" "avsnörde" "avsnört" ;
  avstyra_vb_1_V = mkV "avstyra" "avstyrde" "avstyrt" ;
  avstaa_vb_1_1_V = mkV "avstå" "avstod" "avstått" ;
  avstoera_vb_1_1_V = mkV "avstöra" "avstörde" "avstört" ;
  avsaega_vb_1_1_V = mkV "avsäga" "avsade" "avsagt" ;
  avtraeda_vb_1_1_V = mkV "avträda" "avträdde" "avträtt" ;
  avvinna_vb_1_V = mkV "avvinna" "avvann" "avvunnit" ;
  avvaenja_vb_1_1_V = mkV "avvänja" "avvande" "avvant" ;
  avvaerja_vb_1_1_V = mkV "avvärja" "avvärjde" "avvärjt" ;
  avaeta_vb_1_1_V = mkV "aväta" "avåt" "avätit" ;
  bakbinda_vb_1_V = mkV "bakbinda" "bakband" "bakbundit" ;
  be_vb_1_V = mkV "be" "bad" "bett" ;
  bedriva_vb_1_V = mkV "bedriva" "bedrev" "bedrivit" ;
  befara_vb_2_V = mkV "befara" "befor" "befarit" ;
  begjuta_vb_1_V = mkV "begjuta" "begöt" "begjutit" ;
  begripa_vb_1_V = mkV "begripa" "begrep" "begripit" ;
  begraata_vb_1_1_V = mkV "begråta" "begrät" "begråtit" ;
  begynna_vb_1_V = mkV "begynna" "begynte" "begynt" ;
  begaera_vb_1_1_V = mkV "begära" "begärde" "begärt" ;
  behaalla_vb_1_1_V = mkV "behålla" "behöll" "behållit" ;
  bekantgoera_vb_1_1_V = mkV "bekantgöra" "bekantgjorde" "bekantgjort" ;
  beknipa_vb_1_V = mkV "beknipa" "beknep" "beknipit" ;
  bekomma_vb_1_V = mkV "bekomma" "bekom" "bekommit" ;
  bekaenna_vb_1_1_V = mkV "bekänna" "bekände" "bekänt" ;
  bele_vb_1_V = mkV "bele" "belog" "belett" ;
  beljuga_vb_1_V = mkV "beljuga" "beljög" "beljugit" ;
  belaegga_vb_1_1_V = mkV "belägga" "belade" "belagt" ;
  bepryda_vb_1_V = mkV "bepryda" "beprydde" "beprytt" ;
  bereda_vb_1_V = mkV "bereda" "beredde" "berett" ;
  beroera_vb_1_1_V = mkV "beröra" "berörde" "berört" ;
  bese_vb_1_V = mkV "bese" "besåg" "besett" ;
  besitta_vb_1_V = mkV "besitta" "besatt" "besuttit" ;
  besjunga_vb_1_V = mkV "besjunga" "besjöng" "besjungit" ;
  beskjuta_vb_1_V = mkV "beskjuta" "besköt" "beskjutit" ;
  beskriva_vb_1_V = mkV "beskriva" "beskrev" "beskrivit" ;
  beskaera_vb_1_1_V = mkV "beskära" "beskärde" "beskärt" ;
  beskaera_vb_2_1_V = mkV "beskära" "beskar" "beskurit" ;
  beslaglaegga_vb_1_1_V = mkV "beslaglägga" "beslaglade" "beslaglagt" ;
  beslaa_vb_1_1_V = mkV "beslå" "beslog" "beslagit" ;
  besmoerja_vb_1_1_V = mkV "besmörja" "besmorde" "besmort" ;
  besticka_vb_1_V = mkV "besticka" "bestack" "bestuckit" ;
  bestiga_vb_1_V = mkV "bestiga" "besteg" "bestigit" ;
  bestryka_vb_1_V = mkV "bestryka" "beströk" "bestrukit" ;
  bestyra_vb_1_V = mkV "bestyra" "bestyrde" "bestyrt" ;
  bestaa_vb_1_1_V = mkV "bestå" "bestod" "bestått" ;
  bestaa_vb_2_1_V = mkV "bestå" "bestod" "bestådd" ;
  besoerja_vb_1_1_V = mkV "besörja" "besörjde" "besörjt" ;
  betraeda_vb_1_1_V = mkV "beträda" "beträdde" "beträtt" ;
  betyda_vb_1_V = mkV "betyda" "betydde" "betytt" ;
  bibehaalla_vb_1_1_V = mkV "bibehålla" "bibehöll" "bibehållit" ;
  bifalla_vb_1_V = mkV "bifalla" "biföll" "bifallit" ;
  bilaegga_vb_1_1_V = mkV "bilägga" "bilade" "bilagt" ;
  binda_vb_1_V = mkV "binda" "band" "bundit" ;
  bispringa_vb_1_V = mkV "bispringa" "bisprang" "bisprungit" ;
  bistaa_vb_1_1_V = mkV "bistå" "bistod" "bistått" ;
  bita_vb_1_V = mkV "bita" "bet" "bitit" ;
  bitraeda_vb_1_1_V = mkV "biträda" "biträdde" "biträtt" ;
  bjuda_vb_1_V = mkV "bjuda" "bjöd" "bjudit" ;
  bli_vb_1_V = mkV "bli" "blev" "blivit" ;
  blottlaegga_vb_1_1_V = mkV "blottlägga" "blottlade" "blottlagt" ;
  blaakoera_vb_1_1_V = mkV "blåköra" "blåkörde" "blåkört" ;
  blaaljuga_vb_1_1_V = mkV "blåljuga" "blåljög" "blåljugit" ;
  bloeda_vb_1_1_V = mkV "blöda" "blödde" "blött" ;
  bloetlaegga_vb_1_1_V = mkV "blötlägga" "blötlade" "blötlagt" ;
  bokfoera_vb_1_1_V = mkV "bokföra" "bokförde" "bokfört" ;
  bordlaegga_vb_1_1_V = mkV "bordlägga" "bordlade" "bordlagt" ;
  bortdriva_vb_1_V = mkV "bortdriva" "bortdrev" "bortdrivit" ;
  bortfalla_vb_1_V = mkV "bortfalla" "bortföll" "bortfallit" ;
  bortfoera_vb_1_1_V = mkV "bortföra" "bortförde" "bortfört" ;
  bortgaa_vb_1_1_V = mkV "bortgå" "bortgick" "bortgått" ;
  bortrinna_vb_1_V = mkV "bortrinna" "bortrann" "bortrunnit" ;
  bortse_vb_1_V = mkV "bortse" "bortsåg" "bortsett" ;
  bortskraemma_vb_1_1_V = mkV "bortskrämma" "bortskrämme" "bortskrämt" ;
  bortsluta_vb_1_V = mkV "bortsluta" "bortslöt" "bortslutit" ;
  brinna_vb_1_V = mkV "brinna" "brann" "brunnit" ;
  brinna_vb_2_V = mkV "brinna" "brann" "brunnit" ;
  brista_vb_1_V = mkV "brista" "brast" "brustit" ;
  brista_vb_2_V = mkV "brista" "brast" "brustit" ;
  brolaegga_vb_1_1_V = mkV "brolägga" "brolade" "brolagt" ;
  brukslaa_vb_1_1_V = mkV "brukslå" "brukslog" "brukslagit" ;
  bryta_vb_1_V = mkV "bryta" "bröt" "brutit" ;
  braedbeslaa_vb_1_1_V = mkV "brädbeslå" "brädbeslog" "brädbeslagit" ;
  braedslaa_vb_1_1_V = mkV "brädslå" "brädslog" "brädslagit" ;
  braenna_vb_1_1_V = mkV "bränna" "brände" "bränt" ;
  baera_vb_1_1_V = mkV "bära" "bar" "burit" ;
  boeja_vb_1_1_V = mkV "böja" "böjde" "böjt" ;
  boenfalla_vb_1_1_V = mkV "bönfalla" "bönföll" "bönfallit" ;
  boenhoera_vb_1_1_V = mkV "bönhöra" "bönhörde" "bönhört" ;
  boera_vb_1_1_V = mkV "böra" "borde" "bort" ;
  dammsuga_vb_1_V = mkV "dammsuga" "dammsög" "dammsugit" ;
  diariefoera_vb_1_1_V = mkV "diarieföra" "diarieförde" "diariefört" ;
  dimpa_vb_1_V = mkV "dimpa" "damp" "dumpit" ;
  dricka_vb_1_V = mkV "dricka" "drack" "druckit" ;
  driva_vb_1_V = mkV "driva" "drev" "drivit" ;
  droeja_vb_1_1_V = mkV "dröja" "dröjde" "dröjt" ;
  doe_vb_1_1_V = mkV "dö" "dog" "dött" ;
  doelja_vb_1_1_V = mkV "dölja" "dolde" "dolt" ;
  efterfoelja_vb_1_1_V = mkV "efterfölja" "efterföljde" "efterföljt" ;
  eftergoera_vb_1_1_V = mkV "eftergöra" "eftergjorde" "eftergjort" ;
  efterhaalla_vb_1_1_V = mkV "efterhålla" "efterhöll" "efterhållit" ;
  efterhoera_vb_1_1_V = mkV "efterhöra" "efterhörde" "efterhört" ;
  efterlaata_vb_1_1_V = mkV "efterlåta" "efterlät" "efterlåtit" ;
  efterse_vb_1_V = mkV "efterse" "eftersåg" "eftersett" ;
  eftersaega_vb_1_1_V = mkV "eftersäga" "eftersade" "eftersagt" ;
  eftertraeda_vb_1_1_V = mkV "efterträda" "efterträdde" "efterträtt" ;
  emotse_vb_1_V = mkV "emotse" "emotsåg" "emotsett" ;
  enkelskriva_vb_1_V = mkV "enkelskriva" "enkelskrev" "enkelskrivit" ;
  erbjuda_vb_1_V = mkV "erbjuda" "erbjöd" "erbjudit" ;
  erfara_vb_1_V = mkV "erfara" "erfor" "erfarit" ;
  erhaalla_vb_1_1_V = mkV "erhålla" "erhöll" "erhållit" ;
  erkaenna_vb_1_1_V = mkV "erkänna" "erkände" "erkänt" ;
  erlaegga_vb_1_1_V = mkV "erlägga" "erlade" "erlagt" ;
  falla_vb_1_V = mkV "falla" "föll" "fallit" ;
  fara_vb_1_V = mkV "fara" "for" "farit" ;
  fastgoera_vb_1_1_V = mkV "fastgöra" "fastgjorde" "fastgjort" ;
  fasthaalla_vb_1_1_V = mkV "fasthålla" "fasthöll" "fasthållit" ;
  fastlaegga_vb_1_1_V = mkV "fastlägga" "fastlade" "fastlagt" ;
  fastslaa_vb_1_1_V = mkV "fastslå" "fastslog" "fastslagit" ;
  finbraenna_vb_1_1_V = mkV "finbränna" "finbrände" "finbränt" ;
  finna_vb_1_V = mkV "finna" "fann" "funnit" ;
  flyga_vb_1_V = mkV "flyga" "flög" "flugit" ;
  flyta_vb_1_V = mkV "flyta" "flöt" "flutit" ;
  fogstryka_vb_1_V = mkV "fogstryka" "fogströk" "fogstrukit" ;
  formgjuta_vb_1_V = mkV "formgjuta" "formgöt" "formgjutit" ;
  fortbestaa_vb_1_1_V = mkV "fortbestå" "fortbestod" "fortbestått" ;
  fortfara_vb_1_V = mkV "fortfara" "fortfor" "fortfarit" ;
  fortgaa_vb_1_1_V = mkV "fortgå" "fortgick" "fortgått" ;
  fortskrida_vb_1_V = mkV "fortskrida" "fortskred" "fortskridit" ;
  frambryta_vb_1_V = mkV "frambryta" "frambröt" "frambrutit" ;
  frambaera_vb_1_1_V = mkV "frambära" "frambar" "framburit" ;
  framdriva_vb_1_V = mkV "framdriva" "framdrev" "framdrivit" ;
  framfara_vb_1_V = mkV "framfara" "framfor" "framfarit" ;
  framfoeda_vb_1_1_V = mkV "framföda" "framfödde" "framfött" ;
  framfoera_vb_1_1_V = mkV "framföra" "framförde" "framfört" ;
  framhaalla_vb_1_1_V = mkV "framhålla" "framhöll" "framhållit" ;
  framlida_vb_1_V = mkV "framlida" "framled" "framlidit" ;
  framlaegga_vb_1_1_V = mkV "framlägga" "framlade" "framlagt" ;
  framskina_vb_1_V = mkV "framskina" "framsken" "framskinit" ;
  framskjuta_vb_1_V = mkV "framskjuta" "framsköt" "framskjutit" ;
  framskrida_vb_1_V = mkV "framskrida" "framskred" "framskridit" ;
  framstaa_vb_1_1_V = mkV "framstå" "framstod" "framstått" ;
  framsaega_vb_1_1_V = mkV "framsäga" "framsade" "framsagt" ;
  framtraeda_vb_1_1_V = mkV "framträda" "framträdde" "framträtt" ;
  frigoera_vb_1_1_V = mkV "frigöra" "frigjorde" "frigjort" ;
  frikaenna_vb_1_1_V = mkV "frikänna" "frikände" "frikänt" ;
  frilaegga_vb_1_1_V = mkV "frilägga" "frilade" "frilagt" ;
  friskskriva_vb_1_V = mkV "friskskriva" "friskskrev" "friskskrivit" ;
  fryna_vb_1_V = mkV "fryna" "frynte" "frynt" ;
  fraangaa_vb_1_1_V = mkV "frångå" "frångick" "frångått" ;
  fraankaenna_vb_1_1_V = mkV "frånkänna" "frånkände" "frånkänt" ;
  fraanse_vb_1_1_V = mkV "frånse" "frånsåg" "frånsett" ;
  fraanskilja_vb_1_1_V = mkV "frånskilja" "frånskilde" "frånskilt" ;
  fraantraeda_vb_1_1_V = mkV "frånträda" "frånträdde" "frånträtt" ;
  fullfoelja_vb_1_1_V = mkV "fullfölja" "fullföljde" "fullföljt" ;
  fullgoera_vb_1_1_V = mkV "fullgöra" "fullgjorde" "fullgjort" ;
  faerglaegga_vb_1_1_V = mkV "färglägga" "färglade" "färglagt" ;
  faa_vb_1_1_V = mkV "få" "fick" "fått" ;
  foeda_vb_1_1_V = mkV "föda" "födde" "fött" ;
  foelja_vb_1_1_V = mkV "följa" "följde" "följt" ;
  foera_vb_1_1_V = mkV "föra" "förde" "fört" ;
  foeranleda_vb_1_1_V = mkV "föranleda" "föranledde" "föranlett" ;
  foeranlaata_vb_1_1_V = mkV "föranlåta" "föranlät" "föranlåtit" ;
  foerbehaalla_vb_1_1_V = mkV "förbehålla" "förbehöll" "förbehållit" ;
  foerbereda_vb_1_1_V = mkV "förbereda" "förberedde" "förberett" ;
  foerbinda_vb_1_1_V = mkV "förbinda" "förband" "förbundit" ;
  foerbise_vb_1_1_V = mkV "förbise" "förbisåg" "förbisett" ;
  foerbjuda_vb_1_1_V = mkV "förbjuda" "förbjöd" "förbjudit" ;
  foerbli_vb_1_1_V = mkV "förbli" "förblev" "förblivit" ;
  foerbloeda_vb_1_1_V = mkV "förblöda" "förblödde" "förblött" ;
  foerbrinna_vb_1_1_V = mkV "förbrinna" "förbrann" "förbrunnit" ;
  foerbraenna_vb_1_1_V = mkV "förbränna" "förbrände" "förbränt" ;
  foerdriva_vb_1_1_V = mkV "fördriva" "fördrev" "fördrivit" ;
  foerdroeja_vb_1_1_V = mkV "fördröja" "fördröjde" "fördröjt" ;
  foerdoelja_vb_1_1_V = mkV "fördölja" "fördolde" "fördolt" ;
  foerebaera_vb_1_1_V = mkV "förebära" "förebar" "föreburit" ;
  foerefalla_vb_1_1_V = mkV "förefalla" "föreföll" "förefallit" ;
  foeregripa_vb_1_1_V = mkV "föregripa" "föregrep" "föregripit" ;
  foerehaalla_vb_1_1_V = mkV "förehålla" "förehöll" "förehållit" ;
  foereligga_vb_1_1_V = mkV "föreligga" "förelåg" "förelegat" ;
  foerelaegga_vb_1_1_V = mkV "förelägga" "förelade" "förelagt" ;
  foereskriva_vb_1_1_V = mkV "föreskriva" "föreskrev" "föreskrivit" ;
  foereslaa_vb_1_1_V = mkV "föreslå" "föreslog" "föreslagit" ;
  foerestaa_vb_1_1_V = mkV "förestå" "förestod" "förestått" ;
  foerete_vb_1_1_V = mkV "förete" "företedde" "företett" ;
  foeretraeda_vb_1_1_V = mkV "företräda" "företrädde" "företrätt" ;
  foerfalla_vb_1_1_V = mkV "förfalla" "förföll" "förfallit" ;
  foerfara_vb_1_1_V = mkV "förfara" "förfor" "förfarit" ;
  foerflyta_vb_1_1_V = mkV "förflyta" "förflöt" "förflutit" ;
  foerfoelja_vb_1_1_V = mkV "förfölja" "förföljde" "förföljt" ;
  foerfoera_vb_1_1_V = mkV "förföra" "förförde" "förfört" ;
  foergaeta_vb_1_1_V = mkV "förgäta" "förgat" "förgätit" ;
  foergoera_vb_1_1_V = mkV "förgöra" "förgjorde" "förgjort" ;
  foerhyda_vb_1_1_V = mkV "förhyda" "förhydde" "förhytt" ;
  foerhyra_vb_1_1_V = mkV "förhyra" "förhyrde" "förhyrt" ;
  foerhaalla_vb_1_1_V = mkV "förhålla" "förhöll" "förhållit" ;
  foerhoeja_vb_1_1_V = mkV "förhöja" "förhöjde" "förhöjt" ;
  foerhoera_vb_1_1_V = mkV "förhöra" "förhörde" "förhört" ;
  foerleda_vb_1_1_V = mkV "förleda" "förledde" "förlett" ;
  foerlida_vb_1_1_V = mkV "förlida" "förled" "förlidit" ;
  foerlaegga_vb_1_1_V = mkV "förlägga" "förlade" "förlagt" ;
  foerlaata_vb_1_1_V = mkV "förlåta" "förlät" "förlåtit" ;
  foernoeja_vb_1_1_V = mkV "förnöja" "förnöjde" "förnöjt" ;
  foerrinna_vb_1_1_V = mkV "förrinna" "förrann" "förrunnit" ;
  foerraada_vb_1_1_V = mkV "förråda" "förrådde" "förrått" ;
  foersitta_vb_1_1_V = mkV "försitta" "försatt" "försuttit" ;
  foersjunka_vb_1_1_V = mkV "försjunka" "försjönk" "försjunkit" ;
  foerskjuta_vb_1_1_V = mkV "förskjuta" "försköt" "förskjutit" ;
  foerskriva_vb_1_1_V = mkV "förskriva" "förskrev" "förskrivit" ;
  foerskaera_vb_1_1_V = mkV "förskära" "förskar" "förskurit" ;
  foerslita_vb_1_1_V = mkV "förslita" "förslet" "förslitit" ;
  foersluta_vb_1_1_V = mkV "försluta" "förslöt" "förslutit" ;
  foerslaa_vb_1_1_V = mkV "förslå" "förslog" "förslagit" ;
  foerspoerja_vb_1_1_V = mkV "förspörja" "försporde" "försport" ;
  foerstaa_vb_1_1_V = mkV "förstå" "förstod" "förstått" ;
  foerstoera_vb_1_1_V = mkV "förstöra" "förstörde" "förstört" ;
  foersvinna_vb_1_1_V = mkV "försvinna" "försvann" "försvunnit" ;
  foersaelja_vb_1_1_V = mkV "försälja" "försålde" "försålt" ;
  foersoerja_vb_1_1_V = mkV "försörja" "försörjde" "försörjt" ;
  foertiga_vb_1_1_V = mkV "förtiga" "förteg" "förtigit" ;
  foertryta_vb_1_1_V = mkV "förtryta" "förtröt" "förtrutit" ;
  foertaera_vb_1_1_V = mkV "förtära" "förtärde" "förtärt" ;
  foertoeja_vb_1_1_V = mkV "förtöja" "förtöjde" "förtöjt" ;
  foerutse_vb_1_1_V = mkV "förutse" "förutsåg" "förutsett" ;
  foerutsaega_vb_1_1_V = mkV "förutsäga" "förutsade" "förutsagt" ;
  foervrida_vb_1_1_V = mkV "förvrida" "förvred" "förvridit" ;
  foeryngringsbeskaera_vb_1_1_V = mkV "föryngringsbeskära" "föryngringsbeskar" "föryngringsbeskurit" ;
  foeroeda_vb_1_1_V = mkV "föröda" "förödde" "förött" ;
  gallskrika_vb_1_V = mkV "gallskrika" "gallskrek" "gallskrikit" ;
  galltjuta_vb_1_V = mkV "galltjuta" "galltjöt" "galltjutit" ;
  gendriva_vb_1_V = mkV "gendriva" "gendrev" "gendrivit" ;
  genljuda_vb_1_V = mkV "genljuda" "genljöd" "genljudit" ;
  genombryta_vb_1_V = mkV "genombryta" "genombröt" "genombrutit" ;
  genomdriva_vb_1_V = mkV "genomdriva" "genomdrev" "genomdrivit" ;
  genomfara_vb_1_V = mkV "genomfara" "genomfor" "genomfarit" ;
  genomfoera_vb_1_1_V = mkV "genomföra" "genomförde" "genomfört" ;
  genomlida_vb_1_V = mkV "genomlida" "genomled" "genomlidit" ;
  genomskoelja_vb_1_1_V = mkV "genomskölja" "genomsköljde" "genomsköljt" ;
  genskjuta_vb_1_V = mkV "genskjuta" "gensköt" "genskjutit" ;
  gitta_vb_1_V = mkV "gitta" "gitte" "gittat" ;
  gjuta_vb_1_V = mkV "gjuta" "göt" "gjutit" ;
  glida_vb_1_V = mkV "glida" "gled" "glidit" ;
  gloeda_vb_1_1_V = mkV "glöda" "glödde" "glött" ;
  gnida_vb_1_V = mkV "gnida" "gned" "gnidit" ;
  godkaenna_vb_1_1_V = mkV "godkänna" "godkände" "godkänt" ;
  gottgoera_vb_1_1_V = mkV "gottgöra" "gottgjorde" "gottgjort" ;
  gottskriva_vb_1_V = mkV "gottskriva" "gottskrev" "gottskrivit" ;
  granatbeskjuta_vb_1_V = mkV "granatbeskjuta" "granatbesköt" "granatbeskjutit" ;
  gravlaegga_vb_1_1_V = mkV "gravlägga" "gravlade" "gravlagt" ;
  gripa_vb_1_V = mkV "gripa" "grep" "gripit" ;
  grundlaegga_vb_1_1_V = mkV "grundlägga" "grundlade" "grundlagt" ;
  graata_vb_1_1_V = mkV "gråta" "grät" "gråtit" ;
  gudomliggoera_vb_1_1_V = mkV "gudomliggöra" "gudomliggjorde" "gudomliggjort" ;
  goeda_vb_1_1_V = mkV "göda" "gödde" "gött" ;
  goera_vb_1_1_V = mkV "göra" "gjorde" "gjort" ;
  halshugga_vb_1_V = mkV "halshugga" "halshögg" "halshuggit" ;
  halvsova_vb_1_V = mkV "halvsova" "halvsov" "halvsovit" ;
  halvspringa_vb_1_V = mkV "halvspringa" "halvsprang" "halvsprungit" ;
  handleda_vb_1_V = mkV "handleda" "handledde" "handlett" ;
  handlaegga_vb_1_1_V = mkV "handlägga" "handlade" "handlagt" ;
  hembjuda_vb_1_V = mkV "hembjuda" "hembjöd" "hembjudit" ;
  hembaera_vb_1_1_V = mkV "hembära" "hembar" "hemburit" ;
  hemfalla_vb_1_V = mkV "hemfalla" "hemföll" "hemfallit" ;
  hemfoera_vb_1_1_V = mkV "hemföra" "hemförde" "hemfört" ;
  hemlighaalla_vb_1_1_V = mkV "hemlighålla" "hemlighöll" "hemlighållit" ;
  hinna_vb_1_V = mkV "hinna" "hann" "hunnit" ;
  hopknyta_vb_1_V = mkV "hopknyta" "hopknöt" "hopknutit" ;
  hopskjuta_vb_1_V = mkV "hopskjuta" "hopsköt" "hopskjutit" ;
  hovniga_vb_1_V = mkV "hovniga" "hovneg" "hovnigit" ;
  hugga_vb_1_V = mkV "hugga" "högg" "huggit" ;
  hugga_vb_2_V = mkV "hugga" "högg" "huggit" ;
  hyra_vb_1_V = mkV "hyra" "hyrde" "hyrt" ;
  haenfoera_vb_1_1_V = mkV "hänföra" "hänförde" "hänfört" ;
  haenskjuta_vb_1_1_V = mkV "hänskjuta" "hänsköt" "hänskjutit" ;
  haentyda_vb_1_1_V = mkV "häntyda" "häntydde" "häntytt" ;
  haerflyta_vb_1_1_V = mkV "härflyta" "härflöt" "härflutit" ;
  haerleda_vb_1_1_V = mkV "härleda" "härledde" "härlett" ;
  haalla_vb_1_1_V = mkV "hålla" "höll" "hållit" ;
  haalslaa_vb_1_1_V = mkV "hålslå" "hålslog" "hålslagit" ;
  haanle_vb_1_1_V = mkV "hånle" "hånlog" "hånlett" ;
  haardloeda_vb_1_1_V = mkV "hårdlöda" "hårdlödde" "hårdlött" ;
  hoegtidlighaalla_vb_1_1_V = mkV "högtidlighålla" "högtidlighöll" "högtidlighållit" ;
  hoeja_vb_1_1_V = mkV "höja" "höjde" "höjt" ;
  hoelja_vb_1_1_V = mkV "hölja" "höljde" "höljt" ;
  hoera_vb_1_1_V = mkV "höra" "hörde" "hört" ;
  hoeta_vb_1_1_V = mkV "höta" "hötte" "hött" ;
  igenkaenna_vb_1_1_V = mkV "igenkänna" "igenkände" "igenkänt" ;
  illtjuta_vb_1_V = mkV "illtjuta" "illtjöt" "illtjutit" ;
  inbegripa_vb_1_V = mkV "inbegripa" "inbegrep" "inbegripit" ;
  inbjuda_vb_1_V = mkV "inbjuda" "inbjöd" "inbjudit" ;
  indriva_vb_1_V = mkV "indriva" "indrev" "indrivit" ;
  infalla_vb_1_V = mkV "infalla" "inföll" "infallit" ;
  inflyta_vb_1_V = mkV "inflyta" "inflöt" "influtit" ;
  infoera_vb_1_1_V = mkV "införa" "införde" "infört" ;
  ingjuta_vb_1_V = mkV "ingjuta" "ingöt" "ingjutit" ;
  ingripa_vb_1_V = mkV "ingripa" "ingrep" "ingripit" ;
  ingaa_vb_1_1_V = mkV "ingå" "ingick" "ingått" ;
  inleda_vb_1_V = mkV "inleda" "inledde" "inlett" ;
  inlaegga_vb_1_1_V = mkV "inlägga" "inlade" "inlagt" ;
  inlaera_vb_1_1_V = mkV "inlära" "inlärde" "inlärt" ;
  innebaera_vb_1_1_V = mkV "innebära" "innebar" "inneburit" ;
  innehaalla_vb_1_1_V = mkV "innehålla" "innehöll" "innehållit" ;
  innesluta_vb_1_V = mkV "innesluta" "inneslöt" "inneslutit" ;
  inreda_vb_1_V = mkV "inreda" "inredde" "inrett" ;
  inse_vb_1_V = mkV "inse" "insåg" "insett" ;
  inskjuta_vb_1_V = mkV "inskjuta" "insköt" "inskjutit" ;
  inskrida_vb_1_V = mkV "inskrida" "inskred" "inskridit" ;
  inskriva_vb_1_V = mkV "inskriva" "inskrev" "inskrivit" ;
  insmyga_vb_1_V = mkV "insmyga" "insmög" "insmugit" ;
  insuga_vb_1_V = mkV "insuga" "insög" "insugit" ;
  insupa_vb_1_V = mkV "insupa" "insöp" "insupit" ;
  intraeda_vb_1_1_V = mkV "inträda" "inträdde" "inträtt" ;
  invaelja_vb_1_1_V = mkV "invälja" "invalde" "invalt" ;
  jordslaa_vb_1_1_V = mkV "jordslå" "jordslog" "jordslagit" ;
  jaemfoera_vb_1_1_V = mkV "jämföra" "jämförde" "jämfört" ;
  kalhugga_vb_1_V = mkV "kalhugga" "kalhögg" "kalhuggit" ;
  kalkslaa_vb_1_1_V = mkV "kalkslå" "kalkslog" "kalkslagit" ;
  kallroera_vb_1_1_V = mkV "kallröra" "kallrörde" "kallrört" ;
  kallsmida_vb_1_V = mkV "kallsmida" "kallsmidde" "kallsmitt" ;
  kalaeta_vb_1_1_V = mkV "kaläta" "kalåt" "kalätit" ;
  kanthugga_vb_1_V = mkV "kanthugga" "kanthögg" "kanthuggit" ;
  kartlaegga_vb_1_1_V = mkV "kartlägga" "kartlade" "kartlagt" ;
  klargoera_vb_1_1_V = mkV "klargöra" "klargjorde" "klargjort" ;
  klarlaegga_vb_1_1_V = mkV "klarlägga" "klarlade" "klarlagt" ;
  klavbinda_vb_1_V = mkV "klavbinda" "klavband" "klavbundit" ;
  kliva_vb_1_V = mkV "kliva" "klev" "klivit" ;
  knipa_vb_1_V = mkV "knipa" "knep" "knipit" ;
  knivhugga_vb_1_V = mkV "knivhugga" "knivhögg" "knivhuggit" ;
  knivskaera_vb_1_1_V = mkV "knivskära" "knivskar" "knivskurit" ;
  knyta_vb_1_V = mkV "knyta" "knöt" "knutit" ;
  knaeboeja_vb_1_1_V = mkV "knäböja" "knäböjde" "knäböjt" ;
  knaefalla_vb_1_1_V = mkV "knäfalla" "knäföll" "knäfallit" ;
  korsfoerhoera_vb_1_1_V = mkV "korsförhöra" "korsförhörde" "korsförhört" ;
  korslaegga_vb_1_1_V = mkV "korslägga" "korslade" "korslagt" ;
  kortsluta_vb_1_V = mkV "kortsluta" "kortslöt" "kortslutit" ;
  kringraenna_vb_1_1_V = mkV "kringränna" "kringrände" "kringränt" ;
  kringskaera_vb_1_1_V = mkV "kringskära" "kringskar" "kringskurit" ;
  krypa_vb_1_V = mkV "krypa" "kröp" "krupit" ;
  krypkoera_vb_1_1_V = mkV "krypköra" "krypkörde" "krypkört" ;
  kungoera_vb_1_1_V = mkV "kungöra" "kungjorde" "kungjort" ;
  kvarbli_vb_1_V = mkV "kvarbli" "kvarblev" "kvarblivit" ;
  kvardroeja_vb_1_1_V = mkV "kvardröja" "kvardröjde" "kvardröjt" ;
  kvarhaalla_vb_1_1_V = mkV "kvarhålla" "kvarhöll" "kvarhållit" ;
  kvarstaa_vb_1_1_V = mkV "kvarstå" "kvarstod" "kvarstått" ;
  kvaelja_vb_1_1_V = mkV "kvälja" "kvalde" "kvalt" ;
  kyrkbokfoera_vb_1_1_V = mkV "kyrkbokföra" "kyrkbokförde" "kyrkbokfört" ;
  kyrkobokfoera_vb_1_1_V = mkV "kyrkobokföra" "kyrkobokförde" "kyrkobokfört" ;
  kyrkskriva_vb_1_V = mkV "kyrkskriva" "kyrkskrev" "kyrkskrivit" ;
  kaenna_vb_1_1_V = mkV "känna" "kände" "känt" ;
  kaenna_vb_2_1_V = mkV "känna" "känne" "känt" ;
  koepslaa_vb_1_1_V = mkV "köpslå" "köpslog" "köpslagit" ;
  koera_vb_1_1_V = mkV "köra" "körde" "kört" ;
  lagerfoera_vb_1_1_V = mkV "lagerföra" "lagerförde" "lagerfört" ;
  lagfara_vb_1_V = mkV "lagfara" "lagfor" "lagfarit" ;
  lagfoera_vb_1_1_V = mkV "lagföra" "lagförde" "lagfört" ;
  lamslaa_vb_1_1_V = mkV "lamslå" "lamslog" "lamslagit" ;
  landstiga_vb_1_V = mkV "landstiga" "landsteg" "landstigit" ;
  le_vb_1_V = mkV "le" "log" "lett" ;
  leda_vb_1_V = mkV "leda" "ledde" "lett" ;
  leja_vb_1_V = mkV "leja" "lejde" "lejt" ;
  levandegoera_vb_1_1_V = mkV "levandegöra" "levandegjorde" "levandegjort" ;
  licensbelaegga_vb_1_1_V = mkV "licensbelägga" "licensbelade" "licensbelagt" ;
  lida_vb_1_V = mkV "lida" "led" "lidit" ;
  ligga_vb_1_V = mkV "ligga" "låg" "legat" ;
  livnaera_vb_1_1_V = mkV "livnära" "livnärde" "livnärt" ;
  ljuda_vb_1_V = mkV "ljuda" "ljöd" "ljudit" ;
  ljuga_vb_1_V = mkV "ljuga" "ljög" "ljugit" ;
  lovsjunga_vb_1_V = mkV "lovsjunga" "lovsjöng" "lovsjungit" ;
  lyckliggoera_vb_1_1_V = mkV "lyckliggöra" "lyckliggjorde" "lyckliggjort" ;
  laegga_vb_1_1_V = mkV "lägga" "lade" "lagt" ;
  laera_vb_1_1_V = mkV "lära" "lärde" "lärt" ;
  laagflyga_vb_1_1_V = mkV "lågflyga" "lågflög" "lågflugit" ;
  laata_vb_1_1_V = mkV "låta" "lät" "låtit" ;
  loesgoera_vb_1_1_V = mkV "lösgöra" "lösgjorde" "lösgjort" ;
  marknadsfoera_vb_1_1_V = mkV "marknadsföra" "marknadsförde" "marknadsfört" ;
  medfoelja_vb_1_1_V = mkV "medfölja" "medföljde" "medföljt" ;
  medfoera_vb_1_1_V = mkV "medföra" "medförde" "medfört" ;
  medvetandegoera_vb_1_1_V = mkV "medvetandegöra" "medvetandegjorde" "medvetandegjort" ;
  minna_vb_1_V = mkV "minna" "minde" "mint" ;
  missfoerstaa_vb_1_1_V = mkV "missförstå" "missförstod" "missförstådd" ;
  misskaenna_vb_1_1_V = mkV "misskänna" "misskände" "misskänt" ;
  missleda_vb_1_V = mkV "missleda" "missledde" "misslett" ;
  misspryda_vb_1_V = mkV "misspryda" "missprydde" "missprytt" ;
  misstyda_vb_1_V = mkV "misstyda" "misstydde" "misstytt" ;
  misstaenkliggoera_vb_1_1_V = mkV "misstänkliggöra" "misstänkliggjorde" "misstänkliggjort" ;
  mjukgoera_vb_1_1_V = mkV "mjukgöra" "mjukgjorde" "mjukgjort" ;
  moltiga_vb_1_V = mkV "moltiga" "molteg" "moltigit" ;
  motse_vb_1_V = mkV "motse" "motsåg" "motsett" ;
  motstaa_vb_1_1_V = mkV "motstå" "motstod" "motstått" ;
  motsaega_vb_1_1_V = mkV "motsäga" "motsade" "motsagt" ;
  maerkvaerdiggoera_vb_1_1_V = mkV "märkvärdiggöra" "märkvärdiggjorde" "märkvärdiggjort" ;
  moejliggoera_vb_1_1_V = mkV "möjliggöra" "möjliggjorde" "möjliggjort" ;
  moerklaegga_vb_1_1_V = mkV "mörklägga" "mörklade" "mörklagt" ;
  nagelfara_vb_1_V = mkV "nagelfara" "nagelfor" "nagelfarit" ;
  nedbryta_vb_1_V = mkV "nedbryta" "nedbröt" "nedbrutit" ;
  nedgoera_vb_1_1_V = mkV "nedgöra" "nedgjorde" "nedgjort" ;
  nedlaegga_vb_1_1_V = mkV "nedlägga" "nedlade" "nedlagt" ;
  nedskriva_vb_1_V = mkV "nedskriva" "nedskrev" "nedskrivit" ;
  nedslaa_vb_1_1_V = mkV "nedslå" "nedslog" "nedslagit" ;
  nedstiga_vb_1_V = mkV "nedstiga" "nedsteg" "nedstigit" ;
  nerbryta_vb_1_V = mkV "nerbryta" "nerbröt" "nerbrutit" ;
  nergoera_vb_1_1_V = mkV "nergöra" "nergjorde" "nergjort" ;
  nerlaegga_vb_1_1_V = mkV "nerlägga" "nerlade" "nerlagt" ;
  nerskriva_vb_1_V = mkV "nerskriva" "nerskrev" "nerskrivit" ;
  nerslaa_vb_1_1_V = mkV "nerslå" "nerslog" "nerslagit" ;
  nerstiga_vb_1_V = mkV "nerstiga" "nersteg" "nerstigit" ;
  niga_vb_1_V = mkV "niga" "neg" "nigit" ;
  njuta_vb_1_V = mkV "njuta" "njöt" "njutit" ;
  nyanlaegga_vb_1_1_V = mkV "nyanlägga" "nyanlade" "nyanlagt" ;
  nyttiggoera_vb_1_1_V = mkV "nyttiggöra" "nyttiggjorde" "nyttiggjort" ;
  naera_vb_1_1_V = mkV "nära" "närde" "närt" ;
  naersluta_vb_1_1_V = mkV "närsluta" "närslöt" "närslutit" ;
  offentliggoera_vb_1_1_V = mkV "offentliggöra" "offentliggjorde" "offentliggjort" ;
  ombe_vb_1_V = mkV "ombe" "ombad" "ombett" ;
  ombestyra_vb_1_V = mkV "ombestyra" "ombestyrde" "ombestyrt" ;
  ombesoerja_vb_1_1_V = mkV "ombesörja" "ombesörjde" "ombesörjt" ;
  ombryta_vb_1_V = mkV "ombryta" "ombröt" "ombrutit" ;
  omfoera_vb_1_1_V = mkV "omföra" "omförde" "omfört" ;
  omhoelja_vb_1_1_V = mkV "omhölja" "omhöljde" "omhöljt" ;
  omintetgoera_vb_1_1_V = mkV "omintetgöra" "omintetgjorde" "omintetgjort" ;
  omkoera_vb_1_1_V = mkV "omköra" "omkörde" "omkört" ;
  omse_vb_1_V = mkV "omse" "omsåg" "omsett" ;
  omskriva_vb_1_V = mkV "omskriva" "omskrev" "omskrivit" ;
  omskaera_vb_1_1_V = mkV "omskära" "omskar" "omskurit" ;
  omsluta_vb_1_V = mkV "omsluta" "omslöt" "omslutit" ;
  omspinna_vb_1_V = mkV "omspinna" "omspann" "omspunnit" ;
  omspaenna_vb_1_1_V = mkV "omspänna" "omspände" "omspänt" ;
  omvaelja_vb_1_1_V = mkV "omvälja" "omvalde" "omvalt" ;
  omoejliggoera_vb_1_1_V = mkV "omöjliggöra" "omöjliggjorde" "omöjliggjort" ;
  oppbaera_vb_1_1_V = mkV "oppbära" "oppbar" "oppburit" ;
  oppdriva_vb_1_V = mkV "oppdriva" "oppdrev" "oppdrivit" ;
  oppfinna_vb_1_V = mkV "oppfinna" "oppfann" "oppfunnit" ;
  oppfoeda_vb_1_1_V = mkV "oppföda" "oppfödde" "oppfött" ;
  opphoeja_vb_1_1_V = mkV "opphöja" "opphöjde" "opphöjt" ;
  opphoera_vb_1_1_V = mkV "opphöra" "opphörde" "opphört" ;
  opplaegga_vb_1_1_V = mkV "opplägga" "opplade" "opplagt" ;
  oppskjuta_vb_1_V = mkV "oppskjuta" "oppsköt" "oppskjutit" ;
  oppsuga_vb_1_V = mkV "oppsuga" "oppsög" "oppsugit" ;
  oppaeta_vb_1_1_V = mkV "oppäta" "oppåt" "oppätit" ;
  oskadliggoera_vb_1_1_V = mkV "oskadliggöra" "oskadliggjorde" "oskadliggjort" ;
  osynliggoera_vb_1_1_V = mkV "osynliggöra" "osynliggjorde" "osynliggjort" ;
  pantfoerskriva_vb_1_1_V = mkV "pantförskriva" "pantförskrev" "pantförskrivit" ;
  pipa_vb_1_V = mkV "pipa" "pep" "pipit" ;
  planlaegga_vb_1_1_V = mkV "planlägga" "planlade" "planlagt" ;
  ploeja_vb_1_1_V = mkV "plöja" "plöjde" "plöjt" ;
  portfoerbjuda_vb_1_1_V = mkV "portförbjuda" "portförbjöd" "portförbjudit" ;
  premiaerkoera_vb_1_1_V = mkV "premiärköra" "premiärkörde" "premiärkört" ;
  presslaegga_vb_1_1_V = mkV "presslägga" "presslade" "presslagt" ;
  promenadkoera_vb_1_1_V = mkV "promenadköra" "promenadkörde" "promenadkört" ;
  provkoera_vb_1_1_V = mkV "provköra" "provkörde" "provkört" ;
  provskjuta_vb_1_V = mkV "provskjuta" "provsköt" "provskjutit" ;
  pryda_vb_1_V = mkV "pryda" "prydde" "prytt" ;
  pungslaa_vb_1_1_V = mkV "pungslå" "pungslog" "pungslagit" ;
  pyra_vb_1_V = mkV "pyra" "pyrde" "pyrt" ;
  paabjuda_vb_1_1_V = mkV "påbjuda" "påbjöd" "påbjudit" ;
  paafoera_vb_1_1_V = mkV "påföra" "påförde" "påfört" ;
  paagaa_vb_1_1_V = mkV "pågå" "pågick" "pågått" ;
  paalaegga_vb_1_1_V = mkV "pålägga" "pålade" "pålagt" ;
  paaloeda_vb_1_1_V = mkV "pålöda" "pålödde" "pålött" ;
  paaminna_vb_1_1_V = mkV "påminna" "påminde" "påmint" ;
  paanyttfoeda_vb_1_1_V = mkV "pånyttföda" "pånyttfödde" "pånyttfött" ;
  paaskina_vb_1_1_V = mkV "påskina" "påsken" "påskinit" ;
  paastaa_vb_1_1_V = mkV "påstå" "påstod" "påstådd" ;
  reda_vb_1_V = mkV "reda" "redde" "rett" ;
  redogoera_vb_1_1_V = mkV "redogöra" "redogjorde" "redogjort" ;
  rengoera_vb_1_1_V = mkV "rengöra" "rengjorde" "rengjort" ;
  renskriva_vb_1_V = mkV "renskriva" "renskrev" "renskrivit" ;
  rida_vb_1_V = mkV "rida" "red" "ridit" ;
  rinna_vb_1_V = mkV "rinna" "rann" "runnit" ;
  riva_vb_1_V = mkV "riva" "rev" "rivit" ;
  rumphugga_vb_1_V = mkV "rumphugga" "rumphögg" "rumphuggit" ;
  rundsmoerja_vb_1_1_V = mkV "rundsmörja" "rundsmorde" "rundsmort" ;
  ryta_vb_1_V = mkV "ryta" "röt" "rutit" ;
  raenna_vb_1_1_V = mkV "ränna" "rände" "ränt" ;
  raettfaerdiggoera_vb_1_1_V = mkV "rättfärdiggöra" "rättfärdiggjorde" "rättfärdiggjort" ;
  raada_vb_1_1_V = mkV "råda" "rådde" "rått" ;
  raadfoera_vb_1_1_V = mkV "rådföra" "rådförde" "rådfört" ;
  raadgoera_vb_1_1_V = mkV "rådgöra" "rådgjorde" "rådgjort" ;
  raadlaegga_vb_1_1_V = mkV "rådlägga" "rådlade" "rådlagt" ;
  raadslaa_vb_1_1_V = mkV "rådslå" "rådslog" "rådslagit" ;
  raariva_vb_1_1_V = mkV "råriva" "rårev" "rårivit" ;
  roeja_vb_1_1_V = mkV "röja" "röjde" "röjt" ;
  roeja_vb_2_1_V = mkV "röja" "röjde" "röjt" ;
  roera_vb_1_1_V = mkV "röra" "rörde" "rört" ;
  salubjuda_vb_1_V = mkV "salubjuda" "salubjöd" "salubjudit" ;
  salufoera_vb_1_1_V = mkV "saluföra" "saluförde" "salufört" ;
  samkoera_vb_1_1_V = mkV "samköra" "samkörde" "samkört" ;
  sammanbinda_vb_1_V = mkV "sammanbinda" "sammanband" "sammanbundit" ;
  sammanfalla_vb_1_V = mkV "sammanfalla" "sammanföll" "sammanfallit" ;
  sammanfoera_vb_1_1_V = mkV "sammanföra" "sammanförde" "sammanfört" ;
  sammanhaalla_vb_1_1_V = mkV "sammanhålla" "sammanhöll" "sammanhållit" ;
  sammanlaegga_vb_1_1_V = mkV "sammanlägga" "sammanlade" "sammanlagt" ;
  sammanskjuta_vb_1_V = mkV "sammanskjuta" "sammansköt" "sammanskjutit" ;
  sammanskriva_vb_1_V = mkV "sammanskriva" "sammanskrev" "sammanskrivit" ;
  sammanslaa_vb_1_1_V = mkV "sammanslå" "sammanslog" "sammanslagit" ;
  sammantraeda_vb_1_1_V = mkV "sammanträda" "sammanträdde" "sammanträtt" ;
  samraada_vb_1_1_V = mkV "samråda" "samrådde" "samrått" ;
  se_vb_1_V = mkV "se" "såg" "sett" ;
  segelflyga_vb_1_V = mkV "segelflyga" "segelflög" "segelflugit" ;
  sekretessbelaegga_vb_1_1_V = mkV "sekretessbelägga" "sekretessbelade" "sekretessbelagt" ;
  senarelaegga_vb_1_1_V = mkV "senarelägga" "senarelade" "senarelagt" ;
  sitta_vb_1_V = mkV "sitta" "satt" "suttit" ;
  sjuda_vb_1_V = mkV "sjuda" "sjöd" "sjudit" ;
  sjukskriva_vb_1_V = mkV "sjukskriva" "sjukskrev" "sjukskrivit" ;
  sjunga_vb_1_V = mkV "sjunga" "sjöng" "sjungit" ;
  sjunka_vb_1_V = mkV "sjunka" "sjönk" "sjunkit" ;
  sjaelvdoe_vb_1_1_V = mkV "självdö" "självdog" "självdött" ;
  skadskjuta_vb_1_V = mkV "skadskjuta" "skadsköt" "skadskjutit" ;
  skambelaegga_vb_1_1_V = mkV "skambelägga" "skambelade" "skambelagt" ;
  skattlaegga_vb_1_1_V = mkV "skattlägga" "skattlade" "skattlagt" ;
  skattskriva_vb_1_V = mkV "skattskriva" "skattskrev" "skattskrivit" ;
  ske_vb_1_V = mkV "ske" "skedde" "skett" ;
  skilja_vb_1_V = mkV "skilja" "skilde" "skilt" ;
  skina_vb_1_V = mkV "skina" "sken" "skinit" ;
  skita_vb_1_V = mkV "skita" "sket" "skitit" ;
  skjuta_vb_1_V = mkV "skjuta" "sköt" "skjutit" ;
  skrida_vb_1_V = mkV "skrida" "skred" "skridit" ;
  skrika_vb_1_V = mkV "skrika" "skrek" "skrikit" ;
  skrinlaegga_vb_1_1_V = mkV "skrinlägga" "skrinlade" "skrinlagt" ;
  skriva_vb_1_V = mkV "skriva" "skrev" "skrivit" ;
  skryta_vb_1_V = mkV "skryta" "skröt" "skrutit" ;
  skraeda_vb_1_1_V = mkV "skräda" "skrädde" "skrätt" ;
  skuldbelaegga_vb_1_1_V = mkV "skuldbelägga" "skuldbelade" "skuldbelagt" ;
  skaera_vb_1_1_V = mkV "skära" "skar" "skurit" ;
  skaapsupa_vb_1_1_V = mkV "skåpsupa" "skåpsöp" "skåpsupit" ;
  skoelja_vb_1_1_V = mkV "skölja" "sköljde" "sköljt" ;
  skoenja_vb_1_1_V = mkV "skönja" "skönjde" "skönjt" ;
  slinka_vb_1_V = mkV "slinka" "slank" "slunkit" ;
  slinta_vb_1_V = mkV "slinta" "slant" "sluntit" ;
  slippa_vb_1_V = mkV "slippa" "slapp" "sluppit" ;
  slita_vb_1_V = mkV "slita" "slet" "slitit" ;
  sluta_vb_3_V = mkV "sluta" "slöt" "slutit" ;
  slutfoera_vb_1_1_V = mkV "slutföra" "slutförde" "slutfört" ;
  slaa_vb_1_1_V = mkV "slå" "slog" "slagit" ;
  smida_vb_1_V = mkV "smida" "smidde" "smitt" ;
  smita_vb_1_V = mkV "smita" "smet" "smitit" ;
  smyga_vb_1_V = mkV "smyga" "smög" "smugit" ;
  smygsupa_vb_1_V = mkV "smygsupa" "smygsöp" "smygsupit" ;
  smygaeta_vb_1_1_V = mkV "smygäta" "smygåt" "smygätit" ;
  smaale_vb_1_1_V = mkV "småle" "smålog" "smålett" ;
  smaasjunga_vb_1_1_V = mkV "småsjunga" "småsjöng" "småsjungit" ;
  smaasova_vb_1_1_V = mkV "småsova" "småsov" "småsovit" ;
  smaaspringa_vb_1_1_V = mkV "småspringa" "småsprang" "småsprungit" ;
  smaasvaera_vb_1_1_V = mkV "småsvära" "småsvor" "småsvurit" ;
  smoerja_vb_1_1_V = mkV "smörja" "smorde" "smort" ;
  snabbutreda_vb_1_V = mkV "snabbutreda" "snabbutredde" "snabbutrett" ;
  snedvrida_vb_1_V = mkV "snedvrida" "snedvred" "snedvridit" ;
  snyta_vb_1_V = mkV "snyta" "snöt" "snutit" ;
  snaerja_vb_1_1_V = mkV "snärja" "snärjde" "snärjt" ;
  snoera_vb_1_1_V = mkV "snöra" "snörde" "snört" ;
  sova_vb_1_V = mkV "sova" "sov" "sovit" ;
  spinna_vb_1_V = mkV "spinna" "spann" "spunnit" ;
  spricka_vb_1_V = mkV "spricka" "sprack" "spruckit" ;
  springa_vb_1_V = mkV "springa" "sprang" "sprungit" ;
  spritta_vb_1_V = mkV "spritta" "spratt" "spruttit" ;
  spaenna_vb_1_1_V = mkV "spänna" "spände" "spänt" ;
  spoerja_vb_1_1_V = mkV "spörja" "sporde" "sport" ;
  sticka_vb_1_V = mkV "sticka" "stack" "stuckit" ;
  sticka_vb_3_V = mkV "sticka" "stack" "stuckit" ;
  stiga_vb_1_V = mkV "stiga" "steg" "stigit" ;
  stinka_vb_1_V = mkV "stinka" "stank" "stunkit" ;
  storgraata_vb_1_1_V = mkV "storgråta" "storgrät" "storgråtit" ;
  stryka_vb_1_V = mkV "stryka" "strök" "strukit" ;
  stryka_vb_2_V = mkV "stryka" "strök" "strukit" ;
  styra_vb_1_V = mkV "styra" "styrde" "styrt" ;
  staa_vb_1_1_V = mkV "stå" "stod" "stått" ;
  stoedja_vb_1_1_V = mkV "stöda" "stödde" "stött" ;
  stoera_vb_1_1_V = mkV "störa" "störde" "stört" ;
  stoertbloeda_vb_1_1_V = mkV "störtblöda" "störtblödde" "störtblött" ;
  suga_vb_1_V = mkV "suga" "sög" "sugit" ;
  suga_vb_2_V = mkV "suga" "sög" "sugit" ;
  supa_vb_1_V = mkV "supa" "söp" "supit" ;
  sveda_vb_1_V = mkV "sveda" "svedde" "svett" ;
  svida_vb_1_V = mkV "svida" "sved" "svidit" ;
  svika_vb_1_V = mkV "svika" "svek" "svikit" ;
  svinna_vb_1_V = mkV "svinna" "svann" "svunnit" ;
  svaelja_vb_1_1_V = mkV "svälja" "svalde" "svalt" ;
  svaelta_vb_1_1_V = mkV "svälta" "svalt" "svultit" ;
  svaera_vb_1_1_V = mkV "svära" "svor" "svurit" ;
  synliggoera_vb_1_1_V = mkV "synliggöra" "synliggjorde" "synliggjort" ;
  saega_vb_1_1_V = mkV "säga" "sade" "sagt" ;
  saelja_vb_1_1_V = mkV "sälja" "sålde" "sålt" ;
  saellskapsgraata_vb_1_1_V = mkV "sällskapsgråta" "sällskapsgrät" "sällskapsgråtit" ;
  saellskapsaeta_vb_1_1_V = mkV "sällskapsäta" "sällskapsåt" "sällskapsätit" ;
  saerskilja_vb_1_1_V = mkV "särskilja" "särskilde" "särskilt" ;
  soendagskoera_vb_1_1_V = mkV "söndagsköra" "söndagskörde" "söndagskört" ;
  soenderfalla_vb_1_1_V = mkV "sönderfalla" "sönderföll" "sönderfallit" ;
  soenderriva_vb_1_1_V = mkV "sönderriva" "sönderrev" "sönderrivit" ;
  soerja_vb_1_1_V = mkV "sörja" "sörjde" "sörjt" ;
  tabubelaegga_vb_1_1_V = mkV "tabubelägga" "tabubelade" "tabubelagt" ;
  testflyga_vb_1_V = mkV "testflyga" "testflög" "testflugit" ;
  testkoera_vb_1_1_V = mkV "testköra" "testkörde" "testkört" ;
  tidigarelaegga_vb_1_1_V = mkV "tidigarelägga" "tidigarelade" "tidigarelagt" ;
  tiga_vb_1_V = mkV "tiga" "teg" "tigit" ;
  tillbe_vb_1_V = mkV "tillbe" "tillbad" "tillbett" ;
  tillerkaenna_vb_1_1_V = mkV "tillerkänna" "tillerkände" "tillerkänt" ;
  tillfalla_vb_1_V = mkV "tillfalla" "tillföll" "tillfallit" ;
  tillfoera_vb_1_1_V = mkV "tillföra" "tillförde" "tillfört" ;
  tillgodose_vb_1_V = mkV "tillgodose" "tillgodosåg" "tillgodosett" ;
  tillgripa_vb_1_V = mkV "tillgripa" "tillgrep" "tillgripit" ;
  tillgaa_vb_1_1_V = mkV "tillgå" "tillgick" "tillgått" ;
  tillhandahaalla_vb_1_1_V = mkV "tillhandahålla" "tillhandahöll" "tillhandahållit" ;
  tillhaalla_vb_1_1_V = mkV "tillhålla" "tillhöll" "tillhållit" ;
  tillhoera_vb_1_1_V = mkV "tillhöra" "tillhörde" "tillhört" ;
  tillintetgoera_vb_1_1_V = mkV "tillintetgöra" "tillintetgjorde" "tillintetgjort" ;
  tillmoetesgaa_vb_1_1_V = mkV "tillmötesgå" "tillmötesgick" "tillmötesgått" ;
  tillreda_vb_1_V = mkV "tillreda" "tillredde" "tillrett" ;
  tillryggalaegga_vb_1_1_V = mkV "tillryggalägga" "tillryggalade" "tillryggalagt" ;
  tillraettalaegga_vb_1_1_V = mkV "tillrättalägga" "tillrättalade" "tillrättalagt" ;
  tillraada_vb_1_1_V = mkV "tillråda" "tillrådde" "tillrått" ;
  tillse_vb_1_V = mkV "tillse" "tillsåg" "tillsett" ;
  tillskjuta_vb_1_V = mkV "tillskjuta" "tillsköt" "tillskjutit" ;
  tillskriva_vb_1_V = mkV "tillskriva" "tillskrev" "tillskrivit" ;
  tillskaera_vb_1_1_V = mkV "tillskära" "tillskar" "tillskurit" ;
  tillsluta_vb_1_V = mkV "tillsluta" "tillslöt" "tillslutit" ;
  tillstaa_vb_1_1_V = mkV "tillstå" "tillstod" "tillstått" ;
  tillsaega_vb_1_1_V = mkV "tillsäga" "tillsade" "tillsagt" ;
  tilltraeda_vb_1_1_V = mkV "tillträda" "tillträdde" "tillträtt" ;
  tillvaenja_vb_1_1_V = mkV "tillvänja" "tillvande" "tillvant" ;
  tillaegga_vb_1_1_V = mkV "tillägga" "tillade" "tillagt" ;
  tillaata_vb_1_1_V = mkV "tillåta" "tillät" "tillåtit" ;
  tjuta_vb_1_V = mkV "tjuta" "tjöt" "tjutit" ;
  tjuvhaalla_vb_1_1_V = mkV "tjuvhålla" "tjuvhöll" "tjuvhållit" ;
  tjyvhaalla_vb_1_1_V = mkV "tjyvhålla" "tjyvhöll" "tjyvhållit" ;
  tjaenstgoera_vb_1_1_V = mkV "tjänstgöra" "tjänstgjorde" "tjänstgjort" ;
  topphugga_vb_1_V = mkV "topphugga" "topphögg" "topphuggit" ;
  topprida_vb_1_V = mkV "topprida" "toppred" "toppridit" ;
  torgfoera_vb_1_1_V = mkV "torgföra" "torgförde" "torgfört" ;
  torrlaegga_vb_1_1_V = mkV "torrlägga" "torrlade" "torrlagt" ;
  totalfoerbjuda_vb_1_1_V = mkV "totalförbjuda" "totalförbjöd" "totalförbjudit" ;
  totalfoerstoera_vb_1_1_V = mkV "totalförstöra" "totalförstörde" "totalförstört" ;
  trafikleda_vb_1_V = mkV "trafikleda" "trafikledde" "trafiklett" ;
  trakthugga_vb_1_V = mkV "trakthugga" "trakthögg" "trakthuggit" ;
  trollbinda_vb_1_V = mkV "trollbinda" "trollband" "trollbundit" ;
  tryta_vb_1_V = mkV "tryta" "tröt" "trutit" ;
  traeda_vb_1_1_V = mkV "träda" "trädde" "trätt" ;
  traelbinda_vb_1_1_V = mkV "trälbinda" "trälband" "trälbundit" ;
  tyda_vb_1_V = mkV "tyda" "tydde" "tytt" ;
  tydliggoera_vb_1_1_V = mkV "tydliggöra" "tydliggjorde" "tydliggjort" ;
  taelja_vb_1_1_V = mkV "tälja" "täljde" "täljt" ;
  taemja_vb_1_1_V = mkV "tämja" "tämjde" "tämjt" ;
  taenja_vb_1_1_V = mkV "tänja" "tänjde" "tänjt" ;
  taera_vb_1_1_V = mkV "tära" "tärde" "tärt" ;
  toeja_vb_1_1_V = mkV "töja" "töjde" "töjt" ;
  umbaera_vb_1_1_V = mkV "umbära" "umbar" "umburit" ;
  undanhaalla_vb_1_1_V = mkV "undanhålla" "undanhöll" "undanhållit" ;
  undanroeja_vb_1_1_V = mkV "undanröja" "undanröjde" "undanröjt" ;
  undansticka_vb_1_V = mkV "undansticka" "undanstack" "undanstuckit" ;
  underbinda_vb_1_V = mkV "underbinda" "underband" "underbundit" ;
  underbjuda_vb_1_V = mkV "underbjuda" "underbjöd" "underbjudit" ;
  underdriva_vb_1_V = mkV "underdriva" "underdrev" "underdrivit" ;
  underfoerstaa_vb_1_1_V = mkV "underförstå" "underförstod" "underförstådd" ;
  underhaalla_vb_1_1_V = mkV "underhålla" "underhöll" "underhållit" ;
  underkaenna_vb_1_1_V = mkV "underkänna" "underkände" "underkänt" ;
  underlaata_vb_1_1_V = mkV "underlåta" "underlät" "underlåtit" ;
  underskrida_vb_1_V = mkV "underskrida" "underskred" "underskridit" ;
  underslaa_vb_1_1_V = mkV "underslå" "underslog" "underslagit" ;
  understicka_vb_1_V = mkV "understicka" "understack" "understuckit" ;
  understiga_vb_1_V = mkV "understiga" "understeg" "understigit" ;
  understryka_vb_1_V = mkV "understryka" "underströk" "understrukit" ;
  understoedja_vb_1_1_V = mkV "understöda" "understödde" "understött" ;
  undersaelja_vb_1_1_V = mkV "undersälja" "undersålde" "undersålt" ;
  undfalla_vb_1_V = mkV "undfalla" "undföll" "undfallit" ;
  undfaa_vb_1_1_V = mkV "undfå" "undfick" "undfått" ;
  undgaa_vb_1_1_V = mkV "undgå" "undgick" "undgått" ;
  undkomma_vb_1_V = mkV "undkomma" "undkom" "undkommit" ;
  undslippa_vb_1_V = mkV "undslippa" "undslapp" "undsluppit" ;
  undvika_vb_1_V = mkV "undvika" "undvek" "undvikit" ;
  uppbjuda_vb_1_V = mkV "uppbjuda" "uppbjöd" "uppbjudit" ;
  uppbaera_vb_1_1_V = mkV "uppbära" "uppbar" "uppburit" ;
  uppdriva_vb_1_V = mkV "uppdriva" "uppdrev" "uppdrivit" ;
  uppehaalla_vb_1_1_V = mkV "uppehålla" "uppehöll" "uppehållit" ;
  uppfinna_vb_1_V = mkV "uppfinna" "uppfann" "uppfunnit" ;
  uppfoeda_vb_1_1_V = mkV "uppföda" "uppfödde" "uppfött" ;
  uppfoera_vb_1_1_V = mkV "uppföra" "uppförde" "uppfört" ;
  upphoeja_vb_1_1_V = mkV "upphöja" "upphöjde" "upphöjt" ;
  upphoera_vb_1_1_V = mkV "upphöra" "upphörde" "upphört" ;
  upplaegga_vb_1_1_V = mkV "upplägga" "upplade" "upplagt" ;
  upplaata_vb_1_1_V = mkV "upplåta" "upplät" "upplåtit" ;
  uppriva_vb_1_V = mkV "uppriva" "upprev" "upprivit" ;
  uppraenna_vb_1_1_V = mkV "uppränna" "upprände" "uppränt" ;
  uppraetthaalla_vb_1_1_V = mkV "upprätthålla" "upprätthöll" "upprätthållit" ;
  upproera_vb_1_1_V = mkV "uppröra" "upprörde" "upprört" ;
  uppskjuta_vb_1_V = mkV "uppskjuta" "uppsköt" "uppskjutit" ;
  uppspricka_vb_1_V = mkV "uppspricka" "uppsprack" "uppspruckit" ;
  uppstiga_vb_1_V = mkV "uppstiga" "uppsteg" "uppstigit" ;
  uppsuga_vb_1_V = mkV "uppsuga" "uppsög" "uppsugit" ;
  upptraeda_vb_1_1_V = mkV "uppträda" "uppträdde" "uppträtt" ;
  uppaeta_vb_1_1_V = mkV "uppäta" "uppåt" "uppätit" ;
  uraktlaata_vb_1_1_V = mkV "uraktlåta" "uraktlät" "uraktlåtit" ;
  urskilja_vb_1_V = mkV "urskilja" "urskilde" "urskilt" ;
  urskoenja_vb_1_1_V = mkV "urskönja" "urskönjde" "urskönjt" ;
  uruppfoera_vb_1_1_V = mkV "uruppföra" "uruppförde" "uruppfört" ;
  utbjuda_vb_1_V = mkV "utbjuda" "utbjöd" "utbjudit" ;
  utbrista_vb_1_V = mkV "utbrista" "utbrast" "utbrustit" ;
  utbryta_vb_1_V = mkV "utbryta" "utbröt" "utbrutit" ;
  utdriva_vb_1_V = mkV "utdriva" "utdrev" "utdrivit" ;
  utebli_vb_1_V = mkV "utebli" "uteblev" "uteblivit" ;
  utesluta_vb_1_V = mkV "utesluta" "uteslöt" "uteslutit" ;
  utfalla_vb_1_V = mkV "utfalla" "utföll" "utfallit" ;
  utfaa_vb_1_1_V = mkV "utfå" "utfick" "utfått" ;
  utfoera_vb_1_1_V = mkV "utföra" "utförde" "utfört" ;
  utfoersaelja_vb_1_1_V = mkV "utförsälja" "utförsålde" "utförsålt" ;
  utgjuta_vb_1_V = mkV "utgjuta" "utgöt" "utgjutit" ;
  utgoera_vb_1_1_V = mkV "utgöra" "utgjorde" "utgjort" ;
  uthyra_vb_1_V = mkV "uthyra" "uthyrde" "uthyrt" ;
  utklyva_vb_1_V = mkV "utklyva" "utklöv" "utkluvit" ;
  utlaegga_vb_1_1_V = mkV "utlägga" "utlade" "utlagt" ;
  utreda_vb_1_V = mkV "utreda" "utredde" "utrett" ;
  utse_vb_1_V = mkV "utse" "utsåg" "utsett" ;
  utskilja_vb_1_V = mkV "utskilja" "utskilde" "utskilt" ;
  utskriva_vb_1_V = mkV "utskriva" "utskrev" "utskrivit" ;
  utsuga_vb_1_V = mkV "utsuga" "utsög" "utsugit" ;
  utsaega_vb_1_1_V = mkV "utsäga" "utsade" "utsagt" ;
  uttraeda_vb_1_1_V = mkV "utträda" "utträdde" "utträtt" ;
  uttyda_vb_1_V = mkV "uttyda" "uttydde" "uttytt" ;
  uttaenja_vb_1_1_V = mkV "uttänja" "uttänjde" "uttänjt" ;
  utvinna_vb_1_V = mkV "utvinna" "utvann" "utvunnit" ;
  utvaelja_vb_1_1_V = mkV "utvälja" "utvalde" "utvalt" ;
  vanpryda_vb_1_V = mkV "vanpryda" "vanprydde" "vanprytt" ;
  vanstyra_vb_1_V = mkV "vanstyra" "vanstyrde" "vanstyrt" ;
  varmkoera_vb_1_1_V = mkV "varmköra" "varmkörde" "varmkört" ;
  varsebli_vb_1_V = mkV "varsebli" "varseblev" "varseblivit" ;
  vassgoera_vb_1_1_V = mkV "vassgöra" "vassgjorde" "vassgjort" ;
  vederlaegga_vb_1_1_V = mkV "vederlägga" "vederlade" "vederlagt" ;
  verkliggoera_vb_1_1_V = mkV "verkliggöra" "verkliggjorde" "verkliggjort" ;
  vetta_vb_1_V = mkV "vetta" "vette" "vettat" ;
  vidbraenna_vb_1_1_V = mkV "vidbränna" "vidbrände" "vidbränt" ;
  vidgaa_vb_1_1_V = mkV "vidgå" "vidgick" "vidgått" ;
  vidhaalla_vb_1_1_V = mkV "vidhålla" "vidhöll" "vidhållit" ;
  vidkomma_vb_1_V = mkV "vidkomma" "vidkom" "vidkommit" ;
  vidlaada_vb_1_1_V = mkV "vidlåda" "vidlådde" "vidlått" ;
  vidmakthaalla_vb_1_1_V = mkV "vidmakthålla" "vidmakthöll" "vidmakthållit" ;
  vidroera_vb_1_1_V = mkV "vidröra" "vidrörde" "vidrört" ;
  villfara_vb_1_V = mkV "villfara" "villfor" "villfarit" ;
  vilsefoera_vb_1_1_V = mkV "vilseföra" "vilseförde" "vilsefört" ;
  vilseleda_vb_1_V = mkV "vilseleda" "vilseledde" "vilselett" ;
  vina_vb_1_V = mkV "vina" "ven" "vinit" ;
  vinna_vb_1_V = mkV "vinna" "vann" "vunnit" ;
  vintervaeghaalla_vb_1_1_V = mkV "vinterväghålla" "vinterväghöll" "vinterväghållit" ;
  vrida_vb_1_V = mkV "vrida" "vred" "vridit" ;
  vaegleda_vb_1_1_V = mkV "vägleda" "vägledde" "väglett" ;
  vaeja_vb_1_1_V = mkV "väja" "väjde" "väjt" ;
  vaelja_vb_1_1_V = mkV "välja" "valde" "valt" ;
  vaemja_vb_1_1_V = mkV "vämja" "vämjde" "vämjt" ;
  vaenja_vb_1_1_V = mkV "vänja" "vande" "vant" ;
  vaerja_vb_1_1_V = mkV "värja" "värjde" "värjt" ;
  vaagfoera_vb_1_1_V = mkV "vågföra" "vågförde" "vågfört" ;
  vaaldfoera_vb_1_1_V = mkV "våldföra" "våldförde" "våldfört" ;
  yra_vb_2_V = mkV "yra" "yrde" "yrt" ;
  aeta_vb_1_1_V = mkV "äta" "åt" "ätit" ;
  aadagalaegga_vb_1_1_V = mkV "ådagalägga" "ådagalade" "ådagalagt" ;
  aaderlaata_vb_1_1_V = mkV "åderlåta" "åderlät" "åderlåtit" ;
  aahoera_vb_1_1_V = mkV "åhöra" "åhörde" "åhört" ;
  aaligga_vb_1_1_V = mkV "åligga" "ålåg" "ålegat" ;
  aalaegga_vb_1_1_V = mkV "ålägga" "ålade" "ålagt" ;
  aase_vb_1_1_V = mkV "åse" "åsåg" "åsett" ;
  aaskaadliggoera_vb_1_1_V = mkV "åskådliggöra" "åskådliggjorde" "åskådliggjort" ;
  aaterfalla_vb_1_1_V = mkV "återfalla" "återföll" "återfallit" ;
  aaterfinna_vb_1_1_V = mkV "återfinna" "återfann" "återfunnit" ;
  aaterfaa_vb_1_1_V = mkV "återfå" "återfick" "återfått" ;
  aaterfoera_vb_1_1_V = mkV "återföra" "återförde" "återfört" ;
  aaterfoersluta_vb_1_1_V = mkV "återförsluta" "återförslöt" "återförslutit" ;
  aaterfoersaelja_vb_1_1_V = mkV "återförsälja" "återförsålde" "återförsålt" ;
  aaterhaalla_vb_1_1_V = mkV "återhålla" "återhöll" "återhållit" ;
  aaterinfoera_vb_1_1_V = mkV "återinföra" "återinförde" "återinfört" ;
  aaterknyta_vb_1_1_V = mkV "återknyta" "återknöt" "återknutit" ;
  aaterse_vb_1_1_V = mkV "återse" "återsåg" "återsett" ;
  aaterstaa_vb_1_1_V = mkV "återstå" "återstod" "återstått" ;
  aatersaelja_vb_1_1_V = mkV "återsälja" "återsålde" "återsålt" ;
  aatervinna_vb_1_1_V = mkV "återvinna" "återvann" "återvunnit" ;
  aatervaelja_vb_1_1_V = mkV "återvälja" "återvalde" "återvalt" ;
  aatfoelja_vb_1_1_V = mkV "åtfölja" "åtföljde" "åtföljt" ;
  aatnjuta_vb_1_1_V = mkV "åtnjuta" "åtnjöt" "åtnjutit" ;
  aatskilja_vb_1_1_V = mkV "åtskilja" "åtskilde" "åtskilt" ;
  oeda_vb_1_1_V = mkV "öda" "ödde" "ött" ;
  oedelaegga_vb_1_1_V = mkV "ödelägga" "ödelade" "ödelagt" ;
  oeverbelaegga_vb_1_1_V = mkV "överbelägga" "överbelade" "överbelagt" ;
  oeverbjuda_vb_1_1_V = mkV "överbjuda" "överbjöd" "överbjudit" ;
  oeverdriva_vb_1_1_V = mkV "överdriva" "överdrev" "överdrivit" ;
  oeverfalla_vb_1_1_V = mkV "överfalla" "överföll" "överfallit" ;
  oeverflyga_vb_1_1_V = mkV "överflyga" "överflög" "överflugit" ;
  oeverfoera_vb_1_1_V = mkV "överföra" "överförde" "överfört" ;
  oevergaa_vb_1_1_V = mkV "övergå" "övergick" "övergått" ;
  oevergoeda_vb_1_1_V = mkV "övergöda" "övergödde" "övergött" ;
  oeverhoelja_vb_1_1_V = mkV "överhölja" "överhöljde" "överhöljt" ;
  oeverlaegga_vb_1_1_V = mkV "överlägga" "överlade" "överlagt" ;
  oeverlaata_vb_1_1_V = mkV "överlåta" "överlät" "överlåtit" ;
  oeverse_vb_1_1_V = mkV "överse" "översåg" "översett" ;
  oeverskrida_vb_1_1_V = mkV "överskrida" "överskred" "överskridit" ;
  oeverskoelja_vb_1_1_V = mkV "överskölja" "översköljde" "översköljt" ;
  oeverstiga_vb_1_1_V = mkV "överstiga" "översteg" "överstigit" ;
  oevertraeda_vb_1_1_V = mkV "överträda" "överträdde" "överträtt" ;
  oevervinna_vb_1_1_V = mkV "övervinna" "övervann" "övervunnit" ;
  oevningskoera_vb_1_1_V = mkV "övningsköra" "övningskörde" "övningskört" ;
  foerevara_vb_1_1_V = mkV "förevara" "förevar" "förevarit" ;
  K_maerka_vb_1_1_V = mkV "K-märker" ;
  KU_anmaela_vb_1_1_V = mkV "KU-anmäler" ;
  accelerera_vb_1_V = mkV "accelererar" ;
  agera_vb_1_V = mkV "agerar" ;
  akta_vb_1_V = mkV "aktar" ;
  alstra_vb_1_V = mkV "alstrar" ;
  anbefalla_vb_1_V = mkV "anbefaller" ;
  anbelanga_vb_1_V = mkV "anbelangar" ;
  anfraeta_vb_1_1_V = mkV "anfräter" ;
  anfoertro_vb_1_1_V = mkV "anförtror" ;
  angla_vb_1_V = mkV "anglar" ;
  angraensa_vb_1_1_V = mkV "angränsar" ;
  anlaenda_vb_1_1_V = mkV "anländer" ;
  anloepa_vb_1_1_V = mkV "anlöper" ;
  anmaela_vb_1_1_V = mkV "anmäler" ;
  anmaerka_vb_1_1_V = mkV "anmärker" ;
  anstraenga_vb_1_1_V = mkV "anstränger" ;
  anstaella_vb_1_1_V = mkV "anställer" ;
  ansvara_vb_1_V = mkV "ansvarar" ;
  ansvaella_vb_1_1_V = mkV "ansväller" ;
  ansoeka_vb_1_1_V = mkV "ansöker" ;
  antaenda_vb_1_1_V = mkV "antänder" ;
  anvaenda_vb_1_1_V = mkV "använder" ;
  arbeta_av_vbm_1_V2 = dirV2 (partV (mkV "arbetar")"av") ;
  artbestaemma_vb_1_1_V = mkV "artbestämmer" ;
  asa_vb_1_V = mkV "asar" ;
  asgarva_vb_1_V = mkV "asgarvar" ;
  avbestaella_vb_1_1_V = mkV "avbeställer" ;
  avblaasa_vb_1_1_V = mkV "avblåser" ;
  avdaemma_vb_1_1_V = mkV "avdämmer" ;
  avdoema_vb_1_1_V = mkV "avdömer" ;
  avhjaelpa_vb_1_1_V = mkV "avhjälper" ;
  avhysa_vb_1_V = mkV "avhyser" ;
  avhaenda_vb_1_1_V = mkV "avhänder" ;
  avhaenga_vb_1_1_V = mkV "avhänger" ;
  avkasta_vb_1_V = mkV "avkastar" ;
  avklara_vb_1_V = mkV "avklarar" ;
  avkraeva_vb_1_1_V = mkV "avkräver" ;
  avkyla_vb_1_V = mkV "avkyler" ;
  avlysa_vb_1_V = mkV "avlyser" ;
  avlaesa_vb_1_1_V = mkV "avläser" ;
  avloepa_vb_1_1_V = mkV "avlöper" ;
  avloesa_vb_1_1_V = mkV "avlöser" ;
  avmaeta_vb_1_1_V = mkV "avmäter" ;
  avmoenstra_vb_1_1_V = mkV "avmönstrar" ;
  avresa_vb_1_V = mkV "avreser" ;
  avskava_vb_1_V = mkV "avskaver" ;
  avskraecka_vb_1_1_V = mkV "avskräcker" ;
  avsky_vb_1_V = mkV "avskyr" ;
  avstyrka_vb_1_V = mkV "avstyrker" ;
  avstaella_vb_1_1_V = mkV "avställer" ;
  avstaemma_vb_1_1_V = mkV "avstämmer" ;
  avstaenga_vb_1_1_V = mkV "avstänger" ;
  avstoeta_vb_1_1_V = mkV "avstöter" ;
  avsvimma_vb_1_V = mkV "avsvimmar" ;
  avsaenda_vb_1_1_V = mkV "avsänder" ;
  avsoeka_vb_1_1_V = mkV "avsöker" ;
  avtorka_vb_1_V = mkV "avtorkar" ;
  avtaecka_vb_1_1_V = mkV "avtäcker" ;
  avvaega_vb_1_1_V = mkV "avväger" ;
  avvaenda_vb_1_1_V = mkV "avvänder" ;
  babbla_vb_1_V = mkV "babblar" ;
  balansera_vb_1_V = mkV "balanserar" ;
  bannlysa_vb_1_V = mkV "bannlyser" ;
  banta_vb_1_V = mkV "bantar" ;
  barka_vb_2_V = mkV "barkar" ;
  basa_vb_1_V = mkV "basar" ;
  basuna_ut_vbm_1_V2 = dirV2 (partV (mkV "basunar")"ut") ;
  basunera_ut_vbm_1_V2 = dirV2 (partV (mkV "basunerar")"ut") ;
  baxna_vb_1_V = mkV "baxnar" ;
  bebo_vb_1_V = mkV "bebor" ;
  bebygga_vb_1_V = mkV "bebygger" ;
  bedoema_vb_1_1_V = mkV "bedömer" ;
  befalla_vb_1_V = mkV "befaller" ;
  beglaensa_vb_1_1_V = mkV "beglänser" ;
  behaga_vb_1_V = mkV "behagar" ;
  behaenga_vb_1_1_V = mkV "behänger" ;
  behoeva_vb_1_1_V = mkV "behöver" ;
  belanga_vb_1_V = mkV "belangar" ;
  belysa_vb_1_V = mkV "belyser" ;
  bemaenga_vb_1_1_V = mkV "bemänger" ;
  bemaerka_vb_1_1_V = mkV "bemärker" ;
  bemoeta_vb_1_1_V = mkV "bemöter" ;
  benaemna_vb_1_1_V = mkV "benämner" ;
  bero_vb_1_V = mkV "beror" ;
  beroemma_vb_1_1_V = mkV "berömmer" ;
  beskylla_vb_1_V = mkV "beskyller" ;
  bespara_vb_1_V = mkV "besparar" ;
  besserwissra_vb_1_V = mkV "besserwissrar" ;
  bestroe_vb_1_1_V = mkV "beströr" ;
  bestyrka_vb_1_V = mkV "bestyrker" ;
  bestaella_vb_1_1_V = mkV "beställer" ;
  bestaella_vb_2_1_V = mkV "beställer" ;
  bestaemma_vb_1_1_V = mkV "bestämmer" ;
  bestaenka_vb_1_1_V = mkV "bestänker" ;
  besaa_vb_1_1_V = mkV "besår" ;
  besoeka_vb_1_1_V = mkV "besöker" ;
  beta_av_vbm_1_V2 = dirV2 (partV (mkV "betar")"av") ;
  betro_vb_1_V = mkV "betror" ;
  betrycka_vb_1_V = mkV "betrycker" ;
  betsla_av_vbm_1_V2 = dirV2 (partV (mkV "betslar")"av") ;
  bettla_vb_1_V = mkV "bettlar" ;
  betaecka_vb_1_1_V = mkV "betäcker" ;
  betaenka_vb_1_1_V = mkV "betänker" ;
  bevare_vb_1_V = mkV "bevare" ;
  bila_vb_2_V = mkV "bilar" ;
  bila_av_vbm_1_V2 = dirV2 (partV (mkV "bilar")"av") ;
  bistraecka_vb_1_1_V = mkV "bisträcker" ;
  bjaebba_vb_1_1_V = mkV "bjäbbar" ;
  bladdra_vb_1_V = mkV "bladdrar" ;
  blaja_vb_1_V = mkV "blajar" ;
  blanda_i_vbm_1_V2 = dirV2 (partV (mkV "blandar")"i") ;
  blanda_in_vbm_1_V2 = dirV2 (partV (mkV "blandar")"in") ;
  blanda_om_vbm_1_V2 = dirV2 (partV (mkV "blandar")"om") ;
  blanda_ut_vbm_1_V2 = dirV2 (partV (mkV "blandar")"ut") ;
  blarra_vb_1_V = mkV "blarrar" ;
  blaska_vb_1_V = mkV "blaskar" ;
  blasta_av_vbm_1_V2 = dirV2 (partV (mkV "blastar")"av") ;
  bleka_vb_1_V = mkV "bleker" ;
  blicka_vb_1_V = mkV "blickar" ;
  bliga_vb_1_V = mkV "bligar" ;
  blinka_vb_1_V = mkV "blinkar" ;
  blippa_vb_1_V = mkV "blippar" ;
  blixtra_vb_1_V = mkV "blixtrar" ;
  blomma_vb_1_V = mkV "blommar" ;
  blomstra_vb_1_V = mkV "blomstrar" ;
  blossa_vb_1_V = mkV "blossar" ;
  blota_vb_1_V = mkV "blotar" ;
  bluddra_vb_1_V = mkV "bluddrar" ;
  blunda_vb_1_V = mkV "blundar" ;
  blaeddra_vb_1_1_V = mkV "bläddrar" ;
  blaeddra_igenom_vbm_1_1_V2 = dirV2 (partV (mkV "bläddrar")"igenom") ;
  blaenda_av_vbm_1_1_V2 = dirV2 (partV (mkV "bländar")"av") ;
  blaenga_vb_1_1_V = mkV "blänger" ;
  blaenka_vb_1_1_V = mkV "blänker" ;
  blaestra_vb_1_1_V = mkV "blästrar" ;
  blaana_vb_1_1_V = mkV "blånar" ;
  blaaneka_vb_1_1_V = mkV "blånekar" ;
  blaasa_vb_1_1_V = mkV "blåser" ;
  blaasa_vb_2_1_V = mkV "blåser" ;
  bloeta_vb_1_1_V = mkV "blöter" ;
  bloetna_vb_1_1_V = mkV "blötnar" ;
  bo_vb_1_V = mkV "bor" ;
  bocka_foer_vbm_1_1_V2 = dirV2 (partV (mkV "bockar")"för") ;
  bogsera_in_vbm_1_V2 = dirV2 (partV (mkV "bogserar")"in") ;
  bokna_vb_1_V = mkV "boknar" ;
  bola_vb_1_V = mkV "bolar" ;
  bolma_vb_1_V = mkV "bolmar" ;
  bomma_vb_2_V = mkV "bommar" ;
  bomma_foer_vbm_1_1_V2 = dirV2 (partV (mkV "bommar")"för") ;
  bomma_till_vbm_1_V2 = dirV2 (partV (mkV "bommar")"till") ;
  booma_vb_1_V = mkV "boomar" ;
  bornera_vb_1_V = mkV "bornerar" ;
  borsta_av_vbm_1_V2 = dirV2 (partV (mkV "borstar")"av") ;
  bortarbeta_vb_1_V = mkV "bortarbetar" ;
  bortdomna_vb_1_V = mkV "bortdomnar" ;
  bortforsla_vb_1_V = mkV "bortforslar" ;
  bortfoerklara_vb_1_1_V = mkV "bortförklarar" ;
  bortlova_vb_1_V = mkV "bortlovar" ;
  bortmota_vb_1_V = mkV "bortmotar" ;
  bortoperera_vb_1_V = mkV "bortopererar" ;
  bortrationalisera_vb_1_V = mkV "bortrationaliserar" ;
  bortraekna_vb_1_1_V = mkV "borträknar" ;
  bortraenga_vb_1_1_V = mkV "bortränger" ;
  bortslumpa_vb_1_V = mkV "bortslumpar" ;
  borttappa_vb_1_V = mkV "borttappar" ;
  borttorka_vb_1_V = mkV "borttorkar" ;
  bortvraeka_vb_1_1_V = mkV "bortvräker" ;
  botanisera_vb_1_V = mkV "botaniserar" ;
  bottenfrysa_vb_1_V = mkV "bottenfryser" ;
  bottna_vb_1_V = mkV "bottnar" ;
  bowla_vb_1_V = mkV "bowlar" ;
  braka_vb_1_V = mkV "brakar" ;
  braska_vb_1_V = mkV "braskar" ;
  bravera_vb_1_V = mkV "braverar" ;
  bredsaa_vb_1_1_V = mkV "bredsår" ;
  briljera_vb_1_V = mkV "briljerar" ;
  bronsfoergylla_vb_1_1_V = mkV "bronsförgyller" ;
  brossla_vb_1_V = mkV "brosslar" ;
  brottsutreda_vb_1_V = mkV "brottsutredar" ;
  bruckla_vb_1_V = mkV "brucklar" ;
  brumma_vb_1_V = mkV "brummar" ;
  brusa_vb_1_V = mkV "brusar" ;
  bry_vb_1_V = mkV "bryr" ;
  brygga_vb_1_V = mkV "brygger" ;
  brygga_oever_vbm_1_1_V2 = dirV2 (partV (mkV "bryggar")"över") ;
  braecka_vb_1_1_V = mkV "bräcker" ;
  braeka_vb_1_1_V = mkV "bräker" ;
  braennmaerka_vb_1_1_V = mkV "brännmärker" ;
  braadska_vb_1_1_V = mkV "brådskar" ;
  braaka_vb_1_1_V = mkV "bråkar" ;
  broela_vb_1_1_V = mkV "brölar" ;
  broesta_av_vbm_1_1_V2 = dirV2 (partV (mkV "bröstar")"av") ;
  bua_vb_1_V = mkV "buar" ;
  bubbla_vb_1_V = mkV "bubblar" ;
  buffra_vb_1_V = mkV "buffrar" ;
  buga_vb_1_V = mkV "bugar" ;
  bugga_vb_1_V = mkV "buggar" ;
  bukta_vb_1_V = mkV "buktar" ;
  buktala_vb_1_V = mkV "buktalar" ;
  bullra_vb_1_V = mkV "bullrar" ;
  bulna_vb_1_V = mkV "bulnar" ;
  bunkra_vb_1_V = mkV "bunkrar" ;
  bura_in_vbm_1_V2 = dirV2 (partV (mkV "burar")"in") ;
  busa_vb_1_V = mkV "busar" ;
  buska_vb_2_V = mkV "buskar" ;
  busringa_vb_1_V = mkV "busringer" ;
  busvissla_vb_1_V = mkV "busvisslar" ;
  bygga_vb_1_V = mkV "bygger" ;
  byka_vb_1_V = mkV "byker" ;
  byta_vb_1_V = mkV "byter" ;
  baedda_in_vbm_1_1_V2 = dirV2 (partV (mkV "bäddar")"in") ;
  baedda_om_vbm_1_1_V2 = dirV2 (partV (mkV "bäddar")"om") ;
  baenda_vb_1_1_V = mkV "bänder" ;
  baendsla_vb_1_1_V = mkV "bändslar" ;
  baensla_vb_1_1_V = mkV "bänslar" ;
  baersa_vb_1_1_V = mkV "bärsar" ;
  baeva_vb_1_1_V = mkV "bävar" ;
  baada_vb_1_1_V = mkV "bådar" ;
  baaga_vb_1_1_V = mkV "bågar" ;
  baata_vb_1_1_V = mkV "båtar" ;
  boeka_vb_1_1_V = mkV "bökar" ;
  boela_vb_1_1_V = mkV "bölar" ;
  boelja_vb_1_1_V = mkV "böljar" ;
  boena_vb_1_1_V = mkV "bönar" ;
  boesta_vb_1_1_V = mkV "böstar" ;
  boetfaella_vb_1_1_V = mkV "bötfäller" ;
  campa_vb_1_V = mkV "campar" ;
  changera_vb_1_V = mkV "changerar" ;
  changsera_vb_1_V = mkV "changserar" ;
  chansa_vb_1_V = mkV "chansar" ;
  chansera_vb_1_V = mkV "chanserar" ;
  chatta_vb_1_V = mkV "chattar" ;
  chefa_vb_1_V = mkV "chefar" ;
  chilla_vb_1_V = mkV "chillar" ;
  chimpa_vb_1_V = mkV "chimpar" ;
  cirkla_vb_1_V = mkV "cirklar" ;
  crawla_vb_1_V = mkV "crawlar" ;
  curla_vb_1_V = mkV "curlar" ;
  dagdroemma_vb_1_1_V = mkV "dagdrömmer" ;
  dagga_vb_1_V = mkV "daggar" ;
  dagtinga_vb_1_V = mkV "dagtingar" ;
  dala_vb_1_V = mkV "dalar" ;
  dallra_vb_1_V = mkV "dallrar" ;
  dalta_vb_1_V = mkV "daltar" ;
  damma_vb_1_V = mkV "dammar" ;
  damma_av_vbm_1_V2 = dirV2 (partV (mkV "dammar")"av") ;
  damma_till_vbm_1_V2 = dirV2 (partV (mkV "dammar")"till") ;
  dampa_vb_2_V = mkV "dampar" ;
  dangla_vb_1_V = mkV "danglar" ;
  dansa_vb_1_V = mkV "dansar" ;
  darra_vb_1_V = mkV "darrar" ;
  dassa_vb_1_V = mkV "dassar" ;
  datta_vb_1_V = mkV "dattar" ;
  datummaerka_vb_1_1_V = mkV "datummärker" ;
  debutera_vb_1_V = mkV "debuterar" ;
  dega_vb_1_V = mkV "degar" ;
  dejsa_vb_1_V = mkV "dejsar" ;
  dela_ut_vbm_1_V2 = dirV2 (partV (mkV "delar")"ut") ;
  deltidsarbeta_vb_1_V = mkV "deltidsarbetar" ;
  demonstrera_vb_2_V = mkV "demonstrerar" ;
  deppa_vb_1_V = mkV "deppar" ;
  desertera_vb_1_V = mkV "deserterar" ;
  deviera_vb_1_V = mkV "devierar" ;
  diagonala_vb_1_V = mkV "diagonalar" ;
  dibbla_vb_1_V = mkV "dibblar" ;
  digna_vb_1_V = mkV "dignar" ;
  dika_av_vbm_1_V2 = dirV2 (partV (mkV "dikar")"av") ;
  dila_vb_1_V = mkV "dilar" ;
  dilla_vb_1_V = mkV "dillar" ;
  dinera_vb_1_V = mkV "dinerar" ;
  dingla_vb_1_V = mkV "dinglar" ;
  dippa_vb_2_V = mkV "dippar" ;
  direktsaenda_vb_1_1_V = mkV "direktsänder" ;
  dirka_vb_1_V = mkV "dirkar" ;
  dirra_vb_1_V = mkV "dirrar" ;
  diska_av_vbm_1_V2 = dirV2 (partV (mkV "diskar")"av") ;
  dissonera_vb_1_V = mkV "dissonerar" ;
  djupfrysa_vb_1_V = mkV "djupfryser" ;
  djupna_vb_1_V = mkV "djupnar" ;
  doa_vb_1_V = mkV "doar" ;
  dobbla_vb_1_V = mkV "dobblar" ;
  docera_vb_1_V = mkV "docerar" ;
  dofta_vb_1_V = mkV "doftar" ;
  domdera_vb_1_V = mkV "domderar" ;
  domfaella_vb_1_1_V = mkV "domfäller" ;
  domna_av_vbm_1_V2 = dirV2 (partV (mkV "domnar")"av") ;
  dona_vb_1_V = mkV "donar" ;
  donka_vb_2_V = mkV "donkar" ;
  dravla_vb_1_V = mkV "dravlar" ;
  dregla_vb_1_V = mkV "dreglar" ;
  drejvaenda_vb_1_1_V = mkV "drejvänder" ;
  dribbla_vb_1_V = mkV "dribblar" ;
  droppa_vb_1_V = mkV "droppar" ;
  drulla_vb_1_V = mkV "drullar" ;
  drumla_vb_1_V = mkV "drumlar" ;
  dryga_ut_vbm_1_V2 = dirV2 (partV (mkV "drygar")"ut") ;
  draegla_vb_1_1_V = mkV "dräglar" ;
  draella_vb_1_1_V = mkV "dräller" ;
  draemma_vb_1_1_V = mkV "drämmer" ;
  draenka_vb_1_1_V = mkV "dränker" ;
  draepa_vb_1_1_V = mkV "dräper" ;
  draasa_vb_1_1_V = mkV "dråsar" ;
  droemma_vb_1_1_V = mkV "drömmer" ;
  droena_vb_1_1_V = mkV "drönar" ;
  ducka_vb_1_V = mkV "duckar" ;
  duellera_vb_1_V = mkV "duellerar" ;
  dugga_vb_1_V = mkV "duggar" ;
  duggregna_vb_1_V = mkV "duggregnar" ;
  duka_av_vbm_1_V2 = dirV2 (partV (mkV "dukar")"av") ;
  duna_vb_1_V = mkV "dunar" ;
  dundra_vb_1_V = mkV "dundrar" ;
  dunsa_vb_1_V = mkV "dunsar" ;
  dunsta_vb_1_V = mkV "dunstar" ;
  durka_vb_1_V = mkV "durkar" ;
  duska_vb_1_V = mkV "duskar" ;
  duva_vb_1_V = mkV "duvar" ;
  duvna_vb_1_V = mkV "duvnar" ;
  dyvla_paa_vbm_1_1_V2 = dirV2 (partV (mkV "dyvlar")"på") ;
  daemma_vb_1_1_V = mkV "dämmer" ;
  daenga_vb_1_1_V = mkV "dänger" ;
  daenka_vb_1_1_V = mkV "dänker" ;
  daana_vb_1_1_V = mkV "dånar" ;
  daasa_vb_1_1_V = mkV "dåsar" ;
  doema_vb_1_1_V = mkV "dömer" ;
  doena_vb_1_1_V = mkV "dönar" ;
  doepa_vb_1_1_V = mkV "döper" ;
  ebba_vb_1_V = mkV "ebbar" ;
  efteranmaela_vb_1_1_V = mkV "efteranmäler" ;
  efterleva_vb_1_V = mkV "efterlever" ;
  efterlysa_vb_1_V = mkV "efterlyser" ;
  eftersinna_vb_1_V = mkV "eftersinnar" ;
  efterskaenka_vb_1_1_V = mkV "efterskänker" ;
  eftersaenda_vb_1_1_V = mkV "eftersänder" ;
  eftersoeka_vb_1_1_V = mkV "eftersöker" ;
  eftertraa_vb_1_1_V = mkV "eftertrår" ;
  egensvaenga_vb_1_1_V = mkV "egensvänger" ;
  ejakulera_vb_1_V = mkV "ejakulerar" ;
  eka_vb_1_V = mkV "ekar" ;
  eldvakta_vb_1_V = mkV "eldvaktar" ;
  emanera_vb_1_V = mkV "emanerar" ;
  enkla_vb_1_V = mkV "enklar" ;
  erinra_vb_1_V = mkV "erinrar" ;
  ernaa_vb_1_1_V = mkV "ernår" ;
  evangelisera_vb_1_V = mkV "evangeliserar" ;
  excellera_vb_1_V = mkV "excellerar" ;
  existera_vb_1_V = mkV "existerar" ;
  experimentera_vb_1_V = mkV "experimenterar" ;
  extraknaecka_vb_1_1_V = mkV "extraknäcker" ;
  extremkyla_vb_1_V = mkV "extremkyler" ;
  fabla_vb_1_V = mkV "fablar" ;
  falka_vb_1_V = mkV "falkar" ;
  fallera_vb_1_V = mkV "fallerar" ;
  falsa_av_vbm_1_V2 = dirV2 (partV (mkV "falsar")"av") ;
  famla_vb_1_V = mkV "famlar" ;
  fasa_vb_2_V = mkV "fasar" ;
  fasa_av_vbm_1_V2 = dirV2 (partV (mkV "fasar")"av") ;
  fasa_ut_vbm_1_V2 = dirV2 (partV (mkV "fasar")"ut") ;
  fasta_vb_1_V = mkV "fastar" ;
  fastna_vb_1_V = mkV "fastnar" ;
  faststaella_vb_1_1_V = mkV "fastställer" ;
  fatta_vb_2_V = mkV "fattar" ;
  feja_av_vbm_1_V2 = dirV2 (partV (mkV "fejar")"av") ;
  fela_vb_1_V = mkV "felar" ;
  felbedoema_vb_1_1_V = mkV "felbedömer" ;
  festa_vb_1_V = mkV "festar" ;
  fetma_vb_1_V = mkV "fetmar" ;
  fetna_vb_1_V = mkV "fetnar" ;
  fiffla_vb_1_V = mkV "fifflar" ;
  figurera_vb_1_V = mkV "figurerar" ;
  fika_vb_1_V = mkV "fikar" ;
  fila_av_vbm_1_V2 = dirV2 (partV (mkV "filar")"av") ;
  filosofera_vb_1_V = mkV "filosoferar" ;
  filtrera_av_vbm_1_V2 = dirV2 (partV (mkV "filtrerar")"av") ;
  fingra_vb_1_V = mkV "fingrar" ;
  fininstaella_vb_1_1_V = mkV "fininställer" ;
  fippla_vb_1_V = mkV "fipplar" ;
  fjanta_vb_1_V = mkV "fjantar" ;
  fjaedra_vb_1_1_V = mkV "fjädrar" ;
  fjaella_av_vbm_1_1_V2 = dirV2 (partV (mkV "fjällar")"av") ;
  fjaellvandra_vb_1_1_V = mkV "fjällvandrar" ;
  fjaerta_vb_1_1_V = mkV "fjärtar" ;
  fjaeska_vb_1_1_V = mkV "fjäskar" ;
  fjaettra_vb_1_1_V = mkV "fjättrar" ;
  fjoela_vb_1_1_V = mkV "fjölar" ;
  flabba_vb_1_V = mkV "flabbar" ;
  flacka_vb_1_V = mkV "flackar" ;
  fladdra_vb_1_V = mkV "fladdrar" ;
  flaga_vb_1_V = mkV "flagar" ;
  flamma_vb_1_V = mkV "flammar" ;
  flamsa_vb_1_V = mkV "flamsar" ;
  flanera_vb_1_V = mkV "flanerar" ;
  flatskratta_vb_1_V = mkV "flatskrattar" ;
  flaxa_vb_1_V = mkV "flaxar" ;
  flexa_vb_1_V = mkV "flexar" ;
  flexa_in_vbm_1_V2 = dirV2 (partV (mkV "flexar")"in") ;
  flexa_ut_vbm_1_V2 = dirV2 (partV (mkV "flexar")"ut") ;
  flicka_in_vbm_1_V2 = dirV2 (partV (mkV "flickar")"in") ;
  flika_in_vbm_1_V2 = dirV2 (partV (mkV "flikar")"in") ;
  flimra_vb_1_V = mkV "flimrar" ;
  flina_vb_1_V = mkV "flinar" ;
  flirta_vb_1_V = mkV "flirtar" ;
  florera_vb_1_V = mkV "florerar" ;
  flukta_vb_1_V = mkV "fluktar" ;
  fluktuera_vb_1_V = mkV "fluktuerar" ;
  flumma_vb_1_V = mkV "flummar" ;
  fluorescera_vb_1_V = mkV "fluorescerar" ;
  fly_vb_1_V = mkV "flyr" ;
  flytta_ut_vbm_1_V2 = dirV2 (partV (mkV "flyttar")"ut") ;
  flaeka_vb_1_1_V = mkV "fläker" ;
  flaekta_vb_1_1_V = mkV "fläktar" ;
  flaemta_vb_1_1_V = mkV "flämtar" ;
  flaenga_vb_1_1_V = mkV "flänger" ;
  flaenga_vb_2_1_V = mkV "flänger" ;
  flaeska_paa_vbm_1_1_V2 = dirV2 (partV (mkV "fläskar")"på") ;
  flaeska_till_vbm_1_1_V2 = dirV2 (partV (mkV "fläskar")"till") ;
  flaa_vb_1_1_V = mkV "flår" ;
  flaasa_vb_1_1_V = mkV "flåsar" ;
  floeda_vb_1_1_V = mkV "flödar" ;
  floejla_vb_1_1_V = mkV "flöjlar" ;
  floerta_vb_1_1_V = mkV "flörtar" ;
  fnaska_vb_1_V = mkV "fnaskar" ;
  fnatta_vb_1_V = mkV "fnattar" ;
  fnissa_vb_1_V = mkV "fnissar" ;
  fnittra_vb_1_V = mkV "fnittrar" ;
  fodra_vb_1_V = mkV "fodrar" ;
  folkomroesta_vb_1_1_V = mkV "folkomröstar" ;
  fordra_vb_1_V = mkV "fordrar" ;
  forma_till_vbm_1_V2 = dirV2 (partV (mkV "formar")"till") ;
  forsa_vb_1_V = mkV "forsar" ;
  forska_vb_1_V = mkV "forskar" ;
  forska_igenom_vbm_1_V2 = dirV2 (partV (mkV "forskar")"igenom") ;
  forsla_av_vbm_1_V2 = dirV2 (partV (mkV "forslar")"av") ;
  forsla_in_vbm_1_V2 = dirV2 (partV (mkV "forslar")"in") ;
  fortleva_vb_1_V = mkV "fortlever" ;
  fortloepa_vb_1_1_V = mkV "fortlöper" ;
  fosforescera_vb_1_V = mkV "fosforescerar" ;
  fostra_vb_1_V = mkV "fostrar" ;
  fotvandra_vb_1_V = mkV "fotvandrar" ;
  fradga_vb_1_V = mkV "fradgar" ;
  framavla_vb_1_V = mkV "framavlar" ;
  framhaerda_vb_1_1_V = mkV "framhärdar" ;
  framhaeva_vb_1_1_V = mkV "framhäver" ;
  framleva_vb_1_V = mkV "framlever" ;
  framstaella_vb_1_1_V = mkV "framställer" ;
  framtona_vb_1_V = mkV "framtonar" ;
  framtraenga_vb_1_1_V = mkV "framtränger" ;
  frasa_vb_1_V = mkV "frasar" ;
  fraternisera_vb_1_V = mkV "fraterniserar" ;
  freaka_ut_vbm_1_V2 = dirV2 (partV (mkV "freakar")"ut") ;
  fridlysa_vb_1_V = mkV "fridlyser" ;
  frika_ut_vbm_1_V2 = dirV2 (partV (mkV "frikar")"ut") ;
  frikoepa_vb_1_1_V = mkV "friköper" ;
  frilansa_vb_1_V = mkV "frilansar" ;
  frimaerka_vb_1_1_V = mkV "frimärker" ;
  friska_vb_1_V = mkV "friskar" ;
  friskanmaela_vb_1_1_V = mkV "friskanmäler" ;
  friskna_till_vbm_1_V2 = dirV2 (partV (mkV "frisknar")"till") ;
  frisksporta_vb_1_V = mkV "frisksportar" ;
  frislaeppa_vb_1_1_V = mkV "frisläpper" ;
  fristaella_vb_1_1_V = mkV "friställer" ;
  fromla_vb_1_V = mkV "fromlar" ;
  frossa_vb_1_V = mkV "frossar" ;
  frosta_av_vbm_1_V2 = dirV2 (partV (mkV "frostar")"av") ;
  frosta_ur_vbm_1_V2 = dirV2 (partV (mkV "frostar")"ur") ;
  frukostera_vb_1_V = mkV "frukosterar" ;
  frusa_vb_1_V = mkV "frusar" ;
  frusta_vb_1_V = mkV "frustar" ;
  fraelsa_vb_1_1_V = mkV "frälser" ;
  fraesa_vb_1_1_V = mkV "fräser" ;
  fraesa_vb_2_1_V = mkV "fräser" ;
  fraeta_vb_1_1_V = mkV "fräter" ;
  fraaga_ut_vbm_1_1_V2 = dirV2 (partV (mkV "frågar")"ut") ;
  fraandoema_vb_1_1_V = mkV "fråndömer" ;
  froea_vb_1_1_V = mkV "fröar" ;
  froejda_vb_1_1_V = mkV "fröjdar" ;
  fullproppa_vb_1_V = mkV "fullproppar" ;
  fumla_vb_1_V = mkV "fumlar" ;
  fundera_vb_1_V = mkV "funderar" ;
  fundera_ut_vbm_1_V2 = dirV2 (partV (mkV "funderar")"ut") ;
  fungera_vb_1_V = mkV "fungerar" ;
  funka_vb_1_V = mkV "funkar" ;
  funktionera_vb_1_V = mkV "funktionerar" ;
  fuska_vb_1_V = mkV "fuskar" ;
  futta_vb_1_V = mkV "futtar" ;
  fylla_vb_1_V = mkV "fyller" ;
  fyllna_vb_1_V = mkV "fyllnar" ;
  faekta_vb_1_1_V = mkV "fäktar" ;
  faella_vb_1_1_V = mkV "fäller" ;
  faerdigjaesa_vb_1_1_V = mkV "färdigjäser" ;
  faerdigstaella_vb_1_1_V = mkV "färdigställer" ;
  faanskratta_vb_1_1_V = mkV "fånskrattar" ;
  foela_vb_1_1_V = mkV "fölar" ;
  foeranmaela_vb_1_1_V = mkV "föranmäler" ;
  foerbygga_vb_1_1_V = mkV "förbygger" ;
  foerbyta_vb_1_1_V = mkV "förbyter" ;
  foerdaemma_vb_1_1_V = mkV "fördämmer" ;
  foerdoema_vb_1_1_V = mkV "fördömer" ;
  foerebraa_vb_1_1_V = mkV "förebrår" ;
  foerebygga_vb_1_1_V = mkV "förebygger" ;
  foerelaesa_vb_1_1_V = mkV "föreläser" ;
  foerena_vb_1_1_V = mkV "förenar" ;
  foerespaa_vb_1_1_V = mkV "förespår" ;
  foerestaella_vb_1_1_V = mkV "föreställer" ;
  foeresvaeva_vb_1_1_V = mkV "föresvävar" ;
  foerfoga_vb_1_1_V = mkV "förfogar" ;
  foergloemma_vb_1_1_V = mkV "förglömmer" ;
  foergylla_vb_1_1_V = mkV "förgyller" ;
  foerhaerska_vb_1_1_V = mkV "förhärskar" ;
  foerkrympa_vb_1_1_V = mkV "förkrymper" ;
  foerkvaeva_vb_1_1_V = mkV "förkväver" ;
  foerlika_vb_1_1_V = mkV "förliker" ;
  foerlisa_vb_1_1_V = mkV "förliser" ;
  foerlaenga_vb_1_1_V = mkV "förlänger" ;
  foerloesa_vb_1_1_V = mkV "förlöser" ;
  foermaela_vb_1_1_V = mkV "förmäler" ;
  foermaerka_vb_1_1_V = mkV "förmärker" ;
  foermaa_vb_1_1_V = mkV "förmår" ;
  foernoeta_vb_1_1_V = mkV "förnöter" ;
  foerortsbo_vb_1_1_V = mkV "förortsbor" ;
  foerpassa_in_vbm_1_1_V2 = dirV2 (partV (mkV "förpassar")"in") ;
  foerrycka_vb_1_1_V = mkV "förrycker" ;
  foerskraecka_vb_1_1_V = mkV "förskräcker" ;
  foerskylla_vb_1_1_V = mkV "förskyller" ;
  foersmaekta_vb_1_1_V = mkV "försmäktar" ;
  foersmaa_vb_1_1_V = mkV "försmår" ;
  foerspilla_vb_1_1_V = mkV "förspiller" ;
  foerstraecka_vb_1_1_V = mkV "försträcker" ;
  foerstroe_vb_1_1_V = mkV "förströr" ;
  foerstaella_vb_1_1_V = mkV "förställer" ;
  foerstaemma_vb_1_1_V = mkV "förstämmer" ;
  foerstaerka_vb_1_1_V = mkV "förstärker" ;
  foersaenda_vb_1_1_V = mkV "försänder" ;
  foersaenka_vb_1_1_V = mkV "försänker" ;
  foersoeka_vb_1_1_V = mkV "försöker" ;
  foertjusa_vb_1_1_V = mkV "förtjuser" ;
  foertona_vb_1_1_V = mkV "förtonar" ;
  foertro_vb_1_1_V = mkV "förtror" ;
  foertrycka_vb_1_1_V = mkV "förtrycker" ;
  foertraenga_vb_1_1_V = mkV "förtränger" ;
  foertycka_vb_1_1_V = mkV "förtycker" ;
  foertaenka_vb_1_1_V = mkV "förtänker" ;
  foerundersoeka_vb_1_1_V = mkV "förundersöker" ;
  foerutbestaemma_vb_1_1_V = mkV "förutbestämmer" ;
  foerutspaa_vb_1_1_V = mkV "förutspår" ;
  foervraenga_vb_1_1_V = mkV "förvränger" ;
  foervaella_vb_1_1_V = mkV "förväller" ;
  foervaenda_vb_1_1_V = mkV "förvänder" ;
  foervaervsarbeta_vb_1_1_V = mkV "förvärvsarbetar" ;
  foesa_vb_1_1_V = mkV "föser" ;
  gaffla_vb_1_V = mkV "gafflar" ;
  gagga_vb_1_V = mkV "gaggar" ;
  gallra_ut_vbm_1_V2 = dirV2 (partV (mkV "gallrar")"ut") ;
  galoppera_vb_1_V = mkV "galopperar" ;
  gama_vb_1_V = mkV "gamar" ;
  gana_vb_2_V = mkV "ganar" ;
  gapa_vb_1_V = mkV "gapar" ;
  gapflabba_vb_1_V = mkV "gapflabbar" ;
  gapskratta_vb_1_V = mkV "gapskrattar" ;
  gasa_vb_1_V = mkV "gasar" ;
  gassa_vb_1_V = mkV "gassar" ;
  gasta_vb_1_V = mkV "gastar" ;
  gastera_vb_1_V = mkV "gasterar" ;
  gegga_vb_1_V = mkV "geggar" ;
  gena_vb_1_V = mkV "genar" ;
  genmaela_vb_1_1_V = mkV "genmäler" ;
  genomleva_vb_1_V = mkV "genomlever" ;
  genomlysa_vb_1_V = mkV "genomlyser" ;
  genomsoeka_vb_1_1_V = mkV "genomsöker" ;
  genomtraenga_vb_1_1_V = mkV "genomtränger" ;
  genomtaenka_vb_1_1_V = mkV "genomtänker" ;
  gestikulera_vb_1_V = mkV "gestikulerar" ;
  gigga_vb_1_V = mkV "giggar" ;
  gilja_vb_1_V = mkV "giljar" ;
  gina_vb_1_V = mkV "ginar" ;
  gipa_vb_1_V = mkV "gipar" ;
  gippa_vb_1_V = mkV "gippar" ;
  gira_vb_1_V = mkV "girar" ;
  gissla_vb_1_V = mkV "gisslar" ;
  gistna_vb_1_V = mkV "gistnar" ;
  glamma_vb_1_V = mkV "glammar" ;
  glana_vb_1_V = mkV "glanar" ;
  glappa_vb_1_V = mkV "glappar" ;
  glassa_vb_1_V = mkV "glassar" ;
  glesbygdsbo_vb_1_V = mkV "glesbygdsbor" ;
  glimma_vb_1_V = mkV "glimmar" ;
  glimra_vb_1_V = mkV "glimrar" ;
  glimta_vb_1_V = mkV "glimtar" ;
  glindra_vb_1_V = mkV "glindrar" ;
  glipa_vb_1_V = mkV "glipar" ;
  glisa_vb_1_V = mkV "gliser" ;
  glittra_vb_1_V = mkV "glittrar" ;
  glo_vb_1_V = mkV "glor" ;
  glunka_vb_1_V = mkV "glunkar" ;
  glutta_vb_1_V = mkV "gluttar" ;
  glaefsa_vb_1_1_V = mkV "gläfser" ;
  glaensa_vb_1_1_V = mkV "glänser" ;
  gloedsteka_vb_1_1_V = mkV "glödsteker" ;
  gloedtaenda_vb_1_1_V = mkV "glödtänder" ;
  gloegga_vb_1_1_V = mkV "glöggar" ;
  gloemma_vb_1_1_V = mkV "glömmer" ;
  gloeta_vb_1_1_V = mkV "glötar" ;
  gnaga_vb_1_V = mkV "gnager" ;
  gnata_vb_1_V = mkV "gnatar" ;
  gnava_vb_1_V = mkV "gnaver" ;
  gneta_vb_1_V = mkV "gnetar" ;
  gnissla_vb_1_V = mkV "gnisslar" ;
  gnistra_vb_1_V = mkV "gnistrar" ;
  gno_vb_1_V = mkV "gnor" ;
  gnugga_av_vbm_1_V2 = dirV2 (partV (mkV "gnuggar")"av") ;
  gnussa_vb_1_V = mkV "gnussar" ;
  gny_vb_1_V = mkV "gnyr" ;
  gnaegga_vb_1_1_V = mkV "gnäggar" ;
  gnaella_vb_1_1_V = mkV "gnäller" ;
  gnoela_vb_1_1_V = mkV "gnölar" ;
  gola_vb_1_V = mkV "golar" ;
  golfa_vb_1_V = mkV "golfar" ;
  gorma_vb_1_V = mkV "gormar" ;
  gosa_vb_1_V = mkV "gosar" ;
  grassera_vb_1_V = mkV "grasserar" ;
  gravitera_vb_1_V = mkV "graviterar" ;
  grensla_vb_1_V = mkV "grenslar" ;
  grimasera_vb_1_V = mkV "grimaserar" ;
  grina_vb_1_V = mkV "grinar" ;
  grisa_vb_1_V = mkV "grisar" ;
  gro_vb_1_V = mkV "gror" ;
  grogga_vb_1_V = mkV "groggar" ;
  grovna_vb_1_V = mkV "grovnar" ;
  grubbla_vb_1_V = mkV "grubblar" ;
  gruffa_vb_1_V = mkV "gruffar" ;
  grumla_vb_1_V = mkV "grumlar" ;
  grunda_vb_2_V = mkV "grundar" ;
  grundstoeta_vb_1_1_V = mkV "grundstöter" ;
  grunna_vb_1_V = mkV "grunnar" ;
  gruppsaa_vb_1_1_V = mkV "gruppsår" ;
  gry_vb_1_V = mkV "gryr" ;
  grymta_vb_1_V = mkV "grymtar" ;
  gryna_vb_1_V = mkV "grynar" ;
  graela_vb_1_1_V = mkV "grälar" ;
  graema_vb_1_1_V = mkV "grämer" ;
  graensa_vb_1_1_V = mkV "gränsar" ;
  graensla_vb_1_1_V = mkV "gränslar" ;
  graesa_vb_1_1_V = mkV "gräsar" ;
  graeva_vb_1_1_V = mkV "gräver" ;
  graeva_vb_2_1_V = mkV "gräver" ;
  groengoedsla_vb_1_1_V = mkV "gröngödslar" ;
  groenska_vb_1_1_V = mkV "grönskar" ;
  groeta_vb_1_1_V = mkV "grötar" ;
  gulla_vb_1_V = mkV "gullar" ;
  gumpa_vb_1_V = mkV "gumpar" ;
  gunga_vb_1_V = mkV "gungar" ;
  guppa_vb_1_V = mkV "guppar" ;
  gurgla_vb_1_V = mkV "gurglar" ;
  gurgla_vb_2_V = mkV "gurglar" ;
  gyckla_vb_1_V = mkV "gycklar" ;
  gympa_vb_1_V = mkV "gympar" ;
  gyttra_vb_1_V = mkV "gyttrar" ;
  gaella_vb_1_1_V = mkV "gäller" ;
  gaerdsla_vb_1_1_V = mkV "gärdslar" ;
  gaespa_vb_1_1_V = mkV "gäspar" ;
  gaanga_vb_1_1_V = mkV "gångar" ;
  goedsla_vb_1_1_V = mkV "gödslar" ;
  goemma_vb_1_1_V = mkV "gömmer" ;
  goerdla_vb_1_1_V = mkV "gördlar" ;
  hacka_av_vbm_1_V2 = dirV2 (partV (mkV "hackar")"av") ;
  hafsa_vb_1_V = mkV "hafsar" ;
  hagla_vb_1_V = mkV "haglar" ;
  hajka_vb_1_V = mkV "hajkar" ;
  haka_av_vbm_1_V2 = dirV2 (partV (mkV "hakar")"av") ;
  haka_paa_vbm_1_1_V2 = dirV2 (partV (mkV "hakar")"på") ;
  hala_ut_vbm_1_V2 = dirV2 (partV (mkV "halar")"ut") ;
  halka_vb_1_V = mkV "halkar" ;
  hallaaa_vb_1_1_V = mkV "hallåar" ;
  halstra_vb_1_V = mkV "halstrar" ;
  halta_vb_1_V = mkV "haltar" ;
  halvnaecka_vb_1_1_V = mkV "halvnäckar" ;
  hamla_vb_1_V = mkV "hamlar" ;
  hamstra_vb_1_V = mkV "hamstrar" ;
  handla_vb_1_V = mkV "handlar" ;
  hanka_vb_1_V = mkV "hankar" ;
  harkla_vb_1_V = mkV "harklar" ;
  harmoniera_vb_1_V = mkV "harmonierar" ;
  harskla_vb_1_V = mkV "harsklar" ;
  hasa_vb_1_V = mkV "hasar" ;
  haspla_av_vbm_1_V2 = dirV2 (partV (mkV "hasplar")"av") ;
  hasta_vb_1_V = mkV "hastar" ;
  hatta_vb_1_V = mkV "hattar" ;
  hemstaella_vb_1_1_V = mkV "hemställer" ;
  hemsoeka_vb_1_1_V = mkV "hemsöker" ;
  hesitera_vb_1_V = mkV "hesiterar" ;
  hetta_vb_1_V = mkV "hettar" ;
  hibernera_vb_1_V = mkV "hibernerar" ;
  hicka_vb_1_V = mkV "hickar" ;
  himla_vb_1_V = mkV "himlar" ;
  hindra_vb_1_V = mkV "hindrar" ;
  hisna_vb_1_V = mkV "hisnar" ;
  hissna_vb_1_V = mkV "hissnar" ;
  hitta_paa_vbm_1_1_V2 = dirV2 (partV (mkV "hittar")"på") ;
  hjula_vb_1_V = mkV "hjular" ;
  hjaelpa_vb_1_1_V = mkV "hjälper" ;
  hjaelpe_vb_1_1_V = mkV "hjälpe" ;
  hoa_vb_1_V = mkV "hoar" ;
  hoja_vb_1_V = mkV "hojar" ;
  hojta_vb_1_V = mkV "hojtar" ;
  hopknyckla_vb_1_V = mkV "hopknycklar" ;
  hopkoppla_vb_1_V = mkV "hopkopplar" ;
  hoppa_av_vbm_1_V2 = dirV2 (partV (mkV "hoppar")"av") ;
  hoppa_oever_vbm_1_1_V2 = dirV2 (partV (mkV "hoppar")"över") ;
  hora_vb_1_V = mkV "horar" ;
  hosta_vb_1_V = mkV "hostar" ;
  hovra_vb_1_V = mkV "hovrar" ;
  hudflaenga_vb_1_1_V = mkV "hudflänger" ;
  hulka_vb_1_V = mkV "hulkar" ;
  humma_vb_1_V = mkV "hummar" ;
  hungerstrejka_vb_1_V = mkV "hungerstrejkar" ;
  hungra_vb_1_V = mkV "hungrar" ;
  hurra_vb_1_V = mkV "hurrar" ;
  husera_vb_1_V = mkV "huserar" ;
  hushaalla_vb_1_1_V = mkV "hushållar" ;
  huta_vb_1_V = mkV "hutar" ;
  huttla_vb_1_V = mkV "huttlar" ;
  huttra_vb_1_V = mkV "huttrar" ;
  hyckla_vb_1_V = mkV "hycklar" ;
  hyfsa_till_vbm_1_V2 = dirV2 (partV (mkV "hyfsar")"till") ;
  hyla_vb_1_V = mkV "hylar" ;
  hymla_vb_1_V = mkV "hymlar" ;
  hysa_vb_1_V = mkV "hyser" ;
  hyvla_vb_1_V = mkV "hyvlar" ;
  hyvla_av_vbm_1_V2 = dirV2 (partV (mkV "hyvlar")"av") ;
  haecka_vb_1_1_V = mkV "häckar" ;
  haeckla_vb_1_1_V = mkV "häcklar" ;
  haefta_in_vbm_1_1_V2 = dirV2 (partV (mkV "häftar")"in") ;
  haefta_vid_vbm_1_1_V2 = dirV2 (partV (mkV "häftar")"vid") ;
  haegna_in_vbm_1_1_V2 = dirV2 (partV (mkV "hägnar")"in") ;
  haegra_vb_1_1_V = mkV "hägrar" ;
  haekta_av_vbm_1_1_V2 = dirV2 (partV (mkV "häktar")"av") ;
  haella_vb_1_1_V = mkV "häller" ;
  haellregna_vb_1_1_V = mkV "hällregnar" ;
  haelsa_paa_vbm_1_1_V2 = dirV2 (partV (mkV "hälsar")"på") ;
  haemma_vb_1_1_V = mkV "hämmar" ;
  haenda_vb_1_1_V = mkV "händer" ;
  haenga_vb_1_1_V = mkV "hänger" ;
  haenga_vb_2_1_V = mkV "hänger" ;
  haenrycka_vb_1_1_V = mkV "hänrycker" ;
  haensyfta_vb_1_1_V = mkV "hänsyftar" ;
  haepna_vb_1_1_V = mkV "häpnar" ;
  haerda_ut_vbm_1_1_V2 = dirV2 (partV (mkV "härdar")"ut") ;
  haerska_vb_1_1_V = mkV "härskar" ;
  haerstamma_vb_1_1_V = mkV "härstammar" ;
  haeva_vb_1_1_V = mkV "häver" ;
  haanflina_vb_1_1_V = mkV "hånflinar" ;
  haangla_vb_1_1_V = mkV "hånglar" ;
  haanskratta_vb_1_1_V = mkV "hånskrattar" ;
  haardna_till_vbm_1_1_V2 = dirV2 (partV (mkV "hårdnar")"till") ;
  haava_in_vbm_1_1_V2 = dirV2 (partV (mkV "håvar")"in") ;
  hoefta_till_vbm_1_1_V2 = dirV2 (partV (mkV "höftar")"till") ;
  hoesta_vb_1_1_V = mkV "höstar" ;
  hoesta_in_vbm_1_1_V2 = dirV2 (partV (mkV "höstar")"in") ;
  idissla_vb_1_V = mkV "idisslar" ;
  idrotta_vb_1_V = mkV "idrottar" ;
  ila_vb_1_V = mkV "ilar" ;
  illudera_vb_1_V = mkV "illuderar" ;
  illvraala_vb_1_1_V = mkV "illvrålar" ;
  ilskna_till_vbm_1_V2 = dirV2 (partV (mkV "ilsknar")"till") ;
  imma_vb_1_V = mkV "immar" ;
  inblanda_vb_1_V = mkV "inblandar" ;
  inbygga_vb_1_V = mkV "inbygger" ;
  indraenka_vb_1_1_V = mkV "indränker" ;
  inhysa_vb_1_V = mkV "inhyser" ;
  inhoesta_vb_1_1_V = mkV "inhöstar" ;
  inkraekta_vb_1_1_V = mkV "inkräktar" ;
  inkraeva_vb_1_1_V = mkV "inkräver" ;
  inkoepa_vb_1_1_V = mkV "inköper" ;
  inloepa_vb_1_1_V = mkV "inlöper" ;
  inloesa_vb_1_1_V = mkV "inlöser" ;
  inmaenga_vb_1_1_V = mkV "inmänger" ;
  innestaenga_vb_1_1_V = mkV "innestänger" ;
  inoperera_vb_1_V = mkV "inopererar" ;
  inprogrammera_vb_1_V = mkV "inprogrammerar" ;
  inrymma_vb_1_V = mkV "inrymmer" ;
  inskraenka_vb_1_1_V = mkV "inskränker" ;
  inskaerpa_vb_1_1_V = mkV "inskärper" ;
  inspaerra_vb_1_1_V = mkV "inspärrar" ;
  instunda_vb_1_V = mkV "instundar" ;
  instaella_vb_1_1_V = mkV "inställer" ;
  instaemma_vb_1_1_V = mkV "instämmer" ;
  instaemma_vb_2_1_V = mkV "instämmer" ;
  instaenga_vb_1_1_V = mkV "instänger" ;
  insvepa_vb_1_V = mkV "insveper" ;
  insaenda_vb_1_1_V = mkV "insänder" ;
  intala_vb_1_V = mkV "intalar" ;
  interagera_vb_1_V = mkV "interagerar" ;
  interferera_vb_1_V = mkV "interfererar" ;
  intrigera_vb_1_V = mkV "intrigerar" ;
  intraenga_vb_1_1_V = mkV "intränger" ;
  inverka_vb_1_V = mkV "inverkar" ;
  inviga_vb_1_V = mkV "inviger" ;
  invintra_vb_1_V = mkV "invintrar" ;
  invaenda_vb_1_1_V = mkV "invänder" ;
  invaeva_vb_1_1_V = mkV "inväver" ;
  iordningstaella_vb_1_1_V = mkV "iordningställer" ;
  irisera_vb_1_V = mkV "iriserar" ;
  ironisera_vb_1_V = mkV "ironiserar" ;
  irra_vb_1_V = mkV "irrar" ;
  isa_vb_1_V = mkV "isar" ;
  ivra_vb_1_V = mkV "ivrar" ;
  jaga_ut_vbm_1_V2 = dirV2 (partV (mkV "jagar")"ut") ;
  jama_vb_1_V = mkV "jamar" ;
  jamma_vb_1_V = mkV "jammar" ;
  jamsa_vb_1_V = mkV "jamsar" ;
  jassa_vb_1_V = mkV "jassar" ;
  jazza_vb_1_V = mkV "jazzar" ;
  jiddra_vb_1_V = mkV "jiddrar" ;
  jobba_vb_1_V = mkV "jobbar" ;
  joddla_vb_1_V = mkV "joddlar" ;
  jollra_vb_1_V = mkV "jollrar" ;
  jolta_vb_1_V = mkV "joltar" ;
  joxa_vb_1_V = mkV "joxar" ;
  jubilera_vb_1_V = mkV "jubilerar" ;
  jubla_vb_1_V = mkV "jublar" ;
  jucka_vb_1_V = mkV "juckar" ;
  jula_vb_1_V = mkV "jular" ;
  jumpa_vb_1_V = mkV "jumpar" ;
  jympa_vb_1_V = mkV "jympar" ;
  jaemna_till_vbm_1_1_V2 = dirV2 (partV (mkV "jämnar")"till") ;
  jaemna_ut_vbm_1_1_V2 = dirV2 (partV (mkV "jämnar")"ut") ;
  jaemstaella_vb_1_1_V = mkV "jämställer" ;
  jaernsko_vb_1_1_V = mkV "järnskor" ;
  jaesa_vb_1_1_V = mkV "jäser" ;
  k_maerka_vb_1_1_V = mkV "k-märker" ;
  kabla_vb_1_V = mkV "kablar" ;
  kacka_vb_1_V = mkV "kackar" ;
  kackla_vb_1_V = mkV "kacklar" ;
  kajka_vb_1_V = mkV "kajkar" ;
  kalasa_vb_1_V = mkV "kalasar" ;
  kalla_ut_vbm_1_V2 = dirV2 (partV (mkV "kallar")"ut") ;
  kallgrina_vb_1_V = mkV "kallgrinar" ;
  kallmangla_vb_1_V = mkV "kallmanglar" ;
  kallprata_vb_1_V = mkV "kallpratar" ;
  kallroeka_vb_1_1_V = mkV "kallröker" ;
  kalna_vb_1_V = mkV "kalnar" ;
  kalva_vb_1_V = mkV "kalvar" ;
  kamma_in_vbm_1_V2 = dirV2 (partV (mkV "kammar")"in") ;
  kampa_vb_1_V = mkV "kampar" ;
  kampera_vb_1_V = mkV "kamperar" ;
  kana_vb_1_V = mkV "kanar" ;
  kandidera_vb_1_V = mkV "kandiderar" ;
  kanota_vb_1_V = mkV "kanotar" ;
  kanta_av_vbm_1_V2 = dirV2 (partV (mkV "kantar")"av") ;
  kantklippa_vb_1_V = mkV "kantklipper" ;
  kapa_av_vbm_1_V2 = dirV2 (partV (mkV "kapar")"av") ;
  kapitulera_vb_1_V = mkV "kapitulerar" ;
  kapprusta_vb_1_V = mkV "kapprustar" ;
  kappsegla_vb_1_V = mkV "kappseglar" ;
  kapsla_vb_1_V = mkV "kapslar" ;
  kasa_vb_1_V = mkV "kasar" ;
  kassera_in_vbm_1_V2 = dirV2 (partV (mkV "kasserar")"in") ;
  kasta_in_vbm_1_V2 = dirV2 (partV (mkV "kastar")"in") ;
  kasta_om_vbm_1_V2 = dirV2 (partV (mkV "kastar")"om") ;
  kasta_ut_vbm_1_V2 = dirV2 (partV (mkV "kastar")"ut") ;
  kava_vb_1_V = mkV "kavar" ;
  kavla_vb_1_V = mkV "kavlar" ;
  kavla_ut_vbm_1_V2 = dirV2 (partV (mkV "kavlar")"ut") ;
  kedjeroeka_vb_1_1_V = mkV "kedjeröker" ;
  kela_vb_1_V = mkV "kelar" ;
  kesa_vb_1_V = mkV "kesar" ;
  kikna_vb_1_V = mkV "kiknar" ;
  kila_vb_2_V = mkV "kilar" ;
  kila_in_vbm_1_V2 = dirV2 (partV (mkV "kilar")"in") ;
  kimma_vb_1_V = mkV "kimmar" ;
  kinesa_vb_1_V = mkV "kinesar" ;
  kinka_vb_1_V = mkV "kinkar" ;
  kippa_vb_1_V = mkV "kippar" ;
  kisa_vb_1_V = mkV "kisar" ;
  kittla_vb_1_V = mkV "kittlar" ;
  klabba_vb_1_V = mkV "klabbar" ;
  kladda_vb_1_V = mkV "kladdar" ;
  klaffa_vb_1_V = mkV "klaffar" ;
  klafsa_vb_1_V = mkV "klafsar" ;
  klampa_vb_1_V = mkV "klampar" ;
  klandra_vb_1_V = mkV "klandrar" ;
  klanka_vb_1_V = mkV "klankar" ;
  klanta_till_vbm_1_V2 = dirV2 (partV (mkV "klantar")"till") ;
  klappa_vb_2_V = mkV "klappar" ;
  klappra_vb_1_V = mkV "klapprar" ;
  klara_vb_1_V = mkV "klarar" ;
  klara_av_vbm_1_V2 = dirV2 (partV (mkV "klarar")"av") ;
  klarna_vb_1_V = mkV "klarnar" ;
  klema_vb_1_V = mkV "klemar" ;
  klia_vb_1_V = mkV "kliar" ;
  klibba_vb_1_V = mkV "klibbar" ;
  klicka_vb_1_V = mkV "klickar" ;
  klimpa_vb_1_V = mkV "klimpar" ;
  klinka_vb_1_V = mkV "klinkar" ;
  klippa_vb_1_V = mkV "klipper" ;
  klirra_vb_1_V = mkV "klirrar" ;
  klistra_vb_1_V = mkV "klistrar" ;
  klistra_paa_vbm_1_1_V2 = dirV2 (partV (mkV "klistrar")"på") ;
  klottra_vb_1_V = mkV "klottrar" ;
  klucka_vb_1_V = mkV "kluckar" ;
  klunka_vb_1_V = mkV "klunkar" ;
  klura_ut_vbm_1_V2 = dirV2 (partV (mkV "klurar")"ut") ;
  kluta_ut_vbm_1_V2 = dirV2 (partV (mkV "klutar")"ut") ;
  klaecka_vb_1_1_V = mkV "kläcker" ;
  klaemma_vb_1_1_V = mkV "klämmer" ;
  klaemta_vb_1_1_V = mkV "klämtar" ;
  klaenga_vb_1_1_V = mkV "klänger" ;
  klaenga_vb_2_1_V = mkV "klänger" ;
  klaettra_vb_1_1_V = mkV "klättrar" ;
  klaa_vb_1_1_V = mkV "klår" ;
  klaapa_vb_1_1_V = mkV "klåpar" ;
  kloesa_vb_1_1_V = mkV "klöser" ;
  knacka_av_vbm_1_V2 = dirV2 (partV (mkV "knackar")"av") ;
  knaggla_vb_1_V = mkV "knagglar" ;
  knaka_vb_1_V = mkV "knakar" ;
  knalla_vb_1_V = mkV "knallar" ;
  knappa_in_vbm_1_V2 = dirV2 (partV (mkV "knappar")"in") ;
  knapra_vb_1_V = mkV "knaprar" ;
  knarra_vb_1_V = mkV "knarrar" ;
  knastra_vb_1_V = mkV "knastrar" ;
  knattra_vb_1_V = mkV "knattrar" ;
  knega_vb_1_V = mkV "knegar" ;
  knirka_vb_1_V = mkV "knirkar" ;
  knirra_vb_1_V = mkV "knirrar" ;
  knistra_vb_1_V = mkV "knistrar" ;
  knittra_vb_1_V = mkV "knittrar" ;
  knixa_vb_1_V = mkV "knixar" ;
  knoga_vb_1_V = mkV "knogar" ;
  knollra_vb_1_V = mkV "knollrar" ;
  knoppa_av_vbm_1_V2 = dirV2 (partV (mkV "knoppar")"av") ;
  knorra_vb_1_V = mkV "knorrar" ;
  knorra_vb_2_V = mkV "knorrar" ;
  knota_vb_1_V = mkV "knotar" ;
  knottra_vb_1_V = mkV "knottrar" ;
  knuffa_ut_vbm_1_V2 = dirV2 (partV (mkV "knuffar")"ut") ;
  knussla_vb_1_V = mkV "knusslar" ;
  knycka_vb_1_V = mkV "knycker" ;
  knyckla_vb_1_V = mkV "knycklar" ;
  knyckla_till_vbm_1_V2 = dirV2 (partV (mkV "knycklar")"till") ;
  knyppla_vb_1_V = mkV "knypplar" ;
  knysta_vb_1_V = mkV "knystar" ;
  knaea_vb_1_1_V = mkV "knäar" ;
  knaecka_vb_1_1_V = mkV "knäcker" ;
  knaeppa_vb_1_1_V = mkV "knäpper" ;
  knaeppa_vb_2_1_V = mkV "knäpper" ;
  knaada_in_vbm_1_1_V2 = dirV2 (partV (mkV "knådar")"in") ;
  knaapa_vb_1_1_V = mkV "knåpar" ;
  knoeka_vb_1_1_V = mkV "knökar" ;
  kodvaexla_vb_1_1_V = mkV "kodväxlar" ;
  kohandla_vb_1_V = mkV "kohandlar" ;
  koka_vb_2_V = mkV "kokar" ;
  kokettera_vb_1_V = mkV "koketterar" ;
  koksa_vb_1_V = mkV "koksar" ;
  kollabera_vb_1_V = mkV "kollaberar" ;
  kollaborera_vb_1_V = mkV "kollaborerar" ;
  kollidera_vb_1_V = mkV "kolliderar" ;
  kommunicera_vb_2_V = mkV "kommunicerar" ;
  kompromissa_vb_1_V = mkV "kompromissar" ;
  konferera_vb_1_V = mkV "konfererar" ;
  kongressa_vb_1_V = mkV "kongressar" ;
  konka_vb_1_V = mkV "konkar" ;
  konkurrera_vb_1_V = mkV "konkurrerar" ;
  konsertera_vb_1_V = mkV "konserterar" ;
  konspirera_vb_1_V = mkV "konspirerar" ;
  konstra_vb_1_V = mkV "konstrar" ;
  kontra_vb_1_V = mkV "kontrar" ;
  kontrollvaega_vb_1_1_V = mkV "kontrollväger" ;
  kontrollaesa_vb_1_1_V = mkV "kontrolläser" ;
  konvalescera_vb_1_V = mkV "konvalescerar" ;
  konvertera_vb_1_V = mkV "konverterar" ;
  kooperera_vb_1_V = mkV "koopererar" ;
  koppla_vb_1_V = mkV "kopplar" ;
  koppla_ifraan_vbm_1_1_V2 = dirV2 (partV (mkV "kopplar")"ifrån") ;
  koppla_paa_vbm_1_1_V2 = dirV2 (partV (mkV "kopplar")"på") ;
  koppla_ur_vbm_1_V2 = dirV2 (partV (mkV "kopplar")"ur") ;
  kopulera_vb_1_V = mkV "kopulerar" ;
  korka_till_vbm_1_V2 = dirV2 (partV (mkV "korkar")"till") ;
  korrekturlaesa_vb_1_1_V = mkV "korrekturläser" ;
  korrespondera_vb_1_V = mkV "korresponderar" ;
  korsa_oever_vbm_1_1_V2 = dirV2 (partV (mkV "korsar")"över") ;
  kortklippa_vb_1_V = mkV "kortklipper" ;
  kosta_vb_1_V = mkV "kostar" ;
  kovaenda_vb_1_1_V = mkV "kovänder" ;
  koxa_vb_1_V = mkV "koxar" ;
  krama_ur_vbm_1_V2 = dirV2 (partV (mkV "kramar")"ur") ;
  krama_ut_vbm_1_V2 = dirV2 (partV (mkV "kramar")"ut") ;
  krasa_vb_1_V = mkV "krasar" ;
  kratsa_ut_vbm_1_V2 = dirV2 (partV (mkV "kratsar")"ut") ;
  kratta_av_vbm_1_V2 = dirV2 (partV (mkV "krattar")"av") ;
  kravla_vb_1_V = mkV "kravlar" ;
  kraxa_vb_1_V = mkV "kraxar" ;
  kretsa_vb_1_V = mkV "kretsar" ;
  kriga_vb_1_V = mkV "krigar" ;
  kringstroe_vb_1_1_V = mkV "kringströr" ;
  krisa_vb_1_V = mkV "krisar" ;
  kroka_av_vbm_1_V2 = dirV2 (partV (mkV "krokar")"av") ;
  krokna_vb_1_V = mkV "kroknar" ;
  kroppsarbeta_vb_1_V = mkV "kroppsarbetar" ;
  krubba_vb_1_V = mkV "krubbar" ;
  krumbukta_vb_1_V = mkV "krumbuktar" ;
  krylla_vb_1_V = mkV "kryllar" ;
  krympa_vb_1_V = mkV "krymper" ;
  kryssa_vb_2_V = mkV "kryssar" ;
  kryssa_foer_vbm_1_1_V2 = dirV2 (partV (mkV "kryssar")"för") ;
  kryssa_oever_vbm_1_1_V2 = dirV2 (partV (mkV "kryssar")"över") ;
  krysta_vb_1_V = mkV "krystar" ;
  kraela_vb_1_1_V = mkV "krälar" ;
  kraemta_vb_1_1_V = mkV "krämtar" ;
  kraenga_vb_1_1_V = mkV "kränger" ;
  kraenga_vb_2_1_V = mkV "kränger" ;
  kraenka_vb_1_1_V = mkV "kränker" ;
  kraeva_vb_1_1_V = mkV "kräver" ;
  kraama_vb_1_1_V = mkV "kråmar" ;
  kraangla_vb_1_1_V = mkV "krånglar" ;
  kraangla_till_vbm_1_1_V2 = dirV2 (partV (mkV "krånglar")"till") ;
  kroeka_vb_1_1_V = mkV "kröker" ;
  kroeka_vb_2_1_V = mkV "krökar" ;
  kuckilura_vb_1_V = mkV "kuckilurar" ;
  kuckla_vb_1_V = mkV "kucklar" ;
  kullbyttera_vb_1_V = mkV "kullbytterar" ;
  kullra_vb_1_V = mkV "kullrar" ;
  kulminera_vb_1_V = mkV "kulminerar" ;
  kulna_vb_1_V = mkV "kulnar" ;
  kulturminnesmaerka_vb_1_1_V = mkV "kulturminnesmärker" ;
  kunskapa_vb_1_V = mkV "kunskapar" ;
  kuppa_vb_1_V = mkV "kuppar" ;
  kurra_vb_1_V = mkV "kurrar" ;
  kursera_vb_1_V = mkV "kurserar" ;
  kuska_vb_1_V = mkV "kuskar" ;
  kuta_vb_1_V = mkV "kutar" ;
  kuttra_vb_1_V = mkV "kuttrar" ;
  kvacka_vb_1_V = mkV "kvackar" ;
  kvala_vb_1_V = mkV "kvalar" ;
  kvarta_vb_1_V = mkV "kvartar" ;
  kverulera_vb_1_V = mkV "kverulerar" ;
  kvicka_vb_1_V = mkV "kvickar" ;
  kvickna_till_vbm_1_V2 = dirV2 (partV (mkV "kvicknar")"till") ;
  kvillra_vb_1_V = mkV "kvillrar" ;
  kvintilera_vb_1_V = mkV "kvintilerar" ;
  kvirra_vb_1_V = mkV "kvirrar" ;
  kvista_av_vbm_1_V2 = dirV2 (partV (mkV "kvistar")"av") ;
  kvista_oever_vbm_1_1_V2 = dirV2 (partV (mkV "kvistar")"över") ;
  kvitta_vb_2_V = mkV "kvittar" ;
  kvitta_ut_vbm_1_V2 = dirV2 (partV (mkV "kvittar")"ut") ;
  kvittra_vb_1_V = mkV "kvittrar" ;
  kvaeka_vb_1_1_V = mkV "kväker" ;
  kvaella_vb_1_1_V = mkV "kväller" ;
  kvaesa_vb_1_1_V = mkV "kväser" ;
  kvaeva_vb_1_1_V = mkV "kväver" ;
  kyffa_vb_1_V = mkV "kyffar" ;
  kyla_vb_1_V = mkV "kyler" ;
  kylna_vb_1_V = mkV "kylnar" ;
  kyssa_vb_1_V = mkV "kysser" ;
  kaebbla_vb_1_1_V = mkV "käbblar" ;
  kaefta_vb_1_1_V = mkV "käftar" ;
  kaelta_vb_1_1_V = mkV "kältar" ;
  kaempa_vb_1_1_V = mkV "kämpar" ;
  kaera_vb_2_1_V = mkV "kärar" ;
  kaerna_ur_vbm_1_1_V2 = dirV2 (partV (mkV "kärnar")"ur") ;
  kaerva_vb_1_1_V = mkV "kärvar" ;
  kaexa_vb_1_1_V = mkV "käxar" ;
  kaara_vb_2_1_V = mkV "kårar" ;
  kaasera_vb_1_1_V = mkV "kåserar" ;
  koea_vb_1_1_V = mkV "köar" ;
  koelhala_vb_1_1_V = mkV "kölhalar" ;
  koepa_vb_1_1_V = mkV "köper" ;
  koeva_vb_1_1_V = mkV "köver" ;
  laborera_vb_1_V = mkV "laborerar" ;
  lackera_oever_vbm_1_1_V2 = dirV2 (partV (mkV "lackerar")"över") ;
  ladda_om_vbm_1_V2 = dirV2 (partV (mkV "laddar")"om") ;
  ladda_ur_vbm_1_V2 = dirV2 (partV (mkV "laddar")"ur") ;
  lafsa_vb_1_V = mkV "lafsar" ;
  lagstadga_vb_1_V = mkV "lagstadgar" ;
  lagsoeka_vb_1_1_V = mkV "lagsöker" ;
  lalla_vb_1_V = mkV "lallar" ;
  lamma_vb_1_V = mkV "lammar" ;
  landsbo_vb_1_V = mkV "landsbor" ;
  lantbo_vb_1_V = mkV "lantbor" ;
  lappa_till_vbm_1_V2 = dirV2 (partV (mkV "lappar")"till") ;
  larma_vb_1_V = mkV "larmar" ;
  larva_vb_1_V = mkV "larvar" ;
  lasa_in_vbm_1_V2 = dirV2 (partV (mkV "lasar")"in") ;
  lassa_vb_1_V = mkV "lassar" ;
  lasta_in_vbm_1_V2 = dirV2 (partV (mkV "lastar")"in") ;
  lasta_om_vbm_1_V2 = dirV2 (partV (mkV "lastar")"om") ;
  lasta_paa_vbm_1_1_V2 = dirV2 (partV (mkV "lastar")"på") ;
  lasta_ur_vbm_1_V2 = dirV2 (partV (mkV "lastar")"ur") ;
  lattja_vb_1_V = mkV "lattjar" ;
  laxera_vb_1_V = mkV "laxerar" ;
  ledsna_vb_1_V = mkV "ledsnar" ;
  leka_vb_1_V = mkV "leker" ;
  lessna_vb_1_V = mkV "lessnar" ;
  leta_igenom_vbm_1_V2 = dirV2 (partV (mkV "letar")"igenom") ;
  leta_ut_vbm_1_V2 = dirV2 (partV (mkV "letar")"ut") ;
  lettra_vb_1_V = mkV "lettrar" ;
  leva_vb_1_V = mkV "lever" ;
  lifta_vb_1_V = mkV "liftar" ;
  likna_vb_1_V = mkV "liknar" ;
  likstaella_vb_1_1_V = mkV "likställer" ;
  limma_paa_vbm_1_1_V2 = dirV2 (partV (mkV "limmar")"på") ;
  linda_av_vbm_1_V2 = dirV2 (partV (mkV "lindar")"av") ;
  linda_in_vbm_1_V2 = dirV2 (partV (mkV "lindar")"in") ;
  linda_om_vbm_1_V2 = dirV2 (partV (mkV "lindar")"om") ;
  linka_vb_1_V = mkV "linkar" ;
  lipa_vb_1_V = mkV "lipar" ;
  lirka_vb_1_V = mkV "lirkar" ;
  lisma_vb_1_V = mkV "lismar" ;
  lista_ut_vbm_1_V2 = dirV2 (partV (mkV "listar")"ut") ;
  lita_vb_1_V = mkV "litar" ;
  ljumma_vb_1_V = mkV "ljummar" ;
  ljunga_vb_1_V = mkV "ljungar" ;
  ljusna_vb_1_V = mkV "ljusnar" ;
  ljustra_vb_1_V = mkV "ljustrar" ;
  lobba_vb_2_V = mkV "lobbar" ;
  locka_in_vbm_1_V2 = dirV2 (partV (mkV "lockar")"in") ;
  loda_vb_2_V = mkV "lodar" ;
  logga_in_vbm_1_V2 = dirV2 (partV (mkV "loggar")"in") ;
  logga_ut_vbm_1_V2 = dirV2 (partV (mkV "loggar")"ut") ;
  loma_vb_1_V = mkV "lomar" ;
  lomma_vb_1_V = mkV "lommar" ;
  loska_vb_1_V = mkV "loskar" ;
  lossna_vb_1_V = mkV "lossnar" ;
  lotsa_in_vbm_1_V2 = dirV2 (partV (mkV "lotsar")"in") ;
  lova_vb_2_V = mkV "lovar" ;
  lubba_vb_1_V = mkV "lubbar" ;
  luckra_vb_1_V = mkV "luckrar" ;
  ludda_vb_1_V = mkV "luddar" ;
  luffa_vb_1_V = mkV "luffar" ;
  lufsa_vb_1_V = mkV "lufsar" ;
  lukta_vb_1_V = mkV "luktar" ;
  lulla_vb_1_V = mkV "lullar" ;
  lumpa_vb_1_V = mkV "lumpar" ;
  luncha_vb_1_V = mkV "lunchar" ;
  lunka_vb_1_V = mkV "lunkar" ;
  lunta_vb_1_V = mkV "luntar" ;
  lura_vb_2_V = mkV "lurar" ;
  lura_av_vbm_1_V2 = dirV2 (partV (mkV "lurar")"av") ;
  lusa_vb_1_V = mkV "lusar" ;
  luska_vb_1_V = mkV "luskar" ;
  luslaesa_vb_1_1_V = mkV "lusläser" ;
  lussa_vb_1_V = mkV "lussar" ;
  luta_vb_2_V = mkV "lutar" ;
  luta_av_vbm_1_V2 = dirV2 (partV (mkV "lutar")"av") ;
  luttra_vb_1_V = mkV "luttrar" ;
  lysa_vb_1_V = mkV "lyser" ;
  lysa_vb_2_V = mkV "lyser" ;
  lyssna_vb_1_V = mkV "lyssnar" ;
  lystra_vb_1_V = mkV "lystrar" ;
  lyxa_vb_1_V = mkV "lyxar" ;
  laea_vb_1_1_V = mkV "läar" ;
  laecka_vb_1_1_V = mkV "läcker" ;
  laeka_vb_1_1_V = mkV "läker" ;
  laekarundersoeka_vb_1_1_V = mkV "läkarundersöker" ;
  laenda_vb_1_1_V = mkV "länder" ;
  laenga_vb_1_1_V = mkV "länger" ;
  laengta_vb_1_1_V = mkV "längtar" ;
  laeppja_vb_1_1_V = mkV "läppjar" ;
  laesa_vb_1_1_V = mkV "läser" ;
  laespa_vb_1_1_V = mkV "läspar" ;
  laesta_ut_vbm_1_1_V2 = dirV2 (partV (mkV "lästar")"ut") ;
  laetta_vb_2_1_V = mkV "lättar" ;
  laettna_vb_1_1_V = mkV "lättnar" ;
  laettra_vb_1_1_V = mkV "lättrar" ;
  laaga_vb_1_1_V = mkV "lågar" ;
  laana_ut_vbm_1_1_V2 = dirV2 (partV (mkV "lånar")"ut") ;
  laasa_vb_1_1_V = mkV "låser" ;
  loeddra_vb_1_1_V = mkV "löddrar" ;
  loemskna_vb_1_1_V = mkV "lömsknar" ;
  loepa_vb_2_1_V = mkV "löper" ;
  loepna_vb_1_1_V = mkV "löpnar" ;
  loesa_vb_1_1_V = mkV "löser" ;
  mackla_vb_1_V = mkV "macklar" ;
  magra_vb_1_V = mkV "magrar" ;
  majoritetsaega_vb_1_1_V = mkV "majoritetsäger" ;
  mangla_vb_1_V = mkV "manglar" ;
  mankera_vb_1_V = mkV "mankerar" ;
  mantla_vb_1_V = mkV "mantlar" ;
  marodera_vb_1_V = mkV "maroderar" ;
  marschera_vb_1_V = mkV "marscherar" ;
  maska_vb_1_V = mkV "maskar" ;
  masturbera_vb_1_V = mkV "masturberar" ;
  matvaegra_vb_1_1_V = mkV "matvägrar" ;
  mecka_vb_1_V = mkV "meckar" ;
  meckla_vb_1_V = mkV "mecklar" ;
  medarbeta_vb_1_V = mkV "medarbetar" ;
  meddela_vb_1_V = mkV "meddelar" ;
  meditera_vb_1_V = mkV "mediterar" ;
  medla_vb_1_V = mkV "medlar" ;
  medverka_vb_1_V = mkV "medverkar" ;
  meja_av_vbm_1_V2 = dirV2 (partV (mkV "mejar")"av") ;
  mejsla_av_vbm_1_V2 = dirV2 (partV (mkV "mejslar")"av") ;
  meka_vb_1_V = mkV "mekar" ;
  menstruera_vb_1_V = mkV "menstruerar" ;
  meta_vb_1_V = mkV "metar" ;
  miljoemaerka_vb_1_1_V = mkV "miljömärker" ;
  mingla_vb_1_V = mkV "minglar" ;
  missbedoema_vb_1_1_V = mkV "missbedömer" ;
  misshaga_vb_1_V = mkV "misshagar" ;
  misshushaalla_vb_1_1_V = mkV "misshushållar" ;
  missionera_vb_1_V = mkV "missionerar" ;
  misskoeta_vb_1_1_V = mkV "missköter" ;
  misstro_vb_1_V = mkV "misstror" ;
  misstroesta_vb_1_1_V = mkV "misströstar" ;
  misstycka_vb_1_V = mkV "misstycker" ;
  misstaenka_vb_1_1_V = mkV "misstänker" ;
  missvisa_vb_1_V = mkV "missvisar" ;
  mixtra_vb_1_V = mkV "mixtrar" ;
  mjaua_vb_1_V = mkV "mjauar" ;
  mjukna_vb_1_V = mkV "mjuknar" ;
  mogna_vb_1_V = mkV "mognar" ;
  mojna_vb_1_V = mkV "mojnar" ;
  mola_vb_1_V = mkV "molar" ;
  momsredovisa_vb_1_V = mkV "momsredovisar" ;
  mopeda_vb_1_V = mkV "mopedar" ;
  moralisera_vb_1_V = mkV "moraliserar" ;
  morla_vb_1_V = mkV "morlar" ;
  morra_vb_1_V = mkV "morrar" ;
  morsa_vb_1_V = mkV "morsar" ;
  mota_ut_vbm_1_V2 = dirV2 (partV (mkV "motar")"ut") ;
  motionera_vb_1_V = mkV "motionerar" ;
  motlaesa_vb_1_1_V = mkV "motläser" ;
  motsvara_vb_1_V = mkV "motsvarar" ;
  motvaega_vb_1_1_V = mkV "motväger" ;
  moussera_vb_1_V = mkV "mousserar" ;
  mucka_vb_1_V = mkV "muckar" ;
  muddra_vb_1_V = mkV "muddrar" ;
  mullra_vb_1_V = mkV "mullrar" ;
  mulna_vb_1_V = mkV "mulnar" ;
  multna_vb_1_V = mkV "multnar" ;
  mumla_vb_1_V = mkV "mumlar" ;
  mumsa_vb_1_V = mkV "mumsar" ;
  mura_in_vbm_1_V2 = dirV2 (partV (mkV "murar")"in") ;
  mura_paa_vbm_1_1_V2 = dirV2 (partV (mkV "murar")"på") ;
  mura_till_vbm_1_V2 = dirV2 (partV (mkV "murar")"till") ;
  murkna_vb_1_V = mkV "murknar" ;
  murra_vb_1_V = mkV "murrar" ;
  musicera_vb_1_V = mkV "musicerar" ;
  mussera_vb_1_V = mkV "musserar" ;
  muta_in_vbm_1_V2 = dirV2 (partV (mkV "mutar")"in") ;
  muttra_vb_1_V = mkV "muttrar" ;
  mygla_vb_1_V = mkV "myglar" ;
  myllra_vb_1_V = mkV "myllrar" ;
  mynna_vb_1_V = mkV "mynnar" ;
  mysa_vb_1_V = mkV "myser" ;
  maekla_vb_1_1_V = mkV "mäklar" ;
  maekta_vb_1_1_V = mkV "mäktar" ;
  maela_vb_1_1_V = mkV "mäler" ;
  maenga_vb_1_1_V = mkV "mänger" ;
  maergla_vb_1_1_V = mkV "märglar" ;
  maerka_vb_1_1_V = mkV "märker" ;
  maessa_vb_1_1_V = mkV "mässar" ;
  maeta_vb_1_1_V = mkV "mäter" ;
  maa_vb_1_1_V = mkV "mår" ;
  maala_av_vbm_1_1_V2 = dirV2 (partV (mkV "målar")"av") ;
  maala_om_vbm_1_1_V2 = dirV2 (partV (mkV "målar")"om") ;
  maala_oever_vbm_1_1_V2 = dirV2 (partV (mkV "målar")"över") ;
  maana_vb_1_1_V = mkV "månar" ;
  maangla_vb_1_1_V = mkV "månglar" ;
  moegla_vb_1_1_V = mkV "möglar" ;
  moenstra_av_vbm_1_1_V2 = dirV2 (partV (mkV "mönstrar")"av") ;
  moenstra_paa_vbm_1_1_V2 = dirV2 (partV (mkV "mönstrar")"på") ;
  moerkna_vb_1_1_V = mkV "mörknar" ;
  moeta_vb_1_1_V = mkV "möter" ;
  nagga_vb_2_V = mkV "naggar" ;
  nagla_foer_vbm_1_1_V2 = dirV2 (partV (mkV "naglar")"för") ;
  nappa_vb_1_V = mkV "nappar" ;
  nara_vb_2_V = mkV "narar" ;
  naturvandra_vb_1_V = mkV "naturvandrar" ;
  nedblaasa_vb_1_1_V = mkV "nedblåser" ;
  nedgraeva_vb_1_1_V = mkV "nedgräver" ;
  nedsaenka_vb_1_1_V = mkV "nedsänker" ;
  nerblaasa_vb_1_1_V = mkV "nerblåser" ;
  nersaenka_vb_1_1_V = mkV "nersänker" ;
  nicka_vb_1_V = mkV "nickar" ;
  nitaelska_vb_1_1_V = mkV "nitälskar" ;
  noja_vb_1_V = mkV "nojar" ;
  nojsa_vb_1_V = mkV "nojsar" ;
  nollstaella_vb_1_1_V = mkV "nollställer" ;
  nolltaxera_vb_1_V = mkV "nolltaxerar" ;
  nomadisera_vb_1_V = mkV "nomadiserar" ;
  nosa_vb_1_V = mkV "nosar" ;
  nyanstaella_vb_1_1_V = mkV "nyanställer" ;
  nyktra_till_vbm_1_V2 = dirV2 (partV (mkV "nyktrar")"till") ;
  nysta_av_vbm_1_V2 = dirV2 (partV (mkV "nystar")"av") ;
  nytta_vb_1_V = mkV "nyttar" ;
  naecka_vb_1_1_V = mkV "näckar" ;
  naemna_vb_1_1_V = mkV "nämner" ;
  naepsa_vb_1_1_V = mkV "näpser" ;
  naethandla_vb_1_1_V = mkV "näthandlar" ;
  naetkommunicera_vb_1_1_V = mkV "nätkommunicerar" ;
  naa_vb_1_1_V = mkV "når" ;
  naatla_vb_1_1_V = mkV "nåtlar" ;
  noedsignalera_vb_1_1_V = mkV "nödsignalerar" ;
  noeta_vb_1_1_V = mkV "nöter" ;
  obstruera_vb_1_V = mkV "obstruerar" ;
  ockra_vb_1_V = mkV "ockrar" ;
  officiera_vb_1_V = mkV "officierar" ;
  offra_vb_1_V = mkV "offrar" ;
  oja_vb_1_V = mkV "ojar" ;
  oktavera_vb_1_V = mkV "oktaverar" ;
  okynnesstrejka_vb_1_V = mkV "okynnesstrejkar" ;
  ombetro_vb_1_V = mkV "ombetror" ;
  omnaemna_vb_1_1_V = mkV "omnämner" ;
  omskoeta_vb_1_1_V = mkV "omsköter" ;
  omstaella_vb_1_1_V = mkV "omställer" ;
  omstoepa_vb_1_1_V = mkV "omstöper" ;
  omsvepa_vb_1_V = mkV "omsveper" ;
  omvaelva_vb_1_1_V = mkV "omvälver" ;
  omvaenda_vb_1_1_V = mkV "omvänder" ;
  omvaerva_vb_1_1_V = mkV "omvärver" ;
  omvaexla_vb_1_1_V = mkV "omväxlar" ;
  onanera_vb_1_V = mkV "onanerar" ;
  onanisera_vb_1_V = mkV "onaniserar" ;
  opinera_vb_1_V = mkV "opinerar" ;
  oppfylla_vb_1_V = mkV "oppfyller" ;
  opphaeva_vb_1_1_V = mkV "opphäver" ;
  opplaesa_vb_1_1_V = mkV "oppläser" ;
  oppstaella_vb_1_1_V = mkV "oppställer" ;
  oppsoeka_vb_1_1_V = mkV "oppsöker" ;
  oppvaega_vb_1_1_V = mkV "oppväger" ;
  optera_vb_1_V = mkV "opterar" ;
  orda_vb_1_V = mkV "ordar" ;
  ordna_om_vbm_1_V2 = dirV2 (partV (mkV "ordnar")"om") ;
  orera_vb_1_V = mkV "orerar" ;
  orientera_vb_1_V = mkV "orienterar" ;
  orka_vb_1_V = mkV "orkar" ;
  orma_vb_1_V = mkV "ormar" ;
  osa_vb_1_V = mkV "osar" ;
  oscillera_vb_1_V = mkV "oscillerar" ;
  packa_av_vbm_1_V2 = dirV2 (partV (mkV "packar")"av") ;
  packa_in_vbm_1_V2 = dirV2 (partV (mkV "packar")"in") ;
  packa_om_vbm_1_V2 = dirV2 (partV (mkV "packar")"om") ;
  packa_till_vbm_1_V2 = dirV2 (partV (mkV "packar")"till") ;
  packa_ur_vbm_1_V2 = dirV2 (partV (mkV "packar")"ur") ;
  paddla_vb_1_V = mkV "paddlar" ;
  palla_vb_2_V = mkV "pallar" ;
  palta_paa_vbm_1_1_V2 = dirV2 (partV (mkV "paltar")"på") ;
  panga_vb_1_V = mkV "pangar" ;
  parasitera_vb_1_V = mkV "parasiterar" ;
  parentera_vb_1_V = mkV "parenterar" ;
  parlamentera_vb_1_V = mkV "parlamenterar" ;
  parlera_vb_1_V = mkV "parlerar" ;
  parta_vb_1_V = mkV "partar" ;
  partaja_vb_1_V = mkV "partajar" ;
  passa_vb_1_V = mkV "passar" ;
  peaka_vb_1_V = mkV "peakar" ;
  peka_vb_1_V = mkV "pekar" ;
  peka_ut_vbm_1_V2 = dirV2 (partV (mkV "pekar")"ut") ;
  pendla_vb_1_V = mkV "pendlar" ;
  pensla_vb_1_V = mkV "penslar" ;
  perennera_vb_1_V = mkV "perennerar" ;
  personroesta_vb_1_1_V = mkV "personröstar" ;
  peta_vb_1_V = mkV "petar" ;
  piffa_till_vbm_1_V2 = dirV2 (partV (mkV "piffar")"till") ;
  piggna_till_vbm_1_V2 = dirV2 (partV (mkV "piggnar")"till") ;
  pila_vb_1_V = mkV "pilar" ;
  pilla_vb_1_V = mkV "pillar" ;
  pillra_vb_1_V = mkV "pillrar" ;
  pimpla_vb_1_V = mkV "pimplar" ;
  pingla_vb_1_V = mkV "pinglar" ;
  pinka_vb_1_V = mkV "pinkar" ;
  pinna_vb_2_V = mkV "pinnar" ;
  pirra_vb_1_V = mkV "pirrar" ;
  piruettera_vb_1_V = mkV "piruetterar" ;
  pissa_vb_1_V = mkV "pissar" ;
  pivotera_vb_1_V = mkV "pivoterar" ;
  pjollra_vb_1_V = mkV "pjollrar" ;
  pjoska_vb_1_V = mkV "pjoskar" ;
  pjunka_vb_1_V = mkV "pjunkar" ;
  pladdra_vb_1_V = mkV "pladdrar" ;
  plana_vb_2_V = mkV "planar" ;
  planka_vb_1_V = mkV "plankar" ;
  plantera_om_vbm_1_V2 = dirV2 (partV (mkV "planterar")"om") ;
  plaska_vb_1_V = mkV "plaskar" ;
  platsa_vb_1_V = mkV "platsar" ;
  platta_till_vbm_1_V2 = dirV2 (partV (mkV "plattar")"till") ;
  platta_ut_vbm_1_V2 = dirV2 (partV (mkV "plattar")"ut") ;
  plikta_vb_1_V = mkV "pliktar" ;
  pliktfaella_vb_1_1_V = mkV "pliktfäller" ;
  plira_vb_1_V = mkV "plirar" ;
  plita_vb_1_V = mkV "plitar" ;
  plocka_av_vbm_1_V2 = dirV2 (partV (mkV "plockar")"av") ;
  plocka_ur_vbm_1_V2 = dirV2 (partV (mkV "plockar")"ur") ;
  plocka_ut_vbm_1_V2 = dirV2 (partV (mkV "plockar")"ut") ;
  plottra_vb_1_V = mkV "plottrar" ;
  plugga_vb_2_V = mkV "pluggar" ;
  plugga_in_vbm_1_V2 = dirV2 (partV (mkV "pluggar")"in") ;
  plumpa_vb_1_V = mkV "plumpar" ;
  plumsa_vb_1_V = mkV "plumsar" ;
  plundra_vb_1_V = mkV "plundrar" ;
  plurra_vb_1_V = mkV "plurrar" ;
  plussa_vb_1_V = mkV "plussar" ;
  pluta_vb_1_V = mkV "plutar" ;
  plaedera_vb_1_1_V = mkV "pläderar" ;
  plaega_vb_1_1_V = mkV "plägar" ;
  pocka_vb_1_V = mkV "pockar" ;
  pokulera_vb_1_V = mkV "pokulerar" ;
  pola_vb_1_V = mkV "polar" ;
  polemisera_vb_1_V = mkV "polemiserar" ;
  polera_av_vbm_1_V2 = dirV2 (partV (mkV "polerar")"av") ;
  polera_om_vbm_1_V2 = dirV2 (partV (mkV "polerar")"om") ;
  polisanmaela_vb_1_1_V = mkV "polisanmäler" ;
  polstra_vb_1_V = mkV "polstrar" ;
  ponera_vb_1_V = mkV "ponerar" ;
  porla_vb_1_V = mkV "porlar" ;
  porrsurfa_vb_1_V = mkV "porrsurfar" ;
  portionera_ut_vbm_1_V2 = dirV2 (partV (mkV "portionerar")"ut") ;
  posera_vb_1_V = mkV "poserar" ;
  pracka_paa_vbm_1_1_V2 = dirV2 (partV (mkV "prackar")"på") ;
  praoa_vb_1_V = mkV "praoar" ;
  prassla_vb_1_V = mkV "prasslar" ;
  prata_vb_1_V = mkV "pratar" ;
  predominera_vb_1_V = mkV "predominerar" ;
  prenumerera_vb_1_V = mkV "prenumererar" ;
  presidera_vb_1_V = mkV "presiderar" ;
  prestavera_vb_1_V = mkV "prestaverar" ;
  pretendera_vb_1_V = mkV "pretenderar" ;
  pricka_av_vbm_1_V2 = dirV2 (partV (mkV "prickar")"av") ;
  prisbeloena_vb_1_1_V = mkV "prisbelönar" ;
  prismaerka_vb_1_1_V = mkV "prismärker" ;
  procenta_vb_1_V = mkV "procentar" ;
  processa_vb_1_V = mkV "processar" ;
  profetera_vb_1_V = mkV "profeterar" ;
  profitera_vb_1_V = mkV "profiterar" ;
  programmera_in_vbm_1_V2 = dirV2 (partV (mkV "programmerar")"in") ;
  promenera_vb_1_V = mkV "promenerar" ;
  propagera_vb_1_V = mkV "propagerar" ;
  proppa_in_vbm_1_V2 = dirV2 (partV (mkV "proppar")"in") ;
  proppa_till_vbm_1_V2 = dirV2 (partV (mkV "proppar")"till") ;
  propsa_vb_1_V = mkV "propsar" ;
  prostituera_vb_1_V = mkV "prostituerar" ;
  protestera_vb_1_V = mkV "protesterar" ;
  protestklicka_vb_1_V = mkV "protestklickar" ;
  protestroesta_vb_1_1_V = mkV "proteströstar" ;
  proviantera_vb_1_V = mkV "provianterar" ;
  prunka_vb_1_V = mkV "prunkar" ;
  prusta_vb_1_V = mkV "prustar" ;
  prutta_vb_1_V = mkV "pruttar" ;
  prya_vb_1_V = mkV "pryar" ;
  prygla_vb_1_V = mkV "pryglar" ;
  praenta_i_vbm_1_1_V2 = dirV2 (partV (mkV "präntar")"i") ;
  praestviga_vb_1_1_V = mkV "prästviger" ;
  praala_vb_1_1_V = mkV "prålar" ;
  praangla_vb_1_1_V = mkV "prånglar" ;
  puckla_paa_vbm_1_1_V2 = dirV2 (partV (mkV "pucklar")"på") ;
  puddla_vb_1_V = mkV "puddlar" ;
  pudla_vb_1_V = mkV "pudlar" ;
  puffa_vb_1_V = mkV "puffar" ;
  pula_vb_1_V = mkV "pular" ;
  pulla_vb_1_V = mkV "pullar" ;
  pulsa_vb_1_V = mkV "pulsar" ;
  pulsera_vb_1_V = mkV "pulserar" ;
  pumpa_in_vbm_1_V2 = dirV2 (partV (mkV "pumpar")"in") ;
  punga_ut_vbm_1_V2 = dirV2 (partV (mkV "pungar")"ut") ;
  purkna_vb_1_V = mkV "purknar" ;
  pussla_vb_1_V = mkV "pusslar" ;
  pusta_vb_1_V = mkV "pustar" ;
  puta_vb_1_V = mkV "putar" ;
  putsa_av_vbm_1_V2 = dirV2 (partV (mkV "putsar")"av") ;
  puttra_vb_1_V = mkV "puttrar" ;
  pynta_till_vbm_1_V2 = dirV2 (partV (mkV "pyntar")"till") ;
  pysa_vb_1_V = mkV "pyser" ;
  pyssla_vb_1_V = mkV "pysslar" ;
  paerla_vb_1_1_V = mkV "pärlar" ;
  paata_vb_2_1_V = mkV "påtar" ;
  paavila_vb_1_1_V = mkV "påvilar" ;
  poela_vb_1_1_V = mkV "pölar" ;
  poesa_vb_1_1_V = mkV "pöser" ;
  quiza_vb_1_V = mkV "quizar" ;
  quizza_vb_1_V = mkV "quizzar" ;
  rabbla_vb_1_V = mkV "rabblar" ;
  radionavigera_vb_1_V = mkV "radionavigerar" ;
  rafistulera_vb_1_V = mkV "rafistulerar" ;
  rafsa_vb_1_V = mkV "rafsar" ;
  raggla_vb_1_V = mkV "ragglar" ;
  ragla_vb_1_V = mkV "raglar" ;
  raka_av_vbm_1_V2 = dirV2 (partV (mkV "rakar")"av") ;
  rakna_vb_1_V = mkV "raknar" ;
  raljera_vb_1_V = mkV "raljerar" ;
  ramla_vb_1_V = mkV "ramlar" ;
  rangla_vb_1_V = mkV "ranglar" ;
  ranta_vb_1_V = mkV "rantar" ;
  rapa_vb_1_V = mkV "rapar" ;
  rasa_vb_1_V = mkV "rasar" ;
  rassla_vb_1_V = mkV "rasslar" ;
  rasta_vb_1_V = mkV "rastar" ;
  ratscha_vb_1_V = mkV "ratschar" ;
  reagera_vb_1_V = mkV "reagerar" ;
  rebellera_vb_1_V = mkV "rebellerar" ;
  recidivera_vb_1_V = mkV "recidiverar" ;
  redigera_om_vbm_1_V2 = dirV2 (partV (mkV "redigerar")"om") ;
  regla_vb_1_V = mkV "reglar" ;
  regla_foer_vbm_1_1_V2 = dirV2 (partV (mkV "reglar")"för") ;
  regla_till_vbm_1_V2 = dirV2 (partV (mkV "reglar")"till") ;
  regna_vb_1_V = mkV "regnar" ;
  rekylera_vb_1_V = mkV "rekylerar" ;
  relaxa_vb_1_V = mkV "relaxar" ;
  remma_vb_2_V = mkV "remmar" ;
  remontera_vb_1_V = mkV "remonterar" ;
  rensa_av_vbm_1_V2 = dirV2 (partV (mkV "rensar")"av") ;
  rensa_ut_vbm_1_V2 = dirV2 (partV (mkV "rensar")"ut") ;
  rentvaa_vb_1_1_V = mkV "rentvår" ;
  repliera_vb_1_V = mkV "replierar" ;
  replikera_vb_1_V = mkV "replikerar" ;
  resa_vb_1_V = mkV "reser" ;
  resa_vb_2_V = mkV "reser" ;
  residera_vb_1_V = mkV "residerar" ;
  resignera_vb_1_V = mkV "resignerar" ;
  resonera_vb_1_V = mkV "resonerar" ;
  restera_vb_1_V = mkV "resterar" ;
  resultera_vb_1_V = mkV "resulterar" ;
  retirera_vb_1_V = mkV "retirerar" ;
  revoltera_vb_1_V = mkV "revolterar" ;
  ricka_vb_1_V = mkV "rickar" ;
  rigla_vb_1_V = mkV "riglar" ;
  rigla_foer_vbm_1_1_V2 = dirV2 (partV (mkV "riglar")"för") ;
  rigla_till_vbm_1_V2 = dirV2 (partV (mkV "riglar")"till") ;
  rikta_till_vbm_1_V2 = dirV2 (partV (mkV "riktar")"till") ;
  ringa_vb_1_V = mkV "ringer" ;
  ringla_vb_1_V = mkV "ringlar" ;
  ringmaerka_vb_1_1_V = mkV "ringmärker" ;
  ripostera_vb_1_V = mkV "riposterar" ;
  riskera_vb_1_V = mkV "riskerar" ;
  rissla_vb_1_V = mkV "risslar" ;
  rissla_vb_2_V = mkV "risslar" ;
  rita_av_vbm_1_V2 = dirV2 (partV (mkV "ritar")"av") ;
  rita_in_vbm_1_V2 = dirV2 (partV (mkV "ritar")"in") ;
  rita_ut_vbm_1_V2 = dirV2 (partV (mkV "ritar")"ut") ;
  ritscha_vb_1_V = mkV "ritschar" ;
  rivalisera_vb_1_V = mkV "rivaliserar" ;
  ro_vb_1_V = mkV "ror" ;
  rocka_vb_1_V = mkV "rockar" ;
  rodna_vb_1_V = mkV "rodnar" ;
  ropa_vb_1_V = mkV "ropar" ;
  rossla_vb_1_V = mkV "rosslar" ;
  rosta_vb_1_V = mkV "rostar" ;
  rota_vb_1_V = mkV "rotar" ;
  rotfylla_vb_1_V = mkV "rotfyller" ;
  ruckla_vb_1_V = mkV "rucklar" ;
  ruffla_vb_1_V = mkV "rufflar" ;
  rufsa_vb_1_V = mkV "rufsar" ;
  rugga_vb_1_V = mkV "ruggar" ;
  rulla_vb_2_V = mkV "rullar" ;
  rulla_av_vbm_1_V2 = dirV2 (partV (mkV "rullar")"av") ;
  rulla_ut_vbm_1_V2 = dirV2 (partV (mkV "rullar")"ut") ;
  rulta_vb_1_V = mkV "rultar" ;
  rumla_vb_1_V = mkV "rumlar" ;
  rumstera_vb_1_V = mkV "rumsterar" ;
  runda_till_vbm_1_V2 = dirV2 (partV (mkV "rundar")"till") ;
  runga_vb_1_V = mkV "rungar" ;
  rusa_vb_1_V = mkV "rusar" ;
  ruska_vb_2_V = mkV "ruskar" ;
  rutscha_vb_1_V = mkV "rutschar" ;
  ruttna_vb_1_V = mkV "ruttnar" ;
  ruva_vb_2_V = mkV "ruvar" ;
  rya_vb_1_V = mkV "ryar" ;
  rycka_vb_1_V = mkV "rycker" ;
  rygga_vb_1_V = mkV "ryggar" ;
  ryggsaecksluffa_vb_1_1_V = mkV "ryggsäcksluffar" ;
  rymma_vb_1_V = mkV "rymmer" ;
  rymma_vb_2_V = mkV "rymmer" ;
  ryttla_vb_1_V = mkV "ryttlar" ;
  raecka_vb_1_1_V = mkV "räcker" ;
  raecka_vb_2_1_V = mkV "räcker" ;
  raeffla_vb_1_1_V = mkV "räfflar" ;
  raekna_efter_vbm_1_1_V2 = dirV2 (partV (mkV "räknar")"efter") ;
  raekna_igenom_vbm_1_1_V2 = dirV2 (partV (mkV "räknar")"igenom") ;
  raekna_ut_vbm_1_1_V2 = dirV2 (partV (mkV "räknar")"ut") ;
  raekna_oever_vbm_1_1_V2 = dirV2 (partV (mkV "räknar")"över") ;
  raeta_ut_vbm_1_1_V2 = dirV2 (partV (mkV "rätar")"ut") ;
  raetta_till_vbm_1_1_V2 = dirV2 (partV (mkV "rättar")"till") ;
  raa_vb_2_1_V = mkV "rår" ;
  raama_vb_1_1_V = mkV "råmar" ;
  raaskaella_vb_1_1_V = mkV "råskäller" ;
  raasteka_vb_1_1_V = mkV "råsteker" ;
  roeka_vb_1_1_V = mkV "röker" ;
  roesta_vb_1_1_V = mkV "röstar" ;
  roesta_ut_vbm_1_1_V2 = dirV2 (partV (mkV "röstar")"ut") ;
  roestmaximera_vb_1_1_V = mkV "röstmaximerar" ;
  roestskolka_vb_1_1_V = mkV "röstskolkar" ;
  sacka_vb_1_V = mkV "sackar" ;
  sadla_vb_1_V = mkV "sadlar" ;
  sadla_av_vbm_1_V2 = dirV2 (partV (mkV "sadlar")"av") ;
  sadla_om_vbm_1_V2 = dirV2 (partV (mkV "sadlar")"om") ;
  sadla_paa_vbm_1_1_V2 = dirV2 (partV (mkV "sadlar")"på") ;
  sagga_vb_1_V = mkV "saggar" ;
  sagla_vb_1_V = mkV "saglar" ;
  sakfaella_vb_1_1_V = mkV "sakfäller" ;
  sakna_vb_2_V = mkV "saknar" ;
  salivera_vb_1_V = mkV "saliverar" ;
  salta_in_vbm_1_V2 = dirV2 (partV (mkV "saltar")"in") ;
  samarbeta_vb_1_V = mkV "samarbetar" ;
  sambo_vb_1_V = mkV "sambor" ;
  samhaellsplanera_vb_1_1_V = mkV "samhällsplanerar" ;
  samklinga_vb_1_V = mkV "samklingar" ;
  samla_vb_1_V = mkV "samlar" ;
  sammanbo_vb_1_V = mkV "sammanbor" ;
  sammanhaenga_vb_1_1_V = mkV "sammanhänger" ;
  sammankoppla_vb_1_V = mkV "sammankopplar" ;
  sammanleva_vb_1_V = mkV "sammanlever" ;
  sammanloepa_vb_1_1_V = mkV "sammanlöper" ;
  sammanringa_vb_1_V = mkV "sammanringer" ;
  sammanstaella_vb_1_1_V = mkV "sammanställer" ;
  sammanstoeta_vb_1_1_V = mkV "sammanstöter" ;
  sammantrycka_vb_1_V = mkV "sammantrycker" ;
  sammanvaega_vb_1_1_V = mkV "sammanväger" ;
  sammanvaeva_vb_1_1_V = mkV "sammanväver" ;
  sammanvaexa_vb_1_1_V = mkV "sammanväxer" ;
  sampla_vb_1_V = mkV "samplar" ;
  samspela_vb_1_V = mkV "samspelar" ;
  samspraaka_vb_1_1_V = mkV "samspråkar" ;
  samtala_vb_1_V = mkV "samtalar" ;
  samtycka_vb_1_V = mkV "samtycker" ;
  samverka_vb_1_V = mkV "samverkar" ;
  samaaka_vb_1_1_V = mkV "samåker" ;
  satirisera_vb_1_V = mkV "satiriserar" ;
  sava_vb_1_V = mkV "savar" ;
  schabbla_vb_1_V = mkV "schabblar" ;
  schackla_vb_1_V = mkV "schacklar" ;
  schackra_vb_1_V = mkV "schackrar" ;
  schasa_ut_vbm_1_V2 = dirV2 (partV (mkV "schasar")"ut") ;
  schavottera_vb_1_V = mkV "schavotterar" ;
  sega_vb_1_V = mkV "segar" ;
  segla_vb_1_V = mkV "seglar" ;
  segla_om_vbm_1_V2 = dirV2 (partV (mkV "seglar")"om") ;
  segla_paa_vbm_1_1_V2 = dirV2 (partV (mkV "seglar")"på") ;
  segla_ut_vbm_1_V2 = dirV2 (partV (mkV "seglar")"ut") ;
  segla_oever_vbm_1_1_V2 = dirV2 (partV (mkV "seglar")"över") ;
  segna_vb_1_V = mkV "segnar" ;
  segra_vb_1_V = mkV "segrar" ;
  sejda_vb_1_V = mkV "sejdar" ;
  sela_av_vbm_1_V2 = dirV2 (partV (mkV "selar")"av") ;
  sela_paa_vbm_1_1_V2 = dirV2 (partV (mkV "selar")"på") ;
  semesterresa_vb_1_V = mkV "semesterreser" ;
  semestra_vb_1_V = mkV "semestrar" ;
  sexchatta_vb_1_V = mkV "sexchattar" ;
  sexvaegra_vb_1_1_V = mkV "sexvägrar" ;
  shaka_vb_1_V = mkV "shakar" ;
  shingla_vb_1_V = mkV "shinglar" ;
  shoppa_vb_1_V = mkV "shoppar" ;
  showa_vb_1_V = mkV "showar" ;
  sia_vb_1_V = mkV "siar" ;
  sicksacka_vb_1_V = mkV "sicksackar" ;
  signalera_vb_1_V = mkV "signalerar" ;
  sikta_vb_1_V = mkV "siktar" ;
  sila_vb_2_V = mkV "silar" ;
  sila_av_vbm_1_V2 = dirV2 (partV (mkV "silar")"av") ;
  sila_ifraan_vbm_1_1_V2 = dirV2 (partV (mkV "silar")"ifrån") ;
  sina_vb_1_V = mkV "sinar" ;
  sina_ut_vbm_1_V2 = dirV2 (partV (mkV "sinar")"ut") ;
  singla_vb_1_V = mkV "singlar" ;
  sintra_vb_1_V = mkV "sintrar" ;
  sippra_vb_1_V = mkV "sipprar" ;
  sirpa_vb_1_V = mkV "sirpar" ;
  sirra_vb_1_V = mkV "sirrar" ;
  sisa_vb_1_V = mkV "sisar" ;
  sittstrejka_vb_1_V = mkV "sittstrejkar" ;
  sittupa_vb_1_V = mkV "sittupar" ;
  sittuppa_vb_1_V = mkV "sittuppar" ;
  situpa_vb_1_V = mkV "situpar" ;
  situppa_vb_1_V = mkV "situppar" ;
  sjabbla_vb_1_V = mkV "sjabblar" ;
  sjangsera_vb_1_V = mkV "sjangserar" ;
  sjaska_vb_1_V = mkV "sjaskar" ;
  sjava_vb_1_V = mkV "sjavar" ;
  sjukanmaela_vb_1_1_V = mkV "sjukanmäler" ;
  sjukna_vb_1_V = mkV "sjuknar" ;
  sjaelvantaenda_vb_1_1_V = mkV "självantänder" ;
  sjaelvlaeka_vb_1_1_V = mkV "självläker" ;
  sjaelvtaenda_vb_1_1_V = mkV "självtänder" ;
  sjaaa_vb_1_1_V = mkV "sjåar" ;
  skaka_av_vbm_1_V2 = dirV2 (partV (mkV "skakar")"av") ;
  skaka_om_vbm_1_V2 = dirV2 (partV (mkV "skakar")"om") ;
  skala_vb_2_V = mkV "skalar" ;
  skala_av_vbm_1_V2 = dirV2 (partV (mkV "skalar")"av") ;
  skalla_vb_1_V = mkV "skallar" ;
  skallra_vb_1_V = mkV "skallrar" ;
  skapa_vb_1_V = mkV "skapar" ;
  skarva_vb_2_V = mkV "skarvar" ;
  skarva_till_vbm_1_V2 = dirV2 (partV (mkV "skarvar")"till") ;
  skata_vb_1_V = mkV "skatar" ;
  skatta_vb_1_V = mkV "skattar" ;
  skattefiffla_vb_1_V = mkV "skattefifflar" ;
  skava_vb_1_V = mkV "skaver" ;
  skejta_vb_1_V = mkV "skejtar" ;
  skela_vb_1_V = mkV "skelar" ;
  skeva_vb_1_V = mkV "skevar" ;
  skicka_vb_1_V = mkV "skickar" ;
  skicka_efter_vbm_1_V2 = dirV2 (partV (mkV "skickar")"efter") ;
  skicka_in_vbm_1_V2 = dirV2 (partV (mkV "skickar")"in") ;
  skicka_med_vbm_1_V2 = dirV2 (partV (mkV "skickar")"med") ;
  skicka_ut_vbm_1_V2 = dirV2 (partV (mkV "skickar")"ut") ;
  skicka_oever_vbm_1_1_V2 = dirV2 (partV (mkV "skickar")"över") ;
  skida_vb_1_V = mkV "skidar" ;
  skidra_vb_1_V = mkV "skidrar" ;
  skifta_vb_2_V = mkV "skiftar" ;
  skifta_ut_vbm_1_V2 = dirV2 (partV (mkV "skiftar")"ut") ;
  skimra_vb_1_V = mkV "skimrar" ;
  sko_vb_1_V = mkV "skor" ;
  skoja_vb_1_V = mkV "skojar" ;
  skolka_vb_1_V = mkV "skolkar" ;
  skorra_vb_1_V = mkV "skorrar" ;
  skotta_av_vbm_1_V2 = dirV2 (partV (mkV "skottar")"av") ;
  skovla_vb_1_V = mkV "skovlar" ;
  skralna_vb_1_V = mkV "skralnar" ;
  skralta_vb_1_V = mkV "skraltar" ;
  skramla_vb_1_V = mkV "skramlar" ;
  skramla_vb_2_V = mkV "skramlar" ;
  skrapa_av_vbm_1_V2 = dirV2 (partV (mkV "skrapar")"av") ;
  skrapa_ut_vbm_1_V2 = dirV2 (partV (mkV "skrapar")"ut") ;
  skratta_vb_1_V = mkV "skrattar" ;
  skratta_ut_vbm_1_V2 = dirV2 (partV (mkV "skrattar")"ut") ;
  skreva_vb_1_V = mkV "skrevar" ;
  skria_vb_1_V = mkV "skriar" ;
  skrinna_vb_1_V = mkV "skrinnar" ;
  skritta_vb_1_V = mkV "skrittar" ;
  skrocka_vb_1_V = mkV "skrockar" ;
  skrodera_vb_1_V = mkV "skroderar" ;
  skrota_vb_2_V = mkV "skrotar" ;
  skrubba_av_vbm_1_V2 = dirV2 (partV (mkV "skrubbar")"av") ;
  skrumpna_vb_1_V = mkV "skrumpnar" ;
  skruva_av_vbm_1_V2 = dirV2 (partV (mkV "skruvar")"av") ;
  skruva_foer_vbm_1_1_V2 = dirV2 (partV (mkV "skruvar")"för") ;
  skruva_ifraan_vbm_1_1_V2 = dirV2 (partV (mkV "skruvar")"ifrån") ;
  skruva_in_vbm_1_V2 = dirV2 (partV (mkV "skruvar")"in") ;
  skruva_paa_vbm_1_1_V2 = dirV2 (partV (mkV "skruvar")"på") ;
  skruva_till_vbm_1_V2 = dirV2 (partV (mkV "skruvar")"till") ;
  skrymma_vb_1_V = mkV "skrymmer" ;
  skrynkla_vb_1_V = mkV "skrynklar" ;
  skrynkla_till_vbm_1_V2 = dirV2 (partV (mkV "skrynklar")"till") ;
  skraeddarsy_vb_1_1_V = mkV "skräddarsyr" ;
  skraella_vb_1_1_V = mkV "skräller" ;
  skraemma_vb_1_1_V = mkV "skrämmer" ;
  skraenka_vb_1_1_V = mkV "skränker" ;
  skraeppa_vb_1_1_V = mkV "skräpper" ;
  skraevla_vb_1_1_V = mkV "skrävlar" ;
  skudda_av_vbm_1_V2 = dirV2 (partV (mkV "skuddar")"av") ;
  skuffa_ut_vbm_1_V2 = dirV2 (partV (mkV "skuffar")"ut") ;
  skuggboxa_vb_1_V = mkV "skuggboxar" ;
  skumma_vb_1_V = mkV "skummar" ;
  skura_av_vbm_1_V2 = dirV2 (partV (mkV "skurar")"av") ;
  skvallra_vb_1_V = mkV "skvallrar" ;
  skvalpa_om_vbm_1_V2 = dirV2 (partV (mkV "skvalpar")"om") ;
  skvalpa_ut_vbm_1_V2 = dirV2 (partV (mkV "skvalpar")"ut") ;
  sky_vb_1_V = mkV "skyr" ;
  skyffla_vb_1_V = mkV "skyfflar" ;
  skyffla_av_vbm_1_V2 = dirV2 (partV (mkV "skyfflar")"av") ;
  skyla_vb_1_V = mkV "skyler" ;
  skyldra_vb_1_V = mkV "skyldrar" ;
  skylla_vb_1_V = mkV "skyller" ;
  skymla_vb_1_V = mkV "skymlar" ;
  skymma_vb_1_V = mkV "skymmer" ;
  skaella_vb_1_1_V = mkV "skäller" ;
  skaemma_vb_1_1_V = mkV "skämmer" ;
  skaenka_vb_1_1_V = mkV "skänker" ;
  skaenkla_vb_1_1_V = mkV "skänklar" ;
  skaerma_av_vbm_1_1_V2 = dirV2 (partV (mkV "skärmar")"av") ;
  skaerpa_vb_1_1_V = mkV "skärper" ;
  skaangra_vb_1_1_V = mkV "skångrar" ;
  skaapa_ut_vbm_1_1_V2 = dirV2 (partV (mkV "skåpar")"ut") ;
  skoena_vb_1_1_V = mkV "skönar" ;
  skoeta_vb_1_1_V = mkV "sköter" ;
  skoevla_vb_1_1_V = mkV "skövlar" ;
  slabbra_vb_1_V = mkV "slabbrar" ;
  sladdra_vb_1_V = mkV "sladdrar" ;
  slakta_ut_vbm_1_V2 = dirV2 (partV (mkV "slaktar")"ut") ;
  slamma_vb_1_V = mkV "slammar" ;
  slamra_vb_1_V = mkV "slamrar" ;
  slappzappa_vb_1_V = mkV "slappzappar" ;
  slicka_av_vbm_1_V2 = dirV2 (partV (mkV "slickar")"av") ;
  slingra_vb_1_V = mkV "slingrar" ;
  slitsa_vb_1_V = mkV "slitsar" ;
  sloka_vb_1_V = mkV "slokar" ;
  slopa_vb_1_V = mkV "slopar" ;
  slubba_vb_1_V = mkV "slubbar" ;
  sluddra_vb_1_V = mkV "sluddrar" ;
  slugga_vb_1_V = mkV "sluggar" ;
  slumpa_vb_1_V = mkV "slumpar" ;
  slumra_vb_1_V = mkV "slumrar" ;
  slunga_vb_1_V = mkV "slungar" ;
  slunga_in_vbm_1_V2 = dirV2 (partV (mkV "slungar")"in") ;
  slurfa_vb_1_V = mkV "slurfar" ;
  slurpa_vb_1_V = mkV "slurpar" ;
  slussa_vb_1_V = mkV "slussar" ;
  slussa_ut_vbm_1_V2 = dirV2 (partV (mkV "slussar")"ut") ;
  sluta_vb_1_V = mkV "slutar" ;
  slutplaedera_vb_1_1_V = mkV "slutpläderar" ;
  slutta_vb_1_V = mkV "sluttar" ;
  slaecka_vb_1_1_V = mkV "släcker" ;
  slaegga_vb_1_1_V = mkV "släggar" ;
  slaenga_vb_1_1_V = mkV "slänger" ;
  slaentra_vb_1_1_V = mkV "släntrar" ;
  slaepa_vb_1_1_V = mkV "släpar" ;
  slaepa_in_vbm_1_1_V2 = dirV2 (partV (mkV "släpar")"in") ;
  slaepa_ut_vbm_1_1_V2 = dirV2 (partV (mkV "släpar")"ut") ;
  slaeppa_vb_1_1_V = mkV "släpper" ;
  slaeta_vb_1_1_V = mkV "slätar" ;
  slaeta_av_vbm_1_1_V2 = dirV2 (partV (mkV "slätar")"av") ;
  slaeta_till_vbm_1_1_V2 = dirV2 (partV (mkV "slätar")"till") ;
  slaeta_oever_vbm_1_1_V2 = dirV2 (partV (mkV "slätar")"över") ;
  slaetraka_vb_1_1_V = mkV "slätrakar" ;
  slaetslipa_vb_1_1_V = mkV "slätslipar" ;
  slaatta_vb_1_1_V = mkV "slåttar" ;
  sloea_vb_1_1_V = mkV "slöar" ;
  sloejda_vb_1_1_V = mkV "slöjdar" ;
  sloera_vb_1_1_V = mkV "slörar" ;
  sloesa_vb_1_1_V = mkV "slösar" ;
  sloesurfa_vb_1_1_V = mkV "slösurfar" ;
  sloetitta_vb_1_1_V = mkV "slötittar" ;
  smacka_vb_1_V = mkV "smackar" ;
  smaka_vb_1_V = mkV "smakar" ;
  smaka_vb_2_V = mkV "smakar" ;
  smalfilma_vb_1_V = mkV "smalfilmar" ;
  smalna_vb_1_V = mkV "smalnar" ;
  smarra_vb_1_V = mkV "smarrar" ;
  smasha_vb_1_V = mkV "smashar" ;
  smaska_vb_1_V = mkV "smaskar" ;
  smattra_vb_1_V = mkV "smattrar" ;
  smeka_vb_1_V = mkV "smeker" ;
  smeta_vb_1_V = mkV "smetar" ;
  smeta_paa_vbm_1_1_V2 = dirV2 (partV (mkV "smetar")"på") ;
  smeta_oever_vbm_1_1_V2 = dirV2 (partV (mkV "smetar")"över") ;
  smickra_vb_1_V = mkV "smickrar" ;
  smila_vb_1_V = mkV "smilar" ;
  sminka_vb_1_V = mkV "sminkar" ;
  smiska_vb_1_V = mkV "smiskar" ;
  smitta_vb_1_V = mkV "smittar" ;
  smittspaara_vb_1_1_V = mkV "smittspårar" ;
  smocka_vb_1_V = mkV "smockar" ;
  smocka_till_vbm_1_V2 = dirV2 (partV (mkV "smockar")"till") ;
  smsa_vb_1_V = mkV "sms:ar" ;
  smuggla_vb_1_V = mkV "smugglar" ;
  smuggla_in_vbm_1_V2 = dirV2 (partV (mkV "smugglar")"in") ;
  smula_vb_1_V = mkV "smular" ;
  smulta_vb_1_V = mkV "smultar" ;
  smussla_vb_1_V = mkV "smusslar" ;
  smutsa_vb_1_V = mkV "smutsar" ;
  smutskasta_vb_1_V = mkV "smutskastar" ;
  smutta_vb_1_V = mkV "smuttar" ;
  smycka_vb_1_V = mkV "smyckar" ;
  smygjaga_vb_1_V = mkV "smygjagar" ;
  smyglyssna_vb_1_V = mkV "smyglyssnar" ;
  smygroeka_vb_1_1_V = mkV "smygröker" ;
  smygtitta_vb_1_V = mkV "smygtittar" ;
  smaecka_vb_1_1_V = mkV "smäcker" ;
  smaekta_vb_1_1_V = mkV "smäktar" ;
  smaella_vb_1_1_V = mkV "smäller" ;
  smaergla_vb_1_1_V = mkV "smärglar" ;
  smaerta_vb_1_1_V = mkV "smärtar" ;
  smaaflina_vb_1_1_V = mkV "småflinar" ;
  smaagraela_vb_1_1_V = mkV "smågrälar" ;
  smaaprata_vb_1_1_V = mkV "småpratar" ;
  smaaputtra_vb_1_1_V = mkV "småputtrar" ;
  smaaskratta_vb_1_1_V = mkV "småskrattar" ;
  smaastadsbo_vb_1_1_V = mkV "småstadsbor" ;
  smoera_vb_1_1_V = mkV "smörar" ;
  smoerfraesa_vb_1_1_V = mkV "smörfräser" ;
  snabbteckna_vb_1_V = mkV "snabbtecknar" ;
  snabbtoersta_vb_1_1_V = mkV "snabbtörstar" ;
  snacka_vb_1_V = mkV "snackar" ;
  snagga_vb_1_V = mkV "snaggar" ;
  snappa_vb_1_V = mkV "snappar" ;
  snapsa_vb_1_V = mkV "snapsar" ;
  snara_vb_1_V = mkV "snarar" ;
  snarka_vb_1_V = mkV "snarkar" ;
  snarpa_vb_1_V = mkV "snarpar" ;
  snarra_vb_1_V = mkV "snarrar" ;
  snaska_vb_1_V = mkV "snaskar" ;
  snatta_vb_1_V = mkV "snattar" ;
  snattra_vb_1_V = mkV "snattrar" ;
  snava_vb_1_V = mkV "snavar" ;
  snedda_vb_1_V = mkV "sneddar" ;
  snedstaella_vb_1_1_V = mkV "snedställer" ;
  snegla_vb_1_V = mkV "sneglar" ;
  snida_vb_1_V = mkV "snidar" ;
  sniffa_vb_1_V = mkV "sniffar" ;
  snirkla_vb_1_V = mkV "snirklar" ;
  snitsa_vb_1_V = mkV "snitsar" ;
  snitsla_vb_1_V = mkV "snitslar" ;
  snitta_vb_1_V = mkV "snittar" ;
  sno_vb_1_V = mkV "snor" ;
  snobba_vb_1_V = mkV "snobbar" ;
  snofsa_till_vbm_1_V2 = dirV2 (partV (mkV "snofsar")"till") ;
  snoka_vb_1_V = mkV "snokar" ;
  snoka_igenom_vbm_1_V2 = dirV2 (partV (mkV "snokar")"igenom") ;
  snoppa_vb_1_V = mkV "snoppar" ;
  snora_vb_1_V = mkV "snorar" ;
  snubba_vb_1_V = mkV "snubbar" ;
  snubbla_vb_1_V = mkV "snubblar" ;
  snudda_vb_1_V = mkV "snuddar" ;
  snurra_vb_1_V = mkV "snurrar" ;
  snusa_vb_1_V = mkV "snusar" ;
  snuska_vb_1_V = mkV "snuskar" ;
  snuva_vb_1_V = mkV "snuvar" ;
  snyfta_vb_1_V = mkV "snyftar" ;
  snygga_till_vbm_1_V2 = dirV2 (partV (mkV "snyggar")"till") ;
  snylta_vb_1_V = mkV "snyltar" ;
  snaeppa_vb_1_1_V = mkV "snäpper" ;
  snaerpa_vb_1_1_V = mkV "snärper" ;
  snaerta_vb_1_1_V = mkV "snärtar" ;
  snaesa_vb_1_1_V = mkV "snäser" ;
  snaeva_vb_1_1_V = mkV "snävar" ;
  snaala_vb_1_1_V = mkV "snålar" ;
  snaala_in_vbm_1_1_V2 = dirV2 (partV (mkV "snålar")"in") ;
  snoea_vb_1_1_V = mkV "snöar" ;
  snoea_in_vbm_1_1_V2 = dirV2 (partV (mkV "snöar")"in") ;
  snoepa_vb_1_1_V = mkV "snöper" ;
  snoeploga_vb_1_1_V = mkV "snöplogar" ;
  snoerpa_vb_1_1_V = mkV "snörper" ;
  snoervla_vb_1_1_V = mkV "snörvlar" ;
  sockersalta_vb_1_V = mkV "sockersaltar" ;
  sockra_oever_vbm_1_1_V2 = dirV2 (partV (mkV "sockrar")"över") ;
  soffsurfa_vb_1_V = mkV "soffsurfar" ;
  softa_vb_1_V = mkV "softar" ;
  sol_och_vaara_vb_1_1_V = mkV "sol-och-vårar" ;
  sola_vb_1_V = mkV "solar" ;
  solbada_vb_1_V = mkV "solbadar" ;
  solka_vb_1_V = mkV "solkar" ;
  solochvaara_vb_1_1_V = mkV "solochvårar" ;
  soltorka_vb_1_V = mkV "soltorkar" ;
  solva_vb_1_V = mkV "solvar" ;
  somna_vb_1_V = mkV "somnar" ;
  sopa_vb_1_V = mkV "sopar" ;
  sopa_av_vbm_1_V2 = dirV2 (partV (mkV "sopar")"av") ;
  sopa_ut_vbm_1_V2 = dirV2 (partV (mkV "sopar")"ut") ;
  sota_vb_1_V = mkV "sotar" ;
  sota_vb_2_V = mkV "sotar" ;
  spackla_vb_1_V = mkV "spacklar" ;
  spadvaenda_vb_1_1_V = mkV "spadvänder" ;
  spaka_vb_1_V = mkV "spakar" ;
  spakna_vb_1_V = mkV "spaknar" ;
  spalta_vb_1_V = mkV "spaltar" ;
  spana_vb_1_V = mkV "spanar" ;
  spana_efter_vbm_1_V2 = dirV2 (partV (mkV "spanar")"efter") ;
  spankulera_vb_1_V = mkV "spankulerar" ;
  spara_vb_1_V = mkV "sparar" ;
  spara_vb_2_V = mkV "sparar" ;
  spara_in_vbm_1_V2 = dirV2 (partV (mkV "sparar")"in") ;
  sparka_vb_1_V = mkV "sparkar" ;
  sparka_av_vbm_1_V2 = dirV2 (partV (mkV "sparkar")"av") ;
  sparka_ut_vbm_1_V2 = dirV2 (partV (mkV "sparkar")"ut") ;
  sparra_vb_1_V = mkV "sparrar" ;
  spatsera_vb_1_V = mkV "spatserar" ;
  specialbestaella_vb_1_1_V = mkV "specialbeställer" ;
  speja_vb_1_V = mkV "spejar" ;
  speja_ut_vbm_1_V2 = dirV2 (partV (mkV "spejar")"ut") ;
  spela_vb_2_V = mkV "spelar" ;
  spendera_vb_1_V = mkV "spenderar" ;
  speta_vb_1_V = mkV "spetar" ;
  spetsa_vb_1_V = mkV "spetsar" ;
  spetta_vb_1_V = mkV "spettar" ;
  spexa_vb_1_V = mkV "spexar" ;
  spika_foer_vbm_1_1_V2 = dirV2 (partV (mkV "spikar")"för") ;
  spika_paa_vbm_1_1_V2 = dirV2 (partV (mkV "spikar")"på") ;
  spika_till_vbm_1_V2 = dirV2 (partV (mkV "spikar")"till") ;
  spila_vb_1_V = mkV "spilar" ;
  spilla_vb_1_V = mkV "spiller" ;
  spionera_vb_1_V = mkV "spionerar" ;
  spira_vb_1_V = mkV "spirar" ;
  spisa_vb_1_V = mkV "spisar" ;
  spjaela_vb_1_1_V = mkV "spjälar" ;
  spjaelka_vb_1_1_V = mkV "spjälkar" ;
  spjaerna_vb_1_1_V = mkV "spjärnar" ;
  splinta_vb_1_V = mkV "splintar" ;
  splissa_vb_1_V = mkV "splissar" ;
  splitsa_vb_1_V = mkV "splitsar" ;
  splittra_vb_1_V = mkV "splittrar" ;
  spola_vb_1_V = mkV "spolar" ;
  spola_av_vbm_1_V2 = dirV2 (partV (mkV "spolar")"av") ;
  spola_oever_vbm_1_1_V2 = dirV2 (partV (mkV "spolar")"över") ;
  sponta_vb_1_V = mkV "spontar" ;
  sporra_vb_1_V = mkV "sporrar" ;
  sporta_vb_1_V = mkV "sportar" ;
  spotta_vb_1_V = mkV "spottar" ;
  spraka_vb_1_V = mkV "sprakar" ;
  spralla_vb_1_V = mkV "sprallar" ;
  sprattla_vb_1_V = mkV "sprattlar" ;
  spraya_vb_1_V = mkV "sprayar" ;
  spreja_vb_1_V = mkV "sprejar" ;
  spreta_vb_1_V = mkV "spretar" ;
  sprinta_vb_1_V = mkV "sprintar" ;
  sprita_vb_1_V = mkV "spritar" ;
  sprita_vb_2_V = mkV "spritar" ;
  spritsa_vb_1_V = mkV "spritsar" ;
  sprudla_vb_1_V = mkV "sprudlar" ;
  spruta_vb_1_V = mkV "sprutar" ;
  spruta_in_vbm_1_V2 = dirV2 (partV (mkV "sprutar")"in") ;
  sprutmaala_vb_1_1_V = mkV "sprutmålar" ;
  spraecka_vb_1_1_V = mkV "spräcker" ;
  spraenga_vb_1_1_V = mkV "spränger" ;
  spraenga_vb_2_1_V = mkV "spränger" ;
  spraetta_vb_2_1_V = mkV "sprättar" ;
  spraaka_vb_1_1_V = mkV "språkar" ;
  sproeta_vb_1_1_V = mkV "sprötar" ;
  spurta_vb_1_V = mkV "spurtar" ;
  spy_vb_1_V = mkV "spyr" ;
  spaecka_vb_1_1_V = mkV "späckar" ;
  spaeka_vb_1_1_V = mkV "späker" ;
  spaensta_vb_1_1_V = mkV "spänstar" ;
  spaenta_vb_1_1_V = mkV "späntar" ;
  spaerra_vb_1_1_V = mkV "spärrar" ;
  spaerra_in_vbm_1_1_V2 = dirV2 (partV (mkV "spärrar")"in") ;
  spaerra_till_vbm_1_1_V2 = dirV2 (partV (mkV "spärrar")"till") ;
  spaerra_ut_vbm_1_1_V2 = dirV2 (partV (mkV "spärrar")"ut") ;
  spaa_vb_1_1_V = mkV "spår" ;
  spaana_vb_1_1_V = mkV "spånar" ;
  spaanga_vb_1_1_V = mkV "spångar" ;
  spaanta_vb_1_1_V = mkV "spåntar" ;
  spaara_vb_1_1_V = mkV "spårar" ;
  spaara_ur_vbm_1_1_V2 = dirV2 (partV (mkV "spårar")"ur") ;
  spoea_vb_1_1_V = mkV "spöar" ;
  spoeka_vb_1_1_V = mkV "spökar" ;
  spoeka_ut_vbm_1_1_V2 = dirV2 (partV (mkV "spökar")"ut") ;
  stacka_vb_1_V = mkV "stackar" ;
  stadvaenda_vb_1_1_V = mkV "stadvänder" ;
  staga_vb_1_V = mkV "stagar" ;
  stagvaenda_vb_1_1_V = mkV "stagvänder" ;
  staka_vb_1_V = mkV "stakar" ;
  staka_ut_vbm_1_V2 = dirV2 (partV (mkV "stakar")"ut") ;
  stalla_vb_1_V = mkV "stallar" ;
  stamma_vb_2_V = mkV "stammar" ;
  stampa_vb_1_V = mkV "stampar" ;
  stampa_vb_2_V = mkV "stampar" ;
  stanna_vb_1_V = mkV "stannar" ;
  stansa_vb_1_V = mkV "stansar" ;
  stansa_ut_vbm_1_V2 = dirV2 (partV (mkV "stansar")"ut") ;
  stapla_vb_1_V = mkV "staplar" ;
  stappla_vb_1_V = mkV "stapplar" ;
  starrbliga_vb_1_V = mkV "starrbligar" ;
  starta_vb_1_V = mkV "startar" ;
  starta_om_vbm_1_V2 = dirV2 (partV (mkV "startar")"om") ;
  stassa_vb_1_V = mkV "stassar" ;
  statera_vb_1_V = mkV "staterar" ;
  statuera_vb_1_V = mkV "statuerar" ;
  stava_vb_1_V = mkV "stavar" ;
  stega_vb_1_V = mkV "stegar" ;
  stegla_vb_1_V = mkV "steglar" ;
  steka_vb_1_V = mkV "steker" ;
  stena_vb_1_V = mkV "stenar" ;
  steppa_vb_1_V = mkV "steppar" ;
  sticka_vb_2_V = mkV "stickar" ;
  stifta_vb_1_V = mkV "stiftar" ;
  stila_vb_1_V = mkV "stilar" ;
  stilla_vb_1_V = mkV "stillar" ;
  stillna_vb_1_V = mkV "stillnar" ;
  stimma_vb_1_V = mkV "stimmar" ;
  stirra_vb_1_V = mkV "stirrar" ;
  stjaelpa_vb_1_1_V = mkV "stjälper" ;
  stocka_vb_1_V = mkV "stockar" ;
  stoja_vb_1_V = mkV "stojar" ;
  stolpa_vb_1_V = mkV "stolpar" ;
  stoltsera_vb_1_V = mkV "stoltserar" ;
  stoppa_vb_1_V = mkV "stoppar" ;
  stoppa_in_vbm_1_V2 = dirV2 (partV (mkV "stoppar")"in") ;
  stoppa_om_vbm_1_V2 = dirV2 (partV (mkV "stoppar")"om") ;
  stoppa_till_vbm_1_V2 = dirV2 (partV (mkV "stoppar")"till") ;
  storhandla_vb_1_V = mkV "storhandlar" ;
  storkna_vb_1_V = mkV "storknar" ;
  storma_vb_1_V = mkV "stormar" ;
  stormgraela_vb_1_1_V = mkV "stormgrälar" ;
  stormskaella_vb_1_1_V = mkV "stormskäller" ;
  storsatsa_vb_1_V = mkV "storsatsar" ;
  storskratta_vb_1_V = mkV "storskrattar" ;
  straffa_vb_1_V = mkV "straffar" ;
  straffbeskatta_vb_1_V = mkV "straffbeskattar" ;
  strama_vb_1_V = mkV "stramar" ;
  stranda_vb_1_V = mkV "strandar" ;
  streaka_vb_1_V = mkV "streakar" ;
  strecka_vb_1_V = mkV "streckar" ;
  strejka_vb_1_V = mkV "strejkar" ;
  stressa_vb_1_V = mkV "stressar" ;
  streta_vb_1_V = mkV "stretar" ;
  stretcha_vb_1_V = mkV "stretchar" ;
  strigla_vb_1_V = mkV "striglar" ;
  strila_vb_1_V = mkV "strilar" ;
  strimla_vb_1_V = mkV "strimlar" ;
  stripa_vb_1_V = mkV "stripar" ;
  strippa_vb_1_V = mkV "strippar" ;
  strosa_vb_1_V = mkV "strosar" ;
  strula_vb_1_V = mkV "strular" ;
  strunta_vb_1_V = mkV "struntar" ;
  strutta_vb_1_V = mkV "struttar" ;
  straecka_vb_1_1_V = mkV "sträcker" ;
  straecklaesa_vb_1_1_V = mkV "sträckläser" ;
  straenga_vb_1_1_V = mkV "strängar" ;
  straeva_vb_1_1_V = mkV "strävar" ;
  straala_vb_1_1_V = mkV "strålar" ;
  stroe_vb_1_1_V = mkV "strör" ;
  stroemma_vb_1_1_V = mkV "strömmar" ;
  stroeppla_vb_1_1_V = mkV "ströpplar" ;
  stroeva_vb_1_1_V = mkV "strövar" ;
  stroeva_igenom_vbm_1_1_V2 = dirV2 (partV (mkV "strövar")"igenom") ;
  stubba_vb_1_V = mkV "stubbar" ;
  studsa_vb_1_V = mkV "studsar" ;
  stuka_vb_1_V = mkV "stukar" ;
  stuka_till_vbm_1_V2 = dirV2 (partV (mkV "stukar")"till") ;
  stulta_vb_1_V = mkV "stultar" ;
  stunda_vb_1_V = mkV "stundar" ;
  stura_vb_1_V = mkV "sturar" ;
  stuva_vb_1_V = mkV "stuvar" ;
  stuva_in_vbm_1_V2 = dirV2 (partV (mkV "stuvar")"in") ;
  stuva_om_vbm_1_V2 = dirV2 (partV (mkV "stuvar")"om") ;
  stycka_vb_1_V = mkV "styckar" ;
  stylta_vb_1_V = mkV "styltar" ;
  stympa_vb_1_V = mkV "stympar" ;
  styrka_vb_1_V = mkV "styrker" ;
  styva_vb_1_V = mkV "styvar" ;
  styvna_vb_1_V = mkV "styvnar" ;
  staecka_vb_1_1_V = mkV "stäcker" ;
  staeda_vb_1_1_V = mkV "städar" ;
  staedsla_vb_1_1_V = mkV "städslar" ;
  staella_vb_1_1_V = mkV "ställer" ;
  staemma_vb_1_1_V = mkV "stämmer" ;
  staempla_in_vbm_1_1_V2 = dirV2 (partV (mkV "stämplar")"in") ;
  staempla_ut_vbm_1_1_V2 = dirV2 (partV (mkV "stämplar")"ut") ;
  staenga_vb_1_1_V = mkV "stänger" ;
  staenka_vb_1_1_V = mkV "stänker" ;
  staerka_vb_1_1_V = mkV "stärker" ;
  staeva_vb_1_1_V = mkV "stävar" ;
  staevja_vb_1_1_V = mkV "stävjar" ;
  staanda_vb_1_1_V = mkV "ståndar" ;
  staanga_vb_1_1_V = mkV "stångar" ;
  staanka_vb_1_1_V = mkV "stånkar" ;
  staata_vb_1_1_V = mkV "ståtar" ;
  stoedkoepa_vb_1_1_V = mkV "stödköper" ;
  stoedroesta_vb_1_1_V = mkV "stödröstar" ;
  stoeka_vb_1_1_V = mkV "stökar" ;
  stoeka_till_vbm_1_1_V2 = dirV2 (partV (mkV "stökar")"till") ;
  stoeka_oever_vbm_1_1_V2 = dirV2 (partV (mkV "stökar")"över") ;
  stoena_vb_1_1_V = mkV "stönar" ;
  stoepa_vb_1_1_V = mkV "stöper" ;
  stoeppla_vb_1_1_V = mkV "stöpplar" ;
  stoera_vb_2_1_V = mkV "störar" ;
  stoerta_vb_1_1_V = mkV "störtar" ;
  stoerta_in_vbm_1_1_V2 = dirV2 (partV (mkV "störtar")"in") ;
  stoertregna_vb_1_1_V = mkV "störtregnar" ;
  stoeta_vb_1_1_V = mkV "stöter" ;
  stoetta_vb_1_1_V = mkV "stöttar" ;
  sucka_vb_1_V = mkV "suckar" ;
  sudda_vb_1_V = mkV "suddar" ;
  sudda_ut_vbm_1_V2 = dirV2 (partV (mkV "suddar")"ut") ;
  sudda_oever_vbm_1_1_V2 = dirV2 (partV (mkV "suddar")"över") ;
  suga_av_vbm_1_V2 = dirV2 (partV (mkV "sugar")"av") ;
  sukta_vb_1_V = mkV "suktar" ;
  sula_vb_1_V = mkV "sular" ;
  summa_vb_1_V = mkV "summar" ;
  sumpa_vb_1_V = mkV "sumpar" ;
  supera_vb_1_V = mkV "superar" ;
  suppurera_vb_1_V = mkV "suppurerar" ;
  sura_vb_1_V = mkV "surar" ;
  surfa_vb_1_V = mkV "surfar" ;
  surna_vb_1_V = mkV "surnar" ;
  surra_vb_1_V = mkV "surrar" ;
  surra_vb_2_V = mkV "surrar" ;
  susa_vb_1_V = mkV "susar" ;
  sussa_vb_1_V = mkV "sussar" ;
  svabba_vb_1_V = mkV "svabbar" ;
  svacka_vb_1_V = mkV "svackar" ;
  svaja_vb_1_V = mkV "svajar" ;
  svalka_vb_1_V = mkV "svalkar" ;
  svalla_vb_1_V = mkV "svallar" ;
  svalla_oever_vbm_1_1_V2 = dirV2 (partV (mkV "svallar")"över") ;
  svamla_vb_1_V = mkV "svamlar" ;
  svanka_vb_1_V = mkV "svankar" ;
  svansa_vb_1_V = mkV "svansar" ;
  svartlista_vb_1_V = mkV "svartlistar" ;
  svarva_vb_1_V = mkV "svarvar" ;
  svarva_till_vbm_1_V2 = dirV2 (partV (mkV "svarvar")"till") ;
  svassa_vb_1_V = mkV "svassar" ;
  svavla_vb_1_V = mkV "svavlar" ;
  svedja_vb_1_V = mkV "svedjar" ;
  svedja_av_vbm_1_V2 = dirV2 (partV (mkV "svedjar")"av") ;
  svepa_vb_1_V = mkV "sveper" ;
  svetsa_vb_1_V = mkV "svetsar" ;
  svetta_vb_1_V = mkV "svettar" ;
  svikta_vb_1_V = mkV "sviktar" ;
  svimma_vb_1_V = mkV "svimmar" ;
  svimma_av_vbm_1_V2 = dirV2 (partV (mkV "svimmar")"av") ;
  svindla_vb_1_V = mkV "svindlar" ;
  svindla_vb_2_V = mkV "svindlar" ;
  svinga_vb_1_V = mkV "svingar" ;
  svinga_vb_2_V = mkV "svingar" ;
  svira_vb_1_V = mkV "svirar" ;
  svirra_vb_1_V = mkV "svirrar" ;
  svischa_vb_1_V = mkV "svischar" ;
  svullna_vb_1_V = mkV "svullnar" ;
  svaella_vb_1_1_V = mkV "sväller" ;
  svaemma_oever_vbm_1_1_V2 = dirV2 (partV (mkV "svämmar")"över") ;
  svaenga_vb_1_1_V = mkV "svänger" ;
  svaenga_vb_2_1_V = mkV "svänger" ;
  svaerma_vb_1_1_V = mkV "svärmar" ;
  svaerta_vb_1_1_V = mkV "svärtar" ;
  svaeva_vb_1_1_V = mkV "svävar" ;
  svaeva_ut_vbm_1_1_V2 = dirV2 (partV (mkV "svävar")"ut") ;
  swinga_vb_1_V = mkV "swingar" ;
  sy_vb_1_V = mkV "syr" ;
  syfta_vb_1_V = mkV "syftar" ;
  sylta_vb_1_V = mkV "syltar" ;
  sylta_in_vbm_1_V2 = dirV2 (partV (mkV "syltar")"in") ;
  sympatisera_vb_1_V = mkV "sympatiserar" ;
  syna_vb_1_V = mkV "synar" ;
  synda_vb_1_V = mkV "syndar" ;
  synka_vb_1_V = mkV "synkar" ;
  syra_vb_1_V = mkV "syrar" ;
  syssla_vb_1_V = mkV "sysslar" ;
  systemera_vb_1_V = mkV "systemerar" ;
  saecka_vb_1_1_V = mkV "säckar" ;
  saekerstaella_vb_1_1_V = mkV "säkerställer" ;
  saellskapa_vb_1_1_V = mkV "sällskapar" ;
  saemska_vb_1_1_V = mkV "sämskar" ;
  saemskgarva_vb_1_1_V = mkV "sämskgarvar" ;
  saenda_vb_1_1_V = mkV "sänder" ;
  saengroeka_vb_1_1_V = mkV "sängröker" ;
  saenka_vb_1_1_V = mkV "sänker" ;
  saera_vb_1_1_V = mkV "särar" ;
  saerbeskatta_vb_1_1_V = mkV "särbeskattar" ;
  saa_vb_1_1_V = mkV "sår" ;
  saaga_vb_1_1_V = mkV "sågar" ;
  saaga_av_vbm_1_1_V2 = dirV2 (partV (mkV "sågar")"av") ;
  saaga_ur_vbm_1_1_V2 = dirV2 (partV (mkV "sågar")"ur") ;
  saaga_ut_vbm_1_1_V2 = dirV2 (partV (mkV "sågar")"ut") ;
  saalla_vb_1_1_V = mkV "sållar" ;
  saapa_vb_1_1_V = mkV "såpar" ;
  saara_vb_1_1_V = mkV "sårar" ;
  saasa_vb_1_1_V = mkV "såsar" ;
  saata_vb_1_1_V = mkV "såtar" ;
  soeka_vb_1_1_V = mkV "söker" ;
  soela_vb_1_1_V = mkV "sölar" ;
  soenderdela_vb_1_1_V = mkV "sönderdelar" ;
  soenderhacka_vb_1_1_V = mkV "sönderhackar" ;
  soenderspraenga_vb_1_1_V = mkV "sönderspränger" ;
  soerpla_vb_1_1_V = mkV "sörplar" ;
  soeta_vb_1_1_V = mkV "sötar" ;
  soeva_vb_1_1_V = mkV "söver" ;
  tabulera_vb_1_V = mkV "tabulerar" ;
  tacka_vb_1_V = mkV "tackar" ;
  tackla_vb_1_V = mkV "tacklar" ;
  tackla_av_vbm_1_V2 = dirV2 (partV (mkV "tacklar")"av") ;
  tadla_vb_1_V = mkV "tadlar" ;
  taffla_vb_1_V = mkV "tafflar" ;
  tafsa_vb_1_V = mkV "tafsar" ;
  tagga_vb_1_V = mkV "taggar" ;
  tagla_vb_1_V = mkV "taglar" ;
  taja_vb_1_V = mkV "tajar" ;
  tajma_vb_1_V = mkV "tajmar" ;
  taktera_vb_1_V = mkV "takterar" ;
  taktikroesta_vb_1_1_V = mkV "taktikröstar" ;
  talga_vb_1_V = mkV "talgar" ;
  talka_vb_1_V = mkV "talkar" ;
  talla_vb_1_V = mkV "tallar" ;
  tanda_vb_1_V = mkV "tandar" ;
  tanka_vb_1_V = mkV "tankar" ;
  tappa_vb_1_V = mkV "tappar" ;
  tarva_vb_1_V = mkV "tarvar" ;
  tassa_vb_1_V = mkV "tassar" ;
  tassla_vb_1_V = mkV "tasslar" ;
  taxa_vb_1_V = mkV "taxar" ;
  tejpa_vb_1_V = mkV "tejpar" ;
  teka_vb_1_V = mkV "tekar" ;
  tempa_vb_1_V = mkV "tempar" ;
  tendera_vb_1_V = mkV "tenderar" ;
  tenta_vb_1_V = mkV "tentar" ;
  tentamenslaesa_vb_1_1_V = mkV "tentamensläser" ;
  teoretisera_vb_1_V = mkV "teoretiserar" ;
  testa_vb_1_V = mkV "testar" ;
  texta_vb_1_V = mkV "textar" ;
  ticka_vb_1_V = mkV "tickar" ;
  tidsbegraensa_vb_1_1_V = mkV "tidsbegränsar" ;
  tidsbestaemma_vb_1_1_V = mkV "tidsbestämmer" ;
  tigga_vb_1_V = mkV "tigger" ;
  tillaga_vb_1_V = mkV "tillagar" ;
  tillbakavisa_vb_1_V = mkV "tillbakavisar" ;
  tillblanda_vb_1_V = mkV "tillblandar" ;
  tilldela_vb_1_V = mkV "tilldelar" ;
  tilldoema_vb_1_1_V = mkV "tilldömer" ;
  tillfoga_vb_1_V = mkV "tillfogar" ;
  tillfredsstaella_vb_1_1_V = mkV "tillfredsställer" ;
  tillfriskna_vb_1_V = mkV "tillfrisknar" ;
  tillfrysa_vb_1_V = mkV "tillfryser" ;
  tillfraaga_vb_1_1_V = mkV "tillfrågar" ;
  tillgodoraekna_vb_1_1_V = mkV "tillgodoräknar" ;
  tillkalla_vb_1_V = mkV "tillkallar" ;
  tillmaeta_vb_1_1_V = mkV "tillmäter" ;
  tillpassa_vb_1_V = mkV "tillpassar" ;
  tillplatta_vb_1_V = mkV "tillplattar" ;
  tillra_vb_1_V = mkV "tillrar" ;
  tillraekna_vb_1_1_V = mkV "tillräknar" ;
  tillraettavisa_vb_1_1_V = mkV "tillrättavisar" ;
  tillskapa_vb_1_V = mkV "tillskapar" ;
  tillskynda_vb_1_V = mkV "tillskyndar" ;
  tillspetsa_vb_1_V = mkV "tillspetsar" ;
  tillstunda_vb_1_V = mkV "tillstundar" ;
  tillstyrka_vb_1_V = mkV "tillstyrker" ;
  tillstaella_vb_1_1_V = mkV "tillställer" ;
  tillstoeta_vb_1_1_V = mkV "tillstöter" ;
  tilltala_vb_1_V = mkV "tilltalar" ;
  tilltro_vb_1_V = mkV "tilltror" ;
  tilltyga_vb_1_V = mkV "tilltygar" ;
  tilltaeppa_vb_1_1_V = mkV "tilltäpper" ;
  tillverka_vb_1_V = mkV "tillverkar" ;
  tillvita_vb_1_V = mkV "tillvitar" ;
  tillyxa_vb_1_V = mkV "tillyxar" ;
  tillaegna_vb_1_1_V = mkV "tillägnar" ;
  tillaemna_vb_1_1_V = mkV "tillämnar" ;
  tillaempa_vb_1_1_V = mkV "tillämpar" ;
  tilloenska_vb_1_1_V = mkV "tillönskar" ;
  tima_vb_1_V = mkV "timar" ;
  tina_vb_1_V = mkV "tinar" ;
  tindra_vb_1_V = mkV "tindrar" ;
  tinga_vb_1_V = mkV "tingar" ;
  tiofaldiga_vb_1_V = mkV "tiofaldigar" ;
  tippa_vb_1_V = mkV "tippar" ;
  tipsa_vb_1_V = mkV "tipsar" ;
  tira_vb_1_V = mkV "tirar" ;
  tissla_vb_1_V = mkV "tisslar" ;
  titta_vb_1_V = mkV "tittar" ;
  titta_in_vbm_1_V2 = dirV2 (partV (mkV "tittar")"in") ;
  titta_paa_vbm_1_1_V2 = dirV2 (partV (mkV "tittar")"på") ;
  titta_till_vbm_1_V2 = dirV2 (partV (mkV "tittar")"till") ;
  tjacka_vb_1_V = mkV "tjackar" ;
  tjafsa_vb_1_V = mkV "tjafsar" ;
  tjalla_vb_1_V = mkV "tjallar" ;
  tjata_vb_1_V = mkV "tjatar" ;
  tjattra_vb_1_V = mkV "tjattrar" ;
  tjilla_vb_1_V = mkV "tjillar" ;
  tjimma_vb_1_V = mkV "tjimmar" ;
  tjinga_vb_1_V = mkV "tjingar" ;
  tjoa_vb_1_V = mkV "tjoar" ;
  tjockna_vb_1_V = mkV "tjocknar" ;
  tjorva_vb_1_V = mkV "tjorvar" ;
  tjura_vb_1_V = mkV "tjurar" ;
  tjuva_vb_1_V = mkV "tjuvar" ;
  tjuvkika_vb_1_V = mkV "tjuvkikar" ;
  tjuvmjoelka_vb_1_1_V = mkV "tjuvmjölkar" ;
  tjuvroeka_vb_1_1_V = mkV "tjuvröker" ;
  tjuvstarta_vb_1_V = mkV "tjuvstartar" ;
  tjuvtitta_vb_1_V = mkV "tjuvtittar" ;
  tjuvtraena_vb_1_1_V = mkV "tjuvtränar" ;
  tjyva_vb_1_V = mkV "tjyvar" ;
  tjyvkika_vb_1_V = mkV "tjyvkikar" ;
  tjyvmjoelka_vb_1_1_V = mkV "tjyvmjölkar" ;
  tjyvroeka_vb_1_1_V = mkV "tjyvröker" ;
  tjyvstarta_vb_1_V = mkV "tjyvstartar" ;
  tjyvtitta_vb_1_V = mkV "tjyvtittar" ;
  tjaela_vb_1_1_V = mkV "tjälar" ;
  tjaena_vb_1_1_V = mkV "tjänar" ;
  tjaera_vb_1_1_V = mkV "tjärar" ;
  tocka_vb_1_V = mkV "tockar" ;
  toffla_vb_1_V = mkV "tofflar" ;
  tolka_vb_1_V = mkV "tolkar" ;
  tomta_vb_1_V = mkV "tomtar" ;
  tona_vb_1_V = mkV "tonar" ;
  toppa_vb_1_V = mkV "toppar" ;
  torde_vb_1_V = mkV "tör" ;
  torka_vb_1_V = mkV "torkar" ;
  torka_av_vbm_1_V2 = dirV2 (partV (mkV "torkar")"av") ;
  torka_in_vbm_1_V2 = dirV2 (partV (mkV "torkar")"in") ;
  torka_ut_vbm_1_V2 = dirV2 (partV (mkV "torkar")"ut") ;
  torna_vb_1_V = mkV "tornar" ;
  tornera_vb_1_V = mkV "tornerar" ;
  torrhosta_vb_1_V = mkV "torrhostar" ;
  torrslipa_vb_1_V = mkV "torrslipar" ;
  torroeka_vb_1_1_V = mkV "torröker" ;
  torska_vb_1_V = mkV "torskar" ;
  torva_vb_1_V = mkV "torvar" ;
  torvtaecka_vb_1_1_V = mkV "torvtäcker" ;
  totalkvadda_vb_1_V = mkV "totalkvaddar" ;
  toucha_vb_1_V = mkV "touchar" ;
  tova_vb_1_V = mkV "tovar" ;
  traggla_vb_1_V = mkV "tragglar" ;
  traja_vb_1_V = mkV "trajar" ;
  trakta_vb_1_V = mkV "traktar" ;
  tralla_vb_1_V = mkV "trallar" ;
  trampa_vb_1_V = mkV "trampar" ;
  trampa_till_vbm_1_V2 = dirV2 (partV (mkV "trampar")"till") ;
  trampa_ut_vbm_1_V2 = dirV2 (partV (mkV "trampar")"ut") ;
  tramsa_vb_1_V = mkV "tramsar" ;
  tranchera_vb_1_V = mkV "trancherar" ;
  transpirera_vb_1_V = mkV "transpirerar" ;
  trasa_vb_1_V = mkV "trasar" ;
  traska_vb_1_V = mkV "traskar" ;
  trassla_vb_1_V = mkV "trasslar" ;
  trassla_in_vbm_1_V2 = dirV2 (partV (mkV "trasslar")"in") ;
  trassla_till_vbm_1_V2 = dirV2 (partV (mkV "trasslar")"till") ;
  tratta_vb_1_V = mkV "trattar" ;
  trava_vb_1_V = mkV "travar" ;
  tremulera_vb_1_V = mkV "tremulerar" ;
  treva_vb_1_V = mkV "trevar" ;
  trilla_vb_1_V = mkV "trillar" ;
  trimma_vb_1_V = mkV "trimmar" ;
  trippa_vb_1_V = mkV "trippar" ;
  triumfera_vb_1_V = mkV "triumferar" ;
  tro_vb_1_V = mkV "tror" ;
  trolla_vb_1_V = mkV "trollar" ;
  trolova_vb_1_V = mkV "trolovar" ;
  trona_vb_1_V = mkV "tronar" ;
  troppa_vb_1_V = mkV "troppar" ;
  troppa_av_vbm_1_V2 = dirV2 (partV (mkV "troppar")"av") ;
  trotsa_vb_1_V = mkV "trotsar" ;
  truga_vb_1_V = mkV "trugar" ;
  truga_paa_vbm_1_1_V2 = dirV2 (partV (mkV "trugar")"på") ;
  trula_vb_1_V = mkV "trular" ;
  trumfa_vb_1_V = mkV "trumfar" ;
  trumfa_i_vbm_1_V2 = dirV2 (partV (mkV "trumfar")"i") ;
  trumfa_igenom_vbm_1_V2 = dirV2 (partV (mkV "trumfar")"igenom") ;
  trumla_vb_1_V = mkV "trumlar" ;
  trumma_in_vbm_1_V2 = dirV2 (partV (mkV "trummar")"in") ;
  trumpeta_vb_1_V = mkV "trumpetar" ;
  trumpeta_ut_vbm_1_V2 = dirV2 (partV (mkV "trumpetar")"ut") ;
  truta_vb_1_V = mkV "trutar" ;
  trycka_vb_1_V = mkV "trycker" ;
  trygga_vb_1_V = mkV "tryggar" ;
  tryna_vb_1_V = mkV "trynar" ;
  traecka_vb_1_1_V = mkV "träcker" ;
  traeffa_vb_1_1_V = mkV "träffar" ;
  traeffa_paa_vbm_1_1_V2 = dirV2 (partV (mkV "träffar")"på") ;
  traela_vb_1_1_V = mkV "trälar" ;
  traena_vb_1_1_V = mkV "tränar" ;
  traenga_vb_1_1_V = mkV "tränger" ;
  traengta_vb_1_1_V = mkV "trängtar" ;
  traensa_vb_1_1_V = mkV "tränsar" ;
  traeta_vb_1_1_V = mkV "träter" ;
  traa_vb_1_1_V = mkV "trår" ;
  traackla_vb_1_1_V = mkV "tråcklar" ;
  traackla_till_vbm_1_1_V2 = dirV2 (partV (mkV "tråcklar")"till") ;
  traaka_vb_1_1_V = mkV "tråkar" ;
  traaka_ut_vbm_1_1_V2 = dirV2 (partV (mkV "tråkar")"ut") ;
  traala_vb_1_1_V = mkV "trålar" ;
  traana_vb_1_1_V = mkV "trånar" ;
  troeska_vb_1_1_V = mkV "tröskar" ;
  troesta_vb_1_1_V = mkV "tröstar" ;
  troetta_vb_1_1_V = mkV "tröttar" ;
  tubba_vb_1_V = mkV "tubbar" ;
  tudela_vb_1_V = mkV "tudelar" ;
  tuffa_vb_1_V = mkV "tuffar" ;
  tufsa_vb_1_V = mkV "tufsar" ;
  tufsa_till_vbm_1_V2 = dirV2 (partV (mkV "tufsar")"till") ;
  tugga_vb_1_V = mkV "tuggar" ;
  tugga_om_vbm_1_V2 = dirV2 (partV (mkV "tuggar")"om") ;
  tukta_vb_1_V = mkV "tuktar" ;
  tulla_vb_1_V = mkV "tullar" ;
  tullbesiktiga_vb_1_V = mkV "tullbesiktigar" ;
  tulta_vb_1_V = mkV "tultar" ;
  tumla_vb_1_V = mkV "tumlar" ;
  tumma_vb_2_V = mkV "tummar" ;
  tunna_vb_1_V = mkV "tunnar" ;
  tuppa_av_vbm_1_V2 = dirV2 (partV (mkV "tuppar")"av") ;
  turista_vb_1_V = mkV "turistar" ;
  turnera_vb_1_V = mkV "turnerar" ;
  tuscha_vb_1_V = mkV "tuschar" ;
  tussa_vb_1_V = mkV "tussar" ;
  tuta_vb_1_V = mkV "tutar" ;
  tuta_i_vbm_1_V2 = dirV2 (partV (mkV "tutar")"i") ;
  tutta_paa_vbm_1_1_V2 = dirV2 (partV (mkV "tuttar")"på") ;
  tveka_vb_1_V = mkV "tvekar" ;
  tvina_vb_1_V = mkV "tvinar" ;
  tvinna_vb_1_V = mkV "tvinnar" ;
  tvaera_vb_1_1_V = mkV "tvärar" ;
  tvaerbromsa_vb_1_1_V = mkV "tvärbromsar" ;
  tvaernita_vb_1_1_V = mkV "tvärnitar" ;
  tvaersa_vb_1_1_V = mkV "tvärsar" ;
  tvaerstanna_vb_1_1_V = mkV "tvärstannar" ;
  tvaervaenda_vb_1_1_V = mkV "tvärvänder" ;
  tvaetta_vb_1_1_V = mkV "tvättar" ;
  tvaetta_av_vbm_1_1_V2 = dirV2 (partV (mkV "tvättar")"av") ;
  tvaala_in_vbm_1_1_V2 = dirV2 (partV (mkV "tvålar")"in") ;
  tvaala_till_vbm_1_1_V2 = dirV2 (partV (mkV "tvålar")"till") ;
  tvaangsinloesa_vb_1_1_V = mkV "tvångsinlöser" ;
  twista_vb_1_V = mkV "twistar" ;
  tya_vb_1_V = mkV "tyar" ;
  tycka_vb_1_V = mkV "tycker" ;
  tygla_vb_1_V = mkV "tyglar" ;
  tyna_vb_1_V = mkV "tynar" ;
  tyna_av_vbm_1_V2 = dirV2 (partV (mkV "tynar")"av") ;
  tynga_vb_1_V = mkV "tynger" ;
  tysta_vb_1_V = mkV "tystar" ;
  tystna_vb_1_V = mkV "tystnar" ;
  taecka_vb_1_1_V = mkV "täcker" ;
  taelta_vb_1_1_V = mkV "tältar" ;
  taenda_vb_1_1_V = mkV "tänder" ;
  taenka_vb_1_1_V = mkV "tänker" ;
  taerna_vb_1_1_V = mkV "tärnar" ;
  taeta_vb_1_1_V = mkV "tätar" ;
  taetna_vb_1_1_V = mkV "tätnar" ;
  taaa_vb_1_1_V = mkV "tåar" ;
  taaga_vb_1_1_V = mkV "tågar" ;
  taaga_igenom_vbm_1_1_V2 = dirV2 (partV (mkV "tågar")"igenom") ;
  taaga_ut_vbm_1_1_V2 = dirV2 (partV (mkV "tågar")"ut") ;
  taagluffa_vb_1_1_V = mkV "tågluffar" ;
  taarta_vb_1_1_V = mkV "tårtar" ;
  toea_vb_1_1_V = mkV "töar" ;
  toelta_vb_1_1_V = mkV "töltar" ;
  toemma_vb_1_1_V = mkV "tömmer" ;
  toenta_vb_1_1_V = mkV "töntar" ;
  toerna_vb_1_1_V = mkV "törnar" ;
  toerna_in_vbm_1_1_V2 = dirV2 (partV (mkV "törnar")"in") ;
  toersta_vb_1_1_V = mkV "törstar" ;
  toeva_vb_1_1_V = mkV "tövar" ;
  uggla_vb_1_V = mkV "ugglar" ;
  ugnsbaka_vb_1_V = mkV "ugnsbakar" ;
  ugnsgraedda_vb_1_1_V = mkV "ugnsgräddar" ;
  ugnssteka_vb_1_V = mkV "ugnssteker" ;
  ugnstorka_vb_1_V = mkV "ugnstorkar" ;
  ulka_vb_1_V = mkV "ulkar" ;
  ulma_vb_1_V = mkV "ulmar" ;
  umeaabo_vb_1_1_V = mkV "umeåbor" ;
  umgaella_vb_1_1_V = mkV "umgäller" ;
  undangoemma_vb_1_1_V = mkV "undangömmer" ;
  undanskaffa_vb_1_V = mkV "undanskaffar" ;
  undanskifta_vb_1_V = mkV "undanskiftar" ;
  undanskuffa_vb_1_V = mkV "undanskuffar" ;
  undanskymma_vb_1_V = mkV "undanskymmer" ;
  undansnilla_vb_1_V = mkV "undansnillar" ;
  undantraenga_vb_1_1_V = mkV "undantränger" ;
  underanvaenda_vb_1_1_V = mkV "underanvänder" ;
  underblaasa_vb_1_1_V = mkV "underblåser" ;
  underbygga_vb_1_V = mkV "underbygger" ;
  undergraeva_vb_1_1_V = mkV "undergräver" ;
  underkasta_vb_1_V = mkV "underkastar" ;
  underkuva_vb_1_V = mkV "underkuvar" ;
  underkvista_vb_1_V = mkV "underkvistar" ;
  underkyla_vb_1_V = mkV "underkyler" ;
  underlappa_vb_1_V = mkV "underlappar" ;
  underordna_vb_1_V = mkV "underordnar" ;
  underraetta_vb_1_1_V = mkV "underrättar" ;
  underskatta_vb_1_V = mkV "underskattar" ;
  understrecka_vb_1_V = mkV "understreckar" ;
  understaella_vb_1_1_V = mkV "underställer" ;
  undersoeka_vb_1_1_V = mkV "undersöker" ;
  undertrycka_vb_1_V = mkV "undertrycker" ;
  undervisa_vb_1_V = mkV "undervisar" ;
  undfly_vb_1_V = mkV "undflyr" ;
  undfaegna_vb_1_1_V = mkV "undfägnar" ;
  undskylla_vb_1_V = mkV "undskyller" ;
  undulera_vb_1_V = mkV "undulerar" ;
  unkna_vb_1_V = mkV "unknar" ;
  unna_vb_1_V = mkV "unnar" ;
  upparbeta_vb_1_V = mkV "upparbetar" ;
  uppassa_vb_1_V = mkV "uppassar" ;
  uppblanda_vb_1_V = mkV "uppblandar" ;
  uppbringa_vb_1_V = mkV "uppbringar" ;
  uppbygga_vb_1_V = mkV "uppbygger" ;
  uppbaada_vb_1_1_V = mkV "uppbådar" ;
  uppdaga_vb_1_V = mkV "uppdagar" ;
  uppdela_vb_1_V = mkV "uppdelar" ;
  uppegga_vb_1_V = mkV "uppeggar" ;
  uppenbara_vb_1_V = mkV "uppenbarar" ;
  uppfatta_vb_1_V = mkV "uppfattar" ;
  uppfriska_vb_1_V = mkV "uppfriskar" ;
  uppfylla_vb_1_V = mkV "uppfyller" ;
  uppfaanga_vb_1_1_V = mkV "uppfångar" ;
  uppfoerstora_vb_1_1_V = mkV "uppförstorar" ;
  upphaussa_vb_1_V = mkV "upphaussar" ;
  upphetsa_vb_1_V = mkV "upphetsar" ;
  upphetta_vb_1_V = mkV "upphettar" ;
  upphitta_vb_1_V = mkV "upphittar" ;
  upphaemta_vb_1_1_V = mkV "upphämtar" ;
  upphaeva_vb_1_1_V = mkV "upphäver" ;
  uppjazza_vb_1_V = mkV "uppjazzar" ;
  uppkalla_vb_1_V = mkV "uppkallar" ;
  uppklara_vb_1_V = mkV "uppklarar" ;
  uppkvista_vb_1_V = mkV "uppkvistar" ;
  upplappa_vb_1_V = mkV "upplappar" ;
  uppleva_vb_1_V = mkV "upplever" ;
  uppliva_vb_1_V = mkV "upplivar" ;
  upplysa_vb_1_V = mkV "upplyser" ;
  upplaesa_vb_1_1_V = mkV "uppläser" ;
  upploesa_vb_1_1_V = mkV "upplöser" ;
  uppmana_vb_1_V = mkV "uppmanar" ;
  uppmjuka_vb_1_V = mkV "uppmjukar" ;
  uppmaeta_vb_1_1_V = mkV "uppmäter" ;
  uppnaa_vb_1_1_V = mkV "uppnår" ;
  uppnaala_vb_1_1_V = mkV "uppnålar" ;
  upprada_vb_1_V = mkV "uppradar" ;
  upprensa_vb_1_V = mkV "upprensar" ;
  upprepa_vb_1_V = mkV "upprepar" ;
  uppresa_vb_1_V = mkV "uppreser" ;
  upprusta_vb_1_V = mkV "upprustar" ;
  upprymma_vb_1_V = mkV "upprymmer" ;
  uppraetta_vb_1_1_V = mkV "upprättar" ;
  uppskatta_vb_1_V = mkV "uppskattar" ;
  uppsluka_vb_1_V = mkV "uppslukar" ;
  uppsnabba_vb_1_V = mkV "uppsnabbar" ;
  uppsnappa_vb_1_V = mkV "uppsnappar" ;
  uppspjaelka_vb_1_1_V = mkV "uppspjälkar" ;
  uppspaara_vb_1_1_V = mkV "uppspårar" ;
  uppstrama_vb_1_V = mkV "uppstramar" ;
  uppstaella_vb_1_1_V = mkV "uppställer" ;
  uppstaemma_vb_1_1_V = mkV "uppstämmer" ;
  uppsoeka_vb_1_1_V = mkV "uppsöker" ;
  uppteckna_vb_1_V = mkV "upptecknar" ;
  upptorna_vb_1_V = mkV "upptornar" ;
  upptrampa_vb_1_V = mkV "upptrampar" ;
  upptrappa_vb_1_V = mkV "upptrappar" ;
  upptrissa_vb_1_V = mkV "upptrissar" ;
  upptaecka_vb_1_1_V = mkV "upptäcker" ;
  upptaenda_vb_1_1_V = mkV "upptänder" ;
  uppvakta_vb_1_V = mkV "uppvaktar" ;
  uppvaecka_vb_1_1_V = mkV "uppväcker" ;
  uppvaega_vb_1_1_V = mkV "uppväger" ;
  uppvaerma_vb_1_1_V = mkV "uppvärmer" ;
  uppoeva_vb_1_1_V = mkV "uppövar" ;
  urarta_vb_1_V = mkV "urartar" ;
  urgera_vb_1_V = mkV "urgerar" ;
  urinera_vb_1_V = mkV "urinerar" ;
  urkalka_vb_1_V = mkV "urkalkar" ;
  urlaka_vb_1_V = mkV "urlakar" ;
  ursaka_vb_1_V = mkV "ursakar" ;
  urskulda_vb_1_V = mkV "urskuldar" ;
  ursprungsmaerka_vb_1_1_V = mkV "ursprungsmärker" ;
  ursaekta_vb_1_1_V = mkV "ursäktar" ;
  utanordna_vb_1_V = mkV "utanordnar" ;
  utarbeta_vb_1_V = mkV "utarbetar" ;
  utarma_vb_1_V = mkV "utarmar" ;
  utbilda_vb_1_V = mkV "utbildar" ;
  utbua_vb_1_V = mkV "utbuar" ;
  utbygga_vb_1_V = mkV "utbygger" ;
  utbyta_vb_1_V = mkV "utbyter" ;
  utdela_vb_1_V = mkV "utdelar" ;
  utdika_vb_1_V = mkV "utdikar" ;
  utdunsta_vb_1_V = mkV "utdunstar" ;
  utdoema_vb_1_1_V = mkV "utdömer" ;
  utelaemna_vb_1_1_V = mkV "utelämnar" ;
  utelaasa_vb_1_1_V = mkV "utelåser" ;
  utestaenga_vb_1_1_V = mkV "utestänger" ;
  utfiska_vb_1_V = mkV "utfiskar" ;
  utflagga_vb_1_V = mkV "utflaggar" ;
  utforma_vb_1_V = mkV "utformar" ;
  utforska_vb_1_V = mkV "utforskar" ;
  utfrakta_vb_1_V = mkV "utfraktar" ;
  utfraaga_vb_1_1_V = mkV "utfrågar" ;
  utfylla_vb_1_V = mkV "utfyller" ;
  utfaella_vb_1_1_V = mkV "utfäller" ;
  utfaerda_vb_1_1_V = mkV "utfärdar" ;
  utglesa_vb_1_V = mkV "utglesar" ;
  utgrunda_vb_1_V = mkV "utgrundar" ;
  utgraeva_vb_1_1_V = mkV "utgräver" ;
  uthaerda_vb_1_1_V = mkV "uthärdar" ;
  utjaemna_vb_1_1_V = mkV "utjämnar" ;
  utkasta_vb_1_V = mkV "utkastar" ;
  utklara_vb_1_V = mkV "utklarar" ;
  utklassa_vb_1_V = mkV "utklassar" ;
  utkora_vb_1_V = mkV "utkorar" ;
  utkraeva_vb_1_1_V = mkV "utkräver" ;
  utkyla_vb_1_V = mkV "utkyler" ;
  utkaempa_vb_1_1_V = mkV "utkämpar" ;
  utlotta_vb_1_V = mkV "utlottar" ;
  utlova_vb_1_V = mkV "utlovar" ;
  utlysa_vb_1_V = mkV "utlyser" ;
  utlaesa_vb_1_1_V = mkV "utläser" ;
  utlaana_vb_1_1_V = mkV "utlånar" ;
  utloesa_vb_1_1_V = mkV "utlöser" ;
  utmana_vb_1_V = mkV "utmanar" ;
  utmatta_vb_1_V = mkV "utmattar" ;
  utmynna_vb_1_V = mkV "utmynnar" ;
  utmaerka_vb_1_1_V = mkV "utmärker" ;
  utmaeta_vb_1_1_V = mkV "utmäter" ;
  utmaala_vb_1_1_V = mkV "utmålar" ;
  utnyttja_vb_1_V = mkV "utnyttjar" ;
  utnaemna_vb_1_1_V = mkV "utnämner" ;
  utpeka_vb_1_V = mkV "utpekar" ;
  utplaana_vb_1_1_V = mkV "utplånar" ;
  utpressa_vb_1_V = mkV "utpressar" ;
  utpricka_vb_1_V = mkV "utprickar" ;
  utprova_vb_1_V = mkV "utprovar" ;
  utproeva_vb_1_1_V = mkV "utprövar" ;
  utrensa_vb_1_V = mkV "utrensar" ;
  utropa_vb_1_V = mkV "utropar" ;
  utrota_vb_1_V = mkV "utrotar" ;
  utrusta_vb_1_V = mkV "utrustar" ;
  utrymma_vb_1_V = mkV "utrymmer" ;
  utraetta_vb_1_1_V = mkV "uträttar" ;
  utsira_vb_1_V = mkV "utsirar" ;
  utskeppa_vb_1_V = mkV "utskeppar" ;
  utskaenka_vb_1_1_V = mkV "utskänker" ;
  utslunga_vb_1_V = mkV "utslungar" ;
  utslussa_vb_1_V = mkV "utslussar" ;
  utslaecka_vb_1_1_V = mkV "utsläcker" ;
  utslaeta_vb_1_1_V = mkV "utslätar" ;
  utsmycka_vb_1_V = mkV "utsmyckar" ;
  utspana_vb_1_V = mkV "utspanar" ;
  utspisa_vb_1_V = mkV "utspisar" ;
  utspy_vb_1_V = mkV "utspyr" ;
  utspaerra_vb_1_1_V = mkV "utspärrar" ;
  utstaka_vb_1_V = mkV "utstakar" ;
  utstraecka_vb_1_1_V = mkV "utsträcker" ;
  utstraala_vb_1_1_V = mkV "utstrålar" ;
  utstaella_vb_1_1_V = mkV "utställer" ;
  utstoeta_vb_1_1_V = mkV "utstöter" ;
  utsyna_vb_1_V = mkV "utsynar" ;
  utsaenda_vb_1_1_V = mkV "utsänder" ;
  utsoeka_vb_1_1_V = mkV "utsöker" ;
  uttala_vb_1_V = mkV "uttalar" ;
  uttolka_vb_1_V = mkV "uttolkar" ;
  uttrycka_vb_1_V = mkV "uttrycker" ;
  uttroetta_vb_1_1_V = mkV "uttröttar" ;
  uttunna_vb_1_V = mkV "uttunnar" ;
  uttoemma_vb_1_1_V = mkV "uttömmer" ;
  utverka_vb_1_V = mkV "utverkar" ;
  utvidga_vb_1_V = mkV "utvidgar" ;
  utvisa_vb_1_V = mkV "utvisar" ;
  utoeka_vb_1_1_V = mkV "utökar" ;
  utoeva_vb_1_1_V = mkV "utövar" ;
  vabba_vb_1_V = mkV "vabbar" ;
  vackla_vb_1_V = mkV "vacklar" ;
  vada_vb_1_V = mkV "vadar" ;
  vada_igenom_vbm_1_V2 = dirV2 (partV (mkV "vadar")"igenom") ;
  vagabondera_vb_1_V = mkV "vagabonderar" ;
  vagga_vb_1_V = mkV "vaggar" ;
  vaja_vb_1_V = mkV "vajar" ;
  vaka_vb_1_V = mkV "vakar" ;
  vakta_vb_1_V = mkV "vaktar" ;
  valacka_vb_1_V = mkV "valackar" ;
  valfuska_vb_1_V = mkV "valfuskar" ;
  valka_vb_1_V = mkV "valkar" ;
  valkgarva_vb_1_V = mkV "valkgarvar" ;
  valla_vb_1_V = mkV "vallar" ;
  valla_in_vbm_1_V2 = dirV2 (partV (mkV "vallar")"in") ;
  vallfaerda_vb_1_1_V = mkV "vallfärdar" ;
  valna_vb_1_V = mkV "valnar" ;
  valpa_vb_1_V = mkV "valpar" ;
  valsa_vb_1_V = mkV "valsar" ;
  valsa_ut_vbm_2_V2 = dirV2 (partV (mkV "valsar")"ut") ;
  vampa_vb_1_V = mkV "vampar" ;
  vandra_igenom_vbm_1_V2 = dirV2 (partV (mkV "vandrar")"igenom") ;
  vanka_vb_1_V = mkV "vankar" ;
  vanna_vb_1_V = mkV "vannar" ;
  vanskoeta_vb_1_1_V = mkV "vansköter" ;
  vanstaella_vb_1_1_V = mkV "vanställer" ;
  vantolka_vb_1_V = mkV "vantolkar" ;
  vanvaarda_vb_1_1_V = mkV "vanvårdar" ;
  vanvoerda_vb_1_1_V = mkV "vanvördar" ;
  vanaera_vb_1_1_V = mkV "vanärar" ;
  vapenvaegra_vb_1_1_V = mkV "vapenvägrar" ;
  vara_vb_2_V = mkV "varar" ;
  varga_vb_1_V = mkV "vargar" ;
  varmbona_vb_1_V = mkV "varmbonar" ;
  varmroeka_vb_1_1_V = mkV "varmröker" ;
  varna_vb_1_V = mkV "varnar" ;
  varpa_vb_1_V = mkV "varpar" ;
  varsko_vb_1_V = mkV "varskor" ;
  varsla_vb_1_V = mkV "varslar" ;
  varsna_vb_1_V = mkV "varsnar" ;
  varva_vb_1_V = mkV "varvar" ;
  vaska_vb_1_V = mkV "vaskar" ;
  vaska_ut_vbm_1_V2 = dirV2 (partV (mkV "vaskar")"ut") ;
  vattna_vb_1_V = mkV "vattnar" ;
  vattna_ur_vbm_1_V2 = dirV2 (partV (mkV "vattnar")"ur") ;
  vaxa_vb_1_V = mkV "vaxar" ;
  vecka_vb_1_V = mkV "veckar" ;
  veckohandla_vb_1_V = mkV "veckohandlar" ;
  veckopendla_vb_1_V = mkV "veckopendlar" ;
  vederfaas_vb_1_1_V = mkV "vederfås" ;
  vedergaella_vb_1_1_V = mkV "vedergäller" ;
  vederkvicka_vb_1_V = mkV "vederkvicker" ;
  vedervaaga_vb_1_1_V = mkV "vedervågar" ;
  vegetera_vb_1_V = mkV "vegeterar" ;
  veklaga_vb_1_V = mkV "veklagar" ;
  vekna_vb_1_V = mkV "veknar" ;
  vela_vb_1_V = mkV "velar" ;
  verka_vb_1_V = mkV "verkar" ;
  verkstaella_vb_1_1_V = mkV "verkställer" ;
  vetenskapa_vb_1_V = mkV "vetenskapar" ;
  veva_vb_1_V = mkV "vevar" ;
  vibrera_vb_1_V = mkV "vibrerar" ;
  vicka_vb_1_V = mkV "vickar" ;
  vidga_vb_1_V = mkV "vidgar" ;
  vidhaefta_vb_1_1_V = mkV "vidhäftar" ;
  vidhaenga_vb_1_1_V = mkV "vidhänger" ;
  vidtala_vb_1_V = mkV "vidtalar" ;
  vifta_vb_1_V = mkV "viftar" ;
  viga_vb_1_V = mkV "viger" ;
  vigga_vb_1_V = mkV "viggar" ;
  vigilera_vb_1_V = mkV "vigilerar" ;
  vikariera_vb_1_V = mkV "vikarierar" ;
  vila_vb_1_V = mkV "vilar" ;
  villkora_vb_1_V = mkV "villkorar" ;
  vimla_vb_1_V = mkV "vimlar" ;
  vimsa_vb_1_V = mkV "vimsar" ;
  vina_vb_2_V = mkV "vinar" ;
  vinda_vb_1_V = mkV "vindar" ;
  vindla_vb_1_V = mkV "vindlar" ;
  vindsurfa_vb_1_V = mkV "vindsurfar" ;
  vingklippa_vb_1_V = mkV "vingklipper" ;
  vingla_vb_1_V = mkV "vinglar" ;
  vinka_vb_1_V = mkV "vinkar" ;
  vinkla_vb_1_V = mkV "vinklar" ;
  vinscha_vb_1_V = mkV "vinschar" ;
  vinstvarna_vb_1_V = mkV "vinstvarnar" ;
  vinterbona_vb_1_V = mkV "vinterbonar" ;
  vippa_vb_1_V = mkV "vippar" ;
  vira_vb_1_V = mkV "virar" ;
  virka_vb_1_V = mkV "virkar" ;
  virra_vb_1_V = mkV "virrar" ;
  virvla_vb_1_V = mkV "virvlar" ;
  visa_vb_1_V = mkV "visar" ;
  viska_vb_1_V = mkV "viskar" ;
  vispa_vb_1_V = mkV "vispar" ;
  vissla_vb_1_V = mkV "visslar" ;
  vissna_vb_1_V = mkV "vissnar" ;
  vitgloedga_vb_1_1_V = mkV "vitglödgar" ;
  vitkalka_vb_1_V = mkV "vitkalkar" ;
  vitmena_vb_1_V = mkV "vitmenar" ;
  vitsa_vb_1_V = mkV "vitsar" ;
  vitsorda_vb_1_V = mkV "vitsordar" ;
  vitta_vb_1_V = mkV "vittar" ;
  vittja_vb_1_V = mkV "vittjar" ;
  volma_vb_1_V = mkV "volmar" ;
  volontera_vb_1_V = mkV "volonterar" ;
  voltigera_vb_1_V = mkV "voltigerar" ;
  vomera_vb_1_V = mkV "vomerar" ;
  votera_vb_1_V = mkV "voterar" ;
  vraka_vb_1_V = mkV "vrakar" ;
  vricka_vb_1_V = mkV "vrickar" ;
  vraeka_vb_1_1_V = mkV "vräker" ;
  vraenga_vb_1_1_V = mkV "vränger" ;
  vraala_vb_1_1_V = mkV "vrålar" ;
  vraalplugga_vb_1_1_V = mkV "vrålpluggar" ;
  vroevla_vb_1_1_V = mkV "vrövlar" ;
  vula_vb_1_V = mkV "vular" ;
  vulka_vb_1_V = mkV "vulkar" ;
  vurma_vb_1_V = mkV "vurmar" ;
  vurpa_vb_1_V = mkV "vurpar" ;
  vyssa_vb_1_V = mkV "vyssar" ;
  vyssja_vb_1_V = mkV "vyssjar" ;
  vaecka_vb_1_1_V = mkV "väcker" ;
  vaega_vb_1_1_V = mkV "väger" ;
  vaega_vb_2_1_V = mkV "vägar" ;
  vaega_vb_3_13_V = mkV "väger" ;
  vaelfaegna_vb_1_1_V = mkV "välfägnar" ;
  vaella_vb_1_1_V = mkV "väller" ;
  vaelsigna_vb_1_1_V = mkV "välsignar" ;
  vaelsigne_vb_1_1_V = mkV "välsigne" ;
  vaelta_vb_2_1_V = mkV "vältar" ;
  vaelva_vb_1_1_V = mkV "välver" ;
  vaenda_vb_1_1_V = mkV "vänder" ;
  vaenda_vb_2_1_V = mkV "vänder" ;
  vaendsteka_vb_1_1_V = mkV "vändsteker" ;
  vaensterknaecka_vb_1_1_V = mkV "vänsterknäcker" ;
  vaensterprassla_vb_1_1_V = mkV "vänsterprasslar" ;
  vaenta_vb_1_1_V = mkV "väntar" ;
  vaepna_vb_1_1_V = mkV "väpnar" ;
  vaerka_vb_1_1_V = mkV "värker" ;
  vaerma_vb_1_1_V = mkV "värmer" ;
  vaerna_vb_1_1_V = mkV "värnar" ;
  vaerpa_vb_1_1_V = mkV "värper" ;
  vaerva_vb_1_1_V = mkV "värvar" ;
  vaesa_vb_1_1_V = mkV "väser" ;
  vaessa_vb_1_1_V = mkV "vässar" ;
  vaeta_vb_1_1_V = mkV "väter" ;
  vaetska_vb_1_1_V = mkV "vätskar" ;
  vaeva_vb_1_1_V = mkV "väver" ;
  vaexelverka_vb_1_1_V = mkV "växelverkar" ;
  vaexla_vb_1_1_V = mkV "växlar" ;
  vaaga_vb_1_1_V = mkV "vågar" ;
  vaaldgaesta_vb_1_1_V = mkV "våldgästar" ;
  vaalla_vb_1_1_V = mkV "vållar" ;
  vaalma_vb_1_1_V = mkV "vålmar" ;
  vaanna_vb_1_1_V = mkV "vånnar" ;
  vaara_vb_1_1_V = mkV "vårar" ;
  vaarda_vb_1_1_V = mkV "vårdar" ;
  vaardsloesa_vb_1_1_V = mkV "vårdslösar" ;
  vaatkola_vb_1_1_V = mkV "våtkolar" ;
  vaatpressa_vb_1_1_V = mkV "våtpressar" ;
  voerda_vb_1_1_V = mkV "vördar" ;
  x_a_vb_1_V = mkV "x-ar" ;
  xa_vb_1_V = mkV "x:ar" ;
  yla_vb_1_V = mkV "ylar" ;
  ympa_vb_1_V = mkV "ympar" ;
  yngla_vb_1_V = mkV "ynglar" ;
  ynka_vb_1_V = mkV "ynkar" ;
  yoga_vb_1_V = mkV "yogar" ;
  yppa_vb_1_V = mkV "yppar" ;
  yra_vb_1_V = mkV "yrar" ;
  yrka_vb_1_V = mkV "yrkar" ;
  yrkesarbeta_vb_1_V = mkV "yrkesarbetar" ;
  ysta_vb_1_V = mkV "ystar" ;
  zappa_vb_1_V = mkV "zappar" ;
  zooma_vb_1_V = mkV "zoomar" ;
  aeckla_vb_1_1_V = mkV "äcklar" ;
  aega_vb_1_1_V = mkV "äger" ;
  aega_vb_2_1_V = mkV "äger" ;
  aegna_vb_1_1_V = mkV "ägnar" ;
  aekta_vb_1_1_V = mkV "äktar" ;
  aelga_vb_1_1_V = mkV "älgar" ;
  aelska_vb_2_1_V = mkV "älskar" ;
  aelta_vb_1_1_V = mkV "ältar" ;
  aemna_vb_1_1_V = mkV "ämnar" ;
  aendvaenda_vb_1_1_V = mkV "ändvänder" ;
  aengsla_vb_1_1_V = mkV "ängslar" ;
  aentra_vb_1_1_V = mkV "äntrar" ;
  aera_vb_1_1_V = mkV "ärar" ;
  aerekraenka_vb_1_1_V = mkV "ärekränker" ;
  aerga_vb_1_1_V = mkV "ärgar" ;
  aerja_vb_1_1_V = mkV "ärjar" ;
  aerna_vb_1_1_V = mkV "ärnar" ;
  aerva_vb_1_1_V = mkV "ärver" ;
  aeska_vb_1_1_V = mkV "äskar" ;
  aeventyra_vb_1_1_V = mkV "äventyrar" ;
  aaberopa_vb_1_1_V = mkV "åberopar" ;
  aadoema_vb_1_1_V = mkV "ådömer" ;
  aaka_vb_1_1_V = mkV "åker" ;
  aakalla_vb_1_1_V = mkV "åkallar" ;
  aaklaga_vb_1_1_V = mkV "åklagar" ;
  aala_vb_1_1_V = mkV "ålar" ;
  aaldersbestaemma_vb_1_1_V = mkV "åldersbestämmer" ;
  aanga_vb_1_1_V = mkV "ångar" ;
  aangfoervaella_vb_1_1_V = mkV "ångförväller" ;
  aangra_vb_1_1_V = mkV "ångrar" ;
  aasamka_vb_1_1_V = mkV "åsamkar" ;
  aaska_vb_1_1_V = mkV "åskar" ;
  aaskaada_vb_1_1_V = mkV "åskådar" ;
  aastunda_vb_1_1_V = mkV "åstundar" ;
  aasyfta_vb_1_1_V = mkV "åsyftar" ;
  aatala_vb_1_1_V = mkV "åtalar" ;
  aateranlaenda_vb_1_1_V = mkV "återanländer" ;
  aateranskaffa_vb_1_1_V = mkV "återanskaffar" ;
  aateranvaenda_vb_1_1_V = mkV "återanvänder" ;
  aaterberaetta_vb_1_1_V = mkV "återberättar" ;
  aaterbesoeka_vb_1_1_V = mkV "återbesöker" ;
  aaterflytta_vb_1_1_V = mkV "återflyttar" ;
  aaterfoerena_vb_1_1_V = mkV "återförenar" ;
  aatergaelda_vb_1_1_V = mkV "återgäldar" ;
  aaterhaemta_vb_1_1_V = mkV "återhämtar" ;
  aaterkalla_vb_1_1_V = mkV "återkallar" ;
  aaterkasta_vb_1_1_V = mkV "återkastar" ;
  aaterklinga_vb_1_1_V = mkV "återklingar" ;
  aaterkraeva_vb_1_1_V = mkV "återkräver" ;
  aaterloesa_vb_1_1_V = mkV "återlöser" ;
  aaterropa_vb_1_1_V = mkV "återropar" ;
  aaterskalla_vb_1_1_V = mkV "återskallar" ;
  aaterskapa_vb_1_1_V = mkV "återskapar" ;
  aaterstudsa_vb_1_1_V = mkV "återstudsar" ;
  aaterstaella_vb_1_1_V = mkV "återställer" ;
  aatersaenda_vb_1_1_V = mkV "återsänder" ;
  aatertaaga_vb_1_1_V = mkV "återtågar" ;
  aateruppbygga_vb_1_1_V = mkV "återuppbygger" ;
  aateruppleva_vb_1_1_V = mkV "återupplever" ;
  aateruppliva_vb_1_1_V = mkV "återupplivar" ;
  aateruppraetta_vb_1_1_V = mkV "återupprättar" ;
  aateruppvaecka_vb_1_1_V = mkV "återuppväcker" ;
  aaterutstraala_vb_1_1_V = mkV "återutstrålar" ;
  aaterutsaenda_vb_1_1_V = mkV "återutsänder" ;
  aaterverka_vb_1_1_V = mkV "återverkar" ;
  aatervaenda_vb_1_1_V = mkV "återvänder" ;
  aatgaerda_vb_1_1_V = mkV "åtgärdar" ;
  aatraa_vb_1_1_V = mkV "åtrår" ;
  aatstrama_vb_1_1_V = mkV "åtstramar" ;
  aavila_vb_1_1_V = mkV "åvilar" ;
  oebo_vb_1_1_V = mkV "öbor" ;
  oedmjuka_vb_1_1_V = mkV "ödmjukar" ;
  oegna_vb_1_1_V = mkV "ögnar" ;
  oeka_vb_1_1_V = mkV "ökar" ;
  oeka_vb_2_1_V = mkV "ökar" ;
  oela_vb_1_1_V = mkV "ölar" ;
  oemka_vb_1_1_V = mkV "ömkar" ;
  oemma_vb_1_1_V = mkV "ömmar" ;
  oemsa_vb_1_1_V = mkV "ömsar" ;
  oenska_vb_1_1_V = mkV "önskar" ;
  oerfila_vb_1_1_V = mkV "örfilar" ;
  oerla_vb_1_1_V = mkV "örlar" ;
  oeronmaerka_vb_1_1_V = mkV "öronmärker" ;
  oesa_vb_1_1_V = mkV "öser" ;
  oesregna_vb_1_1_V = mkV "ösregnar" ;
  oeva_vb_1_1_V = mkV "övar" ;
  oeveranstraenga_vb_1_1_V = mkV "överanstränger" ;
  oeverantvarda_vb_1_1_V = mkV "överantvardar" ;
  oeveranvaenda_vb_1_1_V = mkV "överanvänder" ;
  oeverarbeta_vb_1_1_V = mkV "överarbetar" ;
  oeverbefolka_vb_1_1_V = mkV "överbefolkar" ;
  oeverbeskydda_vb_1_1_V = mkV "överbeskyddar" ;
  oeverbetona_vb_1_1_V = mkV "överbetonar" ;
  oeverbevisa_vb_1_1_V = mkV "överbevisar" ;
  oeverblicka_vb_1_1_V = mkV "överblickar" ;
  oeverboka_vb_1_1_V = mkV "överbokar" ;
  oeverbrygga_vb_1_1_V = mkV "överbryggar" ;
  oeverensstaemma_vb_1_1_V = mkV "överensstämmer" ;
  oeverflytta_vb_1_1_V = mkV "överflyttar" ;
  oeverfloeda_vb_1_1_V = mkV "överflödar" ;
  oeverglaensa_vb_1_1_V = mkV "överglänser" ;
  oeverhetta_vb_1_1_V = mkV "överhettar" ;
  oeverhopa_vb_1_1_V = mkV "överhopar" ;
  oeverhoppa_vb_1_1_V = mkV "överhoppar" ;
  oeverklaga_vb_1_1_V = mkV "överklagar" ;
  oeverlappa_vb_1_1_V = mkV "överlappar" ;
  oeverlasta_vb_1_1_V = mkV "överlastar" ;
  oeverleva_vb_1_1_V = mkV "överlever" ;
  oeverlista_vb_1_1_V = mkV "överlistar" ;
  oevermanna_vb_1_1_V = mkV "övermannar" ;
  oevernatta_vb_1_1_V = mkV "övernattar" ;
  oeverproeva_vb_1_1_V = mkV "överprövar" ;
  oeverraecka_vb_1_1_V = mkV "överräcker" ;
  oeverroesta_vb_1_1_V = mkV "överröstar" ;
  oeverskatta_vb_1_1_V = mkV "överskattar" ;
  oeverskugga_vb_1_1_V = mkV "överskuggar" ;
  oeverskygga_vb_1_1_V = mkV "överskyggar" ;
  oeverskyla_vb_1_1_V = mkV "överskyler" ;
  oeverskaada_vb_1_1_V = mkV "överskådar" ;
  oeversaenda_vb_1_1_V = mkV "översänder" ;
  oevertala_vb_1_1_V = mkV "övertalar" ;
  oeverteckna_vb_1_1_V = mkV "övertecknar" ;
  oevertrumfa_vb_1_1_V = mkV "övertrumfar" ;
  oevertraeffa_vb_1_1_V = mkV "överträffar" ;
  oevertyga_vb_1_1_V = mkV "övertygar" ;
  oevervaka_vb_1_1_V = mkV "övervakar" ;
  oevervaega_vb_1_1_V = mkV "överväger" ;
  oevervaega_vb_2_1_V = mkV "överväger" ;
  oevervaeldiga_vb_1_1_V = mkV "överväldigar" ;
  oeveroesa_vb_1_1_V = mkV "överöser" ;
  DNA_testa_vb_1_V = mkV "DNA-testar" ;
  GPS_a_vb_1_V = mkV "GPS-ar" ;
  GPSa_vb_1_V = mkV "GPSar" ;
  GPSa_vb_2_V = mkV "GPS:ar" ;
  OCR_a_vb_1_V = mkV "OCR-ar" ;
  OCRa_vb_1_V = mkV "OCR:ar" ;
  abbreviera_vb_1_V = mkV "abbrevierar" ;
  abdikera_vb_1_V = mkV "abdikerar" ;
  abonnera_vb_1_V = mkV "abonnerar" ;
  abortera_vb_1_V = mkV "aborterar" ;
  abradera_vb_1_V = mkV "abraderar" ;
  absolvera_vb_1_V = mkV "absolverar" ;
  absorbera_vb_1_V = mkV "absorberar" ;
  absorbera_vb_2_V = mkV "absorberar" ;
  abstrahera_vb_1_V = mkV "abstraherar" ;
  accedera_vb_1_V = mkV "accederar" ;
  accelerera_vb_2_V = mkV "accelererar" ;
  accentuera_vb_1_V = mkV "accentuerar" ;
  acceptera_vb_1_V = mkV "accepterar" ;
  accessa_vb_1_V = mkV "accessar" ;
  acklimatisera_vb_1_V = mkV "acklimatiserar" ;
  ackommodera_vb_1_V = mkV "ackommoderar" ;
  ackompanjera_vb_1_V = mkV "ackompanjerar" ;
  ackordera_vb_1_V = mkV "ackorderar" ;
  ackreditera_vb_1_V = mkV "ackrediterar" ;
  ackumulera_vb_1_V = mkV "ackumulerar" ;
  ackvirera_vb_1_V = mkV "ackvirerar" ;
  adaptera_vb_1_V = mkV "adapterar" ;
  addera_vb_1_V = mkV "adderar" ;
  adjungera_vb_1_V = mkV "adjungerar" ;
  adla_vb_1_V = mkV "adlar" ;
  administrera_vb_1_V = mkV "administrerar" ;
  adoptera_vb_1_V = mkV "adopterar" ;
  adressera_vb_1_V = mkV "adresserar" ;
  adsorbera_vb_1_V = mkV "adsorberar" ;
  aducera_vb_1_V = mkV "aducerar" ;
  advocera_vb_1_V = mkV "advocerar" ;
  afficiera_vb_1_V = mkV "afficierar" ;
  affinera_vb_1_V = mkV "affinerar" ;
  affischera_vb_1_V = mkV "affischerar" ;
  afrikanisera_vb_1_V = mkV "afrikaniserar" ;
  aga_vb_1_V = mkV "agar" ;
  agera_vb_2_V = mkV "agerar" ;
  agglomerera_vb_1_V = mkV "agglomererar" ;
  agglutinera_vb_1_V = mkV "agglutinerar" ;
  aggravera_vb_1_V = mkV "aggraverar" ;
  agitera_vb_1_V = mkV "agiterar" ;
  agna_vb_1_V = mkV "agnar" ;
  ajournera_vb_1_V = mkV "ajournerar" ;
  akta_vb_2_V = mkV "aktar" ;
  aktivera_vb_1_V = mkV "aktiverar" ;
  aktualisera_vb_1_V = mkV "aktualiserar" ;
  alarmera_vb_1_V = mkV "alarmerar" ;
  alfabetisera_vb_1_V = mkV "alfabetiserar" ;
  alienera_vb_1_V = mkV "alienerar" ;
  allegorisera_vb_1_V = mkV "allegoriserar" ;
  alliera_vb_1_V = mkV "allierar" ;
  allitterera_vb_1_V = mkV "allittererar" ;
  allmaenbilda_vb_1_1_V = mkV "allmänbildar" ;
  allokera_vb_1_V = mkV "allokerar" ;
  alludera_vb_1_V = mkV "alluderar" ;
  alternera_vb_1_V = mkV "alternerar" ;
  aluminera_vb_1_V = mkV "aluminerar" ;
  alvluckra_vb_1_V = mkV "alvluckrar" ;
  amalgamera_vb_1_V = mkV "amalgamerar" ;
  ambulera_vb_1_V = mkV "ambulerar" ;
  amerikanisera_vb_1_V = mkV "amerikaniserar" ;
  amma_vb_1_V = mkV "ammar" ;
  amortera_vb_1_V = mkV "amorterar" ;
  amplifiera_vb_1_V = mkV "amplifierar" ;
  amplitudmodulera_vb_1_V = mkV "amplitudmodulerar" ;
  amputera_vb_1_V = mkV "amputerar" ;
  ana_vb_1_V = mkV "anar" ;
  analysera_vb_1_V = mkV "analyserar" ;
  anamma_vb_1_V = mkV "anammar" ;
  anfaekta_vb_1_1_V = mkV "anfäktar" ;
  anglisera_vb_1_V = mkV "angliserar" ;
  anhopa_vb_1_V = mkV "anhopar" ;
  animera_vb_1_V = mkV "animerar" ;
  anklaga_vb_1_V = mkV "anklagar" ;
  ankra_vb_1_V = mkV "ankrar" ;
  anlita_vb_1_V = mkV "anlitar" ;
  anmana_vb_1_V = mkV "anmanar" ;
  anmoda_vb_1_V = mkV "anmodar" ;
  annektera_vb_1_V = mkV "annekterar" ;
  annihilera_vb_1_V = mkV "annihilerar" ;
  annonsera_vb_1_V = mkV "annonserar" ;
  annotera_vb_1_V = mkV "annoterar" ;
  annullera_vb_1_V = mkV "annullerar" ;
  anodisera_vb_1_V = mkV "anodiserar" ;
  anonymisera_vb_1_V = mkV "anonymiserar" ;
  anordna_vb_1_V = mkV "anordnar" ;
  anpassa_vb_1_V = mkV "anpassar" ;
  anrika_vb_1_V = mkV "anrikar" ;
  anropa_vb_1_V = mkV "anropar" ;
  anraetta_vb_1_1_V = mkV "anrättar" ;
  ansa_vb_1_V = mkV "ansar" ;
  ansamla_vb_1_V = mkV "ansamlar" ;
  anskaffa_vb_1_V = mkV "anskaffar" ;
  anspela_vb_1_V = mkV "anspelar" ;
  anstifta_vb_1_V = mkV "anstiftar" ;
  anstorma_vb_1_V = mkV "anstormar" ;
  antasta_vb_1_V = mkV "antastar" ;
  antecipera_vb_1_V = mkV "anteciperar" ;
  anteckna_vb_1_V = mkV "antecknar" ;
  antedatera_vb_1_V = mkV "antedaterar" ;
  antichambrera_vb_1_V = mkV "antichambrerar" ;
  antikbehandla_vb_1_V = mkV "antikbehandlar" ;
  antikfynda_vb_1_V = mkV "antikfyndar" ;
  antikisera_vb_1_V = mkV "antikiserar" ;
  antireflexbehandla_vb_1_V = mkV "antireflexbehandlar" ;
  antraeffa_vb_1_1_V = mkV "anträffar" ;
  antvarda_vb_1_V = mkV "antvardar" ;
  antaaga_vb_1_1_V = mkV "antågar" ;
  anvisa_vb_1_V = mkV "anvisar" ;
  apostrofera_vb_1_V = mkV "apostroferar" ;
  appellera_vb_1_V = mkV "appellerar" ;
  applicera_vb_1_V = mkV "applicerar" ;
  applaadera_vb_1_1_V = mkV "applåderar" ;
  apportera_vb_1_V = mkV "apporterar" ;
  appreciera_vb_1_V = mkV "apprecierar" ;
  appretera_vb_1_V = mkV "appreterar" ;
  approchera_vb_1_V = mkV "approcherar" ;
  approximera_vb_1_V = mkV "approximerar" ;
  aptera_vb_1_V = mkV "apterar" ;
  arbeta_vb_1_V = mkV "arbetar" ;
  arbetspendla_vb_1_V = mkV "arbetspendlar" ;
  arborra_vb_1_V = mkV "arborrar" ;
  argumentera_vb_1_V = mkV "argumenterar" ;
  arkaisera_vb_1_V = mkV "arkaiserar" ;
  arkebusera_vb_1_V = mkV "arkebuserar" ;
  arkivera_vb_1_V = mkV "arkiverar" ;
  armera_vb_1_V = mkV "armerar" ;
  arra_vb_1_V = mkV "arrar" ;
  arrangera_vb_1_V = mkV "arrangerar" ;
  arrendera_vb_1_V = mkV "arrenderar" ;
  arrestera_vb_1_V = mkV "arresterar" ;
  arrondera_vb_1_V = mkV "arronderar" ;
  artikulera_vb_1_V = mkV "artikulerar" ;
  arvodera_vb_1_V = mkV "arvoderar" ;
  asfaltera_vb_1_V = mkV "asfalterar" ;
  aska_vb_1_V = mkV "askar" ;
  aspirera_vb_1_V = mkV "aspirerar" ;
  assignera_vb_1_V = mkV "assignerar" ;
  assimilera_vb_1_V = mkV "assimilerar" ;
  assistera_vb_1_V = mkV "assisterar" ;
  associera_vb_1_V = mkV "associerar" ;
  assurera_vb_1_V = mkV "assurerar" ;
  atombomba_vb_1_V = mkV "atombombar" ;
  atrofiera_vb_1_V = mkV "atrofierar" ;
  attackera_vb_1_V = mkV "attackerar" ;
  attestera_vb_1_V = mkV "attesterar" ;
  attrahera_vb_1_V = mkV "attraherar" ;
  attrappera_vb_1_V = mkV "attrapperar" ;
  attribuera_vb_1_V = mkV "attribuerar" ;
  auktionera_vb_1_V = mkV "auktionerar" ;
  auktorisera_vb_1_V = mkV "auktoriserar" ;
  auskultera_vb_1_V = mkV "auskulterar" ;
  autenticera_vb_1_V = mkV "autenticerar" ;
  autentifiera_vb_1_V = mkV "autentifierar" ;
  autentisera_vb_1_V = mkV "autentiserar" ;
  automatisera_vb_1_V = mkV "automatiserar" ;
  ava_vb_1_V = mkV "avar" ;
  avancera_vb_1_V = mkV "avancerar" ;
  avannonsera_vb_1_V = mkV "avannonserar" ;
  avbalka_vb_1_V = mkV "avbalkar" ;
  avbarka_vb_1_V = mkV "avbarkar" ;
  avbeta_vb_1_V = mkV "avbetar" ;
  avbetala_vb_1_V = mkV "avbetalar" ;
  avbilda_vb_1_V = mkV "avbildar" ;
  avboka_vb_1_V = mkV "avbokar" ;
  avboerda_vb_1_1_V = mkV "avbördar" ;
  avdela_vb_1_V = mkV "avdelar" ;
  avdramatisera_vb_1_V = mkV "avdramatiserar" ;
  avdunsta_vb_1_V = mkV "avdunstar" ;
  avfatta_vb_1_V = mkV "avfattar" ;
  avfetta_vb_1_V = mkV "avfettar" ;
  avflytta_vb_1_V = mkV "avflyttar" ;
  avfolka_vb_1_V = mkV "avfolkar" ;
  avfordra_vb_1_V = mkV "avfordrar" ;
  avfrosta_vb_1_V = mkV "avfrostar" ;
  avfukta_vb_1_V = mkV "avfuktar" ;
  avfyra_vb_1_V = mkV "avfyrar" ;
  avfaerda_vb_1_1_V = mkV "avfärdar" ;
  avgifta_vb_1_V = mkV "avgiftar" ;
  avgraensa_vb_1_1_V = mkV "avgränsar" ;
  avguda_vb_1_V = mkV "avgudar" ;
  avgaerda_vb_1_1_V = mkV "avgärdar" ;
  avhandla_vb_1_V = mkV "avhandlar" ;
  avhumanisera_vb_1_V = mkV "avhumaniserar" ;
  avhaemta_vb_1_1_V = mkV "avhämtar" ;
  avhaerda_vb_1_1_V = mkV "avhärdar" ;
  avhoesta_vb_1_1_V = mkV "avhöstar" ;
  avisa_vb_1_V = mkV "avisar" ;
  avisera_vb_1_V = mkV "aviserar" ;
  avjaga_vb_1_V = mkV "avjagar" ;
  avjaemna_vb_1_1_V = mkV "avjämnar" ;
  avkalka_vb_1_V = mkV "avkalkar" ;
  avklara_vb_2_V = mkV "avklarar" ;
  avklinga_vb_1_V = mkV "avklingar" ;
  avknoppa_vb_1_V = mkV "avknoppar" ;
  avkoda_vb_1_V = mkV "avkodar" ;
  avkolonisera_vb_1_V = mkV "avkoloniserar" ;
  avkoppla_vb_1_V = mkV "avkopplar" ;
  avkorta_vb_1_V = mkV "avkortar" ;
  avkriminalisera_vb_1_V = mkV "avkriminaliserar" ;
  avkristna_vb_1_V = mkV "avkristnar" ;
  avkunna_vb_1_V = mkV "avkunnar" ;
  avkoena_vb_1_1_V = mkV "avkönar" ;
  avla_vb_1_V = mkV "avlar" ;
  avlagra_vb_1_V = mkV "avlagrar" ;
  avlasta_vb_1_V = mkV "avlastar" ;
  avleverera_vb_1_V = mkV "avlevererar" ;
  avliva_vb_1_V = mkV "avlivar" ;
  avlocka_vb_1_V = mkV "avlockar" ;
  avlossa_vb_1_V = mkV "avlossar" ;
  avlusa_vb_1_V = mkV "avlusar" ;
  avluta_vb_1_V = mkV "avlutar" ;
  avlyssna_vb_1_V = mkV "avlyssnar" ;
  avlaegsna_vb_1_1_V = mkV "avlägsnar" ;
  avlaemna_vb_1_1_V = mkV "avlämnar" ;
  avlaenka_vb_1_1_V = mkV "avlänkar" ;
  avloena_vb_1_1_V = mkV "avlönar" ;
  avloeva_vb_1_1_V = mkV "avlövar" ;
  avmagnetisera_vb_1_V = mkV "avmagnetiserar" ;
  avmaska_vb_1_V = mkV "avmaskar" ;
  avmasta_vb_1_V = mkV "avmastar" ;
  avmatta_vb_1_V = mkV "avmattar" ;
  avmystifiera_vb_1_V = mkV "avmystifierar" ;
  avnavla_vb_1_V = mkV "avnavlar" ;
  avnazifiera_vb_1_V = mkV "avnazifierar" ;
  avpassa_vb_1_V = mkV "avpassar" ;
  avpatrullera_vb_1_V = mkV "avpatrullerar" ;
  avpersonifiera_vb_1_V = mkV "avpersonifierar" ;
  avplana_vb_1_V = mkV "avplanar" ;
  avpolitisera_vb_1_V = mkV "avpolitiserar" ;
  avpollettera_vb_1_V = mkV "avpolletterar" ;
  avportraettera_vb_1_1_V = mkV "avporträtterar" ;
  avpressa_vb_1_V = mkV "avpressar" ;
  avradikalisera_vb_1_V = mkV "avradikaliserar" ;
  avreagera_vb_1_V = mkV "avreagerar" ;
  avregistrera_vb_1_V = mkV "avregistrerar" ;
  avreglera_vb_1_V = mkV "avreglerar" ;
  avromantisera_vb_1_V = mkV "avromantiserar" ;
  avrunda_vb_1_V = mkV "avrundar" ;
  avrusta_vb_1_V = mkV "avrustar" ;
  avraekna_vb_1_1_V = mkV "avräknar" ;
  avraetta_vb_1_1_V = mkV "avrättar" ;
  avsalta_vb_1_V = mkV "avsaltar" ;
  avsegla_vb_1_V = mkV "avseglar" ;
  avskaffa_vb_1_V = mkV "avskaffar" ;
  avskeda_vb_1_V = mkV "avskedar" ;
  avskaerma_vb_1_1_V = mkV "avskärmar" ;
  avslipa_vb_1_V = mkV "avslipar" ;
  avsluta_vb_1_V = mkV "avslutar" ;
  avsloeja_vb_1_1_V = mkV "avslöjar" ;
  avsmaka_vb_1_V = mkV "avsmakar" ;
  avsmalna_vb_1_V = mkV "avsmalnar" ;
  avsnoppa_vb_1_V = mkV "avsnoppar" ;
  avsocialisera_vb_1_V = mkV "avsocialiserar" ;
  avsomna_vb_1_V = mkV "avsomnar" ;
  avspegla_vb_1_V = mkV "avspeglar" ;
  avspela_vb_1_V = mkV "avspelar" ;
  avspisa_vb_1_V = mkV "avspisar" ;
  avspaerra_vb_1_1_V = mkV "avspärrar" ;
  avstalinisera_vb_1_V = mkV "avstaliniserar" ;
  avstanna_vb_1_V = mkV "avstannar" ;
  avstava_vb_1_V = mkV "avstavar" ;
  avstressa_vb_1_V = mkV "avstressar" ;
  avstycka_vb_1_V = mkV "avstyckar" ;
  avsvalna_vb_1_V = mkV "avsvalnar" ;
  avsvavla_vb_1_V = mkV "avsvavlar" ;
  avsyna_vb_1_V = mkV "avsynar" ;
  avsaaga_vb_1_1_V = mkV "avsågar" ;
  avsoendra_vb_1_1_V = mkV "avsöndrar" ;
  avtacka_vb_1_V = mkV "avtackar" ;
  avtala_vb_1_V = mkV "avtalar" ;
  avtappa_vb_1_V = mkV "avtappar" ;
  avteckna_vb_1_V = mkV "avtecknar" ;
  avtjaena_vb_1_1_V = mkV "avtjänar" ;
  avtona_vb_1_V = mkV "avtonar" ;
  avtrappa_vb_1_V = mkV "avtrappar" ;
  avtrubba_vb_1_V = mkV "avtrubbar" ;
  avtunna_vb_1_V = mkV "avtunnar" ;
  avtaaga_vb_1_1_V = mkV "avtågar" ;
  avvakta_vb_1_V = mkV "avvaktar" ;
  avvattna_vb_1_V = mkV "avvattnar" ;
  avveckla_vb_1_V = mkV "avvecklar" ;
  avverka_vb_1_V = mkV "avverkar" ;
  avvisa_vb_1_V = mkV "avvisar" ;
  avvita_vb_1_V = mkV "avvitar" ;
  avvittra_vb_1_V = mkV "avvittrar" ;
  avvaepna_vb_1_1_V = mkV "avväpnar" ;
  avyttra_vb_1_V = mkV "avyttrar" ;
  axa_vb_1_V = mkV "axar" ;
  axiomatisera_vb_1_V = mkV "axiomatiserar" ;
  axla_vb_1_V = mkV "axlar" ;
  backa_vb_1_V = mkV "backar" ;
  backupa_vb_1_V = mkV "backupar" ;
  backuppa_vb_1_V = mkV "backuppar" ;
  bada_vb_1_V = mkV "badar" ;
  badda_vb_1_V = mkV "baddar" ;
  bagatellisera_vb_1_V = mkV "bagatelliserar" ;
  baggboela_vb_1_1_V = mkV "baggbölar" ;
  baissa_vb_1_V = mkV "baissar" ;
  bajsa_vb_1_V = mkV "bajsar" ;
  baka_vb_1_V = mkV "bakar" ;
  bakdanta_vb_1_V = mkV "bakdantar" ;
  baktala_vb_1_V = mkV "baktalar" ;
  bala_vb_1_V = mkV "balar" ;
  balansera_vb_2_V = mkV "balanserar" ;
  ballotera_vb_1_V = mkV "balloterar" ;
  balsamera_vb_1_V = mkV "balsamerar" ;
  banalisera_vb_1_V = mkV "banaliserar" ;
  banda_vb_1_V = mkV "bandar" ;
  banka_vb_1_V = mkV "bankar" ;
  bankruttera_vb_1_V = mkV "bankrutterar" ;
  banna_vb_1_V = mkV "bannar" ;
  banta_vb_2_V = mkV "bantar" ;
  barka_vb_1_V = mkV "barkar" ;
  barkympa_vb_1_V = mkV "barkympar" ;
  barlasta_vb_1_V = mkV "barlastar" ;
  barra_vb_1_V = mkV "barrar" ;
  barrikadera_vb_1_V = mkV "barrikaderar" ;
  basera_vb_1_V = mkV "baserar" ;
  basta_vb_1_V = mkV "bastar" ;
  baxa_vb_1_V = mkV "baxar" ;
  beakta_vb_1_V = mkV "beaktar" ;
  bearbeta_vb_1_V = mkV "bearbetar" ;
  beatifiera_vb_1_V = mkV "beatifierar" ;
  bebaada_vb_1_1_V = mkV "bebådar" ;
  becka_vb_1_V = mkV "beckar" ;
  bedarra_vb_1_V = mkV "bedarrar" ;
  bedroeva_vb_1_1_V = mkV "bedrövar" ;
  bedyra_vb_1_V = mkV "bedyrar" ;
  bedaara_vb_1_1_V = mkV "bedårar" ;
  bedoeva_vb_1_1_V = mkV "bedövar" ;
  beediga_vb_1_V = mkV "beedigar" ;
  befara_vb_1_V = mkV "befarar" ;
  beflaecka_vb_1_1_V = mkV "befläckar" ;
  befolka_vb_1_V = mkV "befolkar" ;
  befordra_vb_1_V = mkV "befordrar" ;
  befrakta_vb_1_V = mkV "befraktar" ;
  befria_vb_1_V = mkV "befriar" ;
  befrukta_vb_1_V = mkV "befruktar" ;
  befrynda_vb_1_V = mkV "befryndar" ;
  befraemja_vb_1_1_V = mkV "befrämjar" ;
  befullmaektiga_vb_1_1_V = mkV "befullmäktigar" ;
  begabba_vb_1_V = mkV "begabbar" ;
  begagna_vb_1_V = mkV "begagnar" ;
  begapa_vb_1_V = mkV "begapar" ;
  begrunda_vb_1_V = mkV "begrundar" ;
  begraensa_vb_1_1_V = mkV "begränsar" ;
  begaava_vb_1_1_V = mkV "begåvar" ;
  behandla_vb_1_V = mkV "behandlar" ;
  behaerska_vb_1_1_V = mkV "behärskar" ;
  beivra_vb_1_V = mkV "beivrar" ;
  bejaka_vb_1_V = mkV "bejakar" ;
  bejubla_vb_1_V = mkV "bejublar" ;
  bekaja_vb_1_V = mkV "bekajar" ;
  bekika_vb_1_V = mkV "bekikar" ;
  beklaga_vb_1_V = mkV "beklagar" ;
  bekosta_vb_1_V = mkV "bekostar" ;
  bekransa_vb_1_V = mkV "bekransar" ;
  bekriga_vb_1_V = mkV "bekrigar" ;
  bekraefta_vb_1_1_V = mkV "bekräftar" ;
  bekymra_vb_1_V = mkV "bekymrar" ;
  bekaempa_vb_1_1_V = mkV "bekämpar" ;
  belamra_vb_1_V = mkV "belamrar" ;
  belasta_vb_1_V = mkV "belastar" ;
  beledsaga_vb_1_V = mkV "beledsagar" ;
  belaegra_vb_1_1_V = mkV "belägrar" ;
  belaana_vb_1_1_V = mkV "belånar" ;
  beloena_vb_1_1_V = mkV "belönar" ;
  bemanna_vb_1_V = mkV "bemannar" ;
  bemantla_vb_1_V = mkV "bemantlar" ;
  bemedla_vb_1_V = mkV "bemedlar" ;
  bemyndiga_vb_1_V = mkV "bemyndigar" ;
  bemaestra_vb_1_1_V = mkV "bemästrar" ;
  bena_vb_1_V = mkV "benar" ;
  benaada_vb_1_1_V = mkV "benådar" ;
  beordra_vb_1_V = mkV "beordrar" ;
  bepansra_vb_1_V = mkV "bepansrar" ;
  beprisa_vb_1_V = mkV "beprisar" ;
  bepudra_vb_1_V = mkV "bepudrar" ;
  berika_vb_1_V = mkV "berikar" ;
  beriktiga_vb_1_V = mkV "beriktigar" ;
  berusa_vb_1_V = mkV "berusar" ;
  beraekna_vb_1_1_V = mkV "beräknar" ;
  beraetta_vb_1_1_V = mkV "berättar" ;
  beraettiga_vb_1_1_V = mkV "berättigar" ;
  beroeva_vb_1_1_V = mkV "berövar" ;
  besanna_vb_1_V = mkV "besannar" ;
  besegla_vb_1_V = mkV "beseglar" ;
  besegra_vb_1_V = mkV "besegrar" ;
  besiktiga_vb_1_V = mkV "besiktigar" ;
  besinna_vb_1_V = mkV "besinnar" ;
  besjaela_vb_1_1_V = mkV "besjälar" ;
  beskatta_vb_1_V = mkV "beskattar" ;
  beskicka_vb_1_V = mkV "beskickar" ;
  beskugga_vb_1_V = mkV "beskuggar" ;
  beskydda_vb_1_V = mkV "beskyddar" ;
  beskaerma_vb_1_1_V = mkV "beskärmar" ;
  beskaada_vb_1_1_V = mkV "beskådar" ;
  besloeja_vb_1_1_V = mkV "beslöjar" ;
  besmitta_vb_1_V = mkV "besmittar" ;
  besockra_vb_1_V = mkV "besockrar" ;
  besolda_vb_1_V = mkV "besoldar" ;
  bespeja_vb_1_V = mkV "bespejar" ;
  bespisa_vb_1_V = mkV "bespisar" ;
  bespola_vb_1_V = mkV "bespolar" ;
  bespotta_vb_1_V = mkV "bespottar" ;
  bespruta_vb_1_V = mkV "besprutar" ;
  bestorma_vb_1_V = mkV "bestormar" ;
  bestraffa_vb_1_V = mkV "bestraffar" ;
  bestraala_vb_1_1_V = mkV "bestrålar" ;
  bestycka_vb_1_V = mkV "bestyckar" ;
  besudla_vb_1_V = mkV "besudlar" ;
  besvara_vb_1_V = mkV "besvarar" ;
  besvaera_vb_1_1_V = mkV "besvärar" ;
  beta_vb_1_V = mkV "betar" ;
  betalningssaekra_vb_1_1_V = mkV "betalningssäkrar" ;
  beteckna_vb_1_V = mkV "betecknar" ;
  betinga_vb_1_V = mkV "betingar" ;
  betitla_vb_1_V = mkV "betitlar" ;
  betitta_vb_1_V = mkV "betittar" ;
  betjaena_vb_1_1_V = mkV "betjänar" ;
  betona_vb_1_V = mkV "betonar" ;
  betongera_vb_1_V = mkV "betongerar" ;
  betrakta_vb_1_V = mkV "betraktar" ;
  betrygga_vb_1_V = mkV "betryggar" ;
  betraeffa_vb_1_1_V = mkV "beträffar" ;
  betsa_vb_1_V = mkV "betsar" ;
  betsla_vb_1_V = mkV "betslar" ;
  betunga_vb_1_V = mkV "betungar" ;
  betvivla_vb_1_V = mkV "betvivlar" ;
  betyga_vb_1_V = mkV "betygar" ;
  beundra_vb_1_V = mkV "beundrar" ;
  bevaka_vb_1_V = mkV "bevakar" ;
  bevara_vb_1_V = mkV "bevarar" ;
  bevattna_vb_1_V = mkV "bevattnar" ;
  bevilja_vb_1_V = mkV "beviljar" ;
  bevisa_vb_1_V = mkV "bevisar" ;
  bevista_vb_1_V = mkV "bevistar" ;
  bevittna_vb_1_V = mkV "bevittnar" ;
  bevaepna_vb_1_1_V = mkV "beväpnar" ;
  bevaera_vb_1_1_V = mkV "bevärar" ;
  bevaerdiga_vb_1_1_V = mkV "bevärdigar" ;
  bida_vb_1_V = mkV "bidar" ;
  bifoga_vb_1_V = mkV "bifogar" ;
  bikta_vb_1_V = mkV "biktar" ;
  bila_vb_1_V = mkV "bilar" ;
  bilda_vb_1_V = mkV "bildar" ;
  biografera_vb_1_V = mkV "biograferar" ;
  bissera_vb_1_V = mkV "bisserar" ;
  bita_vb_2_V = mkV "bitar" ;
  bivackera_vb_1_V = mkV "bivackerar" ;
  bjussa_vb_1_V = mkV "bjussar" ;
  bjoerna_vb_1_1_V = mkV "björnar" ;
  blada_vb_1_V = mkV "bladar" ;
  blanchera_vb_1_V = mkV "blancherar" ;
  blanda_vb_1_V = mkV "blandar" ;
  blanka_vb_1_V = mkV "blankar" ;
  blankpolera_vb_1_V = mkV "blankpolerar" ;
  blekna_vb_1_V = mkV "bleknar" ;
  blessera_vb_1_V = mkV "blesserar" ;
  blidka_vb_1_V = mkV "blidkar" ;
  blindera_vb_1_V = mkV "blinderar" ;
  blindpressa_vb_1_V = mkV "blindpressar" ;
  blinga_vb_1_V = mkV "blingar" ;
  blixtfotografera_vb_1_V = mkV "blixtfotograferar" ;
  blixtinkalla_vb_1_V = mkV "blixtinkallar" ;
  blocka_vb_1_V = mkV "blockar" ;
  blockera_vb_1_V = mkV "blockerar" ;
  bloda_vb_1_V = mkV "blodar" ;
  blogga_vb_1_V = mkV "bloggar" ;
  blommografera_vb_1_V = mkV "blommograferar" ;
  blomstersmycka_vb_1_V = mkV "blomstersmyckar" ;
  blondera_vb_1_V = mkV "blonderar" ;
  blotta_vb_1_V = mkV "blottar" ;
  bluffa_vb_1_V = mkV "bluffar" ;
  blya_vb_1_V = mkV "blyar" ;
  blaecka_vb_1_1_V = mkV "bläckar" ;
  blaeda_vb_1_1_V = mkV "blädar" ;
  blaenda_vb_1_1_V = mkV "bländar" ;
  blaesta_vb_1_1_V = mkV "blästar" ;
  blaakopiera_vb_1_1_V = mkV "blåkopierar" ;
  boasera_vb_1_V = mkV "boaserar" ;
  bobba_vb_1_V = mkV "bobbar" ;
  bocka_vb_1_V = mkV "bockar" ;
  bogsera_vb_1_V = mkV "bogserar" ;
  bojkotta_vb_1_V = mkV "bojkottar" ;
  boka_vb_1_V = mkV "bokar" ;
  bokstavera_vb_1_V = mkV "bokstaverar" ;
  bolla_vb_1_V = mkV "bollar" ;
  bomba_vb_1_V = mkV "bombar" ;
  bombardera_vb_1_V = mkV "bombarderar" ;
  bomma_vb_1_V = mkV "bommar" ;
  bona_vb_1_V = mkV "bonar" ;
  bondneka_vb_1_V = mkV "bondnekar" ;
  bonga_vb_1_V = mkV "bongar" ;
  bonitera_vb_1_V = mkV "boniterar" ;
  boota_vb_1_V = mkV "bootar" ;
  borda_vb_1_V = mkV "bordar" ;
  borga_vb_1_V = mkV "borgar" ;
  borra_vb_1_V = mkV "borrar" ;
  borsta_vb_1_V = mkV "borstar" ;
  bortmontera_vb_1_V = mkV "bortmonterar" ;
  bortresonera_vb_1_V = mkV "bortresonerar" ;
  bortroeva_vb_1_1_V = mkV "bortrövar" ;
  bortskaffa_vb_1_V = mkV "bortskaffar" ;
  bota_vb_1_V = mkV "botar" ;
  bottenreva_vb_1_V = mkV "bottenrevar" ;
  bottenskrapa_vb_1_V = mkV "bottenskrapar" ;
  boxa_vb_1_V = mkV "boxar" ;
  brandhaerja_vb_1_1_V = mkV "brandhärjar" ;
  brandskatta_vb_1_V = mkV "brandskattar" ;
  brassa_vb_1_V = mkV "brassar" ;
  bredda_vb_1_V = mkV "breddar" ;
  bremsa_vb_1_V = mkV "bremsar" ;
  brevvaexla_vb_1_1_V = mkV "brevväxlar" ;
  briefa_vb_1_V = mkV "briefar" ;
  brikettera_vb_1_V = mkV "briketterar" ;
  brisera_vb_1_V = mkV "briserar" ;
  broa_vb_1_V = mkV "broar" ;
  brodda_vb_1_V = mkV "broddar" ;
  brodera_vb_1_V = mkV "broderar" ;
  bromera_vb_1_V = mkV "bromerar" ;
  bromsa_vb_1_V = mkV "bromsar" ;
  bronsera_vb_1_V = mkV "bronserar" ;
  broschera_vb_1_V = mkV "broscherar" ;
  brotscha_vb_1_V = mkV "brotschar" ;
  bruka_vb_1_V = mkV "brukar" ;
  brunera_vb_1_V = mkV "brunerar" ;
  brunfaerga_vb_1_1_V = mkV "brunfärgar" ;
  brutalisera_vb_1_V = mkV "brutaliserar" ;
  braeda_vb_1_1_V = mkV "brädar" ;
  braedda_vb_1_1_V = mkV "bräddar" ;
  braedfodra_vb_1_1_V = mkV "brädfodrar" ;
  braedsegla_vb_1_1_V = mkV "brädseglar" ;
  braema_vb_1_1_V = mkV "brämar" ;
  braennlackera_vb_1_1_V = mkV "brännlackerar" ;
  braennskada_vb_1_1_V = mkV "brännskadar" ;
  braesera_vb_1_1_V = mkV "bräserar" ;
  braaka_vb_2_1_V = mkV "bråkar" ;
  broea_vb_1_1_V = mkV "bröar" ;
  broeda_vb_1_1_V = mkV "brödar" ;
  bubba_vb_1_V = mkV "bubbar" ;
  buda_vb_1_V = mkV "budar" ;
  budgetera_vb_1_V = mkV "budgeterar" ;
  buffa_vb_1_V = mkV "buffar" ;
  buklanda_vb_1_V = mkV "buklandar" ;
  bulta_vb_1_V = mkV "bultar" ;
  bunta_vb_1_V = mkV "buntar" ;
  burka_vb_1_V = mkV "burkar" ;
  buska_vb_1_V = mkV "buskar" ;
  bussa_vb_1_V = mkV "bussar" ;
  buteljera_vb_1_V = mkV "buteljerar" ;
  byraakratisera_vb_1_1_V = mkV "byråkratiserar" ;
  baedda_vb_1_1_V = mkV "bäddar" ;
  baelga_vb_1_1_V = mkV "bälgar" ;
  baerga_vb_1_1_V = mkV "bärgar" ;
  baettra_vb_1_1_V = mkV "bättrar" ;
  baagna_vb_1_1_V = mkV "bågnar" ;
  boerja_vb_1_1_V = mkV "börjar" ;
  boersnotera_vb_1_1_V = mkV "börsnoterar" ;
  boeta_vb_1_1_V = mkV "bötar" ;
  camouflera_vb_1_V = mkV "camouflerar" ;
  catera_vb_1_V = mkV "caterar" ;
  cedera_vb_1_V = mkV "cederar" ;
  celebrera_vb_1_V = mkV "celebrerar" ;
  cementa_vb_1_V = mkV "cementar" ;
  cementera_vb_1_V = mkV "cementerar" ;
  censurera_vb_1_V = mkV "censurerar" ;
  centra_vb_1_V = mkV "centrar" ;
  centralisera_vb_1_V = mkV "centraliserar" ;
  centrera_vb_1_V = mkV "centrerar" ;
  centrifugera_vb_1_V = mkV "centrifugerar" ;
  cernera_vb_1_V = mkV "cernerar" ;
  certifiera_vb_1_V = mkV "certifierar" ;
  chargera_vb_1_V = mkV "chargerar" ;
  charma_vb_1_V = mkV "charmar" ;
  charmera_vb_1_V = mkV "charmerar" ;
  chartra_vb_1_V = mkV "chartrar" ;
  checka_vb_1_V = mkV "checkar" ;
  chevrotera_vb_1_V = mkV "chevroterar" ;
  chiffrera_vb_1_V = mkV "chiffrerar" ;
  chikanera_vb_1_V = mkV "chikanerar" ;
  chocka_vb_1_V = mkV "chockar" ;
  chockbehandla_vb_1_V = mkV "chockbehandlar" ;
  chockera_vb_1_V = mkV "chockerar" ;
  choka_vb_1_V = mkV "chokar" ;
  cirkulera_vb_1_V = mkV "cirkulerar" ;
  ciselera_vb_1_V = mkV "ciselerar" ;
  citera_vb_1_V = mkV "citerar" ;
  civilisera_vb_1_V = mkV "civiliserar" ;
  cleara_vb_1_V = mkV "clearar" ;
  covra_vb_1_V = mkV "covrar" ;
  curatera_vb_1_V = mkV "curaterar" ;
  curera_vb_1_V = mkV "curerar" ;
  curla_vb_2_V = mkV "curlar" ;
  cykla_vb_1_V = mkV "cyklar" ;
  dadda_vb_1_V = mkV "daddar" ;
  dagteckna_vb_1_V = mkV "dagtecknar" ;
  damma_vb_2_V = mkV "dammar" ;
  dammtorka_vb_1_V = mkV "dammtorkar" ;
  dampa_vb_1_V = mkV "dampar" ;
  dana_vb_1_V = mkV "danar" ;
  daska_vb_1_V = mkV "daskar" ;
  databehandla_vb_1_V = mkV "databehandlar" ;
  datera_vb_1_V = mkV "daterar" ;
  datorisera_vb_1_V = mkV "datoriserar" ;
  datorsimulera_vb_1_V = mkV "datorsimulerar" ;
  datumparkera_vb_1_V = mkV "datumparkerar" ;
  debarkera_vb_1_V = mkV "debarkerar" ;
  debattera_vb_1_V = mkV "debatterar" ;
  debitera_vb_1_V = mkV "debiterar" ;
  decentralisera_vb_1_V = mkV "decentraliserar" ;
  dechiffrera_vb_1_V = mkV "dechiffrerar" ;
  decimera_vb_1_V = mkV "decimerar" ;
  dedicera_vb_1_V = mkV "dedicerar" ;
  dedikera_vb_1_V = mkV "dedikerar" ;
  deducera_vb_1_V = mkV "deducerar" ;
  defilera_vb_1_V = mkV "defilerar" ;
  definiera_vb_1_V = mkV "definierar" ;
  deflorera_vb_1_V = mkV "deflorerar" ;
  deformera_vb_1_V = mkV "deformerar" ;
  degenerera_vb_1_V = mkV "degenererar" ;
  degradera_vb_1_V = mkV "degraderar" ;
  dejta_vb_1_V = mkV "dejtar" ;
  dekantera_vb_1_V = mkV "dekanterar" ;
  dekapitera_vb_1_V = mkV "dekapiterar" ;
  deklamera_vb_1_V = mkV "deklamerar" ;
  deklarera_vb_1_V = mkV "deklarerar" ;
  deklassera_vb_1_V = mkV "deklasserar" ;
  deklinera_vb_1_V = mkV "deklinerar" ;
  dekorera_vb_1_V = mkV "dekorerar" ;
  dekouragera_vb_1_V = mkV "dekouragerar" ;
  dekretera_vb_1_V = mkV "dekreterar" ;
  dela_vb_1_V = mkV "delar" ;
  delegera_vb_1_V = mkV "delegerar" ;
  dema_vb_1_V = mkV "demar" ;
  demaskera_vb_1_V = mkV "demaskerar" ;
  dementera_vb_1_V = mkV "dementerar" ;
  demilitarisera_vb_1_V = mkV "demilitariserar" ;
  demissionera_vb_1_V = mkV "demissionerar" ;
  demobilisera_vb_1_V = mkV "demobiliserar" ;
  demokratisera_vb_1_V = mkV "demokratiserar" ;
  demolera_vb_1_V = mkV "demolerar" ;
  demonisera_vb_1_V = mkV "demoniserar" ;
  demonstrera_vb_1_V = mkV "demonstrerar" ;
  demontera_vb_1_V = mkV "demonterar" ;
  demoralisera_vb_1_V = mkV "demoraliserar" ;
  denaturalisera_vb_1_V = mkV "denaturaliserar" ;
  denaturera_vb_1_V = mkV "denaturerar" ;
  denotera_vb_1_V = mkV "denoterar" ;
  denudera_vb_1_V = mkV "denuderar" ;
  deodorisera_vb_1_V = mkV "deodoriserar" ;
  depatriera_vb_1_V = mkV "depatrierar" ;
  depensera_vb_1_V = mkV "depenserar" ;
  deplacera_vb_1_V = mkV "deplacerar" ;
  deponera_vb_1_V = mkV "deponerar" ;
  deportera_vb_1_V = mkV "deporterar" ;
  depreciera_vb_1_V = mkV "deprecierar" ;
  derangera_vb_1_V = mkV "derangerar" ;
  derivera_vb_1_V = mkV "deriverar" ;
  desarmera_vb_1_V = mkV "desarmerar" ;
  desavouera_vb_1_V = mkV "desavouerar" ;
  desensibilisera_vb_1_V = mkV "desensibiliserar" ;
  designa_vb_1_V = mkV "designar" ;
  designera_vb_1_V = mkV "designerar" ;
  desinfektera_vb_1_V = mkV "desinfekterar" ;
  desinficera_vb_1_V = mkV "desinficerar" ;
  desinformera_vb_1_V = mkV "desinformerar" ;
  desorganisera_vb_1_V = mkV "desorganiserar" ;
  destabilisera_vb_1_V = mkV "destabiliserar" ;
  destillera_vb_1_V = mkV "destillerar" ;
  destinera_vb_1_V = mkV "destinerar" ;
  destruera_vb_1_V = mkV "destruerar" ;
  detachera_vb_1_V = mkV "detacherar" ;
  detaljgranska_vb_1_V = mkV "detaljgranskar" ;
  detektera_vb_1_V = mkV "detekterar" ;
  determinera_vb_1_V = mkV "determinerar" ;
  detonera_vb_1_V = mkV "detonerar" ;
  detronisera_vb_1_V = mkV "detroniserar" ;
  devalvera_vb_1_V = mkV "devalverar" ;
  dia_vb_1_V = mkV "diar" ;
  diagnosticera_vb_1_V = mkV "diagnosticerar" ;
  diagnostisera_vb_1_V = mkV "diagnostiserar" ;
  dialysera_vb_1_V = mkV "dialyserar" ;
  differentiera_vb_1_V = mkV "differentierar" ;
  diffundera_vb_1_V = mkV "diffunderar" ;
  diftongera_vb_1_V = mkV "diftongerar" ;
  digerera_vb_1_V = mkV "digererar" ;
  digga_vb_1_V = mkV "diggar" ;
  dika_vb_1_V = mkV "dikar" ;
  dikta_vb_1_V = mkV "diktar" ;
  diktera_vb_1_V = mkV "dikterar" ;
  dimensionera_vb_1_V = mkV "dimensionerar" ;
  diplomera_vb_1_V = mkV "diplomerar" ;
  dippa_vb_1_V = mkV "dippar" ;
  dirigera_vb_1_V = mkV "dirigerar" ;
  disambiguera_vb_1_V = mkV "disambiguerar" ;
  disciplinera_vb_1_V = mkV "disciplinerar" ;
  disharmoniera_vb_1_V = mkV "disharmonierar" ;
  diska_vb_1_V = mkV "diskar" ;
  diska_vb_2_V = mkV "diskar" ;
  diskontera_vb_1_V = mkV "diskonterar" ;
  diskreditera_vb_1_V = mkV "diskrediterar" ;
  diskriminera_vb_1_V = mkV "diskriminerar" ;
  diskutera_vb_1_V = mkV "diskuterar" ;
  diskvalificera_vb_1_V = mkV "diskvalificerar" ;
  dispaschera_vb_1_V = mkV "dispascherar" ;
  dispensera_vb_1_V = mkV "dispenserar" ;
  dispergera_vb_1_V = mkV "dispergerar" ;
  disponera_vb_1_V = mkV "disponerar" ;
  disputera_vb_1_V = mkV "disputerar" ;
  dissa_vb_1_V = mkV "dissar" ;
  dissekera_vb_1_V = mkV "dissekerar" ;
  dissimilera_vb_1_V = mkV "dissimilerar" ;
  dissociera_vb_1_V = mkV "dissocierar" ;
  distansera_vb_1_V = mkV "distanserar" ;
  distrahera_vb_1_V = mkV "distraherar" ;
  distribuera_vb_1_V = mkV "distribuerar" ;
  divergera_vb_1_V = mkV "divergerar" ;
  diversifiera_vb_1_V = mkV "diversifierar" ;
  dividera_vb_1_V = mkV "dividerar" ;
  djuploda_vb_1_V = mkV "djuplodar" ;
  dna_testa_vb_1_V = mkV "dna-testar" ;
  docera_vb_2_V = mkV "docerar" ;
  docka_vb_1_V = mkV "dockar" ;
  dofta_vb_2_V = mkV "doftar" ;
  doftmarkera_vb_1_V = mkV "doftmarkerar" ;
  dogmatisera_vb_1_V = mkV "dogmatiserar" ;
  doktorera_vb_1_V = mkV "doktorerar" ;
  dokumentera_vb_1_V = mkV "dokumenterar" ;
  domesticera_vb_1_V = mkV "domesticerar" ;
  domiciliera_vb_1_V = mkV "domicilierar" ;
  dominera_vb_1_V = mkV "dominerar" ;
  domna_vb_1_V = mkV "domnar" ;
  domptera_vb_1_V = mkV "dompterar" ;
  donera_vb_1_V = mkV "donerar" ;
  donka_vb_1_V = mkV "donkar" ;
  dopa_vb_1_V = mkV "dopar" ;
  doppa_vb_1_V = mkV "doppar" ;
  dosera_vb_1_V = mkV "doserar" ;
  dossera_vb_1_V = mkV "dosserar" ;
  dotera_vb_1_V = mkV "doterar" ;
  drabba_vb_1_V = mkV "drabbar" ;
  dragera_vb_1_V = mkV "dragerar" ;
  dragga_vb_1_V = mkV "draggar" ;
  dramatisera_vb_1_V = mkV "dramatiserar" ;
  drapera_vb_1_V = mkV "draperar" ;
  dratta_vb_1_V = mkV "drattar" ;
  dreja_vb_1_V = mkV "drejar" ;
  dressera_vb_1_V = mkV "dresserar" ;
  dreva_vb_1_V = mkV "drevar" ;
  drifta_vb_1_V = mkV "driftar" ;
  drilla_vb_1_V = mkV "drillar" ;
  droga_vb_1_V = mkV "drogar" ;
  droppa_vb_2_V = mkV "droppar" ;
  drunkna_vb_1_V = mkV "drunknar" ;
  dryfta_vb_1_V = mkV "dryftar" ;
  draenera_vb_1_1_V = mkV "dränerar" ;
  dua_vb_1_V = mkV "duar" ;
  dubba_vb_1_V = mkV "dubbar" ;
  dubbelbeskatta_vb_1_V = mkV "dubbelbeskattar" ;
  dubbelexponera_vb_1_V = mkV "dubbelexponerar" ;
  dubbla_vb_1_V = mkV "dubblar" ;
  dubblera_vb_1_V = mkV "dubblerar" ;
  duka_vb_1_V = mkV "dukar" ;
  dumpa_vb_1_V = mkV "dumpar" ;
  dunka_vb_1_V = mkV "dunkar" ;
  dunsta_vb_2_V = mkV "dunstar" ;
  dupera_vb_1_V = mkV "duperar" ;
  duplicera_vb_1_V = mkV "duplicerar" ;
  duscha_vb_1_V = mkV "duschar" ;
  dyrka_vb_1_V = mkV "dyrkar" ;
  daecka_vb_1_1_V = mkV "däckar" ;
  daegga_vb_1_1_V = mkV "däggar" ;
  daempa_vb_1_1_V = mkV "dämpar" ;
  daevna_vb_1_1_V = mkV "dävnar" ;
  daana_vb_2_1_V = mkV "dånar" ;
  daara_vb_1_1_V = mkV "dårar" ;
  doeda_vb_1_1_V = mkV "dödar" ;
  doedfoerklara_vb_1_1_V = mkV "dödförklarar" ;
  doerja_vb_1_1_V = mkV "dörjar" ;
  doeva_vb_1_1_V = mkV "dövar" ;
  e_maila_vb_1_V = mkV "e-mailar" ;
  e_posta_vb_1_V = mkV "e-postar" ;
  edera_vb_1_V = mkV "ederar" ;
  effacera_vb_1_V = mkV "effacerar" ;
  effektivera_vb_1_V = mkV "effektiverar" ;
  effektivisera_vb_1_V = mkV "effektiviserar" ;
  effektuera_vb_1_V = mkV "effektuerar" ;
  efterapa_vb_1_V = mkV "efterapar" ;
  efterbehandla_vb_1_V = mkV "efterbehandlar" ;
  efterbilda_vb_1_V = mkV "efterbildar" ;
  efterdatera_vb_1_V = mkV "efterdaterar" ;
  efterdebitera_vb_1_V = mkV "efterdebiterar" ;
  efterforska_vb_1_V = mkV "efterforskar" ;
  efterfraaga_vb_1_1_V = mkV "efterfrågar" ;
  efterhaerma_vb_1_1_V = mkV "efterhärmar" ;
  efterlikna_vb_1_V = mkV "efterliknar" ;
  efterlaemna_vb_1_1_V = mkV "efterlämnar" ;
  eftermogna_vb_1_V = mkV "eftermognar" ;
  efterrationalisera_vb_1_V = mkV "efterrationaliserar" ;
  efterstava_vb_1_V = mkV "efterstavar" ;
  efterstraeva_vb_1_1_V = mkV "eftersträvar" ;
  eftersynkronisera_vb_1_V = mkV "eftersynkroniserar" ;
  eftertaxera_vb_1_V = mkV "eftertaxerar" ;
  eftertrakta_vb_1_V = mkV "eftertraktar" ;
  egalisera_vb_1_V = mkV "egaliserar" ;
  egga_vb_1_V = mkV "eggar" ;
  egoboosta_vb_1_V = mkV "egoboostar" ;
  eka_vb_2_V = mkV "ekar" ;
  ekfatslagra_vb_1_V = mkV "ekfatslagrar" ;
  ekipera_vb_1_V = mkV "ekiperar" ;
  eklatera_vb_1_V = mkV "eklaterar" ;
  eklaerera_vb_1_1_V = mkV "eklärerar" ;
  ekoloda_vb_1_V = mkV "ekolodar" ;
  ekonomisera_vb_1_V = mkV "ekonomiserar" ;
  elaborera_vb_1_V = mkV "elaborerar" ;
  elastisera_vb_1_V = mkV "elastiserar" ;
  elda_vb_1_V = mkV "eldar" ;
  eldhaerja_vb_1_1_V = mkV "eldhärjar" ;
  eldsaekra_vb_1_1_V = mkV "eldsäkrar" ;
  elektrificera_vb_1_V = mkV "elektrificerar" ;
  elektrifiera_vb_1_V = mkV "elektrifierar" ;
  elektrisera_vb_1_V = mkV "elektriserar" ;
  elidera_vb_1_V = mkV "eliderar" ;
  eliminera_vb_1_V = mkV "eliminerar" ;
  eloxera_vb_1_V = mkV "eloxerar" ;
  eludera_vb_1_V = mkV "eluderar" ;
  eluera_vb_1_V = mkV "eluerar" ;
  emaljera_vb_1_V = mkV "emaljerar" ;
  emancipera_vb_1_V = mkV "emanciperar" ;
  emballera_vb_1_V = mkV "emballerar" ;
  embarkera_vb_1_V = mkV "embarkerar" ;
  embellera_vb_1_V = mkV "embellerar" ;
  emendera_vb_1_V = mkV "emenderar" ;
  emigrera_vb_1_V = mkV "emigrerar" ;
  emittera_vb_1_V = mkV "emitterar" ;
  emotionalisera_vb_1_V = mkV "emotionaliserar" ;
  emulgera_vb_1_V = mkV "emulgerar" ;
  ena_vb_1_V = mkV "enar" ;
  endossera_vb_1_V = mkV "endosserar" ;
  enervera_vb_1_V = mkV "enerverar" ;
  engagera_vb_1_V = mkV "engagerar" ;
  enkelrikta_vb_1_V = mkV "enkelriktar" ;
  enkelteckna_vb_1_V = mkV "enkeltecknar" ;
  enlevera_vb_1_V = mkV "enleverar" ;
  enrollera_vb_1_V = mkV "enrollerar" ;
  ensa_vb_1_V = mkV "ensar" ;
  ensilera_vb_1_V = mkV "ensilerar" ;
  entlediga_vb_1_V = mkV "entledigar" ;
  entusiasmera_vb_1_V = mkV "entusiasmerar" ;
  epilera_vb_1_V = mkV "epilerar" ;
  eposta_vb_1_V = mkV "epostar" ;
  erfordra_vb_1_V = mkV "erfordrar" ;
  erigera_vb_1_V = mkV "erigerar" ;
  erodera_vb_1_V = mkV "eroderar" ;
  erotisera_vb_1_V = mkV "erotiserar" ;
  ertappa_vb_1_V = mkV "ertappar" ;
  eroevra_vb_1_1_V = mkV "erövrar" ;
  eskalera_vb_1_V = mkV "eskalerar" ;
  eskortera_vb_1_V = mkV "eskorterar" ;
  esteticera_vb_1_V = mkV "esteticerar" ;
  estetisera_vb_1_V = mkV "estetiserar" ;
  estimera_vb_1_V = mkV "estimerar" ;
  etablera_vb_1_V = mkV "etablerar" ;
  eterisera_vb_1_V = mkV "eteriserar" ;
  etikettera_vb_1_V = mkV "etiketterar" ;
  etsa_vb_1_V = mkV "etsar" ;
  etymologisera_vb_1_V = mkV "etymologiserar" ;
  europeisera_vb_1_V = mkV "europeiserar" ;
  evakuera_vb_1_V = mkV "evakuerar" ;
  evaluera_vb_1_V = mkV "evaluerar" ;
  evalvera_vb_1_V = mkV "evalverar" ;
  evaporera_vb_1_V = mkV "evaporerar" ;
  examinera_vb_1_V = mkV "examinerar" ;
  excerpera_vb_1_V = mkV "excerperar" ;
  excitera_vb_1_V = mkV "exciterar" ;
  exekvera_vb_1_V = mkV "exekverar" ;
  exemplifiera_vb_1_V = mkV "exemplifierar" ;
  exercera_vb_1_V = mkV "exercerar" ;
  exkludera_vb_1_V = mkV "exkluderar" ;
  exkommunicera_vb_1_V = mkV "exkommunicerar" ;
  expandera_vb_1_V = mkV "expanderar" ;
  expatriera_vb_1_V = mkV "expatrierar" ;
  expediera_vb_1_V = mkV "expedierar" ;
  expektorera_vb_1_V = mkV "expektorerar" ;
  explicera_vb_1_V = mkV "explicerar" ;
  exploatera_vb_1_V = mkV "exploaterar" ;
  explodera_vb_1_V = mkV "exploderar" ;
  exponera_vb_1_V = mkV "exponerar" ;
  exportera_vb_1_V = mkV "exporterar" ;
  expropriera_vb_1_V = mkV "exproprierar" ;
  exstirpera_vb_1_V = mkV "exstirperar" ;
  extemporera_vb_1_V = mkV "extemporerar" ;
  extrahera_vb_1_V = mkV "extraherar" ;
  extrapolera_vb_1_V = mkV "extrapolerar" ;
  fabricera_vb_1_V = mkV "fabricerar" ;
  fabulera_vb_1_V = mkV "fabulerar" ;
  facebooka_vb_1_V = mkV "facebookar" ;
  facettera_vb_1_V = mkV "facetterar" ;
  fakturera_vb_1_V = mkV "fakturerar" ;
  falna_vb_1_V = mkV "falnar" ;
  falsa_vb_1_V = mkV "falsar" ;
  falsifiera_vb_1_V = mkV "falsifierar" ;
  falskskylta_vb_1_V = mkV "falskskyltar" ;
  famna_vb_1_V = mkV "famnar" ;
  fantisera_vb_1_V = mkV "fantiserar" ;
  fasa_vb_1_V = mkV "fasar" ;
  fascinera_vb_1_V = mkV "fascinerar" ;
  fasettera_vb_1_V = mkV "fasetterar" ;
  fasonera_vb_1_V = mkV "fasonerar" ;
  fastighetstaxera_vb_1_V = mkV "fastighetstaxerar" ;
  fastkedja_vb_1_V = mkV "fastkedjar" ;
  fastklistra_vb_1_V = mkV "fastklistrar" ;
  fatta_vb_1_V = mkV "fattar" ;
  favorisera_vb_1_V = mkV "favoriserar" ;
  faxa_vb_1_V = mkV "faxar" ;
  feja_vb_1_V = mkV "fejar" ;
  fejka_vb_1_V = mkV "fejkar" ;
  felnavigera_vb_1_V = mkV "felnavigerar" ;
  felparkera_vb_1_V = mkV "felparkerar" ;
  feltolka_vb_1_V = mkV "feltolkar" ;
  femdubbla_vb_1_V = mkV "femdubblar" ;
  femfaldiga_vb_1_V = mkV "femfaldigar" ;
  fermentera_vb_1_V = mkV "fermenterar" ;
  fernissa_vb_1_V = mkV "fernissar" ;
  fetera_vb_1_V = mkV "feterar" ;
  fickparkera_vb_1_V = mkV "fickparkerar" ;
  fila_vb_1_V = mkV "filar" ;
  filea_vb_1_V = mkV "filear" ;
  filera_vb_1_V = mkV "filerar" ;
  filma_vb_1_V = mkV "filmar" ;
  filmatisera_vb_1_V = mkV "filmatiserar" ;
  filta_vb_1_V = mkV "filtar" ;
  filtrera_vb_1_V = mkV "filtrerar" ;
  fimpa_vb_1_V = mkV "fimpar" ;
  finansiera_vb_1_V = mkV "finansierar" ;
  finfoerdela_vb_1_1_V = mkV "finfördelar" ;
  fingera_vb_1_V = mkV "fingerar" ;
  fingranska_vb_1_V = mkV "fingranskar" ;
  finhacka_vb_1_V = mkV "finhackar" ;
  finjustera_vb_1_V = mkV "finjusterar" ;
  finka_vb_1_V = mkV "finkar" ;
  finkamma_vb_1_V = mkV "finkammar" ;
  finlandisera_vb_1_V = mkV "finlandiserar" ;
  finputsa_vb_1_V = mkV "finputsar" ;
  finslipa_vb_1_V = mkV "finslipar" ;
  finta_vb_1_V = mkV "fintar" ;
  fira_vb_1_V = mkV "firar" ;
  fiska_vb_1_V = mkV "fiskar" ;
  fixa_vb_1_V = mkV "fixar" ;
  fixera_vb_1_V = mkV "fixerar" ;
  fjaella_vb_1_1_V = mkV "fjällar" ;
  fjaerma_vb_1_1_V = mkV "fjärmar" ;
  fjaerrblockera_vb_1_1_V = mkV "fjärrblockerar" ;
  flagga_vb_1_V = mkV "flaggar" ;
  flagna_vb_1_V = mkV "flagnar" ;
  flambera_vb_1_V = mkV "flamberar" ;
  flankera_vb_1_V = mkV "flankerar" ;
  flattera_vb_1_V = mkV "flatterar" ;
  flektera_vb_1_V = mkV "flekterar" ;
  flerdubbla_vb_1_V = mkV "flerdubblar" ;
  flerfaldiga_vb_1_V = mkV "flerfaldigar" ;
  flotta_vb_1_V = mkV "flottar" ;
  fluidisera_vb_1_V = mkV "fluidiserar" ;
  fluorera_vb_1_V = mkV "fluorerar" ;
  fluoridera_vb_1_V = mkV "fluoriderar" ;
  flygbomba_vb_1_V = mkV "flygbombar" ;
  flykta_vb_1_V = mkV "flyktar" ;
  flytta_vb_1_V = mkV "flyttar" ;
  flaecka_vb_1_1_V = mkV "fläckar" ;
  flaensa_vb_1_1_V = mkV "flänsar" ;
  flaeta_vb_1_1_V = mkV "flätar" ;
  flaahacka_vb_1_1_V = mkV "flåhackar" ;
  floejta_vb_1_1_V = mkV "flöjtar" ;
  focka_vb_1_V = mkV "fockar" ;
  foga_vb_1_V = mkV "fogar" ;
  fokusera_vb_1_V = mkV "fokuserar" ;
  foliera_vb_1_V = mkV "folierar" ;
  fondera_vb_1_V = mkV "fonderar" ;
  forcera_vb_1_V = mkV "forcerar" ;
  forechecka_vb_1_V = mkV "forecheckar" ;
  forma_vb_1_V = mkV "formar" ;
  formalisera_vb_1_V = mkV "formaliserar" ;
  formera_vb_1_V = mkV "formerar" ;
  formpressa_vb_1_V = mkV "formpressar" ;
  formulera_vb_1_V = mkV "formulerar" ;
  forsla_vb_1_V = mkV "forslar" ;
  fosfatera_vb_1_V = mkV "fosfaterar" ;
  fossilisera_vb_1_V = mkV "fossiliserar" ;
  fota_vb_1_V = mkV "fotar" ;
  fotografera_vb_1_V = mkV "fotograferar" ;
  fotokopiera_vb_1_V = mkV "fotokopierar" ;
  fotostatkopiera_vb_1_V = mkV "fotostatkopierar" ;
  fragmentera_vb_1_V = mkV "fragmenterar" ;
  frakta_vb_1_V = mkV "fraktar" ;
  fraktionera_vb_1_V = mkV "fraktionerar" ;
  framflytta_vb_1_V = mkV "framflyttar" ;
  framkalla_vb_1_V = mkV "framkallar" ;
  framkasta_vb_1_V = mkV "framkastar" ;
  frammana_vb_1_V = mkV "frammanar" ;
  frammata_vb_1_V = mkV "frammatar" ;
  frampressa_vb_1_V = mkV "frampressar" ;
  framskymta_vb_1_V = mkV "framskymtar" ;
  framvisa_vb_1_V = mkV "framvisar" ;
  frankera_vb_1_V = mkV "frankerar" ;
  fransa_vb_1_V = mkV "fransar" ;
  frappera_vb_1_V = mkV "frapperar" ;
  frasera_vb_1_V = mkV "fraserar" ;
  freda_vb_1_V = mkV "fredar" ;
  frekvensmodulera_vb_1_V = mkV "frekvensmodulerar" ;
  frekventera_vb_1_V = mkV "frekventerar" ;
  fresta_vb_1_V = mkV "frestar" ;
  fria_vb_1_V = mkV "friar" ;
  frihetsberoeva_vb_1_1_V = mkV "frihetsberövar" ;
  frikalla_vb_1_V = mkV "frikallar" ;
  frikoppla_vb_1_V = mkV "frikopplar" ;
  frilista_vb_1_V = mkV "frilistar" ;
  frisera_vb_1_V = mkV "friserar" ;
  frisera_vb_2_V = mkV "friserar" ;
  friskfoerklara_vb_1_1_V = mkV "friskförklarar" ;
  frispela_vb_1_V = mkV "frispelar" ;
  fritera_vb_1_V = mkV "friterar" ;
  frondera_vb_1_V = mkV "fronderar" ;
  fronta_vb_1_V = mkV "frontar" ;
  frottera_vb_1_V = mkV "frotterar" ;
  frukta_vb_1_V = mkV "fruktar" ;
  frustrera_vb_1_V = mkV "frustrerar" ;
  frystesta_vb_1_V = mkV "frystestar" ;
  frystorka_vb_1_V = mkV "frystorkar" ;
  fraemja_vb_1_1_V = mkV "främjar" ;
  fraaga_vb_1_1_V = mkV "frågar" ;
  fraanraekna_vb_1_1_V = mkV "frånräknar" ;
  fraanspela_vb_1_1_V = mkV "frånspelar" ;
  fukta_vb_1_V = mkV "fuktar" ;
  fullborda_vb_1_V = mkV "fullbordar" ;
  fullkomna_vb_1_V = mkV "fullkomnar" ;
  fullstaendiga_vb_1_1_V = mkV "fullständigar" ;
  fullaenda_vb_1_1_V = mkV "fulländar" ;
  fulvinkla_vb_1_V = mkV "fulvinklar" ;
  furnera_vb_1_V = mkV "furnerar" ;
  fusionera_vb_1_V = mkV "fusionerar" ;
  fylka_vb_1_V = mkV "fylkar" ;
  fynda_vb_1_V = mkV "fyndar" ;
  fyrdela_vb_1_V = mkV "fyrdelar" ;
  fyrdubbla_vb_1_V = mkV "fyrdubblar" ;
  fyrfaldiga_vb_1_V = mkV "fyrfaldigar" ;
  fysiljera_vb_1_V = mkV "fysiljerar" ;
  faegna_vb_1_1_V = mkV "fägnar" ;
  faengsla_vb_1_1_V = mkV "fängslar" ;
  faerga_vb_1_1_V = mkV "färgar" ;
  faerja_vb_1_1_V = mkV "färjar" ;
  faersera_vb_1_1_V = mkV "färserar" ;
  faerska_vb_1_1_V = mkV "färskar" ;
  faalla_vb_1_1_V = mkV "fållar" ;
  faanga_vb_1_1_V = mkV "fångar" ;
  faara_vb_1_1_V = mkV "fårar" ;
  foena_vb_1_1_V = mkV "fönar" ;
  foerakta_vb_1_1_V = mkV "föraktar" ;
  foerallmaenliga_vb_1_1_V = mkV "förallmänligar" ;
  foerandliga_vb_1_1_V = mkV "förandligar" ;
  foerankra_vb_1_1_V = mkV "förankrar" ;
  foerannonsera_vb_1_1_V = mkV "förannonserar" ;
  foeranstalta_vb_1_1_V = mkV "föranstaltar" ;
  foerarbeta_vb_1_1_V = mkV "förarbetar" ;
  foerarga_vb_1_1_V = mkV "förargar" ;
  foerbanna_vb_1_1_V = mkV "förbannar" ;
  foerbida_vb_1_1_V = mkV "förbidar" ;
  foerbilliga_vb_1_1_V = mkV "förbilligar" ;
  foerbittra_vb_1_1_V = mkV "förbittrar" ;
  foerblanda_vb_1_1_V = mkV "förblandar" ;
  foerblekna_vb_1_1_V = mkV "förbleknar" ;
  foerblinda_vb_1_1_V = mkV "förblindar" ;
  foerbluffa_vb_1_1_V = mkV "förbluffar" ;
  foerborga_vb_1_1_V = mkV "förborgar" ;
  foerborgerliga_vb_1_1_V = mkV "förborgerligar" ;
  foerbruka_vb_1_1_V = mkV "förbrukar" ;
  foerbrylla_vb_1_1_V = mkV "förbryllar" ;
  foerbroedra_vb_1_1_V = mkV "förbrödrar" ;
  foerbuska_vb_1_1_V = mkV "förbuskar" ;
  foerbaettra_vb_1_1_V = mkV "förbättrar" ;
  foerdela_vb_1_1_V = mkV "fördelar" ;
  foerdjupa_vb_1_1_V = mkV "fördjupar" ;
  foerdubbla_vb_1_1_V = mkV "fördubblar" ;
  foerdumma_vb_1_1_V = mkV "fördummar" ;
  foerdunkla_vb_1_1_V = mkV "fördunklar" ;
  foerdunsta_vb_1_1_V = mkV "fördunstar" ;
  foerdyra_vb_1_1_V = mkV "fördyrar" ;
  foerdystra_vb_1_1_V = mkV "fördystrar" ;
  foerdaerva_vb_1_1_V = mkV "fördärvar" ;
  foerebaada_vb_1_1_V = mkV "förebådar" ;
  foerenkla_vb_1_1_V = mkV "förenklar" ;
  foerespegla_vb_1_1_V = mkV "förespeglar" ;
  foerespraaka_vb_1_1_V = mkV "förespråkar" ;
  foerestava_vb_1_1_V = mkV "förestavar" ;
  foereviga_vb_1_1_V = mkV "förevigar" ;
  foerevisa_vb_1_1_V = mkV "förevisar" ;
  foerevita_vb_1_1_V = mkV "förevitar" ;
  foerfalska_vb_1_1_V = mkV "förfalskar" ;
  foerfatta_vb_1_1_V = mkV "författar" ;
  foerfela_vb_1_1_V = mkV "förfelar" ;
  foerfina_vb_1_1_V = mkV "förfinar" ;
  foerflacka_vb_1_1_V = mkV "förflackar" ;
  foerflytta_vb_1_1_V = mkV "förflyttar" ;
  foerfranska_vb_1_1_V = mkV "förfranskar" ;
  foerfraemliga_vb_1_1_V = mkV "förfrämligar" ;
  foerfuska_vb_1_1_V = mkV "förfuskar" ;
  foerfaea_vb_1_1_V = mkV "förfäar" ;
  foerfaekta_vb_1_1_V = mkV "förfäktar" ;
  foerfaera_vb_1_1_V = mkV "förfärar" ;
  foerfaerdiga_vb_1_1_V = mkV "förfärdigar" ;
  foerfaanga_vb_1_1_V = mkV "förfångar" ;
  foerfoerdela_vb_1_1_V = mkV "förfördelar" ;
  foergasa_vb_1_1_V = mkV "förgasar" ;
  foergifta_vb_1_1_V = mkV "förgiftar" ;
  foergrova_vb_1_1_V = mkV "förgrovar" ;
  foergrymma_vb_1_1_V = mkV "förgrymmar" ;
  foerhala_vb_1_1_V = mkV "förhalar" ;
  foerhandla_vb_1_1_V = mkV "förhandlar" ;
  foerhindra_vb_1_1_V = mkV "förhindrar" ;
  foerhaerda_vb_1_1_V = mkV "förhärdar" ;
  foerhaerja_vb_1_1_V = mkV "förhärjar" ;
  foerhaerliga_vb_1_1_V = mkV "förhärligar" ;
  foerhaexa_vb_1_1_V = mkV "förhäxar" ;
  foerhaana_vb_1_1_V = mkV "förhånar" ;
  foerinta_vb_1_1_V = mkV "förintar" ;
  foerjaga_vb_1_1_V = mkV "förjagar" ;
  foerkasta_vb_1_1_V = mkV "förkastar" ;
  foerklara_vb_1_1_V = mkV "förklarar" ;
  foerklinga_vb_1_1_V = mkV "förklingar" ;
  foerklistra_1_vb_1_1_V = mkV "förklistrar" ;
  foerknippa_vb_1_1_V = mkV "förknippar" ;
  foerkolna_vb_1_1_V = mkV "förkolnar" ;
  foerkorta_vb_1_1_V = mkV "förkortar" ;
  foerkovra_vb_1_1_V = mkV "förkovrar" ;
  foerkroma_vb_1_1_V = mkV "förkromar" ;
  foerkroppsliga_vb_1_1_V = mkV "förkroppsligar" ;
  foerkrossa_vb_1_1_V = mkV "förkrossar" ;
  foerkraama_vb_1_1_V = mkV "förkråmar" ;
  foerkunna_vb_1_1_V = mkV "förkunnar" ;
  foerlama_vb_1_1_V = mkV "förlamar" ;
  foerljuva_vb_1_1_V = mkV "förljuvar" ;
  foerlora_vb_1_1_V = mkV "förlorar" ;
  foerlossa_vb_1_1_V = mkV "förlossar" ;
  foerlusta_vb_1_1_V = mkV "förlustar" ;
  foerlaena_vb_1_1_V = mkV "förlänar" ;
  foerloejliga_vb_1_1_V = mkV "förlöjligar" ;
  foermana_vb_1_1_V = mkV "förmanar" ;
  foermedla_vb_1_1_V = mkV "förmedlar" ;
  foermena_vb_1_1_V = mkV "förmenar" ;
  foermildra_vb_1_1_V = mkV "förmildrar" ;
  foerminska_vb_1_1_V = mkV "förminskar" ;
  foermoda_vb_1_1_V = mkV "förmodar" ;
  foermultna_vb_1_1_V = mkV "förmultnar" ;
  foermaenskliga_vb_1_1_V = mkV "förmänskligar" ;
  foermoerka_vb_1_1_V = mkV "förmörkar" ;
  foernagla_vb_1_1_V = mkV "förnaglar" ;
  foernedra_vb_1_1_V = mkV "förnedrar" ;
  foerneka_vb_1_1_V = mkV "förnekar" ;
  foernickla_vb_1_1_V = mkV "förnicklar" ;
  foernya_vb_1_1_V = mkV "förnyar" ;
  foernaerma_vb_1_1_V = mkV "förnärmar" ;
  foerolaempa_vb_1_1_V = mkV "förolämpar" ;
  foerorda_vb_1_1_V = mkV "förordar" ;
  foerordna_vb_1_1_V = mkV "förordnar" ;
  foerorena_vb_1_1_V = mkV "förorenar" ;
  foerorsaka_vb_1_1_V = mkV "förorsakar" ;
  foeroraetta_vb_1_1_V = mkV "förorättar" ;
  foerpacka_vb_1_1_V = mkV "förpackar" ;
  foerpakta_vb_1_1_V = mkV "förpaktar" ;
  foerpanta_vb_1_1_V = mkV "förpantar" ;
  foerpassa_vb_1_1_V = mkV "förpassar" ;
  foerpesta_vb_1_1_V = mkV "förpestar" ;
  foerplikta_vb_1_1_V = mkV "förpliktar" ;
  foerpliktiga_vb_1_1_V = mkV "förpliktigar" ;
  foerplaega_vb_1_1_V = mkV "förplägar" ;
  foerpricka_vb_1_1_V = mkV "förprickar" ;
  foerringa_vb_1_1_V = mkV "förringar" ;
  foerruttna_vb_1_1_V = mkV "förruttnar" ;
  foerryska_vb_1_1_V = mkV "förryskar" ;
  foerraenta_vb_1_1_V = mkV "förräntar" ;
  foerraetta_vb_1_1_V = mkV "förrättar" ;
  foerraaa_vb_1_1_V = mkV "förråar" ;
  foersaka_vb_1_1_V = mkV "försakar" ;
  foersamla_vb_1_1_V = mkV "församlar" ;
  foersegla_vb_1_1_V = mkV "förseglar" ;
  foersena_vb_1_1_V = mkV "försenar" ;
  foersilvra_vb_1_1_V = mkV "försilvrar" ;
  foersinka_vb_1_1_V = mkV "försinkar" ;
  foerskaffa_vb_1_1_V = mkV "förskaffar" ;
  foerskansa_vb_1_1_V = mkV "förskansar" ;
  foerskingra_vb_1_1_V = mkV "förskingrar" ;
  foerskona_vb_1_1_V = mkV "förskonar" ;
  foerskottera_vb_1_1_V = mkV "förskotterar" ;
  foerskoena_vb_1_1_V = mkV "förskönar" ;
  foerslappa_vb_1_1_V = mkV "förslappar" ;
  foerslava_vb_1_1_V = mkV "förslavar" ;
  foersloea_vb_1_1_V = mkV "förslöar" ;
  foersloesa_vb_1_1_V = mkV "förslösar" ;
  foersnilla_vb_1_1_V = mkV "försnillar" ;
  foersoffa_vb_1_1_V = mkV "försoffar" ;
  foersona_vb_1_1_V = mkV "försonar" ;
  foerstatliga_vb_1_1_V = mkV "förstatligar" ;
  foerstelna_vb_1_1_V = mkV "förstelnar" ;
  foerstena_vb_1_1_V = mkV "förstenar" ;
  foerstocka_vb_1_1_V = mkV "förstockar" ;
  foerstoppa_vb_1_1_V = mkV "förstoppar" ;
  foerstora_vb_1_1_V = mkV "förstorar" ;
  foerstraeva_vb_1_1_V = mkV "försträvar" ;
  foerstumma_vb_1_1_V = mkV "förstummar" ;
  foerstaendiga_vb_1_1_V = mkV "förständigar" ;
  foersumma_vb_1_1_V = mkV "försummar" ;
  foersura_vb_1_1_V = mkV "försurar" ;
  foersvaga_vb_1_1_V = mkV "försvagar" ;
  foersvara_vb_1_1_V = mkV "försvarar" ;
  foersvenska_vb_1_1_V = mkV "försvenskar" ;
  foersvaara_vb_1_1_V = mkV "försvårar" ;
  foersaekra_vb_1_1_V = mkV "försäkrar" ;
  foersaemra_vb_1_1_V = mkV "försämrar" ;
  foertala_vb_1_1_V = mkV "förtalar" ;
  foerteckna_vb_1_1_V = mkV "förtecknar" ;
  foertenna_vb_1_1_V = mkV "förtennar" ;
  foertidspensionera_vb_1_1_V = mkV "förtidspensionerar" ;
  foertjocka_vb_1_1_V = mkV "förtjockar" ;
  foertjaena_vb_1_1_V = mkV "förtjänar" ;
  foertorka_vb_1_1_V = mkV "förtorkar" ;
  foertrampa_vb_1_1_V = mkV "förtrampar" ;
  foertreta_vb_1_1_V = mkV "förtretar" ;
  foertrolla_vb_1_1_V = mkV "förtrollar" ;
  foertrusta_vb_1_1_V = mkV "förtrustar" ;
  foertroesta_vb_1_1_V = mkV "förtröstar" ;
  foertulla_vb_1_1_V = mkV "förtullar" ;
  foertunna_vb_1_1_V = mkV "förtunnar" ;
  foertvina_vb_1_1_V = mkV "förtvinar" ;
  foertvivla_vb_1_1_V = mkV "förtvivlar" ;
  foertvaala_vb_1_1_V = mkV "förtvålar" ;
  foertydliga_vb_1_1_V = mkV "förtydligar" ;
  foertyska_vb_1_1_V = mkV "förtyskar" ;
  foertaeta_vb_1_1_V = mkV "förtätar" ;
  foerundra_vb_1_1_V = mkV "förundrar" ;
  foerunna_vb_1_1_V = mkV "förunnar" ;
  foerutskicka_vb_1_1_V = mkV "förutskickar" ;
  foervalta_vb_1_1_V = mkV "förvaltar" ;
  foervandla_vb_1_1_V = mkV "förvandlar" ;
  foervanska_vb_1_1_V = mkV "förvanskar" ;
  foervara_vb_1_1_V = mkV "förvarar" ;
  foervarna_vb_1_1_V = mkV "förvarnar" ;
  foerveda_vb_1_1_V = mkV "förvedar" ;
  foervekliga_vb_1_1_V = mkV "förvekligar" ;
  foerverka_vb_1_1_V = mkV "förverkar" ;
  foerverkliga_vb_1_1_V = mkV "förverkligar" ;
  foervilla_vb_1_1_V = mkV "förvillar" ;
  foervirra_vb_1_1_V = mkV "förvirrar" ;
  foervisa_vb_1_1_V = mkV "förvisar" ;
  foervissa_vb_1_1_V = mkV "förvissar" ;
  foervissna_vb_1_1_V = mkV "förvissnar" ;
  foervittra_vb_1_1_V = mkV "förvittrar" ;
  foervaegra_vb_1_1_V = mkV "förvägrar" ;
  foervaenta_vb_1_1_V = mkV "förväntar" ;
  foervaerldsliga_vb_1_1_V = mkV "förvärldsligar" ;
  foervaerra_vb_1_1_V = mkV "förvärrar" ;
  foervaerva_vb_1_1_V = mkV "förvärvar" ;
  foervaexla_vb_1_1_V = mkV "förväxlar" ;
  foervaalla_vb_1_1_V = mkV "förvållar" ;
  foervaana_vb_1_1_V = mkV "förvånar" ;
  foeryngra_vb_1_1_V = mkV "föryngrar" ;
  foerzinka_vb_1_1_V = mkV "förzinkar" ;
  foeraedla_vb_1_1_V = mkV "förädlar" ;
  foeraendra_vb_1_1_V = mkV "förändrar" ;
  foeraera_vb_1_1_V = mkV "förärar" ;
  foeraanga_vb_1_1_V = mkV "förångar" ;
  foeroedmjuka_vb_1_1_V = mkV "förödmjukar" ;
  foeroeka_vb_1_1_V = mkV "förökar" ;
  foeroeva_vb_1_1_V = mkV "förövar" ;
  gagna_vb_1_V = mkV "gagnar" ;
  gallisera_vb_1_V = mkV "galliserar" ;
  gallra_vb_1_V = mkV "gallrar" ;
  galoschera_vb_1_V = mkV "galoscherar" ;
  galva_vb_1_V = mkV "galvar" ;
  galvanisera_vb_1_V = mkV "galvaniserar" ;
  gana_vb_1_V = mkV "ganar" ;
  gara_vb_1_V = mkV "garar" ;
  garagera_vb_1_V = mkV "garagerar" ;
  garantera_vb_1_V = mkV "garanterar" ;
  gardera_vb_1_V = mkV "garderar" ;
  garnera_vb_1_V = mkV "garnerar" ;
  garnisonera_vb_1_V = mkV "garnisonerar" ;
  garrottera_vb_1_V = mkV "garrotterar" ;
  garva_vb_1_V = mkV "garvar" ;
  gasa_vb_2_V = mkV "gasar" ;
  gastkrama_vb_1_V = mkV "gastkramar" ;
  gastroskopera_vb_1_V = mkV "gastroskoperar" ;
  gauffrera_vb_1_V = mkV "gauffrerar" ;
  gelatinera_vb_1_V = mkV "gelatinerar" ;
  gelea_vb_1_V = mkV "gelear" ;
  geminera_vb_1_V = mkV "geminerar" ;
  genera_vb_1_V = mkV "generar" ;
  generalisera_vb_1_V = mkV "generaliserar" ;
  generera_vb_1_V = mkV "genererar" ;
  gengaelda_vb_1_1_V = mkV "gengäldar" ;
  genmanipulera_vb_1_V = mkV "genmanipulerar" ;
  genomarbeta_vb_1_V = mkV "genomarbetar" ;
  genomborra_vb_1_V = mkV "genomborrar" ;
  genomgraedda_vb_1_1_V = mkV "genomgräddar" ;
  genomkorsa_vb_1_V = mkV "genomkorsar" ;
  genomsippra_vb_1_V = mkV "genomsipprar" ;
  genomskaada_vb_1_1_V = mkV "genomskådar" ;
  genomstroemma_vb_1_1_V = mkV "genomströmmar" ;
  genomsyra_vb_1_V = mkV "genomsyrar" ;
  geometrisera_vb_1_V = mkV "geometriserar" ;
  geotagga_vb_1_V = mkV "geotaggar" ;
  germanisera_vb_1_V = mkV "germaniserar" ;
  gestalta_vb_1_V = mkV "gestaltar" ;
  giga_vb_1_V = mkV "gigar" ;
  giljotinera_vb_1_V = mkV "giljotinerar" ;
  gilla_vb_1_V = mkV "gillar" ;
  gillra_vb_1_V = mkV "gillrar" ;
  gipsa_vb_1_V = mkV "gipsar" ;
  girera_vb_1_V = mkV "girerar" ;
  gissa_vb_1_V = mkV "gissar" ;
  gista_vb_1_V = mkV "gistar" ;
  gjorda_vb_1_V = mkV "gjordar" ;
  glamorisera_vb_1_V = mkV "glamoriserar" ;
  glamourisera_vb_1_V = mkV "glamouriserar" ;
  glansa_vb_1_V = mkV "glansar" ;
  glanska_vb_1_V = mkV "glanskar" ;
  glasa_vb_1_V = mkV "glasar" ;
  glasera_vb_1_V = mkV "glaserar" ;
  glatta_vb_1_V = mkV "glattar" ;
  glesa_vb_1_V = mkV "glesar" ;
  glesna_vb_1_V = mkV "glesnar" ;
  glorifiera_vb_1_V = mkV "glorifierar" ;
  glaenta_vb_1_1_V = mkV "gläntar" ;
  glaetta_vb_1_1_V = mkV "glättar" ;
  gloedga_vb_1_1_V = mkV "glödgar" ;
  gloedrita_vb_1_1_V = mkV "glödritar" ;
  gnista_vb_1_V = mkV "gnistar" ;
  gnola_vb_1_V = mkV "gnolar" ;
  gnugga_vb_1_V = mkV "gnuggar" ;
  goffrera_vb_1_V = mkV "goffrerar" ;
  golva_vb_1_V = mkV "golvar" ;
  googla_vb_1_V = mkV "googlar" ;
  goutera_vb_1_V = mkV "gouterar" ;
  gps_a_vb_1_V = mkV "gps-ar" ;
  gpsa_vb_1_V = mkV "gpsar" ;
  gpsa_vb_2_V = mkV "gps:ar" ;
  grabba_vb_1_V = mkV "grabbar" ;
  grada_vb_1_V = mkV "gradar" ;
  gradera_vb_1_V = mkV "graderar" ;
  graduera_vb_1_V = mkV "graduerar" ;
  grafitera_vb_1_V = mkV "grafiterar" ;
  granska_vb_1_V = mkV "granskar" ;
  granulera_vb_1_V = mkV "granulerar" ;
  gratinera_vb_1_V = mkV "gratinerar" ;
  gratta_vb_1_V = mkV "grattar" ;
  gratulera_vb_1_V = mkV "gratulerar" ;
  grava_vb_1_V = mkV "gravar" ;
  gravera_vb_1_V = mkV "graverar" ;
  greja_vb_1_V = mkV "grejar" ;
  greppa_vb_1_V = mkV "greppar" ;
  griljera_vb_1_V = mkV "griljerar" ;
  grilla_vb_1_V = mkV "grillar" ;
  grimera_vb_1_V = mkV "grimerar" ;
  grodda_vb_1_V = mkV "groddar" ;
  grovplanera_vb_1_V = mkV "grovplanerar" ;
  grovsortera_vb_1_V = mkV "grovsorterar" ;
  grumsa_vb_1_V = mkV "grumsar" ;
  grunda_vb_1_V = mkV "grundar" ;
  grundbehandla_vb_1_V = mkV "grundbehandlar" ;
  grundera_vb_1_V = mkV "grunderar" ;
  grundlura_vb_1_V = mkV "grundlurar" ;
  grundmaala_vb_1_1_V = mkV "grundmålar" ;
  gruppera_vb_1_V = mkV "grupperar" ;
  grusa_vb_1_V = mkV "grusar" ;
  graedda_vb_1_1_V = mkV "gräddar" ;
  graefta_vb_1_1_V = mkV "gräftar" ;
  graana_vb_1_1_V = mkV "grånar" ;
  groepa_vb_1_1_V = mkV "gröpar" ;
  guida_vb_1_V = mkV "guidar" ;
  gulfaerga_vb_1_1_V = mkV "gulfärgar" ;
  gulna_vb_1_V = mkV "gulnar" ;
  gummera_vb_1_V = mkV "gummerar" ;
  gunga_vb_2_V = mkV "gungar" ;
  guska_vb_1_V = mkV "guskar" ;
  gutera_vb_1_V = mkV "guterar" ;
  gymnastisera_vb_1_V = mkV "gymnastiserar" ;
  gynna_vb_1_V = mkV "gynnar" ;
  gaecka_vb_1_1_V = mkV "gäckar" ;
  gaela_vb_1_1_V = mkV "gälar" ;
  gaenga_vb_1_1_V = mkV "gängar" ;
  gaerda_vb_1_1_V = mkV "gärdar" ;
  gaesta_vb_1_1_V = mkV "gästar" ;
  gaestspela_vb_1_1_V = mkV "gästspelar" ;
  gaangra_vb_1_1_V = mkV "gångrar" ;
  goeka_vb_1_1_V = mkV "gökar" ;
  hacka_vb_1_V = mkV "hackar" ;
  haffa_vb_1_V = mkV "haffar" ;
  haja_vb_1_V = mkV "hajar" ;
  haka_vb_1_V = mkV "hakar" ;
  hala_vb_1_V = mkV "halar" ;
  hallstaempla_vb_1_1_V = mkV "hallstämplar" ;
  hallucinera_vb_1_V = mkV "hallucinerar" ;
  halsa_vb_1_V = mkV "halsar" ;
  halvera_vb_1_V = mkV "halverar" ;
  halvsula_vb_1_V = mkV "halvsular" ;
  halvviska_vb_1_V = mkV "halvviskar" ;
  hamna_vb_1_V = mkV "hamnar" ;
  hamra_vb_1_V = mkV "hamrar" ;
  handarbeta_vb_1_V = mkV "handarbetar" ;
  handboja_vb_1_V = mkV "handbojar" ;
  handikappa_vb_1_V = mkV "handikappar" ;
  handla_vb_2_V = mkV "handlar" ;
  handplocka_vb_1_V = mkV "handplockar" ;
  hantera_vb_1_V = mkV "hanterar" ;
  harangera_vb_1_V = mkV "harangerar" ;
  harma_vb_1_V = mkV "harmar" ;
  harmonisera_vb_1_V = mkV "harmoniserar" ;
  harpunera_vb_1_V = mkV "harpunerar" ;
  hartsa_vb_1_V = mkV "hartsar" ;
  harva_vb_1_V = mkV "harvar" ;
  hasa_vb_2_V = mkV "hasar" ;
  hasardera_vb_1_V = mkV "hasarderar" ;
  haspa_vb_1_V = mkV "haspar" ;
  haspla_vb_1_V = mkV "hasplar" ;
  hata_vb_1_V = mkV "hatar" ;
  haussa_vb_1_V = mkV "haussar" ;
  haverera_vb_1_V = mkV "havererar" ;
  hedra_vb_1_V = mkV "hedrar" ;
  heja_vb_1_V = mkV "hejar" ;
  hejda_vb_1_V = mkV "hejdar" ;
  hektografera_vb_1_V = mkV "hektograferar" ;
  hela_vb_1_V = mkV "helar" ;
  helfoersaekra_vb_1_1_V = mkV "helförsäkrar" ;
  helga_vb_1_V = mkV "helgar" ;
  helgardera_vb_1_V = mkV "helgarderar" ;
  helgonfoerklara_vb_1_1_V = mkV "helgonförklarar" ;
  helinackordera_vb_1_V = mkV "helinackorderar" ;
  hemfoerlova_vb_1_1_V = mkV "hemförlovar" ;
  hemkalla_vb_1_V = mkV "hemkallar" ;
  hemligstaempla_vb_1_1_V = mkV "hemligstämplar" ;
  hena_vb_1_V = mkV "henar" ;
  heroisera_vb_1_V = mkV "heroiserar" ;
  hetsa_vb_1_V = mkV "hetsar" ;
  hinka_vb_1_V = mkV "hinkar" ;
  hissa_vb_1_V = mkV "hissar" ;
  historiera_vb_1_V = mkV "historierar" ;
  historisera_vb_1_V = mkV "historiserar" ;
  hitta_vb_1_V = mkV "hittar" ;
  hiva_vb_1_V = mkV "hivar" ;
  hjaerntvaetta_vb_1_1_V = mkV "hjärntvättar" ;
  holografera_vb_1_V = mkV "holograferar" ;
  homogenisera_vb_1_V = mkV "homogeniserar" ;
  honorera_vb_1_V = mkV "honorerar" ;
  hopa_vb_1_V = mkV "hopar" ;
  hopbunta_vb_1_V = mkV "hopbuntar" ;
  hopdikta_vb_1_V = mkV "hopdiktar" ;
  hopfoga_vb_1_V = mkV "hopfogar" ;
  hoplappa_vb_1_V = mkV "hoplappar" ;
  hoppa_vb_1_V = mkV "hoppar" ;
  hoppacka_vb_1_V = mkV "hoppackar" ;
  hoprafsa_vb_1_V = mkV "hoprafsar" ;
  hospitalisera_vb_1_V = mkV "hospitaliserar" ;
  hosta_vb_2_V = mkV "hostar" ;
  hota_vb_1_V = mkV "hotar" ;
  hotta_vb_1_V = mkV "hottar" ;
  hugna_vb_1_V = mkV "hugnar" ;
  hugsvala_vb_1_V = mkV "hugsvalar" ;
  humanisera_vb_1_V = mkV "humaniserar" ;
  hundsa_vb_1_V = mkV "hundsar" ;
  hundsfottera_vb_1_V = mkV "hundsfotterar" ;
  hunsa_vb_1_V = mkV "hunsar" ;
  husera_vb_2_V = mkV "huserar" ;
  hybridisera_vb_1_V = mkV "hybridiserar" ;
  hydrera_vb_1_V = mkV "hydrerar" ;
  hyfsa_vb_1_V = mkV "hyfsar" ;
  hylla_vb_1_V = mkV "hyllar" ;
  hypnotisera_vb_1_V = mkV "hypnotiserar" ;
  hypotisera_vb_1_V = mkV "hypotiserar" ;
  hyresreglera_vb_1_V = mkV "hyresreglerar" ;
  hyssja_vb_1_V = mkV "hyssjar" ;
  hysta_vb_1_V = mkV "hystar" ;
  hyva_vb_1_V = mkV "hyvar" ;
  haeda_vb_1_1_V = mkV "hädar" ;
  haedankalla_vb_1_1_V = mkV "hädankallar" ;
  haefta_vb_1_1_V = mkV "häftar" ;
  haegna_vb_1_1_V = mkV "hägnar" ;
  haekta_vb_1_1_V = mkV "häktar" ;
  haelsa_vb_1_1_V = mkV "hälsar" ;
  haemna_vb_1_1_V = mkV "hämnar" ;
  haemta_vb_1_1_V = mkV "hämtar" ;
  haenvisa_vb_1_1_V = mkV "hänvisar" ;
  haerbaergera_vb_1_1_V = mkV "härbärgerar" ;
  haerda_vb_1_1_V = mkV "härdar" ;
  haerja_vb_1_1_V = mkV "härjar" ;
  haerma_vb_1_1_V = mkV "härmar" ;
  haerskna_vb_1_1_V = mkV "härsknar" ;
  haessja_vb_1_1_V = mkV "hässjar" ;
  haevda_vb_1_1_V = mkV "hävdar" ;
  haala_vb_1_1_V = mkV "hålar" ;
  haana_vb_1_1_V = mkV "hånar" ;
  haardgranska_vb_1_1_V = mkV "hårdgranskar" ;
  haardna_vb_1_1_V = mkV "hårdnar" ;
  haardtraena_vb_1_1_V = mkV "hårdtränar" ;
  haava_vb_1_1_V = mkV "håvar" ;
  hoegakta_vb_1_1_V = mkV "högaktar" ;
  hoegprioritera_vb_1_1_V = mkV "högprioriterar" ;
  hoersamma_vb_1_1_V = mkV "hörsammar" ;
  idealisera_vb_1_V = mkV "idealiserar" ;
  identifiera_vb_1_V = mkV "identifierar" ;
  idiotfoerklara_vb_1_1_V = mkV "idiotförklarar" ;
  idka_vb_1_V = mkV "idkar" ;
  ignorera_vb_1_V = mkV "ignorerar" ;
  illuminera_vb_1_V = mkV "illuminerar" ;
  illustrera_vb_1_V = mkV "illustrerar" ;
  imitera_vb_1_V = mkV "imiterar" ;
  immatrikulera_vb_1_V = mkV "immatrikulerar" ;
  immigrera_vb_1_V = mkV "immigrerar" ;
  immunisera_vb_1_V = mkV "immuniserar" ;
  impa_vb_1_V = mkV "impar" ;
  implantera_vb_1_V = mkV "implanterar" ;
  implicera_vb_1_V = mkV "implicerar" ;
  implodera_vb_1_V = mkV "imploderar" ;
  imponera_vb_1_V = mkV "imponerar" ;
  importera_vb_1_V = mkV "importerar" ;
  impregnera_vb_1_V = mkV "impregnerar" ;
  improvisera_vb_1_V = mkV "improviserar" ;
  inackordera_vb_1_V = mkV "inackorderar" ;
  inarbeta_vb_1_V = mkV "inarbetar" ;
  inaugurera_vb_1_V = mkV "inaugurerar" ;
  inbaka_vb_1_V = mkV "inbakar" ;
  inberaekna_vb_1_1_V = mkV "inberäknar" ;
  inbespara_vb_1_V = mkV "inbesparar" ;
  inbilla_vb_1_V = mkV "inbillar" ;
  indela_vb_1_V = mkV "indelar" ;
  indexera_vb_1_V = mkV "indexerar" ;
  indexreglera_vb_1_V = mkV "indexreglerar" ;
  indicera_vb_1_V = mkV "indicerar" ;
  indikera_vb_1_V = mkV "indikerar" ;
  individualisera_vb_1_V = mkV "individualiserar" ;
  indoktrinera_vb_1_V = mkV "indoktrinerar" ;
  inducera_vb_1_V = mkV "inducerar" ;
  indunsta_vb_1_V = mkV "indunstar" ;
  industrialisera_vb_1_V = mkV "industrialiserar" ;
  infantilisera_vb_1_V = mkV "infantiliserar" ;
  infatta_vb_1_V = mkV "infattar" ;
  infektera_vb_1_V = mkV "infekterar" ;
  infetta_vb_1_V = mkV "infettar" ;
  infiltrera_vb_1_V = mkV "infiltrerar" ;
  inflammera_vb_1_V = mkV "inflammerar" ;
  inflicka_vb_1_V = mkV "inflickar" ;
  inflika_vb_1_V = mkV "inflikar" ;
  influera_vb_1_V = mkV "influerar" ;
  inflytta_vb_1_V = mkV "inflyttar" ;
  inflaeta_vb_1_1_V = mkV "inflätar" ;
  infodra_vb_1_V = mkV "infodrar" ;
  infoga_vb_1_V = mkV "infogar" ;
  infordra_vb_1_V = mkV "infordrar" ;
  informera_vb_1_V = mkV "informerar" ;
  infria_vb_1_V = mkV "infriar" ;
  infaanga_vb_1_1_V = mkV "infångar" ;
  infoerliva_vb_1_1_V = mkV "införlivar" ;
  infoerskaffa_vb_1_1_V = mkV "införskaffar" ;
  ingravera_vb_1_V = mkV "ingraverar" ;
  ingaerda_vb_1_1_V = mkV "ingärdar" ;
  inhalera_vb_1_V = mkV "inhalerar" ;
  inhandla_vb_1_V = mkV "inhandlar" ;
  inhibera_vb_1_V = mkV "inhiberar" ;
  inhibitera_vb_1_V = mkV "inhibiterar" ;
  inhaegna_vb_1_1_V = mkV "inhägnar" ;
  inhaemta_vb_1_1_V = mkV "inhämtar" ;
  initiera_vb_1_V = mkV "initierar" ;
  injaga_vb_1_V = mkV "injagar" ;
  injektera_vb_1_V = mkV "injekterar" ;
  injicera_vb_1_V = mkV "injicerar" ;
  inkalla_vb_1_V = mkV "inkallar" ;
  inkapsla_vb_1_V = mkV "inkapslar" ;
  inkarnera_vb_1_V = mkV "inkarnerar" ;
  inkassera_vb_1_V = mkV "inkasserar" ;
  inklarera_vb_1_V = mkV "inklarerar" ;
  inkludera_vb_1_V = mkV "inkluderar" ;
  inkompetensfoerklara_vb_1_1_V = mkV "inkompetensförklarar" ;
  inkomsttaxera_vb_1_V = mkV "inkomsttaxerar" ;
  inkoppla_vb_1_V = mkV "inkopplar" ;
  inkorporera_vb_1_V = mkV "inkorporerar" ;
  inkvartera_vb_1_V = mkV "inkvarterar" ;
  inlemma_vb_1_V = mkV "inlemmar" ;
  inleverera_vb_1_V = mkV "inlevererar" ;
  inlinda_vb_1_V = mkV "inlindar" ;
  inlaemna_vb_1_1_V = mkV "inlämnar" ;
  inlaana_vb_1_1_V = mkV "inlånar" ;
  inmata_vb_1_V = mkV "inmatar" ;
  inmundiga_vb_1_V = mkV "inmundigar" ;
  inmuta_vb_1_V = mkV "inmutar" ;
  inmoenstra_vb_1_1_V = mkV "inmönstrar" ;
  innefatta_vb_1_V = mkV "innefattar" ;
  innervera_vb_1_V = mkV "innerverar" ;
  inokulera_vb_1_V = mkV "inokulerar" ;
  inolja_vb_1_V = mkV "inoljar" ;
  inordna_vb_1_V = mkV "inordnar" ;
  inpassa_vb_1_V = mkV "inpassar" ;
  inplanta_vb_1_V = mkV "inplantar" ;
  inplantera_vb_1_V = mkV "inplanterar" ;
  inpressa_vb_1_V = mkV "inpressar" ;
  inpricka_vb_1_V = mkV "inprickar" ;
  inpraegla_vb_1_1_V = mkV "inpräglar" ;
  inpraenta_vb_1_1_V = mkV "inpräntar" ;
  inrama_vb_1_V = mkV "inramar" ;
  inrangera_vb_1_V = mkV "inrangerar" ;
  inrapportera_vb_1_V = mkV "inrapporterar" ;
  inregistrera_vb_1_V = mkV "inregistrerar" ;
  inrikta_vb_1_V = mkV "inriktar" ;
  inringa_vb_1_V = mkV "inringar" ;
  inrista_vb_1_V = mkV "inristar" ;
  inropa_vb_1_V = mkV "inropar" ;
  inraekna_vb_1_1_V = mkV "inräknar" ;
  inraetta_vb_1_1_V = mkV "inrättar" ;
  insamla_vb_1_V = mkV "insamlar" ;
  inscenera_vb_1_V = mkV "inscenerar" ;
  insegla_vb_1_V = mkV "inseglar" ;
  inseminera_vb_1_V = mkV "inseminerar" ;
  insinuera_vb_1_V = mkV "insinuerar" ;
  insistera_vb_1_V = mkV "insisterar" ;
  insjukna_vb_1_V = mkV "insjuknar" ;
  inskaffa_vb_1_V = mkV "inskaffar" ;
  inskeppa_vb_1_V = mkV "inskeppar" ;
  inskola_vb_1_V = mkV "inskolar" ;
  insomna_vb_1_V = mkV "insomnar" ;
  inspektera_vb_1_V = mkV "inspekterar" ;
  inspela_vb_1_V = mkV "inspelar" ;
  inspirera_vb_1_V = mkV "inspirerar" ;
  installera_vb_1_V = mkV "installerar" ;
  instifta_vb_1_V = mkV "instiftar" ;
  institutionalisera_vb_1_V = mkV "institutionaliserar" ;
  instruera_vb_1_V = mkV "instruerar" ;
  instrumentera_vb_1_V = mkV "instrumenterar" ;
  instraala_vb_1_1_V = mkV "instrålar" ;
  instudera_vb_1_V = mkV "instuderar" ;
  insoendra_vb_1_1_V = mkV "insöndrar" ;
  inteckna_vb_1_V = mkV "intecknar" ;
  integrera_vb_1_V = mkV "integrerar" ;
  intellektualisera_vb_1_V = mkV "intellektualiserar" ;
  intensifiera_vb_1_V = mkV "intensifierar" ;
  intensivera_vb_1_V = mkV "intensiverar" ;
  interfoliera_vb_1_V = mkV "interfolierar" ;
  internalisera_vb_1_V = mkV "internaliserar" ;
  internationalisera_vb_1_V = mkV "internationaliserar" ;
  internera_vb_1_V = mkV "internerar" ;
  interpellera_vb_1_V = mkV "interpellerar" ;
  interpolera_vb_1_V = mkV "interpolerar" ;
  interpretera_vb_1_V = mkV "interpreterar" ;
  interpunktera_vb_1_V = mkV "interpunkterar" ;
  intervenera_vb_1_V = mkV "intervenerar" ;
  intervjua_vb_1_V = mkV "intervjuar" ;
  intimisera_vb_1_V = mkV "intimiserar" ;
  intolka_vb_1_V = mkV "intolkar" ;
  intonera_vb_1_V = mkV "intonerar" ;
  intressera_vb_1_V = mkV "intresserar" ;
  introducera_vb_1_V = mkV "introducerar" ;
  intrumfa_vb_1_V = mkV "intrumfar" ;
  intraeffa_vb_1_1_V = mkV "inträffar" ;
  intyga_vb_1_V = mkV "intygar" ;
  intaaga_vb_1_1_V = mkV "intågar" ;
  invadera_vb_1_V = mkV "invaderar" ;
  invagga_vb_1_V = mkV "invaggar" ;
  invalidisera_vb_1_V = mkV "invalidiserar" ;
  invandra_vb_1_V = mkV "invandrar" ;
  inveckla_vb_1_V = mkV "invecklar" ;
  inventera_vb_1_V = mkV "inventerar" ;
  invertera_vb_1_V = mkV "inverterar" ;
  investera_vb_1_V = mkV "investerar" ;
  invitera_vb_1_V = mkV "inviterar" ;
  involvera_vb_1_V = mkV "involverar" ;
  invaenta_vb_1_1_V = mkV "inväntar" ;
  inympa_vb_1_V = mkV "inympar" ;
  inoeva_vb_1_1_V = mkV "inövar" ;
  irritera_vb_1_V = mkV "irriterar" ;
  islamisera_vb_1_V = mkV "islamiserar" ;
  isolera_vb_1_V = mkV "isolerar" ;
  iterera_vb_1_V = mkV "itererar" ;
  ituta_vb_1_V = mkV "itutar" ;
  ivaegskicka_vb_1_1_V = mkV "ivägskickar" ;
  jabba_vb_1_V = mkV "jabbar" ;
  jaga_vb_1_V = mkV "jagar" ;
  jaka_vb_1_V = mkV "jakar" ;
  jazzifiera_vb_1_V = mkV "jazzifierar" ;
  jodera_vb_1_V = mkV "joderar" ;
  jogga_vb_1_V = mkV "joggar" ;
  jojka_vb_1_V = mkV "jojkar" ;
  jonglera_vb_1_V = mkV "jonglerar" ;
  jonisera_vb_1_V = mkV "joniserar" ;
  jorda_vb_1_V = mkV "jordar" ;
  justera_vb_1_V = mkV "justerar" ;
  jaekta_vb_1_1_V = mkV "jäktar" ;
  jaemka_vb_1_1_V = mkV "jämkar" ;
  jaemna_vb_1_1_V = mkV "jämnar" ;
  jaeva_vb_1_1_V = mkV "jävar" ;
  kakla_vb_1_V = mkV "kaklar" ;
  kalandrera_vb_1_V = mkV "kalandrerar" ;
  kalavverka_vb_1_V = mkV "kalavverkar" ;
  kalcinera_vb_1_V = mkV "kalcinerar" ;
  kalfatra_vb_1_V = mkV "kalfatrar" ;
  kalibrera_vb_1_V = mkV "kalibrerar" ;
  kalka_vb_1_V = mkV "kalkar" ;
  kalkera_vb_1_V = mkV "kalkerar" ;
  kalkylera_vb_1_V = mkV "kalkylerar" ;
  kalla_vb_1_V = mkV "kallar" ;
  kallarbeta_vb_1_V = mkV "kallarbetar" ;
  kallbearbeta_vb_1_V = mkV "kallbearbetar" ;
  kallbocka_vb_1_V = mkV "kallbockar" ;
  kallhamra_vb_1_V = mkV "kallhamrar" ;
  kallna_vb_1_V = mkV "kallnar" ;
  kallpressa_vb_1_V = mkV "kallpressar" ;
  kallvalsa_vb_1_V = mkV "kallvalsar" ;
  kalmera_vb_1_V = mkV "kalmerar" ;
  kameraoevervaka_vb_1_1_V = mkV "kameraövervakar" ;
  kamma_vb_1_V = mkV "kammar" ;
  kamouflera_vb_1_V = mkV "kamouflerar" ;
  kanalisera_vb_1_V = mkV "kanaliserar" ;
  kandera_vb_1_V = mkV "kanderar" ;
  kannelera_vb_1_V = mkV "kannelerar" ;
  kanonisera_vb_1_V = mkV "kanoniserar" ;
  kanta_vb_1_V = mkV "kantar" ;
  kantra_vb_1_V = mkV "kantrar" ;
  kapa_vb_1_V = mkV "kapar" ;
  kapitalisera_vb_1_V = mkV "kapitaliserar" ;
  kapsejsa_vb_1_V = mkV "kapsejsar" ;
  kara_vb_1_V = mkV "karar" ;
  karakterisera_vb_1_V = mkV "karakteriserar" ;
  karaktaerisera_vb_1_1_V = mkV "karaktäriserar" ;
  karambolera_vb_1_V = mkV "karambolerar" ;
  karbonisera_vb_1_V = mkV "karboniserar" ;
  karda_vb_1_V = mkV "kardar" ;
  karikera_vb_1_V = mkV "karikerar" ;
  kartera_vb_1_V = mkV "karterar" ;
  kartonnera_vb_1_V = mkV "kartonnerar" ;
  karva_vb_1_V = mkV "karvar" ;
  kaskadkoppla_vb_1_V = mkV "kaskadkopplar" ;
  kassera_vb_1_V = mkV "kasserar" ;
  kasta_vb_1_V = mkV "kastar" ;
  kastrera_vb_1_V = mkV "kastrerar" ;
  katalogisera_vb_1_V = mkV "katalogiserar" ;
  katalysera_vb_1_V = mkV "katalyserar" ;
  kategorisera_vb_1_V = mkV "kategoriserar" ;
  kateterisera_vb_1_V = mkV "kateteriserar" ;
  katetrisera_vb_1_V = mkV "katetriserar" ;
  katta_vb_1_V = mkV "kattar" ;
  kauterisera_vb_1_V = mkV "kauteriserar" ;
  kedja_vb_1_V = mkV "kedjar" ;
  kicka_vb_1_V = mkV "kickar" ;
  kidnappa_vb_1_V = mkV "kidnappar" ;
  kika_vb_1_V = mkV "kikar" ;
  kila_vb_1_V = mkV "kilar" ;
  killa_vb_1_V = mkV "killar" ;
  kindpussa_vb_1_V = mkV "kindpussar" ;
  kirra_vb_1_V = mkV "kirrar" ;
  kissa_vb_1_V = mkV "kissar" ;
  kitta_vb_1_V = mkV "kittar" ;
  klacka_vb_1_V = mkV "klackar" ;
  klaga_vb_1_V = mkV "klagar" ;
  klampa_vb_2_V = mkV "klampar" ;
  klamra_vb_1_V = mkV "klamrar" ;
  klappa_vb_1_V = mkV "klappar" ;
  klara_vb_2_V = mkV "klarar" ;
  klarera_vb_1_V = mkV "klarerar" ;
  klassa_vb_1_V = mkV "klassar" ;
  klassificera_vb_1_V = mkV "klassificerar" ;
  klatscha_vb_1_V = mkV "klatschar" ;
  klena_vb_1_V = mkV "klenar" ;
  kleta_vb_1_V = mkV "kletar" ;
  klia_vb_2_V = mkV "kliar" ;
  klicka_vb_2_V = mkV "klickar" ;
  klira_vb_1_V = mkV "klirar" ;
  klocka_vb_1_V = mkV "klockar" ;
  klona_vb_1_V = mkV "klonar" ;
  klorera_vb_1_V = mkV "klorerar" ;
  klubba_vb_1_V = mkV "klubbar" ;
  kludda_vb_1_V = mkV "kluddar" ;
  klyfta_vb_1_V = mkV "klyftar" ;
  kloevja_vb_1_1_V = mkV "klövjar" ;
  knacka_vb_1_V = mkV "knackar" ;
  knarka_vb_1_V = mkV "knarkar" ;
  knata_vb_1_V = mkV "knatar" ;
  knipsa_vb_1_V = mkV "knipsar" ;
  kniva_vb_1_V = mkV "knivar" ;
  knivdoeda_vb_1_1_V = mkV "knivdödar" ;
  knivmoerda_vb_1_1_V = mkV "knivmördar" ;
  knocka_vb_1_V = mkV "knockar" ;
  knopa_vb_1_V = mkV "knopar" ;
  knorva_vb_1_V = mkV "knorvar" ;
  knuffa_vb_1_V = mkV "knuffar" ;
  knulla_vb_1_V = mkV "knullar" ;
  knuttimra_vb_1_V = mkV "knuttimrar" ;
  knaea_vb_2_1_V = mkV "knäar" ;
  knaada_vb_1_1_V = mkV "knådar" ;
  knoela_vb_1_1_V = mkV "knölar" ;
  koaffera_vb_1_V = mkV "koafferar" ;
  koagulera_vb_1_V = mkV "koagulerar" ;
  koda_vb_1_V = mkV "kodar" ;
  kodifiera_vb_1_V = mkV "kodifierar" ;
  koja_vb_1_V = mkV "kojar" ;
  kojsa_vb_1_V = mkV "kojsar" ;
  kola_vb_1_V = mkV "kolar" ;
  kola_2_vb_1_V = mkV "kolar" ;
  kolka_vb_1_V = mkV "kolkar" ;
  kolla_vb_1_V = mkV "kollar" ;
  kollapsa_vb_1_V = mkV "kollapsar" ;
  kollationera_vb_1_V = mkV "kollationerar" ;
  kollektivisera_vb_1_V = mkV "kollektiviserar" ;
  kolonisera_vb_1_V = mkV "koloniserar" ;
  kolorera_vb_1_V = mkV "kolorerar" ;
  kolportera_vb_1_V = mkV "kolporterar" ;
  kombinera_vb_1_V = mkV "kombinerar" ;
  kommatera_vb_1_V = mkV "kommaterar" ;
  kommendera_vb_1_V = mkV "kommenderar" ;
  kommentera_vb_1_V = mkV "kommenterar" ;
  kommersa_vb_1_V = mkV "kommersar" ;
  kommersialisera_vb_1_V = mkV "kommersialiserar" ;
  kommunalisera_vb_1_V = mkV "kommunaliserar" ;
  kommunicera_vb_1_V = mkV "kommunicerar" ;
  kommutera_vb_1_V = mkV "kommuterar" ;
  kompa_vb_1_V = mkV "kompar" ;
  komparera_vb_1_V = mkV "komparerar" ;
  kompensera_vb_1_V = mkV "kompenserar" ;
  kompetensfoerklara_vb_1_1_V = mkV "kompetensförklarar" ;
  kompilera_vb_1_V = mkV "kompilerar" ;
  komplettera_vb_1_V = mkV "kompletterar" ;
  komplicera_vb_1_V = mkV "komplicerar" ;
  komplimentera_vb_1_V = mkV "komplimenterar" ;
  komponera_vb_1_V = mkV "komponerar" ;
  kompostera_vb_1_V = mkV "komposterar" ;
  komprimera_vb_1_V = mkV "komprimerar" ;
  kompromettera_vb_1_V = mkV "komprometterar" ;
  koncentrera_vb_1_V = mkV "koncentrerar" ;
  koncessionera_vb_1_V = mkV "koncessionerar" ;
  koncipiera_vb_1_V = mkV "koncipierar" ;
  kondemnera_vb_1_V = mkV "kondemnerar" ;
  kondensera_vb_1_V = mkV "kondenserar" ;
  konditionera_vb_1_V = mkV "konditionerar" ;
  kondolera_vb_1_V = mkV "kondolerar" ;
  konfirmera_vb_1_V = mkV "konfirmerar" ;
  konfiskera_vb_1_V = mkV "konfiskerar" ;
  konformera_vb_1_V = mkV "konformerar" ;
  konfrontera_vb_1_V = mkV "konfronterar" ;
  konfundera_vb_1_V = mkV "konfunderar" ;
  kongruera_vb_1_V = mkV "kongruerar" ;
  konjugera_vb_1_V = mkV "konjugerar" ;
  konkludera_vb_1_V = mkV "konkluderar" ;
  konkretisera_vb_1_V = mkV "konkretiserar" ;
  konservera_vb_1_V = mkV "konserverar" ;
  konsignera_vb_1_V = mkV "konsignerar" ;
  konsolidera_vb_1_V = mkV "konsoliderar" ;
  konstatera_vb_1_V = mkV "konstaterar" ;
  konstbefrukta_vb_1_V = mkV "konstbefruktar" ;
  konstbevattna_vb_1_V = mkV "konstbevattnar" ;
  konsternera_vb_1_V = mkV "konsternerar" ;
  konstituera_vb_1_V = mkV "konstituerar" ;
  konstruera_vb_1_V = mkV "konstruerar" ;
  konststoppa_vb_1_V = mkV "konststoppar" ;
  konsultera_vb_1_V = mkV "konsulterar" ;
  konsumera_vb_1_V = mkV "konsumerar" ;
  kontakta_vb_1_V = mkV "kontaktar" ;
  kontaminera_vb_1_V = mkV "kontaminerar" ;
  kontera_vb_1_V = mkV "konterar" ;
  kontingentera_vb_1_V = mkV "kontingenterar" ;
  kontorisera_vb_1_V = mkV "kontoriserar" ;
  kontrahera_vb_1_V = mkV "kontraherar" ;
  kontraktera_vb_1_V = mkV "kontrakterar" ;
  kontramandera_vb_1_V = mkV "kontramanderar" ;
  kontrasignera_vb_1_V = mkV "kontrasignerar" ;
  kontrastera_vb_1_V = mkV "kontrasterar" ;
  kontribuera_vb_1_V = mkV "kontribuerar" ;
  kontrollera_vb_1_V = mkV "kontrollerar" ;
  kontrollstaempla_vb_1_1_V = mkV "kontrollstämplar" ;
  konturera_vb_1_V = mkV "konturerar" ;
  konvergera_vb_1_V = mkV "konvergerar" ;
  konversera_vb_1_V = mkV "konverserar" ;
  konvertera_vb_2_V = mkV "konverterar" ;
  konvojera_vb_1_V = mkV "konvojerar" ;
  koordinera_vb_1_V = mkV "koordinerar" ;
  kopiera_vb_1_V = mkV "kopierar" ;
  koppa_vb_1_V = mkV "koppar" ;
  kora_vb_1_V = mkV "korar" ;
  korka_vb_1_V = mkV "korkar" ;
  korpa_vb_1_V = mkV "korpar" ;
  korrelera_vb_1_V = mkV "korrelerar" ;
  korrigera_vb_1_V = mkV "korrigerar" ;
  korrodera_vb_1_V = mkV "korroderar" ;
  korrugera_vb_1_V = mkV "korrugerar" ;
  korrumpera_vb_1_V = mkV "korrumperar" ;
  korsa_vb_1_V = mkV "korsar" ;
  korsbefrukta_vb_1_V = mkV "korsbefruktar" ;
  korsettera_vb_1_V = mkV "korsetterar" ;
  korsvaedra_vb_1_1_V = mkV "korsvädrar" ;
  korta_vb_1_V = mkV "kortar" ;
  kortpassa_vb_1_V = mkV "kortpassar" ;
  kostymera_vb_1_V = mkV "kostymerar" ;
  kracka_vb_1_V = mkV "krackar" ;
  krackelera_vb_1_V = mkV "krackelerar" ;
  krafsa_vb_1_V = mkV "krafsar" ;
  kraftsamla_vb_1_V = mkV "kraftsamlar" ;
  krama_vb_1_V = mkV "kramar" ;
  kransa_vb_1_V = mkV "kransar" ;
  krascha_vb_1_V = mkV "kraschar" ;
  kraschlanda_vb_1_V = mkV "kraschlandar" ;
  kratsa_vb_1_V = mkV "kratsar" ;
  kratta_vb_1_V = mkV "krattar" ;
  kredensa_vb_1_V = mkV "kredensar" ;
  kreditera_vb_1_V = mkV "krediterar" ;
  kreera_vb_1_V = mkV "kreerar" ;
  kremera_vb_1_V = mkV "kremerar" ;
  kreolisera_vb_1_V = mkV "kreoliserar" ;
  krepera_vb_1_V = mkV "kreperar" ;
  kreta_vb_1_V = mkV "kretar" ;
  krevera_vb_1_V = mkV "kreverar" ;
  krigsplacera_vb_1_V = mkV "krigsplacerar" ;
  kriminalisera_vb_1_V = mkV "kriminaliserar" ;
  kringgaerda_vb_1_1_V = mkV "kringgärdar" ;
  kringskansa_vb_1_V = mkV "kringskansar" ;
  kristallisera_vb_1_V = mkV "kristalliserar" ;
  kristna_vb_1_V = mkV "kristnar" ;
  krita_vb_1_V = mkV "kritar" ;
  kritisera_vb_1_V = mkV "kritiserar" ;
  krocka_vb_1_V = mkV "krockar" ;
  kroka_vb_1_V = mkV "krokar" ;
  kroma_vb_1_V = mkV "kromar" ;
  kromgarva_vb_1_V = mkV "kromgarvar" ;
  kroppsvisitera_vb_1_V = mkV "kroppsvisiterar" ;
  krossa_vb_1_V = mkV "krossar" ;
  krulla_vb_1_V = mkV "krullar" ;
  krusa_vb_1_V = mkV "krusar" ;
  krydda_vb_1_V = mkV "kryddar" ;
  kryptera_vb_1_V = mkV "krypterar" ;
  kryssa_vb_1_V = mkV "kryssar" ;
  kraeppa_vb_1_1_V = mkV "kräppar" ;
  kraama_vb_2_1_V = mkV "kråmar" ;
  kubera_vb_1_V = mkV "kuberar" ;
  kugga_vb_1_V = mkV "kuggar" ;
  kujonera_vb_1_V = mkV "kujonerar" ;
  kulla_vb_1_V = mkV "kullar" ;
  kullkasta_vb_1_V = mkV "kullkastar" ;
  kullprata_vb_1_V = mkV "kullpratar" ;
  kultivera_vb_1_V = mkV "kultiverar" ;
  kumulera_vb_1_V = mkV "kumulerar" ;
  kupa_vb_1_V = mkV "kupar" ;
  kupera_vb_1_V = mkV "kuperar" ;
  kura_vb_1_V = mkV "kurar" ;
  kuratera_vb_1_V = mkV "kuraterar" ;
  kurera_vb_1_V = mkV "kurerar" ;
  kursa_vb_1_V = mkV "kursar" ;
  kursivera_vb_1_V = mkV "kursiverar" ;
  kurtisera_vb_1_V = mkV "kurtiserar" ;
  kuscha_vb_1_V = mkV "kuschar" ;
  kuva_vb_1_V = mkV "kuvar" ;
  kuvertera_vb_1_V = mkV "kuverterar" ;
  kvadda_vb_1_V = mkV "kvaddar" ;
  kvadrera_vb_1_V = mkV "kvadrerar" ;
  kvalificera_vb_1_V = mkV "kvalificerar" ;
  kvalitetsgranska_vb_1_V = mkV "kvalitetsgranskar" ;
  kvalitetssaekra_vb_1_1_V = mkV "kvalitetssäkrar" ;
  kvantifiera_vb_1_V = mkV "kvantifierar" ;
  kvarlaemna_vb_1_1_V = mkV "kvarlämnar" ;
  kvarstanna_vb_1_V = mkV "kvarstannar" ;
  kvicksilverbeta_vb_1_V = mkV "kvicksilverbetar" ;
  kvilta_vb_1_V = mkV "kviltar" ;
  kvista_vb_1_V = mkV "kvistar" ;
  kvitta_vb_1_V = mkV "kvittar" ;
  kvittera_vb_1_V = mkV "kvitterar" ;
  kvotera_vb_1_V = mkV "kvoterar" ;
  kyllagra_vb_1_V = mkV "kyllagrar" ;
  kypra_vb_1_V = mkV "kyprar" ;
  kaeka_vb_1_1_V = mkV "käkar" ;
  kaela_vb_1_1_V = mkV "kälar" ;
  kaellsortera_vb_1_1_V = mkV "källsorterar" ;
  kaenneteckna_vb_1_1_V = mkV "kännetecknar" ;
  kaera_vb_1_1_V = mkV "kärar" ;
  kaerna_vb_1_1_V = mkV "kärnar" ;
  kaanka_vb_1_1_V = mkV "kånkar" ;
  kaara_vb_1_1_V = mkV "kårar" ;
  koelhala_vb_2_1_V = mkV "kölhalar" ;
  koena_vb_1_1_V = mkV "könar" ;
  koensdiskriminera_vb_1_1_V = mkV "könsdiskriminerar" ;
  koenskvotera_vb_1_1_V = mkV "könskvoterar" ;
  koerna_vb_1_1_V = mkV "körnar" ;
  labialisera_vb_1_V = mkV "labialiserar" ;
  lacka_vb_1_V = mkV "lackar" ;
  lackera_vb_1_V = mkV "lackerar" ;
  ladda_vb_1_V = mkV "laddar" ;
  laga_vb_1_V = mkV "lagar" ;
  lagerkransa_vb_1_V = mkV "lagerkransar" ;
  lagga_vb_1_V = mkV "laggar" ;
  lagra_vb_1_V = mkV "lagrar" ;
  lagstifta_vb_1_V = mkV "lagstiftar" ;
  lamentera_vb_1_V = mkV "lamenterar" ;
  laminera_vb_1_V = mkV "laminerar" ;
  landa_vb_1_V = mkV "landar" ;
  landa_vb_2_V = mkV "landar" ;
  landsfoervisa_vb_1_1_V = mkV "landsförvisar" ;
  langa_vb_1_V = mkV "langar" ;
  langettera_vb_1_V = mkV "langetterar" ;
  lansera_vb_1_V = mkV "lanserar" ;
  lapa_vb_1_V = mkV "lapar" ;
  lapisera_vb_1_V = mkV "lapiserar" ;
  lappa_vb_1_V = mkV "lappar" ;
  larma_vb_2_V = mkV "larmar" ;
  lasera_vb_1_V = mkV "laserar" ;
  laska_vb_1_V = mkV "laskar" ;
  lasta_vb_1_V = mkV "lastar" ;
  latinisera_vb_1_V = mkV "latiniserar" ;
  lavera_vb_1_V = mkV "laverar" ;
  laxa_vb_1_V = mkV "laxar" ;
  leasa_vb_1_V = mkV "leasar" ;
  leda_vb_2_V = mkV "ledar" ;
  ledigfoerklara_vb_1_1_V = mkV "ledigförklarar" ;
  ledsaga_vb_1_V = mkV "ledsagar" ;
  legalisera_vb_1_V = mkV "legaliserar" ;
  legera_vb_1_V = mkV "legerar" ;
  legitimera_vb_1_V = mkV "legitimerar" ;
  lejdra_vb_1_V = mkV "lejdrar" ;
  lemlaesta_vb_1_1_V = mkV "lemlästar" ;
  lena_vb_1_V = mkV "lenar" ;
  leta_vb_1_V = mkV "letar" ;
  leverera_vb_1_V = mkV "levererar" ;
  liberalisera_vb_1_V = mkV "liberaliserar" ;
  licensera_vb_1_V = mkV "licenserar" ;
  licensiera_vb_1_V = mkV "licensierar" ;
  licentiera_vb_1_V = mkV "licentierar" ;
  liera_vb_1_V = mkV "lierar" ;
  lika_vb_1_V = mkV "likar" ;
  likrikta_vb_1_V = mkV "likriktar" ;
  likvidera_vb_1_V = mkV "likviderar" ;
  limma_vb_1_V = mkV "limmar" ;
  linda_vb_1_V = mkV "lindar" ;
  lindra_vb_1_V = mkV "lindrar" ;
  linjera_vb_1_V = mkV "linjerar" ;
  lira_vb_1_V = mkV "lirar" ;
  lissera_vb_1_V = mkV "lisserar" ;
  lista_vb_1_V = mkV "listar" ;
  litografera_vb_1_V = mkV "litograferar" ;
  litsa_vb_1_V = mkV "litsar" ;
  liva_vb_1_V = mkV "livar" ;
  livfoersaekra_vb_1_1_V = mkV "livförsäkrar" ;
  ljuda_vb_2_V = mkV "ljudar" ;
  ljudisolera_vb_1_V = mkV "ljudisolerar" ;
  ljuskopiera_vb_1_V = mkV "ljuskopierar" ;
  lobba_vb_1_V = mkV "lobbar" ;
  locka_vb_1_V = mkV "lockar" ;
  lockouta_vb_1_V = mkV "lockoutar" ;
  loda_vb_1_V = mkV "lodar" ;
  logera_vb_1_V = mkV "logerar" ;
  logga_vb_1_V = mkV "loggar" ;
  lokalbedoeva_vb_1_1_V = mkV "lokalbedövar" ;
  lokalisera_vb_1_V = mkV "lokaliserar" ;
  loppa_vb_1_V = mkV "loppar" ;
  lossa_vb_1_V = mkV "lossar" ;
  lotsa_vb_1_V = mkV "lotsar" ;
  lotta_vb_1_V = mkV "lottar" ;
  lova_vb_1_V = mkV "lovar" ;
  lovorda_vb_1_V = mkV "lovordar" ;
  lovprisa_vb_1_V = mkV "lovprisar" ;
  luffa_vb_2_V = mkV "luffar" ;
  lufta_vb_1_V = mkV "luftar" ;
  lufttorka_vb_1_V = mkV "lufttorkar" ;
  lugga_vb_1_V = mkV "luggar" ;
  lugna_vb_1_V = mkV "lugnar" ;
  lukta_vb_2_V = mkV "luktar" ;
  lulla_vb_2_V = mkV "lullar" ;
  lunna_vb_1_V = mkV "lunnar" ;
  lura_vb_1_V = mkV "lurar" ;
  lurpassa_vb_1_V = mkV "lurpassar" ;
  luta_vb_1_V = mkV "lutar" ;
  luteinisera_vb_1_V = mkV "luteiniserar" ;
  lyckoenska_vb_1_1_V = mkV "lyckönskar" ;
  lykta_vb_1_V = mkV "lyktar" ;
  lyncha_vb_1_V = mkV "lynchar" ;
  lyra_vb_1_V = mkV "lyrar" ;
  lyster_vb_1_V = mkV "lyster" ;
  lyxkonsumera_vb_1_V = mkV "lyxkonsumerar" ;
  lyxrenovera_vb_1_V = mkV "lyxrenoverar" ;
  laedera_vb_1_1_V = mkV "läderar" ;
  laegra_vb_1_1_V = mkV "lägrar" ;
  laektra_vb_1_1_V = mkV "läktrar" ;
  laemna_vb_1_1_V = mkV "lämnar" ;
  laempa_vb_1_1_V = mkV "lämpar" ;
  laenka_vb_1_1_V = mkV "länkar" ;
  laensa_vb_1_1_V = mkV "länsar" ;
  laenspumpa_vb_1_1_V = mkV "länspumpar" ;
  laer_vb_1_1_V = mkV "lär" ;
  laeska_vb_1_1_V = mkV "läskar" ;
  laetta_vb_1_1_V = mkV "lättar" ;
  laagprioritera_vb_1_1_V = mkV "lågprioriterar" ;
  laana_vb_1_1_V = mkV "lånar" ;
  laangtidsparkera_vb_1_1_V = mkV "långtidsparkerar" ;
  laanspara_vb_1_1_V = mkV "lånsparar" ;
  laassa_vb_1_1_V = mkV "låssar" ;
  laatsa_vb_1_1_V = mkV "låtsar" ;
  loega_vb_1_1_V = mkV "lögar" ;
  loena_vb_1_1_V = mkV "lönar" ;
  loennmoerda_vb_1_1_V = mkV "lönnmördar" ;
  loenspara_vb_1_1_V = mkV "lönsparar" ;
  loeva_vb_1_1_V = mkV "lövar" ;
  madrassera_vb_1_V = mkV "madrasserar" ;
  magasinera_vb_1_V = mkV "magasinerar" ;
  magnetisera_vb_1_V = mkV "magnetiserar" ;
  magpumpa_vb_1_V = mkV "magpumpar" ;
  maila_vb_1_V = mkV "mailar" ;
  maja_vb_1_V = mkV "majar" ;
  maka_vb_1_V = mkV "makar" ;
  makulera_vb_1_V = mkV "makulerar" ;
  malfobera_vb_1_V = mkV "malfoberar" ;
  malma_vb_1_V = mkV "malmar" ;
  maltraetera_vb_1_1_V = mkV "malträterar" ;
  mana_vb_1_V = mkV "manar" ;
  manifestera_vb_1_V = mkV "manifesterar" ;
  manikurera_vb_1_V = mkV "manikurerar" ;
  manikyrera_vb_1_V = mkV "manikyrerar" ;
  manipulera_vb_1_V = mkV "manipulerar" ;
  manoevrera_vb_1_1_V = mkV "manövrerar" ;
  marginalisera_vb_1_V = mkV "marginaliserar" ;
  marinera_vb_1_V = mkV "marinerar" ;
  markera_vb_1_V = mkV "markerar" ;
  marknadsanpassa_vb_1_V = mkV "marknadsanpassar" ;
  marknadsvaerdera_vb_1_1_V = mkV "marknadsvärderar" ;
  marmorera_vb_1_V = mkV "marmorerar" ;
  martera_vb_1_V = mkV "marterar" ;
  masa_vb_1_V = mkV "masar" ;
  maska_vb_2_V = mkV "maskar" ;
  maskera_vb_1_V = mkV "maskerar" ;
  maskulinisera_vb_1_V = mkV "maskuliniserar" ;
  massakrera_vb_1_V = mkV "massakrerar" ;
  massavskeda_vb_1_V = mkV "massavskedar" ;
  massera_vb_1_V = mkV "masserar" ;
  mata_vb_1_V = mkV "matar" ;
  matcha_vb_1_V = mkV "matchar" ;
  matelassera_vb_1_V = mkV "matelasserar" ;
  materialisera_vb_1_V = mkV "materialiserar" ;
  matta_vb_1_V = mkV "mattar" ;
  mattera_vb_1_V = mkV "matterar" ;
  maxa_vb_1_V = mkV "maxar" ;
  maximera_vb_1_V = mkV "maximerar" ;
  medaljera_vb_1_V = mkV "medaljerar" ;
  medicinera_vb_1_V = mkV "medicinerar" ;
  meja_vb_1_V = mkV "mejar" ;
  mejla_vb_1_V = mkV "mejlar" ;
  mejlbomba_vb_1_V = mkV "mejlbombar" ;
  mejsla_vb_1_V = mkV "mejslar" ;
  mekanisera_vb_1_V = mkV "mekaniserar" ;
  mellanlanda_vb_1_V = mkV "mellanlandar" ;
  memorera_vb_1_V = mkV "memorerar" ;
  mensa_vb_1_V = mkV "mensar" ;
  mercerisera_vb_1_V = mkV "merceriserar" ;
  meritera_vb_1_V = mkV "meriterar" ;
  messa_vb_1_V = mkV "messar" ;
  metallisera_vb_1_V = mkV "metalliserar" ;
  micra_vb_1_V = mkV "micrar" ;
  mikra_vb_1_V = mkV "mikrar" ;
  mikrofilma_vb_1_V = mkV "mikrofilmar" ;
  mikrofotografera_vb_1_V = mkV "mikrofotograferar" ;
  mikroskopera_vb_1_V = mkV "mikroskoperar" ;
  mildra_vb_1_V = mkV "mildrar" ;
  militarisera_vb_1_V = mkV "militariserar" ;
  miljoecertifiera_vb_1_1_V = mkV "miljöcertifierar" ;
  miljoefoerstoera_vb_1_1_V = mkV "miljöförstörar" ;
  mima_vb_1_V = mkV "mimar" ;
  minera_vb_1_V = mkV "minerar" ;
  mineralisera_vb_1_V = mkV "mineraliserar" ;
  miniatyrisera_vb_1_V = mkV "miniatyriserar" ;
  minimera_vb_1_V = mkV "minimerar" ;
  minska_vb_1_V = mkV "minskar" ;
  missa_vb_1_V = mkV "missar" ;
  missakta_vb_1_V = mkV "missaktar" ;
  missbruka_vb_1_V = mkV "missbrukar" ;
  missfirma_vb_1_V = mkV "missfirmar" ;
  missfaerga_vb_1_1_V = mkV "missfärgar" ;
  missgynna_vb_1_V = mkV "missgynnar" ;
  misshandla_vb_1_V = mkV "misshandlar" ;
  missivera_vb_1_V = mkV "missiverar" ;
  misskreditera_vb_1_V = mkV "misskrediterar" ;
  misstolka_vb_1_V = mkV "misstolkar" ;
  missunna_vb_1_V = mkV "missunnar" ;
  missuppfatta_vb_1_V = mkV "missuppfattar" ;
  mixa_vb_1_V = mkV "mixar" ;
  mjuka_vb_1_V = mkV "mjukar" ;
  mjuklanda_vb_1_V = mkV "mjuklandar" ;
  mjoela_vb_1_1_V = mkV "mjölar" ;
  mjoelka_vb_1_1_V = mkV "mjölkar" ;
  mobba_vb_1_V = mkV "mobbar" ;
  mobilisera_vb_1_V = mkV "mobiliserar" ;
  mocka_vb_1_V = mkV "mockar" ;
  modellera_vb_1_V = mkV "modellerar" ;
  moderera_vb_1_V = mkV "modererar" ;
  modernisera_vb_1_V = mkV "moderniserar" ;
  modifiera_vb_1_V = mkV "modifierar" ;
  modulera_vb_1_V = mkV "modulerar" ;
  modaernisera_vb_1_1_V = mkV "modärniserar" ;
  monoftongera_vb_1_V = mkV "monoftongerar" ;
  monopolisera_vb_1_V = mkV "monopoliserar" ;
  montera_vb_1_V = mkV "monterar" ;
  moppa_vb_1_V = mkV "moppar" ;
  mordhota_vb_1_V = mkV "mordhotar" ;
  morsera_vb_1_V = mkV "morserar" ;
  mortificera_vb_1_V = mkV "mortificerar" ;
  mortifiera_vb_1_V = mkV "mortifierar" ;
  mosa_vb_1_V = mkV "mosar" ;
  mota_vb_1_V = mkV "motar" ;
  motarbeta_vb_1_V = mkV "motarbetar" ;
  motbevisa_vb_1_V = mkV "motbevisar" ;
  motivera_vb_1_V = mkV "motiverar" ;
  motorisera_vb_1_V = mkV "motoriserar" ;
  motverka_vb_1_V = mkV "motverkar" ;
  mula_vb_1_V = mkV "mular" ;
  muljera_vb_1_V = mkV "muljerar" ;
  multiplicera_vb_1_V = mkV "multiplicerar" ;
  mumifiera_vb_1_V = mkV "mumifierar" ;
  mura_vb_1_V = mkV "murar" ;
  muta_vb_1_V = mkV "mutar" ;
  mutera_vb_1_V = mkV "muterar" ;
  mylla_vb_1_V = mkV "myllar" ;
  mynta_vb_1_V = mkV "myntar" ;
  mystifiera_vb_1_V = mkV "mystifierar" ;
  mytifiera_vb_1_V = mkV "mytifierar" ;
  maekla_vb_2_1_V = mkV "mäklar" ;
  maelta_vb_1_1_V = mkV "mältar" ;
  maeska_vb_1_1_V = mkV "mäskar" ;
  maestra_vb_1_1_V = mkV "mästrar" ;
  maetta_vb_1_1_V = mkV "mättar" ;
  maala_vb_1_1_V = mkV "målar" ;
  maangdubbla_vb_1_1_V = mkV "mångdubblar" ;
  maangfaldiga_vb_1_1_V = mkV "mångfaldigar" ;
  maatta_vb_1_1_V = mkV "måttar" ;
  moeblera_vb_1_1_V = mkV "möblerar" ;
  moenstra_vb_1_1_V = mkV "mönstrar" ;
  moera_vb_1_1_V = mkV "mörar" ;
  moerbulta_vb_1_1_V = mkV "mörbultar" ;
  moerda_vb_1_1_V = mkV "mördar" ;
  moerka_vb_1_1_V = mkV "mörkar" ;
  nacka_vb_1_V = mkV "nackar" ;
  nafsa_vb_1_V = mkV "nafsar" ;
  nagga_vb_1_V = mkV "naggar" ;
  nagla_vb_1_V = mkV "naglar" ;
  naja_vb_1_V = mkV "najar" ;
  nalla_vb_1_V = mkV "nallar" ;
  namna_vb_1_V = mkV "namnar" ;
  nappa_vb_2_V = mkV "nappar" ;
  nara_vb_1_V = mkV "narar" ;
  narra_vb_1_V = mkV "narrar" ;
  narva_vb_1_V = mkV "narvar" ;
  nasa_vb_1_V = mkV "nasar" ;
  nasalera_vb_1_V = mkV "nasalerar" ;
  nasalisera_vb_1_V = mkV "nasaliserar" ;
  nationalisera_vb_1_V = mkV "nationaliserar" ;
  natta_vb_1_V = mkV "nattar" ;
  naturalisera_vb_1_V = mkV "naturaliserar" ;
  navigera_vb_1_V = mkV "navigerar" ;
  navla_vb_1_V = mkV "navlar" ;
  nedarbeta_vb_1_V = mkV "nedarbetar" ;
  nedisa_vb_1_V = mkV "nedisar" ;
  nedkalla_vb_1_V = mkV "nedkallar" ;
  nedkasta_vb_1_V = mkV "nedkastar" ;
  nedkavla_vb_1_V = mkV "nedkavlar" ;
  nedklassa_vb_1_V = mkV "nedklassar" ;
  nedrusta_vb_1_V = mkV "nedrustar" ;
  nedsalta_vb_1_V = mkV "nedsaltar" ;
  nedteckna_vb_1_V = mkV "nedtecknar" ;
  nedtransformera_vb_1_V = mkV "nedtransformerar" ;
  nedtransponera_vb_1_V = mkV "nedtransponerar" ;
  nedtrappa_vb_1_V = mkV "nedtrappar" ;
  nedtysta_vb_1_V = mkV "nedtystar" ;
  nedvaerdera_vb_1_1_V = mkV "nedvärderar" ;
  negera_vb_1_V = mkV "negerar" ;
  negligera_vb_1_V = mkV "negligerar" ;
  negociera_vb_1_V = mkV "negocierar" ;
  negotiera_vb_1_V = mkV "negotierar" ;
  neka_vb_1_V = mkV "nekar" ;
  nerarbeta_vb_1_V = mkV "nerarbetar" ;
  nerisa_vb_1_V = mkV "nerisar" ;
  nerkalla_vb_1_V = mkV "nerkallar" ;
  nerkasta_vb_1_V = mkV "nerkastar" ;
  nerkavla_vb_1_V = mkV "nerkavlar" ;
  nerklassa_vb_1_V = mkV "nerklassar" ;
  nerrusta_vb_1_V = mkV "nerrustar" ;
  nersalta_vb_1_V = mkV "nersaltar" ;
  nerteckna_vb_1_V = mkV "nertecknar" ;
  nertransformera_vb_1_V = mkV "nertransformerar" ;
  nertransponera_vb_1_V = mkV "nertransponerar" ;
  nertrappa_vb_1_V = mkV "nertrappar" ;
  nertysta_vb_1_V = mkV "nertystar" ;
  nervaerdera_vb_1_1_V = mkV "nervärderar" ;
  neurotisera_vb_1_V = mkV "neurotiserar" ;
  neutralisera_vb_1_V = mkV "neutraliserar" ;
  nia_vb_1_V = mkV "niar" ;
  nicka_vb_2_V = mkV "nickar" ;
  niellera_vb_1_V = mkV "niellerar" ;
  nita_vb_1_V = mkV "nitar" ;
  nita_vb_2_V = mkV "nitar" ;
  nitrera_vb_1_V = mkV "nitrerar" ;
  nivellera_vb_1_V = mkV "nivellerar" ;
  nivaagruppera_vb_1_1_V = mkV "nivågrupperar" ;
  nobba_vb_1_V = mkV "nobbar" ;
  nobilisera_vb_1_V = mkV "nobiliserar" ;
  nocka_vb_1_V = mkV "nockar" ;
  nolla_vb_1_V = mkV "nollar" ;
  nominera_vb_1_V = mkV "nominerar" ;
  nonchalera_vb_1_V = mkV "nonchalerar" ;
  noppa_vb_1_V = mkV "noppar" ;
  noppra_vb_1_V = mkV "nopprar" ;
  normalisera_vb_1_V = mkV "normaliserar" ;
  normera_vb_1_V = mkV "normerar" ;
  norpa_vb_1_V = mkV "norpar" ;
  nota_vb_1_V = mkV "notar" ;
  notera_vb_1_V = mkV "noterar" ;
  notificera_vb_1_V = mkV "notificerar" ;
  notifiera_vb_1_V = mkV "notifierar" ;
  notisera_vb_1_V = mkV "notiserar" ;
  nubba_vb_1_V = mkV "nubbar" ;
  nudda_vb_1_V = mkV "nuddar" ;
  numrera_vb_1_V = mkV "numrerar" ;
  nuppa_vb_1_V = mkV "nuppar" ;
  nyansera_vb_1_V = mkV "nyanserar" ;
  nyanskaffa_vb_1_V = mkV "nyanskaffar" ;
  nydana_vb_1_V = mkV "nydanar" ;
  nyemittera_vb_1_V = mkV "nyemitterar" ;
  nyetablera_vb_1_V = mkV "nyetablerar" ;
  nyinvestera_vb_1_V = mkV "nyinvesterar" ;
  nynna_vb_1_V = mkV "nynnar" ;
  nyplantera_vb_1_V = mkV "nyplanterar" ;
  nyskapa_vb_1_V = mkV "nyskapar" ;
  nysta_vb_1_V = mkV "nystar" ;
  nyteckna_vb_1_V = mkV "nytecknar" ;
  nyttja_vb_1_V = mkV "nyttjar" ;
  naerma_vb_1_1_V = mkV "närmar" ;
  naerstudera_vb_1_1_V = mkV "närstuderar" ;
  naeta_vb_1_1_V = mkV "nätar" ;
  naada_vb_1_1_V = mkV "nådar" ;
  naade_vb_1_1_V = mkV "nåde" ;
  naala_vb_1_1_V = mkV "nålar" ;
  naata_vb_1_1_V = mkV "nåtar" ;
  noedbromsa_vb_1_1_V = mkV "nödbromsar" ;
  noedga_vb_1_1_V = mkV "nödgar" ;
  noedlanda_vb_1_1_V = mkV "nödlandar" ;
  noedsaka_vb_1_1_V = mkV "nödsakar" ;
  noedstoppa_vb_1_1_V = mkV "nödstoppar" ;
  noedoeppna_vb_1_1_V = mkV "nödöppnar" ;
  obducera_vb_1_V = mkV "obducerar" ;
  objektivera_vb_1_V = mkV "objektiverar" ;
  obligera_vb_1_V = mkV "obligerar" ;
  observera_vb_1_V = mkV "observerar" ;
  occidentalisera_vb_1_V = mkV "occidentaliserar" ;
  ockupera_vb_1_V = mkV "ockuperar" ;
  odla_vb_1_V = mkV "odlar" ;
  offerera_vb_1_V = mkV "offererar" ;
  ofreda_vb_1_V = mkV "ofredar" ;
  ogilla_vb_1_V = mkV "ogillar" ;
  oka_vb_1_V = mkV "okar" ;
  oktrojera_vb_1_V = mkV "oktrojerar" ;
  okulera_vb_1_V = mkV "okulerar" ;
  okvaeda_vb_1_1_V = mkV "okvädar" ;
  ola_vb_1_V = mkV "olar" ;
  olagligfoerklara_vb_1_1_V = mkV "olagligförklarar" ;
  olja_vb_1_V = mkV "oljar" ;
  olla_vb_1_V = mkV "ollar" ;
  omarbeta_vb_1_V = mkV "omarbetar" ;
  ombilda_vb_1_V = mkV "ombildar" ;
  omdana_vb_1_V = mkV "omdanar" ;
  omdirigera_vb_1_V = mkV "omdirigerar" ;
  omfamna_vb_1_V = mkV "omfamnar" ;
  omfatta_vb_1_V = mkV "omfattar" ;
  omflytta_vb_1_V = mkV "omflyttar" ;
  omforma_vb_1_V = mkV "omformar" ;
  omfoerdela_vb_1_1_V = mkV "omfördelar" ;
  omfoerhandla_vb_1_1_V = mkV "omförhandlar" ;
  omgestalta_vb_1_V = mkV "omgestaltar" ;
  omgruppera_vb_1_V = mkV "omgrupperar" ;
  omgaerda_vb_1_1_V = mkV "omgärdar" ;
  omhulda_vb_1_V = mkV "omhuldar" ;
  omhaegna_vb_1_1_V = mkV "omhägnar" ;
  omhaekta_vb_1_1_V = mkV "omhäktar" ;
  omkasta_vb_1_V = mkV "omkastar" ;
  omkostymera_vb_1_V = mkV "omkostymerar" ;
  omkransa_vb_1_V = mkV "omkransar" ;
  omkretsa_vb_1_V = mkV "omkretsar" ;
  ommoeblera_vb_1_1_V = mkV "ommöblerar" ;
  omorganisera_vb_1_V = mkV "omorganiserar" ;
  omplacera_vb_1_V = mkV "omplacerar" ;
  omplaastra_vb_1_1_V = mkV "omplåstrar" ;
  omproeva_vb_1_1_V = mkV "omprövar" ;
  omrama_vb_1_V = mkV "omramar" ;
  omringa_vb_1_V = mkV "omringar" ;
  omraekna_vb_1_1_V = mkV "omräknar" ;
  omskapa_vb_1_V = mkV "omskapar" ;
  omskola_vb_1_V = mkV "omskolar" ;
  omskulpturera_vb_1_V = mkV "omskulpturerar" ;
  omslingra_vb_1_V = mkV "omslingrar" ;
  omstrukturera_vb_1_V = mkV "omstrukturerar" ;
  omstraala_vb_1_1_V = mkV "omstrålar" ;
  omstoerta_vb_1_1_V = mkV "omstörtar" ;
  omsvaerma_vb_1_1_V = mkV "omsvärmar" ;
  omtala_vb_1_V = mkV "omtalar" ;
  omtolka_vb_1_V = mkV "omtolkar" ;
  omvandla_vb_1_V = mkV "omvandlar" ;
  omvittna_vb_1_V = mkV "omvittnar" ;
  omvaerdera_vb_1_1_V = mkV "omvärderar" ;
  omyndigfoerklara_vb_1_1_V = mkV "omyndigförklarar" ;
  omaendra_vb_1_1_V = mkV "omändrar" ;
  ondulera_vb_1_V = mkV "ondulerar" ;
  operationalisera_vb_1_V = mkV "operationaliserar" ;
  operera_vb_1_V = mkV "opererar" ;
  oppamma_vb_1_V = mkV "oppammar" ;
  opparbeta_vb_1_V = mkV "opparbetar" ;
  oppassa_vb_1_V = mkV "oppassar" ;
  oppblanda_vb_1_V = mkV "oppblandar" ;
  oppbringa_vb_1_V = mkV "oppbringar" ;
  oppdaga_vb_1_V = mkV "oppdagar" ;
  oppdatera_vb_1_V = mkV "oppdaterar" ;
  oppdela_vb_1_V = mkV "oppdelar" ;
  oppegga_vb_1_V = mkV "oppeggar" ;
  oppfatta_vb_1_V = mkV "oppfattar" ;
  oppfostra_vb_1_V = mkV "oppfostrar" ;
  oppfriska_vb_1_V = mkV "oppfriskar" ;
  oppfaanga_vb_1_1_V = mkV "oppfångar" ;
  opphetsa_vb_1_V = mkV "opphetsar" ;
  opphetta_vb_1_V = mkV "opphettar" ;
  opphitta_vb_1_V = mkV "opphittar" ;
  opphaemta_vb_1_1_V = mkV "opphämtar" ;
  oppjustera_vb_1_V = mkV "oppjusterar" ;
  oppkalla_vb_1_V = mkV "oppkallar" ;
  oppklara_vb_1_V = mkV "oppklarar" ;
  oppliva_vb_1_V = mkV "opplivar" ;
  oppmuntra_vb_1_V = mkV "oppmuntrar" ;
  opponera_vb_1_V = mkV "opponerar" ;
  opprada_vb_1_V = mkV "oppradar" ;
  opprensa_vb_1_V = mkV "opprensar" ;
  oppraekna_vb_1_1_V = mkV "oppräknar" ;
  oppsamla_vb_1_V = mkV "oppsamlar" ;
  oppsnabba_vb_1_V = mkV "oppsnabbar" ;
  oppsummera_vb_1_V = mkV "oppsummerar" ;
  opptorna_vb_1_V = mkV "opptornar" ;
  opptrappa_vb_1_V = mkV "opptrappar" ;
  opptrissa_vb_1_V = mkV "opptrissar" ;
  oppvakta_vb_1_V = mkV "oppvaktar" ;
  oppvisa_vb_1_V = mkV "oppvisar" ;
  oppvaerdera_vb_1_1_V = mkV "oppvärderar" ;
  oppoeva_vb_1_1_V = mkV "oppövar" ;
  optimera_vb_1_V = mkV "optimerar" ;
  ordinera_vb_1_V = mkV "ordinerar" ;
  ordna_vb_1_V = mkV "ordnar" ;
  oreda_vb_1_V = mkV "oredar" ;
  orena_vb_1_V = mkV "orenar" ;
  organisera_vb_1_V = mkV "organiserar" ;
  orientera_vb_2_V = mkV "orienterar" ;
  orkestrera_vb_1_V = mkV "orkestrerar" ;
  ornamentera_vb_1_V = mkV "ornamenterar" ;
  ornera_vb_1_V = mkV "ornerar" ;
  oroa_vb_1_V = mkV "oroar" ;
  orsaka_vb_1_V = mkV "orsakar" ;
  oskaera_vb_1_1_V = mkV "oskärar" ;
  osnygga_vb_1_V = mkV "osnyggar" ;
  osaekra_vb_1_1_V = mkV "osäkrar" ;
  outa_vb_1_V = mkV "outar" ;
  oxidera_vb_1_V = mkV "oxiderar" ;
  pacificera_vb_1_V = mkV "pacificerar" ;
  packa_vb_1_V = mkV "packar" ;
  paginera_vb_1_V = mkV "paginerar" ;
  paja_vb_1_V = mkV "pajar" ;
  paketera_vb_1_V = mkV "paketerar" ;
  palatalisera_vb_1_V = mkV "palataliserar" ;
  paljettera_vb_1_V = mkV "paljetterar" ;
  palla_vb_1_V = mkV "pallar" ;
  palma_vb_1_V = mkV "palmar" ;
  palpera_vb_1_V = mkV "palperar" ;
  panela_vb_1_V = mkV "panelar" ;
  panera_vb_1_V = mkV "panerar" ;
  panga_vb_2_V = mkV "pangar" ;
  panikbromsa_vb_1_V = mkV "panikbromsar" ;
  panorera_vb_1_V = mkV "panorerar" ;
  pansra_vb_1_V = mkV "pansrar" ;
  panta_vb_1_V = mkV "pantar" ;
  pantografera_vb_1_V = mkV "pantograferar" ;
  para_vb_1_V = mkV "parar" ;
  paradera_vb_1_V = mkV "paraderar" ;
  parafera_vb_1_V = mkV "paraferar" ;
  paraffinera_vb_1_V = mkV "paraffinerar" ;
  parafrasera_vb_1_V = mkV "parafraserar" ;
  parallellisera_vb_1_V = mkV "parallelliserar" ;
  parallellkoppla_vb_1_V = mkV "parallellkopplar" ;
  paralysera_vb_1_V = mkV "paralyserar" ;
  parera_vb_1_V = mkV "parerar" ;
  parfymera_vb_1_V = mkV "parfymerar" ;
  parkera_vb_1_V = mkV "parkerar" ;
  parkettera_vb_1_V = mkV "parketterar" ;
  parodiera_vb_1_V = mkV "parodierar" ;
  parsa_vb_1_V = mkV "parsar" ;
  passa_vb_2_V = mkV "passar" ;
  passera_vb_1_V = mkV "passerar" ;
  passivera_vb_1_V = mkV "passiverar" ;
  passivisera_vb_1_V = mkV "passiviserar" ;
  pastoerisera_vb_1_1_V = mkV "pastöriserar" ;
  patentera_vb_1_V = mkV "patenterar" ;
  patinera_vb_1_V = mkV "patinerar" ;
  patrullera_vb_1_V = mkV "patrullerar" ;
  pauperisera_vb_1_V = mkV "pauperiserar" ;
  pausa_vb_1_V = mkV "pausar" ;
  pausera_vb_1_V = mkV "pauserar" ;
  pauskommatera_vb_1_V = mkV "pauskommaterar" ;
  paxa_vb_1_V = mkV "paxar" ;
  pejla_vb_1_V = mkV "pejlar" ;
  pelletera_vb_1_V = mkV "pelleterar" ;
  penetrera_vb_1_V = mkV "penetrerar" ;
  pensionera_vb_1_V = mkV "pensionerar" ;
  peppa_vb_1_V = mkV "peppar" ;
  pepparspreja_vb_1_V = mkV "pepparsprejar" ;
  peppra_vb_1_V = mkV "pepprar" ;
  percipiera_vb_1_V = mkV "percipierar" ;
  perforera_vb_1_V = mkV "perforerar" ;
  periodisera_vb_1_V = mkV "periodiserar" ;
  permanenta_vb_1_V = mkV "permanentar" ;
  permanentondulera_vb_1_V = mkV "permanentondulerar" ;
  permittera_vb_1_V = mkV "permitterar" ;
  permutera_vb_1_V = mkV "permuterar" ;
  persiflera_vb_1_V = mkV "persiflerar" ;
  personifiera_vb_1_V = mkV "personifierar" ;
  personkryssa_vb_1_V = mkV "personkryssar" ;
  persvadera_vb_1_V = mkV "persvaderar" ;
  pervertera_vb_1_V = mkV "perverterar" ;
  peta_vb_2_V = mkV "petar" ;
  petrifiera_vb_1_V = mkV "petrifierar" ;
  picka_vb_1_V = mkV "pickar" ;
  pierca_vb_1_V = mkV "piercar" ;
  pika_vb_1_V = mkV "pikar" ;
  pikera_vb_1_V = mkV "pikerar" ;
  pilka_vb_1_V = mkV "pilkar" ;
  pimpa_vb_1_V = mkV "pimpar" ;
  pina_vb_1_V = mkV "pinar" ;
  pincera_vb_1_V = mkV "pincerar" ;
  pinna_vb_1_V = mkV "pinnar" ;
  pippa_vb_1_V = mkV "pippar" ;
  pirka_vb_1_V = mkV "pirkar" ;
  piska_vb_1_V = mkV "piskar" ;
  pistolhota_vb_1_V = mkV "pistolhotar" ;
  placera_vb_1_V = mkV "placerar" ;
  plagiera_vb_1_V = mkV "plagierar" ;
  plana_vb_1_V = mkV "planar" ;
  planera_vb_1_V = mkV "planerar" ;
  planka_vb_2_V = mkV "plankar" ;
  planta_vb_1_V = mkV "plantar" ;
  plantera_vb_1_V = mkV "planterar" ;
  plasta_vb_1_V = mkV "plastar" ;
  platinera_vb_1_V = mkV "platinerar" ;
  pligga_vb_1_V = mkV "pliggar" ;
  plissera_vb_1_V = mkV "plisserar" ;
  plocka_vb_1_V = mkV "plockar" ;
  ploga_vb_1_V = mkV "plogar" ;
  plombera_vb_1_V = mkV "plomberar" ;
  plotta_vb_1_V = mkV "plottar" ;
  plugga_vb_1_V = mkV "pluggar" ;
  plysa_vb_1_V = mkV "plysar" ;
  plaetera_vb_1_1_V = mkV "pläterar" ;
  plaaga_vb_1_1_V = mkV "plågar" ;
  plaastra_vb_1_1_V = mkV "plåstrar" ;
  plaata_vb_1_1_V = mkV "plåtar" ;
  pochera_vb_1_V = mkV "pocherar" ;
  pointera_vb_1_V = mkV "pointerar" ;
  polarisera_vb_1_V = mkV "polariserar" ;
  polera_vb_1_V = mkV "polerar" ;
  polisbevaka_vb_1_V = mkV "polisbevakar" ;
  politisera_vb_1_V = mkV "politiserar" ;
  pollettera_vb_1_V = mkV "polletterar" ;
  pollinera_vb_1_V = mkV "pollinerar" ;
  pomadera_vb_1_V = mkV "pomaderar" ;
  poppa_vb_1_V = mkV "poppar" ;
  popularisera_vb_1_V = mkV "populariserar" ;
  porta_vb_1_V = mkV "portar" ;
  portionera_vb_1_V = mkV "portionerar" ;
  portraettera_vb_1_1_V = mkV "porträtterar" ;
  posta_vb_1_V = mkV "postar" ;
  postdatera_vb_1_V = mkV "postdaterar" ;
  postera_vb_1_V = mkV "posterar" ;
  postponera_vb_1_V = mkV "postponerar" ;
  postroesta_vb_1_1_V = mkV "poströstar" ;
  poststaempla_vb_1_1_V = mkV "poststämplar" ;
  postulera_vb_1_V = mkV "postulerar" ;
  poaengtera_vb_1_1_V = mkV "poängterar" ;
  praktisera_vb_1_V = mkV "praktiserar" ;
  precisera_vb_1_V = mkV "preciserar" ;
  predestinera_vb_1_V = mkV "predestinerar" ;
  predicera_vb_1_V = mkV "predicerar" ;
  predika_vb_1_V = mkV "predikar" ;
  predisponera_vb_1_V = mkV "predisponerar" ;
  prefabricera_vb_1_V = mkV "prefabricerar" ;
  preferera_vb_1_V = mkV "prefererar" ;
  prefigera_vb_1_V = mkV "prefigerar" ;
  preja_vb_1_V = mkV "prejar" ;
  preludiera_vb_1_V = mkV "preludierar" ;
  premiera_vb_1_V = mkV "premierar" ;
  premiaervisa_vb_1_1_V = mkV "premiärvisar" ;
  preparera_vb_1_V = mkV "preparerar" ;
  presenta_vb_1_V = mkV "presentar" ;
  presentera_vb_1_V = mkV "presenterar" ;
  preservera_vb_1_V = mkV "preserverar" ;
  preskribera_vb_1_V = mkV "preskriberar" ;
  pressa_vb_1_V = mkV "pressar" ;
  prestera_vb_1_V = mkV "presterar" ;
  presumera_vb_1_V = mkV "presumerar" ;
  pricka_vb_1_V = mkV "prickar" ;
  prioritera_vb_1_V = mkV "prioriterar" ;
  prisa_vb_1_V = mkV "prisar" ;
  prisreglera_vb_1_V = mkV "prisreglerar" ;
  privatisera_vb_1_V = mkV "privatiserar" ;
  privilegiera_vb_1_V = mkV "privilegierar" ;
  probera_vb_1_V = mkV "proberar" ;
  problematisera_vb_1_V = mkV "problematiserar" ;
  processa_vb_2_V = mkV "processar" ;
  producera_vb_1_V = mkV "producerar" ;
  profanera_vb_1_V = mkV "profanerar" ;
  professionalisera_vb_1_V = mkV "professionaliserar" ;
  profilera_vb_1_V = mkV "profilerar" ;
  prognostisera_vb_1_V = mkV "prognostiserar" ;
  programmera_vb_1_V = mkV "programmerar" ;
  projektera_vb_1_V = mkV "projekterar" ;
  projicera_vb_1_V = mkV "projicerar" ;
  proklamera_vb_1_V = mkV "proklamerar" ;
  proletarisera_vb_1_V = mkV "proletariserar" ;
  prolongera_vb_1_V = mkV "prolongerar" ;
  promovera_vb_1_V = mkV "promoverar" ;
  promulgera_vb_1_V = mkV "promulgerar" ;
  prononcera_vb_1_V = mkV "prononcerar" ;
  proponera_vb_1_V = mkV "proponerar" ;
  proportionera_vb_1_V = mkV "proportionerar" ;
  proppa_vb_1_V = mkV "proppar" ;
  proskribera_vb_1_V = mkV "proskriberar" ;
  prospektera_vb_1_V = mkV "prospekterar" ;
  protegera_vb_1_V = mkV "protegerar" ;
  protokollera_vb_1_V = mkV "protokollerar" ;
  prova_vb_1_V = mkV "provar" ;
  provocera_vb_1_V = mkV "provocerar" ;
  provroersbefrukta_vb_1_1_V = mkV "provrörsbefruktar" ;
  pruta_vb_1_V = mkV "prutar" ;
  praegla_vb_1_1_V = mkV "präglar" ;
  praenta_vb_1_1_V = mkV "präntar" ;
  praama_vb_1_1_V = mkV "pråmar" ;
  proejsa_vb_1_1_V = mkV "pröjsar" ;
  proeva_vb_1_1_V = mkV "prövar" ;
  psyka_vb_1_V = mkV "psykar" ;
  psykoanalysera_vb_1_V = mkV "psykoanalyserar" ;
  psykologisera_vb_1_V = mkV "psykologiserar" ;
  publicera_vb_1_V = mkV "publicerar" ;
  pudra_vb_1_V = mkV "pudrar" ;
  puffa_vb_2_V = mkV "puffar" ;
  pulverisera_vb_1_V = mkV "pulveriserar" ;
  pulverlackera_vb_1_V = mkV "pulverlackerar" ;
  pulvrisera_vb_1_V = mkV "pulvriserar" ;
  pumpa_vb_1_V = mkV "pumpar" ;
  punkta_vb_1_V = mkV "punktar" ;
  punktbevaka_vb_1_V = mkV "punktbevakar" ;
  punktera_vb_1_V = mkV "punkterar" ;
  punktmarkera_vb_1_V = mkV "punktmarkerar" ;
  punktsvetsa_vb_1_V = mkV "punktsvetsar" ;
  punsa_vb_1_V = mkV "punsar" ;
  purgera_vb_1_V = mkV "purgerar" ;
  purpra_vb_1_V = mkV "purprar" ;
  purpurfaerga_vb_1_1_V = mkV "purpurfärgar" ;
  purra_vb_1_V = mkV "purrar" ;
  pusha_vb_1_V = mkV "pushar" ;
  pussa_vb_1_V = mkV "pussar" ;
  putsa_vb_1_V = mkV "putsar" ;
  putta_vb_1_V = mkV "puttar" ;
  pynta_vb_1_V = mkV "pyntar" ;
  pytsa_vb_1_V = mkV "pytsar" ;
  paela_vb_1_1_V = mkV "pälar" ;
  paaa_vb_1_1_V = mkV "påar" ;
  paaannonsera_vb_1_1_V = mkV "påannonserar" ;
  paaboerda_vb_1_1_V = mkV "påbördar" ;
  paaboerja_vb_1_1_V = mkV "påbörjar" ;
  paadyvla_vb_1_1_V = mkV "pådyvlar" ;
  paafordra_vb_1_1_V = mkV "påfordrar" ;
  paakalla_vb_1_1_V = mkV "påkallar" ;
  paala_vb_1_1_V = mkV "pålar" ;
  paapeka_vb_1_1_V = mkV "påpekar" ;
  paaropa_vb_1_1_V = mkV "påropar" ;
  paaraekna_vb_1_1_V = mkV "påräknar" ;
  paaskynda_vb_1_1_V = mkV "påskyndar" ;
  paatala_vb_1_1_V = mkV "påtalar" ;
  paatraeffa_vb_1_1_V = mkV "påträffar" ;
  paaverka_vb_1_1_V = mkV "påverkar" ;
  paavisa_vb_1_1_V = mkV "påvisar" ;
  paayrka_vb_1_1_V = mkV "påyrkar" ;
  quilta_vb_1_V = mkV "quiltar" ;
  rabattera_vb_1_V = mkV "rabatterar" ;
  racka_vb_1_V = mkV "rackar" ;
  radera_vb_1_V = mkV "raderar" ;
  radiera_vb_1_V = mkV "radierar" ;
  radikalisera_vb_1_V = mkV "radikaliserar" ;
  raffinera_vb_1_V = mkV "raffinerar" ;
  ragga_vb_1_V = mkV "raggar" ;
  raka_vb_1_V = mkV "rakar" ;
  rama_vb_1_V = mkV "ramar" ;
  ramma_vb_1_V = mkV "rammar" ;
  ramponera_vb_1_V = mkV "ramponerar" ;
  ramsa_vb_1_V = mkV "ramsar" ;
  randa_vb_1_V = mkV "randar" ;
  randomisera_vb_1_V = mkV "randomiserar" ;
  rangera_vb_1_V = mkV "rangerar" ;
  rangordna_vb_1_V = mkV "rangordnar" ;
  ranka_vb_1_V = mkV "rankar" ;
  rannsaka_vb_1_V = mkV "rannsakar" ;
  ransonera_vb_1_V = mkV "ransonerar" ;
  rappa_vb_1_V = mkV "rappar" ;
  rappellera_vb_1_V = mkV "rappellerar" ;
  rapportera_vb_1_V = mkV "rapporterar" ;
  rasdiskriminera_vb_1_V = mkV "rasdiskriminerar" ;
  rasera_vb_1_V = mkV "raserar" ;
  raspa_vb_1_V = mkV "raspar" ;
  rasta_vb_2_V = mkV "rastar" ;
  rata_vb_1_V = mkV "ratar" ;
  ratificera_vb_1_V = mkV "ratificerar" ;
  rationalisera_vb_1_V = mkV "rationaliserar" ;
  ratta_vb_1_V = mkV "rattar" ;
  rea_vb_1_V = mkV "rear" ;
  reaktivera_vb_1_V = mkV "reaktiverar" ;
  realisera_vb_1_V = mkV "realiserar" ;
  reassurera_vb_1_V = mkV "reassurerar" ;
  recensera_vb_1_V = mkV "recenserar" ;
  recipiera_vb_1_V = mkV "recipierar" ;
  recitera_vb_1_V = mkV "reciterar" ;
  redigera_vb_1_V = mkV "redigerar" ;
  redovisa_vb_1_V = mkV "redovisar" ;
  redubbla_vb_1_V = mkV "redubblar" ;
  reducera_vb_1_V = mkV "reducerar" ;
  referera_vb_1_V = mkV "refererar" ;
  reflektera_vb_1_V = mkV "reflekterar" ;
  reformera_vb_1_V = mkV "reformerar" ;
  refusera_vb_1_V = mkV "refuserar" ;
  regalera_vb_1_V = mkV "regalerar" ;
  regenerera_vb_1_V = mkV "regenererar" ;
  regera_vb_1_V = mkV "regerar" ;
  regissera_vb_1_V = mkV "regisserar" ;
  registrera_vb_1_V = mkV "registrerar" ;
  reglementera_vb_1_V = mkV "reglementerar" ;
  reglera_vb_1_V = mkV "reglerar" ;
  reglera_vb_2_V = mkV "reglerar" ;
  regummera_vb_1_V = mkV "regummerar" ;
  rehabilitera_vb_1_V = mkV "rehabiliterar" ;
  reinkarnera_vb_1_V = mkV "reinkarnerar" ;
  reka_vb_1_V = mkV "rekar" ;
  rekapitulera_vb_1_V = mkV "rekapitulerar" ;
  reklamera_vb_1_V = mkV "reklamerar" ;
  rekognoscera_vb_1_V = mkV "rekognoscerar" ;
  rekognosera_vb_1_V = mkV "rekognoserar" ;
  rekommendera_vb_1_V = mkV "rekommenderar" ;
  rekompensera_vb_1_V = mkV "rekompenserar" ;
  rekonstruera_vb_1_V = mkV "rekonstruerar" ;
  rekrytera_vb_1_V = mkV "rekryterar" ;
  rektificera_vb_1_V = mkV "rektificerar" ;
  rektifiera_vb_1_V = mkV "rektifierar" ;
  rekvirera_vb_1_V = mkV "rekvirerar" ;
  relatera_vb_1_V = mkV "relaterar" ;
  relegera_vb_1_V = mkV "relegerar" ;
  relaea_vb_1_1_V = mkV "reläar" ;
  remissbehandla_vb_1_V = mkV "remissbehandlar" ;
  remittera_vb_1_V = mkV "remitterar" ;
  remma_vb_1_V = mkV "remmar" ;
  remplacera_vb_1_V = mkV "remplacerar" ;
  rena_vb_1_V = mkV "renar" ;
  rendera_vb_1_V = mkV "renderar" ;
  renodla_vb_1_V = mkV "renodlar" ;
  renovera_vb_1_V = mkV "renoverar" ;
  renraka_vb_1_V = mkV "renrakar" ;
  rensa_vb_1_V = mkV "rensar" ;
  reorganisera_vb_1_V = mkV "reorganiserar" ;
  repa_vb_1_V = mkV "repar" ;
  reparera_vb_1_V = mkV "reparerar" ;
  repartisera_vb_1_V = mkV "repartiserar" ;
  repatriera_vb_1_V = mkV "repatrierar" ;
  repellera_vb_1_V = mkV "repellerar" ;
  repetera_vb_1_V = mkV "repeterar" ;
  representera_vb_1_V = mkV "representerar" ;
  reprisera_vb_1_V = mkV "repriserar" ;
  reproducera_vb_1_V = mkV "reproducerar" ;
  reservera_vb_1_V = mkV "reserverar" ;
  resolvera_vb_1_V = mkV "resolverar" ;
  resorbera_vb_1_V = mkV "resorberar" ;
  respektera_vb_1_V = mkV "respekterar" ;
  respirera_vb_1_V = mkV "respirerar" ;
  restaurera_vb_1_V = mkV "restaurerar" ;
  restituera_vb_1_V = mkV "restituerar" ;
  resumera_vb_1_V = mkV "resumerar" ;
  reta_vb_1_V = mkV "retar" ;
  retablera_vb_1_V = mkV "retablerar" ;
  retardera_vb_1_V = mkV "retarderar" ;
  returnera_vb_1_V = mkV "returnerar" ;
  retuschera_vb_1_V = mkV "retuscherar" ;
  reva_vb_1_V = mkV "revar" ;
  revalvera_vb_1_V = mkV "revalverar" ;
  revetera_vb_1_V = mkV "reveterar" ;
  revidera_vb_1_V = mkV "reviderar" ;
  revolutionera_vb_1_V = mkV "revolutionerar" ;
  ria_vb_1_V = mkV "riar" ;
  rigga_vb_1_V = mkV "riggar" ;
  rikoschettera_vb_1_V = mkV "rikoschetterar" ;
  rikta_vb_1_V = mkV "riktar" ;
  rimma_vb_1_V = mkV "rimmar" ;
  rimsalta_vb_1_V = mkV "rimsaltar" ;
  ringa_vb_2_V = mkV "ringar" ;
  ringakta_vb_1_V = mkV "ringaktar" ;
  ringbarka_vb_1_V = mkV "ringbarkar" ;
  risa_vb_1_V = mkV "risar" ;
  rispa_vb_1_V = mkV "rispar" ;
  rista_vb_1_V = mkV "ristar" ;
  rita_vb_1_V = mkV "ritar" ;
  ritsa_vb_1_V = mkV "ritsar" ;
  ritualisera_vb_1_V = mkV "ritualiserar" ;
  rivstarta_vb_1_V = mkV "rivstartar" ;
  roa_vb_1_V = mkV "roar" ;
  robotisera_vb_1_V = mkV "robotiserar" ;
  rockera_vb_1_V = mkV "rockerar" ;
  roffa_vb_1_V = mkV "roffar" ;
  rolla_vb_1_V = mkV "rollar" ;
  romantisera_vb_1_V = mkV "romantiserar" ;
  rosa_vb_1_V = mkV "rosar" ;
  rosta_vb_2_V = mkV "rostar" ;
  rostbehandla_vb_1_V = mkV "rostbehandlar" ;
  rostskydda_vb_1_V = mkV "rostskyddar" ;
  rotera_vb_1_V = mkV "roterar" ;
  rubba_vb_1_V = mkV "rubbar" ;
  rubricera_vb_1_V = mkV "rubricerar" ;
  rucka_vb_1_V = mkV "ruckar" ;
  rugga_vb_2_V = mkV "ruggar" ;
  ruinera_vb_1_V = mkV "ruinerar" ;
  rulla_vb_1_V = mkV "rullar" ;
  runda_vb_1_V = mkV "rundar" ;
  rundsticka_vb_1_V = mkV "rundstickar" ;
  runka_vb_1_V = mkV "runkar" ;
  rusa_vb_2_V = mkV "rusar" ;
  ruska_vb_1_V = mkV "ruskar" ;
  russificera_vb_1_V = mkV "russificerar" ;
  russifiera_vb_1_V = mkV "russifierar" ;
  rusta_vb_1_V = mkV "rustar" ;
  ruva_vb_1_V = mkV "ruvar" ;
  rykta_vb_1_V = mkV "ryktar" ;
  rynka_vb_1_V = mkV "rynkar" ;
  rytmisera_vb_1_V = mkV "rytmiserar" ;
  raedda_vb_1_1_V = mkV "räddar" ;
  raefsa_vb_1_1_V = mkV "räfsar" ;
  raekna_vb_1_1_V = mkV "räknar" ;
  raemna_vb_1_1_V = mkV "rämnar" ;
  raeta_vb_1_1_V = mkV "rätar" ;
  raetta_vb_1_1_V = mkV "rättar" ;
  raettfaerdiga_vb_1_1_V = mkV "rättfärdigar" ;
  raadbraaka_vb_1_1_V = mkV "rådbråkar" ;
  raadfraaga_vb_1_1_V = mkV "rådfrågar" ;
  raadplaega_vb_1_1_V = mkV "rådplägar" ;
  raaga_vb_1_1_V = mkV "rågar" ;
  raaka_vb_1_1_V = mkV "råkar" ;
  raana_vb_1_1_V = mkV "rånar" ;
  raaplugga_vb_1_1_V = mkV "råpluggar" ;
  raaskala_vb_1_1_V = mkV "råskalar" ;
  roedgloedga_vb_1_1_V = mkV "rödglödgar" ;
  roedlista_vb_1_1_V = mkV "rödlistar" ;
  roentga_vb_1_1_V = mkV "röntgar" ;
  roentgenfotografera_vb_1_1_V = mkV "röntgenfotograferar" ;
  roesa_vb_1_1_V = mkV "rösar" ;
  roeta_vb_1_1_V = mkV "rötar" ;
  roeva_vb_1_1_V = mkV "rövar" ;
  roevknulla_vb_1_1_V = mkV "rövknullar" ;
  sabba_vb_1_V = mkV "sabbar" ;
  sabotera_vb_1_V = mkV "saboterar" ;
  sabrera_vb_1_V = mkV "sabrerar" ;
  safta_vb_1_V = mkV "saftar" ;
  saka_vb_1_V = mkV "sakar" ;
  sakerfoerklara_vb_1_1_V = mkV "sakerförklarar" ;
  sakna_vb_1_V = mkV "saknar" ;
  sakta_vb_1_V = mkV "saktar" ;
  sala_vb_1_V = mkV "salar" ;
  saldera_vb_1_V = mkV "salderar" ;
  saligfoerklara_vb_1_1_V = mkV "saligförklarar" ;
  salta_vb_1_V = mkV "saltar" ;
  salutera_vb_1_V = mkV "saluterar" ;
  sambeskatta_vb_1_V = mkV "sambeskattar" ;
  samka_vb_1_V = mkV "samkar" ;
  samla_vb_2_V = mkV "samlar" ;
  sammanavla_vb_1_V = mkV "sammanavlar" ;
  sammanblanda_vb_1_V = mkV "sammanblandar" ;
  sammandrabba_vb_1_V = mkV "sammandrabbar" ;
  sammanfatta_vb_1_V = mkV "sammanfattar" ;
  sammanflaeta_vb_1_1_V = mkV "sammanflätar" ;
  sammanfoga_vb_1_V = mkV "sammanfogar" ;
  sammanhopa_vb_1_V = mkV "sammanhopar" ;
  sammanjaemka_vb_1_1_V = mkV "sammanjämkar" ;
  sammankalla_vb_1_V = mkV "sammankallar" ;
  sammanlaenka_vb_1_1_V = mkV "sammanlänkar" ;
  sammanpacka_vb_1_V = mkV "sammanpackar" ;
  sammanpressa_vb_1_V = mkV "sammanpressar" ;
  sammanraekna_vb_1_1_V = mkV "sammanräknar" ;
  sammanstraala_vb_1_1_V = mkV "sammanstrålar" ;
  sammansvetsa_vb_1_V = mkV "sammansvetsar" ;
  sammantraeffa_vb_1_1_V = mkV "sammanträffar" ;
  samordna_vb_1_V = mkV "samordnar" ;
  samsa_vb_1_V = mkV "samsar" ;
  samtaxera_vb_1_V = mkV "samtaxerar" ;
  sanda_vb_1_V = mkV "sandar" ;
  sandblaestra_vb_1_1_V = mkV "sandblästrar" ;
  sandpappra_vb_1_V = mkV "sandpapprar" ;
  sanera_vb_1_V = mkV "sanerar" ;
  sanforisera_vb_1_V = mkV "sanforiserar" ;
  sanktifiera_vb_1_V = mkV "sanktifierar" ;
  sanktionera_vb_1_V = mkV "sanktionerar" ;
  sanna_vb_1_V = mkV "sannar" ;
  sannolikhetsberaekna_vb_1_1_V = mkV "sannolikhetsberäknar" ;
  saponifiera_vb_1_V = mkV "saponifierar" ;
  sarga_vb_1_V = mkV "sargar" ;
  satinera_vb_1_V = mkV "satinerar" ;
  satisfiera_vb_1_V = mkV "satisfierar" ;
  satsa_vb_1_V = mkV "satsar" ;
  saturera_vb_1_V = mkV "saturerar" ;
  sautera_vb_1_V = mkV "sauterar" ;
  sauvera_vb_1_V = mkV "sauverar" ;
  saxa_vb_1_V = mkV "saxar" ;
  scanna_vb_1_V = mkV "scannar" ;
  schablonera_vb_1_V = mkV "schablonerar" ;
  schablonisera_vb_1_V = mkV "schabloniserar" ;
  schablontaxera_vb_1_V = mkV "schablontaxerar" ;
  schacka_vb_1_V = mkV "schackar" ;
  schakta_vb_1_V = mkV "schaktar" ;
  schamponera_vb_1_V = mkV "schamponerar" ;
  schanghaja_vb_1_V = mkV "schanghajar" ;
  schappa_vb_1_V = mkV "schappar" ;
  schasa_vb_1_V = mkV "schasar" ;
  schattera_vb_1_V = mkV "schatterar" ;
  schematisera_vb_1_V = mkV "schematiserar" ;
  schveifa_vb_1_V = mkV "schveifar" ;
  sedimentera_vb_1_V = mkV "sedimenterar" ;
  seeda_vb_1_V = mkV "seedar" ;
  seghaerda_vb_1_1_V = mkV "seghärdar" ;
  segmentera_vb_1_V = mkV "segmenterar" ;
  segra_vb_2_V = mkV "segrar" ;
  segregera_vb_1_V = mkV "segregerar" ;
  sejsa_vb_1_V = mkV "sejsar" ;
  sekondera_vb_1_V = mkV "sekonderar" ;
  sekularisera_vb_1_V = mkV "sekulariserar" ;
  sekundera_vb_1_V = mkV "sekunderar" ;
  sekvensera_vb_1_V = mkV "sekvenserar" ;
  sekvestrera_vb_1_V = mkV "sekvestrerar" ;
  sela_vb_1_V = mkV "selar" ;
  selektera_vb_1_V = mkV "selekterar" ;
  semaforera_vb_1_V = mkV "semaforerar" ;
  seminera_vb_1_V = mkV "seminerar" ;
  sensibilisera_vb_1_V = mkV "sensibiliserar" ;
  sentera_vb_1_V = mkV "senterar" ;
  separera_vb_1_V = mkV "separerar" ;
  seponera_vb_1_V = mkV "seponerar" ;
  seriekoppla_vb_1_V = mkV "seriekopplar" ;
  serietillverka_vb_1_V = mkV "serietillverkar" ;
  serva_vb_1_V = mkV "servar" ;
  servera_vb_1_V = mkV "serverar" ;
  sexdubbla_vb_1_V = mkV "sexdubblar" ;
  sexfaldiga_vb_1_V = mkV "sexfaldigar" ;
  sexualisera_vb_1_V = mkV "sexualiserar" ;
  sexutnyttja_vb_1_V = mkV "sexutnyttjar" ;
  shamponera_vb_1_V = mkV "shamponerar" ;
  shanghaja_vb_1_V = mkV "shanghajar" ;
  shorta_vb_1_V = mkV "shortar" ;
  shunta_vb_1_V = mkV "shuntar" ;
  sicka_vb_1_V = mkV "sickar" ;
  sickla_vb_1_V = mkV "sicklar" ;
  sicksacka_vb_2_V = mkV "sicksackar" ;
  sidnumrera_vb_1_V = mkV "sidnumrerar" ;
  sidsteppa_vb_1_V = mkV "sidsteppar" ;
  sigillera_vb_1_V = mkV "sigillerar" ;
  signa_vb_1_V = mkV "signar" ;
  signalera_vb_2_V = mkV "signalerar" ;
  signera_vb_1_V = mkV "signerar" ;
  sikta_vb_2_V = mkV "siktar" ;
  sila_vb_1_V = mkV "silar" ;
  silhuettera_vb_1_V = mkV "silhuetterar" ;
  siluettera_vb_1_V = mkV "siluetterar" ;
  silverinfatta_vb_1_V = mkV "silverinfattar" ;
  silvra_vb_1_V = mkV "silvrar" ;
  simplifiera_vb_1_V = mkV "simplifierar" ;
  simsa_vb_1_V = mkV "simsar" ;
  simulera_vb_1_V = mkV "simulerar" ;
  simultantolka_vb_1_V = mkV "simultantolkar" ;
  sinka_vb_1_V = mkV "sinkar" ;
  sira_vb_1_V = mkV "sirar" ;
  sjanghaja_vb_1_V = mkV "sjanghajar" ;
  sjappa_vb_1_V = mkV "sjappar" ;
  sjasa_vb_1_V = mkV "sjasar" ;
  sjufaldiga_vb_1_V = mkV "sjufaldigar" ;
  sjaelvfinansiera_vb_1_1_V = mkV "självfinansierar" ;
  skada_vb_1_V = mkV "skadar" ;
  skadereglera_vb_1_V = mkV "skadereglerar" ;
  skaffa_vb_1_V = mkV "skaffar" ;
  skafta_vb_1_V = mkV "skaftar" ;
  skaka_vb_1_V = mkV "skakar" ;
  skala_vb_1_V = mkV "skalar" ;
  skalda_vb_1_V = mkV "skaldar" ;
  skalka_vb_1_V = mkV "skalkar" ;
  skalla_vb_2_V = mkV "skallar" ;
  skalpera_vb_1_V = mkV "skalperar" ;
  skamfila_vb_1_V = mkV "skamfilar" ;
  skandalisera_vb_1_V = mkV "skandaliserar" ;
  skandera_vb_1_V = mkV "skanderar" ;
  skanna_vb_1_V = mkV "skannar" ;
  skarva_vb_1_V = mkV "skarvar" ;
  skatta_vb_2_V = mkV "skattar" ;
  skatteplanera_vb_1_V = mkV "skatteplanerar" ;
  skeda_vb_1_V = mkV "skedar" ;
  skena_vb_1_V = mkV "skenar" ;
  skenplocka_vb_1_V = mkV "skenplockar" ;
  skeppa_vb_1_V = mkV "skeppar" ;
  skeva_vb_2_V = mkV "skevar" ;
  skevra_vb_1_V = mkV "skevrar" ;
  skifta_vb_1_V = mkV "skiftar" ;
  skikta_vb_1_V = mkV "skiktar" ;
  skildra_vb_1_V = mkV "skildrar" ;
  skingra_vb_1_V = mkV "skingrar" ;
  skinna_vb_1_V = mkV "skinnar" ;
  skipa_vb_1_V = mkV "skipar" ;
  skippa_vb_1_V = mkV "skippar" ;
  skira_vb_1_V = mkV "skirar" ;
  skissa_vb_1_V = mkV "skissar" ;
  skissera_vb_1_V = mkV "skisserar" ;
  skiva_vb_1_V = mkV "skivar" ;
  skjutsa_vb_1_V = mkV "skjutsar" ;
  skjuva_vb_1_V = mkV "skjuvar" ;
  skoja_vb_2_V = mkV "skojar" ;
  skola_vb_1_V = mkV "skolar" ;
  skona_vb_1_V = mkV "skonar" ;
  skopa_vb_1_V = mkV "skopar" ;
  skota_vb_1_V = mkV "skotar" ;
  skotta_vb_1_V = mkV "skottar" ;
  skottskada_vb_1_V = mkV "skottskadar" ;
  skraffera_vb_1_V = mkV "skrafferar" ;
  skrapa_vb_1_V = mkV "skrapar" ;
  skrota_vb_1_V = mkV "skrotar" ;
  skrubba_vb_1_V = mkV "skrubbar" ;
  skruda_vb_1_V = mkV "skrudar" ;
  skruva_vb_1_V = mkV "skruvar" ;
  skrymta_vb_1_V = mkV "skrymtar" ;
  skraedda_vb_1_1_V = mkV "skräddar" ;
  skraena_vb_1_1_V = mkV "skränar" ;
  skraepa_vb_1_1_V = mkV "skräpar" ;
  skraala_vb_1_1_V = mkV "skrålar" ;
  skraama_vb_1_1_V = mkV "skråmar" ;
  skubba_vb_1_V = mkV "skubbar" ;
  skudda_vb_1_V = mkV "skuddar" ;
  skuffa_vb_1_V = mkV "skuffar" ;
  skugga_vb_1_V = mkV "skuggar" ;
  skulptera_vb_1_V = mkV "skulpterar" ;
  skulpturera_vb_1_V = mkV "skulpturerar" ;
  skumma_vb_2_V = mkV "skummar" ;
  skumpa_vb_1_V = mkV "skumpar" ;
  skumtvaetta_vb_1_1_V = mkV "skumtvättar" ;
  skura_vb_1_V = mkV "skurar" ;
  skutta_vb_1_V = mkV "skuttar" ;
  skvala_vb_1_V = mkV "skvalar" ;
  skvalpa_vb_1_V = mkV "skvalpar" ;
  skvalta_vb_1_V = mkV "skvaltar" ;
  skvimpa_vb_1_V = mkV "skvimpar" ;
  skvisa_vb_1_V = mkV "skvisar" ;
  skya_vb_1_V = mkV "skyar" ;
  skydda_vb_1_V = mkV "skyddar" ;
  skyddsimpregnera_vb_1_V = mkV "skyddsimpregnerar" ;
  skyddsympa_vb_1_V = mkV "skyddsympar" ;
  skygga_vb_1_V = mkV "skyggar" ;
  skyla_vb_2_V = mkV "skylar" ;
  skylta_vb_1_V = mkV "skyltar" ;
  skymfa_vb_1_V = mkV "skymfar" ;
  skymta_vb_1_V = mkV "skymtar" ;
  skynda_vb_1_V = mkV "skyndar" ;
  skaefta_vb_1_1_V = mkV "skäftar" ;
  skaegga_vb_1_1_V = mkV "skäggar" ;
  skaekta_vb_1_1_V = mkV "skäktar" ;
  skaemta_vb_1_1_V = mkV "skämtar" ;
  skaenda_vb_1_1_V = mkV "skändar" ;
  skaera_vb_2_1_V = mkV "skärar" ;
  skaermbilda_vb_1_1_V = mkV "skärmbildar" ;
  skaerra_vb_1_1_V = mkV "skärrar" ;
  skaerskaada_vb_1_1_V = mkV "skärskådar" ;
  skaerva_vb_1_1_V = mkV "skärvar" ;
  skaada_vb_1_1_V = mkV "skådar" ;
  skaala_vb_1_1_V = mkV "skålar" ;
  skaalla_vb_1_1_V = mkV "skållar" ;
  skaara_vb_1_1_V = mkV "skårar" ;
  skoelpa_vb_1_1_V = mkV "skölpar" ;
  skoenmaala_vb_1_1_V = mkV "skönmålar" ;
  skoenstaxera_vb_1_1_V = mkV "skönstaxerar" ;
  skoentaxera_vb_1_1_V = mkV "sköntaxerar" ;
  skoera_vb_1_1_V = mkV "skörar" ;
  skoerda_vb_1_1_V = mkV "skördar" ;
  skoerna_vb_1_1_V = mkV "skörnar" ;
  slabba_vb_1_V = mkV "slabbar" ;
  slacka_vb_1_V = mkV "slackar" ;
  sladda_vb_1_V = mkV "sladdar" ;
  slafa_vb_1_V = mkV "slafar" ;
  slafsa_vb_1_V = mkV "slafsar" ;
  slagga_vb_1_V = mkV "slaggar" ;
  slaka_vb_1_V = mkV "slakar" ;
  slakna_vb_1_V = mkV "slaknar" ;
  slakta_vb_1_V = mkV "slaktar" ;
  slamma_vb_2_V = mkV "slammar" ;
  slamsa_vb_1_V = mkV "slamsar" ;
  slanga_vb_1_V = mkV "slangar" ;
  slanka_vb_1_V = mkV "slankar" ;
  slankna_vb_1_V = mkV "slanknar" ;
  slanta_vb_1_V = mkV "slantar" ;
  slappa_vb_1_V = mkV "slappar" ;
  slappna_vb_1_V = mkV "slappnar" ;
  slarva_vb_1_V = mkV "slarvar" ;
  slasa_vb_1_V = mkV "slasar" ;
  slaska_vb_1_V = mkV "slaskar" ;
  slava_vb_1_V = mkV "slavar" ;
  slavisera_vb_1_V = mkV "slaviserar" ;
  slentrianmoerka_vb_1_1_V = mkV "slentrianmörkar" ;
  sleva_vb_1_V = mkV "slevar" ;
  slicka_vb_1_V = mkV "slickar" ;
  slikta_vb_1_V = mkV "sliktar" ;
  slipa_vb_1_V = mkV "slipar" ;
  slira_vb_1_V = mkV "slirar" ;
  slockna_vb_1_V = mkV "slocknar" ;
  slutbehandla_vb_1_V = mkV "slutbehandlar" ;
  slutfoervara_vb_1_1_V = mkV "slutförvarar" ;
  smygfilma_vb_1_V = mkV "smygfilmar" ;
  smygislamisera_vb_1_V = mkV "smygislamiserar" ;
  smaeda_vb_1_1_V = mkV "smädar" ;
  snabbgranska_vb_1_V = mkV "snabbgranskar" ;
  snabbspola_vb_1_V = mkV "snabbspolar" ;
  snedparkera_vb_1_V = mkV "snedparkerar" ;
  snedrekrytera_vb_1_V = mkV "snedrekryterar" ;
  snickra_vb_1_V = mkV "snickrar" ;
  snorkla_vb_1_V = mkV "snorklar" ;
  snorta_vb_1_V = mkV "snortar" ;
  snoemula_vb_1_1_V = mkV "snömular" ;
  socialisera_vb_1_V = mkV "socialiserar" ;
  sockra_vb_1_V = mkV "sockrar" ;
  solvera_vb_1_V = mkV "solverar" ;
  sona_vb_1_V = mkV "sonar" ;
  sondera_vb_1_V = mkV "sonderar" ;
  sondmata_vb_1_V = mkV "sondmatar" ;
  sopsortera_vb_1_V = mkV "sopsorterar" ;
  sordinera_vb_1_V = mkV "sordinerar" ;
  sorla_vb_1_V = mkV "sorlar" ;
  sortera_vb_1_V = mkV "sorterar" ;
  soulagera_vb_1_V = mkV "soulagerar" ;
  sovjetisera_vb_1_V = mkV "sovjetiserar" ;
  sovra_vb_1_V = mkV "sovrar" ;
  spaljera_vb_1_V = mkV "spaljerar" ;
  spallera_vb_1_V = mkV "spallerar" ;
  specialisera_vb_1_V = mkV "specialiserar" ;
  specificera_vb_1_V = mkV "specificerar" ;
  speciminera_vb_1_V = mkV "speciminerar" ;
  spegla_vb_1_V = mkV "speglar" ;
  spekulera_vb_1_V = mkV "spekulerar" ;
  spika_vb_1_V = mkV "spikar" ;
  spoliera_vb_1_V = mkV "spolierar" ;
  sponsra_vb_1_V = mkV "sponsrar" ;
  sprutlackera_vb_1_V = mkV "sprutlackerar" ;
  stabilisera_vb_1_V = mkV "stabiliserar" ;
  stadga_vb_1_V = mkV "stadgar" ;
  stadsplanera_vb_1_V = mkV "stadsplanerar" ;
  staffera_vb_1_V = mkV "stafferar" ;
  stagnera_vb_1_V = mkV "stagnerar" ;
  stajla_vb_1_V = mkV "stajlar" ;
  stalka_vb_1_V = mkV "stalkar" ;
  stamma_vb_1_V = mkV "stammar" ;
  standardisera_vb_1_V = mkV "standardiserar" ;
  stationera_vb_1_V = mkV "stationerar" ;
  statuera_vb_2_V = mkV "statuerar" ;
  stegra_vb_1_V = mkV "stegrar" ;
  stelna_vb_1_V = mkV "stelnar" ;
  stencilera_vb_1_V = mkV "stencilerar" ;
  stenografera_vb_1_V = mkV "stenograferar" ;
  stereofotografera_vb_1_V = mkV "stereofotograferar" ;
  stereotypera_vb_1_V = mkV "stereotyperar" ;
  sterilisera_vb_1_V = mkV "steriliserar" ;
  stigmatisera_vb_1_V = mkV "stigmatiserar" ;
  stilisera_vb_1_V = mkV "stiliserar" ;
  stimulera_vb_1_V = mkV "stimulerar" ;
  stipendiera_vb_1_V = mkV "stipendierar" ;
  stipulera_vb_1_V = mkV "stipulerar" ;
  stoffera_vb_1_V = mkV "stofferar" ;
  stormsaekra_vb_1_1_V = mkV "stormsäkrar" ;
  strangulera_vb_1_V = mkV "strangulerar" ;
  stratifiera_vb_1_V = mkV "stratifierar" ;
  stridsformera_vb_1_V = mkV "stridsformerar" ;
  stridsgruppera_vb_1_V = mkV "stridsgrupperar" ;
  strukturera_vb_1_V = mkV "strukturerar" ;
  strukturrationalisera_vb_1_V = mkV "strukturrationaliserar" ;
  straalkonservera_vb_1_1_V = mkV "strålkonserverar" ;
  studera_vb_1_V = mkV "studerar" ;
  studieorientera_vb_1_V = mkV "studieorienterar" ;
  styla_vb_1_V = mkV "stylar" ;
  staempla_vb_1_1_V = mkV "stämplar" ;
  staengsla_vb_1_1_V = mkV "stängslar" ;
  stoevla_vb_1_1_V = mkV "stövlar" ;
  sublimera_vb_1_V = mkV "sublimerar" ;
  subordinera_vb_1_V = mkV "subordinerar" ;
  subsidiera_vb_1_V = mkV "subsidierar" ;
  subskribera_vb_1_V = mkV "subskriberar" ;
  substantivera_vb_1_V = mkV "substantiverar" ;
  substituera_vb_1_V = mkV "substituerar" ;
  subsumera_vb_1_V = mkV "subsumerar" ;
  subtrahera_vb_1_V = mkV "subtraherar" ;
  subventionera_vb_1_V = mkV "subventionerar" ;
  succedera_vb_1_V = mkV "succederar" ;
  suffigera_vb_1_V = mkV "suffigerar" ;
  sufflera_vb_1_V = mkV "sufflerar" ;
  suggerera_vb_1_V = mkV "suggererar" ;
  summera_vb_1_V = mkV "summerar" ;
  supplera_vb_1_V = mkV "supplerar" ;
  supponera_vb_1_V = mkV "supponerar" ;
  suspendera_vb_1_V = mkV "suspenderar" ;
  svalna_vb_1_V = mkV "svalnar" ;
  svara_vb_1_V = mkV "svarar" ;
  svartmaala_vb_1_1_V = mkV "svartmålar" ;
  svartna_vb_1_V = mkV "svartnar" ;
  symbolisera_vb_1_V = mkV "symboliserar" ;
  synkopera_vb_1_V = mkV "synkoperar" ;
  synkronisera_vb_1_V = mkV "synkroniserar" ;
  syntetisera_vb_1_V = mkV "syntetiserar" ;
  systematisera_vb_1_V = mkV "systematiserar" ;
  saekra_vb_1_1_V = mkV "säkrar" ;
  saerbehandla_vb_1_1_V = mkV "särbehandlar" ;
  saaga_vb_2_1_V = mkV "sågar" ;
  saatera_vb_1_1_V = mkV "såterar" ;
  saavera_vb_1_1_V = mkV "såverar" ;
  soemma_vb_1_1_V = mkV "sömmar" ;
  soendra_vb_1_1_V = mkV "söndrar" ;
  tabellera_vb_1_V = mkV "tabellerar" ;
  tabuera_vb_1_V = mkV "tabuerar" ;
  tamponera_vb_1_V = mkV "tamponerar" ;
  tandtraada_vb_1_1_V = mkV "tandtrådar" ;
  tangera_vb_1_V = mkV "tangerar" ;
  tapetsera_vb_1_V = mkV "tapetserar" ;
  tarera_vb_1_V = mkV "tarerar" ;
  tariffera_vb_1_V = mkV "tarifferar" ;
  tatuera_vb_1_V = mkV "tatuerar" ;
  taxera_vb_1_V = mkV "taxerar" ;
  teckna_vb_1_V = mkV "tecknar" ;
  teknifiera_vb_1_V = mkV "teknifierar" ;
  telefonera_vb_1_V = mkV "telefonerar" ;
  telegrafera_vb_1_V = mkV "telegraferar" ;
  televisera_vb_1_V = mkV "televiserar" ;
  tempera_vb_1_V = mkV "temperar" ;
  temperera_vb_1_V = mkV "tempererar" ;
  tentera_vb_1_V = mkV "tenterar" ;
  terrassera_vb_1_V = mkV "terrasserar" ;
  terrorisera_vb_1_V = mkV "terroriserar" ;
  tesaurera_vb_1_V = mkV "tesaurerar" ;
  testamentera_vb_1_V = mkV "testamenterar" ;
  tidsberaekna_vb_1_1_V = mkV "tidsberäknar" ;
  tillfoerordna_vb_1_1_V = mkV "tillförordnar" ;
  tillfoersaekra_vb_1_1_V = mkV "tillförsäkrar" ;
  tillkoppla_vb_1_V = mkV "tillkopplar" ;
  tillstroemma_vb_1_1_V = mkV "tillströmmar" ;
  tilta_vb_1_V = mkV "tiltar" ;
  timra_vb_1_V = mkV "timrar" ;
  tiodubbla_vb_1_V = mkV "tiodubblar" ;
  titrera_vb_1_V = mkV "titrerar" ;
  titulera_vb_1_V = mkV "titulerar" ;
  tjonga_vb_1_V = mkV "tjongar" ;
  tjudra_vb_1_V = mkV "tjudrar" ;
  tjugofaldiga_vb_1_V = mkV "tjugofaldigar" ;
  tjuvfiska_vb_1_V = mkV "tjuvfiskar" ;
  tjuvjaga_vb_1_V = mkV "tjuvjagar" ;
  tjuvkoppla_vb_1_V = mkV "tjuvkopplar" ;
  tjuvlyssna_vb_1_V = mkV "tjuvlyssnar" ;
  tjyvfiska_vb_1_V = mkV "tjyvfiskar" ;
  tjyvjaga_vb_1_V = mkV "tjyvjagar" ;
  tjyvkoppla_vb_1_V = mkV "tjyvkopplar" ;
  tjyvlyssna_vb_1_V = mkV "tjyvlyssnar" ;
  tolerera_vb_1_V = mkV "tolererar" ;
  tolvfaldiga_vb_1_V = mkV "tolvfaldigar" ;
  topsa_vb_1_V = mkV "topsar" ;
  tordera_vb_1_V = mkV "torderar" ;
  torktumla_vb_1_V = mkV "torktumlar" ;
  torpedera_vb_1_V = mkV "torpederar" ;
  torrdestillera_vb_1_V = mkV "torrdestillerar" ;
  torrschamponera_vb_1_V = mkV "torrschamponerar" ;
  tortera_vb_1_V = mkV "torterar" ;
  totalfinansiera_vb_1_V = mkV "totalfinansierar" ;
  totalfoerlama_vb_1_1_V = mkV "totalförlamar" ;
  totalhaverera_vb_1_V = mkV "totalhavererar" ;
  totalsabba_vb_1_V = mkV "totalsabbar" ;
  totalvaegra_vb_1_1_V = mkV "totalvägrar" ;
  touchera_vb_1_V = mkV "toucherar" ;
  toupera_vb_1_V = mkV "touperar" ;
  tracka_vb_1_V = mkV "trackar" ;
  tradera_vb_1_V = mkV "traderar" ;
  trafikera_vb_1_V = mkV "trafikerar" ;
  trafikreglera_vb_1_V = mkV "trafikreglerar" ;
  trakassera_vb_1_V = mkV "trakasserar" ;
  traktera_vb_1_V = mkV "trakterar" ;
  transferera_vb_1_V = mkV "transfererar" ;
  transformera_vb_1_V = mkV "transformerar" ;
  transitera_vb_1_V = mkV "transiterar" ;
  transkribera_vb_1_V = mkV "transkriberar" ;
  translitterera_vb_1_V = mkV "translittererar" ;
  transmittera_vb_1_V = mkV "transmitterar" ;
  transmutera_vb_1_V = mkV "transmuterar" ;
  transplantera_vb_1_V = mkV "transplanterar" ;
  transponera_vb_1_V = mkV "transponerar" ;
  transportera_vb_1_V = mkV "transporterar" ;
  transumera_vb_1_V = mkV "transumerar" ;
  trasha_vb_1_V = mkV "trashar" ;
  trassera_vb_1_V = mkV "trasserar" ;
  travestera_vb_1_V = mkV "travesterar" ;
  tredubbla_vb_1_V = mkV "tredubblar" ;
  trefaldiga_vb_1_V = mkV "trefaldigar" ;
  trepanera_vb_1_V = mkV "trepanerar" ;
  triangulera_vb_1_V = mkV "triangulerar" ;
  tricksa_vb_1_V = mkV "tricksar" ;
  triera_vb_1_V = mkV "trierar" ;
  trigga_vb_1_V = mkV "triggar" ;
  trippla_vb_1_V = mkV "tripplar" ;
  trivialisera_vb_1_V = mkV "trivialiserar" ;
  trixa_vb_1_V = mkV "trixar" ;
  trumma_vb_1_V = mkV "trummar" ;
  tryckimpregnera_vb_1_V = mkV "tryckimpregnerar" ;
  tryffera_vb_1_V = mkV "tryfferar" ;
  traea_vb_1_1_V = mkV "träar" ;
  troeghetsnavigera_vb_1_1_V = mkV "tröghetsnavigerar" ;
  troettna_vb_1_1_V = mkV "tröttnar" ;
  tumma_vb_1_V = mkV "tummar" ;
  tupera_vb_1_V = mkV "tuperar" ;
  turnera_vb_2_V = mkV "turnerar" ;
  tuschera_vb_1_V = mkV "tuscherar" ;
  tvaga_vb_1_V = mkV "tvagar" ;
  tvista_vb_1_V = mkV "tvistar" ;
  tvivla_vb_1_V = mkV "tvivlar" ;
  tvaangskommendera_vb_1_1_V = mkV "tvångskommenderar" ;
  tvaangsrekrytera_vb_1_1_V = mkV "tvångsrekryterar" ;
  tvaangstatuera_vb_1_1_V = mkV "tvångstatuerar" ;
  twittra_vb_1_V = mkV "twittrar" ;
  typifiera_vb_1_V = mkV "typifierar" ;
  typisera_vb_1_V = mkV "typiserar" ;
  tyrannisera_vb_1_V = mkV "tyranniserar" ;
  taeckdika_vb_1_1_V = mkV "täckdikar" ;
  taevla_vb_1_1_V = mkV "tävlar" ;
  taevlingssegla_vb_1_1_V = mkV "tävlingsseglar" ;
  taagpendla_vb_1_1_V = mkV "tågpendlar" ;
  ultrarapidfotografera_vb_1_V = mkV "ultrarapidfotograferar" ;
  underbalansera_vb_1_V = mkV "underbalanserar" ;
  underdimensionera_vb_1_V = mkV "underdimensionerar" ;
  underexponera_vb_1_V = mkV "underexponerar" ;
  underfoersaekra_vb_1_1_V = mkV "underförsäkrar" ;
  underhandla_vb_1_V = mkV "underhandlar" ;
  underlaetta_vb_1_1_V = mkV "underlättar" ;
  underminera_vb_1_V = mkV "underminerar" ;
  underredsbehandla_vb_1_V = mkV "underredsbehandlar" ;
  undertaxera_vb_1_V = mkV "undertaxerar" ;
  underteckna_vb_1_V = mkV "undertecknar" ;
  undervaerdera_vb_1_1_V = mkV "undervärderar" ;
  undra_vb_1_V = mkV "undrar" ;
  unifiera_vb_1_V = mkV "unifierar" ;
  uniformera_vb_1_V = mkV "uniformerar" ;
  uppamma_vb_1_V = mkV "uppammar" ;
  uppdatera_vb_1_V = mkV "uppdaterar" ;
  uppfodra_vb_1_V = mkV "uppfodrar" ;
  uppfordra_vb_1_V = mkV "uppfordrar" ;
  uppfostra_vb_1_V = mkV "uppfostrar" ;
  uppgradera_vb_1_V = mkV "uppgraderar" ;
  upphandla_vb_1_V = mkV "upphandlar" ;
  uppjustera_vb_1_V = mkV "uppjusterar" ;
  upplagra_vb_1_V = mkV "upplagrar" ;
  uppmuddra_vb_1_V = mkV "uppmuddrar" ;
  uppmuntra_vb_1_V = mkV "uppmuntrar" ;
  uppmaerksamma_vb_1_1_V = mkV "uppmärksammar" ;
  uppodla_vb_1_V = mkV "uppodlar" ;
  uppoffra_vb_1_V = mkV "uppoffrar" ;
  uppreklamera_vb_1_V = mkV "uppreklamerar" ;
  uppraekna_vb_1_1_V = mkV "uppräknar" ;
  uppsamla_vb_1_V = mkV "uppsamlar" ;
  uppslamma_vb_1_V = mkV "uppslammar" ;
  uppsummera_vb_1_V = mkV "uppsummerar" ;
  upptaxera_vb_1_V = mkV "upptaxerar" ;
  uppvigla_vb_1_V = mkV "uppviglar" ;
  uppvisa_vb_1_V = mkV "uppvisar" ;
  uppvaerdera_vb_1_1_V = mkV "uppvärderar" ;
  urbanisera_vb_1_V = mkV "urbaniserar" ;
  urholka_vb_1_V = mkV "urholkar" ;
  usurpera_vb_1_V = mkV "usurperar" ;
  utackordera_vb_1_V = mkV "utackorderar" ;
  utannonsera_vb_1_V = mkV "utannonserar" ;
  utarrendera_vb_1_V = mkV "utarrenderar" ;
  utbalansera_vb_1_V = mkV "utbalanserar" ;
  utbasunera_vb_1_V = mkV "utbasunerar" ;
  utblotta_vb_1_V = mkV "utblottar" ;
  utbomba_vb_1_V = mkV "utbombar" ;
  utbrodera_vb_1_V = mkV "utbroderar" ;
  utdebitera_vb_1_V = mkV "utdebiterar" ;
  utexaminera_vb_1_V = mkV "utexaminerar" ;
  utexperimentera_vb_1_V = mkV "utexperimenterar" ;
  utfodra_vb_1_V = mkV "utfodrar" ;
  utfordra_vb_1_V = mkV "utfordrar" ;
  utfoersaekra_vb_1_1_V = mkV "utförsäkrar" ;
  uthamra_vb_1_V = mkV "uthamrar" ;
  utkamma_vb_1_V = mkV "utkammar" ;
  utklarera_vb_1_V = mkV "utklarerar" ;
  utkommendera_vb_1_V = mkV "utkommenderar" ;
  utkonkurrera_vb_1_V = mkV "utkonkurrerar" ;
  utkristallisera_vb_1_V = mkV "utkristalliserar" ;
  utkvittera_vb_1_V = mkV "utkvitterar" ;
  utlokalisera_vb_1_V = mkV "utlokaliserar" ;
  utlaemna_vb_1_1_V = mkV "utlämnar" ;
  utmanoevrera_vb_1_1_V = mkV "utmanövrerar" ;
  utmejsla_vb_1_V = mkV "utmejslar" ;
  utminutera_vb_1_V = mkV "utminuterar" ;
  utmoenstra_vb_1_1_V = mkV "utmönstrar" ;
  utplacera_vb_1_V = mkV "utplacerar" ;
  utplundra_vb_1_V = mkV "utplundrar" ;
  utpostera_vb_1_V = mkV "utposterar" ;
  utradera_vb_1_V = mkV "utraderar" ;
  utrangera_vb_1_V = mkV "utrangerar" ;
  utslockna_vb_1_V = mkV "utslocknar" ;
  utstoffera_vb_1_V = mkV "utstofferar" ;
  utsoendra_vb_1_1_V = mkV "utsöndrar" ;
  uttaxera_vb_1_V = mkV "uttaxerar" ;
  utvandra_vb_1_V = mkV "utvandrar" ;
  utveckla_vb_1_V = mkV "utvecklar" ;
  utvaerdera_vb_1_1_V = mkV "utvärderar" ;
  utvaexla_vb_1_1_V = mkV "utväxlar" ;
  vaccinera_vb_1_V = mkV "vaccinerar" ;
  vaddera_vb_1_V = mkV "vadderar" ;
  vakna_vb_1_V = mkV "vaknar" ;
  vaksinera_vb_1_V = mkV "vaksinerar" ;
  valutera_vb_1_V = mkV "valuterar" ;
  valvera_vb_1_V = mkV "valverar" ;
  vandalisera_vb_1_V = mkV "vandaliserar" ;
  vandra_vb_1_V = mkV "vandrar" ;
  vanhedra_vb_1_V = mkV "vanhedrar" ;
  vanhelga_vb_1_V = mkV "vanhelgar" ;
  variera_vb_1_V = mkV "varierar" ;
  varudeklarera_vb_1_V = mkV "varudeklarerar" ;
  vattenkamma_vb_1_V = mkV "vattenkammar" ;
  vattra_vb_1_V = mkV "vattrar" ;
  veckla_vb_1_V = mkV "vecklar" ;
  velourisera_vb_1_V = mkV "velouriserar" ;
  ventilera_vb_1_V = mkV "ventilerar" ;
  verbalisera_vb_1_V = mkV "verbaliserar" ;
  verifiera_vb_1_V = mkV "verifierar" ;
  verklighetsfoerankra_vb_1_1_V = mkV "verklighetsförankrar" ;
  versifiera_vb_1_V = mkV "versifierar" ;
  vevla_vb_1_V = mkV "vevlar" ;
  vidarebefordra_vb_1_V = mkV "vidarebefordrar" ;
  vidarerapportera_vb_1_V = mkV "vidarerapporterar" ;
  vidareutbilda_vb_1_V = mkV "vidareutbildar" ;
  vidareutveckla_vb_1_V = mkV "vidareutvecklar" ;
  vidfoga_vb_1_V = mkV "vidfogar" ;
  vidimera_vb_1_V = mkV "vidimerar" ;
  vikta_vb_1_V = mkV "viktar" ;
  vindicera_vb_1_V = mkV "vindicerar" ;
  vindpollinera_vb_1_V = mkV "vindpollinerar" ;
  vinstmaximera_vb_1_V = mkV "vinstmaximerar" ;
  vinterbada_vb_1_V = mkV "vinterbadar" ;
  vintercykla_vb_1_V = mkV "vintercyklar" ;
  visera_vb_1_V = mkV "viserar" ;
  visitera_vb_1_V = mkV "visiterar" ;
  visualisera_vb_1_V = mkV "visualiserar" ;
  vitalisera_vb_1_V = mkV "vitaliserar" ;
  vitaminera_vb_1_V = mkV "vitaminerar" ;
  vitaminisera_vb_1_V = mkV "vitaminiserar" ;
  vitlimma_vb_1_V = mkV "vitlimmar" ;
  vitna_vb_1_V = mkV "vitnar" ;
  vitra_vb_1_V = mkV "vitrar" ;
  vittna_vb_1_V = mkV "vittnar" ;
  vittra_vb_1_V = mkV "vittrar" ;
  vokalisera_vb_1_V = mkV "vokaliserar" ;
  volta_vb_1_V = mkV "voltar" ;
  vulgarisera_vb_1_V = mkV "vulgariserar" ;
  vulkanisera_vb_1_V = mkV "vulkaniserar" ;
  vaedja_vb_1_1_V = mkV "vädjar" ;
  vaedra_vb_1_1_V = mkV "vädrar" ;
  vaeggmontera_vb_1_1_V = mkV "väggmonterar" ;
  vaegra_vb_1_1_V = mkV "vägrar" ;
  vaelkomna_vb_1_1_V = mkV "välkomnar" ;
  vaeltra_vb_1_1_V = mkV "vältrar" ;
  vaenstra_vb_1_1_V = mkV "vänstrar" ;
  vaerdera_vb_1_1_V = mkV "värderar" ;
  vaerdesaekra_vb_1_1_V = mkV "värdesäkrar" ;
  vaermebehandla_vb_1_1_V = mkV "värmebehandlar" ;
  vaermefotografera_vb_1_1_V = mkV "värmefotograferar" ;
  vaermeisolera_vb_1_1_V = mkV "värmeisolerar" ;
  vaermesterilisera_vb_1_1_V = mkV "värmesteriliserar" ;
  vaadaskjuta_vb_1_1_V = mkV "vådaskjutar" ;
  vaarstaeda_vb_1_1_V = mkV "vårstädar" ;
  wallraffa_vb_1_V = mkV "wallraffar" ;
  ytbehandla_vb_1_V = mkV "ytbehandlar" ;
  yttra_vb_1_V = mkV "yttrar" ;
  aelska_vb_1_1_V = mkV "älskar" ;
  aemnesintegrera_vb_1_1_V = mkV "ämnesintegrerar" ;
  aenda_vb_1_1_V = mkV "ändar" ;
  aendra_vb_1_1_V = mkV "ändrar" ;
  aadra_vb_2_1_V = mkV "ådrar" ;
  aaldersdiskriminera_vb_1_1_V = mkV "åldersdiskriminerar" ;
  aasiktsregistrera_vb_1_1_V = mkV "åsiktsregistrerar" ;
  aateranpassa_vb_1_1_V = mkV "återanpassar" ;
  aaterbilda_vb_1_1_V = mkV "återbildar" ;
  aaterboerda_vb_1_1_V = mkV "återbördar" ;
  aatereroevra_vb_1_1_V = mkV "återerövrar" ;
  aaterfoersaekra_vb_1_1_V = mkV "återförsäkrar" ;
  aaterinstallera_vb_1_1_V = mkV "återinstallerar" ;
  aaterinvestera_vb_1_1_V = mkV "återinvesterar" ;
  aaterkoppla_vb_1_1_V = mkV "återkopplar" ;
  aaterlaemna_vb_1_1_V = mkV "återlämnar" ;
  aaterplantera_vb_1_1_V = mkV "återplanterar" ;
  aaterspegla_vb_1_1_V = mkV "återspeglar" ;
  aatra_vb_1_1_V = mkV "åtrar" ;
  oedsla_vb_1_1_V = mkV "ödslar" ;
  oegonflirta_vb_1_1_V = mkV "ögonflirtar" ;
  oegonfloerta_vb_1_1_V = mkV "ögonflörtar" ;
  oeppna_vb_1_1_V = mkV "öppnar" ;
  oeverbelasta_vb_1_1_V = mkV "överbelastar" ;
  oeverdebitera_vb_1_1_V = mkV "överdebiterar" ;
  oeverdimensionera_vb_1_1_V = mkV "överdimensionerar" ;
  oeverdosera_vb_1_1_V = mkV "överdoserar" ;
  oeverexponera_vb_1_1_V = mkV "överexponerar" ;
  oeverflygla_vb_1_1_V = mkV "överflyglar" ;
  oeverkompensera_vb_1_1_V = mkV "överkompenserar" ;
  oeverlagra_vb_1_1_V = mkV "överlagrar" ;
  oeverlaemna_vb_1_1_V = mkV "överlämnar" ;
  oeverordna_vb_1_1_V = mkV "överordnar" ;
  oeverraska_vb_1_1_V = mkV "överraskar" ;
  oeverrenovera_vb_1_1_V = mkV "överrenoverar" ;
  oeverrumpla_vb_1_1_V = mkV "överrumplar" ;
  oeverstegra_vb_1_1_V = mkV "överstegrar" ;
  oeversvaemma_vb_1_1_V = mkV "översvämmar" ;
  oevertrassera_vb_1_1_V = mkV "övertrasserar" ;
  oeverutnyttja_vb_1_1_V = mkV "överutnyttjar" ;
  oevervintra_vb_1_1_V = mkV "övervintrar" ;
  oevervaeltra_vb_1_1_V = mkV "övervältrar" ;
  oevervaerdera_vb_1_1_V = mkV "övervärderar" ;
  oevernattningsrum_nn_1_1_N = mkN "övernattningsrum" "övernattningsrummet" "övernattningsrum" "övernattningsrummen" ;
  oeverman_nn_1_1_N = mkN "överman" "övermannen" "övermän" "övermännen" ;
  oeverhuvud_nn_1_1_N = mkN "överhuvud" "överhuvudet" "överhuvuden" "överhuvudena" ;
  oeverfallsvaaldtaektsman_nn_1_1_N = mkN "överfallsvåldtäktsman" "överfallsvåldtäktsmannen" "överfallsvåldtäktsmän" "överfallsvåldtäktsmännen" ;
  oerlogsman_nn_1_1_N = mkN "örlogsman" "örlogsmannen" "örlogsmän" "örlogsmännen" ;
  oera_nn_1_1_N = mkN "öra" "örat" "öron" "öronen" ;
  oega_nn_1_1_N = mkN "öga" "ögat" "ögon" "ögonen" ;
  oedesdrama_nn_1_1_N = mkN "ödesdrama" "ödesdramat" "ödesdraman" "ödesdramana" ;
  aavatten_nn_1_1_N = mkN "åvatten" "åvattnet" "åvatten" "åvattnen" ;
  aaterstaellningstecken_nn_1_1_N = mkN "återställningstecken" "återställningstecknet" "återställningstecken" "återställningstecknen" ;
  aasneoera_nn_1_1_N = mkN "åsneöra" "åsneörat" "åsneöron" "åsneöronen" ;
  aangstroem_nn_1_1_N = mkN "ångström" "ångströmen" "ångström" "ångströmen" ;
  aalderstecken_nn_1_1_N = mkN "ålderstecken" "ålderstecknet" "ålderstecken" "ålderstecknen" ;
  aalderman_nn_1_1_N = mkN "ålderman" "åldermannen" "åldermän" "åldermännen" ;
  aalderdomshem_nn_1_1_N = mkN "ålderdomshem" "ålderdomshemmet" "ålderdomshem" "ålderdomshemmen" ;
  aettefader_nn_1_1_N = mkN "ättefader" "ättefadern" "ättefäder" "ättefäderna" ;
  aeretecken_nn_1_1_N = mkN "äretecken" "äretecknet" "äretecken" "äretecknen" ;
  aenkeman_nn_1_1_N = mkN "änkeman" "änkemannen" "änkemän" "änkemännen" ;
  aendrim_nn_1_1_N = mkN "ändrim" "ändrimmet" "ändrim" "ändrimmen" ;
  aembetsrum_nn_1_1_N = mkN "ämbetsrum" "ämbetsrummet" "ämbetsrum" "ämbetsrummen" ;
  aembetsman_nn_1_1_N = mkN "ämbetsman" "ämbetsmannen" "ämbetsmän" "ämbetsmännen" ;
  aembetsexamen_nn_1_1_N = mkN "ämbetsexamen" "ämbetsexamen" "ämbetsexamina" "ämbetsexamina" ;
  aembetsbroder_nn_1_1_N = mkN "ämbetsbroder" "ämbetsbrodern" "ämbetsbröder" "ämbetsbröderna" ;
  aelvvatten_nn_1_1_N = mkN "älvvatten" "älvvattnet" "älvvatten" "älvvattnen" ;
  aegotecken_nn_1_1_N = mkN "ägotecken" "ägotecknet" "ägotecken" "ägotecknen" ;
  zaeta_nn_1_1_N = mkN "zäta" "zätat" "zäta" "zätana" ;
  zombie_nn_1_N = mkN "zombie" "zombien" "zombies" "zombiesen" ;
  zloty_nn_1_N = mkN "zloty" "zlotyn" "zloty" "zlotyna" ;
  zimbabwier_nn_1_N = mkN "zimbabwier" "zimbabwiern" "zimbabwier" "zimbabwierna" ;
  zeta_nn_1_N = mkN "zeta" "zetat" "zeta" "zetana" ;
  zambier_nn_1_N = mkN "zambier" "zambiern" "zambier" "zambierna" ;
  zairier_nn_1_N = mkN "zairier" "zairiern" "zairier" "zairierna" ;
  yxhuvud_nn_1_N = mkN "yxhuvud" "yxhuvudet" "yxhuvuden" "yxhuvudena" ;
  yxhammare_nn_1_N = mkN "yxhammare" "yxhammaren" "yxhamrar" "yxhamrarna" ;
  ytvatten_nn_1_N = mkN "ytvatten" "ytvattnet" "ytvatten" "ytvattnen" ;
  ytteroera_nn_1_1_N = mkN "ytteröra" "ytterörat" "ytteröron" "ytteröronen" ;
  yrkespolitiker_nn_1_N = mkN "yrkespolitiker" "yrkespolitikern" "yrkespolitiker" "yrkespolitikerna" ;
  yrkesman_nn_1_N = mkN "yrkesman" "yrkesmannen" "yrkesmän" "yrkesmännen" ;
  yrkesfysiker_nn_1_N = mkN "yrkesfysiker" "yrkesfysikern" "yrkesfysiker" "yrkesfysikerna" ;
  yen_nn_1_N = mkN "yen" "yenen" "yen" "yenen" ;
  yard_nn_1_N = mkN "yard" "yarden" "yard" "yarden" ;
  yankee_nn_1_N = mkN "yankee" "yankeen" "yankees" "yankeesen" ;
  wobbler_nn_1_N = mkN "wobbler" "wobblern" "wobbler" "wobblerna" ;
  wiki_nn_1_N = mkN "wiki" "wikin" "wikier" "wikierna" ;
  whig_nn_1_N = mkN "whig" "whigen" "whigs" "whigsen" ;
  western_nn_1_N = mkN "western" "western" "western" "westerna" ;
  weekend_nn_1_N = mkN "weekend" "weekenden" "weekends" "weekendsen" ;
  watussi_nn_1_N = mkN "watussi" "watussin" "watussi" "watussina" ;
  watusi_nn_1_N = mkN "watusi" "watusin" "watusi" "watusina" ;
  watt_nn_1_N = mkN "watt" "watten" "watt" "watten" ;
  walkie_talkie_nn_1_N = mkN "walkie-talkie" "walkie-talkien" "walkie-talkies" "walkie-talkiesen" ;
  wafer_nn_1_N = mkN "wafer" "wafern" "wafers" "wafersen" ;
  vaatrum_nn_1_1_N = mkN "våtrum" "våtrummet" "våtrum" "våtrummen" ;
  vaartecken_nn_1_1_N = mkN "vårtecken" "vårtecknet" "vårtecken" "vårtecknen" ;
  vaardtecken_nn_1_1_N = mkN "vårdtecken" "vårdtecknet" "vårdtecken" "vårdtecknen" ;
  vaardhem_nn_1_1_N = mkN "vårdhem" "vårdhemmet" "vårdhem" "vårdhemmen" ;
  vaaldtaektsman_nn_1_1_N = mkN "våldtäktsman" "våldtäktsmannen" "våldtäktsmän" "våldtäktsmännen" ;
  vaaldsman_nn_1_1_N = mkN "våldsman" "våldsmannen" "våldsmän" "våldsmännen" ;
  vaextlim_nn_1_1_N = mkN "växtlim" "växtlimmet" "växtlim" "växtlimmen" ;
  vaetevapen_nn_1_1_N = mkN "vätevapen" "vätevapnet" "vätevapen" "vätevapnen" ;
  vaerldsman_nn_1_1_N = mkN "världsman" "världsmannen" "världsmän" "världsmännen" ;
  vaerdighetstecken_nn_1_1_N = mkN "värdighetstecken" "värdighetstecknet" "värdighetstecken" "värdighetstecknen" ;
  vaerderingsman_nn_1_1_N = mkN "värderingsman" "värderingsmannen" "värderingsmän" "värderingsmännen" ;
  vaentrum_nn_1_1_N = mkN "väntrum" "väntrummet" "väntrum" "väntrummen" ;
  vaensteroera_nn_1_1_N = mkN "vänsteröra" "vänsterörat" "vänsteröron" "vänsteröronen" ;
  vaensteroega_nn_1_1_N = mkN "vänsteröga" "vänsterögat" "vänsterögon" "vänsterögonen" ;
  vaensterpolitiker_nn_1_1_N = mkN "vänsterpolitiker" "vänsterpolitikern" "vänsterpolitiker" "vänsterpolitikerna" ;
  vaeglus_nn_1_1_N = mkN "väglus" "väglusen" "väglöss" "väglössen" ;
  vaegglus_nn_1_1_N = mkN "vägglus" "vägglusen" "vägglöss" "vägglössen" ;
  vaegfarande_nn_1_1_N = mkN "vägfarande" "vägfaranden" "vägfarande" "vägfarandena" ;
  vaeckelseman_nn_1_1_N = mkN "väckelseman" "väckelsemannen" "väckelsemän" "väckelsemännen" ;
  vuxenstuderande_nn_1_N = mkN "vuxenstuderande" "vuxenstuderanden" "vuxenstuderande" "vuxenstuderandena" ;
  voucher_nn_1_N = mkN "voucher" "vouchern" "voucher" "voucherna" ;
  volymprocent_nn_1_N = mkN "volymprocent" "volymprocenten" "volymprocent" "volymprocenten" ;
  volt_nn_1_N = mkN "volt" "volten" "volt" "volten" ;
  vokalrim_nn_1_N = mkN "vokalrim" "vokalrimmet" "vokalrim" "vokalrimmen" ;
  vobbler_nn_1_N = mkN "vobbler" "vobblern" "vobbler" "vobblerna" ;
  visman_nn_1_N = mkN "visman" "vismannen" "vismän" "vismännen" ;
  viprum_nn_1_N = mkN "viprum" "viprummet" "viprum" "viprummen" ;
  vinlus_nn_1_N = mkN "vinlus" "vinlusen" "vinlöss" "vinlössen" ;
  vingoera_nn_1_1_N = mkN "vingöra" "vingörat" "vingöron" "vingöronen" ;
  vingaardsman_nn_1_1_N = mkN "vingårdsman" "vingårdsmannen" "vingårdsmän" "vingårdsmännen" ;
  vingman_nn_1_N = mkN "vingman" "vingmannen" "vingmän" "vingmännen" ;
  vindoega_nn_1_1_N = mkN "vindöga" "vindögat" "vindögon" "vindögonen" ;
  vindskammare_nn_1_N = mkN "vindskammare" "vindskammaren" "vindskamrar" "vindskamrarna" ;
  vilrum_nn_1_N = mkN "vilrum" "vilrummet" "vilrum" "vilrummen" ;
  vilorum_nn_1_N = mkN "vilorum" "vilorummet" "vilorum" "vilorummen" ;
  vilohem_nn_1_N = mkN "vilohem" "vilohemmet" "vilohem" "vilohemmen" ;
  vildman_nn_1_N = mkN "vildman" "vildmannen" "vildmän" "vildmännen" ;
  vildgaas_nn_1_1_N = mkN "vildgås" "vildgåsen" "vildgäss" "vildgässen" ;
  viktprocent_nn_1_N = mkN "viktprocent" "viktprocenten" "viktprocent" "viktprocenten" ;
  vigselrum_nn_1_N = mkN "vigselrum" "vigselrummet" "vigselrum" "vigselrummen" ;
  viderboende_nn_1_N = mkN "viderboende" "viderboenden" "viderboende" "viderboendena" ;
  vichyvatten_nn_1_N = mkN "vichyvatten" "vichyvattnet" "vichyvatten" "vichyvattnen" ;
  vetenskapsman_nn_1_N = mkN "vetenskapsman" "vetenskapsmannen" "vetenskapsmän" "vetenskapsmännen" ;
  verst_nn_1_N = mkN "verst" "versten" "verst" "versten" ;
  verktum_nn_1_N = mkN "verktum" "verktummen" "verktum" "verktummen" ;
  vender_nn_1_N = mkN "vender" "vendern" "vender" "venderna" ;
  vederdeloman_nn_1_N = mkN "vederdeloman" "vederdelomannen" "vederdelomän" "vederdelomännen" ;
  vattenledningsvatten_nn_1_N = mkN "vattenledningsvatten" "vattenledningsvattnet" "vattenledningsvatten" "vattenledningsvattnen" ;
  vatten_nn_1_N = mkN "vatten" "vattnet" "vatten" "vattnen" ;
  varufakta_nn_1_N = mkN "varufakta" "varufaktan" "varufakta" "varufaktana" ;
  varningstecken_nn_1_N = mkN "varningstecken" "varningstecknet" "varningstecken" "varningstecknen" ;
  varmvatten_nn_1_N = mkN "varmvatten" "varmvattnet" "varmvatten" "varmvattnen" ;
  varia_nn_1_N = mkN "varia" "varian" "varia" "variana" ;
  vardagsrum_nn_1_N = mkN "vardagsrum" "vardagsrummet" "vardagsrum" "vardagsrummen" ;
  vapenbroder_nn_1_N = mkN "vapenbroder" "vapenbrodern" "vapenbröder" "vapenbröderna" ;
  vapen_nn_1_N = mkN "vapen" "vapnet" "vapen" "vapnen" ;
  vanuatuer_nn_1_N = mkN "vanuatuer" "vanuatuern" "vanuatuer" "vanuatuerna" ;
  vandringsman_nn_1_N = mkN "vandringsman" "vandringsmannen" "vandringsmän" "vandringsmännen" ;
  vandrarhem_nn_1_N = mkN "vandrarhem" "vandrarhemmet" "vandrarhem" "vandrarhemmen" ;
  valslogan_nn_1_N = mkN "valslogan" "valslogan" "valslogans" "valslogansen" ;
  valman_nn_1_N = mkN "valman" "valmannen" "valmän" "valmännen" ;
  vakuumkammare_nn_1_N = mkN "vakuumkammare" "vakuumkammaren" "vakuumkamrar" "vakuumkamrarna" ;
  vaktman_nn_1_N = mkN "vaktman" "vaktmannen" "vaktmän" "vaktmännen" ;
  vakthavande_nn_1_N = mkN "vakthavande" "vakthavanden" "vakthavande" "vakthavandena" ;
  vacuumkammare_nn_1_N = mkN "vacuumkammare" "vacuumkammaren" "vacuumkamrar" "vacuumkamrarna" ;
  uttalstecken_nn_1_N = mkN "uttalstecken" "uttalstecknet" "uttalstecken" "uttalstecknen" ;
  utskottsordfoerande_nn_1_1_N = mkN "utskottsordförande" "utskottsordföranden" "utskottsordförande" "utskottsordförandena" ;
  utropstecken_nn_1_N = mkN "utropstecken" "utropstecknet" "utropstecken" "utropstecknen" ;
  utredningsman_nn_1_N = mkN "utredningsman" "utredningsmannen" "utredningsmän" "utredningsmännen" ;
  uthyrningsrum_nn_1_N = mkN "uthyrningsrum" "uthyrningsrummet" "uthyrningsrum" "uthyrningsrummen" ;
  utfallsrum_nn_1_N = mkN "utfallsrum" "utfallsrummet" "utfallsrum" "utfallsrummen" ;
  uterum_nn_1_N = mkN "uterum" "uterummet" "uterum" "uterummen" ;
  utelaemningstecken_nn_1_1_N = mkN "utelämningstecken" "utelämningstecknet" "utelämningstecken" "utelämningstecknen" ;
  urhem_nn_1_N = mkN "urhem" "urhemmet" "urhem" "urhemmen" ;
  urfader_nn_1_N = mkN "urfader" "urfadern" "urfäder" "urfäderna" ;
  upptaecktsresande_nn_1_1_N = mkN "upptäcktsresande" "upptäcktsresanden" "upptäcktsresande" "upptäcktsresandena" ;
  upptagningshem_nn_1_N = mkN "upptagningshem" "upptagningshemmet" "upptagningshem" "upptagningshemmen" ;
  uppsyningsman_nn_1_N = mkN "uppsyningsman" "uppsyningsmannen" "uppsyningsmän" "uppsyningsmännen" ;
  upprorsman_nn_1_N = mkN "upprorsman" "upprorsmannen" "upprorsmän" "upprorsmännen" ;
  uppklarningsprocent_nn_1_N = mkN "uppklarningsprocent" "uppklarningsprocenten" "uppklarningsprocent" "uppklarningsprocenten" ;
  upphovsman_nn_1_N = mkN "upphovsman" "upphovsmannen" "upphovsmän" "upphovsmännen" ;
  uppfostringshem_nn_1_N = mkN "uppfostringshem" "uppfostringshemmet" "uppfostringshem" "uppfostringshemmen" ;
  uppercut_nn_1_N = mkN "uppercut" "uppercuten" "uppercuts" "uppercutsen" ;
  uppboerdsman_nn_1_1_N = mkN "uppbördsman" "uppbördsmannen" "uppbördsmän" "uppbördsmännen" ;
  universitetsstuderande_nn_1_N = mkN "universitetsstuderande" "universitetsstuderanden" "universitetsstuderande" "universitetsstuderandena" ;
  uniformstecken_nn_1_N = mkN "uniformstecken" "uniformstecknet" "uniformstecken" "uniformstecknen" ;
  ungdomshem_nn_1_N = mkN "ungdomshem" "ungdomshemmet" "ungdomshem" "ungdomshemmen" ;
  undersoekningsrum_nn_1_1_N = mkN "undersökningsrum" "undersökningsrummet" "undersökningsrum" "undersökningsrummen" ;
  underraettelseofficer_nn_1_1_N = mkN "underrättelseofficer" "underrättelseofficern" "underrättelseofficerare" "underrättelseofficerarna" ;
  underofficer_nn_1_N = mkN "underofficer" "underofficern" "underofficerare" "underofficerarna" ;
  underhavande_nn_1_N = mkN "underhavande" "underhavanden" "underhavande" "underhavandena" ;
  undergaangstecken_nn_1_1_N = mkN "undergångstecken" "undergångstecknet" "undergångstecken" "undergångstecknen" ;
  undergaangsscenario_nn_1_1_N = mkN "undergångsscenario" "undergångsscenariot" "undergångsscenarion" "undergångsscenariona" ;
  ultra_nn_1_N = mkN "ultra" "ultran" "ultras" "ultrasen" ;
  ullus_nn_1_N = mkN "ullus" "ullusen" "ullöss" "ullössen" ;
  ugandier_nn_1_N = mkN "ugandier" "ugandiern" "ugandier" "ugandierna" ;
  uddrim_nn_1_N = mkN "uddrim" "uddrimmet" "uddrim" "uddrimmen" ;
  toecken_nn_1_1_N = mkN "töcken" "töcknet" "töcken" "töcknen" ;
  tvaettvatten_nn_1_1_N = mkN "tvättvatten" "tvättvattnet" "tvättvatten" "tvättvattnen" ;
  tunisier_nn_1_N = mkN "tunisier" "tunisiern" "tunisier" "tunisierna" ;
  tuner_nn_1_N = mkN "tuner" "tunern" "tuner" "tunerna" ;
  tum_nn_1_N = mkN "tum" "tummen" "tum" "tummen" ;
  tulltjaensteman_nn_1_1_N = mkN "tulltjänsteman" "tulltjänstemannen" "tulltjänstemän" "tulltjänstemännen" ;
  tullkammare_nn_1_N = mkN "tullkammare" "tullkammaren" "tullkamrar" "tullkamrarna" ;
  tsunami_nn_1_N = mkN "tsunami" "tsunamin" "tsunamier" "tsunamierna" ;
  troetthetstecken_nn_1_1_N = mkN "trötthetstecken" "trötthetstecknet" "trötthetstecken" "trötthetstecknen" ;
  traetobroder_nn_1_1_N = mkN "trätobroder" "trätobrodern" "trätobröder" "trätobröderna" ;
  tryckkammare_nn_1_N = mkN "tryckkammare" "tryckkammaren" "tryckkamrar" "tryckkamrarna" ;
  trumpetsolo_nn_1_N = mkN "trumpetsolo" "trumpetsolot" "trumpetsolon" "trumpetsolona" ;
  troman_nn_1_N = mkN "troman" "tromannen" "tromän" "tromännen" ;
  trio_nn_1_N = mkN "trio" "trion" "trios" "triosen" ;
  trinidadier_nn_1_N = mkN "trinidadier" "trinidadiern" "trinidadier" "trinidadierna" ;
  trimmer_nn_1_N = mkN "trimmer" "trimmern" "trimmers" "trimmersen" ;
  trimhuvud_nn_1_N = mkN "trimhuvud" "trimhuvudet" "trimhuvuden" "trimhuvudena" ;
  triangeldrama_nn_1_N = mkN "triangeldrama" "triangeldramat" "triangeldraman" "triangeldramana" ;
  trauma_nn_1_N = mkN "trauma" "traumat" "trauman" "traumana" ;
  trapper_nn_1_N = mkN "trapper" "trappern" "trapper" "trapperna" ;
  trainee_nn_1_N = mkN "trainee" "traineen" "trainees" "traineesen" ;
  tragiker_nn_1_N = mkN "tragiker" "tragikern" "tragiker" "tragikerna" ;
  tory_nn_1_N = mkN "tory" "toryn" "tories" "tories" ;
  tortyrkammare_nn_1_N = mkN "tortyrkammare" "tortyrkammaren" "tortyrkamrar" "tortyrkamrarna" ;
  torso_nn_1_N = mkN "torso" "torson" "torser" "torserna" ;
  torskoega_nn_1_1_N = mkN "torsköga" "torskögat" "torskögon" "torskögonen" ;
  tornado_nn_1_N = mkN "tornado" "tornadon" "tornados" "tornadosen" ;
  torkrum_nn_1_N = mkN "torkrum" "torkrummet" "torkrum" "torkrummen" ;
  toppolitiker_nn_1_N = mkN "toppolitiker" "toppolitikern" "toppolitiker" "toppolitikerna" ;
  toppman_nn_1_N = mkN "toppman" "toppmannen" "toppmän" "toppmännen" ;
  toppduo_nn_1_N = mkN "toppduo" "toppduon" "toppduos" "toppduosen" ;
  tonkilometer_nn_1_N = mkN "tonkilometer" "tonkilometern" "tonkilometer" "tonkilometerna" ;
  tomrum_nn_1_N = mkN "tomrum" "tomrummet" "tomrum" "tomrummen" ;
  tolvman_nn_1_N = mkN "tolvman" "tolvmannen" "tolvmän" "tolvmännen" ;
  tofsoera_nn_1_1_N = mkN "tofsöra" "tofsörat" "tofsöron" "tofsöronen" ;
  tjaenstevapen_nn_1_1_N = mkN "tjänstevapen" "tjänstevapnet" "tjänstevapen" "tjänstevapnen" ;
  tjaensterum_nn_1_1_N = mkN "tjänsterum" "tjänsterummet" "tjänsterum" "tjänsterummen" ;
  tjaensteman_nn_1_1_N = mkN "tjänsteman" "tjänstemannen" "tjänstemän" "tjänstemännen" ;
  tjurhuvud_nn_1_N = mkN "tjurhuvud" "tjurhuvudet" "tjurhuvuden" "tjurhuvudena" ;
  timmerman_nn_1_N = mkN "timmerman" "timmermannen" "timmermän" "timmermännen" ;
  tillvaextfanatiker_nn_1_1_N = mkN "tillväxtfanatiker" "tillväxtfanatikern" "tillväxtfanatiker" "tillväxtfanatikerna" ;
  tillsynsman_nn_1_N = mkN "tillsynsman" "tillsynsmannen" "tillsynsmän" "tillsynsmännen" ;
  tillsyningsman_nn_1_N = mkN "tillsyningsman" "tillsyningsmannen" "tillsyningsmän" "tillsyningsmännen" ;
  tidvatten_nn_1_N = mkN "tidvatten" "tidvattnet" "tidvatten" "tidvattnen" ;
  tidsstudieman_nn_1_N = mkN "tidsstudieman" "tidsstudiemannen" "tidsstudiemän" "tidsstudiemännen" ;
  tidningsman_nn_1_N = mkN "tidningsman" "tidningsmannen" "tidningsmän" "tidningsmännen" ;
  tic_nn_1_N = mkN "tic" "ticen" "tics" "ticsen" ;
  thaeta_nn_1_1_N = mkN "thäta" "thätat" "thäta" "thätana" ;
  theta_nn_1_N = mkN "theta" "thetat" "theta" "thetana" ;
  teve_nn_2_N = mkN "teve" "teven" "teve" "tevena" ;
  tesla_nn_1_N = mkN "tesla" "teslan" "tesla" "teslana" ;
  territorialvatten_nn_1_N = mkN "territorialvatten" "territorialvattnet" "territorialvatten" "territorialvattnen" ;
  terrier_nn_1_N = mkN "terrier" "terriern" "terrier" "terrierna" ;
  terminalrum_nn_1_N = mkN "terminalrum" "terminalrummet" "terminalrum" "terminalrummen" ;
  terawatt_nn_1_N = mkN "terawatt" "terawatten" "terawatt" "terawatten" ;
  teraelektronvolt_nn_1_N = mkN "teraelektronvolt" "teraelektronvolten" "teraelektronvolt" "teraelektronvolten" ;
  terabyte_nn_1_N = mkN "terabyte" "terabyten" "terabyte" "terabytena" ;
  teoretiker_nn_1_N = mkN "teoretiker" "teoretikern" "teoretiker" "teoretikerna" ;
  tentamen_nn_1_N = mkN "tentamen" "tentamen" "tentamina" "tentamina" ;
  tempo_nn_1_N = mkN "tempo" "tempot" "tempon" "tempona" ;
  tema_nn_1_N = mkN "tema" "temat" "teman" "temana" ;
  teleskopoega_nn_1_1_N = mkN "teleskopöga" "teleskopögat" "teleskopögon" "teleskopögonen" ;
  teledata_nn_1_N = mkN "teledata" "teledatan" "teledata" "teledatana" ;
  tekniker_nn_1_N = mkN "tekniker" "teknikern" "tekniker" "teknikerna" ;
  tecken_nn_1_N = mkN "tecken" "tecknet" "tecken" "tecknen" ;
  teach_in_nn_1_N = mkN "teach-in" "teach-in" "teach-in" "teach-ina" ;
  tchadier_nn_1_N = mkN "tchadier" "tchadiern" "tchadier" "tchadierna" ;
  taxi_nn_1_N = mkN "taxi" "taxin" "taxi" "taxina" ;
  taxeringsman_nn_1_N = mkN "taxeringsman" "taxeringsmannen" "taxeringsmän" "taxeringsmännen" ;
  tanzanier_nn_1_N = mkN "tanzanier" "tanzaniern" "tanzanier" "tanzanierna" ;
  tantslem_nn_1_N = mkN "tantslem" "tantslemmet" "tantslem" "tantslemmen" ;
  tandtekniker_nn_1_N = mkN "tandtekniker" "tandteknikern" "tandtekniker" "tandteknikerna" ;
  talman_nn_1_N = mkN "talman" "talmannen" "talmän" "talmännen" ;
  talesman_nn_1_N = mkN "talesman" "talesmannen" "talesmän" "talesmännen" ;
  taktiker_nn_1_N = mkN "taktiker" "taktikern" "taktiker" "taktikerna" ;
  takeaway_nn_1_N = mkN "takeaway" "takeawayen" "takeawayer" "takeawayerna" ;
  take_away_nn_1_N = mkN "take-away" "take-awayen" "take-awayer" "take-awayerna" ;
  taco_nn_1_N = mkN "taco" "tacon" "tacos" "tacosen" ;
  tabellhuvud_nn_1_N = mkN "tabellhuvud" "tabellhuvudet" "tabellhuvuden" "tabellhuvudena" ;
  soetvatten_nn_1_1_N = mkN "sötvatten" "sötvattnet" "sötvatten" "sötvattnen" ;
  soem_nn_2_1_N = mkN "söm" "sömmet" "söm" "sömmen" ;
  soekande_nn_1_1_N = mkN "sökande" "sökanden" "sökande" "sökandena" ;
  saapvatten_nn_1_1_N = mkN "såpvatten" "såpvattnet" "såpvatten" "såpvattnen" ;
  saaningsman_nn_1_1_N = mkN "såningsman" "såningsmannen" "såningsmän" "såningsmännen" ;
  saangtema_nn_1_1_N = mkN "sångtema" "sångtemat" "sångteman" "sångtemana" ;
  saenkningstecken_nn_1_1_N = mkN "sänkningstecken" "sänkningstecknet" "sänkningstecken" "sänkningstecknen" ;
  saengkammare_nn_1_1_N = mkN "sängkammare" "sängkammaren" "sängkamrar" "sängkamrarna" ;
  saellskapsrum_nn_1_1_N = mkN "sällskapsrum" "sällskapsrummet" "sällskapsrum" "sällskapsrummen" ;
  saellskapsbroder_nn_1_1_N = mkN "sällskapsbroder" "sällskapsbrodern" "sällskapsbröder" "sällskapsbröderna" ;
  saekerhetsman_nn_1_1_N = mkN "säkerhetsman" "säkerhetsmannen" "säkerhetsmän" "säkerhetsmännen" ;
  saedgaas_nn_1_1_N = mkN "sädgås" "sädgåsen" "sädgäss" "sädgässen" ;
  systemman_nn_1_N = mkN "systemman" "systemmannen" "systemmän" "systemmännen" ;
  syssloman_nn_1_N = mkN "syssloman" "sysslomannen" "sysslomän" "sysslomännen" ;
  syrier_nn_1_N = mkN "syrier" "syriern" "syrier" "syrierna" ;
  synoptiker_nn_1_N = mkN "synoptiker" "synoptikern" "synoptiker" "synoptikerna" ;
  symfoniker_nn_1_N = mkN "symfoniker" "symfonikern" "symfoniker" "symfonikerna" ;
  sweatshirt_nn_1_N = mkN "sweatshirt" "sweatshirten" "sweatshirts" "sweatshirtsen" ;
  svaerfar_nn_1_1_N = mkN "svärfar" "svärfadern" "svärfäder" "svärfäderna" ;
  svephammare_nn_1_N = mkN "svephammare" "svephammaren" "svephamrar" "svephamrarna" ;
  svartsjukedrama_nn_1_N = mkN "svartsjukedrama" "svartsjukedramat" "svartsjukedraman" "svartsjukedramana" ;
  svartbroder_nn_1_N = mkN "svartbroder" "svartbrodern" "svartbröder" "svartbröderna" ;
  svarande_nn_1_N = mkN "svarande" "svaranden" "svarande" "svarandena" ;
  svaghetstecken_nn_1_N = mkN "svaghetstecken" "svaghetstecknet" "svaghetstecken" "svaghetstecknen" ;
  sundhetstecken_nn_1_N = mkN "sundhetstecken" "sundhetstecknet" "sundhetstecken" "sundhetstecknen" ;
  sumerer_nn_1_N = mkN "sumerer" "sumerern" "sumerer" "sumererna" ;
  sudoku_nn_1_N = mkN "sudoku" "sudokun" "sudokun" "sudokuna" ;
  stoel_nn_1_1_N = mkN "stöl" "stölen" "stöl" "stölen" ;
  staauppkomiker_nn_1_1_N = mkN "ståuppkomiker" "ståuppkomikern" "ståuppkomiker" "ståuppkomikerna" ;
  staangjaernshammare_nn_1_1_N = mkN "stångjärnshammare" "stångjärnshammaren" "stångjärnshamrar" "stångjärnshamrarna" ;
  staanghammare_nn_1_1_N = mkN "stånghammare" "stånghammaren" "stånghamrar" "stånghamrarna" ;
  staalman_nn_1_1_N = mkN "stålman" "stålmannen" "stålmän" "stålmännen" ;
  staendchen_nn_1_1_N = mkN "ständchen" "ständchenen" "ständchen" "ständchenen" ;
  styvfar_nn_1_N = mkN "styvfar" "styvfadern" "styvfäder" "styvfäderna" ;
  styver_nn_1_N = mkN "styver" "styvern" "styver" "styverna" ;
  styrtecken_nn_1_N = mkN "styrtecken" "styrtecknet" "styrtecken" "styrtecknen" ;
  styrman_nn_1_N = mkN "styrman" "styrmannen" "styrmän" "styrmännen" ;
  styresman_nn_1_N = mkN "styresman" "styresmannen" "styresmän" "styresmännen" ;
  styrelserum_nn_1_N = mkN "styrelserum" "styrelserummet" "styrelserum" "styrelserummen" ;
  styrelseordfoerande_nn_1_1_N = mkN "styrelseordförande" "styrelseordföranden" "styrelseordförande" "styrelseordförandena" ;
  styck_nn_1_N = mkN "styck" "stycken" "styck" "styckena" ;
  stuntman_nn_1_N = mkN "stuntman" "stuntmannen" "stuntmän" "stuntmännen" ;
  studiosus_nn_1_N = mkN "studiosus" "studiosus" "studiosi" "studiosina" ;
  studiomusiker_nn_1_N = mkN "studiomusiker" "studiomusikern" "studiomusiker" "studiomusikerna" ;
  studioman_nn_1_N = mkN "studioman" "studiomannen" "studiomän" "studiomännen" ;
  studerkammare_nn_1_N = mkN "studerkammare" "studerkammaren" "studerkamrar" "studerkamrarna" ;
  studerande_nn_1_N = mkN "studerande" "studeranden" "studerande" "studerandena" ;
  studentrum_nn_1_N = mkN "studentrum" "studentrummet" "studentrum" "studentrummen" ;
  studenthem_nn_1_N = mkN "studenthem" "studenthemmet" "studenthem" "studenthemmen" ;
  studentexamen_nn_1_N = mkN "studentexamen" "studentexamen" "studentexamina" "studentexamina" ;
  strykrum_nn_1_N = mkN "strykrum" "strykrummet" "strykrum" "strykrummen" ;
  struphuvud_nn_1_N = mkN "struphuvud" "struphuvudet" "struphuvuden" "struphuvudena" ;
  stroke_nn_2_N = mkN "stroke" "stroken" "strokes" "strokesen" ;
  stridsman_nn_1_N = mkN "stridsman" "stridsmannen" "stridsmän" "stridsmännen" ;
  streamer_nn_1_N = mkN "streamer" "streamern" "streamers" "streamersen" ;
  stratum_nn_1_N = mkN "stratum" "stratum" "strata" "stratana" ;
  storman_nn_1_N = mkN "storman" "stormannen" "stormän" "stormännen" ;
  stopper_nn_1_N = mkN "stopper" "stoppern" "stoppers" "stoppersen" ;
  stoiker_nn_1_N = mkN "stoiker" "stoikern" "stoiker" "stoikerna" ;
  stimulantia_nn_1_N = mkN "stimulantia" "stimulantian" "stimulantia" "stimulantiana" ;
  stilistiker_nn_1_N = mkN "stilistiker" "stilistikern" "stilistiker" "stilistikerna" ;
  stigman_nn_1_N = mkN "stigman" "stigmannen" "stigmän" "stigmännen" ;
  stigma_nn_1_N = mkN "stigma" "stigmat" "stigman" "stigmana" ;
  stickvapen_nn_1_N = mkN "stickvapen" "stickvapnet" "stickvapen" "stickvapnen" ;
  stavrim_nn_1_N = mkN "stavrim" "stavrimmet" "stavrim" "stavrimmen" ;
  statsoeverhuvud_nn_1_1_N = mkN "statsöverhuvud" "statsöverhuvudet" "statsöverhuvuden" "statsöverhuvudena" ;
  statstjaensteman_nn_1_1_N = mkN "statstjänsteman" "statstjänstemannen" "statstjänstemän" "statstjänstemännen" ;
  statsman_nn_1_N = mkN "statsman" "statsmannen" "statsmän" "statsmännen" ;
  statistiker_nn_1_N = mkN "statistiker" "statistikern" "statistiker" "statistikerna" ;
  starter_nn_1_N = mkN "starter" "startern" "starter" "starterna" ;
  stamfar_nn_1_N = mkN "stamfar" "stamfadern" "stamfäder" "stamfäderna" ;
  stallbroder_nn_1_N = mkN "stallbroder" "stallbrodern" "stallbröder" "stallbröderna" ;
  staffli_nn_1_N = mkN "staffli" "staffliet" "stafflier" "stafflierna" ;
  stadsfullmaektig_nn_1_1_N = mkN "stadsfullmäktig" "stadsfullmäktigen" "stadsfullmäktige" "stadsfullmäktigena" ;
  stabsofficer_nn_1_N = mkN "stabsofficer" "stabsofficern" "stabsofficerare" "stabsofficerarna" ;
  spaaman_nn_1_1_N = mkN "spåman" "spåmannen" "spåmän" "spåmännen" ;
  spaenn_nn_1_1_N = mkN "spänn" "spännen" "spänn" "spännen" ;
  spraaktecken_nn_1_1_N = mkN "språktecken" "språktecknet" "språktecken" "språktecknen" ;
  sprinter_nn_1_N = mkN "sprinter" "sprintern" "sprinter" "sprinterna" ;
  sprinkler_nn_1_N = mkN "sprinkler" "sprinklern" "sprinkler" "sprinklerna" ;
  springvatten_nn_1_N = mkN "springvatten" "springvattnet" "springvatten" "springvattnen" ;
  spotlight_nn_1_N = mkN "spotlight" "spotlighten" "spotlights" "spotlightsen" ;
  sportsman_nn_1_N = mkN "sportsman" "sportsmannen" "sportsmän" "sportsmännen" ;
  spoiler_nn_1_N = mkN "spoiler" "spoilern" "spoiler" "spoilerna" ;
  spiskammare_nn_1_N = mkN "spiskammare" "spiskammaren" "spiskamrar" "spiskamrarna" ;
  spillvatten_nn_1_N = mkN "spillvatten" "spillvattnet" "spillvatten" "spillvattnen" ;
  spikhuvud_nn_1_N = mkN "spikhuvud" "spikhuvudet" "spikhuvuden" "spikhuvudena" ;
  spetsbergsgaas_nn_1_1_N = mkN "spetsbergsgås" "spetsbergsgåsen" "spetsbergsgäss" "spetsbergsgässen" ;
  spelman_nn_1_N = mkN "spelman" "spelmannen" "spelmän" "spelmännen" ;
  speleman_nn_1_N = mkN "speleman" "spelemannen" "spelemän" "spelemännen" ;
  speldrama_nn_1_N = mkN "speldrama" "speldramat" "speldraman" "speldramana" ;
  speaker_nn_1_N = mkN "speaker" "speakern" "speaker" "speakerna" ;
  spastiker_nn_1_N = mkN "spastiker" "spastikern" "spastiker" "spastikerna" ;
  sparringpartner_nn_1_N = mkN "sparringpartner" "sparringpartnern" "sparringpartner" "sparringpartnerna" ;
  spaniel_nn_1_N = mkN "spaniel" "spanieln" "spanielar" "spanielarna" ;
  spader_nn_1_N = mkN "spader" "spadern" "spader" "spaderna" ;
  sovrum_nn_1_N = mkN "sovrum" "sovrummet" "sovrum" "sovrummen" ;
  sommarhem_nn_1_N = mkN "sommarhem" "sommarhemmet" "sommarhem" "sommarhemmen" ;
  somatiker_nn_1_N = mkN "somatiker" "somatikern" "somatiker" "somatikerna" ;
  somalier_nn_1_N = mkN "somalier" "somaliern" "somalier" "somalierna" ;
  soloega_nn_1_1_N = mkN "solöga" "solögat" "solögon" "solögonen" ;
  solo_nn_1_N = mkN "solo" "solot" "solon" "solona" ;
  soldathem_nn_1_N = mkN "soldathem" "soldathemmet" "soldathem" "soldathemmen" ;
  sodavatten_nn_1_N = mkN "sodavatten" "sodavattnet" "sodavatten" "sodavattnen" ;
  snaellhetsguru_nn_1_1_N = mkN "snällhetsguru" "snällhetsgurun" "snällhetsguruer" "snällhetsguruerna" ;
  snowboard_nn_1_N = mkN "snowboard" "snowboarden" "snowboards" "snowboardsen" ;
  smaeltvatten_nn_1_1_N = mkN "smältvatten" "smältvattnet" "smältvatten" "smältvattnen" ;
  smaellglim_nn_1_1_N = mkN "smällglim" "smällglimmen" "smällglim" "smällglimmen" ;
  smutsvatten_nn_1_N = mkN "smutsvatten" "smutsvattnet" "smutsvatten" "smutsvattnen" ;
  smiley_nn_1_N = mkN "smiley" "smileyn" "smileys" "smileysen" ;
  smartphone_nn_1_N = mkN "smartphone" "smartphonen" "smartphones" "smartphonesen" ;
  slaektvapen_nn_1_1_N = mkN "släktvapen" "släktvapnet" "släktvapen" "släktvapnen" ;
  slaegghammare_nn_1_1_N = mkN "slägghammare" "slägghammaren" "slägghamrar" "slägghamrarna" ;
  slusshuvud_nn_1_N = mkN "slusshuvud" "slusshuvudet" "slusshuvuden" "slusshuvudena" ;
  slughuvud_nn_1_N = mkN "slughuvud" "slughuvudet" "slughuvuden" "slughuvudena" ;
  slogan_nn_1_N = mkN "slogan" "slogan" "slogans" "slogansen" ;
  slaskvatten_nn_1_N = mkN "slaskvatten" "slaskvattnet" "slaskvatten" "slaskvattnen" ;
  slagvapen_nn_1_N = mkN "slagvapen" "slagvapnet" "slagvapen" "slagvapnen" ;
  skoeldlus_nn_1_1_N = mkN "sköldlus" "sköldlusen" "sköldlöss" "sköldlössen" ;
  skyeterrier_nn_1_N = mkN "skyeterrier" "skyeterriern" "skyeterrier" "skyeterrierna" ;
  skraepkammare_nn_1_1_N = mkN "skräpkammare" "skräpkammaren" "skräpkamrar" "skräpkamrarna" ;
  skruvhuvud_nn_1_N = mkN "skruvhuvud" "skruvhuvudet" "skruvhuvuden" "skruvhuvudena" ;
  skrivtecken_nn_1_N = mkN "skrivtecken" "skrivtecknet" "skrivtecken" "skrivtecknen" ;
  skottdrama_nn_1_N = mkN "skottdrama" "skottdramat" "skottdraman" "skottdramana" ;
  skolastiker_nn_1_N = mkN "skolastiker" "skolastikern" "skolastiker" "skolastikerna" ;
  skogsraa_nn_1_1_N = mkN "skogsrå" "skogsrået" "skogsrår" "skogsrårna" ;
  skogsmus_nn_1_N = mkN "skogsmus" "skogsmusen" "skogsmöss" "skogsmössen" ;
  skogsgenetiker_nn_1_N = mkN "skogsgenetiker" "skogsgenetikern" "skogsgenetiker" "skogsgenetikerna" ;
  skjutvapen_nn_1_N = mkN "skjutvapen" "skjutvapnet" "skjutvapen" "skjutvapnen" ;
  skinhead_nn_1_N = mkN "skinhead" "skinheadet" "skinheads" "skinheadsen" ;
  skiljetecken_nn_1_N = mkN "skiljetecken" "skiljetecknet" "skiljetecken" "skiljetecknen" ;
  skiljeman_nn_1_N = mkN "skiljeman" "skiljemannen" "skiljemän" "skiljemännen" ;
  skeptiker_nn_1_N = mkN "skeptiker" "skeptikern" "skeptiker" "skeptikerna" ;
  skepparexamen_nn_1_N = mkN "skepparexamen" "skepparexamen" "skepparexamina" "skepparexamina" ;
  skattkammare_nn_1_N = mkN "skattkammare" "skattkammaren" "skattkamrar" "skattkamrarna" ;
  skateboard_nn_1_N = mkN "skateboard" "skateboarden" "skateboard" "skateboarden" ;
  sjoevatten_nn_1_1_N = mkN "sjövatten" "sjövattnet" "sjövatten" "sjövattnen" ;
  sjoeraa_nn_1_1_N = mkN "sjörå" "sjörået" "sjörår" "sjörårna" ;
  sjoeofficer_nn_1_1_N = mkN "sjöofficer" "sjöofficern" "sjöofficerare" "sjöofficerarna" ;
  sjoemil_nn_1_1_N = mkN "sjömil" "sjömilen" "sjömil" "sjömilen" ;
  sjoeman_nn_1_1_N = mkN "sjöman" "sjömannen" "sjömän" "sjömännen" ;
  sjukskoeterskeexamen_nn_1_1_N = mkN "sjuksköterskeexamen" "sjuksköterskeexamen" "sjuksköterskeexamina" "sjuksköterskeexamina" ;
  sitkom_nn_1_N = mkN "sitkom" "sitkomen" "sitkoms" "sitkomsen" ;
  sitcom_nn_1_N = mkN "sitcom" "sitcomen" "sitcoms" "sitcomsen" ;
  silo_nn_1_N = mkN "silo" "silon" "silos" "silosen" ;
  sigma_nn_1_N = mkN "sigma" "sigmat" "sigma" "sigmana" ;
  sievert_nn_1_N = mkN "sievert" "sieverten" "sievert" "sieverten" ;
  sierraleonier_nn_1_N = mkN "sierraleonier" "sierraleoniern" "sierraleonier" "sierraleonierna" ;
  siemens_nn_1_N = mkN "siemens" "siemensen" "siemens" "siemensen" ;
  sidovapen_nn_1_N = mkN "sidovapen" "sidovapnet" "sidovapen" "sidovapnen" ;
  sidotema_nn_1_N = mkN "sidotema" "sidotemat" "sidoteman" "sidotemana" ;
  sibirier_nn_1_N = mkN "sibirier" "sibiriern" "sibirier" "sibirierna" ;
  shilling_nn_1_N = mkN "shilling" "shillingen" "shilling" "shillingen" ;
  shanty_nn_1_N = mkN "shanty" "shantyn" "shanties" "shanties" ;
  seychellier_nn_1_N = mkN "seychellier" "seychelliern" "seychellier" "seychellierna" ;
  sexualia_nn_1_N = mkN "sexualia" "sexualian" "sexualia" "sexualiana" ;
  sexpartner_nn_1_N = mkN "sexpartner" "sexpartnern" "sexpartner" "sexpartnerna" ;
  serviceman_nn_1_N = mkN "serviceman" "servicemannen" "servicemän" "servicemännen" ;
  serievaaldtaektsman_nn_1_1_N = mkN "serievåldtäktsman" "serievåldtäktsmannen" "serievåldtäktsmän" "serievåldtäktsmännen" ;
  sepoy_nn_1_N = mkN "sepoy" "sepoyen" "sepoys" "sepoysen" ;
  sekundmeter_nn_1_N = mkN "sekundmeter" "sekundmetern" "sekundmeter" "sekundmeterna" ;
  segertecken_nn_1_N = mkN "segertecken" "segertecknet" "segertecken" "segertecknen" ;
  script_girl_nn_1_N = mkN "script-girl" "script-girlen" "script-girls" "script-girlsen" ;
  scratchman_nn_1_N = mkN "scratchman" "scratchmannen" "scratchmän" "scratchmännen" ;
  scone_nn_1_N = mkN "scone" "sconen" "scones" "sconesen" ;
  scirocco_nn_1_N = mkN "scirocco" "sciroccon" "sciroccos" "sciroccosen" ;
  schweizerfranc_nn_1_N = mkN "schweizerfranc" "schweizerfrancen" "schweizerfranc" "schweizerfrancen" ;
  schismatiker_nn_1_N = mkN "schismatiker" "schismatikern" "schismatiker" "schismatikerna" ;
  scenario_nn_1_N = mkN "scenario" "scenariot" "scenarion" "scenariona" ;
  saudier_nn_1_N = mkN "saudier" "saudiern" "saudier" "saudierna" ;
  satyrdrama_nn_1_N = mkN "satyrdrama" "satyrdramat" "satyrdraman" "satyrdramana" ;
  satsuma_nn_1_N = mkN "satsuma" "satsuman" "satsumas" "satsumasen" ;
  satiriker_nn_1_N = mkN "satiriker" "satirikern" "satiriker" "satirikerna" ;
  sari_nn_1_N = mkN "sari" "sarin" "sarier" "sarierna" ;
  sanmarinier_nn_1_N = mkN "sanmarinier" "sanmariniern" "sanmarinier" "sanmarinierna" ;
  sanitetstekniker_nn_1_N = mkN "sanitetstekniker" "sanitetsteknikern" "sanitetstekniker" "sanitetsteknikerna" ;
  sangviniker_nn_1_N = mkN "sangviniker" "sangvinikern" "sangviniker" "sangvinikerna" ;
  sang_nn_1_N = mkN "sang" "sangen" "sang" "sangen" ;
  sandwichman_nn_1_N = mkN "sandwichman" "sandwichmannen" "sandwichmän" "sandwichmännen" ;
  samlagspartner_nn_1_N = mkN "samlagspartner" "samlagspartnern" "samlagspartner" "samlagspartnerna" ;
  samhaellskritiker_nn_1_1_N = mkN "samhällskritiker" "samhällskritikern" "samhällskritiker" "samhällskritikerna" ;
  sambo_nn_2_N = mkN "sambo" "sambon" "sambos" "sambosen" ;
  sambandsofficer_nn_1_N = mkN "sambandsofficer" "sambandsofficern" "sambandsofficerare" "sambandsofficerarna" ;
  samarbetspartner_nn_1_N = mkN "samarbetspartner" "samarbetspartnern" "samarbetspartner" "samarbetspartnerna" ;
  samarbetsman_nn_1_N = mkN "samarbetsman" "samarbetsmannen" "samarbetsmän" "samarbetsmännen" ;
  saltvatten_nn_1_N = mkN "saltvatten" "saltvattnet" "saltvatten" "saltvattnen" ;
  salomonier_nn_1_N = mkN "salomonier" "salomoniern" "salomonier" "salomonierna" ;
  salladshuvud_nn_1_N = mkN "salladshuvud" "salladshuvudet" "salladshuvuden" "salladshuvudena" ;
  sakaegande_nn_1_1_N = mkN "sakägande" "sakäganden" "sakägande" "sakägandena" ;
  sagesman_nn_1_N = mkN "sagesman" "sagesmannen" "sagesmän" "sagesmännen" ;
  safari_nn_1_N = mkN "safari" "safarin" "safarier" "safarierna" ;
  roetkammare_nn_1_1_N = mkN "rötkammare" "rötkammaren" "rötkamrar" "rötkamrarna" ;
  roe_nn_1_1_N = mkN "rö" "röt" "rö" "röna" ;
  raadman_nn_1_1_N = mkN "rådman" "rådmannen" "rådmän" "rådmännen" ;
  raadkammare_nn_1_1_N = mkN "rådkammare" "rådkammaren" "rådkamrar" "rådkamrarna" ;
  raa_nn_3_13_N = mkN "rå" "rån" "rår" "rårna" ;
  raa_nn_2_1_N = mkN "rå" "rået" "rår" "rårna" ;
  raettspsykiatriker_nn_1_1_N = mkN "rättspsykiatriker" "rättspsykiatrikern" "rättspsykiatriker" "rättspsykiatrikerna" ;
  rymdvapen_nn_1_N = mkN "rymdvapen" "rymdvapnet" "rymdvapen" "rymdvapnen" ;
  rwandier_nn_1_N = mkN "rwandier" "rwandiern" "rwandier" "rwandierna" ;
  ruter_nn_1_N = mkN "ruter" "rutern" "ruter" "ruterna" ;
  rustkammare_nn_1_N = mkN "rustkammare" "rustkammaren" "rustkamrar" "rustkamrarna" ;
  rubel_nn_1_N = mkN "rubel" "rubeln" "rubel" "rublerna" ;
  royalty_nn_1_N = mkN "royalty" "royaltyn" "royalties" "royalties" ;
  rottweiler_nn_1_N = mkN "rottweiler" "rottweilern" "rottweiler" "rottweilerna" ;
  rottecken_nn_1_N = mkN "rottecken" "rottecknet" "rottecken" "rottecknen" ;
  rorsman_nn_1_N = mkN "rorsman" "rorsmannen" "rorsmän" "rorsmännen" ;
  rookie_nn_1_N = mkN "rookie" "rookien" "rookies" "rookiesen" ;
  romkom_nn_1_N = mkN "romkom" "romkomen" "romkoms" "romkomsen" ;
  romcom_nn_1_N = mkN "romcom" "romcomen" "romcoms" "romcomsen" ;
  romantiker_nn_1_N = mkN "romantiker" "romantikern" "romantiker" "romantikerna" ;
  rododendron_nn_1_N = mkN "rododendron" "rododendronen" "rododendron" "rododendrerna" ;
  robotvapen_nn_1_N = mkN "robotvapen" "robotvapnet" "robotvapen" "robotvapnen" ;
  roadie_nn_1_N = mkN "roadie" "roadien" "roadies" "roadiesen" ;
  ro_nn_2_N = mkN "ro" "ron" "ron" "rona" ;
  riksvapen_nn_1_N = mkN "riksvapen" "riksvapnet" "riksvapen" "riksvapnen" ;
  riksdaler_nn_1_N = mkN "riksdaler" "riksdalern" "riksdaler" "riksdalerna" ;
  riksdagsman_nn_1_N = mkN "riksdagsman" "riksdagsmannen" "riksdagsmän" "riksdagsmännen" ;
  rikeman_nn_1_N = mkN "rikeman" "rikemannen" "rikemän" "rikemännen" ;
  riddersman_nn_1_N = mkN "riddersman" "riddersmannen" "riddersmän" "riddersmännen" ;
  rhododendron_nn_1_N = mkN "rhododendron" "rhododendronen" "rhododendron" "rhododendrerna" ;
  rhodesier_nn_1_N = mkN "rhodesier" "rhodesiern" "rhodesier" "rhodesierna" ;
  reumatiker_nn_1_N = mkN "reumatiker" "reumatikern" "reumatiker" "reumatikerna" ;
  retoriker_nn_1_N = mkN "retoriker" "retorikern" "retoriker" "retorikerna" ;
  residuum_nn_1_N = mkN "residuum" "residuet" "residuer" "residuerna" ;
  reservofficer_nn_1_N = mkN "reservofficer" "reservofficern" "reservofficerare" "reservofficerarna" ;
  researcher_nn_1_N = mkN "researcher" "researchern" "researcher" "researcherna" ;
  resande_nn_1_N = mkN "resande" "resanden" "resande" "resandena" ;
  repristecken_nn_1_N = mkN "repristecken" "repristecknet" "repristecken" "repristecknen" ;
  renlevnadsman_nn_1_N = mkN "renlevnadsman" "renlevnadsmannen" "renlevnadsmän" "renlevnadsmännen" ;
  remedium_nn_1_N = mkN "remedium" "remediumet" "remedium" "remedierna" ;
  rem_nn_2_N = mkN "rem" "remen" "rem" "remen" ;
  religionskritiker_nn_1_N = mkN "religionskritiker" "religionskritikern" "religionskritiker" "religionskritikerna" ;
  regnvatten_nn_1_N = mkN "regnvatten" "regnvattnet" "regnvatten" "regnvattnen" ;
  regimkritiker_nn_1_N = mkN "regimkritiker" "regimkritikern" "regimkritiker" "regimkritikerna" ;
  regeringstalesman_nn_1_N = mkN "regeringstalesman" "regeringstalesmannen" "regeringstalesmän" "regeringstalesmännen" ;
  regementsofficer_nn_1_N = mkN "regementsofficer" "regementsofficern" "regementsofficerare" "regementsofficerarna" ;
  realia_nn_1_N = mkN "realia" "realian" "realia" "realiana" ;
  realexamen_nn_1_N = mkN "realexamen" "realexamen" "realexamina" "realexamina" ;
  rastafari_nn_1_N = mkN "rastafari" "rastafarin" "rastafaris" "rastafarisen" ;
  rapsfroe_nn_1_1_N = mkN "rapsfrö" "rapsfröet" "rapsfröer" "rapsfröerna" ;
  ranger_nn_1_N = mkN "ranger" "rangern" "rangers" "rangersen" ;
  rand_nn_2_N = mkN "rand" "randen" "rand" "randen" ;
  rakvatten_nn_1_N = mkN "rakvatten" "rakvattnet" "rakvatten" "rakvattnen" ;
  raketvapen_nn_1_N = mkN "raketvapen" "raketvapnet" "raketvapen" "raketvapnen" ;
  radioman_nn_1_N = mkN "radioman" "radiomannen" "radiomän" "radiomännen" ;
  rad_nn_2_N = mkN "rad" "raden" "rad" "raden" ;
  qatarier_nn_1_N = mkN "qatarier" "qatariern" "qatarier" "qatarierna" ;
  paafaageloega_nn_1_1_N = mkN "påfågelöga" "påfågelögat" "påfågelögon" "påfågelögonen" ;
  paafaagelsoega_nn_1_1_N = mkN "påfågelsöga" "påfågelsögat" "påfågelsögon" "påfågelsögonen" ;
  pykniker_nn_1_N = mkN "pykniker" "pyknikern" "pykniker" "pyknikerna" ;
  putto_nn_1_N = mkN "putto" "putton" "putti" "puttina" ;
  pundhuvud_nn_1_N = mkN "pundhuvud" "pundhuvudet" "pundhuvuden" "pundhuvudena" ;
  psykofarmaka_nn_1_N = mkN "psykofarmaka" "psykofarmakan" "psykofarmaka" "psykofarmakana" ;
  psykoanalytiker_nn_1_N = mkN "psykoanalytiker" "psykoanalytikern" "psykoanalytiker" "psykoanalytikerna" ;
  psykiatriker_nn_1_N = mkN "psykiatriker" "psykiatrikern" "psykiatriker" "psykiatrikerna" ;
  psoriatiker_nn_1_N = mkN "psoriatiker" "psoriatikern" "psoriatiker" "psoriatikerna" ;
  praestman_nn_1_1_N = mkN "prästman" "prästmannen" "prästmän" "prästmännen" ;
  prydnadsvapen_nn_1_N = mkN "prydnadsvapen" "prydnadsvapnet" "prydnadsvapen" "prydnadsvapnen" ;
  prutgaas_nn_1_1_N = mkN "prutgås" "prutgåsen" "prutgäss" "prutgässen" ;
  provie_nn_1_N = mkN "provie" "provien" "provies" "proviesen" ;
  promille_nn_1_N = mkN "promille" "promillen" "promille" "promillena" ;
  procent_nn_1_N = mkN "procent" "procenten" "procent" "procenten" ;
  privatpraktiker_nn_1_N = mkN "privatpraktiker" "privatpraktikern" "privatpraktiker" "privatpraktikerna" ;
  privatman_nn_1_N = mkN "privatman" "privatmannen" "privatmän" "privatmännen" ;
  pretiosa_nn_1_N = mkN "pretiosa" "pretiosan" "pretiosa" "pretiosana" ;
  prestanda_nn_1_N = mkN "prestanda" "prestandan" "prestanda" "prestandana" ;
  presstalesman_nn_1_N = mkN "presstalesman" "presstalesmannen" "presstalesmän" "presstalesmännen" ;
  preses_nn_1_N = mkN "preses" "preses" "presides" "presesarna" ;
  preciosa_nn_1_N = mkN "preciosa" "preciosan" "preciosa" "preciosana" ;
  praktiker_nn_1_N = mkN "praktiker" "praktikern" "praktiker" "praktikerna" ;
  pragmatiker_nn_1_N = mkN "pragmatiker" "pragmatikern" "pragmatiker" "pragmatikerna" ;
  posttjaensteman_nn_1_1_N = mkN "posttjänsteman" "posttjänstemannen" "posttjänstemän" "posttjänstemännen" ;
  porter_nn_1_N = mkN "porter" "portern" "porter" "porterna" ;
  poncho_nn_1_N = mkN "poncho" "ponchon" "ponchos" "ponchosen" ;
  polynesier_nn_1_N = mkN "polynesier" "polynesiern" "polynesier" "polynesierna" ;
  politiker_nn_1_N = mkN "politiker" "politikern" "politiker" "politikerna" ;
  polistjaensteman_nn_1_1_N = mkN "polistjänsteman" "polistjänstemannen" "polistjänstemän" "polistjänstemännen" ;
  polisman_nn_1_N = mkN "polisman" "polismannen" "polismän" "polismännen" ;
  polemiker_nn_1_N = mkN "polemiker" "polemikern" "polemiker" "polemikerna" ;
  plustecken_nn_1_N = mkN "plustecken" "plustecknet" "plustecken" "plustecknen" ;
  platt_teve_nn_1_N = mkN "platt-teve" "platt-teven" "platt-teve" "platt-tevena" ;
  platoniker_nn_1_N = mkN "platoniker" "platonikern" "platoniker" "platonikerna" ;
  plasmateve_nn_1_N = mkN "plasmateve" "plasmateven" "plasmateve" "plasmatevena" ;
  plasma_teve_nn_1_N = mkN "plasma-teve" "plasma-teven" "plasma-teve" "plasma-tevena" ;
  plankter_nn_1_N = mkN "plankter" "planktern" "plankter" "plankterna" ;
  pirhuvud_nn_1_N = mkN "pirhuvud" "pirhuvudet" "pirhuvuden" "pirhuvudena" ;
  piphuvud_nn_1_N = mkN "piphuvud" "piphuvudet" "piphuvuden" "piphuvudena" ;
  pipeline_nn_1_N = mkN "pipeline" "pipelinen" "pipelines" "pipelinesen" ;
  pilsner_nn_1_N = mkN "pilsner" "pilsnern" "pilsner" "pilsnerna" ;
  pfennig_nn_1_N = mkN "pfennig" "pfennigen" "pfennig" "pfennigen" ;
  petabyte_nn_1_N = mkN "petabyte" "petabyten" "petabyte" "petabytena" ;
  peso_nn_1_N = mkN "peso" "peson" "pesos" "pesosen" ;
  peseta_nn_1_N = mkN "peseta" "pesetan" "pesetas" "pesetasen" ;
  personkilometer_nn_1_N = mkN "personkilometer" "personkilometern" "personkilometer" "personkilometerna" ;
  personalia_nn_1_N = mkN "personalia" "personalian" "personalia" "personaliana" ;
  perser_nn_1_N = mkN "perser" "persern" "perser" "perserna" ;
  pensionspoaeng_nn_1_1_N = mkN "pensionspoäng" "pensionspoängen" "pensionspoäng" "pensionspoängen" ;
  penny_nn_1_N = mkN "penny" "pennyn" "pence" "pencen" ;
  penni_nn_1_N = mkN "penni" "pennin" "penni" "pennina" ;
  pediatriker_nn_1_N = mkN "pediatriker" "pediatrikern" "pediatriker" "pediatrikerna" ;
  paustecken_nn_1_N = mkN "paustecken" "paustecknet" "paustecken" "paustecknen" ;
  patricier_nn_1_N = mkN "patricier" "patriciern" "patricier" "patricierna" ;
  passiva_nn_1_N = mkN "passiva" "passivan" "passiva" "passivana" ;
  pascal_nn_1_N = mkN "pascal" "pascalen" "pascal" "pascalen" ;
  partner_nn_1_N = mkN "partner" "partnern" "partner" "partnerna" ;
  partiordfoerande_nn_1_1_N = mkN "partiordförande" "partiordföranden" "partiordförande" "partiordförandena" ;
  partiman_nn_1_N = mkN "partiman" "partimannen" "partimän" "partimännen" ;
  partikelfysiker_nn_1_N = mkN "partikelfysiker" "partikelfysikern" "partikelfysiker" "partikelfysikerna" ;
  parodiker_nn_1_N = mkN "parodiker" "parodikern" "parodiker" "parodikerna" ;
  parlamentariker_nn_1_N = mkN "parlamentariker" "parlamentarikern" "parlamentariker" "parlamentarikerna" ;
  parentestecken_nn_1_N = mkN "parentestecken" "parentestecknet" "parentestecken" "parentestecknen" ;
  paranoiker_nn_1_N = mkN "paranoiker" "paranoikern" "paranoiker" "paranoikerna" ;
  paralytiker_nn_1_N = mkN "paralytiker" "paralytikern" "paralytiker" "paralytikerna" ;
  paragraftecken_nn_1_N = mkN "paragraftecken" "paragraftecknet" "paragraftecken" "paragraftecknen" ;
  papua_nn_1_N = mkN "papua" "papuan" "papuas" "papuasen" ;
  paper_nn_1_N = mkN "paper" "paperet" "papers" "paperen" ;
  pansarvaernsvapen_nn_1_1_N = mkN "pansarvärnsvapen" "pansarvärnsvapnet" "pansarvärnsvapen" "pansarvärnsvapnen" ;
  panorama_nn_1_N = mkN "panorama" "panoramat" "panoraman" "panoramana" ;
  pannkaksteoretiker_nn_1_N = mkN "pannkaksteoretiker" "pannkaksteoretikern" "pannkaksteoretiker" "pannkaksteoretikerna" ;
  palestinier_nn_1_N = mkN "palestinier" "palestiniern" "palestinier" "palestinierna" ;
  palauer_nn_1_N = mkN "palauer" "palauern" "palauer" "palauerna" ;
  oxoega_nn_1_1_N = mkN "oxöga" "oxögat" "oxögon" "oxögonen" ;
  oxhuvud_nn_1_N = mkN "oxhuvud" "oxhuvudet" "oxhuvuden" "oxhuvudena" ;
  outsider_nn_1_N = mkN "outsider" "outsidern" "outsider" "outsiderna" ;
  otrohetsdrama_nn_1_N = mkN "otrohetsdrama" "otrohetsdramat" "otrohetsdraman" "otrohetsdramana" ;
  ordningsman_nn_1_N = mkN "ordningsman" "ordningsmannen" "ordningsmän" "ordningsmännen" ;
  ordfoerande_nn_1_1_N = mkN "ordförande" "ordföranden" "ordförande" "ordförandena" ;
  ordal_nn_1_N = mkN "ordal" "ordalet" "ordal" "ordalierna" ;
  optiker_nn_1_N = mkN "optiker" "optikern" "optiker" "optikerna" ;
  opinionsanalytiker_nn_1_N = mkN "opinionsanalytiker" "opinionsanalytikern" "opinionsanalytiker" "opinionsanalytikerna" ;
  omvaendningstecken_nn_1_1_N = mkN "omvändningstecken" "omvändningstecknet" "omvändningstecken" "omvändningstecknen" ;
  omega_nn_1_N = mkN "omega" "omegat" "omega" "omegana" ;
  ombudsman_nn_1_N = mkN "ombudsman" "ombudsmannen" "ombudsmän" "ombudsmännen" ;
  omanier_nn_1_N = mkN "omanier" "omaniern" "omanier" "omanierna" ;
  olympier_nn_1_N = mkN "olympier" "olympiern" "olympier" "olympierna" ;
  olycksbroder_nn_1_N = mkN "olycksbroder" "olycksbrodern" "olycksbröder" "olycksbröderna" ;
  oldtimer_nn_1_N = mkN "oldtimer" "oldtimern" "oldtimers" "oldtimersen" ;
  ohm_nn_1_N = mkN "ohm" "ohmen" "ohm" "ohmen" ;
  ogaerningsman_nn_1_1_N = mkN "ogärningsman" "ogärningsmannen" "ogärningsmän" "ogärningsmännen" ;
  officer_nn_1_N = mkN "officer" "officern" "officerare" "officerarna" ;
  odalman_nn_1_N = mkN "odalman" "odalmannen" "odalmän" "odalmännen" ;
  naalsoega_nn_1_1_N = mkN "nålsöga" "nålsögat" "nålsögon" "nålsögonen" ;
  naalshuvud_nn_1_1_N = mkN "nålshuvud" "nålshuvudet" "nålshuvuden" "nålshuvudena" ;
  naetguru_nn_1_1_N = mkN "nätguru" "nätgurun" "nätguruer" "nätguruerna" ;
  naeringsfrihetsombudsman_nn_1_1_N = mkN "näringsfrihetsombudsman" "näringsfrihetsombudsmannen" "näringsfrihetsombudsmän" "näringsfrihetsombudsmännen" ;
  naemndeman_nn_1_1_N = mkN "nämndeman" "nämndemannen" "nämndemän" "nämndemännen" ;
  naebbmus_nn_1_1_N = mkN "näbbmus" "näbbmusen" "näbbmöss" "näbbmössen" ;
  nyklassiker_nn_1_N = mkN "nyklassiker" "nyklassikern" "nyklassiker" "nyklassikerna" ;
  nyckelman_nn_1_N = mkN "nyckelman" "nyckelmannen" "nyckelmän" "nyckelmännen" ;
  nyanseringstecken_nn_1_N = mkN "nyanseringstecken" "nyanseringstecknet" "nyanseringstecken" "nyanseringstecknen" ;
  numismatiker_nn_1_N = mkN "numismatiker" "numismatikern" "numismatiker" "numismatikerna" ;
  nubier_nn_1_N = mkN "nubier" "nubiern" "nubier" "nubierna" ;
  nottecken_nn_1_N = mkN "nottecken" "nottecknet" "nottecken" "nottecknen" ;
  notskriftstecken_nn_1_N = mkN "notskriftstecken" "notskriftstecknet" "notskriftstecken" "notskriftstecknen" ;
  nostalgiker_nn_1_N = mkN "nostalgiker" "nostalgikern" "nostalgiker" "nostalgikerna" ;
  norrman_nn_1_N = mkN "norrman" "norrmannen" "norrmän" "norrmännen" ;
  nordman_nn_1_N = mkN "nordman" "nordmannen" "nordmän" "nordmännen" ;
  niuer_nn_1_N = mkN "niuer" "niuern" "niuer" "niuerna" ;
  nithuvud_nn_1_N = mkN "nithuvud" "nithuvudet" "nithuvuden" "nithuvudena" ;
  nissoega_nn_1_1_N = mkN "nissöga" "nissögat" "nissögon" "nissögonen" ;
  nigerer_nn_1_N = mkN "nigerer" "nigerern" "nigerer" "nigererna" ;
  newton_nn_1_N = mkN "newton" "newtonen" "newton" "newtonen" ;
  neutrino_nn_1_N = mkN "neutrino" "neutrinon" "neutriner" "neutrinerna" ;
  neurotiker_nn_1_N = mkN "neurotiker" "neurotikern" "neurotiker" "neurotikerna" ;
  neuroleptika_nn_1_N = mkN "neuroleptika" "neuroleptikan" "neuroleptika" "neuroleptikana" ;
  nejonoega_nn_1_1_N = mkN "nejonöga" "nejonögat" "nejonögon" "nejonögonen" ;
  nazistofficer_nn_1_N = mkN "nazistofficer" "nazistofficern" "nazistofficerare" "nazistofficerarna" ;
  nautiker_nn_1_N = mkN "nautiker" "nautikern" "nautiker" "nautikerna" ;
  nauruer_nn_1_N = mkN "nauruer" "nauruern" "nauruer" "nauruerna" ;
  naturvetenskapsman_nn_1_N = mkN "naturvetenskapsman" "naturvetenskapsmannen" "naturvetenskapsmän" "naturvetenskapsmännen" ;
  nattglim_nn_1_N = mkN "nattglim" "nattglimmen" "nattglim" "nattglimmen" ;
  narkotikum_nn_1_N = mkN "narkotikum" "narkotikum" "narkotika" "narkotikana" ;
  namibier_nn_1_N = mkN "namibier" "namibiern" "namibier" "namibierna" ;
  moetesordfoerande_nn_1_1_N = mkN "mötesordförande" "mötesordföranden" "mötesordförande" "mötesordförandena" ;
  moessoera_nn_1_1_N = mkN "mössöra" "mössörat" "mössöron" "mössöronen" ;
  moerkman_nn_1_1_N = mkN "mörkman" "mörkmannen" "mörkmän" "mörkmännen" ;
  moerkerman_nn_1_1_N = mkN "mörkerman" "mörkermannen" "mörkermän" "mörkermännen" ;
  maalsaegande_nn_1_1_N = mkN "målsägande" "målsäganden" "målsägande" "målsägandena" ;
  maalsman_nn_1_1_N = mkN "målsman" "målsmannen" "målsmän" "målsmännen" ;
  maetdata_nn_1_1_N = mkN "mätdata" "mätdatan" "mätdata" "mätdatana" ;
  maesterman_nn_1_1_N = mkN "mästerman" "mästermannen" "mästermän" "mästermännen" ;
  maerkhammare_nn_1_1_N = mkN "märkhammare" "märkhammaren" "märkhamrar" "märkhamrarna" ;
  maerkesman_nn_1_1_N = mkN "märkesman" "märkesmannen" "märkesmän" "märkesmännen" ;
  mystiker_nn_1_N = mkN "mystiker" "mystikern" "mystiker" "mystikerna" ;
  mynttecken_nn_1_N = mkN "mynttecken" "mynttecknet" "mynttecken" "mynttecknen" ;
  musoera_nn_1_1_N = mkN "musöra" "musörat" "musöron" "musöronen" ;
  musiktecken_nn_1_N = mkN "musiktecken" "musiktecknet" "musiktecken" "musiktecknen" ;
  musiker_nn_1_N = mkN "musiker" "musikern" "musiker" "musikerna" ;
  musikdrama_nn_1_N = mkN "musikdrama" "musikdramat" "musikdraman" "musikdramana" ;
  mus_nn_1_N = mkN "mus" "musen" "möss" "mössen" ;
  munvatten_nn_1_N = mkN "munvatten" "munvattnet" "munvatten" "munvattnen" ;
  multiplikationstecken_nn_1_N = mkN "multiplikationstecken" "multiplikationstecknet" "multiplikationstecken" "multiplikationstecknen" ;
  multimedium_nn_1_N = mkN "multimedium" "multimediet" "multimedier" "multimedierna" ;
  muffins_nn_1_N = mkN "muffins" "muffinsen" "muffins" "muffinsen" ;
  mocambikier_nn_1_1_N = mkN "moçambikier" "moçambikiern" "moçambikier" "moçambikierna" ;
  motti_nn_1_N = mkN "motti" "mottin" "motti" "mottina" ;
  motstaandsman_nn_1_1_N = mkN "motståndsman" "motståndsmannen" "motståndsmän" "motståndsmännen" ;
  motorman_nn_1_N = mkN "motorman" "motormannen" "motormän" "motormännen" ;
  morfar_nn_1_N = mkN "morfar" "morfadern" "morfäder" "morfäderna" ;
  mordvapen_nn_1_N = mkN "mordvapen" "mordvapnet" "mordvapen" "mordvapnen" ;
  moldavier_nn_1_N = mkN "moldavier" "moldaviern" "moldavier" "moldavierna" ;
  mogenhetsexamen_nn_1_N = mkN "mogenhetsexamen" "mogenhetsexamen" "mogenhetsexamina" "mogenhetsexamina" ;
  moderatpolitiker_nn_1_N = mkN "moderatpolitiker" "moderatpolitikern" "moderatpolitiker" "moderatpolitikerna" ;
  mocambikier_nn_1_N = mkN "mocambikier" "mocambikiern" "mocambikier" "mocambikierna" ;
  mjukdata_nn_1_N = mkN "mjukdata" "mjukdatan" "mjukdata" "mjukdatana" ;
  missgaerningsman_nn_1_1_N = mkN "missgärningsman" "missgärningsmannen" "missgärningsmän" "missgärningsmännen" ;
  minustecken_nn_1_N = mkN "minustecken" "minustecknet" "minustecken" "minustecknen" ;
  mineralvatten_nn_1_N = mkN "mineralvatten" "mineralvattnet" "mineralvatten" "mineralvattnen" ;
  mineral_nn_1_N = mkN "mineral" "mineralet" "mineraler" "mineralerna" ;
  mimiker_nn_1_N = mkN "mimiker" "mimikern" "mimiker" "mimikerna" ;
  milliwatt_nn_1_N = mkN "milliwatt" "milliwatten" "milliwatt" "milliwatten" ;
  millisievert_nn_1_N = mkN "millisievert" "millisieverten" "millisievert" "millisieverten" ;
  milliliter_nn_1_N = mkN "milliliter" "millilitern" "milliliter" "milliliterna" ;
  millibar_nn_1_N = mkN "millibar" "millibaren" "millibar" "millibaren" ;
  militaerhistoriker_nn_1_1_N = mkN "militärhistoriker" "militärhistorikern" "militärhistoriker" "militärhistorikerna" ;
  militieombudsman_nn_1_N = mkN "militieombudsman" "militieombudsmannen" "militieombudsmän" "militieombudsmännen" ;
  mil_nn_1_N = mkN "mil" "milen" "mil" "milen" ;
  mikrosievert_nn_1_N = mkN "mikrosievert" "mikrosieverten" "mikrosievert" "mikrosieverten" ;
  mikronesier_nn_1_N = mkN "mikronesier" "mikronesiern" "mikronesier" "mikronesierna" ;
  metodiker_nn_1_N = mkN "metodiker" "metodikern" "metodiker" "metodikerna" ;
  metafysiker_nn_1_N = mkN "metafysiker" "metafysikern" "metafysiker" "metafysikerna" ;
  metadata_nn_1_N = mkN "metadata" "metadatan" "metadata" "metadatana" ;
  memorandum_nn_1_N = mkN "memorandum" "memorandum" "memoranda" "memorandana" ;
  mellanoera_nn_1_1_N = mkN "mellanöra" "mellanörat" "mellanöron" "mellanöronen" ;
  melankoliker_nn_1_N = mkN "melankoliker" "melankolikern" "melankoliker" "melankolikerna" ;
  melanesier_nn_1_N = mkN "melanesier" "melanesiern" "melanesier" "melanesierna" ;
  mekanikus_nn_1_N = mkN "mekanikus" "mekanikusen" "mekanici" "mekanicina" ;
  mekaniker_nn_1_N = mkN "mekaniker" "mekanikern" "mekaniker" "mekanikerna" ;
  megawatt_nn_1_N = mkN "megawatt" "megawatten" "megawatt" "megawatten" ;
  meganewton_nn_1_N = mkN "meganewton" "meganewtonen" "meganewton" "meganewtonen" ;
  megajoule_nn_1_N = mkN "megajoule" "megajoulen" "megajoule" "megajoulena" ;
  megabyte_nn_1_N = mkN "megabyte" "megabyten" "megabyte" "megabytena" ;
  medsoekande_nn_1_1_N = mkN "medsökande" "medsökanden" "medsökande" "medsökandena" ;
  medloeftesman_nn_1_1_N = mkN "medlöftesman" "medlöftesmannen" "medlöftesmän" "medlöftesmännen" ;
  medium_nn_1_N = mkN "medium" "mediet" "medier" "medierna" ;
  medikus_nn_1_N = mkN "medikus" "medikus" "medici" "medicina" ;
  medicinman_nn_1_N = mkN "medicinman" "medicinmannen" "medicinmän" "medicinmännen" ;
  medbroder_nn_1_N = mkN "medbroder" "medbrodern" "medbröder" "medbröderna" ;
  mauser_nn_1_N = mkN "mauser" "mausern" "mauser" "mauserna" ;
  mauritier_nn_1_N = mkN "mauritier" "mauritiern" "mauritier" "mauritierna" ;
  mauretanier_nn_1_N = mkN "mauretanier" "mauretaniern" "mauretanier" "mauretanierna" ;
  matematiker_nn_1_N = mkN "matematiker" "matematikern" "matematiker" "matematikerna" ;
  massmedium_nn_1_N = mkN "massmedium" "massmediet" "massmedier" "massmedierna" ;
  martini_nn_1_N = mkN "martini" "martinin" "martini" "martinina" ;
  markomanner_nn_1_N = mkN "markomanner" "markomannern" "markomanner" "markomannerna" ;
  mark_nn_2_N = mkN "mark" "marken" "mark" "marken" ;
  mardroemscenario_nn_1_1_N = mkN "mardrömscenario" "mardrömscenariot" "mardrömscenarion" "mardrömscenariona" ;
  maorier_nn_1_N = mkN "maorier" "maoriern" "maorier" "maorierna" ;
  maniker_nn_1_N = mkN "maniker" "manikern" "maniker" "manikerna" ;
  manager_nn_1_N = mkN "manager" "managern" "manager" "managerna" ;
  man_nn_1_N = mkN "man" "mannen" "män" "männen" ;
  malier_nn_1_N = mkN "malier" "maliern" "malier" "malierna" ;
  maldivier_nn_1_N = mkN "maldivier" "maldiviern" "maldivier" "maldivierna" ;
  maldiver_nn_1_N = mkN "maldiver" "maldivern" "maldiver" "maldiverna" ;
  malaysier_nn_1_N = mkN "malaysier" "malaysiern" "malaysier" "malaysierna" ;
  malawier_nn_1_N = mkN "malawier" "malawiern" "malawier" "malawierna" ;
  makedonier_nn_1_N = mkN "makedonier" "makedoniern" "makedonier" "makedonierna" ;
  mahognyfaner_nn_1_N = mkN "mahognyfaner" "mahognyfaneret" "mahognyfaner" "mahognyfaneren" ;
  magnecyl_nn_1_N = mkN "magnecyl" "magnecylen" "magnecyl" "magnecylen" ;
  magmakammare_nn_1_N = mkN "magmakammare" "magmakammaren" "magmakamrar" "magmakamrarna" ;
  magiker_nn_1_N = mkN "magiker" "magikern" "magiker" "magikerna" ;
  magier_nn_1_N = mkN "magier" "magiern" "magier" "magierna" ;
  mager_nn_1_N = mkN "mager" "magern" "mager" "magerna" ;
  mach_nn_1_N = mkN "mach" "machen" "mach" "machen" ;
  loepmeter_nn_1_1_N = mkN "löpmeter" "löpmetern" "löpmeter" "löpmeterna" ;
  loeftesman_nn_1_1_N = mkN "löftesman" "löftesmannen" "löftesmän" "löftesmännen" ;
  laangeman_nn_1_1_N = mkN "långeman" "långemannen" "långemän" "långemännen" ;
  laagvatten_nn_1_1_N = mkN "lågvatten" "lågvattnet" "lågvatten" "lågvattnen" ;
  laeskeblask_nn_2_1_N = mkN "läskeblask" "läskeblasken" "läskeblask" "läskeblasken" ;
  laesk_nn_1_1_N = mkN "läsk" "läsken" "läsk" "läsken" ;
  laeshuvud_nn_1_1_N = mkN "läshuvud" "läshuvudet" "läshuvuden" "läshuvudena" ;
  laesdrama_nn_1_1_N = mkN "läsdrama" "läsdramat" "läsdraman" "läsdramana" ;
  laerofader_nn_1_1_N = mkN "lärofader" "lärofadern" "lärofäder" "lärofäderna" ;
  laensvakthavande_nn_1_1_N = mkN "länsvakthavande" "länsvakthavanden" "länsvakthavande" "länsvakthavandena" ;
  laensman_nn_1_1_N = mkN "länsman" "länsmannen" "länsmän" "länsmännen" ;
  laengdtecken_nn_1_1_N = mkN "längdtecken" "längdtecknet" "längdtecken" "längdtecknen" ;
  laengdmeter_nn_1_1_N = mkN "längdmeter" "längdmetern" "längdmeter" "längdmeterna" ;
  lyriker_nn_1_N = mkN "lyriker" "lyrikern" "lyriker" "lyrikerna" ;
  lyckokloever_nn_1_1_N = mkN "lyckoklöver" "lyckoklövern" "lyckoklöver" "lyckoklöverna" ;
  lux_nn_1_N = mkN "lux" "luxen" "lux" "luxen" ;
  lus_nn_1_N = mkN "lus" "lusen" "löss" "lössen" ;
  lumen_nn_1_N = mkN "lumen" "lumenen" "lumen" "lumenen" ;
  luktvatten_nn_1_N = mkN "luktvatten" "luktvattnet" "luktvatten" "luktvattnen" ;
  lugnvatten_nn_1_N = mkN "lugnvatten" "lugnvattnet" "lugnvatten" "lugnvattnen" ;
  luftvapen_nn_1_N = mkN "luftvapen" "luftvapnet" "luftvapen" "luftvapnen" ;
  loser_nn_1_N = mkN "loser" "losern" "losers" "losersen" ;
  lokalpolitiker_nn_1_N = mkN "lokalpolitiker" "lokalpolitikern" "lokalpolitiker" "lokalpolitikerna" ;
  logiker_nn_1_N = mkN "logiker" "logikern" "logiker" "logikerna" ;
  logi_nn_1_N = mkN "logi" "logiet" "logier" "logierna" ;
  ljushuvud_nn_1_N = mkN "ljushuvud" "ljushuvudet" "ljushuvuden" "ljushuvudena" ;
  ljudtekniker_nn_1_N = mkN "ljudtekniker" "ljudteknikern" "ljudtekniker" "ljudteknikerna" ;
  livstecken_nn_1_N = mkN "livstecken" "livstecknet" "livstecken" "livstecknen" ;
  livrustkammare_nn_1_N = mkN "livrustkammare" "livrustkammaren" "livrustkamrar" "livrustkamrarna" ;
  livmedikus_nn_1_N = mkN "livmedikus" "livmedikus" "livmedici" "livmedicina" ;
  litteraturkritiker_nn_1_N = mkN "litteraturkritiker" "litteraturkritikern" "litteraturkritiker" "litteraturkritikerna" ;
  litauer_nn_1_N = mkN "litauer" "litauern" "litauer" "litauerna" ;
  lire_nn_1_N = mkN "lire" "liren" "lire" "lirena" ;
  linslus_nn_1_N = mkN "linslus" "linslusen" "linslöss" "linslössen" ;
  linjeman_nn_1_N = mkN "linjeman" "linjemannen" "linjemän" "linjemännen" ;
  lim_nn_1_N = mkN "lim" "limmet" "lim" "limmen" ;
  likhetstecken_nn_1_N = mkN "likhetstecken" "likhetstecknet" "likhetstecken" "likhetstecknen" ;
  licentiatexamen_nn_1_N = mkN "licentiatexamen" "licentiatexamen" "licentiatexamina" "licentiatexamina" ;
  libyer_nn_1_N = mkN "libyer" "libyern" "libyer" "libyerna" ;
  liberier_nn_1_N = mkN "liberier" "liberiern" "liberier" "liberierna" ;
  leva_nn_1_N = mkN "leva" "levan" "leva" "levana" ;
  lesothier_nn_1_N = mkN "lesothier" "lesothiern" "lesothier" "lesothierna" ;
  lekmannabroder_nn_1_N = mkN "lekmannabroder" "lekmannabrodern" "lekmannabröder" "lekmannabröderna" ;
  lekman_nn_1_N = mkN "lekman" "lekmannen" "lekmän" "lekmännen" ;
  ledhuvud_nn_1_N = mkN "ledhuvud" "ledhuvudet" "ledhuvuden" "ledhuvudena" ;
  lebeman_nn_1_N = mkN "lebeman" "lebemannen" "lebemän" "lebemännen" ;
  lcd_teve_nn_2_N = mkN "lcd-teve" "lcd-teven" "lcd-teve" "lcd-tevena" ;
  laotier_nn_1_N = mkN "laotier" "laotiern" "laotier" "laotierna" ;
  lantman_nn_1_N = mkN "lantman" "lantmannen" "lantmän" "lantmännen" ;
  landstingsman_nn_1_N = mkN "landstingsman" "landstingsmannen" "landstingsmän" "landstingsmännen" ;
  landsman_nn_1_N = mkN "landsman" "landsmannen" "landsmän" "landsmännen" ;
  landskapsvapen_nn_1_N = mkN "landskapsvapen" "landskapsvapnet" "landskapsvapen" "landskapsvapnen" ;
  landsfader_nn_1_N = mkN "landsfader" "landsfadern" "landsfäder" "landsfäderna" ;
  landmil_nn_1_N = mkN "landmil" "landmilen" "landmil" "landmilen" ;
  lambda_nn_1_N = mkN "lambda" "lambdat" "lambda" "lambdana" ;
  lagman_nn_1_N = mkN "lagman" "lagmannen" "lagmän" "lagmännen" ;
  lady_nn_1_N = mkN "lady" "ladyn" "ladies" "ladies" ;
  lackskoeldlus_nn_1_1_N = mkN "lacksköldlus" "lacksköldlusen" "lacksköldlöss" "lacksköldlössen" ;
  koersbaersfaner_nn_1_1_N = mkN "körsbärsfaner" "körsbärsfaneret" "körsbärsfaner" "körsbärsfaneren" ;
  koerkortssoekande_nn_1_1_N = mkN "körkortssökande" "körkortssökanden" "körkortssökande" "körkortssökandena" ;
  koepman_nn_1_1_N = mkN "köpman" "köpmannen" "köpmän" "köpmännen" ;
  kaarordfoerande_nn_1_1_N = mkN "kårordförande" "kårordföranden" "kårordförande" "kårordförandena" ;
  kaalhuvud_nn_1_1_N = mkN "kålhuvud" "kålhuvudet" "kålhuvuden" "kålhuvudena" ;
  kaernvapen_nn_1_1_N = mkN "kärnvapen" "kärnvapnet" "kärnvapen" "kärnvapnen" ;
  kaerande_nn_1_1_N = mkN "kärande" "käranden" "kärande" "kärandena" ;
  kaennetecken_nn_1_1_N = mkN "kännetecken" "kännetecknet" "kännetecken" "kännetecknen" ;
  kaenguru_nn_1_1_N = mkN "känguru" "kängurun" "kängurur" "kängururna" ;
  kaellvatten_nn_1_1_N = mkN "källvatten" "källvattnet" "källvatten" "källvattnen" ;
  kyrkomusiker_nn_1_N = mkN "kyrkomusiker" "kyrkomusikern" "kyrkomusiker" "kyrkomusikerna" ;
  kyrkoman_nn_1_N = mkN "kyrkoman" "kyrkomannen" "kyrkomän" "kyrkomännen" ;
  kyrkofullmaektig_nn_1_1_N = mkN "kyrkofullmäktig" "kyrkofullmäktigen" "kyrkofullmäktige" "kyrkofullmäktigena" ;
  kyrkofader_nn_1_N = mkN "kyrkofader" "kyrkofadern" "kyrkofäder" "kyrkofäderna" ;
  kyrkobroder_nn_1_N = mkN "kyrkobroder" "kyrkobrodern" "kyrkobröder" "kyrkobröderna" ;
  kyniker_nn_1_N = mkN "kyniker" "kynikern" "kyniker" "kynikerna" ;
  kymrer_nn_1_N = mkN "kymrer" "kymrern" "kymrer" "kymrerna" ;
  kvitten_nn_1_N = mkN "kvitten" "kvitten" "kvitten" "kvittena" ;
  kvickhuvud_nn_1_N = mkN "kvickhuvud" "kvickhuvudet" "kvickhuvuden" "kvickhuvudena" ;
  kuwaitier_nn_1_N = mkN "kuwaitier" "kuwaitiern" "kuwaitier" "kuwaitierna" ;
  kuriosum_nn_1_N = mkN "kuriosum" "kuriosum" "kuriosa" "kuriosana" ;
  kurder_nn_1_N = mkN "kurder" "kurdern" "kurder" "kurderna" ;
  kukhuvud_nn_1_N = mkN "kukhuvud" "kukhuvudet" "kukhuvuden" "kukhuvudena" ;
  kubik_nn_1_N = mkN "kubik" "kubiken" "kubik" "kubiken" ;
  kroniker_nn_1_N = mkN "kroniker" "kronikern" "kroniker" "kronikerna" ;
  kritiker_nn_1_N = mkN "kritiker" "kritikern" "kritiker" "kritikerna" ;
  krigsman_nn_1_N = mkN "krigsman" "krigsmannen" "krigsmän" "krigsmännen" ;
  kreter_nn_1_N = mkN "kreter" "kretern" "kreter" "kreterna" ;
  kranvatten_nn_1_N = mkN "kranvatten" "kranvattnet" "kranvatten" "kranvattnen" ;
  kooega_nn_1_1_N = mkN "koöga" "koögat" "koögon" "koögonen" ;
  korstecken_nn_1_N = mkN "korstecken" "korstecknet" "korstecken" "korstecknen" ;
  korrekturtecken_nn_1_N = mkN "korrekturtecken" "korrekturtecknet" "korrekturtecken" "korrekturtecknen" ;
  korinter_nn_1_N = mkN "korinter" "korintern" "korinter" "korinterna" ;
  kopter_nn_1_N = mkN "kopter" "koptern" "kopter" "kopterna" ;
  kopek_nn_1_N = mkN "kopek" "kopeken" "kopek" "kopeken" ;
  kontaktman_nn_1_N = mkN "kontaktman" "kontaktmannen" "kontaktmän" "kontaktmännen" ;
  konsumentombudsman_nn_1_N = mkN "konsumentombudsman" "konsumentombudsmannen" "konsumentombudsmän" "konsumentombudsmännen" ;
  konstruktionslim_nn_1_N = mkN "konstruktionslim" "konstruktionslimmet" "konstruktionslim" "konstruktionslimmen" ;
  konstkritiker_nn_1_N = mkN "konstkritiker" "konstkritikern" "konstkritiker" "konstkritikerna" ;
  konspirationsteoretiker_nn_1_N = mkN "konspirationsteoretiker" "konspirationsteoretikern" "konspirationsteoretiker" "konspirationsteoretikerna" ;
  kongressman_nn_1_N = mkN "kongressman" "kongressmannen" "kongressmän" "kongressmännen" ;
  konfliktmineral_nn_1_N = mkN "konfliktmineral" "konfliktmineralet" "konfliktmineraler" "konfliktmineralerna" ;
  kompositum_nn_1_N = mkN "kompositum" "kompositum" "komposita" "kompositerna" ;
  kompaniofficer_nn_1_N = mkN "kompaniofficer" "kompaniofficern" "kompaniofficerare" "kompaniofficerarna" ;
  komorier_nn_1_N = mkN "komorier" "komoriern" "komorier" "komorierna" ;
  kommunpolitiker_nn_1_N = mkN "kommunpolitiker" "kommunpolitikern" "kommunpolitiker" "kommunpolitikerna" ;
  kommunfullmaektig_nn_1_1_N = mkN "kommunfullmäktig" "kommunfullmäktigen" "kommunfullmäktige" "kommunfullmäktigena" ;
  kommunalpolitiker_nn_1_N = mkN "kommunalpolitiker" "kommunalpolitikern" "kommunalpolitiker" "kommunalpolitikerna" ;
  kommunalordfoerande_nn_1_1_N = mkN "kommunalordförande" "kommunalordföranden" "kommunalordförande" "kommunalordförandena" ;
  kommunalnaemndsordfoerande_nn_1_1_N = mkN "kommunalnämndsordförande" "kommunalnämndsordföranden" "kommunalnämndsordförande" "kommunalnämndsordförandena" ;
  kommunalman_nn_1_N = mkN "kommunalman" "kommunalmannen" "kommunalmän" "kommunalmännen" ;
  kommunalfullmaektig_nn_1_1_N = mkN "kommunalfullmäktig" "kommunalfullmäktigen" "kommunalfullmäktige" "kommunalfullmäktigena" ;
  kommatecken_nn_1_N = mkN "kommatecken" "kommatecknet" "kommatecken" "kommatecknen" ;
  komiker_nn_1_N = mkN "komiker" "komikern" "komiker" "komikerna" ;
  kolli_nn_1_N = mkN "kolli" "kollit" "kolli" "kollina" ;
  koleriker_nn_1_N = mkN "koleriker" "kolerikern" "koleriker" "kolerikerna" ;
  knop_nn_2_N = mkN "knop" "knopen" "knop" "knopen" ;
  knivman_nn_1_N = mkN "knivman" "knivmannen" "knivmän" "knivmännen" ;
  knappnaalshuvud_nn_1_1_N = mkN "knappnålshuvud" "knappnålshuvudet" "knappnålshuvuden" "knappnålshuvudena" ;
  kloever_nn_1_1_N = mkN "klöver" "klövern" "klöver" "klöverna" ;
  klaedlus_nn_1_1_N = mkN "klädlus" "klädlusen" "klädlöss" "klädlössen" ;
  klaedkammare_nn_1_1_N = mkN "klädkammare" "klädkammaren" "klädkamrar" "klädkamrarna" ;
  klustervapen_nn_1_N = mkN "klustervapen" "klustervapnet" "klustervapen" "klustervapnen" ;
  klosterbroder_nn_1_N = mkN "klosterbroder" "klosterbrodern" "klosterbröder" "klosterbröderna" ;
  klokhuvud_nn_1_N = mkN "klokhuvud" "klokhuvudet" "klokhuvuden" "klokhuvudena" ;
  klipphuvud_nn_1_N = mkN "klipphuvud" "klipphuvudet" "klipphuvuden" "klipphuvudena" ;
  klinker_nn_1_N = mkN "klinker" "klinkern" "klinker" "klinkerna" ;
  kliniker_nn_1_N = mkN "kliniker" "klinikern" "kliniker" "klinikerna" ;
  klimatskeptiker_nn_1_N = mkN "klimatskeptiker" "klimatskeptikern" "klimatskeptiker" "klimatskeptikerna" ;
  klimatkammare_nn_1_N = mkN "klimatkammare" "klimatkammaren" "klimatkamrar" "klimatkamrarna" ;
  klimatfoeraendringsskeptiker_nn_1_1_N = mkN "klimatförändringsskeptiker" "klimatförändringsskeptikern" "klimatförändringsskeptiker" "klimatförändringsskeptikerna" ;
  klassiker_nn_1_N = mkN "klassiker" "klassikern" "klassiker" "klassikerna" ;
  klartecken_nn_1_N = mkN "klartecken" "klartecknet" "klartecken" "klartecknen" ;
  klammer_nn_1_N = mkN "klammer" "klammern" "klammer" "klammerna" ;
  klagande_nn_1_N = mkN "klagande" "klaganden" "klagande" "klagandena" ;
  kiropraktiker_nn_1_N = mkN "kiropraktiker" "kiropraktikern" "kiropraktiker" "kiropraktikerna" ;
  kiribatier_nn_1_N = mkN "kiribatier" "kiribatiern" "kiribatier" "kiribatierna" ;
  kirgisier_nn_1_N = mkN "kirgisier" "kirgisiern" "kirgisier" "kirgisierna" ;
  kimono_nn_1_N = mkN "kimono" "kimonon" "kimonos" "kimonosen" ;
  kilowatt_nn_1_N = mkN "kilowatt" "kilowatten" "kilowatt" "kilowatten" ;
  kilopondmeter_nn_1_N = mkN "kilopondmeter" "kilopondmetern" "kilopondmeter" "kilopondmeterna" ;
  kilobyte_nn_1_N = mkN "kilobyte" "kilobyten" "kilobyte" "kilobytena" ;
  kilo_nn_1_N = mkN "kilo" "kilot" "kilo" "kilona" ;
  keramiker_nn_1_N = mkN "keramiker" "keramikern" "keramiker" "keramikerna" ;
  kelvin_nn_1_N = mkN "kelvin" "kelvinen" "kelvin" "kelvinen" ;
  kavalleriofficer_nn_1_N = mkN "kavalleriofficer" "kavalleriofficern" "kavalleriofficerare" "kavalleriofficerarna" ;
  kaukasier_nn_1_N = mkN "kaukasier" "kaukasiern" "kaukasier" "kaukasierna" ;
  kattoega_nn_1_1_N = mkN "kattöga" "kattögat" "kattögon" "kattögonen" ;
  kastvapen_nn_1_N = mkN "kastvapen" "kastvapnet" "kastvapen" "kastvapnen" ;
  karttecken_nn_1_N = mkN "karttecken" "karttecknet" "karttecken" "karttecknen" ;
  karaktaersdrama_nn_1_1_N = mkN "karaktärsdrama" "karaktärsdramat" "karaktärsdraman" "karaktärsdramana" ;
  karaktaeristika_nn_2_1_N = mkN "karaktäristika" "karaktäristikan" "karaktäristika" "karaktäristikana" ;
  karakteristika_nn_2_N = mkN "karakteristika" "karakteristikan" "karakteristika" "karakteristikana" ;
  kapverdier_nn_1_N = mkN "kapverdier" "kapverdiern" "kapverdier" "kapverdierna" ;
  kappa_nn_2_N = mkN "kappa" "kappat" "kappa" "kappana" ;
  kapardrama_nn_1_N = mkN "kapardrama" "kapardramat" "kapardraman" "kapardramana" ;
  kansliexamen_nn_1_N = mkN "kansliexamen" "kansliexamen" "kansliexamina" "kansliexamina" ;
  kandidatexamen_nn_1_N = mkN "kandidatexamen" "kandidatexamen" "kandidatexamina" "kandidatexamina" ;
  kanadagaas_nn_1_1_N = mkN "kanadagås" "kanadagåsen" "kanadagäss" "kanadagässen" ;
  kammarmusiker_nn_1_N = mkN "kammarmusiker" "kammarmusikern" "kammarmusiker" "kammarmusikerna" ;
  kammare_nn_1_N = mkN "kammare" "kammaren" "kamrar" "kamrarna" ;
  kameraman_nn_1_N = mkN "kameraman" "kameramannen" "kameramän" "kameramännen" ;
  kallvatten_nn_1_N = mkN "kallvatten" "kallvattnet" "kallvatten" "kallvattnen" ;
  jaertecken_nn_1_1_N = mkN "järtecken" "järtecknet" "järtecken" "järtecknen" ;
  jaernvaegstjaensteman_nn_1_1_N = mkN "järnvägstjänsteman" "järnvägstjänstemannen" "järnvägstjänstemän" "järnvägstjänstemännen" ;
  jaernvapen_nn_1_1_N = mkN "järnvapen" "järnvapnet" "järnvapen" "järnvapnen" ;
  justitieombudsman_nn_1_N = mkN "justitieombudsman" "justitieombudsmannen" "justitieombudsmän" "justitieombudsmännen" ;
  justeringsman_nn_1_N = mkN "justeringsman" "justeringsmannen" "justeringsmän" "justeringsmännen" ;
  jungman_nn_1_N = mkN "jungman" "jungmannen" "jungmän" "jungmännen" ;
  jungfrukammare_nn_1_N = mkN "jungfrukammare" "jungfrukammaren" "jungfrukamrar" "jungfrukamrarna" ;
  jourhavande_nn_1_N = mkN "jourhavande" "jourhavanden" "jourhavande" "jourhavandena" ;
  joule_nn_1_N = mkN "joule" "joulen" "joule" "joulena" ;
  jota_nn_1_N = mkN "jota" "jotat" "jota" "jotana" ;
  jordanier_nn_1_N = mkN "jordanier" "jordaniern" "jordanier" "jordanierna" ;
  jonier_nn_1_N = mkN "jonier" "joniern" "jonier" "jonierna" ;
  joner_nn_1_N = mkN "joner" "jonern" "joner" "jonerna" ;
  jobbsoekande_nn_1_1_N = mkN "jobbsökande" "jobbsökanden" "jobbsökande" "jobbsökandena" ;
  jazzmusiker_nn_1_N = mkN "jazzmusiker" "jazzmusikern" "jazzmusiker" "jazzmusikerna" ;
  jaktvapen_nn_1_N = mkN "jaktvapen" "jaktvapnet" "jaktvapen" "jaktvapnen" ;
  jacuzzi_nn_1_N = mkN "jacuzzi" "jacuzzin" "jacuzzis" "jacuzzisen" ;
  ja_nn_1_N = mkN "ja" "jaet" "jan" "jana" ;
  italiker_nn_1_N = mkN "italiker" "italikern" "italiker" "italikerna" ;
  italer_nn_1_N = mkN "italer" "italern" "italer" "italerna" ;
  ironiker_nn_1_N = mkN "ironiker" "ironikern" "ironiker" "ironikerna" ;
  irer_nn_1_N = mkN "irer" "irern" "irer" "irerna" ;
  iranier_nn_1_N = mkN "iranier" "iraniern" "iranier" "iranierna" ;
  irakier_nn_1_N = mkN "irakier" "irakiern" "irakier" "irakierna" ;
  iota_nn_1_N = mkN "iota" "iotat" "iota" "iotana" ;
  invandrarpolitiker_nn_1_N = mkN "invandrarpolitiker" "invandrarpolitikern" "invandrarpolitiker" "invandrarpolitikerna" ;
  inneroera_nn_1_1_N = mkN "inneröra" "innerörat" "inneröron" "inneröronen" ;
  indier_nn_1_N = mkN "indier" "indiern" "indier" "indierna" ;
  illgaerningsman_nn_1_1_N = mkN "illgärningsman" "illgärningsmannen" "illgärningsmän" "illgärningsmännen" ;
  iktus_nn_1_N = mkN "iktus" "iktusen" "iktus" "iktusen" ;
  igenkaenningstecken_nn_1_1_N = mkN "igenkänningstecken" "igenkänningstecknet" "igenkänningstecken" "igenkänningstecknen" ;
  id_edrama_nn_1_1_N = mkN "idédrama" "idédramat" "idédraman" "idédramana" ;
  idylliker_nn_1_N = mkN "idylliker" "idyllikern" "idylliker" "idyllikerna" ;
  idrottsman_nn_1_N = mkN "idrottsman" "idrottsmannen" "idrottsmän" "idrottsmännen" ;
  identitetssoekande_nn_1_1_N = mkN "identitetssökande" "identitetssökanden" "identitetssökande" "identitetssökandena" ;
  hoevitsman_nn_1_1_N = mkN "hövitsman" "hövitsmannen" "hövitsmän" "hövitsmännen" ;
  hoegvatten_nn_1_1_N = mkN "högvatten" "högvattnet" "högvatten" "högvattnen" ;
  hoegvallskloever_nn_1_1_N = mkN "högvallsklöver" "högvallsklövern" "högvallsklöver" "högvallsklöverna" ;
  hoegskoleexamen_nn_1_1_N = mkN "högskoleexamen" "högskoleexamen" "högskoleexamina" "högskoleexamina" ;
  hoegeroera_nn_1_1_N = mkN "högeröra" "högerörat" "högeröron" "högeröronen" ;
  hoegeroega_nn_1_1_N = mkN "högeröga" "högerögat" "högerögon" "högerögonen" ;
  hoegerpolitiker_nn_1_1_N = mkN "högerpolitiker" "högerpolitikern" "högerpolitiker" "högerpolitikerna" ;
  hoegerman_nn_1_1_N = mkN "högerman" "högermannen" "högermän" "högermännen" ;
  hoegbaatsman_nn_1_1_N = mkN "högbåtsman" "högbåtsmannen" "högbåtsmän" "högbåtsmännen" ;
  haarvatten_nn_1_1_N = mkN "hårvatten" "hårvattnet" "hårvatten" "hårvattnen" ;
  haarddata_nn_1_1_N = mkN "hårddata" "hårddatan" "hårddata" "hårddatana" ;
  haestskosoem_nn_1_1_N = mkN "hästskosöm" "hästskosömmet" "hästskosöm" "hästskosömmen" ;
  haesthuvud_nn_1_1_N = mkN "hästhuvud" "hästhuvudet" "hästhuvuden" "hästhuvudena" ;
  haerad_nn_1_1_N = mkN "härad" "häradet" "härad" "häradena" ;
  haensyn_nn_1_1_N = mkN "hänsyn" "hänsynen" "hänsyn" "hänsynen" ;
  haelsovatten_nn_1_1_N = mkN "hälsovatten" "hälsovattnet" "hälsovatten" "hälsovattnen" ;
  haelsotecken_nn_1_1_N = mkN "hälsotecken" "hälsotecknet" "hälsotecken" "hälsotecknen" ;
  haeftklammer_nn_1_1_N = mkN "häftklammer" "häftklammern" "häftklammer" "häftklammerna" ;
  hysteriker_nn_1_N = mkN "hysteriker" "hysterikern" "hysteriker" "hysterikerna" ;
  hypokondriker_nn_1_N = mkN "hypokondriker" "hypokondrikern" "hypokondriker" "hypokondrikerna" ;
  huvudtema_nn_1_N = mkN "huvudtema" "huvudtemat" "huvudteman" "huvudtemana" ;
  huvudman_nn_1_N = mkN "huvudman" "huvudmannen" "huvudmän" "huvudmännen" ;
  huvud_nn_1_N = mkN "huvud" "huvudet" "huvuden" "huvudena" ;
  husfar_nn_1_N = mkN "husfar" "husfadern" "husfäder" "husfäderna" ;
  hurra_nn_1_N = mkN "hurra" "hurrat" "hurra" "hurrana" ;
  hunner_nn_1_N = mkN "hunner" "hunnern" "hunner" "hunnerna" ;
  hundoera_nn_1_1_N = mkN "hundöra" "hundörat" "hundöron" "hundöronen" ;
  hundhuvud_nn_1_N = mkN "hundhuvud" "hundhuvudet" "hundhuvuden" "hundhuvudena" ;
  humusvatten_nn_1_N = mkN "humusvatten" "humusvattnet" "humusvatten" "humusvattnen" ;
  humorduo_nn_1_N = mkN "humorduo" "humorduon" "humorduos" "humorduosen" ;
  humaniora_nn_1_N = mkN "humaniora" "humanioran" "humaniora" "humaniorana" ;
  huggvapen_nn_1_N = mkN "huggvapen" "huggvapnet" "huggvapen" "huggvapnen" ;
  hryvnja_nn_1_N = mkN "hryvnja" "hryvnjan" "hryvnja" "hryvnjana" ;
  hovraettsexamen_nn_1_1_N = mkN "hovrättsexamen" "hovrättsexamen" "hovrättsexamina" "hovrättsexamina" ;
  hovman_nn_1_N = mkN "hovman" "hovmannen" "hovmän" "hovmännen" ;
  hjaertkammare_nn_1_1_N = mkN "hjärtkammare" "hjärtkammaren" "hjärtkamrar" "hjärtkamrarna" ;
  hjaerter_nn_1_1_N = mkN "hjärter" "hjärtern" "hjärter" "hjärterna" ;
  hjuldolly_nn_1_N = mkN "hjuldolly" "hjuldollyn" "hjuldollys" "hjuldollysen" ;
  hit_nn_1_N = mkN "hit" "hiten" "hits" "hitsen" ;
  historiker_nn_1_N = mkN "historiker" "historikern" "historiker" "historikerna" ;
  hirdman_nn_1_N = mkN "hirdman" "hirdmannen" "hirdmän" "hirdmännen" ;
  hippie_nn_1_N = mkN "hippie" "hippien" "hippies" "hippiesen" ;
  hetvatten_nn_1_N = mkN "hetvatten" "hetvattnet" "hetvatten" "hetvattnen" ;
  hertz_nn_1_N = mkN "hertz" "hertzen" "hertz" "hertzen" ;
  herreman_nn_1_N = mkN "herreman" "herremannen" "herremän" "herremännen" ;
  hermeneutiker_nn_1_N = mkN "hermeneutiker" "hermeneutikern" "hermeneutiker" "hermeneutikerna" ;
  heretiker_nn_1_N = mkN "heretiker" "heretikern" "heretiker" "heretikerna" ;
  heraldiker_nn_1_N = mkN "heraldiker" "heraldikern" "heraldiker" "heraldikerna" ;
  henry_nn_1_N = mkN "henry" "henryn" "henry" "henryna" ;
  hemulsman_nn_1_N = mkN "hemulsman" "hemulsmannen" "hemulsmän" "hemulsmännen" ;
  hemmaman_nn_1_N = mkN "hemmaman" "hemmamannen" "hemmamän" "hemmamännen" ;
  hektoliter_nn_1_N = mkN "hektoliter" "hektolitern" "hektoliter" "hektoliterna" ;
  hekto_nn_1_N = mkN "hekto" "hektot" "hekto" "hektona" ;
  hederstecken_nn_1_N = mkN "hederstecken" "hederstecknet" "hederstecken" "hederstecknen" ;
  hedersordfoerande_nn_1_1_N = mkN "hedersordförande" "hedersordföranden" "hedersordförande" "hedersordförandena" ;
  hedersman_nn_1_N = mkN "hedersman" "hedersmannen" "hedersmän" "hedersmännen" ;
  he_man_nn_1_N = mkN "he-man" "he-mannen" "he-män" "he-männen" ;
  havsvatten_nn_1_N = mkN "havsvatten" "havsvattnet" "havsvatten" "havsvattnen" ;
  hasselmus_nn_1_N = mkN "hasselmus" "hasselmusen" "hasselmöss" "hasselmössen" ;
  handvapen_nn_1_N = mkN "handvapen" "handvapnet" "handvapen" "handvapnen" ;
  handout_nn_1_N = mkN "handout" "handouten" "handouts" "handoutsen" ;
  handlande_nn_1_N = mkN "handlande" "handlanden" "handlande" "handlandena" ;
  handkammare_nn_1_N = mkN "handkammare" "handkammaren" "handkamrar" "handkamrarna" ;
  handelsresande_nn_1_N = mkN "handelsresande" "handelsresanden" "handelsresande" "handelsresandena" ;
  handelsman_nn_1_N = mkN "handelsman" "handelsmannen" "handelsmän" "handelsmännen" ;
  handelskammare_nn_1_N = mkN "handelskammare" "handelskammaren" "handelskamrar" "handelskamrarna" ;
  handeldvapen_nn_1_N = mkN "handeldvapen" "handeldvapnet" "handeldvapen" "handeldvapnen" ;
  hammerless_nn_1_N = mkN "hammerless" "hammerlessen" "hammerless" "hammerlessen" ;
  hammare_nn_1_N = mkN "hammare" "hammaren" "hamrar" "hamrarna" ;
  halvtum_nn_1_N = mkN "halvtum" "halvtummen" "halvtum" "halvtummen" ;
  halvmil_nn_1_N = mkN "halvmil" "halvmilen" "halvmil" "halvmilen" ;
  halvliter_nn_1_N = mkN "halvliter" "halvlitern" "halvliter" "halvliterna" ;
  hallaaman_nn_1_1_N = mkN "hallåman" "hallåmannen" "hallåmän" "hallåmännen" ;
  haitier_nn_1_N = mkN "haitier" "haitiern" "haitier" "haitierna" ;
  hacker_nn_1_N = mkN "hacker" "hackern" "hackers" "hackersen" ;
  gaas_nn_1_1_N = mkN "gås" "gåsen" "gäss" "gässen" ;
  gaardfarihandlande_nn_1_1_N = mkN "gårdfarihandlande" "gårdfarihandlanden" "gårdfarihandlande" "gårdfarihandlandena" ;
  gaerningsman_nn_1_1_N = mkN "gärningsman" "gärningsmannen" "gärningsmän" "gärningsmännen" ;
  gyllen_nn_3_N = mkN "gyllen" "gyllen" "gyllen" "gyllena" ;
  gyllen_nn_2_N = mkN "gyllen" "gyllenen" "gyllen" "gyllenen" ;
  guru_nn_1_N = mkN "guru" "gurun" "guruer" "guruerna" ;
  gulden_nn_1_N = mkN "gulden" "guldenen" "gulden" "guldenen" ;
  guinea_nn_1_N = mkN "guinea" "guinean" "guineas" "guineasen" ;
  gudsman_nn_1_N = mkN "gudsman" "gudsmannen" "gudsmän" "gudsmännen" ;
  gudfar_nn_1_N = mkN "gudfar" "gudfadern" "gudfäder" "gudfäderna" ;
  groensaksfroe_nn_1_1_N = mkN "grönsaksfrö" "grönsaksfröet" "grönsaksfröer" "grönsaksfröerna" ;
  graahaarsman_nn_1_1_N = mkN "gråhårsman" "gråhårsmannen" "gråhårsmän" "gråhårsmännen" ;
  graagaas_nn_1_1_N = mkN "grågås" "grågåsen" "grågäss" "grågässen" ;
  graagyllen_nn_1_1_N = mkN "grågyllen" "grågyllen" "grågyllen" "grågyllena" ;
  graabroder_nn_1_1_N = mkN "gråbroder" "gråbrodern" "gråbröder" "gråbröderna" ;
  graestrimmer_nn_1_1_N = mkN "grästrimmer" "grästrimmern" "grästrimmers" "grästrimmersen" ;
  gruvraa_nn_1_1_N = mkN "gruvrå" "gruvrået" "gruvrår" "gruvrårna" ;
  gruvdrama_nn_1_N = mkN "gruvdrama" "gruvdramat" "gruvdraman" "gruvdramana" ;
  grundvatten_nn_1_N = mkN "grundvatten" "grundvattnet" "grundvatten" "grundvattnen" ;
  grundarduo_nn_1_N = mkN "grundarduo" "grundarduon" "grundarduos" "grundarduosen" ;
  groupie_nn_1_N = mkN "groupie" "groupien" "groupies" "groupiesen" ;
  groschen_nn_1_N = mkN "groschen" "groschenen" "groschen" "groschenen" ;
  grodman_nn_1_N = mkN "grodman" "grodmannen" "grodmän" "grodmännen" ;
  grisoega_nn_1_1_N = mkN "grisöga" "grisögat" "grisögon" "grisögonen" ;
  gringo_nn_1_N = mkN "gringo" "gringon" "gringos" "gringosen" ;
  greyhound_nn_1_N = mkN "greyhound" "greyhounden" "greyhounds" "greyhoundsen" ;
  grenadier_nn_1_N = mkN "grenadier" "grenadiern" "grenadier" "grenadierna" ;
  gray_nn_1_N = mkN "gray" "grayen" "gray" "grayen" ;
  gravkammare_nn_1_N = mkN "gravkammare" "gravkammaren" "gravkamrar" "gravkamrarna" ;
  graviditetskilo_nn_1_N = mkN "graviditetskilo" "graviditetskilot" "graviditetskilo" "graviditetskilona" ;
  gravgaas_nn_1_1_N = mkN "gravgås" "gravgåsen" "gravgäss" "gravgässen" ;
  gravensteiner_nn_1_N = mkN "gravensteiner" "gravensteinern" "gravensteiner" "gravensteinerna" ;
  granulum_nn_1_N = mkN "granulum" "granulum" "granula" "granulana" ;
  granskningsman_nn_1_N = mkN "granskningsman" "granskningsmannen" "granskningsmän" "granskningsmännen" ;
  granbarrlus_nn_1_N = mkN "granbarrlus" "granbarrlusen" "granbarrlöss" "granbarrlössen" ;
  grammatiker_nn_1_N = mkN "grammatiker" "grammatikern" "grammatiker" "grammatikerna" ;
  grafiker_nn_1_N = mkN "grafiker" "grafikern" "grafiker" "grafikerna" ;
  gradtecken_nn_1_N = mkN "gradtecken" "gradtecknet" "gradtecken" "gradtecknen" ;
  gospel_nn_1_N = mkN "gospel" "gospeln" "gospel" "gospelna" ;
  gold_digger_nn_1_N = mkN "gold-digger" "gold-diggern" "gold-diggers" "gold-diggersen" ;
  go_cart_nn_1_N = mkN "go-cart" "go-carten" "go-carts" "go-cartsen" ;
  gnostiker_nn_1_N = mkN "gnostiker" "gnostikern" "gnostiker" "gnostikerna" ;
  gnomiker_nn_1_N = mkN "gnomiker" "gnomikern" "gnomiker" "gnomikerna" ;
  gnistkammare_nn_1_N = mkN "gnistkammare" "gnistkammaren" "gnistkamrar" "gnistkamrarna" ;
  glim_nn_1_N = mkN "glim" "glimmen" "glim" "glimmen" ;
  glasoega_nn_1_1_N = mkN "glasöga" "glasögat" "glasögon" "glasögonen" ;
  gisslandrama_nn_1_N = mkN "gisslandrama" "gisslandramat" "gisslandraman" "gisslandramana" ;
  gillesbroder_nn_1_N = mkN "gillesbroder" "gillesbrodern" "gillesbröder" "gillesbröderna" ;
  gigolo_nn_1_N = mkN "gigolo" "gigolon" "gigolos" "gigolosen" ;
  gigawatt_nn_1_N = mkN "gigawatt" "gigawatten" "gigawatt" "gigawatten" ;
  gigabyte_nn_1_N = mkN "gigabyte" "gigabyten" "gigabyte" "gigabytena" ;
  giftoman_nn_1_N = mkN "giftoman" "giftomannen" "giftomän" "giftomännen" ;
  ghost_writer_nn_1_N = mkN "ghost-writer" "ghost-writern" "ghost-writers" "ghost-writersen" ;
  gevaldiger_nn_1_N = mkN "gevaldiger" "gevaldigern" "gevaldiger" "gevaldigerna" ;
  georgier_nn_1_N = mkN "georgier" "georgiern" "georgier" "georgierna" ;
  geometriker_nn_1_N = mkN "geometriker" "geometrikern" "geometriker" "geometrikerna" ;
  geodata_nn_1_N = mkN "geodata" "geodatan" "geodata" "geodatana" ;
  gentleman_nn_1_N = mkN "gentleman" "gentlemannen" "gentlemän" "gentlemännen" ;
  genkaerande_nn_1_1_N = mkN "genkärande" "genkäranden" "genkärande" "genkärandena" ;
  genetiker_nn_1_N = mkN "genetiker" "genetikern" "genetiker" "genetikerna" ;
  gauss_nn_1_N = mkN "gauss" "gaussen" "gauss" "gaussen" ;
  gauge_nn_1_N = mkN "gauge" "gaugen" "gauge" "gaugena" ;
  gaucho_nn_1_N = mkN "gaucho" "gauchon" "gauchos" "gauchosen" ;
  gaskammare_nn_1_N = mkN "gaskammare" "gaskammaren" "gaskamrar" "gaskamrarna" ;
  gartner_nn_1_N = mkN "gartner" "gartnern" "gartner" "gartnerna" ;
  gamma_nn_1_N = mkN "gamma" "gammat" "gamma" "gammana" ;
  gambier_nn_1_N = mkN "gambier" "gambiern" "gambier" "gambierna" ;
  gallon_nn_1_N = mkN "gallon" "gallonen" "gallon" "gallonen" ;
  gallier_nn_1_N = mkN "gallier" "galliern" "gallier" "gallierna" ;
  galler_nn_2_N = mkN "galler" "gallern" "galler" "gallerna" ;
  gage_nn_1_N = mkN "gage" "gaget" "gage" "gagen" ;
  foertroendeman_nn_1_1_N = mkN "förtroendeman" "förtroendemannen" "förtroendemän" "förtroendemännen" ;
  foertjaensttecken_nn_1_1_N = mkN "förtjänsttecken" "förtjänsttecknet" "förtjänsttecken" "förtjänsttecknen" ;
  foertecken_nn_1_1_N = mkN "förtecken" "förtecknet" "förtecken" "förtecknen" ;
  foersvarsvapen_nn_1_1_N = mkN "försvarsvapen" "försvarsvapnet" "försvarsvapen" "försvarsvapnen" ;
  foerstoerelsevapen_nn_1_1_N = mkN "förstörelsevapen" "förstörelsevapnet" "förstörelsevapen" "förstörelsevapnen" ;
  foerman_nn_1_1_N = mkN "förman" "förmannen" "förmän" "förmännen" ;
  foerlikningsman_nn_1_1_N = mkN "förlikningsman" "förlikningsmannen" "förlikningsmän" "förlikningsmännen" ;
  foerlagsman_nn_1_1_N = mkN "förlagsman" "förlagsmannen" "förlagsmän" "förlagsmännen" ;
  foerfader_nn_1_1_N = mkN "förfader" "förfadern" "förfäder" "förfäderna" ;
  foeregaangsman_nn_1_1_N = mkN "föregångsman" "föregångsmannen" "föregångsmän" "föregångsmännen" ;
  foeredragande_nn_1_1_N = mkN "föredragande" "föredraganden" "föredragande" "föredragandena" ;
  foerbindelseofficer_nn_1_1_N = mkN "förbindelseofficer" "förbindelseofficern" "förbindelseofficerare" "förbindelseofficerarna" ;
  faangesman_nn_1_1_N = mkN "fångesman" "fångesmannen" "fångesmän" "fångesmännen" ;
  faestman_nn_1_1_N = mkN "fästman" "fästmannen" "fästmän" "fästmännen" ;
  faerskvatten_nn_1_1_N = mkN "färskvatten" "färskvattnet" "färskvatten" "färskvattnen" ;
  faergteve_nn_1_1_N = mkN "färgteve" "färgteven" "färgteve" "färgtevena" ;
  faelttecken_nn_1_1_N = mkN "fälttecken" "fälttecknet" "fälttecken" "fälttecknen" ;
  fysiker_nn_1_N = mkN "fysiker" "fysikern" "fysiker" "fysikerna" ;
  fullmaektig_nn_1_1_N = mkN "fullmäktig" "fullmäktigen" "fullmäktige" "fullmäktigena" ;
  fukttekniker_nn_1_N = mkN "fukttekniker" "fuktteknikern" "fukttekniker" "fuktteknikerna" ;
  froe_nn_1_1_N = mkN "frö" "fröet" "fröer" "fröerna" ;
  fraagetecken_nn_1_1_N = mkN "frågetecken" "frågetecknet" "frågetecken" "frågetecknen" ;
  fraelseman_nn_1_1_N = mkN "frälseman" "frälsemannen" "frälsemän" "frälsemännen" ;
  fritidspolitiker_nn_1_N = mkN "fritidspolitiker" "fritidspolitikern" "fritidspolitiker" "fritidspolitikerna" ;
  frisbee_nn_1_N = mkN "frisbee" "frisbeen" "frisbeear" "frisbeearna" ;
  freestyle_nn_1_N = mkN "freestyle" "freestylen" "freestyles" "freestylesen" ;
  free_style_nn_1_N = mkN "free-style" "free-stylen" "free-styles" "free-stylesen" ;
  fransman_nn_1_N = mkN "fransman" "fransmannen" "fransmän" "fransmännen" ;
  frankotecken_nn_1_N = mkN "frankotecken" "frankotecknet" "frankotecken" "frankotecknen" ;
  franc_nn_1_N = mkN "franc" "francen" "franc" "francen" ;
  framtidsman_nn_1_N = mkN "framtidsman" "framtidsmannen" "framtidsmän" "framtidsmännen" ;
  foxterrier_nn_1_N = mkN "foxterrier" "foxterriern" "foxterrier" "foxterrierna" ;
  fotino_nn_1_N = mkN "fotino" "fotinon" "fotinos" "fotinosen" ;
  fot_nn_2_N = mkN "fot" "foten" "fot" "foten" ;
  fostervatten_nn_1_N = mkN "fostervatten" "fostervattnet" "fostervatten" "fostervattnen" ;
  fosterfar_nn_1_N = mkN "fosterfar" "fosterfadern" "fosterfäder" "fosterfäderna" ;
  forskningsresande_nn_1_N = mkN "forskningsresande" "forskningsresanden" "forskningsresande" "forskningsresandena" ;
  forshuvud_nn_1_N = mkN "forshuvud" "forshuvudet" "forshuvuden" "forshuvudena" ;
  fornegyptier_nn_1_N = mkN "fornegyptier" "fornegyptiern" "fornegyptier" "fornegyptierna" ;
  formalia_nn_1_N = mkN "formalia" "formalian" "formalia" "formaliana" ;
  foniatriker_nn_1_N = mkN "foniatriker" "foniatrikern" "foniatriker" "foniatrikerna" ;
  fonetiker_nn_1_N = mkN "fonetiker" "fonetikern" "fonetiker" "fonetikerna" ;
  folkmusiker_nn_1_N = mkN "folkmusiker" "folkmusikern" "folkmusiker" "folkmusikerna" ;
  flaedermus_nn_1_1_N = mkN "flädermus" "flädermusen" "flädermöss" "flädermössen" ;
  flygvapen_nn_1_N = mkN "flygvapen" "flygvapnet" "flygvapen" "flygvapnen" ;
  flygdrama_nn_1_N = mkN "flygdrama" "flygdramat" "flygdraman" "flygdramana" ;
  fluidum_nn_1_N = mkN "fluidum" "fluidet" "fluider" "fluiderna" ;
  flottstyrman_nn_1_N = mkN "flottstyrman" "flottstyrmannen" "flottstyrmän" "flottstyrmännen" ;
  flodvatten_nn_1_N = mkN "flodvatten" "flodvattnet" "flodvatten" "flodvattnen" ;
  flickboksklassiker_nn_1_N = mkN "flickboksklassiker" "flickboksklassikern" "flickboksklassiker" "flickboksklassikerna" ;
  flegmatiker_nn_1_N = mkN "flegmatiker" "flegmatikern" "flegmatiker" "flegmatikerna" ;
  flatlus_nn_1_N = mkN "flatlus" "flatlusen" "flatlöss" "flatlössen" ;
  flaggman_nn_1_N = mkN "flaggman" "flaggmannen" "flaggmän" "flaggmännen" ;
  fladdermus_nn_1_N = mkN "fladdermus" "fladdermusen" "fladdermöss" "fladdermössen" ;
  fjaerdingsvaeg_nn_1_1_N = mkN "fjärdingsväg" "fjärdingsvägen" "fjärdingsväg" "fjärdingsvägen" ;
  fjaerdingsman_nn_1_1_N = mkN "fjärdingsman" "fjärdingsmannen" "fjärdingsmän" "fjärdingsmännen" ;
  fittsafari_nn_1_N = mkN "fittsafari" "fittsafarin" "fittsafarier" "fittsafarierna" ;
  fiskoega_nn_1_1_N = mkN "fisköga" "fiskögat" "fiskögon" "fiskögonen" ;
  fiskevatten_nn_1_N = mkN "fiskevatten" "fiskevattnet" "fiskevatten" "fiskevattnen" ;
  finmekaniker_nn_1_N = mkN "finmekaniker" "finmekanikern" "finmekaniker" "finmekanikerna" ;
  finansman_nn_1_N = mkN "finansman" "finansmannen" "finansmän" "finansmännen" ;
  filharmoniker_nn_1_N = mkN "filharmoniker" "filharmonikern" "filharmoniker" "filharmonikerna" ;
  fighter_nn_1_N = mkN "fighter" "fightern" "fighter" "fighterna" ;
  fettprocent_nn_1_N = mkN "fettprocent" "fettprocenten" "fettprocent" "fettprocenten" ;
  fenicier_nn_1_N = mkN "fenicier" "feniciern" "fenicier" "fenicierna" ;
  felprocent_nn_1_N = mkN "felprocent" "felprocenten" "felprocent" "felprocenten" ;
  fasettoega_nn_1_1_N = mkN "fasettöga" "fasettögat" "fasettögon" "fasettögonen" ;
  farvatten_nn_1_N = mkN "farvatten" "farvattnet" "farvatten" "farvattnen" ;
  farmaka_nn_1_N = mkN "farmaka" "farmakan" "farmaka" "farmakana" ;
  farfarsfar_nn_1_N = mkN "farfarsfar" "farfarsfadern" "farfarsfäder" "farfarsfäderna" ;
  farfar_nn_1_N = mkN "farfar" "farfadern" "farfäder" "farfäderna" ;
  farad_nn_1_N = mkN "farad" "faraden" "farad" "faraden" ;
  far_nn_1_N = mkN "far" "fadern" "fäder" "fäderna" ;
  fanatiker_nn_1_N = mkN "fanatiker" "fanatikern" "fanatiker" "fanatikerna" ;
  fan_nn_2_N = mkN "fan" "fanen" "fans" "fansen" ;
  familjedrama_nn_1_N = mkN "familjedrama" "familjedramat" "familjedraman" "familjedramana" ;
  fallhammare_nn_1_N = mkN "fallhammare" "fallhammaren" "fallhamrar" "fallhamrarna" ;
  falkoega_nn_1_1_N = mkN "falköga" "falkögat" "falkögon" "falkögonen" ;
  fajter_nn_1_N = mkN "fajter" "fajtern" "fajter" "fajterna" ;
  fader_nn_1_N = mkN "fader" "fadern" "fäder" "fäderna" ;
  fackman_nn_1_N = mkN "fackman" "fackmannen" "fackmän" "fackmännen" ;
  facettoega_nn_1_1_N = mkN "facettöga" "facettögat" "facettögon" "facettögonen" ;
  eyeliner_nn_1_N = mkN "eyeliner" "eyelinern" "eyeliners" "eyelinersen" ;
  eye_liner_nn_1_N = mkN "eye-liner" "eye-linern" "eye-liners" "eye-linersen" ;
  experimentalfysiker_nn_1_N = mkN "experimentalfysiker" "experimentalfysikern" "experimentalfysiker" "experimentalfysikerna" ;
  excentriker_nn_1_N = mkN "excentriker" "excentrikern" "excentriker" "excentrikerna" ;
  examen_nn_1_N = mkN "examen" "examen" "examina" "examina" ;
  exabyte_nn_1_N = mkN "exabyte" "exabyten" "exabyte" "exabytena" ;
  evergreen_nn_1_N = mkN "evergreen" "evergreenen" "evergreens" "evergreensen" ;
  eurodollar_nn_1_N = mkN "eurodollar" "eurodollarn" "eurodollar" "eurodollarna" ;
  euro_nn_1_N = mkN "euro" "euron" "euro" "eurona" ;
  eurasier_nn_1_N = mkN "eurasier" "eurasiern" "eurasier" "eurasierna" ;
  etui_nn_1_N = mkN "etui" "etuiet" "etuier" "etuierna" ;
  etrusker_nn_1_N = mkN "etrusker" "etruskern" "etrusker" "etruskerna" ;
  etiopier_nn_1_N = mkN "etiopier" "etiopiern" "etiopier" "etiopierna" ;
  etiker_nn_1_N = mkN "etiker" "etikern" "etiker" "etikerna" ;
  etermedium_nn_1_N = mkN "etermedium" "etermediet" "etermedier" "etermedierna" ;
  eta_nn_1_N = mkN "eta" "etat" "eta" "etana" ;
  estetiker_nn_1_N = mkN "estetiker" "estetikern" "estetiker" "estetikerna" ;
  eselhuvud_nn_1_N = mkN "eselhuvud" "eselhuvudet" "eselhuvuden" "eselhuvudena" ;
  escudo_nn_1_N = mkN "escudo" "escudon" "escudos" "escudosen" ;
  errata_nn_1_N = mkN "errata" "erratan" "errata" "erratana" ;
  erotiker_nn_1_N = mkN "erotiker" "erotikern" "erotiker" "erotikerna" ;
  epoxylim_nn_1_N = mkN "epoxylim" "epoxylimmet" "epoxylim" "epoxylimmen" ;
  epileptiker_nn_1_N = mkN "epileptiker" "epileptikern" "epileptiker" "epileptikerna" ;
  epiker_nn_1_N = mkN "epiker" "epikern" "epiker" "epikerna" ;
  eolier_nn_1_N = mkN "eolier" "eoliern" "eolier" "eolierna" ;
  eoler_nn_1_N = mkN "eoler" "eolern" "eoler" "eolerna" ;
  entertainer_nn_1_N = mkN "entertainer" "entertainern" "entertainer" "entertainerna" ;
  engelsman_nn_1_N = mkN "engelsman" "engelsmannen" "engelsmän" "engelsmännen" ;
  empiriker_nn_1_N = mkN "empiriker" "empirikern" "empiriker" "empirikerna" ;
  emiratier_nn_1_N = mkN "emiratier" "emiratiern" "emiratier" "emiratierna" ;
  emeritus_nn_1_N = mkN "emeritus" "emeritus" "emeriti" "emeritina" ;
  emaljoega_nn_1_1_N = mkN "emaljöga" "emaljögat" "emaljögon" "emaljögonen" ;
  elitidrottsman_nn_1_N = mkN "elitidrottsman" "elitidrottsmannen" "elitidrottsmän" "elitidrottsmännen" ;
  elementa_nn_1_N = mkN "elementa" "elementan" "elementa" "elementana" ;
  elektrotekniker_nn_1_N = mkN "elektrotekniker" "elektroteknikern" "elektrotekniker" "elektroteknikerna" ;
  elektronvolt_nn_1_N = mkN "elektronvolt" "elektronvolten" "elektronvolt" "elektronvolten" ;
  elektriker_nn_1_N = mkN "elektriker" "elektrikern" "elektriker" "elektrikerna" ;
  elefantnaebbmus_nn_1_1_N = mkN "elefantnäbbmus" "elefantnäbbmusen" "elefantnäbbmöss" "elefantnäbbmössen" ;
  eldvapen_nn_1_N = mkN "eldvapen" "eldvapnet" "eldvapen" "eldvapnen" ;
  eldhandvapen_nn_1_N = mkN "eldhandvapen" "eldhandvapnet" "eldhandvapen" "eldhandvapnen" ;
  ekonomexamen_nn_1_N = mkN "ekonomexamen" "ekonomexamen" "ekonomexamina" "ekonomexamina" ;
  eklektiker_nn_1_N = mkN "eklektiker" "eklektikern" "eklektiker" "eklektikerna" ;
  egyptier_nn_1_N = mkN "egyptier" "egyptiern" "egyptier" "egyptierna" ;
  egypter_nn_1_N = mkN "egypter" "egyptern" "egypter" "egypterna" ;
  egocentriker_nn_1_N = mkN "egocentriker" "egocentrikern" "egocentriker" "egocentrikerna" ;
  efterkommande_nn_1_N = mkN "efterkommande" "efterkommanden" "efterkommande" "efterkommandena" ;
  efterbraennkammare_nn_1_1_N = mkN "efterbrännkammare" "efterbrännkammaren" "efterbrännkamrar" "efterbrännkamrarna" ;
  daadrafroe_nn_1_1_N = mkN "dådrafrö" "dådrafröet" "dådrafröer" "dådrafröerna" ;
  dyslektiker_nn_1_N = mkN "dyslektiker" "dyslektikern" "dyslektiker" "dyslektikerna" ;
  dvd_rom_nn_1_N = mkN "dvd-rom" "dvd-rommet" "dvd-rom" "dvd-rommen" ;
  duo_nn_1_N = mkN "duo" "duon" "duos" "duosen" ;
  dumhuvud_nn_1_N = mkN "dumhuvud" "dumhuvudet" "dumhuvuden" "dumhuvudena" ;
  draetselkammare_nn_1_1_N = mkN "drätselkammare" "drätselkammaren" "drätselkamrar" "drätselkamrarna" ;
  dryckesbroder_nn_1_N = mkN "dryckesbroder" "dryckesbrodern" "dryckesbröder" "dryckesbröderna" ;
  dricksvatten_nn_1_N = mkN "dricksvatten" "dricksvattnet" "dricksvatten" "dricksvattnen" ;
  dribbler_nn_1_N = mkN "dribbler" "dribblern" "dribbler" "dribblerna" ;
  dramatiker_nn_1_N = mkN "dramatiker" "dramatikern" "dramatiker" "dramatikerna" ;
  drama_nn_1_N = mkN "drama" "dramat" "draman" "dramana" ;
  dorer_nn_1_N = mkN "dorer" "dorern" "dorer" "dorerna" ;
  dominiker_nn_1_N = mkN "dominiker" "dominikern" "dominiker" "dominikerna" ;
  domedagsvapen_nn_1_N = mkN "domedagsvapen" "domedagsvapnet" "domedagsvapen" "domedagsvapnen" ;
  dollar_nn_1_N = mkN "dollar" "dollarn" "dollar" "dollarna" ;
  doktorsexamen_nn_1_N = mkN "doktorsexamen" "doktorsexamen" "doktorsexamina" "doktorsexamina" ;
  dogmatiker_nn_1_N = mkN "dogmatiker" "dogmatikern" "dogmatiker" "dogmatikerna" ;
  djurhuvud_nn_1_N = mkN "djurhuvud" "djurhuvudet" "djurhuvuden" "djurhuvudena" ;
  djupvatten_nn_1_N = mkN "djupvatten" "djupvattnet" "djupvatten" "djupvattnen" ;
  djuphavsvatten_nn_1_N = mkN "djuphavsvatten" "djuphavsvattnet" "djuphavsvatten" "djuphavsvattnen" ;
  djiboutier_nn_1_N = mkN "djiboutier" "djiboutiern" "djiboutier" "djiboutierna" ;
  distriktsordfoerande_nn_1_1_N = mkN "distriktsordförande" "distriktsordföranden" "distriktsordförande" "distriktsordförandena" ;
  dissenter_nn_1_N = mkN "dissenter" "dissentern" "dissenter" "dissenterna" ;
  diskvatten_nn_1_N = mkN "diskvatten" "diskvattnet" "diskvatten" "diskvattnen" ;
  diorama_nn_1_N = mkN "diorama" "dioramat" "dioraman" "dioramana" ;
  dimkammare_nn_1_N = mkN "dimkammare" "dimkammaren" "dimkamrar" "dimkamrarna" ;
  diktamen_nn_1_N = mkN "diktamen" "diktamen" "diktamina" "diktamina" ;
  digitalteve_nn_1_N = mkN "digitalteve" "digitalteven" "digitalteve" "digitaltevena" ;
  digital_teve_nn_1_N = mkN "digital-teve" "digital-teven" "digital-teve" "digital-tevena" ;
  didaktiker_nn_1_N = mkN "didaktiker" "didaktikern" "didaktiker" "didaktikerna" ;
  dialektiker_nn_1_N = mkN "dialektiker" "dialektikern" "dialektiker" "dialektikerna" ;
  diagnostiker_nn_1_N = mkN "diagnostiker" "diagnostikern" "diagnostiker" "diagnostikerna" ;
  diabetiker_nn_1_N = mkN "diabetiker" "diabetikern" "diabetiker" "diabetikerna" ;
  desperado_nn_1_N = mkN "desperado" "desperadon" "desperados" "desperadosen" ;
  designer_nn_1_N = mkN "designer" "designern" "designer" "designerna" ;
  deputerad_nn_1_N = mkN "deputerad" "deputeraden" "deputerade" "deputeradena" ;
  depositum_nn_1_N = mkN "depositum" "depositum" "deposita" "depositana" ;
  denier_nn_1_N = mkN "denier" "denieren" "denier" "denieren" ;
  demo_nn_1_N = mkN "demo" "demon" "demon" "demona" ;
  delta_nn_2_N = mkN "delta" "deltat" "delta" "deltana" ;
  delgivningsman_nn_1_N = mkN "delgivningsman" "delgivningsmannen" "delgivningsmän" "delgivningsmännen" ;
  dego_nn_1_N = mkN "dego" "degon" "degos" "degosen" ;
  decimaltecken_nn_1_N = mkN "decimaltecken" "decimaltecknet" "decimaltecken" "decimaltecknen" ;
  deciliter_nn_1_N = mkN "deciliter" "decilitern" "deciliter" "deciliterna" ;
  decibel_nn_1_N = mkN "decibel" "decibelen" "decibel" "decibelen" ;
  data_nn_1_N = mkN "data" "datan" "data" "datana" ;
  danneman_nn_1_N = mkN "danneman" "dannemannen" "dannemän" "dannemännen" ;
  dalmatiner_nn_1_N = mkN "dalmatiner" "dalmatinern" "dalmatiner" "dalmatinerna" ;
  daler_nn_1_N = mkN "daler" "dalern" "daler" "dalerna" ;
  dagvatten_nn_1_N = mkN "dagvatten" "dagvattnet" "dagvatten" "dagvattnen" ;
  dagofficer_nn_1_N = mkN "dagofficer" "dagofficern" "dagofficerare" "dagofficerarna" ;
  dago_nn_1_N = mkN "dago" "dagon" "dagos" "dagosen" ;
  daghavande_nn_1_N = mkN "daghavande" "daghavanden" "daghavande" "daghavandena" ;
  cyniker_nn_1_N = mkN "cyniker" "cynikern" "cyniker" "cynikerna" ;
  cyklopoega_nn_1_1_N = mkN "cyklopöga" "cyklopögat" "cyklopögon" "cyklopögonen" ;
  cyklamen_nn_1_N = mkN "cyklamen" "cyklamen" "cyklamen" "cyklamena" ;
  curie_nn_1_N = mkN "curie" "curien" "curie" "curiena" ;
  creepe_nn_1_1_N = mkN "crêpe" "crêpen" "crêpes" "crêpesen" ;
  cre_pe_nn_1_1_N = mkN "crèpe" "crèpen" "crèpes" "crèpesen" ;
  crepe_nn_1_N = mkN "crepe" "crepen" "crepes" "crepesen" ;
  cowboy_nn_1_N = mkN "cowboy" "cowboyen" "cowboyer" "cowboyerna" ;
  cover_nn_1_N = mkN "cover" "covern" "covers" "coversen" ;
  coulomb_nn_1_N = mkN "coulomb" "coulomben" "coulomb" "coulomben" ;
  copywriter_nn_1_N = mkN "copywriter" "copywritern" "copywriters" "copywritersen" ;
  copycat_nn_1_N = mkN "copycat" "copycaten" "copycats" "copycatsen" ;
  copy_cat_nn_1_N = mkN "copy-cat" "copy-caten" "copy-cats" "copy-catsen" ;
  comorier_nn_1_N = mkN "comorier" "comoriern" "comorier" "comorierna" ;
  commando_nn_1_N = mkN "commando" "commandon" "commandos" "commandosen" ;
  collie_nn_1_N = mkN "collie" "collien" "collies" "colliesen" ;
  cockerspaniel_nn_1_N = mkN "cockerspaniel" "cockerspanieln" "cockerspanielar" "cockerspanielarna" ;
  citronlaesk_nn_1_1_N = mkN "citronläsk" "citronläsken" "citronläsk" "citronläsken" ;
  citationstecken_nn_1_N = mkN "citationstecken" "citationstecknet" "citationstecken" "citationstecknen" ;
  cigarettetui_nn_1_N = mkN "cigarettetui" "cigarettetuiet" "cigarettetuier" "cigarettetuierna" ;
  chefstjaensteman_nn_1_1_N = mkN "chefstjänsteman" "chefstjänstemannen" "chefstjänstemän" "chefstjänstemännen" ;
  champion_nn_1_N = mkN "champion" "championen" "champions" "championsen" ;
  centralstimulantia_nn_1_N = mkN "centralstimulantia" "centralstimulantian" "centralstimulantia" "centralstimulantiana" ;
  centner_nn_1_N = mkN "centner" "centnern" "centner" "centnerna" ;
  centilong_nn_1_N = mkN "centilong" "centilongen" "centilong" "centilongen" ;
  centiliter_nn_1_N = mkN "centiliter" "centilitern" "centiliter" "centiliterna" ;
  cent_nn_1_N = mkN "cent" "centen" "cent" "centen" ;
  cd_rom_nn_1_N = mkN "cd-rom" "cd-rommet" "cd-rom" "cd-rommen" ;
  caterpillar_nn_1_N = mkN "caterpillar" "caterpillarn" "caterpillars" "caterpillarsen" ;
  cashew_nn_1_N = mkN "cashew" "cashewen" "cashews" "cashewsen" ;
  cardigan_nn_1_N = mkN "cardigan" "cardiganen" "cardigans" "cardigansen" ;
  cappuccino_nn_1_N = mkN "cappuccino" "cappuccinon" "cappuccino" "cappuccinona" ;
  candela_nn_1_N = mkN "candela" "candelan" "candela" "candelana" ;
  callgirl_nn_1_N = mkN "callgirl" "callgirlen" "callgirls" "callgirlsen" ;
  caddie_nn_1_N = mkN "caddie" "caddien" "caddies" "caddiesen" ;
  boersanalytiker_nn_1_1_N = mkN "börsanalytiker" "börsanalytikern" "börsanalytiker" "börsanalytikerna" ;
  boeneman_nn_1_1_N = mkN "böneman" "bönemannen" "bönemän" "bönemännen" ;
  baatsman_nn_1_1_N = mkN "båtsman" "båtsmannen" "båtsmän" "båtsmännen" ;
  baesteman_nn_1_1_N = mkN "bästeman" "bästemannen" "bästemän" "bästemännen" ;
  baeckvatten_nn_1_1_N = mkN "bäckvatten" "bäckvattnet" "bäckvatten" "bäckvattnen" ;
  byte_nn_2_N = mkN "byte" "byten" "byte" "bytena" ;
  butler_nn_1_N = mkN "butler" "butlern" "butlers" "butlersen" ;
  bushman_nn_1_N = mkN "bushman" "bushmannen" "bushmän" "bushmännen" ;
  burundier_nn_1_N = mkN "burundier" "burundiern" "burundier" "burundierna" ;
  burkinier_nn_1_N = mkN "burkinier" "burkiniern" "burkinier" "burkinierna" ;
  burgunder_nn_1_N = mkN "burgunder" "burgundern" "burgunder" "burgunderna" ;
  bulthuvud_nn_1_N = mkN "bulthuvud" "bulthuvudet" "bulthuvuden" "bulthuvudena" ;
  bubbelkammare_nn_1_N = mkN "bubbelkammare" "bubbelkammaren" "bubbelkamrar" "bubbelkamrarna" ;
  braeckvatten_nn_1_1_N = mkN "bräckvatten" "bräckvattnet" "bräckvatten" "bräckvattnen" ;
  braeckhammare_nn_1_1_N = mkN "bräckhammare" "bräckhammaren" "bräckhamrar" "bräckhamrarna" ;
  brytvapen_nn_1_N = mkN "brytvapen" "brytvapnet" "brytvapen" "brytvapnen" ;
  brushuvud_nn_1_N = mkN "brushuvud" "brushuvudet" "brushuvuden" "brushuvudena" ;
  brunnsvatten_nn_1_N = mkN "brunnsvatten" "brunnsvattnet" "brunnsvatten" "brunnsvattnen" ;
  bruneier_nn_1_N = mkN "bruneier" "bruneiern" "bruneier" "bruneierna" ;
  brottsplatstekniker_nn_1_N = mkN "brottsplatstekniker" "brottsplatsteknikern" "brottsplatstekniker" "brottsplatsteknikerna" ;
  brohuvud_nn_1_N = mkN "brohuvud" "brohuvudet" "brohuvuden" "brohuvudena" ;
  broder_nn_1_N = mkN "broder" "brodern" "bröder" "bröderna" ;
  brevhuvud_nn_1_N = mkN "brevhuvud" "brevhuvudet" "brevhuvuden" "brevhuvudena" ;
  brasilier_nn_1_N = mkN "brasilier" "brasiliern" "brasilier" "brasilierna" ;
  brandman_nn_1_N = mkN "brandman" "brandmannen" "brandmän" "brandmännen" ;
  bouzouki_nn_1_N = mkN "bouzouki" "bouzoukin" "bouzouki" "bouzoukina" ;
  boutredningsman_nn_1_N = mkN "boutredningsman" "boutredningsmannen" "boutredningsmän" "boutredningsmännen" ;
  bottenvatten_nn_1_N = mkN "bottenvatten" "bottenvattnet" "bottenvatten" "bottenvattnen" ;
  botswanier_nn_1_N = mkN "botswanier" "botswaniern" "botswanier" "botswanierna" ;
  botaniker_nn_1_N = mkN "botaniker" "botanikern" "botaniker" "botanikerna" ;
  bostadssoekande_nn_1_1_N = mkN "bostadssökande" "bostadssökanden" "bostadssökande" "bostadssökandena" ;
  bosnier_nn_1_N = mkN "bosnier" "bosniern" "bosnier" "bosnierna" ;
  borrhammare_nn_1_N = mkN "borrhammare" "borrhammaren" "borrhamrar" "borrhamrarna" ;
  borgensman_nn_1_N = mkN "borgensman" "borgensmannen" "borgensmän" "borgensmännen" ;
  bordsvatten_nn_1_N = mkN "bordsvatten" "bordsvattnet" "bordsvatten" "bordsvattnen" ;
  bookmaker_nn_1_N = mkN "bookmaker" "bookmakern" "bookmaker" "bookmakerna" ;
  bondkomiker_nn_1_N = mkN "bondkomiker" "bondkomikern" "bondkomiker" "bondkomikerna" ;
  bolagsman_nn_1_N = mkN "bolagsman" "bolagsmannen" "bolagsmän" "bolagsmännen" ;
  bokstavstecken_nn_1_N = mkN "bokstavstecken" "bokstavstecknet" "bokstavstecken" "bokstavstecknen" ;
  boer_nn_1_N = mkN "boer" "boern" "boer" "boerna" ;
  boende_nn_2_N = mkN "boende" "boenden" "boende" "boendena" ;
  blaesgaas_nn_1_1_N = mkN "bläsgås" "bläsgåsen" "bläsgäss" "bläsgässen" ;
  blomkaalsoera_nn_1_1_N = mkN "blomkålsöra" "blomkålsörat" "blomkålsöron" "blomkålsöronen" ;
  blomkaalshuvud_nn_1_1_N = mkN "blomkålshuvud" "blomkålshuvudet" "blomkålshuvuden" "blomkålshuvudena" ;
  blomhuvud_nn_1_N = mkN "blomhuvud" "blomhuvudet" "blomhuvuden" "blomhuvudena" ;
  blodsdrama_nn_1_N = mkN "blodsdrama" "blodsdramat" "blodsdraman" "blodsdramana" ;
  blankvatten_nn_1_N = mkN "blankvatten" "blankvattnet" "blankvatten" "blankvattnen" ;
  blandvatten_nn_1_N = mkN "blandvatten" "blandvattnet" "blandvatten" "blandvattnen" ;
  bladlus_nn_1_N = mkN "bladlus" "bladlusen" "bladlöss" "bladlössen" ;
  bjaelkhuvud_nn_1_1_N = mkN "bjälkhuvud" "bjälkhuvudet" "bjälkhuvuden" "bjälkhuvudena" ;
  bitecken_nn_1_N = mkN "bitecken" "bitecknet" "bitecken" "bitecknen" ;
  birdie_nn_1_N = mkN "birdie" "birdien" "birdies" "birdiesen" ;
  bilmekaniker_nn_1_N = mkN "bilmekaniker" "bilmekanikern" "bilmekaniker" "bilmekanikerna" ;
  bilhammare_nn_1_N = mkN "bilhammare" "bilhammaren" "bilhamrar" "bilhamrarna" ;
  biktfar_nn_1_N = mkN "biktfar" "biktfadern" "biktfäder" "biktfäderna" ;
  bikini_nn_1_N = mkN "bikini" "bikinin" "bikini" "bikinina" ;
  beta_nn_2_N = mkN "beta" "betat" "beta" "betana" ;
  besoekande_nn_1_1_N = mkN "besökande" "besökanden" "besökande" "besökandena" ;
  besaettningsman_nn_1_1_N = mkN "besättningsman" "besättningsmannen" "besättningsmän" "besättningsmännen" ;
  besiktningsman_nn_1_N = mkN "besiktningsman" "besiktningsmannen" "besiktningsmän" "besiktningsmännen" ;
  bergsman_nn_1_N = mkN "bergsman" "bergsmannen" "bergsmän" "bergsmännen" ;
  berber_nn_1_N = mkN "berber" "berbern" "berber" "berberna" ;
  beninier_nn_1_N = mkN "beninier" "beniniern" "beninier" "beninierna" ;
  belizier_nn_1_N = mkN "belizier" "beliziern" "belizier" "belizierna" ;
  belgier_nn_1_N = mkN "belgier" "belgiern" "belgier" "belgierna" ;
  befaelstecken_nn_1_1_N = mkN "befälstecken" "befälstecknet" "befälstecken" "befälstecknen" ;
  befallningsman_nn_1_N = mkN "befallningsman" "befallningsmannen" "befallningsmän" "befallningsmännen" ;
  befallningshavande_nn_1_N = mkN "befallningshavande" "befallningshavanden" "befallningshavande" "befallningshavandena" ;
  becquerel_nn_1_N = mkN "becquerel" "becquerelen" "becquerel" "becquerelen" ;
  baud_nn_1_N = mkN "baud" "bauden" "baud" "bauden" ;
  barnkammare_nn_1_N = mkN "barnkammare" "barnkammaren" "barnkamrar" "barnkamrarna" ;
  barnhuvud_nn_1_N = mkN "barnhuvud" "barnhuvudet" "barnhuvuden" "barnhuvudena" ;
  barnavaardsman_nn_1_1_N = mkN "barnavårdsman" "barnavårdsmannen" "barnavårdsmän" "barnavårdsmännen" ;
  barnafar_nn_1_N = mkN "barnafar" "barnafadern" "barnafäder" "barnafäderna" ;
  barbadier_nn_1_N = mkN "barbadier" "barbadiern" "barbadier" "barbadierna" ;
  bar_nn_2_N = mkN "bar" "baren" "bar" "baren" ;
  banktjaensteman_nn_1_1_N = mkN "banktjänsteman" "banktjänstemannen" "banktjänstemän" "banktjänstemännen" ;
  bankofullmaektig_nn_1_1_N = mkN "bankofullmäktig" "bankofullmäktigen" "bankofullmäktige" "bankofullmäktigena" ;
  bankman_nn_1_N = mkN "bankman" "bankmannen" "bankmän" "bankmännen" ;
  bangladeshier_nn_1_N = mkN "bangladeshier" "bangladeshiern" "bangladeshier" "bangladeshierna" ;
  baneman_nn_1_N = mkN "baneman" "banemannen" "banemän" "banemännen" ;
  baldersbraa_nn_1_1_N = mkN "baldersbrå" "baldersbrån" "baldersbrår" "baldersbrårna" ;
  bakvatten_nn_1_N = mkN "bakvatten" "bakvattnet" "bakvatten" "bakvattnen" ;
  bakhuvud_nn_1_N = mkN "bakhuvud" "bakhuvudet" "bakhuvuden" "bakhuvudena" ;
  bagel_nn_1_N = mkN "bagel" "bageln" "bagels" "bagelsen" ;
  badvatten_nn_1_N = mkN "badvatten" "badvattnet" "badvatten" "badvattnen" ;
  backpacker_nn_1_N = mkN "backpacker" "backpackern" "backpackers" "backpackersen" ;
  babylonier_nn_1_N = mkN "babylonier" "babyloniern" "babylonier" "babylonierna" ;
  baby_nn_1_N = mkN "baby" "babyn" "babyar" "babyarna" ;
  avvikelseprocent_nn_1_N = mkN "avvikelseprocent" "avvikelseprocenten" "avvikelseprocent" "avvikelseprocenten" ;
  avundsman_nn_1_N = mkN "avundsman" "avundsmannen" "avundsmän" "avundsmännen" ;
  avloppsvatten_nn_1_N = mkN "avloppsvatten" "avloppsvattnet" "avloppsvatten" "avloppsvattnen" ;
  aviatiker_nn_1_N = mkN "aviatiker" "aviatikern" "aviatiker" "aviatikerna" ;
  avfallsvatten_nn_1_N = mkN "avfallsvatten" "avfallsvattnet" "avfallsvatten" "avfallsvattnen" ;
  automatvapen_nn_1_N = mkN "automatvapen" "automatvapnet" "automatvapen" "automatvapnen" ;
  australier_nn_1_N = mkN "australier" "australiern" "australier" "australierna" ;
  auktionskammare_nn_1_N = mkN "auktionskammare" "auktionskammaren" "auktionskamrar" "auktionskamrarna" ;
  attentatsman_nn_1_N = mkN "attentatsman" "attentatsmannen" "attentatsmän" "attentatsmännen" ;
  atomvapen_nn_1_N = mkN "atomvapen" "atomvapnet" "atomvapen" "atomvapnen" ;
  ataraktika_nn_1_N = mkN "ataraktika" "ataraktikan" "ataraktika" "ataraktikana" ;
  asylsoekande_nn_1_1_N = mkN "asylsökande" "asylsökanden" "asylsökande" "asylsökandena" ;
  astrofysiker_nn_1_N = mkN "astrofysiker" "astrofysikern" "astrofysiker" "astrofysikerna" ;
  astmatiker_nn_1_N = mkN "astmatiker" "astmatikern" "astmatiker" "astmatikerna" ;
  astigmatiker_nn_1_N = mkN "astigmatiker" "astigmatikern" "astigmatiker" "astigmatikerna" ;
  asteniker_nn_1_N = mkN "asteniker" "astenikern" "asteniker" "astenikerna" ;
  assyrier_nn_1_N = mkN "assyrier" "assyriern" "assyrier" "assyrierna" ;
  artillerivapen_nn_1_N = mkN "artillerivapen" "artillerivapnet" "artillerivapen" "artillerivapnen" ;
  armenier_nn_1_N = mkN "armenier" "armeniern" "armenier" "armenierna" ;
  arier_nn_1_N = mkN "arier" "ariern" "arier" "arierna" ;
  argusoega_nn_1_1_N = mkN "argusöga" "argusögat" "argusögon" "argusögonen" ;
  ardenner_nn_1_N = mkN "ardenner" "ardennern" "ardenner" "ardennerna" ;
  arbetssoekande_nn_1_1_N = mkN "arbetssökande" "arbetssökanden" "arbetssökande" "arbetssökandena" ;
  arbetsstudieman_nn_1_N = mkN "arbetsstudieman" "arbetsstudiemannen" "arbetsstudiemän" "arbetsstudiemännen" ;
  apropaa_nn_1_1_N = mkN "apropå" "apropåt" "apropån" "apropåna" ;
  antiseptika_nn_1_N = mkN "antiseptika" "antiseptikan" "antiseptika" "antiseptikana" ;
  antibiotikum_nn_1_N = mkN "antibiotikum" "antibiotikum" "antibiotika" "antibiotikana" ;
  antecedentia_nn_1_N = mkN "antecedentia" "antecedentian" "antecedentia" "antecedentiana" ;
  anorektiker_nn_1_N = mkN "anorektiker" "anorektikern" "anorektiker" "anorektikerna" ;
  anfoeringstecken_nn_1_1_N = mkN "anföringstecken" "anföringstecknet" "anföringstecken" "anföringstecknen" ;
  anfallsvapen_nn_1_N = mkN "anfallsvapen" "anfallsvapnet" "anfallsvapen" "anfallsvapnen" ;
  anfader_nn_1_N = mkN "anfader" "anfadern" "anfäder" "anfäderna" ;
  anestetika_nn_1_N = mkN "anestetika" "anestetikan" "anestetika" "anestetikana" ;
  anatema_nn_1_N = mkN "anatema" "anatemat" "anateman" "anatemana" ;
  analytiker_nn_1_N = mkN "analytiker" "analytikern" "analytiker" "analytikerna" ;
  analgetika_nn_1_N = mkN "analgetika" "analgetikan" "analgetika" "analgetikana" ;
  amtman_nn_1_N = mkN "amtman" "amtmannen" "amtmän" "amtmännen" ;
  ampere_nn_1_N = mkN "ampere" "amperen" "ampere" "amperena" ;
  ambulansman_nn_1_N = mkN "ambulansman" "ambulansmannen" "ambulansmän" "ambulansmännen" ;
  allmaenpraktiker_nn_1_1_N = mkN "allmänpraktiker" "allmänpraktikern" "allmänpraktiker" "allmänpraktikerna" ;
  allergiker_nn_1_N = mkN "allergiker" "allergikern" "allergiker" "allergikerna" ;
  algerier_nn_1_N = mkN "algerier" "algeriern" "algerier" "algerierna" ;
  alfa_nn_1_N = mkN "alfa" "alfat" "alfa" "alfana" ;
  albyl_nn_1_N = mkN "albyl" "albylen" "albyl" "albylen" ;
  albino_nn_1_N = mkN "albino" "albinon" "albiner" "albinerna" ;
  albigenser_nn_1_N = mkN "albigenser" "albigensern" "albigenser" "albigenserna" ;
  akutvaardsdata_nn_1_1_N = mkN "akutvårdsdata" "akutvårdsdatan" "akutvårdsdata" "akutvårdsdatana" ;
  akustiker_nn_1_N = mkN "akustiker" "akustikern" "akustiker" "akustikerna" ;
  aktiva_nn_1_N = mkN "aktiva" "aktivan" "aktiva" "aktivana" ;
  akademiker_nn_1_N = mkN "akademiker" "akademikern" "akademiker" "akademikerna" ;
  airdaleterrier_nn_1_N = mkN "airdaleterrier" "airdaleterriern" "airdaleterrier" "airdaleterrierna" ;
  agnostiker_nn_1_N = mkN "agnostiker" "agnostikern" "agnostiker" "agnostikerna" ;
  afrodisiakum_nn_1_N = mkN "afrodisiakum" "afrodisiakum" "afrodisiaka" "afrodisiakana" ;
  aforistiker_nn_1_N = mkN "aforistiker" "aforistikern" "aforistiker" "aforistikerna" ;
  affaersman_nn_1_1_N = mkN "affärsman" "affärsmannen" "affärsmän" "affärsmännen" ;
  afatiker_nn_1_N = mkN "afatiker" "afatikern" "afatiker" "afatikerna" ;
  adiafora_nn_1_N = mkN "adiafora" "adiaforan" "adiafora" "adiaforana" ;
  adelsman_nn_1_N = mkN "adelsman" "adelsmannen" "adelsmän" "adelsmännen" ;
  additionstecken_nn_1_N = mkN "additionstecken" "additionstecknet" "additionstecken" "additionstecknen" ;
  addenda_nn_1_N = mkN "addenda" "addendan" "addenda" "addendana" ;
  ackordion_nn_1_N = mkN "ackordion" "ackordionet" "ackordion" "ackordierna" ;
  accenttecken_nn_1_N = mkN "accenttecken" "accenttecknet" "accenttecken" "accenttecknen" ;
  aboriginer_nn_1_N = mkN "aboriginer" "aboriginern" "aboriginer" "aboriginerna" ;
  abiturientexamen_nn_1_N = mkN "abiturientexamen" "abiturientexamen" "abiturientexamina" "abiturientexamina" ;
  abessinier_nn_1_N = mkN "abessinier" "abessiniern" "abessinier" "abessinierna" ;
  abdomen_nn_1_N = mkN "abdomen" "abdomen" "abdomina" "abdomina" ;
  Shakespearedrama_nn_1_N = mkN "Shakespearedrama" "Shakespearedramat" "Shakespearedraman" "Shakespearedramana" ;
  PR_man_nn_1_N = mkN "PR-man" "PR-mannen" "PR-män" "PR-männen" ;
  Metallordfoerande_nn_1_1_N = mkN "Metallordförande" "Metallordföranden" "Metallordförande" "Metallordförandena" ;
  LO_ordfoerande_nn_1_1_N = mkN "LO-ordförande" "LO-ordföranden" "LO-ordförande" "LO-ordförandena" ;
  LCD_teve_nn_2_N = mkN "LCD-teve" "LCD-teven" "LCD-teve" "LCD-tevena" ;
  Europaraadsparlamentariker_nn_1_1_N = mkN "Europarådsparlamentariker" "Europarådsparlamentarikern" "Europarådsparlamentariker" "Europarådsparlamentarikerna" ;
  EU_parlamentariker_nn_1_N = mkN "EU-parlamentariker" "EU-parlamentarikern" "EU-parlamentariker" "EU-parlamentarikerna" ;
  alkoholpolicy_nn_1_N = mkN "alkoholpolicy" "alkoholpolicier" ;
  alltiallo_nn_1_N = mkN "alltiallo" "alltiallor" ;
  assist_nn_1_N = mkN "assist" "assister" ;
  backup_nn_1_N = mkN "backup" "backuper" ;
  backupp_nn_1_N = mkN "backupp" "backupper" ;
  bekant_nn_1_N = mkN "bekant" "bekanter" ;
  bolero_nn_1_N = mkN "bolero" "boleror" ;
  bror_nn_1_N = mkN "bror" "bröder" ;
  bungalow_nn_1_N = mkN "bungalow" "bungalower" ;
  cello_nn_1_N = mkN "cello" "cellor" ;
  cembalo_nn_1_N = mkN "cembalo" "cembalor" ;
  cornichon_nn_1_N = mkN "cornichon" "cornichoner" ;
  dandy_nn_1_N = mkN "dandy" "dandier" ;
  distansminut_nn_1_N = mkN "distansminut" "distansminuter" ;
  drogpolicy_nn_1_N = mkN "drogpolicy" "drogpolicier" ;
  dubror_nn_1_N = mkN "dubror" "dubröder" ;
  dummy_nn_1_N = mkN "dummy" "dummier" ;
  dus_nn_1_N = mkN "dus" "duser" ;
  etage_nn_1_N = mkN "etage" "etager" ;
  fandango_nn_1_N = mkN "fandango" "fandangor" ;
  farbror_nn_1_N = mkN "farbror" "farbröder" ;
  flamenco_nn_1_N = mkN "flamenco" "flamencor" ;
  fosterbror_nn_1_N = mkN "fosterbror" "fosterbröder" ;
  foul_nn_1_N = mkN "foul" "fouler" ;
  foergaetmigej_nn_1_1_N = mkN "förgätmigej" "förgätmigejer" ;
  glasiglo_nn_1_N = mkN "glasiglo" "glasiglor" ;
  gravamen_nn_1_N = mkN "gravamen" "gravamina" ;
  grej_nn_1_N = mkN "grej" "grejer" ;
  guppy_nn_1_N = mkN "guppy" "guppier" ;
  halo_nn_1_N = mkN "halo" "halor" ;
  halvbror_nn_1_N = mkN "halvbror" "halvbröder" ;
  hambo_nn_1_N = mkN "hambo" "hambor" ;
  helbror_nn_1_N = mkN "helbror" "helbröder" ;
  herrbekant_nn_1_N = mkN "herrbekant" "herrbekanter" ;
  hobby_nn_1_N = mkN "hobby" "hobbier" ;
  iglo_nn_1_N = mkN "iglo" "iglor" ;
  igloo_nn_1_N = mkN "igloo" "igloor" ;
  kaffe_nn_2_N = mkN "kaffe" "kaffe" ;
  kanon_nn_1_N = mkN "kanon" "kanoner" ;
  korso_nn_1_N = mkN "korso" "korsor" ;
  kaernvapenparaply_nn_1_1_N = mkN "kärnvapenparaply" "kärnvapenparaplyer" ;
  lasso_nn_1_N = mkN "lasso" "lassor" ;
  libero_nn_1_N = mkN "libero" "liberor" ;
  libretto_nn_1_N = mkN "libretto" "librettor" ;
  litteraturkanon_nn_1_N = mkN "litteraturkanon" "litteraturkanoner" ;
  mango_nn_1_N = mkN "mango" "mangor" ;
  mellanbror_nn_1_N = mkN "mellanbror" "mellanbröder" ;
  mikrofiche_nn_1_N = mkN "mikrofiche" "mikroficher" ;
  mikron_nn_1_N = mkN "mikron" "mikroner" ;
  minut_nn_1_N = mkN "minut" "minuter" ;
  molo_nn_1_N = mkN "molo" "molor" ;
  morbror_nn_1_N = mkN "morbror" "morbröder" ;
  mungo_nn_1_N = mkN "mungo" "mungor" ;
  navaho_nn_1_N = mkN "navaho" "navahoer" ;
  navajo_nn_1_N = mkN "navajo" "navajoer" ;
  paraply_nn_1_N = mkN "paraply" "paraplyer" ;
  personal_nn_2_N = mkN "personal" "personaler" ;
  policy_nn_1_N = mkN "policy" "policier" ;
  ponny_nn_1_N = mkN "ponny" "ponnier" ;
  promovend_nn_1_N = mkN "promovend" "promovender" ;
  shetlandsponny_nn_1_N = mkN "shetlandsponny" "shetlandsponnier" ;
  slutminut_nn_1_N = mkN "slutminut" "slutminuter" ;
  sombrero_nn_1_N = mkN "sombrero" "sombreror" ;
  spin_off_nn_1_N = mkN "spin-off" "spin-offer" ;
  tango_nn_1_N = mkN "tango" "tangor" ;
  te_nn_2_N = mkN "te" "te" ;
  the_nn_2_N = mkN "the" "the" ;
  torero_nn_1_N = mkN "torero" "toreror" ;
  triage_nn_1_N = mkN "triage" "triager" ;
  tvillingbror_nn_1_N = mkN "tvillingbror" "tvillingbröder" ;
  vad_nn_2_N = mkN "vad" "vader" ;
  oeverpris_nn_1_1_N = mkN "överpris" neutrum  ;
  oeverkast_nn_1_1_N = mkN "överkast" neutrum  ;
  oevergaangsproblem_nn_1_1_N = mkN "övergångsproblem" neutrum  ;
  oeverfaangsglas_nn_1_1_N = mkN "överfångsglas" neutrum  ;
  oerclips_nn_1_1_N = mkN "örclips" neutrum  ;
  oelglas_nn_1_1_N = mkN "ölglas" neutrum  ;
  oel_nn_2_1_N = mkN "öl" neutrum  ;
  oel_nn_1_1_N = mkN "öl" neutrum  ;
  oegonkast_nn_1_1_N = mkN "ögonkast" neutrum  ;
  oedem_nn_1_1_N = mkN "ödem" neutrum  ;
  aarder_nn_1_1_N = mkN "årder" neutrum  ;
  aanglokomotiv_nn_1_1_N = mkN "ånglokomotiv" neutrum  ;
  aangestsymtom_nn_1_1_N = mkN "ångestsymtom" neutrum  ;
  aangestsymptom_nn_1_1_N = mkN "ångestsymptom" neutrum  ;
  aalyngel_nn_1_1_N = mkN "ålyngel" neutrum  ;
  aettled_nn_1_1_N = mkN "ättled" neutrum  ;
  aess_nn_1_1_N = mkN "äss" neutrum  ;
  aeppletraed_nn_1_1_N = mkN "äppleträd" neutrum  ;
  aeppeltraed_nn_1_1_N = mkN "äppelträd" neutrum  ;
  aeggviteprov_nn_1_1_N = mkN "äggviteprov" neutrum  ;
  aegardirektiv_nn_1_1_N = mkN "ägardirektiv" neutrum  ;
  aedelloevtraed_nn_1_1_N = mkN "ädellövträd" neutrum  ;
  aeckel_nn_1_1_N = mkN "äckel" neutrum  ;
  zoomobjektiv_nn_1_N = mkN "zoomobjektiv" neutrum  ;
  ziqqurat_nn_1_N = mkN "ziqqurat" neutrum  ;
  zikkurat_nn_1_N = mkN "zikkurat" neutrum  ;
  ziggurat_nn_1_N = mkN "ziggurat" neutrum  ;
  ypsilon_nn_1_N = mkN "ypsilon" neutrum  ;
  yogapass_nn_1_N = mkN "yogapass" neutrum  ;
  ynnestbevis_nn_1_N = mkN "ynnestbevis" neutrum  ;
  yngel_nn_1_N = mkN "yngel" neutrum  ;
  ylletyg_nn_1_N = mkN "ylletyg" neutrum  ;
  yalelaas_nn_1_1_N = mkN "yalelås" neutrum  ;
  xi_nn_1_N = mkN "xi" neutrum  ;
  webbtest_nn_1_N = mkN "webbtest" neutrum  ;
  vaardtraed_nn_1_1_N = mkN "vårdträd" neutrum  ;
  vaexthus_nn_1_1_N = mkN "växthus" neutrum  ;
  vaexthormon_nn_1_1_N = mkN "växthormon" neutrum  ;
  vaevnadsprov_nn_1_1_N = mkN "vävnadsprov" neutrum  ;
  vaetteljus_nn_1_1_N = mkN "vätteljus" neutrum  ;
  vaermeljus_nn_1_1_N = mkN "värmeljus" neutrum  ;
  vaermeledningssystem_nn_1_1_N = mkN "värmeledningssystem" neutrum  ;
  vaermekrus_nn_1_1_N = mkN "värmekrus" neutrum  ;
  vaerdshus_nn_1_1_N = mkN "värdshus" neutrum  ;
  vaensterkryss_nn_1_1_N = mkN "vänsterkryss" neutrum  ;
  vaenskapspris_nn_1_1_N = mkN "vänskapspris" neutrum  ;
  vaenpris_nn_1_1_N = mkN "vänpris" neutrum  ;
  vaendkors_nn_1_1_N = mkN "vändkors" neutrum  ;
  vaelfaerdssystem_nn_1_1_N = mkN "välfärdssystem" neutrum  ;
  vaegkors_nn_1_1_N = mkN "vägkors" neutrum  ;
  vaedersegel_nn_1_1_N = mkN "vädersegel" neutrum  ;
  vaederkaos_nn_1_1_N = mkN "väderkaos" neutrum  ;
  vaeder_nn_1_1_N = mkN "väder" neutrum  ;
  vrakpris_nn_1_N = mkN "vrakpris" neutrum  ;
  vov_nn_1_N = mkN "vov" neutrum  ;
  votum_nn_1_N = mkN "votum" neutrum  ;
  votivljus_nn_1_N = mkN "votivljus" neutrum  ;
  vomitiv_nn_1_N = mkN "vomitiv" neutrum  ;
  vodkaglas_nn_1_N = mkN "vodkaglas" neutrum  ;
  vittnesbaas_nn_1_1_N = mkN "vittnesbås" neutrum  ;
  visum_nn_1_N = mkN "visum" neutrum  ;
  visthus_nn_1_N = mkN "visthus" neutrum  ;
  visarkiv_nn_1_N = mkN "visarkiv" neutrum  ;
  vis_nn_1_N = mkN "vis" neutrum  ;
  virus_nn_1_N = mkN "virus" neutrum  ;
  virkgarn_nn_1_N = mkN "virkgarn" neutrum  ;
  vintermys_nn_1_N = mkN "vintermys" neutrum  ;
  vinstras_nn_1_N = mkN "vinstras" neutrum  ;
  vinkelhus_nn_1_N = mkN "vinkelhus" neutrum  ;
  vinglas_nn_1_N = mkN "vinglas" neutrum  ;
  vindkast_nn_1_N = mkN "vindkast" neutrum  ;
  vin_nn_3_N = mkN "vin" neutrum  ;
  viltstaengsel_nn_1_1_N = mkN "viltstängsel" neutrum  ;
  villapris_nn_1_N = mkN "villapris" neutrum  ;
  vildgraes_nn_1_1_N = mkN "vildgräs" neutrum  ;
  viktsystem_nn_1_N = mkN "viktsystem" neutrum  ;
  vigselritual_nn_1_N = mkN "vigselritual" neutrum  ;
  vigselbevis_nn_1_N = mkN "vigselbevis" neutrum  ;
  vidvinkelobjektiv_nn_1_N = mkN "vidvinkelobjektiv" neutrum  ;
  vidunder_nn_1_N = mkN "vidunder" neutrum  ;
  victoriakors_nn_1_N = mkN "victoriakors" neutrum  ;
  viby_i_nn_1_N = mkN "viby-i" neutrum  ;
  vevhus_nn_1_N = mkN "vevhus" neutrum  ;
  verkstadshus_nn_1_N = mkN "verkstadshus" neutrum  ;
  verbalsubstantiv_nn_1_N = mkN "verbalsubstantiv" neutrum  ;
  verbalabstrakt_nn_1_N = mkN "verbalabstrakt" neutrum  ;
  ventilhus_nn_1_N = mkN "ventilhus" neutrum  ;
  ventilationssystem_nn_1_N = mkN "ventilationssystem" neutrum  ;
  vaxljus_nn_1_N = mkN "vaxljus" neutrum  ;
  vattupass_nn_1_N = mkN "vattupass" neutrum  ;
  vattenvaermesystem_nn_1_1_N = mkN "vattenvärmesystem" neutrum  ;
  vattenprov_nn_1_N = mkN "vattenprov" neutrum  ;
  vattenpass_nn_1_N = mkN "vattenpass" neutrum  ;
  vattenlaas_nn_1_1_N = mkN "vattenlås" neutrum  ;
  vattenkrus_nn_1_N = mkN "vattenkrus" neutrum  ;
  vattenglas_nn_1_N = mkN "vattenglas" neutrum  ;
  varuprov_nn_1_N = mkN "varuprov" neutrum  ;
  varupris_nn_1_N = mkN "varupris" neutrum  ;
  varuhus_nn_1_N = mkN "varuhus" neutrum  ;
  varsel_nn_1_N = mkN "varsel" neutrum  ;
  varningsljus_nn_1_N = mkN "varningsljus" neutrum  ;
  varmvattensystem_nn_1_N = mkN "varmvattensystem" neutrum  ;
  varmvattenssystem_nn_1_N = mkN "varmvattenssystem" neutrum  ;
  varmluftssystem_nn_1_N = mkN "varmluftssystem" neutrum  ;
  varghagel_nn_1_N = mkN "varghagel" neutrum  ;
  vardagsritual_nn_1_N = mkN "vardagsritual" neutrum  ;
  vapensystem_nn_1_N = mkN "vapensystem" neutrum  ;
  vapenhus_nn_1_N = mkN "vapenhus" neutrum  ;
  vant_nn_1_N = mkN "vant" neutrum  ;
  vandringspris_nn_1_N = mkN "vandringspris" neutrum  ;
  vanadinstaal_nn_1_1_N = mkN "vanadinstål" neutrum  ;
  valnoetstraed_nn_1_1_N = mkN "valnötsträd" neutrum  ;
  valmanifest_nn_1_N = mkN "valmanifest" neutrum  ;
  vallokomotiv_nn_1_N = mkN "vallokomotiv" neutrum  ;
  valkaos_nn_1_N = mkN "valkaos" neutrum  ;
  vakuum_nn_1_N = mkN "vakuum" neutrum  ;
  vagnslider_nn_1_N = mkN "vagnslider" neutrum  ;
  vacuum_nn_1_N = mkN "vacuum" neutrum  ;
  vaccin_nn_1_N = mkN "vaccin" neutrum  ;
  utvaerdshus_nn_1_1_N = mkN "utvärdshus" neutrum  ;
  utvisningsbaas_nn_1_1_N = mkN "utvisningsbås" neutrum  ;
  utvecklingstraed_nn_1_1_N = mkN "utvecklingsträd" neutrum  ;
  utseendekomplex_nn_1_N = mkN "utseendekomplex" neutrum  ;
  utkast_nn_1_N = mkN "utkast" neutrum  ;
  utifraanperspektiv_nn_1_1_N = mkN "utifrånperspektiv" neutrum  ;
  uthus_nn_1_N = mkN "uthus" neutrum  ;
  utgivningsbevis_nn_1_N = mkN "utgivningsbevis" neutrum  ;
  utfallsprov_nn_1_N = mkN "utfallsprov" neutrum  ;
  utedass_nn_1_N = mkN "utedass" neutrum  ;
  utbredningscentrum_nn_1_N = mkN "utbredningscentrum" neutrum  ;
  utbildningssystem_nn_1_N = mkN "utbildningssystem" neutrum  ;
  ursprungsbevis_nn_1_N = mkN "ursprungsbevis" neutrum  ;
  urinprov_nn_1_N = mkN "urinprov" neutrum  ;
  uranglas_nn_1_N = mkN "uranglas" neutrum  ;
  uppkast_nn_1_N = mkN "uppkast" neutrum  ;
  uns_nn_1_N = mkN "uns" neutrum  ;
  universum_nn_1_N = mkN "universum" neutrum  ;
  universitetssjukhus_nn_1_N = mkN "universitetssjukhus" neutrum  ;
  unikum_nn_1_N = mkN "unikum" neutrum  ;
  undervisningssjukhus_nn_1_N = mkN "undervisningssjukhus" neutrum  ;
  understatement_nn_1_N = mkN "understatement" neutrum  ;
  undersegel_nn_1_N = mkN "undersegel" neutrum  ;
  underpris_nn_1_N = mkN "underpris" neutrum  ;
  underifraanperspektiv_nn_1_1_N = mkN "underifrånperspektiv" neutrum  ;
  underhaallsproblem_nn_1_1_N = mkN "underhållsproblem" neutrum  ;
  underhus_nn_1_N = mkN "underhus" neutrum  ;
  under_nn_1_N = mkN "under" neutrum  ;
  ultimatum_nn_1_N = mkN "ultimatum" neutrum  ;
  ugnstegel_nn_1_N = mkN "ugnstegel" neutrum  ;
  taartkalas_nn_1_1_N = mkN "tårtkalas" neutrum  ;
  taevlingspris_nn_1_1_N = mkN "tävlingspris" neutrum  ;
  taerningskast_nn_1_1_N = mkN "tärningskast" neutrum  ;
  taendsticksproblem_nn_1_1_N = mkN "tändsticksproblem" neutrum  ;
  taendningslaas_nn_1_1_N = mkN "tändningslås" neutrum  ;
  taeckglas_nn_1_1_N = mkN "täckglas" neutrum  ;
  typexempel_nn_1_N = mkN "typexempel" neutrum  ;
  tygprov_nn_1_N = mkN "tygprov" neutrum  ;
  tyghus_nn_1_N = mkN "tyghus" neutrum  ;
  tyg_nn_1_N = mkN "tyg" neutrum  ;
  tvaakammarsystem_nn_1_1_N = mkN "tvåkammarsystem" neutrum  ;
  tvaafamiljshus_nn_1_1_N = mkN "tvåfamiljshus" neutrum  ;
  tvivel_nn_1_N = mkN "tvivel" neutrum  ;
  tvillingsyskon_nn_1_N = mkN "tvillingsyskon" neutrum  ;
  tulpantraed_nn_1_1_N = mkN "tulpanträd" neutrum  ;
  tullpass_nn_1_N = mkN "tullpass" neutrum  ;
  tukthus_nn_1_N = mkN "tukthus" neutrum  ;
  tsunamivarningssystem_nn_1_N = mkN "tsunamivarningssystem" neutrum  ;
  troestpris_nn_1_1_N = mkN "tröstpris" neutrum  ;
  traadkors_nn_1_1_N = mkN "trådkors" neutrum  ;
  traesk_nn_1_1_N = mkN "träsk" neutrum  ;
  traekors_nn_1_1_N = mkN "träkors" neutrum  ;
  traed_nn_1_1_N = mkN "träd" neutrum  ;
  trubbel_nn_1_N = mkN "trubbel" neutrum  ;
  tricks_nn_1_N = mkN "tricks" neutrum  ;
  trevaaningshus_nn_1_1_N = mkN "trevåningshus" neutrum  ;
  trepass_nn_1_N = mkN "trepass" neutrum  ;
  treledarsystem_nn_1_N = mkN "treledarsystem" neutrum  ;
  tredagarspass_nn_1_N = mkN "tredagarspass" neutrum  ;
  travtips_nn_1_N = mkN "travtips" neutrum  ;
  trapphus_nn_1_N = mkN "trapphus" neutrum  ;
  transumt_nn_1_N = mkN "transumt" neutrum  ;
  transportsystem_nn_1_N = mkN "transportsystem" neutrum  ;
  trafikljus_nn_1_N = mkN "trafikljus" neutrum  ;
  trafikkaos_nn_1_N = mkN "trafikkaos" neutrum  ;
  totalkaos_nn_1_N = mkN "totalkaos" neutrum  ;
  torrdass_nn_1_N = mkN "torrdass" neutrum  ;
  toppsegel_nn_1_N = mkN "toppsegel" neutrum  ;
  tonsystem_nn_1_N = mkN "tonsystem" neutrum  ;
  tonem_nn_1_N = mkN "tonem" neutrum  ;
  tomtebloss_nn_1_N = mkN "tomtebloss" neutrum  ;
  tomglas_nn_1_N = mkN "tomglas" neutrum  ;
  tjaerbloss_nn_1_1_N = mkN "tjärbloss" neutrum  ;
  tips_nn_1_N = mkN "tips" neutrum  ;
  tingshus_nn_1_N = mkN "tingshus" neutrum  ;
  timmerhus_nn_1_N = mkN "timmerhus" neutrum  ;
  timglas_nn_1_N = mkN "timglas" neutrum  ;
  tillvaexthormon_nn_1_1_N = mkN "tillväxthormon" neutrum  ;
  tillstaandsbevis_nn_1_1_N = mkN "tillståndsbevis" neutrum  ;
  tidsperspektiv_nn_1_N = mkN "tidsperspektiv" neutrum  ;
  tidskriftsindex_nn_1_N = mkN "tidskriftsindex" neutrum  ;
  tidsintervall_nn_1_N = mkN "tidsintervall" neutrum  ;
  tidsadverbial_nn_1_N = mkN "tidsadverbial" neutrum  ;
  textarkiv_nn_1_N = mkN "textarkiv" neutrum  ;
  tetrakord_nn_1_N = mkN "tetrakord" neutrum  ;
  test_nn_1_N = mkN "test" neutrum  ;
  teorem_nn_1_N = mkN "teorem" neutrum  ;
  tempel_nn_1_N = mkN "tempel" neutrum  ;
  telex_nn_2_N = mkN "telex" neutrum  ;
  teleobjektiv_nn_1_N = mkN "teleobjektiv" neutrum  ;
  tehus_nn_1_N = mkN "tehus" neutrum  ;
  teglas_nn_1_N = mkN "teglas" neutrum  ;
  tegel_nn_1_N = mkN "tegel" neutrum  ;
  tefralager_nn_1_N = mkN "tefralager" neutrum  ;
  tedeum_nn_1_N = mkN "tedeum" neutrum  ;
  teckningsbevis_nn_1_N = mkN "teckningsbevis" neutrum  ;
  teckensystem_nn_1_N = mkN "teckensystem" neutrum  ;
  teaktraed_nn_1_1_N = mkN "teakträd" neutrum  ;
  taxeringsbevis_nn_1_N = mkN "taxeringsbevis" neutrum  ;
  tau_nn_1_N = mkN "tau" neutrum  ;
  tarmsystem_nn_1_N = mkN "tarmsystem" neutrum  ;
  tarmkaex_nn_1_1_N = mkN "tarmkäx" neutrum  ;
  tantiem_nn_1_N = mkN "tantiem" neutrum  ;
  tankesystem_nn_1_N = mkN "tankesystem" neutrum  ;
  tankeexperiment_nn_1_N = mkN "tankeexperiment" neutrum  ;
  tandborstglas_nn_1_N = mkN "tandborstglas" neutrum  ;
  talsystem_nn_1_N = mkN "talsystem" neutrum  ;
  talgljus_nn_1_N = mkN "talgljus" neutrum  ;
  talcentrum_nn_1_N = mkN "talcentrum" neutrum  ;
  taktegel_nn_1_N = mkN "taktegel" neutrum  ;
  takroest_nn_1_1_N = mkN "takröst" neutrum  ;
  takras_nn_1_N = mkN "takras" neutrum  ;
  taggtraadsstaengsel_nn_1_1_N = mkN "taggtrådsstängsel" neutrum  ;
  tagel_nn_1_N = mkN "tagel" neutrum  ;
  tackoffer_nn_1_N = mkN "tackoffer" neutrum  ;
  tackel_nn_1_N = mkN "tackel" neutrum  ;
  tack_nn_1_N = mkN "tack" neutrum  ;
  tabernakel_nn_1_N = mkN "tabernakel" neutrum  ;
  soemnproblem_nn_1_1_N = mkN "sömnproblem" neutrum  ;
  soemmersketips_nn_1_1_N = mkN "sömmersketips" neutrum  ;
  soekarljus_nn_1_1_N = mkN "sökarljus" neutrum  ;
  saettsadverbial_nn_1_1_N = mkN "sättsadverbial" neutrum  ;
  saekerhetssystem_nn_1_1_N = mkN "säkerhetssystem" neutrum  ;
  saekerhetsproblem_nn_1_1_N = mkN "säkerhetsproblem" neutrum  ;
  saekerhetsglas_nn_1_1_N = mkN "säkerhetsglas" neutrum  ;
  system_nn_1_N = mkN "system" neutrum  ;
  syskon_nn_1_N = mkN "syskon" neutrum  ;
  syntagm_nn_1_N = mkN "syntagm" neutrum  ;
  synset_nn_1_N = mkN "synset" neutrum  ;
  synonymlexikon_nn_1_N = mkN "synonymlexikon" neutrum  ;
  symtom_nn_1_N = mkN "symtom" neutrum  ;
  symptom_nn_1_N = mkN "symptom" neutrum  ;
  svaengningsproblem_nn_1_1_N = mkN "svängningsproblem" neutrum  ;
  svinstall_nn_1_N = mkN "svinstall" neutrum  ;
  svinhus_nn_1_N = mkN "svinhus" neutrum  ;
  svindelperspektiv_nn_1_N = mkN "svindelperspektiv" neutrum  ;
  svinborst_nn_1_N = mkN "svinborst" neutrum  ;
  svidknott_nn_1_N = mkN "svidknott" neutrum  ;
  suterraenghus_nn_1_1_N = mkN "suterränghus" neutrum  ;
  surfproffs_nn_1_N = mkN "surfproffs" neutrum  ;
  supervirus_nn_1_N = mkN "supervirus" neutrum  ;
  sulfit_nn_1_N = mkN "sulfit" neutrum  ;
  sulfat_nn_1_N = mkN "sulfat" neutrum  ;
  suffix_nn_1_N = mkN "suffix" neutrum  ;
  substantiv_nn_1_N = mkN "substantiv" neutrum  ;
  staand_nn_2_1_N = mkN "stånd" neutrum  ;
  staerbhus_nn_1_1_N = mkN "stärbhus" neutrum  ;
  staengsel_nn_1_1_N = mkN "stängsel" neutrum  ;
  staedsel_nn_1_1_N = mkN "städsel" neutrum  ;
  styvsyskon_nn_1_N = mkN "styvsyskon" neutrum  ;
  styrsystem_nn_1_N = mkN "styrsystem" neutrum  ;
  styrkepass_nn_1_N = mkN "styrkepass" neutrum  ;
  styrcentrum_nn_1_N = mkN "styrcentrum" neutrum  ;
  studioalbum_nn_1_N = mkN "studioalbum" neutrum  ;
  straalningsspektrum_nn_1_1_N = mkN "strålningsspektrum" neutrum  ;
  straalningskvantum_nn_1_1_N = mkN "strålningskvantum" neutrum  ;
  straalkastarljus_nn_1_1_N = mkN "strålkastarljus" neutrum  ;
  stresshormon_nn_1_N = mkN "stresshormon" neutrum  ;
  strejkvarsel_nn_1_N = mkN "strejkvarsel" neutrum  ;
  straffkast_nn_1_N = mkN "straffkast" neutrum  ;
  storsyskon_nn_1_N = mkN "storsyskon" neutrum  ;
  storsegel_nn_1_N = mkN "storsegel" neutrum  ;
  stormcentrum_nn_1_N = mkN "stormcentrum" neutrum  ;
  storkors_nn_1_N = mkN "storkors" neutrum  ;
  storfamiljshus_nn_1_N = mkN "storfamiljshus" neutrum  ;
  storasyskon_nn_1_N = mkN "storasyskon" neutrum  ;
  stoppris_nn_1_N = mkN "stoppris" neutrum  ;
  stoppljus_nn_1_N = mkN "stoppljus" neutrum  ;
  stoff_nn_1_N = mkN "stoff" neutrum  ;
  stjaernsystem_nn_1_1_N = mkN "stjärnsystem" neutrum  ;
  stjaernljus_nn_1_1_N = mkN "stjärnljus" neutrum  ;
  stjaernhus_nn_1_1_N = mkN "stjärnhus" neutrum  ;
  stimulus_nn_1_N = mkN "stimulus" neutrum  ;
  stiglaeder_nn_1_1_N = mkN "stigläder" neutrum  ;
  sterbhus_nn_1_N = mkN "sterbhus" neutrum  ;
  stenroes_nn_1_1_N = mkN "stenrös" neutrum  ;
  stenkummel_nn_1_N = mkN "stenkummel" neutrum  ;
  stenkast_nn_1_N = mkN "stenkast" neutrum  ;
  stekhus_nn_1_N = mkN "stekhus" neutrum  ;
  stegel_nn_1_N = mkN "stegel" neutrum  ;
  stearinljus_nn_1_N = mkN "stearinljus" neutrum  ;
  stativ_nn_1_N = mkN "stativ" neutrum  ;
  stationshus_nn_1_N = mkN "stationshus" neutrum  ;
  startsystem_nn_1_N = mkN "startsystem" neutrum  ;
  startproblem_nn_1_N = mkN "startproblem" neutrum  ;
  startpris_nn_1_N = mkN "startpris" neutrum  ;
  starkoel_nn_1_1_N = mkN "starköl" neutrum  ;
  stamtraed_nn_1_1_N = mkN "stamträd" neutrum  ;
  stamlokus_nn_1_N = mkN "stamlokus" neutrum  ;
  stalltips_nn_1_N = mkN "stalltips" neutrum  ;
  stall_nn_1_N = mkN "stall" neutrum  ;
  stagsegel_nn_1_N = mkN "stagsegel" neutrum  ;
  stadsljus_nn_1_N = mkN "stadsljus" neutrum  ;
  stadshus_nn_1_N = mkN "stadshus" neutrum  ;
  stadsarkiv_nn_1_N = mkN "stadsarkiv" neutrum  ;
  stabiliseringsproblem_nn_1_N = mkN "stabiliseringsproblem" neutrum  ;
  spaarljus_nn_1_1_N = mkN "spårljus" neutrum  ;
  spraangsegel_nn_1_1_N = mkN "språngsegel" neutrum  ;
  spraakcentrum_nn_1_1_N = mkN "språkcentrum" neutrum  ;
  sprinklersystem_nn_1_N = mkN "sprinklersystem" neutrum  ;
  splitter_nn_1_N = mkN "splitter" neutrum  ;
  spinnhus_nn_1_N = mkN "spinnhus" neutrum  ;
  spinn_nn_1_N = mkN "spinn" neutrum  ;
  spin_nn_1_N = mkN "spin" neutrum  ;
  spex_nn_1_N = mkN "spex" neutrum  ;
  spetsglas_nn_1_N = mkN "spetsglas" neutrum  ;
  spelproblem_nn_1_N = mkN "spelproblem" neutrum  ;
  spektrum_nn_1_N = mkN "spektrum" neutrum  ;
  spektakel_nn_1_N = mkN "spektakel" neutrum  ;
  spegeltest_nn_1_N = mkN "spegeltest" neutrum  ;
  spegelglas_nn_1_N = mkN "spegelglas" neutrum  ;
  specimen_nn_1_N = mkN "specimen" neutrum  ;
  specialproblem_nn_1_N = mkN "specialproblem" neutrum  ;
  spamm_nn_1_N = mkN "spamm" neutrum  ;
  spam_nn_1_N = mkN "spam" neutrum  ;
  souterraenghus_nn_1_1_N = mkN "souterränghus" neutrum  ;
  souterrainhus_nn_1_N = mkN "souterrainhus" neutrum  ;
  sorkvirus_nn_1_N = mkN "sorkvirus" neutrum  ;
  sopnedkast_nn_1_N = mkN "sopnedkast" neutrum  ;
  sommarparadis_nn_1_N = mkN "sommarparadis" neutrum  ;
  sommarhus_nn_1_N = mkN "sommarhus" neutrum  ;
  solsystem_nn_1_N = mkN "solsystem" neutrum  ;
  solljus_nn_1_N = mkN "solljus" neutrum  ;
  soleksem_nn_1_N = mkN "soleksem" neutrum  ;
  sodaglas_nn_1_N = mkN "sodaglas" neutrum  ;
  societetshus_nn_1_N = mkN "societetshus" neutrum  ;
  snoekaos_nn_1_1_N = mkN "snökaos" neutrum  ;
  snoehagel_nn_1_1_N = mkN "snöhagel" neutrum  ;
  snaepplaas_nn_1_1_N = mkN "snäpplås" neutrum  ;
  snaeckhus_nn_1_1_N = mkN "snäckhus" neutrum  ;
  snigelhus_nn_1_N = mkN "snigelhus" neutrum  ;
  snedsegel_nn_1_N = mkN "snedsegel" neutrum  ;
  snapshot_nn_1_N = mkN "snapshot" neutrum  ;
  snacks_nn_1_N = mkN "snacks" neutrum  ;
  smoergaasmargarin_nn_1_1_N = mkN "smörgåsmargarin" neutrum  ;
  smaasyskon_nn_1_1_N = mkN "småsyskon" neutrum  ;
  smaahus_nn_1_1_N = mkN "småhus" neutrum  ;
  smaaax_nn_1_1_N = mkN "småax" neutrum  ;
  smaecklaas_nn_1_1_N = mkN "smäcklås" neutrum  ;
  smakprov_nn_1_N = mkN "smakprov" neutrum  ;
  smakproblem_nn_1_N = mkN "smakproblem" neutrum  ;
  smajl_nn_1_N = mkN "smajl" neutrum  ;
  slaekttraed_nn_1_1_N = mkN "släktträd" neutrum  ;
  slaektskapstraed_nn_1_1_N = mkN "släktskapsträd" neutrum  ;
  slaektkalas_nn_1_1_N = mkN "släktkalas" neutrum  ;
  slipprov_nn_1_N = mkN "slipprov" neutrum  ;
  slavhus_nn_1_N = mkN "slavhus" neutrum  ;
  slaktoffer_nn_1_N = mkN "slaktoffer" neutrum  ;
  slakthus_nn_1_N = mkN "slakthus" neutrum  ;
  skoenhetspris_nn_1_1_N = mkN "skönhetspris" neutrum  ;
  skoeldkoertelhormon_nn_1_1_N = mkN "sköldkörtelhormon" neutrum  ;
  skaalkors_nn_1_1_N = mkN "skålkors" neutrum  ;
  skumrask_nn_2_N = mkN "skumrask" neutrum  ;
  skuldderivat_nn_1_N = mkN "skuldderivat" neutrum  ;
  skraeckexempel_nn_1_1_N = mkN "skräckexempel" neutrum  ;
  skriptum_nn_1_N = mkN "skriptum" neutrum  ;
  skriftsystem_nn_1_N = mkN "skriftsystem" neutrum  ;
  skolsystem_nn_1_N = mkN "skolsystem" neutrum  ;
  skolljus_nn_1_N = mkN "skolljus" neutrum  ;
  skolhus_nn_1_N = mkN "skolhus" neutrum  ;
  skolexempel_nn_1_N = mkN "skolexempel" neutrum  ;
  skogstraed_nn_1_1_N = mkN "skogsträd" neutrum  ;
  skogshoens_nn_1_1_N = mkN "skogshöns" neutrum  ;
  skjortbroest_nn_1_1_N = mkN "skjortbröst" neutrum  ;
  skivhus_nn_1_N = mkN "skivhus" neutrum  ;
  skivalbum_nn_1_N = mkN "skivalbum" neutrum  ;
  skeppsljus_nn_1_N = mkN "skeppsljus" neutrum  ;
  skatteutjaemningssystem_nn_1_1_N = mkN "skatteutjämningssystem" neutrum  ;
  skattesystem_nn_1_N = mkN "skattesystem" neutrum  ;
  skatteparadis_nn_1_N = mkN "skatteparadis" neutrum  ;
  skalhus_nn_1_N = mkN "skalhus" neutrum  ;
  sjoemanshus_nn_1_1_N = mkN "sjömanshus" neutrum  ;
  sjaelvaeckel_nn_1_1_N = mkN "själväckel" neutrum  ;
  sjutillhaallarlaas_nn_1_1_N = mkN "sjutillhållarlås" neutrum  ;
  sjukhus_nn_1_N = mkN "sjukhus" neutrum  ;
  sjukdomssymtom_nn_1_N = mkN "sjukdomssymtom" neutrum  ;
  sjukdomssymptom_nn_1_N = mkN "sjukdomssymptom" neutrum  ;
  sjabbel_nn_1_N = mkN "sjabbel" neutrum  ;
  sinnessjukhus_nn_1_N = mkN "sinnessjukhus" neutrum  ;
  sinder_nn_1_N = mkN "sinder" neutrum  ;
  simplex_nn_1_N = mkN "simplex" neutrum  ;
  silver_nn_1_N = mkN "silver" neutrum  ;
  silkegarn_nn_1_N = mkN "silkegarn" neutrum  ;
  silikonbroest_nn_1_1_N = mkN "silikonbröst" neutrum  ;
  silikon_nn_1_N = mkN "silikon" neutrum  ;
  silikat_nn_1_N = mkN "silikat" neutrum  ;
  signum_nn_1_N = mkN "signum" neutrum  ;
  signalbloss_nn_1_N = mkN "signalbloss" neutrum  ;
  sifferpussel_nn_1_N = mkN "sifferpussel" neutrum  ;
  sidoroder_nn_1_N = mkN "sidoroder" neutrum  ;
  sidentyg_nn_1_N = mkN "sidentyg" neutrum  ;
  sickativ_nn_1_N = mkN "sickativ" neutrum  ;
  shoppingcentrum_nn_1_N = mkN "shoppingcentrum" neutrum  ;
  shellack_nn_1_N = mkN "shellack" neutrum  ;
  servicehus_nn_1_N = mkN "servicehus" neutrum  ;
  serveuppkast_nn_1_N = mkN "serveuppkast" neutrum  ;
  servess_nn_1_N = mkN "servess" neutrum  ;
  serveess_nn_1_N = mkN "serveess" neutrum  ;
  serum_nn_1_N = mkN "serum" neutrum  ;
  senapsglas_nn_1_N = mkN "senapsglas" neutrum  ;
  semem_nn_1_N = mkN "semem" neutrum  ;
  seltersglas_nn_1_N = mkN "seltersglas" neutrum  ;
  sekelskiftshus_nn_1_N = mkN "sekelskiftshus" neutrum  ;
  sekel_nn_1_N = mkN "sekel" neutrum  ;
  segersmajl_nn_1_N = mkN "segersmajl" neutrum  ;
  segerrus_nn_1_N = mkN "segerrus" neutrum  ;
  segel_nn_1_N = mkN "segel" neutrum  ;
  sedimentprov_nn_1_N = mkN "sedimentprov" neutrum  ;
  schibbolet_nn_1_N = mkN "schibbolet" neutrum  ;
  schackproblem_nn_1_N = mkN "schackproblem" neutrum  ;
  schabbel_nn_1_N = mkN "schabbel" neutrum  ;
  scepter_nn_1_N = mkN "scepter" neutrum  ;
  satskompletteringstest_nn_1_N = mkN "satskompletteringstest" neutrum  ;
  satsadverbial_nn_1_N = mkN "satsadverbial" neutrum  ;
  sannolikhetsbevis_nn_1_N = mkN "sannolikhetsbevis" neutrum  ;
  sandstenshus_nn_1_N = mkN "sandstenshus" neutrum  ;
  sandeltraed_nn_1_1_N = mkN "sandelträd" neutrum  ;
  samsyskon_nn_1_N = mkN "samsyskon" neutrum  ;
  sampel_nn_1_N = mkN "sampel" neutrum  ;
  sammansaettningsled_nn_1_1_N = mkN "sammansättningsled" neutrum  ;
  samhaellssystem_nn_1_1_N = mkN "samhällssystem" neutrum  ;
  samhaellsproblem_nn_1_1_N = mkN "samhällsproblem" neutrum  ;
  salupris_nn_1_N = mkN "salupris" neutrum  ;
  salivprov_nn_1_N = mkN "salivprov" neutrum  ;
  salighetsrus_nn_1_N = mkN "salighetsrus" neutrum  ;
  sagostoff_nn_1_N = mkN "sagostoff" neutrum  ;
  saftkalas_nn_1_N = mkN "saftkalas" neutrum  ;
  roevmoegel_nn_1_1_N = mkN "rövmögel" neutrum  ;
  roevarpris_nn_1_1_N = mkN "rövarpris" neutrum  ;
  roestkaos_nn_1_1_N = mkN "röstkaos" neutrum  ;
  roest_nn_2_1_N = mkN "röst" neutrum  ;
  roes_nn_1_1_N = mkN "rös" neutrum  ;
  roerelsekapital_nn_1_1_N = mkN "rörelsekapital" neutrum  ;
  roerelsecentrum_nn_1_1_N = mkN "rörelsecentrum" neutrum  ;
  raasegel_nn_1_1_N = mkN "råsegel" neutrum  ;
  raamaterial_nn_1_1_N = mkN "råmaterial" neutrum  ;
  raadhus_nn_1_1_N = mkN "rådhus" neutrum  ;
  raettviseperspektiv_nn_1_1_N = mkN "rättviseperspektiv" neutrum  ;
  raettssystem_nn_1_1_N = mkN "rättssystem" neutrum  ;
  raekneexempel_nn_1_1_N = mkN "räkneexempel" neutrum  ;
  rymdepos_nn_1_N = mkN "rymdepos" neutrum  ;
  russ_nn_1_N = mkN "russ" neutrum  ;
  rus_nn_1_N = mkN "rus" neutrum  ;
  runk_nn_1_N = mkN "runk" neutrum  ;
  rumsadverbial_nn_1_N = mkN "rumsadverbial" neutrum  ;
  ruckel_nn_1_N = mkN "ruckel" neutrum  ;
  rotsystem_nn_1_N = mkN "rotsystem" neutrum  ;
  rotmorfem_nn_1_N = mkN "rotmorfem" neutrum  ;
  ros_evinsmingel_nn_1_1_N = mkN "rosévinsmingel" neutrum  ;
  rorschachtest_nn_1_N = mkN "rorschachtest" neutrum  ;
  romanutkast_nn_1_N = mkN "romanutkast" neutrum  ;
  ro_nn_3_N = mkN "ro" neutrum  ;
  rivningshus_nn_1_N = mkN "rivningshus" neutrum  ;
  ritual_nn_1_N = mkN "ritual" neutrum  ;
  rissel_nn_1_N = mkN "rissel" neutrum  ;
  ris_nn_1_N = mkN "ris" neutrum  ;
  ringbrosk_nn_1_N = mkN "ringbrosk" neutrum  ;
  rimlexikon_nn_1_N = mkN "rimlexikon" neutrum  ;
  riktpris_nn_1_N = mkN "riktpris" neutrum  ;
  riksroes_nn_1_1_N = mkN "riksrös" neutrum  ;
  riksdagshus_nn_1_N = mkN "riksdagshus" neutrum  ;
  riksarkiv_nn_1_N = mkN "riksarkiv" neutrum  ;
  riks_nn_1_N = mkN "riks" neutrum  ;
  ridhus_nn_1_N = mkN "ridhus" neutrum  ;
  riddarhus_nn_1_N = mkN "riddarhus" neutrum  ;
  rho_nn_1_N = mkN "rho" neutrum  ;
  returglas_nn_1_N = mkN "returglas" neutrum  ;
  respass_nn_1_N = mkN "respass" neutrum  ;
  reskaos_nn_1_N = mkN "reskaos" neutrum  ;
  residens_nn_1_N = mkN "residens" neutrum  ;
  resekreditiv_nn_1_N = mkN "resekreditiv" neutrum  ;
  renaessanspalats_nn_1_1_N = mkN "renässanspalats" neutrum  ;
  relativpronomen_nn_1_N = mkN "relativpronomen" neutrum  ;
  rekvisit_nn_1_N = mkN "rekvisit" neutrum  ;
  rekviem_nn_1_N = mkN "rekviem" neutrum  ;
  registratur_nn_1_N = mkN "registratur" neutrum  ;
  regionsjukhus_nn_1_N = mkN "regionsjukhus" neutrum  ;
  regeringspussel_nn_1_N = mkN "regeringspussel" neutrum  ;
  regeringsdirektiv_nn_1_N = mkN "regeringsdirektiv" neutrum  ;
  regelsystem_nn_1_N = mkN "regelsystem" neutrum  ;
  regelkraangel_nn_1_1_N = mkN "regelkrångel" neutrum  ;
  referenssystem_nn_1_N = mkN "referenssystem" neutrum  ;
  referendum_nn_1_N = mkN "referendum" neutrum  ;
  recitativ_nn_1_N = mkN "recitativ" neutrum  ;
  recidiv_nn_1_N = mkN "recidiv" neutrum  ;
  reapris_nn_1_N = mkN "reapris" neutrum  ;
  realindex_nn_1_N = mkN "realindex" neutrum  ;
  reagens_nn_1_N = mkN "reagens" neutrum  ;
  rattlaas_nn_1_1_N = mkN "rattlås" neutrum  ;
  ras_nn_2_N = mkN "ras" neutrum  ;
  raptus_nn_1_N = mkN "raptus" neutrum  ;
  rapphoens_nn_1_1_N = mkN "rapphöns" neutrum  ;
  rampris_nn_1_N = mkN "rampris" neutrum  ;
  radonhus_nn_1_N = mkN "radonhus" neutrum  ;
  radionavigeringssystem_nn_1_N = mkN "radionavigeringssystem" neutrum  ;
  radiohus_nn_1_N = mkN "radiohus" neutrum  ;
  radhus_nn_1_N = mkN "radhus" neutrum  ;
  poes_nn_1_1_N = mkN "pös" neutrum  ;
  paavaextproblem_nn_1_1_N = mkN "påväxtproblem" neutrum  ;
  paaskoel_nn_1_1_N = mkN "påsköl" neutrum  ;
  puts_nn_2_N = mkN "puts" neutrum  ;
  pusskalas_nn_1_N = mkN "pusskalas" neutrum  ;
  pussel_nn_1_N = mkN "pussel" neutrum  ;
  purgativ_nn_1_N = mkN "purgativ" neutrum  ;
  punkthus_nn_1_N = mkN "punkthus" neutrum  ;
  pund_nn_1_N = mkN "pund" neutrum  ;
  psi_nn_1_N = mkN "psi" neutrum  ;
  pseudoproblem_nn_1_N = mkN "pseudoproblem" neutrum  ;
  praestcelibat_nn_1_1_N = mkN "prästcelibat" neutrum  ;
  provglas_nn_1_N = mkN "provglas" neutrum  ;
  prov_nn_2_N = mkN "prov" neutrum  ;
  pronomen_nn_1_N = mkN "pronomen" neutrum  ;
  proffs_nn_1_N = mkN "proffs" neutrum  ;
  problemkomplex_nn_1_N = mkN "problemkomplex" neutrum  ;
  problem_nn_1_N = mkN "problem" neutrum  ;
  privatkapital_nn_1_N = mkN "privatkapital" neutrum  ;
  privatiseringsspektakel_nn_1_N = mkN "privatiseringsspektakel" neutrum  ;
  prisras_nn_1_N = mkN "prisras" neutrum  ;
  pris_nn_1_N = mkN "pris" neutrum  ;
  preservativ_nn_1_N = mkN "preservativ" neutrum  ;
  prerogativ_nn_1_N = mkN "prerogativ" neutrum  ;
  prepositionskasus_nn_1_N = mkN "prepositionskasus" neutrum  ;
  preparat_nn_1_N = mkN "preparat" neutrum  ;
  premiaertest_nn_1_1_N = mkN "premiärtest" neutrum  ;
  prefix_nn_1_N = mkN "prefix" neutrum  ;
  predikativ_nn_1_N = mkN "predikativ" neutrum  ;
  predikatadverbial_nn_1_N = mkN "predikatadverbial" neutrum  ;
  predikament_nn_1_N = mkN "predikament" neutrum  ;
  praktexempel_nn_1_N = mkN "praktexempel" neutrum  ;
  poaengtips_nn_1_1_N = mkN "poängtips" neutrum  ;
  poaeng_nn_1_1_N = mkN "poäng" neutrum  ;
  potatischips_nn_1_N = mkN "potatischips" neutrum  ;
  postskriptum_nn_1_N = mkN "postskriptum" neutrum  ;
  positiv_nn_1_N = mkN "positiv" neutrum  ;
  positionsljus_nn_1_N = mkN "positionsljus" neutrum  ;
  popcorn_nn_1_N = mkN "popcorn" neutrum  ;
  polynom_nn_1_N = mkN "polynom" neutrum  ;
  polishus_nn_1_N = mkN "polishus" neutrum  ;
  polhemslaas_nn_1_1_N = mkN "polhemslås" neutrum  ;
  poem_nn_1_N = mkN "poem" neutrum  ;
  plaaster_nn_1_1_N = mkN "plåster" neutrum  ;
  plaagoris_nn_1_1_N = mkN "plågoris" neutrum  ;
  plus_nn_1_N = mkN "plus" neutrum  ;
  pliktcelibat_nn_1_N = mkN "pliktcelibat" neutrum  ;
  plenum_nn_1_N = mkN "plenum" neutrum  ;
  plektrum_nn_1_N = mkN "plektrum" neutrum  ;
  plektron_nn_1_N = mkN "plektron" neutrum  ;
  plattlaeggningsproblem_nn_1_1_N = mkN "plattläggningsproblem" neutrum  ;
  plastiktraesk_nn_1_1_N = mkN "plastikträsk" neutrum  ;
  plastglas_nn_1_N = mkN "plastglas" neutrum  ;
  planetsystem_nn_1_N = mkN "planetsystem" neutrum  ;
  pidgin_nn_1_N = mkN "pidgin" neutrum  ;
  pi_nn_1_N = mkN "pi" neutrum  ;
  phi_nn_1_N = mkN "phi" neutrum  ;
  perspektiv_nn_1_N = mkN "perspektiv" neutrum  ;
  personlighetstest_nn_1_N = mkN "personlighetstest" neutrum  ;
  personbevis_nn_1_N = mkN "personbevis" neutrum  ;
  pergament_nn_1_N = mkN "pergament" neutrum  ;
  perfektiv_nn_1_N = mkN "perfektiv" neutrum  ;
  peptid_nn_1_N = mkN "peptid" neutrum  ;
  pepparkakshus_nn_1_N = mkN "pepparkakshus" neutrum  ;
  pensum_nn_1_N = mkN "pensum" neutrum  ;
  pensionssystem_nn_1_N = mkN "pensionssystem" neutrum  ;
  penningsystem_nn_1_N = mkN "penningsystem" neutrum  ;
  pendelkaos_nn_1_N = mkN "pendelkaos" neutrum  ;
  pektin_nn_1_N = mkN "pektin" neutrum  ;
  pekfingertest_nn_1_N = mkN "pekfingertest" neutrum  ;
  pejorativ_nn_1_N = mkN "pejorativ" neutrum  ;
  patronymikon_nn_1_N = mkN "patronymikon" neutrum  ;
  patentlaas_nn_1_1_N = mkN "patentlås" neutrum  ;
  passionsepos_nn_1_N = mkN "passionsepos" neutrum  ;
  pass_nn_1_N = mkN "pass" neutrum  ;
  partylejon_nn_1_N = mkN "partylejon" neutrum  ;
  partipris_nn_1_N = mkN "partipris" neutrum  ;
  parkeringsljus_nn_1_N = mkN "parkeringsljus" neutrum  ;
  parkeringshus_nn_1_N = mkN "parkeringshus" neutrum  ;
  parhus_nn_1_N = mkN "parhus" neutrum  ;
  parasoll_nn_1_N = mkN "parasoll" neutrum  ;
  paradis_nn_1_N = mkN "paradis" neutrum  ;
  paradigm_nn_1_N = mkN "paradigm" neutrum  ;
  paradexempel_nn_1_N = mkN "paradexempel" neutrum  ;
  pansarglas_nn_1_N = mkN "pansarglas" neutrum  ;
  palmhus_nn_1_N = mkN "palmhus" neutrum  ;
  palindrom_nn_1_N = mkN "palindrom" neutrum  ;
  palats_nn_1_N = mkN "palats" neutrum  ;
  paktum_nn_1_N = mkN "paktum" neutrum  ;
  paketpris_nn_1_N = mkN "paketpris" neutrum  ;
  packhus_nn_1_N = mkN "packhus" neutrum  ;
  ovaederscentrum_nn_1_1_N = mkN "oväderscentrum" neutrum  ;
  otrohetstrassel_nn_1_N = mkN "otrohetstrassel" neutrum  ;
  oskuldsbevis_nn_1_N = mkN "oskuldsbevis" neutrum  ;
  os_nn_2_N = mkN "os" neutrum  ;
  ort_nn_3_N = mkN "ort" neutrum  ;
  orsakskomplex_nn_1_N = mkN "orsakskomplex" neutrum  ;
  orsaksadverbial_nn_1_N = mkN "orsaksadverbial" neutrum  ;
  oroscentrum_nn_1_N = mkN "oroscentrum" neutrum  ;
  ormyngel_nn_1_N = mkN "ormyngel" neutrum  ;
  original_nn_1_N = mkN "original" neutrum  ;
  ordenskapitel_nn_1_N = mkN "ordenskapitel" neutrum  ;
  orakel_nn_1_N = mkN "orakel" neutrum  ;
  opus_nn_1_N = mkN "opus" neutrum  ;
  optimum_nn_1_N = mkN "optimum" neutrum  ;
  oppkast_nn_1_N = mkN "oppkast" neutrum  ;
  opiat_nn_1_N = mkN "opiat" neutrum  ;
  operativsystem_nn_1_N = mkN "operativsystem" neutrum  ;
  operahus_nn_1_N = mkN "operahus" neutrum  ;
  onus_nn_1_N = mkN "onus" neutrum  ;
  ont_nn_2_N = mkN "ont" neutrum  ;
  omkast_nn_1_N = mkN "omkast" neutrum  ;
  omikron_nn_1_N = mkN "omikron" neutrum  ;
  omen_nn_1_N = mkN "omen" neutrum  ;
  ollontraed_nn_1_1_N = mkN "ollonträd" neutrum  ;
  oljepris_nn_1_N = mkN "oljepris" neutrum  ;
  oljelaas_nn_1_1_N = mkN "oljelås" neutrum  ;
  olivtraed_nn_1_1_N = mkN "olivträd" neutrum  ;
  oktan_nn_1_N = mkN "oktan" neutrum  ;
  offer_nn_1_N = mkN "offer" neutrum  ;
  odds_nn_1_N = mkN "odds" neutrum  ;
  observandum_nn_1_N = mkN "observandum" neutrum  ;
  objektiv_nn_1_N = mkN "objektiv" neutrum  ;
  objektglas_nn_1_N = mkN "objektglas" neutrum  ;
  o_nn_1_N = mkN "o" neutrum  ;
  noejespalats_nn_1_1_N = mkN "nöjespalats" neutrum  ;
  naadebevis_nn_1_1_N = mkN "nådebevis" neutrum  ;
  naetverksperspektiv_nn_1_1_N = mkN "nätverksperspektiv" neutrum  ;
  naest_nn_1_1_N = mkN "näst" neutrum  ;
  naesbrosk_nn_1_1_N = mkN "näsbrosk" neutrum  ;
  naes_nn_1_1_N = mkN "näs" neutrum  ;
  nyhetstest_nn_1_N = mkN "nyhetstest" neutrum  ;
  nyckelax_nn_1_N = mkN "nyckelax" neutrum  ;
  ny_nn_1_N = mkN "ny" neutrum  ;
  nutidstest_nn_1_N = mkN "nutidstest" neutrum  ;
  nuklein_nn_1_N = mkN "nuklein" neutrum  ;
  normsystem_nn_1_N = mkN "normsystem" neutrum  ;
  normalobjektiv_nn_1_N = mkN "normalobjektiv" neutrum  ;
  nomen_nn_1_N = mkN "nomen" neutrum  ;
  nomadsystem_nn_1_N = mkN "nomadsystem" neutrum  ;
  nollsuffix_nn_1_N = mkN "nollsuffix" neutrum  ;
  nollmorfem_nn_1_N = mkN "nollmorfem" neutrum  ;
  nollalternativ_nn_1_N = mkN "nollalternativ" neutrum  ;
  nobelpris_nn_1_N = mkN "nobelpris" neutrum  ;
  nitrit_nn_1_N = mkN "nitrit" neutrum  ;
  nitrat_nn_1_N = mkN "nitrat" neutrum  ;
  niotillhaallarlaas_nn_1_1_N = mkN "niotillhållarlås" neutrum  ;
  newyorkoriginal_nn_1_N = mkN "newyorkoriginal" neutrum  ;
  neutrum_nn_1_N = mkN "neutrum" neutrum  ;
  neuron_nn_1_N = mkN "neuron" neutrum  ;
  neurom_nn_1_N = mkN "neurom" neutrum  ;
  nettopris_nn_1_N = mkN "nettopris" neutrum  ;
  nervsystem_nn_1_N = mkN "nervsystem" neutrum  ;
  nersaettningsbevis_nn_1_1_N = mkN "nersättningsbevis" neutrum  ;
  neonljus_nn_1_N = mkN "neonljus" neutrum  ;
  nej_nn_1_N = mkN "nej" neutrum  ;
  negativ_nn_1_N = mkN "negativ" neutrum  ;
  nedsaettningsbevis_nn_1_1_N = mkN "nedsättningsbevis" neutrum  ;
  navigeringssystem_nn_1_N = mkN "navigeringssystem" neutrum  ;
  nattljus_nn_1_N = mkN "nattljus" neutrum  ;
  nattis_nn_2_N = mkN "nattis" neutrum  ;
  natriumsulfat_nn_1_N = mkN "natriumsulfat" neutrum  ;
  natriumnitrat_nn_1_N = mkN "natriumnitrat" neutrum  ;
  nationalitetsbevis_nn_1_N = mkN "nationalitetsbevis" neutrum  ;
  namnchiffer_nn_1_N = mkN "namnchiffer" neutrum  ;
  nakterhus_nn_1_N = mkN "nakterhus" neutrum  ;
  nafs_nn_1_N = mkN "nafs" neutrum  ;
  moerker_nn_1_1_N = mkN "mörker" neutrum  ;
  moenstringsbevis_nn_1_1_N = mkN "mönstringsbevis" neutrum  ;
  moenstergarn_nn_1_1_N = mkN "mönstergarn" neutrum  ;
  moeblemang_nn_1_1_N = mkN "möblemang" neutrum  ;
  moebelvaruhus_nn_1_1_N = mkN "möbelvaruhus" neutrum  ;
  moebeltyg_nn_1_1_N = mkN "möbeltyg" neutrum  ;
  maattsystem_nn_1_1_N = mkN "måttsystem" neutrum  ;
  maetglas_nn_1_1_N = mkN "mätglas" neutrum  ;
  maetarhus_nn_1_1_N = mkN "mätarhus" neutrum  ;
  maessoffer_nn_1_1_N = mkN "mässoffer" neutrum  ;
  maerssegel_nn_1_1_N = mkN "märssegel" neutrum  ;
  maerkgarn_nn_1_1_N = mkN "märkgarn" neutrum  ;
  maenniskooffer_nn_1_1_N = mkN "människooffer" neutrum  ;
  maenniskobroest_nn_1_1_N = mkN "människobröst" neutrum  ;
  mys_nn_1_N = mkN "mys" neutrum  ;
  myntsystem_nn_1_N = mkN "myntsystem" neutrum  ;
  myntinkast_nn_1_N = mkN "myntinkast" neutrum  ;
  my_nn_1_N = mkN "my" neutrum  ;
  mutsystem_nn_1_N = mkN "mutsystem" neutrum  ;
  muskottraed_nn_1_1_N = mkN "muskotträd" neutrum  ;
  muskedunder_nn_1_N = mkN "muskedunder" neutrum  ;
  musikalbum_nn_1_N = mkN "musikalbum" neutrum  ;
  munlaeder_nn_1_1_N = mkN "munläder" neutrum  ;
  mullbaerstraed_nn_1_1_N = mkN "mullbärsträd" neutrum  ;
  mullbaersfikontraed_nn_1_1_N = mkN "mullbärsfikonträd" neutrum  ;
  mottagningsbevis_nn_1_N = mkN "mottagningsbevis" neutrum  ;
  mott_nn_1_N = mkN "mott" neutrum  ;
  motorstativ_nn_1_N = mkN "motorstativ" neutrum  ;
  motiv_nn_1_N = mkN "motiv" neutrum  ;
  motbevis_nn_1_N = mkN "motbevis" neutrum  ;
  morgonritual_nn_1_N = mkN "morgonritual" neutrum  ;
  morgonbloss_nn_1_N = mkN "morgonbloss" neutrum  ;
  morfinpreparat_nn_1_N = mkN "morfinpreparat" neutrum  ;
  morfem_nn_1_N = mkN "morfem" neutrum  ;
  mordoffer_nn_1_N = mkN "mordoffer" neutrum  ;
  moras_nn_1_N = mkN "moras" neutrum  ;
  monokord_nn_1_N = mkN "monokord" neutrum  ;
  modus_nn_1_N = mkN "modus" neutrum  ;
  modulsystem_nn_1_N = mkN "modulsystem" neutrum  ;
  mods_nn_1_N = mkN "mods" neutrum  ;
  modem_nn_1_N = mkN "modem" neutrum  ;
  modehus_nn_1_N = mkN "modehus" neutrum  ;
  mobilvirus_nn_1_N = mkN "mobilvirus" neutrum  ;
  mobilmodem_nn_1_N = mkN "mobilmodem" neutrum  ;
  misstroendevotum_nn_1_N = mkN "misstroendevotum" neutrum  ;
  missiv_nn_1_N = mkN "missiv" neutrum  ;
  missionshus_nn_1_N = mkN "missionshus" neutrum  ;
  mirakel_nn_1_N = mkN "mirakel" neutrum  ;
  minus_nn_1_N = mkN "minus" neutrum  ;
  minnesalbum_nn_1_N = mkN "minnesalbum" neutrum  ;
  minimum_nn_1_N = mkN "minimum" neutrum  ;
  minimipris_nn_1_N = mkN "minimipris" neutrum  ;
  minimikapital_nn_1_N = mkN "minimikapital" neutrum  ;
  mingel_nn_1_N = mkN "mingel" neutrum  ;
  mineralprov_nn_1_N = mkN "mineralprov" neutrum  ;
  mindervaerdeskomplex_nn_1_1_N = mkN "mindervärdeskomplex" neutrum  ;
  miljoeproblem_nn_1_1_N = mkN "miljöproblem" neutrum  ;
  mikrooel_nn_2_1_N = mkN "mikroöl" neutrum  ;
  mikrooel_nn_1_1_N = mkN "mikroöl" neutrum  ;
  mikrokosmos_nn_1_N = mkN "mikrokosmos" neutrum  ;
  mikroklimat_nn_1_N = mkN "mikroklimat" neutrum  ;
  mexitegel_nn_1_N = mkN "mexitegel" neutrum  ;
  metersystem_nn_1_N = mkN "metersystem" neutrum  ;
  metacentrum_nn_1_N = mkN "metacentrum" neutrum  ;
  merkantilsystem_nn_1_N = mkN "merkantilsystem" neutrum  ;
  mentalsjukhus_nn_1_N = mkN "mentalsjukhus" neutrum  ;
  memorial_nn_2_N = mkN "memorial" neutrum  ;
  membrum_nn_1_N = mkN "membrum" neutrum  ;
  membran_nn_1_N = mkN "membran" neutrum  ;
  mellanoel_nn_1_1_N = mkN "mellanöl" neutrum  ;
  mellanmaalstips_nn_1_1_N = mkN "mellanmålstips" neutrum  ;
  melanom_nn_1_N = mkN "melanom" neutrum  ;
  mejl_nn_2_N = mkN "mejl" neutrum  ;
  medium_nn_2_N = mkN "medium" neutrum  ;
  medikament_nn_1_N = mkN "medikament" neutrum  ;
  medicinglas_nn_1_N = mkN "medicinglas" neutrum  ;
  medelpris_nn_1_N = mkN "medelpris" neutrum  ;
  medelhavstraed_nn_1_1_N = mkN "medelhavsträd" neutrum  ;
  medborgarhus_nn_1_N = mkN "medborgarhus" neutrum  ;
  maximum_nn_1_N = mkN "maximum" neutrum  ;
  matsmaeltningssystem_nn_1_1_N = mkN "matsmältningssystem" neutrum  ;
  matlaadetips_nn_1_1_N = mkN "matlådetips" neutrum  ;
  materialproblem_nn_1_N = mkN "materialproblem" neutrum  ;
  material_nn_1_N = mkN "material" neutrum  ;
  mat_nn_2_N = mkN "mat" neutrum  ;
  masspektrum_nn_1_N = mkN "masspektrum" neutrum  ;
  massiv_nn_1_N = mkN "massiv" neutrum  ;
  masscentrum_nn_1_N = mkN "masscentrum" neutrum  ;
  marknadspris_nn_1_N = mkN "marknadspris" neutrum  ;
  maraton_nn_1_N = mkN "maraton" neutrum  ;
  manus_nn_1_N = mkN "manus" neutrum  ;
  mankemang_nn_1_N = mkN "mankemang" neutrum  ;
  manifest_nn_1_N = mkN "manifest" neutrum  ;
  mangrovetraesk_nn_1_1_N = mkN "mangroveträsk" neutrum  ;
  mamutfossil_nn_1_N = mkN "mamutfossil" neutrum  ;
  mammuttraed_nn_1_1_N = mkN "mammutträd" neutrum  ;
  malteserkors_nn_1_N = mkN "malteserkors" neutrum  ;
  maktcentrum_nn_1_N = mkN "maktcentrum" neutrum  ;
  makroklimat_nn_1_N = mkN "makroklimat" neutrum  ;
  majsoel_nn_1_1_N = mkN "majsöl" neutrum  ;
  majestaet_nn_1_1_N = mkN "majestät" neutrum  ;
  mahognylaminat_nn_1_N = mkN "mahognylaminat" neutrum  ;
  mahognyfan_er_nn_1_1_N = mkN "mahognyfanér" neutrum  ;
  magplask_nn_1_N = mkN "magplask" neutrum  ;
  magnesiumhus_nn_1_N = mkN "magnesiumhus" neutrum  ;
  loevtraed_nn_1_1_N = mkN "lövträd" neutrum  ;
  loesbladssystem_nn_1_1_N = mkN "lösbladssystem" neutrum  ;
  loenesystem_nn_1_1_N = mkN "lönesystem" neutrum  ;
  laatgaasystem_nn_1_1_N = mkN "låtgåsystem" neutrum  ;
  laangpass_nn_1_1_N = mkN "långpass" neutrum  ;
  laanghus_nn_1_1_N = mkN "långhus" neutrum  ;
  laagpris_nn_1_1_N = mkN "lågpris" neutrum  ;
  laaghus_nn_1_1_N = mkN "låghus" neutrum  ;
  laettoel_nn_1_1_N = mkN "lättöl" neutrum  ;
  laesglas_nn_1_1_N = mkN "läsglas" neutrum  ;
  laesbarhetsindex_nn_1_1_N = mkN "läsbarhetsindex" neutrum  ;
  laerlingssystem_nn_1_1_N = mkN "lärlingssystem" neutrum  ;
  laerktraed_nn_1_1_N = mkN "lärkträd" neutrum  ;
  laensresidens_nn_1_1_N = mkN "länsresidens" neutrum  ;
  laekarhus_nn_1_1_N = mkN "läkarhus" neutrum  ;
  laedertyg_nn_1_1_N = mkN "lädertyg" neutrum  ;
  laeckageproblem_nn_1_1_N = mkN "läckageproblem" neutrum  ;
  lyxproblem_nn_1_N = mkN "lyxproblem" neutrum  ;
  lystergarn_nn_1_N = mkN "lystergarn" neutrum  ;
  lysozym_nn_1_N = mkN "lysozym" neutrum  ;
  lyktglas_nn_1_N = mkN "lyktglas" neutrum  ;
  lyckorus_nn_1_N = mkN "lyckorus" neutrum  ;
  lyckorecept_nn_1_N = mkN "lyckorecept" neutrum  ;
  lyckokast_nn_1_N = mkN "lyckokast" neutrum  ;
  lusthus_nn_1_N = mkN "lusthus" neutrum  ;
  lustcentrum_nn_1_N = mkN "lustcentrum" neutrum  ;
  luntlaas_nn_1_1_N = mkN "luntlås" neutrum  ;
  lungoedem_nn_1_1_N = mkN "lungödem" neutrum  ;
  luftperspektiv_nn_1_N = mkN "luftperspektiv" neutrum  ;
  luftkonditioneringssystem_nn_1_N = mkN "luftkonditioneringssystem" neutrum  ;
  lokus_nn_1_N = mkN "lokus" neutrum  ;
  lokomotiv_nn_1_N = mkN "lokomotiv" neutrum  ;
  logglas_nn_1_N = mkN "logglas" neutrum  ;
  loggertsegel_nn_1_N = mkN "loggertsegel" neutrum  ;
  logaritmsystem_nn_1_N = mkN "logaritmsystem" neutrum  ;
  lockpris_nn_1_N = mkN "lockpris" neutrum  ;
  ljuskvantum_nn_1_N = mkN "ljuskvantum" neutrum  ;
  ljus_nn_1_N = mkN "ljus" neutrum  ;
  ljudsystem_nn_1_N = mkN "ljudsystem" neutrum  ;
  lix_nn_1_N = mkN "lix" neutrum  ;
  livstraed_nn_1_1_N = mkN "livsträd" neutrum  ;
  livspussel_nn_1_N = mkN "livspussel" neutrum  ;
  livsproblem_nn_1_N = mkN "livsproblem" neutrum  ;
  lipom_nn_1_N = mkN "lipom" neutrum  ;
  linssystem_nn_1_N = mkN "linssystem" neutrum  ;
  linjespektrum_nn_1_N = mkN "linjespektrum" neutrum  ;
  lingarn_nn_1_N = mkN "lingarn" neutrum  ;
  lillsyskon_nn_1_N = mkN "lillsyskon" neutrum  ;
  lillasyskon_nn_1_N = mkN "lillasyskon" neutrum  ;
  likoerglas_nn_1_1_N = mkN "likörglas" neutrum  ;
  lexikon_nn_1_N = mkN "lexikon" neutrum  ;
  lexem_nn_1_N = mkN "lexem" neutrum  ;
  lerras_nn_1_N = mkN "lerras" neutrum  ;
  lerkrus_nn_1_N = mkN "lerkrus" neutrum  ;
  legitimitetsproblem_nn_1_N = mkN "legitimitetsproblem" neutrum  ;
  ledsegel_nn_1_N = mkN "ledsegel" neutrum  ;
  ledmotiv_nn_1_N = mkN "ledmotiv" neutrum  ;
  ledbrosk_nn_1_N = mkN "ledbrosk" neutrum  ;
  led_nn_2_N = mkN "led" neutrum  ;
  laxyngel_nn_1_N = mkN "laxyngel" neutrum  ;
  laxativ_nn_1_N = mkN "laxativ" neutrum  ;
  latinsegel_nn_1_N = mkN "latinsegel" neutrum  ;
  lastbilslass_nn_1_N = mkN "lastbilslass" neutrum  ;
  lass_nn_1_N = mkN "lass" neutrum  ;
  lappkast_nn_1_N = mkN "lappkast" neutrum  ;
  landshoevdingehus_nn_1_1_N = mkN "landshövdingehus" neutrum  ;
  landsarkiv_nn_1_N = mkN "landsarkiv" neutrum  ;
  lamm_nn_2_N = mkN "lamm" neutrum  ;
  lamellhus_nn_1_N = mkN "lamellhus" neutrum  ;
  lagfartsbevis_nn___N = mkN "lagfartsbevis" neutrum  ;
  lageroel_nn_1_1_N = mkN "lageröl" neutrum  ;
  lackmustest_nn_1_N = mkN "lackmustest" neutrum  ;
  lack_nn_1_N = mkN "lack" neutrum  ;
  laboratorieexperiment_nn_1_N = mkN "laboratorieexperiment" neutrum  ;
  koersbaerstraed_nn_1_1_N = mkN "körsbärsträd" neutrum  ;
  koersbaersfan_er_nn_1_1_N = mkN "körsbärsfanér" neutrum  ;
  koepcentrum_nn_1_1_N = mkN "köpcentrum" neutrum  ;
  koenshormon_nn_1_1_N = mkN "könshormon" neutrum  ;
  kaarhus_nn_1_1_N = mkN "kårhus" neutrum  ;
  kaex_nn_1_1_N = mkN "käx" neutrum  ;
  kaernvapenprov_nn_1_1_N = mkN "kärnvapenprov" neutrum  ;
  kaernhus_nn_1_1_N = mkN "kärnhus" neutrum  ;
  kaerleksmums_nn_1_1_N = mkN "kärleksmums" neutrum  ;
  kaerlekslaas_nn_1_1_N = mkN "kärlekslås" neutrum  ;
  kyskhetslaas_nn_1_1_N = mkN "kyskhetslås" neutrum  ;
  kylhus_nn_1_N = mkN "kylhus" neutrum  ;
  kvittentraed_nn_1_1_N = mkN "kvittenträd" neutrum  ;
  kvinns_nn_1_N = mkN "kvinns" neutrum  ;
  kvinnohus_nn_1_N = mkN "kvinnohus" neutrum  ;
  kvinnobroest_nn_1_1_N = mkN "kvinnobröst" neutrum  ;
  kvartssekel_nn_1_N = mkN "kvartssekel" neutrum  ;
  kvantum_nn_1_N = mkN "kvantum" neutrum  ;
  kvadratmeterpris_nn_1_N = mkN "kvadratmeterpris" neutrum  ;
  kurirpass_nn_1_N = mkN "kurirpass" neutrum  ;
  kurhus_nn_1_N = mkN "kurhus" neutrum  ;
  kungsljus_nn_1_N = mkN "kungsljus" neutrum  ;
  kungaresidens_nn_1_N = mkN "kungaresidens" neutrum  ;
  kungahus_nn_1_N = mkN "kungahus" neutrum  ;
  kundnoejdhetsindex_nn_1_1_N = mkN "kundnöjdhetsindex" neutrum  ;
  kummel_nn_1_N = mkN "kummel" neutrum  ;
  kulturhus_nn_1_N = mkN "kulturhus" neutrum  ;
  kulturcentrum_nn_1_N = mkN "kulturcentrum" neutrum  ;
  kullsyskon_nn_1_N = mkN "kullsyskon" neutrum  ;
  kraas_nn_2_1_N = mkN "krås" neutrum  ;
  kraeftkalas_nn_1_1_N = mkN "kräftkalas" neutrum  ;
  kryss_nn_1_N = mkN "kryss" neutrum  ;
  krypin_nn_1_N = mkN "krypin" neutrum  ;
  krux_nn_1_N = mkN "krux" neutrum  ;
  krus_nn_1_N = mkN "krus" neutrum  ;
  krukgods_nn_1_N = mkN "krukgods" neutrum  ;
  krucifix_nn_1_N = mkN "krucifix" neutrum  ;
  kromat_nn_1_N = mkN "kromat" neutrum  ;
  kristallsystem_nn_1_N = mkN "kristallsystem" neutrum  ;
  kristallglas_nn_1_N = mkN "kristallglas" neutrum  ;
  kreditiv_nn_1_N = mkN "kreditiv" neutrum  ;
  krax_nn_1_N = mkN "krax" neutrum  ;
  krakel_nn_1_N = mkN "krakel" neutrum  ;
  kraftcentrum_nn_1_N = mkN "kraftcentrum" neutrum  ;
  kosmos_nn_1_N = mkN "kosmos" neutrum  ;
  korus_nn_1_N = mkN "korus" neutrum  ;
  korum_nn_1_N = mkN "korum" neutrum  ;
  korthus_nn_1_N = mkN "korthus" neutrum  ;
  korsvirkeshus_nn_1_N = mkN "korsvirkeshus" neutrum  ;
  kors_nn_1_N = mkN "kors" neutrum  ;
  korridorsystem_nn_1_N = mkN "korridorsystem" neutrum  ;
  korrektiv_nn_1_N = mkN "korrektiv" neutrum  ;
  koppel_nn_1_N = mkN "koppel" neutrum  ;
  koordinatsystem_nn_1_N = mkN "koordinatsystem" neutrum  ;
  kooperativ_nn_1_N = mkN "kooperativ" neutrum  ;
  konversationslexikon_nn_1_N = mkN "konversationslexikon" neutrum  ;
  konungahus_nn_1_N = mkN "konungahus" neutrum  ;
  kontorshus_nn_1_N = mkN "kontorshus" neutrum  ;
  kontinuum_nn_1_N = mkN "kontinuum" neutrum  ;
  konsumentprisindex_nn_1_N = mkN "konsumentprisindex" neutrum  ;
  konsumentpris_nn_1_N = mkN "konsumentpris" neutrum  ;
  konstruktionslexikon_nn_1_N = mkN "konstruktionslexikon" neutrum  ;
  konstgraes_nn_1_1_N = mkN "konstgräs" neutrum  ;
  konsonantsystem_nn_1_N = mkN "konsonantsystem" neutrum  ;
  konserthus_nn_1_N = mkN "konserthus" neutrum  ;
  konfliktvarsel_nn_1_N = mkN "konfliktvarsel" neutrum  ;
  kondis_nn_1_N = mkN "kondis" neutrum  ;
  koncept_nn_1_N = mkN "koncept" neutrum  ;
  komplex_nn_1_N = mkN "komplex" neutrum  ;
  kompletteringstest_nn_1_N = mkN "kompletteringstest" neutrum  ;
  komplementsystem_nn_1_N = mkN "komplementsystem" neutrum  ;
  kompasshus_nn_1_N = mkN "kompasshus" neutrum  ;
  kommunalhus_nn_1_N = mkN "kommunalhus" neutrum  ;
  kombinationslaas_nn_1_1_N = mkN "kombinationslås" neutrum  ;
  kollokat_nn_1_N = mkN "kollokat" neutrum  ;
  kollektivhus_nn_1_N = mkN "kollektivhus" neutrum  ;
  kollektiv_nn_1_N = mkN "kollektiv" neutrum  ;
  kolhydrat_nn_1_N = mkN "kolhydrat" neutrum  ;
  kolatraed_nn_1_1_N = mkN "kolaträd" neutrum  ;
  kol_nn_1_N = mkN "kol" neutrum  ;
  kodlaas_nn_1_1_N = mkN "kodlås" neutrum  ;
  knytkalas_nn_1_N = mkN "knytkalas" neutrum  ;
  knyst_nn_1_N = mkN "knyst" neutrum  ;
  knott_nn_1_N = mkN "knott" neutrum  ;
  klaettertraed_nn_1_1_N = mkN "klätterträd" neutrum  ;
  klys_nn_1_N = mkN "klys" neutrum  ;
  klorat_nn_1_N = mkN "klorat" neutrum  ;
  klipptempel_nn_1_N = mkN "klipptempel" neutrum  ;
  klippmassiv_nn_1_N = mkN "klippmassiv" neutrum  ;
  klippljus_nn_1_N = mkN "klippljus" neutrum  ;
  klinhus_nn_1_N = mkN "klinhus" neutrum  ;
  klimatsystem_nn_1_N = mkN "klimatsystem" neutrum  ;
  klimatalarm_nn_1_N = mkN "klimatalarm" neutrum  ;
  klicklaas_nn_1_1_N = mkN "klicklås" neutrum  ;
  klenhus_nn_1_N = mkN "klenhus" neutrum  ;
  klatratkomplex_nn_1_N = mkN "klatratkomplex" neutrum  ;
  kilopris_nn_1_N = mkN "kilopris" neutrum  ;
  kex_nn_1_N = mkN "kex" neutrum  ;
  kedjehus_nn_1_N = mkN "kedjehus" neutrum  ;
  kautschuktraed_nn_1_1_N = mkN "kautschukträd" neutrum  ;
  katalogpris_nn_1_N = mkN "katalogpris" neutrum  ;
  kasus_nn_1_N = mkN "kasus" neutrum  ;
  kastanjetraed_nn_1_1_N = mkN "kastanjeträd" neutrum  ;
  kast_nn_2_N = mkN "kast" neutrum  ;
  kassakreditiv_nn_1_N = mkN "kassakreditiv" neutrum  ;
  karriaertips_nn_1_1_N = mkN "karriärtips" neutrum  ;
  karnapp_nn_1_N = mkN "karnapp" neutrum  ;
  karnap_nn_1_N = mkN "karnap" neutrum  ;
  karcinom_nn_1_N = mkN "karcinom" neutrum  ;
  karbonat_nn_1_N = mkN "karbonat" neutrum  ;
  karat_nn_1_N = mkN "karat" neutrum  ;
  kapitael_nn_1_1_N = mkN "kapitäl" neutrum  ;
  kapitel_nn_1_N = mkN "kapitel" neutrum  ;
  kannbrosk_nn_1_N = mkN "kannbrosk" neutrum  ;
  kanalsystem_nn_1_N = mkN "kanalsystem" neutrum  ;
  kanalljus_nn_1_N = mkN "kanalljus" neutrum  ;
  kampeschtraed_nn_1_1_N = mkN "kampeschträd" neutrum  ;
  kampegraes_nn_1_1_N = mkN "kampegräs" neutrum  ;
  kamerastativ_nn_1_N = mkN "kamerastativ" neutrum  ;
  kameraobjektiv_nn_1_N = mkN "kameraobjektiv" neutrum  ;
  kallhus_nn_1_N = mkN "kallhus" neutrum  ;
  kalas_nn_1_N = mkN "kalas" neutrum  ;
  kakelfix_nn_1_N = mkN "kakelfix" neutrum  ;
  kakel_nn_1_N = mkN "kakel" neutrum  ;
  kakaotraed_nn_1_1_N = mkN "kakaoträd" neutrum  ;
  kaffetraed_nn_1_1_N = mkN "kaffeträd" neutrum  ;
  kaffekalas_nn_1_N = mkN "kaffekalas" neutrum  ;
  kaffehus_nn_1_N = mkN "kaffehus" neutrum  ;
  kadersystem_nn_1_N = mkN "kadersystem" neutrum  ;
  kabinettspass_nn_1_N = mkN "kabinettspass" neutrum  ;
  jaevulskap_nn_1_1_N = mkN "jävulskap" neutrum  ;
  jaevelskap_nn_1_1_N = mkN "jävelskap" neutrum  ;
  jaetteplask_nn_1_1_N = mkN "jätteplask" neutrum  ;
  jaettekast_nn_1_1_N = mkN "jättekast" neutrum  ;
  jaetteexperiment_nn_1_1_N = mkN "jätteexperiment" neutrum  ;
  jaestextrakt_nn_1_1_N = mkN "jästextrakt" neutrum  ;
  jaernvaegsstaengsel_nn_1_1_N = mkN "järnvägsstängsel" neutrum  ;
  jaernkors_nn_1_1_N = mkN "järnkors" neutrum  ;
  jaemfoerpris_nn_1_1_N = mkN "jämförpris" neutrum  ;
  jungfrubroest_nn_1_1_N = mkN "jungfrubröst" neutrum  ;
  julmys_nn_1_N = mkN "julmys" neutrum  ;
  julmotiv_nn_1_N = mkN "julmotiv" neutrum  ;
  julljus_nn_1_N = mkN "julljus" neutrum  ;
  julklappstips_nn_1_N = mkN "julklappstips" neutrum  ;
  julgransljus_nn_1_N = mkN "julgransljus" neutrum  ;
  juleljus_nn_1_N = mkN "juleljus" neutrum  ;
  jordagods_nn_1_N = mkN "jordagods" neutrum  ;
  johannitkors_nn_1_N = mkN "johannitkors" neutrum  ;
  johanniterkors_nn_1_N = mkN "johanniterkors" neutrum  ;
  isooktan_nn_1_N = mkN "isooktan" neutrum  ;
  isolerglas_nn_1_N = mkN "isolerglas" neutrum  ;
  isolat_nn_1_N = mkN "isolat" neutrum  ;
  irrbloss_nn_1_N = mkN "irrbloss" neutrum  ;
  invektiv_nn_1_N = mkN "invektiv" neutrum  ;
  intervjuoffer_nn_1_N = mkN "intervjuoffer" neutrum  ;
  intervall_nn_1_N = mkN "intervall" neutrum  ;
  internetforum_nn_1_N = mkN "internetforum" neutrum  ;
  interimsbevis_nn_1_N = mkN "interimsbevis" neutrum  ;
  intelligenstest_nn_1_N = mkN "intelligenstest" neutrum  ;
  insegel_nn_1_N = mkN "insegel" neutrum  ;
  inresevisum_nn_1_N = mkN "inresevisum" neutrum  ;
  inpass_nn_1_N = mkN "inpass" neutrum  ;
  inkoepspris_nn_1_1_N = mkN "inköpspris" neutrum  ;
  inkomstintervall_nn_1_N = mkN "inkomstintervall" neutrum  ;
  inkast_nn_1_N = mkN "inkast" neutrum  ;
  initiativ_nn_1_N = mkN "initiativ" neutrum  ;
  infix_nn_1_N = mkN "infix" neutrum  ;
  individ_nn_1_N = mkN "individ" neutrum  ;
  index_nn_1_N = mkN "index" neutrum  ;
  imperativ_nn_2_N = mkN "imperativ" neutrum  ;
  id_espektrum_nn_1_1_N = mkN "idéspektrum" neutrum  ;
  idiom_nn_1_N = mkN "idiom" neutrum  ;
  i_nn_1_N = mkN "i" neutrum  ;
  hoernhus_nn_1_1_N = mkN "hörnhus" neutrum  ;
  hoenshus_nn_1_1_N = mkN "hönshus" neutrum  ;
  hoens_nn_1_1_N = mkN "höns" neutrum  ;
  hoeghus_nn_1_1_N = mkN "höghus" neutrum  ;
  haarkors_nn_1_1_N = mkN "hårkors" neutrum  ;
  haestlass_nn_1_1_N = mkN "hästlass" neutrum  ;
  haenglaas_nn_1_1_N = mkN "hänglås" neutrum  ;
  haengbroest_nn_1_1_N = mkN "hängbröst" neutrum  ;
  haemtpris_nn_1_1_N = mkN "hämtpris" neutrum  ;
  haelsningsritual_nn_1_1_N = mkN "hälsningsritual" neutrum  ;
  haeftplaaster_nn_1_1_N = mkN "häftplåster" neutrum  ;
  hyss_nn_1_N = mkN "hyss" neutrum  ;
  hyreshus_nn_1_N = mkN "hyreshus" neutrum  ;
  hypofyshormon_nn_1_N = mkN "hypofyshormon" neutrum  ;
  hydrat_nn_1_N = mkN "hydrat" neutrum  ;
  huvudmotiv_nn_1_N = mkN "huvudmotiv" neutrum  ;
  husras_nn_1_N = mkN "husras" neutrum  ;
  huskors_nn_1_N = mkN "huskors" neutrum  ;
  husbloss_nn_1_N = mkN "husbloss" neutrum  ;
  hus_nn_1_N = mkN "hus" neutrum  ;
  hundkaex_nn_2_1_N = mkN "hundkäx" neutrum  ;
  hundkex_nn_1_N = mkN "hundkex" neutrum  ;
  hotellkomplex_nn_1_N = mkN "hotellkomplex" neutrum  ;
  host_nn_2_N = mkN "host" neutrum  ;
  hospits_nn_1_N = mkN "hospits" neutrum  ;
  hospis_nn_1_N = mkN "hospis" neutrum  ;
  hormonsystem_nn_1_N = mkN "hormonsystem" neutrum  ;
  hormon_nn_1_N = mkN "hormon" neutrum  ;
  horisontproblem_nn_1_N = mkN "horisontproblem" neutrum  ;
  horhus_nn_1_N = mkN "horhus" neutrum  ;
  hjullaas_nn_1_1_N = mkN "hjullås" neutrum  ;
  hjulkors_nn_1_N = mkN "hjulkors" neutrum  ;
  hjulhus_nn_1_N = mkN "hjulhus" neutrum  ;
  hjortron_nn_1_N = mkN "hjortron" neutrum  ;
  hindutempel_nn_1_N = mkN "hindutempel" neutrum  ;
  hemvist_nn_1_N = mkN "hemvist" neutrum  ;
  hemlighus_nn_1_N = mkN "hemlighus" neutrum  ;
  helsyskon_nn_1_N = mkN "helsyskon" neutrum  ;
  helljus_nn_1_N = mkN "helljus" neutrum  ;
  hektar_nn_1_N = mkN "hektar" neutrum  ;
  hednatempel_nn_1_N = mkN "hednatempel" neutrum  ;
  hederspris_nn_1_N = mkN "hederspris" neutrum  ;
  havsmotiv_nn_1_N = mkN "havsmotiv" neutrum  ;
  harnesk_nn_1_N = mkN "harnesk" neutrum  ;
  handlingsalternativ_nn_1_N = mkN "handlingsalternativ" neutrum  ;
  handlexikon_nn_1_N = mkN "handlexikon" neutrum  ;
  handelshus_nn_1_N = mkN "handelshus" neutrum  ;
  handeksem_nn_1_N = mkN "handeksem" neutrum  ;
  halvsyskon_nn_1_N = mkN "halvsyskon" neutrum  ;
  halvsekel_nn_1_N = mkN "halvsekel" neutrum  ;
  halvmaraton_nn_1_N = mkN "halvmaraton" neutrum  ;
  halvljus_nn_1_N = mkN "halvljus" neutrum  ;
  halvgraes_nn_1_1_N = mkN "halvgräs" neutrum  ;
  halskraas_nn_1_1_N = mkN "halskrås" neutrum  ;
  halsbloss_nn_1_N = mkN "halsbloss" neutrum  ;
  hakkors_nn_1_N = mkN "hakkors" neutrum  ;
  hagel_nn_1_N = mkN "hagel" neutrum  ;
  goet_nn_2_1_N = mkN "göt" neutrum  ;
  gaasbroest_nn_1_1_N = mkN "gåsbröst" neutrum  ;
  gaardstraed_nn_1_1_N = mkN "gårdsträd" neutrum  ;
  gaardshus_nn_1_1_N = mkN "gårdshus" neutrum  ;
  gaerdsel_nn_1_1_N = mkN "gärdsel" neutrum  ;
  gymnastikhus_nn_1_N = mkN "gymnastikhus" neutrum  ;
  gurgel_nn_1_N = mkN "gurgel" neutrum  ;
  gunstbevis_nn_1_N = mkN "gunstbevis" neutrum  ;
  gummitraed_nn_1_1_N = mkN "gummiträd" neutrum  ;
  guldpris_nn_1_N = mkN "guldpris" neutrum  ;
  gudstjaenstritual_nn_1_1_N = mkN "gudstjänstritual" neutrum  ;
  gudsbevis_nn_1_N = mkN "gudsbevis" neutrum  ;
  gubbtraesk_nn_1_1_N = mkN "gubbträsk" neutrum  ;
  gubbhus_nn_1_N = mkN "gubbhus" neutrum  ;
  graes_nn_1_1_N = mkN "gräs" neutrum  ;
  graendhus_nn_1_1_N = mkN "grändhus" neutrum  ;
  gryn_nn_1_N = mkN "gryn" neutrum  ;
  gruvras_nn_1_N = mkN "gruvras" neutrum  ;
  gruvoffer_nn_1_N = mkN "gruvoffer" neutrum  ;
  grupptest_nn_1_N = mkN "grupptest" neutrum  ;
  grupphus_nn_1_N = mkN "grupphus" neutrum  ;
  grossistpris_nn_1_N = mkN "grossistpris" neutrum  ;
  gross_nn_1_N = mkN "gross" neutrum  ;
  grodyngel_nn_1_N = mkN "grodyngel" neutrum  ;
  grenljus_nn_1_N = mkN "grenljus" neutrum  ;
  gravroes_nn_1_1_N = mkN "gravrös" neutrum  ;
  gravkummel_nn_1_N = mkN "gravkummel" neutrum  ;
  graviditetstest_nn_1_N = mkN "graviditetstest" neutrum  ;
  granatsplitter_nn_1_N = mkN "granatsplitter" neutrum  ;
  grammofonarkiv_nn_1_N = mkN "grammofonarkiv" neutrum  ;
  grafem_nn_1_N = mkN "grafem" neutrum  ;
  gotlandsruss_nn_1_N = mkN "gotlandsruss" neutrum  ;
  gomsegel_nn_1_N = mkN "gomsegel" neutrum  ;
  gods_nn_1_N = mkN "gods" neutrum  ;
  gobelaengtyg_nn_1_1_N = mkN "gobelängtyg" neutrum  ;
  gloeggtest_nn_1_1_N = mkN "glöggtest" neutrum  ;
  glaedjerus_nn_1_1_N = mkN "glädjerus" neutrum  ;
  glaedjehus_nn_1_1_N = mkN "glädjehus" neutrum  ;
  glutamat_nn_1_N = mkN "glutamat" neutrum  ;
  glossar_nn_1_N = mkN "glossar" neutrum  ;
  glashus_nn_1_N = mkN "glashus" neutrum  ;
  glas_nn_1_N = mkN "glas" neutrum  ;
  gissel_nn_1_N = mkN "gissel" neutrum  ;
  georgskors_nn_1_N = mkN "georgskors" neutrum  ;
  genusperspektiv_nn_1_N = mkN "genusperspektiv" neutrum  ;
  genus_nn_1_N = mkN "genus" neutrum  ;
  gelaenk_nn_1_1_N = mkN "gelänk" neutrum  ;
  gavelroest_nn_1_1_N = mkN "gavelröst" neutrum  ;
  gavelhus_nn_1_N = mkN "gavelhus" neutrum  ;
  gatupris_nn_1_N = mkN "gatupris" neutrum  ;
  gatukors_nn_1_N = mkN "gatukors" neutrum  ;
  gatuhus_nn_1_N = mkN "gatuhus" neutrum  ;
  gathus_nn_1_N = mkN "gathus" neutrum  ;
  garn_nn_1_N = mkN "garn" neutrum  ;
  garantibevis_nn_1_N = mkN "garantibevis" neutrum  ;
  ganglion_nn_1_N = mkN "ganglion" neutrum  ;
  galaxspektrum_nn_1_N = mkN "galaxspektrum" neutrum  ;
  galaxcentrum_nn_1_N = mkN "galaxcentrum" neutrum  ;
  gag_nn_1_N = mkN "gag" neutrum  ;
  gaffelsegel_nn_1_N = mkN "gaffelsegel" neutrum  ;
  foeraeldratraed_nn_1_1_N = mkN "föräldraträd" neutrum  ;
  foertroendevotum_nn_1_1_N = mkN "förtroendevotum" neutrum  ;
  foersaeljningspris_nn_1_1_N = mkN "försäljningspris" neutrum  ;
  foersaeljningsled_nn_1_1_N = mkN "försäljningsled" neutrum  ;
  foersaekringssystem_nn_1_1_N = mkN "försäkringssystem" neutrum  ;
  foerstoringsglas_nn_1_1_N = mkN "förstoringsglas" neutrum  ;
  foerstahandsalternativ_nn_1_1_N = mkN "förstahandsalternativ" neutrum  ;
  foersoningsoffer_nn_1_1_N = mkN "försoningsoffer" neutrum  ;
  foersegel_nn_1_1_N = mkN "försegel" neutrum  ;
  foersamlingshus_nn_1_1_N = mkN "församlingshus" neutrum  ;
  foerraadshus_nn_1_1_N = mkN "förrådshus" neutrum  ;
  foerled_nn_1_1_N = mkN "förled" neutrum  ;
  foerlagsbevis_nn_1_1_N = mkN "förlagsbevis" neutrum  ;
  foeregaangsexempel_nn_1_1_N = mkN "föregångsexempel" neutrum  ;
  foensterglas_nn_1_1_N = mkN "fönsterglas" neutrum  ;
  foeljdproblem_nn_1_1_N = mkN "följdproblem" neutrum  ;
  faarhus_nn_1_1_N = mkN "fårhus" neutrum  ;
  faagelperspektiv_nn_1_1_N = mkN "fågelperspektiv" neutrum  ;
  faerskoel_nn_1_1_N = mkN "färsköl" neutrum  ;
  faergspektrum_nn_1_1_N = mkN "färgspektrum" neutrum  ;
  faerdbevis_nn_1_1_N = mkN "färdbevis" neutrum  ;
  faengsel_nn_1_1_N = mkN "fängsel" neutrum  ;
  faeltsjukhus_nn_1_1_N = mkN "fältsjukhus" neutrum  ;
  faelthoens_nn_1_1_N = mkN "fälthöns" neutrum  ;
  faelgkors_nn_1_1_N = mkN "fälgkors" neutrum  ;
  faehus_nn_1_1_N = mkN "fähus" neutrum  ;
  fyrljus_nn_1_N = mkN "fyrljus" neutrum  ;
  fyravaaningshus_nn_1_1_N = mkN "fyravåningshus" neutrum  ;
  fyndpris_nn_1_N = mkN "fyndpris" neutrum  ;
  furstehus_nn_1_N = mkN "furstehus" neutrum  ;
  fullblodsproffs_nn_1_N = mkN "fullblodsproffs" neutrum  ;
  froetraed_nn_1_1_N = mkN "fröträd" neutrum  ;
  froehus_nn_1_1_N = mkN "fröhus" neutrum  ;
  fraagetest_nn_1_1_N = mkN "frågetest" neutrum  ;
  fraemlingspass_nn_1_1_N = mkN "främlingspass" neutrum  ;
  fraelsegods_nn_1_1_N = mkN "frälsegods" neutrum  ;
  frystest_nn_1_N = mkN "frystest" neutrum  ;
  frukttraed_nn_1_1_N = mkN "fruktträd" neutrum  ;
  fritis_nn_1_N = mkN "fritis" neutrum  ;
  fritidsproblem_nn_1_N = mkN "fritidsproblem" neutrum  ;
  fritidshus_nn_1_N = mkN "fritidshus" neutrum  ;
  fripass_nn_1_N = mkN "fripass" neutrum  ;
  frikast_nn_1_N = mkN "frikast" neutrum  ;
  fredspris_nn_1_N = mkN "fredspris" neutrum  ;
  fredagsoel_nn_1_1_N = mkN "fredagsöl" neutrum  ;
  fredagsmys_nn_1_N = mkN "fredagsmys" neutrum  ;
  fotopris_nn_1_N = mkN "fotopris" neutrum  ;
  fotbollstips_nn_1_N = mkN "fotbollstips" neutrum  ;
  fostertest_nn_1_N = mkN "fostertest" neutrum  ;
  fostersyskon_nn_1_N = mkN "fostersyskon" neutrum  ;
  fossil_nn_1_N = mkN "fossil" neutrum  ;
  fosfat_nn_1_N = mkN "fosfat" neutrum  ;
  forum_nn_1_N = mkN "forum" neutrum  ;
  formbildningsproblem_nn_1_N = mkN "formbildningsproblem" neutrum  ;
  fonem_nn_1_N = mkN "fonem" neutrum  ;
  folkoel_nn_1_1_N = mkN "folköl" neutrum  ;
  fniss_nn_1_N = mkN "fniss" neutrum  ;
  fnask_nn_1_N = mkN "fnask" neutrum  ;
  flyttlass_nn_1_N = mkN "flyttlass" neutrum  ;
  flygkaos_nn_1_N = mkN "flygkaos" neutrum  ;
  flodsystem_nn_1_N = mkN "flodsystem" neutrum  ;
  flintlaas_nn_1_1_N = mkN "flintlås" neutrum  ;
  flervaaningshus_nn_1_1_N = mkN "flervåningshus" neutrum  ;
  flervalstest_nn_1_N = mkN "flervalstest" neutrum  ;
  flerpartisystem_nn_1_N = mkN "flerpartisystem" neutrum  ;
  flerfamiljshus_nn_1_N = mkN "flerfamiljshus" neutrum  ;
  flerbostadshus_nn_1_N = mkN "flerbostadshus" neutrum  ;
  fjaerrvaermepris_nn_1_1_N = mkN "fjärrvärmepris" neutrum  ;
  fjaellpanelshus_nn_1_1_N = mkN "fjällpanelshus" neutrum  ;
  fjolaarsgraes_nn_1_1_N = mkN "fjolårsgräs" neutrum  ;
  fixativ_nn_1_N = mkN "fixativ" neutrum  ;
  fix_nn_2_N = mkN "fix" neutrum  ;
  fiskyngel_nn_1_N = mkN "fiskyngel" neutrum  ;
  filosofem_nn_1_N = mkN "filosofem" neutrum  ;
  filigran_nn_1_N = mkN "filigran" neutrum  ;
  fikontraed_nn_1_1_N = mkN "fikonträd" neutrum  ;
  fideikommiss_nn_1_N = mkN "fideikommiss" neutrum  ;
  fibrin_nn_1_N = mkN "fibrin" neutrum  ;
  fi_nn_1_N = mkN "fi" neutrum  ;
  fermat_nn_1_N = mkN "fermat" neutrum  ;
  fax_nn_2_N = mkN "fax" neutrum  ;
  fattighus_nn_1_N = mkN "fattighus" neutrum  ;
  fattigdomsbevis_nn_1_N = mkN "fattigdomsbevis" neutrum  ;
  fastlagsris_nn_1_N = mkN "fastlagsris" neutrum  ;
  fastighetspris_nn_1_N = mkN "fastighetspris" neutrum  ;
  fastighetsindex_nn_1_N = mkN "fastighetsindex" neutrum  ;
  fasadtegel_nn_1_N = mkN "fasadtegel" neutrum  ;
  fantom_nn_1_N = mkN "fantom" neutrum  ;
  familjemys_nn_1_N = mkN "familjemys" neutrum  ;
  familjegods_nn_1_N = mkN "familjegods" neutrum  ;
  familjearkiv_nn_1_N = mkN "familjearkiv" neutrum  ;
  falsklarm_nn_1_N = mkN "falsklarm" neutrum  ;
  falskalarm_nn_1_N = mkN "falskalarm" neutrum  ;
  faktum_nn_1_N = mkN "faktum" neutrum  ;
  faderskomplex_nn_1_N = mkN "faderskomplex" neutrum  ;
  fadershus_nn_1_N = mkN "fadershus" neutrum  ;
  fabrikspris_nn_1_N = mkN "fabrikspris" neutrum  ;
  extrapris_nn_1_N = mkN "extrapris" neutrum  ;
  extraljus_nn_1_N = mkN "extraljus" neutrum  ;
  extrakt_nn_1_N = mkN "extrakt" neutrum  ;
  exlibris_nn_1_N = mkN "exlibris" neutrum  ;
  existensminimum_nn_1_N = mkN "existensminimum" neutrum  ;
  exempel_nn_1_N = mkN "exempel" neutrum  ;
  exantem_nn_1_N = mkN "exantem" neutrum  ;
  ex_nn_1_N = mkN "ex" neutrum  ;
  ess_nn_1_N = mkN "ess" neutrum  ;
  epsilon_nn_1_N = mkN "epsilon" neutrum  ;
  epos_nn_1_N = mkN "epos" neutrum  ;
  epidemisjukhus_nn_1_N = mkN "epidemisjukhus" neutrum  ;
  epicentrum_nn_1_N = mkN "epicentrum" neutrum  ;
  enzymsystem_nn_1_N = mkN "enzymsystem" neutrum  ;
  enzym_nn_1_N = mkN "enzym" neutrum  ;
  envaaningshus_nn_1_1_N = mkN "envåningshus" neutrum  ;
  enris_nn_1_N = mkN "enris" neutrum  ;
  enplanshus_nn_1_N = mkN "enplanshus" neutrum  ;
  enkammarsystem_nn_1_N = mkN "enkammarsystem" neutrum  ;
  enhetspris_nn_1_N = mkN "enhetspris" neutrum  ;
  enfamiljshus_nn_1_N = mkN "enfamiljshus" neutrum  ;
  energisystem_nn_1_N = mkN "energisystem" neutrum  ;
  energiomvandlingscentrum_nn_1_N = mkN "energiomvandlingscentrum" neutrum  ;
  energialternativ_nn_1_N = mkN "energialternativ" neutrum  ;
  empyem_nn_1_N = mkN "empyem" neutrum  ;
  emfysem_nn_1_N = mkN "emfysem" neutrum  ;
  emblem_nn_1_N = mkN "emblem" neutrum  ;
  elstaengsel_nn_1_1_N = mkN "elstängsel" neutrum  ;
  eldsljus_nn_1_N = mkN "eldsljus" neutrum  ;
  eldhus_nn_1_N = mkN "eldhus" neutrum  ;
  eksem_nn_1_N = mkN "eksem" neutrum  ;
  ekosystem_nn_1_N = mkN "ekosystem" neutrum  ;
  eftermiddagspass_nn_1_N = mkN "eftermiddagspass" neutrum  ;
  efterled_nn_1_N = mkN "efterled" neutrum  ;
  efteraccept_nn_1_N = mkN "efteraccept" neutrum  ;
  ebolavirus_nn_1_N = mkN "ebolavirus" neutrum  ;
  doerrlaas_nn_1_1_N = mkN "dörrlås" neutrum  ;
  doedsoffer_nn_1_1_N = mkN "dödsoffer" neutrum  ;
  doedsbevis_nn_1_1_N = mkN "dödsbevis" neutrum  ;
  daarhus_nn_1_1_N = mkN "dårhus" neutrum  ;
  daecker_nn_1_1_N = mkN "däcker" neutrum  ;
  dyn_nn_2_N = mkN "dyn" neutrum  ;
  duralexglas_nn_1_N = mkN "duralexglas" neutrum  ;
  duodecimalsystem_nn_1_N = mkN "duodecimalsystem" neutrum  ;
  dunder_nn_1_N = mkN "dunder" neutrum  ;
  dubbelstjaernsystem_nn_1_1_N = mkN "dubbelstjärnsystem" neutrum  ;
  dryckesoffer_nn_1_N = mkN "dryckesoffer" neutrum  ;
  dryck_nn_2_N = mkN "dryck" neutrum  ;
  druvhagel_nn_1_N = mkN "druvhagel" neutrum  ;
  droppglas_nn_1_N = mkN "droppglas" neutrum  ;
  drogtest_nn_1_N = mkN "drogtest" neutrum  ;
  drivhus_nn_1_N = mkN "drivhus" neutrum  ;
  dricksglas_nn_1_N = mkN "dricksglas" neutrum  ;
  drakblodstraed_nn_1_1_N = mkN "drakblodsträd" neutrum  ;
  dragplaaster_nn_1_1_N = mkN "dragplåster" neutrum  ;
  dopningspreparat_nn_1_N = mkN "dopningspreparat" neutrum  ;
  dopingpreparat_nn_1_N = mkN "dopingpreparat" neutrum  ;
  domkapitel_nn_1_N = mkN "domkapitel" neutrum  ;
  dokumentkreditiv_nn_1_N = mkN "dokumentkreditiv" neutrum  ;
  doftljus_nn_1_N = mkN "doftljus" neutrum  ;
  dna_test_nn_1_N = mkN "dna-test" neutrum  ;
  djaevulskap_nn_1_1_N = mkN "djävulskap" neutrum  ;
  djaevelskap_nn_1_1_N = mkN "djävelskap" neutrum  ;
  djursjukhus_nn_1_N = mkN "djursjukhus" neutrum  ;
  divertissemang_nn_1_N = mkN "divertissemang" neutrum  ;
  distikon_nn_1_N = mkN "distikon" neutrum  ;
  diskussionsforum_nn_1_N = mkN "diskussionsforum" neutrum  ;
  direktiv_nn_1_N = mkN "direktiv" neutrum  ;
  diplomatpass_nn_1_N = mkN "diplomatpass" neutrum  ;
  dinatriumvaetefosfat_nn_1_1_N = mkN "dinatriumvätefosfat" neutrum  ;
  dimljus_nn_1_N = mkN "dimljus" neutrum  ;
  diffraktionsspektrum_nn_1_N = mkN "diffraktionsspektrum" neutrum  ;
  diapositiv_nn_1_N = mkN "diapositiv" neutrum  ;
  diadem_nn_1_N = mkN "diadem" neutrum  ;
  detaljpris_nn_1_N = mkN "detaljpris" neutrum  ;
  depositionsbevis_nn_1_N = mkN "depositionsbevis" neutrum  ;
  delikt_nn_1_N = mkN "delikt" neutrum  ;
  dejtingtips_nn_1_N = mkN "dejtingtips" neutrum  ;
  deficit_nn_1_N = mkN "deficit" neutrum  ;
  decimalsystem_nn_1_N = mkN "decimalsystem" neutrum  ;
  debutalbum_nn_1_N = mkN "debutalbum" neutrum  ;
  datorvirus_nn_1_N = mkN "datorvirus" neutrum  ;
  datorsystem_nn_1_N = mkN "datorsystem" neutrum  ;
  datavirus_nn_1_N = mkN "datavirus" neutrum  ;
  datalagringsdirektiv_nn_1_N = mkN "datalagringsdirektiv" neutrum  ;
  dass_nn_1_N = mkN "dass" neutrum  ;
  dagis_nn_1_N = mkN "dagis" neutrum  ;
  dagenefterpiller_nn_1_N = mkN "dagenefterpiller" neutrum  ;
  dagcentrum_nn_1_N = mkN "dagcentrum" neutrum  ;
  cylinderlaas_nn_1_1_N = mkN "cylinderlås" neutrum  ;
  cykellaas_nn_1_1_N = mkN "cykellås" neutrum  ;
  creepegarn_nn_1_1_N = mkN "crêpegarn" neutrum  ;
  cocktailglas_nn_1_N = mkN "cocktailglas" neutrum  ;
  clips_nn_1_N = mkN "clips" neutrum  ;
  cityljus_nn_1_N = mkN "cityljus" neutrum  ;
  citrontraed_nn_1_1_N = mkN "citronträd" neutrum  ;
  ciss_nn_1_N = mkN "ciss" neutrum  ;
  cirkelbevis_nn_1_N = mkN "cirkelbevis" neutrum  ;
  cirkapris_nn_1_N = mkN "cirkapris" neutrum  ;
  choklad_nn_2_N = mkN "choklad" neutrum  ;
  chips_nn_1_N = mkN "chips" neutrum  ;
  chip_nn_1_N = mkN "chip" neutrum  ;
  chiffer_nn_1_N = mkN "chiffer" neutrum  ;
  chi_nn_1_N = mkN "chi" neutrum  ;
  changemang_nn_1_N = mkN "changemang" neutrum  ;
  champagneglas_nn_1_N = mkN "champagneglas" neutrum  ;
  cerat_nn_1_N = mkN "cerat" neutrum  ;
  centrum_nn_1_N = mkN "centrum" neutrum  ;
  cenakel_nn_1_N = mkN "cenakel" neutrum  ;
  cellulosanitrat_nn_1_N = mkN "cellulosanitrat" neutrum  ;
  cellulosalack_nn_1_N = mkN "cellulosalack" neutrum  ;
  cellprov_nn_1_N = mkN "cellprov" neutrum  ;
  cellmembran_nn_1_N = mkN "cellmembran" neutrum  ;
  celibat_nn_1_N = mkN "celibat" neutrum  ;
  campus_nn_1_N = mkN "campus" neutrum  ;
  boersras_nn_1_1_N = mkN "börsras" neutrum  ;
  boerskaos_nn_1_1_N = mkN "börskaos" neutrum  ;
  boenhus_nn_1_1_N = mkN "bönhus" neutrum  ;
  boenehus_nn_1_1_N = mkN "bönehus" neutrum  ;
  baathus_nn_1_1_N = mkN "båthus" neutrum  ;
  baas_nn_1_1_N = mkN "bås" neutrum  ;
  baarhus_nn_1_1_N = mkN "bårhus" neutrum  ;
  byhus_nn_1_N = mkN "byhus" neutrum  ;
  byggvaruhus_nn_1_N = mkN "byggvaruhus" neutrum  ;
  byggpass_nn_1_N = mkN "byggpass" neutrum  ;
  byggnadskreditiv_nn_1_N = mkN "byggnadskreditiv" neutrum  ;
  byggnadskomplex_nn_1_N = mkN "byggnadskomplex" neutrum  ;
  bygellaas_nn_1_1_N = mkN "bygellås" neutrum  ;
  burhoens_nn_1_1_N = mkN "burhöns" neutrum  ;
  budgetalternativ_nn_1_N = mkN "budgetalternativ" neutrum  ;
  broest_nn_1_1_N = mkN "bröst" neutrum  ;
  braennvinsglas_nn_1_1_N = mkN "brännvinsglas" neutrum  ;
  braennoffer_nn_1_1_N = mkN "brännoffer" neutrum  ;
  braennglas_nn_1_1_N = mkN "brännglas" neutrum  ;
  braennbollskast_nn_1_1_N = mkN "brännbollskast" neutrum  ;
  brytningsindex_nn_1_N = mkN "brytningsindex" neutrum  ;
  brygghus_nn_1_N = mkN "brygghus" neutrum  ;
  bruttopris_nn_1_N = mkN "bruttopris" neutrum  ;
  brunnshus_nn_1_N = mkN "brunnshus" neutrum  ;
  brunchtest_nn_1_N = mkN "brunchtest" neutrum  ;
  bruckel_nn_1_N = mkN "bruckel" neutrum  ;
  brottsoffer_nn_1_N = mkN "brottsoffer" neutrum  ;
  brosk_nn_1_N = mkN "brosk" neutrum  ;
  brons_nn_2_N = mkN "brons" neutrum  ;
  bromssystem_nn_1_N = mkN "bromssystem" neutrum  ;
  bromsljus_nn_1_N = mkN "bromsljus" neutrum  ;
  brohus_nn_1_N = mkN "brohus" neutrum  ;
  briggsegel_nn_1_N = mkN "briggsegel" neutrum  ;
  brevinkast_nn_1_N = mkN "brevinkast" neutrum  ;
  brandsegel_nn_1_N = mkN "brandsegel" neutrum  ;
  brandoffer_nn_1_N = mkN "brandoffer" neutrum  ;
  brandlarm_nn_1_N = mkN "brandlarm" neutrum  ;
  brandalarm_nn_1_N = mkN "brandalarm" neutrum  ;
  bramsegel_nn_1_N = mkN "bramsegel" neutrum  ;
  bostadspris_nn_1_N = mkN "bostadspris" neutrum  ;
  bostadshus_nn_1_N = mkN "bostadshus" neutrum  ;
  boskapsstaengsel_nn_1_1_N = mkN "boskapsstängsel" neutrum  ;
  borstgraes_nn_1_1_N = mkN "borstgräs" neutrum  ;
  borst_nn_1_N = mkN "borst" neutrum  ;
  borgarhus_nn_1_N = mkN "borgarhus" neutrum  ;
  bordlaeggningsplenum_nn_1_1_N = mkN "bordläggningsplenum" neutrum  ;
  bopris_nn_1_N = mkN "bopris" neutrum  ;
  bonussystem_nn_1_N = mkN "bonussystem" neutrum  ;
  bonmot_nn_1_N = mkN "bonmot" neutrum  ;
  boningshus_nn_1_N = mkN "boningshus" neutrum  ;
  bondkalas_nn_1_N = mkN "bondkalas" neutrum  ;
  bomullstyg_nn_1_N = mkN "bomullstyg" neutrum  ;
  bomullsgarn_nn_1_N = mkN "bomullsgarn" neutrum  ;
  bomsegel_nn_1_N = mkN "bomsegel" neutrum  ;
  bombsplitter_nn_1_N = mkN "bombsplitter" neutrum  ;
  bomboffer_nn_1_N = mkN "bomboffer" neutrum  ;
  bollhus_nn_1_N = mkN "bollhus" neutrum  ;
  blaabaersris_nn_1_1_N = mkN "blåbärsris" neutrum  ;
  blyhagel_nn_1_N = mkN "blyhagel" neutrum  ;
  blyacetat_nn_1_N = mkN "blyacetat" neutrum  ;
  bloss_nn_1_N = mkN "bloss" neutrum  ;
  blodsystem_nn_1_N = mkN "blodsystem" neutrum  ;
  blodprov_nn_1_N = mkN "blodprov" neutrum  ;
  blocksystem_nn_1_N = mkN "blocksystem" neutrum  ;
  blockhus_nn_1_N = mkN "blockhus" neutrum  ;
  blixtlaas_nn_1_1_N = mkN "blixtlås" neutrum  ;
  blinkljus_nn_1_N = mkN "blinkljus" neutrum  ;
  bjoernbindsel_nn_1_1_N = mkN "björnbindsel" neutrum  ;
  bjoerkris_nn_1_1_N = mkN "björkris" neutrum  ;
  biyngel_nn_1_N = mkN "biyngel" neutrum  ;
  bits_nn_1_N = mkN "bits" neutrum  ;
  biskopskors_nn_1_N = mkN "biskopskors" neutrum  ;
  binom_nn_1_N = mkN "binom" neutrum  ;
  bindsel_nn_1_N = mkN "bindsel" neutrum  ;
  bilspackel_nn_1_N = mkN "bilspackel" neutrum  ;
  billaas_nn_1_1_N = mkN "billås" neutrum  ;
  billjus_nn_1_N = mkN "billjus" neutrum  ;
  biljettpris_nn_1_N = mkN "biljettpris" neutrum  ;
  biljardbollsuniversum_nn_1_N = mkN "biljardbollsuniversum" neutrum  ;
  bildkryss_nn_1_N = mkN "bildkryss" neutrum  ;
  bihus_nn_1_N = mkN "bihus" neutrum  ;
  bifokalglas_nn_1_N = mkN "bifokalglas" neutrum  ;
  bidragsfusk_nn_1_N = mkN "bidragsfusk" neutrum  ;
  bidevindsegel_nn_1_N = mkN "bidevindsegel" neutrum  ;
  bevis_nn_1_N = mkN "bevis" neutrum  ;
  bevattningssystem_nn_1_N = mkN "bevattningssystem" neutrum  ;
  betsel_nn_1_N = mkN "betsel" neutrum  ;
  betalningsbevis_nn_1_N = mkN "betalningsbevis" neutrum  ;
  beslutskaos_nn_1_N = mkN "beslutskaos" neutrum  ;
  beroendeproblem_nn_1_N = mkN "beroendeproblem" neutrum  ;
  bergsmassiv_nn_1_N = mkN "bergsmassiv" neutrum  ;
  bensinpris_nn_1_N = mkN "bensinpris" neutrum  ;
  benrangel_nn_1_N = mkN "benrangel" neutrum  ;
  benlaas_nn_1_1_N = mkN "benlås" neutrum  ;
  benhus_nn_1_N = mkN "benhus" neutrum  ;
  benbrosk_nn_1_N = mkN "benbrosk" neutrum  ;
  beloeningssystem_nn_1_1_N = mkN "belöningssystem" neutrum  ;
  behoerighetsbevis_nn_1_1_N = mkN "behörighetsbevis" neutrum  ;
  behandlingsalternativ_nn_1_N = mkN "behandlingsalternativ" neutrum  ;
  begreppssystem_nn_1_N = mkN "begreppssystem" neutrum  ;
  begravningskalas_nn_1_N = mkN "begravningskalas" neutrum  ;
  bast_nn_2_N = mkN "bast" neutrum  ;
  basketproffs_nn_1_N = mkN "basketproffs" neutrum  ;
  barrtraed_nn_1_1_N = mkN "barrträd" neutrum  ;
  barockpalats_nn_1_N = mkN "barockpalats" neutrum  ;
  barnsjukhus_nn_1_N = mkN "barnsjukhus" neutrum  ;
  barnkalas_nn_1_N = mkN "barnkalas" neutrum  ;
  barnhus_nn_1_N = mkN "barnhus" neutrum  ;
  barndomsparadis_nn_1_N = mkN "barndomsparadis" neutrum  ;
  barnboerdshus_nn_1_1_N = mkN "barnbördshus" neutrum  ;
  bariumsulfat_nn_1_N = mkN "bariumsulfat" neutrum  ;
  barbiturat_nn_1_N = mkN "barbiturat" neutrum  ;
  bankpalats_nn_1_N = mkN "bankpalats" neutrum  ;
  bankkapital_nn_1_N = mkN "bankkapital" neutrum  ;
  bankhus_nn_1_N = mkN "bankhus" neutrum  ;
  bandspektrum_nn_1_N = mkN "bandspektrum" neutrum  ;
  banantraed_nn_1_1_N = mkN "bananträd" neutrum  ;
  ballongsegel_nn_1_N = mkN "ballongsegel" neutrum  ;
  bakrus_nn_1_N = mkN "bakrus" neutrum  ;
  bakljus_nn_1_N = mkN "bakljus" neutrum  ;
  badrumskakel_nn_1_N = mkN "badrumskakel" neutrum  ;
  badhus_nn_1_N = mkN "badhus" neutrum  ;
  ax_nn_1_N = mkN "ax" neutrum  ;
  avskedskalas_nn_1_N = mkN "avskedskalas" neutrum  ;
  avloppssystem_nn_1_N = mkN "avloppssystem" neutrum  ;
  atomspektrum_nn_1_N = mkN "atomspektrum" neutrum  ;
  associationslexikon_nn_1_N = mkN "associationslexikon" neutrum  ;
  ass_nn_1_N = mkN "ass" neutrum  ;
  as_nn_1_N = mkN "as" neutrum  ;
  arsel_nn_1_N = mkN "arsel" neutrum  ;
  aromglas_nn_1_N = mkN "aromglas" neutrum  ;
  armlaas_nn_1_1_N = mkN "armlås" neutrum  ;
  armborst_nn_1_N = mkN "armborst" neutrum  ;
  arkiv_nn_1_N = mkN "arkiv" neutrum  ;
  arboretum_nn_1_N = mkN "arboretum" neutrum  ;
  arbetsprov_nn_1_N = mkN "arbetsprov" neutrum  ;
  arbetsplenum_nn_1_N = mkN "arbetsplenum" neutrum  ;
  arbetspass_nn_1_N = mkN "arbetspass" neutrum  ;
  arbetsminnestest_nn_1_N = mkN "arbetsminnestest" neutrum  ;
  arbetshus_nn_1_N = mkN "arbetshus" neutrum  ;
  ar_nn_1_N = mkN "ar" neutrum  ;
  appendix_nn_1_N = mkN "appendix" neutrum  ;
  appellativ_nn_1_N = mkN "appellativ" neutrum  ;
  apelsintraed_nn_1_1_N = mkN "apelsinträd" neutrum  ;
  apbroedstraed_nn_1_1_N = mkN "apbrödsträd" neutrum  ;
  antisladdsystem_nn_1_N = mkN "antisladdsystem" neutrum  ;
  antikljus_nn_1_N = mkN "antikljus" neutrum  ;
  annex_nn_1_N = mkN "annex" neutrum  ;
  anlagstest_nn_1_N = mkN "anlagstest" neutrum  ;
  ankbroest_nn_1_1_N = mkN "ankbröst" neutrum  ;
  ankarklys_nn_1_N = mkN "ankarklys" neutrum  ;
  andreaskors_nn_1_N = mkN "andreaskors" neutrum  ;
  andningsenzym_nn_1_N = mkN "andningsenzym" neutrum  ;
  analogibevis_nn_1_N = mkN "analogibevis" neutrum  ;
  amalgam_nn_1_N = mkN "amalgam" neutrum  ;
  alternativ_nn_1_N = mkN "alternativ" neutrum  ;
  altarkors_nn_1_N = mkN "altarkors" neutrum  ;
  allergen_nn_1_N = mkN "allergen" neutrum  ;
  alkotest_nn_1_N = mkN "alkotest" neutrum  ;
  alkolaas_nn_1_1_N = mkN "alkolås" neutrum  ;
  alkoholtest_nn_1_N = mkN "alkoholtest" neutrum  ;
  alfkors_nn_1_N = mkN "alfkors" neutrum  ;
  album_nn_1_N = mkN "album" neutrum  ;
  aktningsbevis_nn_1_N = mkN "aktningsbevis" neutrum  ;
  aktiekapital_nn_1_N = mkN "aktiekapital" neutrum  ;
  akrostikon_nn_1_N = mkN "akrostikon" neutrum  ;
  agnborst_nn_1_N = mkN "agnborst" neutrum  ;
  affaerscentrum_nn_1_1_N = mkN "affärscentrum" neutrum  ;
  affix_nn_1_N = mkN "affix" neutrum  ;
  adventsmys_nn_1_N = mkN "adventsmys" neutrum  ;
  adjektiv_nn_1_N = mkN "adjektiv" neutrum  ;
  adhd_symtom_nn_1_N = mkN "adhd-symtom" neutrum  ;
  adelsgods_nn_1_N = mkN "adelsgods" neutrum  ;
  additiv_nn_1_N = mkN "additiv" neutrum  ;
  acetat_nn_1_N = mkN "acetat" neutrum  ;
  accept_nn_1_N = mkN "accept" neutrum  ;
  acceleratorsystem_nn_1_N = mkN "acceleratorsystem" neutrum  ;
  Yalelaas_nn_1_1_N = mkN "Yalelås" neutrum  ;
  MAO_enzym_nn_1_N = mkN "MAO-enzym" neutrum  ;
  Kremldirektiv_nn_1_N = mkN "Kremldirektiv" neutrum  ;
  Ikeavaruhus_nn_1_N = mkN "Ikeavaruhus" neutrum  ;
  DNA_test_nn_1_N = mkN "DNA-test" neutrum  ;
  Antarktisprojekt_nn_1_N = mkN "Antarktisprojekt" neutrum  ;
  ADHD_symtom_nn_1_N = mkN "ADHD-symtom" neutrum  ;
  AT_laekare_nn_1_1_N = mkN "AT-läkare" utrum  ;
  CD_spelare_nn_1_N = mkN "CD-spelare" utrum  ;
  DVD_spelare_nn_1_N = mkN "DVD-spelare" utrum  ;
  Goeteborgsmaalare_nn_1_1_N = mkN "Göteborgsmålare" utrum  ;
  MP3_spelare_nn_1_N = mkN "MP3-spelare" utrum  ;
  Moskvaborgmaestare_nn_1_1_N = mkN "Moskvaborgmästare" utrum  ;
  Stureplansmoerdare_nn_1_1_N = mkN "Stureplansmördare" utrum  ;
  TV_mottagare_nn_1_N = mkN "TV-mottagare" utrum  ;
  TV_saendare_nn_1_1_N = mkN "TV-sändare" utrum  ;
  TV_tittare_nn_1_N = mkN "TV-tittare" utrum  ;
  abortmotstaandare_nn_1_1_N = mkN "abortmotståndare" utrum  ;
  affischpelare_nn_1_N = mkN "affischpelare" utrum  ;
  aktieaegare_nn_1_1_N = mkN "aktieägare" utrum  ;
  akvarellmaalare_nn_1_1_N = mkN "akvarellmålare" utrum  ;
  alfoerraedare_nn_1_1_N = mkN "alförrädare" utrum  ;
  alkoholmissbrukare_nn_1_N = mkN "alkoholmissbrukare" utrum  ;
  allmaenlaekare_nn_1_1_N = mkN "allmänläkare" utrum  ;
  allsaangsledare_nn_1_1_N = mkN "allsångsledare" utrum  ;
  allvetare_nn_1_N = mkN "allvetare" utrum  ;
  allaetare_nn_1_1_N = mkN "allätare" utrum  ;
  alpjaegare_nn_1_1_N = mkN "alpjägare" utrum  ;
  alstrare_nn_1_N = mkN "alstrare" utrum  ;
  amatoerforskare_nn_1_1_N = mkN "amatörforskare" utrum  ;
  amatoersaendare_nn_1_1_N = mkN "amatörsändare" utrum  ;
  ambassadsekreterare_nn_1_N = mkN "ambassadsekreterare" utrum  ;
  ambulansfoerare_nn_1_1_N = mkN "ambulansförare" utrum  ;
  ambulanssjukskoetare_nn_1_1_N = mkN "ambulanssjukskötare" utrum  ;
  ambulanssjukvaardare_nn_1_1_N = mkN "ambulanssjukvårdare" utrum  ;
  amerikanare_nn_1_N = mkN "amerikanare" utrum  ;
  amningsmobbare_nn_1_N = mkN "amningsmobbare" utrum  ;
  anbudsgivare_nn_1_N = mkN "anbudsgivare" utrum  ;
  andebesvaerjare_nn_1_1_N = mkN "andebesvärjare" utrum  ;
  andeskaadare_nn_1_1_N = mkN "andeskådare" utrum  ;
  andeutdrivare_nn_1_N = mkN "andeutdrivare" utrum  ;
  andraklasspassagerare_nn_1_N = mkN "andraklasspassagerare" utrum  ;
  anfallare_nn_1_N = mkN "anfallare" utrum  ;
  anfallsspelare_nn_1_N = mkN "anfallsspelare" utrum  ;
  anfoerare_nn_1_1_N = mkN "anförare" utrum  ;
  angelsachsare_nn_1_N = mkN "angelsachsare" utrum  ;
  angelsaxare_nn_1_N = mkN "angelsaxare" utrum  ;
  angivare_nn_1_N = mkN "angivare" utrum  ;
  anglosachsare_nn_1_N = mkN "anglosachsare" utrum  ;
  anglosaxare_nn_1_N = mkN "anglosaxare" utrum  ;
  angripare_nn_1_N = mkN "angripare" utrum  ;
  anhaengare_nn_1_1_N = mkN "anhängare" utrum  ;
  anklagare_nn_1_N = mkN "anklagare" utrum  ;
  anlagsbaerare_nn_1_1_N = mkN "anlagsbärare" utrum  ;
  anlaeggare_nn_1_1_N = mkN "anläggare" utrum  ;
  anlaeggningsarbetare_nn_1_1_N = mkN "anläggningsarbetare" utrum  ;
  anmaelare_nn_1_1_N = mkN "anmälare" utrum  ;
  anmaerkare_nn_1_1_N = mkN "anmärkare" utrum  ;
  annonspelare_nn_1_N = mkN "annonspelare" utrum  ;
  anordnare_nn_1_N = mkN "anordnare" utrum  ;
  anskaffare_nn_1_N = mkN "anskaffare" utrum  ;
  anstiftare_nn_1_N = mkN "anstiftare" utrum  ;
  anstrykare_nn_1_N = mkN "anstrykare" utrum  ;
  anstaellare_nn_1_1_N = mkN "anställare" utrum  ;
  antecknare_nn_1_N = mkN "antecknare" utrum  ;
  antikvitetshandlare_nn_1_N = mkN "antikvitetshandlare" utrum  ;
  anvisningslaekare_nn_1_1_N = mkN "anvisningsläkare" utrum  ;
  anvaendare_nn_1_1_N = mkN "användare" utrum  ;
  apotekare_nn_1_N = mkN "apotekare" utrum  ;
  aptitretare_nn_1_N = mkN "aptitretare" utrum  ;
  arbetare_nn_1_N = mkN "arbetare" utrum  ;
  arbetarvaeljare_nn_1_1_N = mkN "arbetarväljare" utrum  ;
  arbetsfoermedlare_nn_1_1_N = mkN "arbetsförmedlare" utrum  ;
  arbetsgivare_nn_1_N = mkN "arbetsgivare" utrum  ;
  arbetskraftsinvandrare_nn_1_N = mkN "arbetskraftsinvandrare" utrum  ;
  arbetskoepare_nn_1_1_N = mkN "arbetsköpare" utrum  ;
  arbetsledare_nn_1_N = mkN "arbetsledare" utrum  ;
  arbetstagare_nn_1_N = mkN "arbetstagare" utrum  ;
  argentinare_nn_1_N = mkN "argentinare" utrum  ;
  arkivarbetare_nn_1_N = mkN "arkivarbetare" utrum  ;
  armbaagsstraeckare_nn_1_1_N = mkN "armbågssträckare" utrum  ;
  artikelfoerfattare_nn_1_1_N = mkN "artikelförfattare" utrum  ;
  arvlaatare_nn_1_1_N = mkN "arvlåtare" utrum  ;
  arvtagare_nn_1_N = mkN "arvtagare" utrum  ;
  asbestarbetare_nn_1_N = mkN "asbestarbetare" utrum  ;
  asaetare_nn_1_1_N = mkN "asätare" utrum  ;
  atlantaangare_nn_1_1_N = mkN "atlantångare" utrum  ;
  atlasspinnare_nn_1_N = mkN "atlasspinnare" utrum  ;
  atmosfaerforskare_nn_1_1_N = mkN "atmosfärforskare" utrum  ;
  attackdykare_nn_1_N = mkN "attackdykare" utrum  ;
  auktionerare_nn_1_N = mkN "auktionerare" utrum  ;
  auktionsfoerraettare_nn_1_1_N = mkN "auktionsförrättare" utrum  ;
  auktionsutropare_nn_1_N = mkN "auktionsutropare" utrum  ;
  australiensare_nn_1_N = mkN "australiensare" utrum  ;
  autografjaegare_nn_1_1_N = mkN "autografjägare" utrum  ;
  avbitare_nn_1_N = mkN "avbitare" utrum  ;
  avbrytare_nn_1_N = mkN "avbrytare" utrum  ;
  avbytare_nn_1_N = mkN "avbytare" utrum  ;
  avdelningslaekare_nn_1_1_N = mkN "avdelningsläkare" utrum  ;
  avfuktare_nn_1_N = mkN "avfuktare" utrum  ;
  avgudadyrkare_nn_1_N = mkN "avgudadyrkare" utrum  ;
  avhoppare_nn_1_N = mkN "avhoppare" utrum  ;
  avkylare_nn_1_N = mkN "avkylare" utrum  ;
  avkaennare_nn_1_1_N = mkN "avkännare" utrum  ;
  avlastare_nn_1_N = mkN "avlastare" utrum  ;
  avledare_nn_1_N = mkN "avledare" utrum  ;
  avloppsrensare_nn_1_N = mkN "avloppsrensare" utrum  ;
  avlaeggare_nn_1_1_N = mkN "avläggare" utrum  ;
  avlaesare_nn_1_1_N = mkN "avläsare" utrum  ;
  avnaemare_nn_1_1_N = mkN "avnämare" utrum  ;
  avskrivare_nn_1_N = mkN "avskrivare" utrum  ;
  avskaerare_nn_1_1_N = mkN "avskärare" utrum  ;
  avstickare_nn_1_N = mkN "avstickare" utrum  ;
  avstaengare_nn_1_1_N = mkN "avstängare" utrum  ;
  avstaandsmaetare_nn_1_1_N = mkN "avståndsmätare" utrum  ;
  avsynare_nn_1_N = mkN "avsynare" utrum  ;
  avsaendare_nn_1_1_N = mkN "avsändare" utrum  ;
  avsoekare_nn_1_1_N = mkN "avsökare" utrum  ;
  avtalssekreterare_nn_1_N = mkN "avtalssekreterare" utrum  ;
  avtryckare_nn_1_N = mkN "avtryckare" utrum  ;
  avtraedare_nn_1_1_N = mkN "avträdare" utrum  ;
  avvikare_nn_1_N = mkN "avvikare" utrum  ;
  avvisare_nn_1_N = mkN "avvisare" utrum  ;
  babblare_nn_1_N = mkN "babblare" utrum  ;
  bacillbaerare_nn_1_1_N = mkN "bacillbärare" utrum  ;
  backhoppare_nn_1_N = mkN "backhoppare" utrum  ;
  backstugusittare_nn_1_N = mkN "backstugusittare" utrum  ;
  badare_nn_1_N = mkN "badare" utrum  ;
  baddare_nn_1_N = mkN "baddare" utrum  ;
  badensare_nn_1_N = mkN "badensare" utrum  ;
  badlaekare_nn_1_1_N = mkN "badläkare" utrum  ;
  bagare_nn_1_N = mkN "bagare" utrum  ;
  baggboelare_nn_1_1_N = mkN "baggbölare" utrum  ;
  bahrainare_nn_1_N = mkN "bahrainare" utrum  ;
  bajrare_nn_1_N = mkN "bajrare" utrum  ;
  bakblaasare_nn_1_1_N = mkN "bakblåsare" utrum  ;
  bakdantare_nn_1_N = mkN "bakdantare" utrum  ;
  bakladdare_nn_1_N = mkN "bakladdare" utrum  ;
  bakstraevare_nn_1_1_N = mkN "baksträvare" utrum  ;
  baktalare_nn_1_N = mkN "baktalare" utrum  ;
  bakaatstraevare_nn_1_1_N = mkN "bakåtsträvare" utrum  ;
  balalajkaspelare_nn_1_N = mkN "balalajkaspelare" utrum  ;
  balettmaestare_nn_1_1_N = mkN "balettmästare" utrum  ;
  balkvaegare_nn_1_1_N = mkN "balkvägare" utrum  ;
  banbrytare_nn_1_N = mkN "banbrytare" utrum  ;
  bandspelare_nn_1_N = mkN "bandspelare" utrum  ;
  banerfoerare_nn_1_1_N = mkN "banerförare" utrum  ;
  bangladeshare_nn_1_N = mkN "bangladeshare" utrum  ;
  bankomatraanare_nn_1_1_N = mkN "bankomatrånare" utrum  ;
  bankraanare_nn_1_1_N = mkN "bankrånare" utrum  ;
  bantamviktare_nn_1_N = mkN "bantamviktare" utrum  ;
  barberare_nn_1_N = mkN "barberare" utrum  ;
  barfotalaekare_nn_1_1_N = mkN "barfotaläkare" utrum  ;
  barnamoerdare_nn_1_1_N = mkN "barnamördare" utrum  ;
  barnknullare_nn_1_N = mkN "barnknullare" utrum  ;
  barnlaekare_nn_1_1_N = mkN "barnläkare" utrum  ;
  barnskoetare_nn_1_1_N = mkN "barnskötare" utrum  ;
  barnsmugglare_nn_1_N = mkN "barnsmugglare" utrum  ;
  basfiolsfodralsmakare_nn_1_N = mkN "basfiolsfodralsmakare" utrum  ;
  bassaangare_nn_1_1_N = mkN "bassångare" utrum  ;
  bataljmaalare_nn_1_1_N = mkN "bataljmålare" utrum  ;
  batteriladdare_nn_1_N = mkN "batteriladdare" utrum  ;
  batteriprovare_nn_1_N = mkN "batteriprovare" utrum  ;
  bearbetare_nn_1_N = mkN "bearbetare" utrum  ;
  bebyggare_nn_1_N = mkN "bebyggare" utrum  ;
  bedragare_nn_1_N = mkN "bedragare" utrum  ;
  bedoemare_nn_1_1_N = mkN "bedömare" utrum  ;
  befattningshavare_nn_1_N = mkN "befattningshavare" utrum  ;
  befordrare_nn_1_N = mkN "befordrare" utrum  ;
  befraktare_nn_1_N = mkN "befraktare" utrum  ;
  befriare_nn_1_N = mkN "befriare" utrum  ;
  befraemjare_nn_1_1_N = mkN "befrämjare" utrum  ;
  befaelhavare_nn_1_1_N = mkN "befälhavare" utrum  ;
  begabbare_nn_1_N = mkN "begabbare" utrum  ;
  behaallare_nn_1_1_N = mkN "behållare" utrum  ;
  beivrare_nn_1_N = mkN "beivrare" utrum  ;
  bekaempare_nn_1_1_N = mkN "bekämpare" utrum  ;
  bekaennare_nn_1_1_N = mkN "bekännare" utrum  ;
  belackare_nn_1_N = mkN "belackare" utrum  ;
  beledsagare_nn_1_N = mkN "beledsagare" utrum  ;
  belgare_nn_1_N = mkN "belgare" utrum  ;
  benknaeckare_nn_1_1_N = mkN "benknäckare" utrum  ;
  beredare_nn_1_N = mkN "beredare" utrum  ;
  bergbestigare_nn_1_N = mkN "bergbestigare" utrum  ;
  bergsbestigare_nn_1_N = mkN "bergsbestigare" utrum  ;
  bergsjaegare_nn_1_1_N = mkN "bergsjägare" utrum  ;
  bergsklaettrare_nn_1_1_N = mkN "bergsklättrare" utrum  ;
  beridare_nn_1_N = mkN "beridare" utrum  ;
  beraettare_nn_1_1_N = mkN "berättare" utrum  ;
  besegrare_nn_1_N = mkN "besegrare" utrum  ;
  besittningshavare_nn_1_N = mkN "besittningshavare" utrum  ;
  beskyddare_nn_1_N = mkN "beskyddare" utrum  ;
  beskaellare_nn_1_1_N = mkN "beskällare" utrum  ;
  beskaermare_nn_1_1_N = mkN "beskärmare" utrum  ;
  beslagare_nn_1_N = mkN "beslagare" utrum  ;
  beslutfattare_nn_1_N = mkN "beslutfattare" utrum  ;
  beslutsfattare_nn_1_N = mkN "beslutsfattare" utrum  ;
  bespottare_nn_1_N = mkN "bespottare" utrum  ;
  bestsellerfoerfattare_nn_1_1_N = mkN "bestsellerförfattare" utrum  ;
  bestaellare_nn_1_1_N = mkN "beställare" utrum  ;
  besvaerjare_nn_1_1_N = mkN "besvärjare" utrum  ;
  besoekare_nn_1_1_N = mkN "besökare" utrum  ;
  betablockerare_nn_1_N = mkN "betablockerare" utrum  ;
  betalare_nn_1_N = mkN "betalare" utrum  ;
  beteendevetare_nn_1_N = mkN "beteendevetare" utrum  ;
  beteltuggare_nn_1_N = mkN "beteltuggare" utrum  ;
  betongblandare_nn_1_N = mkN "betongblandare" utrum  ;
  betraktare_nn_1_N = mkN "betraktare" utrum  ;
  bettlare_nn_1_N = mkN "bettlare" utrum  ;
  betvingare_nn_1_N = mkN "betvingare" utrum  ;
  betygkramare_nn_1_N = mkN "betygkramare" utrum  ;
  beundrare_nn_1_N = mkN "beundrare" utrum  ;
  bidevindare_nn_1_N = mkN "bidevindare" utrum  ;
  bidevindseglare_nn_1_N = mkN "bidevindseglare" utrum  ;
  bidragsfuskare_nn_1_N = mkN "bidragsfuskare" utrum  ;
  bidragsgivare_nn_1_N = mkN "bidragsgivare" utrum  ;
  bildammsugare_nn_1_N = mkN "bildammsugare" utrum  ;
  bildhuggare_nn_1_N = mkN "bildhuggare" utrum  ;
  bildningsfoeraktare_nn_1_1_N = mkN "bildningsföraktare" utrum  ;
  bildsnidare_nn_1_N = mkN "bildsnidare" utrum  ;
  bildstormare_nn_1_N = mkN "bildstormare" utrum  ;
  bilfoerare_nn_1_1_N = mkN "bilförare" utrum  ;
  bilfoersaeljare_nn_1_1_N = mkN "bilförsäljare" utrum  ;
  bilhoegtalare_nn_1_1_N = mkN "bilhögtalare" utrum  ;
  biljettfoersaeljare_nn_1_1_N = mkN "biljettförsäljare" utrum  ;
  bilskojare_nn_1_N = mkN "bilskojare" utrum  ;
  biltillverkare_nn_1_N = mkN "biltillverkare" utrum  ;
  bilaegare_nn_1_1_N = mkN "bilägare" utrum  ;
  bindare_nn_1_N = mkN "bindare" utrum  ;
  biodlare_nn_1_N = mkN "biodlare" utrum  ;
  biograffoerestaandare_nn_1_1_N = mkN "biografföreståndare" utrum  ;
  birfilare_nn_1_N = mkN "birfilare" utrum  ;
  bisittare_nn_1_N = mkN "bisittare" utrum  ;
  bitshaallare_nn_1_1_N = mkN "bitshållare" utrum  ;
  biaetare_nn_1_1_N = mkN "biätare" utrum  ;
  bladminerare_nn_1_N = mkN "bladminerare" utrum  ;
  blandare_nn_1_N = mkN "blandare" utrum  ;
  bleckslagare_nn_1_N = mkN "bleckslagare" utrum  ;
  blindgaangare_nn_1_1_N = mkN "blindgångare" utrum  ;
  blindpassagerare_nn_1_N = mkN "blindpassagerare" utrum  ;
  blockadbrytare_nn_1_N = mkN "blockadbrytare" utrum  ;
  blodgivare_nn_1_N = mkN "blodgivare" utrum  ;
  blodledare_nn_1_N = mkN "blodledare" utrum  ;
  blodsugare_nn_1_N = mkN "blodsugare" utrum  ;
  bloggare_nn_1_N = mkN "bloggare" utrum  ;
  blomsterhandlare_nn_1_N = mkN "blomsterhandlare" utrum  ;
  blottare_nn_1_N = mkN "blottare" utrum  ;
  bluffmakare_nn_1_N = mkN "bluffmakare" utrum  ;
  blaecksuddare_nn_1_1_N = mkN "bläcksuddare" utrum  ;
  blaendare_nn_1_1_N = mkN "bländare" utrum  ;
  blaenkare_nn_1_1_N = mkN "blänkare" utrum  ;
  blaabaersplockare_nn_1_1_N = mkN "blåbärsplockare" utrum  ;
  blaasare_nn_1_1_N = mkN "blåsare" utrum  ;
  bloedare_nn_1_1_N = mkN "blödare" utrum  ;
  bogserare_nn_1_N = mkN "bogserare" utrum  ;
  bokbindare_nn_1_N = mkN "bokbindare" utrum  ;
  bokfoerare_nn_1_1_N = mkN "bokförare" utrum  ;
  bokfoerlaeggare_nn_1_1_N = mkN "bokförläggare" utrum  ;
  bokhandlare_nn_1_N = mkN "bokhandlare" utrum  ;
  bokhaallare_nn_1_1_N = mkN "bokhållare" utrum  ;
  boksamlare_nn_1_N = mkN "boksamlare" utrum  ;
  boktryckare_nn_1_N = mkN "boktryckare" utrum  ;
  bokaelskare_nn_1_1_N = mkN "bokälskare" utrum  ;
  bolagsaegare_nn_1_1_N = mkN "bolagsägare" utrum  ;
  bolare_nn_1_N = mkN "bolare" utrum  ;
  bollspelare_nn_1_N = mkN "bollspelare" utrum  ;
  bombare_nn_1_N = mkN "bombare" utrum  ;
  bomullsplockare_nn_1_N = mkN "bomullsplockare" utrum  ;
  bondfaangare_nn_1_1_N = mkN "bondfångare" utrum  ;
  bordloepare_nn_1_1_N = mkN "bordlöpare" utrum  ;
  bordsstudsare_nn_1_N = mkN "bordsstudsare" utrum  ;
  bordstudsare_nn_1_N = mkN "bordstudsare" utrum  ;
  borgare_nn_1_N = mkN "borgare" utrum  ;
  borgmaestare_nn_1_1_N = mkN "borgmästare" utrum  ;
  borstbindare_nn_1_N = mkN "borstbindare" utrum  ;
  borstviskare_nn_1_N = mkN "borstviskare" utrum  ;
  boskapsskoetare_nn_1_1_N = mkN "boskapsskötare" utrum  ;
  bostadsraettsinnehavare_nn_1_1_N = mkN "bostadsrättsinnehavare" utrum  ;
  bosaettare_nn_1_1_N = mkN "bosättare" utrum  ;
  botgoerare_nn_1_1_N = mkN "botgörare" utrum  ;
  bowlare_nn_1_N = mkN "bowlare" utrum  ;
  boxare_nn_1_N = mkN "boxare" utrum  ;
  brandslaeckare_nn_1_1_N = mkN "brandsläckare" utrum  ;
  brandvarnare_nn_1_N = mkN "brandvarnare" utrum  ;
  brasilianare_nn_1_N = mkN "brasilianare" utrum  ;
  brastaendare_nn_1_1_N = mkN "braständare" utrum  ;
  bretagnare_nn_1_N = mkN "bretagnare" utrum  ;
  brevbaerare_nn_1_1_N = mkN "brevbärare" utrum  ;
  brevskrivare_nn_1_N = mkN "brevskrivare" utrum  ;
  brevstaellare_nn_1_1_N = mkN "brevställare" utrum  ;
  brevoeppnare_nn_1_1_N = mkN "brevöppnare" utrum  ;
  brickplockare_nn_1_N = mkN "brickplockare" utrum  ;
  bromsare_nn_1_N = mkN "bromsare" utrum  ;
  bropelare_nn_1_N = mkN "bropelare" utrum  ;
  brottare_nn_1_N = mkN "brottare" utrum  ;
  brukare_nn_1_N = mkN "brukare" utrum  ;
  bruksarbetare_nn_1_N = mkN "bruksarbetare" utrum  ;
  brukslagare_nn_1_N = mkN "brukslagare" utrum  ;
  brummare_nn_1_N = mkN "brummare" utrum  ;
  bryggare_nn_1_N = mkN "bryggare" utrum  ;
  brytare_nn_1_N = mkN "brytare" utrum  ;
  braennare_nn_1_1_N = mkN "brännare" utrum  ;
  braennkammare_nn_1_1_N = mkN "brännkammare" utrum  ;
  braennvinsprovare_nn_1_1_N = mkN "brännvinsprovare" utrum  ;
  braenslemaetare_nn_1_1_N = mkN "bränslemätare" utrum  ;
  braensleomvandlare_nn_1_1_N = mkN "bränsleomvandlare" utrum  ;
  braakmakare_nn_1_1_N = mkN "bråkmakare" utrum  ;
  broestsimmare_nn_1_1_N = mkN "bröstsimmare" utrum  ;
  bubblare_nn_1_N = mkN "bubblare" utrum  ;
  budbaerare_nn_1_1_N = mkN "budbärare" utrum  ;
  budgeterare_nn_1_N = mkN "budgeterare" utrum  ;
  buktalare_nn_1_N = mkN "buktalare" utrum  ;
  bulklastare_nn_1_N = mkN "bulklastare" utrum  ;
  bunsenbraennare_nn_1_1_N = mkN "bunsenbrännare" utrum  ;
  buntmakare_nn_1_N = mkN "buntmakare" utrum  ;
  burgare_nn_1_N = mkN "burgare" utrum  ;
  burkhaallare_nn_1_1_N = mkN "burkhållare" utrum  ;
  burkoeppnare_nn_1_1_N = mkN "burköppnare" utrum  ;
  buskoerare_nn_1_1_N = mkN "buskörare" utrum  ;
  busringare_nn_1_N = mkN "busringare" utrum  ;
  bussfoerare_nn_1_1_N = mkN "bussförare" utrum  ;
  busspassagerare_nn_1_N = mkN "busspassagerare" utrum  ;
  butiksinnehavare_nn_1_N = mkN "butiksinnehavare" utrum  ;
  butiksaegare_nn_1_1_N = mkN "butiksägare" utrum  ;
  byggarbetare_nn_1_N = mkN "byggarbetare" utrum  ;
  byggare_nn_1_N = mkN "byggare" utrum  ;
  byggmaestare_nn_1_1_N = mkN "byggmästare" utrum  ;
  byggnadsarbetare_nn_1_N = mkN "byggnadsarbetare" utrum  ;
  byggnadssnickare_nn_1_N = mkN "byggnadssnickare" utrum  ;
  byraasekreterare_nn_1_1_N = mkN "byråsekreterare" utrum  ;
  bysthaallare_nn_1_1_N = mkN "bysthållare" utrum  ;
  baegare_nn_1_1_N = mkN "bägare" utrum  ;
  baeltespaennare_nn_1_1_N = mkN "bältespännare" utrum  ;
  baerare_nn_1_1_N = mkN "bärare" utrum  ;
  baergare_nn_1_1_N = mkN "bärgare" utrum  ;
  baerpelare_nn_1_1_N = mkN "bärpelare" utrum  ;
  baerplockare_nn_1_1_N = mkN "bärplockare" utrum  ;
  baestsaeljare_nn_1_1_N = mkN "bästsäljare" utrum  ;
  baarbaerare_nn_1_1_N = mkN "bårbärare" utrum  ;
  baatbyggare_nn_1_1_N = mkN "båtbyggare" utrum  ;
  boehmare_nn_1_1_N = mkN "böhmare" utrum  ;
  boejare_nn_1_1_N = mkN "böjare" utrum  ;
  boeneutropare_nn_1_1_N = mkN "böneutropare" utrum  ;
  boersjobbare_nn_1_1_N = mkN "börsjobbare" utrum  ;
  boersmaeklare_nn_1_1_N = mkN "börsmäklare" utrum  ;
  campare_nn_1_N = mkN "campare" utrum  ;
  cancerforskare_nn_1_N = mkN "cancerforskare" utrum  ;
  cd_spelare_nn_1_N = mkN "cd-spelare" utrum  ;
  cembalobyggare_nn_1_N = mkN "cembalobyggare" utrum  ;
  cementblandare_nn_1_N = mkN "cementblandare" utrum  ;
  ceremonimaestare_nn_1_1_N = mkN "ceremonimästare" utrum  ;
  chanstagare_nn_1_N = mkN "chanstagare" utrum  ;
  chefsaaklagare_nn_1_1_N = mkN "chefsåklagare" utrum  ;
  chilenare_nn_1_N = mkN "chilenare" utrum  ;
  cigarettaendare_nn_1_1_N = mkN "cigarettändare" utrum  ;
  cigarrettaendare_nn_1_1_N = mkN "cigarrettändare" utrum  ;
  cirkelledare_nn_1_N = mkN "cirkelledare" utrum  ;
  cirkulaerledare_nn_1_1_N = mkN "cirkulärledare" utrum  ;
  dagbarnvaardare_nn_1_1_N = mkN "dagbarnvårdare" utrum  ;
  dagdrivare_nn_1_N = mkN "dagdrivare" utrum  ;
  dagdroemmare_nn_1_1_N = mkN "dagdrömmare" utrum  ;
  daghemsfoerestaandare_nn_1_1_N = mkN "daghemsföreståndare" utrum  ;
  dagloenare_nn_1_1_N = mkN "daglönare" utrum  ;
  dagsverkare_nn_1_N = mkN "dagsverkare" utrum  ;
  dammsugare_nn_1_N = mkN "dammsugare" utrum  ;
  danare_nn_1_N = mkN "danare" utrum  ;
  dansare_nn_1_N = mkN "dansare" utrum  ;
  dansledare_nn_1_N = mkN "dansledare" utrum  ;
  dansmaestare_nn_1_1_N = mkN "dansmästare" utrum  ;
  datorprogrammerare_nn_1_N = mkN "datorprogrammerare" utrum  ;
  datumvisare_nn_1_N = mkN "datumvisare" utrum  ;
  debattdeltagare_nn_1_N = mkN "debattdeltagare" utrum  ;
  deckare_nn_1_N = mkN "deckare" utrum  ;
  deckarfoerfattare_nn_1_1_N = mkN "deckarförfattare" utrum  ;
  dekorationsmaalare_nn_1_1_N = mkN "dekorationsmålare" utrum  ;
  deltagare_nn_1_N = mkN "deltagare" utrum  ;
  deltidare_nn_1_N = mkN "deltidare" utrum  ;
  delaegare_nn_1_1_N = mkN "delägare" utrum  ;
  demokratifoerespraakare_nn_1_1_N = mkN "demokratiförespråkare" utrum  ;
  detaljhandlare_nn_1_N = mkN "detaljhandlare" utrum  ;
  diamantskaerare_nn_1_1_N = mkN "diamantskärare" utrum  ;
  dikare_nn_1_N = mkN "dikare" utrum  ;
  dikesgraevare_nn_1_1_N = mkN "dikesgrävare" utrum  ;
  diktare_nn_1_N = mkN "diktare" utrum  ;
  diskare_nn_1_N = mkN "diskare" utrum  ;
  diskplockare_nn_1_N = mkN "diskplockare" utrum  ;
  diskuskastare_nn_1_N = mkN "diskuskastare" utrum  ;
  distriktslaekare_nn_1_1_N = mkN "distriktsläkare" utrum  ;
  distriktsmaestare_nn_1_1_N = mkN "distriktsmästare" utrum  ;
  diversearbetare_nn_1_N = mkN "diversearbetare" utrum  ;
  djurlaekare_nn_1_1_N = mkN "djurläkare" utrum  ;
  djurplaagare_nn_1_1_N = mkN "djurplågare" utrum  ;
  djurskoetare_nn_1_1_N = mkN "djurskötare" utrum  ;
  dobblare_nn_1_N = mkN "dobblare" utrum  ;
  domare_nn_1_N = mkN "domare" utrum  ;
  doppvaermare_nn_1_1_N = mkN "doppvärmare" utrum  ;
  dosmaetare_nn_1_1_N = mkN "dosmätare" utrum  ;
  dragare_nn_1_N = mkN "dragare" utrum  ;
  drakflygare_nn_1_N = mkN "drakflygare" utrum  ;
  drinkare_nn_1_N = mkN "drinkare" utrum  ;
  drive_nn_1_N = mkN "drive" utrum  ;
  droghandlare_nn_1_N = mkN "droghandlare" utrum  ;
  drogmissbrukare_nn_1_N = mkN "drogmissbrukare" utrum  ;
  droskfoerare_nn_1_1_N = mkN "droskförare" utrum  ;
  dryckesbaegare_nn_1_1_N = mkN "dryckesbägare" utrum  ;
  draapare_nn_1_1_N = mkN "dråpare" utrum  ;
  droemmare_nn_1_1_N = mkN "drömmare" utrum  ;
  droemtydare_nn_1_1_N = mkN "drömtydare" utrum  ;
  droenare_nn_1_1_N = mkN "drönare" utrum  ;
  dubbeldaeckare_nn_1_1_N = mkN "dubbeldäckare" utrum  ;
  dubbelgaangare_nn_1_1_N = mkN "dubbelgångare" utrum  ;
  dubblare_nn_1_N = mkN "dubblare" utrum  ;
  dvd_spelare_nn_1_N = mkN "dvd-spelare" utrum  ;
  dvaergbrytare_nn_1_1_N = mkN "dvärgbrytare" utrum  ;
  dykare_nn_1_N = mkN "dykare" utrum  ;
  dynastigrundare_nn_1_N = mkN "dynastigrundare" utrum  ;
  dyngspridare_nn_1_N = mkN "dyngspridare" utrum  ;
  dyrkare_nn_1_N = mkN "dyrkare" utrum  ;
  dyvikare_nn_1_N = mkN "dyvikare" utrum  ;
  daeckhaallare_nn_1_1_N = mkN "däckhållare" utrum  ;
  daeckspassagerare_nn_1_1_N = mkN "däckspassagerare" utrum  ;
  daemmare_nn_1_1_N = mkN "dämmare" utrum  ;
  daempare_nn_1_1_N = mkN "dämpare" utrum  ;
  doeddansare_nn_1_1_N = mkN "döddansare" utrum  ;
  doedgraevare_nn_1_1_N = mkN "dödgrävare" utrum  ;
  doepare_nn_1_1_N = mkN "döpare" utrum  ;
  doerrfoersaeljare_nn_1_1_N = mkN "dörrförsäljare" utrum  ;
  doerrknackare_nn_1_1_N = mkN "dörrknackare" utrum  ;
  doerrstaengare_nn_1_1_N = mkN "dörrstängare" utrum  ;
  doerrvaktare_nn_1_1_N = mkN "dörrvaktare" utrum  ;
  doerroeppnare_nn_1_1_N = mkN "dörröppnare" utrum  ;
  e_boklaesare_nn_1_1_N = mkN "e-bokläsare" utrum  ;
  e_postare_nn_1_N = mkN "e-postare" utrum  ;
  effektfraanskiljare_nn_1_1_N = mkN "effektfrånskiljare" utrum  ;
  effektfoerstaerkare_nn_1_1_N = mkN "effektförstärkare" utrum  ;
  efterapare_nn_1_N = mkN "efterapare" utrum  ;
  efterbildare_nn_1_N = mkN "efterbildare" utrum  ;
  efterbraennare_nn_1_1_N = mkN "efterbrännare" utrum  ;
  efterfoeljare_nn_1_1_N = mkN "efterföljare" utrum  ;
  efterhaermare_nn_1_1_N = mkN "efterhärmare" utrum  ;
  efterslaentrare_nn_1_1_N = mkN "eftersläntrare" utrum  ;
  eftersaegare_nn_1_1_N = mkN "eftersägare" utrum  ;
  eftertraedare_nn_1_1_N = mkN "efterträdare" utrum  ;
  egotrippare_nn_1_N = mkN "egotrippare" utrum  ;
  ekonomifoerestaandare_nn_1_1_N = mkN "ekonomiföreståndare" utrum  ;
  ekspinnare_nn_1_N = mkN "ekspinnare" utrum  ;
  ekvecklare_nn_1_N = mkN "ekvecklare" utrum  ;
  elbilsfoerespraakare_nn_1_1_N = mkN "elbilsförespråkare" utrum  ;
  eldare_nn_1_N = mkN "eldare" utrum  ;
  eldkastare_nn_1_N = mkN "eldkastare" utrum  ;
  eldledare_nn_1_N = mkN "eldledare" utrum  ;
  eldpelare_nn_1_N = mkN "eldpelare" utrum  ;
  eldslukare_nn_1_N = mkN "eldslukare" utrum  ;
  eldslaeckare_nn_1_1_N = mkN "eldsläckare" utrum  ;
  eldslaendare_nn_1_1_N = mkN "eldsländare" utrum  ;
  eldvaktare_nn_1_N = mkN "eldvaktare" utrum  ;
  elgraesklippare_nn_1_1_N = mkN "elgräsklippare" utrum  ;
  elmutterdragare_nn_1_N = mkN "elmutterdragare" utrum  ;
  elmaetare_nn_1_1_N = mkN "elmätare" utrum  ;
  enaktare_nn_1_N = mkN "enaktare" utrum  ;
  enbyggare_nn_1_N = mkN "enbyggare" utrum  ;
  energifoerbrukare_nn_1_1_N = mkN "energiförbrukare" utrum  ;
  engelskalaerare_nn_1_1_N = mkN "engelskalärare" utrum  ;
  engelsklaerare_nn_1_1_N = mkN "engelsklärare" utrum  ;
  enkelkikare_nn_1_N = mkN "enkelkikare" utrum  ;
  enkelladdare_nn_1_N = mkN "enkelladdare" utrum  ;
  enrummare_nn_1_N = mkN "enrummare" utrum  ;
  ensamseglare_nn_1_N = mkN "ensamseglare" utrum  ;
  ensittare_nn_1_N = mkN "ensittare" utrum  ;
  envaaldshaerskare_nn_1_1_N = mkN "envåldshärskare" utrum  ;
  epostare_nn_1_N = mkN "epostare" utrum  ;
  ersaettare_nn_1_1_N = mkN "ersättare" utrum  ;
  eroevrare_nn_1_1_N = mkN "erövrare" utrum  ;
  espressobryggare_nn_1_N = mkN "espressobryggare" utrum  ;
  estlaendare_nn_1_1_N = mkN "estländare" utrum  ;
  etablissemangsfoeretraedare_nn_1_1_N = mkN "etablissemangsföreträdare" utrum  ;
  etsare_nn_1_N = mkN "etsare" utrum  ;
  europamaestare_nn_1_1_N = mkN "europamästare" utrum  ;
  expeditionsledare_nn_1_N = mkN "expeditionsledare" utrum  ;
  expertutredare_nn_1_N = mkN "expertutredare" utrum  ;
  exponeringsmaetare_nn_1_1_N = mkN "exponeringsmätare" utrum  ;
  extralaerare_nn_1_1_N = mkN "extralärare" utrum  ;
  extremskidaakare_nn_1_1_N = mkN "extremskidåkare" utrum  ;
  fabriksarbetare_nn_1_N = mkN "fabriksarbetare" utrum  ;
  fackelbaerare_nn_1_1_N = mkN "fackelbärare" utrum  ;
  fadermoerdare_nn_1_1_N = mkN "fadermördare" utrum  ;
  falkenerare_nn_1_N = mkN "falkenerare" utrum  ;
  fallskaermshoppare_nn_1_1_N = mkN "fallskärmshoppare" utrum  ;
  fallskaermsjaegare_nn_1_1_N = mkN "fallskärmsjägare" utrum  ;
  falskmyntare_nn_1_N = mkN "falskmyntare" utrum  ;
  falskspelare_nn_1_N = mkN "falskspelare" utrum  ;
  familjefoersoerjare_nn_1_1_N = mkN "familjeförsörjare" utrum  ;
  fanbaerare_nn_1_1_N = mkN "fanbärare" utrum  ;
  fanjunkare_nn_1_N = mkN "fanjunkare" utrum  ;
  farmare_nn_1_N = mkN "farmare" utrum  ;
  farthaallare_nn_1_1_N = mkN "farthållare" utrum  ;
  fastighetsmaeklare_nn_1_1_N = mkN "fastighetsmäklare" utrum  ;
  fastighetsskoetare_nn_1_1_N = mkN "fastighetsskötare" utrum  ;
  fastighetsaegare_nn_1_1_N = mkN "fastighetsägare" utrum  ;
  favoritfoerfattare_nn_1_1_N = mkN "favoritförfattare" utrum  ;
  felfinnare_nn_1_N = mkN "felfinnare" utrum  ;
  femaktare_nn_1_N = mkN "femaktare" utrum  ;
  femrummare_nn_1_N = mkN "femrummare" utrum  ;
  femtekolonnare_nn_1_N = mkN "femtekolonnare" utrum  ;
  festdeltagare_nn_1_N = mkN "festdeltagare" utrum  ;
  festfixare_nn_1_N = mkN "festfixare" utrum  ;
  festtalare_nn_1_N = mkN "festtalare" utrum  ;
  fifflare_nn_1_N = mkN "fifflare" utrum  ;
  filare_nn_1_N = mkN "filare" utrum  ;
  fildelare_nn_1_N = mkN "fildelare" utrum  ;
  filippinare_nn_1_N = mkN "filippinare" utrum  ;
  filmare_nn_1_N = mkN "filmare" utrum  ;
  filmskapare_nn_1_N = mkN "filmskapare" utrum  ;
  filmskaadespelare_nn_1_1_N = mkN "filmskådespelare" utrum  ;
  filmtecknare_nn_1_N = mkN "filmtecknare" utrum  ;
  filosofilaerare_nn_1_1_N = mkN "filosofilärare" utrum  ;
  finlaendare_nn_1_1_N = mkN "finländare" utrum  ;
  finsmakare_nn_1_N = mkN "finsmakare" utrum  ;
  finsnickare_nn_1_N = mkN "finsnickare" utrum  ;
  fiolbyggare_nn_1_N = mkN "fiolbyggare" utrum  ;
  fiolspelare_nn_1_N = mkN "fiolspelare" utrum  ;
  firmatecknare_nn_1_N = mkN "firmatecknare" utrum  ;
  fiskare_nn_1_N = mkN "fiskare" utrum  ;
  fixare_nn_1_N = mkN "fixare" utrum  ;
  fjaellpipare_nn_1_1_N = mkN "fjällpipare" utrum  ;
  fjaellvandrare_nn_1_1_N = mkN "fjällvandrare" utrum  ;
  fjaermare_nn_1_1_N = mkN "fjärmare" utrum  ;
  fjaerrskrivare_nn_1_1_N = mkN "fjärrskrivare" utrum  ;
  fjaerrskaadare_nn_1_1_N = mkN "fjärrskådare" utrum  ;
  fjaerrstroembrytare_nn_1_1_N = mkN "fjärrströmbrytare" utrum  ;
  flamlaendare_nn_1_1_N = mkN "flamländare" utrum  ;
  flaskoeppnare_nn_1_1_N = mkN "flasköppnare" utrum  ;
  flickjaegare_nn_1_1_N = mkN "flickjägare" utrum  ;
  flinare_nn_1_N = mkN "flinare" utrum  ;
  flodaangare_nn_1_1_N = mkN "flodångare" utrum  ;
  flottare_nn_1_N = mkN "flottare" utrum  ;
  flugsnappare_nn_1_N = mkN "flugsnappare" utrum  ;
  flygare_nn_1_N = mkN "flygare" utrum  ;
  flygfoerare_nn_1_1_N = mkN "flygförare" utrum  ;
  flygledare_nn_1_N = mkN "flygledare" utrum  ;
  flygpassagerare_nn_1_N = mkN "flygpassagerare" utrum  ;
  flygplanstillverkare_nn_1_N = mkN "flygplanstillverkare" utrum  ;
  folkledare_nn_1_N = mkN "folkledare" utrum  ;
  folklivsforskare_nn_1_N = mkN "folklivsforskare" utrum  ;
  folkskolelaerare_nn_1_1_N = mkN "folkskolelärare" utrum  ;
  folkskollaerare_nn_1_1_N = mkN "folkskollärare" utrum  ;
  folktalare_nn_1_N = mkN "folktalare" utrum  ;
  fondmaeklare_nn_1_1_N = mkN "fondmäklare" utrum  ;
  fordringsaegare_nn_1_1_N = mkN "fordringsägare" utrum  ;
  formare_nn_1_N = mkN "formare" utrum  ;
  formgivare_nn_1_N = mkN "formgivare" utrum  ;
  fornforskare_nn_1_N = mkN "fornforskare" utrum  ;
  forskare_nn_1_N = mkN "forskare" utrum  ;
  fortsaettare_nn_1_1_N = mkN "fortsättare" utrum  ;
  fossiljaegare_nn_1_1_N = mkN "fossiljägare" utrum  ;
  fossilletare_nn_1_N = mkN "fossilletare" utrum  ;
  fosterlandsfoerraedare_nn_1_1_N = mkN "fosterlandsförrädare" utrum  ;
  fostrare_nn_1_N = mkN "fostrare" utrum  ;
  fotbollsledare_nn_1_N = mkN "fotbollsledare" utrum  ;
  fotbollslaektare_nn_1_1_N = mkN "fotbollsläktare" utrum  ;
  fotbollsspelare_nn_1_N = mkN "fotbollsspelare" utrum  ;
  fotbollstraenare_nn_1_1_N = mkN "fotbollstränare" utrum  ;
  fotgaengare_nn_1_1_N = mkN "fotgängare" utrum  ;
  fotohandlare_nn_1_N = mkN "fotohandlare" utrum  ;
  fotvandrare_nn_1_N = mkN "fotvandrare" utrum  ;
  frambringare_nn_1_N = mkN "frambringare" utrum  ;
  framkallare_nn_1_N = mkN "framkallare" utrum  ;
  framladdare_nn_1_N = mkN "framladdare" utrum  ;
  framspelare_nn_1_N = mkN "framspelare" utrum  ;
  framtidsforskare_nn_1_N = mkN "framtidsforskare" utrum  ;
  fransklaerare_nn_1_1_N = mkN "fransklärare" utrum  ;
  frasmakare_nn_1_N = mkN "frasmakare" utrum  ;
  fredsdomare_nn_1_N = mkN "fredsdomare" utrum  ;
  fredsfoerhandlare_nn_1_1_N = mkN "fredsförhandlare" utrum  ;
  fredsmaeklare_nn_1_1_N = mkN "fredsmäklare" utrum  ;
  fredspristagare_nn_1_N = mkN "fredspristagare" utrum  ;
  fredsstiftare_nn_1_N = mkN "fredsstiftare" utrum  ;
  frestare_nn_1_N = mkN "frestare" utrum  ;
  friare_nn_1_N = mkN "friare" utrum  ;
  fribrottare_nn_1_N = mkN "fribrottare" utrum  ;
  fribytare_nn_1_N = mkN "fribytare" utrum  ;
  fridstoerare_nn_1_1_N = mkN "fridstörare" utrum  ;
  frifraesare_nn_1_1_N = mkN "frifräsare" utrum  ;
  frigoerare_nn_1_1_N = mkN "frigörare" utrum  ;
  friidrottare_nn_1_N = mkN "friidrottare" utrum  ;
  frilansare_nn_1_N = mkN "frilansare" utrum  ;
  frilansskaadespelare_nn_1_1_N = mkN "frilansskådespelare" utrum  ;
  frimurare_nn_1_N = mkN "frimurare" utrum  ;
  fripassagerare_nn_1_N = mkN "fripassagerare" utrum  ;
  frisksportare_nn_1_N = mkN "frisksportare" utrum  ;
  fritidshusaegare_nn_1_1_N = mkN "fritidshusägare" utrum  ;
  fritidsledare_nn_1_N = mkN "fritidsledare" utrum  ;
  fritaenkare_nn_1_1_N = mkN "fritänkare" utrum  ;
  frossare_nn_1_N = mkN "frossare" utrum  ;
  frukostaetare_nn_1_1_N = mkN "frukostätare" utrum  ;
  frukthandlare_nn_1_N = mkN "frukthandlare" utrum  ;
  fruktodlare_nn_1_N = mkN "fruktodlare" utrum  ;
  fruktplockare_nn_1_N = mkN "fruktplockare" utrum  ;
  fraelsare_nn_1_1_N = mkN "frälsare" utrum  ;
  fraemjare_nn_1_1_N = mkN "främjare" utrum  ;
  fraagestaellare_nn_1_1_N = mkN "frågeställare" utrum  ;
  fraanskiljare_nn_1_1_N = mkN "frånskiljare" utrum  ;
  fullbordare_nn_1_N = mkN "fullbordare" utrum  ;
  fullgoerare_nn_1_1_N = mkN "fullgörare" utrum  ;
  fullriggare_nn_1_N = mkN "fullriggare" utrum  ;
  fullaendare_nn_1_1_N = mkN "fulländare" utrum  ;
  funderare_nn_1_N = mkN "funderare" utrum  ;
  fuskare_nn_1_N = mkN "fuskare" utrum  ;
  fuskbyggare_nn_1_N = mkN "fuskbyggare" utrum  ;
  fyrarummare_nn_1_N = mkN "fyrarummare" utrum  ;
  fyrmaestare_nn_1_1_N = mkN "fyrmästare" utrum  ;
  fyrrummare_nn_1_N = mkN "fyrrummare" utrum  ;
  fyrtaktare_nn_1_N = mkN "fyrtaktare" utrum  ;
  fyrvaktare_nn_1_N = mkN "fyrvaktare" utrum  ;
  fyrverkare_nn_1_N = mkN "fyrverkare" utrum  ;
  fysikforskare_nn_1_N = mkN "fysikforskare" utrum  ;
  fysiklaerare_nn_1_1_N = mkN "fysiklärare" utrum  ;
  faektare_nn_1_1_N = mkN "fäktare" utrum  ;
  faektmaestare_nn_1_1_N = mkN "fäktmästare" utrum  ;
  faeltflygare_nn_1_1_N = mkN "fältflygare" utrum  ;
  faeltjaegare_nn_1_1_N = mkN "fältjägare" utrum  ;
  faeltkikare_nn_1_1_N = mkN "fältkikare" utrum  ;
  faerdledare_nn_1_1_N = mkN "färdledare" utrum  ;
  faerdskrivare_nn_1_1_N = mkN "färdskrivare" utrum  ;
  faergare_nn_1_1_N = mkN "färgare" utrum  ;
  faerjepassagerare_nn_1_1_N = mkN "färjepassagerare" utrum  ;
  faagelinventerare_nn_1_1_N = mkN "fågelinventerare" utrum  ;
  faagelmatare_nn_1_1_N = mkN "fågelmatare" utrum  ;
  faagelskaadare_nn_1_1_N = mkN "fågelskådare" utrum  ;
  faangvaktare_nn_1_1_N = mkN "fångvaktare" utrum  ;
  faarfarmare_nn_1_1_N = mkN "fårfarmare" utrum  ;
  foeljeslagare_nn_1_1_N = mkN "följeslagare" utrum  ;
  foensterputsare_nn_1_1_N = mkN "fönsterputsare" utrum  ;
  foenstertittare_nn_1_1_N = mkN "fönstertittare" utrum  ;
  foerare_nn_1_1_N = mkN "förare" utrum  ;
  foerbrukare_nn_1_1_N = mkN "förbrukare" utrum  ;
  foerbrytare_nn_1_1_N = mkN "förbrytare" utrum  ;
  foerdelare_nn_1_1_N = mkN "fördelare" utrum  ;
  foerdaervare_nn_1_1_N = mkN "fördärvare" utrum  ;
  foerebaadare_nn_1_1_N = mkN "förebådare" utrum  ;
  foeredragshaallare_nn_1_1_N = mkN "föredragshållare" utrum  ;
  foeregaangare_nn_1_1_N = mkN "föregångare" utrum  ;
  foerelaesare_nn_1_1_N = mkN "föreläsare" utrum  ;
  foereloepare_nn_1_1_N = mkN "förelöpare" utrum  ;
  foerespraakare_nn_1_1_N = mkN "förespråkare" utrum  ;
  foerestaellare_nn_1_1_N = mkN "föreställare" utrum  ;
  foerestaandare_nn_1_1_N = mkN "föreståndare" utrum  ;
  foeretagare_nn_1_1_N = mkN "företagare" utrum  ;
  foeretagsledare_nn_1_1_N = mkN "företagsledare" utrum  ;
  foeretraedare_nn_1_1_N = mkN "företrädare" utrum  ;
  foerevisare_nn_1_1_N = mkN "förevisare" utrum  ;
  foerfalskare_nn_1_1_N = mkN "förfalskare" utrum  ;
  foerfattare_nn_1_1_N = mkN "författare" utrum  ;
  foerfaektare_nn_1_1_N = mkN "förfäktare" utrum  ;
  foerfaerdigare_nn_1_1_N = mkN "förfärdigare" utrum  ;
  foerfoeljare_nn_1_1_N = mkN "förföljare" utrum  ;
  foerfoerare_nn_1_1_N = mkN "förförare" utrum  ;
  foergasare_nn_1_1_N = mkN "förgasare" utrum  ;
  foergyllare_nn_1_1_N = mkN "förgyllare" utrum  ;
  foerhandlare_nn_1_1_N = mkN "förhandlare" utrum  ;
  foerhaexare_nn_1_1_N = mkN "förhäxare" utrum  ;
  foerhoersledare_nn_1_1_N = mkN "förhörsledare" utrum  ;
  foerintelsefoernekare_nn_1_1_N = mkN "förintelseförnekare" utrum  ;
  foerkunnare_nn_1_1_N = mkN "förkunnare" utrum  ;
  foerledare_nn_1_1_N = mkN "förledare" utrum  ;
  foerlorare_nn_1_1_N = mkN "förlorare" utrum  ;
  foerlossare_nn_1_1_N = mkN "förlossare" utrum  ;
  foerlaeggare_nn_1_1_N = mkN "förläggare" utrum  ;
  foerlaenare_nn_1_1_N = mkN "förlänare" utrum  ;
  foerloepare_nn_1_1_N = mkN "förlöpare" utrum  ;
  foerloesare_nn_1_1_N = mkN "förlösare" utrum  ;
  foermedlare_nn_1_1_N = mkN "förmedlare" utrum  ;
  foermyndare_nn_1_1_N = mkN "förmyndare" utrum  ;
  foermaanstagare_nn_1_1_N = mkN "förmånstagare" utrum  ;
  foernekare_nn_1_1_N = mkN "förnekare" utrum  ;
  foernyare_nn_1_1_N = mkN "förnyare" utrum  ;
  foerpaktare_nn_1_1_N = mkN "förpaktare" utrum  ;
  foerraedare_nn_1_1_N = mkN "förrädare" utrum  ;
  foerraettare_nn_1_1_N = mkN "förrättare" utrum  ;
  foerskingrare_nn_1_1_N = mkN "förskingrare" utrum  ;
  foerskolelaerare_nn_1_1_N = mkN "förskolelärare" utrum  ;
  foerskollaerare_nn_1_1_N = mkN "förskollärare" utrum  ;
  foerskaerare_nn_1_1_N = mkN "förskärare" utrum  ;
  foersonare_nn_1_1_N = mkN "försonare" utrum  ;
  foerstagaangskoepare_nn_1_1_N = mkN "förstagångsköpare" utrum  ;
  foerstagaangsvaeljare_nn_1_1_N = mkN "förstagångsväljare" utrum  ;
  foerstamajtalare_nn_1_1_N = mkN "förstamajtalare" utrum  ;
  foerstaerkare_nn_1_1_N = mkN "förstärkare" utrum  ;
  foerstaasigpaaare_nn_1_1_N = mkN "förståsigpåare" utrum  ;
  foerstoerare_nn_1_1_N = mkN "förstörare" utrum  ;
  foersvarare_nn_1_1_N = mkN "försvarare" utrum  ;
  foersvarsspelare_nn_1_1_N = mkN "försvarsspelare" utrum  ;
  foersaekringsgivare_nn_1_1_N = mkN "försäkringsgivare" utrum  ;
  foersaeljare_nn_1_1_N = mkN "försäljare" utrum  ;
  foersaenkare_nn_1_1_N = mkN "försänkare" utrum  ;
  foersoeksledare_nn_1_1_N = mkN "försöksledare" utrum  ;
  foersoerjare_nn_1_1_N = mkN "försörjare" utrum  ;
  foertalare_nn_1_1_N = mkN "förtalare" utrum  ;
  foertjusare_nn_1_1_N = mkN "förtjusare" utrum  ;
  foertrollare_nn_1_1_N = mkN "förtrollare" utrum  ;
  foertryckare_nn_1_1_N = mkN "förtryckare" utrum  ;
  foerundersoekningsledare_nn_1_1_N = mkN "förundersökningsledare" utrum  ;
  foervaltare_nn_1_1_N = mkN "förvaltare" utrum  ;
  foervillare_nn_1_1_N = mkN "förvillare" utrum  ;
  foervaeljare_nn_1_1_N = mkN "förväljare" utrum  ;
  foervaermare_nn_1_1_N = mkN "förvärmare" utrum  ;
  foeroevare_nn_1_1_N = mkN "förövare" utrum  ;
  gangsterpolare_nn_1_N = mkN "gangsterpolare" utrum  ;
  garvare_nn_1_N = mkN "garvare" utrum  ;
  gasbraennare_nn_1_1_N = mkN "gasbrännare" utrum  ;
  gascognare_nn_1_N = mkN "gascognare" utrum  ;
  gatsopare_nn_1_N = mkN "gatsopare" utrum  ;
  gatufoersaeljare_nn_1_1_N = mkN "gatuförsäljare" utrum  ;
  geigermaetare_nn_1_1_N = mkN "geigermätare" utrum  ;
  gelbgjutare_nn_1_N = mkN "gelbgjutare" utrum  ;
  generalbefaelhavare_nn_1_1_N = mkN "generalbefälhavare" utrum  ;
  generalsekreterare_nn_1_N = mkN "generalsekreterare" utrum  ;
  gengaangare_nn_1_1_N = mkN "gengångare" utrum  ;
  genomkoerare_nn_1_1_N = mkN "genomkörare" utrum  ;
  genremaalare_nn_1_1_N = mkN "genremålare" utrum  ;
  gensare_nn_1_N = mkN "gensare" utrum  ;
  geovetare_nn_1_N = mkN "geovetare" utrum  ;
  gerillakrigare_nn_1_N = mkN "gerillakrigare" utrum  ;
  gerillaledare_nn_1_N = mkN "gerillaledare" utrum  ;
  germankrigare_nn_1_N = mkN "germankrigare" utrum  ;
  giftblandare_nn_1_N = mkN "giftblandare" utrum  ;
  giftbaegare_nn_1_1_N = mkN "giftbägare" utrum  ;
  giljare_nn_1_N = mkN "giljare" utrum  ;
  gisslantagare_nn_1_N = mkN "gisslantagare" utrum  ;
  gisslare_nn_1_N = mkN "gisslare" utrum  ;
  gitarrspelare_nn_1_N = mkN "gitarrspelare" utrum  ;
  givare_nn_1_N = mkN "givare" utrum  ;
  gjutare_nn_1_N = mkN "gjutare" utrum  ;
  glasblaasare_nn_1_1_N = mkN "glasblåsare" utrum  ;
  glasmaestare_nn_1_1_N = mkN "glasmästare" utrum  ;
  glasmaalare_nn_1_1_N = mkN "glasmålare" utrum  ;
  glassbaegare_nn_1_1_N = mkN "glassbägare" utrum  ;
  glasskaerare_nn_1_1_N = mkN "glasskärare" utrum  ;
  glasslipare_nn_1_N = mkN "glasslipare" utrum  ;
  glassaelskare_nn_1_1_N = mkN "glassälskare" utrum  ;
  glimtaendare_nn_1_1_N = mkN "glimtändare" utrum  ;
  glaedjedoedare_nn_1_1_N = mkN "glädjedödare" utrum  ;
  gnagare_nn_1_N = mkN "gnagare" utrum  ;
  gnidare_nn_1_N = mkN "gnidare" utrum  ;
  gnistfaangare_nn_1_1_N = mkN "gnistfångare" utrum  ;
  gnistsaendare_nn_1_1_N = mkN "gnistsändare" utrum  ;
  gnussare_nn_1_N = mkN "gnussare" utrum  ;
  godkaennare_nn_1_1_N = mkN "godkännare" utrum  ;
  godsaegare_nn_1_1_N = mkN "godsägare" utrum  ;
  godtemplare_nn_1_N = mkN "godtemplare" utrum  ;
  golfare_nn_1_N = mkN "golfare" utrum  ;
  golvlaeggare_nn_1_1_N = mkN "golvläggare" utrum  ;
  golvvaardare_nn_1_1_N = mkN "golvvårdare" utrum  ;
  gradmaetare_nn_1_1_N = mkN "gradmätare" utrum  ;
  gralsoekare_nn_1_1_N = mkN "gralsökare" utrum  ;
  granitkeramikskaerare_nn_1_1_N = mkN "granitkeramikskärare" utrum  ;
  granskare_nn_1_N = mkN "granskare" utrum  ;
  gransaangare_nn_1_1_N = mkN "gransångare" utrum  ;
  gratispassagerare_nn_1_N = mkN "gratispassagerare" utrum  ;
  gravplundrare_nn_1_N = mkN "gravplundrare" utrum  ;
  grinare_nn_1_N = mkN "grinare" utrum  ;
  grisfoesare_nn_1_1_N = mkN "grisfösare" utrum  ;
  grishandlare_nn_1_N = mkN "grishandlare" utrum  ;
  grosshandlare_nn_1_N = mkN "grosshandlare" utrum  ;
  grottforskare_nn_1_N = mkN "grottforskare" utrum  ;
  grottinnevaanare_nn_1_1_N = mkN "grottinnevånare" utrum  ;
  grottinvaanare_nn_1_1_N = mkN "grottinvånare" utrum  ;
  grovarbetare_nn_1_N = mkN "grovarbetare" utrum  ;
  grubblare_nn_1_N = mkN "grubblare" utrum  ;
  grundare_nn_1_N = mkN "grundare" utrum  ;
  grundlaeggare_nn_1_1_N = mkN "grundläggare" utrum  ;
  grundpelare_nn_1_N = mkN "grundpelare" utrum  ;
  grundskolelaerare_nn_1_1_N = mkN "grundskolelärare" utrum  ;
  gruvarbetare_nn_1_N = mkN "gruvarbetare" utrum  ;
  gruvstigare_nn_1_N = mkN "gruvstigare" utrum  ;
  graeddmaetare_nn_1_1_N = mkN "gräddmätare" utrum  ;
  graelmakare_nn_1_1_N = mkN "grälmakare" utrum  ;
  graensjaegare_nn_1_1_N = mkN "gränsjägare" utrum  ;
  graesklippare_nn_1_1_N = mkN "gräsklippare" utrum  ;
  graesaetare_nn_1_1_N = mkN "gräsätare" utrum  ;
  graevare_nn_1_1_N = mkN "grävare" utrum  ;
  groenlaendare_nn_1_1_N = mkN "grönländare" utrum  ;
  gudsfoernekare_nn_1_1_N = mkN "gudsförnekare" utrum  ;
  gudstjaenstbesoekare_nn_1_1_N = mkN "gudstjänstbesökare" utrum  ;
  guldgraevare_nn_1_1_N = mkN "guldgrävare" utrum  ;
  guldmakare_nn_1_N = mkN "guldmakare" utrum  ;
  guldslagare_nn_1_N = mkN "guldslagare" utrum  ;
  guldtaendare_nn_1_1_N = mkN "guldtändare" utrum  ;
  gycklare_nn_1_N = mkN "gycklare" utrum  ;
  gynnare_nn_1_N = mkN "gynnare" utrum  ;
  gaelbgjutare_nn_1_1_N = mkN "gälbgjutare" utrum  ;
  gaengledare_nn_1_1_N = mkN "gängledare" utrum  ;
  gaengtappshaallare_nn_1_1_N = mkN "gängtappshållare" utrum  ;
  gaestarbetare_nn_1_1_N = mkN "gästarbetare" utrum  ;
  gaestforskare_nn_1_1_N = mkN "gästforskare" utrum  ;
  gaestgivare_nn_1_1_N = mkN "gästgivare" utrum  ;
  gaangare_nn_1_1_N = mkN "gångare" utrum  ;
  gaapaaare_nn_1_1_N = mkN "gåpåare" utrum  ;
  gaardfarihandlare_nn_1_1_N = mkN "gårdfarihandlare" utrum  ;
  goedselspridare_nn_1_1_N = mkN "gödselspridare" utrum  ;
  goerare_nn_1_1_N = mkN "görare" utrum  ;
  goerdelmakare_nn_1_1_N = mkN "gördelmakare" utrum  ;
  goeteborgare_nn_1_1_N = mkN "göteborgare" utrum  ;
  hackare_nn_1_N = mkN "hackare" utrum  ;
  hajkaennare_nn_1_1_N = mkN "hajkännare" utrum  ;
  halmskakare_nn_1_N = mkN "halmskakare" utrum  ;
  halogenstraalkastare_nn_1_1_N = mkN "halogenstrålkastare" utrum  ;
  halvankare_nn_1_N = mkN "halvankare" utrum  ;
  halvdaeckare_nn_1_1_N = mkN "halvdäckare" utrum  ;
  halvledare_nn_1_N = mkN "halvledare" utrum  ;
  hamburgare_nn_1_N = mkN "hamburgare" utrum  ;
  hamnarbetare_nn_1_N = mkN "hamnarbetare" utrum  ;
  handikappidrottare_nn_1_N = mkN "handikappidrottare" utrum  ;
  handjagare_nn_1_N = mkN "handjagare" utrum  ;
  handlare_nn_1_N = mkN "handlare" utrum  ;
  handledare_nn_1_N = mkN "handledare" utrum  ;
  handlaeggare_nn_1_1_N = mkN "handläggare" utrum  ;
  handsekreterare_nn_1_N = mkN "handsekreterare" utrum  ;
  handtittare_nn_1_N = mkN "handtittare" utrum  ;
  hantlangare_nn_1_N = mkN "hantlangare" utrum  ;
  hantverkare_nn_1_N = mkN "hantverkare" utrum  ;
  hantverksarbetare_nn_1_N = mkN "hantverksarbetare" utrum  ;
  hastighetsmaetare_nn_1_1_N = mkN "hastighetsmätare" utrum  ;
  hatare_nn_1_N = mkN "hatare" utrum  ;
  havskryssare_nn_1_N = mkN "havskryssare" utrum  ;
  hedersborgare_nn_1_N = mkN "hedersborgare" utrum  ;
  hejare_nn_1_N = mkN "hejare" utrum  ;
  helikopterfoerare_nn_1_1_N = mkN "helikopterförare" utrum  ;
  helskaeggsluffare_nn_1_1_N = mkN "helskäggsluffare" utrum  ;
  heltidsjobbare_nn_1_N = mkN "heltidsjobbare" utrum  ;
  hembraennare_nn_1_1_N = mkN "hembrännare" utrum  ;
  hemmafixare_nn_1_N = mkN "hemmafixare" utrum  ;
  hemmansaegare_nn_1_1_N = mkN "hemmansägare" utrum  ;
  heroinsmugglare_nn_1_N = mkN "heroinsmugglare" utrum  ;
  herrnhutare_nn_1_N = mkN "herrnhutare" utrum  ;
  himlastormare_nn_1_N = mkN "himlastormare" utrum  ;
  himmelsfarare_nn_1_N = mkN "himmelsfarare" utrum  ;
  hinderloepare_nn_1_1_N = mkN "hinderlöpare" utrum  ;
  hisstillverkare_nn_1_N = mkN "hisstillverkare" utrum  ;
  historieforskare_nn_1_N = mkN "historieforskare" utrum  ;
  historiemaalare_nn_1_1_N = mkN "historiemålare" utrum  ;
  historieskrivare_nn_1_N = mkN "historieskrivare" utrum  ;
  hitmakare_nn_1_N = mkN "hitmakare" utrum  ;
  hjullastare_nn_1_N = mkN "hjullastare" utrum  ;
  hjulmutterdragare_nn_1_N = mkN "hjulmutterdragare" utrum  ;
  hjulaangare_nn_1_1_N = mkN "hjulångare" utrum  ;
  hjaelpare_nn_1_1_N = mkN "hjälpare" utrum  ;
  hjaelpkryssare_nn_1_1_N = mkN "hjälpkryssare" utrum  ;
  hjaelplaerare_nn_1_1_N = mkN "hjälplärare" utrum  ;
  hjaertekrossare_nn_1_1_N = mkN "hjärtekrossare" utrum  ;
  hockeyspelare_nn_1_N = mkN "hockeyspelare" utrum  ;
  hollaendare_nn_1_1_N = mkN "holländare" utrum  ;
  hoppare_nn_1_N = mkN "hoppare" utrum  ;
  hoppledare_nn_1_N = mkN "hoppledare" utrum  ;
  hotellaegare_nn_1_1_N = mkN "hotellägare" utrum  ;
  hovmaestare_nn_1_1_N = mkN "hovmästare" utrum  ;
  hovslagare_nn_1_N = mkN "hovslagare" utrum  ;
  huggare_nn_1_N = mkN "huggare" utrum  ;
  hugsvalare_nn_1_N = mkN "hugsvalare" utrum  ;
  humleplockare_nn_1_N = mkN "humleplockare" utrum  ;
  humoerspelare_nn_1_1_N = mkN "humörspelare" utrum  ;
  hundfoerare_nn_1_1_N = mkN "hundförare" utrum  ;
  hundratusentonnare_nn_1_N = mkN "hundratusentonnare" utrum  ;
  hundaegare_nn_1_1_N = mkN "hundägare" utrum  ;
  hushaallare_nn_1_1_N = mkN "hushållare" utrum  ;
  huslaekare_nn_1_1_N = mkN "husläkare" utrum  ;
  hustruersaettare_nn_1_1_N = mkN "hustruersättare" utrum  ;
  hustrumisshandlare_nn_1_N = mkN "hustrumisshandlare" utrum  ;
  husaegare_nn_1_1_N = mkN "husägare" utrum  ;
  huvudjaegare_nn_1_1_N = mkN "huvudjägare" utrum  ;
  huvudlaerare_nn_1_1_N = mkN "huvudlärare" utrum  ;
  huvudmotstaandare_nn_1_1_N = mkN "huvudmotståndare" utrum  ;
  huvudrollsinnehavare_nn_1_N = mkN "huvudrollsinnehavare" utrum  ;
  huvudstroembrytare_nn_1_1_N = mkN "huvudströmbrytare" utrum  ;
  huvudutmanare_nn_1_N = mkN "huvudutmanare" utrum  ;
  hycklare_nn_1_N = mkN "hycklare" utrum  ;
  hyrlaekare_nn_1_1_N = mkN "hyrläkare" utrum  ;
  hyvlare_nn_1_N = mkN "hyvlare" utrum  ;
  haecklare_nn_1_1_N = mkN "häcklare" utrum  ;
  haeckloepare_nn_1_1_N = mkN "häcklöpare" utrum  ;
  haedare_nn_1_1_N = mkN "hädare" utrum  ;
  haelare_nn_1_1_N = mkN "hälare" utrum  ;
  haelgaangare_nn_1_1_N = mkN "hälgångare" utrum  ;
  haemnare_nn_1_1_N = mkN "hämnare" utrum  ;
  haemtare_nn_1_1_N = mkN "hämtare" utrum  ;
  haengare_nn_1_1_N = mkN "hängare" utrum  ;
  haeradsdomare_nn_1_1_N = mkN "häradsdomare" utrum  ;
  haeradsskrivare_nn_1_1_N = mkN "häradsskrivare" utrum  ;
  haerfoerare_nn_1_1_N = mkN "härförare" utrum  ;
  haerjare_nn_1_1_N = mkN "härjare" utrum  ;
  haermare_nn_1_1_N = mkN "härmare" utrum  ;
  haerskare_nn_1_1_N = mkN "härskare" utrum  ;
  haestskojare_nn_1_1_N = mkN "hästskojare" utrum  ;
  haestskoetare_nn_1_1_N = mkN "hästskötare" utrum  ;
  haevdatecknare_nn_1_1_N = mkN "hävdatecknare" utrum  ;
  haexjaegare_nn_1_1_N = mkN "häxjägare" utrum  ;
  haexmaestare_nn_1_1_N = mkN "häxmästare" utrum  ;
  haallare_nn_1_1_N = mkN "hållare" utrum  ;
  hoefthaallare_nn_1_1_N = mkN "höfthållare" utrum  ;
  hoegerledare_nn_1_1_N = mkN "högerledare" utrum  ;
  hoegfoerraedare_nn_1_1_N = mkN "högförrädare" utrum  ;
  hoeginkomsttagare_nn_1_1_N = mkN "höginkomsttagare" utrum  ;
  hoeglaendare_nn_1_1_N = mkN "högländare" utrum  ;
  hoegoddsare_nn_1_1_N = mkN "högoddsare" utrum  ;
  hoegstadielaerare_nn_1_1_N = mkN "högstadielärare" utrum  ;
  hoegtalare_nn_1_1_N = mkN "högtalare" utrum  ;
  hoejdare_nn_1_1_N = mkN "höjdare" utrum  ;
  hoejdhoppare_nn_1_1_N = mkN "höjdhoppare" utrum  ;
  hoejdmaetare_nn_1_1_N = mkN "höjdmätare" utrum  ;
  hoekare_nn_1_1_N = mkN "hökare" utrum  ;
  hoerare_nn_1_1_N = mkN "hörare" utrum  ;
  hoernpelare_nn_1_1_N = mkN "hörnpelare" utrum  ;
  hoevaendare_nn_1_1_N = mkN "hövändare" utrum  ;
  iPhone_nn_1_N = mkN "iPhone" utrum  ;
  iakttagare_nn_1_N = mkN "iakttagare" utrum  ;
  icke_roekare_nn_1_1_N = mkN "icke-rökare" utrum  ;
  ickeroekare_nn_1_1_N = mkN "ickerökare" utrum  ;
  idisslare_nn_1_N = mkN "idisslare" utrum  ;
  idkare_nn_1_N = mkN "idkare" utrum  ;
  idrottare_nn_1_N = mkN "idrottare" utrum  ;
  idrottsledare_nn_1_N = mkN "idrottsledare" utrum  ;
  id_egivare_nn_1_1_N = mkN "idégivare" utrum  ;
  inbjudare_nn_1_N = mkN "inbjudare" utrum  ;
  inbyggare_nn_1_N = mkN "inbyggare" utrum  ;
  industriarbetare_nn_1_N = mkN "industriarbetare" utrum  ;
  inhoppare_nn_1_N = mkN "inhoppare" utrum  ;
  initiativtagare_nn_1_N = mkN "initiativtagare" utrum  ;
  injektionsmissbrukare_nn_1_N = mkN "injektionsmissbrukare" utrum  ;
  inkomsttagare_nn_1_N = mkN "inkomsttagare" utrum  ;
  inkraektare_nn_1_1_N = mkN "inkräktare" utrum  ;
  inkoepare_nn_1_1_N = mkN "inköpare" utrum  ;
  inledare_nn_1_N = mkN "inledare" utrum  ;
  inmutare_nn_1_N = mkN "inmutare" utrum  ;
  innebyggare_nn_1_N = mkN "innebyggare" utrum  ;
  innehavare_nn_1_N = mkN "innehavare" utrum  ;
  innesittare_nn_1_N = mkN "innesittare" utrum  ;
  innevaanare_nn_1_1_N = mkN "innevånare" utrum  ;
  inombordare_nn_1_N = mkN "inombordare" utrum  ;
  inpiskare_nn_1_N = mkN "inpiskare" utrum  ;
  inriggare_nn_1_N = mkN "inriggare" utrum  ;
  inropare_nn_1_N = mkN "inropare" utrum  ;
  insamlare_nn_1_N = mkN "insamlare" utrum  ;
  insektsborttagare_nn_1_N = mkN "insektsborttagare" utrum  ;
  insektsaetare_nn_1_1_N = mkN "insektsätare" utrum  ;
  inskrivningsdomare_nn_1_N = mkN "inskrivningsdomare" utrum  ;
  instiftare_nn_1_N = mkN "instiftare" utrum  ;
  insaendare_nn_1_1_N = mkN "insändare" utrum  ;
  internetanvaendare_nn_1_1_N = mkN "internetanvändare" utrum  ;
  intervjuare_nn_1_N = mkN "intervjuare" utrum  ;
  intrigmakare_nn_1_N = mkN "intrigmakare" utrum  ;
  invandrare_nn_1_N = mkN "invandrare" utrum  ;
  inventerare_nn_1_N = mkN "inventerare" utrum  ;
  investerare_nn_1_N = mkN "investerare" utrum  ;
  invaanare_nn_1_1_N = mkN "invånare" utrum  ;
  irisblaendare_nn_1_1_N = mkN "irisbländare" utrum  ;
  irlaendare_nn_1_1_N = mkN "irländare" utrum  ;
  isborttagare_nn_1_N = mkN "isborttagare" utrum  ;
  isbrytare_nn_1_N = mkN "isbrytare" utrum  ;
  ishockeyspelare_nn_1_N = mkN "ishockeyspelare" utrum  ;
  iskaellare_nn_1_1_N = mkN "iskällare" utrum  ;
  islaendare_nn_1_1_N = mkN "isländare" utrum  ;
  istidsforskare_nn_1_N = mkN "istidsforskare" utrum  ;
  italienare_nn_1_N = mkN "italienare" utrum  ;
  ivrare_nn_1_N = mkN "ivrare" utrum  ;
  jagare_nn_1_N = mkN "jagare" utrum  ;
  jaktraettsinnehavare_nn_1_1_N = mkN "jakträttsinnehavare" utrum  ;
  jamare_nn_1_N = mkN "jamare" utrum  ;
  jasaegare_nn_1_1_N = mkN "jasägare" utrum  ;
  jetsettare_nn_1_N = mkN "jetsettare" utrum  ;
  jobbare_nn_1_N = mkN "jobbare" utrum  ;
  jobbsoekare_nn_1_1_N = mkN "jobbsökare" utrum  ;
  joggare_nn_1_N = mkN "joggare" utrum  ;
  jonbytare_nn_1_N = mkN "jonbytare" utrum  ;
  jordbrukare_nn_1_N = mkN "jordbrukare" utrum  ;
  jorden_runt_seglare_nn_1_N = mkN "jorden-runt-seglare" utrum  ;
  jordkaellare_nn_1_1_N = mkN "jordkällare" utrum  ;
  jordloepare_nn_1_1_N = mkN "jordlöpare" utrum  ;
  jordaegare_nn_1_1_N = mkN "jordägare" utrum  ;
  justerare_nn_1_N = mkN "justerare" utrum  ;
  justitieborgmaestare_nn_1_1_N = mkN "justitieborgmästare" utrum  ;
  juvelerare_nn_1_N = mkN "juvelerare" utrum  ;
  jaegare_nn_1_1_N = mkN "jägare" utrum  ;
  jaegmaestare_nn_1_1_N = mkN "jägmästare" utrum  ;
  jaenkare_nn_1_1_N = mkN "jänkare" utrum  ;
  jaernvaegare_nn_1_1_N = mkN "järnvägare" utrum  ;
  jaernaaldersfiskare_nn_1_1_N = mkN "järnåldersfiskare" utrum  ;
  kabinettssekreterare_nn_1_N = mkN "kabinettssekreterare" utrum  ;
  kaffebryggare_nn_1_N = mkN "kaffebryggare" utrum  ;
  kaffekokare_nn_1_N = mkN "kaffekokare" utrum  ;
  kakelskaerare_nn_1_1_N = mkN "kakelskärare" utrum  ;
  kakelugnsmakare_nn_1_N = mkN "kakelugnsmakare" utrum  ;
  kakelugnssaettare_nn_1_1_N = mkN "kakelugnssättare" utrum  ;
  kalenderbitare_nn_1_N = mkN "kalenderbitare" utrum  ;
  kallkaellare_nn_1_1_N = mkN "kallkällare" utrum  ;
  kamelforskare_nn_1_N = mkN "kamelforskare" utrum  ;
  kamerunare_nn_1_N = mkN "kamerunare" utrum  ;
  kammarjunkare_nn_1_N = mkN "kammarjunkare" utrum  ;
  kammarskrivare_nn_1_N = mkN "kammarskrivare" utrum  ;
  kammartjaenare_nn_1_1_N = mkN "kammartjänare" utrum  ;
  kammaraaklagare_nn_1_1_N = mkN "kammaråklagare" utrum  ;
  kampanjraadgivare_nn_1_1_N = mkN "kampanjrådgivare" utrum  ;
  kampanjvinnare_nn_1_N = mkN "kampanjvinnare" utrum  ;
  kampare_nn_1_N = mkN "kampare" utrum  ;
  kampsportare_nn_1_N = mkN "kampsportare" utrum  ;
  kamrerare_nn_1_N = mkN "kamrerare" utrum  ;
  kanadensare_nn_1_N = mkN "kanadensare" utrum  ;
  kanalvaeljare_nn_1_1_N = mkN "kanalväljare" utrum  ;
  kanalaangare_nn_1_1_N = mkN "kanalångare" utrum  ;
  kannstoepare_nn_1_1_N = mkN "kannstöpare" utrum  ;
  kanslisekreterare_nn_1_N = mkN "kanslisekreterare" utrum  ;
  kapare_nn_1_N = mkN "kapare" utrum  ;
  kapellmaestare_nn_1_1_N = mkN "kapellmästare" utrum  ;
  kappseglare_nn_1_N = mkN "kappseglare" utrum  ;
  kapsyloeppnare_nn_1_1_N = mkN "kapsylöppnare" utrum  ;
  karaktaersskaadespelare_nn_1_1_N = mkN "karaktärsskådespelare" utrum  ;
  karelare_nn_1_N = mkN "karelare" utrum  ;
  karikatyrtecknare_nn_1_N = mkN "karikatyrtecknare" utrum  ;
  kartlaesare_nn_1_1_N = mkN "kartläsare" utrum  ;
  kartmaetare_nn_1_1_N = mkN "kartmätare" utrum  ;
  kartritare_nn_1_N = mkN "kartritare" utrum  ;
  kassafoervaltare_nn_1_1_N = mkN "kassaförvaltare" utrum  ;
  kassettbandspelare_nn_1_N = mkN "kassettbandspelare" utrum  ;
  kastilianare_nn_1_N = mkN "kastilianare" utrum  ;
  kastratsaangare_nn_1_1_N = mkN "kastratsångare" utrum  ;
  kejsare_nn_1_N = mkN "kejsare" utrum  ;
  kemilaerare_nn_1_1_N = mkN "kemilärare" utrum  ;
  kidnappare_nn_1_N = mkN "kidnappare" utrum  ;
  kikare_nn_1_N = mkN "kikare" utrum  ;
  kistbaerare_nn_1_1_N = mkN "kistbärare" utrum  ;
  kittelflickare_nn_1_N = mkN "kittelflickare" utrum  ;
  kittlare_nn_1_N = mkN "kittlare" utrum  ;
  klandrare_nn_1_N = mkN "klandrare" utrum  ;
  klassfoerestaandare_nn_1_1_N = mkN "klassföreståndare" utrum  ;
  klassfoerraedare_nn_1_1_N = mkN "klassförrädare" utrum  ;
  klasslaerare_nn_1_1_N = mkN "klasslärare" utrum  ;
  klimatforskare_nn_1_N = mkN "klimatforskare" utrum  ;
  klimatfoernekare_nn_1_1_N = mkN "klimatförnekare" utrum  ;
  klinkerskaerare_nn_1_1_N = mkN "klinkerskärare" utrum  ;
  klippare_nn_1_N = mkN "klippare" utrum  ;
  klockare_nn_1_N = mkN "klockare" utrum  ;
  klottrare_nn_1_N = mkN "klottrare" utrum  ;
  klubbmaestare_nn_1_1_N = mkN "klubbmästare" utrum  ;
  kluddare_nn_1_N = mkN "kluddare" utrum  ;
  klyvare_nn_1_N = mkN "klyvare" utrum  ;
  klaedhaengare_nn_1_1_N = mkN "klädhängare" utrum  ;
  klaemmare_nn_1_1_N = mkN "klämmare" utrum  ;
  klaemtare_nn_1_1_N = mkN "klämtare" utrum  ;
  klaettrare_nn_1_1_N = mkN "klättrare" utrum  ;
  klaapare_nn_1_1_N = mkN "klåpare" utrum  ;
  knarkare_nn_1_N = mkN "knarkare" utrum  ;
  knarkbekaempare_nn_1_1_N = mkN "knarkbekämpare" utrum  ;
  knarkhandlare_nn_1_N = mkN "knarkhandlare" utrum  ;
  knarklangare_nn_1_N = mkN "knarklangare" utrum  ;
  knarksmugglare_nn_1_N = mkN "knarksmugglare" utrum  ;
  knegare_nn_1_N = mkN "knegare" utrum  ;
  knivlaeggare_nn_1_1_N = mkN "knivläggare" utrum  ;
  knogare_nn_1_N = mkN "knogare" utrum  ;
  knaeppare_nn_1_1_N = mkN "knäppare" utrum  ;
  knaevaermare_nn_1_1_N = mkN "knävärmare" utrum  ;
  kofaangare_nn_1_1_N = mkN "kofångare" utrum  ;
  kokare_nn_1_N = mkN "kokare" utrum  ;
  kolare_nn_1_N = mkN "kolare" utrum  ;
  kolbaerare_nn_1_1_N = mkN "kolbärare" utrum  ;
  kolhaemtare_nn_1_1_N = mkN "kolhämtare" utrum  ;
  komedifoerfattare_nn_1_1_N = mkN "komediförfattare" utrum  ;
  kommanditdelaegare_nn_1_1_N = mkN "kommanditdelägare" utrum  ;
  kommuninnevaanare_nn_1_1_N = mkN "kommuninnevånare" utrum  ;
  kommuninvaanare_nn_1_1_N = mkN "kommuninvånare" utrum  ;
  kongressdeltagare_nn_1_N = mkN "kongressdeltagare" utrum  ;
  konkursfoervaltare_nn_1_1_N = mkN "konkursförvaltare" utrum  ;
  konsertmaestare_nn_1_1_N = mkN "konsertmästare" utrum  ;
  konservoeppnare_nn_1_1_N = mkN "konservöppnare" utrum  ;
  konsistensgivare_nn_1_N = mkN "konsistensgivare" utrum  ;
  konstberidare_nn_1_N = mkN "konstberidare" utrum  ;
  konstkaennare_nn_1_1_N = mkN "konstkännare" utrum  ;
  konstmaalare_nn_1_1_N = mkN "konstmålare" utrum  ;
  konstryttare_nn_1_N = mkN "konstryttare" utrum  ;
  konstsamlare_nn_1_N = mkN "konstsamlare" utrum  ;
  konstskojare_nn_1_N = mkN "konstskojare" utrum  ;
  konstaelskare_nn_1_1_N = mkN "konstälskare" utrum  ;
  konstaakare_nn_1_1_N = mkN "konståkare" utrum  ;
  kontoinnehavare_nn_1_N = mkN "kontoinnehavare" utrum  ;
  kopparslagare_nn_1_N = mkN "kopparslagare" utrum  ;
  kopplare_nn_1_N = mkN "kopplare" utrum  ;
  kormaestare_nn_1_1_N = mkN "kormästare" utrum  ;
  korruptionsforskare_nn_1_N = mkN "korruptionsforskare" utrum  ;
  korsfarare_nn_1_N = mkN "korsfarare" utrum  ;
  korsikanare_nn_1_N = mkN "korsikanare" utrum  ;
  korsriddare_nn_1_N = mkN "korsriddare" utrum  ;
  korsvisare_nn_1_N = mkN "korsvisare" utrum  ;
  kortdistansloepare_nn_1_1_N = mkN "kortdistanslöpare" utrum  ;
  kortlaesare_nn_1_1_N = mkN "kortläsare" utrum  ;
  kortspelare_nn_1_N = mkN "kortspelare" utrum  ;
  korvaelskare_nn_1_1_N = mkN "korvälskare" utrum  ;
  kotknackare_nn_1_N = mkN "kotknackare" utrum  ;
  kotpelare_nn_1_N = mkN "kotpelare" utrum  ;
  kraftbaerare_nn_1_1_N = mkN "kraftbärare" utrum  ;
  kreditvaerderare_nn_1_1_N = mkN "kreditvärderare" utrum  ;
  kretensare_nn_1_N = mkN "kretensare" utrum  ;
  krigare_nn_1_N = mkN "krigare" utrum  ;
  krigsfoerbrytare_nn_1_1_N = mkN "krigsförbrytare" utrum  ;
  krigsfoerespraakare_nn_1_1_N = mkN "krigsförespråkare" utrum  ;
  krigshetsare_nn_1_N = mkN "krigshetsare" utrum  ;
  krillaetare_nn_1_1_N = mkN "krillätare" utrum  ;
  kriminalare_nn_1_N = mkN "kriminalare" utrum  ;
  krishanterare_nn_1_N = mkN "krishanterare" utrum  ;
  kristallmottagare_nn_1_N = mkN "kristallmottagare" utrum  ;
  kronojaegare_nn_1_1_N = mkN "kronojägare" utrum  ;
  kroppsarbetare_nn_1_N = mkN "kroppsarbetare" utrum  ;
  kroppsbyggare_nn_1_N = mkN "kroppsbyggare" utrum  ;
  krubbitare_nn_1_N = mkN "krubbitare" utrum  ;
  krukmakare_nn_1_N = mkN "krukmakare" utrum  ;
  krypare_nn_1_N = mkN "krypare" utrum  ;
  kryssare_nn_1_N = mkN "kryssare" utrum  ;
  kraemare_nn_1_1_N = mkN "krämare" utrum  ;
  kraengningshaemmare_nn_1_1_N = mkN "krängningshämmare" utrum  ;
  kraangelmakare_nn_1_1_N = mkN "krångelmakare" utrum  ;
  kraanglare_nn_1_1_N = mkN "krånglare" utrum  ;
  kroegare_nn_1_1_N = mkN "krögare" utrum  ;
  kroenare_nn_1_1_N = mkN "krönare" utrum  ;
  kroenikefoerfattare_nn_1_1_N = mkN "krönikeförfattare" utrum  ;
  kulstoetare_nn_1_1_N = mkN "kulstötare" utrum  ;
  kulturarbetare_nn_1_N = mkN "kulturarbetare" utrum  ;
  kulturbaerare_nn_1_1_N = mkN "kulturbärare" utrum  ;
  kulturtaenkare_nn_1_1_N = mkN "kulturtänkare" utrum  ;
  kungamakare_nn_1_N = mkN "kungamakare" utrum  ;
  kungamoerdare_nn_1_1_N = mkN "kungamördare" utrum  ;
  kungsfiskare_nn_1_N = mkN "kungsfiskare" utrum  ;
  kunskapare_nn_1_N = mkN "kunskapare" utrum  ;
  kupongklippare_nn_1_N = mkN "kupongklippare" utrum  ;
  kup_evaermare_nn_1_1_N = mkN "kupévärmare" utrum  ;
  kursare_nn_1_N = mkN "kursare" utrum  ;
  kursdeltagare_nn_1_N = mkN "kursdeltagare" utrum  ;
  kustjaegare_nn_1_1_N = mkN "kustjägare" utrum  ;
  kustpipare_nn_1_N = mkN "kustpipare" utrum  ;
  kvackare_nn_1_N = mkN "kvackare" utrum  ;
  kvacksalvare_nn_1_N = mkN "kvacksalvare" utrum  ;
  kvarntorpare_nn_1_N = mkN "kvarntorpare" utrum  ;
  kvarsittare_nn_1_N = mkN "kvarsittare" utrum  ;
  kvartermaestare_nn_1_1_N = mkN "kvartermästare" utrum  ;
  kvicksilverpelare_nn_1_N = mkN "kvicksilverpelare" utrum  ;
  kvinnofoerfoerare_nn_1_1_N = mkN "kvinnoförförare" utrum  ;
  kvinnohatare_nn_1_N = mkN "kvinnohatare" utrum  ;
  kvinnolaekare_nn_1_1_N = mkN "kvinnoläkare" utrum  ;
  kvinnotjusare_nn_1_N = mkN "kvinnotjusare" utrum  ;
  kvaekare_nn_1_1_N = mkN "kväkare" utrum  ;
  kylare_nn_1_N = mkN "kylare" utrum  ;
  kypare_nn_1_N = mkN "kypare" utrum  ;
  kyrkobesoekare_nn_1_1_N = mkN "kyrkobesökare" utrum  ;
  kyrkolaerare_nn_1_1_N = mkN "kyrkolärare" utrum  ;
  kyrkvaktmaestare_nn_1_1_N = mkN "kyrkvaktmästare" utrum  ;
  kaebblare_nn_1_1_N = mkN "käbblare" utrum  ;
  kaegelspelare_nn_1_1_N = mkN "kägelspelare" utrum  ;
  kaelkborgare_nn_1_1_N = mkN "kälkborgare" utrum  ;
  kaellare_nn_1_1_N = mkN "källare" utrum  ;
  kaellarmaestare_nn_1_1_N = mkN "källarmästare" utrum  ;
  kaennare_nn_1_1_N = mkN "kännare" utrum  ;
  kaernkraftskramare_nn_1_1_N = mkN "kärnkraftskramare" utrum  ;
  kaernkraftsmotstaandare_nn_1_1_N = mkN "kärnkraftsmotståndare" utrum  ;
  kaernvaeljare_nn_1_1_N = mkN "kärnväljare" utrum  ;
  kaettare_nn_1_1_N = mkN "kättare" utrum  ;
  kaettingspaennare_nn_1_1_N = mkN "kättingspännare" utrum  ;
  kaakfarare_nn_1_1_N = mkN "kåkfarare" utrum  ;
  koeksmaestare_nn_1_1_N = mkN "köksmästare" utrum  ;
  koepare_nn_1_1_N = mkN "köpare" utrum  ;
  koerare_nn_1_1_N = mkN "körare" utrum  ;
  koerkortsinnehavare_nn_1_1_N = mkN "körkortsinnehavare" utrum  ;
  koerledare_nn_1_1_N = mkN "körledare" utrum  ;
  koernare_nn_1_1_N = mkN "körnare" utrum  ;
  koerriktningsvisare_nn_1_1_N = mkN "körriktningsvisare" utrum  ;
  koersaangare_nn_1_1_N = mkN "körsångare" utrum  ;
  koettbullsaelskare_nn_1_1_N = mkN "köttbullsälskare" utrum  ;
  koettaetare_nn_1_1_N = mkN "köttätare" utrum  ;
  laddare_nn_1_N = mkN "laddare" utrum  ;
  lagledare_nn_1_N = mkN "lagledare" utrum  ;
  lagstiftare_nn_1_N = mkN "lagstiftare" utrum  ;
  lagtraenare_nn_1_1_N = mkN "lagtränare" utrum  ;
  lagvraengare_nn_1_1_N = mkN "lagvrängare" utrum  ;
  lamphaallare_nn_1_1_N = mkN "lamphållare" utrum  ;
  landsfoerraedare_nn_1_1_N = mkN "landsförrädare" utrum  ;
  landssekreterare_nn_1_N = mkN "landssekreterare" utrum  ;
  landstrykare_nn_1_N = mkN "landstrykare" utrum  ;
  landsvaegsriddare_nn_1_1_N = mkN "landsvägsriddare" utrum  ;
  langare_nn_1_N = mkN "langare" utrum  ;
  lantarbetare_nn_1_N = mkN "lantarbetare" utrum  ;
  lantbrevbaerare_nn_1_1_N = mkN "lantbrevbärare" utrum  ;
  lantbrukare_nn_1_N = mkN "lantbrukare" utrum  ;
  lantjunkare_nn_1_N = mkN "lantjunkare" utrum  ;
  lantmaestare_nn_1_1_N = mkN "lantmästare" utrum  ;
  lantmaetare_nn_1_1_N = mkN "lantmätare" utrum  ;
  lappsoekare_nn_1_1_N = mkN "lappsökare" utrum  ;
  laserpekare_nn_1_N = mkN "laserpekare" utrum  ;
  lastare_nn_1_N = mkN "lastare" utrum  ;
  lastbilsfoerare_nn_1_1_N = mkN "lastbilsförare" utrum  ;
  lasthaallare_nn_1_1_N = mkN "lasthållare" utrum  ;
  latinare_nn_1_N = mkN "latinare" utrum  ;
  latte_nn_1_N = mkN "latte" utrum  ;
  ledare_nn_1_N = mkN "ledare" utrum  ;
  ledsagare_nn_1_N = mkN "ledsagare" utrum  ;
  lejdare_nn_1_N = mkN "lejdare" utrum  ;
  lejontaemjare_nn_1_1_N = mkN "lejontämjare" utrum  ;
  lekare_nn_1_N = mkN "lekare" utrum  ;
  lekledare_nn_1_N = mkN "lekledare" utrum  ;
  lettlaendare_nn_1_1_N = mkN "lettländare" utrum  ;
  levnadstecknare_nn_1_N = mkN "levnadstecknare" utrum  ;
  licensinnehavare_nn_1_N = mkN "licensinnehavare" utrum  ;
  licenstagare_nn_1_N = mkN "licenstagare" utrum  ;
  liechtensteinare_nn_1_N = mkN "liechtensteinare" utrum  ;
  liftare_nn_1_N = mkN "liftare" utrum  ;
  liggare_nn_1_N = mkN "liggare" utrum  ;
  ligustersvaermare_nn_1_1_N = mkN "ligustersvärmare" utrum  ;
  likare_nn_1_N = mkN "likare" utrum  ;
  likriktare_nn_1_N = mkN "likriktare" utrum  ;
  likskaendare_nn_1_1_N = mkN "likskändare" utrum  ;
  lindansare_nn_1_N = mkN "lindansare" utrum  ;
  lindare_nn_1_N = mkN "lindare" utrum  ;
  lingonplockare_nn_1_N = mkN "lingonplockare" utrum  ;
  linjedomare_nn_1_N = mkN "linjedomare" utrum  ;
  linjerare_nn_1_N = mkN "linjerare" utrum  ;
  linjevaeljare_nn_1_1_N = mkN "linjeväljare" utrum  ;
  lirare_nn_1_N = mkN "lirare" utrum  ;
  lismare_nn_1_N = mkN "lismare" utrum  ;
  litteraturforskare_nn_1_N = mkN "litteraturforskare" utrum  ;
  livraeddare_nn_1_1_N = mkN "livräddare" utrum  ;
  livsbejakare_nn_1_N = mkN "livsbejakare" utrum  ;
  livsnjutare_nn_1_N = mkN "livsnjutare" utrum  ;
  livtjaenare_nn_1_1_N = mkN "livtjänare" utrum  ;
  ljuddaempare_nn_1_1_N = mkN "ljuddämpare" utrum  ;
  ljudinspelare_nn_1_N = mkN "ljudinspelare" utrum  ;
  ljugare_nn_1_N = mkN "ljugare" utrum  ;
  ljungpipare_nn_1_N = mkN "ljungpipare" utrum  ;
  ljushaallare_nn_1_1_N = mkN "ljushållare" utrum  ;
  ljusslaeckare_nn_1_1_N = mkN "ljussläckare" utrum  ;
  lodare_nn_1_N = mkN "lodare" utrum  ;
  logerare_nn_1_N = mkN "logerare" utrum  ;
  lokalvaardare_nn_1_1_N = mkN "lokalvårdare" utrum  ;
  lokfoerare_nn_1_1_N = mkN "lokförare" utrum  ;
  loppforskare_nn_1_N = mkN "loppforskare" utrum  ;
  lotterivinnare_nn_1_N = mkN "lotterivinnare" utrum  ;
  lotusaetare_nn_1_1_N = mkN "lotusätare" utrum  ;
  luffare_nn_1_N = mkN "luffare" utrum  ;
  luftfuktare_nn_1_N = mkN "luftfuktare" utrum  ;
  luftrenare_nn_1_N = mkN "luftrenare" utrum  ;
  luftsmoerjare_nn_1_1_N = mkN "luftsmörjare" utrum  ;
  lufttrycksmaetare_nn_1_1_N = mkN "lufttrycksmätare" utrum  ;
  luktborttagare_nn_1_N = mkN "luktborttagare" utrum  ;
  lunchare_nn_1_N = mkN "lunchare" utrum  ;
  lurendrejare_nn_1_N = mkN "lurendrejare" utrum  ;
  lustloegnare_nn_1_1_N = mkN "lustlögnare" utrum  ;
  lustmoerdare_nn_1_1_N = mkN "lustmördare" utrum  ;
  lustspelsfoerfattare_nn_1_1_N = mkN "lustspelsförfattare" utrum  ;
  lutningsmaetare_nn_1_1_N = mkN "lutningsmätare" utrum  ;
  lutspelare_nn_1_N = mkN "lutspelare" utrum  ;
  lutsaangare_nn_1_1_N = mkN "lutsångare" utrum  ;
  luxemburgare_nn_1_N = mkN "luxemburgare" utrum  ;
  lycksoekare_nn_1_1_N = mkN "lycksökare" utrum  ;
  lyktbaerare_nn_1_1_N = mkN "lyktbärare" utrum  ;
  lyrikaelskare_nn_1_1_N = mkN "lyrikälskare" utrum  ;
  lyssnare_nn_1_N = mkN "lyssnare" utrum  ;
  lyxkryssare_nn_1_N = mkN "lyxkryssare" utrum  ;
  laegenhetsinnehavare_nn_1_1_N = mkN "lägenhetsinnehavare" utrum  ;
  laekare_nn_1_1_N = mkN "läkare" utrum  ;
  laekarsekreterare_nn_1_1_N = mkN "läkarsekreterare" utrum  ;
  laektare_nn_1_1_N = mkN "läktare" utrum  ;
  laempare_nn_1_1_N = mkN "lämpare" utrum  ;
  laengdhoppare_nn_1_1_N = mkN "längdhoppare" utrum  ;
  laengdskidaakare_nn_1_1_N = mkN "längdskidåkare" utrum  ;
  laensaaklagare_nn_1_1_N = mkN "länsåklagare" utrum  ;
  laentagare_nn_1_1_N = mkN "läntagare" utrum  ;
  laerare_nn_1_1_N = mkN "lärare" utrum  ;
  laeromaestare_nn_1_1_N = mkN "läromästare" utrum  ;
  laesare_nn_1_1_N = mkN "läsare" utrum  ;
  laettviktare_nn_1_1_N = mkN "lättviktare" utrum  ;
  laaginkomsttagare_nn_1_1_N = mkN "låginkomsttagare" utrum  ;
  laagoddsare_nn_1_1_N = mkN "lågoddsare" utrum  ;
  laagstadielaerare_nn_1_1_N = mkN "lågstadielärare" utrum  ;
  laangfarare_nn_1_1_N = mkN "långfarare" utrum  ;
  laangivare_nn_1_1_N = mkN "långivare" utrum  ;
  laangkoerare_nn_1_1_N = mkN "långkörare" utrum  ;
  laangliggare_nn_1_1_N = mkN "långliggare" utrum  ;
  laangtradare_nn_1_1_N = mkN "långtradare" utrum  ;
  laantagare_nn_1_1_N = mkN "låntagare" utrum  ;
  laatskrivare_nn_1_1_N = mkN "låtskrivare" utrum  ;
  loegnare_nn_1_1_N = mkN "lögnare" utrum  ;
  loenearbetare_nn_1_1_N = mkN "lönearbetare" utrum  ;
  loennmoerdare_nn_1_1_N = mkN "lönnmördare" utrum  ;
  loentagare_nn_1_1_N = mkN "löntagare" utrum  ;
  loepare_nn_1_1_N = mkN "löpare" utrum  ;
  loesdrivare_nn_1_1_N = mkN "lösdrivare" utrum  ;
  loevsaangare_nn_1_1_N = mkN "lövsångare" utrum  ;
  loevuppsamlare_nn_1_1_N = mkN "lövuppsamlare" utrum  ;
  maffiaavsloejare_nn_1_1_N = mkN "maffiaavslöjare" utrum  ;
  magborstare_nn_1_N = mkN "magborstare" utrum  ;
  mailare_nn_1_N = mkN "mailare" utrum  ;
  makthavare_nn_1_N = mkN "makthavare" utrum  ;
  maktutoevare_nn_1_1_N = mkN "maktutövare" utrum  ;
  maltesare_nn_1_N = mkN "maltesare" utrum  ;
  manusfoerfattare_nn_1_1_N = mkN "manusförfattare" utrum  ;
  marginalvaeljare_nn_1_1_N = mkN "marginalväljare" utrum  ;
  marinmaalare_nn_1_1_N = mkN "marinmålare" utrum  ;
  marketentare_nn_1_N = mkN "marketentare" utrum  ;
  marknadsgycklare_nn_1_N = mkN "marknadsgycklare" utrum  ;
  marktaeckare_nn_1_1_N = mkN "marktäckare" utrum  ;
  markaegare_nn_1_1_N = mkN "markägare" utrum  ;
  massmoerdare_nn_1_1_N = mkN "massmördare" utrum  ;
  matare_nn_1_N = mkN "matare" utrum  ;
  matberedare_nn_1_N = mkN "matberedare" utrum  ;
  matematiklaerare_nn_1_1_N = mkN "matematiklärare" utrum  ;
  materialspelare_nn_1_N = mkN "materialspelare" utrum  ;
  matkaellare_nn_1_1_N = mkN "matkällare" utrum  ;
  mattdomare_nn_1_N = mkN "mattdomare" utrum  ;
  mattpiskare_nn_1_N = mkN "mattpiskare" utrum  ;
  mattsopare_nn_1_N = mkN "mattsopare" utrum  ;
  mattvaevare_nn_1_1_N = mkN "mattvävare" utrum  ;
  medarbetare_nn_1_N = mkN "medarbetare" utrum  ;
  medbedoemare_nn_1_1_N = mkN "medbedömare" utrum  ;
  medborgare_nn_1_N = mkN "medborgare" utrum  ;
  medbringare_nn_1_N = mkN "medbringare" utrum  ;
  meddelare_nn_1_N = mkN "meddelare" utrum  ;
  medelinkomsttagare_nn_1_N = mkN "medelinkomsttagare" utrum  ;
  medelpadare_nn_1_N = mkN "medelpadare" utrum  ;
  medeltidstaenkare_nn_1_1_N = mkN "medeltidstänkare" utrum  ;
  medhjaelpare_nn_1_1_N = mkN "medhjälpare" utrum  ;
  medhaallare_nn_1_1_N = mkN "medhållare" utrum  ;
  medianvaeljare_nn_1_1_N = mkN "medianväljare" utrum  ;
  medicinare_nn_1_N = mkN "medicinare" utrum  ;
  medlare_nn_1_N = mkN "medlare" utrum  ;
  medloepare_nn_1_1_N = mkN "medlöpare" utrum  ;
  medpassagerare_nn_1_N = mkN "medpassagerare" utrum  ;
  medspelare_nn_1_N = mkN "medspelare" utrum  ;
  medtaevlare_nn_1_1_N = mkN "medtävlare" utrum  ;
  mejare_nn_1_N = mkN "mejare" utrum  ;
  mejlare_nn_1_N = mkN "mejlare" utrum  ;
  mellanstroembrytare_nn_1_1_N = mkN "mellanströmbrytare" utrum  ;
  memoarfoerfattare_nn_1_1_N = mkN "memoarförfattare" utrum  ;
  menedare_nn_1_N = mkN "menedare" utrum  ;
  meningsmotstaandare_nn_1_1_N = mkN "meningsmotståndare" utrum  ;
  metallarbetare_nn_1_N = mkN "metallarbetare" utrum  ;
  metare_nn_1_N = mkN "metare" utrum  ;
  meterlikare_nn_1_N = mkN "meterlikare" utrum  ;
  middagsaetare_nn_1_1_N = mkN "middagsätare" utrum  ;
  militaerbefaelhavare_nn_1_1_N = mkN "militärbefälhavare" utrum  ;
  militaerlaekare_nn_1_1_N = mkN "militärläkare" utrum  ;
  miljoefoerstoerare_nn_1_1_N = mkN "miljöförstörare" utrum  ;
  miljoehycklare_nn_1_1_N = mkN "miljöhycklare" utrum  ;
  miniatyrmaalare_nn_1_1_N = mkN "miniatyrmålare" utrum  ;
  miniraeknare_nn_1_1_N = mkN "miniräknare" utrum  ;
  minnestecknare_nn_1_N = mkN "minnestecknare" utrum  ;
  minsvepare_nn_1_N = mkN "minsvepare" utrum  ;
  minsoekare_nn_1_1_N = mkN "minsökare" utrum  ;
  minutvisare_nn_1_N = mkN "minutvisare" utrum  ;
  missbrukare_nn_1_N = mkN "missbrukare" utrum  ;
  missdaadare_nn_1_1_N = mkN "missdådare" utrum  ;
  misshushaallare_nn_1_1_N = mkN "misshushållare" utrum  ;
  missilavfyrare_nn_1_N = mkN "missilavfyrare" utrum  ;
  missnoejesvaeljare_nn_1_1_N = mkN "missnöjesväljare" utrum  ;
  mittfaeltare_nn_1_1_N = mkN "mittfältare" utrum  ;
  mjoelkare_nn_1_1_N = mkN "mjölkare" utrum  ;
  mjoelnare_nn_1_1_N = mkN "mjölnare" utrum  ;
  mobilabonnemangsfoersaeljare_nn_1_1_N = mkN "mobilabonnemangsförsäljare" utrum  ;
  mobilladdare_nn_1_N = mkN "mobilladdare" utrum  ;
  moddlare_nn_1_N = mkN "moddlare" utrum  ;
  modeskapare_nn_1_N = mkN "modeskapare" utrum  ;
  mokare_nn_1_N = mkN "mokare" utrum  ;
  monotoniundvikare_nn_1_N = mkN "monotoniundvikare" utrum  ;
  mordbraennare_nn_1_1_N = mkN "mordbrännare" utrum  ;
  motlaesare_nn_1_1_N = mkN "motläsare" utrum  ;
  motorkryssare_nn_1_N = mkN "motorkryssare" utrum  ;
  motorseglare_nn_1_N = mkN "motorseglare" utrum  ;
  motorvaegskramare_nn_1_1_N = mkN "motorvägskramare" utrum  ;
  motorvaermare_nn_1_1_N = mkN "motorvärmare" utrum  ;
  motspelare_nn_1_N = mkN "motspelare" utrum  ;
  motstaandare_nn_1_1_N = mkN "motståndare" utrum  ;
  mottagare_nn_1_N = mkN "mottagare" utrum  ;
  mp3_spelare_nn_1_N = mkN "mp3-spelare" utrum  ;
  muckare_nn_1_N = mkN "muckare" utrum  ;
  mullbaersspinnare_nn_1_1_N = mkN "mullbärsspinnare" utrum  ;
  murare_nn_1_N = mkN "murare" utrum  ;
  museivaktmaestare_nn_1_1_N = mkN "museivaktmästare" utrum  ;
  musikfanjunkare_nn_1_N = mkN "musikfanjunkare" utrum  ;
  musiklaerare_nn_1_1_N = mkN "musiklärare" utrum  ;
  muskelbyggare_nn_1_N = mkN "muskelbyggare" utrum  ;
  muskelstaerkare_nn_1_1_N = mkN "muskelstärkare" utrum  ;
  musketerare_nn_1_N = mkN "musketerare" utrum  ;
  mutterdragare_nn_1_N = mkN "mutterdragare" utrum  ;
  myggjagare_nn_1_N = mkN "myggjagare" utrum  ;
  myglare_nn_1_N = mkN "myglare" utrum  ;
  myndighetsfoeretraedare_nn_1_1_N = mkN "myndighetsföreträdare" utrum  ;
  myndighetsutoevare_nn_1_1_N = mkN "myndighetsutövare" utrum  ;
  mynningsladdare_nn_1_N = mkN "mynningsladdare" utrum  ;
  myrforskare_nn_1_N = mkN "myrforskare" utrum  ;
  maeklare_nn_1_1_N = mkN "mäklare" utrum  ;
  maenniskohatare_nn_1_1_N = mkN "människohatare" utrum  ;
  maenniskokaennare_nn_1_1_N = mkN "människokännare" utrum  ;
  maenniskoraettsfoeretraedare_nn_1_1_N = mkN "människorättsföreträdare" utrum  ;
  maenniskosmugglare_nn_1_1_N = mkN "människosmugglare" utrum  ;
  maenniskoaetare_nn_1_1_N = mkN "människoätare" utrum  ;
  maeskprovare_nn_1_1_N = mkN "mäskprovare" utrum  ;
  maestare_nn_1_1_N = mkN "mästare" utrum  ;
  maesterklottrare_nn_1_1_N = mkN "mästerklottrare" utrum  ;
  maestersaangare_nn_1_1_N = mkN "mästersångare" utrum  ;
  maestertaenkare_nn_1_1_N = mkN "mästertänkare" utrum  ;
  maetare_nn_1_1_N = mkN "mätare" utrum  ;
  maakare_nn_1_1_N = mkN "måkare" utrum  ;
  maalare_nn_1_1_N = mkN "målare" utrum  ;
  maalarmaestare_nn_1_1_N = mkN "målarmästare" utrum  ;
  maaldomare_nn_1_1_N = mkN "måldomare" utrum  ;
  maalspottare_nn_1_1_N = mkN "målspottare" utrum  ;
  maalsaegare_nn_1_1_N = mkN "målsägare" utrum  ;
  maalsoekare_nn_1_1_N = mkN "målsökare" utrum  ;
  maangbyggare_nn_1_1_N = mkN "mångbyggare" utrum  ;
  maangfrestare_nn_1_1_N = mkN "mångfrestare" utrum  ;
  maanglare_nn_1_1_N = mkN "månglare" utrum  ;
  maangsysslare_nn_1_1_N = mkN "mångsysslare" utrum  ;
  maanlandare_nn_1_1_N = mkN "månlandare" utrum  ;
  moebelsnickare_nn_1_1_N = mkN "möbelsnickare" utrum  ;
  moenstringsliggare_nn_1_1_N = mkN "mönstringsliggare" utrum  ;
  moerdare_nn_1_1_N = mkN "mördare" utrum  ;
  moerklaeggare_nn_1_1_N = mkN "mörkläggare" utrum  ;
  moersare_nn_1_1_N = mkN "mörsare" utrum  ;
  nagelpetare_nn_1_N = mkN "nagelpetare" utrum  ;
  nakenbadare_nn_1_N = mkN "nakenbadare" utrum  ;
  nakenvandrare_nn_1_N = mkN "nakenvandrare" utrum  ;
  namnbaerare_nn_1_1_N = mkN "namnbärare" utrum  ;
  napolitanare_nn_1_N = mkN "napolitanare" utrum  ;
  narkoslaekare_nn_1_1_N = mkN "narkosläkare" utrum  ;
  narkotikasmugglare_nn_1_N = mkN "narkotikasmugglare" utrum  ;
  nasare_nn_1_N = mkN "nasare" utrum  ;
  nationalistledare_nn_1_N = mkN "nationalistledare" utrum  ;
  nattfriare_nn_1_N = mkN "nattfriare" utrum  ;
  nattkikare_nn_1_N = mkN "nattkikare" utrum  ;
  nattlogerare_nn_1_N = mkN "nattlogerare" utrum  ;
  nattspanare_nn_1_N = mkN "nattspanare" utrum  ;
  nattsuddare_nn_1_N = mkN "nattsuddare" utrum  ;
  nattvandrare_nn_1_N = mkN "nattvandrare" utrum  ;
  nattvaektare_nn_1_1_N = mkN "nattväktare" utrum  ;
  naturforskare_nn_1_N = mkN "naturforskare" utrum  ;
  naturlaekare_nn_1_1_N = mkN "naturläkare" utrum  ;
  natursaangare_nn_1_1_N = mkN "natursångare" utrum  ;
  naturvetare_nn_1_N = mkN "naturvetare" utrum  ;
  naturvaardare_nn_1_1_N = mkN "naturvårdare" utrum  ;
  naturvaardshandlaeggare_nn_1_1_N = mkN "naturvårdshandläggare" utrum  ;
  navare_nn_1_N = mkN "navare" utrum  ;
  navelskaadare_nn_1_1_N = mkN "navelskådare" utrum  ;
  neandertalare_nn_1_N = mkN "neandertalare" utrum  ;
  nederlaendare_nn_1_1_N = mkN "nederländare" utrum  ;
  nedhalare_nn_1_N = mkN "nedhalare" utrum  ;
  nedsmutsare_nn_1_N = mkN "nedsmutsare" utrum  ;
  nejsaegare_nn_1_1_N = mkN "nejsägare" utrum  ;
  nerhalare_nn_1_N = mkN "nerhalare" utrum  ;
  nersmutsare_nn_1_N = mkN "nersmutsare" utrum  ;
  newfoundlaendare_nn_1_1_N = mkN "newfoundländare" utrum  ;
  nobelpristagare_nn_1_N = mkN "nobelpristagare" utrum  ;
  nolltaxerare_nn_1_N = mkN "nolltaxerare" utrum  ;
  notvaendare_nn_1_1_N = mkN "notvändare" utrum  ;
  nybyggare_nn_1_N = mkN "nybyggare" utrum  ;
  nyboerjare_nn_1_1_N = mkN "nybörjare" utrum  ;
  nydanare_nn_1_N = mkN "nydanare" utrum  ;
  nyhetsmakare_nn_1_N = mkN "nyhetsmakare" utrum  ;
  nyhetsupplaesare_nn_1_1_N = mkN "nyhetsuppläsare" utrum  ;
  nykterhetsivrare_nn_1_N = mkN "nykterhetsivrare" utrum  ;
  nyskapare_nn_1_N = mkN "nyskapare" utrum  ;
  nystavare_nn_1_N = mkN "nystavare" utrum  ;
  nyttjare_nn_1_N = mkN "nyttjare" utrum  ;
  nytaenkare_nn_1_1_N = mkN "nytänkare" utrum  ;
  nyzeelaendare_nn_1_1_N = mkN "nyzeeländare" utrum  ;
  naemnare_nn_1_1_N = mkN "nämnare" utrum  ;
  naeringsidkare_nn_1_1_N = mkN "näringsidkare" utrum  ;
  naeringslivsledare_nn_1_1_N = mkN "näringslivsledare" utrum  ;
  naetbedragare_nn_1_1_N = mkN "nätbedragare" utrum  ;
  naetrullare_nn_1_1_N = mkN "nätrullare" utrum  ;
  naetsurfare_nn_1_1_N = mkN "nätsurfare" utrum  ;
  naeverbehaallare_nn_1_1_N = mkN "näverbehållare" utrum  ;
  noejesfiskare_nn_1_1_N = mkN "nöjesfiskare" utrum  ;
  noetknaeckare_nn_1_1_N = mkN "nötknäckare" utrum  ;
  noetknaeppare_nn_1_1_N = mkN "nötknäppare" utrum  ;
  oceanaangare_nn_1_1_N = mkN "oceanångare" utrum  ;
  ockrare_nn_1_N = mkN "ockrare" utrum  ;
  odlare_nn_1_N = mkN "odlare" utrum  ;
  officerare_nn_1_N = mkN "officerare" utrum  ;
  oledare_nn_1_N = mkN "oledare" utrum  ;
  oliktaenkare_nn_1_1_N = mkN "oliktänkare" utrum  ;
  oljebraennare_nn_1_1_N = mkN "oljebrännare" utrum  ;
  oljenivaamaetare_nn_1_1_N = mkN "oljenivåmätare" utrum  ;
  oljestroembrytare_nn_1_1_N = mkN "oljeströmbrytare" utrum  ;
  olympiasegrare_nn_1_N = mkN "olympiasegrare" utrum  ;
  omformare_nn_1_N = mkN "omformare" utrum  ;
  omkastare_nn_1_N = mkN "omkastare" utrum  ;
  omkopplare_nn_1_N = mkN "omkopplare" utrum  ;
  omriktare_nn_1_N = mkN "omriktare" utrum  ;
  omraekningsrysare_nn_1_1_N = mkN "omräkningsrysare" utrum  ;
  omskapare_nn_1_N = mkN "omskapare" utrum  ;
  omskiftare_nn_1_N = mkN "omskiftare" utrum  ;
  omvandlare_nn_1_N = mkN "omvandlare" utrum  ;
  operasaangare_nn_1_1_N = mkN "operasångare" utrum  ;
  operationslaekare_nn_1_1_N = mkN "operationsläkare" utrum  ;
  opinionsbildare_nn_1_N = mkN "opinionsbildare" utrum  ;
  oppassare_nn_1_N = mkN "oppassare" utrum  ;
  oppbackare_nn_1_N = mkN "oppbackare" utrum  ;
  oppfinnare_nn_1_N = mkN "oppfinnare" utrum  ;
  oppfostrare_nn_1_N = mkN "oppfostrare" utrum  ;
  oppfoedare_nn_1_1_N = mkN "oppfödare" utrum  ;
  oppositionsledare_nn_1_N = mkN "oppositionsledare" utrum  ;
  oppaatstraevare_nn_1_1_N = mkN "oppåtsträvare" utrum  ;
  ordbehandlare_nn_1_N = mkN "ordbehandlare" utrum  ;
  orddelare_nn_1_N = mkN "orddelare" utrum  ;
  ordklasstaggare_nn_1_N = mkN "ordklasstaggare" utrum  ;
  ordmakare_nn_1_N = mkN "ordmakare" utrum  ;
  ordnare_nn_1_N = mkN "ordnare" utrum  ;
  ordryttare_nn_1_N = mkN "ordryttare" utrum  ;
  ordvraengare_nn_1_1_N = mkN "ordvrängare" utrum  ;
  orgeltrampare_nn_1_N = mkN "orgeltrampare" utrum  ;
  orienterare_nn_1_N = mkN "orienterare" utrum  ;
  ormdoedare_nn_1_1_N = mkN "ormdödare" utrum  ;
  ormtjusare_nn_1_N = mkN "ormtjusare" utrum  ;
  orosstiftare_nn_1_N = mkN "orosstiftare" utrum  ;
  ortdrivare_nn_1_N = mkN "ortdrivare" utrum  ;
  ostskaerare_nn_1_1_N = mkN "ostskärare" utrum  ;
  pajsare_nn_1_N = mkN "pajsare" utrum  ;
  pakethaallare_nn_1_1_N = mkN "pakethållare" utrum  ;
  pakistanare_nn_1_N = mkN "pakistanare" utrum  ;
  panthavare_nn_1_N = mkN "panthavare" utrum  ;
  pantlaanare_nn_1_1_N = mkN "pantlånare" utrum  ;
  pantsaettare_nn_1_1_N = mkN "pantsättare" utrum  ;
  paradoxmakare_nn_1_N = mkN "paradoxmakare" utrum  ;
  paragrafryttare_nn_1_N = mkN "paragrafryttare" utrum  ;
  paraguayare_nn_1_N = mkN "paraguayare" utrum  ;
  parkeringsmaetare_nn_1_1_N = mkN "parkeringsmätare" utrum  ;
  parkettlaeggare_nn_1_1_N = mkN "parkettläggare" utrum  ;
  parkskoetare_nn_1_1_N = mkN "parkskötare" utrum  ;
  partifoeretraedare_nn_1_1_N = mkN "partiföreträdare" utrum  ;
  partigaengare_nn_1_1_N = mkN "partigängare" utrum  ;
  partikelkolliderare_nn_1_N = mkN "partikelkolliderare" utrum  ;
  partiledare_nn_1_N = mkN "partiledare" utrum  ;
  partisekreterare_nn_1_N = mkN "partisekreterare" utrum  ;
  passagerare_nn_1_N = mkN "passagerare" utrum  ;
  passare_nn_1_N = mkN "passare" utrum  ;
  passgaangare_nn_1_1_N = mkN "passgångare" utrum  ;
  patentsoekare_nn_1_1_N = mkN "patentsökare" utrum  ;
  patronhaallare_nn_1_1_N = mkN "patronhållare" utrum  ;
  pekare_nn_1_N = mkN "pekare" utrum  ;
  pelare_nn_1_N = mkN "pelare" utrum  ;
  pendlare_nn_1_N = mkN "pendlare" utrum  ;
  pennformerare_nn_1_N = mkN "pennformerare" utrum  ;
  pennfaektare_nn_1_1_N = mkN "pennfäktare" utrum  ;
  penninginsamlare_nn_1_N = mkN "penninginsamlare" utrum  ;
  pennvaessare_nn_1_1_N = mkN "pennvässare" utrum  ;
  pensionatsinnehavare_nn_1_N = mkN "pensionatsinnehavare" utrum  ;
  pensionsraadgivare_nn_1_1_N = mkN "pensionsrådgivare" utrum  ;
  periodare_nn_1_N = mkN "periodare" utrum  ;
  periodsupare_nn_1_N = mkN "periodsupare" utrum  ;
  personallaekare_nn_1_1_N = mkN "personalläkare" utrum  ;
  personalutbildare_nn_1_N = mkN "personalutbildare" utrum  ;
  personsoekare_nn_1_1_N = mkN "personsökare" utrum  ;
  perukmakare_nn_1_N = mkN "perukmakare" utrum  ;
  pigtittare_nn_1_N = mkN "pigtittare" utrum  ;
  pigtjusare_nn_1_N = mkN "pigtjusare" utrum  ;
  pilleknarkare_nn_1_N = mkN "pilleknarkare" utrum  ;
  pillertrillare_nn_1_N = mkN "pillertrillare" utrum  ;
  pipare_nn_1_N = mkN "pipare" utrum  ;
  piprensare_nn_1_N = mkN "piprensare" utrum  ;
  piproekare_nn_1_1_N = mkN "piprökare" utrum  ;
  pipspaennare_nn_1_1_N = mkN "pipspännare" utrum  ;
  pipstoppare_nn_1_N = mkN "pipstoppare" utrum  ;
  piratsaendare_nn_1_1_N = mkN "piratsändare" utrum  ;
  pizzabagare_nn_1_N = mkN "pizzabagare" utrum  ;
  pladdrare_nn_1_N = mkN "pladdrare" utrum  ;
  planerare_nn_1_N = mkN "planerare" utrum  ;
  plankstrykare_nn_1_N = mkN "plankstrykare" utrum  ;
  plikthuggare_nn_1_N = mkN "plikthuggare" utrum  ;
  plockare_nn_1_N = mkN "plockare" utrum  ;
  pluggare_nn_1_N = mkN "pluggare" utrum  ;
  plundrare_nn_1_N = mkN "plundrare" utrum  ;
  plaagare_nn_1_1_N = mkN "plågare" utrum  ;
  plaatslagare_nn_1_1_N = mkN "plåtslagare" utrum  ;
  polare_nn_1_N = mkN "polare" utrum  ;
  polismaestare_nn_1_1_N = mkN "polismästare" utrum  ;
  pollare_nn_1_N = mkN "pollare" utrum  ;
  polospelare_nn_1_N = mkN "polospelare" utrum  ;
  popsaangare_nn_1_1_N = mkN "popsångare" utrum  ;
  portfoeljbaerare_nn_1_1_N = mkN "portföljbärare" utrum  ;
  portraettmaalare_nn_1_1_N = mkN "porträttmålare" utrum  ;
  positivhalare_nn_1_N = mkN "positivhalare" utrum  ;
  postmaestare_nn_1_1_N = mkN "postmästare" utrum  ;
  potatisskalare_nn_1_N = mkN "potatisskalare" utrum  ;
  praktbaegare_nn_1_1_N = mkN "praktbägare" utrum  ;
  pratmakare_nn_1_N = mkN "pratmakare" utrum  ;
  predikare_nn_1_N = mkN "predikare" utrum  ;
  predikohandledare_nn_1_N = mkN "predikohandledare" utrum  ;
  prejare_nn_1_N = mkN "prejare" utrum  ;
  premiebetalare_nn_1_N = mkN "premiebetalare" utrum  ;
  pressare_nn_1_N = mkN "pressare" utrum  ;
  presslaektare_nn_1_1_N = mkN "pressläktare" utrum  ;
  preussare_nn_1_N = mkN "preussare" utrum  ;
  prickare_nn_1_N = mkN "prickare" utrum  ;
  principryttare_nn_1_N = mkN "principryttare" utrum  ;
  prisboxare_nn_1_N = mkN "prisboxare" utrum  ;
  prisdomare_nn_1_N = mkN "prisdomare" utrum  ;
  prismakikare_nn_1_N = mkN "prismakikare" utrum  ;
  pristagare_nn_1_N = mkN "pristagare" utrum  ;
  prisvinnare_nn_1_N = mkN "prisvinnare" utrum  ;
  privatiseringsivrare_nn_1_N = mkN "privatiseringsivrare" utrum  ;
  privatlaekare_nn_1_1_N = mkN "privatläkare" utrum  ;
  privatlaerare_nn_1_1_N = mkN "privatlärare" utrum  ;
  privatmicklare_nn_1_N = mkN "privatmicklare" utrum  ;
  privatsekreterare_nn_1_N = mkN "privatsekreterare" utrum  ;
  procentare_nn_1_N = mkN "procentare" utrum  ;
  proffsspelare_nn_1_N = mkN "proffsspelare" utrum  ;
  proffsvinnare_nn_1_N = mkN "proffsvinnare" utrum  ;
  proffsaakare_nn_1_1_N = mkN "proffsåkare" utrum  ;
  proggare_nn_1_N = mkN "proggare" utrum  ;
  programledare_nn_1_N = mkN "programledare" utrum  ;
  programmerare_nn_1_N = mkN "programmerare" utrum  ;
  programutgivare_nn_1_N = mkN "programutgivare" utrum  ;
  programutvecklare_nn_1_N = mkN "programutvecklare" utrum  ;
  programvaeljare_nn_1_1_N = mkN "programväljare" utrum  ;
  projektledare_nn_1_N = mkN "projektledare" utrum  ;
  provare_nn_1_N = mkN "provare" utrum  ;
  provinsiallaekare_nn_1_1_N = mkN "provinsialläkare" utrum  ;
  provinsstaathaallare_nn_1_1_N = mkN "provinsståthållare" utrum  ;
  provryttare_nn_1_N = mkN "provryttare" utrum  ;
  praanglare_nn_1_1_N = mkN "prånglare" utrum  ;
  psalmdiktare_nn_1_N = mkN "psalmdiktare" utrum  ;
  psaltare_nn_1_N = mkN "psaltare" utrum  ;
  puckare_nn_1_N = mkN "puckare" utrum  ;
  pulslaesare_nn_1_1_N = mkN "pulsläsare" utrum  ;
  pulverslaeckare_nn_1_1_N = mkN "pulversläckare" utrum  ;
  pundare_nn_1_N = mkN "pundare" utrum  ;
  punkare_nn_1_N = mkN "punkare" utrum  ;
  pyndare_nn_1_N = mkN "pyndare" utrum  ;
  paelsfladdrare_nn_1_1_N = mkN "pälsfladdrare" utrum  ;
  paelsjaegare_nn_1_1_N = mkN "pälsjägare" utrum  ;
  paermbaerare_nn_1_1_N = mkN "pärmbärare" utrum  ;
  paermslukare_nn_1_1_N = mkN "pärmslukare" utrum  ;
  paadrivare_nn_1_1_N = mkN "pådrivare" utrum  ;
  paahejare_nn_1_1_N = mkN "påhejare" utrum  ;
  paaklaedare_nn_1_1_N = mkN "påklädare" utrum  ;
  paatryckare_nn_1_1_N = mkN "påtryckare" utrum  ;
  rabattjaegare_nn_1_1_N = mkN "rabattjägare" utrum  ;
  racerfoerare_nn_1_1_N = mkN "racerförare" utrum  ;
  rackabajsare_nn_1_N = mkN "rackabajsare" utrum  ;
  rackare_nn_1_N = mkN "rackare" utrum  ;
  radiomottagare_nn_1_N = mkN "radiomottagare" utrum  ;
  radiosaendare_nn_1_1_N = mkN "radiosändare" utrum  ;
  radskiftare_nn_1_N = mkN "radskiftare" utrum  ;
  radskrivare_nn_1_N = mkN "radskrivare" utrum  ;
  raggare_nn_1_N = mkN "raggare" utrum  ;
  rallare_nn_1_N = mkN "rallare" utrum  ;
  ramlare_nn_1_N = mkN "ramlare" utrum  ;
  ramsaettare_nn_1_1_N = mkN "ramsättare" utrum  ;
  ranchaegare_nn_1_1_N = mkN "ranchägare" utrum  ;
  rashetsare_nn_1_N = mkN "rashetsare" utrum  ;
  reaktorkramare_nn_1_N = mkN "reaktorkramare" utrum  ;
  rebelledare_nn_1_N = mkN "rebelledare" utrum  ;
  redaktionssekreterare_nn_1_N = mkN "redaktionssekreterare" utrum  ;
  redare_nn_1_N = mkN "redare" utrum  ;
  redogoerare_nn_1_1_N = mkN "redogörare" utrum  ;
  refraengsaangare_nn_1_1_N = mkN "refrängsångare" utrum  ;
  regelryttare_nn_1_N = mkN "regelryttare" utrum  ;
  regeringsanhaengare_nn_1_1_N = mkN "regeringsanhängare" utrum  ;
  regnmaetare_nn_1_1_N = mkN "regnmätare" utrum  ;
  religionsstiftare_nn_1_N = mkN "religionsstiftare" utrum  ;
  remmare_nn_1_N = mkN "remmare" utrum  ;
  renjaegare_nn_1_1_N = mkN "renjägare" utrum  ;
  renskoetare_nn_1_1_N = mkN "renskötare" utrum  ;
  repborttagare_nn_1_N = mkN "repborttagare" utrum  ;
  repslagare_nn_1_N = mkN "repslagare" utrum  ;
  reseledare_nn_1_N = mkN "reseledare" utrum  ;
  reservare_nn_1_N = mkN "reservare" utrum  ;
  reservspelare_nn_1_N = mkN "reservspelare" utrum  ;
  reseskildrare_nn_1_N = mkN "reseskildrare" utrum  ;
  revisionssekreterare_nn_1_N = mkN "revisionssekreterare" utrum  ;
  revolutionsledare_nn_1_N = mkN "revolutionsledare" utrum  ;
  revymakare_nn_1_N = mkN "revymakare" utrum  ;
  rickshawfoerare_nn_1_1_N = mkN "rickshawförare" utrum  ;
  riddare_nn_1_N = mkN "riddare" utrum  ;
  riksbyggare_nn_1_N = mkN "riksbyggare" utrum  ;
  riksfoerestaandare_nn_1_1_N = mkN "riksföreståndare" utrum  ;
  riksfoerraedare_nn_1_1_N = mkN "riksförrädare" utrum  ;
  rikslikare_nn_1_N = mkN "rikslikare" utrum  ;
  riksaaklagare_nn_1_1_N = mkN "riksåklagare" utrum  ;
  rimmare_nn_1_N = mkN "rimmare" utrum  ;
  ringare_nn_1_N = mkN "ringare" utrum  ;
  ringdomare_nn_1_N = mkN "ringdomare" utrum  ;
  risktagare_nn_1_N = mkN "risktagare" utrum  ;
  ritare_nn_1_N = mkN "ritare" utrum  ;
  rockvaktmaestare_nn_1_1_N = mkN "rockvaktmästare" utrum  ;
  roddare_nn_1_N = mkN "roddare" utrum  ;
  rolighetsmakare_nn_1_N = mkN "rolighetsmakare" utrum  ;
  romanfoerfattare_nn_1_1_N = mkN "romanförfattare" utrum  ;
  romare_nn_1_N = mkN "romare" utrum  ;
  ropare_nn_1_N = mkN "ropare" utrum  ;
  rorgaengare_nn_1_1_N = mkN "rorgängare" utrum  ;
  rotbedragare_nn_1_N = mkN "rotbedragare" utrum  ;
  rovriddare_nn_1_N = mkN "rovriddare" utrum  ;
  rucklare_nn_1_N = mkN "rucklare" utrum  ;
  rufflare_nn_1_N = mkN "rufflare" utrum  ;
  rumlare_nn_1_N = mkN "rumlare" utrum  ;
  rumpsniffare_nn_1_N = mkN "rumpsniffare" utrum  ;
  rumpvaermare_nn_1_1_N = mkN "rumpvärmare" utrum  ;
  runnare_nn_1_N = mkN "runnare" utrum  ;
  rustare_nn_1_N = mkN "rustare" utrum  ;
  rusthaallare_nn_1_1_N = mkN "rusthållare" utrum  ;
  rustmaestare_nn_1_1_N = mkN "rustmästare" utrum  ;
  ryggdunkare_nn_1_N = mkN "ryggdunkare" utrum  ;
  ryktessmidare_nn_1_N = mkN "ryktessmidare" utrum  ;
  rymdfarare_nn_1_N = mkN "rymdfarare" utrum  ;
  rymmare_nn_1_N = mkN "rymmare" utrum  ;
  rysare_nn_1_N = mkN "rysare" utrum  ;
  rysklaerare_nn_1_1_N = mkN "rysklärare" utrum  ;
  rysslaendare_nn_1_1_N = mkN "ryssländare" utrum  ;
  ryttare_nn_1_N = mkN "ryttare" utrum  ;
  ryttmaestare_nn_1_1_N = mkN "ryttmästare" utrum  ;
  raeddare_nn_1_1_N = mkN "räddare" utrum  ;
  raeddningsledare_nn_1_1_N = mkN "räddningsledare" utrum  ;
  raeknare_nn_1_1_N = mkN "räknare" utrum  ;
  raenksmidare_nn_1_1_N = mkN "ränksmidare" utrum  ;
  raentmaestare_nn_1_1_N = mkN "räntmästare" utrum  ;
  raettare_nn_1_1_N = mkN "rättare" utrum  ;
  raettsinnehavare_nn_1_1_N = mkN "rättsinnehavare" utrum  ;
  raettslaekare_nn_1_1_N = mkN "rättsläkare" utrum  ;
  raettstjaenare_nn_1_1_N = mkN "rättstjänare" utrum  ;
  raadgivare_nn_1_1_N = mkN "rådgivare" utrum  ;
  raadhuskaellare_nn_1_1_N = mkN "rådhuskällare" utrum  ;
  raanare_nn_1_1_N = mkN "rånare" utrum  ;
  raanmoerdare_nn_1_1_N = mkN "rånmördare" utrum  ;
  raaseglare_nn_1_1_N = mkN "råseglare" utrum  ;
  roedhakesaangare_nn_1_1_N = mkN "rödhakesångare" utrum  ;
  roejdykare_nn_1_1_N = mkN "röjdykare" utrum  ;
  roekare_nn_1_1_N = mkN "rökare" utrum  ;
  roekdykare_nn_1_1_N = mkN "rökdykare" utrum  ;
  roekpelare_nn_1_1_N = mkN "rökpelare" utrum  ;
  roerlaeggare_nn_1_1_N = mkN "rörläggare" utrum  ;
  roermokare_nn_1_1_N = mkN "rörmokare" utrum  ;
  roersaangare_nn_1_1_N = mkN "rörsångare" utrum  ;
  roevare_nn_1_1_N = mkN "rövare" utrum  ;
  roevslickare_nn_1_1_N = mkN "rövslickare" utrum  ;
  sachsare_nn_1_N = mkN "sachsare" utrum  ;
  sadelmakare_nn_1_N = mkN "sadelmakare" utrum  ;
  sagoberaettare_nn_1_1_N = mkN "sagoberättare" utrum  ;
  sakfoerare_nn_1_1_N = mkN "sakförare" utrum  ;
  sakramentsfoervaltare_nn_1_1_N = mkN "sakramentsförvaltare" utrum  ;
  sakaegare_nn_1_1_N = mkN "sakägare" utrum  ;
  salivsugare_nn_1_N = mkN "salivsugare" utrum  ;
  salongsuppassare_nn_1_N = mkN "salongsuppassare" utrum  ;
  saltbildare_nn_1_N = mkN "saltbildare" utrum  ;
  saltprovare_nn_1_N = mkN "saltprovare" utrum  ;
  saltstroeare_nn_1_1_N = mkN "saltströare" utrum  ;
  sambadansare_nn_1_N = mkN "sambadansare" utrum  ;
  sambyggare_nn_1_N = mkN "sambyggare" utrum  ;
  samhaellsbevarare_nn_1_1_N = mkN "samhällsbevarare" utrum  ;
  samhaellsforskare_nn_1_1_N = mkN "samhällsforskare" utrum  ;
  samhaellsfoerbaettrare_nn_1_1_N = mkN "samhällsförbättrare" utrum  ;
  samhaellshatare_nn_1_1_N = mkN "samhällshatare" utrum  ;
  samhaellskunskapslaerare_nn_1_1_N = mkN "samhällskunskapslärare" utrum  ;
  samhaellsomstoertare_nn_1_1_N = mkN "samhällsomstörtare" utrum  ;
  samhaellsplanerare_nn_1_1_N = mkN "samhällsplanerare" utrum  ;
  samhaellsvetare_nn_1_1_N = mkN "samhällsvetare" utrum  ;
  samlare_nn_1_N = mkN "samlare" utrum  ;
  samordnare_nn_1_N = mkN "samordnare" utrum  ;
  samtalsmaetare_nn_1_1_N = mkN "samtalsmätare" utrum  ;
  samtalsraeknare_nn_1_1_N = mkN "samtalsräknare" utrum  ;
  samtidsbetraktare_nn_1_N = mkN "samtidsbetraktare" utrum  ;
  sandbindare_nn_1_N = mkN "sandbindare" utrum  ;
  sandjaegare_nn_1_1_N = mkN "sandjägare" utrum  ;
  sandkrypare_nn_1_N = mkN "sandkrypare" utrum  ;
  sandloepare_nn_1_1_N = mkN "sandlöpare" utrum  ;
  sandsugare_nn_1_N = mkN "sandsugare" utrum  ;
  sandvikare_nn_1_N = mkN "sandvikare" utrum  ;
  sanmarinesare_nn_1_N = mkN "sanmarinesare" utrum  ;
  sanningssaegare_nn_1_1_N = mkN "sanningssägare" utrum  ;
  sanningssoekare_nn_1_1_N = mkN "sanningssökare" utrum  ;
  sardinare_nn_1_N = mkN "sardinare" utrum  ;
  saxare_nn_1_N = mkN "saxare" utrum  ;
  scenarbetare_nn_1_N = mkN "scenarbetare" utrum  ;
  scenkonstarbetare_nn_1_N = mkN "scenkonstarbetare" utrum  ;
  schackrare_nn_1_N = mkN "schackrare" utrum  ;
  schackspelare_nn_1_N = mkN "schackspelare" utrum  ;
  schillerstoevare_nn_1_1_N = mkN "schillerstövare" utrum  ;
  schweizare_nn_1_N = mkN "schweizare" utrum  ;
  sedlighetsivrare_nn_1_N = mkN "sedlighetsivrare" utrum  ;
  segelmakare_nn_1_N = mkN "segelmakare" utrum  ;
  segelsoemmare_nn_1_1_N = mkN "segelsömmare" utrum  ;
  seglare_nn_1_N = mkN "seglare" utrum  ;
  segrare_nn_1_N = mkN "segrare" utrum  ;
  sejdare_nn_1_N = mkN "sejdare" utrum  ;
  sekreterare_nn_1_N = mkN "sekreterare" utrum  ;
  sekundvisare_nn_1_N = mkN "sekundvisare" utrum  ;
  semesterfirare_nn_1_N = mkN "semesterfirare" utrum  ;
  seminarielaerare_nn_1_1_N = mkN "seminarielärare" utrum  ;
  sengaangare_nn_1_1_N = mkN "sengångare" utrum  ;
  separatistledare_nn_1_N = mkN "separatistledare" utrum  ;
  serbledare_nn_1_N = mkN "serbledare" utrum  ;
  seriemoerdare_nn_1_1_N = mkN "seriemördare" utrum  ;
  serietecknare_nn_1_N = mkN "serietecknare" utrum  ;
  sexfoerbrytare_nn_1_1_N = mkN "sexförbrytare" utrum  ;
  sexmaestare_nn_1_1_N = mkN "sexmästare" utrum  ;
  sexmoerdare_nn_1_1_N = mkN "sexmördare" utrum  ;
  sexraadgivare_nn_1_1_N = mkN "sexrådgivare" utrum  ;
  siare_nn_1_N = mkN "siare" utrum  ;
  sicilianare_nn_1_N = mkN "sicilianare" utrum  ;
  sigillbevarare_nn_1_N = mkN "sigillbevarare" utrum  ;
  silkespinnare_nn_1_N = mkN "silkespinnare" utrum  ;
  silkesspinnare_nn_1_N = mkN "silkesspinnare" utrum  ;
  sillstrypare_nn_1_N = mkN "sillstrypare" utrum  ;
  silverbaegare_nn_1_1_N = mkN "silverbägare" utrum  ;
  simlaerare_nn_1_1_N = mkN "simlärare" utrum  ;
  simmare_nn_1_N = mkN "simmare" utrum  ;
  sinkare_nn_1_N = mkN "sinkare" utrum  ;
  sinnessjuklaekare_nn_1_1_N = mkN "sinnessjukläkare" utrum  ;
  sjukbaerare_nn_1_1_N = mkN "sjukbärare" utrum  ;
  sjukskoetare_nn_1_1_N = mkN "sjukskötare" utrum  ;
  sjukvaardare_nn_1_1_N = mkN "sjukvårdare" utrum  ;
  sjusovare_nn_1_N = mkN "sjusovare" utrum  ;
  sjaelasoerjare_nn_1_1_N = mkN "själasörjare" utrum  ;
  sjaelvbindare_nn_1_1_N = mkN "självbindare" utrum  ;
  sjaelvfoernekare_nn_1_1_N = mkN "självförnekare" utrum  ;
  sjaelvhaerskare_nn_1_1_N = mkN "självhärskare" utrum  ;
  sjaelvmordsbombare_nn_1_1_N = mkN "självmordsbombare" utrum  ;
  sjaelvmoerdare_nn_1_1_N = mkN "självmördare" utrum  ;
  sjaelvplaagare_nn_1_1_N = mkN "självplågare" utrum  ;
  sjaelvutloesare_nn_1_1_N = mkN "självutlösare" utrum  ;
  sjaaare_nn_1_1_N = mkN "sjåare" utrum  ;
  sjoefarare_nn_1_1_N = mkN "sjöfarare" utrum  ;
  sjoeroevare_nn_1_1_N = mkN "sjörövare" utrum  ;
  skadegoerare_nn_1_1_N = mkN "skadegörare" utrum  ;
  skaffare_nn_1_N = mkN "skaffare" utrum  ;
  skapare_nn_1_N = mkN "skapare" utrum  ;
  skarpraettare_nn_1_1_N = mkN "skarprättare" utrum  ;
  skattebetalare_nn_1_N = mkN "skattebetalare" utrum  ;
  skattefifflare_nn_1_N = mkN "skattefifflare" utrum  ;
  skattefuskare_nn_1_N = mkN "skattefuskare" utrum  ;
  skatteindrivare_nn_1_N = mkN "skatteindrivare" utrum  ;
  skattesmitare_nn_1_N = mkN "skattesmitare" utrum  ;
  skattetrixare_nn_1_N = mkN "skattetrixare" utrum  ;
  skattmaestare_nn_1_1_N = mkN "skattmästare" utrum  ;
  skattsoekare_nn_1_1_N = mkN "skattsökare" utrum  ;
  skeppare_nn_1_N = mkN "skeppare" utrum  ;
  skeppsklarerare_nn_1_N = mkN "skeppsklarerare" utrum  ;
  skeppsmaeklare_nn_1_1_N = mkN "skeppsmäklare" utrum  ;
  skeppsredare_nn_1_N = mkN "skeppsredare" utrum  ;
  skidaakare_nn_1_1_N = mkN "skidåkare" utrum  ;
  skildrare_nn_1_N = mkN "skildrare" utrum  ;
  skiljedomare_nn_1_N = mkN "skiljedomare" utrum  ;
  skinnare_nn_1_N = mkN "skinnare" utrum  ;
  skivpratare_nn_1_N = mkN "skivpratare" utrum  ;
  skivspelare_nn_1_N = mkN "skivspelare" utrum  ;
  skoflickare_nn_1_N = mkN "skoflickare" utrum  ;
  skogsarbetare_nn_1_N = mkN "skogsarbetare" utrum  ;
  skogshuggare_nn_1_N = mkN "skogshuggare" utrum  ;
  skogsmaestare_nn_1_1_N = mkN "skogsmästare" utrum  ;
  skogstraedsfoeraedlare_nn_1_1_N = mkN "skogsträdsförädlare" utrum  ;
  skogvaktare_nn_1_N = mkN "skogvaktare" utrum  ;
  skojare_nn_1_N = mkN "skojare" utrum  ;
  skolkare_nn_1_N = mkN "skolkare" utrum  ;
  skolledare_nn_1_N = mkN "skolledare" utrum  ;
  skollaerare_nn_1_1_N = mkN "skollärare" utrum  ;
  skolmaestare_nn_1_1_N = mkN "skolmästare" utrum  ;
  skolvaktmaestare_nn_1_1_N = mkN "skolvaktmästare" utrum  ;
  skomakare_nn_1_N = mkN "skomakare" utrum  ;
  skonare_nn_1_N = mkN "skonare" utrum  ;
  skoputsare_nn_1_N = mkN "skoputsare" utrum  ;
  skorstensfejare_nn_1_N = mkN "skorstensfejare" utrum  ;
  skrattare_nn_1_N = mkN "skrattare" utrum  ;
  skridskoaakare_nn_1_1_N = mkN "skridskoåkare" utrum  ;
  skriftstaellare_nn_1_1_N = mkN "skriftställare" utrum  ;
  skrinnare_nn_1_N = mkN "skrinnare" utrum  ;
  skrivare_nn_1_N = mkN "skrivare" utrum  ;
  skrivmaskinstillverkare_nn_1_N = mkN "skrivmaskinstillverkare" utrum  ;
  skruvdragare_nn_1_N = mkN "skruvdragare" utrum  ;
  skrymtare_nn_1_N = mkN "skrymtare" utrum  ;
  skrytare_nn_1_N = mkN "skrytare" utrum  ;
  skraeckskildrare_nn_1_1_N = mkN "skräckskildrare" utrum  ;
  skraeddare_nn_1_1_N = mkN "skräddare" utrum  ;
  skraenare_nn_1_1_N = mkN "skränare" utrum  ;
  skraevlare_nn_1_1_N = mkN "skrävlare" utrum  ;
  skumslaeckare_nn_1_1_N = mkN "skumsläckare" utrum  ;
  skvallrare_nn_1_N = mkN "skvallrare" utrum  ;
  skyddare_nn_1_N = mkN "skyddare" utrum  ;
  skaemtare_nn_1_1_N = mkN "skämtare" utrum  ;
  skaemttecknare_nn_1_1_N = mkN "skämttecknare" utrum  ;
  skaendare_nn_1_1_N = mkN "skändare" utrum  ;
  skaerbraennare_nn_1_1_N = mkN "skärbrännare" utrum  ;
  skaergaardskryssare_nn_1_1_N = mkN "skärgårdskryssare" utrum  ;
  skaermslaeckare_nn_1_1_N = mkN "skärmsläckare" utrum  ;
  skaerslipare_nn_1_1_N = mkN "skärslipare" utrum  ;
  skaadespelare_nn_1_1_N = mkN "skådespelare" utrum  ;
  skaapsupare_nn_1_1_N = mkN "skåpsupare" utrum  ;
  skoeldhaallare_nn_1_1_N = mkN "sköldhållare" utrum  ;
  skoenskrivare_nn_1_1_N = mkN "skönskrivare" utrum  ;
  skoetare_nn_1_1_N = mkN "skötare" utrum  ;
  sladdhaallare_nn_1_1_N = mkN "sladdhållare" utrum  ;
  sladdrare_nn_1_N = mkN "sladdrare" utrum  ;
  slaktare_nn_1_N = mkN "slaktare" utrum  ;
  slalomaakare_nn_1_1_N = mkN "slalomåkare" utrum  ;
  slamkrypare_nn_1_N = mkN "slamkrypare" utrum  ;
  slavarbetare_nn_1_N = mkN "slavarbetare" utrum  ;
  slavdrivare_nn_1_N = mkN "slavdrivare" utrum  ;
  slavhandlare_nn_1_N = mkN "slavhandlare" utrum  ;
  slavsaendare_nn_1_1_N = mkN "slavsändare" utrum  ;
  slutare_nn_1_N = mkN "slutare" utrum  ;
  sloejdare_nn_1_1_N = mkN "slöjdare" utrum  ;
  sloesare_nn_1_1_N = mkN "slösare" utrum  ;
  smakdomare_nn_1_N = mkN "smakdomare" utrum  ;
  smakfoerstaerkare_nn_1_1_N = mkN "smakförstärkare" utrum  ;
  smickrare_nn_1_N = mkN "smickrare" utrum  ;
  smidare_nn_1_N = mkN "smidare" utrum  ;
  smilare_nn_1_N = mkN "smilare" utrum  ;
  sminkare_nn_1_N = mkN "sminkare" utrum  ;
  smitare_nn_1_N = mkN "smitare" utrum  ;
  smittbaerare_nn_1_1_N = mkN "smittbärare" utrum  ;
  smittskyddslaekare_nn_1_1_N = mkN "smittskyddsläkare" utrum  ;
  smittskyddssamordnare_nn_1_N = mkN "smittskyddssamordnare" utrum  ;
  smugglare_nn_1_N = mkN "smugglare" utrum  ;
  smygjaegare_nn_1_1_N = mkN "smygjägare" utrum  ;
  smaedare_nn_1_1_N = mkN "smädare" utrum  ;
  smaellare_nn_1_1_N = mkN "smällare" utrum  ;
  smaaborgare_nn_1_1_N = mkN "småborgare" utrum  ;
  smaabrukare_nn_1_1_N = mkN "småbrukare" utrum  ;
  smaafoeretagare_nn_1_1_N = mkN "småföretagare" utrum  ;
  smaagnagare_nn_1_1_N = mkN "smågnagare" utrum  ;
  smaahandlare_nn_1_1_N = mkN "småhandlare" utrum  ;
  smaahusaegare_nn_1_1_N = mkN "småhusägare" utrum  ;
  smaajordbrukare_nn_1_1_N = mkN "småjordbrukare" utrum  ;
  smaasparare_nn_1_1_N = mkN "småsparare" utrum  ;
  snabbladdare_nn_1_N = mkN "snabbladdare" utrum  ;
  snabbvaeljare_nn_1_1_N = mkN "snabbväljare" utrum  ;
  snarkare_nn_1_N = mkN "snarkare" utrum  ;
  snattare_nn_1_N = mkN "snattare" utrum  ;
  snedseglare_nn_1_N = mkN "snedseglare" utrum  ;
  snickare_nn_1_N = mkN "snickare" utrum  ;
  snidare_nn_1_N = mkN "snidare" utrum  ;
  snitsare_nn_1_N = mkN "snitsare" utrum  ;
  snoppare_nn_1_N = mkN "snoppare" utrum  ;
  snyltare_nn_1_N = mkN "snyltare" utrum  ;
  snoepare_nn_1_1_N = mkN "snöpare" utrum  ;
  snoermakare_nn_1_1_N = mkN "snörmakare" utrum  ;
  snoescooterfoerare_nn_1_1_N = mkN "snöscooterförare" utrum  ;
  snoeskoterfoerare_nn_1_1_N = mkN "snöskoterförare" utrum  ;
  snoeskottare_nn_1_1_N = mkN "snöskottare" utrum  ;
  socialarbetare_nn_1_N = mkN "socialarbetare" utrum  ;
  socialhjaelpstagare_nn_1_1_N = mkN "socialhjälpstagare" utrum  ;
  sociallaekare_nn_1_1_N = mkN "socialläkare" utrum  ;
  socialmedicinare_nn_1_N = mkN "socialmedicinare" utrum  ;
  sockerbagare_nn_1_N = mkN "sockerbagare" utrum  ;
  sockerstroeare_nn_1_1_N = mkN "sockerströare" utrum  ;
  soffliggare_nn_1_N = mkN "soffliggare" utrum  ;
  sol_och_vaarare_nn_1_1_N = mkN "sol-och-vårare" utrum  ;
  solbadare_nn_1_N = mkN "solbadare" utrum  ;
  soldyrkare_nn_1_N = mkN "soldyrkare" utrum  ;
  solforskare_nn_1_N = mkN "solforskare" utrum  ;
  solfaangare_nn_1_1_N = mkN "solfångare" utrum  ;
  solochvaarare_nn_1_1_N = mkN "solochvårare" utrum  ;
  solvisare_nn_1_N = mkN "solvisare" utrum  ;
  solvaermefaangare_nn_1_1_N = mkN "solvärmefångare" utrum  ;
  sommarpratare_nn_1_N = mkN "sommarpratare" utrum  ;
  sommarstugeaegare_nn_1_1_N = mkN "sommarstugeägare" utrum  ;
  sophaemtare_nn_1_1_N = mkN "sophämtare" utrum  ;
  sopsaeckshaallare_nn_1_1_N = mkN "sopsäckshållare" utrum  ;
  sopaakare_nn_1_1_N = mkN "sopåkare" utrum  ;
  sorterare_nn_1_N = mkN "sorterare" utrum  ;
  sotare_nn_1_N = mkN "sotare" utrum  ;
  sovjetmedborgare_nn_1_N = mkN "sovjetmedborgare" utrum  ;
  spanare_nn_1_N = mkN "spanare" utrum  ;
  sparare_nn_1_N = mkN "sparare" utrum  ;
  specerihandlare_nn_1_N = mkN "specerihandlare" utrum  ;
  specialare_nn_1_N = mkN "specialare" utrum  ;
  specialdammsugare_nn_1_N = mkN "specialdammsugare" utrum  ;
  speciallaerare_nn_1_1_N = mkN "speciallärare" utrum  ;
  spejare_nn_1_N = mkN "spejare" utrum  ;
  spelare_nn_1_N = mkN "spelare" utrum  ;
  spetsborgare_nn_1_N = mkN "spetsborgare" utrum  ;
  spinnare_nn_1_N = mkN "spinnare" utrum  ;
  spisare_nn_1_N = mkN "spisare" utrum  ;
  splittrare_nn_1_N = mkN "splittrare" utrum  ;
  spridare_nn_1_N = mkN "spridare" utrum  ;
  springare_nn_1_N = mkN "springare" utrum  ;
  spritsmugglare_nn_1_N = mkN "spritsmugglare" utrum  ;
  spraakbrukare_nn_1_1_N = mkN "språkbrukare" utrum  ;
  spraakforskare_nn_1_1_N = mkN "språkforskare" utrum  ;
  spraaklaerare_nn_1_1_N = mkN "språklärare" utrum  ;
  spraakvetare_nn_1_1_N = mkN "språkvetare" utrum  ;
  spraakvaardare_nn_1_1_N = mkN "språkvårdare" utrum  ;
  spaeckhuggare_nn_1_1_N = mkN "späckhuggare" utrum  ;
  spaenningsdelare_nn_1_1_N = mkN "spänningsdelare" utrum  ;
  spaenningsomvandlare_nn_1_1_N = mkN "spänningsomvandlare" utrum  ;
  spaenningssoekare_nn_1_1_N = mkN "spänningssökare" utrum  ;
  spoekskrivare_nn_1_1_N = mkN "spökskrivare" utrum  ;
  stackare_nn_1_N = mkN "stackare" utrum  ;
  stadsjeepaegare_nn_1_1_N = mkN "stadsjeepägare" utrum  ;
  stadsplanerare_nn_1_N = mkN "stadsplanerare" utrum  ;
  stadssekreterare_nn_1_N = mkN "stadssekreterare" utrum  ;
  stafettlaekare_nn_1_1_N = mkN "stafettläkare" utrum  ;
  stalkare_nn_1_N = mkN "stalkare" utrum  ;
  stallmaestare_nn_1_1_N = mkN "stallmästare" utrum  ;
  stamkrigare_nn_1_N = mkN "stamkrigare" utrum  ;
  stammare_nn_1_N = mkN "stammare" utrum  ;
  statare_nn_1_N = mkN "statare" utrum  ;
  statssekreterare_nn_1_N = mkN "statssekreterare" utrum  ;
  statsvetare_nn_1_N = mkN "statsvetare" utrum  ;
  stegraeknare_nn_1_1_N = mkN "stegräknare" utrum  ;
  stekare_nn_1_N = mkN "stekare" utrum  ;
  stekburgare_nn_1_N = mkN "stekburgare" utrum  ;
  stenhuggare_nn_1_N = mkN "stenhuggare" utrum  ;
  stenkastare_nn_1_N = mkN "stenkastare" utrum  ;
  stensaettare_nn_1_1_N = mkN "stensättare" utrum  ;
  stiftare_nn_1_N = mkN "stiftare" utrum  ;
  stigfinnare_nn_1_N = mkN "stigfinnare" utrum  ;
  stilbildare_nn_1_N = mkN "stilbildare" utrum  ;
  stjaernkroegare_nn_1_1_N = mkN "stjärnkrögare" utrum  ;
  stjaernskaadespelare_nn_1_1_N = mkN "stjärnskådespelare" utrum  ;
  stjaerntraenare_nn_1_1_N = mkN "stjärntränare" utrum  ;
  stjaerntydare_nn_1_1_N = mkN "stjärntydare" utrum  ;
  stockholmare_nn_1_N = mkN "stockholmare" utrum  ;
  storbolagsaegare_nn_1_1_N = mkN "storbolagsägare" utrum  ;
  storgodsaegare_nn_1_1_N = mkN "storgodsägare" utrum  ;
  stormaestare_nn_1_1_N = mkN "stormästare" utrum  ;
  storskrytare_nn_1_N = mkN "storskrytare" utrum  ;
  storskraevlare_nn_1_1_N = mkN "storskrävlare" utrum  ;
  storsaeljare_nn_1_1_N = mkN "storsäljare" utrum  ;
  storviltjaegare_nn_1_1_N = mkN "storviltjägare" utrum  ;
  strandpipare_nn_1_N = mkN "strandpipare" utrum  ;
  streckkodlaesare_nn_1_1_N = mkN "streckkodläsare" utrum  ;
  streckkodslaesare_nn_1_1_N = mkN "streckkodsläsare" utrum  ;
  strejkare_nn_1_N = mkN "strejkare" utrum  ;
  strejkbrytare_nn_1_N = mkN "strejkbrytare" utrum  ;
  stridsdomare_nn_1_N = mkN "stridsdomare" utrum  ;
  strumphaallare_nn_1_1_N = mkN "strumphållare" utrum  ;
  strupsaangare_nn_1_1_N = mkN "strupsångare" utrum  ;
  strykare_nn_1_N = mkN "strykare" utrum  ;
  strypare_nn_1_N = mkN "strypare" utrum  ;
  straeckare_nn_1_1_N = mkN "sträckare" utrum  ;
  straevpelare_nn_1_1_N = mkN "strävpelare" utrum  ;
  straalgaangsmaetare_nn_1_1_N = mkN "strålgångsmätare" utrum  ;
  straalkastare_nn_1_1_N = mkN "strålkastare" utrum  ;
  straatroevare_nn_1_1_N = mkN "stråtrövare" utrum  ;
  stroeare_nn_1_1_N = mkN "ströare" utrum  ;
  stroemavtagare_nn_1_1_N = mkN "strömavtagare" utrum  ;
  stroembrytare_nn_1_1_N = mkN "strömbrytare" utrum  ;
  stroemmaetare_nn_1_1_N = mkN "strömmätare" utrum  ;
  stroemstaellare_nn_1_1_N = mkN "strömställare" utrum  ;
  stroevare_nn_1_1_N = mkN "strövare" utrum  ;
  studievaegledare_nn_1_1_N = mkN "studievägledare" utrum  ;
  studsare_nn_1_N = mkN "studsare" utrum  ;
  stugsittare_nn_1_N = mkN "stugsittare" utrum  ;
  stuvare_nn_1_N = mkN "stuvare" utrum  ;
  stuveriarbetare_nn_1_N = mkN "stuveriarbetare" utrum  ;
  styckjunkare_nn_1_N = mkN "styckjunkare" utrum  ;
  styckmaestare_nn_1_1_N = mkN "styckmästare" utrum  ;
  styckmoerdare_nn_1_1_N = mkN "styckmördare" utrum  ;
  stympare_nn_1_N = mkN "stympare" utrum  ;
  styrkeledare_nn_1_N = mkN "styrkeledare" utrum  ;
  staedare_nn_1_1_N = mkN "städare" utrum  ;
  staellfoeretraedare_nn_1_1_N = mkN "ställföreträdare" utrum  ;
  staemningshoejare_nn_1_1_N = mkN "stämningshöjare" utrum  ;
  staandare_nn_1_1_N = mkN "ståndare" utrum  ;
  staangryttare_nn_1_1_N = mkN "stångryttare" utrum  ;
  staathaallare_nn_1_1_N = mkN "ståthållare" utrum  ;
  staauppare_nn_1_1_N = mkN "ståuppare" utrum  ;
  stoedjepelare_nn_1_1_N = mkN "stödjepelare" utrum  ;
  stoepplare_nn_1_1_N = mkN "stöpplare" utrum  ;
  stoetdaempare_nn_1_1_N = mkN "stötdämpare" utrum  ;
  stoetfaangare_nn_1_1_N = mkN "stötfångare" utrum  ;
  stoettepelare_nn_1_1_N = mkN "stöttepelare" utrum  ;
  stoevare_nn_1_1_N = mkN "stövare" utrum  ;
  supare_nn_1_N = mkN "supare" utrum  ;
  supraledare_nn_1_N = mkN "supraledare" utrum  ;
  surfare_nn_1_N = mkN "surfare" utrum  ;
  sutare_nn_1_N = mkN "sutare" utrum  ;
  svampplockare_nn_1_N = mkN "svampplockare" utrum  ;
  svansviftare_nn_1_N = mkN "svansviftare" utrum  ;
  svarvare_nn_1_N = mkN "svarvare" utrum  ;
  svenskfoernekare_nn_1_1_N = mkN "svenskförnekare" utrum  ;
  svenskhetsivrare_nn_1_N = mkN "svenskhetsivrare" utrum  ;
  svensklaerare_nn_1_1_N = mkN "svensklärare" utrum  ;
  svetsare_nn_1_N = mkN "svetsare" utrum  ;
  svikare_nn_1_N = mkN "svikare" utrum  ;
  svindlare_nn_1_N = mkN "svindlare" utrum  ;
  svirare_nn_1_N = mkN "svirare" utrum  ;
  svaerdbaerare_nn_1_1_N = mkN "svärdbärare" utrum  ;
  svaerdfejare_nn_1_1_N = mkN "svärdfejare" utrum  ;
  svaerdsfejare_nn_1_1_N = mkN "svärdsfejare" utrum  ;
  svaerdslukare_nn_1_1_N = mkN "svärdslukare" utrum  ;
  svaerdsslukare_nn_1_1_N = mkN "svärdsslukare" utrum  ;
  svaermare_nn_1_1_N = mkN "svärmare" utrum  ;
  svaevare_nn_1_1_N = mkN "svävare" utrum  ;
  svaevarklippare_nn_1_1_N = mkN "svävarklippare" utrum  ;
  swazilaendare_nn_1_1_N = mkN "swaziländare" utrum  ;
  synare_nn_1_N = mkN "synare" utrum  ;
  syndare_nn_1_N = mkN "syndare" utrum  ;
  syraprovare_nn_1_N = mkN "syraprovare" utrum  ;
  systemerare_nn_1_N = mkN "systemerare" utrum  ;
  systemutvecklare_nn_1_N = mkN "systemutvecklare" utrum  ;
  saedesledare_nn_1_1_N = mkN "sädesledare" utrum  ;
  saekerhetsbrytare_nn_1_1_N = mkN "säkerhetsbrytare" utrum  ;
  saekerhetsraadgivare_nn_1_1_N = mkN "säkerhetsrådgivare" utrum  ;
  saekringshaallare_nn_1_1_N = mkN "säkringshållare" utrum  ;
  saeljare_nn_1_1_N = mkN "säljare" utrum  ;
  saendare_nn_1_1_N = mkN "sändare" utrum  ;
  saengfoesare_nn_1_1_N = mkN "sängfösare" utrum  ;
  saengroekare_nn_1_1_N = mkN "sängrökare" utrum  ;
  saengvaetare_nn_1_1_N = mkN "sängvätare" utrum  ;
  saettare_nn_1_1_N = mkN "sättare" utrum  ;
  saevsaangare_nn_1_1_N = mkN "sävsångare" utrum  ;
  saagverksarbetare_nn_1_1_N = mkN "sågverksarbetare" utrum  ;
  saagverksjobbare_nn_1_1_N = mkN "sågverksjobbare" utrum  ;
  saanganfoerare_nn_1_1_N = mkN "sånganförare" utrum  ;
  saangare_nn_1_1_N = mkN "sångare" utrum  ;
  soekare_nn_1_1_N = mkN "sökare" utrum  ;
  soelare_nn_1_1_N = mkN "sölare" utrum  ;
  soemmare_nn_1_1_N = mkN "sömmare" utrum  ;
  soemngaangare_nn_1_1_N = mkN "sömngångare" utrum  ;
  soendagsjaegare_nn_1_1_N = mkN "söndagsjägare" utrum  ;
  soetvattensforskare_nn_1_1_N = mkN "sötvattensforskare" utrum  ;
  tackjaernsblandare_nn_1_1_N = mkN "tackjärnsblandare" utrum  ;
  taffeltaeckare_nn_1_1_N = mkN "taffeltäckare" utrum  ;
  tafsare_nn_1_N = mkN "tafsare" utrum  ;
  taggare_nn_1_N = mkN "taggare" utrum  ;
  takklaettrare_nn_1_1_N = mkN "takklättrare" utrum  ;
  taklaeggare_nn_1_1_N = mkN "takläggare" utrum  ;
  takryttare_nn_1_N = mkN "takryttare" utrum  ;
  takskottare_nn_1_N = mkN "takskottare" utrum  ;
  taktaeckare_nn_1_1_N = mkN "taktäckare" utrum  ;
  talare_nn_1_N = mkN "talare" utrum  ;
  tallmaetare_nn_1_1_N = mkN "tallmätare" utrum  ;
  tallriksslickare_nn_1_N = mkN "tallriksslickare" utrum  ;
  tallspinnare_nn_1_N = mkN "tallspinnare" utrum  ;
  talskrivare_nn_1_N = mkN "talskrivare" utrum  ;
  tamburvaktmaestare_nn_1_1_N = mkN "tamburvaktmästare" utrum  ;
  tandlaekare_nn_1_1_N = mkN "tandläkare" utrum  ;
  tandpetare_nn_1_N = mkN "tandpetare" utrum  ;
  tangodansare_nn_1_N = mkN "tangodansare" utrum  ;
  tankelaesare_nn_1_1_N = mkN "tankeläsare" utrum  ;
  tankestaellare_nn_1_1_N = mkN "tankeställare" utrum  ;
  tape_nn_1_N = mkN "tape" utrum  ;
  tapetserare_nn_1_N = mkN "tapetserare" utrum  ;
  taskspelare_nn_1_N = mkN "taskspelare" utrum  ;
  tattare_nn_1_N = mkN "tattare" utrum  ;
  tatuerare_nn_1_N = mkN "tatuerare" utrum  ;
  teaterbesoekare_nn_1_1_N = mkN "teaterbesökare" utrum  ;
  teaterkikare_nn_1_N = mkN "teaterkikare" utrum  ;
  teckenskaadare_nn_1_1_N = mkN "teckenskådare" utrum  ;
  teckentydare_nn_1_N = mkN "teckentydare" utrum  ;
  tecknare_nn_1_N = mkN "tecknare" utrum  ;
  tegelbruksarbetare_nn_1_N = mkN "tegelbruksarbetare" utrum  ;
  tegelmaestare_nn_1_1_N = mkN "tegelmästare" utrum  ;
  tegelslagare_nn_1_N = mkN "tegelslagare" utrum  ;
  teknikraadgivare_nn_1_1_N = mkN "teknikrådgivare" utrum  ;
  tekokare_nn_1_N = mkN "tekokare" utrum  ;
  telefonsvarare_nn_1_N = mkN "telefonsvarare" utrum  ;
  telefonvaektare_nn_1_1_N = mkN "telefonväktare" utrum  ;
  tempelriddare_nn_1_N = mkN "tempelriddare" utrum  ;
  temperaturgivare_nn_1_N = mkN "temperaturgivare" utrum  ;
  tempoarbetare_nn_1_N = mkN "tempoarbetare" utrum  ;
  tennisspelare_nn_1_N = mkN "tennisspelare" utrum  ;
  tenorsaangare_nn_1_1_N = mkN "tenorsångare" utrum  ;
  terroristledare_nn_1_N = mkN "terroristledare" utrum  ;
  testuggare_nn_1_N = mkN "testuggare" utrum  ;
  tevemottagare_nn_1_N = mkN "tevemottagare" utrum  ;
  tevesaendare_nn_1_1_N = mkN "tevesändare" utrum  ;
  tevetittare_nn_1_N = mkN "tevetittare" utrum  ;
  textilarbetare_nn_1_N = mkN "textilarbetare" utrum  ;
  textillaerare_nn_1_1_N = mkN "textillärare" utrum  ;
  thailaendare_nn_1_1_N = mkN "thailändare" utrum  ;
  tibetanare_nn_1_N = mkN "tibetanare" utrum  ;
  tidningsledare_nn_1_N = mkN "tidningsledare" utrum  ;
  tidningslaesare_nn_1_1_N = mkN "tidningsläsare" utrum  ;
  tidstroemstaellare_nn_1_1_N = mkN "tidströmställare" utrum  ;
  tidtagare_nn_1_N = mkN "tidtagare" utrum  ;
  tigare_nn_1_N = mkN "tigare" utrum  ;
  tiggare_nn_1_N = mkN "tiggare" utrum  ;
  tillbedjare_nn_1_N = mkN "tillbedjare" utrum  ;
  tillbringare_nn_1_N = mkN "tillbringare" utrum  ;
  tillfaellighetsfoerbrytare_nn_1_1_N = mkN "tillfällighetsförbrytare" utrum  ;
  tillskyndare_nn_1_N = mkN "tillskyndare" utrum  ;
  tillskaerare_nn_1_1_N = mkN "tillskärare" utrum  ;
  tillslutare_nn_1_N = mkN "tillslutare" utrum  ;
  tillstaellare_nn_1_1_N = mkN "tillställare" utrum  ;
  tillsynslaerare_nn_1_1_N = mkN "tillsynslärare" utrum  ;
  tilltraedare_nn_1_1_N = mkN "tillträdare" utrum  ;
  tillverkare_nn_1_N = mkN "tillverkare" utrum  ;
  timlaerare_nn_1_1_N = mkN "timlärare" utrum  ;
  timvisare_nn_1_N = mkN "timvisare" utrum  ;
  tippare_nn_1_N = mkN "tippare" utrum  ;
  tisslare_nn_1_N = mkN "tisslare" utrum  ;
  titelfoersvarare_nn_1_1_N = mkN "titelförsvarare" utrum  ;
  tittare_nn_1_N = mkN "tittare" utrum  ;
  tjallare_nn_1_N = mkN "tjallare" utrum  ;
  tjottablaengare_nn_1_1_N = mkN "tjottablängare" utrum  ;
  tjurfaektare_nn_1_1_N = mkN "tjurfäktare" utrum  ;
  tjurfaektningsmotstaandare_nn_1_1_N = mkN "tjurfäktningsmotståndare" utrum  ;
  tjusare_nn_1_N = mkN "tjusare" utrum  ;
  tjuvfiskare_nn_1_N = mkN "tjuvfiskare" utrum  ;
  tjuvgoemmare_nn_1_1_N = mkN "tjuvgömmare" utrum  ;
  tjuvjaegare_nn_1_1_N = mkN "tjuvjägare" utrum  ;
  tjyvfiskare_nn_1_N = mkN "tjyvfiskare" utrum  ;
  tjyvjaegare_nn_1_1_N = mkN "tjyvjägare" utrum  ;
  tjaenare_nn_1_1_N = mkN "tjänare" utrum  ;
  tjaenstefoerraettare_nn_1_1_N = mkN "tjänsteförrättare" utrum  ;
  tobakshandlare_nn_1_N = mkN "tobakshandlare" utrum  ;
  toftvaegare_nn_1_1_N = mkN "toftvägare" utrum  ;
  tolkare_nn_1_N = mkN "tolkare" utrum  ;
  tolvtaggare_nn_1_N = mkN "tolvtaggare" utrum  ;
  tomtjobbare_nn_1_N = mkN "tomtjobbare" utrum  ;
  tonsaettare_nn_1_1_N = mkN "tonsättare" utrum  ;
  tonaarsfoeroevare_nn_1_1_N = mkN "tonårsförövare" utrum  ;
  torktumlare_nn_1_N = mkN "torktumlare" utrum  ;
  tornseglare_nn_1_N = mkN "tornseglare" utrum  ;
  tornvaektare_nn_1_1_N = mkN "tornväktare" utrum  ;
  torpare_nn_1_N = mkN "torpare" utrum  ;
  torpaegare_nn_1_1_N = mkN "torpägare" utrum  ;
  totempelare_nn_1_N = mkN "totempelare" utrum  ;
  traditionsbaerare_nn_1_1_N = mkN "traditionsbärare" utrum  ;
  trafikdelare_nn_1_N = mkN "trafikdelare" utrum  ;
  trafikflygare_nn_1_N = mkN "trafikflygare" utrum  ;
  trafikledare_nn_1_N = mkN "trafikledare" utrum  ;
  tragedifoerfattare_nn_1_1_N = mkN "tragediförfattare" utrum  ;
  transportarbetare_nn_1_N = mkN "transportarbetare" utrum  ;
  travare_nn_1_N = mkN "travare" utrum  ;
  treaktare_nn_1_N = mkN "treaktare" utrum  ;
  tremastare_nn_1_N = mkN "tremastare" utrum  ;
  trendsaettare_nn_1_1_N = mkN "trendsättare" utrum  ;
  trerummare_nn_1_N = mkN "trerummare" utrum  ;
  trevare_nn_1_N = mkN "trevare" utrum  ;
  tripplare_nn_1_N = mkN "tripplare" utrum  ;
  trippmaetare_nn_1_1_N = mkN "trippmätare" utrum  ;
  tronfoeljare_nn_1_1_N = mkN "tronföljare" utrum  ;
  trosbekaennare_nn_1_1_N = mkN "trosbekännare" utrum  ;
  trosivrare_nn_1_N = mkN "trosivrare" utrum  ;
  trosletare_nn_1_N = mkN "trosletare" utrum  ;
  trotjaenare_nn_1_1_N = mkN "trotjänare" utrum  ;
  trumpetare_nn_1_N = mkN "trumpetare" utrum  ;
  trumslagare_nn_1_N = mkN "trumslagare" utrum  ;
  tryckare_nn_1_N = mkN "tryckare" utrum  ;
  tryckbehaallare_nn_1_1_N = mkN "tryckbehållare" utrum  ;
  tryckbraennare_nn_1_1_N = mkN "tryckbrännare" utrum  ;
  tryckkokare_nn_1_N = mkN "tryckkokare" utrum  ;
  traeblaasare_nn_1_1_N = mkN "träblåsare" utrum  ;
  traedgaardsmaestare_nn_1_1_N = mkN "trädgårdsmästare" utrum  ;
  traedgaardsodlare_nn_1_1_N = mkN "trädgårdsodlare" utrum  ;
  traedgaardsstaedare_nn_1_1_N = mkN "trädgårdsstädare" utrum  ;
  traedgaardssaangare_nn_1_1_N = mkN "trädgårdssångare" utrum  ;
  traedkramare_nn_1_1_N = mkN "trädkramare" utrum  ;
  traedkrypare_nn_1_1_N = mkN "trädkrypare" utrum  ;
  traenare_nn_1_1_N = mkN "tränare" utrum  ;
  traesnidare_nn_1_1_N = mkN "träsnidare" utrum  ;
  traalare_nn_1_1_N = mkN "trålare" utrum  ;
  troestare_nn_1_1_N = mkN "tröstare" utrum  ;
  tubkikare_nn_1_N = mkN "tubkikare" utrum  ;
  tuktomaestare_nn_1_1_N = mkN "tuktomästare" utrum  ;
  tullare_nn_1_N = mkN "tullare" utrum  ;
  tullfoervaltare_nn_1_1_N = mkN "tullförvaltare" utrum  ;
  tumlare_nn_1_N = mkN "tumlare" utrum  ;
  tumsugare_nn_1_N = mkN "tumsugare" utrum  ;
  tungomaalstalare_nn_1_1_N = mkN "tungomålstalare" utrum  ;
  tungviktare_nn_1_N = mkN "tungviktare" utrum  ;
  tungvrickare_nn_1_N = mkN "tungvrickare" utrum  ;
  tunnbindare_nn_1_N = mkN "tunnbindare" utrum  ;
  tv_mottagare_nn_1_N = mkN "tv-mottagare" utrum  ;
  tv_saendare_nn_1_1_N = mkN "tv-sändare" utrum  ;
  tv_tittare_nn_1_N = mkN "tv-tittare" utrum  ;
  tvivlare_nn_1_N = mkN "tvivlare" utrum  ;
  tvaabyggare_nn_1_1_N = mkN "tvåbyggare" utrum  ;
  tvaamastare_nn_1_1_N = mkN "tvåmastare" utrum  ;
  tvaarummare_nn_1_1_N = mkN "tvårummare" utrum  ;
  tvaastegsavtryckare_nn_1_1_N = mkN "tvåstegsavtryckare" utrum  ;
  tvaataktare_nn_1_1_N = mkN "tvåtaktare" utrum  ;
  tyckare_nn_1_N = mkN "tyckare" utrum  ;
  tyngdlyftare_nn_1_N = mkN "tyngdlyftare" utrum  ;
  tyrolare_nn_1_N = mkN "tyrolare" utrum  ;
  tysklaerare_nn_1_1_N = mkN "tysklärare" utrum  ;
  taeljare_nn_1_1_N = mkN "täljare" utrum  ;
  taeltare_nn_1_1_N = mkN "tältare" utrum  ;
  taendare_nn_1_1_N = mkN "tändare" utrum  ;
  taenkare_nn_1_1_N = mkN "tänkare" utrum  ;
  taerningsbaegare_nn_1_1_N = mkN "tärningsbägare" utrum  ;
  taerningsspelare_nn_1_1_N = mkN "tärningsspelare" utrum  ;
  taevlingsledare_nn_1_1_N = mkN "tävlingsledare" utrum  ;
  taagklarerare_nn_1_1_N = mkN "tågklarerare" utrum  ;
  taagpassagerare_nn_1_1_N = mkN "tågpassagerare" utrum  ;
  taagraanare_nn_1_1_N = mkN "tågrånare" utrum  ;
  taagaangare_nn_1_1_N = mkN "tågångare" utrum  ;
  toejningsmaetare_nn_1_1_N = mkN "töjningsmätare" utrum  ;
  toernsaangare_nn_1_1_N = mkN "törnsångare" utrum  ;
  ubaatsfoerstoerare_nn_1_1_N = mkN "ubåtsförstörare" utrum  ;
  ubaatsjagare_nn_1_1_N = mkN "ubåtsjagare" utrum  ;
  ufohackare_nn_1_N = mkN "ufohackare" utrum  ;
  ukrainare_nn_1_N = mkN "ukrainare" utrum  ;
  underbefaelhavare_nn_1_1_N = mkN "underbefälhavare" utrum  ;
  undergoerare_nn_1_1_N = mkN "undergörare" utrum  ;
  underhandlare_nn_1_N = mkN "underhandlare" utrum  ;
  underhuggare_nn_1_N = mkN "underhuggare" utrum  ;
  underhaallare_nn_1_1_N = mkN "underhållare" utrum  ;
  underklassare_nn_1_N = mkN "underklassare" utrum  ;
  underledare_nn_1_N = mkN "underledare" utrum  ;
  underlaekare_nn_1_1_N = mkN "underläkare" utrum  ;
  underspaennare_nn_1_1_N = mkN "underspännare" utrum  ;
  understreckare_nn_1_N = mkN "understreckare" utrum  ;
  undersoekare_nn_1_1_N = mkN "undersökare" utrum  ;
  undersoekningsdomare_nn_1_1_N = mkN "undersökningsdomare" utrum  ;
  undertecknare_nn_1_N = mkN "undertecknare" utrum  ;
  undervisare_nn_1_N = mkN "undervisare" utrum  ;
  ungdomsledare_nn_1_N = mkN "ungdomsledare" utrum  ;
  ungdomsvaeljare_nn_1_1_N = mkN "ungdomsväljare" utrum  ;
  ungrare_nn_1_N = mkN "ungrare" utrum  ;
  uppassare_nn_1_N = mkN "uppassare" utrum  ;
  uppbackare_nn_1_N = mkN "uppbackare" utrum  ;
  uppdragsgivare_nn_1_N = mkN "uppdragsgivare" utrum  ;
  uppdragsmoerdare_nn_1_1_N = mkN "uppdragsmördare" utrum  ;
  uppdragstagare_nn_1_N = mkN "uppdragstagare" utrum  ;
  uppesittare_nn_1_N = mkN "uppesittare" utrum  ;
  uppfinnare_nn_1_N = mkN "uppfinnare" utrum  ;
  uppfostrare_nn_1_N = mkN "uppfostrare" utrum  ;
  uppfoedare_nn_1_1_N = mkN "uppfödare" utrum  ;
  uppfoeljare_nn_1_1_N = mkN "uppföljare" utrum  ;
  uppgiftslaemnare_nn_1_1_N = mkN "uppgiftslämnare" utrum  ;
  upphalare_nn_1_N = mkN "upphalare" utrum  ;
  upphandlare_nn_1_N = mkN "upphandlare" utrum  ;
  upphittare_nn_1_N = mkN "upphittare" utrum  ;
  upphovsraettsinnehavare_nn_1_1_N = mkN "upphovsrättsinnehavare" utrum  ;
  uppkomlingsbloggare_nn_1_N = mkN "uppkomlingsbloggare" utrum  ;
  uppkoepare_nn_1_1_N = mkN "uppköpare" utrum  ;
  upplaesare_nn_1_1_N = mkN "uppläsare" utrum  ;
  uppmaerksamhetspaakallare_nn_1_1_N = mkN "uppmärksamhetspåkallare" utrum  ;
  upprorsmakare_nn_1_N = mkN "upprorsmakare" utrum  ;
  upprymmare_nn_1_N = mkN "upprymmare" utrum  ;
  uppraettare_nn_1_1_N = mkN "upprättare" utrum  ;
  uppraetthaallare_nn_1_1_N = mkN "upprätthållare" utrum  ;
  uppsamlare_nn_1_N = mkN "uppsamlare" utrum  ;
  uppsittare_nn_1_N = mkN "uppsittare" utrum  ;
  uppskaerare_nn_1_1_N = mkN "uppskärare" utrum  ;
  uppstickare_nn_1_N = mkN "uppstickare" utrum  ;
  uppsaettare_nn_1_1_N = mkN "uppsättare" utrum  ;
  upptecknare_nn_1_N = mkN "upptecknare" utrum  ;
  upptaeckare_nn_1_1_N = mkN "upptäckare" utrum  ;
  upptaagsmakare_nn_1_1_N = mkN "upptågsmakare" utrum  ;
  uppviglare_nn_1_N = mkN "uppviglare" utrum  ;
  uppaatstraevare_nn_1_1_N = mkN "uppåtsträvare" utrum  ;
  urinbyggare_nn_1_N = mkN "urinbyggare" utrum  ;
  urinledare_nn_1_N = mkN "urinledare" utrum  ;
  urinnevaanare_nn_1_1_N = mkN "urinnevånare" utrum  ;
  urinvaanare_nn_1_1_N = mkN "urinvånare" utrum  ;
  urladdare_nn_1_N = mkN "urladdare" utrum  ;
  urmakare_nn_1_N = mkN "urmakare" utrum  ;
  uruguayare_nn_1_N = mkN "uruguayare" utrum  ;
  utbordare_nn_1_N = mkN "utbordare" utrum  ;
  utbrytare_nn_1_N = mkN "utbrytare" utrum  ;
  utdragare_nn_1_N = mkN "utdragare" utrum  ;
  uteliggare_nn_1_N = mkN "uteliggare" utrum  ;
  utespelare_nn_1_N = mkN "utespelare" utrum  ;
  uteaetare_nn_1_1_N = mkN "uteätare" utrum  ;
  utforskare_nn_1_N = mkN "utforskare" utrum  ;
  utfoersaakare_nn_1_1_N = mkN "utförsåkare" utrum  ;
  utgivare_nn_1_N = mkN "utgivare" utrum  ;
  utgraevare_nn_1_1_N = mkN "utgrävare" utrum  ;
  uthalare_nn_1_N = mkN "uthalare" utrum  ;
  utkastare_nn_1_N = mkN "utkastare" utrum  ;
  utkoerare_nn_1_1_N = mkN "utkörare" utrum  ;
  utlaeggare_nn_1_1_N = mkN "utläggare" utrum  ;
  utlaanare_nn_1_1_N = mkN "utlånare" utrum  ;
  utloepare_nn_1_1_N = mkN "utlöpare" utrum  ;
  utloesare_nn_1_1_N = mkN "utlösare" utrum  ;
  utmanare_nn_1_N = mkN "utmanare" utrum  ;
  utnyttjare_nn_1_N = mkN "utnyttjare" utrum  ;
  utombordare_nn_1_N = mkN "utombordare" utrum  ;
  utpressare_nn_1_N = mkN "utpressare" utrum  ;
  utredare_nn_1_N = mkN "utredare" utrum  ;
  utriggare_nn_1_N = mkN "utriggare" utrum  ;
  utrikespassagerare_nn_1_N = mkN "utrikespassagerare" utrum  ;
  utropare_nn_1_N = mkN "utropare" utrum  ;
  utstaellare_nn_1_1_N = mkN "utställare" utrum  ;
  utsugare_nn_1_N = mkN "utsugare" utrum  ;
  uttolkare_nn_1_N = mkN "uttolkare" utrum  ;
  uttydare_nn_1_N = mkN "uttydare" utrum  ;
  utvandrare_nn_1_N = mkN "utvandrare" utrum  ;
  utoevare_nn_1_1_N = mkN "utövare" utrum  ;
  vabbare_nn_1_N = mkN "vabbare" utrum  ;
  vadare_nn_1_N = mkN "vadare" utrum  ;
  vadhaallare_nn_1_1_N = mkN "vadhållare" utrum  ;
  vakare_nn_1_N = mkN "vakare" utrum  ;
  vaktare_nn_1_N = mkN "vaktare" utrum  ;
  vaktmaestare_nn_1_1_N = mkN "vaktmästare" utrum  ;
  valarbetare_nn_1_N = mkN "valarbetare" utrum  ;
  valdeltagare_nn_1_N = mkN "valdeltagare" utrum  ;
  valfaangare_nn_1_1_N = mkN "valfångare" utrum  ;
  valkare_nn_1_N = mkN "valkare" utrum  ;
  vallare_nn_1_N = mkN "vallare" utrum  ;
  valvinnare_nn_1_N = mkN "valvinnare" utrum  ;
  vandrare_nn_1_N = mkN "vandrare" utrum  ;
  vanedrinkare_nn_1_N = mkN "vanedrinkare" utrum  ;
  vanefoerbrytare_nn_1_1_N = mkN "vaneförbrytare" utrum  ;
  vaneaetare_nn_1_1_N = mkN "vaneätare" utrum  ;
  vantspridare_nn_1_N = mkN "vantspridare" utrum  ;
  vapendragare_nn_1_N = mkN "vapendragare" utrum  ;
  vapenvaegrare_nn_1_1_N = mkN "vapenvägrare" utrum  ;
  varghatare_nn_1_N = mkN "varghatare" utrum  ;
  varmvattenberedare_nn_1_N = mkN "varmvattenberedare" utrum  ;
  varmvattensberedare_nn_1_N = mkN "varmvattensberedare" utrum  ;
  varuhavare_nn_1_N = mkN "varuhavare" utrum  ;
  varvmaetare_nn_1_1_N = mkN "varvmätare" utrum  ;
  varvraeknare_nn_1_1_N = mkN "varvräknare" utrum  ;
  varvsarbetare_nn_1_N = mkN "varvsarbetare" utrum  ;
  vattenbehaallare_nn_1_1_N = mkN "vattenbehållare" utrum  ;
  vattendelare_nn_1_N = mkN "vattendelare" utrum  ;
  vattenkastare_nn_1_N = mkN "vattenkastare" utrum  ;
  vattenkokare_nn_1_N = mkN "vattenkokare" utrum  ;
  vattenloepare_nn_1_1_N = mkN "vattenlöpare" utrum  ;
  vattenpelare_nn_1_N = mkN "vattenpelare" utrum  ;
  vattenrallare_nn_1_N = mkN "vattenrallare" utrum  ;
  vattenspridare_nn_1_N = mkN "vattenspridare" utrum  ;
  vattenstaandsvisare_nn_1_1_N = mkN "vattenståndsvisare" utrum  ;
  vattenvaermare_nn_1_1_N = mkN "vattenvärmare" utrum  ;
  vattnare_nn_1_N = mkN "vattnare" utrum  ;
  vecklare_nn_1_N = mkN "vecklare" utrum  ;
  vedbaerare_nn_1_1_N = mkN "vedbärare" utrum  ;
  vederdoepare_nn_1_1_N = mkN "vederdöpare" utrum  ;
  vedersakare_nn_1_N = mkN "vedersakare" utrum  ;
  vedhuggare_nn_1_N = mkN "vedhuggare" utrum  ;
  venetianare_nn_1_N = mkN "venetianare" utrum  ;
  verkmaestare_nn_1_1_N = mkN "verkmästare" utrum  ;
  verkslaekare_nn_1_1_N = mkN "verksläkare" utrum  ;
  verkstadsarbetare_nn_1_N = mkN "verkstadsarbetare" utrum  ;
  verkstaellare_nn_1_1_N = mkN "verkställare" utrum  ;
  vernissagebesoekare_nn_1_1_N = mkN "vernissagebesökare" utrum  ;
  versmakare_nn_1_N = mkN "versmakare" utrum  ;
  vertikalskaerare_nn_1_1_N = mkN "vertikalskärare" utrum  ;
  vetenskapare_nn_1_N = mkN "vetenskapare" utrum  ;
  victoriakorsvinnare_nn_1_N = mkN "victoriakorsvinnare" utrum  ;
  videobandspelare_nn_1_N = mkN "videobandspelare" utrum  ;
  vikare_nn_1_N = mkN "vikare" utrum  ;
  viktighetsmakare_nn_1_N = mkN "viktighetsmakare" utrum  ;
  viktjusterare_nn_1_N = mkN "viktjusterare" utrum  ;
  vildbasare_nn_1_N = mkN "vildbasare" utrum  ;
  villaaegare_nn_1_1_N = mkN "villaägare" utrum  ;
  vilthandlare_nn_1_N = mkN "vilthandlare" utrum  ;
  viltvaardare_nn_1_1_N = mkN "viltvårdare" utrum  ;
  vinare_nn_1_N = mkN "vinare" utrum  ;
  vindmaetare_nn_1_1_N = mkN "vindmätare" utrum  ;
  vindrutespolare_nn_1_N = mkN "vindrutespolare" utrum  ;
  vindrutetorkare_nn_1_N = mkN "vindrutetorkare" utrum  ;
  vinglare_nn_1_N = mkN "vinglare" utrum  ;
  vingtaeckare_nn_1_1_N = mkN "vingtäckare" utrum  ;
  vingaardsarbetare_nn_1_1_N = mkN "vingårdsarbetare" utrum  ;
  vinkelmaetare_nn_1_1_N = mkN "vinkelmätare" utrum  ;
  vinkaennare_nn_1_1_N = mkN "vinkännare" utrum  ;
  vinmakare_nn_1_N = mkN "vinmakare" utrum  ;
  vinnare_nn_1_N = mkN "vinnare" utrum  ;
  vinodlare_nn_1_N = mkN "vinodlare" utrum  ;
  vinterbadare_nn_1_N = mkN "vinterbadare" utrum  ;
  vinteridrottare_nn_1_N = mkN "vinteridrottare" utrum  ;
  vinterliggare_nn_1_N = mkN "vinterliggare" utrum  ;
  visare_nn_1_N = mkN "visare" utrum  ;
  viskare_nn_1_N = mkN "viskare" utrum  ;
  visslare_nn_1_N = mkN "visslare" utrum  ;
  vissaangare_nn_1_1_N = mkN "vissångare" utrum  ;
  vitsare_nn_1_N = mkN "vitsare" utrum  ;
  voltmaetare_nn_1_1_N = mkN "voltmätare" utrum  ;
  vrakletare_nn_1_N = mkN "vrakletare" utrum  ;
  vrakplundrare_nn_1_N = mkN "vrakplundrare" utrum  ;
  vraekare_nn_1_1_N = mkN "vräkare" utrum  ;
  vaeckare_nn_1_1_N = mkN "väckare" utrum  ;
  vaederbesvaerjare_nn_1_1_N = mkN "väderbesvärjare" utrum  ;
  vaegare_nn_1_1_N = mkN "vägare" utrum  ;
  vaegbrytare_nn_1_1_N = mkN "vägbrytare" utrum  ;
  vaeggpelare_nn_1_1_N = mkN "väggpelare" utrum  ;
  vaegledare_nn_1_1_N = mkN "vägledare" utrum  ;
  vaegmaetare_nn_1_1_N = mkN "vägmätare" utrum  ;
  vaegrare_nn_1_1_N = mkN "vägrare" utrum  ;
  vaegroejare_nn_1_1_N = mkN "vägröjare" utrum  ;
  vaegvisare_nn_1_1_N = mkN "vägvisare" utrum  ;
  vaektare_nn_1_1_N = mkN "väktare" utrum  ;
  vaelgoerare_nn_1_1_N = mkN "välgörare" utrum  ;
  vaeljare_nn_1_1_N = mkN "väljare" utrum  ;
  vaeltalare_nn_1_1_N = mkN "vältalare" utrum  ;
  vaensteranhaengare_nn_1_1_N = mkN "vänsteranhängare" utrum  ;
  vaensterhandsspelare_nn_1_1_N = mkN "vänsterhandsspelare" utrum  ;
  vaepnare_nn_1_1_N = mkN "väpnare" utrum  ;
  vaerdemaetare_nn_1_1_N = mkN "värdemätare" utrum  ;
  vaerderare_nn_1_1_N = mkN "värderare" utrum  ;
  vaerldsborgare_nn_1_1_N = mkN "världsborgare" utrum  ;
  vaerldseroevrare_nn_1_1_N = mkN "världserövrare" utrum  ;
  vaerldsfoerbaettrare_nn_1_1_N = mkN "världsförbättrare" utrum  ;
  vaerldsmedborgare_nn_1_1_N = mkN "världsmedborgare" utrum  ;
  vaerldsmaestare_nn_1_1_N = mkN "världsmästare" utrum  ;
  vaermeledare_nn_1_1_N = mkN "värmeledare" utrum  ;
  vaermemaetare_nn_1_1_N = mkN "värmemätare" utrum  ;
  vaermevaexlare_nn_1_1_N = mkN "värmeväxlare" utrum  ;
  vaernpliktsvaegrare_nn_1_1_N = mkN "värnpliktsvägrare" utrum  ;
  vaeskryckare_nn_1_1_N = mkN "väskryckare" utrum  ;
  vaestindiefarare_nn_1_1_N = mkN "västindiefarare" utrum  ;
  vaevare_nn_1_1_N = mkN "vävare" utrum  ;
  vaevspaennare_nn_1_1_N = mkN "vävspännare" utrum  ;
  vaexelgivare_nn_1_1_N = mkN "växelgivare" utrum  ;
  vaexelryttare_nn_1_1_N = mkN "växelryttare" utrum  ;
  vaexelutstaellare_nn_1_1_N = mkN "växelutställare" utrum  ;
  vaexlare_nn_1_1_N = mkN "växlare" utrum  ;
  vaextsamlare_nn_1_1_N = mkN "växtsamlare" utrum  ;
  vaextaetare_nn_1_1_N = mkN "växtätare" utrum  ;
  vaagbrytare_nn_1_1_N = mkN "vågbrytare" utrum  ;
  vaagmaestare_nn_1_1_N = mkN "vågmästare" utrum  ;
  vaaldsverkare_nn_1_1_N = mkN "våldsverkare" utrum  ;
  vaardare_nn_1_1_N = mkN "vårdare" utrum  ;
  vaardgivare_nn_1_1_N = mkN "vårdgivare" utrum  ;
  vaardnadshavare_nn_1_1_N = mkN "vårdnadshavare" utrum  ;
  vaardtagare_nn_1_1_N = mkN "vårdtagare" utrum  ;
  vaartbitare_nn_1_1_N = mkN "vårtbitare" utrum  ;
  walesare_nn_1_N = mkN "walesare" utrum  ;
  webblaesare_nn_1_1_N = mkN "webbläsare" utrum  ;
  yrkesarbetare_nn_1_N = mkN "yrkesarbetare" utrum  ;
  yrkeslaerare_nn_1_1_N = mkN "yrkeslärare" utrum  ;
  yrkesvaegledare_nn_1_1_N = mkN "yrkesvägledare" utrum  ;
  zeppelinare_nn_1_N = mkN "zeppelinare" utrum  ;
  zigenare_nn_1_N = mkN "zigenare" utrum  ;
  aegare_nn_1_1_N = mkN "ägare" utrum  ;
  aeggkastare_nn_1_1_N = mkN "äggkastare" utrum  ;
  aeggkokare_nn_1_1_N = mkN "äggkokare" utrum  ;
  aeggledare_nn_1_1_N = mkN "äggledare" utrum  ;
  aeggprickare_nn_1_1_N = mkN "äggprickare" utrum  ;
  aeggvaermare_nn_1_1_N = mkN "äggvärmare" utrum  ;
  aektenskapsbrytare_nn_1_1_N = mkN "äktenskapsbrytare" utrum  ;
  aektenskapsmaeklare_nn_1_1_N = mkN "äktenskapsmäklare" utrum  ;
  aelgjaegare_nn_1_1_N = mkN "älgjägare" utrum  ;
  aelgstudsare_nn_1_1_N = mkN "älgstudsare" utrum  ;
  aelskare_nn_1_1_N = mkN "älskare" utrum  ;
  aemnesfoeretraedare_nn_1_1_N = mkN "ämnesföreträdare" utrum  ;
  aemneslaerare_nn_1_1_N = mkN "ämneslärare" utrum  ;
  aeppelvecklare_nn_1_1_N = mkN "äppelvecklare" utrum  ;
  aerftlighetsforskare_nn_1_1_N = mkN "ärftlighetsforskare" utrum  ;
  aermhaallare_nn_1_1_N = mkN "ärmhållare" utrum  ;
  aertvecklare_nn_1_1_N = mkN "ärtvecklare" utrum  ;
  aeventyrare_nn_1_1_N = mkN "äventyrare" utrum  ;
  aahoerare_nn_1_1_N = mkN "åhörare" utrum  ;
  aakare_nn_1_1_N = mkN "åkare" utrum  ;
  aakerbrukare_nn_1_1_N = mkN "åkerbrukare" utrum  ;
  aakgraesklippare_nn_1_1_N = mkN "åkgräsklippare" utrum  ;
  aaklagare_nn_1_1_N = mkN "åklagare" utrum  ;
  aalfiskare_nn_1_1_N = mkN "ålfiskare" utrum  ;
  aangare_nn_1_1_N = mkN "ångare" utrum  ;
  aangkokare_nn_1_1_N = mkN "ångkokare" utrum  ;
  aaskledare_nn_1_1_N = mkN "åskledare" utrum  ;
  aaskaadare_nn_1_1_N = mkN "åskådare" utrum  ;
  aaskaadarlaektare_nn_1_1_N = mkN "åskådarläktare" utrum  ;
  aasnedrivare_nn_1_1_N = mkN "åsnedrivare" utrum  ;
  aaterfallsfoerbrytare_nn_1_1_N = mkN "återfallsförbrytare" utrum  ;
  aaterfoersaeljare_nn_1_1_N = mkN "återförsäljare" utrum  ;
  aaterloesare_nn_1_1_N = mkN "återlösare" utrum  ;
  aaterstaellare_nn_1_1_N = mkN "återställare" utrum  ;
  aatersaeljare_nn_1_1_N = mkN "återsäljare" utrum  ;
  oedelaeggare_nn_1_1_N = mkN "ödeläggare" utrum  ;
  oegonlaekare_nn_1_1_N = mkN "ögonläkare" utrum  ;
  oegontjaenare_nn_1_1_N = mkN "ögontjänare" utrum  ;
  oegonoeppnare_nn_1_1_N = mkN "ögonöppnare" utrum  ;
  oelsoerplare_nn_1_1_N = mkN "ölsörplare" utrum  ;
  oelutkoerare_nn_1_1_N = mkN "ölutkörare" utrum  ;
  oeloeppnare_nn_1_1_N = mkN "ölöppnare" utrum  ;
  oeppnare_nn_1_1_N = mkN "öppnare" utrum  ;
  oerngottsbandskrusare_nn_1_1_N = mkN "örngottsbandskrusare" utrum  ;
  oeronlaekare_nn_1_1_N = mkN "öronläkare" utrum  ;
  oerontasslare_nn_1_1_N = mkN "örontasslare" utrum  ;
  oertagaardsmaestare_nn_1_1_N = mkN "örtagårdsmästare" utrum  ;
  oesterrikare_nn_1_1_N = mkN "österrikare" utrum  ;
  oeststatsledare_nn_1_1_N = mkN "öststatsledare" utrum  ;
  oeverbefaelhavare_nn_1_1_N = mkN "överbefälhavare" utrum  ;
  oeverbringare_nn_1_1_N = mkN "överbringare" utrum  ;
  oeverdomare_nn_1_1_N = mkN "överdomare" utrum  ;
  oeverdaengare_nn_1_1_N = mkN "överdängare" utrum  ;
  oeverfoermyndare_nn_1_1_N = mkN "överförmyndare" utrum  ;
  oeverklassare_nn_1_1_N = mkN "överklassare" utrum  ;
  oeverliggare_nn_1_1_N = mkN "överliggare" utrum  ;
  oeverlaekare_nn_1_1_N = mkN "överläkare" utrum  ;
  oeverlaemnare_nn_1_1_N = mkN "överlämnare" utrum  ;
  oeverlaerare_nn_1_1_N = mkN "överlärare" utrum  ;
  oeverlaatare_nn_1_1_N = mkN "överlåtare" utrum  ;
  oeverloepare_nn_1_1_N = mkN "överlöpare" utrum  ;
  oeversittare_nn_1_1_N = mkN "översittare" utrum  ;
  oeverstaathaallare_nn_1_1_N = mkN "överståthållare" utrum  ;
  oeversaettare_nn_1_1_N = mkN "översättare" utrum  ;
  oevertraedare_nn_1_1_N = mkN "överträdare" utrum  ;
  oevervakare_nn_1_1_N = mkN "övervakare" utrum  ;
  oevningslaerare_nn_1_1_N = mkN "övningslärare" utrum  ;
  airbag_nn_1_N = mkN "airbag" ;
  allianskollega_nn_1_N = mkN "allianskollega" ;
  alzheimers_nn_1_N = mkN "alzheimers" ;
  amaryllis_nn_1_N = mkN "amaryllis" ;
  ananas_nn_1_N = mkN "ananas" ;
  ankar_nn_1_N = mkN "ankar" ;
  anno_nn_1_N = mkN "anno" ;
  arresteringsorder_nn_1_N = mkN "arresteringsorder" ;
  avsalu_nn_1_N = mkN "avsalu" ;
  avskrot_nn_1_N = mkN "avskrot" ;
  ayatollah_nn_1_N = mkN "ayatollah" ;
  babord_nn_1_N = mkN "babord" ;
  babysitter_nn_1_N = mkN "babysitter" ;
  badmintonrack_nn_1_N = mkN "badmintonrack" ;
  bagis_nn_1_N = mkN "bagis" ;
  bakhas_nn_1_N = mkN "bakhas" ;
  baluster_nn_1_N = mkN "baluster" ;
  banco_nn_1_N = mkN "banco" ;
  banko_nn_1_N = mkN "banko" ;
  bark_nn_2_N = mkN "bark" ;
  bas_nn_3_N = mkN "bas" ;
  basset_nn_1_N = mkN "basset" ;
  belcanto_nn_1_N = mkN "belcanto" ;
  bellis_nn_1_N = mkN "bellis" ;
  besservisser_nn_1_N = mkN "besservisser" ;
  besserwisser_nn_1_N = mkN "besserwisser" ;
  bestseller_nn_1_N = mkN "bestseller" ;
  bibelvers_nn_1_N = mkN "bibelvers" ;
  bill_nn_2_N = mkN "bill" ;
  binokel_nn_1_N = mkN "binokel" ;
  bit_nn_2_N = mkN "bit" ;
  blankocheck_nn_1_N = mkN "blankocheck" ;
  blinker_nn_1_N = mkN "blinker" ;
  blaenk_nn_1_1_N = mkN "blänk" ;
  bobsleigh_nn_1_N = mkN "bobsleigh" ;
  bolster_nn_1_N = mkN "bolster" ;
  bomullstops_nn_1_N = mkN "bomullstops" ;
  boom_nn_1_N = mkN "boom" ;
  bordtennisrack_nn_1_N = mkN "bordtennisrack" ;
  borr_nn_2_N = mkN "borr" ;
  brats_nn_1_N = mkN "brats" ;
  bris_nn_1_N = mkN "bris" ;
  broiler_nn_1_N = mkN "broiler" ;
  braeda_nn_1_1_N = mkN "bräda" ;
  broesthoejd_nn_1_1_N = mkN "brösthöjd" ;
  budget_nn_1_N = mkN "budget" ;
  bukettgroent_nn_1_1_N = mkN "bukettgrönt" ;
  bulldozer_nn_1_N = mkN "bulldozer" ;
  bunker_nn_1_N = mkN "bunker" ;
  burnus_nn_1_N = mkN "burnus" ;
  byggcontainer_nn_1_N = mkN "byggcontainer" ;
  byxdress_nn_1_N = mkN "byxdress" ;
  baers_nn_2_1_N = mkN "bärs" ;
  baest_foere_datum_nn_1_1_N = mkN "bäst-före-datum" ;
  baestfoere_datum_nn_1_1_N = mkN "bästföre-datum" ;
  baestfoeredatum_nn_1_1_N = mkN "bästföredatum" ;
  centerforward_nn_1_N = mkN "centerforward" ;
  centerhalv_nn_1_N = mkN "centerhalv" ;
  centimeter_nn_1_N = mkN "centimeter" ;
  check_nn_1_N = mkN "check" ;
  cig_nn_1_N = mkN "cig" ;
  cigg_nn_1_N = mkN "cigg" ;
  citydress_nn_1_N = mkN "citydress" ;
  clematis_nn_1_N = mkN "clematis" ;
  coach_nn_1_N = mkN "coach" ;
  cocktail_nn_1_N = mkN "cocktail" ;
  complet_nn_1_N = mkN "complet" ;
  container_nn_1_N = mkN "container" ;
  corpus_nn_1_N = mkN "corpus" ;
  cykel_nn_2_N = mkN "cykel" ;
  dagens_nn_1_N = mkN "dagens" ;
  dagorder_nn_1_N = mkN "dagorder" ;
  damgambit_nn_1_N = mkN "damgambit" ;
  dato_nn_1_N = mkN "dato" ;
  datum_nn_1_N = mkN "datum" "datum" ;
  debet_nn_1_N = mkN "debet" ;
  decimeter_nn_1_N = mkN "decimeter" ;
  defroster_nn_1_N = mkN "defroster" ;
  dejt_nn_1_N = mkN "dejt" ;
  deklarationsdags_nn_1_N = mkN "deklarationsdags" ;
  diafragma_nn_1_N = mkN "diafragma" ;
  diamantborr_nn_1_N = mkN "diamantborr" ;
  diktcykel_nn_1_N = mkN "diktcykel" ;
  discjockey_nn_1_N = mkN "discjockey" ;
  diskjockey_nn_1_N = mkN "diskjockey" ;
  dosis_nn_1_N = mkN "dosis" ;
  dress_nn_1_N = mkN "dress" ;
  driftbudget_nn_1_N = mkN "driftbudget" ;
  drop_in_nn_1_N = mkN "drop-in" ;
  dropin_nn_1_N = mkN "dropin" ;
  dubbelnelson_nn_1_N = mkN "dubbelnelson" ;
  dumper_nn_1_N = mkN "dumper" ;
  dunbolster_nn_1_N = mkN "dunbolster" ;
  e_post_nn_1_N = mkN "e-post" ;
  eftermiddagsbris_nn_1_N = mkN "eftermiddagsbris" ;
  egotripp_nn_1_N = mkN "egotripp" ;
  eldupphoerorder_nn_1_1_N = mkN "eldupphörorder" ;
  embarras_nn_1_N = mkN "embarras" ;
  en_tous_cas_nn_1_N = mkN "en-tous-cas" ;
  envig_nn_1_N = mkN "envig" ;
  epost_nn_1_N = mkN "epost" ;
  exodus_nn_1_N = mkN "exodus" ;
  falafel_nn_1_N = mkN "falafel" ;
  fallout_nn_1_N = mkN "fallout" ;
  farm_nn_1_N = mkN "farm" ;
  festivitas_nn_1_N = mkN "festivitas" ;
  filigram_nn_1_N = mkN "filigram" ;
  filosofkollega_nn_1_N = mkN "filosofkollega" ;
  flanellpyjamas_nn_1_N = mkN "flanellpyjamas" ;
  flor_nn_2_N = mkN "flor" ;
  fog_nn_2_N = mkN "fog" ;
  formfranska_nn_1_N = mkN "formfranska" ;
  forward_nn_1_N = mkN "forward" ;
  foxtrot_nn_1_N = mkN "foxtrot" ;
  foxtrott_nn_1_N = mkN "foxtrott" ;
  franska_nn_2_N = mkN "franska" ;
  friholt_nn_1_N = mkN "friholt" ;
  frihult_nn_1_N = mkN "frihult" ;
  fusion_nn_2_N = mkN "fusion" ;
  futt_nn_2_N = mkN "futt" ;
  fyrskaft_nn_1_N = mkN "fyrskaft" ;
  fyrspraang_nn_1_1_N = mkN "fyrsprång" ;
  foedelsedatum_nn_1_1_N = mkN "födelsedatum" ;
  foen_nn_2_1_N = mkN "fön" ;
  foerdevind_nn_1_1_N = mkN "fördevind" ;
  foerhaallningsorder_nn_1_1_N = mkN "förhållningsorder" ;
  gambit_nn_1_N = mkN "gambit" ;
  gan_nn_1_N = mkN "gan" ;
  gangster_nn_1_N = mkN "gangster" ;
  gask_nn_1_N = mkN "gask" ;
  generalorder_nn_1_N = mkN "generalorder" ;
  getfot_nn_1_N = mkN "getfot" ;
  gimmick_nn_1_N = mkN "gimmick" ;
  gingham_nn_1_N = mkN "gingham" ;
  gist_nn_1_N = mkN "gist" ;
  gladiolus_nn_1_N = mkN "gladiolus" ;
  glasprisma_nn_1_N = mkN "glasprisma" ;
  glass_nn_1_N = mkN "glass" ;
  globetrotter_nn_1_N = mkN "globetrotter" ;
  go_nn_2_N = mkN "go" ;
  golvbraeda_nn_1_1_N = mkN "golvbräda" ;
  gonggong_nn_1_N = mkN "gonggong" ;
  graal_nn_1_N = mkN "graal" ;
  gral_nn_1_N = mkN "gral" ;
  graaben_nn_1_1_N = mkN "gråben" ;
  gurkha_nn_1_N = mkN "gurkha" ;
  halvmeter_nn_1_N = mkN "halvmeter" ;
  halvnelson_nn_1_N = mkN "halvnelson" ;
  hanrej_nn_1_N = mkN "hanrej" ;
  happening_nn_1_N = mkN "happening" ;
  has_nn_1_N = mkN "has" ;
  hast_nn_1_N = mkN "hast" ;
  haubits_nn_1_N = mkN "haubits" ;
  havsbris_nn_1_N = mkN "havsbris" ;
  hejd_nn_1_N = mkN "hejd" ;
  helgsmaal_nn_1_1_N = mkN "helgsmål" ;
  high_tech_nn_1_N = mkN "high-tech" ;
  hoper_nn_1_N = mkN "hoper" ;
  hult_nn_1_N = mkN "hult" ;
  hum_nn_1_N = mkN "hum" ;
  hundan_nn_1_N = mkN "hundan" ;
  hut_nn_1_N = mkN "hut" ;
  hyllmeter_nn_1_N = mkN "hyllmeter" ;
  hoeger_nn_1_1_N = mkN "höger" ;
  hoegflor_nn_1_1_N = mkN "högflor" ;
  hoerhaall_nn_1_1_N = mkN "hörhåll" ;
  imprimatur_nn_1_N = mkN "imprimatur" ;
  inka_nn_1_N = mkN "inka" ;
  inkallelseorder_nn_1_N = mkN "inkallelseorder" ;
  inloesen_nn_1_1_N = mkN "inlösen" ;
  insider_nn_1_N = mkN "insider" ;
  insteg_nn_1_N = mkN "insteg" ;
  interferens_nn_2_N = mkN "interferens" ;
  isranunkel_nn_1_N = mkN "isranunkel" ;
  item_nn_1_N = mkN "item" ;
  jack_nn_2_N = mkN "jack" ;
  jackpot_nn_1_N = mkN "jackpot" ;
  jazzschlager_nn_1_N = mkN "jazzschlager" ;
  jobbcoach_nn_1_N = mkN "jobbcoach" ;
  jockey_nn_1_N = mkN "jockey" ;
  jojo_nn_1_N = mkN "jojo" ;
  jordgubb_nn_1_N = mkN "jordgubb" ;
  jugend_nn_1_N = mkN "jugend" ;
  jaetteryck_nn_1_1_N = mkN "jätteryck" ;
  kabinettsorder_nn_1_N = mkN "kabinettsorder" ;
  kader_nn_1_N = mkN "kader" ;
  kakmix_nn_1_N = mkN "kakmix" ;
  kaliber_nn_1_N = mkN "kaliber" ;
  kaliberborr_nn_1_N = mkN "kaliberborr" ;
  kallskuret_nn_1_N = mkN "kallskuret" ;
  kapitalbudget_nn_1_N = mkN "kapitalbudget" ;
  kart_nn_1_N = mkN "kart" ;
  kem_nn_1_N = mkN "kem" ;
  kilogrammeter_nn_1_N = mkN "kilogrammeter" ;
  kilometer_nn_1_N = mkN "kilometer" ;
  klematis_nn_1_N = mkN "klematis" ;
  klerus_nn_1_N = mkN "klerus" ;
  klink_nn_1_N = mkN "klink" ;
  klint_nn_1_N = mkN "klint" ;
  klo_nn_2_N = mkN "klo" ;
  knaster_nn_2_N = mkN "knaster" ;
  kniptaangsmanoever_nn_1_1_N = mkN "kniptångsmanöver" ;
  knaehoejd_nn_1_1_N = mkN "knähöjd" ;
  kofot_nn_1_N = mkN "kofot" ;
  kohl_nn_1_N = mkN "kohl" ;
  kollega_nn_1_N = mkN "kollega" ;
  kompaniorder_nn_1_N = mkN "kompaniorder" ;
  kongressdatum_nn_1_N = mkN "kongressdatum" ;
  kont_nn_1_N = mkN "kont" ;
  kontraorder_nn_1_N = mkN "kontraorder" ;
  korpus_nn_1_N = mkN "korpus" ;
  kos_nn_1_N = mkN "kos" ;
  kredit_nn_2_N = mkN "kredit" ;
  krigsfot_nn_1_N = mkN "krigsfot" ;
  kryddgroent_nn_1_1_N = mkN "kryddgrönt" ;
  krysantemum_nn_1_N = mkN "krysantemum" ;
  krysshult_nn_1_N = mkN "krysshult" ;
  kubikdecimeter_nn_1_N = mkN "kubikdecimeter" ;
  kubikmeter_nn_1_N = mkN "kubikmeter" ;
  kubikmillimeter_nn_1_N = mkN "kubikmillimeter" ;
  kungsgambit_nn_1_N = mkN "kungsgambit" ;
  kurbits_nn_1_N = mkN "kurbits" ;
  kvadratcentimeter_nn_1_N = mkN "kvadratcentimeter" ;
  kvadratkilometer_nn_1_N = mkN "kvadratkilometer" ;
  kvadratmeter_nn_1_N = mkN "kvadratmeter" ;
  kvart_nn_1_N = mkN "kvart" ;
  kved_nn_1_N = mkN "kved" ;
  kvaellsbris_nn_1_1_N = mkN "kvällsbris" ;
  koep_slit_och_slaeng_nn_1_1_N = mkN "köp-slit-och-släng" ;
  lackroller_nn_1_N = mkN "lackroller" ;
  laissez_faire_nn_1_N = mkN "laissez-faire" ;
  lama_nn_3_N = mkN "lama" ;
  landbris_nn_1_N = mkN "landbris" ;
  laptop_nn_1_N = mkN "laptop" ;
  laptopp_nn_1_N = mkN "laptopp" ;
  lift_nn_1_N = mkN "lift" ;
  lilleputt_nn_1_N = mkN "lilleputt" ;
  limes_nn_1_N = mkN "limes" ;
  liter_nn_1_N = mkN "liter" ;
  livscykel_nn_1_N = mkN "livscykel" ;
  lodled_nn_1_N = mkN "lodled" ;
  lov_nn_2_N = mkN "lov" ;
  lovart_nn_1_N = mkN "lovart" ;
  lues_nn_1_N = mkN "lues" ;
  lund_nn_1_N = mkN "lund" ;
  lyckotripp_nn_1_N = mkN "lyckotripp" ;
  lyster_nn_1_N = mkN "lyster" ;
  laerktraetrall_nn_1_1_N = mkN "lärkträtrall" ;
  laangfranska_nn_1_1_N = mkN "långfranska" ;
  laas_nn_1_1_N = mkN "lås" ;
  loenecheck_nn_1_1_N = mkN "lönecheck" ;
  mannamaan_nn_1_1_N = mkN "mannamån" ;
  manoever_nn_1_1_N = mkN "manöver" ;
  marienglas_nn_1_N = mkN "marienglas" ;
  marschorder_nn_1_N = mkN "marschorder" ;
  maskot_nn_1_N = mkN "maskot" ;
  maxiroller_nn_1_N = mkN "maxiroller" ;
  menstruationscykel_nn_1_N = mkN "menstruationscykel" ;
  meter_nn_1_N = mkN "meter" "metern" "meter" "metren" utrum ;
  mikrometer_nn_2_N = mkN "mikrometer" ;
  militaerbudget_nn_1_1_N = mkN "militärbudget" ;
  militaermanoever_nn_1_1_N = mkN "militärmanöver" ;
  millimeter_nn_1_N = mkN "millimeter" ;
  miniroller_nn_1_N = mkN "miniroller" ;
  misskredit_nn_1_N = mkN "misskredit" ;
  mix_nn_1_N = mkN "mix" ;
  mixer_nn_1_N = mkN "mixer" ;
  monokel_nn_1_N = mkN "monokel" ;
  monter_nn_1_N = mkN "monter" ;
  motvaern_nn_1_1_N = mkN "motvärn" ;
  muck_nn_1_N = mkN "muck" ;
  multum_nn_1_N = mkN "multum" ;
  mumsmums_nn_1_N = mkN "mumsmums" ;
  musa_nn_1_N = mkN "musa" ;
  mysdress_nn_1_N = mkN "mysdress" ;
  maet_nn_1_1_N = mkN "mät" ;
  maan_nn_1_1_N = mkN "mån" ;
  maancykel_nn_1_1_N = mkN "måncykel" ;
  nakenskanner_nn_1_N = mkN "nakenskanner" ;
  nanometer_nn_1_N = mkN "nanometer" ;
  nationalbudget_nn_1_N = mkN "nationalbudget" ;
  nek_nn_1_N = mkN "nek" ;
  nelson_nn_1_N = mkN "nelson" ;
  nen_nn_1_N = mkN "nen" ;
  newtonmeter_nn_1_N = mkN "newtonmeter" ;
  nippran_nn_1_N = mkN "nippran" ;
  nit_nn_3_N = mkN "nit" ;
  noa_nn_1_N = mkN "noa" ;
  noll_nn_1_N = mkN "noll" ;
  nordanskog_nn_1_N = mkN "nordanskog" ;
  norr_nn_1_N = mkN "norr" ;
  nostalgitripp_nn_1_N = mkN "nostalgitripp" ;
  numro_nn_1_N = mkN "numro" ;
  naebb_nn_1_1_N = mkN "näbb" ;
  naeverkont_nn_1_1_N = mkN "näverkont" ;
  noedvaern_nn_1_1_N = mkN "nödvärn" ;
  oasis_nn_1_N = mkN "oasis" ;
  officerskollega_nn_1_N = mkN "officerskollega" ;
  oldboy_nn_1_N = mkN "oldboy" ;
  oljetanker_nn_1_N = mkN "oljetanker" ;
  order_nn_1_N = mkN "order" ;
  oro_nn_2_N = mkN "oro" ;
  otal_nn_1_N = mkN "otal" ;
  otid_nn_1_N = mkN "otid" ;
  oting_nn_1_N = mkN "oting" ;
  pacemaker_nn_1_N = mkN "pacemaker" ;
  paddock_nn_1_N = mkN "paddock" ;
  pajas_nn_1_N = mkN "pajas" ;
  paria_nn_1_N = mkN "paria" ;
  parkas_nn_1_N = mkN "parkas" ;
  parser_nn_1_N = mkN "parser" ;
  pelargonia_nn_1_N = mkN "pelargonia" ;
  pellet_nn_1_N = mkN "pellet" ;
  pensioneringsdatum_nn_1_N = mkN "pensioneringsdatum" ;
  pipstopp_nn_1_N = mkN "pipstopp" ;
  pir_nn_1_N = mkN "pir" ;
  playboy_nn_1_N = mkN "playboy" ;
  ploj_nn_1_N = mkN "ploj" ;
  plums_nn_1_N = mkN "plums" ;
  plaed_nn_1_1_N = mkN "pläd" ;
  pojk_nn_1_N = mkN "pojk" ;
  poster_nn_1_N = mkN "poster" ;
  print_on_demand_nn_1_N = mkN "print-on-demand" ;
  prisma_nn_1_N = mkN "prisma" ;
  programbudget_nn_1_N = mkN "programbudget" ;
  psalmvers_nn_1_N = mkN "psalmvers" ;
  purser_nn_1_N = mkN "purser" ;
  pyjamas_nn_1_N = mkN "pyjamas" ;
  paers_nn_1_1_N = mkN "pärs" ;
  quiz_nn_1_N = mkN "quiz" ;
  quizz_nn_1_N = mkN "quizz" ;
  racer_nn_1_N = mkN "racer" ;
  rack_nn_3_N = mkN "rack" ;
  ragnaroek_nn_1_1_N = mkN "ragnarök" ;
  rambudget_nn_1_N = mkN "rambudget" ;
  ranunkel_nn_1_N = mkN "ranunkel" ;
  ready_made_nn_1_N = mkN "ready-made" ;
  receiver_nn_1_N = mkN "receiver" ;
  regeringskollega_nn_1_N = mkN "regeringskollega" ;
  remis_nn_1_N = mkN "remis" ;
  resecheck_nn_1_N = mkN "resecheck" ;
  ribba_nn_2_N = mkN "ribba" ;
  ringfinger_nn_1_N = mkN "ringfinger" ;
  rist_nn_1_N = mkN "rist" ;
  rits_nn_1_N = mkN "rits" ;
  roller_nn_1_N = mkN "roller" ;
  rund_nn_1_N = mkN "rund" ;
  rundhult_nn_1_N = mkN "rundhult" ;
  ruter_nn_2_N = mkN "ruter" ;
  ryck_nn_2_N = mkN "ryck" ;
  raeckhaall_nn_1_1_N = mkN "räckhåll" ;
  raad_nn_3_13_N = mkN "råd" ;
  roestcoach_nn_1_1_N = mkN "röstcoach" ;
  sagocykel_nn_1_N = mkN "sagocykel" ;
  samizdat_nn_1_N = mkN "samizdat" ;
  sarg_nn_1_N = mkN "sarg" ;
  scanner_nn_1_N = mkN "scanner" ;
  scarf_nn_1_N = mkN "scarf" ;
  schilling_nn_1_N = mkN "schilling" ;
  schlager_nn_1_N = mkN "schlager" ;
  scratch_nn_1_N = mkN "scratch" ;
  sec_nn_1_N = mkN "sec" ;
  semitrailer_nn_1_N = mkN "semitrailer" ;
  sexualcykel_nn_1_N = mkN "sexualcykel" ;
  shaker_nn_1_N = mkN "shaker" ;
  sherpa_nn_1_N = mkN "sherpa" ;
  sicksack_nn_1_N = mkN "sicksack" ;
  sitter_nn_1_N = mkN "sitter" ;
  sittup_nn_1_N = mkN "sittup" ;
  sittupp_nn_1_N = mkN "sittupp" ;
  situp_nn_1_N = mkN "situp" ;
  situpp_nn_1_N = mkN "situpp" ;
  sjutusan_nn_1_N = mkN "sjutusan" ;
  skank_nn_1_N = mkN "skank" ;
  skanner_nn_1_N = mkN "skanner" ;
  skenmanoever_nn_1_1_N = mkN "skenmanöver" ;
  skidlift_nn_1_N = mkN "skidlift" ;
  skolaest_nn_2_1_N = mkN "skoläst" ;
  skuggbudget_nn_1_N = mkN "skuggbudget" ;
  slejf_nn_1_N = mkN "slejf" ;
  slipover_nn_1_N = mkN "slipover" ;
  slugger_nn_1_N = mkN "slugger" ;
  slukrist_nn_1_N = mkN "slukrist" ;
  slump_nn_1_N = mkN "slump" ;
  slaeplift_nn_1_1_N = mkN "släplift" ;
  smaafranska_nn_1_1_N = mkN "småfranska" ;
  smaagangster_nn_1_1_N = mkN "smågangster" ;
  snutkollega_nn_1_N = mkN "snutkollega" ;
  snoebudget_nn_1_1_N = mkN "snöbudget" ;
  sol_och_vaar_nn_1_1_N = mkN "sol-och-vår" ;
  solcykel_nn_1_N = mkN "solcykel" ;
  solochvaar_nn_1_1_N = mkN "solochvår" ;
  spaltkilometer_nn_1_N = mkN "spaltkilometer" ;
  spann_nn_1_N = mkN "spann" ;
  spann_nn_2_N = mkN "spann" ;
  sponken_nn_1_N = mkN "sponken" ;
  spaang_nn_1_1_N = mkN "spång" ;
  spaanken_nn_1_1_N = mkN "spånken" ;
  squashrack_nn_1_N = mkN "squashrack" ;
  stadsdress_nn_1_N = mkN "stadsdress" ;
  stalker_nn_1_N = mkN "stalker" ;
  statsbudget_nn_1_N = mkN "statsbudget" ;
  stenfot_nn_1_N = mkN "stenfot" ;
  steward_nn_1_N = mkN "steward" ;
  stewart_nn_1_N = mkN "stewart" ;
  stopp_nn_2_N = mkN "stopp" ;
  stout_nn_1_N = mkN "stout" ;
  stradivarius_nn_1_N = mkN "stradivarius" ;
  styr_nn_1_N = mkN "styr" ;
  styrbord_nn_1_N = mkN "styrbord" ;
  succ_ethriller_nn_1_1_N = mkN "succéthriller" ;
  sudd_nn_3_N = mkN "sudd" ;
  supertanker_nn_1_N = mkN "supertanker" ;
  suput_nn_1_N = mkN "suput" ;
  surkart_nn_1_N = mkN "surkart" ;
  svan_nn_1_N = mkN "svan" ;
  svank_nn_1_N = mkN "svank" ;
  syd_nn_1_N = mkN "syd" ;
  synhaall_nn_1_1_N = mkN "synhåll" ;
  synopsis_nn_1_N = mkN "synopsis" ;
  synthesizer_nn_1_N = mkN "synthesizer" ;
  saerklass_nn_1_1_N = mkN "särklass" ;
  saat_nn_1_1_N = mkN "såt" ;
  tabelras_nn_1_N = mkN "tabelras" ;
  tamtam_nn_1_N = mkN "tamtam" ;
  tandagnisslan_nn_1_N = mkN "tandagnisslan" ;
  tandborr_nn_1_N = mkN "tandborr" ;
  tank_nn_2_N = mkN "tank" ;
  tanker_nn_1_N = mkN "tanker" ;
  tappborr_nn_1_N = mkN "tappborr" ;
  tejp_nn_1_N = mkN "tejp" ;
  telefonjack_nn_1_N = mkN "telefonjack" ;
  tennisrack_nn_1_N = mkN "tennisrack" ;
  textkorpus_nn_1_N = mkN "textkorpus" ;
  thriller_nn_1_N = mkN "thriller" ;
  tillfaellighetsvers_nn_1_1_N = mkN "tillfällighetsvers" ;
  tilt_nn_2_N = mkN "tilt" ;
  tjotaheiti_nn_1_N = mkN "tjotaheiti" ;
  tjotahejti_nn_1_N = mkN "tjotahejti" ;
  tjottaheiti_nn_1_N = mkN "tjottaheiti" ;
  tjottahejti_nn_1_N = mkN "tjottahejti" ;
  tjaern_nn_1_1_N = mkN "tjärn" ;
  tops_nn_1_N = mkN "tops" ;
  topspin_nn_1_N = mkN "topspin" ;
  tortilla_nn_1_N = mkN "tortilla" ;
  trailer_nn_1_N = mkN "trailer" ;
  trall_nn_2_N = mkN "trall" ;
  transponder_nn_1_N = mkN "transponder" ;
  trekvart_nn_1_N = mkN "trekvart" ;
  treraetters_nn_1_1_N = mkN "trerätters" ;
  trick_nn_2_N = mkN "trick" ;
  tripp_nn_1_N = mkN "tripp" ;
  trumf_nn_1_N = mkN "trumf" ;
  tusan_nn_1_N = mkN "tusan" ;
  tuskaft_nn_1_N = mkN "tuskaft" ;
  tvesalu_nn_1_N = mkN "tvesalu" ;
  tvaadagarstripp_nn_1_1_N = mkN "tvådagarstripp" ;
  tvaakomponents_nn_1_1_N = mkN "tvåkomponents" ;
  tvaangsinloesen_nn_1_1_N = mkN "tvångsinlösen" ;
  tvaaskaft_nn_1_1_N = mkN "tvåskaft" ;
  undanmanoever_nn_1_1_N = mkN "undanmanöver" ;
  undseende_nn_1_N = mkN "undseende" ;
  universalborr_nn_1_N = mkN "universalborr" ;
  uppbrottsorder_nn_1_N = mkN "uppbrottsorder" ;
  uppsjoe_nn_1_1_N = mkN "uppsjö" ;
  utbetalningsorder_nn_1_N = mkN "utbetalningsorder" ;
  utgiftsbudget_nn_1_N = mkN "utgiftsbudget" ;
  vaj_nn_1_N = mkN "vaj" ;
  vajsing_nn_1_N = mkN "vajsing" ;
  vamp_nn_1_N = mkN "vamp" ;
  vank_nn_1_N = mkN "vank" ;
  varnagel_nn_1_N = mkN "varnagel" ;
  venia_nn_1_N = mkN "venia" ;
  vers_nn_1_N = mkN "vers" ;
  vinsch_nn_1_N = mkN "vinsch" ;
  vintergroent_nn_1_1_N = mkN "vintergrönt" ;
  vinterny_nn_1_N = mkN "vinterny" ;
  vaenster_nn_1_1_N = mkN "vänster" ;
  vaerldsformat_nn_1_1_N = mkN "världsformat" ;
  vaerldsklass_nn_1_1_N = mkN "världsklass" ;
  vaesen_nn_1_1_N = mkN "väsen" ;
  vaan_nn_1_1_N = mkN "vån" ;
  vaarbudget_nn_1_1_N = mkN "vårbudget" ;
  workshop_nn_1_N = mkN "workshop" ;
  yrkeskollega_nn_1_N = mkN "yrkeskollega" ;
  aeppelkart_nn_1_1_N = mkN "äppelkart" ;
  aepplekart_nn_1_1_N = mkN "äpplekart" ;
  aerta_nn_1_1_N = mkN "ärta" ;
  aettelaegg_nn_1_1_N = mkN "ättelägg" ;
  aarscykel_nn_1_1_N = mkN "årscykel" ;
  aatervaendo_nn_1_1_N = mkN "återvändo" ;
  aatstramningsbudget_nn_1_1_N = mkN "åtstramningsbudget" ;
  aattaaarscykel_nn_1_1_N = mkN "åttaårscykel" ;
  oedesmaal_nn_1_1_N = mkN "ödesmål" ;
  oegonsikte_nn_1_1_N = mkN "ögonsikte" ;
  oera_nn_2_1_N = mkN "öra" ;
  oere_nn_1_1_N = mkN "öre" ;
  oeverspel_nn_1_1_N = mkN "överspel" "överspelet" "överspel" "överspelen" ;
  oeverkommando_nn_1_1_N = mkN "överkommando" "överkommandot" "överkommandon" "överkommandona" ;
  oekenrally_nn_1_1_N = mkN "ökenrally" "ökenrallyt" "ökenrallyn" "ökenrallyna" ;
  aatstramningsprogram_nn_1_1_N = mkN "åtstramningsprogram" "åtstramningsprogrammet" "åtstramningsprogram" "åtstramningsprogrammen" ;
  aatgaerdsprogram_nn_1_1_N = mkN "åtgärdsprogram" "åtgärdsprogrammet" "åtgärdsprogram" "åtgärdsprogrammen" ;
  aenglaspel_nn_1_1_N = mkN "änglaspel" "änglaspelet" "änglaspel" "änglaspelen" ;
  aecklo_nn_1_1_N = mkN "äcklo" "äcklot" "äcklon" "äcklona" ;
  zoo_nn_1_N = mkN "zoo" "zoot" "zoon" "zoona" ;
  zeugma_nn_1_N = mkN "zeugma" "zeugmat" "zeugman" "zeugmana" ;
  vaagspel_nn_1_1_N = mkN "vågspel" "vågspelet" "vågspel" "vågspelen" ;
  vaexelspel_nn_1_1_N = mkN "växelspel" "växelspelet" "växelspel" "växelspelen" ;
  vaexeldiskonto_nn_1_1_N = mkN "växeldiskonto" "växeldiskontot" "växeldiskonton" "växeldiskontona" ;
  vinterspel_nn_1_N = mkN "vinterspel" "vinterspelet" "vinterspel" "vinterspelen" ;
  vinterkvarter_nn_1_N = mkN "vinterkvarter" "vinterkvarteret" "vinterkvarter" "vinterkvarteren" ;
  vingummi_nn_1_N = mkN "vingummi" "vingummit" "vingummin" "vingummina" ;
  vindspel_nn_1_N = mkN "vindspel" "vindspelet" "vindspel" "vindspelen" ;
  villakvarter_nn_1_N = mkN "villakvarter" "villakvarteret" "villakvarter" "villakvarteren" ;
  varmgarage_nn_1_N = mkN "varmgarage" "varmgaraget" "varmgarage" "varmgaragen" ;
  uttalsfel_nn_1_N = mkN "uttalsfel" "uttalsfelet" "uttalsfel" "uttalsfelen" ;
  utspel_nn_1_N = mkN "utspel" "utspelet" "utspel" "utspelen" ;
  utbildningsprogram_nn_1_N = mkN "utbildningsprogram" "utbildningsprogrammet" "utbildningsprogram" "utbildningsprogrammen" ;
  uppspel_nn_1_N = mkN "uppspel" "uppspelet" "uppspel" "uppspelen" ;
  unigram_nn_1_N = mkN "unigram" "unigrammet" "unigram" "unigrammen" ;
  underraettelselaeckage_nn_1_1_N = mkN "underrättelseläckage" "underrättelseläckaget" "underrättelseläckage" "underrättelseläckagen" ;
  underhaallsprogram_nn_1_1_N = mkN "underhållsprogram" "underhållsprogrammet" "underhållsprogram" "underhållsprogrammen" ;
  underhaallningsprogram_nn_1_1_N = mkN "underhållningsprogram" "underhållningsprogrammet" "underhållningsprogram" "underhållningsprogrammen" ;
  taerningsspel_nn_1_1_N = mkN "tärningsspel" "tärningsspelet" "tärningsspel" "tärningsspelen" ;
  tv_program_nn_1_N = mkN "tv-program" "tv-programmet" "tv-program" "tv-programmen" ;
  traeningsdataspel_nn_1_1_N = mkN "träningsdataspel" "träningsdataspelet" "träningsdataspel" "träningsdataspelen" ;
  traeddiagram_nn_1_1_N = mkN "träddiagram" "träddiagrammet" "träddiagram" "träddiagrammen" ;
  tryckfel_nn_1_N = mkN "tryckfel" "tryckfelet" "tryckfel" "tryckfelen" ;
  trigram_nn_1_N = mkN "trigram" "trigrammet" "trigram" "trigrammen" ;
  totospel_nn_1_N = mkN "totospel" "totospelet" "totospel" "totospelen" ;
  tornerspel_nn_1_N = mkN "tornerspel" "tornerspelet" "tornerspel" "tornerspelen" ;
  ton_nn_2_N = mkN "ton" "tonnet" "ton" "tonnen" ;
  tjaenstefel_nn_1_1_N = mkN "tjänstefel" "tjänstefelet" "tjänstefel" "tjänstefelen" ;
  tillfriskningsprogram_nn_1_N = mkN "tillfriskningsprogram" "tillfriskningsprogrammet" "tillfriskningsprogram" "tillfriskningsprogrammen" ;
  teveprogram_nn_1_N = mkN "teveprogram" "teveprogrammet" "teveprogram" "teveprogrammen" ;
  telegram_nn_1_N = mkN "telegram" "telegrammet" "telegram" "telegrammen" ;
  telefonsvararprogram_nn_1_N = mkN "telefonsvararprogram" "telefonsvararprogrammet" "telefonsvararprogram" "telefonsvararprogrammen" ;
  tankefel_nn_1_N = mkN "tankefel" "tankefelet" "tankefel" "tankefelen" ;
  talkshowprogram_nn_1_N = mkN "talkshowprogram" "talkshowprogrammet" "talkshowprogram" "talkshowprogrammen" ;
  talfel_nn_1_N = mkN "talfel" "talfelet" "talfel" "talfelen" ;
  saangspel_nn_1_1_N = mkN "sångspel" "sångspelet" "sångspel" "sångspelen" ;
  saellskapsspel_nn_1_1_N = mkN "sällskapsspel" "sällskapsspelet" "sällskapsspel" "sällskapsspelen" ;
  syrenbuskage_nn_1_N = mkN "syrenbuskage" "syrenbuskaget" "syrenbuskage" "syrenbuskagen" ;
  syralaeckage_nn_1_1_N = mkN "syraläckage" "syraläckaget" "syraläckage" "syraläckagen" ;
  synfel_nn_1_N = mkN "synfel" "synfelet" "synfel" "synfelen" ;
  styrprogram_nn_1_N = mkN "styrprogram" "styrprogrammet" "styrprogram" "styrprogrammen" ;
  stroke_nn_1_N = mkN "stroke" "stroket" "stroke" "stroken" ;
  stormaktsspel_nn_1_N = mkN "stormaktsspel" "stormaktsspelet" "stormaktsspel" "stormaktsspelen" ;
  stolpdiagram_nn_1_N = mkN "stolpdiagram" "stolpdiagrammet" "stolpdiagram" "stolpdiagrammen" ;
  stockankare_nn_1_N = mkN "stockankare" "stockankaret" "stockankare" "stockankarna" ;
  stim_nn_1_N = mkN "stim" "stimmet" "stim" "stimmen" ;
  stenogram_nn_1_N = mkN "stenogram" "stenogrammet" "stenogram" "stenogrammen" ;
  stapeldiagram_nn_1_N = mkN "stapeldiagram" "stapeldiagrammet" "stapeldiagram" "stapeldiagrammen" ;
  spraakspel_nn_1_1_N = mkN "språkspel" "språkspelet" "språkspel" "språkspelen" ;
  spraakfel_nn_1_1_N = mkN "språkfel" "språkfelet" "språkfel" "språkfelen" ;
  sprututbytesprogram_nn_1_N = mkN "sprututbytesprogram" "sprututbytesprogrammet" "sprututbytesprogram" "sprututbytesprogrammen" ;
  spegelmonogram_nn_1_N = mkN "spegelmonogram" "spegelmonogrammet" "spegelmonogram" "spegelmonogrammen" ;
  sorgespel_nn_1_N = mkN "sorgespel" "sorgespelet" "sorgespel" "sorgespelen" ;
  sommarspel_nn_1_N = mkN "sommarspel" "sommarspelet" "sommarspel" "sommarspelen" ;
  sociogram_nn_1_N = mkN "sociogram" "sociogrammet" "sociogram" "sociogrammen" ;
  socialreportage_nn_1_N = mkN "socialreportage" "socialreportaget" "socialreportage" "socialreportagen" ;
  snyftreportage_nn_1_N = mkN "snyftreportage" "snyftreportaget" "snyftreportage" "snyftreportagen" ;
  slutspel_nn_1_N = mkN "slutspel" "slutspelet" "slutspel" "slutspelen" ;
  slutrim_nn_1_N = mkN "slutrim" "slutrimmet" "slutrim" "slutrimmen" ;
  slarvfel_nn_1_N = mkN "slarvfel" "slarvfelet" "slarvfel" "slarvfelen" ;
  skoetrum_nn_1_1_N = mkN "skötrum" "skötrummet" "skötrum" "skötrummen" ;
  skoenhetsfel_nn_1_1_N = mkN "skönhetsfel" "skönhetsfelet" "skönhetsfel" "skönhetsfelen" ;
  skaadespel_nn_1_1_N = mkN "skådespel" "skådespelet" "skådespel" "skådespelen" ;
  skyddsrum_nn_1_N = mkN "skyddsrum" "skyddsrummet" "skyddsrum" "skyddsrummen" ;
  skyddshem_nn_1_N = mkN "skyddshem" "skyddshemmet" "skyddshem" "skyddshemmen" ;
  skolhem_nn_1_N = mkN "skolhem" "skolhemmet" "skolhem" "skolhemmen" ;
  sjukhem_nn_1_N = mkN "sjukhem" "sjukhemmet" "sjukhem" "sjukhemmen" ;
  singelspel_nn_1_N = mkN "singelspel" "singelspelet" "singelspel" "singelspelen" ;
  servgame_nn_1_N = mkN "servgame" "servgamet" "servgame" "servgamen" ;
  serveringsrum_nn_1_N = mkN "serveringsrum" "serveringsrummet" "serveringsrum" "serveringsrummen" ;
  servegame_nn_1_N = mkN "servegame" "servegamet" "servegame" "servegamen" ;
  seriespel_nn_1_N = mkN "seriespel" "seriespelet" "seriespel" "seriespelen" ;
  seismogram_nn_1_N = mkN "seismogram" "seismogrammet" "seismogram" "seismogrammen" ;
  scharner_nn_1_N = mkN "scharner" "scharneret" "scharner" "scharneren" ;
  schackspel_nn_1_N = mkN "schackspel" "schackspelet" "schackspel" "schackspelen" ;
  satyrspel_nn_1_N = mkN "satyrspel" "satyrspelet" "satyrspel" "satyrspelen" ;
  samtalsrum_nn_1_N = mkN "samtalsrum" "samtalsrummet" "samtalsrum" "samtalsrummen" ;
  sammantraedesrum_nn_1_1_N = mkN "sammanträdesrum" "sammanträdesrummet" "sammanträdesrum" "sammanträdesrummen" ;
  samlingsrum_nn_1_N = mkN "samlingsrum" "samlingsrummet" "samlingsrum" "samlingsrummen" ;
  sakfel_nn_1_N = mkN "sakfel" "sakfelet" "sakfel" "sakfelen" ;
  sagovaesen_nn_1_1_N = mkN "sagoväsen" "sagoväsendet" "sagoväsen" "sagoväsena" ;
  sabotage_nn_1_N = mkN "sabotage" "sabotaget" "sabotage" "sabotagen" ;
  raevspel_nn_1_1_N = mkN "rävspel" "rävspelet" "rävspel" "rävspelen" ;
  raettegaangsfel_nn_1_1_N = mkN "rättegångsfel" "rättegångsfelet" "rättegångsfel" "rättegångsfelen" ;
  raenkspel_nn_1_1_N = mkN "ränkspel" "ränkspelet" "ränkspel" "ränkspelen" ;
  raelsfel_nn_1_1_N = mkN "rälsfel" "rälsfelet" "rälsfel" "rälsfelen" ;
  raeddningshem_nn_1_1_N = mkN "räddningshem" "räddningshemmet" "räddningshem" "räddningshemmen" ;
  rymdprogram_nn_1_N = mkN "rymdprogram" "rymdprogrammet" "rymdprogram" "rymdprogrammen" ;
  rum_nn_1_N = mkN "rum" "rummet" "rum" "rummen" ;
  rollspel_nn_1_N = mkN "rollspel" "rollspelet" "rollspel" "rollspelen" ;
  roderfel_nn_1_N = mkN "roderfel" "roderfelet" "roderfel" "roderfelen" ;
  rim_nn_1_N = mkN "rim" "rimmet" "rim" "rimmen" ;
  revider_nn_1_N = mkN "revider" "revideret" "revider" "revideren" ;
  resereportage_nn_1_N = mkN "resereportage" "resereportaget" "resereportage" "resereportagen" ;
  reportage_nn_1_N = mkN "reportage" "reportaget" "reportage" "reportagen" ;
  rehabiliteringshem_nn_1_N = mkN "rehabiliteringshem" "rehabiliteringshemmet" "rehabiliteringshem" "rehabiliteringshemmen" ;
  reglage_nn_1_N = mkN "reglage" "reglaget" "reglage" "reglagen" ;
  registerton_nn_1_N = mkN "registerton" "registertonnet" "registerton" "registertonnen" ;
  radioprogram_nn_1_N = mkN "radioprogram" "radioprogrammet" "radioprogram" "radioprogrammen" ;
  radiogram_nn_1_N = mkN "radiogram" "radiogrammet" "radiogram" "radiogrammen" ;
  paaklaedningsrum_nn_1_1_N = mkN "påklädningsrum" "påklädningsrummet" "påklädningsrum" "påklädningsrummen" ;
  puzzle_nn_1_N = mkN "puzzle" "puzzlet" "puzzle" "puzzlen" ;
  provrum_nn_1_N = mkN "provrum" "provrummet" "provrum" "provrummen" ;
  program_nn_1_N = mkN "program" "programmet" "program" "programmen" ;
  privatiseringsprogram_nn_1_N = mkN "privatiseringsprogram" "privatiseringsprogrammet" "privatiseringsprogram" "privatiseringsprogrammen" ;
  principprogram_nn_1_N = mkN "principprogram" "principprogrammet" "principprogram" "principprogrammen" ;
  pressrevider_nn_1_N = mkN "pressrevider" "pressrevideret" "pressrevider" "pressrevideren" ;
  presidenthoegkvarter_nn_1_1_N = mkN "presidenthögkvarter" "presidenthögkvarteret" "presidenthögkvarter" "presidenthögkvarteren" ;
  pollendiagram_nn_1_N = mkN "pollendiagram" "pollendiagrammet" "pollendiagram" "pollendiagrammen" ;
  pogram_nn_1_N = mkN "pogram" "pogrammet" "pogram" "pogrammen" ;
  pinorum_nn_1_N = mkN "pinorum" "pinorummet" "pinorum" "pinorummen" ;
  piktogram_nn_1_N = mkN "piktogram" "piktogrammet" "piktogram" "piktogrammen" ;
  pianospel_nn_1_N = mkN "pianospel" "pianospelet" "pianospel" "pianospelen" ;
  personalrum_nn_1_N = mkN "personalrum" "personalrummet" "personalrum" "personalrummen" ;
  pentagram_nn_1_N = mkN "pentagram" "pentagrammet" "pentagram" "pentagrammen" ;
  passionsspel_nn_1_N = mkN "passionsspel" "passionsspelet" "passionsspel" "passionsspelen" ;
  partivaesen_nn_1_1_N = mkN "partiväsen" "partiväsendet" "partiväsen" "partiväsena" ;
  partiprogram_nn_1_N = mkN "partiprogram" "partiprogrammet" "partiprogram" "partiprogrammen" ;
  parspel_nn_1_N = mkN "parspel" "parspelet" "parspel" "parspelen" ;
  paradrum_nn_1_N = mkN "paradrum" "paradrummet" "paradrum" "paradrummen" ;
  pannrum_nn_1_N = mkN "pannrum" "pannrummet" "pannrum" "pannrummen" ;
  oscillogram_nn_1_N = mkN "oscillogram" "oscillogrammet" "oscillogram" "oscillogrammen" ;
  orrspel_nn_1_N = mkN "orrspel" "orrspelet" "orrspel" "orrspelen" ;
  ordspel_nn_1_N = mkN "ordspel" "ordspelet" "ordspel" "ordspelen" ;
  omspel_nn_1_N = mkN "omspel" "omspelet" "omspel" "omspelen" ;
  omklaedningsrum_nn_1_1_N = mkN "omklädningsrum" "omklädningsrummet" "omklädningsrum" "omklädningsrummen" ;
  oljelaeckage_nn_1_1_N = mkN "oljeläckage" "oljeläckaget" "oljeläckage" "oljeläckagen" ;
  noejesprogram_nn_1_1_N = mkN "nöjesprogram" "nöjesprogrammet" "nöjesprogram" "nöjesprogrammen" ;
  noedrim_nn_1_1_N = mkN "nödrim" "nödrimmet" "nödrim" "nödrimmen" ;
  nyhetstelegram_nn_1_N = mkN "nyhetstelegram" "nyhetstelegrammet" "nyhetstelegram" "nyhetstelegrammen" ;
  nyhetsprogram_nn_1_N = mkN "nyhetsprogram" "nyhetsprogrammet" "nyhetsprogram" "nyhetsprogrammen" ;
  nyhetsankare_nn_1_N = mkN "nyhetsankare" "nyhetsankaret" "nyhetsankare" "nyhetsankarna" ;
  nomogram_nn_1_N = mkN "nomogram" "nomogrammet" "nomogram" "nomogrammen" ;
  nollsummespel_nn_1_N = mkN "nollsummespel" "nollsummespelet" "nollsummespel" "nollsummespelen" ;
  nettoregisterton_nn_1_N = mkN "nettoregisterton" "nettoregistertonnet" "nettoregisterton" "nettoregistertonnen" ;
  naturvaesen_nn_1_1_N = mkN "naturväsen" "naturväsendet" "naturväsen" "naturväsena" ;
  narvfel_nn_1_N = mkN "narvfel" "narvfelet" "narvfel" "narvfelen" ;
  narrspel_nn_1_N = mkN "narrspel" "narrspelet" "narrspel" "narrspelen" ;
  nanogram_nn_1_N = mkN "nanogram" "nanogrammet" "nanogram" "nanogrammen" ;
  n_gram_nn_1_N = mkN "n-gram" "n-grammet" "n-gram" "n-grammen" ;
  moerkrum_nn_1_1_N = mkN "mörkrum" "mörkrummet" "mörkrum" "mörkrummen" ;
  maengddiagram_nn_1_1_N = mkN "mängddiagram" "mängddiagrammet" "mängddiagram" "mängddiagrammen" ;
  mysteriespel_nn_1_N = mkN "mysteriespel" "mysteriespelet" "mysteriespel" "mysteriespelen" ;
  musettedragspel_nn_1_N = mkN "musettedragspel" "musettedragspelet" "musettedragspel" "musettedragspelen" ;
  murankare_nn_1_N = mkN "murankare" "murankaret" "murankare" "murankarna" ;
  munspel_nn_1_N = mkN "munspel" "munspelet" "munspel" "munspelen" ;
  mottagningsrum_nn_1_N = mkN "mottagningsrum" "mottagningsrummet" "mottagningsrum" "mottagningsrummen" ;
  mottagningshem_nn_1_N = mkN "mottagningshem" "mottagningshemmet" "mottagningshem" "mottagningshemmen" ;
  moringsankare_nn_1_N = mkN "moringsankare" "moringsankaret" "moringsankare" "moringsankarna" ;
  montage_nn_1_N = mkN "montage" "montaget" "montage" "montagen" ;
  monogram_nn_1_N = mkN "monogram" "monogrammet" "monogram" "monogrammen" ;
  moderniseringsprogram_nn_1_N = mkN "moderniseringsprogram" "moderniseringsprogrammet" "moderniseringsprogram" "moderniseringsprogrammen" ;
  mjukvaruprogram_nn_1_N = mkN "mjukvaruprogram" "mjukvaruprogrammet" "mjukvaruprogram" "mjukvaruprogrammen" ;
  mirakelspel_nn_1_N = mkN "mirakelspel" "mirakelspelet" "mirakelspel" "mirakelspelen" ;
  minnesfel_nn_1_N = mkN "minnesfel" "minnesfelet" "minnesfel" "minnesfelen" ;
  milligram_nn_1_N = mkN "milligram" "milligrammet" "milligram" "milligrammen" ;
  mikrogram_nn_1_N = mkN "mikrogram" "mikrogrammet" "mikrogram" "mikrogrammen" ;
  mellanspel_nn_1_N = mkN "mellanspel" "mellanspelet" "mellanspel" "mellanspelen" ;
  mellanrum_nn_1_N = mkN "mellanrum" "mellanrummet" "mellanrum" "mellanrummen" ;
  megaton_nn_1_N = mkN "megaton" "megatonnet" "megaton" "megatonnen" ;
  medelfel_nn_1_N = mkN "medelfel" "medelfelet" "medelfel" "medelfelen" ;
  matrum_nn_1_N = mkN "matrum" "matrummet" "matrum" "matrummen" ;
  maskspel_nn_1_N = mkN "maskspel" "maskspelet" "maskspel" "maskspelen" ;
  maskinrum_nn_1_N = mkN "maskinrum" "maskinrummet" "maskinrum" "maskinrummen" ;
  maner_nn_2_N = mkN "maner" "maneret" "maner" "maneren" ;
  maktspel_nn_1_N = mkN "maktspel" "maktspelet" "maktspel" "maktspelen" ;
  laangspel_nn_1_1_N = mkN "långspel" "långspelet" "långspel" "långspelen" ;
  laesrum_nn_1_1_N = mkN "läsrum" "läsrummet" "läsrum" "läsrummen" ;
  laerarrum_nn_1_1_N = mkN "lärarrum" "lärarrummet" "lärarrum" "lärarrummen" ;
  laeggspel_nn_1_1_N = mkN "läggspel" "läggspelet" "läggspel" "läggspelen" ;
  laeckage_nn_1_1_N = mkN "läckage" "läckaget" "läckage" "läckagen" ;
  lyxtelegram_nn_1_N = mkN "lyxtelegram" "lyxtelegrammet" "lyxtelegram" "lyxtelegrammen" ;
  lustspel_nn_1_N = mkN "lustspel" "lustspelet" "lustspel" "lustspelen" ;
  lunchrum_nn_1_N = mkN "lunchrum" "lunchrummet" "lunchrum" "lunchrummen" ;
  luftsabotage_nn_1_N = mkN "luftsabotage" "luftsabotaget" "luftsabotage" "luftsabotagen" ;
  luftrum_nn_1_N = mkN "luftrum" "luftrummet" "luftrum" "luftrummen" ;
  luftfartssabotage_nn_1_N = mkN "luftfartssabotage" "luftfartssabotaget" "luftfartssabotage" "luftfartssabotagen" ;
  loppspel_nn_1_N = mkN "loppspel" "loppspelet" "loppspel" "loppspelen" ;
  logogram_nn_1_N = mkN "logogram" "logogrammet" "logogram" "logogrammen" ;
  linsfel_nn_1_N = mkN "linsfel" "linsfelet" "linsfel" "linsfelen" ;
  linjespel_nn_1_N = mkN "linjespel" "linjespelet" "linjespel" "linjespelen" ;
  libido_nn_1_N = mkN "libido" "libidon" "libidon" "libidona" ;
  lemgram_nn_1_N = mkN "lemgram" "lemgrammet" "lemgram" "lemgrammen" ;
  lastrum_nn_1_N = mkN "lastrum" "lastrummet" "lastrum" "lastrummen" ;
  lagspel_nn_1_N = mkN "lagspel" "lagspelet" "lagspel" "lagspelen" ;
  lagrum_nn_1_N = mkN "lagrum" "lagrummet" "lagrum" "lagrummen" ;
  kyrkorum_nn_1_N = mkN "kyrkorum" "kyrkorummet" "kyrkorum" "kyrkorummen" ;
  kvarter_nn_1_N = mkN "kvarter" "kvarteret" "kvarter" "kvarteren" ;
  kurtage_nn_1_N = mkN "kurtage" "kurtaget" "kurtage" "kurtagen" ;
  kuratel_nn_1_N = mkN "kuratel" "kuratelet" "kuratel" "kuratelen" ;
  kulspel_nn_1_N = mkN "kulspel" "kulspelet" "kulspel" "kulspelen" ;
  kroenikespel_nn_1_1_N = mkN "krönikespel" "krönikespelet" "krönikespel" "krönikespelen" ;
  kryptogram_nn_1_N = mkN "kryptogram" "kryptogrammet" "kryptogram" "kryptogrammen" ;
  kronikerhem_nn_1_N = mkN "kronikerhem" "kronikerhemmet" "kronikerhem" "kronikerhemmen" ;
  kristusmonogram_nn_1_N = mkN "kristusmonogram" "kristusmonogrammet" "kristusmonogram" "kristusmonogrammen" ;
  krillstim_nn_1_N = mkN "krillstim" "krillstimmet" "krillstim" "krillstimmen" ;
  krigsspel_nn_1_N = mkN "krigsspel" "krigsspelet" "krigsspel" "krigsspelen" ;
  krigsreportage_nn_1_N = mkN "krigsreportage" "krigsreportaget" "krigsreportage" "krigsreportagen" ;
  kraftspel_nn_1_N = mkN "kraftspel" "kraftspelet" "kraftspel" "kraftspelen" ;
  kortspel_nn_1_N = mkN "kortspel" "kortspelet" "kortspel" "kortspelen" ;
  korrekturfel_nn_1_N = mkN "korrekturfel" "korrekturfelet" "korrekturfel" "korrekturfelen" ;
  konvalescenthem_nn_1_N = mkN "konvalescenthem" "konvalescenthemmet" "konvalescenthem" "konvalescenthemmen" ;
  kontrollrum_nn_1_N = mkN "kontrollrum" "kontrollrummet" "kontrollrum" "kontrollrummen" ;
  kontorsrum_nn_1_N = mkN "kontorsrum" "kontorsrummet" "kontorsrum" "kontorsrummen" ;
  konferensrum_nn_1_N = mkN "konferensrum" "konferensrummet" "konferensrum" "konferensrummen" ;
  kollage_nn_1_N = mkN "kollage" "kollaget" "kollage" "kollagen" ;
  klockspel_nn_1_N = mkN "klockspel" "klockspelet" "klockspel" "klockspelen" ;
  klipprum_nn_1_N = mkN "klipprum" "klipprummet" "klipprum" "klipprummen" ;
  klientel_nn_1_N = mkN "klientel" "klientelet" "klientel" "klientelen" ;
  klaver_nn_1_N = mkN "klaver" "klaveret" "klaver" "klaveren" ;
  klassrum_nn_1_N = mkN "klassrum" "klassrummet" "klassrum" "klassrummen" ;
  klaffel_nn_1_N = mkN "klaffel" "klaffelet" "klaffel" "klaffelen" ;
  kiloton_nn_1_N = mkN "kiloton" "kilotonnet" "kiloton" "kilotonnen" ;
  kilogram_nn_1_N = mkN "kilogram" "kilogrammet" "kilogram" "kilogrammen" ;
  killespel_nn_1_N = mkN "killespel" "killespelet" "killespel" "killespelen" ;
  kasus_nn_2_N = mkN "kasus" "kasus" "kasus" "kasusen" ;
  kardiogram_nn_1_N = mkN "kardiogram" "kardiogrammet" "kardiogram" "kardiogrammen" ;
  kardinalfel_nn_1_N = mkN "kardinalfel" "kardinalfelet" "kardinalfel" "kardinalfelen" ;
  karaktaersfel_nn_1_1_N = mkN "karaktärsfel" "karaktärsfelet" "karaktärsfel" "karaktärsfelen" ;
  kapprum_nn_1_N = mkN "kapprum" "kapprummet" "kapprum" "kapprummen" ;
  kammarspel_nn_1_N = mkN "kammarspel" "kammarspelet" "kammarspel" "kammarspelen" ;
  kallgarage_nn_1_N = mkN "kallgarage" "kallgaraget" "kallgarage" "kallgaragen" ;
  julklappsrim_nn_1_N = mkN "julklappsrim" "julklappsrimmet" "julklappsrim" "julklappsrimmen" ;
  introduktionsprogram_nn_1_N = mkN "introduktionsprogram" "introduktionsprogrammet" "introduktionsprogram" "introduktionsprogrammen" ;
  intrigspel_nn_1_N = mkN "intrigspel" "intrigspelet" "intrigspel" "intrigspelen" ;
  intalan_nn_1_N = mkN "intalan" "intalan" "intalanden" "intalandena" ;
  inrim_nn_1_N = mkN "inrim" "inrimmet" "inrim" "inrimmen" ;
  inackorderingshem_nn_1_N = mkN "inackorderingshem" "inackorderingshemmet" "inackorderingshem" "inackorderingshemmen" ;
  ideogram_nn_1_N = mkN "ideogram" "ideogrammet" "ideogram" "ideogrammen" ;
  hoerspel_nn_1_1_N = mkN "hörspel" "hörspelet" "hörspel" "hörspelen" ;
  hoegkvarter_nn_1_1_N = mkN "högkvarter" "högkvarteret" "högkvarter" "högkvarteren" ;
  haalrum_nn_1_1_N = mkN "hålrum" "hålrummet" "hålrum" "hålrummen" ;
  haelsogym_nn_1_1_N = mkN "hälsogym" "hälsogymmet" "hälsogym" "hälsogymmen" ;
  huvudkvarter_nn_1_N = mkN "huvudkvarter" "huvudkvarteret" "huvudkvarter" "huvudkvarteren" ;
  hotellrum_nn_1_N = mkN "hotellrum" "hotellrummet" "hotellrum" "hotellrummen" ;
  hospice_nn_1_N = mkN "hospice" "hospicet" "hospice" "hospicen" ;
  hommage_nn_1_N = mkN "hommage" "hommaget" "hommage" "hommagen" ;
  hologram_nn_1_N = mkN "hologram" "hologrammet" "hologram" "hologrammen" ;
  hjaertfel_nn_1_1_N = mkN "hjärtfel" "hjärtfelet" "hjärtfel" "hjärtfelen" ;
  hem_nn_1_N = mkN "hem" "hemmet" "hem" "hemmen" ;
  hektogram_nn_1_N = mkN "hektogram" "hektogrammet" "hektogram" "hektogrammen" ;
  hastighetsreglage_nn_1_N = mkN "hastighetsreglage" "hastighetsreglaget" "hastighetsreglage" "hastighetsreglagen" ;
  hasardspel_nn_1_N = mkN "hasardspel" "hasardspelet" "hasardspel" "hasardspelen" ;
  handlingsprogram_nn_1_N = mkN "handlingsprogram" "handlingsprogrammet" "handlingsprogram" "handlingsprogrammen" ;
  handklaver_nn_1_N = mkN "handklaver" "handklaveret" "handklaver" "handklaveren" ;
  handbagage_nn_1_N = mkN "handbagage" "handbagaget" "handbagage" "handbagagen" ;
  hamnkvarter_nn_1_N = mkN "hamnkvarter" "hamnkvarteret" "hamnkvarter" "hamnkvarteren" ;
  halvrim_nn_1_N = mkN "halvrim" "halvrimmet" "halvrim" "halvrimmen" ;
  gaardsrum_nn_1_1_N = mkN "gårdsrum" "gårdsrummet" "gårdsrum" "gårdsrummen" ;
  gaangspel_nn_1_1_N = mkN "gångspel" "gångspelet" "gångspel" "gångspelen" ;
  gaestspel_nn_1_1_N = mkN "gästspel" "gästspelet" "gästspel" "gästspelen" ;
  gaestrum_nn_1_1_N = mkN "gästrum" "gästrummet" "gästrum" "gästrummen" ;
  gym_nn_1_N = mkN "gym" "gymmet" "gym" "gymmen" ;
  gyckelspel_nn_1_N = mkN "gyckelspel" "gyckelspelet" "gyckelspel" "gyckelspelen" ;
  gunrum_nn_1_N = mkN "gunrum" "gunrummet" "gunrum" "gunrummen" ;
  gubbslem_nn_1_N = mkN "gubbslem" "gubbslemmet" "gubbslem" "gubbslemmen" ;
  groetrim_nn_1_1_N = mkN "grötrim" "grötrimmet" "grötrim" "grötrimmen" ;
  grundfel_nn_1_N = mkN "grundfel" "grundfelet" "grundfel" "grundfelen" ;
  gratisspel_nn_1_N = mkN "gratisspel" "gratisspelet" "gratisspel" "gratisspelen" ;
  gratisprogram_nn_1_N = mkN "gratisprogram" "gratisprogrammet" "gratisprogram" "gratisprogrammen" ;
  gram_nn_1_N = mkN "gram" "grammet" "gram" "grammen" ;
  golfspel_nn_1_N = mkN "golfspel" "golfspelet" "golfspel" "golfspelen" ;
  glaedjekvarter_nn_1_1_N = mkN "glädjekvarter" "glädjekvarteret" "glädjekvarter" "glädjekvarteren" ;
  glapprum_nn_1_N = mkN "glapprum" "glapprummet" "glapprum" "glapprummen" ;
  gladiatorspel_nn_1_N = mkN "gladiatorspel" "gladiatorspelet" "gladiatorspel" "gladiatorspelen" ;
  gitarrspel_nn_1_N = mkN "gitarrspel" "gitarrspelet" "gitarrspel" "gitarrspelen" ;
  gigaton_nn_1_N = mkN "gigaton" "gigatonnet" "gigaton" "gigatonnen" ;
  generalfel_nn_1_N = mkN "generalfel" "generalfelet" "generalfel" "generalfelen" ;
  gasreglage_nn_1_N = mkN "gasreglage" "gasreglaget" "gasreglage" "gasreglagen" ;
  gaslaeckage_nn_1_1_N = mkN "gasläckage" "gasläckaget" "gasläckage" "gasläckagen" ;
  garage_nn_1_N = mkN "garage" "garaget" "garage" "garagen" ;
  game_nn_1_N = mkN "game" "gamet" "game" "gamen" ;
  gaffelankare_nn_1_N = mkN "gaffelankare" "gaffelankaret" "gaffelankare" "gaffelankarna" ;
  foeraeldrahem_nn_1_1_N = mkN "föräldrahem" "föräldrahemmet" "föräldrahem" "föräldrahemmen" ;
  foervaringsrum_nn_1_1_N = mkN "förvaringsrum" "förvaringsrummet" "förvaringsrum" "förvaringsrummen" ;
  foersvarsspel_nn_1_1_N = mkN "försvarsspel" "försvarsspelet" "försvarsspel" "försvarsspelen" ;
  foerspel_nn_1_1_N = mkN "förspel" "förspelet" "förspel" "förspelen" ;
  foerslagsrum_nn_1_1_N = mkN "förslagsrum" "förslagsrummet" "förslagsrum" "förslagsrummen" ;
  foersamlingshem_nn_1_1_N = mkN "församlingshem" "församlingshemmet" "församlingshem" "församlingshemmen" ;
  foerraadsrum_nn_1_1_N = mkN "förrådsrum" "förrådsrummet" "förrådsrum" "förrådsrummen" ;
  foerrum_nn_1_1_N = mkN "förrum" "förrummet" "förrum" "förrummen" ;
  foerhoersrum_nn_1_1_N = mkN "förhörsrum" "förhörsrummet" "förhörsrum" "förhörsrummen" ;
  foerdjupningsreportage_nn_1_1_N = mkN "fördjupningsreportage" "fördjupningsreportaget" "fördjupningsreportage" "fördjupningsreportagen" ;
  foedelsehem_nn_1_1_N = mkN "födelsehem" "födelsehemmet" "födelsehem" "födelsehemmen" ;
  faergspel_nn_1_1_N = mkN "färgspel" "färgspelet" "färgspel" "färgspelen" ;
  faedernehem_nn_1_1_N = mkN "fädernehem" "fädernehemmet" "fädernehem" "fädernehemmen" ;
  fritidshem_nn_1_N = mkN "fritidshem" "fritidshemmet" "fritidshem" "fritidshemmen" ;
  fotomontage_nn_1_N = mkN "fotomontage" "fotomontaget" "fotomontage" "fotomontagen" ;
  fotogram_nn_1_N = mkN "fotogram" "fotogrammet" "fotogram" "fotogrammen" ;
  fotfel_nn_1_N = mkN "fotfel" "fotfelet" "fotfel" "fotfelen" ;
  fosterhem_nn_1_N = mkN "fosterhem" "fosterhemmet" "fosterhem" "fosterhemmen" ;
  formspel_nn_1_N = mkN "formspel" "formspelet" "formspel" "formspelen" ;
  formfel_nn_1_N = mkN "formfel" "formfelet" "formfel" "formfelen" ;
  fonogram_nn_1_N = mkN "fonogram" "fonogrammet" "fonogram" "fonogrammen" ;
  folklustspel_nn_1_N = mkN "folklustspel" "folklustspelet" "folklustspel" "folklustspelen" ;
  folkhem_nn_1_N = mkN "folkhem" "folkhemmet" "folkhem" "folkhemmen" ;
  floedesdiagram_nn_1_1_N = mkN "flödesdiagram" "flödesdiagrammet" "flödesdiagram" "flödesdiagrammen" ;
  flipperspel_nn_1_N = mkN "flipperspel" "flipperspelet" "flipperspel" "flipperspelen" ;
  flaggspel_nn_1_N = mkN "flaggspel" "flaggspelet" "flaggspel" "flaggspelen" ;
  fittstim_nn_1_N = mkN "fittstim" "fittstimmet" "fittstim" "fittstimmen" ;
  fiskstim_nn_1_N = mkN "fiskstim" "fiskstimmet" "fiskstim" "fiskstimmen" ;
  finrum_nn_1_N = mkN "finrum" "finrummet" "finrum" "finrummen" ;
  festspel_nn_1_N = mkN "festspel" "festspelet" "festspel" "festspelen" ;
  festprogram_nn_1_N = mkN "festprogram" "festprogrammet" "festprogram" "festprogrammen" ;
  fegspel_nn_1_N = mkN "fegspel" "fegspelet" "fegspel" "fegspelen" ;
  featureprogram_nn_1_N = mkN "featureprogram" "featureprogrammet" "featureprogram" "featureprogrammen" ;
  fattigkvarter_nn_1_N = mkN "fattigkvarter" "fattigkvarteret" "fattigkvarter" "fattigkvarteren" ;
  fastage_nn_1_N = mkN "fastage" "fastaget" "fastage" "fastagen" ;
  fartreglage_nn_1_N = mkN "fartreglage" "fartreglaget" "fartreglage" "fartreglagen" ;
  fantasispel_nn_1_N = mkN "fantasispel" "fantasispelet" "fantasispel" "fantasispelen" ;
  faner_nn_1_N = mkN "faner" "faneret" "faner" "faneren" ;
  familjeprogram_nn_1_N = mkN "familjeprogram" "familjeprogrammet" "familjeprogram" "familjeprogrammen" ;
  familjehem_nn_1_N = mkN "familjehem" "familjehemmet" "familjehem" "familjehemmen" ;
  familjedaghem_nn_1_N = mkN "familjedaghem" "familjedaghemmet" "familjedaghem" "familjedaghemmen" ;
  falskspel_nn_1_N = mkN "falskspel" "falskspelet" "falskspel" "falskspelen" ;
  faktafel_nn_1_N = mkN "faktafel" "faktafelet" "faktafel" "faktafelen" ;
  eremitage_nn_1_N = mkN "eremitage" "eremitaget" "eremitage" "eremitagen" ;
  epitel_nn_1_N = mkN "epitel" "epitelet" "epitel" "epitelen" ;
  epigram_nn_1_N = mkN "epigram" "epigrammet" "epigram" "epigrammen" ;
  enkelspel_nn_1_N = mkN "enkelspel" "enkelspelet" "enkelspel" "enkelspelen" ;
  enkelrum_nn_1_N = mkN "enkelrum" "enkelrummet" "enkelrum" "enkelrummen" ;
  engram_nn_1_N = mkN "engram" "engrammet" "engram" "engrammen" ;
  enbaeddsrum_nn_1_1_N = mkN "enbäddsrum" "enbäddsrummet" "enbäddsrum" "enbäddsrummen" ;
  emballage_nn_1_N = mkN "emballage" "emballaget" "emballage" "emballagen" ;
  elevhem_nn_1_N = mkN "elevhem" "elevhemmet" "elevhem" "elevhemmen" ;
  elektrokardiogram_nn_1_N = mkN "elektrokardiogram" "elektrokardiogrammet" "elektrokardiogram" "elektrokardiogrammen" ;
  elektroencefalogram_nn_1_N = mkN "elektroencefalogram" "elektroencefalogrammet" "elektroencefalogram" "elektroencefalogrammen" ;
  eldrum_nn_1_N = mkN "eldrum" "eldrummet" "eldrum" "eldrummen" ;
  ekipage_nn_1_N = mkN "ekipage" "ekipaget" "ekipage" "ekipagen" ;
  egnahem_nn_1_N = mkN "egnahem" "egnahemmet" "egnahem" "egnahemmen" ;
  efterspel_nn_1_N = mkN "efterspel" "efterspelet" "efterspel" "efterspelen" ;
  dubbelspel_nn_1_N = mkN "dubbelspel" "dubbelspelet" "dubbelspel" "dubbelspelen" ;
  dubbelrum_nn_1_N = mkN "dubbelrum" "dubbelrummet" "dubbelrum" "dubbelrummen" ;
  dubbelgarage_nn_1_N = mkN "dubbelgarage" "dubbelgaraget" "dubbelgarage" "dubbelgaragen" ;
  dubbelfel_nn_1_N = mkN "dubbelfel" "dubbelfelet" "dubbelfel" "dubbelfelen" ;
  drivankare_nn_1_N = mkN "drivankare" "drivankaret" "drivankare" "drivankarna" ;
  drillprogram_nn_1_N = mkN "drillprogram" "drillprogrammet" "drillprogram" "drillprogrammen" ;
  drickankare_nn_1_N = mkN "drickankare" "drickankaret" "drickankare" "drickankarna" ;
  dragspel_nn_1_N = mkN "dragspel" "dragspelet" "dragspel" "dragspelen" ;
  dominospel_nn_1_N = mkN "dominospel" "dominospelet" "dominospel" "dominospelen" ;
  dokumentaerprogram_nn_1_1_N = mkN "dokumentärprogram" "dokumentärprogrammet" "dokumentärprogram" "dokumentärprogrammen" ;
  diskrum_nn_1_N = mkN "diskrum" "diskrummet" "diskrum" "diskrummen" ;
  diagram_nn_1_N = mkN "diagram" "diagrammet" "diagram" "diagrammen" ;
  deponens_nn_1_N = mkN "deponens" "deponens" "deponens" "deponensen" ;
  dekolletage_nn_1_N = mkN "dekolletage" "dekolletaget" "dekolletage" "dekolletagen" ;
  deciton_nn_1_N = mkN "deciton" "decitonnet" "deciton" "decitonnen" ;
  debattprogram_nn_1_N = mkN "debattprogram" "debattprogrammet" "debattprogram" "debattprogrammen" ;
  debacle_nn_1_N = mkN "debacle" "debaclet" "debacle" "debaclen" ;
  dataspel_nn_1_N = mkN "dataspel" "dataspelet" "dataspel" "dataspelen" ;
  dataprogram_nn_1_N = mkN "dataprogram" "dataprogrammet" "dataprogram" "dataprogrammen" ;
  dartspel_nn_1_N = mkN "dartspel" "dartspelet" "dartspel" "dartspelen" ;
  damspel_nn_1_N = mkN "damspel" "damspelet" "damspel" "damspelen" ;
  damrum_nn_1_N = mkN "damrum" "damrummet" "damrum" "damrummen" ;
  dagsprogram_nn_1_N = mkN "dagsprogram" "dagsprogrammet" "dagsprogram" "dagsprogrammen" ;
  dagrum_nn_1_N = mkN "dagrum" "dagrummet" "dagrum" "dagrummen" ;
  daghem_nn_1_N = mkN "daghem" "daghemmet" "daghem" "daghemmen" ;
  college_nn_1_N = mkN "college" "colleget" "college" "collegen" ;
  collage_nn_1_N = mkN "collage" "collaget" "collage" "collagen" ;
  charner_nn_1_N = mkN "charner" "charneret" "charner" "charneren" ;
  ceremoniel_nn_1_N = mkN "ceremoniel" "ceremonielet" "ceremoniel" "ceremonielen" ;
  centigram_nn_1_N = mkN "centigram" "centigrammet" "centigram" "centigrammen" ;
  camouflage_nn_1_N = mkN "camouflage" "camouflaget" "camouflage" "camouflagen" ;
  boenerum_nn_1_1_N = mkN "bönerum" "bönerummet" "bönerum" "bönerummen" ;
  buskage_nn_1_N = mkN "buskage" "buskaget" "buskage" "buskagen" ;
  bubbelgum_nn_1_N = mkN "bubbelgum" "bubbelgummet" "bubbelgum" "bubbelgummen" ;
  broestpumpsutspel_nn_1_1_N = mkN "bröstpumpsutspel" "bröstpumpsutspelet" "bröstpumpsutspel" "bröstpumpsutspelen" ;
  broestmjoelkspumpsutspel_nn_1_1_N = mkN "bröstmjölkspumpsutspel" "bröstmjölkspumpsutspelet" "bröstmjölkspumpsutspel" "bröstmjölkspumpsutspelen" ;
  braedspel_nn_1_1_N = mkN "brädspel" "brädspelet" "brädspel" "brädspelen" ;
  brytningsfel_nn_1_N = mkN "brytningsfel" "brytningsfelet" "brytningsfel" "brytningsfelen" ;
  brytarfel_nn_1_N = mkN "brytarfel" "brytarfelet" "brytarfel" "brytarfelen" ;
  bruttoregisterton_nn_1_N = mkN "bruttoregisterton" "bruttoregistertonnet" "bruttoregisterton" "bruttoregistertonnen" ;
  bromsfel_nn_1_N = mkN "bromsfel" "bromsfelet" "bromsfel" "bromsfelen" ;
  brevtelegram_nn_1_N = mkN "brevtelegram" "brevtelegrammet" "brevtelegram" "brevtelegrammen" ;
  bostadskvarter_nn_1_N = mkN "bostadskvarter" "bostadskvarteret" "bostadskvarter" "bostadskvarteren" ;
  boningsrum_nn_1_N = mkN "boningsrum" "boningsrummet" "boningsrum" "boningsrummen" ;
  bollspel_nn_1_N = mkN "bollspel" "bollspelet" "bollspel" "bollspelen" ;
  bokstavsrim_nn_1_N = mkN "bokstavsrim" "bokstavsrimmet" "bokstavsrim" "bokstavsrimmen" ;
  bogankare_nn_1_N = mkN "bogankare" "bogankaret" "bogankare" "bogankarna" ;
  blommogram_nn_1_N = mkN "blommogram" "blommogrammet" "blommogram" "blommogrammen" ;
  blockdiagram_nn_1_N = mkN "blockdiagram" "blockdiagrammet" "blockdiagram" "blockdiagrammen" ;
  bistaandsprogram_nn_1_1_N = mkN "biståndsprogram" "biståndsprogrammet" "biståndsprogram" "biståndsprogrammen" ;
  biljardspel_nn_1_N = mkN "biljardspel" "biljardspelet" "biljardspel" "biljardspelen" ;
  bildspel_nn_1_N = mkN "bildspel" "bildspelet" "bildspel" "bildspelen" ;
  bildreportage_nn_1_N = mkN "bildreportage" "bildreportaget" "bildreportage" "bildreportagen" ;
  bildningsfel_nn_1_N = mkN "bildningsfel" "bildningsfelet" "bildningsfel" "bildningsfelen" ;
  bigram_nn_1_N = mkN "bigram" "bigrammet" "bigram" "bigrammen" ;
  besoeksrum_nn_1_1_N = mkN "besöksrum" "besöksrummet" "besöksrum" "besöksrummen" ;
  beslutsrum_nn_1_N = mkN "beslutsrum" "beslutsrummet" "beslutsrum" "beslutsrummen" ;
  bergrum_nn_1_N = mkN "bergrum" "bergrummet" "bergrum" "bergrummen" ;
  behandlingsrum_nn_1_N = mkN "behandlingsrum" "behandlingsrummet" "behandlingsrum" "behandlingsrummen" ;
  behandlingsprogram_nn_1_N = mkN "behandlingsprogram" "behandlingsprogrammet" "behandlingsprogram" "behandlingsprogrammen" ;
  behandlingshem_nn_1_N = mkN "behandlingshem" "behandlingshemmet" "behandlingshem" "behandlingshemmen" ;
  begynnelserim_nn_1_N = mkN "begynnelserim" "begynnelserimmet" "begynnelserim" "begynnelserimmen" ;
  begravningsspel_nn_1_N = mkN "begravningsspel" "begravningsspelet" "begravningsspel" "begravningsspelen" ;
  barogram_nn_1_N = mkN "barogram" "barogrammet" "barogram" "barogrammen" ;
  barnhem_nn_1_N = mkN "barnhem" "barnhemmet" "barnhem" "barnhemmen" ;
  barndomshem_nn_1_N = mkN "barndomshem" "barndomshemmet" "barndomshem" "barndomshemmen" ;
  barndaghem_nn_1_N = mkN "barndaghem" "barndaghemmet" "barndaghem" "barndaghemmen" ;
  baner_nn_1_N = mkN "baner" "baneret" "baner" "baneren" ;
  bandage_nn_1_N = mkN "bandage" "bandaget" "bandage" "bandagen" ;
  bakgrundsreportage_nn_1_N = mkN "bakgrundsreportage" "bakgrundsreportaget" "bakgrundsreportage" "bakgrundsreportagen" ;
  bagagerum_nn_1_N = mkN "bagagerum" "bagagerummet" "bagagerum" "bagagerummen" ;
  badrum_nn_1_N = mkN "badrum" "badrummet" "badrum" "badrummen" ;
  avbildningsfel_nn_1_N = mkN "avbildningsfel" "avbildningsfelet" "avbildningsfel" "avbildningsfelen" ;
  audiogram_nn_1_N = mkN "audiogram" "audiogrammet" "audiogram" "audiogrammen" ;
  asyndeton_nn_1_N = mkN "asyndeton" "asyndeton" "asyndeton" "asyndetonen" ;
  arkadspel_nn_1_N = mkN "arkadspel" "arkadspelet" "arkadspel" "arkadspelen" ;
  arbetsrum_nn_1_N = mkN "arbetsrum" "arbetsrummet" "arbetsrum" "arbetsrummen" ;
  arbetarkvarter_nn_1_N = mkN "arbetarkvarter" "arbetarkvarteret" "arbetarkvarter" "arbetarkvarteren" ;
  apspel_nn_1_N = mkN "apspel" "apspelet" "apspel" "apspelen" ;
  apparatrum_nn_1_N = mkN "apparatrum" "apparatrummet" "apparatrum" "apparatrummen" ;
  apanage_nn_1_N = mkN "apanage" "apanaget" "apanage" "apanagen" ;
  antivirusprogram_nn_1_N = mkN "antivirusprogram" "antivirusprogrammet" "antivirusprogram" "antivirusprogrammen" ;
  ankarspel_nn_1_N = mkN "ankarspel" "ankarspelet" "ankarspel" "ankarspelen" ;
  ankare_nn_1_N = mkN "ankare" "ankaret" "ankare" "ankarna" ;
  anhaallan_nn_1_1_N = mkN "anhållan" "anhållan" "anhållanden" "anhållandena" ;
  anfallsspel_nn_1_N = mkN "anfallsspel" "anfallsspelet" "anfallsspel" "anfallsspelen" ;
  anestesirum_nn_1_N = mkN "anestesirum" "anestesirummet" "anestesirum" "anestesirummen" ;
  andevaesen_nn_1_1_N = mkN "andeväsen" "andeväsendet" "andeväsen" "andeväsena" ;
  anagram_nn_1_N = mkN "anagram" "anagrammet" "anagram" "anagrammen" ;
  allrum_nn_1_N = mkN "allrum" "allrummet" "allrum" "allrummen" ;
  affaerskvarter_nn_1_1_N = mkN "affärskvarter" "affärskvarteret" "affärskvarter" "affärskvarteren" ;
  affinage_nn_1_N = mkN "affinage" "affinaget" "affinage" "affinagen" ;
  aerogram_nn_1_N = mkN "aerogram" "aerogrammet" "aerogram" "aerogrammen" ;
  adelshem_nn_1_N = mkN "adelshem" "adelshemmet" "adelshem" "adelshemmen" ;
  TV_program_nn_1_N = mkN "TV-program" "TV-programmet" "TV-program" "TV-programmen" ;
  SAP_program_nn_1_N = mkN "SAP-program" "SAP-programmet" "SAP-program" "SAP-programmen" ;
  Apolloprogram_nn_1_N = mkN "Apolloprogram" "Apolloprogrammet" "Apolloprogram" "Apolloprogrammen" ;
  xalkoholinnehav_nn_1_N = mkN "﻿alkoholinnehav" neutrum  ;
  oevervattensfartyg_nn_1_1_N = mkN "övervattensfartyg" neutrum  ;
  oevertramp_nn_1_1_N = mkN "övertramp" neutrum  ;
  oevertidsberg_nn_1_1_N = mkN "övertidsberg" neutrum  ;
  oevertalningsfoersoek_nn_1_1_N = mkN "övertalningsförsök" neutrum  ;
  oevertag_nn_1_1_N = mkN "övertag" neutrum  ;
  oeversaettningsprov_nn_1_1_N = mkN "översättningsprov" neutrum  ;
  oeversaettningslaan_nn_1_1_N = mkN "översättningslån" neutrum  ;
  oeverstroemsskydd_nn_1_1_N = mkN "överströmsskydd" neutrum  ;
  oeverslag_nn_1_1_N = mkN "överslag" neutrum  ;
  oeverskaap_nn_1_1_N = mkN "överskåp" neutrum  ;
  oeverskott_nn_1_1_N = mkN "överskott" neutrum  ;
  oeversiktsverk_nn_1_1_N = mkN "översiktsverk" neutrum  ;
  oeverraskningsmoment_nn_1_1_N = mkN "överraskningsmoment" neutrum  ;
  oeverraskningsanfall_nn_1_1_N = mkN "överraskningsanfall" neutrum  ;
  oeverplagg_nn_1_1_N = mkN "överplagg" neutrum  ;
  oeverord_nn_1_1_N = mkN "överord" neutrum  ;
  oeverljudsplan_nn_1_1_N = mkN "överljudsplan" neutrum  ;
  oeverliv_nn_1_1_N = mkN "överliv" neutrum  ;
  oeverlevnadsskael_nn_1_1_N = mkN "överlevnadsskäl" neutrum  ;
  oeverlakan_nn_1_1_N = mkN "överlakan" neutrum  ;
  oeverladdningsskydd_nn_1_1_N = mkN "överladdningsskydd" neutrum  ;
  oeverkaeksben_nn_1_1_N = mkN "överkäksben" neutrum  ;
  oeverhaeng_nn_1_1_N = mkN "överhäng" neutrum  ;
  oeverhettningsskydd_nn_1_1_N = mkN "överhettningsskydd" neutrum  ;
  oevergaangsverb_nn_1_1_N = mkN "övergångsverb" neutrum  ;
  oevergaangstillstaand_nn_1_1_N = mkN "övergångstillstånd" neutrum  ;
  oevergrepp_nn_1_1_N = mkN "övergrepp" neutrum  ;
  oeverfall_nn_1_1_N = mkN "överfall" neutrum  ;
  oeverdaad_nn_1_1_N = mkN "överdåd" neutrum  ;
  oeverdrag_nn_1_1_N = mkN "överdrag" neutrum  ;
  oeverbud_nn_1_1_N = mkN "överbud" neutrum  ;
  oeverbetyg_nn_1_1_N = mkN "överbetyg" neutrum  ;
  oeverbegrepp_nn_1_1_N = mkN "överbegrepp" neutrum  ;
  oeverbefael_nn_1_1_N = mkN "överbefäl" neutrum  ;
  oeststatsfoertryck_nn_1_1_N = mkN "öststatsförtryck" neutrum  ;
  oesregn_nn_1_1_N = mkN "ösregn" neutrum  ;
  oeskar_nn_1_1_N = mkN "öskar" neutrum  ;
  oerngottsband_nn_1_1_N = mkN "örngottsband" neutrum  ;
  oerngott_nn_1_1_N = mkN "örngott" neutrum  ;
  oerlogsvarv_nn_1_1_N = mkN "örlogsvarv" neutrum  ;
  oerlogsfartyg_nn_1_1_N = mkN "örlogsfartyg" neutrum  ;
  oeppningsbud_nn_1_1_N = mkN "öppningsbud" neutrum  ;
  oenskemaal_nn_1_1_N = mkN "önskemål" neutrum  ;
  oenskebarn_nn_1_1_N = mkN "önskebarn" neutrum  ;
  oelunderlaegg_nn_1_1_N = mkN "ölunderlägg" neutrum  ;
  oeknamn_nn_1_1_N = mkN "öknamn" neutrum  ;
  oekenlandskap_nn_1_1_N = mkN "ökenlandskap" neutrum  ;
  oek_nn_1_1_N = mkN "ök" neutrum  ;
  oegonroerelsemoenster_nn_1_1_N = mkN "ögonrörelsemönster" neutrum  ;
  oegonpar_nn_1_1_N = mkN "ögonpar" neutrum  ;
  oegonlock_nn_1_1_N = mkN "ögonlock" neutrum  ;
  oegonhaar_nn_1_1_N = mkN "ögonhår" neutrum  ;
  oegonbryn_nn_1_1_N = mkN "ögonbryn" neutrum  ;
  oegonblick_nn_1_1_N = mkN "ögonblick" neutrum  ;
  oedesaar_nn_1_1_N = mkN "ödesår" neutrum  ;
  oedesval_nn_1_1_N = mkN "ödesval" neutrum  ;
  aatstramningspaket_nn_1_1_N = mkN "åtstramningspaket" neutrum  ;
  aatstramningsbehov_nn_1_1_N = mkN "åtstramningsbehov" neutrum  ;
  aatgaerdspaket_nn_1_1_N = mkN "åtgärdspaket" neutrum  ;
  aaterval_nn_1_1_N = mkN "återval" neutrum  ;
  aaterupplivningsfoersoek_nn_1_1_N = mkN "återupplivningsförsök" neutrum  ;
  aatertaag_nn_1_1_N = mkN "återtåg" neutrum  ;
  aaterskall_nn_1_1_N = mkN "återskall" neutrum  ;
  aaterrop_nn_1_1_N = mkN "återrop" neutrum  ;
  aaterkoep_nn_1_1_N = mkN "återköp" neutrum  ;
  aaterkrav_nn_1_1_N = mkN "återkrav" neutrum  ;
  aaterfall_nn_1_1_N = mkN "återfall" neutrum  ;
  aaterbud_nn_1_1_N = mkN "återbud" neutrum  ;
  aaterbesoek_nn_1_1_N = mkN "återbesök" neutrum  ;
  aatalsbeslut_nn_1_1_N = mkN "åtalsbeslut" neutrum  ;
  aatal_nn_1_1_N = mkN "åtal" neutrum  ;
  aaskaadningssaett_nn_1_1_N = mkN "åskådningssätt" neutrum  ;
  aaskvaeder_nn_1_1_N = mkN "åskväder" neutrum  ;
  aaskslag_nn_1_1_N = mkN "åskslag" neutrum  ;
  aaskregn_nn_1_1_N = mkN "åskregn" neutrum  ;
  aaskmoln_nn_1_1_N = mkN "åskmoln" neutrum  ;
  aaskdunder_nn_1_1_N = mkN "åskdunder" neutrum  ;
  aartal_nn_1_1_N = mkN "årtal" neutrum  ;
  aartag_nn_1_1_N = mkN "årtag" neutrum  ;
  aarstryck_nn_1_1_N = mkN "årstryck" neutrum  ;
  aarsbarn_nn_1_1_N = mkN "årsbarn" neutrum  ;
  aarblad_nn_1_1_N = mkN "årblad" neutrum  ;
  aar_nn_1_1_N = mkN "år" neutrum  ;
  aangtryck_nn_1_1_N = mkN "ångtryck" neutrum  ;
  aangstrykjaern_nn_1_1_N = mkN "ångstrykjärn" neutrum  ;
  aanglok_nn_1_1_N = mkN "ånglok" neutrum  ;
  aangkoek_nn_1_1_N = mkN "ångkök" neutrum  ;
  aangkraftverk_nn_1_1_N = mkN "ångkraftverk" neutrum  ;
  aangkol_nn_1_1_N = mkN "ångkol" neutrum  ;
  aangfartyg_nn_1_1_N = mkN "ångfartyg" neutrum  ;
  aangestrop_nn_1_1_N = mkN "ångestrop" neutrum  ;
  aangestanfall_nn_1_1_N = mkN "ångestanfall" neutrum  ;
  aalskinn_nn_1_1_N = mkN "ålskinn" neutrum  ;
  aalderstillaegg_nn_1_1_N = mkN "ålderstillägg" neutrum  ;
  aaldersskael_nn_1_1_N = mkN "åldersskäl" neutrum  ;
  aaldersbetyg_nn_1_1_N = mkN "åldersbetyg" neutrum  ;
  aalbestaand_nn_1_1_N = mkN "ålbestånd" neutrum  ;
  aaklagarbeslut_nn_1_1_N = mkN "åklagarbeslut" neutrum  ;
  aakerfaelt_nn_1_1_N = mkN "åkerfält" neutrum  ;
  aakerbaer_nn_1_1_N = mkN "åkerbär" neutrum  ;
  aakerbruk_nn_1_1_N = mkN "åkerbruk" neutrum  ;
  aakdon_nn_1_1_N = mkN "åkdon" neutrum  ;
  aak_nn_1_1_N = mkN "åk" neutrum  ;
  aaderbraack_nn_1_1_N = mkN "åderbråck" neutrum  ;
  aaderbrock_nn_1_1_N = mkN "åderbrock" neutrum  ;
  aeventyrsbad_nn_1_1_N = mkN "äventyrsbad" neutrum  ;
  aeventyr_nn_1_1_N = mkN "äventyr" neutrum  ;
  aettnummer_nn_1_1_N = mkN "ättnummer" neutrum  ;
  aettetal_nn_1_1_N = mkN "ättetal" neutrum  ;
  aetteled_nn_1_1_N = mkN "ätteled" neutrum  ;
  aettartal_nn_1_1_N = mkN "ättartal" neutrum  ;
  aerr_nn_1_1_N = mkN "ärr" neutrum  ;
  aermhaal_nn_1_1_N = mkN "ärmhål" neutrum  ;
  aerkesvin_nn_1_1_N = mkN "ärkesvin" neutrum  ;
  aerkestift_nn_1_1_N = mkN "ärkestift" neutrum  ;
  aerkenoet_nn_1_1_N = mkN "ärkenöt" neutrum  ;
  aerevarv_nn_1_1_N = mkN "ärevarv" neutrum  ;
  aenkeaar_nn_1_1_N = mkN "änkeår" neutrum  ;
  aenkedok_nn_1_1_N = mkN "änkedok" neutrum  ;
  aeng_ljud_nn_1_1_N = mkN "äng-ljud" neutrum  ;
  aendamaal_nn_1_1_N = mkN "ändamål" neutrum  ;
  aemnesnamn_nn_1_1_N = mkN "ämnesnamn" neutrum  ;
  aemnesjaern_nn_1_1_N = mkN "ämnesjärn" neutrum  ;
  aemnesblock_nn_1_1_N = mkN "ämnesblock" neutrum  ;
  aembetsverk_nn_1_1_N = mkN "ämbetsverk" neutrum  ;
  aembetsmannajag_nn_1_1_N = mkN "ämbetsmannajag" neutrum  ;
  aembetsbrott_nn_1_1_N = mkN "ämbetsbrott" neutrum  ;
  aembar_nn_1_1_N = mkN "ämbar" neutrum  ;
  aelskogsgnabb_nn_1_1_N = mkN "älskogsgnabb" neutrum  ;
  aelsklingsprojekt_nn_1_1_N = mkN "älsklingsprojekt" neutrum  ;
  aelgkliv_nn_1_1_N = mkN "älgkliv" neutrum  ;
  aelgbesoek_nn_1_1_N = mkN "älgbesök" neutrum  ;
  aektenskapshinder_nn_1_1_N = mkN "äktenskapshinder" neutrum  ;
  aektenskapsfoerord_nn_1_1_N = mkN "äktenskapsförord" neutrum  ;
  aektenskapscertifikat_nn_1_1_N = mkN "äktenskapscertifikat" neutrum  ;
  aektenskapsbrott_nn_1_1_N = mkN "äktenskapsbrott" neutrum  ;
  aektenskapsbetyg_nn_1_1_N = mkN "äktenskapsbetyg" neutrum  ;
  aektenskap_nn_1_1_N = mkN "äktenskap" neutrum  ;
  aektamakekuvert_nn_1_1_N = mkN "äktamakekuvert" neutrum  ;
  aeggskal_nn_1_1_N = mkN "äggskal" neutrum  ;
  aegglaeggningsroer_nn_1_1_N = mkN "äggläggningsrör" neutrum  ;
  aeggkorn_nn_1_1_N = mkN "äggkorn" neutrum  ;
  aegg_nn_1_1_N = mkN "ägg" neutrum  ;
  aegarkrav_nn_1_1_N = mkN "ägarkrav" neutrum  ;
  aegandebehov_nn_1_1_N = mkN "ägandebehov" neutrum  ;
  aedelpekoral_nn_1_1_N = mkN "ädelpekoral" neutrum  ;
  zonroer_nn_1_1_N = mkN "zonrör" neutrum  ;
  zigenarspraak_nn_1_1_N = mkN "zigenarspråk" neutrum  ;
  zigenarliv_nn_1_N = mkN "zigenarliv" neutrum  ;
  zigenarkapell_nn_1_N = mkN "zigenarkapell" neutrum  ;
  yxskaft_nn_1_N = mkN "yxskaft" neutrum  ;
  yxmord_nn_1_N = mkN "yxmord" neutrum  ;
  yxhugg_nn_1_N = mkN "yxhugg" neutrum  ;
  yxblad_nn_1_N = mkN "yxblad" neutrum  ;
  ytvattenskikt_nn_1_N = mkN "ytvattenskikt" neutrum  ;
  yttryck_nn_1_N = mkN "yttryck" neutrum  ;
  yttertak_nn_1_N = mkN "yttertak" neutrum  ;
  ytterskaer_nn_1_1_N = mkN "ytterskär" neutrum  ;
  ytterplagg_nn_1_N = mkN "ytterplagg" neutrum  ;
  ytterfoder_nn_1_N = mkN "ytterfoder" neutrum  ;
  ytterfack_nn_1_N = mkN "ytterfack" neutrum  ;
  ytterdoerrhandtag_nn_1_1_N = mkN "ytterdörrhandtag" neutrum  ;
  ytskikt_nn_1_N = mkN "ytskikt" neutrum  ;
  ytmaatt_nn_1_1_N = mkN "ytmått" neutrum  ;
  ytlager_nn_1_N = mkN "ytlager" neutrum  ;
  yrvaeder_nn_1_1_N = mkN "yrväder" neutrum  ;
  yrkesval_nn_1_N = mkN "yrkesval" neutrum  ;
  yrkesregister_nn_1_N = mkN "yrkesregister" neutrum  ;
  yrkesliv_nn_1_N = mkN "yrkesliv" neutrum  ;
  yrkesfoerbud_nn_1_1_N = mkN "yrkesförbud" neutrum  ;
  yogainstitut_nn_1_N = mkN "yogainstitut" neutrum  ;
  ynnestprov_nn_1_N = mkN "ynnestprov" neutrum  ;
  yngeltraag_nn_1_1_N = mkN "yngeltråg" neutrum  ;
  ymptvaang_nn_1_1_N = mkN "ymptvång" neutrum  ;
  ympsaar_nn_1_1_N = mkN "ympsår" neutrum  ;
  ympsnitt_nn_1_N = mkN "ympsnitt" neutrum  ;
  ymnighetshorn_nn_1_N = mkN "ymnighetshorn" neutrum  ;
  wienerbroed_nn_1_1_N = mkN "wienerbröd" neutrum  ;
  voertbroed_nn_1_1_N = mkN "vörtbröd" neutrum  ;
  vaatelement_nn_1_1_N = mkN "våtelement" neutrum  ;
  vaarvaeder_nn_1_1_N = mkN "vårväder" neutrum  ;
  vaartsvin_nn_1_1_N = mkN "vårtsvin" neutrum  ;
  vaartmedel_nn_1_1_N = mkN "vårtmedel" neutrum  ;
  vaarmoln_nn_1_1_N = mkN "vårmoln" neutrum  ;
  vaardval_nn_1_1_N = mkN "vårdval" neutrum  ;
  vaardpaket_nn_1_1_N = mkN "vårdpaket" neutrum  ;
  vaardnadsbidrag_nn_1_1_N = mkN "vårdnadsbidrag" neutrum  ;
  vaardintyg_nn_1_1_N = mkN "vårdintyg" neutrum  ;
  vaardfall_nn_1_1_N = mkN "vårdfall" neutrum  ;
  vaardbidrag_nn_1_1_N = mkN "vårdbidrag" neutrum  ;
  vaardbehov_nn_1_1_N = mkN "vårdbehov" neutrum  ;
  vaap_nn_1_1_N = mkN "våp" neutrum  ;
  vaaningsplan_nn_1_1_N = mkN "våningsplan" neutrum  ;
  vaaldtaektsfoersoek_nn_1_1_N = mkN "våldtäktsförsök" neutrum  ;
  vaaldsdaad_nn_1_1_N = mkN "våldsdåd" neutrum  ;
  vaaldsbrott_nn_1_1_N = mkN "våldsbrott" neutrum  ;
  vaagsvall_nn_1_1_N = mkN "vågsvall" neutrum  ;
  vaagplan_nn_1_1_N = mkN "vågplan" neutrum  ;
  vaaghaal_nn_1_1_N = mkN "våghål" neutrum  ;
  vaaffeljaern_nn_1_1_N = mkN "våffeljärn" neutrum  ;
  vaadaskott_nn_1_1_N = mkN "vådaskott" neutrum  ;
  vaextskyddsmedel_nn_1_1_N = mkN "växtskyddsmedel" neutrum  ;
  vaextskott_nn_1_1_N = mkN "växtskott" neutrum  ;
  vaextplankton_nn_1_1_N = mkN "växtplankton" neutrum  ;
  vaexthustak_nn_1_1_N = mkN "växthustak" neutrum  ;
  vaexlingslok_nn_1_1_N = mkN "växlingslok" neutrum  ;
  vaexelstaellverk_nn_1_1_N = mkN "växelställverk" neutrum  ;
  vaexelstaell_nn_1_1_N = mkN "växelställ" neutrum  ;
  vaexelspaar_nn_1_1_N = mkN "växelspår" neutrum  ;
  vaexelmynt_nn_1_1_N = mkN "växelmynt" neutrum  ;
  vaexellok_nn_1_1_N = mkN "växellok" neutrum  ;
  vaexelkontor_nn_1_1_N = mkN "växelkontor" neutrum  ;
  vaexelbord_nn_1_1_N = mkN "växelbord" neutrum  ;
  vaevskael_nn_1_1_N = mkN "vävskäl" neutrum  ;
  vaevskaft_nn_1_1_N = mkN "vävskaft" neutrum  ;
  vaevningsmoenster_nn_1_1_N = mkN "vävningsmönster" neutrum  ;
  vaetmedel_nn_1_1_N = mkN "vätmedel" neutrum  ;
  vaesljud_nn_1_1_N = mkN "väsljud" neutrum  ;
  vaesen_nn_2_1_N = mkN "väsen" neutrum  ;
  vaerv_nn_1_1_N = mkN "värv" neutrum  ;
  vaern_nn_1_1_N = mkN "värn" neutrum  ;
  vaermeaaskvaeder_nn_1_1_N = mkN "värmeåskväder" neutrum  ;
  vaermeverk_nn_1_1_N = mkN "värmeverk" neutrum  ;
  vaermetillaegg_nn_1_1_N = mkN "värmetillägg" neutrum  ;
  vaermeskaap_nn_1_1_N = mkN "värmeskåp" neutrum  ;
  vaermemaatt_nn_1_1_N = mkN "värmemått" neutrum  ;
  vaermekraftverk_nn_1_1_N = mkN "värmekraftverk" neutrum  ;
  vaermegenomgaangstal_nn_1_1_N = mkN "värmegenomgångstal" neutrum  ;
  vaermeelement_nn_1_1_N = mkN "värmeelement" neutrum  ;
  vaermebehov_nn_1_1_N = mkN "värmebehov" neutrum  ;
  vaerldsspraak_nn_1_1_N = mkN "världsspråk" neutrum  ;
  vaerldsscoop_nn_1_1_N = mkN "världsscoop" neutrum  ;
  vaerldssamfund_nn_1_1_N = mkN "världssamfund" neutrum  ;
  vaerldsrekord_nn_1_1_N = mkN "världsrekord" neutrum  ;
  vaerldsnamn_nn_1_1_N = mkN "världsnamn" neutrum  ;
  vaerldsmaesterskap_nn_1_1_N = mkN "världsmästerskap" neutrum  ;
  vaerldskrig_nn_1_1_N = mkN "världskrig" neutrum  ;
  vaerldskedjebrev_nn_1_1_N = mkN "världskedjebrev" neutrum  ;
  vaerldshav_nn_1_1_N = mkN "världshav" neutrum  ;
  vaerldsgenomsnitt_nn_1_1_N = mkN "världsgenomsnitt" neutrum  ;
  vaerldsarv_nn_1_1_N = mkN "världsarv" neutrum  ;
  vaerdpar_nn_1_1_N = mkN "värdpar" neutrum  ;
  vaerdfolk_nn_1_1_N = mkN "värdfolk" neutrum  ;
  vaerdetransportfoeretag_nn_1_1_N = mkN "värdetransportföretag" neutrum  ;
  vaerderaan_nn_1_1_N = mkN "värderån" neutrum  ;
  vaerderingsinstrument_nn_1_1_N = mkN "värderingsinstrument" neutrum  ;
  vaerdepapper_nn_1_1_N = mkN "värdepapper" neutrum  ;
  vaerdeord_nn_1_1_N = mkN "värdeord" neutrum  ;
  vaerdefoeremaal_nn_1_1_N = mkN "värdeföremål" neutrum  ;
  vaerdefall_nn_1_1_N = mkN "värdefall" neutrum  ;
  vaerdebrev_nn_1_1_N = mkN "värdebrev" neutrum  ;
  vaerddjur_nn_1_1_N = mkN "värddjur" neutrum  ;
  vaensterknaeck_nn_1_1_N = mkN "vänsterknäck" neutrum  ;
  vaensterben_nn_1_1_N = mkN "vänsterben" neutrum  ;
  vaenskapsband_nn_1_1_N = mkN "vänskapsband" neutrum  ;
  vaelljaern_nn_1_1_N = mkN "välljärn" neutrum  ;
  vaelkomsttal_nn_1_1_N = mkN "välkomsttal" neutrum  ;
  vaeljarstoed_nn_1_1_N = mkN "väljarstöd" neutrum  ;
  vaegval_nn_1_1_N = mkN "vägval" neutrum  ;
  vaegskael_nn_1_1_N = mkN "vägskäl" neutrum  ;
  vaegnaet_nn_1_1_N = mkN "vägnät" neutrum  ;
  vaeglag_nn_1_1_N = mkN "väglag" neutrum  ;
  vaegguttag_nn_1_1_N = mkN "vägguttag" neutrum  ;
  vaeggur_nn_1_1_N = mkN "väggur" neutrum  ;
  vaeggfaelt_nn_1_1_N = mkN "väggfält" neutrum  ;
  vaeggband_nn_1_1_N = mkN "väggband" neutrum  ;
  vaedertillstaand_nn_1_1_N = mkN "vädertillstånd" neutrum  ;
  vaederstreck_nn_1_1_N = mkN "väderstreck" neutrum  ;
  vaederskepp_nn_1_1_N = mkN "väderskepp" neutrum  ;
  vaederomslag_nn_1_1_N = mkN "väderomslag" neutrum  ;
  vykort_nn_1_N = mkN "vykort" neutrum  ;
  vuxenliv_nn_1_N = mkN "vuxenliv" neutrum  ;
  vulkanutbrott_nn_1_N = mkN "vulkanutbrott" neutrum  ;
  vraalaak_nn_1_1_N = mkN "vrålåk" neutrum  ;
  vraal_nn_1_1_N = mkN "vrål" neutrum  ;
  vristben_nn_1_N = mkN "vristben" neutrum  ;
  vridspoleinstrument_nn_1_N = mkN "vridspoleinstrument" neutrum  ;
  vridmoment_nn_1_N = mkN "vridmoment" neutrum  ;
  vridjaernsinstrument_nn_1_1_N = mkN "vridjärnsinstrument" neutrum  ;
  vredesutbrott_nn_1_N = mkN "vredesutbrott" neutrum  ;
  vred_nn_1_N = mkN "vred" neutrum  ;
  vrak_nn_1_N = mkN "vrak" neutrum  ;
  votivskepp_nn_1_N = mkN "votivskepp" neutrum  ;
  volttal_nn_1_N = mkN "volttal" neutrum  ;
  viv_nn_1_N = mkN "viv" neutrum  ;
  vittnesskrank_nn_1_N = mkN "vittnesskrank" neutrum  ;
  vittnesmaal_nn_1_1_N = mkN "vittnesmål" neutrum  ;
  vittnesfoerhoer_nn_1_1_N = mkN "vittnesförhör" neutrum  ;
  vittnesboerd_nn_1_1_N = mkN "vittnesbörd" neutrum  ;
  vitsord_nn_1_N = mkN "vitsord" neutrum  ;
  vitrinskaap_nn_1_1_N = mkN "vitrinskåp" neutrum  ;
  vitesfoerbud_nn_1_1_N = mkN "vitesförbud" neutrum  ;
  vitaminpiller_nn_1_N = mkN "vitaminpiller" neutrum  ;
  vitalbehov_nn_1_N = mkN "vitalbehov" neutrum  ;
  visumbrott_nn_1_N = mkN "visumbrott" neutrum  ;
  visitkort_nn_1_N = mkN "visitkort" neutrum  ;
  visir_nn_1_N = mkN "visir" neutrum  ;
  viseringskort_nn_1_N = mkN "viseringskort" neutrum  ;
  visefall_nn_1_N = mkN "visefall" neutrum  ;
  visdomsord_nn_1_N = mkN "visdomsord" neutrum  ;
  visakort_nn_1_N = mkN "visakort" neutrum  ;
  virtuosnummer_nn_1_N = mkN "virtuosnummer" neutrum  ;
  vinaar_nn_1_1_N = mkN "vinår" neutrum  ;
  vintervaeglag_nn_1_1_N = mkN "vinterväglag" neutrum  ;
  vintervaeder_nn_1_1_N = mkN "vinterväder" neutrum  ;
  vinterstaand_nn_1_1_N = mkN "vinterstånd" neutrum  ;
  vinterskinn_nn_1_N = mkN "vinterskinn" neutrum  ;
  vinterpaeron_nn_1_1_N = mkN "vinterpäron" neutrum  ;
  vintermoerker_nn_1_1_N = mkN "vintermörker" neutrum  ;
  vinterlov_nn_1_N = mkN "vinterlov" neutrum  ;
  vinterlandskap_nn_1_N = mkN "vinterlandskap" neutrum  ;
  vinterhalvaar_nn_1_1_N = mkN "vinterhalvår" neutrum  ;
  vinterfoerraad_nn_1_1_N = mkN "vinterförråd" neutrum  ;
  vinterfoder_nn_1_N = mkN "vinterfoder" neutrum  ;
  vinterdaeck_nn_1_1_N = mkN "vinterdäck" neutrum  ;
  vinterbad_nn_1_N = mkN "vinterbad" neutrum  ;
  vinstnummer_nn_1_N = mkN "vinstnummer" neutrum  ;
  vinnarhaal_nn_1_1_N = mkN "vinnarhål" neutrum  ;
  vinloev_nn_1_1_N = mkN "vinlöv" neutrum  ;
  vinkelmaatt_nn_1_1_N = mkN "vinkelmått" neutrum  ;
  vinkeljaern_nn_1_1_N = mkN "vinkeljärn" neutrum  ;
  vinkelbeslag_nn_1_N = mkN "vinkelbeslag" neutrum  ;
  vinkelben_nn_1_N = mkN "vinkelben" neutrum  ;
  vinkelavstaand_nn_1_1_N = mkN "vinkelavstånd" neutrum  ;
  vingteckningvaevningsmoenster_nn_1_1_N = mkN "vingteckningvävningsmönster" neutrum  ;
  vingslag_nn_1_N = mkN "vingslag" neutrum  ;
  vindaegg_nn_1_1_N = mkN "vindägg" neutrum  ;
  vindstraak_nn_1_1_N = mkN "vindstråk" neutrum  ;
  vindskydd_nn_1_N = mkN "vindskydd" neutrum  ;
  vindskontor_nn_1_N = mkN "vindskontor" neutrum  ;
  vindruteskydd_nn_1_N = mkN "vindruteskydd" neutrum  ;
  vindmaetningsinstrument_nn_1_1_N = mkN "vindmätningsinstrument" neutrum  ;
  vindkraftverk_nn_1_N = mkN "vindkraftverk" neutrum  ;
  vindkraftsbolag_nn_1_N = mkN "vindkraftsbolag" neutrum  ;
  vindfaang_nn_1_1_N = mkN "vindfång" neutrum  ;
  vinddrag_nn_1_N = mkN "vinddrag" neutrum  ;
  vinbaer_nn_1_1_N = mkN "vinbär" neutrum  ;
  vinblad_nn_1_N = mkN "vinblad" neutrum  ;
  vinberg_nn_1_N = mkN "vinberg" neutrum  ;
  viltstraak_nn_1_1_N = mkN "viltstråk" neutrum  ;
  viltdjur_nn_1_N = mkN "viltdjur" neutrum  ;
  vilolaeger_nn_1_1_N = mkN "viloläger" neutrum  ;
  villospaar_nn_1_1_N = mkN "villospår" neutrum  ;
  villkor_nn_1_N = mkN "villkor" neutrum  ;
  villebraad_nn_1_1_N = mkN "villebråd" neutrum  ;
  villaservitut_nn_1_N = mkN "villaservitut" neutrum  ;
  vildsvin_nn_1_N = mkN "vildsvin" neutrum  ;
  vildskott_nn_1_N = mkN "vildskott" neutrum  ;
  vilddjur_nn_1_N = mkN "vilddjur" neutrum  ;
  viktslag_nn_1_N = mkN "viktslag" neutrum  ;
  vikon_nn_1_N = mkN "vikon" neutrum  ;
  vikingataag_nn_1_1_N = mkN "vikingatåg" neutrum  ;
  vikingaskepp_nn_1_N = mkN "vikingaskepp" neutrum  ;
  vikariestopp_nn_1_N = mkN "vikariestopp" neutrum  ;
  vikariat_nn_1_N = mkN "vikariat" neutrum  ;
  vigselformulaer_nn_1_1_N = mkN "vigselformulär" neutrum  ;
  vidertryck_nn_1_N = mkN "vidertryck" neutrum  ;
  videoklipp_nn_1_N = mkN "videoklipp" neutrum  ;
  videoband_nn_1_N = mkN "videoband" neutrum  ;
  vick_nn_1_N = mkN "vick" neutrum  ;
  vetekorn_nn_1_N = mkN "vetekorn" neutrum  ;
  vetebroed_nn_1_1_N = mkN "vetebröd" neutrum  ;
  vertikalplan_nn_1_N = mkN "vertikalplan" neutrum  ;
  versmaatt_nn_1_1_N = mkN "versmått" neutrum  ;
  verop_nn_1_N = mkN "verop" neutrum  ;
  verktyg_nn_1_N = mkN "verktyg" neutrum  ;
  verksamhetsaar_nn_1_1_N = mkN "verksamhetsår" neutrum  ;
  verksamhetsfaelt_nn_1_1_N = mkN "verksamhetsfält" neutrum  ;
  verksamhetsbehov_nn_1_N = mkN "verksamhetsbehov" neutrum  ;
  verkjaern_nn_1_1_N = mkN "verkjärn" neutrum  ;
  verkbord_nn_1_N = mkN "verkbord" neutrum  ;
  verk_nn_1_N = mkN "verk" neutrum  ;
  verifikat_nn_1_N = mkN "verifikat" neutrum  ;
  verb_nn_1_N = mkN "verb" neutrum  ;
  venusberg_nn_1_N = mkN "venusberg" neutrum  ;
  ventileringshaal_nn_1_1_N = mkN "ventileringshål" neutrum  ;
  vedfaang_nn_1_1_N = mkN "vedfång" neutrum  ;
  vedernamn_nn_1_N = mkN "vedernamn" neutrum  ;
  vederlag_nn_1_N = mkN "vederlag" neutrum  ;
  veckoslut_nn_1_N = mkN "veckoslut" neutrum  ;
  veckomagasin_nn_1_N = mkN "veckomagasin" neutrum  ;
  veckberg_nn_1_N = mkN "veckberg" neutrum  ;
  veck_nn_1_N = mkN "veck" neutrum  ;
  vaxsigill_nn_1_N = mkN "vaxsigill" neutrum  ;
  vaxkabinett_nn_1_N = mkN "vaxkabinett" neutrum  ;
  vaxavtryck_nn_1_N = mkN "vaxavtryck" neutrum  ;
  vattenvaesen_nn_1_1_N = mkN "vattenväsen" neutrum  ;
  vattenverk_nn_1_N = mkN "vattenverk" neutrum  ;
  vattenur_nn_1_N = mkN "vattenur" neutrum  ;
  vattentorn_nn_1_N = mkN "vattentorn" neutrum  ;
  vattensvin_nn_1_N = mkN "vattensvin" neutrum  ;
  vattenstaandsroer_nn_1_1_N = mkN "vattenståndsrör" neutrum  ;
  vattenstaand_nn_1_1_N = mkN "vattenstånd" neutrum  ;
  vattenstaenk_nn_1_1_N = mkN "vattenstänk" neutrum  ;
  vattenskott_nn_1_N = mkN "vattenskott" neutrum  ;
  vattenreningsverk_nn_1_N = mkN "vattenreningsverk" neutrum  ;
  vattenkraftverk_nn_1_N = mkN "vattenkraftverk" neutrum  ;
  vattenhaal_nn_1_1_N = mkN "vattenhål" neutrum  ;
  vattenhjul_nn_1_N = mkN "vattenhjul" neutrum  ;
  vattenfall_nn_1_N = mkN "vattenfall" neutrum  ;
  vattendrag_nn_1_N = mkN "vattendrag" neutrum  ;
  vattendjur_nn_1_N = mkN "vattendjur" neutrum  ;
  vattendjup_nn_1_N = mkN "vattendjup" neutrum  ;
  vattenbruk_nn_1_N = mkN "vattenbruk" neutrum  ;
  vattenbad_nn_1_N = mkN "vattenbad" neutrum  ;
  vaterbord_nn_1_N = mkN "vaterbord" neutrum  ;
  vassroer_nn_1_1_N = mkN "vassrör" neutrum  ;
  varvtal_nn_1_N = mkN "varvtal" neutrum  ;
  varv_nn_2_N = mkN "varv" neutrum  ;
  varv_nn_1_N = mkN "varv" neutrum  ;
  varulaan_nn_1_1_N = mkN "varulån" neutrum  ;
  varuintag_nn_1_N = mkN "varuintag" neutrum  ;
  varubud_nn_1_N = mkN "varubud" neutrum  ;
  varseblivningsfenomen_nn_1_N = mkN "varseblivningsfenomen" neutrum  ;
  varp_nn_2_N = mkN "varp" neutrum  ;
  varningsskott_nn_1_N = mkN "varningsskott" neutrum  ;
  varningsrop_nn_1_N = mkN "varningsrop" neutrum  ;
  varmblod_nn_1_N = mkN "varmblod" neutrum  ;
  varmbad_nn_1_N = mkN "varmbad" neutrum  ;
  variationsinstrument_nn_1_N = mkN "variationsinstrument" neutrum  ;
  vardagsspraak_nn_1_1_N = mkN "vardagsspråk" neutrum  ;
  vardagsliv_nn_1_N = mkN "vardagsliv" neutrum  ;
  vapenstillestaand_nn_1_1_N = mkN "vapenstillestånd" neutrum  ;
  vapenslag_nn_1_N = mkN "vapenslag" neutrum  ;
  vapenlager_nn_1_N = mkN "vapenlager" neutrum  ;
  vapenhot_nn_1_N = mkN "vapenhot" neutrum  ;
  vapenfynd_nn_1_N = mkN "vapenfynd" neutrum  ;
  vansinnesdaad_nn_1_1_N = mkN "vansinnesdåd" neutrum  ;
  vanedjur_nn_1_N = mkN "vanedjur" neutrum  ;
  vandringsaar_nn_1_1_N = mkN "vandringsår" neutrum  ;
  vandringsvaagroer_nn_1_1_N = mkN "vandringsvågrör" neutrum  ;
  vandringsfolk_nn_1_N = mkN "vandringsfolk" neutrum  ;
  vandrarfolk_nn_1_N = mkN "vandrarfolk" neutrum  ;
  vanadinskaft_nn_1_N = mkN "vanadinskaft" neutrum  ;
  valv_nn_1_N = mkN "valv" neutrum  ;
  valutasvin_nn_1_N = mkN "valutasvin" neutrum  ;
  valutabrott_nn_1_N = mkN "valutabrott" neutrum  ;
  valthorn_nn_1_N = mkN "valthorn" neutrum  ;
  valsaett_nn_1_1_N = mkN "valsätt" neutrum  ;
  valsverk_nn_1_N = mkN "valsverk" neutrum  ;
  valspraak_nn_1_1_N = mkN "valspråk" neutrum  ;
  valresultat_nn_1_N = mkN "valresultat" neutrum  ;
  valnederlag_nn_1_N = mkN "valnederlag" neutrum  ;
  valmtak_nn_1_N = mkN "valmtak" neutrum  ;
  vallhorn_nn_1_N = mkN "vallhorn" neutrum  ;
  valkuvert_nn_1_N = mkN "valkuvert" neutrum  ;
  valklagomaal_nn_1_1_N = mkN "valklagomål" neutrum  ;
  valium_nn_1_N = mkN "valium" neutrum  ;
  valenstal_nn_1_N = mkN "valenstal" neutrum  ;
  valdistrikt_nn_1_N = mkN "valdistrikt" neutrum  ;
  valbestaand_nn_1_1_N = mkN "valbestånd" neutrum  ;
  val_nn_1_N = mkN "val" neutrum  ;
  vakttorn_nn_1_N = mkN "vakttorn" neutrum  ;
  vaksin_nn_1_N = mkN "vaksin" neutrum  ;
  vagnsaett_nn_1_1_N = mkN "vagnsätt" neutrum  ;
  vaggtryck_nn_1_N = mkN "vaggtryck" neutrum  ;
  vadben_nn_1_N = mkN "vadben" neutrum  ;
  vad_nn_1_N = mkN "vad" neutrum  ;
  utviksblad_nn_1_N = mkN "utviksblad" neutrum  ;
  utvik_nn_1_N = mkN "utvik" neutrum  ;
  utvecklingsstoed_nn_1_1_N = mkN "utvecklingsstöd" neutrum  ;
  utvecklingsspraang_nn_1_1_N = mkN "utvecklingssprång" neutrum  ;
  utvecklingsplan_nn_1_N = mkN "utvecklingsplan" neutrum  ;
  uttaag_nn_1_1_N = mkN "uttåg" neutrum  ;
  uttryckssaett_nn_1_1_N = mkN "uttryckssätt" neutrum  ;
  uttrycksmedel_nn_1_N = mkN "uttrycksmedel" neutrum  ;
  uttryck_nn_1_N = mkN "uttryck" neutrum  ;
  uttal_nn_1_N = mkN "uttal" neutrum  ;
  uttag_nn_1_N = mkN "uttag" neutrum  ;
  utsoendringsorgan_nn_1_1_N = mkN "utsöndringsorgan" neutrum  ;
  utspraang_nn_1_1_N = mkN "utsprång" neutrum  ;
  utsnitt_nn_1_N = mkN "utsnitt" neutrum  ;
  utslaepp_nn_1_1_N = mkN "utsläpp" neutrum  ;
  utslag_nn_1_N = mkN "utslag" neutrum  ;
  utskaenkningstillstaand_nn_1_1_N = mkN "utskänkningstillstånd" neutrum  ;
  utskov_nn_1_N = mkN "utskov" neutrum  ;
  utskott_nn_1_N = mkN "utskott" neutrum  ;
  utskick_nn_1_N = mkN "utskick" neutrum  ;
  utsiktstorn_nn_1_N = mkN "utsiktstorn" neutrum  ;
  utrymmesskael_nn_1_1_N = mkN "utrymmesskäl" neutrum  ;
  utrotningslaeger_nn_1_1_N = mkN "utrotningsläger" neutrum  ;
  utropsord_nn_1_N = mkN "utropsord" neutrum  ;
  utrop_nn_1_N = mkN "utrop" neutrum  ;
  utrikesflyg_nn_1_N = mkN "utrikesflyg" neutrum  ;
  utrikesdepartement_nn_1_N = mkN "utrikesdepartement" neutrum  ;
  utresetillstaand_nn_1_1_N = mkN "utresetillstånd" neutrum  ;
  utresefoerbud_nn_1_1_N = mkN "utreseförbud" neutrum  ;
  utpressningsmedel_nn_1_N = mkN "utpressningsmedel" neutrum  ;
  utomkvedshavandeskap_nn_1_N = mkN "utomkvedshavandeskap" neutrum  ;
  utomhusbad_nn_1_N = mkN "utomhusbad" neutrum  ;
  utmaal_nn_1_1_N = mkN "utmål" neutrum  ;
  utmattningssyndrom_nn_1_N = mkN "utmattningssyndrom" neutrum  ;
  utmattningsbrott_nn_1_N = mkN "utmattningsbrott" neutrum  ;
  utlaegg_nn_1_1_N = mkN "utlägg" neutrum  ;
  utlopp_nn_1_N = mkN "utlopp" neutrum  ;
  utljud_nn_1_N = mkN "utljud" neutrum  ;
  utlandsuppdrag_nn_1_N = mkN "utlandsuppdrag" neutrum  ;
  utlandssamtal_nn_1_N = mkN "utlandssamtal" neutrum  ;
  utklipp_nn_1_N = mkN "utklipp" neutrum  ;
  utkikstorn_nn_1_N = mkN "utkikstorn" neutrum  ;
  utjaemningsmandat_nn_1_1_N = mkN "utjämningsmandat" neutrum  ;
  uthopp_nn_1_N = mkN "uthopp" neutrum  ;
  utgaangsmaterial_nn_1_1_N = mkN "utgångsmaterial" neutrum  ;
  utgaangsdatum_nn_1_1_N = mkN "utgångsdatum" neutrum  ;
  utgraevningsresultat_nn_1_1_N = mkN "utgrävningsresultat" neutrum  ;
  utflyttningslaen_nn_1_1_N = mkN "utflyttningslän" neutrum  ;
  utfall_nn_1_N = mkN "utfall" neutrum  ;
  utelag_nn_1_N = mkN "utelag" neutrum  ;
  utegaangsfoerbud_nn_1_1_N = mkN "utegångsförbud" neutrum  ;
  utegaangsfaar_nn_1_1_N = mkN "utegångsfår" neutrum  ;
  utefaar_nn_1_1_N = mkN "utefår" neutrum  ;
  utdunstningskaerl_nn_1_1_N = mkN "utdunstningskärl" neutrum  ;
  utdrag_nn_1_N = mkN "utdrag" neutrum  ;
  utbud_nn_1_N = mkN "utbud" neutrum  ;
  utbrott_nn_1_N = mkN "utbrott" neutrum  ;
  utbildningsgap_nn_1_N = mkN "utbildningsgap" neutrum  ;
  utbildningsdepartement_nn_1_N = mkN "utbildningsdepartement" neutrum  ;
  utbildningsbidrag_nn_1_N = mkN "utbildningsbidrag" neutrum  ;
  utbetalningskort_nn_1_N = mkN "utbetalningskort" neutrum  ;
  utanverk_nn_1_N = mkN "utanverk" neutrum  ;
  utanfoerskap_nn_1_1_N = mkN "utanförskap" neutrum  ;
  utandningsprov_nn_1_N = mkN "utandningsprov" neutrum  ;
  urverk_nn_1_N = mkN "urverk" neutrum  ;
  urvalsinstrument_nn_1_N = mkN "urvalsinstrument" neutrum  ;
  urval_nn_1_N = mkN "urval" neutrum  ;
  urtillstaand_nn_1_1_N = mkN "urtillstånd" neutrum  ;
  urtag_nn_1_N = mkN "urtag" neutrum  ;
  urspraak_nn_1_1_N = mkN "urspråk" neutrum  ;
  ursprungscertifikat_nn_1_N = mkN "ursprungscertifikat" neutrum  ;
  ursprung_nn_1_N = mkN "ursprung" neutrum  ;
  urogenitalorgan_nn_1_N = mkN "urogenitalorgan" neutrum  ;
  urladdningsroer_nn_1_1_N = mkN "urladdningsrör" neutrum  ;
  urklipp_nn_1_N = mkN "urklipp" neutrum  ;
  urinroer_nn_1_1_N = mkN "urinrör" neutrum  ;
  urinorgan_nn_1_N = mkN "urinorgan" neutrum  ;
  uriebrev_nn_1_N = mkN "uriebrev" neutrum  ;
  urfolk_nn_1_N = mkN "urfolk" neutrum  ;
  urdjur_nn_1_N = mkN "urdjur" neutrum  ;
  ur_nn_1_N = mkN "ur" neutrum  ;
  uppvaermningsband_nn_1_1_N = mkN "uppvärmningsband" neutrum  ;
  uppvakningsoegonblick_nn_1_1_N = mkN "uppvakningsögonblick" neutrum  ;
  upptaag_nn_1_1_N = mkN "upptåg" neutrum  ;
  upptryck_nn_1_N = mkN "upptryck" neutrum  ;
  uppsaatsbrott_nn_1_1_N = mkN "uppsåtsbrott" neutrum  ;
  uppsaat_nn_1_1_N = mkN "uppsåt" neutrum  ;
  uppsaettningsmaal_nn_1_1_N = mkN "uppsättningsmål" neutrum  ;
  uppsaettningsinstrument_nn_1_1_N = mkN "uppsättningsinstrument" neutrum  ;
  uppsaegningslaan_nn_1_1_N = mkN "uppsägningslån" neutrum  ;
  uppsving_nn_1_N = mkN "uppsving" neutrum  ;
  uppstaellningsspaar_nn_1_1_N = mkN "uppställningsspår" neutrum  ;
  uppstraak_nn_1_1_N = mkN "uppstråk" neutrum  ;
  uppstickarbolag_nn_1_N = mkN "uppstickarbolag" neutrum  ;
  uppspraang_nn_1_1_N = mkN "uppsprång" neutrum  ;
  uppslagsverk_nn_1_N = mkN "uppslagsverk" neutrum  ;
  uppslagsord_nn_1_N = mkN "uppslagsord" neutrum  ;
  uppslag_nn_1_N = mkN "uppslag" neutrum  ;
  uppskov_nn_1_N = mkN "uppskov" neutrum  ;
  uppskjut_nn_1_N = mkN "uppskjut" neutrum  ;
  uppsatslag_nn_1_N = mkN "uppsatslag" neutrum  ;
  uppsamlingslaeger_nn_1_1_N = mkN "uppsamlingsläger" neutrum  ;
  upprymningsstaal_nn_1_1_N = mkN "upprymningsstål" neutrum  ;
  upprorsfoersoek_nn_1_1_N = mkN "upprorsförsök" neutrum  ;
  uppror_nn_1_N = mkN "uppror" neutrum  ;
  upprop_nn_1_N = mkN "upprop" neutrum  ;
  upprepningsmoenster_nn_1_1_N = mkN "upprepningsmönster" neutrum  ;
  uppmaerksamhetsspann_nn_1_1_N = mkN "uppmärksamhetsspann" neutrum  ;
  uppmaerksamhetsfaelt_nn_1_1_N = mkN "uppmärksamhetsfält" neutrum  ;
  upploesningsmedel_nn_1_1_N = mkN "upplösningsmedel" neutrum  ;
  upplaegg_nn_1_1_N = mkN "upplägg" neutrum  ;
  upplopp_nn_1_N = mkN "upplopp" neutrum  ;
  upplivningsfoersoek_nn_1_1_N = mkN "upplivningsförsök" neutrum  ;
  uppland_nn_1_N = mkN "uppland" neutrum  ;
  upplag_nn_1_N = mkN "upplag" neutrum  ;
  uppkoep_nn_1_1_N = mkN "uppköp" neutrum  ;
  uppkok_nn_1_N = mkN "uppkok" neutrum  ;
  upphovsraettsbrott_nn_1_1_N = mkN "upphovsrättsbrott" neutrum  ;
  upphopp_nn_1_N = mkN "upphopp" neutrum  ;
  uppflaag_nn_1_1_N = mkN "uppflåg" neutrum  ;
  uppflog_nn_1_N = mkN "uppflog" neutrum  ;
  uppehaallsvaeder_nn_1_1_N = mkN "uppehållsväder" neutrum  ;
  uppehaallstillstaand_nn_1_1_N = mkN "uppehållstillstånd" neutrum  ;
  uppehaall_nn_1_1_N = mkN "uppehåll" neutrum  ;
  uppdrag_nn_1_N = mkN "uppdrag" neutrum  ;
  uppboerdsaar_nn_1_1_N = mkN "uppbördsår" neutrum  ;
  uppbaad_nn_1_1_N = mkN "uppbåd" neutrum  ;
  uppbygglighetsanspraak_nn_1_1_N = mkN "uppbygglighetsanspråk" neutrum  ;
  uppbud_nn_1_N = mkN "uppbud" neutrum  ;
  uppbrott_nn_1_N = mkN "uppbrott" neutrum  ;
  universitetsbibliotek_nn_1_N = mkN "universitetsbibliotek" neutrum  ;
  universitet_nn_1_N = mkN "universitet" neutrum  ;
  universalspraak_nn_1_1_N = mkN "universalspråk" neutrum  ;
  universalmedel_nn_1_N = mkN "universalmedel" neutrum  ;
  universalbegrepp_nn_1_N = mkN "universalbegrepp" neutrum  ;
  unionsbrott_nn_1_N = mkN "unionsbrott" neutrum  ;
  unikat_nn_1_N = mkN "unikat" neutrum  ;
  ungnoet_nn_1_1_N = mkN "ungnöt" neutrum  ;
  ungkarlshotell_nn_1_N = mkN "ungkarlshotell" neutrum  ;
  ungdomsaar_nn_1_1_N = mkN "ungdomsår" neutrum  ;
  ungdomsverk_nn_1_N = mkN "ungdomsverk" neutrum  ;
  ungdomsraad_nn_1_1_N = mkN "ungdomsråd" neutrum  ;
  ungdomsfoerbund_nn_1_1_N = mkN "ungdomsförbund" neutrum  ;
  ungdjur_nn_1_N = mkN "ungdjur" neutrum  ;
  undsaettningsfoersoek_nn_1_1_N = mkN "undsättningsförsök" neutrum  ;
  undervisningsspraak_nn_1_1_N = mkN "undervisningsspråk" neutrum  ;
  undervisningsraad_nn_1_1_N = mkN "undervisningsråd" neutrum  ;
  undervisningspaket_nn_1_N = mkN "undervisningspaket" neutrum  ;
  undervisningsmaterial_nn_1_N = mkN "undervisningsmaterial" neutrum  ;
  underverk_nn_1_N = mkN "underverk" neutrum  ;
  undertak_nn_1_N = mkN "undertak" neutrum  ;
  understag_nn_1_N = mkN "understag" neutrum  ;
  underslev_nn_1_N = mkN "underslev" neutrum  ;
  underslag_nn_1_N = mkN "underslag" neutrum  ;
  underskaap_nn_1_1_N = mkN "underskåp" neutrum  ;
  underskottsavdrag_nn_1_N = mkN "underskottsavdrag" neutrum  ;
  underskott_nn_1_N = mkN "underskott" neutrum  ;
  underplagg_nn_1_N = mkN "underplagg" neutrum  ;
  underlaegg_nn_1_1_N = mkN "underlägg" neutrum  ;
  underliv_nn_1_N = mkN "underliv" neutrum  ;
  underlakan_nn_1_N = mkN "underlakan" neutrum  ;
  underlag_nn_1_N = mkN "underlag" neutrum  ;
  underjordsprov_nn_1_N = mkN "underjordsprov" neutrum  ;
  underhaallsfoerband_nn_1_1_N = mkN "underhållsförband" neutrum  ;
  underhaallsbidrag_nn_1_1_N = mkN "underhållsbidrag" neutrum  ;
  underhaall_nn_1_1_N = mkN "underhåll" neutrum  ;
  underhypotek_nn_1_N = mkN "underhypotek" neutrum  ;
  underhandsbesked_nn_1_N = mkN "underhandsbesked" neutrum  ;
  underhandsackord_nn_1_N = mkN "underhandsackord" neutrum  ;
  undergaangshot_nn_1_1_N = mkN "undergångshot" neutrum  ;
  underfall_nn_1_N = mkN "underfall" neutrum  ;
  underdaeck_nn_1_1_N = mkN "underdäck" neutrum  ;
  underdjur_nn_1_N = mkN "underdjur" neutrum  ;
  underbud_nn_1_N = mkN "underbud" neutrum  ;
  underbetyg_nn_1_N = mkN "underbetyg" neutrum  ;
  underbett_nn_1_N = mkN "underbett" neutrum  ;
  underbestaand_nn_1_1_N = mkN "underbestånd" neutrum  ;
  underben_nn_1_N = mkN "underben" neutrum  ;
  underbegrepp_nn_1_N = mkN "underbegrepp" neutrum  ;
  underbefael_nn_1_1_N = mkN "underbefäl" neutrum  ;
  underbarn_nn_1_N = mkN "underbarn" neutrum  ;
  undantagstillstaand_nn_1_1_N = mkN "undantagstillstånd" neutrum  ;
  undantagsfall_nn_1_N = mkN "undantagsfall" neutrum  ;
  undantag_nn_1_N = mkN "undantag" neutrum  ;
  ultraljud_nn_1_N = mkN "ultraljud" neutrum  ;
  ugnskol_nn_1_N = mkN "ugnskol" neutrum  ;
  uddljud_nn_1_N = mkN "uddljud" neutrum  ;
  uddjaern_nn_1_1_N = mkN "uddjärn" neutrum  ;
  uddblad_nn_1_N = mkN "uddblad" neutrum  ;
  uddaplagg_nn_1_N = mkN "uddaplagg" neutrum  ;
  uddanummer_nn_1_N = mkN "uddanummer" neutrum  ;
  uddamaal_nn_1_1_N = mkN "uddamål" neutrum  ;
  ubaatsnaet_nn_1_1_N = mkN "ubåtsnät" neutrum  ;
  ubaatsjaktfartyg_nn_1_1_N = mkN "ubåtsjaktfartyg" neutrum  ;
  toevaeder_nn_1_1_N = mkN "töväder" neutrum  ;
  toernrosasnaar_nn_1_1_N = mkN "törnrosasnår" neutrum  ;
  toemningshaal_nn_1_1_N = mkN "tömningshål" neutrum  ;
  taarben_nn_1_1_N = mkN "tårben" neutrum  ;
  taangbad_nn_1_1_N = mkN "tångbad" neutrum  ;
  taajaern_nn_1_1_N = mkN "tåjärn" neutrum  ;
  taagsaett_nn_1_1_N = mkN "tågsätt" neutrum  ;
  taagstopp_nn_1_1_N = mkN "tågstopp" neutrum  ;
  taagraan_nn_1_1_N = mkN "tågrån" neutrum  ;
  taag_nn_1_1_N = mkN "tåg" neutrum  ;
  taevlingshumoer_nn_1_1_N = mkN "tävlingshumör" neutrum  ;
  taenkesaett_nn_1_1_N = mkN "tänkesätt" neutrum  ;
  taenkespraak_nn_1_1_N = mkN "tänkespråk" neutrum  ;
  taendstift_nn_1_1_N = mkN "tändstift" neutrum  ;
  taendsticksmoenster_nn_1_1_N = mkN "tändsticksmönster" neutrum  ;
  taendroer_nn_1_1_N = mkN "tändrör" neutrum  ;
  taendmedel_nn_1_1_N = mkN "tändmedel" neutrum  ;
  taendaruttag_nn_1_1_N = mkN "tändaruttag" neutrum  ;
  taelttak_nn_1_1_N = mkN "tälttak" neutrum  ;
  taelt_nn_1_1_N = mkN "tält" neutrum  ;
  taeckord_nn_1_1_N = mkN "täckord" neutrum  ;
  taeckningskoep_nn_1_1_N = mkN "täckningsköp" neutrum  ;
  taecknamn_nn_1_1_N = mkN "täcknamn" neutrum  ;
  taeckhaar_nn_1_1_N = mkN "täckhår" neutrum  ;
  taeckfoerband_nn_1_1_N = mkN "täckförband" neutrum  ;
  taeckblad_nn_1_1_N = mkN "täckblad" neutrum  ;
  typsnitt_nn_1_N = mkN "typsnitt" neutrum  ;
  typnummer_nn_1_N = mkN "typnummer" neutrum  ;
  typfall_nn_1_N = mkN "typfall" neutrum  ;
  tygoeverdrag_nn_1_1_N = mkN "tygöverdrag" neutrum  ;
  tygtryck_nn_1_N = mkN "tygtryck" neutrum  ;
  tygsjok_nn_1_N = mkN "tygsjok" neutrum  ;
  tygband_nn_1_N = mkN "tygband" neutrum  ;
  tvaatimmarsskift_nn_1_1_N = mkN "tvåtimmarsskift" neutrum  ;
  tvaaspann_nn_1_1_N = mkN "tvåspann" neutrum  ;
  tvaangsmedel_nn_1_1_N = mkN "tvångsmedel" neutrum  ;
  tvaamanstaelt_nn_1_1_N = mkN "tvåmanstält" neutrum  ;
  tvaamannataelt_nn_1_1_N = mkN "tvåmannatält" neutrum  ;
  tvaafrontskrig_nn_1_1_N = mkN "tvåfrontskrig" neutrum  ;
  tvaablad_nn_1_1_N = mkN "tvåblad" neutrum  ;
  tvaettstaell_nn_1_1_N = mkN "tvättställ" neutrum  ;
  tvaettstugebraak_nn_1_1_N = mkN "tvättstugebråk" neutrum  ;
  tvaettresultat_nn_1_1_N = mkN "tvättresultat" neutrum  ;
  tvaettpulver_nn_1_1_N = mkN "tvättpulver" neutrum  ;
  tvaettmedel_nn_1_1_N = mkN "tvättmedel" neutrum  ;
  tvaettfat_nn_1_1_N = mkN "tvättfat" neutrum  ;
  tvaerstup_nn_1_1_N = mkN "tvärstup" neutrum  ;
  tvaerstreck_nn_1_1_N = mkN "tvärstreck" neutrum  ;
  tvaerstopp_nn_1_1_N = mkN "tvärstopp" neutrum  ;
  tvaersnitt_nn_1_1_N = mkN "tvärsnitt" neutrum  ;
  tvaerskepp_nn_1_1_N = mkN "tvärskepp" neutrum  ;
  tvistemaal_nn_1_1_N = mkN "tvistemål" neutrum  ;
  tvillingtorn_nn_1_N = mkN "tvillingtorn" neutrum  ;
  tvillingpar_nn_1_N = mkN "tvillingpar" neutrum  ;
  tut_nn_2_N = mkN "tut" neutrum  ;
  tusental_nn_1_N = mkN "tusental" neutrum  ;
  turkfolk_nn_1_N = mkN "turkfolk" neutrum  ;
  turistmaal_nn_1_1_N = mkN "turistmål" neutrum  ;
  turbojetplan_nn_1_N = mkN "turbojetplan" neutrum  ;
  turbinlager_nn_1_N = mkN "turbinlager" neutrum  ;
  tuppjuck_nn_1_N = mkN "tuppjuck" neutrum  ;
  tuppfjaet_nn_1_1_N = mkN "tuppfjät" neutrum  ;
  tunnvalv_nn_1_N = mkN "tunnvalv" neutrum  ;
  tunnland_nn_1_N = mkN "tunnland" neutrum  ;
  tunnelgenombrott_nn_1_N = mkN "tunnelgenombrott" neutrum  ;
  tunnbroed_nn_1_1_N = mkN "tunnbröd" neutrum  ;
  tunnband_nn_1_N = mkN "tunnband" neutrum  ;
  tungspets_r_nn_1_N = mkN "tungspets-r" neutrum  ;
  tungrots_r_nn_1_N = mkN "tungrots-r" neutrum  ;
  tungomaal_nn_1_1_N = mkN "tungomål" neutrum  ;
  tungljud_nn_1_N = mkN "tungljud" neutrum  ;
  tungben_nn_1_N = mkN "tungben" neutrum  ;
  tungband_nn_1_N = mkN "tungband" neutrum  ;
  tun_nn_1_N = mkN "tun" neutrum  ;
  tumveck_nn_1_N = mkN "tumveck" neutrum  ;
  tumult_nn_1_N = mkN "tumult" neutrum  ;
  tumgrepp_nn_1_N = mkN "tumgrepp" neutrum  ;
  tullverk_nn_1_N = mkN "tullverk" neutrum  ;
  tullskydd_nn_1_N = mkN "tullskydd" neutrum  ;
  tullkontor_nn_1_N = mkN "tullkontor" neutrum  ;
  tuggummipaket_nn_1_N = mkN "tuggummipaket" neutrum  ;
  tubroer_nn_1_1_N = mkN "tubrör" neutrum  ;
  troestmaal_nn_1_1_N = mkN "tröstmål" neutrum  ;
  troeskverk_nn_1_1_N = mkN "tröskverk" neutrum  ;
  troegdjur_nn_1_1_N = mkN "trögdjur" neutrum  ;
  traangmaal_nn_1_1_N = mkN "trångmål" neutrum  ;
  traag_nn_1_1_N = mkN "tråg" neutrum  ;
  traackelstygn_nn_1_1_N = mkN "tråckelstygn" neutrum  ;
  traesvaerd_nn_1_1_N = mkN "träsvärd" neutrum  ;
  traestift_nn_1_1_N = mkN "trästift" neutrum  ;
  traestick_nn_1_1_N = mkN "trästick" neutrum  ;
  traespaan_nn_1_1_N = mkN "träspån" neutrum  ;
  traesnitt_nn_1_1_N = mkN "träsnitt" neutrum  ;
  traeslott_nn_1_1_N = mkN "träslott" neutrum  ;
  traeslag_nn_1_1_N = mkN "träslag" neutrum  ;
  traeskyddsmedel_nn_1_1_N = mkN "träskyddsmedel" neutrum  ;
  traeskydd_nn_1_1_N = mkN "träskydd" neutrum  ;
  traeskosteg_nn_1_1_N = mkN "träskosteg" neutrum  ;
  traeskland_nn_1_1_N = mkN "träskland" neutrum  ;
  traeskfolk_nn_1_1_N = mkN "träskfolk" neutrum  ;
  traenjon_nn_1_1_N = mkN "tränjon" neutrum  ;
  traeningsupplaegg_nn_1_1_N = mkN "träningsupplägg" neutrum  ;
  traeningslaeger_nn_1_1_N = mkN "träningsläger" neutrum  ;
  traekol_nn_1_1_N = mkN "träkol" neutrum  ;
  traegolv_nn_1_1_N = mkN "trägolv" neutrum  ;
  traefartyg_nn_1_1_N = mkN "träfartyg" neutrum  ;
  traedstygn_nn_1_1_N = mkN "trädstygn" neutrum  ;
  traedslag_nn_1_1_N = mkN "trädslag" neutrum  ;
  traedgaardsredskap_nn_1_1_N = mkN "trädgårdsredskap" neutrum  ;
  traedgaardsland_nn_1_1_N = mkN "trädgårdsland" neutrum  ;
  traeblaasinstrument_nn_1_1_N = mkN "träblåsinstrument" neutrum  ;
  traeben_nn_1_1_N = mkN "träben" neutrum  ;
  tryckaar_nn_1_1_N = mkN "tryckår" neutrum  ;
  tryckskydd_nn_1_N = mkN "tryckskydd" neutrum  ;
  tryckord_nn_1_N = mkN "tryckord" neutrum  ;
  tryckkaerl_nn_1_1_N = mkN "tryckkärl" neutrum  ;
  tryckfoerband_nn_1_1_N = mkN "tryckförband" neutrum  ;
  tryckalster_nn_1_N = mkN "tryckalster" neutrum  ;
  tryck_nn_1_N = mkN "tryck" neutrum  ;
  trutaegg_nn_1_1_N = mkN "trutägg" neutrum  ;
  trupptransporttaag_nn_1_1_N = mkN "trupptransporttåg" neutrum  ;
  trupptransportfartyg_nn_1_N = mkN "trupptransportfartyg" neutrum  ;
  truppslag_nn_1_N = mkN "truppslag" neutrum  ;
  truppfoerband_nn_1_1_N = mkN "truppförband" neutrum  ;
  trumslag_nn_1_N = mkN "trumslag" neutrum  ;
  trumskinn_nn_1_N = mkN "trumskinn" neutrum  ;
  trumfkort_nn_1_N = mkN "trumfkort" neutrum  ;
  trosskydd_nn_1_N = mkN "trosskydd" neutrum  ;
  trossdaeck_nn_1_1_N = mkN "trossdäck" neutrum  ;
  trossamfund_nn_1_N = mkN "trossamfund" neutrum  ;
  trontal_nn_1_N = mkN "trontal" neutrum  ;
  troninnehav_nn_1_N = mkN "troninnehav" neutrum  ;
  tronfoeljdskrig_nn_1_1_N = mkN "tronföljdskrig" neutrum  ;
  trolovningsbarn_nn_1_N = mkN "trolovningsbarn" neutrum  ;
  trolltyg_nn_1_N = mkN "trolltyg" neutrum  ;
  trollslag_nn_1_N = mkN "trollslag" neutrum  ;
  trollskott_nn_1_N = mkN "trollskott" neutrum  ;
  trollmedel_nn_1_N = mkN "trollmedel" neutrum  ;
  trolleritrick_nn_1_N = mkN "trolleritrick" neutrum  ;
  trollbaer_nn_1_1_N = mkN "trollbär" neutrum  ;
  trollbarn_nn_1_N = mkN "trollbarn" neutrum  ;
  troll_nn_1_N = mkN "troll" neutrum  ;
  trivialnamn_nn_1_N = mkN "trivialnamn" neutrum  ;
  triumvirat_nn_1_N = mkN "triumvirat" neutrum  ;
  triumftaag_nn_1_1_N = mkN "triumftåg" neutrum  ;
  tripp_nn_2_N = mkN "tripp" neutrum  ;
  trick_nn_1_N = mkN "trick" neutrum  ;
  tribunat_nn_1_N = mkN "tribunat" neutrum  ;
  trettital_nn_1_N = mkN "trettital" neutrum  ;
  trettiotal_nn_1_N = mkN "trettiotal" neutrum  ;
  tretal_nn_1_N = mkN "tretal" neutrum  ;
  trestegshopp_nn_1_N = mkN "trestegshopp" neutrum  ;
  trespann_nn_1_N = mkN "trespann" neutrum  ;
  trendbrott_nn_1_N = mkN "trendbrott" neutrum  ;
  trendanalysfoeretag_nn_1_1_N = mkN "trendanalysföretag" neutrum  ;
  treglasfoenster_nn_1_1_N = mkN "treglasfönster" neutrum  ;
  trefaergstryck_nn_1_1_N = mkN "trefärgstryck" neutrum  ;
  trapptorn_nn_1_N = mkN "trapptorn" neutrum  ;
  trappsteg_nn_1_N = mkN "trappsteg" neutrum  ;
  transporttaag_nn_1_1_N = mkN "transporttåg" neutrum  ;
  transportnaet_nn_1_1_N = mkN "transportnät" neutrum  ;
  transportmedel_nn_1_N = mkN "transportmedel" neutrum  ;
  transporthjul_nn_1_N = mkN "transporthjul" neutrum  ;
  transportfoeretag_nn_1_1_N = mkN "transportföretag" neutrum  ;
  transportfoerbud_nn_1_1_N = mkN "transportförbud" neutrum  ;
  transportband_nn_1_N = mkN "transportband" neutrum  ;
  transportavtal_nn_1_N = mkN "transportavtal" neutrum  ;
  transplantat_nn_1_N = mkN "transplantat" neutrum  ;
  tranbaer_nn_1_1_N = mkN "tranbär" neutrum  ;
  tranben_nn_1_N = mkN "tranben" neutrum  ;
  tramphjul_nn_1_N = mkN "tramphjul" neutrum  ;
  trampfartyg_nn_1_N = mkN "trampfartyg" neutrum  ;
  traktordaeck_nn_1_1_N = mkN "traktordäck" neutrum  ;
  trakom_nn_1_N = mkN "trakom" neutrum  ;
  traj_nn_1_N = mkN "traj" neutrum  ;
  trafiktillstaand_nn_1_1_N = mkN "trafiktillstånd" neutrum  ;
  trafiksaekerhetsverk_nn_1_1_N = mkN "trafiksäkerhetsverk" neutrum  ;
  trafikkort_nn_1_N = mkN "trafikkort" neutrum  ;
  trafikkontor_nn_1_N = mkN "trafikkontor" neutrum  ;
  trafikflygplan_nn_1_N = mkN "trafikflygplan" neutrum  ;
  traditionsbrott_nn_1_N = mkN "traditionsbrott" neutrum  ;
  totalfoerbud_nn_1_1_N = mkN "totalförbud" neutrum  ;
  totalbelopp_nn_1_N = mkN "totalbelopp" neutrum  ;
  torvtak_nn_1_N = mkN "torvtak" neutrum  ;
  torvmossfynd_nn_1_N = mkN "torvmossfynd" neutrum  ;
  tortyrredskap_nn_1_N = mkN "tortyrredskap" neutrum  ;
  torsdagsnummer_nn_1_N = mkN "torsdagsnummer" neutrum  ;
  torrelement_nn_1_N = mkN "torrelement" neutrum  ;
  torp_nn_1_N = mkN "torp" neutrum  ;
  tornur_nn_1_N = mkN "tornur" neutrum  ;
  tornfoenster_nn_1_1_N = mkN "tornfönster" neutrum  ;
  torn_nn_1_N = mkN "torn" neutrum  ;
  torktumlarfilter_nn_1_N = mkN "torktumlarfilter" neutrum  ;
  torkstaell_nn_1_1_N = mkN "torkställ" neutrum  ;
  torkstreck_nn_1_N = mkN "torkstreck" neutrum  ;
  torkskaap_nn_1_1_N = mkN "torkskåp" neutrum  ;
  torkpapper_nn_1_N = mkN "torkpapper" neutrum  ;
  torkblock_nn_1_N = mkN "torkblock" neutrum  ;
  torkarblad_nn_1_N = mkN "torkarblad" neutrum  ;
  torgstaand_nn_1_1_N = mkN "torgstånd" neutrum  ;
  torg_nn_1_N = mkN "torg" neutrum  ;
  tordoen_nn_1_1_N = mkN "tordön" neutrum  ;
  toppskott_nn_1_N = mkN "toppskott" neutrum  ;
  topplaan_nn_1_1_N = mkN "topplån" neutrum  ;
  topplock_nn_1_N = mkN "topplock" neutrum  ;
  toppjobb_nn_1_N = mkN "toppjobb" neutrum  ;
  toppbetyg_nn_1_N = mkN "toppbetyg" neutrum  ;
  tonaarsgaeng_nn_1_1_N = mkN "tonårsgäng" neutrum  ;
  tonsteg_nn_1_N = mkN "tonsteg" neutrum  ;
  tonspraak_nn_1_1_N = mkN "tonspråk" neutrum  ;
  tonomfaang_nn_1_1_N = mkN "tonomfång" neutrum  ;
  tonikum_nn_1_N = mkN "tonikum" neutrum  ;
  tonfall_nn_1_N = mkN "tonfall" neutrum  ;
  tonband_nn_1_N = mkN "tonband" neutrum  ;
  toffeldjur_nn_1_N = mkN "toffeldjur" neutrum  ;
  tobaksmonopol_nn_1_N = mkN "tobaksmonopol" neutrum  ;
  tobaksflarn_nn_1_N = mkN "tobaksflarn" neutrum  ;
  tobaksblad_nn_1_N = mkN "tobaksblad" neutrum  ;
  toalettskaap_nn_1_1_N = mkN "toalettskåp" neutrum  ;
  toalettlock_nn_1_N = mkN "toalettlock" neutrum  ;
  toalettbord_nn_1_N = mkN "toalettbord" neutrum  ;
  toalettbesoek_nn_1_1_N = mkN "toalettbesök" neutrum  ;
  tjaerblomster_nn_1_1_N = mkN "tjärblomster" neutrum  ;
  tjaenstgoeringsnummer_nn_1_1_N = mkN "tjänstgöringsnummer" neutrum  ;
  tjaensteaar_nn_1_1_N = mkN "tjänsteår" neutrum  ;
  tjaenstehjon_nn_1_1_N = mkN "tjänstehjon" neutrum  ;
  tjaenstebrev_nn_1_1_N = mkN "tjänstebrev" neutrum  ;
  tjaensteavtal_nn_1_1_N = mkN "tjänsteavtal" neutrum  ;
  tjaelskott_nn_1_1_N = mkN "tjälskott" neutrum  ;
  tjaell_nn_1_1_N = mkN "tjäll" neutrum  ;
  tjyvnyp_nn_1_N = mkN "tjyvnyp" neutrum  ;
  tjyvknep_nn_1_N = mkN "tjyvknep" neutrum  ;
  tjuvtryck_nn_1_N = mkN "tjuvtryck" neutrum  ;
  tjuvstreck_nn_1_N = mkN "tjuvstreck" neutrum  ;
  tjuvnyp_nn_1_N = mkN "tjuvnyp" neutrum  ;
  tjuvlarm_nn_1_N = mkN "tjuvlarm" neutrum  ;
  tjuvknep_nn_1_N = mkN "tjuvknep" neutrum  ;
  tjuvalarm_nn_1_N = mkN "tjuvalarm" neutrum  ;
  tjut_nn_1_N = mkN "tjut" neutrum  ;
  tjugotal_nn_1_N = mkN "tjugotal" neutrum  ;
  tjuder_nn_1_N = mkN "tjuder" neutrum  ;
  tjog_nn_1_N = mkN "tjog" neutrum  ;
  tjack_nn_1_N = mkN "tjack" neutrum  ;
  tittskaap_nn_1_1_N = mkN "tittskåp" neutrum  ;
  titthaal_nn_1_1_N = mkN "titthål" neutrum  ;
  titelblad_nn_1_N = mkN "titelblad" neutrum  ;
  tistron_nn_1_N = mkN "tistron" neutrum  ;
  tippskydd_nn_1_N = mkN "tippskydd" neutrum  ;
  tippflak_nn_1_N = mkN "tippflak" neutrum  ;
  tiotusental_nn_1_N = mkN "tiotusental" neutrum  ;
  tiotal_nn_1_N = mkN "tiotal" neutrum  ;
  tiokronorsmynt_nn_1_N = mkN "tiokronorsmynt" neutrum  ;
  tinningben_nn_1_N = mkN "tinningben" neutrum  ;
  tingslag_nn_1_N = mkN "tingslag" neutrum  ;
  tingord_nn_1_N = mkN "tingord" neutrum  ;
  ting_nn_2_N = mkN "ting" neutrum  ;
  ting_nn_1_N = mkN "ting" neutrum  ;
  timslag_nn_1_N = mkN "timslag" neutrum  ;
  timmerstek_nn_1_N = mkN "timmerstek" neutrum  ;
  timmerslaep_nn_1_1_N = mkN "timmersläp" neutrum  ;
  timmermagasin_nn_1_N = mkN "timmermagasin" neutrum  ;
  timmeravlaegg_nn_1_1_N = mkN "timmeravlägg" neutrum  ;
  timmer_nn_1_N = mkN "timmer" neutrum  ;
  tillaeggsmandat_nn_1_1_N = mkN "tilläggsmandat" neutrum  ;
  tillaeggsbelopp_nn_1_1_N = mkN "tilläggsbelopp" neutrum  ;
  tillaegg_nn_1_1_N = mkN "tillägg" neutrum  ;
  tillvaegagaangssaett_nn_1_1_N = mkN "tillvägagångssätt" neutrum  ;
  tillverkningsaar_nn_1_1_N = mkN "tillverkningsår" neutrum  ;
  tillval_nn_1_N = mkN "tillval" neutrum  ;
  tilltalsord_nn_1_N = mkN "tilltalsord" neutrum  ;
  tilltalsnamn_nn_1_N = mkN "tilltalsnamn" neutrum  ;
  tilltag_nn_1_N = mkN "tilltag" neutrum  ;
  tillstaand_nn_1_1_N = mkN "tillstånd" neutrum  ;
  tillslag_nn_1_N = mkN "tillslag" neutrum  ;
  tillskott_nn_1_N = mkN "tillskott" neutrum  ;
  tillrop_nn_1_N = mkN "tillrop" neutrum  ;
  tillopp_nn_1_N = mkN "tillopp" neutrum  ;
  tillnamn_nn_1_N = mkN "tillnamn" neutrum  ;
  tillhaall_nn_1_1_N = mkN "tillhåll" neutrum  ;
  tillgrepp_nn_1_N = mkN "tillgrepp" neutrum  ;
  tillbud_nn_1_N = mkN "tillbud" neutrum  ;
  tillbehoer_nn_1_1_N = mkN "tillbehör" neutrum  ;
  tiggarbrev_nn_1_N = mkN "tiggarbrev" neutrum  ;
  tigerspraang_nn_1_1_N = mkN "tigersprång" neutrum  ;
  tigerskinn_nn_1_N = mkN "tigerskinn" neutrum  ;
  tie_break_nn_1_N = mkN "tie-break" neutrum  ;
  tidvattenkraftverk_nn_1_N = mkN "tidvattenkraftverk" neutrum  ;
  tidur_nn_1_N = mkN "tidur" neutrum  ;
  tidtagarur_nn_1_N = mkN "tidtagarur" neutrum  ;
  tidsoeverdrag_nn_1_1_N = mkN "tidsöverdrag" neutrum  ;
  tidsplan_nn_2_N = mkN "tidsplan" neutrum  ;
  tidsmaatt_nn_1_1_N = mkN "tidsmått" neutrum  ;
  tidskriftsnummer_nn_1_N = mkN "tidskriftsnummer" neutrum  ;
  tidsfoerlopp_nn_1_1_N = mkN "tidsförlopp" neutrum  ;
  tidsfoerdriv_nn_1_1_N = mkN "tidsfördriv" neutrum  ;
  tidsdokument_nn_1_N = mkN "tidsdokument" neutrum  ;
  tidsbegrepp_nn_1_N = mkN "tidsbegrepp" neutrum  ;
  tidroer_nn_1_1_N = mkN "tidrör" neutrum  ;
  tidningsstaell_nn_1_1_N = mkN "tidningsställ" neutrum  ;
  tidningsreferat_nn_1_N = mkN "tidningsreferat" neutrum  ;
  tidningsfoeretag_nn_1_1_N = mkN "tidningsföretag" neutrum  ;
  tidningsbud_nn_1_N = mkN "tidningsbud" neutrum  ;
  tidlaan_nn_1_1_N = mkN "tidlån" neutrum  ;
  tidkort_nn_1_N = mkN "tidkort" neutrum  ;
  tidkontrollur_nn_1_N = mkN "tidkontrollur" neutrum  ;
  tidjordsfenomen_nn_1_N = mkN "tidjordsfenomen" neutrum  ;
  tidevarv_nn_1_N = mkN "tidevarv" neutrum  ;
  tidelag_nn_1_N = mkN "tidelag" neutrum  ;
  tick_nn_1_N = mkN "tick" neutrum  ;
  tick_tack_nn_1_N = mkN "tick-tack" neutrum  ;
  thaispraak_nn_1_1_N = mkN "thaispråk" neutrum  ;
  textavsnitt_nn_1_N = mkN "textavsnitt" neutrum  ;
  teveabonnemang_nn_1_N = mkN "teveabonnemang" neutrum  ;
  tetrapak_nn_1_N = mkN "tetrapak" neutrum  ;
  terraengnamn_nn_1_1_N = mkN "terrängnamn" neutrum  ;
  terrornaetverk_nn_1_1_N = mkN "terrornätverk" neutrum  ;
  terrorhot_nn_1_N = mkN "terrorhot" neutrum  ;
  terrordaad_nn_1_1_N = mkN "terrordåd" neutrum  ;
  termoelement_nn_1_N = mkN "termoelement" neutrum  ;
  tennislaeger_nn_1_1_N = mkN "tennisläger" neutrum  ;
  tempus_nn_1_N = mkN "tempus" neutrum  ;
  tempolopp_nn_1_N = mkN "tempolopp" neutrum  ;
  temperamentsutbrott_nn_1_N = mkN "temperamentsutbrott" neutrum  ;
  temperament_nn_1_N = mkN "temperament" neutrum  ;
  tempeltorn_nn_1_N = mkN "tempeltorn" neutrum  ;
  temanummer_nn_1_N = mkN "temanummer" neutrum  ;
  televerk_nn_1_N = mkN "televerk" neutrum  ;
  teleskoproer_nn_1_1_N = mkN "teleskoprör" neutrum  ;
  teleskop_nn_1_N = mkN "teleskop" neutrum  ;
  telenaet_nn_1_1_N = mkN "telenät" neutrum  ;
  telegrambud_nn_1_N = mkN "telegrambud" neutrum  ;
  telefonsvar_nn_1_N = mkN "telefonsvar" neutrum  ;
  telefonsamtal_nn_1_N = mkN "telefonsamtal" neutrum  ;
  telefonnaet_nn_1_1_N = mkN "telefonnät" neutrum  ;
  telefonnummer_nn_1_N = mkN "telefonnummer" neutrum  ;
  telefonkort_nn_1_N = mkN "telefonkort" neutrum  ;
  telefonbolag_nn_1_N = mkN "telefonbolag" neutrum  ;
  telefonanrop_nn_1_N = mkN "telefonanrop" neutrum  ;
  tegelbruk_nn_1_N = mkN "tegelbruk" neutrum  ;
  tefat_nn_1_N = mkN "tefat" neutrum  ;
  teckenspraak_nn_1_1_N = mkN "teckenspråk" neutrum  ;
  teckenalfabet_nn_1_N = mkN "teckenalfabet" neutrum  ;
  teblad_nn_1_N = mkN "teblad" neutrum  ;
  teatersaellskap_nn_1_1_N = mkN "teatersällskap" neutrum  ;
  teaterliv_nn_1_N = mkN "teaterliv" neutrum  ;
  teaterdistrikt_nn_1_N = mkN "teaterdistrikt" neutrum  ;
  teaterbesoek_nn_1_1_N = mkN "teaterbesök" neutrum  ;
  team_nn_1_N = mkN "team" neutrum  ;
  taxifoenster_nn_1_1_N = mkN "taxifönster" neutrum  ;
  taxeringsaar_nn_1_1_N = mkN "taxeringsår" neutrum  ;
  taxeringsbeslut_nn_1_N = mkN "taxeringsbeslut" neutrum  ;
  tarsalben_nn_1_N = mkN "tarsalben" neutrum  ;
  tarmvred_nn_1_N = mkN "tarmvred" neutrum  ;
  tarmben_nn_1_N = mkN "tarmben" neutrum  ;
  tappningsroer_nn_1_1_N = mkN "tappningsrör" neutrum  ;
  tapplager_nn_1_N = mkN "tapplager" neutrum  ;
  tapphaal_nn_1_1_N = mkN "tapphål" neutrum  ;
  tapp_nn_2_N = mkN "tapp" neutrum  ;
  tapetserarstift_nn_1_N = mkN "tapetserarstift" neutrum  ;
  tantalikval_nn_1_N = mkN "tantalikval" neutrum  ;
  tankstreck_nn_1_N = mkN "tankstreck" neutrum  ;
  tankgevaer_nn_1_1_N = mkN "tankgevär" neutrum  ;
  tankfartyg_nn_1_N = mkN "tankfartyg" neutrum  ;
  tankespaar_nn_1_1_N = mkN "tankespår" neutrum  ;
  tankemoenster_nn_1_1_N = mkN "tankemönster" neutrum  ;
  tankeled_nn_1_N = mkN "tankeled" neutrum  ;
  tankefoster_nn_1_N = mkN "tankefoster" neutrum  ;
  tangentplan_nn_1_N = mkN "tangentplan" neutrum  ;
  tangentinstrument_nn_1_N = mkN "tangentinstrument" neutrum  ;
  tangentbord_nn_1_N = mkN "tangentbord" neutrum  ;
  tandvaardsbidrag_nn_1_1_N = mkN "tandvårdsbidrag" neutrum  ;
  tandutskott_nn_1_N = mkN "tandutskott" neutrum  ;
  tandsnitt_nn_1_N = mkN "tandsnitt" neutrum  ;
  tandskydd_nn_1_N = mkN "tandskydd" neutrum  ;
  tandlaekarbesoek_nn_1_1_N = mkN "tandläkarbesök" neutrum  ;
  tandimplantat_nn_1_N = mkN "tandimplantat" neutrum  ;
  tandhjul_nn_1_N = mkN "tandhjul" neutrum  ;
  tandgenombrott_nn_1_N = mkN "tandgenombrott" neutrum  ;
  tandgarnityr_nn_1_N = mkN "tandgarnityr" neutrum  ;
  tamsvin_nn_1_N = mkN "tamsvin" neutrum  ;
  talspraak_nn_1_1_N = mkN "talspråk" neutrum  ;
  talroer_nn_1_1_N = mkN "talrör" neutrum  ;
  talorgan_nn_1_N = mkN "talorgan" neutrum  ;
  tallrikshjul_nn_1_N = mkN "tallrikshjul" neutrum  ;
  tallbarr_nn_1_N = mkN "tallbarr" neutrum  ;
  talesaett_nn_1_1_N = mkN "talesätt" neutrum  ;
  tal_nn_1_N = mkN "tal" neutrum  ;
  taktstreck_nn_1_N = mkN "taktstreck" neutrum  ;
  taktslag_nn_1_N = mkN "taktslag" neutrum  ;
  takspraang_nn_1_1_N = mkN "taksprång" neutrum  ;
  takskaegg_nn_1_1_N = mkN "takskägg" neutrum  ;
  takraeck_nn_1_1_N = mkN "takräck" neutrum  ;
  taklagsoel_nn_1_1_N = mkN "taklagsöl" neutrum  ;
  taklag_nn_1_N = mkN "taklag" neutrum  ;
  takistoskop_nn_1_N = mkN "takistoskop" neutrum  ;
  takfoenster_nn_1_1_N = mkN "takfönster" neutrum  ;
  takfall_nn_1_N = mkN "takfall" neutrum  ;
  tak_nn_1_N = mkN "tak" neutrum  ;
  taggtraadshinder_nn_1_1_N = mkN "taggtrådshinder" neutrum  ;
  taggpar_nn_1_N = mkN "taggpar" neutrum  ;
  tag_nn_1_N = mkN "tag" neutrum  ;
  taffelberg_nn_1_N = mkN "taffelberg" neutrum  ;
  tacorecept_nn_1_N = mkN "tacorecept" neutrum  ;
  tacktal_nn_1_N = mkN "tacktal" neutrum  ;
  tackkort_nn_1_N = mkN "tackkort" neutrum  ;
  tabuord_nn_1_N = mkN "tabuord" neutrum  ;
  soetningsmedel_nn_1_1_N = mkN "sötningsmedel" neutrum  ;
  soendagsbarn_nn_1_1_N = mkN "söndagsbarn" neutrum  ;
  soemnmedel_nn_1_1_N = mkN "sömnmedel" neutrum  ;
  soekpaadrag_nn_1_1_N = mkN "sökpådrag" neutrum  ;
  soekgraenssnitt_nn_1_1_N = mkN "sökgränssnitt" neutrum  ;
  saar_nn_1_1_N = mkN "sår" neutrum  ;
  saangsaett_nn_1_1_N = mkN "sångsätt" neutrum  ;
  saangprov_nn_1_1_N = mkN "sångprov" neutrum  ;
  saall_nn_1_1_N = mkN "såll" neutrum  ;
  saagverk_nn_1_1_N = mkN "sågverk" neutrum  ;
  saagtak_nn_1_1_N = mkN "sågtak" neutrum  ;
  saagspaan_nn_1_1_N = mkN "sågspån" neutrum  ;
  saagblad_nn_1_1_N = mkN "sågblad" neutrum  ;
  saettsord_nn_1_1_N = mkN "sättsord" neutrum  ;
  saettskepp_nn_1_1_N = mkN "sättskepp" neutrum  ;
  saettnaet_nn_1_1_N = mkN "sättnät" neutrum  ;
  saett_nn_1_1_N = mkN "sätt" neutrum  ;
  saeteritak_nn_1_1_N = mkN "säteritak" neutrum  ;
  saertryck_nn_1_1_N = mkN "särtryck" neutrum  ;
  saerkullsbarn_nn_1_1_N = mkN "särkullsbarn" neutrum  ;
  saerkullbarn_nn_1_1_N = mkN "särkullbarn" neutrum  ;
  saerfall_nn_1_1_N = mkN "särfall" neutrum  ;
  saerdrag_nn_1_1_N = mkN "särdrag" neutrum  ;
  saengbord_nn_1_1_N = mkN "sängbord" neutrum  ;
  saendningsuppehaall_nn_1_1_N = mkN "sändningsuppehåll" neutrum  ;
  saendebud_nn_1_1_N = mkN "sändebud" neutrum  ;
  saemskskinn_nn_1_1_N = mkN "sämskskinn" neutrum  ;
  saelskinn_nn_1_1_N = mkN "sälskinn" neutrum  ;
  saellskapsliv_nn_1_1_N = mkN "sällskapsliv" neutrum  ;
  saellskapsdjur_nn_1_1_N = mkN "sällskapsdjur" neutrum  ;
  saellskap_nn_1_1_N = mkN "sällskap" neutrum  ;
  saeljstopp_nn_1_1_N = mkN "säljstopp" neutrum  ;
  saeldjur_nn_1_1_N = mkN "säldjur" neutrum  ;
  saekerhetsskael_nn_1_1_N = mkN "säkerhetsskäl" neutrum  ;
  saekerhetspaadrag_nn_1_1_N = mkN "säkerhetspådrag" neutrum  ;
  saekerhetsgrepp_nn_1_1_N = mkN "säkerhetsgrepp" neutrum  ;
  saekerhetsavstaand_nn_1_1_N = mkN "säkerhetsavstånd" neutrum  ;
  saekerhetsarrangemang_nn_1_1_N = mkN "säkerhetsarrangemang" neutrum  ;
  saedesslag_nn_1_1_N = mkN "sädesslag" neutrum  ;
  systerfartyg_nn_1_N = mkN "systerfartyg" neutrum  ;
  systerbarn_nn_1_N = mkN "systerbarn" neutrum  ;
  systembolag_nn_1_N = mkN "systembolag" neutrum  ;
  syskonaektenskap_nn_1_1_N = mkN "syskonäktenskap" neutrum  ;
  syskonbarn_nn_1_N = mkN "syskonbarn" neutrum  ;
  syrefaelt_nn_1_1_N = mkN "syrefält" neutrum  ;
  syntetmaterial_nn_1_N = mkN "syntetmaterial" neutrum  ;
  syntaxtraed_nn_1_1_N = mkN "syntaxträd" neutrum  ;
  synsaett_nn_1_1_N = mkN "synsätt" neutrum  ;
  synorgan_nn_1_N = mkN "synorgan" neutrum  ;
  synonympar_nn_1_N = mkN "synonympar" neutrum  ;
  synintryck_nn_1_N = mkN "synintryck" neutrum  ;
  synfaelt_nn_1_1_N = mkN "synfält" neutrum  ;
  syndrom_nn_1_N = mkN "syndrom" neutrum  ;
  syndikat_nn_1_N = mkN "syndikat" neutrum  ;
  syndastraff_nn_1_N = mkN "syndastraff" neutrum  ;
  syndaregister_nn_1_N = mkN "syndaregister" neutrum  ;
  syndafall_nn_1_N = mkN "syndafall" neutrum  ;
  symmetriplan_nn_1_N = mkN "symmetriplan" neutrum  ;
  syltpaeron_nn_1_1_N = mkN "syltpäron" neutrum  ;
  sybehoer_nn_1_1_N = mkN "sybehör" neutrum  ;
  svaerord_nn_1_1_N = mkN "svärord" neutrum  ;
  svaerdskydd_nn_1_1_N = mkN "svärdskydd" neutrum  ;
  svaerd_nn_1_1_N = mkN "svärd" neutrum  ;
  svaengningstal_nn_1_1_N = mkN "svängningstal" neutrum  ;
  svaenghjul_nn_1_1_N = mkN "svänghjul" neutrum  ;
  sviskon_nn_1_N = mkN "sviskon" neutrum  ;
  svinn_nn_1_N = mkN "svinn" neutrum  ;
  svinkoett_nn_1_1_N = mkN "svinkött" neutrum  ;
  svinhugg_nn_1_N = mkN "svinhugg" neutrum  ;
  sving_nn_1_N = mkN "sving" neutrum  ;
  svindleriaatal_nn_1_1_N = mkN "svindleriåtal" neutrum  ;
  svin_nn_1_N = mkN "svin" neutrum  ;
  svettband_nn_1_N = mkN "svettband" neutrum  ;
  svepskael_nn_1_1_N = mkN "svepskäl" neutrum  ;
  svep_nn_1_N = mkN "svep" neutrum  ;
  svek_nn_1_N = mkN "svek" neutrum  ;
  svedjeland_nn_1_N = mkN "svedjeland" neutrum  ;
  sveamaal_nn_1_1_N = mkN "sveamål" neutrum  ;
  svavelpulver_nn_1_N = mkN "svavelpulver" neutrum  ;
  svarvstaal_nn_1_1_N = mkN "svarvstål" neutrum  ;
  svartsjukebraak_nn_1_1_N = mkN "svartsjukebråk" neutrum  ;
  svaromaal_nn_1_1_N = mkN "svaromål" neutrum  ;
  svar_nn_1_N = mkN "svar" neutrum  ;
  svanhopp_nn_1_N = mkN "svanhopp" neutrum  ;
  svampmoln_nn_1_N = mkN "svampmoln" neutrum  ;
  svampdjur_nn_1_N = mkN "svampdjur" neutrum  ;
  svalstjaertutspraang_nn_1_1_N = mkN "svalstjärtutsprång" neutrum  ;
  svall_nn_1_N = mkN "svall" neutrum  ;
  svalg_nn_1_N = mkN "svalg" neutrum  ;
  suterraengplan_nn_1_1_N = mkN "suterrängplan" neutrum  ;
  surrogat_nn_1_N = mkN "surrogat" neutrum  ;
  surkoersbaer_nn_1_1_N = mkN "surkörsbär" neutrum  ;
  surfoder_nn_1_N = mkN "surfoder" neutrum  ;
  surdegsbroed_nn_1_1_N = mkN "surdegsbröd" neutrum  ;
  supporterbraak_nn_1_1_N = mkN "supporterbråk" neutrum  ;
  supplement_nn_1_N = mkN "supplement" neutrum  ;
  supernovautbrott_nn_1_N = mkN "supernovautbrott" neutrum  ;
  suntaelt_nn_1_1_N = mkN "suntält" neutrum  ;
  sund_nn_1_N = mkN "sund" neutrum  ;
  sultanrussin_nn_1_N = mkN "sultanrussin" neutrum  ;
  sultanat_nn_1_N = mkN "sultanat" neutrum  ;
  sugroer_nn_1_1_N = mkN "sugrör" neutrum  ;
  suckljud_nn_1_N = mkN "suckljud" neutrum  ;
  substrat_nn_1_N = mkN "substrat" neutrum  ;
  substitut_nn_1_N = mkN "substitut" neutrum  ;
  subjekt_nn_1_N = mkN "subjekt" neutrum  ;
  stoevelskaft_nn_1_1_N = mkN "stövelskaft" neutrum  ;
  stoetskydd_nn_1_1_N = mkN "stötskydd" neutrum  ;
  stoertregn_nn_1_1_N = mkN "störtregn" neutrum  ;
  stoertlopp_nn_1_1_N = mkN "störtlopp" neutrum  ;
  stoerskydd_nn_1_1_N = mkN "störskydd" neutrum  ;
  stoerningsmoment_nn_1_1_N = mkN "störningsmoment" neutrum  ;
  stoen_nn_1_1_N = mkN "stön" neutrum  ;
  stoedteam_nn_1_1_N = mkN "stödteam" neutrum  ;
  stoedsamtal_nn_1_1_N = mkN "stödsamtal" neutrum  ;
  stoedpapper_nn_1_1_N = mkN "stödpapper" neutrum  ;
  stoedkoep_nn_1_1_N = mkN "stödköp" neutrum  ;
  stoedjordbruk_nn_1_1_N = mkN "stödjordbruk" neutrum  ;
  stoedhjul_nn_1_1_N = mkN "stödhjul" neutrum  ;
  stoed_nn_1_1_N = mkN "stöd" neutrum  ;
  staand_nn_1_1_N = mkN "stånd" neutrum  ;
  staalverk_nn_1_1_N = mkN "stålverk" neutrum  ;
  staaltryck_nn_1_1_N = mkN "ståltryck" neutrum  ;
  staalstick_nn_1_1_N = mkN "stålstick" neutrum  ;
  staalskelett_nn_1_1_N = mkN "stålskelett" neutrum  ;
  staalroer_nn_1_1_N = mkN "stålrör" neutrum  ;
  staalbad_nn_1_1_N = mkN "stålbad" neutrum  ;
  staal_nn_1_1_N = mkN "stål" neutrum  ;
  staev_nn_2_1_N = mkN "stäv" neutrum  ;
  staenkskydd_nn_1_1_N = mkN "stänkskydd" neutrum  ;
  staenk_nn_1_1_N = mkN "stänk" neutrum  ;
  staempelur_nn_1_1_N = mkN "stämpelur" neutrum  ;
  staemmobeslut_nn_1_1_N = mkN "stämmobeslut" neutrum  ;
  staemjaern_nn_1_1_N = mkN "stämjärn" neutrum  ;
  staemband_nn_1_1_N = mkN "stämband" neutrum  ;
  staellverk_nn_1_1_N = mkN "ställverk" neutrum  ;
  staellningssteg_nn_1_1_N = mkN "ställningssteg" neutrum  ;
  staellningskrig_nn_1_1_N = mkN "ställningskrig" neutrum  ;
  staell_nn_1_1_N = mkN "ställ" neutrum  ;
  staedskaap_nn_1_1_N = mkN "städskåp" neutrum  ;
  staedredskap_nn_1_1_N = mkN "städredskap" neutrum  ;
  staedgrael_nn_1_1_N = mkN "städgräl" neutrum  ;
  staedfynd_nn_1_1_N = mkN "städfynd" neutrum  ;
  staedbolag_nn_1_1_N = mkN "städbolag" neutrum  ;
  staed_nn_1_1_N = mkN "städ" neutrum  ;
  styvbarn_nn_1_N = mkN "styvbarn" neutrum  ;
  styrmedel_nn_1_N = mkN "styrmedel" neutrum  ;
  styrkeprov_nn_1_N = mkN "styrkeprov" neutrum  ;
  styrhjul_nn_1_N = mkN "styrhjul" neutrum  ;
  styrelseuppdrag_nn_1_N = mkN "styrelseuppdrag" neutrum  ;
  styng_nn_1_N = mkN "styng" neutrum  ;
  stygn_nn_1_N = mkN "stygn" neutrum  ;
  styckmord_nn_1_N = mkN "styckmord" neutrum  ;
  styckebruk_nn_1_N = mkN "styckebruk" neutrum  ;
  stuproer_nn_1_1_N = mkN "stuprör" neutrum  ;
  stup_nn_1_N = mkN "stup" neutrum  ;
  stunttrick_nn_1_N = mkN "stunttrick" neutrum  ;
  stugkoep_nn_1_1_N = mkN "stugköp" neutrum  ;
  stugfoenster_nn_1_1_N = mkN "stugfönster" neutrum  ;
  studiosamtal_nn_1_N = mkN "studiosamtal" neutrum  ;
  studieaar_nn_1_1_N = mkN "studieår" neutrum  ;
  studieobjekt_nn_1_N = mkN "studieobjekt" neutrum  ;
  studiemedel_nn_1_N = mkN "studiemedel" neutrum  ;
  studielaan_nn_1_1_N = mkN "studielån" neutrum  ;
  studiefoerbund_nn_1_1_N = mkN "studieförbund" neutrum  ;
  studiebidrag_nn_1_N = mkN "studiebidrag" neutrum  ;
  studiebesoek_nn_1_1_N = mkN "studiebesök" neutrum  ;
  studentflak_nn_1_N = mkN "studentflak" neutrum  ;
  studentbetyg_nn_1_N = mkN "studentbetyg" neutrum  ;
  stroevtaag_nn_1_1_N = mkN "strövtåg" neutrum  ;
  stroemuttag_nn_1_1_N = mkN "strömuttag" neutrum  ;
  stroemoln_nn_1_1_N = mkN "strömoln" neutrum  ;
  stroemhopp_nn_1_1_N = mkN "strömhopp" neutrum  ;
  stroemavbrott_nn_1_1_N = mkN "strömavbrott" neutrum  ;
  stroejobb_nn_1_1_N = mkN "ströjobb" neutrum  ;
  stroeg_nn_1_1_N = mkN "strög" neutrum  ;
  straalskyddsinstitut_nn_1_1_N = mkN "strålskyddsinstitut" neutrum  ;
  straaldjur_nn_1_1_N = mkN "stråldjur" neutrum  ;
  straalben_nn_1_1_N = mkN "strålben" neutrum  ;
  straakinstrument_nn_1_1_N = mkN "stråkinstrument" neutrum  ;
  straakdrag_nn_1_1_N = mkN "stråkdrag" neutrum  ;
  straak_nn_1_1_N = mkN "stråk" neutrum  ;
  straenginstrument_nn_1_1_N = mkN "stränginstrument" neutrum  ;
  straeckfoerband_nn_1_1_N = mkN "sträckförband" neutrum  ;
  straeck_nn_1_1_N = mkN "sträck" neutrum  ;
  strypgrepp_nn_1_N = mkN "strypgrepp" neutrum  ;
  strykjaern_nn_1_1_N = mkN "strykjärn" neutrum  ;
  strutsaegg_nn_1_1_N = mkN "strutsägg" neutrum  ;
  struplock_nn_1_N = mkN "struplock" neutrum  ;
  strupljud_nn_1_N = mkN "strupljud" neutrum  ;
  strumpeband_nn_1_N = mkN "strumpeband" neutrum  ;
  strofpar_nn_1_N = mkN "strofpar" neutrum  ;
  stroboskop_nn_1_N = mkN "stroboskop" neutrum  ;
  stridsvaern_nn_1_1_N = mkN "stridsvärn" neutrum  ;
  stridsvagnshinder_nn_1_N = mkN "stridsvagnshinder" neutrum  ;
  stridsrop_nn_1_N = mkN "stridsrop" neutrum  ;
  stridsmedel_nn_1_N = mkN "stridsmedel" neutrum  ;
  stridsledningsflygplan_nn_1_N = mkN "stridsledningsflygplan" neutrum  ;
  stridslarm_nn_1_N = mkN "stridslarm" neutrum  ;
  stridshorn_nn_1_N = mkN "stridshorn" neutrum  ;
  stridsflygplan_nn_1_N = mkN "stridsflygplan" neutrum  ;
  stridsflyg_nn_1_N = mkN "stridsflyg" neutrum  ;
  stressyndrom_nn_1_N = mkN "stressyndrom" neutrum  ;
  streck_nn_1_N = mkN "streck" neutrum  ;
  strategidokument_nn_1_N = mkN "strategidokument" neutrum  ;
  strandhugg_nn_1_N = mkN "strandhugg" neutrum  ;
  strandfynd_nn_1_N = mkN "strandfynd" neutrum  ;
  straffregister_nn_1_N = mkN "straffregister" neutrum  ;
  straffredskap_nn_1_N = mkN "straffredskap" neutrum  ;
  straff_nn_1_N = mkN "straff" neutrum  ;
  storverk_nn_1_N = mkN "storverk" neutrum  ;
  storstadsliv_nn_1_N = mkN "storstadsliv" neutrum  ;
  storskot_nn_1_N = mkN "storskot" neutrum  ;
  storsjoeodjur_nn_1_1_N = mkN "storsjöodjur" neutrum  ;
  stormtak_nn_1_N = mkN "stormtak" neutrum  ;
  stormningsanfall_nn_1_N = mkN "stormningsanfall" neutrum  ;
  stormhinder_nn_1_N = mkN "stormhinder" neutrum  ;
  stormgrael_nn_1_1_N = mkN "stormgräl" neutrum  ;
  storleksnummer_nn_1_N = mkN "storleksnummer" neutrum  ;
  storkoek_nn_1_1_N = mkN "storkök" neutrum  ;
  storkrig_nn_1_N = mkN "storkrig" neutrum  ;
  storhushaall_nn_1_1_N = mkN "storhushåll" neutrum  ;
  storgrael_nn_1_1_N = mkN "storgräl" neutrum  ;
  storfoeretag_nn_1_1_N = mkN "storföretag" neutrum  ;
  stordaad_nn_1_1_N = mkN "stordåd" neutrum  ;
  storbraak_nn_1_1_N = mkN "storbråk" neutrum  ;
  storbolag_nn_1_N = mkN "storbolag" neutrum  ;
  storband_nn_1_N = mkN "storband" neutrum  ;
  stoppur_nn_1_N = mkN "stoppur" neutrum  ;
  stopp_nn_1_N = mkN "stopp" neutrum  ;
  stop_nn_1_N = mkN "stop" neutrum  ;
  stolpskott_nn_1_N = mkN "stolpskott" neutrum  ;
  stolpiller_nn_1_N = mkN "stolpiller" neutrum  ;
  stoftmoln_nn_1_N = mkN "stoftmoln" neutrum  ;
  stoftkorn_nn_1_N = mkN "stoftkorn" neutrum  ;
  stoft_nn_1_N = mkN "stoft" neutrum  ;
  stjaernvalv_nn_1_1_N = mkN "stjärnvalv" neutrum  ;
  stjaernskott_nn_1_1_N = mkN "stjärnskott" neutrum  ;
  stjaernpar_nn_1_1_N = mkN "stjärnpar" neutrum  ;
  stjaernfallsregn_nn_1_1_N = mkN "stjärnfallsregn" neutrum  ;
  stjaernfall_nn_1_1_N = mkN "stjärnfall" neutrum  ;
  stjaernevalv_nn_1_1_N = mkN "stjärnevalv" neutrum  ;
  stjaerndygn_nn_1_1_N = mkN "stjärndygn" neutrum  ;
  stjaelkstygn_nn_1_1_N = mkN "stjälkstygn" neutrum  ;
  stinkdjur_nn_1_N = mkN "stinkdjur" neutrum  ;
  sting_nn_1_N = mkN "sting" neutrum  ;
  stimulanspaket_nn_1_N = mkN "stimulanspaket" neutrum  ;
  stilval_nn_1_N = mkN "stilval" neutrum  ;
  stillestaand_nn_1_1_N = mkN "stillestånd" neutrum  ;
  stilleben_nn_1_N = mkN "stilleben" neutrum  ;
  stildrag_nn_1_N = mkN "stildrag" neutrum  ;
  stilbrott_nn_1_N = mkN "stilbrott" neutrum  ;
  stift_nn_2_N = mkN "stift" neutrum  ;
  stift_nn_1_N = mkN "stift" neutrum  ;
  stickspaar_nn_1_1_N = mkN "stickspår" neutrum  ;
  stickprov_nn_1_N = mkN "stickprov" neutrum  ;
  stickord_nn_1_N = mkN "stickord" neutrum  ;
  stickelbaer_nn_1_1_N = mkN "stickelbär" neutrum  ;
  stick_nn_1_N = mkN "stick" neutrum  ;
  stetoskop_nn_1_N = mkN "stetoskop" neutrum  ;
  stereoskop_nn_1_N = mkN "stereoskop" neutrum  ;
  stenaaldersfynd_nn_1_1_N = mkN "stenåldersfynd" neutrum  ;
  stenverktyg_nn_1_N = mkN "stenverktyg" neutrum  ;
  stenskottsskydd_nn_1_N = mkN "stenskottsskydd" neutrum  ;
  stenskott_nn_1_N = mkN "stenskott" neutrum  ;
  stenkol_nn_1_N = mkN "stenkol" neutrum  ;
  stenhallon_nn_1_N = mkN "stenhallon" neutrum  ;
  stengolv_nn_1_N = mkN "stengolv" neutrum  ;
  stenbaer_nn_1_1_N = mkN "stenbär" neutrum  ;
  stenbrott_nn_1_N = mkN "stenbrott" neutrum  ;
  stenblock_nn_1_N = mkN "stenblock" neutrum  ;
  stekspett_nn_1_N = mkN "stekspett" neutrum  ;
  stek_nn_2_N = mkN "stek" neutrum  ;
  steg_nn_1_N = mkN "steg" neutrum  ;
  stavhopp_nn_1_N = mkN "stavhopp" neutrum  ;
  stavbrott_nn_1_N = mkN "stavbrott" neutrum  ;
  statsskick_nn_1_N = mkN "statsskick" neutrum  ;
  statsraad_nn_1_1_N = mkN "statsråd" neutrum  ;
  statspapper_nn_1_N = mkN "statspapper" neutrum  ;
  statsdepartement_nn_1_N = mkN "statsdepartement" neutrum  ;
  statsbidrag_nn_1_N = mkN "statsbidrag" neutrum  ;
  statsbesoek_nn_1_1_N = mkN "statsbesök" neutrum  ;
  statsanslag_nn_1_N = mkN "statsanslag" neutrum  ;
  stationsbefael_nn_1_1_N = mkN "stationsbefäl" neutrum  ;
  startspjaell_nn_1_1_N = mkN "startspjäll" neutrum  ;
  startskott_nn_1_N = mkN "startskott" neutrum  ;
  startskjut_nn_1_N = mkN "startskjut" neutrum  ;
  startfaelt_nn_1_1_N = mkN "startfält" neutrum  ;
  startblock_nn_1_N = mkN "startblock" neutrum  ;
  stannplan_nn_1_N = mkN "stannplan" neutrum  ;
  standardverk_nn_1_N = mkN "standardverk" neutrum  ;
  standardsvar_nn_1_N = mkN "standardsvar" neutrum  ;
  standardspraak_nn_1_1_N = mkN "standardspråk" neutrum  ;
  standardprov_nn_1_N = mkN "standardprov" neutrum  ;
  standardformulaer_nn_1_1_N = mkN "standardformulär" neutrum  ;
  standar_nn_1_N = mkN "standar" neutrum  ;
  stamspraak_nn_1_1_N = mkN "stamspråk" neutrum  ;
  stamp_nn_2_N = mkN "stamp" neutrum  ;
  stambord_nn_1_N = mkN "stambord" neutrum  ;
  stall_nn_2_N = mkN "stall" neutrum  ;
  staket_nn_1_N = mkN "staket" neutrum  ;
  stag_nn_1_N = mkN "stag" neutrum  ;
  stadsplanekontor_nn_1_N = mkN "stadsplanekontor" neutrum  ;
  stadshotell_nn_1_N = mkN "stadshotell" neutrum  ;
  stadsbyggnadskontor_nn_1_N = mkN "stadsbyggnadskontor" neutrum  ;
  stadsbyggnadsborgarraad_nn_1_1_N = mkN "stadsbyggnadsborgarråd" neutrum  ;
  stadsbud_nn_1_N = mkN "stadsbud" neutrum  ;
  stadsbibliotek_nn_1_N = mkN "stadsbibliotek" neutrum  ;
  stadsbesoek_nn_1_1_N = mkN "stadsbesök" neutrum  ;
  stadion_nn_1_N = mkN "stadion" neutrum  ;
  stackmoln_nn_1_N = mkN "stackmoln" neutrum  ;
  spoestraff_nn_1_1_N = mkN "spöstraff" neutrum  ;
  spoersmaal_nn_1_1_N = mkN "spörsmål" neutrum  ;
  spoekdjur_nn_1_1_N = mkN "spökdjur" neutrum  ;
  spaarelement_nn_1_1_N = mkN "spårelement" neutrum  ;
  spaar_nn_1_1_N = mkN "spår" neutrum  ;
  spaan_nn_1_1_N = mkN "spån" neutrum  ;
  spaennband_nn_1_1_N = mkN "spännband" neutrum  ;
  spaedbarn_nn_1_1_N = mkN "spädbarn" neutrum  ;
  spygatt_nn_1_N = mkN "spygatt" neutrum  ;
  sproet_nn_1_1_N = mkN "spröt" neutrum  ;
  spraang_nn_1_1_N = mkN "språng" neutrum  ;
  spraakroer_nn_1_1_N = mkN "språkrör" neutrum  ;
  spraakprov_nn_1_1_N = mkN "språkprov" neutrum  ;
  spraakmoenster_nn_1_1_N = mkN "språkmönster" neutrum  ;
  spraakljud_nn_1_1_N = mkN "språkljud" neutrum  ;
  spraakbraak_nn_1_1_N = mkN "språkbråk" neutrum  ;
  spraak_nn_1_1_N = mkN "språk" neutrum  ;
  spraengstoff_nn_1_1_N = mkN "sprängstoff" neutrum  ;
  spraengmedel_nn_1_1_N = mkN "sprängmedel" neutrum  ;
  spraengdaad_nn_1_1_N = mkN "sprängdåd" neutrum  ;
  spraengattentat_nn_1_1_N = mkN "sprängattentat" neutrum  ;
  sprut_nn_1_N = mkN "sprut" neutrum  ;
  sprund_nn_1_N = mkN "sprund" neutrum  ;
  spritkoek_nn_1_1_N = mkN "spritkök" neutrum  ;
  springpojksjobb_nn_1_N = mkN "springpojksjobb" neutrum  ;
  springardrag_nn_1_N = mkN "springardrag" neutrum  ;
  spring_nn_2_N = mkN "spring" neutrum  ;
  spridningsmaatt_nn_1_1_N = mkN "spridningsmått" neutrum  ;
  spratt_nn_1_N = mkN "spratt" neutrum  ;
  sportlov_nn_1_N = mkN "sportlov" neutrum  ;
  sportflygplan_nn_1_N = mkN "sportflygplan" neutrum  ;
  spordjur_nn_1_N = mkN "spordjur" neutrum  ;
  splittersaar_nn_1_1_N = mkN "splittersår" neutrum  ;
  spjaellband_nn_1_1_N = mkN "spjällband" neutrum  ;
  spjaell_nn_1_1_N = mkN "spjäll" neutrum  ;
  spjut_nn_1_N = mkN "spjut" neutrum  ;
  spiralblock_nn_1_N = mkN "spiralblock" neutrum  ;
  spionfall_nn_1_N = mkN "spionfall" neutrum  ;
  spinnkvalster_nn_1_N = mkN "spinnkvalster" neutrum  ;
  spindelnaet_nn_1_1_N = mkN "spindelnät" neutrum  ;
  spindeldjur_nn_1_N = mkN "spindeldjur" neutrum  ;
  spikband_nn_1_N = mkN "spikband" neutrum  ;
  spikattentat_nn_1_N = mkN "spikattentat" neutrum  ;
  spett_nn_1_N = mkN "spett" neutrum  ;
  spenabarn_nn_1_N = mkN "spenabarn" neutrum  ;
  spelaar_nn_1_1_N = mkN "spelår" neutrum  ;
  spelverk_nn_1_N = mkN "spelverk" neutrum  ;
  spelprov_nn_1_N = mkN "spelprov" neutrum  ;
  spelkort_nn_1_N = mkN "spelkort" neutrum  ;
  spelbord_nn_1_N = mkN "spelbord" neutrum  ;
  spel_nn_1_N = mkN "spel" neutrum  ;
  spektroskop_nn_1_N = mkN "spektroskop" neutrum  ;
  spegelteleskop_nn_1_N = mkN "spegelteleskop" neutrum  ;
  species_nn_1_N = mkN "species" neutrum  ;
  specialtaag_nn_1_1_N = mkN "specialtåg" neutrum  ;
  specialtillstaand_nn_1_1_N = mkN "specialtillstånd" neutrum  ;
  specialnummer_nn_1_N = mkN "specialnummer" neutrum  ;
  sparpaket_nn_1_N = mkN "sparpaket" neutrum  ;
  sparlaan_nn_1_1_N = mkN "sparlån" neutrum  ;
  sparlakan_nn_1_N = mkN "sparlakan" neutrum  ;
  sparkrav_nn_1_N = mkN "sparkrav" neutrum  ;
  sparknummer_nn_1_N = mkN "sparknummer" neutrum  ;
  sparbeting_nn_1_N = mkN "sparbeting" neutrum  ;
  spant_nn_1_N = mkN "spant" neutrum  ;
  spanskroer_nn_1_1_N = mkN "spanskrör" neutrum  ;
  spann_nn_3_N = mkN "spann" neutrum  ;
  spaningsuppdrag_nn_1_N = mkN "spaningsuppdrag" neutrum  ;
  spaningsplan_nn_1_N = mkN "spaningsplan" neutrum  ;
  spaningsmord_nn_1_N = mkN "spaningsmord" neutrum  ;
  spaningsflyg_nn_1_N = mkN "spaningsflyg" neutrum  ;
  spaltkorrektur_nn_1_N = mkN "spaltkorrektur" neutrum  ;
  spakblock_nn_1_N = mkN "spakblock" neutrum  ;
  spadtag_nn_1_N = mkN "spadtag" neutrum  ;
  sovrumsfoenster_nn_1_1_N = mkN "sovrumsfönster" neutrum  ;
  souterraengplan_nn_1_1_N = mkN "souterrängplan" neutrum  ;
  souterrainplan_nn_1_N = mkN "souterrainplan" neutrum  ;
  sound_nn_1_N = mkN "sound" neutrum  ;
  soulagemang_nn_1_N = mkN "soulagemang" neutrum  ;
  sotskikt_nn_1_N = mkN "sotskikt" neutrum  ;
  sotmoln_nn_1_N = mkN "sotmoln" neutrum  ;
  sortiment_nn_1_N = mkN "sortiment" neutrum  ;
  sorteringsverk_nn_1_N = mkN "sorteringsverk" neutrum  ;
  sorgflor_nn_1_N = mkN "sorgflor" neutrum  ;
  sorgeaar_nn_1_1_N = mkN "sorgeår" neutrum  ;
  sorgebud_nn_1_N = mkN "sorgebud" neutrum  ;
  sorgebarn_nn_1_N = mkN "sorgebarn" neutrum  ;
  sorgbarn_nn_1_N = mkN "sorgbarn" neutrum  ;
  sorgband_nn_1_N = mkN "sorgband" neutrum  ;
  soppkoek_nn_1_1_N = mkN "soppkök" neutrum  ;
  sopberg_nn_1_N = mkN "sopberg" neutrum  ;
  sonnamn_nn_1_N = mkN "sonnamn" neutrum  ;
  sommarvaeder_nn_1_1_N = mkN "sommarväder" neutrum  ;
  sommartorp_nn_1_N = mkN "sommartorp" neutrum  ;
  sommarregn_nn_1_N = mkN "sommarregn" neutrum  ;
  sommarmoln_nn_1_N = mkN "sommarmoln" neutrum  ;
  sommarlaeger_nn_1_1_N = mkN "sommarläger" neutrum  ;
  sommarlov_nn_1_N = mkN "sommarlov" neutrum  ;
  sommarland_nn_1_N = mkN "sommarland" neutrum  ;
  sommarjobb_nn_1_N = mkN "sommarjobb" neutrum  ;
  sommarhalvaar_nn_1_1_N = mkN "sommarhalvår" neutrum  ;
  sommargyllen_nn_1_N = mkN "sommargyllen" neutrum  ;
  sommardaeck_nn_1_1_N = mkN "sommardäck" neutrum  ;
  sommarbarn_nn_1_N = mkN "sommarbarn" neutrum  ;
  solaar_nn_1_1_N = mkN "solår" neutrum  ;
  solvarv_nn_1_N = mkN "solvarv" neutrum  ;
  solv_nn_1_N = mkN "solv" neutrum  ;
  solur_nn_1_N = mkN "solur" neutrum  ;
  soltak_nn_1_N = mkN "soltak" neutrum  ;
  solskyddsmedel_nn_1_N = mkN "solskyddsmedel" neutrum  ;
  solskydd_nn_1_N = mkN "solskydd" neutrum  ;
  solskensvaeder_nn_1_1_N = mkN "solskensväder" neutrum  ;
  solmaal_nn_1_1_N = mkN "solmål" neutrum  ;
  solklipp_nn_1_N = mkN "solklipp" neutrum  ;
  solhjul_nn_1_N = mkN "solhjul" neutrum  ;
  solfall_nn_1_N = mkN "solfall" neutrum  ;
  soldygn_nn_1_N = mkN "soldygn" neutrum  ;
  soldattorp_nn_1_N = mkN "soldattorp" neutrum  ;
  soldatnamn_nn_1_N = mkN "soldatnamn" neutrum  ;
  solbad_nn_1_N = mkN "solbad" neutrum  ;
  sofflock_nn_1_N = mkN "sofflock" neutrum  ;
  soffbord_nn_1_N = mkN "soffbord" neutrum  ;
  sockeroeverdrag_nn_1_1_N = mkN "sockeröverdrag" neutrum  ;
  sockerroer_nn_1_1_N = mkN "sockerrör" neutrum  ;
  sockerpiller_nn_1_N = mkN "sockerpiller" neutrum  ;
  sockergryn_nn_1_N = mkN "sockergryn" neutrum  ;
  sockerbruk_nn_1_N = mkN "sockerbruk" neutrum  ;
  sockenbud_nn_1_N = mkN "sockenbud" neutrum  ;
  societetslejon_nn_1_N = mkN "societetslejon" neutrum  ;
  socialregister_nn_1_N = mkN "socialregister" neutrum  ;
  socialfoersaekringsutskott_nn_1_1_N = mkN "socialförsäkringsutskott" neutrum  ;
  socialfall_nn_1_N = mkN "socialfall" neutrum  ;
  socialbidrag_nn_1_N = mkN "socialbidrag" neutrum  ;
  snoestaket_nn_1_1_N = mkN "snöstaket" neutrum  ;
  snoeskred_nn_1_1_N = mkN "snöskred" neutrum  ;
  snoerliv_nn_1_1_N = mkN "snörliv" neutrum  ;
  snoeredskap_nn_1_1_N = mkN "snöredskap" neutrum  ;
  snoeovaeder_nn_1_1_N = mkN "snöoväder" neutrum  ;
  snoelandskap_nn_1_1_N = mkN "snölandskap" neutrum  ;
  snoeklot_nn_1_1_N = mkN "snöklot" neutrum  ;
  snoefjaell_nn_1_1_N = mkN "snöfjäll" neutrum  ;
  snoefall_nn_1_1_N = mkN "snöfall" neutrum  ;
  snoedjup_nn_1_1_N = mkN "snödjup" neutrum  ;
  snoebaer_nn_1_1_N = mkN "snöbär" neutrum  ;
  snoebollskrig_nn_1_1_N = mkN "snöbollskrig" neutrum  ;
  snaar_nn_1_1_N = mkN "snår" neutrum  ;
  snaerp_nn_2_1_N = mkN "snärp" neutrum  ;
  snaerj_nn_2_1_N = mkN "snärj" neutrum  ;
  snaepplock_nn_1_1_N = mkN "snäpplock" neutrum  ;
  snaepp_nn_1_1_N = mkN "snäpp" neutrum  ;
  snaelltaag_nn_1_1_N = mkN "snälltåg" neutrum  ;
  snaeckskal_nn_1_1_N = mkN "snäckskal" neutrum  ;
  snaeckhjul_nn_1_1_N = mkN "snäckhjul" neutrum  ;
  snaeckdjur_nn_1_1_N = mkN "snäckdjur" neutrum  ;
  snyft_nn_1_N = mkN "snyft" neutrum  ;
  snittbetyg_nn_1_N = mkN "snittbetyg" neutrum  ;
  snitt_nn_1_N = mkN "snitt" neutrum  ;
  snilleverk_nn_1_N = mkN "snilleverk" neutrum  ;
  snilleprov_nn_1_N = mkN "snilleprov" neutrum  ;
  snillefoster_nn_1_N = mkN "snillefoster" neutrum  ;
  snilledrag_nn_1_N = mkN "snilledrag" neutrum  ;
  snickarverktyg_nn_1_N = mkN "snickarverktyg" neutrum  ;
  snedtak_nn_1_N = mkN "snedtak" neutrum  ;
  snedstreck_nn_1_N = mkN "snedstreck" neutrum  ;
  snedsteg_nn_1_N = mkN "snedsteg" neutrum  ;
  snedspraang_nn_1_1_N = mkN "snedsprång" neutrum  ;
  snabbtaag_nn_1_1_N = mkN "snabbtåg" neutrum  ;
  snabbstopp_nn_1_N = mkN "snabbstopp" neutrum  ;
  snabbprotokoll_nn_1_N = mkN "snabbprotokoll" neutrum  ;
  snabbportraett_nn_1_1_N = mkN "snabbporträtt" neutrum  ;
  snabbkoep_nn_1_1_N = mkN "snabbköp" neutrum  ;
  snabbfoerband_nn_1_1_N = mkN "snabbförband" neutrum  ;
  smoerjmedel_nn_1_1_N = mkN "smörjmedel" neutrum  ;
  smoerjhaal_nn_1_1_N = mkN "smörjhål" neutrum  ;
  smoergaaspaalaegg_nn_1_1_N = mkN "smörgåspålägg" neutrum  ;
  smoergaasbord_nn_1_1_N = mkN "smörgåsbord" neutrum  ;
  smoerberg_nn_1_1_N = mkN "smörberg" neutrum  ;
  smaapaket_nn_1_1_N = mkN "småpaket" neutrum  ;
  smaaord_nn_1_1_N = mkN "småord" neutrum  ;
  smaamynt_nn_1_1_N = mkN "småmynt" neutrum  ;
  smaakryp_nn_1_1_N = mkN "småkryp" neutrum  ;
  smaajordbruk_nn_1_1_N = mkN "småjordbruk" neutrum  ;
  smaahuslaan_nn_1_1_N = mkN "småhuslån" neutrum  ;
  smaagrael_nn_1_1_N = mkN "smågräl" neutrum  ;
  smaafoeretag_nn_1_1_N = mkN "småföretag" neutrum  ;
  smaaflin_nn_1_1_N = mkN "småflin" neutrum  ;
  smaadjur_nn_1_1_N = mkN "smådjur" neutrum  ;
  smaabruk_nn_1_1_N = mkN "småbruk" neutrum  ;
  smaabarnsaar_nn_1_1_N = mkN "småbarnsår" neutrum  ;
  smaabarnsliv_nn_1_1_N = mkN "småbarnsliv" neutrum  ;
  smaabarn_nn_1_1_N = mkN "småbarn" neutrum  ;
  smaerttillstaand_nn_1_1_N = mkN "smärttillstånd" neutrum  ;
  smaeltverk_nn_1_1_N = mkN "smältverk" neutrum  ;
  smaeltskydd_nn_1_1_N = mkN "smältskydd" neutrum  ;
  smaedeord_nn_1_1_N = mkN "smädeord" neutrum  ;
  smaedenamn_nn_1_1_N = mkN "smädenamn" neutrum  ;
  smyghaal_nn_1_1_N = mkN "smyghål" neutrum  ;
  smyckegarnityr_nn_1_N = mkN "smyckegarnityr" neutrum  ;
  smutsblad_nn_1_N = mkN "smutsblad" neutrum  ;
  smultron_nn_1_N = mkN "smultron" neutrum  ;
  smugglingsbrott_nn_1_N = mkN "smugglingsbrott" neutrum  ;
  smugglarskepp_nn_1_N = mkN "smugglarskepp" neutrum  ;
  smil_nn_1_N = mkN "smil" neutrum  ;
  smidesverktyg_nn_1_N = mkN "smidesverktyg" neutrum  ;
  smekord_nn_1_N = mkN "smekord" neutrum  ;
  smeknamn_nn_1_N = mkN "smeknamn" neutrum  ;
  smaldjur_nn_1_N = mkN "smaldjur" neutrum  ;
  smalben_nn_1_N = mkN "smalben" neutrum  ;
  smakraad_nn_1_1_N = mkN "smakråd" neutrum  ;
  sloer_nn_2_1_N = mkN "slör" neutrum  ;
  sloejmoln_nn_1_1_N = mkN "slöjmoln" neutrum  ;
  slaanbaer_nn_1_1_N = mkN "slånbär" neutrum  ;
  slaepp_nn_1_1_N = mkN "släpp" neutrum  ;
  slaep_nn_1_1_N = mkN "släp" neutrum  ;
  slaengskott_nn_1_1_N = mkN "slängskott" neutrum  ;
  slaektregister_nn_1_1_N = mkN "släktregister" neutrum  ;
  slaektportraett_nn_1_1_N = mkN "släktporträtt" neutrum  ;
  slaektnamn_nn_1_1_N = mkN "släktnamn" neutrum  ;
  slaektled_nn_1_1_N = mkN "släktled" neutrum  ;
  slaektdrag_nn_1_1_N = mkN "släktdrag" neutrum  ;
  slaektbesoek_nn_1_1_N = mkN "släktbesök" neutrum  ;
  slaektband_nn_1_1_N = mkN "släktband" neutrum  ;
  slaeddon_nn_1_1_N = mkN "släddon" neutrum  ;
  slutstreck_nn_1_N = mkN "slutstreck" neutrum  ;
  slutsteg_nn_1_N = mkN "slutsteg" neutrum  ;
  slutresultat_nn_1_N = mkN "slutresultat" neutrum  ;
  slutprov_nn_1_N = mkN "slutprov" neutrum  ;
  slutmaal_nn_1_1_N = mkN "slutmål" neutrum  ;
  slutljud_nn_1_N = mkN "slutljud" neutrum  ;
  slutfall_nn_1_N = mkN "slutfall" neutrum  ;
  slut_nn_1_N = mkN "slut" neutrum  ;
  slumpurval_nn_1_N = mkN "slumpurval" neutrum  ;
  slumptal_nn_1_N = mkN "slumptal" neutrum  ;
  slott_nn_1_N = mkN "slott" neutrum  ;
  slitskydd_nn_1_N = mkN "slitskydd" neutrum  ;
  slitlager_nn_1_N = mkN "slitlager" neutrum  ;
  slirskydd_nn_1_N = mkN "slirskydd" neutrum  ;
  slipsval_nn_1_N = mkN "slipsval" neutrum  ;
  slipsnitt_nn_1_N = mkN "slipsnitt" neutrum  ;
  slipresultat_nn_1_N = mkN "slipresultat" neutrum  ;
  slippapper_nn_1_N = mkN "slippapper" neutrum  ;
  slipmedel_nn_1_N = mkN "slipmedel" neutrum  ;
  slingerskott_nn_1_N = mkN "slingerskott" neutrum  ;
  slingerbord_nn_1_N = mkN "slingerbord" neutrum  ;
  sling_nn_1_N = mkN "sling" neutrum  ;
  slinder_nn_1_N = mkN "slinder" neutrum  ;
  slidhornsdjur_nn_1_N = mkN "slidhornsdjur" neutrum  ;
  slavuppror_nn_1_N = mkN "slavuppror" neutrum  ;
  slavlaeger_nn_1_1_N = mkN "slavläger" neutrum  ;
  slavarbetslaeger_nn_1_1_N = mkN "slavarbetsläger" neutrum  ;
  slangspraak_nn_1_1_N = mkN "slangspråk" neutrum  ;
  slaktdjur_nn_1_N = mkN "slaktdjur" neutrum  ;
  slagverk_nn_1_N = mkN "slagverk" neutrum  ;
  slagsvaerd_nn_1_1_N = mkN "slagsvärd" neutrum  ;
  slagstift_nn_1_N = mkN "slagstift" neutrum  ;
  slagsmaal_nn_1_1_N = mkN "slagsmål" neutrum  ;
  slagskepp_nn_1_N = mkN "slagskepp" neutrum  ;
  slagregn_nn_1_N = mkN "slagregn" neutrum  ;
  slagord_nn_1_N = mkN "slagord" neutrum  ;
  slagnummer_nn_1_N = mkN "slagnummer" neutrum  ;
  slaginstrument_nn_1_N = mkN "slaginstrument" neutrum  ;
  slagfaelt_nn_1_1_N = mkN "slagfält" neutrum  ;
  slagbord_nn_1_N = mkN "slagbord" neutrum  ;
  slaganfall_nn_1_N = mkN "slaganfall" neutrum  ;
  slag_nn_1_N = mkN "slag" neutrum  ;
  sladdbarn_nn_1_N = mkN "sladdbarn" neutrum  ;
  skoetebarn_nn_1_1_N = mkN "skötebarn" neutrum  ;
  skoetbord_nn_1_1_N = mkN "skötbord" neutrum  ;
  skoert_nn_1_1_N = mkN "skört" neutrum  ;
  skoenhetsmedel_nn_1_1_N = mkN "skönhetsmedel" neutrum  ;
  skoenhetsideal_nn_1_1_N = mkN "skönhetsideal" neutrum  ;
  skoenhetsfoeretag_nn_1_1_N = mkN "skönhetsföretag" neutrum  ;
  skoeldebrev_nn_1_1_N = mkN "sköldebrev" neutrum  ;
  skaar_nn_1_1_N = mkN "skår" neutrum  ;
  skaap_nn_1_1_N = mkN "skåp" neutrum  ;
  skaalpund_nn_1_1_N = mkN "skålpund" neutrum  ;
  skaadespelarpar_nn_1_1_N = mkN "skådespelarpar" neutrum  ;
  skaademynt_nn_1_1_N = mkN "skådemynt" neutrum  ;
  skaerpedjup_nn_1_1_N = mkN "skärpedjup" neutrum  ;
  skaerp_nn_1_1_N = mkN "skärp" neutrum  ;
  skaer_nn_1_1_N = mkN "skär" neutrum  ;
  skaemt_nn_1_1_N = mkN "skämt" neutrum  ;
  skaellsord_nn_1_1_N = mkN "skällsord" neutrum  ;
  skael_nn_1_1_N = mkN "skäl" neutrum  ;
  skaegg_nn_1_1_N = mkN "skägg" neutrum  ;
  skyttevaern_nn_1_1_N = mkN "skyttevärn" neutrum  ;
  skyttegravskrig_nn_1_N = mkN "skyttegravskrig" neutrum  ;
  skymford_nn_1_N = mkN "skymford" neutrum  ;
  skyltskaap_nn_1_1_N = mkN "skyltskåp" neutrum  ;
  skyltfoenster_nn_1_1_N = mkN "skyltfönster" neutrum  ;
  skylight_nn_1_N = mkN "skylight" neutrum  ;
  skyfall_nn_1_N = mkN "skyfall" neutrum  ;
  skydrag_nn_1_N = mkN "skydrag" neutrum  ;
  skyddsoeverdrag_nn_1_1_N = mkN "skyddsöverdrag" neutrum  ;
  skyddsvaern_nn_1_1_N = mkN "skyddsvärn" neutrum  ;
  skyddstak_nn_1_N = mkN "skyddstak" neutrum  ;
  skyddspapper_nn_1_N = mkN "skyddspapper" neutrum  ;
  skyddsombud_nn_1_N = mkN "skyddsombud" neutrum  ;
  skyddsnaet_nn_1_1_N = mkN "skyddsnät" neutrum  ;
  skyddsmedel_nn_1_N = mkN "skyddsmedel" neutrum  ;
  skyddslock_nn_1_N = mkN "skyddslock" neutrum  ;
  skyddshelgon_nn_1_N = mkN "skyddshelgon" neutrum  ;
  skydd_nn_2_N = mkN "skydd" neutrum  ;
  skvallerdrev_nn_1_N = mkN "skvallerdrev" neutrum  ;
  skvallerbaer_nn_1_1_N = mkN "skvallerbär" neutrum  ;
  skutt_nn_1_N = mkN "skutt" neutrum  ;
  skurpulver_nn_1_N = mkN "skurpulver" neutrum  ;
  skurmedel_nn_1_N = mkN "skurmedel" neutrum  ;
  skurlov_nn_1_N = mkN "skurlov" neutrum  ;
  skurkstreck_nn_1_N = mkN "skurkstreck" neutrum  ;
  skurgolv_nn_1_N = mkN "skurgolv" neutrum  ;
  skuramedel_nn_1_N = mkN "skuramedel" neutrum  ;
  skunkdjur_nn_1_N = mkN "skunkdjur" neutrum  ;
  skumbad_nn_1_N = mkN "skumbad" neutrum  ;
  skulderblad_nn_1_N = mkN "skulderblad" neutrum  ;
  skuldebrev_nn_1_N = mkN "skuldebrev" neutrum  ;
  skuldbelopp_nn_1_N = mkN "skuldbelopp" neutrum  ;
  skuggkabinett_nn_1_N = mkN "skuggkabinett" neutrum  ;
  skubb_nn_1_N = mkN "skubb" neutrum  ;
  skraal_nn_1_1_N = mkN "skrål" neutrum  ;
  skraepplockningsspjut_nn_1_1_N = mkN "skräpplockningsspjut" neutrum  ;
  skraen_nn_1_1_N = mkN "skrän" neutrum  ;
  skraemskott_nn_1_1_N = mkN "skrämskott" neutrum  ;
  skraeckkabinett_nn_1_1_N = mkN "skräckkabinett" neutrum  ;
  skrymt_nn_1_N = mkN "skrymt" neutrum  ;
  skruvstaed_nn_1_1_N = mkN "skruvstäd" neutrum  ;
  skruvhaal_nn_1_1_N = mkN "skruvhål" neutrum  ;
  skruvfoerband_nn_1_1_N = mkN "skruvförband" neutrum  ;
  skruvavstaand_nn_1_1_N = mkN "skruvavstånd" neutrum  ;
  skrubbsaar_nn_1_1_N = mkN "skrubbsår" neutrum  ;
  skrovmaal_nn_1_1_N = mkN "skrovmål" neutrum  ;
  skrov_nn_1_N = mkN "skrov" neutrum  ;
  skrotupplag_nn_1_N = mkN "skrotupplag" neutrum  ;
  skrivaar_nn_1_1_N = mkN "skrivår" neutrum  ;
  skrivunderlaegg_nn_1_1_N = mkN "skrivunderlägg" neutrum  ;
  skrivsaett_nn_1_1_N = mkN "skrivsätt" neutrum  ;
  skrivplaan_nn_1_1_N = mkN "skrivplån" neutrum  ;
  skrivmaskinsbord_nn_1_N = mkN "skrivmaskinsbord" neutrum  ;
  skrivbordsunderlaegg_nn_1_1_N = mkN "skrivbordsunderlägg" neutrum  ;
  skrivbordsjobb_nn_1_N = mkN "skrivbordsjobb" neutrum  ;
  skrivbord_nn_1_N = mkN "skrivbord" neutrum  ;
  skrivblock_nn_1_N = mkN "skrivblock" neutrum  ;
  skrivarpapper_nn_1_N = mkN "skrivarpapper" neutrum  ;
  skrin_nn_1_N = mkN "skrin" neutrum  ;
  skrik_nn_1_N = mkN "skrik" neutrum  ;
  skriftspraak_nn_1_1_N = mkN "skriftspråk" neutrum  ;
  skriftermaal_nn_1_1_N = mkN "skriftermål" neutrum  ;
  skrev_nn_1_N = mkN "skrev" neutrum  ;
  skred_nn_1_N = mkN "skred" neutrum  ;
  skrattpaalaegg_nn_1_1_N = mkN "skrattpålägg" neutrum  ;
  skratt_nn_1_N = mkN "skratt" neutrum  ;
  skrapsaar_nn_1_1_N = mkN "skrapsår" neutrum  ;
  skrapfaelt_nn_1_1_N = mkN "skrapfält" neutrum  ;
  skrank_nn_1_N = mkN "skrank" neutrum  ;
  skovelhjul_nn_1_N = mkN "skovelhjul" neutrum  ;
  skov_nn_1_N = mkN "skov" neutrum  ;
  skottaar_nn_1_1_N = mkN "skottår" neutrum  ;
  skottkaerrehjul_nn_1_1_N = mkN "skottkärrehjul" neutrum  ;
  skotthaal_nn_1_1_N = mkN "skotthål" neutrum  ;
  skottfaelt_nn_1_1_N = mkN "skottfält" neutrum  ;
  skott_nn_1_N = mkN "skott" neutrum  ;
  skotstek_nn_1_N = mkN "skotstek" neutrum  ;
  skothorn_nn_1_N = mkN "skothorn" neutrum  ;
  skot_nn_1_N = mkN "skot" neutrum  ;
  skonummer_nn_1_N = mkN "skonummer" neutrum  ;
  skonertskepp_nn_1_N = mkN "skonertskepp" neutrum  ;
  skolaar_nn_1_1_N = mkN "skolår" neutrum  ;
  skolskepp_nn_1_N = mkN "skolskepp" neutrum  ;
  skolraad_nn_1_1_N = mkN "skolråd" neutrum  ;
  skolprov_nn_1_N = mkN "skolprov" neutrum  ;
  skolmognadsprov_nn_1_N = mkN "skolmognadsprov" neutrum  ;
  skollov_nn_1_N = mkN "skollov" neutrum  ;
  skolkoek_nn_1_1_N = mkN "skolkök" neutrum  ;
  skolkort_nn_1_N = mkN "skolkort" neutrum  ;
  skolflygplan_nn_1_N = mkN "skolflygplan" neutrum  ;
  skolfartyg_nn_1_N = mkN "skolfartyg" neutrum  ;
  skoldistrikt_nn_1_N = mkN "skoldistrikt" neutrum  ;
  skolbetyg_nn_1_N = mkN "skolbetyg" neutrum  ;
  skolbarn_nn_1_N = mkN "skolbarn" neutrum  ;
  skoj_nn_1_N = mkN "skoj" neutrum  ;
  skohorn_nn_1_N = mkN "skohorn" neutrum  ;
  skogslandskap_nn_1_N = mkN "skogslandskap" neutrum  ;
  skogsbolag_nn_1_N = mkN "skogsbolag" neutrum  ;
  skodon_nn_1_N = mkN "skodon" neutrum  ;
  skoblock_nn_1_N = mkN "skoblock" neutrum  ;
  skjutshaall_nn_1_1_N = mkN "skjutshåll" neutrum  ;
  skjutmaattset_nn_1_1_N = mkN "skjutmåttset" neutrum  ;
  skjutmaatt_nn_1_1_N = mkN "skjutmått" neutrum  ;
  skjutjaern_nn_1_1_N = mkN "skjutjärn" neutrum  ;
  skjutfoenster_nn_1_1_N = mkN "skjutfönster" neutrum  ;
  skjutfaelt_nn_1_1_N = mkN "skjutfält" neutrum  ;
  skjut_nn_1_N = mkN "skjut" neutrum  ;
  skjul_nn_1_N = mkN "skjul" neutrum  ;
  skivomslag_nn_1_N = mkN "skivomslag" neutrum  ;
  skivkontrakt_nn_1_N = mkN "skivkontrakt" neutrum  ;
  skivbolag_nn_1_N = mkN "skivbolag" neutrum  ;
  skitaar_nn_1_1_N = mkN "skitår" neutrum  ;
  skissblock_nn_1_N = mkN "skissblock" neutrum  ;
  skioptikon_nn_1_N = mkN "skioptikon" neutrum  ;
  skinnband_nn_1_N = mkN "skinnband" neutrum  ;
  skinn_nn_1_N = mkN "skinn" neutrum  ;
  skingringsfoerbud_nn_1_1_N = mkN "skingringsförbud" neutrum  ;
  skilsmaessopapper_nn_1_1_N = mkN "skilsmässopapper" neutrum  ;
  skilsmaessobarn_nn_1_1_N = mkN "skilsmässobarn" neutrum  ;
  skillingtryck_nn_1_N = mkN "skillingtryck" neutrum  ;
  skiljeset_nn_1_N = mkN "skiljeset" neutrum  ;
  skiljemynt_nn_1_N = mkN "skiljemynt" neutrum  ;
  skiktmoln_nn_1_N = mkN "skiktmoln" neutrum  ;
  skikt_nn_1_N = mkN "skikt" neutrum  ;
  skift_nn_1_N = mkN "skift" neutrum  ;
  skiffertak_nn_1_N = mkN "skiffertak" neutrum  ;
  skidspaar_nn_1_1_N = mkN "skidspår" neutrum  ;
  skidfynd_nn_1_N = mkN "skidfynd" neutrum  ;
  skickebud_nn_1_N = mkN "skickebud" neutrum  ;
  skick_nn_1_N = mkN "skick" neutrum  ;
  skevroder_nn_1_N = mkN "skevroder" neutrum  ;
  skevningsroder_nn_1_N = mkN "skevningsroder" neutrum  ;
  skeppund_nn_1_N = mkN "skeppund" neutrum  ;
  skeppsvarv_nn_1_N = mkN "skeppsvarv" neutrum  ;
  skeppslag_nn_1_N = mkN "skeppslag" neutrum  ;
  skeppsbrott_nn_1_N = mkN "skeppsbrott" neutrum  ;
  skeppsapotek_nn_1_N = mkN "skeppsapotek" neutrum  ;
  skepparbrev_nn_1_N = mkN "skepparbrev" neutrum  ;
  skepp_nn_1_N = mkN "skepp" neutrum  ;
  skenaektenskap_nn_1_1_N = mkN "skenäktenskap" neutrum  ;
  skenben_nn_1_N = mkN "skenben" neutrum  ;
  sken_nn_1_N = mkN "sken" neutrum  ;
  skelett_nn_1_N = mkN "skelett" neutrum  ;
  skeddrag_nn_1_N = mkN "skeddrag" neutrum  ;
  skavsaar_nn_1_1_N = mkN "skavsår" neutrum  ;
  skavskydd_nn_1_N = mkN "skavskydd" neutrum  ;
  skatteverk_nn_1_N = mkN "skatteverk" neutrum  ;
  skatteuttag_nn_1_N = mkN "skatteuttag" neutrum  ;
  skatteuppskov_nn_1_N = mkN "skatteuppskov" neutrum  ;
  skatteunderlag_nn_1_N = mkN "skatteunderlag" neutrum  ;
  skattetryck_nn_1_N = mkN "skattetryck" neutrum  ;
  skattetillaegg_nn_1_1_N = mkN "skattetillägg" neutrum  ;
  skattetak_nn_1_N = mkN "skattetak" neutrum  ;
  skattemedel_nn_1_N = mkN "skattemedel" neutrum  ;
  skattekort_nn_1_N = mkN "skattekort" neutrum  ;
  skattefoerslag_nn_1_1_N = mkN "skatteförslag" neutrum  ;
  skattebrott_nn_1_N = mkN "skattebrott" neutrum  ;
  skattebelopp_nn_1_N = mkN "skattebelopp" neutrum  ;
  skatteavdrag_nn_1_N = mkN "skatteavdrag" neutrum  ;
  skarndaeck_nn_1_1_N = mkN "skarndäck" neutrum  ;
  skarn_nn_1_N = mkN "skarn" neutrum  ;
  skap_nn_1_N = mkN "skap" neutrum  ;
  skandalmaal_nn_1_1_N = mkN "skandalmål" neutrum  ;
  skamgrepp_nn_1_N = mkN "skamgrepp" neutrum  ;
  skalv_nn_1_N = mkN "skalv" neutrum  ;
  skalstreck_nn_1_N = mkN "skalstreck" neutrum  ;
  skallben_nn_1_N = mkN "skallben" neutrum  ;
  skall_nn_1_N = mkN "skall" neutrum  ;
  skalkorn_nn_1_N = mkN "skalkorn" neutrum  ;
  skalkeskjul_nn_1_N = mkN "skalkeskjul" neutrum  ;
  skaldjur_nn_1_N = mkN "skaldjur" neutrum  ;
  skal_nn_1_N = mkN "skal" neutrum  ;
  skak_nn_1_N = mkN "skak" neutrum  ;
  skaft_nn_1_N = mkN "skaft" neutrum  ;
  skadestaand_nn_1_1_N = mkN "skadestånd" neutrum  ;
  skadedjur_nn_1_N = mkN "skadedjur" neutrum  ;
  skabbdjur_nn_1_N = mkN "skabbdjur" neutrum  ;
  sjoeslag_nn_1_1_N = mkN "sjöslag" neutrum  ;
  sjoesediment_nn_1_1_N = mkN "sjösediment" neutrum  ;
  sjoeodjur_nn_1_1_N = mkN "sjöodjur" neutrum  ;
  sjoelejon_nn_1_1_N = mkN "sjölejon" neutrum  ;
  sjoekrig_nn_1_1_N = mkN "sjökrig" neutrum  ;
  sjoekort_nn_1_1_N = mkN "sjökort" neutrum  ;
  sjoekaptensbrev_nn_1_1_N = mkN "sjökaptensbrev" neutrum  ;
  sjoefoerhoer_nn_1_1_N = mkN "sjöförhör" neutrum  ;
  sjoefynd_nn_1_1_N = mkN "sjöfynd" neutrum  ;
  sjoeflygplan_nn_1_1_N = mkN "sjöflygplan" neutrum  ;
  sjaap_nn_1_1_N = mkN "sjåp" neutrum  ;
  sjaelvaendamaal_nn_1_1_N = mkN "självändamål" neutrum  ;
  sjaelvportraett_nn_1_1_N = mkN "självporträtt" neutrum  ;
  sjaelvmaal_nn_1_1_N = mkN "självmål" neutrum  ;
  sjaelvmordsuppdrag_nn_1_1_N = mkN "självmordsuppdrag" neutrum  ;
  sjaelvmordsfoersoek_nn_1_1_N = mkN "självmordsförsök" neutrum  ;
  sjaelvmord_nn_1_1_N = mkN "självmord" neutrum  ;
  sjaelvljud_nn_1_1_N = mkN "självljud" neutrum  ;
  sjaelvhjaelpsraad_nn_1_1_N = mkN "självhjälpsråd" neutrum  ;
  sjaelstillstaand_nn_1_1_N = mkN "själstillstånd" neutrum  ;
  sjumilakliv_nn_1_N = mkN "sjumilakliv" neutrum  ;
  sjuklaeger_nn_1_1_N = mkN "sjukläger" neutrum  ;
  sjukdomstillstaand_nn_1_1_N = mkN "sjukdomstillstånd" neutrum  ;
  sjukdomsfoerlopp_nn_1_1_N = mkN "sjukdomsförlopp" neutrum  ;
  sjukbud_nn_1_N = mkN "sjukbud" neutrum  ;
  sjukbesoek_nn_1_1_N = mkN "sjukbesök" neutrum  ;
  sjukavdrag_nn_1_N = mkN "sjukavdrag" neutrum  ;
  sjok_nn_1_N = mkN "sjok" neutrum  ;
  sjapp_nn_1_N = mkN "sjapp" neutrum  ;
  sj_ljud_nn_1_N = mkN "sj-ljud" neutrum  ;
  sittben_nn_1_N = mkN "sittben" neutrum  ;
  sittbadkar_nn_1_N = mkN "sittbadkar" neutrum  ;
  sirentjut_nn_1_N = mkN "sirentjut" neutrum  ;
  sirendjur_nn_1_N = mkN "sirendjur" neutrum  ;
  sinnesorgan_nn_1_N = mkN "sinnesorgan" neutrum  ;
  sinnesintryck_nn_1_N = mkN "sinnesintryck" neutrum  ;
  simtag_nn_1_N = mkN "simtag" neutrum  ;
  simsaett_nn_1_1_N = mkN "simsätt" neutrum  ;
  simprov_nn_1_N = mkN "simprov" neutrum  ;
  simorgan_nn_1_N = mkN "simorgan" neutrum  ;
  simhopp_nn_1_N = mkN "simhopp" neutrum  ;
  simhallstak_nn_1_N = mkN "simhallstak" neutrum  ;
  silvermynt_nn_1_N = mkN "silvermynt" neutrum  ;
  silverlejon_nn_1_N = mkN "silverlejon" neutrum  ;
  silverfoeremaal_nn_1_1_N = mkN "silverföremål" neutrum  ;
  silverfat_nn_1_N = mkN "silverfat" neutrum  ;
  silverbroellop_nn_1_1_N = mkN "silverbröllop" neutrum  ;
  silverbrudpar_nn_1_N = mkN "silverbrudpar" neutrum  ;
  silverbeslag_nn_1_N = mkN "silverbeslag" neutrum  ;
  silkesband_nn_1_N = mkN "silkesband" neutrum  ;
  silkepapper_nn_1_N = mkN "silkepapper" neutrum  ;
  silikonimplantat_nn_1_N = mkN "silikonimplantat" neutrum  ;
  silben_nn_1_N = mkN "silben" neutrum  ;
  siktbroed_nn_1_1_N = mkN "siktbröd" neutrum  ;
  signet_nn_1_N = mkN "signet" neutrum  ;
  signalur_nn_1_N = mkN "signalur" neutrum  ;
  signalstaell_nn_1_1_N = mkN "signalställ" neutrum  ;
  signalmoenster_nn_1_1_N = mkN "signalmönster" neutrum  ;
  signalhorn_nn_1_N = mkN "signalhorn" neutrum  ;
  signalement_nn_1_N = mkN "signalement" neutrum  ;
  sigill_nn_1_N = mkN "sigill" neutrum  ;
  sifferbetyg_nn_1_N = mkN "sifferbetyg" neutrum  ;
  sidroder_nn_1_N = mkN "sidroder" neutrum  ;
  sidospaar_nn_1_1_N = mkN "sidospår" neutrum  ;
  sidospraang_nn_1_1_N = mkN "sidosprång" neutrum  ;
  sidoskott_nn_1_N = mkN "sidoskott" neutrum  ;
  sidoskepp_nn_1_N = mkN "sidoskepp" neutrum  ;
  sidoplan_nn_1_N = mkN "sidoplan" neutrum  ;
  sidolinjeorgan_nn_1_N = mkN "sidolinjeorgan" neutrum  ;
  sidohandtag_nn_1_N = mkN "sidohandtag" neutrum  ;
  sidogevaer_nn_1_1_N = mkN "sidogevär" neutrum  ;
  sidodaeck_nn_1_1_N = mkN "sidodäck" neutrum  ;
  sidobord_nn_1_N = mkN "sidobord" neutrum  ;
  sidoarv_nn_1_N = mkN "sidoarv" neutrum  ;
  sidnummer_nn_1_N = mkN "sidnummer" neutrum  ;
  sideboard_nn_1_N = mkN "sideboard" neutrum  ;
  sibetdjur_nn_1_N = mkN "sibetdjur" neutrum  ;
  shuffle_board_nn_1_N = mkN "shuffle-board" neutrum  ;
  shelterdaeck_nn_1_1_N = mkN "shelterdäck" neutrum  ;
  sexualorgan_nn_1_N = mkN "sexualorgan" neutrum  ;
  sexualmord_nn_1_N = mkN "sexualmord" neutrum  ;
  sexualbrott_nn_1_N = mkN "sexualbrott" neutrum  ;
  sexspann_nn_1_N = mkN "sexspann" neutrum  ;
  sexpartssamtal_nn_1_N = mkN "sexpartssamtal" neutrum  ;
  sexmord_nn_1_N = mkN "sexmord" neutrum  ;
  sexkoep_nn_1_1_N = mkN "sexköp" neutrum  ;
  sexklipp_nn_1_N = mkN "sexklipp" neutrum  ;
  sexhjaelpmedel_nn_1_1_N = mkN "sexhjälpmedel" neutrum  ;
  sexbrott_nn_1_N = mkN "sexbrott" neutrum  ;
  settlement_nn_1_N = mkN "settlement" neutrum  ;
  set_nn_1_N = mkN "set" neutrum  ;
  servitut_nn_1_N = mkN "servitut" neutrum  ;
  serveringsfat_nn_1_N = mkN "serveringsfat" neutrum  ;
  serveringsbord_nn_1_N = mkN "serveringsbord" neutrum  ;
  seriemord_nn_1_N = mkN "seriemord" neutrum  ;
  seriemagasin_nn_1_N = mkN "seriemagasin" neutrum  ;
  serafimerband_nn_1_N = mkN "serafimerband" neutrum  ;
  separat_nn_1_N = mkN "separat" neutrum  ;
  sentiment_nn_1_N = mkN "sentiment" neutrum  ;
  senorgan_nn_1_N = mkN "senorgan" neutrum  ;
  senapskorn_nn_1_N = mkN "senapskorn" neutrum  ;
  semikolon_nn_1_N = mkN "semikolon" neutrum  ;
  semestertillaegg_nn_1_1_N = mkN "semestertillägg" neutrum  ;
  semesterfynd_nn_1_N = mkN "semesterfynd" neutrum  ;
  semaforalfabet_nn_1_N = mkN "semaforalfabet" neutrum  ;
  seltyg_nn_1_N = mkN "seltyg" neutrum  ;
  seldon_nn_1_N = mkN "seldon" neutrum  ;
  selbrott_nn_1_N = mkN "selbrott" neutrum  ;
  sel_nn_1_N = mkN "sel" neutrum  ;
  sekretariat_nn_1_N = mkN "sekretariat" neutrum  ;
  sekret_nn_1_N = mkN "sekret" neutrum  ;
  sejnfall_nn_1_N = mkN "sejnfall" neutrum  ;
  segregat_nn_1_N = mkN "segregat" neutrum  ;
  segment_nn_1_N = mkN "segment" neutrum  ;
  segertaag_nn_1_1_N = mkN "segertåg" neutrum  ;
  segermonument_nn_1_N = mkN "segermonument" neutrum  ;
  segelstaell_nn_1_1_N = mkN "segelställ" neutrum  ;
  segelkapell_nn_1_N = mkN "segelkapell" neutrum  ;
  segelflygplan_nn_1_N = mkN "segelflygplan" neutrum  ;
  segelflyg_nn_1_N = mkN "segelflyg" neutrum  ;
  segelfartyg_nn_1_N = mkN "segelfartyg" neutrum  ;
  sedlighetsbrott_nn_1_N = mkN "sedlighetsbrott" neutrum  ;
  sedimentlager_nn_1_N = mkN "sedimentlager" neutrum  ;
  sediment_nn_1_N = mkN "sediment" neutrum  ;
  sedebetyg_nn_1_N = mkN "sedebetyg" neutrum  ;
  scoutlaeger_nn_1_1_N = mkN "scoutläger" neutrum  ;
  scoop_nn_1_N = mkN "scoop" neutrum  ;
  schwa_ljud_nn_1_N = mkN "schwa-ljud" neutrum  ;
  schlagerbraak_nn_1_1_N = mkN "schlagerbråk" neutrum  ;
  schlagerbidrag_nn_1_N = mkN "schlagerbidrag" neutrum  ;
  schatull_nn_1_N = mkN "schatull" neutrum  ;
  schapp_nn_1_N = mkN "schapp" neutrum  ;
  schakt_nn_1_N = mkN "schakt" neutrum  ;
  schackmoenster_nn_1_1_N = mkN "schackmönster" neutrum  ;
  schackdrag_nn_1_N = mkN "schackdrag" neutrum  ;
  schackbord_nn_1_N = mkN "schackbord" neutrum  ;
  schabrak_nn_1_N = mkN "schabrak" neutrum  ;
  schablontillaegg_nn_1_1_N = mkN "schablontillägg" neutrum  ;
  schablonbelopp_nn_1_N = mkN "schablonbelopp" neutrum  ;
  schablonavdrag_nn_1_N = mkN "schablonavdrag" neutrum  ;
  saxskaer_nn_1_1_N = mkN "saxskär" neutrum  ;
  saxredskap_nn_1_N = mkN "saxredskap" neutrum  ;
  saxblad_nn_1_N = mkN "saxblad" neutrum  ;
  sattyg_nn_1_N = mkN "sattyg" neutrum  ;
  satsbord_nn_1_N = mkN "satsbord" neutrum  ;
  satemspraak_nn_1_1_N = mkN "satemspråk" neutrum  ;
  sarkom_nn_1_N = mkN "sarkom" neutrum  ;
  sanningskrav_nn_1_N = mkN "sanningskrav" neutrum  ;
  sanningskorn_nn_1_N = mkN "sanningskorn" neutrum  ;
  sanningsanspraak_nn_1_1_N = mkN "sanningsanspråk" neutrum  ;
  sanitetskaerl_nn_1_1_N = mkN "sanitetskärl" neutrum  ;
  saneringsmedel_nn_1_N = mkN "saneringsmedel" neutrum  ;
  saneringsfartyg_nn_1_N = mkN "saneringsfartyg" neutrum  ;
  sandur_nn_1_N = mkN "sandur" neutrum  ;
  sandtag_nn_1_N = mkN "sandtag" neutrum  ;
  sandspaar_nn_1_1_N = mkN "sandspår" neutrum  ;
  sandroer_nn_1_1_N = mkN "sandrör" neutrum  ;
  sandrev_nn_1_N = mkN "sandrev" neutrum  ;
  sandpapper_nn_1_N = mkN "sandpapper" neutrum  ;
  sandlaadekrig_nn_1_1_N = mkN "sandlådekrig" neutrum  ;
  sandkorn_nn_1_N = mkN "sandkorn" neutrum  ;
  sandflugebett_nn_1_N = mkN "sandflugebett" neutrum  ;
  sandbad_nn_1_N = mkN "sandbad" neutrum  ;
  samvetsaektenskap_nn_1_1_N = mkN "samvetsäktenskap" neutrum  ;
  samvetsstyng_nn_1_N = mkN "samvetsstyng" neutrum  ;
  samvetsskael_nn_1_1_N = mkN "samvetsskäl" neutrum  ;
  samvetskval_nn_1_N = mkN "samvetskval" neutrum  ;
  samverkansprojekt_nn_1_N = mkN "samverkansprojekt" neutrum  ;
  samurajsvaerd_nn_1_1_N = mkN "samurajsvärd" neutrum  ;
  samtal_nn_1_N = mkN "samtal" neutrum  ;
  samraad_nn_1_1_N = mkN "samråd" neutrum  ;
  sammetsblomster_nn_1_N = mkN "sammetsblomster" neutrum  ;
  sammelnamn_nn_1_N = mkN "sammelnamn" neutrum  ;
  sammelband_nn_1_N = mkN "sammelband" neutrum  ;
  sammanskott_nn_1_N = mkN "sammanskott" neutrum  ;
  sammanhang_nn_1_N = mkN "sammanhang" neutrum  ;
  sammanfall_nn_1_N = mkN "sammanfall" neutrum  ;
  sammandrag_nn_1_N = mkN "sammandrag" neutrum  ;
  sammanbrott_nn_1_N = mkN "sammanbrott" neutrum  ;
  samlingsverk_nn_1_N = mkN "samlingsverk" neutrum  ;
  samlingsnamn_nn_1_N = mkN "samlingsnamn" neutrum  ;
  samlingsband_nn_1_N = mkN "samlingsband" neutrum  ;
  samlarfoeremaal_nn_1_1_N = mkN "samlarföremål" neutrum  ;
  samlarfolk_nn_1_N = mkN "samlarfolk" neutrum  ;
  samlag_nn_1_N = mkN "samlag" neutrum  ;
  samkoep_nn_1_1_N = mkN "samköp" neutrum  ;
  samkvaem_nn_1_1_N = mkN "samkväm" neutrum  ;
  samhaellsskikt_nn_1_1_N = mkN "samhällsskikt" neutrum  ;
  samhaellsskick_nn_1_1_N = mkN "samhällsskick" neutrum  ;
  samhaellsorgan_nn_1_1_N = mkN "samhällsorgan" neutrum  ;
  samhaellskontrakt_nn_1_1_N = mkN "samhällskontrakt" neutrum  ;
  samhaellsideal_nn_1_1_N = mkN "samhällsideal" neutrum  ;
  samhaellsfoerdrag_nn_1_1_N = mkN "samhällsfördrag" neutrum  ;
  samfaerdsmedel_nn_1_1_N = mkN "samfärdsmedel" neutrum  ;
  samfund_nn_1_N = mkN "samfund" neutrum  ;
  sambord_nn_1_N = mkN "sambord" neutrum  ;
  samboavtal_nn_1_N = mkN "samboavtal" neutrum  ;
  samband_nn_1_N = mkN "samband" neutrum  ;
  samarv_nn_1_N = mkN "samarv" neutrum  ;
  samarbetsorgan_nn_1_N = mkN "samarbetsorgan" neutrum  ;
  salutskott_nn_1_N = mkN "salutskott" neutrum  ;
  salutorg_nn_1_N = mkN "salutorg" neutrum  ;
  salustaand_nn_1_1_N = mkN "salustånd" neutrum  ;
  saltverk_nn_1_N = mkN "saltverk" neutrum  ;
  saltkar_nn_1_N = mkN "saltkar" neutrum  ;
  saltbehov_nn_1_N = mkN "saltbehov" neutrum  ;
  saltbad_nn_1_N = mkN "saltbad" neutrum  ;
  salsgolv_nn_1_N = mkN "salsgolv" neutrum  ;
  salongslejon_nn_1_N = mkN "salongslejon" neutrum  ;
  salongsgevaer_nn_1_1_N = mkN "salongsgevär" neutrum  ;
  salningshorn_nn_1_N = mkN "salningshorn" neutrum  ;
  salladsland_nn_1_N = mkN "salladsland" neutrum  ;
  salladsbestick_nn_1_N = mkN "salladsbestick" neutrum  ;
  salighetsmedel_nn_1_N = mkN "salighetsmedel" neutrum  ;
  salband_nn_1_N = mkN "salband" neutrum  ;
  sakskael_nn_1_1_N = mkN "sakskäl" neutrum  ;
  sakregister_nn_1_N = mkN "sakregister" neutrum  ;
  sakramentsskaap_nn_1_1_N = mkN "sakramentsskåp" neutrum  ;
  sakrament_nn_1_N = mkN "sakrament" neutrum  ;
  sakord_nn_1_N = mkN "sakord" neutrum  ;
  sakobjekt_nn_1_N = mkN "sakobjekt" neutrum  ;
  sakkunniguppdrag_nn_1_N = mkN "sakkunniguppdrag" neutrum  ;
  sagoslott_nn_1_N = mkN "sagoslott" neutrum  ;
  sagogryn_nn_1_N = mkN "sagogryn" neutrum  ;
  sagodjur_nn_1_N = mkN "sagodjur" neutrum  ;
  saffransbroed_nn_1_1_N = mkN "saffransbröd" neutrum  ;
  sadeltak_nn_1_N = mkN "sadeltak" neutrum  ;
  sadelskydd_nn_1_N = mkN "sadelskydd" neutrum  ;
  sadelmakarstift_nn_1_N = mkN "sadelmakarstift" neutrum  ;
  sadelbrott_nn_1_N = mkN "sadelbrott" neutrum  ;
  sabbatsaar_nn_1_1_N = mkN "sabbatsår" neutrum  ;
  sabbatsbrott_nn_1_N = mkN "sabbatsbrott" neutrum  ;
  roevhaal_nn_1_1_N = mkN "rövhål" neutrum  ;
  roetaegg_nn_1_1_N = mkN "rötägg" neutrum  ;
  roestkort_nn_1_1_N = mkN "röstkort" neutrum  ;
  roestjaern_nn_1_1_N = mkN "röstjärn" neutrum  ;
  roestetal_nn_1_1_N = mkN "röstetal" neutrum  ;
  roerelsemoenster_nn_1_1_N = mkN "rörelsemönster" neutrum  ;
  roerelsemaengdsmoment_nn_1_1_N = mkN "rörelsemängdsmoment" neutrum  ;
  roerblad_nn_1_1_N = mkN "rörblad" neutrum  ;
  roer_nn_1_1_N = mkN "rör" neutrum  ;
  roentgenroer_nn_1_1_N = mkN "röntgenrör" neutrum  ;
  roentgenmikroskop_nn_1_1_N = mkN "röntgenmikroskop" neutrum  ;
  roennbaer_nn_1_1_N = mkN "rönnbär" neutrum  ;
  roen_nn_1_1_N = mkN "rön" neutrum  ;
  roekmoln_nn_1_1_N = mkN "rökmoln" neutrum  ;
  roekfoerbud_nn_1_1_N = mkN "rökförbud" neutrum  ;
  roekfaang_nn_1_1_N = mkN "rökfång" neutrum  ;
  roekelsekar_nn_1_1_N = mkN "rökelsekar" neutrum  ;
  roekbord_nn_1_1_N = mkN "rökbord" neutrum  ;
  roedtjut_nn_1_1_N = mkN "rödtjut" neutrum  ;
  roedskinn_nn_1_1_N = mkN "rödskinn" neutrum  ;
  roedfilter_nn_1_1_N = mkN "rödfilter" neutrum  ;
  raatthaal_nn_1_1_N = mkN "råtthål" neutrum  ;
  raattdjur_nn_1_1_N = mkN "råttdjur" neutrum  ;
  raaskinn_nn_1_1_N = mkN "råskinn" neutrum  ;
  raanmord_nn_1_1_N = mkN "rånmord" neutrum  ;
  raanfoersoek_nn_1_1_N = mkN "rånförsök" neutrum  ;
  raan_nn_1_1_N = mkN "rån" neutrum  ;
  raakurr_nn_1_1_N = mkN "råkurr" neutrum  ;
  raagkorn_nn_1_1_N = mkN "rågkorn" neutrum  ;
  raagbroed_nn_1_1_N = mkN "rågbröd" neutrum  ;
  raadslut_nn_1_1_N = mkN "rådslut" neutrum  ;
  raadslag_nn_1_1_N = mkN "rådslag" neutrum  ;
  raadjurskid_nn_1_1_N = mkN "rådjurskid" neutrum  ;
  raadjur_nn_1_1_N = mkN "rådjur" neutrum  ;
  raad_nn_2_1_N = mkN "råd" neutrum  ;
  raad_nn_1_1_N = mkN "råd" neutrum  ;
  raaband_nn_1_1_N = mkN "råband" neutrum  ;
  raettviseideal_nn_1_1_N = mkN "rättviseideal" neutrum  ;
  raettviseengagemang_nn_1_1_N = mkN "rättviseengagemang" neutrum  ;
  raettsoevergrepp_nn_1_1_N = mkN "rättsövergrepp" neutrum  ;
  raettssubjekt_nn_1_1_N = mkN "rättssubjekt" neutrum  ;
  raettshjaelpskontor_nn_1_1_N = mkN "rättshjälpskontor" neutrum  ;
  raettsfall_nn_1_1_N = mkN "rättsfall" neutrum  ;
  raettsbegrepp_nn_1_1_N = mkN "rättsbegrepp" neutrum  ;
  raetblock_nn_1_1_N = mkN "rätblock" neutrum  ;
  raentebesked_nn_1_1_N = mkN "räntebesked" neutrum  ;
  raenteavdrag_nn_1_1_N = mkN "ränteavdrag" neutrum  ;
  raelsbrott_nn_1_1_N = mkN "rälsbrott" neutrum  ;
  raekneverk_nn_1_1_N = mkN "räkneverk" neutrum  ;
  raeknesaett_nn_1_1_N = mkN "räknesätt" neutrum  ;
  raekneord_nn_1_1_N = mkN "räkneord" neutrum  ;
  raekenskapsaar_nn_1_1_N = mkN "räkenskapsår" neutrum  ;
  raeddningspaadrag_nn_1_1_N = mkN "räddningspådrag" neutrum  ;
  raeddningspaket_nn_1_1_N = mkN "räddningspaket" neutrum  ;
  raeddningsflyg_nn_1_1_N = mkN "räddningsflyg" neutrum  ;
  raeckverk_nn_1_1_N = mkN "räckverk" neutrum  ;
  raeck_nn_1_1_N = mkN "räck" neutrum  ;
  ryttarfolk_nn_1_N = mkN "ryttarfolk" neutrum  ;
  rysch_nn_1_N = mkN "rysch" neutrum  ;
  rymdskepp_nn_1_N = mkN "rymdskepp" neutrum  ;
  rymdmaatt_nn_1_1_N = mkN "rymdmått" neutrum  ;
  ryggstoed_nn_1_1_N = mkN "ryggstöd" neutrum  ;
  ryggslut_nn_1_N = mkN "ryggslut" neutrum  ;
  ryggskott_nn_1_N = mkN "ryggskott" neutrum  ;
  ryggradsdjur_nn_1_N = mkN "ryggradsdjur" neutrum  ;
  ryggornament_nn_1_N = mkN "ryggornament" neutrum  ;
  ryggmaergsprov_nn_1_1_N = mkN "ryggmärgsprov" neutrum  ;
  ryggbesvaer_nn_1_1_N = mkN "ryggbesvär" neutrum  ;
  ryck_nn_1_N = mkN "ryck" neutrum  ;
  rutpapper_nn_1_N = mkN "rutpapper" neutrum  ;
  rutnaet_nn_1_1_N = mkN "rutnät" neutrum  ;
  rutmoenster_nn_1_1_N = mkN "rutmönster" neutrum  ;
  rutavdrag_nn_1_N = mkN "rutavdrag" neutrum  ;
  rusthaall_nn_1_1_N = mkN "rusthåll" neutrum  ;
  russin_nn_1_N = mkN "russin" neutrum  ;
  rusdrycksfoerbud_nn_1_1_N = mkN "rusdrycksförbud" neutrum  ;
  rundjaern_nn_1_1_N = mkN "rundjärn" neutrum  ;
  rundfoenster_nn_1_1_N = mkN "rundfönster" neutrum  ;
  rundbrev_nn_1_N = mkN "rundbrev" neutrum  ;
  rundabordssamtal_nn_1_N = mkN "rundabordssamtal" neutrum  ;
  rumsnummer_nn_1_N = mkN "rumsnummer" neutrum  ;
  rumptroll_nn_1_N = mkN "rumptroll" neutrum  ;
  rullrev_nn_1_N = mkN "rullrev" neutrum  ;
  rullbord_nn_1_N = mkN "rullbord" neutrum  ;
  rullband_nn_1_N = mkN "rullband" neutrum  ;
  rullager_nn_1_N = mkN "rullager" neutrum  ;
  rufftak_nn_1_N = mkN "rufftak" neutrum  ;
  rudiment_nn_1_N = mkN "rudiment" neutrum  ;
  rovdjur_nn_1_N = mkN "rovdjur" neutrum  ;
  rov_nn_1_N = mkN "rov" neutrum  ;
  rotorblad_nn_1_N = mkN "rotorblad" neutrum  ;
  rotavdrag_nn_1_N = mkN "rotavdrag" neutrum  ;
  rostskyddspigment_nn_1_N = mkN "rostskyddspigment" neutrum  ;
  rostskyddsmedel_nn_1_N = mkN "rostskyddsmedel" neutrum  ;
  rostskydd_nn_1_N = mkN "rostskydd" neutrum  ;
  roster_nn_1_N = mkN "roster" neutrum  ;
  rosettmoenster_nn_1_1_N = mkN "rosettmönster" neutrum  ;
  rosettfoenster_nn_1_1_N = mkN "rosettfönster" neutrum  ;
  rosenmoln_nn_1_N = mkN "rosenmoln" neutrum  ;
  rosenbroed_nn_1_1_N = mkN "rosenbröd" neutrum  ;
  rop_nn_1_N = mkN "rop" neutrum  ;
  rollfack_nn_1_N = mkN "rollfack" neutrum  ;
  rollerhandtag_nn_1_N = mkN "rollerhandtag" neutrum  ;
  roll_on_roll_off_fartyg_nn_1_N = mkN "roll-on/roll-off-fartyg" neutrum  ;
  roder_nn_1_N = mkN "roder" neutrum  ;
  roddarlag_nn_1_N = mkN "roddarlag" neutrum  ;
  rockband_nn_1_N = mkN "rockband" neutrum  ;
  ro_ro_fartyg_nn_1_N = mkN "ro-ro-fartyg" neutrum  ;
  rivningskontrakt_nn_1_N = mkN "rivningskontrakt" neutrum  ;
  rivjaern_nn_1_1_N = mkN "rivjärn" neutrum  ;
  ritualmord_nn_1_N = mkN "ritualmord" neutrum  ;
  ritkol_nn_1_N = mkN "ritkol" neutrum  ;
  ritbord_nn_1_N = mkN "ritbord" neutrum  ;
  ritblock_nn_1_N = mkN "ritblock" neutrum  ;
  ritbestick_nn_1_N = mkN "ritbestick" neutrum  ;
  risktal_nn_1_N = mkN "risktal" neutrum  ;
  riskkapitalbolag_nn_1_N = mkN "riskkapitalbolag" neutrum  ;
  risgryn_nn_1_N = mkN "risgryn" neutrum  ;
  ringvrak_nn_1_N = mkN "ringvrak" neutrum  ;
  ringtryck_nn_1_N = mkN "ringtryck" neutrum  ;
  ringrev_nn_1_N = mkN "ringrev" neutrum  ;
  ringberg_nn_1_N = mkN "ringberg" neutrum  ;
  riktnummer_nn_1_N = mkN "riktnummer" neutrum  ;
  riktmedel_nn_1_N = mkN "riktmedel" neutrum  ;
  riktinstrument_nn_1_N = mkN "riktinstrument" neutrum  ;
  riksuttag_nn_1_N = mkN "riksuttag" neutrum  ;
  riksspraak_nn_1_1_N = mkN "riksspråk" neutrum  ;
  rikssamtal_nn_1_N = mkN "rikssamtal" neutrum  ;
  riksraad_nn_1_1_N = mkN "riksråd" neutrum  ;
  riksnaet_nn_1_1_N = mkN "riksnät" neutrum  ;
  riksmynt_nn_1_N = mkN "riksmynt" neutrum  ;
  riksgenomsnitt_nn_1_N = mkN "riksgenomsnitt" neutrum  ;
  riksfoerbund_nn_1_1_N = mkN "riksförbund" neutrum  ;
  riksdagsval_nn_1_N = mkN "riksdagsval" neutrum  ;
  riksdagsprotokoll_nn_1_N = mkN "riksdagsprotokoll" neutrum  ;
  riksdagsmandat_nn_1_N = mkN "riksdagsmandat" neutrum  ;
  riksdagsbeslut_nn_1_N = mkN "riksdagsbeslut" neutrum  ;
  rikemansbarn_nn_1_N = mkN "rikemansbarn" neutrum  ;
  riff_nn_1_N = mkN "riff" neutrum  ;
  ridaafall_nn_1_1_N = mkN "ridåfall" neutrum  ;
  ridsaar_nn_1_1_N = mkN "ridsår" neutrum  ;
  ridkunnighetsprov_nn_1_N = mkN "ridkunnighetsprov" neutrum  ;
  riddjur_nn_1_N = mkN "riddjur" neutrum  ;
  riddarslag_nn_1_N = mkN "riddarslag" neutrum  ;
  ribbvalv_nn_1_N = mkN "ribbvalv" neutrum  ;
  revir_nn_1_N = mkN "revir" neutrum  ;
  reversal_nn_1_N = mkN "reversal" neutrum  ;
  revbensspjaell_nn_1_1_N = mkN "revbensspjäll" neutrum  ;
  revben_nn_1_N = mkN "revben" neutrum  ;
  rev_nn_1_N = mkN "rev" neutrum  ;
  retardationsfaelt_nn_1_1_N = mkN "retardationsfält" neutrum  ;
  resaarband_nn_1_1_N = mkN "resårband" neutrum  ;
  resultatbesked_nn_1_N = mkN "resultatbesked" neutrum  ;
  resultat_nn_1_N = mkN "resultat" neutrum  ;
  restlager_nn_1_N = mkN "restlager" neutrum  ;
  restaurangkoek_nn_1_1_N = mkN "restaurangkök" neutrum  ;
  restaurangbord_nn_1_N = mkN "restaurangbord" neutrum  ;
  restaurangbesoek_nn_1_1_N = mkN "restaurangbesök" neutrum  ;
  ressentiment_nn_1_N = mkN "ressentiment" neutrum  ;
  resonemangsaektenskap_nn_1_1_N = mkN "resonemangsäktenskap" neutrum  ;
  resonemang_nn_1_N = mkN "resonemang" neutrum  ;
  resningsbeslut_nn_1_N = mkN "resningsbeslut" neutrum  ;
  resmaal_nn_1_1_N = mkN "resmål" neutrum  ;
  reskript_nn_1_N = mkN "reskript" neutrum  ;
  resetillbehoer_nn_1_1_N = mkN "resetillbehör" neutrum  ;
  reservlager_nn_1_N = mkN "reservlager" neutrum  ;
  reservat_nn_1_N = mkN "reservat" neutrum  ;
  resefoerbud_nn_1_1_N = mkN "reseförbud" neutrum  ;
  resebadkar_nn_1_N = mkN "resebadkar" neutrum  ;
  researrangemang_nn_1_N = mkN "researrangemang" neutrum  ;
  reseapotek_nn_1_N = mkN "reseapotek" neutrum  ;
  repetergevaer_nn_1_1_N = mkN "repetergevär" neutrum  ;
  rep_nn_1_N = mkN "rep" neutrum  ;
  rensroer_nn_1_1_N = mkN "rensrör" neutrum  ;
  renskinn_nn_1_N = mkN "renskinn" neutrum  ;
  renlevnadskrav_nn_1_N = mkN "renlevnadskrav" neutrum  ;
  reningsverk_nn_1_N = mkN "reningsverk" neutrum  ;
  renhorn_nn_1_N = mkN "renhorn" neutrum  ;
  rengoeringsmedel_nn_1_1_N = mkN "rengöringsmedel" neutrum  ;
  renben_nn_1_N = mkN "renben" neutrum  ;
  remtyg_nn_1_N = mkN "remtyg" neutrum  ;
  remissvar_nn_1_N = mkN "remissvar" neutrum  ;
  relationstal_nn_1_N = mkN "relationstal" neutrum  ;
  relationsraad_nn_1_1_N = mkN "relationsråd" neutrum  ;
  rektorat_nn_1_N = mkN "rektorat" neutrum  ;
  rekryteringsfoeretag_nn_1_1_N = mkN "rekryteringsföretag" neutrum  ;
  rekordvarvtal_nn_1_N = mkN "rekordvarvtal" neutrum  ;
  rekord_nn_1_N = mkN "rekord" neutrum  ;
  rekommendationsbrev_nn_1_N = mkN "rekommendationsbrev" neutrum  ;
  reklamtrick_nn_1_N = mkN "reklamtrick" neutrum  ;
  reklamplakat_nn_1_N = mkN "reklamplakat" neutrum  ;
  reklaminslag_nn_1_N = mkN "reklaminslag" neutrum  ;
  rek_nn_1_N = mkN "rek" neutrum  ;
  regnstaenk_nn_1_1_N = mkN "regnstänk" neutrum  ;
  regnstaell_nn_1_1_N = mkN "regnställ" neutrum  ;
  regnskydd_nn_1_N = mkN "regnskydd" neutrum  ;
  regnovaeder_nn_1_1_N = mkN "regnoväder" neutrum  ;
  regnmoln_nn_1_N = mkN "regnmoln" neutrum  ;
  regn_nn_1_N = mkN "regn" neutrum  ;
  registreringsnummer_nn_1_N = mkN "registreringsnummer" neutrum  ;
  registerutdrag_nn_1_N = mkN "registerutdrag" neutrum  ;
  register_nn_1_N = mkN "register" neutrum  ;
  regeringssaett_nn_1_1_N = mkN "regeringssätt" neutrum  ;
  regeringsraad_nn_1_1_N = mkN "regeringsråd" neutrum  ;
  regeringsplan_nn_1_N = mkN "regeringsplan" neutrum  ;
  regeringsorgan_nn_1_N = mkN "regeringsorgan" neutrum  ;
  regeringsbeslut_nn_1_N = mkN "regeringsbeslut" neutrum  ;
  regelverk_nn_1_N = mkN "regelverk" neutrum  ;
  regelbrott_nn_1_N = mkN "regelbrott" neutrum  ;
  regalskepp_nn_1_N = mkN "regalskepp" neutrum  ;
  reformkrav_nn_1_N = mkN "reformkrav" neutrum  ;
  referensmaterial_nn_1_N = mkN "referensmaterial" neutrum  ;
  referensbibliotek_nn_1_N = mkN "referensbibliotek" neutrum  ;
  referat_nn_1_N = mkN "referat" neutrum  ;
  redskap_nn_1_N = mkN "redskap" neutrum  ;
  redlighetskrav_nn_1_N = mkN "redlighetskrav" neutrum  ;
  recept_nn_1_N = mkN "recept" neutrum  ;
  recensionsuppdrag_nn_1_N = mkN "recensionsuppdrag" neutrum  ;
  recensionsexemplar_nn_1_N = mkN "recensionsexemplar" neutrum  ;
  reaplan_nn_1_N = mkN "reaplan" neutrum  ;
  reallaeroverk_nn_1_1_N = mkN "realläroverk" neutrum  ;
  realkapital_nn_1_N = mkN "realkapital" neutrum  ;
  reaktorutslaepp_nn_1_1_N = mkN "reaktorutsläpp" neutrum  ;
  reagenspapper_nn_1_N = mkN "reagenspapper" neutrum  ;
  ratsch_nn_1_N = mkN "ratsch" neutrum  ;
  ratifikationsinstrument_nn_1_N = mkN "ratifikationsinstrument" neutrum  ;
  raster_nn_1_N = mkN "raster" neutrum  ;
  raskrig_nn_1_N = mkN "raskrig" neutrum  ;
  raseriutbrott_nn_1_N = mkN "raseriutbrott" neutrum  ;
  rasdjur_nn_1_N = mkN "rasdjur" neutrum  ;
  rasben_nn_1_N = mkN "rasben" neutrum  ;
  rapsfaelt_nn_1_1_N = mkN "rapsfält" neutrum  ;
  rapp_nn_2_N = mkN "rapp" neutrum  ;
  rap_nn_1_N = mkN "rap" neutrum  ;
  ransoneringskort_nn_1_N = mkN "ransoneringskort" neutrum  ;
  randhav_nn_1_N = mkN "randhav" neutrum  ;
  randfenomen_nn_1_N = mkN "randfenomen" neutrum  ;
  randberg_nn_1_N = mkN "randberg" neutrum  ;
  ramverk_nn_1_N = mkN "ramverk" neutrum  ;
  ramavtal_nn_1_N = mkN "ramavtal" neutrum  ;
  raketsteg_nn_1_N = mkN "raketsteg" neutrum  ;
  raketgevaer_nn_1_1_N = mkN "raketgevär" neutrum  ;
  rakblad_nn_1_N = mkN "rakblad" neutrum  ;
  ragg_nn_2_N = mkN "ragg" neutrum  ;
  raffinemang_nn_1_N = mkN "raffinemang" neutrum  ;
  radioteleskop_nn_1_N = mkN "radioteleskop" neutrum  ;
  radioroer_nn_1_1_N = mkN "radiorör" neutrum  ;
  radiallager_nn_1_N = mkN "radiallager" neutrum  ;
  radialdaeck_nn_1_1_N = mkN "radialdäck" neutrum  ;
  radband_nn_1_N = mkN "radband" neutrum  ;
  radavstaand_nn_1_1_N = mkN "radavstånd" neutrum  ;
  radarpar_nn_1_N = mkN "radarpar" neutrum  ;
  rackartyg_nn_1_N = mkN "rackartyg" neutrum  ;
  rack_nn_2_N = mkN "rack" neutrum  ;
  rabiesutbrott_nn_1_N = mkN "rabiesutbrott" neutrum  ;
  rabattkort_nn_1_N = mkN "rabattkort" neutrum  ;
  r_nn_1_N = mkN "r" neutrum  ;
  paavehov_nn_1_1_N = mkN "påvehov" neutrum  ;
  paatryckningsmedel_nn_1_1_N = mkN "påtryckningsmedel" neutrum  ;
  paaslakan_nn_1_1_N = mkN "påslakan" neutrum  ;
  paaslag_nn_1_1_N = mkN "påslag" neutrum  ;
  paaskaegg_nn_1_1_N = mkN "påskägg" neutrum  ;
  paaskalamm_nn_1_1_N = mkN "påskalamm" neutrum  ;
  paarop_nn_1_1_N = mkN "pårop" neutrum  ;
  paalaegg_nn_1_1_N = mkN "pålägg" neutrum  ;
  paalverk_nn_1_1_N = mkN "pålverk" neutrum  ;
  paalstek_nn_1_1_N = mkN "pålstek" neutrum  ;
  paahugg_nn_1_1_N = mkN "påhugg" neutrum  ;
  paahopp_nn_1_1_N = mkN "påhopp" neutrum  ;
  paahitt_nn_1_1_N = mkN "påhitt" neutrum  ;
  paafund_nn_1_1_N = mkN "påfund" neutrum  ;
  paadrag_nn_1_1_N = mkN "pådrag" neutrum  ;
  paabud_nn_1_1_N = mkN "påbud" neutrum  ;
  paeron_nn_1_1_N = mkN "päron" neutrum  ;
  paermebrev_nn_1_1_N = mkN "pärmebrev" neutrum  ;
  paermbrev_nn_1_1_N = mkN "pärmbrev" neutrum  ;
  paermblad_nn_1_1_N = mkN "pärmblad" neutrum  ;
  paerlsponttak_nn_1_1_N = mkN "pärlsponttak" neutrum  ;
  paerlhalsband_nn_1_1_N = mkN "pärlhalsband" neutrum  ;
  paerlgryn_nn_1_1_N = mkN "pärlgryn" neutrum  ;
  paerlemormoln_nn_1_1_N = mkN "pärlemormoln" neutrum  ;
  paerlband_nn_1_1_N = mkN "pärlband" neutrum  ;
  paelsskinn_nn_1_1_N = mkN "pälsskinn" neutrum  ;
  paelsfaar_nn_1_1_N = mkN "pälsfår" neutrum  ;
  paelsdjur_nn_1_1_N = mkN "pälsdjur" neutrum  ;
  punkband_nn_1_N = mkN "punkband" neutrum  ;
  pungdjur_nn_1_N = mkN "pungdjur" neutrum  ;
  pumpverk_nn_1_N = mkN "pumpverk" neutrum  ;
  pulver_nn_1_N = mkN "pulver" neutrum  ;
  pulstaag_nn_1_1_N = mkN "pulståg" neutrum  ;
  pulsslag_nn_1_N = mkN "pulsslag" neutrum  ;
  pulpettak_nn_1_N = mkN "pulpettak" neutrum  ;
  pukslag_nn_1_N = mkN "pukslag" neutrum  ;
  puderunderlag_nn_1_N = mkN "puderunderlag" neutrum  ;
  publiceringsbeslut_nn_1_N = mkN "publiceringsbeslut" neutrum  ;
  pubeshaar_nn_2_1_N = mkN "pubeshår" neutrum  ;
  psykiaterfoerbund_nn_1_1_N = mkN "psykiaterförbund" neutrum  ;
  psykfall_nn_1_N = mkN "psykfall" neutrum  ;
  psykbryt_nn_1_N = mkN "psykbryt" neutrum  ;
  psalmodikon_nn_1_N = mkN "psalmodikon" neutrum  ;
  psalmnummer_nn_1_N = mkN "psalmnummer" neutrum  ;
  proevningstillstaand_nn_1_1_N = mkN "prövningstillstånd" neutrum  ;
  praang_nn_1_1_N = mkN "prång" neutrum  ;
  praestgaell_nn_1_1_N = mkN "prästgäll" neutrum  ;
  praestbetyg_nn_1_1_N = mkN "prästbetyg" neutrum  ;
  praent_nn_1_1_N = mkN "pränt" neutrum  ;
  prydnadsfoeremaal_nn_1_1_N = mkN "prydnadsföremål" neutrum  ;
  provaar_nn_1_1_N = mkN "provår" neutrum  ;
  provsvar_nn_1_N = mkN "provsvar" neutrum  ;
  provstopp_nn_1_N = mkN "provstopp" neutrum  ;
  provroersbarn_nn_1_1_N = mkN "provrörsbarn" neutrum  ;
  provroer_nn_1_1_N = mkN "provrör" neutrum  ;
  provkoek_nn_1_1_N = mkN "provkök" neutrum  ;
  proverb_nn_1_N = mkN "proverb" neutrum  ;
  prov_nn_1_N = mkN "prov" neutrum  ;
  protokoll_nn_1_N = mkN "protokoll" neutrum  ;
  protesttal_nn_1_N = mkN "protesttal" neutrum  ;
  protektorat_nn_1_N = mkN "protektorat" neutrum  ;
  proteinslag_nn_1_N = mkN "proteinslag" neutrum  ;
  proteinbehov_nn_1_N = mkN "proteinbehov" neutrum  ;
  prospekt_nn_1_N = mkN "prospekt" neutrum  ;
  proppskaap_nn_1_1_N = mkN "proppskåp" neutrum  ;
  propellerplan_nn_1_N = mkN "propellerplan" neutrum  ;
  propagandaoevertag_nn_1_1_N = mkN "propagandaövertag" neutrum  ;
  promenadstraak_nn_1_1_N = mkN "promenadstråk" neutrum  ;
  projekt_nn_1_N = mkN "projekt" neutrum  ;
  programspraak_nn_1_1_N = mkN "programspråk" neutrum  ;
  programmotek_nn_1_N = mkN "programmotek" neutrum  ;
  programmeringsspraak_nn_1_1_N = mkN "programmeringsspråk" neutrum  ;
  programformat_nn_1_N = mkN "programformat" neutrum  ;
  proggband_nn_1_N = mkN "proggband" neutrum  ;
  profilspaar_nn_1_1_N = mkN "profilspår" neutrum  ;
  produktionsmedel_nn_1_N = mkN "produktionsmedel" neutrum  ;
  produktionsbortfall_nn_1_N = mkN "produktionsbortfall" neutrum  ;
  produktionsbolag_nn_1_N = mkN "produktionsbolag" neutrum  ;
  problembarn_nn_1_N = mkN "problembarn" neutrum  ;
  privilegiebrev_nn_1_N = mkN "privilegiebrev" neutrum  ;
  privattryck_nn_1_N = mkN "privattryck" neutrum  ;
  privatlaan_nn_1_1_N = mkN "privatlån" neutrum  ;
  privatiseringsprojekt_nn_1_N = mkN "privatiseringsprojekt" neutrum  ;
  pristak_nn_1_N = mkN "pristak" neutrum  ;
  prisstopp_nn_1_N = mkN "prisstopp" neutrum  ;
  prisregn_nn_1_N = mkN "prisregn" neutrum  ;
  priskrig_nn_1_N = mkN "priskrig" neutrum  ;
  prisfall_nn_1_N = mkN "prisfall" neutrum  ;
  primaerval_nn_1_1_N = mkN "primärval" neutrum  ;
  primaerlaan_nn_1_1_N = mkN "primärlån" neutrum  ;
  primuskoek_nn_1_1_N = mkN "primuskök" neutrum  ;
  primtal_nn_1_N = mkN "primtal" neutrum  ;
  primalskrik_nn_1_N = mkN "primalskrik" neutrum  ;
  preventivpiller_nn_1_N = mkN "preventivpiller" neutrum  ;
  preventivmedel_nn_1_N = mkN "preventivmedel" neutrum  ;
  preventivkrig_nn_1_N = mkN "preventivkrig" neutrum  ;
  prestigeuppdrag_nn_1_N = mkN "prestigeuppdrag" neutrum  ;
  prestigeprojekt_nn_1_N = mkN "prestigeprojekt" neutrum  ;
  pressveck_nn_1_N = mkN "pressveck" neutrum  ;
  presstopp_nn_1_N = mkN "presstopp" neutrum  ;
  pressorgan_nn_1_N = mkN "pressorgan" neutrum  ;
  presskort_nn_1_N = mkN "presskort" neutrum  ;
  pressjaern_nn_1_1_N = mkN "pressjärn" neutrum  ;
  pressgaeng_nn_1_1_N = mkN "pressgäng" neutrum  ;
  presidentval_nn_1_N = mkN "presidentval" neutrum  ;
  presidentskap_nn_1_N = mkN "presidentskap" neutrum  ;
  presentkort_nn_1_N = mkN "presentkort" neutrum  ;
  presensparticip_nn_1_N = mkN "presensparticip" neutrum  ;
  presens_nn_1_N = mkN "presens" neutrum  ;
  prepositionsuttryck_nn_1_N = mkN "prepositionsuttryck" neutrum  ;
  premielaan_nn_1_1_N = mkN "premielån" neutrum  ;
  prejudikat_nn_1_N = mkN "prejudikat" neutrum  ;
  predikat_nn_1_N = mkN "predikat" neutrum  ;
  precisionsmaatt_nn_1_1_N = mkN "precisionsmått" neutrum  ;
  precedensfall_nn_1_N = mkN "precedensfall" neutrum  ;
  prat_nn_1_N = mkN "prat" neutrum  ;
  praktverk_nn_1_N = mkN "praktverk" neutrum  ;
  praktkraek_nn_1_1_N = mkN "praktkräk" neutrum  ;
  praktexemplar_nn_1_N = mkN "praktexemplar" neutrum  ;
  praktband_nn_1_N = mkN "praktband" neutrum  ;
  poaengantal_nn_1_1_N = mkN "poängantal" neutrum  ;
  postverk_nn_1_N = mkN "postverk" neutrum  ;
  postulat_nn_1_N = mkN "postulat" neutrum  ;
  postraan_nn_1_1_N = mkN "postrån" neutrum  ;
  postorderfoeretag_nn_1_1_N = mkN "postorderföretag" neutrum  ;
  postnummer_nn_1_N = mkN "postnummer" neutrum  ;
  postkort_nn_1_N = mkN "postkort" neutrum  ;
  postkontor_nn_1_N = mkN "postkontor" neutrum  ;
  posthorn_nn_1_N = mkN "posthorn" neutrum  ;
  postfoerskott_nn_1_1_N = mkN "postförskott" neutrum  ;
  postfack_nn_1_N = mkN "postfack" neutrum  ;
  postbud_nn_1_N = mkN "postbud" neutrum  ;
  postament_nn_1_N = mkN "postament" neutrum  ;
  portvalv_nn_1_N = mkN "portvalv" neutrum  ;
  portraett_nn_1_1_N = mkN "porträtt" neutrum  ;
  portfoerbud_nn_1_1_N = mkN "portförbud" neutrum  ;
  portalbegrepp_nn_1_N = mkN "portalbegrepp" neutrum  ;
  porslinsskaap_nn_1_1_N = mkN "porslinsskåp" neutrum  ;
  porslinsfilter_nn_1_N = mkN "porslinsfilter" neutrum  ;
  pontifikat_nn_1_N = mkN "pontifikat" neutrum  ;
  pond_nn_1_N = mkN "pond" neutrum  ;
  pomeransskal_nn_1_N = mkN "pomeransskal" neutrum  ;
  polypropenmaterial_nn_1_N = mkN "polypropenmaterial" neutrum  ;
  polvaendningsskydd_nn_1_1_N = mkN "polvändningsskydd" neutrum  ;
  pollenkorn_nn_1_N = mkN "pollenkorn" neutrum  ;
  pollenfynd_nn_1_N = mkN "pollenfynd" neutrum  ;
  polistillslag_nn_1_N = mkN "polistillslag" neutrum  ;
  polisfoerhoer_nn_1_1_N = mkN "polisförhör" neutrum  ;
  polisfordon_nn_1_N = mkN "polisfordon" neutrum  ;
  polisdistrikt_nn_1_N = mkN "polisdistrikt" neutrum  ;
  polisbefael_nn_1_1_N = mkN "polisbefäl" neutrum  ;
  polermedel_nn_1_N = mkN "polermedel" neutrum  ;
  polentagryn_nn_1_N = mkN "polentagryn" neutrum  ;
  polderland_nn_1_N = mkN "polderland" neutrum  ;
  polarisationsfilter_nn_1_N = mkN "polarisationsfilter" neutrum  ;
  polarhav_nn_1_N = mkN "polarhav" neutrum  ;
  polarflyg_nn_1_N = mkN "polarflyg" neutrum  ;
  pojkaar_nn_1_1_N = mkN "pojkår" neutrum  ;
  pojkstreck_nn_1_N = mkN "pojkstreck" neutrum  ;
  pojknamn_nn_1_N = mkN "pojknamn" neutrum  ;
  pojklag_nn_1_N = mkN "pojklag" neutrum  ;
  plaatverktyg_nn_1_1_N = mkN "plåtverktyg" neutrum  ;
  plaattak_nn_1_1_N = mkN "plåttak" neutrum  ;
  plaatskjul_nn_1_1_N = mkN "plåtskjul" neutrum  ;
  plaatschabrak_nn_1_1_N = mkN "plåtschabrak" neutrum  ;
  plaatnav_nn_1_1_N = mkN "plåtnav" neutrum  ;
  plaatmynt_nn_1_1_N = mkN "plåtmynt" neutrum  ;
  plaatkaerl_nn_1_1_N = mkN "plåtkärl" neutrum  ;
  plaan_nn_1_1_N = mkN "plån" neutrum  ;
  plundringstaag_nn_1_1_N = mkN "plundringståg" neutrum  ;
  plugg_nn_1_N = mkN "plugg" neutrum  ;
  plommonstop_nn_1_N = mkN "plommonstop" neutrum  ;
  plommon_nn_1_N = mkN "plommon" neutrum  ;
  plogben_nn_1_N = mkN "plogben" neutrum  ;
  pling_nn_1_N = mkN "pling" neutrum  ;
  pliktexemplar_nn_1_N = mkN "pliktexemplar" neutrum  ;
  plenimaal_nn_1_1_N = mkN "plenimål" neutrum  ;
  plebiscit_nn_1_N = mkN "plebiscit" neutrum  ;
  play_off_nn_1_N = mkN "play-off" neutrum  ;
  plataagupp_nn_1_1_N = mkN "platågupp" neutrum  ;
  plataaberg_nn_1_1_N = mkN "platåberg" neutrum  ;
  plattjaern_nn_1_1_N = mkN "plattjärn" neutrum  ;
  platskontor_nn_1_N = mkN "platskontor" neutrum  ;
  plastnav_nn_1_N = mkN "plastnav" neutrum  ;
  plastlaminat_nn_1_N = mkN "plastlaminat" neutrum  ;
  plastkort_nn_1_N = mkN "plastkort" neutrum  ;
  plastflygplan_nn_1_N = mkN "plastflygplan" neutrum  ;
  plastbindemedel_nn_1_N = mkN "plastbindemedel" neutrum  ;
  plastbestick_nn_1_N = mkN "plastbestick" neutrum  ;
  plastband_nn_1_N = mkN "plastband" neutrum  ;
  planschverk_nn_1_N = mkN "planschverk" neutrum  ;
  planktondjur_nn_1_N = mkN "planktondjur" neutrum  ;
  plankton_nn_1_N = mkN "plankton" neutrum  ;
  plankgolv_nn_1_N = mkN "plankgolv" neutrum  ;
  plank_nn_2_N = mkN "plank" neutrum  ;
  planeringsorgan_nn_1_N = mkN "planeringsorgan" neutrum  ;
  plan_nn_2_N = mkN "plan" neutrum  ;
  plakat_nn_1_N = mkN "plakat" neutrum  ;
  plagiat_nn_1_N = mkN "plagiat" neutrum  ;
  plagg_nn_1_N = mkN "plagg" neutrum  ;
  placeringsobjekt_nn_1_N = mkN "placeringsobjekt" neutrum  ;
  placeringskort_nn_1_N = mkN "placeringskort" neutrum  ;
  pjoltersaellskap_nn_1_1_N = mkN "pjoltersällskap" neutrum  ;
  pix_nn_1_N = mkN "pix" neutrum  ;
  pivaafoenster_nn_1_1_N = mkN "pivåfönster" neutrum  ;
  pivothjul_nn_1_N = mkN "pivothjul" neutrum  ;
  pivotfoenster_nn_1_1_N = mkN "pivotfönster" neutrum  ;
  pistolskott_nn_1_N = mkN "pistolskott" neutrum  ;
  pistolraan_nn_1_1_N = mkN "pistolrån" neutrum  ;
  pistolhot_nn_1_N = mkN "pistolhot" neutrum  ;
  pisksnaertskydd_nn_1_1_N = mkN "pisksnärtskydd" neutrum  ;
  piskrapp_nn_1_N = mkN "piskrapp" neutrum  ;
  pipskaegg_nn_1_1_N = mkN "pipskägg" neutrum  ;
  pipskaft_nn_1_N = mkN "pipskaft" neutrum  ;
  pip_nn_2_N = mkN "pip" neutrum  ;
  pinoredskap_nn_1_N = mkN "pinoredskap" neutrum  ;
  pinnhaal_nn_1_1_N = mkN "pinnhål" neutrum  ;
  pinakotek_nn_1_N = mkN "pinakotek" neutrum  ;
  piltraed_nn_1_1_N = mkN "pilträd" neutrum  ;
  pilotfall_nn_1_N = mkN "pilotfall" neutrum  ;
  piller_nn_1_N = mkN "piller" neutrum  ;
  pilkoger_nn_1_N = mkN "pilkoger" neutrum  ;
  pigment_nn_1_N = mkN "pigment" neutrum  ;
  piggsvin_nn_1_N = mkN "piggsvin" neutrum  ;
  pianopling_nn_1_N = mkN "pianopling" neutrum  ;
  petrifikat_nn_1_N = mkN "petrifikat" neutrum  ;
  pessar_nn_1_N = mkN "pessar" neutrum  ;
  perukbraak_nn_1_1_N = mkN "perukbråk" neutrum  ;
  perspektivfoenster_nn_1_1_N = mkN "perspektivfönster" neutrum  ;
  personval_nn_1_N = mkN "personval" neutrum  ;
  persontaag_nn_1_1_N = mkN "persontåg" neutrum  ;
  personregister_nn_1_N = mkN "personregister" neutrum  ;
  personnummer_nn_1_N = mkN "personnummer" neutrum  ;
  personnamn_nn_1_N = mkN "personnamn" neutrum  ;
  personlighetsdrag_nn_1_N = mkN "personlighetsdrag" neutrum  ;
  personalblad_nn_1_N = mkN "personalblad" neutrum  ;
  perkussionsinstrument_nn_1_N = mkN "perkussionsinstrument" neutrum  ;
  periskop_nn_1_N = mkN "periskop" neutrum  ;
  periodtal_nn_1_N = mkN "periodtal" neutrum  ;
  pergamentsbrev_nn_1_N = mkN "pergamentsbrev" neutrum  ;
  pergamentbrev_nn_1_N = mkN "pergamentbrev" neutrum  ;
  pergamentband_nn_1_N = mkN "pergamentband" neutrum  ;
  perfektparticip_nn_1_N = mkN "perfektparticip" neutrum  ;
  pepparkorn_nn_1_N = mkN "pepparkorn" neutrum  ;
  pepparkaksrekord_nn_1_N = mkN "pepparkaksrekord" neutrum  ;
  pepparkaksbak_nn_1_N = mkN "pepparkaksbak" neutrum  ;
  pensionaerstillhaall_nn_1_1_N = mkN "pensionärstillhåll" neutrum  ;
  pensionsval_nn_1_N = mkN "pensionsval" neutrum  ;
  pensionsbrev_nn_1_N = mkN "pensionsbrev" neutrum  ;
  pensionat_nn_1_N = mkN "pensionat" neutrum  ;
  penseldrag_nn_1_N = mkN "penseldrag" neutrum  ;
  pennstreck_nn_1_N = mkN "pennstreck" neutrum  ;
  pennskaft_nn_1_N = mkN "pennskaft" neutrum  ;
  penningmedel_nn_1_N = mkN "penningmedel" neutrum  ;
  penninglaan_nn_1_1_N = mkN "penninglån" neutrum  ;
  penningbekymmer_nn_1_N = mkN "penningbekymmer" neutrum  ;
  penndrag_nn_1_N = mkN "penndrag" neutrum  ;
  penisollon_nn_1_N = mkN "penisollon" neutrum  ;
  pendelur_nn_1_N = mkN "pendelur" neutrum  ;
  pendeltaag_nn_1_1_N = mkN "pendeltåg" neutrum  ;
  pendelavstaand_nn_1_1_N = mkN "pendelavstånd" neutrum  ;
  pelarhelgon_nn_1_N = mkN "pelarhelgon" neutrum  ;
  pelarbord_nn_1_N = mkN "pelarbord" neutrum  ;
  pekoral_nn_1_N = mkN "pekoral" neutrum  ;
  pediment_nn_1_N = mkN "pediment" neutrum  ;
  patronkoek_nn_1_1_N = mkN "patronkök" neutrum  ;
  patriarkat_nn_1_N = mkN "patriarkat" neutrum  ;
  patientbesoek_nn_1_1_N = mkN "patientbesök" neutrum  ;
  paternosterverk_nn_1_N = mkN "paternosterverk" neutrum  ;
  paternoster_nn_1_N = mkN "paternoster" neutrum  ;
  patentverk_nn_1_N = mkN "patentverk" neutrum  ;
  patentmaal_nn_1_1_N = mkN "patentmål" neutrum  ;
  patentintraang_nn_1_1_N = mkN "patentintrång" neutrum  ;
  patent_nn_1_N = mkN "patent" neutrum  ;
  pastorat_nn_1_N = mkN "pastorat" neutrum  ;
  passionssamlag_nn_1_N = mkN "passionssamlag" neutrum  ;
  passerkort_nn_1_N = mkN "passerkort" neutrum  ;
  passagerarflygplan_nn_1_N = mkN "passagerarflygplan" neutrum  ;
  passagerarflyg_nn_1_N = mkN "passagerarflyg" neutrum  ;
  partytaelt_nn_1_1_N = mkN "partytält" neutrum  ;
  partsorgan_nn_1_N = mkN "partsorgan" neutrum  ;
  partnerskap_nn_1_N = mkN "partnerskap" neutrum  ;
  partitur_nn_1_N = mkN "partitur" neutrum  ;
  partiorgan_nn_1_N = mkN "partiorgan" neutrum  ;
  partikelregn_nn_1_N = mkN "partikelregn" neutrum  ;
  partikellock_nn_1_N = mkN "partikellock" neutrum  ;
  partidistrikt_nn_1_N = mkN "partidistrikt" neutrum  ;
  particip_nn_1_N = mkN "particip" neutrum  ;
  partiblock_nn_1_N = mkN "partiblock" neutrum  ;
  partialtryck_nn_1_N = mkN "partialtryck" neutrum  ;
  partaj_nn_1_N = mkN "partaj" neutrum  ;
  parningsorgan_nn_1_N = mkN "parningsorgan" neutrum  ;
  parlament_nn_1_N = mkN "parlament" neutrum  ;
  parkettgolv_nn_1_N = mkN "parkettgolv" neutrum  ;
  pariserhjul_nn_1_N = mkN "pariserhjul" neutrum  ;
  paraplytak_nn_1_N = mkN "paraplytak" neutrum  ;
  paraplystaell_nn_1_1_N = mkN "paraplyställ" neutrum  ;
  parallellstag_nn_1_N = mkN "parallellstag" neutrum  ;
  parallellfall_nn_1_N = mkN "parallellfall" neutrum  ;
  paradnummer_nn_1_N = mkN "paradnummer" neutrum  ;
  paradiskorn_nn_1_N = mkN "paradiskorn" neutrum  ;
  par_nn_1_N = mkN "par" neutrum  ;
  pappersplan_nn_1_N = mkN "pappersplan" neutrum  ;
  pappersmynt_nn_1_N = mkN "pappersmynt" neutrum  ;
  pappersformat_nn_1_N = mkN "pappersformat" neutrum  ;
  pappersbruk_nn_1_N = mkN "pappersbruk" neutrum  ;
  pappersark_nn_1_N = mkN "pappersark" neutrum  ;
  papper_nn_1_N = mkN "papper" neutrum  ;
  pappband_nn_1_N = mkN "pappband" neutrum  ;
  papillom_nn_1_N = mkN "papillom" neutrum  ;
  papaverin_nn_1_N = mkN "papaverin" neutrum  ;
  pantlaan_nn_1_1_N = mkN "pantlån" neutrum  ;
  panterspraang_nn_1_1_N = mkN "pantersprång" neutrum  ;
  panteon_nn_1_N = mkN "panteon" neutrum  ;
  pantbrev_nn_1_N = mkN "pantbrev" neutrum  ;
  pansarvaern_nn_1_1_N = mkN "pansarvärn" neutrum  ;
  pansartorn_nn_1_N = mkN "pansartorn" neutrum  ;
  pansarskott_nn_1_N = mkN "pansarskott" neutrum  ;
  pansarroer_nn_1_1_N = mkN "pansarrör" neutrum  ;
  pansarhinder_nn_1_N = mkN "pansarhinder" neutrum  ;
  pansarfordon_nn_1_N = mkN "pansarfordon" neutrum  ;
  pansarfartyg_nn_1_N = mkN "pansarfartyg" neutrum  ;
  pansar_nn_1_N = mkN "pansar" neutrum  ;
  panoramafoenster_nn_1_1_N = mkN "panoramafönster" neutrum  ;
  panoptikon_nn_1_N = mkN "panoptikon" neutrum  ;
  pannkaksmoln_nn_1_N = mkN "pannkaksmoln" neutrum  ;
  pannben_nn_1_N = mkN "pannben" neutrum  ;
  pannband_nn_1_N = mkN "pannband" neutrum  ;
  panikanfall_nn_1_N = mkN "panikanfall" neutrum  ;
  pang_nn_1_N = mkN "pang" neutrum  ;
  paltbroed_nn_1_1_N = mkN "paltbröd" neutrum  ;
  palmblad_nn_1_N = mkN "palmblad" neutrum  ;
  pall_nn_2_N = mkN "pall" neutrum  ;
  paket_nn_1_N = mkN "paket" neutrum  ;
  packdjur_nn_1_N = mkN "packdjur" neutrum  ;
  p_piller_nn_1_N = mkN "p-piller" neutrum  ;
  ozonskikt_nn_1_N = mkN "ozonskikt" neutrum  ;
  ozonlager_nn_1_N = mkN "ozonlager" neutrum  ;
  oxstyng_nn_1_N = mkN "oxstyng" neutrum  ;
  oxidationstal_nn_1_N = mkN "oxidationstal" neutrum  ;
  oxidationsmedel_nn_1_N = mkN "oxidationsmedel" neutrum  ;
  oxdjur_nn_1_N = mkN "oxdjur" neutrum  ;
  oxbaer_nn_1_1_N = mkN "oxbär" neutrum  ;
  ovaeder_nn_1_1_N = mkN "oväder" neutrum  ;
  otrohetsgrael_nn_1_1_N = mkN "otrohetsgräl" neutrum  ;
  osaekerhetsmoment_nn_1_1_N = mkN "osäkerhetsmoment" neutrum  ;
  ostronskal_nn_1_N = mkN "ostronskal" neutrum  ;
  ostron_nn_1_N = mkN "ostron" neutrum  ;
  oskick_nn_1_N = mkN "oskick" neutrum  ;
  oscilloskop_nn_1_N = mkN "oscilloskop" neutrum  ;
  orv_nn_1_N = mkN "orv" neutrum  ;
  ortstillaegg_nn_1_1_N = mkN "ortstillägg" neutrum  ;
  ortsavdrag_nn_1_N = mkN "ortsavdrag" neutrum  ;
  ortnamn_nn_1_N = mkN "ortnamn" neutrum  ;
  orsakssammanhang_nn_1_N = mkN "orsakssammanhang" neutrum  ;
  orsakssamband_nn_1_N = mkN "orsakssamband" neutrum  ;
  orosaar_nn_1_1_N = mkN "orosår" neutrum  ;
  orosmoment_nn_1_N = mkN "orosmoment" neutrum  ;
  orosmoln_nn_1_N = mkN "orosmoln" neutrum  ;
  ornament_nn_1_N = mkN "ornament" neutrum  ;
  ormskinn_nn_1_N = mkN "ormskinn" neutrum  ;
  ormhaar_nn_1_1_N = mkN "ormhår" neutrum  ;
  ormbaer_nn_1_1_N = mkN "ormbär" neutrum  ;
  originalspraak_nn_1_1_N = mkN "originalspråk" neutrum  ;
  originalitetskrav_nn_1_N = mkN "originalitetskrav" neutrum  ;
  originaldokument_nn_1_N = mkN "originaldokument" neutrum  ;
  orgelregister_nn_1_N = mkN "orgelregister" neutrum  ;
  organum_nn_1_N = mkN "organum" neutrum  ;
  organdonationskort_nn_1_N = mkN "organdonationskort" neutrum  ;
  organ_nn_1_N = mkN "organ" neutrum  ;
  ordval_nn_1_N = mkN "ordval" neutrum  ;
  ordsvall_nn_1_N = mkN "ordsvall" neutrum  ;
  ordstaev_nn_1_1_N = mkN "ordstäv" neutrum  ;
  ordspraak_nn_1_1_N = mkN "ordspråk" neutrum  ;
  ordslut_nn_1_N = mkN "ordslut" neutrum  ;
  ordnaet_nn_1_1_N = mkN "ordnät" neutrum  ;
  ordningstal_nn_1_N = mkN "ordningstal" neutrum  ;
  ordningsnummer_nn_1_N = mkN "ordningsnummer" neutrum  ;
  ordkrig_nn_1_N = mkN "ordkrig" neutrum  ;
  ordfoerraad_nn_1_1_N = mkN "ordförråd" neutrum  ;
  ordfoerandeskap_nn_1_1_N = mkN "ordförandeskap" neutrum  ;
  ordfragment_nn_1_N = mkN "ordfragment" neutrum  ;
  ordenssaellskap_nn_1_1_N = mkN "ordenssällskap" neutrum  ;
  ord_nn_1_N = mkN "ord" neutrum  ;
  orakelsvar_nn_1_N = mkN "orakelsvar" neutrum  ;
  or_nn_1_N = mkN "or" neutrum  ;
  oppsving_nn_1_N = mkN "oppsving" neutrum  ;
  oppstaellningsspaar_nn_1_1_N = mkN "oppställningsspår" neutrum  ;
  opplaegg_nn_1_1_N = mkN "opplägg" neutrum  ;
  oppflaag_nn_1_1_N = mkN "oppflåg" neutrum  ;
  oppflog_nn_1_N = mkN "oppflog" neutrum  ;
  opinionsorgan_nn_1_N = mkN "opinionsorgan" neutrum  ;
  operationsbestick_nn_1_N = mkN "operationsbestick" neutrum  ;
  ont_nn_1_N = mkN "ont" neutrum  ;
  omval_nn_1_N = mkN "omval" neutrum  ;
  omtryck_nn_1_N = mkN "omtryck" neutrum  ;
  omtal_nn_1_N = mkN "omtal" neutrum  ;
  omtag_nn_1_N = mkN "omtag" neutrum  ;
  omslut_nn_1_N = mkN "omslut" neutrum  ;
  omslagspapper_nn_1_N = mkN "omslagspapper" neutrum  ;
  omslag_nn_1_N = mkN "omslag" neutrum  ;
  omlopp_nn_1_N = mkN "omlopp" neutrum  ;
  omljud_nn_1_N = mkN "omljud" neutrum  ;
  omkoerningsfoerbud_nn_1_1_N = mkN "omkörningsförbud" neutrum  ;
  omkoep_nn_1_1_N = mkN "omköp" neutrum  ;
  omhopp_nn_1_N = mkN "omhopp" neutrum  ;
  ombud_nn_1_N = mkN "ombud" neutrum  ;
  omblad_nn_1_N = mkN "omblad" neutrum  ;
  olycksaar_nn_1_1_N = mkN "olycksår" neutrum  ;
  olyckstillbud_nn_1_N = mkN "olyckstillbud" neutrum  ;
  olyckstal_nn_1_N = mkN "olyckstal" neutrum  ;
  olycksfall_nn_1_N = mkN "olycksfall" neutrum  ;
  olycksbarn_nn_1_N = mkN "olycksbarn" neutrum  ;
  olvon_nn_1_N = mkN "olvon" neutrum  ;
  ollonsvin_nn_1_N = mkN "ollonsvin" neutrum  ;
  ollonskott_nn_1_N = mkN "ollonskott" neutrum  ;
  ollon_nn_1_N = mkN "ollon" neutrum  ;
  oljud_nn_1_N = mkN "oljud" neutrum  ;
  oljeutslaepp_nn_1_1_N = mkN "oljeutsläpp" neutrum  ;
  oljetraag_nn_1_1_N = mkN "oljetråg" neutrum  ;
  oljetryck_nn_1_N = mkN "oljetryck" neutrum  ;
  oljestaell_nn_1_1_N = mkN "oljeställ" neutrum  ;
  oljestopp_nn_1_N = mkN "oljestopp" neutrum  ;
  oljefaelt_nn_1_1_N = mkN "oljefält" neutrum  ;
  oljefilter_nn_1_N = mkN "oljefilter" neutrum  ;
  oljefat_nn_1_N = mkN "oljefat" neutrum  ;
  oljebytartraag_nn_1_1_N = mkN "oljebytartråg" neutrum  ;
  oljeborrtorn_nn_1_N = mkN "oljeborrtorn" neutrum  ;
  oljebolag_nn_1_N = mkN "oljebolag" neutrum  ;
  oljebad_nn_1_N = mkN "oljebad" neutrum  ;
  oljeaggregat_nn_1_N = mkN "oljeaggregat" neutrum  ;
  oligopol_nn_1_N = mkN "oligopol" neutrum  ;
  oleat_nn_2_N = mkN "oleat" neutrum  ;
  okvaedinsord_nn_1_1_N = mkN "okvädinsord" neutrum  ;
  okvaedingsord_nn_1_1_N = mkN "okvädingsord" neutrum  ;
  okular_nn_1_N = mkN "okular" neutrum  ;
  oktantal_nn_1_N = mkN "oktantal" neutrum  ;
  okben_nn_1_N = mkN "okben" neutrum  ;
  ok_nn_1_N = mkN "ok" neutrum  ;
  ohaelsotal_nn_1_1_N = mkN "ohälsotal" neutrum  ;
  oftalmoskop_nn_1_N = mkN "oftalmoskop" neutrum  ;
  ofog_nn_1_N = mkN "ofog" neutrum  ;
  offerlamm_nn_1_N = mkN "offerlamm" neutrum  ;
  odon_nn_1_N = mkN "odon" neutrum  ;
  odlingslager_nn_1_N = mkN "odlingslager" neutrum  ;
  odlingsfoersoek_nn_1_1_N = mkN "odlingsförsök" neutrum  ;
  odjur_nn_1_N = mkN "odjur" neutrum  ;
  observationsmaterial_nn_1_N = mkN "observationsmaterial" neutrum  ;
  obligationslaan_nn_1_1_N = mkN "obligationslån" neutrum  ;
  objektspraak_nn_1_1_N = mkN "objektspråk" neutrum  ;
  objekt_nn_1_N = mkN "objekt" neutrum  ;
  obehag_nn_1_N = mkN "obehag" neutrum  ;
  obduktionsresultat_nn_1_N = mkN "obduktionsresultat" neutrum  ;
  oaktsamhetsbrott_nn_1_N = mkN "oaktsamhetsbrott" neutrum  ;
  noetstyng_nn_1_1_N = mkN "nötstyng" neutrum  ;
  noetskal_nn_1_1_N = mkN "nötskal" neutrum  ;
  noetkreatur_nn_1_1_N = mkN "nötkreatur" neutrum  ;
  noet_nn_2_1_N = mkN "nöt" neutrum  ;
  noejesfaelt_nn_1_1_N = mkN "nöjesfält" neutrum  ;
  noejesetablissemang_nn_1_1_N = mkN "nöjesetablissemang" neutrum  ;
  noejesdistrikt_nn_1_1_N = mkN "nöjesdistrikt" neutrum  ;
  noejesbegaer_nn_1_1_N = mkN "nöjesbegär" neutrum  ;
  noedaar_nn_1_1_N = mkN "nödår" neutrum  ;
  noedstopp_nn_1_1_N = mkN "nödstopp" neutrum  ;
  noedrop_nn_1_1_N = mkN "nödrop" neutrum  ;
  noedmynt_nn_1_1_N = mkN "nödmynt" neutrum  ;
  noedlaan_nn_1_1_N = mkN "nödlån" neutrum  ;
  noedfall_nn_1_1_N = mkN "nödfall" neutrum  ;
  noeddop_nn_1_1_N = mkN "nöddop" neutrum  ;
  noedanrop_nn_1_1_N = mkN "nödanrop" neutrum  ;
  naatstaal_nn_1_1_N = mkN "nåtstål" neutrum  ;
  naalstyng_nn_1_1_N = mkN "nålstyng" neutrum  ;
  naalstygn_nn_1_1_N = mkN "nålstygn" neutrum  ;
  naalsting_nn_1_1_N = mkN "nålsting" neutrum  ;
  naalsticksangrepp_nn_1_1_N = mkN "nålsticksangrepp" neutrum  ;
  naalstick_nn_1_1_N = mkN "nålstick" neutrum  ;
  naalkort_nn_1_1_N = mkN "nålkort" neutrum  ;
  naalbrev_nn_1_1_N = mkN "nålbrev" neutrum  ;
  naadaar_nn_1_1_N = mkN "nådår" neutrum  ;
  naademedel_nn_1_1_N = mkN "nådemedel" neutrum  ;
  naadehjon_nn_1_1_N = mkN "nådehjon" neutrum  ;
  naadebord_nn_1_1_N = mkN "nådebord" neutrum  ;
  naadaval_nn_1_1_N = mkN "nådaval" neutrum  ;
  naadaskott_nn_1_1_N = mkN "nådaskott" neutrum  ;
  naeverflak_nn_1_1_N = mkN "näverflak" neutrum  ;
  naetverk_nn_1_1_N = mkN "nätverk" neutrum  ;
  naetuppslagsverk_nn_1_1_N = mkN "nätuppslagsverk" neutrum  ;
  naetfoenster_nn_1_1_N = mkN "nätfönster" neutrum  ;
  naet_nn_1_1_N = mkN "nät" neutrum  ;
  naestaegg_nn_1_1_N = mkN "nästägg" neutrum  ;
  naesseldjur_nn_1_1_N = mkN "nässeldjur" neutrum  ;
  naesljud_nn_1_1_N = mkN "näsljud" neutrum  ;
  naesben_nn_1_1_N = mkN "näsben" neutrum  ;
  naesavtryck_nn_1_1_N = mkN "näsavtryck" neutrum  ;
  naeringsmedel_nn_1_1_N = mkN "näringsmedel" neutrum  ;
  naeringsfaang_nn_1_1_N = mkN "näringsfång" neutrum  ;
  naektergalsslag_nn_1_1_N = mkN "näktergalsslag" neutrum  ;
  naeckrosblad_nn_1_1_N = mkN "näckrosblad" neutrum  ;
  naebbdjur_nn_1_1_N = mkN "näbbdjur" neutrum  ;
  nyaar_nn_1_1_N = mkN "nyår" neutrum  ;
  nyval_nn_1_N = mkN "nyval" neutrum  ;
  nyttofoeremaal_nn_1_1_N = mkN "nyttoföremål" neutrum  ;
  nytryck_nn_1_N = mkN "nytryck" neutrum  ;
  nytillskott_nn_1_N = mkN "nytillskott" neutrum  ;
  nystan_nn_1_N = mkN "nystan" neutrum  ;
  nyskott_nn_1_N = mkN "nyskott" neutrum  ;
  nypon_nn_1_N = mkN "nypon" neutrum  ;
  nyp_nn_1_N = mkN "nyp" neutrum  ;
  nyord_nn_1_N = mkN "nyord" neutrum  ;
  nylonhjul_nn_1_N = mkN "nylonhjul" neutrum  ;
  nyhetssoek_nn_1_1_N = mkN "nyhetssök" neutrum  ;
  nyhetsblad_nn_1_N = mkN "nyhetsblad" neutrum  ;
  nyfoervaerv_nn_1_1_N = mkN "nyförvärv" neutrum  ;
  nyckelskaap_nn_1_1_N = mkN "nyckelskåp" neutrum  ;
  nyckelord_nn_1_N = mkN "nyckelord" neutrum  ;
  nyckelkort_nn_1_N = mkN "nyckelkort" neutrum  ;
  nyckelinslag_nn_1_N = mkN "nyckelinslag" neutrum  ;
  nyckelhaal_nn_1_1_N = mkN "nyckelhål" neutrum  ;
  nyckelblomster_nn_1_N = mkN "nyckelblomster" neutrum  ;
  nyckelben_nn_1_N = mkN "nyckelben" neutrum  ;
  nyckelbarn_nn_1_N = mkN "nyckelbarn" neutrum  ;
  nyboerjarset_nn_1_1_N = mkN "nybörjarset" neutrum  ;
  nutritionsorgan_nn_1_N = mkN "nutritionsorgan" neutrum  ;
  nunnedok_nn_1_N = mkN "nunnedok" neutrum  ;
  nummer_nn_1_N = mkN "nummer" neutrum  ;
  numerus_nn_1_N = mkN "numerus" neutrum  ;
  nukleontal_nn_1_N = mkN "nukleontal" neutrum  ;
  novitiat_nn_1_N = mkN "novitiat" neutrum  ;
  novautbrott_nn_1_N = mkN "novautbrott" neutrum  ;
  notvarp_nn_1_N = mkN "notvarp" neutrum  ;
  notstaal_nn_1_1_N = mkN "notstål" neutrum  ;
  notstaell_nn_1_1_N = mkN "notställ" neutrum  ;
  notplan_nn_1_N = mkN "notplan" neutrum  ;
  notpapper_nn_1_N = mkN "notpapper" neutrum  ;
  notlag_nn_1_N = mkN "notlag" neutrum  ;
  notesblock_nn_1_N = mkN "notesblock" neutrum  ;
  notblad_nn_1_N = mkN "notblad" neutrum  ;
  notariat_nn_1_N = mkN "notariat" neutrum  ;
  noshjul_nn_1_N = mkN "noshjul" neutrum  ;
  normaltillstaand_nn_1_1_N = mkN "normaltillstånd" neutrum  ;
  normalmaatt_nn_1_1_N = mkN "normalmått" neutrum  ;
  nordanland_nn_1_N = mkN "nordanland" neutrum  ;
  nor_nn_1_N = mkN "nor" neutrum  ;
  nonstopflyg_nn_1_N = mkN "nonstopflyg" neutrum  ;
  nonaggressionsfoerdrag_nn_1_1_N = mkN "nonaggressionsfördrag" neutrum  ;
  nominativsubjekt_nn_1_N = mkN "nominativsubjekt" neutrum  ;
  nomadfolk_nn_1_N = mkN "nomadfolk" neutrum  ;
  nollutslaepp_nn_1_1_N = mkN "nollutsläpp" neutrum  ;
  nollspant_nn_1_N = mkN "nollspant" neutrum  ;
  nollplan_nn_1_N = mkN "nollplan" neutrum  ;
  nollkorrektur_nn_1_N = mkN "nollkorrektur" neutrum  ;
  noaord_nn_1_N = mkN "noaord" neutrum  ;
  noanamn_nn_1_N = mkN "noanamn" neutrum  ;
  njutningsmedel_nn_1_N = mkN "njutningsmedel" neutrum  ;
  njurbaecken_nn_1_1_N = mkN "njurbäcken" neutrum  ;
  nitfoerband_nn_1_1_N = mkN "nitförband" neutrum  ;
  nidingsverk_nn_1_N = mkN "nidingsverk" neutrum  ;
  nidingsdaad_nn_1_1_N = mkN "nidingsdåd" neutrum  ;
  ng_ljud_nn_1_N = mkN "ng-ljud" neutrum  ;
  neutrinohav_nn_1_N = mkN "neutrinohav" neutrum  ;
  nervvrak_nn_1_N = mkN "nervvrak" neutrum  ;
  nervsignalmoenster_nn_1_1_N = mkN "nervsignalmönster" neutrum  ;
  nervsammanbrott_nn_1_N = mkN "nervsammanbrott" neutrum  ;
  nervkrig_nn_1_N = mkN "nervkrig" neutrum  ;
  nerstraak_nn_1_1_N = mkN "nerstråk" neutrum  ;
  nerslaepp_nn_1_1_N = mkN "nersläpp" neutrum  ;
  nerslag_nn_1_N = mkN "nerslag" neutrum  ;
  nerlaeggningshot_nn_1_1_N = mkN "nerläggningshot" neutrum  ;
  nerfall_nn_1_N = mkN "nerfall" neutrum  ;
  neonroer_nn_1_1_N = mkN "neonrör" neutrum  ;
  nektardrag_nn_1_N = mkN "nektardrag" neutrum  ;
  nedstraak_nn_1_1_N = mkN "nedstråk" neutrum  ;
  nedslaepp_nn_1_1_N = mkN "nedsläpp" neutrum  ;
  nedslag_nn_1_N = mkN "nedslag" neutrum  ;
  nedlaeggningshot_nn_1_1_N = mkN "nedläggningshot" neutrum  ;
  nedfall_nn_1_N = mkN "nedfall" neutrum  ;
  nederlag_nn_1_N = mkN "nederlag" neutrum  ;
  nedan_nn_1_N = mkN "nedan" neutrum  ;
  nazibrott_nn_1_N = mkN "nazibrott" neutrum  ;
  navelsvin_nn_1_N = mkN "navelsvin" neutrum  ;
  navelband_nn_1_N = mkN "navelband" neutrum  ;
  navajoreservat_nn_1_N = mkN "navajoreservat" neutrum  ;
  navahoreservat_nn_1_N = mkN "navahoreservat" neutrum  ;
  nav_nn_1_N = mkN "nav" neutrum  ;
  naturvaardsverk_nn_1_1_N = mkN "naturvårdsverk" neutrum  ;
  naturtillstaand_nn_1_1_N = mkN "naturtillstånd" neutrum  ;
  naturreservat_nn_1_N = mkN "naturreservat" neutrum  ;
  naturnamn_nn_1_N = mkN "naturnamn" neutrum  ;
  naturlaekemedel_nn_1_1_N = mkN "naturläkemedel" neutrum  ;
  naturljud_nn_1_N = mkN "naturljud" neutrum  ;
  naturhorn_nn_1_N = mkN "naturhorn" neutrum  ;
  naturhinder_nn_1_N = mkN "naturhinder" neutrum  ;
  naturfoeremaal_nn_1_1_N = mkN "naturföremål" neutrum  ;
  naturfolk_nn_1_N = mkN "naturfolk" neutrum  ;
  naturfenomen_nn_1_N = mkN "naturfenomen" neutrum  ;
  naturbehov_nn_1_N = mkN "naturbehov" neutrum  ;
  naturbarn_nn_1_N = mkN "naturbarn" neutrum  ;
  naturaliekabinett_nn_1_N = mkN "naturaliekabinett" neutrum  ;
  nattaag_nn_1_1_N = mkN "nattåg" neutrum  ;
  nattygsbord_nn_1_N = mkN "nattygsbord" neutrum  ;
  nattvardskaerl_nn_1_1_N = mkN "nattvardskärl" neutrum  ;
  nattvardsbroed_nn_1_1_N = mkN "nattvardsbröd" neutrum  ;
  nattvardsbord_nn_1_N = mkN "nattvardsbord" neutrum  ;
  nattvardsbarn_nn_1_N = mkN "nattvardsbarn" neutrum  ;
  nattvak_nn_1_N = mkN "nattvak" neutrum  ;
  nattspaar_nn_1_1_N = mkN "nattspår" neutrum  ;
  nattslag_nn_1_N = mkN "nattslag" neutrum  ;
  nattskift_nn_1_N = mkN "nattskift" neutrum  ;
  nattraj_nn_1_N = mkN "nattraj" neutrum  ;
  nattmoln_nn_1_N = mkN "nattmoln" neutrum  ;
  nattlaeger_nn_1_1_N = mkN "nattläger" neutrum  ;
  nattkaerl_nn_1_1_N = mkN "nattkärl" neutrum  ;
  nattfack_nn_1_N = mkN "nattfack" neutrum  ;
  nattduksbord_nn_1_N = mkN "nattduksbord" neutrum  ;
  nattdjur_nn_1_N = mkN "nattdjur" neutrum  ;
  nattbord_nn_1_N = mkN "nattbord" neutrum  ;
  nationalspraak_nn_1_1_N = mkN "nationalspråk" neutrum  ;
  nationalkapital_nn_1_N = mkN "nationalkapital" neutrum  ;
  nationalitetsintyg_nn_1_N = mkN "nationalitetsintyg" neutrum  ;
  nationalitetscertifikat_nn_1_N = mkN "nationalitetscertifikat" neutrum  ;
  nationalhelgon_nn_1_N = mkN "nationalhelgon" neutrum  ;
  nationaldrag_nn_1_N = mkN "nationaldrag" neutrum  ;
  nationalbegrepp_nn_1_N = mkN "nationalbegrepp" neutrum  ;
  narrstreck_nn_1_N = mkN "narrstreck" neutrum  ;
  narkotikainnehav_nn_1_N = mkN "narkotikainnehav" neutrum  ;
  narkotikabrott_nn_1_N = mkN "narkotikabrott" neutrum  ;
  narkosmedel_nn_1_N = mkN "narkosmedel" neutrum  ;
  nappatag_nn_1_N = mkN "nappatag" neutrum  ;
  napp_nn_1_N = mkN "napp" neutrum  ;
  nanoroer_nn_1_1_N = mkN "nanorör" neutrum  ;
  nanokolroer_nn_1_1_N = mkN "nanokolrör" neutrum  ;
  namnupprop_nn_1_N = mkN "namnupprop" neutrum  ;
  namnskydd_nn_1_N = mkN "namnskydd" neutrum  ;
  namnsdagsbarn_nn_1_N = mkN "namnsdagsbarn" neutrum  ;
  namnanrop_nn_1_N = mkN "namnanrop" neutrum  ;
  namn_nn_1_N = mkN "namn" neutrum  ;
  nakenbad_nn_1_N = mkN "nakenbad" neutrum  ;
  najtaag_nn_1_1_N = mkN "najtåg" neutrum  ;
  nagg_nn_2_N = mkN "nagg" neutrum  ;
  nagellack_nn_1_N = mkN "nagellack" neutrum  ;
  nagelband_nn_1_N = mkN "nagelband" neutrum  ;
  nacksving_nn_1_N = mkN "nacksving" neutrum  ;
  nackben_nn_1_N = mkN "nackben" neutrum  ;
  nachspil_nn_1_N = mkN "nachspil" neutrum  ;
  n_nn_1_N = mkN "n" neutrum  ;
  moetesspaar_nn_1_1_N = mkN "mötesspår" neutrum  ;
  moetesfoerbud_nn_1_1_N = mkN "mötesförbud" neutrum  ;
  moesskapell_nn_1_1_N = mkN "mösskapell" neutrum  ;
  moerklaeggningsfoersoek_nn_1_1_N = mkN "mörkläggningsförsök" neutrum  ;
  moerkertal_nn_1_1_N = mkN "mörkertal" neutrum  ;
  moerdarband_nn_1_1_N = mkN "mördarband" neutrum  ;
  moensterskydd_nn_1_1_N = mkN "mönsterskydd" neutrum  ;
  moensterjordbruk_nn_1_1_N = mkN "mönsterjordbruk" neutrum  ;
  moensterdjup_nn_1_1_N = mkN "mönsterdjup" neutrum  ;
  moenster_nn_1_1_N = mkN "mönster" neutrum  ;
  moebeloeverdrag_nn_1_1_N = mkN "möbelöverdrag" neutrum  ;
  moebelfoeretag_nn_1_1_N = mkN "möbelföretag" neutrum  ;
  maattverktyg_nn_1_1_N = mkN "måttverktyg" neutrum  ;
  maattband_nn_1_1_N = mkN "måttband" neutrum  ;
  maatt_nn_1_1_N = mkN "mått" neutrum  ;
  maasaegg_nn_1_1_N = mkN "måsägg" neutrum  ;
  maarddjur_nn_1_1_N = mkN "mårddjur" neutrum  ;
  maanaar_nn_1_1_N = mkN "månår" neutrum  ;
  maanvarv_nn_1_1_N = mkN "månvarv" neutrum  ;
  maanlandskap_nn_1_1_N = mkN "månlandskap" neutrum  ;
  maangmiljardbelopp_nn_1_1_N = mkN "mångmiljardbelopp" neutrum  ;
  maandygn_nn_1_1_N = mkN "måndygn" neutrum  ;
  maandagsexemplar_nn_1_1_N = mkN "måndagsexemplar" neutrum  ;
  maanadtal_nn_1_1_N = mkN "månadtal" neutrum  ;
  maanadssmultron_nn_1_1_N = mkN "månadssmultron" neutrum  ;
  maanadskort_nn_1_1_N = mkN "månadskort" neutrum  ;
  maanadsbidrag_nn_1_1_N = mkN "månadsbidrag" neutrum  ;
  maalspraak_nn_1_1_N = mkN "målspråk" neutrum  ;
  maal_nn_1_1_N = mkN "mål" neutrum  ;
  maabaer_nn_1_1_N = mkN "måbär" neutrum  ;
  maetverktyg_nn_1_1_N = mkN "mätverktyg" neutrum  ;
  maettningstryck_nn_1_1_N = mkN "mättningstryck" neutrum  ;
  maetredskap_nn_1_1_N = mkN "mätredskap" neutrum  ;
  maetningstal_nn_1_1_N = mkN "mätningstal" neutrum  ;
  maetningsfartyg_nn_1_1_N = mkN "mätningsfartyg" neutrum  ;
  maetinstrument_nn_1_1_N = mkN "mätinstrument" neutrum  ;
  maetetal_nn_1_1_N = mkN "mätetal" neutrum  ;
  maetbrev_nn_1_1_N = mkN "mätbrev" neutrum  ;
  maetbord_nn_1_1_N = mkN "mätbord" neutrum  ;
  maetband_nn_1_1_N = mkN "mätband" neutrum  ;
  maesterverk_nn_1_1_N = mkN "mästerverk" neutrum  ;
  maesterskap_nn_1_1_N = mkN "mästerskap" neutrum  ;
  maestarprov_nn_1_1_N = mkN "mästarprov" neutrum  ;
  maestarbrev_nn_1_1_N = mkN "mästarbrev" neutrum  ;
  maessingsinstrument_nn_1_1_N = mkN "mässingsinstrument" neutrum  ;
  maessingsfotstoed_nn_1_1_N = mkN "mässingsfotstöd" neutrum  ;
  maessinginstrument_nn_1_1_N = mkN "mässinginstrument" neutrum  ;
  maessingblaasinstrument_nn_1_1_N = mkN "mässingblåsinstrument" neutrum  ;
  maessfall_nn_1_1_N = mkN "mässfall" neutrum  ;
  maerkband_nn_1_1_N = mkN "märkband" neutrum  ;
  maergben_nn_1_1_N = mkN "märgben" neutrum  ;
  maenskobarn_nn_1_1_N = mkN "mänskobarn" neutrum  ;
  maenniskoraettsbrott_nn_1_1_N = mkN "människorättsbrott" neutrum  ;
  maenniskorov_nn_1_1_N = mkN "människorov" neutrum  ;
  maenniskoliv_nn_1_1_N = mkN "människoliv" neutrum  ;
  maenniskolik_nn_1_1_N = mkN "människolik" neutrum  ;
  maenniskofoster_nn_1_1_N = mkN "människofoster" neutrum  ;
  maenniskoben_nn_1_1_N = mkN "människoben" neutrum  ;
  maenniskobarn_nn_1_1_N = mkN "människobarn" neutrum  ;
  maelarlandskap_nn_1_1_N = mkN "mälarlandskap" neutrum  ;
  myskdjur_nn_1_N = mkN "myskdjur" neutrum  ;
  myraegg_nn_1_1_N = mkN "myrägg" neutrum  ;
  myrsteg_nn_1_N = mkN "myrsteg" neutrum  ;
  myrlejon_nn_1_N = mkN "myrlejon" neutrum  ;
  myrland_nn_1_N = mkN "myrland" neutrum  ;
  myom_nn_1_N = mkN "myom" neutrum  ;
  myntverk_nn_1_N = mkN "myntverk" neutrum  ;
  mynt_nn_1_N = mkN "mynt" neutrum  ;
  myndighetstillstaand_nn_1_1_N = mkN "myndighetstillstånd" neutrum  ;
  myggnaet_nn_1_1_N = mkN "myggnät" neutrum  ;
  myggmedel_nn_1_N = mkN "myggmedel" neutrum  ;
  myggfoenster_nn_1_1_N = mkN "myggfönster" neutrum  ;
  myggbett_nn_1_N = mkN "myggbett" neutrum  ;
  mygg_nn_1_N = mkN "mygg" neutrum  ;
  mutterknack_nn_1_N = mkN "mutterknack" neutrum  ;
  mutbrott_nn_1_N = mkN "mutbrott" neutrum  ;
  musselskal_nn_1_N = mkN "musselskal" neutrum  ;
  musklick_nn_1_N = mkN "musklick" neutrum  ;
  musikverk_nn_1_N = mkN "musikverk" neutrum  ;
  musikliv_nn_1_N = mkN "musikliv" neutrum  ;
  musikinstrument_nn_1_N = mkN "musikinstrument" neutrum  ;
  musikfoerlag_nn_1_1_N = mkN "musikförlag" neutrum  ;
  museifoeremaal_nn_1_1_N = mkN "museiföremål" neutrum  ;
  musbarn_nn_1_N = mkN "musbarn" neutrum  ;
  murverk_nn_1_N = mkN "murverk" neutrum  ;
  murskift_nn_1_N = mkN "murskift" neutrum  ;
  murmeldjur_nn_1_N = mkN "murmeldjur" neutrum  ;
  murliv_nn_1_N = mkN "murliv" neutrum  ;
  murkroen_nn_1_1_N = mkN "murkrön" neutrum  ;
  murintag_nn_1_N = mkN "murintag" neutrum  ;
  murhoern_nn_1_1_N = mkN "murhörn" neutrum  ;
  murgroenemoenster_nn_1_1_N = mkN "murgrönemönster" neutrum  ;
  murfoerband_nn_1_1_N = mkN "murförband" neutrum  ;
  murband_nn_1_N = mkN "murband" neutrum  ;
  murarverktyg_nn_1_N = mkN "murarverktyg" neutrum  ;
  munvaeder_nn_1_1_N = mkN "munväder" neutrum  ;
  munsaar_nn_1_1_N = mkN "munsår" neutrum  ;
  munskydd_nn_1_N = mkN "munskydd" neutrum  ;
  munlag_nn_1_N = mkN "munlag" neutrum  ;
  munkfoerband_nn_1_1_N = mkN "munkförband" neutrum  ;
  multituberkulat_nn_1_N = mkN "multituberkulat" neutrum  ;
  multipeltaag_nn_1_1_N = mkN "multipeltåg" neutrum  ;
  multihandikapp_nn_1_N = mkN "multihandikapp" neutrum  ;
  mullbaersfikon_nn_1_1_N = mkN "mullbärsfikon" neutrum  ;
  mullbaer_nn_1_1_N = mkN "mullbär" neutrum  ;
  mufflonfaar_nn_1_1_N = mkN "mufflonfår" neutrum  ;
  mudderverk_nn_1_N = mkN "mudderverk" neutrum  ;
  motstaandarlag_nn_1_1_N = mkN "motståndarlag" neutrum  ;
  motstaand_nn_1_1_N = mkN "motstånd" neutrum  ;
  motskael_nn_1_1_N = mkN "motskäl" neutrum  ;
  motskott_nn_1_N = mkN "motskott" neutrum  ;
  motsatspar_nn_1_N = mkN "motsatspar" neutrum  ;
  motorstopp_nn_1_N = mkN "motorstopp" neutrum  ;
  motorskydd_nn_1_N = mkN "motorskydd" neutrum  ;
  motorljud_nn_1_N = mkN "motorljud" neutrum  ;
  motorhotell_nn_1_N = mkN "motorhotell" neutrum  ;
  motorfordon_nn_1_N = mkN "motorfordon" neutrum  ;
  motorfartyg_nn_1_N = mkN "motorfartyg" neutrum  ;
  motorcykelstaell_nn_1_1_N = mkN "motorcykelställ" neutrum  ;
  motlut_nn_1_N = mkN "motlut" neutrum  ;
  motkrav_nn_1_N = mkN "motkrav" neutrum  ;
  motionsspaar_nn_1_1_N = mkN "motionsspår" neutrum  ;
  motinlaegg_nn_1_1_N = mkN "motinlägg" neutrum  ;
  mothaall_nn_1_1_N = mkN "mothåll" neutrum  ;
  mothugg_nn_1_N = mkN "mothugg" neutrum  ;
  motfoerslag_nn_1_1_N = mkN "motförslag" neutrum  ;
  motell_nn_1_N = mkN "motell" neutrum  ;
  motdrag_nn_1_N = mkN "motdrag" neutrum  ;
  motbud_nn_1_N = mkN "motbud" neutrum  ;
  motargument_nn_1_N = mkN "motargument" neutrum  ;
  motangrepp_nn_1_N = mkN "motangrepp" neutrum  ;
  motanfall_nn_1_N = mkN "motanfall" neutrum  ;
  mot_nn_1_N = mkN "mot" neutrum  ;
  mosslik_nn_1_N = mkN "mosslik" neutrum  ;
  mossfynd_nn_1_N = mkN "mossfynd" neutrum  ;
  mossfolk_nn_1_N = mkN "mossfolk" neutrum  ;
  moskitnaet_nn_1_1_N = mkN "moskitnät" neutrum  ;
  mosaikmoenster_nn_1_1_N = mkN "mosaikmönster" neutrum  ;
  mosaiklandskap_nn_1_N = mkN "mosaiklandskap" neutrum  ;
  morsarv_nn_1_N = mkN "morsarv" neutrum  ;
  morrhaar_nn_1_1_N = mkN "morrhår" neutrum  ;
  morkullsstraeck_nn_1_1_N = mkN "morkullssträck" neutrum  ;
  mordfoersoek_nn_1_1_N = mkN "mordförsök" neutrum  ;
  mordfall_nn_1_N = mkN "mordfall" neutrum  ;
  mord_nn_1_N = mkN "mord" neutrum  ;
  moralbegrepp_nn_1_N = mkN "moralbegrepp" neutrum  ;
  monument_nn_1_N = mkN "monument" neutrum  ;
  monteringshaal_nn_1_1_N = mkN "monteringshål" neutrum  ;
  monsterfartyg_nn_1_N = mkN "monsterfartyg" neutrum  ;
  monster_nn_1_N = mkN "monster" neutrum  ;
  monopol_nn_1_N = mkN "monopol" neutrum  ;
  monoplan_nn_1_N = mkN "monoplan" neutrum  ;
  moment_nn_1_N = mkN "moment" neutrum  ;
  moln_nn_1_N = mkN "moln" neutrum  ;
  mollackord_nn_1_N = mkN "mollackord" neutrum  ;
  modersmaal_nn_1_1_N = mkN "modersmål" neutrum  ;
  moderskepp_nn_1_N = mkN "moderskepp" neutrum  ;
  modernitetsideal_nn_1_N = mkN "modernitetsideal" neutrum  ;
  moderliv_nn_1_N = mkN "moderliv" neutrum  ;
  moderfoeretag_nn_1_1_N = mkN "moderföretag" neutrum  ;
  moderbolag_nn_1_N = mkN "moderbolag" neutrum  ;
  modeord_nn_1_N = mkN "modeord" neutrum  ;
  modemagasin_nn_1_N = mkN "modemagasin" neutrum  ;
  modellplan_nn_1_N = mkN "modellplan" neutrum  ;
  modellfoersoek_nn_1_1_N = mkN "modellförsök" neutrum  ;
  modellflygplan_nn_1_N = mkN "modellflygplan" neutrum  ;
  modelejon_nn_1_N = mkN "modelejon" neutrum  ;
  mobilsamtal_nn_1_N = mkN "mobilsamtal" neutrum  ;
  mobilabonnemang_nn_1_N = mkN "mobilabonnemang" neutrum  ;
  mjoelon_nn_1_1_N = mkN "mjölon" neutrum  ;
  mjoelkoeverskott_nn_1_1_N = mkN "mjölköverskott" neutrum  ;
  mjoelkspann_nn_1_1_N = mkN "mjölkspann" neutrum  ;
  mjoelkpaket_nn_1_1_N = mkN "mjölkpaket" neutrum  ;
  mjoelkkaerl_nn_1_1_N = mkN "mjölkkärl" neutrum  ;
  mjoelkgrymt_nn_1_1_N = mkN "mjölkgrymt" neutrum  ;
  mjoelkbud_nn_1_1_N = mkN "mjölkbud" neutrum  ;
  mjaelthugg_nn_1_1_N = mkN "mjälthugg" neutrum  ;
  mjukningsmedel_nn_1_N = mkN "mjukningsmedel" neutrum  ;
  mjukisdjur_nn_1_N = mkN "mjukisdjur" neutrum  ;
  mittskepp_nn_1_N = mkN "mittskepp" neutrum  ;
  mittfaelt_nn_1_1_N = mkN "mittfält" neutrum  ;
  mittenlager_nn_1_N = mkN "mittenlager" neutrum  ;
  missvaextaar_nn_1_1_N = mkN "missväxtår" neutrum  ;
  misstag_nn_1_N = mkN "misstag" neutrum  ;
  missljud_nn_1_N = mkN "missljud" neutrum  ;
  missionshotell_nn_1_N = mkN "missionshotell" neutrum  ;
  missionsfoerbund_nn_1_1_N = mkN "missionsförbund" neutrum  ;
  missionsfaelt_nn_1_1_N = mkN "missionsfält" neutrum  ;
  missionsbudskap_nn_1_N = mkN "missionsbudskap" neutrum  ;
  misshandelsfall_nn_1_N = mkN "misshandelsfall" neutrum  ;
  missgrepp_nn_1_N = mkN "missgrepp" neutrum  ;
  missfoerstaand_nn_1_1_N = mkN "missförstånd" neutrum  ;
  missfoster_nn_1_N = mkN "missfoster" neutrum  ;
  missfall_nn_1_N = mkN "missfall" neutrum  ;
  missdaad_nn_1_1_N = mkN "missdåd" neutrum  ;
  missbruk_nn_1_N = mkN "missbruk" neutrum  ;
  minsvep_nn_1_N = mkN "minsvep" neutrum  ;
  minoritetsskydd_nn_1_N = mkN "minoritetsskydd" neutrum  ;
  minoritetsfolk_nn_1_N = mkN "minoritetsfolk" neutrum  ;
  minnestal_nn_1_N = mkN "minnestal" neutrum  ;
  minnesspaar_nn_1_1_N = mkN "minnesspår" neutrum  ;
  minnesord_nn_1_N = mkN "minnesord" neutrum  ;
  minnesfragment_nn_1_N = mkN "minnesfragment" neutrum  ;
  ministerraad_nn_1_1_N = mkN "ministerråd" neutrum  ;
  minimibelopp_nn_1_N = mkN "minimibelopp" neutrum  ;
  minfaelt_nn_1_1_N = mkN "minfält" neutrum  ;
  minfartyg_nn_1_N = mkN "minfartyg" neutrum  ;
  mineraloeverdrag_nn_1_1_N = mkN "mineralöverdrag" neutrum  ;
  mindretal_nn_1_N = mkN "mindretal" neutrum  ;
  minaretfoerbud_nn_1_1_N = mkN "minaretförbud" neutrum  ;
  millimeterpapper_nn_1_N = mkN "millimeterpapper" neutrum  ;
  miljoeutskott_nn_1_1_N = mkN "miljöutskott" neutrum  ;
  miljoekrav_nn_1_1_N = mkN "miljökrav" neutrum  ;
  miljoehaensyn_nn_1_1_N = mkN "miljöhänsyn" neutrum  ;
  miljoebrott_nn_1_1_N = mkN "miljöbrott" neutrum  ;
  miljoeavtal_nn_1_1_N = mkN "miljöavtal" neutrum  ;
  miljonstoed_nn_1_1_N = mkN "miljonstöd" neutrum  ;
  miljonskadestaand_nn_1_1_N = mkN "miljonskadestånd" neutrum  ;
  miljonklipp_nn_1_N = mkN "miljonklipp" neutrum  ;
  miljonbelopp_nn_1_N = mkN "miljonbelopp" neutrum  ;
  miljardlaan_nn_1_1_N = mkN "miljardlån" neutrum  ;
  militaerfordon_nn_1_1_N = mkN "militärfordon" neutrum  ;
  mildvaeder_nn_1_1_N = mkN "mildväder" neutrum  ;
  mikroskop_nn_1_N = mkN "mikroskop" neutrum  ;
  mikrolock_nn_1_N = mkN "mikrolock" neutrum  ;
  mikrokort_nn_1_N = mkN "mikrokort" neutrum  ;
  midvinterblot_nn_1_N = mkN "midvinterblot" neutrum  ;
  midsommarblomster_nn_1_N = mkN "midsommarblomster" neutrum  ;
  midjemaatt_nn_1_1_N = mkN "midjemått" neutrum  ;
  midjeband_nn_1_N = mkN "midjeband" neutrum  ;
  middagssaellskap_nn_1_1_N = mkN "middagssällskap" neutrum  ;
  middagsmaal_nn_1_1_N = mkN "middagsmål" neutrum  ;
  microlock_nn_1_N = mkN "microlock" neutrum  ;
  metodkrav_nn_1_N = mkN "metodkrav" neutrum  ;
  metermaatt_nn_1_1_N = mkN "metermått" neutrum  ;
  meteorjaern_nn_1_1_N = mkN "meteorjärn" neutrum  ;
  meteoritnedslag_nn_1_N = mkN "meteoritnedslag" neutrum  ;
  metaspraak_nn_1_1_N = mkN "metaspråk" neutrum  ;
  metallspaan_nn_1_1_N = mkN "metallspån" neutrum  ;
  metallpulver_nn_1_N = mkN "metallpulver" neutrum  ;
  metallgolv_nn_1_N = mkN "metallgolv" neutrum  ;
  metallfoeremaal_nn_1_1_N = mkN "metallföremål" neutrum  ;
  metallbad_nn_1_N = mkN "metallbad" neutrum  ;
  metakoek_nn_1_1_N = mkN "metakök" neutrum  ;
  merinofaar_nn_1_1_N = mkN "merinofår" neutrum  ;
  menyfoerslag_nn_1_1_N = mkN "menyförslag" neutrum  ;
  mensskydd_nn_1_N = mkN "mensskydd" neutrum  ;
  men_nn_1_N = mkN "men" neutrum  ;
  mellanverk_nn_1_N = mkN "mellanverk" neutrum  ;
  mellanting_nn_1_N = mkN "mellanting" neutrum  ;
  mellanstick_nn_1_N = mkN "mellanstick" neutrum  ;
  mellanslag_nn_1_N = mkN "mellanslag" neutrum  ;
  mellanskikt_nn_1_N = mkN "mellanskikt" neutrum  ;
  mellanrev_nn_1_N = mkN "mellanrev" neutrum  ;
  mellanregister_nn_1_N = mkN "mellanregister" neutrum  ;
  mellanmaal_nn_1_1_N = mkN "mellanmål" neutrum  ;
  mellanlaegg_nn_1_1_N = mkN "mellanlägg" neutrum  ;
  mellanled_nn_1_N = mkN "mellanled" neutrum  ;
  mellanhopp_nn_1_N = mkN "mellanhopp" neutrum  ;
  mellanheat_nn_1_N = mkN "mellanheat" neutrum  ;
  mellandaeck_nn_1_1_N = mkN "mellandäck" neutrum  ;
  melittafilter_nn_1_N = mkN "melittafilter" neutrum  ;
  mejlintraang_nn_1_1_N = mkN "mejlintrång" neutrum  ;
  mejlhot_nn_1_N = mkN "mejlhot" neutrum  ;
  medlut_nn_1_N = mkN "medlut" neutrum  ;
  medljud_nn_1_N = mkN "medljud" neutrum  ;
  medlingsuppdrag_nn_1_N = mkN "medlingsuppdrag" neutrum  ;
  medlingsfoersoek_nn_1_1_N = mkN "medlingsförsök" neutrum  ;
  medlingsfoerslag_nn_1_1_N = mkN "medlingsförslag" neutrum  ;
  medlemsskap_nn_1_N = mkN "medlemsskap" neutrum  ;
  medlemskort_nn_1_N = mkN "medlemskort" neutrum  ;
  medlemskap_nn_1_N = mkN "medlemskap" neutrum  ;
  medlemsfoeretag_nn_1_1_N = mkN "medlemsföretag" neutrum  ;
  medlemsantal_nn_1_N = mkN "medlemsantal" neutrum  ;
  mediotek_nn_1_N = mkN "mediotek" neutrum  ;
  medieutbud_nn_1_N = mkN "medieutbud" neutrum  ;
  medieuppbaad_nn_1_1_N = mkN "medieuppbåd" neutrum  ;
  medieklimat_nn_1_N = mkN "medieklimat" neutrum  ;
  mediefoeretag_nn_1_1_N = mkN "medieföretag" neutrum  ;
  mediedrev_nn_1_N = mkN "mediedrev" neutrum  ;
  mediatek_nn_1_N = mkN "mediatek" neutrum  ;
  mediadrev_nn_1_N = mkN "mediadrev" neutrum  ;
  medelvattenstaand_nn_1_1_N = mkN "medelvattenstånd" neutrum  ;
  medeltal_nn_1_N = mkN "medeltal" neutrum  ;
  medelhav_nn_1_N = mkN "medelhav" neutrum  ;
  medelavstaand_nn_1_1_N = mkN "medelavstånd" neutrum  ;
  medel_nn_1_N = mkN "medel" neutrum  ;
  meddelelsemedel_nn_1_N = mkN "meddelelsemedel" neutrum  ;
  medborgarskap_nn_1_N = mkN "medborgarskap" neutrum  ;
  medborgarraettsengagemang_nn_1_1_N = mkN "medborgarrättsengagemang" neutrum  ;
  medaljongtryck_nn_1_N = mkN "medaljongtryck" neutrum  ;
  mayafolk_nn_1_N = mkN "mayafolk" neutrum  ;
  mausergevaer_nn_1_1_N = mkN "mausergevär" neutrum  ;
  matvrak_nn_1_N = mkN "matvrak" neutrum  ;
  matteprov_nn_1_N = mkN "matteprov" neutrum  ;
  matsmaeltningsorgan_nn_1_1_N = mkN "matsmältningsorgan" neutrum  ;
  matrecept_nn_1_N = mkN "matrecept" neutrum  ;
  matlarm_nn_1_N = mkN "matlarm" neutrum  ;
  matlag_nn_1_N = mkN "matlag" neutrum  ;
  matinkoep_nn_1_1_N = mkN "matinköp" neutrum  ;
  matfoerraad_nn_1_1_N = mkN "matförråd" neutrum  ;
  materiemoln_nn_1_N = mkN "materiemoln" neutrum  ;
  materialfoerraad_nn_1_1_N = mkN "materialförråd" neutrum  ;
  matbroed_nn_1_1_N = mkN "matbröd" neutrum  ;
  matbord_nn_1_N = mkN "matbord" neutrum  ;
  matbestick_nn_1_N = mkN "matbestick" neutrum  ;
  masverk_nn_1_N = mkN "masverk" neutrum  ;
  mastodontprojekt_nn_1_N = mkN "mastodontprojekt" neutrum  ;
  masthaal_nn_1_1_N = mkN "masthål" neutrum  ;
  massutskick_nn_1_N = mkN "massutskick" neutrum  ;
  masstal_nn_1_N = mkN "masstal" neutrum  ;
  massmord_nn_1_N = mkN "massmord" neutrum  ;
  masskorsband_nn_1_N = mkN "masskorsband" neutrum  ;
  massageinstitut_nn_1_N = mkN "massageinstitut" neutrum  ;
  massabruk_nn_1_N = mkN "massabruk" neutrum  ;
  maskrosbarn_nn_1_N = mkN "maskrosbarn" neutrum  ;
  maskmedel_nn_1_N = mkN "maskmedel" neutrum  ;
  maskinspraak_nn_1_1_N = mkN "maskinspråk" neutrum  ;
  maskingevaer_nn_1_1_N = mkN "maskingevär" neutrum  ;
  maskinelement_nn_1_N = mkN "maskinelement" neutrum  ;
  maskhaal_nn_1_1_N = mkN "maskhål" neutrum  ;
  martyrskap_nn_1_N = mkN "martyrskap" neutrum  ;
  martasbekymmer_nn_1_N = mkN "martasbekymmer" neutrum  ;
  marsvin_nn_1_N = mkN "marsvin" neutrum  ;
  marmorgolv_nn_1_N = mkN "marmorgolv" neutrum  ;
  marmorbord_nn_1_N = mkN "marmorbord" neutrum  ;
  marknaet_nn_1_1_N = mkN "marknät" neutrum  ;
  marknadstorg_nn_1_N = mkN "marknadstorg" neutrum  ;
  marknadsstaand_nn_1_1_N = mkN "marknadsstånd" neutrum  ;
  maratonlopp_nn_1_N = mkN "maratonlopp" neutrum  ;
  man_er_nn_1_1_N = mkN "manér" neutrum  ;
  manaar_nn_1_1_N = mkN "manår" neutrum  ;
  manuskript_nn_1_N = mkN "manuskript" neutrum  ;
  mantaag_nn_1_1_N = mkN "mantåg" neutrum  ;
  manteldjur_nn_1_N = mkN "manteldjur" neutrum  ;
  mantal_nn_1_N = mkN "mantal" neutrum  ;
  mansnamn_nn_1_N = mkN "mansnamn" neutrum  ;
  manslaeger_nn_1_1_N = mkN "mansläger" neutrum  ;
  manskap_nn_1_N = mkN "manskap" neutrum  ;
  mansideal_nn_1_N = mkN "mansideal" neutrum  ;
  mansardtak_nn_1_N = mkN "mansardtak" neutrum  ;
  mannagryn_nn_1_N = mkN "mannagryn" neutrum  ;
  manlighetsprov_nn_1_N = mkN "manlighetsprov" neutrum  ;
  manlighetsdop_nn_1_N = mkN "manlighetsdop" neutrum  ;
  mankoen_nn_1_1_N = mkN "mankön" neutrum  ;
  manhaal_nn_1_1_N = mkN "manhål" neutrum  ;
  manfolk_nn_1_N = mkN "manfolk" neutrum  ;
  manfall_nn_1_N = mkN "manfall" neutrum  ;
  mandomsprov_nn_1_N = mkN "mandomsprov" neutrum  ;
  mandelspaan_nn_1_1_N = mkN "mandelspån" neutrum  ;
  mandat_nn_1_N = mkN "mandat" neutrum  ;
  malmfaelt_nn_1_1_N = mkN "malmfält" neutrum  ;
  malmedel_nn_1_N = mkN "malmedel" neutrum  ;
  maktoevergrepp_nn_1_1_N = mkN "maktövergrepp" neutrum  ;
  maktmedel_nn_1_N = mkN "maktmedel" neutrum  ;
  maktinnehav_nn_1_N = mkN "maktinnehav" neutrum  ;
  maktblock_nn_1_N = mkN "maktblock" neutrum  ;
  maktanspraak_nn_1_1_N = mkN "maktanspråk" neutrum  ;
  majskorn_nn_1_N = mkN "majskorn" neutrum  ;
  majoritetsval_nn_1_N = mkN "majoritetsval" neutrum  ;
  majestaetsbrott_nn_1_1_N = mkN "majestätsbrott" neutrum  ;
  mail_nn_2_N = mkN "mail" neutrum  ;
  magsaar_nn_1_1_N = mkN "magsår" neutrum  ;
  magnetkort_nn_1_N = mkN "magnetkort" neutrum  ;
  magnetfaelt_nn_1_1_N = mkN "magnetfält" neutrum  ;
  magnetband_nn_1_N = mkN "magnetband" neutrum  ;
  maginnehaall_nn_1_1_N = mkN "maginnehåll" neutrum  ;
  magbesvaer_nn_1_1_N = mkN "magbesvär" neutrum  ;
  magasin_nn_1_N = mkN "magasin" neutrum  ;
  mackbesoek_nn_1_1_N = mkN "mackbesök" neutrum  ;
  machverk_nn_1_N = mkN "machverk" neutrum  ;
  machtal_nn_1_N = mkN "machtal" neutrum  ;
  macholiv_nn_1_N = mkN "macholiv" neutrum  ;
  machoideal_nn_1_N = mkN "machoideal" neutrum  ;
  m_nn_1_N = mkN "m" neutrum  ;
  loevverk_nn_1_1_N = mkN "lövverk" neutrum  ;
  loevfoder_nn_1_1_N = mkN "lövfoder" neutrum  ;
  loev_nn_1_1_N = mkN "löv" neutrum  ;
  loesoerekoep_nn_1_1_N = mkN "lösöreköp" neutrum  ;
  loesskaegg_nn_1_1_N = mkN "lösskägg" neutrum  ;
  loesnummer_nn_1_1_N = mkN "lösnummer" neutrum  ;
  loesningsmedel_nn_1_1_N = mkN "lösningsmedel" neutrum  ;
  loeshaar_nn_1_1_N = mkN "löshår" neutrum  ;
  loesfynd_nn_1_1_N = mkN "lösfynd" neutrum  ;
  loesenordskrav_nn_1_1_N = mkN "lösenordskrav" neutrum  ;
  loesenord_nn_1_1_N = mkN "lösenord" neutrum  ;
  loesenbelopp_nn_1_1_N = mkN "lösenbelopp" neutrum  ;
  loesebelopp_nn_1_1_N = mkN "lösebelopp" neutrum  ;
  loepsteg_nn_1_1_N = mkN "löpsteg" neutrum  ;
  loepskift_nn_1_1_N = mkN "löpskift" neutrum  ;
  loepord_nn_1_1_N = mkN "löpord" neutrum  ;
  loephjul_nn_1_1_N = mkN "löphjul" neutrum  ;
  loepband_nn_1_1_N = mkN "löpband" neutrum  ;
  loep_nn_1_1_N = mkN "löp" neutrum  ;
  loennmord_nn_1_1_N = mkN "lönnmord" neutrum  ;
  loennfack_nn_1_1_N = mkN "lönnfack" neutrum  ;
  loenetillaegg_nn_1_1_N = mkN "lönetillägg" neutrum  ;
  loenetak_nn_1_1_N = mkN "lönetak" neutrum  ;
  loenestopp_nn_1_1_N = mkN "lönestopp" neutrum  ;
  loenepaaslag_nn_1_1_N = mkN "lönepåslag" neutrum  ;
  loenelyft_nn_1_1_N = mkN "lönelyft" neutrum  ;
  loenekuvert_nn_1_1_N = mkN "lönekuvert" neutrum  ;
  loeneklipp_nn_1_1_N = mkN "löneklipp" neutrum  ;
  loenebidrag_nn_1_1_N = mkN "lönebidrag" neutrum  ;
  loenebesked_nn_1_1_N = mkN "lönebesked" neutrum  ;
  loeneavtal_nn_1_1_N = mkN "löneavtal" neutrum  ;
  loeneavdrag_nn_1_1_N = mkN "löneavdrag" neutrum  ;
  loeneanspraak_nn_1_1_N = mkN "löneanspråk" neutrum  ;
  loekfjaell_nn_1_1_N = mkN "lökfjäll" neutrum  ;
  loeftesbrott_nn_1_1_N = mkN "löftesbrott" neutrum  ;
  loedverktyg_nn_1_1_N = mkN "lödverktyg" neutrum  ;
  laasvred_nn_1_1_N = mkN "låsvred" neutrum  ;
  laasbeslag_nn_1_1_N = mkN "låsbeslag" neutrum  ;
  laarbensbrott_nn_1_1_N = mkN "lårbensbrott" neutrum  ;
  laarben_nn_1_1_N = mkN "lårben" neutrum  ;
  laar_nn_1_1_N = mkN "lår" neutrum  ;
  laanord_nn_1_1_N = mkN "lånord" neutrum  ;
  laangtidsvikariat_nn_1_1_N = mkN "långtidsvikariat" neutrum  ;
  laangtidsskydd_nn_1_1_N = mkN "långtidsskydd" neutrum  ;
  laangspant_nn_1_1_N = mkN "långspant" neutrum  ;
  laangskott_nn_1_1_N = mkN "långskott" neutrum  ;
  laangskepp_nn_1_1_N = mkN "långskepp" neutrum  ;
  laanglopp_nn_1_1_N = mkN "långlopp" neutrum  ;
  laangkok_nn_1_1_N = mkN "långkok" neutrum  ;
  laangbord_nn_1_1_N = mkN "långbord" neutrum  ;
  laanetak_nn_1_1_N = mkN "lånetak" neutrum  ;
  laanekoep_nn_1_1_N = mkN "låneköp" neutrum  ;
  laanekort_nn_1_1_N = mkN "lånekort" neutrum  ;
  laanekontor_nn_1_1_N = mkN "lånekontor" neutrum  ;
  laanebibliotek_nn_1_1_N = mkN "lånebibliotek" neutrum  ;
  laan_nn_1_1_N = mkN "lån" neutrum  ;
  laagvarv_nn_1_1_N = mkN "lågvarv" neutrum  ;
  laagtryck_nn_1_1_N = mkN "lågtryck" neutrum  ;
  laagstadiebarn_nn_1_1_N = mkN "lågstadiebarn" neutrum  ;
  laagpriskort_nn_1_1_N = mkN "lågpriskort" neutrum  ;
  laagprisflygbolag_nn_1_1_N = mkN "lågprisflygbolag" neutrum  ;
  laagprisbolag_nn_1_1_N = mkN "lågprisbolag" neutrum  ;
  laagloenepaaslag_nn_1_1_N = mkN "låglönepåslag" neutrum  ;
  laagfjaell_nn_1_1_N = mkN "lågfjäll" neutrum  ;
  laagblad_nn_1_1_N = mkN "lågblad" neutrum  ;
  laexprov_nn_1_1_N = mkN "läxprov" neutrum  ;
  laexfoerhoer_nn_1_1_N = mkN "läxförhör" neutrum  ;
  laettbruk_nn_1_1_N = mkN "lättbruk" neutrum  ;
  laesaar_nn_1_1_N = mkN "läsår" neutrum  ;
  laesuttal_nn_1_1_N = mkN "läsuttal" neutrum  ;
  laestblock_nn_1_1_N = mkN "lästblock" neutrum  ;
  laespljud_nn_1_1_N = mkN "läspljud" neutrum  ;
  laeskpapper_nn_1_1_N = mkN "läskpapper" neutrum  ;
  laesklager_nn_1_1_N = mkN "läsklager" neutrum  ;
  laesbarn_nn_1_1_N = mkN "läsbarn" neutrum  ;
  laeroaar_nn_1_1_N = mkN "läroår" neutrum  ;
  laeroverk_nn_1_1_N = mkN "läroverk" neutrum  ;
  laeromedelspaket_nn_1_1_N = mkN "läromedelspaket" neutrum  ;
  laeromedel_nn_1_1_N = mkN "läromedel" neutrum  ;
  laerlingsaar_nn_1_1_N = mkN "lärlingsår" neutrum  ;
  laerdomsprov_nn_1_1_N = mkN "lärdomsprov" neutrum  ;
  laerandemaal_nn_1_1_N = mkN "lärandemål" neutrum  ;
  laeppstift_nn_1_1_N = mkN "läppstift" neutrum  ;
  laeppljud_nn_1_1_N = mkN "läppljud" neutrum  ;
  laensraad_nn_1_1_N = mkN "länsråd" neutrum  ;
  laenslasarett_nn_1_1_N = mkN "länslasarett" neutrum  ;
  laenkhjul_nn_1_1_N = mkN "länkhjul" neutrum  ;
  laengdstreck_nn_1_1_N = mkN "längdstreck" neutrum  ;
  laengdsnitt_nn_1_1_N = mkN "längdsnitt" neutrum  ;
  laengdmaatt_nn_1_1_N = mkN "längdmått" neutrum  ;
  laengdhopp_nn_1_1_N = mkN "längdhopp" neutrum  ;
  laenderval_nn_1_1_N = mkN "länderval" neutrum  ;
  laen_nn_1_1_N = mkN "län" neutrum  ;
  laemplighetsintyg_nn_1_1_N = mkN "lämplighetsintyg" neutrum  ;
  laemmelaar_nn_1_1_N = mkN "lämmelår" neutrum  ;
  laemmeltaag_nn_1_1_N = mkN "lämmeltåg" neutrum  ;
  laekemedelsfoeretag_nn_1_1_N = mkN "läkemedelsföretag" neutrum  ;
  laekemedelsbolag_nn_1_1_N = mkN "läkemedelsbolag" neutrum  ;
  laekemedel_nn_1_1_N = mkN "läkemedel" neutrum  ;
  laekarrecept_nn_1_1_N = mkN "läkarrecept" neutrum  ;
  laekarintyg_nn_1_1_N = mkN "läkarintyg" neutrum  ;
  laegg_nn_1_1_N = mkN "lägg" neutrum  ;
  laegerbaal_nn_1_1_N = mkN "lägerbål" neutrum  ;
  laeger_nn_1_1_N = mkN "läger" neutrum  ;
  laegenhetshotell_nn_1_1_N = mkN "lägenhetshotell" neutrum  ;
  laederfodral_nn_1_1_N = mkN "läderfodral" neutrum  ;
  lyxliv_nn_1_N = mkN "lyxliv" neutrum  ;
  lyxhotell_nn_1_N = mkN "lyxhotell" neutrum  ;
  lysroer_nn_1_1_N = mkN "lysrör" neutrum  ;
  lynnesutbrott_nn_1_N = mkN "lynnesutbrott" neutrum  ;
  lymfkaerl_nn_1_1_N = mkN "lymfkärl" neutrum  ;
  lyktbaer_nn_1_1_N = mkN "lyktbär" neutrum  ;
  lyftverk_nn_1_N = mkN "lyftverk" neutrum  ;
  lyftskydd_nn_1_N = mkN "lyftskydd" neutrum  ;
  lyftblock_nn_1_N = mkN "lyftblock" neutrum  ;
  lyft_nn_1_N = mkN "lyft" neutrum  ;
  lydnadsbrott_nn_1_N = mkN "lydnadsbrott" neutrum  ;
  lydfolk_nn_1_N = mkN "lydfolk" neutrum  ;
  lyckoaar_nn_1_1_N = mkN "lyckoår" neutrum  ;
  lyckotal_nn_1_N = mkN "lyckotal" neutrum  ;
  lyckopiller_nn_1_N = mkN "lyckopiller" neutrum  ;
  lyckohjul_nn_1_N = mkN "lyckohjul" neutrum  ;
  lutningsstreck_nn_1_N = mkN "lutningsstreck" neutrum  ;
  lut_nn_2_N = mkN "lut" neutrum  ;
  lustslott_nn_1_N = mkN "lustslott" neutrum  ;
  lustmord_nn_1_N = mkN "lustmord" neutrum  ;
  lustbehov_nn_1_N = mkN "lustbehov" neutrum  ;
  luserngroenmjoel_nn_1_1_N = mkN "luserngrönmjöl" neutrum  ;
  lungskott_nn_1_N = mkN "lungskott" neutrum  ;
  lunchuppehaall_nn_1_1_N = mkN "lunchuppehåll" neutrum  ;
  lunchbord_nn_1_N = mkN "lunchbord" neutrum  ;
  lumen_nn_2_N = mkN "lumen" neutrum  ;
  luftvaern_nn_1_1_N = mkN "luftvärn" neutrum  ;
  lufttryck_nn_1_N = mkN "lufttryck" neutrum  ;
  luftstreck_nn_1_N = mkN "luftstreck" neutrum  ;
  luftslott_nn_1_N = mkN "luftslott" neutrum  ;
  luftskikt_nn_1_N = mkN "luftskikt" neutrum  ;
  luftskepp_nn_1_N = mkN "luftskepp" neutrum  ;
  luftroer_nn_1_1_N = mkN "luftrör" neutrum  ;
  luftpistolset_nn_1_N = mkN "luftpistolset" neutrum  ;
  luftlager_nn_1_N = mkN "luftlager" neutrum  ;
  lufthaal_nn_1_1_N = mkN "lufthål" neutrum  ;
  lufthav_nn_1_N = mkN "lufthav" neutrum  ;
  luftgummihjul_nn_1_N = mkN "luftgummihjul" neutrum  ;
  luftgevaer_nn_1_1_N = mkN "luftgevär" neutrum  ;
  luftgap_nn_1_N = mkN "luftgap" neutrum  ;
  luftfilter_nn_1_N = mkN "luftfilter" neutrum  ;
  luftfartyg_nn_1_N = mkN "luftfartyg" neutrum  ;
  luftdrag_nn_1_N = mkN "luftdrag" neutrum  ;
  luftanfall_nn_1_N = mkN "luftanfall" neutrum  ;
  luder_nn_1_N = mkN "luder" neutrum  ;
  luddbraak_nn_1_1_N = mkN "luddbråk" neutrum  ;
  luciataag_nn_1_1_N = mkN "luciatåg" neutrum  ;
  lovtal_nn_1_N = mkN "lovtal" neutrum  ;
  lovord_nn_1_N = mkN "lovord" neutrum  ;
  lov_nn_3_N = mkN "lov" neutrum  ;
  lotsdistrikt_nn_1_N = mkN "lotsdistrikt" neutrum  ;
  loppisfynd_nn_1_N = mkN "loppisfynd" neutrum  ;
  lopp_nn_1_N = mkN "lopp" neutrum  ;
  lokaltaag_nn_1_1_N = mkN "lokaltåg" neutrum  ;
  lokalsamtal_nn_1_N = mkN "lokalsamtal" neutrum  ;
  lokalombud_nn_1_N = mkN "lokalombud" neutrum  ;
  lokalkontor_nn_1_N = mkN "lokalkontor" neutrum  ;
  lokaliseringsstoed_nn_1_1_N = mkN "lokaliseringsstöd" neutrum  ;
  lok_nn_1_N = mkN "lok" neutrum  ;
  lojalitetsband_nn_1_N = mkN "lojalitetsband" neutrum  ;
  logementsfartyg_nn_1_N = mkN "logementsfartyg" neutrum  ;
  logement_nn_1_N = mkN "logement" neutrum  ;
  loft_nn_1_N = mkN "loft" neutrum  ;
  lodstreck_nn_1_N = mkN "lodstreck" neutrum  ;
  lodskott_nn_1_N = mkN "lodskott" neutrum  ;
  lodplan_nn_1_N = mkN "lodplan" neutrum  ;
  lodjur_nn_1_N = mkN "lodjur" neutrum  ;
  lod_nn_1_N = mkN "lod" neutrum  ;
  lockrop_nn_1_N = mkN "lockrop" neutrum  ;
  lockdjur_nn_1_N = mkN "lockdjur" neutrum  ;
  lock_nn_2_N = mkN "lock" neutrum  ;
  ljusaar_nn_1_1_N = mkN "ljusår" neutrum  ;
  ljustryck_nn_1_N = mkN "ljustryck" neutrum  ;
  ljuster_nn_1_N = mkN "ljuster" neutrum  ;
  ljussken_nn_1_N = mkN "ljussken" neutrum  ;
  ljusnaet_nn_1_1_N = mkN "ljusnät" neutrum  ;
  ljusmikroskop_nn_1_N = mkN "ljusmikroskop" neutrum  ;
  ljusfilter_nn_1_N = mkN "ljusfilter" neutrum  ;
  ljusfenomen_nn_1_N = mkN "ljusfenomen" neutrum  ;
  ljumskbraack_nn_1_1_N = mkN "ljumskbråck" neutrum  ;
  ljudresultat_nn_1_N = mkN "ljudresultat" neutrum  ;
  ljudintryck_nn_1_N = mkN "ljudintryck" neutrum  ;
  ljudhaal_nn_1_1_N = mkN "ljudhål" neutrum  ;
  ljudbrev_nn_1_N = mkN "ljudbrev" neutrum  ;
  ljudbildband_nn_1_N = mkN "ljudbildband" neutrum  ;
  ljudband_nn_1_N = mkN "ljudband" neutrum  ;
  ljud_nn_1_N = mkN "ljud" neutrum  ;
  livtag_nn_1_N = mkN "livtag" neutrum  ;
  livsvillkor_nn_1_N = mkN "livsvillkor" neutrum  ;
  livsverk_nn_1_N = mkN "livsverk" neutrum  ;
  livstidsstraff_nn_1_N = mkN "livstidsstraff" neutrum  ;
  livsstilsfenomen_nn_1_N = mkN "livsstilsfenomen" neutrum  ;
  livsslut_nn_1_N = mkN "livsslut" neutrum  ;
  livsmedel_nn_1_N = mkN "livsmedel" neutrum  ;
  livselixir_nn_1_N = mkN "livselixir" neutrum  ;
  livmoderframfall_nn_1_N = mkN "livmoderframfall" neutrum  ;
  livdjur_nn_1_N = mkN "livdjur" neutrum  ;
  liv_nn_1_N = mkN "liv" neutrum  ;
  litteraturspraak_nn_1_1_N = mkN "litteraturspråk" neutrum  ;
  litermaatt_nn_1_1_N = mkN "litermått" neutrum  ;
  listverk_nn_1_N = mkN "listverk" neutrum  ;
  listornament_nn_1_N = mkN "listornament" neutrum  ;
  lispund_nn_1_N = mkN "lispund" neutrum  ;
  linoleumsnitt_nn_1_N = mkN "linoleumsnitt" neutrum  ;
  linneskaap_nn_1_1_N = mkN "linneskåp" neutrum  ;
  linjeskepp_nn_1_N = mkN "linjeskepp" neutrum  ;
  linjelopp_nn_1_N = mkN "linjelopp" neutrum  ;
  liniment_nn_1_N = mkN "liniment" neutrum  ;
  lingonpaeron_nn_1_1_N = mkN "lingonpäron" neutrum  ;
  lingon_nn_1_N = mkN "lingon" neutrum  ;
  lindloev_nn_1_1_N = mkN "lindlöv" neutrum  ;
  lindebarn_nn_1_N = mkN "lindebarn" neutrum  ;
  linddrag_nn_1_N = mkN "linddrag" neutrum  ;
  liljemoenster_nn_1_1_N = mkN "liljemönster" neutrum  ;
  likfynd_nn_1_N = mkN "likfynd" neutrum  ;
  lik_nn_1_N = mkN "lik" neutrum  ;
  liggunderlag_nn_1_N = mkN "liggunderlag" neutrum  ;
  liggsaar_nn_1_1_N = mkN "liggsår" neutrum  ;
  ligg_nn_1_N = mkN "ligg" neutrum  ;
  ligament_nn_1_N = mkN "ligament" neutrum  ;
  liftkort_nn_1_N = mkN "liftkort" neutrum  ;
  lieskaft_nn_1_N = mkN "lieskaft" neutrum  ;
  lider_nn_1_N = mkN "lider" neutrum  ;
  lexikonprojekt_nn_1_N = mkN "lexikonprojekt" neutrum  ;
  levnadsaar_nn_1_1_N = mkN "levnadsår" neutrum  ;
  levnadsvillkor_nn_1_N = mkN "levnadsvillkor" neutrum  ;
  levnadssaett_nn_1_1_N = mkN "levnadssätt" neutrum  ;
  levnadsmoenster_nn_1_1_N = mkN "levnadsmönster" neutrum  ;
  levnadslopp_nn_1_N = mkN "levnadslopp" neutrum  ;
  leverop_nn_1_N = mkN "leverop" neutrum  ;
  leveransavtal_nn_1_N = mkN "leveransavtal" neutrum  ;
  lerkaerl_nn_1_1_N = mkN "lerkärl" neutrum  ;
  leopardskinn_nn_1_N = mkN "leopardskinn" neutrum  ;
  lekverk_nn_1_N = mkN "lekverk" neutrum  ;
  lektorat_nn_1_N = mkN "lektorat" neutrum  ;
  lekotek_nn_1_N = mkN "lekotek" neutrum  ;
  lejongap_nn_1_N = mkN "lejongap" neutrum  ;
  lejon_nn_1_N = mkN "lejon" neutrum  ;
  lejdebrev_nn_1_N = mkN "lejdebrev" neutrum  ;
  legohjon_nn_1_N = mkN "legohjon" neutrum  ;
  legoavtal_nn_1_N = mkN "legoavtal" neutrum  ;
  legg_nn_1_N = mkN "legg" neutrum  ;
  legat_nn_2_N = mkN "legat" neutrum  ;
  leg_nn_1_N = mkN "leg" neutrum  ;
  ledungsskepp_nn_1_N = mkN "ledungsskepp" neutrum  ;
  ledord_nn_1_N = mkN "ledord" neutrum  ;
  ledningsorgan_nn_1_N = mkN "ledningsorgan" neutrum  ;
  ledningsmaal_nn_1_1_N = mkN "ledningsmål" neutrum  ;
  ledningsmotstaand_nn_1_1_N = mkN "ledningsmotstånd" neutrum  ;
  ledkort_nn_1_N = mkN "ledkort" neutrum  ;
  leddjur_nn_1_N = mkN "leddjur" neutrum  ;
  ledband_nn_1_N = mkN "ledband" neutrum  ;
  ledarstick_nn_1_N = mkN "ledarstick" neutrum  ;
  ledarskikt_nn_1_N = mkN "ledarskikt" neutrum  ;
  ledarpar_nn_1_N = mkN "ledarpar" neutrum  ;
  led_nn_3_N = mkN "led" neutrum  ;
  laxkar_nn_1_N = mkN "laxkar" neutrum  ;
  laxerpiller_nn_1_N = mkN "laxerpiller" neutrum  ;
  laxermedel_nn_1_N = mkN "laxermedel" neutrum  ;
  lavemang_nn_1_N = mkN "lavemang" neutrum  ;
  lavafaelt_nn_1_1_N = mkN "lavafält" neutrum  ;
  laudatur_nn_1_N = mkN "laudatur" neutrum  ;
  latinlaeroverk_nn_1_1_N = mkN "latinläroverk" neutrum  ;
  lastnaet_nn_1_1_N = mkN "lastnät" neutrum  ;
  lastgaller_nn_1_N = mkN "lastgaller" neutrum  ;
  lastflak_nn_1_N = mkN "lastflak" neutrum  ;
  lastfartyg_nn_1_N = mkN "lastfartyg" neutrum  ;
  lastdjur_nn_1_N = mkN "lastdjur" neutrum  ;
  lastbilsflak_nn_1_N = mkN "lastbilsflak" neutrum  ;
  lasarett_nn_1_N = mkN "lasarett" neutrum  ;
  laryngoskop_nn_1_N = mkN "laryngoskop" neutrum  ;
  larvband_nn_1_N = mkN "larvband" neutrum  ;
  larmnummer_nn_1_N = mkN "larmnummer" neutrum  ;
  larm_nn_1_N = mkN "larm" neutrum  ;
  lappverk_nn_1_N = mkN "lappverk" neutrum  ;
  lantvaern_nn_1_1_N = mkN "lantvärn" neutrum  ;
  lantdjur_nn_1_N = mkN "lantdjur" neutrum  ;
  lantbruksuniversitet_nn_1_N = mkN "lantbruksuniversitet" neutrum  ;
  lantbruksfoerbund_nn_1_1_N = mkN "lantbruksförbund" neutrum  ;
  lantbruk_nn_1_N = mkN "lantbruk" neutrum  ;
  langettstygn_nn_1_N = mkN "langettstygn" neutrum  ;
  landstingsraad_nn_1_1_N = mkN "landstingsråd" neutrum  ;
  landstingsfoerbund_nn_1_1_N = mkN "landstingsförbund" neutrum  ;
  landsting_nn_1_N = mkN "landsting" neutrum  ;
  landssekretariat_nn_1_N = mkN "landssekretariat" neutrum  ;
  landsnummer_nn_1_N = mkN "landsnummer" neutrum  ;
  landsmaalsalfabet_nn_1_1_N = mkN "landsmålsalfabet" neutrum  ;
  landsmaal_nn_1_1_N = mkN "landsmål" neutrum  ;
  landslag_nn_1_N = mkN "landslag" neutrum  ;
  landskap_nn_1_N = mkN "landskap" neutrum  ;
  landningsoegonblick_nn_1_1_N = mkN "landningsögonblick" neutrum  ;
  landningsstaell_nn_1_1_N = mkN "landningsställ" neutrum  ;
  landningshjul_nn_1_N = mkN "landningshjul" neutrum  ;
  landningsfoerbud_nn_1_1_N = mkN "landningsförbud" neutrum  ;
  land_nn_2_N = mkN "land" neutrum  ;
  lampsken_nn_1_N = mkN "lampsken" neutrum  ;
  lammspett_nn_1_N = mkN "lammspett" neutrum  ;
  lammskinn_nn_1_N = mkN "lammskinn" neutrum  ;
  lamm_nn_1_N = mkN "lamm" neutrum  ;
  laminat_nn_1_N = mkN "laminat" neutrum  ;
  lamadjur_nn_1_N = mkN "lamadjur" neutrum  ;
  lakan_nn_1_N = mkN "lakan" neutrum  ;
  lagutskott_nn_1_N = mkN "lagutskott" neutrum  ;
  lagtempolopp_nn_1_N = mkN "lagtempolopp" neutrum  ;
  lagspraak_nn_1_1_N = mkN "lagspråk" neutrum  ;
  lagraad_nn_1_1_N = mkN "lagråd" neutrum  ;
  lagn_nn_1_N = mkN "lagn" neutrum  ;
  laggkaerl_nn_1_1_N = mkN "laggkärl" neutrum  ;
  laggband_nn_1_N = mkN "laggband" neutrum  ;
  lagfoerslag_nn_1_1_N = mkN "lagförslag" neutrum  ;
  lagerbaersblad_nn_1_1_N = mkN "lagerbärsblad" neutrum  ;
  lagerblad_nn_1_N = mkN "lagerblad" neutrum  ;
  lager_nn_1_N = mkN "lager" neutrum  ;
  lagbrott_nn_1_N = mkN "lagbrott" neutrum  ;
  lag_nn_2_N = mkN "lag" neutrum  ;
  ladugaardstak_nn_1_1_N = mkN "ladugårdstak" neutrum  ;
  lad_nn_1_N = mkN "lad" neutrum  ;
  lackskaerp_nn_1_1_N = mkN "lackskärp" neutrum  ;
  laboratorieresultat_nn_1_N = mkN "laboratorieresultat" neutrum  ;
  labb_nn_2_N = mkN "labb" neutrum  ;
  lab_nn_2_N = mkN "lab" neutrum  ;
  l_nn_1_N = mkN "l" neutrum  ;
  koettsaar_nn_1_1_N = mkN "köttsår" neutrum  ;
  koettben_nn_1_1_N = mkN "köttben" neutrum  ;
  koestaell_nn_1_1_N = mkN "köställ" neutrum  ;
  koersbaer_nn_1_1_N = mkN "körsbär" neutrum  ;
  koerkortstillstaand_nn_1_1_N = mkN "körkortstillstånd" neutrum  ;
  koerkortsprov_nn_1_1_N = mkN "körkortsprov" neutrum  ;
  koerkort_nn_1_1_N = mkN "körkort" neutrum  ;
  koerfoerbud_nn_1_1_N = mkN "körförbud" neutrum  ;
  koerfaelt_nn_1_1_N = mkN "körfält" neutrum  ;
  koepvillkor_nn_1_1_N = mkN "köpvillkor" neutrum  ;
  koepslut_nn_1_1_N = mkN "köpslut" neutrum  ;
  koepkort_nn_1_1_N = mkN "köpkort" neutrum  ;
  koepekontrakt_nn_1_1_N = mkN "köpekontrakt" neutrum  ;
  koepebroed_nn_1_1_N = mkN "köpebröd" neutrum  ;
  koepebrev_nn_1_1_N = mkN "köpebrev" neutrum  ;
  koepeavtal_nn_1_1_N = mkN "köpeavtal" neutrum  ;
  koep_nn_1_1_N = mkN "köp" neutrum  ;
  koensskaemt_nn_1_1_N = mkN "könsskämt" neutrum  ;
  koensorgan_nn_1_1_N = mkN "könsorgan" neutrum  ;
  koensord_nn_1_1_N = mkN "könsord" neutrum  ;
  koenshaar_nn_2_1_N = mkN "könshår" neutrum  ;
  koen_nn_1_1_N = mkN "kön" neutrum  ;
  koelsvin_nn_1_1_N = mkN "kölsvin" neutrum  ;
  koekstak_nn_1_1_N = mkN "kökstak" neutrum  ;
  koeksfoenster_nn_1_1_N = mkN "köksfönster" neutrum  ;
  koeksbordssamtal_nn_1_1_N = mkN "köksbordssamtal" neutrum  ;
  koeksbord_nn_1_1_N = mkN "köksbord" neutrum  ;
  koek_nn_1_1_N = mkN "kök" neutrum  ;
  kaatslag_nn_1_1_N = mkN "kåtslag" neutrum  ;
  kaettarbaal_nn_1_1_N = mkN "kättarbål" neutrum  ;
  kaerrhjul_nn_1_1_N = mkN "kärrhjul" neutrum  ;
  kaerr_nn_1_1_N = mkN "kärr" neutrum  ;
  kaeromaal_nn_1_1_N = mkN "käromål" neutrum  ;
  kaernvapenlager_nn_1_1_N = mkN "kärnvapenlager" neutrum  ;
  kaernvapenkrig_nn_1_1_N = mkN "kärnvapenkrig" neutrum  ;
  kaernvapeninnehav_nn_1_1_N = mkN "kärnvapeninnehav" neutrum  ;
  kaernsoenderfall_nn_1_1_N = mkN "kärnsönderfall" neutrum  ;
  kaernland_nn_1_1_N = mkN "kärnland" neutrum  ;
  kaernkraftverk_nn_1_1_N = mkN "kärnkraftverk" neutrum  ;
  kaerleksaeventyr_nn_1_1_N = mkN "kärleksäventyr" neutrum  ;
  kaerleksval_nn_1_1_N = mkN "kärleksval" neutrum  ;
  kaerlekspar_nn_1_1_N = mkN "kärlekspar" neutrum  ;
  kaerleksord_nn_1_1_N = mkN "kärleksord" neutrum  ;
  kaerlekskval_nn_1_1_N = mkN "kärlekskval" neutrum  ;
  kaerleksknep_nn_1_1_N = mkN "kärleksknep" neutrum  ;
  kaerleksbudskap_nn_1_1_N = mkN "kärleksbudskap" neutrum  ;
  kaerleksbud_nn_1_1_N = mkN "kärleksbud" neutrum  ;
  kaerleksbrev_nn_1_1_N = mkN "kärleksbrev" neutrum  ;
  kaerleksbarn_nn_1_1_N = mkN "kärleksbarn" neutrum  ;
  kaerl_nn_1_1_N = mkN "kärl" neutrum  ;
  kaeril_nn_1_1_N = mkN "käril" neutrum  ;
  kaenslouttryck_nn_1_1_N = mkN "känslouttryck" neutrum  ;
  kaensloutbrott_nn_1_1_N = mkN "känsloutbrott" neutrum  ;
  kaenslosvall_nn_1_1_N = mkN "känslosvall" neutrum  ;
  kaensloengagemang_nn_1_1_N = mkN "känsloengagemang" neutrum  ;
  kaenselsproet_nn_1_1_N = mkN "känselspröt" neutrum  ;
  kaenselorgan_nn_1_1_N = mkN "känselorgan" neutrum  ;
  kaenselhaar_nn_1_1_N = mkN "känselhår" neutrum  ;
  kaempatag_nn_1_1_N = mkN "kämpatag" neutrum  ;
  kaellspraang_nn_1_1_N = mkN "källsprång" neutrum  ;
  kaellmaterial_nn_1_1_N = mkN "källmaterial" neutrum  ;
  kaelldrag_nn_1_1_N = mkN "källdrag" neutrum  ;
  kaellarvalv_nn_1_1_N = mkN "källarvalv" neutrum  ;
  kaekben_nn_1_1_N = mkN "käkben" neutrum  ;
  kaegelsnitt_nn_1_1_N = mkN "kägelsnitt" neutrum  ;
  kytt_nn_1_N = mkN "kytt" neutrum  ;
  kyrktorn_nn_1_N = mkN "kyrktorn" neutrum  ;
  kyrktak_nn_1_N = mkN "kyrktak" neutrum  ;
  kyrkoaar_nn_1_1_N = mkN "kyrkoår" neutrum  ;
  kyrkospraak_nn_1_1_N = mkN "kyrkospråk" neutrum  ;
  kyrkosamfund_nn_1_N = mkN "kyrkosamfund" neutrum  ;
  kyrkoraad_nn_1_1_N = mkN "kyrkoråd" neutrum  ;
  kyrkobruk_nn_1_N = mkN "kyrkobruk" neutrum  ;
  kyrkobesoek_nn_1_1_N = mkN "kyrkobesök" neutrum  ;
  kyrkfoenster_nn_1_1_N = mkN "kyrkfönster" neutrum  ;
  kyrkbroellop_nn_1_1_N = mkN "kyrkbröllop" neutrum  ;
  kyrkbesoek_nn_1_1_N = mkN "kyrkbesök" neutrum  ;
  kylskaapsgaller_nn_1_1_N = mkN "kylskåpsgaller" neutrum  ;
  kylskaap_nn_1_1_N = mkN "kylskåp" neutrum  ;
  kylroer_nn_1_1_N = mkN "kylrör" neutrum  ;
  kyller_nn_1_N = mkN "kyller" neutrum  ;
  kylfack_nn_1_N = mkN "kylfack" neutrum  ;
  kylargaller_nn_1_N = mkN "kylargaller" neutrum  ;
  kvaevegoedselmedel_nn_1_1_N = mkN "kvävegödselmedel" neutrum  ;
  kvaellsskift_nn_1_1_N = mkN "kvällsskift" neutrum  ;
  kvaellsmaal_nn_1_1_N = mkN "kvällsmål" neutrum  ;
  kvitteringsmaal_nn_1_1_N = mkN "kvitteringsmål" neutrum  ;
  kvisthaal_nn_1_1_N = mkN "kvisthål" neutrum  ;
  kvinnooevergrepp_nn_1_1_N = mkN "kvinnoövergrepp" neutrum  ;
  kvinnoutbrott_nn_1_N = mkN "kvinnoutbrott" neutrum  ;
  kvinnoskratt_nn_1_N = mkN "kvinnoskratt" neutrum  ;
  kvinnorov_nn_1_N = mkN "kvinnorov" neutrum  ;
  kvinnoplagg_nn_1_N = mkN "kvinnoplagg" neutrum  ;
  kvinnonamn_nn_1_N = mkN "kvinnonamn" neutrum  ;
  kvinnolaeger_nn_1_1_N = mkN "kvinnoläger" neutrum  ;
  kvinnoideal_nn_1_N = mkN "kvinnoideal" neutrum  ;
  kvinnoben_nn_1_N = mkN "kvinnoben" neutrum  ;
  kvinnfolk_nn_1_N = mkN "kvinnfolk" neutrum  ;
  kvastskaft_nn_1_N = mkN "kvastskaft" neutrum  ;
  kvasikontrakt_nn_1_N = mkN "kvasikontrakt" neutrum  ;
  kvartsur_nn_1_N = mkN "kvartsur" neutrum  ;
  kvartssamtal_nn_1_N = mkN "kvartssamtal" neutrum  ;
  kvartal_nn_1_N = mkN "kvartal" neutrum  ;
  kvarnhjul_nn_1_N = mkN "kvarnhjul" neutrum  ;
  kvanttal_nn_1_N = mkN "kvanttal" neutrum  ;
  kvalster_nn_1_N = mkN "kvalster" neutrum  ;
  kvalitetskrav_nn_1_N = mkN "kvalitetskrav" neutrum  ;
  kvalifikationsaar_nn_1_1_N = mkN "kvalifikationsår" neutrum  ;
  kval_nn_1_N = mkN "kval" neutrum  ;
  kvadratmaatt_nn_1_1_N = mkN "kvadratmått" neutrum  ;
  kvack_nn_1_N = mkN "kvack" neutrum  ;
  kuvertbroed_nn_1_1_N = mkN "kuvertbröd" neutrum  ;
  kuvert_nn_1_N = mkN "kuvert" neutrum  ;
  kusinaektenskap_nn_1_1_N = mkN "kusinäktenskap" neutrum  ;
  kursfall_nn_1_N = mkN "kursfall" neutrum  ;
  kurr_nn_2_N = mkN "kurr" neutrum  ;
  kup_efoenster_nn_1_1_N = mkN "kupéfönster" neutrum  ;
  kuppfoersoek_nn_1_1_N = mkN "kuppförsök" neutrum  ;
  kupolvalv_nn_1_N = mkN "kupolvalv" neutrum  ;
  kupoltak_nn_1_N = mkN "kupoltak" neutrum  ;
  kunskapsstoff_nn_1_N = mkN "kunskapsstoff" neutrum  ;
  kungsord_nn_1_N = mkN "kungsord" neutrum  ;
  kungaval_nn_1_N = mkN "kungaval" neutrum  ;
  kungapar_nn_1_N = mkN "kungapar" neutrum  ;
  kungamord_nn_1_N = mkN "kungamord" neutrum  ;
  kungabrev_nn_1_N = mkN "kungabrev" neutrum  ;
  kundoenskemaal_nn_1_1_N = mkN "kundönskemål" neutrum  ;
  kundunderlag_nn_1_N = mkN "kundunderlag" neutrum  ;
  kulturspraak_nn_1_1_N = mkN "kulturspråk" neutrum  ;
  kulturraad_nn_1_1_N = mkN "kulturråd" neutrum  ;
  kulturreservat_nn_1_N = mkN "kulturreservat" neutrum  ;
  kulturmoenster_nn_1_1_N = mkN "kulturmönster" neutrum  ;
  kulturlandskap_nn_1_N = mkN "kulturlandskap" neutrum  ;
  kulturlager_nn_1_N = mkN "kulturlager" neutrum  ;
  kulturinstitut_nn_1_N = mkN "kulturinstitut" neutrum  ;
  kulturfolk_nn_1_N = mkN "kulturfolk" neutrum  ;
  kulturevenemang_nn_1_N = mkN "kulturevenemang" neutrum  ;
  kulturarv_nn_1_N = mkN "kulturarv" neutrum  ;
  kultryck_nn_1_N = mkN "kultryck" neutrum  ;
  kultfoeremaal_nn_1_1_N = mkN "kultföremål" neutrum  ;
  kulspaar_nn_1_1_N = mkN "kulspår" neutrum  ;
  kulsprutegevaer_nn_1_1_N = mkN "kulsprutegevär" neutrum  ;
  kulregn_nn_1_N = mkN "kulregn" neutrum  ;
  kullerstenstorg_nn_1_N = mkN "kullerstenstorg" neutrum  ;
  kullager_nn_1_N = mkN "kullager" neutrum  ;
  kulhaal_nn_1_1_N = mkN "kulhål" neutrum  ;
  kulgevaer_nn_1_1_N = mkN "kulgevär" neutrum  ;
  kulfaang_nn_1_1_N = mkN "kulfång" neutrum  ;
  kugghjul_nn_1_N = mkN "kugghjul" neutrum  ;
  kuddvar_nn_1_N = mkN "kuddvar" neutrum  ;
  kuddkrig_nn_1_N = mkN "kuddkrig" neutrum  ;
  kroeson_nn_1_1_N = mkN "kröson" neutrum  ;
  kroen_nn_1_1_N = mkN "krön" neutrum  ;
  kraakslott_nn_1_1_N = mkN "kråkslott" neutrum  ;
  kraakbaer_nn_1_1_N = mkN "kråkbär" neutrum  ;
  kraengningsprov_nn_1_1_N = mkN "krängningsprov" neutrum  ;
  kraeldjur_nn_1_1_N = mkN "kräldjur" neutrum  ;
  kraekmedel_nn_1_1_N = mkN "kräkmedel" neutrum  ;
  kraek_nn_1_1_N = mkN "kräk" neutrum  ;
  kraeftdjur_nn_1_1_N = mkN "kräftdjur" neutrum  ;
  kryssvalv_nn_1_N = mkN "kryssvalv" neutrum  ;
  krysstag_nn_1_N = mkN "krysstag" neutrum  ;
  kryssningsfartyg_nn_1_N = mkN "kryssningsfartyg" neutrum  ;
  kryssfoerband_nn_1_1_N = mkN "kryssförband" neutrum  ;
  kryphaal_nn_1_1_N = mkN "kryphål" neutrum  ;
  kryp_nn_1_N = mkN "kryp" neutrum  ;
  krutkorn_nn_1_N = mkN "krutkorn" neutrum  ;
  kruthorn_nn_1_N = mkN "kruthorn" neutrum  ;
  krusbaer_nn_1_1_N = mkN "krusbär" neutrum  ;
  krumspraang_nn_1_1_N = mkN "krumsprång" neutrum  ;
  krumhorn_nn_1_N = mkN "krumhorn" neutrum  ;
  krossaar_nn_1_1_N = mkN "krossår" neutrum  ;
  kroppsorgan_nn_1_N = mkN "kroppsorgan" neutrum  ;
  kroppshaar_nn_2_1_N = mkN "kroppshår" neutrum  ;
  kroppsfynd_nn_1_N = mkN "kroppsfynd" neutrum  ;
  kronvrak_nn_1_N = mkN "kronvrak" neutrum  ;
  krontal_nn_1_N = mkN "krontal" neutrum  ;
  kronprinsessbroellop_nn_1_1_N = mkN "kronprinsessbröllop" neutrum  ;
  kronblad_nn_1_N = mkN "kronblad" neutrum  ;
  kromosompar_nn_1_N = mkN "kromosompar" neutrum  ;
  krokodilskinn_nn_1_N = mkN "krokodilskinn" neutrum  ;
  krogsamtal_nn_1_N = mkN "krogsamtal" neutrum  ;
  krogbesoek_nn_1_1_N = mkN "krogbesök" neutrum  ;
  kritter_nn_1_N = mkN "kritter" neutrum  ;
  kritstreck_nn_1_N = mkN "kritstreck" neutrum  ;
  kristidsfoeretag_nn_1_1_N = mkN "kristidsföretag" neutrum  ;
  kristallmoenster_nn_1_1_N = mkN "kristallmönster" neutrum  ;
  krispaket_nn_1_N = mkN "krispaket" neutrum  ;
  krismedel_nn_1_N = mkN "krismedel" neutrum  ;
  krishanteringsraad_nn_1_1_N = mkN "krishanteringsråd" neutrum  ;
  krishanteringsrecept_nn_1_N = mkN "krishanteringsrecept" neutrum  ;
  kriminalregister_nn_1_N = mkN "kriminalregister" neutrum  ;
  kriminalfall_nn_1_N = mkN "kriminalfall" neutrum  ;
  krikon_nn_1_N = mkN "krikon" neutrum  ;
  krigsaar_nn_1_1_N = mkN "krigsår" neutrum  ;
  krigsaeventyr_nn_1_1_N = mkN "krigsäventyr" neutrum  ;
  krigsutbrott_nn_1_N = mkN "krigsutbrott" neutrum  ;
  krigstaag_nn_1_1_N = mkN "krigståg" neutrum  ;
  krigstillstaand_nn_1_1_N = mkN "krigstillstånd" neutrum  ;
  krigsslut_nn_1_N = mkN "krigsslut" neutrum  ;
  krigsskepp_nn_1_N = mkN "krigsskepp" neutrum  ;
  krigsskadestaand_nn_1_1_N = mkN "krigsskadestånd" neutrum  ;
  krigsraad_nn_1_1_N = mkN "krigsråd" neutrum  ;
  krigsmonument_nn_1_N = mkN "krigsmonument" neutrum  ;
  krigslik_nn_1_N = mkN "krigslik" neutrum  ;
  krigsfoerbrytarmaal_nn_1_1_N = mkN "krigsförbrytarmål" neutrum  ;
  krigsfartyg_nn_1_N = mkN "krigsfartyg" neutrum  ;
  krigsbrott_nn_1_N = mkN "krigsbrott" neutrum  ;
  krigsbarn_nn_1_N = mkN "krigsbarn" neutrum  ;
  krig_nn_1_N = mkN "krig" neutrum  ;
  krevadmoln_nn_1_N = mkN "krevadmoln" neutrum  ;
  kretslopp_nn_1_N = mkN "kretslopp" neutrum  ;
  kretskort_nn_1_N = mkN "kretskort" neutrum  ;
  kreolspraak_nn_1_1_N = mkN "kreolspråk" neutrum  ;
  kreolinslag_nn_1_N = mkN "kreolinslag" neutrum  ;
  kreditvaerderingsinstitut_nn_1_1_N = mkN "kreditvärderingsinstitut" neutrum  ;
  kreditvillkor_nn_1_N = mkN "kreditvillkor" neutrum  ;
  kreditkort_nn_1_N = mkN "kreditkort" neutrum  ;
  kreditivbrev_nn_1_N = mkN "kreditivbrev" neutrum  ;
  kreditinstitut_nn_1_N = mkN "kreditinstitut" neutrum  ;
  kreatur_nn_1_N = mkN "kreatur" neutrum  ;
  kravbrev_nn_1_N = mkN "kravbrev" neutrum  ;
  kravallstaket_nn_1_N = mkN "kravallstaket" neutrum  ;
  krav_nn_1_N = mkN "krav" neutrum  ;
  kraterberg_nn_1_N = mkN "kraterberg" neutrum  ;
  kranskaerl_nn_1_1_N = mkN "kranskärl" neutrum  ;
  kransband_nn_1_N = mkN "kransband" neutrum  ;
  kraftvaermeverk_nn_1_1_N = mkN "kraftvärmeverk" neutrum  ;
  kraftverk_nn_1_N = mkN "kraftverk" neutrum  ;
  kraftuttryck_nn_1_N = mkN "kraftuttryck" neutrum  ;
  krafttag_nn_1_N = mkN "krafttag" neutrum  ;
  kraftprov_nn_1_N = mkN "kraftprov" neutrum  ;
  kraftpaket_nn_1_N = mkN "kraftpaket" neutrum  ;
  kraftord_nn_1_N = mkN "kraftord" neutrum  ;
  kraftnaet_nn_1_1_N = mkN "kraftnät" neutrum  ;
  kraftmedel_nn_1_N = mkN "kraftmedel" neutrum  ;
  kraftfoeretag_nn_1_1_N = mkN "kraftföretag" neutrum  ;
  kraftfaelt_nn_1_1_N = mkN "kraftfält" neutrum  ;
  kraftfoder_nn_1_N = mkN "kraftfoder" neutrum  ;
  kraftbolag_nn_1_N = mkN "kraftbolag" neutrum  ;
  kraftbehov_nn_1_N = mkN "kraftbehov" neutrum  ;
  kraftaggregat_nn_1_N = mkN "kraftaggregat" neutrum  ;
  kotben_nn_1_N = mkN "kotben" neutrum  ;
  kosttillskott_nn_1_N = mkN "kosttillskott" neutrum  ;
  kostraad_nn_1_1_N = mkN "kostråd" neutrum  ;
  kostnadsvall_nn_1_N = mkN "kostnadsvall" neutrum  ;
  kostnadstak_nn_1_N = mkN "kostnadstak" neutrum  ;
  kostnadsskael_nn_1_1_N = mkN "kostnadsskäl" neutrum  ;
  kostnadsfoerslag_nn_1_1_N = mkN "kostnadsförslag" neutrum  ;
  kosmetikafoeretag_nn_1_1_N = mkN "kosmetikaföretag" neutrum  ;
  korvstaand_nn_1_1_N = mkN "korvstånd" neutrum  ;
  korvskinn_nn_1_N = mkN "korvskinn" neutrum  ;
  korvjobb_nn_1_N = mkN "korvjobb" neutrum  ;
  kortslutningsskydd_nn_1_N = mkN "kortslutningsskydd" neutrum  ;
  kortregister_nn_1_N = mkN "kortregister" neutrum  ;
  kort_nn_1_N = mkN "kort" neutrum  ;
  korsvalv_nn_1_N = mkN "korsvalv" neutrum  ;
  korstaag_nn_1_1_N = mkN "korståg" neutrum  ;
  korsstygn_nn_1_N = mkN "korsstygn" neutrum  ;
  korsord_nn_1_N = mkN "korsord" neutrum  ;
  korskrank_nn_1_N = mkN "korskrank" neutrum  ;
  korsfoerhoer_nn_1_1_N = mkN "korsförhör" neutrum  ;
  korsben_nn_1_N = mkN "korsben" neutrum  ;
  korsband_nn_1_N = mkN "korsband" neutrum  ;
  korruptionsaatal_nn_1_1_N = mkN "korruptionsåtal" neutrum  ;
  korruptionsbrott_nn_1_N = mkN "korruptionsbrott" neutrum  ;
  korrosionsskydd_nn_1_N = mkN "korrosionsskydd" neutrum  ;
  korrespondenskort_nn_1_N = mkN "korrespondenskort" neutrum  ;
  korrelat_nn_1_N = mkN "korrelat" neutrum  ;
  korrektur_nn_1_N = mkN "korrektur" neutrum  ;
  korr_nn_1_N = mkN "korr" neutrum  ;
  korngryn_nn_1_N = mkN "korngryn" neutrum  ;
  kornbroed_nn_1_1_N = mkN "kornbröd" neutrum  ;
  korn_nn_1_N = mkN "korn" neutrum  ;
  korklager_nn_1_N = mkN "korklager" neutrum  ;
  korkgolv_nn_1_N = mkN "korkgolv" neutrum  ;
  korfoenster_nn_1_1_N = mkN "korfönster" neutrum  ;
  korallrev_nn_1_N = mkN "korallrev" neutrum  ;
  korallhalsband_nn_1_N = mkN "korallhalsband" neutrum  ;
  koralldjur_nn_1_N = mkN "koralldjur" neutrum  ;
  kor_nn_1_N = mkN "kor" neutrum  ;
  koppaerr_nn_1_1_N = mkN "koppärr" neutrum  ;
  kopplerimaal_nn_1_1_N = mkN "kopplerimål" neutrum  ;
  koppartak_nn_1_N = mkN "koppartak" neutrum  ;
  kopparstick_nn_1_N = mkN "kopparstick" neutrum  ;
  kopparmynt_nn_1_N = mkN "kopparmynt" neutrum  ;
  kopiepapper_nn_1_N = mkN "kopiepapper" neutrum  ;
  konvolut_nn_1_N = mkN "konvolut" neutrum  ;
  konverteringskit_nn_1_N = mkN "konverteringskit" neutrum  ;
  konventionsbrott_nn_1_N = mkN "konventionsbrott" neutrum  ;
  konvent_nn_1_N = mkN "konvent" neutrum  ;
  konungamord_nn_1_N = mkN "konungamord" neutrum  ;
  kontrolltorn_nn_1_N = mkN "kontrolltorn" neutrum  ;
  kontrollorgan_nn_1_N = mkN "kontrollorgan" neutrum  ;
  kontrollnummer_nn_1_N = mkN "kontrollnummer" neutrum  ;
  kontrollinstrument_nn_1_N = mkN "kontrollinstrument" neutrum  ;
  kontrollbord_nn_1_N = mkN "kontrollbord" neutrum  ;
  kontrastmedel_nn_1_N = mkN "kontrastmedel" neutrum  ;
  kontraktsbrott_nn_1_N = mkN "kontraktsbrott" neutrum  ;
  kontrakt_nn_1_N = mkN "kontrakt" neutrum  ;
  kontoutdrag_nn_1_N = mkN "kontoutdrag" neutrum  ;
  kontorslandskap_nn_1_N = mkN "kontorslandskap" neutrum  ;
  kontorsbud_nn_1_N = mkN "kontorsbud" neutrum  ;
  kontor_nn_1_N = mkN "kontor" neutrum  ;
  kontonummer_nn_1_N = mkN "kontonummer" neutrum  ;
  kontokort_nn_1_N = mkN "kontokort" neutrum  ;
  konterfej_nn_1_N = mkN "konterfej" neutrum  ;
  kontantkort_nn_1_N = mkN "kontantkort" neutrum  ;
  kontaminationsoegonblick_nn_1_1_N = mkN "kontaminationsögonblick" neutrum  ;
  konsumtionsmoenster_nn_1_1_N = mkN "konsumtionsmönster" neutrum  ;
  konsumentverk_nn_1_N = mkN "konsumentverk" neutrum  ;
  konsultfoeretag_nn_1_1_N = mkN "konsultföretag" neutrum  ;
  konsulsval_nn_1_N = mkN "konsulsval" neutrum  ;
  konsulat_nn_1_N = mkN "konsulat" neutrum  ;
  konstverk_nn_1_N = mkN "konstverk" neutrum  ;
  konstspraak_nn_1_1_N = mkN "konstspråk" neutrum  ;
  konstruktionsmaterial_nn_1_N = mkN "konstruktionsmaterial" neutrum  ;
  konstliv_nn_1_N = mkN "konstliv" neutrum  ;
  konstitutorial_nn_1_N = mkN "konstitutorial" neutrum  ;
  konstitutionsutskott_nn_1_N = mkN "konstitutionsutskott" neutrum  ;
  konsthantverk_nn_1_N = mkN "konsthantverk" neutrum  ;
  konstgrepp_nn_1_N = mkN "konstgrepp" neutrum  ;
  konstansfenomen_nn_1_N = mkN "konstansfenomen" neutrum  ;
  konserveringsmedel_nn_1_N = mkN "konserveringsmedel" neutrum  ;
  konossement_nn_1_N = mkN "konossement" neutrum  ;
  konkurrensmedel_nn_1_N = mkN "konkurrensmedel" neutrum  ;
  konkrement_nn_1_N = mkN "konkrement" neutrum  ;
  konkordat_nn_1_N = mkN "konkordat" neutrum  ;
  konjunkturstoed_nn_1_1_N = mkN "konjunkturstöd" neutrum  ;
  konjunkturraad_nn_1_1_N = mkN "konjunkturråd" neutrum  ;
  konjunkturomslag_nn_1_N = mkN "konjunkturomslag" neutrum  ;
  konjunkturinstitut_nn_1_N = mkN "konjunkturinstitut" neutrum  ;
  kongruensfall_nn_1_N = mkN "kongruensfall" neutrum  ;
  konglomerat_nn_1_N = mkN "konglomerat" neutrum  ;
  konfliktmoenster_nn_1_1_N = mkN "konfliktmönster" neutrum  ;
  kondensspaar_nn_1_1_N = mkN "kondensspår" neutrum  ;
  kondensat_nn_1_N = mkN "kondensat" neutrum  ;
  konceptpapper_nn_1_N = mkN "konceptpapper" neutrum  ;
  koncept_nn_2_N = mkN "koncept" neutrum  ;
  koncentrationslaeger_nn_1_1_N = mkN "koncentrationsläger" neutrum  ;
  koncentrat_nn_1_N = mkN "koncentrat" neutrum  ;
  kompositmaterial_nn_1_N = mkN "kompositmaterial" neutrum  ;
  komplement_nn_1_N = mkN "komplement" neutrum  ;
  kompisgaeng_nn_1_1_N = mkN "kompisgäng" neutrum  ;
  kompilat_nn_1_N = mkN "kompilat" neutrum  ;
  kommunikationsnaet_nn_1_1_N = mkN "kommunikationsnät" neutrum  ;
  kommunikationsmedel_nn_1_N = mkN "kommunikationsmedel" neutrum  ;
  kommunikationsdepartement_nn_1_N = mkN "kommunikationsdepartement" neutrum  ;
  kommunfoerbund_nn_1_1_N = mkN "kommunförbund" neutrum  ;
  kommundelsraad_nn_1_1_N = mkN "kommundelsråd" neutrum  ;
  kommunblock_nn_1_N = mkN "kommunblock" neutrum  ;
  kommunalval_nn_1_N = mkN "kommunalval" neutrum  ;
  kommunalraad_nn_1_1_N = mkN "kommunalråd" neutrum  ;
  kommissariat_nn_1_N = mkN "kommissariat" neutrum  ;
  kommerseraad_nn_1_1_N = mkN "kommerseråd" neutrum  ;
  kommandorop_nn_1_N = mkN "kommandorop" neutrum  ;
  kommandoord_nn_1_N = mkN "kommandoord" neutrum  ;
  kommandomaal_nn_1_1_N = mkN "kommandomål" neutrum  ;
  kommanditbolag_nn_1_N = mkN "kommanditbolag" neutrum  ;
  kometmoln_nn_1_N = mkN "kometmoln" neutrum  ;
  kombinat_nn_1_N = mkN "kombinat" neutrum  ;
  koltbarn_nn_1_N = mkN "koltbarn" neutrum  ;
  kolsyregevaer_nn_1_1_N = mkN "kolsyregevär" neutrum  ;
  kolstaal_nn_1_1_N = mkN "kolstål" neutrum  ;
  kolstift_nn_1_N = mkN "kolstift" neutrum  ;
  kolroer_nn_1_1_N = mkN "kolrör" neutrum  ;
  kolossalformat_nn_1_N = mkN "kolossalformat" neutrum  ;
  kolonisationsfoersoek_nn_1_1_N = mkN "kolonisationsförsök" neutrum  ;
  koloniland_nn_1_N = mkN "koloniland" neutrum  ;
  kolonialkrig_nn_1_N = mkN "kolonialkrig" neutrum  ;
  kolonat_nn_1_N = mkN "kolonat" neutrum  ;
  kolon_nn_1_N = mkN "kolon" neutrum  ;
  kolnanoroer_nn_1_1_N = mkN "kolnanorör" neutrum  ;
  kollisionsskott_nn_1_N = mkN "kollisionsskott" neutrum  ;
  kollektivjordbruk_nn_1_N = mkN "kollektivjordbruk" neutrum  ;
  kollektivavtal_nn_1_N = mkN "kollektivavtal" neutrum  ;
  kollegieblock_nn_1_N = mkN "kollegieblock" neutrum  ;
  kolikanfall_nn_1_N = mkN "kolikanfall" neutrum  ;
  kolfilter_nn_1_N = mkN "kolfilter" neutrum  ;
  koldioxidutslaepp_nn_1_1_N = mkN "koldioxidutsläpp" neutrum  ;
  kokkaerl_nn_1_1_N = mkN "kokkärl" neutrum  ;
  kok_nn_1_N = mkN "kok" neutrum  ;
  koger_nn_1_N = mkN "koger" neutrum  ;
  kodspraak_nn_1_1_N = mkN "kodspråk" neutrum  ;
  knaeveck_nn_1_1_N = mkN "knäveck" neutrum  ;
  knaeslut_nn_1_1_N = mkN "knäslut" neutrum  ;
  knaeskydd_nn_1_1_N = mkN "knäskydd" neutrum  ;
  knaeroer_nn_1_1_N = mkN "knärör" neutrum  ;
  knaeckebroed_nn_1_1_N = mkN "knäckebröd" neutrum  ;
  knaeck_nn_2_1_N = mkN "knäck" neutrum  ;
  knytskaerp_nn_1_1_N = mkN "knytskärp" neutrum  ;
  knytnaevsslag_nn_1_1_N = mkN "knytnävsslag" neutrum  ;
  knull_nn_1_N = mkN "knull" neutrum  ;
  knoster_nn_1_N = mkN "knoster" neutrum  ;
  knogjaern_nn_1_1_N = mkN "knogjärn" neutrum  ;
  knog_nn_1_N = mkN "knog" neutrum  ;
  knivsaar_nn_1_1_N = mkN "knivsår" neutrum  ;
  knivskaft_nn_1_N = mkN "knivskaft" neutrum  ;
  knivmord_nn_1_N = mkN "knivmord" neutrum  ;
  knivhugg_nn_1_N = mkN "knivhugg" neutrum  ;
  knivblad_nn_1_N = mkN "knivblad" neutrum  ;
  knip_nn_1_N = mkN "knip" neutrum  ;
  knep_nn_1_N = mkN "knep" neutrum  ;
  kneg_nn_1_N = mkN "kneg" neutrum  ;
  knapptryck_nn_1_N = mkN "knapptryck" neutrum  ;
  knapphaal_nn_1_1_N = mkN "knapphål" neutrum  ;
  knallskott_nn_1_N = mkN "knallskott" neutrum  ;
  knack_nn_1_N = mkN "knack" neutrum  ;
  kloeverblad_nn_1_1_N = mkN "klöverblad" neutrum  ;
  kloevdjur_nn_1_1_N = mkN "klövdjur" neutrum  ;
  klaetterrep_nn_1_1_N = mkN "klätterrep" neutrum  ;
  klaetterjaern_nn_1_1_N = mkN "klätterjärn" neutrum  ;
  klaenningsliv_nn_1_1_N = mkN "klänningsliv" neutrum  ;
  klaedstreck_nn_1_1_N = mkN "klädstreck" neutrum  ;
  klaedskaap_nn_1_1_N = mkN "klädskåp" neutrum  ;
  klaedesplagg_nn_1_1_N = mkN "klädesplagg" neutrum  ;
  kluster_nn_1_N = mkN "kluster" neutrum  ;
  klumpackord_nn_1_N = mkN "klumpackord" neutrum  ;
  klubbslag_nn_1_N = mkN "klubbslag" neutrum  ;
  klotterplank_nn_1_N = mkN "klotterplank" neutrum  ;
  klot_nn_1_N = mkN "klot" neutrum  ;
  kloster_nn_1_N = mkN "kloster" neutrum  ;
  klocktorn_nn_1_N = mkN "klocktorn" neutrum  ;
  klockslag_nn_1_N = mkN "klockslag" neutrum  ;
  kloakdjur_nn_1_N = mkN "kloakdjur" neutrum  ;
  kliv_nn_1_N = mkN "kliv" neutrum  ;
  klippstup_nn_1_N = mkN "klippstup" neutrum  ;
  klippotek_nn_1_N = mkN "klippotek" neutrum  ;
  klippkort_nn_1_N = mkN "klippkort" neutrum  ;
  klippblock_nn_1_N = mkN "klippblock" neutrum  ;
  klipp_nn_1_N = mkN "klipp" neutrum  ;
  klimatskael_nn_1_1_N = mkN "klimatskäl" neutrum  ;
  klimathot_nn_1_N = mkN "klimathot" neutrum  ;
  klimatavtal_nn_1_N = mkN "klimatavtal" neutrum  ;
  klimat_nn_1_N = mkN "klimat" neutrum  ;
  klickljud_nn_1_N = mkN "klickljud" neutrum  ;
  klick_nn_2_N = mkN "klick" neutrum  ;
  klev_nn_1_N = mkN "klev" neutrum  ;
  klavikord_nn_1_N = mkN "klavikord" neutrum  ;
  klaverutdrag_nn_1_N = mkN "klaverutdrag" neutrum  ;
  klavertramp_nn_1_N = mkN "klavertramp" neutrum  ;
  klassmoerj_nn_1_1_N = mkN "klassmörj" neutrum  ;
  klasslag_nn_2_N = mkN "klasslag" neutrum  ;
  klarskinn_nn_1_N = mkN "klarskinn" neutrum  ;
  klarmedel_nn_1_N = mkN "klarmedel" neutrum  ;
  klarbaer_nn_1_1_N = mkN "klarbär" neutrum  ;
  klagotjut_nn_1_N = mkN "klagotjut" neutrum  ;
  klagorop_nn_1_N = mkN "klagorop" neutrum  ;
  klagomaal_nn_1_1_N = mkN "klagomål" neutrum  ;
  klaffbord_nn_1_N = mkN "klaffbord" neutrum  ;
  klackjaern_nn_1_1_N = mkN "klackjärn" neutrum  ;
  kjoltyg_nn_1_N = mkN "kjoltyg" neutrum  ;
  kit_nn_1_N = mkN "kit" neutrum  ;
  kistebrev_nn_1_N = mkN "kistebrev" neutrum  ;
  kistbrev_nn_1_N = mkN "kistbrev" neutrum  ;
  kindben_nn_1_N = mkN "kindben" neutrum  ;
  kilspaar_nn_1_1_N = mkN "kilspår" neutrum  ;
  kilopond_nn_1_N = mkN "kilopond" neutrum  ;
  kilben_nn_1_N = mkN "kilben" neutrum  ;
  kikhaal_nn_1_1_N = mkN "kikhål" neutrum  ;
  kidnappningsfoersoek_nn_1_1_N = mkN "kidnappningsförsök" neutrum  ;
  kid_nn_1_N = mkN "kid" neutrum  ;
  kejsarsnitt_nn_1_N = mkN "kejsarsnitt" neutrum  ;
  kedjestygn_nn_1_N = mkN "kedjestygn" neutrum  ;
  kedjeskydd_nn_1_N = mkN "kedjeskydd" neutrum  ;
  kedjelyftblock_nn_1_N = mkN "kedjelyftblock" neutrum  ;
  kedjehjul_nn_1_N = mkN "kedjehjul" neutrum  ;
  kedjebraak_nn_1_1_N = mkN "kedjebråk" neutrum  ;
  kedjebrev_nn_1_N = mkN "kedjebrev" neutrum  ;
  kedjeblock_nn_1_N = mkN "kedjeblock" neutrum  ;
  kebabstaand_nn_1_1_N = mkN "kebabstånd" neutrum  ;
  kavitetsdjur_nn_1_N = mkN "kavitetsdjur" neutrum  ;
  kavajslag_nn_1_N = mkN "kavajslag" neutrum  ;
  kattpensionat_nn_1_N = mkN "kattpensionat" neutrum  ;
  katthaar_nn_1_1_N = mkN "katthår" neutrum  ;
  kattdjur_nn_1_N = mkN "kattdjur" neutrum  ;
  katrinplommon_nn_1_N = mkN "katrinplommon" neutrum  ;
  katodstraaleroer_nn_1_1_N = mkN "katodstrålerör" neutrum  ;
  katastrofval_nn_1_N = mkN "katastrofval" neutrum  ;
  katastroftillstaand_nn_1_1_N = mkN "katastroftillstånd" neutrum  ;
  katastroflarm_nn_1_N = mkN "katastroflarm" neutrum  ;
  katalognummer_nn_1_N = mkN "katalognummer" neutrum  ;
  katalogfoeretag_nn_1_1_N = mkN "katalogföretag" neutrum  ;
  kasusspraak_nn_1_1_N = mkN "kasusspråk" neutrum  ;
  kaststygn_nn_1_N = mkN "kaststygn" neutrum  ;
  kastspjut_nn_1_N = mkN "kastspjut" neutrum  ;
  kastskydd_nn_1_N = mkN "kastskydd" neutrum  ;
  kastell_nn_1_N = mkN "kastell" neutrum  ;
  kastblock_nn_1_N = mkN "kastblock" neutrum  ;
  kassettdaeck_nn_1_1_N = mkN "kassettdäck" neutrum  ;
  kassettband_nn_1_N = mkN "kassettband" neutrum  ;
  kassavalv_nn_1_N = mkN "kassavalv" neutrum  ;
  kassaskaap_nn_1_1_N = mkN "kassaskåp" neutrum  ;
  kassaskrin_nn_1_N = mkN "kassaskrin" neutrum  ;
  kassandrarop_nn_1_N = mkN "kassandrarop" neutrum  ;
  kassakoep_nn_1_1_N = mkN "kassaköp" neutrum  ;
  kassakontor_nn_1_N = mkN "kassakontor" neutrum  ;
  kasernfoerbud_nn_1_1_N = mkN "kasernförbud" neutrum  ;
  karvsnitt_nn_1_N = mkN "karvsnitt" neutrum  ;
  kartotek_nn_1_N = mkN "kartotek" neutrum  ;
  kartongbruk_nn_1_N = mkN "kartongbruk" neutrum  ;
  karottunderlaegg_nn_1_1_N = mkN "karottunderlägg" neutrum  ;
  karlsbaderbroed_nn_1_1_N = mkN "karlsbaderbröd" neutrum  ;
  karlatag_nn_1_N = mkN "karlatag" neutrum  ;
  kardinaltal_nn_1_N = mkN "kardinaltal" neutrum  ;
  kardinalstreck_nn_1_N = mkN "kardinalstreck" neutrum  ;
  kardborreband_nn_1_N = mkN "kardborreband" neutrum  ;
  kardborrband_nn_1_N = mkN "kardborrband" neutrum  ;
  karbonpapper_nn_1_N = mkN "karbonpapper" neutrum  ;
  karbad_nn_1_N = mkN "karbad" neutrum  ;
  karamellpapper_nn_1_N = mkN "karamellpapper" neutrum  ;
  karaktaersmord_nn_1_1_N = mkN "karaktärsmord" neutrum  ;
  karaktaersdrag_nn_1_1_N = mkN "karaktärsdrag" neutrum  ;
  kar_nn_1_N = mkN "kar" neutrum  ;
  kapningsfoersoek_nn_1_1_N = mkN "kapningsförsök" neutrum  ;
  kapkrusbaer_nn_1_1_N = mkN "kapkrusbär" neutrum  ;
  kapital_nn_1_N = mkN "kapital" neutrum  ;
  kapillaerroer_nn_1_1_N = mkN "kapillärrör" neutrum  ;
  kapfaar_nn_1_1_N = mkN "kapfår" neutrum  ;
  kapell_nn_1_N = mkN "kapell" neutrum  ;
  kaparbrev_nn_1_N = mkN "kaparbrev" neutrum  ;
  kap_nn_2_N = mkN "kap" neutrum  ;
  kaosvaeder_nn_1_1_N = mkN "kaosväder" neutrum  ;
  kanvasband_nn_1_N = mkN "kanvasband" neutrum  ;
  kantrep_nn_1_N = mkN "kantrep" neutrum  ;
  kantbeslag_nn_1_N = mkN "kantbeslag" neutrum  ;
  kantband_nn_1_N = mkN "kantband" neutrum  ;
  kansliraad_nn_1_1_N = mkN "kansliråd" neutrum  ;
  kanotlaeger_nn_1_1_N = mkN "kanotläger" neutrum  ;
  kanonvaeder_nn_1_1_N = mkN "kanonväder" neutrum  ;
  kanontorn_nn_1_N = mkN "kanontorn" neutrum  ;
  kanonset_nn_1_N = mkN "kanonset" neutrum  ;
  kanonlopp_nn_1_N = mkN "kanonlopp" neutrum  ;
  kanonkoep_nn_1_1_N = mkN "kanonköp" neutrum  ;
  kanondaan_nn_1_1_N = mkN "kanondån" neutrum  ;
  kaninhaal_nn_1_1_N = mkN "kaninhål" neutrum  ;
  kandar_nn_1_N = mkN "kandar" neutrum  ;
  kanalutbud_nn_1_N = mkN "kanalutbud" neutrum  ;
  kamouflageinlaegg_nn_1_1_N = mkN "kamouflageinlägg" neutrum  ;
  kamikazeuppdrag_nn_1_N = mkN "kamikazeuppdrag" neutrum  ;
  kamelforskningsprojekt_nn_1_N = mkN "kamelforskningsprojekt" neutrum  ;
  kameldjur_nn_1_N = mkN "kameldjur" neutrum  ;
  kalvskinnsband_nn_1_N = mkN "kalvskinnsband" neutrum  ;
  kalvskinn_nn_1_N = mkN "kalvskinn" neutrum  ;
  kaloriintag_nn_1_N = mkN "kaloriintag" neutrum  ;
  kaloribehov_nn_1_N = mkN "kaloribehov" neutrum  ;
  kallortstillaegg_nn_1_1_N = mkN "kallortstillägg" neutrum  ;
  kallgrin_nn_1_N = mkN "kallgrin" neutrum  ;
  kallelsefoerslag_nn_1_1_N = mkN "kallelseförslag" neutrum  ;
  kallelsebrev_nn_1_N = mkN "kallelsebrev" neutrum  ;
  kallelsebeslut_nn_1_N = mkN "kallelsebeslut" neutrum  ;
  kallblod_nn_1_N = mkN "kallblod" neutrum  ;
  kallbad_nn_1_N = mkN "kallbad" neutrum  ;
  kall_nn_1_N = mkN "kall" neutrum  ;
  kalkylark_nn_1_N = mkN "kalkylark" neutrum  ;
  kalkskal_nn_1_N = mkN "kalkskal" neutrum  ;
  kalksediment_nn_1_N = mkN "kalksediment" neutrum  ;
  kalkerpapper_nn_1_N = mkN "kalkerpapper" neutrum  ;
  kalkbruk_nn_1_N = mkN "kalkbruk" neutrum  ;
  kalkbrott_nn_1_N = mkN "kalkbrott" neutrum  ;
  kalifat_nn_1_N = mkN "kalifat" neutrum  ;
  kalfjaell_nn_1_1_N = mkN "kalfjäll" neutrum  ;
  kalenderaar_nn_1_1_N = mkN "kalenderår" neutrum  ;
  kalenderdygn_nn_1_N = mkN "kalenderdygn" neutrum  ;
  kalejdoskop_nn_1_N = mkN "kalejdoskop" neutrum  ;
  kaleidoskop_nn_1_N = mkN "kaleidoskop" neutrum  ;
  kaktusfikon_nn_1_N = mkN "kaktusfikon" neutrum  ;
  kakmaatt_nn_1_1_N = mkN "kakmått" neutrum  ;
  kakfat_nn_1_N = mkN "kakfat" neutrum  ;
  kakelverktyg_nn_1_N = mkN "kakelverktyg" neutrum  ;
  kakbak_nn_1_N = mkN "kakbak" neutrum  ;
  kajutdaeck_nn_1_1_N = mkN "kajutdäck" neutrum  ;
  kajdjup_nn_1_N = mkN "kajdjup" neutrum  ;
  kairotal_nn_1_N = mkN "kairotal" neutrum  ;
  kaf_ebord_nn_1_1_N = mkN "kafébord" neutrum  ;
  kafferspraak_nn_1_1_N = mkN "kafferspråk" neutrum  ;
  kafferspjut_nn_1_N = mkN "kafferspjut" neutrum  ;
  kafferep_nn_1_N = mkN "kafferep" neutrum  ;
  kaffepulver_nn_1_N = mkN "kaffepulver" neutrum  ;
  kaffefilter_nn_1_N = mkN "kaffefilter" neutrum  ;
  kaffefat_nn_1_N = mkN "kaffefat" neutrum  ;
  kaffebord_nn_1_N = mkN "kaffebord" neutrum  ;
  kadettfartyg_nn_1_N = mkN "kadettfartyg" neutrum  ;
  kadaver_nn_1_N = mkN "kadaver" neutrum  ;
  kabinettskort_nn_1_N = mkN "kabinettskort" neutrum  ;
  kabinettsformat_nn_1_N = mkN "kabinettsformat" neutrum  ;
  kabinett_nn_1_N = mkN "kabinett" neutrum  ;
  kabelskaap_nn_1_1_N = mkN "kabelskåp" neutrum  ;
  kabelgatt_nn_1_N = mkN "kabelgatt" neutrum  ;
  jaevulstyg_nn_1_1_N = mkN "jävulstyg" neutrum  ;
  jaevelstyg_nn_1_1_N = mkN "jävelstyg" neutrum  ;
  jaev_nn_1_1_N = mkN "jäv" neutrum  ;
  jaettesteg_nn_1_1_N = mkN "jättesteg" neutrum  ;
  jaetteslagsmaal_nn_1_1_N = mkN "jätteslagsmål" neutrum  ;
  jaettemoln_nn_1_1_N = mkN "jättemoln" neutrum  ;
  jaetteklot_nn_1_1_N = mkN "jätteklot" neutrum  ;
  jaettekliv_nn_1_1_N = mkN "jättekliv" neutrum  ;
  jaetteisberg_nn_1_1_N = mkN "jätteisberg" neutrum  ;
  jaettefoeretag_nn_1_1_N = mkN "jätteföretag" neutrum  ;
  jaetteavtal_nn_1_1_N = mkN "jätteavtal" neutrum  ;
  jaernaar_nn_1_1_N = mkN "järnår" neutrum  ;
  jaernvaegsspaar_nn_1_1_N = mkN "järnvägsspår" neutrum  ;
  jaernverk_nn_1_1_N = mkN "järnverk" neutrum  ;
  jaernstaket_nn_1_1_N = mkN "järnstaket" neutrum  ;
  jaernstag_nn_1_1_N = mkN "järnstag" neutrum  ;
  jaernspett_nn_1_1_N = mkN "järnspett" neutrum  ;
  jaernroer_nn_1_1_N = mkN "järnrör" neutrum  ;
  jaernredskap_nn_1_1_N = mkN "järnredskap" neutrum  ;
  jaerngrepp_nn_1_1_N = mkN "järngrepp" neutrum  ;
  jaernfoeremaal_nn_1_1_N = mkN "järnföremål" neutrum  ;
  jaernbroellop_nn_1_1_N = mkN "järnbröllop" neutrum  ;
  jaernbruk_nn_1_1_N = mkN "järnbruk" neutrum  ;
  jaernblad_nn_1_1_N = mkN "järnblad" neutrum  ;
  jaernbeslag_nn_1_1_N = mkN "järnbeslag" neutrum  ;
  jaern_nn_1_1_N = mkN "järn" neutrum  ;
  jaemviktsorgan_nn_1_1_N = mkN "jämviktsorgan" neutrum  ;
  jaemnviktsorgan_nn_1_1_N = mkN "jämnviktsorgan" neutrum  ;
  jaemmerrop_nn_1_1_N = mkN "jämmerrop" neutrum  ;
  jaemfoerelsetal_nn_1_1_N = mkN "jämförelsetal" neutrum  ;
  jaegarhorn_nn_1_1_N = mkN "jägarhorn" neutrum  ;
  jaegarfoerband_nn_1_1_N = mkN "jägarförband" neutrum  ;
  jaegarfolk_nn_1_1_N = mkN "jägarfolk" neutrum  ;
  juver_nn_1_N = mkN "juver" neutrum  ;
  juvelerarfoenster_nn_1_1_N = mkN "juvelerarfönster" neutrum  ;
  justitieutskott_nn_1_N = mkN "justitieutskott" neutrum  ;
  justitieraad_nn_1_1_N = mkN "justitieråd" neutrum  ;
  justitiemord_nn_1_N = mkN "justitiemord" neutrum  ;
  justitiedepartement_nn_1_N = mkN "justitiedepartement" neutrum  ;
  jurt_nn_1_N = mkN "jurt" neutrum  ;
  jungfrutal_nn_1_N = mkN "jungfrutal" neutrum  ;
  jungfrustift_nn_1_N = mkN "jungfrustift" neutrum  ;
  jungfruben_nn_1_N = mkN "jungfruben" neutrum  ;
  julrecept_nn_1_N = mkN "julrecept" neutrum  ;
  julpynt_nn_1_N = mkN "julpynt" neutrum  ;
  jullov_nn_1_N = mkN "jullov" neutrum  ;
  julkort_nn_1_N = mkN "julkort" neutrum  ;
  julbord_nn_1_N = mkN "julbord" neutrum  ;
  jugendband_nn_1_N = mkN "jugendband" neutrum  ;
  judebroed_nn_1_1_N = mkN "judebröd" neutrum  ;
  jubileumsaar_nn_1_1_N = mkN "jubileumsår" neutrum  ;
  jubileumsmynt_nn_1_N = mkN "jubileumsmynt" neutrum  ;
  jubelaar_nn_1_1_N = mkN "jubelår" neutrum  ;
  jubelrop_nn_1_N = mkN "jubelrop" neutrum  ;
  jordtag_nn_1_N = mkN "jordtag" neutrum  ;
  jordsvin_nn_1_N = mkN "jordsvin" neutrum  ;
  jordspjut_nn_1_N = mkN "jordspjut" neutrum  ;
  jordskred_nn_1_N = mkN "jordskred" neutrum  ;
  jordskott_nn_1_N = mkN "jordskott" neutrum  ;
  jordskalv_nn_1_N = mkN "jordskalv" neutrum  ;
  jordregister_nn_1_N = mkN "jordregister" neutrum  ;
  jordmaterial_nn_1_N = mkN "jordmaterial" neutrum  ;
  jordlager_nn_1_N = mkN "jordlager" neutrum  ;
  jordgolv_nn_1_N = mkN "jordgolv" neutrum  ;
  jordfynd_nn_1_N = mkN "jordfynd" neutrum  ;
  jordbruksredskap_nn_1_N = mkN "jordbruksredskap" neutrum  ;
  jordbrukslandskap_nn_1_N = mkN "jordbrukslandskap" neutrum  ;
  jordbruksdepartement_nn_1_N = mkN "jordbruksdepartement" neutrum  ;
  jordbruk_nn_1_N = mkN "jordbruk" neutrum  ;
  jordblad_nn_1_N = mkN "jordblad" neutrum  ;
  jongitter_nn_1_N = mkN "jongitter" neutrum  ;
  jojovaeder_nn_1_1_N = mkN "jojoväder" neutrum  ;
  jobbskatteavdrag_nn_1_N = mkN "jobbskatteavdrag" neutrum  ;
  jobbkoek_nn_1_1_N = mkN "jobbkök" neutrum  ;
  jobbcoachningsfoeretag_nn_1_1_N = mkN "jobbcoachningsföretag" neutrum  ;
  jobb_nn_1_N = mkN "jobb" neutrum  ;
  jetset_nn_1_N = mkN "jetset" neutrum  ;
  jetplan_nn_1_N = mkN "jetplan" neutrum  ;
  jetflygplan_nn_1_N = mkN "jetflygplan" neutrum  ;
  jesusbarn_nn_1_N = mkN "jesusbarn" neutrum  ;
  jazzband_nn_1_N = mkN "jazzband" neutrum  ;
  jarop_nn_1_N = mkN "jarop" neutrum  ;
  jaktspaar_nn_1_1_N = mkN "jaktspår" neutrum  ;
  jaktslott_nn_1_N = mkN "jaktslott" neutrum  ;
  jaktprov_nn_1_N = mkN "jaktprov" neutrum  ;
  jaktplan_nn_1_N = mkN "jaktplan" neutrum  ;
  jaktlopp_nn_1_N = mkN "jaktlopp" neutrum  ;
  jaktlag_nn_1_N = mkN "jaktlag" neutrum  ;
  jaktkort_nn_1_N = mkN "jaktkort" neutrum  ;
  jakthorn_nn_1_N = mkN "jakthorn" neutrum  ;
  jaktgevaer_nn_1_1_N = mkN "jaktgevär" neutrum  ;
  jaktbrott_nn_1_N = mkN "jaktbrott" neutrum  ;
  jag_nn_1_N = mkN "jag" neutrum  ;
  jackuttag_nn_1_N = mkN "jackuttag" neutrum  ;
  jack_nn_1_N = mkN "jack" neutrum  ;
  it_foeretag_nn_1_1_N = mkN "it-företag" neutrum  ;
  istryck_nn_1_N = mkN "istryck" neutrum  ;
  isterband_nn_1_N = mkN "isterband" neutrum  ;
  isskaap_nn_1_1_N = mkN "isskåp" neutrum  ;
  isoleringsmaterial_nn_1_N = mkN "isoleringsmaterial" neutrum  ;
  isoleringsband_nn_1_N = mkN "isoleringsband" neutrum  ;
  isolerband_nn_1_N = mkN "isolerband" neutrum  ;
  islamtal_nn_1_N = mkN "islamtal" neutrum  ;
  iskorn_nn_1_N = mkN "iskorn" neutrum  ;
  ishockeyroer_nn_1_1_N = mkN "ishockeyrör" neutrum  ;
  ishav_nn_1_N = mkN "ishav" neutrum  ;
  isflak_nn_1_N = mkN "isflak" neutrum  ;
  isblock_nn_1_N = mkN "isblock" neutrum  ;
  isberg_nn_1_N = mkN "isberg" neutrum  ;
  irritationsmoment_nn_1_N = mkN "irritationsmoment" neutrum  ;
  irritament_nn_1_N = mkN "irritament" neutrum  ;
  iridiumlager_nn_1_N = mkN "iridiumlager" neutrum  ;
  ip_nummer_nn_1_N = mkN "ip-nummer" neutrum  ;
  investmentbolag_nn_1_N = mkN "investmentbolag" neutrum  ;
  inverterelverk_nn_1_N = mkN "inverterelverk" neutrum  ;
  invandrarverk_nn_1_N = mkN "invandrarverk" neutrum  ;
  invandrarbroellop_nn_1_1_N = mkN "invandrarbröllop" neutrum  ;
  inval_nn_1_N = mkN "inval" neutrum  ;
  intaag_nn_1_1_N = mkN "intåg" neutrum  ;
  intyg_nn_1_N = mkN "intyg" neutrum  ;
  intraedestal_nn_1_1_N = mkN "inträdestal" neutrum  ;
  intraedesprov_nn_1_1_N = mkN "inträdesprov" neutrum  ;
  intraedeskrav_nn_1_1_N = mkN "inträdeskrav" neutrum  ;
  intryck_nn_1_N = mkN "intryck" neutrum  ;
  introduktionsbrev_nn_1_N = mkN "introduktionsbrev" neutrum  ;
  intranaet_nn_1_1_N = mkN "intranät" neutrum  ;
  intjack_nn_1_N = mkN "intjack" neutrum  ;
  intestatarv_nn_1_N = mkN "intestatarv" neutrum  ;
  intervjuobjekt_nn_1_N = mkN "intervjuobjekt" neutrum  ;
  interregnum_nn_1_N = mkN "interregnum" neutrum  ;
  interneringslaeger_nn_1_1_N = mkN "interneringsläger" neutrum  ;
  internat_nn_1_N = mkN "internat" neutrum  ;
  interferensmoenster_nn_1_1_N = mkN "interferensmönster" neutrum  ;
  interdikt_nn_1_N = mkN "interdikt" neutrum  ;
  intercitytaag_nn_1_1_N = mkN "intercitytåg" neutrum  ;
  intentionsdjup_nn_1_N = mkN "intentionsdjup" neutrum  ;
  intellekt_nn_1_N = mkN "intellekt" neutrum  ;
  inteckningslaan_nn_1_1_N = mkN "inteckningslån" neutrum  ;
  intag_nn_1_N = mkN "intag" neutrum  ;
  instrument_nn_1_N = mkN "instrument" neutrum  ;
  institut_nn_1_N = mkN "institut" neutrum  ;
  installationstal_nn_1_N = mkN "installationstal" neutrum  ;
  insnitt_nn_1_N = mkN "insnitt" neutrum  ;
  inslaepp_nn_1_1_N = mkN "insläpp" neutrum  ;
  inslag_nn_1_N = mkN "inslag" neutrum  ;
  inskott_nn_1_N = mkN "inskott" neutrum  ;
  insideraatal_nn_1_1_N = mkN "insideråtal" neutrum  ;
  insidermaal_nn_1_1_N = mkN "insidermål" neutrum  ;
  insektsmedel_nn_1_N = mkN "insektsmedel" neutrum  ;
  insektsbett_nn_1_N = mkN "insektsbett" neutrum  ;
  insektsangrepp_nn_1_N = mkN "insektsangrepp" neutrum  ;
  inrop_nn_1_N = mkN "inrop" neutrum  ;
  inrikesdepartement_nn_1_N = mkN "inrikesdepartement" neutrum  ;
  inresetillstaand_nn_1_1_N = mkN "inresetillstånd" neutrum  ;
  inomhusgolv_nn_1_N = mkN "inomhusgolv" neutrum  ;
  innertak_nn_1_N = mkN "innertak" neutrum  ;
  innerskaer_nn_1_1_N = mkN "innerskär" neutrum  ;
  innerdoerrhandtag_nn_1_1_N = mkN "innerdörrhandtag" neutrum  ;
  innehaallsord_nn_1_1_N = mkN "innehållsord" neutrum  ;
  innehaallsobjekt_nn_1_1_N = mkN "innehållsobjekt" neutrum  ;
  innehaall_nn_1_1_N = mkN "innehåll" neutrum  ;
  innehavarpapper_nn_1_N = mkN "innehavarpapper" neutrum  ;
  innehav_nn_1_N = mkN "innehav" neutrum  ;
  innanlaar_nn_1_1_N = mkN "innanlår" neutrum  ;
  innanhav_nn_1_N = mkN "innanhav" neutrum  ;
  innanfoenster_nn_1_1_N = mkN "innanfönster" neutrum  ;
  inlaerningsresultat_nn_1_1_N = mkN "inlärningsresultat" neutrum  ;
  inlaegg_nn_1_1_N = mkN "inlägg" neutrum  ;
  inlopp_nn_1_N = mkN "inlopp" neutrum  ;
  inljud_nn_1_N = mkN "inljud" neutrum  ;
  inkoep_nn_1_1_N = mkN "inköp" neutrum  ;
  inkomstslag_nn_1_N = mkN "inkomstslag" neutrum  ;
  inkomstmaatt_nn_1_1_N = mkN "inkomstmått" neutrum  ;
  inkomstkort_nn_1_N = mkN "inkomstkort" neutrum  ;
  inkomstbortfall_nn_1_N = mkN "inkomstbortfall" neutrum  ;
  inkomstbelopp_nn_1_N = mkN "inkomstbelopp" neutrum  ;
  inkomstbegrepp_nn_1_N = mkN "inkomstbegrepp" neutrum  ;
  inkassobrev_nn_1_N = mkN "inkassobrev" neutrum  ;
  inkallelsebrev_nn_1_N = mkN "inkallelsebrev" neutrum  ;
  inkabaer_nn_1_1_N = mkN "inkabär" neutrum  ;
  initialord_nn_1_N = mkN "initialord" neutrum  ;
  inhopp_nn_1_N = mkN "inhopp" neutrum  ;
  inhav_nn_1_N = mkN "inhav" neutrum  ;
  ingoet_nn_1_1_N = mkN "ingöt" neutrum  ;
  ingrepp_nn_1_N = mkN "ingrepp" neutrum  ;
  ingefaerspaeron_nn_1_1_N = mkN "ingefärspäron" neutrum  ;
  infusionsdjur_nn_1_N = mkN "infusionsdjur" neutrum  ;
  infraljud_nn_1_N = mkN "infraljud" neutrum  ;
  informationsorgan_nn_1_N = mkN "informationsorgan" neutrum  ;
  influensafall_nn_1_N = mkN "influensafall" neutrum  ;
  influensadoedsfall_nn_1_1_N = mkN "influensadödsfall" neutrum  ;
  inflationsskydd_nn_1_N = mkN "inflationsskydd" neutrum  ;
  infall_nn_1_N = mkN "infall" neutrum  ;
  industrifoerbund_nn_1_1_N = mkN "industriförbund" neutrum  ;
  indrag_nn_1_N = mkN "indrag" neutrum  ;
  indiantjut_nn_1_N = mkN "indiantjut" neutrum  ;
  indianreservat_nn_1_N = mkN "indianreservat" neutrum  ;
  indianfolk_nn_1_N = mkN "indianfolk" neutrum  ;
  indexavtal_nn_1_N = mkN "indexavtal" neutrum  ;
  incitament_nn_1_N = mkN "incitament" neutrum  ;
  incabaer_nn_1_1_N = mkN "incabär" neutrum  ;
  inboerdeskrig_nn_1_1_N = mkN "inbördeskrig" neutrum  ;
  inbrott_nn_1_N = mkN "inbrott" neutrum  ;
  inbjudningskort_nn_1_N = mkN "inbjudningskort" neutrum  ;
  inbillningsfoster_nn_1_N = mkN "inbillningsfoster" neutrum  ;
  inbetalningskort_nn_1_N = mkN "inbetalningskort" neutrum  ;
  inbegrepp_nn_1_N = mkN "inbegrepp" neutrum  ;
  imskydd_nn_1_N = mkN "imskydd" neutrum  ;
  imroer_nn_1_1_N = mkN "imrör" neutrum  ;
  impulskoep_nn_1_1_N = mkN "impulsköp" neutrum  ;
  importstopp_nn_1_N = mkN "importstopp" neutrum  ;
  importfoerbud_nn_1_1_N = mkN "importförbud" neutrum  ;
  implantat_nn_1_N = mkN "implantat" neutrum  ;
  imperiekrig_nn_1_N = mkN "imperiekrig" neutrum  ;
  imperialformat_nn_1_N = mkN "imperialformat" neutrum  ;
  impediment_nn_1_N = mkN "impediment" neutrum  ;
  ilsamtal_nn_1_N = mkN "ilsamtal" neutrum  ;
  illvraal_nn_1_1_N = mkN "illvrål" neutrum  ;
  illusionsnummer_nn_1_N = mkN "illusionsnummer" neutrum  ;
  illtjut_nn_1_N = mkN "illtjut" neutrum  ;
  illdaad_nn_1_1_N = mkN "illdåd" neutrum  ;
  ilbud_nn_1_N = mkN "ilbud" neutrum  ;
  ifyllnadsprov_nn_1_N = mkN "ifyllnadsprov" neutrum  ;
  idrottsreferat_nn_1_N = mkN "idrottsreferat" neutrum  ;
  idrottslag_nn_1_N = mkN "idrottslag" neutrum  ;
  idolskap_nn_1_N = mkN "idolskap" neutrum  ;
  idolportraett_nn_1_1_N = mkN "idolporträtt" neutrum  ;
  identitetskort_nn_1_N = mkN "identitetskort" neutrum  ;
  ideal_nn_1_N = mkN "ideal" neutrum  ;
  id_kort_nn_1_N = mkN "id-kort" neutrum  ;
  icke_spridningsavtal_nn_1_N = mkN "icke-spridningsavtal" neutrum  ;
  hoestvaeder_nn_1_1_N = mkN "höstväder" neutrum  ;
  hoestregn_nn_1_1_N = mkN "höstregn" neutrum  ;
  hoestloev_nn_1_1_N = mkN "höstlöv" neutrum  ;
  hoestlov_nn_1_1_N = mkN "höstlov" neutrum  ;
  hoerselskydd_nn_1_1_N = mkN "hörselskydd" neutrum  ;
  hoerselorgan_nn_1_1_N = mkN "hörselorgan" neutrum  ;
  hoerselben_nn_1_1_N = mkN "hörselben" neutrum  ;
  hoerntorn_nn_1_1_N = mkN "hörntorn" neutrum  ;
  hoernskaap_nn_1_1_N = mkN "hörnskåp" neutrum  ;
  hoern_nn_1_1_N = mkN "hörn" neutrum  ;
  hoensaegg_nn_1_1_N = mkN "hönsägg" neutrum  ;
  hoensnaet_nn_1_1_N = mkN "hönsnät" neutrum  ;
  hoensbaer_nn_1_1_N = mkN "hönsbär" neutrum  ;
  hoelster_nn_1_1_N = mkN "hölster" neutrum  ;
  hoejdhopp_nn_1_1_N = mkN "höjdhopp" neutrum  ;
  hoegvarv_nn_1_1_N = mkN "högvarv" neutrum  ;
  hoegtryck_nn_1_1_N = mkN "högtryck" neutrum  ;
  hoegtidsaar_nn_1_1_N = mkN "högtidsår" neutrum  ;
  hoegtidstal_nn_1_1_N = mkN "högtidstal" neutrum  ;
  hoegrev_nn_1_1_N = mkN "högrev" neutrum  ;
  hoegmaalsbrott_nn_1_1_N = mkN "högmålsbrott" neutrum  ;
  hoegloenejobb_nn_1_1_N = mkN "höglönejobb" neutrum  ;
  hoeglager_nn_1_1_N = mkN "höglager" neutrum  ;
  hoegkor_nn_1_1_N = mkN "högkor" neutrum  ;
  hoeghastighetstaag_nn_1_1_N = mkN "höghastighetståg" neutrum  ;
  hoegfjaell_nn_1_1_N = mkN "högfjäll" neutrum  ;
  hoegerben_nn_1_1_N = mkN "högerben" neutrum  ;
  hoegdjur_nn_1_1_N = mkN "högdjur" neutrum  ;
  hoegblad_nn_1_1_N = mkN "högblad" neutrum  ;
  hoegben_nn_1_1_N = mkN "högben" neutrum  ;
  hoeftben_nn_1_1_N = mkN "höftben" neutrum  ;
  haarsvall_nn_1_1_N = mkN "hårsvall" neutrum  ;
  haarroerskaerl_nn_1_1_N = mkN "hårrörskärl" neutrum  ;
  haarroer_nn_1_1_N = mkN "hårrör" neutrum  ;
  haarlag_nn_1_1_N = mkN "hårlag" neutrum  ;
  haarfaergningsmedel_nn_1_1_N = mkN "hårfärgningsmedel" neutrum  ;
  haarband_nn_1_1_N = mkN "hårband" neutrum  ;
  haar_nn_2_1_N = mkN "hår" neutrum  ;
  haanskratt_nn_1_1_N = mkN "hånskratt" neutrum  ;
  haangelpar_nn_1_1_N = mkN "hångelpar" neutrum  ;
  haanflin_nn_1_1_N = mkN "hånflin" neutrum  ;
  haalspikband_nn_1_1_N = mkN "hålspikband" neutrum  ;
  haalslag_nn_1_1_N = mkN "hålslag" neutrum  ;
  haalmoenster_nn_1_1_N = mkN "hålmönster" neutrum  ;
  haallningssaett_nn_1_1_N = mkN "hållningssätt" neutrum  ;
  haalligaang_nn_1_1_N = mkN "hålligång" neutrum  ;
  haall_nn_1_1_N = mkN "håll" neutrum  ;
  haalkort_nn_1_1_N = mkN "hålkort" neutrum  ;
  haalfotsinlaegg_nn_1_1_N = mkN "hålfotsinlägg" neutrum  ;
  haal_nn_1_1_N = mkN "hål" neutrum  ;
  haeststyng_nn_1_1_N = mkN "häststyng" neutrum  ;
  haestspann_nn_1_1_N = mkN "hästspann" neutrum  ;
  haestdjur_nn_1_1_N = mkN "hästdjur" neutrum  ;
  haestben_nn_1_1_N = mkN "hästben" neutrum  ;
  haertaag_nn_1_1_N = mkN "härtåg" neutrum  ;
  haerskarpar_nn_1_1_N = mkN "härskarpar" neutrum  ;
  haernadstaag_nn_1_1_N = mkN "härnadståg" neutrum  ;
  haerjningstaag_nn_1_1_N = mkN "härjningståg" neutrum  ;
  haerdighetskrav_nn_1_1_N = mkN "härdighetskrav" neutrum  ;
  haeradsting_nn_1_1_N = mkN "häradsting" neutrum  ;
  haengavtal_nn_1_1_N = mkN "hängavtal" neutrum  ;
  haendelsefoerlopp_nn_1_1_N = mkN "händelseförlopp" neutrum  ;
  haelsotek_nn_1_1_N = mkN "hälsotek" neutrum  ;
  haelsoskael_nn_1_1_N = mkN "hälsoskäl" neutrum  ;
  haelsokort_nn_1_1_N = mkN "hälsokort" neutrum  ;
  haelsningstal_nn_1_1_N = mkN "hälsningstal" neutrum  ;
  haellregn_nn_1_1_N = mkN "hällregn" neutrum  ;
  haelftenbruk_nn_1_1_N = mkN "hälftenbruk" neutrum  ;
  haelben_nn_1_1_N = mkN "hälben" neutrum  ;
  haektningsbeslut_nn_1_1_N = mkN "häktningsbeslut" neutrum  ;
  haeftstift_nn_1_1_N = mkN "häftstift" neutrum  ;
  haedelseaatal_nn_1_1_N = mkN "hädelseåtal" neutrum  ;
  haecklopp_nn_1_1_N = mkN "häcklopp" neutrum  ;
  hyvelstaal_nn_1_1_N = mkN "hyvelstål" neutrum  ;
  hyvelspaan_nn_1_1_N = mkN "hyvelspån" neutrum  ;
  hyveljaern_nn_1_1_N = mkN "hyveljärn" neutrum  ;
  hyresvillkor_nn_1_N = mkN "hyresvillkor" neutrum  ;
  hyrestillaegg_nn_1_1_N = mkN "hyrestillägg" neutrum  ;
  hyreskontrakt_nn_1_N = mkN "hyreskontrakt" neutrum  ;
  hyresavtal_nn_1_N = mkN "hyresavtal" neutrum  ;
  hypotekslaan_nn_1_1_N = mkN "hypotekslån" neutrum  ;
  hypotek_nn_1_N = mkN "hypotek" neutrum  ;
  hydroplan_nn_1_N = mkN "hydroplan" neutrum  ;
  huvudverb_nn_1_N = mkN "huvudverb" neutrum  ;
  huvudstraak_nn_1_1_N = mkN "huvudstråk" neutrum  ;
  huvudskael_nn_1_1_N = mkN "huvudskäl" neutrum  ;
  huvudskyddsombud_nn_1_N = mkN "huvudskyddsombud" neutrum  ;
  huvudskydd_nn_1_N = mkN "huvudskydd" neutrum  ;
  huvudord_nn_1_N = mkN "huvudord" neutrum  ;
  huvudmoment_nn_1_N = mkN "huvudmoment" neutrum  ;
  huvudlag_nn_1_N = mkN "huvudlag" neutrum  ;
  huvudkontor_nn_1_N = mkN "huvudkontor" neutrum  ;
  huvudinnehaall_nn_1_1_N = mkN "huvudinnehåll" neutrum  ;
  huvudhaar_nn_1_1_N = mkN "huvudhår" neutrum  ;
  huvuddrag_nn_1_N = mkN "huvuddrag" neutrum  ;
  huvudbudskap_nn_1_N = mkN "huvudbudskap" neutrum  ;
  huvudavtal_nn_1_N = mkN "huvudavtal" neutrum  ;
  hustrutillaegg_nn_1_1_N = mkN "hustrutillägg" neutrum  ;
  hustimmer_nn_1_N = mkN "hustimmer" neutrum  ;
  hustak_nn_1_N = mkN "hustak" neutrum  ;
  husorgan_nn_1_N = mkN "husorgan" neutrum  ;
  husnummer_nn_1_N = mkN "husnummer" neutrum  ;
  huskoep_nn_1_1_N = mkN "husköp" neutrum  ;
  hushaallningssaellskap_nn_1_1_N = mkN "hushållningssällskap" neutrum  ;
  hushaall_nn_1_1_N = mkN "hushåll" neutrum  ;
  husgeraad_nn_1_1_N = mkN "husgeråd" neutrum  ;
  husfoervaerv_nn_1_1_N = mkN "husförvärv" neutrum  ;
  husfoerhoer_nn_1_1_N = mkN "husförhör" neutrum  ;
  husfridsknull_nn_1_N = mkN "husfridsknull" neutrum  ;
  husdjur_nn_1_N = mkN "husdjur" neutrum  ;
  husbehov_nn_1_N = mkN "husbehov" neutrum  ;
  husapotek_nn_1_N = mkN "husapotek" neutrum  ;
  hurrarop_nn_1_N = mkN "hurrarop" neutrum  ;
  hungerupplopp_nn_1_N = mkN "hungerupplopp" neutrum  ;
  hundaar_nn_1_1_N = mkN "hundår" neutrum  ;
  hundvaeder_nn_1_1_N = mkN "hundväder" neutrum  ;
  hundslagsmaal_nn_1_1_N = mkN "hundslagsmål" neutrum  ;
  hundratusental_nn_1_N = mkN "hundratusental" neutrum  ;
  hundratal_nn_1_N = mkN "hundratal" neutrum  ;
  hundpensionat_nn_1_N = mkN "hundpensionat" neutrum  ;
  hundhaar_nn_1_1_N = mkN "hundhår" neutrum  ;
  hundhalsband_nn_1_N = mkN "hundhalsband" neutrum  ;
  hunddjur_nn_1_N = mkN "hunddjur" neutrum  ;
  hundben_nn_1_N = mkN "hundben" neutrum  ;
  humoer_nn_1_1_N = mkN "humör" neutrum  ;
  humlesurr_nn_1_N = mkN "humlesurr" neutrum  ;
  humleblomster_nn_1_N = mkN "humleblomster" neutrum  ;
  hugskott_nn_1_N = mkN "hugskott" neutrum  ;
  huggsaar_nn_1_1_N = mkN "huggsår" neutrum  ;
  hugg_nn_1_N = mkN "hugg" neutrum  ;
  hudveck_nn_1_N = mkN "hudveck" neutrum  ;
  hudutslag_nn_1_N = mkN "hudutslag" neutrum  ;
  hudmedel_nn_1_N = mkN "hudmedel" neutrum  ;
  hudlager_nn_1_N = mkN "hudlager" neutrum  ;
  hudhorn_nn_1_N = mkN "hudhorn" neutrum  ;
  hovslag_nn_1_N = mkN "hovslag" neutrum  ;
  hovraettsraad_nn_1_1_N = mkN "hovrättsråd" neutrum  ;
  hovkapell_nn_1_N = mkN "hovkapell" neutrum  ;
  hovdjur_nn_1_N = mkN "hovdjur" neutrum  ;
  hovbeslag_nn_1_N = mkN "hovbeslag" neutrum  ;
  hov_nn_2_N = mkN "hov" neutrum  ;
  hotelsebrev_nn_1_N = mkN "hotelsebrev" neutrum  ;
  hotell_nn_1_N = mkN "hotell" neutrum  ;
  hot_nn_1_N = mkN "hot" neutrum  ;
  hostanfall_nn_1_N = mkN "hostanfall" neutrum  ;
  hospital_nn_1_N = mkN "hospital" neutrum  ;
  horoskop_nn_1_N = mkN "horoskop" neutrum  ;
  horn_nn_1_N = mkN "horn" neutrum  ;
  hormonsvall_nn_1_N = mkN "hormonsvall" neutrum  ;
  horisontalplan_nn_1_N = mkN "horisontalplan" neutrum  ;
  hopptorn_nn_1_N = mkN "hopptorn" neutrum  ;
  hopprep_nn_1_N = mkN "hopprep" neutrum  ;
  hoppfoersoek_nn_1_1_N = mkN "hoppförsök" neutrum  ;
  hopp_nn_1_N = mkN "hopp" neutrum  ;
  hopkok_nn_1_N = mkN "hopkok" neutrum  ;
  hopklumpningstillstaand_nn_1_1_N = mkN "hopklumpningstillstånd" neutrum  ;
  honorar_nn_1_N = mkN "honorar" neutrum  ;
  honnoersord_nn_1_1_N = mkN "honnörsord" neutrum  ;
  honnoersbord_nn_1_1_N = mkN "honnörsbord" neutrum  ;
  honnoersbetyg_nn_1_1_N = mkN "honnörsbetyg" neutrum  ;
  hondjur_nn_1_N = mkN "hondjur" neutrum  ;
  homoaektenskap_nn_1_1_N = mkN "homoäktenskap" neutrum  ;
  homopar_nn_1_N = mkN "homopar" neutrum  ;
  holt_nn_1_N = mkN "holt" neutrum  ;
  holdingbolag_nn_1_N = mkN "holdingbolag" neutrum  ;
  hockeyroer_nn_1_1_N = mkN "hockeyrör" neutrum  ;
  hjaessben_nn_1_1_N = mkN "hjässben" neutrum  ;
  hjaertstopp_nn_1_1_N = mkN "hjärtstopp" neutrum  ;
  hjaertstillestaand_nn_1_1_N = mkN "hjärtstillestånd" neutrum  ;
  hjaertslag_nn_1_1_N = mkN "hjärtslag" neutrum  ;
  hjaertljud_nn_1_1_N = mkN "hjärtljud" neutrum  ;
  hjaertelag_nn_1_1_N = mkN "hjärtelag" neutrum  ;
  hjaertekval_nn_1_1_N = mkN "hjärtekval" neutrum  ;
  hjaertegull_nn_1_1_N = mkN "hjärtegull" neutrum  ;
  hjaertegryn_nn_1_1_N = mkN "hjärtegryn" neutrum  ;
  hjaertebarn_nn_1_1_N = mkN "hjärtebarn" neutrum  ;
  hjaertblad_nn_1_1_N = mkN "hjärtblad" neutrum  ;
  hjaertbarn_nn_1_1_N = mkN "hjärtbarn" neutrum  ;
  hjaernslaepp_nn_1_1_N = mkN "hjärnsläpp" neutrum  ;
  hjaernbihang_nn_1_1_N = mkN "hjärnbihang" neutrum  ;
  hjaelteportraett_nn_1_1_N = mkN "hjälteporträtt" neutrum  ;
  hjaeltedaad_nn_1_1_N = mkN "hjältedåd" neutrum  ;
  hjaelpverb_nn_1_1_N = mkN "hjälpverb" neutrum  ;
  hjaelpspraak_nn_1_1_N = mkN "hjälpspråk" neutrum  ;
  hjaelpmedel_nn_1_1_N = mkN "hjälpmedel" neutrum  ;
  hjaelpfartyg_nn_1_1_N = mkN "hjälpfartyg" neutrum  ;
  hjulspaar_nn_1_1_N = mkN "hjulspår" neutrum  ;
  hjulnav_nn_1_N = mkN "hjulnav" neutrum  ;
  hjullager_nn_1_N = mkN "hjullager" neutrum  ;
  hjulfoenster_nn_1_1_N = mkN "hjulfönster" neutrum  ;
  hjuldjur_nn_1_N = mkN "hjuldjur" neutrum  ;
  hjul_nn_1_N = mkN "hjul" neutrum  ;
  hjortdjur_nn_1_N = mkN "hjortdjur" neutrum  ;
  hjonelag_nn_1_N = mkN "hjonelag" neutrum  ;
  hjon_nn_1_N = mkN "hjon" neutrum  ;
  hivutbrott_nn_1_N = mkN "hivutbrott" neutrum  ;
  hittebarn_nn_1_N = mkN "hittebarn" neutrum  ;
  historieverk_nn_1_N = mkN "historieverk" neutrum  ;
  hindertrick_nn_1_N = mkN "hindertrick" neutrum  ;
  hinder_nn_1_N = mkN "hinder" neutrum  ;
  himmelsobjekt_nn_1_N = mkN "himmelsobjekt" neutrum  ;
  himlafenomen_nn_1_N = mkN "himlafenomen" neutrum  ;
  hetsbrott_nn_1_N = mkN "hetsbrott" neutrum  ;
  heteropar_nn_1_N = mkN "heteropar" neutrum  ;
  herrskap_nn_1_N = mkN "herrskap" neutrum  ;
  herrlandslag_nn_1_N = mkN "herrlandslag" neutrum  ;
  herrefolk_nn_1_N = mkN "herrefolk" neutrum  ;
  heroinvrak_nn_1_N = mkN "heroinvrak" neutrum  ;
  herdefolk_nn_1_N = mkN "herdefolk" neutrum  ;
  herdabrev_nn_1_N = mkN "herdabrev" neutrum  ;
  hemvaern_nn_1_1_N = mkN "hemvärn" neutrum  ;
  hemspraak_nn_1_1_N = mkN "hemspråk" neutrum  ;
  hemsjukvaardsbidrag_nn_1_1_N = mkN "hemsjukvårdsbidrag" neutrum  ;
  hemnummer_nn_1_N = mkN "hemnummer" neutrum  ;
  hemman_nn_1_N = mkN "hemman" neutrum  ;
  hemmalag_nn_1_N = mkN "hemmalag" neutrum  ;
  hemlaan_nn_1_1_N = mkN "hemlån" neutrum  ;
  hemfridsbrott_nn_1_N = mkN "hemfridsbrott" neutrum  ;
  hembud_nn_1_N = mkN "hembud" neutrum  ;
  hembesoek_nn_1_1_N = mkN "hembesök" neutrum  ;
  heltidsjobb_nn_1_N = mkN "heltidsjobb" neutrum  ;
  heltal_nn_1_N = mkN "heltal" neutrum  ;
  helskaegg_nn_1_1_N = mkN "helskägg" neutrum  ;
  helikopterraan_nn_1_1_N = mkN "helikopterrån" neutrum  ;
  helikon_nn_1_N = mkN "helikon" neutrum  ;
  helhetsintryck_nn_1_N = mkN "helhetsintryck" neutrum  ;
  helgon_nn_1_N = mkN "helgon" neutrum  ;
  helgeraan_nn_1_1_N = mkN "helgerån" neutrum  ;
  helfabrikat_nn_1_N = mkN "helfabrikat" neutrum  ;
  hedersord_nn_1_N = mkN "hedersord" neutrum  ;
  hedersnamn_nn_1_N = mkN "hedersnamn" neutrum  ;
  hedersmord_nn_1_N = mkN "hedersmord" neutrum  ;
  hedersbegrepp_nn_1_N = mkN "hedersbegrepp" neutrum  ;
  heat_nn_1_N = mkN "heat" neutrum  ;
  havsoernspar_nn_1_1_N = mkN "havsörnspar" neutrum  ;
  havsmonster_nn_1_N = mkN "havsmonster" neutrum  ;
  havsdjup_nn_1_N = mkN "havsdjup" neutrum  ;
  havsbad_nn_1_N = mkN "havsbad" neutrum  ;
  havrekorn_nn_1_N = mkN "havrekorn" neutrum  ;
  havregryn_nn_1_N = mkN "havregryn" neutrum  ;
  havreflarn_nn_1_N = mkN "havreflarn" neutrum  ;
  havandeskap_nn_1_N = mkN "havandeskap" neutrum  ;
  hav_nn_1_N = mkN "hav" neutrum  ;
  hatsamtal_nn_1_N = mkN "hatsamtal" neutrum  ;
  hatportraett_nn_1_1_N = mkN "hatporträtt" neutrum  ;
  hatobjekt_nn_1_N = mkN "hatobjekt" neutrum  ;
  hatbrott_nn_1_N = mkN "hatbrott" neutrum  ;
  hatbrev_nn_1_N = mkN "hatbrev" neutrum  ;
  hastverk_nn_1_N = mkN "hastverk" neutrum  ;
  harspaar_nn_1_1_N = mkN "harspår" neutrum  ;
  harem_nn_1_N = mkN "harem" neutrum  ;
  hantverksjobb_nn_1_N = mkN "hantverksjobb" neutrum  ;
  hantverk_nn_1_N = mkN "hantverk" neutrum  ;
  hanorgan_nn_1_N = mkN "hanorgan" neutrum  ;
  hangarfartyg_nn_1_N = mkN "hangarfartyg" neutrum  ;
  hang_nn_1_N = mkN "hang" neutrum  ;
  handtag_nn_1_N = mkN "handtag" neutrum  ;
  handslag_nn_1_N = mkN "handslag" neutrum  ;
  handskfack_nn_1_N = mkN "handskfack" neutrum  ;
  handlaan_nn_1_1_N = mkN "handlån" neutrum  ;
  handlingssaett_nn_1_1_N = mkN "handlingssätt" neutrum  ;
  handlingsord_nn_1_N = mkN "handlingsord" neutrum  ;
  handjur_nn_1_N = mkN "handjur" neutrum  ;
  handikapp_nn_1_N = mkN "handikapp" neutrum  ;
  handgrepp_nn_1_N = mkN "handgrepp" neutrum  ;
  handgemaeng_nn_1_1_N = mkN "handgemäng" neutrum  ;
  handfat_nn_1_N = mkN "handfat" neutrum  ;
  handelsregister_nn_1_N = mkN "handelsregister" neutrum  ;
  handelskoep_nn_1_1_N = mkN "handelsköp" neutrum  ;
  handelskontor_nn_1_N = mkN "handelskontor" neutrum  ;
  handelsfoeretag_nn_1_1_N = mkN "handelsföretag" neutrum  ;
  handelsfoerdrag_nn_1_1_N = mkN "handelsfördrag" neutrum  ;
  handelsfartyg_nn_1_N = mkN "handelsfartyg" neutrum  ;
  handelsdepartement_nn_1_N = mkN "handelsdepartement" neutrum  ;
  handelsbolag_nn_1_N = mkN "handelsbolag" neutrum  ;
  handelsavtal_nn_1_N = mkN "handelsavtal" neutrum  ;
  handbrev_nn_1_N = mkN "handbrev" neutrum  ;
  handavtryck_nn_1_N = mkN "handavtryck" neutrum  ;
  handalfabet_nn_1_N = mkN "handalfabet" neutrum  ;
  hamnkontor_nn_1_N = mkN "hamnkontor" neutrum  ;
  hammockgaangjaern_nn_1_1_N = mkN "hammockgångjärn" neutrum  ;
  hammarslag_nn_1_N = mkN "hammarslag" neutrum  ;
  hammarband_nn_1_N = mkN "hammarband" neutrum  ;
  halvaar_nn_1_1_N = mkN "halvår" neutrum  ;
  halvstop_nn_1_N = mkN "halvstop" neutrum  ;
  halvslag_nn_1_N = mkN "halvslag" neutrum  ;
  halvmaratonlopp_nn_1_N = mkN "halvmaratonlopp" neutrum  ;
  halvklot_nn_1_N = mkN "halvklot" neutrum  ;
  halvfabrikat_nn_1_N = mkN "halvfabrikat" neutrum  ;
  halvdaeck_nn_1_1_N = mkN "halvdäck" neutrum  ;
  halvdussin_nn_1_N = mkN "halvdussin" neutrum  ;
  halvblod_nn_1_N = mkN "halvblod" neutrum  ;
  halster_nn_1_N = mkN "halster" neutrum  ;
  halsjaern_nn_1_1_N = mkN "halsjärn" neutrum  ;
  halsband_nn_1_N = mkN "halsband" neutrum  ;
  halogenstraalkastarset_nn_1_1_N = mkN "halogenstrålkastarset" neutrum  ;
  halofenomen_nn_1_N = mkN "halofenomen" neutrum  ;
  halmtak_nn_1_N = mkN "halmtak" neutrum  ;
  hallucinationstillstaand_nn_1_1_N = mkN "hallucinationstillstånd" neutrum  ;
  hallon_nn_1_N = mkN "hallon" neutrum  ;
  hallgolv_nn_1_N = mkN "hallgolv" neutrum  ;
  halkskydd_nn_1_N = mkN "halkskydd" neutrum  ;
  halgatt_nn_1_N = mkN "halgatt" neutrum  ;
  hakskaegg_nn_1_1_N = mkN "hakskägg" neutrum  ;
  hakband_nn_1_N = mkN "hakband" neutrum  ;
  hak_nn_1_N = mkN "hak" neutrum  ;
  hagelkorn_nn_1_N = mkN "hagelkorn" neutrum  ;
  hagelgevaer_nn_1_1_N = mkN "hagelgevär" neutrum  ;
  hagelboesseskott_nn_1_1_N = mkN "hagelbösseskott" neutrum  ;
  hafsverk_nn_1_N = mkN "hafsverk" neutrum  ;
  hackningsfoersoek_nn_1_1_N = mkN "hackningsförsök" neutrum  ;
  hack_nn_1_N = mkN "hack" neutrum  ;
  goetvalsverk_nn_1_1_N = mkN "götvalsverk" neutrum  ;
  goetamaal_nn_1_1_N = mkN "götamål" neutrum  ;
  goeromaal_nn_1_1_N = mkN "göromål" neutrum  ;
  goerdeldaeck_nn_1_1_N = mkN "gördeldäck" neutrum  ;
  goekur_nn_1_1_N = mkN "gökur" neutrum  ;
  goekblomster_nn_1_1_N = mkN "gökblomster" neutrum  ;
  goedselmedel_nn_1_1_N = mkN "gödselmedel" neutrum  ;
  goedningsmedel_nn_1_1_N = mkN "gödningsmedel" neutrum  ;
  goeddjur_nn_1_1_N = mkN "göddjur" neutrum  ;
  gaavobrev_nn_1_1_N = mkN "gåvobrev" neutrum  ;
  gaavoavtal_nn_1_1_N = mkN "gåvoavtal" neutrum  ;
  gaasaegg_nn_1_1_N = mkN "gåsägg" neutrum  ;
  gaangjaern_nn_1_1_N = mkN "gångjärn" neutrum  ;
  gaanghjaelpmedel_nn_1_1_N = mkN "gånghjälpmedel" neutrum  ;
  gaangbord_nn_1_1_N = mkN "gångbord" neutrum  ;
  gaangavstaand_nn_1_1_N = mkN "gångavstånd" neutrum  ;
  gaahjaelpmedel_nn_1_1_N = mkN "gåhjälpmedel" neutrum  ;
  gaestabud_nn_1_1_N = mkN "gästabud" neutrum  ;
  gaesp_nn_1_1_N = mkN "gäsp" neutrum  ;
  gaengverktyg_nn_1_1_N = mkN "gängverktyg" neutrum  ;
  gaengstaal_nn_1_1_N = mkN "gängstål" neutrum  ;
  gaengkrig_nn_1_1_N = mkN "gängkrig" neutrum  ;
  gaeng_nn_1_1_N = mkN "gäng" neutrum  ;
  gaelblad_nn_1_1_N = mkN "gälblad" neutrum  ;
  gaeddhaeng_nn_1_1_N = mkN "gäddhäng" neutrum  ;
  gyttjebad_nn_1_N = mkN "gyttjebad" neutrum  ;
  gyroskop_nn_1_N = mkN "gyroskop" neutrum  ;
  gymnastikredskap_nn_1_N = mkN "gymnastikredskap" neutrum  ;
  gymnastikhopp_nn_1_N = mkN "gymnastikhopp" neutrum  ;
  gymnasieval_nn_1_N = mkN "gymnasieval" neutrum  ;
  gymkort_nn_1_N = mkN "gymkort" neutrum  ;
  gyllental_nn_1_N = mkN "gyllental" neutrum  ;
  gyllen_nn_1_N = mkN "gyllen" neutrum  ;
  guvernement_nn_1_N = mkN "guvernement" neutrum  ;
  gupp_nn_1_N = mkN "gupp" neutrum  ;
  gummiskydd_nn_1_N = mkN "gummiskydd" neutrum  ;
  gummimaterial_nn_1_N = mkN "gummimaterial" neutrum  ;
  gummihjul_nn_1_N = mkN "gummihjul" neutrum  ;
  gummidaeck_nn_1_1_N = mkN "gummidäck" neutrum  ;
  gummiband_nn_1_N = mkN "gummiband" neutrum  ;
  gull_nn_1_N = mkN "gull" neutrum  ;
  gulfilter_nn_1_N = mkN "gulfilter" neutrum  ;
  guldsnitt_nn_1_N = mkN "guldsnitt" neutrum  ;
  guldprov_nn_1_N = mkN "guldprov" neutrum  ;
  guldmynt_nn_1_N = mkN "guldmynt" neutrum  ;
  guldkorn_nn_1_N = mkN "guldkorn" neutrum  ;
  guldfoeremaal_nn_1_1_N = mkN "guldföremål" neutrum  ;
  guldfynd_nn_1_N = mkN "guldfynd" neutrum  ;
  guldbaer_nn_1_1_N = mkN "guldbär" neutrum  ;
  guldbroellop_nn_1_1_N = mkN "guldbröllop" neutrum  ;
  guld_nn_1_N = mkN "guld" neutrum  ;
  gudsord_nn_1_N = mkN "gudsord" neutrum  ;
  gudslaan_nn_1_1_N = mkN "gudslån" neutrum  ;
  gudbarn_nn_1_N = mkN "gudbarn" neutrum  ;
  gubbskaegg_nn_1_1_N = mkN "gubbskägg" neutrum  ;
  groetomslag_nn_1_1_N = mkN "grötomslag" neutrum  ;
  groensaksstaand_nn_1_1_N = mkN "grönsaksstånd" neutrum  ;
  graavaedersmoln_nn_1_1_N = mkN "gråvädersmoln" neutrum  ;
  graavaeder_nn_1_1_N = mkN "gråväder" neutrum  ;
  graaskaegg_nn_1_1_N = mkN "gråskägg" neutrum  ;
  graapaeron_nn_1_1_N = mkN "gråpäron" neutrum  ;
  graabroedrakonvent_nn_1_1_N = mkN "gråbrödrakonvent" neutrum  ;
  graevsvin_nn_1_1_N = mkN "grävsvin" neutrum  ;
  graevschakt_nn_1_1_N = mkN "grävschakt" neutrum  ;
  graevlingshaar_nn_1_1_N = mkN "grävlingshår" neutrum  ;
  graevlingsgryt_nn_1_1_N = mkN "grävlingsgryt" neutrum  ;
  graenssnitt_nn_1_1_N = mkN "gränssnitt" neutrum  ;
  graensskikt_nn_1_1_N = mkN "gränsskikt" neutrum  ;
  graensfall_nn_1_1_N = mkN "gränsfall" neutrum  ;
  graensbraak_nn_1_1_N = mkN "gränsbråk" neutrum  ;
  graen_nn_1_1_N = mkN "grän" neutrum  ;
  grael_nn_1_1_N = mkN "gräl" neutrum  ;
  grytskaap_nn_1_1_N = mkN "grytskåp" neutrum  ;
  grytlock_nn_1_N = mkN "grytlock" neutrum  ;
  gryt_nn_1_N = mkN "gryt" neutrum  ;
  gruvschakt_nn_1_N = mkN "gruvschakt" neutrum  ;
  gruvhaal_nn_1_1_N = mkN "gruvhål" neutrum  ;
  gruvfaelt_nn_1_1_N = mkN "gruvfält" neutrum  ;
  gruvbolag_nn_1_N = mkN "gruvbolag" neutrum  ;
  grustag_nn_1_N = mkN "grustag" neutrum  ;
  gruppsamtal_nn_1_N = mkN "gruppsamtal" neutrum  ;
  gruppkorsband_nn_1_N = mkN "gruppkorsband" neutrum  ;
  grundvillkor_nn_1_N = mkN "grundvillkor" neutrum  ;
  grundtillstaand_nn_1_1_N = mkN "grundtillstånd" neutrum  ;
  grundtal_nn_1_N = mkN "grundtal" neutrum  ;
  grundspraak_nn_1_1_N = mkN "grundspråk" neutrum  ;
  grundskott_nn_1_N = mkN "grundskott" neutrum  ;
  grundskolebarn_nn_1_N = mkN "grundskolebarn" neutrum  ;
  grundord_nn_1_N = mkN "grundord" neutrum  ;
  grundmaatt_nn_1_1_N = mkN "grundmått" neutrum  ;
  grundlagsbrott_nn_1_N = mkN "grundlagsbrott" neutrum  ;
  grundlag_nn_2_N = mkN "grundlag" neutrum  ;
  grundhav_nn_1_N = mkN "grundhav" neutrum  ;
  grundelement_nn_1_N = mkN "grundelement" neutrum  ;
  grunddrag_nn_1_N = mkN "grunddrag" neutrum  ;
  grundbrott_nn_1_N = mkN "grundbrott" neutrum  ;
  grundbelopp_nn_1_N = mkN "grundbelopp" neutrum  ;
  grundbegrepp_nn_1_N = mkN "grundbegrepp" neutrum  ;
  grundavdrag_nn_1_N = mkN "grundavdrag" neutrum  ;
  grundackord_nn_1_N = mkN "grundackord" neutrum  ;
  grund_nn_2_N = mkN "grund" neutrum  ;
  gruff_nn_1_N = mkN "gruff" neutrum  ;
  grovkoek_nn_1_1_N = mkN "grovkök" neutrum  ;
  grovbruk_nn_1_N = mkN "grovbruk" neutrum  ;
  grodaegg_nn_1_1_N = mkN "grodägg" neutrum  ;
  grodlaar_nn_1_1_N = mkN "grodlår" neutrum  ;
  groddjur_nn_1_N = mkN "groddjur" neutrum  ;
  groddblad_nn_1_N = mkN "groddblad" neutrum  ;
  groblad_nn_1_N = mkN "groblad" neutrum  ;
  grindbeslag_nn_1_N = mkN "grindbeslag" neutrum  ;
  grin_nn_1_N = mkN "grin" neutrum  ;
  grimskaft_nn_1_N = mkN "grimskaft" neutrum  ;
  grillspett_nn_1_N = mkN "grillspett" neutrum  ;
  griftetal_nn_1_N = mkN "griftetal" neutrum  ;
  grevskap_nn_1_N = mkN "grevskap" neutrum  ;
  grepp_nn_1_N = mkN "grepp" neutrum  ;
  grenveck_nn_1_N = mkN "grenveck" neutrum  ;
  grenuttag_nn_1_N = mkN "grenuttag" neutrum  ;
  grenhopp_nn_1_N = mkN "grenhopp" neutrum  ;
  gravoel_nn_1_1_N = mkN "gravöl" neutrum  ;
  gravvalv_nn_1_N = mkN "gravvalv" neutrum  ;
  gravtal_nn_1_N = mkN "gravtal" neutrum  ;
  gravskick_nn_1_N = mkN "gravskick" neutrum  ;
  gravmonument_nn_1_N = mkN "gravmonument" neutrum  ;
  gravmaterial_nn_1_N = mkN "gravmaterial" neutrum  ;
  gravkor_nn_1_N = mkN "gravkor" neutrum  ;
  gravkapell_nn_1_N = mkN "gravkapell" neutrum  ;
  gravfaelt_nn_1_1_N = mkN "gravfält" neutrum  ;
  gravfynd_nn_1_N = mkN "gravfynd" neutrum  ;
  gravbrev_nn_1_N = mkN "gravbrev" neutrum  ;
  gratulationskort_nn_1_N = mkN "gratulationskort" neutrum  ;
  gratulationsbrev_nn_1_N = mkN "gratulationsbrev" neutrum  ;
  gratisskjut_nn_1_N = mkN "gratisskjut" neutrum  ;
  granulat_nn_1_N = mkN "granulat" neutrum  ;
  granskningsexemplar_nn_1_N = mkN "granskningsexemplar" neutrum  ;
  grannskap_nn_1_N = mkN "grannskap" neutrum  ;
  granbarr_nn_1_N = mkN "granbarr" neutrum  ;
  granatgevaer_nn_1_1_N = mkN "granatgevär" neutrum  ;
  gran_nn_2_N = mkN "gran" neutrum  ;
  grammofonstift_nn_1_N = mkN "grammofonstift" neutrum  ;
  grahamsbroed_nn_1_1_N = mkN "grahamsbröd" neutrum  ;
  gradtal_nn_1_N = mkN "gradtal" neutrum  ;
  gradstreck_nn_1_N = mkN "gradstreck" neutrum  ;
  gradnaet_nn_1_1_N = mkN "gradnät" neutrum  ;
  graderverk_nn_1_N = mkN "graderverk" neutrum  ;
  grabbatag_nn_1_N = mkN "grabbatag" neutrum  ;
  gossebarn_nn_1_N = mkN "gossebarn" neutrum  ;
  goraan_nn_1_1_N = mkN "gorån" neutrum  ;
  gomljud_nn_1_N = mkN "gomljud" neutrum  ;
  gomben_nn_1_N = mkN "gomben" neutrum  ;
  golvur_nn_1_N = mkN "golvur" neutrum  ;
  golvskyddspapper_nn_1_N = mkN "golvskyddspapper" neutrum  ;
  golv_nn_1_N = mkN "golv" neutrum  ;
  godtrosfoervaerv_nn_1_1_N = mkN "godtrosförvärv" neutrum  ;
  godstaag_nn_1_1_N = mkN "godståg" neutrum  ;
  godsmagasin_nn_1_N = mkN "godsmagasin" neutrum  ;
  godmanskap_nn_1_N = mkN "godmanskap" neutrum  ;
  gnistskydd_nn_1_N = mkN "gnistskydd" neutrum  ;
  gnistgap_nn_1_N = mkN "gnistgap" neutrum  ;
  gnistgaller_nn_1_N = mkN "gnistgaller" neutrum  ;
  gnisselljud_nn_1_N = mkN "gnisselljud" neutrum  ;
  gnabb_nn_1_N = mkN "gnabb" neutrum  ;
  glaapord_nn_1_1_N = mkN "glåpord" neutrum  ;
  glaedjespraang_nn_1_1_N = mkN "glädjesprång" neutrum  ;
  glaedjerop_nn_1_1_N = mkN "glädjerop" neutrum  ;
  glaedjebudskap_nn_1_1_N = mkN "glädjebudskap" neutrum  ;
  glaedjebud_nn_1_1_N = mkN "glädjebud" neutrum  ;
  glaedjebetyg_nn_1_1_N = mkN "glädjebetyg" neutrum  ;
  glaedjebesked_nn_1_1_N = mkN "glädjebesked" neutrum  ;
  glyptotek_nn_1_N = mkN "glyptotek" neutrum  ;
  gliom_nn_1_N = mkN "gliom" neutrum  ;
  glinder_nn_1_N = mkN "glinder" neutrum  ;
  glidmedel_nn_1_N = mkN "glidmedel" neutrum  ;
  glidljud_nn_1_N = mkN "glidljud" neutrum  ;
  glidlager_nn_1_N = mkN "glidlager" neutrum  ;
  glid_nn_1_N = mkN "glid" neutrum  ;
  glasoegonfodral_nn_1_1_N = mkN "glasögonfodral" neutrum  ;
  glassrecept_nn_1_N = mkN "glassrecept" neutrum  ;
  glasskaap_nn_1_1_N = mkN "glasskåp" neutrum  ;
  glasroer_nn_1_1_N = mkN "glasrör" neutrum  ;
  glasklot_nn_1_N = mkN "glasklot" neutrum  ;
  glasfoeremaal_nn_1_1_N = mkN "glasföremål" neutrum  ;
  glasbruk_nn_1_N = mkN "glasbruk" neutrum  ;
  glasberg_nn_1_N = mkN "glasberg" neutrum  ;
  glapp_nn_1_N = mkN "glapp" neutrum  ;
  glanspapper_nn_1_N = mkN "glanspapper" neutrum  ;
  glansnummer_nn_1_N = mkN "glansnummer" neutrum  ;
  glad_nn_1_N = mkN "glad" neutrum  ;
  givkort_nn_1_N = mkN "givkort" neutrum  ;
  gitter_nn_1_N = mkN "gitter" neutrum  ;
  gisselslag_nn_1_N = mkN "gisselslag" neutrum  ;
  gisseldjur_nn_1_N = mkN "gisseldjur" neutrum  ;
  girobesked_nn_1_N = mkN "girobesked" neutrum  ;
  gipstak_nn_1_N = mkN "gipstak" neutrum  ;
  gipsfoerband_nn_1_1_N = mkN "gipsförband" neutrum  ;
  ginnungagap_nn_1_N = mkN "ginnungagap" neutrum  ;
  giller_nn_1_N = mkN "giller" neutrum  ;
  gig_nn_1_N = mkN "gig" neutrum  ;
  giftutslaepp_nn_1_1_N = mkN "giftutsläpp" neutrum  ;
  giftpiller_nn_1_N = mkN "giftpiller" neutrum  ;
  giftmord_nn_1_N = mkN "giftmord" neutrum  ;
  giftmoln_nn_1_N = mkN "giftmoln" neutrum  ;
  giftermaal_nn_1_1_N = mkN "giftermål" neutrum  ;
  gevaersskott_nn_1_1_N = mkN "gevärsskott" neutrum  ;
  gevaer_nn_1_1_N = mkN "gevär" neutrum  ;
  getskaegg_nn_1_1_N = mkN "getskägg" neutrum  ;
  getskinn_nn_1_N = mkN "getskinn" neutrum  ;
  getingstick_nn_1_N = mkN "getingstick" neutrum  ;
  gesaellprov_nn_1_1_N = mkN "gesällprov" neutrum  ;
  gesaellbrev_nn_1_1_N = mkN "gesällbrev" neutrum  ;
  geschaeft_nn_1_1_N = mkN "geschäft" neutrum  ;
  germanfolk_nn_1_N = mkN "germanfolk" neutrum  ;
  gerillakrig_nn_1_N = mkN "gerillakrig" neutrum  ;
  gerilladaad_nn_1_1_N = mkN "gerilladåd" neutrum  ;
  gentlemannabeslut_nn_1_N = mkN "gentlemannabeslut" neutrum  ;
  genrep_nn_1_N = mkN "genrep" neutrum  ;
  genomtaag_nn_1_1_N = mkN "genomtåg" neutrum  ;
  genomsnitt_nn_1_N = mkN "genomsnitt" neutrum  ;
  genomslagspapper_nn_1_N = mkN "genomslagspapper" neutrum  ;
  genomslag_nn_1_N = mkN "genomslag" neutrum  ;
  genombrott_nn_1_N = mkN "genombrott" neutrum  ;
  genom_nn_1_N = mkN "genom" neutrum  ;
  genitivattribut_nn_1_N = mkN "genitivattribut" neutrum  ;
  generalrep_nn_1_N = mkN "generalrep" neutrum  ;
  generalkonsulat_nn_1_N = mkN "generalkonsulat" neutrum  ;
  generalangrepp_nn_1_N = mkN "generalangrepp" neutrum  ;
  gemyt_nn_1_N = mkN "gemyt" neutrum  ;
  gemak_nn_1_N = mkN "gemak" neutrum  ;
  gem_nn_2_N = mkN "gem" neutrum  ;
  gel_ehallon_nn_1_1_N = mkN "geléhallon" neutrum  ;
  geiger_mullerroer_nn_1_1_N = mkN "geiger-müllerrör" neutrum  ;
  gehaeng_nn_1_1_N = mkN "gehäng" neutrum  ;
  geheimeraad_nn_1_1_N = mkN "geheimeråd" neutrum  ;
  gebit_nn_1_N = mkN "gebit" neutrum  ;
  gavelfaelt_nn_1_1_N = mkN "gavelfält" neutrum  ;
  gatustaand_nn_1_1_N = mkN "gatustånd" neutrum  ;
  gatuplan_nn_1_N = mkN "gatuplan" neutrum  ;
  gatunamn_nn_1_N = mkN "gatunamn" neutrum  ;
  gatuliv_nn_1_N = mkN "gatuliv" neutrum  ;
  gatukoek_nn_1_1_N = mkN "gatukök" neutrum  ;
  gatukontor_nn_1_N = mkN "gatukontor" neutrum  ;
  gatubarn_nn_1_N = mkN "gatubarn" neutrum  ;
  gatt_nn_1_N = mkN "gatt" neutrum  ;
  gatlopp_nn_1_N = mkN "gatlopp" neutrum  ;
  gathoern_nn_1_1_N = mkN "gathörn" neutrum  ;
  gasverk_nn_1_N = mkN "gasverk" neutrum  ;
  gasutslaepp_nn_1_1_N = mkN "gasutsläpp" neutrum  ;
  gastryck_nn_1_N = mkN "gastryck" neutrum  ;
  gastroskop_nn_1_N = mkN "gastroskop" neutrum  ;
  gasskydd_nn_1_N = mkN "gasskydd" neutrum  ;
  gasolkoek_nn_1_1_N = mkN "gasolkök" neutrum  ;
  gasmoln_nn_1_N = mkN "gasmoln" neutrum  ;
  gasmaskfodral_nn_1_N = mkN "gasmaskfodral" neutrum  ;
  gaskoek_nn_1_1_N = mkN "gaskök" neutrum  ;
  gasklot_nn_1_N = mkN "gasklot" neutrum  ;
  garvmedel_nn_1_N = mkN "garvmedel" neutrum  ;
  garv_nn_1_N = mkN "garv" neutrum  ;
  garnityr_nn_1_N = mkN "garnityr" neutrum  ;
  gardjaern_nn_1_1_N = mkN "gardjärn" neutrum  ;
  gardinband_nn_1_N = mkN "gardinband" neutrum  ;
  garantilaan_nn_1_1_N = mkN "garantilån" neutrum  ;
  garantifoerdrag_nn_1_1_N = mkN "garantifördrag" neutrum  ;
  garantibelopp_nn_1_N = mkN "garantibelopp" neutrum  ;
  gapskratt_nn_1_N = mkN "gapskratt" neutrum  ;
  gapflabb_nn_1_N = mkN "gapflabb" neutrum  ;
  gap_nn_1_N = mkN "gap" neutrum  ;
  galvanoskop_nn_1_N = mkN "galvanoskop" neutrum  ;
  galltjut_nn_1_N = mkN "galltjut" neutrum  ;
  gallskrik_nn_1_N = mkN "gallskrik" neutrum  ;
  gallkvalster_nn_1_N = mkN "gallkvalster" neutrum  ;
  gallerverk_nn_1_N = mkN "gallerverk" neutrum  ;
  gallerstaket_nn_1_N = mkN "gallerstaket" neutrum  ;
  gallerfoenster_nn_1_1_N = mkN "gallerfönster" neutrum  ;
  galler_nn_1_N = mkN "galler" neutrum  ;
  foeraeldrabesoek_nn_1_1_N = mkN "föräldrabesök" neutrum  ;
  foervaervsavdrag_nn_1_1_N = mkN "förvärvsavdrag" neutrum  ;
  foervaerv_nn_1_1_N = mkN "förvärv" neutrum  ;
  foervaringsskaap_nn_1_1_N = mkN "förvaringsskåp" neutrum  ;
  foervaringskaerl_nn_1_1_N = mkN "förvaringskärl" neutrum  ;
  foervandlingsstraff_nn_1_1_N = mkN "förvandlingsstraff" neutrum  ;
  foervandlingsnummer_nn_1_1_N = mkN "förvandlingsnummer" neutrum  ;
  foervaltningsutskott_nn_1_1_N = mkN "förvaltningsutskott" neutrum  ;
  foervaltningsbolag_nn_1_1_N = mkN "förvaltningsbolag" neutrum  ;
  foervaltningsbeslut_nn_1_1_N = mkN "förvaltningsbeslut" neutrum  ;
  foerundersoekningsprotokoll_nn_1_1_N = mkN "förundersökningsprotokoll" neutrum  ;
  foertroendeuppdrag_nn_1_1_N = mkN "förtroendeuppdrag" neutrum  ;
  foertroenderaad_nn_1_1_N = mkN "förtroenderåd" neutrum  ;
  foertroendeglapp_nn_1_1_N = mkN "förtroendeglapp" neutrum  ;
  foertalsmaal_nn_1_1_N = mkN "förtalsmål" neutrum  ;
  foersoerjningsprojekt_nn_1_1_N = mkN "försörjningsprojekt" neutrum  ;
  foersoeksobjekt_nn_1_1_N = mkN "försöksobjekt" neutrum  ;
  foersoeksheat_nn_1_1_N = mkN "försöksheat" neutrum  ;
  foersoeksdjur_nn_1_1_N = mkN "försöksdjur" neutrum  ;
  foersoek_nn_1_1_N = mkN "försök" neutrum  ;
  foersaat_nn_1_1_N = mkN "försåt" neutrum  ;
  foersaettsblad_nn_1_1_N = mkN "försättsblad" neutrum  ;
  foersaeljningsstaand_nn_1_1_N = mkN "försäljningsstånd" neutrum  ;
  foersaeljningsstopp_nn_1_1_N = mkN "försäljningsstopp" neutrum  ;
  foersaekringsvillkor_nn_1_1_N = mkN "försäkringsvillkor" neutrum  ;
  foersaekringsskydd_nn_1_1_N = mkN "försäkringsskydd" neutrum  ;
  foersaekringsinslag_nn_1_1_N = mkN "försäkringsinslag" neutrum  ;
  foersaekringsbrev_nn_1_1_N = mkN "försäkringsbrev" neutrum  ;
  foersaekringsbolagskontor_nn_1_1_N = mkN "försäkringsbolagskontor" neutrum  ;
  foersaekringsbolag_nn_1_1_N = mkN "försäkringsbolag" neutrum  ;
  foersaekringsbesked_nn_1_1_N = mkN "försäkringsbesked" neutrum  ;
  foersvarsverk_nn_1_1_N = mkN "försvarsverk" neutrum  ;
  foersvarsutskott_nn_1_1_N = mkN "försvarsutskott" neutrum  ;
  foersvarstal_nn_1_1_N = mkN "försvarstal" neutrum  ;
  foersvarsraster_nn_1_1_N = mkN "försvarsraster" neutrum  ;
  foersvarskrig_nn_1_1_N = mkN "försvarskrig" neutrum  ;
  foersvarsdepartement_nn_1_1_N = mkN "försvarsdepartement" neutrum  ;
  foerstoerelseverk_nn_1_1_N = mkN "förstörelseverk" neutrum  ;
  foerstaandshandikapp_nn_1_1_N = mkN "förståndshandikapp" neutrum  ;
  foerstaerkningsord_nn_1_1_N = mkN "förstärkningsord" neutrum  ;
  foerstoppningsbesvaer_nn_1_1_N = mkN "förstoppningsbesvär" neutrum  ;
  foersteg_nn_1_1_N = mkN "försteg" neutrum  ;
  foerstaslag_nn_1_1_N = mkN "förstaslag" neutrum  ;
  foerstanamn_nn_1_1_N = mkN "förstanamn" neutrum  ;
  foerstamajtaag_nn_1_1_N = mkN "förstamajtåg" neutrum  ;
  foerstamajtal_nn_1_1_N = mkN "förstamajtal" neutrum  ;
  foerstaklasshotell_nn_1_1_N = mkN "förstaklasshotell" neutrum  ;
  foerstag_nn_1_1_N = mkN "förstag" neutrum  ;
  foerstadagsbrev_nn_1_1_N = mkN "förstadagsbrev" neutrum  ;
  foersoningsknull_nn_1_1_N = mkN "försoningsknull" neutrum  ;
  foerslag_2_nn_1_1_N = mkN "förslag" neutrum  ;
  foerslag_nn_1_1_N = mkN "förslag" neutrum  ;
  foerskott_nn_1_1_N = mkN "förskott" neutrum  ;
  foerskinn_nn_1_1_N = mkN "förskinn" neutrum  ;
  foerskepp_nn_1_1_N = mkN "förskepp" neutrum  ;
  foersiktighetsmaatt_nn_1_1_N = mkN "försiktighetsmått" neutrum  ;
  foersamlingsraad_nn_1_1_N = mkN "församlingsråd" neutrum  ;
  foerraad_nn_1_1_N = mkN "förråd" neutrum  ;
  foerord_nn_1_1_N = mkN "förord" neutrum  ;
  foernuftsskael_nn_1_1_N = mkN "förnuftsskäl" neutrum  ;
  foernedringstillstaand_nn_1_1_N = mkN "förnedringstillstånd" neutrum  ;
  foernamn_nn_1_1_N = mkN "förnamn" neutrum  ;
  foermoegenhetsbrott_nn_1_1_N = mkN "förmögenhetsbrott" neutrum  ;
  foermyndarskap_nn_1_1_N = mkN "förmyndarskap" neutrum  ;
  foermaningstal_nn_1_1_N = mkN "förmaningstal" neutrum  ;
  foermak_nn_1_1_N = mkN "förmak" neutrum  ;
  foerlaengningsskaft_nn_1_1_N = mkN "förlängningsskaft" neutrum  ;
  foerlaengningsroer_nn_1_1_N = mkN "förlängningsrör" neutrum  ;
  foerlustaar_nn_1_1_N = mkN "förlustår" neutrum  ;
  foerlorargaeng_nn_1_1_N = mkN "förlorargäng" neutrum  ;
  foerlopp_nn_1_1_N = mkN "förlopp" neutrum  ;
  foerlagslaan_nn_1_1_N = mkN "förlagslån" neutrum  ;
  foerlag_2_nn_1_1_N = mkN "förlag" neutrum  ;
  foerlag_nn_1_1_N = mkN "förlag" neutrum  ;
  foerkoep_nn_1_1_N = mkN "förköp" neutrum  ;
  foerhoersprotokoll_nn_1_1_N = mkN "förhörsprotokoll" neutrum  ;
  foerhoer_nn_1_1_N = mkN "förhör" neutrum  ;
  foerhaallningssaett_nn_1_1_N = mkN "förhållningssätt" neutrum  ;
  foerhaall_nn_1_1_N = mkN "förhåll" neutrum  ;
  foerhinder_nn_1_1_N = mkN "förhinder" neutrum  ;
  foerhandlingstrick_nn_1_1_N = mkN "förhandlingstrick" neutrum  ;
  foerhandlingsbord_nn_1_1_N = mkN "förhandlingsbord" neutrum  ;
  foerhalningsfoersoek_nn_1_1_N = mkN "förhalningsförsök" neutrum  ;
  foerfattarportraett_nn_1_1_N = mkN "författarporträtt" neutrum  ;
  foerfattarjag_nn_1_1_N = mkN "författarjag" neutrum  ;
  foerfaringssaett_nn_1_1_N = mkN "förfaringssätt" neutrum  ;
  foerfalskningsbrott_nn_1_1_N = mkN "förfalskningsbrott" neutrum  ;
  foeretal_nn_1_1_N = mkN "företal" neutrum  ;
  foeretag_nn_1_1_N = mkN "företag" neutrum  ;
  foerestaellningssaett_nn_1_1_N = mkN "föreställningssätt" neutrum  ;
  foereningsband_nn_1_1_N = mkN "föreningsband" neutrum  ;
  foeremaal_nn_1_1_N = mkN "föremål" neutrum  ;
  foeredrag_nn_1_1_N = mkN "föredrag" neutrum  ;
  foerebud_nn_1_1_N = mkN "förebud" neutrum  ;
  foerdaeck_nn_1_1_N = mkN "fördäck" neutrum  ;
  foerdragsbrott_nn_1_1_N = mkN "fördragsbrott" neutrum  ;
  foerdrag_nn_1_1_N = mkN "fördrag" neutrum  ;
  foerbaettringslaan_nn_1_1_N = mkN "förbättringslån" neutrum  ;
  foerbundsbrev_nn_1_1_N = mkN "förbundsbrev" neutrum  ;
  foerbund_nn_1_1_N = mkN "förbund" neutrum  ;
  foerbudslag_nn_1_1_N = mkN "förbudslag" neutrum  ;
  foerbud_nn_1_1_N = mkN "förbud" neutrum  ;
  foerbrukningsmaterial_nn_1_1_N = mkN "förbrukningsmaterial" neutrum  ;
  foerbindelsemedel_nn_1_1_N = mkN "förbindelsemedel" neutrum  ;
  foerberg_nn_1_1_N = mkN "förberg" neutrum  ;
  foerbehaall_nn_1_1_N = mkN "förbehåll" neutrum  ;
  foerband_2_nn_1_1_N = mkN "förband" neutrum  ;
  foerband_nn_1_1_N = mkN "förband" neutrum  ;
  foensterkuvert_nn_1_1_N = mkN "fönsterkuvert" neutrum  ;
  foensterkitt_nn_1_1_N = mkN "fönsterkitt" neutrum  ;
  foenstergaller_nn_1_1_N = mkN "fönstergaller" neutrum  ;
  foensterbord_nn_1_1_N = mkN "fönsterbord" neutrum  ;
  foensterbleck_nn_1_1_N = mkN "fönsterbleck" neutrum  ;
  foensterbeslag_nn_1_1_N = mkN "fönsterbeslag" neutrum  ;
  foenster_nn_1_1_N = mkN "fönster" neutrum  ;
  foeljebrev_nn_1_1_N = mkN "följebrev" neutrum  ;
  foel_nn_1_1_N = mkN "föl" neutrum  ;
  foedslotal_nn_1_1_N = mkN "födslotal" neutrum  ;
  foedseltal_nn_1_1_N = mkN "födseltal" neutrum  ;
  foedoraad_nn_1_1_N = mkN "födoråd" neutrum  ;
  foedelseaar_nn_1_1_N = mkN "födelseår" neutrum  ;
  foedelsetal_nn_1_1_N = mkN "födelsetal" neutrum  ;
  foedelsenummer_nn_1_1_N = mkN "födelsenummer" neutrum  ;
  foedelsedagsbarn_nn_1_1_N = mkN "födelsedagsbarn" neutrum  ;
  faatal_nn_1_1_N = mkN "fåtal" neutrum  ;
  faarskinn_nn_1_1_N = mkN "fårskinn" neutrum  ;
  faar_nn_1_1_N = mkN "får" neutrum  ;
  faanskratt_nn_1_1_N = mkN "fånskratt" neutrum  ;
  faanguppror_nn_1_1_N = mkN "fånguppror" neutrum  ;
  faangstredskap_nn_1_1_N = mkN "fångstredskap" neutrum  ;
  faangstfolk_nn_1_1_N = mkN "fångstfolk" neutrum  ;
  faangstfartyg_nn_1_1_N = mkN "fångstfartyg" neutrum  ;
  faanglaeger_nn_1_1_N = mkN "fångläger" neutrum  ;
  faang_nn_1_1_N = mkN "fång" neutrum  ;
  faan_nn_1_1_N = mkN "fån" neutrum  ;
  faamansfoeretag_nn_1_1_N = mkN "fåmansföretag" neutrum  ;
  faagelaegg_nn_1_1_N = mkN "fågelägg" neutrum  ;
  faagelstraeck_nn_1_1_N = mkN "fågelsträck" neutrum  ;
  faageldun_nn_1_1_N = mkN "fågeldun" neutrum  ;
  faagelbaer_nn_1_1_N = mkN "fågelbär" neutrum  ;
  faagelbord_nn_1_1_N = mkN "fågelbord" neutrum  ;
  faagelbad_nn_1_1_N = mkN "fågelbad" neutrum  ;
  faestjaern_nn_1_1_N = mkN "fästjärn" neutrum  ;
  faestefolk_nn_1_1_N = mkN "fästefolk" neutrum  ;
  faergtryck_nn_1_1_N = mkN "färgtryck" neutrum  ;
  faergpigment_nn_1_1_N = mkN "färgpigment" neutrum  ;
  faergmoenster_nn_1_1_N = mkN "färgmönster" neutrum  ;
  faergfilter_nn_1_1_N = mkN "färgfilter" neutrum  ;
  faergband_nn_1_1_N = mkN "färgband" neutrum  ;
  faergbad_nn_1_1_N = mkN "färgbad" neutrum  ;
  faerdmedel_nn_1_1_N = mkN "färdmedel" neutrum  ;
  faenghaal_nn_1_1_N = mkN "fänghål" neutrum  ;
  faengelsestraff_nn_1_1_N = mkN "fängelsestraff" neutrum  ;
  faengelsegaller_nn_1_1_N = mkN "fängelsegaller" neutrum  ;
  faelttaag_nn_1_1_N = mkN "fälttåg" neutrum  ;
  faeltslag_nn_1_1_N = mkN "fältslag" neutrum  ;
  faeltrop_nn_1_1_N = mkN "fältrop" neutrum  ;
  faeltpostkort_nn_1_1_N = mkN "fältpostkort" neutrum  ;
  faeltkoek_nn_1_1_N = mkN "fältkök" neutrum  ;
  faeltfoersoek_nn_1_1_N = mkN "fältförsök" neutrum  ;
  faelt_nn_1_1_N = mkN "fält" neutrum  ;
  faellbord_nn_1_1_N = mkN "fällbord" neutrum  ;
  faedernearv_nn_1_1_N = mkN "fädernearv" neutrum  ;
  fyrtorn_nn_1_N = mkN "fyrtorn" neutrum  ;
  fyrtal_nn_1_N = mkN "fyrtal" neutrum  ;
  fyrspann_nn_1_N = mkN "fyrspann" neutrum  ;
  fyrskepp_nn_1_N = mkN "fyrskepp" neutrum  ;
  fyrradskorn_nn_1_N = mkN "fyrradskorn" neutrum  ;
  fyrop_nn_1_N = mkN "fyrop" neutrum  ;
  fyrfaergstryck_nn_1_1_N = mkN "fyrfärgstryck" neutrum  ;
  fyrfotadjur_nn_1_N = mkN "fyrfotadjur" neutrum  ;
  fyrfat_nn_1_N = mkN "fyrfat" neutrum  ;
  fynd_nn_1_N = mkN "fynd" neutrum  ;
  fyllnadsval_nn_1_N = mkN "fyllnadsval" neutrum  ;
  fylleslag_nn_1_N = mkN "fylleslag" neutrum  ;
  fyllebraak_nn_1_1_N = mkN "fyllebråk" neutrum  ;
  fuskverk_nn_1_N = mkN "fuskverk" neutrum  ;
  furugolv_nn_1_N = mkN "furugolv" neutrum  ;
  funktionssaett_nn_1_1_N = mkN "funktionssätt" neutrum  ;
  funktionshinder_nn_1_N = mkN "funktionshinder" neutrum  ;
  fundament_nn_1_N = mkN "fundament" neutrum  ;
  fullkornsbroed_nn_1_1_N = mkN "fullkornsbröd" neutrum  ;
  fullblod_nn_1_N = mkN "fullblod" neutrum  ;
  fuffens_nn_1_N = mkN "fuffens" neutrum  ;
  froeskal_nn_1_1_N = mkN "fröskal" neutrum  ;
  fraageord_nn_1_1_N = mkN "frågeord" neutrum  ;
  fraageformulaer_nn_1_1_N = mkN "frågeformulär" neutrum  ;
  fraesstaal_nn_1_1_N = mkN "frässtål" neutrum  ;
  fraelsehemman_nn_1_1_N = mkN "frälsehemman" neutrum  ;
  frysfoersoek_nn_1_1_N = mkN "frysförsök" neutrum  ;
  frysfack_nn_1_N = mkN "frysfack" neutrum  ;
  fruntimmer_nn_1_N = mkN "fruntimmer" neutrum  ;
  frukostaegg_nn_1_1_N = mkN "frukostägg" neutrum  ;
  frukostbord_nn_1_N = mkN "frukostbord" neutrum  ;
  frontavsnitt_nn_1_N = mkN "frontavsnitt" neutrum  ;
  frontalangrepp_nn_1_N = mkN "frontalangrepp" neutrum  ;
  friaar_nn_1_1_N = mkN "friår" neutrum  ;
  fritagningsfoersoek_nn_1_1_N = mkN "fritagningsförsök" neutrum  ;
  frislag_nn_1_N = mkN "frislag" neutrum  ;
  friskluftsintag_nn_1_N = mkN "friskluftsintag" neutrum  ;
  friskintyg_nn_1_N = mkN "friskintyg" neutrum  ;
  friluftsaendamaal_nn_1_1_N = mkN "friluftsändamål" neutrum  ;
  friluftsbad_nn_1_N = mkN "friluftsbad" neutrum  ;
  frilansvillkor_nn_1_N = mkN "frilansvillkor" neutrum  ;
  friland_nn_1_N = mkN "friland" neutrum  ;
  frikoep_nn_1_1_N = mkN "friköp" neutrum  ;
  friktionstal_nn_1_N = mkN "friktionstal" neutrum  ;
  frikort_nn_1_N = mkN "frikort" neutrum  ;
  friidrottslandslag_nn_1_N = mkN "friidrottslandslag" neutrum  ;
  frihjul_nn_1_N = mkN "frihjul" neutrum  ;
  frihetsstraff_nn_1_N = mkN "frihetsstraff" neutrum  ;
  frihetskrig_nn_1_N = mkN "frihetskrig" neutrum  ;
  frihetsbrev_nn_1_N = mkN "frihetsbrev" neutrum  ;
  frigivningsvillkor_nn_1_N = mkN "frigivningsvillkor" neutrum  ;
  friexemplar_nn_1_N = mkN "friexemplar" neutrum  ;
  fribrev_nn_1_N = mkN "fribrev" neutrum  ;
  fribord_nn_1_N = mkN "fribord" neutrum  ;
  friarbrev_nn_1_N = mkN "friarbrev" neutrum  ;
  frekvensband_nn_1_N = mkN "frekvensband" neutrum  ;
  fredsvillkor_nn_1_N = mkN "fredsvillkor" neutrum  ;
  fredsuppdrag_nn_1_N = mkN "fredsuppdrag" neutrum  ;
  fredsslut_nn_1_N = mkN "fredsslut" neutrum  ;
  fredssamtal_nn_1_N = mkN "fredssamtal" neutrum  ;
  fredsprisval_nn_1_N = mkN "fredsprisval" neutrum  ;
  fredsfoerslag_nn_1_1_N = mkN "fredsförslag" neutrum  ;
  fredsfoerdrag_nn_1_1_N = mkN "fredsfördrag" neutrum  ;
  fredsbrott_nn_1_N = mkN "fredsbrott" neutrum  ;
  fredsavtal_nn_1_N = mkN "fredsavtal" neutrum  ;
  frasnaet_nn_1_1_N = mkN "frasnät" neutrum  ;
  franskbroed_nn_1_1_N = mkN "franskbröd" neutrum  ;
  franciskanerkloster_nn_1_N = mkN "franciskanerkloster" neutrum  ;
  framtidsmaal_nn_1_1_N = mkN "framtidsmål" neutrum  ;
  framstaellningssaett_nn_1_1_N = mkN "framställningssätt" neutrum  ;
  framsteg_nn_1_N = mkN "framsteg" neutrum  ;
  framhjul_nn_1_N = mkN "framhjul" neutrum  ;
  framgaangsrecept_nn_1_1_N = mkN "framgångsrecept" neutrum  ;
  framgaangskoncept_nn_1_1_N = mkN "framgångskoncept" neutrum  ;
  framfall_nn_1_N = mkN "framfall" neutrum  ;
  framben_nn_1_N = mkN "framben" neutrum  ;
  fraktbolag_nn_1_N = mkN "fraktbolag" neutrum  ;
  fraktavtal_nn_1_N = mkN "fraktavtal" neutrum  ;
  fragment_nn_1_N = mkN "fragment" neutrum  ;
  fotvalv_nn_1_N = mkN "fotvalv" neutrum  ;
  fotstoed_nn_1_1_N = mkN "fotstöd" neutrum  ;
  fotsteg_nn_1_N = mkN "fotsteg" neutrum  ;
  fotspaar_nn_1_1_N = mkN "fotspår" neutrum  ;
  fotogenkoek_nn_1_1_N = mkN "fotogenkök" neutrum  ;
  fotbollsstadion_nn_1_N = mkN "fotbollsstadion" neutrum  ;
  fotbollsmaal_nn_1_1_N = mkN "fotbollsmål" neutrum  ;
  fotbollslag_nn_1_N = mkN "fotbollslag" neutrum  ;
  fotbollskrig_nn_1_N = mkN "fotbollskrig" neutrum  ;
  fotbollsfoerbund_nn_1_1_N = mkN "fotbollsförbund" neutrum  ;
  fotbollsbraak_nn_1_1_N = mkN "fotbollsbråk" neutrum  ;
  fotbollfoerbund_nn_1_1_N = mkN "fotbollförbund" neutrum  ;
  fotblad_nn_1_N = mkN "fotblad" neutrum  ;
  fotbad_nn_1_N = mkN "fotbad" neutrum  ;
  fotavtryck_nn_1_N = mkN "fotavtryck" neutrum  ;
  fosterljud_nn_1_N = mkN "fosterljud" neutrum  ;
  fosterbarn_nn_1_N = mkN "fosterbarn" neutrum  ;
  foster_nn_1_N = mkN "foster" neutrum  ;
  fostbroedralag_nn_1_1_N = mkN "fostbrödralag" neutrum  ;
  fossilgasnaet_nn_1_1_N = mkN "fossilgasnät" neutrum  ;
  fossilfynd_nn_1_N = mkN "fossilfynd" neutrum  ;
  fortskaffningsmedel_nn_1_N = mkN "fortskaffningsmedel" neutrum  ;
  fortplantningsorgan_nn_1_N = mkN "fortplantningsorgan" neutrum  ;
  fort_nn_1_N = mkN "fort" neutrum  ;
  forskningsroen_nn_1_1_N = mkN "forskningsrön" neutrum  ;
  forskningsraad_nn_1_1_N = mkN "forskningsråd" neutrum  ;
  forskningsresultat_nn_1_N = mkN "forskningsresultat" neutrum  ;
  forskningsprojekt_nn_1_N = mkN "forskningsprojekt" neutrum  ;
  forskningsinstitut_nn_1_N = mkN "forskningsinstitut" neutrum  ;
  forskningsfaelt_nn_1_1_N = mkN "forskningsfält" neutrum  ;
  forskningsframsteg_nn_1_N = mkN "forskningsframsteg" neutrum  ;
  forskningsfartyg_nn_1_N = mkN "forskningsfartyg" neutrum  ;
  forskarlag_nn_1_N = mkN "forskarlag" neutrum  ;
  fornminnesbrott_nn_1_N = mkN "fornminnesbrott" neutrum  ;
  fornfynd_nn_1_N = mkN "fornfynd" neutrum  ;
  fornfolk_nn_1_N = mkN "fornfolk" neutrum  ;
  formulaer_nn_1_1_N = mkN "formulär" neutrum  ;
  formspraak_nn_1_1_N = mkN "formspråk" neutrum  ;
  formord_nn_1_N = mkN "formord" neutrum  ;
  formbroed_nn_1_1_N = mkN "formbröd" neutrum  ;
  format_nn_1_N = mkN "format" neutrum  ;
  fordon_nn_1_N = mkN "fordon" neutrum  ;
  fonotek_nn_1_N = mkN "fonotek" neutrum  ;
  fondpapper_nn_1_N = mkN "fondpapper" neutrum  ;
  fondbolag_nn_1_N = mkN "fondbolag" neutrum  ;
  folkuniversitet_nn_1_N = mkN "folkuniversitet" neutrum  ;
  folkting_nn_1_N = mkN "folkting" neutrum  ;
  folkspraak_nn_1_1_N = mkN "folkspråk" neutrum  ;
  folkslag_nn_1_N = mkN "folkslag" neutrum  ;
  folkmaal_nn_1_1_N = mkN "folkmål" neutrum  ;
  folkmord_nn_1_N = mkN "folkmord" neutrum  ;
  folklager_nn_1_N = mkN "folklager" neutrum  ;
  folkkoek_nn_1_1_N = mkN "folkkök" neutrum  ;
  folketing_nn_1_N = mkN "folketing" neutrum  ;
  folkdjup_nn_1_N = mkN "folkdjup" neutrum  ;
  folkbibliotek_nn_1_N = mkN "folkbibliotek" neutrum  ;
  folk_nn_1_N = mkN "folk" neutrum  ;
  folioformat_nn_1_N = mkN "folioformat" neutrum  ;
  fokalplan_nn_1_N = mkN "fokalplan" neutrum  ;
  fogeord_nn_1_N = mkN "fogeord" neutrum  ;
  fodral_nn_1_N = mkN "fodral" neutrum  ;
  foderblad_nn_1_N = mkN "foderblad" neutrum  ;
  foder_nn_1_N = mkN "foder" neutrum  ;
  flaetverk_nn_1_1_N = mkN "flätverk" neutrum  ;
  flaederbaer_nn_1_1_N = mkN "fläderbär" neutrum  ;
  flaeckborttagningsmedel_nn_1_1_N = mkN "fläckborttagningsmedel" neutrum  ;
  flyttblock_nn_1_N = mkN "flyttblock" neutrum  ;
  flytetyg_nn_1_N = mkN "flytetyg" neutrum  ;
  flyktinglaeger_nn_1_1_N = mkN "flyktingläger" neutrum  ;
  flyktingbarn_nn_1_N = mkN "flyktingbarn" neutrum  ;
  flyktfoersoek_nn_1_1_N = mkN "flyktförsök" neutrum  ;
  flygstopp_nn_1_N = mkN "flygstopp" neutrum  ;
  flygsandsfaelt_nn_1_1_N = mkN "flygsandsfält" neutrum  ;
  flygplansroder_nn_1_N = mkN "flygplansroder" neutrum  ;
  flygplan_nn_1_N = mkN "flygplan" neutrum  ;
  flyglarm_nn_1_N = mkN "flyglarm" neutrum  ;
  flygfoerbud_nn_1_1_N = mkN "flygförbud" neutrum  ;
  flygfoerband_nn_1_1_N = mkN "flygförband" neutrum  ;
  flygfaelt_nn_1_1_N = mkN "flygfält" neutrum  ;
  flygcertifikat_nn_1_N = mkN "flygcertifikat" neutrum  ;
  flygbolag_nn_1_N = mkN "flygbolag" neutrum  ;
  flygblad_nn_1_N = mkN "flygblad" neutrum  ;
  flyganfall_nn_1_N = mkN "flyganfall" neutrum  ;
  flyg_nn_1_N = mkN "flyg" neutrum  ;
  fluster_nn_1_N = mkN "fluster" neutrum  ;
  flussmedel_nn_1_N = mkN "flussmedel" neutrum  ;
  flugpapper_nn_1_N = mkN "flugpapper" neutrum  ;
  flugblomster_nn_1_N = mkN "flugblomster" neutrum  ;
  flottningstimmer_nn_1_N = mkN "flottningstimmer" neutrum  ;
  flottbesoek_nn_1_1_N = mkN "flottbesök" neutrum  ;
  flor_nn_1_N = mkN "flor" neutrum  ;
  flodsvin_nn_1_N = mkN "flodsvin" neutrum  ;
  flockdjur_nn_1_N = mkN "flockdjur" neutrum  ;
  flintlaasgevaer_nn_1_1_N = mkN "flintlåsgevär" neutrum  ;
  flin_nn_1_N = mkN "flin" neutrum  ;
  flimmerhaar_nn_1_1_N = mkN "flimmerhår" neutrum  ;
  flicknamn_nn_1_N = mkN "flicknamn" neutrum  ;
  flickebarn_nn_1_N = mkN "flickebarn" neutrum  ;
  flerhandikapp_nn_1_N = mkN "flerhandikapp" neutrum  ;
  flerfaergstryck_nn_1_1_N = mkN "flerfärgstryck" neutrum  ;
  fleece_foder_nn_1_N = mkN "fleece-foder" neutrum  ;
  flatskratt_nn_1_N = mkN "flatskratt" neutrum  ;
  flatgarv_nn_1_N = mkN "flatgarv" neutrum  ;
  flatbroed_nn_1_1_N = mkN "flatbröd" neutrum  ;
  flaskhaal_nn_1_1_N = mkN "flaskhål" neutrum  ;
  flaskbarn_nn_1_N = mkN "flaskbarn" neutrum  ;
  flarn_nn_1_N = mkN "flarn" neutrum  ;
  flankanfall_nn_1_N = mkN "flankanfall" neutrum  ;
  flamskyddsmedel_nn_1_N = mkN "flamskyddsmedel" neutrum  ;
  flak_nn_1_N = mkN "flak" neutrum  ;
  flaggskepp_nn_1_N = mkN "flaggskepp" neutrum  ;
  flabb_nn_2_N = mkN "flabb" neutrum  ;
  fjaet_nn_1_1_N = mkN "fjät" neutrum  ;
  fjaerrtaag_nn_1_1_N = mkN "fjärrtåg" neutrum  ;
  fjaelster_nn_1_1_N = mkN "fjälster" neutrum  ;
  fjaellpansar_nn_1_1_N = mkN "fjällpansar" neutrum  ;
  fjaellandskap_nn_1_1_N = mkN "fjällandskap" neutrum  ;
  fjaell_nn_1_1_N = mkN "fjäll" neutrum  ;
  fjaedermoln_nn_1_1_N = mkN "fjädermoln" neutrum  ;
  fjaederluftgevaer_nn_1_1_N = mkN "fjäderluftgevär" neutrum  ;
  fjun_nn_1_N = mkN "fjun" neutrum  ;
  fjolaar_nn_1_1_N = mkN "fjolår" neutrum  ;
  fixerbad_nn_1_N = mkN "fixerbad" neutrum  ;
  fiskredskap_nn_1_N = mkN "fiskredskap" neutrum  ;
  fisknaet_nn_1_1_N = mkN "fisknät" neutrum  ;
  fiskhalster_nn_1_N = mkN "fiskhalster" neutrum  ;
  fiskeredskap_nn_1_N = mkN "fiskeredskap" neutrum  ;
  fiskenaet_nn_1_1_N = mkN "fiskenät" neutrum  ;
  fiskekort_nn_1_N = mkN "fiskekort" neutrum  ;
  fiskefartyg_nn_1_N = mkN "fiskefartyg" neutrum  ;
  fiskedrag_nn_1_N = mkN "fiskedrag" neutrum  ;
  fiskedon_nn_1_N = mkN "fiskedon" neutrum  ;
  fiskbensmoenster_nn_1_1_N = mkN "fiskbensmönster" neutrum  ;
  fiskben_nn_1_N = mkN "fiskben" neutrum  ;
  firmanamn_nn_1_N = mkN "firmanamn" neutrum  ;
  fiolblock_nn_1_N = mkN "fiolblock" neutrum  ;
  finskaap_nn_1_1_N = mkN "finskåp" neutrum  ;
  finlir_nn_1_N = mkN "finlir" neutrum  ;
  fingerprov_nn_1_N = mkN "fingerprov" neutrum  ;
  fingeravtryck_nn_1_N = mkN "fingeravtryck" neutrum  ;
  finbruk_nn_1_N = mkN "finbruk" neutrum  ;
  finansutskott_nn_1_N = mkN "finansutskott" neutrum  ;
  finansdepartement_nn_1_N = mkN "finansdepartement" neutrum  ;
  filtrerpapper_nn_1_N = mkN "filtrerpapper" neutrum  ;
  filtrat_nn_1_N = mkN "filtrat" neutrum  ;
  filter_nn_1_N = mkN "filter" neutrum  ;
  filspaan_nn_1_1_N = mkN "filspån" neutrum  ;
  filmotek_nn_1_N = mkN "filmotek" neutrum  ;
  filmmanuskript_nn_1_N = mkN "filmmanuskript" neutrum  ;
  filmklipp_nn_1_N = mkN "filmklipp" neutrum  ;
  filmavsnitt_nn_1_N = mkN "filmavsnitt" neutrum  ;
  filialkontor_nn_1_N = mkN "filialkontor" neutrum  ;
  filhandtag_nn_1_N = mkN "filhandtag" neutrum  ;
  fikonspraak_nn_1_1_N = mkN "fikonspråk" neutrum  ;
  fikonloev_nn_1_1_N = mkN "fikonlöv" neutrum  ;
  fikon_nn_1_N = mkN "fikon" neutrum  ;
  fik_nn_1_N = mkN "fik" neutrum  ;
  fickur_nn_1_N = mkN "fickur" neutrum  ;
  ficklock_nn_1_N = mkN "ficklock" neutrum  ;
  fickformat_nn_1_N = mkN "fickformat" neutrum  ;
  fettsvansfaar_nn_1_1_N = mkN "fettsvansfår" neutrum  ;
  fetblad_nn_1_N = mkN "fetblad" neutrum  ;
  festtaag_nn_1_1_N = mkN "festtåg" neutrum  ;
  festtal_nn_1_N = mkN "festtal" neutrum  ;
  festbord_nn_1_N = mkN "festbord" neutrum  ;
  ferment_nn_1_N = mkN "ferment" neutrum  ;
  fenomen_nn_1_N = mkN "fenomen" neutrum  ;
  femtonaarsstraff_nn_1_1_N = mkN "femtonårsstraff" neutrum  ;
  femtonhundrameterslopp_nn_1_N = mkN "femtonhundrameterslopp" neutrum  ;
  femtital_nn_1_N = mkN "femtital" neutrum  ;
  femtiotal_nn_1_N = mkN "femtiotal" neutrum  ;
  femtal_nn_1_N = mkN "femtal" neutrum  ;
  femkronorsmynt_nn_1_N = mkN "femkronorsmynt" neutrum  ;
  femfilmskontrakt_nn_1_N = mkN "femfilmskontrakt" neutrum  ;
  felval_nn_1_N = mkN "felval" neutrum  ;
  feltaenk_nn_1_1_N = mkN "feltänk" neutrum  ;
  felsteg_nn_1_N = mkN "felsteg" neutrum  ;
  felslut_nn_1_N = mkN "felslut" neutrum  ;
  felgrepp_nn_1_N = mkN "felgrepp" neutrum  ;
  feldrag_nn_1_N = mkN "feldrag" neutrum  ;
  fel_nn_1_N = mkN "fel" neutrum  ;
  feberanfall_nn_1_N = mkN "feberanfall" neutrum  ;
  favoritknep_nn_1_N = mkN "favoritknep" neutrum  ;
  favorithak_nn_1_N = mkN "favorithak" neutrum  ;
  favoritfik_nn_1_N = mkN "favoritfik" neutrum  ;
  fattighjon_nn_1_N = mkN "fattighjon" neutrum  ;
  fattigdomsstreck_nn_1_N = mkN "fattigdomsstreck" neutrum  ;
  fattigbarn_nn_1_N = mkN "fattigbarn" neutrum  ;
  fat_nn_1_N = mkN "fat" neutrum  ;
  fastighetslaan_nn_1_1_N = mkN "fastighetslån" neutrum  ;
  fastighetskoep_nn_1_1_N = mkN "fastighetsköp" neutrum  ;
  fastighetskontor_nn_1_N = mkN "fastighetskontor" neutrum  ;
  fastebrev_nn_1_N = mkN "fastebrev" neutrum  ;
  farvael_nn_1_1_N = mkN "farväl" neutrum  ;
  fartygsvrak_nn_1_N = mkN "fartygsvrak" neutrum  ;
  fartygsskrov_nn_1_N = mkN "fartygsskrov" neutrum  ;
  fartygsdaeck_nn_1_1_N = mkN "fartygsdäck" neutrum  ;
  fartyg_nn_1_N = mkN "fartyg" neutrum  ;
  farthinder_nn_1_N = mkN "farthinder" neutrum  ;
  farsarv_nn_1_N = mkN "farsarv" neutrum  ;
  fantasiliv_nn_1_N = mkN "fantasiliv" neutrum  ;
  fantasifoster_nn_1_N = mkN "fantasifoster" neutrum  ;
  fantasidjur_nn_1_N = mkN "fantasidjur" neutrum  ;
  fanstyg_nn_1_N = mkN "fanstyg" neutrum  ;
  fanskap_nn_1_N = mkN "fanskap" neutrum  ;
  fan_nn_3_N = mkN "fan" neutrum  ;
  famntag_nn_1_N = mkN "famntag" neutrum  ;
  familjenamn_nn_1_N = mkN "familjenamn" neutrum  ;
  familjejordbruk_nn_1_N = mkN "familjejordbruk" neutrum  ;
  familjeideal_nn_1_N = mkN "familjeideal" neutrum  ;
  familjehotell_nn_1_N = mkN "familjehotell" neutrum  ;
  familjefoeretag_nn_1_1_N = mkN "familjeföretag" neutrum  ;
  familjebolag_nn_1_N = mkN "familjebolag" neutrum  ;
  familjebidrag_nn_1_N = mkN "familjebidrag" neutrum  ;
  familjeband_nn_1_N = mkN "familjeband" neutrum  ;
  falsifikat_nn_1_N = mkN "falsifikat" neutrum  ;
  fallverk_nn_1_N = mkN "fallverk" neutrum  ;
  fallskaermstrick_nn_1_1_N = mkN "fallskärmstrick" neutrum  ;
  fallrep_nn_1_N = mkN "fallrep" neutrum  ;
  fallissemang_nn_1_N = mkN "fallissemang" neutrum  ;
  fall_nn_1_N = mkN "fall" neutrum  ;
  faktotum_nn_1_N = mkN "faktotum" neutrum  ;
  faksimil_nn_1_N = mkN "faksimil" neutrum  ;
  fadervaar_nn_1_1_N = mkN "fadervår" neutrum  ;
  fadersnamn_nn_1_N = mkN "fadersnamn" neutrum  ;
  fadersarv_nn_1_N = mkN "fadersarv" neutrum  ;
  fadermord_nn_1_N = mkN "fadermord" neutrum  ;
  fadderbarn_nn_1_N = mkN "fadderbarn" neutrum  ;
  fackverk_nn_1_N = mkN "fackverk" neutrum  ;
  fackspraak_nn_1_1_N = mkN "fackspråk" neutrum  ;
  fackorgan_nn_1_N = mkN "fackorgan" neutrum  ;
  fackfoerbund_nn_1_1_N = mkN "fackförbund" neutrum  ;
  fackeltaag_nn_1_1_N = mkN "fackeltåg" neutrum  ;
  fackelblomster_nn_1_N = mkN "fackelblomster" neutrum  ;
  fack_nn_1_N = mkN "fack" neutrum  ;
  fabrikat_nn_1_N = mkN "fabrikat" neutrum  ;
  fabeldjur_nn_1_N = mkN "fabeldjur" neutrum  ;
  f_nn_1_N = mkN "f" neutrum  ;
  extremvaeder_nn_1_1_N = mkN "extremväder" neutrum  ;
  extremfall_nn_1_N = mkN "extremfall" neutrum  ;
  extrataag_nn_1_1_N = mkN "extratåg" neutrum  ;
  extranummer_nn_1_N = mkN "extranummer" neutrum  ;
  extraknaeck_nn_1_1_N = mkN "extraknäck" neutrum  ;
  externat_nn_1_N = mkN "externat" neutrum  ;
  exsudat_nn_1_N = mkN "exsudat" neutrum  ;
  exsickat_nn_1_N = mkN "exsickat" neutrum  ;
  expresstaag_nn_1_1_N = mkN "expresståg" neutrum  ;
  expressbud_nn_1_N = mkN "expressbud" neutrum  ;
  expressbrev_nn_1_N = mkN "expressbrev" neutrum  ;
  exportbolag_nn_1_N = mkN "exportbolag" neutrum  ;
  explosionsoegonblick_nn_1_1_N = mkN "explosionsögonblick" neutrum  ;
  explosionssaett_nn_1_1_N = mkN "explosionssätt" neutrum  ;
  explosionsfoerlopp_nn_1_1_N = mkN "explosionsförlopp" neutrum  ;
  expertspraak_nn_1_1_N = mkN "expertspråk" neutrum  ;
  experimentfaelt_nn_1_1_N = mkN "experimentfält" neutrum  ;
  experiment_nn_1_N = mkN "experiment" neutrum  ;
  expansionskaerl_nn_1_1_N = mkN "expansionskärl" neutrum  ;
  exkret_nn_1_N = mkN "exkret" neutrum  ;
  existensvillkor_nn_1_N = mkN "existensvillkor" neutrum  ;
  existensmedel_nn_1_N = mkN "existensmedel" neutrum  ;
  exemplar_nn_1_N = mkN "exemplar" neutrum  ;
  evighetsfilter_nn_1_N = mkN "evighetsfilter" neutrum  ;
  evenemang_nn_1_N = mkN "evenemang" neutrum  ;
  europamaesterskap_nn_1_1_N = mkN "europamästerskap" neutrum  ;
  etsmedel_nn_1_N = mkN "etsmedel" neutrum  ;
  etikettraad_nn_1_1_N = mkN "etikettråd" neutrum  ;
  etermediemonopol_nn_1_N = mkN "etermediemonopol" neutrum  ;
  etablissement_nn_1_N = mkN "etablissement" neutrum  ;
  etablissemang_nn_1_N = mkN "etablissemang" neutrum  ;
  estradsamtal_nn_1_N = mkN "estradsamtal" neutrum  ;
  eroevringstaag_nn_1_1_N = mkN "erövringståg" neutrum  ;
  ersaettningsbelopp_nn_1_1_N = mkN "ersättningsbelopp" neutrum  ;
  ersaettningsanspraak_nn_1_1_N = mkN "ersättningsanspråk" neutrum  ;
  ergativsubjekt_nn_1_N = mkN "ergativsubjekt" neutrum  ;
  epostbrev_nn_1_N = mkN "epostbrev" neutrum  ;
  epitet_nn_1_N = mkN "epitet" neutrum  ;
  episkopat_nn_1_N = mkN "episkopat" neutrum  ;
  episkop_nn_1_N = mkN "episkop" neutrum  ;
  enzymtvaettmedel_nn_1_1_N = mkN "enzymtvättmedel" neutrum  ;
  entreprenoerskap_nn_1_1_N = mkN "entreprenörskap" neutrum  ;
  ental_nn_1_N = mkN "ental" neutrum  ;
  ensamhushaall_nn_1_1_N = mkN "ensamhushåll" neutrum  ;
  enkaetsvar_nn_1_1_N = mkN "enkätsvar" neutrum  ;
  enkomponentskitt_nn_1_N = mkN "enkomponentskitt" neutrum  ;
  enjambemang_nn_1_N = mkN "enjambemang" neutrum  ;
  enhetsmaatt_nn_1_1_N = mkN "enhetsmått" neutrum  ;
  enhetsflygplan_nn_1_N = mkN "enhetsflygplan" neutrum  ;
  engaangsligg_nn_1_1_N = mkN "engångsligg" neutrum  ;
  engagemang_nn_1_N = mkN "engagemang" neutrum  ;
  energiverk_nn_1_N = mkN "energiverk" neutrum  ;
  energitillstaand_nn_1_1_N = mkN "energitillstånd" neutrum  ;
  energiintag_nn_1_N = mkN "energiintag" neutrum  ;
  energiinnehaall_nn_1_1_N = mkN "energiinnehåll" neutrum  ;
  energidepartement_nn_1_N = mkN "energidepartement" neutrum  ;
  energibehov_nn_1_N = mkN "energibehov" neutrum  ;
  endossement_nn_1_N = mkN "endossement" neutrum  ;
  endossemang_nn_1_N = mkN "endossemang" neutrum  ;
  endagsbesoek_nn_1_1_N = mkN "endagsbesök" neutrum  ;
  enbaer_nn_1_1_N = mkN "enbär" neutrum  ;
  enbet_nn_1_N = mkN "enbet" neutrum  ;
  email_nn_2_N = mkN "email" neutrum  ;
  elverk_nn_1_N = mkN "elverk" neutrum  ;
  elvamannalag_nn_1_N = mkN "elvamannalag" neutrum  ;
  eluttag_nn_1_N = mkN "eluttag" neutrum  ;
  elnaet_nn_1_1_N = mkN "elnät" neutrum  ;
  ellok_nn_1_N = mkN "ellok" neutrum  ;
  elljusspaar_nn_1_1_N = mkN "elljusspår" neutrum  ;
  elkraftsaggregat_nn_1_N = mkN "elkraftsaggregat" neutrum  ;
  elixir_nn_1_N = mkN "elixir" neutrum  ;
  elittaenk_nn_1_1_N = mkN "elittänk" neutrum  ;
  elitfoerband_nn_1_1_N = mkN "elitförband" neutrum  ;
  elfenbenstorn_nn_1_N = mkN "elfenbenstorn" neutrum  ;
  elevunderlag_nn_1_N = mkN "elevunderlag" neutrum  ;
  elevraad_nn_1_1_N = mkN "elevråd" neutrum  ;
  elevfartyg_nn_1_N = mkN "elevfartyg" neutrum  ;
  elementarlaeroverk_nn_1_1_N = mkN "elementarläroverk" neutrum  ;
  element_nn_1_N = mkN "element" neutrum  ;
  elektroskop_nn_1_N = mkN "elektroskop" neutrum  ;
  elektronskal_nn_1_N = mkN "elektronskal" neutrum  ;
  elektronroer_nn_1_1_N = mkN "elektronrör" neutrum  ;
  elektronpar_nn_1_N = mkN "elektronpar" neutrum  ;
  elektronmoln_nn_1_N = mkN "elektronmoln" neutrum  ;
  elektronmikroskop_nn_1_N = mkN "elektronmikroskop" neutrum  ;
  elektrofilter_nn_1_N = mkN "elektrofilter" neutrum  ;
  elektricitetsverk_nn_1_N = mkN "elektricitetsverk" neutrum  ;
  elefantupplopp_nn_1_N = mkN "elefantupplopp" neutrum  ;
  elefantinhopp_nn_1_N = mkN "elefantinhopp" neutrum  ;
  eldoeverfall_nn_1_1_N = mkN "eldöverfall" neutrum  ;
  eldupphoer_nn_1_1_N = mkN "eldupphör" neutrum  ;
  eldstaal_nn_1_1_N = mkN "eldstål" neutrum  ;
  eldsken_nn_1_N = mkN "eldsken" neutrum  ;
  eldroer_nn_1_1_N = mkN "eldrör" neutrum  ;
  eldredskap_nn_1_N = mkN "eldredskap" neutrum  ;
  eldprov_nn_1_N = mkN "eldprov" neutrum  ;
  eldkol_nn_1_N = mkN "eldkol" neutrum  ;
  elddop_nn_1_N = mkN "elddop" neutrum  ;
  elddon_nn_1_N = mkN "elddon" neutrum  ;
  eldavstaand_nn_1_1_N = mkN "eldavstånd" neutrum  ;
  ekvatorsplan_nn_1_N = mkN "ekvatorsplan" neutrum  ;
  ekorrdjur_nn_1_N = mkN "ekorrdjur" neutrum  ;
  ekorrbaer_nn_1_1_N = mkN "ekorrbär" neutrum  ;
  ekonomipaket_nn_1_N = mkN "ekonomipaket" neutrum  ;
  ekonomibrev_nn_1_N = mkN "ekonomibrev" neutrum  ;
  ekolod_nn_1_N = mkN "ekolod" neutrum  ;
  ekollon_nn_1_N = mkN "ekollon" neutrum  ;
  ekobrott_nn_1_N = mkN "ekobrott" neutrum  ;
  ekloev_nn_1_1_N = mkN "eklöv" neutrum  ;
  ekfat_nn_1_N = mkN "ekfat" neutrum  ;
  ejderdun_nn_1_N = mkN "ejderdun" neutrum  ;
  ejakulat_nn_1_N = mkN "ejakulat" neutrum  ;
  eggverktyg_nn_1_N = mkN "eggverktyg" neutrum  ;
  eggjaern_nn_1_1_N = mkN "eggjärn" neutrum  ;
  egenskapsord_nn_1_N = mkN "egenskapsord" neutrum  ;
  egennamn_nn_1_N = mkN "egennamn" neutrum  ;
  egendomsbrott_nn_1_N = mkN "egendomsbrott" neutrum  ;
  eftertryck_nn_1_N = mkN "eftertryck" neutrum  ;
  eftersaettsblad_nn_1_1_N = mkN "eftersättsblad" neutrum  ;
  efterstygn_nn_1_N = mkN "efterstygn" neutrum  ;
  efterslag_nn_1_N = mkN "efterslag" neutrum  ;
  efterskott_nn_1_N = mkN "efterskott" neutrum  ;
  efterord_nn_1_N = mkN "efterord" neutrum  ;
  efternamn_nn_1_N = mkN "efternamn" neutrum  ;
  eftermiddagsjobb_nn_1_N = mkN "eftermiddagsjobb" neutrum  ;
  efterkrav_nn_1_N = mkN "efterkrav" neutrum  ;
  effektivitetsargument_nn_1_N = mkN "effektivitetsargument" neutrum  ;
  edsoeresbrott_nn_1_1_N = mkN "edsöresbrott" neutrum  ;
  edsbrott_nn_1_N = mkN "edsbrott" neutrum  ;
  edikt_nn_1_N = mkN "edikt" neutrum  ;
  ed_nn_2_N = mkN "ed" neutrum  ;
  ecklesiastikdepartement_nn_1_N = mkN "ecklesiastikdepartement" neutrum  ;
  ebrev_nn_1_N = mkN "ebrev" neutrum  ;
  e_postbrev_nn_1_N = mkN "e-postbrev" neutrum  ;
  e_mail_nn_2_N = mkN "e-mail" neutrum  ;
  e_brev_nn_1_N = mkN "e-brev" neutrum  ;
  doerrvred_nn_1_1_N = mkN "dörrvred" neutrum  ;
  doerrhandtag_nn_1_1_N = mkN "dörrhandtag" neutrum  ;
  doerrblad_nn_1_1_N = mkN "dörrblad" neutrum  ;
  doedsaar_nn_1_1_N = mkN "dödsår" neutrum  ;
  doedsur_nn_1_1_N = mkN "dödsur" neutrum  ;
  doedstal_nn_1_1_N = mkN "dödstal" neutrum  ;
  doedssaett_nn_1_1_N = mkN "dödssätt" neutrum  ;
  doedsstraff_nn_1_1_N = mkN "dödsstraff" neutrum  ;
  doedsskott_nn_1_1_N = mkN "dödsskott" neutrum  ;
  doedsorsaksregister_nn_1_1_N = mkN "dödsorsaksregister" neutrum  ;
  doedskallefynd_nn_1_1_N = mkN "dödskallefynd" neutrum  ;
  doedshot_nn_1_1_N = mkN "dödshot" neutrum  ;
  doedsfall_nn_1_1_N = mkN "dödsfall" neutrum  ;
  doedsbud_nn_1_1_N = mkN "dödsbud" neutrum  ;
  doedmansgrepp_nn_1_1_N = mkN "dödmansgrepp" neutrum  ;
  daan_nn_1_1_N = mkN "dån" neutrum  ;
  daad_nn_1_1_N = mkN "dåd" neutrum  ;
  daeggdjur_nn_1_1_N = mkN "däggdjur" neutrum  ;
  daecksmanskap_nn_1_1_N = mkN "däcksmanskap" neutrum  ;
  daeckjaern_nn_1_1_N = mkN "däckjärn" neutrum  ;
  daeck_nn_2_1_N = mkN "däck" neutrum  ;
  daeck_nn_1_1_N = mkN "däck" neutrum  ;
  dyrtidstillaegg_nn_1_1_N = mkN "dyrtidstillägg" neutrum  ;
  dynlandskap_nn_1_N = mkN "dynlandskap" neutrum  ;
  dygn_nn_1_N = mkN "dygn" neutrum  ;
  dygdemoenster_nn_1_1_N = mkN "dygdemönster" neutrum  ;
  dyblad_nn_1_N = mkN "dyblad" neutrum  ;
  duvslag_nn_1_N = mkN "duvslag" neutrum  ;
  dussintal_nn_1_N = mkN "dussintal" neutrum  ;
  dussin_nn_1_N = mkN "dussin" neutrum  ;
  duschhandtag_nn_1_N = mkN "duschhandtag" neutrum  ;
  durkslag_nn_1_N = mkN "durkslag" neutrum  ;
  durkmoenster_nn_1_1_N = mkN "durkmönster" neutrum  ;
  durackord_nn_1_N = mkN "durackord" neutrum  ;
  duplikat_nn_1_N = mkN "duplikat" neutrum  ;
  dun_nn_1_N = mkN "dun" neutrum  ;
  duggregn_nn_1_N = mkN "duggregn" neutrum  ;
  dubbelspaar_nn_1_1_N = mkN "dubbelspår" neutrum  ;
  dubbelroer_nn_1_1_N = mkN "dubbelrör" neutrum  ;
  dubbelnamn_nn_1_N = mkN "dubbelnamn" neutrum  ;
  dubbelmord_nn_1_N = mkN "dubbelmord" neutrum  ;
  dubbelhoelster_nn_1_1_N = mkN "dubbelhölster" neutrum  ;
  dubbelgrepp_nn_1_N = mkN "dubbelgrepp" neutrum  ;
  dubbelfoenster_nn_1_1_N = mkN "dubbelfönster" neutrum  ;
  dubbelbroellop_nn_1_1_N = mkN "dubbelbröllop" neutrum  ;
  dubbdaeck_nn_1_1_N = mkN "dubbdäck" neutrum  ;
  droemsaellskap_nn_1_1_N = mkN "drömsällskap" neutrum  ;
  droemslott_nn_1_1_N = mkN "drömslott" neutrum  ;
  droemmaal_nn_1_1_N = mkN "drömmål" neutrum  ;
  droemliv_nn_1_1_N = mkN "drömliv" neutrum  ;
  droemlandskap_nn_1_1_N = mkN "drömlandskap" neutrum  ;
  droejsmaal_nn_1_1_N = mkN "dröjsmål" neutrum  ;
  draapslag_nn_1_1_N = mkN "dråpslag" neutrum  ;
  draap_nn_1_1_N = mkN "dråp" neutrum  ;
  draeneringsroer_nn_1_1_N = mkN "dräneringsrör" neutrum  ;
  draektskick_nn_1_1_N = mkN "dräktskick" neutrum  ;
  dryckeslag_nn_1_N = mkN "dryckeslag" neutrum  ;
  dryckeskaerl_nn_1_1_N = mkN "dryckeskärl" neutrum  ;
  dryckeshorn_nn_1_N = mkN "dryckeshorn" neutrum  ;
  druvrussin_nn_1_N = mkN "druvrussin" neutrum  ;
  drunkningsaar_nn_1_1_N = mkN "drunkningsår" neutrum  ;
  drogmissbruk_nn_1_N = mkN "drogmissbruk" neutrum  ;
  drivmedelsbehov_nn_1_N = mkN "drivmedelsbehov" neutrum  ;
  drivmedel_nn_1_N = mkN "drivmedel" neutrum  ;
  drivhjul_nn_1_N = mkN "drivhjul" neutrum  ;
  drivgarn_nn_1_N = mkN "drivgarn" neutrum  ;
  drivband_nn_1_N = mkN "drivband" neutrum  ;
  driftstopp_nn_1_N = mkN "driftstopp" neutrum  ;
  driftstillstaand_nn_1_1_N = mkN "driftstillstånd" neutrum  ;
  driftstillestaand_nn_1_1_N = mkN "driftstillestånd" neutrum  ;
  driftsstoed_nn_1_1_N = mkN "driftsstöd" neutrum  ;
  drev_nn_1_N = mkN "drev" neutrum  ;
  drakskepp_nn_1_N = mkN "drakskepp" neutrum  ;
  dragstift_nn_1_N = mkN "dragstift" neutrum  ;
  dragskaap_nn_1_1_N = mkN "dragskåp" neutrum  ;
  dragrep_nn_1_N = mkN "dragrep" neutrum  ;
  dragprov_nn_1_N = mkN "dragprov" neutrum  ;
  dragdjur_nn_1_N = mkN "dragdjur" neutrum  ;
  dragband_nn_1_N = mkN "dragband" neutrum  ;
  drag_nn_1_N = mkN "drag" neutrum  ;
  dotterspraak_nn_1_1_N = mkN "dotterspråk" neutrum  ;
  dotterfoeretag_nn_1_1_N = mkN "dotterföretag" neutrum  ;
  dotterbolag_nn_1_N = mkN "dotterbolag" neutrum  ;
  dopp_nn_1_N = mkN "dopp" neutrum  ;
  dopningsbrott_nn_1_N = mkN "dopningsbrott" neutrum  ;
  dopnamn_nn_1_N = mkN "dopnamn" neutrum  ;
  dopingbrott_nn_1_N = mkN "dopingbrott" neutrum  ;
  dop_nn_1_N = mkN "dop" neutrum  ;
  donationsmedel_nn_1_N = mkN "donationsmedel" neutrum  ;
  donationsbrev_nn_1_N = mkN "donationsbrev" neutrum  ;
  don_nn_1_N = mkN "don" neutrum  ;
  domaenverk_nn_1_1_N = mkN "domänverk" neutrum  ;
  domstolsverk_nn_1_N = mkN "domstolsverk" neutrum  ;
  domstolsprotokoll_nn_1_N = mkN "domstolsprotokoll" neutrum  ;
  domstolsmaal_nn_1_1_N = mkN "domstolsmål" neutrum  ;
  domstolsbeslut_nn_1_N = mkN "domstolsbeslut" neutrum  ;
  domslut_nn_1_N = mkN "domslut" neutrum  ;
  domskael_nn_1_1_N = mkN "domskäl" neutrum  ;
  domkval_nn_1_N = mkN "domkval" neutrum  ;
  dominohav_nn_1_N = mkN "dominohav" neutrum  ;
  dominikankloster_nn_1_N = mkN "dominikankloster" neutrum  ;
  dominikanerkloster_nn_1_N = mkN "dominikanerkloster" neutrum  ;
  domicil_nn_1_N = mkN "domicil" neutrum  ;
  dollargrin_nn_1_N = mkN "dollargrin" neutrum  ;
  dokumentskaap_nn_1_1_N = mkN "dokumentskåp" neutrum  ;
  dokument_nn_1_N = mkN "dokument" neutrum  ;
  dok_nn_1_N = mkN "dok" neutrum  ;
  dockskaap_nn_1_1_N = mkN "dockskåp" neutrum  ;
  djaevulstyg_nn_1_1_N = mkN "djävulstyg" neutrum  ;
  djaevelstyg_nn_1_1_N = mkN "djävelstyg" neutrum  ;
  djurslag_nn_1_N = mkN "djurslag" neutrum  ;
  djurskinn_nn_1_N = mkN "djurskinn" neutrum  ;
  djurplankton_nn_1_N = mkN "djurplankton" neutrum  ;
  djurkadaver_nn_1_N = mkN "djurkadaver" neutrum  ;
  djurfoersoek_nn_1_1_N = mkN "djurförsök" neutrum  ;
  djurfoder_nn_1_N = mkN "djurfoder" neutrum  ;
  djurben_nn_1_N = mkN "djurben" neutrum  ;
  djurangrepp_nn_1_N = mkN "djurangrepp" neutrum  ;
  djur_nn_1_N = mkN "djur" neutrum  ;
  djuptryck_nn_1_N = mkN "djuptryck" neutrum  ;
  djuplod_nn_1_N = mkN "djuplod" neutrum  ;
  djup_nn_1_N = mkN "djup" neutrum  ;
  djungelbryn_nn_1_N = mkN "djungelbryn" neutrum  ;
  distriktsmaesterskap_nn_1_1_N = mkN "distriktsmästerskap" neutrum  ;
  distrikt_nn_1_N = mkN "distrikt" neutrum  ;
  distributionsfoeretag_nn_1_1_N = mkN "distributionsföretag" neutrum  ;
  diskussionsprotokoll_nn_1_N = mkN "diskussionsprotokoll" neutrum  ;
  diskstaell_nn_1_1_N = mkN "diskställ" neutrum  ;
  diskotek_nn_1_N = mkN "diskotek" neutrum  ;
  diskmedel_nn_1_N = mkN "diskmedel" neutrum  ;
  diskbraack_nn_1_1_N = mkN "diskbråck" neutrum  ;
  diskbrock_nn_1_N = mkN "diskbrock" neutrum  ;
  disciplinstraff_nn_1_N = mkN "disciplinstraff" neutrum  ;
  disciplinmaal_nn_1_1_N = mkN "disciplinmål" neutrum  ;
  direktskott_nn_1_N = mkN "direktskott" neutrum  ;
  direktreferat_nn_1_N = mkN "direktreferat" neutrum  ;
  diplom_nn_1_N = mkN "diplom" neutrum  ;
  dimmoln_nn_1_N = mkN "dimmoln" neutrum  ;
  diktverk_nn_1_N = mkN "diktverk" neutrum  ;
  diktjag_nn_1_N = mkN "diktjag" neutrum  ;
  diktat_nn_1_N = mkN "diktat" neutrum  ;
  dieselkraftverk_nn_1_N = mkN "dieselkraftverk" neutrum  ;
  dibarn_nn_1_N = mkN "dibarn" neutrum  ;
  diarienummer_nn_1_N = mkN "diarienummer" neutrum  ;
  diamantbroellop_nn_1_1_N = mkN "diamantbröllop" neutrum  ;
  diamantbrynstaal_nn_1_1_N = mkN "diamantbrynstål" neutrum  ;
  dialektord_nn_1_N = mkN "dialektord" neutrum  ;
  detonationstryck_nn_1_N = mkN "detonationstryck" neutrum  ;
  detachement_nn_1_N = mkN "detachement" neutrum  ;
  destillat_nn_1_N = mkN "destillat" neutrum  ;
  desinficeringsmedel_nn_1_N = mkN "desinficeringsmedel" neutrum  ;
  desinfektionsmedel_nn_1_N = mkN "desinfektionsmedel" neutrum  ;
  derivat_nn_1_N = mkN "derivat" neutrum  ;
  depaafynd_nn_1_1_N = mkN "depåfynd" neutrum  ;
  departementsraad_nn_1_1_N = mkN "departementsråd" neutrum  ;
  departement_nn_1_N = mkN "departement" neutrum  ;
  demonstrationstaag_nn_1_1_N = mkN "demonstrationståg" neutrum  ;
  demonstrationstillstaand_nn_1_1_N = mkN "demonstrationstillstånd" neutrum  ;
  demenshandikapp_nn_1_N = mkN "demenshandikapp" neutrum  ;
  delstreck_nn_1_N = mkN "delstreck" neutrum  ;
  delprojekt_nn_1_N = mkN "delprojekt" neutrum  ;
  delikatessjaev_nn_1_1_N = mkN "delikatessjäv" neutrum  ;
  delfinspraang_nn_1_1_N = mkN "delfinsprång" neutrum  ;
  dekret_nn_1_N = mkN "dekret" neutrum  ;
  dedikationsexemplar_nn_1_N = mkN "dedikationsexemplar" neutrum  ;
  decimaltal_nn_1_N = mkN "decimaltal" neutrum  ;
  decimalbraak_nn_1_1_N = mkN "decimalbråk" neutrum  ;
  decilitermaatt_nn_1_1_N = mkN "decilitermått" neutrum  ;
  debattknep_nn_1_N = mkN "debattknep" neutrum  ;
  debattinlaegg_nn_1_1_N = mkN "debattinlägg" neutrum  ;
  datorstoed_nn_1_1_N = mkN "datorstöd" neutrum  ;
  datorintraang_nn_1_1_N = mkN "datorintrång" neutrum  ;
  datorfodral_nn_1_N = mkN "datorfodral" neutrum  ;
  dativobjekt_nn_1_N = mkN "dativobjekt" neutrum  ;
  dataregister_nn_1_N = mkN "dataregister" neutrum  ;
  datanaet_nn_1_1_N = mkN "datanät" neutrum  ;
  datalagringsfoeretag_nn_1_1_N = mkN "datalagringsföretag" neutrum  ;
  dataintraang_nn_1_1_N = mkN "dataintrång" neutrum  ;
  danssteg_nn_1_N = mkN "danssteg" neutrum  ;
  danshak_nn_1_N = mkN "danshak" neutrum  ;
  dansgolv_nn_1_N = mkN "dansgolv" neutrum  ;
  dansband_nn_1_N = mkN "dansband" neutrum  ;
  danaarv_nn_1_N = mkN "danaarv" neutrum  ;
  damsaellskap_nn_1_1_N = mkN "damsällskap" neutrum  ;
  damoklessvaerd_nn_1_1_N = mkN "damoklessvärd" neutrum  ;
  dammoln_nn_1_N = mkN "dammoln" neutrum  ;
  dammlager_nn_1_N = mkN "dammlager" neutrum  ;
  dammkvalster_nn_1_N = mkN "dammkvalster" neutrum  ;
  dammkorn_nn_1_N = mkN "dammkorn" neutrum  ;
  dammfoersoek_nn_1_1_N = mkN "dammförsök" neutrum  ;
  dammbindningsmedel_nn_1_N = mkN "dammbindningsmedel" neutrum  ;
  dambesoek_nn_1_1_N = mkN "dambesök" neutrum  ;
  dalmaal_nn_1_1_N = mkN "dalmål" neutrum  ;
  dagtaag_nn_1_1_N = mkN "dagtåg" neutrum  ;
  dagsregn_nn_1_N = mkN "dagsregn" neutrum  ;
  dagsbehov_nn_1_N = mkN "dagsbehov" neutrum  ;
  dagdjur_nn_1_N = mkN "dagdjur" neutrum  ;
  dagbrott_nn_1_N = mkN "dagbrott" neutrum  ;
  dagblad_nn_1_N = mkN "dagblad" neutrum  ;
  dagbefael_nn_1_1_N = mkN "dagbefäl" neutrum  ;
  dagbarn_nn_1_N = mkN "dagbarn" neutrum  ;
  cystoskop_nn_1_N = mkN "cystoskop" neutrum  ;
  cylinderblock_nn_1_N = mkN "cylinderblock" neutrum  ;
  cyklop_nn_2_N = mkN "cyklop" neutrum  ;
  cykelstaell_nn_1_1_N = mkN "cykelställ" neutrum  ;
  cykeldaeck_nn_1_1_N = mkN "cykeldäck" neutrum  ;
  curlingbarn_nn_1_N = mkN "curlingbarn" neutrum  ;
  cumulusmoln_nn_1_N = mkN "cumulusmoln" neutrum  ;
  cocktailbaer_nn_1_1_N = mkN "cocktailbär" neutrum  ;
  cocktailbord_nn_1_N = mkN "cocktailbord" neutrum  ;
  cochlearimplantat_nn_1_N = mkN "cochlearimplantat" neutrum  ;
  cochleaimplantat_nn_1_N = mkN "cochleaimplantat" neutrum  ;
  civilaektenskap_nn_1_1_N = mkN "civiläktenskap" neutrum  ;
  civilstaand_nn_1_1_N = mkN "civilstånd" neutrum  ;
  civilmaal_nn_1_1_N = mkN "civilmål" neutrum  ;
  citronskal_nn_1_N = mkN "citronskal" neutrum  ;
  citatord_nn_1_N = mkN "citatord" neutrum  ;
  citat_nn_1_N = mkN "citat" neutrum  ;
  citadell_nn_1_N = mkN "citadell" neutrum  ;
  cistercienserkloster_nn_1_N = mkN "cistercienserkloster" neutrum  ;
  cirrusmoln_nn_1_N = mkN "cirrusmoln" neutrum  ;
  cirkustaelt_nn_1_1_N = mkN "cirkustält" neutrum  ;
  cirkusnummer_nn_1_N = mkN "cirkusnummer" neutrum  ;
  cirkusdjur_nn_1_N = mkN "cirkusdjur" neutrum  ;
  cirkulaerbrev_nn_1_1_N = mkN "cirkulärbrev" neutrum  ;
  cirkulaer_nn_1_1_N = mkN "cirkulär" neutrum  ;
  cirkelslut_nn_1_N = mkN "cirkelslut" neutrum  ;
  cirkelsegment_nn_1_N = mkN "cirkelsegment" neutrum  ;
  cirkelben_nn_1_N = mkN "cirkelben" neutrum  ;
  cinematek_nn_1_N = mkN "cinematek" neutrum  ;
  cigarrettaendaruttag_nn_1_1_N = mkN "cigarrettändaruttag" neutrum  ;
  cigarrettuttag_nn_1_N = mkN "cigarrettuttag" neutrum  ;
  cigarrettpaket_nn_1_N = mkN "cigarrettpaket" neutrum  ;
  cigarettaendaruttag_nn_1_1_N = mkN "cigarettändaruttag" neutrum  ;
  cigarettuttag_nn_1_N = mkN "cigarettuttag" neutrum  ;
  cigarettpaket_nn_1_N = mkN "cigarettpaket" neutrum  ;
  chocktillstaand_nn_1_1_N = mkN "chocktillstånd" neutrum  ;
  chockbesked_nn_1_N = mkN "chockbesked" neutrum  ;
  chefsjobb_nn_1_N = mkN "chefsjobb" neutrum  ;
  chefsfartyg_nn_1_N = mkN "chefsfartyg" neutrum  ;
  charmtroll_nn_1_N = mkN "charmtroll" neutrum  ;
  championat_nn_1_N = mkN "championat" neutrum  ;
  certifikat_nn_1_N = mkN "certifikat" neutrum  ;
  centumspraak_nn_1_1_N = mkN "centumspråk" neutrum  ;
  centrallasarett_nn_1_N = mkN "centrallasarett" neutrum  ;
  centralkontor_nn_1_N = mkN "centralkontor" neutrum  ;
  centralfoerbund_nn_1_1_N = mkN "centralförbund" neutrum  ;
  centerbord_nn_1_N = mkN "centerbord" neutrum  ;
  cementroer_nn_1_1_N = mkN "cementrör" neutrum  ;
  cellstraff_nn_1_N = mkN "cellstraff" neutrum  ;
  cellskikt_nn_1_N = mkN "cellskikt" neutrum  ;
  cellsjok_nn_1_N = mkN "cellsjok" neutrum  ;
  cash_nn_1_N = mkN "cash" neutrum  ;
  cancerfall_nn_1_N = mkN "cancerfall" neutrum  ;
  campingkoek_nn_1_1_N = mkN "campingkök" neutrum  ;
  caf_ebord_nn_1_1_N = mkN "cafébord" neutrum  ;
  boetesstraff_nn_1_1_N = mkN "bötesstraff" neutrum  ;
  boetesbelopp_nn_1_1_N = mkN "bötesbelopp" neutrum  ;
  boesshaall_nn_1_1_N = mkN "bösshåll" neutrum  ;
  boersbolag_nn_1_1_N = mkN "börsbolag" neutrum  ;
  boeneanrop_nn_1_1_N = mkN "böneanrop" neutrum  ;
  boeljeslag_nn_1_1_N = mkN "böljeslag" neutrum  ;
  boejprov_nn_1_1_N = mkN "böjprov" neutrum  ;
  boejningsmoenster_nn_1_1_N = mkN "böjningsmönster" neutrum  ;
  baatvaardsmedel_nn_1_1_N = mkN "båtvårdsmedel" neutrum  ;
  baatskjul_nn_1_1_N = mkN "båtskjul" neutrum  ;
  baatdaeck_nn_1_1_N = mkN "båtdäck" neutrum  ;
  baatben_nn_1_1_N = mkN "båtben" neutrum  ;
  baalverk_nn_1_1_N = mkN "bålverk" neutrum  ;
  baal_nn_2_1_N = mkN "bål" neutrum  ;
  baagskyttefaelt_nn_1_1_N = mkN "bågskyttefält" neutrum  ;
  baagfoenster_nn_1_1_N = mkN "bågfönster" neutrum  ;
  baagfaelt_nn_1_1_N = mkN "bågfält" neutrum  ;
  baerplan_nn_1_1_N = mkN "bärplan" neutrum  ;
  baerlager_nn_1_1_N = mkN "bärlager" neutrum  ;
  baerhandtag_nn_1_1_N = mkN "bärhandtag" neutrum  ;
  baergningsfoeretag_nn_1_1_N = mkN "bärgningsföretag" neutrum  ;
  baer_nn_1_1_N = mkN "bär" neutrum  ;
  baenkskaap_nn_1_1_N = mkN "bänkskåp" neutrum  ;
  baenknummer_nn_1_1_N = mkN "bänknummer" neutrum  ;
  baendjaern_nn_1_1_N = mkN "bändjärn" neutrum  ;
  baendelband_nn_1_1_N = mkN "bändelband" neutrum  ;
  baeltestvaang_nn_1_1_N = mkN "bältestvång" neutrum  ;
  baeltdjur_nn_1_1_N = mkN "bältdjur" neutrum  ;
  baeckenben_nn_1_1_N = mkN "bäckenben" neutrum  ;
  baecken_nn_1_1_N = mkN "bäcken" neutrum  ;
  byxslag_nn_1_N = mkN "byxslag" neutrum  ;
  byxben_nn_1_N = mkN "byxben" neutrum  ;
  bytesobjekt_nn_1_N = mkN "bytesobjekt" neutrum  ;
  bytesmedel_nn_1_N = mkN "bytesmedel" neutrum  ;
  bytesdjur_nn_1_N = mkN "bytesdjur" neutrum  ;
  bytesbrev_nn_1_N = mkN "bytesbrev" neutrum  ;
  bytesbalansoeverskott_nn_1_1_N = mkN "bytesbalansöverskott" neutrum  ;
  bytesbalansunderskott_nn_1_N = mkN "bytesbalansunderskott" neutrum  ;
  bystmaatt_nn_1_1_N = mkN "bystmått" neutrum  ;
  bymoln_nn_1_N = mkN "bymoln" neutrum  ;
  byggstopp_nn_1_N = mkN "byggstopp" neutrum  ;
  byggprojekt_nn_1_N = mkN "byggprojekt" neutrum  ;
  byggnadsverk_nn_1_N = mkN "byggnadsverk" neutrum  ;
  byggnadstillstaand_nn_1_1_N = mkN "byggnadstillstånd" neutrum  ;
  byggnadssaett_nn_1_1_N = mkN "byggnadssätt" neutrum  ;
  byggnadsmaterial_nn_1_N = mkN "byggnadsmaterial" neutrum  ;
  byggnadslaan_nn_1_1_N = mkN "byggnadslån" neutrum  ;
  byggnadslov_nn_1_N = mkN "byggnadslov" neutrum  ;
  byggnadskontor_nn_1_N = mkN "byggnadskontor" neutrum  ;
  byggnadsfoeretag_nn_1_1_N = mkN "byggnadsföretag" neutrum  ;
  byggmaterial_nn_1_N = mkN "byggmaterial" neutrum  ;
  bygglov_nn_1_N = mkN "bygglov" neutrum  ;
  byggfoeretag_nn_1_1_N = mkN "byggföretag" neutrum  ;
  byggelement_nn_1_N = mkN "byggelement" neutrum  ;
  byggbeslag_nn_1_N = mkN "byggbeslag" neutrum  ;
  bygelhorn_nn_1_N = mkN "bygelhorn" neutrum  ;
  bygdemaal_nn_1_1_N = mkN "bygdemål" neutrum  ;
  byamaal_nn_1_1_N = mkN "byamål" neutrum  ;
  byalag_nn_1_N = mkN "byalag" neutrum  ;
  butiksraan_nn_1_1_N = mkN "butiksrån" neutrum  ;
  butiksfoenster_nn_1_1_N = mkN "butiksfönster" neutrum  ;
  busvaeder_nn_1_1_N = mkN "busväder" neutrum  ;
  busskort_nn_1_N = mkN "busskort" neutrum  ;
  busksnaar_nn_1_1_N = mkN "busksnår" neutrum  ;
  burspraaksfoenster_nn_1_1_N = mkN "burspråksfönster" neutrum  ;
  burspraak_nn_1_1_N = mkN "burspråk" neutrum  ;
  burr_nn_1_N = mkN "burr" neutrum  ;
  burkoel_nn_1_1_N = mkN "burköl" neutrum  ;
  burbrev_nn_1_N = mkN "burbrev" neutrum  ;
  bullerkrav_nn_1_N = mkN "bullerkrav" neutrum  ;
  bullerblomster_nn_1_N = mkN "bullerblomster" neutrum  ;
  buller_nn_1_N = mkN "buller" neutrum  ;
  bullbak_nn_1_N = mkN "bullbak" neutrum  ;
  bulkmedel_nn_1_N = mkN "bulkmedel" neutrum  ;
  bulkfartyg_nn_1_N = mkN "bulkfartyg" neutrum  ;
  buljongben_nn_1_N = mkN "buljongben" neutrum  ;
  bulbjaern_nn_1_1_N = mkN "bulbjärn" neutrum  ;
  bukskott_nn_1_N = mkN "bukskott" neutrum  ;
  bukfettslager_nn_1_N = mkN "bukfettslager" neutrum  ;
  buffertlager_nn_1_N = mkN "buffertlager" neutrum  ;
  budskap_nn_1_N = mkN "budskap" neutrum  ;
  budord_nn_1_N = mkN "budord" neutrum  ;
  budgetoeverskott_nn_1_1_N = mkN "budgetöverskott" neutrum  ;
  budgetaar_nn_1_1_N = mkN "budgetår" neutrum  ;
  budgetunderskott_nn_1_N = mkN "budgetunderskott" neutrum  ;
  budgetflyg_nn_1_N = mkN "budgetflyg" neutrum  ;
  bud_nn_1_N = mkN "bud" neutrum  ;
  bubbelbadkar_nn_1_N = mkN "bubbelbadkar" neutrum  ;
  bubbelbad_nn_1_N = mkN "bubbelbad" neutrum  ;
  broestvaern_nn_1_1_N = mkN "bröstvärn" neutrum  ;
  broestskydd_nn_1_1_N = mkN "bröstskydd" neutrum  ;
  broestsimtag_nn_1_1_N = mkN "bröstsimtag" neutrum  ;
  broestregister_nn_1_1_N = mkN "bröstregister" neutrum  ;
  broestmaatt_nn_1_1_N = mkN "bröstmått" neutrum  ;
  broestingrepp_nn_1_1_N = mkN "bröstingrepp" neutrum  ;
  broestimplantat_nn_1_1_N = mkN "bröstimplantat" neutrum  ;
  broestben_nn_1_1_N = mkN "bröstben" neutrum  ;
  broestbarn_nn_1_1_N = mkN "bröstbarn" neutrum  ;
  broestarv_nn_1_1_N = mkN "bröstarv" neutrum  ;
  broellopsresmaal_nn_1_1_N = mkN "bröllopsresmål" neutrum  ;
  broellopspar_nn_1_1_N = mkN "bröllopspar" neutrum  ;
  broellop_nn_1_1_N = mkN "bröllop" neutrum  ;
  broel_nn_1_1_N = mkN "bröl" neutrum  ;
  broedraskap_nn_1_1_N = mkN "brödraskap" neutrum  ;
  broedrapar_nn_1_1_N = mkN "brödrapar" neutrum  ;
  broedrafolk_nn_1_1_N = mkN "brödrafolk" neutrum  ;
  broedfat_nn_1_1_N = mkN "brödfat" neutrum  ;
  broedbak_nn_1_1_N = mkN "brödbak" neutrum  ;
  broed_nn_1_1_N = mkN "bröd" neutrum  ;
  braaktal_nn_1_1_N = mkN "bråktal" neutrum  ;
  braakstreck_nn_1_1_N = mkN "bråkstreck" neutrum  ;
  braak_nn_1_1_N = mkN "bråk" neutrum  ;
  braaddjup_nn_1_1_N = mkN "bråddjup" neutrum  ;
  braackband_nn_1_1_N = mkN "bråckband" neutrum  ;
  braack_nn_1_1_N = mkN "bråck" neutrum  ;
  braensletillaegg_nn_1_1_N = mkN "bränsletillägg" neutrum  ;
  braenslefoerraad_nn_1_1_N = mkN "bränsleförråd" neutrum  ;
  braenslefaelt_nn_1_1_N = mkN "bränslefält" neutrum  ;
  braenslefilter_nn_1_1_N = mkN "bränslefilter" neutrum  ;
  braensleelement_nn_1_1_N = mkN "bränsleelement" neutrum  ;
  braenslecellskraftverk_nn_1_1_N = mkN "bränslecellskraftverk" neutrum  ;
  braennvinsbord_nn_1_1_N = mkN "brännvinsbord" neutrum  ;
  braennsaar_nn_1_1_N = mkN "brännsår" neutrum  ;
  braennmaterial_nn_1_1_N = mkN "brännmaterial" neutrum  ;
  braennjaern_nn_1_1_N = mkN "brännjärn" neutrum  ;
  braennhaar_nn_1_1_N = mkN "brännhår" neutrum  ;
  braem_nn_1_1_N = mkN "bräm" neutrum  ;
  braedplank_nn_1_1_N = mkN "brädplank" neutrum  ;
  braeddavlopp_nn_1_1_N = mkN "bräddavlopp" neutrum  ;
  braeckjaern_nn_1_1_N = mkN "bräckjärn" neutrum  ;
  brytningsaar_nn_1_1_N = mkN "brytningsår" neutrum  ;
  brytblad_nn_1_N = mkN "brytblad" neutrum  ;
  brynstaal_nn_1_1_N = mkN "brynstål" neutrum  ;
  brynset_nn_1_N = mkN "brynset" neutrum  ;
  bryn_nn_1_N = mkN "bryn" neutrum  ;
  brunnskar_nn_1_N = mkN "brunnskar" neutrum  ;
  brunkol_nn_1_N = mkN "brunkol" neutrum  ;
  brunbaer_nn_1_1_N = mkN "brunbär" neutrum  ;
  bruksfoeremaal_nn_1_1_N = mkN "bruksföremål" neutrum  ;
  bruksdjur_nn_1_N = mkN "bruksdjur" neutrum  ;
  bruk_nn_2_N = mkN "bruk" neutrum  ;
  bruk_nn_1_N = mkN "bruk" neutrum  ;
  brudrov_nn_1_N = mkN "brudrov" neutrum  ;
  brudpar_nn_1_N = mkN "brudpar" neutrum  ;
  brudkoep_nn_1_1_N = mkN "brudköp" neutrum  ;
  brovalv_nn_1_N = mkN "brovalv" neutrum  ;
  brottsrekvisit_nn_1_N = mkN "brottsrekvisit" neutrum  ;
  brottsregister_nn_1_N = mkN "brottsregister" neutrum  ;
  brottningsgrepp_nn_1_N = mkN "brottningsgrepp" neutrum  ;
  brottmaal_nn_1_1_N = mkN "brottmål" neutrum  ;
  brott_nn_2_N = mkN "brott" neutrum  ;
  brott_nn_1_N = mkN "brott" neutrum  ;
  brospann_nn_1_N = mkN "brospann" neutrum  ;
  broskverk_nn_1_N = mkN "broskverk" neutrum  ;
  brorsbarn_nn_1_N = mkN "brorsbarn" neutrum  ;
  brorsarv_nn_1_N = mkN "brorsarv" neutrum  ;
  bronsaaldersfynd_nn_1_1_N = mkN "bronsåldersfynd" neutrum  ;
  bronssvaerd_nn_1_1_N = mkN "bronssvärd" neutrum  ;
  bronsmynt_nn_1_N = mkN "bronsmynt" neutrum  ;
  bronkoskop_nn_1_N = mkN "bronkoskop" neutrum  ;
  bromsspaar_nn_1_1_N = mkN "bromsspår" neutrum  ;
  bromsilverpapper_nn_1_N = mkN "bromsilverpapper" neutrum  ;
  bromshandtag_nn_1_N = mkN "bromshandtag" neutrum  ;
  bromsgaller_nn_1_N = mkN "bromsgaller" neutrum  ;
  bromsblock_nn_1_N = mkN "bromsblock" neutrum  ;
  bromsbelaegg_nn_1_1_N = mkN "bromsbelägg" neutrum  ;
  bromsband_nn_1_N = mkN "bromsband" neutrum  ;
  brolopp_nn_1_N = mkN "brolopp" neutrum  ;
  brokar_nn_1_N = mkN "brokar" neutrum  ;
  broderskap_nn_1_N = mkN "broderskap" neutrum  ;
  brodermord_nn_1_N = mkN "brodermord" neutrum  ;
  broderfolk_nn_1_N = mkN "broderfolk" neutrum  ;
  brockband_nn_1_N = mkN "brockband" neutrum  ;
  brock_nn_2_N = mkN "brock" neutrum  ;
  brittsommarvaeder_nn_1_1_N = mkN "brittsommarväder" neutrum  ;
  bridgebord_nn_1_N = mkN "bridgebord" neutrum  ;
  brickunderlaegg_nn_1_1_N = mkN "brickunderlägg" neutrum  ;
  brickbord_nn_1_N = mkN "brickbord" neutrum  ;
  brickband_nn_1_N = mkN "brickband" neutrum  ;
  brevsvar_nn_1_N = mkN "brevsvar" neutrum  ;
  brevstaell_nn_1_1_N = mkN "brevställ" neutrum  ;
  brevpapper_nn_1_N = mkN "brevpapper" neutrum  ;
  brevlaadefoeretag_nn_1_1_N = mkN "brevlådeföretag" neutrum  ;
  brevkort_nn_1_N = mkN "brevkort" neutrum  ;
  brevfack_nn_1_N = mkN "brevfack" neutrum  ;
  brev_nn_1_N = mkN "brev" neutrum  ;
  bredbandsfoeretag_nn_1_1_N = mkN "bredbandsföretag" neutrum  ;
  bredband_nn_1_N = mkN "bredband" neutrum  ;
  break_nn_1_N = mkN "break" neutrum  ;
  bravurnummer_nn_1_N = mkN "bravurnummer" neutrum  ;
  bravorop_nn_1_N = mkN "bravorop" neutrum  ;
  branschraad_nn_1_1_N = mkN "branschråd" neutrum  ;
  brandtorn_nn_1_N = mkN "brandtorn" neutrum  ;
  brandtal_nn_1_N = mkN "brandtal" neutrum  ;
  brandstodsbolag_nn_1_N = mkN "brandstodsbolag" neutrum  ;
  brandskaap_nn_1_1_N = mkN "brandskåp" neutrum  ;
  brandroer_nn_1_1_N = mkN "brandrör" neutrum  ;
  brandredskap_nn_1_N = mkN "brandredskap" neutrum  ;
  brandlager_nn_1_N = mkN "brandlager" neutrum  ;
  brandfoersaekringsbolag_nn_1_1_N = mkN "brandförsäkringsbolag" neutrum  ;
  brandbefael_nn_1_1_N = mkN "brandbefäl" neutrum  ;
  brandattentat_nn_1_N = mkN "brandattentat" neutrum  ;
  bragdlopp_nn_1_N = mkN "bragdlopp" neutrum  ;
  bragdguld_nn_1_N = mkN "bragdguld" neutrum  ;
  boaegg_nn_1_1_N = mkN "boägg" neutrum  ;
  boxnummer_nn_1_N = mkN "boxnummer" neutrum  ;
  bowlingklot_nn_1_N = mkN "bowlingklot" neutrum  ;
  bovstreck_nn_1_N = mkN "bovstreck" neutrum  ;
  bottenskikt_nn_1_N = mkN "bottenskikt" neutrum  ;
  bottensediment_nn_1_N = mkN "bottensediment" neutrum  ;
  bottenrev_nn_1_N = mkN "bottenrev" neutrum  ;
  bottenrekord_nn_1_N = mkN "bottenrekord" neutrum  ;
  bottenplan_nn_1_N = mkN "bottenplan" neutrum  ;
  bottennapp_nn_1_N = mkN "bottennapp" neutrum  ;
  bottenlaan_nn_1_1_N = mkN "bottenlån" neutrum  ;
  bottenlag_nn_1_N = mkN "bottenlag" neutrum  ;
  bottengarn_nn_1_N = mkN "bottengarn" neutrum  ;
  bottendjur_nn_1_N = mkN "bottendjur" neutrum  ;
  botemedel_nn_1_N = mkN "botemedel" neutrum  ;
  bosaettningsstopp_nn_1_1_N = mkN "bosättningsstopp" neutrum  ;
  bosaettningslaan_nn_1_1_N = mkN "bosättningslån" neutrum  ;
  bostadstillaegg_nn_1_1_N = mkN "bostadstillägg" neutrum  ;
  bostadslaan_nn_1_1_N = mkN "bostadslån" neutrum  ;
  bostadsfoeretag_nn_1_1_N = mkN "bostadsföretag" neutrum  ;
  bostadsfoerbaettringslaan_nn_1_1_N = mkN "bostadsförbättringslån" neutrum  ;
  bostadsbolag_nn_1_N = mkN "bostadsbolag" neutrum  ;
  bostadsbidrag_nn_1_N = mkN "bostadsbidrag" neutrum  ;
  bostadsband_nn_1_N = mkN "bostadsband" neutrum  ;
  boskapsfoder_nn_1_N = mkN "boskapsfoder" neutrum  ;
  bortfall_nn_1_N = mkN "bortfall" neutrum  ;
  bortalag_nn_1_N = mkN "bortalag" neutrum  ;
  borstgarnityr_nn_1_N = mkN "borstgarnityr" neutrum  ;
  borrtorn_nn_1_N = mkN "borrtorn" neutrum  ;
  borrstaal_nn_1_1_N = mkN "borrstål" neutrum  ;
  borrspaan_nn_1_1_N = mkN "borrspån" neutrum  ;
  borrhaal_nn_1_1_N = mkN "borrhål" neutrum  ;
  borgtorn_nn_1_N = mkN "borgtorn" neutrum  ;
  borgerskap_nn_1_N = mkN "borgerskap" neutrum  ;
  borgenslaan_nn_1_1_N = mkN "borgenslån" neutrum  ;
  borgarraad_nn_1_1_N = mkN "borgarråd" neutrum  ;
  borgarbrev_nn_1_N = mkN "borgarbrev" neutrum  ;
  bordtennisbord_nn_1_N = mkN "bordtennisbord" neutrum  ;
  bordssaellskap_nn_1_1_N = mkN "bordssällskap" neutrum  ;
  bordsstaell_nn_1_1_N = mkN "bordsställ" neutrum  ;
  bordsskick_nn_1_N = mkN "bordsskick" neutrum  ;
  bordssamtal_nn_1_N = mkN "bordssamtal" neutrum  ;
  bordskick_nn_1_N = mkN "bordskick" neutrum  ;
  bordsben_nn_1_N = mkN "bordsben" neutrum  ;
  bordsamtal_nn_1_N = mkN "bordsamtal" neutrum  ;
  bord_nn_1_N = mkN "bord" neutrum  ;
  boomaar_nn_1_1_N = mkN "boomår" neutrum  ;
  bonusbarn_nn_1_N = mkN "bonusbarn" neutrum  ;
  bondfoersoek_nn_1_1_N = mkN "bondförsök" neutrum  ;
  bondfolk_nn_1_N = mkN "bondfolk" neutrum  ;
  bondeuppror_nn_1_N = mkN "bondeuppror" neutrum  ;
  bondeuppbaad_nn_1_1_N = mkN "bondeuppbåd" neutrum  ;
  bondetaag_nn_1_1_N = mkN "bondetåg" neutrum  ;
  bondehemman_nn_1_N = mkN "bondehemman" neutrum  ;
  bomullsband_nn_1_N = mkN "bomullsband" neutrum  ;
  bomskott_nn_1_N = mkN "bomskott" neutrum  ;
  bombskydd_nn_1_N = mkN "bombskydd" neutrum  ;
  bombplan_nn_1_N = mkN "bombplan" neutrum  ;
  bombnedslag_nn_1_N = mkN "bombnedslag" neutrum  ;
  bomblarm_nn_1_N = mkN "bomblarm" neutrum  ;
  bombkrig_nn_1_N = mkN "bombkrig" neutrum  ;
  bombhot_nn_1_N = mkN "bombhot" neutrum  ;
  bombdaad_nn_1_1_N = mkN "bombdåd" neutrum  ;
  bombattentat_nn_1_N = mkN "bombattentat" neutrum  ;
  bombardemang_nn_1_N = mkN "bombardemang" neutrum  ;
  bombanfall_nn_1_N = mkN "bombanfall" neutrum  ;
  bomaterial_nn_1_N = mkN "bomaterial" neutrum  ;
  bolaan_nn_1_1_N = mkN "bolån" neutrum  ;
  bolstervar_nn_1_N = mkN "bolstervar" neutrum  ;
  bollplank_nn_1_N = mkN "bollplank" neutrum  ;
  bollhav_nn_1_N = mkN "bollhav" neutrum  ;
  bolag_nn_1_N = mkN "bolag" neutrum  ;
  bol_nn_1_N = mkN "bol" neutrum  ;
  bokverk_nn_1_N = mkN "bokverk" neutrum  ;
  bokval_nn_1_N = mkN "bokval" neutrum  ;
  bokuppslag_nn_1_N = mkN "bokuppslag" neutrum  ;
  boktorn_nn_1_N = mkN "boktorn" neutrum  ;
  bokstoed_nn_1_1_N = mkN "bokstöd" neutrum  ;
  bokstavsbarn_nn_1_N = mkN "bokstavsbarn" neutrum  ;
  bokslut_nn_1_N = mkN "bokslut" neutrum  ;
  bokskaap_nn_1_1_N = mkN "bokskåp" neutrum  ;
  bokomslag_nn_1_N = mkN "bokomslag" neutrum  ;
  bokollon_nn_1_N = mkN "bokollon" neutrum  ;
  bokmagasin_nn_1_N = mkN "bokmagasin" neutrum  ;
  boklaan_nn_1_1_N = mkN "boklån" neutrum  ;
  bokfoerraad_nn_1_1_N = mkN "bokförråd" neutrum  ;
  bokfoerlag_nn_1_1_N = mkN "bokförlag" neutrum  ;
  bokfoeringsaar_nn_1_1_N = mkN "bokföringsår" neutrum  ;
  bokfoeringsbrott_nn_1_1_N = mkN "bokföringsbrott" neutrum  ;
  bokformat_nn_1_N = mkN "bokformat" neutrum  ;
  bokband_nn_1_N = mkN "bokband" neutrum  ;
  bohag_nn_1_N = mkN "bohag" neutrum  ;
  bogvisir_nn_1_N = mkN "bogvisir" neutrum  ;
  bogsproet_nn_1_1_N = mkN "bogspröt" neutrum  ;
  bogserslaep_nn_1_1_N = mkN "bogsersläp" neutrum  ;
  bogblad_nn_1_N = mkN "bogblad" neutrum  ;
  bockverktyg_nn_1_N = mkN "bockverktyg" neutrum  ;
  bockspraang_nn_1_1_N = mkN "bocksprång" neutrum  ;
  bockskaegg_nn_1_1_N = mkN "bockskägg" neutrum  ;
  bockprov_nn_1_N = mkN "bockprov" neutrum  ;
  bockhorn_nn_1_N = mkN "bockhorn" neutrum  ;
  bockblad_nn_1_N = mkN "bockblad" neutrum  ;
  boardingcard_nn_1_N = mkN "boardingcard" neutrum  ;
  bloetlaeggningsmedel_nn_1_1_N = mkN "blötläggningsmedel" neutrum  ;
  bloetdjur_nn_1_1_N = mkN "blötdjur" neutrum  ;
  blaasvaeder_nn_1_1_N = mkN "blåsväder" neutrum  ;
  blaastaell_nn_1_1_N = mkN "blåställ" neutrum  ;
  blaasroer_nn_1_1_N = mkN "blåsrör" neutrum  ;
  blaasljud_nn_1_1_N = mkN "blåsljud" neutrum  ;
  blaasinstrument_nn_1_1_N = mkN "blåsinstrument" neutrum  ;
  blaashaal_nn_1_1_N = mkN "blåshål" neutrum  ;
  blaahjon_nn_1_1_N = mkN "blåhjon" neutrum  ;
  blaahallon_nn_1_1_N = mkN "blåhallon" neutrum  ;
  blaabaer_nn_1_1_N = mkN "blåbär" neutrum  ;
  blaesterroer_nn_1_1_N = mkN "blästerrör" neutrum  ;
  blaendverk_nn_1_1_N = mkN "bländverk" neutrum  ;
  blaendskydd_nn_1_1_N = mkN "bländskydd" neutrum  ;
  blaedderblock_nn_1_1_N = mkN "blädderblock" neutrum  ;
  blaeckhorn_nn_1_1_N = mkN "bläckhorn" neutrum  ;
  blylod_nn_1_N = mkN "blylod" neutrum  ;
  blygdhaar_nn_2_1_N = mkN "blygdhår" neutrum  ;
  blygdben_nn_1_N = mkN "blygdben" neutrum  ;
  blusliv_nn_1_N = mkN "blusliv" neutrum  ;
  bluffprojekt_nn_1_N = mkN "bluffprojekt" neutrum  ;
  bluffpiller_nn_1_N = mkN "bluffpiller" neutrum  ;
  blot_nn_1_N = mkN "blot" neutrum  ;
  blomsterbord_nn_1_N = mkN "blomsterbord" neutrum  ;
  blomster_nn_1_N = mkN "blomster" neutrum  ;
  blomskaft_nn_1_N = mkN "blomskaft" neutrum  ;
  blommoenster_nn_1_1_N = mkN "blommönster" neutrum  ;
  blomhoelster_nn_1_1_N = mkN "blomhölster" neutrum  ;
  blomfoder_nn_1_N = mkN "blomfoder" neutrum  ;
  blomfjaell_nn_1_1_N = mkN "blomfjäll" neutrum  ;
  blomfat_nn_1_N = mkN "blomfat" neutrum  ;
  blombord_nn_1_N = mkN "blombord" neutrum  ;
  blomblad_nn_1_N = mkN "blomblad" neutrum  ;
  blogginlaegg_nn_1_1_N = mkN "blogginlägg" neutrum  ;
  blodtryck_nn_1_N = mkN "blodtryck" neutrum  ;
  blodspaar_nn_1_1_N = mkN "blodspår" neutrum  ;
  blodsdaad_nn_1_1_N = mkN "blodsdåd" neutrum  ;
  blodsband_nn_1_N = mkN "blodsband" neutrum  ;
  blodkaerlsbraack_nn_1_1_N = mkN "blodkärlsbråck" neutrum  ;
  blodkaerl_nn_1_1_N = mkN "blodkärl" neutrum  ;
  blodbad_nn_1_N = mkN "blodbad" neutrum  ;
  blocktyg_nn_1_N = mkN "blocktyg" neutrum  ;
  blockadbrott_nn_1_N = mkN "blockadbrott" neutrum  ;
  block_nn_1_N = mkN "block" neutrum  ;
  blixtsamtal_nn_1_N = mkN "blixtsamtal" neutrum  ;
  blixtnedslag_nn_1_N = mkN "blixtnedslag" neutrum  ;
  blixtkrig_nn_1_N = mkN "blixtkrig" neutrum  ;
  blixtbesoek_nn_1_1_N = mkN "blixtbesök" neutrum  ;
  blixtanfall_nn_1_N = mkN "blixtanfall" neutrum  ;
  blink_nn_1_N = mkN "blink" neutrum  ;
  blindtryck_nn_1_N = mkN "blindtryck" neutrum  ;
  blindspaar_nn_1_1_N = mkN "blindspår" neutrum  ;
  blindskaer_nn_1_1_N = mkN "blindskär" neutrum  ;
  blindfoenster_nn_1_1_N = mkN "blindfönster" neutrum  ;
  blindalfabet_nn_1_N = mkN "blindalfabet" neutrum  ;
  blidvaeder_nn_1_1_N = mkN "blidväder" neutrum  ;
  blickfaang_nn_1_1_N = mkN "blickfång" neutrum  ;
  blickfaelt_nn_1_1_N = mkN "blickfält" neutrum  ;
  blekmedel_nn_1_N = mkN "blekmedel" neutrum  ;
  bleckblaasinstrument_nn_1_1_N = mkN "bleckblåsinstrument" neutrum  ;
  bleck_nn_1_N = mkN "bleck" neutrum  ;
  blankettskaap_nn_1_1_N = mkN "blankettskåp" neutrum  ;
  blandaektenskap_nn_1_1_N = mkN "blandäktenskap" neutrum  ;
  blandspraak_nn_1_1_N = mkN "blandspråk" neutrum  ;
  blandfolk_nn_1_N = mkN "blandfolk" neutrum  ;
  bladskaft_nn_1_N = mkN "bladskaft" neutrum  ;
  blad_nn_1_N = mkN "blad" neutrum  ;
  bjoernskinn_nn_1_1_N = mkN "björnskinn" neutrum  ;
  bjoernskall_nn_1_1_N = mkN "björnskall" neutrum  ;
  bjoernhallon_nn_1_1_N = mkN "björnhallon" neutrum  ;
  bjoernbaer_nn_1_1_N = mkN "björnbär" neutrum  ;
  bjoerkloev_nn_1_1_N = mkN "björklöv" neutrum  ;
  bjoerkblad_nn_1_1_N = mkN "björkblad" neutrum  ;
  bjaelkverk_nn_1_1_N = mkN "bjälkverk" neutrum  ;
  bjaelklag_nn_1_1_N = mkN "bjälklag" neutrum  ;
  biverkningsfall_nn_1_N = mkN "biverkningsfall" neutrum  ;
  bitsaar_nn_1_1_N = mkN "bitsår" neutrum  ;
  bistaandsskepp_nn_1_1_N = mkN "biståndsskepp" neutrum  ;
  bistaandsprojekt_nn_1_1_N = mkN "biståndsprojekt" neutrum  ;
  bistaandsorgan_nn_1_1_N = mkN "biståndsorgan" neutrum  ;
  bistaandsmaal_nn_1_1_N = mkN "biståndsmål" neutrum  ;
  bistyng_nn_1_N = mkN "bistyng" neutrum  ;
  bisting_nn_1_N = mkN "bisting" neutrum  ;
  bistick_nn_1_N = mkN "bistick" neutrum  ;
  biskopsval_nn_1_N = mkN "biskopsval" neutrum  ;
  biskopsstift_nn_1_N = mkN "biskopsstift" neutrum  ;
  bisamsvin_nn_1_N = mkN "bisamsvin" neutrum  ;
  biplan_nn_1_N = mkN "biplan" neutrum  ;
  biodrivmedel_nn_1_N = mkN "biodrivmedel" neutrum  ;
  biobesoek_nn_1_1_N = mkN "biobesök" neutrum  ;
  bindgarn_nn_1_N = mkN "bindgarn" neutrum  ;
  bindestreck_nn_1_N = mkN "bindestreck" neutrum  ;
  bindeord_nn_1_N = mkN "bindeord" neutrum  ;
  bindemedel_nn_1_N = mkN "bindemedel" neutrum  ;
  bind_nn_1_N = mkN "bind" neutrum  ;
  binamn_nn_1_N = mkN "binamn" neutrum  ;
  bilaeger_nn_1_1_N = mkN "biläger" neutrum  ;
  bilvrak_nn_1_N = mkN "bilvrak" neutrum  ;
  biltak_nn_1_N = mkN "biltak" neutrum  ;
  bilregister_nn_1_N = mkN "bilregister" neutrum  ;
  bilnummer_nn_1_N = mkN "bilnummer" neutrum  ;
  billaan_nn_1_1_N = mkN "billån" neutrum  ;
  bilkoep_nn_1_1_N = mkN "bilköp" neutrum  ;
  biljud_nn_1_N = mkN "biljud" neutrum  ;
  biljettkoep_nn_1_1_N = mkN "biljettköp" neutrum  ;
  biljettkontor_nn_1_N = mkN "biljettkontor" neutrum  ;
  biljardbord_nn_1_N = mkN "biljardbord" neutrum  ;
  bilhjul_nn_1_N = mkN "bilhjul" neutrum  ;
  bilgolv_nn_1_N = mkN "bilgolv" neutrum  ;
  bilfoenster_nn_1_1_N = mkN "bilfönster" neutrum  ;
  bildaeck_nn_1_1_N = mkN "bildäck" neutrum  ;
  bildverk_nn_1_N = mkN "bildverk" neutrum  ;
  bildspraak_nn_1_1_N = mkN "bildspråk" neutrum  ;
  bildroer_nn_1_1_N = mkN "bildrör" neutrum  ;
  bildningsfoerbund_nn_1_1_N = mkN "bildningsförbund" neutrum  ;
  bildmaterial_nn_1_N = mkN "bildmaterial" neutrum  ;
  bildinnehav_nn_1_N = mkN "bildinnehav" neutrum  ;
  bildband_nn_1_N = mkN "bildband" neutrum  ;
  biktbarn_nn_1_N = mkN "biktbarn" neutrum  ;
  bihav_nn_1_N = mkN "bihav" neutrum  ;
  bihang_nn_1_N = mkN "bihang" neutrum  ;
  biffdjur_nn_1_N = mkN "biffdjur" neutrum  ;
  bifallsrop_nn_1_N = mkN "bifallsrop" neutrum  ;
  bifall_nn_1_N = mkN "bifall" neutrum  ;
  bidragsfoerskott_nn_1_1_N = mkN "bidragsförskott" neutrum  ;
  bidrag_nn_1_N = mkN "bidrag" neutrum  ;
  bibroed_nn_1_1_N = mkN "bibröd" neutrum  ;
  bibliotekslaan_nn_1_1_N = mkN "bibliotekslån" neutrum  ;
  biblioteksbord_nn_1_N = mkN "biblioteksbord" neutrum  ;
  biblioteksband_nn_1_N = mkN "biblioteksband" neutrum  ;
  bibliotek_nn_1_N = mkN "bibliotek" neutrum  ;
  bibelsaellskap_nn_1_1_N = mkN "bibelsällskap" neutrum  ;
  bibelspraak_nn_1_1_N = mkN "bibelspråk" neutrum  ;
  bibelsamtal_nn_1_N = mkN "bibelsamtal" neutrum  ;
  bibelord_nn_1_N = mkN "bibelord" neutrum  ;
  bibelcitat_nn_1_N = mkN "bibelcitat" neutrum  ;
  bevismedel_nn_1_N = mkN "bevismedel" neutrum  ;
  bevismaterial_nn_1_N = mkN "bevismaterial" neutrum  ;
  beviskrav_nn_1_N = mkN "beviskrav" neutrum  ;
  bevillningsutskott_nn_1_N = mkN "bevillningsutskott" neutrum  ;
  bevakningsuppdrag_nn_1_N = mkN "bevakningsuppdrag" neutrum  ;
  betyg_nn_1_N = mkN "betyg" neutrum  ;
  betydelseskikt_nn_1_N = mkN "betydelseskikt" neutrum  ;
  betydelselager_nn_1_N = mkN "betydelselager" neutrum  ;
  bett_nn_1_N = mkN "bett" neutrum  ;
  betsmedel_nn_1_N = mkN "betsmedel" neutrum  ;
  betraktelsesaett_nn_1_1_N = mkN "betraktelsesätt" neutrum  ;
  betongvalv_nn_1_N = mkN "betongvalv" neutrum  ;
  betonghinder_nn_1_N = mkN "betonghinder" neutrum  ;
  betonggolv_nn_1_N = mkN "betonggolv" neutrum  ;
  betongblock_nn_1_N = mkN "betongblock" neutrum  ;
  betongbjaelklag_nn_1_1_N = mkN "betongbjälklag" neutrum  ;
  betmedel_nn_1_N = mkN "betmedel" neutrum  ;
  beting_nn_1_N = mkN "beting" neutrum  ;
  betesland_nn_1_N = mkN "betesland" neutrum  ;
  betelblad_nn_1_N = mkN "betelblad" neutrum  ;
  beteendemoenster_nn_1_1_N = mkN "beteendemönster" neutrum  ;
  beteckningssaett_nn_1_1_N = mkN "beteckningssätt" neutrum  ;
  betasoenderfall_nn_1_1_N = mkN "betasönderfall" neutrum  ;
  betalningsvillkor_nn_1_N = mkN "betalningsvillkor" neutrum  ;
  betalningsmedel_nn_1_N = mkN "betalningsmedel" neutrum  ;
  betalningsavtal_nn_1_N = mkN "betalningsavtal" neutrum  ;
  betalningsanstaand_nn_1_1_N = mkN "betalningsanstånd" neutrum  ;
  besoekstopp_nn_1_1_N = mkN "besökstopp" neutrum  ;
  besoeksfoerbud_nn_1_1_N = mkN "besöksförbud" neutrum  ;
  besoek_nn_1_1_N = mkN "besök" neutrum  ;
  besaettningsband_nn_1_1_N = mkN "besättningsband" neutrum  ;
  besvaerssubjekt_nn_1_1_N = mkN "besvärssubjekt" neutrum  ;
  besvaersmaal_nn_1_1_N = mkN "besvärsmål" neutrum  ;
  besvaer_nn_1_1_N = mkN "besvär" neutrum  ;
  bestaand_nn_1_1_N = mkN "bestånd" neutrum  ;
  bestaemningsord_nn_1_1_N = mkN "bestämningsord" neutrum  ;
  bestaellningsverk_nn_1_1_N = mkN "beställningsverk" neutrum  ;
  bestyr_nn_1_N = mkN "bestyr" neutrum  ;
  bestraffningsmedel_nn_1_N = mkN "bestraffningsmedel" neutrum  ;
  bestick_nn_1_N = mkN "bestick" neutrum  ;
  bessemerstaal_nn_1_1_N = mkN "bessemerstål" neutrum  ;
  besprutningsmedel_nn_1_N = mkN "besprutningsmedel" neutrum  ;
  besparingskrav_nn_1_N = mkN "besparingskrav" neutrum  ;
  besman_nn_1_N = mkN "besman" neutrum  ;
  beslutsunderlag_nn_1_N = mkN "beslutsunderlag" neutrum  ;
  beslut_nn_1_N = mkN "beslut" neutrum  ;
  beslagsband_nn_1_N = mkN "beslagsband" neutrum  ;
  beslag_nn_1_N = mkN "beslag" neutrum  ;
  besked_nn_1_N = mkN "besked" neutrum  ;
  beskattningsaar_nn_1_1_N = mkN "beskattningsår" neutrum  ;
  besittningsskydd_nn_1_N = mkN "besittningsskydd" neutrum  ;
  besiktningsprotokoll_nn_1_N = mkN "besiktningsprotokoll" neutrum  ;
  besiktningsinstrument_nn_1_N = mkN "besiktningsinstrument" neutrum  ;
  beraettarjag_nn_1_1_N = mkN "berättarjag" neutrum  ;
  beraekningssaett_nn_1_1_N = mkN "beräkningssätt" neutrum  ;
  bergtroll_nn_1_N = mkN "bergtroll" neutrum  ;
  bergstup_nn_1_N = mkN "bergstup" neutrum  ;
  bergslandskap_nn_1_N = mkN "bergslandskap" neutrum  ;
  bergslager_nn_1_N = mkN "bergslager" neutrum  ;
  bergskroen_nn_1_1_N = mkN "bergskrön" neutrum  ;
  bergskred_nn_1_N = mkN "bergskred" neutrum  ;
  berglandskap_nn_1_N = mkN "berglandskap" neutrum  ;
  bergkroen_nn_1_1_N = mkN "bergkrön" neutrum  ;
  bergartslager_nn_1_N = mkN "bergartslager" neutrum  ;
  berg_nn_1_N = mkN "berg" neutrum  ;
  beredskapsplan_nn_1_N = mkN "beredskapsplan" neutrum  ;
  beredskapslager_nn_1_N = mkN "beredskapslager" neutrum  ;
  beredningsutskott_nn_1_N = mkN "beredningsutskott" neutrum  ;
  benutskott_nn_1_N = mkN "benutskott" neutrum  ;
  bensaar_nn_1_1_N = mkN "bensår" neutrum  ;
  benskydd_nn_1_N = mkN "benskydd" neutrum  ;
  bensinstopp_nn_1_N = mkN "bensinstopp" neutrum  ;
  bensinbolag_nn_1_N = mkN "bensinbolag" neutrum  ;
  benfragment_nn_1_N = mkN "benfragment" neutrum  ;
  benediktinkloster_nn_1_N = mkN "benediktinkloster" neutrum  ;
  benediktinerkloster_nn_1_N = mkN "benediktinerkloster" neutrum  ;
  benbrott_nn_1_N = mkN "benbrott" neutrum  ;
  ben_nn_1_N = mkN "ben" neutrum  ;
  bemanningsfoeretag_nn_1_1_N = mkN "bemanningsföretag" neutrum  ;
  belaegringstorn_nn_1_1_N = mkN "belägringstorn" neutrum  ;
  belaegringstillstaand_nn_1_1_N = mkN "belägringstillstånd" neutrum  ;
  belaegg_nn_1_1_N = mkN "belägg" neutrum  ;
  belopp_nn_1_N = mkN "belopp" neutrum  ;
  belastningsregister_nn_1_N = mkN "belastningsregister" neutrum  ;
  belag_nn_1_N = mkN "belag" neutrum  ;
  bekaempningsmedel_nn_1_1_N = mkN "bekämpningsmedel" neutrum  ;
  bekymmer_nn_1_N = mkN "bekymmer" neutrum  ;
  bekraeftelsebehov_nn_1_1_N = mkN "bekräftelsebehov" neutrum  ;
  behovstryck_nn_1_N = mkN "behovstryck" neutrum  ;
  behov_nn_1_N = mkN "behov" neutrum  ;
  behandlingssaett_nn_1_1_N = mkN "behandlingssätt" neutrum  ;
  behag_nn_1_N = mkN "behag" neutrum  ;
  begaer_nn_1_1_N = mkN "begär" neutrum  ;
  begynnelsespraak_nn_1_1_N = mkN "begynnelsespråk" neutrum  ;
  begrepp_nn_1_N = mkN "begrepp" neutrum  ;
  begravningstaag_nn_1_1_N = mkN "begravningståg" neutrum  ;
  begagnatkoep_nn_1_1_N = mkN "begagnatköp" neutrum  ;
  befaestningsverk_nn_1_1_N = mkN "befästningsverk" neutrum  ;
  befaestningsskydd_nn_1_1_N = mkN "befästningsskydd" neutrum  ;
  befaelsuppdrag_nn_1_1_N = mkN "befälsuppdrag" neutrum  ;
  befael_nn_1_1_N = mkN "befäl" neutrum  ;
  befruktningsoegonblick_nn_1_1_N = mkN "befruktningsögonblick" neutrum  ;
  befrielsekrig_nn_1_N = mkN "befrielsekrig" neutrum  ;
  bedoevningsmedel_nn_1_1_N = mkN "bedövningsmedel" neutrum  ;
  bedraegeribrott_nn_1_1_N = mkN "bedrägeribrott" neutrum  ;
  bebyggelsenamn_nn_1_N = mkN "bebyggelsenamn" neutrum  ;
  batongstaand_nn_1_1_N = mkN "batongstånd" neutrum  ;
  batongslag_nn_1_N = mkN "batongslag" neutrum  ;
  basaar_nn_1_1_N = mkN "basår" neutrum  ;
  bastubad_nn_1_N = mkN "bastubad" neutrum  ;
  bassetthorn_nn_1_N = mkN "bassetthorn" neutrum  ;
  baspar_nn_1_N = mkN "baspar" neutrum  ;
  baslaeger_nn_1_1_N = mkN "basläger" neutrum  ;
  basfiolsfodral_nn_1_N = mkN "basfiolsfodral" neutrum  ;
  basbelopp_nn_1_N = mkN "basbelopp" neutrum  ;
  barskaap_nn_1_1_N = mkN "barskåp" neutrum  ;
  barriaerrev_nn_1_1_N = mkN "barriärrev" neutrum  ;
  barr_nn_1_N = mkN "barr" neutrum  ;
  barometerstaand_nn_1_1_N = mkN "barometerstånd" neutrum  ;
  barometerfall_nn_1_N = mkN "barometerfall" neutrum  ;
  barnspraak_nn_1_1_N = mkN "barnspråk" neutrum  ;
  barnskrik_nn_1_N = mkN "barnskrik" neutrum  ;
  barnskratt_nn_1_N = mkN "barnskratt" neutrum  ;
  barnrov_nn_1_N = mkN "barnrov" neutrum  ;
  barnkorstaag_nn_1_1_N = mkN "barnkorståg" neutrum  ;
  barnkammarfoenster_nn_1_1_N = mkN "barnkammarfönster" neutrum  ;
  barnhusbarn_nn_1_N = mkN "barnhusbarn" neutrum  ;
  barnhemsbarn_nn_1_N = mkN "barnhemsbarn" neutrum  ;
  barndop_nn_1_N = mkN "barndop" neutrum  ;
  barndomstillstaand_nn_1_1_N = mkN "barndomstillstånd" neutrum  ;
  barnbidrag_nn_1_N = mkN "barnbidrag" neutrum  ;
  barnbesoek_nn_1_1_N = mkN "barnbesök" neutrum  ;
  barnbarnsbarn_nn_1_N = mkN "barnbarnsbarn" neutrum  ;
  barnbarn_nn_1_N = mkN "barnbarn" neutrum  ;
  barnarov_nn_1_N = mkN "barnarov" neutrum  ;
  barnamord_nn_1_N = mkN "barnamord" neutrum  ;
  barn_nn_1_N = mkN "barn" neutrum  ;
  barmhaertighetsverk_nn_1_1_N = mkN "barmhärtighetsverk" neutrum  ;
  barmhaertighetsmord_nn_1_1_N = mkN "barmhärtighetsmord" neutrum  ;
  barkskepp_nn_1_N = mkN "barkskepp" neutrum  ;
  barkbroed_nn_1_1_N = mkN "barkbröd" neutrum  ;
  bantuspraak_nn_1_1_N = mkN "bantuspråk" neutrum  ;
  bantufolk_nn_1_N = mkN "bantufolk" neutrum  ;
  bantningspiller_nn_1_N = mkN "bantningspiller" neutrum  ;
  bantningsmedel_nn_1_N = mkN "bantningsmedel" neutrum  ;
  bantlaer_nn_1_1_N = mkN "bantlär" neutrum  ;
  banrekord_nn_1_N = mkN "banrekord" neutrum  ;
  bann_nn_1_N = mkN "bann" neutrum  ;
  bankraan_nn_1_1_N = mkN "bankrån" neutrum  ;
  bankomatkort_nn_1_N = mkN "bankomatkort" neutrum  ;
  banklaan_nn_1_1_N = mkN "banklån" neutrum  ;
  bankkort_nn_1_N = mkN "bankkort" neutrum  ;
  bankkontor_nn_1_N = mkN "bankkontor" neutrum  ;
  bankfack_nn_1_N = mkN "bankfack" neutrum  ;
  banjoinstrument_nn_1_N = mkN "banjoinstrument" neutrum  ;
  banesaar_nn_1_1_N = mkN "banesår" neutrum  ;
  bandyslag_nn_1_N = mkN "bandyslag" neutrum  ;
  bandyroer_nn_1_1_N = mkN "bandyrör" neutrum  ;
  bandotek_nn_1_N = mkN "bandotek" neutrum  ;
  bandolaer_nn_1_1_N = mkN "bandolär" neutrum  ;
  bandjaern_nn_1_1_N = mkN "bandjärn" neutrum  ;
  banditgaeng_nn_1_1_N = mkN "banditgäng" neutrum  ;
  bandfordon_nn_1_N = mkN "bandfordon" neutrum  ;
  band_nn_1_N = mkN "band" neutrum  ;
  bamburoer_nn_1_1_N = mkN "bamburör" neutrum  ;
  balloptikon_nn_1_N = mkN "balloptikon" neutrum  ;
  ballongdaeck_nn_1_1_N = mkN "ballongdäck" neutrum  ;
  balkverk_nn_1_N = mkN "balkverk" neutrum  ;
  balkmaatt_nn_1_1_N = mkN "balkmått" neutrum  ;
  balkanfolk_nn_1_N = mkN "balkanfolk" neutrum  ;
  balansroder_nn_1_N = mkN "balansroder" neutrum  ;
  balansorgan_nn_1_N = mkN "balansorgan" neutrum  ;
  balansnummer_nn_1_N = mkN "balansnummer" neutrum  ;
  balanshjul_nn_1_N = mkN "balanshjul" neutrum  ;
  bakaatsteg_nn_1_1_N = mkN "bakåtsteg" neutrum  ;
  bakverk_nn_1_N = mkN "bakverk" neutrum  ;
  baksteg_nn_1_N = mkN "baksteg" neutrum  ;
  bakspaar_nn_1_1_N = mkN "bakspår" neutrum  ;
  bakslag_nn_1_N = mkN "bakslag" neutrum  ;
  bakpulver_nn_1_N = mkN "bakpulver" neutrum  ;
  bakplaatspapper_nn_1_1_N = mkN "bakplåtspapper" neutrum  ;
  bakhaall_nn_1_1_N = mkN "bakhåll" neutrum  ;
  bakhjul_nn_1_N = mkN "bakhjul" neutrum  ;
  bakgrundstal_nn_1_N = mkN "bakgrundstal" neutrum  ;
  bakgrundsljud_nn_1_N = mkN "bakgrundsljud" neutrum  ;
  bakdaeck_nn_1_1_N = mkN "bakdäck" neutrum  ;
  bakben_nn_1_N = mkN "bakben" neutrum  ;
  bakarv_nn_1_N = mkN "bakarv" neutrum  ;
  bak_nn_2_N = mkN "bak" neutrum  ;
  bagatellmaal_nn_1_1_N = mkN "bagatellmål" neutrum  ;
  badrumsskaap_nn_1_1_N = mkN "badrumsskåp" neutrum  ;
  badrumsgolv_nn_1_N = mkN "badrumsgolv" neutrum  ;
  badlakan_nn_1_N = mkN "badlakan" neutrum  ;
  badkar_nn_1_N = mkN "badkar" neutrum  ;
  bad_nn_1_N = mkN "bad" neutrum  ;
  backstag_nn_1_N = mkN "backstag" neutrum  ;
  backslag_nn_1_N = mkN "backslag" neutrum  ;
  backlandskap_nn_1_N = mkN "backlandskap" neutrum  ;
  backkroen_nn_1_1_N = mkN "backkrön" neutrum  ;
  axplock_nn_1_N = mkN "axplock" neutrum  ;
  axiom_nn_1_N = mkN "axiom" neutrum  ;
  axelset_nn_1_N = mkN "axelset" neutrum  ;
  axellager_nn_1_N = mkN "axellager" neutrum  ;
  axelhoelster_nn_1_1_N = mkN "axelhölster" neutrum  ;
  axelhaal_nn_1_1_N = mkN "axelhål" neutrum  ;
  axelgehaeng_nn_1_1_N = mkN "axelgehäng" neutrum  ;
  axelband_nn_1_N = mkN "axelband" neutrum  ;
  avvaegningsinstrument_nn_1_1_N = mkN "avvägningsinstrument" neutrum  ;
  avvisningsbeslut_nn_1_N = mkN "avvisningsbeslut" neutrum  ;
  avvecklingsbeslut_nn_1_N = mkN "avvecklingsbeslut" neutrum  ;
  avtaag_nn_1_1_N = mkN "avtåg" neutrum  ;
  avtryck_nn_1_N = mkN "avtryck" neutrum  ;
  avtalsbrott_nn_1_N = mkN "avtalsbrott" neutrum  ;
  avtal_nn_1_N = mkN "avtal" neutrum  ;
  avsaendarnummer_nn_1_1_N = mkN "avsändarnummer" neutrum  ;
  avstaand_nn_1_1_N = mkN "avstånd" neutrum  ;
  avsteg_nn_1_N = mkN "avsteg" neutrum  ;
  avstamp_nn_1_N = mkN "avstamp" neutrum  ;
  avspaerrningsband_nn_1_1_N = mkN "avspärrningsband" neutrum  ;
  avspraang_nn_1_1_N = mkN "avsprång" neutrum  ;
  avsnitt_nn_1_N = mkN "avsnitt" neutrum  ;
  avslut_nn_1_N = mkN "avslut" neutrum  ;
  avslag_nn_1_N = mkN "avslag" neutrum  ;
  avskrivningsobjekt_nn_1_N = mkN "avskrivningsobjekt" neutrum  ;
  avskedstal_nn_1_N = mkN "avskedstal" neutrum  ;
  avskedsord_nn_1_N = mkN "avskedsord" neutrum  ;
  avskedsknull_nn_1_N = mkN "avskedsknull" neutrum  ;
  avskedsbrev_nn_1_N = mkN "avskedsbrev" neutrum  ;
  avsked_nn_1_N = mkN "avsked" neutrum  ;
  avrop_nn_1_N = mkN "avrop" neutrum  ;
  avlusningsmedel_nn_1_N = mkN "avlusningsmedel" neutrum  ;
  avloppsroer_nn_1_1_N = mkN "avloppsrör" neutrum  ;
  avloppsledningsroer_nn_1_1_N = mkN "avloppsledningsrör" neutrum  ;
  avlopp_nn_1_N = mkN "avlopp" neutrum  ;
  avljud_nn_1_N = mkN "avljud" neutrum  ;
  avlatsbrev_nn_1_N = mkN "avlatsbrev" neutrum  ;
  avkok_nn_1_N = mkN "avkok" neutrum  ;
  avknoppningsfoeretag_nn_1_1_N = mkN "avknoppningsföretag" neutrum  ;
  avkastningskrav_nn_1_N = mkN "avkastningskrav" neutrum  ;
  avisofartyg_nn_1_N = mkN "avisofartyg" neutrum  ;
  avhaall_nn_1_1_N = mkN "avhåll" neutrum  ;
  avhopp_nn_1_N = mkN "avhopp" neutrum  ;
  avgaangsvederlag_nn_1_1_N = mkN "avgångsvederlag" neutrum  ;
  avgaangskrav_nn_1_1_N = mkN "avgångskrav" neutrum  ;
  avgaangsbidrag_nn_1_1_N = mkN "avgångsbidrag" neutrum  ;
  avgaangsbetyg_nn_1_1_N = mkN "avgångsbetyg" neutrum  ;
  avgrundsdjup_nn_1_N = mkN "avgrundsdjup" neutrum  ;
  avgasroer_nn_1_1_N = mkN "avgasrör" neutrum  ;
  avfoeringsmedel_nn_1_1_N = mkN "avföringsmedel" neutrum  ;
  avflyttningsfoerbud_nn_1_1_N = mkN "avflyttningsförbud" neutrum  ;
  avfettningsmedel_nn_1_N = mkN "avfettningsmedel" neutrum  ;
  avfallsupplag_nn_1_N = mkN "avfallsupplag" neutrum  ;
  avfall_nn_1_N = mkN "avfall" neutrum  ;
  avelsdjur_nn_1_N = mkN "avelsdjur" neutrum  ;
  avdrag_nn_1_N = mkN "avdrag" neutrum  ;
  avdelningskontor_nn_1_N = mkN "avdelningskontor" neutrum  ;
  avbraeck_nn_1_1_N = mkN "avbräck" neutrum  ;
  avbrott_nn_1_N = mkN "avbrott" neutrum  ;
  avbetalningsarrangemang_nn_1_N = mkN "avbetalningsarrangemang" neutrum  ;
  avancemang_nn_1_N = mkN "avancemang" neutrum  ;
  automatgevaer_nn_1_1_N = mkN "automatgevär" neutrum  ;
  auktionsverk_nn_1_N = mkN "auktionsverk" neutrum  ;
  augustipaeron_nn_1_1_N = mkN "augustipäron" neutrum  ;
  augment_nn_1_N = mkN "augment" neutrum  ;
  augiasstall_nn_1_N = mkN "augiasstall" neutrum  ;
  attribut_nn_1_N = mkN "attribut" neutrum  ;
  attentat_nn_1_N = mkN "attentat" neutrum  ;
  attackplan_nn_1_N = mkN "attackplan" neutrum  ;
  attackflygplan_nn_1_N = mkN "attackflygplan" neutrum  ;
  attackflyg_nn_1_N = mkN "attackflyg" neutrum  ;
  atomur_nn_1_N = mkN "atomur" neutrum  ;
  atomnummer_nn_1_N = mkN "atomnummer" neutrum  ;
  atomkraftmikroskop_nn_1_N = mkN "atomkraftmikroskop" neutrum  ;
  atomenergiorgan_nn_1_N = mkN "atomenergiorgan" neutrum  ;
  atmosfaerstryck_nn_1_1_N = mkN "atmosfärstryck" neutrum  ;
  atmosfaerslager_nn_1_1_N = mkN "atmosfärslager" neutrum  ;
  atelj_efoenster_nn_1_1_N = mkN "ateljéfönster" neutrum  ;
  asteroidnedfall_nn_1_N = mkN "asteroidnedfall" neutrum  ;
  asploev_nn_1_1_N = mkN "asplöv" neutrum  ;
  askregn_nn_1_N = mkN "askregn" neutrum  ;
  askmoln_nn_1_N = mkN "askmoln" neutrum  ;
  askhot_nn_1_N = mkN "askhot" neutrum  ;
  askfat_nn_1_N = mkN "askfat" neutrum  ;
  arvsanspraak_nn_1_1_N = mkN "arvsanspråk" neutrum  ;
  arvsanlag_nn_1_N = mkN "arvsanlag" neutrum  ;
  arvord_nn_1_N = mkN "arvord" neutrum  ;
  arv_nn_1_N = mkN "arv" neutrum  ;
  artotek_nn_1_N = mkN "artotek" neutrum  ;
  artnamn_nn_1_N = mkN "artnamn" neutrum  ;
  artistnamn_nn_1_N = mkN "artistnamn" neutrum  ;
  artillerimanskap_nn_1_N = mkN "artillerimanskap" neutrum  ;
  artillerifoerband_nn_1_1_N = mkN "artilleriförband" neutrum  ;
  arrendekontrakt_nn_1_N = mkN "arrendekontrakt" neutrum  ;
  arrangemang_nn_1_N = mkN "arrangemang" neutrum  ;
  arr_nn_1_N = mkN "arr" neutrum  ;
  arm_egevaer_nn_1_1_N = mkN "armégevär" neutrum  ;
  arm_efoerband_nn_1_1_N = mkN "arméförband" neutrum  ;
  armveck_nn_1_N = mkN "armveck" neutrum  ;
  armtag_nn_1_N = mkN "armtag" neutrum  ;
  armstoed_nn_1_1_N = mkN "armstöd" neutrum  ;
  armhaalsstoed_nn_1_1_N = mkN "armhålsstöd" neutrum  ;
  armeringsjaern_nn_1_1_N = mkN "armeringsjärn" neutrum  ;
  armbaagsutskott_nn_1_1_N = mkN "armbågsutskott" neutrum  ;
  armbaagsskydd_nn_1_1_N = mkN "armbågsskydd" neutrum  ;
  armbaagsben_nn_1_1_N = mkN "armbågsben" neutrum  ;
  armbrott_nn_1_N = mkN "armbrott" neutrum  ;
  armbandsur_nn_1_N = mkN "armbandsur" neutrum  ;
  armband_nn_1_N = mkN "armband" neutrum  ;
  arkivexemplar_nn_1_N = mkN "arkivexemplar" neutrum  ;
  ark_nn_1_N = mkN "ark" neutrum  ;
  argument_nn_1_N = mkN "argument" neutrum  ;
  arbetsaar_nn_1_1_N = mkN "arbetsår" neutrum  ;
  arbetsvillkor_nn_1_N = mkN "arbetsvillkor" neutrum  ;
  arbetsverktyg_nn_1_N = mkN "arbetsverktyg" neutrum  ;
  arbetsutskott_nn_1_N = mkN "arbetsutskott" neutrum  ;
  arbetstillstaand_nn_1_1_N = mkN "arbetstillstånd" neutrum  ;
  arbetssaett_nn_1_1_N = mkN "arbetssätt" neutrum  ;
  arbetsredskap_nn_1_N = mkN "arbetsredskap" neutrum  ;
  arbetsnamn_nn_1_N = mkN "arbetsnamn" neutrum  ;
  arbetsmoment_nn_1_N = mkN "arbetsmoment" neutrum  ;
  arbetsmiljoemaal_nn_1_1_N = mkN "arbetsmiljömål" neutrum  ;
  arbetsmiljoebrott_nn_1_1_N = mkN "arbetsmiljöbrott" neutrum  ;
  arbetsmaterial_nn_1_N = mkN "arbetsmaterial" neutrum  ;
  arbetslaeger_nn_1_1_N = mkN "arbetsläger" neutrum  ;
  arbetslag_nn_1_N = mkN "arbetslag" neutrum  ;
  arbetsklimat_nn_1_N = mkN "arbetsklimat" neutrum  ;
  arbetshandikapp_nn_1_N = mkN "arbetshandikapp" neutrum  ;
  arbetsfaelt_nn_1_1_N = mkN "arbetsfält" neutrum  ;
  arbetsdjur_nn_1_N = mkN "arbetsdjur" neutrum  ;
  arbetsbord_nn_1_N = mkN "arbetsbord" neutrum  ;
  arbetsavtal_nn_1_N = mkN "arbetsavtal" neutrum  ;
  arbetaruppror_nn_1_N = mkN "arbetaruppror" neutrum  ;
  arbetarraad_nn_1_1_N = mkN "arbetarråd" neutrum  ;
  arbetarinstitut_nn_1_N = mkN "arbetarinstitut" neutrum  ;
  aprilvaeder_nn_1_1_N = mkN "aprilväder" neutrum  ;
  aprilskaemt_nn_1_1_N = mkN "aprilskämt" neutrum  ;
  approbatur_nn_1_N = mkN "approbatur" neutrum  ;
  apotek_nn_1_N = mkN "apotek" neutrum  ;
  aplik_nn_1_N = mkN "aplik" neutrum  ;
  apelsinskal_nn_1_N = mkN "apelsinskal" neutrum  ;
  anvaendningssaett_nn_1_1_N = mkN "användningssätt" neutrum  ;
  antaag_nn_1_1_N = mkN "antåg" neutrum  ;
  antivibrationshandtag_nn_1_N = mkN "antivibrationshandtag" neutrum  ;
  antistatmedel_nn_1_N = mkN "antistatmedel" neutrum  ;
  antioxidationsmedel_nn_1_N = mkN "antioxidationsmedel" neutrum  ;
  antikvariat_nn_1_N = mkN "antikvariat" neutrum  ;
  antennuttag_nn_1_N = mkN "antennuttag" neutrum  ;
  anteckningsblock_nn_1_N = mkN "anteckningsblock" neutrum  ;
  antal_nn_1_N = mkN "antal" neutrum  ;
  ansoekningspapper_nn_1_1_N = mkN "ansökningspapper" neutrum  ;
  anstaand_nn_1_1_N = mkN "anstånd" neutrum  ;
  anstaellningsstopp_nn_1_1_N = mkN "anställningsstopp" neutrum  ;
  anstaellningsskydd_nn_1_1_N = mkN "anställningsskydd" neutrum  ;
  anstaellningskontrakt_nn_1_1_N = mkN "anställningskontrakt" neutrum  ;
  anstaellningsavtal_nn_1_1_N = mkN "anställningsavtal" neutrum  ;
  anspraak_nn_1_1_N = mkN "anspråk" neutrum  ;
  anspann_nn_1_N = mkN "anspann" neutrum  ;
  anslutningsavtal_nn_1_N = mkN "anslutningsavtal" neutrum  ;
  anslag_nn_1_N = mkN "anslag" neutrum  ;
  ansiktsuttryck_nn_1_N = mkN "ansiktsuttryck" neutrum  ;
  ansiktsskydd_nn_1_N = mkN "ansiktsskydd" neutrum  ;
  ansiktslyft_nn_1_N = mkN "ansiktslyft" neutrum  ;
  ansiktsdrag_nn_1_N = mkN "ansiktsdrag" neutrum  ;
  anropsnummer_nn_1_N = mkN "anropsnummer" neutrum  ;
  anrop_nn_1_N = mkN "anrop" neutrum  ;
  anonymiseringsverktyg_nn_1_N = mkN "anonymiseringsverktyg" neutrum  ;
  annuitetslaan_nn_1_1_N = mkN "annuitetslån" neutrum  ;
  annonssvar_nn_1_N = mkN "annonssvar" neutrum  ;
  anlopp_nn_1_N = mkN "anlopp" neutrum  ;
  anletsdrag_nn_1_N = mkN "anletsdrag" neutrum  ;
  anlag_nn_1_N = mkN "anlag" neutrum  ;
  ankaegg_nn_1_1_N = mkN "ankägg" neutrum  ;
  ankarslut_nn_1_N = mkN "ankarslut" neutrum  ;
  ankarjaern_nn_1_1_N = mkN "ankarjärn" neutrum  ;
  anhang_nn_1_N = mkN "anhang" neutrum  ;
  angreppssaett_nn_1_1_N = mkN "angreppssätt" neutrum  ;
  angrepp_nn_1_N = mkN "angrepp" neutrum  ;
  angivelsebrott_nn_1_N = mkN "angivelsebrott" neutrum  ;
  anfoeringsverb_nn_1_1_N = mkN "anföringsverb" neutrum  ;
  anflog_nn_1_N = mkN "anflog" neutrum  ;
  anfallskrig_nn_1_N = mkN "anfallskrig" neutrum  ;
  anfall_nn_1_N = mkN "anfall" neutrum  ;
  andstraeck_nn_1_1_N = mkN "andsträck" neutrum  ;
  andranamn_nn_1_N = mkN "andranamn" neutrum  ;
  andrahandsval_nn_1_N = mkN "andrahandsval" neutrum  ;
  andrahandsfoeremaal_nn_1_1_N = mkN "andrahandsföremål" neutrum  ;
  andrag_nn_1_N = mkN "andrag" neutrum  ;
  andningsuppehaall_nn_1_1_N = mkN "andningsuppehåll" neutrum  ;
  andningsskydd_nn_1_N = mkN "andningsskydd" neutrum  ;
  andningsroer_nn_1_1_N = mkN "andningsrör" neutrum  ;
  andningsorgan_nn_1_N = mkN "andningsorgan" neutrum  ;
  andningshaal_nn_1_1_N = mkN "andningshål" neutrum  ;
  andhaal_nn_1_1_N = mkN "andhål" neutrum  ;
  andetag_nn_1_N = mkN "andetag" neutrum  ;
  andedrag_nn_1_N = mkN "andedrag" neutrum  ;
  anbud_nn_1_N = mkN "anbud" neutrum  ;
  anbrott_nn_1_N = mkN "anbrott" neutrum  ;
  analogislut_nn_1_N = mkN "analogislut" neutrum  ;
  amt_nn_1_N = mkN "amt" neutrum  ;
  amperevarv_nn_1_N = mkN "amperevarv" neutrum  ;
  amorteringslaan_nn_1_1_N = mkN "amorteringslån" neutrum  ;
  amfibieplan_nn_1_N = mkN "amfibieplan" neutrum  ;
  amfetaminbeslag_nn_1_N = mkN "amfetaminbeslag" neutrum  ;
  amendemang_nn_1_N = mkN "amendemang" neutrum  ;
  ambulansflyg_nn_1_N = mkN "ambulansflyg" neutrum  ;
  ambassadraad_nn_1_1_N = mkN "ambassadråd" neutrum  ;
  amatoerteleskop_nn_1_1_N = mkN "amatörteleskop" neutrum  ;
  amatoerprojekt_nn_1_1_N = mkN "amatörprojekt" neutrum  ;
  alveolarben_nn_1_N = mkN "alveolarben" neutrum  ;
  aluminiumsmaeltverk_nn_1_1_N = mkN "aluminiumsmältverk" neutrum  ;
  aluminiumpulver_nn_1_N = mkN "aluminiumpulver" neutrum  ;
  aluminiumnaet_nn_1_1_N = mkN "aluminiumnät" neutrum  ;
  althorn_nn_1_N = mkN "althorn" neutrum  ;
  altarskaap_nn_1_1_N = mkN "altarskåp" neutrum  ;
  altarbrun_nn_1_N = mkN "altarbrun" neutrum  ;
  altarbord_nn_1_N = mkN "altarbord" neutrum  ;
  alster_nn_1_N = mkN "alster" neutrum  ;
  alspaan_nn_1_1_N = mkN "alspån" neutrum  ;
  alphorn_nn_1_N = mkN "alphorn" neutrum  ;
  almanacksblad_nn_1_N = mkN "almanacksblad" neutrum  ;
  allvaedersskydd_nn_1_1_N = mkN "allvädersskydd" neutrum  ;
  allvarsord_nn_1_N = mkN "allvarsord" neutrum  ;
  allting_nn_1_N = mkN "allting" neutrum  ;
  allshaerjarting_nn_1_1_N = mkN "allshärjarting" neutrum  ;
  allmaenbegrepp_nn_1_1_N = mkN "allmänbegrepp" neutrum  ;
  allkonstverk_nn_1_N = mkN "allkonstverk" neutrum  ;
  allegat_nn_1_N = mkN "allegat" neutrum  ;
  alfasoenderfall_nn_1_1_N = mkN "alfasönderfall" neutrum  ;
  alfabet_nn_1_N = mkN "alfabet" neutrum  ;
  alarm_nn_1_N = mkN "alarm" neutrum  ;
  alanin_nn_1_N = mkN "alanin" neutrum  ;
  akutfall_nn_1_N = mkN "akutfall" neutrum  ;
  aktiveringsmoenster_nn_1_1_N = mkN "aktiveringsmönster" neutrum  ;
  aktionssaett_nn_1_1_N = mkN "aktionssätt" neutrum  ;
  aktieinnehav_nn_1_N = mkN "aktieinnehav" neutrum  ;
  aktiebrev_nn_1_N = mkN "aktiebrev" neutrum  ;
  aktiebolag_nn_1_N = mkN "aktiebolag" neutrum  ;
  akterskepp_nn_1_N = mkN "akterskepp" neutrum  ;
  akterlik_nn_1_N = mkN "akterlik" neutrum  ;
  akterdaeck_nn_1_1_N = mkN "akterdäck" neutrum  ;
  akantusblad_nn_1_N = mkN "akantusblad" neutrum  ;
  aikidotrick_nn_1_N = mkN "aikidotrick" neutrum  ;
  agremang_nn_1_N = mkN "agremang" neutrum  ;
  agrarfoerbund_nn_1_1_N = mkN "agrarförbund" neutrum  ;
  agn_nn_1_N = mkN "agn" neutrum  ;
  aggregationstillstaand_nn_1_1_N = mkN "aggregationstillstånd" neutrum  ;
  aggregat_nn_1_N = mkN "aggregat" neutrum  ;
  agglomerat_nn_1_N = mkN "agglomerat" neutrum  ;
  aftonmaal_nn_1_1_N = mkN "aftonmål" neutrum  ;
  affaersverk_nn_1_1_N = mkN "affärsverk" neutrum  ;
  affaersstraak_nn_1_1_N = mkN "affärsstråk" neutrum  ;
  affaersliv_nn_1_1_N = mkN "affärsliv" neutrum  ;
  affaersfoerslag_nn_1_1_N = mkN "affärsförslag" neutrum  ;
  affaersfoeretag_nn_1_1_N = mkN "affärsföretag" neutrum  ;
  affaersdistrikt_nn_1_1_N = mkN "affärsdistrikt" neutrum  ;
  affaersbrev_nn_1_1_N = mkN "affärsbrev" neutrum  ;
  affaersavtal_nn_1_1_N = mkN "affärsavtal" neutrum  ;
  affischnamn_nn_1_N = mkN "affischnamn" neutrum  ;
  affidavit_nn_1_N = mkN "affidavit" neutrum  ;
  aeroplan_nn_1_N = mkN "aeroplan" neutrum  ;
  advokatkontor_nn_1_N = mkN "advokatkontor" neutrum  ;
  adverbial_nn_1_N = mkN "adverbial" neutrum  ;
  adverb_nn_1_N = mkN "adverb" neutrum  ;
  adresskort_nn_1_N = mkN "adresskort" neutrum  ;
  adoptivbarn_nn_1_N = mkN "adoptivbarn" neutrum  ;
  adjektivattribut_nn_1_N = mkN "adjektivattribut" neutrum  ;
  adelsbrev_nn_1_N = mkN "adelsbrev" neutrum  ;
  additament_nn_1_N = mkN "additament" neutrum  ;
  ackusativobjekt_nn_1_N = mkN "ackusativobjekt" neutrum  ;
  ackordgrepp_nn_1_N = mkN "ackordgrepp" neutrum  ;
  ackord_nn_2_N = mkN "ackord" neutrum  ;
  ackord_nn_1_N = mkN "ackord" neutrum  ;
  ackompanjemang_nn_1_N = mkN "ackompanjemang" neutrum  ;
  acerolakoersbaer_nn_1_1_N = mkN "acerolakörsbär" neutrum  ;
  accidenstryck_nn_1_N = mkN "accidenstryck" neutrum  ;
  accelerationsfaelt_nn_1_1_N = mkN "accelerationsfält" neutrum  ;
  absolutivsubjekt_nn_1_N = mkN "absolutivsubjekt" neutrum  ;
  absolutivobjekt_nn_1_N = mkN "absolutivobjekt" neutrum  ;
  absolutbelopp_nn_1_N = mkN "absolutbelopp" neutrum  ;
  abortpiller_nn_1_N = mkN "abortpiller" neutrum  ;
  abortmotstaand_nn_1_1_N = mkN "abortmotstånd" neutrum  ;
  abonnemang_nn_1_N = mkN "abonnemang" neutrum  ;
  aber_nn_1_N = mkN "aber" neutrum  ;
  abdikationshot_nn_1_N = mkN "abdikationshot" neutrum  ;
  _15_aarsstraff_nn_1_1_N = mkN "15-årsstraff" neutrum  ;
  Visakort_nn_1_N = mkN "Visakort" neutrum  ;
  Visa_kort_nn_1_N = mkN "Visa-kort" neutrum  ;
  Vietnamkrig_nn_1_N = mkN "Vietnamkrig" neutrum  ;
  Tjernobylnedfall_nn_1_N = mkN "Tjernobylnedfall" neutrum  ;
  TV_abonnemang_nn_1_N = mkN "TV-abonnemang" neutrum  ;
  Sverigemaesterskap_nn_1_1_N = mkN "Sverigemästerskap" neutrum  ;
  RUT_avdrag_nn_1_N = mkN "RUT-avdrag" neutrum  ;
  ROT_avdrag_nn_1_N = mkN "ROT-avdrag" neutrum  ;
  PCB_foerbud_nn_1_1_N = mkN "PCB-förbud" neutrum  ;
  Osloavtal_nn_1_N = mkN "Osloavtal" neutrum  ;
  Natomedlemskap_nn_1_N = mkN "Natomedlemskap" neutrum  ;
  Koepenhamnsackord_nn_1_1_N = mkN "Köpenhamnsackord" neutrum  ;
  Koechelnummer_nn_1_1_N = mkN "Köchelnummer" neutrum  ;
  Koranbaal_nn_1_1_N = mkN "Koranbål" neutrum  ;
  Kinabesoek_nn_1_1_N = mkN "Kinabesök" neutrum  ;
  Kairobesoek_nn_1_1_N = mkN "Kairobesök" neutrum  ;
  IT_foeretag_nn_1_1_N = mkN "IT-företag" neutrum  ;
  IP_nummer_nn_1_N = mkN "IP-nummer" neutrum  ;
  ID_kort_nn_1_N = mkN "ID-kort" neutrum  ;
  Gripenplan_nn_1_N = mkN "Gripenplan" neutrum  ;
  FN_organ_nn_1_N = mkN "FN-organ" neutrum  ;
  EU_val_nn_1_N = mkN "EU-val" neutrum  ;
  EU_parlament_nn_1_N = mkN "EU-parlament" neutrum  ;
  Antarktisfoerdrag_nn_1_1_N = mkN "Antarktisfördrag" neutrum  ;
  Almedalstal_nn_1_N = mkN "Almedalstal" neutrum  ;
  Almedalental_nn_1_N = mkN "Almedalental" neutrum  ;
  Alexanderhugg_nn_1_N = mkN "Alexanderhugg" neutrum  ;
  vikande_nn_1_N = mkN "vikande" ;
  vikarierande_nn_1_N = mkN "vikarierande" ;
  viktande_nn_1_N = mkN "viktande" ;
  vilande_nn_1_N = mkN "vilande" ;
  viljande_nn_1_N = mkN "viljande" ;
  villfarande_nn_1_N = mkN "villfarande" ;
  villkorande_nn_1_N = mkN "villkorande" ;
  vilsefoerande_nn_1_1_N = mkN "vilseförande" ;
  vilseledande_nn_1_N = mkN "vilseledande" ;
  vimlande_nn_1_N = mkN "vimlande" ;
  vimsande_nn_1_N = mkN "vimsande" ;
  vinande_nn_1_N = mkN "vinande" ;
  vindande_nn_1_N = mkN "vindande" ;
  vindfoerhaallande_nn_1_1_N = mkN "vindförhållande" ;
  vindicerande_nn_1_N = mkN "vindicerande" ;
  vindlande_nn_1_N = mkN "vindlande" ;
  vindpollinerande_nn_1_N = mkN "vindpollinerande" ;
  vindsurfande_nn_1_N = mkN "vindsurfande" ;
  vinglande_nn_1_N = mkN "vinglande" ;
  vinkande_nn_1_N = mkN "vinkande" ;
  vinklande_nn_1_N = mkN "vinklande" ;
  vinnande_nn_1_N = mkN "vinnande" ;
  vinschande_nn_1_N = mkN "vinschande" ;
  vinstmaximerande_nn_1_N = mkN "vinstmaximerande" ;
  vinstvarnande_nn_1_N = mkN "vinstvarnande" ;
  vinterbadande_nn_1_N = mkN "vinterbadande" ;
  vinterbonande_nn_1_N = mkN "vinterbonande" ;
  vinteraepple_nn_1_1_N = mkN "vinteräpple" ;
  vippande_nn_1_N = mkN "vippande" ;
  virande_nn_1_N = mkN "virande" ;
  virkande_nn_1_N = mkN "virkande" ;
  virrande_nn_1_N = mkN "virrande" ;
  virvlande_nn_1_N = mkN "virvlande" ;
  visande_nn_1_N = mkN "visande" ;
  viserande_nn_1_N = mkN "viserande" ;
  visiterande_nn_1_N = mkN "visiterande" ;
  viskande_nn_1_N = mkN "viskande" ;
  vispande_nn_1_N = mkN "vispande" ;
  visslande_nn_1_N = mkN "visslande" ;
  vissnande_nn_1_N = mkN "vissnande" ;
  visstidsfoerordnande_nn_1_1_N = mkN "visstidsförordnande" ;
  visualiserande_nn_1_N = mkN "visualiserande" ;
  vitaliserande_nn_1_N = mkN "vitaliserande" ;
  vitaminerande_nn_1_N = mkN "vitaminerande" ;
  vitaminiserande_nn_1_N = mkN "vitaminiserande" ;
  vitesfoerelaeggande_nn_1_1_N = mkN "vitesföreläggande" ;
  vitgloedgande_nn_1_1_N = mkN "vitglödgande" ;
  vitkalkande_nn_1_N = mkN "vitkalkande" ;
  vitlimmande_nn_1_N = mkN "vitlimmande" ;
  vitmenande_nn_1_N = mkN "vitmenande" ;
  vitnande_nn_1_N = mkN "vitnande" ;
  vitrande_nn_1_N = mkN "vitrande" ;
  vitsande_nn_1_N = mkN "vitsande" ;
  vitsordande_nn_1_N = mkN "vitsordande" ;
  vittande_nn_1_N = mkN "vittande" ;
  vittjande_nn_1_N = mkN "vittjande" ;
  vittnande_nn_1_N = mkN "vittnande" ;
  vittrande_nn_1_N = mkN "vittrande" ;
  vokaliserande_nn_1_N = mkN "vokaliserande" ;
  volmande_nn_1_N = mkN "volmande" ;
  voltande_nn_1_N = mkN "voltande" ;
  voltigerande_nn_1_N = mkN "voltigerande" ;
  vomerande_nn_1_N = mkN "vomerande" ;
  voterande_nn_1_N = mkN "voterande" ;
  vrakande_nn_1_N = mkN "vrakande" ;
  vrickande_nn_1_N = mkN "vrickande" ;
  vridande_nn_1_N = mkN "vridande" ;
  vraekande_nn_1_1_N = mkN "vräkande" ;
  vraengande_nn_1_1_N = mkN "vrängande" ;
  vraalande_nn_1_1_N = mkN "vrålande" ;
  vraalpluggande_nn_1_1_N = mkN "vrålpluggande" ;
  vroevlande_nn_1_1_N = mkN "vrövlande" ;
  vulande_nn_1_N = mkN "vulande" ;
  vulgariserande_nn_1_N = mkN "vulgariserande" ;
  vulkande_nn_1_N = mkN "vulkande" ;
  vulkaniserande_nn_1_N = mkN "vulkaniserande" ;
  vurmande_nn_1_N = mkN "vurmande" ;
  vurpande_nn_1_N = mkN "vurpande" ;
  vyssande_nn_1_N = mkN "vyssande" ;
  vyssjande_nn_1_N = mkN "vyssjande" ;
  vaeckande_nn_1_1_N = mkN "väckande" ;
  vaederfoerhaallande_nn_1_1_N = mkN "väderförhållande" ;
  vaedjande_nn_1_1_N = mkN "vädjande" ;
  vaedrande_nn_1_1_N = mkN "vädrande" ;
  vaegande_nn_1_1_N = mkN "vägande" ;
  vaeggfaeste_nn_1_1_N = mkN "väggfäste" ;
  vaeggmonterande_nn_1_1_N = mkN "väggmonterande" ;
  vaegledande_nn_1_1_N = mkN "vägledande" ;
  vaegrande_nn_1_1_N = mkN "vägrande" ;
  vaejande_nn_1_1_N = mkN "väjande" ;
  vaelfaegnande_nn_1_1_N = mkN "välfägnande" ;
  vaeljande_nn_1_1_N = mkN "väljande" ;
  vaellande_nn_1_1_N = mkN "vällande" ;
  vaelsignande_nn_1_1_N = mkN "välsignande" ;
  vaeltande_nn_1_1_N = mkN "vältande" ;
  vaeltrande_nn_1_1_N = mkN "vältrande" ;
  vaelvande_nn_1_1_N = mkN "välvande" ;
  vaemjande_nn_1_1_N = mkN "vämjande" ;
  vaendande_nn_1_1_N = mkN "vändande" ;
  vaenjande_nn_1_1_N = mkN "vänjande" ;
  vaensterfaeste_nn_1_1_N = mkN "vänsterfäste" ;
  vaensterknaeckande_nn_1_1_N = mkN "vänsterknäckande" ;
  vaensterprasslande_nn_1_1_N = mkN "vänsterprasslande" ;
  vaenstrande_nn_1_1_N = mkN "vänstrande" ;
  vaentande_nn_1_1_N = mkN "väntande" ;
  vaepnande_nn_1_1_N = mkN "väpnande" ;
  vaerde_nn_1_1_N = mkN "värde" ;
  vaerderande_nn_1_1_N = mkN "värderande" ;
  vaerdesaekrande_nn_1_1_N = mkN "värdesäkrande" ;
  vaerdesaettande_nn_1_1_N = mkN "värdesättande" ;
  vaerjande_nn_1_1_N = mkN "värjande" ;
  vaerkande_nn_1_1_N = mkN "värkande" ;
  vaermande_nn_1_1_N = mkN "värmande" ;
  vaermebehandlande_nn_1_1_N = mkN "värmebehandlande" ;
  vaermefotograferande_nn_1_1_N = mkN "värmefotograferande" ;
  vaermeisolerande_nn_1_1_N = mkN "värmeisolerande" ;
  vaermesteriliserande_nn_1_1_N = mkN "värmesteriliserande" ;
  vaernande_nn_1_1_N = mkN "värnande" ;
  vaerpande_nn_1_1_N = mkN "värpande" ;
  vaervande_nn_1_1_N = mkN "värvande" ;
  vaesende_nn_1_1_N = mkN "väsende" ;
  vaessande_nn_1_1_N = mkN "vässande" ;
  vaetande_nn_1_1_N = mkN "vätande" ;
  vaetskande_nn_1_1_N = mkN "vätskande" ;
  vaevande_nn_1_1_N = mkN "vävande" ;
  vaexande_nn_1_1_N = mkN "växande" ;
  vaexelverkande_nn_1_1_N = mkN "växelverkande" ;
  vaexlande_nn_1_1_N = mkN "växlande" ;
  vaadaskjutande_nn_1_1_N = mkN "vådaskjutande" ;
  vaagande_nn_1_1_N = mkN "vågande" ;
  vaagfoerande_nn_1_1_N = mkN "vågförande" ;
  vaaldgaestande_nn_1_1_N = mkN "våldgästande" ;
  vaaldtagande_nn_1_1_N = mkN "våldtagande" ;
  vaalmande_nn_1_1_N = mkN "vålmande" ;
  vaannande_nn_1_1_N = mkN "vånnande" ;
  vaarande_nn_1_1_N = mkN "vårande" ;
  vaardande_nn_1_1_N = mkN "vårdande" ;
  vaardberoende_nn_1_1_N = mkN "vårdberoende" ;
  vaardsloesande_nn_1_1_N = mkN "vårdslösande" ;
  vaatkolande_nn_1_1_N = mkN "våtkolande" ;
  vaatpressande_nn_1_1_N = mkN "våtpressande" ;
  voerdande_nn_1_1_N = mkN "vördande" ;
  x_ande_nn_1_N = mkN "x-ande" ;
  xande_nn_1_N = mkN "x:ande" ;
  ylande_nn_1_N = mkN "ylande" ;
  ympande_nn_1_N = mkN "ympande" ;
  ynglande_nn_1_N = mkN "ynglande" ;
  ynkande_nn_1_N = mkN "ynkande" ;
  yppande_nn_1_N = mkN "yppande" ;
  yrande_nn_1_N = mkN "yrande" ;
  yrkande_nn_1_N = mkN "yrkande" ;
  ystande_nn_1_N = mkN "ystande" ;
  ytbehandlande_nn_1_N = mkN "ytbehandlande" ;
  yttrande_nn_1_N = mkN "yttrande" ;
  zappande_nn_1_N = mkN "zappande" ;
  zoomande_nn_1_N = mkN "zoomande" ;
  aecklande_nn_1_1_N = mkN "äcklande" ;
  aegande_nn_1_1_N = mkN "ägande" ;
  aegandefoerhaallande_nn_1_1_N = mkN "ägandeförhållande" ;
  aegnande_nn_1_1_N = mkN "ägnande" ;
  aektande_nn_1_1_N = mkN "äktande" ;
  aeldreboende_nn_1_1_N = mkN "äldreboende" ;
  aelgande_nn_1_1_N = mkN "älgande" ;
  aelskande_nn_1_1_N = mkN "älskande" ;
  aeltande_nn_1_1_N = mkN "ältande" ;
  aembetsaaliggande_nn_1_1_N = mkN "ämbetsåliggande" ;
  aemnande_nn_1_1_N = mkN "ämnande" ;
  aemnesintegrerande_nn_1_1_N = mkN "ämnesintegrerande" ;
  aendamaalsenlighetsavvaegande_nn_1_1_N = mkN "ändamålsenlighetsavvägande" ;
  aendande_nn_1_1_N = mkN "ändande" ;
  aendrande_nn_1_1_N = mkN "ändrande" ;
  aendvaendande_nn_1_1_N = mkN "ändvändande" ;
  aengslande_nn_1_1_N = mkN "ängslande" ;
  aentrande_nn_1_1_N = mkN "äntrande" ;
  aepple_nn_1_1_N = mkN "äpple" ;
  aerande_nn_1_1_N = mkN "ärande" ;
  aerekraenkande_nn_1_1_N = mkN "ärekränkande" ;
  aerende_nn_1_1_N = mkN "ärende" ;
  aergande_nn_1_1_N = mkN "ärgande" ;
  aerjande_nn_1_1_N = mkN "ärjande" ;
  aernande_nn_1_1_N = mkN "ärnande" ;
  aervande_nn_1_1_N = mkN "ärvande" ;
  aeskande_nn_1_1_N = mkN "äskande" ;
  aetande_nn_1_1_N = mkN "ätande" ;
  aeventyrande_nn_1_1_N = mkN "äventyrande" ;
  aaberopande_nn_1_1_N = mkN "åberopande" ;
  aadagalaeggande_nn_1_1_N = mkN "ådagaläggande" ;
  aaderlaatande_nn_1_1_N = mkN "åderlåtande" ;
  aadragande_nn_1_1_N = mkN "ådragande" ;
  aadrande_nn_1_1_N = mkN "ådrande" ;
  aadoemande_nn_1_1_N = mkN "ådömande" ;
  aahoerande_nn_1_1_N = mkN "åhörande" ;
  aakallande_nn_1_1_N = mkN "åkallande" ;
  aakande_nn_1_1_N = mkN "åkande" ;
  aaklagande_nn_1_1_N = mkN "åklagande" ;
  aalande_nn_1_1_N = mkN "ålande" ;
  aaldersbestaemmande_nn_1_1_N = mkN "åldersbestämmande" ;
  aaldersdiskriminerande_nn_1_1_N = mkN "åldersdiskriminerande" ;
  aaliggande_nn_1_1_N = mkN "åliggande" ;
  aalaeggande_nn_1_1_N = mkN "åläggande" ;
  aangande_nn_1_1_N = mkN "ångande" ;
  aangfoervaellande_nn_1_1_N = mkN "ångförvällande" ;
  aangkokande_nn_1_1_N = mkN "ångkokande" ;
  aangrande_nn_1_1_N = mkN "ångrande" ;
  aartionde_nn_1_1_N = mkN "årtionde" ;
  aartusende_nn_1_1_N = mkN "årtusende" ;
  aasamkande_nn_1_1_N = mkN "åsamkande" ;
  aaseende_nn_1_1_N = mkN "åseende" ;
  aasidosaettande_nn_1_1_N = mkN "åsidosättande" ;
  aasiktsregistrerande_nn_1_1_N = mkN "åsiktsregistrerande" ;
  aaskande_nn_1_1_N = mkN "åskande" ;
  aaskaadande_nn_1_1_N = mkN "åskådande" ;
  aaskaadliggoerande_nn_1_1_N = mkN "åskådliggörande" ;
  aastadkommande_nn_1_1_N = mkN "åstadkommande" ;
  aastundande_nn_1_1_N = mkN "åstundande" ;
  aasyftande_nn_1_1_N = mkN "åsyftande" ;
  aasaettande_nn_1_1_N = mkN "åsättande" ;
  aatagande_nn_1_1_N = mkN "åtagande" ;
  aatalande_nn_1_1_N = mkN "åtalande" ;
  aateranlaendande_nn_1_1_N = mkN "återanländande" ;
  aateranpassande_nn_1_1_N = mkN "återanpassande" ;
  aateranskaffande_nn_1_1_N = mkN "återanskaffande" ;
  aateranvaendande_nn_1_1_N = mkN "återanvändande" ;
  aaterberaettande_nn_1_1_N = mkN "återberättande" ;
  aaterbesoekande_nn_1_1_N = mkN "återbesökande" ;
  aaterbetalande_nn_1_1_N = mkN "återbetalande" ;
  aaterbildande_nn_1_1_N = mkN "återbildande" ;
  aaterboerdande_nn_1_1_N = mkN "återbördande" ;
  aatereroevrande_nn_1_1_N = mkN "återerövrande" ;
  aaterfallande_nn_1_1_N = mkN "återfallande" ;
  aaterfinnande_nn_1_1_N = mkN "återfinnande" ;
  aaterflyttande_nn_1_1_N = mkN "återflyttande" ;
  aaterfaaende_nn_1_1_N = mkN "återfående" ;
  aaterfoerande_nn_1_1_N = mkN "återförande" ;
  aaterfoerenande_nn_1_1_N = mkN "återförenande" ;
  aaterfoerslutande_nn_1_1_N = mkN "återförslutande" ;
  aaterfoersaekrande_nn_1_1_N = mkN "återförsäkrande" ;
  aaterfoersaeljande_nn_1_1_N = mkN "återförsäljande" ;
  aatergivande_nn_1_1_N = mkN "återgivande" ;
  aatergaeldande_nn_1_1_N = mkN "återgäldande" ;
  aatergaaende_nn_1_1_N = mkN "återgående" ;
  aaterhaemtande_nn_1_1_N = mkN "återhämtande" ;
  aaterhaallande_nn_1_1_N = mkN "återhållande" ;
  aaterinfoerande_nn_1_1_N = mkN "återinförande" ;
  aaterinstallerande_nn_1_1_N = mkN "återinstallerande" ;
  aaterinsaettande_nn_1_1_N = mkN "återinsättande" ;
  aaterkallande_nn_1_1_N = mkN "återkallande" ;
  aaterkastande_nn_1_1_N = mkN "återkastande" ;
  aaterklingande_nn_1_1_N = mkN "återklingande" ;
  aaterknytande_nn_1_1_N = mkN "återknytande" ;
  aaterkommande_nn_1_1_N = mkN "återkommande" ;
  aaterkopplande_nn_1_1_N = mkN "återkopplande" ;
  aaterlaemnande_nn_1_1_N = mkN "återlämnande" ;
  aaterloesande_nn_1_1_N = mkN "återlösande" ;
  aaterropande_nn_1_1_N = mkN "återropande" ;
  aaterskallande_nn_1_1_N = mkN "återskallande" ;
  aaterspeglande_nn_1_1_N = mkN "återspeglande" ;
  aaterstudsande_nn_1_1_N = mkN "återstudsande" ;
  aaterstaellande_nn_1_1_N = mkN "återställande" ;
  aaterstaaende_nn_1_1_N = mkN "återstående" ;
  aatersaeljande_nn_1_1_N = mkN "återsäljande" ;
  aatersaendande_nn_1_1_N = mkN "återsändande" ;
  aatertagande_nn_1_1_N = mkN "återtagande" ;
  aatertaagande_nn_1_1_N = mkN "återtågande" ;
  aateruppbyggande_nn_1_1_N = mkN "återuppbyggande" ;
  aaterupplivande_nn_1_1_N = mkN "återupplivande" ;
  aateruppraettande_nn_1_1_N = mkN "återupprättande" ;
  aateruppstaaende_nn_1_1_N = mkN "återuppstående" ;
  aaterupptagande_nn_1_1_N = mkN "återupptagande" ;
  aateruppvaeckande_nn_1_1_N = mkN "återuppväckande" ;
  aaterutstraalande_nn_1_1_N = mkN "återutstrålande" ;
  aaterutsaendande_nn_1_1_N = mkN "återutsändande" ;
  aaterverkande_nn_1_1_N = mkN "återverkande" ;
  aatervinnande_nn_1_1_N = mkN "återvinnande" ;
  aatervaeljande_nn_1_1_N = mkN "återväljande" ;
  aatervaendande_nn_1_1_N = mkN "återvändande" ;
  aatfoeljande_nn_1_1_N = mkN "åtföljande" ;
  aatgaerdande_nn_1_1_N = mkN "åtgärdande" ;
  aatgaaende_nn_1_1_N = mkN "åtgående" ;
  aatgoerande_nn_1_1_N = mkN "åtgörande" ;
  aatlydande_nn_1_1_N = mkN "åtlydande" ;
  aatrande_nn_1_1_N = mkN "åtrande" ;
  aatraaende_nn_1_1_N = mkN "åtrående" ;
  aatskiljande_nn_1_1_N = mkN "åtskiljande" ;
  aatstramande_nn_1_1_N = mkN "åtstramande" ;
  aavilande_nn_1_1_N = mkN "åvilande" ;
  aavaegabringande_nn_1_1_N = mkN "åvägabringande" ;
  oedande_nn_1_1_N = mkN "ödande" ;
  oedelaeggande_nn_1_1_N = mkN "ödeläggande" ;
  oedmjukande_nn_1_1_N = mkN "ödmjukande" ;
  oedslande_nn_1_1_N = mkN "ödslande" ;
  oegnande_nn_1_1_N = mkN "ögnande" ;
  oegonflirtande_nn_1_1_N = mkN "ögonflirtande" ;
  oegonfloertande_nn_1_1_N = mkN "ögonflörtande" ;
  oekande_nn_1_1_N = mkN "ökande" ;
  oelande_nn_1_1_N = mkN "ölande" ;
  oemkande_nn_1_1_N = mkN "ömkande" ;
  oemmande_nn_1_1_N = mkN "ömmande" ;
  oemsande_nn_1_1_N = mkN "ömsande" ;
  oenskande_nn_1_1_N = mkN "önskande" ;
  oeppnande_nn_1_1_N = mkN "öppnande" ;
  oerfilande_nn_1_1_N = mkN "örfilande" ;
  oerlande_nn_1_1_N = mkN "örlande" ;
  oeronmaerkande_nn_1_1_N = mkN "öronmärkande" ;
  oesande_nn_1_1_N = mkN "ösande" ;
  oesregnande_nn_1_1_N = mkN "ösregnande" ;
  oevande_nn_1_1_N = mkN "övande" ;
  oeveranstraengande_nn_1_1_N = mkN "överansträngande" ;
  oeverantvardande_nn_1_1_N = mkN "överantvardande" ;
  oeveranvaendande_nn_1_1_N = mkN "överanvändande" ;
  oeverarbetande_nn_1_1_N = mkN "överarbetande" ;
  oeverbefolkande_nn_1_1_N = mkN "överbefolkande" ;
  oeverbevisande_nn_1_1_N = mkN "överbevisande" ;
  oeverbjudande_nn_1_1_N = mkN "överbjudande" ;
  oeverblickande_nn_1_1_N = mkN "överblickande" ;
  oeverbokande_nn_1_1_N = mkN "överbokande" ;
  oeverbringande_nn_1_1_N = mkN "överbringande" ;
  oeverbryggande_nn_1_1_N = mkN "överbryggande" ;
  oeverdimensionerande_nn_1_1_N = mkN "överdimensionerande" ;
  oeverdoserande_nn_1_1_N = mkN "överdoserande" ;
  oeverdragande_nn_1_1_N = mkN "överdragande" ;
  oeverdrivande_nn_1_1_N = mkN "överdrivande" ;
  oeverenskommande_nn_1_1_N = mkN "överenskommande" ;
  oeverensstaemmande_nn_1_1_N = mkN "överensstämmande" ;
  oeverexponerande_nn_1_1_N = mkN "överexponerande" ;
  oeverfallande_nn_1_1_N = mkN "överfallande" ;
  oeverflyglande_nn_1_1_N = mkN "överflyglande" ;
  oeverflyttande_nn_1_1_N = mkN "överflyttande" ;
  oeverfloedande_nn_1_1_N = mkN "överflödande" ;
  oeverfoerande_nn_1_1_N = mkN "överförande" ;
  oevergivande_nn_1_1_N = mkN "övergivande" ;
  oeverglaensande_nn_1_1_N = mkN "överglänsande" ;
  oevergaaende_nn_1_1_N = mkN "övergående" ;
  oevergaangsstaelle_nn_1_1_N = mkN "övergångsställe" ;
  oevergoedande_nn_1_1_N = mkN "övergödande" ;
  oeverhettande_nn_1_1_N = mkN "överhettande" ;
  oeverhopande_nn_1_1_N = mkN "överhopande" ;
  oeverhoppande_nn_1_1_N = mkN "överhoppande" ;
  oeverhoeljande_nn_1_1_N = mkN "överhöljande" ;
  oeverklagande_nn_1_1_N = mkN "överklagande" ;
  oeverkompenserande_nn_1_1_N = mkN "överkompenserande" ;
  oeverlagrande_nn_1_1_N = mkN "överlagrande" ;
  oeverlappande_nn_1_1_N = mkN "överlappande" ;
  oeverlevande_nn_1_1_N = mkN "överlevande" ;
  oeverlistande_nn_1_1_N = mkN "överlistande" ;
  oeverlaeggande_nn_1_1_N = mkN "överläggande" ;
  oeverlaemnande_nn_1_1_N = mkN "överlämnande" ;
  oeverlaatande_nn_1_1_N = mkN "överlåtande" ;
  oevermannande_nn_1_1_N = mkN "övermannande" ;
  oevernattande_nn_1_1_N = mkN "övernattande" ;
  oeverordnande_nn_1_1_N = mkN "överordnande" ;
  oeverproevande_nn_1_1_N = mkN "överprövande" ;
  oeverraskande_nn_1_1_N = mkN "överraskande" ;
  oeverrumplande_nn_1_1_N = mkN "överrumplande" ;
  oeverraeckande_nn_1_1_N = mkN "överräckande" ;
  oeverroestande_nn_1_1_N = mkN "överröstande" ;
  oeverseende_nn_1_1_N = mkN "överseende" ;
  oeverskridande_nn_1_1_N = mkN "överskridande" ;
  oeverskuggande_nn_1_1_N = mkN "överskuggande" ;
  oeverskyggande_nn_1_1_N = mkN "överskyggande" ;
  oeverskylande_nn_1_1_N = mkN "överskylande" ;
  oeverskaadande_nn_1_1_N = mkN "överskådande" ;
  oeverskoeljande_nn_1_1_N = mkN "översköljande" ;
  oeverstegrande_nn_1_1_N = mkN "överstegrande" ;
  oeverstigande_nn_1_1_N = mkN "överstigande" ;
  oeversvaemmande_nn_1_1_N = mkN "översvämmande" ;
  oeversaendande_nn_1_1_N = mkN "översändande" ;
  oeversaettande_nn_1_1_N = mkN "översättande" ;
  oevertagande_nn_1_1_N = mkN "övertagande" ;
  oevertalande_nn_1_1_N = mkN "övertalande" ;
  oevertecknande_nn_1_1_N = mkN "övertecknande" ;
  oevertrasserande_nn_1_1_N = mkN "övertrasserande" ;
  oevertrumfande_nn_1_1_N = mkN "övertrumfande" ;
  oevertraedande_nn_1_1_N = mkN "överträdande" ;
  oevertraeffande_nn_1_1_N = mkN "överträffande" ;
  oevertygande_nn_1_1_N = mkN "övertygande" ;
  oeverutnyttjande_nn_1_1_N = mkN "överutnyttjande" ;
  oevervakande_nn_1_1_N = mkN "övervakande" ;
  oevervarande_nn_1_1_N = mkN "övervarande" ;
  oevervinnande_nn_1_1_N = mkN "övervinnande" ;
  oevervintrande_nn_1_1_N = mkN "övervintrande" ;
  oevervaegande_nn_1_1_N = mkN "övervägande" ;
  oevervaeldigande_nn_1_1_N = mkN "överväldigande" ;
  oevervaeltrande_nn_1_1_N = mkN "övervältrande" ;
  oevervaerderande_nn_1_1_N = mkN "övervärderande" ;
  oegonvraa_nn_1_1_N = mkN "ögonvrå" "ögonvrån" "ögonvrår" "ögonvrårna" ;
  aasnesto_nn_1_1_N = mkN "åsnesto" "åsnestoet" "åsneston" "åsnestona" ;
  aasneskri_nn_1_1_N = mkN "åsneskri" "åsneskrit" "åsneskrin" "åsneskrien" ;
  aangestskri_nn_1_1_N = mkN "ångestskri" "ångestskrit" "ångestskrin" "ångestskrien" ;
  vinkelknae_nn_1_1_N = mkN "vinkelknä" "vinkelknäet" "vinkelknän" "vinkelknäna" ;
  vibrato_nn_1_N = mkN "vibrato" "vibratot" "vibraton" "vibratona" ;
  veto_nn_1_N = mkN "veto" "vetot" "veton" "vetona" ;
  ventilgummi_nn_1_N = mkN "ventilgummi" "ventilgummit" "ventilgummin" "ventilgummina" ;
  vedtrae_nn_1_1_N = mkN "vedträ" "vedträet" "vedträn" "vedträna" ;
  vaxschampo_nn_1_N = mkN "vaxschampo" "vaxschampot" "vaxschampon" "vaxschampona" ;
  vattenbi_nn_1_N = mkN "vattenbi" "vattenbit" "vattenbin" "vattenbien" ;
  vallmofroe_nn_1_1_N = mkN "vallmofrö" "vallmofröt" "vallmofrön" "vallmofröen" ;
  valfiasko_nn_1_N = mkN "valfiasko" "valfiaskot" "valfiaskon" "valfiaskona" ;
  urskri_nn_1_N = mkN "urskri" "urskrit" "urskrin" "urskrien" ;
  urarvabo_nn_1_N = mkN "urarvabo" "urarvabot" "urarvabon" "urarvaboen" ;
  ufo_nn_1_N = mkN "ufo" "ufot" "ufon" "ufona" ;
  tvistefroe_nn_1_1_N = mkN "tvistefrö" "tvistefröt" "tvistefrön" "tvistefröen" ;
  tutti_nn_1_N = mkN "tutti" "tuttit" "tuttin" "tuttina" ;
  tuggummi_nn_1_N = mkN "tuggummi" "tuggummit" "tuggummin" "tuggummina" ;
  trae_nn_2_1_N = mkN "trä" "träet" "trän" "träna" ;
  trollspoe_nn_1_1_N = mkN "trollspö" "trollspöet" "trollspön" "trollspöna" ;
  tremolo_nn_1_N = mkN "tremolo" "tremolot" "tremolon" "tremolona" ;
  trema_nn_1_N = mkN "trema" "tremat" "treman" "tremana" ;
  torrschampo_nn_1_N = mkN "torrschampo" "torrschampot" "torrschampon" "torrschampona" ;
  tivoli_nn_1_N = mkN "tivoli" "tivolit" "tivolin" "tivolina" ;
  tillgodokvitto_nn_1_N = mkN "tillgodokvitto" "tillgodokvittot" "tillgodokvitton" "tillgodokvittona" ;
  tigerhjaerta_nn_1_1_N = mkN "tigerhjärta" "tigerhjärtat" "tigerhjärtan" "tigerhjärtana" ;
  tidsschema_nn_1_N = mkN "tidsschema" "tidsschemat" "tidsscheman" "tidsschemana" ;
  telefoto_nn_1_N = mkN "telefoto" "telefotot" "telefoton" "telefotona" ;
  tapto_nn_1_N = mkN "tapto" "taptot" "tapton" "taptona" ;
  tankefroe_nn_1_1_N = mkN "tankefrö" "tankefröt" "tankefrön" "tankefröen" ;
  tabu_nn_1_N = mkN "tabu" "tabut" "tabun" "tabuna" ;
  saelltrae_nn_1_1_N = mkN "sällträ" "sällträet" "sällträn" "sällträna" ;
  sumo_nn_2_N = mkN "sumo" "sumot" "sumon" "sumona" ;
  suddgummi_nn_1_N = mkN "suddgummi" "suddgummit" "suddgummin" "suddgummina" ;
  styckningsschema_nn_1_N = mkN "styckningsschema" "styckningsschemat" "styckningsscheman" "styckningsschemana" ;
  straa_nn_1_1_N = mkN "strå" "strået" "strån" "stråna" ;
  sto_nn_1_N = mkN "sto" "stoet" "ston" "stona" ;
  stinkfly_nn_1_N = mkN "stinkfly" "stinkflyt" "stinkflyn" "stinkflyen" ;
  stackato_nn_1_N = mkN "stackato" "stackatot" "stackaton" "stackatona" ;
  spoe_nn_1_1_N = mkN "spö" "spöet" "spön" "spöna" ;
  spaerrkonto_nn_1_1_N = mkN "spärrkonto" "spärrkontot" "spärrkonton" "spärrkontona" ;
  spri_nn_1_N = mkN "spri" "sprit" "sprin" "sprien" ;
  spinnspoe_nn_1_1_N = mkN "spinnspö" "spinnspöet" "spinnspön" "spinnspöna" ;
  spikpiano_nn_1_N = mkN "spikpiano" "spikpianot" "spikpianon" "spikpianona" ;
  specialkommando_nn_1_N = mkN "specialkommando" "specialkommandot" "specialkommandon" "specialkommandona" ;
  sparkonto_nn_1_N = mkN "sparkonto" "sparkontot" "sparkonton" "sparkontona" ;
  spa_nn_1_N = mkN "spa" "spat" "span" "spana" ;
  solrosfroe_nn_1_1_N = mkN "solrosfrö" "solrosfröt" "solrosfrön" "solrosfröen" ;
  snyltbi_nn_1_N = mkN "snyltbi" "snyltbit" "snyltbin" "snyltbien" ;
  snabbfoto_nn_1_N = mkN "snabbfoto" "snabbfotot" "snabbfoton" "snabbfotona" ;
  smaagli_nn_1_1_N = mkN "smågli" "småglit" "småglin" "småglien" ;
  smultronstraa_nn_1_1_N = mkN "smultronstrå" "smultronstrået" "smultronstrån" "smultronstråna" ;
  smarto_nn_1_N = mkN "smarto" "smartot" "smarton" "smartona" ;
  sly_nn_1_N = mkN "sly" "slyet" "slyn" "slyna" ;
  slantspoe_nn_1_1_N = mkN "slantspö" "slantspöt" "slantspön" "slantspöna" ;
  slagtrae_nn_1_1_N = mkN "slagträ" "slagträet" "slagträn" "slagträna" ;
  skoenhetstuggummi_nn_1_1_N = mkN "skönhetstuggummi" "skönhetstuggummit" "skönhetstuggummin" "skönhetstuggummina" ;
  skaekttrae_nn_1_1_N = mkN "skäktträ" "skäktträt" "skäktträn" "skäktträna" ;
  skaektetrae_nn_1_1_N = mkN "skäkteträ" "skäkteträet" "skäkteträn" "skäkteträna" ;
  skaeggstraa_nn_1_1_N = mkN "skäggstrå" "skäggstrået" "skäggstrån" "skäggstråna" ;
  skumhjaerta_nn_1_1_N = mkN "skumhjärta" "skumhjärtat" "skumhjärtan" "skumhjärtana" ;
  skraa_nn_1_1_N = mkN "skrå" "skråt" "skrån" "skråen" ;
  skri_nn_1_N = mkN "skri" "skrit" "skrin" "skrien" ;
  sidoaltare_nn_1_N = mkN "sidoaltare" "sidoaltaret" "sidoaltaren" "sidoaltarna" ;
  shampoo_nn_1_N = mkN "shampoo" "shampoot" "shampoon" "shampoona" ;
  sesamfroe_nn_1_1_N = mkN "sesamfrö" "sesamfröt" "sesamfrön" "sesamfröen" ;
  scherzo_nn_1_N = mkN "scherzo" "scherzot" "scherzon" "scherzona" ;
  schema_nn_1_N = mkN "schema" "schemat" "scheman" "schemana" ;
  schampo_nn_1_N = mkN "schampo" "schampot" "schampon" "schampona" ;
  saldo_nn_1_N = mkN "saldo" "saldot" "saldon" "saldona" ;
  roerelsekommando_nn_1_1_N = mkN "rörelsekommando" "rörelsekommandot" "rörelsekommandon" "rörelsekommandona" ;
  raattbo_nn_1_1_N = mkN "råttbo" "råttbot" "råttbon" "råttboen" ;
  rondo_nn_1_N = mkN "rondo" "rondot" "rondon" "rondona" ;
  ritardando_nn_1_N = mkN "ritardando" "ritardandot" "ritardandon" "ritardandona" ;
  ridspoe_nn_1_1_N = mkN "ridspö" "ridspöet" "ridspön" "ridspöna" ;
  ri_nn_1_N = mkN "ri" "riet" "rin" "rien" ;
  returporto_nn_1_N = mkN "returporto" "returportot" "returporton" "returportona" ;
  restaurangalibi_nn_1_N = mkN "restaurangalibi" "restaurangalibit" "restaurangalibin" "restaurangalibina" ;
  renhjaerta_nn_1_1_N = mkN "renhjärta" "renhjärtat" "renhjärtan" "renhjärtana" ;
  reklamjippo_nn_1_N = mkN "reklamjippo" "reklamjippot" "reklamjippon" "reklamjippona" ;
  randdelta_nn_1_N = mkN "randdelta" "randdeltat" "randdeltan" "randdeltana" ;
  ramaskri_nn_1_N = mkN "ramaskri" "ramaskrit" "ramaskrin" "ramaskrien" ;
  rally_nn_1_N = mkN "rally" "rallyt" "rallyn" "rallyna" ;
  radergummi_nn_1_N = mkN "radergummi" "radergummit" "radergummin" "radergummina" ;
  pyjamasparty_nn_1_N = mkN "pyjamasparty" "pyjamaspartyt" "pyjamaspartyn" "pyjamaspartyna" ;
  pucko_nn_1_N = mkN "pucko" "puckot" "puckon" "puckona" ;
  prydnadshjaerta_nn_1_1_N = mkN "prydnadshjärta" "prydnadshjärtat" "prydnadshjärtan" "prydnadshjärtana" ;
  prisrally_nn_1_N = mkN "prisrally" "prisrallyt" "prisrallyn" "prisrallyna" ;
  pretto_nn_1_N = mkN "pretto" "prettot" "pretton" "prettona" ;
  presto_nn_1_N = mkN "presto" "prestot" "preston" "prestona" ;
  praktfiasko_nn_1_N = mkN "praktfiasko" "praktfiaskot" "praktfiaskon" "praktfiaskona" ;
  postgirokonto_nn_1_N = mkN "postgirokonto" "postgirokontot" "postgirokonton" "postgirokontona" ;
  postgiro_nn_1_N = mkN "postgiro" "postgirot" "postgiron" "postgirona" ;
  porto_nn_1_N = mkN "porto" "portot" "porton" "portona" ;
  portamento_nn_1_N = mkN "portamento" "portamentot" "portamenton" "portamentona" ;
  pizzicato_nn_1_N = mkN "pizzicato" "pizzicatot" "pizzicaton" "pizzicatona" ;
  pimpelspoe_nn_1_1_N = mkN "pimpelspö" "pimpelspöet" "pimpelspön" "pimpelspöna" ;
  piano_nn_1_N = mkN "piano" "pianot" "pianon" "pianona" ;
  pianissimo_nn_1_N = mkN "pianissimo" "pianissimot" "pianissimon" "pianissimona" ;
  pianino_nn_1_N = mkN "pianino" "pianinot" "pianinon" "pianinona" ;
  pervo_nn_1_N = mkN "pervo" "pervot" "pervon" "pervona" ;
  personkonto_nn_1_N = mkN "personkonto" "personkontot" "personkonton" "personkontona" ;
  pentry_nn_1_N = mkN "pentry" "pentryt" "pentryn" "pentryna" ;
  peddo_nn_1_N = mkN "peddo" "peddot" "peddon" "peddona" ;
  passfoto_nn_1_N = mkN "passfoto" "passfotot" "passfoton" "passfotona" ;
  party_nn_1_N = mkN "party" "partyt" "partyn" "partyna" ;
  parlando_nn_1_N = mkN "parlando" "parlandot" "parlandon" "parlandona" ;
  paradisfroe_nn_1_1_N = mkN "paradisfrö" "paradisfröt" "paradisfrön" "paradisfröen" ;
  pansarhjaerta_nn_1_1_N = mkN "pansarhjärta" "pansarhjärtat" "pansarhjärtan" "pansarhjärtana" ;
  ostinato_nn_1_N = mkN "ostinato" "ostinatot" "ostinaton" "ostinatona" ;
  ormbo_nn_1_N = mkN "ormbo" "ormbot" "ormbon" "ormboen" ;
  okynnesfae_nn_1_1_N = mkN "okynnesfä" "okynnesfäet" "okynnesfän" "okynnesfäna" ;
  odensfly_nn_1_N = mkN "odensfly" "odensflyt" "odensflyn" "odensflyen" ;
  nyteckning_nn_1_N = mkN "nyteckning" "nyteckningt" "nyteckningn" "nyteckningna" ;
  netto_nn_1_N = mkN "netto" "nettot" "netton" "nettona" ;
  nattfly_nn_1_N = mkN "nattfly" "nattflyt" "nattflyn" "nattflyen" ;
  maalfoto_nn_1_1_N = mkN "målfoto" "målfotot" "målfoton" "målfotona" ;
  maenniskohjaerta_nn_1_1_N = mkN "människohjärta" "människohjärtat" "människohjärtan" "människohjärtana" ;
  maehae_nn_1_1_N = mkN "mähä" "mähäet" "mähän" "mähäna" ;
  mysfyllo_nn_1_N = mkN "mysfyllo" "mysfyllot" "mysfyllon" "mysfyllona" ;
  motto_nn_1_N = mkN "motto" "mottot" "motton" "mottona" ;
  mongo_nn_1_N = mkN "mongo" "mongot" "mongon" "mongona" ;
  modershjaerta_nn_1_1_N = mkN "modershjärta" "modershjärtat" "modershjärtan" "modershjärtana" ;
  mjaellschampo_nn_1_1_N = mkN "mjällschampo" "mjällschampot" "mjällschampon" "mjällschampona" ;
  mjau_nn_1_N = mkN "mjau" "mjauet" "mjaun" "mjauna" ;
  milo_nn_1_N = mkN "milo" "milot" "milon" "milona" ;
  mikrofoto_nn_1_N = mkN "mikrofoto" "mikrofotot" "mikrofoton" "mikrofotona" ;
  miko_nn_1_N = mkN "miko" "mikot" "mikon" "mikona" ;
  miffo_nn_1_N = mkN "miffo" "miffot" "miffon" "miffona" ;
  metspoe_nn_1_1_N = mkN "metspö" "metspöet" "metspön" "metspöna" ;
  memento_nn_1_N = mkN "memento" "mementot" "mementon" "mementona" ;
  melodrama_nn_1_N = mkN "melodrama" "melodramat" "melodraman" "melodramana" ;
  medelklassghetto_nn_1_N = mkN "medelklassghetto" "medelklassghettot" "medelklassghetton" "medelklassghettona" ;
  medelklassgetto_nn_1_N = mkN "medelklassgetto" "medelklassgettot" "medelklassgetton" "medelklassgettona" ;
  mecka_nn_1_N = mkN "mecka" "meckat" "meckan" "meckana" ;
  meccano_nn_1_N = mkN "meccano" "meccanot" "meccanon" "meccanona" ;
  mantra_nn_1_N = mkN "mantra" "mantrat" "mantran" "mantrana" ;
  manko_nn_1_N = mkN "manko" "mankot" "mankon" "mankona" ;
  loejtnantshjaerta_nn_1_1_N = mkN "löjtnantshjärta" "löjtnantshjärtat" "löjtnantshjärtan" "löjtnantshjärtana" ;
  laerkbo_nn_1_1_N = mkN "lärkbo" "lärkbot" "lärkbon" "lärkboen" ;
  linfroe_nn_1_1_N = mkN "linfrö" "linfröt" "linfrön" "linfröen" ;
  lemma_nn_1_N = mkN "lemma" "lemmat" "lemman" "lemmana" ;
  lego_nn_1_N = mkN "lego" "legot" "legon" "legona" ;
  legato_nn_1_N = mkN "legato" "legatot" "legaton" "legatona" ;
  largo_nn_1_N = mkN "largo" "largot" "largon" "largona" ;
  largetto_nn_1_N = mkN "largetto" "largettot" "largetton" "largettona" ;
  lagtempo_nn_1_N = mkN "lagtempo" "lagtempot" "lagtempon" "lagtempona" ;
  kvitto_nn_1_N = mkN "kvitto" "kvittot" "kvitton" "kvittona" ;
  kuttrasju_nn_1_N = mkN "kuttrasju" "kuttrasjut" "kuttrasjun" "kuttrasjuna" ;
  krypto_nn_1_N = mkN "krypto" "kryptot" "krypton" "kryptona" ;
  kostschema_nn_1_N = mkN "kostschema" "kostschemat" "kostscheman" "kostschemana" ;
  kopplingsschema_nn_1_N = mkN "kopplingsschema" "kopplingsschemat" "kopplingsscheman" "kopplingsschemana" ;
  konto_nn_1_N = mkN "konto" "kontot" "konton" "kontona" ;
  konkursbo_nn_1_N = mkN "konkursbo" "konkursbot" "konkursbon" "konkursboen" ;
  kommando_nn_1_N = mkN "kommando" "kommandot" "kommandon" "kommandona" ;
  komma_nn_1_N = mkN "komma" "kommat" "komman" "kommana" ;
  kollo_nn_1_N = mkN "kollo" "kollot" "kollon" "kollona" ;
  knae_nn_1_1_N = mkN "knä" "knäet" "knän" "knäna" ;
  klapptrae_nn_1_1_N = mkN "klappträ" "klappträet" "klappträn" "klappträna" ;
  kasttrae_nn_1_1_N = mkN "kastträ" "kastträet" "kastträn" "kastträna" ;
  kastspoe_nn_1_1_N = mkN "kastspö" "kastspöet" "kastspön" "kastspöna" ;
  kassakvitto_nn_1_N = mkN "kassakvitto" "kassakvittot" "kassakvitton" "kassakvittona" ;
  kasko_nn_1_N = mkN "kasko" "kaskot" "kaskon" "kaskona" ;
  kasino_nn_1_N = mkN "kasino" "kasinot" "kasinon" "kasinona" ;
  kapitalkonto_nn_1_N = mkN "kapitalkonto" "kapitalkontot" "kapitalkonton" "kapitalkontona" ;
  kanariefroe_nn_1_1_N = mkN "kanariefrö" "kanariefröt" "kanariefrön" "kanariefröen" ;
  kammarpiano_nn_1_N = mkN "kammarpiano" "kammarpianot" "kammarpianon" "kammarpianona" ;
  jaettefiasko_nn_1_1_N = mkN "jättefiasko" "jättefiaskot" "jättefiaskon" "jättefiaskona" ;
  jaemmerskri_nn_1_1_N = mkN "jämmerskri" "jämmerskrit" "jämmerskrin" "jämmerskrien" ;
  jordfly_nn_1_N = mkN "jordfly" "jordflyt" "jordflyn" "jordflyen" ;
  jordbi_nn_1_N = mkN "jordbi" "jordbit" "jordbin" "jordbien" ;
  jippo_nn_1_N = mkN "jippo" "jippot" "jippon" "jippona" ;
  intermezzo_nn_1_N = mkN "intermezzo" "intermezzot" "intermezzon" "intermezzona" ;
  inferno_nn_1_N = mkN "inferno" "infernot" "infernon" "infernona" ;
  impromptu_nn_1_N = mkN "impromptu" "impromptut" "impromptun" "impromptuna" ;
  hoegaltare_nn_1_1_N = mkN "högaltare" "högaltaret" "högaltaren" "högaltarna" ;
  haarstraa_nn_1_1_N = mkN "hårstrå" "hårstrået" "hårstrån" "hårstråna" ;
  haarschampo_nn_1_1_N = mkN "hårschampo" "hårschampot" "hårschampon" "hårschampona" ;
  haerskri_nn_1_1_N = mkN "härskri" "härskrit" "härskrin" "härskrien" ;
  hygglo_nn_1_N = mkN "hygglo" "hygglot" "hygglon" "hygglona" ;
  hosianna_nn_1_N = mkN "hosianna" "hosiannat" "hosiannan" "hosiannana" ;
  hjaerta_nn_1_1_N = mkN "hjärta" "hjärtat" "hjärtan" "hjärtana" ;
  hampfroe_nn_1_1_N = mkN "hampfrö" "hampfröt" "hampfrön" "hampfröen" ;
  halmstraa_nn_1_1_N = mkN "halmstrå" "halmstrået" "halmstrån" "halmstråna" ;
  halmhjaerta_nn_1_1_N = mkN "halmhjärta" "halmhjärtat" "halmhjärtan" "halmhjärtana" ;
  halleluja_nn_1_N = mkN "halleluja" "hallelujat" "hallelujan" "hallelujana" ;
  gyro_nn_1_N = mkN "gyro" "gyrot" "gyron" "gyrona" ;
  gungfly_nn_1_N = mkN "gungfly" "gungflyt" "gungflyn" "gungflyen" ;
  gummi_nn_1_N = mkN "gummi" "gummit" "gummin" "gummina" ;
  graesstraa_nn_1_1_N = mkN "grässtrå" "grässtrået" "grässtrån" "grässtråna" ;
  graesfly_nn_1_1_N = mkN "gräsfly" "gräsflyt" "gräsflyn" "gräsflyen" ;
  grisningsbo_nn_1_N = mkN "grisningsbo" "grisningsbot" "grisningsbon" "grisningsboen" ;
  goraa_nn_1_1_N = mkN "gorå" "goråt" "gorån" "goråna" ;
  godishjaerta_nn_1_1_N = mkN "godishjärta" "godishjärtat" "godishjärtan" "godishjärtana" ;
  glissando_nn_1_N = mkN "glissando" "glissandot" "glissandon" "glissandona" ;
  gli_nn_1_N = mkN "gli" "glit" "glin" "glien" ;
  giro_nn_1_N = mkN "giro" "girot" "giron" "girona" ;
  ghetto_nn_1_N = mkN "ghetto" "ghettot" "ghetton" "ghettona" ;
  getto_nn_1_N = mkN "getto" "gettot" "getton" "gettona" ;
  getingbo_nn_1_N = mkN "getingbo" "getingbot" "getingbon" "getingboen" ;
  gammafly_nn_1_N = mkN "gammafly" "gammaflyt" "gammaflyn" "gammaflyen" ;
  foerklae_nn_1_1_N = mkN "förklä" "förklät" "förklän" "förkläna" ;
  foeretagsfiasko_nn_1_1_N = mkN "företagsfiasko" "företagsfiaskot" "företagsfiaskon" "företagsfiaskona" ;
  foelsto_nn_1_1_N = mkN "fölsto" "fölstoet" "fölston" "fölstona" ;
  foedsloskri_nn_1_1_N = mkN "födsloskri" "födsloskrit" "födsloskrin" "födsloskrien" ;
  faagelbo_nn_1_1_N = mkN "fågelbo" "fågelbot" "fågelbon" "fågelboen" ;
  fae_nn_1_1_N = mkN "fä" "fäet" "fän" "fäna" ;
  fyllo_nn_1_N = mkN "fyllo" "fyllot" "fyllon" "fyllona" ;
  furioso_nn_1_N = mkN "furioso" "furiosot" "furioson" "furiosona" ;
  foto_nn_1_N = mkN "foto" "fotot" "foton" "fotona" ;
  fortissimo_nn_1_N = mkN "fortissimo" "fortissimot" "fortissimon" "fortissimona" ;
  fortepiano_nn_1_N = mkN "fortepiano" "fortepianot" "fortepianon" "fortepianona" ;
  floedesschema_nn_1_1_N = mkN "flödesschema" "flödesschemat" "flödesscheman" "flödesschemana" ;
  flygfae_nn_1_1_N = mkN "flygfä" "flygfäet" "flygfän" "flygfäna" ;
  flygfoto_nn_1_N = mkN "flygfoto" "flygfotot" "flygfoton" "flygfotona" ;
  fly_nn_1_N = mkN "fly" "flyt" "flyn" "flyen" ;
  fjaederfae_nn_1_1_N = mkN "fjäderfä" "fjäderfäet" "fjäderfän" "fjäderfäna" ;
  finansnetto_nn_1_N = mkN "finansnetto" "finansnettot" "finansnetton" "finansnettona" ;
  fiasko_nn_1_N = mkN "fiasko" "fiaskot" "fiaskon" "fiaskona" ;
  fetto_nn_1_N = mkN "fetto" "fettot" "fetton" "fettona" ;
  fetthjaerta_nn_1_1_N = mkN "fetthjärta" "fetthjärtat" "fetthjärtan" "fetthjärtana" ;
  familjefoto_nn_1_N = mkN "familjefoto" "familjefotot" "familjefoton" "familjefotona" ;
  fadershjaerta_nn_1_1_N = mkN "fadershjärta" "fadershjärtat" "fadershjärtan" "fadershjärtana" ;
  enhetsporto_nn_1_N = mkN "enhetsporto" "enhetsportot" "enhetsporton" "enhetsportona" ;
  embryo_nn_1_N = mkN "embryo" "embryot" "embryon" "embryona" ;
  eldorado_nn_1_N = mkN "eldorado" "eldoradot" "eldoradon" "eldoradona" ;
  eldkommando_nn_1_N = mkN "eldkommando" "eldkommandot" "eldkommandon" "eldkommandona" ;
  eko_nn_1_N = mkN "eko" "ekot" "ekon" "ekona" ;
  doedsbo_nn_1_1_N = mkN "dödsbo" "dödsbot" "dödsbon" "dödsboen" ;
  dubbelkommando_nn_1_N = mkN "dubbelkommando" "dubbelkommandot" "dubbelkommandon" "dubbelkommandona" ;
  diskonto_nn_1_N = mkN "diskonto" "diskontot" "diskonton" "diskontona" ;
  disko_nn_1_N = mkN "disko" "diskot" "diskon" "diskona" ;
  disco_nn_1_N = mkN "disco" "discot" "discon" "discona" ;
  diminuendo_nn_1_N = mkN "diminuendo" "diminuendot" "diminuendon" "diminuendona" ;
  dilemma_nn_1_N = mkN "dilemma" "dilemmat" "dilemman" "dilemmana" ;
  derby_nn_1_N = mkN "derby" "derbyt" "derbyn" "derbyna" ;
  delta_nn_1_N = mkN "delta" "deltat" "deltan" "deltana" ;
  decimalkomma_nn_1_N = mkN "decimalkomma" "decimalkommat" "decimalkomman" "decimalkommana" ;
  dakapo_nn_1_N = mkN "dakapo" "dakapot" "dakapon" "dakapona" ;
  crescendo_nn_1_N = mkN "crescendo" "crescendot" "crescendon" "crescendona" ;
  credo_nn_1_N = mkN "credo" "credot" "credon" "credona" ;
  cocktailparty_nn_1_N = mkN "cocktailparty" "cocktailpartyt" "cocktailpartyn" "cocktailpartyna" ;
  city_nn_1_N = mkN "city" "cityt" "cityn" "cityna" ;
  checkkonto_nn_1_N = mkN "checkkonto" "checkkontot" "checkkonton" "checkkontona" ;
  baatskraa_nn_1_1_N = mkN "båtskrå" "båtskråt" "båtskrån" "båtskråen" ;
  byxknae_nn_1_1_N = mkN "byxknä" "byxknäet" "byxknän" "byxknäna" ;
  busksly_nn_1_N = mkN "busksly" "buskslyet" "buskslyn" "buskslyna" ;
  busfroe_nn_1_1_N = mkN "busfrö" "busfröt" "busfrön" "busfröen" ;
  budgetspa_nn_1_N = mkN "budgetspa" "budgetspat" "budgetspan" "budgetspana" ;
  broellopsfoto_nn_1_1_N = mkN "bröllopsfoto" "bröllopsfotot" "bröllopsfoton" "bröllopsfotona" ;
  braennbollstrae_nn_1_1_N = mkN "brännbollsträ" "brännbollsträet" "brännbollsträn" "brännbollsträna" ;
  brutto_nn_1_N = mkN "brutto" "bruttot" "brutton" "bruttona" ;
  brudfoto_nn_1_N = mkN "brudfoto" "brudfotot" "brudfoton" "brudfotona" ;
  brevporto_nn_1_N = mkN "brevporto" "brevportot" "brevporton" "brevportona" ;
  brakfiasko_nn_1_N = mkN "brakfiasko" "brakfiaskot" "brakfiaskon" "brakfiaskona" ;
  bortafiasko_nn_1_N = mkN "bortafiasko" "bortafiaskot" "bortafiaskon" "bortafiaskona" ;
  bomullsfroe_nn_1_1_N = mkN "bomullsfrö" "bomullsfröt" "bomullsfrön" "bomullsfröen" ;
  bolltrae_nn_1_1_N = mkN "bollträ" "bollträet" "bollträn" "bollträna" ;
  bockhornskloeverfroe_nn_1_1_N = mkN "bockhornsklöverfrö" "bockhornsklöverfröt" "bockhornsklöverfrön" "bockhornsklöverfröen" ;
  bo_nn_1_N = mkN "bo" "bot" "bon" "boen" ;
  blixtfoto_nn_1_N = mkN "blixtfoto" "blixtfotot" "blixtfoton" "blixtfotona" ;
  bilschampo_nn_1_N = mkN "bilschampo" "bilschampot" "bilschampon" "bilschampona" ;
  bilrally_nn_1_N = mkN "bilrally" "bilrallyt" "bilrallyn" "bilrallyna" ;
  bi_nn_1_N = mkN "bi" "bit" "bin" "bien" ;
  basebolltrae_nn_1_1_N = mkN "basebollträ" "basebollträet" "basebollträn" "basebollträna" ;
  basebollstrae_nn_1_1_N = mkN "basebollsträ" "basebollsträet" "basebollsträn" "basebollsträna" ;
  baseballtrae_nn_1_1_N = mkN "baseballträ" "baseballträet" "baseballträn" "baseballträna" ;
  baseballstrae_nn_1_1_N = mkN "baseballsträ" "baseballsträet" "baseballsträn" "baseballsträna" ;
  barnlaekarskraa_nn_1_1_N = mkN "barnläkarskrå" "barnläkarskråt" "barnläkarskrån" "barnläkarskråen" ;
  barnahjaerta_nn_1_1_N = mkN "barnahjärta" "barnahjärtat" "barnahjärtan" "barnahjärtana" ;
  bankkonto_nn_1_N = mkN "bankkonto" "bankkontot" "bankkonton" "bankkontona" ;
  bankgiro_nn_1_N = mkN "bankgiro" "bankgirot" "bankgiron" "bankgirona" ;
  balkknae_nn_1_1_N = mkN "balkknä" "balkknäet" "balkknän" "balkknäna" ;
  balanskonto_nn_1_N = mkN "balanskonto" "balanskontot" "balanskonton" "balanskontona" ;
  avelssto_nn_1_N = mkN "avelssto" "avelsstoet" "avelsston" "avelsstona" ;
  arpeggio_nn_1_N = mkN "arpeggio" "arpeggiot" "arpeggion" "arpeggiona" ;
  arioso_nn_1_N = mkN "arioso" "ariosot" "arioson" "ariosona" ;
  arbetsschema_nn_1_N = mkN "arbetsschema" "arbetsschemat" "arbetsscheman" "arbetsschemana" ;
  arbetsbi_nn_1_N = mkN "arbetsbi" "arbetsbit" "arbetsbin" "arbetsbien" ;
  anskri_nn_1_N = mkN "anskri" "anskrit" "anskrin" "anskrien" ;
  ankarfly_nn_1_N = mkN "ankarfly" "ankarflyt" "ankarflyn" "ankarflyen" ;
  altare_nn_1_N = mkN "altare" "altaret" "altaren" "altarna" ;
  allegro_nn_1_N = mkN "allegro" "allegrot" "allegron" "allegrona" ;
  allegretto_nn_1_N = mkN "allegretto" "allegrettot" "allegretton" "allegrettona" ;
  alibi_nn_1_N = mkN "alibi" "alibit" "alibin" "alibina" ;
  adjoe_nn_1_1_N = mkN "adjö" "adjöt" "adjön" "adjöna" ;
  adagio_nn_1_N = mkN "adagio" "adagiot" "adagion" "adagiona" ;
  aluminiumfolie_nn_1_N = mkN "aluminiumfolie" "aluminiumfolier" ;
  blyfolie_nn_1_N = mkN "blyfolie" "blyfolier" ;
  folie_nn_1_N = mkN "folie" "folier" ;
  ganglie_nn_1_N = mkN "ganglie" "ganglier" ;
  plastfolie_nn_1_N = mkN "plastfolie" "plastfolier" ;
  silverfolie_nn_1_N = mkN "silverfolie" "silverfolier" ;
  staerkelse_nn_1_1_N = mkN "stärkelse" "stärkelser" ;
  tennfolie_nn_1_N = mkN "tennfolie" "tennfolier" ;
  vaeckelse_nn_1_1_N = mkN "väckelse" "väckelser" ;
  vaeckelseroerelse_nn_1_1_N = mkN "väckelserörelse" "väckelserörelser" ;
  vaegfoerbindelse_nn_1_1_N = mkN "vägförbindelse" "vägförbindelser" ;
  vaelsignelse_nn_1_1_N = mkN "välsignelse" "välsignelser" ;
  vaendradie_nn_1_1_N = mkN "vändradie" "vändradier" ;
  vaenskapsfoerbindelse_nn_1_1_N = mkN "vänskapsförbindelse" "vänskapsförbindelser" ;
  vaerdefoersaendelse_nn_1_1_N = mkN "värdeförsändelse" "värdeförsändelser" ;
  vaerdshusroerelse_nn_1_1_N = mkN "värdshusrörelse" "värdshusrörelser" ;
  vaerldsfoersakelse_nn_1_1_N = mkN "världsförsakelse" "världsförsakelser" ;
  vaerldshaendelse_nn_1_1_N = mkN "världshändelse" "världshändelser" ;
  vaerldsmedborgarroerelse_nn_1_1_N = mkN "världsmedborgarrörelse" "världsmedborgarrörelser" ;
  vaaglinje_nn_1_1_N = mkN "våglinje" "våglinjer" ;
  vaagroerelse_nn_1_1_N = mkN "vågrörelse" "vågrörelser" ;
  vaardlinje_nn_1_1_N = mkN "vårdlinje" "vårdlinjer" ;
  voerdnadsbetygelse_nn_1_1_N = mkN "vördnadsbetygelse" "vördnadsbetygelser" ;
  ynnestbetygelse_nn_1_N = mkN "ynnestbetygelse" "ynnestbetygelser" ;
  aendelse_nn_1_1_N = mkN "ändelse" "ändelser" ;
  aerebetygelse_nn_1_1_N = mkN "ärebetygelse" "ärebetygelser" ;
  aerkefiende_nn_1_1_N = mkN "ärkefiende" "ärkefiender" ;
  aabo_nn_1_1_N = mkN "åbo" "åbor" ;
  aarsberaettelse_nn_1_1_N = mkN "årsberättelse" "årsberättelser" ;
  aasiktsfoerfoeljelse_nn_1_1_N = mkN "åsiktsförföljelse" "åsiktsförföljelser" ;
  aaterkallelse_nn_1_1_N = mkN "återkallelse" "återkallelser" ;
  aateruppstaandelse_nn_1_1_N = mkN "återuppståndelse" "återuppståndelser" ;
  aateruppvaeckelse_nn_1_1_N = mkN "återuppväckelse" "återuppväckelser" ;
  oedelaeggelse_nn_1_1_N = mkN "ödeläggelse" "ödeläggelser" ;
  oegonroerelse_nn_1_1_N = mkN "ögonrörelse" "ögonrörelser" ;
  oeverenskommelse_nn_1_1_N = mkN "överenskommelse" "överenskommelser" ;
  oeverensstaemmelse_nn_1_1_N = mkN "överensstämmelse" "överensstämmelser" ;
  oeverlaatelse_nn_1_1_N = mkN "överlåtelse" "överlåtelser" ;
  oevertraedelse_nn_1_1_N = mkN "överträdelse" "överträdelser" ;
  oevertygelse_nn_1_1_N = mkN "övertygelse" "övertygelser" ;
  DNA_testande_nn_1_N = mkN "DNA-testande" ;
  K_maerkande_nn_1_1_N = mkN "K-märkande" ;
  TV_tittande_nn_1_N = mkN "TV-tittande" ;
  USB_minne_nn_1_N = mkN "USB-minne" ;
  _1800_talsmode_nn_1_N = mkN "1800-talsmode" ;
  abbrevierande_nn_1_N = mkN "abbrevierande" ;
  abdikerande_nn_1_N = mkN "abdikerande" ;
  abonnerande_nn_1_N = mkN "abonnerande" ;
  aborterande_nn_1_N = mkN "aborterande" ;
  abraderande_nn_1_N = mkN "abraderande" ;
  absolverande_nn_1_N = mkN "absolverande" ;
  absorberande_nn_1_N = mkN "absorberande" ;
  abstraherande_nn_1_N = mkN "abstraherande" ;
  accederande_nn_1_N = mkN "accederande" ;
  accelererande_nn_1_N = mkN "accelererande" ;
  accentuerande_nn_1_N = mkN "accentuerande" ;
  accepterande_nn_1_N = mkN "accepterande" ;
  accessande_nn_1_N = mkN "accessande" ;
  acklimatiserande_nn_1_N = mkN "acklimatiserande" ;
  ackommoderande_nn_1_N = mkN "ackommoderande" ;
  ackompanjerande_nn_1_N = mkN "ackompanjerande" ;
  ackorderande_nn_1_N = mkN "ackorderande" ;
  ackordsarbete_nn_1_N = mkN "ackordsarbete" ;
  ackrediterande_nn_1_N = mkN "ackrediterande" ;
  ackumulerande_nn_1_N = mkN "ackumulerande" ;
  ackvirerande_nn_1_N = mkN "ackvirerande" ;
  adamsaepple_nn_1_1_N = mkN "adamsäpple" ;
  adapterande_nn_1_N = mkN "adapterande" ;
  adderande_nn_1_N = mkN "adderande" ;
  adelsmaerke_nn_1_1_N = mkN "adelsmärke" ;
  adjungerande_nn_1_N = mkN "adjungerande" ;
  adlande_nn_1_N = mkN "adlande" ;
  administrerande_nn_1_N = mkN "administrerande" ;
  adopterande_nn_1_N = mkN "adopterande" ;
  adresserande_nn_1_N = mkN "adresserande" ;
  adsorberande_nn_1_N = mkN "adsorberande" ;
  aducerande_nn_1_N = mkN "aducerande" ;
  advocerande_nn_1_N = mkN "advocerande" ;
  affektionsvaerde_nn_1_1_N = mkN "affektionsvärde" ;
  afficierande_nn_1_N = mkN "afficierande" ;
  affinerande_nn_1_N = mkN "affinerande" ;
  affischerande_nn_1_N = mkN "affischerande" ;
  affaersbitraede_nn_1_1_N = mkN "affärsbiträde" ;
  afrikaniserande_nn_1_N = mkN "afrikaniserande" ;
  agande_nn_1_N = mkN "agande" ;
  agerande_nn_1_N = mkN "agerande" ;
  agglomererande_nn_1_N = mkN "agglomererande" ;
  agglutinerande_nn_1_N = mkN "agglutinerande" ;
  agiterande_nn_1_N = mkN "agiterande" ;
  agnande_nn_1_N = mkN "agnande" ;
  ajournerande_nn_1_N = mkN "ajournerande" ;
  aktande_nn_1_N = mkN "aktande" ;
  aktieaegande_nn_1_1_N = mkN "aktieägande" ;
  aktiverande_nn_1_N = mkN "aktiverande" ;
  aktstycke_nn_1_N = mkN "aktstycke" ;
  aktualiserande_nn_1_N = mkN "aktualiserande" ;
  alarmerande_nn_1_N = mkN "alarmerande" ;
  alfabetiserande_nn_1_N = mkN "alfabetiserande" ;
  alfaagelskytte_nn_1_1_N = mkN "alfågelskytte" ;
  alienerande_nn_1_N = mkN "alienerande" ;
  allegoriserande_nn_1_N = mkN "allegoriserande" ;
  allenastyre_nn_1_N = mkN "allenastyre" ;
  allierande_nn_1_N = mkN "allierande" ;
  allittererande_nn_1_N = mkN "allittererande" ;
  allmaenbildande_nn_1_1_N = mkN "allmänbildande" ;
  allmaenintresse_nn_1_1_N = mkN "allmänintresse" ;
  allokerande_nn_1_N = mkN "allokerande" ;
  alluderande_nn_1_N = mkN "alluderande" ;
  alstrande_nn_1_N = mkN "alstrande" ;
  altanfaeste_nn_1_1_N = mkN "altanfäste" ;
  altarklaede_nn_1_1_N = mkN "altarkläde" ;
  alternerande_nn_1_N = mkN "alternerande" ;
  aluminerande_nn_1_N = mkN "aluminerande" ;
  alvluckrande_nn_1_N = mkN "alvluckrande" ;
  amalgamerande_nn_1_N = mkN "amalgamerande" ;
  ambulerande_nn_1_N = mkN "ambulerande" ;
  amerikaniserande_nn_1_N = mkN "amerikaniserande" ;
  ammande_nn_1_N = mkN "ammande" ;
  amorterande_nn_1_N = mkN "amorterande" ;
  amplifierande_nn_1_N = mkN "amplifierande" ;
  amplitudmodulerande_nn_1_N = mkN "amplitudmodulerande" ;
  amputerande_nn_1_N = mkN "amputerande" ;
  analyserande_nn_1_N = mkN "analyserande" ;
  anammande_nn_1_N = mkN "anammande" ;
  anande_nn_1_N = mkN "anande" ;
  anbefallande_nn_1_N = mkN "anbefallande" ;
  anbelangande_nn_1_N = mkN "anbelangande" ;
  anbringande_nn_1_N = mkN "anbringande" ;
  andante_nn_1_N = mkN "andante" ;
  andragande_nn_1_N = mkN "andragande" ;
  andrahandsvaerde_nn_1_1_N = mkN "andrahandsvärde" ;
  anfallande_nn_1_N = mkN "anfallande" ;
  anfallsomraade_nn_1_1_N = mkN "anfallsområde" ;
  anfraetande_nn_1_1_N = mkN "anfrätande" ;
  anfaektande_nn_1_1_N = mkN "anfäktande" ;
  anfoerande_nn_1_1_N = mkN "anförande" ;
  anfoertroende_nn_1_1_N = mkN "anförtroende" ;
  angivande_nn_1_N = mkN "angivande" ;
  anglande_nn_1_N = mkN "anglande" ;
  angliserande_nn_1_N = mkN "angliserande" ;
  angripande_nn_1_N = mkN "angripande" ;
  angraensande_nn_1_1_N = mkN "angränsande" ;
  angoerande_nn_1_1_N = mkN "angörande" ;
  anhopande_nn_1_N = mkN "anhopande" ;
  anhaallande_nn_1_1_N = mkN "anhållande" ;
  animerande_nn_1_N = mkN "animerande" ;
  ankarfaeste_nn_1_1_N = mkN "ankarfäste" ;
  anklagande_nn_1_N = mkN "anklagande" ;
  anknytande_nn_1_N = mkN "anknytande" ;
  ankommande_nn_1_N = mkN "ankommande" ;
  ankrande_nn_1_N = mkN "ankrande" ;
  anlete_nn_1_N = mkN "anlete" ;
  anliggande_nn_1_N = mkN "anliggande" ;
  anlitande_nn_1_N = mkN "anlitande" ;
  anlaendande_nn_1_1_N = mkN "anländande" ;
  anloepande_nn_1_1_N = mkN "anlöpande" ;
  anmanande_nn_1_N = mkN "anmanande" ;
  anmodande_nn_1_N = mkN "anmodande" ;
  anmaelande_nn_1_1_N = mkN "anmälande" ;
  anmaerkande_nn_1_1_N = mkN "anmärkande" ;
  annekterande_nn_1_N = mkN "annekterande" ;
  annihilerande_nn_1_N = mkN "annihilerande" ;
  annonserande_nn_1_N = mkN "annonserande" ;
  annoterande_nn_1_N = mkN "annoterande" ;
  annullerande_nn_1_N = mkN "annullerande" ;
  anodiserande_nn_1_N = mkN "anodiserande" ;
  anonymiserande_nn_1_N = mkN "anonymiserande" ;
  anordnande_nn_1_N = mkN "anordnande" ;
  anpassande_nn_1_N = mkN "anpassande" ;
  anrikande_nn_1_N = mkN "anrikande" ;
  anropande_nn_1_N = mkN "anropande" ;
  anraettande_nn_1_1_N = mkN "anrättande" ;
  ansamlande_nn_1_N = mkN "ansamlande" ;
  ansande_nn_1_N = mkN "ansande" ;
  anseende_nn_1_N = mkN "anseende" ;
  ansikte_nn_1_N = mkN "ansikte" ;
  anskaffande_nn_1_N = mkN "anskaffande" ;
  anslagsaeskande_nn_1_1_N = mkN "anslagsäskande" ;
  anslutande_nn_1_N = mkN "anslutande" ;
  anslaaende_nn_1_1_N = mkN "anslående" ;
  anspelande_nn_1_N = mkN "anspelande" ;
  anstiftande_nn_1_N = mkN "anstiftande" ;
  anstormande_nn_1_N = mkN "anstormande" ;
  anstrykande_nn_1_N = mkN "anstrykande" ;
  anstraengande_nn_1_1_N = mkN "ansträngande" ;
  anstaellande_nn_1_1_N = mkN "anställande" ;
  anstaaende_nn_1_1_N = mkN "anstående" ;
  ansvarande_nn_1_N = mkN "ansvarande" ;
  ansvarsomraade_nn_1_1_N = mkN "ansvarsområde" ;
  ansvarsutkraevande_nn_1_1_N = mkN "ansvarsutkrävande" ;
  ansvaellande_nn_1_1_N = mkN "ansvällande" ;
  ansaettande_nn_1_1_N = mkN "ansättande" ;
  ansoekande_nn_1_1_N = mkN "ansökande" ;
  antagande_nn_1_N = mkN "antagande" ;
  antastande_nn_1_N = mkN "antastande" ;
  anteciperande_nn_1_N = mkN "anteciperande" ;
  antecknande_nn_1_N = mkN "antecknande" ;
  antedaterande_nn_1_N = mkN "antedaterande" ;
  antichambrerande_nn_1_N = mkN "antichambrerande" ;
  antikbehandlande_nn_1_N = mkN "antikbehandlande" ;
  antikfyndande_nn_1_N = mkN "antikfyndande" ;
  antikiserande_nn_1_N = mkN "antikiserande" ;
  antraedande_nn_1_1_N = mkN "anträdande" ;
  antraeffande_nn_1_1_N = mkN "anträffande" ;
  antvardande_nn_1_N = mkN "antvardande" ;
  antydande_nn_1_N = mkN "antydande" ;
  antaendande_nn_1_1_N = mkN "antändande" ;
  antaagande_nn_1_1_N = mkN "antågande" ;
  anvisande_nn_1_N = mkN "anvisande" ;
  anvaendande_nn_1_1_N = mkN "användande" ;
  anvaendningsomraade_nn_1_1_N = mkN "användningsområde" ;
  apostroferande_nn_1_N = mkN "apostroferande" ;
  appellerande_nn_1_N = mkN "appellerande" ;
  applicerande_nn_1_N = mkN "applicerande" ;
  applaaderande_nn_1_1_N = mkN "applåderande" ;
  apporterande_nn_1_N = mkN "apporterande" ;
  apprecierande_nn_1_N = mkN "apprecierande" ;
  appreterande_nn_1_N = mkN "appreterande" ;
  approcherande_nn_1_N = mkN "approcherande" ;
  approximerande_nn_1_N = mkN "approximerande" ;
  apterande_nn_1_N = mkN "apterande" ;
  arbetande_nn_1_N = mkN "arbetande" ;
  arbete_nn_1_N = mkN "arbete" ;
  arbetsbyte_nn_1_N = mkN "arbetsbyte" ;
  arbetsfoerhaallande_nn_1_1_N = mkN "arbetsförhållande" ;
  arbetsgivarintraede_nn_1_1_N = mkN "arbetsgivarinträde" ;
  arbetsminne_nn_1_N = mkN "arbetsminne" ;
  arbetsomraade_nn_1_1_N = mkN "arbetsområde" ;
  arbetspendlande_nn_1_N = mkN "arbetspendlande" ;
  arbetsstycke_nn_1_N = mkN "arbetsstycke" ;
  arbetstillfaelle_nn_1_1_N = mkN "arbetstillfälle" ;
  arborrande_nn_1_N = mkN "arborrande" ;
  arenabygge_nn_1_N = mkN "arenabygge" ;
  argumenterande_nn_1_N = mkN "argumenterande" ;
  arkaiserande_nn_1_N = mkN "arkaiserande" ;
  arkebuserande_nn_1_N = mkN "arkebuserande" ;
  arkivarbete_nn_1_N = mkN "arkivarbete" ;
  arkiverande_nn_1_N = mkN "arkiverande" ;
  armbaagande_nn_1_1_N = mkN "armbågande" ;
  armerande_nn_1_N = mkN "armerande" ;
  arrangerande_nn_1_N = mkN "arrangerande" ;
  arrende_nn_1_N = mkN "arrende" ;
  arrenderande_nn_1_N = mkN "arrenderande" ;
  arresterande_nn_1_N = mkN "arresterande" ;
  arriaergarde_nn_1_1_N = mkN "arriärgarde" ;
  arronderande_nn_1_N = mkN "arronderande" ;
  arsle_nn_1_N = mkN "arsle" ;
  artbestaemmande_nn_1_1_N = mkN "artbestämmande" ;
  artikulationsstaelle_nn_1_1_N = mkN "artikulationsställe" ;
  artikulerande_nn_1_N = mkN "artikulerande" ;
  artilleriregemente_nn_1_N = mkN "artilleriregemente" ;
  artistframtraedande_nn_1_1_N = mkN "artistframträdande" ;
  artonhundratalsmode_nn_1_N = mkN "artonhundratalsmode" ;
  arvode_nn_1_N = mkN "arvode" ;
  arvoderande_nn_1_N = mkN "arvoderande" ;
  arvrike_nn_1_N = mkN "arvrike" ;
  arvskifte_nn_1_N = mkN "arvskifte" ;
  asande_nn_1_N = mkN "asande" ;
  asfalterande_nn_1_N = mkN "asfalterande" ;
  askande_nn_1_N = mkN "askande" ;
  aspirerande_nn_1_N = mkN "aspirerande" ;
  assignerande_nn_1_N = mkN "assignerande" ;
  assimilerande_nn_1_N = mkN "assimilerande" ;
  assisterande_nn_1_N = mkN "assisterande" ;
  associerande_nn_1_N = mkN "associerande" ;
  assurerande_nn_1_N = mkN "assurerande" ;
  atombombande_nn_1_N = mkN "atombombande" ;
  atrofierande_nn_1_N = mkN "atrofierande" ;
  attackerande_nn_1_N = mkN "attackerande" ;
  attesterande_nn_1_N = mkN "attesterande" ;
  attraherande_nn_1_N = mkN "attraherande" ;
  attrapperande_nn_1_N = mkN "attrapperande" ;
  attribuerande_nn_1_N = mkN "attribuerande" ;
  auktionerande_nn_1_N = mkN "auktionerande" ;
  auktoriserande_nn_1_N = mkN "auktoriserande" ;
  auskulterande_nn_1_N = mkN "auskulterande" ;
  autenticerande_nn_1_N = mkN "autenticerande" ;
  autentifierande_nn_1_N = mkN "autentifierande" ;
  autentiserande_nn_1_N = mkN "autentiserande" ;
  automatiserande_nn_1_N = mkN "automatiserande" ;
  avancerande_nn_1_N = mkN "avancerande" ;
  avande_nn_1_N = mkN "avande" ;
  avannonserande_nn_1_N = mkN "avannonserande" ;
  avbalkande_nn_1_N = mkN "avbalkande" ;
  avbestaellande_nn_1_1_N = mkN "avbeställande" ;
  avbetalande_nn_1_N = mkN "avbetalande" ;
  avbetande_nn_1_N = mkN "avbetande" ;
  avbildande_nn_1_N = mkN "avbildande" ;
  avblaasande_nn_1_1_N = mkN "avblåsande" ;
  avbokande_nn_1_N = mkN "avbokande" ;
  avbrytande_nn_1_N = mkN "avbrytande" ;
  avboejande_nn_1_1_N = mkN "avböjande" ;
  avboerdande_nn_1_1_N = mkN "avbördande" ;
  avdagatagande_nn_1_N = mkN "avdagatagande" ;
  avdelande_nn_1_N = mkN "avdelande" ;
  avdramatiserande_nn_1_N = mkN "avdramatiserande" ;
  avdrivande_nn_1_N = mkN "avdrivande" ;
  avdunstande_nn_1_N = mkN "avdunstande" ;
  avdaemmande_nn_1_1_N = mkN "avdämmande" ;
  avdoemande_nn_1_1_N = mkN "avdömande" ;
  ave_nn_1_N = mkN "ave" ;
  avfallande_nn_1_N = mkN "avfallande" ;
  avfattande_nn_1_N = mkN "avfattande" ;
  avfettande_nn_1_N = mkN "avfettande" ;
  avflyttande_nn_1_N = mkN "avflyttande" ;
  avfloede_nn_1_1_N = mkN "avflöde" ;
  avfolkande_nn_1_N = mkN "avfolkande" ;
  avfordrande_nn_1_N = mkN "avfordrande" ;
  avfrostande_nn_1_N = mkN "avfrostande" ;
  avfuktande_nn_1_N = mkN "avfuktande" ;
  avfyrande_nn_1_N = mkN "avfyrande" ;
  avfaerdande_nn_1_1_N = mkN "avfärdande" ;
  avfoerande_nn_1_1_N = mkN "avförande" ;
  avgiftande_nn_1_N = mkN "avgiftande" ;
  avgiftsbelaeggande_nn_1_1_N = mkN "avgiftsbeläggande" ;
  avgivande_nn_1_N = mkN "avgivande" ;
  avgraensande_nn_1_1_N = mkN "avgränsande" ;
  avgudande_nn_1_N = mkN "avgudande" ;
  avgaerdande_nn_1_1_N = mkN "avgärdande" ;
  avgaaende_nn_1_1_N = mkN "avgående" ;
  avgoerande_nn_1_1_N = mkN "avgörande" ;
  avhandlande_nn_1_N = mkN "avhandlande" ;
  avhjaelpande_nn_1_1_N = mkN "avhjälpande" ;
  avhysande_nn_1_N = mkN "avhysande" ;
  avhaemtande_nn_1_1_N = mkN "avhämtande" ;
  avhaendande_nn_1_1_N = mkN "avhändande" ;
  avhaengande_nn_1_1_N = mkN "avhängande" ;
  avhaerdande_nn_1_1_N = mkN "avhärdande" ;
  avhaallande_nn_1_1_N = mkN "avhållande" ;
  avhoerande_nn_1_1_N = mkN "avhörande" ;
  avhoestande_nn_1_1_N = mkN "avhöstande" ;
  avisande_nn_1_N = mkN "avisande" ;
  aviserande_nn_1_N = mkN "aviserande" ;
  avjagande_nn_1_N = mkN "avjagande" ;
  avjaemnande_nn_1_1_N = mkN "avjämnande" ;
  avkalkande_nn_1_N = mkN "avkalkande" ;
  avkastande_nn_1_N = mkN "avkastande" ;
  avklarande_nn_1_N = mkN "avklarande" ;
  avklingande_nn_1_N = mkN "avklingande" ;
  avklaedande_nn_1_1_N = mkN "avklädande" ;
  avknoppande_nn_1_N = mkN "avknoppande" ;
  avkoloniserande_nn_1_N = mkN "avkoloniserande" ;
  avkopplande_nn_1_N = mkN "avkopplande" ;
  avkortande_nn_1_N = mkN "avkortande" ;
  avkriminaliserande_nn_1_N = mkN "avkriminaliserande" ;
  avkristnande_nn_1_N = mkN "avkristnande" ;
  avkraevande_nn_1_1_N = mkN "avkrävande" ;
  avkunnande_nn_1_N = mkN "avkunnande" ;
  avkoenande_nn_1_1_N = mkN "avkönande" ;
  avlagrande_nn_1_N = mkN "avlagrande" ;
  avlande_nn_1_N = mkN "avlande" ;
  avlastande_nn_1_N = mkN "avlastande" ;
  avledande_nn_1_N = mkN "avledande" ;
  avlidande_nn_1_N = mkN "avlidande" ;
  avlinge_nn_1_N = mkN "avlinge" ;
  avlivande_nn_1_N = mkN "avlivande" ;
  avlockande_nn_1_N = mkN "avlockande" ;
  avloppsdike_nn_1_N = mkN "avloppsdike" ;
  avlossande_nn_1_N = mkN "avlossande" ;
  avlusande_nn_1_N = mkN "avlusande" ;
  avlutande_nn_1_N = mkN "avlutande" ;
  avlysande_nn_1_N = mkN "avlysande" ;
  avlyssnande_nn_1_N = mkN "avlyssnande" ;
  avlaeggande_nn_1_1_N = mkN "avläggande" ;
  avlaegsnande_nn_1_1_N = mkN "avlägsnande" ;
  avlaemnande_nn_1_1_N = mkN "avlämnande" ;
  avlaenkande_nn_1_1_N = mkN "avlänkande" ;
  avlaesande_nn_1_1_N = mkN "avläsande" ;
  avlaatande_nn_1_1_N = mkN "avlåtande" ;
  avloenande_nn_1_1_N = mkN "avlönande" ;
  avloepande_nn_1_1_N = mkN "avlöpande" ;
  avloesande_nn_1_1_N = mkN "avlösande" ;
  avloevande_nn_1_1_N = mkN "avlövande" ;
  avmagnetiserande_nn_1_N = mkN "avmagnetiserande" ;
  avmaskande_nn_1_N = mkN "avmaskande" ;
  avmastande_nn_1_N = mkN "avmastande" ;
  avmattande_nn_1_N = mkN "avmattande" ;
  avmaetande_nn_1_1_N = mkN "avmätande" ;
  avnavlande_nn_1_N = mkN "avnavlande" ;
  avnazifierande_nn_1_N = mkN "avnazifierande" ;
  avnjutande_nn_1_N = mkN "avnjutande" ;
  avpassande_nn_1_N = mkN "avpassande" ;
  avpatrullerande_nn_1_N = mkN "avpatrullerande" ;
  avplanande_nn_1_N = mkN "avplanande" ;
  avpolitiserande_nn_1_N = mkN "avpolitiserande" ;
  avpolletterande_nn_1_N = mkN "avpolletterande" ;
  avportraetterande_nn_1_1_N = mkN "avporträtterande" ;
  avpressande_nn_1_N = mkN "avpressande" ;
  avreagerande_nn_1_N = mkN "avreagerande" ;
  avredande_nn_1_N = mkN "avredande" ;
  avregistrerande_nn_1_N = mkN "avregistrerande" ;
  avreglerande_nn_1_N = mkN "avreglerande" ;
  avresande_nn_1_N = mkN "avresande" ;
  avrinnande_nn_1_N = mkN "avrinnande" ;
  avromantiserande_nn_1_N = mkN "avromantiserande" ;
  avrundande_nn_1_N = mkN "avrundande" ;
  avrustande_nn_1_N = mkN "avrustande" ;
  avraeknande_nn_1_1_N = mkN "avräknande" ;
  avraettande_nn_1_1_N = mkN "avrättande" ;
  avraadande_nn_1_1_N = mkN "avrådande" ;
  avsaltande_nn_1_N = mkN "avsaltande" ;
  avseende_nn_1_N = mkN "avseende" ;
  avseglande_nn_1_N = mkN "avseglande" ;
  avsjungande_nn_1_N = mkN "avsjungande" ;
  avskaffande_nn_1_N = mkN "avskaffande" ;
  avskavande_nn_1_N = mkN "avskavande" ;
  avskedande_nn_1_N = mkN "avskedande" ;
  avskedstagande_nn_1_N = mkN "avskedstagande" ;
  avskiljande_nn_1_N = mkN "avskiljande" ;
  avskjutande_nn_1_N = mkN "avskjutande" ;
  avskrivande_nn_1_N = mkN "avskrivande" ;
  avskraeckande_nn_1_1_N = mkN "avskräckande" ;
  avskraedande_nn_1_1_N = mkN "avskrädande" ;
  avskraede_nn_1_1_N = mkN "avskräde" ;
  avskyende_nn_1_N = mkN "avskyende" ;
  avskaerande_nn_1_1_N = mkN "avskärande" ;
  avskaermande_nn_1_1_N = mkN "avskärmande" ;
  avslipande_nn_1_N = mkN "avslipande" ;
  avslitande_nn_1_N = mkN "avslitande" ;
  avslutande_nn_1_N = mkN "avslutande" ;
  avslaaende_nn_1_1_N = mkN "avslående" ;
  avsloejande_nn_1_1_N = mkN "avslöjande" ;
  avsmakande_nn_1_N = mkN "avsmakande" ;
  avsmalnande_nn_1_N = mkN "avsmalnande" ;
  avsnoppande_nn_1_N = mkN "avsnoppande" ;
  avsnoerande_nn_1_1_N = mkN "avsnörande" ;
  avsocialiserande_nn_1_N = mkN "avsocialiserande" ;
  avsomnande_nn_1_N = mkN "avsomnande" ;
  avspeglande_nn_1_N = mkN "avspeglande" ;
  avspelande_nn_1_N = mkN "avspelande" ;
  avspisande_nn_1_N = mkN "avspisande" ;
  avspaerrande_nn_1_1_N = mkN "avspärrande" ;
  avstaliniserande_nn_1_N = mkN "avstaliniserande" ;
  avstannande_nn_1_N = mkN "avstannande" ;
  avstavande_nn_1_N = mkN "avstavande" ;
  avstressande_nn_1_N = mkN "avstressande" ;
  avstyckande_nn_1_N = mkN "avstyckande" ;
  avstyrande_nn_1_N = mkN "avstyrande" ;
  avstyrkande_nn_1_N = mkN "avstyrkande" ;
  avstaellande_nn_1_1_N = mkN "avställande" ;
  avstaemmande_nn_1_1_N = mkN "avstämmande" ;
  avstaengande_nn_1_1_N = mkN "avstängande" ;
  avstaaende_nn_1_1_N = mkN "avstående" ;
  avstaandstagande_nn_1_1_N = mkN "avståndstagande" ;
  avstoerande_nn_1_1_N = mkN "avstörande" ;
  avstoetande_nn_1_1_N = mkN "avstötande" ;
  avsvalnande_nn_1_N = mkN "avsvalnande" ;
  avsvavlande_nn_1_N = mkN "avsvavlande" ;
  avsvimmande_nn_1_N = mkN "avsvimmande" ;
  avsvaerjande_nn_1_1_N = mkN "avsvärjande" ;
  avsynande_nn_1_N = mkN "avsynande" ;
  avsaegande_nn_1_1_N = mkN "avsägande" ;
  avsaendande_nn_1_1_N = mkN "avsändande" ;
  avsaagande_nn_1_1_N = mkN "avsågande" ;
  avsoekande_nn_1_1_N = mkN "avsökande" ;
  avsoendrande_nn_1_1_N = mkN "avsöndrande" ;
  avtackande_nn_1_N = mkN "avtackande" ;
  avtalande_nn_1_N = mkN "avtalande" ;
  avtappande_nn_1_N = mkN "avtappande" ;
  avtecknande_nn_1_N = mkN "avtecknande" ;
  avtjaenande_nn_1_1_N = mkN "avtjänande" ;
  avtonande_nn_1_N = mkN "avtonande" ;
  avtrappande_nn_1_N = mkN "avtrappande" ;
  avtrubbande_nn_1_N = mkN "avtrubbande" ;
  avtraedande_nn_1_1_N = mkN "avträdande" ;
  avtraede_nn_1_1_N = mkN "avträde" ;
  avtunnande_nn_1_N = mkN "avtunnande" ;
  avtvingande_nn_1_N = mkN "avtvingande" ;
  avtvaaende_nn_1_1_N = mkN "avtvående" ;
  avtaeckande_nn_1_1_N = mkN "avtäckande" ;
  avtaagande_nn_1_1_N = mkN "avtågande" ;
  avvaktande_nn_1_N = mkN "avvaktande" ;
  avvarande_nn_1_N = mkN "avvarande" ;
  avvattnande_nn_1_N = mkN "avvattnande" ;
  avvecklande_nn_1_N = mkN "avvecklande" ;
  avverkande_nn_1_N = mkN "avverkande" ;
  avverkningsarbete_nn_1_N = mkN "avverkningsarbete" ;
  avvikande_nn_1_N = mkN "avvikande" ;
  avvinnande_nn_1_N = mkN "avvinnande" ;
  avvisande_nn_1_N = mkN "avvisande" ;
  avvitande_nn_1_N = mkN "avvitande" ;
  avvittrande_nn_1_N = mkN "avvittrande" ;
  avvaegande_nn_1_1_N = mkN "avvägande" ;
  avvaendande_nn_1_1_N = mkN "avvändande" ;
  avvaenjande_nn_1_1_N = mkN "avvänjande" ;
  avvaepnande_nn_1_1_N = mkN "avväpnande" ;
  avvaerjande_nn_1_1_N = mkN "avvärjande" ;
  avyttrande_nn_1_N = mkN "avyttrande" ;
  avaetande_nn_1_1_N = mkN "avätande" ;
  axiomatiserande_nn_1_N = mkN "axiomatiserande" ;
  axlande_nn_1_N = mkN "axlande" ;
  babblande_nn_1_N = mkN "babblande" ;
  backande_nn_1_N = mkN "backande" ;
  backupande_nn_1_N = mkN "backupande" ;
  backuppande_nn_1_N = mkN "backuppande" ;
  badande_nn_1_N = mkN "badande" ;
  baddande_nn_1_N = mkN "baddande" ;
  badstaelle_nn_1_1_N = mkN "badställe" ;
  bagageutrymme_nn_1_N = mkN "bagageutrymme" ;
  bagatelliserande_nn_1_N = mkN "bagatelliserande" ;
  baggboelande_nn_1_1_N = mkN "baggbölande" ;
  baissande_nn_1_N = mkN "baissande" ;
  bajsande_nn_1_N = mkN "bajsande" ;
  bakande_nn_1_N = mkN "bakande" ;
  bakbindande_nn_1_N = mkN "bakbindande" ;
  bakstycke_nn_1_N = mkN "bakstycke" ;
  baksaete_nn_1_1_N = mkN "baksäte" ;
  baktalande_nn_1_N = mkN "baktalande" ;
  balande_nn_1_N = mkN "balande" ;
  balanserande_nn_1_N = mkN "balanserande" ;
  balanssinne_nn_1_N = mkN "balanssinne" ;
  balloterande_nn_1_N = mkN "balloterande" ;
  balsamerande_nn_1_N = mkN "balsamerande" ;
  banaliserande_nn_1_N = mkN "banaliserande" ;
  bandande_nn_1_N = mkN "bandande" ;
  bankande_nn_1_N = mkN "bankande" ;
  bankrutterande_nn_1_N = mkN "bankrutterande" ;
  banksparande_nn_1_N = mkN "banksparande" ;
  bannande_nn_1_N = mkN "bannande" ;
  bannlysande_nn_1_N = mkN "bannlysande" ;
  bantande_nn_1_N = mkN "bantande" ;
  barkande_nn_1_N = mkN "barkande" ;
  barkympande_nn_1_N = mkN "barkympande" ;
  barlastande_nn_1_N = mkN "barlastande" ;
  barnalstrande_nn_1_N = mkN "barnalstrande" ;
  barnansikte_nn_1_N = mkN "barnansikte" ;
  barnasinne_nn_1_N = mkN "barnasinne" ;
  barrande_nn_1_N = mkN "barrande" ;
  barrikaderande_nn_1_N = mkN "barrikaderande" ;
  basande_nn_1_N = mkN "basande" ;
  baserande_nn_1_N = mkN "baserande" ;
  bastande_nn_1_N = mkN "bastande" ;
  batongsvingande_nn_1_N = mkN "batongsvingande" ;
  baxande_nn_1_N = mkN "baxande" ;
  baxnande_nn_1_N = mkN "baxnande" ;
  bearbetande_nn_1_N = mkN "bearbetande" ;
  beboende_nn_1_N = mkN "beboende" ;
  bebyggande_nn_1_N = mkN "bebyggande" ;
  bebaadande_nn_1_1_N = mkN "bebådande" ;
  beckande_nn_1_N = mkN "beckande" ;
  bedarrande_nn_1_N = mkN "bedarrande" ;
  bedragande_nn_1_N = mkN "bedragande" ;
  bedrivande_nn_1_N = mkN "bedrivande" ;
  bedroevande_nn_1_1_N = mkN "bedrövande" ;
  bedyrande_nn_1_N = mkN "bedyrande" ;
  bedaarande_nn_1_1_N = mkN "bedårande" ;
  bedoemande_nn_1_1_N = mkN "bedömande" ;
  bedoevande_nn_1_1_N = mkN "bedövande" ;
  beedigande_nn_1_N = mkN "beedigande" ;
  befallande_nn_1_N = mkN "befallande" ;
  befarande_nn_1_N = mkN "befarande" ;
  beflaeckande_nn_1_1_N = mkN "befläckande" ;
  befolkande_nn_1_N = mkN "befolkande" ;
  befordrande_nn_1_N = mkN "befordrande" ;
  befraktande_nn_1_N = mkN "befraktande" ;
  befriande_nn_1_N = mkN "befriande" ;
  befruktande_nn_1_N = mkN "befruktande" ;
  befryndande_nn_1_N = mkN "befryndande" ;
  befraemjande_nn_1_1_N = mkN "befrämjande" ;
  befullmaektigande_nn_1_1_N = mkN "befullmäktigande" ;
  befaestande_nn_1_1_N = mkN "befästande" ;
  begagnande_nn_1_N = mkN "begagnande" ;
  begapande_nn_1_N = mkN "begapande" ;
  begivande_nn_1_N = mkN "begivande" ;
  begjutande_nn_1_N = mkN "begjutande" ;
  beglaensande_nn_1_1_N = mkN "beglänsande" ;
  begravande_nn_1_N = mkN "begravande" ;
  begripande_nn_1_N = mkN "begripande" ;
  begrundande_nn_1_N = mkN "begrundande" ;
  begraensande_nn_1_1_N = mkN "begränsande" ;
  begraatande_nn_1_1_N = mkN "begråtande" ;
  begynnande_nn_1_N = mkN "begynnande" ;
  begynnelseskede_nn_1_N = mkN "begynnelseskede" ;
  begynnelsevaerde_nn_1_1_N = mkN "begynnelsevärde" ;
  begaerande_nn_1_1_N = mkN "begärande" ;
  begaaende_nn_1_1_N = mkN "begående" ;
  begaavande_nn_1_1_N = mkN "begåvande" ;
  behagande_nn_1_N = mkN "behagande" ;
  behandlande_nn_1_N = mkN "behandlande" ;
  behaengande_nn_1_1_N = mkN "behängande" ;
  behaerskande_nn_1_1_N = mkN "behärskande" ;
  behaallande_nn_1_1_N = mkN "behållande" ;
  behoevande_nn_1_1_N = mkN "behövande" ;
  beivrande_nn_1_N = mkN "beivrande" ;
  bejakande_nn_1_N = mkN "bejakande" ;
  bejublande_nn_1_N = mkN "bejublande" ;
  bekajande_nn_1_N = mkN "bekajande" ;
  bekantgoerande_nn_1_1_N = mkN "bekantgörande" ;
  bekikande_nn_1_N = mkN "bekikande" ;
  beklagande_nn_1_N = mkN "beklagande" ;
  beklaedande_nn_1_1_N = mkN "beklädande" ;
  beknipande_nn_1_N = mkN "beknipande" ;
  bekommande_nn_1_N = mkN "bekommande" ;
  bekostande_nn_1_N = mkN "bekostande" ;
  bekransande_nn_1_N = mkN "bekransande" ;
  bekrigande_nn_1_N = mkN "bekrigande" ;
  bekraeftande_nn_1_1_N = mkN "bekräftande" ;
  bekroenande_nn_1_1_N = mkN "bekrönande" ;
  bekymrande_nn_1_N = mkN "bekymrande" ;
  bekaempande_nn_1_1_N = mkN "bekämpande" ;
  bekaennande_nn_1_1_N = mkN "bekännande" ;
  belamrande_nn_1_N = mkN "belamrande" ;
  belangande_nn_1_N = mkN "belangande" ;
  belastande_nn_1_N = mkN "belastande" ;
  beledsagande_nn_1_N = mkN "beledsagande" ;
  beleende_nn_1_N = mkN "beleende" ;
  beljugande_nn_1_N = mkN "beljugande" ;
  belysande_nn_1_N = mkN "belysande" ;
  belaeggande_nn_1_1_N = mkN "beläggande" ;
  belaeggningssnoere_nn_1_1_N = mkN "beläggningssnöre" ;
  belaegrande_nn_1_1_N = mkN "belägrande" ;
  belaete_nn_1_1_N = mkN "beläte" ;
  belaanande_nn_1_1_N = mkN "belånande" ;
  beloenande_nn_1_1_N = mkN "belönande" ;
  bemannande_nn_1_N = mkN "bemannande" ;
  bemantlande_nn_1_N = mkN "bemantlande" ;
  bemedlande_nn_1_N = mkN "bemedlande" ;
  bemyndigande_nn_1_N = mkN "bemyndigande" ;
  bemaengande_nn_1_1_N = mkN "bemängande" ;
  bemaerkande_nn_1_1_N = mkN "bemärkande" ;
  bemaestrande_nn_1_1_N = mkN "bemästrande" ;
  bemoedande_nn_1_1_N = mkN "bemödande" ;
  benande_nn_1_N = mkN "benande" ;
  benaemnande_nn_1_1_N = mkN "benämnande" ;
  benaadande_nn_1_1_N = mkN "benådande" ;
  beordrande_nn_1_N = mkN "beordrande" ;
  bepansrande_nn_1_N = mkN "bepansrande" ;
  beprisande_nn_1_N = mkN "beprisande" ;
  beprydande_nn_1_N = mkN "beprydande" ;
  bepudrande_nn_1_N = mkN "bepudrande" ;
  beredande_nn_1_N = mkN "beredande" ;
  beredskapsarbete_nn_1_N = mkN "beredskapsarbete" ;
  bergsomraade_nn_1_1_N = mkN "bergsområde" ;
  berikande_nn_1_N = mkN "berikande" ;
  beriktigande_nn_1_N = mkN "beriktigande" ;
  beroende_nn_2_N = mkN "beroende" ;
  berusande_nn_1_N = mkN "berusande" ;
  beraeknande_nn_1_1_N = mkN "beräknande" ;
  beraettande_nn_1_1_N = mkN "berättande" ;
  beroemmande_nn_1_1_N = mkN "berömmande" ;
  beroerande_nn_1_1_N = mkN "berörande" ;
  beroevande_nn_1_1_N = mkN "berövande" ;
  besannande_nn_1_N = mkN "besannande" ;
  beseglande_nn_1_N = mkN "beseglande" ;
  besegrande_nn_1_N = mkN "besegrande" ;
  besiktigande_nn_1_N = mkN "besiktigande" ;
  besinnande_nn_1_N = mkN "besinnande" ;
  besittande_nn_1_N = mkN "besittande" ;
  besjungande_nn_1_N = mkN "besjungande" ;
  besjaelande_nn_1_1_N = mkN "besjälande" ;
  beskattande_nn_1_N = mkN "beskattande" ;
  beskickande_nn_1_N = mkN "beskickande" ;
  beskjutande_nn_1_N = mkN "beskjutande" ;
  beskrivande_nn_1_N = mkN "beskrivande" ;
  beskuggande_nn_1_N = mkN "beskuggande" ;
  beskyddande_nn_1_N = mkN "beskyddande" ;
  beskyllande_nn_1_N = mkN "beskyllande" ;
  beskaerande_nn_1_1_N = mkN "beskärande" ;
  beskaermande_nn_1_1_N = mkN "beskärmande" ;
  beslaglaeggande_nn_1_1_N = mkN "beslagläggande" ;
  beslagssmide_nn_1_N = mkN "beslagssmide" ;
  beslagtagande_nn_1_N = mkN "beslagtagande" ;
  beslutande_nn_1_N = mkN "beslutande" ;
  beslaaende_nn_1_1_N = mkN "beslående" ;
  besloejande_nn_1_1_N = mkN "beslöjande" ;
  besmittande_nn_1_N = mkN "besmittande" ;
  besmoerjande_nn_1_1_N = mkN "besmörjande" ;
  besockrande_nn_1_N = mkN "besockrande" ;
  besoldande_nn_1_N = mkN "besoldande" ;
  besparande_nn_1_N = mkN "besparande" ;
  bespejande_nn_1_N = mkN "bespejande" ;
  bespisande_nn_1_N = mkN "bespisande" ;
  bespolande_nn_1_N = mkN "bespolande" ;
  bespottande_nn_1_N = mkN "bespottande" ;
  besprutande_nn_1_N = mkN "besprutande" ;
  bestickande_nn_1_N = mkN "bestickande" ;
  bestigande_nn_1_N = mkN "bestigande" ;
  bestjaelande_nn_1_1_N = mkN "bestjälande" ;
  bestormande_nn_1_N = mkN "bestormande" ;
  bestraffande_nn_1_N = mkN "bestraffande" ;
  bestridande_nn_1_N = mkN "bestridande" ;
  bestrykande_nn_1_N = mkN "bestrykande" ;
  bestraalande_nn_1_1_N = mkN "bestrålande" ;
  bestroeende_nn_1_1_N = mkN "beströende" ;
  bestyckande_nn_1_N = mkN "bestyckande" ;
  bestyrande_nn_1_N = mkN "bestyrande" ;
  bestyrkande_nn_1_N = mkN "bestyrkande" ;
  bestaellande_nn_1_1_N = mkN "beställande" ;
  bestaellningsarbete_nn_1_1_N = mkN "beställningsarbete" ;
  bestaemmande_nn_1_1_N = mkN "bestämmande" ;
  bestaenkande_nn_1_1_N = mkN "bestänkande" ;
  bestaaende_nn_1_1_N = mkN "bestående" ;
  besvarande_nn_1_N = mkN "besvarande" ;
  besvaerande_nn_1_1_N = mkN "besvärande" ;
  besvaerjande_nn_1_1_N = mkN "besvärjande" ;
  besaettande_nn_1_1_N = mkN "besättande" ;
  besaaende_nn_1_1_N = mkN "besående" ;
  besoekande_nn_2_1_N = mkN "besökande" ;
  besoerjande_nn_1_1_N = mkN "besörjande" ;
  betagande_nn_1_N = mkN "betagande" ;
  betalande_nn_1_N = mkN "betalande" ;
  betalningsfoerelaeggande_nn_1_1_N = mkN "betalningsföreläggande" ;
  betande_nn_1_N = mkN "betande" ;
  bete_nn_1_N = mkN "bete" ;
  betecknande_nn_1_N = mkN "betecknande" ;
  beteende_nn_1_N = mkN "beteende" ;
  betesomraade_nn_1_1_N = mkN "betesområde" ;
  betingande_nn_1_N = mkN "betingande" ;
  betingsarbete_nn_1_N = mkN "betingsarbete" ;
  betitlande_nn_1_N = mkN "betitlande" ;
  betittande_nn_1_N = mkN "betittande" ;
  betjaenande_nn_1_1_N = mkN "betjänande" ;
  betonande_nn_1_N = mkN "betonande" ;
  betongerande_nn_1_N = mkN "betongerande" ;
  betroende_nn_1_N = mkN "betroende" ;
  betryckande_nn_1_N = mkN "betryckande" ;
  betryggande_nn_1_N = mkN "betryggande" ;
  betraedande_nn_1_1_N = mkN "beträdande" ;
  betraeffande_nn_1_1_N = mkN "beträffande" ;
  betsande_nn_1_N = mkN "betsande" ;
  betslande_nn_1_N = mkN "betslande" ;
  bettlande_nn_1_N = mkN "bettlande" ;
  betungande_nn_1_N = mkN "betungande" ;
  betvingande_nn_1_N = mkN "betvingande" ;
  betvivlande_nn_1_N = mkN "betvivlande" ;
  betydande_nn_1_N = mkN "betydande" ;
  betygande_nn_1_N = mkN "betygande" ;
  betygssaettande_nn_1_1_N = mkN "betygssättande" ;
  betygsaettande_nn_1_1_N = mkN "betygsättande" ;
  betaeckande_nn_1_1_N = mkN "betäckande" ;
  betaenkande_nn_1_1_N = mkN "betänkande" ;
  beundrande_nn_1_N = mkN "beundrande" ;
  bevakande_nn_1_N = mkN "bevakande" ;
  bevakningsomraade_nn_1_1_N = mkN "bevakningsområde" ;
  bevarande_nn_1_N = mkN "bevarande" ;
  bevattnande_nn_1_N = mkN "bevattnande" ;
  bevekande_nn_1_N = mkN "bevekande" ;
  beviljande_nn_1_N = mkN "beviljande" ;
  bevisande_nn_1_N = mkN "bevisande" ;
  bevistande_nn_1_N = mkN "bevistande" ;
  bevisvaerde_nn_1_1_N = mkN "bevisvärde" ;
  bevittnande_nn_1_N = mkN "bevittnande" ;
  bevaepnande_nn_1_1_N = mkN "beväpnande" ;
  bevaerande_nn_1_1_N = mkN "bevärande" ;
  bevaerdigande_nn_1_1_N = mkN "bevärdigande" ;
  bibehaallande_nn_1_1_N = mkN "bibehållande" ;
  bibelstaelle_nn_1_1_N = mkN "bibelställe" ;
  bibringande_nn_1_N = mkN "bibringande" ;
  bidande_nn_1_N = mkN "bidande" ;
  bidragande_nn_1_N = mkN "bidragande" ;
  bifallande_nn_1_N = mkN "bifallande" ;
  bifloede_nn_1_1_N = mkN "biflöde" ;
  bifogande_nn_1_N = mkN "bifogande" ;
  biktande_nn_1_N = mkN "biktande" ;
  bilande_nn_1_N = mkN "bilande" ;
  bilbaelte_nn_1_1_N = mkN "bilbälte" ;
  bildande_nn_1_N = mkN "bildande" ;
  bildfloede_nn_1_1_N = mkN "bildflöde" ;
  biljetthaefte_nn_1_1_N = mkN "biljetthäfte" ;
  bilmaerke_nn_1_1_N = mkN "bilmärke" ;
  bilsaete_nn_1_1_N = mkN "bilsäte" ;
  bilaeggande_nn_1_1_N = mkN "biläggande" ;
  bindande_nn_1_N = mkN "bindande" ;
  bindsle_nn_1_N = mkN "bindsle" ;
  bindaemne_nn_1_1_N = mkN "bindämne" ;
  biobraensle_nn_1_1_N = mkN "biobränsle" ;
  biograferande_nn_1_N = mkN "biograferande" ;
  bisamhaelle_nn_1_1_N = mkN "bisamhälle" ;
  biskopsdoeme_nn_1_1_N = mkN "biskopsdöme" ;
  biskopsmoete_nn_1_1_N = mkN "biskopsmöte" ;
  biskopssaete_nn_1_1_N = mkN "biskopssäte" ;
  bispringande_nn_1_N = mkN "bispringande" ;
  bisserande_nn_1_N = mkN "bisserande" ;
  bistraeckande_nn_1_1_N = mkN "bisträckande" ;
  bistaaende_nn_1_1_N = mkN "bistående" ;
  bisaettande_nn_1_1_N = mkN "bisättande" ;
  bitande_nn_1_N = mkN "bitande" ;
  bitmaerke_nn_1_1_N = mkN "bitmärke" ;
  bitraedande_nn_1_1_N = mkN "biträdande" ;
  bitraede_nn_1_1_N = mkN "biträde" ;
  bivackerande_nn_1_N = mkN "bivackerande" ;
  biaemne_nn_1_1_N = mkN "biämne" ;
  bjudande_nn_1_N = mkN "bjudande" ;
  bjussande_nn_1_N = mkN "bjussande" ;
  bjaebbande_nn_1_1_N = mkN "bjäbbande" ;
  bjoernande_nn_1_1_N = mkN "björnande" ;
  bjoernbindsle_nn_1_1_N = mkN "björnbindsle" ;
  bjoernide_nn_1_1_N = mkN "björnide" ;
  bladande_nn_1_N = mkN "bladande" ;
  bladbyte_nn_1_N = mkN "bladbyte" ;
  bladdrande_nn_1_N = mkN "bladdrande" ;
  blajande_nn_1_N = mkN "blajande" ;
  blancherande_nn_1_N = mkN "blancherande" ;
  blandande_nn_1_N = mkN "blandande" ;
  blandningsfoerhaallande_nn_1_1_N = mkN "blandningsförhållande" ;
  blankande_nn_1_N = mkN "blankande" ;
  blankpolerande_nn_1_N = mkN "blankpolerande" ;
  blarrande_nn_1_N = mkN "blarrande" ;
  blaskande_nn_1_N = mkN "blaskande" ;
  blekande_nn_1_N = mkN "blekande" ;
  blekansikte_nn_1_N = mkN "blekansikte" ;
  bleknande_nn_1_N = mkN "bleknande" ;
  blesserande_nn_1_N = mkN "blesserande" ;
  blickande_nn_1_N = mkN "blickande" ;
  blidkande_nn_1_N = mkN "blidkande" ;
  bliende_nn_1_N = mkN "bliende" ;
  bligande_nn_1_N = mkN "bligande" ;
  blinderande_nn_1_N = mkN "blinderande" ;
  blindpressande_nn_1_N = mkN "blindpressande" ;
  blindstyre_nn_1_N = mkN "blindstyre" ;
  blinkande_nn_1_N = mkN "blinkande" ;
  blippande_nn_1_N = mkN "blippande" ;
  blivande_nn_1_N = mkN "blivande" ;
  blixtfotograferande_nn_1_N = mkN "blixtfotograferande" ;
  blixtinkallande_nn_1_N = mkN "blixtinkallande" ;
  blixtrande_nn_1_N = mkN "blixtrande" ;
  blockande_nn_1_N = mkN "blockande" ;
  blockerande_nn_1_N = mkN "blockerande" ;
  blockaemne_nn_1_1_N = mkN "blockämne" ;
  blodande_nn_1_N = mkN "blodande" ;
  blodfloede_nn_1_1_N = mkN "blodflöde" ;
  blodfaergaemne_nn_1_1_N = mkN "blodfärgämne" ;
  blodvite_nn_1_N = mkN "blodvite" ;
  blodvaerde_nn_1_1_N = mkN "blodvärde" ;
  bloggande_nn_1_N = mkN "bloggande" ;
  blomfaeste_nn_1_1_N = mkN "blomfäste" ;
  blomhylle_nn_1_N = mkN "blomhylle" ;
  blomhaenge_nn_1_1_N = mkN "blomhänge" ;
  blomknippe_nn_1_N = mkN "blomknippe" ;
  blommande_nn_1_N = mkN "blommande" ;
  blommograferande_nn_1_N = mkN "blommograferande" ;
  blomstrande_nn_1_N = mkN "blomstrande" ;
  blonderande_nn_1_N = mkN "blonderande" ;
  blossande_nn_1_N = mkN "blossande" ;
  blotande_nn_1_N = mkN "blotande" ;
  blottande_nn_1_N = mkN "blottande" ;
  blottlaeggande_nn_1_1_N = mkN "blottläggande" ;
  bluddrande_nn_1_N = mkN "bluddrande" ;
  bluffande_nn_1_N = mkN "bluffande" ;
  bluffbygge_nn_1_N = mkN "bluffbygge" ;
  blundande_nn_1_N = mkN "blundande" ;
  blyande_nn_1_N = mkN "blyande" ;
  blaeckande_nn_1_1_N = mkN "bläckande" ;
  blaedande_nn_1_1_N = mkN "blädande" ;
  blaeddrande_nn_1_1_N = mkN "bläddrande" ;
  blaendande_nn_1_1_N = mkN "bländande" ;
  blaende_nn_1_1_N = mkN "blände" ;
  blaengande_nn_1_1_N = mkN "blängande" ;
  blaenkande_nn_1_1_N = mkN "blänkande" ;
  blaenke_nn_1_1_N = mkN "blänke" ;
  blaestande_nn_1_1_N = mkN "blästande" ;
  blaestrande_nn_1_1_N = mkN "blästrande" ;
  blaakopierande_nn_1_1_N = mkN "blåkopierande" ;
  blaakoerande_nn_1_1_N = mkN "blåkörande" ;
  blaamaerke_nn_1_1_N = mkN "blåmärke" ;
  blaanande_nn_1_1_N = mkN "blånande" ;
  blaanekande_nn_1_1_N = mkN "blånekande" ;
  blaasande_nn_1_1_N = mkN "blåsande" ;
  bloedande_nn_1_1_N = mkN "blödande" ;
  bloejbyte_nn_1_1_N = mkN "blöjbyte" ;
  bloetande_nn_1_1_N = mkN "blötande" ;
  bloetlaeggande_nn_1_1_N = mkN "blötläggande" ;
  bloetnande_nn_1_1_N = mkN "blötnande" ;
  boaserande_nn_1_N = mkN "boaserande" ;
  bobbande_nn_1_N = mkN "bobbande" ;
  bockande_nn_1_N = mkN "bockande" ;
  boende_nn_1_N = mkN "boende" ;
  bogserande_nn_1_N = mkN "bogserande" ;
  bojkottande_nn_1_N = mkN "bojkottande" ;
  bokande_nn_1_N = mkN "bokande" ;
  bokfoerande_nn_1_1_N = mkN "bokförande" ;
  bokmaerke_nn_1_1_N = mkN "bokmärke" ;
  boknande_nn_1_N = mkN "boknande" ;
  bokstaverande_nn_1_N = mkN "bokstaverande" ;
  bolande_nn_1_N = mkN "bolande" ;
  bollande_nn_1_N = mkN "bollande" ;
  bollsinne_nn_1_N = mkN "bollsinne" ;
  bolmande_nn_1_N = mkN "bolmande" ;
  bombande_nn_1_N = mkN "bombande" ;
  bombarderande_nn_1_N = mkN "bombarderande" ;
  bombsikte_nn_1_N = mkN "bombsikte" ;
  bommande_nn_1_N = mkN "bommande" ;
  bomaerke_nn_1_1_N = mkN "bomärke" ;
  bonande_nn_1_N = mkN "bonande" ;
  bondesamhaelle_nn_1_1_N = mkN "bondesamhälle" ;
  bondnekande_nn_1_N = mkN "bondnekande" ;
  bongande_nn_1_N = mkN "bongande" ;
  boniterande_nn_1_N = mkN "boniterande" ;
  boomande_nn_1_N = mkN "boomande" ;
  bordande_nn_1_N = mkN "bordande" ;
  bordlaeggande_nn_1_1_N = mkN "bordläggande" ;
  borgande_nn_1_N = mkN "borgande" ;
  borgardoeme_nn_1_1_N = mkN "borgardöme" ;
  borgargarde_nn_1_N = mkN "borgargarde" ;
  borgensaatagande_nn_1_1_N = mkN "borgensåtagande" ;
  bornerande_nn_1_N = mkN "bornerande" ;
  borrande_nn_1_N = mkN "borrande" ;
  borstande_nn_1_N = mkN "borstande" ;
  bortarbetande_nn_1_N = mkN "bortarbetande" ;
  bortdomnande_nn_1_N = mkN "bortdomnande" ;
  bortdrivande_nn_1_N = mkN "bortdrivande" ;
  bortdoeende_nn_1_1_N = mkN "bortdöende" ;
  bortfallande_nn_1_N = mkN "bortfallande" ;
  bortforslande_nn_1_N = mkN "bortforslande" ;
  bortfoerande_nn_1_1_N = mkN "bortförande" ;
  bortfoerklarande_nn_1_1_N = mkN "bortförklarande" ;
  bortgaaende_nn_1_1_N = mkN "bortgående" ;
  bortlovande_nn_1_N = mkN "bortlovande" ;
  bortmotande_nn_1_N = mkN "bortmotande" ;
  bortopererande_nn_1_N = mkN "bortopererande" ;
  bortrationaliserande_nn_1_N = mkN "bortrationaliserande" ;
  bortresonerande_nn_1_N = mkN "bortresonerande" ;
  bortrinnande_nn_1_N = mkN "bortrinnande" ;
  bortraeknande_nn_1_1_N = mkN "borträknande" ;
  bortroevande_nn_1_1_N = mkN "bortrövande" ;
  bortseende_nn_1_N = mkN "bortseende" ;
  bortskraemmande_nn_1_1_N = mkN "bortskrämmande" ;
  bortslumpande_nn_1_N = mkN "bortslumpande" ;
  bortslutande_nn_1_N = mkN "bortslutande" ;
  borttagande_nn_1_N = mkN "borttagande" ;
  borttappande_nn_1_N = mkN "borttappande" ;
  borttorkande_nn_1_N = mkN "borttorkande" ;
  bortvraekande_nn_1_1_N = mkN "bortvräkande" ;
  boskifte_nn_1_N = mkN "boskifte" ;
  bossvaelde_nn_1_1_N = mkN "bossvälde" ;
  bostadsbyggande_nn_1_N = mkN "bostadsbyggande" ;
  bostadsomraade_nn_1_1_N = mkN "bostadsområde" ;
  bostaelle_nn_1_1_N = mkN "boställe" ;
  botande_nn_1_N = mkN "botande" ;
  botaniserande_nn_1_N = mkN "botaniserande" ;
  bottenfrysande_nn_1_N = mkN "bottenfrysande" ;
  bottenlaege_nn_1_1_N = mkN "bottenläge" ;
  bottenrevande_nn_1_N = mkN "bottenrevande" ;
  bottenskrapande_nn_1_N = mkN "bottenskrapande" ;
  bottnande_nn_1_N = mkN "bottnande" ;
  bowlande_nn_1_N = mkN "bowlande" ;
  boxande_nn_1_N = mkN "boxande" ;
  brageloefte_nn_1_1_N = mkN "bragelöfte" ;
  brakande_nn_1_N = mkN "brakande" ;
  branddike_nn_1_N = mkN "branddike" ;
  brandhaerjande_nn_1_1_N = mkN "brandhärjande" ;
  brandskattande_nn_1_N = mkN "brandskattande" ;
  braskande_nn_1_N = mkN "braskande" ;
  brassande_nn_1_N = mkN "brassande" ;
  braverande_nn_1_N = mkN "braverande" ;
  bredande_nn_1_N = mkN "bredande" ;
  breddande_nn_1_N = mkN "breddande" ;
  bredsaaende_nn_1_1_N = mkN "bredsående" ;
  breende_nn_1_N = mkN "breende" ;
  brevvaexlande_nn_1_1_N = mkN "brevväxlande" ;
  briefande_nn_1_N = mkN "briefande" ;
  briketterande_nn_1_N = mkN "briketterande" ;
  briljerande_nn_1_N = mkN "briljerande" ;
  bringande_nn_1_N = mkN "bringande" ;
  brinnande_nn_1_N = mkN "brinnande" ;
  briserande_nn_1_N = mkN "briserande" ;
  bristande_nn_1_N = mkN "bristande" ;
  bristlaege_nn_1_1_N = mkN "bristläge" ;
  bristyrke_nn_1_N = mkN "bristyrke" ;
  broande_nn_1_N = mkN "broande" ;
  broddande_nn_1_N = mkN "broddande" ;
  broderande_nn_1_N = mkN "broderande" ;
  brofaeste_nn_1_1_N = mkN "brofäste" ;
  brolaeggande_nn_1_1_N = mkN "broläggande" ;
  bromerande_nn_1_N = mkN "bromerande" ;
  bromsande_nn_1_N = mkN "bromsande" ;
  bronserande_nn_1_N = mkN "bronserande" ;
  bronsfoergyllande_nn_1_1_N = mkN "bronsförgyllande" ;
  bronsmaerke_nn_1_1_N = mkN "bronsmärke" ;
  bronsspaenne_nn_1_1_N = mkN "bronsspänne" ;
  broscherande_nn_1_N = mkN "broscherande" ;
  brosslande_nn_1_N = mkN "brosslande" ;
  brotschande_nn_1_N = mkN "brotschande" ;
  brottstillfaelle_nn_1_1_N = mkN "brottstillfälle" ;
  brottstycke_nn_1_N = mkN "brottstycke" ;
  brottstaelle_nn_1_1_N = mkN "brottställe" ;
  brucklande_nn_1_N = mkN "brucklande" ;
  brudfoelje_nn_1_1_N = mkN "brudfölje" ;
  brukande_nn_1_N = mkN "brukande" ;
  brukslaaende_nn_1_1_N = mkN "brukslående" ;
  brukssamhaelle_nn_1_1_N = mkN "brukssamhälle" ;
  bruksvaerde_nn_1_1_N = mkN "bruksvärde" ;
  brummande_nn_1_N = mkN "brummande" ;
  brunerande_nn_1_N = mkN "brunerande" ;
  brunfaergande_nn_1_1_N = mkN "brunfärgande" ;
  brusande_nn_1_N = mkN "brusande" ;
  brutaliserande_nn_1_N = mkN "brutaliserande" ;
  bryende_nn_1_N = mkN "bryende" ;
  bryggande_nn_1_N = mkN "bryggande" ;
  bryggkaffe_nn_1_N = mkN "bryggkaffe" ;
  brynande_nn_1_N = mkN "brynande" ;
  bryne_nn_1_N = mkN "bryne" ;
  brytande_nn_1_N = mkN "brytande" ;
  braeckande_nn_1_1_N = mkN "bräckande" ;
  braedande_nn_1_1_N = mkN "brädande" ;
  braedbeklaedande_nn_1_1_N = mkN "brädbeklädande" ;
  braedbeslaaende_nn_1_1_N = mkN "brädbeslående" ;
  braeddande_nn_1_1_N = mkN "bräddande" ;
  braede_nn_1_1_N = mkN "bräde" ;
  braedfodrande_nn_1_1_N = mkN "brädfodrande" ;
  braedseglande_nn_1_1_N = mkN "brädseglande" ;
  braedslaaende_nn_1_1_N = mkN "brädslående" ;
  braekande_nn_1_1_N = mkN "bräkande" ;
  braemande_nn_1_1_N = mkN "brämande" ;
  braennande_nn_1_1_N = mkN "brännande" ;
  braennlackerande_nn_1_1_N = mkN "brännlackerande" ;
  braennmaerkande_nn_1_1_N = mkN "brännmärkande" ;
  braennmaerke_nn_1_1_N = mkN "brännmärke" ;
  braennskadande_nn_1_1_N = mkN "brännskadande" ;
  braensle_nn_1_1_N = mkN "bränsle" ;
  braeserande_nn_1_1_N = mkN "bräserande" ;
  braette_nn_1_1_N = mkN "brätte" ;
  braadskande_nn_1_1_N = mkN "brådskande" ;
  braakande_nn_1_1_N = mkN "bråkande" ;
  broeande_nn_1_1_N = mkN "bröande" ;
  broedande_nn_1_1_N = mkN "brödande" ;
  broedstycke_nn_1_1_N = mkN "brödstycke" ;
  broelande_nn_1_1_N = mkN "brölande" ;
  broellopsvittne_nn_1_1_N = mkN "bröllopsvittne" ;
  buande_nn_1_N = mkN "buande" ;
  bubbande_nn_1_N = mkN "bubbande" ;
  bubblande_nn_1_N = mkN "bubblande" ;
  budande_nn_1_N = mkN "budande" ;
  budgetarbete_nn_1_N = mkN "budgetarbete" ;
  budgeterande_nn_1_N = mkN "budgeterande" ;
  buffande_nn_1_N = mkN "buffande" ;
  buffrande_nn_1_N = mkN "buffrande" ;
  bugande_nn_1_N = mkN "bugande" ;
  buggande_nn_1_N = mkN "buggande" ;
  buklandande_nn_1_N = mkN "buklandande" ;
  buktalande_nn_1_N = mkN "buktalande" ;
  buktande_nn_1_N = mkN "buktande" ;
  bullrande_nn_1_N = mkN "bullrande" ;
  bulnande_nn_1_N = mkN "bulnande" ;
  bultande_nn_1_N = mkN "bultande" ;
  buntande_nn_1_N = mkN "buntande" ;
  burgarstaelle_nn_1_1_N = mkN "burgarställe" ;
  burgerstaelle_nn_1_1_N = mkN "burgerställe" ;
  burkande_nn_1_N = mkN "burkande" ;
  busande_nn_1_N = mkN "busande" ;
  buskande_nn_1_N = mkN "buskande" ;
  busringande_nn_1_N = mkN "busringande" ;
  bussande_nn_1_N = mkN "bussande" ;
  busvisslande_nn_1_N = mkN "busvisslande" ;
  buteljerande_nn_1_N = mkN "buteljerande" ;
  butiksbitraede_nn_1_1_N = mkN "butiksbiträde" ;
  bygge_nn_1_N = mkN "bygge" ;
  byggnadsminne_nn_1_N = mkN "byggnadsminne" ;
  bykande_nn_1_N = mkN "bykande" ;
  bylte_nn_1_N = mkN "bylte" ;
  byomraade_nn_1_1_N = mkN "byområde" ;
  byraakratiserande_nn_1_1_N = mkN "byråkratiserande" ;
  bysnille_nn_1_N = mkN "bysnille" ;
  bysaettande_nn_1_1_N = mkN "bysättande" ;
  bytande_nn_1_N = mkN "bytande" ;
  byte_nn_1_N = mkN "byte" ;
  bytesvaerde_nn_1_1_N = mkN "bytesvärde" ;
  baeddande_nn_1_1_N = mkN "bäddande" ;
  baelgande_nn_1_1_N = mkN "bälgande" ;
  baelte_nn_1_1_N = mkN "bälte" ;
  baendande_nn_1_1_N = mkN "bändande" ;
  baendslande_nn_1_1_N = mkN "bändslande" ;
  baenslande_nn_1_1_N = mkN "bänslande" ;
  baerande_nn_1_1_N = mkN "bärande" ;
  baergande_nn_1_1_N = mkN "bärgande" ;
  baersande_nn_1_1_N = mkN "bärsande" ;
  baettrande_nn_1_1_N = mkN "bättrande" ;
  baevande_nn_1_1_N = mkN "bävande" ;
  baadande_nn_1_1_N = mkN "bådande" ;
  baagande_nn_1_1_N = mkN "bågande" ;
  baagnande_nn_1_1_N = mkN "bågnande" ;
  baatande_nn_1_1_N = mkN "båtande" ;
  baatbygge_nn_1_1_N = mkN "båtbygge" ;
  boejande_nn_1_1_N = mkN "böjande" ;
  boekande_nn_1_1_N = mkN "bökande" ;
  boelande_nn_1_1_N = mkN "bölande" ;
  boeljande_nn_1_1_N = mkN "böljande" ;
  boeljeslagsmaerke_nn_1_1_N = mkN "böljeslagsmärke" ;
  boenande_nn_1_1_N = mkN "bönande" ;
  boenemoete_nn_1_1_N = mkN "bönemöte" ;
  boenfallande_nn_1_1_N = mkN "bönfallande" ;
  boenhoerande_nn_1_1_N = mkN "bönhörande" ;
  boerande_nn_1_1_N = mkN "börande" ;
  boerjande_nn_1_1_N = mkN "börjande" ;
  boersnoterande_nn_1_1_N = mkN "börsnoterande" ;
  boestande_nn_1_1_N = mkN "böstande" ;
  boetande_nn_1_1_N = mkN "bötande" ;
  boetfaellande_nn_1_1_N = mkN "bötfällande" ;
  camouflerande_nn_1_N = mkN "camouflerande" ;
  campande_nn_1_N = mkN "campande" ;
  caterande_nn_1_N = mkN "caterande" ;
  cederande_nn_1_N = mkN "cederande" ;
  celebrerande_nn_1_N = mkN "celebrerande" ;
  celibatloefte_nn_1_1_N = mkN "celibatlöfte" ;
  cembalobygge_nn_1_N = mkN "cembalobygge" ;
  cementande_nn_1_N = mkN "cementande" ;
  cementerande_nn_1_N = mkN "cementerande" ;
  censurerande_nn_1_N = mkN "censurerande" ;
  centraliserande_nn_1_N = mkN "centraliserande" ;
  centrande_nn_1_N = mkN "centrande" ;
  centrerande_nn_1_N = mkN "centrerande" ;
  centrifugerande_nn_1_N = mkN "centrifugerande" ;
  cernerande_nn_1_N = mkN "cernerande" ;
  certifierande_nn_1_N = mkN "certifierande" ;
  champagnesprutande_nn_1_N = mkN "champagnesprutande" ;
  changerande_nn_1_N = mkN "changerande" ;
  changserande_nn_1_N = mkN "changserande" ;
  chansande_nn_1_N = mkN "chansande" ;
  chanserande_nn_1_N = mkN "chanserande" ;
  chargerande_nn_1_N = mkN "chargerande" ;
  charmande_nn_1_N = mkN "charmande" ;
  charmerande_nn_1_N = mkN "charmerande" ;
  chartrande_nn_1_N = mkN "chartrande" ;
  chattande_nn_1_N = mkN "chattande" ;
  checkande_nn_1_N = mkN "checkande" ;
  checkhaefte_nn_1_1_N = mkN "checkhäfte" ;
  chefande_nn_1_N = mkN "chefande" ;
  chevroterande_nn_1_N = mkN "chevroterande" ;
  chiffrerande_nn_1_N = mkN "chiffrerande" ;
  chikanerande_nn_1_N = mkN "chikanerande" ;
  chillande_nn_1_N = mkN "chillande" ;
  chockande_nn_1_N = mkN "chockande" ;
  chockbehandlande_nn_1_N = mkN "chockbehandlande" ;
  chockerande_nn_1_N = mkN "chockerande" ;
  chokande_nn_1_N = mkN "chokande" ;
  cirklande_nn_1_N = mkN "cirklande" ;
  cirkulerande_nn_1_N = mkN "cirkulerande" ;
  ciselerande_nn_1_N = mkN "ciselerande" ;
  citerande_nn_1_N = mkN "citerande" ;
  civiliserande_nn_1_N = mkN "civiliserande" ;
  clearande_nn_1_N = mkN "clearande" ;
  crawlande_nn_1_N = mkN "crawlande" ;
  curaterande_nn_1_N = mkN "curaterande" ;
  curerande_nn_1_N = mkN "curerande" ;
  curlande_nn_1_N = mkN "curlande" ;
  cykelstyre_nn_1_N = mkN "cykelstyre" ;
  cyklande_nn_1_N = mkN "cyklande" ;
  daddande_nn_1_N = mkN "daddande" ;
  dagdroemmande_nn_1_1_N = mkN "dagdrömmande" ;
  daggande_nn_1_N = mkN "daggande" ;
  dagsverke_nn_1_N = mkN "dagsverke" ;
  dagtecknande_nn_1_N = mkN "dagtecknande" ;
  dagtingande_nn_1_N = mkN "dagtingande" ;
  dagtraktamente_nn_1_N = mkN "dagtraktamente" ;
  dalande_nn_1_N = mkN "dalande" ;
  dallrande_nn_1_N = mkN "dallrande" ;
  daltande_nn_1_N = mkN "daltande" ;
  dammande_nn_1_N = mkN "dammande" ;
  dammode_nn_1_N = mkN "dammode" ;
  dammsugande_nn_1_N = mkN "dammsugande" ;
  dammtorkande_nn_1_N = mkN "dammtorkande" ;
  dampande_nn_1_N = mkN "dampande" ;
  danande_nn_1_N = mkN "danande" ;
  danglande_nn_1_N = mkN "danglande" ;
  dansande_nn_1_N = mkN "dansande" ;
  dansbaneelaende_nn_1_1_N = mkN "dansbaneelände" ;
  dansgille_nn_1_N = mkN "dansgille" ;
  dansstaelle_nn_1_1_N = mkN "dansställe" ;
  darrande_nn_1_N = mkN "darrande" ;
  daskande_nn_1_N = mkN "daskande" ;
  dassande_nn_1_N = mkN "dassande" ;
  databehandlande_nn_1_N = mkN "databehandlande" ;
  dataminne_nn_1_N = mkN "dataminne" ;
  datautbyte_nn_1_N = mkN "datautbyte" ;
  daterande_nn_1_N = mkN "daterande" ;
  datoriserande_nn_1_N = mkN "datoriserande" ;
  datorminne_nn_1_N = mkN "datorminne" ;
  datorsimulerande_nn_1_N = mkN "datorsimulerande" ;
  dattande_nn_1_N = mkN "dattande" ;
  datummaerkande_nn_1_1_N = mkN "datummärkande" ;
  datumparkerande_nn_1_N = mkN "datumparkerande" ;
  debarkerande_nn_1_N = mkN "debarkerande" ;
  debatterande_nn_1_N = mkN "debatterande" ;
  debiterande_nn_1_N = mkN "debiterande" ;
  debuterande_nn_1_N = mkN "debuterande" ;
  decentraliserande_nn_1_N = mkN "decentraliserande" ;
  dechiffrerande_nn_1_N = mkN "dechiffrerande" ;
  decimerande_nn_1_N = mkN "decimerande" ;
  dedicerande_nn_1_N = mkN "dedicerande" ;
  dedikerande_nn_1_N = mkN "dedikerande" ;
  deducerande_nn_1_N = mkN "deducerande" ;
  defilerande_nn_1_N = mkN "defilerande" ;
  definierande_nn_1_N = mkN "definierande" ;
  deflorerande_nn_1_N = mkN "deflorerande" ;
  deformerande_nn_1_N = mkN "deformerande" ;
  degande_nn_1_N = mkN "degande" ;
  degenererande_nn_1_N = mkN "degenererande" ;
  degraderande_nn_1_N = mkN "degraderande" ;
  dejsande_nn_1_N = mkN "dejsande" ;
  dejtande_nn_1_N = mkN "dejtande" ;
  dekanterande_nn_1_N = mkN "dekanterande" ;
  dekapiterande_nn_1_N = mkN "dekapiterande" ;
  deklamerande_nn_1_N = mkN "deklamerande" ;
  deklarerande_nn_1_N = mkN "deklarerande" ;
  deklasserande_nn_1_N = mkN "deklasserande" ;
  deklinerande_nn_1_N = mkN "deklinerande" ;
  dekorerande_nn_1_N = mkN "dekorerande" ;
  dekouragerande_nn_1_N = mkN "dekouragerande" ;
  dekreterande_nn_1_N = mkN "dekreterande" ;
  delande_nn_1_N = mkN "delande" ;
  delegerande_nn_1_N = mkN "delegerande" ;
  delgivande_nn_1_N = mkN "delgivande" ;
  deltidsarbete_nn_1_N = mkN "deltidsarbete" ;
  demande_nn_1_N = mkN "demande" ;
  demaskerande_nn_1_N = mkN "demaskerande" ;
  dementerande_nn_1_N = mkN "dementerande" ;
  demilitariserande_nn_1_N = mkN "demilitariserande" ;
  demissionerande_nn_1_N = mkN "demissionerande" ;
  demobiliserande_nn_1_N = mkN "demobiliserande" ;
  demokratibygge_nn_1_N = mkN "demokratibygge" ;
  demokratiserande_nn_1_N = mkN "demokratiserande" ;
  demolerande_nn_1_N = mkN "demolerande" ;
  demonstrerande_nn_1_N = mkN "demonstrerande" ;
  demonterande_nn_1_N = mkN "demonterande" ;
  demoraliserande_nn_1_N = mkN "demoraliserande" ;
  denaturaliserande_nn_1_N = mkN "denaturaliserande" ;
  denaturerande_nn_1_N = mkN "denaturerande" ;
  denoterande_nn_1_N = mkN "denoterande" ;
  denuderande_nn_1_N = mkN "denuderande" ;
  deodoriserande_nn_1_N = mkN "deodoriserande" ;
  departementsaerende_nn_1_1_N = mkN "departementsärende" ;
  depatrierande_nn_1_N = mkN "depatrierande" ;
  depenserande_nn_1_N = mkN "depenserande" ;
  deplacerande_nn_1_N = mkN "deplacerande" ;
  deponerande_nn_1_N = mkN "deponerande" ;
  deporterande_nn_1_N = mkN "deporterande" ;
  deppande_nn_1_N = mkN "deppande" ;
  deprecierande_nn_1_N = mkN "deprecierande" ;
  derangerande_nn_1_N = mkN "derangerande" ;
  deriverande_nn_1_N = mkN "deriverande" ;
  desarmerande_nn_1_N = mkN "desarmerande" ;
  desavouerande_nn_1_N = mkN "desavouerande" ;
  desensibiliserande_nn_1_N = mkN "desensibiliserande" ;
  deserterande_nn_1_N = mkN "deserterande" ;
  designande_nn_1_N = mkN "designande" ;
  designerande_nn_1_N = mkN "designerande" ;
  desinfekterande_nn_1_N = mkN "desinfekterande" ;
  desinficerande_nn_1_N = mkN "desinficerande" ;
  desinformerande_nn_1_N = mkN "desinformerande" ;
  desorganiserande_nn_1_N = mkN "desorganiserande" ;
  destabiliserande_nn_1_N = mkN "destabiliserande" ;
  destillerande_nn_1_N = mkN "destillerande" ;
  destinerande_nn_1_N = mkN "destinerande" ;
  destruerande_nn_1_N = mkN "destruerande" ;
  detacherande_nn_1_N = mkN "detacherande" ;
  detaljarbete_nn_1_N = mkN "detaljarbete" ;
  detaljgranskande_nn_1_N = mkN "detaljgranskande" ;
  detaljutfoerande_nn_1_1_N = mkN "detaljutförande" ;
  detekterande_nn_1_N = mkN "detekterande" ;
  detektivarbete_nn_1_N = mkN "detektivarbete" ;
  determinerande_nn_1_N = mkN "determinerande" ;
  detonerande_nn_1_N = mkN "detonerande" ;
  detroniserande_nn_1_N = mkN "detroniserande" ;
  devalverande_nn_1_N = mkN "devalverande" ;
  devierande_nn_1_N = mkN "devierande" ;
  diagnosticerande_nn_1_N = mkN "diagnosticerande" ;
  diagnostiserande_nn_1_N = mkN "diagnostiserande" ;
  diagonalande_nn_1_N = mkN "diagonalande" ;
  dialyserande_nn_1_N = mkN "dialyserande" ;
  diande_nn_1_N = mkN "diande" ;
  diariefoerande_nn_1_1_N = mkN "diarieförande" ;
  dibblande_nn_1_N = mkN "dibblande" ;
  differentierande_nn_1_N = mkN "differentierande" ;
  diffunderande_nn_1_N = mkN "diffunderande" ;
  diftongerande_nn_1_N = mkN "diftongerande" ;
  digererande_nn_1_N = mkN "digererande" ;
  diggande_nn_1_N = mkN "diggande" ;
  dignande_nn_1_N = mkN "dignande" ;
  dikande_nn_1_N = mkN "dikande" ;
  dike_nn_1_N = mkN "dike" ;
  diktande_nn_1_N = mkN "diktande" ;
  dikterande_nn_1_N = mkN "dikterande" ;
  dikthaefte_nn_1_1_N = mkN "dikthäfte" ;
  dillande_nn_1_N = mkN "dillande" ;
  dimensionerande_nn_1_N = mkN "dimensionerande" ;
  dimpande_nn_1_N = mkN "dimpande" ;
  dinerande_nn_1_N = mkN "dinerande" ;
  dinglande_nn_1_N = mkN "dinglande" ;
  diplomerande_nn_1_N = mkN "diplomerande" ;
  dippande_nn_1_N = mkN "dippande" ;
  direktinflytande_nn_1_N = mkN "direktinflytande" ;
  dirigerande_nn_1_N = mkN "dirigerande" ;
  dirkande_nn_1_N = mkN "dirkande" ;
  dirrande_nn_1_N = mkN "dirrande" ;
  disambiguerande_nn_1_N = mkN "disambiguerande" ;
  disciplinerande_nn_1_N = mkN "disciplinerande" ;
  disharmonierande_nn_1_N = mkN "disharmonierande" ;
  diskande_nn_1_N = mkN "diskande" ;
  diskonterande_nn_1_N = mkN "diskonterande" ;
  diskrediterande_nn_1_N = mkN "diskrediterande" ;
  diskriminerande_nn_1_N = mkN "diskriminerande" ;
  diskuterande_nn_1_N = mkN "diskuterande" ;
  diskvalificerande_nn_1_N = mkN "diskvalificerande" ;
  dispascherande_nn_1_N = mkN "dispascherande" ;
  dispenserande_nn_1_N = mkN "dispenserande" ;
  dispergerande_nn_1_N = mkN "dispergerande" ;
  disponerande_nn_1_N = mkN "disponerande" ;
  disputerande_nn_1_N = mkN "disputerande" ;
  dissande_nn_1_N = mkN "dissande" ;
  dissekerande_nn_1_N = mkN "dissekerande" ;
  dissimilerande_nn_1_N = mkN "dissimilerande" ;
  dissocierande_nn_1_N = mkN "dissocierande" ;
  dissonerande_nn_1_N = mkN "dissonerande" ;
  distanserande_nn_1_N = mkN "distanserande" ;
  distraherande_nn_1_N = mkN "distraherande" ;
  distribuerande_nn_1_N = mkN "distribuerande" ;
  divergerande_nn_1_N = mkN "divergerande" ;
  diversifierande_nn_1_N = mkN "diversifierande" ;
  dividerande_nn_1_N = mkN "dividerande" ;
  djupfrysande_nn_1_N = mkN "djupfrysande" ;
  djuplodande_nn_1_N = mkN "djuplodande" ;
  djupnande_nn_1_N = mkN "djupnande" ;
  djupsinne_nn_1_N = mkN "djupsinne" ;
  djurlaete_nn_1_1_N = mkN "djurläte" ;
  doande_nn_1_N = mkN "doande" ;
  dobblande_nn_1_N = mkN "dobblande" ;
  docerande_nn_1_N = mkN "docerande" ;
  dockande_nn_1_N = mkN "dockande" ;
  dockansikte_nn_1_N = mkN "dockansikte" ;
  doftande_nn_1_N = mkN "doftande" ;
  doftmarkerande_nn_1_N = mkN "doftmarkerande" ;
  doftsinne_nn_1_N = mkN "doftsinne" ;
  doftaemne_nn_1_1_N = mkN "doftämne" ;
  dogmatiserande_nn_1_N = mkN "dogmatiserande" ;
  doktorerande_nn_1_N = mkN "doktorerande" ;
  dokumenterande_nn_1_N = mkN "dokumenterande" ;
  domderande_nn_1_N = mkN "domderande" ;
  domesticerande_nn_1_N = mkN "domesticerande" ;
  domfaellande_nn_1_1_N = mkN "domfällande" ;
  domicilierande_nn_1_N = mkN "domicilierande" ;
  dominerande_nn_1_N = mkN "dominerande" ;
  domnande_nn_1_N = mkN "domnande" ;
  dompterande_nn_1_N = mkN "dompterande" ;
  donande_nn_1_N = mkN "donande" ;
  donerande_nn_1_N = mkN "donerande" ;
  donkande_nn_1_N = mkN "donkande" ;
  donlaege_nn_1_1_N = mkN "donläge" ;
  dopande_nn_1_N = mkN "dopande" ;
  doppande_nn_1_N = mkN "doppande" ;
  dopvittne_nn_1_N = mkN "dopvittne" ;
  doserande_nn_1_N = mkN "doserande" ;
  dosserande_nn_1_N = mkN "dosserande" ;
  doterande_nn_1_N = mkN "doterande" ;
  drabbande_nn_1_N = mkN "drabbande" ;
  dragande_nn_1_N = mkN "dragande" ;
  dragerande_nn_1_N = mkN "dragerande" ;
  draggande_nn_1_N = mkN "draggande" ;
  dragsnoere_nn_1_1_N = mkN "dragsnöre" ;
  dramatiserande_nn_1_N = mkN "dramatiserande" ;
  draperande_nn_1_N = mkN "draperande" ;
  drattande_nn_1_N = mkN "drattande" ;
  dravlande_nn_1_N = mkN "dravlande" ;
  dreglande_nn_1_N = mkN "dreglande" ;
  drejande_nn_1_N = mkN "drejande" ;
  drejvaendande_nn_1_1_N = mkN "drejvändande" ;
  dresserande_nn_1_N = mkN "dresserande" ;
  drevande_nn_1_N = mkN "drevande" ;
  dribblande_nn_1_N = mkN "dribblande" ;
  drickande_nn_1_N = mkN "drickande" ;
  drillande_nn_1_N = mkN "drillande" ;
  drivande_nn_1_N = mkN "drivande" ;
  drogande_nn_1_N = mkN "drogande" ;
  droppande_nn_1_N = mkN "droppande" ;
  drottkvaede_nn_1_1_N = mkN "drottkväde" ;
  drullande_nn_1_N = mkN "drullande" ;
  drumlande_nn_1_N = mkN "drumlande" ;
  drunknande_nn_1_N = mkN "drunknande" ;
  dryftande_nn_1_N = mkN "dryftande" ;
  drypande_nn_1_N = mkN "drypande" ;
  draeglande_nn_1_1_N = mkN "dräglande" ;
  draektspaenne_nn_1_1_N = mkN "dräktspänne" ;
  draellande_nn_1_1_N = mkN "drällande" ;
  draemmande_nn_1_1_N = mkN "drämmande" ;
  draenerande_nn_1_1_N = mkN "dränerande" ;
  draeneringsdike_nn_1_1_N = mkN "dräneringsdike" ;
  draeneringsomraade_nn_1_1_N = mkN "dräneringsområde" ;
  draenkande_nn_1_1_N = mkN "dränkande" ;
  draepande_nn_1_1_N = mkN "dräpande" ;
  draasande_nn_1_1_N = mkN "dråsande" ;
  droejande_nn_1_1_N = mkN "dröjande" ;
  droemmande_nn_1_1_N = mkN "drömmande" ;
  droemtydande_nn_1_1_N = mkN "drömtydande" ;
  droenande_nn_1_1_N = mkN "drönande" ;
  droesande_nn_1_1_N = mkN "drösande" ;
  duande_nn_1_N = mkN "duande" ;
  dubbande_nn_1_N = mkN "dubbande" ;
  dubbelansikte_nn_1_N = mkN "dubbelansikte" ;
  dubbelbeskattande_nn_1_N = mkN "dubbelbeskattande" ;
  dubbelexponerande_nn_1_N = mkN "dubbelexponerande" ;
  dubblande_nn_1_N = mkN "dubblande" ;
  dubblerande_nn_1_N = mkN "dubblerande" ;
  duckande_nn_1_N = mkN "duckande" ;
  duellerande_nn_1_N = mkN "duellerande" ;
  dugande_nn_1_N = mkN "dugande" ;
  duggande_nn_1_N = mkN "duggande" ;
  duggregnande_nn_1_N = mkN "duggregnande" ;
  dukande_nn_1_N = mkN "dukande" ;
  dumpande_nn_1_N = mkN "dumpande" ;
  dunande_nn_1_N = mkN "dunande" ;
  dundrande_nn_1_N = mkN "dundrande" ;
  dunkande_nn_1_N = mkN "dunkande" ;
  dunsande_nn_1_N = mkN "dunsande" ;
  dunstande_nn_1_N = mkN "dunstande" ;
  duntaecke_nn_1_1_N = mkN "duntäcke" ;
  duperande_nn_1_N = mkN "duperande" ;
  duplicerande_nn_1_N = mkN "duplicerande" ;
  durkande_nn_1_N = mkN "durkande" ;
  duschande_nn_1_N = mkN "duschande" ;
  duskande_nn_1_N = mkN "duskande" ;
  duvande_nn_1_N = mkN "duvande" ;
  duvnande_nn_1_N = mkN "duvnande" ;
  dykande_nn_1_N = mkN "dykande" ;
  dyrkande_nn_1_N = mkN "dyrkande" ;
  daeckande_nn_1_1_N = mkN "däckande" ;
  daeckbyte_nn_1_1_N = mkN "däckbyte" ;
  daeggande_nn_1_1_N = mkN "däggande" ;
  daemmande_nn_1_1_N = mkN "dämmande" ;
  daemme_nn_1_1_N = mkN "dämme" ;
  daempande_nn_1_1_N = mkN "dämpande" ;
  daengande_nn_1_1_N = mkN "dängande" ;
  daenkande_nn_1_1_N = mkN "dänkande" ;
  daevnande_nn_1_1_N = mkN "dävnande" ;
  daanande_nn_1_1_N = mkN "dånande" ;
  daarande_nn_1_1_N = mkN "dårande" ;
  daasande_nn_1_1_N = mkN "dåsande" ;
  doedfoerklarande_nn_1_1_N = mkN "dödförklarande" ;
  doedlaege_nn_1_1_N = mkN "dödläge" ;
  doedsrike_nn_1_1_N = mkN "dödsrike" ;
  doeende_nn_1_1_N = mkN "döende" ;
  doeljande_nn_1_1_N = mkN "döljande" ;
  doemande_nn_1_1_N = mkN "dömande" ;
  doenande_nn_1_1_N = mkN "dönande" ;
  doepande_nn_1_1_N = mkN "döpande" ;
  doerjande_nn_1_1_N = mkN "dörjande" ;
  doerrfoerhaenge_nn_1_1_N = mkN "dörrförhänge" ;
  doevande_nn_1_1_N = mkN "dövande" ;
  e_mailande_nn_1_N = mkN "e-mailande" ;
  e_postande_nn_1_N = mkN "e-postande" ;
  e_postmeddelande_nn_1_N = mkN "e-postmeddelande" ;
  ebbande_nn_1_N = mkN "ebbande" ;
  ederande_nn_1_N = mkN "ederande" ;
  edfaestande_nn_1_1_N = mkN "edfästande" ;
  effacerande_nn_1_N = mkN "effacerande" ;
  effektiverande_nn_1_N = mkN "effektiverande" ;
  effektiviserande_nn_1_N = mkN "effektiviserande" ;
  effektlaege_nn_1_1_N = mkN "effektläge" ;
  effektuerande_nn_1_N = mkN "effektuerande" ;
  efterapande_nn_1_N = mkN "efterapande" ;
  efterarbete_nn_1_N = mkN "efterarbete" ;
  efterbehandlande_nn_1_N = mkN "efterbehandlande" ;
  efterbildande_nn_1_N = mkN "efterbildande" ;
  efterdaterande_nn_1_N = mkN "efterdaterande" ;
  efterdebiterande_nn_1_N = mkN "efterdebiterande" ;
  efterdoeme_nn_1_1_N = mkN "efterdöme" ;
  efterforskande_nn_1_N = mkN "efterforskande" ;
  efterfraagande_nn_1_1_N = mkN "efterfrågande" ;
  efterfoeljande_nn_1_1_N = mkN "efterföljande" ;
  eftergivande_nn_1_N = mkN "eftergivande" ;
  eftergoerande_nn_1_1_N = mkN "eftergörande" ;
  efterhaermande_nn_1_1_N = mkN "efterhärmande" ;
  efterhaallande_nn_1_1_N = mkN "efterhållande" ;
  efterhoerande_nn_1_1_N = mkN "efterhörande" ;
  efterkommande_nn_2_N = mkN "efterkommande" ;
  efterlevande_nn_1_N = mkN "efterlevande" ;
  efterliknande_nn_1_N = mkN "efterliknande" ;
  efterlysande_nn_1_N = mkN "efterlysande" ;
  efterlaemnande_nn_1_1_N = mkN "efterlämnande" ;
  efterlaatande_nn_1_1_N = mkN "efterlåtande" ;
  eftermognande_nn_1_N = mkN "eftermognande" ;
  eftermaele_nn_1_1_N = mkN "eftermäle" ;
  efterrationaliserande_nn_1_N = mkN "efterrationaliserande" ;
  efterseende_nn_1_N = mkN "efterseende" ;
  eftersinnande_nn_1_N = mkN "eftersinnande" ;
  efterstavande_nn_1_N = mkN "efterstavande" ;
  efterstraevande_nn_1_1_N = mkN "eftersträvande" ;
  eftersynkroniserande_nn_1_N = mkN "eftersynkroniserande" ;
  eftersaegande_nn_1_1_N = mkN "eftersägande" ;
  eftersaendande_nn_1_1_N = mkN "eftersändande" ;
  eftersaettande_nn_1_1_N = mkN "eftersättande" ;
  eftersoekande_nn_1_1_N = mkN "eftersökande" ;
  eftertaxerande_nn_1_N = mkN "eftertaxerande" ;
  eftertraktande_nn_1_N = mkN "eftertraktande" ;
  eftertraedande_nn_1_1_N = mkN "efterträdande" ;
  eftertraaende_nn_1_1_N = mkN "eftertrående" ;
  egaliserande_nn_1_N = mkN "egaliserande" ;
  egenintresse_nn_1_N = mkN "egenintresse" ;
  egensinne_nn_1_N = mkN "egensinne" ;
  egensvaengande_nn_1_1_N = mkN "egensvängande" ;
  eggande_nn_1_N = mkN "eggande" ;
  ejakulerande_nn_1_N = mkN "ejakulerande" ;
  ekande_nn_1_N = mkN "ekande" ;
  ekfatslagrande_nn_1_N = mkN "ekfatslagrande" ;
  ekiperande_nn_1_N = mkN "ekiperande" ;
  eklaterande_nn_1_N = mkN "eklaterande" ;
  eklaererande_nn_1_1_N = mkN "eklärerande" ;
  ekolodande_nn_1_N = mkN "ekolodande" ;
  ekonomibitraede_nn_1_1_N = mkN "ekonomibiträde" ;
  ekonomiserande_nn_1_N = mkN "ekonomiserande" ;
  ekvatorialbaelte_nn_1_1_N = mkN "ekvatorialbälte" ;
  elaborerande_nn_1_N = mkN "elaborerande" ;
  elastiserande_nn_1_N = mkN "elastiserande" ;
  eldande_nn_1_N = mkN "eldande" ;
  eldhaerjande_nn_1_1_N = mkN "eldhärjande" ;
  eldsmaerke_nn_1_1_N = mkN "eldsmärke" ;
  eldsaekrande_nn_1_1_N = mkN "eldsäkrande" ;
  eldvaktande_nn_1_N = mkN "eldvaktande" ;
  elektrificerande_nn_1_N = mkN "elektrificerande" ;
  elektrifierande_nn_1_N = mkN "elektrifierande" ;
  elektriserande_nn_1_N = mkN "elektriserande" ;
  elektronhoelje_nn_1_1_N = mkN "elektronhölje" ;
  eliderande_nn_1_N = mkN "eliderande" ;
  eliminerande_nn_1_N = mkN "eliminerande" ;
  eloxerande_nn_1_N = mkN "eloxerande" ;
  eluderande_nn_1_N = mkN "eluderande" ;
  eluerande_nn_1_N = mkN "eluerande" ;
  elaende_nn_1_1_N = mkN "elände" ;
  emaljerande_nn_1_N = mkN "emaljerande" ;
  emanciperande_nn_1_N = mkN "emanciperande" ;
  emanerande_nn_1_N = mkN "emanerande" ;
  emballerande_nn_1_N = mkN "emballerande" ;
  embarkerande_nn_1_N = mkN "embarkerande" ;
  embellerande_nn_1_N = mkN "embellerande" ;
  emenderande_nn_1_N = mkN "emenderande" ;
  emigrerande_nn_1_N = mkN "emigrerande" ;
  emitterande_nn_1_N = mkN "emitterande" ;
  emotseende_nn_1_N = mkN "emotseende" ;
  emotstaaende_nn_1_1_N = mkN "emotstående" ;
  emottagande_nn_1_N = mkN "emottagande" ;
  emulgerande_nn_1_N = mkN "emulgerande" ;
  emulsionsspraengaemne_nn_1_1_N = mkN "emulsionssprängämne" ;
  enande_nn_1_N = mkN "enande" ;
  endosserande_nn_1_N = mkN "endosserande" ;
  energiknippe_nn_1_N = mkN "energiknippe" ;
  enerverande_nn_1_N = mkN "enerverande" ;
  engagerande_nn_1_N = mkN "engagerande" ;
  engaangsvaerde_nn_1_1_N = mkN "engångsvärde" ;
  enkelriktande_nn_1_N = mkN "enkelriktande" ;
  enkelskrivande_nn_1_N = mkN "enkelskrivande" ;
  enkeltecknande_nn_1_N = mkN "enkeltecknande" ;
  enklande_nn_1_N = mkN "enklande" ;
  enleverande_nn_1_N = mkN "enleverande" ;
  enrollerande_nn_1_N = mkN "enrollerande" ;
  ensande_nn_1_N = mkN "ensande" ;
  ensilerande_nn_1_N = mkN "ensilerande" ;
  entledigande_nn_1_N = mkN "entledigande" ;
  entusiasmerande_nn_1_N = mkN "entusiasmerande" ;
  epilerande_nn_1_N = mkN "epilerande" ;
  epostande_nn_1_N = mkN "epostande" ;
  epostmeddelande_nn_1_N = mkN "epostmeddelande" ;
  erbjudande_nn_1_N = mkN "erbjudande" ;
  erfarande_nn_1_N = mkN "erfarande" ;
  erfordrande_nn_1_N = mkN "erfordrande" ;
  erhaallande_nn_1_1_N = mkN "erhållande" ;
  erigerande_nn_1_N = mkN "erigerande" ;
  erinrande_nn_1_N = mkN "erinrande" ;
  erkaennande_nn_1_1_N = mkN "erkännande" ;
  erlaeggande_nn_1_1_N = mkN "erläggande" ;
  ernaaende_nn_1_1_N = mkN "ernående" ;
  eroderande_nn_1_N = mkN "eroderande" ;
  ersaettande_nn_1_1_N = mkN "ersättande" ;
  ertappande_nn_1_N = mkN "ertappande" ;
  eroevrande_nn_1_1_N = mkN "erövrande" ;
  eskalerande_nn_1_N = mkN "eskalerande" ;
  eskorterande_nn_1_N = mkN "eskorterande" ;
  esteticerande_nn_1_N = mkN "esteticerande" ;
  estetiserande_nn_1_N = mkN "estetiserande" ;
  estimerande_nn_1_N = mkN "estimerande" ;
  etablerande_nn_1_N = mkN "etablerande" ;
  eteriserande_nn_1_N = mkN "eteriserande" ;
  etiketterande_nn_1_N = mkN "etiketterande" ;
  etsande_nn_1_N = mkN "etsande" ;
  etymologiserande_nn_1_N = mkN "etymologiserande" ;
  europeiserande_nn_1_N = mkN "europeiserande" ;
  evakuerande_nn_1_N = mkN "evakuerande" ;
  evaluerande_nn_1_N = mkN "evaluerande" ;
  evalverande_nn_1_N = mkN "evalverande" ;
  evangeliserande_nn_1_N = mkN "evangeliserande" ;
  evaporerande_nn_1_N = mkN "evaporerande" ;
  examensarbete_nn_1_N = mkN "examensarbete" ;
  examinerande_nn_1_N = mkN "examinerande" ;
  excellerande_nn_1_N = mkN "excellerande" ;
  excerperande_nn_1_N = mkN "excerperande" ;
  exciterande_nn_1_N = mkN "exciterande" ;
  exekverande_nn_1_N = mkN "exekverande" ;
  exemplifierande_nn_1_N = mkN "exemplifierande" ;
  exercerande_nn_1_N = mkN "exercerande" ;
  existerande_nn_1_N = mkN "existerande" ;
  exkluderande_nn_1_N = mkN "exkluderande" ;
  exkommunicerande_nn_1_N = mkN "exkommunicerande" ;
  expanderande_nn_1_N = mkN "expanderande" ;
  expatrierande_nn_1_N = mkN "expatrierande" ;
  expedierande_nn_1_N = mkN "expedierande" ;
  expektorerande_nn_1_N = mkN "expektorerande" ;
  experimenterande_nn_1_N = mkN "experimenterande" ;
  expertutlaatande_nn_1_1_N = mkN "expertutlåtande" ;
  explicerande_nn_1_N = mkN "explicerande" ;
  exploaterande_nn_1_N = mkN "exploaterande" ;
  exploderande_nn_1_N = mkN "exploderande" ;
  explosionsomraade_nn_1_1_N = mkN "explosionsområde" ;
  exponerande_nn_1_N = mkN "exponerande" ;
  exportberoende_nn_1_N = mkN "exportberoende" ;
  exporterande_nn_1_N = mkN "exporterande" ;
  exproprierande_nn_1_N = mkN "exproprierande" ;
  exstirperande_nn_1_N = mkN "exstirperande" ;
  extemporerande_nn_1_N = mkN "extemporerande" ;
  extraarbete_nn_1_N = mkN "extraarbete" ;
  extraherande_nn_1_N = mkN "extraherande" ;
  extraknaeckande_nn_1_1_N = mkN "extraknäckande" ;
  extraktivaemne_nn_1_1_N = mkN "extraktivämne" ;
  extrapolerande_nn_1_N = mkN "extrapolerande" ;
  fablande_nn_1_N = mkN "fablande" ;
  fabricerande_nn_1_N = mkN "fabricerande" ;
  fabriksomraade_nn_1_1_N = mkN "fabriksområde" ;
  fabulerande_nn_1_N = mkN "fabulerande" ;
  facebookande_nn_1_N = mkN "facebookande" ;
  facetterande_nn_1_N = mkN "facetterande" ;
  fadersvaelde_nn_1_1_N = mkN "fadersvälde" ;
  fakturerande_nn_1_N = mkN "fakturerande" ;
  falkande_nn_1_N = mkN "falkande" ;
  fallande_nn_1_N = mkN "fallande" ;
  fallerande_nn_1_N = mkN "fallerande" ;
  falnande_nn_1_N = mkN "falnande" ;
  falsande_nn_1_N = mkN "falsande" ;
  falsifierande_nn_1_N = mkN "falsifierande" ;
  falskskyltande_nn_1_N = mkN "falskskyltande" ;
  famlande_nn_1_N = mkN "famlande" ;
  famnande_nn_1_N = mkN "famnande" ;
  fantiserande_nn_1_N = mkN "fantiserande" ;
  farande_nn_1_N = mkN "farande" ;
  fasande_nn_1_N = mkN "fasande" ;
  fascinerande_nn_1_N = mkN "fascinerande" ;
  fasetterande_nn_1_N = mkN "fasetterande" ;
  fasonerande_nn_1_N = mkN "fasonerande" ;
  fastande_nn_1_N = mkN "fastande" ;
  fastgoerande_nn_1_1_N = mkN "fastgörande" ;
  fasthaallande_nn_1_1_N = mkN "fasthållande" ;
  fastighetstaxerande_nn_1_N = mkN "fastighetstaxerande" ;
  fastkedjande_nn_1_N = mkN "fastkedjande" ;
  fastklistrande_nn_1_N = mkN "fastklistrande" ;
  fastlaeggande_nn_1_1_N = mkN "fastläggande" ;
  fastnande_nn_1_N = mkN "fastnande" ;
  fastslaaende_nn_1_1_N = mkN "fastslående" ;
  faststaellande_nn_1_1_N = mkN "fastställande" ;
  fastsaettande_nn_1_1_N = mkN "fastsättande" ;
  fasttagande_nn_1_N = mkN "fasttagande" ;
  fattande_nn_1_N = mkN "fattande" ;
  fattigdomsloefte_nn_1_1_N = mkN "fattigdomslöfte" ;
  favoriserande_nn_1_N = mkN "favoriserande" ;
  faxande_nn_1_N = mkN "faxande" ;
  fejande_nn_1_N = mkN "fejande" ;
  fejkande_nn_1_N = mkN "fejkande" ;
  felande_nn_1_N = mkN "felande" ;
  felbedoemande_nn_1_1_N = mkN "felbedömande" ;
  felparkerande_nn_1_N = mkN "felparkerande" ;
  feltolkande_nn_1_N = mkN "feltolkande" ;
  fermenterande_nn_1_N = mkN "fermenterande" ;
  fernissande_nn_1_N = mkN "fernissande" ;
  festande_nn_1_N = mkN "festande" ;
  feterande_nn_1_N = mkN "feterande" ;
  fetmande_nn_1_N = mkN "fetmande" ;
  fetnande_nn_1_N = mkN "fetnande" ;
  fettaemne_nn_1_1_N = mkN "fettämne" ;
  fickparkerande_nn_1_N = mkN "fickparkerande" ;
  fifflande_nn_1_N = mkN "fifflande" ;
  figurerande_nn_1_N = mkN "figurerande" ;
  fikande_nn_1_N = mkN "fikande" ;
  filande_nn_1_N = mkN "filande" ;
  filbyte_nn_1_N = mkN "filbyte" ;
  fileande_nn_1_N = mkN "fileande" ;
  filerande_nn_1_N = mkN "filerande" ;
  filmande_nn_1_N = mkN "filmande" ;
  filmatiserande_nn_1_N = mkN "filmatiserande" ;
  filmberaettande_nn_1_1_N = mkN "filmberättande" ;
  filosoferande_nn_1_N = mkN "filosoferande" ;
  filtande_nn_1_N = mkN "filtande" ;
  filtrerande_nn_1_N = mkN "filtrerande" ;
  fimpande_nn_1_N = mkN "fimpande" ;
  finansierande_nn_1_N = mkN "finansierande" ;
  finbraennande_nn_1_1_N = mkN "finbrännande" ;
  finfoerdelande_nn_1_1_N = mkN "finfördelande" ;
  fingerande_nn_1_N = mkN "fingerande" ;
  fingrande_nn_1_N = mkN "fingrande" ;
  fingranskande_nn_1_N = mkN "fingranskande" ;
  fininstaellande_nn_1_1_N = mkN "fininställande" ;
  finjusterande_nn_1_N = mkN "finjusterande" ;
  finkammande_nn_1_N = mkN "finkammande" ;
  finkande_nn_1_N = mkN "finkande" ;
  finlandiserande_nn_1_N = mkN "finlandiserande" ;
  finnande_nn_1_N = mkN "finnande" ;
  finputsande_nn_1_N = mkN "finputsande" ;
  finslipande_nn_1_N = mkN "finslipande" ;
  finsmide_nn_1_N = mkN "finsmide" ;
  fintande_nn_1_N = mkN "fintande" ;
  fipplande_nn_1_N = mkN "fipplande" ;
  firande_nn_1_N = mkN "firande" ;
  firmamaerke_nn_1_1_N = mkN "firmamärke" ;
  fisande_nn_1_N = mkN "fisande" ;
  fiskafaenge_nn_1_1_N = mkN "fiskafänge" ;
  fiskande_nn_1_N = mkN "fiskande" ;
  fiskelaege_nn_1_1_N = mkN "fiskeläge" ;
  fixande_nn_1_N = mkN "fixande" ;
  fixerande_nn_1_N = mkN "fixerande" ;
  fjantande_nn_1_N = mkN "fjantande" ;
  fjaedrande_nn_1_1_N = mkN "fjädrande" ;
  fjaellande_nn_1_1_N = mkN "fjällande" ;
  fjaellvandrande_nn_1_1_N = mkN "fjällvandrande" ;
  fjaermande_nn_1_1_N = mkN "fjärmande" ;
  fjaerrblockerande_nn_1_1_N = mkN "fjärrblockerande" ;
  fjaertande_nn_1_1_N = mkN "fjärtande" ;
  fjaeskande_nn_1_1_N = mkN "fjäskande" ;
  fjaettrande_nn_1_1_N = mkN "fjättrande" ;
  flabbande_nn_1_N = mkN "flabbande" ;
  flackande_nn_1_N = mkN "flackande" ;
  fladdrande_nn_1_N = mkN "fladdrande" ;
  flagande_nn_1_N = mkN "flagande" ;
  flaggande_nn_1_N = mkN "flaggande" ;
  flaggviftande_nn_1_N = mkN "flaggviftande" ;
  flagnande_nn_1_N = mkN "flagnande" ;
  flamberande_nn_1_N = mkN "flamberande" ;
  flammande_nn_1_N = mkN "flammande" ;
  flamsande_nn_1_N = mkN "flamsande" ;
  flanerande_nn_1_N = mkN "flanerande" ;
  flankerande_nn_1_N = mkN "flankerande" ;
  flatskrattande_nn_1_N = mkN "flatskrattande" ;
  flatterande_nn_1_N = mkN "flatterande" ;
  flaxande_nn_1_N = mkN "flaxande" ;
  flekterande_nn_1_N = mkN "flekterande" ;
  flerdubblande_nn_1_N = mkN "flerdubblande" ;
  flerfaldigande_nn_1_N = mkN "flerfaldigande" ;
  flexande_nn_1_N = mkN "flexande" ;
  flickansikte_nn_1_N = mkN "flickansikte" ;
  flimrande_nn_1_N = mkN "flimrande" ;
  flinande_nn_1_N = mkN "flinande" ;
  flirtande_nn_1_N = mkN "flirtande" ;
  flockbeteende_nn_1_N = mkN "flockbeteende" ;
  flodomraade_nn_1_1_N = mkN "flodområde" ;
  florerande_nn_1_N = mkN "florerande" ;
  flottande_nn_1_N = mkN "flottande" ;
  flottyrkokande_nn_1_N = mkN "flottyrkokande" ;
  fluidiserande_nn_1_N = mkN "fluidiserande" ;
  fluktande_nn_1_N = mkN "fluktande" ;
  fluktuerande_nn_1_N = mkN "fluktuerande" ;
  flummande_nn_1_N = mkN "flummande" ;
  fluorerande_nn_1_N = mkN "fluorerande" ;
  fluorescerande_nn_1_N = mkN "fluorescerande" ;
  fluoriderande_nn_1_N = mkN "fluoriderande" ;
  flyende_nn_1_N = mkN "flyende" ;
  flygande_nn_1_N = mkN "flygande" ;
  flygbombande_nn_1_N = mkN "flygbombande" ;
  flygbraensle_nn_1_1_N = mkN "flygbränsle" ;
  flyktande_nn_1_N = mkN "flyktande" ;
  flytande_nn_1_N = mkN "flytande" ;
  flyttande_nn_1_N = mkN "flyttande" ;
  flaeckande_nn_1_1_N = mkN "fläckande" ;
  flaekande_nn_1_1_N = mkN "fläkande" ;
  flaektande_nn_1_1_N = mkN "fläktande" ;
  flaemtande_nn_1_1_N = mkN "flämtande" ;
  flaengande_nn_1_1_N = mkN "flängande" ;
  flaensande_nn_1_1_N = mkN "flänsande" ;
  flaeskstycke_nn_1_1_N = mkN "fläskstycke" ;
  flaetande_nn_1_1_N = mkN "flätande" ;
  flaaende_nn_1_1_N = mkN "flående" ;
  flaahackande_nn_1_1_N = mkN "flåhackande" ;
  flaasande_nn_1_1_N = mkN "flåsande" ;
  floedande_nn_1_1_N = mkN "flödande" ;
  floede_nn_1_1_N = mkN "flöde" ;
  floejlande_nn_1_1_N = mkN "flöjlande" ;
  floejtande_nn_1_1_N = mkN "flöjtande" ;
  floertande_nn_1_1_N = mkN "flörtande" ;
  floete_nn_1_1_N = mkN "flöte" ;
  fnaskande_nn_1_N = mkN "fnaskande" ;
  fnattande_nn_1_N = mkN "fnattande" ;
  fnissande_nn_1_N = mkN "fnissande" ;
  fnittrande_nn_1_N = mkN "fnittrande" ;
  fnysande_nn_1_N = mkN "fnysande" ;
  fnoeske_nn_1_1_N = mkN "fnöske" ;
  fockande_nn_1_N = mkN "fockande" ;
  fodervaerde_nn_1_1_N = mkN "fodervärde" ;
  fodrande_nn_1_N = mkN "fodrande" ;
  fogande_nn_1_N = mkN "fogande" ;
  fogstrykande_nn_1_N = mkN "fogstrykande" ;
  fokuserande_nn_1_N = mkN "fokuserande" ;
  folierande_nn_1_N = mkN "folierande" ;
  folkminne_nn_1_N = mkN "folkminne" ;
  folkmoete_nn_1_1_N = mkN "folkmöte" ;
  folknoeje_nn_1_1_N = mkN "folknöje" ;
  folkstyre_nn_1_N = mkN "folkstyre" ;
  folkvaelde_nn_1_1_N = mkN "folkvälde" ;
  fonderande_nn_1_N = mkN "fonderande" ;
  forcerande_nn_1_N = mkN "forcerande" ;
  fordrande_nn_1_N = mkN "fordrande" ;
  fordskraelle_nn_1_1_N = mkN "fordskrälle" ;
  forecheckande_nn_1_N = mkN "forecheckande" ;
  formaliserande_nn_1_N = mkN "formaliserande" ;
  formande_nn_1_N = mkN "formande" ;
  formerande_nn_1_N = mkN "formerande" ;
  formgivande_nn_1_N = mkN "formgivande" ;
  formgjutande_nn_1_N = mkN "formgjutande" ;
  formpressande_nn_1_N = mkN "formpressande" ;
  formsinne_nn_1_N = mkN "formsinne" ;
  formulerande_nn_1_N = mkN "formulerande" ;
  fornminne_nn_1_N = mkN "fornminne" ;
  forsande_nn_1_N = mkN "forsande" ;
  forskande_nn_1_N = mkN "forskande" ;
  forskningsarbete_nn_1_N = mkN "forskningsarbete" ;
  forskningsfaeste_nn_1_1_N = mkN "forskningsfäste" ;
  forskningsomraade_nn_1_1_N = mkN "forskningsområde" ;
  forskningssyfte_nn_1_N = mkN "forskningssyfte" ;
  forslande_nn_1_N = mkN "forslande" ;
  fortbestaaende_nn_1_1_N = mkN "fortbestående" ;
  forte_nn_1_N = mkN "forte" ;
  fortfarande_nn_1_N = mkN "fortfarande" ;
  fortgaaende_nn_1_1_N = mkN "fortgående" ;
  fortlevande_nn_1_N = mkN "fortlevande" ;
  fortloepande_nn_1_1_N = mkN "fortlöpande" ;
  fortskridande_nn_1_N = mkN "fortskridande" ;
  fortsaettande_nn_1_1_N = mkN "fortsättande" ;
  fosfaterande_nn_1_N = mkN "fosfaterande" ;
  fosforescerande_nn_1_N = mkN "fosforescerande" ;
  fossilbraensle_nn_1_1_N = mkN "fossilbränsle" ;
  fossiliserande_nn_1_N = mkN "fossiliserande" ;
  fosterlaege_nn_1_1_N = mkN "fosterläge" ;
  fostrande_nn_1_N = mkN "fostrande" ;
  fotande_nn_1_N = mkN "fotande" ;
  fotarbete_nn_1_N = mkN "fotarbete" ;
  fotograferande_nn_1_N = mkN "fotograferande" ;
  fotokopierande_nn_1_N = mkN "fotokopierande" ;
  fotostatkopierande_nn_1_N = mkN "fotostatkopierande" ;
  fotvandrande_nn_1_N = mkN "fotvandrande" ;
  fradgande_nn_1_N = mkN "fradgande" ;
  fragmenterande_nn_1_N = mkN "fragmenterande" ;
  fraktande_nn_1_N = mkN "fraktande" ;
  fraktionerande_nn_1_N = mkN "fraktionerande" ;
  framavlande_nn_1_N = mkN "framavlande" ;
  frambesvaerjande_nn_1_1_N = mkN "frambesvärjande" ;
  frambringande_nn_1_N = mkN "frambringande" ;
  frambrytande_nn_1_N = mkN "frambrytande" ;
  frambaerande_nn_1_1_N = mkN "frambärande" ;
  framfarande_nn_1_N = mkN "framfarande" ;
  framflyttande_nn_1_N = mkN "framflyttande" ;
  framfoedande_nn_1_1_N = mkN "framfödande" ;
  framfoerande_nn_1_1_N = mkN "framförande" ;
  framgaaende_nn_1_1_N = mkN "framgående" ;
  framhaerdande_nn_1_1_N = mkN "framhärdande" ;
  framhaevande_nn_1_1_N = mkN "framhävande" ;
  framhaallande_nn_1_1_N = mkN "framhållande" ;
  framkallande_nn_1_N = mkN "framkallande" ;
  framkastande_nn_1_N = mkN "framkastande" ;
  framkommande_nn_1_N = mkN "framkommande" ;
  framlevande_nn_1_N = mkN "framlevande" ;
  framlidande_nn_1_N = mkN "framlidande" ;
  framlaeggande_nn_1_1_N = mkN "framläggande" ;
  frammanande_nn_1_N = mkN "frammanande" ;
  frammatande_nn_1_N = mkN "frammatande" ;
  framskinande_nn_1_N = mkN "framskinande" ;
  framskjutande_nn_1_N = mkN "framskjutande" ;
  framskridande_nn_1_N = mkN "framskridande" ;
  framskymtande_nn_1_N = mkN "framskymtande" ;
  framstycke_nn_1_N = mkN "framstycke" ;
  framstaellande_nn_1_1_N = mkN "framställande" ;
  framstaaende_nn_1_1_N = mkN "framstående" ;
  framsaegande_nn_1_1_N = mkN "framsägande" ;
  framsaete_nn_1_1_N = mkN "framsäte" ;
  framtidsloefte_nn_1_1_N = mkN "framtidslöfte" ;
  framtonande_nn_1_N = mkN "framtonande" ;
  framtraedande_nn_1_1_N = mkN "framträdande" ;
  framtvingande_nn_1_N = mkN "framtvingande" ;
  framvisande_nn_1_N = mkN "framvisande" ;
  framvaexande_nn_1_1_N = mkN "framväxande" ;
  frankerande_nn_1_N = mkN "frankerande" ;
  fransande_nn_1_N = mkN "fransande" ;
  frapperande_nn_1_N = mkN "frapperande" ;
  frasande_nn_1_N = mkN "frasande" ;
  fraserande_nn_1_N = mkN "fraserande" ;
  fraterniserande_nn_1_N = mkN "fraterniserande" ;
  fredande_nn_1_N = mkN "fredande" ;
  fredsstraevande_nn_1_1_N = mkN "fredssträvande" ;
  frekvensmodulerande_nn_1_N = mkN "frekvensmodulerande" ;
  frekvensomraade_nn_1_1_N = mkN "frekvensområde" ;
  frekventerande_nn_1_N = mkN "frekventerande" ;
  frestande_nn_1_N = mkN "frestande" ;
  friande_nn_1_N = mkN "friande" ;
  fridlysande_nn_1_N = mkN "fridlysande" ;
  frigivande_nn_1_N = mkN "frigivande" ;
  frigoerande_nn_1_1_N = mkN "frigörande" ;
  frihandelsomraade_nn_1_1_N = mkN "frihandelsområde" ;
  frihetsberoevande_nn_1_1_N = mkN "frihetsberövande" ;
  frikallande_nn_1_N = mkN "frikallande" ;
  frikopplande_nn_1_N = mkN "frikopplande" ;
  frikaennande_nn_1_1_N = mkN "frikännande" ;
  frikoepande_nn_1_1_N = mkN "friköpande" ;
  frilansande_nn_1_N = mkN "frilansande" ;
  frilistande_nn_1_N = mkN "frilistande" ;
  friluftsintresse_nn_1_N = mkN "friluftsintresse" ;
  friluftsomraade_nn_1_1_N = mkN "friluftsområde" ;
  frilaege_nn_1_1_N = mkN "friläge" ;
  frilaeggande_nn_1_1_N = mkN "friläggande" ;
  frimaerkande_nn_1_1_N = mkN "frimärkande" ;
  frimaerke_nn_1_1_N = mkN "frimärke" ;
  frisinne_nn_1_N = mkN "frisinne" ;
  friskande_nn_1_N = mkN "friskande" ;
  friskanmaelande_nn_1_1_N = mkN "friskanmälande" ;
  friskfoerklarande_nn_1_1_N = mkN "friskförklarande" ;
  friskskrivande_nn_1_N = mkN "friskskrivande" ;
  frisksportande_nn_1_N = mkN "frisksportande" ;
  frislaeppande_nn_1_1_N = mkN "frisläppande" ;
  frispelande_nn_1_N = mkN "frispelande" ;
  fristaellande_nn_1_1_N = mkN "friställande" ;
  frisaettande_nn_1_1_N = mkN "frisättande" ;
  fritagande_nn_1_N = mkN "fritagande" ;
  friterande_nn_1_N = mkN "friterande" ;
  fritidsomraade_nn_1_1_N = mkN "fritidsområde" ;
  fromlande_nn_1_N = mkN "fromlande" ;
  fronderande_nn_1_N = mkN "fronderande" ;
  frontande_nn_1_N = mkN "frontande" ;
  frossande_nn_1_N = mkN "frossande" ;
  frotterande_nn_1_N = mkN "frotterande" ;
  frukosterande_nn_1_N = mkN "frukosterande" ;
  fruktande_nn_1_N = mkN "fruktande" ;
  fruktaemne_nn_1_1_N = mkN "fruktämne" ;
  frusande_nn_1_N = mkN "frusande" ;
  frustande_nn_1_N = mkN "frustande" ;
  frustrerande_nn_1_N = mkN "frustrerande" ;
  frynande_nn_1_N = mkN "frynande" ;
  frysande_nn_1_N = mkN "frysande" ;
  frystestande_nn_1_N = mkN "frystestande" ;
  frystorkande_nn_1_N = mkN "frystorkande" ;
  fraelsande_nn_1_1_N = mkN "frälsande" ;
  fraelsningsmoete_nn_1_1_N = mkN "frälsningsmöte" ;
  fraemjande_nn_1_1_N = mkN "främjande" ;
  fraemmande_nn_1_1_N = mkN "främmande" ;
  fraesande_nn_1_1_N = mkN "fräsande" ;
  fraetande_nn_1_1_N = mkN "frätande" ;
  fraagande_nn_1_1_N = mkN "frågande" ;
  fraandoemande_nn_1_1_N = mkN "fråndömande" ;
  fraanfaelle_nn_1_1_N = mkN "frånfälle" ;
  fraangaaende_nn_1_1_N = mkN "frångående" ;
  fraankaennande_nn_1_1_N = mkN "frånkännande" ;
  fraanraeknande_nn_1_1_N = mkN "frånräknande" ;
  fraanseende_nn_1_1_N = mkN "frånseende" ;
  fraanspelande_nn_1_1_N = mkN "frånspelande" ;
  fraantagande_nn_1_1_N = mkN "fråntagande" ;
  fraantraedande_nn_1_1_N = mkN "frånträdande" ;
  froeande_nn_1_1_N = mkN "fröande" ;
  froefaeste_nn_1_1_N = mkN "fröfäste" ;
  froegoemme_nn_1_1_N = mkN "frögömme" ;
  froejdande_nn_1_1_N = mkN "fröjdande" ;
  froeaemne_nn_1_1_N = mkN "fröämne" ;
  fuktande_nn_1_N = mkN "fuktande" ;
  fullbordande_nn_1_N = mkN "fullbordande" ;
  fullfoeljande_nn_1_1_N = mkN "fullföljande" ;
  fullgoerande_nn_1_1_N = mkN "fullgörande" ;
  fullkomnande_nn_1_N = mkN "fullkomnande" ;
  fullstaendigande_nn_1_1_N = mkN "fullständigande" ;
  fullaendande_nn_1_1_N = mkN "fulländande" ;
  fumlande_nn_1_N = mkN "fumlande" ;
  funderande_nn_1_N = mkN "funderande" ;
  fungerande_nn_1_N = mkN "fungerande" ;
  funkande_nn_1_N = mkN "funkande" ;
  funktionerande_nn_1_N = mkN "funktionerande" ;
  funktionsvaerde_nn_1_1_N = mkN "funktionsvärde" ;
  furnerande_nn_1_N = mkN "furnerande" ;
  furstendoeme_nn_1_1_N = mkN "furstendöme" ;
  fusionerande_nn_1_N = mkN "fusionerande" ;
  fuskande_nn_1_N = mkN "fuskande" ;
  fuskbygge_nn_1_N = mkN "fuskbygge" ;
  futtande_nn_1_N = mkN "futtande" ;
  fylkande_nn_1_N = mkN "fylkande" ;
  fylke_nn_1_N = mkN "fylke" ;
  fyllande_nn_1_N = mkN "fyllande" ;
  fyllnande_nn_1_N = mkN "fyllnande" ;
  fyndande_nn_1_N = mkN "fyndande" ;
  fysiljerande_nn_1_N = mkN "fysiljerande" ;
  faebodstaelle_nn_1_1_N = mkN "fäbodställe" ;
  faegnande_nn_1_1_N = mkN "fägnande" ;
  faektande_nn_1_1_N = mkN "fäktande" ;
  faellande_nn_1_1_N = mkN "fällande" ;
  faeltarbete_nn_1_1_N = mkN "fältarbete" ;
  faengelsefoerhaallande_nn_1_1_N = mkN "fängelseförhållande" ;
  faengslande_nn_1_1_N = mkN "fängslande" ;
  faerdighetsaemne_nn_1_1_N = mkN "färdighetsämne" ;
  faerdigstaellande_nn_1_1_N = mkN "färdigställande" ;
  faergande_nn_1_1_N = mkN "färgande" ;
  faerglaeggande_nn_1_1_N = mkN "färgläggande" ;
  faergsinne_nn_1_1_N = mkN "färgsinne" ;
  faergaemne_nn_1_1_N = mkN "färgämne" ;
  faerjande_nn_1_1_N = mkN "färjande" ;
  faerjelaege_nn_1_1_N = mkN "färjeläge" ;
  faerserande_nn_1_1_N = mkN "färserande" ;
  faerskande_nn_1_1_N = mkN "färskande" ;
  faestande_nn_1_1_N = mkN "fästande" ;
  faeste_nn_1_1_N = mkN "fäste" ;
  faaende_nn_1_1_N = mkN "fående" ;
  faagelfaenge_nn_1_1_N = mkN "fågelfänge" ;
  faallande_nn_1_1_N = mkN "fållande" ;
  faangande_nn_1_1_N = mkN "fångande" ;
  faangstsamhaelle_nn_1_1_N = mkN "fångstsamhälle" ;
  faanskrattande_nn_1_1_N = mkN "fånskrattande" ;
  faarande_nn_1_1_N = mkN "fårande" ;
  faarbete_nn_1_1_N = mkN "fårbete" ;
  foedande_nn_1_1_N = mkN "födande" ;
  foedelsemaerke_nn_1_1_N = mkN "födelsemärke" ;
  foedoaemne_nn_1_1_N = mkN "födoämne" ;
  foelande_nn_1_1_N = mkN "fölande" ;
  foeljande_nn_1_1_N = mkN "följande" ;
  foelje_nn_1_1_N = mkN "följe" ;
  foenande_nn_1_1_N = mkN "fönande" ;
  foensterbraede_nn_1_1_N = mkN "fönsterbräde" ;
  foeraktande_nn_1_1_N = mkN "föraktande" ;
  foerallmaenligande_nn_1_1_N = mkN "förallmänligande" ;
  foerande_nn_1_1_N = mkN "förande" ;
  foerandligande_nn_1_1_N = mkN "förandligande" ;
  foerankrande_nn_1_1_N = mkN "förankrande" ;
  foeranledande_nn_1_1_N = mkN "föranledande" ;
  foeranmaelande_nn_1_1_N = mkN "föranmälande" ;
  foerannonserande_nn_1_1_N = mkN "förannonserande" ;
  foeranstaltande_nn_1_1_N = mkN "föranstaltande" ;
  foerarbete_nn_1_1_N = mkN "förarbete" ;
  foerargande_nn_1_1_N = mkN "förargande" ;
  foerbannande_nn_1_1_N = mkN "förbannande" ;
  foerbehaallande_nn_1_1_N = mkN "förbehållande" ;
  foerberedande_nn_1_1_N = mkN "förberedande" ;
  foerberedelsearbete_nn_1_1_N = mkN "förberedelsearbete" ;
  foerbidande_nn_1_1_N = mkN "förbidande" ;
  foerbigaaende_nn_1_1_N = mkN "förbigående" ;
  foerbilligande_nn_1_1_N = mkN "förbilligande" ;
  foerbindande_nn_1_1_N = mkN "förbindande" ;
  foerbindelsearbete_nn_1_1_N = mkN "förbindelsearbete" ;
  foerbiseende_nn_1_1_N = mkN "förbiseende" ;
  foerbittrande_nn_1_1_N = mkN "förbittrande" ;
  foerbjudande_nn_1_1_N = mkN "förbjudande" ;
  foerblandande_nn_1_1_N = mkN "förblandande" ;
  foerbleknande_nn_1_1_N = mkN "förbleknande" ;
  foerblindande_nn_1_1_N = mkN "förblindande" ;
  foerblivande_nn_1_1_N = mkN "förblivande" ;
  foerbluffande_nn_1_1_N = mkN "förbluffande" ;
  foerbloedande_nn_1_1_N = mkN "förblödande" ;
  foerborgande_nn_1_1_N = mkN "förborgande" ;
  foerborgerligande_nn_1_1_N = mkN "förborgerligande" ;
  foerbrinnande_nn_1_1_N = mkN "förbrinnande" ;
  foerbrukande_nn_1_1_N = mkN "förbrukande" ;
  foerbryllande_nn_1_1_N = mkN "förbryllande" ;
  foerbraennande_nn_1_1_N = mkN "förbrännande" ;
  foerbroedrande_nn_1_1_N = mkN "förbrödrande" ;
  foerbuskande_nn_1_1_N = mkN "förbuskande" ;
  foerbyggande_nn_1_1_N = mkN "förbyggande" ;
  foerbytande_nn_1_1_N = mkN "förbytande" ;
  foerbaettrande_nn_1_1_N = mkN "förbättrande" ;
  foerdelande_nn_1_1_N = mkN "fördelande" ;
  foerdjupande_nn_1_1_N = mkN "fördjupande" ;
  foerdragande_nn_1_1_N = mkN "fördragande" ;
  foerdrivande_nn_1_1_N = mkN "fördrivande" ;
  foerdroejande_nn_1_1_N = mkN "fördröjande" ;
  foerdubblande_nn_1_1_N = mkN "fördubblande" ;
  foerdummande_nn_1_1_N = mkN "fördummande" ;
  foerdunklande_nn_1_1_N = mkN "fördunklande" ;
  foerdyrande_nn_1_1_N = mkN "fördyrande" ;
  foerdystrande_nn_1_1_N = mkN "fördystrande" ;
  foerdaemmande_nn_1_1_N = mkN "fördämmande" ;
  foerdaervande_nn_1_1_N = mkN "fördärvande" ;
  foerdoeljande_nn_1_1_N = mkN "fördöljande" ;
  foerdoemande_nn_1_1_N = mkN "fördömande" ;
  foere_nn_1_1_N = mkN "före" ;
  foerebraaende_nn_1_1_N = mkN "förebrående" ;
  foerebyggande_nn_1_1_N = mkN "förebyggande" ;
  foerebaerande_nn_1_1_N = mkN "förebärande" ;
  foerebaadande_nn_1_1_N = mkN "förebådande" ;
  foeredragande_nn_2_1_N = mkN "föredragande" ;
  foeredoeme_nn_1_1_N = mkN "föredöme" ;
  foerefallande_nn_1_1_N = mkN "förefallande" ;
  foeregivande_nn_1_1_N = mkN "föregivande" ;
  foeregripande_nn_1_1_N = mkN "föregripande" ;
  foeregaaende_nn_2_1_N = mkN "föregående" ;
  foerehavande_nn_1_1_N = mkN "förehavande" ;
  foerehaallande_nn_1_1_N = mkN "förehållande" ;
  foerekommande_nn_1_1_N = mkN "förekommande" ;
  foereliggande_nn_1_1_N = mkN "föreliggande" ;
  foerelaeggande_nn_1_1_N = mkN "föreläggande" ;
  foerelaesande_nn_1_1_N = mkN "föreläsande" ;
  foerenande_nn_1_1_N = mkN "förenande" ;
  foerenklande_nn_1_1_N = mkN "förenklande" ;
  foereskrivande_nn_1_1_N = mkN "föreskrivande" ;
  foereslaaende_nn_1_1_N = mkN "föreslående" ;
  foerespeglande_nn_1_1_N = mkN "förespeglande" ;
  foerespraakande_nn_1_1_N = mkN "förespråkande" ;
  foerespaaende_nn_1_1_N = mkN "förespående" ;
  foerestavande_nn_1_1_N = mkN "förestavande" ;
  foerestaellande_nn_1_1_N = mkN "föreställande" ;
  foerestaaende_nn_1_1_N = mkN "förestående" ;
  foeresvaevande_nn_1_1_N = mkN "föresvävande" ;
  foeretagande_nn_1_1_N = mkN "företagande" ;
  foereteende_nn_1_1_N = mkN "företeende" ;
  foeretraedande_nn_1_1_N = mkN "företrädande" ;
  foeretraede_nn_1_1_N = mkN "företräde" ;
  foerevarande_nn_1_1_N = mkN "förevarande" ;
  foerevigande_nn_1_1_N = mkN "förevigande" ;
  foerevisande_nn_1_1_N = mkN "förevisande" ;
  foerevitande_nn_1_1_N = mkN "förevitande" ;
  foerfallande_nn_1_1_N = mkN "förfallande" ;
  foerfalskande_nn_1_1_N = mkN "förfalskande" ;
  foerfarande_nn_1_1_N = mkN "förfarande" ;
  foerfattande_nn_1_1_N = mkN "författande" ;
  foerfelande_nn_1_1_N = mkN "förfelande" ;
  foerfinande_nn_1_1_N = mkN "förfinande" ;
  foerflackande_nn_1_1_N = mkN "förflackande" ;
  foerflytande_nn_1_1_N = mkN "förflytande" ;
  foerflyttande_nn_1_1_N = mkN "förflyttande" ;
  foerfogande_nn_1_1_N = mkN "förfogande" ;
  foerfranskande_nn_1_1_N = mkN "förfranskande" ;
  foerfrysande_nn_1_1_N = mkN "förfrysande" ;
  foerfraemligande_nn_1_1_N = mkN "förfrämligande" ;
  foerfuskande_nn_1_1_N = mkN "förfuskande" ;
  foerfaeande_nn_1_1_N = mkN "förfäande" ;
  foerfaektande_nn_1_1_N = mkN "förfäktande" ;
  foerfaerande_nn_1_1_N = mkN "förfärande" ;
  foerfaerdigande_nn_1_1_N = mkN "förfärdigande" ;
  foerfaangande_nn_1_1_N = mkN "förfångande" ;
  foerfoeljande_nn_1_1_N = mkN "förföljande" ;
  foerfoerande_nn_1_1_N = mkN "förförande" ;
  foerfoerdelande_nn_1_1_N = mkN "förfördelande" ;
  foergasande_nn_1_1_N = mkN "förgasande" ;
  foergiftande_nn_1_1_N = mkN "förgiftande" ;
  foergloemmande_nn_1_1_N = mkN "förglömmande" ;
  foergrovande_nn_1_1_N = mkN "förgrovande" ;
  foergrymmande_nn_1_1_N = mkN "förgrymmande" ;
  foergyllande_nn_1_1_N = mkN "förgyllande" ;
  foergaetande_nn_1_1_N = mkN "förgätande" ;
  foergaaende_nn_1_1_N = mkN "förgående" ;
  foergoerande_nn_1_1_N = mkN "förgörande" ;
  foerhalande_nn_1_1_N = mkN "förhalande" ;
  foerhandlande_nn_1_1_N = mkN "förhandlande" ;
  foerhandlingslaege_nn_1_1_N = mkN "förhandlingsläge" ;
  foerhindrande_nn_1_1_N = mkN "förhindrande" ;
  foerhydande_nn_1_1_N = mkN "förhydande" ;
  foerhyrande_nn_1_1_N = mkN "förhyrande" ;
  foerhaenge_nn_1_1_N = mkN "förhänge" ;
  foerhaerdande_nn_1_1_N = mkN "förhärdande" ;
  foerhaerjande_nn_1_1_N = mkN "förhärjande" ;
  foerhaerligande_nn_1_1_N = mkN "förhärligande" ;
  foerhaerskande_nn_1_1_N = mkN "förhärskande" ;
  foerhaexande_nn_1_1_N = mkN "förhäxande" ;
  foerhaallande_nn_1_1_N = mkN "förhållande" ;
  foerhaanande_nn_1_1_N = mkN "förhånande" ;
  foerhoejande_nn_1_1_N = mkN "förhöjande" ;
  foerhoerande_nn_1_1_N = mkN "förhörande" ;
  foerhoersvittne_nn_1_1_N = mkN "förhörsvittne" ;
  foerintande_nn_1_1_N = mkN "förintande" ;
  foerjagande_nn_1_1_N = mkN "förjagande" ;
  foerkastande_nn_1_1_N = mkN "förkastande" ;
  foerklarande_nn_1_1_N = mkN "förklarande" ;
  foerklingande_nn_1_1_N = mkN "förklingande" ;
  foerklistrande_nn_1_1_N = mkN "förklistrande" ;
  foerklaede_nn_1_1_N = mkN "förkläde" ;
  foerknippande_nn_1_1_N = mkN "förknippande" ;
  foerkolnande_nn_1_1_N = mkN "förkolnande" ;
  foerkommande_nn_1_1_N = mkN "förkommande" ;
  foerkortande_nn_1_1_N = mkN "förkortande" ;
  foerkovrande_nn_1_1_N = mkN "förkovrande" ;
  foerkromande_nn_1_1_N = mkN "förkromande" ;
  foerkroppsligande_nn_1_1_N = mkN "förkroppsligande" ;
  foerkrossande_nn_1_1_N = mkN "förkrossande" ;
  foerkrympande_nn_1_1_N = mkN "förkrympande" ;
  foerkraamande_nn_1_1_N = mkN "förkråmande" ;
  foerkunnande_nn_1_1_N = mkN "förkunnande" ;
  foerkvaevande_nn_1_1_N = mkN "förkvävande" ;
  foerlamande_nn_1_1_N = mkN "förlamande" ;
  foerledande_nn_1_1_N = mkN "förledande" ;
  foerlidande_nn_1_1_N = mkN "förlidande" ;
  foerlikande_nn_1_1_N = mkN "förlikande" ;
  foerlisande_nn_1_1_N = mkN "förlisande" ;
  foerljudande_nn_1_1_N = mkN "förljudande" ;
  foerljuvande_nn_1_1_N = mkN "förljuvande" ;
  foerlorande_nn_1_1_N = mkN "förlorande" ;
  foerlossande_nn_1_1_N = mkN "förlossande" ;
  foerlossningsarbete_nn_1_1_N = mkN "förlossningsarbete" ;
  foerlustande_nn_1_1_N = mkN "förlustande" ;
  foerlaeggande_nn_1_1_N = mkN "förläggande" ;
  foerlaenande_nn_1_1_N = mkN "förlänande" ;
  foerlaengande_nn_1_1_N = mkN "förlängande" ;
  foerlaatande_nn_1_1_N = mkN "förlåtande" ;
  foerloejligande_nn_1_1_N = mkN "förlöjligande" ;
  foerloepande_nn_1_1_N = mkN "förlöpande" ;
  foerloesande_nn_1_1_N = mkN "förlösande" ;
  foermanande_nn_1_1_N = mkN "förmanande" ;
  foermedlande_nn_1_1_N = mkN "förmedlande" ;
  foermenande_nn_2_1_N = mkN "förmenande" ;
  foermiddagskaffe_nn_1_1_N = mkN "förmiddagskaffe" ;
  foermildrande_nn_1_1_N = mkN "förmildrande" ;
  foerminskande_nn_1_1_N = mkN "förminskande" ;
  foermodande_nn_1_1_N = mkN "förmodande" ;
  foermultnande_nn_1_1_N = mkN "förmultnande" ;
  foermyndarstyre_nn_1_1_N = mkN "förmyndarstyre" ;
  foermaelande_nn_1_1_N = mkN "förmälande" ;
  foermaenskligande_nn_1_1_N = mkN "förmänskligande" ;
  foermaerkande_nn_1_1_N = mkN "förmärkande" ;
  foermaaende_nn_1_1_N = mkN "förmående" ;
  foermaanserbjudande_nn_1_1_N = mkN "förmånserbjudande" ;
  foermoerkande_nn_1_1_N = mkN "förmörkande" ;
  foernedrande_nn_1_1_N = mkN "förnedrande" ;
  foernekande_nn_1_1_N = mkN "förnekande" ;
  foernicklande_nn_1_1_N = mkN "förnicklande" ;
  foernimmande_nn_1_1_N = mkN "förnimmande" ;
  foernyande_nn_1_1_N = mkN "förnyande" ;
  foernaermande_nn_1_1_N = mkN "förnärmande" ;
  foernoejande_nn_1_1_N = mkN "förnöjande" ;
  foernoetande_nn_1_1_N = mkN "förnötande" ;
  foerolaempande_nn_1_1_N = mkN "förolämpande" ;
  foerordande_nn_1_1_N = mkN "förordande" ;
  foerordnande_nn_1_1_N = mkN "förordnande" ;
  foerorenande_nn_1_1_N = mkN "förorenande" ;
  foerorsakande_nn_1_1_N = mkN "förorsakande" ;
  foeroraettande_nn_1_1_N = mkN "förorättande" ;
  foerpackande_nn_1_1_N = mkN "förpackande" ;
  foerpaktande_nn_1_1_N = mkN "förpaktande" ;
  foerpantande_nn_1_1_N = mkN "förpantande" ;
  foerpassande_nn_1_1_N = mkN "förpassande" ;
  foerpestande_nn_1_1_N = mkN "förpestande" ;
  foerpliktande_nn_1_1_N = mkN "förpliktande" ;
  foerpliktigande_nn_1_1_N = mkN "förpliktigande" ;
  foerplaegande_nn_1_1_N = mkN "förplägande" ;
  foerprickande_nn_1_1_N = mkN "förprickande" ;
  foerringande_nn_1_1_N = mkN "förringande" ;
  foerrinnande_nn_1_1_N = mkN "förrinnande" ;
  foerruttnande_nn_1_1_N = mkN "förruttnande" ;
  foerryckande_nn_1_1_N = mkN "förryckande" ;
  foerryskande_nn_1_1_N = mkN "förryskande" ;
  foerraentande_nn_1_1_N = mkN "förräntande" ;
  foerraettande_nn_1_1_N = mkN "förrättande" ;
  foerraaande_nn_1_1_N = mkN "förråande" ;
  foerraadande_nn_1_1_N = mkN "förrådande" ;
  foerraadsutrymme_nn_1_1_N = mkN "förrådsutrymme" ;
  foersakande_nn_1_1_N = mkN "försakande" ;
  foersamlande_nn_1_1_N = mkN "församlande" ;
  foerseende_nn_1_1_N = mkN "förseende" ;
  foerseglande_nn_1_1_N = mkN "förseglande" ;
  foersenande_nn_1_1_N = mkN "försenande" ;
  foersiggaaende_nn_1_1_N = mkN "försiggående" ;
  foersilvrande_nn_1_1_N = mkN "försilvrande" ;
  foersinkande_nn_1_1_N = mkN "försinkande" ;
  foersittande_nn_1_1_N = mkN "försittande" ;
  foersjunkande_nn_1_1_N = mkN "försjunkande" ;
  foerskaffande_nn_1_1_N = mkN "förskaffande" ;
  foerskansande_nn_1_1_N = mkN "förskansande" ;
  foerskingrande_nn_1_1_N = mkN "förskingrande" ;
  foerskjutande_nn_1_1_N = mkN "förskjutande" ;
  foerskonande_nn_1_1_N = mkN "förskonande" ;
  foerskotterande_nn_1_1_N = mkN "förskotterande" ;
  foerskrivande_nn_1_1_N = mkN "förskrivande" ;
  foerskraeckande_nn_1_1_N = mkN "förskräckande" ;
  foerskyllande_nn_1_1_N = mkN "förskyllande" ;
  foerskaerande_nn_1_1_N = mkN "förskärande" ;
  foerskoenande_nn_1_1_N = mkN "förskönande" ;
  foerslappande_nn_1_1_N = mkN "förslappande" ;
  foerslavande_nn_1_1_N = mkN "förslavande" ;
  foerslitande_nn_1_1_N = mkN "förslitande" ;
  foerslutande_nn_1_1_N = mkN "förslutande" ;
  foerslaaende_nn_1_1_N = mkN "förslående" ;
  foersloeande_nn_1_1_N = mkN "förslöande" ;
  foersloesande_nn_1_1_N = mkN "förslösande" ;
  foersmaektande_nn_1_1_N = mkN "försmäktande" ;
  foersmaaende_nn_1_1_N = mkN "försmående" ;
  foersnillande_nn_1_1_N = mkN "försnillande" ;
  foersonande_nn_1_1_N = mkN "försonande" ;
  foerspillande_nn_1_1_N = mkN "förspillande" ;
  foerspoerjande_nn_1_1_N = mkN "förspörjande" ;
  foerstatligande_nn_1_1_N = mkN "förstatligande" ;
  foerstelnande_nn_1_1_N = mkN "förstelnande" ;
  foerstenande_nn_1_1_N = mkN "förstenande" ;
  foerstlingsarbete_nn_1_1_N = mkN "förstlingsarbete" ;
  foerstockande_nn_1_1_N = mkN "förstockande" ;
  foerstoppande_nn_1_1_N = mkN "förstoppande" ;
  foerstorande_nn_1_1_N = mkN "förstorande" ;
  foerstraeckande_nn_1_1_N = mkN "försträckande" ;
  foerstraevande_nn_1_1_N = mkN "försträvande" ;
  foerstroeende_nn_1_1_N = mkN "förströende" ;
  foerstummande_nn_1_1_N = mkN "förstummande" ;
  foerstaellande_nn_1_1_N = mkN "förställande" ;
  foerstaemmande_nn_1_1_N = mkN "förstämmande" ;
  foerstaendigande_nn_1_1_N = mkN "förständigande" ;
  foerstaerkande_nn_1_1_N = mkN "förstärkande" ;
  foerstaaende_nn_1_1_N = mkN "förstående" ;
  foerstoerande_nn_1_1_N = mkN "förstörande" ;
  foersummande_nn_1_1_N = mkN "försummande" ;
  foersurande_nn_1_1_N = mkN "försurande" ;
  foersvagande_nn_1_1_N = mkN "försvagande" ;
  foersvarande_nn_1_1_N = mkN "försvarande" ;
  foersvarsomraade_nn_1_1_N = mkN "försvarsområde" ;
  foersvarsaatagande_nn_1_1_N = mkN "försvarsåtagande" ;
  foersvenskande_nn_1_1_N = mkN "försvenskande" ;
  foersvinnande_nn_1_1_N = mkN "försvinnande" ;
  foersvaerjande_nn_1_1_N = mkN "försvärjande" ;
  foersvaarande_nn_1_1_N = mkN "försvårande" ;
  foersaekrande_nn_1_1_N = mkN "försäkrande" ;
  foersaeljande_nn_1_1_N = mkN "försäljande" ;
  foersaemrande_nn_1_1_N = mkN "försämrande" ;
  foersaendande_nn_1_1_N = mkN "försändande" ;
  foersaenkande_nn_1_1_N = mkN "försänkande" ;
  foersaettande_nn_1_1_N = mkN "försättande" ;
  foersoekande_nn_1_1_N = mkN "försökande" ;
  foersoerjande_nn_1_1_N = mkN "försörjande" ;
  foersoerjningslaege_nn_1_1_N = mkN "försörjningsläge" ;
  foertagande_nn_1_1_N = mkN "förtagande" ;
  foertalande_nn_1_1_N = mkN "förtalande" ;
  foertecknande_nn_1_1_N = mkN "förtecknande" ;
  foertennande_nn_1_1_N = mkN "förtennande" ;
  foertidspensionerande_nn_1_1_N = mkN "förtidspensionerande" ;
  foertigande_nn_1_1_N = mkN "förtigande" ;
  foertjockande_nn_1_1_N = mkN "förtjockande" ;
  foertjusande_nn_1_1_N = mkN "förtjusande" ;
  foertjaenande_nn_1_1_N = mkN "förtjänande" ;
  foertonande_nn_1_1_N = mkN "förtonande" ;
  foertorkande_nn_1_1_N = mkN "förtorkande" ;
  foertrampande_nn_1_1_N = mkN "förtrampande" ;
  foertretande_nn_1_1_N = mkN "förtretande" ;
  foertroende_nn_1_1_N = mkN "förtroende" ;
  foertrollande_nn_1_1_N = mkN "förtrollande" ;
  foertrustande_nn_1_1_N = mkN "förtrustande" ;
  foertryckande_nn_1_1_N = mkN "förtryckande" ;
  foertrytande_nn_1_1_N = mkN "förtrytande" ;
  foertraengande_nn_1_1_N = mkN "förträngande" ;
  foertroestande_nn_1_1_N = mkN "förtröstande" ;
  foertullande_nn_1_1_N = mkN "förtullande" ;
  foertunnande_nn_1_1_N = mkN "förtunnande" ;
  foertvinande_nn_1_1_N = mkN "förtvinande" ;
  foertvivlande_nn_1_1_N = mkN "förtvivlande" ;
  foertvaalande_nn_1_1_N = mkN "förtvålande" ;
  foertyckande_nn_1_1_N = mkN "förtyckande" ;
  foertydligande_nn_1_1_N = mkN "förtydligande" ;
  foertyskande_nn_1_1_N = mkN "förtyskande" ;
  foertaeljande_nn_1_1_N = mkN "förtäljande" ;
  foertaenkande_nn_1_1_N = mkN "förtänkande" ;
  foertaerande_nn_1_1_N = mkN "förtärande" ;
  foertaetande_nn_1_1_N = mkN "förtätande" ;
  foertoejande_nn_1_1_N = mkN "förtöjande" ;
  foerundersoekande_nn_1_1_N = mkN "förundersökande" ;
  foerundrande_nn_1_1_N = mkN "förundrande" ;
  foerunnande_nn_1_1_N = mkN "förunnande" ;
  foerutbestaemmande_nn_1_1_N = mkN "förutbestämmande" ;
  foerutskickande_nn_1_1_N = mkN "förutskickande" ;
  foerutspaaende_nn_1_1_N = mkN "förutspående" ;
  foerutsaegande_nn_1_1_N = mkN "förutsägande" ;
  foerutsaettande_nn_1_1_N = mkN "förutsättande" ;
  foervaltande_nn_1_1_N = mkN "förvaltande" ;
  foervaltarskapsomraade_nn_1_1_N = mkN "förvaltarskapsområde" ;
  foervandlande_nn_1_1_N = mkN "förvandlande" ;
  foervanskande_nn_1_1_N = mkN "förvanskande" ;
  foervarande_nn_1_1_N = mkN "förvarande" ;
  foervaringsstaelle_nn_1_1_N = mkN "förvaringsställe" ;
  foervaringsutrymme_nn_1_1_N = mkN "förvaringsutrymme" ;
  foervarnande_nn_1_1_N = mkN "förvarnande" ;
  foervedande_nn_1_1_N = mkN "förvedande" ;
  foervekligande_nn_1_1_N = mkN "förvekligande" ;
  foerverkande_nn_1_1_N = mkN "förverkande" ;
  foerverkligande_nn_1_1_N = mkN "förverkligande" ;
  foervillande_nn_1_1_N = mkN "förvillande" ;
  foervirrande_nn_1_1_N = mkN "förvirrande" ;
  foervisande_nn_1_1_N = mkN "förvisande" ;
  foervissande_nn_1_1_N = mkN "förvissande" ;
  foervissnande_nn_1_1_N = mkN "förvissnande" ;
  foervittrande_nn_1_1_N = mkN "förvittrande" ;
  foervridande_nn_1_1_N = mkN "förvridande" ;
  foervraengande_nn_1_1_N = mkN "förvrängande" ;
  foervaegrande_nn_1_1_N = mkN "förvägrande" ;
  foervaellande_nn_1_1_N = mkN "förvällande" ;
  foervaendande_nn_1_1_N = mkN "förvändande" ;
  foervaentande_nn_1_1_N = mkN "förväntande" ;
  foervaerldsligande_nn_1_1_N = mkN "förvärldsligande" ;
  foervaerrande_nn_1_1_N = mkN "förvärrande" ;
  foervaervande_nn_1_1_N = mkN "förvärvande" ;
  foervaervsarbetande_nn_1_1_N = mkN "förvärvsarbetande" ;
  foervaexlande_nn_1_1_N = mkN "förväxlande" ;
  foervaanande_nn_1_1_N = mkN "förvånande" ;
  foeryngrande_nn_1_1_N = mkN "föryngrande" ;
  foerzinkande_nn_1_1_N = mkN "förzinkande" ;
  foeraedlande_nn_1_1_N = mkN "förädlande" ;
  foeraedlingsarbete_nn_1_1_N = mkN "förädlingsarbete" ;
  foeraeldramoete_nn_1_1_N = mkN "föräldramöte" ;
  foeraendrande_nn_1_1_N = mkN "förändrande" ;
  foeraendringsarbete_nn_1_1_N = mkN "förändringsarbete" ;
  foeraerande_nn_1_1_N = mkN "förärande" ;
  foeraangande_nn_1_1_N = mkN "förångande" ;
  foeroedande_nn_1_1_N = mkN "förödande" ;
  foeroedmjukande_nn_1_1_N = mkN "förödmjukande" ;
  foeroekande_nn_1_1_N = mkN "förökande" ;
  foeroevande_nn_1_1_N = mkN "förövande" ;
  foesande_nn_1_1_N = mkN "fösande" ;
  gafflande_nn_1_N = mkN "gafflande" ;
  gaggande_nn_1_N = mkN "gaggande" ;
  gagnande_nn_1_N = mkN "gagnande" ;
  galande_nn_1_N = mkN "galande" ;
  galliserande_nn_1_N = mkN "galliserande" ;
  gallrande_nn_1_N = mkN "gallrande" ;
  gallskrikande_nn_1_N = mkN "gallskrikande" ;
  galltjutande_nn_1_N = mkN "galltjutande" ;
  gallaepple_nn_1_1_N = mkN "galläpple" ;
  galopperande_nn_1_N = mkN "galopperande" ;
  galoscherande_nn_1_N = mkN "galoscherande" ;
  galvande_nn_1_N = mkN "galvande" ;
  galvaniserande_nn_1_N = mkN "galvaniserande" ;
  gamande_nn_1_N = mkN "gamande" ;
  ganande_nn_1_N = mkN "ganande" ;
  gandhiskynke_nn_1_N = mkN "gandhiskynke" ;
  gapande_nn_1_N = mkN "gapande" ;
  gapflabbande_nn_1_N = mkN "gapflabbande" ;
  gapskrattande_nn_1_N = mkN "gapskrattande" ;
  garagerande_nn_1_N = mkN "garagerande" ;
  garande_nn_1_N = mkN "garande" ;
  garanterande_nn_1_N = mkN "garanterande" ;
  garde_nn_1_N = mkN "garde" ;
  garderande_nn_1_N = mkN "garderande" ;
  garnerande_nn_1_N = mkN "garnerande" ;
  garnisonerande_nn_1_N = mkN "garnisonerande" ;
  garrotterande_nn_1_N = mkN "garrotterande" ;
  garvande_nn_1_N = mkN "garvande" ;
  garvaemne_nn_1_1_N = mkN "garvämne" ;
  gasande_nn_1_N = mkN "gasande" ;
  gassande_nn_1_N = mkN "gassande" ;
  gastande_nn_1_N = mkN "gastande" ;
  gasterande_nn_1_N = mkN "gasterande" ;
  gastkramande_nn_1_N = mkN "gastkramande" ;
  gastroskoperande_nn_1_N = mkN "gastroskoperande" ;
  gauffrerande_nn_1_N = mkN "gauffrerande" ;
  gavelroeste_nn_1_1_N = mkN "gavelröste" ;
  geende_nn_1_N = mkN "geende" ;
  geggande_nn_1_N = mkN "geggande" ;
  gelatinerande_nn_1_N = mkN "gelatinerande" ;
  geleande_nn_1_N = mkN "geleande" ;
  geminerande_nn_1_N = mkN "geminerande" ;
  genande_nn_1_N = mkN "genande" ;
  gendrivande_nn_1_N = mkN "gendrivande" ;
  generaliserande_nn_1_N = mkN "generaliserande" ;
  generande_nn_1_N = mkN "generande" ;
  generationsskifte_nn_1_N = mkN "generationsskifte" ;
  genererande_nn_1_N = mkN "genererande" ;
  genfloede_nn_1_1_N = mkN "genflöde" ;
  gengaeldande_nn_1_1_N = mkN "gengäldande" ;
  genljudande_nn_1_N = mkN "genljudande" ;
  genmanipulerande_nn_1_N = mkN "genmanipulerande" ;
  genmaelande_nn_1_1_N = mkN "genmälande" ;
  genmaele_nn_1_1_N = mkN "genmäle" ;
  genomarbetande_nn_1_N = mkN "genomarbetande" ;
  genomborrande_nn_1_N = mkN "genomborrande" ;
  genombrytande_nn_1_N = mkN "genombrytande" ;
  genomdrivande_nn_1_N = mkN "genomdrivande" ;
  genomfarande_nn_1_N = mkN "genomfarande" ;
  genomfoerande_nn_1_1_N = mkN "genomförande" ;
  genomgaaende_nn_1_1_N = mkN "genomgående" ;
  genomkorsande_nn_1_N = mkN "genomkorsande" ;
  genomlevande_nn_1_N = mkN "genomlevande" ;
  genomlidande_nn_1_N = mkN "genomlidande" ;
  genomlysande_nn_1_N = mkN "genomlysande" ;
  genomsipprande_nn_1_N = mkN "genomsipprande" ;
  genomskaadande_nn_1_1_N = mkN "genomskådande" ;
  genomskoeljande_nn_1_1_N = mkN "genomsköljande" ;
  genomsnittsvaerde_nn_1_1_N = mkN "genomsnittsvärde" ;
  genomstroemmande_nn_1_1_N = mkN "genomströmmande" ;
  genomsyrande_nn_1_N = mkN "genomsyrande" ;
  genomsoekande_nn_1_1_N = mkN "genomsökande" ;
  genomtraengande_nn_1_1_N = mkN "genomträngande" ;
  genomtaenkande_nn_1_1_N = mkN "genomtänkande" ;
  genskjutande_nn_1_N = mkN "genskjutande" ;
  gentagande_nn_1_N = mkN "gentagande" ;
  geometriserande_nn_1_N = mkN "geometriserande" ;
  geotaggande_nn_1_N = mkN "geotaggande" ;
  germaniserande_nn_1_N = mkN "germaniserande" ;
  gestaltande_nn_1_N = mkN "gestaltande" ;
  gestikulerande_nn_1_N = mkN "gestikulerande" ;
  gevaerssikte_nn_1_1_N = mkN "gevärssikte" ;
  gevaerssmide_nn_1_1_N = mkN "gevärssmide" ;
  gifte_nn_1_N = mkN "gifte" ;
  gigande_nn_1_N = mkN "gigande" ;
  giggande_nn_1_N = mkN "giggande" ;
  giljande_nn_1_N = mkN "giljande" ;
  giljotinerande_nn_1_N = mkN "giljotinerande" ;
  gillande_nn_1_N = mkN "gillande" ;
  gille_nn_1_N = mkN "gille" ;
  gillrande_nn_1_N = mkN "gillrande" ;
  ginande_nn_1_N = mkN "ginande" ;
  gipande_nn_1_N = mkN "gipande" ;
  gippande_nn_1_N = mkN "gippande" ;
  gipsande_nn_1_N = mkN "gipsande" ;
  girande_nn_1_N = mkN "girande" ;
  girerande_nn_1_N = mkN "girerande" ;
  gissande_nn_1_N = mkN "gissande" ;
  gisslande_nn_1_N = mkN "gisslande" ;
  gisslantagande_nn_1_N = mkN "gisslantagande" ;
  gistande_nn_1_N = mkN "gistande" ;
  gistnande_nn_1_N = mkN "gistnande" ;
  gittande_nn_1_N = mkN "gittande" ;
  givande_nn_1_N = mkN "givande" ;
  gjordande_nn_1_N = mkN "gjordande" ;
  gjutande_nn_1_N = mkN "gjutande" ;
  glammande_nn_1_N = mkN "glammande" ;
  glamoriserande_nn_1_N = mkN "glamoriserande" ;
  glamouriserande_nn_1_N = mkN "glamouriserande" ;
  glanande_nn_1_N = mkN "glanande" ;
  glansande_nn_1_N = mkN "glansande" ;
  glanskande_nn_1_N = mkN "glanskande" ;
  glappande_nn_1_N = mkN "glappande" ;
  glasande_nn_1_N = mkN "glasande" ;
  glaserande_nn_1_N = mkN "glaserande" ;
  glassande_nn_1_N = mkN "glassande" ;
  glasaepple_nn_1_1_N = mkN "glasäpple" ;
  glattande_nn_1_N = mkN "glattande" ;
  glesande_nn_1_N = mkN "glesande" ;
  glesnande_nn_1_N = mkN "glesnande" ;
  glidande_nn_1_N = mkN "glidande" ;
  glimmande_nn_1_N = mkN "glimmande" ;
  glimrande_nn_1_N = mkN "glimrande" ;
  glimtande_nn_1_N = mkN "glimtande" ;
  glindrande_nn_1_N = mkN "glindrande" ;
  glipande_nn_1_N = mkN "glipande" ;
  glisande_nn_1_N = mkN "glisande" ;
  glittrande_nn_1_N = mkN "glittrande" ;
  gloende_nn_1_N = mkN "gloende" ;
  glorifierande_nn_1_N = mkN "glorifierande" ;
  glunkande_nn_1_N = mkN "glunkande" ;
  gluttande_nn_1_N = mkN "gluttande" ;
  glaedjande_nn_1_1_N = mkN "glädjande" ;
  glaedjeaemne_nn_1_1_N = mkN "glädjeämne" ;
  glaefsande_nn_1_1_N = mkN "gläfsande" ;
  glaensande_nn_1_1_N = mkN "glänsande" ;
  glaentande_nn_1_1_N = mkN "gläntande" ;
  glaettande_nn_1_1_N = mkN "glättande" ;
  gloedande_nn_1_1_N = mkN "glödande" ;
  gloedbakande_nn_1_1_N = mkN "glödbakande" ;
  gloedgande_nn_1_1_N = mkN "glödgande" ;
  gloedritande_nn_1_1_N = mkN "glödritande" ;
  gloedstekande_nn_1_1_N = mkN "glödstekande" ;
  gloedtaendande_nn_1_1_N = mkN "glödtändande" ;
  gloeggande_nn_1_1_N = mkN "glöggande" ;
  gloemmande_nn_1_1_N = mkN "glömmande" ;
  gloetande_nn_1_1_N = mkN "glötande" ;
  gnagande_nn_1_N = mkN "gnagande" ;
  gnatande_nn_1_N = mkN "gnatande" ;
  gnavande_nn_1_N = mkN "gnavande" ;
  gnetande_nn_1_N = mkN "gnetande" ;
  gnidande_nn_1_N = mkN "gnidande" ;
  gnisslande_nn_1_N = mkN "gnisslande" ;
  gnistande_nn_1_N = mkN "gnistande" ;
  gnistrande_nn_1_N = mkN "gnistrande" ;
  gnoende_nn_1_N = mkN "gnoende" ;
  gnolande_nn_1_N = mkN "gnolande" ;
  gnuggande_nn_1_N = mkN "gnuggande" ;
  gnussande_nn_1_N = mkN "gnussande" ;
  gnyende_nn_1_N = mkN "gnyende" ;
  gnaeggande_nn_1_1_N = mkN "gnäggande" ;
  gnaellande_nn_1_1_N = mkN "gnällande" ;
  gnoelande_nn_1_1_N = mkN "gnölande" ;
  godkaennande_nn_1_1_N = mkN "godkännande" ;
  godtagande_nn_1_N = mkN "godtagande" ;
  goffrerande_nn_1_N = mkN "goffrerande" ;
  golfande_nn_1_N = mkN "golfande" ;
  golvande_nn_1_N = mkN "golvande" ;
  googlande_nn_1_N = mkN "googlande" ;
  gormande_nn_1_N = mkN "gormande" ;
  gosande_nn_1_N = mkN "gosande" ;
  gottgoerande_nn_1_1_N = mkN "gottgörande" ;
  gottskrivande_nn_1_N = mkN "gottskrivande" ;
  gouterande_nn_1_N = mkN "gouterande" ;
  grabbande_nn_1_N = mkN "grabbande" ;
  gradande_nn_1_N = mkN "gradande" ;
  graderande_nn_1_N = mkN "graderande" ;
  graduerande_nn_1_N = mkN "graduerande" ;
  grafiterande_nn_1_N = mkN "grafiterande" ;
  granataepple_nn_1_1_N = mkN "granatäpple" ;
  grannrike_nn_1_N = mkN "grannrike" ;
  grannraecke_nn_1_1_N = mkN "grannräcke" ;
  granskande_nn_1_N = mkN "granskande" ;
  granulerande_nn_1_N = mkN "granulerande" ;
  grasserande_nn_1_N = mkN "grasserande" ;
  gratinerande_nn_1_N = mkN "gratinerande" ;
  gratisnoeje_nn_1_1_N = mkN "gratisnöje" ;
  grattande_nn_1_N = mkN "grattande" ;
  gratulerande_nn_1_N = mkN "gratulerande" ;
  gravande_nn_1_N = mkN "gravande" ;
  graverande_nn_1_N = mkN "graverande" ;
  graviterande_nn_1_N = mkN "graviterande" ;
  gravlaeggande_nn_1_1_N = mkN "gravläggande" ;
  gravroese_nn_1_1_N = mkN "gravröse" ;
  gravsaettande_nn_1_1_N = mkN "gravsättande" ;
  grejande_nn_1_N = mkN "grejande" ;
  grenadjaerregemente_nn_1_1_N = mkN "grenadjärregemente" ;
  grenslande_nn_1_N = mkN "grenslande" ;
  greppande_nn_1_N = mkN "greppande" ;
  greppbraede_nn_1_1_N = mkN "greppbräde" ;
  griljerande_nn_1_N = mkN "griljerande" ;
  grillande_nn_1_N = mkN "grillande" ;
  grimaserande_nn_1_N = mkN "grimaserande" ;
  grimerande_nn_1_N = mkN "grimerande" ;
  grinande_nn_1_N = mkN "grinande" ;
  gripande_nn_1_N = mkN "gripande" ;
  grisande_nn_1_N = mkN "grisande" ;
  groddande_nn_1_N = mkN "groddande" ;
  groende_nn_1_N = mkN "groende" ;
  groggande_nn_1_N = mkN "groggande" ;
  grovarbete_nn_1_N = mkN "grovarbete" ;
  grovnande_nn_1_N = mkN "grovnande" ;
  grovplanerande_nn_1_N = mkN "grovplanerande" ;
  grovsorterande_nn_1_N = mkN "grovsorterande" ;
  grubblande_nn_1_N = mkN "grubblande" ;
  gruffande_nn_1_N = mkN "gruffande" ;
  grumlande_nn_1_N = mkN "grumlande" ;
  grumsande_nn_1_N = mkN "grumsande" ;
  grundande_nn_1_N = mkN "grundande" ;
  grundantagande_nn_1_N = mkN "grundantagande" ;
  grundbehandlande_nn_1_N = mkN "grundbehandlande" ;
  grunderande_nn_1_N = mkN "grunderande" ;
  grundlurande_nn_1_N = mkN "grundlurande" ;
  grundlaeggande_nn_1_1_N = mkN "grundläggande" ;
  grundmaalande_nn_1_1_N = mkN "grundmålande" ;
  grundstoetande_nn_1_1_N = mkN "grundstötande" ;
  grundaemne_nn_1_1_N = mkN "grundämne" ;
  grunnande_nn_1_N = mkN "grunnande" ;
  grupparbete_nn_1_N = mkN "grupparbete" ;
  gruppboende_nn_1_N = mkN "gruppboende" ;
  grupperande_nn_1_N = mkN "grupperande" ;
  gruppsaaende_nn_1_1_N = mkN "gruppsående" ;
  grusande_nn_1_N = mkN "grusande" ;
  gryende_nn_1_N = mkN "gryende" ;
  grymtande_nn_1_N = mkN "grymtande" ;
  grynande_nn_1_N = mkN "grynande" ;
  graeddande_nn_1_1_N = mkN "gräddande" ;
  graeftande_nn_1_1_N = mkN "gräftande" ;
  graelande_nn_1_1_N = mkN "grälande" ;
  graemande_nn_1_1_N = mkN "grämande" ;
  graenslande_nn_1_1_N = mkN "gränslande" ;
  graensmaerke_nn_1_1_N = mkN "gränsmärke" ;
  graensomraade_nn_1_1_N = mkN "gränsområde" ;
  graensvaerde_nn_1_1_N = mkN "gränsvärde" ;
  graensoeverskridande_nn_1_1_N = mkN "gränsöverskridande" ;
  graesande_nn_1_1_N = mkN "gräsande" ;
  graevande_nn_1_1_N = mkN "grävande" ;
  graanande_nn_1_1_N = mkN "grånande" ;
  graatande_nn_1_1_N = mkN "gråtande" ;
  groengoedslande_nn_1_1_N = mkN "gröngödslande" ;
  groenomraade_nn_1_1_N = mkN "grönområde" ;
  groenskande_nn_1_1_N = mkN "grönskande" ;
  groepande_nn_1_1_N = mkN "gröpande" ;
  groetande_nn_1_1_N = mkN "grötande" ;
  gubbvaelde_nn_1_1_N = mkN "gubbvälde" ;
  gudabelaete_nn_1_1_N = mkN "gudabeläte" ;
  guidande_nn_1_N = mkN "guidande" ;
  guldsmide_nn_1_N = mkN "guldsmide" ;
  guldaepple_nn_1_1_N = mkN "guldäpple" ;
  gulfaergande_nn_1_1_N = mkN "gulfärgande" ;
  gullande_nn_1_N = mkN "gullande" ;
  gulnande_nn_1_N = mkN "gulnande" ;
  gummerande_nn_1_N = mkN "gummerande" ;
  gumpande_nn_1_N = mkN "gumpande" ;
  gungande_nn_1_N = mkN "gungande" ;
  gungbraede_nn_1_1_N = mkN "gungbräde" ;
  guppande_nn_1_N = mkN "guppande" ;
  gurglande_nn_1_N = mkN "gurglande" ;
  guskande_nn_1_N = mkN "guskande" ;
  guterande_nn_1_N = mkN "guterande" ;
  gycklande_nn_1_N = mkN "gycklande" ;
  gyllenklaede_nn_1_1_N = mkN "gyllenkläde" ;
  gymnastiserande_nn_1_N = mkN "gymnastiserande" ;
  gympande_nn_1_N = mkN "gympande" ;
  gynnande_nn_1_N = mkN "gynnande" ;
  gyttrande_nn_1_N = mkN "gyttrande" ;
  gaeckande_nn_1_1_N = mkN "gäckande" ;
  gaelande_nn_1_1_N = mkN "gälande" ;
  gaeldande_nn_1_1_N = mkN "gäldande" ;
  gaellande_nn_1_1_N = mkN "gällande" ;
  gaengande_nn_1_1_N = mkN "gängande" ;
  gaenge_nn_1_1_N = mkN "gänge" ;
  gaerdande_nn_1_1_N = mkN "gärdande" ;
  gaerde_nn_1_1_N = mkN "gärde" ;
  gaerdslande_nn_1_1_N = mkN "gärdslande" ;
  gaerdsle_nn_1_1_N = mkN "gärdsle" ;
  gaespande_nn_1_1_N = mkN "gäspande" ;
  gaestande_nn_1_1_N = mkN "gästande" ;
  gaestspelande_nn_1_1_N = mkN "gästspelande" ;
  gaaende_nn_1_1_N = mkN "gående" ;
  gaangande_nn_1_1_N = mkN "gångande" ;
  gaangrande_nn_1_1_N = mkN "gångrande" ;
  gaardsomraade_nn_1_1_N = mkN "gårdsområde" ;
  goedande_nn_1_1_N = mkN "gödande" ;
  goedslande_nn_1_1_N = mkN "gödslande" ;
  goekande_nn_1_1_N = mkN "gökande" ;
  goemmande_nn_1_1_N = mkN "gömmande" ;
  goemme_nn_1_1_N = mkN "gömme" ;
  goemsle_nn_1_1_N = mkN "gömsle" ;
  goemstaelle_nn_1_1_N = mkN "gömställe" ;
  goerande_nn_1_1_N = mkN "görande" ;
  goerdlande_nn_1_1_N = mkN "gördlande" ;
  goete_nn_1_1_N = mkN "göte" ;
  hackande_nn_1_N = mkN "hackande" ;
  hackbraede_nn_1_1_N = mkN "hackbräde" ;
  haffande_nn_1_N = mkN "haffande" ;
  hafsande_nn_1_N = mkN "hafsande" ;
  haglande_nn_1_N = mkN "haglande" ;
  hajande_nn_1_N = mkN "hajande" ;
  hajkande_nn_1_N = mkN "hajkande" ;
  hakande_nn_1_N = mkN "hakande" ;
  halande_nn_1_N = mkN "halande" ;
  halkande_nn_1_N = mkN "halkande" ;
  hallelujamoete_nn_1_1_N = mkN "hallelujamöte" ;
  hallstaemplande_nn_1_1_N = mkN "hallstämplande" ;
  hallucinerande_nn_1_N = mkN "hallucinerande" ;
  hallaaande_nn_1_1_N = mkN "hallåande" ;
  halsande_nn_1_N = mkN "halsande" ;
  halshuggande_nn_1_N = mkN "halshuggande" ;
  halssmycke_nn_1_N = mkN "halssmycke" ;
  halstrande_nn_1_N = mkN "halstrande" ;
  haltande_nn_1_N = mkN "haltande" ;
  halverande_nn_1_N = mkN "halverande" ;
  halvsovande_nn_1_N = mkN "halvsovande" ;
  halvsulande_nn_1_N = mkN "halvsulande" ;
  halvviskande_nn_1_N = mkN "halvviskande" ;
  halvaarsskifte_nn_1_1_N = mkN "halvårsskifte" ;
  hamburgarstaelle_nn_1_1_N = mkN "hamburgarställe" ;
  hamburgerstaelle_nn_1_1_N = mkN "hamburgerställe" ;
  hamlande_nn_1_N = mkN "hamlande" ;
  hamnande_nn_1_N = mkN "hamnande" ;
  hamnfoerhaallande_nn_1_1_N = mkN "hamnförhållande" ;
  hamrande_nn_1_N = mkN "hamrande" ;
  hamstrande_nn_1_N = mkN "hamstrande" ;
  handarbetande_nn_1_N = mkN "handarbetande" ;
  handarbete_nn_1_N = mkN "handarbete" ;
  handelsutbyte_nn_1_N = mkN "handelsutbyte" ;
  handhavande_nn_1_N = mkN "handhavande" ;
  handikappande_nn_1_N = mkN "handikappande" ;
  handlande_nn_2_N = mkN "handlande" ;
  handledande_nn_1_N = mkN "handledande" ;
  handlaeggande_nn_1_1_N = mkN "handläggande" ;
  handplockande_nn_1_N = mkN "handplockande" ;
  hankande_nn_1_N = mkN "hankande" ;
  hanterande_nn_1_N = mkN "hanterande" ;
  harangerande_nn_1_N = mkN "harangerande" ;
  harklande_nn_1_N = mkN "harklande" ;
  harmande_nn_1_N = mkN "harmande" ;
  harmonierande_nn_1_N = mkN "harmonierande" ;
  harmoniserande_nn_1_N = mkN "harmoniserande" ;
  harpunerande_nn_1_N = mkN "harpunerande" ;
  harsklande_nn_1_N = mkN "harsklande" ;
  hartsande_nn_1_N = mkN "hartsande" ;
  harvande_nn_1_N = mkN "harvande" ;
  hasande_nn_1_N = mkN "hasande" ;
  hasarderande_nn_1_N = mkN "hasarderande" ;
  haspande_nn_1_N = mkN "haspande" ;
  hasplande_nn_1_N = mkN "hasplande" ;
  hastande_nn_1_N = mkN "hastande" ;
  hatande_nn_1_N = mkN "hatande" ;
  hattande_nn_1_N = mkN "hattande" ;
  haussande_nn_1_N = mkN "haussande" ;
  havande_nn_1_N = mkN "havande" ;
  havererande_nn_1_N = mkN "havererande" ;
  havsomraade_nn_1_1_N = mkN "havsområde" ;
  hedersomnaemnande_nn_1_1_N = mkN "hedersomnämnande" ;
  hedrande_nn_1_N = mkN "hedrande" ;
  hejande_nn_1_N = mkN "hejande" ;
  hejdande_nn_1_N = mkN "hejdande" ;
  hektograferande_nn_1_N = mkN "hektograferande" ;
  helande_nn_1_N = mkN "helande" ;
  helfoersaekrande_nn_1_1_N = mkN "helförsäkrande" ;
  helgande_nn_1_N = mkN "helgande" ;
  helgarderande_nn_1_N = mkN "helgarderande" ;
  helgonfoerklarande_nn_1_1_N = mkN "helgonförklarande" ;
  helinackorderande_nn_1_N = mkN "helinackorderande" ;
  helsike_nn_1_N = mkN "helsike" ;
  helvete_nn_1_N = mkN "helvete" ;
  hemarbete_nn_1_N = mkN "hemarbete" ;
  hembitraede_nn_1_1_N = mkN "hembiträde" ;
  hembjudande_nn_1_N = mkN "hembjudande" ;
  hembaerande_nn_1_1_N = mkN "hembärande" ;
  hemfallande_nn_1_N = mkN "hemfallande" ;
  hemfoerande_nn_1_1_N = mkN "hemförande" ;
  hemfoerlovande_nn_1_1_N = mkN "hemförlovande" ;
  hemkallande_nn_1_N = mkN "hemkallande" ;
  hemlighaallande_nn_1_1_N = mkN "hemlighållande" ;
  hemligstaemplande_nn_1_1_N = mkN "hemligstämplande" ;
  hemstaellande_nn_1_1_N = mkN "hemställande" ;
  hemsoekande_nn_1_1_N = mkN "hemsökande" ;
  hemvaendande_nn_1_1_N = mkN "hemvändande" ;
  henande_nn_1_N = mkN "henande" ;
  herdaminne_nn_1_N = mkN "herdaminne" ;
  herkulesarbete_nn_1_N = mkN "herkulesarbete" ;
  heroiserande_nn_1_N = mkN "heroiserande" ;
  herradoeme_nn_1_1_N = mkN "herradöme" ;
  herravaelde_nn_1_1_N = mkN "herravälde" ;
  herresaete_nn_1_1_N = mkN "herresäte" ;
  herrmode_nn_1_N = mkN "herrmode" ;
  hertigdoeme_nn_1_1_N = mkN "hertigdöme" ;
  hesiterande_nn_1_N = mkN "hesiterande" ;
  hetande_nn_1_N = mkN "hetande" ;
  hetsande_nn_1_N = mkN "hetsande" ;
  hettande_nn_1_N = mkN "hettande" ;
  hibernerande_nn_1_N = mkN "hibernerande" ;
  hickande_nn_1_N = mkN "hickande" ;
  himlande_nn_1_N = mkN "himlande" ;
  hindrande_nn_1_N = mkN "hindrande" ;
  hinkande_nn_1_N = mkN "hinkande" ;
  hinnande_nn_1_N = mkN "hinnande" ;
  hisnande_nn_1_N = mkN "hisnande" ;
  hissande_nn_1_N = mkN "hissande" ;
  hissnande_nn_1_N = mkN "hissnande" ;
  historieberaettande_nn_1_1_N = mkN "historieberättande" ;
  historierande_nn_1_N = mkN "historierande" ;
  historiserande_nn_1_N = mkN "historiserande" ;
  hittande_nn_1_N = mkN "hittande" ;
  hivande_nn_1_N = mkN "hivande" ;
  hjulande_nn_1_N = mkN "hjulande" ;
  hjaelpande_nn_1_1_N = mkN "hjälpande" ;
  hjaernbyte_nn_1_1_N = mkN "hjärnbyte" ;
  hjaernspoeke_nn_1_1_N = mkN "hjärnspöke" ;
  hjaerntvaettande_nn_1_1_N = mkN "hjärntvättande" ;
  hoande_nn_1_N = mkN "hoande" ;
  hojande_nn_1_N = mkN "hojande" ;
  hojtande_nn_1_N = mkN "hojtande" ;
  holograferande_nn_1_N = mkN "holograferande" ;
  homogeniserande_nn_1_N = mkN "homogeniserande" ;
  honorerande_nn_1_N = mkN "honorerande" ;
  hopande_nn_1_N = mkN "hopande" ;
  hopbringande_nn_1_N = mkN "hopbringande" ;
  hopbuntande_nn_1_N = mkN "hopbuntande" ;
  hopdiktande_nn_1_N = mkN "hopdiktande" ;
  hopfogande_nn_1_N = mkN "hopfogande" ;
  hopknycklande_nn_1_N = mkN "hopknycklande" ;
  hopknytande_nn_1_N = mkN "hopknytande" ;
  hopkopplande_nn_1_N = mkN "hopkopplande" ;
  hoplappande_nn_1_N = mkN "hoplappande" ;
  hoppackande_nn_1_N = mkN "hoppackande" ;
  hoppande_nn_1_N = mkN "hoppande" ;
  hoprafsande_nn_1_N = mkN "hoprafsande" ;
  hopskjutande_nn_1_N = mkN "hopskjutande" ;
  hopvikande_nn_1_N = mkN "hopvikande" ;
  horande_nn_1_N = mkN "horande" ;
  horisontallaege_nn_1_1_N = mkN "horisontalläge" ;
  hospitaliserande_nn_1_N = mkN "hospitaliserande" ;
  hostande_nn_1_N = mkN "hostande" ;
  hotande_nn_1_N = mkN "hotande" ;
  hottande_nn_1_N = mkN "hottande" ;
  hovnigande_nn_1_N = mkN "hovnigande" ;
  hovrande_nn_1_N = mkN "hovrande" ;
  huckle_nn_1_N = mkN "huckle" ;
  hudflaengande_nn_1_1_N = mkN "hudflängande" ;
  hugfaestande_nn_1_1_N = mkN "hugfästande" ;
  huggande_nn_1_N = mkN "huggande" ;
  hugnande_nn_1_N = mkN "hugnande" ;
  hugsvalande_nn_1_N = mkN "hugsvalande" ;
  hulkande_nn_1_N = mkN "hulkande" ;
  humaniserande_nn_1_N = mkN "humaniserande" ;
  hummande_nn_1_N = mkN "hummande" ;
  humusaemne_nn_1_1_N = mkN "humusämne" ;
  hundare_nn_1_N = mkN "hundare" ;
  hundrade_nn_1_N = mkN "hundrade" ;
  hundraaarsminne_nn_1_1_N = mkN "hundraårsminne" ;
  hundsande_nn_1_N = mkN "hundsande" ;
  hundsfotterande_nn_1_N = mkN "hundsfotterande" ;
  hungerstrejkande_nn_1_N = mkN "hungerstrejkande" ;
  hungrande_nn_1_N = mkN "hungrande" ;
  hunsande_nn_1_N = mkN "hunsande" ;
  hurrande_nn_1_N = mkN "hurrande" ;
  hursarregemente_nn_1_N = mkN "hursarregemente" ;
  husbygge_nn_1_N = mkN "husbygge" ;
  huserande_nn_1_N = mkN "huserande" ;
  hushaallande_nn_1_1_N = mkN "hushållande" ;
  hushaallsarbete_nn_1_1_N = mkN "hushållsarbete" ;
  hutande_nn_1_N = mkN "hutande" ;
  huttlande_nn_1_N = mkN "huttlande" ;
  huttrande_nn_1_N = mkN "huttrande" ;
  huve_nn_1_N = mkN "huve" ;
  huvudanfoerande_nn_1_1_N = mkN "huvudanförande" ;
  huvudintresse_nn_1_N = mkN "huvudintresse" ;
  huvudstycke_nn_1_N = mkN "huvudstycke" ;
  huvudsaete_nn_1_1_N = mkN "huvudsäte" ;
  huvudvittne_nn_1_N = mkN "huvudvittne" ;
  huvudaemne_nn_1_1_N = mkN "huvudämne" ;
  hybble_nn_1_N = mkN "hybble" ;
  hybridiserande_nn_1_N = mkN "hybridiserande" ;
  hycklande_nn_1_N = mkN "hycklande" ;
  hydrerande_nn_1_N = mkN "hydrerande" ;
  hyende_nn_1_N = mkN "hyende" ;
  hyfsande_nn_1_N = mkN "hyfsande" ;
  hygge_nn_1_N = mkN "hygge" ;
  hylande_nn_1_N = mkN "hylande" ;
  hyllande_nn_1_N = mkN "hyllande" ;
  hylle_nn_1_N = mkN "hylle" ;
  hymlande_nn_1_N = mkN "hymlande" ;
  hypnotiserande_nn_1_N = mkN "hypnotiserande" ;
  hypotiserande_nn_1_N = mkN "hypotiserande" ;
  hyrande_nn_1_N = mkN "hyrande" ;
  hyresreglerande_nn_1_N = mkN "hyresreglerande" ;
  hysande_nn_1_N = mkN "hysande" ;
  hyssjande_nn_1_N = mkN "hyssjande" ;
  hystande_nn_1_N = mkN "hystande" ;
  hyttande_nn_1_N = mkN "hyttande" ;
  hyvande_nn_1_N = mkN "hyvande" ;
  hyvlande_nn_1_N = mkN "hyvlande" ;
  haeckande_nn_1_1_N = mkN "häckande" ;
  haecklande_nn_1_1_N = mkN "häcklande" ;
  haedande_nn_1_1_N = mkN "hädande" ;
  haedankallande_nn_1_1_N = mkN "hädankallande" ;
  haeftande_nn_1_1_N = mkN "häftande" ;
  haefte_nn_1_1_N = mkN "häfte" ;
  haegnande_nn_1_1_N = mkN "hägnande" ;
  haegrande_nn_1_1_N = mkN "hägrande" ;
  haektande_nn_1_1_N = mkN "häktande" ;
  haekte_nn_1_1_N = mkN "häkte" ;
  haellande_nn_1_1_N = mkN "hällande" ;
  haellregnande_nn_1_1_N = mkN "hällregnande" ;
  haelsande_nn_1_1_N = mkN "hälsande" ;
  haelsningsanfoerande_nn_1_1_N = mkN "hälsningsanförande" ;
  haelsningsfoerfarande_nn_1_1_N = mkN "hälsningsförfarande" ;
  haelsolaege_nn_1_1_N = mkN "hälsoläge" ;
  haemmande_nn_1_1_N = mkN "hämmande" ;
  haemnande_nn_1_1_N = mkN "hämnande" ;
  haemtande_nn_1_1_N = mkN "hämtande" ;
  haendande_nn_1_1_N = mkN "händande" ;
  haenfoerande_nn_1_1_N = mkN "hänförande" ;
  haengande_nn_1_1_N = mkN "hängande" ;
  haengbrobygge_nn_1_1_N = mkN "hängbrobygge" ;
  haenge_nn_1_1_N = mkN "hänge" ;
  haengsle_nn_1_1_N = mkN "hängsle" ;
  haengsmycke_nn_1_1_N = mkN "hängsmycke" ;
  haenryckande_nn_1_1_N = mkN "hänryckande" ;
  haenseende_nn_1_1_N = mkN "hänseende" ;
  haenskjutande_nn_1_1_N = mkN "hänskjutande" ;
  haensyftande_nn_1_1_N = mkN "hänsyftande" ;
  haensynstagande_nn_1_1_N = mkN "hänsynstagande" ;
  haentydande_nn_1_1_N = mkN "häntydande" ;
  haenvisande_nn_1_1_N = mkN "hänvisande" ;
  haepnande_nn_1_1_N = mkN "häpnande" ;
  haerbre_nn_1_1_N = mkN "härbre" ;
  haerbaerge_nn_1_1_N = mkN "härbärge" ;
  haerbaergerande_nn_1_1_N = mkN "härbärgerande" ;
  haerdande_nn_1_1_N = mkN "härdande" ;
  haerflytande_nn_1_1_N = mkN "härflytande" ;
  haerjande_nn_1_1_N = mkN "härjande" ;
  haerledande_nn_1_1_N = mkN "härledande" ;
  haermande_nn_1_1_N = mkN "härmande" ;
  haerroerande_nn_1_1_N = mkN "härrörande" ;
  haerskande_nn_1_1_N = mkN "härskande" ;
  haersknande_nn_1_1_N = mkN "härsknande" ;
  haerstammande_nn_1_1_N = mkN "härstammande" ;
  haessjande_nn_1_1_N = mkN "hässjande" ;
  haestansikte_nn_1_1_N = mkN "hästansikte" ;
  haevande_nn_1_1_N = mkN "hävande" ;
  haevdande_nn_1_1_N = mkN "hävdande" ;
  haalande_nn_1_1_N = mkN "hålande" ;
  haallande_nn_1_1_N = mkN "hållande" ;
  haalslaaende_nn_1_1_N = mkN "hålslående" ;
  haanande_nn_1_1_N = mkN "hånande" ;
  haanflinande_nn_1_1_N = mkN "hånflinande" ;
  haanglande_nn_1_1_N = mkN "hånglande" ;
  haanleende_nn_1_1_N = mkN "hånleende" ;
  haanskrattande_nn_1_1_N = mkN "hånskrattande" ;
  haardnande_nn_1_1_N = mkN "hårdnande" ;
  haardragande_nn_1_1_N = mkN "hårdragande" ;
  haardtraenande_nn_1_1_N = mkN "hårdtränande" ;
  haarfaeste_nn_1_1_N = mkN "hårfäste" ;
  haarmode_nn_1_1_N = mkN "hårmode" ;
  haarspaenne_nn_1_1_N = mkN "hårspänne" ;
  haavande_nn_1_1_N = mkN "håvande" ;
  hoeftskynke_nn_1_1_N = mkN "höftskynke" ;
  hoegaktande_nn_1_1_N = mkN "högaktande" ;
  hoegfjaellsomraade_nn_1_1_N = mkN "högfjällsområde" ;
  hoegriskbeteende_nn_1_1_N = mkN "högriskbeteende" ;
  hoegsaete_nn_1_1_N = mkN "högsäte" ;
  hoegtidlighaallande_nn_1_1_N = mkN "högtidlighållande" ;
  hoegtrycksomraade_nn_1_1_N = mkN "högtrycksområde" ;
  hoejande_nn_1_1_N = mkN "höjande" ;
  hoejdlaege_nn_1_1_N = mkN "höjdläge" ;
  hoeljande_nn_1_1_N = mkN "höljande" ;
  hoelje_nn_1_1_N = mkN "hölje" ;
  hoerande_nn_1_1_N = mkN "hörande" ;
  hoersammande_nn_1_1_N = mkN "hörsammande" ;
  hoerselsinne_nn_1_1_N = mkN "hörselsinne" ;
  hoestande_nn_1_1_N = mkN "höstande" ;
  hoetande_nn_1_1_N = mkN "hötande" ;
  hoettande_nn_1_1_N = mkN "höttande" ;
  hoevdingasamhaelle_nn_1_1_N = mkN "hövdingasamhälle" ;
  iakttagande_nn_1_N = mkN "iakttagande" ;
  ide_nn_1_N = mkN "ide" ;
  idealiserande_nn_1_N = mkN "idealiserande" ;
  idealsamhaelle_nn_1_1_N = mkN "idealsamhälle" ;
  identifierande_nn_1_N = mkN "identifierande" ;
  idiotfoerklarande_nn_1_1_N = mkN "idiotförklarande" ;
  idisslande_nn_1_N = mkN "idisslande" ;
  idkande_nn_1_N = mkN "idkande" ;
  idrottande_nn_1_N = mkN "idrottande" ;
  idunsaepple_nn_1_1_N = mkN "idunsäpple" ;
  id_emoete_nn_1_1_N = mkN "idémöte" ;
  ifraagakommande_nn_1_1_N = mkN "ifrågakommande" ;
  ifraagasaettande_nn_1_1_N = mkN "ifrågasättande" ;
  ignorerande_nn_1_N = mkN "ignorerande" ;
  igaangsaettande_nn_1_1_N = mkN "igångsättande" ;
  ihopbuntande_nn_1_N = mkN "ihopbuntande" ;
  ihopknycklande_nn_1_N = mkN "ihopknycklande" ;
  ihopkopplande_nn_1_N = mkN "ihopkopplande" ;
  ihoppackande_nn_1_N = mkN "ihoppackande" ;
  ihopskjutande_nn_1_N = mkN "ihopskjutande" ;
  ihaagkommande_nn_1_1_N = mkN "ihågkommande" ;
  iklaedande_nn_1_1_N = mkN "iklädande" ;
  ilande_nn_1_N = mkN "ilande" ;
  ilandsaettande_nn_1_1_N = mkN "ilandsättande" ;
  illtjutande_nn_1_N = mkN "illtjutande" ;
  illuderande_nn_1_N = mkN "illuderande" ;
  illuminerande_nn_1_N = mkN "illuminerande" ;
  illustrerande_nn_1_N = mkN "illustrerande" ;
  illvraalande_nn_1_1_N = mkN "illvrålande" ;
  imiterande_nn_1_N = mkN "imiterande" ;
  immande_nn_1_N = mkN "immande" ;
  immatrikulerande_nn_1_N = mkN "immatrikulerande" ;
  immigrerande_nn_1_N = mkN "immigrerande" ;
  immuniserande_nn_1_N = mkN "immuniserande" ;
  impande_nn_1_N = mkN "impande" ;
  implanterande_nn_1_N = mkN "implanterande" ;
  implicerande_nn_1_N = mkN "implicerande" ;
  imploderande_nn_1_N = mkN "imploderande" ;
  imponerande_nn_1_N = mkN "imponerande" ;
  importerande_nn_1_N = mkN "importerande" ;
  impregnerande_nn_1_N = mkN "impregnerande" ;
  improviserande_nn_1_N = mkN "improviserande" ;
  inackorderande_nn_1_N = mkN "inackorderande" ;
  inarbetande_nn_1_N = mkN "inarbetande" ;
  inaugurerande_nn_1_N = mkN "inaugurerande" ;
  inbakande_nn_1_N = mkN "inbakande" ;
  inbegripande_nn_1_N = mkN "inbegripande" ;
  inberaeknande_nn_1_1_N = mkN "inberäknande" ;
  inbesparande_nn_1_N = mkN "inbesparande" ;
  inbetalande_nn_1_N = mkN "inbetalande" ;
  inbillande_nn_1_N = mkN "inbillande" ;
  inbringande_nn_1_N = mkN "inbringande" ;
  inbyggande_nn_1_N = mkN "inbyggande" ;
  inbyte_nn_1_N = mkN "inbyte" ;
  indelande_nn_1_N = mkN "indelande" ;
  indexerande_nn_1_N = mkN "indexerande" ;
  indexreglerande_nn_1_N = mkN "indexreglerande" ;
  indicerande_nn_1_N = mkN "indicerande" ;
  indikerande_nn_1_N = mkN "indikerande" ;
  individualiserande_nn_1_N = mkN "individualiserande" ;
  indoktrinerande_nn_1_N = mkN "indoktrinerande" ;
  indragande_nn_1_N = mkN "indragande" ;
  indrivande_nn_1_N = mkN "indrivande" ;
  indraenkande_nn_1_1_N = mkN "indränkande" ;
  inducerande_nn_1_N = mkN "inducerande" ;
  indunstande_nn_1_N = mkN "indunstande" ;
  industrialiserande_nn_1_N = mkN "industrialiserande" ;
  industriomraade_nn_1_1_N = mkN "industriområde" ;
  industrisamhaelle_nn_1_1_N = mkN "industrisamhälle" ;
  infallande_nn_1_N = mkN "infallande" ;
  infattande_nn_1_N = mkN "infattande" ;
  infekterande_nn_1_N = mkN "infekterande" ;
  infettande_nn_1_N = mkN "infettande" ;
  infiltrerande_nn_1_N = mkN "infiltrerande" ;
  infinitivmaerke_nn_1_1_N = mkN "infinitivmärke" ;
  inflammerande_nn_1_N = mkN "inflammerande" ;
  inflickande_nn_1_N = mkN "inflickande" ;
  inflikande_nn_1_N = mkN "inflikande" ;
  influerande_nn_1_N = mkN "influerande" ;
  inflytande_nn_1_N = mkN "inflytande" ;
  inflyttande_nn_1_N = mkN "inflyttande" ;
  inflaetande_nn_1_1_N = mkN "inflätande" ;
  infloede_nn_1_1_N = mkN "inflöde" ;
  infodrande_nn_1_N = mkN "infodrande" ;
  infogande_nn_1_N = mkN "infogande" ;
  infordrande_nn_1_N = mkN "infordrande" ;
  informationsfloede_nn_1_1_N = mkN "informationsflöde" ;
  informationsfoerelaeggande_nn_1_1_N = mkN "informationsföreläggande" ;
  informationsmoete_nn_1_1_N = mkN "informationsmöte" ;
  informationssamhaelle_nn_1_1_N = mkN "informationssamhälle" ;
  informationsutbyte_nn_1_N = mkN "informationsutbyte" ;
  informerande_nn_1_N = mkN "informerande" ;
  infriande_nn_1_N = mkN "infriande" ;
  infaangande_nn_1_1_N = mkN "infångande" ;
  infoerande_nn_1_1_N = mkN "införande" ;
  infoerlivande_nn_1_1_N = mkN "införlivande" ;
  infoerskaffande_nn_1_1_N = mkN "införskaffande" ;
  ingifte_nn_1_N = mkN "ingifte" ;
  ingivande_nn_1_N = mkN "ingivande" ;
  ingjutande_nn_1_N = mkN "ingjutande" ;
  ingraverande_nn_1_N = mkN "ingraverande" ;
  ingripande_nn_1_N = mkN "ingripande" ;
  ingaaende_nn_1_1_N = mkN "ingående" ;
  ingoete_nn_1_1_N = mkN "ingöte" ;
  inhalerande_nn_1_N = mkN "inhalerande" ;
  inhandlande_nn_1_N = mkN "inhandlande" ;
  inhiberande_nn_1_N = mkN "inhiberande" ;
  inhibiterande_nn_1_N = mkN "inhibiterande" ;
  inhysande_nn_1_N = mkN "inhysande" ;
  inhaegnande_nn_1_1_N = mkN "inhägnande" ;
  inhaemtande_nn_1_1_N = mkN "inhämtande" ;
  inhoestande_nn_1_1_N = mkN "inhöstande" ;
  initierande_nn_1_N = mkN "initierande" ;
  injagande_nn_1_N = mkN "injagande" ;
  injekterande_nn_1_N = mkN "injekterande" ;
  injektionsstaelle_nn_1_1_N = mkN "injektionsställe" ;
  injicerande_nn_1_N = mkN "injicerande" ;
  inkallande_nn_1_N = mkN "inkallande" ;
  inkapslande_nn_1_N = mkN "inkapslande" ;
  inkarnerande_nn_1_N = mkN "inkarnerande" ;
  inkasserande_nn_1_N = mkN "inkasserande" ;
  inklarerande_nn_1_N = mkN "inklarerande" ;
  inkluderande_nn_1_N = mkN "inkluderande" ;
  inkokande_nn_1_N = mkN "inkokande" ;
  inkommande_nn_1_N = mkN "inkommande" ;
  inkomsttaxerande_nn_1_N = mkN "inkomsttaxerande" ;
  inkopplande_nn_1_N = mkN "inkopplande" ;
  inkorporerande_nn_1_N = mkN "inkorporerande" ;
  inkraektande_nn_1_1_N = mkN "inkräktande" ;
  inkraevande_nn_1_1_N = mkN "inkrävande" ;
  inkvarterande_nn_1_N = mkN "inkvarterande" ;
  inkoepande_nn_1_1_N = mkN "inköpande" ;
  inlasande_nn_1_N = mkN "inlasande" ;
  inledande_nn_1_N = mkN "inledande" ;
  inledningsskede_nn_1_N = mkN "inledningsskede" ;
  inlemmande_nn_1_N = mkN "inlemmande" ;
  inlindande_nn_1_N = mkN "inlindande" ;
  inlaeggande_nn_1_1_N = mkN "inläggande" ;
  inlaemnande_nn_1_1_N = mkN "inlämnande" ;
  inlaerande_nn_1_1_N = mkN "inlärande" ;
  inlaanande_nn_1_1_N = mkN "inlånande" ;
  inloepande_nn_1_1_N = mkN "inlöpande" ;
  inloesande_nn_1_1_N = mkN "inlösande" ;
  inmatande_nn_1_N = mkN "inmatande" ;
  inmundigande_nn_1_N = mkN "inmundigande" ;
  inmutande_nn_1_N = mkN "inmutande" ;
  inmaengande_nn_1_1_N = mkN "inmängande" ;
  inmoenstrande_nn_1_1_N = mkN "inmönstrande" ;
  innandoeme_nn_1_1_N = mkN "innandöme" ;
  innanmaete_nn_1_1_N = mkN "innanmäte" ;
  innebaerande_nn_1_1_N = mkN "innebärande" ;
  innefattande_nn_1_N = mkN "innefattande" ;
  innehavande_nn_1_N = mkN "innehavande" ;
  innehaallande_nn_1_1_N = mkN "innehållande" ;
  innerverande_nn_1_N = mkN "innerverande" ;
  inneslutande_nn_1_N = mkN "inneslutande" ;
  innestaengande_nn_1_1_N = mkN "innestängande" ;
  inokulerande_nn_1_N = mkN "inokulerande" ;
  inoljande_nn_1_N = mkN "inoljande" ;
  inordnande_nn_1_N = mkN "inordnande" ;
  inpassande_nn_1_N = mkN "inpassande" ;
  inplantande_nn_1_N = mkN "inplantande" ;
  inplanterande_nn_1_N = mkN "inplanterande" ;
  inpressande_nn_1_N = mkN "inpressande" ;
  inprickande_nn_1_N = mkN "inprickande" ;
  inpraeglande_nn_1_1_N = mkN "inpräglande" ;
  inpraentande_nn_1_1_N = mkN "inpräntande" ;
  inramande_nn_1_N = mkN "inramande" ;
  inrangerande_nn_1_N = mkN "inrangerande" ;
  inrapporterande_nn_1_N = mkN "inrapporterande" ;
  inredande_nn_1_N = mkN "inredande" ;
  inregistrerande_nn_1_N = mkN "inregistrerande" ;
  inriktande_nn_1_N = mkN "inriktande" ;
  inringande_nn_1_N = mkN "inringande" ;
  inristande_nn_1_N = mkN "inristande" ;
  inropande_nn_1_N = mkN "inropande" ;
  inrymmande_nn_1_N = mkN "inrymmande" ;
  inraeknande_nn_1_1_N = mkN "inräknande" ;
  inraettande_nn_1_1_N = mkN "inrättande" ;
  insamlande_nn_1_N = mkN "insamlande" ;
  inscenerande_nn_1_N = mkN "inscenerande" ;
  inseglande_nn_1_N = mkN "inseglande" ;
  inseminerande_nn_1_N = mkN "inseminerande" ;
  insinuerande_nn_1_N = mkN "insinuerande" ;
  insisterande_nn_1_N = mkN "insisterande" ;
  insjuknande_nn_1_N = mkN "insjuknande" ;
  inskeppande_nn_1_N = mkN "inskeppande" ;
  inskjutande_nn_1_N = mkN "inskjutande" ;
  inskolande_nn_1_N = mkN "inskolande" ;
  inskridande_nn_1_N = mkN "inskridande" ;
  inskrivande_nn_1_N = mkN "inskrivande" ;
  inskraenkande_nn_1_1_N = mkN "inskränkande" ;
  inskaerpande_nn_1_1_N = mkN "inskärpande" ;
  insmygande_nn_1_N = mkN "insmygande" ;
  insmaeltande_nn_1_1_N = mkN "insmältande" ;
  insomnande_nn_1_N = mkN "insomnande" ;
  inspekterande_nn_1_N = mkN "inspekterande" ;
  inspelande_nn_1_N = mkN "inspelande" ;
  inspirerande_nn_1_N = mkN "inspirerande" ;
  insprutningsmunstycke_nn_1_N = mkN "insprutningsmunstycke" ;
  inspaerrande_nn_1_1_N = mkN "inspärrande" ;
  installerande_nn_1_N = mkN "installerande" ;
  instiftande_nn_1_N = mkN "instiftande" ;
  institutionaliserande_nn_1_N = mkN "institutionaliserande" ;
  instruerande_nn_1_N = mkN "instruerande" ;
  instrumentbraede_nn_1_1_N = mkN "instrumentbräde" ;
  instrumenterande_nn_1_N = mkN "instrumenterande" ;
  instraalande_nn_1_1_N = mkN "instrålande" ;
  instuderande_nn_1_N = mkN "instuderande" ;
  instundande_nn_1_N = mkN "instundande" ;
  instaellande_nn_1_1_N = mkN "inställande" ;
  instaemmande_nn_1_1_N = mkN "instämmande" ;
  instaengande_nn_1_1_N = mkN "instängande" ;
  insugande_nn_1_N = mkN "insugande" ;
  insupande_nn_1_N = mkN "insupande" ;
  insvepande_nn_1_N = mkN "insvepande" ;
  insaendande_nn_1_1_N = mkN "insändande" ;
  insaettande_nn_1_1_N = mkN "insättande" ;
  insoendrande_nn_1_1_N = mkN "insöndrande" ;
  intagande_nn_1_N = mkN "intagande" ;
  intalande_nn_1_N = mkN "intalande" ;
  intecknande_nn_1_N = mkN "intecknande" ;
  integrerande_nn_1_N = mkN "integrerande" ;
  intellektualiserande_nn_1_N = mkN "intellektualiserande" ;
  intensifierande_nn_1_N = mkN "intensifierande" ;
  intensiverande_nn_1_N = mkN "intensiverande" ;
  interagerande_nn_1_N = mkN "interagerande" ;
  interfererande_nn_1_N = mkN "interfererande" ;
  interfolierande_nn_1_N = mkN "interfolierande" ;
  internaliserande_nn_1_N = mkN "internaliserande" ;
  internationaliserande_nn_1_N = mkN "internationaliserande" ;
  internerande_nn_1_N = mkN "internerande" ;
  interpellerande_nn_1_N = mkN "interpellerande" ;
  interpolerande_nn_1_N = mkN "interpolerande" ;
  interpreterande_nn_1_N = mkN "interpreterande" ;
  interpunkterande_nn_1_N = mkN "interpunkterande" ;
  intervenerande_nn_1_N = mkN "intervenerande" ;
  intervjuande_nn_1_N = mkN "intervjuande" ;
  intolkande_nn_1_N = mkN "intolkande" ;
  intonerande_nn_1_N = mkN "intonerande" ;
  intresse_nn_1_N = mkN "intresse" ;
  intresseomraade_nn_1_1_N = mkN "intresseområde" ;
  intresserande_nn_1_N = mkN "intresserande" ;
  intrigerande_nn_1_N = mkN "intrigerande" ;
  introducerande_nn_1_N = mkN "introducerande" ;
  introduktionserbjudande_nn_1_N = mkN "introduktionserbjudande" ;
  intrumfande_nn_1_N = mkN "intrumfande" ;
  intraedande_nn_1_1_N = mkN "inträdande" ;
  intraede_nn_1_1_N = mkN "inträde" ;
  intraeffande_nn_1_1_N = mkN "inträffande" ;
  intraengande_nn_1_1_N = mkN "inträngande" ;
  intygande_nn_1_N = mkN "intygande" ;
  intaagande_nn_1_1_N = mkN "intågande" ;
  invaderande_nn_1_N = mkN "invaderande" ;
  invaggande_nn_1_N = mkN "invaggande" ;
  invalidiserande_nn_1_N = mkN "invalidiserande" ;
  invandrande_nn_1_N = mkN "invandrande" ;
  invecklande_nn_1_N = mkN "invecklande" ;
  inventerande_nn_1_N = mkN "inventerande" ;
  inverkande_nn_1_N = mkN "inverkande" ;
  inverterande_nn_1_N = mkN "inverterande" ;
  investerande_nn_1_N = mkN "investerande" ;
  invigande_nn_1_N = mkN "invigande" ;
  invintrande_nn_1_N = mkN "invintrande" ;
  inviterande_nn_1_N = mkN "inviterande" ;
  involverande_nn_1_N = mkN "involverande" ;
  invaeljande_nn_1_1_N = mkN "inväljande" ;
  invaendande_nn_1_1_N = mkN "invändande" ;
  invaentande_nn_1_1_N = mkN "inväntande" ;
  invaevande_nn_1_1_N = mkN "invävande" ;
  inympande_nn_1_N = mkN "inympande" ;
  inoevande_nn_1_1_N = mkN "inövande" ;
  iordningstaellande_nn_1_1_N = mkN "iordningställande" ;
  iriserande_nn_1_N = mkN "iriserande" ;
  ironiserande_nn_1_N = mkN "ironiserande" ;
  irrande_nn_1_N = mkN "irrande" ;
  irriterande_nn_1_N = mkN "irriterande" ;
  isande_nn_1_N = mkN "isande" ;
  isbaelte_nn_1_1_N = mkN "isbälte" ;
  iscensaettande_nn_1_1_N = mkN "iscensättande" ;
  isfoerhaallande_nn_1_1_N = mkN "isförhållande" ;
  islamiserande_nn_1_N = mkN "islamiserande" ;
  isolerande_nn_1_N = mkN "isolerande" ;
  istaecke_nn_1_1_N = mkN "istäcke" ;
  istaandsaettande_nn_1_1_N = mkN "iståndsättande" ;
  itererande_nn_1_N = mkN "itererande" ;
  itutande_nn_1_N = mkN "itutande" ;
  ivrande_nn_1_N = mkN "ivrande" ;
  ivaegskickande_nn_1_1_N = mkN "ivägskickande" ;
  jabbande_nn_1_N = mkN "jabbande" ;
  jagande_nn_1_N = mkN "jagande" ;
  jakande_nn_1_N = mkN "jakande" ;
  jaktbyte_nn_1_N = mkN "jaktbyte" ;
  jakttillfaelle_nn_1_1_N = mkN "jakttillfälle" ;
  jamande_nn_1_N = mkN "jamande" ;
  jammande_nn_1_N = mkN "jammande" ;
  jamsande_nn_1_N = mkN "jamsande" ;
  janusanlete_nn_1_N = mkN "janusanlete" ;
  janusansikte_nn_1_N = mkN "janusansikte" ;
  jassande_nn_1_N = mkN "jassande" ;
  jazzande_nn_1_N = mkN "jazzande" ;
  jazzifierande_nn_1_N = mkN "jazzifierande" ;
  jobbande_nn_1_N = mkN "jobbande" ;
  joddlande_nn_1_N = mkN "joddlande" ;
  joderande_nn_1_N = mkN "joderande" ;
  joggande_nn_1_N = mkN "joggande" ;
  jojkande_nn_1_N = mkN "jojkande" ;
  jollrande_nn_1_N = mkN "jollrande" ;
  joltande_nn_1_N = mkN "joltande" ;
  jonglerande_nn_1_N = mkN "jonglerande" ;
  joniserande_nn_1_N = mkN "joniserande" ;
  jordande_nn_2_N = mkN "jordande" ;
  jordbrukarsamhaelle_nn_1_1_N = mkN "jordbrukarsamhälle" ;
  jordfaergaemne_nn_1_1_N = mkN "jordfärgämne" ;
  jordfaestande_nn_1_1_N = mkN "jordfästande" ;
  jordomraade_nn_1_1_N = mkN "jordområde" ;
  jordslaaende_nn_1_1_N = mkN "jordslående" ;
  jordvaerde_nn_1_1_N = mkN "jordvärde" ;
  joxande_nn_1_N = mkN "joxande" ;
  jubilerande_nn_1_N = mkN "jubilerande" ;
  jublande_nn_1_N = mkN "jublande" ;
  juckande_nn_1_N = mkN "juckande" ;
  julande_nn_1_N = mkN "julande" ;
  jumpande_nn_1_N = mkN "jumpande" ;
  justerande_nn_1_N = mkN "justerande" ;
  jympande_nn_1_N = mkN "jympande" ;
  jaektande_nn_1_1_N = mkN "jäktande" ;
  jaemfoerande_nn_1_1_N = mkN "jämförande" ;
  jaemkande_nn_1_1_N = mkN "jämkande" ;
  jaemnande_nn_1_1_N = mkN "jämnande" ;
  jaemnviktslaege_nn_1_1_N = mkN "jämnviktsläge" ;
  jaemstaellande_nn_1_1_N = mkN "jämställande" ;
  jaemviktslaege_nn_1_1_N = mkN "jämviktsläge" ;
  jaernraecke_nn_1_1_N = mkN "järnräcke" ;
  jaernskoende_nn_1_1_N = mkN "järnskoende" ;
  jaernstycke_nn_1_1_N = mkN "järnstycke" ;
  jaernvaegsbygge_nn_1_1_N = mkN "järnvägsbygge" ;
  jaesande_nn_1_1_N = mkN "jäsande" ;
  jaevande_nn_1_1_N = mkN "jävande" ;
  joensande_nn_1_1_N = mkN "jönsande" ;
  k_maerkande_nn_1_1_N = mkN "k-märkande" ;
  kabelfaeste_nn_1_1_N = mkN "kabelfäste" ;
  kabelhoelje_nn_1_1_N = mkN "kabelhölje" ;
  kablande_nn_1_N = mkN "kablande" ;
  kackande_nn_1_N = mkN "kackande" ;
  kacklande_nn_1_N = mkN "kacklande" ;
  kaffe_nn_1_N = mkN "kaffe" ;
  kaffedrickande_nn_1_N = mkN "kaffedrickande" ;
  kafferastaemne_nn_1_1_N = mkN "kafferastämne" ;
  kajkande_nn_1_N = mkN "kajkande" ;
  kakdoppande_nn_1_N = mkN "kakdoppande" ;
  kaklande_nn_1_N = mkN "kaklande" ;
  kalandrerande_nn_1_N = mkN "kalandrerande" ;
  kalasande_nn_1_N = mkN "kalasande" ;
  kalavverkande_nn_1_N = mkN "kalavverkande" ;
  kalcinerande_nn_1_N = mkN "kalcinerande" ;
  kalfatrande_nn_1_N = mkN "kalfatrande" ;
  kalhuggande_nn_1_N = mkN "kalhuggande" ;
  kalhygge_nn_1_N = mkN "kalhygge" ;
  kalibrerande_nn_1_N = mkN "kalibrerande" ;
  kalkande_nn_1_N = mkN "kalkande" ;
  kalkerande_nn_1_N = mkN "kalkerande" ;
  kalkslaaende_nn_1_1_N = mkN "kalkslående" ;
  kalkylerande_nn_1_N = mkN "kalkylerande" ;
  kallande_nn_1_N = mkN "kallande" ;
  kallarbetande_nn_1_N = mkN "kallarbetande" ;
  kallbearbetande_nn_1_N = mkN "kallbearbetande" ;
  kallbockande_nn_1_N = mkN "kallbockande" ;
  kalldragande_nn_1_N = mkN "kalldragande" ;
  kallgrinande_nn_1_N = mkN "kallgrinande" ;
  kallhamrande_nn_1_N = mkN "kallhamrande" ;
  kallmanglande_nn_1_N = mkN "kallmanglande" ;
  kallnande_nn_1_N = mkN "kallnande" ;
  kallpratande_nn_1_N = mkN "kallpratande" ;
  kallpressande_nn_1_N = mkN "kallpressande" ;
  kallroekande_nn_1_1_N = mkN "kallrökande" ;
  kallroerande_nn_1_1_N = mkN "kallrörande" ;
  kallsinne_nn_1_N = mkN "kallsinne" ;
  kallsmidande_nn_1_N = mkN "kallsmidande" ;
  kalluftslaege_nn_1_1_N = mkN "kalluftsläge" ;
  kallvalsande_nn_1_N = mkN "kallvalsande" ;
  kalmerande_nn_1_N = mkN "kalmerande" ;
  kalnande_nn_1_N = mkN "kalnande" ;
  kalorivaerde_nn_1_1_N = mkN "kalorivärde" ;
  kalvande_nn_1_N = mkN "kalvande" ;
  kalaetande_nn_1_1_N = mkN "kalätande" ;
  kammande_nn_1_N = mkN "kammande" ;
  kamouflerande_nn_1_N = mkN "kamouflerande" ;
  kampande_nn_1_N = mkN "kampande" ;
  kamperande_nn_1_N = mkN "kamperande" ;
  kanalbygge_nn_1_N = mkN "kanalbygge" ;
  kanaliserande_nn_1_N = mkN "kanaliserande" ;
  kanande_nn_1_N = mkN "kanande" ;
  kanderande_nn_1_N = mkN "kanderande" ;
  kandiderande_nn_1_N = mkN "kandiderande" ;
  kannelerande_nn_1_N = mkN "kannelerande" ;
  kanonerbjudande_nn_1_N = mkN "kanonerbjudande" ;
  kanoniserande_nn_1_N = mkN "kanoniserande" ;
  kanotande_nn_1_N = mkN "kanotande" ;
  kantande_nn_1_N = mkN "kantande" ;
  kanthuggande_nn_1_N = mkN "kanthuggande" ;
  kantklippande_nn_1_N = mkN "kantklippande" ;
  kantrande_nn_1_N = mkN "kantrande" ;
  kapacitetsutnyttjande_nn_1_N = mkN "kapacitetsutnyttjande" ;
  kapande_nn_1_N = mkN "kapande" ;
  kapitaliserande_nn_1_N = mkN "kapitaliserande" ;
  kapitalvaerde_nn_1_1_N = mkN "kapitalvärde" ;
  kapitulerande_nn_1_N = mkN "kapitulerande" ;
  kapprustande_nn_1_N = mkN "kapprustande" ;
  kappseglande_nn_1_N = mkN "kappseglande" ;
  kapsejsande_nn_1_N = mkN "kapsejsande" ;
  kapslande_nn_1_N = mkN "kapslande" ;
  karakteriserande_nn_1_N = mkN "karakteriserande" ;
  karaktaeriserande_nn_1_1_N = mkN "karaktäriserande" ;
  karaktaersvittne_nn_1_1_N = mkN "karaktärsvittne" ;
  karambolerande_nn_1_N = mkN "karambolerande" ;
  karande_nn_1_N = mkN "karande" ;
  karboniserande_nn_1_N = mkN "karboniserande" ;
  kardande_nn_1_N = mkN "kardande" ;
  kardborrfaeste_nn_1_1_N = mkN "kardborrfäste" ;
  karikerande_nn_1_N = mkN "karikerande" ;
  karlansikte_nn_1_N = mkN "karlansikte" ;
  karldagsverke_nn_1_N = mkN "karldagsverke" ;
  karterande_nn_1_N = mkN "karterande" ;
  kartlaeggande_nn_1_1_N = mkN "kartläggande" ;
  kartonnerande_nn_1_N = mkN "kartonnerande" ;
  karvande_nn_1_N = mkN "karvande" ;
  kasande_nn_1_N = mkN "kasande" ;
  kaskadkopplande_nn_1_N = mkN "kaskadkopplande" ;
  kasserande_nn_1_N = mkN "kasserande" ;
  kastande_nn_1_N = mkN "kastande" ;
  kastmaerke_nn_1_1_N = mkN "kastmärke" ;
  kastrerande_nn_1_N = mkN "kastrerande" ;
  katalogiserande_nn_1_N = mkN "katalogiserande" ;
  katalyserande_nn_1_N = mkN "katalyserande" ;
  katastroflaege_nn_1_1_N = mkN "katastrofläge" ;
  katedralbygge_nn_1_N = mkN "katedralbygge" ;
  kategoriserande_nn_1_N = mkN "kategoriserande" ;
  kategoriseringsarbete_nn_1_N = mkN "kategoriseringsarbete" ;
  katekesstycke_nn_1_N = mkN "katekesstycke" ;
  kateteriserande_nn_1_N = mkN "kateteriserande" ;
  katetriserande_nn_1_N = mkN "katetriserande" ;
  kattande_nn_1_N = mkN "kattande" ;
  kausalfoerhaallande_nn_1_1_N = mkN "kausalförhållande" ;
  kauteriserande_nn_1_N = mkN "kauteriserande" ;
  kavande_nn_1_N = mkN "kavande" ;
  kavlande_nn_1_N = mkN "kavlande" ;
  kedjande_nn_1_N = mkN "kedjande" ;
  kedjeroekande_nn_1_1_N = mkN "kedjerökande" ;
  kejsardoeme_nn_1_1_N = mkN "kejsardöme" ;
  kelande_nn_1_N = mkN "kelande" ;
  kemisamhaelle_nn_1_1_N = mkN "kemisamhälle" ;
  kesande_nn_1_N = mkN "kesande" ;
  kickande_nn_1_N = mkN "kickande" ;
  kidnappande_nn_1_N = mkN "kidnappande" ;
  kikande_nn_1_N = mkN "kikande" ;
  kikarsikte_nn_1_N = mkN "kikarsikte" ;
  kiknande_nn_1_N = mkN "kiknande" ;
  kilande_nn_1_N = mkN "kilande" ;
  killande_nn_1_N = mkN "killande" ;
  kimmande_nn_1_N = mkN "kimmande" ;
  kinesande_nn_1_N = mkN "kinesande" ;
  kinkande_nn_1_N = mkN "kinkande" ;
  kippande_nn_1_N = mkN "kippande" ;
  kirrande_nn_1_N = mkN "kirrande" ;
  kisande_nn_1_N = mkN "kisande" ;
  kissande_nn_1_N = mkN "kissande" ;
  kittande_nn_1_N = mkN "kittande" ;
  kittlande_nn_1_N = mkN "kittlande" ;
  klabbande_nn_1_N = mkN "klabbande" ;
  klackande_nn_1_N = mkN "klackande" ;
  kladdande_nn_1_N = mkN "kladdande" ;
  klaffande_nn_1_N = mkN "klaffande" ;
  klafsande_nn_1_N = mkN "klafsande" ;
  klampande_nn_1_N = mkN "klampande" ;
  klamrande_nn_1_N = mkN "klamrande" ;
  klandrande_nn_1_N = mkN "klandrande" ;
  klankande_nn_1_N = mkN "klankande" ;
  klappande_nn_1_N = mkN "klappande" ;
  klappbraede_nn_1_1_N = mkN "klappbräde" ;
  klapprande_nn_1_N = mkN "klapprande" ;
  klarande_nn_1_N = mkN "klarande" ;
  klarerande_nn_1_N = mkN "klarerande" ;
  klargoerande_nn_1_1_N = mkN "klargörande" ;
  klarlaeggande_nn_1_1_N = mkN "klarläggande" ;
  klarnande_nn_1_N = mkN "klarnande" ;
  klassamhaelle_nn_1_1_N = mkN "klassamhälle" ;
  klassande_nn_1_N = mkN "klassande" ;
  klassificerande_nn_1_N = mkN "klassificerande" ;
  klassmaerke_nn_1_1_N = mkN "klassmärke" ;
  klatschande_nn_1_N = mkN "klatschande" ;
  klavbindande_nn_1_N = mkN "klavbindande" ;
  klemande_nn_1_N = mkN "klemande" ;
  klenande_nn_1_N = mkN "klenande" ;
  klensmide_nn_1_N = mkN "klensmide" ;
  kletande_nn_1_N = mkN "kletande" ;
  kliande_nn_1_N = mkN "kliande" ;
  klibbande_nn_1_N = mkN "klibbande" ;
  klickande_nn_1_N = mkN "klickande" ;
  klimatombyte_nn_1_N = mkN "klimatombyte" ;
  klimattoppmoete_nn_1_1_N = mkN "klimattoppmöte" ;
  klimpande_nn_1_N = mkN "klimpande" ;
  klingande_nn_1_N = mkN "klingande" ;
  klinkande_nn_1_N = mkN "klinkande" ;
  klippande_nn_1_N = mkN "klippande" ;
  klippstycke_nn_1_N = mkN "klippstycke" ;
  klirande_nn_1_N = mkN "klirande" ;
  klirrande_nn_1_N = mkN "klirrande" ;
  klistermaerke_nn_1_1_N = mkN "klistermärke" ;
  klistrande_nn_1_N = mkN "klistrande" ;
  klivande_nn_1_N = mkN "klivande" ;
  klockande_nn_1_N = mkN "klockande" ;
  klonande_nn_1_N = mkN "klonande" ;
  klorerande_nn_1_N = mkN "klorerande" ;
  klorkolvaete_nn_1_1_N = mkN "klorkolväte" ;
  klosterloefte_nn_1_1_N = mkN "klosterlöfte" ;
  klottrande_nn_1_N = mkN "klottrande" ;
  klubbande_nn_1_N = mkN "klubbande" ;
  klubbmaerke_nn_1_1_N = mkN "klubbmärke" ;
  kluckande_nn_1_N = mkN "kluckande" ;
  kluddande_nn_1_N = mkN "kluddande" ;
  klunkande_nn_1_N = mkN "klunkande" ;
  klyftande_nn_1_N = mkN "klyftande" ;
  klyvande_nn_1_N = mkN "klyvande" ;
  klaeckande_nn_1_1_N = mkN "kläckande" ;
  klaedande_nn_1_1_N = mkN "klädande" ;
  klaedbyte_nn_1_1_N = mkN "klädbyte" ;
  klaede_nn_1_1_N = mkN "kläde" ;
  klaedspaenne_nn_1_1_N = mkN "klädspänne" ;
  klaeende_nn_1_1_N = mkN "kläende" ;
  klaemmande_nn_1_1_N = mkN "klämmande" ;
  klaemtande_nn_1_1_N = mkN "klämtande" ;
  klaengande_nn_1_1_N = mkN "klängande" ;
  klaenge_nn_1_1_N = mkN "klänge" ;
  klaettrande_nn_1_1_N = mkN "klättrande" ;
  klaaende_nn_1_1_N = mkN "klående" ;
  klaapande_nn_1_1_N = mkN "klåpande" ;
  kloesande_nn_1_1_N = mkN "klösande" ;
  kloevjande_nn_1_1_N = mkN "klövjande" ;
  knackande_nn_1_N = mkN "knackande" ;
  knagglande_nn_1_N = mkN "knagglande" ;
  knallande_nn_1_N = mkN "knallande" ;
  knapptryckande_nn_1_N = mkN "knapptryckande" ;
  knaprande_nn_1_N = mkN "knaprande" ;
  knarkande_nn_1_N = mkN "knarkande" ;
  knarrande_nn_1_N = mkN "knarrande" ;
  knastrande_nn_1_N = mkN "knastrande" ;
  knatande_nn_1_N = mkN "knatande" ;
  knattrande_nn_1_N = mkN "knattrande" ;
  knegande_nn_1_N = mkN "knegande" ;
  knipande_nn_1_N = mkN "knipande" ;
  knippe_nn_1_N = mkN "knippe" ;
  knipsande_nn_1_N = mkN "knipsande" ;
  knirkande_nn_1_N = mkN "knirkande" ;
  knirrande_nn_1_N = mkN "knirrande" ;
  knistrande_nn_1_N = mkN "knistrande" ;
  knittrande_nn_1_N = mkN "knittrande" ;
  knivande_nn_1_N = mkN "knivande" ;
  knivmoerdande_nn_1_1_N = mkN "knivmördande" ;
  knixande_nn_1_N = mkN "knixande" ;
  knockande_nn_1_N = mkN "knockande" ;
  knogande_nn_1_N = mkN "knogande" ;
  knollrande_nn_1_N = mkN "knollrande" ;
  knopande_nn_1_N = mkN "knopande" ;
  knorrande_nn_1_N = mkN "knorrande" ;
  knorvande_nn_1_N = mkN "knorvande" ;
  knotande_nn_1_N = mkN "knotande" ;
  knottrande_nn_1_N = mkN "knottrande" ;
  knuffande_nn_1_N = mkN "knuffande" ;
  knullande_nn_1_N = mkN "knullande" ;
  knusslande_nn_1_N = mkN "knusslande" ;
  knuttimrande_nn_1_N = mkN "knuttimrande" ;
  knyckande_nn_1_N = mkN "knyckande" ;
  knycklande_nn_1_N = mkN "knycklande" ;
  knypplande_nn_1_N = mkN "knypplande" ;
  knystande_nn_1_N = mkN "knystande" ;
  knytande_nn_1_N = mkN "knytande" ;
  knyte_nn_1_N = mkN "knyte" ;
  knaeande_nn_1_1_N = mkN "knäande" ;
  knaeboejande_nn_1_1_N = mkN "knäböjande" ;
  knaeckande_nn_1_1_N = mkN "knäckande" ;
  knaefallande_nn_1_1_N = mkN "knäfallande" ;
  knaeppande_nn_1_1_N = mkN "knäppande" ;
  knaeppe_nn_1_1_N = mkN "knäppe" ;
  knaesaettande_nn_1_1_N = mkN "knäsättande" ;
  knaadande_nn_1_1_N = mkN "knådande" ;
  knaapande_nn_1_1_N = mkN "knåpande" ;
  knoekande_nn_1_1_N = mkN "knökande" ;
  knoelande_nn_1_1_N = mkN "knölande" ;
  koafferande_nn_1_N = mkN "koafferande" ;
  koagulerande_nn_1_N = mkN "koagulerande" ;
  kodande_nn_1_N = mkN "kodande" ;
  kodifierande_nn_1_N = mkN "kodifierande" ;
  kohandlande_nn_1_N = mkN "kohandlande" ;
  kojande_nn_1_N = mkN "kojande" ;
  kojsande_nn_1_N = mkN "kojsande" ;
  kokande_nn_1_N = mkN "kokande" ;
  koketterande_nn_1_N = mkN "koketterande" ;
  kokkaffe_nn_1_N = mkN "kokkaffe" ;
  koksande_nn_1_N = mkN "koksande" ;
  kolande_nn_1_N = mkN "kolande" ;
  kolkande_nn_1_N = mkN "kolkande" ;
  kollaberande_nn_1_N = mkN "kollaberande" ;
  kollaborerande_nn_1_N = mkN "kollaborerande" ;
  kollande_nn_1_N = mkN "kollande" ;
  kollapsande_nn_1_N = mkN "kollapsande" ;
  kollationerande_nn_1_N = mkN "kollationerande" ;
  kollektiviserande_nn_1_N = mkN "kollektiviserande" ;
  kolliderande_nn_1_N = mkN "kolliderande" ;
  kolonialvaelde_nn_1_1_N = mkN "kolonialvälde" ;
  koloniserande_nn_1_N = mkN "koloniserande" ;
  kolorerande_nn_1_N = mkN "kolorerande" ;
  kolportagehaefte_nn_1_1_N = mkN "kolportagehäfte" ;
  kolporterande_nn_1_N = mkN "kolporterande" ;
  kolumnutrymme_nn_1_N = mkN "kolumnutrymme" ;
  kolvaete_nn_1_1_N = mkN "kolväte" ;
  kombinerande_nn_1_N = mkN "kombinerande" ;
  kommande_nn_1_N = mkN "kommande" ;
  kommaterande_nn_1_N = mkN "kommaterande" ;
  kommenderande_nn_1_N = mkN "kommenderande" ;
  kommenterande_nn_1_N = mkN "kommenterande" ;
  kommersande_nn_1_N = mkN "kommersande" ;
  kommersialiserande_nn_1_N = mkN "kommersialiserande" ;
  kommunaliserande_nn_1_N = mkN "kommunaliserande" ;
  kommunfullmaektige_nn_1_1_N = mkN "kommunfullmäktige" ;
  kommunicerande_nn_1_N = mkN "kommunicerande" ;
  kommuterande_nn_1_N = mkN "kommuterande" ;
  kompande_nn_1_N = mkN "kompande" ;
  komparerande_nn_1_N = mkN "komparerande" ;
  kompenserande_nn_1_N = mkN "kompenserande" ;
  kompetensfoerklarande_nn_1_1_N = mkN "kompetensförklarande" ;
  kompetensomraade_nn_1_1_N = mkN "kompetensområde" ;
  kompilerande_nn_1_N = mkN "kompilerande" ;
  kompletterande_nn_1_N = mkN "kompletterande" ;
  komplicerande_nn_1_N = mkN "komplicerande" ;
  komplimenterande_nn_1_N = mkN "komplimenterande" ;
  komponerande_nn_1_N = mkN "komponerande" ;
  komposterande_nn_1_N = mkN "komposterande" ;
  komprimerande_nn_1_N = mkN "komprimerande" ;
  komprometterande_nn_1_N = mkN "komprometterande" ;
  kompromissande_nn_1_N = mkN "kompromissande" ;
  koncentrerande_nn_1_N = mkN "koncentrerande" ;
  koncessionerande_nn_1_N = mkN "koncessionerande" ;
  koncipierande_nn_1_N = mkN "koncipierande" ;
  kondemnerande_nn_1_N = mkN "kondemnerande" ;
  kondenserande_nn_1_N = mkN "kondenserande" ;
  konditionerande_nn_1_N = mkN "konditionerande" ;
  kondolerande_nn_1_N = mkN "kondolerande" ;
  konfererande_nn_1_N = mkN "konfererande" ;
  konfirmerande_nn_1_N = mkN "konfirmerande" ;
  konfiskerande_nn_1_N = mkN "konfiskerande" ;
  konfronterande_nn_1_N = mkN "konfronterande" ;
  konfunderande_nn_1_N = mkN "konfunderande" ;
  kongressande_nn_1_N = mkN "kongressande" ;
  kongruerande_nn_1_N = mkN "kongruerande" ;
  konjugerande_nn_1_N = mkN "konjugerande" ;
  konkande_nn_1_N = mkN "konkande" ;
  konkluderande_nn_1_N = mkN "konkluderande" ;
  konkretiserande_nn_1_N = mkN "konkretiserande" ;
  konkurrenssamhaelle_nn_1_1_N = mkN "konkurrenssamhälle" ;
  konkurrerande_nn_1_N = mkN "konkurrerande" ;
  konserterande_nn_1_N = mkN "konserterande" ;
  konsertstycke_nn_1_N = mkN "konsertstycke" ;
  konserverande_nn_1_N = mkN "konserverande" ;
  konsignerande_nn_1_N = mkN "konsignerande" ;
  konsoliderande_nn_1_N = mkN "konsoliderande" ;
  konspirerande_nn_1_N = mkN "konspirerande" ;
  konstaterande_nn_1_N = mkN "konstaterande" ;
  konstbefruktande_nn_1_N = mkN "konstbefruktande" ;
  konstbevattnande_nn_1_N = mkN "konstbevattnande" ;
  konsternerande_nn_1_N = mkN "konsternerande" ;
  konstituerande_nn_1_N = mkN "konstituerande" ;
  konstrande_nn_1_N = mkN "konstrande" ;
  konstruerande_nn_1_N = mkN "konstruerande" ;
  konststoppande_nn_1_N = mkN "konststoppande" ;
  konststycke_nn_1_N = mkN "konststycke" ;
  konsulterande_nn_1_N = mkN "konsulterande" ;
  konsumerande_nn_1_N = mkN "konsumerande" ;
  konsumtionssamhaelle_nn_1_1_N = mkN "konsumtionssamhälle" ;
  kontaktande_nn_1_N = mkN "kontaktande" ;
  kontaminerande_nn_1_N = mkN "kontaminerande" ;
  konterande_nn_1_N = mkN "konterande" ;
  kontingenterande_nn_1_N = mkN "kontingenterande" ;
  kontoriserande_nn_1_N = mkN "kontoriserande" ;
  kontorsarbete_nn_1_N = mkN "kontorsarbete" ;
  kontorsbitraede_nn_1_1_N = mkN "kontorsbiträde" ;
  kontorsutrymme_nn_1_N = mkN "kontorsutrymme" ;
  kontraherande_nn_1_N = mkN "kontraherande" ;
  kontrakterande_nn_1_N = mkN "kontrakterande" ;
  kontramanderande_nn_1_N = mkN "kontramanderande" ;
  kontramaerke_nn_1_1_N = mkN "kontramärke" ;
  kontrande_nn_1_N = mkN "kontrande" ;
  kontrasignerande_nn_1_N = mkN "kontrasignerande" ;
  kontrasterande_nn_1_N = mkN "kontrasterande" ;
  kontribuerande_nn_1_N = mkN "kontribuerande" ;
  kontrollerande_nn_1_N = mkN "kontrollerande" ;
  kontrollmaerke_nn_1_1_N = mkN "kontrollmärke" ;
  kontrollsamhaelle_nn_1_1_N = mkN "kontrollsamhälle" ;
  kontrollstaemplande_nn_1_1_N = mkN "kontrollstämplande" ;
  kontrollvaegande_nn_1_1_N = mkN "kontrollvägande" ;
  konturerande_nn_1_N = mkN "konturerande" ;
  konungadoeme_nn_1_1_N = mkN "konungadöme" ;
  konungarike_nn_1_N = mkN "konungarike" ;
  konungasaete_nn_1_1_N = mkN "konungasäte" ;
  konvergerande_nn_1_N = mkN "konvergerande" ;
  konversationsstycke_nn_1_N = mkN "konversationsstycke" ;
  konverserande_nn_1_N = mkN "konverserande" ;
  konverterande_nn_1_N = mkN "konverterande" ;
  konvojerande_nn_1_N = mkN "konvojerande" ;
  koopererande_nn_1_N = mkN "koopererande" ;
  koordinerande_nn_1_N = mkN "koordinerande" ;
  kopierande_nn_1_N = mkN "kopierande" ;
  koppande_nn_1_N = mkN "koppande" ;
  kopplande_nn_1_N = mkN "kopplande" ;
  kopplingsstycke_nn_1_N = mkN "kopplingsstycke" ;
  kopulerande_nn_1_N = mkN "kopulerande" ;
  korande_nn_1_N = mkN "korande" ;
  korkande_nn_1_N = mkN "korkande" ;
  korpande_nn_2_N = mkN "korpande" ;
  korrekturlaesande_nn_1_1_N = mkN "korrekturläsande" ;
  korrelerande_nn_1_N = mkN "korrelerande" ;
  korresponderande_nn_1_N = mkN "korresponderande" ;
  korrigerande_nn_1_N = mkN "korrigerande" ;
  korroderande_nn_1_N = mkN "korroderande" ;
  korrugerande_nn_1_N = mkN "korrugerande" ;
  korrumperande_nn_1_N = mkN "korrumperande" ;
  korsande_nn_1_N = mkN "korsande" ;
  korsbefruktande_nn_1_N = mkN "korsbefruktande" ;
  korsetterande_nn_1_N = mkN "korsetterande" ;
  korsfaestande_nn_1_1_N = mkN "korsfästande" ;
  korsfoerhoerande_nn_1_1_N = mkN "korsförhörande" ;
  kortande_nn_1_N = mkN "kortande" ;
  kortpassande_nn_1_N = mkN "kortpassande" ;
  kortslutande_nn_1_N = mkN "kortslutande" ;
  kostande_nn_1_N = mkN "kostande" ;
  kostymerande_nn_1_N = mkN "kostymerande" ;
  kovaendande_nn_1_1_N = mkN "kovändande" ;
  koxande_nn_1_N = mkN "koxande" ;
  krackande_nn_1_N = mkN "krackande" ;
  krackelerande_nn_1_N = mkN "krackelerande" ;
  krafsande_nn_1_N = mkN "krafsande" ;
  kraftverksbygge_nn_1_N = mkN "kraftverksbygge" ;
  kramande_nn_1_N = mkN "kramande" ;
  kransande_nn_1_N = mkN "kransande" ;
  krasande_nn_1_N = mkN "krasande" ;
  kraschande_nn_1_N = mkN "kraschande" ;
  kraschlandande_nn_1_N = mkN "kraschlandande" ;
  kratsande_nn_1_N = mkN "kratsande" ;
  krattande_nn_1_N = mkN "krattande" ;
  kravlande_nn_1_N = mkN "kravlande" ;
  kraxande_nn_1_N = mkN "kraxande" ;
  kredensande_nn_1_N = mkN "kredensande" ;
  krediterande_nn_1_N = mkN "krediterande" ;
  kreerande_nn_1_N = mkN "kreerande" ;
  kremerande_nn_1_N = mkN "kremerande" ;
  kreperande_nn_1_N = mkN "kreperande" ;
  kretande_nn_1_N = mkN "kretande" ;
  kretsande_nn_1_N = mkN "kretsande" ;
  kretsloppssamhaelle_nn_1_1_N = mkN "kretsloppssamhälle" ;
  kreverande_nn_1_N = mkN "kreverande" ;
  krigande_nn_1_N = mkN "krigande" ;
  krigsbyte_nn_1_N = mkN "krigsbyte" ;
  krigsplacerande_nn_1_N = mkN "krigsplacerande" ;
  kriminaliserande_nn_1_N = mkN "kriminaliserande" ;
  kringgaerdande_nn_1_1_N = mkN "kringgärdande" ;
  kringgaaende_nn_1_1_N = mkN "kringgående" ;
  kringraennande_nn_1_1_N = mkN "kringrännande" ;
  kringskansande_nn_1_N = mkN "kringskansande" ;
  kringskaerande_nn_1_1_N = mkN "kringskärande" ;
  krisande_nn_1_N = mkN "krisande" ;
  krismoete_nn_1_1_N = mkN "krismöte" ;
  kristalliserande_nn_1_N = mkN "kristalliserande" ;
  kristnande_nn_1_N = mkN "kristnande" ;
  kritande_nn_1_N = mkN "kritande" ;
  kritiserande_nn_1_N = mkN "kritiserande" ;
  krockande_nn_1_N = mkN "krockande" ;
  krokande_nn_1_N = mkN "krokande" ;
  kromande_nn_1_N = mkN "kromande" ;
  kromgarvande_nn_1_N = mkN "kromgarvande" ;
  krondike_nn_1_N = mkN "krondike" ;
  kronvittne_nn_1_N = mkN "kronvittne" ;
  kroppsarbetande_nn_1_N = mkN "kroppsarbetande" ;
  kroppsarbete_nn_1_N = mkN "kroppsarbete" ;
  kroppsvisiterande_nn_1_N = mkN "kroppsvisiterande" ;
  krossande_nn_1_N = mkN "krossande" ;
  krubbande_nn_1_N = mkN "krubbande" ;
  krullande_nn_1_N = mkN "krullande" ;
  krumbuktande_nn_1_N = mkN "krumbuktande" ;
  krusande_nn_1_N = mkN "krusande" ;
  kryllande_nn_1_N = mkN "kryllande" ;
  krympande_nn_1_N = mkN "krympande" ;
  krypande_nn_1_N = mkN "krypande" ;
  krypkoerande_nn_1_1_N = mkN "krypkörande" ;
  krypterande_nn_1_N = mkN "krypterande" ;
  kryssande_nn_1_N = mkN "kryssande" ;
  krystande_nn_1_N = mkN "krystande" ;
  kraelande_nn_1_1_N = mkN "krälande" ;
  kraemtande_nn_1_1_N = mkN "krämtande" ;
  kraengande_nn_1_1_N = mkN "krängande" ;
  kraenkande_nn_1_1_N = mkN "kränkande" ;
  kraeppande_nn_1_1_N = mkN "kräppande" ;
  kraevande_nn_1_1_N = mkN "krävande" ;
  kraamande_nn_1_1_N = mkN "kråmande" ;
  kraanglande_nn_1_1_N = mkN "krånglande" ;
  kroekande_nn_1_1_N = mkN "krökande" ;
  kroenande_nn_1_1_N = mkN "krönande" ;
  kuberande_nn_1_N = mkN "kuberande" ;
  kuckilurande_nn_1_N = mkN "kuckilurande" ;
  kucklande_nn_1_N = mkN "kucklande" ;
  kuggande_nn_1_N = mkN "kuggande" ;
  kujonerande_nn_1_N = mkN "kujonerande" ;
  kullande_nn_1_N = mkN "kullande" ;
  kullbytterande_nn_1_N = mkN "kullbytterande" ;
  kullkastande_nn_1_N = mkN "kullkastande" ;
  kullpratande_nn_1_N = mkN "kullpratande" ;
  kullrande_nn_1_N = mkN "kullrande" ;
  kulminerande_nn_1_N = mkN "kulminerande" ;
  kulnande_nn_1_N = mkN "kulnande" ;
  kulsprutenaeste_nn_1_1_N = mkN "kulsprutenäste" ;
  kultiverande_nn_1_N = mkN "kultiverande" ;
  kulturminne_nn_1_N = mkN "kulturminne" ;
  kulturminnesmaerkande_nn_1_1_N = mkN "kulturminnesmärkande" ;
  kulturminnesmaerke_nn_1_1_N = mkN "kulturminnesmärke" ;
  kulturutbyte_nn_1_N = mkN "kulturutbyte" ;
  kumulerande_nn_1_N = mkN "kumulerande" ;
  kungadoeme_nn_1_1_N = mkN "kungadöme" ;
  kungafoerhaerligande_nn_1_1_N = mkN "kungaförhärligande" ;
  kungarike_nn_1_N = mkN "kungarike" ;
  kungasaete_nn_1_1_N = mkN "kungasäte" ;
  kungoerande_nn_1_1_N = mkN "kungörande" ;
  kunskapande_nn_1_N = mkN "kunskapande" ;
  kunskapslaege_nn_1_1_N = mkN "kunskapsläge" ;
  kunskapssoekande_nn_1_1_N = mkN "kunskapssökande" ;
  kupande_nn_1_N = mkN "kupande" ;
  kuperande_nn_1_N = mkN "kuperande" ;
  kuppande_nn_1_N = mkN "kuppande" ;
  kurande_nn_1_N = mkN "kurande" ;
  kuraterande_nn_1_N = mkN "kuraterande" ;
  kurerande_nn_1_N = mkN "kurerande" ;
  kurrande_nn_1_N = mkN "kurrande" ;
  kursande_nn_1_N = mkN "kursande" ;
  kurserande_nn_1_N = mkN "kurserande" ;
  kursiverande_nn_1_N = mkN "kursiverande" ;
  kurtiserande_nn_1_N = mkN "kurtiserande" ;
  kuschande_nn_1_N = mkN "kuschande" ;
  kusingifte_nn_1_N = mkN "kusingifte" ;
  kuskande_nn_1_N = mkN "kuskande" ;
  kustomraade_nn_1_1_N = mkN "kustområde" ;
  kutande_nn_1_N = mkN "kutande" ;
  kuttersmycke_nn_1_N = mkN "kuttersmycke" ;
  kuttrande_nn_1_N = mkN "kuttrande" ;
  kuvande_nn_1_N = mkN "kuvande" ;
  kuverterande_nn_1_N = mkN "kuverterande" ;
  kvackande_nn_1_N = mkN "kvackande" ;
  kvaddande_nn_1_N = mkN "kvaddande" ;
  kvadrerande_nn_1_N = mkN "kvadrerande" ;
  kvalande_nn_1_N = mkN "kvalande" ;
  kvalificerande_nn_1_N = mkN "kvalificerande" ;
  kvalitetsarbete_nn_1_N = mkN "kvalitetsarbete" ;
  kvalitetsgranskande_nn_1_N = mkN "kvalitetsgranskande" ;
  kvalitetssaekrande_nn_1_1_N = mkN "kvalitetssäkrande" ;
  kvantifierande_nn_1_N = mkN "kvantifierande" ;
  kvarblivande_nn_1_N = mkN "kvarblivande" ;
  kvardroejande_nn_1_1_N = mkN "kvardröjande" ;
  kvarhaallande_nn_1_1_N = mkN "kvarhållande" ;
  kvarlaemnande_nn_1_1_N = mkN "kvarlämnande" ;
  kvarstannande_nn_1_N = mkN "kvarstannande" ;
  kvarstaaende_nn_1_1_N = mkN "kvarstående" ;
  kvartande_nn_1_N = mkN "kvartande" ;
  kverulerande_nn_1_N = mkN "kverulerande" ;
  kvickande_nn_1_N = mkN "kvickande" ;
  kvicksilverbetande_nn_1_N = mkN "kvicksilverbetande" ;
  kvidande_nn_1_N = mkN "kvidande" ;
  kvillrande_nn_1_N = mkN "kvillrande" ;
  kviltande_nn_1_N = mkN "kviltande" ;
  kvinnoarbete_nn_1_N = mkN "kvinnoarbete" ;
  kvinnosmycke_nn_1_N = mkN "kvinnosmycke" ;
  kvinnooede_nn_1_1_N = mkN "kvinnoöde" ;
  kvintilerande_nn_1_N = mkN "kvintilerande" ;
  kvirrande_nn_1_N = mkN "kvirrande" ;
  kvistande_nn_1_N = mkN "kvistande" ;
  kvittande_nn_1_N = mkN "kvittande" ;
  kvitterande_nn_1_N = mkN "kvitterande" ;
  kvittrande_nn_1_N = mkN "kvittrande" ;
  kvoterande_nn_1_N = mkN "kvoterande" ;
  kvaedande_nn_1_1_N = mkN "kvädande" ;
  kvaede_nn_1_1_N = mkN "kväde" ;
  kvaekande_nn_1_1_N = mkN "kväkande" ;
  kvaeljande_nn_1_1_N = mkN "kväljande" ;
  kvaellande_nn_1_1_N = mkN "kvällande" ;
  kvaesande_nn_1_1_N = mkN "kväsande" ;
  kvaevande_nn_1_1_N = mkN "kvävande" ;
  kyffande_nn_1_N = mkN "kyffande" ;
  kyffe_nn_1_N = mkN "kyffe" ;
  kylande_nn_1_N = mkN "kylande" ;
  kyllagrande_nn_1_N = mkN "kyllagrande" ;
  kylnande_nn_1_N = mkN "kylnande" ;
  kynne_nn_1_N = mkN "kynne" ;
  kyprande_nn_1_N = mkN "kyprande" ;
  kyrkbokfoerande_nn_1_1_N = mkN "kyrkbokförande" ;
  kyrkbygge_nn_1_N = mkN "kyrkbygge" ;
  kyrkobokfoerande_nn_1_1_N = mkN "kyrkobokförande" ;
  kyrkomoete_nn_1_1_N = mkN "kyrkomöte" ;
  kyrkskrivande_nn_1_N = mkN "kyrkskrivande" ;
  kyskhetsbaelte_nn_1_1_N = mkN "kyskhetsbälte" ;
  kyskhetsloefte_nn_1_1_N = mkN "kyskhetslöfte" ;
  kyssande_nn_1_N = mkN "kyssande" ;
  kaebblande_nn_1_1_N = mkN "käbblande" ;
  kaeftande_nn_1_1_N = mkN "käftande" ;
  kaekande_nn_1_1_N = mkN "käkande" ;
  kaelande_nn_1_1_N = mkN "kälande" ;
  kaellfloede_nn_1_1_N = mkN "källflöde" ;
  kaellsorterande_nn_1_1_N = mkN "källsorterande" ;
  kaeltande_nn_1_1_N = mkN "kältande" ;
  kaempande_nn_1_1_N = mkN "kämpande" ;
  kaennande_nn_1_1_N = mkN "kännande" ;
  kaennemaerke_nn_1_1_N = mkN "kännemärke" ;
  kaennetecknande_nn_1_1_N = mkN "kännetecknande" ;
  kaenslolaege_nn_1_1_N = mkN "känsloläge" ;
  kaerande_nn_2_1_N = mkN "kärande" ;
  kaerleksfoerhaallande_nn_1_1_N = mkN "kärleksförhållande" ;
  kaerleksmoete_nn_1_1_N = mkN "kärleksmöte" ;
  kaerleksrykte_nn_1_1_N = mkN "kärleksrykte" ;
  kaernande_nn_1_1_N = mkN "kärnande" ;
  kaernbraensle_nn_1_1_N = mkN "kärnbränsle" ;
  kaernminne_nn_1_1_N = mkN "kärnminne" ;
  kaernreaktorbygge_nn_1_1_N = mkN "kärnreaktorbygge" ;
  kaernrike_nn_1_1_N = mkN "kärnrike" ;
  kaervande_nn_1_1_N = mkN "kärvande" ;
  kaexande_nn_1_1_N = mkN "käxande" ;
  kaankande_nn_1_1_N = mkN "kånkande" ;
  kaarande_nn_1_1_N = mkN "kårande" ;
  kaaserande_nn_1_1_N = mkN "kåserande" ;
  koeande_nn_1_1_N = mkN "köande" ;
  koelhalande_nn_1_1_N = mkN "kölhalande" ;
  koenande_nn_1_1_N = mkN "könande" ;
  koensbyte_nn_1_1_N = mkN "könsbyte" ;
  koensdiskriminerande_nn_1_1_N = mkN "könsdiskriminerande" ;
  koenskvoterande_nn_1_1_N = mkN "könskvoterande" ;
  koensumgaenge_nn_1_1_N = mkN "könsumgänge" ;
  koepande_nn_1_1_N = mkN "köpande" ;
  koepbeteende_nn_1_1_N = mkN "köpbeteende" ;
  koerande_nn_1_1_N = mkN "körande" ;
  koernande_nn_1_1_N = mkN "körnande" ;
  koettstycke_nn_1_1_N = mkN "köttstycke" ;
  koevande_nn_1_1_N = mkN "kövande" ;
  labialiserande_nn_1_N = mkN "labialiserande" ;
  laborerande_nn_1_N = mkN "laborerande" ;
  lackande_nn_1_N = mkN "lackande" ;
  lackerande_nn_1_N = mkN "lackerande" ;
  laddande_nn_1_N = mkN "laddande" ;
  lafsande_nn_1_N = mkN "lafsande" ;
  lagande_nn_1_N = mkN "lagande" ;
  lagarbete_nn_1_N = mkN "lagarbete" ;
  lagerfoerande_nn_1_1_N = mkN "lagerförande" ;
  lagerkransande_nn_1_N = mkN "lagerkransande" ;
  lagerkroenande_nn_1_1_N = mkN "lagerkrönande" ;
  lagfarande_nn_1_N = mkN "lagfarande" ;
  lagfaestande_nn_1_1_N = mkN "lagfästande" ;
  lagfoerande_nn_1_1_N = mkN "lagförande" ;
  laggande_nn_1_N = mkN "laggande" ;
  laggdike_nn_1_N = mkN "laggdike" ;
  lagomraade_nn_1_1_N = mkN "lagområde" ;
  lagrande_nn_1_N = mkN "lagrande" ;
  lagstiftande_nn_1_N = mkN "lagstiftande" ;
  lagsoekande_nn_1_1_N = mkN "lagsökande" ;
  lallande_nn_1_N = mkN "lallande" ;
  lamenterande_nn_1_N = mkN "lamenterande" ;
  laminerande_nn_1_N = mkN "laminerande" ;
  lammande_nn_1_N = mkN "lammande" ;
  lamslaaende_nn_1_1_N = mkN "lamslående" ;
  landamaere_nn_1_1_N = mkN "landamäre" ;
  landande_nn_1_N = mkN "landande" ;
  landfaeste_nn_1_1_N = mkN "landfäste" ;
  landmaerke_nn_1_1_N = mkN "landmärke" ;
  landningsmaerke_nn_1_1_N = mkN "landningsmärke" ;
  landomraade_nn_1_1_N = mkN "landområde" ;
  landsfoervisande_nn_1_1_N = mkN "landsförvisande" ;
  landshoevdingeaembete_nn_1_1_N = mkN "landshövdingeämbete" ;
  landstigande_nn_1_N = mkN "landstigande" ;
  landstaelle_nn_1_1_N = mkN "landställe" ;
  landsaettande_nn_1_1_N = mkN "landsättande" ;
  langande_nn_1_N = mkN "langande" ;
  langetterande_nn_1_N = mkN "langetterande" ;
  lanserande_nn_1_N = mkN "lanserande" ;
  lantbrukskunnande_nn_1_N = mkN "lantbrukskunnande" ;
  lantstaelle_nn_1_1_N = mkN "lantställe" ;
  lapande_nn_1_N = mkN "lapande" ;
  lapiserande_nn_1_N = mkN "lapiserande" ;
  lappande_nn_1_N = mkN "lappande" ;
  lapptaecke_nn_1_1_N = mkN "lapptäcke" ;
  larmande_nn_1_N = mkN "larmande" ;
  larvande_nn_1_N = mkN "larvande" ;
  laserande_nn_1_N = mkN "laserande" ;
  lasersikte_nn_1_N = mkN "lasersikte" ;
  laskande_nn_1_N = mkN "laskande" ;
  lassande_nn_1_N = mkN "lassande" ;
  lastande_nn_1_N = mkN "lastande" ;
  lastutrymme_nn_1_N = mkN "lastutrymme" ;
  latiniserande_nn_1_N = mkN "latiniserande" ;
  latinvaelde_nn_1_1_N = mkN "latinvälde" ;
  lattjande_nn_1_N = mkN "lattjande" ;
  lavafloede_nn_1_1_N = mkN "lavaflöde" ;
  laverande_nn_1_N = mkN "laverande" ;
  laxande_nn_1_N = mkN "laxande" ;
  laxerande_nn_1_N = mkN "laxerande" ;
  leasande_nn_1_N = mkN "leasande" ;
  ledande_nn_1_N = mkN "ledande" ;
  ledarskifte_nn_1_N = mkN "ledarskifte" ;
  ledigfoerklarande_nn_1_1_N = mkN "ledigförklarande" ;
  ledsagande_nn_1_N = mkN "ledsagande" ;
  ledsnande_nn_1_N = mkN "ledsnande" ;
  ledutrymme_nn_1_N = mkN "ledutrymme" ;
  leende_nn_1_N = mkN "leende" ;
  legaliserande_nn_1_N = mkN "legaliserande" ;
  legerande_nn_1_N = mkN "legerande" ;
  legitimerande_nn_1_N = mkN "legitimerande" ;
  lejande_nn_1_N = mkN "lejande" ;
  lejdrande_nn_1_N = mkN "lejdrande" ;
  lekande_nn_1_N = mkN "lekande" ;
  lemlaestande_nn_1_1_N = mkN "lemlästande" ;
  lenande_nn_1_N = mkN "lenande" ;
  lessnande_nn_1_N = mkN "lessnande" ;
  letande_nn_1_N = mkN "letande" ;
  lettrande_nn_1_N = mkN "lettrande" ;
  levande_nn_1_N = mkN "levande" ;
  levandegoerande_nn_1_1_N = mkN "levandegörande" ;
  leve_nn_1_N = mkN "leve" ;
  levererande_nn_1_N = mkN "levererande" ;
  levnadsfoerhaallande_nn_1_1_N = mkN "levnadsförhållande" ;
  levnadsoede_nn_1_1_N = mkN "levnadsöde" ;
  liberaliserande_nn_1_N = mkN "liberaliserande" ;
  licensbelaeggande_nn_1_1_N = mkN "licensbeläggande" ;
  licenserande_nn_1_N = mkN "licenserande" ;
  licensierande_nn_1_N = mkN "licensierande" ;
  licentierande_nn_1_N = mkN "licentierande" ;
  lidande_nn_1_N = mkN "lidande" ;
  lierande_nn_1_N = mkN "lierande" ;
  liftande_nn_1_N = mkN "liftande" ;
  liggande_nn_1_N = mkN "liggande" ;
  likande_nn_1_N = mkN "likande" ;
  liknande_nn_1_N = mkN "liknande" ;
  likriktande_nn_1_N = mkN "likriktande" ;
  likstaellande_nn_1_1_N = mkN "likställande" ;
  likviderande_nn_1_N = mkN "likviderande" ;
  limmande_nn_1_N = mkN "limmande" ;
  limaemne_nn_1_1_N = mkN "limämne" ;
  lindande_nn_1_N = mkN "lindande" ;
  lindrande_nn_1_N = mkN "lindrande" ;
  linjearbete_nn_1_N = mkN "linjearbete" ;
  linjerande_nn_1_N = mkN "linjerande" ;
  linkande_nn_1_N = mkN "linkande" ;
  linne_nn_2_N = mkN "linne" ;
  lipande_nn_1_N = mkN "lipande" ;
  lirande_nn_1_N = mkN "lirande" ;
  lirkande_nn_1_N = mkN "lirkande" ;
  lismande_nn_1_N = mkN "lismande" ;
  lisserande_nn_1_N = mkN "lisserande" ;
  listande_nn_1_N = mkN "listande" ;
  litande_nn_1_N = mkN "litande" ;
  litograferande_nn_1_N = mkN "litograferande" ;
  litsande_nn_1_N = mkN "litsande" ;
  livande_nn_1_N = mkN "livande" ;
  livbaelte_nn_1_1_N = mkN "livbälte" ;
  livfoersaekrande_nn_1_1_N = mkN "livförsäkrande" ;
  livgarde_nn_1_N = mkN "livgarde" ;
  livnaerande_nn_1_1_N = mkN "livnärande" ;
  livregemente_nn_1_N = mkN "livregemente" ;
  livstycke_nn_1_N = mkN "livstycke" ;
  ljudande_nn_1_N = mkN "ljudande" ;
  ljudisolerande_nn_1_N = mkN "ljudisolerande" ;
  ljudsaettande_nn_1_1_N = mkN "ljudsättande" ;
  ljugande_nn_1_N = mkN "ljugande" ;
  ljummande_nn_1_N = mkN "ljummande" ;
  ljungande_nn_1_N = mkN "ljungande" ;
  ljusfloede_nn_1_1_N = mkN "ljusflöde" ;
  ljusfoerhaallande_nn_1_1_N = mkN "ljusförhållande" ;
  ljuskopierande_nn_1_N = mkN "ljuskopierande" ;
  ljusnande_nn_1_N = mkN "ljusnande" ;
  ljustrande_nn_1_N = mkN "ljustrande" ;
  lobbande_nn_1_N = mkN "lobbande" ;
  lockande_nn_1_N = mkN "lockande" ;
  lockbete_nn_1_N = mkN "lockbete" ;
  lockoutande_nn_1_N = mkN "lockoutande" ;
  lodande_nn_1_N = mkN "lodande" ;
  logerande_nn_1_N = mkN "logerande" ;
  loggande_nn_1_N = mkN "loggande" ;
  lokalbedoevande_nn_1_1_N = mkN "lokalbedövande" ;
  lokalintresse_nn_1_N = mkN "lokalintresse" ;
  lokaliserande_nn_1_N = mkN "lokaliserande" ;
  lokalsamhaelle_nn_1_1_N = mkN "lokalsamhälle" ;
  lokalsinne_nn_1_N = mkN "lokalsinne" ;
  lomande_nn_1_N = mkN "lomande" ;
  lommande_nn_1_N = mkN "lommande" ;
  loppande_nn_1_N = mkN "loppande" ;
  loskande_nn_1_N = mkN "loskande" ;
  lossande_nn_1_N = mkN "lossande" ;
  lossnande_nn_1_N = mkN "lossnande" ;
  lotsande_nn_1_N = mkN "lotsande" ;
  lottande_nn_1_N = mkN "lottande" ;
  lovande_nn_1_N = mkN "lovande" ;
  lovordande_nn_1_N = mkN "lovordande" ;
  lovprisande_nn_1_N = mkN "lovprisande" ;
  lovsjungande_nn_1_N = mkN "lovsjungande" ;
  lubbande_nn_1_N = mkN "lubbande" ;
  luckrande_nn_1_N = mkN "luckrande" ;
  luddande_nn_1_N = mkN "luddande" ;
  luffande_nn_1_N = mkN "luffande" ;
  luffaransikte_nn_1_N = mkN "luffaransikte" ;
  lufsande_nn_1_N = mkN "lufsande" ;
  luftande_nn_2_N = mkN "luftande" ;
  luftlandsaettande_nn_1_1_N = mkN "luftlandsättande" ;
  luftombyte_nn_1_N = mkN "luftombyte" ;
  lufttorkande_nn_1_N = mkN "lufttorkande" ;
  luggande_nn_1_N = mkN "luggande" ;
  lugnande_nn_1_N = mkN "lugnande" ;
  luktande_nn_1_N = mkN "luktande" ;
  luktsinne_nn_1_N = mkN "luktsinne" ;
  lullande_nn_1_N = mkN "lullande" ;
  lumpande_nn_1_N = mkN "lumpande" ;
  lunchande_nn_1_N = mkN "lunchande" ;
  lunchstaelle_nn_1_1_N = mkN "lunchställe" ;
  lungbyte_nn_1_N = mkN "lungbyte" ;
  lunkande_nn_1_N = mkN "lunkande" ;
  lunnande_nn_1_N = mkN "lunnande" ;
  luntande_nn_1_N = mkN "luntande" ;
  lurande_nn_1_N = mkN "lurande" ;
  lurpassande_nn_1_N = mkN "lurpassande" ;
  lusande_nn_1_N = mkN "lusande" ;
  luskande_nn_1_N = mkN "luskande" ;
  luslaesande_nn_1_1_N = mkN "lusläsande" ;
  lussande_nn_1_N = mkN "lussande" ;
  lutande_nn_1_N = mkN "lutande" ;
  luteiniserande_nn_1_N = mkN "luteiniserande" ;
  luttrande_nn_1_N = mkN "luttrande" ;
  lyckliggoerande_nn_1_1_N = mkN "lyckliggörande" ;
  lyckorike_nn_1_N = mkN "lyckorike" ;
  lyckoenskande_nn_1_1_N = mkN "lyckönskande" ;
  lydande_nn_1_N = mkN "lydande" ;
  lydrike_nn_1_N = mkN "lydrike" ;
  lyftande_nn_1_N = mkN "lyftande" ;
  lyktande_nn_1_N = mkN "lyktande" ;
  lynchande_nn_1_N = mkN "lynchande" ;
  lynne_nn_1_N = mkN "lynne" ;
  lyrande_nn_1_N = mkN "lyrande" ;
  lysande_nn_1_N = mkN "lysande" ;
  lyse_nn_1_N = mkN "lyse" ;
  lyssnande_nn_1_N = mkN "lyssnande" ;
  lystmaete_nn_1_1_N = mkN "lystmäte" ;
  lystrande_nn_1_N = mkN "lystrande" ;
  lysaemne_nn_1_1_N = mkN "lysämne" ;
  lyte_nn_1_N = mkN "lyte" ;
  lyxande_nn_1_N = mkN "lyxande" ;
  lyxrenoverande_nn_1_N = mkN "lyxrenoverande" ;
  laeande_nn_1_1_N = mkN "läande" ;
  laeckande_nn_1_1_N = mkN "läckande" ;
  laederande_nn_1_1_N = mkN "läderande" ;
  laege_nn_1_1_N = mkN "läge" ;
  laegenhetsbyte_nn_1_1_N = mkN "lägenhetsbyte" ;
  laegessinne_nn_1_1_N = mkN "lägessinne" ;
  laeggande_nn_1_1_N = mkN "läggande" ;
  laegrande_nn_1_1_N = mkN "lägrande" ;
  laekande_nn_1_1_N = mkN "läkande" ;
  laekarundersoekande_nn_1_1_N = mkN "läkarundersökande" ;
  laektrande_nn_1_1_N = mkN "läktrande" ;
  laemnande_nn_1_1_N = mkN "lämnande" ;
  laempande_nn_1_1_N = mkN "lämpande" ;
  laendande_nn_1_1_N = mkN "ländande" ;
  laendklaede_nn_1_1_N = mkN "ländkläde" ;
  laendstycke_nn_1_1_N = mkN "ländstycke" ;
  laengande_nn_1_1_N = mkN "längande" ;
  laengtande_nn_1_1_N = mkN "längtande" ;
  laenkande_nn_1_1_N = mkN "länkande" ;
  laensande_nn_1_1_N = mkN "länsande" ;
  laeppjande_nn_1_1_N = mkN "läppjande" ;
  laerande_nn_1_1_N = mkN "lärande" ;
  laerostycke_nn_1_1_N = mkN "lärostycke" ;
  laerosaete_nn_1_1_N = mkN "lärosäte" ;
  laeroaemne_nn_1_1_N = mkN "läroämne" ;
  laesande_nn_1_1_N = mkN "läsande" ;
  laeskande_nn_1_1_N = mkN "läskande" ;
  laespande_nn_1_1_N = mkN "läspande" ;
  laesvaerde_nn_1_1_N = mkN "läsvärde" ;
  laesaemne_nn_1_1_N = mkN "läsämne" ;
  laete_nn_1_1_N = mkN "läte" ;
  laettande_nn_1_1_N = mkN "lättande" ;
  laettnande_nn_1_1_N = mkN "lättnande" ;
  laettrande_nn_1_1_N = mkN "lättrande" ;
  laettsinne_nn_1_1_N = mkN "lättsinne" ;
  laadaemne_nn_1_1_N = mkN "lådämne" ;
  laagande_nn_1_1_N = mkN "lågande" ;
  laagflygande_nn_1_1_N = mkN "lågflygande" ;
  laagprioriterande_nn_1_1_N = mkN "lågprioriterande" ;
  laagpriskaffe_nn_1_1_N = mkN "lågpriskaffe" ;
  laagtrycksomraade_nn_1_1_N = mkN "lågtrycksområde" ;
  laagvattenmaerke_nn_1_1_N = mkN "lågvattenmärke" ;
  laanande_nn_1_1_N = mkN "lånande" ;
  laaneloefte_nn_1_1_N = mkN "lånelöfte" ;
  laangtidsparkerande_nn_1_1_N = mkN "långtidsparkerande" ;
  laansparande_nn_1_1_N = mkN "lånsparande" ;
  laarstycke_nn_1_1_N = mkN "lårstycke" ;
  laasande_nn_1_1_N = mkN "låsande" ;
  laassande_nn_1_1_N = mkN "låssande" ;
  laatande_nn_1_1_N = mkN "låtande" ;
  laatsande_nn_1_1_N = mkN "låtsande" ;
  loedande_nn_1_1_N = mkN "lödande" ;
  loeddrande_nn_1_1_N = mkN "löddrande" ;
  loefte_nn_1_1_N = mkN "löfte" ;
  loegande_nn_1_1_N = mkN "lögande" ;
  loeje_nn_1_1_N = mkN "löje" ;
  loemsknande_nn_1_1_N = mkN "lömsknande" ;
  loenande_nn_1_1_N = mkN "lönande" ;
  loenelaege_nn_1_1_N = mkN "löneläge" ;
  loennmoerdande_nn_1_1_N = mkN "lönnmördande" ;
  loenskalaege_nn_1_1_N = mkN "lönskaläge" ;
  loensparande_nn_1_1_N = mkN "lönsparande" ;
  loepande_nn_1_1_N = mkN "löpande" ;
  loepnande_nn_1_1_N = mkN "löpnande" ;
  loesande_nn_1_1_N = mkN "lösande" ;
  loesgoerande_nn_1_1_N = mkN "lösgörande" ;
  loesoere_nn_1_1_N = mkN "lösöre" ;
  loevande_nn_1_1_N = mkN "lövande" ;
  macklande_nn_1_N = mkN "macklande" ;
  madrasserande_nn_1_N = mkN "madrasserande" ;
  magasinerande_nn_1_N = mkN "magasinerande" ;
  magnetiserande_nn_1_N = mkN "magnetiserande" ;
  magpumpande_nn_1_N = mkN "magpumpande" ;
  magrande_nn_1_N = mkN "magrande" ;
  mailande_nn_1_N = mkN "mailande" ;
  majande_nn_1_N = mkN "majande" ;
  majoritetssamhaelle_nn_1_1_N = mkN "majoritetssamhälle" ;
  majoritetsaegande_nn_1_1_N = mkN "majoritetsägande" ;
  makande_nn_1_N = mkN "makande" ;
  maktskifte_nn_1_N = mkN "maktskifte" ;
  maktoevertagande_nn_1_1_N = mkN "maktövertagande" ;
  makulerande_nn_1_N = mkN "makulerande" ;
  malande_nn_1_N = mkN "malande" ;
  malfoberande_nn_1_N = mkN "malfoberande" ;
  malmande_nn_1_N = mkN "malmande" ;
  maltraeterande_nn_1_1_N = mkN "malträterande" ;
  manande_nn_1_N = mkN "manande" ;
  manglande_nn_1_N = mkN "manglande" ;
  manifesterande_nn_1_N = mkN "manifesterande" ;
  manikurerande_nn_1_N = mkN "manikurerande" ;
  manikyrerande_nn_1_N = mkN "manikyrerande" ;
  manipulerande_nn_1_N = mkN "manipulerande" ;
  mankerande_nn_1_N = mkN "mankerande" ;
  manschettyrke_nn_1_N = mkN "manschettyrke" ;
  mansintresse_nn_1_N = mkN "mansintresse" ;
  manssamhaelle_nn_1_1_N = mkN "manssamhälle" ;
  mantlande_nn_1_N = mkN "mantlande" ;
  manoeverutrymme_nn_1_1_N = mkN "manöverutrymme" ;
  manoevrerande_nn_1_1_N = mkN "manövrerande" ;
  marginaliserande_nn_1_N = mkN "marginaliserande" ;
  marinerande_nn_1_N = mkN "marinerande" ;
  markerande_nn_1_N = mkN "markerande" ;
  marknadsanpassande_nn_1_N = mkN "marknadsanpassande" ;
  marknadsfoerande_nn_1_1_N = mkN "marknadsförande" ;
  marknadslaege_nn_1_1_N = mkN "marknadsläge" ;
  marknadsvaerde_nn_1_1_N = mkN "marknadsvärde" ;
  marknadsvaerderande_nn_1_1_N = mkN "marknadsvärderande" ;
  markomraade_nn_1_1_N = mkN "markområde" ;
  marmorerande_nn_1_N = mkN "marmorerande" ;
  maroderande_nn_1_N = mkN "maroderande" ;
  marscherande_nn_1_N = mkN "marscherande" ;
  marschlaege_nn_1_1_N = mkN "marschläge" ;
  marterande_nn_1_N = mkN "marterande" ;
  masande_nn_1_N = mkN "masande" ;
  maskande_nn_1_N = mkN "maskande" ;
  maskerande_nn_1_N = mkN "maskerande" ;
  maskuliniserande_nn_1_N = mkN "maskuliniserande" ;
  massakrerande_nn_1_N = mkN "massakrerande" ;
  massavskedande_nn_1_N = mkN "massavskedande" ;
  masserande_nn_1_N = mkN "masserande" ;
  massgripande_nn_1_N = mkN "massgripande" ;
  massmoete_nn_1_1_N = mkN "massmöte" ;
  massutdoeende_nn_1_1_N = mkN "massutdöende" ;
  masturberande_nn_1_N = mkN "masturberande" ;
  matande_nn_1_N = mkN "matande" ;
  matchande_nn_1_N = mkN "matchande" ;
  matelasserande_nn_1_N = mkN "matelasserande" ;
  materialiserande_nn_1_N = mkN "materialiserande" ;
  materieutbyte_nn_1_N = mkN "materieutbyte" ;
  matstaelle_nn_1_1_N = mkN "matställe" ;
  mattande_nn_1_N = mkN "mattande" ;
  matterande_nn_1_N = mkN "matterande" ;
  mattesnille_nn_1_N = mkN "mattesnille" ;
  matvaegrande_nn_1_1_N = mkN "matvägrande" ;
  mataepple_nn_1_1_N = mkN "matäpple" ;
  maxande_nn_1_N = mkN "maxande" ;
  maximerande_nn_1_N = mkN "maximerande" ;
  meckande_nn_1_N = mkN "meckande" ;
  mecklande_nn_1_N = mkN "mecklande" ;
  medaljerande_nn_1_N = mkN "medaljerande" ;
  medarbetande_nn_1_N = mkN "medarbetande" ;
  medborgargarde_nn_1_N = mkN "medborgargarde" ;
  medborgarinflytande_nn_1_N = mkN "medborgarinflytande" ;
  medborgarsinne_nn_1_N = mkN "medborgarsinne" ;
  medborgarvittne_nn_1_N = mkN "medborgarvittne" ;
  medbringande_nn_1_N = mkN "medbringande" ;
  meddelande_nn_1_N = mkN "meddelande" ;
  medelvaerde_nn_1_1_N = mkN "medelvärde" ;
  medfoeljande_nn_1_1_N = mkN "medföljande" ;
  medfoerande_nn_1_1_N = mkN "medförande" ;
  medgivande_nn_1_N = mkN "medgivande" ;
  medicinerande_nn_1_N = mkN "medicinerande" ;
  mediterande_nn_1_N = mkN "mediterande" ;
  medlande_nn_1_N = mkN "medlande" ;
  medlemsmoete_nn_1_1_N = mkN "medlemsmöte" ;
  medtagande_nn_1_N = mkN "medtagande" ;
  medverkande_nn_1_N = mkN "medverkande" ;
  mejande_nn_1_N = mkN "mejande" ;
  mejlande_nn_1_N = mkN "mejlande" ;
  mejlbombande_nn_1_N = mkN "mejlbombande" ;
  mejslande_nn_1_N = mkN "mejslande" ;
  mekande_nn_1_N = mkN "mekande" ;
  mekaniserande_nn_1_N = mkN "mekaniserande" ;
  mellangaerde_nn_1_1_N = mkN "mellangärde" ;
  mellanhavande_nn_1_N = mkN "mellanhavande" ;
  mellanlandande_nn_1_N = mkN "mellanlandande" ;
  mellanlaege_nn_1_1_N = mkN "mellanläge" ;
  melonaepple_nn_1_1_N = mkN "melonäpple" ;
  memorerande_nn_1_N = mkN "memorerande" ;
  menande_nn_1_N = mkN "menande" ;
  menfoere_nn_1_1_N = mkN "menföre" ;
  meningsbyte_nn_1_N = mkN "meningsbyte" ;
  meningsutbyte_nn_1_N = mkN "meningsutbyte" ;
  menstruerande_nn_1_N = mkN "menstruerande" ;
  merarbete_nn_1_N = mkN "merarbete" ;
  merceriserande_nn_1_N = mkN "merceriserande" ;
  meriterande_nn_1_N = mkN "meriterande" ;
  mervaerde_nn_1_1_N = mkN "mervärde" ;
  messande_nn_1_N = mkN "messande" ;
  messiasrike_nn_1_N = mkN "messiasrike" ;
  metalliserande_nn_1_N = mkN "metalliserande" ;
  metallvaerde_nn_1_1_N = mkN "metallvärde" ;
  metande_nn_1_N = mkN "metande" ;
  mete_nn_1_N = mkN "mete" ;
  mezzoforte_nn_1_N = mkN "mezzoforte" ;
  micrande_nn_1_N = mkN "micrande" ;
  mikrande_nn_1_N = mkN "mikrande" ;
  mikrofilmande_nn_1_N = mkN "mikrofilmande" ;
  mikrofotograferande_nn_1_N = mkN "mikrofotograferande" ;
  mikrometersikte_nn_1_N = mkN "mikrometersikte" ;
  mikroskoperande_nn_1_N = mkN "mikroskoperande" ;
  mildrande_nn_1_N = mkN "mildrande" ;
  milennieskifte_nn_1_N = mkN "milennieskifte" ;
  militariserande_nn_1_N = mkN "militariserande" ;
  militaeromraade_nn_1_1_N = mkN "militärområde" ;
  miljoearbete_nn_1_1_N = mkN "miljöarbete" ;
  miljoebyte_nn_1_1_N = mkN "miljöbyte" ;
  miljoecertifierande_nn_1_1_N = mkN "miljöcertifierande" ;
  miljoemaerkande_nn_1_1_N = mkN "miljömärkande" ;
  miljoeombyte_nn_1_1_N = mkN "miljöombyte" ;
  miljoetaenkande_nn_1_1_N = mkN "miljötänkande" ;
  millennieskifte_nn_1_N = mkN "millennieskifte" ;
  mimande_nn_1_N = mkN "mimande" ;
  minaretbygge_nn_1_N = mkN "minaretbygge" ;
  mineraliserande_nn_1_N = mkN "mineraliserande" ;
  mineralaemne_nn_1_1_N = mkN "mineralämne" ;
  minerande_nn_1_N = mkN "minerande" ;
  minglande_nn_1_N = mkN "minglande" ;
  miniatyriserande_nn_1_N = mkN "miniatyriserande" ;
  minimerande_nn_1_N = mkN "minimerande" ;
  ministerstyre_nn_1_N = mkN "ministerstyre" ;
  ministeraembete_nn_1_1_N = mkN "ministerämbete" ;
  minnande_nn_1_N = mkN "minnande" ;
  minne_nn_1_N = mkN "minne" ;
  minnesmaerke_nn_1_1_N = mkN "minnesmärke" ;
  minoritetsvaelde_nn_1_1_N = mkN "minoritetsvälde" ;
  minskande_nn_1_N = mkN "minskande" ;
  missaktande_nn_1_N = mkN "missaktande" ;
  missale_nn_1_N = mkN "missale" ;
  missande_nn_1_N = mkN "missande" ;
  missbedoemande_nn_1_1_N = mkN "missbedömande" ;
  missbrukande_nn_1_N = mkN "missbrukande" ;
  missbrukarumgaenge_nn_1_1_N = mkN "missbrukarumgänge" ;
  missfirmande_nn_1_N = mkN "missfirmande" ;
  missfaergande_nn_1_1_N = mkN "missfärgande" ;
  missfoerhaallande_nn_1_1_N = mkN "missförhållande" ;
  missfoerstaaende_nn_1_1_N = mkN "missförstående" ;
  missgynnande_nn_1_N = mkN "missgynnande" ;
  misshagande_nn_1_N = mkN "misshagande" ;
  misshandlande_nn_1_N = mkN "misshandlande" ;
  missionerande_nn_1_N = mkN "missionerande" ;
  missiverande_nn_1_N = mkN "missiverande" ;
  missklaedande_nn_1_1_N = mkN "missklädande" ;
  misskrediterande_nn_1_N = mkN "misskrediterande" ;
  misskaennande_nn_1_1_N = mkN "misskännande" ;
  misskoetande_nn_1_1_N = mkN "misskötande" ;
  missledande_nn_1_N = mkN "missledande" ;
  misslyckande_nn_1_N = mkN "misslyckande" ;
  missnoeje_nn_1_1_N = mkN "missnöje" ;
  missprydande_nn_1_N = mkN "missprydande" ;
  misstagande_nn_1_N = mkN "misstagande" ;
  misstolkande_nn_1_N = mkN "misstolkande" ;
  misstroende_nn_1_N = mkN "misstroende" ;
  misstroestande_nn_1_1_N = mkN "misströstande" ;
  misstyckande_nn_1_N = mkN "misstyckande" ;
  misstydande_nn_1_N = mkN "misstydande" ;
  misstaenkande_nn_1_1_N = mkN "misstänkande" ;
  misstaenkliggoerande_nn_1_1_N = mkN "misstänkliggörande" ;
  missunnande_nn_1_N = mkN "missunnande" ;
  missuppfattande_nn_1_N = mkN "missuppfattande" ;
  missvisande_nn_1_N = mkN "missvisande" ;
  missoede_nn_1_1_N = mkN "missöde" ;
  mistande_nn_1_N = mkN "mistande" ;
  mittraecke_nn_1_1_N = mkN "mitträcke" ;
  mixande_nn_1_N = mkN "mixande" ;
  mixtrande_nn_1_N = mkN "mixtrande" ;
  mjauande_nn_1_N = mkN "mjauande" ;
  mjukande_nn_1_N = mkN "mjukande" ;
  mjukgoerande_nn_1_1_N = mkN "mjukgörande" ;
  mjuklandande_nn_1_N = mkN "mjuklandande" ;
  mjuknande_nn_1_N = mkN "mjuknande" ;
  mjoelande_nn_1_1_N = mkN "mjölande" ;
  mjoelkande_nn_1_1_N = mkN "mjölkande" ;
  mjoelkfloede_nn_1_1_N = mkN "mjölkflöde" ;
  mobbande_nn_1_N = mkN "mobbande" ;
  mobiliserande_nn_1_N = mkN "mobiliserande" ;
  mobilpratande_nn_1_N = mkN "mobilpratande" ;
  mockande_nn_1_N = mkN "mockande" ;
  mode_nn_1_N = mkN "mode" ;
  modellbygge_nn_1_N = mkN "modellbygge" ;
  modellerande_nn_1_N = mkN "modellerande" ;
  modererande_nn_1_N = mkN "modererande" ;
  moderniserande_nn_1_N = mkN "moderniserande" ;
  modersskoete_nn_1_1_N = mkN "moderssköte" ;
  modifierande_nn_1_N = mkN "modifierande" ;
  modulerande_nn_1_N = mkN "modulerande" ;
  modaerniserande_nn_1_1_N = mkN "modärniserande" ;
  mognande_nn_1_N = mkN "mognande" ;
  mojnande_nn_1_N = mkN "mojnande" ;
  molande_nn_1_N = mkN "molande" ;
  molnhoelje_nn_1_1_N = mkN "molnhölje" ;
  molntaecke_nn_1_1_N = mkN "molntäcke" ;
  moltigande_nn_1_N = mkN "moltigande" ;
  momsredovisande_nn_1_N = mkN "momsredovisande" ;
  mongolrike_nn_1_N = mkN "mongolrike" ;
  monoftongerande_nn_1_N = mkN "monoftongerande" ;
  monopoliserande_nn_1_N = mkN "monopoliserande" ;
  monterande_nn_1_N = mkN "monterande" ;
  mopedande_nn_1_N = mkN "mopedande" ;
  moppande_nn_1_N = mkN "moppande" ;
  moraliserande_nn_1_N = mkN "moraliserande" ;
  mordhotande_nn_1_N = mkN "mordhotande" ;
  morgonmoete_nn_1_1_N = mkN "morgonmöte" ;
  morlande_nn_1_N = mkN "morlande" ;
  morrande_nn_1_N = mkN "morrande" ;
  morsande_nn_1_N = mkN "morsande" ;
  morserande_nn_1_N = mkN "morserande" ;
  mortificerande_nn_1_N = mkN "mortificerande" ;
  mortifierande_nn_1_N = mkN "mortifierande" ;
  mosande_nn_1_N = mkN "mosande" ;
  motande_nn_1_N = mkN "motande" ;
  motarbetande_nn_1_N = mkN "motarbetande" ;
  motbevisande_nn_1_N = mkN "motbevisande" ;
  motionerande_nn_1_N = mkN "motionerande" ;
  motiverande_nn_1_N = mkN "motiverande" ;
  motlaesande_nn_1_1_N = mkN "motläsande" ;
  motorbraensle_nn_1_1_N = mkN "motorbränsle" ;
  motoriserande_nn_1_N = mkN "motoriserande" ;
  motsatsfoerhaallande_nn_1_1_N = mkN "motsatsförhållande" ;
  motseende_nn_1_N = mkN "motseende" ;
  motstycke_nn_1_N = mkN "motstycke" ;
  motstaaende_nn_1_1_N = mkN "motstående" ;
  motstaandsnaeste_nn_1_1_N = mkN "motståndsnäste" ;
  motstaandsomraade_nn_1_1_N = mkN "motståndsområde" ;
  motsvarande_nn_1_N = mkN "motsvarande" ;
  motsaegande_nn_1_1_N = mkN "motsägande" ;
  mottagande_nn_1_N = mkN "mottagande" ;
  motverkande_nn_1_N = mkN "motverkande" ;
  motvaegande_nn_1_1_N = mkN "motvägande" ;
  mousserande_nn_1_N = mkN "mousserande" ;
  muckande_nn_1_N = mkN "muckande" ;
  muddrande_nn_1_N = mkN "muddrande" ;
  mulande_nn_1_N = mkN "mulande" ;
  mulbete_nn_1_N = mkN "mulbete" ;
  muljerande_nn_1_N = mkN "muljerande" ;
  mullrande_nn_1_N = mkN "mullrande" ;
  mullvadsarbete_nn_1_N = mkN "mullvadsarbete" ;
  mulnande_nn_1_N = mkN "mulnande" ;
  multiplicerande_nn_1_N = mkN "multiplicerande" ;
  multnande_nn_1_N = mkN "multnande" ;
  mumifierande_nn_1_N = mkN "mumifierande" ;
  mumlande_nn_1_N = mkN "mumlande" ;
  mumsande_nn_1_N = mkN "mumsande" ;
  municipalsamhaelle_nn_1_1_N = mkN "municipalsamhälle" ;
  munkabaelte_nn_1_1_N = mkN "munkabälte" ;
  munkloefte_nn_1_1_N = mkN "munklöfte" ;
  munstycke_nn_1_N = mkN "munstycke" ;
  munstycksbyte_nn_1_N = mkN "munstycksbyte" ;
  murande_nn_1_N = mkN "murande" ;
  murknande_nn_1_N = mkN "murknande" ;
  murrande_nn_1_N = mkN "murrande" ;
  musicerande_nn_1_N = mkN "musicerande" ;
  musikstycke_nn_1_N = mkN "musikstycke" ;
  muskelarbete_nn_1_N = mkN "muskelarbete" ;
  muskelknippe_nn_1_N = mkN "muskelknippe" ;
  muskelsinne_nn_1_N = mkN "muskelsinne" ;
  musserande_nn_1_N = mkN "musserande" ;
  mutande_nn_1_N = mkN "mutande" ;
  muterande_nn_1_N = mkN "muterande" ;
  muttrande_nn_1_N = mkN "muttrande" ;
  myglande_nn_1_N = mkN "myglande" ;
  myllande_nn_1_N = mkN "myllande" ;
  myllrande_nn_1_N = mkN "myllrande" ;
  mynnande_nn_1_N = mkN "mynnande" ;
  myntande_nn_1_N = mkN "myntande" ;
  myrsamhaelle_nn_1_1_N = mkN "myrsamhälle" ;
  mysande_nn_1_N = mkN "mysande" ;
  mystifierande_nn_1_N = mkN "mystifierande" ;
  maeklande_nn_1_1_N = mkN "mäklande" ;
  maeklararvode_nn_1_1_N = mkN "mäklararvode" ;
  maektande_nn_1_1_N = mkN "mäktande" ;
  maelande_nn_1_1_N = mkN "mälande" ;
  maeltande_nn_1_1_N = mkN "mältande" ;
  maengande_nn_1_1_N = mkN "mängande" ;
  maenniskoansikte_nn_1_1_N = mkN "människoansikte" ;
  maenniskoslaekte_nn_1_1_N = mkN "människosläkte" ;
  maenniskovaerde_nn_1_1_N = mkN "människovärde" ;
  maenniskooede_nn_1_1_N = mkN "människoöde" ;
  maerglande_nn_1_1_N = mkN "märglande" ;
  maerkande_nn_1_1_N = mkN "märkande" ;
  maerke_nn_1_1_N = mkN "märke" ;
  maerksnoere_nn_1_1_N = mkN "märksnöre" ;
  maeskande_nn_1_1_N = mkN "mäskande" ;
  maessande_nn_1_1_N = mkN "mässande" ;
  maessingsknaeppe_nn_1_1_N = mkN "mässingsknäppe" ;
  maesterstycke_nn_1_1_N = mkN "mästerstycke" ;
  maestrande_nn_1_1_N = mkN "mästrande" ;
  maetande_nn_1_1_N = mkN "mätande" ;
  maetomraade_nn_1_1_N = mkN "mätområde" ;
  maettande_nn_1_1_N = mkN "mättande" ;
  maetvaerde_nn_1_1_N = mkN "mätvärde" ;
  maaende_nn_1_1_N = mkN "mående" ;
  maalande_nn_1_1_N = mkN "målande" ;
  maaleriarbete_nn_1_1_N = mkN "måleriarbete" ;
  maalningsarbete_nn_1_1_N = mkN "målningsarbete" ;
  maalomraade_nn_1_1_N = mkN "målområde" ;
  maalskytte_nn_1_1_N = mkN "målskytte" ;
  maalsnoere_nn_1_1_N = mkN "målsnöre" ;
  maalsaegarbitraede_nn_1_1_N = mkN "målsägarbiträde" ;
  maanadsskifte_nn_1_1_N = mkN "månadsskifte" ;
  maanande_nn_1_1_N = mkN "månande" ;
  maanansikte_nn_1_1_N = mkN "månansikte" ;
  maangdubblande_nn_1_1_N = mkN "mångdubblande" ;
  maangfaldigande_nn_1_1_N = mkN "mångfaldigande" ;
  maanglande_nn_1_1_N = mkN "månglande" ;
  maanskifte_nn_1_1_N = mkN "månskifte" ;
  maaste_nn_1_1_N = mkN "måste" ;
  maattande_nn_1_1_N = mkN "måttande" ;
  moeblerande_nn_1_1_N = mkN "möblerande" ;
  moeglande_nn_1_1_N = mkN "möglande" ;
  moejliggoerande_nn_1_1_N = mkN "möjliggörande" ;
  moenstersamhaelle_nn_1_1_N = mkN "mönstersamhälle" ;
  moenstrande_nn_1_1_N = mkN "mönstrande" ;
  moerande_nn_1_1_N = mkN "mörande" ;
  moerbultande_nn_1_1_N = mkN "mörbultande" ;
  moerdande_nn_1_1_N = mkN "mördande" ;
  moerkande_nn_1_1_N = mkN "mörkande" ;
  moerklaeggande_nn_1_1_N = mkN "mörkläggande" ;
  moerknande_nn_1_1_N = mkN "mörknande" ;
  moetande_nn_1_1_N = mkN "mötande" ;
  moete_nn_1_1_N = mkN "möte" ;
  nackande_nn_1_N = mkN "nackande" ;
  nafsande_nn_1_N = mkN "nafsande" ;
  nagelfarande_nn_1_N = mkN "nagelfarande" ;
  nagelklippningsloefte_nn_1_1_N = mkN "nagelklippningslöfte" ;
  naggande_nn_1_N = mkN "naggande" ;
  naglande_nn_1_N = mkN "naglande" ;
  najande_nn_1_N = mkN "najande" ;
  nallande_nn_1_N = mkN "nallande" ;
  namnande_nn_1_N = mkN "namnande" ;
  namnbyte_nn_1_N = mkN "namnbyte" ;
  namnfaestande_nn_1_1_N = mkN "namnfästande" ;
  namngivande_nn_1_N = mkN "namngivande" ;
  namnvaerde_nn_1_1_N = mkN "namnvärde" ;
  nappande_nn_1_N = mkN "nappande" ;
  narande_nn_1_N = mkN "narande" ;
  narkotikaberoende_nn_1_N = mkN "narkotikaberoende" ;
  narrande_nn_1_N = mkN "narrande" ;
  narvande_nn_1_N = mkN "narvande" ;
  nasalerande_nn_1_N = mkN "nasalerande" ;
  nasaliserande_nn_1_N = mkN "nasaliserande" ;
  nasande_nn_1_N = mkN "nasande" ;
  nationaldagsfirande_nn_1_N = mkN "nationaldagsfirande" ;
  nationalgarde_nn_1_N = mkN "nationalgarde" ;
  nationaliserande_nn_1_N = mkN "nationaliserande" ;
  nationalitetsmaerke_nn_1_1_N = mkN "nationalitetsmärke" ;
  nationalitetsstraevande_nn_1_1_N = mkN "nationalitetssträvande" ;
  nationalmedvetande_nn_1_N = mkN "nationalmedvetande" ;
  nationsbygge_nn_1_N = mkN "nationsbygge" ;
  nattande_nn_1_N = mkN "nattande" ;
  nattarbete_nn_1_N = mkN "nattarbete" ;
  nattlinne_nn_1_N = mkN "nattlinne" ;
  nattsikte_nn_1_N = mkN "nattsikte" ;
  naturaliserande_nn_1_N = mkN "naturaliserande" ;
  naturminne_nn_1_N = mkN "naturminne" ;
  naturminnesmaerke_nn_1_1_N = mkN "naturminnesmärke" ;
  navelskaadande_nn_1_1_N = mkN "navelskådande" ;
  navigerande_nn_1_N = mkN "navigerande" ;
  navlande_nn_1_N = mkN "navlande" ;
  nedarbetande_nn_1_N = mkN "nedarbetande" ;
  nedblaasande_nn_1_1_N = mkN "nedblåsande" ;
  nedbringande_nn_1_N = mkN "nedbringande" ;
  nedbrytande_nn_1_N = mkN "nedbrytande" ;
  nederboerdsomraade_nn_1_1_N = mkN "nederbördsområde" ;
  nedfrysande_nn_1_N = mkN "nedfrysande" ;
  nedgraevande_nn_1_1_N = mkN "nedgrävande" ;
  nedgoerande_nn_1_1_N = mkN "nedgörande" ;
  nedisande_nn_1_N = mkN "nedisande" ;
  nedkallande_nn_1_N = mkN "nedkallande" ;
  nedkastande_nn_1_N = mkN "nedkastande" ;
  nedkavlande_nn_1_N = mkN "nedkavlande" ;
  nedklassande_nn_1_N = mkN "nedklassande" ;
  nedkommande_nn_1_N = mkN "nedkommande" ;
  nedlaeggande_nn_1_1_N = mkN "nedläggande" ;
  nedrustande_nn_1_N = mkN "nedrustande" ;
  nedsaltande_nn_1_N = mkN "nedsaltande" ;
  nedskrivande_nn_1_N = mkN "nedskrivande" ;
  nedslaaende_nn_1_1_N = mkN "nedslående" ;
  nedstigande_nn_1_N = mkN "nedstigande" ;
  nedsaenkande_nn_1_1_N = mkN "nedsänkande" ;
  nedsaettande_nn_1_1_N = mkN "nedsättande" ;
  nedtecknande_nn_1_N = mkN "nedtecknande" ;
  nedtransformerande_nn_1_N = mkN "nedtransformerande" ;
  nedtransponerande_nn_1_N = mkN "nedtransponerande" ;
  nedtrappande_nn_1_N = mkN "nedtrappande" ;
  nedvaerderande_nn_1_1_N = mkN "nedvärderande" ;
  negerande_nn_1_N = mkN "negerande" ;
  negligerande_nn_1_N = mkN "negligerande" ;
  negocierande_nn_1_N = mkN "negocierande" ;
  negotierande_nn_1_N = mkN "negotierande" ;
  nekande_nn_1_N = mkN "nekande" ;
  nerarbetande_nn_1_N = mkN "nerarbetande" ;
  nerblaasande_nn_1_1_N = mkN "nerblåsande" ;
  nerbringande_nn_1_N = mkN "nerbringande" ;
  nerbrytande_nn_1_N = mkN "nerbrytande" ;
  nerfrysande_nn_1_N = mkN "nerfrysande" ;
  nergoerande_nn_1_1_N = mkN "nergörande" ;
  nerisande_nn_1_N = mkN "nerisande" ;
  nerkallande_nn_1_N = mkN "nerkallande" ;
  nerkastande_nn_1_N = mkN "nerkastande" ;
  nerkavlande_nn_1_N = mkN "nerkavlande" ;
  nerklassande_nn_1_N = mkN "nerklassande" ;
  nerkommande_nn_1_N = mkN "nerkommande" ;
  nerlaeggande_nn_1_1_N = mkN "nerläggande" ;
  nerrustande_nn_1_N = mkN "nerrustande" ;
  nersaltande_nn_1_N = mkN "nersaltande" ;
  nerskrivande_nn_1_N = mkN "nerskrivande" ;
  nerslaaende_nn_1_1_N = mkN "nerslående" ;
  nerstigande_nn_1_N = mkN "nerstigande" ;
  nersaenkande_nn_1_1_N = mkN "nersänkande" ;
  nersaettande_nn_1_1_N = mkN "nersättande" ;
  nertecknande_nn_1_N = mkN "nertecknande" ;
  nertransformerande_nn_1_N = mkN "nertransformerande" ;
  nertransponerande_nn_1_N = mkN "nertransponerande" ;
  nertrappande_nn_1_N = mkN "nertrappande" ;
  nervknippe_nn_1_N = mkN "nervknippe" ;
  nervaerderande_nn_1_1_N = mkN "nervärderande" ;
  nettosparande_nn_1_N = mkN "nettosparande" ;
  neutraliserande_nn_1_N = mkN "neutraliserande" ;
  neutrallaege_nn_1_1_N = mkN "neutralläge" ;
  niande_nn_1_N = mkN "niande" ;
  nickande_nn_1_N = mkN "nickande" ;
  niellerande_nn_1_N = mkN "niellerande" ;
  nigande_nn_1_N = mkN "nigande" ;
  nitande_nn_1_N = mkN "nitande" ;
  nitrerande_nn_1_N = mkN "nitrerande" ;
  nitaelskande_nn_1_1_N = mkN "nitälskande" ;
  nivellerande_nn_1_N = mkN "nivellerande" ;
  nivaagrupperande_nn_1_1_N = mkN "nivågrupperande" ;
  njurbaelte_nn_1_1_N = mkN "njurbälte" ;
  njutande_nn_1_N = mkN "njutande" ;
  nobbande_nn_1_N = mkN "nobbande" ;
  nobiliserande_nn_1_N = mkN "nobiliserande" ;
  nockande_nn_1_N = mkN "nockande" ;
  nojsande_nn_1_N = mkN "nojsande" ;
  nollande_nn_1_N = mkN "nollande" ;
  nollstaellande_nn_1_1_N = mkN "nollställande" ;
  nollstaelle_nn_1_1_N = mkN "nollställe" ;
  nolltaxerande_nn_1_N = mkN "nolltaxerande" ;
  nollaege_nn_1_1_N = mkN "nolläge" ;
  nomadiserande_nn_1_N = mkN "nomadiserande" ;
  nominalvaerde_nn_1_1_N = mkN "nominalvärde" ;
  nominerande_nn_1_N = mkN "nominerande" ;
  nonchalerande_nn_1_N = mkN "nonchalerande" ;
  noppande_nn_1_N = mkN "noppande" ;
  normaliserande_nn_1_N = mkN "normaliserande" ;
  normerande_nn_1_N = mkN "normerande" ;
  norpande_nn_1_N = mkN "norpande" ;
  nosande_nn_1_N = mkN "nosande" ;
  notande_nn_1_N = mkN "notande" ;
  noterande_nn_1_N = mkN "noterande" ;
  notificerande_nn_1_N = mkN "notificerande" ;
  notifierande_nn_1_N = mkN "notifierande" ;
  notiserande_nn_1_N = mkN "notiserande" ;
  nubbande_nn_1_N = mkN "nubbande" ;
  nuddande_nn_1_N = mkN "nuddande" ;
  numrerande_nn_1_N = mkN "numrerande" ;
  nyanlaeggande_nn_1_1_N = mkN "nyanläggande" ;
  nyanserande_nn_1_N = mkN "nyanserande" ;
  nyanskaffande_nn_1_N = mkN "nyanskaffande" ;
  nyanstaellande_nn_1_1_N = mkN "nyanställande" ;
  nybygge_nn_1_N = mkN "nybygge" ;
  nyckelaemne_nn_1_1_N = mkN "nyckelämne" ;
  nydanande_nn_1_N = mkN "nydanande" ;
  nyemitterande_nn_1_N = mkN "nyemitterande" ;
  nyetablerande_nn_1_N = mkN "nyetablerande" ;
  nyinvesterande_nn_1_N = mkN "nyinvesterande" ;
  nylle_nn_1_N = mkN "nylle" ;
  nylonsnoere_nn_1_1_N = mkN "nylonsnöre" ;
  nynnande_nn_1_N = mkN "nynnande" ;
  nypande_nn_1_N = mkN "nypande" ;
  nyplanterande_nn_1_N = mkN "nyplanterande" ;
  nystande_nn_1_N = mkN "nystande" ;
  nytecknande_nn_1_N = mkN "nytecknande" ;
  nyttande_nn_1_N = mkN "nyttande" ;
  nyttiggoerande_nn_1_1_N = mkN "nyttiggörande" ;
  nyttjande_nn_1_N = mkN "nyttjande" ;
  nyvaerde_nn_1_1_N = mkN "nyvärde" ;
  nyaarsloefte_nn_1_1_N = mkN "nyårslöfte" ;
  naemnande_nn_1_1_N = mkN "nämnande" ;
  naepsande_nn_1_1_N = mkN "näpsande" ;
  naerande_nn_1_1_N = mkN "närande" ;
  naerboende_nn_1_1_N = mkN "närboende" ;
  naeringsstaelle_nn_1_1_N = mkN "näringsställe" ;
  naeringsvaerde_nn_1_1_N = mkN "näringsvärde" ;
  naeringsaemne_nn_1_1_N = mkN "näringsämne" ;
  naermande_nn_1_1_N = mkN "närmande" ;
  naermevaerde_nn_1_1_N = mkN "närmevärde" ;
  naeromraade_nn_1_1_N = mkN "närområde" ;
  naersamhaelle_nn_1_1_N = mkN "närsamhälle" ;
  naerslutande_nn_1_1_N = mkN "närslutande" ;
  naervarande_nn_1_1_N = mkN "närvarande" ;
  naestande_nn_1_1_N = mkN "nästande" ;
  naeste_nn_1_1_N = mkN "näste" ;
  naetande_nn_1_1_N = mkN "nätande" ;
  naethandlande_nn_1_1_N = mkN "näthandlande" ;
  naadande_nn_1_1_N = mkN "nådande" ;
  naadevedermaele_nn_1_1_N = mkN "nådevedermäle" ;
  naaende_nn_1_1_N = mkN "nående" ;
  naalande_nn_1_1_N = mkN "nålande" ;
  naatande_nn_1_1_N = mkN "nåtande" ;
  naatlande_nn_1_1_N = mkN "nåtlande" ;
  noedbromsande_nn_1_1_N = mkN "nödbromsande" ;
  noedgande_nn_1_1_N = mkN "nödgande" ;
  noedlandande_nn_1_1_N = mkN "nödlandande" ;
  noedlaege_nn_1_1_N = mkN "nödläge" ;
  noedsakande_nn_1_1_N = mkN "nödsakande" ;
  noedsignalerande_nn_1_1_N = mkN "nödsignalerande" ;
  noedstoppande_nn_1_1_N = mkN "nödstoppande" ;
  noedoeppnande_nn_1_1_N = mkN "nödöppnande" ;
  noeje_nn_1_1_N = mkN "nöje" ;
  noetande_nn_1_1_N = mkN "nötande" ;
  noetknaepparansikte_nn_1_1_N = mkN "nötknäpparansikte" ;
  obducerande_nn_1_N = mkN "obducerande" ;
  objektiverande_nn_1_N = mkN "objektiverande" ;
  obligerande_nn_1_N = mkN "obligerande" ;
  observerande_nn_1_N = mkN "observerande" ;
  obstruerande_nn_1_N = mkN "obstruerande" ;
  occidentaliserande_nn_1_N = mkN "occidentaliserande" ;
  ockrande_nn_1_N = mkN "ockrande" ;
  ockuperande_nn_1_N = mkN "ockuperande" ;
  ode_nn_1_N = mkN "ode" ;
  odlande_nn_1_N = mkN "odlande" ;
  offentliggoerande_nn_1_1_N = mkN "offentliggörande" ;
  offererande_nn_1_N = mkN "offererande" ;
  officierande_nn_1_N = mkN "officierande" ;
  offrande_nn_1_N = mkN "offrande" ;
  ofredande_nn_1_N = mkN "ofredande" ;
  ogillande_nn_1_N = mkN "ogillande" ;
  ojande_nn_1_N = mkN "ojande" ;
  okande_nn_1_N = mkN "okande" ;
  oktanvaerde_nn_1_1_N = mkN "oktanvärde" ;
  oktaverande_nn_1_N = mkN "oktaverande" ;
  oktrojerande_nn_1_N = mkN "oktrojerande" ;
  okulerande_nn_1_N = mkN "okulerande" ;
  okvaedande_nn_1_1_N = mkN "okvädande" ;
  okvaede_nn_1_1_N = mkN "okväde" ;
  olande_nn_1_N = mkN "olande" ;
  oljande_nn_1_N = mkN "oljande" ;
  oljebyte_nn_1_N = mkN "oljebyte" ;
  oljebaelte_nn_1_1_N = mkN "oljebälte" ;
  ollande_nn_1_N = mkN "ollande" ;
  olyckstillfaelle_nn_1_1_N = mkN "olyckstillfälle" ;
  olycksoede_nn_1_1_N = mkN "olycksöde" ;
  omarbetande_nn_1_N = mkN "omarbetande" ;
  ombedjande_nn_1_N = mkN "ombedjande" ;
  ombestyrande_nn_1_N = mkN "ombestyrande" ;
  ombesoerjande_nn_1_1_N = mkN "ombesörjande" ;
  ombetroende_nn_1_N = mkN "ombetroende" ;
  ombildande_nn_1_N = mkN "ombildande" ;
  ombrytande_nn_1_N = mkN "ombrytande" ;
  ombyggande_nn_1_N = mkN "ombyggande" ;
  ombyte_nn_1_N = mkN "ombyte" ;
  omdanande_nn_1_N = mkN "omdanande" ;
  omdirigerande_nn_1_N = mkN "omdirigerande" ;
  omdoeme_nn_1_1_N = mkN "omdöme" ;
  omfamnande_nn_1_N = mkN "omfamnande" ;
  omfattande_nn_1_N = mkN "omfattande" ;
  omformande_nn_1_N = mkN "omformande" ;
  omfoerande_nn_1_1_N = mkN "omförande" ;
  omfoerdelande_nn_1_1_N = mkN "omfördelande" ;
  omfoerhandlande_nn_1_1_N = mkN "omförhandlande" ;
  omfoermaelande_nn_1_1_N = mkN "omförmälande" ;
  omgestaltande_nn_1_N = mkN "omgestaltande" ;
  omgivande_nn_1_N = mkN "omgivande" ;
  omgaerdande_nn_1_1_N = mkN "omgärdande" ;
  omhuldande_nn_1_N = mkN "omhuldande" ;
  omhaegnande_nn_1_1_N = mkN "omhägnande" ;
  omhaektande_nn_1_1_N = mkN "omhäktande" ;
  omhaenderhavande_nn_1_1_N = mkN "omhänderhavande" ;
  omhaendertagande_nn_1_1_N = mkN "omhändertagande" ;
  omhaenge_nn_1_1_N = mkN "omhänge" ;
  omhoeljande_nn_1_1_N = mkN "omhöljande" ;
  omintetgoerande_nn_1_1_N = mkN "omintetgörande" ;
  omkastande_nn_1_N = mkN "omkastande" ;
  omklaedande_nn_1_1_N = mkN "omklädande" ;
  omklaedningsutrymme_nn_1_1_N = mkN "omklädningsutrymme" ;
  omklaeende_nn_1_1_N = mkN "omkläende" ;
  omkommande_nn_1_N = mkN "omkommande" ;
  omkransande_nn_1_N = mkN "omkransande" ;
  omkretsande_nn_1_N = mkN "omkretsande" ;
  omkvaede_nn_1_1_N = mkN "omkväde" ;
  omkoerande_nn_1_1_N = mkN "omkörande" ;
  ommoeblerande_nn_1_1_N = mkN "ommöblerande" ;
  omnaemnande_nn_1_1_N = mkN "omnämnande" ;
  omorganiserande_nn_1_N = mkN "omorganiserande" ;
  omplacerande_nn_1_N = mkN "omplacerande" ;
  omplaastrande_nn_1_1_N = mkN "omplåstrande" ;
  omproevande_nn_1_1_N = mkN "omprövande" ;
  omramande_nn_1_N = mkN "omramande" ;
  omringande_nn_1_N = mkN "omringande" ;
  omraeknande_nn_1_1_N = mkN "omräknande" ;
  omraade_nn_1_1_N = mkN "område" ;
  omseende_nn_1_N = mkN "omseende" ;
  omskapande_nn_1_N = mkN "omskapande" ;
  omskolande_nn_1_N = mkN "omskolande" ;
  omskrivande_nn_1_N = mkN "omskrivande" ;
  omskulpturerande_nn_1_N = mkN "omskulpturerande" ;
  omskaerande_nn_1_1_N = mkN "omskärande" ;
  omskoetande_nn_1_1_N = mkN "omskötande" ;
  omslingrande_nn_1_N = mkN "omslingrande" ;
  omslutande_nn_1_N = mkN "omslutande" ;
  omspinnande_nn_1_N = mkN "omspinnande" ;
  omspaennande_nn_1_1_N = mkN "omspännande" ;
  omstrukturerande_nn_1_N = mkN "omstrukturerande" ;
  omstraalande_nn_1_1_N = mkN "omstrålande" ;
  omstaellande_nn_1_1_N = mkN "omställande" ;
  omstoepande_nn_1_1_N = mkN "omstöpande" ;
  omstoertande_nn_1_1_N = mkN "omstörtande" ;
  omsvepande_nn_1_N = mkN "omsvepande" ;
  omsvaermande_nn_1_1_N = mkN "omsvärmande" ;
  omsaettande_nn_1_1_N = mkN "omsättande" ;
  omtagande_nn_1_N = mkN "omtagande" ;
  omtalande_nn_1_N = mkN "omtalande" ;
  omtolkande_nn_1_N = mkN "omtolkande" ;
  omvandlande_nn_1_N = mkN "omvandlande" ;
  omvittnande_nn_1_N = mkN "omvittnande" ;
  omvaeljande_nn_1_1_N = mkN "omväljande" ;
  omvaelvande_nn_1_1_N = mkN "omvälvande" ;
  omvaendande_nn_1_1_N = mkN "omvändande" ;
  omvaerderande_nn_1_1_N = mkN "omvärderande" ;
  omvaervande_nn_1_1_N = mkN "omvärvande" ;
  omvaexlande_nn_1_1_N = mkN "omväxlande" ;
  omyndigfoerklarande_nn_1_1_N = mkN "omyndigförklarande" ;
  omaendrande_nn_1_1_N = mkN "omändrande" ;
  omoejliggoerande_nn_1_1_N = mkN "omöjliggörande" ;
  onanerande_nn_1_N = mkN "onanerande" ;
  onaniserande_nn_1_N = mkN "onaniserande" ;
  ondulerande_nn_1_N = mkN "ondulerande" ;
  operadike_nn_1_N = mkN "operadike" ;
  operationaliserande_nn_1_N = mkN "operationaliserande" ;
  opererande_nn_1_N = mkN "opererande" ;
  opinerande_nn_1_N = mkN "opinerande" ;
  oppammande_nn_1_N = mkN "oppammande" ;
  opparbetande_nn_1_N = mkN "opparbetande" ;
  oppassande_nn_1_N = mkN "oppassande" ;
  oppassningsstaelle_nn_1_1_N = mkN "oppassningsställe" ;
  oppblandande_nn_1_N = mkN "oppblandande" ;
  oppbringande_nn_1_N = mkN "oppbringande" ;
  oppdagande_nn_1_N = mkN "oppdagande" ;
  oppdaterande_nn_1_N = mkN "oppdaterande" ;
  oppdelande_nn_1_N = mkN "oppdelande" ;
  oppdrivande_nn_1_N = mkN "oppdrivande" ;
  oppeggande_nn_1_N = mkN "oppeggande" ;
  oppfattande_nn_1_N = mkN "oppfattande" ;
  oppfinnande_nn_1_N = mkN "oppfinnande" ;
  oppfostrande_nn_1_N = mkN "oppfostrande" ;
  oppfriskande_nn_1_N = mkN "oppfriskande" ;
  oppfyllande_nn_1_N = mkN "oppfyllande" ;
  oppfaangande_nn_1_1_N = mkN "oppfångande" ;
  oppfoedande_nn_1_1_N = mkN "oppfödande" ;
  opphetsande_nn_1_N = mkN "opphetsande" ;
  opphettande_nn_1_N = mkN "opphettande" ;
  opphittande_nn_1_N = mkN "opphittande" ;
  opphottande_nn_1_N = mkN "opphottande" ;
  opphaemtande_nn_1_1_N = mkN "opphämtande" ;
  opphaevande_nn_1_1_N = mkN "opphävande" ;
  opphoejande_nn_1_1_N = mkN "opphöjande" ;
  opphoerande_nn_1_1_N = mkN "opphörande" ;
  oppiggande_nn_1_N = mkN "oppiggande" ;
  oppjusterande_nn_1_N = mkN "oppjusterande" ;
  oppkallande_nn_1_N = mkN "oppkallande" ;
  oppklarande_nn_1_N = mkN "oppklarande" ;
  opplivande_nn_1_N = mkN "opplivande" ;
  opplaeggande_nn_1_1_N = mkN "oppläggande" ;
  opplaesande_nn_1_1_N = mkN "oppläsande" ;
  oppmuntrande_nn_1_N = mkN "oppmuntrande" ;
  opponerande_nn_1_N = mkN "opponerande" ;
  oppradande_nn_1_N = mkN "oppradande" ;
  opprensande_nn_1_N = mkN "opprensande" ;
  oppraeknande_nn_1_1_N = mkN "oppräknande" ;
  oppraettande_nn_1_1_N = mkN "opprättande" ;
  oppsamlande_nn_1_N = mkN "oppsamlande" ;
  oppskjutande_nn_1_N = mkN "oppskjutande" ;
  oppsnabbande_nn_1_N = mkN "oppsnabbande" ;
  oppstaellande_nn_1_1_N = mkN "oppställande" ;
  oppsugande_nn_1_N = mkN "oppsugande" ;
  oppsummerande_nn_1_N = mkN "oppsummerande" ;
  oppsaettande_nn_1_1_N = mkN "oppsättande" ;
  oppsoekande_nn_1_1_N = mkN "oppsökande" ;
  opptagande_nn_1_N = mkN "opptagande" ;
  opptornande_nn_1_N = mkN "opptornande" ;
  opptrappande_nn_1_N = mkN "opptrappande" ;
  opptrissande_nn_1_N = mkN "opptrissande" ;
  oppvaktande_nn_1_N = mkN "oppvaktande" ;
  oppvisande_nn_1_N = mkN "oppvisande" ;
  oppvaegande_nn_1_1_N = mkN "oppvägande" ;
  oppvaerderande_nn_1_1_N = mkN "oppvärderande" ;
  oppvaexande_nn_1_1_N = mkN "oppväxande" ;
  oppaetande_nn_1_1_N = mkN "oppätande" ;
  oppoevande_nn_1_1_N = mkN "oppövande" ;
  opterande_nn_1_N = mkN "opterande" ;
  optimerande_nn_1_N = mkN "optimerande" ;
  ordande_nn_1_N = mkN "ordande" ;
  ordbyte_nn_1_N = mkN "ordbyte" ;
  ordfloede_nn_1_1_N = mkN "ordflöde" ;
  ordinariesaettande_nn_1_1_N = mkN "ordinariesättande" ;
  ordinerande_nn_1_N = mkN "ordinerande" ;
  ordnande_nn_1_N = mkN "ordnande" ;
  ordningssinne_nn_1_N = mkN "ordningssinne" ;
  ordskifte_nn_1_N = mkN "ordskifte" ;
  oredande_nn_1_N = mkN "oredande" ;
  orenande_nn_1_N = mkN "orenande" ;
  orerande_nn_1_N = mkN "orerande" ;
  organisationsarbete_nn_1_N = mkN "organisationsarbete" ;
  organiserande_nn_1_N = mkN "organiserande" ;
  orgelstycke_nn_1_N = mkN "orgelstycke" ;
  orienterande_nn_1_N = mkN "orienterande" ;
  orienteringsaemne_nn_1_1_N = mkN "orienteringsämne" ;
  orkande_nn_1_N = mkN "orkande" ;
  orkesterdike_nn_1_N = mkN "orkesterdike" ;
  orkesterstycke_nn_1_N = mkN "orkesterstycke" ;
  orkestrerande_nn_1_N = mkN "orkestrerande" ;
  ormande_nn_1_N = mkN "ormande" ;
  ornamenterande_nn_1_N = mkN "ornamenterande" ;
  ornerande_nn_1_N = mkN "ornerande" ;
  oroande_nn_1_N = mkN "oroande" ;
  orsakande_nn_1_N = mkN "orsakande" ;
  osande_nn_1_N = mkN "osande" ;
  oscillerande_nn_1_N = mkN "oscillerande" ;
  oskadliggoerande_nn_1_1_N = mkN "oskadliggörande" ;
  oskaerande_nn_1_1_N = mkN "oskärande" ;
  osnyggande_nn_1_N = mkN "osnyggande" ;
  osynliggoerande_nn_1_1_N = mkN "osynliggörande" ;
  osaekrande_nn_1_1_N = mkN "osäkrande" ;
  outande_nn_1_N = mkN "outande" ;
  oxiderande_nn_1_N = mkN "oxiderande" ;
  pH_vaerde_nn_1_1_N = mkN "pH-värde" ;
  pacificerande_nn_1_N = mkN "pacificerande" ;
  packande_nn_1_N = mkN "packande" ;
  paginerande_nn_1_N = mkN "paginerande" ;
  pajande_nn_1_N = mkN "pajande" ;
  paketerande_nn_1_N = mkN "paketerande" ;
  palataliserande_nn_1_N = mkN "palataliserande" ;
  paljetterande_nn_1_N = mkN "paljetterande" ;
  pallande_nn_1_N = mkN "pallande" ;
  palmande_nn_1_N = mkN "palmande" ;
  palperande_nn_1_N = mkN "palperande" ;
  panelande_nn_1_N = mkN "panelande" ;
  panerande_nn_1_N = mkN "panerande" ;
  pangande_nn_1_N = mkN "pangande" ;
  panorerande_nn_1_N = mkN "panorerande" ;
  pansarregemente_nn_1_N = mkN "pansarregemente" ;
  pansrande_nn_1_N = mkN "pansrande" ;
  pantande_nn_1_N = mkN "pantande" ;
  pantfoerskrivande_nn_1_1_N = mkN "pantförskrivande" ;
  pantograferande_nn_1_N = mkN "pantograferande" ;
  pantsaettande_nn_1_1_N = mkN "pantsättande" ;
  pappersarbete_nn_1_N = mkN "pappersarbete" ;
  papperssnoere_nn_1_1_N = mkN "papperssnöre" ;
  paraderande_nn_1_N = mkN "paraderande" ;
  paradigmskifte_nn_1_N = mkN "paradigmskifte" ;
  paradisaepple_nn_1_1_N = mkN "paradisäpple" ;
  paraferande_nn_1_N = mkN "paraferande" ;
  paraffinerande_nn_1_N = mkN "paraffinerande" ;
  parafraserande_nn_1_N = mkN "parafraserande" ;
  parallelliserande_nn_1_N = mkN "parallelliserande" ;
  parallellkopplande_nn_1_N = mkN "parallellkopplande" ;
  paralyserande_nn_1_N = mkN "paralyserande" ;
  parande_nn_1_N = mkN "parande" ;
  parasiterande_nn_1_N = mkN "parasiterande" ;
  parenterande_nn_1_N = mkN "parenterande" ;
  parerande_nn_1_N = mkN "parerande" ;
  parfymerande_nn_1_N = mkN "parfymerande" ;
  parfoerhaallande_nn_1_1_N = mkN "parförhållande" ;
  parismode_nn_1_N = mkN "parismode" ;
  parkerande_nn_1_N = mkN "parkerande" ;
  parketterande_nn_1_N = mkN "parketterande" ;
  parlamenterande_nn_1_N = mkN "parlamenterande" ;
  parlerande_nn_1_N = mkN "parlerande" ;
  parodierande_nn_1_N = mkN "parodierande" ;
  partajande_nn_1_N = mkN "partajande" ;
  partande_nn_1_N = mkN "partande" ;
  partiledarbyte_nn_1_N = mkN "partiledarbyte" ;
  partivaesende_nn_1_1_N = mkN "partiväsende" ;
  passagerarsaete_nn_1_1_N = mkN "passagerarsäte" ;
  passande_nn_1_N = mkN "passande" ;
  passerande_nn_1_N = mkN "passerande" ;
  passiverande_nn_1_N = mkN "passiverande" ;
  passiviserande_nn_1_N = mkN "passiviserande" ;
  pastorsaembete_nn_1_1_N = mkN "pastorsämbete" ;
  pastoeriserande_nn_1_1_N = mkN "pastöriserande" ;
  patenterande_nn_1_N = mkN "patenterande" ;
  patinerande_nn_1_N = mkN "patinerande" ;
  patronbaelte_nn_1_1_N = mkN "patronbälte" ;
  patrullerande_nn_1_N = mkN "patrullerande" ;
  pauperiserande_nn_1_N = mkN "pauperiserande" ;
  pausande_nn_1_N = mkN "pausande" ;
  pauserande_nn_1_N = mkN "pauserande" ;
  pauskommaterande_nn_1_N = mkN "pauskommaterande" ;
  paxande_nn_1_N = mkN "paxande" ;
  pejlande_nn_1_N = mkN "pejlande" ;
  pekande_nn_1_N = mkN "pekande" ;
  pelleterande_nn_1_N = mkN "pelleterande" ;
  pendlande_nn_1_N = mkN "pendlande" ;
  penetrerande_nn_1_N = mkN "penetrerande" ;
  penningfloede_nn_1_1_N = mkN "penningflöde" ;
  pensionerande_nn_1_N = mkN "pensionerande" ;
  pensionssparande_nn_1_N = mkN "pensionssparande" ;
  penslande_nn_1_N = mkN "penslande" ;
  peppande_nn_1_N = mkN "peppande" ;
  pepparsprejande_nn_1_N = mkN "pepparsprejande" ;
  pepprande_nn_1_N = mkN "pepprande" ;
  percipierande_nn_1_N = mkN "percipierande" ;
  perennerande_nn_1_N = mkN "perennerande" ;
  perforerande_nn_1_N = mkN "perforerande" ;
  periodiserande_nn_1_N = mkN "periodiserande" ;
  permanentande_nn_1_N = mkN "permanentande" ;
  permanentondulerande_nn_1_N = mkN "permanentondulerande" ;
  permitterande_nn_1_N = mkN "permitterande" ;
  permuterande_nn_1_N = mkN "permuterande" ;
  persiflerande_nn_1_N = mkN "persiflerande" ;
  personifierande_nn_1_N = mkN "personifierande" ;
  personkryssande_nn_1_N = mkN "personkryssande" ;
  perspektivskifte_nn_1_N = mkN "perspektivskifte" ;
  persvaderande_nn_1_N = mkN "persvaderande" ;
  perverterande_nn_1_N = mkN "perverterande" ;
  petande_nn_1_N = mkN "petande" ;
  petrifierande_nn_1_N = mkN "petrifierande" ;
  pickande_nn_1_N = mkN "pickande" ;
  piercingsmycke_nn_1_N = mkN "piercingsmycke" ;
  pikande_nn_1_N = mkN "pikande" ;
  pikerande_nn_1_N = mkN "pikerande" ;
  pilande_nn_1_N = mkN "pilande" ;
  pilkande_nn_1_N = mkN "pilkande" ;
  pillande_nn_1_N = mkN "pillande" ;
  pillrande_nn_1_N = mkN "pillrande" ;
  pimpande_nn_1_N = mkN "pimpande" ;
  pimplande_nn_1_N = mkN "pimplande" ;
  pinande_nn_1_N = mkN "pinande" ;
  pincerande_nn_1_N = mkN "pincerande" ;
  pinglande_nn_1_N = mkN "pinglande" ;
  pinkande_nn_1_N = mkN "pinkande" ;
  pinnande_nn_1_N = mkN "pinnande" ;
  pipande_nn_1_N = mkN "pipande" ;
  pippande_nn_1_N = mkN "pippande" ;
  pirkande_nn_1_N = mkN "pirkande" ;
  pirrande_nn_1_N = mkN "pirrande" ;
  piruetterande_nn_1_N = mkN "piruetterande" ;
  piskande_nn_1_N = mkN "piskande" ;
  pissande_nn_1_N = mkN "pissande" ;
  pivoterande_nn_1_N = mkN "pivoterande" ;
  pjollrande_nn_1_N = mkN "pjollrande" ;
  pjoskande_nn_1_N = mkN "pjoskande" ;
  pjunkande_nn_1_N = mkN "pjunkande" ;
  placerande_nn_1_N = mkN "placerande" ;
  pladdrande_nn_1_N = mkN "pladdrande" ;
  plagierande_nn_1_N = mkN "plagierande" ;
  planande_nn_1_N = mkN "planande" ;
  planerande_nn_1_N = mkN "planerande" ;
  plankande_nn_1_N = mkN "plankande" ;
  planlaeggande_nn_1_1_N = mkN "planläggande" ;
  plantande_nn_1_N = mkN "plantande" ;
  planterande_nn_1_N = mkN "planterande" ;
  plaskande_nn_1_N = mkN "plaskande" ;
  plastande_nn_1_N = mkN "plastande" ;
  platinerande_nn_1_N = mkN "platinerande" ;
  platsande_nn_1_N = mkN "platsande" ;
  pliggande_nn_1_N = mkN "pliggande" ;
  pliktande_nn_1_N = mkN "pliktande" ;
  pliktfaellande_nn_1_1_N = mkN "pliktfällande" ;
  plirande_nn_1_N = mkN "plirande" ;
  plisserande_nn_1_N = mkN "plisserande" ;
  plitande_nn_1_N = mkN "plitande" ;
  plockande_nn_1_N = mkN "plockande" ;
  plogande_nn_1_N = mkN "plogande" ;
  plomberande_nn_1_N = mkN "plomberande" ;
  plottande_nn_1_N = mkN "plottande" ;
  plottrande_nn_1_N = mkN "plottrande" ;
  pluggande_nn_1_N = mkN "pluggande" ;
  pluggaemne_nn_1_1_N = mkN "pluggämne" ;
  plumpande_nn_1_N = mkN "plumpande" ;
  plumsande_nn_1_N = mkN "plumsande" ;
  plundrande_nn_1_N = mkN "plundrande" ;
  plurrande_nn_1_N = mkN "plurrande" ;
  plussande_nn_1_N = mkN "plussande" ;
  plutande_nn_1_N = mkN "plutande" ;
  plysande_nn_1_N = mkN "plysande" ;
  plyte_nn_1_N = mkN "plyte" ;
  plaederande_nn_1_1_N = mkN "pläderande" ;
  plaegande_nn_1_1_N = mkN "plägande" ;
  plaeterande_nn_1_1_N = mkN "pläterande" ;
  plaagande_nn_1_1_N = mkN "plågande" ;
  plaastrande_nn_1_1_N = mkN "plåstrande" ;
  plaatande_nn_1_1_N = mkN "plåtande" ;
  ploejande_nn_1_1_N = mkN "plöjande" ;
  pocherande_nn_1_N = mkN "pocherande" ;
  pockande_nn_1_N = mkN "pockande" ;
  pointerande_nn_1_N = mkN "pointerande" ;
  pokeransikte_nn_1_N = mkN "pokeransikte" ;
  pokulerande_nn_1_N = mkN "pokulerande" ;
  polande_nn_1_N = mkN "polande" ;
  polariserande_nn_1_N = mkN "polariserande" ;
  polaromraade_nn_1_1_N = mkN "polarområde" ;
  polemiserande_nn_1_N = mkN "polemiserande" ;
  polerande_nn_1_N = mkN "polerande" ;
  polisanmaelande_nn_1_1_N = mkN "polisanmälande" ;
  polisarbete_nn_1_N = mkN "polisarbete" ;
  polisbevakande_nn_1_N = mkN "polisbevakande" ;
  polisingripande_nn_1_N = mkN "polisingripande" ;
  polisvaesende_nn_1_1_N = mkN "polisväsende" ;
  polisyrke_nn_1_N = mkN "polisyrke" ;
  polisaerende_nn_1_1_N = mkN "polisärende" ;
  politiserande_nn_1_N = mkN "politiserande" ;
  polletterande_nn_1_N = mkN "polletterande" ;
  pollinerande_nn_1_N = mkN "pollinerande" ;
  polstrande_nn_1_N = mkN "polstrande" ;
  pomaderande_nn_1_N = mkN "pomaderande" ;
  ponerande_nn_1_N = mkN "ponerande" ;
  poppande_nn_1_N = mkN "poppande" ;
  populariserande_nn_1_N = mkN "populariserande" ;
  porlande_nn_1_N = mkN "porlande" ;
  porrsurfande_nn_1_N = mkN "porrsurfande" ;
  portande_nn_1_N = mkN "portande" ;
  portfoerbjudande_nn_1_1_N = mkN "portförbjudande" ;
  portionerande_nn_1_N = mkN "portionerande" ;
  portraetterande_nn_1_1_N = mkN "porträtterande" ;
  portskrymsle_nn_1_N = mkN "portskrymsle" ;
  poserande_nn_1_N = mkN "poserande" ;
  postande_nn_1_N = mkN "postande" ;
  postdaterande_nn_1_N = mkN "postdaterande" ;
  posterande_nn_1_N = mkN "posterande" ;
  postponerande_nn_1_N = mkN "postponerande" ;
  postroestande_nn_1_1_N = mkN "poströstande" ;
  poststaemplande_nn_1_1_N = mkN "poststämplande" ;
  postulerande_nn_1_N = mkN "postulerande" ;
  poaengterande_nn_1_1_N = mkN "poängterande" ;
  praktiserande_nn_1_N = mkN "praktiserande" ;
  prasslande_nn_1_N = mkN "prasslande" ;
  pratande_nn_1_N = mkN "pratande" ;
  prebende_nn_1_N = mkN "prebende" ;
  preciserande_nn_1_N = mkN "preciserande" ;
  precisionsarbete_nn_1_N = mkN "precisionsarbete" ;
  predestinerande_nn_1_N = mkN "predestinerande" ;
  predicerande_nn_1_N = mkN "predicerande" ;
  predikande_nn_1_N = mkN "predikande" ;
  predisponerande_nn_1_N = mkN "predisponerande" ;
  predominerande_nn_1_N = mkN "predominerande" ;
  prefabricerande_nn_1_N = mkN "prefabricerande" ;
  prefererande_nn_1_N = mkN "prefererande" ;
  prefigerande_nn_1_N = mkN "prefigerande" ;
  prejande_nn_1_N = mkN "prejande" ;
  preludierande_nn_1_N = mkN "preludierande" ;
  premierande_nn_1_N = mkN "premierande" ;
  premiaerkoerande_nn_1_1_N = mkN "premiärkörande" ;
  prenumererande_nn_1_N = mkN "prenumererande" ;
  preparerande_nn_1_N = mkN "preparerande" ;
  presentande_nn_1_N = mkN "presentande" ;
  presenterande_nn_1_N = mkN "presenterande" ;
  preserverande_nn_1_N = mkN "preserverande" ;
  presidentstyre_nn_1_N = mkN "presidentstyre" ;
  presiderande_nn_1_N = mkN "presiderande" ;
  preskriberande_nn_1_N = mkN "preskriberande" ;
  pressande_nn_1_N = mkN "pressande" ;
  presslaeggande_nn_1_1_N = mkN "pressläggande" ;
  pressmeddelande_nn_1_N = mkN "pressmeddelande" ;
  pressmoete_nn_1_1_N = mkN "pressmöte" ;
  prestaverande_nn_1_N = mkN "prestaverande" ;
  presterande_nn_1_N = mkN "presterande" ;
  presumerande_nn_1_N = mkN "presumerande" ;
  pretenderande_nn_1_N = mkN "pretenderande" ;
  prickande_nn_1_N = mkN "prickande" ;
  primaerminne_nn_1_1_N = mkN "primärminne" ;
  prioriterande_nn_1_N = mkN "prioriterande" ;
  prisande_nn_1_N = mkN "prisande" ;
  prisbeloenande_nn_1_1_N = mkN "prisbelönande" ;
  prisgivande_nn_1_N = mkN "prisgivande" ;
  prismaerkande_nn_1_1_N = mkN "prismärkande" ;
  prisreglerande_nn_1_N = mkN "prisreglerande" ;
  prissaettande_nn_1_1_N = mkN "prissättande" ;
  privatiserande_nn_1_N = mkN "privatiserande" ;
  privilegierande_nn_1_N = mkN "privilegierande" ;
  proberande_nn_1_N = mkN "proberande" ;
  problematiserande_nn_1_N = mkN "problematiserande" ;
  procentande_nn_1_N = mkN "procentande" ;
  procentvaerde_nn_1_1_N = mkN "procentvärde" ;
  processande_nn_1_N = mkN "processande" ;
  producerande_nn_1_N = mkN "producerande" ;
  produktionsfoerhaallande_nn_1_1_N = mkN "produktionsförhållande" ;
  profanerande_nn_1_N = mkN "profanerande" ;
  professionaliserande_nn_1_N = mkN "professionaliserande" ;
  profeterande_nn_1_N = mkN "profeterande" ;
  profilerande_nn_1_N = mkN "profilerande" ;
  profiterande_nn_1_N = mkN "profiterande" ;
  prognostiserande_nn_1_N = mkN "prognostiserande" ;
  programmerande_nn_1_N = mkN "programmerande" ;
  projektarbete_nn_1_N = mkN "projektarbete" ;
  projekterande_nn_1_N = mkN "projekterande" ;
  projicerande_nn_1_N = mkN "projicerande" ;
  proklamerande_nn_1_N = mkN "proklamerande" ;
  proletariserande_nn_1_N = mkN "proletariserande" ;
  prolongerande_nn_1_N = mkN "prolongerande" ;
  promenadkoerande_nn_1_1_N = mkN "promenadkörande" ;
  promenerande_nn_1_N = mkN "promenerande" ;
  promoverande_nn_1_N = mkN "promoverande" ;
  promulgerande_nn_1_N = mkN "promulgerande" ;
  prononcerande_nn_1_N = mkN "prononcerande" ;
  propagerande_nn_1_N = mkN "propagerande" ;
  proponerande_nn_1_N = mkN "proponerande" ;
  proportionerande_nn_1_N = mkN "proportionerande" ;
  proppande_nn_1_N = mkN "proppande" ;
  propsande_nn_1_N = mkN "propsande" ;
  proskriberande_nn_1_N = mkN "proskriberande" ;
  prospekterande_nn_1_N = mkN "prospekterande" ;
  prostituerande_nn_1_N = mkN "prostituerande" ;
  protegerande_nn_1_N = mkN "protegerande" ;
  protesterande_nn_1_N = mkN "protesterande" ;
  protestklickande_nn_1_N = mkN "protestklickande" ;
  protestmoete_nn_1_1_N = mkN "protestmöte" ;
  protestroestande_nn_1_1_N = mkN "proteströstande" ;
  protokollerande_nn_1_N = mkN "protokollerande" ;
  provande_nn_1_N = mkN "provande" ;
  provianterande_nn_1_N = mkN "provianterande" ;
  provkoerande_nn_1_1_N = mkN "provkörande" ;
  provocerande_nn_1_N = mkN "provocerande" ;
  prunkande_nn_1_N = mkN "prunkande" ;
  prustande_nn_1_N = mkN "prustande" ;
  prutande_nn_1_N = mkN "prutande" ;
  pruttande_nn_1_N = mkN "pruttande" ;
  pryande_nn_1_N = mkN "pryande" ;
  prydande_nn_1_N = mkN "prydande" ;
  prydnadssnoere_nn_1_1_N = mkN "prydnadssnöre" ;
  pryglande_nn_1_N = mkN "pryglande" ;
  praegelvaerde_nn_1_1_N = mkN "prägelvärde" ;
  praeglande_nn_1_1_N = mkN "präglande" ;
  praentande_nn_1_1_N = mkN "präntande" ;
  praestvigande_nn_1_1_N = mkN "prästvigande" ;
  praestvaelde_nn_1_1_N = mkN "prästvälde" ;
  praestaembete_nn_1_1_N = mkN "prästämbete" ;
  praalande_nn_1_1_N = mkN "prålande" ;
  praamande_nn_1_1_N = mkN "pråmande" ;
  praanglande_nn_1_1_N = mkN "prånglande" ;
  proejsande_nn_1_1_N = mkN "pröjsande" ;
  proevande_nn_1_1_N = mkN "prövande" ;
  psykande_nn_1_N = mkN "psykande" ;
  psyke_nn_1_N = mkN "psyke" ;
  psykoanalyserande_nn_1_N = mkN "psykoanalyserande" ;
  psykologiserande_nn_1_N = mkN "psykologiserande" ;
  publicerande_nn_1_N = mkN "publicerande" ;
  puddlande_nn_1_N = mkN "puddlande" ;
  pudlande_nn_1_N = mkN "pudlande" ;
  pudrande_nn_1_N = mkN "pudrande" ;
  puffande_nn_1_N = mkN "puffande" ;
  pulande_nn_1_N = mkN "pulande" ;
  pullande_nn_1_N = mkN "pullande" ;
  pulsande_nn_1_N = mkN "pulsande" ;
  pulserande_nn_1_N = mkN "pulserande" ;
  pulveriserande_nn_1_N = mkN "pulveriserande" ;
  pulverlackerande_nn_1_N = mkN "pulverlackerande" ;
  pulvriserande_nn_1_N = mkN "pulvriserande" ;
  pumpande_nn_1_N = mkN "pumpande" ;
  pungslaaende_nn_1_1_N = mkN "pungslående" ;
  punktande_nn_1_N = mkN "punktande" ;
  punkterande_nn_1_N = mkN "punkterande" ;
  punktsvetsande_nn_1_N = mkN "punktsvetsande" ;
  punsande_nn_1_N = mkN "punsande" ;
  purgerande_nn_1_N = mkN "purgerande" ;
  purknande_nn_1_N = mkN "purknande" ;
  purprande_nn_1_N = mkN "purprande" ;
  purpurfaergande_nn_1_1_N = mkN "purpurfärgande" ;
  purrande_nn_1_N = mkN "purrande" ;
  pushande_nn_1_N = mkN "pushande" ;
  pussande_nn_1_N = mkN "pussande" ;
  pusslande_nn_1_N = mkN "pusslande" ;
  pustande_nn_1_N = mkN "pustande" ;
  putande_nn_1_N = mkN "putande" ;
  putsande_nn_1_N = mkN "putsande" ;
  puttande_nn_1_N = mkN "puttande" ;
  puttrande_nn_1_N = mkN "puttrande" ;
  pycke_nn_1_N = mkN "pycke" ;
  pyntande_nn_1_N = mkN "pyntande" ;
  pyrande_nn_1_N = mkN "pyrande" ;
  pyre_nn_1_N = mkN "pyre" ;
  pysande_nn_1_N = mkN "pysande" ;
  pysslande_nn_1_N = mkN "pysslande" ;
  pytsande_nn_1_N = mkN "pytsande" ;
  paelande_nn_1_1_N = mkN "pälande" ;
  paerlande_nn_1_1_N = mkN "pärlande" ;
  paaande_nn_1_1_N = mkN "påande" ;
  paaannonserande_nn_1_1_N = mkN "påannonserande" ;
  paabjudande_nn_1_1_N = mkN "påbjudande" ;
  paaboerdande_nn_1_1_N = mkN "påbördande" ;
  paaboerjande_nn_1_1_N = mkN "påbörjande" ;
  paadyvlande_nn_1_1_N = mkN "pådyvlande" ;
  paafordrande_nn_1_1_N = mkN "påfordrande" ;
  paafoerande_nn_1_1_N = mkN "påförande" ;
  paagaaende_nn_1_1_N = mkN "pågående" ;
  paakallande_nn_1_1_N = mkN "påkallande" ;
  paaklaedande_nn_1_1_N = mkN "påklädande" ;
  paalande_nn_1_1_N = mkN "pålande" ;
  paalaeggande_nn_1_1_N = mkN "påläggande" ;
  paaloedande_nn_1_1_N = mkN "pålödande" ;
  paaminnande_nn_1_1_N = mkN "påminnande" ;
  paanyttfoedande_nn_1_1_N = mkN "pånyttfödande" ;
  paapekande_nn_1_1_N = mkN "påpekande" ;
  paaropande_nn_1_1_N = mkN "påropande" ;
  paaraeknande_nn_1_1_N = mkN "påräknande" ;
  paaskinande_nn_1_1_N = mkN "påskinande" ;
  paaskyndande_nn_1_1_N = mkN "påskyndande" ;
  paaspaedande_nn_1_1_N = mkN "påspädande" ;
  paaspaeende_nn_1_1_N = mkN "påspäende" ;
  paastaaende_nn_1_1_N = mkN "påstående" ;
  paatagande_nn_1_1_N = mkN "påtagande" ;
  paatalande_nn_1_1_N = mkN "påtalande" ;
  paatande_nn_1_1_N = mkN "påtande" ;
  paatraeffande_nn_1_1_N = mkN "påträffande" ;
  paatvingande_nn_1_1_N = mkN "påtvingande" ;
  paavedoeme_nn_1_1_N = mkN "påvedöme" ;
  paaverkande_nn_1_1_N = mkN "påverkande" ;
  paavilande_nn_1_1_N = mkN "påvilande" ;
  paavisande_nn_1_1_N = mkN "påvisande" ;
  paayrkande_nn_1_1_N = mkN "påyrkande" ;
  poebelvaelde_nn_1_1_N = mkN "pöbelvälde" ;
  poelande_nn_1_1_N = mkN "pölande" ;
  poerte_nn_1_1_N = mkN "pörte" ;
  poesande_nn_1_1_N = mkN "pösande" ;
  quiltande_nn_1_N = mkN "quiltande" ;
  quizande_nn_1_N = mkN "quizande" ;
  quizzande_nn_1_N = mkN "quizzande" ;
  rabatterande_nn_1_N = mkN "rabatterande" ;
  rabattfrimaerke_nn_1_1_N = mkN "rabattfrimärke" ;
  rabatthaefte_nn_1_1_N = mkN "rabatthäfte" ;
  rackande_nn_1_N = mkN "rackande" ;
  radbyte_nn_1_N = mkN "radbyte" ;
  raderande_nn_1_N = mkN "raderande" ;
  radhusomraade_nn_1_1_N = mkN "radhusområde" ;
  radierande_nn_1_N = mkN "radierande" ;
  radikaliserande_nn_1_N = mkN "radikaliserande" ;
  radionavigerande_nn_1_N = mkN "radionavigerande" ;
  raffinerande_nn_1_N = mkN "raffinerande" ;
  rafistulerande_nn_1_N = mkN "rafistulerande" ;
  raggande_nn_1_N = mkN "raggande" ;
  ragglande_nn_1_N = mkN "ragglande" ;
  raglande_nn_1_N = mkN "raglande" ;
  rakande_nn_1_N = mkN "rakande" ;
  raknande_nn_1_N = mkN "raknande" ;
  raljerande_nn_1_N = mkN "raljerande" ;
  ramande_nn_1_N = mkN "ramande" ;
  ramlande_nn_1_N = mkN "ramlande" ;
  rammande_nn_1_N = mkN "rammande" ;
  ramponerande_nn_1_N = mkN "ramponerande" ;
  ramsande_nn_1_N = mkN "ramsande" ;
  randande_nn_1_N = mkN "randande" ;
  rangerande_nn_1_N = mkN "rangerande" ;
  ranglande_nn_1_N = mkN "ranglande" ;
  rangordnande_nn_1_N = mkN "rangordnande" ;
  rankande_nn_1_N = mkN "rankande" ;
  rannsakande_nn_1_N = mkN "rannsakande" ;
  ransonerande_nn_1_N = mkN "ransonerande" ;
  rantande_nn_1_N = mkN "rantande" ;
  rapande_nn_1_N = mkN "rapande" ;
  rappande_nn_1_N = mkN "rappande" ;
  rappellerande_nn_1_N = mkN "rappellerande" ;
  rapporterande_nn_1_N = mkN "rapporterande" ;
  rasande_nn_1_N = mkN "rasande" ;
  rasdiskriminerande_nn_1_N = mkN "rasdiskriminerande" ;
  raserande_nn_1_N = mkN "raserande" ;
  raspande_nn_1_N = mkN "raspande" ;
  rasslande_nn_1_N = mkN "rasslande" ;
  rastande_nn_1_N = mkN "rastande" ;
  ratande_nn_1_N = mkN "ratande" ;
  ratificerande_nn_1_N = mkN "ratificerande" ;
  rationaliserande_nn_1_N = mkN "rationaliserande" ;
  ratschande_nn_1_N = mkN "ratschande" ;
  rattande_nn_1_N = mkN "rattande" ;
  rayonsilke_nn_1_N = mkN "rayonsilke" ;
  reagerande_nn_1_N = mkN "reagerande" ;
  reaktiverande_nn_1_N = mkN "reaktiverande" ;
  reale_nn_1_N = mkN "reale" ;
  realiserande_nn_1_N = mkN "realiserande" ;
  realvaerde_nn_1_1_N = mkN "realvärde" ;
  reande_nn_1_N = mkN "reande" ;
  reassurerande_nn_1_N = mkN "reassurerande" ;
  rebellerande_nn_1_N = mkN "rebellerande" ;
  rebellfaeste_nn_1_1_N = mkN "rebellfäste" ;
  recenserande_nn_1_N = mkN "recenserande" ;
  recidiverande_nn_1_N = mkN "recidiverande" ;
  recipierande_nn_1_N = mkN "recipierande" ;
  reciterande_nn_1_N = mkN "reciterande" ;
  redande_nn_1_N = mkN "redande" ;
  rede_nn_1_N = mkN "rede" ;
  redigerande_nn_1_N = mkN "redigerande" ;
  redogoerande_nn_1_1_N = mkN "redogörande" ;
  redovisande_nn_1_N = mkN "redovisande" ;
  redubblande_nn_1_N = mkN "redubblande" ;
  reducerande_nn_1_N = mkN "reducerande" ;
  refererande_nn_1_N = mkN "refererande" ;
  reflekterande_nn_1_N = mkN "reflekterande" ;
  reformerande_nn_1_N = mkN "reformerande" ;
  reformstraevande_nn_1_1_N = mkN "reformsträvande" ;
  refuserande_nn_1_N = mkN "refuserande" ;
  regale_nn_1_N = mkN "regale" ;
  regalerande_nn_1_N = mkN "regalerande" ;
  regemente_nn_1_N = mkN "regemente" ;
  regenererande_nn_1_N = mkN "regenererande" ;
  regerande_nn_1_N = mkN "regerande" ;
  regeringssammantraede_nn_1_1_N = mkN "regeringssammanträde" ;
  regisserande_nn_1_N = mkN "regisserande" ;
  registrerande_nn_1_N = mkN "registrerande" ;
  reglemente_nn_1_N = mkN "reglemente" ;
  reglementerande_nn_1_N = mkN "reglementerande" ;
  reglerande_nn_1_N = mkN "reglerande" ;
  regnande_nn_1_N = mkN "regnande" ;
  regnomraade_nn_1_1_N = mkN "regnområde" ;
  regummerande_nn_1_N = mkN "regummerande" ;
  rehabiliterande_nn_1_N = mkN "rehabiliterande" ;
  reinkarnerande_nn_1_N = mkN "reinkarnerande" ;
  rekande_nn_1_N = mkN "rekande" ;
  rekapitulerande_nn_1_N = mkN "rekapitulerande" ;
  reklamerande_nn_1_N = mkN "reklamerande" ;
  reklamsyfte_nn_1_N = mkN "reklamsyfte" ;
  rekognoscerande_nn_1_N = mkN "rekognoscerande" ;
  rekognoserande_nn_1_N = mkN "rekognoserande" ;
  rekommenderande_nn_1_N = mkN "rekommenderande" ;
  rekompenserande_nn_1_N = mkN "rekompenserande" ;
  rekonstruerande_nn_1_N = mkN "rekonstruerande" ;
  rekreationsomraade_nn_1_1_N = mkN "rekreationsområde" ;
  rekryterande_nn_1_N = mkN "rekryterande" ;
  rektificerande_nn_1_N = mkN "rektificerande" ;
  rektifierande_nn_1_N = mkN "rektifierande" ;
  rektorsomraade_nn_1_1_N = mkN "rektorsområde" ;
  rekvirerande_nn_1_N = mkN "rekvirerande" ;
  rekylerande_nn_1_N = mkN "rekylerande" ;
  relaterande_nn_1_N = mkN "relaterande" ;
  relaxande_nn_1_N = mkN "relaxande" ;
  relegerande_nn_1_N = mkN "relegerande" ;
  relaeande_nn_1_1_N = mkN "reläande" ;
  remissyttrande_nn_1_N = mkN "remissyttrande" ;
  remitterande_nn_1_N = mkN "remitterande" ;
  remmande_nn_1_N = mkN "remmande" ;
  remonterande_nn_1_N = mkN "remonterande" ;
  remplacerande_nn_1_N = mkN "remplacerande" ;
  renande_nn_1_N = mkN "renande" ;
  renderande_nn_1_N = mkN "renderande" ;
  rengoerande_nn_1_1_N = mkN "rengörande" ;
  rengoeringssnoere_nn_1_1_N = mkN "rengöringssnöre" ;
  renmaerke_nn_1_1_N = mkN "renmärke" ;
  renodlande_nn_1_N = mkN "renodlande" ;
  renoverande_nn_1_N = mkN "renoverande" ;
  renoveringsarbete_nn_1_N = mkN "renoveringsarbete" ;
  renrakande_nn_1_N = mkN "renrakande" ;
  rensande_nn_1_N = mkN "rensande" ;
  renskrivande_nn_1_N = mkN "renskrivande" ;
  rentvaaende_nn_1_1_N = mkN "rentvående" ;
  reorganiserande_nn_1_N = mkN "reorganiserande" ;
  repande_nn_1_N = mkN "repande" ;
  reparerande_nn_1_N = mkN "reparerande" ;
  repartiserande_nn_1_N = mkN "repartiserande" ;
  repatrierande_nn_1_N = mkN "repatrierande" ;
  repellerande_nn_1_N = mkN "repellerande" ;
  repeterande_nn_1_N = mkN "repeterande" ;
  replierande_nn_1_N = mkN "replierande" ;
  replikerande_nn_1_N = mkN "replikerande" ;
  replikskifte_nn_1_N = mkN "replikskifte" ;
  representerande_nn_1_N = mkN "representerande" ;
  repriserande_nn_1_N = mkN "repriserande" ;
  reproducerande_nn_1_N = mkN "reproducerande" ;
  resande_nn_3_N = mkN "resande" ;
  reserverande_nn_1_N = mkN "reserverande" ;
  residerande_nn_1_N = mkN "residerande" ;
  resignerande_nn_1_N = mkN "resignerande" ;
  resistensomraade_nn_1_1_N = mkN "resistensområde" ;
  resolverande_nn_1_N = mkN "resolverande" ;
  resonerande_nn_1_N = mkN "resonerande" ;
  resorberande_nn_1_N = mkN "resorberande" ;
  respekterande_nn_1_N = mkN "respekterande" ;
  respirerande_nn_1_N = mkN "respirerande" ;
  restaurerande_nn_1_N = mkN "restaurerande" ;
  resterande_nn_1_N = mkN "resterande" ;
  restituerande_nn_1_N = mkN "restituerande" ;
  resulterande_nn_1_N = mkN "resulterande" ;
  resumerande_nn_1_N = mkN "resumerande" ;
  retablerande_nn_1_N = mkN "retablerande" ;
  retande_nn_1_N = mkN "retande" ;
  retarderande_nn_1_N = mkN "retarderande" ;
  retirerande_nn_1_N = mkN "retirerande" ;
  returnerande_nn_1_N = mkN "returnerande" ;
  retuscherande_nn_1_N = mkN "retuscherande" ;
  revalverande_nn_1_N = mkN "revalverande" ;
  revande_nn_1_N = mkN "revande" ;
  reveterande_nn_1_N = mkN "reveterande" ;
  reviderande_nn_1_N = mkN "reviderande" ;
  revolterande_nn_1_N = mkN "revolterande" ;
  revolutionerande_nn_1_N = mkN "revolutionerande" ;
  riande_nn_1_N = mkN "riande" ;
  rickande_nn_1_N = mkN "rickande" ;
  ridande_nn_1_N = mkN "ridande" ;
  ridborgarmaerke_nn_1_1_N = mkN "ridborgarmärke" ;
  riggande_nn_1_N = mkN "riggande" ;
  rike_nn_1_N = mkN "rike" ;
  rikoschetterande_nn_1_N = mkN "rikoschetterande" ;
  riksdagssammantraede_nn_1_1_N = mkN "riksdagssammanträde" ;
  riksdagsvaelde_nn_1_1_N = mkN "riksdagsvälde" ;
  riksintresse_nn_1_N = mkN "riksintresse" ;
  riksmoete_nn_1_1_N = mkN "riksmöte" ;
  riksroese_nn_1_1_N = mkN "riksröse" ;
  riktande_nn_1_N = mkN "riktande" ;
  riktmaerke_nn_1_1_N = mkN "riktmärke" ;
  rimmande_nn_1_N = mkN "rimmande" ;
  rimsaltande_nn_1_N = mkN "rimsaltande" ;
  ringaktande_nn_1_N = mkN "ringaktande" ;
  ringande_nn_1_N = mkN "ringande" ;
  ringbarkande_nn_1_N = mkN "ringbarkande" ;
  ringlande_nn_1_N = mkN "ringlande" ;
  ringmaerkande_nn_1_1_N = mkN "ringmärkande" ;
  rinnande_nn_1_N = mkN "rinnande" ;
  riposterande_nn_1_N = mkN "riposterande" ;
  risande_nn_1_N = mkN "risande" ;
  riskbygge_nn_1_N = mkN "riskbygge" ;
  riskerande_nn_1_N = mkN "riskerande" ;
  riskomraade_nn_1_1_N = mkN "riskområde" ;
  rispande_nn_1_N = mkN "rispande" ;
  risslande_nn_1_N = mkN "risslande" ;
  ristande_nn_1_N = mkN "ristande" ;
  ritande_nn_1_N = mkN "ritande" ;
  ritsande_nn_1_N = mkN "ritsande" ;
  ritschande_nn_1_N = mkN "ritschande" ;
  ritualiserande_nn_1_N = mkN "ritualiserande" ;
  rivaliserande_nn_1_N = mkN "rivaliserande" ;
  rivande_nn_1_N = mkN "rivande" ;
  rivstartande_nn_1_N = mkN "rivstartande" ;
  roande_nn_1_N = mkN "roande" ;
  robotiserande_nn_1_N = mkN "robotiserande" ;
  rockande_nn_1_N = mkN "rockande" ;
  rockerande_nn_1_N = mkN "rockerande" ;
  rodnande_nn_1_N = mkN "rodnande" ;
  roende_nn_1_N = mkN "roende" ;
  roffande_nn_1_N = mkN "roffande" ;
  rollande_nn_1_N = mkN "rollande" ;
  rollskifte_nn_1_N = mkN "rollskifte" ;
  romantiserande_nn_1_N = mkN "romantiserande" ;
  ropande_nn_1_N = mkN "ropande" ;
  rosande_nn_1_N = mkN "rosande" ;
  rosslande_nn_1_N = mkN "rosslande" ;
  rostande_nn_1_N = mkN "rostande" ;
  rostbehandlande_nn_1_N = mkN "rostbehandlande" ;
  rostskyddande_nn_1_N = mkN "rostskyddande" ;
  rotande_nn_1_N = mkN "rotande" ;
  roterande_nn_1_N = mkN "roterande" ;
  rotfyllande_nn_1_N = mkN "rotfyllande" ;
  rotfaeste_nn_1_1_N = mkN "rotfäste" ;
  rotmaerke_nn_1_1_N = mkN "rotmärke" ;
  rubbande_nn_1_N = mkN "rubbande" ;
  rubricerande_nn_1_N = mkN "rubricerande" ;
  ruckande_nn_1_N = mkN "ruckande" ;
  rucklande_nn_1_N = mkN "rucklande" ;
  rufflande_nn_1_N = mkN "rufflande" ;
  rufsande_nn_1_N = mkN "rufsande" ;
  ruggande_nn_1_N = mkN "ruggande" ;
  ruinerande_nn_1_N = mkN "ruinerande" ;
  rullande_nn_1_N = mkN "rullande" ;
  rullbraede_nn_1_1_N = mkN "rullbräde" ;
  rullbaelte_nn_1_1_N = mkN "rullbälte" ;
  rullstolssele_nn_1_N = mkN "rullstolssele" ;
  rulltrappsraecke_nn_1_1_N = mkN "rulltrappsräcke" ;
  rultande_nn_1_N = mkN "rultande" ;
  rumlande_nn_1_N = mkN "rumlande" ;
  rumphuggande_nn_1_N = mkN "rumphuggande" ;
  rumsterande_nn_1_N = mkN "rumsterande" ;
  rundande_nn_1_N = mkN "rundande" ;
  rundningsmaerke_nn_1_1_N = mkN "rundningsmärke" ;
  rundsmoerjande_nn_1_1_N = mkN "rundsmörjande" ;
  rundstickande_nn_1_N = mkN "rundstickande" ;
  rundstycke_nn_1_N = mkN "rundstycke" ;
  rungande_nn_1_N = mkN "rungande" ;
  runkande_nn_1_N = mkN "runkande" ;
  runstensomraade_nn_1_1_N = mkN "runstensområde" ;
  runstycke_nn_1_N = mkN "runstycke" ;
  rusande_nn_1_N = mkN "rusande" ;
  ruskande_nn_1_N = mkN "ruskande" ;
  russificerande_nn_1_N = mkN "russificerande" ;
  russifierande_nn_1_N = mkN "russifierande" ;
  rustande_nn_1_N = mkN "rustande" ;
  rutande_nn_1_N = mkN "rutande" ;
  rutinaerende_nn_1_1_N = mkN "rutinärende" ;
  rutschande_nn_1_N = mkN "rutschande" ;
  ruttnande_nn_1_N = mkN "ruttnande" ;
  ruvande_nn_1_N = mkN "ruvande" ;
  ryande_nn_1_N = mkN "ryande" ;
  ryckande_nn_1_N = mkN "ryckande" ;
  ryggande_nn_1_N = mkN "ryggande" ;
  rygglaege_nn_1_1_N = mkN "ryggläge" ;
  ryggsaecksluffande_nn_1_1_N = mkN "ryggsäcksluffande" ;
  rykande_nn_1_N = mkN "rykande" ;
  ryktande_nn_1_N = mkN "ryktande" ;
  rykte_nn_1_N = mkN "rykte" ;
  rymmande_nn_1_N = mkN "rymmande" ;
  rynkande_nn_1_N = mkN "rynkande" ;
  rysande_nn_1_N = mkN "rysande" ;
  rytande_nn_1_N = mkN "rytande" ;
  rytmiserande_nn_1_N = mkN "rytmiserande" ;
  ryttlande_nn_1_N = mkN "ryttlande" ;
  raeckande_nn_1_1_N = mkN "räckande" ;
  raecke_nn_1_1_N = mkN "räcke" ;
  raeddande_nn_1_1_N = mkN "räddande" ;
  raefflande_nn_1_1_N = mkN "räfflande" ;
  raefsande_nn_1_1_N = mkN "räfsande" ;
  raeknande_nn_1_1_N = mkN "räknande" ;
  raemnande_nn_1_1_N = mkN "rämnande" ;
  raennande_nn_1_1_N = mkN "rännande" ;
  raetande_nn_1_1_N = mkN "rätande" ;
  raettande_nn_1_1_N = mkN "rättande" ;
  raettegaangsbitraede_nn_1_1_N = mkN "rättegångsbiträde" ;
  raettesnoere_nn_1_1_N = mkN "rättesnöre" ;
  raettfaerdigande_nn_1_1_N = mkN "rättfärdigande" ;
  raettfaerdiggoerande_nn_1_1_N = mkN "rättfärdiggörande" ;
  raettslaege_nn_1_1_N = mkN "rättsläge" ;
  raettsmedvetande_nn_1_1_N = mkN "rättsmedvetande" ;
  raettssamhaelle_nn_1_1_N = mkN "rättssamhälle" ;
  raettssaekerhetsintresse_nn_1_1_N = mkN "rättssäkerhetsintresse" ;
  raettsvaesende_nn_1_1_N = mkN "rättsväsende" ;
  raadande_nn_1_1_N = mkN "rådande" ;
  raadbraakande_nn_1_1_N = mkN "rådbråkande" ;
  raadfraagande_nn_1_1_N = mkN "rådfrågande" ;
  raadfoerande_nn_1_1_N = mkN "rådförande" ;
  raadgoerande_nn_1_1_N = mkN "rådgörande" ;
  raadlaeggande_nn_1_1_N = mkN "rådläggande" ;
  raadplaegande_nn_1_1_N = mkN "rådplägande" ;
  raadslaaende_nn_1_1_N = mkN "rådslående" ;
  raaende_nn_1_1_N = mkN "rående" ;
  raagande_nn_1_1_N = mkN "rågande" ;
  raakande_nn_1_1_N = mkN "råkande" ;
  raamande_nn_1_1_N = mkN "råmande" ;
  raamaerke_nn_1_1_N = mkN "råmärke" ;
  raanande_nn_1_1_N = mkN "rånande" ;
  raanbyte_nn_1_1_N = mkN "rånbyte" ;
  raapluggande_nn_1_1_N = mkN "råpluggande" ;
  raarivande_nn_1_1_N = mkN "rårivande" ;
  raaskalande_nn_1_1_N = mkN "råskalande" ;
  raaskaellande_nn_1_1_N = mkN "råskällande" ;
  raastekande_nn_1_1_N = mkN "råstekande" ;
  raaaemne_nn_1_1_N = mkN "råämne" ;
  roedgloedgande_nn_1_1_N = mkN "rödglödgande" ;
  roedlistande_nn_1_1_N = mkN "rödlistande" ;
  roedpunktsikte_nn_1_1_N = mkN "rödpunktsikte" ;
  roedpunktssikte_nn_1_1_N = mkN "rödpunktssikte" ;
  roejande_nn_1_1_N = mkN "röjande" ;
  roejningsarbete_nn_1_1_N = mkN "röjningsarbete" ;
  roekande_nn_1_1_N = mkN "rökande" ;
  roenande_nn_1_1_N = mkN "rönande" ;
  roentgande_nn_1_1_N = mkN "röntgande" ;
  roentgenfotograferande_nn_1_1_N = mkN "röntgenfotograferande" ;
  roerande_nn_1_1_N = mkN "rörande" ;
  roerelsesinne_nn_1_1_N = mkN "rörelsesinne" ;
  roerknippe_nn_1_1_N = mkN "rörknippe" ;
  roesande_nn_1_1_N = mkN "rösande" ;
  roese_nn_1_1_N = mkN "röse" ;
  roestande_nn_1_1_N = mkN "röstande" ;
  roeste_nn_1_1_N = mkN "röste" ;
  roestlaege_nn_1_1_N = mkN "röstläge" ;
  roestmaximerande_nn_1_1_N = mkN "röstmaximerande" ;
  roevande_nn_1_1_N = mkN "rövande" ;
  roevknullande_nn_1_1_N = mkN "rövknullande" ;
  sabbande_nn_1_N = mkN "sabbande" ;
  saboterande_nn_1_N = mkN "saboterande" ;
  sabrerande_nn_1_N = mkN "sabrerande" ;
  sackande_nn_1_N = mkN "sackande" ;
  sadellaege_nn_1_1_N = mkN "sadelläge" ;
  sadeltaecke_nn_1_1_N = mkN "sadeltäcke" ;
  sadlande_nn_1_N = mkN "sadlande" ;
  saftande_nn_1_N = mkN "saftande" ;
  saggande_nn_1_N = mkN "saggande" ;
  saglande_nn_1_N = mkN "saglande" ;
  sakande_nn_1_N = mkN "sakande" ;
  sakerfoerklarande_nn_1_1_N = mkN "sakerförklarande" ;
  sakfaellande_nn_1_1_N = mkN "sakfällande" ;
  sakfoerhaallande_nn_1_1_N = mkN "sakförhållande" ;
  sakkunnigbetaenkande_nn_1_1_N = mkN "sakkunnigbetänkande" ;
  sakkunnigutlaatande_nn_1_1_N = mkN "sakkunnigutlåtande" ;
  saknande_nn_1_N = mkN "saknande" ;
  saktande_nn_1_N = mkN "saktande" ;
  sakoere_nn_1_1_N = mkN "saköre" ;
  salande_nn_1_N = mkN "salande" ;
  salderande_nn_1_N = mkN "salderande" ;
  saligfoerklarande_nn_1_1_N = mkN "saligförklarande" ;
  saliverande_nn_1_N = mkN "saliverande" ;
  saltande_nn_1_N = mkN "saltande" ;
  saltsleke_nn_1_N = mkN "saltsleke" ;
  salubjudande_nn_1_N = mkN "salubjudande" ;
  salufoerande_nn_1_1_N = mkN "saluförande" ;
  saluterande_nn_1_N = mkN "saluterande" ;
  saluvaerde_nn_1_1_N = mkN "saluvärde" ;
  samarbetande_nn_1_N = mkN "samarbetande" ;
  samarbete_nn_1_N = mkN "samarbete" ;
  sambeskattande_nn_1_N = mkN "sambeskattande" ;
  samboende_nn_2_N = mkN "samboende" ;
  samhaelle_nn_1_1_N = mkN "samhälle" ;
  samhaellsarbete_nn_1_1_N = mkN "samhällsarbete" ;
  samhaellsingripande_nn_1_1_N = mkN "samhällsingripande" ;
  samhaellsomraade_nn_1_1_N = mkN "samhällsområde" ;
  samhaellsplanerande_nn_1_1_N = mkN "samhällsplanerande" ;
  samkande_nn_1_N = mkN "samkande" ;
  samklingande_nn_1_N = mkN "samklingande" ;
  samkoerande_nn_1_1_N = mkN "samkörande" ;
  samlande_nn_1_N = mkN "samlande" ;
  sammanavlande_nn_1_N = mkN "sammanavlande" ;
  sammanbindande_nn_1_N = mkN "sammanbindande" ;
  sammanblandande_nn_1_N = mkN "sammanblandande" ;
  sammanboende_nn_1_N = mkN "sammanboende" ;
  sammandrabbande_nn_1_N = mkN "sammandrabbande" ;
  sammandragande_nn_1_N = mkN "sammandragande" ;
  sammanfallande_nn_1_N = mkN "sammanfallande" ;
  sammanfattande_nn_1_N = mkN "sammanfattande" ;
  sammanflaetande_nn_1_1_N = mkN "sammanflätande" ;
  sammanfloede_nn_1_1_N = mkN "sammanflöde" ;
  sammanfogande_nn_1_N = mkN "sammanfogande" ;
  sammanfoerande_nn_1_1_N = mkN "sammanförande" ;
  sammangaaende_nn_1_1_N = mkN "sammangående" ;
  sammanhopande_nn_1_N = mkN "sammanhopande" ;
  sammanhaengande_nn_1_1_N = mkN "sammanhängande" ;
  sammanhaallande_nn_1_1_N = mkN "sammanhållande" ;
  sammanjaemkande_nn_1_1_N = mkN "sammanjämkande" ;
  sammankallande_nn_1_N = mkN "sammankallande" ;
  sammankopplande_nn_1_N = mkN "sammankopplande" ;
  sammanlevande_nn_1_N = mkN "sammanlevande" ;
  sammanlaeggande_nn_1_1_N = mkN "sammanläggande" ;
  sammanlaenkande_nn_1_1_N = mkN "sammanlänkande" ;
  sammanloepande_nn_1_1_N = mkN "sammanlöpande" ;
  sammanpackande_nn_1_N = mkN "sammanpackande" ;
  sammanpressande_nn_1_N = mkN "sammanpressande" ;
  sammanringande_nn_1_N = mkN "sammanringande" ;
  sammanraeknande_nn_1_1_N = mkN "sammanräknande" ;
  sammanskjutande_nn_1_N = mkN "sammanskjutande" ;
  sammanskrivande_nn_1_N = mkN "sammanskrivande" ;
  sammanslaaende_nn_1_1_N = mkN "sammanslående" ;
  sammansmaeltande_nn_1_1_N = mkN "sammansmältande" ;
  sammanstraalande_nn_1_1_N = mkN "sammanstrålande" ;
  sammanstaellande_nn_1_1_N = mkN "sammanställande" ;
  sammanstoetande_nn_1_1_N = mkN "sammanstötande" ;
  sammansvetsande_nn_1_N = mkN "sammansvetsande" ;
  sammansaettande_nn_1_1_N = mkN "sammansättande" ;
  sammantryckande_nn_1_N = mkN "sammantryckande" ;
  sammantraedande_nn_1_1_N = mkN "sammanträdande" ;
  sammantraede_nn_1_1_N = mkN "sammanträde" ;
  sammantraeffande_nn_1_1_N = mkN "sammanträffande" ;
  sammanvaevande_nn_1_1_N = mkN "sammanvävande" ;
  sammanvaexande_nn_1_1_N = mkN "sammanväxande" ;
  samordnande_nn_1_N = mkN "samordnande" ;
  samplande_nn_1_N = mkN "samplande" ;
  samraadande_nn_1_1_N = mkN "samrådande" ;
  samsande_nn_1_N = mkN "samsande" ;
  samspelande_nn_1_N = mkN "samspelande" ;
  samspraakande_nn_1_1_N = mkN "samspråkande" ;
  samtalande_nn_1_N = mkN "samtalande" ;
  samtalslaege_nn_1_1_N = mkN "samtalsläge" ;
  samtalsaemne_nn_1_1_N = mkN "samtalsämne" ;
  samtaxerande_nn_1_N = mkN "samtaxerande" ;
  samtyckande_nn_1_N = mkN "samtyckande" ;
  samtycke_nn_1_N = mkN "samtycke" ;
  samvarande_nn_1_N = mkN "samvarande" ;
  samverkande_nn_1_N = mkN "samverkande" ;
  samvete_nn_1_N = mkN "samvete" ;
  samvaelde_nn_1_1_N = mkN "samvälde" ;
  samaakande_nn_1_1_N = mkN "samåkande" ;
  sandande_nn_1_N = mkN "sandande" ;
  sandblaestrande_nn_1_1_N = mkN "sandblästrande" ;
  sandpapprande_nn_1_N = mkN "sandpapprande" ;
  sanerande_nn_1_N = mkN "sanerande" ;
  sanforiserande_nn_1_N = mkN "sanforiserande" ;
  sanktifierande_nn_1_N = mkN "sanktifierande" ;
  sanktionerande_nn_1_N = mkN "sanktionerande" ;
  sannande_nn_1_N = mkN "sannande" ;
  sanningsvittne_nn_1_N = mkN "sanningsvittne" ;
  saponifierande_nn_1_N = mkN "saponifierande" ;
  sargande_nn_1_N = mkN "sargande" ;
  satinerande_nn_1_N = mkN "satinerande" ;
  satiriserande_nn_1_N = mkN "satiriserande" ;
  satisfierande_nn_1_N = mkN "satisfierande" ;
  satsande_nn_1_N = mkN "satsande" ;
  satsbraede_nn_1_1_N = mkN "satsbräde" ;
  saturerande_nn_1_N = mkN "saturerande" ;
  sauterande_nn_1_N = mkN "sauterande" ;
  sauverande_nn_1_N = mkN "sauverande" ;
  savande_nn_1_N = mkN "savande" ;
  saxande_nn_1_N = mkN "saxande" ;
  scannande_nn_1_N = mkN "scannande" ;
  scenframtraedande_nn_1_1_N = mkN "scenframträdande" ;
  scenuppfoerande_nn_1_1_N = mkN "scenuppförande" ;
  schabblande_nn_1_N = mkN "schabblande" ;
  schablonerande_nn_1_N = mkN "schablonerande" ;
  schabloniserande_nn_1_N = mkN "schabloniserande" ;
  schablontaxerande_nn_1_N = mkN "schablontaxerande" ;
  schackande_nn_1_N = mkN "schackande" ;
  schackbraede_nn_1_1_N = mkN "schackbräde" ;
  schacklande_nn_1_N = mkN "schacklande" ;
  schackrande_nn_1_N = mkN "schackrande" ;
  schaktande_nn_1_N = mkN "schaktande" ;
  schamponerande_nn_1_N = mkN "schamponerande" ;
  schanghajande_nn_1_N = mkN "schanghajande" ;
  schappande_nn_1_N = mkN "schappande" ;
  schasande_nn_1_N = mkN "schasande" ;
  schatterande_nn_1_N = mkN "schatterande" ;
  schavotterande_nn_1_N = mkN "schavotterande" ;
  schematiserande_nn_1_N = mkN "schematiserande" ;
  schveifande_nn_1_N = mkN "schveifande" ;
  scoutloefte_nn_1_1_N = mkN "scoutlöfte" ;
  sedimenterande_nn_1_N = mkN "sedimenterande" ;
  seedande_nn_1_N = mkN "seedande" ;
  seende_nn_1_N = mkN "seende" ;
  segande_nn_1_N = mkN "segande" ;
  segdragande_nn_1_N = mkN "segdragande" ;
  segelflygande_nn_1_N = mkN "segelflygande" ;
  segelmaerke_nn_1_1_N = mkN "segelmärke" ;
  seghaerdande_nn_1_1_N = mkN "seghärdande" ;
  seglande_nn_1_N = mkN "seglande" ;
  segmenterande_nn_1_N = mkN "segmenterande" ;
  segnande_nn_1_N = mkN "segnande" ;
  segrande_nn_1_N = mkN "segrande" ;
  segregerande_nn_1_N = mkN "segregerande" ;
  sejdande_nn_1_N = mkN "sejdande" ;
  sejsande_nn_1_N = mkN "sejsande" ;
  sekelskifte_nn_1_N = mkN "sekelskifte" ;
  sekonderande_nn_1_N = mkN "sekonderande" ;
  sekretessbelaeggande_nn_1_1_N = mkN "sekretessbeläggande" ;
  sekulariserande_nn_1_N = mkN "sekulariserande" ;
  sekularsnille_nn_1_N = mkN "sekularsnille" ;
  sekunderande_nn_1_N = mkN "sekunderande" ;
  sekundaerminne_nn_1_1_N = mkN "sekundärminne" ;
  sekvenserande_nn_1_N = mkN "sekvenserande" ;
  sekvestrerande_nn_1_N = mkN "sekvestrerande" ;
  selande_nn_1_N = mkN "selande" ;
  selekterande_nn_1_N = mkN "selekterande" ;
  semaforerande_nn_1_N = mkN "semaforerande" ;
  semesterarvode_nn_1_N = mkN "semesterarvode" ;
  semestrande_nn_1_N = mkN "semestrande" ;
  seminerande_nn_1_N = mkN "seminerande" ;
  senarelaeggande_nn_1_1_N = mkN "senareläggande" ;
  sensibiliserande_nn_1_N = mkN "sensibiliserande" ;
  senterande_nn_1_N = mkN "senterande" ;
  separerande_nn_1_N = mkN "separerande" ;
  seriekopplande_nn_1_N = mkN "seriekopplande" ;
  serietillverkande_nn_1_N = mkN "serietillverkande" ;
  servande_nn_1_N = mkN "servande" ;
  serverande_nn_1_N = mkN "serverande" ;
  serviceyrke_nn_1_N = mkN "serviceyrke" ;
  sexchattande_nn_1_N = mkN "sexchattande" ;
  sexofredande_nn_1_N = mkN "sexofredande" ;
  sexualiserande_nn_1_N = mkN "sexualiserande" ;
  sexutnyttjande_nn_1_N = mkN "sexutnyttjande" ;
  shakande_nn_1_N = mkN "shakande" ;
  shamponerande_nn_1_N = mkN "shamponerande" ;
  shanghajande_nn_1_N = mkN "shanghajande" ;
  shinglande_nn_1_N = mkN "shinglande" ;
  shoppande_nn_1_N = mkN "shoppande" ;
  shortande_nn_1_N = mkN "shortande" ;
  showande_nn_1_N = mkN "showande" ;
  shuntande_nn_1_N = mkN "shuntande" ;
  siande_nn_1_N = mkN "siande" ;
  sickande_nn_1_N = mkN "sickande" ;
  sicklande_nn_1_N = mkN "sicklande" ;
  sicksackande_nn_1_N = mkN "sicksackande" ;
  sidbyte_nn_1_N = mkN "sidbyte" ;
  sidnumrerande_nn_1_N = mkN "sidnumrerande" ;
  sidolaege_nn_1_1_N = mkN "sidoläge" ;
  sidsteppande_nn_1_N = mkN "sidsteppande" ;
  sigillerande_nn_1_N = mkN "sigillerande" ;
  signalerande_nn_1_N = mkN "signalerande" ;
  signande_nn_1_N = mkN "signande" ;
  signerande_nn_1_N = mkN "signerande" ;
  siktande_nn_1_N = mkN "siktande" ;
  sikte_nn_1_N = mkN "sikte" ;
  silande_nn_1_N = mkN "silande" ;
  silhuetterande_nn_1_N = mkN "silhuetterande" ;
  silke_nn_1_N = mkN "silke" ;
  silkesnoere_nn_1_1_N = mkN "silkesnöre" ;
  silkessnoere_nn_1_1_N = mkN "silkessnöre" ;
  siluetterande_nn_1_N = mkN "siluetterande" ;
  silverinfattande_nn_1_N = mkN "silverinfattande" ;
  silversmide_nn_1_N = mkN "silversmide" ;
  silvrande_nn_1_N = mkN "silvrande" ;
  simborgarmaerke_nn_1_1_N = mkN "simborgarmärke" ;
  simbaelte_nn_1_1_N = mkN "simbälte" ;
  simmande_nn_1_N = mkN "simmande" ;
  simmaerke_nn_1_1_N = mkN "simmärke" ;
  simplifierande_nn_1_N = mkN "simplifierande" ;
  simsande_nn_1_N = mkN "simsande" ;
  simulerande_nn_1_N = mkN "simulerande" ;
  simultantolkande_nn_1_N = mkN "simultantolkande" ;
  sinande_nn_1_N = mkN "sinande" ;
  singlande_nn_1_N = mkN "singlande" ;
  sinkande_nn_1_N = mkN "sinkande" ;
  sinne_nn_1_N = mkN "sinne" ;
  sintrande_nn_1_N = mkN "sintrande" ;
  sipprande_nn_1_N = mkN "sipprande" ;
  sirande_nn_1_N = mkN "sirande" ;
  sirpande_nn_1_N = mkN "sirpande" ;
  sirrande_nn_1_N = mkN "sirrande" ;
  sisande_nn_1_N = mkN "sisande" ;
  sisyfusarbete_nn_1_N = mkN "sisyfusarbete" ;
  sittande_nn_1_N = mkN "sittande" ;
  sittbraede_nn_1_1_N = mkN "sittbräde" ;
  sittstrejkande_nn_1_N = mkN "sittstrejkande" ;
  sittupande_nn_1_N = mkN "sittupande" ;
  sittuppande_nn_1_N = mkN "sittuppande" ;
  situpande_nn_1_N = mkN "situpande" ;
  situppande_nn_1_N = mkN "situppande" ;
  sjabblande_nn_1_N = mkN "sjabblande" ;
  sjanghajande_nn_1_N = mkN "sjanghajande" ;
  sjangserande_nn_1_N = mkN "sjangserande" ;
  sjappande_nn_1_N = mkN "sjappande" ;
  sjasande_nn_1_N = mkN "sjasande" ;
  sjaskande_nn_1_N = mkN "sjaskande" ;
  sjavande_nn_1_N = mkN "sjavande" ;
  sjudande_nn_1_N = mkN "sjudande" ;
  sjukanmaelande_nn_1_1_N = mkN "sjukanmälande" ;
  sjuknande_nn_1_N = mkN "sjuknande" ;
  sjukskrivande_nn_1_N = mkN "sjukskrivande" ;
  sjukvaardsbitraede_nn_1_1_N = mkN "sjukvårdsbiträde" ;
  sjunkande_nn_1_N = mkN "sjunkande" ;
  sjaelvbespeglande_nn_1_1_N = mkN "självbespeglande" ;
  sjaelvbevarande_nn_1_1_N = mkN "självbevarande" ;
  sjaelvdoeende_nn_1_1_N = mkN "självdöende" ;
  sjaelvfinansierande_nn_1_1_N = mkN "självfinansierande" ;
  sjaelvfoerhaerligande_nn_1_1_N = mkN "självförhärligande" ;
  sjaelvlaekande_nn_1_1_N = mkN "självläkande" ;
  sjaelvmedvetande_nn_1_1_N = mkN "självmedvetande" ;
  sjaelvstyre_nn_1_1_N = mkN "självstyre" ;
  sjaelvstaendighetsstraevande_nn_1_1_N = mkN "självständighetssträvande" ;
  sjaelvtaendande_nn_1_1_N = mkN "självtändande" ;
  sjaelvoemkande_nn_1_1_N = mkN "självömkande" ;
  sjaaande_nn_1_1_N = mkN "sjåande" ;
  sjoemaerke_nn_1_1_N = mkN "sjömärke" ;
  sjoesaettande_nn_1_1_N = mkN "sjösättande" ;
  skadande_nn_1_N = mkN "skadande" ;
  skadereglerande_nn_1_N = mkN "skadereglerande" ;
  skadestaandsyrkande_nn_1_1_N = mkN "skadeståndsyrkande" ;
  skadskjutande_nn_1_N = mkN "skadskjutande" ;
  skaffande_nn_1_N = mkN "skaffande" ;
  skaftande_nn_1_N = mkN "skaftande" ;
  skakande_nn_1_N = mkN "skakande" ;
  skalande_nn_1_N = mkN "skalande" ;
  skaldande_nn_1_N = mkN "skaldande" ;
  skaldestycke_nn_1_N = mkN "skaldestycke" ;
  skalkande_nn_1_N = mkN "skalkande" ;
  skallande_nn_1_N = mkN "skallande" ;
  skallrande_nn_1_N = mkN "skallrande" ;
  skalperande_nn_1_N = mkN "skalperande" ;
  skamfilande_nn_1_N = mkN "skamfilande" ;
  skandalavsloejande_nn_1_1_N = mkN "skandalavslöjande" ;
  skandaliserande_nn_1_N = mkN "skandaliserande" ;
  skanderande_nn_1_N = mkN "skanderande" ;
  skannande_nn_1_N = mkN "skannande" ;
  skapande_nn_1_N = mkN "skapande" ;
  skaplynne_nn_1_N = mkN "skaplynne" ;
  skarpsinne_nn_1_N = mkN "skarpsinne" ;
  skarvande_nn_1_N = mkN "skarvande" ;
  skatande_nn_1_N = mkN "skatande" ;
  skattande_nn_1_N = mkN "skattande" ;
  skattefifflande_nn_1_N = mkN "skattefifflande" ;
  skattemaerke_nn_1_1_N = mkN "skattemärke" ;
  skatteplanerande_nn_1_N = mkN "skatteplanerande" ;
  skatteaerende_nn_1_1_N = mkN "skatteärende" ;
  skattlaeggande_nn_1_1_N = mkN "skattläggande" ;
  skattskrivande_nn_1_N = mkN "skattskrivande" ;
  skavande_nn_1_N = mkN "skavande" ;
  skedande_nn_1_N = mkN "skedande" ;
  skede_nn_1_N = mkN "skede" ;
  skeende_nn_1_N = mkN "skeende" ;
  skejtande_nn_1_N = mkN "skejtande" ;
  skelande_nn_1_N = mkN "skelande" ;
  skenande_nn_1_N = mkN "skenande" ;
  skeppande_nn_1_N = mkN "skeppande" ;
  skevande_nn_1_N = mkN "skevande" ;
  skevrande_nn_1_N = mkN "skevrande" ;
  skickande_nn_1_N = mkN "skickande" ;
  skidande_nn_1_N = mkN "skidande" ;
  skiftande_nn_1_N = mkN "skiftande" ;
  skiftarbete_nn_1_N = mkN "skiftarbete" ;
  skifte_nn_1_N = mkN "skifte" ;
  skiktande_nn_1_N = mkN "skiktande" ;
  skildrande_nn_1_N = mkN "skildrande" ;
  skiljande_nn_1_N = mkN "skiljande" ;
  skilje_nn_1_N = mkN "skilje" ;
  skiljefoerfarande_nn_1_1_N = mkN "skiljeförfarande" ;
  skimrande_nn_1_N = mkN "skimrande" ;
  skinande_nn_1_N = mkN "skinande" ;
  skingrande_nn_1_N = mkN "skingrande" ;
  skinnande_nn_1_N = mkN "skinnande" ;
  skipande_nn_1_N = mkN "skipande" ;
  skippande_nn_1_N = mkN "skippande" ;
  skirande_nn_1_N = mkN "skirande" ;
  skissande_nn_1_N = mkN "skissande" ;
  skisserande_nn_1_N = mkN "skisserande" ;
  skitande_nn_1_N = mkN "skitande" ;
  skitstaelle_nn_1_1_N = mkN "skitställe" ;
  skivande_nn_1_N = mkN "skivande" ;
  skivminne_nn_1_N = mkN "skivminne" ;
  skjutande_nn_1_N = mkN "skjutande" ;
  skjutsande_nn_1_N = mkN "skjutsande" ;
  skjuvande_nn_1_N = mkN "skjuvande" ;
  skoende_nn_1_N = mkN "skoende" ;
  skogsarbete_nn_1_N = mkN "skogsarbete" ;
  skogsbete_nn_1_N = mkN "skogsbete" ;
  skogsomraade_nn_1_1_N = mkN "skogsområde" ;
  skojande_nn_1_N = mkN "skojande" ;
  skolande_nn_1_N = mkN "skolande" ;
  skolarbete_nn_1_N = mkN "skolarbete" ;
  skolbygge_nn_1_N = mkN "skolbygge" ;
  skolkande_nn_1_N = mkN "skolkande" ;
  skolvaesende_nn_1_1_N = mkN "skolväsende" ;
  skolaemne_nn_1_1_N = mkN "skolämne" ;
  skonande_nn_1_N = mkN "skonande" ;
  skopande_nn_1_N = mkN "skopande" ;
  skorrande_nn_1_N = mkN "skorrande" ;
  skosnoere_nn_1_1_N = mkN "skosnöre" ;
  skotande_nn_1_N = mkN "skotande" ;
  skottande_nn_1_N = mkN "skottande" ;
  skottskadande_nn_1_N = mkN "skottskadande" ;
  skovlande_nn_1_N = mkN "skovlande" ;
  skrafferande_nn_1_N = mkN "skrafferande" ;
  skralnande_nn_1_N = mkN "skralnande" ;
  skraltande_nn_1_N = mkN "skraltande" ;
  skramlande_nn_1_N = mkN "skramlande" ;
  skrapande_nn_1_N = mkN "skrapande" ;
  skrattande_nn_1_N = mkN "skrattande" ;
  skrevande_nn_1_N = mkN "skrevande" ;
  skriande_nn_1_N = mkN "skriande" ;
  skridande_nn_1_N = mkN "skridande" ;
  skrikande_nn_1_N = mkN "skrikande" ;
  skrinlaeggande_nn_1_1_N = mkN "skrinläggande" ;
  skrinnande_nn_1_N = mkN "skrinnande" ;
  skrittande_nn_1_N = mkN "skrittande" ;
  skrivande_nn_1_N = mkN "skrivande" ;
  skrivhaefte_nn_1_1_N = mkN "skrivhäfte" ;
  skrockande_nn_1_N = mkN "skrockande" ;
  skroderande_nn_1_N = mkN "skroderande" ;
  skrotande_nn_1_N = mkN "skrotande" ;
  skrubbande_nn_1_N = mkN "skrubbande" ;
  skrudande_nn_1_N = mkN "skrudande" ;
  skrumpnande_nn_1_N = mkN "skrumpnande" ;
  skruvande_nn_1_N = mkN "skruvande" ;
  skruvstycke_nn_1_N = mkN "skruvstycke" ;
  skrymmande_nn_1_N = mkN "skrymmande" ;
  skrymsle_nn_1_N = mkN "skrymsle" ;
  skrymtande_nn_1_N = mkN "skrymtande" ;
  skrynklande_nn_1_N = mkN "skrynklande" ;
  skrytande_nn_1_N = mkN "skrytande" ;
  skrytbygge_nn_1_N = mkN "skrytbygge" ;
  skraeckvaelde_nn_1_1_N = mkN "skräckvälde" ;
  skraedande_nn_1_1_N = mkN "skrädande" ;
  skraeddande_nn_1_1_N = mkN "skräddande" ;
  skraeddarsyende_nn_1_1_N = mkN "skräddarsyende" ;
  skraellande_nn_1_1_N = mkN "skrällande" ;
  skraelle_nn_1_1_N = mkN "skrälle" ;
  skraemmande_nn_1_1_N = mkN "skrämmande" ;
  skraenande_nn_1_1_N = mkN "skränande" ;
  skraenkande_nn_1_1_N = mkN "skränkande" ;
  skraepande_nn_1_1_N = mkN "skräpande" ;
  skraeppande_nn_1_1_N = mkN "skräppande" ;
  skraevlande_nn_1_1_N = mkN "skrävlande" ;
  skraalande_nn_1_1_N = mkN "skrålande" ;
  skraamande_nn_1_1_N = mkN "skråmande" ;
  skubbande_nn_1_N = mkN "skubbande" ;
  skuddande_nn_1_N = mkN "skuddande" ;
  skuffande_nn_1_N = mkN "skuffande" ;
  skuggande_nn_1_N = mkN "skuggande" ;
  skuggboxande_nn_1_N = mkN "skuggboxande" ;
  skuldbelaeggande_nn_1_1_N = mkN "skuldbeläggande" ;
  skulpterande_nn_1_N = mkN "skulpterande" ;
  skulpturerande_nn_1_N = mkN "skulpturerande" ;
  skummande_nn_1_N = mkN "skummande" ;
  skumpande_nn_1_N = mkN "skumpande" ;
  skumraskfoerehavande_nn_1_1_N = mkN "skumraskförehavande" ;
  skumtvaettande_nn_1_1_N = mkN "skumtvättande" ;
  skurande_nn_1_N = mkN "skurande" ;
  skuttande_nn_1_N = mkN "skuttande" ;
  skvalande_nn_1_N = mkN "skvalande" ;
  skvallrande_nn_1_N = mkN "skvallrande" ;
  skvalpande_nn_1_N = mkN "skvalpande" ;
  skvaltande_nn_1_N = mkN "skvaltande" ;
  skvimpande_nn_1_N = mkN "skvimpande" ;
  skvisande_nn_1_N = mkN "skvisande" ;
  skvaettande_nn_1_1_N = mkN "skvättande" ;
  skyande_nn_1_N = mkN "skyande" ;
  skyddande_nn_1_N = mkN "skyddande" ;
  skyddshoelje_nn_1_1_N = mkN "skyddshölje" ;
  skyddsimpregnerande_nn_1_N = mkN "skyddsimpregnerande" ;
  skyddsomraade_nn_1_1_N = mkN "skyddsområde" ;
  skyddsympande_nn_1_N = mkN "skyddsympande" ;
  skyende_nn_1_N = mkN "skyende" ;
  skyfflande_nn_1_N = mkN "skyfflande" ;
  skyggande_nn_1_N = mkN "skyggande" ;
  skygge_nn_1_N = mkN "skygge" ;
  skylande_nn_1_N = mkN "skylande" ;
  skyldrande_nn_1_N = mkN "skyldrande" ;
  skyllande_nn_1_N = mkN "skyllande" ;
  skyltande_nn_1_N = mkN "skyltande" ;
  skymfande_nn_1_N = mkN "skymfande" ;
  skymlande_nn_1_N = mkN "skymlande" ;
  skymmande_nn_1_N = mkN "skymmande" ;
  skymtande_nn_1_N = mkN "skymtande" ;
  skyndande_nn_1_N = mkN "skyndande" ;
  skynke_nn_1_N = mkN "skynke" ;
  skytte_nn_1_N = mkN "skytte" ;
  skaeftande_nn_1_1_N = mkN "skäftande" ;
  skaeggande_nn_1_1_N = mkN "skäggande" ;
  skaektande_nn_1_1_N = mkN "skäktande" ;
  skaellande_nn_1_1_N = mkN "skällande" ;
  skaelmstycke_nn_1_1_N = mkN "skälmstycke" ;
  skaelvande_nn_1_1_N = mkN "skälvande" ;
  skaemmande_nn_1_1_N = mkN "skämmande" ;
  skaemtande_nn_1_1_N = mkN "skämtande" ;
  skaendande_nn_1_1_N = mkN "skändande" ;
  skaenkande_nn_1_1_N = mkN "skänkande" ;
  skaenklande_nn_1_1_N = mkN "skänklande" ;
  skaerande_nn_1_1_N = mkN "skärande" ;
  skaerbraede_nn_1_1_N = mkN "skärbräde" ;
  skaermbildande_nn_1_1_N = mkN "skärmbildande" ;
  skaerpande_nn_1_1_N = mkN "skärpande" ;
  skaerrande_nn_1_1_N = mkN "skärrande" ;
  skaerskaadande_nn_1_1_N = mkN "skärskådande" ;
  skaervande_nn_1_1_N = mkN "skärvande" ;
  skaadande_nn_1_1_N = mkN "skådande" ;
  skaalande_nn_1_1_N = mkN "skålande" ;
  skaallande_nn_1_1_N = mkN "skållande" ;
  skaangrande_nn_1_1_N = mkN "skångrande" ;
  skaapsupande_nn_1_1_N = mkN "skåpsupande" ;
  skaapaetande_nn_1_1_N = mkN "skåpätande" ;
  skaarande_nn_1_1_N = mkN "skårande" ;
  skoeldemaerke_nn_1_1_N = mkN "sköldemärke" ;
  skoeljande_nn_1_1_N = mkN "sköljande" ;
  skoelpande_nn_1_1_N = mkN "skölpande" ;
  skoenande_nn_2_1_N = mkN "skönande" ;
  skoenhetsvaerde_nn_1_1_N = mkN "skönhetsvärde" ;
  skoenjande_nn_1_1_N = mkN "skönjande" ;
  skoenmaalande_nn_1_1_N = mkN "skönmålande" ;
  skoenstaxerande_nn_1_1_N = mkN "skönstaxerande" ;
  skoentaxerande_nn_1_1_N = mkN "sköntaxerande" ;
  skoerande_nn_1_1_N = mkN "skörande" ;
  skoerdande_nn_1_1_N = mkN "skördande" ;
  skoernande_nn_1_1_N = mkN "skörnande" ;
  skoetande_nn_1_1_N = mkN "skötande" ;
  skoete_nn_1_1_N = mkN "sköte" ;
  skoevlande_nn_1_1_N = mkN "skövlande" ;
  slabbande_nn_1_N = mkN "slabbande" ;
  slabbrande_nn_1_N = mkN "slabbrande" ;
  slackande_nn_1_N = mkN "slackande" ;
  sladdande_nn_1_N = mkN "sladdande" ;
  sladdrande_nn_1_N = mkN "sladdrande" ;
  slafande_nn_1_N = mkN "slafande" ;
  slafsande_nn_1_N = mkN "slafsande" ;
  slaggande_nn_1_N = mkN "slaggande" ;
  slakande_nn_1_N = mkN "slakande" ;
  slaknande_nn_1_N = mkN "slaknande" ;
  slaktande_nn_1_N = mkN "slaktande" ;
  slammande_nn_1_N = mkN "slammande" ;
  slamrande_nn_1_N = mkN "slamrande" ;
  slamsande_nn_1_N = mkN "slamsande" ;
  slankande_nn_1_N = mkN "slankande" ;
  slanknande_nn_1_N = mkN "slanknande" ;
  slantande_nn_1_N = mkN "slantande" ;
  slappande_nn_1_N = mkN "slappande" ;
  slappnande_nn_1_N = mkN "slappnande" ;
  slarvande_nn_1_N = mkN "slarvande" ;
  slasande_nn_1_N = mkN "slasande" ;
  slaskande_nn_1_N = mkN "slaskande" ;
  slavande_nn_1_N = mkN "slavande" ;
  slavarbete_nn_1_N = mkN "slavarbete" ;
  slaviserande_nn_1_N = mkN "slaviserande" ;
  slavmaerke_nn_1_1_N = mkN "slavmärke" ;
  sleke_nn_1_N = mkN "sleke" ;
  slentrianmoerkande_nn_1_1_N = mkN "slentrianmörkande" ;
  slevande_nn_1_N = mkN "slevande" ;
  slickande_nn_1_N = mkN "slickande" ;
  sliktande_nn_1_N = mkN "sliktande" ;
  slingrande_nn_1_N = mkN "slingrande" ;
  slinkande_nn_1_N = mkN "slinkande" ;
  slintande_nn_1_N = mkN "slintande" ;
  slipande_nn_1_N = mkN "slipande" ;
  slippande_nn_1_N = mkN "slippande" ;
  slirande_nn_1_N = mkN "slirande" ;
  slitande_nn_1_N = mkN "slitande" ;
  slitsande_nn_1_N = mkN "slitsande" ;
  slocknande_nn_1_N = mkN "slocknande" ;
  slokande_nn_1_N = mkN "slokande" ;
  slopande_nn_1_N = mkN "slopande" ;
  slubbande_nn_1_N = mkN "slubbande" ;
  sluddrande_nn_1_N = mkN "sluddrande" ;
  sluggande_nn_1_N = mkN "sluggande" ;
  slukande_nn_1_N = mkN "slukande" ;
  slumomraade_nn_1_1_N = mkN "slumområde" ;
  slumpande_nn_1_N = mkN "slumpande" ;
  slumrande_nn_1_N = mkN "slumrande" ;
  slungande_nn_1_N = mkN "slungande" ;
  slussande_nn_1_N = mkN "slussande" ;
  slutande_nn_1_N = mkN "slutande" ;
  slutbehandlande_nn_1_N = mkN "slutbehandlande" ;
  slutfoerande_nn_1_1_N = mkN "slutförande" ;
  slutomdoeme_nn_1_1_N = mkN "slutomdöme" ;
  slutplaederande_nn_1_1_N = mkN "slutpläderande" ;
  slutskede_nn_1_N = mkN "slutskede" ;
  slutstycke_nn_1_N = mkN "slutstycke" ;
  sluttande_nn_1_N = mkN "sluttande" ;
  slaeckande_nn_1_1_N = mkN "släckande" ;
  slaeggande_nn_1_1_N = mkN "släggande" ;
  slaekte_nn_1_1_N = mkN "släkte" ;
  slaektskapsfoerhaallande_nn_1_1_N = mkN "släktskapsförhållande" ;
  slaengande_nn_1_1_N = mkN "slängande" ;
  slaentrande_nn_1_1_N = mkN "släntrande" ;
  slaepande_nn_1_1_N = mkN "släpande" ;
  slaeppande_nn_1_1_N = mkN "släppande" ;
  slaetande_nn_1_1_N = mkN "slätande" ;
  slaetrakande_nn_1_1_N = mkN "slätrakande" ;
  slaetslipande_nn_1_1_N = mkN "slätslipande" ;
  slaaende_nn_1_1_N = mkN "slående" ;
  slaattande_nn_1_1_N = mkN "slåttande" ;
  sloeande_nn_1_1_N = mkN "slöande" ;
  sloejdande_nn_1_1_N = mkN "slöjdande" ;
  sloerande_nn_1_1_N = mkN "slörande" ;
  sloesande_nn_1_1_N = mkN "slösande" ;
  sloetittande_nn_1_1_N = mkN "slötittande" ;
  smackande_nn_1_N = mkN "smackande" ;
  smakande_nn_1_N = mkN "smakande" ;
  smaksinne_nn_1_N = mkN "smaksinne" ;
  smaksaettande_nn_1_1_N = mkN "smaksättande" ;
  smakaemne_nn_1_1_N = mkN "smakämne" ;
  smalfilmande_nn_1_N = mkN "smalfilmande" ;
  smalnande_nn_1_N = mkN "smalnande" ;
  smarrande_nn_1_N = mkN "smarrande" ;
  smashande_nn_1_N = mkN "smashande" ;
  smaskande_nn_1_N = mkN "smaskande" ;
  smattrande_nn_1_N = mkN "smattrande" ;
  smekande_nn_1_N = mkN "smekande" ;
  smetande_nn_1_N = mkN "smetande" ;
  smickrande_nn_1_N = mkN "smickrande" ;
  smidande_nn_1_N = mkN "smidande" ;
  smide_nn_1_N = mkN "smide" ;
  smidjebaelte_nn_1_1_N = mkN "smidjebälte" ;
  smilande_nn_1_N = mkN "smilande" ;
  sminkande_nn_1_N = mkN "sminkande" ;
  smiskande_nn_1_N = mkN "smiskande" ;
  smitande_nn_1_N = mkN "smitande" ;
  smittande_nn_1_N = mkN "smittande" ;
  smittaemne_nn_1_1_N = mkN "smittämne" ;
  smockande_nn_1_N = mkN "smockande" ;
  smsande_nn_1_N = mkN "sms:ande" ;
  smugglande_nn_1_N = mkN "smugglande" ;
  smulande_nn_1_N = mkN "smulande" ;
  smultande_nn_1_N = mkN "smultande" ;
  smultronstaelle_nn_1_1_N = mkN "smultronställe" ;
  smusslande_nn_1_N = mkN "smusslande" ;
  smutsande_nn_1_N = mkN "smutsande" ;
  smutskastande_nn_1_N = mkN "smutskastande" ;
  smuttande_nn_1_N = mkN "smuttande" ;
  smyckande_nn_1_N = mkN "smyckande" ;
  smycke_nn_1_N = mkN "smycke" ;
  smygande_nn_1_N = mkN "smygande" ;
  smygfilmande_nn_1_N = mkN "smygfilmande" ;
  smyglyssnande_nn_1_N = mkN "smyglyssnande" ;
  smygsupande_nn_1_N = mkN "smygsupande" ;
  smygtittande_nn_1_N = mkN "smygtittande" ;
  smygaetande_nn_1_1_N = mkN "smygätande" ;
  smaeckande_nn_1_1_N = mkN "smäckande" ;
  smaedande_nn_1_1_N = mkN "smädande" ;
  smaektande_nn_1_1_N = mkN "smäktande" ;
  smaellande_nn_1_1_N = mkN "smällande" ;
  smaeltande_nn_1_1_N = mkN "smältande" ;
  smaertande_nn_1_1_N = mkN "smärtande" ;
  smaertsinne_nn_1_1_N = mkN "smärtsinne" ;
  smaettande_nn_1_1_N = mkN "smättande" ;
  smaaflinande_nn_1_1_N = mkN "småflinande" ;
  smaagraelande_nn_1_1_N = mkN "smågrälande" ;
  smaaleende_nn_1_1_N = mkN "småleende" ;
  smaapratande_nn_1_1_N = mkN "småpratande" ;
  smaasjungande_nn_1_1_N = mkN "småsjungande" ;
  smaasovande_nn_1_1_N = mkN "småsovande" ;
  smaaspringande_nn_1_1_N = mkN "småspringande" ;
  smaasvaerande_nn_1_1_N = mkN "småsvärande" ;
  smoerande_nn_1_1_N = mkN "smörande" ;
  smoerfraesande_nn_1_1_N = mkN "smörfräsande" ;
  smoerjande_nn_1_1_N = mkN "smörjande" ;
  snabbfrysande_nn_1_N = mkN "snabbfrysande" ;
  snabbgranskande_nn_1_N = mkN "snabbgranskande" ;
  snabbspolande_nn_1_N = mkN "snabbspolande" ;
  snabbspaenne_nn_1_1_N = mkN "snabbspänne" ;
  snabbtecknande_nn_1_N = mkN "snabbtecknande" ;
  snabbutredande_nn_1_N = mkN "snabbutredande" ;
  snackande_nn_1_N = mkN "snackande" ;
  snaggande_nn_1_N = mkN "snaggande" ;
  snappande_nn_1_N = mkN "snappande" ;
  snapsande_nn_1_N = mkN "snapsande" ;
  snarande_nn_1_N = mkN "snarande" ;
  snarkande_nn_1_N = mkN "snarkande" ;
  snarpande_nn_1_N = mkN "snarpande" ;
  snarrande_nn_1_N = mkN "snarrande" ;
  snaskande_nn_1_N = mkN "snaskande" ;
  snattande_nn_1_N = mkN "snattande" ;
  snattrande_nn_1_N = mkN "snattrande" ;
  snavande_nn_1_N = mkN "snavande" ;
  sneddande_nn_1_N = mkN "sneddande" ;
  snedparkerande_nn_1_N = mkN "snedparkerande" ;
  snedrekryterande_nn_1_N = mkN "snedrekryterande" ;
  snedstaellande_nn_1_1_N = mkN "snedställande" ;
  snedvridande_nn_1_N = mkN "snedvridande" ;
  sneglande_nn_1_N = mkN "sneglande" ;
  snickarbaelte_nn_1_1_N = mkN "snickarbälte" ;
  snickarfoerklaede_nn_1_1_N = mkN "snickarförkläde" ;
  snickrande_nn_1_N = mkN "snickrande" ;
  snidande_nn_1_N = mkN "snidande" ;
  sniffande_nn_1_N = mkN "sniffande" ;
  snikande_nn_1_N = mkN "snikande" ;
  snille_nn_1_N = mkN "snille" ;
  snirklande_nn_1_N = mkN "snirklande" ;
  snitsande_nn_1_N = mkN "snitsande" ;
  snitslande_nn_1_N = mkN "snitslande" ;
  snittande_nn_1_N = mkN "snittande" ;
  snobbande_nn_1_N = mkN "snobbande" ;
  snoende_nn_1_N = mkN "snoende" ;
  snokande_nn_1_N = mkN "snokande" ;
  snoppande_nn_1_N = mkN "snoppande" ;
  snorande_nn_1_N = mkN "snorande" ;
  snorklande_nn_1_N = mkN "snorklande" ;
  snortande_nn_1_N = mkN "snortande" ;
  snubbande_nn_1_N = mkN "snubbande" ;
  snubblande_nn_1_N = mkN "snubblande" ;
  snuddande_nn_1_N = mkN "snuddande" ;
  snurrande_nn_1_N = mkN "snurrande" ;
  snusande_nn_1_N = mkN "snusande" ;
  snuskande_nn_1_N = mkN "snuskande" ;
  snusmalande_nn_1_N = mkN "snusmalande" ;
  snuvande_nn_1_N = mkN "snuvande" ;
  snyftande_nn_1_N = mkN "snyftande" ;
  snyltande_nn_1_N = mkN "snyltande" ;
  snytande_nn_1_N = mkN "snytande" ;
  snyte_nn_1_N = mkN "snyte" ;
  snaeppande_nn_1_1_N = mkN "snäppande" ;
  snaerjande_nn_1_1_N = mkN "snärjande" ;
  snaerje_nn_1_1_N = mkN "snärje" ;
  snaerpande_nn_1_1_N = mkN "snärpande" ;
  snaertande_nn_1_1_N = mkN "snärtande" ;
  snaesande_nn_1_1_N = mkN "snäsande" ;
  snaevande_nn_1_1_N = mkN "snävande" ;
  snaalande_nn_1_1_N = mkN "snålande" ;
  snoeande_nn_1_1_N = mkN "snöande" ;
  snoebraede_nn_1_1_N = mkN "snöbräde" ;
  snoemulande_nn_1_1_N = mkN "snömulande" ;
  snoepande_nn_1_1_N = mkN "snöpande" ;
  snoeplogande_nn_1_1_N = mkN "snöplogande" ;
  snoerande_nn_1_1_N = mkN "snörande" ;
  snoere_nn_1_1_N = mkN "snöre" ;
  snoerpande_nn_1_1_N = mkN "snörpande" ;
  snoervlande_nn_1_1_N = mkN "snörvlande" ;
  snoetaecke_nn_1_1_N = mkN "snötäcke" ;
  socialarbete_nn_1_N = mkN "socialarbete" ;
  socialiserande_nn_1_N = mkN "socialiserande" ;
  sockersaltande_nn_1_N = mkN "sockersaltande" ;
  sockrande_nn_1_N = mkN "sockrande" ;
  sodomsaepple_nn_1_1_N = mkN "sodomsäpple" ;
  soffsurfande_nn_1_N = mkN "soffsurfande" ;
  sol_och_vaarande_nn_1_1_N = mkN "sol-och-vårande" ;
  solande_nn_1_N = mkN "solande" ;
  solbadande_nn_1_N = mkN "solbadande" ;
  solkande_nn_1_N = mkN "solkande" ;
  solochvaarande_nn_1_1_N = mkN "solochvårande" ;
  soltorkande_nn_1_N = mkN "soltorkande" ;
  solvande_nn_1_N = mkN "solvande" ;
  solverande_nn_1_N = mkN "solverande" ;
  sommarnoeje_nn_1_1_N = mkN "sommarnöje" ;
  sommarstaelle_nn_1_1_N = mkN "sommarställe" ;
  somnande_nn_1_N = mkN "somnande" ;
  sonande_nn_1_N = mkN "sonande" ;
  sonderande_nn_1_N = mkN "sonderande" ;
  sondmatande_nn_1_N = mkN "sondmatande" ;
  sopande_nn_1_N = mkN "sopande" ;
  sopbaelte_nn_1_1_N = mkN "sopbälte" ;
  sordinerande_nn_1_N = mkN "sordinerande" ;
  sorgearbete_nn_1_N = mkN "sorgearbete" ;
  sorgeaemne_nn_1_1_N = mkN "sorgeämne" ;
  sorlande_nn_1_N = mkN "sorlande" ;
  sorterande_nn_1_N = mkN "sorterande" ;
  sotande_nn_1_N = mkN "sotande" ;
  soulagerande_nn_1_N = mkN "soulagerande" ;
  sovande_nn_1_N = mkN "sovande" ;
  sovjetiserande_nn_1_N = mkN "sovjetiserande" ;
  sovrande_nn_1_N = mkN "sovrande" ;
  spacklande_nn_1_N = mkN "spacklande" ;
  spadvaendande_nn_1_1_N = mkN "spadvändande" ;
  spakande_nn_1_N = mkN "spakande" ;
  spaknande_nn_1_N = mkN "spaknande" ;
  spaljerande_nn_1_N = mkN "spaljerande" ;
  spallerande_nn_1_N = mkN "spallerande" ;
  spaltande_nn_1_N = mkN "spaltande" ;
  spanande_nn_1_N = mkN "spanande" ;
  spankulerande_nn_1_N = mkN "spankulerande" ;
  spanskvaelde_nn_1_1_N = mkN "spanskvälde" ;
  sparande_nn_1_N = mkN "sparande" ;
  sparkande_nn_1_N = mkN "sparkande" ;
  sparrande_nn_1_N = mkN "sparrande" ;
  spatserande_nn_1_N = mkN "spatserande" ;
  specialarbete_nn_1_N = mkN "specialarbete" ;
  specialintresse_nn_1_N = mkN "specialintresse" ;
  specialiserande_nn_1_N = mkN "specialiserande" ;
  specialomraade_nn_1_1_N = mkN "specialområde" ;
  specificerande_nn_1_N = mkN "specificerande" ;
  speciminerande_nn_1_N = mkN "speciminerande" ;
  speglande_nn_1_N = mkN "speglande" ;
  spejande_nn_1_N = mkN "spejande" ;
  spekulerande_nn_1_N = mkN "spekulerande" ;
  spelande_nn_1_N = mkN "spelande" ;
  spelarbyte_nn_1_N = mkN "spelarbyte" ;
  spenderande_nn_1_N = mkN "spenderande" ;
  spetande_nn_1_N = mkN "spetande" ;
  spetsande_nn_1_N = mkN "spetsande" ;
  spettande_nn_1_N = mkN "spettande" ;
  spexande_nn_1_N = mkN "spexande" ;
  spikande_nn_1_N = mkN "spikande" ;
  spilande_nn_1_N = mkN "spilande" ;
  spillande_nn_1_N = mkN "spillande" ;
  spinnande_nn_1_N = mkN "spinnande" ;
  spionerande_nn_1_N = mkN "spionerande" ;
  spirande_nn_1_N = mkN "spirande" ;
  spisande_nn_1_N = mkN "spisande" ;
  spjaelande_nn_1_1_N = mkN "spjälande" ;
  spjaelkande_nn_1_1_N = mkN "spjälkande" ;
  spjaellsnoere_nn_1_1_N = mkN "spjällsnöre" ;
  spjaernande_nn_1_1_N = mkN "spjärnande" ;
  splintande_nn_1_N = mkN "splintande" ;
  splissande_nn_1_N = mkN "splissande" ;
  splitsande_nn_1_N = mkN "splitsande" ;
  splittrande_nn_1_N = mkN "splittrande" ;
  spolande_nn_1_N = mkN "spolande" ;
  spolierande_nn_1_N = mkN "spolierande" ;
  sponsrande_nn_1_N = mkN "sponsrande" ;
  spontande_nn_1_N = mkN "spontande" ;
  sporgoemme_nn_1_1_N = mkN "sporgömme" ;
  sporrande_nn_1_N = mkN "sporrande" ;
  sportande_nn_1_N = mkN "sportande" ;
  spottande_nn_1_N = mkN "spottande" ;
  sprakande_nn_1_N = mkN "sprakande" ;
  sprallande_nn_1_N = mkN "sprallande" ;
  sprattlande_nn_1_N = mkN "sprattlande" ;
  sprayande_nn_1_N = mkN "sprayande" ;
  spraymunstycke_nn_1_N = mkN "spraymunstycke" ;
  sprejande_nn_1_N = mkN "sprejande" ;
  sprejmunstycke_nn_1_N = mkN "sprejmunstycke" ;
  spretande_nn_1_N = mkN "spretande" ;
  sprickande_nn_1_N = mkN "sprickande" ;
  spridande_nn_1_N = mkN "spridande" ;
  springande_nn_1_N = mkN "springande" ;
  sprintande_nn_1_N = mkN "sprintande" ;
  spritande_nn_1_N = mkN "spritande" ;
  spritsande_nn_1_N = mkN "spritsande" ;
  sprittande_nn_1_N = mkN "sprittande" ;
  sprudlande_nn_1_N = mkN "sprudlande" ;
  sprutande_nn_1_N = mkN "sprutande" ;
  sprutbyte_nn_1_N = mkN "sprutbyte" ;
  sprutlackerande_nn_1_N = mkN "sprutlackerande" ;
  sprutmaalande_nn_1_1_N = mkN "sprutmålande" ;
  spraeckande_nn_1_1_N = mkN "spräckande" ;
  spraengande_nn_1_1_N = mkN "sprängande" ;
  spraengarbete_nn_1_1_N = mkN "sprängarbete" ;
  spraengningsarbete_nn_1_1_N = mkN "sprängningsarbete" ;
  spraengaemne_nn_1_1_N = mkN "sprängämne" ;
  spraettande_nn_1_1_N = mkN "sprättande" ;
  spraakande_nn_1_1_N = mkN "språkande" ;
  spraakbyte_nn_1_1_N = mkN "språkbyte" ;
  spraakmoete_nn_1_1_N = mkN "språkmöte" ;
  sproetande_nn_1_1_N = mkN "sprötande" ;
  spurtande_nn_1_N = mkN "spurtande" ;
  spyende_nn_1_N = mkN "spyende" ;
  spaeckande_nn_1_1_N = mkN "späckande" ;
  spaedande_nn_1_1_N = mkN "spädande" ;
  spaekande_nn_1_1_N = mkN "späkande" ;
  spaennande_nn_1_1_N = mkN "spännande" ;
  spaenne_nn_1_1_N = mkN "spänne" ;
  spaenstande_nn_1_1_N = mkN "spänstande" ;
  spaentande_nn_1_1_N = mkN "späntande" ;
  spaerrande_nn_1_1_N = mkN "spärrande" ;
  spaaende_nn_1_1_N = mkN "spående" ;
  spaanande_nn_1_1_N = mkN "spånande" ;
  spaangande_nn_1_1_N = mkN "spångande" ;
  spaantande_nn_1_1_N = mkN "spåntande" ;
  spaaraemne_nn_1_1_N = mkN "spårämne" ;
  spoeande_nn_1_1_N = mkN "spöande" ;
  spoekande_nn_1_1_N = mkN "spökande" ;
  spoeke_nn_1_1_N = mkN "spöke" ;
  spoerjande_nn_1_1_N = mkN "spörjande" ;
  stabiliserande_nn_1_N = mkN "stabiliserande" ;
  stackande_nn_1_N = mkN "stackande" ;
  stadfaestande_nn_1_1_N = mkN "stadfästande" ;
  stadgande_nn_1_N = mkN "stadgande" ;
  stadsplanerande_nn_1_N = mkN "stadsplanerande" ;
  stadvaendande_nn_1_1_N = mkN "stadvändande" ;
  stafferande_nn_1_N = mkN "stafferande" ;
  stagande_nn_1_N = mkN "stagande" ;
  stagnerande_nn_1_N = mkN "stagnerande" ;
  stagvaendande_nn_1_1_N = mkN "stagvändande" ;
  stakande_nn_1_N = mkN "stakande" ;
  stalkande_nn_1_N = mkN "stalkande" ;
  stallande_nn_1_N = mkN "stallande" ;
  stammande_nn_1_N = mkN "stammande" ;
  stampande_nn_1_N = mkN "stampande" ;
  stamsamhaelle_nn_1_1_N = mkN "stamsamhälle" ;
  standardiserande_nn_1_N = mkN "standardiserande" ;
  stannande_nn_1_N = mkN "stannande" ;
  stansande_nn_1_N = mkN "stansande" ;
  staplande_nn_1_N = mkN "staplande" ;
  stapplande_nn_1_N = mkN "stapplande" ;
  starrbligande_nn_1_N = mkN "starrbligande" ;
  startande_nn_1_N = mkN "startande" ;
  startsnoere_nn_1_1_N = mkN "startsnöre" ;
  stassande_nn_1_N = mkN "stassande" ;
  staterande_nn_1_N = mkN "staterande" ;
  stationerande_nn_1_N = mkN "stationerande" ;
  stationssamhaelle_nn_1_1_N = mkN "stationssamhälle" ;
  statsbygge_nn_1_N = mkN "statsbygge" ;
  statuerande_nn_1_N = mkN "statuerande" ;
  stavande_nn_1_N = mkN "stavande" ;
  stegande_nn_1_N = mkN "stegande" ;
  steglande_nn_1_N = mkN "steglande" ;
  stegrande_nn_1_N = mkN "stegrande" ;
  stekande_nn_1_N = mkN "stekande" ;
  stelnande_nn_1_N = mkN "stelnande" ;
  stenande_nn_1_N = mkN "stenande" ;
  stenansikte_nn_1_N = mkN "stenansikte" ;
  stencilerande_nn_1_N = mkN "stencilerande" ;
  stenkastande_nn_1_N = mkN "stenkastande" ;
  stenograferande_nn_1_N = mkN "stenograferande" ;
  stenroese_nn_1_1_N = mkN "stenröse" ;
  steppande_nn_1_N = mkN "steppande" ;
  stereofotograferande_nn_1_N = mkN "stereofotograferande" ;
  stereotyperande_nn_1_N = mkN "stereotyperande" ;
  steriliserande_nn_1_N = mkN "steriliserande" ;
  stickande_nn_1_N = mkN "stickande" ;
  stiftande_nn_1_N = mkN "stiftande" ;
  stigande_nn_1_N = mkN "stigande" ;
  stigmatiserande_nn_1_N = mkN "stigmatiserande" ;
  stilande_nn_1_N = mkN "stilande" ;
  stiliserande_nn_1_N = mkN "stiliserande" ;
  stillande_nn_1_N = mkN "stillande" ;
  stillnande_nn_1_N = mkN "stillnande" ;
  stimmande_nn_1_N = mkN "stimmande" ;
  stimulerande_nn_1_N = mkN "stimulerande" ;
  stingande_nn_1_N = mkN "stingande" ;
  stinkande_nn_1_N = mkN "stinkande" ;
  stipendierande_nn_1_N = mkN "stipendierande" ;
  stipulerande_nn_1_N = mkN "stipulerande" ;
  stirrande_nn_1_N = mkN "stirrande" ;
  stjaelande_nn_1_1_N = mkN "stjälande" ;
  stjaelpande_nn_1_1_N = mkN "stjälpande" ;
  stockande_nn_1_N = mkN "stockande" ;
  stofferande_nn_1_N = mkN "stofferande" ;
  stojande_nn_1_N = mkN "stojande" ;
  stolpande_nn_1_N = mkN "stolpande" ;
  stoltserande_nn_1_N = mkN "stoltserande" ;
  stomatolleende_nn_1_N = mkN "stomatolleende" ;
  stoppande_nn_1_N = mkN "stoppande" ;
  storebrorssamhaelle_nn_1_1_N = mkN "storebrorssamhälle" ;
  storfurstendoeme_nn_1_1_N = mkN "storfurstendöme" ;
  storgraatande_nn_1_1_N = mkN "storgråtande" ;
  storhandlande_nn_1_N = mkN "storhandlande" ;
  storhetsvansinne_nn_1_N = mkN "storhetsvansinne" ;
  storknande_nn_1_N = mkN "storknande" ;
  stormaktsvaelde_nn_1_1_N = mkN "stormaktsvälde" ;
  stormande_nn_1_N = mkN "stormande" ;
  stormskaellande_nn_1_1_N = mkN "stormskällande" ;
  stormsaekrande_nn_1_1_N = mkN "stormsäkrande" ;
  stormoete_nn_1_1_N = mkN "stormöte" ;
  storsatsande_nn_1_N = mkN "storsatsande" ;
  straffande_nn_1_N = mkN "straffande" ;
  straffarbete_nn_1_N = mkN "straffarbete" ;
  straffomraade_nn_1_1_N = mkN "straffområde" ;
  straffoerelaeggande_nn_1_1_N = mkN "strafföreläggande" ;
  stramande_nn_1_N = mkN "stramande" ;
  strandande_nn_1_N = mkN "strandande" ;
  strandsaettande_nn_1_1_N = mkN "strandsättande" ;
  strangulerande_nn_1_N = mkN "strangulerande" ;
  stratifierande_nn_1_N = mkN "stratifierande" ;
  streakande_nn_1_N = mkN "streakande" ;
  streckande_nn_1_N = mkN "streckande" ;
  strejkande_nn_1_N = mkN "strejkande" ;
  stressande_nn_1_N = mkN "stressande" ;
  stretande_nn_1_N = mkN "stretande" ;
  stretchande_nn_1_N = mkN "stretchande" ;
  stridande_nn_1_N = mkN "stridande" ;
  stridsformerande_nn_1_N = mkN "stridsformerande" ;
  stridsgrupperande_nn_1_N = mkN "stridsgrupperande" ;
  stridsaepple_nn_1_1_N = mkN "stridsäpple" ;
  striglande_nn_1_N = mkN "striglande" ;
  strilande_nn_1_N = mkN "strilande" ;
  strimlande_nn_1_N = mkN "strimlande" ;
  stripande_nn_1_N = mkN "stripande" ;
  strippande_nn_1_N = mkN "strippande" ;
  strosande_nn_1_N = mkN "strosande" ;
  strukturerande_nn_1_N = mkN "strukturerande" ;
  strukturrationaliserande_nn_1_N = mkN "strukturrationaliserande" ;
  strulande_nn_1_N = mkN "strulande" ;
  struntande_nn_1_N = mkN "struntande" ;
  struttande_nn_1_N = mkN "struttande" ;
  strykande_nn_1_N = mkN "strykande" ;
  strykbraede_nn_1_1_N = mkN "strykbräde" ;
  strypande_nn_1_N = mkN "strypande" ;
  strypmaerke_nn_1_1_N = mkN "strypmärke" ;
  straeckande_nn_1_1_N = mkN "sträckande" ;
  straecklaesande_nn_1_1_N = mkN "sträckläsande" ;
  straengande_nn_1_1_N = mkN "strängande" ;
  straevande_nn_1_1_N = mkN "strävande" ;
  straalande_nn_1_1_N = mkN "strålande" ;
  straalknippe_nn_1_1_N = mkN "strålknippe" ;
  straalkonserverande_nn_1_1_N = mkN "strålkonserverande" ;
  straalningsarbete_nn_1_1_N = mkN "strålningsarbete" ;
  straalningsbaelte_nn_1_1_N = mkN "strålningsbälte" ;
  straalskyddsarbete_nn_1_1_N = mkN "strålskyddsarbete" ;
  stroeende_nn_1_1_N = mkN "ströende" ;
  stroemmande_nn_1_1_N = mkN "strömmande" ;
  stroepplande_nn_1_1_N = mkN "ströpplande" ;
  stroevande_nn_1_1_N = mkN "strövande" ;
  stroevomraade_nn_1_1_N = mkN "strövområde" ;
  stubbande_nn_1_N = mkN "stubbande" ;
  studentfirande_nn_1_N = mkN "studentfirande" ;
  studentinflytande_nn_1_N = mkN "studentinflytande" ;
  studerande_nn_2_N = mkN "studerande" ;
  studieorienterande_nn_1_N = mkN "studieorienterande" ;
  studsande_nn_1_N = mkN "studsande" ;
  stukande_nn_1_N = mkN "stukande" ;
  stultande_nn_1_N = mkN "stultande" ;
  stundande_nn_1_N = mkN "stundande" ;
  stupande_nn_1_N = mkN "stupande" ;
  sturande_nn_1_N = mkN "sturande" ;
  stuvande_nn_1_N = mkN "stuvande" ;
  styckande_nn_1_N = mkN "styckande" ;
  stycke_nn_1_N = mkN "stycke" ;
  styltande_nn_1_N = mkN "styltande" ;
  stympande_nn_1_N = mkN "stympande" ;
  styrande_nn_1_N = mkN "styrande" ;
  styre_nn_1_N = mkN "styre" ;
  styre_nn_2_N = mkN "styre" ;
  styrkande_nn_1_N = mkN "styrkande" ;
  styrkefoerhaallande_nn_1_1_N = mkN "styrkeförhållande" ;
  styvande_nn_1_N = mkN "styvande" ;
  styvnande_nn_1_N = mkN "styvnande" ;
  staeckande_nn_1_1_N = mkN "stäckande" ;
  staedande_nn_1_1_N = mkN "städande" ;
  staedjande_nn_1_1_N = mkN "städjande" ;
  staedslande_nn_1_1_N = mkN "städslande" ;
  staellande_nn_1_1_N = mkN "ställande" ;
  staelle_nn_1_1_N = mkN "ställe" ;
  staellningstagande_nn_1_1_N = mkN "ställningstagande" ;
  staemmande_nn_1_1_N = mkN "stämmande" ;
  staemningslaege_nn_1_1_N = mkN "stämningsläge" ;
  staemplande_nn_1_1_N = mkN "stämplande" ;
  staengande_nn_1_1_N = mkN "stängande" ;
  staenge_nn_1_1_N = mkN "stänge" ;
  staengslande_nn_1_1_N = mkN "stängslande" ;
  staenkande_nn_1_1_N = mkN "stänkande" ;
  staerkande_nn_1_1_N = mkN "stärkande" ;
  staevande_nn_1_1_N = mkN "stävande" ;
  staevjande_nn_1_1_N = mkN "stävjande" ;
  staaende_nn_1_1_N = mkN "stående" ;
  staandande_nn_1_1_N = mkN "ståndande" ;
  staangande_nn_1_1_N = mkN "stångande" ;
  staankande_nn_1_1_N = mkN "stånkande" ;
  staatande_nn_1_1_N = mkN "ståtande" ;
  stoedboende_nn_1_1_N = mkN "stödboende" ;
  stoedjande_nn_1_1_N = mkN "stödjande" ;
  stoedkoepande_nn_1_1_N = mkN "stödköpande" ;
  stoedomraade_nn_1_1_N = mkN "stödområde" ;
  stoedroestande_nn_1_1_N = mkN "stödröstande" ;
  stoekande_nn_1_1_N = mkN "stökande" ;
  stoenande_nn_1_1_N = mkN "stönande" ;
  stoepande_nn_1_1_N = mkN "stöpande" ;
  stoepplande_nn_1_1_N = mkN "stöpplande" ;
  stoerande_nn_1_1_N = mkN "störande" ;
  stoertande_nn_1_1_N = mkN "störtande" ;
  stoetande_nn_1_1_N = mkN "stötande" ;
  stoettande_nn_1_1_N = mkN "stöttande" ;
  stoevlande_nn_1_1_N = mkN "stövlande" ;
  sublimerande_nn_1_N = mkN "sublimerande" ;
  subordinerande_nn_1_N = mkN "subordinerande" ;
  subsidierande_nn_1_N = mkN "subsidierande" ;
  subskriberande_nn_1_N = mkN "subskriberande" ;
  substantiverande_nn_1_N = mkN "substantiverande" ;
  substituerande_nn_1_N = mkN "substituerande" ;
  subsumerande_nn_1_N = mkN "subsumerande" ;
  subtraherande_nn_1_N = mkN "subtraherande" ;
  subventionerande_nn_1_N = mkN "subventionerande" ;
  succederande_nn_1_N = mkN "succederande" ;
  suckande_nn_1_N = mkN "suckande" ;
  suddande_nn_1_N = mkN "suddande" ;
  suffigerande_nn_1_N = mkN "suffigerande" ;
  sufflerande_nn_1_N = mkN "sufflerande" ;
  sugande_nn_1_N = mkN "sugande" ;
  suggererande_nn_1_N = mkN "suggererande" ;
  suktande_nn_1_N = mkN "suktande" ;
  sulande_nn_1_N = mkN "sulande" ;
  summande_nn_1_N = mkN "summande" ;
  summerande_nn_1_N = mkN "summerande" ;
  sumpande_nn_1_N = mkN "sumpande" ;
  sumpomraade_nn_1_1_N = mkN "sumpområde" ;
  supande_nn_1_N = mkN "supande" ;
  superande_nn_1_N = mkN "superande" ;
  supplerande_nn_1_N = mkN "supplerande" ;
  supponerande_nn_1_N = mkN "supponerande" ;
  suppurerande_nn_1_N = mkN "suppurerande" ;
  surande_nn_1_N = mkN "surande" ;
  surfande_nn_1_N = mkN "surfande" ;
  surfbraede_nn_1_1_N = mkN "surfbräde" ;
  surfingbraede_nn_1_1_N = mkN "surfingbräde" ;
  surnande_nn_1_N = mkN "surnande" ;
  surrande_nn_1_N = mkN "surrande" ;
  susande_nn_1_N = mkN "susande" ;
  suspenderande_nn_1_N = mkN "suspenderande" ;
  sussande_nn_1_N = mkN "sussande" ;
  svabbande_nn_1_N = mkN "svabbande" ;
  svajande_nn_1_N = mkN "svajande" ;
  svalkande_nn_1_N = mkN "svalkande" ;
  svallande_nn_1_N = mkN "svallande" ;
  svalnande_nn_1_N = mkN "svalnande" ;
  svamlande_nn_1_N = mkN "svamlande" ;
  svankande_nn_1_N = mkN "svankande" ;
  svansande_nn_1_N = mkN "svansande" ;
  svarande_nn_2_N = mkN "svarande" ;
  svartbygge_nn_1_N = mkN "svartbygge" ;
  svartlistande_nn_1_N = mkN "svartlistande" ;
  svartnande_nn_1_N = mkN "svartnande" ;
  svarvande_nn_1_N = mkN "svarvande" ;
  svassande_nn_1_N = mkN "svassande" ;
  svavlande_nn_1_N = mkN "svavlande" ;
  svedande_nn_1_N = mkN "svedande" ;
  svedjande_nn_1_N = mkN "svedjande" ;
  svepande_nn_1_N = mkN "svepande" ;
  svepe_nn_1_N = mkN "svepe" ;
  svetsande_nn_1_N = mkN "svetsande" ;
  svettande_nn_1_N = mkN "svettande" ;
  svidande_nn_1_N = mkN "svidande" ;
  svikande_nn_1_N = mkN "svikande" ;
  sviktande_nn_1_N = mkN "sviktande" ;
  svimmande_nn_1_N = mkN "svimmande" ;
  svindlande_nn_1_N = mkN "svindlande" ;
  svingande_nn_1_N = mkN "svingande" ;
  svinnande_nn_1_N = mkN "svinnande" ;
  svirande_nn_1_N = mkN "svirande" ;
  svirrande_nn_1_N = mkN "svirrande" ;
  svischande_nn_1_N = mkN "svischande" ;
  svullnande_nn_1_N = mkN "svullnande" ;
  svaeljande_nn_1_1_N = mkN "sväljande" ;
  svaellande_nn_1_1_N = mkN "svällande" ;
  svaeltande_nn_1_1_N = mkN "svältande" ;
  svaengande_nn_1_1_N = mkN "svängande" ;
  svaerande_nn_1_1_N = mkN "svärande" ;
  svaerdfaeste_nn_1_1_N = mkN "svärdfäste" ;
  svaermande_nn_1_1_N = mkN "svärmande" ;
  svaertande_nn_1_1_N = mkN "svärtande" ;
  svaevande_nn_1_1_N = mkN "svävande" ;
  swingande_nn_1_N = mkN "swingande" ;
  syende_nn_1_N = mkN "syende" ;
  syftande_nn_1_N = mkN "syftande" ;
  syfte_nn_1_N = mkN "syfte" ;
  syltande_nn_1_N = mkN "syltande" ;
  symboliserande_nn_1_N = mkN "symboliserande" ;
  symbolvaerde_nn_1_1_N = mkN "symbolvärde" ;
  sympatiserande_nn_1_N = mkN "sympatiserande" ;
  synande_nn_1_N = mkN "synande" ;
  syndande_nn_1_N = mkN "syndande" ;
  synkande_nn_1_N = mkN "synkande" ;
  synkoperande_nn_1_N = mkN "synkoperande" ;
  synkroniserande_nn_1_N = mkN "synkroniserande" ;
  synsinne_nn_1_N = mkN "synsinne" ;
  syntetiserande_nn_1_N = mkN "syntetiserande" ;
  syrande_nn_1_N = mkN "syrande" ;
  syrsaettande_nn_1_1_N = mkN "syrsättande" ;
  sysselsaettande_nn_1_1_N = mkN "sysselsättande" ;
  sysslande_nn_1_N = mkN "sysslande" ;
  systematiserande_nn_1_N = mkN "systematiserande" ;
  systemerande_nn_1_N = mkN "systemerande" ;
  systemskifte_nn_1_N = mkN "systemskifte" ;
  saeckande_nn_1_1_N = mkN "säckande" ;
  saede_nn_1_1_N = mkN "säde" ;
  saegande_nn_1_1_N = mkN "sägande" ;
  saekerhetsarbete_nn_1_1_N = mkN "säkerhetsarbete" ;
  saekerhetsbaelte_nn_1_1_N = mkN "säkerhetsbälte" ;
  saekerhetslaege_nn_1_1_N = mkN "säkerhetsläge" ;
  saekerhetssele_nn_1_1_N = mkN "säkerhetssele" ;
  saekerstaellande_nn_1_1_N = mkN "säkerställande" ;
  saekrande_nn_1_1_N = mkN "säkrande" ;
  saelghaenge_nn_1_1_N = mkN "sälghänge" ;
  saeljande_nn_1_1_N = mkN "säljande" ;
  saellskapande_nn_1_1_N = mkN "sällskapande" ;
  saellskapsnoeje_nn_1_1_N = mkN "sällskapsnöje" ;
  saemskande_nn_1_1_N = mkN "sämskande" ;
  saemskgarvande_nn_1_1_N = mkN "sämskgarvande" ;
  saendande_nn_1_1_N = mkN "sändande" ;
  saengfoerhaenge_nn_1_1_N = mkN "sängförhänge" ;
  saengkammarregemente_nn_1_1_N = mkN "sängkammarregemente" ;
  saengroekande_nn_1_1_N = mkN "sängrökande" ;
  saenkande_nn_1_1_N = mkN "sänkande" ;
  saenke_nn_1_1_N = mkN "sänke" ;
  saerande_nn_1_1_N = mkN "särande" ;
  saerartstaenkande_nn_1_1_N = mkN "särartstänkande" ;
  saerbehandlande_nn_1_1_N = mkN "särbehandlande" ;
  saerbeskattande_nn_1_1_N = mkN "särbeskattande" ;
  saerintresse_nn_1_1_N = mkN "särintresse" ;
  saermaerke_nn_1_1_N = mkN "särmärke" ;
  saerskiljande_nn_1_1_N = mkN "särskiljande" ;
  saete_nn_1_1_N = mkN "säte" ;
  saettande_nn_1_1_N = mkN "sättande" ;
  saaende_nn_1_1_N = mkN "sående" ;
  saagande_nn_1_1_N = mkN "sågande" ;
  saallande_nn_1_1_N = mkN "sållande" ;
  saapande_nn_1_1_N = mkN "såpande" ;
  saarande_nn_1_1_N = mkN "sårande" ;
  saasande_nn_1_1_N = mkN "såsande" ;
  saatande_nn_1_1_N = mkN "såtande" ;
  saaterande_nn_1_1_N = mkN "såterande" ;
  saaverande_nn_1_1_N = mkN "såverande" ;
  soekande_nn_2_1_N = mkN "sökande" ;
  soelande_nn_1_1_N = mkN "sölande" ;
  soemmande_nn_1_1_N = mkN "sömmande" ;
  soenderdelande_nn_1_1_N = mkN "sönderdelande" ;
  soenderfallande_nn_1_1_N = mkN "sönderfallande" ;
  soenderhackande_nn_1_1_N = mkN "sönderhackande" ;
  soenderrivande_nn_1_1_N = mkN "sönderrivande" ;
  soenderspraengande_nn_1_1_N = mkN "söndersprängande" ;
  soendrande_nn_1_1_N = mkN "söndrande" ;
  soerjande_nn_1_1_N = mkN "sörjande" ;
  soerplande_nn_1_1_N = mkN "sörplande" ;
  soetande_nn_1_1_N = mkN "sötande" ;
  soevande_nn_1_1_N = mkN "sövande" ;
  tabellerande_nn_1_N = mkN "tabellerande" ;
  tabuerande_nn_1_N = mkN "tabuerande" ;
  tabulerande_nn_1_N = mkN "tabulerande" ;
  tackande_nn_1_N = mkN "tackande" ;
  tacklande_nn_1_N = mkN "tacklande" ;
  tadlande_nn_1_N = mkN "tadlande" ;
  tafflande_nn_1_N = mkN "tafflande" ;
  tafsande_nn_1_N = mkN "tafsande" ;
  tagande_nn_1_N = mkN "tagande" ;
  taggande_nn_1_N = mkN "taggande" ;
  taglande_nn_1_N = mkN "taglande" ;
  tajmande_nn_1_N = mkN "tajmande" ;
  takraecke_nn_1_1_N = mkN "takräcke" ;
  takroeste_nn_1_1_N = mkN "takröste" ;
  takterande_nn_1_N = mkN "takterande" ;
  talande_nn_1_N = mkN "talande" ;
  talfoerhaallande_nn_1_1_N = mkN "talförhållande" ;
  talgande_nn_1_N = mkN "talgande" ;
  talkande_nn_1_N = mkN "talkande" ;
  tallande_nn_1_N = mkN "tallande" ;
  tamponerande_nn_1_N = mkN "tamponerande" ;
  tandande_nn_1_N = mkN "tandande" ;
  tangerande_nn_1_N = mkN "tangerande" ;
  tankande_nn_1_N = mkN "tankande" ;
  tankearbete_nn_1_N = mkN "tankearbete" ;
  tankeutbyte_nn_1_N = mkN "tankeutbyte" ;
  tankstaelle_nn_1_1_N = mkN "tankställe" ;
  tapetserande_nn_1_N = mkN "tapetserande" ;
  tappande_nn_1_N = mkN "tappande" ;
  tarerande_nn_1_N = mkN "tarerande" ;
  tarifferande_nn_1_N = mkN "tarifferande" ;
  tarvande_nn_1_N = mkN "tarvande" ;
  tassande_nn_1_N = mkN "tassande" ;
  tasslande_nn_1_N = mkN "tasslande" ;
  tatuerande_nn_1_N = mkN "tatuerande" ;
  taxande_nn_1_N = mkN "taxande" ;
  taxeomraade_nn_1_1_N = mkN "taxeområde" ;
  taxerande_nn_1_N = mkN "taxerande" ;
  taxeringsvaerde_nn_1_1_N = mkN "taxeringsvärde" ;
  teaterstycke_nn_1_N = mkN "teaterstycke" ;
  tecknande_nn_1_N = mkN "tecknande" ;
  tejpande_nn_1_N = mkN "tejpande" ;
  tekande_nn_1_N = mkN "tekande" ;
  teknifierande_nn_1_N = mkN "teknifierande" ;
  teknikkunnande_nn_1_N = mkN "teknikkunnande" ;
  telefonerande_nn_1_N = mkN "telefonerande" ;
  telefonsvararmeddelande_nn_1_N = mkN "telefonsvararmeddelande" ;
  telegraferande_nn_1_N = mkN "telegraferande" ;
  televiserande_nn_1_N = mkN "televiserande" ;
  tempande_nn_1_N = mkN "tempande" ;
  temperande_nn_1_N = mkN "temperande" ;
  temperaturfoerhaallande_nn_1_1_N = mkN "temperaturförhållande" ;
  temperaturomraade_nn_1_1_N = mkN "temperaturområde" ;
  tempererande_nn_1_N = mkN "tempererande" ;
  tempoarbete_nn_1_N = mkN "tempoarbete" ;
  tenderande_nn_1_N = mkN "tenderande" ;
  tentamenslaesande_nn_1_1_N = mkN "tentamensläsande" ;
  tentande_nn_1_N = mkN "tentande" ;
  tenterande_nn_1_N = mkN "tenterande" ;
  teoretiserande_nn_1_N = mkN "teoretiserande" ;
  terrasserande_nn_1_N = mkN "terrasserande" ;
  terroriserande_nn_1_N = mkN "terroriserande" ;
  tesaurerande_nn_1_N = mkN "tesaurerande" ;
  testamente_nn_1_N = mkN "testamente" ;
  testamenterande_nn_1_N = mkN "testamenterande" ;
  testande_nn_1_N = mkN "testande" ;
  testvaerde_nn_1_1_N = mkN "testvärde" ;
  tevetittande_nn_1_N = mkN "tevetittande" ;
  textande_nn_1_N = mkN "textande" ;
  textstycke_nn_1_N = mkN "textstycke" ;
  tickande_nn_1_N = mkN "tickande" ;
  tidfaestande_nn_1_1_N = mkN "tidfästande" ;
  tidigarelaeggande_nn_1_1_N = mkN "tidigareläggande" ;
  tidsbegraensande_nn_1_1_N = mkN "tidsbegränsande" ;
  tidsbestaemmande_nn_1_1_N = mkN "tidsbestämmande" ;
  tidsfoerhaallande_nn_1_1_N = mkN "tidsförhållande" ;
  tidsmedvetande_nn_1_N = mkN "tidsmedvetande" ;
  tidsskede_nn_1_N = mkN "tidsskede" ;
  tigande_nn_1_N = mkN "tigande" ;
  tiggande_nn_1_N = mkN "tiggande" ;
  tillagande_nn_1_N = mkN "tillagande" ;
  tillbakavisande_nn_1_N = mkN "tillbakavisande" ;
  tillbedjande_nn_1_N = mkN "tillbedjande" ;
  tillblandande_nn_1_N = mkN "tillblandande" ;
  tillbringande_nn_1_N = mkN "tillbringande" ;
  tilldelande_nn_1_N = mkN "tilldelande" ;
  tilldoemande_nn_1_1_N = mkN "tilldömande" ;
  tillerkaennande_nn_1_1_N = mkN "tillerkännande" ;
  tillfallande_nn_1_N = mkN "tillfallande" ;
  tillfloede_nn_1_1_N = mkN "tillflöde" ;
  tillfogande_nn_1_N = mkN "tillfogande" ;
  tillfredsstaellande_nn_1_1_N = mkN "tillfredsställande" ;
  tillfrysande_nn_1_N = mkN "tillfrysande" ;
  tillfraagande_nn_1_1_N = mkN "tillfrågande" ;
  tillfaelle_nn_1_1_N = mkN "tillfälle" ;
  tillfaellighetsarbete_nn_1_1_N = mkN "tillfällighetsarbete" ;
  tillfaangatagande_nn_1_1_N = mkN "tillfångatagande" ;
  tillfoerande_nn_1_1_N = mkN "tillförande" ;
  tillfoersaekrande_nn_1_1_N = mkN "tillförsäkrande" ;
  tillgivande_nn_1_N = mkN "tillgivande" ;
  tillgodohavande_nn_1_N = mkN "tillgodohavande" ;
  tillgodoraeknande_nn_1_1_N = mkN "tillgodoräknande" ;
  tillgodoseende_nn_1_N = mkN "tillgodoseende" ;
  tillgripande_nn_1_N = mkN "tillgripande" ;
  tillgaaende_nn_1_1_N = mkN "tillgående" ;
  tillhandahaallande_nn_1_1_N = mkN "tillhandahållande" ;
  tillhygge_nn_1_N = mkN "tillhygge" ;
  tillhaallande_nn_1_1_N = mkN "tillhållande" ;
  tillhoerande_nn_1_1_N = mkN "tillhörande" ;
  tillintetgoerande_nn_1_1_N = mkN "tillintetgörande" ;
  tillkallande_nn_1_N = mkN "tillkallande" ;
  tillkommande_nn_1_N = mkN "tillkommande" ;
  tillkopplande_nn_1_N = mkN "tillkopplande" ;
  tillkortakommande_nn_1_N = mkN "tillkortakommande" ;
  tillkaennagivande_nn_1_1_N = mkN "tillkännagivande" ;
  tillmaele_nn_1_1_N = mkN "tillmäle" ;
  tillmaetande_nn_1_1_N = mkN "tillmätande" ;
  tillpassande_nn_1_N = mkN "tillpassande" ;
  tillplattande_nn_1_N = mkN "tillplattande" ;
  tillrande_nn_1_N = mkN "tillrande" ;
  tillredande_nn_1_N = mkN "tillredande" ;
  tillryggalaeggande_nn_1_1_N = mkN "tillryggaläggande" ;
  tillraeknande_nn_1_1_N = mkN "tillräknande" ;
  tillraettalaeggande_nn_1_1_N = mkN "tillrättaläggande" ;
  tillraettavisande_nn_1_1_N = mkN "tillrättavisande" ;
  tillraadande_nn_1_1_N = mkN "tillrådande" ;
  tillsatsaemne_nn_1_1_N = mkN "tillsatsämne" ;
  tillseende_nn_1_N = mkN "tillseende" ;
  tillskapande_nn_1_N = mkN "tillskapande" ;
  tillskjutande_nn_1_N = mkN "tillskjutande" ;
  tillskrivande_nn_1_N = mkN "tillskrivande" ;
  tillskyndande_nn_1_N = mkN "tillskyndande" ;
  tillskaerande_nn_1_1_N = mkN "tillskärande" ;
  tillslutande_nn_1_N = mkN "tillslutande" ;
  tillspetsande_nn_1_N = mkN "tillspetsande" ;
  tillspillogivande_nn_1_N = mkN "tillspillogivande" ;
  tillstroemmande_nn_1_1_N = mkN "tillströmmande" ;
  tillstundande_nn_1_N = mkN "tillstundande" ;
  tillstyrkande_nn_1_N = mkN "tillstyrkande" ;
  tillstaedjande_nn_1_1_N = mkN "tillstädjande" ;
  tillstaellande_nn_1_1_N = mkN "tillställande" ;
  tillstaaende_nn_1_1_N = mkN "tillstående" ;
  tillstoetande_nn_1_1_N = mkN "tillstötande" ;
  tillsvidarefoerordnande_nn_1_1_N = mkN "tillsvidareförordnande" ;
  tillsaegande_nn_1_1_N = mkN "tillsägande" ;
  tillsaettande_nn_1_1_N = mkN "tillsättande" ;
  tillsaettningsaerende_nn_1_1_N = mkN "tillsättningsärende" ;
  tilltalande_nn_1_N = mkN "tilltalande" ;
  tilltroende_nn_1_N = mkN "tilltroende" ;
  tilltraedande_nn_1_1_N = mkN "tillträdande" ;
  tilltraede_nn_1_1_N = mkN "tillträde" ;
  tilltygande_nn_1_N = mkN "tilltygande" ;
  tilltaeppande_nn_1_1_N = mkN "tilltäppande" ;
  tillvalsaemne_nn_1_1_N = mkN "tillvalsämne" ;
  tillvaratagande_nn_1_N = mkN "tillvaratagande" ;
  tillverkande_nn_1_N = mkN "tillverkande" ;
  tillvitande_nn_1_N = mkN "tillvitande" ;
  tillvaegabringande_nn_1_1_N = mkN "tillvägabringande" ;
  tillvaenjande_nn_1_1_N = mkN "tillvänjande" ;
  tillvaexande_nn_1_1_N = mkN "tillväxande" ;
  tillvaextaemne_nn_1_1_N = mkN "tillväxtämne" ;
  tillyxande_nn_1_N = mkN "tillyxande" ;
  tillaeggande_nn_1_1_N = mkN "tilläggande" ;
  tillaegnande_nn_1_1_N = mkN "tillägnande" ;
  tillaemnande_nn_1_1_N = mkN "tillämnande" ;
  tillaempande_nn_1_1_N = mkN "tillämpande" ;
  tillaatande_nn_1_1_N = mkN "tillåtande" ;
  tilloenskande_nn_1_1_N = mkN "tillönskande" ;
  tiltande_nn_1_N = mkN "tiltande" ;
  timande_nn_1_N = mkN "timande" ;
  timarvode_nn_1_N = mkN "timarvode" ;
  timrande_nn_1_N = mkN "timrande" ;
  tinande_nn_1_N = mkN "tinande" ;
  tindrande_nn_1_N = mkN "tindrande" ;
  tingande_nn_1_N = mkN "tingande" ;
  tiodubblande_nn_1_N = mkN "tiodubblande" ;
  tiofaldigande_nn_1_N = mkN "tiofaldigande" ;
  tippande_nn_1_N = mkN "tippande" ;
  tipsande_nn_1_N = mkN "tipsande" ;
  tirande_nn_1_N = mkN "tirande" ;
  tisslande_nn_1_N = mkN "tisslande" ;
  titrerande_nn_1_N = mkN "titrerande" ;
  tittande_nn_1_N = mkN "tittande" ;
  titulerande_nn_1_N = mkN "titulerande" ;
  tjackande_nn_1_N = mkN "tjackande" ;
  tjafsande_nn_1_N = mkN "tjafsande" ;
  tjallande_nn_1_N = mkN "tjallande" ;
  tjatande_nn_1_N = mkN "tjatande" ;
  tjattrande_nn_1_N = mkN "tjattrande" ;
  tjillande_nn_1_N = mkN "tjillande" ;
  tjimmande_nn_1_N = mkN "tjimmande" ;
  tjingande_nn_1_N = mkN "tjingande" ;
  tjoande_nn_1_N = mkN "tjoande" ;
  tjocknande_nn_1_N = mkN "tjocknande" ;
  tjongande_nn_1_N = mkN "tjongande" ;
  tjorvande_nn_1_N = mkN "tjorvande" ;
  tjudrande_nn_1_N = mkN "tjudrande" ;
  tjugofaldigande_nn_1_N = mkN "tjugofaldigande" ;
  tjurande_nn_1_N = mkN "tjurande" ;
  tjusande_nn_1_N = mkN "tjusande" ;
  tjutande_nn_1_N = mkN "tjutande" ;
  tjuvande_nn_1_N = mkN "tjuvande" ;
  tjuvhaallande_nn_1_1_N = mkN "tjuvhållande" ;
  tjuvkopplande_nn_1_N = mkN "tjuvkopplande" ;
  tjuvlyssnande_nn_1_N = mkN "tjuvlyssnande" ;
  tjuvmjoelkande_nn_1_1_N = mkN "tjuvmjölkande" ;
  tjuvsamhaelle_nn_1_1_N = mkN "tjuvsamhälle" ;
  tjuvstartande_nn_1_N = mkN "tjuvstartande" ;
  tjuvtraenande_nn_1_1_N = mkN "tjuvtränande" ;
  tjyvande_nn_1_N = mkN "tjyvande" ;
  tjyvhaallande_nn_1_1_N = mkN "tjyvhållande" ;
  tjyvkopplande_nn_1_N = mkN "tjyvkopplande" ;
  tjyvlyssnande_nn_1_N = mkN "tjyvlyssnande" ;
  tjyvmjoelkande_nn_1_1_N = mkN "tjyvmjölkande" ;
  tjyvsamhaelle_nn_1_1_N = mkN "tjyvsamhälle" ;
  tjyvstartande_nn_1_N = mkN "tjyvstartande" ;
  tjaelande_nn_1_1_N = mkN "tjälande" ;
  tjaenande_nn_1_1_N = mkN "tjänande" ;
  tjaensteaerende_nn_1_1_N = mkN "tjänsteärende" ;
  tjaenstgoerande_nn_1_1_N = mkN "tjänstgörande" ;
  tjaerande_nn_1_1_N = mkN "tjärande" ;
  tockande_nn_1_N = mkN "tockande" ;
  tofflande_nn_1_N = mkN "tofflande" ;
  tolererande_nn_1_N = mkN "tolererande" ;
  tolkande_nn_1_N = mkN "tolkande" ;
  tomtande_nn_1_N = mkN "tomtande" ;
  tomteskrockande_nn_1_N = mkN "tomteskrockande" ;
  tonande_nn_1_N = mkN "tonande" ;
  tonlaege_nn_1_1_N = mkN "tonläge" ;
  tonomraade_nn_1_1_N = mkN "tonområde" ;
  tonsaettande_nn_1_1_N = mkN "tonsättande" ;
  toppande_nn_1_N = mkN "toppande" ;
  topphuggande_nn_1_N = mkN "topphuggande" ;
  toppmoete_nn_1_1_N = mkN "toppmöte" ;
  toppridande_nn_1_N = mkN "toppridande" ;
  topsande_nn_1_N = mkN "topsande" ;
  tordeende_nn_1_N = mkN "tordeende" ;
  torderande_nn_1_N = mkN "torderande" ;
  torgfoerande_nn_1_1_N = mkN "torgförande" ;
  torkande_nn_1_N = mkN "torkande" ;
  torktumlande_nn_1_N = mkN "torktumlande" ;
  torkaemne_nn_1_1_N = mkN "torkämne" ;
  tornande_nn_1_N = mkN "tornande" ;
  tornerande_nn_1_N = mkN "tornerande" ;
  torpederande_nn_1_N = mkN "torpederande" ;
  torrdestillerande_nn_1_N = mkN "torrdestillerande" ;
  torrhostande_nn_1_N = mkN "torrhostande" ;
  torrkokande_nn_1_N = mkN "torrkokande" ;
  torrlaeggande_nn_1_1_N = mkN "torrläggande" ;
  torrschamponerande_nn_1_N = mkN "torrschamponerande" ;
  torrslipande_nn_1_N = mkN "torrslipande" ;
  torroekande_nn_1_1_N = mkN "torrökande" ;
  torskande_nn_1_N = mkN "torskande" ;
  torterande_nn_1_N = mkN "torterande" ;
  torvande_nn_1_N = mkN "torvande" ;
  torvdike_nn_1_N = mkN "torvdike" ;
  torvtaeckande_nn_1_1_N = mkN "torvtäckande" ;
  totalfinansierande_nn_1_N = mkN "totalfinansierande" ;
  totalfoerbjudande_nn_1_1_N = mkN "totalförbjudande" ;
  totalfoerlamande_nn_1_1_N = mkN "totalförlamande" ;
  totalfoerstoerande_nn_1_1_N = mkN "totalförstörande" ;
  totalhavererande_nn_1_N = mkN "totalhavererande" ;
  totalvaegrande_nn_1_1_N = mkN "totalvägrande" ;
  totalvaerde_nn_1_1_N = mkN "totalvärde" ;
  touchande_nn_1_N = mkN "touchande" ;
  toucherande_nn_1_N = mkN "toucherande" ;
  touperande_nn_1_N = mkN "touperande" ;
  tovande_nn_1_N = mkN "tovande" ;
  trackande_nn_1_N = mkN "trackande" ;
  traderande_nn_1_N = mkN "traderande" ;
  trafikerande_nn_1_N = mkN "trafikerande" ;
  trafiklaege_nn_1_1_N = mkN "trafikläge" ;
  trafikmaerke_nn_1_1_N = mkN "trafikmärke" ;
  trafikreglerande_nn_1_N = mkN "trafikreglerande" ;
  tragglande_nn_1_N = mkN "tragglande" ;
  trajande_nn_1_N = mkN "trajande" ;
  trakasserande_nn_1_N = mkN "trakasserande" ;
  traktamente_nn_1_N = mkN "traktamente" ;
  traktande_nn_1_N = mkN "traktande" ;
  trakterande_nn_1_N = mkN "trakterande" ;
  trakthuggande_nn_1_N = mkN "trakthuggande" ;
  trallande_nn_1_N = mkN "trallande" ;
  trampande_nn_1_N = mkN "trampande" ;
  tramsande_nn_1_N = mkN "tramsande" ;
  trancherande_nn_1_N = mkN "trancherande" ;
  transfererande_nn_1_N = mkN "transfererande" ;
  transformerande_nn_1_N = mkN "transformerande" ;
  transiterande_nn_1_N = mkN "transiterande" ;
  transkriberande_nn_1_N = mkN "transkriberande" ;
  translittererande_nn_1_N = mkN "translittererande" ;
  transmitterande_nn_1_N = mkN "transmitterande" ;
  transmuterande_nn_1_N = mkN "transmuterande" ;
  transpirerande_nn_1_N = mkN "transpirerande" ;
  transplanterande_nn_1_N = mkN "transplanterande" ;
  transponerande_nn_1_N = mkN "transponerande" ;
  transportberoende_nn_1_N = mkN "transportberoende" ;
  transporterande_nn_1_N = mkN "transporterande" ;
  transportlaege_nn_1_1_N = mkN "transportläge" ;
  transumerande_nn_1_N = mkN "transumerande" ;
  trappraecke_nn_1_1_N = mkN "trappräcke" ;
  trasande_nn_1_N = mkN "trasande" ;
  trashande_nn_1_N = mkN "trashande" ;
  traskande_nn_1_N = mkN "traskande" ;
  trasserande_nn_1_N = mkN "trasserande" ;
  trasslande_nn_1_N = mkN "trasslande" ;
  trattande_nn_1_N = mkN "trattande" ;
  travande_nn_1_N = mkN "travande" ;
  travesterande_nn_1_N = mkN "travesterande" ;
  tremulerande_nn_1_N = mkN "tremulerande" ;
  trepanerande_nn_1_N = mkN "trepanerande" ;
  trepunktsbaelte_nn_1_1_N = mkN "trepunktsbälte" ;
  trevande_nn_1_N = mkN "trevande" ;
  triangelbyte_nn_1_N = mkN "triangelbyte" ;
  triangulerande_nn_1_N = mkN "triangulerande" ;
  tricksande_nn_1_N = mkN "tricksande" ;
  trierande_nn_1_N = mkN "trierande" ;
  triggande_nn_1_N = mkN "triggande" ;
  trillande_nn_1_N = mkN "trillande" ;
  trimmande_nn_1_N = mkN "trimmande" ;
  trippande_nn_1_N = mkN "trippande" ;
  tripplande_nn_1_N = mkN "tripplande" ;
  triumferande_nn_1_N = mkN "triumferande" ;
  trivialiserande_nn_1_N = mkN "trivialiserande" ;
  trixande_nn_1_N = mkN "trixande" ;
  troende_nn_1_N = mkN "troende" ;
  trohetsloefte_nn_1_1_N = mkN "trohetslöfte" ;
  trollande_nn_1_N = mkN "trollande" ;
  trollbindande_nn_1_N = mkN "trollbindande" ;
  trolovande_nn_1_N = mkN "trolovande" ;
  trolovningsloefte_nn_1_1_N = mkN "trolovningslöfte" ;
  tronande_nn_1_N = mkN "tronande" ;
  tronskifte_nn_1_N = mkN "tronskifte" ;
  trontilltraede_nn_1_1_N = mkN "trontillträde" ;
  troppande_nn_1_N = mkN "troppande" ;
  trotsande_nn_1_N = mkN "trotsande" ;
  trugande_nn_1_N = mkN "trugande" ;
  trulande_nn_1_N = mkN "trulande" ;
  trumfande_nn_1_N = mkN "trumfande" ;
  trumlande_nn_1_N = mkN "trumlande" ;
  trummande_nn_1_N = mkN "trummande" ;
  trumminne_nn_1_N = mkN "trumminne" ;
  trumpetande_nn_1_N = mkN "trumpetande" ;
  trutande_nn_1_N = mkN "trutande" ;
  tryckande_nn_1_N = mkN "tryckande" ;
  trycke_nn_1_N = mkN "trycke" ;
  tryckimpregnerande_nn_1_N = mkN "tryckimpregnerande" ;
  tryfferande_nn_1_N = mkN "tryfferande" ;
  tryggande_nn_1_N = mkN "tryggande" ;
  trygghetsboende_nn_1_N = mkN "trygghetsboende" ;
  trynande_nn_1_N = mkN "trynande" ;
  tryne_nn_1_N = mkN "tryne" ;
  trytande_nn_1_N = mkN "trytande" ;
  traeande_nn_1_1_N = mkN "träande" ;
  traeckande_nn_1_1_N = mkN "träckande" ;
  traedande_nn_1_1_N = mkN "trädande" ;
  traede_nn_1_1_N = mkN "träde" ;
  traeffande_nn_1_1_N = mkN "träffande" ;
  traelande_nn_1_1_N = mkN "trälande" ;
  traelarbete_nn_1_1_N = mkN "trälarbete" ;
  traelbindande_nn_1_1_N = mkN "trälbindande" ;
  traenande_nn_1_1_N = mkN "tränande" ;
  traengande_nn_1_1_N = mkN "trängande" ;
  traengtande_nn_1_1_N = mkN "trängtande" ;
  traensande_nn_1_1_N = mkN "tränsande" ;
  traestycke_nn_1_1_N = mkN "trästycke" ;
  traetande_nn_1_1_N = mkN "trätande" ;
  traacklande_nn_1_1_N = mkN "tråcklande" ;
  traadaemne_nn_1_1_N = mkN "trådämne" ;
  traaende_nn_1_1_N = mkN "trående" ;
  traakande_nn_1_1_N = mkN "tråkande" ;
  traalande_nn_1_1_N = mkN "trålande" ;
  traanande_nn_1_1_N = mkN "trånande" ;
  troeghetsnavigerande_nn_1_1_N = mkN "tröghetsnavigerande" ;
  troeskande_nn_1_1_N = mkN "tröskande" ;
  troeskelvaerde_nn_1_1_N = mkN "tröskelvärde" ;
  troestande_nn_1_1_N = mkN "tröstande" ;
  troettande_nn_1_1_N = mkN "tröttande" ;
  troettnande_nn_1_1_N = mkN "tröttnande" ;
  tubbande_nn_1_N = mkN "tubbande" ;
  tudelande_nn_1_N = mkN "tudelande" ;
  tuffande_nn_1_N = mkN "tuffande" ;
  tufsande_nn_1_N = mkN "tufsande" ;
  tuggande_nn_1_N = mkN "tuggande" ;
  tuktande_nn_1_N = mkN "tuktande" ;
  tullande_nn_1_N = mkN "tullande" ;
  tullbesiktigande_nn_1_N = mkN "tullbesiktigande" ;
  tultande_nn_1_N = mkN "tultande" ;
  tumlande_nn_1_N = mkN "tumlande" ;
  tummande_nn_1_N = mkN "tummande" ;
  tungsinne_nn_1_N = mkN "tungsinne" ;
  tungsmycke_nn_1_N = mkN "tungsmycke" ;
  tunnande_nn_1_N = mkN "tunnande" ;
  tunnelbanebygge_nn_1_N = mkN "tunnelbanebygge" ;
  tunnelseende_nn_1_N = mkN "tunnelseende" ;
  tuperande_nn_1_N = mkN "tuperande" ;
  turistande_nn_1_N = mkN "turistande" ;
  turnerande_nn_1_N = mkN "turnerande" ;
  tuschande_nn_1_N = mkN "tuschande" ;
  tuscherande_nn_1_N = mkN "tuscherande" ;
  tusende_nn_1_N = mkN "tusende" ;
  tusenaarsrike_nn_1_1_N = mkN "tusenårsrike" ;
  tussande_nn_1_N = mkN "tussande" ;
  tutande_nn_1_N = mkN "tutande" ;
  tv_tittande_nn_1_N = mkN "tv-tittande" ;
  tvegifte_nn_1_N = mkN "tvegifte" ;
  tvekande_nn_1_N = mkN "tvekande" ;
  tvinande_nn_1_N = mkN "tvinande" ;
  tvingande_nn_1_N = mkN "tvingande" ;
  tvinnande_nn_1_N = mkN "tvinnande" ;
  tvistande_nn_1_N = mkN "tvistande" ;
  tvisteaemne_nn_1_1_N = mkN "tvisteämne" ;
  tvisteaepple_nn_1_1_N = mkN "tvisteäpple" ;
  tvivlande_nn_1_N = mkN "tvivlande" ;
  tvaerande_nn_1_1_N = mkN "tvärande" ;
  tvaerbromsande_nn_1_1_N = mkN "tvärbromsande" ;
  tvaernitande_nn_1_1_N = mkN "tvärnitande" ;
  tvaersande_nn_1_1_N = mkN "tvärsande" ;
  tvaerstannande_nn_1_1_N = mkN "tvärstannande" ;
  tvaervaendande_nn_1_1_N = mkN "tvärvändande" ;
  tvaettande_nn_1_1_N = mkN "tvättande" ;
  tvaettbraede_nn_1_1_N = mkN "tvättbräde" ;
  tvaaende_nn_1_1_N = mkN "tvående" ;
  tvaangsarbete_nn_1_1_N = mkN "tvångsarbete" ;
  tvaangsbaelte_nn_1_1_N = mkN "tvångsbälte" ;
  tvaangsgifte_nn_1_1_N = mkN "tvångsgifte" ;
  tvaangsinloesande_nn_1_1_N = mkN "tvångsinlösande" ;
  tvaangskommenderande_nn_1_1_N = mkN "tvångskommenderande" ;
  tvaangslaege_nn_1_1_N = mkN "tvångsläge" ;
  tvaangsrekryterande_nn_1_1_N = mkN "tvångsrekryterande" ;
  tvaangstatuerande_nn_1_1_N = mkN "tvångstatuerande" ;
  tvaapartsfoerhaallande_nn_1_1_N = mkN "tvåpartsförhållande" ;
  twistande_nn_1_N = mkN "twistande" ;
  twittrande_nn_1_N = mkN "twittrande" ;
  tyande_nn_1_N = mkN "tyande" ;
  tyckande_nn_1_N = mkN "tyckande" ;
  tycke_nn_1_N = mkN "tycke" ;
  tydande_nn_1_N = mkN "tydande" ;
  tydliggoerande_nn_1_1_N = mkN "tydliggörande" ;
  tyglande_nn_1_N = mkN "tyglande" ;
  tygstycke_nn_1_N = mkN "tygstycke" ;
  tynande_nn_1_N = mkN "tynande" ;
  tyngande_nn_1_N = mkN "tyngande" ;
  typifierande_nn_1_N = mkN "typifierande" ;
  typiserande_nn_1_N = mkN "typiserande" ;
  typvaerde_nn_1_1_N = mkN "typvärde" ;
  tyranniserande_nn_1_N = mkN "tyranniserande" ;
  tystande_nn_1_N = mkN "tystande" ;
  tysthetsloefte_nn_1_1_N = mkN "tysthetslöfte" ;
  tystnande_nn_1_N = mkN "tystnande" ;
  taeckande_nn_1_1_N = mkN "täckande" ;
  taeckdikande_nn_1_1_N = mkN "täckdikande" ;
  taeckdike_nn_1_1_N = mkN "täckdike" ;
  taecke_nn_1_1_N = mkN "täcke" ;
  taeljande_nn_1_1_N = mkN "täljande" ;
  taeltande_nn_1_1_N = mkN "tältande" ;
  taeltmoete_nn_1_1_N = mkN "tältmöte" ;
  taemjande_nn_1_1_N = mkN "tämjande" ;
  taendande_nn_1_1_N = mkN "tändande" ;
  taendaemne_nn_1_1_N = mkN "tändämne" ;
  taenjande_nn_1_1_N = mkN "tänjande" ;
  taenkande_nn_1_1_N = mkN "tänkande" ;
  taerande_nn_1_1_N = mkN "tärande" ;
  taernande_nn_1_1_N = mkN "tärnande" ;
  taetande_nn_1_1_N = mkN "tätande" ;
  taetnande_nn_1_1_N = mkN "tätnande" ;
  taevlande_nn_1_1_N = mkN "tävlande" ;
  taevlingsseglande_nn_1_1_N = mkN "tävlingsseglande" ;
  taaande_nn_1_1_N = mkN "tåande" ;
  taagande_nn_1_1_N = mkN "tågande" ;
  taagluffande_nn_1_1_N = mkN "tågluffande" ;
  taalande_nn_1_1_N = mkN "tålande" ;
  taarefloede_nn_1_1_N = mkN "tåreflöde" ;
  taartande_nn_1_1_N = mkN "tårtande" ;
  toeande_nn_1_1_N = mkN "töande" ;
  toejande_nn_1_1_N = mkN "töjande" ;
  toeltande_nn_1_1_N = mkN "töltande" ;
  toemmande_nn_1_1_N = mkN "tömmande" ;
  toentande_nn_1_1_N = mkN "töntande" ;
  toernande_nn_1_1_N = mkN "törnande" ;
  toerne_nn_1_1_N = mkN "törne" ;
  toerstande_nn_1_1_N = mkN "törstande" ;
  toevande_nn_1_1_N = mkN "tövande" ;
  ugglande_nn_1_N = mkN "ugglande" ;
  ugnsbakande_nn_1_N = mkN "ugnsbakande" ;
  ugnsgraeddande_nn_1_1_N = mkN "ugnsgräddande" ;
  ugnskokande_nn_1_N = mkN "ugnskokande" ;
  ugnsstekande_nn_1_N = mkN "ugnsstekande" ;
  ugnstorkande_nn_1_N = mkN "ugnstorkande" ;
  ulkande_nn_1_N = mkN "ulkande" ;
  ulltaecke_nn_1_1_N = mkN "ulltäcke" ;
  ulmande_nn_1_N = mkN "ulmande" ;
  ultrarapidfotograferande_nn_1_N = mkN "ultrarapidfotograferande" ;
  umbaerande_nn_1_1_N = mkN "umbärande" ;
  umgaellande_nn_1_1_N = mkN "umgällande" ;
  umgaenge_nn_1_1_N = mkN "umgänge" ;
  undangoemmande_nn_1_1_N = mkN "undangömmande" ;
  undanhaallande_nn_1_1_N = mkN "undanhållande" ;
  undanroejande_nn_1_1_N = mkN "undanröjande" ;
  undanskaffande_nn_1_N = mkN "undanskaffande" ;
  undanskiftande_nn_1_N = mkN "undanskiftande" ;
  undanskymmande_nn_1_N = mkN "undanskymmande" ;
  undansnillande_nn_1_N = mkN "undansnillande" ;
  undanstickande_nn_1_N = mkN "undanstickande" ;
  undantagande_nn_1_N = mkN "undantagande" ;
  undantraengande_nn_1_1_N = mkN "undanträngande" ;
  underanvaendande_nn_1_1_N = mkN "underanvändande" ;
  underarbete_nn_1_N = mkN "underarbete" ;
  underbalanserande_nn_1_N = mkN "underbalanserande" ;
  underbetalande_nn_1_N = mkN "underbetalande" ;
  underbindande_nn_1_N = mkN "underbindande" ;
  underbjudande_nn_1_N = mkN "underbjudande" ;
  underblaasande_nn_1_1_N = mkN "underblåsande" ;
  underbyggande_nn_1_N = mkN "underbyggande" ;
  underdimensionerande_nn_1_N = mkN "underdimensionerande" ;
  underdrivande_nn_1_N = mkN "underdrivande" ;
  underexponerande_nn_1_N = mkN "underexponerande" ;
  underfoerstaaende_nn_1_1_N = mkN "underförstående" ;
  underfoersaekrande_nn_1_1_N = mkN "underförsäkrande" ;
  undergraevande_nn_1_1_N = mkN "undergrävande" ;
  undergaaende_nn_1_1_N = mkN "undergående" ;
  underhandlande_nn_1_N = mkN "underhandlande" ;
  underhaallande_nn_1_1_N = mkN "underhållande" ;
  underhaallsarbete_nn_1_1_N = mkN "underhållsarbete" ;
  underjordsarbete_nn_1_N = mkN "underjordsarbete" ;
  underkastande_nn_1_N = mkN "underkastande" ;
  underkuvande_nn_1_N = mkN "underkuvande" ;
  underkvistande_nn_1_N = mkN "underkvistande" ;
  underkylande_nn_1_N = mkN "underkylande" ;
  underkaennande_nn_1_1_N = mkN "underkännande" ;
  underlappande_nn_1_N = mkN "underlappande" ;
  underlaettande_nn_1_1_N = mkN "underlättande" ;
  underlaatande_nn_1_1_N = mkN "underlåtande" ;
  underminerande_nn_1_N = mkN "underminerande" ;
  underordnande_nn_1_N = mkN "underordnande" ;
  underrede_nn_1_N = mkN "underrede" ;
  underredsbehandlande_nn_1_N = mkN "underredsbehandlande" ;
  underraettande_nn_1_1_N = mkN "underrättande" ;
  underskattande_nn_1_N = mkN "underskattande" ;
  underskridande_nn_1_N = mkN "underskridande" ;
  underslaekte_nn_1_1_N = mkN "undersläkte" ;
  underslaaende_nn_1_1_N = mkN "underslående" ;
  understickande_nn_1_N = mkN "understickande" ;
  understigande_nn_1_N = mkN "understigande" ;
  understreckande_nn_1_N = mkN "understreckande" ;
  understrykande_nn_1_N = mkN "understrykande" ;
  understaellande_nn_1_1_N = mkN "underställande" ;
  understoedjande_nn_1_1_N = mkN "understödjande" ;
  undersaeljande_nn_1_1_N = mkN "undersäljande" ;
  undersoekande_nn_1_1_N = mkN "undersökande" ;
  undertaxerande_nn_1_N = mkN "undertaxerande" ;
  undertecknande_nn_1_N = mkN "undertecknande" ;
  undertryckande_nn_1_N = mkN "undertryckande" ;
  undervisande_nn_1_N = mkN "undervisande" ;
  undervisningsaemne_nn_1_1_N = mkN "undervisningsämne" ;
  undervaerderande_nn_1_1_N = mkN "undervärderande" ;
  undfallande_nn_1_N = mkN "undfallande" ;
  undfaegnande_nn_1_1_N = mkN "undfägnande" ;
  undfaaende_nn_1_1_N = mkN "undfående" ;
  undgaaende_nn_1_1_N = mkN "undgående" ;
  undkommande_nn_1_N = mkN "undkommande" ;
  undrande_nn_1_N = mkN "undrande" ;
  undskyllande_nn_1_N = mkN "undskyllande" ;
  undslippande_nn_1_N = mkN "undslippande" ;
  undsaettande_nn_1_1_N = mkN "undsättande" ;
  undulerande_nn_1_N = mkN "undulerande" ;
  undvarande_nn_1_N = mkN "undvarande" ;
  undvikande_nn_1_N = mkN "undvikande" ;
  ungdomsarbete_nn_1_N = mkN "ungdomsarbete" ;
  unifierande_nn_1_N = mkN "unifierande" ;
  uniformerande_nn_1_N = mkN "uniformerande" ;
  uniformssnoere_nn_1_1_N = mkN "uniformssnöre" ;
  universalsnille_nn_1_N = mkN "universalsnille" ;
  universitetsaemne_nn_1_1_N = mkN "universitetsämne" ;
  unknande_nn_1_N = mkN "unknande" ;
  unnande_nn_1_N = mkN "unnande" ;
  uppammande_nn_1_N = mkN "uppammande" ;
  upparbetande_nn_1_N = mkN "upparbetande" ;
  uppassande_nn_1_N = mkN "uppassande" ;
  uppassningsstaelle_nn_1_1_N = mkN "uppassningsställe" ;
  uppbjudande_nn_1_N = mkN "uppbjudande" ;
  uppblandande_nn_1_N = mkN "uppblandande" ;
  uppbringande_nn_1_N = mkN "uppbringande" ;
  uppbrusande_nn_1_N = mkN "uppbrusande" ;
  uppbyggande_nn_1_N = mkN "uppbyggande" ;
  uppbyggelsemoete_nn_1_1_N = mkN "uppbyggelsemöte" ;
  uppbyggnadsskede_nn_1_N = mkN "uppbyggnadsskede" ;
  uppbaadande_nn_1_1_N = mkN "uppbådande" ;
  uppdagande_nn_1_N = mkN "uppdagande" ;
  uppdaterande_nn_1_N = mkN "uppdaterande" ;
  uppdelande_nn_1_N = mkN "uppdelande" ;
  uppdragande_nn_1_N = mkN "uppdragande" ;
  uppdrivande_nn_1_N = mkN "uppdrivande" ;
  uppdykande_nn_1_N = mkN "uppdykande" ;
  uppeggande_nn_1_N = mkN "uppeggande" ;
  uppehaallande_nn_1_1_N = mkN "uppehållande" ;
  uppenbarande_nn_1_N = mkN "uppenbarande" ;
  uppfattande_nn_1_N = mkN "uppfattande" ;
  uppfinnande_nn_1_N = mkN "uppfinnande" ;
  uppfordrande_nn_1_N = mkN "uppfordrande" ;
  uppfostrande_nn_1_N = mkN "uppfostrande" ;
  uppfriskande_nn_1_N = mkN "uppfriskande" ;
  uppfyllande_nn_1_N = mkN "uppfyllande" ;
  uppfaangande_nn_1_1_N = mkN "uppfångande" ;
  uppfoedande_nn_1_1_N = mkN "uppfödande" ;
  uppfoerande_nn_1_1_N = mkN "uppförande" ;
  uppfoerstorande_nn_1_1_N = mkN "uppförstorande" ;
  uppgivande_nn_1_N = mkN "uppgivande" ;
  uppgraderande_nn_1_N = mkN "uppgraderande" ;
  uppgaaende_nn_1_1_N = mkN "uppgående" ;
  upphandlande_nn_1_N = mkN "upphandlande" ;
  upphaussande_nn_1_N = mkN "upphaussande" ;
  upphetsande_nn_1_N = mkN "upphetsande" ;
  upphettande_nn_1_N = mkN "upphettande" ;
  upphittande_nn_1_N = mkN "upphittande" ;
  upphottande_nn_1_N = mkN "upphottande" ;
  upphaemtande_nn_1_1_N = mkN "upphämtande" ;
  upphaevande_nn_1_1_N = mkN "upphävande" ;
  upphoejande_nn_1_1_N = mkN "upphöjande" ;
  upphoerande_nn_1_1_N = mkN "upphörande" ;
  uppiggande_nn_1_N = mkN "uppiggande" ;
  uppjazzande_nn_1_N = mkN "uppjazzande" ;
  uppjusterande_nn_1_N = mkN "uppjusterande" ;
  uppkallande_nn_1_N = mkN "uppkallande" ;
  uppklarande_nn_1_N = mkN "uppklarande" ;
  uppkommande_nn_1_N = mkN "uppkommande" ;
  uppkvistande_nn_1_N = mkN "uppkvistande" ;
  upplagrande_nn_1_N = mkN "upplagrande" ;
  upplappande_nn_1_N = mkN "upplappande" ;
  upplevande_nn_1_N = mkN "upplevande" ;
  upplivande_nn_1_N = mkN "upplivande" ;
  upplysande_nn_1_N = mkN "upplysande" ;
  upplaeggande_nn_1_1_N = mkN "uppläggande" ;
  upplaesande_nn_1_1_N = mkN "uppläsande" ;
  upplaatande_nn_1_1_N = mkN "upplåtande" ;
  upploesande_nn_1_1_N = mkN "upplösande" ;
  uppmanande_nn_1_N = mkN "uppmanande" ;
  uppmarschomraade_nn_1_1_N = mkN "uppmarschområde" ;
  uppmjukande_nn_1_N = mkN "uppmjukande" ;
  uppmuddrande_nn_1_N = mkN "uppmuddrande" ;
  uppmuntrande_nn_1_N = mkN "uppmuntrande" ;
  uppmaerksammande_nn_1_1_N = mkN "uppmärksammande" ;
  uppmaetande_nn_1_1_N = mkN "uppmätande" ;
  uppnaaende_nn_1_1_N = mkN "uppnående" ;
  uppnaalande_nn_1_1_N = mkN "uppnålande" ;
  uppodlande_nn_1_N = mkN "uppodlande" ;
  uppoffrande_nn_1_N = mkN "uppoffrande" ;
  uppradande_nn_1_N = mkN "uppradande" ;
  uppreklamerande_nn_1_N = mkN "uppreklamerande" ;
  upprensande_nn_1_N = mkN "upprensande" ;
  upprepande_nn_1_N = mkN "upprepande" ;
  uppresande_nn_1_N = mkN "uppresande" ;
  upprivande_nn_1_N = mkN "upprivande" ;
  upprustande_nn_1_N = mkN "upprustande" ;
  upprymmande_nn_1_N = mkN "upprymmande" ;
  uppraeknande_nn_1_1_N = mkN "uppräknande" ;
  uppraennande_nn_1_1_N = mkN "upprännande" ;
  uppraettande_nn_1_1_N = mkN "upprättande" ;
  uppraetthaallande_nn_1_1_N = mkN "upprätthållande" ;
  upproerande_nn_1_1_N = mkN "upprörande" ;
  uppsamlande_nn_1_N = mkN "uppsamlande" ;
  uppsatsaemne_nn_1_1_N = mkN "uppsatsämne" ;
  uppskattande_nn_1_N = mkN "uppskattande" ;
  uppskjutande_nn_1_N = mkN "uppskjutande" ;
  uppslagssikte_nn_1_N = mkN "uppslagssikte" ;
  uppslammande_nn_1_N = mkN "uppslammande" ;
  uppslukande_nn_1_N = mkN "uppslukande" ;
  uppsnabbande_nn_1_N = mkN "uppsnabbande" ;
  uppsnappande_nn_1_N = mkN "uppsnappande" ;
  uppspjaelkande_nn_1_1_N = mkN "uppspjälkande" ;
  uppsprickande_nn_1_N = mkN "uppsprickande" ;
  uppspaarande_nn_1_1_N = mkN "uppspårande" ;
  uppstigande_nn_1_N = mkN "uppstigande" ;
  uppstramande_nn_1_N = mkN "uppstramande" ;
  uppstaellande_nn_1_1_N = mkN "uppställande" ;
  uppstaemmande_nn_1_1_N = mkN "uppstämmande" ;
  uppstaaende_nn_1_1_N = mkN "uppstående" ;
  uppsugande_nn_1_N = mkN "uppsugande" ;
  uppsummerande_nn_1_N = mkN "uppsummerande" ;
  uppsaettande_nn_1_1_N = mkN "uppsättande" ;
  uppsoekande_nn_1_1_N = mkN "uppsökande" ;
  upptagande_nn_1_N = mkN "upptagande" ;
  upptagningsomraade_nn_1_1_N = mkN "upptagningsområde" ;
  upptaxerande_nn_1_N = mkN "upptaxerande" ;
  upptecknande_nn_1_N = mkN "upptecknande" ;
  upptornande_nn_1_N = mkN "upptornande" ;
  upptrampande_nn_1_N = mkN "upptrampande" ;
  upptrappande_nn_1_N = mkN "upptrappande" ;
  upptrissande_nn_1_N = mkN "upptrissande" ;
  upptraedande_nn_1_1_N = mkN "uppträdande" ;
  upptraede_nn_1_1_N = mkN "uppträde" ;
  upptaeckande_nn_1_1_N = mkN "upptäckande" ;
  upptaendande_nn_1_1_N = mkN "upptändande" ;
  uppvaktande_nn_1_N = mkN "uppvaktande" ;
  uppviglande_nn_1_N = mkN "uppviglande" ;
  uppvisande_nn_1_N = mkN "uppvisande" ;
  uppvaeckande_nn_1_1_N = mkN "uppväckande" ;
  uppvaegande_nn_1_1_N = mkN "uppvägande" ;
  uppvaerderande_nn_1_1_N = mkN "uppvärderande" ;
  uppvaermande_nn_1_1_N = mkN "uppvärmande" ;
  uppvaexande_nn_1_1_N = mkN "uppväxande" ;
  uppaetande_nn_1_1_N = mkN "uppätande" ;
  uppoevande_nn_1_1_N = mkN "uppövande" ;
  uraktlaatande_nn_1_1_N = mkN "uraktlåtande" ;
  urartande_nn_1_N = mkN "urartande" ;
  urbaniserande_nn_1_N = mkN "urbaniserande" ;
  urgerande_nn_1_N = mkN "urgerande" ;
  urinerande_nn_1_N = mkN "urinerande" ;
  urkalkande_nn_1_N = mkN "urkalkande" ;
  urlakande_nn_1_N = mkN "urlakande" ;
  ursakande_nn_1_N = mkN "ursakande" ;
  ursinne_nn_1_N = mkN "ursinne" ;
  urskiljande_nn_1_N = mkN "urskiljande" ;
  urskuldande_nn_1_N = mkN "urskuldande" ;
  urskoenjande_nn_1_1_N = mkN "urskönjande" ;
  ursprungslaege_nn_1_1_N = mkN "ursprungsläge" ;
  ursprungsmaerkande_nn_1_1_N = mkN "ursprungsmärkande" ;
  ursaektande_nn_1_1_N = mkN "ursäktande" ;
  uruppfoerande_nn_1_1_N = mkN "uruppförande" ;
  uraemne_nn_1_1_N = mkN "urämne" ;
  usb_minne_nn_1_N = mkN "usb-minne" ;
  usurperande_nn_1_N = mkN "usurperande" ;
  utackorderande_nn_1_N = mkN "utackorderande" ;
  utannonserande_nn_1_N = mkN "utannonserande" ;
  utanordnande_nn_1_N = mkN "utanordnande" ;
  utarbetande_nn_1_N = mkN "utarbetande" ;
  utarmande_nn_1_N = mkN "utarmande" ;
  utarrenderande_nn_1_N = mkN "utarrenderande" ;
  utbalanserande_nn_1_N = mkN "utbalanserande" ;
  utbasunerande_nn_1_N = mkN "utbasunerande" ;
  utbekommande_nn_1_N = mkN "utbekommande" ;
  utbetalande_nn_1_N = mkN "utbetalande" ;
  utbildande_nn_1_N = mkN "utbildande" ;
  utbjudande_nn_1_N = mkN "utbjudande" ;
  utbombande_nn_1_N = mkN "utbombande" ;
  utbredande_nn_1_N = mkN "utbredande" ;
  utbredningsomraade_nn_1_1_N = mkN "utbredningsområde" ;
  utbreende_nn_1_N = mkN "utbreende" ;
  utbringande_nn_1_N = mkN "utbringande" ;
  utbristande_nn_1_N = mkN "utbristande" ;
  utbroderande_nn_1_N = mkN "utbroderande" ;
  utbrytande_nn_1_N = mkN "utbrytande" ;
  utbuande_nn_1_N = mkN "utbuande" ;
  utbyggande_nn_1_N = mkN "utbyggande" ;
  utbygge_nn_1_N = mkN "utbygge" ;
  utbytande_nn_1_N = mkN "utbytande" ;
  utbyte_nn_1_N = mkN "utbyte" ;
  utdebiterande_nn_1_N = mkN "utdebiterande" ;
  utdelande_nn_1_N = mkN "utdelande" ;
  utdikande_nn_1_N = mkN "utdikande" ;
  utdragande_nn_1_N = mkN "utdragande" ;
  utdrivande_nn_1_N = mkN "utdrivande" ;
  utdunstande_nn_1_N = mkN "utdunstande" ;
  utdoemande_nn_1_1_N = mkN "utdömande" ;
  utebliende_nn_1_N = mkN "utebliende" ;
  uteblivande_nn_1_N = mkN "uteblivande" ;
  utelaemnande_nn_1_1_N = mkN "utelämnande" ;
  utelaasande_nn_1_1_N = mkN "utelåsande" ;
  uteslutande_nn_1_N = mkN "uteslutande" ;
  utestaengande_nn_1_1_N = mkN "utestängande" ;
  utexaminerande_nn_1_N = mkN "utexaminerande" ;
  utexperimenterande_nn_1_N = mkN "utexperimenterande" ;
  utfallande_nn_1_N = mkN "utfallande" ;
  utfallsdike_nn_1_N = mkN "utfallsdike" ;
  utfiskande_nn_1_N = mkN "utfiskande" ;
  utflaggande_nn_1_N = mkN "utflaggande" ;
  utfloede_nn_1_1_N = mkN "utflöde" ;
  utfodrande_nn_1_N = mkN "utfodrande" ;
  utfordrande_nn_1_N = mkN "utfordrande" ;
  utformande_nn_1_N = mkN "utformande" ;
  utforskande_nn_1_N = mkN "utforskande" ;
  utfraktande_nn_1_N = mkN "utfraktande" ;
  utfraagande_nn_1_1_N = mkN "utfrågande" ;
  utfyllande_nn_1_N = mkN "utfyllande" ;
  utfaellande_nn_1_1_N = mkN "utfällande" ;
  utfaerdande_nn_1_1_N = mkN "utfärdande" ;
  utfaestande_nn_1_1_N = mkN "utfästande" ;
  utfaaende_nn_1_1_N = mkN "utfående" ;
  utfoerande_nn_1_1_N = mkN "utförande" ;
  utfoersaekrande_nn_1_1_N = mkN "utförsäkrande" ;
  utfoersaeljande_nn_1_1_N = mkN "utförsäljande" ;
  utgeende_nn_1_N = mkN "utgeende" ;
  utgivande_nn_1_N = mkN "utgivande" ;
  utgjutande_nn_1_N = mkN "utgjutande" ;
  utglesande_nn_1_N = mkN "utglesande" ;
  utgrundande_nn_1_N = mkN "utgrundande" ;
  utgraevande_nn_1_1_N = mkN "utgrävande" ;
  utgaaende_nn_1_1_N = mkN "utgående" ;
  utgaangslaege_nn_1_1_N = mkN "utgångsläge" ;
  utgoerande_nn_1_1_N = mkN "utgörande" ;
  uthamrande_nn_1_N = mkN "uthamrande" ;
  uthyrande_nn_1_N = mkN "uthyrande" ;
  uthaerdande_nn_1_1_N = mkN "uthärdande" ;
  utjaemnande_nn_1_1_N = mkN "utjämnande" ;
  utkammande_nn_1_N = mkN "utkammande" ;
  utkastande_nn_1_N = mkN "utkastande" ;
  utklarande_nn_1_N = mkN "utklarande" ;
  utklarerande_nn_1_N = mkN "utklarerande" ;
  utklassande_nn_1_N = mkN "utklassande" ;
  utklyvande_nn_1_N = mkN "utklyvande" ;
  utkommande_nn_1_N = mkN "utkommande" ;
  utkommenderande_nn_1_N = mkN "utkommenderande" ;
  utkonkurrerande_nn_1_N = mkN "utkonkurrerande" ;
  utkorande_nn_1_N = mkN "utkorande" ;
  utkristalliserande_nn_1_N = mkN "utkristalliserande" ;
  utkraevande_nn_1_1_N = mkN "utkrävande" ;
  utkvitterande_nn_1_N = mkN "utkvitterande" ;
  utkylande_nn_1_N = mkN "utkylande" ;
  utkaempande_nn_1_1_N = mkN "utkämpande" ;
  utlokaliserande_nn_1_N = mkN "utlokaliserande" ;
  utlottande_nn_1_N = mkN "utlottande" ;
  utlovande_nn_1_N = mkN "utlovande" ;
  utlysande_nn_1_N = mkN "utlysande" ;
  utlaeggande_nn_1_1_N = mkN "utläggande" ;
  utlaemnande_nn_1_1_N = mkN "utlämnande" ;
  utlaemningsfoerfarande_nn_1_1_N = mkN "utlämningsförfarande" ;
  utlaesande_nn_1_1_N = mkN "utläsande" ;
  utlaanande_nn_1_1_N = mkN "utlånande" ;
  utlaatande_nn_1_1_N = mkN "utlåtande" ;
  utloepande_nn_1_1_N = mkN "utlöpande" ;
  utloesande_nn_1_1_N = mkN "utlösande" ;
  utmanande_nn_1_N = mkN "utmanande" ;
  utmanoevrerande_nn_1_1_N = mkN "utmanövrerande" ;
  utmattande_nn_1_N = mkN "utmattande" ;
  utmejslande_nn_1_N = mkN "utmejslande" ;
  utminuterande_nn_1_N = mkN "utminuterande" ;
  utmynnande_nn_1_N = mkN "utmynnande" ;
  utmaerkande_nn_1_1_N = mkN "utmärkande" ;
  utmaetande_nn_1_1_N = mkN "utmätande" ;
  utmaalande_nn_1_1_N = mkN "utmålande" ;
  utmoenstrande_nn_1_1_N = mkN "utmönstrande" ;
  utnyttjande_nn_1_N = mkN "utnyttjande" ;
  utnaemnande_nn_1_1_N = mkN "utnämnande" ;
  utpekande_nn_1_N = mkN "utpekande" ;
  utplacerande_nn_1_N = mkN "utplacerande" ;
  utplundrande_nn_1_N = mkN "utplundrande" ;
  utplaanande_nn_1_1_N = mkN "utplånande" ;
  utposterande_nn_1_N = mkN "utposterande" ;
  utpressande_nn_1_N = mkN "utpressande" ;
  utpressningssyfte_nn_1_N = mkN "utpressningssyfte" ;
  utprickande_nn_1_N = mkN "utprickande" ;
  utprovande_nn_1_N = mkN "utprovande" ;
  utproevande_nn_1_1_N = mkN "utprövande" ;
  utraderande_nn_1_N = mkN "utraderande" ;
  utrangerande_nn_1_N = mkN "utrangerande" ;
  utredande_nn_1_N = mkN "utredande" ;
  utredningsarbete_nn_1_N = mkN "utredningsarbete" ;
  utrensande_nn_1_N = mkN "utrensande" ;
  utropande_nn_1_N = mkN "utropande" ;
  utrotande_nn_1_N = mkN "utrotande" ;
  utrustande_nn_1_N = mkN "utrustande" ;
  utrymmande_nn_1_N = mkN "utrymmande" ;
  utrymme_nn_1_N = mkN "utrymme" ;
  utraettande_nn_1_1_N = mkN "uträttande" ;
  utroenande_nn_1_1_N = mkN "utrönande" ;
  utseende_nn_1_N = mkN "utseende" ;
  utsirande_nn_1_N = mkN "utsirande" ;
  utskeppande_nn_1_N = mkN "utskeppande" ;
  utskiljande_nn_1_N = mkN "utskiljande" ;
  utskottsbetaenkande_nn_1_1_N = mkN "utskottsbetänkande" ;
  utskrivande_nn_1_N = mkN "utskrivande" ;
  utskaenkande_nn_1_1_N = mkN "utskänkande" ;
  utslungande_nn_1_N = mkN "utslungande" ;
  utslussande_nn_1_N = mkN "utslussande" ;
  utslaeckande_nn_1_1_N = mkN "utsläckande" ;
  utslaetande_nn_1_1_N = mkN "utslätande" ;
  utsmyckande_nn_1_N = mkN "utsmyckande" ;
  utspanande_nn_1_N = mkN "utspanande" ;
  utspisande_nn_1_N = mkN "utspisande" ;
  utspisningsstaelle_nn_1_1_N = mkN "utspisningsställe" ;
  utspridande_nn_1_N = mkN "utspridande" ;
  utspyende_nn_1_N = mkN "utspyende" ;
  utspaerrande_nn_1_1_N = mkN "utspärrande" ;
  utstakande_nn_1_N = mkN "utstakande" ;
  utstofferande_nn_1_N = mkN "utstofferande" ;
  utstraeckande_nn_1_1_N = mkN "utsträckande" ;
  utstraalande_nn_1_1_N = mkN "utstrålande" ;
  utstaellande_nn_1_1_N = mkN "utställande" ;
  utstaaende_nn_1_1_N = mkN "utstående" ;
  utstoetande_nn_1_1_N = mkN "utstötande" ;
  utsugande_nn_1_N = mkN "utsugande" ;
  utsynande_nn_1_N = mkN "utsynande" ;
  utsaede_nn_1_1_N = mkN "utsäde" ;
  utsaegande_nn_1_1_N = mkN "utsägande" ;
  utsaendande_nn_1_1_N = mkN "utsändande" ;
  utsaettande_nn_1_1_N = mkN "utsättande" ;
  utsoekande_nn_1_1_N = mkN "utsökande" ;
  utsoendrande_nn_1_1_N = mkN "utsöndrande" ;
  uttalande_nn_1_N = mkN "uttalande" ;
  uttaxerande_nn_1_N = mkN "uttaxerande" ;
  uttolkande_nn_1_N = mkN "uttolkande" ;
  uttorkande_nn_1_N = mkN "uttorkande" ;
  uttryckande_nn_1_N = mkN "uttryckande" ;
  uttraedande_nn_1_1_N = mkN "utträdande" ;
  uttraede_nn_1_1_N = mkN "utträde" ;
  uttroettande_nn_1_1_N = mkN "uttröttande" ;
  uttunnande_nn_1_N = mkN "uttunnande" ;
  uttydande_nn_1_N = mkN "uttydande" ;
  uttaenjande_nn_1_1_N = mkN "uttänjande" ;
  uttoemmande_nn_1_1_N = mkN "uttömmande" ;
  utvandrande_nn_1_N = mkN "utvandrande" ;
  utvecklande_nn_1_N = mkN "utvecklande" ;
  utvecklingsarbete_nn_1_N = mkN "utvecklingsarbete" ;
  utvecklingsskede_nn_1_N = mkN "utvecklingsskede" ;
  utverkande_nn_1_N = mkN "utverkande" ;
  utvidgande_nn_1_N = mkN "utvidgande" ;
  utvinnande_nn_1_N = mkN "utvinnande" ;
  utvisande_nn_1_N = mkN "utvisande" ;
  utvaeljande_nn_1_1_N = mkN "utväljande" ;
  utvaerderande_nn_1_1_N = mkN "utvärderande" ;
  utvaexlande_nn_1_1_N = mkN "utväxlande" ;
  utoekande_nn_1_1_N = mkN "utökande" ;
  utoevande_nn_1_1_N = mkN "utövande" ;
  vabbande_nn_1_N = mkN "vabbande" ;
  vaccinerande_nn_1_N = mkN "vaccinerande" ;
  vacklande_nn_1_N = mkN "vacklande" ;
  vadande_nn_1_N = mkN "vadande" ;
  vadderande_nn_1_N = mkN "vadderande" ;
  vadstaelle_nn_1_1_N = mkN "vadställe" ;
  vagabonderande_nn_1_N = mkN "vagabonderande" ;
  vaggande_nn_1_N = mkN "vaggande" ;
  vagnlaege_nn_1_1_N = mkN "vagnläge" ;
  vajande_nn_1_N = mkN "vajande" ;
  vakande_nn_1_N = mkN "vakande" ;
  vakansfoerordnande_nn_1_1_N = mkN "vakansförordnande" ;
  vakanssaettande_nn_1_1_N = mkN "vakanssättande" ;
  vakantsaettande_nn_1_1_N = mkN "vakantsättande" ;
  vaknande_nn_1_N = mkN "vaknande" ;
  vaksinerande_nn_1_N = mkN "vaksinerande" ;
  vaktande_nn_1_N = mkN "vaktande" ;
  valackande_nn_1_N = mkN "valackande" ;
  valborgsmaessofirande_nn_1_1_N = mkN "valborgsmässofirande" ;
  valdeltagande_nn_1_N = mkN "valdeltagande" ;
  valfuskande_nn_1_N = mkN "valfuskande" ;
  valkande_nn_1_N = mkN "valkande" ;
  valkgarvande_nn_1_N = mkN "valkgarvande" ;
  vallande_nn_1_N = mkN "vallande" ;
  vallfaerdande_nn_1_1_N = mkN "vallfärdande" ;
  valloefte_nn_1_1_N = mkN "vallöfte" ;
  valmoete_nn_1_1_N = mkN "valmöte" ;
  valnande_nn_1_N = mkN "valnande" ;
  valpande_nn_1_N = mkN "valpande" ;
  valrike_nn_1_N = mkN "valrike" ;
  valsande_nn_1_N = mkN "valsande" ;
  valstugeavsloejande_nn_1_1_N = mkN "valstugeavslöjande" ;
  valutasamarbete_nn_1_N = mkN "valutasamarbete" ;
  valuterande_nn_1_N = mkN "valuterande" ;
  valverande_nn_1_N = mkN "valverande" ;
  valoeverklagande_nn_1_1_N = mkN "valöverklagande" ;
  vampande_nn_1_N = mkN "vampande" ;
  vandaliserande_nn_1_N = mkN "vandaliserande" ;
  vandrande_nn_1_N = mkN "vandrande" ;
  vanhedrande_nn_1_N = mkN "vanhedrande" ;
  vanhelgande_nn_1_N = mkN "vanhelgande" ;
  vankande_nn_1_N = mkN "vankande" ;
  vannande_nn_1_N = mkN "vannande" ;
  vanprydande_nn_1_N = mkN "vanprydande" ;
  vanrykte_nn_1_N = mkN "vanrykte" ;
  vansinne_nn_1_N = mkN "vansinne" ;
  vanskoetande_nn_1_1_N = mkN "vanskötande" ;
  vanstyrande_nn_1_N = mkN "vanstyrande" ;
  vanstyre_nn_1_N = mkN "vanstyre" ;
  vanstaellande_nn_1_1_N = mkN "vanställande" ;
  vantolkande_nn_1_N = mkN "vantolkande" ;
  vanvaardande_nn_1_1_N = mkN "vanvårdande" ;
  vanvoerdande_nn_1_1_N = mkN "vanvördande" ;
  vanaerande_nn_1_1_N = mkN "vanärande" ;
  vapenskifte_nn_1_N = mkN "vapenskifte" ;
  vapenvaegrande_nn_1_1_N = mkN "vapenvägrande" ;
  varande_nn_1_N = mkN "varande" ;
  vardagstaenkande_nn_1_1_N = mkN "vardagstänkande" ;
  vardande_nn_1_N = mkN "vardande" ;
  vargande_nn_1_N = mkN "vargande" ;
  varierande_nn_1_N = mkN "varierande" ;
  varmbonande_nn_1_N = mkN "varmbonande" ;
  varmkoerande_nn_1_1_N = mkN "varmkörande" ;
  varnande_nn_1_N = mkN "varnande" ;
  varningsmaerke_nn_1_1_N = mkN "varningsmärke" ;
  varpande_nn_1_N = mkN "varpande" ;
  varseblivande_nn_1_N = mkN "varseblivande" ;
  varskoende_nn_1_N = mkN "varskoende" ;
  varslande_nn_1_N = mkN "varslande" ;
  varsnande_nn_1_N = mkN "varsnande" ;
  varudeklarerande_nn_1_N = mkN "varudeklarerande" ;
  varumaerke_nn_1_1_N = mkN "varumärke" ;
  varvande_nn_1_N = mkN "varvande" ;
  vaskande_nn_1_N = mkN "vaskande" ;
  vassgoerande_nn_1_1_N = mkN "vassgörande" ;
  vattenfloede_nn_1_1_N = mkN "vattenflöde" ;
  vattenhoelje_nn_1_1_N = mkN "vattenhölje" ;
  vattenkammande_nn_1_N = mkN "vattenkammande" ;
  vattenmaerke_nn_1_1_N = mkN "vattenmärke" ;
  vattenvaerde_nn_1_1_N = mkN "vattenvärde" ;
  vattnande_nn_1_N = mkN "vattnande" ;
  vattrande_nn_1_N = mkN "vattrande" ;
  vaxande_nn_1_N = mkN "vaxande" ;
  veckande_nn_1_N = mkN "veckande" ;
  vecklande_nn_1_N = mkN "vecklande" ;
  veckohandlande_nn_1_N = mkN "veckohandlande" ;
  veckopendlande_nn_1_N = mkN "veckopendlande" ;
  vederboerande_nn_1_1_N = mkN "vederbörande" ;
  vedergaellande_nn_1_1_N = mkN "vedergällande" ;
  vederkvickande_nn_1_N = mkN "vederkvickande" ;
  vedermaele_nn_1_1_N = mkN "vedermäle" ;
  vedervaagande_nn_1_1_N = mkN "vedervågande" ;
  vegetationsbaelte_nn_1_1_N = mkN "vegetationsbälte" ;
  vegeterande_nn_1_N = mkN "vegeterande" ;
  veklagande_nn_1_N = mkN "veklagande" ;
  veknande_nn_1_N = mkN "veknande" ;
  velande_nn_1_N = mkN "velande" ;
  velouriserande_nn_1_N = mkN "velouriserande" ;
  ventilerande_nn_1_N = mkN "ventilerande" ;
  ventilsnoere_nn_1_1_N = mkN "ventilsnöre" ;
  verandaraecke_nn_1_1_N = mkN "verandaräcke" ;
  verbaliserande_nn_1_N = mkN "verbaliserande" ;
  verifierande_nn_1_N = mkN "verifierande" ;
  verkande_nn_1_N = mkN "verkande" ;
  verkliggoerande_nn_1_1_N = mkN "verkliggörande" ;
  verklighetsfoerankrande_nn_1_1_N = mkN "verklighetsförankrande" ;
  verksamhetsomraade_nn_1_1_N = mkN "verksamhetsområde" ;
  verkstadsarbete_nn_1_N = mkN "verkstadsarbete" ;
  verkstaellande_nn_1_1_N = mkN "verkställande" ;
  verktygsbaelte_nn_1_1_N = mkN "verktygsbälte" ;
  versifierande_nn_1_N = mkN "versifierande" ;
  vertikallaege_nn_1_1_N = mkN "vertikalläge" ;
  vetenskapande_nn_1_N = mkN "vetenskapande" ;
  vettande_nn_1_N = mkN "vettande" ;
  vevande_nn_1_N = mkN "vevande" ;
  vevlande_nn_1_N = mkN "vevlande" ;
  vibrerande_nn_1_N = mkN "vibrerande" ;
  vickande_nn_1_N = mkN "vickande" ;
  vidarebefordrande_nn_1_N = mkN "vidarebefordrande" ;
  vidareutbildande_nn_1_N = mkN "vidareutbildande" ;
  vidareutvecklande_nn_1_N = mkN "vidareutvecklande" ;
  vidbraennande_nn_1_1_N = mkN "vidbrännande" ;
  vide_nn_1_N = mkN "vide" ;
  vidgande_nn_1_N = mkN "vidgande" ;
  vidgaaende_nn_1_1_N = mkN "vidgående" ;
  vidhaeftande_nn_1_1_N = mkN "vidhäftande" ;
  vidhaengande_nn_1_1_N = mkN "vidhängande" ;
  vidhaallande_nn_1_1_N = mkN "vidhållande" ;
  vidimerande_nn_1_N = mkN "vidimerande" ;
  vidkommande_nn_1_N = mkN "vidkommande" ;
  vidlaadande_nn_1_1_N = mkN "vidlådande" ;
  vidmakthaallande_nn_1_1_N = mkN "vidmakthållande" ;
  vidroerande_nn_1_1_N = mkN "vidrörande" ;
  vidtagande_nn_1_N = mkN "vidtagande" ;
  vidtalande_nn_1_N = mkN "vidtalande" ;
  viftande_nn_1_N = mkN "viftande" ;
  vigande_nn_1_N = mkN "vigande" ;
  viggande_nn_1_N = mkN "viggande" ;
  vigilerande_nn_1_N = mkN "vigilerande" ;
  vigningsloefte_nn_1_1_N = mkN "vigningslöfte" ;
  villaomraade_nn_1_1_N = mkN "villaområde" ;
  vilolaege_nn_1_1_N = mkN "viloläge" ;
  vindbaelte_nn_1_1_N = mkN "vindbälte" ;
  vindfaelle_nn_1_1_N = mkN "vindfälle" ;
  vindskifte_nn_1_N = mkN "vindskifte" ;
  vindsutrymme_nn_1_N = mkN "vindsutrymme" ;
  vinmaerke_nn_1_1_N = mkN "vinmärke" ;
  vinstsyfte_nn_1_N = mkN "vinstsyfte" ;
  vippbraede_nn_1_1_N = mkN "vippbräde" ;
  viste_nn_1_N = mkN "viste" ;
  vite_nn_1_N = mkN "vite" ;
  vittne_nn_1_N = mkN "vittne" ;
  vokalmoete_nn_1_1_N = mkN "vokalmöte" ;
  vulgonaeste_nn_1_1_N = mkN "vulgonäste" ;
  vaeckelsemoete_nn_1_1_N = mkN "väckelsemöte" ;
  vaegarbete_nn_1_1_N = mkN "vägarbete" ;
  vaegbygge_nn_1_1_N = mkN "vägbygge" ;
  vaegdike_nn_1_1_N = mkN "vägdike" ;
  vaegmaerke_nn_1_1_N = mkN "vägmärke" ;
  vaegraecke_nn_1_1_N = mkN "vägräcke" ;
  vaelde_nn_1_1_N = mkN "välde" ;
  vaelfaerdsbygge_nn_1_1_N = mkN "välfärdsbygge" ;
  vaelfaerdsloefte_nn_1_1_N = mkN "välfärdslöfte" ;
  vaelfaerdssamhaelle_nn_1_1_N = mkN "välfärdssamhälle" ;
  vaentevaerde_nn_1_1_N = mkN "väntevärde" ;
  vaerdeomdoeme_nn_1_1_N = mkN "värdeomdöme" ;
  vaerldsherravaelde_nn_1_1_N = mkN "världsherravälde" ;
  vaermefloede_nn_1_1_N = mkN "värmeflöde" ;
  vaermeutbyte_nn_1_1_N = mkN "värmeutbyte" ;
  vaextsamhaelle_nn_1_1_N = mkN "växtsamhälle" ;
  vaextslaekte_nn_1_1_N = mkN "växtsläkte" ;
  vaextaemne_nn_1_1_N = mkN "växtämne" ;
  vaagstycke_nn_1_1_N = mkN "vågstycke" ;
  vaarbete_nn_1_1_N = mkN "vårbete" ;
  vaardyrke_nn_1_1_N = mkN "vårdyrke" ;
  vaatutrymme_nn_1_1_N = mkN "våtutrymme" ;
  wallraffande_nn_1_N = mkN "wallraffande" ;
  ynglingalynne_nn_1_N = mkN "ynglingalynne" ;
  ynglingasinne_nn_1_N = mkN "ynglingasinne" ;
  yrke_nn_1_N = mkN "yrke" ;
  yrkesarbete_nn_1_N = mkN "yrkesarbete" ;
  yste_nn_1_N = mkN "yste" ;
  ytterhoelje_nn_1_1_N = mkN "ytterhölje" ;
  ytteromraade_nn_1_1_N = mkN "ytterområde" ;
  yxaemne_nn_1_1_N = mkN "yxämne" ;
  OEstersjoesamarbete_nn_1_1_N = mkN "Östersjösamarbete" ;
  aeggviteaemne_nn_1_1_N = mkN "äggviteämne" ;
  aegoskifte_nn_1_1_N = mkN "ägoskifte" ;
  aektenskapsloefte_nn_1_1_N = mkN "äktenskapslöfte" ;
  aembete_nn_1_1_N = mkN "ämbete" ;
  aemne_nn_1_1_N = mkN "ämne" ;
  aemnesomraade_nn_1_1_N = mkN "ämnesområde" ;
  aenkesaete_nn_1_1_N = mkN "änkesäte" ;
  aenne_nn_1_1_N = mkN "änne" ;
  aereminne_nn_1_1_N = mkN "äreminne" ;
  aermbraede_nn_1_1_N = mkN "ärmbräde" ;
  aabaeke_nn_1_1_N = mkN "åbäke" ;
  aakergaerde_nn_1_1_N = mkN "åkergärde" ;
  aakerspoeke_nn_1_1_N = mkN "åkerspöke" ;
  aalagille_nn_1_1_N = mkN "ålagille" ;
  aarhundrade_nn_1_1_N = mkN "århundrade" ;
  aarsmoete_nn_1_1_N = mkN "årsmöte" ;
  aarsskifte_nn_1_1_N = mkN "årsskifte" ;
  aasiktsutbyte_nn_1_1_N = mkN "åsiktsutbyte" ;
  oede_nn_1_1_N = mkN "öde" ;
  oedemarksomraade_nn_1_1_N = mkN "ödemarksområde" ;
  oegonmaerke_nn_1_1_N = mkN "ögonmärke" ;
  oegonvittne_nn_1_1_N = mkN "ögonvittne" ;
  oelsinne_nn_1_1_N = mkN "ölsinne" ;
  oeppningsskede_nn_1_1_N = mkN "öppningsskede" ;
  oerhaenge_nn_1_1_N = mkN "örhänge" ;
  oerike_nn_1_1_N = mkN "örike" ;
  oeverarbete_nn_1_1_N = mkN "överarbete" ;
  oeverfloedssamhaelle_nn_1_1_N = mkN "överflödssamhälle" ;
  oevergaangsskede_nn_1_1_N = mkN "övergångsskede" ;
  oeverlaege_nn_1_1_N = mkN "överläge" ;
  oeverrede_nn_1_1_N = mkN "överrede" ;
  oeverstycke_nn_1_1_N = mkN "överstycke" ;
  oevertidsarbete_nn_1_1_N = mkN "övertidsarbete" ;
  oevervakningssamhaelle_nn_1_1_N = mkN "övervakningssamhälle" ;
  oevervaelde_nn_1_1_N = mkN "övervälde" ;
  oevningsaemne_nn_1_1_N = mkN "övningsämne" ;
  oemhetsbetygelse_nn_1_1_N = mkN "ömhetsbetygelse" "ömhetsbetygelseen" "ömhetsbetygelseer" "ömhetsbetygelseerna" ;
  vaen_nn_1_1_N = mkN "vän" "vännen" "vänner" "vännerna" ;
  vaeggmadam_nn_1_1_N = mkN "väggmadam" "väggmadammen" "väggmadammer" "väggmadammerna" ;
  vraa_nn_1_1_N = mkN "vrå" "vrån" "vrår" "vrårna" ;
  vinbladsdolma_nn_1_N = mkN "vinbladsdolma" "vinbladsdolman" "vinbladsdolmar" "vinbladsdolmarna" ;
  ungmoe_nn_1_1_N = mkN "ungmö" "ungmön" "ungmör" "ungmörna" ;
  ungersven_nn_1_N = mkN "ungersven" "ungersvennen" "ungersvenner" "ungersvennerna" ;
  ungdomsvaen_nn_1_1_N = mkN "ungdomsvän" "ungdomsvännen" "ungdomsvänner" "ungdomsvännerna" ;
  ungdomsfaengelse_nn_1_1_N = mkN "ungdomsfängelse" "ungdomsfängelset" "ungdomsfängelser" "ungdomsfängelserna" ;
  underraa_nn_1_1_N = mkN "underrå" "underrån" "underrår" "underrårna" ;
  taa_nn_1_1_N = mkN "tå" "tån" "tår" "tårna" ;
  taeckelse_nn_1_1_N = mkN "täckelse" "täckelset" "täckelser" "täckelserna" ;
  trikolor_nn_1_N = mkN "trikolor" "trikoloren" "trikolorer" "trikolorerna" ;
  toreador_nn_1_N = mkN "toreador" "toreadoren" "toreadorer" "toreadorerna" ;
  tenor_nn_1_N = mkN "tenor" "tenoren" "tenorer" "tenorerna" ;
  saangmoe_nn_1_1_N = mkN "sångmö" "sångmön" "sångmör" "sångmörna" ;
  sykomor_nn_1_N = mkN "sykomor" "sykomoren" "sykomorer" "sykomorerna" ;
  sven_nn_1_N = mkN "sven" "svennen" "svenner" "svennerna" ;
  stortaa_nn_1_1_N = mkN "stortå" "stortån" "stortår" "stortårna" ;
  stiftsjungfru_nn_1_N = mkN "stiftsjungfru" "stiftsjungfrun" "stiftsjungfrur" "stiftsjungfrurna" ;
  spoekelse_nn_1_1_N = mkN "spökelse" "spökelset" "spökelser" "spökelserna" ;
  spray_nn_1_N = mkN "spray" "sprayet" "sprayer" "sprayerna" ;
  spor_nn_1_N = mkN "spor" "sporen" "sporer" "sporerna" ;
  spiselvraa_nn_1_1_N = mkN "spiselvrå" "spiselvrån" "spiselvrår" "spiselvrårna" ;
  spermatofor_nn_1_N = mkN "spermatofor" "spermatoforen" "spermatoforer" "spermatoforerna" ;
  spanjor_nn_1_N = mkN "spanjor" "spanjoren" "spanjorer" "spanjorerna" ;
  sonhustru_nn_1_N = mkN "sonhustru" "sonhustrun" "sonhustrur" "sonhustrurna" ;
  smoertenor_nn_1_1_N = mkN "smörtenor" "smörtenoren" "smörtenorer" "smörtenorerna" ;
  skoeldmoe_nn_1_1_N = mkN "sköldmö" "sköldmön" "sköldmör" "sköldmörna" ;
  skraeckfaengelse_nn_1_1_N = mkN "skräckfängelse" "skräckfängelset" "skräckfängelser" "skräckfängelserna" ;
  skolkorridor_nn_1_N = mkN "skolkorridor" "skolkorridoren" "skolkorridorer" "skolkorridorerna" ;
  sjoejungfru_nn_1_1_N = mkN "sjöjungfru" "sjöjungfrun" "sjöjungfrur" "sjöjungfrurna" ;
  sjukhuskorridor_nn_1_N = mkN "sjukhuskorridor" "sjukhuskorridoren" "sjukhuskorridorer" "sjukhuskorridorerna" ;
  signor_nn_1_N = mkN "signor" "signoren" "signorer" "signorerna" ;
  senor_nn_1_1_N = mkN "señor" "señoren" "señorer" "señorerna" ;
  semafor_nn_1_N = mkN "semafor" "semaforen" "semaforer" "semaforerna" ;
  raa_nn_1_1_N = mkN "rå" "rån" "rår" "rårna" ;
  roddarmadam_nn_1_N = mkN "roddarmadam" "roddarmadammen" "roddarmadammer" "roddarmadammerna" ;
  presidenthustru_nn_1_N = mkN "presidenthustru" "presidenthustrun" "presidenthustrur" "presidenthustrurna" ;
  portvinstaa_nn_1_1_N = mkN "portvinstå" "portvinstån" "portvinstår" "portvinstårna" ;
  por_nn_1_N = mkN "por" "poren" "porer" "porerna" ;
  politikerhustru_nn_1_N = mkN "politikerhustru" "politikerhustrun" "politikerhustrur" "politikerhustrurna" ;
  polismajor_nn_1_N = mkN "polismajor" "polismajoren" "polismajorer" "polismajorerna" ;
  pojkvaen_nn_1_1_N = mkN "pojkvän" "pojkvännen" "pojkvänner" "pojkvännerna" ;
  plasma_nn_1_N = mkN "plasma" "plasmat" "plasmer" "plasmerna" ;
  pingstvaen_nn_1_1_N = mkN "pingstvän" "pingstvännen" "pingstvänner" "pingstvännerna" ;
  pikador_nn_1_N = mkN "pikador" "pikadoren" "pikadorer" "pikadorerna" ;
  picador_nn_1_N = mkN "picador" "picadoren" "picadorer" "picadorerna" ;
  pektaa_nn_1_1_N = mkN "pektå" "pektån" "pektår" "pektårna" ;
  parallellogram_nn_1_N = mkN "parallellogram" "parallellogrammen" "parallellogrammer" "parallellogrammerna" ;
  ovaen_nn_1_1_N = mkN "ovän" "ovännen" "ovänner" "ovännerna" ;
  ormslaa_nn_1_1_N = mkN "ormslå" "ormslån" "ormslår" "ormslårna" ;
  omnivor_nn_1_N = mkN "omnivor" "omnivoren" "omnivorer" "omnivorerna" ;
  okulage_nn_1_N = mkN "okulage" "okulaget" "okulager" "okulagerna" ;
  naesspray_nn_1_1_N = mkN "nässpray" "nässprayen" "nässprayer" "nässprayerna" ;
  naturvaen_nn_1_1_N = mkN "naturvän" "naturvännen" "naturvänner" "naturvännerna" ;
  moe_nn_1_1_N = mkN "mö" "mön" "mör" "mörna" ;
  maersraa_nn_1_1_N = mkN "märsrå" "märsrån" "märsrår" "märsrårna" ;
  maenniskovaen_nn_1_1_N = mkN "människovän" "människovännen" "människovänner" "människovännerna" ;
  minior_nn_1_N = mkN "minior" "minioren" "miniorer" "miniorerna" ;
  meteor_nn_1_N = mkN "meteor" "meteoren" "meteorer" "meteorerna" ;
  matvraa_nn_1_1_N = mkN "matvrå" "matvrån" "matvrår" "matvrårna" ;
  matador_nn_1_N = mkN "matador" "matadoren" "matadorer" "matadorerna" ;
  madam_nn_1_N = mkN "madam" "madammen" "madammer" "madammerna" ;
  lyxhustru_nn_1_N = mkN "lyxhustru" "lyxhustrun" "lyxhustrur" "lyxhustrurna" ;
  livstidsfaengelse_nn_1_1_N = mkN "livstidsfängelse" "livstidsfängelset" "livstidsfängelser" "livstidsfängelserna" ;
  lilltaa_nn_1_1_N = mkN "lilltå" "lilltån" "lilltår" "lilltårna" ;
  lantarbetarhustru_nn_1_N = mkN "lantarbetarhustru" "lantarbetarhustrun" "lantarbetarhustrur" "lantarbetarhustrurna" ;
  labrador_nn_1_N = mkN "labrador" "labradoren" "labradorer" "labradorerna" ;
  koersven_nn_1_1_N = mkN "körsven" "körsvennen" "körsvenner" "körsvennerna" ;
  kaaldolma_nn_1_1_N = mkN "kåldolma" "kåldolman" "kåldolmar" "kåldolmarna" ;
  kvinnofaengelse_nn_1_1_N = mkN "kvinnofängelse" "kvinnofängelset" "kvinnofängelser" "kvinnofängelserna" ;
  kraftparallellogram_nn_1_N = mkN "kraftparallellogram" "kraftparallellogrammen" "kraftparallellogrammer" "kraftparallellogrammerna" ;
  korridor_nn_1_N = mkN "korridor" "korridoren" "korridorer" "korridorerna" ;
  kondor_nn_1_N = mkN "kondor" "kondoren" "kondorer" "kondorerna" ;
  kokvraa_nn_1_1_N = mkN "kokvrå" "kokvrån" "kokvrår" "kokvrårna" ;
  karnivor_nn_1_N = mkN "karnivor" "karnivoren" "karnivorer" "karnivorerna" ;
  kammarjungfru_nn_1_N = mkN "kammarjungfru" "kammarjungfrun" "kammarjungfrur" "kammarjungfrurna" ;
  jaernjungfru_nn_1_1_N = mkN "järnjungfru" "järnjungfrun" "järnjungfrur" "järnjungfrurna" ;
  jungfru_nn_1_N = mkN "jungfru" "jungfrun" "jungfrur" "jungfrurna" ;
  hydrofor_nn_1_N = mkN "hydrofor" "hydroforen" "hydroforer" "hydroforerna" ;
  hustru_nn_1_N = mkN "hustru" "hustrun" "hustrur" "hustrurna" ;
  hjaertevaen_nn_1_1_N = mkN "hjärtevän" "hjärtevännen" "hjärtevänner" "hjärtevännerna" ;
  hjaeltetenor_nn_1_1_N = mkN "hjältetenor" "hjältetenoren" "hjältetenorer" "hjältetenorerna" ;
  gem_nn_1_N = mkN "gem" "gemmen" "gemmer" "gemmerna" ;
  foerfattarvaen_nn_1_1_N = mkN "författarvän" "författarvännen" "författarvänner" "författarvännerna" ;
  faestmoe_nn_1_1_N = mkN "fästmö" "fästmön" "fästmör" "fästmörna" ;
  faengelse_nn_1_1_N = mkN "fängelse" "fängelset" "fängelser" "fängelserna" ;
  flygkorridor_nn_1_N = mkN "flygkorridor" "flygkorridoren" "flygkorridorer" "flygkorridorerna" ;
  flickvaen_nn_1_1_N = mkN "flickvän" "flickvännen" "flickvänner" "flickvännerna" ;
  farstu_nn_1_N = mkN "farstu" "farstun" "farstur" "farsturna" ;
  expojkvaen_nn_1_1_N = mkN "expojkvän" "expojkvännen" "expojkvänner" "expojkvännerna" ;
  exhustru_nn_1_N = mkN "exhustru" "exhustrun" "exhustrur" "exhustrurna" ;
  exflickvaen_nn_1_1_N = mkN "exflickvän" "exflickvännen" "exflickvänner" "exflickvännerna" ;
  elektrofor_nn_1_N = mkN "elektrofor" "elektroforen" "elektroforer" "elektroforerna" ;
  efor_nn_1_N = mkN "efor" "eforen" "eforer" "eforerna" ;
  dolma_nn_1_N = mkN "dolma" "dolman" "dolmar" "dolmarna" ;
  djurvaen_nn_1_1_N = mkN "djurvän" "djurvännen" "djurvänner" "djurvännerna" ;
  display_nn_1_N = mkN "display" "displayen" "displayer" "displayerna" ;
  diplomathustru_nn_1_N = mkN "diplomathustru" "diplomathustrun" "diplomathustrur" "diplomathustrurna" ;
  dekor_nn_1_N = mkN "dekor" "dekoren" "dekorer" "dekorerna" ;
  cellplasma_nn_1_N = mkN "cellplasma" "cellplasmat" "cellplasmer" "cellplasmerna" ;
  cellfaengelse_nn_1_1_N = mkN "cellfängelse" "cellfängelset" "cellfängelser" "cellfängelserna" ;
  brevvaen_nn_1_1_N = mkN "brevvän" "brevvännen" "brevvänner" "brevvännerna" ;
  bondhustru_nn_1_N = mkN "bondhustru" "bondhustrun" "bondhustrur" "bondhustrurna" ;
  blindraa_nn_1_1_N = mkN "blindrå" "blindrån" "blindrår" "blindrårna" ;
  bihustru_nn_1_N = mkN "bihustru" "bihustrun" "bihustrur" "bihustrurna" ;
  beslutskorridor_nn_1_N = mkN "beslutskorridor" "beslutskorridoren" "beslutskorridorer" "beslutskorridorerna" ;
  begineraa_nn_1_1_N = mkN "beginerå" "beginerån" "beginerår" "beginerårna" ;
  bastu_nn_1_N = mkN "bastu" "bastun" "bastur" "basturna" ;
  barnjungfru_nn_1_N = mkN "barnjungfru" "barnjungfrun" "barnjungfrur" "barnjungfrurna" ;
  barndomsvaen_nn_1_1_N = mkN "barndomsvän" "barndomsvännen" "barndomsvänner" "barndomsvännerna" ;
  bankirhustru_nn_1_N = mkN "bankirhustru" "bankirhustrun" "bankirhustrur" "bankirhustrurna" ;
  andretenor_nn_1_N = mkN "andretenor" "andretenoren" "andretenorer" "andretenorerna" ;
  andratenor_nn_1_N = mkN "andratenor" "andratenoren" "andratenorer" "andratenorerna" ;
  anafor_nn_1_N = mkN "anafor" "anaforen" "anaforer" "anaforerna" ;
  Helsingforsvaen_nn_1_1_N = mkN "Helsingforsvän" "Helsingforsvännen" "Helsingforsvänner" "Helsingforsvännerna" ;
  Afghanistantrupp_nn_1_N = mkN "Afghanistantrupp" "Afghanistantrupper" ;
  Arianeraket_nn_1_N = mkN "Arianeraket" "Arianeraketer" ;
  Beethovensonat_nn_1_N = mkN "Beethovensonat" "Beethovensonater" ;
  DNA_profil_nn_1_N = mkN "DNA-profil" "DNA-profiler" ;
  EU_korrespondent_nn_1_N = mkN "EU-korrespondent" "EU-korrespondenter" ;
  FN_tribunal_nn_1_N = mkN "FN-tribunal" "FN-tribunaler" ;
  LO_chef_nn_1_N = mkN "LO-chef" "LO-chefer" ;
  Linkoepingsbo_nn_1_1_N = mkN "Linköpingsbo" "Linköpingsbor" ;
  MAO_aktivitet_nn_1_N = mkN "MAO-aktivitet" "MAO-aktiviteter" ;
  Muhammedkarikatyr_nn_1_N = mkN "Muhammedkarikatyr" "Muhammedkarikatyrer" ;
  Nobelpriskandidat_nn_1_N = mkN "Nobelpriskandidat" "Nobelpriskandidater" ;
  PCB_halt_nn_1_N = mkN "PCB-halt" "PCB-halter" ;
  PR_kupp_nn_1_N = mkN "PR-kupp" "PR-kupper" ;
  PRkupp_nn_1_N = mkN "PRkupp" "PRkupper" ;
  Papyrusaktie_nn_1_N = mkN "Papyrusaktie" "Papyrusaktier" ;
  SAS_chef_nn_1_N = mkN "SAS-chef" "SAS-chefer" ;
  Stasiagent_nn_1_N = mkN "Stasiagent" "Stasiagenter" ;
  Stockholmsfotograf_nn_1_N = mkN "Stockholmsfotograf" "Stockholmsfotografer" ;
  Stockholmsguide_nn_1_N = mkN "Stockholmsguide" "Stockholmsguider" ;
  Stockholmshelg_nn_1_N = mkN "Stockholmshelg" "Stockholmshelger" ;
  TV_antenn_nn_1_N = mkN "TV-antenn" "TV-antenner" ;
  TV_apparat_nn_1_N = mkN "TV-apparat" "TV-apparater" ;
  TV_bild_nn_1_N = mkN "TV-bild" "TV-bilder" ;
  TV_chef_nn_1_N = mkN "TV-chef" "TV-chefer" ;
  TV_kanal_nn_1_N = mkN "TV-kanal" "TV-kanaler" ;
  TV_leverantoer_nn_1_1_N = mkN "TV-leverantör" "TV-leverantörer" ;
  TV_nyhet_nn_1_N = mkN "TV-nyhet" "TV-nyheter" ;
  TV_reparatoer_nn_1_1_N = mkN "TV-reparatör" "TV-reparatörer" ;
  TV_serie_nn_1_N = mkN "TV-serie" "TV-serier" ;
  TV_studio_nn_1_N = mkN "TV-studio" "TV-studior" ;
  Tarzanfilm_nn_1_N = mkN "Tarzanfilm" "Tarzanfilmer" ;
  abiturient_nn_1_N = mkN "abiturient" "abiturienter" ;
  abonnent_nn_1_N = mkN "abonnent" "abonnenter" ;
  abortoer_nn_1_1_N = mkN "abortör" "abortörer" ;
  absint_nn_1_N = mkN "absint" "absinter" ;
  absorptionslinje_nn_1_N = mkN "absorptionslinje" "absorptionslinjer" ;
  accessionskatalog_nn_1_N = mkN "accessionskatalog" "accessionskataloger" ;
  accesstid_nn_1_N = mkN "accesstid" "accesstider" ;
  ackompanjatoer_nn_1_1_N = mkN "ackompanjatör" "ackompanjatörer" ;
  ackuschoer_nn_1_1_N = mkN "ackuschör" "ackuschörer" ;
  ackvisitoer_nn_1_1_N = mkN "ackvisitör" "ackvisitörer" ;
  addend_nn_1_N = mkN "addend" "addender" ;
  adelsaett_nn_1_1_N = mkN "adelsätt" "adelsätter" ;
  adept_nn_1_N = mkN "adept" "adepter" ;
  adidasgympasko_nn_1_N = mkN "adidasgympasko" "adidasgympaskor" ;
  adjunkt_nn_1_N = mkN "adjunkt" "adjunkter" ;
  adjutant_nn_1_N = mkN "adjutant" "adjutanter" ;
  administratoer_nn_1_1_N = mkN "administratör" "administratörer" ;
  adonisgestalt_nn_1_N = mkN "adonisgestalt" "adonisgestalter" ;
  adoratoer_nn_1_1_N = mkN "adoratör" "adoratörer" ;
  adrenalin_nn_1_N = mkN "adrenalin" "adrenaliner" ;
  adressat_nn_1_N = mkN "adressat" "adressater" ;
  advokatfiskal_nn_1_N = mkN "advokatfiskal" "advokatfiskaler" ;
  advokatyr_nn_1_N = mkN "advokatyr" "advokatyrer" ;
  aerodrom_nn_1_N = mkN "aerodrom" "aerodromer" ;
  aeronaut_nn_1_N = mkN "aeronaut" "aeronauter" ;
  affekt_nn_1_N = mkN "affekt" "affekter" ;
  affischoer_nn_1_1_N = mkN "affischör" "affischörer" ;
  affaersbank_nn_1_1_N = mkN "affärsbank" "affärsbanker" ;
  affaerslokal_nn_1_1_N = mkN "affärslokal" "affärslokaler" ;
  affaerstid_nn_1_1_N = mkN "affärstid" "affärstider" ;
  affaersuppgoerelse_nn_1_1_N = mkN "affärsuppgörelse" "affärsuppgörelser" ;
  afrofrisyr_nn_1_N = mkN "afrofrisyr" "afrofrisyrer" ;
  aftonpsalm_nn_1_N = mkN "aftonpsalm" "aftonpsalmer" ;
  aftontoalett_nn_1_N = mkN "aftontoalett" "aftontoaletter" ;
  aftonvard_nn_1_N = mkN "aftonvard" "aftonvarder" ;
  agat_nn_1_N = mkN "agat" "agater" ;
  agave_nn_1_N = mkN "agave" "agaver" ;
  agent_nn_1_N = mkN "agent" "agenter" ;
  agnat_nn_1_N = mkN "agnat" "agnater" ;
  agraff_nn_1_N = mkN "agraff" "agraffer" ;
  agrar_nn_1_N = mkN "agrar" "agrarer" ;
  agronom_nn_1_N = mkN "agronom" "agronomer" ;
  aha_upplevelse_nn_1_N = mkN "aha-upplevelse" "aha-upplevelser" ;
  ahaupplevelse_nn_1_N = mkN "ahaupplevelse" "ahaupplevelser" ;
  akrobat_nn_1_N = mkN "akrobat" "akrobater" ;
  akronym_nn_1_N = mkN "akronym" "akronymer" ;
  aktie_nn_1_N = mkN "aktie" "aktier" ;
  aktiekupong_nn_1_N = mkN "aktiekupong" "aktiekuponger" ;
  aktieportfoelj_nn_1_1_N = mkN "aktieportfölj" "aktieportföljer" ;
  aktionsart_nn_1_N = mkN "aktionsart" "aktionsarter" ;
  aktionsradie_nn_1_N = mkN "aktionsradie" "aktionsradier" ;
  aktivum_nn_1_N = mkN "aktiv" "aktiver" ;
  aktningsbetygelse_nn_1_N = mkN "aktningsbetygelse" "aktningsbetygelser" ;
  aktuarie_nn_1_N = mkN "aktuarie" "aktuarier" ;
  aktoer_nn_1_1_N = mkN "aktör" "aktörer" ;
  akvanaut_nn_1_N = mkN "akvanaut" "akvanauter" ;
  akvarell_nn_1_N = mkN "akvarell" "akvareller" ;
  akvatint_nn_1_N = mkN "akvatint" "akvatinter" ;
  akvedukt_nn_1_N = mkN "akvedukt" "akvedukter" ;
  aladaab_nn_1_1_N = mkN "aladåb" "aladåber" ;
  alagreck_nn_1_N = mkN "alagreck" "alagrecker" ;
  albumin_nn_1_N = mkN "albumin" "albuminer" ;
  alemann_nn_1_N = mkN "alemann" "alemanner" ;
  alfametyltyrosin_nn_1_N = mkN "alfametyltyrosin" "alfametyltyrosiner" ;
  algoritm_nn_1_N = mkN "algoritm" "algoritmer" ;
  alienationsupplevelse_nn_1_N = mkN "alienationsupplevelse" "alienationsupplevelser" ;
  alkalimetall_nn_1_N = mkN "alkalimetall" "alkalimetaller" ;
  alkov_nn_1_N = mkN "alkov" "alkover" ;
  allergitablett_nn_1_N = mkN "allergitablett" "allergitabletter" ;
  allograf_nn_1_N = mkN "allograf" "allografer" ;
  allomorf_nn_1_N = mkN "allomorf" "allomorfer" ;
  allongeperuk_nn_1_N = mkN "allongeperuk" "allongeperuker" ;
  allstroemsapparat_nn_1_1_N = mkN "allströmsapparat" "allströmsapparater" ;
  aloe_nn_1_N = mkN "aloe" "aloer" ;
  alp_nn_1_N = mkN "alp" "alper" ;
  alpviol_nn_1_N = mkN "alpviol" "alpvioler" ;
  altarrund_nn_1_N = mkN "altarrund" "altarrunder" ;
  altfiol_nn_1_N = mkN "altfiol" "altfioler" ;
  altitud_nn_1_N = mkN "altitud" "altituder" ;
  alumn_nn_1_N = mkN "alumn" "alumner" ;
  alveolar_nn_1_N = mkN "alveolar" "alveolarer" ;
  amatoer_nn_1_1_N = mkN "amatör" "amatörer" ;
  amatoerbestaemmelse_nn_1_1_N = mkN "amatörbestämmelse" "amatörbestämmelser" ;
  ambassad_nn_1_N = mkN "ambassad" "ambassader" ;
  amerikabiljett_nn_1_N = mkN "amerikabiljett" "amerikabiljetter" ;
  amfetamin_nn_1_N = mkN "amfetamin" "amfetaminer" ;
  amfibie_nn_1_N = mkN "amfibie" "amfibier" ;
  amin_nn_1_N = mkN "amin" "aminer" ;
  amiral_nn_1_N = mkN "amiral" "amiraler" ;
  amiralsperson_nn_1_N = mkN "amiralsperson" "amiralspersoner" ;
  ammoniumnitrat_nn_1_N = mkN "ammoniumnitrat" "ammoniumnitrater" ;
  amperesekund_nn_1_N = mkN "amperesekund" "amperesekunder" ;
  amplitud_nn_1_N = mkN "amplitud" "amplituder" ;
  ampull_nn_1_N = mkN "ampull" "ampuller" ;
  anakolut_nn_1_N = mkN "anakolut" "anakoluter" ;
  anakoret_nn_1_N = mkN "anakoret" "anakoreter" ;
  analfabet_nn_1_N = mkN "analfabet" "analfabeter" ;
  anatom_nn_1_N = mkN "anatom" "anatomer" ;
  and_nn_1_N = mkN "and" "änder" ;
  andakt_nn_1_N = mkN "andakt" "andakter" ;
  andebesvaerjelse_nn_1_1_N = mkN "andebesvärjelse" "andebesvärjelser" ;
  andningsapparat_nn_1_N = mkN "andningsapparat" "andningsapparater" ;
  andraklassbiljett_nn_1_N = mkN "andraklassbiljett" "andraklassbiljetter" ;
  anekdot_nn_1_N = mkN "anekdot" "anekdoter" ;
  anfallsfront_nn_1_N = mkN "anfallsfront" "anfallsfronter" ;
  anfallslinje_nn_1_N = mkN "anfallslinje" "anfallslinjer" ;
  anfang_nn_1_N = mkN "anfang" "anfanger" ;
  anfart_nn_1_N = mkN "anfart" "anfarter" ;
  anfaektelse_nn_1_1_N = mkN "anfäktelse" "anfäktelser" ;
  anfoervant_nn_1_1_N = mkN "anförvant" "anförvanter" ;
  angiosperm_nn_1_N = mkN "angiosperm" "angiospermer" ;
  angivelse_nn_1_N = mkN "angivelse" "angivelser" ;
  angorakatt_nn_1_N = mkN "angorakatt" "angorakatter" ;
  anhalt_nn_1_N = mkN "anhalt" "anhalter" ;
  animatoer_nn_1_1_N = mkN "animatör" "animatörer" ;
  anisett_nn_1_N = mkN "anisett" "anisetter" ;
  ankargrund_nn_1_N = mkN "ankargrund" "ankargrunder" ;
  ankbonde_nn_1_N = mkN "ankbonde" "ankbönder" ;
  anklagelse_nn_1_N = mkN "anklagelse" "anklagelser" ;
  anklagelseakt_nn_1_N = mkN "anklagelseakt" "anklagelseakter" ;
  anklang_nn_1_N = mkN "anklang" "anklanger" ;
  annonsoer_nn_1_1_N = mkN "annonsör" "annonsörer" ;
  anod_nn_1_N = mkN "anod" "anoder" ;
  anorak_nn_1_N = mkN "anorak" "anoraker" ;
  anpassningsklinik_nn_1_N = mkN "anpassningsklinik" "anpassningskliniker" ;
  ansiktsnerv_nn_1_N = mkN "ansiktsnerv" "ansiktsnerver" ;
  anstalt_nn_1_N = mkN "anstalt" "anstalter" ;
  anstaltsvistelse_nn_1_N = mkN "anstaltsvistelse" "anstaltsvistelser" ;
  ansoekningstid_nn_1_1_N = mkN "ansökningstid" "ansökningstider" ;
  antenn_nn_1_N = mkN "antenn" "antenner" ;
  antigen_nn_1_N = mkN "antigen" "antigener" ;
  antiklinal_nn_1_N = mkN "antiklinal" "antiklinaler" ;
  antikvarie_nn_1_N = mkN "antikvarie" "antikvarier" ;
  antilop_nn_1_N = mkN "antilop" "antiloper" ;
  antipassad_nn_1_N = mkN "antipassad" "antipassader" ;
  antipod_nn_1_N = mkN "antipod" "antipoder" ;
  antitoxin_nn_1_N = mkN "antitoxin" "antitoxiner" ;
  antropofag_nn_1_N = mkN "antropofag" "antropofager" ;
  antroposof_nn_1_N = mkN "antroposof" "antroposofer" ;
  anvaendbarhetsaspekt_nn_1_1_N = mkN "användbarhetsaspekt" "användbarhetsaspekter" ;
  apache_nn_1_N = mkN "apache" "apacher" ;
  apekatt_nn_1_N = mkN "apekatt" "apekatter" ;
  apelsinmousse_nn_1_N = mkN "apelsinmousse" "apelsinmousser" ;
  apelsinsaft_nn_1_N = mkN "apelsinsaft" "apelsinsafter" ;
  aperitif_nn_1_N = mkN "aperitif" "aperitifer" ;
  apetidin_nn_1_N = mkN "apetidin" "apetidiner" ;
  apologet_nn_1_N = mkN "apologet" "apologeter" ;
  applaad_nn_1_1_N = mkN "applåd" "applåder" ;
  apsort_nn_1_N = mkN "apsort" "apsorter" ;
  arab_nn_1_N = mkN "arab" "araber" ;
  arbetarbostad_nn_1_N = mkN "arbetarbostad" "arbetarbostäder" ;
  arbetarkommun_nn_1_N = mkN "arbetarkommun" "arbetarkommuner" ;
  arbetarroerelse_nn_1_1_N = mkN "arbetarrörelse" "arbetarrörelser" ;
  arbetsinstaellelse_nn_1_1_N = mkN "arbetsinställelse" "arbetsinställelser" ;
  arbetskamrat_nn_1_N = mkN "arbetskamrat" "arbetskamrater" ;
  arbetslokal_nn_1_N = mkN "arbetslokal" "arbetslokaler" ;
  arbetsloeshetsperiod_nn_1_1_N = mkN "arbetslöshetsperiod" "arbetslöshetsperioder" ;
  arbetsmaskin_nn_1_N = mkN "arbetsmaskin" "arbetsmaskiner" ;
  arbetsmetod_nn_1_N = mkN "arbetsmetod" "arbetsmetoder" ;
  arbetsmoral_nn_1_N = mkN "arbetsmoral" "arbetsmoraler" ;
  arbetsnedlaeggelse_nn_1_1_N = mkN "arbetsnedläggelse" "arbetsnedläggelser" ;
  arbetsterapeut_nn_1_N = mkN "arbetsterapeut" "arbetsterapeuter" ;
  areal_nn_1_N = mkN "areal" "arealer" ;
  areopag_nn_1_N = mkN "areopag" "areopager" ;
  aristokrat_nn_1_N = mkN "aristokrat" "aristokrater" ;
  arkad_nn_1_N = mkN "arkad" "arkader" ;
  arketyp_nn_1_N = mkN "arketyp" "arketyper" ;
  arkivarie_nn_1_N = mkN "arkivarie" "arkivarier" ;
  armbaagsnerv_nn_1_1_N = mkN "armbågsnerv" "armbågsnerver" ;
  armpolyp_nn_1_N = mkN "armpolyp" "armpolyper" ;
  armroerelse_nn_1_1_N = mkN "armrörelse" "armrörelser" ;
  arm_egeneral_nn_1_1_N = mkN "armégeneral" "armégeneraler" ;
  arom_nn_1_N = mkN "arom" "aromer" ;
  arrestlokal_nn_1_N = mkN "arrestlokal" "arrestlokaler" ;
  arsenal_nn_1_N = mkN "arsenal" "arsenaler" ;
  art_nn_1_N = mkN "art" "arter" ;
  artefakt_nn_1_N = mkN "artefakt" "artefakter" ;
  artfraende_nn_1_1_N = mkN "artfrände" "artfränder" ;
  artighetsbetygelse_nn_1_N = mkN "artighetsbetygelse" "artighetsbetygelser" ;
  artikelserie_nn_1_N = mkN "artikelserie" "artikelserier" ;
  artillerigranat_nn_1_N = mkN "artillerigranat" "artillerigranater" ;
  arvfiende_nn_1_N = mkN "arvfiende" "arvfiender" ;
  arvfoeljd_nn_1_1_N = mkN "arvföljd" "arvföljder" ;
  arvsfoeljd_nn_1_1_N = mkN "arvsföljd" "arvsföljder" ;
  arvslott_nn_1_N = mkN "arvslott" "arvslotter" ;
  arvsynd_nn_1_N = mkN "arvsynd" "arvsynder" ;
  arvtant_nn_1_N = mkN "arvtant" "arvtanter" ;
  asfalt_nn_1_N = mkN "asfalt" "asfalter" ;
  asfaltlack_nn_1_N = mkN "asfaltlack" "asfaltlacker" ;
  asfaltmoped_nn_1_N = mkN "asfaltmoped" "asfaltmopeder" ;
  asiat_nn_1_N = mkN "asiat" "asiater" ;
  asimut_nn_1_N = mkN "asimut" "asimuter" ;
  asket_nn_1_N = mkN "asket" "asketer" ;
  aspekt_nn_1_N = mkN "aspekt" "aspekter" ;
  aspirin_nn_1_N = mkN "aspirin" "aspiriner" ;
  assegaj_nn_1_N = mkN "assegaj" "assegajer" ;
  assiett_nn_1_N = mkN "assiett" "assietter" ;
  assistent_nn_1_N = mkN "assistent" "assistenter" ;
  assuradoer_nn_1_1_N = mkN "assuradör" "assuradörer" ;
  astrakan_nn_2_N = mkN "astrakan" "astrakaner" ;
  asymptot_nn_1_N = mkN "asymptot" "asymptoter" ;
  atenienn_nn_1_N = mkN "atenienn" "atenienner" ;
  atlet_nn_1_N = mkN "atlet" "atleter" ;
  atmosfaer_nn_1_1_N = mkN "atmosfär" "atmosfärer" ;
  atoll_nn_1_N = mkN "atoll" "atoller" ;
  atommodell_nn_1_N = mkN "atommodell" "atommodeller" ;
  attack_nn_1_N = mkN "attack" "attacker" ;
  attiralj_nn_1_N = mkN "attiralj" "attiraljer" ;
  attrapp_nn_1_N = mkN "attrapp" "attrapper" ;
  aubergine_nn_1_N = mkN "aubergine" "auberginer" ;
  augustinatt_nn_1_N = mkN "augustinatt" "augustinätter" ;
  auteur_nn_1_N = mkN "auteur" "auteurer" ;
  autodidakt_nn_1_N = mkN "autodidakt" "autodidakter" ;
  autodrom_nn_1_N = mkN "autodrom" "autodromer" ;
  autograf_nn_1_N = mkN "autograf" "autografer" ;
  autoklav_nn_1_N = mkN "autoklav" "autoklaver" ;
  autokrat_nn_1_N = mkN "autokrat" "autokrater" ;
  avantloge_nn_1_N = mkN "avantloge" "avantloger" ;
  avantscen_nn_1_N = mkN "avantscen" "avantscener" ;
  avart_nn_1_N = mkN "avart" "avarter" ;
  avbitartaang_nn_1_1_N = mkN "avbitartång" "avbitartänger" ;
  avec_nn_1_N = mkN "avec" "avecer" ;
  avfart_nn_1_N = mkN "avfart" "avfarter" ;
  avfyrningskod_nn_1_N = mkN "avfyrningskod" "avfyrningskoder" ;
  avgift_nn_1_N = mkN "avgift" "avgifter" ;
  avgiftningsklinik_nn_1_N = mkN "avgiftningsklinik" "avgiftningskliniker" ;
  avgrund_nn_1_N = mkN "avgrund" "avgrunder" ;
  avgaeld_nn_1_1_N = mkN "avgäld" "avgälder" ;
  aviatoer_nn_1_1_N = mkN "aviatör" "aviatörer" ;
  aviseringsperiod_nn_1_N = mkN "aviseringsperiod" "aviseringsperioder" ;
  avkoerningsramp_nn_1_1_N = mkN "avkörningsramp" "avkörningsramper" ;
  avledningsaendelse_nn_1_1_N = mkN "avledningsändelse" "avledningsändelser" ;
  avmaskningskur_nn_1_N = mkN "avmaskningskur" "avmaskningskurer" ;
  avocado_nn_1_N = mkN "avocado" "avocador" ;
  avokado_nn_1_N = mkN "avokado" "avokador" ;
  avsikt_nn_1_N = mkN "avsikt" "avsikter" ;
  avspaenningspedagog_nn_1_1_N = mkN "avspänningspedagog" "avspänningspedagoger" ;
  avstaandskraft_nn_1_1_N = mkN "avståndskraft" "avståndskrafter" ;
  avsaegelse_nn_1_1_N = mkN "avsägelse" "avsägelser" ;
  avsaettningsbassaeng_nn_1_1_N = mkN "avsättningsbassäng" "avsättningsbassänger" ;
  avtalsperiod_nn_1_N = mkN "avtalsperiod" "avtalsperioder" ;
  avtalsroerelse_nn_1_1_N = mkN "avtalsrörelse" "avtalsrörelser" ;
  avtraedelse_nn_1_1_N = mkN "avträdelse" "avträdelser" ;
  avvikelse_nn_1_N = mkN "avvikelse" "avvikelser" ;
  aztek_nn_1_N = mkN "aztek" "azteker" ;
  babordsvakt_nn_1_N = mkN "babordsvakt" "babordsvakter" ;
  backanal_nn_1_N = mkN "backanal" "backanaler" ;
  backvial_nn_1_N = mkN "backvial" "backvialer" ;
  badbassaeng_nn_1_1_N = mkN "badbassäng" "badbassänger" ;
  badhytt_nn_1_N = mkN "badhytt" "badhytter" ;
  badkarseffekt_nn_1_N = mkN "badkarseffekt" "badkarseffekter" ;
  badsko_nn_1_N = mkN "badsko" "badskor" ;
  badstrand_nn_1_N = mkN "badstrand" "badstränder" ;
  bagatell_nn_1_N = mkN "bagatell" "bagateller" ;
  baguette_nn_1_N = mkN "baguette" "baguetter" ;
  bahytt_nn_1_N = mkN "bahytt" "bahytter" ;
  baisse_nn_1_N = mkN "baisse" "baisser" ;
  bajadaer_nn_1_1_N = mkN "bajadär" "bajadärer" ;
  bajonett_nn_1_N = mkN "bajonett" "bajonetter" ;
  bakelse_nn_1_N = mkN "bakelse" "bakelser" ;
  bakgrund_nn_1_N = mkN "bakgrund" "bakgrunder" ;
  bakjour_nn_1_N = mkN "bakjour" "bakjourer" ;
  bakslagsventil_nn_1_N = mkN "bakslagsventil" "bakslagsventiler" ;
  bakterie_nn_1_N = mkN "bakterie" "bakterier" ;
  bakteriofag_nn_1_N = mkN "bakteriofag" "bakteriofager" ;
  bakvikt_nn_1_N = mkN "bakvikt" "bakvikter" ;
  balansakt_nn_1_N = mkN "balansakt" "balansakter" ;
  balanserstaang_nn_1_1_N = mkN "balanserstång" "balanserstänger" ;
  balett_nn_1_N = mkN "balett" "baletter" ;
  balkong_nn_1_N = mkN "balkong" "balkonger" ;
  balksko_nn_1_N = mkN "balksko" "balkskor" ;
  ballad_nn_1_N = mkN "ballad" "ballader" ;
  ballong_nn_1_N = mkN "ballong" "ballonger" ;
  balsam_nn_1_N = mkN "balsam" "balsamer" ;
  balt_nn_1_N = mkN "balt" "balter" ;
  bananrepublik_nn_1_N = mkN "bananrepublik" "bananrepubliker" ;
  banderol_nn_1_N = mkN "banderol" "banderoler" ;
  banderoll_nn_1_N = mkN "banderoll" "banderoller" ;
  banjo_nn_1_N = mkN "banjo" "banjor" ;
  bankett_nn_1_N = mkN "bankett" "banketter" ;
  bankomat_nn_1_N = mkN "bankomat" "bankomater" ;
  bankrutt_nn_1_N = mkN "bankrutt" "bankrutter" ;
  bankruttoer_nn_1_1_N = mkN "bankruttör" "bankruttörer" ;
  bankroerelse_nn_1_1_N = mkN "bankrörelse" "bankrörelser" ;
  banroerelse_nn_1_1_N = mkN "banrörelse" "banrörelser" ;
  bantningskur_nn_1_N = mkN "bantningskur" "bantningskurer" ;
  bar_nn_1_N = mkN "bar" "barer" ;
  barack_nn_1_N = mkN "barack" "baracker" ;
  barbar_nn_1_N = mkN "barbar" "barbarer" ;
  bard_nn_1_N = mkN "bard" "barder" ;
  bardun_nn_1_N = mkN "bardun" "barduner" ;
  barett_nn_1_N = mkN "barett" "baretter" ;
  bark_nn_1_N = mkN "bark" "barker" ;
  barkaroll_nn_1_N = mkN "barkaroll" "barkaroller" ;
  barktaekt_nn_1_1_N = mkN "barktäkt" "barktäkter" ;
  barmark_nn_1_N = mkN "barmark" "barmarker" ;
  barnavaardscentral_nn_1_1_N = mkN "barnavårdscentral" "barnavårdscentraler" ;
  barndomsstad_nn_1_N = mkN "barndomsstad" "barndomsstäder" ;
  barndomsupplevelse_nn_1_N = mkN "barndomsupplevelse" "barndomsupplevelser" ;
  barnfotomodell_nn_1_N = mkN "barnfotomodell" "barnfotomodeller" ;
  barnklinik_nn_1_N = mkN "barnklinik" "barnkliniker" ;
  barnsboerd_nn_1_1_N = mkN "barnsbörd" "barnsbörder" ;
  barnsko_nn_1_N = mkN "barnsko" "barnskor" ;
  barnskoetarlinje_nn_1_1_N = mkN "barnskötarlinje" "barnskötarlinjer" ;
  barntoalett_nn_1_N = mkN "barntoalett" "barntoaletter" ;
  barnvakt_nn_1_N = mkN "barnvakt" "barnvakter" ;
  barograf_nn_1_N = mkN "barograf" "barografer" ;
  barr_nn_2_N = mkN "barr" "barrer" ;
  barrikad_nn_1_N = mkN "barrikad" "barrikader" ;
  barriaer_nn_1_1_N = mkN "barriär" "barriärer" ;
  barysfaer_nn_1_1_N = mkN "barysfär" "barysfärer" ;
  basar_nn_1_N = mkN "basar" "basarer" ;
  basfiol_nn_1_N = mkN "basfiol" "basfioler" ;
  basgitarr_nn_1_N = mkN "basgitarr" "basgitarrer" ;
  baslinje_nn_1_N = mkN "baslinje" "baslinjer" ;
  basrelief_nn_1_N = mkN "basrelief" "basreliefer" ;
  bastard_nn_1_N = mkN "bastard" "bastarder" ;
  bastonad_nn_1_N = mkN "bastonad" "bastonader" ;
  basun_nn_1_N = mkN "basun" "basuner" ;
  batalj_nn_1_N = mkN "batalj" "bataljer" ;
  bataljon_nn_1_N = mkN "bataljon" "bataljoner" ;
  batat_nn_1_N = mkN "batat" "batater" ;
  batong_nn_1_N = mkN "batong" "batonger" ;
  batterisekatoer_nn_1_1_N = mkN "batterisekatör" "batterisekatörer" ;
  batysfaer_nn_1_1_N = mkN "batysfär" "batysfärer" ;
  bearnaise_nn_1_N = mkN "bearnaise" "bearnaiser" ;
  bebyggelse_nn_1_N = mkN "bebyggelse" "bebyggelser" ;
  bebaadelse_nn_1_1_N = mkN "bebådelse" "bebådelser" ;
  bedrift_nn_1_N = mkN "bedrift" "bedrifter" ;
  bedroevelse_nn_1_1_N = mkN "bedrövelse" "bedrövelser" ;
  beflaeckelse_nn_1_1_N = mkN "befläckelse" "befläckelser" ;
  befolkningsstatistik_nn_1_N = mkN "befolkningsstatistik" "befolkningsstatistiker" ;
  befordringsgrund_nn_1_N = mkN "befordringsgrund" "befordringsgrunder" ;
  befrielse_nn_1_N = mkN "befrielse" "befrielser" ;
  befrielseakt_nn_1_N = mkN "befrielseakt" "befrielseakter" ;
  befrielsefront_nn_1_N = mkN "befrielsefront" "befrielsefronter" ;
  befrielsekamp_nn_1_N = mkN "befrielsekamp" "befrielsekamper" ;
  befrielseroerelse_nn_1_1_N = mkN "befrielserörelse" "befrielserörelser" ;
  befaelselev_nn_1_1_N = mkN "befälselev" "befälselever" ;
  befaelstalang_nn_1_1_N = mkN "befälstalang" "befälstalanger" ;
  befaestningslinje_nn_1_1_N = mkN "befästningslinje" "befästningslinjer" ;
  begravningsakt_nn_1_N = mkN "begravningsakt" "begravningsakter" ;
  begravningsentreprenoer_nn_1_1_N = mkN "begravningsentreprenör" "begravningsentreprenörer" ;
  begravningsmin_nn_1_N = mkN "begravningsmin" "begravningsminer" ;
  begraensningslinje_nn_1_1_N = mkN "begränsningslinje" "begränsningslinjer" ;
  begynnelse_nn_1_N = mkN "begynnelse" "begynnelser" ;
  begynnelsebokstav_nn_1_N = mkN "begynnelsebokstav" "begynnelsebokstäver" ;
  begaerelse_nn_1_1_N = mkN "begärelse" "begärelser" ;
  begaavningsreserv_nn_1_1_N = mkN "begåvningsreserv" "begåvningsreserver" ;
  behandlingsmetod_nn_1_N = mkN "behandlingsmetod" "behandlingsmetoder" ;
  behovstillfredsstaellelse_nn_1_1_N = mkN "behovstillfredsställelse" "behovstillfredsställelser" ;
  bej_nn_1_N = mkN "bej" "bejer" ;
  bekantskap_nn_1_N = mkN "bekantskap" "bekantskaper" ;
  bekraeftelse_nn_1_1_N = mkN "bekräftelse" "bekräftelser" ;
  bekaennelse_nn_1_1_N = mkN "bekännelse" "bekännelser" ;
  beloeningsmedalj_nn_1_1_N = mkN "belöningsmedalj" "belöningsmedaljer" ;
  bemaerkelse_nn_1_1_N = mkN "bemärkelse" "bemärkelser" ;
  bensinautomat_nn_1_N = mkN "bensinautomat" "bensinautomater" ;
  berceuse_nn_1_N = mkN "berceuse" "berceuser" ;
  beredelse_nn_1_N = mkN "beredelse" "beredelser" ;
  beredningsnaemnd_nn_1_1_N = mkN "beredningsnämnd" "beredningsnämnder" ;
  beredskap_nn_1_N = mkN "beredskap" "beredskaper" ;
  beredskapsstat_nn_1_N = mkN "beredskapsstat" "beredskapsstater" ;
  bergamott_nn_1_N = mkN "bergamott" "bergamotter" ;
  bergand_nn_1_N = mkN "bergand" "bergänder" ;
  bergart_nn_1_N = mkN "bergart" "bergarter" ;
  bergnymf_nn_1_N = mkN "bergnymf" "bergnymfer" ;
  bergslag_nn_1_N = mkN "bergslag" "bergslager" ;
  bergstrakt_nn_1_N = mkN "bergstrakt" "bergstrakter" ;
  beryll_nn_1_N = mkN "beryll" "beryller" ;
  beraekningsmetod_nn_1_1_N = mkN "beräkningsmetod" "beräkningsmetoder" ;
  beraettartalang_nn_1_1_N = mkN "berättartalang" "berättartalanger" ;
  beraettarteknik_nn_1_1_N = mkN "berättarteknik" "berättartekniker" ;
  beraettelse_nn_1_1_N = mkN "berättelse" "berättelser" ;
  beskattningsgrund_nn_1_N = mkN "beskattningsgrund" "beskattningsgrunder" ;
  beskaermelse_nn_1_1_N = mkN "beskärmelse" "beskärmelser" ;
  beslutsrymd_nn_1_N = mkN "beslutsrymd" "beslutsrymder" ;
  besmittelse_nn_1_N = mkN "besmittelse" "besmittelser" ;
  bespottelse_nn_1_N = mkN "bespottelse" "bespottelser" ;
  bestaemmelse_nn_1_1_N = mkN "bestämmelse" "bestämmelser" ;
  besvikelse_nn_1_N = mkN "besvikelse" "besvikelser" ;
  besvaerjelse_nn_1_1_N = mkN "besvärjelse" "besvärjelser" ;
  besvaersgrund_nn_1_1_N = mkN "besvärsgrund" "besvärsgrunder" ;
  besoeksfaatoelj_nn_1_1_N = mkN "besöksfåtölj" "besöksfåtöljer" ;
  betalningsinstaellelse_nn_1_1_N = mkN "betalningsinställelse" "betalningsinställelser" ;
  betalningstid_nn_1_N = mkN "betalningstid" "betalningstider" ;
  beteendeterapeut_nn_1_N = mkN "beteendeterapeut" "beteendeterapeuter" ;
  betelpalm_nn_1_N = mkN "betelpalm" "betelpalmer" ;
  betingelse_nn_1_N = mkN "betingelse" "betingelser" ;
  betjaeningsavgift_nn_1_1_N = mkN "betjäningsavgift" "betjäningsavgifter" ;
  betjaent_nn_1_1_N = mkN "betjänt" "betjänter" ;
  betraktelse_nn_1_N = mkN "betraktelse" "betraktelser" ;
  betydelse_nn_1_N = mkN "betydelse" "betydelser" ;
  betygelse_nn_1_N = mkN "betygelse" "betygelser" ;
  betygskatalog_nn_1_N = mkN "betygskatalog" "betygskataloger" ;
  bevekelse_nn_1_N = mkN "bevekelse" "bevekelser" ;
  bevekelsegrund_nn_1_N = mkN "bevekelsegrund" "bevekelsegrunder" ;
  bevillningsavgift_nn_1_N = mkN "bevillningsavgift" "bevillningsavgifter" ;
  beviskraft_nn_1_N = mkN "beviskraft" "beviskrafter" ;
  biaccent_nn_1_N = mkN "biaccent" "biaccenter" ;
  biavsikt_nn_1_N = mkN "biavsikt" "biavsikter" ;
  bibeltext_nn_1_N = mkN "bibeltext" "bibeltexter" ;
  bibetydelse_nn_1_N = mkN "bibetydelse" "bibetydelser" ;
  bibliofil_nn_1_N = mkN "bibliofil" "bibliofiler" ;
  bibliograf_nn_1_N = mkN "bibliograf" "bibliografer" ;
  bibliotekarie_nn_1_N = mkN "bibliotekarie" "bibliotekarier" ;
  biblioteksbrand_nn_1_N = mkN "biblioteksbrand" "biblioteksbränder" ;
  bibliotekskatalog_nn_1_N = mkN "bibliotekskatalog" "bibliotekskataloger" ;
  bieffekt_nn_1_N = mkN "bieffekt" "bieffekter" ;
  biennal_nn_1_N = mkN "biennal" "biennaler" ;
  bifenyl_nn_1_N = mkN "bifenyl" "bifenyler" ;
  biffko_nn_1_N = mkN "biffko" "biffkor" ;
  biflod_nn_1_N = mkN "biflod" "bifloder" ;
  bikt_nn_1_N = mkN "bikt" "bikter" ;
  bikvadrat_nn_1_N = mkN "bikvadrat" "bikvadrater" ;
  bilbrand_nn_1_N = mkN "bilbrand" "bilbränder" ;
  bildberaettelse_nn_1_1_N = mkN "bildberättelse" "bildberättelser" ;
  bildningsaristokrat_nn_1_N = mkN "bildningsaristokrat" "bildningsaristokrater" ;
  biljettautomat_nn_1_N = mkN "biljettautomat" "biljettautomater" ;
  biljettmaskin_nn_1_N = mkN "biljettmaskin" "biljettmaskiner" ;
  biljettaang_nn_1_1_N = mkN "biljettång" "biljettänger" ;
  bilmaskin_nn_1_N = mkN "bilmaskin" "bilmaskiner" ;
  bilpark_nn_1_N = mkN "bilpark" "bilparker" ;
  bilradio_nn_1_N = mkN "bilradio" "bilradior" ;
  bilskrotningspremie_nn_1_N = mkN "bilskrotningspremie" "bilskrotningspremier" ;
  bilverkstad_nn_1_N = mkN "bilverkstad" "bilverkstäder" ;
  bimetall_nn_1_N = mkN "bimetall" "bimetaller" ;
  bindevokal_nn_1_N = mkN "bindevokal" "bindevokaler" ;
  biobiljett_nn_1_N = mkN "biobiljett" "biobiljetter" ;
  biograf_nn_1_N = mkN "biograf" "biografer" ;
  biosfaer_nn_1_1_N = mkN "biosfär" "biosfärer" ;
  bioteknik_nn_1_N = mkN "bioteknik" "biotekniker" ;
  biotop_nn_1_N = mkN "biotop" "biotoper" ;
  biotyp_nn_1_N = mkN "biotyp" "biotyper" ;
  biperson_nn_1_N = mkN "biperson" "bipersoner" ;
  biplanet_nn_1_N = mkN "biplanet" "biplaneter" ;
  birem_nn_1_N = mkN "birem" "biremer" ;
  bisatsordfoeljd_nn_1_1_N = mkN "bisatsordföljd" "bisatsordföljder" ;
  bismak_nn_1_N = mkN "bismak" "bismaker" ;
  bivack_nn_1_N = mkN "bivack" "bivacker" ;
  bjudcigarr_nn_1_N = mkN "bjudcigarr" "bjudcigarrer" ;
  bjaellko_nn_1_1_N = mkN "bjällko" "bjällkor" ;
  blackout_nn_1_N = mkN "blackout" "blackouter" ;
  blam_nn_1_N = mkN "blam" "blamer" ;
  blamage_nn_1_N = mkN "blamage" "blamager" ;
  blankett_nn_1_N = mkN "blankett" "blanketter" ;
  blindpatron_nn_1_N = mkN "blindpatron" "blindpatroner" ;
  blixtinkallelse_nn_1_N = mkN "blixtinkallelse" "blixtinkallelser" ;
  blixtpatron_nn_1_N = mkN "blixtpatron" "blixtpatroner" ;
  blockfloejt_nn_1_1_N = mkN "blockflöjt" "blockflöjter" ;
  blocksignal_nn_1_N = mkN "blocksignal" "blocksignaler" ;
  blodbank_nn_1_N = mkN "blodbank" "blodbanker" ;
  blodcell_nn_1_N = mkN "blodcell" "blodceller" ;
  blodgivarcentral_nn_1_N = mkN "blodgivarcentral" "blodgivarcentraler" ;
  blodrand_nn_1_N = mkN "blodrand" "blodränder" ;
  blodsutgjutelse_nn_1_N = mkN "blodsutgjutelse" "blodsutgjutelser" ;
  blodtyp_nn_1_N = mkN "blodtyp" "blodtyper" ;
  blombukett_nn_1_N = mkN "blombukett" "blombuketter" ;
  blond_nn_1_N = mkN "blond" "blonder" ;
  blaesand_nn_1_1_N = mkN "bläsand" "bläsänder" ;
  blaabaerssaft_nn_1_1_N = mkN "blåbärssaft" "blåbärssafter" ;
  blaabaerssylt_nn_1_1_N = mkN "blåbärssylt" "blåbärssylter" ;
  blaalusern_nn_1_1_N = mkN "blålusern" "blåluserner" ;
  bodbetjaent_nn_1_1_N = mkN "bodbetjänt" "bodbetjänter" ;
  boett_nn_1_N = mkN "boett" "boetter" ;
  bohem_nn_1_N = mkN "bohem" "bohemer" ;
  boj_nn_2_N = mkN "boj" "bojer" ;
  bojar_nn_1_N = mkN "bojar" "bojarer" ;
  bojkott_nn_1_N = mkN "bojkott" "bojkotter" ;
  bokfilm_nn_1_N = mkN "bokfilm" "bokfilmer" ;
  bokflod_nn_1_N = mkN "bokflod" "bokfloder" ;
  bokstav_nn_1_N = mkN "bokstav" "bokstäver" ;
  bokstavsfoeljd_nn_1_1_N = mkN "bokstavsföljd" "bokstavsföljder" ;
  bolagsstyrelse_nn_1_N = mkN "bolagsstyrelse" "bolagsstyrelser" ;
  bolsjevik_nn_1_N = mkN "bolsjevik" "bolsjeviker" ;
  bombasm_nn_1_N = mkN "bombasm" "bombasmer" ;
  bomullsflanell_nn_1_N = mkN "bomullsflanell" "bomullsflaneller" ;
  bomullsplantage_nn_1_N = mkN "bomullsplantage" "bomullsplantager" ;
  bomullsservett_nn_1_N = mkN "bomullsservett" "bomullsservetter" ;
  bonbonjaer_nn_1_1_N = mkN "bonbonjär" "bonbonjärer" ;
  bonde_nn_1_N = mkN "bonde" "bönder" ;
  bondefred_nn_1_N = mkN "bondefred" "bondefreder" ;
  bondkatt_nn_1_N = mkN "bondkatt" "bondkatter" ;
  bonjour_nn_1_N = mkN "bonjour" "bonjourer" ;
  bonnett_nn_1_N = mkN "bonnett" "bonnetter" ;
  bordell_nn_1_N = mkN "bordell" "bordeller" ;
  borgensfoerbindelse_nn_1_1_N = mkN "borgensförbindelse" "borgensförbindelser" ;
  borgfred_nn_1_N = mkN "borgfred" "borgfreder" ;
  borrmaskin_nn_1_N = mkN "borrmaskin" "borrmaskiner" ;
  bostad_nn_1_N = mkN "bostad" "bostäder" ;
  bostadsstyrelse_nn_1_N = mkN "bostadsstyrelse" "bostadsstyrelser" ;
  botgoerelse_nn_1_1_N = mkN "botgörelse" "botgörelser" ;
  bottenventil_nn_1_N = mkN "bottenventil" "bottenventiler" ;
  boulevard_nn_1_N = mkN "boulevard" "boulevarder" ;
  bouquet_nn_1_N = mkN "bouquet" "bouqueter" ;
  bourgogne_nn_1_N = mkN "bourgogne" "bourgogner" ;
  boutique_nn_1_N = mkN "boutique" "boutiquer" ;
  boxningslokal_nn_1_N = mkN "boxningslokal" "boxningslokaler" ;
  boyscout_nn_1_N = mkN "boyscout" "boyscouter" ;
  bragd_nn_1_N = mkN "bragd" "bragder" ;
  brakteat_nn_1_N = mkN "brakteat" "brakteater" ;
  bramstaang_nn_1_1_N = mkN "bramstång" "bramstänger" ;
  brand_nn_1_N = mkN "brand" "bränder" ;
  brandkapten_nn_1_N = mkN "brandkapten" "brandkaptener" ;
  brandslaeckarattrapp_nn_1_1_N = mkN "brandsläckarattrapp" "brandsläckarattrapper" ;
  brandsoldat_nn_1_N = mkN "brandsoldat" "brandsoldater" ;
  brandsyn_nn_1_N = mkN "brandsyn" "brandsyner" ;
  brant_nn_1_N = mkN "brant" "branter" ;
  bravad_nn_1_N = mkN "bravad" "bravader" ;
  bredd_nn_1_N = mkN "bredd" "bredder" ;
  brevfoersaendelse_nn_1_1_N = mkN "brevförsändelse" "brevförsändelser" ;
  bridong_nn_1_N = mkN "bridong" "bridonger" ;
  brigad_nn_1_N = mkN "brigad" "brigader" ;
  brigadgeneral_nn_1_N = mkN "brigadgeneral" "brigadgeneraler" ;
  brikett_nn_1_N = mkN "brikett" "briketter" ;
  brisad_nn_1_N = mkN "brisad" "brisader" ;
  brisansgranat_nn_1_N = mkN "brisansgranat" "brisansgranater" ;
  britt_nn_1_N = mkN "britt" "britter" ;
  brokad_nn_1_N = mkN "brokad" "brokader" ;
  brokanal_nn_1_N = mkN "brokanal" "brokanaler" ;
  bromsraket_nn_1_N = mkN "bromsraket" "bromsraketer" ;
  bromssko_nn_1_N = mkN "bromssko" "bromsskor" ;
  bronsmedalj_nn_1_N = mkN "bronsmedalj" "bronsmedaljer" ;
  brorslott_nn_1_N = mkN "brorslott" "brorslotter" ;
  brorson_nn_1_N = mkN "brorson" "brorsöner" ;
  brudand_nn_1_N = mkN "brudand" "brudänder" ;
  brudbukett_nn_1_N = mkN "brudbukett" "brudbuketter" ;
  brugd_nn_1_N = mkN "brugd" "brugder" ;
  bruksdisponent_nn_1_N = mkN "bruksdisponent" "bruksdisponenter" ;
  brukspatron_nn_1_N = mkN "brukspatron" "brukspatroner" ;
  bruksroerelse_nn_1_1_N = mkN "bruksrörelse" "bruksrörelser" ;
  brunand_nn_1_N = mkN "brunand" "brunänder" ;
  brunnskur_nn_1_N = mkN "brunnskur" "brunnskurer" ;
  brustablett_nn_1_N = mkN "brustablett" "brustabletter" ;
  bruttonationalprodukt_nn_1_N = mkN "bruttonationalprodukt" "bruttonationalprodukter" ;
  brygd_nn_1_N = mkN "brygd" "brygder" ;
  brytningsexponent_nn_1_N = mkN "brytningsexponent" "brytningsexponenter" ;
  brytningspunkt_nn_1_N = mkN "brytningspunkt" "brytningspunkter" ;
  braennmanet_nn_1_1_N = mkN "brännmanet" "brännmaneter" ;
  braennpunkt_nn_1_1_N = mkN "brännpunkt" "brännpunkter" ;
  braennvidd_nn_1_1_N = mkN "brännvidd" "brännvidder" ;
  braenslecell_nn_1_1_N = mkN "bränslecell" "bränsleceller" ;
  braenslekanal_nn_1_1_N = mkN "bränslekanal" "bränslekanaler" ;
  broedfrukt_nn_1_1_N = mkN "brödfrukt" "brödfrukter" ;
  broedsbrytelse_nn_1_1_N = mkN "brödsbrytelse" "brödsbrytelser" ;
  broellopsnatt_nn_1_1_N = mkN "bröllopsnatt" "bröllopsnätter" ;
  broellopssed_nn_1_1_N = mkN "bröllopssed" "bröllopsseder" ;
  broellopsvideo_nn_1_1_N = mkN "bröllopsvideo" "bröllopsvideor" ;
  broestboeld_nn_1_1_N = mkN "bröstböld" "bröstbölder" ;
  broestkaramell_nn_1_1_N = mkN "bröstkaramell" "bröstkarameller" ;
  broestvidd_nn_1_1_N = mkN "bröstvidd" "bröstvidder" ;
  bubbelpool_nn_1_N = mkN "bubbelpool" "bubbelpooler" ;
  bukett_nn_1_N = mkN "bukett" "buketter" ;
  bulb_nn_1_N = mkN "bulb" "bulber" ;
  bulevard_nn_1_N = mkN "bulevard" "bulevarder" ;
  bulgar_nn_1_N = mkN "bulgar" "bulgarer" ;
  buljong_nn_1_N = mkN "buljong" "buljonger" ;
  bumerang_nn_1_N = mkN "bumerang" "bumeranger" ;
  bundsfoervant_nn_1_1_N = mkN "bundsförvant" "bundsförvanter" ;
  burgarbar_nn_1_N = mkN "burgarbar" "burgarbarer" ;
  burgerbar_nn_1_N = mkN "burgerbar" "burgerbarer" ;
  busfason_nn_1_N = mkN "busfason" "busfasoner" ;
  bussarong_nn_1_N = mkN "bussarong" "bussaronger" ;
  bussfoerbindelse_nn_1_1_N = mkN "bussförbindelse" "bussförbindelser" ;
  busslinje_nn_1_N = mkN "busslinje" "busslinjer" ;
  butan_nn_1_N = mkN "butan" "butaner" ;
  butelj_nn_1_N = mkN "butelj" "buteljer" ;
  butik_nn_1_N = mkN "butik" "butiker" ;
  butyl_nn_1_N = mkN "butyl" "butyler" ;
  byggnadsstyrelse_nn_1_N = mkN "byggnadsstyrelse" "byggnadsstyrelser" ;
  byrett_nn_1_N = mkN "byrett" "byretter" ;
  byraaassistent_nn_1_1_N = mkN "byråassistent" "byråassistenter" ;
  byraakrat_nn_1_1_N = mkN "byråkrat" "byråkrater" ;
  baeckforell_nn_1_1_N = mkN "bäckforell" "bäckforeller" ;
  baegarkorall_nn_1_1_N = mkN "bägarkorall" "bägarkoraller" ;
  baegarmanet_nn_1_1_N = mkN "bägarmanet" "bägarmaneter" ;
  baenkkamrat_nn_1_1_N = mkN "bänkkamrat" "bänkkamrater" ;
  baenkslipmaskin_nn_1_1_N = mkN "bänkslipmaskin" "bänkslipmaskiner" ;
  baerm_nn_1_1_N = mkN "bärm" "bärmer" ;
  baerraket_nn_1_1_N = mkN "bärraket" "bärraketer" ;
  baervidd_nn_1_1_N = mkN "bärvidd" "bärvidder" ;
  baagsekund_nn_1_1_N = mkN "bågsekund" "bågsekunder" ;
  baard_nn_1_1_N = mkN "bård" "bårder" ;
  b_earnaise_nn_1_1_N = mkN "béarnaise" "béarnaiser" ;
  boejelse_nn_1_1_N = mkN "böjelse" "böjelser" ;
  boejningsaendelse_nn_1_1_N = mkN "böjningsändelse" "böjningsändelser" ;
  boeld_nn_1_1_N = mkN "böld" "bölder" ;
  boenhoerelse_nn_1_1_N = mkN "bönhörelse" "bönhörelser" ;
  boersstyrelse_nn_1_1_N = mkN "börsstyrelse" "börsstyrelser" ;
  cabriolet_nn_1_N = mkN "cabriolet" "cabrioleter" ;
  cancertumoer_nn_1_1_N = mkN "cancertumör" "cancertumörer" ;
  cape_nn_1_N = mkN "cape" "caper" ;
  cedilj_nn_1_N = mkN "cedilj" "cediljer" ;
  cell_nn_1_N = mkN "cell" "celler" ;
  cellkamrat_nn_1_N = mkN "cellkamrat" "cellkamrater" ;
  centaur_nn_1_N = mkN "centaur" "centaurer" ;
  centralbank_nn_1_N = mkN "centralbank" "centralbanker" ;
  centralgestalt_nn_1_N = mkN "centralgestalt" "centralgestalter" ;
  centralroerelse_nn_1_1_N = mkN "centralrörelse" "centralrörelser" ;
  centralstyrelse_nn_1_N = mkN "centralstyrelse" "centralstyrelser" ;
  centrifug_nn_1_N = mkN "centrifug" "centrifuger" ;
  cerise_nn_1_N = mkN "cerise" "ceriser" ;
  cert_nn_1_N = mkN "cert" "certer" ;
  champagne_nn_1_N = mkN "champagne" "champagner" ;
  chapeau_claque_nn_1_N = mkN "chapeau-claque" "chapeau-claquer" ;
  char_nn_1_N = mkN "char" "charer" ;
  charge_nn_1_N = mkN "charge" "charger" ;
  chartreuse_nn_1_N = mkN "chartreuse" "chartreuser" ;
  chateaubriand_nn_1_N = mkN "chateaubriand" "chateaubriander" ;
  chef_nn_1_N = mkN "chef" "chefer" ;
  chemisett_nn_1_N = mkN "chemisett" "chemisetter" ;
  chevelyr_nn_1_N = mkN "chevelyr" "chevelyrer" ;
  cheviot_nn_1_N = mkN "cheviot" "chevioter" ;
  chock_nn_1_N = mkN "chock" "chocker" ;
  cigarett_nn_1_N = mkN "cigarett" "cigaretter" ;
  cigarettautomat_nn_1_N = mkN "cigarettautomat" "cigarettautomater" ;
  cigarr_nn_1_N = mkN "cigarr" "cigarrer" ;
  cigarrcigarett_nn_1_N = mkN "cigarrcigarett" "cigarrcigaretter" ;
  cigarrcigarrett_nn_1_N = mkN "cigarrcigarrett" "cigarrcigarretter" ;
  cigarrett_nn_1_N = mkN "cigarrett" "cigarretter" ;
  cilie_nn_1_N = mkN "cilie" "cilier" ;
  cirkelroerelse_nn_1_1_N = mkN "cirkelrörelse" "cirkelrörelser" ;
  cirkuselefant_nn_1_N = mkN "cirkuselefant" "cirkuselefanter" ;
  cirkusmanege_nn_1_N = mkN "cirkusmanege" "cirkusmaneger" ;
  ciseloer_nn_1_1_N = mkN "ciselör" "ciselörer" ;
  cistern_nn_1_N = mkN "cistern" "cisterner" ;
  citronbakelse_nn_1_N = mkN "citronbakelse" "citronbakelser" ;
  citronmousse_nn_1_N = mkN "citronmousse" "citronmousser" ;
  citrusfrukt_nn_1_N = mkN "citrusfrukt" "citrusfrukter" ;
  civilmilitaer_nn_1_1_N = mkN "civilmilitär" "civilmilitärer" ;
  civilstat_nn_1_N = mkN "civilstat" "civilstater" ;
  clown_nn_1_N = mkN "clown" "clowner" ;
  colibakterie_nn_1_N = mkN "colibakterie" "colibakterier" ;
  come_back_nn_1_N = mkN "come-back" "come-backer" ;
  comeback_nn_1_N = mkN "comeback" "comebacker" ;
  commandotrupp_nn_1_N = mkN "commandotrupp" "commandotrupper" ;
  cortege_nn_1_N = mkN "cortege" "corteger" ;
  cortison_nn_1_N = mkN "cortison" "cortisoner" ;
  corte_ge_nn_1_1_N = mkN "cortège" "cortèger" ;
  coupe_nn_1_N = mkN "coupe" "couper" ;
  coyote_nn_1_N = mkN "coyote" "coyoter" ;
  creme_nn_1_N = mkN "creme" "cremer" ;
  cre_me_nn_1_1_N = mkN "crème" "crèmer" ;
  cup_nn_1_N = mkN "cup" "cuper" ;
  cyanobakterie_nn_1_N = mkN "cyanobakterie" "cyanobakterier" ;
  cykeltrupp_nn_1_N = mkN "cykeltrupp" "cykeltrupper" ;
  cykelventil_nn_1_N = mkN "cykelventil" "cykelventiler" ;
  cyklop_nn_1_N = mkN "cyklop" "cykloper" ;
  cypriot_nn_1_N = mkN "cypriot" "cyprioter" ;
  dadelpalm_nn_1_N = mkN "dadelpalm" "dadelpalmer" ;
  dagcentral_nn_1_N = mkN "dagcentral" "dagcentraler" ;
  dagerrotyp_nn_1_N = mkN "dagerrotyp" "dagerrotyper" ;
  daggpunkt_nn_1_N = mkN "daggpunkt" "daggpunkter" ;
  dagsbot_nn_1_N = mkN "dagsbot" "dagsböter" ;
  dagsranson_nn_1_N = mkN "dagsranson" "dagsransoner" ;
  dagsversskribent_nn_1_N = mkN "dagsversskribent" "dagsversskribenter" ;
  dagtid_nn_1_N = mkN "dagtid" "dagtider" ;
  dalbo_nn_1_N = mkN "dalbo" "dalbor" ;
  dalprofil_nn_1_N = mkN "dalprofil" "dalprofiler" ;
  damastservett_nn_1_N = mkN "damastservett" "damastservetter" ;
  damejeanne_nn_1_N = mkN "damejeanne" "damejeanner" ;
  dammspiral_nn_1_N = mkN "dammspiral" "dammspiraler" ;
  dammsugaragent_nn_1_N = mkN "dammsugaragent" "dammsugaragenter" ;
  damsko_nn_1_N = mkN "damsko" "damskor" ;
  damtoalett_nn_1_N = mkN "damtoalett" "damtoaletter" ;
  dansoer_nn_1_1_N = mkN "dansör" "dansörer" ;
  databank_nn_1_N = mkN "databank" "databanker" ;
  datacentral_nn_1_N = mkN "datacentral" "datacentraler" ;
  datafil_nn_1_N = mkN "datafil" "datafiler" ;
  datamaskin_nn_1_N = mkN "datamaskin" "datamaskiner" ;
  datautbytesoeverenskommelse_nn_1_1_N = mkN "datautbytesöverenskommelse" "datautbytesöverenskommelser" ;
  date_nn_1_N = mkN "date" "dater" ;
  datormodell_nn_1_N = mkN "datormodell" "datormodeller" ;
  debatt_nn_1_N = mkN "debatt" "debatter" ;
  debattoer_nn_1_1_N = mkN "debattör" "debattörer" ;
  decharge_nn_1_N = mkN "decharge" "decharger" ;
  dechargedebatt_nn_1_N = mkN "dechargedebatt" "dechargedebatter" ;
  decimal_nn_1_N = mkN "decimal" "decimaler" ;
  definitionsmaengd_nn_1_1_N = mkN "definitionsmängd" "definitionsmängder" ;
  degrand_nn_1_N = mkN "degrand" "degränder" ;
  dejtingsajt_nn_1_N = mkN "dejtingsajt" "dejtingsajter" ;
  dekad_nn_1_N = mkN "dekad" "dekader" ;
  dekal_nn_1_N = mkN "dekal" "dekaler" ;
  deklamatoer_nn_1_1_N = mkN "deklamatör" "deklamatörer" ;
  deklarationsblankett_nn_1_N = mkN "deklarationsblankett" "deklarationsblanketter" ;
  dekokt_nn_1_N = mkN "dekokt" "dekokter" ;
  dekoratoer_nn_1_1_N = mkN "dekoratör" "dekoratörer" ;
  delegat_nn_1_N = mkN "delegat" "delegater" ;
  delinkvent_nn_1_N = mkN "delinkvent" "delinkventer" ;
  delperiod_nn_1_N = mkN "delperiod" "delperioder" ;
  delrepublik_nn_1_N = mkN "delrepublik" "delrepubliker" ;
  deltid_nn_1_N = mkN "deltid" "deltider" ;
  demagog_nn_1_N = mkN "demagog" "demagoger" ;
  demarkationslinje_nn_1_N = mkN "demarkationslinje" "demarkationslinjer" ;
  demimond_nn_1_N = mkN "demimond" "demimonder" ;
  demiurg_nn_1_N = mkN "demiurg" "demiurger" ;
  demoeffekt_nn_1_N = mkN "demoeffekt" "demoeffekter" ;
  demokrat_nn_1_N = mkN "demokrat" "demokrater" ;
  demokratiroerelse_nn_1_1_N = mkN "demokratirörelse" "demokratirörelser" ;
  demonregissoer_nn_1_1_N = mkN "demonregissör" "demonregissörer" ;
  demonstratoer_nn_1_1_N = mkN "demonstratör" "demonstratörer" ;
  demotape_nn_1_N = mkN "demotape" "demotaper" ;
  dental_nn_1_N = mkN "dental" "dentaler" ;
  deponent_nn_1_N = mkN "deponent" "deponenter" ;
  descendent_nn_1_N = mkN "descendent" "descendenter" ;
  desertoer_nn_1_1_N = mkN "desertör" "desertörer" ;
  desinfektoer_nn_1_1_N = mkN "desinfektör" "desinfektörer" ;
  despot_nn_1_N = mkN "despot" "despoter" ;
  dessert_nn_1_N = mkN "dessert" "desserter" ;
  dessinatoer_nn_1_1_N = mkN "dessinatör" "dessinatörer" ;
  dessaeng_nn_1_1_N = mkN "dessäng" "dessänger" ;
  destillationsapparat_nn_1_N = mkN "destillationsapparat" "destillationsapparater" ;
  destinataer_nn_1_1_N = mkN "destinatär" "destinatärer" ;
  destinatoer_nn_1_1_N = mkN "destinatör" "destinatörer" ;
  destruent_nn_1_N = mkN "destruent" "destruenter" ;
  detachoer_nn_1_1_N = mkN "detachör" "detachörer" ;
  detalj_nn_1_N = mkN "detalj" "detaljer" ;
  detektivberaettelse_nn_1_1_N = mkN "detektivberättelse" "detektivberättelser" ;
  detergent_nn_1_N = mkN "detergent" "detergenter" ;
  dextran_nn_1_N = mkN "dextran" "dextraner" ;
  dextrin_nn_1_N = mkN "dextrin" "dextriner" ;
  diafilm_nn_1_N = mkN "diafilm" "diafilmer" ;
  diagnosmetod_nn_1_N = mkN "diagnosmetod" "diagnosmetoder" ;
  diagonal_nn_1_N = mkN "diagonal" "diagonaler" ;
  diakonistyrelse_nn_1_N = mkN "diakonistyrelse" "diakonistyrelser" ;
  dialekt_nn_1_N = mkN "dialekt" "dialekter" ;
  diatrib_nn_1_N = mkN "diatrib" "diatriber" ;
  diet_nn_1_N = mkN "diet" "dieter" ;
  differential_nn_1_N = mkN "differential" "differentialer" ;
  diftong_nn_1_N = mkN "diftong" "diftonger" ;
  dikteringsmaskin_nn_1_N = mkN "dikteringsmaskin" "dikteringsmaskiner" ;
  diminutiv_nn_1_N = mkN "diminutiv" "diminutiver" ;
  dinar_nn_1_N = mkN "dinar" "dinarer" ;
  dingo_nn_1_N = mkN "dingo" "dingor" ;
  dinosaurie_nn_1_N = mkN "dinosaurie" "dinosaurier" ;
  diperiod_nn_1_N = mkN "diperiod" "diperioder" ;
  diplomat_nn_1_N = mkN "diplomat" "diplomater" ;
  diplomatbostad_nn_1_N = mkN "diplomatbostad" "diplomatbostäder" ;
  diplomatportfoelj_nn_1_1_N = mkN "diplomatportfölj" "diplomatportföljer" ;
  direktkontakt_nn_1_N = mkN "direktkontakt" "direktkontakter" ;
  direktlinje_nn_1_N = mkN "direktlinje" "direktlinjer" ;
  direktmetod_nn_1_N = mkN "direktmetod" "direktmetoder" ;
  dirigent_nn_1_N = mkN "dirigent" "dirigenter" ;
  disciplinbot_nn_1_N = mkN "disciplinbot" "disciplinböter" ;
  diskantklav_nn_1_N = mkN "diskantklav" "diskantklaver" ;
  diskett_nn_1_N = mkN "diskett" "disketter" ;
  diskofil_nn_1_N = mkN "diskofil" "diskofiler" ;
  diskontoer_nn_1_1_N = mkN "diskontör" "diskontörer" ;
  dispensaer_nn_1_1_N = mkN "dispensär" "dispensärer" ;
  disponent_nn_1_N = mkN "disponent" "disponenter" ;
  dispyt_nn_1_N = mkN "dispyt" "dispyter" ;
  dissident_nn_1_N = mkN "dissident" "dissidenter" ;
  distribuent_nn_1_N = mkN "distribuent" "distribuenter" ;
  distribunal_nn_1_N = mkN "distribunal" "distribunaler" ;
  distributionscentral_nn_1_N = mkN "distributionscentral" "distributionscentraler" ;
  distributoer_nn_1_1_N = mkN "distributör" "distributörer" ;
  dityramb_nn_1_N = mkN "dityramb" "dityramber" ;
  dividend_nn_1_N = mkN "dividend" "dividender" ;
  divisionsgeneral_nn_1_N = mkN "divisionsgeneral" "divisionsgeneraler" ;
  djonk_nn_1_N = mkN "djonk" "djonker" ;
  djupbergart_nn_1_N = mkN "djupbergart" "djupbergarter" ;
  djurpark_nn_1_N = mkN "djurpark" "djurparker" ;
  dna_profil_nn_1_N = mkN "dna-profil" "dna-profiler" ;
  docent_nn_1_N = mkN "docent" "docenter" ;
  dockperuk_nn_1_N = mkN "dockperuk" "dockperuker" ;
  doft_nn_1_N = mkN "doft" "dofter" ;
  dogcart_nn_1_N = mkN "dogcart" "dogcarter" ;
  doge_nn_1_N = mkN "doge" "doger" ;
  dogm_nn_1_N = mkN "dogm" "dogmer" ;
  dokumentportfoelj_nn_1_1_N = mkN "dokumentportfölj" "dokumentportföljer" ;
  dolikocefal_nn_1_N = mkN "dolikocefal" "dolikocefaler" ;
  dom_nn_2_N = mkN "dom" "domer" ;
  domedagsprofet_nn_1_N = mkN "domedagsprofet" "domedagsprofeter" ;
  domestik_nn_1_N = mkN "domestik" "domestiker" ;
  domino_nn_1_N = mkN "domino" "dominor" ;
  domkraft_nn_1_N = mkN "domkraft" "domkrafter" ;
  domkyrkoadjunkt_nn_1_N = mkN "domkyrkoadjunkt" "domkyrkoadjunkter" ;
  domptoer_nn_1_1_N = mkN "domptör" "domptörer" ;
  domstolsbetjaent_nn_1_1_N = mkN "domstolsbetjänt" "domstolsbetjänter" ;
  domaen_nn_1_1_N = mkN "domän" "domäner" ;
  dopamin_nn_1_N = mkN "dopamin" "dopaminer" ;
  dopbassaeng_nn_1_1_N = mkN "dopbassäng" "dopbassänger" ;
  doppsko_nn_1_N = mkN "doppsko" "doppskor" ;
  dorsal_nn_1_N = mkN "dorsal" "dorsaler" ;
  dosekvivalent_nn_1_N = mkN "dosekvivalent" "dosekvivalenter" ;
  doslibell_nn_1_N = mkN "doslibell" "doslibeller" ;
  dotterson_nn_1_N = mkN "dotterson" "dottersöner" ;
  dottertumoer_nn_1_1_N = mkN "dottertumör" "dottertumörer" ;
  downperiod_nn_1_N = mkN "downperiod" "downperioder" ;
  dragbasun_nn_1_N = mkN "dragbasun" "dragbasuner" ;
  dragkamp_nn_1_N = mkN "dragkamp" "dragkamper" ;
  dragshow_nn_1_N = mkN "dragshow" "dragshower" ;
  dragsko_nn_1_N = mkN "dragsko" "dragskor" ;
  dragstaang_nn_1_1_N = mkN "dragstång" "dragstänger" ;
  draksaadd_nn_1_1_N = mkN "draksådd" "draksådder" ;
  drasut_nn_1_N = mkN "drasut" "drasuter" ;
  dressyr_nn_1_N = mkN "dressyr" "dressyrer" ;
  dressoer_nn_1_1_N = mkN "dressör" "dressörer" ;
  drift_nn_2_N = mkN "drift" "drifter" ;
  drog_nn_1_N = mkN "drog" "droger" ;
  drogeffekt_nn_1_N = mkN "drogeffekt" "drogeffekter" ;
  dromedar_nn_1_N = mkN "dromedar" "dromedarer" ;
  dront_nn_1_N = mkN "dront" "dronter" ;
  drottningsylt_nn_1_N = mkN "drottningsylt" "drottningsylter" ;
  druvboerd_nn_1_1_N = mkN "druvbörd" "druvbörder" ;
  druvsaft_nn_1_N = mkN "druvsaft" "druvsafter" ;
  dryad_nn_1_N = mkN "dryad" "dryader" ;
  draen_nn_1_1_N = mkN "drän" "dräner" ;
  droemkandidat_nn_1_1_N = mkN "drömkandidat" "drömkandidater" ;
  droemskapelse_nn_1_1_N = mkN "drömskapelse" "drömskapelser" ;
  dubbelagent_nn_1_N = mkN "dubbelagent" "dubbelagenter" ;
  dubbelbredd_nn_1_N = mkN "dubbelbredd" "dubbelbredder" ;
  dubbelhytt_nn_1_N = mkN "dubbelhytt" "dubbelhytter" ;
  dubbelkvartett_nn_1_N = mkN "dubbelkvartett" "dubbelkvartetter" ;
  duchatel_nn_1_N = mkN "duchatel" "duchateler" ;
  duell_nn_1_N = mkN "duell" "dueller" ;
  duett_nn_1_N = mkN "duett" "duetter" ;
  dukat_nn_1_N = mkN "dukat" "dukater" ;
  duplett_nn_1_N = mkN "duplett" "dupletter" ;
  duplik_nn_1_N = mkN "duplik" "dupliker" ;
  dusoer_nn_1_1_N = mkN "dusör" "dusörer" ;
  dykand_nn_1_N = mkN "dykand" "dykänder" ;
  dykdalb_nn_1_N = mkN "dykdalb" "dykdalber" ;
  dyn_nn_1_N = mkN "dyn" "dyner" ;
  dynamitard_nn_1_N = mkN "dynamitard" "dynamitarder" ;
  dynamo_nn_1_N = mkN "dynamo" "dynamor" ;
  dyrtid_nn_1_N = mkN "dyrtid" "dyrtider" ;
  dyschatell_nn_1_N = mkN "dyschatell" "dyschateller" ;
  daeckbytarhelg_nn_1_1_N = mkN "däckbytarhelg" "däckbytarhelger" ;
  daeckventil_nn_1_1_N = mkN "däckventil" "däckventiler" ;
  daeckverkstad_nn_1_1_N = mkN "däckverkstad" "däckverkstäder" ;
  daeggdjurstand_nn_1_1_N = mkN "däggdjurstand" "däggdjurständer" ;
  daeld_nn_1_1_N = mkN "däld" "dälder" ;
  daarskap_nn_1_1_N = mkN "dårskap" "dårskaper" ;
  doebattang_nn_1_1_N = mkN "döbattang" "döbattanger" ;
  doedperiod_nn_1_1_N = mkN "dödperiod" "dödperioder" ;
  doedsbakterie_nn_1_1_N = mkN "dödsbakterie" "dödsbakterier" ;
  doedsfiende_nn_1_1_N = mkN "dödsfiende" "dödsfiender" ;
  doedshjaelpsdebatt_nn_1_1_N = mkN "dödshjälpsdebatt" "dödshjälpsdebatter" ;
  doedskamp_nn_1_1_N = mkN "dödskamp" "dödskamper" ;
  doedsklinik_nn_1_1_N = mkN "dödsklinik" "dödskliniker" ;
  doedspatrull_nn_1_1_N = mkN "dödspatrull" "dödspatruller" ;
  doedssynd_nn_1_1_N = mkN "dödssynd" "dödssynder" ;
  echelong_nn_1_N = mkN "echelong" "echelonger" ;
  ed_nn_1_N = mkN "ed" "eder" ;
  edil_nn_1_N = mkN "edil" "ediler" ;
  efedrin_nn_1_N = mkN "efedrin" "efedriner" ;
  effekt_nn_1_N = mkN "effekt" "effekter" ;
  efterboerd_nn_1_1_N = mkN "efterbörd" "efterbörder" ;
  efterfoeljelse_nn_1_1_N = mkN "efterföljelse" "efterföljelser" ;
  eftergift_nn_1_N = mkN "eftergift" "eftergifter" ;
  efterklang_nn_1_N = mkN "efterklang" "efterklanger" ;
  eftertextnot_nn_1_N = mkN "eftertextnot" "eftertextnoter" ;
  eftertrupp_nn_1_N = mkN "eftertrupp" "eftertrupper" ;
  eftertraedarkandidat_nn_1_1_N = mkN "efterträdarkandidat" "efterträdarkandidater" ;
  eftervalsdebatt_nn_1_N = mkN "eftervalsdebatt" "eftervalsdebatter" ;
  egenskap_nn_1_N = mkN "egenskap" "egenskaper" ;
  eggelse_nn_1_N = mkN "eggelse" "eggelser" ;
  eklog_nn_1_N = mkN "eklog" "ekloger" ;
  ekonomlinje_nn_1_N = mkN "ekonomlinje" "ekonomlinjer" ;
  ekoradio_nn_1_N = mkN "ekoradio" "ekoradior" ;
  ekotyp_nn_1_N = mkN "ekotyp" "ekotyper" ;
  ekvatorialzon_nn_1_N = mkN "ekvatorialzon" "ekvatorialzoner" ;
  ekvipotentiallinje_nn_1_N = mkN "ekvipotentiallinje" "ekvipotentiallinjer" ;
  ekvivalentvikt_nn_1_N = mkN "ekvivalentvikt" "ekvivalentvikter" ;
  eland_nn_1_N = mkN "eland" "elander" ;
  elapparat_nn_1_N = mkN "elapparat" "elapparater" ;
  elchock_nn_1_N = mkN "elchock" "elchocker" ;
  eldbegaengelse_nn_1_1_N = mkN "eldbegängelse" "eldbegängelser" ;
  eldbrand_nn_1_N = mkN "eldbrand" "eldbränder" ;
  eldkanal_nn_1_N = mkN "eldkanal" "eldkanaler" ;
  eldlinje_nn_1_N = mkN "eldlinje" "eldlinjer" ;
  eldstad_nn_1_N = mkN "eldstad" "eldstäder" ;
  elektrochock_nn_1_N = mkN "elektrochock" "elektrochocker" ;
  elektrod_nn_1_N = mkN "elektrod" "elektroder" ;
  elektrolyt_nn_1_N = mkN "elektrolyt" "elektrolyter" ;
  elektronikkomponent_nn_1_N = mkN "elektronikkomponent" "elektronikkomponenter" ;
  elektronroersdiod_nn_1_1_N = mkN "elektronrörsdiod" "elektronrörsdioder" ;
  elektrotyp_nn_1_N = mkN "elektrotyp" "elektrotyper" ;
  elementaerkraft_nn_1_1_N = mkN "elementärkraft" "elementärkrafter" ;
  elev_nn_1_N = mkN "elev" "elever" ;
  elfenbenspalm_nn_1_N = mkN "elfenbenspalm" "elfenbenspalmer" ;
  elgitarr_nn_1_N = mkN "elgitarr" "elgitarrer" ;
  elitserie_nn_1_N = mkN "elitserie" "elitserier" ;
  elittrupp_nn_1_N = mkN "elittrupp" "elittrupper" ;
  eloge_nn_1_N = mkN "eloge" "eloger" ;
  elsevir_nn_1_N = mkN "elsevir" "elsevirer" ;
  elvaaarsperiod_nn_1_1_N = mkN "elvaårsperiod" "elvaårsperioder" ;
  elzevier_nn_1_N = mkN "elzevier" "elzevierer" ;
  elaendesfoerutsaegelse_nn_1_1_N = mkN "eländesförutsägelse" "eländesförutsägelser" ;
  emalj_nn_1_N = mkN "emalj" "emaljer" ;
  emaljplomb_nn_1_N = mkN "emaljplomb" "emaljplomber" ;
  emaljoer_nn_1_1_N = mkN "emaljör" "emaljörer" ;
  emir_nn_1_N = mkN "emir" "emirer" ;
  emissarie_nn_1_N = mkN "emissarie" "emissarier" ;
  endiv_nn_1_N = mkN "endiv" "endiver" ;
  endossat_nn_1_N = mkN "endossat" "endossater" ;
  endossent_nn_1_N = mkN "endossent" "endossenter" ;
  energiuppgoerelse_nn_1_1_N = mkN "energiuppgörelse" "energiuppgörelser" ;
  engaangsfoereteelse_nn_1_1_N = mkN "engångsföreteelse" "engångsföreteelser" ;
  engaangsservett_nn_1_1_N = mkN "engångsservett" "engångsservetter" ;
  enhetsfront_nn_1_N = mkN "enhetsfront" "enhetsfronter" ;
  enhetspatron_nn_1_N = mkN "enhetspatron" "enhetspatroner" ;
  enkelbiljett_nn_1_N = mkN "enkelbiljett" "enkelbiljetter" ;
  enkelbredd_nn_1_N = mkN "enkelbredd" "enkelbredder" ;
  enkelkvartett_nn_1_N = mkN "enkelkvartett" "enkelkvartetter" ;
  enklav_nn_1_N = mkN "enklav" "enklaver" ;
  enmansshow_nn_1_N = mkN "enmansshow" "enmansshower" ;
  ensemble_nn_1_N = mkN "ensemble" "ensembler" ;
  enslinje_nn_1_N = mkN "enslinje" "enslinjer" ;
  entente_nn_1_N = mkN "entente" "ententer" ;
  entrecote_nn_1_N = mkN "entrecote" "entrecoter" ;
  entrecoote_nn_1_1_N = mkN "entrecôte" "entrecôter" ;
  entreprenad_nn_1_N = mkN "entreprenad" "entreprenader" ;
  entreprenoer_nn_1_1_N = mkN "entreprenör" "entreprenörer" ;
  entr_ebiljett_nn_1_1_N = mkN "entrébiljett" "entrébiljetter" ;
  entusiastsajt_nn_1_N = mkN "entusiastsajt" "entusiastsajter" ;
  eosin_nn_1_N = mkN "eosin" "eosiner" ;
  epifyt_nn_1_N = mkN "epifyt" "epifyter" ;
  epilog_nn_1_N = mkN "epilog" "epiloger" ;
  epinefrin_nn_1_N = mkN "epinefrin" "epinefriner" ;
  episod_nn_1_N = mkN "episod" "episoder" ;
  epok_nn_1_N = mkN "epok" "epoker" ;
  epaalett_nn_1_1_N = mkN "epålett" "epåletter" ;
  ergonom_nn_1_N = mkN "ergonom" "ergonomer" ;
  erinnye_nn_1_N = mkN "erinnye" "erinnyer" ;
  erosionsstrand_nn_1_N = mkN "erosionsstrand" "erosionsstränder" ;
  eruptivbergart_nn_1_N = mkN "eruptivbergart" "eruptivbergarter" ;
  erytropoitin_nn_1_N = mkN "erytropoitin" "erytropoitiner" ;
  eskapad_nn_1_N = mkN "eskapad" "eskapader" ;
  eskarp_nn_1_N = mkN "eskarp" "eskarper" ;
  eskort_nn_1_N = mkN "eskort" "eskorter" ;
  eskulap_nn_1_N = mkN "eskulap" "eskulaper" ;
  espadrill_nn_1_N = mkN "espadrill" "espadriller" ;
  espagnolett_nn_1_N = mkN "espagnolett" "espagnoletter" ;
  esplanad_nn_1_N = mkN "esplanad" "esplanader" ;
  essaeuppgift_nn_1_1_N = mkN "essäuppgift" "essäuppgifter" ;
  estet_nn_1_N = mkN "estet" "esteter" ;
  estraddebatt_nn_1_N = mkN "estraddebatt" "estraddebatter" ;
  estradoer_nn_1_1_N = mkN "estradör" "estradörer" ;
  etagaer_nn_1_1_N = mkN "etagär" "etagärer" ;
  etalong_nn_1_N = mkN "etalong" "etalonger" ;
  etan_nn_1_N = mkN "etan" "etaner" ;
  etapp_nn_1_N = mkN "etapp" "etapper" ;
  etapplinje_nn_1_N = mkN "etapplinje" "etapplinjer" ;
  etikett_nn_1_N = mkN "etikett" "etiketter" ;
  etiop_nn_1_N = mkN "etiop" "etioper" ;
  etnograf_nn_1_N = mkN "etnograf" "etnografer" ;
  eunuck_nn_1_N = mkN "eunuck" "eunucker" ;
  evakostym_nn_1_N = mkN "evakostym" "evakostymer" ;
  evertebrat_nn_1_N = mkN "evertebrat" "evertebrater" ;
  evighetsmaskin_nn_1_N = mkN "evighetsmaskin" "evighetsmaskiner" ;
  examinand_nn_1_N = mkN "examinand" "examinander" ;
  excerpt_nn_1_N = mkN "excerpt" "excerpter" ;
  exeget_nn_1_N = mkN "exeget" "exegeter" ;
  exekutoer_nn_1_1_N = mkN "exekutör" "exekutörer" ;
  exilhuvudstad_nn_1_N = mkN "exilhuvudstad" "exilhuvudstäder" ;
  exoplanet_nn_1_N = mkN "exoplanet" "exoplaneter" ;
  expeditionsministaer_nn_1_1_N = mkN "expeditionsministär" "expeditionsministärer" ;
  expeditoer_nn_1_1_N = mkN "expeditör" "expeditörer" ;
  expert_nn_1_N = mkN "expert" "experter" ;
  exploatoer_nn_1_1_N = mkN "exploatör" "exploatörer" ;
  expo_nn_1_N = mkN "expo" "expor" ;
  exponent_nn_1_N = mkN "exponent" "exponenter" ;
  exportoer_nn_1_1_N = mkN "exportör" "exportörer" ;
  expresident_nn_1_N = mkN "expresident" "expresidenter" ;
  expressfoersaendelse_nn_1_1_N = mkN "expressförsändelse" "expressförsändelser" ;
  exterioer_nn_1_1_N = mkN "exteriör" "exteriörer" ;
  extern_nn_1_N = mkN "extern" "externer" ;
  extraordinarie_nn_1_N = mkN "extraordinarie" "extraordinarier" ;
  extraranson_nn_1_N = mkN "extraranson" "extraransoner" ;
  fabrikstomt_nn_1_N = mkN "fabrikstomt" "fabrikstomter" ;
  facett_nn_1_N = mkN "facett" "facetter" ;
  fackfoereningsroerelse_nn_1_1_N = mkN "fackföreningsrörelse" "fackföreningsrörelser" ;
  fackidiot_nn_1_N = mkN "fackidiot" "fackidioter" ;
  fackterm_nn_1_N = mkN "fackterm" "facktermer" ;
  fadersgestalt_nn_1_N = mkN "fadersgestalt" "fadersgestalter" ;
  fagott_nn_1_N = mkN "fagott" "fagotter" ;
  faiblesse_nn_1_N = mkN "faiblesse" "faiblesser" ;
  fakir_nn_1_N = mkN "fakir" "fakirer" ;
  faksimile_nn_1_N = mkN "faksimile" "faksimiler" ;
  fakultetsopponent_nn_1_N = mkN "fakultetsopponent" "fakultetsopponenter" ;
  falang_nn_1_N = mkN "falang" "falanger" ;
  falkonett_nn_1_N = mkN "falkonett" "falkonetter" ;
  fallfrukt_nn_1_N = mkN "fallfrukt" "fallfrukter" ;
  fallskaermstrupp_nn_1_1_N = mkN "fallskärmstrupp" "fallskärmstrupper" ;
  fallstudie_nn_1_N = mkN "fallstudie" "fallstudier" ;
  familjebiljett_nn_1_N = mkN "familjebiljett" "familjebiljetter" ;
  familjestiftelse_nn_1_N = mkN "familjestiftelse" "familjestiftelser" ;
  fanfar_nn_1_N = mkN "fanfar" "fanfarer" ;
  fantasigestalt_nn_1_N = mkN "fantasigestalt" "fantasigestalter" ;
  fantasiprodukt_nn_1_N = mkN "fantasiprodukt" "fantasiprodukter" ;
  fantasiskapelse_nn_1_N = mkN "fantasiskapelse" "fantasiskapelser" ;
  fantasivarelse_nn_1_N = mkN "fantasivarelse" "fantasivarelser" ;
  fantom_nn_2_N = mkN "fantom" "fantomer" ;
  farmaceut_nn_1_N = mkN "farmaceut" "farmaceuter" ;
  farmacevt_nn_1_N = mkN "farmacevt" "farmacevter" ;
  farozon_nn_1_N = mkN "farozon" "farozoner" ;
  farsot_nn_1_N = mkN "farsot" "farsoter" ;
  fart_nn_1_N = mkN "fart" "farter" ;
  fartrand_nn_1_N = mkN "fartrand" "fartränder" ;
  fasad_nn_1_N = mkN "fasad" "fasader" ;
  fasett_nn_1_N = mkN "fasett" "fasetter" ;
  fastighetsmogul_nn_1_N = mkN "fastighetsmogul" "fastighetsmoguler" ;
  faststaellelse_nn_1_1_N = mkN "fastställelse" "fastställelser" ;
  fatabur_nn_1_N = mkN "fatabur" "fataburer" ;
  fatalietid_nn_1_N = mkN "fatalietid" "fatalietider" ;
  fatbur_nn_1_N = mkN "fatbur" "fatburer" ;
  faun_nn_1_N = mkN "faun" "fauner" ;
  faute_nn_1_N = mkN "faute" "fauter" ;
  favoritpsalm_nn_1_N = mkN "favoritpsalm" "favoritpsalmer" ;
  favoritstrand_nn_1_N = mkN "favoritstrand" "favoritstränder" ;
  favoer_nn_1_1_N = mkN "favör" "favörer" ;
  fejd_nn_1_N = mkN "fejd" "fejder" ;
  felmarginal_nn_1_N = mkN "felmarginal" "felmarginaler" ;
  femininum_nn_1_N = mkN "feminin" "femininer" ;
  femkamp_nn_1_N = mkN "femkamp" "femkamper" ;
  femtekolonn_nn_1_N = mkN "femtekolonn" "femtekolonner" ;
  femaarsperiod_nn_1_1_N = mkN "femårsperiod" "femårsperioder" ;
  fenedrin_nn_1_N = mkN "fenedrin" "fenedriner" ;
  fenmetralin_nn_1_N = mkN "fenmetralin" "fenmetraliner" ;
  fenolftalein_nn_1_N = mkN "fenolftalein" "fenolftaleiner" ;
  fenotyp_nn_1_N = mkN "fenotyp" "fenotyper" ;
  ferie_nn_1_N = mkN "ferie" "ferier" ;
  festival_nn_1_N = mkN "festival" "festivaler" ;
  festlokal_nn_1_N = mkN "festlokal" "festlokaler" ;
  festong_nn_1_N = mkN "festong" "festonger" ;
  fettreserv_nn_1_N = mkN "fettreserv" "fettreserver" ;
  fibrill_nn_1_N = mkN "fibrill" "fibriller" ;
  fiction_novell_nn_1_N = mkN "fiction-novell" "fiction-noveller" ;
  fiende_nn_1_N = mkN "fiende" "fiender" ;
  fiendelinje_nn_1_N = mkN "fiendelinje" "fiendelinjer" ;
  fiendskap_nn_1_N = mkN "fiendskap" "fiendskaper" ;
  filial_nn_1_N = mkN "filial" "filialer" ;
  filippik_nn_1_N = mkN "filippik" "filippiker" ;
  filmfotograf_nn_1_N = mkN "filmfotograf" "filmfotografer" ;
  filmregissoer_nn_1_1_N = mkN "filmregissör" "filmregissörer" ;
  filmscen_nn_1_N = mkN "filmscen" "filmscener" ;
  filmstudio_nn_1_N = mkN "filmstudio" "filmstudior" ;
  filosof_nn_1_N = mkN "filosof" "filosofer" ;
  filtercigarett_nn_1_N = mkN "filtercigarett" "filtercigaretter" ;
  filur_nn_1_N = mkN "filur" "filurer" ;
  fimmelstaang_nn_1_1_N = mkN "fimmelstång" "fimmelstänger" ;
  fimmerstaang_nn_1_1_N = mkN "fimmerstång" "fimmerstänger" ;
  final_nn_1_N = mkN "final" "finaler" ;
  finansdebatt_nn_1_N = mkN "finansdebatt" "finansdebatter" ;
  finansiaer_nn_1_1_N = mkN "finansiär" "finansiärer" ;
  fingeravtrycksaspekt_nn_1_N = mkN "fingeravtrycksaspekt" "fingeravtrycksaspekter" ;
  fingernerv_nn_1_N = mkN "fingernerv" "fingernerver" ;
  finnmark_nn_1_N = mkN "finnmark" "finnmarker" ;
  finsko_nn_1_N = mkN "finsko" "finskor" ;
  fint_nn_1_N = mkN "fint" "finter" ;
  fiol_nn_1_N = mkN "fiol" "fioler" ;
  fiskeristyrelse_nn_1_N = mkN "fiskeristyrelse" "fiskeristyrelser" ;
  fiskezon_nn_1_N = mkN "fiskezon" "fiskezoner" ;
  fjaelltrakt_nn_1_1_N = mkN "fjälltrakt" "fjälltrakter" ;
  fjaerilslarv_nn_1_1_N = mkN "fjärilslarv" "fjärilslarver" ;
  fladdermusfaatoelj_nn_1_1_N = mkN "fladdermusfåtölj" "fladdermusfåtöljer" ;
  flagell_nn_1_N = mkN "flagell" "flageller" ;
  flagellat_nn_1_N = mkN "flagellat" "flagellater" ;
  flageolett_nn_1_N = mkN "flageolett" "flageoletter" ;
  flaggkapten_nn_1_N = mkN "flaggkapten" "flaggkaptener" ;
  flaggstaang_nn_1_1_N = mkN "flaggstång" "flaggstänger" ;
  flakong_nn_1_N = mkN "flakong" "flakonger" ;
  flamingo_nn_1_N = mkN "flamingo" "flamingor" ;
  flampunkt_nn_1_N = mkN "flampunkt" "flampunkter" ;
  flanell_nn_1_N = mkN "flanell" "flaneller" ;
  flanellkostym_nn_1_N = mkN "flanellkostym" "flanellkostymer" ;
  flanellograf_nn_1_N = mkN "flanellograf" "flanellografer" ;
  flank_nn_1_N = mkN "flank" "flanker" ;
  flanoer_nn_1_1_N = mkN "flanör" "flanörer" ;
  flervalsuppgift_nn_1_N = mkN "flervalsuppgift" "flervalsuppgifter" ;
  flextid_nn_1_N = mkN "flextid" "flextider" ;
  flockkamrat_nn_1_N = mkN "flockkamrat" "flockkamrater" ;
  flod_nn_1_N = mkN "flod" "floder" ;
  flodprofil_nn_1_N = mkN "flodprofil" "flodprofiler" ;
  flodslaett_nn_1_1_N = mkN "flodslätt" "flodslätter" ;
  flodstrand_nn_1_N = mkN "flodstrand" "flodstränder" ;
  florett_nn_1_N = mkN "florett" "floretter" ;
  flottilj_nn_1_N = mkN "flottilj" "flottiljer" ;
  flottyr_nn_1_N = mkN "flottyr" "flottyrer" ;
  flottoer_nn_1_1_N = mkN "flottör" "flottörer" ;
  flygbiljett_nn_1_N = mkN "flygbiljett" "flygbiljetter" ;
  flygfrakt_nn_1_N = mkN "flygfrakt" "flygfrakter" ;
  flygkapten_nn_1_N = mkN "flygkapten" "flygkaptener" ;
  flyglinje_nn_1_N = mkN "flyglinje" "flyglinjer" ;
  flygmaskin_nn_1_N = mkN "flygmaskin" "flygmaskiner" ;
  flygplansmodell_nn_1_N = mkN "flygplansmodell" "flygplansmodeller" ;
  flykt_nn_1_N = mkN "flykt" "flykter" ;
  flaeskkotlett_nn_1_1_N = mkN "fläskkotlett" "fläskkotletter" ;
  floejt_nn_1_1_N = mkN "flöjt" "flöjter" ;
  floejttravaer_nn_1_1_N = mkN "flöjttravär" "flöjttravärer" ;
  folkfront_nn_1_N = mkN "folkfront" "folkfronter" ;
  folkkommissarie_nn_1_N = mkN "folkkommissarie" "folkkommissarier" ;
  folkkommun_nn_1_N = mkN "folkkommun" "folkkommuner" ;
  folkmaengd_nn_1_1_N = mkN "folkmängd" "folkmängder" ;
  folkpark_nn_1_N = mkN "folkpark" "folkparker" ;
  folkrepublik_nn_1_N = mkN "folkrepublik" "folkrepubliker" ;
  folkroerelse_nn_1_1_N = mkN "folkrörelse" "folkrörelser" ;
  folktribun_nn_1_N = mkN "folktribun" "folktribuner" ;
  fondaktie_nn_1_N = mkN "fondaktie" "fondaktier" ;
  fondbestaemmelse_nn_1_1_N = mkN "fondbestämmelse" "fondbestämmelser" ;
  fondtapet_nn_1_N = mkN "fondtapet" "fondtapeter" ;
  fondue_nn_1_N = mkN "fondue" "fonduer" ;
  fonograf_nn_1_N = mkN "fonograf" "fonografer" ;
  fontanell_nn_1_N = mkN "fontanell" "fontaneller" ;
  fontaen_nn_1_1_N = mkN "fontän" "fontäner" ;
  forell_nn_1_N = mkN "forell" "foreller" ;
  formbakelse_nn_1_N = mkN "formbakelse" "formbakelser" ;
  forntid_nn_1_N = mkN "forntid" "forntider" ;
  forskarassistent_nn_1_N = mkN "forskarassistent" "forskarassistenter" ;
  fortplantningsdrift_nn_1_N = mkN "fortplantningsdrift" "fortplantningsdrifter" ;
  fosterson_nn_1_N = mkN "fosterson" "fostersöner" ;
  fotoautomat_nn_1_N = mkN "fotoautomat" "fotoautomater" ;
  fotocell_nn_1_N = mkN "fotocell" "fotoceller" ;
  fotograf_nn_1_N = mkN "fotograf" "fotografer" ;
  fotogravyr_nn_1_N = mkN "fotogravyr" "fotogravyrer" ;
  fotokarriaer_nn_1_1_N = mkN "fotokarriär" "fotokarriärer" ;
  fotomodell_nn_1_N = mkN "fotomodell" "fotomodeller" ;
  frakt_nn_1_N = mkN "frakt" "frakter" ;
  framkallningsapparat_nn_1_N = mkN "framkallningsapparat" "framkallningsapparater" ;
  framlob_nn_1_N = mkN "framlob" "framlober" ;
  framtand_nn_1_N = mkN "framtand" "framtänder" ;
  framtidsfoerutsaegelse_nn_1_1_N = mkN "framtidsförutsägelse" "framtidsförutsägelser" ;
  frasliberal_nn_1_N = mkN "frasliberal" "frasliberaler" ;
  frasradikal_nn_1_N = mkN "frasradikal" "frasradikaler" ;
  fredsroerelse_nn_1_1_N = mkN "fredsrörelse" "fredsrörelser" ;
  fredsoeverenskommelse_nn_1_1_N = mkN "fredsöverenskommelse" "fredsöverenskommelser" ;
  fregatt_nn_1_N = mkN "fregatt" "fregatter" ;
  frestelse_nn_1_N = mkN "frestelse" "frestelser" ;
  fribiljett_nn_1_N = mkN "fribiljett" "fribiljetter" ;
  fribonde_nn_1_N = mkN "fribonde" "fribönder" ;
  frid_nn_1_N = mkN "frid" "frider" ;
  frihetskamp_nn_1_N = mkN "frihetskamp" "frihetskamper" ;
  frikadell_nn_1_N = mkN "frikadell" "frikadeller" ;
  frikallelse_nn_1_N = mkN "frikallelse" "frikallelser" ;
  friktionskoefficient_nn_1_N = mkN "friktionskoefficient" "friktionskoefficienter" ;
  frikyrkoroerelse_nn_1_1_N = mkN "frikyrkorörelse" "frikyrkorörelser" ;
  frikaennelse_nn_1_1_N = mkN "frikännelse" "frikännelser" ;
  frilansskribent_nn_1_N = mkN "frilansskribent" "frilansskribenter" ;
  frimurarloge_nn_1_N = mkN "frimurarloge" "frimurarloger" ;
  fristad_nn_1_N = mkN "fristad" "fristäder" ;
  frisyr_nn_1_N = mkN "frisyr" "frisyrer" ;
  frisyrgel_e_nn_1_1_N = mkN "frisyrgelé" "frisyrgeléer" ;
  frisoerelev_nn_1_1_N = mkN "frisörelev" "frisörelever" ;
  fritidsbebyggelse_nn_1_N = mkN "fritidsbebyggelse" "fritidsbebyggelser" ;
  fritidslokal_nn_1_N = mkN "fritidslokal" "fritidslokaler" ;
  fritidspedagog_nn_1_N = mkN "fritidspedagog" "fritidspedagoger" ;
  frityr_nn_1_N = mkN "frityr" "frityrer" ;
  frivakt_nn_1_N = mkN "frivakt" "frivakter" ;
  frivolt_nn_1_N = mkN "frivolt" "frivolter" ;
  fromage_nn_1_N = mkN "fromage" "fromager" ;
  frondoer_nn_1_1_N = mkN "frondör" "frondörer" ;
  front_nn_1_N = mkN "front" "fronter" ;
  frontallob_nn_1_N = mkN "frontallob" "frontallober" ;
  frontfoerbindelse_nn_1_1_N = mkN "frontförbindelse" "frontförbindelser" ;
  frontlinje_nn_1_N = mkN "frontlinje" "frontlinjer" ;
  frostnatt_nn_1_N = mkN "frostnatt" "frostnätter" ;
  fruktkompott_nn_1_N = mkN "fruktkompott" "fruktkompotter" ;
  fruktsaft_nn_1_N = mkN "fruktsaft" "fruktsafter" ;
  fryspunkt_nn_1_N = mkN "fryspunkt" "fryspunkter" ;
  fraelsebonde_nn_1_1_N = mkN "frälsebonde" "frälsebönder" ;
  fraelsningssoldat_nn_1_1_N = mkN "frälsningssoldat" "frälsningssoldater" ;
  fraelsningsupplevelse_nn_1_1_N = mkN "frälsningsupplevelse" "frälsningsupplevelser" ;
  fraemlingslegionaer_nn_1_1_N = mkN "främlingslegionär" "främlingslegionärer" ;
  fraende_nn_1_1_N = mkN "frände" "fränder" ;
  fraendskap_nn_1_1_N = mkN "frändskap" "frändskaper" ;
  fraesmaskin_nn_1_1_N = mkN "fräsmaskin" "fräsmaskiner" ;
  fraagespalt_nn_1_1_N = mkN "frågespalt" "frågespalter" ;
  fraagestund_nn_1_1_N = mkN "frågestund" "frågestunder" ;
  froeplantage_nn_1_1_N = mkN "fröplantage" "fröplantager" ;
  funktionaer_nn_1_1_N = mkN "funktionär" "funktionärer" ;
  furie_nn_1_N = mkN "furie" "furier" ;
  furir_nn_1_N = mkN "furir" "furirer" ;
  furnissoer_nn_1_1_N = mkN "furnissör" "furnissörer" ;
  fursteaett_nn_1_1_N = mkN "fursteätt" "fursteätter" ;
  futhark_nn_1_N = mkN "futhark" "futharker" ;
  fyllerifoerseelse_nn_1_1_N = mkN "fylleriförseelse" "fylleriförseelser" ;
  fyrbackslinje_nn_1_N = mkN "fyrbackslinje" "fyrbackslinjer" ;
  fyrkant_nn_1_N = mkN "fyrkant" "fyrkanter" ;
  fyrkaraktaer_nn_1_1_N = mkN "fyrkaraktär" "fyrkaraktärer" ;
  fysikvetenskap_nn_1_N = mkN "fysikvetenskap" "fysikvetenskaper" ;
  fysiokrat_nn_1_N = mkN "fysiokrat" "fysiokrater" ;
  faedernestad_nn_1_1_N = mkN "fädernestad" "fädernestäder" ;
  faeltassistent_nn_1_1_N = mkN "fältassistent" "fältassistenter" ;
  faeltspat_nn_1_1_N = mkN "fältspat" "fältspater" ;
  faengelsecell_nn_1_1_N = mkN "fängelsecell" "fängelseceller" ;
  faengelsekund_nn_1_1_N = mkN "fängelsekund" "fängelsekunder" ;
  faerd_nn_1_1_N = mkN "färd" "färder" ;
  faerdbiljett_nn_1_1_N = mkN "färdbiljett" "färdbiljetter" ;
  faergsprutpistol_nn_1_1_N = mkN "färgsprutpistol" "färgsprutpistoler" ;
  faergstoff_nn_1_1_N = mkN "färgstoff" "färgstoffer" ;
  faerskmalm_nn_1_1_N = mkN "färskmalm" "färskmalmer" ;
  faesoer_nn_1_1_N = mkN "fäsör" "fäsörer" ;
  faarfiol_nn_1_1_N = mkN "fårfiol" "fårfioler" ;
  faat_nn_1_1_N = mkN "fåt" "fåter" ;
  faatoelj_nn_1_1_N = mkN "fåtölj" "fåtöljer" ;
  foedelse_nn_1_1_N = mkN "födelse" "födelser" ;
  foedelsekontroll_nn_1_1_N = mkN "födelsekontroll" "födelsekontroller" ;
  foedelsestad_nn_1_1_N = mkN "födelsestad" "födelsestäder" ;
  foeljetong_nn_1_1_N = mkN "följetong" "följetonger" ;
  foerarhytt_nn_1_1_N = mkN "förarhytt" "förarhytter" ;
  foerbannelse_nn_1_1_N = mkN "förbannelse" "förbannelser" ;
  foerberedelse_nn_1_1_N = mkN "förberedelse" "förberedelser" ;
  foerbindelse_nn_1_1_N = mkN "förbindelse" "förbindelser" ;
  foerbindelselinje_nn_1_1_N = mkN "förbindelselinje" "förbindelselinjer" ;
  foerbrytelse_nn_1_1_N = mkN "förbrytelse" "förbrytelser" ;
  foerbundskapten_nn_1_1_N = mkN "förbundskapten" "förbundskaptener" ;
  foerbundspresident_nn_1_1_N = mkN "förbundspresident" "förbundspresidenter" ;
  foerbundsrepublik_nn_1_1_N = mkN "förbundsrepublik" "förbundsrepubliker" ;
  foerbundsstyrelse_nn_1_1_N = mkN "förbundsstyrelse" "förbundsstyrelser" ;
  foerebraaelse_nn_1_1_N = mkN "förebråelse" "förebråelser" ;
  foereningsbank_nn_1_1_N = mkN "föreningsbank" "föreningsbanker" ;
  foereningslokal_nn_1_1_N = mkN "föreningslokal" "föreningslokaler" ;
  foereningsmaengd_nn_1_1_N = mkN "föreningsmängd" "föreningsmängder" ;
  foereningsroerelse_nn_1_1_N = mkN "föreningsrörelse" "föreningsrörelser" ;
  foeretagsfilial_nn_1_1_N = mkN "företagsfilial" "företagsfilialer" ;
  foeretagsstyrelse_nn_1_1_N = mkN "företagsstyrelse" "företagsstyrelser" ;
  foereteelse_nn_1_1_N = mkN "företeelse" "företeelser" ;
  foerfoeljelse_nn_1_1_N = mkN "förföljelse" "förföljelser" ;
  foerfoerelse_nn_1_1_N = mkN "förförelse" "förförelser" ;
  foergripelse_nn_1_1_N = mkN "förgripelse" "förgripelser" ;
  foergrund_nn_1_1_N = mkN "förgrund" "förgrunder" ;
  foergrundsgestalt_nn_1_1_N = mkN "förgrundsgestalt" "förgrundsgestalter" ;
  foerhand_nn_1_1_N = mkN "förhand" "förhänder" ;
  foerhandlingsmodell_nn_1_1_N = mkN "förhandlingsmodell" "förhandlingsmodeller" ;
  foerhandsbukt_nn_1_1_N = mkN "förhandsbukt" "förhandsbukter" ;
  foerklaringsmodell_nn_1_1_N = mkN "förklaringsmodell" "förklaringsmodeller" ;
  foerkrigstid_nn_1_1_N = mkN "förkrigstid" "förkrigstider" ;
  foerkunnelse_nn_1_1_N = mkN "förkunnelse" "förkunnelser" ;
  foerlossningsklinik_nn_1_1_N = mkN "förlossningsklinik" "förlossningskliniker" ;
  foerlossningstaang_nn_1_1_N = mkN "förlossningstång" "förlossningstänger" ;
  foerlustelse_nn_1_1_N = mkN "förlustelse" "förlustelser" ;
  foerlaat_nn_1_1_N = mkN "förlåt" "förlåter" ;
  foermaan_nn_1_1_N = mkN "förmån" "förmåner" ;
  foermoerkelse_nn_1_1_N = mkN "förmörkelse" "förmörkelser" ;
  foernatt_nn_1_1_N = mkN "förnatt" "förnätter" ;
  foernekelse_nn_1_1_N = mkN "förnekelse" "förnekelser" ;
  foernimmelse_nn_1_1_N = mkN "förnimmelse" "förnimmelser" ;
  foernyelse_nn_1_1_N = mkN "förnyelse" "förnyelser" ;
  foernaermelse_nn_1_1_N = mkN "förnärmelse" "förnärmelser" ;
  foernoejelse_nn_1_1_N = mkN "förnöjelse" "förnöjelser" ;
  foerpatrull_nn_1_1_N = mkN "förpatrull" "förpatruller" ;
  foerpliktelse_nn_1_1_N = mkN "förpliktelse" "förpliktelser" ;
  foersakelse_nn_1_1_N = mkN "försakelse" "försakelser" ;
  foersamlingsassistent_nn_1_1_N = mkN "församlingsassistent" "församlingsassistenter" ;
  foerseelse_nn_1_1_N = mkN "förseelse" "förseelser" ;
  foerskraeckelse_nn_1_1_N = mkN "förskräckelse" "förskräckelser" ;
  foerstad_nn_1_1_N = mkN "förstad" "förstäder" ;
  foerstaklassbiljett_nn_1_1_N = mkN "förstaklassbiljett" "förstaklassbiljetter" ;
  foerstaklasshytt_nn_1_1_N = mkN "förstaklasshytt" "förstaklasshytter" ;
  foerstavelse_nn_1_1_N = mkN "förstavelse" "förstavelser" ;
  foerstoringsapparat_nn_1_1_N = mkN "förstoringsapparat" "förstoringsapparater" ;
  foerstroeelse_nn_1_1_N = mkN "förströelse" "förströelser" ;
  foerstudie_nn_1_1_N = mkN "förstudie" "förstudier" ;
  foerstaang_nn_1_1_N = mkN "förstång" "förstänger" ;
  foerstoerelse_nn_1_1_N = mkN "förstörelse" "förstörelser" ;
  foersummelse_nn_1_1_N = mkN "försummelse" "försummelser" ;
  foersvarskraft_nn_1_1_N = mkN "försvarskraft" "försvarskrafter" ;
  foersvarslinje_nn_1_1_N = mkN "försvarslinje" "försvarslinjer" ;
  foersyndelse_nn_1_1_N = mkN "försyndelse" "försyndelser" ;
  foersaekringsagent_nn_1_1_N = mkN "försäkringsagent" "försäkringsagenter" ;
  foersaekringspremie_nn_1_1_N = mkN "försäkringspremie" "försäkringspremier" ;
  foersaendelse_nn_1_1_N = mkN "försändelse" "försändelser" ;
  foersoeksballong_nn_1_1_N = mkN "försöksballong" "försöksballonger" ;
  foertidsboerd_nn_1_1_N = mkN "förtidsbörd" "förtidsbörder" ;
  foertrupp_nn_1_1_N = mkN "förtrupp" "förtrupper" ;
  foerutbestaemmelse_nn_1_1_N = mkN "förutbestämmelse" "förutbestämmelser" ;
  foerutsaegelse_nn_1_1_N = mkN "förutsägelse" "förutsägelser" ;
  foervaltningsberaettelse_nn_1_1_N = mkN "förvaltningsberättelse" "förvaltningsberättelser" ;
  foervillelse_nn_1_1_N = mkN "förvillelse" "förvillelser" ;
  foeraeldrafoermaan_nn_1_1_N = mkN "föräldraförmån" "föräldraförmåner" ;
  foeraelskelse_nn_1_1_N = mkN "förälskelse" "förälskelser" ;
  foeraendringstakt_nn_1_1_N = mkN "förändringstakt" "förändringstakter" ;
  foeroedelse_nn_1_1_N = mkN "förödelse" "förödelser" ;
  foeroedmjukelse_nn_1_1_N = mkN "förödmjukelse" "förödmjukelser" ;
  g_klav_nn_1_N = mkN "g-klav" "g-klaver" ;
  gaffelantilop_nn_1_N = mkN "gaffelantilop" "gaffelantiloper" ;
  gaffelklo_nn_1_N = mkN "gaffelklo" "gaffelklor" ;
  gagat_nn_1_N = mkN "gagat" "gagater" ;
  gaillarde_nn_1_N = mkN "gaillarde" "gaillarder" ;
  galat_nn_1_N = mkN "galat" "galater" ;
  galenskap_nn_1_N = mkN "galenskap" "galenskaper" ;
  gall_nn_1_N = mkN "gall" "galler" ;
  gallko_nn_1_N = mkN "gallko" "gallkor" ;
  galvanotyp_nn_1_N = mkN "galvanotyp" "galvanotyper" ;
  galaer_nn_1_1_N = mkN "galär" "galärer" ;
  gamet_nn_1_N = mkN "gamet" "gameter" ;
  gammaglobulin_nn_1_N = mkN "gammaglobulin" "gammaglobuliner" ;
  gamaeng_nn_1_1_N = mkN "gamäng" "gamänger" ;
  ganymed_nn_1_N = mkN "ganymed" "ganymeder" ;
  gard_nn_1_N = mkN "gard" "garder" ;
  garderob_nn_1_N = mkN "garderob" "garderober" ;
  garderobiaer_nn_1_1_N = mkN "garderobiär" "garderobiärer" ;
  garderobsstaang_nn_1_1_N = mkN "garderobsstång" "garderobsstänger" ;
  gardinstaang_nn_1_1_N = mkN "gardinstång" "gardinstänger" ;
  garnison_nn_1_N = mkN "garnison" "garnisoner" ;
  garsong_nn_1_N = mkN "garsong" "garsonger" ;
  gas_nn_2_N = mkN "gas" "gaser" ;
  gasett_nn_1_N = mkN "gasett" "gasetter" ;
  gaskromatograf_nn_1_N = mkN "gaskromatograf" "gaskromatografer" ;
  gasoltub_nn_1_N = mkN "gasoltub" "gasoltuber" ;
  gastronom_nn_1_N = mkN "gastronom" "gastronomer" ;
  gasventil_nn_1_N = mkN "gasventil" "gasventiler" ;
  gatumusikant_nn_1_N = mkN "gatumusikant" "gatumusikanter" ;
  gayal_nn_1_N = mkN "gayal" "gayaler" ;
  gecko_nn_1_N = mkN "gecko" "geckor" ;
  gejd_nn_1_N = mkN "gejd" "gejder" ;
  gel_e_nn_1_1_N = mkN "gelé" "geléer" ;
  gemaal_nn_1_1_N = mkN "gemål" "gemåler" ;
  gendarm_nn_1_N = mkN "gendarm" "gendarmer" ;
  genealog_nn_1_N = mkN "genealog" "genealoger" ;
  general_nn_1_N = mkN "general" "generaler" ;
  generalagent_nn_1_N = mkN "generalagent" "generalagenter" ;
  generalloejtnant_nn_1_1_N = mkN "generallöjtnant" "generallöjtnanter" ;
  generalsperson_nn_1_N = mkN "generalsperson" "generalspersoner" ;
  genett_nn_1_N = mkN "genett" "genetter" ;
  genie_nn_1_N = mkN "genie" "genier" ;
  genmanipulationsteknik_nn_1_N = mkN "genmanipulationsteknik" "genmanipulationstekniker" ;
  genomfart_nn_1_N = mkN "genomfart" "genomfarter" ;
  genre_nn_1_N = mkN "genre" "genrer" ;
  gensaegelse_nn_1_1_N = mkN "gensägelse" "gensägelser" ;
  geodet_nn_1_N = mkN "geodet" "geodeter" ;
  geograf_nn_1_N = mkN "geograf" "geografer" ;
  geosynklinal_nn_1_N = mkN "geosynklinal" "geosynklinaler" ;
  gepard_nn_1_N = mkN "gepard" "geparder" ;
  geridong_nn_1_N = mkN "geridong" "geridonger" ;
  gerillaroerelse_nn_1_1_N = mkN "gerillarörelse" "gerillarörelser" ;
  gestalt_nn_1_N = mkN "gestalt" "gestalter" ;
  gesaell_nn_1_1_N = mkN "gesäll" "gesäller" ;
  gevaersgranat_nn_1_1_N = mkN "gevärsgranat" "gevärsgranater" ;
  gevaerspatron_nn_1_1_N = mkN "gevärspatron" "gevärspatroner" ;
  ghasel_nn_1_N = mkN "ghasel" "ghaseler" ;
  giftapparat_nn_1_N = mkN "giftapparat" "giftapparater" ;
  giftinformationscentral_nn_1_N = mkN "giftinformationscentral" "giftinformationscentraler" ;
  gifttand_nn_1_N = mkN "gifttand" "gifttänder" ;
  gigue_nn_1_N = mkN "gigue" "giguer" ;
  ginstkatt_nn_1_N = mkN "ginstkatt" "ginstkatter" ;
  gips_nn_1_N = mkN "gips" "gipser" ;
  gipyr_nn_1_N = mkN "gipyr" "gipyrer" ;
  giraff_nn_1_N = mkN "giraff" "giraffer" ;
  girandole_nn_1_N = mkN "girandole" "girandoler" ;
  gitarr_nn_1_N = mkN "gitarr" "gitarrer" ;
  givakt_nn_1_N = mkN "givakt" "givakter" ;
  gjutmodell_nn_1_N = mkN "gjutmodell" "gjutmodeller" ;
  gjutrand_nn_1_N = mkN "gjutrand" "gjutränder" ;
  glacialperiod_nn_1_N = mkN "glacialperiod" "glacialperioder" ;
  glansperiod_nn_1_N = mkN "glansperiod" "glansperioder" ;
  glansroll_nn_1_N = mkN "glansroll" "glansroller" ;
  glanstid_nn_1_N = mkN "glanstid" "glanstider" ;
  glassdessert_nn_1_N = mkN "glassdessert" "glassdesserter" ;
  glassmaskin_nn_1_N = mkN "glassmaskin" "glassmaskiner" ;
  glasyr_nn_1_N = mkN "glasyr" "glasyrer" ;
  glesbygd_nn_1_N = mkN "glesbygd" "glesbygder" ;
  glidkraem_nn_1_1_N = mkN "glidkräm" "glidkrämer" ;
  globulin_nn_1_N = mkN "globulin" "globuliner" ;
  glossematik_nn_1_N = mkN "glossematik" "glossematiker" ;
  glaedjebetygelse_nn_1_1_N = mkN "glädjebetygelse" "glädjebetygelser" ;
  gloedkatod_nn_1_1_N = mkN "glödkatod" "glödkatoder" ;
  gnagtand_nn_1_N = mkN "gnagtand" "gnagtänder" ;
  gobelaeng_nn_1_1_N = mkN "gobeläng" "gobelänger" ;
  godvikt_nn_1_N = mkN "godvikt" "godvikter" ;
  golf_nn_2_N = mkN "golf" "golfer" ;
  golgiapparat_nn_1_N = mkN "golgiapparat" "golgiapparater" ;
  golvramp_nn_1_N = mkN "golvramp" "golvramper" ;
  gonad_nn_1_N = mkN "gonad" "gonader" ;
  gondoljaer_nn_1_1_N = mkN "gondoljär" "gondoljärer" ;
  gonfaloniaer_nn_1_1_N = mkN "gonfaloniär" "gonfaloniärer" ;
  gonokock_nn_1_N = mkN "gonokock" "gonokocker" ;
  gottgoerelse_nn_1_1_N = mkN "gottgörelse" "gottgörelser" ;
  gouache_nn_1_N = mkN "gouache" "gouacher" ;
  gourmand_nn_1_N = mkN "gourmand" "gourmander" ;
  gourmet_nn_1_N = mkN "gourmet" "gourmeter" ;
  grace_nn_1_N = mkN "grace" "gracer" ;
  gradient_nn_1_N = mkN "gradient" "gradienter" ;
  gradualpsalm_nn_1_N = mkN "gradualpsalm" "gradualpsalmer" ;
  granat_nn_1_N = mkN "granat" "granater" ;
  granatchock_nn_1_N = mkN "granatchock" "granatchocker" ;
  granataepplejuice_nn_1_1_N = mkN "granatäpplejuice" "granatäpplejuicer" ;
  grand_nn_2_N = mkN "grand" "grander" ;
  grandseigneur_nn_1_N = mkN "grandseigneur" "grandseigneurer" ;
  grangirlang_nn_1_N = mkN "grangirlang" "grangirlanger" ;
  grannlaat_nn_1_1_N = mkN "grannlåt" "grannlåter" ;
  grapefrukt_nn_1_N = mkN "grapefrukt" "grapefrukter" ;
  gratial_nn_1_N = mkN "gratial" "gratialer" ;
  gratie_nn_1_N = mkN "gratie" "gratier" ;
  gratisaktie_nn_1_N = mkN "gratisaktie" "gratisaktier" ;
  gravand_nn_1_N = mkN "gravand" "gravänder" ;
  gravitationskraft_nn_1_N = mkN "gravitationskraft" "gravitationskrafter" ;
  gravrelief_nn_1_N = mkN "gravrelief" "gravreliefer" ;
  gravsed_nn_1_N = mkN "gravsed" "gravseder" ;
  gravoer_nn_1_1_N = mkN "gravör" "gravörer" ;
  green_nn_1_N = mkN "green" "greener" ;
  grek_nn_1_N = mkN "grek" "greker" ;
  grekcypriot_nn_1_N = mkN "grekcypriot" "grekcyprioter" ;
  grenadin_nn_1_N = mkN "grenadin" "grenadiner" ;
  grenadjaer_nn_1_1_N = mkN "grenadjär" "grenadjärer" ;
  grift_nn_1_N = mkN "grift" "grifter" ;
  grisaille_nn_1_N = mkN "grisaille" "grisailler" ;
  grisbonde_nn_1_N = mkN "grisbonde" "grisbönder" ;
  grisett_nn_1_N = mkN "grisett" "grisetter" ;
  grisinsulin_nn_1_N = mkN "grisinsulin" "grisinsuliner" ;
  grogrund_nn_1_N = mkN "grogrund" "grogrunder" ;
  grossoer_nn_1_1_N = mkN "grossör" "grossörer" ;
  grund_nn_1_N = mkN "grund" "grunder" ;
  grundbetydelse_nn_1_N = mkN "grundbetydelse" "grundbetydelser" ;
  grundkaraktaer_nn_1_1_N = mkN "grundkaraktär" "grundkaraktärer" ;
  grundkraft_nn_1_N = mkN "grundkraft" "grundkrafter" ;
  grundlinje_nn_1_N = mkN "grundlinje" "grundlinjer" ;
  grundperiod_nn_1_N = mkN "grundperiod" "grundperioder" ;
  grustaekt_nn_1_1_N = mkN "grustäkt" "grustäkter" ;
  gruvdrift_nn_1_N = mkN "gruvdrift" "gruvdrifter" ;
  graeddbakelse_nn_1_1_N = mkN "gräddbakelse" "gräddbakelser" ;
  graemelse_nn_1_1_N = mkN "grämelse" "grämelser" ;
  graend_nn_1_1_N = mkN "gränd" "gränder" ;
  graensbo_nn_1_1_N = mkN "gränsbo" "gränsbor" ;
  graensintaekt_nn_1_1_N = mkN "gränsintäkt" "gränsintäkter" ;
  graenslinje_nn_1_1_N = mkN "gränslinje" "gränslinjer" ;
  graensstad_nn_1_1_N = mkN "gränsstad" "gränsstäder" ;
  graenstrakt_nn_1_1_N = mkN "gränstrakt" "gränstrakter" ;
  graesand_nn_1_1_N = mkN "gräsand" "gräsänder" ;
  graabo_nn_1_1_N = mkN "gråbo" "gråbor" ;
  guatemaltek_nn_1_N = mkN "guatemaltek" "guatemalteker" ;
  guckusko_nn_1_N = mkN "guckusko" "guckuskor" ;
  gudsfoernekelse_nn_1_1_N = mkN "gudsförnekelse" "gudsförnekelser" ;
  gudson_nn_1_N = mkN "gudson" "gudsöner" ;
  gudstjaenstlokal_nn_1_1_N = mkN "gudstjänstlokal" "gudstjänstlokaler" ;
  gudsupplevelse_nn_1_N = mkN "gudsupplevelse" "gudsupplevelser" ;
  guide_nn_1_N = mkN "guide" "guider" ;
  guldbarr_nn_1_N = mkN "guldbarr" "guldbarrer" ;
  guldberlock_nn_1_N = mkN "guldberlock" "guldberlocker" ;
  guldmedalj_nn_1_N = mkN "guldmedalj" "guldmedaljer" ;
  guldmedaljoer_nn_1_1_N = mkN "guldmedaljör" "guldmedaljörer" ;
  guldreserv_nn_1_N = mkN "guldreserv" "guldreserver" ;
  guldtand_nn_1_N = mkN "guldtand" "guldtänder" ;
  gummiparagraf_nn_1_N = mkN "gummiparagraf" "gummiparagrafer" ;
  gummiplantage_nn_1_N = mkN "gummiplantage" "gummiplantager" ;
  gustavadolfsbakelse_nn_1_N = mkN "gustavadolfsbakelse" "gustavadolfsbakelser" ;
  gymnasielinje_nn_1_N = mkN "gymnasielinje" "gymnasielinjer" ;
  gymnastiksko_nn_1_N = mkN "gymnastiksko" "gymnastikskor" ;
  gymnosperm_nn_1_N = mkN "gymnosperm" "gymnospermer" ;
  gympasko_nn_1_N = mkN "gympasko" "gympaskor" ;
  gyrohorisont_nn_1_N = mkN "gyrohorisont" "gyrohorisonter" ;
  gaeldenaer_nn_1_1_N = mkN "gäldenär" "gäldenärer" ;
  gaerd_nn_1_1_N = mkN "gärd" "gärder" ;
  gaerningsmannaprofil_nn_1_1_N = mkN "gärningsmannaprofil" "gärningsmannaprofiler" ;
  gaestnatt_nn_1_1_N = mkN "gästnatt" "gästnätter" ;
  gaabortskostym_nn_1_1_N = mkN "gåbortskostym" "gåbortskostymer" ;
  gaangart_nn_1_1_N = mkN "gångart" "gångarter" ;
  gaangbergart_nn_1_1_N = mkN "gångbergart" "gångbergarter" ;
  gaanggrift_nn_1_1_N = mkN "gånggrift" "gånggrifter" ;
  gaangtrafikant_nn_1_1_N = mkN "gångtrafikant" "gångtrafikanter" ;
  gaardsmusikant_nn_1_1_N = mkN "gårdsmusikant" "gårdsmusikanter" ;
  gaardstomt_nn_1_1_N = mkN "gårdstomt" "gårdstomter" ;
  goedselstad_nn_1_1_N = mkN "gödselstad" "gödselstäder" ;
  hallonsaft_nn_1_N = mkN "hallonsaft" "hallonsafter" ;
  hallonsylt_nn_1_N = mkN "hallonsylt" "hallonsylter" ;
  haloeffekt_nn_1_N = mkN "haloeffekt" "haloeffekter" ;
  halogen_nn_1_N = mkN "halogen" "halogener" ;
  halsboeld_nn_1_1_N = mkN "halsböld" "halsbölder" ;
  halstablett_nn_1_N = mkN "halstablett" "halstabletter" ;
  halvkolonn_nn_1_N = mkN "halvkolonn" "halvkolonner" ;
  halvkonserv_nn_1_N = mkN "halvkonserv" "halvkonserver" ;
  halvmesyr_nn_1_N = mkN "halvmesyr" "halvmesyrer" ;
  halvmetall_nn_1_N = mkN "halvmetall" "halvmetaller" ;
  halvnot_nn_1_N = mkN "halvnot" "halvnoter" ;
  halvpart_nn_1_N = mkN "halvpart" "halvparter" ;
  halvprofil_nn_1_N = mkN "halvprofil" "halvprofiler" ;
  halvvokal_nn_1_N = mkN "halvvokal" "halvvokaler" ;
  hamnbassaeng_nn_1_1_N = mkN "hamnbassäng" "hamnbassänger" ;
  hamnkapten_nn_1_N = mkN "hamnkapten" "hamnkaptener" ;
  hamnstad_nn_1_N = mkN "hamnstad" "hamnstäder" ;
  hamnstyrelse_nn_1_N = mkN "hamnstyrelse" "hamnstyrelser" ;
  hand_nn_1_N = mkN "hand" "händer" ;
  handelsbank_nn_1_N = mkN "handelsbank" "handelsbanker" ;
  handelsstad_nn_1_N = mkN "handelsstad" "handelsstäder" ;
  handgranat_nn_1_N = mkN "handgranat" "handgranater" ;
  handroerelse_nn_1_1_N = mkN "handrörelse" "handrörelser" ;
  handvolt_nn_1_N = mkN "handvolt" "handvolter" ;
  hangar_nn_1_N = mkN "hangar" "hangarer" ;
  haptoglobin_nn_1_N = mkN "haptoglobin" "haptoglobiner" ;
  harang_nn_1_N = mkN "harang" "haranger" ;
  harpun_nn_1_N = mkN "harpun" "harpuner" ;
  hartsfiol_nn_1_N = mkN "hartsfiol" "hartsfioler" ;
  haschcigarett_nn_1_N = mkN "haschcigarett" "haschcigaretter" ;
  hausse_nn_1_N = mkN "hausse" "hausser" ;
  havskatt_nn_1_N = mkN "havskatt" "havskatter" ;
  havsnymf_nn_1_N = mkN "havsnymf" "havsnymfer" ;
  havsstrand_nn_1_N = mkN "havsstrand" "havsstränder" ;
  hedersbetygelse_nn_1_N = mkN "hedersbetygelse" "hedersbetygelser" ;
  hedersledamot_nn_1_N = mkN "hedersledamot" "hedersledamöter" ;
  hedersmedalj_nn_1_N = mkN "hedersmedalj" "hedersmedaljer" ;
  hedersskuld_nn_1_N = mkN "hedersskuld" "hedersskulder" ;
  hedersutmaerkelse_nn_1_1_N = mkN "hedersutmärkelse" "hedersutmärkelser" ;
  hekatomb_nn_1_N = mkN "hekatomb" "hekatomber" ;
  hektograf_nn_1_N = mkN "hektograf" "hektografer" ;
  helbraegdagoerelse_nn_1_1_N = mkN "helbrägdagörelse" "helbrägdagörelser" ;
  helg_nn_1_N = mkN "helg" "helger" ;
  helgonkult_nn_1_N = mkN "helgonkult" "helgonkulter" ;
  helhetssyn_nn_1_N = mkN "helhetssyn" "helhetssyner" ;
  helikopterpilot_nn_1_N = mkN "helikopterpilot" "helikopterpiloter" ;
  heliograf_nn_1_N = mkN "heliograf" "heliografer" ;
  heliostat_nn_1_N = mkN "heliostat" "heliostater" ;
  heliotrop_nn_1_N = mkN "heliotrop" "heliotroper" ;
  helkonserv_nn_1_N = mkN "helkonserv" "helkonserver" ;
  hellen_nn_1_N = mkN "hellen" "hellener" ;
  helnot_nn_1_N = mkN "helnot" "helnoter" ;
  helvetesmaskin_nn_1_N = mkN "helvetesmaskin" "helvetesmaskiner" ;
  helaakersbygd_nn_1_1_N = mkN "helåkersbygd" "helåkersbygder" ;
  hembygd_nn_1_N = mkN "hembygd" "hembygder" ;
  hemgift_nn_1_N = mkN "hemgift" "hemgifter" ;
  hemisfaer_nn_1_1_N = mkN "hemisfär" "hemisfärer" ;
  hemkonsulent_nn_1_N = mkN "hemkonsulent" "hemkonsulenter" ;
  hemmason_nn_1_N = mkN "hemmason" "hemmasöner" ;
  hemoglobin_nn_1_N = mkN "hemoglobin" "hemoglobiner" ;
  hemstad_nn_1_N = mkN "hemstad" "hemstäder" ;
  hemsoekelse_nn_1_1_N = mkN "hemsökelse" "hemsökelser" ;
  hemtrakt_nn_1_N = mkN "hemtrakt" "hemtrakter" ;
  heparin_nn_1_N = mkN "heparin" "hepariner" ;
  herdefloejt_nn_1_1_N = mkN "herdeflöjt" "herdeflöjter" ;
  herdestund_nn_1_N = mkN "herdestund" "herdestunder" ;
  herm_nn_1_N = mkN "herm" "hermer" ;
  heroin_nn_1_N = mkN "heroin" "heroiner" ;
  herrsko_nn_1_N = mkN "herrsko" "herrskor" ;
  herrtoalett_nn_1_N = mkN "herrtoalett" "herrtoaletter" ;
  hetaer_nn_1_1_N = mkN "hetär" "hetärer" ;
  hieroglyf_nn_1_N = mkN "hieroglyf" "hieroglyfer" ;
  hillebard_nn_1_N = mkN "hillebard" "hillebarder" ;
  himmelspol_nn_1_N = mkN "himmelspol" "himmelspoler" ;
  himmelssfaer_nn_1_1_N = mkN "himmelssfär" "himmelssfärer" ;
  hippodrom_nn_1_N = mkN "hippodrom" "hippodromer" ;
  hird_nn_1_N = mkN "hird" "hirder" ;
  historiett_nn_1_N = mkN "historiett" "historietter" ;
  historik_nn_1_N = mkN "historik" "historiker" ;
  historiograf_nn_1_N = mkN "historiograf" "historiografer" ;
  hitteloen_nn_1_1_N = mkN "hittelön" "hittelöner" ;
  hjortronsylt_nn_1_N = mkN "hjortronsylt" "hjortronsylter" ;
  hjaelplinje_nn_1_1_N = mkN "hjälplinje" "hjälplinjer" ;
  hjaelptrupp_nn_1_1_N = mkN "hjälptrupp" "hjälptrupper" ;
  hjaeltbragd_nn_1_1_N = mkN "hjältbragd" "hjältbragder" ;
  hjaeltebragd_nn_1_1_N = mkN "hjältebragd" "hjältebragder" ;
  hjaerntumoer_nn_1_1_N = mkN "hjärntumör" "hjärntumörer" ;
  hjaertattack_nn_1_1_N = mkN "hjärtattack" "hjärtattacker" ;
  hjaertinfarkt_nn_1_1_N = mkN "hjärtinfarkt" "hjärtinfarkter" ;
  hjaertkramp_nn_1_1_N = mkN "hjärtkramp" "hjärtkramper" ;
  hjaertlungmaskin_nn_1_1_N = mkN "hjärtlungmaskin" "hjärtlungmaskiner" ;
  hjaertpunkt_nn_1_1_N = mkN "hjärtpunkt" "hjärtpunkter" ;
  homeopat_nn_1_N = mkN "homeopat" "homeopater" ;
  homilet_nn_1_N = mkN "homilet" "homileter" ;
  homofil_nn_1_N = mkN "homofil" "homofiler" ;
  honnoer_nn_1_1_N = mkN "honnör" "honnörer" ;
  hord_nn_1_N = mkN "hord" "horder" ;
  horisont_nn_1_N = mkN "horisont" "horisonter" ;
  horisontlinje_nn_1_N = mkN "horisontlinje" "horisontlinjer" ;
  horroer_nn_1_1_N = mkN "horrör" "horrörer" ;
  hortonom_nn_1_N = mkN "hortonom" "hortonomer" ;
  hotellbrand_nn_1_N = mkN "hotellbrand" "hotellbränder" ;
  hotelse_nn_1_N = mkN "hotelse" "hotelser" ;
  hottentott_nn_1_N = mkN "hottentott" "hottentotter" ;
  hovbetjaent_nn_1_1_N = mkN "hovbetjänt" "hovbetjänter" ;
  hovraettspresident_nn_1_1_N = mkN "hovrättspresident" "hovrättspresidenter" ;
  hovstat_nn_1_N = mkN "hovstat" "hovstater" ;
  hovtaang_nn_1_1_N = mkN "hovtång" "hovtänger" ;
  hudkraem_nn_1_1_N = mkN "hudkräm" "hudkrämer" ;
  hugenott_nn_1_N = mkN "hugenott" "hugenotter" ;
  huggtand_nn_1_N = mkN "huggtand" "huggtänder" ;
  humuskomponent_nn_1_N = mkN "humuskomponent" "humuskomponenter" ;
  hunddressyr_nn_1_N = mkN "hunddressyr" "hunddressyrer" ;
  hundpatrull_nn_1_N = mkN "hundpatrull" "hundpatruller" ;
  hundraaarsperiod_nn_1_1_N = mkN "hundraårsperiod" "hundraårsperioder" ;
  husandakt_nn_1_N = mkN "husandakt" "husandakter" ;
  husar_nn_1_N = mkN "husar" "husarer" ;
  husbonde_nn_1_N = mkN "husbonde" "husbönder" ;
  husesyn_nn_1_N = mkN "husesyn" "husesyner" ;
  hushaallsassistent_nn_1_1_N = mkN "hushållsassistent" "hushållsassistenter" ;
  huskur_nn_1_N = mkN "huskur" "huskurer" ;
  hustyrann_nn_1_N = mkN "hustyrann" "hustyranner" ;
  huvudgaerd_nn_1_1_N = mkN "huvudgärd" "huvudgärder" ;
  huvudlinje_nn_1_N = mkN "huvudlinje" "huvudlinjer" ;
  huvudroerelse_nn_1_1_N = mkN "huvudrörelse" "huvudrörelser" ;
  huvudstad_nn_1_N = mkN "huvudstad" "huvudstäder" ;
  huvudvaerkstablett_nn_1_1_N = mkN "huvudvärkstablett" "huvudvärkstabletter" ;
  hyacint_nn_1_N = mkN "hyacint" "hyacinter" ;
  hydrofyt_nn_1_N = mkN "hydrofyt" "hydrofyter" ;
  hyf_nn_1_N = mkN "hyf" "hyfer" ;
  hygrograf_nn_1_N = mkN "hygrograf" "hygrografer" ;
  hymn_nn_1_N = mkN "hymn" "hymner" ;
  hypnotisoer_nn_1_1_N = mkN "hypnotisör" "hypnotisörer" ;
  hyresbostad_nn_1_N = mkN "hyresbostad" "hyresbostäder" ;
  hyreskasern_nn_1_N = mkN "hyreskasern" "hyreskaserner" ;
  hytt_nn_1_N = mkN "hytt" "hytter" ;
  haedanfaerd_nn_1_1_N = mkN "hädanfärd" "hädanfärder" ;
  haedelse_nn_1_1_N = mkN "hädelse" "hädelser" ;
  haeftapparat_nn_1_1_N = mkN "häftapparat" "häftapparater" ;
  haelft_nn_1_1_N = mkN "hälft" "hälfter" ;
  haelsoeffekt_nn_1_1_N = mkN "hälsoeffekt" "hälsoeffekter" ;
  haemsko_nn_1_1_N = mkN "hämsko" "hämskor" ;
  haendelse_nn_1_1_N = mkN "händelse" "händelser" ;
  haenvaendelse_nn_1_1_N = mkN "hänvändelse" "hänvändelser" ;
  haerdlack_nn_1_1_N = mkN "härdlack" "härdlacker" ;
  haerold_nn_1_1_N = mkN "härold" "härolder" ;
  haestbonde_nn_1_1_N = mkN "hästbonde" "hästbönder" ;
  haestdressyr_nn_1_1_N = mkN "hästdressyr" "hästdressyrer" ;
  haestkraft_nn_1_1_N = mkN "hästkraft" "hästkrafter" ;
  haestkur_nn_1_1_N = mkN "hästkur" "hästkurer" ;
  haestlaengd_nn_1_1_N = mkN "hästlängd" "hästlängder" ;
  haestsko_nn_1_1_N = mkN "hästsko" "hästskor" ;
  haevd_nn_1_1_N = mkN "hävd" "hävder" ;
  haevstaang_nn_1_1_N = mkN "hävstång" "hävstänger" ;
  haexfoerfoeljelse_nn_1_1_N = mkN "häxförföljelse" "häxförföljelser" ;
  haexsabbat_nn_1_1_N = mkN "häxsabbat" "häxsabbater" ;
  haalven_nn_1_1_N = mkN "hålven" "hålvener" ;
  haardmetall_nn_1_1_N = mkN "hårdmetall" "hårdmetaller" ;
  haarplattaang_nn_1_1_N = mkN "hårplattång" "hårplattänger" ;
  hoeft_nn_1_1_N = mkN "höft" "höfter" ;
  hoeftlinje_nn_1_1_N = mkN "höftlinje" "höftlinjer" ;
  hoegerhand_nn_1_1_N = mkN "högerhand" "högerhänder" ;
  hoeghastighetslinje_nn_1_1_N = mkN "höghastighetslinje" "höghastighetslinjer" ;
  hoegrelief_nn_1_1_N = mkN "högrelief" "högreliefer" ;
  hoegskoleadjunkt_nn_1_1_N = mkN "högskoleadjunkt" "högskoleadjunkter" ;
  hoegskoleguide_nn_1_1_N = mkN "högskoleguide" "högskoleguider" ;
  hoegslaett_nn_1_1_N = mkN "högslätt" "högslätter" ;
  hoegtid_nn_1_1_N = mkN "högtid" "högtider" ;
  hoegtidsstund_nn_1_1_N = mkN "högtidsstund" "högtidsstunder" ;
  hoejdpunkt_nn_1_1_N = mkN "höjdpunkt" "höjdpunkter" ;
  hoeknatt_nn_1_1_N = mkN "höknatt" "höknätter" ;
  hoerapparat_nn_1_1_N = mkN "hörapparat" "hörapparater" ;
  hoerntand_nn_1_1_N = mkN "hörntand" "hörntänder" ;
  iakttagelse_nn_1_N = mkN "iakttagelse" "iakttagelser" ;
  icke_angreppspakt_nn_1_N = mkN "icke-angreppspakt" "icke-angreppspakter" ;
  icke_haendelse_nn_1_1_N = mkN "icke-händelse" "icke-händelser" ;
  icke_metall_nn_1_N = mkN "icke-metall" "icke-metaller" ;
  idiolekt_nn_1_N = mkN "idiolekt" "idiolekter" ;
  idiot_nn_1_N = mkN "idiot" "idioter" ;
  idrottsbragd_nn_1_N = mkN "idrottsbragd" "idrottsbragder" ;
  idrottsroerelse_nn_1_1_N = mkN "idrottsrörelse" "idrottsrörelser" ;
  idrottssko_nn_1_N = mkN "idrottssko" "idrottsskor" ;
  idyll_nn_1_N = mkN "idyll" "idyller" ;
  illustratoer_nn_1_1_N = mkN "illustratör" "illustratörer" ;
  imitatoer_nn_1_1_N = mkN "imitatör" "imitatörer" ;
  imperfektum_nn_1_N = mkN "imperfekt" "imperfekter" ;
  imperialoktav_nn_1_N = mkN "imperialoktav" "imperialoktaver" ;
  importoer_nn_1_1_N = mkN "importör" "importörer" ;
  improvisationsteknik_nn_1_N = mkN "improvisationsteknik" "improvisationstekniker" ;
  improvisatoer_nn_1_1_N = mkN "improvisatör" "improvisatörer" ;
  incident_nn_1_N = mkN "incident" "incidenter" ;
  independent_nn_1_N = mkN "independent" "independenter" ;
  induktionsapparat_nn_1_N = mkN "induktionsapparat" "induktionsapparater" ;
  industriaktie_nn_1_N = mkN "industriaktie" "industriaktier" ;
  industrilokal_nn_1_N = mkN "industrilokal" "industrilokaler" ;
  infarkt_nn_1_N = mkN "infarkt" "infarkter" ;
  infart_nn_1_N = mkN "infart" "infarter" ;
  infiltratoer_nn_1_1_N = mkN "infiltratör" "infiltratörer" ;
  inflationsmodell_nn_1_N = mkN "inflationsmodell" "inflationsmodeller" ;
  inflationsspiral_nn_1_N = mkN "inflationsspiral" "inflationsspiraler" ;
  inflationstakt_nn_1_N = mkN "inflationstakt" "inflationstakter" ;
  influensmaskin_nn_1_N = mkN "influensmaskin" "influensmaskiner" ;
  inflytelse_nn_1_N = mkN "inflytelse" "inflytelser" ;
  informatoer_nn_1_1_N = mkN "informatör" "informatörer" ;
  ingenjoerstrupp_nn_1_1_N = mkN "ingenjörstrupp" "ingenjörstrupper" ;
  ingivelse_nn_1_N = mkN "ingivelse" "ingivelser" ;
  ingaeld_nn_1_1_N = mkN "ingäld" "ingälder" ;
  ingaangspsalm_nn_1_1_N = mkN "ingångspsalm" "ingångspsalmer" ;
  initial_nn_1_N = mkN "initial" "initialer" ;
  injurie_nn_1_N = mkN "injurie" "injurier" ;
  inkallelse_nn_1_N = mkN "inkallelse" "inkallelser" ;
  inkubationstid_nn_1_N = mkN "inkubationstid" "inkubationstider" ;
  inkoerningsperiod_nn_1_1_N = mkN "inkörningsperiod" "inkörningsperioder" ;
  inlaerningsstudio_nn_1_1_N = mkN "inlärningsstudio" "inlärningsstudior" ;
  inneboerd_nn_1_1_N = mkN "innebörd" "innebörder" ;
  innegrej_nn_1_N = mkN "innegrej" "innegrejer" ;
  innehaallsoeversikt_nn_1_1_N = mkN "innehållsöversikt" "innehållsöversikter" ;
  innerstad_nn_1_N = mkN "innerstad" "innerstäder" ;
  innesko_nn_1_N = mkN "innesko" "inneskor" ;
  innovatoer_nn_1_1_N = mkN "innovatör" "innovatörer" ;
  inomhusvistelse_nn_1_N = mkN "inomhusvistelse" "inomhusvistelser" ;
  inredningsarkitekt_nn_1_N = mkN "inredningsarkitekt" "inredningsarkitekter" ;
  insikt_nn_1_N = mkN "insikt" "insikter" ;
  inskottsvokal_nn_1_N = mkN "inskottsvokal" "inskottsvokaler" ;
  inspelningsstudio_nn_1_N = mkN "inspelningsstudio" "inspelningsstudior" ;
  inspicient_nn_1_N = mkN "inspicient" "inspicienter" ;
  inspiratoer_nn_1_1_N = mkN "inspiratör" "inspiratörer" ;
  installatoer_nn_1_1_N = mkN "installatör" "installatörer" ;
  instiftelse_nn_1_N = mkN "instiftelse" "instiftelser" ;
  instinkt_nn_1_N = mkN "instinkt" "instinkter" ;
  instrumentpanel_nn_1_N = mkN "instrumentpanel" "instrumentpaneler" ;
  instaellelse_nn_1_1_N = mkN "inställelse" "inställelser" ;
  insugningsventil_nn_1_N = mkN "insugningsventil" "insugningsventiler" ;
  insulin_nn_1_N = mkN "insulin" "insuliner" ;
  insulinchock_nn_1_N = mkN "insulinchock" "insulinchocker" ;
  insurgent_nn_1_N = mkN "insurgent" "insurgenter" ;
  insaendarskribent_nn_1_1_N = mkN "insändarskribent" "insändarskribenter" ;
  integral_nn_1_N = mkN "integral" "integraler" ;
  integrand_nn_1_N = mkN "integrand" "integrander" ;
  integrationsdebatt_nn_1_N = mkN "integrationsdebatt" "integrationsdebatter" ;
  intelligensaristokrat_nn_1_N = mkN "intelligensaristokrat" "intelligensaristokrater" ;
  intendent_nn_1_N = mkN "intendent" "intendenter" ;
  intensiv_nn_1_N = mkN "intensiv" "intensiver" ;
  interdental_nn_1_N = mkN "interdental" "interdentaler" ;
  interglacial_nn_1_N = mkN "interglacial" "interglacialer" ;
  interimsstyrelse_nn_1_N = mkN "interimsstyrelse" "interimsstyrelser" ;
  interioer_nn_1_1_N = mkN "interiör" "interiörer" ;
  interlokutoer_nn_1_1_N = mkN "interlokutör" "interlokutörer" ;
  intern_nn_1_N = mkN "intern" "interner" ;
  international_nn_1_N = mkN "international" "internationaler" ;
  internetoperatoer_nn_1_1_N = mkN "internetoperatör" "internetoperatörer" ;
  internetsajt_nn_1_N = mkN "internetsajt" "internetsajter" ;
  interpellationsdebatt_nn_1_N = mkN "interpellationsdebatt" "interpellationsdebatter" ;
  interpret_nn_1_N = mkN "interpret" "interpreter" ;
  interrimspresident_nn_1_N = mkN "interrimspresident" "interrimspresidenter" ;
  intjaenandetid_nn_1_1_N = mkN "intjänandetid" "intjänandetider" ;
  intressent_nn_1_N = mkN "intressent" "intressenter" ;
  intressesfaer_nn_1_1_N = mkN "intressesfär" "intressesfärer" ;
  intrig_nn_1_N = mkN "intrig" "intriger" ;
  intrigoer_nn_1_1_N = mkN "intrigör" "intrigörer" ;
  introduktoer_nn_1_1_N = mkN "introduktör" "introduktörer" ;
  intaekt_nn_1_1_N = mkN "intäkt" "intäkter" ;
  intaektschablon_nn_1_1_N = mkN "intäktschablon" "intäktschabloner" ;
  invertebrat_nn_1_N = mkN "invertebrat" "invertebrater" ;
  investeringsbank_nn_1_N = mkN "investeringsbank" "investeringsbanker" ;
  investmentbank_nn_1_N = mkN "investmentbank" "investmentbanker" ;
  isbalett_nn_1_N = mkN "isbalett" "isbaletter" ;
  ischiasnerv_nn_1_N = mkN "ischiasnerv" "ischiasnerver" ;
  isfront_nn_1_N = mkN "isfront" "isfronter" ;
  iskonvalje_nn_1_N = mkN "iskonvalje" "iskonvaljer" ;
  isoleringscell_nn_1_N = mkN "isoleringscell" "isoleringsceller" ;
  isoterm_nn_1_N = mkN "isoterm" "isotermer" ;
  isotop_nn_1_N = mkN "isotop" "isotoper" ;
  isperiod_nn_1_N = mkN "isperiod" "isperioder" ;
  israel_nn_1_N = mkN "israel" "israeler" ;
  isrand_nn_1_N = mkN "isrand" "isränder" ;
  istid_nn_1_N = mkN "istid" "istider" ;
  jabot_nn_1_N = mkN "jabot" "jaboter" ;
  jagmodell_nn_1_N = mkN "jagmodell" "jagmodeller" ;
  jaguar_nn_1_N = mkN "jaguar" "jaguarer" ;
  jagupplevelse_nn_1_N = mkN "jagupplevelse" "jagupplevelser" ;
  jaha_upplevelse_nn_1_N = mkN "jaha-upplevelse" "jaha-upplevelser" ;
  jahaupplevelse_nn_1_N = mkN "jahaupplevelse" "jahaupplevelser" ;
  jakobskamp_nn_1_N = mkN "jakobskamp" "jakobskamper" ;
  jaktleopard_nn_1_N = mkN "jaktleopard" "jaktleoparder" ;
  jaktsignal_nn_1_N = mkN "jaktsignal" "jaktsignaler" ;
  jakttabell_nn_1_N = mkN "jakttabell" "jakttabeller" ;
  jakttid_nn_1_N = mkN "jakttid" "jakttider" ;
  jamb_nn_1_N = mkN "jamb" "jamber" ;
  jamboree_nn_1_N = mkN "jamboree" "jamboreer" ;
  janitsjar_nn_1_N = mkN "janitsjar" "janitsjarer" ;
  jardinjaer_nn_1_1_N = mkN "jardinjär" "jardinjärer" ;
  jargong_nn_1_N = mkN "jargong" "jargonger" ;
  jazzbalett_nn_1_N = mkN "jazzbalett" "jazzbaletter" ;
  jazzkonsert_nn_1_N = mkN "jazzkonsert" "jazzkonserter" ;
  jeremiad_nn_1_N = mkN "jeremiad" "jeremiader" ;
  jerseyko_nn_1_N = mkN "jerseyko" "jerseykor" ;
  jesuitgeneral_nn_1_N = mkN "jesuitgeneral" "jesuitgeneraler" ;
  jetong_nn_1_N = mkN "jetong" "jetonger" ;
  jodtablett_nn_1_N = mkN "jodtablett" "jodtabletter" ;
  joggingsko_nn_1_N = mkN "joggingsko" "joggingskor" ;
  joint_nn_1_N = mkN "joint" "jointer" ;
  jongloer_nn_1_1_N = mkN "jonglör" "jonglörer" ;
  jordafaerd_nn_1_1_N = mkN "jordafärd" "jordafärder" ;
  jordartsmetall_nn_1_N = mkN "jordartsmetall" "jordartsmetaller" ;
  jordatmosfaer_nn_1_1_N = mkN "jordatmosfär" "jordatmosfärer" ;
  jordbruksbebyggelse_nn_1_N = mkN "jordbruksbebyggelse" "jordbruksbebyggelser" ;
  jordbruksbygd_nn_1_N = mkN "jordbruksbygd" "jordbruksbygder" ;
  jordgubbssaft_nn_1_N = mkN "jordgubbssaft" "jordgubbssafter" ;
  jordgubbssylt_nn_1_N = mkN "jordgubbssylt" "jordgubbssylter" ;
  jordlott_nn_1_N = mkN "jordlott" "jordlotter" ;
  jordmetall_nn_1_N = mkN "jordmetall" "jordmetaller" ;
  jordskyld_nn_1_N = mkN "jordskyld" "jordskylder" ;
  jordtaekt_nn_1_1_N = mkN "jordtäkt" "jordtäkter" ;
  jour_nn_1_N = mkN "jour" "jourer" ;
  journal_nn_1_N = mkN "journal" "journaler" ;
  jubilar_nn_1_N = mkN "jubilar" "jubilarer" ;
  judefoerfoeljelse_nn_1_1_N = mkN "judeförföljelse" "judeförföljelser" ;
  jugoslav_nn_1_N = mkN "jugoslav" "jugoslaver" ;
  juice_nn_1_N = mkN "juice" "juicer" ;
  julgranskaramell_nn_1_N = mkN "julgranskaramell" "julgranskarameller" ;
  julhelg_nn_1_N = mkN "julhelg" "julhelger" ;
  julshow_nn_1_N = mkN "julshow" "julshower" ;
  jumbo_nn_1_N = mkN "jumbo" "jumbor" ;
  jungfruboerd_nn_1_1_N = mkN "jungfrubörd" "jungfrubörder" ;
  jaekelskap_nn_1_1_N = mkN "jäkelskap" "jäkelskaper" ;
  jaemfoerelse_nn_1_1_N = mkN "jämförelse" "jämförelser" ;
  jaernaffaer_nn_1_1_N = mkN "järnaffär" "järnaffärer" ;
  jaernbakterie_nn_1_1_N = mkN "järnbakterie" "järnbakterier" ;
  jaernhand_nn_1_1_N = mkN "järnhand" "järnhänder" ;
  jaernmalm_nn_1_1_N = mkN "järnmalm" "järnmalmer" ;
  jaernnatt_nn_1_1_N = mkN "järnnatt" "järnnätter" ;
  jaernstaang_nn_1_1_N = mkN "järnstång" "järnstänger" ;
  jaernvaruaffaer_nn_1_1_N = mkN "järnvaruaffär" "järnvaruaffärer" ;
  jaernvaegsbiljett_nn_1_1_N = mkN "järnvägsbiljett" "järnvägsbiljetter" ;
  jaernvaegslinje_nn_1_1_N = mkN "järnvägslinje" "järnvägslinjer" ;
  jaernaaldersbonde_nn_1_1_N = mkN "järnåldersbonde" "järnåldersbönder" ;
  jaernaaldersbygd_nn_1_1_N = mkN "järnåldersbygd" "järnåldersbygder" ;
  kabelsko_nn_1_N = mkN "kabelsko" "kabelskor" ;
  kabelskotaang_nn_1_1_N = mkN "kabelskotång" "kabelskotänger" ;
  kadett_nn_1_N = mkN "kadett" "kadetter" ;
  kadrilj_nn_1_N = mkN "kadrilj" "kadriljer" ;
  kaffeautomat_nn_1_N = mkN "kaffeautomat" "kaffeautomater" ;
  kaffetant_nn_1_N = mkN "kaffetant" "kaffetanter" ;
  kaf_eroerelse_nn_1_1_N = mkN "kaférörelse" "kaférörelser" ;
  kaj_nn_1_N = mkN "kaj" "kajer" ;
  kajak_nn_1_N = mkN "kajak" "kajaker" ;
  kajal_nn_1_N = mkN "kajal" "kajaler" ;
  kajavgift_nn_1_N = mkN "kajavgift" "kajavgifter" ;
  kakaolikoer_nn_1_1_N = mkN "kakaolikör" "kakaolikörer" ;
  kakelmaskin_nn_1_N = mkN "kakelmaskin" "kakelmaskiner" ;
  kakelugnsventil_nn_1_N = mkN "kakelugnsventil" "kakelugnsventiler" ;
  kaksmet_nn_1_N = mkN "kaksmet" "kaksmeter" ;
  kaktaang_nn_1_1_N = mkN "kaktång" "kaktänger" ;
  kakuminal_nn_1_N = mkN "kakuminal" "kakuminaler" ;
  kalabalik_nn_1_N = mkN "kalabalik" "kalabaliker" ;
  kalciumsilikat_nn_1_N = mkN "kalciumsilikat" "kalciumsilikater" ;
  kalif_nn_1_N = mkN "kalif" "kalifer" ;
  kalkgrund_nn_1_N = mkN "kalkgrund" "kalkgrunder" ;
  kalktuff_nn_1_N = mkN "kalktuff" "kalktuffer" ;
  kallelse_nn_1_N = mkN "kallelse" "kallelser" ;
  kallelsetid_nn_1_N = mkN "kallelsetid" "kallelsetider" ;
  kallfront_nn_1_N = mkN "kallfront" "kallfronter" ;
  kallpunkt_nn_1_N = mkN "kallpunkt" "kallpunkter" ;
  kallstart_nn_1_N = mkN "kallstart" "kallstarter" ;
  kalmuck_nn_1_N = mkN "kalmuck" "kalmucker" ;
  kaloritabell_nn_1_N = mkN "kaloritabell" "kaloritabeller" ;
  kalott_nn_1_N = mkN "kalott" "kalotter" ;
  kalvill_nn_1_N = mkN "kalvill" "kalviller" ;
  kalvko_nn_1_N = mkN "kalvko" "kalvkor" ;
  kamel_nn_1_N = mkN "kamel" "kameler" ;
  kameleont_nn_1_N = mkN "kameleont" "kameleonter" ;
  kamelopard_nn_1_N = mkN "kamelopard" "kameloparder" ;
  kamin_nn_1_N = mkN "kamin" "kaminer" ;
  kammanet_nn_1_N = mkN "kammanet" "kammaneter" ;
  kammardressyr_nn_1_N = mkN "kammardressyr" "kammardressyrer" ;
  kamomill_nn_1_N = mkN "kamomill" "kamomiller" ;
  kamp_nn_1_N = mkN "kamp" "kamper" ;
  kamrat_nn_1_N = mkN "kamrat" "kamrater" ;
  kamtsjadal_nn_1_N = mkN "kamtsjadal" "kamtsjadaler" ;
  kanadick_nn_1_N = mkN "kanadick" "kanadicker" ;
  kanak_nn_1_N = mkN "kanak" "kanaker" ;
  kanal_nn_1_N = mkN "kanal" "kanaler" ;
  kanalje_nn_1_N = mkN "kanalje" "kanaljer" ;
  kandidat_nn_1_N = mkN "kandidat" "kandidater" ;
  kanelstaang_nn_1_1_N = mkN "kanelstång" "kanelstänger" ;
  kanik_nn_1_N = mkN "kanik" "kaniker" ;
  kannelyr_nn_1_N = mkN "kannelyr" "kannelyrer" ;
  kanonad_nn_1_N = mkN "kanonad" "kanonader" ;
  kanonfotograf_nn_1_N = mkN "kanonfotograf" "kanonfotografer" ;
  kanoniaer_nn_1_1_N = mkN "kanoniär" "kanoniärer" ;
  kanonjaer_nn_1_1_N = mkN "kanonjär" "kanonjärer" ;
  kantele_nn_1_N = mkN "kantele" "kanteler" ;
  kapillaer_nn_1_1_N = mkN "kapillär" "kapillärer" ;
  kapitael_nn_2_1_N = mkN "kapitäl" "kapitäler" ;
  kapott_nn_1_N = mkN "kapott" "kapotter" ;
  kapten_nn_1_N = mkN "kapten" "kaptener" ;
  kapun_nn_1_N = mkN "kapun" "kapuner" ;
  kapuschong_nn_1_N = mkN "kapuschong" "kapuschonger" ;
  karabinjaer_nn_1_1_N = mkN "karabinjär" "karabinjärer" ;
  karaff_nn_1_N = mkN "karaff" "karaffer" ;
  karakteristik_nn_1_N = mkN "karakteristik" "karakteristiker" ;
  karaktaeristik_nn_1_1_N = mkN "karaktäristik" "karaktäristiker" ;
  karaktaersroll_nn_1_1_N = mkN "karaktärsroll" "karaktärsroller" ;
  karantaen_nn_1_1_N = mkN "karantän" "karantäner" ;
  karavanseraj_nn_1_N = mkN "karavanseraj" "karavanserajer" ;
  karavell_nn_1_N = mkN "karavell" "karaveller" ;
  karbonatsmaeltecell_nn_1_1_N = mkN "karbonatsmältecell" "karbonatsmälteceller" ;
  kardel_nn_1_N = mkN "kardel" "kardeler" ;
  kardinal_nn_1_N = mkN "kardinal" "kardinaler" ;
  kardinaldygd_nn_1_N = mkN "kardinaldygd" "kardinaldygder" ;
  kardinalsynd_nn_1_N = mkN "kardinalsynd" "kardinalsynder" ;
  kardiograf_nn_1_N = mkN "kardiograf" "kardiografer" ;
  karel_nn_1_N = mkN "karel" "kareler" ;
  karet_nn_1_N = mkN "karet" "kareter" ;
  karikatyr_nn_1_N = mkN "karikatyr" "karikatyrer" ;
  karneval_nn_1_N = mkN "karneval" "karnevaler" ;
  karoling_nn_1_N = mkN "karoling" "karolinger" ;
  karott_nn_1_N = mkN "karott" "karotter" ;
  karriaer_nn_1_1_N = mkN "karriär" "karriärer" ;
  karriaerdiplomat_nn_1_1_N = mkN "karriärdiplomat" "karriärdiplomater" ;
  karronad_nn_1_N = mkN "karronad" "karronader" ;
  kartell_nn_1_N = mkN "kartell" "karteller" ;
  kartspecial_nn_1_N = mkN "kartspecial" "kartspecialer" ;
  karusell_nn_1_N = mkN "karusell" "karuseller" ;
  kasack_nn_1_N = mkN "kasack" "kasacker" ;
  kasein_nn_1_N = mkN "kasein" "kaseiner" ;
  kasematt_nn_1_N = mkN "kasematt" "kasematter" ;
  kasern_nn_1_N = mkN "kasern" "kaserner" ;
  kashmir_nn_1_N = mkN "kashmir" "kashmirer" ;
  kassaaffaer_nn_1_1_N = mkN "kassaaffär" "kassaaffärer" ;
  kassako_nn_1_N = mkN "kassako" "kassakor" ;
  kassakontrollapparat_nn_1_N = mkN "kassakontrollapparat" "kassakontrollapparater" ;
  kassareserv_nn_1_N = mkN "kassareserv" "kassareserver" ;
  kassett_nn_1_N = mkN "kassett" "kassetter" ;
  kastal_nn_1_N = mkN "kastal" "kastaler" ;
  kastanje_nn_1_N = mkN "kastanje" "kastanjer" ;
  kastmaskin_nn_1_N = mkN "kastmaskin" "kastmaskiner" ;
  kastrat_nn_1_N = mkN "kastrat" "kastrater" ;
  kastrull_nn_1_N = mkN "kastrull" "kastruller" ;
  kasuar_nn_1_N = mkN "kasuar" "kasuarer" ;
  katafalk_nn_1_N = mkN "katafalk" "katafalker" ;
  katakomb_nn_1_N = mkN "katakomb" "katakomber" ;
  katalog_nn_1_N = mkN "katalog" "kataloger" ;
  katapult_nn_1_N = mkN "katapult" "katapulter" ;
  katarakt_nn_1_N = mkN "katarakt" "katarakter" ;
  katastrof_nn_1_N = mkN "katastrof" "katastrofer" ;
  katedral_nn_1_N = mkN "katedral" "katedraler" ;
  kateket_nn_1_N = mkN "kateket" "kateketer" ;
  katod_nn_1_N = mkN "katod" "katoder" ;
  kattoalett_nn_1_N = mkN "kattoalett" "kattoaletter" ;
  kattun_nn_1_N = mkN "kattun" "kattuner" ;
  kautschukparagraf_nn_1_N = mkN "kautschukparagraf" "kautschukparagrafer" ;
  kavaj_nn_1_N = mkN "kavaj" "kavajer" ;
  kavalett_nn_1_N = mkN "kavalett" "kavaletter" ;
  kavalkad_nn_1_N = mkN "kavalkad" "kavalkader" ;
  kavall_nn_1_N = mkN "kavall" "kavaller" ;
  kavallerichock_nn_1_N = mkN "kavallerichock" "kavallerichocker" ;
  kavalleritrupp_nn_1_N = mkN "kavalleritrupp" "kavalleritrupper" ;
  kavern_nn_1_N = mkN "kavern" "kaverner" ;
  kemikalie_nn_1_N = mkN "kemikalie" "kemikalier" ;
  kemomat_nn_1_N = mkN "kemomat" "kemomater" ;
  kentaur_nn_1_N = mkN "kentaur" "kentaurer" ;
  kerub_nn_1_N = mkN "kerub" "keruber" ;
  kiasm_nn_1_N = mkN "kiasm" "kiasmer" ;
  kibbutz_nn_1_N = mkN "kibbutz" "kibbutzer" ;
  kilklacksko_nn_1_N = mkN "kilklacksko" "kilklackskor" ;
  kind_nn_1_N = mkN "kind" "kinder" ;
  kindtand_nn_1_N = mkN "kindtand" "kindtänder" ;
  kinematograf_nn_1_N = mkN "kinematograf" "kinematografer" ;
  kippsko_nn_1_N = mkN "kippsko" "kippskor" ;
  kirurgtaang_nn_1_1_N = mkN "kirurgtång" "kirurgtänger" ;
  kissekatt_nn_1_N = mkN "kissekatt" "kissekatter" ;
  klackbar_nn_1_N = mkN "klackbar" "klackbarer" ;
  klang_nn_1_N = mkN "klang" "klanger" ;
  klapperstenstrand_nn_1_N = mkN "klapperstenstrand" "klapperstenstränder" ;
  klarinett_nn_1_N = mkN "klarinett" "klarinetter" ;
  klasskamp_nn_1_N = mkN "klasskamp" "klasskamper" ;
  klasskamrat_nn_1_N = mkN "klasskamrat" "klasskamrater" ;
  klausul_nn_1_N = mkN "klausul" "klausuler" ;
  klenaet_nn_1_1_N = mkN "klenät" "klenäter" ;
  klerk_nn_1_N = mkN "klerk" "klerker" ;
  klient_nn_1_N = mkN "klient" "klienter" ;
  klimatdebatt_nn_1_N = mkN "klimatdebatt" "klimatdebatter" ;
  klimatmodell_nn_1_N = mkN "klimatmodell" "klimatmodeller" ;
  klimatpanel_nn_1_N = mkN "klimatpanel" "klimatpaneler" ;
  klinik_nn_1_N = mkN "klinik" "kliniker" ;
  klipptaang_nn_1_1_N = mkN "klipptång" "klipptänger" ;
  klo_nn_1_N = mkN "klo" "klor" ;
  kloak_nn_1_N = mkN "kloak" "kloaker" ;
  klocktid_nn_1_N = mkN "klocktid" "klocktider" ;
  klon_nn_1_N = mkN "klon" "kloner" ;
  kloratom_nn_1_N = mkN "kloratom" "kloratomer" ;
  klosett_nn_1_N = mkN "klosett" "klosetter" ;
  klostercell_nn_1_N = mkN "klostercell" "klosterceller" ;
  klosterlikoer_nn_1_1_N = mkN "klosterlikör" "klosterlikörer" ;
  klotaang_nn_1_1_N = mkN "klotång" "klotänger" ;
  klubblokal_nn_1_N = mkN "klubblokal" "klubblokaler" ;
  klusil_nn_1_N = mkN "klusil" "klusiler" ;
  klyft_nn_1_N = mkN "klyft" "klyfter" ;
  klaedkod_nn_1_1_N = mkN "klädkod" "klädkoder" ;
  klaettersko_nn_1_1_N = mkN "klättersko" "klätterskor" ;
  knarkkurir_nn_1_N = mkN "knarkkurir" "knarkkurirer" ;
  kneippkur_nn_1_N = mkN "kneippkur" "kneippkurer" ;
  knejpkur_nn_1_N = mkN "knejpkur" "knejpkurer" ;
  kniptaang_nn_1_1_N = mkN "kniptång" "kniptänger" ;
  knivroerelse_nn_1_1_N = mkN "knivrörelse" "knivrörelser" ;
  ko_nn_1_N = mkN "ko" "kor" ;
  koaffoer_nn_1_1_N = mkN "koafför" "koafförer" ;
  koboltkanon_nn_1_N = mkN "koboltkanon" "koboltkanoner" ;
  kock_nn_2_N = mkN "kock" "kocker" ;
  kodicill_nn_1_N = mkN "kodicill" "kodiciller" ;
  koefficient_nn_1_N = mkN "koefficient" "koefficienter" ;
  kokapparat_nn_1_N = mkN "kokapparat" "kokapparater" ;
  kokard_nn_1_N = mkN "kokard" "kokarder" ;
  kokett_nn_1_N = mkN "kokett" "koketter" ;
  kokill_nn_1_N = mkN "kokill" "kokiller" ;
  kokong_nn_1_N = mkN "kokong" "kokonger" ;
  kokospalm_nn_1_N = mkN "kokospalm" "kokospalmer" ;
  kokott_nn_1_N = mkN "kokott" "kokotter" ;
  kokpunkt_nn_1_N = mkN "kokpunkt" "kokpunkter" ;
  koktid_nn_1_N = mkN "koktid" "koktider" ;
  kolatom_nn_1_N = mkN "kolatom" "kolatomer" ;
  kolbrikett_nn_1_N = mkN "kolbrikett" "kolbriketter" ;
  koldioxidkanal_nn_1_N = mkN "koldioxidkanal" "koldioxidkanaler" ;
  kolerabakterie_nn_1_N = mkN "kolerabakterie" "kolerabakterier" ;
  kolibakterie_nn_1_N = mkN "kolibakterie" "kolibakterier" ;
  kolisotop_nn_1_N = mkN "kolisotop" "kolisotoper" ;
  kollaboratoer_nn_1_1_N = mkN "kollaboratör" "kollaboratörer" ;
  kollekt_nn_1_N = mkN "kollekt" "kollekter" ;
  kollektivnot_nn_1_N = mkN "kollektivnot" "kollektivnoter" ;
  kolokvint_nn_1_N = mkN "kolokvint" "kolokvinter" ;
  kolonilott_nn_1_N = mkN "kolonilott" "kolonilotter" ;
  kolonisatoer_nn_1_1_N = mkN "kolonisatör" "kolonisatörer" ;
  kolonn_nn_1_N = mkN "kolonn" "kolonner" ;
  kolonnad_nn_1_N = mkN "kolonnad" "kolonnader" ;
  kolonnett_nn_1_N = mkN "kolonnett" "kolonnetter" ;
  kolportoer_nn_1_1_N = mkN "kolportör" "kolportörer" ;
  koltablett_nn_1_N = mkN "koltablett" "koltabletter" ;
  kolumn_nn_1_N = mkN "kolumn" "kolumner" ;
  komedienn_nn_1_N = mkN "komedienn" "komedienner" ;
  komet_nn_1_N = mkN "komet" "kometer" ;
  kommabacill_nn_1_N = mkN "kommabacill" "kommabaciller" ;
  kommandocentral_nn_1_N = mkN "kommandocentral" "kommandocentraler" ;
  kommendoerkapten_nn_1_1_N = mkN "kommendörkapten" "kommendörkaptener" ;
  kommentar_nn_1_N = mkN "kommentar" "kommentarer" ;
  kommissarie_nn_1_N = mkN "kommissarie" "kommissarier" ;
  kommod_nn_1_N = mkN "kommod" "kommoder" ;
  kommun_nn_1_N = mkN "kommun" "kommuner" ;
  kommunalstyrelse_nn_1_N = mkN "kommunalstyrelse" "kommunalstyrelser" ;
  kommunard_nn_1_N = mkN "kommunard" "kommunarder" ;
  kommunikationsakt_nn_1_N = mkN "kommunikationsakt" "kommunikationsakter" ;
  kommunikationsradio_nn_1_N = mkN "kommunikationsradio" "kommunikationsradior" ;
  kommunikationstabell_nn_1_N = mkN "kommunikationstabell" "kommunikationstabeller" ;
  kommunikatoer_nn_1_1_N = mkN "kommunikatör" "kommunikatörer" ;
  kommunistsympatisoer_nn_1_1_N = mkN "kommunistsympatisör" "kommunistsympatisörer" ;
  kommunstyrelse_nn_1_N = mkN "kommunstyrelse" "kommunstyrelser" ;
  kompaniadjutant_nn_1_N = mkN "kompaniadjutant" "kompaniadjutanter" ;
  kompanjon_nn_1_N = mkN "kompanjon" "kompanjoner" ;
  komplementmaengd_nn_1_1_N = mkN "komplementmängd" "komplementmängder" ;
  komplementaer_nn_1_1_N = mkN "komplementär" "komplementärer" ;
  komplimang_nn_1_N = mkN "komplimang" "komplimanger" ;
  kompositoer_nn_1_1_N = mkN "kompositör" "kompositörer" ;
  kompott_nn_1_N = mkN "kompott" "kompotter" ;
  kon_nn_1_N = mkN "kon" "koner" ;
  kondom_nn_1_N = mkN "kondom" "kondomer" ;
  kondottiaer_nn_1_1_N = mkN "kondottiär" "kondottiärer" ;
  konfessionarie_nn_1_N = mkN "konfessionarie" "konfessionarier" ;
  konfirmand_nn_1_N = mkN "konfirmand" "konfirmander" ;
  konfirmationskostym_nn_1_N = mkN "konfirmationskostym" "konfirmationskostymer" ;
  konflikt_nn_1_N = mkN "konflikt" "konflikter" ;
  konklav_nn_1_N = mkN "konklav" "konklaver" ;
  konkurrent_nn_1_N = mkN "konkurrent" "konkurrenter" ;
  konkursdividend_nn_1_N = mkN "konkursdividend" "konkursdividender" ;
  konnaessoer_nn_1_1_N = mkN "konnässör" "konnässörer" ;
  konselj_nn_1_N = mkN "konselj" "konseljer" ;
  konseljpresident_nn_1_N = mkN "konseljpresident" "konseljpresidenter" ;
  konsert_nn_1_N = mkN "konsert" "konserter" ;
  konserv_nn_1_N = mkN "konserv" "konserver" ;
  konserveringsapparat_nn_1_N = mkN "konserveringsapparat" "konserveringsapparater" ;
  konspiratoer_nn_1_1_N = mkN "konspiratör" "konspiratörer" ;
  konstart_nn_1_N = mkN "konstart" "konstarter" ;
  konstruktionsgrammatik_nn_1_N = mkN "konstruktionsgrammatik" "konstruktionsgrammatiker" ;
  konsulent_nn_1_N = mkN "konsulent" "konsulenter" ;
  konsult_nn_1_N = mkN "konsult" "konsulter" ;
  konteramiral_nn_1_N = mkN "konteramiral" "konteramiraler" ;
  kontext_nn_1_N = mkN "kontext" "kontexter" ;
  kontinent_nn_1_N = mkN "kontinent" "kontinenter" ;
  kontingent_nn_1_N = mkN "kontingent" "kontingenter" ;
  kontorspulpet_nn_1_N = mkN "kontorspulpet" "kontorspulpeter" ;
  kontorstid_nn_1_N = mkN "kontorstid" "kontorstider" ;
  kontrahent_nn_1_N = mkN "kontrahent" "kontrahenter" ;
  kontraktstid_nn_1_N = mkN "kontraktstid" "kontraktstider" ;
  konungalaengd_nn_1_1_N = mkN "konungalängd" "konungalängder" ;
  konungaaett_nn_1_1_N = mkN "konungaätt" "konungaätter" ;
  konvalescent_nn_1_N = mkN "konvalescent" "konvalescenter" ;
  konvalje_nn_1_N = mkN "konvalje" "konvaljer" ;
  kooperatoer_nn_1_1_N = mkN "kooperatör" "kooperatörer" ;
  koordinat_nn_1_N = mkN "koordinat" "koordinater" ;
  kopieringsapparat_nn_1_N = mkN "kopieringsapparat" "kopieringsapparater" ;
  kopieringsmaskin_nn_1_N = mkN "kopieringsmaskin" "kopieringsmaskiner" ;
  kopparspiral_nn_1_N = mkN "kopparspiral" "kopparspiraler" ;
  kopparsulfat_nn_1_N = mkN "kopparsulfat" "kopparsulfater" ;
  koral_nn_1_N = mkN "koral" "koraler" ;
  korall_nn_1_N = mkN "korall" "koraller" ;
  kordong_nn_1_N = mkN "kordong" "kordonger" ;
  koreograf_nn_1_N = mkN "koreograf" "koreografer" ;
  korint_nn_1_N = mkN "korint" "korinter" ;
  korkmaskin_nn_1_N = mkN "korkmaskin" "korkmaskiner" ;
  korksmak_nn_1_N = mkN "korksmak" "korksmaker" ;
  kornett_nn_1_N = mkN "kornett" "kornetter" ;
  korpral_nn_1_N = mkN "korpral" "korpraler" ;
  korrespondent_nn_1_N = mkN "korrespondent" "korrespondenter" ;
  korsar_nn_1_N = mkN "korsar" "korsarer" ;
  korselett_nn_1_N = mkN "korselett" "korseletter" ;
  korsett_nn_1_N = mkN "korsett" "korsetter" ;
  korsfaestelse_nn_1_1_N = mkN "korsfästelse" "korsfästelser" ;
  korsordskonstruktoer_nn_1_1_N = mkN "korsordskonstruktör" "korsordskonstruktörer" ;
  kortege_nn_1_N = mkN "kortege" "korteger" ;
  kortison_nn_1_N = mkN "kortison" "kortisoner" ;
  kortkatalog_nn_1_N = mkN "kortkatalog" "kortkataloger" ;
  korttidsvikarie_nn_1_N = mkN "korttidsvikarie" "korttidsvikarier" ;
  kortvaagsradio_nn_1_1_N = mkN "kortvågsradio" "kortvågsradior" ;
  korund_nn_1_N = mkN "korund" "korunder" ;
  korvett_nn_1_N = mkN "korvett" "korvetter" ;
  kosack_nn_1_N = mkN "kosack" "kosacker" ;
  kosmodrom_nn_1_N = mkN "kosmodrom" "kosmodromer" ;
  kosmonaut_nn_1_N = mkN "kosmonaut" "kosmonauter" ;
  kostym_nn_1_N = mkN "kostym" "kostymer" ;
  kotiljong_nn_1_N = mkN "kotiljong" "kotiljonger" ;
  kotlett_nn_1_N = mkN "kotlett" "kotletter" ;
  koturn_nn_1_N = mkN "koturn" "koturner" ;
  kovall_nn_1_N = mkN "kovall" "kovaller" ;
  krabat_nn_1_N = mkN "krabat" "krabater" ;
  kraftcentral_nn_1_N = mkN "kraftcentral" "kraftcentraler" ;
  kraftkonsument_nn_1_N = mkN "kraftkonsument" "kraftkonsumenter" ;
  kraftlinje_nn_1_N = mkN "kraftlinje" "kraftlinjer" ;
  kramp_nn_1_N = mkN "kramp" "kramper" ;
  kransartaer_nn_1_1_N = mkN "kransartär" "kransartärer" ;
  kranskommun_nn_1_N = mkN "kranskommun" "kranskommuner" ;
  kravatt_nn_1_N = mkN "kravatt" "kravatter" ;
  kravell_nn_1_N = mkN "kravell" "kraveller" ;
  kravmaskin_nn_1_N = mkN "kravmaskin" "kravmaskiner" ;
  kretong_nn_1_N = mkN "kretong" "kretonger" ;
  krevad_nn_1_N = mkN "krevad" "krevader" ;
  krigsberedskap_nn_1_N = mkN "krigsberedskap" "krigsberedskaper" ;
  krigsbrottstribunal_nn_1_N = mkN "krigsbrottstribunal" "krigsbrottstribunaler" ;
  krigsfotograf_nn_1_N = mkN "krigsfotograf" "krigsfotografer" ;
  krigsfoerbrytartribunal_nn_1_1_N = mkN "krigsförbrytartribunal" "krigsförbrytartribunaler" ;
  krigsfoerbrytelse_nn_1_1_N = mkN "krigsförbrytelse" "krigsförbrytelser" ;
  krigskorrespondent_nn_1_N = mkN "krigskorrespondent" "krigskorrespondenter" ;
  krisjour_nn_1_N = mkN "krisjour" "krisjourer" ;
  krissituation_nn_1_N = mkN "krissituation" "krissituationer" ;
  kroat_nn_1_N = mkN "kroat" "kroater" ;
  krogkund_nn_1_N = mkN "krogkund" "krogkunder" ;
  krogrecension_nn_1_N = mkN "krogrecension" "krogrecensioner" ;
  krogshow_nn_1_N = mkN "krogshow" "krogshower" ;
  krokett_nn_1_N = mkN "krokett" "kroketter" ;
  kroklinje_nn_1_N = mkN "kroklinje" "kroklinjer" ;
  krokodil_nn_1_N = mkN "krokodil" "krokodiler" ;
  kromosom_nn_1_N = mkN "kromosom" "kromosomer" ;
  kromosomavvikelse_nn_1_N = mkN "kromosomavvikelse" "kromosomavvikelser" ;
  kronjuvel_nn_1_N = mkN "kronjuvel" "kronjuveler" ;
  kronopark_nn_1_N = mkN "kronopark" "kronoparker" ;
  kronoutskyld_nn_1_N = mkN "kronoutskyld" "kronoutskylder" ;
  kroppskanal_nn_1_N = mkN "kroppskanal" "kroppskanaler" ;
  kroppsroerelse_nn_1_1_N = mkN "kroppsrörelse" "kroppsrörelser" ;
  krossmaskin_nn_1_N = mkN "krossmaskin" "krossmaskiner" ;
  krumbukt_nn_1_N = mkN "krumbukt" "krumbukter" ;
  krusidull_nn_1_N = mkN "krusidull" "krusiduller" ;
  krustad_nn_1_N = mkN "krustad" "krustader" ;
  krustaang_nn_1_1_N = mkN "krustång" "krustänger" ;
  krutong_nn_1_N = mkN "krutong" "krutonger" ;
  krympfilm_nn_1_N = mkN "krympfilm" "krympfilmer" ;
  krympmaan_nn_1_1_N = mkN "krympmån" "krympmåner" ;
  kryostat_nn_1_N = mkN "kryostat" "kryostater" ;
  kryoteknik_nn_1_N = mkN "kryoteknik" "kryotekniker" ;
  krypfil_nn_1_N = mkN "krypfil" "krypfiler" ;
  kryptogam_nn_1_N = mkN "kryptogam" "kryptogamer" ;
  krysantem_nn_1_N = mkN "krysantem" "krysantemer" ;
  kryssningsraket_nn_1_N = mkN "kryssningsraket" "kryssningsraketer" ;
  kraem_nn_1_1_N = mkN "kräm" "krämer" ;
  kub_nn_1_N = mkN "kub" "kuber" ;
  kuggstaang_nn_1_1_N = mkN "kuggstång" "kuggstänger" ;
  kujon_nn_1_N = mkN "kujon" "kujoner" ;
  kulak_nn_1_N = mkN "kulak" "kulaker" ;
  kullerstenspassage_nn_1_N = mkN "kullerstenspassage" "kullerstenspassager" ;
  kullkamrat_nn_1_N = mkN "kullkamrat" "kullkamrater" ;
  kullko_nn_1_N = mkN "kullko" "kullkor" ;
  kulskrivmaskin_nn_1_N = mkN "kulskrivmaskin" "kulskrivmaskiner" ;
  kult_nn_1_N = mkN "kult" "kulter" ;
  kulturbygd_nn_1_N = mkN "kulturbygd" "kulturbygder" ;
  kulturchock_nn_1_N = mkN "kulturchock" "kulturchocker" ;
  kulturdebatt_nn_1_N = mkN "kulturdebatt" "kulturdebatter" ;
  kulturradikal_nn_1_N = mkN "kulturradikal" "kulturradikaler" ;
  kulturskribent_nn_1_N = mkN "kulturskribent" "kulturskribenter" ;
  kulventil_nn_1_N = mkN "kulventil" "kulventiler" ;
  kuloer_nn_1_1_N = mkN "kulör" "kulörer" ;
  kund_nn_1_N = mkN "kund" "kunder" ;
  kundkontakt_nn_1_N = mkN "kundkontakt" "kundkontakter" ;
  kungalaengd_nn_1_1_N = mkN "kungalängd" "kungalängder" ;
  kungaaett_nn_1_1_N = mkN "kungaätt" "kungaätter" ;
  kungsbonde_nn_1_N = mkN "kungsbonde" "kungsbönder" ;
  kungoerelse_nn_1_1_N = mkN "kungörelse" "kungörelser" ;
  kunskap_nn_1_N = mkN "kunskap" "kunskaper" ;
  kunskapssyn_nn_1_N = mkN "kunskapssyn" "kunskapssyner" ;
  kuplett_nn_1_N = mkN "kuplett" "kupletter" ;
  kupong_nn_1_N = mkN "kupong" "kuponger" ;
  kupp_nn_1_N = mkN "kupp" "kupper" ;
  kur_nn_1_N = mkN "kur" "kurer" ;
  kuriosaspalt_nn_1_N = mkN "kuriosaspalt" "kuriosaspalter" ;
  kurskamrat_nn_1_N = mkN "kurskamrat" "kurskamrater" ;
  kursroerelse_nn_1_1_N = mkN "kursrörelse" "kursrörelser" ;
  kurtisoer_nn_1_1_N = mkN "kurtisör" "kurtisörer" ;
  kustbygd_nn_1_N = mkN "kustbygd" "kustbygder" ;
  kustlinje_nn_1_N = mkN "kustlinje" "kustlinjer" ;
  kustslaett_nn_1_1_N = mkN "kustslätt" "kustslätter" ;
  kuststad_nn_1_N = mkN "kuststad" "kuststäder" ;
  kuvertavgift_nn_1_N = mkN "kuvertavgift" "kuvertavgifter" ;
  kvadrat_nn_1_N = mkN "kvadrat" "kvadrater" ;
  kvarstad_nn_1_N = mkN "kvarstad" "kvarstader" ;
  kvart_nn_2_N = mkN "kvart" "kvarter" ;
  kvartett_nn_1_N = mkN "kvartett" "kvartetter" ;
  kvartil_nn_1_N = mkN "kvartil" "kvartiler" ;
  kvidd_nn_1_N = mkN "kvidd" "kvidder" ;
  kvinnofrisyr_nn_1_N = mkN "kvinnofrisyr" "kvinnofrisyrer" ;
  kvinnogestalt_nn_1_N = mkN "kvinnogestalt" "kvinnogestalter" ;
  kvinnojour_nn_1_N = mkN "kvinnojour" "kvinnojourer" ;
  kvinnoklinik_nn_1_N = mkN "kvinnoklinik" "kvinnokliniker" ;
  kvinnoroerelse_nn_1_1_N = mkN "kvinnorörelse" "kvinnorörelser" ;
  kvint_nn_1_N = mkN "kvint" "kvinter" ;
  kvintett_nn_1_N = mkN "kvintett" "kvintetter" ;
  kvaellsvard_nn_1_1_N = mkN "kvällsvard" "kvällsvarder" ;
  kybernetik_nn_1_N = mkN "kybernetik" "kybernetiker" ;
  kylargardin_nn_1_N = mkN "kylargardin" "kylargardiner" ;
  kylkonserv_nn_1_N = mkN "kylkonserv" "kylkonserver" ;
  kymograf_nn_1_N = mkN "kymograf" "kymografer" ;
  kyrassiaer_nn_1_1_N = mkN "kyrassiär" "kyrassiärer" ;
  kyrassjaer_nn_1_1_N = mkN "kyrassjär" "kyrassjärer" ;
  kyrkoadjunkt_nn_1_N = mkN "kyrkoadjunkt" "kyrkoadjunkter" ;
  kyrkoavgift_nn_1_N = mkN "kyrkoavgift" "kyrkoavgifter" ;
  kyrkobyggnad_nn_1_N = mkN "kyrkobyggnad" "kyrkobyggnader" ;
  kyrkokonsert_nn_1_N = mkN "kyrkokonsert" "kyrkokonserter" ;
  kyrkoruin_nn_1_N = mkN "kyrkoruin" "kyrkoruiner" ;
  kyrkostrid_nn_1_N = mkN "kyrkostrid" "kyrkostrider" ;
  kyrkosaang_nn_1_1_N = mkN "kyrkosång" "kyrkosånger" ;
  kyrkoton_nn_1_N = mkN "kyrkoton" "kyrkotoner" ;
  kyrkotonart_nn_1_N = mkN "kyrkotonart" "kyrkotonarter" ;
  kyrkoverksamhet_nn_1_N = mkN "kyrkoverksamhet" "kyrkoverksamheter" ;
  kyrkstad_nn_1_N = mkN "kyrkstad" "kyrkstäder" ;
  kyskhet_nn_1_N = mkN "kyskhet" "kyskheter" ;
  kyskhetsnorm_nn_1_N = mkN "kyskhetsnorm" "kyskhetsnormer" ;
  kaeckhet_nn_1_1_N = mkN "käckhet" "käckheter" ;
  kaekled_nn_1_1_N = mkN "käkled" "käkleder" ;
  kaellarlokal_nn_1_1_N = mkN "källarlokal" "källarlokaler" ;
  kaellskrift_nn_1_1_N = mkN "källskrift" "källskrifter" ;
  kaemnaersraett_nn_1_1_N = mkN "kämnärsrätt" "kämnärsrätter" ;
  kaempagloed_nn_1_1_N = mkN "kämpaglöd" "kämpaglöder" ;
  kaenslighet_nn_1_1_N = mkN "känslighet" "känsligheter" ;
  kaensloagitation_nn_1_1_N = mkN "känsloagitation" "känsloagitationer" ;
  kaensloloeshet_nn_1_1_N = mkN "känslolöshet" "känslolösheter" ;
  kaenslosamhet_nn_1_1_N = mkN "känslosamhet" "känslosamheter" ;
  kaerleksaffaer_nn_1_1_N = mkN "kärleksaffär" "kärleksaffärer" ;
  kaerleksakt_nn_1_1_N = mkN "kärleksakt" "kärleksakter" ;
  kaerleksbard_nn_1_1_N = mkN "kärleksbard" "kärleksbarder" ;
  kaerleksbetygelse_nn_1_1_N = mkN "kärleksbetygelse" "kärleksbetygelser" ;
  kaerleksdikt_nn_1_1_N = mkN "kärleksdikt" "kärleksdikter" ;
  kaerleksdryck_nn_1_1_N = mkN "kärleksdryck" "kärleksdrycker" ;
  kaerleksfoerbindelse_nn_1_1_N = mkN "kärleksförbindelse" "kärleksförbindelser" ;
  kaerlekskonflikt_nn_1_1_N = mkN "kärlekskonflikt" "kärlekskonflikter" ;
  kaerleksnatt_nn_1_1_N = mkN "kärleksnatt" "kärleksnätter" ;
  kaerleksnovell_nn_1_1_N = mkN "kärleksnovell" "kärleksnoveller" ;
  kaerleksrelation_nn_1_1_N = mkN "kärleksrelation" "kärleksrelationer" ;
  kaerleksrival_nn_1_1_N = mkN "kärleksrival" "kärleksrivaler" ;
  kaerlekssorg_nn_1_1_N = mkN "kärlekssorg" "kärlekssorger" ;
  kaernfamilj_nn_1_1_N = mkN "kärnfamilj" "kärnfamiljer" ;
  kaernfrukt_nn_1_1_N = mkN "kärnfrukt" "kärnfrukter" ;
  kaernfullhet_nn_1_1_N = mkN "kärnfullhet" "kärnfullheter" ;
  kaernkraftinspektion_nn_1_1_N = mkN "kärnkraftinspektion" "kärnkraftinspektioner" ;
  kaernkraftsoperatoer_nn_1_1_N = mkN "kärnkraftsoperatör" "kärnkraftsoperatörer" ;
  kaernkraftsaekerhet_nn_1_1_N = mkN "kärnkraftsäkerhet" "kärnkraftsäkerheter" ;
  kaernlinje_nn_1_1_N = mkN "kärnlinje" "kärnlinjer" ;
  kaernpunkt_nn_1_1_N = mkN "kärnpunkt" "kärnpunkter" ;
  kaernreaktion_nn_1_1_N = mkN "kärnreaktion" "kärnreaktioner" ;
  kaerntrupp_nn_1_1_N = mkN "kärntrupp" "kärntrupper" ;
  kaernvapenarsenal_nn_1_1_N = mkN "kärnvapenarsenal" "kärnvapenarsenaler" ;
  kaernvapenexplosion_nn_1_1_N = mkN "kärnvapenexplosion" "kärnvapenexplosioner" ;
  kaernvapenmakt_nn_1_1_N = mkN "kärnvapenmakt" "kärnvapenmakter" ;
  kaernverksamhet_nn_1_1_N = mkN "kärnverksamhet" "kärnverksamheter" ;
  kaerrvial_nn_1_1_N = mkN "kärrvial" "kärrvialer" ;
  kaervaenlighet_nn_1_1_N = mkN "kärvänlighet" "kärvänligheter" ;
  kaakstad_nn_1_1_N = mkN "kåkstad" "kåkstäder" ;
  kaasoer_nn_1_1_N = mkN "kåsör" "kåsörer" ;
  koeksmaskin_nn_1_1_N = mkN "köksmaskin" "köksmaskiner" ;
  koeldgrad_nn_1_1_N = mkN "köldgrad" "köldgrader" ;
  koeldpol_nn_1_1_N = mkN "köldpol" "köldpoler" ;
  koeldpunkt_nn_1_1_N = mkN "köldpunkt" "köldpunkter" ;
  koensakt_nn_1_1_N = mkN "könsakt" "könsakter" ;
  koenscell_nn_1_1_N = mkN "könscell" "könsceller" ;
  koenskaraktaer_nn_1_1_N = mkN "könskaraktär" "könskaraktärer" ;
  koensmognad_nn_1_1_N = mkN "könsmognad" "könsmognader" ;
  koensroll_nn_1_1_N = mkN "könsroll" "könsroller" ;
  koensskillnad_nn_1_1_N = mkN "könsskillnad" "könsskillnader" ;
  koensvarelse_nn_1_1_N = mkN "könsvarelse" "könsvarelser" ;
  koepenskap_nn_1_1_N = mkN "köpenskap" "köpenskaper" ;
  koepstad_nn_1_1_N = mkN "köpstad" "köpstäder" ;
  koer_nn_1_1_N = mkN "kör" "körer" ;
  koeregenskap_nn_1_1_N = mkN "köregenskap" "köregenskaper" ;
  koerlektion_nn_1_1_N = mkN "körlektion" "körlektioner" ;
  koersnaer_nn_1_1_N = mkN "körsnär" "körsnärer" ;
  koertelcell_nn_1_1_N = mkN "körtelcell" "körtelceller" ;
  koertid_nn_1_1_N = mkN "körtid" "körtider" ;
  koettbonde_nn_1_1_N = mkN "köttbonde" "köttbönder" ;
  koetted_nn_1_1_N = mkN "kötted" "kötteder" ;
  koettko_nn_1_1_N = mkN "köttko" "köttkor" ;
  koettkonnaessoer_nn_1_1_N = mkN "köttkonnässör" "köttkonnässörer" ;
  koettmarknad_nn_1_1_N = mkN "köttmarknad" "köttmarknader" ;
  koettraett_nn_1_1_N = mkN "kötträtt" "kötträtter" ;
  koettsaft_nn_1_1_N = mkN "köttsaft" "köttsafter" ;
  labial_nn_1_N = mkN "labial" "labialer" ;
  labilitet_nn_1_N = mkN "labilitet" "labiliteter" ;
  labiodental_nn_1_N = mkN "labiodental" "labiodentaler" ;
  laboration_nn_1_N = mkN "laboration" "laborationer" ;
  laboratorieassistent_nn_1_N = mkN "laboratorieassistent" "laboratorieassistenter" ;
  labyrint_nn_1_N = mkN "labyrint" "labyrinter" ;
  lackfaerg_nn_1_1_N = mkN "lackfärg" "lackfärger" ;
  lacksko_nn_1_N = mkN "lacksko" "lackskor" ;
  lackviol_nn_1_N = mkN "lackviol" "lackvioler" ;
  laddningstid_nn_1_N = mkN "laddningstid" "laddningstider" ;
  lagbestaemmelse_nn_1_1_N = mkN "lagbestämmelse" "lagbestämmelser" ;
  lagbundenhet_nn_1_N = mkN "lagbundenhet" "lagbundenheter" ;
  lagerfoeljd_nn_1_1_N = mkN "lagerföljd" "lagerföljder" ;
  lagerkostnad_nn_1_N = mkN "lagerkostnad" "lagerkostnader" ;
  lagerlokal_nn_1_N = mkN "lagerlokal" "lagerlokaler" ;
  lagerserie_nn_1_N = mkN "lagerserie" "lagerserier" ;
  lagfart_nn_1_N = mkN "lagfart" "lagfarter" ;
  lagkamrat_nn_1_N = mkN "lagkamrat" "lagkamrater" ;
  lagkapp_nn_1_N = mkN "lagkapp" "lagkapper" ;
  lagkapten_nn_1_N = mkN "lagkapten" "lagkaptener" ;
  laglighet_nn_1_N = mkN "laglighet" "lagligheter" ;
  laglott_nn_1_N = mkN "laglott" "laglotter" ;
  lagloeshet_nn_1_1_N = mkN "laglöshet" "laglösheter" ;
  lagringskostnad_nn_1_N = mkN "lagringskostnad" "lagringskostnader" ;
  lagun_nn_1_N = mkN "lagun" "laguner" ;
  lakej_nn_1_N = mkN "lakej" "lakejer" ;
  laktalbumin_nn_1_N = mkN "laktalbumin" "laktalbuminer" ;
  laktation_nn_1_N = mkN "laktation" "laktationer" ;
  lakun_nn_1_N = mkN "lakun" "lakuner" ;
  lamell_nn_1_N = mkN "lamell" "lameller" ;
  lamellkontakt_nn_1_N = mkN "lamellkontakt" "lamellkontakter" ;
  lamentation_nn_1_N = mkN "lamentation" "lamentationer" ;
  lampett_nn_1_N = mkN "lampett" "lampetter" ;
  lampfabrik_nn_1_N = mkN "lampfabrik" "lampfabriker" ;
  landbo_nn_1_N = mkN "landbo" "landbor" ;
  landningszon_nn_1_N = mkN "landningszon" "landningszoner" ;
  landpermission_nn_1_N = mkN "landpermission" "landpermissioner" ;
  landsantikvarie_nn_1_N = mkN "landsantikvarie" "landsantikvarier" ;
  landsarkivarie_nn_1_N = mkN "landsarkivarie" "landsarkivarier" ;
  landsfiskal_nn_1_N = mkN "landsfiskal" "landsfiskaler" ;
  landskamp_nn_1_N = mkN "landskamp" "landskamper" ;
  landskommun_nn_1_N = mkN "landskommun" "landskommuner" ;
  landsortsstad_nn_1_N = mkN "landsortsstad" "landsortsstäder" ;
  landstingskatalog_nn_1_N = mkN "landstingskatalog" "landstingskataloger" ;
  landstingskommun_nn_1_N = mkN "landstingskommun" "landstingskommuner" ;
  langett_nn_1_N = mkN "langett" "langetter" ;
  lansett_nn_1_N = mkN "lansett" "lansetter" ;
  lansiaer_nn_1_1_N = mkN "lansiär" "lansiärer" ;
  lantbrukskonsulent_nn_1_N = mkN "lantbrukskonsulent" "lantbrukskonsulenter" ;
  lantbruksnaemnd_nn_1_1_N = mkN "lantbruksnämnd" "lantbruksnämnder" ;
  lantbruksstyrelse_nn_1_N = mkN "lantbruksstyrelse" "lantbruksstyrelser" ;
  laryngal_nn_1_N = mkN "laryngal" "laryngaler" ;
  laserfaerg_nn_1_1_N = mkN "laserfärg" "laserfärger" ;
  laserkanon_nn_1_N = mkN "laserkanon" "laserkanoner" ;
  laserteknik_nn_1_N = mkN "laserteknik" "lasertekniker" ;
  lastbarhet_nn_1_N = mkN "lastbarhet" "lastbarheter" ;
  lastbilsbar_nn_1_N = mkN "lastbilsbar" "lastbilsbarer" ;
  lastkaj_nn_1_N = mkN "lastkaj" "lastkajer" ;
  lastlinje_nn_1_N = mkN "lastlinje" "lastlinjer" ;
  lastmaskin_nn_1_N = mkN "lastmaskin" "lastmaskiner" ;
  lastprofil_nn_1_N = mkN "lastprofil" "lastprofiler" ;
  lastvattenlinje_nn_1_N = mkN "lastvattenlinje" "lastvattenlinjer" ;
  lastzon_nn_1_N = mkN "lastzon" "lastzoner" ;
  lasyr_nn_1_N = mkN "lasyr" "lasyrer" ;
  latenstid_nn_1_N = mkN "latenstid" "latenstider" ;
  lateral_nn_1_N = mkN "lateral" "lateraler" ;
  latinlinje_nn_1_N = mkN "latinlinje" "latinlinjer" ;
  latitud_nn_1_N = mkN "latitud" "latituder" ;
  lattebar_nn_1_N = mkN "lattebar" "lattebarer" ;
  lavett_nn_1_N = mkN "lavett" "lavetter" ;
  lavoar_nn_1_N = mkN "lavoar" "lavoarer" ;
  lavregion_nn_1_N = mkN "lavregion" "lavregioner" ;
  lavyr_nn_1_N = mkN "lavyr" "lavyrer" ;
  laxfiskeraettighet_nn_1_1_N = mkN "laxfiskerättighet" "laxfiskerättigheter" ;
  laxfaerg_nn_1_1_N = mkN "laxfärg" "laxfärger" ;
  layout_nn_1_N = mkN "layout" "layouter" ;
  layoutchef_nn_1_N = mkN "layoutchef" "layoutchefer" ;
  lecitin_nn_1_N = mkN "lecitin" "lecitiner" ;
  ledamot_nn_1_N = mkN "ledamot" "ledamöter" ;
  ledarkult_nn_1_N = mkN "ledarkult" "ledarkulter" ;
  ledarskribent_nn_1_N = mkN "ledarskribent" "ledarskribenter" ;
  ledd_nn_1_N = mkN "ledd" "ledder" ;
  ledighet_nn_1_N = mkN "ledighet" "ledigheter" ;
  ledinflammation_nn_1_N = mkN "ledinflammation" "ledinflammationer" ;
  ledningsgrupp_nn_1_N = mkN "ledningsgrupp" "ledningsgrupper" ;
  ledningskapacitet_nn_1_N = mkN "ledningskapacitet" "ledningskapaciteter" ;
  ledningsvaevnad_nn_1_1_N = mkN "ledningsvävnad" "ledningsvävnader" ;
  ledsamhet_nn_1_N = mkN "ledsamhet" "ledsamheter" ;
  ledsenhet_nn_1_N = mkN "ledsenhet" "ledsenheter" ;
  ledsnad_nn_1_N = mkN "ledsnad" "ledsnader" ;
  ledstaang_nn_1_1_N = mkN "ledstång" "ledstänger" ;
  legalisation_nn_1_N = mkN "legalisation" "legalisationer" ;
  legalitet_nn_1_N = mkN "legalitet" "legaliteter" ;
  legat_nn_1_N = mkN "legat" "legater" ;
  legatarie_nn_1_N = mkN "legatarie" "legatarier" ;
  legation_nn_1_N = mkN "legation" "legationer" ;
  legion_nn_1_N = mkN "legion" "legioner" ;
  legionaer_nn_1_1_N = mkN "legionär" "legionärer" ;
  legitimation_nn_1_N = mkN "legitimation" "legitimationer" ;
  legitimitet_nn_1_N = mkN "legitimitet" "legitimiteter" ;
  legotrupp_nn_1_N = mkN "legotrupp" "legotrupper" ;
  legymsallad_nn_1_N = mkN "legymsallad" "legymsallader" ;
  lekatt_nn_1_N = mkN "lekatt" "lekatter" ;
  lekdraekt_nn_1_1_N = mkN "lekdräkt" "lekdräkter" ;
  lekfullhet_nn_1_N = mkN "lekfullhet" "lekfullheter" ;
  lekkamrat_nn_1_N = mkN "lekkamrat" "lekkamrater" ;
  lekmannaorganisation_nn_1_N = mkN "lekmannaorganisation" "lekmannaorganisationer" ;
  lekpark_nn_1_N = mkN "lekpark" "lekparker" ;
  leksak_nn_1_N = mkN "leksak" "leksaker" ;
  lektid_nn_1_N = mkN "lektid" "lektider" ;
  lektion_nn_1_N = mkN "lektion" "lektioner" ;
  lektoer_nn_1_1_N = mkN "lektör" "lektörer" ;
  lemonad_nn_1_N = mkN "lemonad" "lemonader" ;
  leopard_nn_1_N = mkN "leopard" "leoparder" ;
  lerhalt_nn_1_N = mkN "lerhalt" "lerhalter" ;
  lerslaett_nn_1_1_N = mkN "lerslätt" "lerslätter" ;
  lesion_nn_1_N = mkN "lesion" "lesioner" ;
  lessenhet_nn_1_N = mkN "lessenhet" "lessenheter" ;
  lessnad_nn_1_N = mkN "lessnad" "lessnader" ;
  lett_nn_1_N = mkN "lett" "letter" ;
  leukocyt_nn_1_N = mkN "leukocyt" "leukocyter" ;
  levang_nn_1_N = mkN "levang" "levanger" ;
  leveranstid_nn_1_N = mkN "leveranstid" "leveranstider" ;
  leverantoer_nn_1_1_N = mkN "leverantör" "leverantörer" ;
  levercell_nn_1_N = mkN "levercell" "leverceller" ;
  levnad_nn_1_N = mkN "levnad" "levnader" ;
  levnadskonstnaer_nn_1_1_N = mkN "levnadskonstnär" "levnadskonstnärer" ;
  levnadskostnad_nn_1_N = mkN "levnadskostnad" "levnadskostnader" ;
  lexikograf_nn_1_N = mkN "lexikograf" "lexikografer" ;
  libation_nn_1_N = mkN "libation" "libationer" ;
  libell_nn_1_N = mkN "libell" "libeller" ;
  libration_nn_1_N = mkN "libration" "librationer" ;
  licentiat_nn_1_N = mkN "licentiat" "licentiater" ;
  lid_nn_1_N = mkN "lid" "lider" ;
  lidelse_nn_1_N = mkN "lidelse" "lidelser" ;
  lidelsefullhet_nn_1_N = mkN "lidelsefullhet" "lidelsefullheter" ;
  liderlighet_nn_1_N = mkN "liderlighet" "liderligheter" ;
  liggetid_nn_1_N = mkN "liggetid" "liggetider" ;
  lignin_nn_1_N = mkN "lignin" "ligniner" ;
  likaloen_nn_1_1_N = mkN "likalön" "likalöner" ;
  likbjudarmin_nn_1_N = mkN "likbjudarmin" "likbjudarminer" ;
  likblaanad_nn_1_1_N = mkN "likblånad" "likblånader" ;
  likformighet_nn_1_N = mkN "likformighet" "likformigheter" ;
  likfaerd_nn_1_1_N = mkN "likfärd" "likfärder" ;
  likgiltighet_nn_1_N = mkN "likgiltighet" "likgiltigheter" ;
  likhet_nn_1_N = mkN "likhet" "likheter" ;
  liknelse_nn_1_N = mkN "liknelse" "liknelser" ;
  likstelhet_nn_1_N = mkN "likstelhet" "likstelheter" ;
  likstaellighet_nn_1_1_N = mkN "likställighet" "likställigheter" ;
  likstaemmighet_nn_1_1_N = mkN "likstämmighet" "likstämmigheter" ;
  likvidation_nn_1_N = mkN "likvidation" "likvidationer" ;
  likviditet_nn_1_N = mkN "likviditet" "likviditeter" ;
  likoer_nn_1_1_N = mkN "likör" "likörer" ;
  liljekonvalje_nn_1_N = mkN "liljekonvalje" "liljekonvaljer" ;
  lime_nn_1_N = mkN "lime" "limer" ;
  limfaerg_nn_1_1_N = mkN "limfärg" "limfärger" ;
  limit_nn_1_N = mkN "limit" "limiter" ;
  limitation_nn_1_N = mkN "limitation" "limitationer" ;
  limningsmaskin_nn_1_N = mkN "limningsmaskin" "limningsmaskiner" ;
  limnograf_nn_1_N = mkN "limnograf" "limnografer" ;
  limousine_nn_1_N = mkN "limousine" "limousiner" ;
  lingonsaft_nn_1_N = mkN "lingonsaft" "lingonsafter" ;
  lingonsylt_nn_1_N = mkN "lingonsylt" "lingonsylter" ;
  linjal_nn_1_N = mkN "linjal" "linjaler" ;
  linje_nn_1_N = mkN "linje" "linjer" ;
  linjenaemnd_nn_1_1_N = mkN "linjenämnd" "linjenämnder" ;
  linnedraekt_nn_1_1_N = mkN "linnedräkt" "linnedräkter" ;
  linoljefaerg_nn_1_1_N = mkN "linoljefärg" "linoljefärger" ;
  lisen_nn_1_N = mkN "lisen" "lisener" ;
  listprofil_nn_1_N = mkN "listprofil" "listprofiler" ;
  litenhet_nn_1_N = mkN "litenhet" "litenheter" ;
  litograf_nn_1_N = mkN "litograf" "litografer" ;
  litteraturgenre_nn_1_N = mkN "litteraturgenre" "litteraturgenrer" ;
  litteratursyn_nn_1_N = mkN "litteratursyn" "litteratursyner" ;
  litteratoer_nn_1_1_N = mkN "litteratör" "litteratörer" ;
  liturg_nn_1_N = mkN "liturg" "liturger" ;
  livbojsort_nn_1_N = mkN "livbojsort" "livbojsorter" ;
  live_show_nn_1_N = mkN "live-show" "live-shower" ;
  livklaednad_nn_1_1_N = mkN "livklädnad" "livklädnader" ;
  livlighet_nn_1_N = mkN "livlighet" "livligheter" ;
  livraeddningsdraekt_nn_1_1_N = mkN "livräddningsdräkt" "livräddningsdräkter" ;
  livraett_nn_1_1_N = mkN "livrätt" "livrätter" ;
  livsbetingelse_nn_1_N = mkN "livsbetingelse" "livsbetingelser" ;
  livserfarenhet_nn_1_N = mkN "livserfarenhet" "livserfarenheter" ;
  livsfarlighet_nn_1_N = mkN "livsfarlighet" "livsfarligheter" ;
  livsform_nn_1_N = mkN "livsform" "livsformer" ;
  livsfrukt_nn_1_N = mkN "livsfrukt" "livsfrukter" ;
  livsfoernekelse_nn_1_1_N = mkN "livsförnekelse" "livsförnekelser" ;
  livskamrat_nn_1_N = mkN "livskamrat" "livskamrater" ;
  livskvalitet_nn_1_N = mkN "livskvalitet" "livskvaliteter" ;
  livslinje_nn_1_N = mkN "livslinje" "livslinjer" ;
  livslaengd_nn_1_1_N = mkN "livslängd" "livslängder" ;
  livsloegn_nn_1_1_N = mkN "livslögn" "livslögner" ;
  livsmedelsaffaer_nn_1_1_N = mkN "livsmedelsaffär" "livsmedelsaffärer" ;
  livsmedelsbutik_nn_1_N = mkN "livsmedelsbutik" "livsmedelsbutiker" ;
  livsmedelsfaerg_nn_1_1_N = mkN "livsmedelsfärg" "livsmedelsfärger" ;
  livsnerv_nn_1_N = mkN "livsnerv" "livsnerver" ;
  livsreaktion_nn_1_N = mkN "livsreaktion" "livsreaktioner" ;
  livssituation_nn_1_N = mkN "livssituation" "livssituationer" ;
  livssyn_nn_1_N = mkN "livssyn" "livssyner" ;
  livsuppgift_nn_1_N = mkN "livsuppgift" "livsuppgifter" ;
  livvakt_nn_1_N = mkN "livvakt" "livvakter" ;
  ljudbild_nn_1_N = mkN "ljudbild" "ljudbilder" ;
  ljudfilm_nn_1_N = mkN "ljudfilm" "ljudfilmer" ;
  ljudfoerbindelse_nn_1_1_N = mkN "ljudförbindelse" "ljudförbindelser" ;
  ljudhastighet_nn_1_N = mkN "ljudhastighet" "ljudhastigheter" ;
  ljudkvalitet_nn_1_N = mkN "ljudkvalitet" "ljudkvaliteter" ;
  ljudskrift_nn_1_N = mkN "ljudskrift" "ljudskrifter" ;
  ljumhet_nn_1_N = mkN "ljumhet" "ljumheter" ;
  ljumsktrakt_nn_1_N = mkN "ljumsktrakt" "ljumsktrakter" ;
  ljusalf_nn_1_N = mkN "ljusalf" "ljusalfer" ;
  ljusalv_nn_1_N = mkN "ljusalv" "ljusalver" ;
  ljusbild_nn_1_N = mkN "ljusbild" "ljusbilder" ;
  ljusgestalt_nn_1_N = mkN "ljusgestalt" "ljusgestalter" ;
  ljushastighet_nn_1_N = mkN "ljushastighet" "ljushastigheter" ;
  ljuskaenslighet_nn_1_1_N = mkN "ljuskänslighet" "ljuskänsligheter" ;
  ljuspunkt_nn_1_N = mkN "ljuspunkt" "ljuspunkter" ;
  ljusramp_nn_1_N = mkN "ljusramp" "ljusramper" ;
  ljusskygghet_nn_1_N = mkN "ljusskygghet" "ljusskyggheter" ;
  ljuvhet_nn_1_N = mkN "ljuvhet" "ljuvheter" ;
  ljuvlighet_nn_1_N = mkN "ljuvlighet" "ljuvligheter" ;
  lob_nn_1_N = mkN "lob" "lober" ;
  lobbyverksamhet_nn_1_N = mkN "lobbyverksamhet" "lobbyverksamheter" ;
  lockelse_nn_1_N = mkN "lockelse" "lockelser" ;
  lockfaerg_nn_1_1_N = mkN "lockfärg" "lockfärger" ;
  lockout_nn_1_N = mkN "lockout" "lockouter" ;
  locktaang_nn_1_1_N = mkN "locktång" "locktänger" ;
  lodlinje_nn_1_N = mkN "lodlinje" "lodlinjer" ;
  logaritm_nn_1_N = mkN "logaritm" "logaritmer" ;
  loge_nn_2_N = mkN "loge" "loger" ;
  logoped_nn_1_N = mkN "logoped" "logopeder" ;
  lojalitet_nn_1_N = mkN "lojalitet" "lojaliteter" ;
  lokalchef_nn_1_N = mkN "lokalchef" "lokalchefer" ;
  lokalfaerg_nn_1_1_N = mkN "lokalfärg" "lokalfärger" ;
  lokalitet_nn_1_N = mkN "lokalitet" "lokaliteter" ;
  lokaltid_nn_1_N = mkN "lokaltid" "lokaltider" ;
  lokatt_nn_1_N = mkN "lokatt" "lokatter" ;
  longitud_nn_1_N = mkN "longitud" "longituder" ;
  longoer_nn_1_1_N = mkN "longör" "longörer" ;
  loppmarknad_nn_1_N = mkN "loppmarknad" "loppmarknader" ;
  lord_nn_1_N = mkN "lord" "lorder" ;
  lornjett_nn_1_N = mkN "lornjett" "lornjetter" ;
  lossningskaj_nn_1_N = mkN "lossningskaj" "lossningskajer" ;
  lotsled_nn_1_N = mkN "lotsled" "lotsleder" ;
  lott_nn_1_N = mkN "lott" "lotter" ;
  lottakaar_nn_1_1_N = mkN "lottakår" "lottakårer" ;
  lottaroerelse_nn_1_1_N = mkN "lottarörelse" "lottarörelser" ;
  lounge_nn_1_N = mkN "lounge" "lounger" ;
  lovpsalm_nn_1_N = mkN "lovpsalm" "lovpsalmer" ;
  lovsaang_nn_1_1_N = mkN "lovsång" "lovsånger" ;
  loxodrom_nn_1_N = mkN "loxodrom" "loxodromer" ;
  luciasaang_nn_1_1_N = mkN "luciasång" "luciasånger" ;
  luddighet_nn_1_N = mkN "luddighet" "luddigheter" ;
  luftaffaer_nn_1_1_N = mkN "luftaffär" "luftaffärer" ;
  luftakrobat_nn_1_N = mkN "luftakrobat" "luftakrobater" ;
  luftattack_nn_1_N = mkN "luftattack" "luftattacker" ;
  luftballong_nn_1_N = mkN "luftballong" "luftballonger" ;
  luftfartsmyndighet_nn_1_N = mkN "luftfartsmyndighet" "luftfartsmyndigheter" ;
  luftfuktighet_nn_1_N = mkN "luftfuktighet" "luftfuktigheter" ;
  luftfaerd_nn_1_1_N = mkN "luftfärd" "luftfärder" ;
  luftighet_nn_1_N = mkN "luftighet" "luftigheter" ;
  luftkonditioneringsapparat_nn_1_N = mkN "luftkonditioneringsapparat" "luftkonditioneringsapparater" ;
  luftkub_nn_1_N = mkN "luftkub" "luftkuber" ;
  luftkvalitet_nn_1_N = mkN "luftkvalitet" "luftkvaliteter" ;
  luftled_nn_1_N = mkN "luftled" "luftleder" ;
  luftmaengd_nn_1_1_N = mkN "luftmängd" "luftmängder" ;
  luftventil_nn_1_N = mkN "luftventil" "luftventiler" ;
  luftvaegsinfektion_nn_1_1_N = mkN "luftvägsinfektion" "luftvägsinfektioner" ;
  luftvaernskanon_nn_1_1_N = mkN "luftvärnskanon" "luftvärnskanoner" ;
  luktnerv_nn_1_N = mkN "luktnerv" "luktnerver" ;
  luktvial_nn_1_N = mkN "luktvial" "luktvialer" ;
  luktviol_nn_1_N = mkN "luktviol" "luktvioler" ;
  luktaert_nn_1_1_N = mkN "luktärt" "luktärter" ;
  lumbalpunktion_nn_1_N = mkN "lumbalpunktion" "lumbalpunktioner" ;
  lunation_nn_1_N = mkN "lunation" "lunationer" ;
  lunchtid_nn_1_N = mkN "lunchtid" "lunchtider" ;
  lunginflammation_nn_1_N = mkN "lunginflammation" "lunginflammationer" ;
  lunglob_nn_1_N = mkN "lunglob" "lunglober" ;
  lungsaecksinflammation_nn_1_1_N = mkN "lungsäcksinflammation" "lungsäcksinflammationer" ;
  lungvaevnad_nn_1_1_N = mkN "lungvävnad" "lungvävnader" ;
  lungoert_nn_1_1_N = mkN "lungört" "lungörter" ;
  lupp_nn_1_N = mkN "lupp" "lupper" ;
  lurighet_nn_1_N = mkN "lurighet" "lurigheter" ;
  lusern_nn_1_N = mkN "lusern" "luserner" ;
  lussekatt_nn_1_N = mkN "lussekatt" "lussekatter" ;
  lustbarhet_nn_1_N = mkN "lustbarhet" "lustbarheter" ;
  lustfaerd_nn_1_1_N = mkN "lustfärd" "lustfärder" ;
  lustighet_nn_1_N = mkN "lustighet" "lustigheter" ;
  lustjakt_nn_1_N = mkN "lustjakt" "lustjakter" ;
  lustpark_nn_1_N = mkN "lustpark" "lustparker" ;
  lustupplevelse_nn_1_N = mkN "lustupplevelse" "lustupplevelser" ;
  lutningsvariation_nn_1_N = mkN "lutningsvariation" "lutningsvariationer" ;
  luxation_nn_1_N = mkN "luxation" "luxationer" ;
  lycklighet_nn_1_N = mkN "lycklighet" "lyckligheter" ;
  lyckoentreprenoer_nn_1_1_N = mkN "lyckoentreprenör" "lyckoentreprenörer" ;
  lydelse_nn_1_N = mkN "lydelse" "lydelser" ;
  lydstat_nn_1_N = mkN "lydstat" "lydstater" ;
  lyfthoejd_nn_1_1_N = mkN "lyfthöjd" "lyfthöjder" ;
  lyftkapacitet_nn_1_N = mkN "lyftkapacitet" "lyftkapaciteter" ;
  lyftkraft_nn_1_N = mkN "lyftkraft" "lyftkrafter" ;
  lyftpunkt_nn_1_N = mkN "lyftpunkt" "lyftpunkter" ;
  lyktrad_nn_1_N = mkN "lyktrad" "lyktrader" ;
  lymfocyt_nn_1_N = mkN "lymfocyt" "lymfocyter" ;
  lysbomb_nn_1_N = mkN "lysbomb" "lysbomber" ;
  lysosom_nn_1_N = mkN "lysosom" "lysosomer" ;
  lyspatron_nn_1_N = mkN "lyspatron" "lyspatroner" ;
  lysraket_nn_1_N = mkN "lysraket" "lysraketer" ;
  lyssnarapparat_nn_1_N = mkN "lyssnarapparat" "lyssnarapparater" ;
  lysterfaerg_nn_1_1_N = mkN "lysterfärg" "lysterfärger" ;
  lystnad_nn_1_N = mkN "lystnad" "lystnader" ;
  lyxighet_nn_1_N = mkN "lyxighet" "lyxigheter" ;
  lyxkonsumtion_nn_1_N = mkN "lyxkonsumtion" "lyxkonsumtioner" ;
  lyxlaegenhet_nn_1_1_N = mkN "lyxlägenhet" "lyxlägenheter" ;
  laebbighet_nn_1_1_N = mkN "läbbighet" "läbbigheter" ;
  laeckerhet_nn_1_1_N = mkN "läckerhet" "läckerheter" ;
  laegenhet_nn_1_1_N = mkN "lägenhet" "lägenheter" ;
  laegenhetsbrand_nn_1_1_N = mkN "lägenhetsbrand" "lägenhetsbränder" ;
  laekarcentral_nn_1_1_N = mkN "läkarcentral" "läkarcentraler" ;
  laekarkaar_nn_1_1_N = mkN "läkarkår" "läkarkårer" ;
  laekarlegitimation_nn_1_1_N = mkN "läkarlegitimation" "läkarlegitimationer" ;
  laekarordination_nn_1_1_N = mkN "läkarordination" "läkarordinationer" ;
  laekt_nn_1_1_N = mkN "läkt" "läkter" ;
  laemplighet_nn_1_1_N = mkN "lämplighet" "lämpligheter" ;
  laend_nn_1_1_N = mkN "länd" "länder" ;
  laendergrupp_nn_1_1_N = mkN "ländergrupp" "ländergrupper" ;
  laengdenhet_nn_1_1_N = mkN "längdenhet" "längdenheter" ;
  laengdgrad_nn_1_1_N = mkN "längdgrad" "längdgrader" ;
  laengdprofil_nn_1_1_N = mkN "längdprofil" "längdprofiler" ;
  laenkroerelse_nn_1_1_N = mkN "länkrörelse" "länkrörelser" ;
  laenkstation_nn_1_1_N = mkN "länkstation" "länkstationer" ;
  laensarbetsnaemnd_nn_1_1_N = mkN "länsarbetsnämnd" "länsarbetsnämnder" ;
  laensarkitekt_nn_1_1_N = mkN "länsarkitekt" "länsarkitekter" ;
  laensbokstav_nn_1_1_N = mkN "länsbokstav" "länsbokstäver" ;
  laenskod_nn_1_1_N = mkN "länskod" "länskoder" ;
  laenskommunikationscentral_nn_1_1_N = mkN "länskommunikationscentral" "länskommunikationscentraler" ;
  laensraett_nn_1_1_N = mkN "länsrätt" "länsrätter" ;
  laensskatteraett_nn_1_1_N = mkN "länsskatterätt" "länsskatterätter" ;
  laensskolnaemnd_nn_1_1_N = mkN "länsskolnämnd" "länsskolnämnder" ;
  laensstyrelse_nn_1_1_N = mkN "länsstyrelse" "länsstyrelser" ;
  laepproerelse_nn_1_1_N = mkN "läpprörelse" "läpprörelser" ;
  laerarkandidat_nn_1_1_N = mkN "lärarkandidat" "lärarkandidater" ;
  laerarkaar_nn_1_1_N = mkN "lärarkår" "lärarkårer" ;
  laerarlegitimation_nn_1_1_N = mkN "lärarlegitimation" "lärarlegitimationer" ;
  laerarlinje_nn_1_1_N = mkN "lärarlinje" "lärarlinjer" ;
  laerarroll_nn_1_1_N = mkN "lärarroll" "lärarroller" ;
  laerartaethet_nn_1_1_N = mkN "lärartäthet" "lärartätheter" ;
  laerdomsstad_nn_1_1_N = mkN "lärdomsstad" "lärdomsstäder" ;
  laerft_nn_1_1_N = mkN "lärft" "lärfter" ;
  laeroanstalt_nn_1_1_N = mkN "läroanstalt" "läroanstalter" ;
  laeroboksnaemnd_nn_1_1_N = mkN "läroboksnämnd" "läroboksnämnder" ;
  laerobyggnad_nn_1_1_N = mkN "lärobyggnad" "lärobyggnader" ;
  laerodikt_nn_1_1_N = mkN "lärodikt" "lärodikter" ;
  laesapparat_nn_1_1_N = mkN "läsapparat" "läsapparater" ;
  laesart_nn_1_1_N = mkN "läsart" "läsarter" ;
  laesbarhet_nn_1_1_N = mkN "läsbarhet" "läsbarheter" ;
  laesefrukt_nn_1_1_N = mkN "läsefrukt" "läsefrukter" ;
  laesesalong_nn_1_1_N = mkN "läsesalong" "läsesalonger" ;
  laesfaerdighet_nn_1_1_N = mkN "läsfärdighet" "läsfärdigheter" ;
  laesion_nn_1_1_N = mkN "läsion" "läsioner" ;
  laeskamrat_nn_1_1_N = mkN "läskamrat" "läskamrater" ;
  laeskedryck_nn_1_1_N = mkN "läskedryck" "läskedrycker" ;
  laeskighet_nn_1_1_N = mkN "läskighet" "läskigheter" ;
  laesklinik_nn_1_1_N = mkN "läsklinik" "läskliniker" ;
  laeskstaang_nn_1_1_N = mkN "läskstång" "läskstänger" ;
  laeskunnighet_nn_1_1_N = mkN "läskunnighet" "läskunnigheter" ;
  laessvaarighet_nn_1_1_N = mkN "lässvårighet" "lässvårigheter" ;
  laesupplevelse_nn_1_1_N = mkN "läsupplevelse" "läsupplevelser" ;
  laesvaerdhet_nn_1_1_N = mkN "läsvärdhet" "läsvärdheter" ;
  laettfaerdighet_nn_1_1_N = mkN "lättfärdighet" "lättfärdigheter" ;
  laettmetall_nn_1_1_N = mkN "lättmetall" "lättmetaller" ;
  laettnad_nn_1_1_N = mkN "lättnad" "lättnader" ;
  laettsamhet_nn_1_1_N = mkN "lättsamhet" "lättsamheter" ;
  laettsinnighet_nn_1_1_N = mkN "lättsinnighet" "lättsinnigheter" ;
  laettvindighet_nn_2_1_N = mkN "lättvindighet" "lättvindigheter" ;
  laagfaerg_nn_1_1_N = mkN "lågfärg" "lågfärger" ;
  laaghet_nn_1_1_N = mkN "låghet" "lågheter" ;
  laagloeneprofil_nn_1_1_N = mkN "låglöneprofil" "låglöneprofiler" ;
  laagrelief_nn_1_1_N = mkN "lågrelief" "lågreliefer" ;
  laagsko_nn_1_1_N = mkN "lågsko" "lågskor" ;
  laagslaett_nn_1_1_N = mkN "lågslätt" "lågslätter" ;
  laaneexpedition_nn_1_1_N = mkN "låneexpedition" "låneexpeditioner" ;
  laaneform_nn_1_1_N = mkN "låneform" "låneformer" ;
  laangdistansraket_nn_1_1_N = mkN "långdistansraket" "långdistansraketer" ;
  laangfilm_nn_1_1_N = mkN "långfilm" "långfilmer" ;
  laangfaerd_nn_1_1_N = mkN "långfärd" "långfärder" ;
  laanggardin_nn_1_1_N = mkN "långgardin" "långgardiner" ;
  laanghelg_nn_1_1_N = mkN "långhelg" "långhelger" ;
  laangledighet_nn_1_1_N = mkN "långledighet" "långledigheter" ;
  laangpromenad_nn_1_1_N = mkN "långpromenad" "långpromenader" ;
  laangsynthet_nn_1_1_N = mkN "långsynthet" "långsyntheter" ;
  laangtur_nn_1_1_N = mkN "långtur" "långturer" ;
  laassmed_nn_1_1_N = mkN "låssmed" "låssmeder" ;
  laatsascigarett_nn_1_1_N = mkN "låtsascigarett" "låtsascigaretter" ;
  laatstoeld_nn_1_1_N = mkN "låtstöld" "låtstölder" ;
  loedmetall_nn_1_1_N = mkN "lödmetall" "lödmetaller" ;
  loeftesskrift_nn_1_1_N = mkN "löftesskrift" "löftesskrifter" ;
  loegn_nn_1_1_N = mkN "lögn" "lögner" ;
  loegnaktighet_nn_1_1_N = mkN "lögnaktighet" "lögnaktigheter" ;
  loejlighet_nn_1_1_N = mkN "löjlighet" "löjligheter" ;
  loejtnant_nn_1_1_N = mkN "löjtnant" "löjtnanter" ;
  loekighet_nn_1_1_N = mkN "lökighet" "lökigheter" ;
  loenefil_nn_1_1_N = mkN "lönefil" "lönefiler" ;
  loenefoermaan_nn_1_1_N = mkN "löneförmån" "löneförmåner" ;
  loenegrad_nn_1_1_N = mkN "lönegrad" "lönegrader" ;
  loenekostnad_nn_1_1_N = mkN "lönekostnad" "lönekostnader" ;
  loeneroerelse_nn_1_1_N = mkN "lönerörelse" "lönerörelser" ;
  loeneuppgift_nn_1_1_N = mkN "löneuppgift" "löneuppgifter" ;
  loensamhet_nn_1_1_N = mkN "lönsamhet" "lönsamheter" ;
  loentagarfond_nn_1_1_N = mkN "löntagarfond" "löntagarfonder" ;
  loepteknik_nn_1_1_N = mkN "löpteknik" "löptekniker" ;
  loeptid_nn_1_1_N = mkN "löptid" "löptider" ;
  loepvikt_nn_1_1_N = mkN "löpvikt" "löpvikter" ;
  loeslighet_nn_2_1_N = mkN "löslighet" "lösligheter" ;
  loesningsegenskap_nn_1_1_N = mkN "lösningsegenskap" "lösningsegenskaper" ;
  loevhyddohoegtid_nn_1_1_N = mkN "lövhyddohögtid" "lövhyddohögtider" ;
  loevtaekt_nn_1_1_N = mkN "lövtäkt" "lövtäkter" ;
  machete_nn_1_N = mkN "machete" "macheter" ;
  machomyt_nn_1_N = mkN "machomyt" "machomyter" ;
  mackapaer_nn_1_1_N = mkN "mackapär" "mackapärer" ;
  mad_nn_1_N = mkN "mad" "mader" ;
  madame_nn_1_N = mkN "madame" "madamer" ;
  madapolam_nn_1_N = mkN "madapolam" "madapolamer" ;
  madrassfabrik_nn_1_N = mkN "madrassfabrik" "madrassfabriker" ;
  madrigal_nn_1_N = mkN "madrigal" "madrigaler" ;
  maffiafilm_nn_1_N = mkN "maffiafilm" "maffiafilmer" ;
  magistrat_nn_1_N = mkN "magistrat" "magistrater" ;
  magmabergart_nn_1_N = mkN "magmabergart" "magmabergarter" ;
  magmaexplosion_nn_1_N = mkN "magmaexplosion" "magmaexplosioner" ;
  magnesiumsulfat_nn_1_N = mkN "magnesiumsulfat" "magnesiumsulfater" ;
  magnetapparat_nn_1_N = mkN "magnetapparat" "magnetapparater" ;
  magnetisoer_nn_1_1_N = mkN "magnetisör" "magnetisörer" ;
  magnetpol_nn_1_N = mkN "magnetpol" "magnetpoler" ;
  magnitud_nn_1_N = mkN "magnitud" "magnituder" ;
  magsaft_nn_1_N = mkN "magsaft" "magsafter" ;
  magsaarsbakterie_nn_1_1_N = mkN "magsårsbakterie" "magsårsbakterier" ;
  magtrakt_nn_1_N = mkN "magtrakt" "magtrakter" ;
  magyar_nn_1_N = mkN "magyar" "magyarer" ;
  mahognymotorjakt_nn_1_N = mkN "mahognymotorjakt" "mahognymotorjakter" ;
  majestaetsfoerbrytelse_nn_1_1_N = mkN "majestätsförbrytelse" "majestätsförbrytelser" ;
  majoritet_nn_1_N = mkN "majoritet" "majoriteter" ;
  majoritetskoalition_nn_1_N = mkN "majoritetskoalition" "majoritetskoalitioner" ;
  majstaang_nn_1_1_N = mkN "majstång" "majstänger" ;
  makaloeshet_nn_2_1_N = mkN "makalöshet" "makalösheter" ;
  maktbefogenhet_nn_1_N = mkN "maktbefogenhet" "maktbefogenheter" ;
  maktkamp_nn_1_N = mkN "maktkamp" "maktkamper" ;
  maktkoncentration_nn_1_N = mkN "maktkoncentration" "maktkoncentrationer" ;
  maktposition_nn_1_N = mkN "maktposition" "maktpositioner" ;
  maktsfaer_nn_1_1_N = mkN "maktsfär" "maktsfärer" ;
  maktstrid_nn_1_N = mkN "maktstrid" "maktstrider" ;
  malm_nn_2_N = mkN "malm" "malmer" ;
  malmfyndighet_nn_1_N = mkN "malmfyndighet" "malmfyndigheter" ;
  malmhalt_nn_1_N = mkN "malmhalt" "malmhalter" ;
  malmklang_nn_1_N = mkN "malmklang" "malmklanger" ;
  malmtaekt_nn_1_1_N = mkN "malmtäkt" "malmtäkter" ;
  malmoebo_nn_1_1_N = mkN "malmöbo" "malmöbor" ;
  maltdryck_nn_1_N = mkN "maltdryck" "maltdrycker" ;
  maloer_nn_1_1_N = mkN "malör" "malörer" ;
  mambo_nn_1_N = mkN "mambo" "mambor" ;
  mammutpopulation_nn_1_N = mkN "mammutpopulation" "mammutpopulationer" ;
  mamsell_nn_1_N = mkN "mamsell" "mamseller" ;
  manbyggnad_nn_1_N = mkN "manbyggnad" "manbyggnader" ;
  manchesterkostym_nn_1_N = mkN "manchesterkostym" "manchesterkostymer" ;
  mandatperiod_nn_1_N = mkN "mandatperiod" "mandatperioder" ;
  mandrill_nn_1_N = mkN "mandrill" "mandriller" ;
  manege_nn_1_N = mkN "manege" "maneger" ;
  manet_nn_1_N = mkN "manet" "maneter" ;
  mangrove_nn_1_N = mkN "mangrove" "mangrover" ;
  mangaardsbyggnad_nn_1_1_N = mkN "mangårdsbyggnad" "mangårdsbyggnader" ;
  manick_nn_1_N = mkN "manick" "manicker" ;
  manifestation_nn_1_N = mkN "manifestation" "manifestationer" ;
  manipulation_nn_1_N = mkN "manipulation" "manipulationer" ;
  mankill_nn_1_N = mkN "mankill" "mankiller" ;
  mannekaeng_nn_1_1_N = mkN "mannekäng" "mannekänger" ;
  mansard_nn_1_N = mkN "mansard" "mansarder" ;
  manschett_nn_1_N = mkN "manschett" "manschetter" ;
  mansdraekt_nn_1_1_N = mkN "mansdräkt" "mansdräkter" ;
  manshoejd_nn_1_1_N = mkN "manshöjd" "manshöjder" ;
  manskvartett_nn_1_N = mkN "manskvartett" "manskvartetter" ;
  manskoer_nn_1_1_N = mkN "manskör" "manskörer" ;
  mansperson_nn_1_N = mkN "mansperson" "manspersoner" ;
  mantalslaengd_nn_1_1_N = mkN "mantalslängd" "mantalslängder" ;
  mantelroerelse_nn_1_1_N = mkN "mantelrörelse" "mantelrörelser" ;
  manual_nn_1_N = mkN "manual" "manualer" ;
  manoeverkraft_nn_1_1_N = mkN "manöverkraft" "manöverkrafter" ;
  mardroemsstart_nn_1_1_N = mkN "mardrömsstart" "mardrömsstarter" ;
  mardroemssyn_nn_1_1_N = mkN "mardrömssyn" "mardrömssyner" ;
  marg_nn_1_N = mkN "marg" "marger" ;
  margarin_nn_1_N = mkN "margarin" "margariner" ;
  marginal_nn_1_N = mkN "marginal" "marginaler" ;
  marginaleffekt_nn_1_N = mkN "marginaleffekt" "marginaleffekter" ;
  marginalintaekt_nn_1_1_N = mkN "marginalintäkt" "marginalintäkter" ;
  marginalkostnad_nn_1_N = mkN "marginalkostnad" "marginalkostnader" ;
  marighet_nn_1_N = mkN "marighet" "marigheter" ;
  marinkaar_nn_1_1_N = mkN "marinkår" "marinkårer" ;
  marionett_nn_1_N = mkN "marionett" "marionetter" ;
  markkonflikt_nn_1_N = mkN "markkonflikt" "markkonflikter" ;
  marknad_nn_1_N = mkN "marknad" "marknader" ;
  marknadsfoeringskupp_nn_1_1_N = mkN "marknadsföringskupp" "marknadsföringskupper" ;
  marknadsmanipulation_nn_1_N = mkN "marknadsmanipulation" "marknadsmanipulationer" ;
  marknadsmaessighet_nn_1_1_N = mkN "marknadsmässighet" "marknadsmässigheter" ;
  marknadsreaktion_nn_1_N = mkN "marknadsreaktion" "marknadsreaktioner" ;
  marknadsreform_nn_1_N = mkN "marknadsreform" "marknadsreformer" ;
  markoer_nn_1_1_N = mkN "markör" "markörer" ;
  marodoer_nn_1_1_N = mkN "marodör" "marodörer" ;
  marschall_nn_1_N = mkN "marschall" "marschaller" ;
  marschfart_nn_1_N = mkN "marschfart" "marschfarter" ;
  marshmallow_nn_1_N = mkN "marshmallow" "marshmallower" ;
  marskatt_nn_1_N = mkN "marskatt" "marskatter" ;
  martyr_nn_1_N = mkN "martyr" "martyrer" ;
  marviol_nn_1_N = mkN "marviol" "marvioler" ;
  maraeng_nn_1_1_N = mkN "maräng" "maränger" ;
  maskeradbal_nn_1_N = mkN "maskeradbal" "maskeradbaler" ;
  maskeraddraekt_nn_1_1_N = mkN "maskeraddräkt" "maskeraddräkter" ;
  maskinpark_nn_1_N = mkN "maskinpark" "maskinparker" ;
  maskintid_nn_1_N = mkN "maskintid" "maskintider" ;
  maskinverkstad_nn_1_N = mkN "maskinverkstad" "maskinverkstäder" ;
  maskningsaktion_nn_1_N = mkN "maskningsaktion" "maskningsaktioner" ;
  masktaethet_nn_1_1_N = mkN "masktäthet" "masktätheter" ;
  maskulinum_nn_1_N = mkN "maskulin" "maskuliner" ;
  maskoer_nn_1_1_N = mkN "maskör" "maskörer" ;
  massafabrik_nn_1_N = mkN "massafabrik" "massafabriker" ;
  massageapparat_nn_1_N = mkN "massageapparat" "massageapparater" ;
  massagefaatoelj_nn_1_1_N = mkN "massagefåtölj" "massagefåtöljer" ;
  massakerklan_nn_1_N = mkN "massakerklan" "massakerklaner" ;
  massillusion_nn_1_N = mkN "massillusion" "massillusioner" ;
  massivitet_nn_1_N = mkN "massivitet" "massiviteter" ;
  masskommunikation_nn_1_N = mkN "masskommunikation" "masskommunikationer" ;
  masslakt_nn_1_N = mkN "masslakt" "masslakter" ;
  massverkanseffekt_nn_1_N = mkN "massverkanseffekt" "massverkanseffekter" ;
  massvaaldtaekt_nn_1_1_N = mkN "massvåldtäkt" "massvåldtäkter" ;
  massoer_nn_1_1_N = mkN "massör" "massörer" ;
  mastodont_nn_1_N = mkN "mastodont" "mastodonter" ;
  masturbation_nn_1_N = mkN "masturbation" "masturbationer" ;
  matbutik_nn_1_N = mkN "matbutik" "matbutiker" ;
  materialisation_nn_1_N = mkN "materialisation" "materialisationer" ;
  materie_nn_1_N = mkN "materie" "materier" ;
  matfrukt_nn_1_N = mkN "matfrukt" "matfrukter" ;
  matkupong_nn_1_N = mkN "matkupong" "matkuponger" ;
  matlagningsskicklighet_nn_1_N = mkN "matlagningsskicklighet" "matlagningsskickligheter" ;
  matnyttighet_nn_1_N = mkN "matnyttighet" "matnyttigheter" ;
  matpatrull_nn_1_N = mkN "matpatrull" "matpatruller" ;
  matranson_nn_1_N = mkN "matranson" "matransoner" ;
  matroskostym_nn_1_N = mkN "matroskostym" "matroskostymer" ;
  matraett_nn_1_1_N = mkN "maträtt" "maträtter" ;
  matsalong_nn_1_N = mkN "matsalong" "matsalonger" ;
  matsmaeltningsapparat_nn_1_1_N = mkN "matsmältningsapparat" "matsmältningsapparater" ;
  matsmaeltningskanal_nn_1_1_N = mkN "matsmältningskanal" "matsmältningskanaler" ;
  matthet_nn_1_N = mkN "matthet" "mattheter" ;
  mattighet_nn_1_N = mkN "mattighet" "mattigheter" ;
  mattkamp_nn_1_N = mkN "mattkamp" "mattkamper" ;
  matvaruaffaer_nn_1_1_N = mkN "matvaruaffär" "matvaruaffärer" ;
  maxfart_nn_1_N = mkN "maxfart" "maxfarter" ;
  maxhastighet_nn_1_N = mkN "maxhastighet" "maxhastigheter" ;
  maxill_nn_1_N = mkN "maxill" "maxiller" ;
  maxiloen_nn_1_1_N = mkN "maxilön" "maxilöner" ;
  maxim_nn_1_N = mkN "maxim" "maximer" ;
  maximipunkt_nn_1_N = mkN "maximipunkt" "maximipunkter" ;
  mecenat_nn_1_N = mkN "mecenat" "mecenater" ;
  medalj_nn_1_N = mkN "medalj" "medaljer" ;
  medaljong_nn_1_N = mkN "medaljong" "medaljonger" ;
  medaljoer_nn_1_1_N = mkN "medaljör" "medaljörer" ;
  medborgarraettsroerelse_nn_1_1_N = mkN "medborgarrättsrörelse" "medborgarrättsrörelser" ;
  medborgenaer_nn_1_1_N = mkN "medborgenär" "medborgenärer" ;
  medeldistansraket_nn_1_N = mkN "medeldistansraket" "medeldistansraketer" ;
  medelhastighet_nn_1_N = mkN "medelhastighet" "medelhastigheter" ;
  medelhoejd_nn_1_1_N = mkN "medelhöjd" "medelhöjder" ;
  medellivslaengd_nn_1_1_N = mkN "medellivslängd" "medellivslängder" ;
  medellaengd_nn_1_1_N = mkN "medellängd" "medellängder" ;
  medelpunkt_nn_1_N = mkN "medelpunkt" "medelpunkter" ;
  medelsoltid_nn_1_N = mkN "medelsoltid" "medelsoltider" ;
  medelsvensson_nn_1_N = mkN "medelsvensson" "medelsvenssöner" ;
  medfinansiaer_nn_1_1_N = mkN "medfinansiär" "medfinansiärer" ;
  mediabild_nn_1_N = mkN "mediabild" "mediabilder" ;
  medicinalstyrelse_nn_1_N = mkN "medicinalstyrelse" "medicinalstyrelser" ;
  mediebild_nn_1_N = mkN "mediebild" "mediebilder" ;
  mediekanal_nn_1_N = mkN "mediekanal" "mediekanaler" ;
  mediemogul_nn_1_N = mkN "mediemogul" "mediemoguler" ;
  medieteknik_nn_1_N = mkN "medieteknik" "medietekniker" ;
  medietrend_nn_1_N = mkN "medietrend" "medietrender" ;
  medieval_nn_1_N = mkN "medieval" "medievaler" ;
  meditation_nn_1_N = mkN "meditation" "meditationer" ;
  mediuppgift_nn_1_N = mkN "mediuppgift" "mediuppgifter" ;
  medlarroll_nn_1_N = mkN "medlarroll" "medlarroller" ;
  medlemsavgift_nn_1_N = mkN "medlemsavgift" "medlemsavgifter" ;
  medlemsstat_nn_1_N = mkN "medlemsstat" "medlemsstater" ;
  medlingskommission_nn_1_N = mkN "medlingskommission" "medlingskommissioner" ;
  medregent_nn_1_N = mkN "medregent" "medregenter" ;
  medresenaer_nn_1_1_N = mkN "medresenär" "medresenärer" ;
  medtrafikant_nn_1_N = mkN "medtrafikant" "medtrafikanter" ;
  medvetenhet_nn_1_N = mkN "medvetenhet" "medvetenheter" ;
  megakollision_nn_1_N = mkN "megakollision" "megakollisioner" ;
  megaskuld_nn_1_N = mkN "megaskuld" "megaskulder" ;
  mejerifabrik_nn_1_N = mkN "mejerifabrik" "mejerifabriker" ;
  melatoninproduktion_nn_1_N = mkN "melatoninproduktion" "melatoninproduktioner" ;
  melioration_nn_1_N = mkN "melioration" "meliorationer" ;
  mellanakt_nn_1_N = mkN "mellanakt" "mellanakter" ;
  mellanchef_nn_1_N = mkN "mellanchef" "mellanchefer" ;
  mellanform_nn_1_N = mkN "mellanform" "mellanformer" ;
  mellanhand_nn_1_N = mkN "mellanhand" "mellanhänder" ;
  mellankrigstid_nn_1_N = mkN "mellankrigstid" "mellankrigstider" ;
  mellanraett_nn_1_1_N = mkN "mellanrätt" "mellanrätter" ;
  mellanskillnad_nn_1_N = mkN "mellanskillnad" "mellanskillnader" ;
  mellantid_nn_1_N = mkN "mellantid" "mellantider" ;
  mened_nn_1_N = mkN "mened" "meneder" ;
  menighet_nn_1_N = mkN "menighet" "menigheter" ;
  meningsbyggnad_nn_1_N = mkN "meningsbyggnad" "meningsbyggnader" ;
  meningsfraende_nn_1_1_N = mkN "meningsfrände" "meningsfränder" ;
  meningsloeshet_nn_1_1_N = mkN "meningslöshet" "meningslösheter" ;
  meningsskiljaktighet_nn_1_N = mkN "meningsskiljaktighet" "meningsskiljaktigheter" ;
  menloeshet_nn_1_1_N = mkN "menlöshet" "menlösheter" ;
  menstruation_nn_1_N = mkN "menstruation" "menstruationer" ;
  mentalitet_nn_1_N = mkN "mentalitet" "mentaliteter" ;
  mentalklinik_nn_1_N = mkN "mentalklinik" "mentalkliniker" ;
  menuett_nn_1_N = mkN "menuett" "menuetter" ;
  meridianhoejd_nn_1_1_N = mkN "meridianhöjd" "meridianhöjder" ;
  merkostnad_nn_1_N = mkN "merkostnad" "merkostnader" ;
  meskalin_nn_1_N = mkN "meskalin" "meskaliner" ;
  mesopotam_nn_1_N = mkN "mesopotam" "mesopotamer" ;
  mestgynnadnation_nn_1_N = mkN "mestgynnadnation" "mestgynnadnationer" ;
  metacenterhoejd_nn_1_1_N = mkN "metacenterhöjd" "metacenterhöjder" ;
  metall_nn_1_N = mkN "metall" "metaller" ;
  metallatom_nn_1_N = mkN "metallatom" "metallatomer" ;
  metallicfaerg_nn_1_1_N = mkN "metallicfärg" "metallicfärger" ;
  metallkapmaskin_nn_1_N = mkN "metallkapmaskin" "metallkapmaskiner" ;
  metallspiral_nn_1_N = mkN "metallspiral" "metallspiraler" ;
  metallurg_nn_1_N = mkN "metallurg" "metallurger" ;
  metallvikt_nn_1_N = mkN "metallvikt" "metallvikter" ;
  metan_nn_1_N = mkN "metan" "metaner" ;
  metatablett_nn_1_N = mkN "metatablett" "metatabletter" ;
  meterprototyp_nn_1_N = mkN "meterprototyp" "meterprototyper" ;
  metod_nn_1_N = mkN "metod" "metoder" ;
  metodsynpunkt_nn_1_N = mkN "metodsynpunkt" "metodsynpunkter" ;
  metodvetenskap_nn_1_N = mkN "metodvetenskap" "metodvetenskaper" ;
  metro_nn_1_N = mkN "metro" "metror" ;
  metronom_nn_1_N = mkN "metronom" "metronomer" ;
  micro_nn_1_N = mkN "micro" "micror" ;
  middagshoejd_nn_1_1_N = mkN "middagshöjd" "middagshöjder" ;
  middagstid_nn_1_N = mkN "middagstid" "middagstider" ;
  middagstystnad_nn_1_N = mkN "middagstystnad" "middagstystnader" ;
  midjetrakt_nn_1_N = mkN "midjetrakt" "midjetrakter" ;
  midskeppssektion_nn_1_N = mkN "midskeppssektion" "midskeppssektioner" ;
  midsommarhelg_nn_1_N = mkN "midsommarhelg" "midsommarhelger" ;
  midsommarnatt_nn_1_N = mkN "midsommarnatt" "midsommarnätter" ;
  midsommarstaang_nn_1_1_N = mkN "midsommarstång" "midsommarstänger" ;
  midsommartid_nn_1_N = mkN "midsommartid" "midsommartider" ;
  migration_nn_1_N = mkN "migration" "migrationer" ;
  migrationskommissionaer_nn_1_1_N = mkN "migrationskommissionär" "migrationskommissionärer" ;
  migraenattack_nn_1_1_N = mkN "migränattack" "migränattacker" ;
  mikro_nn_1_N = mkN "mikro" "mikror" ;
  mikroalg_nn_1_N = mkN "mikroalg" "mikroalger" ;
  mikrob_nn_1_N = mkN "mikrob" "mikrober" ;
  mikrofilm_nn_1_N = mkN "mikrofilm" "mikrofilmer" ;
  mikrofonteknik_nn_1_N = mkN "mikrofonteknik" "mikrofontekniker" ;
  mikrosekund_nn_1_N = mkN "mikrosekund" "mikrosekunder" ;
  mikrotom_nn_1_N = mkN "mikrotom" "mikrotomer" ;
  mildhet_nn_1_N = mkN "mildhet" "mildheter" ;
  militaer_nn_1_1_N = mkN "militär" "militärer" ;
  militaerkupp_nn_1_1_N = mkN "militärkupp" "militärkupper" ;
  militaermakt_nn_1_1_N = mkN "militärmakt" "militärmakter" ;
  militaerpromenad_nn_1_1_N = mkN "militärpromenad" "militärpromenader" ;
  militaeruniform_nn_1_1_N = mkN "militäruniform" "militäruniformer" ;
  miljardaffaer_nn_1_1_N = mkN "miljardaffär" "miljardaffärer" ;
  miljardaer_nn_1_1_N = mkN "miljardär" "miljardärer" ;
  miljonpublik_nn_1_N = mkN "miljonpublik" "miljonpubliker" ;
  miljonstad_nn_1_N = mkN "miljonstad" "miljonstäder" ;
  miljonaer_nn_1_1_N = mkN "miljonär" "miljonärer" ;
  miljoegiftshalt_nn_1_1_N = mkN "miljögiftshalt" "miljögiftshalter" ;
  miljoetidskrift_nn_1_1_N = mkN "miljötidskrift" "miljötidskrifter" ;
  mim_nn_1_N = mkN "mim" "mimer" ;
  mimosasallad_nn_1_N = mkN "mimosasallad" "mimosasallader" ;
  min_nn_1_N = mkN "min" "miner" ;
  minaret_nn_1_N = mkN "minaret" "minareter" ;
  minbomb_nn_1_N = mkN "minbomb" "minbomber" ;
  mineralfaerg_nn_1_1_N = mkN "mineralfärg" "mineralfärger" ;
  mineralhalt_nn_1_N = mkN "mineralhalt" "mineralhalter" ;
  mineralog_nn_1_N = mkN "mineralog" "mineraloger" ;
  minexplosion_nn_1_N = mkN "minexplosion" "minexplosioner" ;
  minimiloen_nn_1_1_N = mkN "minimilön" "minimilöner" ;
  minimipunkt_nn_1_N = mkN "minimipunkt" "minimipunkter" ;
  ministeransvarighet_nn_1_N = mkN "ministeransvarighet" "ministeransvarigheter" ;
  ministerportfoelj_nn_1_1_N = mkN "ministerportfölj" "ministerportföljer" ;
  ministerpresident_nn_1_N = mkN "ministerpresident" "ministerpresidenter" ;
  ministerstyrelse_nn_1_N = mkN "ministerstyrelse" "ministerstyrelser" ;
  ministertaburett_nn_1_N = mkN "ministertaburett" "ministertaburetter" ;
  ministaer_nn_1_1_N = mkN "ministär" "ministärer" ;
  minnesbild_nn_1_N = mkN "minnesbild" "minnesbilder" ;
  minnesenhet_nn_1_N = mkN "minnesenhet" "minnesenheter" ;
  minnesfond_nn_1_N = mkN "minnesfond" "minnesfonder" ;
  minnesfunktion_nn_1_N = mkN "minnesfunktion" "minnesfunktioner" ;
  minnesgaerd_nn_1_1_N = mkN "minnesgärd" "minnesgärder" ;
  minneskonstnaer_nn_1_1_N = mkN "minneskonstnär" "minneskonstnärer" ;
  minneskunskap_nn_1_N = mkN "minneskunskap" "minneskunskaper" ;
  minnesrymd_nn_1_N = mkN "minnesrymd" "minnesrymder" ;
  minnesskrift_nn_1_N = mkN "minnesskrift" "minnesskrifter" ;
  minnesstod_nn_1_N = mkN "minnesstod" "minnesstoder" ;
  minnesaang_nn_1_1_N = mkN "minnesång" "minnesånger" ;
  minoritet_nn_1_N = mkN "minoritet" "minoriteter" ;
  mintlikoer_nn_1_1_N = mkN "mintlikör" "mintlikörer" ;
  minuend_nn_1_N = mkN "minuend" "minuender" ;
  minusgrad_nn_1_N = mkN "minusgrad" "minusgrader" ;
  minuspol_nn_1_N = mkN "minuspol" "minuspoler" ;
  minoer_nn_1_1_N = mkN "minör" "minörer" ;
  mirabell_nn_1_N = mkN "mirabell" "mirabeller" ;
  mirakelkur_nn_1_N = mkN "mirakelkur" "mirakelkurer" ;
  misantrop_nn_1_N = mkN "misantrop" "misantroper" ;
  missbruksproblematik_nn_1_N = mkN "missbruksproblematik" "missbruksproblematiker" ;
  missfirmelse_nn_1_N = mkN "missfirmelse" "missfirmelser" ;
  missgynnsamhet_nn_1_N = mkN "missgynnsamhet" "missgynnsamheter" ;
  misshandelsscen_nn_1_N = mkN "misshandelsscen" "misshandelsscener" ;
  misshaellighet_nn_1_1_N = mkN "misshällighet" "misshälligheter" ;
  mission_nn_1_N = mkN "mission" "missioner" ;
  missionsstation_nn_1_N = mkN "missionsstation" "missionsstationer" ;
  missionaer_nn_1_1_N = mkN "missionär" "missionärer" ;
  missnoejesaktion_nn_1_1_N = mkN "missnöjesaktion" "missnöjesaktioner" ;
  misstankegrad_nn_1_N = mkN "misstankegrad" "misstankegrader" ;
  misstaenksamhet_nn_1_1_N = mkN "misstänksamhet" "misstänksamheter" ;
  misaer_nn_1_1_N = mkN "misär" "misärer" ;
  mitokondrie_nn_1_N = mkN "mitokondrie" "mitokondrier" ;
  mittlinje_nn_1_N = mkN "mittlinje" "mittlinjer" ;
  mittpunkt_nn_1_N = mkN "mittpunkt" "mittpunkter" ;
  mittpunktsnormal_nn_1_N = mkN "mittpunktsnormal" "mittpunktsnormaler" ;
  mjukhet_nn_1_N = mkN "mjukhet" "mjukheter" ;
  mjukvaevnad_nn_1_1_N = mkN "mjukvävnad" "mjukvävnader" ;
  mjoelkaffaer_nn_1_1_N = mkN "mjölkaffär" "mjölkaffärer" ;
  mjoelkbar_nn_1_1_N = mkN "mjölkbar" "mjölkbarer" ;
  mjoelkbonde_nn_1_1_N = mkN "mjölkbonde" "mjölkbönder" ;
  mjoelkcell_nn_1_1_N = mkN "mjölkcell" "mjölkceller" ;
  mjoelkcentral_nn_1_1_N = mkN "mjölkcentral" "mjölkcentraler" ;
  mjoelkkanal_nn_1_1_N = mkN "mjölkkanal" "mjölkkanaler" ;
  mjoelkko_nn_1_1_N = mkN "mjölkko" "mjölkkor" ;
  mjoelkproducent_nn_1_1_N = mkN "mjölkproducent" "mjölkproducenter" ;
  mjoelkprodukt_nn_1_1_N = mkN "mjölkprodukt" "mjölkprodukter" ;
  mjoelkproduktion_nn_1_1_N = mkN "mjölkproduktion" "mjölkproduktioner" ;
  mjoelksaft_nn_1_1_N = mkN "mjölksaft" "mjölksafter" ;
  mjoelksyrebakterie_nn_1_1_N = mkN "mjölksyrebakterie" "mjölksyrebakterier" ;
  mjoelktand_nn_1_1_N = mkN "mjölktand" "mjölktänder" ;
  mjoelkoert_nn_1_1_N = mkN "mjölkört" "mjölkörter" ;
  mobilitet_nn_1_N = mkN "mobilitet" "mobiliteter" ;
  mobilskuld_nn_1_N = mkN "mobilskuld" "mobilskulder" ;
  modalitet_nn_1_N = mkN "modalitet" "modaliteter" ;
  modeaffaer_nn_1_1_N = mkN "modeaffär" "modeaffärer" ;
  modebutik_nn_1_N = mkN "modebutik" "modebutiker" ;
  modejournal_nn_1_N = mkN "modejournal" "modejournaler" ;
  modekarriaer_nn_1_1_N = mkN "modekarriär" "modekarriärer" ;
  modelinje_nn_1_N = mkN "modelinje" "modelinjer" ;
  modellkarriaer_nn_1_1_N = mkN "modellkarriär" "modellkarriärer" ;
  modellstudie_nn_1_N = mkN "modellstudie" "modellstudier" ;
  modenyck_nn_1_N = mkN "modenyck" "modenycker" ;
  moderation_nn_1_N = mkN "moderation" "moderationer" ;
  modercell_nn_1_N = mkN "modercell" "moderceller" ;
  moderniseringsreform_nn_1_N = mkN "moderniseringsreform" "moderniseringsreformer" ;
  modernitet_nn_1_N = mkN "modernitet" "moderniteter" ;
  modersgestalt_nn_1_N = mkN "modersgestalt" "modersgestalter" ;
  modesak_nn_1_N = mkN "modesak" "modesaker" ;
  modifikation_nn_1_N = mkN "modifikation" "modifikationer" ;
  modul_nn_1_N = mkN "modul" "moduler" ;
  modulation_nn_1_N = mkN "modulation" "modulationer" ;
  mogenhet_nn_1_N = mkN "mogenhet" "mogenheter" ;
  mognad_nn_1_N = mkN "mognad" "mognader" ;
  mojaeng_nn_1_1_N = mkN "mojäng" "mojänger" ;
  molar_nn_1_N = mkN "molar" "molarer" ;
  molaritet_nn_1_N = mkN "molaritet" "molariteter" ;
  molekylarattraktion_nn_1_N = mkN "molekylarattraktion" "molekylarattraktioner" ;
  molekylarkraft_nn_1_N = mkN "molekylarkraft" "molekylarkrafter" ;
  molekylvikt_nn_1_N = mkN "molekylvikt" "molekylvikter" ;
  molnhoejd_nn_1_1_N = mkN "molnhöjd" "molnhöjder" ;
  molnighet_nn_1_N = mkN "molnighet" "molnigheter" ;
  molnkant_nn_1_N = mkN "molnkant" "molnkanter" ;
  molnstod_nn_1_N = mkN "molnstod" "molnstoder" ;
  momang_nn_1_N = mkN "momang" "momanger" ;
  monad_nn_1_N = mkN "monad" "monader" ;
  monark_nn_1_N = mkN "monark" "monarker" ;
  mondaenitet_nn_1_1_N = mkN "mondänitet" "mondäniteter" ;
  monoaminoxidas_nn_1_N = mkN "monoaminoxidas" "monoaminoxidaser" ;
  monoftong_nn_1_N = mkN "monoftong" "monoftonger" ;
  monotonitet_nn_1_N = mkN "monotonitet" "monotoniteter" ;
  monotype_nn_1_N = mkN "monotype" "monotyper" ;
  monseigneur_nn_1_N = mkN "monseigneur" "monseigneurer" ;
  monsignore_nn_1_N = mkN "monsignore" "monsignorer" ;
  monstruositet_nn_1_N = mkN "monstruositet" "monstruositeter" ;
  monsun_nn_1_N = mkN "monsun" "monsuner" ;
  montoer_nn_1_1_N = mkN "montör" "montörer" ;
  monumentalbyggnad_nn_1_N = mkN "monumentalbyggnad" "monumentalbyggnader" ;
  monumentalitet_nn_1_N = mkN "monumentalitet" "monumentaliteter" ;
  mopedreparation_nn_1_N = mkN "mopedreparation" "mopedreparationer" ;
  mor_unge_konflikt_nn_1_N = mkN "mor-unge-konflikt" "mor-unge-konflikter" ;
  moral_nn_1_N = mkN "moral" "moraler" ;
  moralitet_nn_1_N = mkN "moralitet" "moraliteter" ;
  moralsed_nn_1_N = mkN "moralsed" "moralseder" ;
  morbiditet_nn_1_N = mkN "morbiditet" "morbiditeter" ;
  mordbrand_nn_1_N = mkN "mordbrand" "mordbränder" ;
  mordkommission_nn_1_N = mkN "mordkommission" "mordkommissioner" ;
  mordkonspiration_nn_1_N = mkN "mordkonspiration" "mordkonspirationer" ;
  mordlystnad_nn_1_N = mkN "mordlystnad" "mordlystnader" ;
  morell_nn_1_N = mkN "morell" "moreller" ;
  morgonandakt_nn_1_N = mkN "morgonandakt" "morgonandakter" ;
  morgonboen_nn_1_1_N = mkN "morgonbön" "morgonböner" ;
  morgonpsalm_nn_1_N = mkN "morgonpsalm" "morgonpsalmer" ;
  morgonrodnad_nn_1_N = mkN "morgonrodnad" "morgonrodnader" ;
  morgonstund_nn_1_N = mkN "morgonstund" "morgonstunder" ;
  morgonsaang_nn_1_1_N = mkN "morgonsång" "morgonsånger" ;
  mormorsstaang_nn_1_1_N = mkN "mormorsstång" "mormorsstänger" ;
  morslott_nn_1_N = mkN "morslott" "morslotter" ;
  mortalitet_nn_1_N = mkN "mortalitet" "mortaliteter" ;
  mortifikation_nn_1_N = mkN "mortifikation" "mortifikationer" ;
  moraen_nn_1_1_N = mkN "morän" "moräner" ;
  moraenmark_nn_1_1_N = mkN "moränmark" "moränmarker" ;
  motaktion_nn_1_N = mkN "motaktion" "motaktioner" ;
  motbild_nn_1_N = mkN "motbild" "motbilder" ;
  motellchef_nn_1_N = mkN "motellchef" "motellchefer" ;
  motighet_nn_1_N = mkN "motighet" "motigheter" ;
  motion_nn_1_N = mkN "motion" "motioner" ;
  motionsflod_nn_1_N = mkN "motionsflod" "motionsfloder" ;
  motionsidrott_nn_1_N = mkN "motionsidrott" "motionsidrotter" ;
  motionstid_nn_1_N = mkN "motionstid" "motionstider" ;
  motionaer_nn_1_1_N = mkN "motionär" "motionärer" ;
  motivation_nn_1_N = mkN "motivation" "motivationer" ;
  motivbild_nn_1_N = mkN "motivbild" "motivbilder" ;
  motkandidat_nn_1_N = mkN "motkandidat" "motkandidater" ;
  motkraft_nn_1_N = mkN "motkraft" "motkrafter" ;
  motoreffekt_nn_1_N = mkN "motoreffekt" "motoreffekter" ;
  motorjakt_nn_1_N = mkN "motorjakt" "motorjakter" ;
  motorkraft_nn_1_N = mkN "motorkraft" "motorkrafter" ;
  motortrafikled_nn_1_N = mkN "motortrafikled" "motortrafikleder" ;
  motorvaegsfoerbindelse_nn_1_1_N = mkN "motorvägsförbindelse" "motorvägsförbindelser" ;
  motpart_nn_1_N = mkN "motpart" "motparter" ;
  motpol_nn_1_N = mkN "motpol" "motpoler" ;
  motprestation_nn_1_N = mkN "motprestation" "motprestationer" ;
  motreformation_nn_1_N = mkN "motreformation" "motreformationer" ;
  motreplik_nn_1_N = mkN "motreplik" "motrepliker" ;
  motrevolution_nn_1_N = mkN "motrevolution" "motrevolutioner" ;
  motroerelse_nn_1_1_N = mkN "motrörelse" "motrörelser" ;
  motskrift_nn_1_N = mkN "motskrift" "motskrifter" ;
  motstrof_nn_1_N = mkN "motstrof" "motstrofer" ;
  motstaandsroerelse_nn_1_1_N = mkN "motståndsrörelse" "motståndsrörelser" ;
  motsvarighet_nn_1_N = mkN "motsvarighet" "motsvarigheter" ;
  motsaegelse_nn_1_1_N = mkN "motsägelse" "motsägelser" ;
  motvikt_nn_1_N = mkN "motvikt" "motvikter" ;
  motaatgaerd_nn_1_1_N = mkN "motåtgärd" "motåtgärder" ;
  mousse_nn_1_N = mkN "mousse" "mousser" ;
  muffelfaerg_nn_1_1_N = mkN "muffelfärg" "muffelfärger" ;
  mulatt_nn_1_N = mkN "mulatt" "mulatter" ;
  mullhalt_nn_1_N = mkN "mullhalt" "mullhalter" ;
  multiplikand_nn_1_N = mkN "multiplikand" "multiplikander" ;
  multiplikation_nn_1_N = mkN "multiplikation" "multiplikationer" ;
  multiplikationstabell_nn_1_N = mkN "multiplikationstabell" "multiplikationstabeller" ;
  mumie_nn_1_N = mkN "mumie" "mumier" ;
  mumifikation_nn_1_N = mkN "mumifikation" "mumifikationer" ;
  munart_nn_1_N = mkN "munart" "munarter" ;
  munkcell_nn_1_N = mkN "munkcell" "munkceller" ;
  munklikoer_nn_1_1_N = mkN "munklikör" "munklikörer" ;
  munterhet_nn_1_N = mkN "munterhet" "munterheter" ;
  muntration_nn_1_N = mkN "muntration" "muntrationer" ;
  museichef_nn_1_N = mkN "museichef" "museichefer" ;
  museiintendent_nn_1_N = mkN "museiintendent" "museiintendenter" ;
  museikatalog_nn_1_N = mkN "museikatalog" "museikataloger" ;
  museikonflikt_nn_1_N = mkN "museikonflikt" "museikonflikter" ;
  musical_nn_1_N = mkN "musical" "musicaler" ;
  musikal_nn_1_N = mkN "musikal" "musikaler" ;
  musikalitet_nn_1_N = mkN "musikalitet" "musikaliteter" ;
  musikelev_nn_1_N = mkN "musikelev" "musikelever" ;
  musikensemble_nn_1_N = mkN "musikensemble" "musikensembler" ;
  musikform_nn_1_N = mkN "musikform" "musikformer" ;
  musikgrupp_nn_1_N = mkN "musikgrupp" "musikgrupper" ;
  musikkomposition_nn_1_N = mkN "musikkomposition" "musikkompositioner" ;
  musikkvartett_nn_1_N = mkN "musikkvartett" "musikkvartetter" ;
  musikkaar_nn_1_1_N = mkN "musikkår" "musikkårer" ;
  musikverksamhet_nn_1_N = mkN "musikverksamhet" "musikverksamheter" ;
  musikvetenskap_nn_1_N = mkN "musikvetenskap" "musikvetenskaper" ;
  musjik_nn_1_N = mkN "musjik" "musjiker" ;
  muskelbyggnad_nn_1_N = mkN "muskelbyggnad" "muskelbyggnader" ;
  muskelcell_nn_1_N = mkN "muskelcell" "muskelceller" ;
  muskelkraft_nn_1_N = mkN "muskelkraft" "muskelkrafter" ;
  muskelkramp_nn_1_N = mkN "muskelkramp" "muskelkramper" ;
  muskellaengd_nn_1_1_N = mkN "muskellängd" "muskellängder" ;
  muskelroerelse_nn_1_1_N = mkN "muskelrörelse" "muskelrörelser" ;
  muskelvaevnad_nn_1_1_N = mkN "muskelvävnad" "muskelvävnader" ;
  musketoer_nn_1_1_N = mkN "musketör" "musketörer" ;
  muskoet_nn_1_1_N = mkN "musköt" "musköter" ;
  muslin_nn_1_N = mkN "muslin" "musliner" ;
  musselform_nn_1_N = mkN "musselform" "musselformer" ;
  mustang_nn_1_N = mkN "mustang" "mustanger" ;
  mustrakt_nn_1_N = mkN "mustrakt" "mustrakter" ;
  mutation_nn_1_N = mkN "mutation" "mutationer" ;
  myckenhet_nn_1_N = mkN "myckenhet" "myckenheter" ;
  mygglarv_nn_1_N = mkN "mygglarv" "mygglarver" ;
  myndighet_nn_1_N = mkN "myndighet" "myndigheter" ;
  myndighetschef_nn_1_N = mkN "myndighetschef" "myndighetschefer" ;
  myndighetsperson_nn_1_N = mkN "myndighetsperson" "myndighetspersoner" ;
  myntautomat_nn_1_N = mkN "myntautomat" "myntautomater" ;
  myntcirkulation_nn_1_N = mkN "myntcirkulation" "myntcirkulationer" ;
  myntenhet_nn_1_N = mkN "myntenhet" "myntenheter" ;
  myntmetall_nn_1_N = mkN "myntmetall" "myntmetaller" ;
  myntrealisation_nn_1_N = mkN "myntrealisation" "myntrealisationer" ;
  myntunion_nn_1_N = mkN "myntunion" "myntunioner" ;
  myntvaloer_nn_1_1_N = mkN "myntvalör" "myntvalörer" ;
  myntvikt_nn_1_N = mkN "myntvikt" "myntvikter" ;
  myosin_nn_1_N = mkN "myosin" "myosiner" ;
  myriad_nn_1_N = mkN "myriad" "myriader" ;
  myrkant_nn_1_N = mkN "myrkant" "myrkanter" ;
  myrmalm_nn_1_N = mkN "myrmalm" "myrmalmer" ;
  myrmark_nn_1_N = mkN "myrmark" "myrmarker" ;
  mysteriereligion_nn_1_N = mkN "mysteriereligion" "mysteriereligioner" ;
  mystifikation_nn_1_N = mkN "mystifikation" "mystifikationer" ;
  myt_nn_1_N = mkN "myt" "myter" ;
  maeklarinformation_nn_1_1_N = mkN "mäklarinformation" "mäklarinformationer" ;
  maektighet_nn_1_1_N = mkN "mäktighet" "mäktigheter" ;
  maenniskogestalt_nn_1_1_N = mkN "människogestalt" "människogestalter" ;
  maenniskohand_nn_1_1_N = mkN "människohand" "människohänder" ;
  maenniskojakt_nn_1_1_N = mkN "människojakt" "människojakter" ;
  maenniskoraettsorganisation_nn_1_1_N = mkN "människorättsorganisation" "människorättsorganisationer" ;
  maenniskospermie_nn_1_1_N = mkN "människospermie" "människospermier" ;
  maenniskotand_nn_1_1_N = mkN "människotand" "människotänder" ;
  maenniskovaenlighet_nn_1_1_N = mkN "människovänlighet" "människovänligheter" ;
  maensklighet_nn_1_1_N = mkN "mänsklighet" "mänskligheter" ;
  maer_nn_1_1_N = mkN "mär" "märer" ;
  maerklighet_nn_1_1_N = mkN "märklighet" "märkligheter" ;
  maerkvaerdighet_nn_1_1_N = mkN "märkvärdighet" "märkvärdigheter" ;
  maersstaang_nn_1_1_N = mkN "märsstång" "märsstänger" ;
  maessdraekt_nn_1_1_N = mkN "mässdräkt" "mässdräkter" ;
  maessingsstaang_nn_1_1_N = mkN "mässingsstång" "mässingsstänger" ;
  maetapparat_nn_1_1_N = mkN "mätapparat" "mätapparater" ;
  maetarlarv_nn_1_1_N = mkN "mätarlarv" "mätarlarver" ;
  maetbarhet_nn_1_1_N = mkN "mätbarhet" "mätbarheter" ;
  maetmetod_nn_1_1_N = mkN "mätmetod" "mätmetoder" ;
  maetperiod_nn_1_1_N = mkN "mätperiod" "mätperioder" ;
  maettnad_nn_1_1_N = mkN "mättnad" "mättnader" ;
  maalarfaerg_nn_1_1_N = mkN "målarfärg" "målarfärger" ;
  maalgrupp_nn_1_1_N = mkN "målgrupp" "målgrupper" ;
  maalkonflikt_nn_1_1_N = mkN "målkonflikt" "målkonflikter" ;
  maalkvot_nn_1_1_N = mkN "målkvot" "målkvoter" ;
  maallinje_nn_1_1_N = mkN "mållinje" "mållinjer" ;
  maalningsteknik_nn_1_1_N = mkN "målningsteknik" "målningstekniker" ;
  maalskillnad_nn_1_1_N = mkN "målskillnad" "målskillnader" ;
  maaltid_nn_1_1_N = mkN "måltid" "måltider" ;
  maaltidsdryck_nn_1_1_N = mkN "måltidsdryck" "måltidsdrycker" ;
  maalvakt_nn_1_1_N = mkN "målvakt" "målvakter" ;
  maanad_nn_1_1_N = mkN "månad" "månader" ;
  maanadsloen_nn_1_1_N = mkN "månadslön" "månadslöner" ;
  maanadsskrift_nn_1_1_N = mkN "månadsskrift" "månadsskrifter" ;
  maanadstidskrift_nn_1_1_N = mkN "månadstidskrift" "månadstidskrifter" ;
  maanflod_nn_1_1_N = mkN "månflod" "månfloder" ;
  maanfaerd_nn_1_1_N = mkN "månfärd" "månfärder" ;
  maanfoermoerkelse_nn_1_1_N = mkN "månförmörkelse" "månförmörkelser" ;
  maangalenhet_nn_1_1_N = mkN "mångalenhet" "mångalenheter" ;
  maangalenskap_nn_1_1_N = mkN "mångalenskap" "mångalenskaper" ;
  maangfald_nn_1_1_N = mkN "mångfald" "mångfalder" ;
  maangformighet_nn_1_1_N = mkN "mångformighet" "mångformigheter" ;
  maangkamp_nn_1_1_N = mkN "mångkamp" "mångkamper" ;
  maangmiljardaffaer_nn_1_1_N = mkN "mångmiljardaffär" "mångmiljardaffärer" ;
  maangsidighet_nn_1_1_N = mkN "mångsidighet" "mångsidigheter" ;
  maangtydighet_nn_1_1_N = mkN "mångtydighet" "mångtydigheter" ;
  maanviol_nn_1_1_N = mkN "månviol" "månvioler" ;
  maattenhet_nn_1_1_N = mkN "måttenhet" "måttenheter" ;
  maattsenhet_nn_1_1_N = mkN "måttsenhet" "måttsenheter" ;
  moedravaardscentral_nn_1_1_N = mkN "mödravårdscentral" "mödravårdscentraler" ;
  moejlighet_nn_1_1_N = mkN "möjlighet" "möjligheter" ;
  moenjefaerg_nn_1_1_N = mkN "mönjefärg" "mönjefärger" ;
  moenstringsexpedition_nn_1_1_N = mkN "mönstringsexpedition" "mönstringsexpeditioner" ;
  moerdarjakt_nn_1_1_N = mkN "mördarjakt" "mördarjakter" ;
  moerkalf_nn_1_1_N = mkN "mörkalf" "mörkalfer" ;
  moerkalv_nn_1_1_N = mkN "mörkalv" "mörkalver" ;
  moerklaeggningsgardin_nn_1_1_N = mkN "mörkläggningsgardin" "mörkläggningsgardiner" ;
  moetesfrihet_nn_1_1_N = mkN "mötesfrihet" "mötesfriheter" ;
  moetespunkt_nn_1_1_N = mkN "mötespunkt" "mötespunkter" ;
  moetesstation_nn_1_1_N = mkN "mötesstation" "mötesstationer" ;
  nabo_nn_1_N = mkN "nabo" "nabor" ;
  nabob_nn_1_N = mkN "nabob" "nabober" ;
  nageloert_nn_1_1_N = mkN "nagelört" "nagelörter" ;
  naivitet_nn_1_N = mkN "naivitet" "naiviteter" ;
  najad_nn_1_N = mkN "najad" "najader" ;
  nakenakt_nn_1_N = mkN "nakenakt" "nakenakter" ;
  nakenbild_nn_1_N = mkN "nakenbild" "nakenbilder" ;
  nakenhet_nn_1_N = mkN "nakenhet" "nakenheter" ;
  nakenkult_nn_1_N = mkN "nakenkult" "nakenkulter" ;
  nakenmodell_nn_1_N = mkN "nakenmodell" "nakenmodeller" ;
  nakenscen_nn_1_N = mkN "nakenscen" "nakenscener" ;
  nakenstudie_nn_1_N = mkN "nakenstudie" "nakenstudier" ;
  naketbild_nn_1_N = mkN "naketbild" "naketbilder" ;
  namnaktie_nn_1_N = mkN "namnaktie" "namnaktier" ;
  namndikt_nn_1_N = mkN "namndikt" "namndikter" ;
  namnkunnighet_nn_1_N = mkN "namnkunnighet" "namnkunnigheter" ;
  namnlaengd_nn_1_1_N = mkN "namnlängd" "namnlängder" ;
  namnsaekerhet_nn_1_1_N = mkN "namnsäkerhet" "namnsäkerheter" ;
  namnunderskrift_nn_1_N = mkN "namnunderskrift" "namnunderskrifter" ;
  namnuppgift_nn_1_N = mkN "namnuppgift" "namnuppgifter" ;
  nanosekund_nn_1_N = mkN "nanosekund" "nanosekunder" ;
  napalmbomb_nn_1_N = mkN "napalmbomb" "napalmbomber" ;
  napoleonbakelse_nn_1_N = mkN "napoleonbakelse" "napoleonbakelser" ;
  naprapat_nn_1_N = mkN "naprapat" "naprapater" ;
  narighet_nn_1_N = mkN "narighet" "narigheter" ;
  narkotikaklinik_nn_1_N = mkN "narkotikaklinik" "narkotikakliniker" ;
  narrdraekt_nn_1_1_N = mkN "narrdräkt" "narrdräkter" ;
  narvspalt_nn_1_N = mkN "narvspalt" "narvspalter" ;
  nasir_nn_1_N = mkN "nasir" "nasirer" ;
  nation_nn_1_N = mkN "nation" "nationer" ;
  nationaldraekt_nn_1_1_N = mkN "nationaldräkt" "nationaldräkter" ;
  nationalfoermoegenhet_nn_1_1_N = mkN "nationalförmögenhet" "nationalförmögenheter" ;
  nationalistroerelse_nn_1_1_N = mkN "nationaliströrelse" "nationaliströrelser" ;
  nationalitet_nn_1_N = mkN "nationalitet" "nationaliteter" ;
  nationalitetsbokstav_nn_1_N = mkN "nationalitetsbokstav" "nationalitetsbokstäver" ;
  nationalkaraktaer_nn_1_1_N = mkN "nationalkaraktär" "nationalkaraktärer" ;
  nationalpark_nn_1_N = mkN "nationalpark" "nationalparker" ;
  nationalprodukt_nn_1_N = mkN "nationalprodukt" "nationalprodukter" ;
  nationalraett_nn_1_1_N = mkN "nationalrätt" "nationalrätter" ;
  nationalscen_nn_1_N = mkN "nationalscen" "nationalscener" ;
  nationalskald_nn_1_N = mkN "nationalskald" "nationalskalder" ;
  nationalsport_nn_1_N = mkN "nationalsport" "nationalsporter" ;
  nationalstat_nn_1_N = mkN "nationalstat" "nationalstater" ;
  nationalsaang_nn_1_1_N = mkN "nationalsång" "nationalsånger" ;
  nationsavgift_nn_1_N = mkN "nationsavgift" "nationsavgifter" ;
  nativitet_nn_1_N = mkN "nativitet" "nativiteter" ;
  natriumhalt_nn_1_N = mkN "natriumhalt" "natriumhalter" ;
  natriumkonsumtion_nn_1_N = mkN "natriumkonsumtion" "natriumkonsumtioner" ;
  natriumtiosulfat_nn_1_N = mkN "natriumtiosulfat" "natriumtiosulfater" ;
  natt_nn_1_N = mkN "natt" "nätter" ;
  nattblindhet_nn_1_N = mkN "nattblindhet" "nattblindheter" ;
  nattdraekt_nn_1_1_N = mkN "nattdräkt" "nattdräkter" ;
  nattjour_nn_1_N = mkN "nattjour" "nattjourer" ;
  nattklubbskund_nn_1_N = mkN "nattklubbskund" "nattklubbskunder" ;
  nattkraem_nn_1_1_N = mkN "nattkräm" "nattkrämer" ;
  nattlaengd_nn_1_1_N = mkN "nattlängd" "nattlängder" ;
  nattpatrull_nn_1_N = mkN "nattpatrull" "nattpatruller" ;
  nattstrid_nn_1_N = mkN "nattstrid" "nattstrider" ;
  nattvakt_nn_1_N = mkN "nattvakt" "nattvakter" ;
  nattvard_nn_1_N = mkN "nattvard" "nattvarder" ;
  nattvardsberedelse_nn_1_N = mkN "nattvardsberedelse" "nattvardsberedelser" ;
  nattviol_nn_1_N = mkN "nattviol" "nattvioler" ;
  nattvaekt_nn_1_1_N = mkN "nattväkt" "nattväkter" ;
  naturalisation_nn_1_N = mkN "naturalisation" "naturalisationer" ;
  naturaportion_nn_1_N = mkN "naturaportion" "naturaportioner" ;
  naturbetingelse_nn_1_N = mkN "naturbetingelse" "naturbetingelser" ;
  naturelltapet_nn_1_N = mkN "naturelltapet" "naturelltapeter" ;
  naturfilosof_nn_1_N = mkN "naturfilosof" "naturfilosofer" ;
  naturformation_nn_1_N = mkN "naturformation" "naturformationer" ;
  naturfaerg_nn_1_1_N = mkN "naturfärg" "naturfärger" ;
  naturinstinkt_nn_1_N = mkN "naturinstinkt" "naturinstinkter" ;
  naturkraft_nn_1_N = mkN "naturkraft" "naturkrafter" ;
  naturlaekemetod_nn_1_1_N = mkN "naturläkemetod" "naturläkemetoder" ;
  naturmetod_nn_1_N = mkN "naturmetod" "naturmetoder" ;
  naturnoedvaendighet_nn_1_1_N = mkN "naturnödvändighet" "naturnödvändigheter" ;
  naturpark_nn_1_N = mkN "naturpark" "naturparker" ;
  naturprodukt_nn_1_N = mkN "naturprodukt" "naturprodukter" ;
  naturreligion_nn_1_N = mkN "naturreligion" "naturreligioner" ;
  naturtomt_nn_1_N = mkN "naturtomt" "naturtomter" ;
  naturtyp_nn_1_N = mkN "naturtyp" "naturtyper" ;
  naturvetenskap_nn_1_N = mkN "naturvetenskap" "naturvetenskaper" ;
  navigation_nn_1_N = mkN "navigation" "navigationer" ;
  navigatoer_nn_1_1_N = mkN "navigatör" "navigatörer" ;
  nazistsympatisoer_nn_1_1_N = mkN "nazistsympatisör" "nazistsympatisörer" ;
  nebulosalinje_nn_1_N = mkN "nebulosalinje" "nebulosalinjer" ;
  necessaer_nn_1_1_N = mkN "necessär" "necessärer" ;
  nedbrytningsstation_nn_1_N = mkN "nedbrytningsstation" "nedbrytningsstationer" ;
  nederboerdsmaengd_nn_1_1_N = mkN "nederbördsmängd" "nederbördsmängder" ;
  nederkant_nn_1_N = mkN "nederkant" "nederkanter" ;
  nedfart_nn_1_N = mkN "nedfart" "nedfarter" ;
  nedfaerd_nn_1_1_N = mkN "nedfärd" "nedfärder" ;
  nedlaeggelse_nn_1_1_N = mkN "nedläggelse" "nedläggelser" ;
  nedlaatenhet_nn_1_1_N = mkN "nedlåtenhet" "nedlåtenheter" ;
  nedrighet_nn_1_N = mkN "nedrighet" "nedrigheter" ;
  nedskaerningskonsulent_nn_1_1_N = mkN "nedskärningskonsulent" "nedskärningskonsulenter" ;
  negation_nn_1_N = mkN "negation" "negationer" ;
  nematod_nn_1_N = mkN "nematod" "nematoder" ;
  neodym_nn_2_N = mkN "neodym" "neodymer" ;
  neotektonik_nn_1_N = mkN "neotektonik" "neotektoniker" ;
  nerbrytningsstation_nn_1_N = mkN "nerbrytningsstation" "nerbrytningsstationer" ;
  nerfart_nn_1_N = mkN "nerfart" "nerfarter" ;
  nerfaerd_nn_1_1_N = mkN "nerfärd" "nerfärder" ;
  nerlaeggelse_nn_1_1_N = mkN "nerläggelse" "nerläggelser" ;
  nerlaatenhet_nn_1_1_N = mkN "nerlåtenhet" "nerlåtenheter" ;
  nerv_nn_1_N = mkN "nerv" "nerver" ;
  nervaktivitet_nn_1_N = mkN "nervaktivitet" "nervaktiviteter" ;
  nervattack_nn_1_N = mkN "nervattack" "nervattacker" ;
  nervcell_nn_1_N = mkN "nervcell" "nervceller" ;
  nervcellsgrupp_nn_1_N = mkN "nervcellsgrupp" "nervcellsgrupper" ;
  nervchock_nn_1_N = mkN "nervchock" "nervchocker" ;
  nervfoerbindelse_nn_1_1_N = mkN "nervförbindelse" "nervförbindelser" ;
  nervositet_nn_1_N = mkN "nervositet" "nervositeter" ;
  nervvaevnad_nn_1_1_N = mkN "nervvävnad" "nervvävnader" ;
  neslighet_nn_1_N = mkN "neslighet" "nesligheter" ;
  nettofoermoegenhet_nn_1_1_N = mkN "nettoförmögenhet" "nettoförmögenheter" ;
  nettoloen_nn_1_1_N = mkN "nettolön" "nettolöner" ;
  nettoskuld_nn_1_N = mkN "nettoskuld" "nettoskulder" ;
  nettostudietid_nn_1_N = mkN "nettostudietid" "nettostudietider" ;
  neuropat_nn_1_N = mkN "neuropat" "neuropater" ;
  neurovetenskap_nn_1_N = mkN "neurovetenskap" "neurovetenskaper" ;
  neutralisation_nn_1_N = mkN "neutralisation" "neutralisationer" ;
  neutralitet_nn_1_N = mkN "neutralitet" "neutraliteter" ;
  neutrinomodell_nn_1_N = mkN "neutrinomodell" "neutrinomodeller" ;
  neutronbomb_nn_1_N = mkN "neutronbomb" "neutronbomber" ;
  nidation_nn_1_N = mkN "nidation" "nidationer" ;
  nidbild_nn_1_N = mkN "nidbild" "nidbilder" ;
  niddikt_nn_1_N = mkN "niddikt" "niddikter" ;
  nidskrift_nn_1_N = mkN "nidskrift" "nidskrifter" ;
  nidstaang_nn_1_1_N = mkN "nidstång" "nidstänger" ;
  niece_nn_1_N = mkN "niece" "niecer" ;
  nipbrant_nn_1_N = mkN "nipbrant" "nipbranter" ;
  nipflod_nn_1_N = mkN "nipflod" "nipfloder" ;
  nitlott_nn_1_N = mkN "nitlott" "nitlotter" ;
  nitratbakterie_nn_1_N = mkN "nitratbakterie" "nitratbakterier" ;
  nitritbakterie_nn_1_N = mkN "nitritbakterie" "nitritbakterier" ;
  nitroglycerin_nn_1_N = mkN "nitroglycerin" "nitroglyceriner" ;
  nitrogrupp_nn_1_N = mkN "nitrogrupp" "nitrogrupper" ;
  nivation_nn_1_N = mkN "nivation" "nivationer" ;
  nivaaskillnad_nn_1_1_N = mkN "nivåskillnad" "nivåskillnader" ;
  njurtransplantation_nn_1_N = mkN "njurtransplantation" "njurtransplantationer" ;
  njutningslystnad_nn_1_N = mkN "njutningslystnad" "njutningslystnader" ;
  nocturne_nn_1_N = mkN "nocturne" "nocturner" ;
  nod_nn_1_N = mkN "nod" "noder" ;
  noggrannhet_nn_1_N = mkN "noggrannhet" "noggrannheter" ;
  nojighet_nn_1_N = mkN "nojighet" "nojigheter" ;
  nokturn_nn_1_N = mkN "nokturn" "nokturner" ;
  nollpunkt_nn_1_N = mkN "nollpunkt" "nollpunkter" ;
  nomadfamilj_nn_1_N = mkN "nomadfamilj" "nomadfamiljer" ;
  nominalkatalog_nn_1_N = mkN "nominalkatalog" "nominalkataloger" ;
  nominalloen_nn_1_1_N = mkN "nominallön" "nominallöner" ;
  nonaggression_nn_1_N = mkN "nonaggression" "nonaggressioner" ;
  nonie_nn_1_N = mkN "nonie" "nonier" ;
  nonintervention_nn_1_N = mkN "nonintervention" "noninterventioner" ;
  noradrenalin_nn_1_N = mkN "noradrenalin" "noradrenaliner" ;
  nordbo_nn_1_N = mkN "nordbo" "nordbor" ;
  nordpol_nn_1_N = mkN "nordpol" "nordpoler" ;
  norepinefrin_nn_1_N = mkN "norepinefrin" "norepinefriner" ;
  norm_nn_1_N = mkN "norm" "normer" ;
  normal_nn_1_N = mkN "normal" "normaler" ;
  normalbild_nn_1_N = mkN "normalbild" "normalbilder" ;
  normalfilm_nn_1_N = mkN "normalfilm" "normalfilmer" ;
  normalfaerg_nn_1_1_N = mkN "normalfärg" "normalfärger" ;
  normalitet_nn_1_N = mkN "normalitet" "normaliteter" ;
  normalmaanad_nn_1_1_N = mkN "normalmånad" "normalmånader" ;
  normalstudietid_nn_1_N = mkN "normalstudietid" "normalstudietider" ;
  normaltid_nn_1_N = mkN "normaltid" "normaltider" ;
  normalton_nn_1_N = mkN "normalton" "normaltoner" ;
  normalvikt_nn_1_N = mkN "normalvikt" "normalvikter" ;
  normand_nn_1_N = mkN "normand" "normander" ;
  normloeshet_nn_1_1_N = mkN "normlöshet" "normlösheter" ;
  norrskensupplevelse_nn_1_N = mkN "norrskensupplevelse" "norrskensupplevelser" ;
  nosighet_nn_1_N = mkN "nosighet" "nosigheter" ;
  noskighet_nn_1_N = mkN "noskighet" "noskigheter" ;
  noskon_nn_1_N = mkN "noskon" "noskoner" ;
  noslaengd_nn_1_1_N = mkN "noslängd" "noslängder" ;
  nosregion_nn_1_N = mkN "nosregion" "nosregioner" ;
  notabilitet_nn_1_N = mkN "notabilitet" "notabiliteter" ;
  notarie_nn_1_N = mkN "notarie" "notarier" ;
  notation_nn_1_N = mkN "notation" "notationer" ;
  notdraekt_nn_1_1_N = mkN "notdräkt" "notdräkter" ;
  notifikation_nn_1_N = mkN "notifikation" "notifikationer" ;
  notlinje_nn_1_N = mkN "notlinje" "notlinjer" ;
  notorietet_nn_1_N = mkN "notorietet" "notorieteter" ;
  notrad_nn_1_N = mkN "notrad" "notrader" ;
  novation_nn_1_N = mkN "novation" "novationer" ;
  novell_nn_1_N = mkN "novell" "noveller" ;
  novellett_nn_1_N = mkN "novellett" "novelletter" ;
  novitet_nn_1_N = mkN "novitet" "noviteter" ;
  nuditet_nn_1_N = mkN "nuditet" "nuditeter" ;
  nullitet_nn_1_N = mkN "nullitet" "nulliteter" ;
  numeraer_nn_1_1_N = mkN "numerär" "numerärer" ;
  nummerfoeljd_nn_1_1_N = mkN "nummerföljd" "nummerföljder" ;
  nummerpresentatoer_nn_1_1_N = mkN "nummerpresentatör" "nummerpresentatörer" ;
  nunneoert_nn_1_1_N = mkN "nunneört" "nunneörter" ;
  nuntie_nn_1_N = mkN "nuntie" "nuntier" ;
  nuspraaklighet_nn_1_1_N = mkN "nuspråklighet" "nuspråkligheter" ;
  nutrition_nn_1_N = mkN "nutrition" "nutritioner" ;
  nyansloeshet_nn_1_1_N = mkN "nyanslöshet" "nyanslösheter" ;
  nybyggnad_nn_1_N = mkN "nybyggnad" "nybyggnader" ;
  nyck_nn_1_N = mkN "nyck" "nycker" ;
  nyckelfunktion_nn_1_N = mkN "nyckelfunktion" "nyckelfunktioner" ;
  nyckelposition_nn_1_N = mkN "nyckelposition" "nyckelpositioner" ;
  nyckelroll_nn_1_N = mkN "nyckelroll" "nyckelroller" ;
  nyckelstaang_nn_1_1_N = mkN "nyckelstång" "nyckelstänger" ;
  nyckfullhet_nn_1_N = mkN "nyckfullhet" "nyckfullheter" ;
  nyemission_nn_1_N = mkN "nyemission" "nyemissioner" ;
  nyfikenhet_nn_1_N = mkN "nyfikenhet" "nyfikenheter" ;
  nygrad_nn_1_N = mkN "nygrad" "nygrader" ;
  nyhet_nn_1_N = mkN "nyhet" "nyheter" ;
  nyhetsportal_nn_1_N = mkN "nyhetsportal" "nyhetsportaler" ;
  nyhetsredaktion_nn_1_N = mkN "nyhetsredaktion" "nyhetsredaktioner" ;
  nykolonisation_nn_1_N = mkN "nykolonisation" "nykolonisationer" ;
  nykterhet_nn_1_N = mkN "nykterhet" "nykterheter" ;
  nykterhetsnaemnd_nn_1_1_N = mkN "nykterhetsnämnd" "nykterhetsnämnder" ;
  nykterhetsroerelse_nn_1_1_N = mkN "nykterhetsrörelse" "nykterhetsrörelser" ;
  nymf_nn_1_N = mkN "nymf" "nymfer" ;
  nymodighet_nn_1_N = mkN "nymodighet" "nymodigheter" ;
  nyproduktion_nn_1_N = mkN "nyproduktion" "nyproduktioner" ;
  nysattack_nn_1_N = mkN "nysattack" "nysattacker" ;
  nyskapelse_nn_1_N = mkN "nyskapelse" "nyskapelser" ;
  nystart_nn_1_N = mkN "nystart" "nystarter" ;
  nysoert_nn_1_1_N = mkN "nysört" "nysörter" ;
  nyttighet_nn_1_N = mkN "nyttighet" "nyttigheter" ;
  nyttosynpunkt_nn_1_N = mkN "nyttosynpunkt" "nyttosynpunkter" ;
  nyaarsboen_nn_1_1_N = mkN "nyårsbön" "nyårsböner" ;
  nyaarsnatt_nn_1_1_N = mkN "nyårsnatt" "nyårsnätter" ;
  naebbsko_nn_1_1_N = mkN "näbbsko" "näbbskor" ;
  naepenhet_nn_1_1_N = mkN "näpenhet" "näpenheter" ;
  naerbild_nn_1_1_N = mkN "närbild" "närbilder" ;
  naerbutik_nn_1_1_N = mkN "närbutik" "närbutiker" ;
  naergaangenhet_nn_1_1_N = mkN "närgångenhet" "närgångenheter" ;
  naerhet_nn_1_1_N = mkN "närhet" "närheter" ;
  naeringsfrihet_nn_1_1_N = mkN "näringsfrihet" "näringsfriheter" ;
  naeringsverksamhet_nn_1_1_N = mkN "näringsverksamhet" "näringsverksamheter" ;
  naerkamp_nn_1_1_N = mkN "närkamp" "närkamper" ;
  naerpassage_nn_1_1_N = mkN "närpassage" "närpassager" ;
  naerpunkt_nn_1_1_N = mkN "närpunkt" "närpunkter" ;
  naerstrid_nn_1_1_N = mkN "närstrid" "närstrider" ;
  naersynthet_nn_1_1_N = mkN "närsynthet" "närsyntheter" ;
  naesprydnad_nn_1_1_N = mkN "näsprydnad" "näsprydnader" ;
  naesselcell_nn_1_1_N = mkN "nässelcell" "nässelceller" ;
  naessprej_nn_1_1_N = mkN "nässprej" "nässprejer" ;
  naetattack_nn_1_1_N = mkN "nätattack" "nätattacker" ;
  naetdrog_nn_1_1_N = mkN "nätdrog" "nätdroger" ;
  naetgemenskap_nn_1_1_N = mkN "nätgemenskap" "nätgemenskaper" ;
  naetkommunikation_nn_1_1_N = mkN "nätkommunikation" "nätkommunikationer" ;
  naetkontakt_nn_1_1_N = mkN "nätkontakt" "nätkontakter" ;
  naevkamp_nn_1_1_N = mkN "nävkamp" "nävkamper" ;
  naalventil_nn_1_1_N = mkN "nålventil" "nålventiler" ;
  noedloegn_nn_1_1_N = mkN "nödlögn" "nödlögner" ;
  noedraket_nn_1_1_N = mkN "nödraket" "nödraketer" ;
  noedsituation_nn_1_1_N = mkN "nödsituation" "nödsituationer" ;
  noedtorftighet_nn_1_1_N = mkN "nödtorftighet" "nödtorftigheter" ;
  noedvaendighet_nn_1_1_N = mkN "nödvändighet" "nödvändigheter" ;
  noejeslokal_nn_1_1_N = mkN "nöjeslokal" "nöjeslokaler" ;
  noejesmaskin_nn_1_1_N = mkN "nöjesmaskin" "nöjesmaskiner" ;
  noejespark_nn_1_1_N = mkN "nöjespark" "nöjesparker" ;
  noejestur_nn_1_1_N = mkN "nöjestur" "nöjesturer" ;
  noetbarhet_nn_1_1_N = mkN "nötbarhet" "nötbarheter" ;
  noetfrukt_nn_1_1_N = mkN "nötfrukt" "nötfrukter" ;
  oaktsamhet_nn_1_N = mkN "oaktsamhet" "oaktsamheter" ;
  oanfaektbarhet_nn_1_1_N = mkN "oanfäktbarhet" "oanfäktbarheter" ;
  oanfaektlighet_nn_1_1_N = mkN "oanfäktlighet" "oanfäktligheter" ;
  oanstaendighet_nn_1_1_N = mkN "oanständighet" "oanständigheter" ;
  oantastbarhet_nn_1_N = mkN "oantastbarhet" "oantastbarheter" ;
  oantastlighet_nn_1_N = mkN "oantastlighet" "oantastligheter" ;
  oart_nn_1_N = mkN "oart" "oarter" ;
  oartighet_nn_1_N = mkN "oartighet" "oartigheter" ;
  oavhaengighet_nn_1_1_N = mkN "oavhängighet" "oavhängigheter" ;
  obducent_nn_1_N = mkN "obducent" "obducenter" ;
  obduktion_nn_1_N = mkN "obduktion" "obduktioner" ;
  obegriplighet_nn_1_N = mkN "obegriplighet" "obegripligheter" ;
  obehaglighet_nn_1_N = mkN "obehaglighet" "obehagligheter" ;
  obehoevlighet_nn_1_1_N = mkN "obehövlighet" "obehövligheter" ;
  obekvaemhet_nn_1_1_N = mkN "obekvämhet" "obekvämheter" ;
  obemaerkthet_nn_1_1_N = mkN "obemärkthet" "obemärktheter" ;
  oberoerdhet_nn_1_1_N = mkN "oberördhet" "oberördheter" ;
  obeslutsamhet_nn_1_N = mkN "obeslutsamhet" "obeslutsamheter" ;
  obestaembarhet_nn_1_1_N = mkN "obestämbarhet" "obestämbarheter" ;
  obestaemdhet_nn_1_1_N = mkN "obestämdhet" "obestämdheter" ;
  obestaendighet_nn_1_1_N = mkN "obeständighet" "obeständigheter" ;
  obetydlighet_nn_1_N = mkN "obetydlighet" "obetydligheter" ;
  obillighet_nn_1_N = mkN "obillighet" "obilligheter" ;
  objektivitet_nn_1_N = mkN "objektivitet" "objektiviteter" ;
  objektsform_nn_1_N = mkN "objektsform" "objektsformer" ;
  oblat_nn_1_N = mkN "oblat" "oblater" ;
  obligation_nn_1_N = mkN "obligation" "obligationer" ;
  oblikvitet_nn_1_N = mkN "oblikvitet" "oblikviteter" ;
  oboe_nn_1_N = mkN "oboe" "oboer" ;
  obscenitet_nn_1_N = mkN "obscenitet" "obsceniteter" ;
  observation_nn_1_N = mkN "observation" "observationer" ;
  observationsakt_nn_1_N = mkN "observationsakt" "observationsakter" ;
  observationsklinik_nn_1_N = mkN "observationsklinik" "observationskliniker" ;
  observatoer_nn_1_1_N = mkN "observatör" "observatörer" ;
  obsklinik_nn_1_N = mkN "obsklinik" "obskliniker" ;
  obstipation_nn_1_N = mkN "obstipation" "obstipationer" ;
  obstruent_nn_1_N = mkN "obstruent" "obstruenter" ;
  obstruktion_nn_1_N = mkN "obstruktion" "obstruktioner" ;
  obygd_nn_1_N = mkN "obygd" "obygder" ;
  oboenhoerlighet_nn_1_1_N = mkN "obönhörlighet" "obönhörligheter" ;
  occasion_nn_1_N = mkN "occasion" "occasioner" ;
  oceanograf_nn_1_N = mkN "oceanograf" "oceanografer" ;
  ockasion_nn_1_N = mkN "ockasion" "ockasioner" ;
  ocklusion_nn_1_N = mkN "ocklusion" "ocklusioner" ;
  ockultation_nn_1_N = mkN "ockultation" "ockultationer" ;
  ockupation_nn_1_N = mkN "ockupation" "ockupationer" ;
  odlingsareal_nn_1_N = mkN "odlingsareal" "odlingsarealer" ;
  odlingsmark_nn_1_N = mkN "odlingsmark" "odlingsmarker" ;
  odrickbarhet_nn_1_N = mkN "odrickbarhet" "odrickbarheter" ;
  odoer_nn_1_1_N = mkN "odör" "odörer" ;
  oegentlighet_nn_1_N = mkN "oegentlighet" "oegentligheter" ;
  oenighet_nn_1_N = mkN "oenighet" "oenigheter" ;
  ofarlighet_nn_1_N = mkN "ofarlighet" "ofarligheter" ;
  offensiv_nn_1_N = mkN "offensiv" "offensiver" ;
  offentlighet_nn_1_N = mkN "offentlighet" "offentligheter" ;
  offerent_nn_1_N = mkN "offerent" "offerenter" ;
  offeridentitet_nn_1_N = mkN "offeridentitet" "offeridentiteter" ;
  offerroll_nn_1_N = mkN "offerroll" "offerroller" ;
  offert_nn_1_N = mkN "offert" "offerter" ;
  officerskamrat_nn_1_N = mkN "officerskamrat" "officerskamrater" ;
  oformlighet_nn_1_N = mkN "oformlighet" "oformligheter" ;
  ofrihet_nn_1_N = mkN "ofrihet" "ofriheter" ;
  ofullkomlighet_nn_1_N = mkN "ofullkomlighet" "ofullkomligheter" ;
  ofullstaendighet_nn_1_1_N = mkN "ofullständighet" "ofullständigheter" ;
  ofaerdighet_nn_2_1_N = mkN "ofärdighet" "ofärdigheter" ;
  ofaerg_nn_1_1_N = mkN "ofärg" "ofärger" ;
  ofoerarglighet_nn_1_1_N = mkN "oförarglighet" "oförargligheter" ;
  ofoerenlighet_nn_1_1_N = mkN "oförenlighet" "oförenligheter" ;
  ofoergloemlighet_nn_1_1_N = mkN "oförglömlighet" "oförglömligheter" ;
  ofoergaenglighet_nn_1_1_N = mkN "oförgänglighet" "oförgängligheter" ;
  ofoerklarlighet_nn_1_1_N = mkN "oförklarlighet" "oförklarligheter" ;
  ofoernuftighet_nn_1_1_N = mkN "oförnuftighet" "oförnuftigheter" ;
  ofoerraett_nn_1_1_N = mkN "oförrätt" "oförrätter" ;
  ofoerskaemdhet_nn_1_1_N = mkN "oförskämdhet" "oförskämdheter" ;
  ofoerstaaelighet_nn_1_1_N = mkN "oförståelighet" "oförståeligheter" ;
  ofoervaegenhet_nn_1_1_N = mkN "oförvägenhet" "oförvägenheter" ;
  ofoeraenderlighet_nn_1_1_N = mkN "oföränderlighet" "oföränderligheter" ;
  ohederlighet_nn_1_N = mkN "ohederlighet" "ohederligheter" ;
  ohygglighet_nn_1_N = mkN "ohygglighet" "ohyggligheter" ;
  ohaallbarhet_nn_1_1_N = mkN "ohållbarhet" "ohållbarheter" ;
  ohoerbarhet_nn_1_1_N = mkN "ohörbarhet" "ohörbarheter" ;
  ojusthet_nn_1_N = mkN "ojusthet" "ojustheter" ;
  ojaemlikhet_nn_1_1_N = mkN "ojämlikhet" "ojämlikheter" ;
  ojaemnhet_nn_1_1_N = mkN "ojämnhet" "ojämnheter" ;
  okamratlighet_nn_1_N = mkN "okamratlighet" "okamratligheter" ;
  oklarhet_nn_1_N = mkN "oklarhet" "oklarheter" ;
  okristlighet_nn_1_N = mkN "okristlighet" "okristligheter" ;
  oktett_nn_1_N = mkN "oktett" "oktetter" ;
  okunnighet_nn_1_N = mkN "okunnighet" "okunnigheter" ;
  okynnesjakt_nn_1_N = mkN "okynnesjakt" "okynnesjakter" ;
  okyskhet_nn_1_N = mkN "okyskhet" "okyskheter" ;
  okaenslighet_nn_1_1_N = mkN "okänslighet" "okänsligheter" ;
  olaglighet_nn_1_N = mkN "olaglighet" "olagligheter" ;
  olat_nn_1_N = mkN "olat" "olater" ;
  oleat_nn_1_N = mkN "oleat" "oleater" ;
  olefin_nn_1_N = mkN "olefin" "olefiner" ;
  olidlighet_nn_1_N = mkN "olidlighet" "olidligheter" ;
  olikformighet_nn_1_N = mkN "olikformighet" "olikformigheter" ;
  olikhet_nn_1_N = mkN "olikhet" "olikheter" ;
  oliv_nn_1_N = mkN "oliv" "oliver" ;
  olivin_nn_1_N = mkN "olivin" "oliviner" ;
  oljebrand_nn_1_N = mkN "oljebrand" "oljebränder" ;
  oljefaerg_nn_1_1_N = mkN "oljefärg" "oljefärger" ;
  oljenivaavakt_nn_1_1_N = mkN "oljenivåvakt" "oljenivåvakter" ;
  oljepalm_nn_1_N = mkN "oljepalm" "oljepalmer" ;
  oljesanktion_nn_1_N = mkN "oljesanktion" "oljesanktioner" ;
  oljestad_nn_1_N = mkN "oljestad" "oljestäder" ;
  olovlighet_nn_1_N = mkN "olovlighet" "olovligheter" ;
  olyckshaendelse_nn_1_1_N = mkN "olyckshändelse" "olyckshändelser" ;
  olyckskamrat_nn_1_N = mkN "olyckskamrat" "olyckskamrater" ;
  olycksstatistik_nn_1_N = mkN "olycksstatistik" "olycksstatistiker" ;
  olyckstrend_nn_1_N = mkN "olyckstrend" "olyckstrender" ;
  olydighet_nn_1_N = mkN "olydighet" "olydigheter" ;
  olydnad_nn_1_N = mkN "olydnad" "olydnader" ;
  olympiad_nn_1_N = mkN "olympiad" "olympiader" ;
  olaegenhet_nn_1_1_N = mkN "olägenhet" "olägenheter" ;
  olaeglighet_nn_1_1_N = mkN "oläglighet" "olägligheter" ;
  ombyggnad_nn_1_N = mkN "ombyggnad" "ombyggnader" ;
  ombyggnation_nn_1_N = mkN "ombyggnation" "ombyggnationer" ;
  omdoemesgillhet_nn_1_1_N = mkN "omdömesgillhet" "omdömesgillheter" ;
  omdoemesloeshet_nn_1_1_N = mkN "omdömeslöshet" "omdömeslösheter" ;
  omedvetenhet_nn_1_N = mkN "omedvetenhet" "omedvetenheter" ;
  omelett_nn_1_N = mkN "omelett" "omeletter" ;
  omistlighet_nn_1_N = mkN "omistlighet" "omistligheter" ;
  omkostnad_nn_1_N = mkN "omkostnad" "omkostnader" ;
  omkoerningsfil_nn_1_1_N = mkN "omkörningsfil" "omkörningsfiler" ;
  omloppshastighet_nn_1_N = mkN "omloppshastighet" "omloppshastigheter" ;
  omloppstid_nn_1_N = mkN "omloppstid" "omloppstider" ;
  omogenhet_nn_1_N = mkN "omogenhet" "omogenheter" ;
  omskiftartangent_nn_1_N = mkN "omskiftartangent" "omskiftartangenter" ;
  omskaerelse_nn_1_1_N = mkN "omskärelse" "omskärelser" ;
  omslagsbild_nn_1_N = mkN "omslagsbild" "omslagsbilder" ;
  omsorg_nn_1_N = mkN "omsorg" "omsorger" ;
  omsorgsfullhet_nn_1_N = mkN "omsorgsfullhet" "omsorgsfullheter" ;
  omstart_nn_1_N = mkN "omstart" "omstarter" ;
  omstaendighet_nn_1_1_N = mkN "omständighet" "omständigheter" ;
  omvaendelse_nn_1_1_N = mkN "omvändelse" "omvändelser" ;
  omvaendningsfilm_nn_1_1_N = mkN "omvändningsfilm" "omvändningsfilmer" ;
  omvaardnad_nn_1_1_N = mkN "omvårdnad" "omvårdnader" ;
  omaensklighet_nn_1_1_N = mkN "omänsklighet" "omänskligheter" ;
  omaattlighet_nn_1_1_N = mkN "omåttlighet" "omåttligheter" ;
  omoejlighet_nn_1_1_N = mkN "omöjlighet" "omöjligheter" ;
  onaturlighet_nn_1_N = mkN "onaturlighet" "onaturligheter" ;
  ondskefullhet_nn_1_N = mkN "ondskefullhet" "ondskefullheter" ;
  onykterhet_nn_1_N = mkN "onykterhet" "onykterheter" ;
  onyttighet_nn_1_N = mkN "onyttighet" "onyttigheter" ;
  onoedighet_nn_1_1_N = mkN "onödighet" "onödigheter" ;
  opacitet_nn_1_N = mkN "opacitet" "opaciteter" ;
  opal_nn_1_N = mkN "opal" "opaler" ;
  operabalett_nn_1_N = mkN "operabalett" "operabaletter" ;
  operabiljett_nn_1_N = mkN "operabiljett" "operabiljetter" ;
  operakompositoer_nn_1_1_N = mkN "operakompositör" "operakompositörer" ;
  operation_nn_1_N = mkN "operation" "operationer" ;
  operationslinje_nn_1_N = mkN "operationslinje" "operationslinjer" ;
  operatoer_nn_1_1_N = mkN "operatör" "operatörer" ;
  opinion_nn_1_N = mkN "opinion" "opinioner" ;
  opinionsnaemnd_nn_1_1_N = mkN "opinionsnämnd" "opinionsnämnder" ;
  oppbyggnad_nn_1_N = mkN "oppbyggnad" "oppbyggnader" ;
  oppfart_nn_1_N = mkN "oppfart" "oppfarter" ;
  oppgoerelse_nn_1_1_N = mkN "oppgörelse" "oppgörelser" ;
  opphoejdhet_nn_1_1_N = mkN "opphöjdhet" "opphöjdheter" ;
  opphoejelse_nn_1_1_N = mkN "opphöjelse" "opphöjelser" ;
  oppkaeftighet_nn_1_1_N = mkN "oppkäftighet" "oppkäftigheter" ;
  opponent_nn_1_N = mkN "opponent" "opponenter" ;
  opposition_nn_1_N = mkN "opposition" "oppositioner" ;
  opptagenhet_nn_1_N = mkN "opptagenhet" "opptagenheter" ;
  option_nn_1_N = mkN "option" "optioner" ;
  optionsraett_nn_1_1_N = mkN "optionsrätt" "optionsrätter" ;
  optokomponent_nn_1_N = mkN "optokomponent" "optokomponenter" ;
  orange_nn_1_N = mkN "orange" "oranger" ;
  orangutang_nn_1_N = mkN "orangutang" "orangutanger" ;
  oration_nn_1_N = mkN "oration" "orationer" ;
  orbital_nn_1_N = mkN "orbital" "orbitaler" ;
  ordaccent_nn_1_N = mkN "ordaccent" "ordaccenter" ;
  ordalydelse_nn_1_N = mkN "ordalydelse" "ordalydelser" ;
  ordbild_nn_1_N = mkN "ordbild" "ordbilder" ;
  ordblindhet_nn_1_N = mkN "ordblindhet" "ordblindheter" ;
  ordbredd_nn_1_N = mkN "ordbredd" "ordbredder" ;
  ordentreprenoer_nn_1_1_N = mkN "ordentreprenör" "ordentreprenörer" ;
  ordform_nn_1_N = mkN "ordform" "ordformer" ;
  ordfoeljd_nn_1_1_N = mkN "ordföljd" "ordföljder" ;
  ordgrupp_nn_1_N = mkN "ordgrupp" "ordgrupper" ;
  ordinand_nn_1_N = mkN "ordinand" "ordinander" ;
  ordination_nn_1_N = mkN "ordination" "ordinationer" ;
  ordkonstnaer_nn_1_1_N = mkN "ordkonstnär" "ordkonstnärer" ;
  ordkonstruktion_nn_1_N = mkN "ordkonstruktion" "ordkonstruktioner" ;
  ordlaengd_nn_1_1_N = mkN "ordlängd" "ordlängder" ;
  ordningsbestaemmelse_nn_1_1_N = mkN "ordningsbestämmelse" "ordningsbestämmelser" ;
  ordningsfoeljd_nn_1_1_N = mkN "ordningsföljd" "ordningsföljder" ;
  ordningsfoereskrift_nn_1_1_N = mkN "ordningsföreskrift" "ordningsföreskrifter" ;
  ordningsfoerseelse_nn_1_1_N = mkN "ordningsförseelse" "ordningsförseelser" ;
  ordningsvakt_nn_1_N = mkN "ordningsvakt" "ordningsvakter" ;
  ordskillnad_nn_1_N = mkN "ordskillnad" "ordskillnader" ;
  ordskrift_nn_1_N = mkN "ordskrift" "ordskrifter" ;
  ordstrid_nn_1_N = mkN "ordstrid" "ordstrider" ;
  oread_nn_1_N = mkN "oread" "oreader" ;
  oredlighet_nn_1_N = mkN "oredlighet" "oredligheter" ;
  oregelbundenhet_nn_1_N = mkN "oregelbundenhet" "oregelbundenheter" ;
  oregelmaessighet_nn_1_1_N = mkN "oregelmässighet" "oregelmässigheter" ;
  orenhet_nn_1_N = mkN "orenhet" "orenheter" ;
  orenlighet_nn_1_N = mkN "orenlighet" "orenligheter" ;
  organcell_nn_1_N = mkN "organcell" "organceller" ;
  organdonation_nn_1_N = mkN "organdonation" "organdonationer" ;
  organell_nn_1_N = mkN "organell" "organeller" ;
  organisation_nn_1_N = mkN "organisation" "organisationer" ;
  organisationsform_nn_1_N = mkN "organisationsform" "organisationsformer" ;
  organisatoer_nn_1_1_N = mkN "organisatör" "organisatörer" ;
  orgasm_nn_1_N = mkN "orgasm" "orgasmer" ;
  orgie_nn_1_N = mkN "orgie" "orgier" ;
  oriental_nn_1_N = mkN "oriental" "orientaler" ;
  orienteringspunkt_nn_1_N = mkN "orienteringspunkt" "orienteringspunkter" ;
  originalitet_nn_1_N = mkN "originalitet" "originaliteter" ;
  oriktighet_nn_1_N = mkN "oriktighet" "oriktigheter" ;
  orimlighet_nn_1_N = mkN "orimlighet" "orimligheter" ;
  ornat_nn_1_N = mkN "ornat" "ornater" ;
  orolighet_nn_1_N = mkN "orolighet" "oroligheter" ;
  orsak_nn_1_N = mkN "orsak" "orsaker" ;
  ort_nn_1_N = mkN "ort" "orter" ;
  ortlinje_nn_1_N = mkN "ortlinje" "ortlinjer" ;
  ortodrom_nn_1_N = mkN "ortodrom" "ortodromer" ;
  ortoped_nn_1_N = mkN "ortoped" "ortopeder" ;
  ortsgrupp_nn_1_N = mkN "ortsgrupp" "ortsgrupper" ;
  ortstid_nn_1_N = mkN "ortstid" "ortstider" ;
  oraett_nn_1_1_N = mkN "orätt" "orätter" ;
  oraettfaerdighet_nn_1_1_N = mkN "orättfärdighet" "orättfärdigheter" ;
  osaklighet_nn_1_N = mkN "osaklighet" "osakligheter" ;
  oscillation_nn_1_N = mkN "oscillation" "oscillationer" ;
  oscillograf_nn_1_N = mkN "oscillograf" "oscillografer" ;
  osed_nn_1_N = mkN "osed" "oseder" ;
  osedlighet_nn_1_N = mkN "osedlighet" "osedligheter" ;
  osjaelviskhet_nn_1_1_N = mkN "osjälviskhet" "osjälviskheter" ;
  osjaelvstaendighet_nn_1_1_N = mkN "osjälvständighet" "osjälvständigheter" ;
  oskiljaktighet_nn_1_N = mkN "oskiljaktighet" "oskiljaktigheter" ;
  oskuld_nn_1_N = mkN "oskuld" "oskulder" ;
  osmaklighet_nn_1_N = mkN "osmaklighet" "osmakligheter" ;
  osmidighet_nn_1_N = mkN "osmidighet" "osmidigheter" ;
  osportslighet_nn_1_N = mkN "osportslighet" "osportsligheter" ;
  ostasiat_nn_1_N = mkN "ostasiat" "ostasiater" ;
  ostentation_nn_1_N = mkN "ostentation" "ostentationer" ;
  ostkant_nn_1_N = mkN "ostkant" "ostkanter" ;
  ostkraem_nn_1_1_N = mkN "ostkräm" "ostkrämer" ;
  oststaang_nn_1_1_N = mkN "oststång" "oststänger" ;
  osundhet_nn_1_N = mkN "osundhet" "osundheter" ;
  osynlighet_nn_1_N = mkN "osynlighet" "osynligheter" ;
  osaekerhet_nn_1_1_N = mkN "osäkerhet" "osäkerheter" ;
  osaekerhetsrelation_nn_1_1_N = mkN "osäkerhetsrelation" "osäkerhetsrelationer" ;
  otidighet_nn_1_N = mkN "otidighet" "otidigheter" ;
  otidsenlighet_nn_1_N = mkN "otidsenlighet" "otidsenligheter" ;
  otillboerlighet_nn_1_1_N = mkN "otillbörlighet" "otillbörligheter" ;
  otillgaenglighet_nn_1_1_N = mkN "otillgänglighet" "otillgängligheter" ;
  otrevlighet_nn_1_N = mkN "otrevlighet" "otrevligheter" ;
  otrohet_nn_1_N = mkN "otrohet" "otroheter" ;
  otrohetsaffaer_nn_1_1_N = mkN "otrohetsaffär" "otrohetsaffärer" ;
  otrohetsuppgift_nn_1_N = mkN "otrohetsuppgift" "otrohetsuppgifter" ;
  otrolighet_nn_1_N = mkN "otrolighet" "otroligheter" ;
  otryckbarhet_nn_1_N = mkN "otryckbarhet" "otryckbarheter" ;
  otydlighet_nn_1_N = mkN "otydlighet" "otydligheter" ;
  otymplighet_nn_1_N = mkN "otymplighet" "otympligheter" ;
  otaeckhet_nn_1_1_N = mkN "otäckhet" "otäckheter" ;
  otaethet_nn_1_1_N = mkN "otäthet" "otätheter" ;
  ouvertyr_nn_1_N = mkN "ouvertyr" "ouvertyrer" ;
  oval_nn_1_N = mkN "oval" "ovaler" ;
  ovanlighet_nn_1_N = mkN "ovanlighet" "ovanligheter" ;
  ovation_nn_1_N = mkN "ovation" "ovationer" ;
  overall_nn_1_N = mkN "overall" "overaller" ;
  overheadbild_nn_1_N = mkN "overheadbild" "overheadbilder" ;
  overksamhet_nn_1_N = mkN "overksamhet" "overksamheter" ;
  ovetenhet_nn_1_N = mkN "ovetenhet" "ovetenheter" ;
  ovettighet_nn_1_N = mkN "ovettighet" "ovettigheter" ;
  ovisshet_nn_1_N = mkN "ovisshet" "ovissheter" ;
  ovulation_nn_1_N = mkN "ovulation" "ovulationer" ;
  ovaenlighet_nn_1_1_N = mkN "ovänlighet" "ovänligheter" ;
  ovaenskap_nn_1_1_N = mkN "ovänskap" "ovänskaper" ;
  ovaesentlighet_nn_1_1_N = mkN "oväsentlighet" "oväsentligheter" ;
  oxeltand_nn_1_N = mkN "oxeltand" "oxeltänder" ;
  oxidation_nn_1_N = mkN "oxidation" "oxidationer" ;
  oxidationsreaktion_nn_1_N = mkN "oxidationsreaktion" "oxidationsreaktioner" ;
  oxytocin_nn_1_N = mkN "oxytocin" "oxytociner" ;
  ozelot_nn_1_N = mkN "ozelot" "ozeloter" ;
  ozonhalt_nn_1_N = mkN "ozonhalt" "ozonhalter" ;
  ozonmaengd_nn_1_1_N = mkN "ozonmängd" "ozonmängder" ;
  ozonreduktion_nn_1_N = mkN "ozonreduktion" "ozonreduktioner" ;
  oaendlighet_nn_1_1_N = mkN "oändlighet" "oändligheter" ;
  oaerlighet_nn_1_1_N = mkN "oärlighet" "oärligheter" ;
  oaatkomlighet_nn_1_1_N = mkN "oåtkomlighet" "oåtkomligheter" ;
  page_nn_1_N = mkN "page" "pager" ;
  pagefrisyr_nn_1_N = mkN "pagefrisyr" "pagefrisyrer" ;
  pagod_nn_1_N = mkN "pagod" "pagoder" ;
  paj_nn_1_N = mkN "paj" "pajer" ;
  paketauktion_nn_1_N = mkN "paketauktion" "paketauktioner" ;
  paketexpedition_nn_1_N = mkN "paketexpedition" "paketexpeditioner" ;
  pakt_nn_1_N = mkN "pakt" "pakter" ;
  palatal_nn_1_N = mkN "palatal" "palataler" ;
  palatsrevolution_nn_1_N = mkN "palatsrevolution" "palatsrevolutioner" ;
  paleograf_nn_1_N = mkN "paleograf" "paleografer" ;
  palett_nn_1_N = mkN "palett" "paletter" ;
  palissad_nn_1_N = mkN "palissad" "palissader" ;
  paljett_nn_1_N = mkN "paljett" "paljetter" ;
  palm_nn_1_N = mkN "palm" "palmer" ;
  palmett_nn_1_N = mkN "palmett" "palmetter" ;
  palmplym_nn_1_N = mkN "palmplym" "palmplymer" ;
  palp_nn_1_N = mkN "palp" "palper" ;
  palpation_nn_1_N = mkN "palpation" "palpationer" ;
  pamflett_nn_1_N = mkN "pamflett" "pamfletter" ;
  panegyrik_nn_1_N = mkN "panegyrik" "panegyriker" ;
  paneldebatt_nn_1_N = mkN "paneldebatt" "paneldebatter" ;
  paneldiskussion_nn_1_N = mkN "paneldiskussion" "paneldiskussioner" ;
  panett_nn_1_N = mkN "panett" "panetter" ;
  panfloejt_nn_1_1_N = mkN "panflöjt" "panflöjter" ;
  pang_pangfilm_nn_1_N = mkN "pang-pangfilm" "pang-pangfilmer" ;
  panikattack_nn_1_N = mkN "panikattack" "panikattacker" ;
  panikaangestattack_nn_1_1_N = mkN "panikångestattack" "panikångestattacker" ;
  pannkakssmet_nn_1_N = mkN "pannkakssmet" "pannkakssmeter" ;
  pannlob_nn_1_N = mkN "pannlob" "pannlober" ;
  pansargeneral_nn_1_N = mkN "pansargeneral" "pansargeneraler" ;
  pansargranat_nn_1_N = mkN "pansargranat" "pansargranater" ;
  pansartrupp_nn_1_N = mkN "pansartrupp" "pansartrupper" ;
  pant_nn_1_N = mkN "pant" "panter" ;
  pantbank_nn_1_N = mkN "pantbank" "pantbanker" ;
  panterkatt_nn_1_N = mkN "panterkatt" "panterkatter" ;
  pantlaaneroerelse_nn_1_1_N = mkN "pantlånerörelse" "pantlånerörelser" ;
  pantograf_nn_1_N = mkN "pantograf" "pantografer" ;
  pantomim_nn_1_N = mkN "pantomim" "pantomimer" ;
  pantraett_nn_1_1_N = mkN "panträtt" "panträtter" ;
  papiljott_nn_1_N = mkN "papiljott" "papiljotter" ;
  papill_nn_1_N = mkN "papill" "papiller" ;
  pappersmaskin_nn_1_N = mkN "pappersmaskin" "pappersmaskiner" ;
  papperspapiljott_nn_1_N = mkN "papperspapiljott" "papperspapiljotter" ;
  pappersservett_nn_1_N = mkN "pappersservett" "pappersservetter" ;
  pappkartong_nn_1_N = mkN "pappkartong" "pappkartonger" ;
  parabolantenn_nn_1_N = mkN "parabolantenn" "parabolantenner" ;
  paradisstrand_nn_1_N = mkN "paradisstrand" "paradisstränder" ;
  paraduniform_nn_1_N = mkN "paraduniform" "paraduniformer" ;
  paragraf_nn_1_N = mkN "paragraf" "paragrafer" ;
  parallelldam_nn_1_N = mkN "parallelldam" "parallelldamer" ;
  parallellepiped_nn_1_N = mkN "parallellepiped" "parallellepipeder" ;
  parallellgrad_nn_1_N = mkN "parallellgrad" "parallellgrader" ;
  parallellitet_nn_1_N = mkN "parallellitet" "parallelliteter" ;
  parapet_nn_1_N = mkN "parapet" "parapeter" ;
  paraplyorganisation_nn_1_N = mkN "paraplyorganisation" "paraplyorganisationer" ;
  parce_nn_1_N = mkN "parce" "parcer" ;
  parcell_nn_1_N = mkN "parcell" "parceller" ;
  parentation_nn_1_N = mkN "parentation" "parentationer" ;
  parerstaang_nn_1_1_N = mkN "parerstång" "parerstänger" ;
  parfym_nn_1_N = mkN "parfym" "parfymer" ;
  parfymaffaer_nn_1_1_N = mkN "parfymaffär" "parfymaffärer" ;
  parfymdoft_nn_1_N = mkN "parfymdoft" "parfymdofter" ;
  parisfrisyr_nn_1_N = mkN "parisfrisyr" "parisfrisyrer" ;
  paritet_nn_1_N = mkN "paritet" "pariteter" ;
  park_nn_1_N = mkN "park" "parker" ;
  parkeringsautomat_nn_1_N = mkN "parkeringsautomat" "parkeringsautomater" ;
  parkeringsavgift_nn_1_N = mkN "parkeringsavgift" "parkeringsavgifter" ;
  parkeringsbot_nn_1_N = mkN "parkeringsbot" "parkeringsböter" ;
  parkeringsvakt_nn_1_N = mkN "parkeringsvakt" "parkeringsvakter" ;
  parkett_nn_1_N = mkN "parkett" "parketter" ;
  parkpromenad_nn_1_N = mkN "parkpromenad" "parkpromenader" ;
  parlamentsreform_nn_1_N = mkN "parlamentsreform" "parlamentsreformer" ;
  parlamentaer_nn_1_1_N = mkN "parlamentär" "parlamentärer" ;
  parloer_nn_1_1_N = mkN "parlör" "parlörer" ;
  parningsdrift_nn_1_N = mkN "parningsdrift" "parningsdrifter" ;
  parningsdraekt_nn_1_1_N = mkN "parningsdräkt" "parningsdräkter" ;
  parningsmetod_nn_1_N = mkN "parningsmetod" "parningsmetoder" ;
  parningstid_nn_1_N = mkN "parningstid" "parningstider" ;
  paroll_nn_1_N = mkN "paroll" "paroller" ;
  paroxysm_nn_1_N = mkN "paroxysm" "paroxysmer" ;
  part_nn_1_N = mkN "part" "parter" ;
  parterr_nn_1_N = mkN "parterr" "parterrer" ;
  partialton_nn_1_N = mkN "partialton" "partialtoner" ;
  partiapparat_nn_1_N = mkN "partiapparat" "partiapparater" ;
  partichef_nn_1_N = mkN "partichef" "partichefer" ;
  partifaerg_nn_1_1_N = mkN "partifärg" "partifärger" ;
  partigrupp_nn_1_N = mkN "partigrupp" "partigrupper" ;
  partikamrat_nn_1_N = mkN "partikamrat" "partikamrater" ;
  partikelegenskap_nn_1_N = mkN "partikelegenskap" "partikelegenskaper" ;
  partikelreaktion_nn_1_N = mkN "partikelreaktion" "partikelreaktioner" ;
  partiledardebatt_nn_1_N = mkN "partiledardebatt" "partiledardebatter" ;
  partiledarkandidat_nn_1_N = mkN "partiledarkandidat" "partiledarkandidater" ;
  partimotion_nn_1_N = mkN "partimotion" "partimotioner" ;
  partiskhet_nn_1_N = mkN "partiskhet" "partiskheter" ;
  partistyrelse_nn_1_N = mkN "partistyrelse" "partistyrelser" ;
  partitrohet_nn_1_N = mkN "partitrohet" "partitroheter" ;
  partsbehoerighet_nn_1_1_N = mkN "partsbehörighet" "partsbehörigheter" ;
  paskill_nn_1_N = mkN "paskill" "paskiller" ;
  passad_nn_1_N = mkN "passad" "passader" ;
  passage_nn_1_N = mkN "passage" "passager" ;
  passagerarsalong_nn_1_N = mkN "passagerarsalong" "passagerarsalonger" ;
  passepartout_nn_1_N = mkN "passepartout" "passepartouter" ;
  passfrihet_nn_1_N = mkN "passfrihet" "passfriheter" ;
  passion_nn_1_N = mkN "passion" "passioner" ;
  passionsfrukt_nn_1_N = mkN "passionsfrukt" "passionsfrukter" ;
  passivform_nn_1_N = mkN "passivform" "passivformer" ;
  passivitet_nn_1_N = mkN "passivitet" "passiviteter" ;
  passivum_nn_1_N = mkN "passiv" "passiver" ;
  passkontrollant_nn_1_N = mkN "passkontrollant" "passkontrollanter" ;
  passopp_nn_1_N = mkN "passopp" "passopper" ;
  passpoal_nn_1_N = mkN "passpoal" "passpoaler" ;
  pastaraett_nn_1_1_N = mkN "pastarätt" "pastarätter" ;
  pastasallad_nn_1_N = mkN "pastasallad" "pastasallader" ;
  pastej_nn_1_N = mkN "pastej" "pastejer" ;
  pastell_nn_1_N = mkN "pastell" "pasteller" ;
  pastellfaerg_nn_1_1_N = mkN "pastellfärg" "pastellfärger" ;
  pastill_nn_1_N = mkN "pastill" "pastiller" ;
  pastoral_nn_1_N = mkN "pastoral" "pastoraler" ;
  pastoratsadjunkt_nn_1_N = mkN "pastoratsadjunkt" "pastoratsadjunkter" ;
  pastorsadjunkt_nn_1_N = mkN "pastorsadjunkt" "pastorsadjunkter" ;
  pastorsexpedition_nn_1_N = mkN "pastorsexpedition" "pastorsexpeditioner" ;
  paten_nn_1_N = mkN "paten" "patener" ;
  patentadvokat_nn_1_N = mkN "patentadvokat" "patentadvokater" ;
  patient_nn_1_N = mkN "patient" "patienter" ;
  patriark_nn_1_N = mkN "patriark" "patriarker" ;
  patricierslaekt_nn_1_1_N = mkN "patriciersläkt" "patriciersläkter" ;
  patrull_nn_1_N = mkN "patrull" "patruller" ;
  paulun_nn_1_N = mkN "paulun" "pauluner" ;
  pavane_nn_1_N = mkN "pavane" "pavaner" ;
  paviljong_nn_1_N = mkN "paviljong" "paviljonger" ;
  peang_nn_1_N = mkN "peang" "peanger" ;
  pedagog_nn_1_N = mkN "pedagog" "pedagoger" ;
  pedal_nn_1_N = mkN "pedal" "pedaler" ;
  pedell_nn_1_N = mkN "pedell" "pedeller" ;
  peelingkraem_nn_1_1_N = mkN "peelingkräm" "peelingkrämer" ;
  pelarborrmaskin_nn_1_N = mkN "pelarborrmaskin" "pelarborrmaskiner" ;
  pelardomkraft_nn_1_N = mkN "pelardomkraft" "pelardomkrafter" ;
  pendang_nn_1_N = mkN "pendang" "pendanger" ;
  pendelroerelse_nn_1_1_N = mkN "pendelrörelse" "pendelrörelser" ;
  pendeltidtabell_nn_1_N = mkN "pendeltidtabell" "pendeltidtabeller" ;
  pendeltaagstidtabell_nn_1_1_N = mkN "pendeltågstidtabell" "pendeltågstidtabeller" ;
  penetration_nn_1_N = mkN "penetration" "penetrationer" ;
  penicillin_nn_1_N = mkN "penicillin" "penicilliner" ;
  penisattrapp_nn_1_N = mkN "penisattrapp" "penisattrapper" ;
  penjoar_nn_1_N = mkN "penjoar" "penjoarer" ;
  penningfoersaendelse_nn_1_1_N = mkN "penningförsändelse" "penningförsändelser" ;
  penninglott_nn_1_N = mkN "penninglott" "penninglotter" ;
  penningmarknad_nn_1_N = mkN "penningmarknad" "penningmarknader" ;
  penningtransaktion_nn_1_N = mkN "penningtransaktion" "penningtransaktioner" ;
  pennmodell_nn_1_N = mkN "pennmodell" "pennmodeller" ;
  pension_nn_1_N = mkN "pension" "pensioner" ;
  pensionaer_nn_1_1_N = mkN "pensionär" "pensionärer" ;
  pensionaerslaegenhet_nn_1_1_N = mkN "pensionärslägenhet" "pensionärslägenheter" ;
  pepparkaksmarodoer_nn_1_1_N = mkN "pepparkaksmarodör" "pepparkaksmarodörer" ;
  pepparkaksstad_nn_1_N = mkN "pepparkaksstad" "pepparkaksstäder" ;
  perception_nn_1_N = mkN "perception" "perceptioner" ;
  perfektion_nn_1_N = mkN "perfektion" "perfektioner" ;
  perfektum_nn_1_N = mkN "perfekt" "perfekter" ;
  perfiditet_nn_1_N = mkN "perfiditet" "perfiditeter" ;
  perforation_nn_1_N = mkN "perforation" "perforationer" ;
  period_nn_1_N = mkN "period" "perioder" ;
  periodicitet_nn_1_N = mkN "periodicitet" "periodiciteter" ;
  perkal_nn_1_N = mkN "perkal" "perkaler" ;
  perkolation_nn_1_N = mkN "perkolation" "perkolationer" ;
  perkussion_nn_1_N = mkN "perkussion" "perkussioner" ;
  permeabilitet_nn_1_N = mkN "permeabilitet" "permeabiliteter" ;
  permission_nn_1_N = mkN "permission" "permissioner" ;
  permittent_nn_1_N = mkN "permittent" "permittenter" ;
  permutation_nn_1_N = mkN "permutation" "permutationer" ;
  perrong_nn_1_N = mkN "perrong" "perronger" ;
  perrongkant_nn_1_N = mkN "perrongkant" "perrongkanter" ;
  perseveration_nn_1_N = mkN "perseveration" "perseverationer" ;
  persienn_nn_1_N = mkN "persienn" "persienner" ;
  personage_nn_1_N = mkN "personage" "personager" ;
  personalansvarsnaemnd_nn_1_1_N = mkN "personalansvarsnämnd" "personalansvarsnämnder" ;
  personalchef_nn_1_N = mkN "personalchef" "personalchefer" ;
  personalerfarenhet_nn_1_N = mkN "personalerfarenhet" "personalerfarenheter" ;
  personalorganisation_nn_1_N = mkN "personalorganisation" "personalorganisationer" ;
  personalpool_nn_1_N = mkN "personalpool" "personalpooler" ;
  personaltaethet_nn_1_1_N = mkN "personaltäthet" "personaltätheter" ;
  personalunion_nn_1_N = mkN "personalunion" "personalunioner" ;
  personattack_nn_1_N = mkN "personattack" "personattacker" ;
  personbilsvolym_nn_1_N = mkN "personbilsvolym" "personbilsvolymer" ;
  personifikation_nn_1_N = mkN "personifikation" "personifikationer" ;
  personkontakt_nn_1_N = mkN "personkontakt" "personkontakter" ;
  personkult_nn_1_N = mkN "personkult" "personkulter" ;
  personlighet_nn_1_N = mkN "personlighet" "personligheter" ;
  personlighetstyp_nn_1_N = mkN "personlighetstyp" "personlighetstyper" ;
  persontyp_nn_1_N = mkN "persontyp" "persontyper" ;
  personuppgift_nn_1_N = mkN "personuppgift" "personuppgifter" ;
  perspektivbild_nn_1_N = mkN "perspektivbild" "perspektivbilder" ;
  perturbation_nn_1_N = mkN "perturbation" "perturbationer" ;
  perversion_nn_1_N = mkN "perversion" "perversioner" ;
  perversitet_nn_1_N = mkN "perversitet" "perversiteter" ;
  petition_nn_1_N = mkN "petition" "petitioner" ;
  piaff_nn_1_N = mkN "piaff" "piaffer" ;
  pianokonsert_nn_1_N = mkN "pianokonsert" "pianokonserter" ;
  pianolektion_nn_1_N = mkN "pianolektion" "pianolektioner" ;
  pianosonat_nn_1_N = mkN "pianosonat" "pianosonater" ;
  piccolafloejt_nn_1_1_N = mkN "piccolaflöjt" "piccolaflöjter" ;
  piccolo_nn_1_N = mkN "piccolo" "piccolor" ;
  pickup_nn_1_N = mkN "pickup" "pickuper" ;
  picot_nn_1_N = mkN "picot" "picoter" ;
  piedestal_nn_1_N = mkN "piedestal" "piedestaler" ;
  pierrot_nn_1_N = mkN "pierrot" "pierroter" ;
  pietet_nn_1_N = mkN "pietet" "pieteter" ;
  piezoelektricitet_nn_1_N = mkN "piezoelektricitet" "piezoelektriciteter" ;
  pigdebatt_nn_1_N = mkN "pigdebatt" "pigdebatter" ;
  piket_nn_1_N = mkN "piket" "piketer" ;
  pikoer_nn_1_1_N = mkN "pikör" "pikörer" ;
  pilaff_nn_1_N = mkN "pilaff" "pilaffer" ;
  pilgrim_nn_1_N = mkN "pilgrim" "pilgrimer" ;
  pilgrimsfaerd_nn_1_1_N = mkN "pilgrimsfärd" "pilgrimsfärder" ;
  pilot_nn_1_N = mkN "pilot" "piloter" ;
  pilotballong_nn_1_N = mkN "pilotballong" "pilotballonger" ;
  pilotstudie_nn_1_N = mkN "pilotstudie" "pilotstudier" ;
  pilsnerfilm_nn_1_N = mkN "pilsnerfilm" "pilsnerfilmer" ;
  pinal_nn_1_N = mkN "pinal" "pinaler" ;
  pincett_nn_1_N = mkN "pincett" "pincetter" ;
  pingsthelg_nn_1_N = mkN "pingsthelg" "pingsthelger" ;
  pinje_nn_1_N = mkN "pinje" "pinjer" ;
  pinlighet_nn_1_N = mkN "pinlighet" "pinligheter" ;
  pinsamhet_nn_1_N = mkN "pinsamhet" "pinsamheter" ;
  pinupbild_nn_1_N = mkN "pinupbild" "pinupbilder" ;
  pionjaer_nn_1_1_N = mkN "pionjär" "pionjärer" ;
  pipett_nn_1_N = mkN "pipett" "pipetter" ;
  piplaengd_nn_1_1_N = mkN "piplängd" "piplängder" ;
  pirat_nn_1_N = mkN "pirat" "pirater" ;
  piruett_nn_1_N = mkN "piruett" "piruetter" ;
  piskbalkong_nn_1_N = mkN "piskbalkong" "piskbalkonger" ;
  piskperuk_nn_1_N = mkN "piskperuk" "piskperuker" ;
  pisksnaertoperation_nn_1_1_N = mkN "pisksnärtoperation" "pisksnärtoperationer" ;
  pisksnaertsoperation_nn_1_1_N = mkN "pisksnärtsoperation" "pisksnärtsoperationer" ;
  pissoar_nn_1_N = mkN "pissoar" "pissoarer" ;
  pistage_nn_1_N = mkN "pistage" "pistager" ;
  pistong_nn_1_N = mkN "pistong" "pistonger" ;
  pizzakartong_nn_1_N = mkN "pizzakartong" "pizzakartonger" ;
  placeboeffekt_nn_1_N = mkN "placeboeffekt" "placeboeffekter" ;
  plage_nn_1_N = mkN "plage" "plager" ;
  plagiatanklagelse_nn_1_N = mkN "plagiatanklagelse" "plagiatanklagelser" ;
  planet_nn_1_N = mkN "planet" "planeter" ;
  planetesimal_nn_1_N = mkN "planetesimal" "planetesimaler" ;
  planetroerelse_nn_1_1_N = mkN "planetrörelse" "planetrörelser" ;
  planschett_nn_1_N = mkN "planschett" "planschetter" ;
  plantage_nn_1_N = mkN "plantage" "plantager" ;
  plastbassaeng_nn_1_1_N = mkN "plastbassäng" "plastbassänger" ;
  plastglob_nn_1_N = mkN "plastglob" "plastglober" ;
  plasticitet_nn_1_N = mkN "plasticitet" "plasticiteter" ;
  plastikkirurg_nn_1_N = mkN "plastikkirurg" "plastikkirurger" ;
  plastikoperation_nn_1_N = mkN "plastikoperation" "plastikoperationer" ;
  plastrong_nn_1_N = mkN "plastrong" "plastronger" ;
  plastsko_nn_1_N = mkN "plastsko" "plastskor" ;
  plastspiral_nn_1_N = mkN "plastspiral" "plastspiraler" ;
  plasttrumpet_nn_1_N = mkN "plasttrumpet" "plasttrumpeter" ;
  platsbiljett_nn_1_N = mkN "platsbiljett" "platsbiljetter" ;
  platschef_nn_1_N = mkN "platschef" "platschefer" ;
  plattdistribution_nn_1_N = mkN "plattdistribution" "plattdistributioner" ;
  platthet_nn_2_N = mkN "platthet" "plattheter" ;
  plattaang_nn_1_1_N = mkN "plattång" "plattänger" ;
  plebej_nn_1_N = mkN "plebej" "plebejer" ;
  plejad_nn_1_N = mkN "plejad" "plejader" ;
  pleonasm_nn_1_N = mkN "pleonasm" "pleonasmer" ;
  plesiosaurie_nn_1_N = mkN "plesiosaurie" "plesiosaurier" ;
  plomb_nn_1_N = mkN "plomb" "plomber" ;
  plommonsylt_nn_1_N = mkN "plommonsylt" "plommonsylter" ;
  plumphet_nn_1_N = mkN "plumphet" "plumpheter" ;
  pluralitet_nn_1_N = mkN "pluralitet" "pluraliteter" ;
  plusgrad_nn_1_N = mkN "plusgrad" "plusgrader" ;
  pluskvamperfektum_nn_1_N = mkN "pluskvamperfekt" "pluskvamperfekter" ;
  pluspol_nn_1_N = mkN "pluspol" "pluspoler" ;
  plutokrat_nn_1_N = mkN "plutokrat" "plutokrater" ;
  plutonchef_nn_1_N = mkN "plutonchef" "plutonchefer" ;
  pluvialperiod_nn_1_N = mkN "pluvialperiod" "pluvialperioder" ;
  plym_nn_1_N = mkN "plym" "plymer" ;
  plysmaskin_nn_1_N = mkN "plysmaskin" "plysmaskiner" ;
  plywoodfabrik_nn_1_N = mkN "plywoodfabrik" "plywoodfabriker" ;
  plaegsed_nn_1_1_N = mkN "plägsed" "plägseder" ;
  plaagsamhet_nn_1_1_N = mkN "plågsamhet" "plågsamheter" ;
  plaatfaerg_nn_1_1_N = mkN "plåtfärg" "plåtfärger" ;
  plaatkant_nn_1_1_N = mkN "plåtkant" "plåtkanter" ;
  ploetslighet_nn_1_1_N = mkN "plötslighet" "plötsligheter" ;
  poesitradition_nn_1_N = mkN "poesitradition" "poesitraditioner" ;
  poet_nn_1_N = mkN "poet" "poeter" ;
  pogrom_nn_1_N = mkN "pogrom" "pogromer" ;
  pojkinstinkt_nn_1_N = mkN "pojkinstinkt" "pojkinstinkter" ;
  pokal_nn_1_N = mkN "pokal" "pokaler" ;
  pokerprofil_nn_1_N = mkN "pokerprofil" "pokerprofiler" ;
  polack_nn_1_N = mkN "polack" "polacker" ;
  polarexpedition_nn_1_N = mkN "polarexpedition" "polarexpeditioner" ;
  polarfront_nn_1_N = mkN "polarfront" "polarfronter" ;
  polarisation_nn_1_N = mkN "polarisation" "polarisationer" ;
  polaritet_nn_1_N = mkN "polaritet" "polariteter" ;
  polaroidfilm_nn_1_N = mkN "polaroidfilm" "polaroidfilmer" ;
  polartrakt_nn_1_N = mkN "polartrakt" "polartrakter" ;
  polemik_nn_1_N = mkN "polemik" "polemiker" ;
  polermaskin_nn_1_N = mkN "polermaskin" "polermaskiner" ;
  polerrondell_nn_1_N = mkN "polerrondell" "polerrondeller" ;
  poliklinik_nn_1_N = mkN "poliklinik" "polikliniker" ;
  polischef_nn_1_N = mkN "polischef" "polischefer" ;
  polischock_nn_1_N = mkN "polischock" "polischocker" ;
  polisintendent_nn_1_N = mkN "polisintendent" "polisintendenter" ;
  poliskommissarie_nn_1_N = mkN "poliskommissarie" "poliskommissarier" ;
  poliskund_nn_1_N = mkN "poliskund" "poliskunder" ;
  polismyndighet_nn_1_N = mkN "polismyndighet" "polismyndigheter" ;
  polisong_nn_1_N = mkN "polisong" "polisonger" ;
  polisorganisation_nn_1_N = mkN "polisorganisation" "polisorganisationer" ;
  polispatrull_nn_1_N = mkN "polispatrull" "polispatruller" ;
  polisserie_nn_1_N = mkN "polisserie" "polisserier" ;
  polisstat_nn_1_N = mkN "polisstat" "polisstater" ;
  polisstation_nn_1_N = mkN "polisstation" "polisstationer" ;
  polisuniform_nn_1_N = mkN "polisuniform" "polisuniformer" ;
  politruk_nn_1_N = mkN "politruk" "politruker" ;
  polityr_nn_1_N = mkN "polityr" "polityrer" ;
  polkett_nn_1_N = mkN "polkett" "polketter" ;
  pollett_nn_1_N = mkN "pollett" "polletter" ;
  pollination_nn_1_N = mkN "pollination" "pollinationer" ;
  pollution_nn_1_N = mkN "pollution" "pollutioner" ;
  polsko_nn_1_N = mkN "polsko" "polskor" ;
  polygraf_nn_1_N = mkN "polygraf" "polygrafer" ;
  polymer_nn_1_N = mkN "polymer" "polymerer" ;
  polymerisation_nn_1_N = mkN "polymerisation" "polymerisationer" ;
  polyp_nn_1_N = mkN "polyp" "polyper" ;
  pompong_nn_1_N = mkN "pompong" "pomponger" ;
  pontonjaer_nn_1_1_N = mkN "pontonjär" "pontonjärer" ;
  poolkant_nn_1_N = mkN "poolkant" "poolkanter" ;
  popcornapparat_nn_1_N = mkN "popcornapparat" "popcornapparater" ;
  popgrupp_nn_1_N = mkN "popgrupp" "popgrupper" ;
  popkonsert_nn_1_N = mkN "popkonsert" "popkonserter" ;
  poplin_nn_1_N = mkN "poplin" "popliner" ;
  popularitet_nn_1_N = mkN "popularitet" "populariteter" ;
  population_nn_1_N = mkN "population" "populationer" ;
  populaerkonsert_nn_1_1_N = mkN "populärkonsert" "populärkonserter" ;
  porfyr_nn_1_N = mkN "porfyr" "porfyrer" ;
  porositet_nn_1_N = mkN "porositet" "porositeter" ;
  porrfilm_nn_1_N = mkN "porrfilm" "porrfilmer" ;
  porrmodell_nn_1_N = mkN "porrmodell" "porrmodeller" ;
  porslinsaffaer_nn_1_1_N = mkN "porslinsaffär" "porslinsaffärer" ;
  porslinsfaerg_nn_1_1_N = mkN "porslinsfärg" "porslinsfärger" ;
  portalgestalt_nn_1_N = mkN "portalgestalt" "portalgestalter" ;
  portfoelj_nn_1_1_N = mkN "portfölj" "portföljer" ;
  portik_nn_1_N = mkN "portik" "portiker" ;
  portion_nn_1_N = mkN "portion" "portioner" ;
  portiaer_nn_1_1_N = mkN "portiär" "portiärer" ;
  portraettoer_nn_1_1_N = mkN "porträttör" "porträttörer" ;
  portvakt_nn_1_N = mkN "portvakt" "portvakter" ;
  portoer_nn_1_1_N = mkN "portör" "portörer" ;
  pose_nn_1_N = mkN "pose" "poser" ;
  position_nn_1_N = mkN "position" "positioner" ;
  possession_nn_1_N = mkN "possession" "possessioner" ;
  possessionat_nn_1_N = mkN "possessionat" "possessionater" ;
  postanstalt_nn_1_N = mkN "postanstalt" "postanstalter" ;
  postexpedition_nn_1_N = mkN "postexpedition" "postexpeditioner" ;
  postfoersaendelse_nn_1_1_N = mkN "postförsändelse" "postförsändelser" ;
  postkod_nn_1_N = mkN "postkod" "postkoder" ;
  postposition_nn_1_N = mkN "postposition" "postpositioner" ;
  poststation_nn_1_N = mkN "poststation" "poststationer" ;
  posttur_nn_1_N = mkN "posttur" "postturer" ;
  posoer_nn_1_1_N = mkN "posör" "posörer" ;
  potage_nn_1_N = mkN "potage" "potager" ;
  potatiskanon_nn_1_N = mkN "potatiskanon" "potatiskanoner" ;
  potatissallad_nn_1_N = mkN "potatissallad" "potatissallader" ;
  potentat_nn_1_N = mkN "potentat" "potentater" ;
  potential_nn_1_N = mkN "potential" "potentialer" ;
  pott_nn_1_N = mkN "pott" "potter" ;
  poulard_nn_1_N = mkN "poulard" "poularder" ;
  poaeng_nn_2_1_N = mkN "poäng" "poänger" ;
  pr_kupp_nn_1_N = mkN "pr-kupp" "pr-kupper" ;
  prakrit_nn_1_N = mkN "prakrit" "prakriter" ;
  praktfullhet_nn_1_N = mkN "praktfullhet" "praktfullheter" ;
  praktikalitet_nn_1_N = mkN "praktikalitet" "praktikaliteter" ;
  praktiskhet_nn_2_N = mkN "praktiskhet" "praktiskheter" ;
  pratstund_nn_1_N = mkN "pratstund" "pratstunder" ;
  preciositet_nn_1_N = mkN "preciositet" "preciositeter" ;
  precision_nn_1_N = mkN "precision" "precisioner" ;
  precisionsroerelse_nn_1_1_N = mkN "precisionsrörelse" "precisionsrörelser" ;
  predation_nn_1_N = mkN "predation" "predationer" ;
  predestination_nn_1_N = mkN "predestination" "predestinationer" ;
  predikatsfyllnad_nn_1_N = mkN "predikatsfyllnad" "predikatsfyllnader" ;
  predikotur_nn_1_N = mkN "predikotur" "predikoturer" ;
  predisposition_nn_1_N = mkN "predisposition" "predispositioner" ;
  prefekt_nn_1_N = mkN "prefekt" "prefekter" ;
  preferensaktie_nn_1_N = mkN "preferensaktie" "preferensaktier" ;
  prelat_nn_1_N = mkN "prelat" "prelater" ;
  premie_nn_1_N = mkN "premie" "premier" ;
  premieobligation_nn_1_N = mkN "premieobligation" "premieobligationer" ;
  premiaer_nn_1_1_N = mkN "premiär" "premiärer" ;
  premiaerbiljett_nn_1_1_N = mkN "premiärbiljett" "premiärbiljetter" ;
  premolar_nn_1_N = mkN "premolar" "premolarer" ;
  prenumeration_nn_1_N = mkN "prenumeration" "prenumerationer" ;
  preparand_nn_1_N = mkN "preparand" "preparander" ;
  preparation_nn_1_N = mkN "preparation" "preparationer" ;
  preposition_nn_1_N = mkN "preposition" "prepositioner" ;
  present_nn_1_N = mkN "present" "presenter" ;
  presentation_nn_1_N = mkN "presentation" "presentationer" ;
  presentatoer_nn_1_1_N = mkN "presentatör" "presentatörer" ;
  presidentbostad_nn_1_N = mkN "presidentbostad" "presidentbostäder" ;
  preskription_nn_1_N = mkN "preskription" "preskriptioner" ;
  preskriptionstid_nn_1_N = mkN "preskriptionstid" "preskriptionstider" ;
  presschef_nn_1_N = mkN "presschef" "presschefer" ;
  pressfotograf_nn_1_N = mkN "pressfotograf" "pressfotografer" ;
  pressinformatoer_nn_1_1_N = mkN "pressinformatör" "pressinformatörer" ;
  pression_nn_1_N = mkN "pression" "pressioner" ;
  presskommissarie_nn_1_N = mkN "presskommissarie" "presskommissarier" ;
  pressmaskin_nn_1_N = mkN "pressmaskin" "pressmaskiner" ;
  pressrelease_nn_1_N = mkN "pressrelease" "pressreleaser" ;
  presstoedsnaemnd_nn_1_1_N = mkN "presstödsnämnd" "presstödsnämnder" ;
  prestation_nn_1_N = mkN "prestation" "prestationer" ;
  prestav_nn_1_N = mkN "prestav" "prestaver" ;
  pretendent_nn_1_N = mkN "pretendent" "pretendenter" ;
  pretention_nn_1_N = mkN "pretention" "pretentioner" ;
  pretext_nn_1_N = mkN "pretext" "pretexter" ;
  pretiositet_nn_1_N = mkN "pretiositet" "pretiositeter" ;
  prillighet_nn_1_N = mkN "prillighet" "prilligheter" ;
  prim_nn_1_N = mkN "prim" "primer" ;
  primarie_nn_1_N = mkN "primarie" "primarier" ;
  primitivitet_nn_1_N = mkN "primitivitet" "primitiviteter" ;
  primaergrupp_nn_1_1_N = mkN "primärgrupp" "primärgrupper" ;
  primaerkommun_nn_1_1_N = mkN "primärkommun" "primärkommuner" ;
  primoer_nn_1_1_N = mkN "primör" "primörer" ;
  principal_nn_1_N = mkN "principal" "principaler" ;
  prinsgemaal_nn_1_1_N = mkN "prinsgemål" "prinsgemåler" ;
  prinsregent_nn_1_N = mkN "prinsregent" "prinsregenter" ;
  prioritet_nn_1_N = mkN "prioritet" "prioriteter" ;
  prisbomb_nn_1_N = mkN "prisbomb" "prisbomber" ;
  prischock_nn_1_N = mkN "prischock" "prischocker" ;
  priselasticitet_nn_1_N = mkN "priselasticitet" "priselasticiteter" ;
  prisjakt_nn_1_N = mkN "prisjakt" "prisjakter" ;
  prissensation_nn_1_N = mkN "prissensation" "prissensationer" ;
  prisuppgift_nn_1_N = mkN "prisuppgift" "prisuppgifter" ;
  prisvariation_nn_1_N = mkN "prisvariation" "prisvariationer" ;
  privatbank_nn_1_N = mkN "privatbank" "privatbanker" ;
  privatdiskontoer_nn_1_1_N = mkN "privatdiskontör" "privatdiskontörer" ;
  privatlektion_nn_1_N = mkN "privatlektion" "privatlektioner" ;
  privatperson_nn_1_N = mkN "privatperson" "privatpersoner" ;
  privatsak_nn_1_N = mkN "privatsak" "privatsaker" ;
  privatscen_nn_1_N = mkN "privatscen" "privatscener" ;
  prkupp_nn_1_N = mkN "prkupp" "prkupper" ;
  probabilitet_nn_1_N = mkN "probabilitet" "probabiliteter" ;
  problembild_nn_1_N = mkN "problembild" "problembilder" ;
  procentenhet_nn_1_N = mkN "procentenhet" "procentenheter" ;
  procenthalt_nn_1_N = mkN "procenthalt" "procenthalter" ;
  procession_nn_1_N = mkN "procession" "processioner" ;
  producent_nn_1_N = mkN "producent" "producenter" ;
  produkt_nn_1_N = mkN "produkt" "produkter" ;
  produktion_nn_1_N = mkN "produktion" "produktioner" ;
  produktionsapparat_nn_1_N = mkN "produktionsapparat" "produktionsapparater" ;
  produktionskostnad_nn_1_N = mkN "produktionskostnad" "produktionskostnader" ;
  produktionsteknik_nn_1_N = mkN "produktionsteknik" "produktionstekniker" ;
  produktivitet_nn_1_N = mkN "produktivitet" "produktiviteter" ;
  produktivkraft_nn_1_N = mkN "produktivkraft" "produktivkrafter" ;
  produktmaengd_nn_1_1_N = mkN "produktmängd" "produktmängder" ;
  profanation_nn_1_N = mkN "profanation" "profanationer" ;
  profession_nn_1_N = mkN "profession" "professioner" ;
  profet_nn_1_N = mkN "profet" "profeter" ;
  profitoer_nn_1_1_N = mkN "profitör" "profitörer" ;
  programchef_nn_1_N = mkN "programchef" "programchefer" ;
  programproduktion_nn_1_N = mkN "programproduktion" "programproduktioner" ;
  programpunkt_nn_1_N = mkN "programpunkt" "programpunkter" ;
  programskrift_nn_1_N = mkN "programskrift" "programskrifter" ;
  progression_nn_1_N = mkN "progression" "progressioner" ;
  progressivitet_nn_1_N = mkN "progressivitet" "progressiviteter" ;
  proinsulin_nn_1_N = mkN "proinsulin" "proinsuliner" ;
  projektgrupp_nn_1_N = mkN "projektgrupp" "projektgrupper" ;
  projektil_nn_1_N = mkN "projektil" "projektiler" ;
  projektion_nn_1_N = mkN "projektion" "projektioner" ;
  projektionsapparat_nn_1_N = mkN "projektionsapparat" "projektionsapparater" ;
  projektoer_nn_1_1_N = mkN "projektör" "projektörer" ;
  proklamation_nn_1_N = mkN "proklamation" "proklamationer" ;
  prolaktin_nn_1_N = mkN "prolaktin" "prolaktiner" ;
  prolongation_nn_1_N = mkN "prolongation" "prolongationer" ;
  promenad_nn_1_N = mkN "promenad" "promenader" ;
  promenadkonsert_nn_1_N = mkN "promenadkonsert" "promenadkonserter" ;
  promenoar_nn_1_N = mkN "promenoar" "promenoarer" ;
  promiskuitet_nn_1_N = mkN "promiskuitet" "promiskuiteter" ;
  promotion_nn_1_N = mkN "promotion" "promotioner" ;
  promulgation_nn_1_N = mkN "promulgation" "promulgationer" ;
  prononciation_nn_1_N = mkN "prononciation" "prononciationer" ;
  propagandadikt_nn_1_N = mkN "propagandadikt" "propagandadikter" ;
  propagandafilm_nn_1_N = mkN "propagandafilm" "propagandafilmer" ;
  propagandaloegn_nn_1_1_N = mkN "propagandalögn" "propagandalögner" ;
  proponent_nn_1_N = mkN "proponent" "proponenter" ;
  proportion_nn_1_N = mkN "proportion" "proportioner" ;
  proportional_nn_1_N = mkN "proportional" "proportionaler" ;
  proportionalitet_nn_1_N = mkN "proportionalitet" "proportionaliteter" ;
  proposition_nn_1_N = mkN "proposition" "propositioner" ;
  proppfullhet_nn_1_N = mkN "proppfullhet" "proppfullheter" ;
  proprietaer_nn_1_1_N = mkN "proprietär" "proprietärer" ;
  prorogation_nn_1_N = mkN "prorogation" "prorogationer" ;
  prosadikt_nn_1_N = mkN "prosadikt" "prosadikter" ;
  proselyt_nn_1_N = mkN "proselyt" "proselyter" ;
  proskription_nn_1_N = mkN "proskription" "proskriptioner" ;
  prostatacancertumoer_nn_1_1_N = mkN "prostatacancertumör" "prostatacancertumörer" ;
  prostitution_nn_1_N = mkN "prostitution" "prostitutioner" ;
  proteinfabrik_nn_1_N = mkN "proteinfabrik" "proteinfabriker" ;
  proteinfamilj_nn_1_N = mkN "proteinfamilj" "proteinfamiljer" ;
  protektion_nn_1_N = mkN "protektion" "protektioner" ;
  protestaktion_nn_1_N = mkN "protestaktion" "protestaktioner" ;
  protestroerelse_nn_1_1_N = mkN "proteströrelse" "proteströrelser" ;
  protestskrivelse_nn_1_N = mkN "protestskrivelse" "protestskrivelser" ;
  protolyt_nn_1_N = mkN "protolyt" "protolyter" ;
  prototyp_nn_1_N = mkN "prototyp" "prototyper" ;
  provanstaellningstid_nn_1_1_N = mkN "provanställningstid" "provanställningstider" ;
  provensal_nn_1_N = mkN "provensal" "provensaler" ;
  provision_nn_1_N = mkN "provision" "provisioner" ;
  provokation_nn_1_N = mkN "provokation" "provokationer" ;
  provokatoer_nn_1_1_N = mkN "provokatör" "provokatörer" ;
  provtur_nn_1_N = mkN "provtur" "provturer" ;
  provuppgift_nn_1_N = mkN "provuppgift" "provuppgifter" ;
  prudentlighet_nn_1_N = mkN "prudentlighet" "prudentligheter" ;
  prunell_nn_1_N = mkN "prunell" "pruneller" ;
  prydhet_nn_1_N = mkN "prydhet" "prydheter" ;
  prydnad_nn_1_N = mkN "prydnad" "prydnader" ;
  pryo_nn_1_N = mkN "pryo" "pryor" ;
  praerie_nn_1_1_N = mkN "prärie" "prärier" ;
  praestdraekt_nn_1_1_N = mkN "prästdräkt" "prästdräkter" ;
  praestroll_nn_1_1_N = mkN "prästroll" "prästroller" ;
  praalighet_nn_1_1_N = mkN "prålighet" "pråligheter" ;
  proevostund_nn_1_1_N = mkN "prövostund" "prövostunder" ;
  proevotid_nn_1_1_N = mkN "prövotid" "prövotider" ;
  psalm_nn_1_N = mkN "psalm" "psalmer" ;
  pseudohaendelse_nn_1_1_N = mkN "pseudohändelse" "pseudohändelser" ;
  pseudonym_nn_1_N = mkN "pseudonym" "pseudonymer" ;
  psykopat_nn_1_N = mkN "psykopat" "psykopater" ;
  psykoterapeut_nn_1_N = mkN "psykoterapeut" "psykoterapeuter" ;
  pubertet_nn_1_N = mkN "pubertet" "puberteter" ;
  publicitet_nn_1_N = mkN "publicitet" "publiciteter" ;
  publikation_nn_1_N = mkN "publikation" "publikationer" ;
  puckadhet_nn_1_N = mkN "puckadhet" "puckadheter" ;
  puderkraem_nn_1_1_N = mkN "puderkräm" "puderkrämer" ;
  puerilitet_nn_1_N = mkN "puerilitet" "pueriliteter" ;
  pulpet_nn_1_N = mkN "pulpet" "pulpeter" ;
  pult_nn_1_N = mkN "pult" "pulter" ;
  pulverlack_nn_1_N = mkN "pulverlack" "pulverlacker" ;
  punkfrisyr_nn_1_N = mkN "punkfrisyr" "punkfrisyrer" ;
  punktion_nn_1_N = mkN "punktion" "punktioner" ;
  punktmaengd_nn_1_1_N = mkN "punktmängd" "punktmängder" ;
  pupill_nn_1_N = mkN "pupill" "pupiller" ;
  purin_nn_1_N = mkN "purin" "puriner" ;
  putslustighet_nn_1_N = mkN "putslustighet" "putslustigheter" ;
  pyridin_nn_1_N = mkN "pyridin" "pyridiner" ;
  paer_nn_1_1_N = mkN "pär" "pärer" ;
  paerlhyacint_nn_1_1_N = mkN "pärlhyacint" "pärlhyacinter" ;
  paermkarusell_nn_1_1_N = mkN "pärmkarusell" "pärmkaruseller" ;
  paert_nn_1_1_N = mkN "pärt" "pärter" ;
  paabyggnad_nn_1_1_N = mkN "påbyggnad" "påbyggnader" ;
  paafart_nn_1_1_N = mkN "påfart" "påfarter" ;
  paafoeljd_nn_1_1_N = mkN "påföljd" "påföljder" ;
  paahittighet_nn_1_1_N = mkN "påhittighet" "påhittigheter" ;
  paaminnelse_nn_1_1_N = mkN "påminnelse" "påminnelser" ;
  paaskhelg_nn_1_1_N = mkN "påskhelg" "påskhelger" ;
  paaskrift_nn_1_1_N = mkN "påskrift" "påskrifter" ;
  paavevaerdighet_nn_1_1_N = mkN "påvevärdighet" "påvevärdigheter" ;
  poebelaktighet_nn_1_1_N = mkN "pöbelaktighet" "pöbelaktigheter" ;
  poebelmentalitet_nn_1_1_N = mkN "pöbelmentalitet" "pöbelmentaliteter" ;
  rabarberpaj_nn_1_N = mkN "rabarberpaj" "rabarberpajer" ;
  rabatt_nn_1_N = mkN "rabatt" "rabatter" ;
  rabattkupong_nn_1_N = mkN "rabattkupong" "rabattkuponger" ;
  radarantenn_nn_1_N = mkN "radarantenn" "radarantenner" ;
  radarkontroll_nn_1_N = mkN "radarkontroll" "radarkontroller" ;
  radhusfamilj_nn_1_N = mkN "radhusfamilj" "radhusfamiljer" ;
  radialhastighet_nn_1_N = mkN "radialhastighet" "radialhastigheter" ;
  radie_nn_1_N = mkN "radie" "radier" ;
  radikaloperation_nn_1_N = mkN "radikaloperation" "radikaloperationer" ;
  radio_nn_1_N = mkN "radio" "radior" ;
  radioaktivitet_nn_1_N = mkN "radioaktivitet" "radioaktiviteter" ;
  radioamatoer_nn_1_1_N = mkN "radioamatör" "radioamatörer" ;
  radioandakt_nn_1_N = mkN "radioandakt" "radioandakter" ;
  radioantenn_nn_1_N = mkN "radioantenn" "radioantenner" ;
  radioapparat_nn_1_N = mkN "radioapparat" "radioapparater" ;
  radioisotop_nn_1_N = mkN "radioisotop" "radioisotoper" ;
  radiokanal_nn_1_N = mkN "radiokanal" "radiokanaler" ;
  radiolarie_nn_1_N = mkN "radiolarie" "radiolarier" ;
  radiosond_nn_1_N = mkN "radiosond" "radiosonder" ;
  radiostation_nn_1_N = mkN "radiostation" "radiostationer" ;
  radiot_nn_1_N = mkN "radiot" "radioter" ;
  radioteknik_nn_1_N = mkN "radioteknik" "radiotekniker" ;
  radiotaang_nn_1_1_N = mkN "radiotång" "radiotänger" ;
  radslutssignal_nn_1_N = mkN "radslutssignal" "radslutssignaler" ;
  raffinad_nn_1_N = mkN "raffinad" "raffinader" ;
  rafraeschissoer_nn_1_1_N = mkN "rafräschissör" "rafräschissörer" ;
  rajd_nn_1_N = mkN "rajd" "rajder" ;
  rakapparat_nn_1_N = mkN "rakapparat" "rakapparater" ;
  raket_nn_1_N = mkN "raket" "raketer" ;
  raketfaerd_nn_1_1_N = mkN "raketfärd" "raketfärder" ;
  raketkonstruktoer_nn_1_1_N = mkN "raketkonstruktör" "raketkonstruktörer" ;
  ramberaettelse_nn_1_1_N = mkN "ramberättelse" "ramberättelser" ;
  ramp_nn_1_N = mkN "ramp" "ramper" ;
  ramverkstad_nn_1_N = mkN "ramverkstad" "ramverkstäder" ;
  ranchaegartyp_nn_1_1_N = mkN "ranchägartyp" "ranchägartyper" ;
  rancune_nn_1_N = mkN "rancune" "rancuner" ;
  rand_nn_1_N = mkN "rand" "ränder" ;
  rappell_nn_1_N = mkN "rappell" "rappeller" ;
  rapportoer_nn_1_1_N = mkN "rapportör" "rapportörer" ;
  rapsod_nn_1_N = mkN "rapsod" "rapsoder" ;
  raritet_nn_1_N = mkN "raritet" "rariteter" ;
  rasfoerfoeljelse_nn_1_1_N = mkN "rasförföljelse" "rasförföljelser" ;
  rasorolighet_nn_1_N = mkN "rasorolighet" "rasoroligheter" ;
  rate_nn_1_N = mkN "rate" "rater" ;
  ratifikation_nn_1_N = mkN "ratifikation" "ratifikationer" ;
  ration_nn_1_N = mkN "ration" "rationer" ;
  rationalitet_nn_1_N = mkN "rationalitet" "rationaliteter" ;
  rattonykterhet_nn_1_N = mkN "rattonykterhet" "rattonykterheter" ;
  rattstaang_nn_1_1_N = mkN "rattstång" "rattstänger" ;
  ravin_nn_1_N = mkN "ravin" "raviner" ;
  reaktion_nn_1_N = mkN "reaktion" "reaktioner" ;
  reaktionsprodukt_nn_1_N = mkN "reaktionsprodukt" "reaktionsprodukter" ;
  reaktionstid_nn_1_N = mkN "reaktionstid" "reaktionstider" ;
  reaktionszon_nn_1_N = mkN "reaktionszon" "reaktionszoner" ;
  reaktorbyggnad_nn_1_N = mkN "reaktorbyggnad" "reaktorbyggnader" ;
  reaktorsaekerhet_nn_1_1_N = mkN "reaktorsäkerhet" "reaktorsäkerheter" ;
  reaktortyp_nn_1_N = mkN "reaktortyp" "reaktortyper" ;
  realisation_nn_1_N = mkN "realisation" "realisationer" ;
  realitet_nn_1_N = mkN "realitet" "realiteter" ;
  realkatalog_nn_1_N = mkN "realkatalog" "realkataloger" ;
  reallinje_nn_1_N = mkN "reallinje" "reallinjer" ;
  realloen_nn_1_1_N = mkN "reallön" "reallöner" ;
  realsaekerhet_nn_1_1_N = mkN "realsäkerhet" "realsäkerheter" ;
  realunion_nn_1_N = mkN "realunion" "realunioner" ;
  rebell_nn_1_N = mkN "rebell" "rebeller" ;
  recensent_nn_1_N = mkN "recensent" "recensenter" ;
  recension_nn_1_N = mkN "recension" "recensioner" ;
  receptarie_nn_1_N = mkN "receptarie" "receptarier" ;
  reception_nn_1_N = mkN "reception" "receptioner" ;
  receptivitet_nn_1_N = mkN "receptivitet" "receptiviteter" ;
  recession_nn_1_N = mkN "recession" "recessioner" ;
  recett_nn_1_N = mkN "recett" "recetter" ;
  recipiend_nn_1_N = mkN "recipiend" "recipiender" ;
  recipient_nn_1_N = mkN "recipient" "recipienter" ;
  reciprocitet_nn_1_N = mkN "reciprocitet" "reciprociteter" ;
  recitation_nn_1_N = mkN "recitation" "recitationer" ;
  redaktion_nn_1_N = mkN "redaktion" "redaktioner" ;
  redd_nn_1_N = mkN "redd" "redder" ;
  rederiverksamhet_nn_1_N = mkN "rederiverksamhet" "rederiverksamheter" ;
  redingot_nn_1_N = mkN "redingot" "redingoter" ;
  redlighet_nn_1_N = mkN "redlighet" "redligheter" ;
  redogoerelse_nn_1_1_N = mkN "redogörelse" "redogörelser" ;
  redovisningsskyldighet_nn_1_N = mkN "redovisningsskyldighet" "redovisningsskyldigheter" ;
  redskapsmetall_nn_1_N = mkN "redskapsmetall" "redskapsmetaller" ;
  reduceringsventil_nn_1_N = mkN "reduceringsventil" "reduceringsventiler" ;
  reduktion_nn_1_N = mkN "reduktion" "reduktioner" ;
  reduplikation_nn_1_N = mkN "reduplikation" "reduplikationer" ;
  redutt_nn_1_N = mkN "redutt" "redutter" ;
  referensgrupp_nn_1_N = mkN "referensgrupp" "referensgrupper" ;
  referenspunkt_nn_1_N = mkN "referenspunkt" "referenspunkter" ;
  referenssort_nn_1_N = mkN "referenssort" "referenssorter" ;
  referent_nn_1_N = mkN "referent" "referenter" ;
  refill_nn_1_N = mkN "refill" "refiller" ;
  reflektion_nn_1_N = mkN "reflektion" "reflektioner" ;
  reflexion_nn_1_N = mkN "reflexion" "reflexioner" ;
  reformation_nn_1_N = mkN "reformation" "reformationer" ;
  refraktion_nn_1_N = mkN "refraktion" "refraktioner" ;
  refraeng_nn_1_1_N = mkN "refräng" "refränger" ;
  refug_nn_1_N = mkN "refug" "refuger" ;
  regal_nn_1_N = mkN "regal" "regaler" ;
  regelbundenhet_nn_1_N = mkN "regelbundenhet" "regelbundenheter" ;
  regelefterlevnad_nn_1_N = mkN "regelefterlevnad" "regelefterlevnader" ;
  regelmaessighet_nn_1_1_N = mkN "regelmässighet" "regelmässigheter" ;
  regelvidrighet_nn_1_N = mkN "regelvidrighet" "regelvidrigheter" ;
  regementschef_nn_1_N = mkN "regementschef" "regementschefer" ;
  regeneration_nn_1_N = mkN "regeneration" "regenerationer" ;
  regent_nn_1_N = mkN "regent" "regenter" ;
  regentfamilj_nn_1_N = mkN "regentfamilj" "regentfamiljer" ;
  regentlaengd_nn_1_1_N = mkN "regentlängd" "regentlängder" ;
  regeringsbyggnad_nn_1_N = mkN "regeringsbyggnad" "regeringsbyggnader" ;
  regeringschef_nn_1_N = mkN "regeringschef" "regeringschefer" ;
  regeringsdeklaration_nn_1_N = mkN "regeringsdeklaration" "regeringsdeklarationer" ;
  regeringsform_nn_1_N = mkN "regeringsform" "regeringsformer" ;
  regeringskoalition_nn_1_N = mkN "regeringskoalition" "regeringskoalitioner" ;
  regeringsmakt_nn_1_N = mkN "regeringsmakt" "regeringsmakter" ;
  regeringsproposition_nn_1_N = mkN "regeringsproposition" "regeringspropositioner" ;
  regeringsraett_nn_1_1_N = mkN "regeringsrätt" "regeringsrätter" ;
  regimfiende_nn_1_N = mkN "regimfiende" "regimfiender" ;
  region_nn_1_N = mkN "region" "regioner" ;
  regionstyrelse_nn_1_N = mkN "regionstyrelse" "regionstyrelser" ;
  regissoer_nn_1_1_N = mkN "regissör" "regissörer" ;
  regnmaengd_nn_1_1_N = mkN "regnmängd" "regnmängder" ;
  regnperiod_nn_1_N = mkN "regnperiod" "regnperioder" ;
  regntid_nn_1_N = mkN "regntid" "regntider" ;
  regression_nn_1_N = mkN "regression" "regressioner" ;
  regularitet_nn_1_N = mkN "regularitet" "regulariteter" ;
  rehabiliteringsplan_nn_1_N = mkN "rehabiliteringsplan" "rehabiliteringsplaner" ;
  reifikation_nn_1_N = mkN "reifikation" "reifikationer" ;
  reinkarnation_nn_1_N = mkN "reinkarnation" "reinkarnationer" ;
  rekapitulation_nn_1_N = mkN "rekapitulation" "rekapitulationer" ;
  reklam_nn_1_N = mkN "reklam" "reklamer" ;
  reklamagent_nn_1_N = mkN "reklamagent" "reklamagenter" ;
  reklamation_nn_1_N = mkN "reklamation" "reklamationer" ;
  reklamkupp_nn_1_N = mkN "reklamkupp" "reklamkupper" ;
  rekommendation_nn_1_N = mkN "rekommendation" "rekommendationer" ;
  rekonstruktion_nn_1_N = mkN "rekonstruktion" "rekonstruktioner" ;
  rekreation_nn_1_N = mkN "rekreation" "rekreationer" ;
  rekryt_nn_1_N = mkN "rekryt" "rekryter" ;
  rektascension_nn_1_N = mkN "rektascension" "rektascensioner" ;
  rektifikation_nn_1_N = mkN "rektifikation" "rektifikationer" ;
  rektion_nn_1_N = mkN "rektion" "rektioner" ;
  rektorsexpedition_nn_1_N = mkN "rektorsexpedition" "rektorsexpeditioner" ;
  rekurrensrelation_nn_1_N = mkN "rekurrensrelation" "rekurrensrelationer" ;
  rekvisition_nn_1_N = mkN "rekvisition" "rekvisitioner" ;
  rekvisitoer_nn_1_1_N = mkN "rekvisitör" "rekvisitörer" ;
  relation_nn_1_N = mkN "relation" "relationer" ;
  relativitet_nn_1_N = mkN "relativitet" "relativiteter" ;
  relaxation_nn_1_N = mkN "relaxation" "relaxationer" ;
  release_nn_1_N = mkN "release" "releaser" ;
  reliabilitet_nn_1_N = mkN "reliabilitet" "reliabiliteter" ;
  relief_nn_1_N = mkN "relief" "reliefer" ;
  religion_nn_1_N = mkN "religion" "religioner" ;
  religionsfrihet_nn_1_N = mkN "religionsfrihet" "religionsfriheter" ;
  religionsfoerfoeljelse_nn_1_1_N = mkN "religionsförföljelse" "religionsförföljelser" ;
  religionsurkund_nn_1_N = mkN "religionsurkund" "religionsurkunder" ;
  religiositet_nn_1_N = mkN "religiositet" "religiositeter" ;
  relaestation_nn_1_1_N = mkN "relästation" "relästationer" ;
  remissdebatt_nn_1_N = mkN "remissdebatt" "remissdebatter" ;
  remittent_nn_1_N = mkN "remittent" "remittenter" ;
  renegat_nn_1_N = mkN "renegat" "renegater" ;
  renhet_nn_1_N = mkN "renhet" "renheter" ;
  renhaallningsmyndighet_nn_1_1_N = mkN "renhållningsmyndighet" "renhållningsmyndigheter" ;
  renjakt_nn_1_N = mkN "renjakt" "renjakter" ;
  renko_nn_1_N = mkN "renko" "renkor" ;
  renkonterstrid_nn_1_N = mkN "renkonterstrid" "renkonterstrider" ;
  renlevnad_nn_1_N = mkN "renlevnad" "renlevnader" ;
  renlighet_nn_1_N = mkN "renlighet" "renligheter" ;
  renlaerighet_nn_1_1_N = mkN "renlärighet" "renlärigheter" ;
  renovation_nn_1_N = mkN "renovation" "renovationer" ;
  reostat_nn_1_N = mkN "reostat" "reostater" ;
  reparation_nn_1_N = mkN "reparation" "reparationer" ;
  reparatoer_nn_1_1_N = mkN "reparatör" "reparatörer" ;
  repartition_nn_1_N = mkN "repartition" "repartitioner" ;
  repertoar_nn_1_N = mkN "repertoar" "repertoarer" ;
  repetition_nn_1_N = mkN "repetition" "repetitioner" ;
  repetitionslokal_nn_1_N = mkN "repetitionslokal" "repetitionslokaler" ;
  repetitoer_nn_1_1_N = mkN "repetitör" "repetitörer" ;
  replik_nn_1_N = mkN "replik" "repliker" ;
  replipunkt_nn_1_N = mkN "replipunkt" "replipunkter" ;
  replokal_nn_1_N = mkN "replokal" "replokaler" ;
  repmaanad_nn_1_1_N = mkN "repmånad" "repmånader" ;
  representation_nn_1_N = mkN "representation" "representationer" ;
  representationsreform_nn_1_N = mkN "representationsreform" "representationsreformer" ;
  repressalie_nn_1_N = mkN "repressalie" "repressalier" ;
  repressalieaatgaerd_nn_1_1_N = mkN "repressalieåtgärd" "repressalieåtgärder" ;
  repression_nn_1_N = mkN "repression" "repressioner" ;
  reprimand_nn_1_N = mkN "reprimand" "reprimander" ;
  reproduktion_nn_1_N = mkN "reproduktion" "reproduktioner" ;
  republik_nn_1_N = mkN "republik" "republiker" ;
  repulsion_nn_1_N = mkN "repulsion" "repulsioner" ;
  reputation_nn_1_N = mkN "reputation" "reputationer" ;
  researrangoer_nn_1_1_N = mkN "researrangör" "researrangörer" ;
  resebiljett_nn_1_N = mkN "resebiljett" "resebiljetter" ;
  resegarderob_nn_1_N = mkN "resegarderob" "resegarderober" ;
  reseguide_nn_1_N = mkN "reseguide" "reseguider" ;
  resektion_nn_1_N = mkN "resektion" "resektioner" ;
  resenaer_nn_1_1_N = mkN "resenär" "resenärer" ;
  reserv_nn_1_N = mkN "reserv" "reserver" ;
  reservation_nn_1_N = mkN "reservation" "reservationer" ;
  reservationsloeshet_nn_1_1_N = mkN "reservationslöshet" "reservationslösheter" ;
  reservoar_nn_1_N = mkN "reservoar" "reservoarer" ;
  reseskrivmaskin_nn_1_N = mkN "reseskrivmaskin" "reseskrivmaskiner" ;
  resguide_nn_1_N = mkN "resguide" "resguider" ;
  residensstad_nn_1_N = mkN "residensstad" "residensstäder" ;
  resignation_nn_1_N = mkN "resignation" "resignationer" ;
  resistivitet_nn_1_N = mkN "resistivitet" "resistiviteter" ;
  reskamrat_nn_1_N = mkN "reskamrat" "reskamrater" ;
  resolution_nn_1_N = mkN "resolution" "resolutioner" ;
  resonoer_nn_1_1_N = mkN "resonör" "resonörer" ;
  resorption_nn_1_N = mkN "resorption" "resorptioner" ;
  respektfullhet_nn_1_N = mkN "respektfullhet" "respektfullheter" ;
  respektloeshet_nn_1_1_N = mkN "respektlöshet" "respektlösheter" ;
  respiration_nn_1_N = mkN "respiration" "respirationer" ;
  respondent_nn_1_N = mkN "respondent" "respondenter" ;
  restauration_nn_1_N = mkN "restauration" "restaurationer" ;
  restauratoer_nn_1_1_N = mkN "restauratör" "restauratörer" ;
  restid_nn_1_N = mkN "restid" "restider" ;
  restitution_nn_1_N = mkN "restitution" "restitutioner" ;
  restlaengd_nn_1_1_N = mkN "restlängd" "restlängder" ;
  restprodukt_nn_1_N = mkN "restprodukt" "restprodukter" ;
  restriktion_nn_1_N = mkN "restriktion" "restriktioner" ;
  resaar_nn_1_1_N = mkN "resår" "resårer" ;
  retardation_nn_1_N = mkN "retardation" "retardationer" ;
  retbarhet_nn_1_N = mkN "retbarhet" "retbarheter" ;
  retention_nn_1_N = mkN "retention" "retentioner" ;
  retort_nn_1_N = mkN "retort" "retorter" ;
  retsamhet_nn_1_N = mkN "retsamhet" "retsamheter" ;
  returfaerd_nn_1_1_N = mkN "returfärd" "returfärder" ;
  reunion_nn_1_N = mkN "reunion" "reunioner" ;
  revelation_nn_1_N = mkN "revelation" "revelationer" ;
  revelj_nn_1_N = mkN "revelj" "reveljer" ;
  revision_nn_1_N = mkN "revision" "revisioner" ;
  revisionsberaettelse_nn_1_1_N = mkN "revisionsberättelse" "revisionsberättelser" ;
  revoke_nn_1_N = mkN "revoke" "revoker" ;
  revolt_nn_1_N = mkN "revolt" "revolter" ;
  revoltoer_nn_1_1_N = mkN "revoltör" "revoltörer" ;
  revolution_nn_1_N = mkN "revolution" "revolutioner" ;
  revaer_nn_1_1_N = mkN "revär" "revärer" ;
  rhizom_nn_1_N = mkN "rhizom" "rhizomer" ;
  ribosom_nn_1_N = mkN "ribosom" "ribosomer" ;
  rickettsie_nn_1_N = mkN "rickettsie" "rickettsier" ;
  riddraekt_nn_1_1_N = mkN "riddräkt" "riddräkter" ;
  ridhaestdressyr_nn_1_1_N = mkN "ridhästdressyr" "ridhästdressyrer" ;
  ridkunnighet_nn_1_N = mkN "ridkunnighet" "ridkunnigheter" ;
  ridtur_nn_1_N = mkN "ridtur" "ridturer" ;
  rififikupp_nn_1_N = mkN "rififikupp" "rififikupper" ;
  rikoschett_nn_1_N = mkN "rikoschett" "rikoschetter" ;
  riksangelaegenhet_nn_1_1_N = mkN "riksangelägenhet" "riksangelägenheter" ;
  riksantikvarie_nn_1_N = mkN "riksantikvarie" "riksantikvarier" ;
  riksarkivarie_nn_1_N = mkN "riksarkivarie" "riksarkivarier" ;
  riksbank_nn_1_N = mkN "riksbank" "riksbanker" ;
  riksbibliotekarie_nn_1_N = mkN "riksbibliotekarie" "riksbibliotekarier" ;
  riksdagsdebatt_nn_1_N = mkN "riksdagsdebatt" "riksdagsdebatter" ;
  riksdagsgrupp_nn_1_N = mkN "riksdagsgrupp" "riksdagsgrupper" ;
  riksdagsledamot_nn_1_N = mkN "riksdagsledamot" "riksdagsledamöter" ;
  riksorganisation_nn_1_N = mkN "riksorganisation" "riksorganisationer" ;
  riksprototyp_nn_1_N = mkN "riksprototyp" "riksprototyper" ;
  riksraett_nn_1_1_N = mkN "riksrätt" "riksrätter" ;
  riksstyrelse_nn_1_N = mkN "riksstyrelse" "riksstyrelser" ;
  riktighet_nn_1_N = mkN "riktighet" "riktigheter" ;
  riktlinje_nn_1_N = mkN "riktlinje" "riktlinjer" ;
  riktningskoefficient_nn_1_N = mkN "riktningskoefficient" "riktningskoefficienter" ;
  riktpunkt_nn_1_N = mkN "riktpunkt" "riktpunkter" ;
  rimlighet_nn_1_N = mkN "rimlighet" "rimligheter" ;
  rimsmed_nn_1_N = mkN "rimsmed" "rimsmeder" ;
  ringart_nn_1_N = mkN "ringart" "ringarter" ;
  ringhet_nn_1_N = mkN "ringhet" "ringheter" ;
  rips_nn_1_N = mkN "rips" "ripser" ;
  riskgrupp_nn_1_N = mkN "riskgrupp" "riskgrupper" ;
  riskmodell_nn_1_N = mkN "riskmodell" "riskmodeller" ;
  riskzon_nn_1_N = mkN "riskzon" "riskzoner" ;
  risoll_nn_1_N = mkN "risoll" "risoller" ;
  risraett_nn_1_1_N = mkN "risrätt" "risrätter" ;
  rit_nn_1_N = mkN "rit" "riter" ;
  ritapparat_nn_1_N = mkN "ritapparat" "ritapparater" ;
  rival_nn_1_N = mkN "rival" "rivaler" ;
  rivalitet_nn_1_N = mkN "rivalitet" "rivaliteter" ;
  rivningslaegenhet_nn_1_1_N = mkN "rivningslägenhet" "rivningslägenheter" ;
  rivningstomt_nn_1_N = mkN "rivningstomt" "rivningstomter" ;
  rivstart_nn_1_N = mkN "rivstart" "rivstarter" ;
  robe_nn_1_N = mkN "robe" "rober" ;
  robinsonad_nn_1_N = mkN "robinsonad" "robinsonader" ;
  rockad_nn_1_N = mkN "rockad" "rockader" ;
  rockkonsert_nn_1_N = mkN "rockkonsert" "rockkonserter" ;
  rodd_nn_1_N = mkN "rodd" "rodder" ;
  roddarsaang_nn_1_1_N = mkN "roddarsång" "roddarsånger" ;
  rodeo_nn_1_N = mkN "rodeo" "rodeor" ;
  rodnad_nn_1_N = mkN "rodnad" "rodnader" ;
  rokokodam_nn_1_N = mkN "rokokodam" "rokokodamer" ;
  rolighet_nn_1_N = mkN "rolighet" "roligheter" ;
  romanistik_nn_1_N = mkN "romanistik" "romanistiker" ;
  romansvit_nn_1_N = mkN "romansvit" "romansviter" ;
  romantradition_nn_1_N = mkN "romantradition" "romantraditioner" ;
  romb_nn_1_N = mkN "romb" "romber" ;
  rond_nn_1_N = mkN "rond" "ronder" ;
  rondell_nn_1_N = mkN "rondell" "rondeller" ;
  rosenkind_nn_1_N = mkN "rosenkind" "rosenkinder" ;
  rosenrabatt_nn_1_N = mkN "rosenrabatt" "rosenrabatter" ;
  rosett_nn_1_N = mkN "rosett" "rosetter" ;
  rostskyddsfaerg_nn_1_1_N = mkN "rostskyddsfärg" "rostskyddsfärger" ;
  rotation_nn_1_N = mkN "rotation" "rotationer" ;
  rotationshastighet_nn_1_N = mkN "rotationshastighet" "rotationshastigheter" ;
  rotfrukt_nn_1_N = mkN "rotfrukt" "rotfrukter" ;
  rotgroensak_nn_1_1_N = mkN "rotgrönsak" "rotgrönsaker" ;
  rotkanal_nn_1_N = mkN "rotkanal" "rotkanaler" ;
  rotogravyr_nn_1_N = mkN "rotogravyr" "rotogravyrer" ;
  rotogravyrbild_nn_1_N = mkN "rotogravyrbild" "rotogravyrbilder" ;
  rotsak_nn_1_N = mkN "rotsak" "rotsaker" ;
  rottingfaatoelj_nn_1_1_N = mkN "rottingfåtölj" "rottingfåtöljer" ;
  route_nn_1_N = mkN "route" "router" ;
  ruinstad_nn_1_N = mkN "ruinstad" "ruinstäder" ;
  rullgardin_nn_1_N = mkN "rullgardin" "rullgardiner" ;
  rullskridsko_nn_1_N = mkN "rullskridsko" "rullskridskor" ;
  rumsbredd_nn_1_N = mkN "rumsbredd" "rumsbredder" ;
  rumskamrat_nn_1_N = mkN "rumskamrat" "rumskamrater" ;
  rumslighet_nn_1_N = mkN "rumslighet" "rumsligheter" ;
  rumaen_nn_1_1_N = mkN "rumän" "rumäner" ;
  rundhet_nn_1_N = mkN "rundhet" "rundheter" ;
  rundhorisont_nn_1_N = mkN "rundhorisont" "rundhorisonter" ;
  rundskrivelse_nn_1_N = mkN "rundskrivelse" "rundskrivelser" ;
  rundtur_nn_1_N = mkN "rundtur" "rundturer" ;
  runosaang_nn_1_1_N = mkN "runosång" "runosånger" ;
  runrad_nn_1_N = mkN "runrad" "runrader" ;
  runskrift_nn_1_N = mkN "runskrift" "runskrifter" ;
  rupie_nn_1_N = mkN "rupie" "rupier" ;
  rusdryck_nn_1_N = mkN "rusdryck" "rusdrycker" ;
  ruskighet_nn_1_N = mkN "ruskighet" "ruskigheter" ;
  rusningstid_nn_1_N = mkN "rusningstid" "rusningstider" ;
  ruten_nn_1_N = mkN "ruten" "rutener" ;
  rutinoperation_nn_1_N = mkN "rutinoperation" "rutinoperationer" ;
  ruttenhet_nn_2_N = mkN "ruttenhet" "ruttenheter" ;
  ryggoperation_nn_1_N = mkN "ryggoperation" "ryggoperationer" ;
  ryggrad_nn_1_N = mkN "ryggrad" "ryggrader" ;
  ryggtrakt_nn_1_N = mkN "ryggtrakt" "ryggtrakter" ;
  ryktbarhet_nn_1_N = mkN "ryktbarhet" "ryktbarheter" ;
  rymd_nn_1_N = mkN "rymd" "rymder" ;
  rymddraekt_nn_1_1_N = mkN "rymddräkt" "rymddräkter" ;
  rymdfartsstyrelse_nn_1_N = mkN "rymdfartsstyrelse" "rymdfartsstyrelser" ;
  rymdfaerd_nn_1_1_N = mkN "rymdfärd" "rymdfärder" ;
  rymdpilot_nn_1_N = mkN "rymdpilot" "rymdpiloter" ;
  rymdpromenad_nn_1_N = mkN "rymdpromenad" "rymdpromenader" ;
  rymdraket_nn_1_N = mkN "rymdraket" "rymdraketer" ;
  rymdsond_nn_1_N = mkN "rymdsond" "rymdsonder" ;
  rymdstation_nn_1_N = mkN "rymdstation" "rymdstationer" ;
  rymdstyrelse_nn_1_N = mkN "rymdstyrelse" "rymdstyrelser" ;
  rysklektion_nn_1_N = mkN "rysklektion" "rysklektioner" ;
  ryslighet_nn_1_N = mkN "ryslighet" "rysligheter" ;
  rytm_nn_1_N = mkN "rytm" "rytmer" ;
  rytmicitet_nn_1_N = mkN "rytmicitet" "rytmiciteter" ;
  rytmsektion_nn_1_N = mkN "rytmsektion" "rytmsektioner" ;
  raeckvidd_nn_1_1_N = mkN "räckvidd" "räckvidder" ;
  raeddningsaktion_nn_1_1_N = mkN "räddningsaktion" "räddningsaktioner" ;
  raeddningschef_nn_1_1_N = mkN "räddningschef" "räddningschefer" ;
  raeddningsenhet_nn_1_1_N = mkN "räddningsenhet" "räddningsenheter" ;
  raeddningsoperation_nn_1_1_N = mkN "räddningsoperation" "räddningsoperationer" ;
  raejong_nn_1_1_N = mkN "räjong" "räjonger" ;
  raekneapparat_nn_1_1_N = mkN "räkneapparat" "räkneapparater" ;
  raeknekapacitet_nn_1_1_N = mkN "räknekapacitet" "räknekapaciteter" ;
  raeknemaskin_nn_1_1_N = mkN "räknemaskin" "räknemaskiner" ;
  raeknesnabbhet_nn_1_1_N = mkN "räknesnabbhet" "räknesnabbheter" ;
  raekpaj_nn_1_1_N = mkN "räkpaj" "räkpajer" ;
  rael_nn_1_1_N = mkN "räl" "räler" ;
  raelighet_nn_1_1_N = mkN "rälighet" "räligheter" ;
  raelsbusstation_nn_1_1_N = mkN "rälsbusstation" "rälsbusstationer" ;
  raenkfullhet_nn_1_1_N = mkN "ränkfullhet" "ränkfullheter" ;
  raentabilitet_nn_1_1_N = mkN "räntabilitet" "räntabiliteter" ;
  raentemarginal_nn_1_1_N = mkN "räntemarginal" "räntemarginaler" ;
  raentesubvention_nn_1_1_N = mkN "räntesubvention" "räntesubventioner" ;
  raentetermin_nn_1_1_N = mkN "räntetermin" "ränteterminer" ;
  raett_nn_2_1_N = mkN "rätt" "rätter" ;
  raettelse_nn_1_1_N = mkN "rättelse" "rättelser" ;
  raettframhet_nn_1_1_N = mkN "rättframhet" "rättframheter" ;
  raettfaerdighet_nn_1_1_N = mkN "rättfärdighet" "rättfärdigheter" ;
  raettighet_nn_1_1_N = mkN "rättighet" "rättigheter" ;
  raettschef_nn_1_1_N = mkN "rättschef" "rättschefer" ;
  raettsinformation_nn_1_1_N = mkN "rättsinformation" "rättsinformationer" ;
  raettskapacitet_nn_1_1_N = mkN "rättskapacitet" "rättskapaciteter" ;
  raettsosaekerhet_nn_1_1_N = mkN "rättsosäkerhet" "rättsosäkerheter" ;
  raettspaafoeljd_nn_1_1_N = mkN "rättspåföljd" "rättspåföljder" ;
  raettssak_nn_1_1_N = mkN "rättssak" "rättssaker" ;
  raettsstat_nn_1_1_N = mkN "rättsstat" "rättsstater" ;
  raettssaekerhet_nn_1_1_N = mkN "rättssäkerhet" "rättssäkerheter" ;
  raevjakt_nn_1_1_N = mkN "rävjakt" "rävjakter" ;
  raadhusraett_nn_1_1_N = mkN "rådhusrätt" "rådhusrätter" ;
  raadsrepublik_nn_1_1_N = mkN "rådsrepublik" "rådsrepubliker" ;
  raadstuguraett_nn_1_1_N = mkN "rådstugurätt" "rådstugurätter" ;
  raadsturaett_nn_1_1_N = mkN "rådsturätt" "rådsturätter" ;
  raadstuvuraett_nn_1_1_N = mkN "rådstuvurätt" "rådstuvurätter" ;
  raahet_nn_1_1_N = mkN "råhet" "råheter" ;
  raakostaffaer_nn_1_1_N = mkN "råkostaffär" "råkostaffärer" ;
  raasockerfabrik_nn_1_1_N = mkN "råsockerfabrik" "råsockerfabriker" ;
  roedbetssallad_nn_1_1_N = mkN "rödbetssallad" "rödbetssallader" ;
  roekbomb_nn_1_1_N = mkN "rökbomb" "rökbomber" ;
  roekelse_nn_1_1_N = mkN "rökelse" "rökelser" ;
  roekgranat_nn_1_1_N = mkN "rökgranat" "rökgranater" ;
  roekheroin_nn_1_1_N = mkN "rökheroin" "rökheroiner" ;
  roekkanal_nn_1_1_N = mkN "rökkanal" "rökkanaler" ;
  roekspiral_nn_1_1_N = mkN "rökspiral" "rökspiraler" ;
  roentgenapparat_nn_1_1_N = mkN "röntgenapparat" "röntgenapparater" ;
  roentgenbild_nn_1_1_N = mkN "röntgenbild" "röntgenbilder" ;
  roentgentid_nn_1_1_N = mkN "röntgentid" "röntgentider" ;
  roerelse_nn_1_1_N = mkN "rörelse" "rörelser" ;
  roerelsefrihet_nn_1_1_N = mkN "rörelsefrihet" "rörelsefriheter" ;
  roerelsemaengd_nn_1_1_N = mkN "rörelsemängd" "rörelsemängder" ;
  roerelsesvaarighet_nn_1_1_N = mkN "rörelsesvårighet" "rörelsesvårigheter" ;
  roerlighet_nn_1_1_N = mkN "rörlighet" "rörligheter" ;
  roermontoer_nn_1_1_N = mkN "rörmontör" "rörmontörer" ;
  roertaang_nn_1_1_N = mkN "rörtång" "rörtänger" ;
  roestlaengd_nn_1_1_N = mkN "röstlängd" "röstlängder" ;
  roestraekningsmaskin_nn_1_1_N = mkN "rösträkningsmaskin" "rösträkningsmaskiner" ;
  roetmaanad_nn_1_1_N = mkN "rötmånad" "rötmånader" ;
  roevtrakt_nn_1_1_N = mkN "rövtrakt" "rövtrakter" ;
  sabadill_nn_1_N = mkN "sabadill" "sabadiller" ;
  sabbat_nn_1_N = mkN "sabbat" "sabbater" ;
  sabbatstermin_nn_1_N = mkN "sabbatstermin" "sabbatsterminer" ;
  sabelbajonett_nn_1_N = mkN "sabelbajonett" "sabelbajonetter" ;
  sabotoer_nn_1_1_N = mkN "sabotör" "sabotörer" ;
  sackarin_nn_1_N = mkN "sackarin" "sackariner" ;
  sackett_nn_1_N = mkN "sackett" "sacketter" ;
  saffranslaengd_nn_1_1_N = mkN "saffranslängd" "saffranslängder" ;
  safir_nn_1_N = mkN "safir" "safirer" ;
  saftkraem_nn_1_1_N = mkN "saftkräm" "saftkrämer" ;
  saftstation_nn_1_N = mkN "saftstation" "saftstationer" ;
  sagogestalt_nn_1_N = mkN "sagogestalt" "sagogestalter" ;
  sagopalm_nn_1_N = mkN "sagopalm" "sagopalmer" ;
  sagostund_nn_1_N = mkN "sagostund" "sagostunder" ;
  sakdebatt_nn_1_N = mkN "sakdebatt" "sakdebatter" ;
  sakdiskussion_nn_1_N = mkN "sakdiskussion" "sakdiskussioner" ;
  saklighet_nn_1_N = mkN "saklighet" "sakligheter" ;
  saknad_nn_1_N = mkN "saknad" "saknader" ;
  sakuppgift_nn_1_N = mkN "sakuppgift" "sakuppgifter" ;
  sakoereslaengd_nn_1_1_N = mkN "saköreslängd" "saköreslängder" ;
  saladjaer_nn_1_1_N = mkN "saladjär" "saladjärer" ;
  salighet_nn_1_N = mkN "salighet" "saligheter" ;
  salinitet_nn_1_N = mkN "salinitet" "saliniteter" ;
  salivation_nn_1_N = mkN "salivation" "salivationer" ;
  sallad_nn_1_N = mkN "sallad" "sallader" ;
  salladsbar_nn_1_N = mkN "salladsbar" "salladsbarer" ;
  salong_nn_1_N = mkN "salong" "salonger" ;
  salongsbiljett_nn_1_N = mkN "salongsbiljett" "salongsbiljetter" ;
  salongsbolsjevik_nn_1_N = mkN "salongsbolsjevik" "salongsbolsjeviker" ;
  salongsfilosof_nn_1_N = mkN "salongsfilosof" "salongsfilosofer" ;
  salpeterbakterie_nn_1_N = mkN "salpeterbakterie" "salpeterbakterier" ;
  salpetersyrlighet_nn_1_N = mkN "salpetersyrlighet" "salpetersyrligheter" ;
  salspatient_nn_1_N = mkN "salspatient" "salspatienter" ;
  saltbassaeng_nn_1_1_N = mkN "saltbassäng" "saltbassänger" ;
  salthalt_nn_1_N = mkN "salthalt" "salthalter" ;
  saltkoncentration_nn_1_N = mkN "saltkoncentration" "saltkoncentrationer" ;
  saltomortal_nn_1_N = mkN "saltomortal" "saltomortaler" ;
  saltstod_nn_1_N = mkN "saltstod" "saltstoder" ;
  saltoert_nn_1_1_N = mkN "saltört" "saltörter" ;
  salut_nn_1_N = mkN "salut" "saluter" ;
  salutkanon_nn_1_N = mkN "salutkanon" "salutkanoner" ;
  salvelsefullhet_nn_1_N = mkN "salvelsefullhet" "salvelsefullheter" ;
  salvkanon_nn_1_N = mkN "salvkanon" "salvkanoner" ;
  samarbetsform_nn_1_N = mkN "samarbetsform" "samarbetsformer" ;
  samarbetsorganisation_nn_1_N = mkN "samarbetsorganisation" "samarbetsorganisationer" ;
  sambo_nn_1_N = mkN "sambo" "sambor" ;
  samdistribution_nn_1_N = mkN "samdistribution" "samdistributioner" ;
  same_nn_1_N = mkN "same" "samer" ;
  samfaellighet_nn_1_1_N = mkN "samfällighet" "samfälligheter" ;
  samfaerdsled_nn_1_1_N = mkN "samfärdsled" "samfärdsleder" ;
  samhaellsbyggnad_nn_1_1_N = mkN "samhällsbyggnad" "samhällsbyggnader" ;
  samhaellsdebatt_nn_1_1_N = mkN "samhällsdebatt" "samhällsdebatter" ;
  samhaellsform_nn_1_1_N = mkN "samhällsform" "samhällsformer" ;
  samhaellsfunktion_nn_1_1_N = mkN "samhällsfunktion" "samhällsfunktioner" ;
  samhaellsgrupp_nn_1_1_N = mkN "samhällsgrupp" "samhällsgrupper" ;
  samhaellsinformation_nn_1_1_N = mkN "samhällsinformation" "samhällsinformationer" ;
  samhaellskostnad_nn_1_1_N = mkN "samhällskostnad" "samhällskostnader" ;
  samhaellsnorm_nn_1_1_N = mkN "samhällsnorm" "samhällsnormer" ;
  samhaellssfaer_nn_1_1_N = mkN "samhällssfär" "samhällssfärer" ;
  samhaellssyn_nn_1_1_N = mkN "samhällssyn" "samhällssyner" ;
  samhaellsuppbyggnad_nn_1_1_N = mkN "samhällsuppbyggnad" "samhällsuppbyggnader" ;
  samhaellsvarelse_nn_1_1_N = mkN "samhällsvarelse" "samhällsvarelser" ;
  samhaellsvetenskap_nn_1_1_N = mkN "samhällsvetenskap" "samhällsvetenskaper" ;
  samhoerighet_nn_1_1_N = mkN "samhörighet" "samhörigheter" ;
  samlevnad_nn_1_N = mkN "samlevnad" "samlevnader" ;
  samlingslokal_nn_1_N = mkN "samlingslokal" "samlingslokaler" ;
  samlingspunkt_nn_1_N = mkN "samlingspunkt" "samlingspunkter" ;
  sammansaettningsfabrik_nn_1_1_N = mkN "sammansättningsfabrik" "sammansättningsfabriker" ;
  sammetsnatt_nn_1_N = mkN "sammetsnatt" "sammetsnätter" ;
  samojed_nn_1_N = mkN "samojed" "samojeder" ;
  samovar_nn_1_N = mkN "samovar" "samovarer" ;
  samtalsavgift_nn_1_N = mkN "samtalsavgift" "samtalsavgifter" ;
  samtalsgrupp_nn_1_N = mkN "samtalsgrupp" "samtalsgrupper" ;
  samtalsperiod_nn_1_N = mkN "samtalsperiod" "samtalsperioder" ;
  samtalsterapeut_nn_1_N = mkN "samtalsterapeut" "samtalsterapeuter" ;
  samtidighet_nn_1_N = mkN "samtidighet" "samtidigheter" ;
  samtidskommentar_nn_1_N = mkN "samtidskommentar" "samtidskommentarer" ;
  samuraj_nn_1_N = mkN "samuraj" "samurajer" ;
  samvariation_nn_1_N = mkN "samvariation" "samvariationer" ;
  samverkanskomponent_nn_1_N = mkN "samverkanskomponent" "samverkanskomponenter" ;
  samvetsattack_nn_1_N = mkN "samvetsattack" "samvetsattacker" ;
  samvetsbetaenklighet_nn_1_1_N = mkN "samvetsbetänklighet" "samvetsbetänkligheter" ;
  samvetsfrihet_nn_1_N = mkN "samvetsfrihet" "samvetsfriheter" ;
  samvetsfoerebraaelse_nn_1_1_N = mkN "samvetsförebråelse" "samvetsförebråelser" ;
  samvetskonflikt_nn_1_N = mkN "samvetskonflikt" "samvetskonflikter" ;
  samvetsloeshet_nn_1_1_N = mkN "samvetslöshet" "samvetslösheter" ;
  samvetssak_nn_1_N = mkN "samvetssak" "samvetssaker" ;
  sandal_nn_1_N = mkN "sandal" "sandaler" ;
  sandalett_nn_1_N = mkN "sandalett" "sandaletter" ;
  sandbakelse_nn_1_N = mkN "sandbakelse" "sandbakelser" ;
  sanddyn_nn_1_N = mkN "sanddyn" "sanddyner" ;
  sandmark_nn_1_N = mkN "sandmark" "sandmarker" ;
  sandstrand_nn_1_N = mkN "sandstrand" "sandstränder" ;
  sandtaekt_nn_1_1_N = mkN "sandtäkt" "sandtäkter" ;
  saneringsfastighet_nn_1_N = mkN "saneringsfastighet" "saneringsfastigheter" ;
  saneringskostnad_nn_1_N = mkN "saneringskostnad" "saneringskostnader" ;
  sanitet_nn_1_N = mkN "sanitet" "saniteter" ;
  sanitetsanstalt_nn_1_N = mkN "sanitetsanstalt" "sanitetsanstalter" ;
  sanitetstrupp_nn_1_N = mkN "sanitetstrupp" "sanitetstrupper" ;
  sanktifikation_nn_1_N = mkN "sanktifikation" "sanktifikationer" ;
  sanktion_nn_1_N = mkN "sanktion" "sanktioner" ;
  sanningsdrog_nn_1_N = mkN "sanningsdrog" "sanningsdroger" ;
  sannolikhet_nn_1_N = mkN "sannolikhet" "sannolikheter" ;
  sansculotte_nn_1_N = mkN "sansculotte" "sansculotter" ;
  sansloeshet_nn_2_1_N = mkN "sanslöshet" "sanslösheter" ;
  sapp_nn_1_N = mkN "sapp" "sapper" ;
  sappoer_nn_1_1_N = mkN "sappör" "sappörer" ;
  saprofyt_nn_1_N = mkN "saprofyt" "saprofyter" ;
  saraband_nn_1_N = mkN "saraband" "sarabander" ;
  saracen_nn_1_N = mkN "saracen" "saracener" ;
  sard_nn_1_N = mkN "sard" "sarder" ;
  sardell_nn_1_N = mkN "sardell" "sardeller" ;
  sarkasm_nn_1_N = mkN "sarkasm" "sarkasmer" ;
  sarkofag_nn_1_N = mkN "sarkofag" "sarkofager" ;
  sarong_nn_1_N = mkN "sarong" "saronger" ;
  sars_nn_1_N = mkN "sars" "sarser" ;
  satellitbild_nn_1_N = mkN "satellitbild" "satellitbilder" ;
  satellitradiostation_nn_1_N = mkN "satellitradiostation" "satellitradiostationer" ;
  satellitstat_nn_1_N = mkN "satellitstat" "satellitstater" ;
  satin_nn_1_N = mkN "satin" "satiner" ;
  satir_nn_1_N = mkN "satir" "satirer" ;
  satisfaktion_nn_1_N = mkN "satisfaktion" "satisfaktioner" ;
  satrap_nn_1_N = mkN "satrap" "satraper" ;
  satsaccent_nn_1_N = mkN "satsaccent" "satsaccenter" ;
  satsbyggnad_nn_1_N = mkN "satsbyggnad" "satsbyggnader" ;
  satskonstruktion_nn_1_N = mkN "satskonstruktion" "satskonstruktioner" ;
  satstyp_nn_1_N = mkN "satstyp" "satstyper" ;
  satyr_nn_1_N = mkN "satyr" "satyrer" ;
  sataeng_nn_1_1_N = mkN "satäng" "satänger" ;
  saudiarab_nn_1_N = mkN "saudiarab" "saudiaraber" ;
  savann_nn_1_N = mkN "savann" "savanner" ;
  savningstid_nn_1_N = mkN "savningstid" "savningstider" ;
  savojard_nn_1_N = mkN "savojard" "savojarder" ;
  savtid_nn_1_N = mkN "savtid" "savtider" ;
  saxdomkraft_nn_1_N = mkN "saxdomkraft" "saxdomkrafter" ;
  sbirr_nn_1_N = mkN "sbirr" "sbirrer" ;
  scenbild_nn_1_N = mkN "scenbild" "scenbilder" ;
  sceninstruktoer_nn_1_1_N = mkN "sceninstruktör" "sceninstruktörer" ;
  scenograf_nn_1_N = mkN "scenograf" "scenografer" ;
  scenshow_nn_1_N = mkN "scenshow" "scenshower" ;
  schablonbild_nn_1_N = mkN "schablonbild" "schablonbilder" ;
  schackningsperiod_nn_1_N = mkN "schackningsperiod" "schackningsperioder" ;
  schagg_nn_1_N = mkN "schagg" "schagger" ;
  schaktkant_nn_1_N = mkN "schaktkant" "schaktkanter" ;
  schaktmaskin_nn_1_N = mkN "schaktmaskin" "schaktmaskiner" ;
  schalett_nn_1_N = mkN "schalett" "schaletter" ;
  schavott_nn_1_N = mkN "schavott" "schavotter" ;
  schejk_nn_1_N = mkN "schejk" "schejker" ;
  schrammelkvartett_nn_1_N = mkN "schrammelkvartett" "schrammelkvartetter" ;
  schaeslong_nn_1_1_N = mkN "schäslong" "schäslonger" ;
  scintillation_nn_1_N = mkN "scintillation" "scintillationer" ;
  scopolamin_nn_1_N = mkN "scopolamin" "scopolaminer" ;
  scout_nn_1_N = mkN "scout" "scouter" ;
  scoutjamboree_nn_1_N = mkN "scoutjamboree" "scoutjamboreer" ;
  scoutkaar_nn_1_1_N = mkN "scoutkår" "scoutkårer" ;
  scoutpatrull_nn_1_N = mkN "scoutpatrull" "scoutpatruller" ;
  sedativum_nn_1_N = mkN "sedativ" "sedativer" ;
  sedelautomat_nn_1_N = mkN "sedelautomat" "sedelautomater" ;
  sedelreserv_nn_1_N = mkN "sedelreserv" "sedelreserver" ;
  sedlighet_nn_1_N = mkN "sedlighet" "sedligheter" ;
  sefard_nn_1_N = mkN "sefard" "sefarder" ;
  segeljakt_nn_1_N = mkN "segeljakt" "segeljakter" ;
  segelkanot_nn_1_N = mkN "segelkanot" "segelkanoter" ;
  segelled_nn_1_N = mkN "segelled" "segelleder" ;
  segelskridsko_nn_1_N = mkN "segelskridsko" "segelskridskor" ;
  seghet_nn_1_N = mkN "seghet" "segheter" ;
  seglation_nn_1_N = mkN "seglation" "seglationer" ;
  segregation_nn_1_N = mkN "segregation" "segregationer" ;
  seigneur_nn_1_N = mkN "seigneur" "seigneurer" ;
  seismograf_nn_1_N = mkN "seismograf" "seismografer" ;
  sejour_nn_1_N = mkN "sejour" "sejourer" ;
  sekatoer_nn_1_1_N = mkN "sekatör" "sekatörer" ;
  sekretion_nn_1_N = mkN "sekretion" "sekretioner" ;
  sekretaer_nn_1_1_N = mkN "sekretär" "sekretärer" ;
  sekt_nn_1_N = mkN "sekt" "sekter" ;
  sektion_nn_1_N = mkN "sektion" "sektioner" ;
  sektmentalitet_nn_1_N = mkN "sektmentalitet" "sektmentaliteter" ;
  sekularisation_nn_1_N = mkN "sekularisation" "sekularisationer" ;
  sekund_nn_1_N = mkN "sekund" "sekunder" ;
  sekundchef_nn_1_N = mkN "sekundchef" "sekundchefer" ;
  sekundaergrupp_nn_1_1_N = mkN "sekundärgrupp" "sekundärgrupper" ;
  sekundaerinfektion_nn_1_1_N = mkN "sekundärinfektion" "sekundärinfektioner" ;
  sekundaerkommun_nn_1_1_N = mkN "sekundärkommun" "sekundärkommuner" ;
  selektion_nn_1_N = mkN "selektion" "selektioner" ;
  selektivitet_nn_1_N = mkN "selektivitet" "selektiviteter" ;
  selencell_nn_1_N = mkN "selencell" "selenceller" ;
  semesterfloert_nn_1_1_N = mkN "semesterflört" "semesterflörter" ;
  semesterloen_nn_1_1_N = mkN "semesterlön" "semesterlöner" ;
  semestermaanad_nn_1_1_N = mkN "semestermånad" "semestermånader" ;
  semesterort_nn_1_N = mkN "semesterort" "semesterorter" ;
  semestertid_nn_1_N = mkN "semestertid" "semestertider" ;
  semination_nn_1_N = mkN "semination" "seminationer" ;
  seminstation_nn_1_N = mkN "seminstation" "seminstationer" ;
  seminoer_nn_1_1_N = mkN "seminör" "seminörer" ;
  senat_nn_1_N = mkN "senat" "senater" ;
  senilitet_nn_1_N = mkN "senilitet" "seniliteter" ;
  sensation_nn_1_N = mkN "sensation" "sensationer" ;
  sensibilitet_nn_1_N = mkN "sensibilitet" "sensibiliteter" ;
  sensigrupp_nn_1_N = mkN "sensigrupp" "sensigrupper" ;
  sensitivitet_nn_1_N = mkN "sensitivitet" "sensitiviteter" ;
  sensitivitetstalang_nn_1_N = mkN "sensitivitetstalang" "sensitivitetstalanger" ;
  sensmoral_nn_1_N = mkN "sensmoral" "sensmoraler" ;
  sensommarnatt_nn_1_N = mkN "sensommarnatt" "sensommarnätter" ;
  sensualitet_nn_1_N = mkN "sensualitet" "sensualiteter" ;
  sentimentalitet_nn_1_N = mkN "sentimentalitet" "sentimentaliteter" ;
  separatfred_nn_1_N = mkN "separatfred" "separatfreder" ;
  separation_nn_1_N = mkN "separation" "separationer" ;
  separatistroerelse_nn_1_1_N = mkN "separatiströrelse" "separatiströrelser" ;
  septett_nn_1_N = mkN "septett" "septetter" ;
  seraf_nn_1_N = mkN "seraf" "serafer" ;
  seralj_nn_1_N = mkN "seralj" "seraljer" ;
  serb_nn_1_N = mkN "serb" "serber" ;
  serenad_nn_1_N = mkN "serenad" "serenader" ;
  serenitet_nn_1_N = mkN "serenitet" "sereniteter" ;
  sergeant_nn_1_N = mkN "sergeant" "sergeanter" ;
  serie_nn_1_N = mkN "serie" "serier" ;
  serieproduktion_nn_1_N = mkN "serieproduktion" "serieproduktioner" ;
  seriff_nn_1_N = mkN "seriff" "seriffer" ;
  seriositet_nn_1_N = mkN "seriositet" "seriositeter" ;
  serotonin_nn_1_N = mkN "serotonin" "serotoniner" ;
  serpent_nn_1_N = mkN "serpent" "serpenter" ;
  servelinje_nn_1_N = mkN "servelinje" "servelinjer" ;
  serveringsavgift_nn_1_N = mkN "serveringsavgift" "serveringsavgifter" ;
  servett_nn_1_N = mkN "servett" "servetter" ;
  servicebostad_nn_1_N = mkN "servicebostad" "servicebostäder" ;
  servicebutik_nn_1_N = mkN "servicebutik" "servicebutiker" ;
  servicelaegenhet_nn_1_1_N = mkN "servicelägenhet" "servicelägenheter" ;
  servicepersonal_nn_1_N = mkN "servicepersonal" "servicepersonaler" ;
  servicestation_nn_1_N = mkN "servicestation" "servicestationer" ;
  servilitet_nn_1_N = mkN "servilitet" "serviliteter" ;
  servitoer_nn_1_1_N = mkN "servitör" "servitörer" ;
  servlinje_nn_1_N = mkN "servlinje" "servlinjer" ;
  session_nn_1_N = mkN "session" "sessioner" ;
  sevaerdhet_nn_1_1_N = mkN "sevärdhet" "sevärdheter" ;
  sexaffaer_nn_1_1_N = mkN "sexaffär" "sexaffärer" ;
  sexakt_nn_1_N = mkN "sexakt" "sexakter" ;
  sexbomb_nn_1_N = mkN "sexbomb" "sexbomber" ;
  sexhaendelse_nn_1_1_N = mkN "sexhändelse" "sexhändelser" ;
  sexklinik_nn_1_N = mkN "sexklinik" "sexkliniker" ;
  sexleksak_nn_1_N = mkN "sexleksak" "sexleksaker" ;
  sexmyt_nn_1_N = mkN "sexmyt" "sexmyter" ;
  sexsajt_nn_1_N = mkN "sexsajt" "sexsajter" ;
  sexscen_nn_1_N = mkN "sexscen" "sexscener" ;
  sext_nn_1_N = mkN "sext" "sexter" ;
  sextett_nn_1_N = mkN "sextett" "sextetter" ;
  sexualakt_nn_1_N = mkN "sexualakt" "sexualakter" ;
  sexualdrift_nn_1_N = mkN "sexualdrift" "sexualdrifter" ;
  sexualitet_nn_1_N = mkN "sexualitet" "sexualiteter" ;
  sexaarsperiod_nn_1_1_N = mkN "sexårsperiod" "sexårsperioder" ;
  shejk_nn_1_N = mkN "shejk" "shejker" ;
  sheriff_nn_1_N = mkN "sheriff" "sheriffer" ;
  shoppingtur_nn_1_N = mkN "shoppingtur" "shoppingturer" ;
  show_nn_1_N = mkN "show" "shower" ;
  shuntventil_nn_1_N = mkN "shuntventil" "shuntventiler" ;
  siameskatt_nn_1_N = mkN "siameskatt" "siameskatter" ;
  sibet_nn_1_N = mkN "sibet" "sibeter" ;
  sibetkatt_nn_1_N = mkN "sibetkatt" "sibetkatter" ;
  sidlinje_nn_1_N = mkN "sidlinje" "sidlinjer" ;
  sidoapparat_nn_1_N = mkN "sidoapparat" "sidoapparater" ;
  sidobyggnad_nn_1_N = mkN "sidobyggnad" "sidobyggnader" ;
  sidoeffekt_nn_1_N = mkN "sidoeffekt" "sidoeffekter" ;
  sidolinje_nn_1_N = mkN "sidolinje" "sidolinjer" ;
  sidvoerdnad_nn_1_1_N = mkN "sidvördnad" "sidvördnader" ;
  sifferfoeljd_nn_1_1_N = mkN "sifferföljd" "sifferföljder" ;
  sifferkombination_nn_1_N = mkN "sifferkombination" "sifferkombinationer" ;
  sifferuppgift_nn_1_N = mkN "sifferuppgift" "sifferuppgifter" ;
  signalhastighet_nn_1_N = mkN "signalhastighet" "signalhastigheter" ;
  signaltrupp_nn_1_N = mkN "signaltrupp" "signaltrupper" ;
  signataer_nn_1_1_N = mkN "signatär" "signatärer" ;
  signataermakt_nn_1_1_N = mkN "signatärmakt" "signatärmakter" ;
  signelse_nn_1_N = mkN "signelse" "signelser" ;
  sikh_nn_1_N = mkN "sikh" "sikher" ;
  siktlinje_nn_1_N = mkN "siktlinje" "siktlinjer" ;
  silen_nn_1_N = mkN "silen" "silener" ;
  silhuett_nn_1_N = mkN "silhuett" "silhuetter" ;
  silkeslarv_nn_1_N = mkN "silkeslarv" "silkeslarver" ;
  sillperiod_nn_1_N = mkN "sillperiod" "sillperioder" ;
  sillsallad_nn_1_N = mkN "sillsallad" "sillsallader" ;
  sillsallat_nn_1_N = mkN "sillsallat" "sillsallater" ;
  siluett_nn_1_N = mkN "siluett" "siluetter" ;
  silverhalt_nn_1_N = mkN "silverhalt" "silverhalter" ;
  silvermedalj_nn_1_N = mkN "silvermedalj" "silvermedaljer" ;
  silversmed_nn_1_N = mkN "silversmed" "silversmeder" ;
  simand_nn_1_N = mkN "simand" "simänder" ;
  simbassaeng_nn_1_1_N = mkN "simbassäng" "simbassänger" ;
  simdraekt_nn_1_1_N = mkN "simdräkt" "simdräkter" ;
  simkandidat_nn_1_N = mkN "simkandidat" "simkandidater" ;
  simpelhet_nn_1_N = mkN "simpelhet" "simpelheter" ;
  simpromotion_nn_1_N = mkN "simpromotion" "simpromotioner" ;
  simtur_nn_1_N = mkN "simtur" "simturer" ;
  simulation_nn_1_N = mkN "simulation" "simulationer" ;
  simultanscen_nn_1_N = mkN "simultanscen" "simultanscener" ;
  sinekur_nn_1_N = mkN "sinekur" "sinekurer" ;
  singularitet_nn_1_N = mkN "singularitet" "singulariteter" ;
  sinnebild_nn_1_N = mkN "sinnebild" "sinnebilder" ;
  sinnesart_nn_1_N = mkN "sinnesart" "sinnesarter" ;
  sinnescell_nn_1_N = mkN "sinnescell" "sinnesceller" ;
  sinnesfoernimmelse_nn_1_1_N = mkN "sinnesförnimmelse" "sinnesförnimmelser" ;
  sinnesnerv_nn_1_N = mkN "sinnesnerv" "sinnesnerver" ;
  sinnesroerelse_nn_1_1_N = mkN "sinnesrörelse" "sinnesrörelser" ;
  sinnesupplevelse_nn_1_N = mkN "sinnesupplevelse" "sinnesupplevelser" ;
  sinnlighet_nn_1_N = mkN "sinnlighet" "sinnligheter" ;
  sinuston_nn_1_N = mkN "sinuston" "sinustoner" ;
  sirat_nn_1_N = mkN "sirat" "sirater" ;
  siren_nn_1_N = mkN "siren" "sirener" ;
  sirlighet_nn_1_N = mkN "sirlighet" "sirligheter" ;
  sitar_nn_1_N = mkN "sitar" "sitarer" ;
  sittgrupp_nn_1_N = mkN "sittgrupp" "sittgrupper" ;
  sittstaang_nn_1_1_N = mkN "sittstång" "sittstänger" ;
  situation_nn_1_N = mkN "situation" "situationer" ;
  situationsbild_nn_1_N = mkN "situationsbild" "situationsbilder" ;
  sjagg_nn_1_N = mkN "sjagg" "sjagger" ;
  sjalett_nn_1_N = mkN "sjalett" "sjaletter" ;
  sjaskighet_nn_1_N = mkN "sjaskighet" "sjaskigheter" ;
  sjukdomsbild_nn_1_N = mkN "sjukdomsbild" "sjukdomsbilder" ;
  sjukhet_nn_1_N = mkN "sjukhet" "sjukheter" ;
  sjukjournal_nn_1_N = mkN "sjukjournal" "sjukjournaler" ;
  sjukledighet_nn_1_N = mkN "sjukledighet" "sjukledigheter" ;
  sjuklighet_nn_1_N = mkN "sjuklighet" "sjukligheter" ;
  sjukpension_nn_1_N = mkN "sjukpension" "sjukpensioner" ;
  sjukvikarie_nn_1_N = mkN "sjukvikarie" "sjukvikarier" ;
  sjukvaardsaffaer_nn_1_1_N = mkN "sjukvårdsaffär" "sjukvårdsaffärer" ;
  sjukvaardsapparat_nn_1_1_N = mkN "sjukvårdsapparat" "sjukvårdsapparater" ;
  sjukvaardsreform_nn_1_1_N = mkN "sjukvårdsreform" "sjukvårdsreformer" ;
  sjukvaardsregion_nn_1_1_N = mkN "sjukvårdsregion" "sjukvårdsregioner" ;
  sjunkbomb_nn_1_N = mkN "sjunkbomb" "sjunkbomber" ;
  sjaelloeshet_nn_1_1_N = mkN "själlöshet" "själlösheter" ;
  sjaelsegenskap_nn_1_1_N = mkN "själsegenskap" "själsegenskaper" ;
  sjaelsfraende_nn_1_1_N = mkN "själsfrände" "själsfränder" ;
  sjaelsfoermoegenhet_nn_1_1_N = mkN "själsförmögenhet" "själsförmögenheter" ;
  sjaelskonflikt_nn_1_1_N = mkN "själskonflikt" "själskonflikter" ;
  sjaelsstrid_nn_1_1_N = mkN "själsstrid" "själsstrider" ;
  sjaelvanklagelse_nn_1_1_N = mkN "självanklagelse" "självanklagelser" ;
  sjaelvbekaennelse_nn_1_1_N = mkN "självbekännelse" "självbekännelser" ;
  sjaelvbelaatenhet_nn_1_1_N = mkN "självbelåtenhet" "självbelåtenheter" ;
  sjaelvbo_nn_1_1_N = mkN "självbo" "självbor" ;
  sjaelvdeklaration_nn_1_1_N = mkN "självdeklaration" "självdeklarationer" ;
  sjaelvfoerebraaelse_nn_1_1_N = mkN "självförebråelse" "självförebråelser" ;
  sjaelvfoerhaevelse_nn_1_1_N = mkN "självförhävelse" "självförhävelser" ;
  sjaelvfoernekelse_nn_1_1_N = mkN "självförnekelse" "självförnekelser" ;
  sjaelvgodhet_nn_1_1_N = mkN "självgodhet" "självgodheter" ;
  sjaelvhjaelpsentreprenoer_nn_1_1_N = mkN "självhjälpsentreprenör" "självhjälpsentreprenörer" ;
  sjaelvhjaelpsgenre_nn_1_1_N = mkN "självhjälpsgenre" "självhjälpsgenrer" ;
  sjaelviakttagelse_nn_1_1_N = mkN "själviakttagelse" "själviakttagelser" ;
  sjaelviskhet_nn_1_1_N = mkN "själviskhet" "själviskheter" ;
  sjaelvklarhet_nn_1_1_N = mkN "självklarhet" "självklarheter" ;
  sjaelvmedvetenhet_nn_1_1_N = mkN "självmedvetenhet" "självmedvetenheter" ;
  sjaelvmordsattack_nn_1_1_N = mkN "självmordsattack" "självmordsattacker" ;
  sjaelvmordsbomb_nn_1_1_N = mkN "självmordsbomb" "självmordsbomber" ;
  sjaelvmordskandidat_nn_1_1_N = mkN "självmordskandidat" "självmordskandidater" ;
  sjaelvmotsaegelse_nn_1_1_N = mkN "självmotsägelse" "självmotsägelser" ;
  sjaelvstaendighet_nn_1_1_N = mkN "självständighet" "självständigheter" ;
  sjaelvsuggestion_nn_1_1_N = mkN "självsuggestion" "självsuggestioner" ;
  sjaelvsaekerhet_nn_1_1_N = mkN "självsäkerhet" "självsäkerheter" ;
  sjoefrakt_nn_1_1_N = mkN "sjöfrakt" "sjöfrakter" ;
  sjoefaerd_nn_1_1_N = mkN "sjöfärd" "sjöfärder" ;
  sjoefaagelsjakt_nn_1_1_N = mkN "sjöfågelsjakt" "sjöfågelsjakter" ;
  sjoekapten_nn_1_1_N = mkN "sjökapten" "sjökaptener" ;
  sjoeko_nn_1_1_N = mkN "sjöko" "sjökor" ;
  sjoelaegenhet_nn_1_1_N = mkN "sjölägenhet" "sjölägenheter" ;
  sjoeroevarkapten_nn_1_1_N = mkN "sjörövarkapten" "sjörövarkaptener" ;
  sjoestrid_nn_1_1_N = mkN "sjöstrid" "sjöstrider" ;
  sjoetomt_nn_1_1_N = mkN "sjötomt" "sjötomter" ;
  sjoevaerdighet_nn_1_1_N = mkN "sjövärdighet" "sjövärdigheter" ;
  skadegoerelse_nn_1_1_N = mkN "skadegörelse" "skadegörelser" ;
  skadeinsekt_nn_1_N = mkN "skadeinsekt" "skadeinsekter" ;
  skadlighet_nn_1_N = mkN "skadlighet" "skadligheter" ;
  skallform_nn_1_N = mkN "skallform" "skallformer" ;
  skalp_nn_1_N = mkN "skalp" "skalper" ;
  skalpell_nn_1_N = mkN "skalpell" "skalpeller" ;
  skamlighet_nn_1_N = mkN "skamlighet" "skamligheter" ;
  skamloeshet_nn_1_1_N = mkN "skamlöshet" "skamlösheter" ;
  skandal_nn_1_N = mkN "skandal" "skandaler" ;
  skandalbild_nn_1_N = mkN "skandalbild" "skandalbilder" ;
  skandalscen_nn_1_N = mkN "skandalscen" "skandalscener" ;
  skandinav_nn_1_N = mkN "skandinav" "skandinaver" ;
  skaparkraft_nn_1_N = mkN "skaparkraft" "skaparkrafter" ;
  skapelse_nn_1_N = mkN "skapelse" "skapelser" ;
  skapelseakt_nn_1_N = mkN "skapelseakt" "skapelseakter" ;
  skapelseberaettelse_nn_1_1_N = mkN "skapelseberättelse" "skapelseberättelser" ;
  skapnad_nn_1_N = mkN "skapnad" "skapnader" ;
  skarphet_nn_2_N = mkN "skarphet" "skarpheter" ;
  skarpsyn_nn_1_N = mkN "skarpsyn" "skarpsyner" ;
  skarvpopulation_nn_1_N = mkN "skarvpopulation" "skarvpopulationer" ;
  skattebefrielse_nn_1_N = mkN "skattebefrielse" "skattebefrielser" ;
  skattebonde_nn_1_N = mkN "skattebonde" "skattebönder" ;
  skattefrihet_nn_1_N = mkN "skattefrihet" "skattefriheter" ;
  skatteintaekt_nn_1_1_N = mkN "skatteintäkt" "skatteintäkter" ;
  skattekraft_nn_1_N = mkN "skattekraft" "skattekrafter" ;
  skattelaettnad_nn_1_1_N = mkN "skattelättnad" "skattelättnader" ;
  skattemoral_nn_1_N = mkN "skattemoral" "skattemoraler" ;
  skattemyndighet_nn_1_N = mkN "skattemyndighet" "skattemyndigheter" ;
  skattereduktion_nn_1_N = mkN "skattereduktion" "skattereduktioner" ;
  skattereform_nn_1_N = mkN "skattereform" "skattereformer" ;
  skatterevolt_nn_1_N = mkN "skatterevolt" "skatterevolter" ;
  skattesubvention_nn_1_N = mkN "skattesubvention" "skattesubventioner" ;
  skattetabell_nn_1_N = mkN "skattetabell" "skattetabeller" ;
  skatteuppboerd_nn_1_1_N = mkN "skatteuppbörd" "skatteuppbörder" ;
  skavank_nn_1_N = mkN "skavank" "skavanker" ;
  skedand_nn_1_N = mkN "skedand" "skedänder" ;
  skeloegdhet_nn_1_1_N = mkN "skelögdhet" "skelögdheter" ;
  skenbild_nn_1_N = mkN "skenbild" "skenbilder" ;
  skenfrukt_nn_1_N = mkN "skenfrukt" "skenfrukter" ;
  skengestalt_nn_1_N = mkN "skengestalt" "skengestalter" ;
  skenhelighet_nn_1_N = mkN "skenhelighet" "skenheligheter" ;
  skenhaendelse_nn_1_1_N = mkN "skenhändelse" "skenhändelser" ;
  skepnad_nn_1_N = mkN "skepnad" "skepnader" ;
  skevhet_nn_1_N = mkN "skevhet" "skevheter" ;
  skickelse_nn_1_N = mkN "skickelse" "skickelser" ;
  skicklighet_nn_1_N = mkN "skicklighet" "skickligheter" ;
  skidort_nn_1_N = mkN "skidort" "skidorter" ;
  skidtur_nn_1_N = mkN "skidtur" "skidturer" ;
  skidtyp_nn_1_N = mkN "skidtyp" "skidtyper" ;
  skiktroentgenapparat_nn_1_1_N = mkN "skiktröntgenapparat" "skiktröntgenapparater" ;
  skiljaktighet_nn_1_N = mkN "skiljaktighet" "skiljaktigheter" ;
  skiljelinje_nn_1_N = mkN "skiljelinje" "skiljelinjer" ;
  skiljenaemnd_nn_1_1_N = mkN "skiljenämnd" "skiljenämnder" ;
  skillnad_nn_1_N = mkN "skillnad" "skillnader" ;
  skiltvakt_nn_1_N = mkN "skiltvakt" "skiltvakter" ;
  skinnfaatoelj_nn_1_1_N = mkN "skinnfåtölj" "skinnfåtöljer" ;
  skinnimitation_nn_1_N = mkN "skinnimitation" "skinnimitationer" ;
  skitsak_nn_1_N = mkN "skitsak" "skitsaker" ;
  skivaffaer_nn_1_1_N = mkN "skivaffär" "skivaffärer" ;
  skivbar_nn_1_N = mkN "skivbar" "skivbarer" ;
  skivdistribution_nn_1_N = mkN "skivdistribution" "skivdistributioner" ;
  skivstaang_nn_1_1_N = mkN "skivstång" "skivstänger" ;
  sko_nn_1_N = mkN "sko" "skor" ;
  skogsbrand_nn_1_N = mkN "skogsbrand" "skogsbränder" ;
  skogskovall_nn_1_N = mkN "skogskovall" "skogskovaller" ;
  skogsmark_nn_1_N = mkN "skogsmark" "skogsmarker" ;
  skogstomt_nn_1_N = mkN "skogstomt" "skogstomter" ;
  skogsutflykt_nn_1_N = mkN "skogsutflykt" "skogsutflykter" ;
  skogsvidd_nn_1_N = mkN "skogsvidd" "skogsvidder" ;
  skojighet_nn_1_N = mkN "skojighet" "skojigheter" ;
  skokartong_nn_1_N = mkN "skokartong" "skokartonger" ;
  skokraem_nn_1_1_N = mkN "skokräm" "skokrämer" ;
  skolavgift_nn_1_N = mkN "skolavgift" "skolavgifter" ;
  skolbrand_nn_1_N = mkN "skolbrand" "skolbränder" ;
  skolbyggnad_nn_1_N = mkN "skolbyggnad" "skolbyggnader" ;
  skolchef_nn_1_N = mkN "skolchef" "skolchefer" ;
  skolelev_nn_1_N = mkN "skolelev" "skolelever" ;
  skolform_nn_1_N = mkN "skolform" "skolformer" ;
  skolgrammatik_nn_1_N = mkN "skolgrammatik" "skolgrammatiker" ;
  skolinspektion_nn_1_N = mkN "skolinspektion" "skolinspektioner" ;
  skoljournal_nn_1_N = mkN "skoljournal" "skoljournaler" ;
  skolkamrat_nn_1_N = mkN "skolkamrat" "skolkamrater" ;
  skolmognad_nn_1_N = mkN "skolmognad" "skolmognader" ;
  skolmyndighet_nn_1_N = mkN "skolmyndighet" "skolmyndigheter" ;
  skolmaaltid_nn_1_1_N = mkN "skolmåltid" "skolmåltider" ;
  skolnaemnd_nn_1_1_N = mkN "skolnämnd" "skolnämnder" ;
  skolsituation_nn_1_N = mkN "skolsituation" "skolsituationer" ;
  skolstyrelse_nn_1_N = mkN "skolstyrelse" "skolstyrelser" ;
  skolunderbyggnad_nn_1_N = mkN "skolunderbyggnad" "skolunderbyggnader" ;
  skolungdomsidrott_nn_1_N = mkN "skolungdomsidrott" "skolungdomsidrotter" ;
  skomakarverkstad_nn_1_N = mkN "skomakarverkstad" "skomakarverkstäder" ;
  skonert_nn_1_N = mkN "skonert" "skonerter" ;
  skoningsloeshet_nn_1_1_N = mkN "skoningslöshet" "skoningslösheter" ;
  skopofil_nn_1_N = mkN "skopofil" "skopofiler" ;
  skopolamin_nn_1_N = mkN "skopolamin" "skopolaminer" ;
  skottlinje_nn_1_N = mkN "skottlinje" "skottlinjer" ;
  skottsekund_nn_1_N = mkN "skottsekund" "skottsekunder" ;
  skottvidd_nn_1_N = mkN "skottvidd" "skottvidder" ;
  skraplott_nn_1_N = mkN "skraplott" "skraplotter" ;
  skrattkramp_nn_1_N = mkN "skrattkramp" "skrattkramper" ;
  skribent_nn_1_N = mkN "skribent" "skribenter" ;
  skridsko_nn_1_N = mkN "skridsko" "skridskor" ;
  skriftbild_nn_1_N = mkN "skriftbild" "skriftbilder" ;
  skriftspraaklighet_nn_1_1_N = mkN "skriftspråklighet" "skriftspråkligheter" ;
  skriksession_nn_1_N = mkN "skriksession" "skriksessioner" ;
  skrivbordskonstruktion_nn_1_N = mkN "skrivbordskonstruktion" "skrivbordskonstruktioner" ;
  skrivelse_nn_1_N = mkN "skrivelse" "skrivelser" ;
  skrivmaskin_nn_1_N = mkN "skrivmaskin" "skrivmaskiner" ;
  skrivmaskinstangent_nn_1_N = mkN "skrivmaskinstangent" "skrivmaskinstangenter" ;
  skrockfullhet_nn_1_N = mkN "skrockfullhet" "skrockfullheter" ;
  skrodoer_nn_1_1_N = mkN "skrodör" "skrodörer" ;
  skrotningspremie_nn_1_N = mkN "skrotningspremie" "skrotningspremier" ;
  skrovlighet_nn_1_N = mkN "skrovlighet" "skrovligheter" ;
  skrupelloeshet_nn_1_1_N = mkN "skrupellöshet" "skrupellösheter" ;
  skraeckberaettelse_nn_1_1_N = mkN "skräckberättelse" "skräckberättelser" ;
  skraeckbild_nn_1_1_N = mkN "skräckbild" "skräckbilder" ;
  skraeckfilm_nn_1_1_N = mkN "skräckfilm" "skräckfilmer" ;
  skraecknatt_nn_1_1_N = mkN "skräcknatt" "skräcknätter" ;
  skraecknovell_nn_1_1_N = mkN "skräcknovell" "skräcknoveller" ;
  skraeckrubrik_nn_1_1_N = mkN "skräckrubrik" "skräckrubriker" ;
  skraecksyn_nn_1_1_N = mkN "skräcksyn" "skräcksyner" ;
  skraeckvision_nn_1_1_N = mkN "skräckvision" "skräckvisioner" ;
  skraepprodukt_nn_1_1_N = mkN "skräpprodukt" "skräpprodukter" ;
  skroeplighet_nn_1_1_N = mkN "skröplighet" "skröpligheter" ;
  skuggbild_nn_1_N = mkN "skuggbild" "skuggbilder" ;
  skulderled_nn_1_N = mkN "skulderled" "skulderleder" ;
  skuldfoerbindelse_nn_1_1_N = mkN "skuldförbindelse" "skuldförbindelser" ;
  skulpturgrupp_nn_1_N = mkN "skulpturgrupp" "skulpturgrupper" ;
  skulpturpark_nn_1_N = mkN "skulpturpark" "skulpturparker" ;
  skulptoer_nn_1_1_N = mkN "skulptör" "skulptörer" ;
  skumhet_nn_2_N = mkN "skumhet" "skumheter" ;
  skumraskaffaer_nn_1_1_N = mkN "skumraskaffär" "skumraskaffärer" ;
  skunkighet_nn_1_N = mkN "skunkighet" "skunkigheter" ;
  skurkaktighet_nn_1_N = mkN "skurkaktighet" "skurkaktigheter" ;
  skurkstat_nn_1_N = mkN "skurkstat" "skurkstater" ;
  skvallerspalt_nn_1_N = mkN "skvallerspalt" "skvallerspalter" ;
  skvallertant_nn_1_N = mkN "skvallertant" "skvallertanter" ;
  skyddsdraekt_nn_1_1_N = mkN "skyddsdräkt" "skyddsdräkter" ;
  skyddsfaerg_nn_1_1_N = mkN "skyddsfärg" "skyddsfärger" ;
  skyddskonsulent_nn_1_N = mkN "skyddskonsulent" "skyddskonsulenter" ;
  skyddskaar_nn_1_1_N = mkN "skyddskår" "skyddskårer" ;
  skyddspatron_nn_1_N = mkN "skyddspatron" "skyddspatroner" ;
  skyddsstat_nn_1_N = mkN "skyddsstat" "skyddsstater" ;
  skyddsvakt_nn_1_N = mkN "skyddsvakt" "skyddsvakter" ;
  skyddsaatgaerd_nn_1_1_N = mkN "skyddsåtgärd" "skyddsåtgärder" ;
  skyldighet_nn_1_N = mkN "skyldighet" "skyldigheter" ;
  skymf_nn_1_N = mkN "skymf" "skymfer" ;
  skyttebrigad_nn_1_N = mkN "skyttebrigad" "skyttebrigader" ;
  skyttegravskant_nn_1_N = mkN "skyttegravskant" "skyttegravskanter" ;
  skyttegrupp_nn_1_N = mkN "skyttegrupp" "skyttegrupper" ;
  skyttelinje_nn_1_N = mkN "skyttelinje" "skyttelinjer" ;
  skyttepaviljong_nn_1_N = mkN "skyttepaviljong" "skyttepaviljonger" ;
  skyttesalong_nn_1_N = mkN "skyttesalong" "skyttesalonger" ;
  skaellko_nn_1_1_N = mkN "skällko" "skällkor" ;
  skaemtsamhet_nn_1_1_N = mkN "skämtsamhet" "skämtsamheter" ;
  skaendlighet_nn_1_1_N = mkN "skändlighet" "skändligheter" ;
  skaenk_nn_2_1_N = mkN "skänk" "skänker" ;
  skaergaardsbo_nn_1_1_N = mkN "skärgårdsbo" "skärgårdsbor" ;
  skaerhaallfasthet_nn_1_1_N = mkN "skärhållfasthet" "skärhållfastheter" ;
  skaermbild_nn_1_1_N = mkN "skärmbild" "skärmbilder" ;
  skaerningspunkt_nn_1_1_N = mkN "skärningspunkt" "skärningspunkter" ;
  skaadespelartrupp_nn_1_1_N = mkN "skådespelartrupp" "skådespelartrupper" ;
  skoenhet_nn_1_1_N = mkN "skönhet" "skönheter" ;
  skoenhetsoperation_nn_1_1_N = mkN "skönhetsoperation" "skönhetsoperationer" ;
  skoenhetssalong_nn_1_1_N = mkN "skönhetssalong" "skönhetssalonger" ;
  skoenhetsupplevelse_nn_1_1_N = mkN "skönhetsupplevelse" "skönhetsupplevelser" ;
  skoerdeenhet_nn_1_1_N = mkN "skördeenhet" "skördeenheter" ;
  skoerdemaskin_nn_1_1_N = mkN "skördemaskin" "skördemaskiner" ;
  skoerdemaanad_nn_1_1_N = mkN "skördemånad" "skördemånader" ;
  skoerdetid_nn_1_1_N = mkN "skördetid" "skördetider" ;
  skoerlevnad_nn_1_1_N = mkN "skörlevnad" "skörlevnader" ;
  skoeterskegrad_nn_1_1_N = mkN "sköterskegrad" "sköterskegrader" ;
  skoetesynd_nn_1_1_N = mkN "skötesynd" "skötesynder" ;
  slaganfallspatient_nn_1_N = mkN "slaganfallspatient" "slaganfallspatienter" ;
  slagg_nn_1_N = mkN "slagg" "slagger" ;
  slaggmaengd_nn_1_1_N = mkN "slaggmängd" "slaggmängder" ;
  slaglaengd_nn_1_1_N = mkN "slaglängd" "slaglängder" ;
  slagseghet_nn_1_N = mkN "slagseghet" "slagsegheter" ;
  slakteributik_nn_1_N = mkN "slakteributik" "slakteributiker" ;
  slaktmaanad_nn_1_1_N = mkN "slaktmånad" "slaktmånader" ;
  slarvighet_nn_1_N = mkN "slarvighet" "slarvigheter" ;
  slaskspalt_nn_1_N = mkN "slaskspalt" "slaskspalter" ;
  slav_nn_2_N = mkN "slav" "slaver" ;
  slavloen_nn_1_1_N = mkN "slavlön" "slavlöner" ;
  slavstation_nn_1_N = mkN "slavstation" "slavstationer" ;
  slemmighet_nn_2_N = mkN "slemmighet" "slemmigheter" ;
  slibbighet_nn_1_N = mkN "slibbighet" "slibbigheter" ;
  slid_nn_1_N = mkN "slid" "slider" ;
  slingerkoj_nn_1_N = mkN "slingerkoj" "slingerkojer" ;
  slinkled_nn_1_N = mkN "slinkled" "slinkleder" ;
  slipmaskin_nn_1_N = mkN "slipmaskin" "slipmaskiner" ;
  slipprighet_nn_1_N = mkN "slipprighet" "slipprigheter" ;
  slirighet_nn_2_N = mkN "slirighet" "slirigheter" ;
  slottspark_nn_1_N = mkN "slottspark" "slottsparker" ;
  slottsruin_nn_1_N = mkN "slottsruin" "slottsruiner" ;
  slovak_nn_1_N = mkN "slovak" "slovaker" ;
  sloven_nn_1_N = mkN "sloven" "slovener" ;
  slughet_nn_1_N = mkN "slughet" "slugheter" ;
  slutloen_nn_1_1_N = mkN "slutlön" "slutlöner" ;
  slutprodukt_nn_1_N = mkN "slutprodukt" "slutprodukter" ;
  slutpunkt_nn_1_N = mkN "slutpunkt" "slutpunkter" ;
  slutrad_nn_1_N = mkN "slutrad" "slutrader" ;
  slutskrift_nn_1_N = mkN "slutskrift" "slutskrifter" ;
  slutspurt_nn_1_N = mkN "slutspurt" "slutspurter" ;
  slutstation_nn_1_N = mkN "slutstation" "slutstationer" ;
  slutuppgoerelse_nn_1_1_N = mkN "slutuppgörelse" "slutuppgörelser" ;
  slutvinjett_nn_1_N = mkN "slutvinjett" "slutvinjetter" ;
  slutvokal_nn_1_N = mkN "slutvokal" "slutvokaler" ;
  slaektdrift_nn_1_1_N = mkN "släktdrift" "släktdrifter" ;
  slaektfejd_nn_1_1_N = mkN "släktfejd" "släktfejder" ;
  slaektklenod_nn_1_1_N = mkN "släktklenod" "släktklenoder" ;
  slaektlinje_nn_1_1_N = mkN "släktlinje" "släktlinjer" ;
  slaendlarv_nn_1_1_N = mkN "sländlarv" "sländlarver" ;
  slaent_nn_1_1_N = mkN "slänt" "slänter" ;
  slaepkontakt_nn_1_1_N = mkN "släpkontakt" "släpkontakter" ;
  slaepsko_nn_1_1_N = mkN "släpsko" "släpskor" ;
  slaett_nn_1_1_N = mkN "slätt" "slätter" ;
  slaettbygd_nn_1_1_N = mkN "slättbygd" "slättbygder" ;
  slaettmark_nn_1_1_N = mkN "slättmark" "slättmarker" ;
  slaattermaskin_nn_1_1_N = mkN "slåttermaskin" "slåttermaskiner" ;
  sloehet_nn_1_1_N = mkN "slöhet" "slöheter" ;
  sloejd_nn_1_1_N = mkN "slöjd" "slöjder" ;
  sloejdebatt_nn_1_1_N = mkN "slöjdebatt" "slöjdebatter" ;
  smak_nn_1_N = mkN "smak" "smaker" ;
  smakfullhet_nn_1_N = mkN "smakfullhet" "smakfullheter" ;
  smaklighet_nn_1_N = mkN "smaklighet" "smakligheter" ;
  smakloeshet_nn_1_1_N = mkN "smaklöshet" "smaklösheter" ;
  smakpanel_nn_1_N = mkN "smakpanel" "smakpaneler" ;
  smaksak_nn_1_N = mkN "smaksak" "smaksaker" ;
  smakupplevelse_nn_1_N = mkN "smakupplevelse" "smakupplevelser" ;
  smalfilm_nn_1_N = mkN "smalfilm" "smalfilmer" ;
  smaragd_nn_1_N = mkN "smaragd" "smaragder" ;
  smarthet_nn_1_N = mkN "smarthet" "smartheter" ;
  smaskighet_nn_1_N = mkN "smaskighet" "smaskigheter" ;
  smekmaanad_nn_1_1_N = mkN "smekmånad" "smekmånader" ;
  smet_nn_1_N = mkN "smet" "smeter" ;
  sminkoer_nn_1_1_N = mkN "sminkör" "sminkörer" ;
  smittskyddsmyndighet_nn_1_N = mkN "smittskyddsmyndighet" "smittskyddsmyndigheter" ;
  smuggelcigarett_nn_1_N = mkN "smuggelcigarett" "smuggelcigaretter" ;
  smycketyp_nn_1_N = mkN "smycketyp" "smycketyper" ;
  smaedebild_nn_1_1_N = mkN "smädebild" "smädebilder" ;
  smaedelse_nn_1_1_N = mkN "smädelse" "smädelser" ;
  smaedeskrift_nn_1_1_N = mkN "smädeskrift" "smädeskrifter" ;
  smaedlighet_nn_1_1_N = mkN "smädlighet" "smädligheter" ;
  smaellkaramell_nn_1_1_N = mkN "smällkaramell" "smällkarameller" ;
  smaeltentalpitet_nn_1_1_N = mkN "smältentalpitet" "smältentalpiteter" ;
  smaeltpunkt_nn_1_1_N = mkN "smältpunkt" "smältpunkter" ;
  smaertattack_nn_1_1_N = mkN "smärtattack" "smärtattacker" ;
  smaertfoernimmelse_nn_1_1_N = mkN "smärtförnimmelse" "smärtförnimmelser" ;
  smaertpunkt_nn_1_1_N = mkN "smärtpunkt" "smärtpunkter" ;
  smaertupplevelse_nn_1_1_N = mkN "smärtupplevelse" "smärtupplevelser" ;
  smaaaktighet_nn_1_1_N = mkN "småaktighet" "småaktigheter" ;
  smaabarnsaktighet_nn_1_1_N = mkN "småbarnsaktighet" "småbarnsaktigheter" ;
  smaabarnsfamilj_nn_1_1_N = mkN "småbarnsfamilj" "småbarnsfamiljer" ;
  smaabonde_nn_1_1_N = mkN "småbonde" "småbönder" ;
  smaaborgerlighet_nn_1_1_N = mkN "småborgerlighet" "småborgerligheter" ;
  smaadjursklinik_nn_1_1_N = mkN "smådjursklinik" "smådjurskliniker" ;
  smaagrisdoedlighet_nn_1_1_N = mkN "smågrisdödlighet" "smågrisdödligheter" ;
  smaahet_nn_1_1_N = mkN "småhet" "småheter" ;
  smaaplanet_nn_1_1_N = mkN "småplanet" "småplaneter" ;
  smaarolighet_nn_1_1_N = mkN "smårolighet" "småroligheter" ;
  smaaraett_nn_1_1_N = mkN "smårätt" "smårätter" ;
  smaasak_nn_1_1_N = mkN "småsak" "småsaker" ;
  smaastad_nn_1_1_N = mkN "småstad" "småstäder" ;
  smaastadstjej_nn_1_1_N = mkN "småstadstjej" "småstadstjejer" ;
  smaatjej_nn_1_1_N = mkN "småtjej" "småtjejer" ;
  smaattighet_nn_1_1_N = mkN "småttighet" "småttigheter" ;
  smoerbakelse_nn_1_1_N = mkN "smörbakelse" "smörbakelser" ;
  smoerdegspastej_nn_1_1_N = mkN "smördegspastej" "smördegspastejer" ;
  smoerjelse_nn_1_1_N = mkN "smörjelse" "smörjelser" ;
  snabbguide_nn_1_N = mkN "snabbguide" "snabbguider" ;
  snabbhet_nn_1_N = mkN "snabbhet" "snabbheter" ;
  snabbkoepsbutik_nn_1_1_N = mkN "snabbköpsbutik" "snabbköpsbutiker" ;
  snabbreparation_nn_1_N = mkN "snabbreparation" "snabbreparationer" ;
  snabbtaagslinje_nn_1_1_N = mkN "snabbtågslinje" "snabbtågslinjer" ;
  snabbversion_nn_1_N = mkN "snabbversion" "snabbversioner" ;
  snabelsko_nn_1_N = mkN "snabelsko" "snabelskor" ;
  snackbar_nn_1_N = mkN "snackbar" "snackbarer" ;
  snaskighet_nn_1_N = mkN "snaskighet" "snaskigheter" ;
  snatterand_nn_1_N = mkN "snatterand" "snatteränder" ;
  snedhet_nn_1_N = mkN "snedhet" "snedheter" ;
  snedprofil_nn_1_N = mkN "snedprofil" "snedprofiler" ;
  snickarverkstad_nn_1_N = mkN "snickarverkstad" "snickarverkstäder" ;
  snickerifabrik_nn_1_N = mkN "snickerifabrik" "snickerifabriker" ;
  snilj_nn_1_N = mkN "snilj" "sniljer" ;
  snillrikhet_nn_1_N = mkN "snillrikhet" "snillrikheter" ;
  snittmaengd_nn_1_1_N = mkN "snittmängd" "snittmängder" ;
  snurrfaatoelj_nn_1_1_N = mkN "snurrfåtölj" "snurrfåtöljer" ;
  snurrighet_nn_1_N = mkN "snurrighet" "snurrigheter" ;
  snuskighet_nn_1_N = mkN "snuskighet" "snuskigheter" ;
  snyftventil_nn_1_N = mkN "snyftventil" "snyftventiler" ;
  snaeckart_nn_1_1_N = mkN "snäckart" "snäckarter" ;
  snaellhet_nn_1_1_N = mkN "snällhet" "snällheter" ;
  snaerjvaevnad_nn_1_1_N = mkN "snärjvävnad" "snärjvävnader" ;
  snoealg_nn_1_1_N = mkN "snöalg" "snöalger" ;
  snoeblindhet_nn_1_1_N = mkN "snöblindhet" "snöblindheter" ;
  snoedraekt_nn_1_1_N = mkN "snödräkt" "snödräkter" ;
  snoeflingedekoration_nn_1_1_N = mkN "snöflingedekoration" "snöflingedekorationer" ;
  snoekanon_nn_1_1_N = mkN "snökanon" "snökanoner" ;
  snoeregion_nn_1_1_N = mkN "snöregion" "snöregioner" ;
  snoersko_nn_1_1_N = mkN "snörsko" "snörskor" ;
  snoerstart_nn_1_1_N = mkN "snörstart" "snörstarter" ;
  snoesko_nn_1_1_N = mkN "snösko" "snöskor" ;
  socialassistent_nn_1_N = mkN "socialassistent" "socialassistenter" ;
  socialavgift_nn_1_N = mkN "socialavgift" "socialavgifter" ;
  socialbidragskostnad_nn_1_N = mkN "socialbidragskostnad" "socialbidragskostnader" ;
  socialgrupp_nn_1_N = mkN "socialgrupp" "socialgrupper" ;
  socialisation_nn_1_N = mkN "socialisation" "socialisationer" ;
  socialitet_nn_1_N = mkN "socialitet" "socialiteter" ;
  socialliberal_nn_1_N = mkN "socialliberal" "socialliberaler" ;
  socialloen_nn_1_1_N = mkN "sociallön" "sociallöner" ;
  socialnaemnd_nn_1_1_N = mkN "socialnämnd" "socialnämnder" ;
  socialvetenskap_nn_1_N = mkN "socialvetenskap" "socialvetenskaper" ;
  societet_nn_1_N = mkN "societet" "societeter" ;
  societetsfotograf_nn_1_N = mkN "societetsfotograf" "societetsfotografer" ;
  sociolekt_nn_1_N = mkN "sociolekt" "sociolekter" ;
  socionom_nn_1_N = mkN "socionom" "socionomer" ;
  sociopat_nn_1_N = mkN "sociopat" "sociopater" ;
  sockendraekt_nn_1_1_N = mkN "sockendräkt" "sockendräkter" ;
  sockerart_nn_1_N = mkN "sockerart" "sockerarter" ;
  sockerbetssaft_nn_1_N = mkN "sockerbetssaft" "sockerbetssafter" ;
  sockerglasyr_nn_1_N = mkN "sockerglasyr" "sockerglasyrer" ;
  sockerhalt_nn_1_N = mkN "sockerhalt" "sockerhalter" ;
  sockertaang_nn_1_1_N = mkN "sockertång" "sockertänger" ;
  sodahalt_nn_1_N = mkN "sodahalt" "sodahalter" ;
  soffgrupp_nn_1_N = mkN "soffgrupp" "soffgrupper" ;
  softballplan_nn_1_N = mkN "softballplan" "softballplaner" ;
  solanin_nn_1_N = mkN "solanin" "solaniner" ;
  solblindhet_nn_1_N = mkN "solblindhet" "solblindheter" ;
  solcell_nn_1_N = mkN "solcell" "solceller" ;
  solcellspanel_nn_1_N = mkN "solcellspanel" "solcellspaneler" ;
  soldat_nn_1_N = mkN "soldat" "soldater" ;
  soldenaer_nn_1_1_N = mkN "soldenär" "soldenärer" ;
  soldnaer_nn_1_1_N = mkN "soldnär" "soldnärer" ;
  soldraekt_nn_1_1_N = mkN "soldräkt" "soldräkter" ;
  solennitet_nn_1_N = mkN "solennitet" "solenniteter" ;
  solfatar_nn_1_N = mkN "solfatar" "solfatarer" ;
  solflod_nn_1_N = mkN "solflod" "solfloder" ;
  solfoermoerkelse_nn_1_1_N = mkN "solförmörkelse" "solförmörkelser" ;
  solidaritet_nn_1_N = mkN "solidaritet" "solidariteter" ;
  solidaritetsaatgaerd_nn_1_1_N = mkN "solidaritetsåtgärd" "solidaritetsåtgärder" ;
  soliditet_nn_1_N = mkN "soliditet" "soliditeter" ;
  solkatt_nn_1_N = mkN "solkatt" "solkatter" ;
  solkraem_nn_1_1_N = mkN "solkräm" "solkrämer" ;
  solmisation_nn_1_N = mkN "solmisation" "solmisationer" ;
  solpanel_nn_1_N = mkN "solpanel" "solpaneler" ;
  solroerelse_nn_1_1_N = mkN "solrörelse" "solrörelser" ;
  solution_nn_1_N = mkN "solution" "solutioner" ;
  solventil_nn_1_N = mkN "solventil" "solventiler" ;
  sommarbostad_nn_1_N = mkN "sommarbostad" "sommarbostäder" ;
  sommarfrisyr_nn_1_N = mkN "sommarfrisyr" "sommarfrisyrer" ;
  sommarkostym_nn_1_N = mkN "sommarkostym" "sommarkostymer" ;
  sommarledighet_nn_1_N = mkN "sommarledighet" "sommarledigheter" ;
  sommarvistelse_nn_1_N = mkN "sommarvistelse" "sommarvistelser" ;
  son_nn_1_N = mkN "son" "söner" ;
  sonat_nn_1_N = mkN "sonat" "sonater" ;
  sond_nn_1_N = mkN "sond" "sonder" ;
  sonett_nn_1_N = mkN "sonett" "sonetter" ;
  sonoritet_nn_1_N = mkN "sonoritet" "sonoriteter" ;
  sonson_nn_1_N = mkN "sonson" "sonsöner" ;
  sopstation_nn_1_N = mkN "sopstation" "sopstationer" ;
  sorb_nn_1_N = mkN "sorb" "sorber" ;
  sorgdraekt_nn_1_1_N = mkN "sorgdräkt" "sorgdräkter" ;
  sorgeakt_nn_1_N = mkN "sorgeakt" "sorgeakter" ;
  sorgestund_nn_1_N = mkN "sorgestund" "sorgestunder" ;
  sorgfaerg_nn_1_1_N = mkN "sorgfärg" "sorgfärger" ;
  sorgkant_nn_1_N = mkN "sorgkant" "sorgkanter" ;
  sorglighet_nn_1_N = mkN "sorglighet" "sorgligheter" ;
  sorgloeshet_nn_1_1_N = mkN "sorglöshet" "sorglösheter" ;
  sort_nn_1_N = mkN "sort" "sorter" ;
  sotbrand_nn_1_N = mkN "sotbrand" "sotbränder" ;
  souschef_nn_1_N = mkN "souschef" "souschefer" ;
  souterrainbyggnad_nn_1_N = mkN "souterrainbyggnad" "souterrainbyggnader" ;
  souterraengbyggnad_nn_1_1_N = mkN "souterrängbyggnad" "souterrängbyggnader" ;
  souvenir_nn_1_N = mkN "souvenir" "souvenirer" ;
  sovjet_nn_1_N = mkN "sovjet" "sovjeter" ;
  sovjetrepublik_nn_1_N = mkN "sovjetrepublik" "sovjetrepubliker" ;
  sovstad_nn_1_N = mkN "sovstad" "sovstäder" ;
  sovvagnsbiljett_nn_1_N = mkN "sovvagnsbiljett" "sovvagnsbiljetter" ;
  spalt_nn_1_N = mkN "spalt" "spalter" ;
  spaltfyllnad_nn_1_N = mkN "spaltfyllnad" "spaltfyllnader" ;
  spaningspatrull_nn_1_N = mkN "spaningspatrull" "spaningspatruller" ;
  spanjolett_nn_1_N = mkN "spanjolett" "spanjoletter" ;
  sparbank_nn_1_N = mkN "sparbank" "sparbanker" ;
  sparform_nn_1_N = mkN "sparform" "sparformer" ;
  sparkdraekt_nn_1_1_N = mkN "sparkdräkt" "sparkdräkter" ;
  spasm_nn_1_N = mkN "spasm" "spasmer" ;
  spasticitet_nn_1_N = mkN "spasticitet" "spasticiteter" ;
  spattighet_nn_1_N = mkN "spattighet" "spattigheter" ;
  speceriaffaer_nn_1_1_N = mkN "speceriaffär" "speceriaffärer" ;
  specialitet_nn_1_N = mkN "specialitet" "specialiteter" ;
  specie_nn_1_N = mkN "specie" "specier" ;
  specifikation_nn_1_N = mkN "specifikation" "specifikationer" ;
  spedition_nn_1_N = mkN "spedition" "speditioner" ;
  speditoer_nn_1_1_N = mkN "speditör" "speditörer" ;
  spefullhet_nn_1_N = mkN "spefullhet" "spefullheter" ;
  spegelbild_nn_1_N = mkN "spegelbild" "spegelbilder" ;
  spektralapparat_nn_1_N = mkN "spektralapparat" "spektralapparater" ;
  spektrallinje_nn_1_N = mkN "spektrallinje" "spektrallinjer" ;
  spektrograf_nn_1_N = mkN "spektrograf" "spektrografer" ;
  spekulation_nn_1_N = mkN "spekulation" "spekulationer" ;
  spelautomat_nn_1_N = mkN "spelautomat" "spelautomater" ;
  spelbutik_nn_1_N = mkN "spelbutik" "spelbutiker" ;
  spelfilm_nn_1_N = mkN "spelfilm" "spelfilmer" ;
  spelkonsol_nn_1_N = mkN "spelkonsol" "spelkonsoler" ;
  spelmark_nn_1_N = mkN "spelmark" "spelmarker" ;
  spelplan_nn_1_N = mkN "spelplan" "spelplaner" ;
  spermabank_nn_1_N = mkN "spermabank" "spermabanker" ;
  spermakvalitet_nn_1_N = mkN "spermakvalitet" "spermakvaliteter" ;
  spermie_nn_1_N = mkN "spermie" "spermier" ;
  spermiemitokondrie_nn_1_N = mkN "spermiemitokondrie" "spermiemitokondrier" ;
  spermiemodercell_nn_1_N = mkN "spermiemodercell" "spermiemoderceller" ;
  spetsfundighet_nn_1_N = mkN "spetsfundighet" "spetsfundigheter" ;
  spetsgardin_nn_1_N = mkN "spetsgardin" "spetsgardiner" ;
  spetsighet_nn_2_N = mkN "spetsighet" "spetsigheter" ;
  spetstaang_nn_1_1_N = mkN "spetstång" "spetstänger" ;
  spiksko_nn_1_N = mkN "spiksko" "spikskor" ;
  spinalganglie_nn_1_N = mkN "spinalganglie" "spinalganglier" ;
  spindelart_nn_1_N = mkN "spindelart" "spindelarter" ;
  spinell_nn_1_N = mkN "spinell" "spineller" ;
  spinett_nn_1_N = mkN "spinett" "spinetter" ;
  spionageanklagelse_nn_1_N = mkN "spionageanklagelse" "spionageanklagelser" ;
  spionanklagelse_nn_1_N = mkN "spionanklagelse" "spionanklagelser" ;
  spiral_nn_1_N = mkN "spiral" "spiraler" ;
  spiralroerelse_nn_1_1_N = mkN "spiralrörelse" "spiralrörelser" ;
  spirellakorsett_nn_1_N = mkN "spirellakorsett" "spirellakorsetter" ;
  spirill_nn_1_N = mkN "spirill" "spiriller" ;
  spiritualitet_nn_1_N = mkN "spiritualitet" "spiritualiteter" ;
  spiroket_nn_1_N = mkN "spiroket" "spiroketer" ;
  splatterfilm_nn_1_N = mkN "splatterfilm" "splatterfilmer" ;
  splitterbomb_nn_1_N = mkN "splitterbomb" "splitterbomber" ;
  spontanitet_nn_1_N = mkN "spontanitet" "spontaniteter" ;
  sportaffaer_nn_1_1_N = mkN "sportaffär" "sportaffärer" ;
  sportchef_nn_1_N = mkN "sportchef" "sportchefer" ;
  sportfiskemetod_nn_1_N = mkN "sportfiskemetod" "sportfiskemetoder" ;
  sportform_nn_1_N = mkN "sportform" "sportformer" ;
  sportlegend_nn_1_N = mkN "sportlegend" "sportlegender" ;
  sportmodell_nn_1_N = mkN "sportmodell" "sportmodeller" ;
  sportprestation_nn_1_N = mkN "sportprestation" "sportprestationer" ;
  sprayburkskonstnaer_nn_1_1_N = mkN "sprayburkskonstnär" "sprayburkskonstnärer" ;
  sprej_nn_1_N = mkN "sprej" "sprejer" ;
  spretighet_nn_1_N = mkN "spretighet" "spretigheter" ;
  spridningseffekt_nn_1_N = mkN "spridningseffekt" "spridningseffekter" ;
  springstilett_nn_1_N = mkN "springstilett" "springstiletter" ;
  springvikarie_nn_1_N = mkN "springvikarie" "springvikarier" ;
  spritdryck_nn_1_N = mkN "spritdryck" "spritdrycker" ;
  sprithalt_nn_1_N = mkN "sprithalt" "sprithalter" ;
  spritraettighet_nn_1_1_N = mkN "spriträttighet" "spriträttigheter" ;
  spraengaemnespatron_nn_1_1_N = mkN "sprängämnespatron" "sprängämnespatroner" ;
  spraakbank_nn_1_1_N = mkN "språkbank" "språkbanker" ;
  spraakbarriaer_nn_1_1_N = mkN "språkbarriär" "språkbarriärer" ;
  spraakdraekt_nn_1_1_N = mkN "språkdräkt" "språkdräkter" ;
  spraakfamilj_nn_1_1_N = mkN "språkfamilj" "språkfamiljer" ;
  spraakfilosof_nn_1_1_N = mkN "språkfilosof" "språkfilosofer" ;
  spraakform_nn_1_1_N = mkN "språkform" "språkformer" ;
  spraakfaerdighet_nn_1_1_N = mkN "språkfärdighet" "språkfärdigheter" ;
  spraakgrupp_nn_1_1_N = mkN "språkgrupp" "språkgrupper" ;
  spraakkontrollant_nn_1_1_N = mkN "språkkontrollant" "språkkontrollanter" ;
  spraakkunskap_nn_1_1_N = mkN "språkkunskap" "språkkunskaper" ;
  spraaklektion_nn_1_1_N = mkN "språklektion" "språklektioner" ;
  spraaklighet_nn_1_1_N = mkN "språklighet" "språkligheter" ;
  spraakriktighet_nn_1_1_N = mkN "språkriktighet" "språkriktigheter" ;
  spraakstrid_nn_1_1_N = mkN "språkstrid" "språkstrider" ;
  spraakteknik_nn_1_1_N = mkN "språkteknik" "språktekniker" ;
  spraakvetenskap_nn_1_1_N = mkN "språkvetenskap" "språkvetenskaper" ;
  spurt_nn_1_N = mkN "spurt" "spurter" ;
  spydighet_nn_1_N = mkN "spydighet" "spydigheter" ;
  spaedbarnsdoedlighet_nn_1_1_N = mkN "spädbarnsdödlighet" "spädbarnsdödligheter" ;
  spaennvidd_nn_1_1_N = mkN "spännvidd" "spännvidder" ;
  spaerrballong_nn_1_1_N = mkN "spärrballong" "spärrballonger" ;
  spaerrlinje_nn_1_1_N = mkN "spärrlinje" "spärrlinjer" ;
  spaerrvakt_nn_1_1_N = mkN "spärrvakt" "spärrvakter" ;
  spaanad_nn_1_1_N = mkN "spånad" "spånader" ;
  spaarvidd_nn_1_1_N = mkN "spårvidd" "spårvidder" ;
  spaarvaegschef_nn_1_1_N = mkN "spårvägschef" "spårvägschefer" ;
  spoekbild_nn_1_1_N = mkN "spökbild" "spökbilder" ;
  spoekgestalt_nn_1_1_N = mkN "spökgestalt" "spökgestalter" ;
  spoekstad_nn_1_1_N = mkN "spökstad" "spökstäder" ;
  stab_nn_1_N = mkN "stab" "staber" ;
  stabilitet_nn_1_N = mkN "stabilitet" "stabiliteter" ;
  stabilitetspakt_nn_1_N = mkN "stabilitetspakt" "stabilitetspakter" ;
  stabschef_nn_1_N = mkN "stabschef" "stabschefer" ;
  stad_nn_1_N = mkN "stad" "städer" ;
  stadfaestelse_nn_1_1_N = mkN "stadfästelse" "stadfästelser" ;
  stadkant_nn_1_N = mkN "stadkant" "stadkanter" ;
  stadsarkitekt_nn_1_N = mkN "stadsarkitekt" "stadsarkitekter" ;
  stadsbebyggelse_nn_1_N = mkN "stadsbebyggelse" "stadsbebyggelser" ;
  stadsbild_nn_1_N = mkN "stadsbild" "stadsbilder" ;
  stadsbo_nn_1_N = mkN "stadsbo" "stadsbor" ;
  stadsmission_nn_1_N = mkN "stadsmission" "stadsmissioner" ;
  stadspark_nn_1_N = mkN "stadspark" "stadsparker" ;
  stadssilhuett_nn_1_N = mkN "stadssilhuett" "stadssilhuetter" ;
  stadsstat_nn_1_N = mkN "stadsstat" "stadsstater" ;
  stafett_nn_1_N = mkN "stafett" "stafetter" ;
  stafylokock_nn_1_N = mkN "stafylokock" "stafylokocker" ;
  stagflation_nn_1_N = mkN "stagflation" "stagflationer" ;
  stagnation_nn_1_N = mkN "stagnation" "stagnationer" ;
  stamaktie_nn_1_N = mkN "stamaktie" "stamaktier" ;
  stamcell_nn_1_N = mkN "stamcell" "stamceller" ;
  stamkund_nn_1_N = mkN "stamkund" "stamkunder" ;
  stamlinje_nn_1_N = mkN "stamlinje" "stamlinjer" ;
  stamort_nn_1_N = mkN "stamort" "stamorter" ;
  stamton_nn_1_N = mkN "stamton" "stamtoner" ;
  standard_nn_1_N = mkN "standard" "standarder" ;
  standardavvikelse_nn_1_N = mkN "standardavvikelse" "standardavvikelser" ;
  standardspraaklighet_nn_1_1_N = mkN "standardspråklighet" "standardspråkligheter" ;
  stank_nn_1_N = mkN "stank" "stanker" ;
  stapelstad_nn_1_N = mkN "stapelstad" "stapelstäder" ;
  starroperation_nn_1_N = mkN "starroperation" "starroperationer" ;
  start_nn_1_N = mkN "start" "starter" ;
  startavgift_nn_1_N = mkN "startavgift" "startavgifter" ;
  startlinje_nn_1_N = mkN "startlinje" "startlinjer" ;
  startpunkt_nn_1_N = mkN "startpunkt" "startpunkter" ;
  stat_nn_1_N = mkN "stat" "stater" ;
  station_nn_1_N = mkN "station" "stationer" ;
  stationsbyggnad_nn_1_N = mkN "stationsbyggnad" "stationsbyggnader" ;
  statistik_nn_1_N = mkN "statistik" "statistiker" ;
  statministerkandidat_nn_1_N = mkN "statministerkandidat" "statministerkandidater" ;
  statsangelaegenhet_nn_1_1_N = mkN "statsangelägenhet" "statsangelägenheter" ;
  statsapparat_nn_1_N = mkN "statsapparat" "statsapparater" ;
  statsbankett_nn_1_N = mkN "statsbankett" "statsbanketter" ;
  statschef_nn_1_N = mkN "statschef" "statschefer" ;
  statshemlighet_nn_1_N = mkN "statshemlighet" "statshemligheter" ;
  statskupp_nn_1_N = mkN "statskupp" "statskupper" ;
  statsmakt_nn_2_N = mkN "statsmakt" "statsmakter" ;
  statsobligation_nn_1_N = mkN "statsobligation" "statsobligationer" ;
  statsreligion_nn_1_N = mkN "statsreligion" "statsreligioner" ;
  statsskuld_nn_1_N = mkN "statsskuld" "statsskulder" ;
  statsverksproposition_nn_1_N = mkN "statsverksproposition" "statsverkspropositioner" ;
  statsvetenskap_nn_1_N = mkN "statsvetenskap" "statsvetenskaper" ;
  statyett_nn_1_N = mkN "statyett" "statyetter" ;
  stav_nn_2_N = mkN "stav" "stäver" ;
  stavelse_nn_1_N = mkN "stavelse" "stavelser" ;
  stavelseskrift_nn_1_N = mkN "stavelseskrift" "stavelseskrifter" ;
  stavningsreform_nn_1_N = mkN "stavningsreform" "stavningsreformer" ;
  stearindoft_nn_1_N = mkN "stearindoft" "stearindofter" ;
  steeplechase_nn_1_N = mkN "steeplechase" "steeplechaser" ;
  stelbenthet_nn_1_N = mkN "stelbenthet" "stelbentheter" ;
  stelhet_nn_1_N = mkN "stelhet" "stelheter" ;
  stenattack_nn_1_N = mkN "stenattack" "stenattacker" ;
  stencil_nn_1_N = mkN "stencil" "stenciler" ;
  stenfrukt_nn_1_N = mkN "stenfrukt" "stenfrukter" ;
  stenograf_nn_1_N = mkN "stenograf" "stenografer" ;
  stenotop_nn_1_N = mkN "stenotop" "stenotoper" ;
  stereobild_nn_1_N = mkN "stereobild" "stereobilder" ;
  sterilitet_nn_1_N = mkN "sterilitet" "steriliteter" ;
  sternalpunktion_nn_1_N = mkN "sternalpunktion" "sternalpunktioner" ;
  stickkontakt_nn_1_N = mkN "stickkontakt" "stickkontakter" ;
  stickmaskin_nn_1_N = mkN "stickmaskin" "stickmaskiner" ;
  stickreplik_nn_1_N = mkN "stickreplik" "stickrepliker" ;
  stiftelse_nn_1_N = mkN "stiftelse" "stiftelser" ;
  stiftsadjunkt_nn_1_N = mkN "stiftsadjunkt" "stiftsadjunkter" ;
  stiftsstad_nn_1_N = mkN "stiftsstad" "stiftsstäder" ;
  stiftsstyrelse_nn_1_N = mkN "stiftsstyrelse" "stiftsstyrelser" ;
  stifttand_nn_1_N = mkN "stifttand" "stifttänder" ;
  stigarcentral_nn_1_N = mkN "stigarcentral" "stigarcentraler" ;
  stigort_nn_1_N = mkN "stigort" "stigorter" ;
  stilart_nn_1_N = mkN "stilart" "stilarter" ;
  stilett_nn_1_N = mkN "stilett" "stiletter" ;
  stilfullhet_nn_1_N = mkN "stilfullhet" "stilfullheter" ;
  stillbild_nn_1_N = mkN "stillbild" "stillbilder" ;
  stillfilm_nn_1_N = mkN "stillfilm" "stillfilmer" ;
  stillhet_nn_1_N = mkN "stillhet" "stillheter" ;
  stilloeshet_nn_1_1_N = mkN "stillöshet" "stillösheter" ;
  stilsort_nn_1_N = mkN "stilsort" "stilsorter" ;
  stimulansaatgaerd_nn_1_1_N = mkN "stimulansåtgärd" "stimulansåtgärder" ;
  stimuleringsaatgaerd_nn_1_1_N = mkN "stimuleringsåtgärd" "stimuleringsåtgärder" ;
  stingslighet_nn_1_N = mkN "stingslighet" "stingsligheter" ;
  stinkbomb_nn_1_N = mkN "stinkbomb" "stinkbomber" ;
  stipendiat_nn_1_N = mkN "stipendiat" "stipendiater" ;
  stipulation_nn_1_N = mkN "stipulation" "stipulationer" ;
  stjaernarkitekt_nn_1_1_N = mkN "stjärnarkitekt" "stjärnarkitekter" ;
  stjaernassociation_nn_1_1_N = mkN "stjärnassociation" "stjärnassociationer" ;
  stjaernbild_nn_1_1_N = mkN "stjärnbild" "stjärnbilder" ;
  stjaernkonstellation_nn_1_1_N = mkN "stjärnkonstellation" "stjärnkonstellationer" ;
  stjaernmaalvakt_nn_1_1_N = mkN "stjärnmålvakt" "stjärnmålvakter" ;
  stjaerntriplett_nn_1_1_N = mkN "stjärntriplett" "stjärntripletter" ;
  stjaertand_nn_1_1_N = mkN "stjärtand" "stjärtänder" ;
  stjaertskulptoer_nn_1_1_N = mkN "stjärtskulptör" "stjärtskulptörer" ;
  stjaerttrakt_nn_1_1_N = mkN "stjärttrakt" "stjärttrakter" ;
  stoftmaengd_nn_1_1_N = mkN "stoftmängd" "stoftmängder" ;
  stollighet_nn_1_N = mkN "stollighet" "stolligheter" ;
  stolprad_nn_1_N = mkN "stolprad" "stolprader" ;
  stolpsko_nn_1_N = mkN "stolpsko" "stolpskor" ;
  stolsrad_nn_1_N = mkN "stolsrad" "stolsrader" ;
  stolthet_nn_1_N = mkN "stolthet" "stoltheter" ;
  storbonde_nn_1_N = mkN "storbonde" "storbönder" ;
  storbrand_nn_1_N = mkN "storbrand" "storbränder" ;
  store_nn_1_N = mkN "store" "storer" ;
  storfamilj_nn_1_N = mkN "storfamilj" "storfamiljer" ;
  storhet_nn_1_N = mkN "storhet" "storheter" ;
  storhetstid_nn_1_N = mkN "storhetstid" "storhetstider" ;
  storkommun_nn_1_N = mkN "storkommun" "storkommuner" ;
  stormakt_nn_1_N = mkN "stormakt" "stormakter" ;
  stormaktstid_nn_1_N = mkN "stormaktstid" "stormaktstider" ;
  stormarknad_nn_1_N = mkN "stormarknad" "stormarknader" ;
  stormflod_nn_1_N = mkN "stormflod" "stormfloder" ;
  stormogul_nn_1_N = mkN "stormogul" "stormoguler" ;
  stormpunkt_nn_1_N = mkN "stormpunkt" "stormpunkter" ;
  storstad_nn_1_N = mkN "storstad" "storstäder" ;
  storstadsbo_nn_1_N = mkN "storstadsbo" "storstadsbor" ;
  straffanstalt_nn_1_N = mkN "straffanstalt" "straffanstalter" ;
  straffexpedition_nn_1_N = mkN "straffexpedition" "straffexpeditioner" ;
  straffpaafoeljd_nn_1_1_N = mkN "straffpåföljd" "straffpåföljder" ;
  strafftid_nn_1_N = mkN "strafftid" "strafftider" ;
  stramalj_nn_1_N = mkN "stramalj" "stramaljer" ;
  strand_nn_1_N = mkN "strand" "stränder" ;
  strandkant_nn_1_N = mkN "strandkant" "strandkanter" ;
  strandlinje_nn_1_N = mkN "strandlinje" "strandlinjer" ;
  strandpromenad_nn_1_N = mkN "strandpromenad" "strandpromenader" ;
  strandstat_nn_1_N = mkN "strandstat" "strandstater" ;
  strandtomt_nn_1_N = mkN "strandtomt" "strandtomter" ;
  strandtyp_nn_1_N = mkN "strandtyp" "strandtyper" ;
  strandoert_nn_1_1_N = mkN "strandört" "strandörter" ;
  strangulation_nn_1_N = mkN "strangulation" "strangulationer" ;
  streckkod_nn_1_N = mkN "streckkod" "streckkoder" ;
  strejk_nn_1_N = mkN "strejk" "strejker" ;
  strejkvakt_nn_1_N = mkN "strejkvakt" "strejkvakter" ;
  streptokock_nn_1_N = mkN "streptokock" "streptokocker" ;
  streptomycin_nn_1_N = mkN "streptomycin" "streptomyciner" ;
  stretchnylon_nn_1_N = mkN "stretchnylon" "stretchnyloner" ;
  strid_nn_1_N = mkN "strid" "strider" ;
  stridighet_nn_1_N = mkN "stridighet" "stridigheter" ;
  stridsledningscentral_nn_1_N = mkN "stridsledningscentral" "stridsledningscentraler" ;
  stridsskrift_nn_1_N = mkN "stridsskrift" "stridsskrifter" ;
  stridszon_nn_1_N = mkN "stridszon" "stridszoner" ;
  stridsaatgaerd_nn_1_1_N = mkN "stridsåtgärd" "stridsåtgärder" ;
  stridulation_nn_1_N = mkN "stridulation" "stridulationer" ;
  striktion_nn_1_N = mkN "striktion" "striktioner" ;
  strippshow_nn_1_N = mkN "strippshow" "strippshower" ;
  strippstaang_nn_1_1_N = mkN "strippstång" "strippstänger" ;
  strof_nn_1_N = mkN "strof" "strofer" ;
  strukturarbetsloeshet_nn_1_1_N = mkN "strukturarbetslöshet" "strukturarbetslösheter" ;
  strukturmodell_nn_1_N = mkN "strukturmodell" "strukturmodeller" ;
  strulighet_nn_1_N = mkN "strulighet" "struligheter" ;
  strutsplym_nn_1_N = mkN "strutsplym" "strutsplymer" ;
  strykarkatt_nn_1_N = mkN "strykarkatt" "strykarkatter" ;
  straakkvartett_nn_1_1_N = mkN "stråkkvartett" "stråkkvartetter" ;
  straalningseffekt_nn_1_1_N = mkN "strålningseffekt" "strålningseffekter" ;
  straalningsegenskap_nn_1_1_N = mkN "strålningsegenskap" "strålningsegenskaper" ;
  straalsaekerhetsmyndighet_nn_1_1_N = mkN "strålsäkerhetsmyndighet" "strålsäkerhetsmyndigheter" ;
  stroekund_nn_1_1_N = mkN "strökund" "strökunder" ;
  stuck_nn_1_N = mkN "stuck" "stucker" ;
  stuckatoer_nn_1_1_N = mkN "stuckatör" "stuckatörer" ;
  student_nn_1_N = mkN "student" "studenter" ;
  studentkaar_nn_1_1_N = mkN "studentkår" "studentkårer" ;
  studentnation_nn_1_N = mkN "studentnation" "studentnationer" ;
  studentprenumeration_nn_1_N = mkN "studentprenumeration" "studentprenumerationer" ;
  studentrevolt_nn_1_N = mkN "studentrevolt" "studentrevolter" ;
  studentsaang_nn_1_1_N = mkN "studentsång" "studentsånger" ;
  studie_nn_1_N = mkN "studie" "studier" ;
  studiegrupp_nn_1_N = mkN "studiegrupp" "studiegrupper" ;
  studieskuld_nn_1_N = mkN "studieskuld" "studieskulder" ;
  studietid_nn_1_N = mkN "studietid" "studietider" ;
  studietradition_nn_1_N = mkN "studietradition" "studietraditioner" ;
  studio_nn_1_N = mkN "studio" "studior" ;
  stuff_nn_1_N = mkN "stuff" "stuffer" ;
  stumfilm_nn_1_N = mkN "stumfilm" "stumfilmer" ;
  stumhet_nn_1_N = mkN "stumhet" "stumheter" ;
  stund_nn_1_N = mkN "stund" "stunder" ;
  stupiditet_nn_1_N = mkN "stupiditet" "stupiditeter" ;
  stuproersmodell_nn_1_1_N = mkN "stuprörsmodell" "stuprörsmodeller" ;
  styggelse_nn_1_N = mkN "styggelse" "styggelser" ;
  stylobat_nn_1_N = mkN "stylobat" "stylobater" ;
  styrelse_nn_1_N = mkN "styrelse" "styrelser" ;
  styrelseform_nn_1_N = mkN "styrelseform" "styrelseformer" ;
  styrelseledamot_nn_1_N = mkN "styrelseledamot" "styrelseledamöter" ;
  styrlastighet_nn_1_N = mkN "styrlastighet" "styrlastigheter" ;
  styrstaang_nn_1_1_N = mkN "styrstång" "styrstänger" ;
  styvhet_nn_1_N = mkN "styvhet" "styvheter" ;
  styvmorsviol_nn_1_N = mkN "styvmorsviol" "styvmorsvioler" ;
  styvnad_nn_1_N = mkN "styvnad" "styvnader" ;
  styvson_nn_1_N = mkN "styvson" "styvsöner" ;
  staedambition_nn_1_1_N = mkN "städambition" "städambitioner" ;
  staemningsbild_nn_1_1_N = mkN "stämningsbild" "stämningsbilder" ;
  staempelavgift_nn_1_1_N = mkN "stämpelavgift" "stämpelavgifter" ;
  staeppantilop_nn_1_1_N = mkN "stäppantilop" "stäppantiloper" ;
  staalkonstruktion_nn_1_1_N = mkN "stålkonstruktion" "stålkonstruktioner" ;
  staandort_nn_1_1_N = mkN "ståndort" "ståndorter" ;
  staandpunkt_nn_1_1_N = mkN "ståndpunkt" "ståndpunkter" ;
  staandraett_nn_1_1_N = mkN "ståndrätt" "ståndrätter" ;
  staandscirkulation_nn_1_1_N = mkN "ståndscirkulation" "ståndscirkulationer" ;
  staandsperson_nn_1_1_N = mkN "ståndsperson" "ståndspersoner" ;
  staang_nn_1_1_N = mkN "stång" "stänger" ;
  stoedgrupp_nn_1_1_N = mkN "stödgrupp" "stödgrupper" ;
  stoedjecell_nn_1_1_N = mkN "stödjecell" "stödjeceller" ;
  stoedjepunkt_nn_1_1_N = mkN "stödjepunkt" "stödjepunkter" ;
  stoedjevaevnad_nn_1_1_N = mkN "stödjevävnad" "stödjevävnader" ;
  stoedaatgaerd_nn_1_1_N = mkN "stödåtgärd" "stödåtgärder" ;
  stoekighet_nn_1_1_N = mkN "stökighet" "stökigheter" ;
  stoeldraed_nn_1_1_N = mkN "stöldräd" "stöldräder" ;
  stoeratom_nn_1_1_N = mkN "störatom" "störatomer" ;
  stoertflod_nn_1_1_N = mkN "störtflod" "störtfloder" ;
  subaltern_nn_1_N = mkN "subaltern" "subalterner" ;
  subjektivitet_nn_1_N = mkN "subjektivitet" "subjektiviteter" ;
  subjunktion_nn_1_N = mkN "subjunktion" "subjunktioner" ;
  subkontinent_nn_1_N = mkN "subkontinent" "subkontinenter" ;
  sublimation_nn_1_N = mkN "sublimation" "sublimationer" ;
  subordination_nn_1_N = mkN "subordination" "subordinationer" ;
  subrett_nn_1_N = mkN "subrett" "subretter" ;
  subskribent_nn_1_N = mkN "subskribent" "subskribenter" ;
  substitution_nn_1_N = mkN "substitution" "substitutioner" ;
  subtilitet_nn_1_N = mkN "subtilitet" "subtiliteter" ;
  subtraktion_nn_1_N = mkN "subtraktion" "subtraktioner" ;
  subvention_nn_1_N = mkN "subvention" "subventioner" ;
  succession_nn_1_N = mkN "succession" "successioner" ;
  suddighet_nn_1_N = mkN "suddighet" "suddigheter" ;
  sufflett_nn_1_N = mkN "sufflett" "suffletter" ;
  suffloer_nn_1_1_N = mkN "sufflör" "sufflörer" ;
  suffragett_nn_1_N = mkN "suffragett" "suffragetter" ;
  suggestion_nn_1_N = mkN "suggestion" "suggestioner" ;
  sujett_nn_1_N = mkN "sujett" "sujetter" ;
  sulfatfabrik_nn_1_N = mkN "sulfatfabrik" "sulfatfabriker" ;
  sulfitfabrik_nn_1_N = mkN "sulfitfabrik" "sulfitfabriker" ;
  summerton_nn_1_N = mkN "summerton" "summertoner" ;
  sumpgasbrand_nn_1_N = mkN "sumpgasbrand" "sumpgasbränder" ;
  sumpmark_nn_1_N = mkN "sumpmark" "sumpmarker" ;
  sundae_nn_1_N = mkN "sundae" "sundaer" ;
  sunkighet_nn_1_N = mkN "sunkighet" "sunkigheter" ;
  superintendent_nn_1_N = mkN "superintendent" "superintendenter" ;
  supermakt_nn_1_N = mkN "supermakt" "supermakter" ;
  supermodell_nn_1_N = mkN "supermodell" "supermodeller" ;
  supernovaexplosion_nn_1_N = mkN "supernovaexplosion" "supernovaexplosioner" ;
  superposition_nn_1_N = mkN "superposition" "superpositioner" ;
  supplik_nn_1_N = mkN "supplik" "suppliker" ;
  supposition_nn_1_N = mkN "supposition" "suppositioner" ;
  supradental_nn_1_N = mkN "supradental" "supradentaler" ;
  surhet_nn_1_N = mkN "surhet" "surheter" ;
  surhetsgrad_nn_1_N = mkN "surhetsgrad" "surhetsgrader" ;
  suspension_nn_1_N = mkN "suspension" "suspensioner" ;
  sutenoer_nn_1_1_N = mkN "sutenör" "sutenörer" ;
  suterraengbyggnad_nn_1_1_N = mkN "suterrängbyggnad" "suterrängbyggnader" ;
  suvenir_nn_1_N = mkN "suvenir" "suvenirer" ;
  suveraenitet_nn_1_1_N = mkN "suveränitet" "suveräniteter" ;
  svaghet_nn_1_N = mkN "svaghet" "svagheter" ;
  svamlighet_nn_1_N = mkN "svamlighet" "svamligheter" ;
  svarskupong_nn_1_N = mkN "svarskupong" "svarskuponger" ;
  svartalf_nn_1_N = mkN "svartalf" "svartalfer" ;
  svartnad_nn_1_N = mkN "svartnad" "svartnader" ;
  svartsynthet_nn_1_N = mkN "svartsynthet" "svartsyntheter" ;
  svavelbakterie_nn_1_N = mkN "svavelbakterie" "svavelbakterier" ;
  svavelhalt_nn_1_N = mkN "svavelhalt" "svavelhalter" ;
  svavelsyrlighet_nn_1_N = mkN "svavelsyrlighet" "svavelsyrligheter" ;
  sved_nn_1_N = mkN "sved" "sveder" ;
  svekfullhet_nn_1_N = mkN "svekfullhet" "svekfullheter" ;
  svenskbygd_nn_1_N = mkN "svenskbygd" "svenskbygder" ;
  svenskhet_nn_1_N = mkN "svenskhet" "svenskheter" ;
  svensklektion_nn_1_N = mkN "svensklektion" "svensklektioner" ;
  svetsstaang_nn_1_1_N = mkN "svetsstång" "svetsstänger" ;
  svinaktighet_nn_1_N = mkN "svinaktighet" "svinaktigheter" ;
  svit_nn_1_N = mkN "svit" "sviter" ;
  svullnad_nn_1_N = mkN "svullnad" "svullnader" ;
  svulstighet_nn_1_N = mkN "svulstighet" "svulstigheter" ;
  svaeltkonstnaer_nn_1_1_N = mkN "svältkonstnär" "svältkonstnärer" ;
  svaeltloen_nn_1_1_N = mkN "svältlön" "svältlöner" ;
  svaermorsrabatt_nn_1_1_N = mkN "svärmorsrabatt" "svärmorsrabatter" ;
  svaerson_nn_1_1_N = mkN "svärson" "svärsöner" ;
  svaarbegriplighet_nn_1_1_N = mkN "svårbegriplighet" "svårbegripligheter" ;
  svaarfattlighet_nn_1_1_N = mkN "svårfattlighet" "svårfattligheter" ;
  svaarfoerklarlighet_nn_1_1_N = mkN "svårförklarlighet" "svårförklarligheter" ;
  svaarfoerstaaelighet_nn_1_1_N = mkN "svårförståelighet" "svårförståeligheter" ;
  svaarighet_nn_1_1_N = mkN "svårighet" "svårigheter" ;
  swimmingpool_nn_1_N = mkN "swimmingpool" "swimmingpooler" ;
  sydfrukt_nn_1_N = mkN "sydfrukt" "sydfrukter" ;
  sydpol_nn_1_N = mkN "sydpol" "sydpoler" ;
  sydstat_nn_1_N = mkN "sydstat" "sydstater" ;
  syfoereningstant_nn_1_1_N = mkN "syföreningstant" "syföreningstanter" ;
  sylf_nn_1_N = mkN "sylf" "sylfer" ;
  sylvesterbal_nn_1_N = mkN "sylvesterbal" "sylvesterbaler" ;
  symaskin_nn_1_N = mkN "symaskin" "symaskiner" ;
  symmetrilinje_nn_1_N = mkN "symmetrilinje" "symmetrilinjer" ;
  sympatisoer_nn_1_1_N = mkN "sympatisör" "sympatisörer" ;
  synapsbassaeng_nn_1_1_N = mkN "synapsbassäng" "synapsbassänger" ;
  synbild_nn_1_N = mkN "synbild" "synbilder" ;
  syncell_nn_1_N = mkN "syncell" "synceller" ;
  synd_nn_1_N = mkN "synd" "synder" ;
  syndabekaennelse_nn_1_1_N = mkN "syndabekännelse" "syndabekännelser" ;
  syndaflod_nn_1_N = mkN "syndaflod" "syndafloder" ;
  syndfrihet_nn_1_N = mkN "syndfrihet" "syndfriheter" ;
  synfoernimmelse_nn_1_1_N = mkN "synförnimmelse" "synförnimmelser" ;
  synkop_nn_1_N = mkN "synkop" "synkoper" ;
  synlighet_nn_1_N = mkN "synlighet" "synligheter" ;
  synnerv_nn_1_N = mkN "synnerv" "synnerver" ;
  synod_nn_1_N = mkN "synod" "synoder" ;
  synonymmaengd_nn_1_1_N = mkN "synonymmängd" "synonymmängder" ;
  synpunkt_nn_1_N = mkN "synpunkt" "synpunkter" ;
  syo_nn_1_N = mkN "syo" "syor" ;
  syokonsulent_nn_1_N = mkN "syokonsulent" "syokonsulenter" ;
  syracistern_nn_1_N = mkN "syracistern" "syracisterner" ;
  syreatom_nn_1_N = mkN "syreatom" "syreatomer" ;
  syreisotop_nn_1_N = mkN "syreisotop" "syreisotoper" ;
  syren_nn_1_N = mkN "syren" "syrener" ;
  syrgastub_nn_1_N = mkN "syrgastub" "syrgastuber" ;
  syrlighet_nn_2_N = mkN "syrlighet" "syrligheter" ;
  syrtut_nn_1_N = mkN "syrtut" "syrtuter" ;
  syskongrupp_nn_1_N = mkN "syskongrupp" "syskongrupper" ;
  sysselsaettningsgrad_nn_1_1_N = mkN "sysselsättningsgrad" "sysselsättningsgrader" ;
  systerson_nn_1_N = mkN "systerson" "systersöner" ;
  saedescell_nn_1_1_N = mkN "sädescell" "sädesceller" ;
  saekerhet_nn_1_1_N = mkN "säkerhet" "säkerheter" ;
  saekerhetsaspekt_nn_1_1_N = mkN "säkerhetsaspekt" "säkerhetsaspekter" ;
  saekerhetsbestaemmelse_nn_1_1_N = mkN "säkerhetsbestämmelse" "säkerhetsbestämmelser" ;
  saekerhetschef_nn_1_1_N = mkN "säkerhetschef" "säkerhetschefer" ;
  saekerhetsfoereskrift_nn_1_1_N = mkN "säkerhetsföreskrift" "säkerhetsföreskrifter" ;
  saekerhetstjaenst_nn_1_1_N = mkN "säkerhetstjänst" "säkerhetstjänster" ;
  saekerhetsvakt_nn_1_1_N = mkN "säkerhetsvakt" "säkerhetsvakter" ;
  saekerhetsventil_nn_1_1_N = mkN "säkerhetsventil" "säkerhetsventiler" ;
  saekerhetsaatgaerd_nn_1_1_N = mkN "säkerhetsåtgärd" "säkerhetsåtgärder" ;
  saellhet_nn_1_1_N = mkN "sällhet" "sällheter" ;
  saellsamhet_nn_1_1_N = mkN "sällsamhet" "sällsamheter" ;
  saellskapsdam_nn_1_1_N = mkN "sällskapsdam" "sällskapsdamer" ;
  saellsynthet_nn_1_1_N = mkN "sällsynthet" "sällsyntheter" ;
  saendningsraettighet_nn_1_1_N = mkN "sändningsrättighet" "sändningsrättigheter" ;
  saengkamrat_nn_1_1_N = mkN "sängkamrat" "sängkamrater" ;
  saengkant_nn_1_1_N = mkN "sängkant" "sängkanter" ;
  saenkningsreaktion_nn_1_1_N = mkN "sänkningsreaktion" "sänkningsreaktioner" ;
  saerbo_nn_1_1_N = mkN "särbo" "särbor" ;
  saeregenhet_nn_1_1_N = mkN "säregenhet" "säregenheter" ;
  saesong_nn_1_1_N = mkN "säsong" "säsonger" ;
  saesongsupptakt_nn_1_1_N = mkN "säsongsupptakt" "säsongsupptakter" ;
  saettmaskin_nn_1_1_N = mkN "sättmaskin" "sättmaskiner" ;
  saamaskin_nn_1_1_N = mkN "såmaskin" "såmaskiner" ;
  saangteknik_nn_1_1_N = mkN "sångteknik" "sångtekniker" ;
  saarbarhet_nn_1_1_N = mkN "sårbarhet" "sårbarheter" ;
  saarighet_nn_1_1_N = mkN "sårighet" "sårigheter" ;
  saarinfektion_nn_1_1_N = mkN "sårinfektion" "sårinfektioner" ;
  saarmarkoer_nn_1_1_N = mkN "sårmarkör" "sårmarkörer" ;
  saarnad_nn_1_1_N = mkN "sårnad" "sårnader" ;
  soekaktivitet_nn_1_1_N = mkN "sökaktivitet" "sökaktiviteter" ;
  soemnad_nn_1_1_N = mkN "sömnad" "sömnader" ;
  soemnsvaarighet_nn_1_1_N = mkN "sömnsvårighet" "sömnsvårigheter" ;
  soemntablett_nn_1_1_N = mkN "sömntablett" "sömntabletter" ;
  soemsmaan_nn_1_1_N = mkN "sömsmån" "sömsmåner" ;
  soendagsbokstav_nn_1_1_N = mkN "söndagsbokstav" "söndagsbokstäver" ;
  soetsak_nn_1_1_N = mkN "sötsak" "sötsaker" ;
  tabell_nn_1_N = mkN "tabell" "tabeller" ;
  taburett_nn_1_N = mkN "taburett" "taburetter" ;
  tacksamhet_nn_1_N = mkN "tacksamhet" "tacksamheter" ;
  tacksaegelse_nn_1_1_N = mkN "tacksägelse" "tacksägelser" ;
  tafflighet_nn_1_N = mkN "tafflighet" "taffligheter" ;
  takbrand_nn_1_N = mkN "takbrand" "takbränder" ;
  takhoejd_nn_1_1_N = mkN "takhöjd" "takhöjder" ;
  taklaekt_nn_1_1_N = mkN "takläkt" "takläkter" ;
  taksektion_nn_1_N = mkN "taksektion" "taksektioner" ;
  taksilhuett_nn_1_N = mkN "taksilhuett" "taksilhuetter" ;
  taktart_nn_1_N = mkN "taktart" "taktarter" ;
  taktloeshet_nn_1_1_N = mkN "taktlöshet" "taktlösheter" ;
  talakt_nn_1_N = mkN "talakt" "talakter" ;
  talang_nn_1_N = mkN "talang" "talanger" ;
  talangjakt_nn_1_N = mkN "talangjakt" "talangjakter" ;
  talangscout_nn_1_N = mkN "talangscout" "talangscouter" ;
  talapparat_nn_1_N = mkN "talapparat" "talapparater" ;
  talar_nn_1_N = mkN "talar" "talarer" ;
  talent_nn_1_N = mkN "talent" "talenter" ;
  talfoeljd_nn_1_1_N = mkN "talföljd" "talföljder" ;
  talklinik_nn_1_N = mkN "talklinik" "talkliniker" ;
  talkshow_nn_1_N = mkN "talkshow" "talkshower" ;
  talkoer_nn_1_1_N = mkN "talkör" "talkörer" ;
  tallinje_nn_1_N = mkN "tallinje" "tallinjer" ;
  tallriksventil_nn_1_N = mkN "tallriksventil" "tallriksventiler" ;
  tallsort_nn_1_N = mkN "tallsort" "tallsorter" ;
  talloert_nn_1_1_N = mkN "tallört" "tallörter" ;
  talong_nn_1_N = mkN "talong" "talonger" ;
  talpedagog_nn_1_N = mkN "talpedagog" "talpedagoger" ;
  talregistreringsapparat_nn_1_N = mkN "talregistreringsapparat" "talregistreringsapparater" ;
  talroll_nn_1_N = mkN "talroll" "talroller" ;
  talscen_nn_1_N = mkN "talscen" "talscener" ;
  talshow_nn_1_N = mkN "talshow" "talshower" ;
  talsituation_nn_1_N = mkN "talsituation" "talsituationer" ;
  talspraaklighet_nn_1_1_N = mkN "talspråklighet" "talspråkligheter" ;
  talsvaarighet_nn_1_1_N = mkN "talsvårighet" "talsvårigheter" ;
  tamarind_nn_1_N = mkN "tamarind" "tamarinder" ;
  tampong_nn_1_N = mkN "tampong" "tamponger" ;
  tamul_nn_1_N = mkN "tamul" "tamuler" ;
  tand_nn_1_N = mkN "tand" "tänder" ;
  tandborrmaskin_nn_1_N = mkN "tandborrmaskin" "tandborrmaskiner" ;
  tandboeld_nn_1_1_N = mkN "tandböld" "tandbölder" ;
  tandemmaskin_nn_1_N = mkN "tandemmaskin" "tandemmaskiner" ;
  tandemspermie_nn_1_N = mkN "tandemspermie" "tandemspermier" ;
  tandkonstruktion_nn_1_N = mkN "tandkonstruktion" "tandkonstruktioner" ;
  tandkraem_nn_1_1_N = mkN "tandkräm" "tandkrämer" ;
  tandlaekarpraktik_nn_1_1_N = mkN "tandläkarpraktik" "tandläkarpraktiker" ;
  tandlaekartid_nn_1_1_N = mkN "tandläkartid" "tandläkartider" ;
  tandloeshet_nn_2_1_N = mkN "tandlöshet" "tandlösheter" ;
  tandrad_nn_1_N = mkN "tandrad" "tandrader" ;
  tangent_nn_1_N = mkN "tangent" "tangenter" ;
  tangeringspunkt_nn_1_N = mkN "tangeringspunkt" "tangeringspunkter" ;
  tangorabatt_nn_1_N = mkN "tangorabatt" "tangorabatter" ;
  tankebyggnad_nn_1_N = mkN "tankebyggnad" "tankebyggnader" ;
  tankedikt_nn_1_N = mkN "tankedikt" "tankedikter" ;
  tankeform_nn_1_N = mkN "tankeform" "tankeformer" ;
  tankefrihet_nn_1_N = mkN "tankefrihet" "tankefriheter" ;
  tankekraft_nn_1_N = mkN "tankekraft" "tankekrafter" ;
  tankemetod_nn_1_N = mkN "tankemetod" "tankemetoder" ;
  tanketomhet_nn_1_N = mkN "tanketomhet" "tanketomheter" ;
  tanketradition_nn_1_N = mkN "tanketradition" "tanketraditioner" ;
  tankkapacitet_nn_1_N = mkN "tankkapacitet" "tankkapaciteter" ;
  tankloeshet_nn_1_1_N = mkN "tanklöshet" "tanklösheter" ;
  tankomat_nn_1_N = mkN "tankomat" "tankomater" ;
  tant_nn_1_N = mkN "tant" "tanter" ;
  tapet_nn_1_N = mkN "tapet" "tapeter" ;
  tapetbaard_nn_1_1_N = mkN "tapetbård" "tapetbårder" ;
  tapetvaad_nn_1_1_N = mkN "tapetvåd" "tapetvåder" ;
  tapisseriaffaer_nn_1_1_N = mkN "tapisseriaffär" "tapisseriaffärer" ;
  tapperhet_nn_1_N = mkN "tapperhet" "tapperheter" ;
  tapperhetsmedalj_nn_1_N = mkN "tapperhetsmedalj" "tapperhetsmedaljer" ;
  tappstation_nn_1_N = mkN "tappstation" "tappstationer" ;
  tariff_nn_1_N = mkN "tariff" "tariffer" ;
  tarmbakterie_nn_1_N = mkN "tarmbakterie" "tarmbakterier" ;
  tarmkanal_nn_1_N = mkN "tarmkanal" "tarmkanaler" ;
  tarmroerelse_nn_1_1_N = mkN "tarmrörelse" "tarmrörelser" ;
  tarmsaft_nn_1_N = mkN "tarmsaft" "tarmsafter" ;
  tartelett_nn_1_N = mkN "tartelett" "tarteletter" ;
  tartrat_nn_1_N = mkN "tartrat" "tartrater" ;
  tarvlighet_nn_1_N = mkN "tarvlighet" "tarvligheter" ;
  taskighet_nn_1_N = mkN "taskighet" "taskigheter" ;
  tassemark_nn_1_N = mkN "tassemark" "tassemarker" ;
  taxeringsassistent_nn_1_N = mkN "taxeringsassistent" "taxeringsassistenter" ;
  taxeringsenhet_nn_1_N = mkN "taxeringsenhet" "taxeringsenheter" ;
  taxeringsintendent_nn_1_N = mkN "taxeringsintendent" "taxeringsintendenter" ;
  taxeringslaengd_nn_1_1_N = mkN "taxeringslängd" "taxeringslängder" ;
  taxeringsmyndighet_nn_1_N = mkN "taxeringsmyndighet" "taxeringsmyndigheter" ;
  taxeringsnaemnd_nn_1_1_N = mkN "taxeringsnämnd" "taxeringsnämnder" ;
  taxikund_nn_1_N = mkN "taxikund" "taxikunder" ;
  taxistation_nn_1_N = mkN "taxistation" "taxistationer" ;
  tazett_nn_1_N = mkN "tazett" "tazetter" ;
  teamwork_nn_1_N = mkN "teamwork" "teamworker" ;
  teaterbiljett_nn_1_N = mkN "teaterbiljett" "teaterbiljetter" ;
  teaterchef_nn_1_N = mkN "teaterchef" "teaterchefer" ;
  teaterdebatt_nn_1_N = mkN "teaterdebatt" "teaterdebatter" ;
  teaterdekoration_nn_1_N = mkN "teaterdekoration" "teaterdekorationer" ;
  teatereffekt_nn_1_N = mkN "teatereffekt" "teatereffekter" ;
  teatergrupp_nn_1_N = mkN "teatergrupp" "teatergrupper" ;
  teaterloge_nn_1_N = mkN "teaterloge" "teaterloger" ;
  teaterroll_nn_1_N = mkN "teaterroll" "teaterroller" ;
  teaterscen_nn_1_N = mkN "teaterscen" "teaterscener" ;
  tegelbyggnad_nn_1_N = mkN "tegelbyggnad" "tegelbyggnader" ;
  tegelsilhuett_nn_1_N = mkN "tegelsilhuett" "tegelsilhuetter" ;
  tein_nn_1_N = mkN "tein" "teiner" ;
  teknikalitet_nn_1_N = mkN "teknikalitet" "teknikaliteter" ;
  teknokrat_nn_1_N = mkN "teknokrat" "teknokrater" ;
  teleavgift_nn_1_N = mkN "teleavgift" "teleavgifter" ;
  telefonabonnent_nn_1_N = mkN "telefonabonnent" "telefonabonnenter" ;
  telefonapparat_nn_1_N = mkN "telefonapparat" "telefonapparater" ;
  telefonautomat_nn_1_N = mkN "telefonautomat" "telefonautomater" ;
  telefonhytt_nn_1_N = mkN "telefonhytt" "telefonhytter" ;
  telefonkatalog_nn_1_N = mkN "telefonkatalog" "telefonkataloger" ;
  telefonkontakt_nn_1_N = mkN "telefonkontakt" "telefonkontakter" ;
  telefonoperatoer_nn_1_1_N = mkN "telefonoperatör" "telefonoperatörer" ;
  telefonstation_nn_1_N = mkN "telefonstation" "telefonstationer" ;
  telefonvakt_nn_1_N = mkN "telefonvakt" "telefonvakter" ;
  telefonoer_nn_1_1_N = mkN "telefonör" "telefonörer" ;
  telefoerbindelse_nn_1_1_N = mkN "teleförbindelse" "teleförbindelser" ;
  telegrafstation_nn_1_N = mkN "telegrafstation" "telegrafstationer" ;
  telekommunikation_nn_1_N = mkN "telekommunikation" "telekommunikationer" ;
  teleskopfunktion_nn_1_N = mkN "teleskopfunktion" "teleskopfunktioner" ;
  telestation_nn_1_N = mkN "telestation" "telestationer" ;
  temperaturskillnad_nn_1_N = mkN "temperaturskillnad" "temperaturskillnader" ;
  tennisplan_nn_1_N = mkN "tennisplan" "tennisplaner" ;
  tennissko_nn_1_N = mkN "tennissko" "tennisskor" ;
  tennsoldat_nn_1_N = mkN "tennsoldat" "tennsoldater" ;
  tension_nn_1_N = mkN "tension" "tensioner" ;
  tentamensnervositet_nn_1_N = mkN "tentamensnervositet" "tentamensnervositeter" ;
  tentand_nn_1_N = mkN "tentand" "tentander" ;
  teobromin_nn_1_N = mkN "teobromin" "teobrominer" ;
  teofyllin_nn_1_N = mkN "teofyllin" "teofylliner" ;
  teosof_nn_1_N = mkN "teosof" "teosofer" ;
  terapeut_nn_1_N = mkN "terapeut" "terapeuter" ;
  terapisession_nn_1_N = mkN "terapisession" "terapisessioner" ;
  terebint_nn_1_N = mkN "terebint" "terebinter" ;
  term_nn_1_N = mkN "term" "termer" ;
  termin_nn_1_N = mkN "termin" "terminer" ;
  terminsaffaer_nn_1_1_N = mkN "terminsaffär" "terminsaffärer" ;
  terminsavgift_nn_1_N = mkN "terminsavgift" "terminsavgifter" ;
  termoelektricitet_nn_1_N = mkN "termoelektricitet" "termoelektriciteter" ;
  termostat_nn_1_N = mkN "termostat" "termostater" ;
  tern_nn_1_N = mkN "tern" "terner" ;
  terpen_nn_1_N = mkN "terpen" "terpener" ;
  terrorattack_nn_1_N = mkN "terrorattack" "terrorattacker" ;
  terroristattack_nn_1_N = mkN "terroristattack" "terroristattacker" ;
  terraeng_nn_1_1_N = mkN "terräng" "terränger" ;
  tersett_nn_1_N = mkN "tersett" "tersetter" ;
  terzett_nn_1_N = mkN "terzett" "terzetter" ;
  testbild_nn_1_N = mkN "testbild" "testbilder" ;
  testpilot_nn_1_N = mkN "testpilot" "testpiloter" ;
  tetrark_nn_1_N = mkN "tetrark" "tetrarker" ;
  teveantenn_nn_1_N = mkN "teveantenn" "teveantenner" ;
  teveapparat_nn_1_N = mkN "teveapparat" "teveapparater" ;
  tevebild_nn_1_N = mkN "tevebild" "tevebilder" ;
  tevechef_nn_1_N = mkN "tevechef" "tevechefer" ;
  tevekanal_nn_1_N = mkN "tevekanal" "tevekanaler" ;
  tevenyhet_nn_1_N = mkN "tevenyhet" "tevenyheter" ;
  tevereparatoer_nn_1_1_N = mkN "tevereparatör" "tevereparatörer" ;
  teveserie_nn_1_N = mkN "teveserie" "teveserier" ;
  tevestudio_nn_1_N = mkN "tevestudio" "tevestudior" ;
  text_nn_1_N = mkN "text" "texter" ;
  textilfabrik_nn_1_N = mkN "textilfabrik" "textilfabriker" ;
  textilkonstnaer_nn_1_1_N = mkN "textilkonstnär" "textilkonstnärer" ;
  textrad_nn_1_N = mkN "textrad" "textrader" ;
  thrillerfilm_nn_1_N = mkN "thrillerfilm" "thrillerfilmer" ;
  thyroxin_nn_1_N = mkN "thyroxin" "thyroxiner" ;
  tid_nn_1_N = mkN "tid" "tider" ;
  tidegaerd_nn_1_1_N = mkN "tidegärd" "tidegärder" ;
  tidjordskraft_nn_1_N = mkN "tidjordskraft" "tidjordskrafter" ;
  tidloen_nn_1_1_N = mkN "tidlön" "tidlöner" ;
  tidloeshet_nn_1_1_N = mkN "tidlöshet" "tidlösheter" ;
  tidningskant_nn_1_N = mkN "tidningskant" "tidningskanter" ;
  tidningsredaktion_nn_1_N = mkN "tidningsredaktion" "tidningsredaktioner" ;
  tidningsspalt_nn_1_N = mkN "tidningsspalt" "tidningsspalter" ;
  tidningstext_nn_1_N = mkN "tidningstext" "tidningstexter" ;
  tidningsuppgift_nn_1_N = mkN "tidningsuppgift" "tidningsuppgifter" ;
  tidpunkt_nn_1_N = mkN "tidpunkt" "tidpunkter" ;
  tidrymd_nn_1_N = mkN "tidrymd" "tidrymder" ;
  tidsangivelse_nn_1_N = mkN "tidsangivelse" "tidsangivelser" ;
  tidsaspekt_nn_1_N = mkN "tidsaspekt" "tidsaspekter" ;
  tidsbild_nn_1_N = mkN "tidsbild" "tidsbilder" ;
  tidsekvation_nn_1_N = mkN "tidsekvation" "tidsekvationer" ;
  tidsenhet_nn_1_N = mkN "tidsenhet" "tidsenheter" ;
  tidsepok_nn_1_N = mkN "tidsepok" "tidsepoker" ;
  tidsfoeljd_nn_1_1_N = mkN "tidsföljd" "tidsföljder" ;
  tidskrift_nn_1_N = mkN "tidskrift" "tidskrifter" ;
  tidskriftsillustration_nn_1_N = mkN "tidskriftsillustration" "tidskriftsillustrationer" ;
  tidsmarginal_nn_1_N = mkN "tidsmarginal" "tidsmarginaler" ;
  tidsmaskin_nn_1_N = mkN "tidsmaskin" "tidsmaskiner" ;
  tidsmaessighet_nn_1_1_N = mkN "tidsmässighet" "tidsmässigheter" ;
  tidsperiod_nn_1_N = mkN "tidsperiod" "tidsperioder" ;
  tidsrymd_nn_1_N = mkN "tidsrymd" "tidsrymder" ;
  tidsskillnad_nn_1_N = mkN "tidsskillnad" "tidsskillnader" ;
  tidszon_nn_1_N = mkN "tidszon" "tidszoner" ;
  tidtabell_nn_1_N = mkN "tidtabell" "tidtabeller" ;
  tidvattenhoejd_nn_1_1_N = mkN "tidvattenhöjd" "tidvattenhöjder" ;
  tidvattenkraft_nn_1_N = mkN "tidvattenkraft" "tidvattenkrafter" ;
  tigerbalsam_nn_1_N = mkN "tigerbalsam" "tigerbalsamer" ;
  tigerkatt_nn_1_N = mkN "tigerkatt" "tigerkatter" ;
  tillbyggnad_nn_1_N = mkN "tillbyggnad" "tillbyggnader" ;
  tilldragelse_nn_1_N = mkN "tilldragelse" "tilldragelser" ;
  tillfart_nn_1_N = mkN "tillfart" "tillfarter" ;
  tillflyktsort_nn_1_N = mkN "tillflyktsort" "tillflyktsorter" ;
  tillfaellighet_nn_1_1_N = mkN "tillfällighet" "tillfälligheter" ;
  tillfaellighetsdikt_nn_1_1_N = mkN "tillfällighetsdikt" "tillfällighetsdikter" ;
  tillfoerlitlighet_nn_1_1_N = mkN "tillförlitlighet" "tillförlitligheter" ;
  tillgivenhet_nn_1_N = mkN "tillgivenhet" "tillgivenheter" ;
  tillgjordhet_nn_1_N = mkN "tillgjordhet" "tillgjordheter" ;
  tillhoerighet_nn_1_1_N = mkN "tillhörighet" "tillhörigheter" ;
  tillslagningsteknik_nn_1_N = mkN "tillslagningsteknik" "tillslagningstekniker" ;
  tillstymmelse_nn_1_N = mkN "tillstymmelse" "tillstymmelser" ;
  tillsynsmyndighet_nn_1_N = mkN "tillsynsmyndighet" "tillsynsmyndigheter" ;
  tillsaegelse_nn_1_1_N = mkN "tillsägelse" "tillsägelser" ;
  tilltalsform_nn_1_N = mkN "tilltalsform" "tilltalsformer" ;
  tillverkningskostnad_nn_1_N = mkN "tillverkningskostnad" "tillverkningskostnader" ;
  tillverkningsserie_nn_1_N = mkN "tillverkningsserie" "tillverkningsserier" ;
  tillvitelse_nn_1_N = mkN "tillvitelse" "tillvitelser" ;
  tillvaexthastighet_nn_1_1_N = mkN "tillväxthastighet" "tillväxthastigheter" ;
  tillvaextmodell_nn_1_1_N = mkN "tillväxtmodell" "tillväxtmodeller" ;
  tillvaextperiod_nn_1_1_N = mkN "tillväxtperiod" "tillväxtperioder" ;
  tillaeggskostnad_nn_1_1_N = mkN "tilläggskostnad" "tilläggskostnader" ;
  tillaeggspension_nn_1_1_N = mkN "tilläggspension" "tilläggspensioner" ;
  tillaempningsfoereskrift_nn_1_1_N = mkN "tillämpningsföreskrift" "tillämpningsföreskrifter" ;
  timlighet_nn_1_N = mkN "timlighet" "timligheter" ;
  timloen_nn_1_1_N = mkN "timlön" "timlöner" ;
  tingsraett_nn_1_1_N = mkN "tingsrätt" "tingsrätter" ;
  tinninglob_nn_1_N = mkN "tinninglob" "tinninglober" ;
  tiokamp_nn_1_N = mkN "tiokamp" "tiokamper" ;
  tipskupong_nn_1_N = mkN "tipskupong" "tipskuponger" ;
  tipspromenad_nn_1_N = mkN "tipspromenad" "tipspromenader" ;
  tipsrad_nn_1_N = mkN "tipsrad" "tipsrader" ;
  tistelstaang_nn_1_1_N = mkN "tistelstång" "tistelstänger" ;
  titeldikt_nn_1_N = mkN "titeldikt" "titeldikter" ;
  titelnovell_nn_1_N = mkN "titelnovell" "titelnoveller" ;
  titelroll_nn_1_N = mkN "titelroll" "titelroller" ;
  titthaalsoperation_nn_1_1_N = mkN "titthålsoperation" "titthålsoperationer" ;
  tjeckoslovak_nn_1_N = mkN "tjeckoslovak" "tjeckoslovaker" ;
  tjej_nn_1_N = mkN "tjej" "tjejer" ;
  tjejslakt_nn_1_N = mkN "tjejslakt" "tjejslakter" ;
  tjockskallighet_nn_1_N = mkN "tjockskallighet" "tjockskalligheter" ;
  tjocktarmstumoer_nn_1_1_N = mkN "tjocktarmstumör" "tjocktarmstumörer" ;
  tjurskallighet_nn_1_N = mkN "tjurskallighet" "tjurskalligheter" ;
  tjuvnad_nn_1_N = mkN "tjuvnad" "tjuvnader" ;
  tjuvstart_nn_1_N = mkN "tjuvstart" "tjuvstarter" ;
  tjyvstart_nn_1_N = mkN "tjyvstart" "tjyvstarter" ;
  tjaenstebostad_nn_1_1_N = mkN "tjänstebostad" "tjänstebostäder" ;
  tjaenstebrevsraett_nn_1_1_N = mkN "tjänstebrevsrätt" "tjänstebrevsrätter" ;
  tjaenstefoerseelse_nn_1_1_N = mkN "tjänsteförseelse" "tjänsteförseelser" ;
  tjaenstefoersaendelse_nn_1_1_N = mkN "tjänsteförsändelse" "tjänsteförsändelser" ;
  tjaenstegrad_nn_1_1_N = mkN "tjänstegrad" "tjänstegrader" ;
  tjaenstemannaorganisation_nn_1_1_N = mkN "tjänstemannaorganisation" "tjänstemannaorganisationer" ;
  tjaenstepension_nn_1_1_N = mkN "tjänstepension" "tjänstepensioner" ;
  tjaenstetid_nn_1_1_N = mkN "tjänstetid" "tjänstetider" ;
  tjaenstledighet_nn_1_1_N = mkN "tjänstledighet" "tjänstledigheter" ;
  tobaksaffaer_nn_1_1_N = mkN "tobaksaffär" "tobaksaffärer" ;
  tobaksbutik_nn_1_N = mkN "tobaksbutik" "tobaksbutiker" ;
  tobaksimportoer_nn_1_1_N = mkN "tobaksimportör" "tobaksimportörer" ;
  toft_nn_1_N = mkN "toft" "tofter" ;
  tokighet_nn_1_N = mkN "tokighet" "tokigheter" ;
  tokrolighet_nn_1_N = mkN "tokrolighet" "tokroligheter" ;
  tolft_nn_1_N = mkN "tolft" "tolfter" ;
  tolkningsmetod_nn_1_N = mkN "tolkningsmetod" "tolkningsmetoder" ;
  tolkningsmoejlighet_nn_1_1_N = mkN "tolkningsmöjlighet" "tolkningsmöjligheter" ;
  tom_nn_1_N = mkN "tom" "tomer" ;
  tomat_nn_1_N = mkN "tomat" "tomater" ;
  tombutelj_nn_1_N = mkN "tombutelj" "tombuteljer" ;
  tomhet_nn_1_N = mkN "tomhet" "tomheter" ;
  tomkartong_nn_1_N = mkN "tomkartong" "tomkartonger" ;
  tomt_nn_1_N = mkN "tomt" "tomter" ;
  tomtedraekt_nn_1_1_N = mkN "tomtedräkt" "tomtedräkter" ;
  tomteverkstad_nn_1_N = mkN "tomteverkstad" "tomteverkstäder" ;
  tomtmark_nn_1_N = mkN "tomtmark" "tomtmarker" ;
  tomtraettsavgaeld_nn_1_1_N = mkN "tomträttsavgäld" "tomträttsavgälder" ;
  tonalitet_nn_1_N = mkN "tonalitet" "tonaliteter" ;
  tonart_nn_1_N = mkN "tonart" "tonarter" ;
  tonett_nn_1_N = mkN "tonett" "tonetter" ;
  tonfoeljd_nn_1_1_N = mkN "tonföljd" "tonföljder" ;
  tonhoejd_nn_1_1_N = mkN "tonhöjd" "tonhöjder" ;
  tonsill_nn_1_N = mkN "tonsill" "tonsiller" ;
  tonaarsidentitet_nn_1_1_N = mkN "tonårsidentitet" "tonårsidentiteter" ;
  tonaarsperiod_nn_1_1_N = mkN "tonårsperiod" "tonårsperioder" ;
  topograf_nn_1_N = mkN "topograf" "topografer" ;
  toppkraft_nn_1_N = mkN "toppkraft" "toppkrafter" ;
  toppmodell_nn_1_N = mkN "toppmodell" "toppmodeller" ;
  topposition_nn_1_N = mkN "topposition" "toppositioner" ;
  toque_nn_1_N = mkN "toque" "toquer" ;
  torftighet_nn_1_N = mkN "torftighet" "torftigheter" ;
  torgmarknad_nn_1_N = mkN "torgmarknad" "torgmarknader" ;
  torkperiod_nn_1_N = mkN "torkperiod" "torkperioder" ;
  torped_nn_1_N = mkN "torped" "torpeder" ;
  torpedattack_nn_1_N = mkN "torpedattack" "torpedattacker" ;
  torpedtub_nn_1_N = mkN "torpedtub" "torpedtuber" ;
  torpruin_nn_1_N = mkN "torpruin" "torpruiner" ;
  torrdestillation_nn_1_N = mkN "torrdestillation" "torrdestillationer" ;
  torrklosett_nn_1_N = mkN "torrklosett" "torrklosetter" ;
  torrolighet_nn_1_N = mkN "torrolighet" "torroligheter" ;
  torrperiod_nn_1_N = mkN "torrperiod" "torrperioder" ;
  torrtid_nn_1_N = mkN "torrtid" "torrtider" ;
  torsion_nn_1_N = mkN "torsion" "torsioner" ;
  tortyranklagelse_nn_1_N = mkN "tortyranklagelse" "tortyranklagelser" ;
  torvbrikett_nn_1_N = mkN "torvbrikett" "torvbriketter" ;
  torvbrikettfabrik_nn_1_N = mkN "torvbrikettfabrik" "torvbrikettfabriker" ;
  torvmullsklosett_nn_1_N = mkN "torvmullsklosett" "torvmullsklosetter" ;
  torvtaekt_nn_1_1_N = mkN "torvtäkt" "torvtäkter" ;
  tosighet_nn_1_N = mkN "tosighet" "tosigheter" ;
  tossighet_nn_1_N = mkN "tossighet" "tossigheter" ;
  totalbild_nn_1_N = mkN "totalbild" "totalbilder" ;
  totalfoermoerkelse_nn_1_1_N = mkN "totalförmörkelse" "totalförmörkelser" ;
  totalitet_nn_1_N = mkN "totalitet" "totaliteter" ;
  totalreflexion_nn_1_N = mkN "totalreflexion" "totalreflexioner" ;
  totalvikt_nn_1_N = mkN "totalvikt" "totalvikter" ;
  touche_nn_1_N = mkN "touche" "toucher" ;
  toxicitet_nn_1_N = mkN "toxicitet" "toxiciteter" ;
  tradition_nn_1_N = mkN "tradition" "traditioner" ;
  traffickinganklagelse_nn_1_N = mkN "traffickinganklagelse" "traffickinganklagelser" ;
  trafikled_nn_1_N = mkN "trafikled" "trafikleder" ;
  trafikpilot_nn_1_N = mkN "trafikpilot" "trafikpiloter" ;
  trafiksituation_nn_1_N = mkN "trafiksituation" "trafiksituationer" ;
  trafiksaekerhet_nn_1_1_N = mkN "trafiksäkerhet" "trafiksäkerheter" ;
  trafiksaekerhetschef_nn_1_1_N = mkN "trafiksäkerhetschef" "trafiksäkerhetschefer" ;
  trafikvakt_nn_1_N = mkN "trafikvakt" "trafikvakter" ;
  tragedienn_nn_1_N = mkN "tragedienn" "tragedienner" ;
  tragoed_nn_1_1_N = mkN "tragöd" "tragöder" ;
  traktat_nn_1_N = mkN "traktat" "traktater" ;
  traktoer_nn_1_1_N = mkN "traktör" "traktörer" ;
  trakyt_nn_1_N = mkN "trakyt" "trakyter" ;
  tramproerelse_nn_1_1_N = mkN "tramprörelse" "tramprörelser" ;
  trampoert_nn_1_1_N = mkN "trampört" "trampörter" ;
  tramsighet_nn_1_N = mkN "tramsighet" "tramsigheter" ;
  tranbaerssaft_nn_1_1_N = mkN "tranbärssaft" "tranbärssafter" ;
  trankilitet_nn_1_N = mkN "trankilitet" "trankiliteter" ;
  transaktion_nn_1_N = mkN "transaktion" "transaktioner" ;
  transfiguration_nn_1_N = mkN "transfiguration" "transfigurationer" ;
  transformation_nn_1_N = mkN "transformation" "transformationer" ;
  transformationsgrammatik_nn_1_N = mkN "transformationsgrammatik" "transformationsgrammatiker" ;
  transformatorbrand_nn_1_N = mkN "transformatorbrand" "transformatorbränder" ;
  transformatorstation_nn_1_N = mkN "transformatorstation" "transformatorstationer" ;
  transfusion_nn_1_N = mkN "transfusion" "transfusioner" ;
  transgression_nn_1_N = mkN "transgression" "transgressioner" ;
  transkription_nn_1_N = mkN "transkription" "transkriptioner" ;
  translitteration_nn_1_N = mkN "translitteration" "translitterationer" ;
  transmission_nn_1_N = mkN "transmission" "transmissioner" ;
  transmutation_nn_1_N = mkN "transmutation" "transmutationer" ;
  transparang_nn_1_N = mkN "transparang" "transparanger" ;
  transperson_nn_1_N = mkN "transperson" "transpersoner" ;
  transpiration_nn_1_N = mkN "transpiration" "transpirationer" ;
  transplantation_nn_1_N = mkN "transplantation" "transplantationer" ;
  transportsaekerhet_nn_1_1_N = mkN "transportsäkerhet" "transportsäkerheter" ;
  transportoer_nn_1_1_N = mkN "transportör" "transportörer" ;
  transposition_nn_1_N = mkN "transposition" "transpositioner" ;
  transsubstantiation_nn_1_N = mkN "transsubstantiation" "transsubstantiationer" ;
  transubstantiation_nn_1_N = mkN "transubstantiation" "transubstantiationer" ;
  transuran_nn_1_N = mkN "transuran" "transuraner" ;
  trapets_nn_2_N = mkN "trapets" "trapetser" ;
  trapetskonstnaer_nn_1_1_N = mkN "trapetskonstnär" "trapetskonstnärer" ;
  trappfunktion_nn_1_N = mkN "trappfunktion" "trappfunktioner" ;
  trassat_nn_1_N = mkN "trassat" "trassater" ;
  trassent_nn_1_N = mkN "trassent" "trassenter" ;
  trasslighet_nn_1_N = mkN "trasslighet" "trassligheter" ;
  tredjegradsekvation_nn_1_N = mkN "tredjegradsekvation" "tredjegradsekvationer" ;
  tredjeopponent_nn_1_N = mkN "tredjeopponent" "tredjeopponenter" ;
  treenighet_nn_1_N = mkN "treenighet" "treenigheter" ;
  trefald_nn_1_N = mkN "trefald" "trefalder" ;
  trefaldighet_nn_1_N = mkN "trefaldighet" "trefaldigheter" ;
  trekant_nn_1_N = mkN "trekant" "trekanter" ;
  trekantsprofil_nn_1_N = mkN "trekantsprofil" "trekantsprofiler" ;
  treklang_nn_1_N = mkN "treklang" "treklanger" ;
  trelaekarstation_nn_1_1_N = mkN "treläkarstation" "treläkarstationer" ;
  tremaanadersperiod_nn_1_1_N = mkN "tremånadersperiod" "tremånadersperioder" ;
  trend_nn_1_N = mkN "trend" "trender" ;
  trendighet_nn_1_N = mkN "trendighet" "trendigheter" ;
  trepanation_nn_1_N = mkN "trepanation" "trepanationer" ;
  trerumslaegenhet_nn_1_1_N = mkN "trerumslägenhet" "trerumslägenheter" ;
  trestegsraket_nn_1_N = mkN "trestegsraket" "trestegsraketer" ;
  trettiodagarsperiod_nn_1_N = mkN "trettiodagarsperiod" "trettiodagarsperioder" ;
  trevlighet_nn_1_N = mkN "trevlighet" "trevligheter" ;
  trevnad_nn_1_N = mkN "trevnad" "trevnader" ;
  triad_nn_1_N = mkN "triad" "triader" ;
  triangelpunkt_nn_1_N = mkN "triangelpunkt" "triangelpunkter" ;
  tribad_nn_1_N = mkN "tribad" "tribader" ;
  tribun_nn_1_N = mkN "tribun" "tribuner" ;
  tribunal_nn_1_N = mkN "tribunal" "tribunaler" ;
  tribut_nn_1_N = mkN "tribut" "tributer" ;
  trickfilm_nn_1_N = mkN "trickfilm" "trickfilmer" ;
  triennal_nn_1_N = mkN "triennal" "triennaler" ;
  triftong_nn_1_N = mkN "triftong" "triftonger" ;
  triglyf_nn_1_N = mkN "triglyf" "triglyfer" ;
  trillingnerv_nn_1_N = mkN "trillingnerv" "trillingnerver" ;
  trimningsfunktion_nn_1_N = mkN "trimningsfunktion" "trimningsfunktioner" ;
  triod_nn_1_N = mkN "triod" "trioder" ;
  trioxipurin_nn_1_N = mkN "trioxipurin" "trioxipuriner" ;
  tripod_nn_1_N = mkN "tripod" "tripoder" ;
  trippelpunkt_nn_1_N = mkN "trippelpunkt" "trippelpunkter" ;
  triptyk_nn_1_N = mkN "triptyk" "triptyker" ;
  trisslott_nn_1_N = mkN "trisslott" "trisslotter" ;
  triumf_nn_1_N = mkN "triumf" "triumfer" ;
  triumvir_nn_1_N = mkN "triumvir" "triumvirer" ;
  trivialitet_nn_1_N = mkN "trivialitet" "trivialiteter" ;
  trivsamhet_nn_1_N = mkN "trivsamhet" "trivsamheter" ;
  trivselvikt_nn_1_N = mkN "trivselvikt" "trivselvikter" ;
  trixighet_nn_1_N = mkN "trixighet" "trixigheter" ;
  trofasthet_nn_1_N = mkN "trofasthet" "trofastheter" ;
  trogenhet_nn_1_N = mkN "trogenhet" "trogenheter" ;
  troglodyt_nn_1_N = mkN "troglodyt" "troglodyter" ;
  trohet_nn_1_N = mkN "trohet" "troheter" ;
  trohetsed_nn_1_N = mkN "trohetsed" "trohetseder" ;
  trohjaertenhet_nn_1_1_N = mkN "trohjärtenhet" "trohjärtenheter" ;
  trolldryck_nn_1_N = mkN "trolldryck" "trolldrycker" ;
  trollerikonstnaer_nn_1_1_N = mkN "trollerikonstnär" "trollerikonstnärer" ;
  trollkonstnaer_nn_1_1_N = mkN "trollkonstnär" "trollkonstnärer" ;
  trollsaang_nn_1_1_N = mkN "trollsång" "trollsånger" ;
  troloeshet_nn_1_1_N = mkN "trolöshet" "trolösheter" ;
  tromb_nn_1_N = mkN "tromb" "tromber" ;
  trombocyt_nn_1_N = mkN "trombocyt" "trombocyter" ;
  tronavsaegelse_nn_1_1_N = mkN "tronavsägelse" "tronavsägelser" ;
  tronfoeljd_nn_1_1_N = mkN "tronföljd" "tronföljder" ;
  tronpretendent_nn_1_N = mkN "tronpretendent" "tronpretendenter" ;
  trop_nn_1_N = mkN "trop" "troper" ;
  tropik_nn_1_N = mkN "tropik" "tropiker" ;
  troposfaer_nn_1_1_N = mkN "troposfär" "troposfärer" ;
  trosbekaennelse_nn_1_1_N = mkN "trosbekännelse" "trosbekännelser" ;
  trosfrihet_nn_1_N = mkN "trosfrihet" "trosfriheter" ;
  trosfraende_nn_1_1_N = mkN "trosfrände" "trosfränder" ;
  trosgemenskap_nn_1_N = mkN "trosgemenskap" "trosgemenskaper" ;
  trosroerelse_nn_1_1_N = mkN "trosrörelse" "trosrörelser" ;
  trottoar_nn_1_N = mkN "trottoar" "trottoarer" ;
  trottoarbonde_nn_1_N = mkN "trottoarbonde" "trottoarbönder" ;
  trottoarkant_nn_1_N = mkN "trottoarkant" "trottoarkanter" ;
  trudelutt_nn_1_N = mkN "trudelutt" "trudelutter" ;
  trumpetkonsert_nn_1_N = mkN "trumpetkonsert" "trumpetkonserter" ;
  trunkmaskin_nn_1_N = mkN "trunkmaskin" "trunkmaskiner" ;
  trupp_nn_1_N = mkN "trupp" "trupper" ;
  trupproerelse_nn_1_1_N = mkN "trupprörelse" "trupprörelser" ;
  tryckaccent_nn_1_N = mkN "tryckaccent" "tryckaccenter" ;
  tryckbokstav_nn_1_N = mkN "tryckbokstav" "tryckbokstäver" ;
  tryckdraekt_nn_1_1_N = mkN "tryckdräkt" "tryckdräkter" ;
  tryckfrihet_nn_1_N = mkN "tryckfrihet" "tryckfriheter" ;
  tryckfaerg_nn_1_1_N = mkN "tryckfärg" "tryckfärger" ;
  tryckkontakt_nn_1_N = mkN "tryckkontakt" "tryckkontakter" ;
  tryckluftsapparat_nn_1_N = mkN "tryckluftsapparat" "tryckluftsapparater" ;
  tryckmetod_nn_1_N = mkN "tryckmetod" "tryckmetoder" ;
  tryckort_nn_1_N = mkN "tryckort" "tryckorter" ;
  tryckpunkt_nn_1_N = mkN "tryckpunkt" "tryckpunkter" ;
  trycksak_nn_1_N = mkN "trycksak" "trycksaker" ;
  trycktyp_nn_1_N = mkN "trycktyp" "trycktyper" ;
  trygghet_nn_1_N = mkN "trygghet" "tryggheter" ;
  trypsin_nn_1_N = mkN "trypsin" "trypsiner" ;
  traecell_nn_1_1_N = mkN "träcell" "träceller" ;
  traedbank_nn_1_1_N = mkN "trädbank" "trädbanker" ;
  traedestillation_nn_1_1_N = mkN "trädestillation" "trädestillationer" ;
  traedgaardsarkitekt_nn_1_1_N = mkN "trädgårdsarkitekt" "trädgårdsarkitekter" ;
  traedgaardsprydnad_nn_1_1_N = mkN "trädgårdsprydnad" "trädgårdsprydnader" ;
  traedgaardsaert_nn_1_1_N = mkN "trädgårdsärt" "trädgårdsärter" ;
  traeffbild_nn_1_1_N = mkN "träffbild" "träffbilder" ;
  traeffpunkt_nn_1_1_N = mkN "träffpunkt" "träffpunkter" ;
  traeffsaekerhet_nn_1_1_N = mkN "träffsäkerhet" "träffsäkerheter" ;
  traegravyr_nn_1_1_N = mkN "trägravyr" "trägravyrer" ;
  traekonstruktion_nn_1_1_N = mkN "träkonstruktion" "träkonstruktioner" ;
  traengselavgift_nn_1_1_N = mkN "trängselavgift" "trängselavgifter" ;
  traengtrupp_nn_1_1_N = mkN "trängtrupp" "trängtrupper" ;
  traeningsdraekt_nn_1_1_N = mkN "träningsdräkt" "träningsdräkter" ;
  traeprodukt_nn_1_1_N = mkN "träprodukt" "träprodukter" ;
  traesko_nn_1_1_N = mkN "träsko" "träskor" ;
  traesnittsillustration_nn_1_1_N = mkN "träsnittsillustration" "träsnittsillustrationer" ;
  traakighet_nn_1_1_N = mkN "tråkighet" "tråkigheter" ;
  traanad_nn_1_1_N = mkN "trånad" "trånader" ;
  troeghet_nn_2_1_N = mkN "tröghet" "trögheter" ;
  troejfabrik_nn_1_1_N = mkN "tröjfabrik" "tröjfabriker" ;
  troeskeleffekt_nn_1_1_N = mkN "tröskeleffekt" "tröskeleffekter" ;
  troestegrund_nn_1_1_N = mkN "tröstegrund" "tröstegrunder" ;
  troesteskrift_nn_1_1_N = mkN "trösteskrift" "trösteskrifter" ;
  tsar_nn_1_N = mkN "tsar" "tsarer" ;
  tsarfamilj_nn_1_N = mkN "tsarfamilj" "tsarfamiljer" ;
  tub_nn_1_N = mkN "tub" "tuber" ;
  tuberkelbakterie_nn_1_N = mkN "tuberkelbakterie" "tuberkelbakterier" ;
  tuberkulin_nn_1_N = mkN "tuberkulin" "tuberkuliner" ;
  tubkanon_nn_1_N = mkN "tubkanon" "tubkanoner" ;
  tulkoert_nn_1_1_N = mkN "tulkört" "tulkörter" ;
  tullavgift_nn_1_N = mkN "tullavgift" "tullavgifter" ;
  tulldeklaration_nn_1_N = mkN "tulldeklaration" "tulldeklarationer" ;
  tullnaer_nn_1_1_N = mkN "tullnär" "tullnärer" ;
  tullstation_nn_1_N = mkN "tullstation" "tullstationer" ;
  tullunion_nn_1_N = mkN "tullunion" "tullunioner" ;
  tullvisitation_nn_1_N = mkN "tullvisitation" "tullvisitationer" ;
  tumsbredd_nn_1_N = mkN "tumsbredd" "tumsbredder" ;
  tumoer_nn_1_1_N = mkN "tumör" "tumörer" ;
  tungmetall_nn_1_N = mkN "tungmetall" "tungmetaller" ;
  tungsinthet_nn_1_N = mkN "tungsinthet" "tungsintheter" ;
  tungoert_nn_1_1_N = mkN "tungört" "tungörter" ;
  tunik_nn_1_N = mkN "tunik" "tuniker" ;
  tunnelbanefaerd_nn_1_1_N = mkN "tunnelbanefärd" "tunnelbanefärder" ;
  tunnelbanestation_nn_1_N = mkN "tunnelbanestation" "tunnelbanestationer" ;
  tunneleffekt_nn_1_N = mkN "tunneleffekt" "tunneleffekter" ;
  turistinformation_nn_1_N = mkN "turistinformation" "turistinformationer" ;
  turiststation_nn_1_N = mkN "turiststation" "turiststationer" ;
  turkcypriot_nn_1_N = mkN "turkcypriot" "turkcyprioter" ;
  turnyr_nn_1_N = mkN "turnyr" "turnyrer" ;
  turochreturbiljett_nn_1_N = mkN "turochreturbiljett" "turochreturbiljetter" ;
  tusenkonstnaer_nn_1_1_N = mkN "tusenkonstnär" "tusenkonstnärer" ;
  tussilago_nn_1_N = mkN "tussilago" "tussilagor" ;
  tv_kanal_nn_1_N = mkN "tv-kanal" "tv-kanaler" ;
  tv_leverantoer_nn_1_1_N = mkN "tv-leverantör" "tv-leverantörer" ;
  tv_nyhet_nn_1_N = mkN "tv-nyhet" "tv-nyheter" ;
  tv_reparatoer_nn_1_1_N = mkN "tv-reparatör" "tv-reparatörer" ;
  tv_serie_nn_1_N = mkN "tv-serie" "tv-serier" ;
  tv_studio_nn_1_N = mkN "tv-studio" "tv-studior" ;
  tvekamp_nn_1_N = mkN "tvekamp" "tvekamper" ;
  tveksamhet_nn_1_N = mkN "tveksamhet" "tveksamheter" ;
  tvetydighet_nn_1_N = mkN "tvetydighet" "tvetydigheter" ;
  tvillingmaskin_nn_1_N = mkN "tvillingmaskin" "tvillingmaskiner" ;
  tvistighet_nn_1_N = mkN "tvistighet" "tvistigheter" ;
  tvaerbrant_nn_1_1_N = mkN "tvärbrant" "tvärbranter" ;
  tvaerfloejt_nn_1_1_N = mkN "tvärflöjt" "tvärflöjter" ;
  tvaerlinje_nn_1_1_N = mkN "tvärlinje" "tvärlinjer" ;
  tvaervetenskap_nn_1_1_N = mkN "tvärvetenskap" "tvärvetenskaper" ;
  tvaettautomat_nn_1_1_N = mkN "tvättautomat" "tvättautomater" ;
  tvaettbar_nn_1_1_N = mkN "tvättbar" "tvättbarer" ;
  tvaettmaskin_nn_1_1_N = mkN "tvättmaskin" "tvättmaskiner" ;
  tvaettomat_nn_1_1_N = mkN "tvättomat" "tvättomater" ;
  tvaangsmaessighet_nn_1_1_N = mkN "tvångsmässighet" "tvångsmässigheter" ;
  tvaangssituation_nn_1_1_N = mkN "tvångssituation" "tvångssituationer" ;
  tvaangsaatgaerd_nn_1_1_N = mkN "tvångsåtgärd" "tvångsåtgärder" ;
  tvaarumslaegenhet_nn_1_1_N = mkN "tvårumslägenhet" "tvårumslägenheter" ;
  tvaasamhet_nn_1_1_N = mkN "tvåsamhet" "tvåsamheter" ;
  tvaastavighetsaccent_nn_1_1_N = mkN "tvåstavighetsaccent" "tvåstavighetsaccenter" ;
  tvaatakt_nn_1_1_N = mkN "tvåtakt" "tvåtakter" ;
  tydlighet_nn_2_N = mkN "tydlighet" "tydligheter" ;
  tyfoidbakterie_nn_1_N = mkN "tyfoidbakterie" "tyfoidbakterier" ;
  tygbanderoll_nn_1_N = mkN "tygbanderoll" "tygbanderoller" ;
  tygbredd_nn_1_N = mkN "tygbredd" "tygbredder" ;
  tygkant_nn_1_N = mkN "tygkant" "tygkanter" ;
  tygsko_nn_1_N = mkN "tygsko" "tygskor" ;
  tykenhet_nn_1_N = mkN "tykenhet" "tykenheter" ;
  tyngdacceleration_nn_1_N = mkN "tyngdacceleration" "tyngdaccelerationer" ;
  tyngdloeshet_nn_1_1_N = mkN "tyngdlöshet" "tyngdlösheter" ;
  tyngdpunkt_nn_1_N = mkN "tyngdpunkt" "tyngdpunkter" ;
  typ_nn_1_N = mkN "typ" "typer" ;
  tysklektion_nn_1_N = mkN "tysklektion" "tysklektioner" ;
  tysthet_nn_1_N = mkN "tysthet" "tystheter" ;
  tystnad_nn_1_N = mkN "tystnad" "tystnader" ;
  taeckfaerg_nn_1_1_N = mkN "täckfärg" "täckfärger" ;
  taeckningsgrad_nn_1_1_N = mkN "täckningsgrad" "täckningsgrader" ;
  taeckorganisation_nn_1_1_N = mkN "täckorganisation" "täckorganisationer" ;
  taekt_nn_1_1_N = mkN "täkt" "täkter" ;
  taendpatron_nn_1_1_N = mkN "tändpatron" "tändpatroner" ;
  taendsticksfabrik_nn_1_1_N = mkN "tändsticksfabrik" "tändsticksfabriker" ;
  taenkarpose_nn_1_1_N = mkN "tänkarpose" "tänkarposer" ;
  taenkbarhet_nn_1_1_N = mkN "tänkbarhet" "tänkbarheter" ;
  taenkvaerdhet_nn_1_1_N = mkN "tänkvärdhet" "tänkvärdheter" ;
  taet_nn_1_1_N = mkN "tät" "täter" ;
  taethetsvariation_nn_1_1_N = mkN "täthetsvariation" "täthetsvariationer" ;
  taetort_nn_1_1_N = mkN "tätort" "tätorter" ;
  taetortsbo_nn_1_1_N = mkN "tätortsbo" "tätortsbor" ;
  taevlingsinstinkt_nn_1_1_N = mkN "tävlingsinstinkt" "tävlingsinstinkter" ;
  taevlingskamp_nn_1_1_N = mkN "tävlingskamp" "tävlingskamper" ;
  taagbiljett_nn_1_1_N = mkN "tågbiljett" "tågbiljetter" ;
  taaglinje_nn_1_1_N = mkN "tåglinje" "tåglinjer" ;
  taaglaegenhet_nn_1_1_N = mkN "tåglägenhet" "tåglägenheter" ;
  taagtid_nn_1_1_N = mkN "tågtid" "tågtider" ;
  taagtidtabell_nn_1_1_N = mkN "tågtidtabell" "tågtidtabeller" ;
  taagtur_nn_1_1_N = mkN "tågtur" "tågturer" ;
  taang_nn_1_1_N = mkN "tång" "tänger" ;
  taargaspatron_nn_1_1_N = mkN "tårgaspatron" "tårgaspatroner" ;
  taarkanal_nn_1_1_N = mkN "tårkanal" "tårkanaler" ;
  teete_a_teete_nn_1_1_N = mkN "tête-à-tête" "tête-à-têter" ;
  toejbarhet_nn_1_1_N = mkN "töjbarhet" "töjbarheter" ;
  toentighet_nn_1_1_N = mkN "töntighet" "töntigheter" ;
  ubikvitet_nn_1_N = mkN "ubikvitet" "ubikviteter" ;
  ubaatsjakt_nn_1_1_N = mkN "ubåtsjakt" "ubåtsjakter" ;
  uddatalsmetod_nn_1_N = mkN "uddatalsmetod" "uddatalsmetoder" ;
  ugnsomelett_nn_1_N = mkN "ugnsomelett" "ugnsomeletter" ;
  ukulele_nn_1_N = mkN "ukulele" "ukuleler" ;
  ulloert_nn_1_1_N = mkN "ullört" "ullörter" ;
  ultimoaffaer_nn_1_1_N = mkN "ultimoaffär" "ultimoaffärer" ;
  ultraljudsbild_nn_1_N = mkN "ultraljudsbild" "ultraljudsbilder" ;
  ultrarapidfilm_nn_1_N = mkN "ultrarapidfilm" "ultrarapidfilmer" ;
  umbaerlighet_nn_1_1_N = mkN "umbärlighet" "umbärligheter" ;
  umgaengelse_nn_1_1_N = mkN "umgängelse" "umgängelser" ;
  umgaengesform_nn_1_1_N = mkN "umgängesform" "umgängesformer" ;
  umgaengesnorm_nn_1_1_N = mkN "umgängesnorm" "umgängesnormer" ;
  uncial_nn_1_N = mkN "uncial" "uncialer" ;
  undanflykt_nn_1_N = mkN "undanflykt" "undanflykter" ;
  undantagsbestaemmelse_nn_1_1_N = mkN "undantagsbestämmelse" "undantagsbestämmelser" ;
  undantagsraett_nn_1_1_N = mkN "undantagsrätt" "undantagsrätter" ;
  underart_nn_1_N = mkN "underart" "underarter" ;
  underbyggnad_nn_1_N = mkN "underbyggnad" "underbyggnader" ;
  underdrift_nn_1_N = mkN "underdrift" "underdrifter" ;
  underdaanighet_nn_1_1_N = mkN "underdånighet" "underdånigheter" ;
  underemission_nn_1_N = mkN "underemission" "underemissioner" ;
  underfamilj_nn_1_N = mkN "underfamilj" "underfamiljer" ;
  underfart_nn_1_N = mkN "underfart" "underfarter" ;
  underfundighet_nn_1_N = mkN "underfundighet" "underfundigheter" ;
  undergardin_nn_1_N = mkN "undergardin" "undergardiner" ;
  undergrund_nn_1_N = mkN "undergrund" "undergrunder" ;
  underhandskontakt_nn_1_N = mkN "underhandskontakt" "underhandskontakter" ;
  underhaallskostnad_nn_1_1_N = mkN "underhållskostnad" "underhållskostnader" ;
  underhaallstrupp_nn_1_1_N = mkN "underhållstrupp" "underhållstrupper" ;
  underkant_nn_1_N = mkN "underkant" "underkanter" ;
  underleverantoer_nn_1_1_N = mkN "underleverantör" "underleverantörer" ;
  underlighet_nn_1_N = mkN "underlighet" "underligheter" ;
  underljudsfart_nn_1_N = mkN "underljudsfart" "underljudsfarter" ;
  underljudshastighet_nn_1_N = mkN "underljudshastighet" "underljudshastigheter" ;
  underlaegsenhet_nn_1_1_N = mkN "underlägsenhet" "underlägsenheter" ;
  underlaatelse_nn_1_1_N = mkN "underlåtelse" "underlåtelser" ;
  underlaatenhet_nn_1_1_N = mkN "underlåtenhet" "underlåtenheter" ;
  underlaatenhetssynd_nn_1_1_N = mkN "underlåtenhetssynd" "underlåtenhetssynder" ;
  underloejtnant_nn_1_1_N = mkN "underlöjtnant" "underlöjtnanter" ;
  undermaalighet_nn_1_1_N = mkN "undermålighet" "undermåligheter" ;
  underpant_nn_1_N = mkN "underpant" "underpanter" ;
  underrubrik_nn_1_N = mkN "underrubrik" "underrubriker" ;
  underraett_nn_1_1_N = mkN "underrätt" "underrätter" ;
  underraettelse_nn_1_1_N = mkN "underrättelse" "underrättelser" ;
  underraettelseverksamhet_nn_1_1_N = mkN "underrättelseverksamhet" "underrättelseverksamheter" ;
  underskrift_nn_1_N = mkN "underskrift" "underskrifter" ;
  understoedsnaemnd_nn_1_1_N = mkN "understödsnämnd" "understödsnämnder" ;
  undersoekningsmetod_nn_1_1_N = mkN "undersökningsmetod" "undersökningsmetoder" ;
  underterm_nn_1_N = mkN "underterm" "undertermer" ;
  underton_nn_1_N = mkN "underton" "undertoner" ;
  undervattensfoerbindelse_nn_1_1_N = mkN "undervattensförbindelse" "undervattensförbindelser" ;
  undervegetation_nn_1_N = mkN "undervegetation" "undervegetationer" ;
  undervisningsanstalt_nn_1_N = mkN "undervisningsanstalt" "undervisningsanstalter" ;
  undervisningsskicklighet_nn_1_N = mkN "undervisningsskicklighet" "undervisningsskickligheter" ;
  undervisningsskyldighet_nn_1_N = mkN "undervisningsskyldighet" "undervisningsskyldigheter" ;
  undfallenhet_nn_1_N = mkN "undfallenhet" "undfallenheter" ;
  undflykt_nn_1_N = mkN "undflykt" "undflykter" ;
  undfaegnad_nn_1_1_N = mkN "undfägnad" "undfägnader" ;
  undsaettningsfond_nn_1_1_N = mkN "undsättningsfond" "undsättningsfonder" ;
  undulat_nn_1_N = mkN "undulat" "undulater" ;
  undulation_nn_1_N = mkN "undulation" "undulationer" ;
  ungdomsanstalt_nn_1_N = mkN "ungdomsanstalt" "ungdomsanstalter" ;
  ungdomsarbetsloeshet_nn_1_1_N = mkN "ungdomsarbetslöshet" "ungdomsarbetslösheter" ;
  ungdomsbrottslighet_nn_1_N = mkN "ungdomsbrottslighet" "ungdomsbrottsligheter" ;
  ungdomsfilm_nn_1_N = mkN "ungdomsfilm" "ungdomsfilmer" ;
  ungdomsgrupp_nn_1_N = mkN "ungdomsgrupp" "ungdomsgrupper" ;
  ungdomskonsulent_nn_1_N = mkN "ungdomskonsulent" "ungdomskonsulenter" ;
  ungdomskriminalitet_nn_1_N = mkN "ungdomskriminalitet" "ungdomskriminaliteter" ;
  ungdomsorganisation_nn_1_N = mkN "ungdomsorganisation" "ungdomsorganisationer" ;
  ungdomspraktikant_nn_1_N = mkN "ungdomspraktikant" "ungdomspraktikanter" ;
  ungdomsroerelse_nn_1_1_N = mkN "ungdomsrörelse" "ungdomsrörelser" ;
  ungdomssynd_nn_1_N = mkN "ungdomssynd" "ungdomssynder" ;
  ungdomstid_nn_1_N = mkN "ungdomstid" "ungdomstider" ;
  ungdomsverksamhet_nn_1_N = mkN "ungdomsverksamhet" "ungdomsverksamheter" ;
  uniform_nn_1_N = mkN "uniform" "uniformer" ;
  uniformitet_nn_1_N = mkN "uniformitet" "uniformiteter" ;
  union_nn_1_N = mkN "union" "unioner" ;
  unitarie_nn_1_N = mkN "unitarie" "unitarier" ;
  universalitet_nn_1_N = mkN "universalitet" "universaliteter" ;
  universitetsadjunkt_nn_1_N = mkN "universitetsadjunkt" "universitetsadjunkter" ;
  universitetsfilial_nn_1_N = mkN "universitetsfilial" "universitetsfilialer" ;
  universitetsinstitution_nn_1_N = mkN "universitetsinstitution" "universitetsinstitutioner" ;
  universitetsstad_nn_1_N = mkN "universitetsstad" "universitetsstäder" ;
  uppbyggnad_nn_1_N = mkN "uppbyggnad" "uppbyggnader" ;
  uppboerd_nn_1_1_N = mkN "uppbörd" "uppbörder" ;
  uppboerdslaengd_nn_1_1_N = mkN "uppbördslängd" "uppbördslängder" ;
  uppboerdstermin_nn_1_1_N = mkN "uppbördstermin" "uppbördsterminer" ;
  uppdragsskribent_nn_1_N = mkN "uppdragsskribent" "uppdragsskribenter" ;
  uppehaallsort_nn_1_1_N = mkN "uppehållsort" "uppehållsorter" ;
  uppenbarelse_nn_1_N = mkN "uppenbarelse" "uppenbarelser" ;
  uppenbarelsereligion_nn_1_N = mkN "uppenbarelsereligion" "uppenbarelsereligioner" ;
  uppfart_nn_1_N = mkN "uppfart" "uppfarter" ;
  uppfartsramp_nn_1_N = mkN "uppfartsramp" "uppfartsramper" ;
  uppfostringsanstalt_nn_1_N = mkN "uppfostringsanstalt" "uppfostringsanstalter" ;
  uppgift_nn_1_N = mkN "uppgift" "uppgifter" ;
  uppgivenhet_nn_1_N = mkN "uppgivenhet" "uppgivenheter" ;
  uppgaeld_nn_1_1_N = mkN "uppgäld" "uppgälder" ;
  uppgoerelse_nn_1_1_N = mkN "uppgörelse" "uppgörelser" ;
  upphoejdhet_nn_1_1_N = mkN "upphöjdhet" "upphöjdheter" ;
  upphoejelse_nn_1_1_N = mkN "upphöjelse" "upphöjelser" ;
  uppkaeftighet_nn_1_1_N = mkN "uppkäftighet" "uppkäftigheter" ;
  uppkoerningsramp_nn_1_1_N = mkN "uppkörningsramp" "uppkörningsramper" ;
  upplagscell_nn_1_N = mkN "upplagscell" "upplagsceller" ;
  upplevelse_nn_1_N = mkN "upplevelse" "upplevelser" ;
  upplaatelse_nn_1_1_N = mkN "upplåtelse" "upplåtelser" ;
  uppmaerksamhet_nn_1_1_N = mkN "uppmärksamhet" "uppmärksamheter" ;
  uppriktighet_nn_1_N = mkN "uppriktighet" "uppriktigheter" ;
  upprinnelse_nn_1_N = mkN "upprinnelse" "upprinnelser" ;
  uppraettelse_nn_1_1_N = mkN "upprättelse" "upprättelser" ;
  uppskalningsmoejlighet_nn_1_1_N = mkN "uppskalningsmöjlighet" "uppskalningsmöjligheter" ;
  uppslagsform_nn_1_N = mkN "uppslagsform" "uppslagsformer" ;
  uppstad_nn_1_N = mkN "uppstad" "uppstäder" ;
  uppstickarbank_nn_1_N = mkN "uppstickarbank" "uppstickarbanker" ;
  uppsyn_nn_1_N = mkN "uppsyn" "uppsyner" ;
  uppsaegelse_nn_1_1_N = mkN "uppsägelse" "uppsägelser" ;
  uppsaegningstermin_nn_1_1_N = mkN "uppsägningstermin" "uppsägningsterminer" ;
  uppsaegningstid_nn_1_1_N = mkN "uppsägningstid" "uppsägningstider" ;
  upptagenhet_nn_1_N = mkN "upptagenhet" "upptagenheter" ;
  upptakt_nn_1_N = mkN "upptakt" "upptakter" ;
  upptuktelse_nn_1_N = mkN "upptuktelse" "upptuktelser" ;
  upptaeckt_nn_1_1_N = mkN "upptäckt" "upptäckter" ;
  upptaecktsfaerd_nn_1_1_N = mkN "upptäcktsfärd" "upptäcktsfärder" ;
  uppvaeckelse_nn_1_1_N = mkN "uppväckelse" "uppväckelser" ;
  ur_ur_kroppen_upplevelse_nn_1_N = mkN "ur-ur-kroppen-upplevelse" "ur-ur-kroppen-upplevelser" ;
  uraktlaatenhet_nn_1_1_N = mkN "uraktlåtenhet" "uraktlåtenheter" ;
  urbanitet_nn_1_N = mkN "urbanitet" "urbaniteter" ;
  urbergsterraeng_nn_1_1_N = mkN "urbergsterräng" "urbergsterränger" ;
  urbild_nn_1_N = mkN "urbild" "urbilder" ;
  urcell_nn_1_N = mkN "urcell" "urceller" ;
  urdjurscell_nn_1_N = mkN "urdjurscell" "urdjursceller" ;
  urdaalighet_nn_1_1_N = mkN "urdålighet" "urdåligheter" ;
  urexplosion_nn_1_N = mkN "urexplosion" "urexplosioner" ;
  urform_nn_1_N = mkN "urform" "urformer" ;
  urformation_nn_1_N = mkN "urformation" "urformationer" ;
  uridom_nn_1_N = mkN "uridom" "uridomer" ;
  urinoar_nn_1_N = mkN "urinoar" "urinoarer" ;
  urinstinkt_nn_1_N = mkN "urinstinkt" "urinstinkter" ;
  urinvaegsinfektion_nn_1_1_N = mkN "urinvägsinfektion" "urinvägsinfektioner" ;
  urkund_nn_1_N = mkN "urkund" "urkunder" ;
  urminneshaevd_nn_1_1_N = mkN "urminneshävd" "urminneshävder" ;
  urogenitalapparat_nn_1_N = mkN "urogenitalapparat" "urogenitalapparater" ;
  ursame_nn_1_N = mkN "ursame" "ursamer" ;
  ursprungsart_nn_1_N = mkN "ursprungsart" "ursprungsarter" ;
  ursprungscell_nn_1_N = mkN "ursprungscell" "ursprungsceller" ;
  ursprungsdokumentation_nn_1_N = mkN "ursprungsdokumentation" "ursprungsdokumentationer" ;
  ursprungsort_nn_1_N = mkN "ursprungsort" "ursprungsorter" ;
  ursaekt_nn_1_1_N = mkN "ursäkt" "ursäkter" ;
  urtyp_nn_1_N = mkN "urtyp" "urtyper" ;
  uschlighet_nn_1_N = mkN "uschlighet" "uschligheter" ;
  uselhet_nn_1_N = mkN "uselhet" "uselheter" ;
  uslighet_nn_1_N = mkN "uslighet" "usligheter" ;
  usurpation_nn_1_N = mkN "usurpation" "usurpationer" ;
  utanfoerskapsmarkoer_nn_1_1_N = mkN "utanförskapsmarkör" "utanförskapsmarkörer" ;
  utanpaaskrift_nn_1_1_N = mkN "utanpåskrift" "utanpåskrifter" ;
  utanskrift_nn_1_N = mkN "utanskrift" "utanskrifter" ;
  utbildningsexplosion_nn_1_N = mkN "utbildningsexplosion" "utbildningsexplosioner" ;
  utbildningslinje_nn_1_N = mkN "utbildningslinje" "utbildningslinjer" ;
  utbildningstid_nn_1_N = mkN "utbildningstid" "utbildningstider" ;
  utbo_nn_1_N = mkN "utbo" "utbor" ;
  utbrytarregion_nn_1_N = mkN "utbrytarregion" "utbrytarregioner" ;
  utbrytarrepublik_nn_1_N = mkN "utbrytarrepublik" "utbrytarrepubliker" ;
  utbrytarstat_nn_1_N = mkN "utbrytarstat" "utbrytarstater" ;
  utbyggnad_nn_1_N = mkN "utbyggnad" "utbyggnader" ;
  utbytbarhet_nn_1_N = mkN "utbytbarhet" "utbytbarheter" ;
  utfallsrymd_nn_1_N = mkN "utfallsrymd" "utfallsrymder" ;
  utfart_nn_1_N = mkN "utfart" "utfarter" ;
  utflykt_nn_1_N = mkN "utflykt" "utflykter" ;
  utflyttningslaengd_nn_1_1_N = mkN "utflyttningslängd" "utflyttningslängder" ;
  utflaekartrend_nn_1_1_N = mkN "utfläkartrend" "utfläkartrender" ;
  utfodringsjournal_nn_1_N = mkN "utfodringsjournal" "utfodringsjournaler" ;
  utfodringsstat_nn_1_N = mkN "utfodringsstat" "utfodringsstater" ;
  utfyllnad_nn_1_N = mkN "utfyllnad" "utfyllnader" ;
  utfaerd_nn_1_1_N = mkN "utfärd" "utfärder" ;
  utfaestelse_nn_1_1_N = mkN "utfästelse" "utfästelser" ;
  utgift_nn_1_N = mkN "utgift" "utgifter" ;
  utgiftsverifikation_nn_1_N = mkN "utgiftsverifikation" "utgiftsverifikationer" ;
  utgjutelse_nn_1_N = mkN "utgjutelse" "utgjutelser" ;
  utgaangshastighet_nn_1_1_N = mkN "utgångshastighet" "utgångshastigheter" ;
  utgaangsposition_nn_1_1_N = mkN "utgångsposition" "utgångspositioner" ;
  utgaangspunkt_nn_1_1_N = mkN "utgångspunkt" "utgångspunkter" ;
  utgaangsrad_nn_1_1_N = mkN "utgångsrad" "utgångsrader" ;
  uthaallighet_nn_1_1_N = mkN "uthållighet" "uthålligheter" ;
  utkant_nn_1_N = mkN "utkant" "utkanter" ;
  utkikspunkt_nn_1_N = mkN "utkikspunkt" "utkikspunkter" ;
  utkorelse_nn_1_N = mkN "utkorelse" "utkorelser" ;
  utlandskorrespondent_nn_1_N = mkN "utlandskorrespondent" "utlandskorrespondenter" ;
  utlaatelse_nn_1_1_N = mkN "utlåtelse" "utlåtelser" ;
  utmark_nn_1_N = mkN "utmark" "utmarker" ;
  utmattningsdepression_nn_1_N = mkN "utmattningsdepression" "utmattningsdepressioner" ;
  utmaerkelse_nn_1_1_N = mkN "utmärkelse" "utmärkelser" ;
  utomhusbar_nn_1_N = mkN "utomhusbar" "utomhusbarer" ;
  utomhuskonsert_nn_1_N = mkN "utomhuskonsert" "utomhuskonserter" ;
  utomhusvistelse_nn_1_N = mkN "utomhusvistelse" "utomhusvistelser" ;
  utpressningssituation_nn_1_N = mkN "utpressningssituation" "utpressningssituationer" ;
  utrikesdebatt_nn_1_N = mkN "utrikesdebatt" "utrikesdebatter" ;
  utrikesdeklaration_nn_1_N = mkN "utrikesdeklaration" "utrikesdeklarationer" ;
  utrikeskorrespondent_nn_1_N = mkN "utrikeskorrespondent" "utrikeskorrespondenter" ;
  utrymmesstandard_nn_1_N = mkN "utrymmesstandard" "utrymmesstandarder" ;
  utsikt_nn_1_N = mkN "utsikt" "utsikter" ;
  utsiktspunkt_nn_1_N = mkN "utsiktspunkt" "utsiktspunkter" ;
  utskottsmajoritet_nn_1_N = mkN "utskottsmajoritet" "utskottsmajoriteter" ;
  utskrift_nn_1_N = mkN "utskrift" "utskrifter" ;
  utskyld_nn_1_N = mkN "utskyld" "utskylder" ;
  utslaeppsnation_nn_1_1_N = mkN "utsläppsnation" "utsläppsnationer" ;
  utslaeppsraett_nn_1_1_N = mkN "utsläppsrätt" "utsläppsrätter" ;
  utstaellelse_nn_1_1_N = mkN "utställelse" "utställelser" ;
  utsoekthet_nn_1_1_N = mkN "utsökthet" "utsöktheter" ;
  uttrycksform_nn_1_N = mkN "uttrycksform" "uttrycksformer" ;
  utvecklingsgrad_nn_1_N = mkN "utvecklingsgrad" "utvecklingsgrader" ;
  utvecklingslinje_nn_1_N = mkN "utvecklingslinje" "utvecklingslinjer" ;
  utvecklingsmoejlighet_nn_1_1_N = mkN "utvecklingsmöjlighet" "utvecklingsmöjligheter" ;
  utvecklingsserie_nn_1_N = mkN "utvecklingsserie" "utvecklingsserier" ;
  utvikningsbild_nn_1_N = mkN "utvikningsbild" "utvikningsbilder" ;
  utvinnelsegrad_nn_1_N = mkN "utvinnelsegrad" "utvinnelsegrader" ;
  utvaerderingsenhet_nn_1_1_N = mkN "utvärderingsenhet" "utvärderingsenheter" ;
  uvertyr_nn_1_N = mkN "uvertyr" "uvertyrer" ;
  vaccination_nn_1_N = mkN "vaccination" "vaccinationer" ;
  vaccinatoer_nn_1_1_N = mkN "vaccinatör" "vaccinatörer" ;
  vacuumtoalett_nn_1_N = mkN "vacuumtoalett" "vacuumtoaletter" ;
  vagabond_nn_1_N = mkN "vagabond" "vagabonder" ;
  vaggsaang_nn_1_1_N = mkN "vaggsång" "vaggsånger" ;
  vagnpark_nn_1_N = mkN "vagnpark" "vagnparker" ;
  vakansvikarie_nn_1_N = mkN "vakansvikarie" "vakansvikarier" ;
  vaknatt_nn_1_N = mkN "vaknatt" "vaknätter" ;
  vaksination_nn_1_N = mkN "vaksination" "vaksinationer" ;
  vaksinatoer_nn_1_1_N = mkN "vaksinatör" "vaksinatörer" ;
  vakt_nn_1_N = mkN "vakt" "vakter" ;
  vaktparad_nn_1_N = mkN "vaktparad" "vaktparader" ;
  vaktuniform_nn_1_N = mkN "vaktuniform" "vaktuniformer" ;
  vakuumtoalett_nn_1_N = mkN "vakuumtoalett" "vakuumtoaletter" ;
  valack_nn_1_N = mkN "valack" "valacker" ;
  valapparat_nn_1_N = mkN "valapparat" "valapparater" ;
  valdebatt_nn_1_N = mkN "valdebatt" "valdebatter" ;
  valfrihet_nn_1_N = mkN "valfrihet" "valfriheter" ;
  valfraendskap_nn_1_1_N = mkN "valfrändskap" "valfrändskaper" ;
  valgranskningsskommission_nn_1_N = mkN "valgranskningsskommission" "valgranskningsskommissioner" ;
  valhemlighet_nn_1_N = mkN "valhemlighet" "valhemligheter" ;
  valhaenthet_nn_1_1_N = mkN "valhänthet" "valhäntheter" ;
  validitet_nn_1_N = mkN "validitet" "validiteter" ;
  valkarstaang_nn_1_1_N = mkN "valkarstång" "valkarstänger" ;
  valkommission_nn_1_N = mkN "valkommission" "valkommissioner" ;
  vallbonde_nn_1_N = mkN "vallbonde" "vallbönder" ;
  vallfart_nn_1_N = mkN "vallfart" "vallfarter" ;
  vallfartsort_nn_1_N = mkN "vallfartsort" "vallfartsorter" ;
  vallfaerd_nn_1_1_N = mkN "vallfärd" "vallfärder" ;
  vallmo_nn_1_N = mkN "vallmo" "vallmor" ;
  vallningstabell_nn_1_N = mkN "vallningstabell" "vallningstabeller" ;
  vallokal_nn_1_N = mkN "vallokal" "vallokaler" ;
  vallaengd_nn_1_1_N = mkN "vallängd" "vallängder" ;
  valmanskaar_nn_1_1_N = mkN "valmanskår" "valmanskårer" ;
  valmoejlighet_nn_1_1_N = mkN "valmöjlighet" "valmöjligheter" ;
  valobservatoer_nn_1_1_N = mkN "valobservatör" "valobservatörer" ;
  valorisation_nn_1_N = mkN "valorisation" "valorisationer" ;
  valparoll_nn_1_N = mkN "valparoll" "valparoller" ;
  valroerelse_nn_1_1_N = mkN "valrörelse" "valrörelser" ;
  valsituation_nn_1_N = mkN "valsituation" "valsituationer" ;
  valspurt_nn_1_N = mkN "valspurt" "valspurter" ;
  valstakt_nn_1_N = mkN "valstakt" "valstakter" ;
  valstugeaffaer_nn_1_1_N = mkN "valstugeaffär" "valstugeaffärer" ;
  valsaang_nn_1_1_N = mkN "valsång" "valsånger" ;
  valsoer_nn_1_1_N = mkN "valsör" "valsörer" ;
  valupptakt_nn_1_N = mkN "valupptakt" "valupptakter" ;
  valutaaffaer_nn_1_1_N = mkN "valutaaffär" "valutaaffärer" ;
  valutafond_nn_1_N = mkN "valutafond" "valutafonder" ;
  valutaklausul_nn_1_N = mkN "valutaklausul" "valutaklausuler" ;
  valutareserv_nn_1_N = mkN "valutareserv" "valutareserver" ;
  valutaunion_nn_1_N = mkN "valutaunion" "valutaunioner" ;
  valoer_nn_1_1_N = mkN "valör" "valörer" ;
  vampyr_nn_1_N = mkN "vampyr" "vampyrer" ;
  vanart_nn_1_N = mkN "vanart" "vanarter" ;
  vandrarcell_nn_1_N = mkN "vandrarcell" "vandrarceller" ;
  vandringscell_nn_1_N = mkN "vandringscell" "vandringsceller" ;
  vandringsled_nn_1_N = mkN "vandringsled" "vandringsleder" ;
  vandringspokal_nn_1_N = mkN "vandringspokal" "vandringspokaler" ;
  vanesak_nn_1_N = mkN "vanesak" "vanesaker" ;
  vanfoerhet_nn_1_1_N = mkN "vanförhet" "vanförheter" ;
  vanillin_nn_1_N = mkN "vanillin" "vanilliner" ;
  vankant_nn_1_N = mkN "vankant" "vankanter" ;
  vanlighet_nn_1_N = mkN "vanlighet" "vanligheter" ;
  vanprydnad_nn_1_N = mkN "vanprydnad" "vanprydnader" ;
  vansinnighet_nn_1_N = mkN "vansinnighet" "vansinnigheter" ;
  vanskapnad_nn_1_N = mkN "vanskapnad" "vanskapnader" ;
  vanskapthet_nn_1_N = mkN "vanskapthet" "vanskaptheter" ;
  vansklighet_nn_1_N = mkN "vansklighet" "vanskligheter" ;
  vanvettighet_nn_1_N = mkN "vanvettighet" "vanvettigheter" ;
  vanvoerdnad_nn_1_1_N = mkN "vanvördnad" "vanvördnader" ;
  vapenarsenal_nn_1_N = mkN "vapenarsenal" "vapenarsenaler" ;
  vapenfabrik_nn_1_N = mkN "vapenfabrik" "vapenfabriker" ;
  vapensmed_nn_1_N = mkN "vapensmed" "vapensmeder" ;
  vapentyp_nn_1_N = mkN "vapentyp" "vapentyper" ;
  vapoer_nn_1_1_N = mkN "vapör" "vapörer" ;
  varaktighet_nn_1_N = mkN "varaktighet" "varaktigheter" ;
  varboeld_nn_1_1_N = mkN "varböld" "varbölder" ;
  vardaglighet_nn_1_N = mkN "vardaglighet" "vardagligheter" ;
  vardagsangelaegenhet_nn_1_1_N = mkN "vardagsangelägenhet" "vardagsangelägenheter" ;
  vardagsraett_nn_1_1_N = mkN "vardagsrätt" "vardagsrätter" ;
  vardagsupplevelse_nn_1_N = mkN "vardagsupplevelse" "vardagsupplevelser" ;
  varelse_nn_1_N = mkN "varelse" "varelser" ;
  variabilitet_nn_1_N = mkN "variabilitet" "variabiliteter" ;
  variation_nn_1_N = mkN "variation" "variationer" ;
  variationsbredd_nn_1_N = mkN "variationsbredd" "variationsbredder" ;
  varietet_nn_1_N = mkN "varietet" "varieteter" ;
  varjag_nn_1_N = mkN "varjag" "varjager" ;
  varmfront_nn_1_N = mkN "varmfront" "varmfronter" ;
  varmraett_nn_1_1_N = mkN "varmrätt" "varmrätter" ;
  varudeklaration_nn_1_N = mkN "varudeklaration" "varudeklarationer" ;
  varumaengd_nn_1_1_N = mkN "varumängd" "varumängder" ;
  vasall_nn_1_N = mkN "vasall" "vasaller" ;
  vasallstat_nn_1_N = mkN "vasallstat" "vasallstater" ;
  vattenbyggnad_nn_1_N = mkN "vattenbyggnad" "vattenbyggnader" ;
  vattenfaerg_nn_1_1_N = mkN "vattenfärg" "vattenfärger" ;
  vattenhalt_nn_1_N = mkN "vattenhalt" "vattenhalter" ;
  vattenhyacint_nn_1_N = mkN "vattenhyacint" "vattenhyacinter" ;
  vattenkanon_nn_1_N = mkN "vattenkanon" "vattenkanoner" ;
  vattenklosett_nn_1_N = mkN "vattenklosett" "vattenklosetter" ;
  vattenled_nn_1_N = mkN "vattenled" "vattenleder" ;
  vattenlinje_nn_1_N = mkN "vattenlinje" "vattenlinjer" ;
  vattenloeslighet_nn_1_1_N = mkN "vattenlöslighet" "vattenlösligheter" ;
  vattennymf_nn_1_N = mkN "vattennymf" "vattennymfer" ;
  vattenpostventil_nn_1_N = mkN "vattenpostventil" "vattenpostventiler" ;
  vattentaekt_nn_1_1_N = mkN "vattentäkt" "vattentäkter" ;
  vaudeville_nn_1_N = mkN "vaudeville" "vaudeviller" ;
  veckobiljett_nn_1_N = mkN "veckobiljett" "veckobiljetter" ;
  veckohelg_nn_1_N = mkN "veckohelg" "veckohelger" ;
  veckotablett_nn_1_N = mkN "veckotablett" "veckotabletter" ;
  veckotidningsnovell_nn_1_N = mkN "veckotidningsnovell" "veckotidningsnoveller" ;
  vedbrand_nn_1_N = mkN "vedbrand" "vedbränder" ;
  vederkvickelse_nn_1_N = mkN "vederkvickelse" "vederkvickelser" ;
  vederpart_nn_1_N = mkN "vederpart" "vederparter" ;
  vederstygglighet_nn_1_N = mkN "vederstygglighet" "vederstyggligheter" ;
  vedervaerdighet_nn_1_1_N = mkN "vedervärdighet" "vedervärdigheter" ;
  vegetation_nn_1_N = mkN "vegetation" "vegetationer" ;
  vegetationsperiod_nn_1_N = mkN "vegetationsperiod" "vegetationsperioder" ;
  vegetationszon_nn_1_N = mkN "vegetationszon" "vegetationszoner" ;
  veklighet_nn_1_N = mkN "veklighet" "vekligheter" ;
  velighet_nn_1_N = mkN "velighet" "veligheter" ;
  velociped_nn_1_N = mkN "velociped" "velocipeder" ;
  velodrom_nn_1_N = mkN "velodrom" "velodromer" ;
  ven_nn_1_N = mkN "ven" "vener" ;
  veneration_nn_1_N = mkN "veneration" "venerationer" ;
  ventilation_nn_1_N = mkN "ventilation" "ventilationer" ;
  ventilbasun_nn_1_N = mkN "ventilbasun" "ventilbasuner" ;
  verbalinspiration_nn_1_N = mkN "verbalinspiration" "verbalinspirationer" ;
  verbalitet_nn_1_N = mkN "verbalitet" "verbaliteter" ;
  verbalnot_nn_1_N = mkN "verbalnot" "verbalnoter" ;
  verbform_nn_1_N = mkN "verbform" "verbformer" ;
  verbaendelse_nn_1_1_N = mkN "verbändelse" "verbändelser" ;
  verifikation_nn_1_N = mkN "verifikation" "verifikationer" ;
  verklighet_nn_1_N = mkN "verklighet" "verkligheter" ;
  verklighetsbakgrund_nn_1_N = mkN "verklighetsbakgrund" "verklighetsbakgrunder" ;
  verklighetsbild_nn_1_N = mkN "verklighetsbild" "verklighetsbilder" ;
  verklighetschock_nn_1_N = mkN "verklighetschock" "verklighetschocker" ;
  verkningsgrad_nn_1_N = mkN "verkningsgrad" "verkningsgrader" ;
  verksamhet_nn_1_N = mkN "verksamhet" "verksamheter" ;
  verksamhetsberaettelse_nn_1_1_N = mkN "verksamhetsberättelse" "verksamhetsberättelser" ;
  verkshoejd_nn_1_1_N = mkN "verkshöjd" "verkshöjder" ;
  verkstad_nn_1_N = mkN "verkstad" "verkstäder" ;
  verkstaellighet_nn_1_1_N = mkN "verkställighet" "verkställigheter" ;
  verksynd_nn_1_N = mkN "verksynd" "verksynder" ;
  verktygsmaskin_nn_1_N = mkN "verktygsmaskin" "verktygsmaskiner" ;
  vernissage_nn_1_N = mkN "vernissage" "vernissager" ;
  versal_nn_1_N = mkN "versal" "versaler" ;
  versberaettelse_nn_1_1_N = mkN "versberättelse" "versberättelser" ;
  versifikation_nn_1_N = mkN "versifikation" "versifikationer" ;
  versifikatoer_nn_1_1_N = mkN "versifikatör" "versifikatörer" ;
  version_nn_1_N = mkN "version" "versioner" ;
  versrad_nn_1_N = mkN "versrad" "versrader" ;
  vertebrat_nn_1_N = mkN "vertebrat" "vertebrater" ;
  vertikal_nn_1_N = mkN "vertikal" "vertikaler" ;
  vertikalprojektion_nn_1_N = mkN "vertikalprojektion" "vertikalprojektioner" ;
  vestal_nn_1_N = mkN "vestal" "vestaler" ;
  vestibul_nn_1_N = mkN "vestibul" "vestibuler" ;
  vetebroedslaengd_nn_1_1_N = mkN "vetebrödslängd" "vetebrödslängder" ;
  vetelaengd_nn_1_1_N = mkN "vetelängd" "vetelängder" ;
  vetenskap_nn_1_N = mkN "vetenskap" "vetenskaper" ;
  veterinaer_nn_1_1_N = mkN "veterinär" "veterinärer" ;
  vetesort_nn_1_N = mkN "vetesort" "vetesorter" ;
  vettighet_nn_1_N = mkN "vettighet" "vettigheter" ;
  vettloeshet_nn_1_1_N = mkN "vettlöshet" "vettlösheter" ;
  vettvillighet_nn_1_N = mkN "vettvillighet" "vettvilligheter" ;
  vevstaang_nn_1_1_N = mkN "vevstång" "vevstänger" ;
  viadukt_nn_1_N = mkN "viadukt" "viadukter" ;
  vial_nn_1_N = mkN "vial" "vialer" ;
  vibration_nn_1_N = mkN "vibration" "vibrationer" ;
  viceamiral_nn_1_N = mkN "viceamiral" "viceamiraler" ;
  vicekorpral_nn_1_N = mkN "vicekorpral" "vicekorpraler" ;
  vicepresident_nn_1_N = mkN "vicepresident" "vicepresidenter" ;
  vicepresidentkandidat_nn_1_N = mkN "vicepresidentkandidat" "vicepresidentkandidater" ;
  vidd_nn_1_N = mkN "vidd" "vidder" ;
  video_nn_1_N = mkN "video" "videor" ;
  videoaffaer_nn_1_1_N = mkN "videoaffär" "videoaffärer" ;
  videobutik_nn_1_N = mkN "videobutik" "videobutiker" ;
  videofilm_nn_1_N = mkN "videofilm" "videofilmer" ;
  videregion_nn_1_N = mkN "videregion" "videregioner" ;
  vidfilm_nn_1_N = mkN "vidfilm" "vidfilmer" ;
  vidimation_nn_1_N = mkN "vidimation" "vidimationer" ;
  vidlyftighet_nn_1_N = mkN "vidlyftighet" "vidlyftigheter" ;
  vidrighet_nn_1_N = mkN "vidrighet" "vidrigheter" ;
  vidskepelse_nn_1_N = mkN "vidskepelse" "vidskepelser" ;
  vidskeplighet_nn_1_N = mkN "vidskeplighet" "vidskepligheter" ;
  vidsynthet_nn_1_N = mkN "vidsynthet" "vidsyntheter" ;
  vidunderlighet_nn_1_N = mkN "vidunderlighet" "vidunderligheter" ;
  vielle_nn_1_N = mkN "vielle" "vieller" ;
  vigselakt_nn_1_N = mkN "vigselakt" "vigselakter" ;
  vikarie_nn_1_N = mkN "vikarie" "vikarier" ;
  viktenhet_nn_1_N = mkN "viktenhet" "viktenheter" ;
  viktighet_nn_1_N = mkN "viktighet" "viktigheter" ;
  viktnedgaangsaatgaerd_nn_1_1_N = mkN "viktnedgångsåtgärd" "viktnedgångsåtgärder" ;
  viktskillnad_nn_1_N = mkN "viktskillnad" "viktskillnader" ;
  vildand_nn_1_N = mkN "vildand" "vildänder" ;
  vildkatt_nn_1_N = mkN "vildkatt" "vildkatter" ;
  vildmark_nn_1_N = mkN "vildmark" "vildmarker" ;
  vildmarksbrand_nn_1_N = mkN "vildmarksbrand" "vildmarksbränder" ;
  vildnad_nn_1_N = mkN "vildnad" "vildnader" ;
  vildrensjakt_nn_1_N = mkN "vildrensjakt" "vildrensjakter" ;
  vilfaatoelj_nn_1_1_N = mkN "vilfåtölj" "vilfåtöljer" ;
  viljeakt_nn_1_N = mkN "viljeakt" "viljeakter" ;
  villabrand_nn_1_N = mkN "villabrand" "villabränder" ;
  villanell_nn_1_N = mkN "villanell" "villaneller" ;
  villatomt_nn_1_N = mkN "villatomt" "villatomter" ;
  villfarelse_nn_1_N = mkN "villfarelse" "villfarelser" ;
  villkorskonjunktion_nn_1_N = mkN "villkorskonjunktion" "villkorskonjunktioner" ;
  vilopunkt_nn_1_N = mkN "vilopunkt" "vilopunkter" ;
  vimperg_nn_1_N = mkN "vimperg" "vimperger" ;
  vinbaerssaft_nn_1_1_N = mkN "vinbärssaft" "vinbärssafter" ;
  vindhastighet_nn_1_N = mkN "vindhastighet" "vindhastigheter" ;
  vindikation_nn_1_N = mkN "vindikation" "vindikationer" ;
  vindsbrand_nn_1_N = mkN "vindsbrand" "vindsbränder" ;
  vingbredd_nn_1_N = mkN "vingbredd" "vingbredder" ;
  vingfrukt_nn_1_N = mkN "vingfrukt" "vingfrukter" ;
  vinjett_nn_1_N = mkN "vinjett" "vinjetter" ;
  vinkelacceleration_nn_1_N = mkN "vinkelacceleration" "vinkelaccelerationer" ;
  vinkelhastighet_nn_1_N = mkN "vinkelhastighet" "vinkelhastigheter" ;
  vinkelskillnad_nn_1_N = mkN "vinkelskillnad" "vinkelskillnader" ;
  vinnarinstinkt_nn_1_N = mkN "vinnarinstinkt" "vinnarinstinkter" ;
  vinningslystnad_nn_1_N = mkN "vinningslystnad" "vinningslystnader" ;
  vinorganisation_nn_1_N = mkN "vinorganisation" "vinorganisationer" ;
  vinraettighet_nn_1_1_N = mkN "vinrättighet" "vinrättigheter" ;
  vinsort_nn_1_N = mkN "vinsort" "vinsorter" ;
  vinstlott_nn_1_N = mkN "vinstlott" "vinstlotter" ;
  vinstmarginal_nn_1_N = mkN "vinstmarginal" "vinstmarginaler" ;
  vinstmaskin_nn_1_N = mkN "vinstmaskin" "vinstmaskiner" ;
  vinterbostad_nn_1_N = mkN "vinterbostad" "vinterbostäder" ;
  vinterdraekt_nn_1_1_N = mkN "vinterdräkt" "vinterdräkter" ;
  vinterfrukt_nn_1_N = mkN "vinterfrukt" "vinterfrukter" ;
  vinteridrott_nn_1_N = mkN "vinteridrott" "vinteridrotter" ;
  vinterleksak_nn_1_N = mkN "vinterleksak" "vinterleksaker" ;
  vintermaanad_nn_1_1_N = mkN "vintermånad" "vintermånader" ;
  vinternatt_nn_1_N = mkN "vinternatt" "vinternätter" ;
  vintersport_nn_1_N = mkN "vintersport" "vintersporter" ;
  vintertroetthet_nn_1_1_N = mkN "vintertrötthet" "vintertröttheter" ;
  viol_nn_1_N = mkN "viol" "violer" ;
  violinklav_nn_1_N = mkN "violinklav" "violinklaver" ;
  violoncell_nn_1_N = mkN "violoncell" "violonceller" ;
  virilitet_nn_1_N = mkN "virilitet" "viriliteter" ;
  virkeskvalitet_nn_1_N = mkN "virkeskvalitet" "virkeskvaliteter" ;
  virrighet_nn_1_N = mkN "virrighet" "virrigheter" ;
  virtuositet_nn_1_N = mkN "virtuositet" "virtuositeter" ;
  virusinfektion_nn_1_N = mkN "virusinfektion" "virusinfektioner" ;
  virvelroerelse_nn_1_1_N = mkN "virvelrörelse" "virvelrörelser" ;
  viscount_nn_1_N = mkN "viscount" "viscounter" ;
  visdomstand_nn_1_N = mkN "visdomstand" "visdomständer" ;
  visent_nn_1_N = mkN "visent" "visenter" ;
  vishet_nn_1_N = mkN "vishet" "visheter" ;
  vision_nn_1_N = mkN "vision" "visioner" ;
  visionaer_nn_1_1_N = mkN "visionär" "visionärer" ;
  visitation_nn_1_N = mkN "visitation" "visitationer" ;
  viskositet_nn_1_N = mkN "viskositet" "viskositeter" ;
  visshet_nn_1_N = mkN "visshet" "vissheter" ;
  vistelse_nn_1_N = mkN "vistelse" "vistelser" ;
  vistelseort_nn_1_N = mkN "vistelseort" "vistelseorter" ;
  vitalf_nn_1_N = mkN "vitalf" "vitalfer" ;
  vitalfoernimmelse_nn_1_1_N = mkN "vitalförnimmelse" "vitalförnimmelser" ;
  vitalitet_nn_1_N = mkN "vitalitet" "vitaliteter" ;
  vitalkapacitet_nn_1_N = mkN "vitalkapacitet" "vitalkapaciteter" ;
  vitalv_nn_1_N = mkN "vitalv" "vitalver" ;
  vitamin_nn_1_N = mkN "vitamin" "vitaminer" ;
  vitamininjektion_nn_1_N = mkN "vitamininjektion" "vitamininjektioner" ;
  vithet_nn_1_N = mkN "vithet" "vitheter" ;
  vitmetall_nn_1_N = mkN "vitmetall" "vitmetaller" ;
  vitnad_nn_1_N = mkN "vitnad" "vitnader" ;
  vitsighet_nn_1_N = mkN "vitsighet" "vitsigheter" ;
  vitterhet_nn_1_N = mkN "vitterhet" "vitterheter" ;
  vittnesed_nn_1_N = mkN "vittnesed" "vittneseder" ;
  vittneskonfrontation_nn_1_N = mkN "vittneskonfrontation" "vittneskonfrontationer" ;
  vittnesuppgift_nn_1_N = mkN "vittnesuppgift" "vittnesuppgifter" ;
  vivacitet_nn_1_N = mkN "vivacitet" "vivaciteter" ;
  vivisektion_nn_1_N = mkN "vivisektion" "vivisektioner" ;
  vivisektoer_nn_1_1_N = mkN "vivisektör" "vivisektörer" ;
  vivoer_nn_1_1_N = mkN "vivör" "vivörer" ;
  voidkoefficient_nn_1_N = mkN "voidkoefficient" "voidkoefficienter" ;
  vokabulaer_nn_1_1_N = mkN "vokabulär" "vokabulärer" ;
  vokal_nn_1_N = mkN "vokal" "vokaler" ;
  vokalisation_nn_1_N = mkN "vokalisation" "vokalisationer" ;
  vokalkvalitet_nn_1_N = mkN "vokalkvalitet" "vokalkvaliteter" ;
  vokalkvantitet_nn_1_N = mkN "vokalkvantitet" "vokalkvantiteter" ;
  vokallaengd_nn_1_1_N = mkN "vokallängd" "vokallängder" ;
  volauvent_nn_1_N = mkN "volauvent" "volauventer" ;
  voljaer_nn_1_1_N = mkN "voljär" "voljärer" ;
  volontaer_nn_1_1_N = mkN "volontär" "volontärer" ;
  voltige_nn_1_N = mkN "voltige" "voltiger" ;
  voltigoer_nn_1_1_N = mkN "voltigör" "voltigörer" ;
  volut_nn_1_N = mkN "volut" "voluter" ;
  volym_nn_1_N = mkN "volym" "volymer" ;
  volymenhet_nn_1_N = mkN "volymenhet" "volymenheter" ;
  volymsenhet_nn_1_N = mkN "volymsenhet" "volymsenheter" ;
  voyeur_nn_1_N = mkN "voyeur" "voyeurer" ;
  vresighet_nn_1_N = mkN "vresighet" "vresigheter" ;
  vridled_nn_1_N = mkN "vridled" "vridleder" ;
  vridscen_nn_1_N = mkN "vridscen" "vridscener" ;
  vraekighet_nn_1_1_N = mkN "vräkighet" "vräkigheter" ;
  vraangbild_nn_1_1_N = mkN "vrångbild" "vrångbilder" ;
  vraanghet_nn_1_1_N = mkN "vrånghet" "vrångheter" ;
  vulgaritet_nn_1_N = mkN "vulgaritet" "vulgariteter" ;
  vulkapparat_nn_1_N = mkN "vulkapparat" "vulkapparater" ;
  vaederobservation_nn_1_1_N = mkN "väderobservation" "väderobservationer" ;
  vaegbomb_nn_1_1_N = mkN "vägbomb" "vägbomber" ;
  vaegegenskap_nn_1_1_N = mkN "vägegenskap" "vägegenskaper" ;
  vaeggbonad_nn_1_1_N = mkN "väggbonad" "väggbonader" ;
  vaegkant_nn_1_1_N = mkN "vägkant" "vägkanter" ;
  vaegmaskin_nn_1_1_N = mkN "vägmaskin" "vägmaskiner" ;
  vaekt_nn_1_1_N = mkN "väkt" "väkter" ;
  vaeldighet_nn_1_1_N = mkN "väldighet" "väldigheter" ;
  vaelfaegnad_nn_1_1_N = mkN "välfägnad" "välfägnader" ;
  vaelfaerdsstat_nn_1_1_N = mkN "välfärdsstat" "välfärdsstater" ;
  vaelgoerenhet_nn_1_1_N = mkN "välgörenhet" "välgörenheter" ;
  vaelgoerenhetsbasar_nn_1_1_N = mkN "välgörenhetsbasar" "välgörenhetsbasarer" ;
  vaelgoerenhetsorganisation_nn_1_1_N = mkN "välgörenhetsorganisation" "välgörenhetsorganisationer" ;
  vaeljarkaar_nn_1_1_N = mkN "väljarkår" "väljarkårer" ;
  vaellevnad_nn_1_1_N = mkN "vällevnad" "vällevnader" ;
  vaeltalighet_nn_1_1_N = mkN "vältalighet" "vältaligheter" ;
  vaelvillighet_nn_1_1_N = mkN "välvillighet" "välvilligheter" ;
  vaemjelighet_nn_1_1_N = mkN "vämjelighet" "vämjeligheter" ;
  vaendpunkt_nn_1_1_N = mkN "vändpunkt" "vändpunkter" ;
  vaenlighet_nn_1_1_N = mkN "vänlighet" "vänligheter" ;
  vaenort_nn_1_1_N = mkN "vänort" "vänorter" ;
  vaenskaplighet_nn_1_1_N = mkN "vänskaplighet" "vänskapligheter" ;
  vaensterhand_nn_1_1_N = mkN "vänsterhand" "vänsterhänder" ;
  vaensterkoalition_nn_1_1_N = mkN "vänsterkoalition" "vänsterkoalitioner" ;
  vaenstermyt_nn_1_1_N = mkN "vänstermyt" "vänstermyter" ;
  vaensteropposition_nn_1_1_N = mkN "vänsteropposition" "vänsteroppositioner" ;
  vaensterradikal_nn_1_1_N = mkN "vänsterradikal" "vänsterradikaler" ;
  vaenstersympatisoer_nn_1_1_N = mkN "vänstersympatisör" "vänstersympatisörer" ;
  vaensteraasikt_nn_1_1_N = mkN "vänsteråsikt" "vänsteråsikter" ;
  vaentetid_nn_1_1_N = mkN "väntetid" "väntetider" ;
  vaerdefullhet_nn_1_1_N = mkN "värdefullhet" "värdefullheter" ;
  vaerdegrund_nn_1_1_N = mkN "värdegrund" "värdegrunder" ;
  vaerdemaengd_nn_1_1_N = mkN "värdemängd" "värdemängder" ;
  vaerdepappersfond_nn_1_1_N = mkN "värdepappersfond" "värdepappersfonder" ;
  vaerdepappersmarknad_nn_1_1_N = mkN "värdepappersmarknad" "värdepappersmarknader" ;
  vaerderingsnorm_nn_1_1_N = mkN "värderingsnorm" "värderingsnormer" ;
  vaerdesak_nn_1_1_N = mkN "värdesak" "värdesaker" ;
  vaerdetabell_nn_1_1_N = mkN "värdetabell" "värdetabeller" ;
  vaerdfamilj_nn_1_1_N = mkN "värdfamilj" "värdfamiljer" ;
  vaerdighet_nn_1_1_N = mkN "värdighet" "värdigheter" ;
  vaerjemaalsed_nn_1_1_N = mkN "värjemålsed" "värjemålseder" ;
  vaerktablett_nn_1_1_N = mkN "värktablett" "värktabletter" ;
  vaerldsberoemdhet_nn_1_1_N = mkN "världsberömdhet" "världsberömdheter" ;
  vaerldsbild_nn_1_1_N = mkN "världsbild" "världsbilder" ;
  vaerldsbrand_nn_1_1_N = mkN "världsbrand" "världsbränder" ;
  vaerldscup_nn_1_1_N = mkN "världscup" "världscuper" ;
  vaerldsdam_nn_1_1_N = mkN "världsdam" "världsdamer" ;
  vaerldslighet_nn_1_1_N = mkN "världslighet" "världsligheter" ;
  vaerldsmakt_nn_1_1_N = mkN "världsmakt" "världsmakter" ;
  vaerldsmarknad_nn_1_1_N = mkN "världsmarknad" "världsmarknader" ;
  vaerldsorganisation_nn_1_1_N = mkN "världsorganisation" "världsorganisationer" ;
  vaerldsreligion_nn_1_1_N = mkN "världsreligion" "världsreligioner" ;
  vaerldsrevolution_nn_1_1_N = mkN "världsrevolution" "världsrevolutioner" ;
  vaerldsrymd_nn_1_1_N = mkN "världsrymd" "världsrymder" ;
  vaerldsstad_nn_1_1_N = mkN "världsstad" "världsstäder" ;
  vaerldstid_nn_1_1_N = mkN "världstid" "världstider" ;
  vaerldsaasikt_nn_1_1_N = mkN "världsåsikt" "världsåsikter" ;
  vaermeapparat_nn_1_1_N = mkN "värmeapparat" "värmeapparater" ;
  vaermebild_nn_1_1_N = mkN "värmebild" "värmebilder" ;
  vaermecentral_nn_1_1_N = mkN "värmecentral" "värmecentraler" ;
  vaermeenhet_nn_1_1_N = mkN "värmeenhet" "värmeenheter" ;
  vaermeexpansion_nn_1_1_N = mkN "värmeexpansion" "värmeexpansioner" ;
  vaermegrad_nn_1_1_N = mkN "värmegrad" "värmegrader" ;
  vaermekapacitet_nn_1_1_N = mkN "värmekapacitet" "värmekapaciteter" ;
  vaermekapacitivitet_nn_1_1_N = mkN "värmekapacitivitet" "värmekapacitiviteter" ;
  vaermekonduktivitet_nn_1_1_N = mkN "värmekonduktivitet" "värmekonduktiviteter" ;
  vaermekostnad_nn_1_1_N = mkN "värmekostnad" "värmekostnader" ;
  vaermemaengd_nn_1_1_N = mkN "värmemängd" "värmemängder" ;
  vaermningsfunktion_nn_1_1_N = mkN "värmningsfunktion" "värmningsfunktioner" ;
  vaernpliktsmyndighet_nn_1_1_N = mkN "värnpliktsmyndighet" "värnpliktsmyndigheter" ;
  vaesentlighet_nn_1_1_N = mkN "väsentlighet" "väsentligheter" ;
  vaestfront_nn_1_1_N = mkN "västfront" "västfronter" ;
  vaestgot_nn_1_1_N = mkN "västgot" "västgoter" ;
  vaestkustsallad_nn_1_1_N = mkN "västkustsallad" "västkustsallader" ;
  vaestmakt_nn_1_1_N = mkN "västmakt" "västmakter" ;
  vaeteatom_nn_1_1_N = mkN "väteatom" "väteatomer" ;
  vaetebomb_nn_1_1_N = mkN "vätebomb" "vätebomber" ;
  vaetejonkoncentration_nn_1_1_N = mkN "vätejonkoncentration" "vätejonkoncentrationer" ;
  vaetekarbonat_nn_1_1_N = mkN "vätekarbonat" "vätekarbonater" ;
  vaevnad_nn_1_1_N = mkN "vävnad" "vävnader" ;
  vaevtyngd_nn_1_1_N = mkN "vävtyngd" "vävtyngder" ;
  vaexelaffaer_nn_1_1_N = mkN "växelaffär" "växelaffärer" ;
  vaexeldiskont_nn_1_1_N = mkN "växeldiskont" "växeldiskonter" ;
  vaexelgaeldenaer_nn_1_1_N = mkN "växelgäldenär" "växelgäldenärer" ;
  vaexelsaang_nn_1_1_N = mkN "växelsång" "växelsånger" ;
  vaexeltrassat_nn_1_1_N = mkN "växeltrassat" "växeltrassater" ;
  vaexeltrassent_nn_1_1_N = mkN "växeltrassent" "växeltrassenter" ;
  vaextart_nn_1_1_N = mkN "växtart" "växtarter" ;
  vaextcell_nn_1_1_N = mkN "växtcell" "växtceller" ;
  vaextfamilj_nn_1_1_N = mkN "växtfamilj" "växtfamiljer" ;
  vaextfaerg_nn_1_1_N = mkN "växtfärg" "växtfärger" ;
  vaextfoeljd_nn_1_1_N = mkN "växtföljd" "växtföljder" ;
  vaextlighet_nn_1_1_N = mkN "växtlighet" "växtligheter" ;
  vaextlokal_nn_1_1_N = mkN "växtlokal" "växtlokaler" ;
  vaextmargarin_nn_1_1_N = mkN "växtmargarin" "växtmargariner" ;
  vaextperiod_nn_1_1_N = mkN "växtperiod" "växtperioder" ;
  vaextsaft_nn_1_1_N = mkN "växtsaft" "växtsafter" ;
  vaextvaevnad_nn_1_1_N = mkN "växtvävnad" "växtvävnader" ;
  vaagform_nn_1_1_N = mkN "vågform" "vågformer" ;
  vaagfront_nn_1_1_N = mkN "vågfront" "vågfronter" ;
  vaaghalsighet_nn_1_1_N = mkN "våghalsighet" "våghalsigheter" ;
  vaaghoejd_nn_1_1_N = mkN "våghöjd" "våghöjder" ;
  vaaglaengd_nn_1_1_N = mkN "våglängd" "våglängder" ;
  vaagmaestarroll_nn_1_1_N = mkN "vågmästarroll" "vågmästarroller" ;
  vaaldsamhet_nn_1_1_N = mkN "våldsamhet" "våldsamheter" ;
  vaaldsmentalitet_nn_1_1_N = mkN "våldsmentalitet" "våldsmentaliteter" ;
  vaaldspiral_nn_1_1_N = mkN "våldspiral" "våldspiraler" ;
  vaaldsscen_nn_1_1_N = mkN "våldsscen" "våldsscener" ;
  vaaldtaekt_nn_1_1_N = mkN "våldtäkt" "våldtäkter" ;
  vaalnad_nn_1_1_N = mkN "vålnad" "vålnader" ;
  vaardanstalt_nn_1_1_N = mkN "vårdanstalt" "vårdanstalter" ;
  vaardcentral_nn_1_1_N = mkN "vårdcentral" "vårdcentraler" ;
  vaardepression_nn_1_1_N = mkN "vårdepression" "vårdepressioner" ;
  vaardklinik_nn_1_1_N = mkN "vårdklinik" "vårdkliniker" ;
  vaardnad_nn_1_1_N = mkN "vårdnad" "vårdnader" ;
  vaardsloeshet_nn_1_1_N = mkN "vårdslöshet" "vårdslösheter" ;
  vaarmaanad_nn_1_1_N = mkN "vårmånad" "vårmånader" ;
  vaartermin_nn_1_1_N = mkN "vårtermin" "vårterminer" ;
  vaartroetthet_nn_1_1_N = mkN "vårtrötthet" "vårtröttheter" ;
  vaarvial_nn_1_1_N = mkN "vårvial" "vårvialer" ;
  vaatmark_nn_1_1_N = mkN "våtmark" "våtmarker" ;
  vaatservett_nn_1_1_N = mkN "våtservett" "våtservetter" ;
  voerdnad_nn_1_1_N = mkN "vördnad" "vördnader" ;
  wattsekund_nn_1_N = mkN "wattsekund" "wattsekunder" ;
  webanonymitet_nn_1_N = mkN "webanonymitet" "webanonymiteter" ;
  westernfilm_nn_1_N = mkN "westernfilm" "westernfilmer" ;
  whiskysort_nn_1_N = mkN "whiskysort" "whiskysorter" ;
  yacht_nn_1_N = mkN "yacht" "yachter" ;
  yllevaevnad_nn_1_1_N = mkN "yllevävnad" "yllevävnader" ;
  yngelcell_nn_1_N = mkN "yngelcell" "yngelceller" ;
  ypperlighet_nn_1_N = mkN "ypperlighet" "ypperligheter" ;
  yrkesetik_nn_1_N = mkN "yrkesetik" "yrkesetiker" ;
  yrkesgrupp_nn_1_N = mkN "yrkesgrupp" "yrkesgrupper" ;
  yrkeshemlighet_nn_1_N = mkN "yrkeshemlighet" "yrkeshemligheter" ;
  yrkesinspektion_nn_1_N = mkN "yrkesinspektion" "yrkesinspektioner" ;
  yrkeskaar_nn_1_1_N = mkN "yrkeskår" "yrkeskårer" ;
  ytbergart_nn_1_N = mkN "ytbergart" "ytbergarter" ;
  yteffekt_nn_1_N = mkN "yteffekt" "yteffekter" ;
  ytenhet_nn_1_N = mkN "ytenhet" "ytenheter" ;
  ytform_nn_1_N = mkN "ytform" "ytformer" ;
  ytlighet_nn_1_N = mkN "ytlighet" "ytligheter" ;
  ytmoraen_nn_1_1_N = mkN "ytmorän" "ytmoräner" ;
  ytterkant_nn_1_N = mkN "ytterkant" "ytterkanter" ;
  ytterlighet_nn_1_N = mkN "ytterlighet" "ytterligheter" ;
  yttermarginal_nn_1_N = mkN "yttermarginal" "yttermarginaler" ;
  yttrandefrihet_nn_1_N = mkN "yttrandefrihet" "yttrandefriheter" ;
  ytvidd_nn_1_N = mkN "ytvidd" "ytvidder" ;
  yvighet_nn_2_N = mkN "yvighet" "yvigheter" ;
  zefyr_nn_1_N = mkN "zefyr" "zefyrer" ;
  zeppelinarpilot_nn_1_N = mkN "zeppelinarpilot" "zeppelinarpiloter" ;
  zinkmalm_nn_1_N = mkN "zinkmalm" "zinkmalmer" ;
  zontariff_nn_1_N = mkN "zontariff" "zontariffer" ;
  zygot_nn_1_N = mkN "zygot" "zygoter" ;
  aecklighet_nn_1_1_N = mkN "äcklighet" "äckligheter" ;
  aedelmetall_nn_1_1_N = mkN "ädelmetall" "ädelmetaller" ;
  aedelsmed_nn_1_1_N = mkN "ädelsmed" "ädelsmeder" ;
  aegarform_nn_1_1_N = mkN "ägarform" "ägarformer" ;
  aeggcell_nn_1_1_N = mkN "äggcell" "äggceller" ;
  aeggklaeckningsmaskin_nn_1_1_N = mkN "äggkläckningsmaskin" "äggkläckningsmaskiner" ;
  aeggstocksinflammation_nn_1_1_N = mkN "äggstocksinflammation" "äggstocksinflammationer" ;
  aegiljett_nn_1_1_N = mkN "ägiljett" "ägiljetter" ;
  aegrett_nn_1_1_N = mkN "ägrett" "ägretter" ;
  aektenskapskandidat_nn_1_1_N = mkN "äktenskapskandidat" "äktenskapskandidater" ;
  aektenskapsmarknad_nn_1_1_N = mkN "äktenskapsmarknad" "äktenskapsmarknader" ;
  aektenskapsskillnad_nn_1_1_N = mkN "äktenskapsskillnad" "äktenskapsskillnader" ;
  aekthet_nn_1_1_N = mkN "äkthet" "äktheter" ;
  aelgjakt_nn_1_1_N = mkN "älgjakt" "älgjakter" ;
  aelsklighet_nn_1_1_N = mkN "älsklighet" "älskligheter" ;
  aelsklingsraett_nn_1_1_N = mkN "älsklingsrätt" "älsklingsrätter" ;
  aelskvaerdhet_nn_1_1_N = mkN "älskvärdhet" "älskvärdheter" ;
  aelvstrand_nn_1_1_N = mkN "älvstrand" "älvstränder" ;
  aembetsdraekt_nn_1_1_N = mkN "ämbetsdräkt" "ämbetsdräkter" ;
  aembetsed_nn_1_1_N = mkN "ämbetsed" "ämbetseder" ;
  aembetsperiod_nn_1_1_N = mkN "ämbetsperiod" "ämbetsperioder" ;
  aembetsplikt_nn_1_1_N = mkN "ämbetsplikt" "ämbetsplikter" ;
  aemnesgrupp_nn_1_1_N = mkN "ämnesgrupp" "ämnesgrupper" ;
  aemnesintegration_nn_1_1_N = mkN "ämnesintegration" "ämnesintegrationer" ;
  aemneskombination_nn_1_1_N = mkN "ämneskombination" "ämneskombinationer" ;
  aemnessfaer_nn_1_1_N = mkN "ämnessfär" "ämnessfärer" ;
  aendamaalsenlighet_nn_1_1_N = mkN "ändamålsenlighet" "ändamålsenligheter" ;
  aendmoraen_nn_1_1_N = mkN "ändmorän" "ändmoräner" ;
  aendpunkt_nn_1_1_N = mkN "ändpunkt" "ändpunkter" ;
  aendstation_nn_1_1_N = mkN "ändstation" "ändstationer" ;
  aengd_nn_1_1_N = mkN "ängd" "ängder" ;
  aenglakoer_nn_1_1_N = mkN "änglakör" "änglakörer" ;
  aengsmark_nn_1_1_N = mkN "ängsmark" "ängsmarker" ;
  aengsvial_nn_1_1_N = mkN "ängsvial" "ängsvialer" ;
  aenkenaad_nn_1_1_N = mkN "änkenåd" "änkenåder" ;
  aenkepension_nn_1_1_N = mkN "änkepension" "änkepensioner" ;
  aentringsstrid_nn_1_1_N = mkN "äntringsstrid" "äntringsstrider" ;
  aeppelpaj_nn_1_1_N = mkN "äppelpaj" "äppelpajer" ;
  aerelystnad_nn_1_1_N = mkN "ärelystnad" "ärelystnader" ;
  aereroerighet_nn_1_1_N = mkN "ärerörighet" "ärerörigheter" ;
  aeresak_nn_1_1_N = mkN "äresak" "äresaker" ;
  aerftlighet_nn_1_1_N = mkN "ärftlighet" "ärftligheter" ;
  aerkerival_nn_1_1_N = mkN "ärkerival" "ärkerivaler" ;
  aerlighet_nn_1_1_N = mkN "ärlighet" "ärligheter" ;
  aerrvaevnad_nn_1_1_N = mkN "ärrvävnad" "ärrvävnader" ;
  aert_nn_1_1_N = mkN "ärt" "ärter" ;
  aetlighet_nn_1_1_N = mkN "ätlighet" "ätligheter" ;
  aetstoerningsproblematik_nn_1_1_N = mkN "ätstörningsproblematik" "ätstörningsproblematiker" ;
  aettlaengd_nn_1_1_N = mkN "ättlängd" "ättlängder" ;
  aeventyrlighet_nn_1_1_N = mkN "äventyrlighet" "äventyrligheter" ;
  aeventyrsfilm_nn_1_1_N = mkN "äventyrsfilm" "äventyrsfilmer" ;
  aakattraktion_nn_1_1_N = mkN "åkattraktion" "åkattraktioner" ;
  aakermark_nn_1_1_N = mkN "åkermark" "åkermarker" ;
  aakeraert_nn_1_1_N = mkN "åkerärt" "åkerärter" ;
  aaklagarmyndighet_nn_1_1_N = mkN "åklagarmyndighet" "åklagarmyndigheter" ;
  aaktur_nn_1_1_N = mkN "åktur" "åkturer" ;
  aalderdomlighet_nn_1_1_N = mkN "ålderdomlighet" "ålderdomligheter" ;
  aalderdomspension_nn_1_1_N = mkN "ålderdomspension" "ålderdomspensioner" ;
  aalderdomssvaghet_nn_1_1_N = mkN "ålderdomssvaghet" "ålderdomssvagheter" ;
  aaldersgrupp_nn_1_1_N = mkN "åldersgrupp" "åldersgrupper" ;
  aalderslaangsynthet_nn_1_1_N = mkN "ålderslångsynthet" "ålderslångsyntheter" ;
  aalderspension_nn_1_1_N = mkN "ålderspension" "ålderspensioner" ;
  aalderspensionaer_nn_1_1_N = mkN "ålderspensionär" "ålderspensionärer" ;
  aalderspresident_nn_1_1_N = mkN "ålderspresident" "ålderspresidenter" ;
  aaldersskillnad_nn_1_1_N = mkN "åldersskillnad" "åldersskillnader" ;
  aangcentral_nn_1_1_N = mkN "ångcentral" "ångcentraler" ;
  aangestattack_nn_1_1_N = mkN "ångestattack" "ångestattacker" ;
  aangmaskin_nn_1_1_N = mkN "ångmaskin" "ångmaskiner" ;
  aaretruntbostad_nn_1_1_N = mkN "åretruntbostad" "åretruntbostäder" ;
  aarsavgift_nn_1_1_N = mkN "årsavgift" "årsavgifter" ;
  aarsbokstav_nn_1_1_N = mkN "årsbokstav" "årsbokstäver" ;
  aarsmodell_nn_1_1_N = mkN "årsmodell" "årsmodeller" ;
  aarstid_nn_1_1_N = mkN "årstid" "årstider" ;
  aasikt_nn_1_1_N = mkN "åsikt" "åsikter" ;
  aasiktsfrihet_nn_1_1_N = mkN "åsiktsfrihet" "åsiktsfriheter" ;
  aasiktsskillnad_nn_1_1_N = mkN "åsiktsskillnad" "åsiktsskillnader" ;
  aaskfront_nn_1_1_N = mkN "åskfront" "åskfronter" ;
  aaskaadlighet_nn_1_1_N = mkN "åskådlighet" "åskådligheter" ;
  aasstaang_nn_1_1_N = mkN "åsstång" "åsstänger" ;
  aatalsimmunitet_nn_1_1_N = mkN "åtalsimmunitet" "åtalsimmuniteter" ;
  aatalspunkt_nn_1_1_N = mkN "åtalspunkt" "åtalspunkter" ;
  aatboerd_nn_1_1_N = mkN "åtbörd" "åtbörder" ;
  aaterbetalningsskyldighet_nn_1_1_N = mkN "återbetalningsskyldighet" "återbetalningsskyldigheter" ;
  aaterfaerd_nn_1_1_N = mkN "återfärd" "återfärder" ;
  aaterhaallsamhet_nn_1_1_N = mkN "återhållsamhet" "återhållsamheter" ;
  aaterstod_nn_1_1_N = mkN "återstod" "återstoder" ;
  aatervinningscentral_nn_1_1_N = mkN "återvinningscentral" "återvinningscentraler" ;
  aatervinningsstation_nn_1_1_N = mkN "återvinningsstation" "återvinningsstationer" ;
  aatervaendsgraend_nn_1_1_N = mkN "återvändsgränd" "återvändsgränder" ;
  aatgaerd_nn_1_1_N = mkN "åtgärd" "åtgärder" ;
  aatlydnad_nn_1_1_N = mkN "åtlydnad" "åtlydnader" ;
  aatskillnad_nn_1_1_N = mkN "åtskillnad" "åtskillnader" ;
  oedemark_nn_1_1_N = mkN "ödemark" "ödemarker" ;
  oedesstund_nn_1_1_N = mkN "ödesstund" "ödesstunder" ;
  oedmjukhet_nn_1_1_N = mkN "ödmjukhet" "ödmjukheter" ;
  oedslighet_nn_1_1_N = mkN "ödslighet" "ödsligheter" ;
  oegonblicksbild_nn_1_1_N = mkN "ögonblicksbild" "ögonblicksbilder" ;
  oegonflirt_nn_1_1_N = mkN "ögonflirt" "ögonflirter" ;
  oegonfloert_nn_1_1_N = mkN "ögonflört" "ögonflörter" ;
  oegonfroejd_nn_1_1_N = mkN "ögonfröjd" "ögonfröjder" ;
  oegonfaegnad_nn_1_1_N = mkN "ögonfägnad" "ögonfägnader" ;
  oegonfaerg_nn_1_1_N = mkN "ögonfärg" "ögonfärger" ;
  oegonglob_nn_1_1_N = mkN "ögonglob" "ögonglober" ;
  oegoninflammation_nn_1_1_N = mkN "ögoninflammation" "ögoninflammationer" ;
  oegonkontakt_nn_1_1_N = mkN "ögonkontakt" "ögonkontakter" ;
  oegonoperation_nn_1_1_N = mkN "ögonoperation" "ögonoperationer" ;
  oegontand_nn_1_1_N = mkN "ögontand" "ögontänder" ;
  oegonvidd_nn_1_1_N = mkN "ögonvidd" "ögonvidder" ;
  oegrupp_nn_1_1_N = mkN "ögrupp" "ögrupper" ;
  oekenrand_nn_1_1_N = mkN "ökenrand" "ökenränder" ;
  oelraettighet_nn_1_1_N = mkN "ölrättighet" "ölrättigheter" ;
  oemhet_nn_1_1_N = mkN "ömhet" "ömheter" ;
  oemklighet_nn_1_1_N = mkN "ömklighet" "ömkligheter" ;
  oemtaalighet_nn_1_1_N = mkN "ömtålighet" "ömtåligheter" ;
  oenskeroll_nn_1_1_N = mkN "önskeroll" "önskeroller" ;
  oeppenhet_nn_1_1_N = mkN "öppenhet" "öppenheter" ;
  oeppettid_nn_1_1_N = mkN "öppettid" "öppettider" ;
  oeroninflammation_nn_1_1_N = mkN "öroninflammation" "öroninflammationer" ;
  oeronlappsfaatoelj_nn_1_1_N = mkN "öronlappsfåtölj" "öronlappsfåtöljer" ;
  oeronoperation_nn_1_1_N = mkN "öronoperation" "öronoperationer" ;
  oerontrumpet_nn_1_1_N = mkN "örontrumpet" "örontrumpeter" ;
  oestasiat_nn_1_1_N = mkN "östasiat" "östasiater" ;
  oestat_nn_1_1_N = mkN "östat" "östater" ;
  oestfront_nn_1_1_N = mkN "östfront" "östfronter" ;
  oestgot_nn_1_1_N = mkN "östgot" "östgoter" ;
  oestkant_nn_1_1_N = mkN "östkant" "östkanter" ;
  oeststat_nn_1_1_N = mkN "öststat" "öststater" ;
  oeverbyggnad_nn_1_1_N = mkN "överbyggnad" "överbyggnader" ;
  oeverdragsdraekt_nn_1_1_N = mkN "överdragsdräkt" "överdragsdräkter" ;
  oeverdrift_nn_1_1_N = mkN "överdrift" "överdrifter" ;
  oeverdoedlighet_nn_1_1_N = mkN "överdödlighet" "överdödligheter" ;
  oeverfallsvaaldtaekt_nn_1_1_N = mkN "överfallsvåldtäkt" "överfallsvåldtäkter" ;
  oeverfart_nn_1_1_N = mkN "överfart" "överfarter" ;
  oeverfurir_nn_1_1_N = mkN "överfurir" "överfurirer" ;
  oeverfaerd_nn_1_1_N = mkN "överfärd" "överfärder" ;
  oeverfoeringsbild_nn_1_1_N = mkN "överföringsbild" "överföringsbilder" ;
  oeverfoeringskapacitet_nn_1_1_N = mkN "överföringskapacitet" "överföringskapaciteter" ;
  oevergaangsform_nn_1_1_N = mkN "övergångsform" "övergångsformer" ;
  oevergaangstid_nn_1_1_N = mkN "övergångstid" "övergångstider" ;
  oeverhet_nn_1_1_N = mkN "överhet" "överheter" ;
  oeverhoeghet_nn_1_1_N = mkN "överhöghet" "överhögheter" ;
  oeverintendent_nn_1_1_N = mkN "överintendent" "överintendenter" ;
  oeverklasstant_nn_1_1_N = mkN "överklasstant" "överklasstanter" ;
  oeverkonsumtion_nn_1_1_N = mkN "överkonsumtion" "överkonsumtioner" ;
  oeverkaenslighet_nn_1_1_N = mkN "överkänslighet" "överkänsligheter" ;
  oeverlevnad_nn_1_1_N = mkN "överlevnad" "överlevnader" ;
  oeverlevnadsinstinkt_nn_1_1_N = mkN "överlevnadsinstinkt" "överlevnadsinstinkter" ;
  oeverljudsfart_nn_1_1_N = mkN "överljudsfart" "överljudsfarter" ;
  oeverlaegsenhet_nn_1_1_N = mkN "överlägsenhet" "överlägsenheter" ;
  oevernattningslaegenhet_nn_1_1_N = mkN "övernattningslägenhet" "övernattningslägenheter" ;
  oevernattningsmoejlighet_nn_1_1_N = mkN "övernattningsmöjlighet" "övernattningsmöjligheter" ;
  oevernaturlighet_nn_1_1_N = mkN "övernaturlighet" "övernaturligheter" ;
  oeverproduktion_nn_1_1_N = mkN "överproduktion" "överproduktioner" ;
  oeverraett_nn_1_1_N = mkN "överrätt" "överrätter" ;
  oeversikt_nn_1_1_N = mkN "översikt" "översikter" ;
  oeverskrift_nn_1_1_N = mkN "överskrift" "överskrifter" ;
  oeverspaendhet_nn_1_1_N = mkN "överspändhet" "överspändheter" ;
  oeversteloejtnant_nn_1_1_N = mkN "överstelöjtnant" "överstelöjtnanter" ;
  oeversyn_nn_1_1_N = mkN "översyn" "översyner" ;
  oeversaettningsmaskin_nn_1_1_N = mkN "översättningsmaskin" "översättningsmaskiner" ;
  oeverton_nn_1_1_N = mkN "överton" "övertoner" ;
  oevertydlighet_nn_1_1_N = mkN "övertydlighet" "övertydligheter" ;
  oevervakningsbild_nn_1_1_N = mkN "övervakningsbild" "övervakningsbilder" ;
  oeverklassmiljoe_nn_1_1_N = mkN "överklassmiljö" "överklassmiljön" "överklassmiljöer" "överklassmiljöerna" ;
  oevergaangsmiljoe_nn_1_1_N = mkN "övergångsmiljö" "övergångsmiljön" "övergångsmiljöer" "övergångsmiljöerna" ;
  oeverarmsmuskel_nn_1_1_N = mkN "överarmsmuskel" "överarmsmuskeln" "överarmsmuskler" "överarmsmusklerna" ;
  oestkustmiljoe_nn_1_1_N = mkN "östkustmiljö" "östkustmiljön" "östkustmiljöer" "östkustmiljöerna" ;
  oegonmuskel_nn_1_1_N = mkN "ögonmuskel" "ögonmuskeln" "ögonmuskler" "ögonmusklerna" ;
  zulu_nn_1_N = mkN "zulu" "zulun" "zuluer" "zuluerna" ;
  zeppelinarhangar_nn_1_N = mkN "zeppelinarhangar" "zeppelinarhangarn" "zeppelinarhangarer" "zeppelinarhangarerna" ;
  yogi_nn_1_N = mkN "yogi" "yogin" "yogier" "yogierna" ;
  vaextfiber_nn_1_1_N = mkN "växtfiber" "växtfibern" "växtfibrer" "växtfibrerna" ;
  vokabel_nn_1_N = mkN "vokabel" "vokabeln" "vokabler" "vokablerna" ;
  variabel_nn_1_N = mkN "variabel" "variabeln" "variabler" "variablerna" ;
  vardagsrumsmoebel_nn_1_1_N = mkN "vardagsrumsmöbel" "vardagsrumsmöbeln" "vardagsrumsmöbler" "vardagsrumsmöblerna" ;
  valvel_nn_1_N = mkN "valvel" "valveln" "valvler" "valvlerna" ;
  vakuummateria_nn_1_N = mkN "vakuummateria" "vakuummaterian" "vakuummaterier" "vakuummaterierna" ;
  vacuummateria_nn_1_N = mkN "vacuummateria" "vacuummaterian" "vacuummaterier" "vacuummaterierna" ;
  vaccinationskoe_nn_1_1_N = mkN "vaccinationskö" "vaccinationskön" "vaccinationsköer" "vaccinationsköerna" ;
  utemoebel_nn_1_1_N = mkN "utemöbel" "utemöbeln" "utemöbler" "utemöblerna" ;
  utemiljoe_nn_1_1_N = mkN "utemiljö" "utemiljön" "utemiljöer" "utemiljöerna" ;
  uppvaextmiljoe_nn_1_1_N = mkN "uppväxtmiljö" "uppväxtmiljön" "uppväxtmiljöer" "uppväxtmiljöerna" ;
  universitetskansler_nn_1_N = mkN "universitetskansler" "universitetskanslern" "universitetskanslerer" "universitetskanslererna" ;
  turordningsregel_nn_1_N = mkN "turordningsregel" "turordningsregeln" "turordningsregler" "turordningsreglerna" ;
  tumregel_nn_1_N = mkN "tumregel" "tumregeln" "tumregler" "tumreglerna" ;
  tuggmuskel_nn_1_N = mkN "tuggmuskel" "tuggmuskeln" "tuggmuskler" "tuggmusklerna" ;
  tuberkel_nn_1_N = mkN "tuberkel" "tuberkeln" "tuberkler" "tuberklerna" ;
  traefiber_nn_1_1_N = mkN "träfiber" "träfibern" "träfibrer" "träfibrerna" ;
  traedgaardsmoebel_nn_1_1_N = mkN "trädgårdsmöbel" "trädgårdsmöbeln" "trädgårdsmöbler" "trädgårdsmöblerna" ;
  trollformel_nn_1_N = mkN "trollformel" "trollformeln" "trollformler" "trollformlerna" ;
  trivselregel_nn_1_N = mkN "trivselregel" "trivselregeln" "trivselregler" "trivselreglerna" ;
  trippel_nn_3_N = mkN "trippel" "trippeln" "trippler" "tripplerna" ;
  tricepsmuskel_nn_1_N = mkN "tricepsmuskel" "tricepsmuskeln" "tricepsmuskler" "tricepsmusklerna" ;
  trafikregel_nn_1_N = mkN "trafikregel" "trafikregeln" "trafikregler" "trafikreglerna" ;
  toalettkoe_nn_1_1_N = mkN "toalettkö" "toalettkön" "toalettköer" "toalettköerna" ;
  titulaerkonsul_nn_1_1_N = mkN "titulärkonsul" "titulärkonsuln" "titulärkonsuler" "titulärkonsulerna" ;
  textilfiber_nn_1_N = mkN "textilfiber" "textilfibern" "textilfibrer" "textilfibrerna" ;
  teveintervju_nn_1_N = mkN "teveintervju" "teveintervjun" "teveintervjuer" "teveintervjuerna" ;
  tentakel_nn_1_N = mkN "tentakel" "tentakeln" "tentakler" "tentaklerna" ;
  telefonkoe_nn_1_1_N = mkN "telefonkö" "telefonkön" "telefonköer" "telefonköerna" ;
  tandformel_nn_1_N = mkN "tandformel" "tandformeln" "tandformler" "tandformlerna" ;
  saegen_nn_1_1_N = mkN "sägen" "sägenn" "sägner" "sägnerna" ;
  systemkoe_nn_1_1_N = mkN "systemkö" "systemkön" "systemköer" "systemköerna" ;
  syntetfiber_nn_1_N = mkN "syntetfiber" "syntetfibern" "syntetfibrer" "syntetfibrerna" ;
  svaermorshistoria_nn_1_1_N = mkN "svärmorshistoria" "svärmorshistorien" "svärmorshistorier" "svärmorshistorierna" ;
  straeckarmuskel_nn_1_1_N = mkN "sträckarmuskel" "sträckarmuskeln" "sträckarmuskler" "sträckarmusklerna" ;
  strukturformel_nn_1_N = mkN "strukturformel" "strukturformeln" "strukturformler" "strukturformlerna" ;
  strandmiljoe_nn_1_1_N = mkN "strandmiljö" "strandmiljön" "strandmiljöer" "strandmiljöerna" ;
  stormufti_nn_1_N = mkN "stormufti" "stormuftin" "stormuftier" "stormuftierna" ;
  stipel_nn_1_N = mkN "stipel" "stipeln" "stipler" "stiplerna" ;
  stilmoebel_nn_1_1_N = mkN "stilmöbel" "stilmöbeln" "stilmöbler" "stilmöblerna" ;
  stadsmiljoe_nn_1_1_N = mkN "stadsmiljö" "stadsmiljön" "stadsmiljöer" "stadsmiljöerna" ;
  squaw_nn_1_N = mkN "squaw" "squawn" "squawer" "squawerna" ;
  spoekhistoria_nn_1_1_N = mkN "spökhistoria" "spökhistorien" "spökhistorier" "spökhistorierna" ;
  spraakregel_nn_1_1_N = mkN "språkregel" "språkregeln" "språkregler" "språkreglerna" ;
  spermatozo_nn_1_N = mkN "spermatozo" "spermatozon" "spermatozoer" "spermatozoerna" ;
  spelregel_nn_1_N = mkN "spelregel" "spelregeln" "spelregler" "spelreglerna" ;
  solmateria_nn_1_N = mkN "solmateria" "solmaterian" "solmaterier" "solmaterierna" ;
  slaekthistoria_nn_1_1_N = mkN "släkthistoria" "släkthistorien" "släkthistorier" "släkthistorierna" ;
  slutmuskel_nn_1_N = mkN "slutmuskel" "slutmuskeln" "slutmuskler" "slutmusklerna" ;
  skraeckhistoria_nn_1_1_N = mkN "skräckhistoria" "skräckhistorien" "skräckhistorier" "skräckhistorierna" ;
  skrupel_nn_1_N = mkN "skrupel" "skrupeln" "skrupler" "skruplerna" ;
  skolmassaker_nn_1_N = mkN "skolmassaker" "skolmassakern" "skolmassakrer" "skolmassakrerna" ;
  skjutjaernsintervju_nn_1_1_N = mkN "skjutjärnsintervju" "skjutjärnsintervjun" "skjutjärnsintervjuer" "skjutjärnsintervjuerna" ;
  skepparhistoria_nn_1_N = mkN "skepparhistoria" "skepparhistorien" "skepparhistorier" "skepparhistorierna" ;
  skelettmuskel_nn_1_N = mkN "skelettmuskel" "skelettmuskeln" "skelettmuskler" "skelettmusklerna" ;
  skatteregel_nn_1_N = mkN "skatteregel" "skatteregeln" "skatteregler" "skattereglerna" ;
  skandalhistoria_nn_1_N = mkN "skandalhistoria" "skandalhistorien" "skandalhistorier" "skandalhistorierna" ;
  sjoevaegsregel_nn_1_1_N = mkN "sjövägsregel" "sjövägsregeln" "sjövägsregler" "sjövägsreglerna" ;
  sjoefartsregel_nn_1_1_N = mkN "sjöfartsregel" "sjöfartsregeln" "sjöfartsregler" "sjöfartsreglerna" ;
  sjukregel_nn_1_N = mkN "sjukregel" "sjukregeln" "sjukregler" "sjukreglerna" ;
  sjukdomshistoria_nn_1_N = mkN "sjukdomshistoria" "sjukdomshistorien" "sjukdomshistorier" "sjukdomshistorierna" ;
  sittmoebel_nn_1_1_N = mkN "sittmöbel" "sittmöbeln" "sittmöbler" "sittmöblerna" ;
  sigel_nn_1_N = mkN "sigel" "sigeln" "sigler" "siglerna" ;
  shogun_nn_1_N = mkN "shogun" "shogun" "shoguner" "shogunerna" ;
  senior_nn_1_N = mkN "senior" "senioren" "seniorer" "seniorerna" ;
  sebu_nn_1_N = mkN "sebu" "sebun" "sebuer" "sebuerna" ;
  samtidsmiljoe_nn_1_1_N = mkN "samtidsmiljö" "samtidsmiljön" "samtidsmiljöer" "samtidsmiljöerna" ;
  roevarhistoria_nn_1_1_N = mkN "rövarhistoria" "rövarhistorien" "rövarhistorier" "rövarhistorierna" ;
  raettsregel_nn_1_1_N = mkN "rättsregel" "rättsregeln" "rättsregler" "rättsreglerna" ;
  rymdmateria_nn_1_N = mkN "rymdmateria" "rymdmaterian" "rymdmaterier" "rymdmaterierna" ;
  ryggmuskel_nn_1_N = mkN "ryggmuskel" "ryggmuskeln" "ryggmuskler" "ryggmusklerna" ;
  ringmuskel_nn_1_N = mkN "ringmuskel" "ringmuskeln" "ringmuskler" "ringmusklerna" ;
  rikskansler_nn_1_N = mkN "rikskansler" "rikskanslern" "rikskanslerer" "rikskanslererna" ;
  rickshaw_nn_1_N = mkN "rickshaw" "rickshawn" "rickshawer" "rickshawerna" ;
  renkonter_nn_1_N = mkN "renkonter" "renkontern" "renkontrer" "renkontrerna" ;
  regel_nn_1_N = mkN "regel" "regeln" "regler" "reglerna" ;
  ragu_nn_1_N = mkN "ragu" "ragun" "raguer" "raguerna" ;
  rabbi_nn_1_N = mkN "rabbi" "rabbin" "rabbier" "rabbierna" ;
  pustel_nn_1_N = mkN "pustel" "pusteln" "pustler" "pustlerna" ;
  punkteringsspray_nn_1_N = mkN "punkteringsspray" "punkteringssprayen" "punkteringssprayer" "punkteringssprayerna" ;
  psykiater_nn_1_N = mkN "psykiater" "psykiatern" "psykiatrer" "psykiatrerna" ;
  protozo_nn_1_N = mkN "protozo" "protozon" "protozoer" "protozoerna" ;
  prokonsul_nn_1_N = mkN "prokonsul" "prokonsuln" "prokonsuler" "prokonsulerna" ;
  prokansler_nn_1_N = mkN "prokansler" "prokanslern" "prokanslerer" "prokanslererna" ;
  presstoedsregel_nn_1_1_N = mkN "presstödsregel" "presstödsregeln" "presstödsregler" "presstödsreglerna" ;
  presbyter_nn_1_N = mkN "presbyter" "presbytern" "presbyterer" "presbytererna" ;
  portmonnae_nn_1_1_N = mkN "portmonnä" "portmonnän" "portmonnäer" "portmonnäerna" ;
  polarmiljoe_nn_1_1_N = mkN "polarmiljö" "polarmiljön" "polarmiljöer" "polarmiljöerna" ;
  plastfiber_nn_1_N = mkN "plastfiber" "plastfibern" "plastfibrer" "plastfibrerna" ;
  petitchou_nn_1_N = mkN "petitchou" "petitchoun" "petitchouer" "petitchouerna" ;
  petit_chou_nn_1_N = mkN "petit-chou" "petit-choun" "petit-chouer" "petit-chouerna" ;
  patron_nn_1_N = mkN "patron" "patron" "patroner" "patronerna" ;
  passionshistoria_nn_1_N = mkN "passionshistoria" "passionshistorien" "passionshistorier" "passionshistorierna" ;
  parafiber_nn_1_N = mkN "parafiber" "parafibern" "parafibrer" "parafibrerna" ;
  parabel_nn_1_N = mkN "parabel" "parabeln" "parabler" "parablerna" ;
  palaver_nn_1_N = mkN "palaver" "palavern" "palavrer" "palavrerna" ;
  ordensregel_nn_1_N = mkN "ordensregel" "ordensregeln" "ordensregler" "ordensreglerna" ;
  onager_nn_1_N = mkN "onager" "onagern" "onagrer" "onagrerna" ;
  okapi_nn_1_N = mkN "okapi" "okapin" "okapier" "okapierna" ;
  naesselfiber_nn_1_1_N = mkN "nässelfiber" "nässelfibern" "nässelfibrer" "nässelfibrerna" ;
  naermiljoe_nn_1_1_N = mkN "närmiljö" "närmiljön" "närmiljöer" "närmiljöerna" ;
  nutidshistoria_nn_1_N = mkN "nutidshistoria" "nutidshistorien" "nutidshistorier" "nutidshistorierna" ;
  nigger_nn_1_N = mkN "nigger" "niggern" "niggrer" "niggrerna" ;
  niello_nn_1_N = mkN "niello" "niellon" "nieller" "niellerna" ;
  nevoe_nn_1_1_N = mkN "nevö" "nevön" "nevöer" "nevöerna" ;
  nerium_nn_1_N = mkN "nerium" "nerien" "nerier" "nerierna" ;
  neger_nn_1_N = mkN "neger" "negern" "negrer" "negrerna" ;
  naturmiljoe_nn_1_1_N = mkN "naturmiljö" "naturmiljön" "naturmiljöer" "naturmiljöerna" ;
  naturfiber_nn_1_N = mkN "naturfiber" "naturfibern" "naturfibrer" "naturfibrerna" ;
  moebel_nn_1_1_N = mkN "möbel" "möbeln" "möbler" "möblerna" ;
  maetningsregel_nn_1_1_N = mkN "mätningsregel" "mätningsregeln" "mätningsregler" "mätningsreglerna" ;
  muskelfiber_nn_1_N = mkN "muskelfiber" "muskelfibern" "muskelfibrer" "muskelfibrerna" ;
  muskel_nn_1_N = mkN "muskel" "muskeln" "muskler" "musklerna" ;
  musikermiljoe_nn_1_1_N = mkN "musikermiljö" "musikermiljön" "musikermiljöer" "musikermiljöerna" ;
  multipel_nn_1_N = mkN "multipel" "multipeln" "multipler" "multiplerna" ;
  mufti_nn_1_N = mkN "mufti" "muftin" "muftier" "muftierna" ;
  mor_nn_2_N = mkN "mor" "moren" "morer" "morerna" ;
  mogul_nn_1_N = mkN "mogul" "moguln" "moguler" "mogulerna" ;
  minuskel_nn_1_N = mkN "minuskel" "minuskeln" "minuskler" "minusklerna" ;
  minnesregel_nn_1_N = mkN "minnesregel" "minnesregeln" "minnesregler" "minnesreglerna" ;
  miljoe_nn_1_1_N = mkN "miljö" "miljön" "miljöer" "miljöerna" ;
  mikrofiber_nn_1_N = mkN "mikrofiber" "mikrofibern" "mikrofibrer" "mikrofibrerna" ;
  metazo_nn_1_N = mkN "metazo" "metazon" "metazoer" "metazoerna" ;
  metafor_nn_1_N = mkN "metafor" "metaforen" "metaforer" "metaforerna" ;
  metafiber_nn_1_N = mkN "metafiber" "metafibern" "metafibrer" "metafibrerna" ;
  mejlintervju_nn_1_N = mkN "mejlintervju" "mejlintervjun" "mejlintervjuer" "mejlintervjuerna" ;
  medkonsul_nn_1_N = mkN "medkonsul" "medkonsuln" "medkonsuler" "medkonsulerna" ;
  materia_nn_1_N = mkN "materia" "materian" "materier" "materierna" ;
  massaker_nn_1_N = mkN "massaker" "massakern" "massakrer" "massakrerna" ;
  marabu_nn_1_N = mkN "marabu" "marabun" "marabuer" "marabuerna" ;
  maori_nn_1_N = mkN "maori" "maorin" "maorier" "maorierna" ;
  mandibel_nn_1_N = mkN "mandibel" "mandibeln" "mandibler" "mandiblerna" ;
  manchu_nn_1_N = mkN "manchu" "manchun" "manchuer" "manchuerna" ;
  majuskel_nn_1_N = mkN "majuskel" "majuskeln" "majuskler" "majusklerna" ;
  magmuskel_nn_1_N = mkN "magmuskel" "magmuskeln" "magmuskler" "magmusklerna" ;
  laarmuskel_nn_1_1_N = mkN "lårmuskel" "lårmuskeln" "lårmuskler" "lårmusklerna" ;
  laanekoe_nn_1_1_N = mkN "lånekö" "lånekön" "låneköer" "låneköerna" ;
  lordkansler_nn_1_N = mkN "lordkansler" "lordkanslern" "lordkanslerer" "lordkanslererna" ;
  livsmiljoe_nn_1_1_N = mkN "livsmiljö" "livsmiljön" "livsmiljöer" "livsmiljöerna" ;
  linnefiber_nn_1_N = mkN "linnefiber" "linnefibern" "linnefibrer" "linnefibrerna" ;
  liftkoe_nn_1_1_N = mkN "liftkö" "liftkön" "liftköer" "liftköerna" ;
  lidandeshistoria_nn_1_N = mkN "lidandeshistoria" "lidandeshistorien" "lidandeshistorier" "lidandeshistorierna" ;
  levnadsregel_nn_1_N = mkN "levnadsregel" "levnadsregeln" "levnadsregler" "levnadsreglerna" ;
  leverabel_nn_1_N = mkN "leverabel" "leverabeln" "leverabler" "leverablerna" ;
  koe_nn_1_1_N = mkN "kö" "kön" "köer" "köerna" ;
  kaerlekshistoria_nn_1_1_N = mkN "kärlekshistoria" "kärlekshistorien" "kärlekshistorier" "kärlekshistorierna" ;
  kuli_nn_1_N = mkN "kuli" "kulin" "kulier" "kulierna" ;
  krigsmiljoe_nn_1_1_N = mkN "krigsmiljö" "krigsmiljön" "krigsmiljöer" "krigsmiljöerna" ;
  krigshistoria_nn_1_N = mkN "krigshistoria" "krigshistorien" "krigshistorier" "krigshistorierna" ;
  kostfiber_nn_1_N = mkN "kostfiber" "kostfibern" "kostfibrer" "kostfibrerna" ;
  korpuskel_nn_1_N = mkN "korpuskel" "korpuskeln" "korpuskler" "korpusklerna" ;
  konsul_nn_1_N = mkN "konsul" "konsuln" "konsuler" "konsulerna" ;
  konstfibermoebel_nn_1_1_N = mkN "konstfibermöbel" "konstfibermöbeln" "konstfibermöbler" "konstfibermöblerna" ;
  konstfiber_nn_1_N = mkN "konstfiber" "konstfibern" "konstfibrer" "konstfibrerna" ;
  kolibri_nn_1_N = mkN "kolibri" "kolibrin" "kolibrier" "kolibrierna" ;
  kokosfiber_nn_1_N = mkN "kokosfiber" "kokosfibern" "kokosfibrer" "kokosfibrerna" ;
  knarkhistoria_nn_1_N = mkN "knarkhistoria" "knarkhistorien" "knarkhistorier" "knarkhistorierna" ;
  klosterregel_nn_1_N = mkN "klosterregel" "klosterregeln" "klosterregler" "klosterreglerna" ;
  klanmassaker_nn_1_N = mkN "klanmassaker" "klanmassakern" "klanmassakrer" "klanmassakrerna" ;
  kiwi_nn_1_N = mkN "kiwi" "kiwin" "kiwier" "kiwierna" ;
  kivi_nn_1_N = mkN "kivi" "kivin" "kivier" "kivierna" ;
  kidnappningshistoria_nn_1_N = mkN "kidnappningshistoria" "kidnappningshistorien" "kidnappningshistorier" "kidnappningshistorierna" ;
  kazoo_nn_1_N = mkN "kazoo" "kazoon" "kazooer" "kazooerna" ;
  kauri_nn_1_N = mkN "kauri" "kaurin" "kaurier" "kaurierna" ;
  kassakoe_nn_1_1_N = mkN "kassakö" "kassakön" "kassaköer" "kassaköerna" ;
  karisma_nn_1_N = mkN "karisma" "karisman" "karismer" "karismerna" ;
  kaprifolium_nn_1_N = mkN "kaprifolium" "kaprifolien" "kaprifolier" "kaprifolierna" ;
  kaffer_nn_1_N = mkN "kaffer" "kaffern" "kaffrer" "kaffrerna" ;
  kadi_nn_1_N = mkN "kadi" "kadin" "kadier" "kadierna" ;
  junior_nn_1_N = mkN "junior" "junioren" "juniorer" "juniorerna" ;
  juldekor_nn_1_N = mkN "juldekor" "juldekoren" "juldekorer" "juldekorerna" ;
  jordmateria_nn_1_N = mkN "jordmateria" "jordmaterian" "jordmaterier" "jordmaterierna" ;
  jobbintervju_nn_1_N = mkN "jobbintervju" "jobbintervjun" "jobbintervjuer" "jobbintervjuerna" ;
  jakthistoria_nn_1_N = mkN "jakthistoria" "jakthistorien" "jakthistorier" "jakthistorierna" ;
  intervju_nn_1_N = mkN "intervju" "intervjun" "intervjuer" "intervjuerna" ;
  inkunabel_nn_1_N = mkN "inkunabel" "inkunabeln" "inkunabler" "inkunablerna" ;
  impressario_nn_1_N = mkN "impressario" "impressarion" "impressarier" "impressarierna" ;
  hoersaegen_nn_1_1_N = mkN "hörsägen" "hörsägenn" "hörsägner" "hörsägnerna" ;
  hypokonder_nn_1_N = mkN "hypokonder" "hypokondern" "hypokondrer" "hypokondrerna" ;
  hyperbel_nn_1_N = mkN "hyperbel" "hyperbeln" "hyperbler" "hyperblerna" ;
  huvudregel_nn_1_N = mkN "huvudregel" "huvudregeln" "huvudregler" "huvudreglerna" ;
  hjaertmuskel_nn_1_1_N = mkN "hjärtmuskel" "hjärtmuskeln" "hjärtmuskler" "hjärtmusklerna" ;
  historia_nn_1_N = mkN "historia" "historien" "historier" "historierna" ;
  hemmiljoe_nn_1_1_N = mkN "hemmiljö" "hemmiljön" "hemmiljöer" "hemmiljöerna" ;
  handlingsregel_nn_1_N = mkN "handlingsregel" "handlingsregeln" "handlingsregler" "handlingsreglerna" ;
  haiku_nn_1_N = mkN "haiku" "haikun" "haikuer" "haikuerna" ;
  gurami_nn_1_N = mkN "gurami" "guramin" "guramier" "guramierna" ;
  gulddekor_nn_1_N = mkN "gulddekor" "gulddekoren" "gulddekorer" "gulddekorerna" ;
  grundregel_nn_1_N = mkN "grundregel" "grundregeln" "grundregler" "grundreglerna" ;
  grammatikregel_nn_1_N = mkN "grammatikregel" "grammatikregeln" "grammatikregler" "grammatikreglerna" ;
  gnu_nn_1_N = mkN "gnu" "gnun" "gnuer" "gnuerna" ;
  glasfiber_nn_1_N = mkN "glasfiber" "glasfibern" "glasfibrer" "glasfibrerna" ;
  glandel_nn_1_N = mkN "glandel" "glandeln" "glandler" "glandlerna" ;
  geranium_nn_1_N = mkN "geranium" "geranien" "geranier" "geranierna" ;
  genitivmetafor_nn_1_N = mkN "genitivmetafor" "genitivmetaforen" "genitivmetaforer" "genitivmetaforerna" ;
  generalkonsul_nn_1_N = mkN "generalkonsul" "generalkonsuln" "generalkonsuler" "generalkonsulerna" ;
  foermoerkelsevariabel_nn_1_1_N = mkN "förmörkelsevariabel" "förmörkelsevariabeln" "förmörkelsevariabler" "förmörkelsevariablerna" ;
  foerhaallningsregel_nn_1_1_N = mkN "förhållningsregel" "förhållningsregeln" "förhållningsregler" "förhållningsreglerna" ;
  foerbundskansler_nn_1_1_N = mkN "förbundskansler" "förbundskanslern" "förbundskanslerer" "förbundskanslererna" ;
  friluftsmiljoe_nn_1_1_N = mkN "friluftsmiljö" "friluftsmiljön" "friluftsmiljöer" "friluftsmiljöerna" ;
  framgaangshistoria_nn_1_1_N = mkN "framgångshistoria" "framgångshistorien" "framgångshistorier" "framgångshistorierna" ;
  foyer_nn_1_N = mkN "foyer" "foyern" "foyerer" "foyererna" ;
  forskningsmiljoe_nn_1_1_N = mkN "forskningsmiljö" "forskningsmiljön" "forskningsmiljöer" "forskningsmiljöerna" ;
  formel_nn_1_N = mkN "formel" "formeln" "formler" "formlerna" ;
  foniater_nn_1_N = mkN "foniater" "foniatern" "foniatrer" "foniatrerna" ;
  folksaegen_nn_1_1_N = mkN "folksägen" "folksägenn" "folksägner" "folksägnerna" ;
  flygplanshangar_nn_1_N = mkN "flygplanshangar" "flygplanshangarn" "flygplanshangarer" "flygplanshangarerna" ;
  floskel_nn_1_N = mkN "floskel" "floskeln" "floskler" "flosklerna" ;
  fingerstraeckarmuskel_nn_1_1_N = mkN "fingersträckarmuskel" "fingersträckarmuskeln" "fingersträckarmuskler" "fingersträckarmusklerna" ;
  fingerboejarmuskel_nn_1_1_N = mkN "fingerböjarmuskel" "fingerböjarmuskeln" "fingerböjarmuskler" "fingerböjarmusklerna" ;
  filmhistoria_nn_1_N = mkN "filmhistoria" "filmhistorien" "filmhistorier" "filmhistorierna" ;
  fiber_nn_1_N = mkN "fiber" "fibern" "fibrer" "fibrerna" ;
  farao_nn_1_N = mkN "farao" "farao" "faraoner" "faraonerna" ;
  familjeplaneringsregel_nn_1_N = mkN "familjeplaneringsregel" "familjeplaneringsregeln" "familjeplaneringsregler" "familjeplaneringsreglerna" ;
  fabel_nn_1_N = mkN "fabel" "fabeln" "fabler" "fablerna" ;
  essae_nn_1_1_N = mkN "essä" "essän" "essäer" "essäerna" ;
  enkoensregel_nn_1_1_N = mkN "enkönsregel" "enkönsregeln" "enkönsregler" "enkönsreglerna" ;
  emu_nn_1_N = mkN "emu" "emun" "emuer" "emuerna" ;
  eforus_nn_1_N = mkN "eforus" "eforus" "eforer" "eforerna" ;
  dramaturgi_nn_1_N = mkN "dramaturgi" "dramaturgin" "dramaturgier" "dramaturgierna" ;
  drakma_nn_1_N = mkN "drakma" "drakman" "drakmer" "drakmerna" ;
  drachma_nn_1_N = mkN "drachma" "drachman" "drachmer" "drachmerna" ;
  dossier_nn_1_N = mkN "dossier" "dossiern" "dossierer" "dossiererna" ;
  donjuan_nn_1_N = mkN "donjuan" "donjuan" "donjuaner" "donjuanerna" ;
  djurfabel_nn_1_N = mkN "djurfabel" "djurfabeln" "djurfabler" "djurfablerna" ;
  djupintervju_nn_1_N = mkN "djupintervju" "djupintervjun" "djupintervjuer" "djupintervjuerna" ;
  djungel_nn_1_N = mkN "djungel" "djungeln" "djungler" "djunglerna" ;
  deltamuskel_nn_1_N = mkN "deltamuskel" "deltamuskeln" "deltamuskler" "deltamusklerna" ;
  ciliarmuskel_nn_1_N = mkN "ciliarmuskel" "ciliarmuskeln" "ciliarmuskler" "ciliarmusklerna" ;
  boejmuskel_nn_1_1_N = mkN "böjmuskel" "böjmuskeln" "böjmuskler" "böjmusklerna" ;
  boejarmuskel_nn_1_1_N = mkN "böjarmuskel" "böjarmuskeln" "böjarmuskler" "böjarmusklerna" ;
  bukmuskel_nn_1_N = mkN "bukmuskel" "bukmuskeln" "bukmuskler" "bukmusklerna" ;
  broestmuskel_nn_1_1_N = mkN "bröstmuskel" "bröstmuskeln" "bröstmuskler" "bröstmusklerna" ;
  broedkoe_nn_1_1_N = mkN "brödkö" "brödkön" "brödköer" "brödköerna" ;
  bruttoformel_nn_1_N = mkN "bruttoformel" "bruttoformeln" "bruttoformler" "bruttoformlerna" ;
  bostadsmiljoe_nn_1_1_N = mkN "bostadsmiljö" "bostadsmiljön" "bostadsmiljöer" "bostadsmiljöerna" ;
  bostadskoe_nn_1_1_N = mkN "bostadskö" "bostadskön" "bostadsköer" "bostadsköerna" ;
  bonusregel_nn_1_N = mkN "bonusregel" "bonusregeln" "bonusregler" "bonusreglerna" ;
  boggi_nn_1_N = mkN "boggi" "boggin" "boggier" "boggierna" ;
  bistro_nn_1_N = mkN "bistro" "bistron" "bistroer" "bistroerna" ;
  bilkoe_nn_1_1_N = mkN "bilkö" "bilkön" "bilköer" "bilköerna" ;
  biljardkoe_nn_1_1_N = mkN "biljardkö" "biljardkön" "biljardköer" "biljardköerna" ;
  bicepsmuskel_nn_1_N = mkN "bicepsmuskel" "bicepsmuskeln" "bicepsmuskler" "bicepsmusklerna" ;
  bibelkanon_nn_1_N = mkN "bibelkanon" "bibelkanon" "bibelkanoner" "bibelkanonerna" ;
  bevattningsregel_nn_1_N = mkN "bevattningsregel" "bevattningsregeln" "bevattningsregler" "bevattningsreglerna" ;
  besvaerjelseformel_nn_1_1_N = mkN "besvärjelseformel" "besvärjelseformeln" "besvärjelseformler" "besvärjelseformlerna" ;
  benmuskel_nn_1_N = mkN "benmuskel" "benmuskeln" "benmuskler" "benmusklerna" ;
  bastfiber_nn_1_N = mkN "bastfiber" "bastfibern" "bastfibrer" "bastfibrerna" ;
  bakgrundsvariabel_nn_1_N = mkN "bakgrundsvariabel" "bakgrundsvariabeln" "bakgrundsvariabler" "bakgrundsvariablerna" ;
  badrumsmoebel_nn_1_1_N = mkN "badrumsmöbel" "badrumsmöbeln" "badrumsmöbler" "badrumsmöblerna" ;
  armmuskel_nn_1_N = mkN "armmuskel" "armmuskeln" "armmuskler" "armmusklerna" ;
  arkiater_nn_1_N = mkN "arkiater" "arkiatern" "arkiatrer" "arkiatrerna" ;
  arbetstidsregel_nn_1_N = mkN "arbetstidsregel" "arbetstidsregeln" "arbetstidsregler" "arbetstidsreglerna" ;
  arbetsmiljoe_nn_1_1_N = mkN "arbetsmiljö" "arbetsmiljön" "arbetsmiljöer" "arbetsmiljöerna" ;
  arbetsintervju_nn_1_N = mkN "arbetsintervju" "arbetsintervjun" "arbetsintervjuer" "arbetsintervjuerna" ;
  apotekskoe_nn_1_1_N = mkN "apotekskö" "apotekskön" "apoteksköer" "apoteksköerna" ;
  anstaellningsintervju_nn_1_1_N = mkN "anställningsintervju" "anställningsintervjun" "anställningsintervjuer" "anställningsintervjuerna" ;
  ansiktsmuskel_nn_1_N = mkN "ansiktsmuskel" "ansiktsmuskeln" "ansiktsmuskler" "ansiktsmusklerna" ;
  amatoerregel_nn_1_1_N = mkN "amatörregel" "amatörregeln" "amatörregler" "amatörreglerna" ;
  aguti_nn_1_N = mkN "aguti" "agutin" "agutier" "agutierna" ;
  TV_intervju_nn_1_N = mkN "TV-intervju" "TV-intervjun" "TV-intervjuer" "TV-intervjuerna" ;
  Katynmassaker_nn_1_N = mkN "Katynmassaker" "Katynmassakern" "Katynmassakrer" "Katynmassakrerna" ;
  IKEA_moebel_nn_1_1_N = mkN "IKEA-möbel" "IKEA-möbeln" "IKEA-möbler" "IKEA-möblerna" ;
  A_bomb_nn_1_N = mkN "A-bomb" "A-bomber" ;
  A_vitaminbrist_nn_1_N = mkN "A-vitaminbrist" "A-vitaminbrister" ;
  Administrator_nn_1_N = mkN "Administrator" "Administratorer" ;
  Afrikatrad_nn_1_N = mkN "Afrikatrad" "Afrikatrader" ;
  B_vitaminbrist_nn_1_N = mkN "B-vitaminbrist" "B-vitaminbrister" ;
  Ballograf_nn_1_N = mkN "Ballograf" "Ballografer" ;
  Citroen_nn_1_N = mkN "Citroen" "Citroener" ;
  DNA_molekyl_nn_1_N = mkN "DNA-molekyl" "DNA-molekyler" ;
  DNA_sekvens_nn_1_N = mkN "DNA-sekvens" "DNA-sekvenser" ;
  DVD_film_nn_1_N = mkN "DVD-film" "DVD-filmer" ;
  Dramatenchef_nn_1_N = mkN "Dramatenchef" "Dramatenchefer" ;
  EU_kommission_nn_1_N = mkN "EU-kommission" "EU-kommissioner" ;
  Facebookbild_nn_1_N = mkN "Facebookbild" "Facebookbilder" ;
  Facebookgrupp_nn_1_N = mkN "Facebookgrupp" "Facebookgrupper" ;
  G_kraft_nn_1_N = mkN "G-kraft" "G-krafter" ;
  G_punkt_nn_1_N = mkN "G-punkt" "G-punkter" ;
  Hausdorffdimension_nn_1_N = mkN "Hausdorffdimension" "Hausdorffdimensioner" ;
  Higgsboson_nn_1_N = mkN "Higgsboson" "Higgsbosoner" ;
  Hiroshimabomb_nn_1_N = mkN "Hiroshimabomb" "Hiroshimabomber" ;
  Hitchcockfilm_nn_1_N = mkN "Hitchcockfilm" "Hitchcockfilmer" ;
  Kubakris_nn_1_N = mkN "Kubakris" "Kubakriser" ;
  MP3_bok_nn_1_N = mkN "MP3-bok" "MP3-böcker" ;
  Marylandaccent_nn_1_N = mkN "Marylandaccent" "Marylandaccenter" ;
  Medelshavskultur_nn_1_N = mkN "Medelshavskultur" "Medelshavskulturer" ;
  Mosebok_nn_1_N = mkN "Mosebok" "Moseböcker" ;
  Natosoldat_nn_1_N = mkN "Natosoldat" "Natosoldater" ;
  Oxfordstudent_nn_1_N = mkN "Oxfordstudent" "Oxfordstudenter" ;
  PIN_kod_nn_1_N = mkN "PIN-kod" "PIN-koder" ;
  Parisflygplats_nn_1_N = mkN "Parisflygplats" "Parisflygplatser" ;
  Rembrandt_nn_1_N = mkN "Rembrandt" "Rembrandter" ;
  SCOPE_rapport_nn_1_N = mkN "SCOPE-rapport" "SCOPE-rapporter" ;
  Salazar_regim_nn_1_N = mkN "Salazar-regim" "Salazar-regimer" ;
  Sokratesdialog_nn_1_N = mkN "Sokratesdialog" "Sokratesdialoger" ;
  Stillahavsskvadron_nn_1_N = mkN "Stillahavsskvadron" "Stillahavsskvadroner" ;
  Stureplansprofil_nn_1_N = mkN "Stureplansprofil" "Stureplansprofiler" ;
  Sverigedemokrat_nn_1_N = mkN "Sverigedemokrat" "Sverigedemokrater" ;
  TV_evangelist_nn_1_N = mkN "TV-evangelist" "TV-evangelister" ;
  TV_konferens_nn_1_N = mkN "TV-konferens" "TV-konferenser" ;
  TV_mast_nn_1_N = mkN "TV-mast" "TV-master" ;
  TV_predikant_nn_1_N = mkN "TV-predikant" "TV-predikanter" ;
  TV_producent_nn_1_N = mkN "TV-producent" "TV-producenter" ;
  TV_profil_nn_1_N = mkN "TV-profil" "TV-profiler" ;
  TV_signal_nn_1_N = mkN "TV-signal" "TV-signaler" ;
  VVS_armatur_nn_1_N = mkN "VVS-armatur" "VVS-armaturer" ;
  Vellingemoderat_nn_1_N = mkN "Vellingemoderat" "Vellingemoderater" ;
  Vietnamveteran_nn_1_N = mkN "Vietnamveteran" "Vietnamveteraner" ;
  X_kromosom_nn_1_N = mkN "X-kromosom" "X-kromosomer" ;
  Y_kromosom_nn_1_N = mkN "Y-kromosom" "Y-kromosomer" ;
  a_bomb_nn_1_N = mkN "a-bomb" "a-bomber" ;
  abakus_nn_1_N = mkN "abakus" "abakuser" ;
  abbreviation_nn_1_N = mkN "abbreviation" "abbreviationer" ;
  abbreviatur_nn_1_N = mkN "abbreviatur" "abbreviaturer" ;
  abdikation_nn_1_N = mkN "abdikation" "abdikationer" ;
  aberration_nn_1_N = mkN "aberration" "aberrationer" ;
  abessiv_nn_1_N = mkN "abessiv" "abessiver" ;
  abilitet_nn_1_N = mkN "abilitet" "abiliteter" ;
  ablation_nn_1_N = mkN "ablation" "ablationer" ;
  ablativ_nn_1_N = mkN "ablativ" "ablativer" ;
  abnormitet_nn_1_N = mkN "abnormitet" "abnormiteter" ;
  abolition_nn_1_N = mkN "abolition" "abolitioner" ;
  abolitionist_nn_1_N = mkN "abolitionist" "abolitionister" ;
  aborigin_nn_1_N = mkN "aborigin" "aboriginer" ;
  abort_nn_1_N = mkN "abort" "aborter" ;
  abortraett_nn_1_1_N = mkN "aborträtt" "aborträtter" ;
  abrasion_nn_1_N = mkN "abrasion" "abrasioner" ;
  abrovink_nn_1_N = mkN "abrovink" "abrovinker" ;
  abrovinsch_nn_1_N = mkN "abrovinsch" "abrovinscher" ;
  abscess_nn_1_N = mkN "abscess" "abscesser" ;
  absens_nn_1_N = mkN "absens" "absenser" ;
  absid_nn_1_N = mkN "absid" "absider" ;
  absolution_nn_1_N = mkN "absolution" "absolutioner" ;
  absolutism_nn_1_N = mkN "absolutism" "absolutismer" ;
  absolutist_nn_1_N = mkN "absolutist" "absolutister" ;
  absolutiv_nn_1_N = mkN "absolutiv" "absolutiver" ;
  absorption_nn_1_N = mkN "absorption" "absorptioner" ;
  abstraktion_nn_1_N = mkN "abstraktion" "abstraktioner" ;
  absurdism_nn_1_N = mkN "absurdism" "absurdismer" ;
  absurditet_nn_1_N = mkN "absurditet" "absurditeter" ;
  acceleration_nn_1_N = mkN "acceleration" "accelerationer" ;
  accelerator_nn_1_N = mkN "accelerator" "acceleratorer" ;
  acceleratormaskin_nn_1_N = mkN "acceleratormaskin" "acceleratormaskiner" ;
  accent_nn_1_N = mkN "accent" "accenter" ;
  accept_nn_2_N = mkN "accept" "accepter" ;
  acceptant_nn_1_N = mkN "acceptant" "acceptanter" ;
  acceptkredit_nn_1_N = mkN "acceptkredit" "acceptkrediter" ;
  access_nn_1_N = mkN "access" "accesser" ;
  accession_nn_1_N = mkN "accession" "accessioner" ;
  accessoar_nn_1_N = mkN "accessoar" "accessoarer" ;
  accidens_nn_1_N = mkN "accidens" "accidenser" ;
  accis_nn_1_N = mkN "accis" "acciser" ;
  acetaldehyd_nn_1_N = mkN "acetaldehyd" "acetaldehyder" ;
  aciditet_nn_1_N = mkN "aciditet" "aciditeter" ;
  acklamation_nn_1_N = mkN "acklamation" "acklamationer" ;
  ackommodation_nn_1_N = mkN "ackommodation" "ackommodationer" ;
  ackordsloen_nn_1_1_N = mkN "ackordslön" "ackordslöner" ;
  ackumulation_nn_1_N = mkN "ackumulation" "ackumulationer" ;
  ackumulator_nn_1_N = mkN "ackumulator" "ackumulatorer" ;
  ackusativ_nn_1_N = mkN "ackusativ" "ackusativer" ;
  ackvisition_nn_1_N = mkN "ackvisition" "ackvisitioner" ;
  actionfilm_nn_1_N = mkN "actionfilm" "actionfilmer" ;
  adaptation_nn_1_N = mkN "adaptation" "adaptationer" ;
  adaption_nn_1_N = mkN "adaption" "adaptioner" ;
  addiktion_nn_1_N = mkN "addiktion" "addiktioner" ;
  addiktolog_nn_1_N = mkN "addiktolog" "addiktologer" ;
  addition_nn_1_N = mkN "addition" "additioner" ;
  adduktion_nn_1_N = mkN "adduktion" "adduktioner" ;
  adelsdam_nn_1_N = mkN "adelsdam" "adelsdamer" ;
  adelsslaekt_nn_1_1_N = mkN "adelssläkt" "adelssläkter" ;
  adenit_nn_1_N = mkN "adenit" "adeniter" ;
  adessiv_nn_1_N = mkN "adessiv" "adessiver" ;
  adhesion_nn_1_N = mkN "adhesion" "adhesioner" ;
  adjunktion_nn_1_N = mkN "adjunktion" "adjunktioner" ;
  adjunktur_nn_1_N = mkN "adjunktur" "adjunkturer" ;
  administration_nn_1_N = mkN "administration" "administrationer" ;
  administrator_nn_1_N = mkN "administrator" "administratorer" ;
  admonition_nn_1_N = mkN "admonition" "admonitioner" ;
  adoptant_nn_1_N = mkN "adoptant" "adoptanter" ;
  adoption_nn_1_N = mkN "adoption" "adoptioner" ;
  adress_nn_1_N = mkN "adress" "adresser" ;
  adsorption_nn_1_N = mkN "adsorption" "adsorptioner" ;
  adventist_nn_1_N = mkN "adventist" "adventister" ;
  advers_nn_1_N = mkN "advers" "adverser" ;
  advokat_nn_1_N = mkN "advokat" "advokater" ;
  advokatbyraa_nn_1_1_N = mkN "advokatbyrå" "advokatbyråer" ;
  aerogel_nn_1_N = mkN "aerogel" "aerogeler" ;
  aerosol_nn_1_N = mkN "aerosol" "aerosoler" ;
  affektation_nn_1_N = mkN "affektation" "affektationer" ;
  affektion_nn_1_N = mkN "affektion" "affektioner" ;
  affinitet_nn_1_N = mkN "affinitet" "affiniteter" ;
  affisch_nn_1_N = mkN "affisch" "affischer" ;
  affischkampanj_nn_1_N = mkN "affischkampanj" "affischkampanjer" ;
  affaer_nn_1_1_N = mkN "affär" "affärer" ;
  affaersfastighet_nn_1_1_N = mkN "affärsfastighet" "affärsfastigheter" ;
  affaersresenaer_nn_1_1_N = mkN "affärsresenär" "affärsresenärer" ;
  affaerstransaktion_nn_1_1_N = mkN "affärstransaktion" "affärstransaktioner" ;
  affaersverksamhet_nn_1_1_N = mkN "affärsverksamhet" "affärsverksamheter" ;
  afghan_nn_1_N = mkN "afghan" "afghaner" ;
  aforism_nn_1_N = mkN "aforism" "aforismer" ;
  afrikan_nn_1_N = mkN "afrikan" "afrikaner" ;
  afroamerikan_nn_1_N = mkN "afroamerikan" "afroamerikaner" ;
  aftonboen_nn_1_1_N = mkN "aftonbön" "aftonböner" ;
  aftondraekt_nn_1_1_N = mkN "aftondräkt" "aftondräkter" ;
  aftongudstjaenst_nn_1_1_N = mkN "aftongudstjänst" "aftongudstjänster" ;
  aftonmaaltid_nn_1_1_N = mkN "aftonmåltid" "aftonmåltider" ;
  aftonrodnad_nn_1_N = mkN "aftonrodnad" "aftonrodnader" ;
  aftonstund_nn_1_N = mkN "aftonstund" "aftonstunder" ;
  aftonsaang_nn_1_1_N = mkN "aftonsång" "aftonsånger" ;
  agens_nn_1_N = mkN "agens" "agenser" ;
  agentfilm_nn_1_N = mkN "agentfilm" "agentfilmer" ;
  agentur_nn_1_N = mkN "agentur" "agenturer" ;
  agglomeration_nn_1_N = mkN "agglomeration" "agglomerationer" ;
  agglutination_nn_1_N = mkN "agglutination" "agglutinationer" ;
  aggregation_nn_1_N = mkN "aggregation" "aggregationer" ;
  aggregationsform_nn_1_N = mkN "aggregationsform" "aggregationsformer" ;
  aggression_nn_1_N = mkN "aggression" "aggressioner" ;
  aggressivitet_nn_1_N = mkN "aggressivitet" "aggressiviteter" ;
  agitation_nn_1_N = mkN "agitation" "agitationer" ;
  agitator_nn_1_N = mkN "agitator" "agitatorer" ;
  agnosticism_nn_1_N = mkN "agnosticism" "agnosticismer" ;
  aidsmedicin_nn_1_N = mkN "aidsmedicin" "aidsmediciner" ;
  aidspanik_nn_1_N = mkN "aidspanik" "aidspaniker" ;
  air_nn_1_N = mkN "air" "airer" ;
  airbagsensor_nn_1_N = mkN "airbagsensor" "airbagsensorer" ;
  akademist_nn_1_N = mkN "akademist" "akademister" ;
  akant_nn_1_N = mkN "akant" "akanter" ;
  akropol_nn_1_N = mkN "akropol" "akropoler" ;
  akt_nn_1_N = mkN "akt" "akter" ;
  aktant_nn_1_N = mkN "aktant" "aktanter" ;
  aktieboers_nn_1_1_N = mkN "aktiebörs" "aktiebörser" ;
  aktieemission_nn_1_N = mkN "aktieemission" "aktieemissioner" ;
  aktiekurs_nn_1_N = mkN "aktiekurs" "aktiekurser" ;
  aktiemajoritet_nn_1_N = mkN "aktiemajoritet" "aktiemajoriteter" ;
  aktiepost_nn_1_N = mkN "aktiepost" "aktieposter" ;
  aktievinst_nn_1_N = mkN "aktievinst" "aktievinster" ;
  aktion_nn_1_N = mkN "aktion" "aktioner" ;
  aktionsgrupp_nn_1_N = mkN "aktionsgrupp" "aktionsgrupper" ;
  aktionsturbin_nn_1_N = mkN "aktionsturbin" "aktionsturbiner" ;
  aktivism_nn_1_N = mkN "aktivism" "aktivismer" ;
  aktivist_nn_1_N = mkN "aktivist" "aktivister" ;
  aktivitet_nn_1_N = mkN "aktivitet" "aktiviteter" ;
  aktor_nn_1_N = mkN "aktor" "aktorer" ;
  aktris_nn_1_N = mkN "aktris" "aktriser" ;
  aktsamhet_nn_1_N = mkN "aktsamhet" "aktsamheter" ;
  aktsamhetsplikt_nn_1_N = mkN "aktsamhetsplikt" "aktsamhetsplikter" ;
  aktualitet_nn_1_N = mkN "aktualitet" "aktualiteter" ;
  akut_nn_1_N = mkN "akut" "akuter" ;
  akvakultur_nn_1_N = mkN "akvakultur" "akvakulturer" ;
  akvamarin_nn_1_N = mkN "akvamarin" "akvamariner" ;
  akvarellfaerg_nn_1_1_N = mkN "akvarellfärg" "akvarellfärger" ;
  akvarellist_nn_1_N = mkN "akvarellist" "akvarellister" ;
  akvavit_nn_1_N = mkN "akvavit" "akvaviter" ;
  alan_nn_1_N = mkN "alan" "alaner" ;
  alant_nn_1_N = mkN "alant" "alanter" ;
  alarmist_nn_1_N = mkN "alarmist" "alarmister" ;
  alarmsignal_nn_1_N = mkN "alarmsignal" "alarmsignaler" ;
  alban_nn_1_N = mkN "alban" "albaner" ;
  albatross_nn_1_N = mkN "albatross" "albatrosser" ;
  albigens_nn_1_N = mkN "albigens" "albigenser" ;
  albinism_nn_1_N = mkN "albinism" "albinismer" ;
  aldehyd_nn_1_N = mkN "aldehyd" "aldehyder" ;
  alexandrin_nn_1_N = mkN "alexandrin" "alexandriner" ;
  alf_nn_1_N = mkN "alf" "alfer" ;
  alfons_nn_1_N = mkN "alfons" "alfonser" ;
  alg_nn_1_N = mkN "alg" "alger" ;
  algolog_nn_1_N = mkN "algolog" "algologer" ;
  alienation_nn_1_N = mkN "alienation" "alienationer" ;
  alkaloid_nn_1_N = mkN "alkaloid" "alkaloider" ;
  alkan_nn_1_N = mkN "alkan" "alkaner" ;
  alkanol_nn_1_N = mkN "alkanol" "alkanoler" ;
  alkemist_nn_1_N = mkN "alkemist" "alkemister" ;
  alkohol_nn_1_N = mkN "alkohol" "alkoholer" ;
  alkoholhalt_nn_1_N = mkN "alkoholhalt" "alkoholhalter" ;
  alkoholism_nn_1_N = mkN "alkoholism" "alkoholismer" ;
  alkoholist_nn_1_N = mkN "alkoholist" "alkoholister" ;
  alkoholistanstalt_nn_1_N = mkN "alkoholistanstalt" "alkoholistanstalter" ;
  alkoholkonsumtion_nn_1_N = mkN "alkoholkonsumtion" "alkoholkonsumtioner" ;
  alkoholpsykos_nn_1_N = mkN "alkoholpsykos" "alkoholpsykoser" ;
  alkoholskatt_nn_1_N = mkN "alkoholskatt" "alkoholskatter" ;
  alkyd_nn_1_N = mkN "alkyd" "alkyder" ;
  alkyl_nn_1_N = mkN "alkyl" "alkyler" ;
  alkyn_nn_1_N = mkN "alkyn" "alkyner" ;
  allativ_nn_1_N = mkN "allativ" "allativer" ;
  allel_nn_1_N = mkN "allel" "alleler" ;
  allemansfond_nn_1_N = mkN "allemansfond" "allemansfonder" ;
  allergimedicin_nn_1_N = mkN "allergimedicin" "allergimediciner" ;
  allergolog_nn_1_N = mkN "allergolog" "allergologer" ;
  allians_nn_1_N = mkN "allians" "allianser" ;
  alligator_nn_1_N = mkN "alligator" "alligatorer" ;
  allitteration_nn_1_N = mkN "allitteration" "allitterationer" ;
  allkonstnaer_nn_1_1_N = mkN "allkonstnär" "allkonstnärer" ;
  allmogedraekt_nn_1_1_N = mkN "allmogedräkt" "allmogedräkter" ;
  allmogekultur_nn_1_N = mkN "allmogekultur" "allmogekulturer" ;
  allmogevaevnad_nn_1_1_N = mkN "allmogevävnad" "allmogevävnader" ;
  allmaengiltighet_nn_1_1_N = mkN "allmängiltighet" "allmängiltigheter" ;
  allmaenhet_nn_1_1_N = mkN "allmänhet" "allmänheter" ;
  allmaenprevention_nn_1_1_N = mkN "allmänprevention" "allmänpreventioner" ;
  allofon_nn_1_N = mkN "allofon" "allofoner" ;
  allokution_nn_1_N = mkN "allokution" "allokutioner" ;
  allsaang_nn_1_1_N = mkN "allsång" "allsånger" ;
  allusion_nn_1_N = mkN "allusion" "allusioner" ;
  allvarsamhet_nn_1_N = mkN "allvarsamhet" "allvarsamheter" ;
  all_e_nn_1_1_N = mkN "allé" "alléer" ;
  almanack_nn_1_N = mkN "almanack" "almanacker" ;
  alpidyll_nn_1_N = mkN "alpidyll" "alpidyller" ;
  alpinism_nn_1_N = mkN "alpinism" "alpinismer" ;
  alpinist_nn_1_N = mkN "alpinist" "alpinister" ;
  altan_nn_1_N = mkN "altan" "altaner" ;
  altarprydnad_nn_1_N = mkN "altarprydnad" "altarprydnader" ;
  altartjaenst_nn_1_1_N = mkN "altartjänst" "altartjänster" ;
  alteration_nn_1_N = mkN "alteration" "alterationer" ;
  alternativkurs_nn_1_N = mkN "alternativkurs" "alternativkurser" ;
  altfloejt_nn_1_1_N = mkN "altflöjt" "altflöjter" ;
  altruism_nn_1_N = mkN "altruism" "altruismer" ;
  altruist_nn_1_N = mkN "altruist" "altruister" ;
  altroest_nn_1_1_N = mkN "altröst" "altröster" ;
  altviolin_nn_1_N = mkN "altviolin" "altvioliner" ;
  aluminiumfabrik_nn_1_N = mkN "aluminiumfabrik" "aluminiumfabriker" ;
  aluminiumjon_nn_1_N = mkN "aluminiumjon" "aluminiumjoner" ;
  aluminiumlinjal_nn_1_N = mkN "aluminiumlinjal" "aluminiumlinjaler" ;
  alv_nn_2_N = mkN "alv" "alver" ;
  alvarsmark_nn_1_N = mkN "alvarsmark" "alvarsmarker" ;
  alveol_nn_1_N = mkN "alveol" "alveoler" ;
  amanuens_nn_1_N = mkN "amanuens" "amanuenser" ;
  amarant_nn_1_N = mkN "amarant" "amaranter" ;
  amason_nn_1_N = mkN "amason" "amasoner" ;
  amatoerastronom_nn_1_1_N = mkN "amatörastronom" "amatörastronomer" ;
  amatoeridrott_nn_1_1_N = mkN "amatöridrott" "amatöridrotter" ;
  amatoerism_nn_1_1_N = mkN "amatörism" "amatörismer" ;
  amazon_nn_1_N = mkN "amazon" "amazoner" ;
  ambassadris_nn_1_N = mkN "ambassadris" "ambassadriser" ;
  ambassadoer_nn_1_1_N = mkN "ambassadör" "ambassadörer" ;
  ambassadoerspost_nn_1_1_N = mkN "ambassadörspost" "ambassadörsposter" ;
  ambiguitet_nn_1_N = mkN "ambiguitet" "ambiguiteter" ;
  ambition_nn_1_N = mkN "ambition" "ambitioner" ;
  ambitionssak_nn_1_N = mkN "ambitionssak" "ambitionssaker" ;
  ambulans_nn_1_N = mkN "ambulans" "ambulanser" ;
  amerikan_nn_1_N = mkN "amerikan" "amerikaner" ;
  amerikanism_nn_1_N = mkN "amerikanism" "amerikanismer" ;
  ametist_nn_1_N = mkN "ametist" "ametister" ;
  amfibolit_nn_1_N = mkN "amfibolit" "amfiboliter" ;
  amid_nn_1_N = mkN "amid" "amider" ;
  ammonit_nn_1_N = mkN "ammonit" "ammoniter" ;
  ammunition_nn_1_N = mkN "ammunition" "ammunitioner" ;
  amoralism_nn_1_N = mkN "amoralism" "amoralismer" ;
  amoralitet_nn_1_N = mkN "amoralitet" "amoraliteter" ;
  amorfism_nn_1_N = mkN "amorfism" "amorfismer" ;
  amorin_nn_1_N = mkN "amorin" "amoriner" ;
  amorteringsplan_nn_1_N = mkN "amorteringsplan" "amorteringsplaner" ;
  amputation_nn_1_N = mkN "amputation" "amputationer" ;
  amulett_nn_1_N = mkN "amulett" "amuletter" ;
  amylas_nn_1_N = mkN "amylas" "amylaser" ;
  anabaptism_nn_1_N = mkN "anabaptism" "anabaptismer" ;
  anabaptist_nn_1_N = mkN "anabaptist" "anabaptister" ;
  anabol_nn_1_N = mkN "anabol" "anaboler" ;
  anakronism_nn_1_N = mkN "anakronism" "anakronismer" ;
  analfabetism_nn_1_N = mkN "analfabetism" "analfabetismer" ;
  analys_nn_1_N = mkN "analys" "analyser" ;
  analysmetodik_nn_1_N = mkN "analysmetodik" "analysmetodiker" ;
  anamnes_nn_1_N = mkN "anamnes" "anamneser" ;
  ananassallad_nn_1_N = mkN "ananassallad" "ananassallader" ;
  anapest_nn_1_N = mkN "anapest" "anapester" ;
  anarkism_nn_1_N = mkN "anarkism" "anarkismer" ;
  anarkist_nn_1_N = mkN "anarkist" "anarkister" ;
  anarkosyndikalism_nn_1_N = mkN "anarkosyndikalism" "anarkosyndikalismer" ;
  anarkosyndikalist_nn_1_N = mkN "anarkosyndikalist" "anarkosyndikalister" ;
  anastas_nn_1_N = mkN "anastas" "anastaser" ;
  ancestor_nn_1_N = mkN "ancestor" "ancestorer" ;
  anciennitet_nn_1_N = mkN "anciennitet" "ancienniteter" ;
  andaktsstund_nn_1_N = mkN "andaktsstund" "andaktsstunder" ;
  andedraekt_nn_1_1_N = mkN "andedräkt" "andedräkter" ;
  andfigur_nn_1_N = mkN "andfigur" "andfigurer" ;
  andhaemtningspaus_nn_1_1_N = mkN "andhämtningspaus" "andhämtningspauser" ;
  andjakt_nn_1_N = mkN "andjakt" "andjakter" ;
  andningspaus_nn_1_N = mkN "andningspaus" "andningspauser" ;
  andningsreaktion_nn_1_N = mkN "andningsreaktion" "andningsreaktioner" ;
  andningssvaarighet_nn_1_1_N = mkN "andningssvårighet" "andningssvårigheter" ;
  andorran_nn_1_N = mkN "andorran" "andorraner" ;
  andragradsekvation_nn_1_N = mkN "andragradsekvation" "andragradsekvationer" ;
  andrahandsbutik_nn_1_N = mkN "andrahandsbutik" "andrahandsbutiker" ;
  andrahandsfaktorer_nn_1_N = mkN "andrahandsfaktorer" "andrahandsfaktorerer" ;
  andrahandsinformation_nn_1_N = mkN "andrahandsinformation" "andrahandsinformationer" ;
  andrahandsuppgift_nn_1_N = mkN "andrahandsuppgift" "andrahandsuppgifter" ;
  andraplats_nn_1_N = mkN "andraplats" "andraplatser" ;
  andrechef_nn_1_N = mkN "andrechef" "andrechefer" ;
  androgyn_nn_1_N = mkN "androgyn" "androgyner" ;
  android_nn_1_N = mkN "android" "androider" ;
  anemon_nn_1_N = mkN "anemon" "anemoner" ;
  anestesiolog_nn_1_N = mkN "anestesiolog" "anestesiologer" ;
  anfallsbas_nn_1_N = mkN "anfallsbas" "anfallsbaser" ;
  angelaegenhet_nn_1_1_N = mkN "angelägenhet" "angelägenheter" ;
  anglicism_nn_1_N = mkN "anglicism" "anglicismer" ;
  anglist_nn_1_N = mkN "anglist" "anglister" ;
  anglaes_nn_1_1_N = mkN "angläs" "angläser" ;
  angolan_nn_1_N = mkN "angolan" "angolaner" ;
  angreppspunkt_nn_1_N = mkN "angreppspunkt" "angreppspunkter" ;
  anilinfaerg_nn_1_1_N = mkN "anilinfärg" "anilinfärger" ;
  animation_nn_1_N = mkN "animation" "animationer" ;
  animism_nn_1_N = mkN "animism" "animismer" ;
  animositet_nn_1_N = mkN "animositet" "animositeter" ;
  aningsloeshet_nn_1_1_N = mkN "aningslöshet" "aningslösheter" ;
  anjon_nn_1_N = mkN "anjon" "anjoner" ;
  ankarplats_nn_1_N = mkN "ankarplats" "ankarplatser" ;
  anklagelsepunkt_nn_1_N = mkN "anklagelsepunkt" "anklagelsepunkter" ;
  anklagelseskrift_nn_1_N = mkN "anklagelseskrift" "anklagelseskrifter" ;
  ankomst_nn_1_N = mkN "ankomst" "ankomster" ;
  ankomstkommun_nn_1_N = mkN "ankomstkommun" "ankomstkommuner" ;
  ankomsttid_nn_1_N = mkN "ankomsttid" "ankomsttider" ;
  ankringsplats_nn_1_N = mkN "ankringsplats" "ankringsplatser" ;
  anlaeggningskostnad_nn_1_1_N = mkN "anläggningskostnad" "anläggningskostnader" ;
  anlaeggningsplats_nn_1_1_N = mkN "anläggningsplats" "anläggningsplatser" ;
  anmarsch_nn_1_N = mkN "anmarsch" "anmarscher" ;
  anmaelningsbenaegenhet_nn_1_1_N = mkN "anmälningsbenägenhet" "anmälningsbenägenheter" ;
  anmaelningstid_nn_1_1_N = mkN "anmälningstid" "anmälningstider" ;
  annalist_nn_1_N = mkN "annalist" "annalister" ;
  annektion_nn_1_N = mkN "annektion" "annektioner" ;
  annexion_nn_1_N = mkN "annexion" "annexioner" ;
  annihilation_nn_1_N = mkN "annihilation" "annihilationer" ;
  annons_nn_1_N = mkN "annons" "annonser" ;
  annonsbojkott_nn_1_N = mkN "annonsbojkott" "annonsbojkotter" ;
  annonsbyraa_nn_1_1_N = mkN "annonsbyrå" "annonsbyråer" ;
  annonskampanj_nn_1_N = mkN "annonskampanj" "annonskampanjer" ;
  annonsplats_nn_1_N = mkN "annonsplats" "annonsplatser" ;
  annotation_nn_1_N = mkN "annotation" "annotationer" ;
  annuitet_nn_1_N = mkN "annuitet" "annuiteter" ;
  anonymitet_nn_1_N = mkN "anonymitet" "anonymiteter" ;
  anpassningsgrupp_nn_1_N = mkN "anpassningsgrupp" "anpassningsgrupper" ;
  anropssignal_nn_1_N = mkN "anropssignal" "anropssignaler" ;
  ansats_nn_1_N = mkN "ansats" "ansatser" ;
  ansiktsform_nn_1_N = mkN "ansiktsform" "ansiktsformer" ;
  ansiktsfaerg_nn_1_1_N = mkN "ansiktsfärg" "ansiktsfärger" ;
  ansiktskraem_nn_1_1_N = mkN "ansiktskräm" "ansiktskrämer" ;
  ansiktsmask_nn_1_N = mkN "ansiktsmask" "ansiktsmasker" ;
  ansiktsoval_nn_1_N = mkN "ansiktsoval" "ansiktsovaler" ;
  anskaffningskostnad_nn_1_N = mkN "anskaffningskostnad" "anskaffningskostnader" ;
  anskraemlighet_nn_1_1_N = mkN "anskrämlighet" "anskrämligheter" ;
  anslutningskontakt_nn_1_N = mkN "anslutningskontakt" "anslutningskontakter" ;
  anslutningspunkt_nn_1_N = mkN "anslutningspunkt" "anslutningspunkter" ;
  anspraaksloeshet_nn_1_1_N = mkN "anspråkslöshet" "anspråkslösheter" ;
  anstaltspastor_nn_1_N = mkN "anstaltspastor" "anstaltspastorer" ;
  anstaellningskommitt_e_nn_1_1_N = mkN "anställningskommitté" "anställningskommittéer" ;
  anstaellningsraettighet_nn_1_1_N = mkN "anställningsrättighet" "anställningsrättigheter" ;
  anstaellningstid_nn_1_1_N = mkN "anställningstid" "anställningstider" ;
  anstaendighet_nn_1_1_N = mkN "anständighet" "anständigheter" ;
  anstoetlighet_nn_1_1_N = mkN "anstötlighet" "anstötligheter" ;
  ansvarsfrihet_nn_1_N = mkN "ansvarsfrihet" "ansvarsfriheter" ;
  ansvarsnaemnd_nn_1_1_N = mkN "ansvarsnämnd" "ansvarsnämnder" ;
  ansvarspaafoeljd_nn_1_1_N = mkN "ansvarspåföljd" "ansvarspåföljder" ;
  ansvarsskyldighet_nn_1_N = mkN "ansvarsskyldighet" "ansvarsskyldigheter" ;
  antagonism_nn_1_N = mkN "antagonism" "antagonismer" ;
  antagonist_nn_1_N = mkN "antagonist" "antagonister" ;
  antecipation_nn_1_N = mkN "antecipation" "antecipationer" ;
  antefix_nn_1_N = mkN "antefix" "antefixer" ;
  anticyklon_nn_1_N = mkN "anticyklon" "anticykloner" ;
  antidiskrimineringsbyraa_nn_1_1_N = mkN "antidiskrimineringsbyrå" "antidiskrimineringsbyråer" ;
  antiguan_nn_1_N = mkN "antiguan" "antiguaner" ;
  antiintellektualism_nn_1_N = mkN "antiintellektualism" "antiintellektualismer" ;
  antikommunism_nn_1_N = mkN "antikommunism" "antikommunismer" ;
  antikorruptionsaktivist_nn_1_N = mkN "antikorruptionsaktivist" "antikorruptionsaktivister" ;
  antikorruptionskonferens_nn_1_N = mkN "antikorruptionskonferens" "antikorruptionskonferenser" ;
  antikvitet_nn_1_N = mkN "antikvitet" "antikviteter" ;
  antimakass_nn_1_N = mkN "antimakass" "antimakasser" ;
  antimilitarism_nn_1_N = mkN "antimilitarism" "antimilitarismer" ;
  antimilitarist_nn_1_N = mkN "antimilitarist" "antimilitarister" ;
  antioxidant_nn_1_N = mkN "antioxidant" "antioxidanter" ;
  antirynkkraem_nn_1_1_N = mkN "antirynkkräm" "antirynkkrämer" ;
  antisemit_nn_1_N = mkN "antisemit" "antisemiter" ;
  antisemitism_nn_1_N = mkN "antisemitism" "antisemitismer" ;
  antisionism_nn_1_N = mkN "antisionism" "antisionismer" ;
  antites_nn_1_N = mkN "antites" "antiteser" ;
  antivirusexpert_nn_1_N = mkN "antivirusexpert" "antivirusexperter" ;
  antiaalderskraem_nn_1_1_N = mkN "antiålderskräm" "antiålderskrämer" ;
  antonym_nn_1_N = mkN "antonym" "antonymer" ;
  antropoid_nn_1_N = mkN "antropoid" "antropoider" ;
  antropolog_nn_1_N = mkN "antropolog" "antropologer" ;
  antropomorfism_nn_1_N = mkN "antropomorfism" "antropomorfismer" ;
  anvisningskommun_nn_1_N = mkN "anvisningskommun" "anvisningskommuner" ;
  anvaendargrupp_nn_1_1_N = mkN "användargrupp" "användargrupper" ;
  anvaendbarhet_nn_1_1_N = mkN "användbarhet" "användbarheter" ;
  anvaendningsmoejlighet_nn_1_1_N = mkN "användningsmöjlighet" "användningsmöjligheter" ;
  aorist_nn_1_N = mkN "aorist" "aorister" ;
  apart_nn_1_N = mkN "apart" "aparter" ;
  apartheidregim_nn_1_N = mkN "apartheidregim" "apartheidregimer" ;
  apelsin_nn_1_N = mkN "apelsin" "apelsiner" ;
  apelsinmarmelad_nn_1_N = mkN "apelsinmarmelad" "apelsinmarmelader" ;
  apertur_nn_1_N = mkN "apertur" "aperturer" ;
  apokalyps_nn_1_N = mkN "apokalyps" "apokalypser" ;
  apostrof_nn_1_N = mkN "apostrof" "apostrofer" ;
  apoteksvaext_nn_1_1_N = mkN "apoteksväxt" "apoteksväxter" ;
  apoteos_nn_1_N = mkN "apoteos" "apoteoser" ;
  apparans_nn_1_N = mkN "apparans" "apparanser" ;
  apparat_nn_1_N = mkN "apparat" "apparater" ;
  apparatur_nn_1_N = mkN "apparatur" "apparaturer" ;
  apparition_nn_1_N = mkN "apparition" "apparitioner" ;
  appell_nn_1_N = mkN "appell" "appeller" ;
  appellant_nn_1_N = mkN "appellant" "appellanter" ;
  appendicit_nn_1_N = mkN "appendicit" "appendiciter" ;
  apperception_nn_1_N = mkN "apperception" "apperceptioner" ;
  applikation_nn_1_N = mkN "applikation" "applikationer" ;
  applikatur_nn_1_N = mkN "applikatur" "applikaturer" ;
  apport_nn_1_N = mkN "apport" "apporter" ;
  apposition_nn_1_N = mkN "apposition" "appositioner" ;
  appretur_nn_1_N = mkN "appretur" "appreturer" ;
  appretyr_nn_1_N = mkN "appretyr" "appretyrer" ;
  approach_nn_1_N = mkN "approach" "approacher" ;
  approximation_nn_1_N = mkN "approximation" "approximationer" ;
  aprikos_nn_1_N = mkN "aprikos" "aprikoser" ;
  aptitlighet_nn_1_N = mkN "aptitlighet" "aptitligheter" ;
  aptitloeshet_nn_1_1_N = mkN "aptitlöshet" "aptitlösheter" ;
  arabesk_nn_1_N = mkN "arabesk" "arabesker" ;
  arabist_nn_1_N = mkN "arabist" "arabister" ;
  aramid_nn_1_N = mkN "aramid" "aramider" ;
  arbetargrupp_nn_1_N = mkN "arbetargrupp" "arbetargrupper" ;
  arbetarklass_nn_1_N = mkN "arbetarklass" "arbetarklasser" ;
  arbetarsaang_nn_1_1_N = mkN "arbetarsång" "arbetarsånger" ;
  arbetsanstalt_nn_1_N = mkN "arbetsanstalt" "arbetsanstalter" ;
  arbetsbredd_nn_1_N = mkN "arbetsbredd" "arbetsbredder" ;
  arbetschef_nn_1_N = mkN "arbetschef" "arbetschefer" ;
  arbetsdraekt_nn_1_1_N = mkN "arbetsdräkt" "arbetsdräkter" ;
  arbetsfoertjaenst_nn_1_1_N = mkN "arbetsförtjänst" "arbetsförtjänster" ;
  arbetsgivaravgift_nn_1_N = mkN "arbetsgivaravgift" "arbetsgivaravgifter" ;
  arbetsgrupp_nn_1_N = mkN "arbetsgrupp" "arbetsgrupper" ;
  arbetshypotes_nn_1_N = mkN "arbetshypotes" "arbetshypoteser" ;
  arbetsinkomst_nn_1_N = mkN "arbetsinkomst" "arbetsinkomster" ;
  arbetsinsats_nn_1_N = mkN "arbetsinsats" "arbetsinsatser" ;
  arbetskonflikt_nn_1_N = mkN "arbetskonflikt" "arbetskonflikter" ;
  arbetskostnad_nn_1_N = mkN "arbetskostnad" "arbetskostnader" ;
  arbetslivserfarenhet_nn_1_N = mkN "arbetslivserfarenhet" "arbetslivserfarenheter" ;
  arbetslivsfond_nn_1_N = mkN "arbetslivsfond" "arbetslivsfonder" ;
  arbetslaengd_nn_1_1_N = mkN "arbetslängd" "arbetslängder" ;
  arbetsloen_nn_1_1_N = mkN "arbetslön" "arbetslöner" ;
  arbetsloeshet_nn_1_1_N = mkN "arbetslöshet" "arbetslösheter" ;
  arbetsmarknad_nn_1_N = mkN "arbetsmarknad" "arbetsmarknader" ;
  arbetsmarknadskonflikt_nn_1_N = mkN "arbetsmarknadskonflikt" "arbetsmarknadskonflikter" ;
  arbetsmarknadsaatgaerd_nn_1_1_N = mkN "arbetsmarknadsåtgärd" "arbetsmarknadsåtgärder" ;
  arbetsmaengd_nn_1_1_N = mkN "arbetsmängd" "arbetsmängder" ;
  arbetsnarkoman_nn_1_N = mkN "arbetsnarkoman" "arbetsnarkomaner" ;
  arbetsnaemnd_nn_1_1_N = mkN "arbetsnämnd" "arbetsnämnder" ;
  arbetsplan_nn_1_N = mkN "arbetsplan" "arbetsplaner" ;
  arbetsplats_nn_1_N = mkN "arbetsplats" "arbetsplatser" ;
  arbetspremiss_nn_1_N = mkN "arbetspremiss" "arbetspremisser" ;
  arbetsrelation_nn_1_N = mkN "arbetsrelation" "arbetsrelationer" ;
  arbetssaang_nn_1_1_N = mkN "arbetssång" "arbetssånger" ;
  arbetstemperatur_nn_1_N = mkN "arbetstemperatur" "arbetstemperaturer" ;
  arbetstid_nn_1_N = mkN "arbetstid" "arbetstider" ;
  arbetstvist_nn_1_N = mkN "arbetstvist" "arbetstvister" ;
  arbetsuppgift_nn_1_N = mkN "arbetsuppgift" "arbetsuppgifter" ;
  argumentation_nn_1_N = mkN "argumentation" "argumentationer" ;
  arian_nn_1_N = mkN "arian" "arianer" ;
  arianism_nn_1_N = mkN "arianism" "arianismer" ;
  arkaism_nn_1_N = mkN "arkaism" "arkaismer" ;
  arkeolog_nn_1_N = mkN "arkeolog" "arkeologer" ;
  arkipelag_nn_1_N = mkN "arkipelag" "arkipelager" ;
  arkitekt_nn_1_N = mkN "arkitekt" "arkitekter" ;
  arkitektur_nn_1_N = mkN "arkitektur" "arkitekturer" ;
  arkitrav_nn_1_N = mkN "arkitrav" "arkitraver" ;
  arkivolt_nn_1_N = mkN "arkivolt" "arkivolter" ;
  arksignatur_nn_1_N = mkN "arksignatur" "arksignaturer" ;
  armatur_nn_1_N = mkN "armatur" "armaturer" ;
  armbaagsled_nn_1_1_N = mkN "armbågsled" "armbågsleder" ;
  armkraft_nn_1_N = mkN "armkraft" "armkrafter" ;
  armled_nn_1_N = mkN "armled" "armleder" ;
  armlaengd_nn_1_1_N = mkN "armlängd" "armlängder" ;
  armslaengd_nn_1_1_N = mkN "armslängd" "armslängder" ;
  armtrakt_nn_1_N = mkN "armtrakt" "armtrakter" ;
  arm_e_nn_1_1_N = mkN "armé" "arméer" ;
  arm_eattach_e_nn_1_1_N = mkN "arméattaché" "arméattachéer" ;
  arm_echef_nn_1_1_N = mkN "arméchef" "arméchefer" ;
  arm_ekommunik_e_nn_1_1_N = mkN "armékommuniké" "armékommunikéer" ;
  arm_ekaar_nn_1_1_N = mkN "armékår" "armékårer" ;
  arm_eorganisation_nn_1_1_N = mkN "arméorganisation" "arméorganisationer" ;
  arm_estab_nn_1_1_N = mkN "arméstab" "arméstaber" ;
  arrangoer_nn_1_1_N = mkN "arrangör" "arrangörer" ;
  arrendator_nn_1_N = mkN "arrendator" "arrendatorer" ;
  arrendeavgift_nn_1_N = mkN "arrendeavgift" "arrendeavgifter" ;
  arrest_nn_1_N = mkN "arrest" "arrester" ;
  arrestant_nn_1_N = mkN "arrestant" "arrestanter" ;
  arrivist_nn_1_N = mkN "arrivist" "arrivister" ;
  arsenikhalt_nn_1_N = mkN "arsenikhalt" "arsenikhalter" ;
  arsenikkis_nn_1_N = mkN "arsenikkis" "arsenikkiser" ;
  artbank_nn_1_N = mkN "artbank" "artbanker" ;
  artdatabank_nn_1_N = mkN "artdatabank" "artdatabanker" ;
  arterioskleros_nn_1_N = mkN "arterioskleros" "arterioskleroser" ;
  artighet_nn_1_N = mkN "artighet" "artigheter" ;
  artighetsfras_nn_1_N = mkN "artighetsfras" "artighetsfraser" ;
  artighetsvisit_nn_1_N = mkN "artighetsvisit" "artighetsvisiter" ;
  artikulation_nn_1_N = mkN "artikulation" "artikulationer" ;
  artikulationsbas_nn_1_N = mkN "artikulationsbas" "artikulationsbaser" ;
  artilleriduell_nn_1_N = mkN "artilleriduell" "artilleridueller" ;
  artilleripjaes_nn_1_1_N = mkN "artilleripjäs" "artilleripjäser" ;
  artillerist_nn_1_N = mkN "artillerist" "artillerister" ;
  artist_nn_1_N = mkN "artist" "artister" ;
  artrit_nn_1_N = mkN "artrit" "artriter" ;
  artros_nn_1_N = mkN "artros" "artroser" ;
  artskillnad_nn_1_N = mkN "artskillnad" "artskillnader" ;
  artaer_nn_1_1_N = mkN "artär" "artärer" ;
  arvsfaktor_nn_1_N = mkN "arvsfaktor" "arvsfaktorer" ;
  arvsfond_nn_1_N = mkN "arvsfond" "arvsfonder" ;
  arvskatt_nn_1_N = mkN "arvskatt" "arvskatter" ;
  arvsmolekyl_nn_1_N = mkN "arvsmolekyl" "arvsmolekyler" ;
  arvsraett_nn_1_1_N = mkN "arvsrätt" "arvsrätter" ;
  arvsskatt_nn_1_N = mkN "arvsskatt" "arvsskatter" ;
  arvstvist_nn_1_N = mkN "arvstvist" "arvstvister" ;
  asfaltemulsion_nn_1_N = mkN "asfaltemulsion" "asfaltemulsioner" ;
  askenas_nn_1_N = mkN "askenas" "askenaser" ;
  askeruption_nn_1_N = mkN "askeruption" "askeruptioner" ;
  asketism_nn_1_N = mkN "asketism" "asketismer" ;
  askexplosion_nn_1_N = mkN "askexplosion" "askexplosioner" ;
  askkoncentration_nn_1_N = mkN "askkoncentration" "askkoncentrationer" ;
  askkris_nn_1_N = mkN "askkris" "askkriser" ;
  asocialitet_nn_1_N = mkN "asocialitet" "asocialiteter" ;
  aspirant_nn_1_N = mkN "aspirant" "aspiranter" ;
  aspiration_nn_1_N = mkN "aspiration" "aspirationer" ;
  assessor_nn_1_N = mkN "assessor" "assessorer" ;
  assignant_nn_1_N = mkN "assignant" "assignanter" ;
  assignation_nn_1_N = mkN "assignation" "assignationer" ;
  assimilation_nn_1_N = mkN "assimilation" "assimilationer" ;
  assistans_nn_1_N = mkN "assistans" "assistanser" ;
  association_nn_1_N = mkN "association" "associationer" ;
  assonans_nn_1_N = mkN "assonans" "assonanser" ;
  assurans_nn_1_N = mkN "assurans" "assuranser" ;
  asterisk_nn_1_N = mkN "asterisk" "asterisker" ;
  asteroid_nn_1_N = mkN "asteroid" "asteroider" ;
  astigmatism_nn_1_N = mkN "astigmatism" "astigmatismer" ;
  astrakan_nn_1_N = mkN "astrakan" "astrakaner" ;
  astrolog_nn_1_N = mkN "astrolog" "astrologer" ;
  astronaut_nn_1_N = mkN "astronaut" "astronauter" ;
  astronautik_nn_1_N = mkN "astronautik" "astronautiker" ;
  astronom_nn_1_N = mkN "astronom" "astronomer" ;
  asyl_nn_1_N = mkN "asyl" "asyler" ;
  asyndes_nn_1_N = mkN "asyndes" "asyndeser" ;
  atavism_nn_1_N = mkN "atavism" "atavismer" ;
  ateism_nn_1_N = mkN "ateism" "ateismer" ;
  ateist_nn_1_N = mkN "ateist" "ateister" ;
  atelj_e_nn_1_1_N = mkN "ateljé" "ateljéer" ;
  atelj_ebild_nn_1_1_N = mkN "ateljébild" "ateljébilder" ;
  ateroskleros_nn_1_N = mkN "ateroskleros" "ateroskleroser" ;
  atlas_nn_1_N = mkN "atlas" "atlaser" ;
  atmosfaerkemist_nn_1_1_N = mkN "atmosfärkemist" "atmosfärkemister" ;
  atom_nn_1_N = mkN "atom" "atomer" ;
  atombomb_nn_1_N = mkN "atombomb" "atombomber" ;
  atomenergiorganisation_nn_1_N = mkN "atomenergiorganisation" "atomenergiorganisationer" ;
  atomgrupp_nn_1_N = mkN "atomgrupp" "atomgrupper" ;
  atomism_nn_1_N = mkN "atomism" "atomismer" ;
  atomjon_nn_1_N = mkN "atomjon" "atomjoner" ;
  atomkraftsutbyggnad_nn_1_N = mkN "atomkraftsutbyggnad" "atomkraftsutbyggnader" ;
  atomreaktor_nn_1_N = mkN "atomreaktor" "atomreaktorer" ;
  atomvikt_nn_1_N = mkN "atomvikt" "atomvikter" ;
  att_sats_nn_1_N = mkN "att-sats" "att-satser" ;
  attach_e_nn_1_1_N = mkN "attaché" "attachéer" ;
  attentator_nn_1_N = mkN "attentator" "attentatorer" ;
  attest_nn_1_N = mkN "attest" "attester" ;
  attityd_nn_1_N = mkN "attityd" "attityder" ;
  attraktion_nn_1_N = mkN "attraktion" "attraktioner" ;
  attraktionskraft_nn_1_N = mkN "attraktionskraft" "attraktionskrafter" ;
  attribution_nn_1_N = mkN "attribution" "attributioner" ;
  au_pair_nn_1_N = mkN "au-pair" "au-pairer" ;
  audiens_nn_1_N = mkN "audiens" "audienser" ;
  auditoer_nn_1_1_N = mkN "auditör" "auditörer" ;
  augur_nn_1_N = mkN "augur" "augurer" ;
  auktion_nn_1_N = mkN "auktion" "auktioner" ;
  auktionist_nn_1_N = mkN "auktionist" "auktionister" ;
  auktor_nn_1_N = mkN "auktor" "auktorer" ;
  auktorisation_nn_1_N = mkN "auktorisation" "auktorisationer" ;
  auktoritet_nn_1_N = mkN "auktoritet" "auktoriteter" ;
  auskultant_nn_1_N = mkN "auskultant" "auskultanter" ;
  auskultation_nn_1_N = mkN "auskultation" "auskultationer" ;
  autencitet_nn_1_N = mkN "autencitet" "autenciteter" ;
  autenticitet_nn_1_N = mkN "autenticitet" "autenticiteter" ;
  autism_nn_1_N = mkN "autism" "autismer" ;
  autist_nn_1_N = mkN "autist" "autister" ;
  autodaf_e_nn_1_1_N = mkN "autodafé" "autodaféer" ;
  automat_nn_1_N = mkN "automat" "automater" ;
  automation_nn_1_N = mkN "automation" "automationer" ;
  automatkarbin_nn_1_N = mkN "automatkarbin" "automatkarbiner" ;
  automobil_nn_1_N = mkN "automobil" "automobiler" ;
  autopilot_nn_1_N = mkN "autopilot" "autopiloter" ;
  avannons_nn_1_N = mkN "avannons" "avannonser" ;
  avans_nn_1_N = mkN "avans" "avanser" ;
  avantgardism_nn_1_N = mkN "avantgardism" "avantgardismer" ;
  avantgardist_nn_1_N = mkN "avantgardist" "avantgardister" ;
  avatar_nn_1_N = mkN "avatar" "avatarer" ;
  avbetalningsplan_nn_1_N = mkN "avbetalningsplan" "avbetalningsplaner" ;
  avbild_nn_1_N = mkN "avbild" "avbilder" ;
  avboen_nn_1_1_N = mkN "avbön" "avböner" ;
  avdelningschef_nn_1_N = mkN "avdelningschef" "avdelningschefer" ;
  avdelningsdirektoer_nn_1_1_N = mkN "avdelningsdirektör" "avdelningsdirektörer" ;
  avdragsmoejlighet_nn_1_1_N = mkN "avdragsmöjlighet" "avdragsmöjligheter" ;
  aveny_nn_1_N = mkN "aveny" "avenyer" ;
  avers_nn_1_N = mkN "avers" "averser" ;
  aversion_nn_1_N = mkN "aversion" "aversioner" ;
  avfyrningsprocedur_nn_1_N = mkN "avfyrningsprocedur" "avfyrningsprocedurer" ;
  avfaerd_nn_1_1_N = mkN "avfärd" "avfärder" ;
  avgudabild_nn_1_N = mkN "avgudabild" "avgudabilder" ;
  avgaangsklass_nn_1_1_N = mkN "avgångsklass" "avgångsklasser" ;
  avis_nn_1_N = mkN "avis" "aviser" ;
  avitaminos_nn_1_N = mkN "avitaminos" "avitaminoser" ;
  avlastningsplats_nn_1_N = mkN "avlastningsplats" "avlastningsplatser" ;
  avlyssningsapparatur_nn_1_N = mkN "avlyssningsapparatur" "avlyssningsapparaturer" ;
  avmagnetiseringsprocess_nn_1_N = mkN "avmagnetiseringsprocess" "avmagnetiseringsprocesser" ;
  avmarsch_nn_1_N = mkN "avmarsch" "avmarscher" ;
  avocadosaas_nn_1_1_N = mkN "avocadosås" "avocadosåser" ;
  avokadosaas_nn_1_1_N = mkN "avokadosås" "avokadosåser" ;
  avraettningsplats_nn_1_1_N = mkN "avrättningsplats" "avrättningsplatser" ;
  avsaknad_nn_1_N = mkN "avsaknad" "avsaknader" ;
  avsats_nn_1_N = mkN "avsats" "avsatser" ;
  avskedsdikt_nn_1_N = mkN "avskedsdikt" "avskedsdikter" ;
  avskedsfest_nn_1_N = mkN "avskedsfest" "avskedsfester" ;
  avskedsturn_e_nn_1_1_N = mkN "avskedsturné" "avskedsturnéer" ;
  avskedsvisit_nn_1_N = mkN "avskedsvisit" "avskedsvisiter" ;
  avskildhet_nn_1_N = mkN "avskildhet" "avskildheter" ;
  avskrift_nn_1_N = mkN "avskrift" "avskrifter" ;
  avslutningsfest_nn_1_N = mkN "avslutningsfest" "avslutningsfester" ;
  avstjaelpningscentral_nn_1_1_N = mkN "avstjälpningscentral" "avstjälpningscentraler" ;
  avstjaelpningsplats_nn_1_1_N = mkN "avstjälpningsplats" "avstjälpningsplatser" ;
  avstaandsinformation_nn_1_1_N = mkN "avståndsinformation" "avståndsinformationer" ;
  avtalsfrihet_nn_1_N = mkN "avtalsfrihet" "avtalsfriheter" ;
  avvaenjningstid_nn_1_1_N = mkN "avvänjningstid" "avvänjningstider" ;
  axelinflammation_nn_1_N = mkN "axelinflammation" "axelinflammationer" ;
  axion_nn_1_N = mkN "axion" "axioner" ;
  azerbajdzjan_nn_1_N = mkN "azerbajdzjan" "azerbajdzjaner" ;
  babian_nn_1_N = mkN "babian" "babianer" ;
  babydraekt_nn_1_1_N = mkN "babydräkt" "babydräkter" ;
  babysketch_nn_1_N = mkN "babysketch" "babysketcher" ;
  bacill_nn_1_N = mkN "bacill" "baciller" ;
  backant_nn_1_N = mkN "backant" "backanter" ;
  badanstalt_nn_1_N = mkN "badanstalt" "badanstalter" ;
  baddraekt_nn_1_1_N = mkN "baddräkt" "baddräkter" ;
  badgaest_nn_1_1_N = mkN "badgäst" "badgäster" ;
  badkarskant_nn_1_N = mkN "badkarskant" "badkarskanter" ;
  badort_nn_1_N = mkN "badort" "badorter" ;
  badrumsfaerg_nn_1_1_N = mkN "badrumsfärg" "badrumsfärger" ;
  badturist_nn_1_N = mkN "badturist" "badturister" ;
  badvakt_nn_1_N = mkN "badvakt" "badvakter" ;
  bahaman_nn_1_N = mkN "bahaman" "bahamaner" ;
  bakgrundsfigur_nn_1_N = mkN "bakgrundsfigur" "bakgrundsfigurer" ;
  bakgrundston_nn_1_N = mkN "bakgrundston" "bakgrundstoner" ;
  bakkant_nn_1_N = mkN "bakkant" "bakkanter" ;
  bakljusramp_nn_1_N = mkN "bakljusramp" "bakljusramper" ;
  bakprojektion_nn_1_N = mkN "bakprojektion" "bakprojektioner" ;
  baksidestext_nn_1_N = mkN "baksidestext" "baksidestexter" ;
  baktericid_nn_1_N = mkN "baktericid" "baktericider" ;
  bakterieart_nn_1_N = mkN "bakterieart" "bakteriearter" ;
  bakterieinfektion_nn_1_N = mkN "bakterieinfektion" "bakterieinfektioner" ;
  bakteriekultur_nn_1_N = mkN "bakteriekultur" "bakteriekulturer" ;
  bakteriolog_nn_1_N = mkN "bakteriolog" "bakteriologer" ;
  bal_nn_2_N = mkN "bal" "baler" ;
  balans_nn_1_N = mkN "balans" "balanser" ;
  balanskonstnaer_nn_1_1_N = mkN "balanskonstnär" "balanskonstnärer" ;
  baldakin_nn_1_N = mkN "baldakin" "baldakiner" ;
  balettdans_nn_1_N = mkN "balettdans" "balettdanser" ;
  balettdansoes_nn_1_1_N = mkN "balettdansös" "balettdansöser" ;
  baljvaext_nn_1_1_N = mkN "baljväxt" "baljväxter" ;
  ballast_nn_1_N = mkN "ballast" "ballaster" ;
  ballograf_nn_1_N = mkN "ballograf" "ballografer" ;
  ballongfamilj_nn_1_N = mkN "ballongfamilj" "ballongfamiljer" ;
  ballongfaerd_nn_1_1_N = mkN "ballongfärd" "ballongfärder" ;
  ballonggas_nn_1_N = mkN "ballonggas" "ballonggaser" ;
  balneolog_nn_1_N = mkN "balneolog" "balneologer" ;
  balsamin_nn_1_N = mkN "balsamin" "balsaminer" ;
  balsamterpentin_nn_1_N = mkN "balsamterpentin" "balsamterpentiner" ;
  baluns_nn_1_N = mkN "baluns" "balunser" ;
  balustrad_nn_1_N = mkN "balustrad" "balustrader" ;
  banalitet_nn_1_N = mkN "banalitet" "banaliteter" ;
  banan_nn_1_N = mkN "banan" "bananer" ;
  banankontakt_nn_1_N = mkN "banankontakt" "banankontakter" ;
  bandgenerator_nn_1_N = mkN "bandgenerator" "bandgeneratorer" ;
  bandit_nn_1_N = mkN "bandit" "banditer" ;
  bandstation_nn_1_N = mkN "bandstation" "bandstationer" ;
  bandtraktor_nn_1_N = mkN "bandtraktor" "bandtraktorer" ;
  bank_nn_2_N = mkN "bank" "banker" ;
  bankdirektoer_nn_1_1_N = mkN "bankdirektör" "bankdirektörer" ;
  bankinspektion_nn_1_N = mkN "bankinspektion" "bankinspektioner" ;
  bankir_nn_1_N = mkN "bankir" "bankirer" ;
  bankkollaps_nn_1_N = mkN "bankkollaps" "bankkollapser" ;
  bankkund_nn_1_N = mkN "bankkund" "bankkunder" ;
  banksektor_nn_1_N = mkN "banksektor" "banksektorer" ;
  banvakt_nn_1_N = mkN "banvakt" "banvakter" ;
  baptism_nn_1_N = mkN "baptism" "baptismer" ;
  baptist_nn_1_N = mkN "baptist" "baptister" ;
  baptistpastor_nn_1_N = mkN "baptistpastor" "baptistpastorer" ;
  baptistpredikant_nn_1_N = mkN "baptistpredikant" "baptistpredikanter" ;
  barbarism_nn_1_N = mkN "barbarism" "barbarismer" ;
  bardisan_nn_1_N = mkN "bardisan" "bardisaner" ;
  bariton_nn_1_N = mkN "bariton" "baritoner" ;
  barkass_nn_1_N = mkN "barkass" "barkasser" ;
  barlast_nn_1_N = mkN "barlast" "barlaster" ;
  barmhaertighet_nn_1_1_N = mkN "barmhärtighet" "barmhärtigheter" ;
  barnadoedlighet_nn_1_1_N = mkN "barnadödlighet" "barnadödligheter" ;
  barnavaardsnaemnd_nn_1_1_N = mkN "barnavårdsnämnd" "barnavårdsnämnder" ;
  barndos_nn_1_N = mkN "barndos" "barndoser" ;
  barnfamilj_nn_1_N = mkN "barnfamilj" "barnfamiljer" ;
  barngrupp_nn_1_N = mkN "barngrupp" "barngrupper" ;
  barnkoer_nn_1_1_N = mkN "barnkör" "barnkörer" ;
  barnneurolog_nn_1_N = mkN "barnneurolog" "barnneurologer" ;
  barnomsorgsavgift_nn_1_N = mkN "barnomsorgsavgift" "barnomsorgsavgifter" ;
  barnomsorgskostnad_nn_1_N = mkN "barnomsorgskostnad" "barnomsorgskostnader" ;
  barnroest_nn_1_1_N = mkN "barnröst" "barnröster" ;
  barnsak_nn_1_N = mkN "barnsak" "barnsaker" ;
  barnslighet_nn_1_N = mkN "barnslighet" "barnsligheter" ;
  barnsoldat_nn_1_N = mkN "barnsoldat" "barnsoldater" ;
  barnvaelgoerenhetsorganisation_nn_1_1_N = mkN "barnvälgörenhetsorganisation" "barnvälgörenhetsorganisationer" ;
  barockkonst_nn_1_N = mkN "barockkonst" "barockkonster" ;
  baron_nn_1_N = mkN "baron" "baroner" ;
  barospirator_nn_1_N = mkN "barospirator" "barospiratorer" ;
  barrdoft_nn_1_N = mkN "barrdoft" "barrdofter" ;
  barrikadstrid_nn_1_N = mkN "barrikadstrid" "barrikadstrider" ;
  barrskogsgraens_nn_1_1_N = mkN "barrskogsgräns" "barrskogsgränser" ;
  barrskogsregion_nn_1_N = mkN "barrskogsregion" "barrskogsregioner" ;
  barrtraedssort_nn_1_1_N = mkN "barrträdssort" "barrträdssorter" ;
  baryton_nn_1_N = mkN "baryton" "barytoner" ;
  bas_nn_2_N = mkN "bas" "baser" ;
  basenhet_nn_1_N = mkN "basenhet" "basenheter" ;
  basfiolsfodralsmakaregesaell_nn_1_1_N = mkN "basfiolsfodralsmakaregesäll" "basfiolsfodralsmakaregesäller" ;
  basfaerdighet_nn_1_1_N = mkN "basfärdighet" "basfärdigheter" ;
  basilisk_nn_1_N = mkN "basilisk" "basilisker" ;
  basist_nn_1_N = mkN "basist" "basister" ;
  bask_nn_1_N = mkN "bask" "basker" ;
  basorganisation_nn_1_N = mkN "basorganisation" "basorganisationer" ;
  basroest_nn_1_1_N = mkN "basröst" "basröster" ;
  basstation_nn_1_N = mkN "basstation" "basstationer" ;
  bassaeng_nn_1_1_N = mkN "bassäng" "bassänger" ;
  bastardform_nn_1_N = mkN "bastardform" "bastardformer" ;
  bastcell_nn_1_N = mkN "bastcell" "bastceller" ;
  bastion_nn_1_N = mkN "bastion" "bastioner" ;
  baston_nn_1_N = mkN "baston" "bastoner" ;
  bataljonsadjutant_nn_1_N = mkN "bataljonsadjutant" "bataljonsadjutanter" ;
  bataljonschef_nn_1_N = mkN "bataljonschef" "bataljonschefer" ;
  batist_nn_1_N = mkN "batist" "batister" ;
  batterist_nn_1_N = mkN "batterist" "batterister" ;
  bearnaisesaas_nn_1_1_N = mkN "bearnaisesås" "bearnaisesåser" ;
  bearnaes_nn_1_1_N = mkN "bearnäs" "bearnäser" ;
  bearnaessaas_nn_1_1_N = mkN "bearnässås" "bearnässåser" ;
  beckasin_nn_1_N = mkN "beckasin" "beckasiner" ;
  bedraeglighet_nn_1_1_N = mkN "bedräglighet" "bedrägligheter" ;
  bedroevlighet_nn_1_1_N = mkN "bedrövlighet" "bedrövligheter" ;
  beduin_nn_1_N = mkN "beduin" "beduiner" ;
  befintlighet_nn_1_N = mkN "befintlighet" "befintligheter" ;
  befogenhet_nn_1_N = mkN "befogenhet" "befogenheter" ;
  befolkningsexplosion_nn_1_N = mkN "befolkningsexplosion" "befolkningsexplosioner" ;
  befolkningsgrupp_nn_1_N = mkN "befolkningsgrupp" "befolkningsgrupper" ;
  befolkningspyramid_nn_1_N = mkN "befolkningspyramid" "befolkningspyramider" ;
  befrielsearm_e_nn_1_1_N = mkN "befrielsearmé" "befrielsearméer" ;
  befaelsgrad_nn_1_1_N = mkN "befälsgrad" "befälsgrader" ;
  befaengdhet_nn_1_1_N = mkN "befängdhet" "befängdheter" ;
  begivenhet_nn_1_N = mkN "begivenhet" "begivenheter" ;
  begravningsbyraa_nn_1_1_N = mkN "begravningsbyrå" "begravningsbyråer" ;
  begravningsgaest_nn_1_1_N = mkN "begravningsgäst" "begravningsgäster" ;
  begravningsmarsch_nn_1_N = mkN "begravningsmarsch" "begravningsmarscher" ;
  begravningsplats_nn_1_N = mkN "begravningsplats" "begravningsplatser" ;
  begravningsprocession_nn_1_N = mkN "begravningsprocession" "begravningsprocessioner" ;
  begravningspsalm_nn_1_N = mkN "begravningspsalm" "begravningspsalmer" ;
  begreppsanalys_nn_1_N = mkN "begreppsanalys" "begreppsanalyser" ;
  begreppsapparat_nn_1_N = mkN "begreppsapparat" "begreppsapparater" ;
  begreppsexercis_nn_1_N = mkN "begreppsexercis" "begreppsexerciser" ;
  begreppsnivaa_nn_1_1_N = mkN "begreppsnivå" "begreppsnivåer" ;
  begriplighet_nn_1_N = mkN "begriplighet" "begripligheter" ;
  begynnelsehastighet_nn_1_N = mkN "begynnelsehastighet" "begynnelsehastigheter" ;
  begynnelseloen_nn_1_1_N = mkN "begynnelselön" "begynnelselöner" ;
  begaerlighet_nn_1_1_N = mkN "begärlighet" "begärligheter" ;
  behagfullhet_nn_1_N = mkN "behagfullhet" "behagfullheter" ;
  behaglighet_nn_1_N = mkN "behaglighet" "behagligheter" ;
  behandlingsenhet_nn_1_N = mkN "behandlingsenhet" "behandlingsenheter" ;
  behaviorism_nn_1_N = mkN "behaviorism" "behaviorismer" ;
  behaviorist_nn_1_N = mkN "behaviorist" "behaviorister" ;
  behjaertenhet_nn_1_1_N = mkN "behjärtenhet" "behjärtenheter" ;
  behovloeshet_nn_1_1_N = mkN "behovlöshet" "behovlösheter" ;
  behovsprincip_nn_1_N = mkN "behovsprincip" "behovsprinciper" ;
  behoerighet_nn_1_1_N = mkN "behörighet" "behörigheter" ;
  beklaednad_nn_1_1_N = mkN "beklädnad" "beklädnader" ;
  bekostnad_nn_1_N = mkN "bekostnad" "bekostnader" ;
  bekvaemlighet_nn_1_1_N = mkN "bekvämlighet" "bekvämligheter" ;
  bekaennelsefrihet_nn_1_1_N = mkN "bekännelsefrihet" "bekännelsefriheter" ;
  bekaennelseroman_nn_1_1_N = mkN "bekännelseroman" "bekännelseromaner" ;
  bekaennelseskrift_nn_1_1_N = mkN "bekännelseskrift" "bekännelseskrifter" ;
  belastningsuppgift_nn_1_N = mkN "belastningsuppgift" "belastningsuppgifter" ;
  belemnit_nn_1_N = mkN "belemnit" "belemniter" ;
  belevenhet_nn_1_N = mkN "belevenhet" "belevenheter" ;
  belletrist_nn_1_N = mkN "belletrist" "belletrister" ;
  belysningsarmatur_nn_1_N = mkN "belysningsarmatur" "belysningsarmaturer" ;
  belaegenhet_nn_1_1_N = mkN "belägenhet" "belägenheter" ;
  belaeggningsgrad_nn_1_1_N = mkN "beläggningsgrad" "beläggningsgrader" ;
  belaesenhet_nn_1_1_N = mkN "beläsenhet" "beläsenheter" ;
  belaesthet_nn_1_1_N = mkN "belästhet" "belästheter" ;
  belaaningsgrad_nn_1_1_N = mkN "belåningsgrad" "belåningsgrader" ;
  belaatenhet_nn_1_1_N = mkN "belåtenhet" "belåtenheter" ;
  benediktin_nn_1_N = mkN "benediktin" "benediktiner" ;
  benhinneinflammation_nn_1_N = mkN "benhinneinflammation" "benhinneinflammationer" ;
  benkirurg_nn_1_N = mkN "benkirurg" "benkirurger" ;
  benprotes_nn_1_N = mkN "benprotes" "benproteser" ;
  benrest_nn_1_N = mkN "benrest" "benrester" ;
  bensinmotor_nn_1_N = mkN "bensinmotor" "bensinmotorer" ;
  bensinskatt_nn_1_N = mkN "bensinskatt" "bensinskatter" ;
  bensinstation_nn_1_N = mkN "bensinstation" "bensinstationer" ;
  bensintillsats_nn_1_N = mkN "bensintillsats" "bensintillsatser" ;
  benskoerhet_nn_1_1_N = mkN "benskörhet" "benskörheter" ;
  bensubstans_nn_1_N = mkN "bensubstans" "bensubstanser" ;
  bensvulst_nn_1_N = mkN "bensvulst" "bensvulster" ;
  bentonit_nn_1_N = mkN "bentonit" "bentoniter" ;
  bentrakt_nn_1_N = mkN "bentrakt" "bentrakter" ;
  benvaevnad_nn_1_1_N = mkN "benvävnad" "benvävnader" ;
  benaegenhet_nn_1_1_N = mkN "benägenhet" "benägenheter" ;
  beredskapstjaenst_nn_1_1_N = mkN "beredskapstjänst" "beredskapstjänster" ;
  beredvillighet_nn_1_N = mkN "beredvillighet" "beredvilligheter" ;
  berggrund_nn_1_N = mkN "berggrund" "berggrunder" ;
  bergkristall_nn_1_N = mkN "bergkristall" "bergkristaller" ;
  bergsbestigningsexpedition_nn_1_N = mkN "bergsbestigningsexpedition" "bergsbestigningsexpeditioner" ;
  bergsbrant_nn_1_N = mkN "bergsbrant" "bergsbranter" ;
  bergsbygd_nn_1_N = mkN "bergsbygd" "bergsbygder" ;
  bergsformation_nn_1_N = mkN "bergsformation" "bergsformationer" ;
  bergsglaciaer_nn_1_1_N = mkN "bergsglaciär" "bergsglaciärer" ;
  bergsplataa_nn_1_1_N = mkN "bergsplatå" "bergsplatåer" ;
  berlock_nn_1_N = mkN "berlock" "berlocker" ;
  bernaes_nn_1_1_N = mkN "bernäs" "bernäser" ;
  bernaessaas_nn_1_1_N = mkN "bernässås" "bernässåser" ;
  bersaa_nn_1_1_N = mkN "berså" "bersåer" ;
  berusningsgrad_nn_1_N = mkN "berusningsgrad" "berusningsgrader" ;
  beraekningsgrund_nn_1_1_N = mkN "beräkningsgrund" "beräkningsgrunder" ;
  beraettarkonst_nn_1_1_N = mkN "berättarkonst" "berättarkonster" ;
  beraettarroest_nn_1_1_N = mkN "berättarröst" "berättarröster" ;
  beroemdhet_nn_1_1_N = mkN "berömdhet" "berömdheter" ;
  beroemlighet_nn_1_1_N = mkN "berömlighet" "berömligheter" ;
  beroeringsassociation_nn_1_1_N = mkN "beröringsassociation" "beröringsassociationer" ;
  beroeringselektricitet_nn_1_1_N = mkN "beröringselektricitet" "beröringselektriciteter" ;
  beroeringspunkt_nn_1_1_N = mkN "beröringspunkt" "beröringspunkter" ;
  besatthet_nn_1_N = mkN "besatthet" "besattheter" ;
  besinningsloeshet_nn_1_1_N = mkN "besinningslöshet" "besinningslösheter" ;
  besittningsraett_nn_1_1_N = mkN "besittningsrätt" "besittningsrätter" ;
  beskaffenhet_nn_1_N = mkN "beskaffenhet" "beskaffenheter" ;
  beskattningsnaemnd_nn_1_1_N = mkN "beskattningsnämnd" "beskattningsnämnder" ;
  beskattningsprincip_nn_1_N = mkN "beskattningsprincip" "beskattningsprinciper" ;
  beskhet_nn_1_N = mkN "beskhet" "beskheter" ;
  beskickningschef_nn_1_N = mkN "beskickningschef" "beskickningschefer" ;
  beskyddarverksamhet_nn_1_N = mkN "beskyddarverksamhet" "beskyddarverksamheter" ;
  beskaeftighet_nn_1_1_N = mkN "beskäftighet" "beskäftigheter" ;
  beslagssmed_nn_1_N = mkN "beslagssmed" "beslagssmeder" ;
  beslutnivaa_nn_1_1_N = mkN "beslutnivå" "beslutnivåer" ;
  beslutsamhet_nn_1_N = mkN "beslutsamhet" "beslutsamheter" ;
  beslutsnivaa_nn_1_1_N = mkN "beslutsnivå" "beslutsnivåer" ;
  beslutsprocess_nn_1_N = mkN "beslutsprocess" "beslutsprocesser" ;
  besparingstorped_nn_1_N = mkN "besparingstorped" "besparingstorpeder" ;
  besserwisserattityd_nn_1_N = mkN "besserwisserattityd" "besserwisserattityder" ;
  bestaellningsavgift_nn_1_1_N = mkN "beställningsavgift" "beställningsavgifter" ;
  bestaemmelseort_nn_1_1_N = mkN "bestämmelseort" "bestämmelseorter" ;
  bestaendighet_nn_1_1_N = mkN "beständighet" "beständigheter" ;
  besvaerlighet_nn_1_1_N = mkN "besvärlighet" "besvärligheter" ;
  besvaersinstans_nn_1_1_N = mkN "besvärsinstans" "besvärsinstanser" ;
  besvaersmyndighet_nn_1_1_N = mkN "besvärsmyndighet" "besvärsmyndigheter" ;
  besvaersskrift_nn_1_1_N = mkN "besvärsskrift" "besvärsskrifter" ;
  besvaerstid_nn_1_1_N = mkN "besvärstid" "besvärstider" ;
  besynnerlighet_nn_1_N = mkN "besynnerlighet" "besynnerligheter" ;
  besoeksadress_nn_1_1_N = mkN "besöksadress" "besöksadresser" ;
  besoeksrestriktion_nn_1_1_N = mkN "besöksrestriktion" "besöksrestriktioner" ;
  besoekstid_nn_1_1_N = mkN "besökstid" "besökstider" ;
  betalkurs_nn_1_N = mkN "betalkurs" "betalkurser" ;
  betalningsbalans_nn_1_N = mkN "betalningsbalans" "betalningsbalanser" ;
  betalningsfrist_nn_1_N = mkN "betalningsfrist" "betalningsfrister" ;
  betalningstermin_nn_1_N = mkN "betalningstermin" "betalningsterminer" ;
  betatron_nn_1_N = mkN "betatron" "betatroner" ;
  beteendevetenskap_nn_1_N = mkN "beteendevetenskap" "beteendevetenskaper" ;
  betesmark_nn_1_N = mkN "betesmark" "betesmarker" ;
  betesplats_nn_1_N = mkN "betesplats" "betesplatser" ;
  betkampanj_nn_1_N = mkN "betkampanj" "betkampanjer" ;
  betong_nn_1_N = mkN "betong" "betonger" ;
  betongfaerg_nn_1_1_N = mkN "betongfärg" "betongfärger" ;
  betongmaskin_nn_1_N = mkN "betongmaskin" "betongmaskiner" ;
  betongvibrator_nn_1_N = mkN "betongvibrator" "betongvibratorer" ;
  bets_nn_1_N = mkN "bets" "betser" ;
  betydelsenyans_nn_1_N = mkN "betydelsenyans" "betydelsenyanser" ;
  betydenhet_nn_1_N = mkN "betydenhet" "betydenheter" ;
  betygsavskrift_nn_1_N = mkN "betygsavskrift" "betygsavskrifter" ;
  betygsgrad_nn_1_N = mkN "betygsgrad" "betygsgrader" ;
  betygsnaemnd_nn_1_1_N = mkN "betygsnämnd" "betygsnämnder" ;
  betaenketid_nn_1_1_N = mkN "betänketid" "betänketider" ;
  betaenklighet_nn_1_1_N = mkN "betänklighet" "betänkligheter" ;
  bevattningskanal_nn_1_N = mkN "bevattningskanal" "bevattningskanaler" ;
  bevissvaarighet_nn_1_1_N = mkN "bevissvårighet" "bevissvårigheter" ;
  bevaagenhet_nn_1_1_N = mkN "bevågenhet" "bevågenheter" ;
  bhutanes_nn_1_N = mkN "bhutanes" "bhutaneser" ;
  bias_nn_1_N = mkN "bias" "biaser" ;
  bibelhandskrift_nn_1_N = mkN "bibelhandskrift" "bibelhandskrifter" ;
  bibelkommission_nn_1_N = mkN "bibelkommission" "bibelkommissioner" ;
  bibelkonkordans_nn_1_N = mkN "bibelkonkordans" "bibelkonkordanser" ;
  biblicism_nn_1_N = mkN "biblicism" "biblicismer" ;
  biblioman_nn_1_N = mkN "biblioman" "bibliomaner" ;
  biblioteksavgift_nn_1_N = mkN "biblioteksavgift" "biblioteksavgifter" ;
  bidragsmiljon_nn_1_N = mkN "bidragsmiljon" "bidragsmiljoner" ;
  bidragsskyldighet_nn_1_N = mkN "bidragsskyldighet" "bidragsskyldigheter" ;
  bid_e_nn_1_1_N = mkN "bidé" "bidéer" ;
  biffrad_nn_1_N = mkN "biffrad" "biffrader" ;
  bifigur_nn_1_N = mkN "bifigur" "bifigurer" ;
  biform_nn_1_N = mkN "biform" "biformer" ;
  bifurkation_nn_1_N = mkN "bifurkation" "bifurkationer" ;
  bigamist_nn_1_N = mkN "bigamist" "bigamister" ;
  bigarraa_nn_1_1_N = mkN "bigarrå" "bigarråer" ;
  bihaaleinflammation_nn_1_1_N = mkN "bihåleinflammation" "bihåleinflammationer" ;
  biinkomst_nn_1_N = mkN "biinkomst" "biinkomster" ;
  bilaccis_nn_1_N = mkN "bilaccis" "bilacciser" ;
  bilaffaer_nn_1_1_N = mkN "bilaffär" "bilaffärer" ;
  bilantenn_nn_1_N = mkN "bilantenn" "bilantenner" ;
  bilbok_e_nn_1_1_N = mkN "bilboké" "bilbokéer" ;
  bild_nn_1_N = mkN "bild" "bilder" ;
  bildkonst_nn_1_N = mkN "bildkonst" "bildkonster" ;
  bildmonitor_nn_1_N = mkN "bildmonitor" "bildmonitorer" ;
  bildningsanstalt_nn_1_N = mkN "bildningsanstalt" "bildningsanstalter" ;
  bildningsgrad_nn_1_N = mkN "bildningsgrad" "bildningsgrader" ;
  bildningsnivaa_nn_1_1_N = mkN "bildningsnivå" "bildningsnivåer" ;
  bildningsorganisation_nn_1_N = mkN "bildningsorganisation" "bildningsorganisationer" ;
  bildningsroman_nn_1_N = mkN "bildningsroman" "bildningsromaner" ;
  bildningsverksamhet_nn_1_N = mkN "bildningsverksamhet" "bildningsverksamheter" ;
  bildredaktoer_nn_1_1_N = mkN "bildredaktör" "bildredaktörer" ;
  bildsignal_nn_1_N = mkN "bildsignal" "bildsignaler" ;
  bildskrift_nn_1_N = mkN "bildskrift" "bildskrifter" ;
  bildstod_nn_1_N = mkN "bildstod" "bildstoder" ;
  bildstrid_nn_1_N = mkN "bildstrid" "bildstrider" ;
  bildsvit_nn_1_N = mkN "bildsvit" "bildsviter" ;
  bildtelefon_nn_1_N = mkN "bildtelefon" "bildtelefoner" ;
  bildtext_nn_1_N = mkN "bildtext" "bildtexter" ;
  bildvaevnad_nn_1_1_N = mkN "bildvävnad" "bildvävnader" ;
  bilfabrik_nn_1_N = mkN "bilfabrik" "bilfabriker" ;
  bilfabrikoer_nn_1_1_N = mkN "bilfabrikör" "bilfabrikörer" ;
  bilfaerd_nn_1_1_N = mkN "bilfärd" "bilfärder" ;
  bilingualism_nn_1_N = mkN "bilingualism" "bilingualismer" ;
  bilism_nn_1_N = mkN "bilism" "bilismer" ;
  bilist_nn_1_N = mkN "bilist" "bilister" ;
  biljard_nn_1_N = mkN "biljard" "biljarder" ;
  biljardsalong_nn_1_N = mkN "biljardsalong" "biljardsalonger" ;
  biljett_nn_1_N = mkN "biljett" "biljetter" ;
  biljettexpedition_nn_1_N = mkN "biljettexpedition" "biljettexpeditioner" ;
  biljettinkomst_nn_1_N = mkN "biljettinkomst" "biljettinkomster" ;
  biljettkontroll_nn_1_N = mkN "biljettkontroll" "biljettkontroller" ;
  biljon_nn_1_N = mkN "biljon" "biljoner" ;
  bilkaross_nn_1_N = mkN "bilkaross" "bilkarosser" ;
  bilkonstruktoer_nn_1_1_N = mkN "bilkonstruktör" "bilkonstruktörer" ;
  bilkrasch_nn_1_N = mkN "bilkrasch" "bilkrascher" ;
  bilkup_e_nn_1_1_N = mkN "bilkupé" "bilkupéer" ;
  bilkaar_nn_1_1_N = mkN "bilkår" "bilkårer" ;
  bilkaarist_nn_1_1_N = mkN "bilkårist" "bilkårister" ;
  billast_nn_1_N = mkN "billast" "billaster" ;
  billiard_nn_1_N = mkN "billiard" "billiarder" ;
  billighet_nn_1_N = mkN "billighet" "billigheter" ;
  billion_nn_1_N = mkN "billion" "billioner" ;
  bilmotor_nn_1_N = mkN "bilmotor" "bilmotorer" ;
  bilnavigator_nn_1_N = mkN "bilnavigator" "bilnavigatorer" ;
  bilradioapparat_nn_1_N = mkN "bilradioapparat" "bilradioapparater" ;
  bilskatt_nn_1_N = mkN "bilskatt" "bilskatter" ;
  bilstoeld_nn_1_1_N = mkN "bilstöld" "bilstölder" ;
  biltelefon_nn_1_N = mkN "biltelefon" "biltelefoner" ;
  biltur_nn_1_N = mkN "biltur" "bilturer" ;
  bimetallism_nn_1_N = mkN "bimetallism" "bimetallismer" ;
  bindehinneinflammation_nn_1_N = mkN "bindehinneinflammation" "bindehinneinflammationer" ;
  bindesubstans_nn_1_N = mkN "bindesubstans" "bindesubstanser" ;
  bindningstid_nn_1_N = mkN "bindningstid" "bindningstider" ;
  biobank_nn_1_N = mkN "biobank" "biobanker" ;
  biocid_nn_1_N = mkN "biocid" "biocider" ;
  biogas_nn_1_N = mkN "biogas" "biogaser" ;
  biografbyraa_nn_1_1_N = mkN "biografbyrå" "biografbyråer" ;
  biokemist_nn_1_N = mkN "biokemist" "biokemister" ;
  biolog_nn_1_N = mkN "biolog" "biologer" ;
  biomstaendighet_nn_1_1_N = mkN "biomständighet" "biomständigheter" ;
  biopremiaer_nn_1_1_N = mkN "biopremiär" "biopremiärer" ;
  bioreaktor_nn_1_N = mkN "bioreaktor" "bioreaktorer" ;
  biosalong_nn_1_N = mkN "biosalong" "biosalonger" ;
  bipolaritet_nn_1_N = mkN "bipolaritet" "bipolariteter" ;
  biprodukt_nn_1_N = mkN "biprodukt" "biprodukter" ;
  biroll_nn_1_N = mkN "biroll" "biroller" ;
  bisak_nn_1_N = mkN "bisak" "bisaker" ;
  bisats_nn_1_N = mkN "bisats" "bisatser" ;
  bisektris_nn_1_N = mkN "bisektris" "bisektriser" ;
  bisexualitet_nn_1_N = mkN "bisexualitet" "bisexualiteter" ;
  biskopsvisitation_nn_1_N = mkN "biskopsvisitation" "biskopsvisitationer" ;
  bissauguinean_nn_1_N = mkN "bissauguinean" "bissauguineaner" ;
  biton_nn_1_N = mkN "biton" "bitoner" ;
  bitterhet_nn_1_N = mkN "bitterhet" "bitterheter" ;
  biverkningsrapport_nn_1_N = mkN "biverkningsrapport" "biverkningsrapporter" ;
  bjaebbighet_nn_1_1_N = mkN "bjäbbighet" "bjäbbigheter" ;
  bjoerkregion_nn_1_1_N = mkN "björkregion" "björkregioner" ;
  bjoernjakt_nn_1_1_N = mkN "björnjakt" "björnjakter" ;
  bjoerntjaenst_nn_1_1_N = mkN "björntjänst" "björntjänster" ;
  bladlaengd_nn_1_1_N = mkN "bladlängd" "bladlängder" ;
  blancmang_e_nn_1_1_N = mkN "blancmangé" "blancmangéer" ;
  blandform_nn_1_N = mkN "blandform" "blandformer" ;
  blandfaerg_nn_1_1_N = mkN "blandfärg" "blandfärger" ;
  blandkultur_nn_1_N = mkN "blandkultur" "blandkulturer" ;
  blandras_nn_1_N = mkN "blandras" "blandraser" ;
  blandtyp_nn_1_N = mkN "blandtyp" "blandtyper" ;
  blankningsaffaer_nn_1_1_N = mkN "blankningsaffär" "blankningsaffärer" ;
  blankoaccept_nn_1_N = mkN "blankoaccept" "blankoaccepter" ;
  blankofullmakt_nn_1_N = mkN "blankofullmakt" "blankofullmakter" ;
  blankokredit_nn_1_N = mkN "blankokredit" "blankokrediter" ;
  blankotransport_nn_1_N = mkN "blankotransport" "blankotransporter" ;
  blekhet_nn_1_N = mkN "blekhet" "blekheter" ;
  blessyr_nn_1_N = mkN "blessyr" "blessyrer" ;
  blidgrad_nn_1_N = mkN "blidgrad" "blidgrader" ;
  blindtarmsinflammation_nn_1_N = mkN "blindtarmsinflammation" "blindtarmsinflammationer" ;
  blindtarmsoperation_nn_1_N = mkN "blindtarmsoperation" "blindtarmsoperationer" ;
  blixtvisit_nn_1_N = mkN "blixtvisit" "blixtvisiter" ;
  blockad_nn_1_N = mkN "blockad" "blockader" ;
  blockalmanack_nn_1_N = mkN "blockalmanack" "blockalmanacker" ;
  blockgraens_nn_1_1_N = mkN "blockgräns" "blockgränser" ;
  blodapelsin_nn_1_N = mkN "blodapelsin" "blodapelsiner" ;
  blodcirkulation_nn_1_N = mkN "blodcirkulation" "blodcirkulationer" ;
  blodgrupp_nn_1_N = mkN "blodgrupp" "blodgrupper" ;
  blodighet_nn_1_N = mkN "blodighet" "blodigheter" ;
  blodsdiamant_nn_1_N = mkN "blodsdiamant" "blodsdiamanter" ;
  blodsvulst_nn_1_N = mkN "blodsvulst" "blodsvulster" ;
  blodtransfusion_nn_1_N = mkN "blodtransfusion" "blodtransfusioner" ;
  blodoeverfyllnad_nn_1_1_N = mkN "blodöverfyllnad" "blodöverfyllnader" ;
  bloggosfaer_nn_1_1_N = mkN "bloggosfär" "bloggosfärer" ;
  blomdoft_nn_1_N = mkN "blomdoft" "blomdofter" ;
  blomform_nn_1_N = mkN "blomform" "blomformer" ;
  blommighet_nn_1_N = mkN "blommighet" "blommigheter" ;
  blomningstid_nn_1_N = mkN "blomningstid" "blomningstider" ;
  blomsteraffaer_nn_1_1_N = mkN "blomsteraffär" "blomsteraffärer" ;
  blomsterdoft_nn_1_N = mkN "blomsterdoft" "blomsterdofter" ;
  blomstermaanad_nn_1_1_N = mkN "blomstermånad" "blomstermånader" ;
  blomsterrabatt_nn_1_N = mkN "blomsterrabatt" "blomsterrabatter" ;
  blomstertid_nn_1_N = mkN "blomstertid" "blomstertider" ;
  blomsteruppsats_nn_1_N = mkN "blomsteruppsats" "blomsteruppsatser" ;
  blomstervas_nn_1_N = mkN "blomstervas" "blomstervaser" ;
  blomstringsperiod_nn_1_N = mkN "blomstringsperiod" "blomstringsperioder" ;
  blomstringstid_nn_1_N = mkN "blomstringstid" "blomstringstider" ;
  blomvas_nn_1_N = mkN "blomvas" "blomvaser" ;
  blomvaext_nn_1_1_N = mkN "blomväxt" "blomväxter" ;
  blondin_nn_1_N = mkN "blondin" "blondiner" ;
  blyackumulator_nn_1_N = mkN "blyackumulator" "blyackumulatorer" ;
  blyazid_nn_1_N = mkN "blyazid" "blyazider" ;
  blyfaerg_nn_1_1_N = mkN "blyfärg" "blyfärger" ;
  blyghet_nn_1_N = mkN "blyghet" "blygheter" ;
  blygsamhet_nn_1_N = mkN "blygsamhet" "blygsamheter" ;
  blyhalt_nn_1_N = mkN "blyhalt" "blyhalter" ;
  blyoxid_nn_1_N = mkN "blyoxid" "blyoxider" ;
  blytyngd_nn_1_N = mkN "blytyngd" "blytyngder" ;
  blaendrisk_nn_1_1_N = mkN "bländrisk" "bländrisker" ;
  blaagroenalg_nn_1_1_N = mkN "blågrönalg" "blågrönalger" ;
  blaamusseron_nn_1_1_N = mkN "blåmusseron" "blåmusseroner" ;
  blaanad_nn_1_1_N = mkN "blånad" "blånader" ;
  blaaskatarr_nn_1_1_N = mkN "blåskatarr" "blåskatarrer" ;
  blaaspistol_nn_1_1_N = mkN "blåspistol" "blåspistoler" ;
  bloedighet_nn_1_1_N = mkN "blödighet" "blödigheter" ;
  bobin_nn_1_N = mkN "bobin" "bobiner" ;
  boendeform_nn_1_N = mkN "boendeform" "boendeformer" ;
  boendekostnad_nn_1_N = mkN "boendekostnad" "boendekostnader" ;
  boghoejd_nn_1_1_N = mkN "boghöjd" "boghöjder" ;
  bokauktion_nn_1_N = mkN "bokauktion" "bokauktioner" ;
  bokfoeringsskyldighet_nn_1_1_N = mkN "bokföringsskyldighet" "bokföringsskyldigheter" ;
  bokmarknad_nn_1_N = mkN "bokmarknad" "bokmarknader" ;
  bokrad_nn_1_N = mkN "bokrad" "bokrader" ;
  bokstavlighet_nn_1_N = mkN "bokstavlighet" "bokstavligheter" ;
  bokstavsinspiration_nn_1_N = mkN "bokstavsinspiration" "bokstavsinspirationer" ;
  bokversion_nn_1_N = mkN "bokversion" "bokversioner" ;
  bolid_nn_1_N = mkN "bolid" "bolider" ;
  bolin_nn_1_N = mkN "bolin" "boliner" ;
  bolivian_nn_1_N = mkN "bolivian" "bolivianer" ;
  bollplan_nn_1_N = mkN "bollplan" "bollplaner" ;
  bolsjevism_nn_1_N = mkN "bolsjevism" "bolsjevismer" ;
  bolaanekris_nn_1_1_N = mkN "bolånekris" "bolånekriser" ;
  bolaanekund_nn_1_1_N = mkN "bolånekund" "bolånekunder" ;
  bomb_nn_1_N = mkN "bomb" "bomber" ;
  bombattack_nn_1_N = mkN "bombattack" "bombattacker" ;
  bombraid_nn_1_N = mkN "bombraid" "bombraider" ;
  bombraed_nn_1_1_N = mkN "bombräd" "bombräder" ;
  bombskyddssektion_nn_1_N = mkN "bombskyddssektion" "bombskyddssektioner" ;
  bomullsvaevnad_nn_1_1_N = mkN "bomullsvävnad" "bomullsvävnader" ;
  bomullsvaext_nn_1_1_N = mkN "bomullsväxt" "bomullsväxter" ;
  bonad_nn_1_N = mkN "bonad" "bonader" ;
  bondearm_e_nn_1_1_N = mkN "bondearmé" "bondearméer" ;
  bondegeneration_nn_1_N = mkN "bondegeneration" "bondegenerationer" ;
  bondekultur_nn_1_N = mkN "bondekultur" "bondekulturer" ;
  bondeprotest_nn_1_N = mkN "bondeprotest" "bondeprotester" ;
  bondeslaekt_nn_1_1_N = mkN "bondesläkt" "bondesläkter" ;
  bondfamilj_nn_1_N = mkN "bondfamilj" "bondfamiljer" ;
  bondpermission_nn_1_N = mkN "bondpermission" "bondpermissioner" ;
  bonitet_nn_1_N = mkN "bonitet" "boniteter" ;
  bonusklass_nn_1_N = mkN "bonusklass" "bonusklasser" ;
  boplats_nn_1_N = mkN "boplats" "boplatser" ;
  borddans_nn_1_N = mkN "borddans" "borddanser" ;
  bordeaux_nn_1_N = mkN "bordeaux" "bordeauxer" ;
  bordellverksamhet_nn_1_N = mkN "bordellverksamhet" "bordellverksamheter" ;
  bordsboen_nn_1_1_N = mkN "bordsbön" "bordsböner" ;
  bordsdam_nn_1_N = mkN "bordsdam" "bordsdamer" ;
  bordsdryck_nn_1_N = mkN "bordsdryck" "bordsdrycker" ;
  bordservis_nn_1_N = mkN "bordservis" "bordserviser" ;
  bordsgaest_nn_1_1_N = mkN "bordsgäst" "bordsgäster" ;
  bordskamrat_nn_1_N = mkN "bordskamrat" "bordskamrater" ;
  bordskant_nn_1_N = mkN "bordskant" "bordskanter" ;
  bordskavaljer_nn_1_N = mkN "bordskavaljer" "bordskavaljerer" ;
  bordsservis_nn_1_N = mkN "bordsservis" "bordsserviser" ;
  bordsuppsats_nn_1_N = mkN "bordsuppsats" "bordsuppsatser" ;
  borgarfamilj_nn_1_N = mkN "borgarfamilj" "borgarfamiljer" ;
  borgarklass_nn_1_N = mkN "borgarklass" "borgarklasser" ;
  borgarslaekt_nn_1_1_N = mkN "borgarsläkt" "borgarsläkter" ;
  borgenaer_nn_1_1_N = mkN "borgenär" "borgenärer" ;
  borgenaersed_nn_1_1_N = mkN "borgenärsed" "borgenärseder" ;
  borgerlighet_nn_1_N = mkN "borgerlighet" "borgerligheter" ;
  borgruin_nn_1_N = mkN "borgruin" "borgruiner" ;
  borkarbid_nn_1_N = mkN "borkarbid" "borkarbider" ;
  borrlaengd_nn_1_1_N = mkN "borrlängd" "borrlängder" ;
  bortamatch_nn_1_N = mkN "bortamatch" "bortamatcher" ;
  bortaplan_nn_1_N = mkN "bortaplan" "bortaplaner" ;
  boskapsmarknad_nn_1_N = mkN "boskapsmarknad" "boskapsmarknader" ;
  boskillnad_nn_1_N = mkN "boskillnad" "boskillnader" ;
  boson_nn_1_N = mkN "boson" "bosoner" ;
  bostadsadress_nn_1_N = mkN "bostadsadress" "bostadsadresser" ;
  bostadsexpert_nn_1_N = mkN "bostadsexpert" "bostadsexperter" ;
  bostadsinspektion_nn_1_N = mkN "bostadsinspektion" "bostadsinspektioner" ;
  bostadskooperation_nn_1_N = mkN "bostadskooperation" "bostadskooperationer" ;
  bostadskredit_nn_1_N = mkN "bostadskredit" "bostadskrediter" ;
  bostadslaegenhet_nn_1_1_N = mkN "bostadslägenhet" "bostadslägenheter" ;
  bostadsmarknad_nn_1_N = mkN "bostadsmarknad" "bostadsmarknader" ;
  bostadsnaemnd_nn_1_1_N = mkN "bostadsnämnd" "bostadsnämnder" ;
  bostadsproduktion_nn_1_N = mkN "bostadsproduktion" "bostadsproduktioner" ;
  bostadsraett_nn_1_1_N = mkN "bostadsrätt" "bostadsrätter" ;
  bostonvals_nn_1_N = mkN "bostonvals" "bostonvalser" ;
  bosaettningsaffaer_nn_1_1_N = mkN "bosättningsaffär" "bosättningsaffärer" ;
  bosaettningsort_nn_1_1_N = mkN "bosättningsort" "bosättningsorter" ;
  botanist_nn_1_N = mkN "botanist" "botanister" ;
  bottenformation_nn_1_N = mkN "bottenformation" "bottenformationer" ;
  bottenfaerg_nn_1_1_N = mkN "bottenfärg" "bottenfärger" ;
  bottenkurs_nn_1_N = mkN "bottenkurs" "bottenkurser" ;
  bottenloeshet_nn_1_1_N = mkN "bottenlöshet" "bottenlösheter" ;
  bottenmagnet_nn_1_N = mkN "bottenmagnet" "bottenmagneter" ;
  bottensats_nn_1_N = mkN "bottensats" "bottensatser" ;
  bottin_nn_1_N = mkN "bottin" "bottiner" ;
  botulism_nn_1_N = mkN "botulism" "botulismer" ;
  boudoir_nn_1_N = mkN "boudoir" "boudoirer" ;
  boxningsmatch_nn_1_N = mkN "boxningsmatch" "boxningsmatcher" ;
  brakfest_nn_1_N = mkN "brakfest" "brakfester" ;
  braksucc_e_nn_1_1_N = mkN "braksuccé" "braksuccéer" ;
  braman_nn_1_N = mkN "braman" "bramaner" ;
  bramanism_nn_1_N = mkN "bramanism" "bramanismer" ;
  bramin_nn_1_N = mkN "bramin" "braminer" ;
  brandbomb_nn_1_N = mkN "brandbomb" "brandbomber" ;
  brandchef_nn_1_N = mkN "brandchef" "brandchefer" ;
  brandingenjoer_nn_1_1_N = mkN "brandingenjör" "brandingenjörer" ;
  brandinspektion_nn_1_N = mkN "brandinspektion" "brandinspektioner" ;
  brandinspektoer_nn_1_1_N = mkN "brandinspektör" "brandinspektörer" ;
  brandkaar_nn_1_1_N = mkN "brandkår" "brandkårer" ;
  brandorsak_nn_1_N = mkN "brandorsak" "brandorsaker" ;
  brandpost_nn_1_N = mkN "brandpost" "brandposter" ;
  brandrest_nn_1_N = mkN "brandrest" "brandrester" ;
  brandskatt_nn_1_N = mkN "brandskatt" "brandskatter" ;
  brandstation_nn_1_N = mkN "brandstation" "brandstationer" ;
  brandvakt_nn_1_N = mkN "brandvakt" "brandvakter" ;
  bransch_nn_1_N = mkN "bransch" "branscher" ;
  brasilian_nn_1_N = mkN "brasilian" "brasilianer" ;
  bravurroll_nn_1_N = mkN "bravurroll" "bravurroller" ;
  breddgrad_nn_1_N = mkN "breddgrad" "breddgrader" ;
  breddidrott_nn_1_N = mkN "breddidrott" "breddidrotter" ;
  breton_nn_1_N = mkN "breton" "bretoner" ;
  brevbomb_nn_1_N = mkN "brevbomb" "brevbomber" ;
  brevhemlighet_nn_1_N = mkN "brevhemlighet" "brevhemligheter" ;
  brevroman_nn_1_N = mkN "brevroman" "brevromaner" ;
  bricklunch_nn_1_N = mkN "bricklunch" "brickluncher" ;
  bridreaktor_nn_1_N = mkN "bridreaktor" "bridreaktorer" ;
  brigadchef_nn_1_N = mkN "brigadchef" "brigadchefer" ;
  brigadoer_nn_1_1_N = mkN "brigadör" "brigadörer" ;
  brigantin_nn_1_N = mkN "brigantin" "brigantiner" ;
  briljant_nn_1_N = mkN "briljant" "briljanter" ;
  brisans_nn_1_N = mkN "brisans" "brisanser" ;
  brisant_nn_1_N = mkN "brisant" "brisanter" ;
  brist_nn_1_N = mkN "brist" "brister" ;
  bristfaellighet_nn_1_1_N = mkN "bristfällighet" "bristfälligheter" ;
  bristsituation_nn_1_N = mkN "bristsituation" "bristsituationer" ;
  broavgift_nn_1_N = mkN "broavgift" "broavgifter" ;
  brodyr_nn_1_N = mkN "brodyr" "brodyrer" ;
  brodoes_nn_1_1_N = mkN "brodös" "brodöser" ;
  brokighet_nn_1_N = mkN "brokighet" "brokigheter" ;
  bromid_nn_1_N = mkN "bromid" "bromider" ;
  bromism_nn_1_N = mkN "bromism" "bromismer" ;
  bromsmedicin_nn_1_N = mkN "bromsmedicin" "bromsmediciner" ;
  bromspedal_nn_1_N = mkN "bromspedal" "bromspedaler" ;
  bronkit_nn_1_N = mkN "bronkit" "bronkiter" ;
  brons_nn_1_N = mkN "brons" "bronser" ;
  bronsstaty_nn_1_N = mkN "bronsstaty" "bronsstatyer" ;
  bronsstatyett_nn_1_N = mkN "bronsstatyett" "bronsstatyetter" ;
  brosch_nn_1_N = mkN "brosch" "broscher" ;
  broschyr_nn_1_N = mkN "broschyr" "broschyrer" ;
  broskvaevnad_nn_1_1_N = mkN "broskvävnad" "broskvävnader" ;
  brottningskamp_nn_1_N = mkN "brottningskamp" "brottningskamper" ;
  brottningsmatch_nn_1_N = mkN "brottningsmatch" "brottningsmatcher" ;
  brottslighet_nn_1_N = mkN "brottslighet" "brottsligheter" ;
  brottsplats_nn_1_N = mkN "brottsplats" "brottsplatser" ;
  brottsplatsexpert_nn_1_N = mkN "brottsplatsexpert" "brottsplatsexperter" ;
  brottsprovokation_nn_1_N = mkN "brottsprovokation" "brottsprovokationer" ;
  bruklighet_nn_1_N = mkN "bruklighet" "brukligheter" ;
  brukningsenhet_nn_1_N = mkN "brukningsenhet" "brukningsenheter" ;
  bruksort_nn_1_N = mkN "bruksort" "bruksorter" ;
  brumkoer_nn_1_1_N = mkN "brumkör" "brumkörer" ;
  brunalg_nn_1_N = mkN "brunalg" "brunalger" ;
  brunch_nn_1_N = mkN "brunch" "bruncher" ;
  brunett_nn_1_N = mkN "brunett" "brunetter" ;
  brunnsort_nn_1_N = mkN "brunnsort" "brunnsorter" ;
  brunoert_nn_1_1_N = mkN "brunört" "brunörter" ;
  brutalitet_nn_1_N = mkN "brutalitet" "brutaliteter" ;
  bruttodraektighet_nn_1_1_N = mkN "bruttodräktighet" "bruttodräktigheter" ;
  bruttoinkomst_nn_1_N = mkN "bruttoinkomst" "bruttoinkomster" ;
  bruttoloen_nn_1_1_N = mkN "bruttolön" "bruttolöner" ;
  bruttovinst_nn_1_N = mkN "bruttovinst" "bruttovinster" ;
  bryggkant_nn_1_N = mkN "bryggkant" "bryggkanter" ;
  bryggplats_nn_1_N = mkN "bryggplats" "bryggplatser" ;
  brylaa_nn_1_1_N = mkN "brylå" "brylåer" ;
  bryolog_nn_1_N = mkN "bryolog" "bryologer" ;
  brytningsperiod_nn_1_N = mkN "brytningsperiod" "brytningsperioder" ;
  brytningstid_nn_1_N = mkN "brytningstid" "brytningstider" ;
  brytpunkt_nn_1_N = mkN "brytpunkt" "brytpunkter" ;
  braennvinsadvokat_nn_1_1_N = mkN "brännvinsadvokat" "brännvinsadvokater" ;
  braenslecellskonstruktion_nn_1_1_N = mkN "bränslecellskonstruktion" "bränslecellskonstruktioner" ;
  braenslecellstyp_nn_1_1_N = mkN "bränslecellstyp" "bränslecellstyper" ;
  braensledepaa_nn_1_1_N = mkN "bränsledepå" "bränsledepåer" ;
  braenslegas_nn_1_1_N = mkN "bränslegas" "bränslegaser" ;
  braenslekris_nn_1_1_N = mkN "bränslekris" "bränslekriser" ;
  braensletyp_nn_1_1_N = mkN "bränsletyp" "bränsletyper" ;
  braesch_nn_1_1_N = mkN "bräsch" "bräscher" ;
  braanad_nn_1_1_N = mkN "brånad" "brånader" ;
  broedkant_nn_1_1_N = mkN "brödkant" "brödkanter" ;
  broellopsdikt_nn_1_1_N = mkN "bröllopsdikt" "bröllopsdikter" ;
  broellopsfest_nn_1_1_N = mkN "bröllopsfest" "bröllopsfester" ;
  broellopsgaest_nn_1_1_N = mkN "bröllopsgäst" "bröllopsgäster" ;
  broellopsmarsch_nn_1_1_N = mkN "bröllopsmarsch" "bröllopsmarscher" ;
  broellopsplan_nn_1_1_N = mkN "bröllopsplan" "bröllopsplaner" ;
  broellopspoet_nn_1_1_N = mkN "bröllopspoet" "bröllopspoeter" ;
  broellopspresent_nn_1_1_N = mkN "bröllopspresent" "bröllopspresenter" ;
  broestbild_nn_1_1_N = mkN "bröstbild" "bröstbilder" ;
  broestcancerdiagnos_nn_1_1_N = mkN "bröstcancerdiagnos" "bröstcancerdiagnoser" ;
  broestkatarr_nn_1_1_N = mkN "bröstkatarr" "bröstkatarrer" ;
  broestkompression_nn_1_1_N = mkN "bröstkompression" "bröstkompressioner" ;
  broestoperation_nn_1_1_N = mkN "bröstoperation" "bröstoperationer" ;
  broestton_nn_1_1_N = mkN "bröstton" "brösttoner" ;
  bubon_nn_1_N = mkN "bubon" "buboner" ;
  budbyraa_nn_1_1_N = mkN "budbyrå" "budbyråer" ;
  buddhism_nn_1_N = mkN "buddhism" "buddhismer" ;
  buddhist_nn_1_N = mkN "buddhist" "buddhister" ;
  buddism_nn_1_N = mkN "buddism" "buddismer" ;
  buddist_nn_1_N = mkN "buddist" "buddister" ;
  budgetmotion_nn_1_N = mkN "budgetmotion" "budgetmotioner" ;
  budgetproposition_nn_1_N = mkN "budgetproposition" "budgetpropositioner" ;
  budgetvariant_nn_1_N = mkN "budgetvariant" "budgetvarianter" ;
  budoar_nn_1_N = mkN "budoar" "budoarer" ;
  buffertkapacitet_nn_1_N = mkN "buffertkapacitet" "buffertkapaciteter" ;
  buffertstat_nn_1_N = mkN "buffertstat" "buffertstater" ;
  bufflighet_nn_1_N = mkN "bufflighet" "buffligheter" ;
  buff_e_nn_1_1_N = mkN "buffé" "bufféer" ;
  bukhinneinflammation_nn_1_N = mkN "bukhinneinflammation" "bukhinneinflammationer" ;
  bukt_nn_1_N = mkN "bukt" "bukter" ;
  bulklast_nn_1_N = mkN "bulklast" "bulklaster" ;
  bulletin_nn_1_N = mkN "bulletin" "bulletiner" ;
  bulnad_nn_1_N = mkN "bulnad" "bulnader" ;
  bultpistol_nn_1_N = mkN "bultpistol" "bultpistoler" ;
  bulvan_nn_1_N = mkN "bulvan" "bulvaner" ;
  bulvanverksamhet_nn_1_N = mkN "bulvanverksamhet" "bulvanverksamheter" ;
  bunkringsplats_nn_1_N = mkN "bunkringsplats" "bunkringsplatser" ;
  bunkringsstation_nn_1_N = mkN "bunkringsstation" "bunkringsstationer" ;
  burgarrestaurang_nn_1_N = mkN "burgarrestaurang" "burgarrestauranger" ;
  burgerrestaurang_nn_1_N = mkN "burgerrestaurang" "burgerrestauranger" ;
  burgund_nn_1_N = mkN "burgund" "burgunder" ;
  burlesk_nn_1_N = mkN "burlesk" "burlesker" ;
  burman_nn_1_N = mkN "burman" "burmaner" ;
  burmes_nn_1_N = mkN "burmes" "burmeser" ;
  buskagitation_nn_1_N = mkN "buskagitation" "buskagitationer" ;
  bussankomst_nn_1_N = mkN "bussankomst" "bussankomster" ;
  busschauffoer_nn_1_1_N = mkN "busschaufför" "busschaufförer" ;
  busshaallplats_nn_1_1_N = mkN "busshållplats" "busshållplatser" ;
  busslast_nn_1_N = mkN "busslast" "busslaster" ;
  busstation_nn_1_N = mkN "busstation" "busstationer" ;
  bussterminal_nn_1_N = mkN "bussterminal" "bussterminaler" ;
  busstidtabell_nn_1_N = mkN "busstidtabell" "busstidtabeller" ;
  busstransport_nn_1_N = mkN "busstransport" "busstransporter" ;
  busstur_nn_1_N = mkN "busstur" "bussturer" ;
  byff_e_nn_1_1_N = mkN "byffé" "byfféer" ;
  bygd_nn_1_N = mkN "bygd" "bygder" ;
  byggarbetsplats_nn_1_N = mkN "byggarbetsplats" "byggarbetsplatser" ;
  byggdispens_nn_1_N = mkN "byggdispens" "byggdispenser" ;
  byggkostnad_nn_1_N = mkN "byggkostnad" "byggkostnader" ;
  bygglekplats_nn_1_N = mkN "bygglekplats" "bygglekplatser" ;
  byggnad_nn_1_N = mkN "byggnad" "byggnader" ;
  byggnadskonstruktion_nn_1_N = mkN "byggnadskonstruktion" "byggnadskonstruktioner" ;
  byggnadskredit_nn_1_N = mkN "byggnadskredit" "byggnadskrediter" ;
  byggnadsnaemnd_nn_1_1_N = mkN "byggnadsnämnd" "byggnadsnämnder" ;
  byggnadsplan_nn_1_N = mkN "byggnadsplan" "byggnadsplaner" ;
  byggnadsplats_nn_1_N = mkN "byggnadsplats" "byggnadsplatser" ;
  byggnation_nn_1_N = mkN "byggnation" "byggnationer" ;
  byggnorm_nn_1_N = mkN "byggnorm" "byggnormer" ;
  byggplan_nn_1_N = mkN "byggplan" "byggplaner" ;
  byggsats_nn_1_N = mkN "byggsats" "byggsatser" ;
  byggstart_nn_1_N = mkN "byggstart" "byggstarter" ;
  byggtid_nn_1_N = mkN "byggtid" "byggtider" ;
  bymosk_e_nn_1_1_N = mkN "bymoské" "bymoskéer" ;
  byraa_nn_2_1_N = mkN "byrå" "byråer" ;
  byraachef_nn_1_1_N = mkN "byråchef" "byråchefer" ;
  byraadirektoer_nn_1_1_N = mkN "byrådirektör" "byrådirektörer" ;
  byraakratism_nn_1_1_N = mkN "byråkratism" "byråkratismer" ;
  bysamfaellighet_nn_1_1_N = mkN "bysamfällighet" "bysamfälligheter" ;
  bysantin_nn_1_N = mkN "bysantin" "bysantiner" ;
  bysantinism_nn_1_N = mkN "bysantinism" "bysantinismer" ;
  byst_nn_1_N = mkN "byst" "byster" ;
  bytesaffaer_nn_1_1_N = mkN "bytesaffär" "bytesaffärer" ;
  byteslaegenhet_nn_1_1_N = mkN "byteslägenhet" "byteslägenheter" ;
  byxdraekt_nn_1_1_N = mkN "byxdräkt" "byxdräkter" ;
  baeckravin_nn_1_1_N = mkN "bäckravin" "bäckraviner" ;
  baenkplats_nn_1_1_N = mkN "bänkplats" "bänkplatser" ;
  baenkrad_nn_1_1_N = mkN "bänkrad" "bänkrader" ;
  baerfrekvens_nn_1_1_N = mkN "bärfrekvens" "bärfrekvenser" ;
  baergarloen_nn_1_1_N = mkN "bärgarlön" "bärgarlöner" ;
  baermark_nn_1_1_N = mkN "bärmark" "bärmarker" ;
  baernaes_nn_1_1_N = mkN "bärnäs" "bärnäser" ;
  baernaessaas_nn_1_1_N = mkN "bärnässås" "bärnässåser" ;
  baevernylonoverall_nn_1_1_N = mkN "bävernylonoverall" "bävernylonoveraller" ;
  baagform_nn_1_1_N = mkN "bågform" "bågformer" ;
  baagfris_nn_1_1_N = mkN "bågfris" "bågfriser" ;
  baagminut_nn_1_1_N = mkN "bågminut" "bågminuter" ;
  baalvaext_nn_1_1_N = mkN "bålväxt" "bålväxter" ;
  baatankomst_nn_1_1_N = mkN "båtankomst" "båtankomster" ;
  baatfaerd_nn_1_1_N = mkN "båtfärd" "båtfärder" ;
  baatlaegenhet_nn_1_1_N = mkN "båtlägenhet" "båtlägenheter" ;
  baatmotor_nn_1_1_N = mkN "båtmotor" "båtmotorer" ;
  baatnad_nn_1_1_N = mkN "båtnad" "båtnader" ;
  baatplats_nn_1_1_N = mkN "båtplats" "båtplatser" ;
  baatterminal_nn_1_1_N = mkN "båtterminal" "båtterminaler" ;
  baattidtabell_nn_1_1_N = mkN "båttidtabell" "båttidtabeller" ;
  baattransport_nn_1_1_N = mkN "båttransport" "båttransporter" ;
  baattur_nn_1_1_N = mkN "båttur" "båtturer" ;
  b_earnaisesaas_nn_1_1_N = mkN "béarnaisesås" "béarnaisesåser" ;
  boejhaallfasthet_nn_1_1_N = mkN "böjhållfasthet" "böjhållfastheter" ;
  boejningsform_nn_1_1_N = mkN "böjningsform" "böjningsformer" ;
  boen_nn_1_1_N = mkN "bön" "böner" ;
  boenegudstjaenst_nn_1_1_N = mkN "bönegudstjänst" "bönegudstjänster" ;
  boeneramp_nn_1_1_N = mkN "böneramp" "böneramper" ;
  boeneskrift_nn_1_1_N = mkN "böneskrift" "böneskrifter" ;
  boenestund_nn_1_1_N = mkN "bönestund" "bönestunder" ;
  boenvaext_nn_1_1_N = mkN "bönväxt" "bönväxter" ;
  boers_nn_2_1_N = mkN "börs" "börser" ;
  boersanalys_nn_1_1_N = mkN "börsanalys" "börsanalyser" ;
  boerskrasch_nn_1_1_N = mkN "börskrasch" "börskrascher" ;
  boerskurs_nn_1_1_N = mkN "börskurs" "börskurser" ;
  boersspekulant_nn_1_1_N = mkN "börsspekulant" "börsspekulanter" ;
  boersspekulation_nn_1_1_N = mkN "börsspekulation" "börsspekulationer" ;
  boerstelegraf_nn_1_1_N = mkN "börstelegraf" "börstelegrafer" ;
  calvados_nn_1_N = mkN "calvados" "calvadoser" ;
  campingplats_nn_1_N = mkN "campingplats" "campingplatser" ;
  cancerform_nn_1_N = mkN "cancerform" "cancerformer" ;
  cancerogen_nn_1_N = mkN "cancerogen" "cancerogener" ;
  cancerrisk_nn_1_N = mkN "cancerrisk" "cancerrisker" ;
  cancersvulst_nn_1_N = mkN "cancersvulst" "cancersvulster" ;
  carcinogen_nn_1_N = mkN "carcinogen" "carcinogener" ;
  celebritet_nn_1_N = mkN "celebritet" "celebriteter" ;
  cellist_nn_1_N = mkN "cellist" "cellister" ;
  cellstruktur_nn_1_N = mkN "cellstruktur" "cellstrukturer" ;
  celltyp_nn_1_N = mkN "celltyp" "celltyper" ;
  cellulosaetanol_nn_1_N = mkN "cellulosaetanol" "cellulosaetanoler" ;
  cellulosafabrik_nn_1_N = mkN "cellulosafabrik" "cellulosafabriker" ;
  cellulosamolekyl_nn_1_N = mkN "cellulosamolekyl" "cellulosamolekyler" ;
  cellulosaplast_nn_1_N = mkN "cellulosaplast" "cellulosaplaster" ;
  celsiusgrad_nn_1_N = mkN "celsiusgrad" "celsiusgrader" ;
  celt_nn_1_N = mkN "celt" "celter" ;
  cembalist_nn_1_N = mkN "cembalist" "cembalister" ;
  cementfaerg_nn_1_1_N = mkN "cementfärg" "cementfärger" ;
  censor_nn_1_N = mkN "censor" "censorer" ;
  centerism_nn_1_N = mkN "centerism" "centerismer" ;
  centerpartist_nn_1_N = mkN "centerpartist" "centerpartister" ;
  centerprofil_nn_1_N = mkN "centerprofil" "centerprofiler" ;
  central_nn_1_N = mkN "central" "centraler" ;
  centralafrikan_nn_1_N = mkN "centralafrikan" "centralafrikaner" ;
  centralanstalt_nn_1_N = mkN "centralanstalt" "centralanstalter" ;
  centralantenn_nn_1_N = mkN "centralantenn" "centralantenner" ;
  centralbankschef_nn_1_N = mkN "centralbankschef" "centralbankschefer" ;
  centralbyggnad_nn_1_N = mkN "centralbyggnad" "centralbyggnader" ;
  centralbyraa_nn_1_1_N = mkN "centralbyrå" "centralbyråer" ;
  centralenhet_nn_1_N = mkN "centralenhet" "centralenheter" ;
  centralfigur_nn_1_N = mkN "centralfigur" "centralfigurer" ;
  centralism_nn_1_N = mkN "centralism" "centralismer" ;
  centralkommitt_e_nn_1_1_N = mkN "centralkommitté" "centralkommittéer" ;
  centralmakt_nn_1_N = mkN "centralmakt" "centralmakter" ;
  centralnaemnd_nn_1_1_N = mkN "centralnämnd" "centralnämnder" ;
  centralorganisation_nn_1_N = mkN "centralorganisation" "centralorganisationer" ;
  centralort_nn_1_N = mkN "centralort" "centralorter" ;
  centralpunkt_nn_1_N = mkN "centralpunkt" "centralpunkter" ;
  centralstation_nn_1_N = mkN "centralstation" "centralstationer" ;
  cesarism_nn_1_N = mkN "cesarism" "cesarismer" ;
  cession_nn_1_N = mkN "cession" "cessioner" ;
  cesur_nn_1_N = mkN "cesur" "cesurer" ;
  champinjon_nn_1_N = mkN "champinjon" "champinjoner" ;
  chans_nn_1_N = mkN "chans" "chanser" ;
  chanson_nn_1_N = mkN "chanson" "chansoner" ;
  chansonett_nn_1_N = mkN "chansonett" "chansonetter" ;
  charabang_nn_1_N = mkN "charabang" "charabanger" ;
  charad_nn_1_N = mkN "charad" "charader" ;
  charg_e_d_affaires_nn_1_1_N = mkN "chargé-d'affaires" "chargé-d'affaireser" ;
  charkuterist_nn_1_N = mkN "charkuterist" "charkuterister" ;
  charlatan_nn_1_N = mkN "charlatan" "charlataner" ;
  charmkurs_nn_1_N = mkN "charmkurs" "charmkurser" ;
  charmloeshet_nn_1_1_N = mkN "charmlöshet" "charmlösheter" ;
  charmoffensiv_nn_1_N = mkN "charmoffensiv" "charmoffensiver" ;
  charmoer_nn_1_1_N = mkN "charmör" "charmörer" ;
  charterturist_nn_1_N = mkN "charterturist" "charterturister" ;
  chassidism_nn_1_N = mkN "chassidism" "chassidismer" ;
  chattkonversation_nn_1_N = mkN "chattkonversation" "chattkonversationer" ;
  chauffoer_nn_1_1_N = mkN "chaufför" "chaufförer" ;
  chauss_e_nn_1_1_N = mkN "chaussé" "chausséer" ;
  chauvinism_nn_1_N = mkN "chauvinism" "chauvinismer" ;
  chauvinist_nn_1_N = mkN "chauvinist" "chauvinister" ;
  checkkredit_nn_1_N = mkN "checkkredit" "checkkrediter" ;
  checkloen_nn_1_1_N = mkN "checklön" "checklöner" ;
  chefredaktoer_nn_1_1_N = mkN "chefredaktör" "chefredaktörer" ;
  chefsekonom_nn_1_N = mkN "chefsekonom" "chefsekonomer" ;
  chefsideolog_nn_1_N = mkN "chefsideolog" "chefsideologer" ;
  chefskirurg_nn_1_N = mkN "chefskirurg" "chefskirurger" ;
  chefsmikrobiolog_nn_1_N = mkN "chefsmikrobiolog" "chefsmikrobiologer" ;
  chemis_nn_1_N = mkN "chemis" "chemiser" ;
  chiffong_nn_1_N = mkN "chiffong" "chiffonger" ;
  chiffonj_e_nn_1_1_N = mkN "chiffonjé" "chiffonjéer" ;
  chikan_nn_1_N = mkN "chikan" "chikaner" ;
  chilen_nn_1_N = mkN "chilen" "chilener" ;
  chimpans_nn_1_N = mkN "chimpans" "chimpanser" ;
  chimaer_nn_1_1_N = mkN "chimär" "chimärer" ;
  chinjong_nn_1_N = mkN "chinjong" "chinjonger" ;
  chockbild_nn_1_N = mkN "chockbild" "chockbilder" ;
  chockfas_nn_1_N = mkN "chockfas" "chockfaser" ;
  choklad_nn_1_N = mkN "choklad" "choklader" ;
  ciceron_nn_1_N = mkN "ciceron" "ciceroner" ;
  cigarettaendarkontakt_nn_1_1_N = mkN "cigarettändarkontakt" "cigarettändarkontakter" ;
  cigarill_nn_1_N = mkN "cigarill" "cigariller" ;
  cigarrettaendarkontakt_nn_1_1_N = mkN "cigarrettändarkontakt" "cigarrettändarkontakter" ;
  cigarrill_nn_1_N = mkN "cigarrill" "cigarriller" ;
  cineast_nn_1_N = mkN "cineast" "cineaster" ;
  cirkeldefinition_nn_1_N = mkN "cirkeldefinition" "cirkeldefinitioner" ;
  cirkelprocess_nn_1_N = mkN "cirkelprocess" "cirkelprocesser" ;
  cirkelsektor_nn_1_N = mkN "cirkelsektor" "cirkelsektorer" ;
  cirkulation_nn_1_N = mkN "cirkulation" "cirkulationer" ;
  cirkulationsplats_nn_1_N = mkN "cirkulationsplats" "cirkulationsplatser" ;
  cirkumflex_nn_1_N = mkN "cirkumflex" "cirkumflexer" ;
  cirkusartist_nn_1_N = mkN "cirkusartist" "cirkusartister" ;
  cirkusbyggnad_nn_1_N = mkN "cirkusbyggnad" "cirkusbyggnader" ;
  cisterciens_nn_1_N = mkN "cisterciens" "cistercienser" ;
  citation_nn_1_N = mkN "citation" "citationer" ;
  citrin_nn_1_N = mkN "citrin" "citriner" ;
  citroen_nn_1_N = mkN "citroen" "citroener" ;
  citron_nn_1_N = mkN "citron" "citroner" ;
  citrondoft_nn_1_N = mkN "citrondoft" "citrondofter" ;
  civilekonom_nn_1_N = mkN "civilekonom" "civilekonomer" ;
  civilingenjoer_nn_1_1_N = mkN "civilingenjör" "civilingenjörer" ;
  civilisation_nn_1_N = mkN "civilisation" "civilisationer" ;
  civilist_nn_1_N = mkN "civilist" "civilister" ;
  civilprocess_nn_1_N = mkN "civilprocess" "civilprocesser" ;
  clairobscur_nn_1_N = mkN "clairobscur" "clairobscurer" ;
  clementin_nn_1_N = mkN "clementin" "clementiner" ;
  cloqu_e_nn_1_1_N = mkN "cloqué" "cloquéer" ;
  colombian_nn_1_N = mkN "colombian" "colombianer" ;
  consensuskultur_nn_1_N = mkN "consensuskultur" "consensuskulturer" ;
  consomm_e_nn_1_1_N = mkN "consommé" "consomméer" ;
  coronacell_nn_1_N = mkN "coronacell" "coronaceller" ;
  costarican_nn_1_N = mkN "costarican" "costaricaner" ;
  cotangent_nn_1_N = mkN "cotangent" "cotangenter" ;
  coverversion_nn_1_N = mkN "coverversion" "coverversioner" ;
  croissant_nn_1_N = mkN "croissant" "croissanter" ;
  croquis_nn_1_N = mkN "croquis" "croquiser" ;
  cuban_nn_1_N = mkN "cuban" "cubaner" ;
  cumuluscell_nn_1_N = mkN "cumuluscell" "cumulusceller" ;
  curator_nn_1_N = mkN "curator" "curatorer" ;
  curlingfinal_nn_1_N = mkN "curlingfinal" "curlingfinaler" ;
  cyanid_nn_1_N = mkN "cyanid" "cyanider" ;
  cyberbrottslighet_nn_1_N = mkN "cyberbrottslighet" "cyberbrottsligheter" ;
  cykelstoeld_nn_1_1_N = mkN "cykelstöld" "cykelstölder" ;
  cykelutflykt_nn_1_N = mkN "cykelutflykt" "cykelutflykter" ;
  cyklist_nn_1_N = mkN "cyklist" "cyklister" ;
  cykloid_nn_1_N = mkN "cykloid" "cykloider" ;
  cyklon_nn_1_N = mkN "cyklon" "cykloner" ;
  cyklonfamilj_nn_1_N = mkN "cyklonfamilj" "cyklonfamiljer" ;
  cyklotron_nn_1_N = mkN "cyklotron" "cyklotroner" ;
  cymbal_nn_1_N = mkN "cymbal" "cymbaler" ;
  cynism_nn_1_N = mkN "cynism" "cynismer" ;
  cypress_nn_1_N = mkN "cypress" "cypresser" ;
  dadaism_nn_1_N = mkN "dadaism" "dadaismer" ;
  dadaist_nn_1_N = mkN "dadaist" "dadaister" ;
  dagloen_nn_1_1_N = mkN "daglön" "daglöner" ;
  dagort_nn_1_N = mkN "dagort" "dagorter" ;
  dagsled_nn_1_N = mkN "dagsled" "dagsleder" ;
  dagsmarsch_nn_1_N = mkN "dagsmarsch" "dagsmarscher" ;
  dagsnyhet_nn_1_N = mkN "dagsnyhet" "dagsnyheter" ;
  dagstemperatur_nn_1_N = mkN "dagstemperatur" "dagstemperaturer" ;
  dagstidningsredaktoer_nn_1_1_N = mkN "dagstidningsredaktör" "dagstidningsredaktörer" ;
  dagsvers_nn_1_N = mkN "dagsvers" "dagsverser" ;
  daktyl_nn_1_N = mkN "daktyl" "daktyler" ;
  daldans_nn_1_N = mkN "daldans" "daldanser" ;
  dam_nn_1_N = mkN "dam" "damer" ;
  damask_nn_1_N = mkN "damask" "damasker" ;
  damast_nn_1_N = mkN "damast" "damaster" ;
  damfrisoer_nn_1_1_N = mkN "damfrisör" "damfrisörer" ;
  damkoer_nn_1_1_N = mkN "damkör" "damkörer" ;
  dampjaes_nn_1_1_N = mkN "dampjäs" "dampjäser" ;
  danism_nn_1_N = mkN "danism" "danismer" ;
  dans_nn_1_N = mkN "dans" "danser" ;
  dansbandskultur_nn_1_N = mkN "dansbandskultur" "dansbandskulturer" ;
  danskonst_nn_1_N = mkN "danskonst" "danskonster" ;
  danslektion_nn_1_N = mkN "danslektion" "danslektioner" ;
  dansrestaurang_nn_1_N = mkN "dansrestaurang" "dansrestauranger" ;
  dansrytm_nn_1_N = mkN "dansrytm" "dansrytmer" ;
  danssalong_nn_1_N = mkN "danssalong" "danssalonger" ;
  dansoes_nn_1_1_N = mkN "dansös" "dansöser" ;
  darwinism_nn_1_N = mkN "darwinism" "darwinismer" ;
  darwinist_nn_1_N = mkN "darwinist" "darwinister" ;
  dat_nn_1_N = mkN "dat" "dater" ;
  databas_nn_1_N = mkN "databas" "databaser" ;
  datainsamlingskampanj_nn_1_N = mkN "datainsamlingskampanj" "datainsamlingskampanjer" ;
  dataintraangsskandal_nn_1_1_N = mkN "dataintrångsskandal" "dataintrångsskandaler" ;
  datakommunikation_nn_1_N = mkN "datakommunikation" "datakommunikationer" ;
  datamaengd_nn_1_1_N = mkN "datamängd" "datamängder" ;
  dataterminal_nn_1_N = mkN "dataterminal" "dataterminaler" ;
  dativ_nn_1_N = mkN "dativ" "dativer" ;
  dator_nn_1_N = mkN "dator" "datorer" ;
  datoradress_nn_1_N = mkN "datoradress" "datoradresser" ;
  datortelefon_nn_1_N = mkN "datortelefon" "datortelefoner" ;
  datumgraens_nn_1_1_N = mkN "datumgräns" "datumgränser" ;
  debilitet_nn_1_N = mkN "debilitet" "debiliteter" ;
  debit_nn_1_N = mkN "debit" "debiter" ;
  debut_nn_1_N = mkN "debut" "debuter" ;
  debutant_nn_1_N = mkN "debutant" "debutanter" ;
  debutroman_nn_1_N = mkN "debutroman" "debutromaner" ;
  decentralisation_nn_1_N = mkN "decentralisation" "decentralisationer" ;
  dedikation_nn_1_N = mkN "dedikation" "dedikationer" ;
  deduktion_nn_1_N = mkN "deduktion" "deduktioner" ;
  defaitism_nn_1_N = mkN "defaitism" "defaitismer" ;
  defaitist_nn_1_N = mkN "defaitist" "defaitister" ;
  defekt_nn_1_N = mkN "defekt" "defekter" ;
  defil_e_nn_1_1_N = mkN "defilé" "defiléer" ;
  definition_nn_1_N = mkN "definition" "definitioner" ;
  deflagration_nn_1_N = mkN "deflagration" "deflagrationer" ;
  deflation_nn_1_N = mkN "deflation" "deflationer" ;
  defloration_nn_1_N = mkN "defloration" "deflorationer" ;
  deformation_nn_1_N = mkN "deformation" "deformationer" ;
  deformitet_nn_1_N = mkN "deformitet" "deformiteter" ;
  degeneration_nn_1_N = mkN "degeneration" "degenerationer" ;
  deglaciation_nn_1_N = mkN "deglaciation" "deglaciationer" ;
  degradation_nn_1_N = mkN "degradation" "degradationer" ;
  degression_nn_1_N = mkN "degression" "degressioner" ;
  deism_nn_1_N = mkN "deism" "deismer" ;
  deist_nn_1_N = mkN "deist" "deister" ;
  dekan_nn_1_N = mkN "dekan" "dekaner" ;
  deklamation_nn_1_N = mkN "deklamation" "deklamationer" ;
  deklarant_nn_1_N = mkN "deklarant" "deklaranter" ;
  deklaration_nn_1_N = mkN "deklaration" "deklarationer" ;
  deklination_nn_1_N = mkN "deklination" "deklinationer" ;
  dekoration_nn_1_N = mkN "dekoration" "dekorationer" ;
  dekorationslist_nn_1_N = mkN "dekorationslist" "dekorationslister" ;
  delaktighet_nn_1_N = mkN "delaktighet" "delaktigheter" ;
  delativ_nn_1_N = mkN "delativ" "delativer" ;
  delegation_nn_1_N = mkN "delegation" "delegationer" ;
  delfin_nn_1_N = mkN "delfin" "delfiner" ;
  delikatess_nn_1_N = mkN "delikatess" "delikatesser" ;
  delirant_nn_1_N = mkN "delirant" "deliranter" ;
  delkultur_nn_1_N = mkN "delkultur" "delkulturer" ;
  dellikvid_nn_1_N = mkN "dellikvid" "dellikvider" ;
  delmaengd_nn_1_1_N = mkN "delmängd" "delmängder" ;
  delstat_nn_1_N = mkN "delstat" "delstater" ;
  demarsch_nn_1_N = mkN "demarsch" "demarscher" ;
  demenspatient_nn_1_N = mkN "demenspatient" "demenspatienter" ;
  demensrisk_nn_1_N = mkN "demensrisk" "demensrisker" ;
  demission_nn_1_N = mkN "demission" "demissioner" ;
  demokratism_nn_1_N = mkN "demokratism" "demokratismer" ;
  demon_nn_1_N = mkN "demon" "demoner" ;
  demonstrant_nn_1_N = mkN "demonstrant" "demonstranter" ;
  demonstration_nn_1_N = mkN "demonstration" "demonstrationer" ;
  demonstrationsfrihet_nn_1_N = mkN "demonstrationsfrihet" "demonstrationsfriheter" ;
  demonstratris_nn_1_N = mkN "demonstratris" "demonstratriser" ;
  demoralisation_nn_1_N = mkN "demoralisation" "demoralisationer" ;
  denar_nn_1_N = mkN "denar" "denarer" ;
  denaturalisation_nn_1_N = mkN "denaturalisation" "denaturalisationer" ;
  dendrit_nn_1_N = mkN "dendrit" "dendriter" ;
  dendrolog_nn_1_N = mkN "dendrolog" "dendrologer" ;
  denotation_nn_1_N = mkN "denotation" "denotationer" ;
  densitet_nn_1_N = mkN "densitet" "densiteter" ;
  dentist_nn_1_N = mkN "dentist" "dentister" ;
  denudation_nn_1_N = mkN "denudation" "denudationer" ;
  deodorant_nn_1_N = mkN "deodorant" "deodoranter" ;
  departementschef_nn_1_N = mkN "departementschef" "departementschefer" ;
  depens_nn_1_N = mkN "depens" "depenser" ;
  depersonalisation_nn_1_N = mkN "depersonalisation" "depersonalisationer" ;
  depesch_nn_1_N = mkN "depesch" "depescher" ;
  depeschbyraa_nn_1_1_N = mkN "depeschbyrå" "depeschbyråer" ;
  depolarisator_nn_1_N = mkN "depolarisator" "depolarisatorer" ;
  deportation_nn_1_N = mkN "deportation" "deportationer" ;
  deportationsort_nn_1_N = mkN "deportationsort" "deportationsorter" ;
  deposition_nn_1_N = mkN "deposition" "depositioner" ;
  depravation_nn_1_N = mkN "depravation" "depravationer" ;
  depression_nn_1_N = mkN "depression" "depressioner" ;
  depressionsdiagnos_nn_1_N = mkN "depressionsdiagnos" "depressionsdiagnoser" ;
  deprivation_nn_1_N = mkN "deprivation" "deprivationer" ;
  deputation_nn_1_N = mkN "deputation" "deputationer" ;
  depaa_nn_1_1_N = mkN "depå" "depåer" ;
  derivation_nn_1_N = mkN "derivation" "derivationer" ;
  dermatit_nn_1_N = mkN "dermatit" "dermatiter" ;
  dermatolog_nn_1_N = mkN "dermatolog" "dermatologer" ;
  dervisch_nn_1_N = mkN "dervisch" "dervischer" ;
  dervischdans_nn_1_N = mkN "dervischdans" "dervischdanser" ;
  desegregation_nn_1_N = mkN "desegregation" "desegregationer" ;
  deshabill_e_nn_1_1_N = mkN "deshabillé" "deshabilléer" ;
  designstudent_nn_1_N = mkN "designstudent" "designstudenter" ;
  desillusion_nn_1_N = mkN "desillusion" "desillusioner" ;
  desinfektion_nn_1_N = mkN "desinfektion" "desinfektioner" ;
  desinformation_nn_1_N = mkN "desinformation" "desinformationer" ;
  desinsektion_nn_1_N = mkN "desinsektion" "desinsektioner" ;
  desintegration_nn_1_N = mkN "desintegration" "desintegrationer" ;
  deskription_nn_1_N = mkN "deskription" "deskriptioner" ;
  desorganisation_nn_1_N = mkN "desorganisation" "desorganisationer" ;
  desperation_nn_1_N = mkN "desperation" "desperationer" ;
  despotism_nn_1_N = mkN "despotism" "despotismer" ;
  dessertsaas_nn_1_1_N = mkN "dessertsås" "dessertsåser" ;
  destillation_nn_1_N = mkN "destillation" "destillationer" ;
  destination_nn_1_N = mkN "destination" "destinationer" ;
  destinationsort_nn_1_N = mkN "destinationsort" "destinationsorter" ;
  destruktion_nn_1_N = mkN "destruktion" "destruktioner" ;
  detaljist_nn_1_N = mkN "detaljist" "detaljister" ;
  detaljplan_nn_1_N = mkN "detaljplan" "detaljplaner" ;
  detektiv_nn_1_N = mkN "detektiv" "detektiver" ;
  detektivroman_nn_1_N = mkN "detektivroman" "detektivromaner" ;
  detektor_nn_1_N = mkN "detektor" "detektorer" ;
  determination_nn_1_N = mkN "determination" "determinationer" ;
  determinism_nn_1_N = mkN "determinism" "determinismer" ;
  determinist_nn_1_N = mkN "determinist" "determinister" ;
  detonation_nn_1_N = mkN "detonation" "detonationer" ;
  detonationshastighet_nn_1_N = mkN "detonationshastighet" "detonationshastigheter" ;
  detonationszon_nn_1_N = mkN "detonationszon" "detonationszoner" ;
  detonator_nn_1_N = mkN "detonator" "detonatorer" ;
  deuteron_nn_1_N = mkN "deuteron" "deuteroner" ;
  deutron_nn_1_N = mkN "deutron" "deutroner" ;
  deviation_nn_1_N = mkN "deviation" "deviationer" ;
  devis_nn_1_N = mkN "devis" "deviser" ;
  diabas_nn_1_N = mkN "diabas" "diabaser" ;
  diabild_nn_1_N = mkN "diabild" "diabilder" ;
  diagnos_nn_1_N = mkN "diagnos" "diagnoser" ;
  diakon_nn_1_N = mkN "diakon" "diakoner" ;
  diakonissanstalt_nn_1_N = mkN "diakonissanstalt" "diakonissanstalter" ;
  dialektolog_nn_1_N = mkN "dialektolog" "dialektologer" ;
  dialog_nn_1_N = mkN "dialog" "dialoger" ;
  dialys_nn_1_N = mkN "dialys" "dialyser" ;
  diamant_nn_1_N = mkN "diamant" "diamanter" ;
  diarr_e_nn_1_1_N = mkN "diarré" "diarréer" ;
  diastas_nn_1_N = mkN "diastas" "diastaser" ;
  dieselgenerator_nn_1_N = mkN "dieselgenerator" "dieselgeneratorer" ;
  dieselhybrid_nn_1_N = mkN "dieselhybrid" "dieselhybrider" ;
  dieselmotor_nn_1_N = mkN "dieselmotor" "dieselmotorer" ;
  dietist_nn_1_N = mkN "dietist" "dietister" ;
  differens_nn_1_N = mkN "differens" "differenser" ;
  differentialekvation_nn_1_N = mkN "differentialekvation" "differentialekvationer" ;
  differentialkalkyl_nn_1_N = mkN "differentialkalkyl" "differentialkalkyler" ;
  diffraktion_nn_1_N = mkN "diffraktion" "diffraktioner" ;
  diffusion_nn_1_N = mkN "diffusion" "diffusioner" ;
  digestion_nn_1_N = mkN "digestion" "digestioner" ;
  dignitet_nn_1_N = mkN "dignitet" "digniteter" ;
  dignitaer_nn_1_1_N = mkN "dignitär" "dignitärer" ;
  digression_nn_1_N = mkN "digression" "digressioner" ;
  diklin_nn_1_N = mkN "diklin" "dikliner" ;
  dikotyledon_nn_1_N = mkN "dikotyledon" "dikotyledoner" ;
  dikt_nn_1_N = mkN "dikt" "dikter" ;
  diktafon_nn_1_N = mkN "diktafon" "diktafoner" ;
  diktarfursteroll_nn_1_N = mkN "diktarfursteroll" "diktarfursteroller" ;
  diktargrupp_nn_1_N = mkN "diktargrupp" "diktargrupper" ;
  diktart_nn_1_N = mkN "diktart" "diktarter" ;
  diktator_nn_1_N = mkN "diktator" "diktatorer" ;
  diktatur_nn_1_N = mkN "diktatur" "diktaturer" ;
  diktaturregim_nn_1_N = mkN "diktaturregim" "diktaturregimer" ;
  diktion_nn_1_N = mkN "diktion" "diktioner" ;
  dikvaeveoxid_nn_1_1_N = mkN "dikväveoxid" "dikväveoxider" ;
  dilatation_nn_1_N = mkN "dilatation" "dilatationer" ;
  dilettant_nn_1_N = mkN "dilettant" "dilettanter" ;
  dilettantism_nn_1_N = mkN "dilettantism" "dilettantismer" ;
  diligens_nn_1_N = mkN "diligens" "diligenser" ;
  dillsaas_nn_1_1_N = mkN "dillsås" "dillsåser" ;
  dimension_nn_1_N = mkN "dimension" "dimensioner" ;
  dimission_nn_1_N = mkN "dimission" "dimissioner" ;
  dimorfism_nn_1_N = mkN "dimorfism" "dimorfismer" ;
  dimridaa_nn_1_1_N = mkN "dimridå" "dimridåer" ;
  dinosaur_nn_1_N = mkN "dinosaur" "dinosaurer" ;
  dinosaurieart_nn_1_N = mkN "dinosaurieart" "dinosauriearter" ;
  din_e_nn_1_1_N = mkN "diné" "dinéer" ;
  diod_nn_1_N = mkN "diod" "dioder" ;
  diorit_nn_1_N = mkN "diorit" "dioriter" ;
  dioskur_nn_1_N = mkN "dioskur" "dioskurer" ;
  diplomingenjoer_nn_1_1_N = mkN "diplomingenjör" "diplomingenjörer" ;
  dipol_nn_1_N = mkN "dipol" "dipoler" ;
  dipsoman_nn_1_N = mkN "dipsoman" "dipsomaner" ;
  diptyk_nn_1_N = mkN "diptyk" "diptyker" ;
  direkthet_nn_1_N = mkN "direkthet" "direktheter" ;
  direktion_nn_1_N = mkN "direktion" "direktioner" ;
  direktor_nn_1_N = mkN "direktor" "direktorer" ;
  direktris_nn_1_N = mkN "direktris" "direktriser" ;
  direktoer_nn_1_1_N = mkN "direktör" "direktörer" ;
  dirigism_nn_1_N = mkN "dirigism" "dirigismer" ;
  dis_nn_2_N = mkN "dis" "diser" ;
  disackarid_nn_1_N = mkN "disackarid" "disackarider" ;
  disciplin_nn_1_N = mkN "disciplin" "discipliner" ;
  disciplingraens_nn_1_1_N = mkN "disciplingräns" "disciplingränser" ;
  disciplinpaafoeljd_nn_1_1_N = mkN "disciplinpåföljd" "disciplinpåföljder" ;
  disjunktion_nn_1_N = mkN "disjunktion" "disjunktioner" ;
  diskant_nn_1_N = mkN "diskant" "diskanter" ;
  diskmaskin_nn_1_N = mkN "diskmaskin" "diskmaskiner" ;
  diskontinuitet_nn_1_N = mkN "diskontinuitet" "diskontinuiteter" ;
  diskordans_nn_1_N = mkN "diskordans" "diskordanser" ;
  diskrepans_nn_1_N = mkN "diskrepans" "diskrepanser" ;
  diskretion_nn_1_N = mkN "diskretion" "diskretioner" ;
  diskurs_nn_1_N = mkN "diskurs" "diskurser" ;
  diskussion_nn_1_N = mkN "diskussion" "diskussioner" ;
  diskvalifikation_nn_1_N = mkN "diskvalifikation" "diskvalifikationer" ;
  dislokation_nn_1_N = mkN "dislokation" "dislokationer" ;
  dispasch_nn_1_N = mkN "dispasch" "dispascher" ;
  dispaschoer_nn_1_1_N = mkN "dispaschör" "dispaschörer" ;
  dispens_nn_1_N = mkN "dispens" "dispenser" ;
  dispersion_nn_1_N = mkN "dispersion" "dispersioner" ;
  disponibilitet_nn_1_N = mkN "disponibilitet" "disponibiliteter" ;
  disposition_nn_1_N = mkN "disposition" "dispositioner" ;
  dispositionsfond_nn_1_N = mkN "dispositionsfond" "dispositionsfonder" ;
  disproportion_nn_1_N = mkN "disproportion" "disproportioner" ;
  disputation_nn_1_N = mkN "disputation" "disputationer" ;
  dissektion_nn_1_N = mkN "dissektion" "dissektioner" ;
  dissertation_nn_1_N = mkN "dissertation" "dissertationer" ;
  dissimilation_nn_1_N = mkN "dissimilation" "dissimilationer" ;
  dissociation_nn_1_N = mkN "dissociation" "dissociationer" ;
  dissonans_nn_1_N = mkN "dissonans" "dissonanser" ;
  dissonant_nn_1_N = mkN "dissonant" "dissonanter" ;
  distans_nn_1_N = mkN "distans" "distanser" ;
  distinktion_nn_1_N = mkN "distinktion" "distinktioner" ;
  distorsion_nn_1_N = mkN "distorsion" "distorsioner" ;
  distraktion_nn_1_N = mkN "distraktion" "distraktioner" ;
  distraktor_nn_1_N = mkN "distraktor" "distraktorer" ;
  distribution_nn_1_N = mkN "distribution" "distributioner" ;
  disoes_nn_1_1_N = mkN "disös" "disöser" ;
  divan_nn_1_N = mkN "divan" "divaner" ;
  divergens_nn_1_N = mkN "divergens" "divergenser" ;
  diversion_nn_1_N = mkN "diversion" "diversioner" ;
  divis_nn_1_N = mkN "divis" "diviser" ;
  division_nn_1_N = mkN "division" "divisioner" ;
  divisionschef_nn_1_N = mkN "divisionschef" "divisionschefer" ;
  divisor_nn_1_N = mkN "divisor" "divisorer" ;
  djupbild_nn_1_N = mkN "djupbild" "djupbilder" ;
  djupdimension_nn_1_N = mkN "djupdimension" "djupdimensioner" ;
  djupsinnighet_nn_1_N = mkN "djupsinnighet" "djupsinnigheter" ;
  djupstruktur_nn_1_N = mkN "djupstruktur" "djupstrukturer" ;
  djurart_nn_1_N = mkN "djurart" "djurarter" ;
  djurbok_nn_1_N = mkN "djurbok" "djurböcker" ;
  djurgrupp_nn_1_N = mkN "djurgrupp" "djurgrupper" ;
  djurraettsaktivist_nn_1_1_N = mkN "djurrättsaktivist" "djurrättsaktivister" ;
  djurskyddsinspektoer_nn_1_1_N = mkN "djurskyddsinspektör" "djurskyddsinspektörer" ;
  djaeklighet_nn_1_1_N = mkN "djäklighet" "djäkligheter" ;
  djaervhet_nn_1_1_N = mkN "djärvhet" "djärvheter" ;
  djaevlighet_nn_1_1_N = mkN "djävlighet" "djävligheter" ;
  dna_molekyl_nn_1_N = mkN "dna-molekyl" "dna-molekyler" ;
  dna_sekvens_nn_1_N = mkN "dna-sekvens" "dna-sekvenser" ;
  doakoer_nn_1_1_N = mkN "doakör" "doakörer" ;
  docentur_nn_1_N = mkN "docentur" "docenturer" ;
  dogmatism_nn_1_N = mkN "dogmatism" "dogmatismer" ;
  doktor_nn_1_N = mkN "doktor" "doktorer" ;
  doktorand_nn_1_N = mkN "doktorand" "doktorander" ;
  doktorsdisputation_nn_1_N = mkN "doktorsdisputation" "doktorsdisputationer" ;
  doktorsgrad_nn_1_N = mkN "doktorsgrad" "doktorsgrader" ;
  doktorspromotion_nn_1_N = mkN "doktorspromotion" "doktorspromotioner" ;
  doktrin_nn_1_N = mkN "doktrin" "doktriner" ;
  doktrinarism_nn_1_N = mkN "doktrinarism" "doktrinarismer" ;
  dokumentalist_nn_1_N = mkN "dokumentalist" "dokumentalister" ;
  dokumentation_nn_1_N = mkN "dokumentation" "dokumentationer" ;
  dokumentaer_nn_1_1_N = mkN "dokumentär" "dokumentärer" ;
  dokumentaerfilm_nn_1_1_N = mkN "dokumentärfilm" "dokumentärfilmer" ;
  dokumentaerroman_nn_1_1_N = mkN "dokumentärroman" "dokumentärromaner" ;
  dolkstoetslegend_nn_1_1_N = mkN "dolkstötslegend" "dolkstötslegender" ;
  dollarturist_nn_1_N = mkN "dollarturist" "dollarturister" ;
  dolomit_nn_1_N = mkN "dolomit" "dolomiter" ;
  domared_nn_1_N = mkN "domared" "domareder" ;
  domaredans_nn_1_N = mkN "domaredans" "domaredanser" ;
  domarkaar_nn_1_1_N = mkN "domarkår" "domarkårer" ;
  domarornat_nn_1_N = mkN "domarornat" "domarornater" ;
  domarpost_nn_1_N = mkN "domarpost" "domarposter" ;
  dombok_nn_1_N = mkN "dombok" "domböcker" ;
  domedagspredikant_nn_1_N = mkN "domedagspredikant" "domedagspredikanter" ;
  dominant_nn_1_N = mkN "dominant" "dominanter" ;
  dominikan_nn_1_N = mkN "dominikan" "dominikaner" ;
  domptoersfason_nn_1_1_N = mkN "domptörsfason" "domptörsfasoner" ;
  domaenintendent_nn_1_1_N = mkN "domänintendent" "domänintendenter" ;
  donation_nn_1_N = mkN "donation" "donationer" ;
  donator_nn_1_N = mkN "donator" "donatorer" ;
  dopattest_nn_1_N = mkN "dopattest" "dopattester" ;
  dos_nn_1_N = mkN "dos" "doser" ;
  dossi_e_nn_1_1_N = mkN "dossié" "dossiéer" ;
  dotation_nn_1_N = mkN "dotation" "dotationer" ;
  dottercell_nn_1_N = mkN "dottercell" "dotterceller" ;
  dottersvulst_nn_1_N = mkN "dottersvulst" "dottersvulster" ;
  doubl_e_nn_2_1_N = mkN "doublé" "doubléer" ;
  doyen_nn_1_N = mkN "doyen" "doyener" ;
  drabant_nn_1_N = mkN "drabant" "drabanter" ;
  drabantstat_nn_1_N = mkN "drabantstat" "drabantstater" ;
  dragenhet_nn_2_N = mkN "dragenhet" "dragenheter" ;
  draghaallfasthet_nn_1_1_N = mkN "draghållfasthet" "draghållfastheter" ;
  dragoman_nn_1_N = mkN "dragoman" "dragomaner" ;
  dragon_nn_1_N = mkN "dragon" "dragoner" ;
  drag_e_nn_1_1_N = mkN "dragé" "dragéer" ;
  dramaturg_nn_1_N = mkN "dramaturg" "dramaturger" ;
  dressin_nn_1_N = mkN "dressin" "dressiner" ;
  drevjakt_nn_1_N = mkN "drevjakt" "drevjakter" ;
  driftkostnad_nn_1_N = mkN "driftkostnad" "driftkostnader" ;
  driftskostnad_nn_1_N = mkN "driftskostnad" "driftskostnader" ;
  drifttid_nn_1_N = mkN "drifttid" "drifttider" ;
  drivkraft_nn_1_N = mkN "drivkraft" "drivkrafter" ;
  droppinfektion_nn_1_N = mkN "droppinfektion" "droppinfektioner" ;
  druid_nn_1_N = mkN "druid" "druider" ;
  drullighet_nn_1_N = mkN "drullighet" "drulligheter" ;
  drumlighet_nn_1_N = mkN "drumlighet" "drumligheter" ;
  drus_nn_1_N = mkN "drus" "druser" ;
  dryck_nn_1_N = mkN "dryck" "drycker" ;
  dryckesservis_nn_1_N = mkN "dryckesservis" "dryckesserviser" ;
  dryghet_nn_1_N = mkN "dryghet" "drygheter" ;
  draekt_nn_1_1_N = mkN "dräkt" "dräkter" ;
  draektighet_nn_1_1_N = mkN "dräktighet" "dräktigheter" ;
  draengtjaenst_nn_1_1_N = mkN "drängtjänst" "drängtjänster" ;
  draetselnaemnd_nn_1_1_N = mkN "drätselnämnd" "drätselnämnder" ;
  draaplighet_nn_1_1_N = mkN "dråplighet" "dråpligheter" ;
  droembild_nn_1_1_N = mkN "drömbild" "drömbilder" ;
  droembok_nn_1_1_N = mkN "drömbok" "drömböcker" ;
  droemgraens_nn_1_1_N = mkN "drömgräns" "drömgränser" ;
  droemstart_nn_1_1_N = mkN "drömstart" "drömstarter" ;
  droemsyn_nn_1_1_N = mkN "drömsyn" "drömsyner" ;
  droemtydningsbok_nn_1_1_N = mkN "drömtydningsbok" "drömtydningsböcker" ;
  droenarattack_nn_1_1_N = mkN "drönarattack" "drönarattacker" ;
  droenarraed_nn_1_1_N = mkN "drönarräd" "drönarräder" ;
  dualism_nn_1_N = mkN "dualism" "dualismer" ;
  dualist_nn_1_N = mkN "dualist" "dualister" ;
  dubbelbeckasin_nn_1_N = mkN "dubbelbeckasin" "dubbelbeckasiner" ;
  dubbelhet_nn_1_N = mkN "dubbelhet" "dubbelheter" ;
  dubbelkontakt_nn_1_N = mkN "dubbelkontakt" "dubbelkontakter" ;
  dubbelkoer_nn_1_1_N = mkN "dubbelkör" "dubbelkörer" ;
  dubbelmadrass_nn_1_N = mkN "dubbelmadrass" "dubbelmadrasser" ;
  dubbelnatur_nn_1_N = mkN "dubbelnatur" "dubbelnaturer" ;
  dubbelrevolution_nn_1_N = mkN "dubbelrevolution" "dubbelrevolutioner" ;
  dubbelroll_nn_1_N = mkN "dubbelroll" "dubbelroller" ;
  dubbelspaarsutbyggnad_nn_1_1_N = mkN "dubbelspårsutbyggnad" "dubbelspårsutbyggnader" ;
  dubblett_nn_1_N = mkN "dubblett" "dubbletter" ;
  dubbl_e_nn_2_1_N = mkN "dubblé" "dubbléer" ;
  dublett_nn_1_N = mkN "dublett" "dubletter" ;
  duellant_nn_1_N = mkN "duellant" "duellanter" ;
  duglighet_nn_1_N = mkN "duglighet" "dugligheter" ;
  dukt_nn_1_N = mkN "dukt" "dukter" ;
  dulcian_nn_1_N = mkN "dulcian" "dulcianer" ;
  dumhet_nn_1_N = mkN "dumhet" "dumheter" ;
  dumskallemajoritet_nn_1_N = mkN "dumskallemajoritet" "dumskallemajoriteter" ;
  dunkelhet_nn_1_N = mkN "dunkelhet" "dunkelheter" ;
  dunst_nn_1_N = mkN "dunst" "dunster" ;
  duodes_nn_1_N = mkN "duodes" "duodeser" ;
  duplexfaerg_nn_1_1_N = mkN "duplexfärg" "duplexfärger" ;
  duplikator_nn_1_N = mkN "duplikator" "duplikatorer" ;
  dureform_nn_1_N = mkN "dureform" "dureformer" ;
  duroplast_nn_1_N = mkN "duroplast" "duroplaster" ;
  duschkraem_nn_1_1_N = mkN "duschkräm" "duschkrämer" ;
  dussinroman_nn_1_N = mkN "dussinroman" "dussinromaner" ;
  dust_nn_1_N = mkN "dust" "duster" ;
  dvd_film_nn_1_N = mkN "dvd-film" "dvd-filmer" ;
  dvaerggalax_nn_1_1_N = mkN "dvärggalax" "dvärggalaxer" ;
  dvaergschimpans_nn_1_1_N = mkN "dvärgschimpans" "dvärgschimpanser" ;
  dygd_nn_1_N = mkN "dygd" "dygder" ;
  dygnsrytm_nn_1_N = mkN "dygnsrytm" "dygnsrytmer" ;
  dykardraekt_nn_1_1_N = mkN "dykardräkt" "dykardräkter" ;
  dynamism_nn_1_N = mkN "dynamism" "dynamismer" ;
  dyrbarhet_nn_1_N = mkN "dyrbarhet" "dyrbarheter" ;
  dyrort_nn_1_N = mkN "dyrort" "dyrorter" ;
  dyrortsgrupp_nn_1_N = mkN "dyrortsgrupp" "dyrortsgrupper" ;
  dys_nn_1_N = mkN "dys" "dyser" ;
  dysterhet_nn_1_N = mkN "dysterhet" "dysterheter" ;
  daeckdimension_nn_1_1_N = mkN "däckdimension" "däckdimensioner" ;
  daeckslast_nn_1_1_N = mkN "däckslast" "däckslaster" ;
  daeggdjursgrupp_nn_1_1_N = mkN "däggdjursgrupp" "däggdjursgrupper" ;
  daeggdjurstyp_nn_1_1_N = mkN "däggdjurstyp" "däggdjurstyper" ;
  daalighet_nn_1_1_N = mkN "dålighet" "dåligheter" ;
  daaraktighet_nn_1_1_N = mkN "dåraktighet" "dåraktigheter" ;
  daasighet_nn_1_1_N = mkN "dåsighet" "dåsigheter" ;
  doedlighet_nn_1_1_N = mkN "dödlighet" "dödligheter" ;
  doedsannons_nn_1_1_N = mkN "dödsannons" "dödsannonser" ;
  doedsattest_nn_1_1_N = mkN "dödsattest" "dödsattester" ;
  doedsdans_nn_1_1_N = mkN "dödsdans" "dödsdanser" ;
  doedsfas_nn_1_1_N = mkN "dödsfas" "dödsfaser" ;
  doedskrasch_nn_1_1_N = mkN "dödskrasch" "dödskrascher" ;
  doedsmask_nn_1_1_N = mkN "dödsmask" "dödsmasker" ;
  doedsorsak_nn_1_1_N = mkN "dödsorsak" "dödsorsaker" ;
  doedsstelhet_nn_1_1_N = mkN "dödsstelhet" "dödsstelheter" ;
  doedsstund_nn_1_1_N = mkN "dödsstund" "dödsstunder" ;
  doedstystnad_nn_1_1_N = mkN "dödstystnad" "dödstystnader" ;
  doerrfaerg_nn_1_1_N = mkN "dörrfärg" "dörrfärger" ;
  doerrknackningskampanj_nn_1_1_N = mkN "dörrknackningskampanj" "dörrknackningskampanjer" ;
  doerrpost_nn_1_1_N = mkN "dörrpost" "dörrposter" ;
  doerrvakt_nn_1_1_N = mkN "dörrvakt" "dörrvakter" ;
  doevhet_nn_1_1_N = mkN "dövhet" "dövheter" ;
  e_bok_nn_1_N = mkN "e-bok" "e-böcker" ;
  e_tidskrift_nn_1_N = mkN "e-tidskrift" "e-tidskrifter" ;
  e_vetenskap_nn_1_N = mkN "e-vetenskap" "e-vetenskaper" ;
  ebenist_nn_1_N = mkN "ebenist" "ebenister" ;
  ecuadorian_nn_1_N = mkN "ecuadorian" "ecuadorianer" ;
  edition_nn_1_N = mkN "edition" "editioner" ;
  efemerid_nn_1_N = mkN "efemerid" "efemerider" ;
  effektfaktor_nn_1_N = mkN "effektfaktor" "effektfaktorer" ;
  effektivitet_nn_1_N = mkN "effektivitet" "effektiviteter" ;
  efterbild_nn_1_N = mkN "efterbild" "efterbilder" ;
  efterboers_nn_1_1_N = mkN "efterbörs" "efterbörser" ;
  efterfest_nn_1_N = mkN "efterfest" "efterfester" ;
  eftergivenhet_nn_1_N = mkN "eftergivenhet" "eftergivenheter" ;
  efterhandskonstruktion_nn_1_N = mkN "efterhandskonstruktion" "efterhandskonstruktioner" ;
  efterkonstruktion_nn_1_N = mkN "efterkonstruktion" "efterkonstruktioner" ;
  efterkontroll_nn_1_N = mkN "efterkontroll" "efterkontroller" ;
  efterkrigstid_nn_1_N = mkN "efterkrigstid" "efterkrigstider" ;
  efterlevnad_nn_1_N = mkN "efterlevnad" "efterlevnader" ;
  eftermiddagssejour_nn_1_N = mkN "eftermiddagssejour" "eftermiddagssejourer" ;
  efterraett_nn_1_1_N = mkN "efterrätt" "efterrätter" ;
  eftersats_nn_1_N = mkN "eftersats" "eftersatser" ;
  efterskrift_nn_1_N = mkN "efterskrift" "efterskrifter" ;
  egalitet_nn_1_N = mkN "egalitet" "egaliteter" ;
  egendomlighet_nn_1_N = mkN "egendomlighet" "egendomligheter" ;
  egendomsaffaer_nn_1_1_N = mkN "egendomsaffär" "egendomsaffärer" ;
  egenfrekvens_nn_1_N = mkN "egenfrekvens" "egenfrekvenser" ;
  egenhet_nn_1_N = mkN "egenhet" "egenheter" ;
  egenskapsgenitiv_nn_1_N = mkN "egenskapsgenitiv" "egenskapsgenitiver" ;
  egocentricitet_nn_1_N = mkN "egocentricitet" "egocentriciteter" ;
  egoism_nn_1_N = mkN "egoism" "egoismer" ;
  egoist_nn_1_N = mkN "egoist" "egoister" ;
  egotism_nn_1_N = mkN "egotism" "egotismer" ;
  egyptolog_nn_1_N = mkN "egyptolog" "egyptologer" ;
  ejakulation_nn_1_N = mkN "ejakulation" "ejakulationer" ;
  ejektor_nn_1_N = mkN "ejektor" "ejektorer" ;
  ekiperingsaffaer_nn_1_1_N = mkN "ekiperingsaffär" "ekiperingsaffärer" ;
  eklekticism_nn_1_N = mkN "eklekticism" "eklekticismer" ;
  eklips_nn_1_N = mkN "eklips" "eklipser" ;
  ekolobby_nn_1_N = mkN "ekolobby" "ekolobbyer" ;
  ekolog_nn_1_N = mkN "ekolog" "ekologer" ;
  ekonom_nn_1_N = mkN "ekonom" "ekonomer" ;
  ekonomibyggnad_nn_1_N = mkN "ekonomibyggnad" "ekonomibyggnader" ;
  ekonomichef_nn_1_N = mkN "ekonomichef" "ekonomichefer" ;
  ekonomikroenikoer_nn_1_1_N = mkN "ekonomikrönikör" "ekonomikrönikörer" ;
  ekoturist_nn_1_N = mkN "ekoturist" "ekoturister" ;
  ekumenism_nn_1_N = mkN "ekumenism" "ekumenismer" ;
  ekvation_nn_1_N = mkN "ekvation" "ekvationer" ;
  ekvatorialguinean_nn_1_N = mkN "ekvatorialguinean" "ekvatorialguineaner" ;
  ekvilibrist_nn_1_N = mkN "ekvilibrist" "ekvilibrister" ;
  ekvivalent_nn_1_N = mkN "ekvivalent" "ekvivalenter" ;
  elakhet_nn_1_N = mkN "elakhet" "elakheter" ;
  elandantilop_nn_1_N = mkN "elandantilop" "elandantiloper" ;
  elasticitet_nn_1_N = mkN "elasticitet" "elasticiteter" ;
  elasticitetsgraens_nn_1_1_N = mkN "elasticitetsgräns" "elasticitetsgränser" ;
  elativ_nn_1_N = mkN "elativ" "elativer" ;
  elbilspionjaer_nn_1_1_N = mkN "elbilspionjär" "elbilspionjärer" ;
  elboers_nn_1_1_N = mkN "elbörs" "elbörser" ;
  eldhastighet_nn_1_N = mkN "eldhastighet" "eldhastigheter" ;
  eldsats_nn_1_N = mkN "eldsats" "eldsatser" ;
  eldsignal_nn_1_N = mkN "eldsignal" "eldsignaler" ;
  eldstod_nn_1_N = mkN "eldstod" "eldstoder" ;
  eldstrid_nn_1_N = mkN "eldstrid" "eldstrider" ;
  elefant_nn_1_N = mkN "elefant" "elefanter" ;
  elektor_nn_1_N = mkN "elektor" "elektorer" ;
  elektorsroest_nn_1_1_N = mkN "elektorsröst" "elektorsröster" ;
  elektricitet_nn_1_N = mkN "elektricitet" "elektriciteter" ;
  elektricitetsmaengd_nn_1_1_N = mkN "elektricitetsmängd" "elektricitetsmängder" ;
  elektrikermejselsats_nn_1_N = mkN "elektrikermejselsats" "elektrikermejselsatser" ;
  elektroingenjoer_nn_1_1_N = mkN "elektroingenjör" "elektroingenjörer" ;
  elektrolys_nn_1_N = mkN "elektrolys" "elektrolyser" ;
  elektromagnet_nn_1_N = mkN "elektromagnet" "elektromagneter" ;
  elektromagnetism_nn_1_N = mkN "elektromagnetism" "elektromagnetismer" ;
  elektromotor_nn_1_N = mkN "elektromotor" "elektromotorer" ;
  elektron_nn_1_N = mkN "elektron" "elektroner" ;
  elektronegativitet_nn_1_N = mkN "elektronegativitet" "elektronegativiteter" ;
  elektronmikroskopbild_nn_1_N = mkN "elektronmikroskopbild" "elektronmikroskopbilder" ;
  elektrostriktion_nn_1_N = mkN "elektrostriktion" "elektrostriktioner" ;
  elementarbok_nn_1_N = mkN "elementarbok" "elementarböcker" ;
  elementfaerg_nn_1_1_N = mkN "elementfärg" "elementfärger" ;
  elevation_nn_1_N = mkN "elevation" "elevationer" ;
  elevator_nn_1_N = mkN "elevator" "elevatorer" ;
  elgenerator_nn_1_N = mkN "elgenerator" "elgeneratorer" ;
  elhybrid_nn_1_N = mkN "elhybrid" "elhybrider" ;
  elimination_nn_1_N = mkN "elimination" "eliminationer" ;
  elision_nn_1_N = mkN "elision" "elisioner" ;
  elit_nn_1_N = mkN "elit" "eliter" ;
  elitidrott_nn_1_N = mkN "elitidrott" "elitidrotter" ;
  elitism_nn_1_N = mkN "elitism" "elitismer" ;
  elitkaar_nn_1_1_N = mkN "elitkår" "elitkårer" ;
  elitsoldat_nn_1_N = mkN "elitsoldat" "elitsoldater" ;
  ellips_nn_1_N = mkN "ellips" "ellipser" ;
  ellipsoid_nn_1_N = mkN "ellipsoid" "ellipsoider" ;
  elmarknad_nn_1_N = mkN "elmarknad" "elmarknader" ;
  elmotor_nn_1_N = mkN "elmotor" "elmotorer" ;
  elongation_nn_1_N = mkN "elongation" "elongationer" ;
  elpistol_nn_1_N = mkN "elpistol" "elpistoler" ;
  elusion_nn_1_N = mkN "elusion" "elusioner" ;
  elvispfabrik_nn_1_N = mkN "elvispfabrik" "elvispfabriker" ;
  emaljfaerg_nn_1_1_N = mkN "emaljfärg" "emaljfärger" ;
  emanation_nn_1_N = mkN "emanation" "emanationer" ;
  emancipation_nn_1_N = mkN "emancipation" "emancipationer" ;
  embryolog_nn_1_N = mkN "embryolog" "embryologer" ;
  emendation_nn_1_N = mkN "emendation" "emendationer" ;
  emigrant_nn_1_N = mkN "emigrant" "emigranter" ;
  emigration_nn_1_N = mkN "emigration" "emigrationer" ;
  eminens_nn_1_N = mkN "eminens" "eminenser" ;
  emission_nn_1_N = mkN "emission" "emissioner" ;
  emissionskurs_nn_1_N = mkN "emissionskurs" "emissionskurser" ;
  emollition_nn_1_N = mkN "emollition" "emollitioner" ;
  emotion_nn_1_N = mkN "emotion" "emotioner" ;
  empirism_nn_1_N = mkN "empirism" "empirismer" ;
  empirist_nn_1_N = mkN "empirist" "empirister" ;
  emulsion_nn_1_N = mkN "emulsion" "emulsioner" ;
  emulsionsfaerg_nn_1_1_N = mkN "emulsionsfärg" "emulsionsfärger" ;
  encefalit_nn_1_N = mkN "encefalit" "encefaliter" ;
  encyklopedist_nn_1_N = mkN "encyklopedist" "encyklopedister" ;
  endokrinolog_nn_1_N = mkN "endokrinolog" "endokrinologer" ;
  endonym_nn_1_N = mkN "endonym" "endonymer" ;
  energidryck_nn_1_N = mkN "energidryck" "energidrycker" ;
  energieffektivitet_nn_1_N = mkN "energieffektivitet" "energieffektiviteter" ;
  energiform_nn_1_N = mkN "energiform" "energiformer" ;
  energifoerlust_nn_1_1_N = mkN "energiförlust" "energiförluster" ;
  energikoncentration_nn_1_N = mkN "energikoncentration" "energikoncentrationer" ;
  energimarknad_nn_1_N = mkN "energimarknad" "energimarknader" ;
  energimix_nn_1_N = mkN "energimix" "energimixer" ;
  energimaengd_nn_1_1_N = mkN "energimängd" "energimängder" ;
  energiskatt_nn_1_N = mkN "energiskatt" "energiskatter" ;
  energivinst_nn_1_N = mkN "energivinst" "energivinster" ;
  enfoeraeldersfamilj_nn_1_1_N = mkN "enföräldersfamilj" "enföräldersfamiljer" ;
  engelskakurs_nn_1_N = mkN "engelskakurs" "engelskakurser" ;
  engelskalektion_nn_1_N = mkN "engelskalektion" "engelskalektioner" ;
  engelskkurs_nn_1_N = mkN "engelskkurs" "engelskkurser" ;
  engelsklektion_nn_1_N = mkN "engelsklektion" "engelsklektioner" ;
  englergrad_nn_1_N = mkN "englergrad" "englergrader" ;
  engrossist_nn_1_N = mkN "engrossist" "engrossister" ;
  engaangsdos_nn_1_1_N = mkN "engångsdos" "engångsdoser" ;
  engaangskostnad_nn_1_1_N = mkN "engångskostnad" "engångskostnader" ;
  engaangsskatt_nn_1_1_N = mkN "engångsskatt" "engångsskatter" ;
  enhet_nn_1_N = mkN "enhet" "enheter" ;
  enhetslast_nn_1_N = mkN "enhetslast" "enhetslaster" ;
  enhetsvektor_nn_1_N = mkN "enhetsvektor" "enhetsvektorer" ;
  enighet_nn_1_N = mkN "enighet" "enigheter" ;
  enkelbeckasin_nn_1_N = mkN "enkelbeckasin" "enkelbeckasiner" ;
  enkelhet_nn_1_N = mkN "enkelhet" "enkelheter" ;
  enkelrad_nn_1_N = mkN "enkelrad" "enkelrader" ;
  enkaet_nn_1_1_N = mkN "enkät" "enkäter" ;
  enmanspublik_nn_1_N = mkN "enmanspublik" "enmanspubliker" ;
  enpartistat_nn_1_N = mkN "enpartistat" "enpartistater" ;
  enpersonsfamilj_nn_1_N = mkN "enpersonsfamilj" "enpersonsfamiljer" ;
  enrumslaegenhet_nn_1_1_N = mkN "enrumslägenhet" "enrumslägenheter" ;
  ensak_nn_1_N = mkN "ensak" "ensaker" ;
  ensamhet_nn_1_N = mkN "ensamhet" "ensamheter" ;
  ensamraett_nn_1_1_N = mkN "ensamrätt" "ensamrätter" ;
  enskildhet_nn_1_N = mkN "enskildhet" "enskildheter" ;
  entent_nn_1_N = mkN "entent" "ententer" ;
  entitet_nn_1_N = mkN "entitet" "entiteter" ;
  entomolog_nn_1_N = mkN "entomolog" "entomologer" ;
  entresol_nn_1_N = mkN "entresol" "entresoler" ;
  entresoll_nn_1_N = mkN "entresoll" "entresoller" ;
  entr_e_nn_1_1_N = mkN "entré" "entréer" ;
  entr_eavgift_nn_1_1_N = mkN "entréavgift" "entréavgifter" ;
  entr_eraett_nn_1_1_N = mkN "entrérätt" "entrérätter" ;
  entusiast_nn_1_N = mkN "entusiast" "entusiaster" ;
  entydighet_nn_1_N = mkN "entydighet" "entydigheter" ;
  enumeration_nn_1_N = mkN "enumeration" "enumerationer" ;
  environg_nn_1_N = mkN "environg" "environger" ;
  envaegskommunikation_nn_1_1_N = mkN "envägskommunikation" "envägskommunikationer" ;
  envaaningsbarack_nn_1_1_N = mkN "envåningsbarack" "envåningsbaracker" ;
  eon_nn_1_N = mkN "eon" "eoner" ;
  epatraktor_nn_1_N = mkN "epatraktor" "epatraktorer" ;
  epidemolog_nn_1_N = mkN "epidemolog" "epidemologer" ;
  epiduralblockad_nn_1_N = mkN "epiduralblockad" "epiduralblockader" ;
  epifys_nn_1_N = mkN "epifys" "epifyser" ;
  epigon_nn_1_N = mkN "epigon" "epigoner" ;
  epikurism_nn_1_N = mkN "epikurism" "epikurismer" ;
  epistyl_nn_1_N = mkN "epistyl" "epistyler" ;
  epitelcell_nn_1_N = mkN "epitelcell" "epitelceller" ;
  erbarmlighet_nn_1_N = mkN "erbarmlighet" "erbarmligheter" ;
  erektion_nn_1_N = mkN "erektion" "erektioner" ;
  eremit_nn_1_N = mkN "eremit" "eremiter" ;
  erfarenhet_nn_1_N = mkN "erfarenhet" "erfarenheter" ;
  erfarenhetsbank_nn_1_N = mkN "erfarenhetsbank" "erfarenhetsbanker" ;
  erfarenhetssfaer_nn_1_1_N = mkN "erfarenhetssfär" "erfarenhetssfärer" ;
  ergativ_nn_1_N = mkN "ergativ" "ergativer" ;
  eritrean_nn_1_N = mkN "eritrean" "eritreaner" ;
  erosion_nn_1_N = mkN "erosion" "erosioner" ;
  erotoman_nn_1_N = mkN "erotoman" "erotomaner" ;
  ersaettningsnivaa_nn_1_1_N = mkN "ersättningsnivå" "ersättningsnivåer" ;
  eruption_nn_1_N = mkN "eruption" "eruptioner" ;
  eskalation_nn_1_N = mkN "eskalation" "eskalationer" ;
  eskapism_nn_1_N = mkN "eskapism" "eskapismer" ;
  eskimaa_nn_1_1_N = mkN "eskimå" "eskimåer" ;
  esperantist_nn_1_N = mkN "esperantist" "esperantister" ;
  esprit_nn_2_N = mkN "esprit" "espriter" ;
  essayist_nn_1_N = mkN "essayist" "essayister" ;
  essayistik_nn_1_N = mkN "essayistik" "essayistiker" ;
  essens_nn_2_N = mkN "essens" "essenser" ;
  essiv_nn_1_N = mkN "essiv" "essiver" ;
  essaebok_nn_1_1_N = mkN "essäbok" "essäböcker" ;
  essaeist_nn_1_1_N = mkN "essäist" "essäister" ;
  est_nn_1_N = mkN "est" "ester" ;
  esterplast_nn_1_N = mkN "esterplast" "esterplaster" ;
  esteticism_nn_1_N = mkN "esteticism" "esteticismer" ;
  estrad_nn_1_N = mkN "estrad" "estrader" ;
  estradartist_nn_1_N = mkN "estradartist" "estradartister" ;
  eterisation_nn_1_N = mkN "eterisation" "eterisationer" ;
  eternell_nn_1_N = mkN "eternell" "eterneller" ;
  etnicitet_nn_1_N = mkN "etnicitet" "etniciteter" ;
  etnocentrism_nn_1_N = mkN "etnocentrism" "etnocentrismer" ;
  etnolog_nn_1_N = mkN "etnolog" "etnologer" ;
  etolog_nn_1_N = mkN "etolog" "etologer" ;
  etrusk_nn_1_N = mkN "etrusk" "etrusker" ;
  ettrumslaegenhet_nn_1_1_N = mkN "ettrumslägenhet" "ettrumslägenheter" ;
  etyd_nn_1_N = mkN "etyd" "etyder" ;
  etymolog_nn_1_N = mkN "etymolog" "etymologer" ;
  eudemonism_nn_1_N = mkN "eudemonism" "eudemonismer" ;
  eufemism_nn_1_N = mkN "eufemism" "eufemismer" ;
  eumenid_nn_1_N = mkN "eumenid" "eumenider" ;
  eurokalabalik_nn_1_N = mkN "eurokalabalik" "eurokalabaliker" ;
  eurokommunism_nn_1_N = mkN "eurokommunism" "eurokommunismer" ;
  eurokris_nn_1_N = mkN "eurokris" "eurokriser" ;
  europaboers_nn_1_1_N = mkN "europabörs" "europabörser" ;
  europid_nn_1_N = mkN "europid" "europider" ;
  eurovision_nn_1_N = mkN "eurovision" "eurovisioner" ;
  evangeliebok_nn_1_N = mkN "evangeliebok" "evangelieböcker" ;
  evangelietext_nn_1_N = mkN "evangelietext" "evangelietexter" ;
  evangelisation_nn_1_N = mkN "evangelisation" "evangelisationer" ;
  evangelist_nn_1_N = mkN "evangelist" "evangelister" ;
  evaporation_nn_1_N = mkN "evaporation" "evaporationer" ;
  eventualitet_nn_1_N = mkN "eventualitet" "eventualiteter" ;
  evighet_nn_1_N = mkN "evighet" "evigheter" ;
  evolution_nn_1_N = mkN "evolution" "evolutioner" ;
  evolutionism_nn_1_N = mkN "evolutionism" "evolutionismer" ;
  evolutionist_nn_1_N = mkN "evolutionist" "evolutionister" ;
  evolutionsbiolog_nn_1_N = mkN "evolutionsbiolog" "evolutionsbiologer" ;
  evolutionsmekanism_nn_1_N = mkN "evolutionsmekanism" "evolutionsmekanismer" ;
  exakthet_nn_1_N = mkN "exakthet" "exaktheter" ;
  exaltation_nn_1_N = mkN "exaltation" "exaltationer" ;
  examensuppgift_nn_1_N = mkN "examensuppgift" "examensuppgifter" ;
  examination_nn_1_N = mkN "examination" "examinationer" ;
  examinator_nn_1_N = mkN "examinator" "examinatorer" ;
  excellens_nn_1_N = mkN "excellens" "excellenser" ;
  excentricitet_nn_1_N = mkN "excentricitet" "excentriciteter" ;
  excerpist_nn_1_N = mkN "excerpist" "excerpister" ;
  excess_nn_1_N = mkN "excess" "excesser" ;
  excision_nn_1_N = mkN "excision" "excisioner" ;
  excitation_nn_1_N = mkN "excitation" "excitationer" ;
  exekution_nn_1_N = mkN "exekution" "exekutioner" ;
  exekutionspluton_nn_1_N = mkN "exekutionspluton" "exekutionsplutoner" ;
  exekutiv_nn_1_N = mkN "exekutiv" "exekutiver" ;
  exekutor_nn_1_N = mkN "exekutor" "exekutorer" ;
  exempelloeshet_nn_1_1_N = mkN "exempellöshet" "exempellösheter" ;
  exemplifikation_nn_1_N = mkN "exemplifikation" "exemplifikationer" ;
  exercis_nn_1_N = mkN "exercis" "exerciser" ;
  exhibitionism_nn_1_N = mkN "exhibitionism" "exhibitionismer" ;
  exhibitionist_nn_1_N = mkN "exhibitionist" "exhibitionister" ;
  existens_nn_1_N = mkN "existens" "existenser" ;
  existensform_nn_1_N = mkN "existensform" "existensformer" ;
  existentialism_nn_1_N = mkN "existentialism" "existentialismer" ;
  exklamation_nn_1_N = mkN "exklamation" "exklamationer" ;
  exklav_nn_1_N = mkN "exklav" "exklaver" ;
  exklusivitet_nn_1_N = mkN "exklusivitet" "exklusiviteter" ;
  exkommunikation_nn_1_N = mkN "exkommunikation" "exkommunikationer" ;
  exkretion_nn_1_N = mkN "exkretion" "exkretioner" ;
  exkurs_nn_1_N = mkN "exkurs" "exkurser" ;
  exkursion_nn_1_N = mkN "exkursion" "exkursioner" ;
  exonym_nn_1_N = mkN "exonym" "exonymer" ;
  exorcism_nn_1_N = mkN "exorcism" "exorcismer" ;
  exorcist_nn_1_N = mkN "exorcist" "exorcister" ;
  exotism_nn_1_N = mkN "exotism" "exotismer" ;
  expansion_nn_1_N = mkN "expansion" "expansioner" ;
  expansionism_nn_1_N = mkN "expansionism" "expansionismer" ;
  expansionsplan_nn_1_N = mkN "expansionsplan" "expansionsplaner" ;
  expedit_nn_1_N = mkN "expedit" "expediter" ;
  expedition_nn_1_N = mkN "expedition" "expeditioner" ;
  expeditionschef_nn_1_N = mkN "expeditionschef" "expeditionschefer" ;
  expeditionskaar_nn_1_1_N = mkN "expeditionskår" "expeditionskårer" ;
  expeditionsvakt_nn_1_N = mkN "expeditionsvakt" "expeditionsvakter" ;
  expektoration_nn_1_N = mkN "expektoration" "expektorationer" ;
  experimentator_nn_1_N = mkN "experimentator" "experimentatorer" ;
  experimentstation_nn_1_N = mkN "experimentstation" "experimentstationer" ;
  expertgrupp_nn_1_N = mkN "expertgrupp" "expertgrupper" ;
  expertkommentator_nn_1_N = mkN "expertkommentator" "expertkommentatorer" ;
  expertkommitt_e_nn_1_1_N = mkN "expertkommitté" "expertkommittéer" ;
  explikation_nn_1_N = mkN "explikation" "explikationer" ;
  explosion_nn_1_N = mkN "explosion" "explosioner" ;
  explosionsmotor_nn_1_N = mkN "explosionsmotor" "explosionsmotorer" ;
  explosionsrisk_nn_1_N = mkN "explosionsrisk" "explosionsrisker" ;
  exponentialfunktion_nn_1_N = mkN "exponentialfunktion" "exponentialfunktioner" ;
  export_nn_1_N = mkN "export" "exporter" ;
  exportinkomst_nn_1_N = mkN "exportinkomst" "exportinkomster" ;
  exportmarknad_nn_1_N = mkN "exportmarknad" "exportmarknader" ;
  exposition_nn_1_N = mkN "exposition" "expositioner" ;
  expos_e_nn_1_1_N = mkN "exposé" "exposéer" ;
  express_nn_1_N = mkN "express" "expresser" ;
  expressbyraa_nn_1_1_N = mkN "expressbyrå" "expressbyråer" ;
  expressionism_nn_1_N = mkN "expressionism" "expressionismer" ;
  expressionist_nn_1_N = mkN "expressionist" "expressionister" ;
  expressivitet_nn_1_N = mkN "expressivitet" "expressiviteter" ;
  expropriation_nn_1_N = mkN "expropriation" "expropriationer" ;
  exsickator_nn_1_N = mkN "exsickator" "exsickatorer" ;
  exspiration_nn_1_N = mkN "exspiration" "exspirationer" ;
  extension_nn_1_N = mkN "extension" "extensioner" ;
  extrainkomst_nn_1_N = mkN "extrainkomst" "extrainkomster" ;
  extrakongress_nn_1_N = mkN "extrakongress" "extrakongresser" ;
  extraktion_nn_1_N = mkN "extraktion" "extraktioner" ;
  extraktor_nn_1_N = mkN "extraktor" "extraktorer" ;
  extrapolation_nn_1_N = mkN "extrapolation" "extrapolationer" ;
  extratur_nn_1_N = mkN "extratur" "extraturer" ;
  extravagans_nn_1_N = mkN "extravagans" "extravaganser" ;
  extrem_nn_1_N = mkN "extrem" "extremer" ;
  extremism_nn_1_N = mkN "extremism" "extremismer" ;
  extremist_nn_1_N = mkN "extremist" "extremister" ;
  extremitet_nn_1_N = mkN "extremitet" "extremiteter" ;
  extremnationalist_nn_1_N = mkN "extremnationalist" "extremnationalister" ;
  fabrik_nn_1_N = mkN "fabrik" "fabriker" ;
  fabrikant_nn_1_N = mkN "fabrikant" "fabrikanter" ;
  fabrikation_nn_1_N = mkN "fabrikation" "fabrikationer" ;
  fabriksbyggnad_nn_1_N = mkN "fabriksbyggnad" "fabriksbyggnader" ;
  fabrikoer_nn_1_1_N = mkN "fabrikör" "fabrikörer" ;
  facebookbild_nn_1_N = mkN "facebookbild" "facebookbilder" ;
  facebookgrupp_nn_1_N = mkN "facebookgrupp" "facebookgrupper" ;
  facilitet_nn_1_N = mkN "facilitet" "faciliteter" ;
  fackkunskap_nn_1_N = mkN "fackkunskap" "fackkunskaper" ;
  fackordbok_nn_1_N = mkN "fackordbok" "fackordböcker" ;
  facktidskrift_nn_1_N = mkN "facktidskrift" "facktidskrifter" ;
  fackutskottsprincip_nn_1_N = mkN "fackutskottsprincip" "fackutskottsprinciper" ;
  fadersfigur_nn_1_N = mkN "fadersfigur" "fadersfigurer" ;
  fadaes_nn_1_1_N = mkN "fadäs" "fadäser" ;
  fajans_nn_1_N = mkN "fajans" "fajanser" ;
  fajansfabrik_nn_1_N = mkN "fajansfabrik" "fajansfabriker" ;
  fajt_nn_1_N = mkN "fajt" "fajter" ;
  fakticitet_nn_1_N = mkN "fakticitet" "fakticiteter" ;
  faktoid_nn_1_N = mkN "faktoid" "faktoider" ;
  faktor_nn_1_N = mkN "faktor" "faktorer" ;
  faktoranalys_nn_1_N = mkN "faktoranalys" "faktoranalyser" ;
  fakultet_nn_1_N = mkN "fakultet" "fakulteter" ;
  fakultetsgraens_nn_1_1_N = mkN "fakultetsgräns" "fakultetsgränser" ;
  falangist_nn_1_N = mkN "falangist" "falangister" ;
  falangstrid_nn_1_N = mkN "falangstrid" "falangstrider" ;
  falkjakt_nn_1_N = mkN "falkjakt" "falkjakter" ;
  fallenhet_nn_1_N = mkN "fallenhet" "fallenheter" ;
  fallhoejd_nn_1_1_N = mkN "fallhöjd" "fallhöjder" ;
  falsettroest_nn_1_1_N = mkN "falsettröst" "falsettröster" ;
  falskhet_nn_1_N = mkN "falskhet" "falskheter" ;
  familj_nn_1_N = mkN "familj" "familjer" ;
  familjaritet_nn_1_N = mkN "familjaritet" "familjariteter" ;
  familjebild_nn_1_N = mkN "familjebild" "familjebilder" ;
  familjefejd_nn_1_N = mkN "familjefejd" "familjefejder" ;
  familjehemlighet_nn_1_N = mkN "familjehemlighet" "familjehemligheter" ;
  familjepension_nn_1_N = mkN "familjepension" "familjepensioner" ;
  familjerabatt_nn_1_N = mkN "familjerabatt" "familjerabatter" ;
  familjetradition_nn_1_N = mkN "familjetradition" "familjetraditioner" ;
  fanatism_nn_1_N = mkN "fanatism" "fanatismer" ;
  fanerogam_nn_1_N = mkN "fanerogam" "fanerogamer" ;
  fantasibild_nn_1_N = mkN "fantasibild" "fantasibilder" ;
  fantasifigur_nn_1_N = mkN "fantasifigur" "fantasifigurer" ;
  fantasifullhet_nn_1_N = mkN "fantasifullhet" "fantasifullheter" ;
  fantasiloeshet_nn_1_1_N = mkN "fantasilöshet" "fantasilösheter" ;
  fantast_nn_1_N = mkN "fantast" "fantaster" ;
  fantombild_nn_1_N = mkN "fantombild" "fantombilder" ;
  fanvakt_nn_1_N = mkN "fanvakt" "fanvakter" ;
  fariseism_nn_1_N = mkN "fariseism" "fariseismer" ;
  farkost_nn_1_N = mkN "farkost" "farkoster" ;
  farled_nn_1_N = mkN "farled" "farleder" ;
  farlighet_nn_1_N = mkN "farlighet" "farligheter" ;
  farmakolog_nn_1_N = mkN "farmakolog" "farmakologer" ;
  farmakop_e_nn_1_1_N = mkN "farmakopé" "farmakopéer" ;
  farmardomkraft_nn_1_N = mkN "farmardomkraft" "farmardomkrafter" ;
  fars_nn_1_N = mkN "fars" "farser" ;
  fartygsbyggartradition_nn_1_N = mkN "fartygsbyggartradition" "fartygsbyggartraditioner" ;
  fartygsincident_nn_1_N = mkN "fartygsincident" "fartygsincidenter" ;
  fartygskapten_nn_1_N = mkN "fartygskapten" "fartygskaptener" ;
  fartygskatastrof_nn_1_N = mkN "fartygskatastrof" "fartygskatastrofer" ;
  fartygskollision_nn_1_N = mkN "fartygskollision" "fartygskollisioner" ;
  fartygskonvoj_nn_1_N = mkN "fartygskonvoj" "fartygskonvojer" ;
  fartygskurs_nn_1_N = mkN "fartygskurs" "fartygskurser" ;
  fartygslast_nn_1_N = mkN "fartygslast" "fartygslaster" ;
  fartygstyp_nn_1_N = mkN "fartygstyp" "fartygstyper" ;
  fas_nn_1_N = mkN "fas" "faser" ;
  fasan_nn_1_N = mkN "fasan" "fasaner" ;
  fasansfullhet_nn_1_N = mkN "fasansfullhet" "fasansfullheter" ;
  fascination_nn_1_N = mkN "fascination" "fascinationer" ;
  fascism_nn_1_N = mkN "fascism" "fascismer" ;
  fascist_nn_1_N = mkN "fascist" "fascister" ;
  faskin_nn_1_N = mkN "faskin" "faskiner" ;
  faslighet_nn_1_N = mkN "faslighet" "fasligheter" ;
  fason_nn_1_N = mkN "fason" "fasoner" ;
  fastemaanad_nn_1_1_N = mkN "fastemånad" "fastemånader" ;
  fastetid_nn_1_N = mkN "fastetid" "fastetider" ;
  fasthet_nn_1_N = mkN "fasthet" "fastheter" ;
  fastighet_nn_1_N = mkN "fastighet" "fastigheter" ;
  fastighetsaffaer_nn_1_1_N = mkN "fastighetsaffär" "fastighetsaffärer" ;
  fastighetsbyraa_nn_1_1_N = mkN "fastighetsbyrå" "fastighetsbyråer" ;
  fastighetskris_nn_1_N = mkN "fastighetskris" "fastighetskriser" ;
  fastighetsskatt_nn_1_N = mkN "fastighetsskatt" "fastighetsskatter" ;
  fastighetsspekulation_nn_1_N = mkN "fastighetsspekulation" "fastighetsspekulationer" ;
  fatalism_nn_1_N = mkN "fatalism" "fatalismer" ;
  fatalist_nn_1_N = mkN "fatalist" "fatalister" ;
  fatalitet_nn_1_N = mkN "fatalitet" "fataliteter" ;
  fattbarhet_nn_1_N = mkN "fattbarhet" "fattbarheter" ;
  faunist_nn_1_N = mkN "faunist" "faunister" ;
  favorit_nn_1_N = mkN "favorit" "favoriter" ;
  favoritaccessoar_nn_1_N = mkN "favoritaccessoar" "favoritaccessoarer" ;
  favoritbild_nn_1_N = mkN "favoritbild" "favoritbilder" ;
  favoritrestaurang_nn_1_N = mkN "favoritrestaurang" "favoritrestauranger" ;
  favoritraett_nn_1_1_N = mkN "favoriträtt" "favoriträtter" ;
  februarioffensiv_nn_1_N = mkN "februarioffensiv" "februarioffensiver" ;
  federalism_nn_1_N = mkN "federalism" "federalismer" ;
  federalist_nn_1_N = mkN "federalist" "federalister" ;
  federation_nn_1_N = mkN "federation" "federationer" ;
  feghet_nn_1_N = mkN "feghet" "fegheter" ;
  felaktighet_nn_1_N = mkN "felaktighet" "felaktigheter" ;
  feldiagnos_nn_1_N = mkN "feldiagnos" "feldiagnoser" ;
  femdygnsprognos_nn_1_N = mkN "femdygnsprognos" "femdygnsprognoser" ;
  femininform_nn_1_N = mkN "femininform" "femininformer" ;
  feminism_nn_1_N = mkN "feminism" "feminismer" ;
  feminist_nn_1_N = mkN "feminist" "feminister" ;
  fempunktsplan_nn_1_N = mkN "fempunktsplan" "fempunktsplaner" ;
  femrumslaegenhet_nn_1_1_N = mkN "femrumslägenhet" "femrumslägenheter" ;
  femtiotalist_nn_1_N = mkN "femtiotalist" "femtiotalister" ;
  femtitalist_nn_1_N = mkN "femtitalist" "femtitalister" ;
  femtocell_nn_1_N = mkN "femtocell" "femtoceller" ;
  femaarsplan_nn_1_1_N = mkN "femårsplan" "femårsplaner" ;
  fennicism_nn_1_N = mkN "fennicism" "fennicismer" ;
  fennoman_nn_1_N = mkN "fennoman" "fennomaner" ;
  fenol_nn_1_N = mkN "fenol" "fenoler" ;
  fenomenalism_nn_1_N = mkN "fenomenalism" "fenomenalismer" ;
  fenoplast_nn_1_N = mkN "fenoplast" "fenoplaster" ;
  feodalism_nn_1_N = mkN "feodalism" "feodalismer" ;
  fermitet_nn_1_N = mkN "fermitet" "fermiteter" ;
  ferrit_nn_1_N = mkN "ferrit" "ferriter" ;
  fertilitet_nn_1_N = mkN "fertilitet" "fertiliteter" ;
  fest_nn_1_N = mkN "fest" "fester" ;
  festarrangoer_nn_1_1_N = mkN "festarrangör" "festarrangörer" ;
  festdraekt_nn_1_1_N = mkN "festdräkt" "festdräkter" ;
  festivitet_nn_1_N = mkN "festivitet" "festiviteter" ;
  festkamrat_nn_1_N = mkN "festkamrat" "festkamrater" ;
  festlighet_nn_1_N = mkN "festlighet" "festligheter" ;
  festmaaltid_nn_1_1_N = mkN "festmåltid" "festmåltider" ;
  feston_nn_1_N = mkN "feston" "festoner" ;
  festskrift_nn_1_N = mkN "festskrift" "festskrifter" ;
  fetisch_nn_1_N = mkN "fetisch" "fetischer" ;
  fetischism_nn_1_N = mkN "fetischism" "fetischismer" ;
  fetischist_nn_1_N = mkN "fetischist" "fetischister" ;
  fets_nn_1_N = mkN "fets" "fetser" ;
  fetthalt_nn_1_N = mkN "fetthalt" "fetthalter" ;
  fettloeslighet_nn_1_1_N = mkN "fettlöslighet" "fettlösligheter" ;
  fettvaevnad_nn_1_1_N = mkN "fettvävnad" "fettvävnader" ;
  fez_nn_1_N = mkN "fez" "fezer" ;
  fial_nn_1_N = mkN "fial" "fialer" ;
  fiaskokonferens_nn_1_N = mkN "fiaskokonferens" "fiaskokonferenser" ;
  fibertillsats_nn_1_N = mkN "fibertillsats" "fibertillsatser" ;
  fibervaext_nn_1_1_N = mkN "fiberväxt" "fiberväxter" ;
  fibrinogen_nn_1_N = mkN "fibrinogen" "fibrinogener" ;
  fickhandbok_nn_1_N = mkN "fickhandbok" "fickhandböcker" ;
  fickkalkylator_nn_1_N = mkN "fickkalkylator" "fickkalkylatorer" ;
  fickstoeld_nn_1_1_N = mkN "fickstöld" "fickstölder" ;
  fidjian_nn_1_N = mkN "fidjian" "fidjianer" ;
  fiendearm_e_nn_1_1_N = mkN "fiendearmé" "fiendearméer" ;
  fiendesoldat_nn_1_N = mkN "fiendesoldat" "fiendesoldater" ;
  fientlighet_nn_1_N = mkN "fientlighet" "fientligheter" ;
  fiffighet_nn_1_N = mkN "fiffighet" "fiffigheter" ;
  fight_nn_1_N = mkN "fight" "fighter" ;
  figur_nn_1_N = mkN "figur" "figurer" ;
  figurant_nn_1_N = mkN "figurant" "figuranter" ;
  figuration_nn_1_N = mkN "figuration" "figurationer" ;
  fijian_nn_1_N = mkN "fijian" "fijianer" ;
  fikapaus_nn_1_N = mkN "fikapaus" "fikapauser" ;
  fiktion_nn_1_N = mkN "fiktion" "fiktioner" ;
  fiktionalism_nn_1_N = mkN "fiktionalism" "fiktionalismer" ;
  fil_nn_1_N = mkN "fil" "filer" ;
  filantrop_nn_1_N = mkN "filantrop" "filantroper" ;
  filatelist_nn_1_N = mkN "filatelist" "filatelister" ;
  file_nn_1_N = mkN "file" "fileer" ;
  filipin_nn_1_N = mkN "filipin" "filipiner" ;
  film_nn_1_N = mkN "film" "filmer" ;
  filmaffisch_nn_1_N = mkN "filmaffisch" "filmaffischer" ;
  filmaskin_nn_1_N = mkN "filmaskin" "filmaskiner" ;
  filmatelj_e_nn_1_1_N = mkN "filmateljé" "filmateljéer" ;
  filmbild_nn_1_N = mkN "filmbild" "filmbilder" ;
  filmdebut_nn_1_N = mkN "filmdebut" "filmdebuter" ;
  filmexpert_nn_1_N = mkN "filmexpert" "filmexperter" ;
  filmfars_nn_1_N = mkN "filmfars" "filmfarser" ;
  filmfestival_nn_1_N = mkN "filmfestival" "filmfestivaler" ;
  filmmatin_e_nn_1_1_N = mkN "filmmatiné" "filmmatinéer" ;
  filmpremiaer_nn_1_1_N = mkN "filmpremiär" "filmpremiärer" ;
  filmproducent_nn_1_N = mkN "filmproducent" "filmproducenter" ;
  filmprofessor_nn_1_N = mkN "filmprofessor" "filmprofessorer" ;
  filmtidskrift_nn_1_N = mkN "filmtidskrift" "filmtidskrifter" ;
  filmversion_nn_1_N = mkN "filmversion" "filmversioner" ;
  filmvetenskap_nn_1_N = mkN "filmvetenskap" "filmvetenskaper" ;
  filolog_nn_1_N = mkN "filolog" "filologer" ;
  fil_e_nn_1_1_N = mkN "filé" "filéer" ;
  finalist_nn_1_N = mkN "finalist" "finalister" ;
  finalplats_nn_1_N = mkN "finalplats" "finalplatser" ;
  finanschef_nn_1_N = mkN "finanschef" "finanschefer" ;
  finansinspektion_nn_1_N = mkN "finansinspektion" "finansinspektioner" ;
  finanskrasch_nn_1_N = mkN "finanskrasch" "finanskrascher" ;
  finanskris_nn_1_N = mkN "finanskris" "finanskriser" ;
  finansmarknad_nn_1_N = mkN "finansmarknad" "finansmarknader" ;
  finansplan_nn_1_N = mkN "finansplan" "finansplaner" ;
  finess_nn_1_N = mkN "finess" "finesser" ;
  fingerbredd_nn_1_N = mkN "fingerbredd" "fingerbredder" ;
  fingerfaerg_nn_1_1_N = mkN "fingerfärg" "fingerfärger" ;
  fingerled_nn_1_N = mkN "fingerled" "fingerleder" ;
  fingertoppsnyans_nn_1_N = mkN "fingertoppsnyans" "fingertoppsnyanser" ;
  fingeroert_nn_1_1_N = mkN "fingerört" "fingerörter" ;
  finhet_nn_2_N = mkN "finhet" "finheter" ;
  finkart_nn_1_N = mkN "finkart" "finkarter" ;
  finkaenslighet_nn_1_1_N = mkN "finkänslighet" "finkänsligheter" ;
  finlandism_nn_1_N = mkN "finlandism" "finlandismer" ;
  finnkamp_nn_1_N = mkN "finnkamp" "finnkamper" ;
  finskhet_nn_1_N = mkN "finskhet" "finskheter" ;
  finstruktur_nn_1_N = mkN "finstruktur" "finstrukturer" ;
  fintlighet_nn_1_N = mkN "fintlighet" "fintligheter" ;
  finurlighet_nn_1_N = mkN "finurlighet" "finurligheter" ;
  fioritur_nn_1_N = mkN "fioritur" "fioriturer" ;
  firmafest_nn_1_N = mkN "firmafest" "firmafester" ;
  firngraens_nn_1_1_N = mkN "firngräns" "firngränser" ;
  fischy_nn_1_N = mkN "fischy" "fischyer" ;
  fiskal_nn_1_N = mkN "fiskal" "fiskaler" ;
  fiskart_nn_1_N = mkN "fiskart" "fiskarter" ;
  fiskegraens_nn_1_1_N = mkN "fiskegräns" "fiskegränser" ;
  fiskenation_nn_1_N = mkN "fiskenation" "fiskenationer" ;
  fiskfil_e_nn_1_1_N = mkN "fiskfilé" "fiskfiléer" ;
  fiskfaers_nn_1_1_N = mkN "fiskfärs" "fiskfärser" ;
  fiskfaangst_nn_1_1_N = mkN "fiskfångst" "fiskfångster" ;
  fiskmaaltid_nn_1_1_N = mkN "fiskmåltid" "fiskmåltider" ;
  fiskraett_nn_1_1_N = mkN "fiskrätt" "fiskrätter" ;
  fisksaas_nn_1_1_N = mkN "fisksås" "fisksåser" ;
  fission_nn_1_N = mkN "fission" "fissioner" ;
  fissur_nn_1_N = mkN "fissur" "fissurer" ;
  fittrakt_nn_1_N = mkN "fittrakt" "fittrakter" ;
  fixeringsbild_nn_1_N = mkN "fixeringsbild" "fixeringsbilder" ;
  fixpunkt_nn_1_N = mkN "fixpunkt" "fixpunkter" ;
  fixtur_nn_1_N = mkN "fixtur" "fixturer" ;
  fjollighet_nn_1_N = mkN "fjollighet" "fjolligheter" ;
  fjaederdraekt_nn_1_1_N = mkN "fjäderdräkt" "fjäderdräkter" ;
  fjaedertyp_nn_1_1_N = mkN "fjädertyp" "fjädertyper" ;
  fjaedringsmekanism_nn_1_1_N = mkN "fjädringsmekanism" "fjädringsmekanismer" ;
  fjaellbilist_nn_1_1_N = mkN "fjällbilist" "fjällbilister" ;
  fjaellplataa_nn_1_1_N = mkN "fjällplatå" "fjällplatåer" ;
  fjaellturist_nn_1_1_N = mkN "fjällturist" "fjällturister" ;
  fjaerdegradsekvation_nn_1_1_N = mkN "fjärdegradsekvation" "fjärdegradsekvationer" ;
  fjaerilsart_nn_1_1_N = mkN "fjärilsart" "fjärilsarter" ;
  fjaerrkontroll_nn_1_1_N = mkN "fjärrkontroll" "fjärrkontroller" ;
  fjaerrpunkt_nn_1_1_N = mkN "fjärrpunkt" "fjärrpunkter" ;
  fjaerrskrivmaskin_nn_1_1_N = mkN "fjärrskrivmaskin" "fjärrskrivmaskiner" ;
  flackbanepjaes_nn_1_1_N = mkN "flackbanepjäs" "flackbanepjäser" ;
  flagellant_nn_1_N = mkN "flagellant" "flagellanter" ;
  flaggvakt_nn_1_N = mkN "flaggvakt" "flaggvakter" ;
  flamencogitarrist_nn_1_N = mkN "flamencogitarrist" "flamencogitarrister" ;
  flamskvaevnad_nn_1_1_N = mkN "flamskvävnad" "flamskvävnader" ;
  flasknosdelfin_nn_1_N = mkN "flasknosdelfin" "flasknosdelfiner" ;
  flatulens_nn_1_N = mkN "flatulens" "flatulenser" ;
  flektion_nn_1_N = mkN "flektion" "flektioner" ;
  flerbarnsfamilj_nn_1_N = mkN "flerbarnsfamilj" "flerbarnsfamiljer" ;
  flerhet_nn_1_N = mkN "flerhet" "flerheter" ;
  flerordsenhet_nn_1_N = mkN "flerordsenhet" "flerordsenheter" ;
  flexion_nn_1_N = mkN "flexion" "flexioner" ;
  flexur_nn_1_N = mkN "flexur" "flexurer" ;
  flickbok_nn_1_N = mkN "flickbok" "flickböcker" ;
  flickbokstradition_nn_1_N = mkN "flickbokstradition" "flickbokstraditioner" ;
  flickkoer_nn_1_1_N = mkN "flickkör" "flickkörer" ;
  flickmatch_nn_1_N = mkN "flickmatch" "flickmatcher" ;
  flickpension_nn_1_N = mkN "flickpension" "flickpensioner" ;
  flickroest_nn_1_1_N = mkN "flickröst" "flickröster" ;
  flight_nn_1_N = mkN "flight" "flighter" ;
  flimmercell_nn_1_N = mkN "flimmercell" "flimmerceller" ;
  flockinstinkt_nn_1_N = mkN "flockinstinkt" "flockinstinkter" ;
  flodterrass_nn_1_N = mkN "flodterrass" "flodterrasser" ;
  florettfaektningskurs_nn_1_1_N = mkN "florettfäktningskurs" "florettfäktningskurser" ;
  florin_nn_1_N = mkN "florin" "floriner" ;
  florist_nn_1_N = mkN "florist" "florister" ;
  floskelpatriot_nn_1_N = mkN "floskelpatriot" "floskelpatrioter" ;
  flotation_nn_1_N = mkN "flotation" "flotationer" ;
  flottbas_nn_1_N = mkN "flottbas" "flottbaser" ;
  flottenhet_nn_1_N = mkN "flottenhet" "flottenheter" ;
  flottist_nn_1_N = mkN "flottist" "flottister" ;
  flottled_nn_1_N = mkN "flottled" "flottleder" ;
  flottstrateg_nn_1_N = mkN "flottstrateg" "flottstrateger" ;
  fluffighet_nn_1_N = mkN "fluffighet" "fluffigheter" ;
  fluid_nn_1_N = mkN "fluid" "fluider" ;
  fluktuation_nn_1_N = mkN "fluktuation" "fluktuationer" ;
  fluorhalt_nn_1_N = mkN "fluorhalt" "fluorhalter" ;
  fluorid_nn_1_N = mkN "fluorid" "fluorider" ;
  fluss_nn_1_N = mkN "fluss" "flusser" ;
  flygankomst_nn_1_N = mkN "flygankomst" "flygankomster" ;
  flygattach_e_nn_1_1_N = mkN "flygattaché" "flygattachéer" ;
  flygattack_nn_1_N = mkN "flygattack" "flygattacker" ;
  flygbas_nn_1_N = mkN "flygbas" "flygbaser" ;
  flygbasbarack_nn_1_N = mkN "flygbasbarack" "flygbasbaracker" ;
  flygbild_nn_1_N = mkN "flygbild" "flygbilder" ;
  flygbomb_nn_1_N = mkN "flygbomb" "flygbomber" ;
  flygelbyggnad_nn_1_N = mkN "flygelbyggnad" "flygelbyggnader" ;
  flygfaerd_nn_1_1_N = mkN "flygfärd" "flygfärder" ;
  flygfoerbudszon_nn_1_1_N = mkN "flygförbudszon" "flygförbudszoner" ;
  flyghastighet_nn_1_N = mkN "flyghastighet" "flyghastigheter" ;
  flygkapacitet_nn_1_N = mkN "flygkapacitet" "flygkapaciteter" ;
  flygkatastrof_nn_1_N = mkN "flygkatastrof" "flygkatastrofer" ;
  flygkonst_nn_1_N = mkN "flygkonst" "flygkonster" ;
  flygkaar_nn_1_1_N = mkN "flygkår" "flygkårer" ;
  flygledarstrejk_nn_1_N = mkN "flygledarstrejk" "flygledarstrejker" ;
  flyglaegenhet_nn_1_1_N = mkN "flyglägenhet" "flyglägenheter" ;
  flygplanskabin_nn_1_N = mkN "flygplanskabin" "flygplanskabiner" ;
  flygplats_nn_1_N = mkN "flygplats" "flygplatser" ;
  flygraed_nn_1_1_N = mkN "flygräd" "flygräder" ;
  flygskrift_nn_1_N = mkN "flygskrift" "flygskrifter" ;
  flygsaekerhetsexpert_nn_1_1_N = mkN "flygsäkerhetsexpert" "flygsäkerhetsexperter" ;
  flygsaekerhetskonsult_nn_1_1_N = mkN "flygsäkerhetskonsult" "flygsäkerhetskonsulter" ;
  flygterminal_nn_1_N = mkN "flygterminal" "flygterminaler" ;
  flygtidtabell_nn_1_N = mkN "flygtidtabell" "flygtidtabeller" ;
  flygtransport_nn_1_N = mkN "flygtransport" "flygtransporter" ;
  flygtur_nn_1_N = mkN "flygtur" "flygturer" ;
  flygvapenchef_nn_1_N = mkN "flygvapenchef" "flygvapenchefer" ;
  flyktighet_nn_2_N = mkN "flyktighet" "flyktigheter" ;
  flyktingfamilj_nn_1_N = mkN "flyktingfamilj" "flyktingfamiljer" ;
  flyktmekanism_nn_1_N = mkN "flyktmekanism" "flyktmekanismer" ;
  flyktmoejlighet_nn_1_1_N = mkN "flyktmöjlighet" "flyktmöjligheter" ;
  flyktreaktion_nn_1_N = mkN "flyktreaktion" "flyktreaktioner" ;
  flyktrisk_nn_1_N = mkN "flyktrisk" "flyktrisker" ;
  flyttkartong_nn_1_N = mkN "flyttkartong" "flyttkartonger" ;
  flaerdfullhet_nn_1_1_N = mkN "flärdfullhet" "flärdfullheter" ;
  flaerdloeshet_nn_1_1_N = mkN "flärdlöshet" "flärdlösheter" ;
  flaeskfil_e_nn_1_1_N = mkN "fläskfilé" "fläskfiléer" ;
  flaeskfaers_nn_1_1_N = mkN "fläskfärs" "fläskfärser" ;
  flaeskkarr_e_nn_1_1_N = mkN "fläskkarré" "fläskkarréer" ;
  floejtist_nn_1_1_N = mkN "flöjtist" "flöjtister" ;
  floejtton_nn_1_1_N = mkN "flöjtton" "flöjttoner" ;
  floert_nn_1_1_N = mkN "flört" "flörter" ;
  floets_nn_1_1_N = mkN "flöts" "flötser" ;
  fnoskighet_nn_1_N = mkN "fnoskighet" "fnoskigheter" ;
  foaje_nn_1_N = mkN "foaje" "foajeer" ;
  foaj_e_nn_1_1_N = mkN "foajé" "foajéer" ;
  fockmast_nn_1_N = mkN "fockmast" "fockmaster" ;
  fodermark_nn_1_N = mkN "fodermark" "fodermarker" ;
  fodermaengd_nn_1_1_N = mkN "fodermängd" "fodermängder" ;
  fodervaext_nn_1_1_N = mkN "foderväxt" "foderväxter" ;
  fokaldistans_nn_1_N = mkN "fokaldistans" "fokaldistanser" ;
  foliant_nn_1_N = mkN "foliant" "folianter" ;
  folkarm_e_nn_1_1_N = mkN "folkarmé" "folkarméer" ;
  folkbank_nn_1_N = mkN "folkbank" "folkbanker" ;
  folkbildningstidskrift_nn_1_N = mkN "folkbildningstidskrift" "folkbildningstidskrifter" ;
  folkbok_nn_1_N = mkN "folkbok" "folkböcker" ;
  folkdans_nn_1_N = mkN "folkdans" "folkdanser" ;
  folkdikt_nn_1_N = mkN "folkdikt" "folkdikter" ;
  folkdraekt_nn_1_1_N = mkN "folkdräkt" "folkdräkter" ;
  folkfest_nn_1_N = mkN "folkfest" "folkfester" ;
  folkgrupp_nn_1_N = mkN "folkgrupp" "folkgrupper" ;
  folkhemsidyll_nn_1_N = mkN "folkhemsidyll" "folkhemsidyller" ;
  folkkongress_nn_1_N = mkN "folkkongress" "folkkongresser" ;
  folklighet_nn_1_N = mkN "folklighet" "folkligheter" ;
  folklorist_nn_1_N = mkN "folklorist" "folklorister" ;
  folkopinion_nn_1_N = mkN "folkopinion" "folkopinioner" ;
  folkpartist_nn_1_N = mkN "folkpartist" "folkpartister" ;
  folkpension_nn_1_N = mkN "folkpension" "folkpensioner" ;
  folkpensionaer_nn_1_1_N = mkN "folkpensionär" "folkpensionärer" ;
  folkrepresentant_nn_1_N = mkN "folkrepresentant" "folkrepresentanter" ;
  folkrepresentation_nn_1_N = mkN "folkrepresentation" "folkrepresentationer" ;
  folksaang_nn_1_1_N = mkN "folksång" "folksånger" ;
  folktaethet_nn_1_1_N = mkN "folktäthet" "folktätheter" ;
  folkvettsexpert_nn_1_N = mkN "folkvettsexpert" "folkvettsexperter" ;
  folkviseton_nn_1_N = mkN "folkviseton" "folkvisetoner" ;
  fon_nn_1_N = mkN "fon" "foner" ;
  fond_nn_1_N = mkN "fond" "fonder" ;
  fond_nn_2_N = mkN "fond" "fonder" ;
  fondboers_nn_1_1_N = mkN "fondbörs" "fondbörser" ;
  fondemission_nn_1_N = mkN "fondemission" "fondemissioner" ;
  fondkommissionaer_nn_1_1_N = mkN "fondkommissionär" "fondkommissionärer" ;
  fondy_nn_1_N = mkN "fondy" "fondyer" ;
  font_nn_1_N = mkN "font" "fonter" ;
  fordonskolonn_nn_1_N = mkN "fordonskolonn" "fordonskolonner" ;
  fordonsvikt_nn_1_N = mkN "fordonsvikt" "fordonsvikter" ;
  form_nn_2_N = mkN "form" "former" ;
  formaldehyd_nn_1_N = mkN "formaldehyd" "formaldehyder" ;
  formalism_nn_1_N = mkN "formalism" "formalismer" ;
  formalist_nn_1_N = mkN "formalist" "formalister" ;
  formalitet_nn_1_N = mkN "formalitet" "formaliteter" ;
  formant_nn_1_N = mkN "formant" "formanter" ;
  formation_nn_1_N = mkN "formation" "formationer" ;
  formelenhet_nn_1_N = mkN "formelenhet" "formelenheter" ;
  formsak_nn_1_N = mkN "formsak" "formsaker" ;
  fornsak_nn_1_N = mkN "fornsak" "fornsaker" ;
  forsfaerd_nn_1_1_N = mkN "forsfärd" "forsfärder" ;
  forskargrupp_nn_1_N = mkN "forskargrupp" "forskargrupper" ;
  forskarkonspiration_nn_1_N = mkN "forskarkonspiration" "forskarkonspirationer" ;
  forskarledighet_nn_1_N = mkN "forskarledighet" "forskarledigheter" ;
  forskningsfaerd_nn_1_1_N = mkN "forskningsfärd" "forskningsfärder" ;
  forskningsingenjoer_nn_1_1_N = mkN "forskningsingenjör" "forskningsingenjörer" ;
  forskningsinsats_nn_1_N = mkN "forskningsinsats" "forskningsinsatser" ;
  forskningskompetens_nn_1_N = mkN "forskningskompetens" "forskningskompetenser" ;
  forskningsmetodik_nn_1_N = mkN "forskningsmetodik" "forskningsmetodiker" ;
  forskningsorganisation_nn_1_N = mkN "forskningsorganisation" "forskningsorganisationer" ;
  forskningsprocess_nn_1_N = mkN "forskningsprocess" "forskningsprocesser" ;
  forskningsstation_nn_1_N = mkN "forskningsstation" "forskningsstationer" ;
  fortbildningskurs_nn_1_N = mkN "fortbildningskurs" "fortbildningskurser" ;
  fortifikation_nn_1_N = mkN "fortifikation" "fortifikationer" ;
  fortifikationskaar_nn_1_1_N = mkN "fortifikationskår" "fortifikationskårer" ;
  fortkomst_nn_1_N = mkN "fortkomst" "fortkomster" ;
  fosforit_nn_1_N = mkN "fosforit" "fosforiter" ;
  fosforsyracell_nn_1_N = mkN "fosforsyracell" "fosforsyraceller" ;
  fossilisation_nn_1_N = mkN "fossilisation" "fossilisationer" ;
  fossilletarexpedition_nn_1_N = mkN "fossilletarexpedition" "fossilletarexpeditioner" ;
  fosterfamilj_nn_1_N = mkN "fosterfamilj" "fosterfamiljer" ;
  fot_nn_1_N = mkN "fot" "fötter" ;
  fotbollsexpert_nn_1_N = mkN "fotbollsexpert" "fotbollsexperter" ;
  fotbollshuligan_nn_1_N = mkN "fotbollshuligan" "fotbollshuliganer" ;
  fotbollsmatch_nn_1_N = mkN "fotbollsmatch" "fotbollsmatcher" ;
  fotbollsplan_nn_1_N = mkN "fotbollsplan" "fotbollsplaner" ;
  fotled_nn_1_N = mkN "fotled" "fotleder" ;
  fotnot_nn_1_N = mkN "fotnot" "fotnoter" ;
  fotoaffaer_nn_1_1_N = mkN "fotoaffär" "fotoaffärer" ;
  fotoatelj_e_nn_1_1_N = mkN "fotoateljé" "fotoateljéer" ;
  fotoelektricitet_nn_1_N = mkN "fotoelektricitet" "fotoelektriciteter" ;
  fotogenmotor_nn_1_N = mkN "fotogenmotor" "fotogenmotorer" ;
  foton_nn_1_N = mkN "foton" "fotoner" ;
  fotoresistor_nn_1_N = mkN "fotoresistor" "fotoresistorer" ;
  fotosfaer_nn_1_1_N = mkN "fotosfär" "fotosfärer" ;
  fotosyntes_nn_1_N = mkN "fotosyntes" "fotosynteser" ;
  fotpedal_nn_1_N = mkN "fotpedal" "fotpedaler" ;
  fotsoldat_nn_1_N = mkN "fotsoldat" "fotsoldater" ;
  fotvaardssalong_nn_1_1_N = mkN "fotvårdssalong" "fotvårdssalonger" ;
  fraktion_nn_1_N = mkN "fraktion" "fraktioner" ;
  fraktkostnad_nn_1_N = mkN "fraktkostnad" "fraktkostnader" ;
  fraktsats_nn_1_N = mkN "fraktsats" "fraktsatser" ;
  fraktterminal_nn_1_N = mkN "fraktterminal" "fraktterminaler" ;
  fraktur_nn_2_N = mkN "fraktur" "frakturer" ;
  framextremitet_nn_1_N = mkN "framextremitet" "framextremiteter" ;
  framfaerd_nn_1_1_N = mkN "framfärd" "framfärder" ;
  framgaangsevangelist_nn_1_1_N = mkN "framgångsevangelist" "framgångsevangelister" ;
  framkant_nn_1_N = mkN "framkant" "framkanter" ;
  framkomlighet_nn_1_N = mkN "framkomlighet" "framkomligheter" ;
  frammarsch_nn_1_N = mkN "frammarsch" "frammarscher" ;
  framstegsoptimism_nn_1_N = mkN "framstegsoptimism" "framstegsoptimismer" ;
  framtid_nn_1_N = mkN "framtid" "framtider" ;
  framtidsbild_nn_1_N = mkN "framtidsbild" "framtidsbilder" ;
  framtidsbransch_nn_1_N = mkN "framtidsbransch" "framtidsbranscher" ;
  framtidskalkyl_nn_1_N = mkN "framtidskalkyl" "framtidskalkyler" ;
  framtidsplan_nn_1_N = mkN "framtidsplan" "framtidsplaner" ;
  framtidssyn_nn_1_N = mkN "framtidssyn" "framtidssyner" ;
  framtidsutsikt_nn_1_N = mkN "framtidsutsikt" "framtidsutsikter" ;
  framtidsversion_nn_1_N = mkN "framtidsversion" "framtidsversioner" ;
  framtidsvision_nn_1_N = mkN "framtidsvision" "framtidsvisioner" ;
  framtidsvy_nn_1_N = mkN "framtidsvy" "framtidsvyer" ;
  franciskan_nn_1_N = mkN "franciskan" "franciskaner" ;
  frank_nn_1_N = mkN "frank" "franker" ;
  frankist_nn_1_N = mkN "frankist" "frankister" ;
  franskklassicism_nn_1_N = mkN "franskklassicism" "franskklassicismer" ;
  franskkurs_nn_1_N = mkN "franskkurs" "franskkurser" ;
  fransklektion_nn_1_N = mkN "fransklektion" "fransklektioner" ;
  fransos_nn_1_N = mkN "fransos" "fransoser" ;
  fransaes_nn_1_1_N = mkN "fransäs" "fransäser" ;
  fras_nn_1_N = mkN "fras" "fraser" ;
  fred_nn_1_N = mkN "fred" "freder" ;
  fredagsboen_nn_1_1_N = mkN "fredagsbön" "fredagsböner" ;
  fredagsboers_nn_1_1_N = mkN "fredagsbörs" "fredagsbörser" ;
  fredsaktivist_nn_1_N = mkN "fredsaktivist" "fredsaktivister" ;
  fredskonferens_nn_1_N = mkN "fredskonferens" "fredskonferenser" ;
  fredskongress_nn_1_N = mkN "fredskongress" "fredskongresser" ;
  fredskaar_nn_1_1_N = mkN "fredskår" "fredskårer" ;
  fredspristagarfavorit_nn_1_N = mkN "fredspristagarfavorit" "fredspristagarfavoriter" ;
  fredsprocess_nn_1_N = mkN "fredsprocess" "fredsprocesser" ;
  fredstid_nn_1_N = mkN "fredstid" "fredstider" ;
  frekvens_nn_1_N = mkN "frekvens" "frekvenser" ;
  freon_nn_1_N = mkN "freon" "freoner" ;
  fresk_nn_1_N = mkN "fresk" "fresker" ;
  friarfaerd_nn_1_1_N = mkN "friarfärd" "friarfärder" ;
  frigiditet_nn_1_N = mkN "frigiditet" "frigiditeter" ;
  frigivningsnaemnd_nn_1_1_N = mkN "frigivningsnämnd" "frigivningsnämnder" ;
  frigjordhet_nn_1_N = mkN "frigjordhet" "frigjordheter" ;
  frihet_nn_1_N = mkN "frihet" "friheter" ;
  frihetsgrad_nn_1_N = mkN "frihetsgrad" "frihetsgrader" ;
  frihetssymbol_nn_1_N = mkN "frihetssymbol" "frihetssymboler" ;
  friidrott_nn_1_N = mkN "friidrott" "friidrotter" ;
  frikass_e_nn_1_1_N = mkN "frikassé" "frikasséer" ;
  friktion_nn_1_N = mkN "friktion" "friktioner" ;
  frikyrklighet_nn_1_N = mkN "frikyrklighet" "frikyrkligheter" ;
  frikyrkopastor_nn_1_N = mkN "frikyrkopastor" "frikyrkopastorer" ;
  frikaar_nn_1_1_N = mkN "frikår" "frikårer" ;
  frilansjournalist_nn_1_N = mkN "frilansjournalist" "frilansjournalister" ;
  friplats_nn_1_N = mkN "friplats" "friplatser" ;
  fris_nn_1_N = mkN "fris" "friser" ;
  fris_2_nn_1_N = mkN "fris" "friser" ;
  frisersalong_nn_1_N = mkN "frisersalong" "frisersalonger" ;
  frispraakighet_nn_1_1_N = mkN "frispråkighet" "frispråkigheter" ;
  frist_nn_1_N = mkN "frist" "frister" ;
  fristat_nn_1_N = mkN "fristat" "fristater" ;
  frisoer_nn_1_1_N = mkN "frisör" "frisörer" ;
  frisoersalong_nn_1_1_N = mkN "frisörsalong" "frisörsalonger" ;
  fritidsaktivitet_nn_1_N = mkN "fritidsaktivitet" "fritidsaktiviteter" ;
  fritidsnaemnd_nn_1_1_N = mkN "fritidsnämnd" "fritidsnämnder" ;
  frivillighet_nn_1_N = mkN "frivillighet" "frivilligheter" ;
  frivilligorganisation_nn_1_N = mkN "frivilligorganisation" "frivilligorganisationer" ;
  frivolitet_nn_1_N = mkN "frivolitet" "frivoliteter" ;
  frizon_nn_1_N = mkN "frizon" "frizoner" ;
  fromhet_nn_1_N = mkN "fromhet" "fromheter" ;
  frontespis_nn_1_N = mkN "frontespis" "frontespiser" ;
  fronton_nn_1_N = mkN "fronton" "frontoner" ;
  frontong_nn_1_N = mkN "frontong" "frontonger" ;
  frontsoldat_nn_1_N = mkN "frontsoldat" "frontsoldater" ;
  frontzon_nn_1_N = mkN "frontzon" "frontzoner" ;
  frosch_nn_1_N = mkN "frosch" "froscher" ;
  frosthaerdighet_nn_1_1_N = mkN "frosthärdighet" "frosthärdigheter" ;
  frostkaenslighet_nn_1_1_N = mkN "frostkänslighet" "frostkänsligheter" ;
  frott_e_nn_1_1_N = mkN "frotté" "frottéer" ;
  frukostbuff_e_nn_1_1_N = mkN "frukostbuffé" "frukostbufféer" ;
  frukostmeny_nn_1_N = mkN "frukostmeny" "frukostmenyer" ;
  frukostrast_nn_1_N = mkN "frukostrast" "frukostraster" ;
  frukt_nn_1_N = mkN "frukt" "frukter" ;
  fruktaffaer_nn_1_1_N = mkN "fruktaffär" "fruktaffärer" ;
  fruktbarhet_nn_1_N = mkN "fruktbarhet" "fruktbarheter" ;
  fruktsallad_nn_1_N = mkN "fruktsallad" "fruktsallader" ;
  fruktsmak_nn_1_N = mkN "fruktsmak" "fruktsmaker" ;
  fruktsaas_nn_1_1_N = mkN "fruktsås" "fruktsåser" ;
  frustration_nn_1_N = mkN "frustration" "frustrationer" ;
  fryntlighet_nn_1_N = mkN "fryntlighet" "fryntligheter" ;
  fraeckhet_nn_1_1_N = mkN "fräckhet" "fräckheter" ;
  fraemlingslegion_nn_1_1_N = mkN "främlingslegion" "främlingslegioner" ;
  fraageform_nn_1_1_N = mkN "frågeform" "frågeformer" ;
  fraagementalitet_nn_1_1_N = mkN "frågementalitet" "frågementaliteter" ;
  fraagesats_nn_1_1_N = mkN "frågesats" "frågesatser" ;
  fraagesport_nn_1_1_N = mkN "frågesport" "frågesporter" ;
  fraageton_nn_1_1_N = mkN "frågeton" "frågetoner" ;
  froejd_nn_1_1_N = mkN "fröjd" "fröjder" ;
  froevaext_nn_1_1_N = mkN "fröväxt" "fröväxter" ;
  ftalat_nn_1_N = mkN "ftalat" "ftalater" ;
  fuktighet_nn_1_N = mkN "fuktighet" "fuktigheter" ;
  fulhet_nn_1_N = mkN "fulhet" "fulheter" ;
  fulkultur_nn_1_N = mkN "fulkultur" "fulkulturer" ;
  fullblodsindian_nn_1_N = mkN "fullblodsindian" "fullblodsindianer" ;
  fulleren_nn_1_N = mkN "fulleren" "fullerener" ;
  fullkomlighet_nn_1_N = mkN "fullkomlighet" "fullkomligheter" ;
  fullmakt_nn_1_N = mkN "fullmakt" "fullmakter" ;
  fullstaendighet_nn_1_1_N = mkN "fullständighet" "fullständigheter" ;
  fulloedighet_nn_1_1_N = mkN "fullödighet" "fullödigheter" ;
  fumlighet_nn_1_N = mkN "fumlighet" "fumligheter" ;
  fundamentalism_nn_1_N = mkN "fundamentalism" "fundamentalismer" ;
  fundamentalist_nn_1_N = mkN "fundamentalist" "fundamentalister" ;
  fundamentalsats_nn_1_N = mkN "fundamentalsats" "fundamentalsatser" ;
  funktion_nn_1_N = mkN "funktion" "funktioner" ;
  funktionalism_nn_1_N = mkN "funktionalism" "funktionalismer" ;
  funktionalist_nn_1_N = mkN "funktionalist" "funktionalister" ;
  furstlighet_nn_1_N = mkN "furstlighet" "furstligheter" ;
  fusion_nn_1_N = mkN "fusion" "fusioner" ;
  futilitet_nn_1_N = mkN "futilitet" "futiliteter" ;
  futtighet_nn_1_N = mkN "futtighet" "futtigheter" ;
  futurism_nn_1_N = mkN "futurism" "futurismer" ;
  futurist_nn_1_N = mkN "futurist" "futurister" ;
  futurolog_nn_1_N = mkN "futurolog" "futurologer" ;
  fyllerist_nn_1_N = mkN "fyllerist" "fyllerister" ;
  fyllnad_nn_1_N = mkN "fyllnad" "fyllnader" ;
  fyndighet_nn_1_N = mkN "fyndighet" "fyndigheter" ;
  fyndort_nn_1_N = mkN "fyndort" "fyndorter" ;
  fyndplats_nn_1_N = mkN "fyndplats" "fyndplatser" ;
  fyrarumslaegenhet_nn_1_1_N = mkN "fyrarumslägenhet" "fyrarumslägenheter" ;
  fyrkantighet_nn_1_N = mkN "fyrkantighet" "fyrkantigheter" ;
  fyrrumslaegenhet_nn_1_1_N = mkN "fyrrumslägenhet" "fyrrumslägenheter" ;
  fyrtakt_nn_1_N = mkN "fyrtakt" "fyrtakter" ;
  fyrtaktsmotor_nn_1_N = mkN "fyrtaktsmotor" "fyrtaktsmotorer" ;
  fyrtiotalism_nn_1_N = mkN "fyrtiotalism" "fyrtiotalismer" ;
  fyrtiotalist_nn_1_N = mkN "fyrtiotalist" "fyrtiotalister" ;
  fyrtioaarskris_nn_1_1_N = mkN "fyrtioårskris" "fyrtioårskriser" ;
  fyrtitalism_nn_1_N = mkN "fyrtitalism" "fyrtitalismer" ;
  fyrtitalist_nn_1_N = mkN "fyrtitalist" "fyrtitalister" ;
  fyrtiaarskris_nn_1_1_N = mkN "fyrtiårskris" "fyrtiårskriser" ;
  fyrverkeripjaes_nn_1_1_N = mkN "fyrverkeripjäs" "fyrverkeripjäser" ;
  fysikbok_nn_1_N = mkN "fysikbok" "fysikböcker" ;
  fysikprofessor_nn_1_N = mkN "fysikprofessor" "fysikprofessorer" ;
  fysiokratism_nn_1_N = mkN "fysiokratism" "fysiokratismer" ;
  fysiolog_nn_1_N = mkN "fysiolog" "fysiologer" ;
  fytotron_nn_1_N = mkN "fytotron" "fytotroner" ;
  faebless_nn_1_1_N = mkN "fäbless" "fäblesser" ;
  faegnad_nn_1_1_N = mkN "fägnad" "fägnader" ;
  faektningsmatch_nn_1_1_N = mkN "fäktningsmatch" "fäktningsmatcher" ;
  faeltarm_e_nn_1_1_N = mkN "fältarmé" "fältarméer" ;
  faeltbiolog_nn_1_1_N = mkN "fältbiolog" "fältbiologer" ;
  faeltjaegarkaar_nn_1_1_N = mkN "fältjägarkår" "fältjägarkårer" ;
  faeltkirurg_nn_1_1_N = mkN "fältkirurg" "fältkirurger" ;
  faeltpraest_nn_1_1_N = mkN "fältpräst" "fältpräster" ;
  faeltskaer_nn_1_1_N = mkN "fältskär" "fältskärer" ;
  faelttaagsplan_nn_1_1_N = mkN "fälttågsplan" "fälttågsplaner" ;
  faeltuniform_nn_1_1_N = mkN "fältuniform" "fältuniformer" ;
  faenad_nn_1_1_N = mkN "fänad" "fänader" ;
  faengelsechef_nn_1_1_N = mkN "fängelsechef" "fängelsechefer" ;
  faengelsedirektoer_nn_1_1_N = mkN "fängelsedirektör" "fängelsedirektörer" ;
  faerdighet_nn_1_1_N = mkN "färdighet" "färdigheter" ;
  faerdled_nn_1_1_N = mkN "färdled" "färdleder" ;
  faerg_nn_1_1_N = mkN "färg" "färger" ;
  faergbild_nn_1_1_N = mkN "färgbild" "färgbilder" ;
  faergfilm_nn_1_1_N = mkN "färgfilm" "färgfilmer" ;
  faergillustration_nn_1_1_N = mkN "färgillustration" "färgillustrationer" ;
  faergkontrast_nn_1_1_N = mkN "färgkontrast" "färgkontraster" ;
  faergkaenslighet_nn_1_1_N = mkN "färgkänslighet" "färgkänsligheter" ;
  faergnyans_nn_1_1_N = mkN "färgnyans" "färgnyanser" ;
  faergreproduktion_nn_1_1_N = mkN "färgreproduktion" "färgreproduktioner" ;
  faergtemperatur_nn_1_1_N = mkN "färgtemperatur" "färgtemperaturer" ;
  faergton_nn_1_1_N = mkN "färgton" "färgtoner" ;
  faerjeankomst_nn_1_1_N = mkN "färjeankomst" "färjeankomster" ;
  faerjelaegenhet_nn_1_1_N = mkN "färjelägenhet" "färjelägenheter" ;
  faerjeterminal_nn_1_1_N = mkN "färjeterminal" "färjeterminaler" ;
  faerjetidtabell_nn_1_1_N = mkN "färjetidtabell" "färjetidtabeller" ;
  faerjetransport_nn_1_1_N = mkN "färjetransport" "färjetransporter" ;
  faerjetur_nn_1_1_N = mkN "färjetur" "färjeturer" ;
  faermitet_nn_1_1_N = mkN "färmitet" "färmiteter" ;
  faers_nn_1_1_N = mkN "färs" "färser" ;
  faestningskommendant_nn_1_1_N = mkN "fästningskommendant" "fästningskommendanter" ;
  faestpunkt_nn_1_1_N = mkN "fästpunkt" "fästpunkter" ;
  faafaenglighet_nn_1_1_N = mkN "fåfänglighet" "fåfängligheter" ;
  faagelart_nn_1_1_N = mkN "fågelart" "fågelarter" ;
  faageldans_nn_1_1_N = mkN "fågeldans" "fågeldanser" ;
  faageljakt_nn_1_1_N = mkN "fågeljakt" "fågeljakter" ;
  faagelpopulation_nn_1_1_N = mkN "fågelpopulation" "fågelpopulationer" ;
  faangdraekt_nn_1_1_N = mkN "fångdräkt" "fångdräkter" ;
  faangst_nn_1_1_N = mkN "fångst" "fångster" ;
  faangstkultur_nn_1_1_N = mkN "fångstkultur" "fångstkulturer" ;
  faangstplats_nn_1_1_N = mkN "fångstplats" "fångstplatser" ;
  faangtransport_nn_1_1_N = mkN "fångtransport" "fångtransporter" ;
  faangvaardsanstalt_nn_1_1_N = mkN "fångvårdsanstalt" "fångvårdsanstalter" ;
  faanighet_nn_1_1_N = mkN "fånighet" "fånigheter" ;
  foedelseattest_nn_1_1_N = mkN "födelseattest" "födelseattester" ;
  foedelsebygd_nn_1_1_N = mkN "födelsebygd" "födelsebygder" ;
  foedelsedagsfest_nn_1_1_N = mkN "födelsedagsfest" "födelsedagsfester" ;
  foedelsedagspresent_nn_1_1_N = mkN "födelsedagspresent" "födelsedagspresenter" ;
  foedelseort_nn_1_1_N = mkN "födelseort" "födelseorter" ;
  foedoorganism_nn_1_1_N = mkN "födoorganism" "födoorganismer" ;
  foedsloraett_nn_1_1_N = mkN "födslorätt" "födslorätter" ;
  foeljd_nn_1_1_N = mkN "följd" "följder" ;
  foeljdsats_nn_1_1_N = mkN "följdsats" "följdsatser" ;
  foeljsamhet_nn_1_1_N = mkN "följsamhet" "följsamheter" ;
  foensterfaerg_nn_1_1_N = mkN "fönsterfärg" "fönsterfärger" ;
  foensterluft_nn_1_1_N = mkN "fönsterluft" "fönsterlufter" ;
  foensternisch_nn_1_1_N = mkN "fönsternisch" "fönsternischer" ;
  foensterplats_nn_1_1_N = mkN "fönsterplats" "fönsterplatser" ;
  foensterpost_nn_1_1_N = mkN "fönsterpost" "fönsterposter" ;
  foeraktfullhet_nn_1_1_N = mkN "föraktfullhet" "föraktfullheter" ;
  foeraktlighet_nn_1_1_N = mkN "föraktlighet" "föraktligheter" ;
  foerarglighet_nn_1_1_N = mkN "förarglighet" "förargligheter" ;
  foerarkabin_nn_1_1_N = mkN "förarkabin" "förarkabiner" ;
  foerarplats_nn_1_1_N = mkN "förarplats" "förarplatser" ;
  foerbandsplats_nn_1_1_N = mkN "förbandsplats" "förbandsplatser" ;
  foerbehaallsamhet_nn_1_1_N = mkN "förbehållsamhet" "förbehållsamheter" ;
  foerberedelsetid_nn_1_1_N = mkN "förberedelsetid" "förberedelsetider" ;
  foerbifart_nn_1_1_N = mkN "förbifart" "förbifarter" ;
  foerbifartsled_nn_1_1_N = mkN "förbifartsled" "förbifartsleder" ;
  foerbindelseled_nn_1_1_N = mkN "förbindelseled" "förbindelseleder" ;
  foerbraenningsmotor_nn_1_1_N = mkN "förbränningsmotor" "förbränningsmotorer" ;
  foerbraenningsprodukt_nn_1_1_N = mkN "förbränningsprodukt" "förbränningsprodukter" ;
  foerbundsstat_nn_1_1_N = mkN "förbundsstat" "förbundsstater" ;
  foerbyggnad_nn_1_1_N = mkN "förbyggnad" "förbyggnader" ;
  foerbaettringspotential_nn_1_1_N = mkN "förbättringspotential" "förbättringspotentialer" ;
  foerboen_nn_1_1_N = mkN "förbön" "förböner" ;
  foerdjupningskurs_nn_1_1_N = mkN "fördjupningskurs" "fördjupningskurser" ;
  foerdomsfullhet_nn_1_1_N = mkN "fördomsfullhet" "fördomsfullheter" ;
  foerdragsamhet_nn_1_1_N = mkN "fördragsamhet" "fördragsamheter" ;
  foerdroejningstaktik_nn_1_1_N = mkN "fördröjningstaktik" "fördröjningstaktiker" ;
  foerebild_nn_1_1_N = mkN "förebild" "förebilder" ;
  foerekomst_nn_1_1_N = mkN "förekomst" "förekomster" ;
  foereningsfrihet_nn_1_1_N = mkN "föreningsfrihet" "föreningsfriheter" ;
  foereningspunkt_nn_1_1_N = mkN "föreningspunkt" "föreningspunkter" ;
  foerenlighet_nn_1_1_N = mkN "förenlighet" "förenligheter" ;
  foeresats_nn_1_1_N = mkN "föresats" "föresatser" ;
  foereskrift_nn_1_1_N = mkN "föreskrift" "föreskrifter" ;
  foerestaellningsrepertoar_nn_1_1_N = mkN "föreställningsrepertoar" "föreställningsrepertoarer" ;
  foeretagsamhet_nn_1_1_N = mkN "företagsamhet" "företagsamheter" ;
  foeretagsekonom_nn_1_1_N = mkN "företagsekonom" "företagsekonomer" ;
  foeretagsnaemnd_nn_1_1_N = mkN "företagsnämnd" "företagsnämnder" ;
  foeretagsvinst_nn_1_1_N = mkN "företagsvinst" "företagsvinster" ;
  foerfallsperiod_nn_1_1_N = mkN "förfallsperiod" "förfallsperioder" ;
  foerfattningsstridighet_nn_1_1_N = mkN "författningsstridighet" "författningsstridigheter" ;
  foerfaerlighet_nn_1_1_N = mkN "förfärlighet" "förfärligheter" ;
  foerfoerelsekonst_nn_1_1_N = mkN "förförelsekonst" "förförelsekonster" ;
  foergriplighet_nn_1_1_N = mkN "förgriplighet" "förgripligheter" ;
  foergrundsfigur_nn_1_1_N = mkN "förgrundsfigur" "förgrundsfigurer" ;
  foergaenglighet_nn_1_1_N = mkN "förgänglighet" "förgängligheter" ;
  foerhalningstaktik_nn_1_1_N = mkN "förhalningstaktik" "förhalningstaktiker" ;
  foerhandlingsdelegation_nn_1_1_N = mkN "förhandlingsdelegation" "förhandlingsdelegationer" ;
  foerhandsinformation_nn_1_1_N = mkN "förhandsinformation" "förhandsinformationer" ;
  foerhatlighet_nn_1_1_N = mkN "förhatlighet" "förhatligheter" ;
  foerhaardnad_nn_1_1_N = mkN "förhårdnad" "förhårdnader" ;
  foerhoersutskrift_nn_1_1_N = mkN "förhörsutskrift" "förhörsutskrifter" ;
  foerklaednad_nn_1_1_N = mkN "förklädnad" "förklädnader" ;
  foerlagsverksamhet_nn_1_1_N = mkN "förlagsverksamhet" "förlagsverksamheter" ;
  foerlikningskommission_nn_1_1_N = mkN "förlikningskommission" "förlikningskommissioner" ;
  foerlossningsanstalt_nn_1_1_N = mkN "förlossningsanstalt" "förlossningsanstalter" ;
  foerlust_nn_1_1_N = mkN "förlust" "förluster" ;
  foerlaegenhet_nn_1_1_N = mkN "förlägenhet" "förlägenheter" ;
  foerlaeggningsort_nn_1_1_N = mkN "förläggningsort" "förläggningsorter" ;
  foermatch_nn_1_1_N = mkN "förmatch" "förmatcher" ;
  foermoegenhet_nn_1_1_N = mkN "förmögenhet" "förmögenheter" ;
  foermoegenhetsraett_nn_1_1_N = mkN "förmögenhetsrätt" "förmögenhetsrätter" ;
  foermoegenhetsskatt_nn_1_1_N = mkN "förmögenhetsskatt" "förmögenhetsskatter" ;
  foernekelsefas_nn_1_1_N = mkN "förnekelsefas" "förnekelsefaser" ;
  foernimbarhet_nn_1_1_N = mkN "förnimbarhet" "förnimbarheter" ;
  foernuftsloeshet_nn_1_1_N = mkN "förnuftslöshet" "förnuftslösheter" ;
  foernumstighet_nn_1_1_N = mkN "förnumstighet" "förnumstigheter" ;
  foernaemhet_nn_1_1_N = mkN "förnämhet" "förnämheter" ;
  foernaemitet_nn_1_1_N = mkN "förnämitet" "förnämiteter" ;
  foernoedenhet_nn_1_1_N = mkN "förnödenhet" "förnödenheter" ;
  foeroreningsgrad_nn_1_1_N = mkN "föroreningsgrad" "föroreningsgrader" ;
  foerort_nn_1_1_N = mkN "förort" "förorter" ;
  foerplaegnad_nn_1_1_N = mkN "förplägnad" "förplägnader" ;
  foerpost_nn_1_1_N = mkN "förpost" "förposter" ;
  foerpubertet_nn_1_1_N = mkN "förpubertet" "förpuberteter" ;
  foerruttnelsegas_nn_1_1_N = mkN "förruttnelsegas" "förruttnelsegaser" ;
  foerruttnelseprocess_nn_1_1_N = mkN "förruttnelseprocess" "förruttnelseprocesser" ;
  foerraediskhet_nn_1_1_N = mkN "förrädiskhet" "förrädiskheter" ;
  foerraett_nn_1_1_N = mkN "förrätt" "förrätter" ;
  foersamlingsbok_nn_1_1_N = mkN "församlingsbok" "församlingsböcker" ;
  foersamlingsfrihet_nn_1_1_N = mkN "församlingsfrihet" "församlingsfriheter" ;
  foersamlingspraest_nn_1_1_N = mkN "församlingspräst" "församlingspräster" ;
  foersats_nn_1_1_N = mkN "försats" "försatser" ;
  foerseningskampanj_nn_1_1_N = mkN "förseningskampanj" "förseningskampanjer" ;
  foersiktighet_nn_1_1_N = mkN "försiktighet" "försiktigheter" ;
  foersiktighetsprincip_nn_1_1_N = mkN "försiktighetsprincip" "försiktighetsprinciper" ;
  foersiktighetsaatgaerd_nn_1_1_N = mkN "försiktighetsåtgärd" "försiktighetsåtgärder" ;
  foerskraecklighet_nn_1_1_N = mkN "förskräcklighet" "förskräckligheter" ;
  foersoningsfest_nn_1_1_N = mkN "försoningsfest" "försoningsfester" ;
  foersoningsgest_nn_1_1_N = mkN "försoningsgest" "försoningsgester" ;
  foerstagradsekvation_nn_1_1_N = mkN "förstagradsekvation" "förstagradsekvationer" ;
  foerstahandsuppgift_nn_1_1_N = mkN "förstahandsuppgift" "förstahandsuppgifter" ;
  foerstainstans_nn_1_1_N = mkN "förstainstans" "förstainstanser" ;
  foerstaplats_nn_1_1_N = mkN "förstaplats" "förstaplatser" ;
  foerstaaarsstudent_nn_1_1_N = mkN "förstaårsstudent" "förstaårsstudenter" ;
  foersumlighet_nn_1_1_N = mkN "försumlighet" "försumligheter" ;
  foersvarsadvokat_nn_1_1_N = mkN "försvarsadvokat" "försvarsadvokater" ;
  foersvarsallians_nn_1_1_N = mkN "försvarsallians" "försvarsallianser" ;
  foersvarsattach_e_nn_1_1_N = mkN "försvarsattaché" "försvarsattachéer" ;
  foersvarsdator_nn_1_1_N = mkN "försvarsdator" "försvarsdatorer" ;
  foersvarsfunktion_nn_1_1_N = mkN "försvarsfunktion" "försvarsfunktioner" ;
  foersvarsgrenschef_nn_1_1_N = mkN "försvarsgrenschef" "försvarsgrenschefer" ;
  foersvarshemlighet_nn_1_1_N = mkN "försvarshemlighet" "försvarshemligheter" ;
  foersvarskostnad_nn_1_1_N = mkN "försvarskostnad" "försvarskostnader" ;
  foersvarsmekanism_nn_1_1_N = mkN "försvarsmekanism" "försvarsmekanismer" ;
  foersvarsskrift_nn_1_1_N = mkN "försvarsskrift" "försvarsskrifter" ;
  foersvarsstab_nn_1_1_N = mkN "försvarsstab" "försvarsstaber" ;
  foersaekringsbolagskontorist_nn_1_1_N = mkN "försäkringsbolagskontorist" "försäkringsbolagskontorister" ;
  foersaekringsmarknad_nn_1_1_N = mkN "försäkringsmarknad" "försäkringsmarknader" ;
  foersaekringspolis_nn_1_1_N = mkN "försäkringspolis" "försäkringspoliser" ;
  foersaeljningsbransch_nn_1_1_N = mkN "försäljningsbransch" "försäljningsbranscher" ;
  foersaeljningschef_nn_1_1_N = mkN "försäljningschef" "försäljningschefer" ;
  foersaeljningsort_nn_1_1_N = mkN "försäljningsort" "försäljningsorter" ;
  foersaeljningssucc_e_nn_1_1_N = mkN "försäljningssuccé" "försäljningssuccéer" ;
  foersaeljningsvinst_nn_1_1_N = mkN "försäljningsvinst" "försäljningsvinster" ;
  foersaeljningsvolym_nn_1_1_N = mkN "försäljningsvolym" "försäljningsvolymer" ;
  foersaettslins_nn_1_1_N = mkN "försättslins" "försättslinser" ;
  foersaatlighet_nn_1_1_N = mkN "försåtlighet" "försåtligheter" ;
  foersoekskanin_nn_1_1_N = mkN "försökskanin" "försökskaniner" ;
  foersoeksperson_nn_1_1_N = mkN "försöksperson" "försökspersoner" ;
  foersoeksverksamhet_nn_1_1_N = mkN "försöksverksamhet" "försöksverksamheter" ;
  foersoerjningsanstalt_nn_1_1_N = mkN "försörjningsanstalt" "försörjningsanstalter" ;
  foertalskampanj_nn_1_1_N = mkN "förtalskampanj" "förtalskampanjer" ;
  foertidspension_nn_1_1_N = mkN "förtidspension" "förtidspensioner" ;
  foertjaenst_nn_1_1_N = mkN "förtjänst" "förtjänster" ;
  foertretlighet_nn_1_1_N = mkN "förtretlighet" "förtretligheter" ;
  foertroendekris_nn_1_1_N = mkN "förtroendekris" "förtroendekriser" ;
  foertroendepost_nn_1_1_N = mkN "förtroendepost" "förtroendeposter" ;
  foertrogenhet_nn_1_1_N = mkN "förtrogenhet" "förtrogenheter" ;
  foertrolighet_nn_1_1_N = mkN "förtrolighet" "förtroligheter" ;
  foertraefflighet_nn_1_1_N = mkN "förträfflighet" "förträffligheter" ;
  foertraengningsmekanism_nn_1_1_N = mkN "förträngningsmekanism" "förträngningsmekanismer" ;
  foerunderlighet_nn_1_1_N = mkN "förunderlighet" "förunderligheter" ;
  foervaltningsbyggnad_nn_1_1_N = mkN "förvaltningsbyggnad" "förvaltningsbyggnader" ;
  foervaltningsraett_nn_1_1_N = mkN "förvaltningsrätt" "förvaltningsrätter" ;
  foervandlingskonstnaer_nn_1_1_N = mkN "förvandlingskonstnär" "förvandlingskonstnärer" ;
  foervandlingsprocess_nn_1_1_N = mkN "förvandlingsprocess" "förvandlingsprocesser" ;
  foervaringsmoejlighet_nn_1_1_N = mkN "förvaringsmöjlighet" "förvaringsmöjligheter" ;
  foervaringsplats_nn_1_1_N = mkN "förvaringsplats" "förvaringsplatser" ;
  foervisningsort_nn_1_1_N = mkN "förvisningsort" "förvisningsorter" ;
  foervaervsverksamhet_nn_1_1_N = mkN "förvärvsverksamhet" "förvärvsverksamheter" ;
  foeraeldrakreativitet_nn_1_1_N = mkN "föräldrakreativitet" "föräldrakreativiteter" ;
  foeraeldraledighet_nn_1_1_N = mkN "föräldraledighet" "föräldraledigheter" ;
  foeraendringsprocess_nn_1_1_N = mkN "förändringsprocess" "förändringsprocesser" ;
  g_draekt_nn_1_1_N = mkN "g-dräkt" "g-dräkter" ;
  g_kraft_nn_1_N = mkN "g-kraft" "g-krafter" ;
  g_punkt_nn_1_N = mkN "g-punkt" "g-punkter" ;
  gabon_nn_2_N = mkN "gabon" "gaboner" ;
  gabones_nn_1_N = mkN "gabones" "gaboneser" ;
  gael_nn_1_N = mkN "gael" "gaeler" ;
  gaffellaengd_nn_1_1_N = mkN "gaffellängd" "gaffellängder" ;
  gagnelighet_nn_1_N = mkN "gagnelighet" "gagneligheter" ;
  gagnvaext_nn_1_1_N = mkN "gagnväxt" "gagnväxter" ;
  galadraekt_nn_1_1_N = mkN "galadräkt" "galadräkter" ;
  galapremiaer_nn_1_1_N = mkN "galapremiär" "galapremiärer" ;
  galauniform_nn_1_N = mkN "galauniform" "galauniformer" ;
  galax_nn_1_N = mkN "galax" "galaxer" ;
  galeas_nn_1_N = mkN "galeas" "galeaser" ;
  galjon_nn_1_N = mkN "galjon" "galjoner" ;
  galjonsbild_nn_1_N = mkN "galjonsbild" "galjonsbilder" ;
  galjonsfigur_nn_1_N = mkN "galjonsfigur" "galjonsfigurer" ;
  gallerist_nn_1_N = mkN "gallerist" "gallerister" ;
  gallicism_nn_1_N = mkN "gallicism" "gallicismer" ;
  gallion_nn_1_N = mkN "gallion" "gallioner" ;
  galon_nn_2_N = mkN "galon" "galoner" ;
  galopp_nn_1_N = mkN "galopp" "galopper" ;
  galoppad_nn_1_N = mkN "galoppad" "galoppader" ;
  galosch_nn_1_N = mkN "galosch" "galoscher" ;
  galvanism_nn_1_N = mkN "galvanism" "galvanismer" ;
  gamasch_nn_1_N = mkN "gamasch" "gamascher" ;
  gammaldans_nn_1_N = mkN "gammaldans" "gammaldanser" ;
  gammalkommunist_nn_1_N = mkN "gammalkommunist" "gammalkommunister" ;
  gammalvals_nn_1_N = mkN "gammalvals" "gammalvalser" ;
  gammeldans_nn_1_N = mkN "gammeldans" "gammeldanser" ;
  gammelkommunist_nn_1_N = mkN "gammelkommunist" "gammelkommunister" ;
  gammelmoderat_nn_1_N = mkN "gammelmoderat" "gammelmoderater" ;
  gammeltantsgarderob_nn_1_N = mkN "gammeltantsgarderob" "gammeltantsgarderober" ;
  gammelvals_nn_1_N = mkN "gammelvals" "gammelvalser" ;
  ganasch_nn_1_N = mkN "ganasch" "ganascher" ;
  gangsterism_nn_1_N = mkN "gangsterism" "gangsterismer" ;
  gans_nn_1_N = mkN "gans" "ganser" ;
  garagedomkraft_nn_1_N = mkN "garagedomkraft" "garagedomkrafter" ;
  garageuppfart_nn_1_N = mkN "garageuppfart" "garageuppfarter" ;
  garagevakt_nn_1_N = mkN "garagevakt" "garagevakter" ;
  garant_nn_1_N = mkN "garant" "garanter" ;
  garantifond_nn_1_N = mkN "garantifond" "garantifonder" ;
  garderobi_e_nn_1_1_N = mkN "garderobié" "garderobiéer" ;
  gardessoldat_nn_1_N = mkN "gardessoldat" "gardessoldater" ;
  gardian_nn_1_N = mkN "gardian" "gardianer" ;
  gardin_nn_1_N = mkN "gardin" "gardiner" ;
  gardinluft_nn_1_N = mkN "gardinluft" "gardinlufter" ;
  gardist_nn_1_N = mkN "gardist" "gardister" ;
  garnisonspraest_nn_1_1_N = mkN "garnisonspräst" "garnisonspräster" ;
  garcon_nn_1_1_N = mkN "garçon" "garçoner" ;
  gas_nn_1_N = mkN "gas" "gaser" ;
  gasackumulator_nn_1_N = mkN "gasackumulator" "gasackumulatorer" ;
  gasell_nn_1_N = mkN "gasell" "gaseller" ;
  gaseruption_nn_1_N = mkN "gaseruption" "gaseruptioner" ;
  gasexplosion_nn_1_N = mkN "gasexplosion" "gasexplosioner" ;
  gasgenerator_nn_1_N = mkN "gasgenerator" "gasgeneratorer" ;
  gaskatastrof_nn_1_N = mkN "gaskatastrof" "gaskatastrofer" ;
  gasmask_nn_1_N = mkN "gasmask" "gasmasker" ;
  gasmotor_nn_1_N = mkN "gasmotor" "gasmotorer" ;
  gaspedal_nn_1_N = mkN "gaspedal" "gaspedaler" ;
  gaspollett_nn_1_N = mkN "gaspollett" "gaspolletter" ;
  gastrit_nn_1_N = mkN "gastrit" "gastriter" ;
  gastub_nn_1_N = mkN "gastub" "gastuber" ;
  gasturbin_nn_1_N = mkN "gasturbin" "gasturbiner" ;
  gatudemonstration_nn_1_N = mkN "gatudemonstration" "gatudemonstrationer" ;
  gatumanifestation_nn_1_N = mkN "gatumanifestation" "gatumanifestationer" ;
  gatuprotest_nn_1_N = mkN "gatuprotest" "gatuprotester" ;
  gatuscen_nn_1_N = mkN "gatuscen" "gatuscener" ;
  gaullism_nn_1_N = mkN "gaullism" "gaullismer" ;
  gaullist_nn_1_N = mkN "gaullist" "gaullister" ;
  gaur_nn_1_N = mkN "gaur" "gaurer" ;
  gavial_nn_1_N = mkN "gavial" "gavialer" ;
  gavott_nn_1_N = mkN "gavott" "gavotter" ;
  geg_nn_1_N = mkN "geg" "geger" ;
  gemenhet_nn_1_N = mkN "gemenhet" "gemenheter" ;
  gemensamhet_nn_1_N = mkN "gemensamhet" "gemensamheter" ;
  gemenskap_nn_2_N = mkN "gemenskap" "gemenskaper" ;
  gemenskapsform_nn_1_N = mkN "gemenskapsform" "gemenskapsformer" ;
  gemination_nn_1_N = mkN "gemination" "geminationer" ;
  gems_nn_1_N = mkN "gems" "gemser" ;
  gemytlighet_nn_1_N = mkN "gemytlighet" "gemytligheter" ;
  gen_nn_1_N = mkN "gen" "gener" ;
  genbank_nn_1_N = mkN "genbank" "genbanker" ;
  generaldirektoer_nn_1_1_N = mkN "generaldirektör" "generaldirektörer" ;
  generalguvernoer_nn_1_1_N = mkN "generalguvernör" "generalguvernörer" ;
  generalisation_nn_1_N = mkN "generalisation" "generalisationer" ;
  generaliseringsprocess_nn_1_N = mkN "generaliseringsprocess" "generaliseringsprocesser" ;
  generalist_nn_1_N = mkN "generalist" "generalister" ;
  generalitet_nn_2_N = mkN "generalitet" "generaliteter" ;
  generalmajor_nn_1_N = mkN "generalmajor" "generalmajorer" ;
  generalpaus_nn_1_N = mkN "generalpaus" "generalpauser" ;
  generalplan_nn_1_N = mkN "generalplan" "generalplaner" ;
  generalpostdirektoer_nn_1_1_N = mkN "generalpostdirektör" "generalpostdirektörer" ;
  generalprevention_nn_1_N = mkN "generalprevention" "generalpreventioner" ;
  generalrepetition_nn_1_N = mkN "generalrepetition" "generalrepetitioner" ;
  generalstab_nn_1_N = mkN "generalstab" "generalstaber" ;
  generalstabsnivaa_nn_1_1_N = mkN "generalstabsnivå" "generalstabsnivåer" ;
  generalstrejk_nn_1_N = mkN "generalstrejk" "generalstrejker" ;
  generation_nn_1_N = mkN "generation" "generationer" ;
  generationstid_nn_1_N = mkN "generationstid" "generationstider" ;
  generator_nn_1_N = mkN "generator" "generatorer" ;
  generatris_nn_1_N = mkN "generatris" "generatriser" ;
  generositet_nn_1_N = mkN "generositet" "generositeter" ;
  genialitet_nn_1_N = mkN "genialitet" "genialiteter" ;
  genitiv_nn_1_N = mkN "genitiv" "genitiver" ;
  genmanipulation_nn_1_N = mkN "genmanipulation" "genmanipulationer" ;
  genocid_nn_1_N = mkN "genocid" "genocider" ;
  genombrottsbok_nn_1_N = mkN "genombrottsbok" "genombrottsböcker" ;
  genomfartsled_nn_1_N = mkN "genomfartsled" "genomfartsleder" ;
  genommarsch_nn_1_N = mkN "genommarsch" "genommarscher" ;
  genomslaepplighet_nn_1_1_N = mkN "genomsläpplighet" "genomsläppligheter" ;
  genomsnittsinkomst_nn_1_N = mkN "genomsnittsinkomst" "genomsnittsinkomster" ;
  genomsnittsskatt_nn_1_N = mkN "genomsnittsskatt" "genomsnittsskatter" ;
  genotyp_nn_1_N = mkN "genotyp" "genotyper" ;
  genpool_nn_1_N = mkN "genpool" "genpooler" ;
  gentjaenst_nn_1_1_N = mkN "gentjänst" "gentjänster" ;
  genusvetenskap_nn_1_N = mkN "genusvetenskap" "genusvetenskaper" ;
  geofon_nn_1_N = mkN "geofon" "geofoner" ;
  geografibok_nn_1_N = mkN "geografibok" "geografiböcker" ;
  geolog_nn_1_N = mkN "geolog" "geologer" ;
  geologiprofessor_nn_1_N = mkN "geologiprofessor" "geologiprofessorer" ;
  geotropism_nn_1_N = mkN "geotropism" "geotropismer" ;
  geovetenskap_nn_1_N = mkN "geovetenskap" "geovetenskaper" ;
  geridon_nn_1_N = mkN "geridon" "geridoner" ;
  gerillaveteran_nn_1_N = mkN "gerillaveteran" "gerillaveteraner" ;
  german_nn_1_N = mkN "german" "germaner" ;
  germanism_nn_1_N = mkN "germanism" "germanismer" ;
  germanist_nn_1_N = mkN "germanist" "germanister" ;
  gesant_nn_1_N = mkN "gesant" "gesanter" ;
  gesims_nn_1_N = mkN "gesims" "gesimser" ;
  gesimslist_nn_1_N = mkN "gesimslist" "gesimslister" ;
  gest_nn_1_N = mkN "gest" "gester" ;
  gestaltningsform_nn_1_N = mkN "gestaltningsform" "gestaltningsformer" ;
  gestikulation_nn_1_N = mkN "gestikulation" "gestikulationer" ;
  get_nn_1_N = mkN "get" "getter" ;
  gevaerspost_nn_1_1_N = mkN "gevärspost" "gevärsposter" ;
  gevaerssmed_nn_1_1_N = mkN "gevärssmed" "gevärssmeder" ;
  ghanan_nn_1_N = mkN "ghanan" "ghananer" ;
  ghanes_nn_1_N = mkN "ghanes" "ghaneser" ;
  gibbon_nn_1_N = mkN "gibbon" "gibboner" ;
  giftbok_nn_1_N = mkN "giftbok" "giftböcker" ;
  giftgas_nn_1_N = mkN "giftgas" "giftgaser" ;
  gifthalt_nn_1_N = mkN "gifthalt" "gifthalter" ;
  giftighet_nn_1_N = mkN "giftighet" "giftigheter" ;
  giftinformation_nn_1_N = mkN "giftinformation" "giftinformationer" ;
  giftinjektion_nn_1_N = mkN "giftinjektion" "giftinjektioner" ;
  giftmaengd_nn_1_1_N = mkN "giftmängd" "giftmängder" ;
  gifttransport_nn_1_N = mkN "gifttransport" "gifttransporter" ;
  gigant_nn_1_N = mkN "gigant" "giganter" ;
  giljarfaerd_nn_1_1_N = mkN "giljarfärd" "giljarfärder" ;
  giljotin_nn_1_N = mkN "giljotin" "giljotiner" ;
  gillessocialism_nn_1_N = mkN "gillessocialism" "gillessocialismer" ;
  giltighet_nn_1_N = mkN "giltighet" "giltigheter" ;
  giltighetstid_nn_1_N = mkN "giltighetstid" "giltighetstider" ;
  ginseng_nn_2_N = mkN "ginseng" "ginsenger" ;
  ginst_nn_1_N = mkN "ginst" "ginster" ;
  gipsbyst_nn_1_N = mkN "gipsbyst" "gipsbyster" ;
  girighet_nn_1_N = mkN "girighet" "girigheter" ;
  girland_nn_1_N = mkN "girland" "girlander" ;
  girlang_nn_1_N = mkN "girlang" "girlanger" ;
  gisslansituation_nn_1_N = mkN "gisslansituation" "gisslansituationer" ;
  gitarrist_nn_1_N = mkN "gitarrist" "gitarrister" ;
  givmildhet_nn_1_N = mkN "givmildhet" "givmildheter" ;
  glaciolog_nn_1_N = mkN "glaciolog" "glaciologer" ;
  glaciaer_nn_1_1_N = mkN "glaciär" "glaciärer" ;
  glaciaernisch_nn_1_1_N = mkN "glaciärnisch" "glaciärnischer" ;
  gladiator_nn_1_N = mkN "gladiator" "gladiatorer" ;
  glasighet_nn_1_N = mkN "glasighet" "glasigheter" ;
  glaskaraff_nn_1_N = mkN "glaskaraff" "glaskaraffer" ;
  glasmaestardiamant_nn_1_1_N = mkN "glasmästardiamant" "glasmästardiamanter" ;
  glaspokal_nn_1_N = mkN "glaspokal" "glaspokaler" ;
  glassbomb_nn_1_N = mkN "glassbomb" "glassbomber" ;
  glasskaerardiamant_nn_1_1_N = mkN "glasskärardiamant" "glasskärardiamanter" ;
  glasvakt_nn_1_N = mkN "glasvakt" "glasvakter" ;
  glidfriktion_nn_1_N = mkN "glidfriktion" "glidfriktioner" ;
  glidkontakt_nn_1_N = mkN "glidkontakt" "glidkontakter" ;
  glisoert_nn_1_1_N = mkN "glisört" "glisörter" ;
  glittergirlang_nn_1_N = mkN "glittergirlang" "glittergirlanger" ;
  glob_nn_1_N = mkN "glob" "glober" ;
  glycerid_nn_1_N = mkN "glycerid" "glycerider" ;
  glycin_nn_1_N = mkN "glycin" "glyciner" ;
  glykol_nn_1_N = mkN "glykol" "glykoler" ;
  glykopeptid_nn_1_N = mkN "glykopeptid" "glykopeptider" ;
  glaedjedans_nn_1_1_N = mkN "glädjedans" "glädjedanser" ;
  glaedjefest_nn_1_1_N = mkN "glädjefest" "glädjefester" ;
  glaedjekalkyl_nn_1_1_N = mkN "glädjekalkyl" "glädjekalkyler" ;
  glaettighet_nn_1_1_N = mkN "glättighet" "glättigheter" ;
  glaamighet_nn_1_1_N = mkN "glåmighet" "glåmigheter" ;
  gloed_nn_1_1_N = mkN "glöd" "glöder" ;
  gloedlampsfabrik_nn_1_1_N = mkN "glödlampsfabrik" "glödlampsfabriker" ;
  gnejs_nn_1_N = mkN "gnejs" "gnejser" ;
  gnet_nn_1_N = mkN "gnet" "gnetter" ;
  gnidningselektricitet_nn_1_N = mkN "gnidningselektricitet" "gnidningselektriciteter" ;
  gnistinduktor_nn_1_N = mkN "gnistinduktor" "gnistinduktorer" ;
  gniststation_nn_1_N = mkN "gniststation" "gniststationer" ;
  gnom_nn_1_N = mkN "gnom" "gnomer" ;
  gnomon_nn_1_N = mkN "gnomon" "gnomoner" ;
  gnosticism_nn_1_N = mkN "gnosticism" "gnosticismer" ;
  gnuggbild_nn_1_N = mkN "gnuggbild" "gnuggbilder" ;
  godhet_nn_1_N = mkN "godhet" "godheter" ;
  godhjaertenhet_nn_1_1_N = mkN "godhjärtenhet" "godhjärtenheter" ;
  godsak_nn_1_N = mkN "godsak" "godsaker" ;
  godsexpedition_nn_1_N = mkN "godsexpedition" "godsexpeditioner" ;
  godsstation_nn_1_N = mkN "godsstation" "godsstationer" ;
  godsterminal_nn_1_N = mkN "godsterminal" "godsterminaler" ;
  godstransport_nn_1_N = mkN "godstransport" "godstransporter" ;
  godtycklighet_nn_1_N = mkN "godtycklighet" "godtyckligheter" ;
  golvfaerg_nn_1_1_N = mkN "golvfärg" "golvfärger" ;
  gon_nn_1_N = mkN "gon" "goner" ;
  gondol_nn_1_N = mkN "gondol" "gondoler" ;
  gonorr_e_nn_1_1_N = mkN "gonorré" "gonorréer" ;
  gorgon_nn_1_N = mkN "gorgon" "gorgoner" ;
  gosskoer_nn_1_1_N = mkN "gosskör" "gosskörer" ;
  got_nn_1_N = mkN "got" "goter" ;
  gourm_e_nn_1_1_N = mkN "gourmé" "gourméer" ;
  grad_nn_1_N = mkN "grad" "grader" ;
  gradation_nn_1_N = mkN "gradation" "gradationer" ;
  gradlist_nn_1_N = mkN "gradlist" "gradlister" ;
  gradskillnad_nn_1_N = mkN "gradskillnad" "gradskillnader" ;
  gradaeng_nn_1_1_N = mkN "gradäng" "gradänger" ;
  graf_nn_1_N = mkN "graf" "grafer" ;
  grafen_nn_1_N = mkN "grafen" "grafener" ;
  grafit_nn_1_N = mkN "grafit" "grafiter" ;
  grafolog_nn_1_N = mkN "grafolog" "grafologer" ;
  grammatik_nn_1_N = mkN "grammatik" "grammatiker" ;
  grammatikbok_nn_1_N = mkN "grammatikbok" "grammatikböcker" ;
  grammofon_nn_1_N = mkN "grammofon" "grammofoner" ;
  grammolekyl_nn_1_N = mkN "grammolekyl" "grammolekyler" ;
  granatattack_nn_1_N = mkN "granatattack" "granatattacker" ;
  granatkartesch_nn_1_N = mkN "granatkartesch" "granatkartescher" ;
  granimitation_nn_1_N = mkN "granimitation" "granimitationer" ;
  granit_nn_1_N = mkN "granit" "graniter" ;
  grannfastighet_nn_1_N = mkN "grannfastighet" "grannfastigheter" ;
  grannfejd_nn_1_N = mkN "grannfejd" "grannfejder" ;
  grannlagenhet_nn_1_N = mkN "grannlagenhet" "grannlagenheter" ;
  grannstat_nn_1_N = mkN "grannstat" "grannstater" ;
  granskningskommission_nn_1_N = mkN "granskningskommission" "granskningskommissioner" ;
  granskningsnaemnd_nn_1_1_N = mkN "granskningsnämnd" "granskningsnämnder" ;
  gransort_nn_1_N = mkN "gransort" "gransorter" ;
  granulation_nn_1_N = mkN "granulation" "granulationer" ;
  granulationsvaevnad_nn_1_1_N = mkN "granulationsvävnad" "granulationsvävnader" ;
  gratialist_nn_1_N = mkN "gratialist" "gratialister" ;
  gratifikation_nn_1_N = mkN "gratifikation" "gratifikationer" ;
  gratin_nn_1_N = mkN "gratin" "gratiner" ;
  gratisplats_nn_1_N = mkN "gratisplats" "gratisplatser" ;
  gratulant_nn_1_N = mkN "gratulant" "gratulanter" ;
  gratulation_nn_1_N = mkN "gratulation" "gratulationer" ;
  grataeng_nn_1_1_N = mkN "gratäng" "gratänger" ;
  gravation_nn_1_N = mkN "gravation" "gravationer" ;
  gravbyggnad_nn_1_N = mkN "gravbyggnad" "gravbyggnader" ;
  gravdikt_nn_1_N = mkN "gravdikt" "gravdikter" ;
  gravenstein_nn_1_N = mkN "gravenstein" "gravensteiner" ;
  graviditet_nn_1_N = mkN "graviditet" "graviditeter" ;
  graviditetsdagbok_nn_1_N = mkN "graviditetsdagbok" "graviditetsdagböcker" ;
  gravitation_nn_1_N = mkN "gravitation" "gravitationer" ;
  gravitationskollaps_nn_1_N = mkN "gravitationskollaps" "gravitationskollapser" ;
  gravitationskonstant_nn_1_N = mkN "gravitationskonstant" "gravitationskonstanter" ;
  gravitet_nn_1_N = mkN "gravitet" "graviteter" ;
  graviton_nn_1_N = mkN "graviton" "gravitoner" ;
  gravplats_nn_1_N = mkN "gravplats" "gravplatser" ;
  gravyr_nn_1_N = mkN "gravyr" "gravyrer" ;
  gravyrmaskin_nn_1_N = mkN "gravyrmaskin" "gravyrmaskiner" ;
  grecism_nn_1_N = mkN "grecism" "grecismer" ;
  greppbarhet_nn_2_N = mkN "greppbarhet" "greppbarheter" ;
  grillbar_nn_1_N = mkN "grillbar" "grillbarer" ;
  grimas_nn_1_N = mkN "grimas" "grimaser" ;
  grinighet_nn_1_N = mkN "grinighet" "grinigheter" ;
  grisfest_nn_1_N = mkN "grisfest" "grisfester" ;
  grisskandal_nn_1_N = mkN "grisskandal" "grisskandaler" ;
  grobarhet_nn_1_N = mkN "grobarhet" "grobarheter" ;
  grobian_nn_1_N = mkN "grobian" "grobianer" ;
  grossess_nn_1_N = mkN "grossess" "grossesser" ;
  grossist_nn_1_N = mkN "grossist" "grossister" ;
  grotesk_nn_1_N = mkN "grotesk" "grotesker" ;
  grovhet_nn_1_N = mkN "grovhet" "grovheter" ;
  grovkornighet_nn_2_N = mkN "grovkornighet" "grovkornigheter" ;
  grumlighet_nn_1_N = mkN "grumlighet" "grumligheter" ;
  grundavgift_nn_1_N = mkN "grundavgift" "grundavgifter" ;
  grundbok_nn_1_N = mkN "grundbok" "grundböcker" ;
  grundenhet_nn_1_N = mkN "grundenhet" "grundenheter" ;
  grundfond_nn_1_N = mkN "grundfond" "grundfonder" ;
  grundform_nn_1_N = mkN "grundform" "grundformer" ;
  grundfaerg_nn_1_1_N = mkN "grundfärg" "grundfärger" ;
  grundkurs_nn_1_N = mkN "grundkurs" "grundkurser" ;
  grundlighet_nn_1_N = mkN "grundlighet" "grundligheter" ;
  grundloen_nn_1_1_N = mkN "grundlön" "grundlöner" ;
  grundorsak_nn_1_N = mkN "grundorsak" "grundorsaker" ;
  grundplan_nn_1_N = mkN "grundplan" "grundplaner" ;
  grundsats_nn_1_N = mkN "grundsats" "grundsatser" ;
  grundskatt_nn_1_N = mkN "grundskatt" "grundskatter" ;
  grundtes_nn_1_N = mkN "grundtes" "grundteser" ;
  grundtext_nn_1_N = mkN "grundtext" "grundtexter" ;
  grundton_nn_1_N = mkN "grundton" "grundtoner" ;
  grupp_nn_1_N = mkN "grupp" "grupper" ;
  gruppbild_nn_1_N = mkN "gruppbild" "gruppbilder" ;
  gruppchef_nn_1_N = mkN "gruppchef" "gruppchefer" ;
  gruppgenitiv_nn_1_N = mkN "gruppgenitiv" "gruppgenitiver" ;
  gruppidentitet_nn_1_N = mkN "gruppidentitet" "gruppidentiteter" ;
  grusplan_nn_1_N = mkN "grusplan" "grusplaner" ;
  gruvexplosion_nn_1_N = mkN "gruvexplosion" "gruvexplosioner" ;
  gruvkompass_nn_1_N = mkN "gruvkompass" "gruvkompasser" ;
  gruvlighet_nn_1_N = mkN "gruvlighet" "gruvligheter" ;
  gruvstrejk_nn_1_N = mkN "gruvstrejk" "gruvstrejker" ;
  grymhet_nn_1_N = mkN "grymhet" "grymheter" ;
  grymthastighet_nn_1_N = mkN "grymthastighet" "grymthastigheter" ;
  grynighet_nn_1_N = mkN "grynighet" "grynigheter" ;
  graeddfil_nn_2_1_N = mkN "gräddfil" "gräddfiler" ;
  graeddhalt_nn_1_1_N = mkN "gräddhalt" "gräddhalter" ;
  graens_nn_1_1_N = mkN "gräns" "gränser" ;
  graensbastion_nn_1_1_N = mkN "gränsbastion" "gränsbastioner" ;
  graenskontroll_nn_1_1_N = mkN "gränskontroll" "gränskontroller" ;
  graenskostnad_nn_1_1_N = mkN "gränskostnad" "gränskostnader" ;
  graenspolis_nn_2_1_N = mkN "gränspolis" "gränspoliser" ;
  graenssnittsdokumentation_nn_1_1_N = mkN "gränssnittsdokumentation" "gränssnittsdokumentationer" ;
  graensvakt_nn_1_1_N = mkN "gränsvakt" "gränsvakter" ;
  graesklippningsmaskin_nn_1_1_N = mkN "gräsklippningsmaskin" "gräsklippningsmaskiner" ;
  graeslighet_nn_1_1_N = mkN "gräslighet" "gräsligheter" ;
  graesmaanad_nn_1_1_N = mkN "gräsmånad" "gräsmånader" ;
  graesplan_nn_1_1_N = mkN "gräsplan" "gräsplaner" ;
  graesrotskampanj_nn_1_1_N = mkN "gräsrotskampanj" "gräsrotskampanjer" ;
  graesvaext_nn_1_1_N = mkN "gräsväxt" "gräsväxter" ;
  graevargeneration_nn_1_1_N = mkN "grävargeneration" "grävargenerationer" ;
  graevarjournalist_nn_1_1_N = mkN "grävarjournalist" "grävarjournalister" ;
  graevgrupp_nn_1_1_N = mkN "grävgrupp" "grävgrupper" ;
  graevmaskin_nn_1_1_N = mkN "grävmaskin" "grävmaskiner" ;
  graanad_nn_1_1_N = mkN "grånad" "grånader" ;
  graasossefalang_nn_1_1_N = mkN "gråsossefalang" "gråsossefalanger" ;
  graatattack_nn_1_1_N = mkN "gråtattack" "gråtattacker" ;
  graaton_nn_1_1_N = mkN "gråton" "gråtoner" ;
  graazon_nn_1_1_N = mkN "gråzon" "gråzoner" ;
  groenalg_nn_1_1_N = mkN "grönalg" "grönalger" ;
  groenmognad_nn_1_1_N = mkN "grönmognad" "grönmognader" ;
  groenraett_nn_1_1_N = mkN "grönrätt" "grönrätter" ;
  groensak_nn_1_1_N = mkN "grönsak" "grönsaker" ;
  groensallad_nn_1_1_N = mkN "grönsallad" "grönsallader" ;
  guatemalan_nn_1_N = mkN "guatemalan" "guatemalaner" ;
  guayanan_nn_1_N = mkN "guayanan" "guayananer" ;
  gudabild_nn_1_N = mkN "gudabild" "gudabilder" ;
  gudadryck_nn_1_N = mkN "gudadryck" "gudadrycker" ;
  gudomlighet_nn_1_N = mkN "gudomlighet" "gudomligheter" ;
  gudsbild_nn_1_N = mkN "gudsbild" "gudsbilder" ;
  gudstjaenst_nn_1_1_N = mkN "gudstjänst" "gudstjänster" ;
  gudstjaenstfrekvens_nn_1_1_N = mkN "gudstjänstfrekvens" "gudstjänstfrekvenser" ;
  gudstjaensttid_nn_1_1_N = mkN "gudstjänsttid" "gudstjänsttider" ;
  guinean_nn_1_N = mkN "guinean" "guineaner" ;
  gulasch_nn_2_N = mkN "gulasch" "gulascher" ;
  gulaschbaron_nn_1_N = mkN "gulaschbaron" "gulaschbaroner" ;
  gulddukat_nn_1_N = mkN "gulddukat" "gulddukater" ;
  guldfasan_nn_1_N = mkN "guldfasan" "guldfasaner" ;
  guldfestong_nn_1_N = mkN "guldfestong" "guldfestonger" ;
  guldhalt_nn_1_N = mkN "guldhalt" "guldhalter" ;
  guldkant_nn_1_N = mkN "guldkant" "guldkanter" ;
  guldrusch_nn_1_N = mkN "guldrusch" "guldruscher" ;
  guldrush_nn_1_N = mkN "guldrush" "guldrusher" ;
  guldsmed_nn_1_N = mkN "guldsmed" "guldsmeder" ;
  guldspadejury_nn_1_N = mkN "guldspadejury" "guldspadejuryer" ;
  guldstrid_nn_1_N = mkN "guldstrid" "guldstrider" ;
  gullighet_nn_1_N = mkN "gullighet" "gulligheter" ;
  gulnad_nn_1_N = mkN "gulnad" "gulnader" ;
  gunst_nn_1_N = mkN "gunst" "gunster" ;
  gurklist_nn_1_N = mkN "gurklist" "gurklister" ;
  gurkvaext_nn_1_1_N = mkN "gurkväxt" "gurkväxter" ;
  gustavian_nn_1_N = mkN "gustavian" "gustavianer" ;
  guttural_nn_1_N = mkN "guttural" "gutturaler" ;
  guvernant_nn_1_N = mkN "guvernant" "guvernanter" ;
  guvernoer_nn_1_1_N = mkN "guvernör" "guvernörer" ;
  guyanan_nn_1_N = mkN "guyanan" "guyananer" ;
  gyckelbild_nn_1_N = mkN "gyckelbild" "gyckelbilder" ;
  gymnasieekonom_nn_1_N = mkN "gymnasieekonom" "gymnasieekonomer" ;
  gymnasieingenjoer_nn_1_1_N = mkN "gymnasieingenjör" "gymnasieingenjörer" ;
  gymnasieinspektoer_nn_1_1_N = mkN "gymnasieinspektör" "gymnasieinspektörer" ;
  gymnasist_nn_1_N = mkN "gymnasist" "gymnasister" ;
  gymnast_nn_1_N = mkN "gymnast" "gymnaster" ;
  gymnastikdirektoer_nn_1_1_N = mkN "gymnastikdirektör" "gymnastikdirektörer" ;
  gymnastikdraekt_nn_1_1_N = mkN "gymnastikdräkt" "gymnastikdräkter" ;
  gymnastiklektion_nn_1_N = mkN "gymnastiklektion" "gymnastiklektioner" ;
  gynekolog_nn_1_N = mkN "gynekolog" "gynekologer" ;
  gyrokompass_nn_1_N = mkN "gyrokompass" "gyrokompasser" ;
  gyroskopkompass_nn_1_N = mkN "gyroskopkompass" "gyroskopkompasser" ;
  gyrostabilisator_nn_1_N = mkN "gyrostabilisator" "gyrostabilisatorer" ;
  gaeckmast_nn_1_1_N = mkN "gäckmast" "gäckmaster" ;
  gael_nn_2_1_N = mkN "gäl" "gäler" ;
  gaems_nn_1_1_N = mkN "gäms" "gämser" ;
  gaenginsats_nn_1_1_N = mkN "gänginsats" "gänginsatser" ;
  gaengverktygssats_nn_1_1_N = mkN "gängverktygssats" "gängverktygssatser" ;
  gaerningsmannaprofilgrupp_nn_1_1_N = mkN "gärningsmannaprofilgrupp" "gärningsmannaprofilgrupper" ;
  gaerningsort_nn_1_1_N = mkN "gärningsort" "gärningsorter" ;
  gaerningsperson_nn_1_1_N = mkN "gärningsperson" "gärningspersoner" ;
  gaest_nn_1_1_N = mkN "gäst" "gäster" ;
  gaestatom_nn_1_1_N = mkN "gästatom" "gästatomer" ;
  gaestbok_nn_1_1_N = mkN "gästbok" "gästböcker" ;
  gaestmolekyl_nn_1_1_N = mkN "gästmolekyl" "gästmolekyler" ;
  gaestroll_nn_1_1_N = mkN "gästroll" "gästroller" ;
  gaang_nn_2_1_N = mkN "gång" "gånger" ;
  gaangjaernsled_nn_1_1_N = mkN "gångjärnsled" "gångjärnsleder" ;
  gaangled_nn_1_1_N = mkN "gångled" "gångleder" ;
  gaardsplan_nn_1_1_N = mkN "gårdsplan" "gårdsplaner" ;
  gaardsplats_nn_1_1_N = mkN "gårdsplats" "gårdsplatser" ;
  gaatfullhet_nn_1_1_N = mkN "gåtfullhet" "gåtfullheter" ;
  gaavoskatt_nn_1_1_N = mkN "gåvoskatt" "gåvoskatter" ;
  goejemaanad_nn_1_1_N = mkN "göjemånad" "göjemånader" ;
  goet_nn_3_13_N = mkN "göt" "göter" ;
  goeticism_nn_1_1_N = mkN "göticism" "göticismer" ;
  habilitet_nn_1_N = mkN "habilitet" "habiliteter" ;
  habit_nn_1_N = mkN "habit" "habiter" ;
  hagmark_nn_1_N = mkN "hagmark" "hagmarker" ;
  hakparentes_nn_1_N = mkN "hakparentes" "hakparenteser" ;
  halkrisk_nn_1_N = mkN "halkrisk" "halkrisker" ;
  halltelefon_nn_1_N = mkN "halltelefon" "halltelefoner" ;
  hallucination_nn_1_N = mkN "hallucination" "hallucinationer" ;
  hallucinogen_nn_1_N = mkN "hallucinogen" "hallucinogener" ;
  halmmadrass_nn_1_N = mkN "halmmadrass" "halmmadrasser" ;
  halsfluss_nn_1_N = mkN "halsfluss" "halsflusser" ;
  halskatarr_nn_1_N = mkN "halskatarr" "halskatarrer" ;
  halt_nn_1_N = mkN "halt" "halter" ;
  halvbild_nn_1_N = mkN "halvbild" "halvbilder" ;
  halvbutelj_nn_1_N = mkN "halvbutelj" "halvbuteljer" ;
  halvfigur_nn_1_N = mkN "halvfigur" "halvfigurer" ;
  halvfaerdighet_nn_1_1_N = mkN "halvfärdighet" "halvfärdigheter" ;
  halvhet_nn_1_N = mkN "halvhet" "halvheter" ;
  halvklass_nn_1_N = mkN "halvklass" "halvklasser" ;
  halvledardiod_nn_1_N = mkN "halvledardiod" "halvledardioder" ;
  halvlitersbutelj_nn_1_N = mkN "halvlitersbutelj" "halvlitersbuteljer" ;
  halvpension_nn_1_N = mkN "halvpension" "halvpensioner" ;
  halvtid_nn_1_N = mkN "halvtid" "halvtider" ;
  halvton_nn_1_N = mkN "halvton" "halvtoner" ;
  hamburgarbar_nn_1_N = mkN "hamburgarbar" "hamburgarbarer" ;
  hamburgarrestaurang_nn_1_N = mkN "hamburgarrestaurang" "hamburgarrestauranger" ;
  hamburgerbar_nn_1_N = mkN "hamburgerbar" "hamburgerbarer" ;
  hamburgerrestaurang_nn_1_N = mkN "hamburgerrestaurang" "hamburgerrestauranger" ;
  hamit_nn_1_N = mkN "hamit" "hamiter" ;
  hammarattack_nn_1_N = mkN "hammarattack" "hammarattacker" ;
  hamnarbetarstrejk_nn_1_N = mkN "hamnarbetarstrejk" "hamnarbetarstrejker" ;
  hamndirektion_nn_1_N = mkN "hamndirektion" "hamndirektioner" ;
  handbok_nn_1_N = mkN "handbok" "handböcker" ;
  handbollsmatch_nn_1_N = mkN "handbollsmatch" "handbollsmatcher" ;
  handdator_nn_1_N = mkN "handdator" "handdatorer" ;
  handelsled_nn_1_N = mkN "handelsled" "handelsleder" ;
  handelsplats_nn_1_N = mkN "handelsplats" "handelsplatser" ;
  handelssanktion_nn_1_N = mkN "handelssanktion" "handelssanktioner" ;
  handenhet_nn_1_N = mkN "handenhet" "handenheter" ;
  handfallenhet_nn_1_N = mkN "handfallenhet" "handfallenheter" ;
  handgranatduell_nn_1_N = mkN "handgranatduell" "handgranatdueller" ;
  handgriplighet_nn_1_N = mkN "handgriplighet" "handgripligheter" ;
  handikappidrott_nn_1_N = mkN "handikappidrott" "handikappidrotter" ;
  handikapporganisation_nn_1_N = mkN "handikapporganisation" "handikapporganisationer" ;
  handkontroll_nn_1_N = mkN "handkontroll" "handkontroller" ;
  handkraem_nn_1_1_N = mkN "handkräm" "handkrämer" ;
  handled_nn_1_N = mkN "handled" "handleder" ;
  handlingsfrihet_nn_1_N = mkN "handlingsfrihet" "handlingsfriheter" ;
  handsbredd_nn_1_N = mkN "handsbredd" "handsbredder" ;
  handskrift_nn_1_N = mkN "handskrift" "handskrifter" ;
  handstilsexpert_nn_1_N = mkN "handstilsexpert" "handstilsexperter" ;
  hangarversion_nn_1_N = mkN "hangarversion" "hangarversioner" ;
  hanteringskostnad_nn_1_N = mkN "hanteringskostnad" "hanteringskostnader" ;
  hanteringsrisk_nn_1_N = mkN "hanteringsrisk" "hanteringsrisker" ;
  hantverkarsats_nn_1_N = mkN "hantverkarsats" "hantverkarsatser" ;
  hantverksskicklighet_nn_1_N = mkN "hantverksskicklighet" "hantverksskickligheter" ;
  haremsdam_nn_1_N = mkN "haremsdam" "haremsdamer" ;
  harlekin_nn_1_N = mkN "harlekin" "harlekiner" ;
  harmloeshet_nn_1_1_N = mkN "harmlöshet" "harmlösheter" ;
  harpist_nn_1_N = mkN "harpist" "harpister" ;
  harpoton_nn_1_N = mkN "harpoton" "harpotoner" ;
  hastighet_nn_1_N = mkN "hastighet" "hastigheter" ;
  hastighetsgraens_nn_1_1_N = mkN "hastighetsgräns" "hastighetsgränser" ;
  hastighetskontroll_nn_1_N = mkN "hastighetskontroll" "hastighetskontroller" ;
  hatgrupp_nn_1_N = mkN "hatgrupp" "hatgrupper" ;
  haverikommission_nn_1_N = mkN "haverikommission" "haverikommissioner" ;
  haverist_nn_1_N = mkN "haverist" "haverister" ;
  havretraktor_nn_1_N = mkN "havretraktor" "havretraktorer" ;
  havsanemon_nn_1_N = mkN "havsanemon" "havsanemoner" ;
  havshorisont_nn_1_N = mkN "havshorisont" "havshorisonter" ;
  havskajak_nn_1_N = mkN "havskajak" "havskajaker" ;
  havsnivaa_nn_1_1_N = mkN "havsnivå" "havsnivåer" ;
  havsorganism_nn_1_N = mkN "havsorganism" "havsorganismer" ;
  havstulpan_nn_1_N = mkN "havstulpan" "havstulpaner" ;
  havsvaext_nn_1_1_N = mkN "havsväxt" "havsväxter" ;
  hbt_person_nn_1_N = mkN "hbt-person" "hbt-personer" ;
  hedersdoktor_nn_1_N = mkN "hedersdoktor" "hedersdoktorer" ;
  hedersgaest_nn_1_1_N = mkN "hedersgäst" "hedersgäster" ;
  hederskonflikt_nn_1_N = mkN "hederskonflikt" "hederskonflikter" ;
  hederskultur_nn_1_N = mkN "hederskultur" "hederskulturer" ;
  hedersplats_nn_1_N = mkN "hedersplats" "hedersplatser" ;
  hederspost_nn_1_N = mkN "hederspost" "hedersposter" ;
  hederssak_nn_1_N = mkN "hederssak" "hederssaker" ;
  hedersvakt_nn_1_N = mkN "hedersvakt" "hedersvakter" ;
  hedmark_nn_1_N = mkN "hedmark" "hedmarker" ;
  hednamission_nn_1_N = mkN "hednamission" "hednamissioner" ;
  hednatid_nn_1_N = mkN "hednatid" "hednatider" ;
  hedonism_nn_1_N = mkN "hedonism" "hedonismer" ;
  hedonist_nn_1_N = mkN "hedonist" "hedonister" ;
  hejdloeshet_nn_1_1_N = mkN "hejdlöshet" "hejdlösheter" ;
  helbild_nn_1_N = mkN "helbild" "helbilder" ;
  helbutelj_nn_1_N = mkN "helbutelj" "helbuteljer" ;
  helfigur_nn_1_N = mkN "helfigur" "helfigurer" ;
  helgonbild_nn_1_N = mkN "helgonbild" "helgonbilder" ;
  helgonlegend_nn_1_N = mkN "helgonlegend" "helgonlegender" ;
  helgonstaty_nn_1_N = mkN "helgonstaty" "helgonstatyer" ;
  helhet_nn_1_N = mkN "helhet" "helheter" ;
  helhetsbild_nn_1_N = mkN "helhetsbild" "helhetsbilder" ;
  helighet_nn_1_N = mkN "helighet" "heligheter" ;
  helikopterkrasch_nn_1_N = mkN "helikopterkrasch" "helikopterkrascher" ;
  helikopterkupp_nn_1_N = mkN "helikopterkupp" "helikopterkupper" ;
  helkroppsdos_nn_1_N = mkN "helkroppsdos" "helkroppsdoser" ;
  hellenism_nn_1_N = mkN "hellenism" "hellenismer" ;
  helpension_nn_1_N = mkN "helpension" "helpensioner" ;
  helsidesannons_nn_1_N = mkN "helsidesannons" "helsidesannonser" ;
  heltid_nn_1_N = mkN "heltid" "heltider" ;
  heltidsloen_nn_1_1_N = mkN "heltidslön" "heltidslöner" ;
  helton_nn_1_N = mkN "helton" "heltoner" ;
  hematit_nn_1_N = mkN "hematit" "hematiter" ;
  hemdator_nn_1_N = mkN "hemdator" "hemdatorer" ;
  hemgalax_nn_1_N = mkN "hemgalax" "hemgalaxer" ;
  hemhoerighet_nn_1_1_N = mkN "hemhörighet" "hemhörigheter" ;
  hemlighet_nn_1_N = mkN "hemlighet" "hemligheter" ;
  hemmahoerighet_nn_1_1_N = mkN "hemmahörighet" "hemmahörigheter" ;
  hemmamatch_nn_1_N = mkN "hemmamatch" "hemmamatcher" ;
  hemmaopinion_nn_1_N = mkN "hemmaopinion" "hemmaopinioner" ;
  hemmaplan_nn_1_N = mkN "hemmaplan" "hemmaplaner" ;
  hemort_nn_1_N = mkN "hemort" "hemorter" ;
  hemsamarit_nn_1_N = mkN "hemsamarit" "hemsamariter" ;
  hemskhet_nn_1_N = mkN "hemskhet" "hemskheter" ;
  hemskillnad_nn_1_N = mkN "hemskillnad" "hemskillnader" ;
  hemtjaenst_nn_1_1_N = mkN "hemtjänst" "hemtjänster" ;
  hemtrevlighet_nn_1_N = mkN "hemtrevlighet" "hemtrevligheter" ;
  hemtrevnad_nn_2_N = mkN "hemtrevnad" "hemtrevnader" ;
  hemuppgift_nn_1_N = mkN "hemuppgift" "hemuppgifter" ;
  hemvaernschef_nn_1_1_N = mkN "hemvärnschef" "hemvärnschefer" ;
  hepatit_nn_1_N = mkN "hepatit" "hepatiter" ;
  herbicid_nn_1_N = mkN "herbicid" "herbicider" ;
  herdedikt_nn_1_N = mkN "herdedikt" "herdedikter" ;
  hermafrodit_nn_1_N = mkN "hermafrodit" "hermafroditer" ;
  hermelin_nn_1_N = mkN "hermelin" "hermeliner" ;
  heroinist_nn_1_N = mkN "heroinist" "heroinister" ;
  heroism_nn_1_N = mkN "heroism" "heroismer" ;
  heros_nn_1_N = mkN "heros" "heroser" ;
  herrgaardsbyggnad_nn_1_1_N = mkN "herrgårdsbyggnad" "herrgårdsbyggnader" ;
  herrnhutism_nn_1_N = mkN "herrnhutism" "herrnhutismer" ;
  heshet_nn_1_N = mkN "heshet" "hesheter" ;
  heteroklis_nn_1_N = mkN "heteroklis" "heterokliser" ;
  heteronorm_nn_1_N = mkN "heteronorm" "heteronormer" ;
  heteronormativitet_nn_1_N = mkN "heteronormativitet" "heteronormativiteter" ;
  heterozygot_nn_1_N = mkN "heterozygot" "heterozygoter" ;
  hetman_nn_1_N = mkN "hetman" "hetmaner" ;
  hetsighet_nn_1_N = mkN "hetsighet" "hetsigheter" ;
  hetsjakt_nn_1_N = mkN "hetsjakt" "hetsjakter" ;
  hettit_nn_1_N = mkN "hettit" "hettiter" ;
  hibernation_nn_1_N = mkN "hibernation" "hibernationer" ;
  hieroglyfinskrift_nn_1_N = mkN "hieroglyfinskrift" "hieroglyfinskrifter" ;
  higgsboson_nn_1_N = mkN "higgsboson" "higgsbosoner" ;
  himmelsfaerd_nn_1_1_N = mkN "himmelsfärd" "himmelsfärder" ;
  himmelsglob_nn_1_N = mkN "himmelsglob" "himmelsglober" ;
  himmelshoejd_nn_1_1_N = mkN "himmelshöjd" "himmelshöjder" ;
  hinduism_nn_1_N = mkN "hinduism" "hinduismer" ;
  hippolog_nn_1_N = mkN "hippolog" "hippologer" ;
  hiskelighet_nn_1_N = mkN "hiskelighet" "hiskeligheter" ;
  hisklighet_nn_1_N = mkN "hisklighet" "hiskligheter" ;
  hissinstallation_nn_1_N = mkN "hissinstallation" "hissinstallationer" ;
  histolog_nn_1_N = mkN "histolog" "histologer" ;
  historicism_nn_1_N = mkN "historicism" "historicismer" ;
  historiebok_nn_1_N = mkN "historiebok" "historieböcker" ;
  historierevisionist_nn_1_N = mkN "historierevisionist" "historierevisionister" ;
  historievetenskap_nn_1_N = mkN "historievetenskap" "historievetenskaper" ;
  historism_nn_1_N = mkN "historism" "historismer" ;
  histrion_nn_1_N = mkN "histrion" "histrioner" ;
  hjulbas_nn_1_N = mkN "hjulbas" "hjulbaser" ;
  hjulsats_nn_1_N = mkN "hjulsats" "hjulsatser" ;
  hjaelmprydnad_nn_1_1_N = mkN "hjälmprydnad" "hjälmprydnader" ;
  hjaelpklass_nn_1_1_N = mkN "hjälpklass" "hjälpklasser" ;
  hjaelpmotor_nn_1_1_N = mkN "hjälpmotor" "hjälpmotorer" ;
  hjaelporganisation_nn_1_1_N = mkN "hjälporganisation" "hjälporganisationer" ;
  hjaelpsamhet_nn_1_1_N = mkN "hjälpsamhet" "hjälpsamheter" ;
  hjaelpvetenskap_nn_1_1_N = mkN "hjälpvetenskap" "hjälpvetenskaper" ;
  hjaeltedikt_nn_1_1_N = mkN "hjältedikt" "hjältedikter" ;
  hjaelteroll_nn_1_1_N = mkN "hjälteroll" "hjälteroller" ;
  hjaernaktivitet_nn_1_1_N = mkN "hjärnaktivitet" "hjärnaktiviteter" ;
  hjaerncell_nn_1_1_N = mkN "hjärncell" "hjärnceller" ;
  hjaernhinneinflammation_nn_1_1_N = mkN "hjärnhinneinflammation" "hjärnhinneinflammationer" ;
  hjaerninflammation_nn_1_1_N = mkN "hjärninflammation" "hjärninflammationer" ;
  hjaernoperation_nn_1_1_N = mkN "hjärnoperation" "hjärnoperationer" ;
  hjaerntrust_nn_1_1_N = mkN "hjärntrust" "hjärntruster" ;
  hjaernvolym_nn_1_1_N = mkN "hjärnvolym" "hjärnvolymer" ;
  hjaertaktivitet_nn_1_1_N = mkN "hjärtaktivitet" "hjärtaktiviteter" ;
  hjaerteangelaegenhet_nn_1_1_N = mkN "hjärteangelägenhet" "hjärteangelägenheter" ;
  hjaertefroejd_nn_1_1_N = mkN "hjärtefröjd" "hjärtefröjder" ;
  hjaertesak_nn_1_1_N = mkN "hjärtesak" "hjärtesaker" ;
  hjaertesorg_nn_1_1_N = mkN "hjärtesorg" "hjärtesorger" ;
  hjaertetrakt_nn_1_1_N = mkN "hjärtetrakt" "hjärtetrakter" ;
  hjaertinnerlighet_nn_1_1_N = mkN "hjärtinnerlighet" "hjärtinnerligheter" ;
  hjaertkirurg_nn_1_1_N = mkN "hjärtkirurg" "hjärtkirurger" ;
  hjaertlighet_nn_1_1_N = mkN "hjärtlighet" "hjärtligheter" ;
  hjaertloeshet_nn_1_1_N = mkN "hjärtlöshet" "hjärtlösheter" ;
  hjaertoperation_nn_1_1_N = mkN "hjärtoperation" "hjärtoperationer" ;
  hjaertrytm_nn_1_1_N = mkN "hjärtrytm" "hjärtrytmer" ;
  hjaerttrakt_nn_1_1_N = mkN "hjärttrakt" "hjärttrakter" ;
  hjaerttransplantation_nn_1_1_N = mkN "hjärttransplantation" "hjärttransplantationer" ;
  hjaertverksamhet_nn_1_1_N = mkN "hjärtverksamhet" "hjärtverksamheter" ;
  hmong_nn_1_N = mkN "hmong" "hmonger" ;
  holism_nn_1_N = mkN "holism" "holismer" ;
  holonym_nn_1_N = mkN "holonym" "holonymer" ;
  homofon_nn_1_N = mkN "homofon" "homofoner" ;
  homogenitet_nn_1_N = mkN "homogenitet" "homogeniteter" ;
  homograf_nn_1_N = mkN "homograf" "homografer" ;
  homokultur_nn_1_N = mkN "homokultur" "homokulturer" ;
  homonym_nn_1_N = mkN "homonym" "homonymer" ;
  homosexualitet_nn_1_N = mkN "homosexualitet" "homosexualiteter" ;
  homozygot_nn_1_N = mkN "homozygot" "homozygoter" ;
  honduran_nn_1_N = mkN "honduran" "honduraner" ;
  honnoerspost_nn_1_1_N = mkN "honnörspost" "honnörsposter" ;
  honungsmelon_nn_1_N = mkN "honungsmelon" "honungsmeloner" ;
  honungsproducent_nn_1_N = mkN "honungsproducent" "honungsproducenter" ;
  hoplit_nn_1_N = mkN "hoplit" "hopliter" ;
  hoppfullhet_nn_1_N = mkN "hoppfullhet" "hoppfullheter" ;
  hopploeshet_nn_1_1_N = mkN "hopplöshet" "hopplösheter" ;
  hormonbalans_nn_1_N = mkN "hormonbalans" "hormonbalanser" ;
  hormonfunktion_nn_1_N = mkN "hormonfunktion" "hormonfunktioner" ;
  hormonhalt_nn_1_N = mkN "hormonhalt" "hormonhalter" ;
  hormonproduktion_nn_1_N = mkN "hormonproduktion" "hormonproduktioner" ;
  hornist_nn_1_N = mkN "hornist" "hornister" ;
  hostattack_nn_1_N = mkN "hostattack" "hostattacker" ;
  hotbild_nn_1_N = mkN "hotbild" "hotbilder" ;
  hotellfoaj_e_nn_1_1_N = mkN "hotellfoajé" "hotellfoajéer" ;
  hotellgaest_nn_1_1_N = mkN "hotellgäst" "hotellgäster" ;
  hotellobby_nn_1_N = mkN "hotellobby" "hotellobbyer" ;
  hotfullhet_nn_1_N = mkN "hotfullhet" "hotfullheter" ;
  hotnivaa_nn_1_1_N = mkN "hotnivå" "hotnivåer" ;
  hovdam_nn_1_N = mkN "hovdam" "hovdamer" ;
  hovleverantoer_nn_1_1_N = mkN "hovleverantör" "hovleverantörer" ;
  hovpredikant_nn_1_N = mkN "hovpredikant" "hovpredikanter" ;
  hovraett_nn_1_1_N = mkN "hovrätt" "hovrätter" ;
  hudcancerform_nn_1_N = mkN "hudcancerform" "hudcancerformer" ;
  hudcell_nn_1_N = mkN "hudcell" "hudceller" ;
  hudfaerg_nn_1_1_N = mkN "hudfärg" "hudfärger" ;
  hudinflammation_nn_1_N = mkN "hudinflammation" "hudinflammationer" ;
  hudspecialist_nn_1_N = mkN "hudspecialist" "hudspecialister" ;
  hudterapeut_nn_1_N = mkN "hudterapeut" "hudterapeuter" ;
  hudtransplantation_nn_1_N = mkN "hudtransplantation" "hudtransplantationer" ;
  hugnad_nn_1_N = mkN "hugnad" "hugnader" ;
  huligan_nn_1_N = mkN "huligan" "huliganer" ;
  humanism_nn_1_N = mkN "humanism" "humanismer" ;
  humanist_nn_1_N = mkN "humanist" "humanister" ;
  humanitet_nn_1_N = mkN "humanitet" "humaniteter" ;
  humanvetenskap_nn_1_N = mkN "humanvetenskap" "humanvetenskaper" ;
  hummersaas_nn_1_1_N = mkN "hummersås" "hummersåser" ;
  humoresk_nn_1_N = mkN "humoresk" "humoresker" ;
  humorist_nn_1_N = mkN "humorist" "humorister" ;
  humushalt_nn_1_N = mkN "humushalt" "humushalter" ;
  humuskoncentration_nn_1_N = mkN "humuskoncentration" "humuskoncentrationer" ;
  humussubstans_nn_1_N = mkN "humussubstans" "humussubstanser" ;
  hundkurs_nn_1_N = mkN "hundkurs" "hundkurser" ;
  hundras_nn_1_N = mkN "hundras" "hundraser" ;
  hundskatt_nn_1_N = mkN "hundskatt" "hundskatter" ;
  hundskulptur_nn_1_N = mkN "hundskulptur" "hundskulpturer" ;
  hundvakt_nn_1_N = mkN "hundvakt" "hundvakter" ;
  hungerstrejk_nn_1_N = mkN "hungerstrejk" "hungerstrejker" ;
  hunn_nn_1_N = mkN "hunn" "hunner" ;
  husarloejtnant_nn_1_1_N = mkN "husarlöjtnant" "husarlöjtnanter" ;
  husbyggnad_nn_1_N = mkN "husbyggnad" "husbyggnader" ;
  husdoktor_nn_1_N = mkN "husdoktor" "husdoktorer" ;
  husfasad_nn_1_N = mkN "husfasad" "husfasader" ;
  husgrund_nn_1_N = mkN "husgrund" "husgrunder" ;
  hushaallsbok_nn_1_1_N = mkN "hushållsbok" "hushållsböcker" ;
  huspredikant_nn_1_N = mkN "huspredikant" "huspredikanter" ;
  husrad_nn_1_N = mkN "husrad" "husrader" ;
  hustomt_nn_1_N = mkN "hustomt" "hustomter" ;
  hutloeshet_nn_1_1_N = mkN "hutlöshet" "hutlösheter" ;
  huvudanstalt_nn_1_N = mkN "huvudanstalt" "huvudanstalter" ;
  huvudbok_nn_1_N = mkN "huvudbok" "huvudböcker" ;
  huvudbonad_nn_1_N = mkN "huvudbonad" "huvudbonader" ;
  huvudbyggnad_nn_1_N = mkN "huvudbyggnad" "huvudbyggnader" ;
  huvudentr_e_nn_1_1_N = mkN "huvudentré" "huvudentréer" ;
  huvudfasad_nn_1_N = mkN "huvudfasad" "huvudfasader" ;
  huvudfigur_nn_1_N = mkN "huvudfigur" "huvudfigurer" ;
  huvudform_nn_1_N = mkN "huvudform" "huvudformer" ;
  huvudfunktion_nn_1_N = mkN "huvudfunktion" "huvudfunktioner" ;
  huvudinkomst_nn_1_N = mkN "huvudinkomst" "huvudinkomster" ;
  huvudled_nn_1_N = mkN "huvudled" "huvudleder" ;
  huvudloeshet_nn_1_1_N = mkN "huvudlöshet" "huvudlösheter" ;
  huvudmotor_nn_1_N = mkN "huvudmotor" "huvudmotorer" ;
  huvudorsak_nn_1_N = mkN "huvudorsak" "huvudorsaker" ;
  huvudort_nn_1_N = mkN "huvudort" "huvudorter" ;
  huvudperson_nn_1_N = mkN "huvudperson" "huvudpersoner" ;
  huvudpunkt_nn_1_N = mkN "huvudpunkt" "huvudpunkter" ;
  huvudroll_nn_1_N = mkN "huvudroll" "huvudroller" ;
  huvudraett_nn_1_1_N = mkN "huvudrätt" "huvudrätter" ;
  huvudsak_nn_1_N = mkN "huvudsak" "huvudsaker" ;
  huvudsats_nn_1_N = mkN "huvudsats" "huvudsatser" ;
  huvudton_nn_1_N = mkN "huvudton" "huvudtoner" ;
  huvudtrakt_nn_1_N = mkN "huvudtrakt" "huvudtrakter" ;
  huvuduppgift_nn_1_N = mkN "huvuduppgift" "huvuduppgifter" ;
  hybrid_nn_1_N = mkN "hybrid" "hybrider" ;
  hydrofon_nn_1_N = mkN "hydrofon" "hydrofoner" ;
  hydrokultur_nn_1_N = mkN "hydrokultur" "hydrokulturer" ;
  hydrolog_nn_1_N = mkN "hydrolog" "hydrologer" ;
  hydrolys_nn_1_N = mkN "hydrolys" "hydrolyser" ;
  hydroxid_nn_1_N = mkN "hydroxid" "hydroxider" ;
  hydroxidjon_nn_1_N = mkN "hydroxidjon" "hydroxidjoner" ;
  hygglighet_nn_1_N = mkN "hygglighet" "hyggligheter" ;
  hygienist_nn_1_N = mkN "hygienist" "hygienister" ;
  hygienkampanj_nn_1_N = mkN "hygienkampanj" "hygienkampanjer" ;
  hyllningsdikt_nn_1_N = mkN "hyllningsdikt" "hyllningsdikter" ;
  hyllningssaang_nn_1_1_N = mkN "hyllningssång" "hyllningssånger" ;
  hylsnyckelsats_nn_1_N = mkN "hylsnyckelsats" "hylsnyckelsatser" ;
  hylssats_nn_1_N = mkN "hylssats" "hylssatser" ;
  hyperbol_nn_1_N = mkN "hyperbol" "hyperboler" ;
  hyperinflation_nn_1_N = mkN "hyperinflation" "hyperinflationer" ;
  hyperit_nn_1_N = mkN "hyperit" "hyperiter" ;
  hypernym_nn_1_N = mkN "hypernym" "hypernymer" ;
  hyperonym_nn_1_N = mkN "hyperonym" "hyperonymer" ;
  hypersvecism_nn_1_N = mkN "hypersvecism" "hypersvecismer" ;
  hypertext_nn_1_N = mkN "hypertext" "hypertexter" ;
  hypnos_nn_1_N = mkN "hypnos" "hypnoser" ;
  hypnoskurs_nn_1_N = mkN "hypnoskurs" "hypnoskurser" ;
  hypnotism_nn_1_N = mkN "hypnotism" "hypnotismer" ;
  hypofys_nn_1_N = mkN "hypofys" "hypofyser" ;
  hypokrit_nn_1_N = mkN "hypokrit" "hypokriter" ;
  hyponym_nn_1_N = mkN "hyponym" "hyponymer" ;
  hypotes_nn_1_N = mkN "hypotes" "hypoteser" ;
  hyresgaest_nn_1_1_N = mkN "hyresgäst" "hyresgäster" ;
  hyreslaegenhet_nn_1_1_N = mkN "hyreslägenhet" "hyreslägenheter" ;
  hyresmarknad_nn_1_N = mkN "hyresmarknad" "hyresmarknader" ;
  hyresnaemnd_nn_1_1_N = mkN "hyresnämnd" "hyresnämnder" ;
  hyresraett_nn_1_1_N = mkN "hyresrätt" "hyresrätter" ;
  hyresstrejk_nn_1_N = mkN "hyresstrejk" "hyresstrejker" ;
  hyrestvist_nn_1_N = mkN "hyrestvist" "hyrestvister" ;
  hyvelbredd_nn_1_N = mkN "hyvelbredd" "hyvelbredder" ;
  haeckningsplats_nn_1_1_N = mkN "häckningsplats" "häckningsplatser" ;
  haeftpistol_nn_1_1_N = mkN "häftpistol" "häftpistoler" ;
  haegnad_nn_1_1_N = mkN "hägnad" "hägnader" ;
  haektesvakt_nn_1_1_N = mkN "häktesvakt" "häktesvakter" ;
  haektningstid_nn_1_1_N = mkN "häktningstid" "häktningstider" ;
  haellkonst_nn_1_1_N = mkN "hällkonst" "hällkonster" ;
  haellmark_nn_1_1_N = mkN "hällmark" "hällmarker" ;
  haelsningsfras_nn_1_1_N = mkN "hälsningsfras" "hälsningsfraser" ;
  haelsodryck_nn_1_1_N = mkN "hälsodryck" "hälsodrycker" ;
  haelsofantast_nn_1_1_N = mkN "hälsofantast" "hälsofantaster" ;
  haelsofarlighet_nn_1_1_N = mkN "hälsofarlighet" "hälsofarligheter" ;
  haelsokontroll_nn_1_1_N = mkN "hälsokontroll" "hälsokontroller" ;
  haelsorisk_nn_1_1_N = mkN "hälsorisk" "hälsorisker" ;
  haelsovaadlighet_nn_1_1_N = mkN "hälsovådlighet" "hälsovådligheter" ;
  haelsovaardskostnad_nn_1_1_N = mkN "hälsovårdskostnad" "hälsovårdskostnader" ;
  haelsovaardsnaemnd_nn_1_1_N = mkN "hälsovårdsnämnd" "hälsovårdsnämnder" ;
  haemndaktion_nn_1_1_N = mkN "hämndaktion" "hämndaktioner" ;
  haemndattack_nn_1_1_N = mkN "hämndattack" "hämndattacker" ;
  haemndeaktion_nn_1_1_N = mkN "hämndeaktion" "hämndeaktioner" ;
  haemndlystnad_nn_1_1_N = mkN "hämndlystnad" "hämndlystnader" ;
  haemndrekyl_nn_1_1_N = mkN "hämndrekyl" "hämndrekyler" ;
  haemningsloeshet_nn_1_1_N = mkN "hämningslöshet" "hämningslösheter" ;
  haendelsehorisont_nn_1_1_N = mkN "händelsehorisont" "händelsehorisonter" ;
  haengkoj_nn_1_1_N = mkN "hängkoj" "hängkojer" ;
  haensynsfullhet_nn_1_1_N = mkN "hänsynsfullhet" "hänsynsfullheter" ;
  haensynsloeshet_nn_1_1_N = mkN "hänsynslöshet" "hänsynslösheter" ;
  haenthet_nn_1_1_N = mkN "hänthet" "häntheter" ;
  haepnad_nn_1_1_N = mkN "häpnad" "häpnader" ;
  haeradsraett_nn_1_1_N = mkN "häradsrätt" "häradsrätter" ;
  haerdighet_nn_1_1_N = mkN "härdighet" "härdigheter" ;
  haerdningstid_nn_1_1_N = mkN "härdningstid" "härdningstider" ;
  haerdplast_nn_1_1_N = mkN "härdplast" "härdplaster" ;
  haerdtid_nn_1_1_N = mkN "härdtid" "härdtider" ;
  haerlighet_nn_1_1_N = mkN "härlighet" "härligheter" ;
  haernad_nn_1_1_N = mkN "härnad" "härnader" ;
  haerskarfamilj_nn_1_1_N = mkN "härskarfamilj" "härskarfamiljer" ;
  haerskarklass_nn_1_1_N = mkN "härskarklass" "härskarklasser" ;
  haesthovsoert_nn_1_1_N = mkN "hästhovsört" "hästhovsörter" ;
  haestkastanj_nn_1_1_N = mkN "hästkastanj" "hästkastanjer" ;
  haestras_nn_1_1_N = mkN "hästras" "hästraser" ;
  haestskomagnet_nn_1_1_N = mkN "hästskomagnet" "hästskomagneter" ;
  haeststaty_nn_1_1_N = mkN "häststaty" "häststatyer" ;
  haesttjej_nn_1_1_N = mkN "hästtjej" "hästtjejer" ;
  haetskhet_nn_1_1_N = mkN "hätskhet" "hätskheter" ;
  haexdans_nn_1_1_N = mkN "häxdans" "häxdanser" ;
  haexjakt_nn_1_1_N = mkN "häxjakt" "häxjakter" ;
  haexkonspiration_nn_1_1_N = mkN "häxkonspiration" "häxkonspirationer" ;
  haexkonst_nn_1_1_N = mkN "häxkonst" "häxkonster" ;
  haexkraft_nn_1_1_N = mkN "häxkraft" "häxkrafter" ;
  haexprocess_nn_1_1_N = mkN "häxprocess" "häxprocesser" ;
  haagkomst_nn_1_1_N = mkN "hågkomst" "hågkomster" ;
  haalighet_nn_1_1_N = mkN "hålighet" "håligheter" ;
  haallbarhet_nn_1_1_N = mkN "hållbarhet" "hållbarheter" ;
  haalldam_nn_1_1_N = mkN "hålldam" "hålldamer" ;
  haallfasthet_nn_1_1_N = mkN "hållfasthet" "hållfastheter" ;
  haallplats_nn_1_1_N = mkN "hållplats" "hållplatser" ;
  haallpunkt_nn_1_1_N = mkN "hållpunkt" "hållpunkter" ;
  haalltid_nn_1_1_N = mkN "hålltid" "hålltider" ;
  haanfullhet_nn_1_1_N = mkN "hånfullhet" "hånfullheter" ;
  haarbeklaednad_nn_1_1_N = mkN "hårbeklädnad" "hårbeklädnader" ;
  haardhet_nn_2_1_N = mkN "hårdhet" "hårdheter" ;
  haardplast_nn_1_1_N = mkN "hårdplast" "hårdplaster" ;
  haarfrisoer_nn_1_1_N = mkN "hårfrisör" "hårfrisörer" ;
  haarfaerg_nn_1_1_N = mkN "hårfärg" "hårfärger" ;
  haarvegetation_nn_1_1_N = mkN "hårvegetation" "hårvegetationer" ;
  hoeftled_nn_1_1_N = mkN "höftled" "höftleder" ;
  hoeftledsoperation_nn_1_1_N = mkN "höftledsoperation" "höftledsoperationer" ;
  hoegenergikollision_nn_1_1_N = mkN "högenergikollision" "högenergikollisioner" ;
  hoegerkoalition_nn_1_1_N = mkN "högerkoalition" "högerkoalitioner" ;
  hoegermajoritet_nn_1_1_N = mkN "högermajoritet" "högermajoriteter" ;
  hoegermyt_nn_1_1_N = mkN "högermyt" "högermyter" ;
  hoegform_nn_2_1_N = mkN "högform" "högformer" ;
  hoegfrekvens_nn_1_1_N = mkN "högfrekvens" "högfrekvenser" ;
  hoeghet_nn_1_1_N = mkN "höghet" "högheter" ;
  hoegkonjunktur_nn_1_1_N = mkN "högkonjunktur" "högkonjunkturer" ;
  hoegkultur_nn_1_1_N = mkN "högkultur" "högkulturer" ;
  hoegmaalsprocess_nn_1_1_N = mkN "högmålsprocess" "högmålsprocesser" ;
  hoegplataa_nn_1_1_N = mkN "högplatå" "högplatåer" ;
  hoegrestaandsdam_nn_1_1_N = mkN "högreståndsdam" "högreståndsdamer" ;
  hoegrestaandskultur_nn_1_1_N = mkN "högreståndskultur" "högreståndskulturer" ;
  hoegriskfond_nn_1_1_N = mkN "högriskfond" "högriskfonder" ;
  hoegriskmatch_nn_1_1_N = mkN "högriskmatch" "högriskmatcher" ;
  hoegskolelektor_nn_1_1_N = mkN "högskolelektor" "högskolelektorer" ;
  hoegskoleplats_nn_1_1_N = mkN "högskoleplats" "högskoleplatser" ;
  hoegsaesong_nn_1_1_N = mkN "högsäsong" "högsäsonger" ;
  hoegtidlighet_nn_1_1_N = mkN "högtidlighet" "högtidligheter" ;
  hoegtidsdraekt_nn_1_1_N = mkN "högtidsdräkt" "högtidsdräkter" ;
  hoegvakt_nn_1_1_N = mkN "högvakt" "högvakter" ;
  hoegvoerdighet_nn_1_1_N = mkN "högvördighet" "högvördigheter" ;
  hoejd_nn_1_1_N = mkN "höjd" "höjder" ;
  hoejdskillnad_nn_1_1_N = mkN "höjdskillnad" "höjdskillnader" ;
  hoerbarhet_nn_1_1_N = mkN "hörbarhet" "hörbarheter" ;
  hoerselklass_nn_1_1_N = mkN "hörselklass" "hörselklasser" ;
  hoertelefon_nn_1_1_N = mkN "hörtelefon" "hörtelefoner" ;
  hoestkantarell_nn_1_1_N = mkN "höstkantarell" "höstkantareller" ;
  hoestmaanad_nn_1_1_N = mkN "höstmånad" "höstmånader" ;
  hoestslakt_nn_1_1_N = mkN "höstslakt" "höstslakter" ;
  hoestsaesong_nn_1_1_N = mkN "höstsäsong" "höstsäsonger" ;
  hoesttermin_nn_1_1_N = mkN "hösttermin" "höstterminer" ;
  hoeviskhet_nn_1_1_N = mkN "höviskhet" "höviskheter" ;
  hoevlighet_nn_1_1_N = mkN "hövlighet" "hövligheter" ;
  hoevlighetsvisit_nn_1_1_N = mkN "hövlighetsvisit" "hövlighetsvisiter" ;
  icke_muslim_nn_1_N = mkN "icke-muslim" "icke-muslimer" ;
  icke_specialist_nn_1_N = mkN "icke-specialist" "icke-specialister" ;
  ickevaaldsentusiast_nn_1_1_N = mkN "ickevåldsentusiast" "ickevåldsentusiaster" ;
  idealbild_nn_1_N = mkN "idealbild" "idealbilder" ;
  idealism_nn_1_N = mkN "idealism" "idealismer" ;
  idealist_nn_1_N = mkN "idealist" "idealister" ;
  idealitet_nn_1_N = mkN "idealitet" "idealiteter" ;
  identifikation_nn_1_N = mkN "identifikation" "identifikationer" ;
  identifikationsprocess_nn_1_N = mkN "identifikationsprocess" "identifikationsprocesser" ;
  identitet_nn_1_N = mkN "identitet" "identiteter" ;
  identitetskris_nn_1_N = mkN "identitetskris" "identitetskriser" ;
  ideolog_nn_1_N = mkN "ideolog" "ideologer" ;
  idol_nn_1_N = mkN "idol" "idoler" ;
  idrott_nn_1_N = mkN "idrott" "idrotter" ;
  idrottsdraekt_nn_1_1_N = mkN "idrottsdräkt" "idrottsdräkter" ;
  idrottsplats_nn_1_N = mkN "idrottsplats" "idrottsplatser" ;
  idrottsprestation_nn_1_N = mkN "idrottsprestation" "idrottsprestationer" ;
  id_eassociation_nn_1_1_N = mkN "idéassociation" "idéassociationer" ;
  igenkaenningsfaktor_nn_1_1_N = mkN "igenkänningsfaktor" "igenkänningsfaktorer" ;
  igenkaenningssignal_nn_1_1_N = mkN "igenkänningssignal" "igenkänningssignaler" ;
  ignorant_nn_1_N = mkN "ignorant" "ignoranter" ;
  ihaagkomst_nn_1_1_N = mkN "ihågkomst" "ihågkomster" ;
  ihaalighet_nn_1_1_N = mkN "ihålighet" "ihåligheter" ;
  ikon_nn_1_N = mkN "ikon" "ikoner" ;
  ikonostas_nn_1_N = mkN "ikonostas" "ikonostaser" ;
  iktyolog_nn_1_N = mkN "iktyolog" "iktyologer" ;
  illegalitet_nn_1_N = mkN "illegalitet" "illegaliteter" ;
  illegitimitet_nn_1_N = mkN "illegitimitet" "illegitimiteter" ;
  illslughet_nn_1_N = mkN "illslughet" "illslugheter" ;
  illumination_nn_1_N = mkN "illumination" "illuminationer" ;
  illusion_nn_1_N = mkN "illusion" "illusioner" ;
  illusionist_nn_1_N = mkN "illusionist" "illusionister" ;
  illusionsloeshet_nn_1_1_N = mkN "illusionslöshet" "illusionslösheter" ;
  illustration_nn_1_N = mkN "illustration" "illustrationer" ;
  illvillighet_nn_1_N = mkN "illvillighet" "illvilligheter" ;
  illyr_nn_1_N = mkN "illyr" "illyrer" ;
  ilmarsch_nn_1_N = mkN "ilmarsch" "ilmarscher" ;
  imitation_nn_1_N = mkN "imitation" "imitationer" ;
  immatrikulation_nn_1_N = mkN "immatrikulation" "immatrikulationer" ;
  immigrant_nn_1_N = mkN "immigrant" "immigranter" ;
  immigration_nn_1_N = mkN "immigration" "immigrationer" ;
  immission_nn_1_N = mkN "immission" "immissioner" ;
  immunbrist_nn_1_N = mkN "immunbrist" "immunbrister" ;
  immunitet_nn_1_N = mkN "immunitet" "immuniteter" ;
  immunolog_nn_1_N = mkN "immunolog" "immunologer" ;
  imperativ_nn_1_N = mkN "imperativ" "imperativer" ;
  imperator_nn_1_N = mkN "imperator" "imperatorer" ;
  imperialism_nn_1_N = mkN "imperialism" "imperialismer" ;
  imperialist_nn_1_N = mkN "imperialist" "imperialister" ;
  impertinens_nn_1_N = mkN "impertinens" "impertinenser" ;
  implikation_nn_1_N = mkN "implikation" "implikationer" ;
  implosion_nn_1_N = mkN "implosion" "implosioner" ;
  impopularitet_nn_1_N = mkN "impopularitet" "impopulariteter" ;
  import_nn_1_N = mkN "import" "importer" ;
  importavgift_nn_1_N = mkN "importavgift" "importavgifter" ;
  importkvot_nn_1_N = mkN "importkvot" "importkvoter" ;
  impost_nn_1_N = mkN "impost" "imposter" ;
  impressionism_nn_1_N = mkN "impressionism" "impressionismer" ;
  impressionist_nn_1_N = mkN "impressionist" "impressionister" ;
  improvisation_nn_1_N = mkN "improvisation" "improvisationer" ;
  impuls_nn_1_N = mkN "impuls" "impulser" ;
  impulsivitet_nn_1_N = mkN "impulsivitet" "impulsiviteter" ;
  inadvertens_nn_1_N = mkN "inadvertens" "inadvertenser" ;
  inaktivitet_nn_1_N = mkN "inaktivitet" "inaktiviteter" ;
  inauguration_nn_1_N = mkN "inauguration" "inaugurationer" ;
  inbilskhet_nn_1_N = mkN "inbilskhet" "inbilskheter" ;
  inbjudningsskrift_nn_1_N = mkN "inbjudningsskrift" "inbjudningsskrifter" ;
  incest_nn_1_N = mkN "incest" "incester" ;
  indelningsgrund_nn_1_N = mkN "indelningsgrund" "indelningsgrunder" ;
  indelningsprincip_nn_1_N = mkN "indelningsprincip" "indelningsprinciper" ;
  indian_nn_1_N = mkN "indian" "indianer" ;
  indianbok_nn_1_N = mkN "indianbok" "indianböcker" ;
  indifferentism_nn_1_N = mkN "indifferentism" "indifferentismer" ;
  indigestion_nn_1_N = mkN "indigestion" "indigestioner" ;
  indignation_nn_1_N = mkN "indignation" "indignationer" ;
  indikation_nn_1_N = mkN "indikation" "indikationer" ;
  indikativ_nn_1_N = mkN "indikativ" "indikativer" ;
  indikator_nn_1_N = mkN "indikator" "indikatorer" ;
  indiskretion_nn_1_N = mkN "indiskretion" "indiskretioner" ;
  indisposition_nn_1_N = mkN "indisposition" "indispositioner" ;
  individakt_nn_1_N = mkN "individakt" "individakter" ;
  individualism_nn_1_N = mkN "individualism" "individualismer" ;
  individualist_nn_1_N = mkN "individualist" "individualister" ;
  individualitet_nn_1_N = mkN "individualitet" "individualiteter" ;
  individualprevention_nn_1_N = mkN "individualprevention" "individualpreventioner" ;
  indolog_nn_1_N = mkN "indolog" "indologer" ;
  indones_nn_1_N = mkN "indones" "indoneser" ;
  induktion_nn_1_N = mkN "induktion" "induktioner" ;
  induktionsmotor_nn_1_N = mkN "induktionsmotor" "induktionsmotorer" ;
  induktor_nn_1_N = mkN "induktor" "induktorer" ;
  industrialism_nn_1_N = mkN "industrialism" "industrialismer" ;
  industridiamant_nn_1_N = mkN "industridiamant" "industridiamanter" ;
  industriprodukt_nn_1_N = mkN "industriprodukt" "industriprodukter" ;
  industriregion_nn_1_N = mkN "industriregion" "industriregioner" ;
  inessiv_nn_1_N = mkN "inessiv" "inessiver" ;
  infant_nn_1_N = mkN "infant" "infanter" ;
  infanterimarsch_nn_1_N = mkN "infanterimarsch" "infanterimarscher" ;
  infanterist_nn_1_N = mkN "infanterist" "infanterister" ;
  infantilism_nn_1_N = mkN "infantilism" "infantilismer" ;
  infartsled_nn_1_N = mkN "infartsled" "infartsleder" ;
  infektion_nn_1_N = mkN "infektion" "infektioner" ;
  infiltration_nn_1_N = mkN "infiltration" "infiltrationer" ;
  infinitiv_nn_1_N = mkN "infinitiv" "infinitiver" ;
  inflammation_nn_1_N = mkN "inflammation" "inflammationer" ;
  inflation_nn_1_N = mkN "inflation" "inflationer" ;
  inflationsfas_nn_1_N = mkN "inflationsfas" "inflationsfaser" ;
  influens_nn_1_N = mkN "influens" "influenser" ;
  influensamedicin_nn_1_N = mkN "influensamedicin" "influensamediciner" ;
  informant_nn_1_N = mkN "informant" "informanter" ;
  information_nn_1_N = mkN "information" "informationer" ;
  informationsbroschyr_nn_1_N = mkN "informationsbroschyr" "informationsbroschyrer" ;
  informationsbyraa_nn_1_1_N = mkN "informationsbyrå" "informationsbyråer" ;
  informationschef_nn_1_N = mkN "informationschef" "informationschefer" ;
  informator_nn_1_N = mkN "informator" "informatorer" ;
  infrastruktur_nn_1_N = mkN "infrastruktur" "infrastrukturer" ;
  infusion_nn_1_N = mkN "infusion" "infusioner" ;
  ingefaersvaext_nn_1_1_N = mkN "ingefärsväxt" "ingefärsväxter" ;
  ingenjoer_nn_1_1_N = mkN "ingenjör" "ingenjörer" ;
  ingenjoersstudent_nn_1_1_N = mkN "ingenjörsstudent" "ingenjörsstudenter" ;
  ingenjoersvetenskap_nn_1_1_N = mkN "ingenjörsvetenskap" "ingenjörsvetenskaper" ;
  ingeny_nn_1_N = mkN "ingeny" "ingenyer" ;
  ingrediens_nn_1_N = mkN "ingrediens" "ingredienser" ;
  ingress_nn_1_N = mkN "ingress" "ingresser" ;
  ingaangsloen_nn_1_1_N = mkN "ingångslön" "ingångslöner" ;
  ingaangsmarsch_nn_1_1_N = mkN "ingångsmarsch" "ingångsmarscher" ;
  inhalation_nn_1_N = mkN "inhalation" "inhalationer" ;
  inhalator_nn_1_N = mkN "inhalator" "inhalatorer" ;
  inhibitor_nn_1_N = mkN "inhibitor" "inhibitorer" ;
  inhyseshjon_nn_1_N = mkN "inhyseshjon" "inhyseshjoner" ;
  inhaegnad_nn_1_1_N = mkN "inhägnad" "inhägnader" ;
  initialsvaarighet_nn_1_1_N = mkN "initialsvårighet" "initialsvårigheter" ;
  initiation_nn_1_N = mkN "initiation" "initiationer" ;
  initiationsrit_nn_1_N = mkN "initiationsrit" "initiationsriter" ;
  injektion_nn_1_N = mkN "injektion" "injektioner" ;
  injektor_nn_1_N = mkN "injektor" "injektorer" ;
  inkaindian_nn_1_N = mkN "inkaindian" "inkaindianer" ;
  inkarnation_nn_1_N = mkN "inkarnation" "inkarnationer" ;
  inklination_nn_1_N = mkN "inklination" "inklinationer" ;
  inkomst_nn_1_N = mkN "inkomst" "inkomster" ;
  inkomstpost_nn_1_N = mkN "inkomstpost" "inkomstposter" ;
  inkomstskatt_nn_1_N = mkN "inkomstskatt" "inkomstskatter" ;
  inkomstskillnad_nn_1_N = mkN "inkomstskillnad" "inkomstskillnader" ;
  inkongruens_nn_1_N = mkN "inkongruens" "inkongruenser" ;
  inkonsekvens_nn_1_N = mkN "inkonsekvens" "inkonsekvenser" ;
  inkrustation_nn_1_N = mkN "inkrustation" "inkrustationer" ;
  inkubation_nn_1_N = mkN "inkubation" "inkubationer" ;
  inkvisition_nn_1_N = mkN "inkvisition" "inkvisitioner" ;
  inkvisitor_nn_1_N = mkN "inkvisitor" "inkvisitorer" ;
  inledningsrad_nn_1_N = mkN "inledningsrad" "inledningsrader" ;
  inloggningsuppgift_nn_1_N = mkN "inloggningsuppgift" "inloggningsuppgifter" ;
  inlaerningsplataa_nn_1_1_N = mkN "inlärningsplatå" "inlärningsplatåer" ;
  inmarsch_nn_1_N = mkN "inmarsch" "inmarscher" ;
  inmatningsbredd_nn_1_N = mkN "inmatningsbredd" "inmatningsbredder" ;
  innehaallsanalys_nn_1_1_N = mkN "innehållsanalys" "innehållsanalyser" ;
  innehaallsdeklaration_nn_1_1_N = mkN "innehållsdeklaration" "innehållsdeklarationer" ;
  innervation_nn_1_N = mkN "innervation" "innervationer" ;
  innovation_nn_1_N = mkN "innovation" "innovationer" ;
  innovationskaskad_nn_1_N = mkN "innovationskaskad" "innovationskaskader" ;
  inokulation_nn_1_N = mkN "inokulation" "inokulationer" ;
  inombordsmotor_nn_1_N = mkN "inombordsmotor" "inombordsmotorer" ;
  inomhusidrott_nn_1_N = mkN "inomhusidrott" "inomhusidrotter" ;
  inredningsdetalj_nn_1_N = mkN "inredningsdetalj" "inredningsdetaljer" ;
  inredningsgenialitet_nn_1_N = mkN "inredningsgenialitet" "inredningsgenialiteter" ;
  inremission_nn_1_N = mkN "inremission" "inremissioner" ;
  insats_nn_1_N = mkN "insats" "insatser" ;
  insatslaegenhet_nn_1_1_N = mkN "insatslägenhet" "insatslägenheter" ;
  insekt_nn_1_N = mkN "insekt" "insekter" ;
  insekticid_nn_1_N = mkN "insekticid" "insekticider" ;
  insemination_nn_1_N = mkN "insemination" "inseminationer" ;
  insinuation_nn_1_N = mkN "insinuation" "insinuationer" ;
  inskolningsprocess_nn_1_N = mkN "inskolningsprocess" "inskolningsprocesser" ;
  inskrift_nn_1_N = mkN "inskrift" "inskrifter" ;
  inskription_nn_1_N = mkN "inskription" "inskriptioner" ;
  inskrivningsbok_nn_1_N = mkN "inskrivningsbok" "inskrivningsböcker" ;
  inskraenkthet_nn_1_1_N = mkN "inskränkthet" "inskränktheter" ;
  insolation_nn_1_N = mkN "insolation" "insolationer" ;
  inspektion_nn_1_N = mkN "inspektion" "inspektioner" ;
  inspektor_nn_1_N = mkN "inspektor" "inspektorer" ;
  inspektoer_nn_1_1_N = mkN "inspektör" "inspektörer" ;
  inspiration_nn_1_N = mkN "inspiration" "inspirationer" ;
  insprutningsmotor_nn_1_N = mkN "insprutningsmotor" "insprutningsmotorer" ;
  instabilitet_nn_1_N = mkN "instabilitet" "instabiliteter" ;
  installand_nn_1_N = mkN "installand" "installander" ;
  installation_nn_1_N = mkN "installation" "installationer" ;
  installator_nn_1_N = mkN "installator" "installatorer" ;
  instans_nn_1_N = mkN "instans" "instanser" ;
  institution_nn_1_N = mkN "institution" "institutioner" ;
  instruktion_nn_1_N = mkN "instruktion" "instruktioner" ;
  instruktionsmanual_nn_1_N = mkN "instruktionsmanual" "instruktionsmanualer" ;
  instruktoer_nn_1_1_N = mkN "instruktör" "instruktörer" ;
  instrumentalist_nn_1_N = mkN "instrumentalist" "instrumentalister" ;
  instrumentation_nn_1_N = mkN "instrumentation" "instrumentationer" ;
  instaellsamhet_nn_1_1_N = mkN "inställsamhet" "inställsamheter" ;
  insubordination_nn_1_N = mkN "insubordination" "insubordinationer" ;
  insufficiens_nn_1_N = mkN "insufficiens" "insufficienser" ;
  integralkalkyl_nn_1_N = mkN "integralkalkyl" "integralkalkyler" ;
  integration_nn_1_N = mkN "integration" "integrationer" ;
  integritet_nn_1_N = mkN "integritet" "integriteter" ;
  intellektualism_nn_1_N = mkN "intellektualism" "intellektualismer" ;
  intellektualist_nn_1_N = mkN "intellektualist" "intellektualister" ;
  intelligens_nn_1_N = mkN "intelligens" "intelligenser" ;
  intelligenskvot_nn_1_N = mkN "intelligenskvot" "intelligenskvoter" ;
  intendentur_nn_1_N = mkN "intendentur" "intendenturer" ;
  intendenturtjaenst_nn_1_1_N = mkN "intendenturtjänst" "intendenturtjänster" ;
  intension_nn_1_N = mkN "intension" "intensioner" ;
  intensitet_nn_1_N = mkN "intensitet" "intensiteter" ;
  intention_nn_1_N = mkN "intention" "intentioner" ;
  interaktion_nn_1_N = mkN "interaktion" "interaktioner" ;
  interferens_nn_1_N = mkN "interferens" "interferenser" ;
  interglacialtid_nn_1_N = mkN "interglacialtid" "interglacialtider" ;
  interjektion_nn_1_N = mkN "interjektion" "interjektioner" ;
  internationalism_nn_1_N = mkN "internationalism" "internationalismer" ;
  internationalist_nn_1_N = mkN "internationalist" "internationalister" ;
  internist_nn_1_N = mkN "internist" "internister" ;
  internutredningsgrupp_nn_1_N = mkN "internutredningsgrupp" "internutredningsgrupper" ;
  interpellant_nn_1_N = mkN "interpellant" "interpellanter" ;
  interpellation_nn_1_N = mkN "interpellation" "interpellationer" ;
  interpolation_nn_1_N = mkN "interpolation" "interpolationer" ;
  interpretation_nn_1_N = mkN "interpretation" "interpretationer" ;
  interpunktion_nn_1_N = mkN "interpunktion" "interpunktioner" ;
  intervention_nn_1_N = mkN "intervention" "interventioner" ;
  intighet_nn_1_N = mkN "intighet" "intigheter" ;
  intimist_nn_1_N = mkN "intimist" "intimister" ;
  intimitet_nn_1_N = mkN "intimitet" "intimiteter" ;
  intonation_nn_1_N = mkN "intonation" "intonationer" ;
  intoxikation_nn_1_N = mkN "intoxikation" "intoxikationer" ;
  intressegemenskap_nn_1_N = mkN "intressegemenskap" "intressegemenskaper" ;
  intressegrupp_nn_1_N = mkN "intressegrupp" "intressegrupper" ;
  intressekonflikt_nn_1_N = mkN "intressekonflikt" "intressekonflikter" ;
  intresseorganisation_nn_1_N = mkN "intresseorganisation" "intresseorganisationer" ;
  intrigant_nn_1_N = mkN "intrigant" "intriganter" ;
  introduktion_nn_1_N = mkN "introduktion" "introduktioner" ;
  introduktionskurs_nn_1_N = mkN "introduktionskurs" "introduktionskurser" ;
  introspektion_nn_1_N = mkN "introspektion" "introspektioner" ;
  introversion_nn_1_N = mkN "introversion" "introversioner" ;
  intraedesavgift_nn_1_1_N = mkN "inträdesavgift" "inträdesavgifter" ;
  intubation_nn_1_N = mkN "intubation" "intubationer" ;
  intuition_nn_1_N = mkN "intuition" "intuitioner" ;
  intaektsmoejlighet_nn_1_1_N = mkN "intäktsmöjlighet" "intäktsmöjligheter" ;
  inuit_nn_1_N = mkN "inuit" "inuiter" ;
  invalid_nn_1_N = mkN "invalid" "invalider" ;
  invaliditet_nn_1_N = mkN "invaliditet" "invaliditeter" ;
  invandrargrupp_nn_1_N = mkN "invandrargrupp" "invandrargrupper" ;
  invandrarklass_nn_1_N = mkN "invandrarklass" "invandrarklasser" ;
  invandrarteatergrupp_nn_1_N = mkN "invandrarteatergrupp" "invandrarteatergrupper" ;
  invandringskvot_nn_1_N = mkN "invandringskvot" "invandringskvoter" ;
  invasion_nn_1_N = mkN "invasion" "invasioner" ;
  invasionsarm_e_nn_1_1_N = mkN "invasionsarmé" "invasionsarméer" ;
  inventariebok_nn_1_N = mkN "inventariebok" "inventarieböcker" ;
  invers_nn_1_N = mkN "invers" "inverser" ;
  inversion_nn_1_N = mkN "inversion" "inversioner" ;
  investeringsfond_nn_1_N = mkN "investeringsfond" "investeringsfonder" ;
  investeringsform_nn_1_N = mkN "investeringsform" "investeringsformer" ;
  invintringsprocess_nn_1_N = mkN "invintringsprocess" "invintringsprocesser" ;
  invit_nn_1_N = mkN "invit" "inviter" ;
  invitation_nn_1_N = mkN "invitation" "invitationer" ;
  invokation_nn_1_N = mkN "invokation" "invokationer" ;
  irredentism_nn_1_N = mkN "irredentism" "irredentismer" ;
  irreligiositet_nn_1_N = mkN "irreligiositet" "irreligiositeter" ;
  irrfaerd_nn_1_1_N = mkN "irrfärd" "irrfärder" ;
  irrigation_nn_1_N = mkN "irrigation" "irrigationer" ;
  irritation_nn_1_N = mkN "irritation" "irritationer" ;
  isbrytarassistans_nn_1_N = mkN "isbrytarassistans" "isbrytarassistanser" ;
  isbrytaregenskap_nn_1_N = mkN "isbrytaregenskap" "isbrytaregenskaper" ;
  isjakt_nn_1_N = mkN "isjakt" "isjakter" ;
  iskant_nn_1_N = mkN "iskant" "iskanter" ;
  iskonvalj_nn_1_N = mkN "iskonvalj" "iskonvaljer" ;
  iskristall_nn_1_N = mkN "iskristall" "iskristaller" ;
  islamism_nn_1_N = mkN "islamism" "islamismer" ;
  islamist_nn_1_N = mkN "islamist" "islamister" ;
  ism_nn_1_N = mkN "ism" "ismer" ;
  isobar_nn_1_N = mkN "isobar" "isobarer" ;
  isogloss_nn_1_N = mkN "isogloss" "isoglosser" ;
  isogon_nn_1_N = mkN "isogon" "isogoner" ;
  isolationism_nn_1_N = mkN "isolationism" "isolationismer" ;
  isolator_nn_1_N = mkN "isolator" "isolatorer" ;
  isoleringsklass_nn_1_N = mkN "isoleringsklass" "isoleringsklasser" ;
  isomer_nn_1_N = mkN "isomer" "isomerer" ;
  israelit_nn_1_N = mkN "israelit" "israeliter" ;
  israpport_nn_1_N = mkN "israpport" "israpporter" ;
  isrevy_nn_1_N = mkN "isrevy" "isrevyer" ;
  iteration_nn_1_N = mkN "iteration" "iterationer" ;
  ivorian_nn_1_N = mkN "ivorian" "ivorianer" ;
  jackett_nn_1_N = mkN "jackett" "jacketter" ;
  jagillusion_nn_1_N = mkN "jagillusion" "jagillusioner" ;
  jagsvaghet_nn_1_N = mkN "jagsvaghet" "jagsvagheter" ;
  jainism_nn_1_N = mkN "jainism" "jainismer" ;
  jakobin_nn_1_N = mkN "jakobin" "jakobiner" ;
  jakt_nn_1_N = mkN "jakt" "jakter" ;
  jaktavgift_nn_1_N = mkN "jaktavgift" "jaktavgifter" ;
  jaktexpedition_nn_1_N = mkN "jaktexpedition" "jaktexpeditioner" ;
  jaktmark_nn_1_N = mkN "jaktmark" "jaktmarker" ;
  jakttrof_e_nn_1_1_N = mkN "jakttrofé" "jakttroféer" ;
  jamaican_nn_1_N = mkN "jamaican" "jamaicaner" ;
  jamaikan_nn_1_N = mkN "jamaikan" "jamaikaner" ;
  jansenism_nn_1_N = mkN "jansenism" "jansenismer" ;
  japan_nn_1_N = mkN "japan" "japaner" ;
  japanes_nn_1_N = mkN "japanes" "japaneser" ;
  japroposition_nn_1_N = mkN "japroposition" "japropositioner" ;
  jaroest_nn_1_1_N = mkN "jaröst" "jaröster" ;
  jasmin_nn_1_N = mkN "jasmin" "jasminer" ;
  javan_nn_1_N = mkN "javan" "javaner" ;
  javanes_nn_1_N = mkN "javanes" "javaneser" ;
  jemenit_nn_1_N = mkN "jemenit" "jemeniter" ;
  jesuit_nn_1_N = mkN "jesuit" "jesuiter" ;
  jetmotor_nn_1_N = mkN "jetmotor" "jetmotorer" ;
  jingoism_nn_1_N = mkN "jingoism" "jingoismer" ;
  jobbighet_nn_2_N = mkN "jobbighet" "jobbigheter" ;
  jobbprognos_nn_1_N = mkN "jobbprognos" "jobbprognoser" ;
  jobbras_nn_1_N = mkN "jobbras" "jobbraser" ;
  jobbsoekaraktivitet_nn_1_1_N = mkN "jobbsökaraktivitet" "jobbsökaraktiviteter" ;
  jobspost_nn_1_N = mkN "jobspost" "jobsposter" ;
  jockej_nn_1_N = mkN "jockej" "jockejer" ;
  joggingtur_nn_1_N = mkN "joggingtur" "joggingturer" ;
  johannesoert_nn_1_1_N = mkN "johannesört" "johannesörter" ;
  johannit_nn_1_N = mkN "johannit" "johanniter" ;
  jon_nn_1_N = mkN "jon" "joner" ;
  jonisation_nn_1_N = mkN "jonisation" "jonisationer" ;
  joniseringstendens_nn_1_N = mkN "joniseringstendens" "joniseringstendenser" ;
  jonkill_nn_1_N = mkN "jonkill" "jonkiller" ;
  jonkvill_nn_1_N = mkN "jonkvill" "jonkviller" ;
  jordanalys_nn_1_N = mkN "jordanalys" "jordanalyser" ;
  jordart_nn_1_N = mkN "jordart" "jordarter" ;
  jordbruksmark_nn_1_N = mkN "jordbruksmark" "jordbruksmarker" ;
  jordbruksmaskin_nn_1_N = mkN "jordbruksmaskin" "jordbruksmaskiner" ;
  jordbruksnaemnd_nn_1_1_N = mkN "jordbruksnämnd" "jordbruksnämnder" ;
  jordbruksprodukt_nn_1_N = mkN "jordbruksprodukt" "jordbruksprodukter" ;
  jordbruksreform_nn_1_N = mkN "jordbruksreform" "jordbruksreformer" ;
  jordebok_nn_1_N = mkN "jordebok" "jordeböcker" ;
  jordfaerg_nn_1_1_N = mkN "jordfärg" "jordfärger" ;
  jordglob_nn_1_N = mkN "jordglob" "jordglober" ;
  jordmagnetism_nn_1_N = mkN "jordmagnetism" "jordmagnetismer" ;
  jordreform_nn_1_N = mkN "jordreform" "jordreformer" ;
  jordrotation_nn_1_N = mkN "jordrotation" "jordrotationer" ;
  jordskalvsaktivist_nn_1_N = mkN "jordskalvsaktivist" "jordskalvsaktivister" ;
  jordtroetthet_nn_1_1_N = mkN "jordtrötthet" "jordtröttheter" ;
  jordtyp_nn_1_N = mkN "jordtyp" "jordtyper" ;
  jorsskalvsaktivist_nn_1_N = mkN "jorsskalvsaktivist" "jorsskalvsaktivister" ;
  jos_nn_1_N = mkN "jos" "joser" ;
  jourbutik_nn_1_N = mkN "jourbutik" "jourbutiker" ;
  journalfilm_nn_1_N = mkN "journalfilm" "journalfilmer" ;
  journalist_nn_1_N = mkN "journalist" "journalister" ;
  jovialitet_nn_1_N = mkN "jovialitet" "jovialiteter" ;
  jubeldoktor_nn_1_N = mkN "jubeldoktor" "jubeldoktorer" ;
  jubelfest_nn_1_N = mkN "jubelfest" "jubelfester" ;
  jubelidiot_nn_1_N = mkN "jubelidiot" "jubelidioter" ;
  judenhet_nn_1_N = mkN "judenhet" "judenheter" ;
  julboen_nn_1_1_N = mkN "julbön" "julböner" ;
  juldekoration_nn_1_N = mkN "juldekoration" "juldekorationer" ;
  julfest_nn_1_N = mkN "julfest" "julfester" ;
  julfilm_nn_1_N = mkN "julfilm" "julfilmer" ;
  julgransprydnad_nn_1_N = mkN "julgransprydnad" "julgransprydnader" ;
  julgrupp_nn_1_N = mkN "julgrupp" "julgrupper" ;
  julsaang_nn_1_1_N = mkN "julsång" "julsånger" ;
  jurisdiktion_nn_1_N = mkN "jurisdiktion" "jurisdiktioner" ;
  jurist_nn_1_N = mkN "jurist" "jurister" ;
  jury_nn_1_N = mkN "jury" "juryer" ;
  jus_nn_1_N = mkN "jus" "juser" ;
  justeringsmoejlighet_nn_1_1_N = mkN "justeringsmöjlighet" "justeringsmöjligheter" ;
  juvel_nn_1_N = mkN "juvel" "juveler" ;
  juveleraraffaer_nn_1_1_N = mkN "juveleraraffär" "juveleraraffärer" ;
  juvelerarbutik_nn_1_N = mkN "juvelerarbutik" "juvelerarbutiker" ;
  juverinflammation_nn_1_N = mkN "juverinflammation" "juverinflammationer" ;
  juvervaevnad_nn_1_1_N = mkN "juvervävnad" "juvervävnader" ;
  juxtaposition_nn_1_N = mkN "juxtaposition" "juxtapositioner" ;
  jaegarbataljon_nn_1_1_N = mkN "jägarbataljon" "jägarbataljoner" ;
  jaegarloejtnant_nn_1_1_N = mkN "jägarlöjtnant" "jägarlöjtnanter" ;
  jaeklighet_nn_1_1_N = mkN "jäklighet" "jäkligheter" ;
  jaemfoerelsetjaenst_nn_1_1_N = mkN "jämförelsetjänst" "jämförelsetjänster" ;
  jaemlikhet_nn_1_1_N = mkN "jämlikhet" "jämlikheter" ;
  jaemmerlighet_nn_1_1_N = mkN "jämmerlighet" "jämmerligheter" ;
  jaemstaelldhet_nn_1_1_N = mkN "jämställdhet" "jämställdheter" ;
  jaemstaelldhetsdiskussion_nn_1_1_N = mkN "jämställdhetsdiskussion" "jämställdhetsdiskussioner" ;
  jaernkatastrof_nn_1_1_N = mkN "järnkatastrof" "järnkatastrofer" ;
  jaernmanufaktur_nn_1_1_N = mkN "järnmanufaktur" "järnmanufakturer" ;
  jaernoxid_nn_1_1_N = mkN "järnoxid" "järnoxider" ;
  jaernproduktion_nn_1_1_N = mkN "järnproduktion" "järnproduktioner" ;
  jaernridaa_nn_1_1_N = mkN "järnridå" "järnridåer" ;
  jaernsulfid_nn_1_1_N = mkN "järnsulfid" "järnsulfider" ;
  jaernvaegssignal_nn_1_1_N = mkN "järnvägssignal" "järnvägssignaler" ;
  jaernvaegsstation_nn_1_1_N = mkN "järnvägsstation" "järnvägsstationer" ;
  jaernvaegsstrejk_nn_1_1_N = mkN "järnvägsstrejk" "järnvägsstrejker" ;
  jaernvaegsviadukt_nn_1_1_N = mkN "järnvägsviadukt" "järnvägsviadukter" ;
  jaernoert_nn_1_1_N = mkN "järnört" "järnörter" ;
  jaetteraed_nn_1_1_N = mkN "jätteräd" "jätteräder" ;
  jaettetyfon_nn_1_1_N = mkN "jättetyfon" "jättetyfoner" ;
  jaevlighet_nn_1_1_N = mkN "jävlighet" "jävligheter" ;
  kabal_nn_1_N = mkN "kabal" "kabaler" ;
  kabar_e_nn_1_1_N = mkN "kabaré" "kabaréer" ;
  kabbalism_nn_1_N = mkN "kabbalism" "kabbalismer" ;
  kabbalist_nn_1_N = mkN "kabbalist" "kabbalister" ;
  kabellaengd_nn_1_1_N = mkN "kabellängd" "kabellängder" ;
  kabin_nn_1_N = mkN "kabin" "kabiner" ;
  kabyl_nn_1_N = mkN "kabyl" "kabyler" ;
  kabyss_nn_1_N = mkN "kabyss" "kabysser" ;
  kadaverlydnad_nn_1_N = mkN "kadaverlydnad" "kadaverlydnader" ;
  kadens_nn_1_N = mkN "kadens" "kadenser" ;
  kadettkaar_nn_1_1_N = mkN "kadettkår" "kadettkårer" ;
  kadmiumjon_nn_1_N = mkN "kadmiumjon" "kadmiumjoner" ;
  kafferast_nn_1_N = mkN "kafferast" "kafferaster" ;
  kaftan_nn_1_N = mkN "kaftan" "kaftaner" ;
  kajman_nn_1_N = mkN "kajman" "kajmaner" ;
  kajplats_nn_1_N = mkN "kajplats" "kajplatser" ;
  kajutpost_nn_1_N = mkN "kajutpost" "kajutposter" ;
  kakelugnsnisch_nn_1_N = mkN "kakelugnsnisch" "kakelugnsnischer" ;
  kakiuniform_nn_1_N = mkN "kakiuniform" "kakiuniformer" ;
  kakt_e_nn_1_1_N = mkN "kakté" "kaktéer" ;
  kalabass_nn_1_N = mkN "kalabass" "kalabasser" ;
  kalamitet_nn_1_N = mkN "kalamitet" "kalamiteter" ;
  kalcedon_nn_1_N = mkN "kalcedon" "kalcedoner" ;
  kalciumhydroxid_nn_1_N = mkN "kalciumhydroxid" "kalciumhydroxider" ;
  kalciumoxid_nn_1_N = mkN "kalciumoxid" "kalciumoxider" ;
  kalebass_nn_1_N = mkN "kalebass" "kalebasser" ;
  kalendermaanad_nn_1_1_N = mkN "kalendermånad" "kalendermånader" ;
  kalesch_nn_1_N = mkN "kalesch" "kalescher" ;
  kalfaktor_nn_1_N = mkN "kalfaktor" "kalfaktorer" ;
  kaliumhydroxid_nn_1_N = mkN "kaliumhydroxid" "kaliumhydroxider" ;
  kaliumjon_nn_1_N = mkN "kaliumjon" "kaliumjoner" ;
  kalk_nn_1_N = mkN "kalk" "kalker" ;
  kalkalg_nn_1_N = mkN "kalkalg" "kalkalger" ;
  kalkformation_nn_1_N = mkN "kalkformation" "kalkformationer" ;
  kalkfaerg_nn_1_1_N = mkN "kalkfärg" "kalkfärger" ;
  kalkhalt_nn_1_N = mkN "kalkhalt" "kalkhalter" ;
  kalkjon_nn_1_N = mkN "kalkjon" "kalkjoner" ;
  kalkon_nn_1_N = mkN "kalkon" "kalkoner" ;
  kalkrest_nn_1_N = mkN "kalkrest" "kalkrester" ;
  kalkyl_nn_1_N = mkN "kalkyl" "kalkyler" ;
  kalkylator_nn_1_N = mkN "kalkylator" "kalkylatorer" ;
  kallblodighet_nn_1_N = mkN "kallblodighet" "kallblodigheter" ;
  kalmark_nn_1_N = mkN "kalmark" "kalmarker" ;
  kaloribomb_nn_1_N = mkN "kaloribomb" "kaloribomber" ;
  kalorijakt_nn_1_N = mkN "kalorijakt" "kalorijakter" ;
  kalrest_nn_1_N = mkN "kalrest" "kalrester" ;
  kalufs_nn_1_N = mkN "kalufs" "kalufser" ;
  kalvfrikass_e_nn_1_1_N = mkN "kalvfrikassé" "kalvfrikasséer" ;
  kalvinism_nn_1_N = mkN "kalvinism" "kalvinismer" ;
  kalvinist_nn_1_N = mkN "kalvinist" "kalvinister" ;
  kalvrulad_nn_1_N = mkN "kalvrulad" "kalvrulader" ;
  kalvrullad_nn_1_N = mkN "kalvrullad" "kalvrullader" ;
  kambodjan_nn_1_N = mkN "kambodjan" "kambodjaner" ;
  kamelmedicin_nn_1_N = mkN "kamelmedicin" "kamelmediciner" ;
  kamelritt_nn_1_N = mkN "kamelritt" "kamelritter" ;
  kamerajakt_nn_1_N = mkN "kamerajakt" "kamerajakter" ;
  kammarammunition_nn_1_N = mkN "kammarammunition" "kammarammunitioner" ;
  kammarraett_nn_1_1_N = mkN "kammarrätt" "kammarrätter" ;
  kampanil_nn_1_N = mkN "kampanil" "kampaniler" ;
  kampanj_nn_1_N = mkN "kampanj" "kampanjer" ;
  kampanjstab_nn_1_N = mkN "kampanjstab" "kampanjstaber" ;
  kampkonst_nn_1_N = mkN "kampkonst" "kampkonster" ;
  kamporganisation_nn_1_N = mkN "kamporganisation" "kamporganisationer" ;
  kampsport_nn_1_N = mkN "kampsport" "kampsporter" ;
  kampsaang_nn_1_1_N = mkN "kampsång" "kampsånger" ;
  kampuchean_nn_1_N = mkN "kampuchean" "kampucheaner" ;
  kamratlighet_nn_1_N = mkN "kamratlighet" "kamratligheter" ;
  kam_e_nn_1_1_N = mkN "kamé" "kaméer" ;
  kan_nn_1_N = mkN "kan" "kaner" ;
  kanalchef_nn_1_N = mkN "kanalchef" "kanalchefer" ;
  kanap_e_nn_1_1_N = mkN "kanapé" "kanapéer" ;
  kandidatur_nn_1_N = mkN "kandidatur" "kandidaturer" ;
  kanfas_nn_1_N = mkN "kanfas" "kanfaser" ;
  kanin_nn_1_N = mkN "kanin" "kaniner" ;
  kanjon_nn_1_N = mkN "kanjon" "kanjoner" ;
  kannibal_nn_1_N = mkN "kannibal" "kannibaler" ;
  kannibalism_nn_1_N = mkN "kannibalism" "kannibalismer" ;
  kanon_nn_2_N = mkN "kanon" "kanoner" ;
  kanonaffaer_nn_1_1_N = mkN "kanonaffär" "kanonaffärer" ;
  kanonisation_nn_1_N = mkN "kanonisation" "kanonisationer" ;
  kanonisationsprocess_nn_1_N = mkN "kanonisationsprocess" "kanonisationsprocesser" ;
  kanoniseringsprocess_nn_1_N = mkN "kanoniseringsprocess" "kanoniseringsprocesser" ;
  kanot_nn_1_N = mkN "kanot" "kanoter" ;
  kanotist_nn_1_N = mkN "kanotist" "kanotister" ;
  kansler_nn_1_N = mkN "kansler" "kanslerer" ;
  kanslist_nn_1_N = mkN "kanslist" "kanslister" ;
  kant_nn_1_N = mkN "kant" "kanter" ;
  kantarell_nn_1_N = mkN "kantarell" "kantareller" ;
  kantat_nn_1_N = mkN "kantat" "kantater" ;
  kantighet_nn_2_N = mkN "kantighet" "kantigheter" ;
  kantin_nn_1_N = mkN "kantin" "kantiner" ;
  kanton_nn_1_N = mkN "kanton" "kantoner" ;
  kantor_nn_1_N = mkN "kantor" "kantorer" ;
  kantrad_nn_1_N = mkN "kantrad" "kantrader" ;
  kantvaext_nn_1_1_N = mkN "kantväxt" "kantväxter" ;
  kanyl_nn_1_N = mkN "kanyl" "kanyler" ;
  kanzon_nn_1_N = mkN "kanzon" "kanzoner" ;
  kanzonett_nn_1_N = mkN "kanzonett" "kanzonetter" ;
  kapacitet_nn_1_N = mkN "kapacitet" "kapaciteter" ;
  kapacitetsbrist_nn_1_N = mkN "kapacitetsbrist" "kapacitetsbrister" ;
  kaparkapten_nn_1_N = mkN "kaparkapten" "kaparkaptener" ;
  kapillaritet_nn_1_N = mkN "kapillaritet" "kapillariteter" ;
  kapitalfoerlust_nn_1_1_N = mkN "kapitalförlust" "kapitalförluster" ;
  kapitalinkomst_nn_1_N = mkN "kapitalinkomst" "kapitalinkomster" ;
  kapitalism_nn_1_N = mkN "kapitalism" "kapitalismer" ;
  kapitalist_nn_1_N = mkN "kapitalist" "kapitalister" ;
  kapitaliststat_nn_1_N = mkN "kapitaliststat" "kapitaliststater" ;
  kapitalmarknad_nn_1_N = mkN "kapitalmarknad" "kapitalmarknader" ;
  kapitalvinst_nn_1_N = mkN "kapitalvinst" "kapitalvinster" ;
  kapitulation_nn_1_N = mkN "kapitulation" "kapitulationer" ;
  kaplan_nn_1_N = mkN "kaplan" "kaplaner" ;
  kapmaskin_nn_1_N = mkN "kapmaskin" "kapmaskiner" ;
  kaprifol_nn_1_N = mkN "kaprifol" "kaprifoler" ;
  kapriol_nn_1_N = mkN "kapriol" "kaprioler" ;
  kapris_nn_1_N = mkN "kapris" "kapriser" ;
  kapson_nn_1_N = mkN "kapson" "kapsoner" ;
  kapsyl_nn_1_N = mkN "kapsyl" "kapsyler" ;
  kapucin_nn_1_N = mkN "kapucin" "kapuciner" ;
  kapybar_nn_1_N = mkN "kapybar" "kapybarer" ;
  karaffin_nn_1_N = mkN "karaffin" "karaffiner" ;
  karaktaer_nn_1_1_N = mkN "karaktär" "karaktärer" ;
  karaktaersart_nn_1_1_N = mkN "karaktärsart" "karaktärsarter" ;
  karaktaerstyp_nn_1_1_N = mkN "karaktärstyp" "karaktärstyper" ;
  karamell_nn_1_N = mkN "karamell" "karameller" ;
  karamellfabrik_nn_1_N = mkN "karamellfabrik" "karamellfabriker" ;
  karamellfaerg_nn_1_1_N = mkN "karamellfärg" "karamellfärger" ;
  karamellsaas_nn_1_1_N = mkN "karamellsås" "karamellsåser" ;
  karavan_nn_1_N = mkN "karavan" "karavaner" ;
  karbamid_nn_1_N = mkN "karbamid" "karbamider" ;
  karbas_nn_1_N = mkN "karbas" "karbaser" ;
  karbid_nn_1_N = mkN "karbid" "karbider" ;
  karbin_nn_1_N = mkN "karbin" "karbiner" ;
  karbonatjon_nn_1_N = mkN "karbonatjon" "karbonatjoner" ;
  karburator_nn_1_N = mkN "karburator" "karburatorer" ;
  karcinogen_nn_1_N = mkN "karcinogen" "karcinogener" ;
  kardan_nn_1_N = mkN "kardan" "kardaner" ;
  kardiolog_nn_1_N = mkN "kardiolog" "kardiologer" ;
  kardus_nn_1_N = mkN "kardus" "karduser" ;
  karess_nn_1_N = mkN "karess" "karesser" ;
  karismasignal_nn_1_N = mkN "karismasignal" "karismasignaler" ;
  karkas_nn_1_N = mkN "karkas" "karkaser" ;
  karled_nn_1_N = mkN "karled" "karleder" ;
  karmelit_nn_1_N = mkN "karmelit" "karmeliter" ;
  karnation_nn_1_N = mkN "karnation" "karnationer" ;
  karneol_nn_1_N = mkN "karneol" "karneoler" ;
  karnis_nn_1_N = mkN "karnis" "karniser" ;
  karolin_nn_1_N = mkN "karolin" "karoliner" ;
  kaross_nn_1_N = mkN "kaross" "karosser" ;
  karriaerism_nn_1_1_N = mkN "karriärism" "karriärismer" ;
  karriaerist_nn_1_1_N = mkN "karriärist" "karriärister" ;
  karr_e_nn_1_1_N = mkN "karré" "karréer" ;
  karst_nn_1_N = mkN "karst" "karster" ;
  kartbild_nn_1_N = mkN "kartbild" "kartbilder" ;
  kartbok_nn_1_N = mkN "kartbok" "kartböcker" ;
  kartesch_nn_1_N = mkN "kartesch" "kartescher" ;
  kartong_nn_1_N = mkN "kartong" "kartonger" ;
  kartonist_nn_1_N = mkN "kartonist" "kartonister" ;
  kartprojektion_nn_1_N = mkN "kartprojektion" "kartprojektioner" ;
  kartritartradition_nn_1_N = mkN "kartritartradition" "kartritartraditioner" ;
  kartusch_nn_1_N = mkN "kartusch" "kartuscher" ;
  kartusian_nn_1_N = mkN "kartusian" "kartusianer" ;
  karyatid_nn_1_N = mkN "karyatid" "karyatider" ;
  kaskad_nn_1_N = mkN "kaskad" "kaskader" ;
  kaskelot_nn_1_N = mkN "kaskelot" "kaskeloter" ;
  kaskelott_nn_1_N = mkN "kaskelott" "kaskelotter" ;
  kaskett_nn_1_N = mkN "kaskett" "kasketter" ;
  kassaapparat_nn_1_N = mkN "kassaapparat" "kassaapparater" ;
  kassabok_nn_1_N = mkN "kassabok" "kassaböcker" ;
  kassabrist_nn_1_N = mkN "kassabrist" "kassabrister" ;
  kassadirektoer_nn_1_1_N = mkN "kassadirektör" "kassadirektörer" ;
  kassapjaes_nn_1_1_N = mkN "kassapjäs" "kassapjäser" ;
  kassarabatt_nn_1_N = mkN "kassarabatt" "kassarabatter" ;
  kassation_nn_1_N = mkN "kassation" "kassationer" ;
  kassun_nn_1_N = mkN "kassun" "kassuner" ;
  kassoer_nn_1_1_N = mkN "kassör" "kassörer" ;
  kast_nn_1_N = mkN "kast" "kaster" ;
  kastanj_nn_1_N = mkN "kastanj" "kastanjer" ;
  kastanjett_nn_1_N = mkN "kastanjett" "kastanjetter" ;
  kastellan_nn_1_N = mkN "kastellan" "kastellaner" ;
  kastilian_nn_1_N = mkN "kastilian" "kastilianer" ;
  kastpjaes_nn_1_1_N = mkN "kastpjäs" "kastpjäser" ;
  kasun_nn_1_N = mkN "kasun" "kasuner" ;
  katakres_nn_1_N = mkN "katakres" "katakreser" ;
  katalan_nn_1_N = mkN "katalan" "katalaner" ;
  katalysator_nn_1_N = mkN "katalysator" "katalysatorer" ;
  katamaran_nn_1_N = mkN "katamaran" "katamaraner" ;
  katarr_nn_1_N = mkN "katarr" "katarrer" ;
  katastroffilm_nn_1_N = mkN "katastroffilm" "katastroffilmer" ;
  katastrofhanteringsmyndighet_nn_1_N = mkN "katastrofhanteringsmyndighet" "katastrofhanteringsmyndigheter" ;
  katastrofsituation_nn_1_N = mkN "katastrofsituation" "katastrofsituationer" ;
  katedersocialism_nn_1_N = mkN "katedersocialism" "katedersocialismer" ;
  katekes_nn_1_N = mkN "katekes" "katekeser" ;
  katet_nn_1_N = mkN "katet" "kateter" ;
  katjon_nn_1_N = mkN "katjon" "katjoner" ;
  katolicism_nn_1_N = mkN "katolicism" "katolicismer" ;
  katolik_nn_1_N = mkN "katolik" "katoliker" ;
  katt_nn_1_N = mkN "katt" "katter" ;
  kattras_nn_1_N = mkN "kattras" "kattraser" ;
  kaus_nn_1_N = mkN "kaus" "kauser" ;
  kausalitet_nn_1_N = mkN "kausalitet" "kausaliteter" ;
  kausalsats_nn_1_N = mkN "kausalsats" "kausalsatser" ;
  kaution_nn_1_N = mkN "kaution" "kautioner" ;
  kavaljer_nn_1_N = mkN "kavaljer" "kavaljerer" ;
  kavallerist_nn_1_N = mkN "kavallerist" "kavallerister" ;
  kavitation_nn_1_N = mkN "kavitation" "kavitationer" ;
  kavitet_nn_1_N = mkN "kavitet" "kaviteter" ;
  kazak_nn_1_N = mkN "kazak" "kazaker" ;
  kebab_nn_1_N = mkN "kebab" "kebaber" ;
  ked_nn_1_N = mkN "ked" "keder" ;
  kediv_nn_1_N = mkN "kediv" "kediver" ;
  kedjemolekyl_nn_1_N = mkN "kedjemolekyl" "kedjemolekyler" ;
  kedjereaktion_nn_1_N = mkN "kedjereaktion" "kedjereaktioner" ;
  kejsarpingvin_nn_1_N = mkN "kejsarpingvin" "kejsarpingviner" ;
  kejsartron_nn_1_N = mkN "kejsartron" "kejsartroner" ;
  kelim_nn_1_N = mkN "kelim" "kelimer" ;
  kelt_nn_1_N = mkN "kelt" "kelter" ;
  kemibok_nn_1_N = mkN "kemibok" "kemiböcker" ;
  kemiprofessor_nn_1_N = mkN "kemiprofessor" "kemiprofessorer" ;
  kemist_nn_1_N = mkN "kemist" "kemister" ;
  kenyan_nn_1_N = mkN "kenyan" "kenyaner" ;
  ketch_nn_1_N = mkN "ketch" "ketcher" ;
  khan_nn_1_N = mkN "khan" "khaner" ;
  khmer_nn_1_N = mkN "khmer" "khmerer" ;
  kickstart_nn_1_N = mkN "kickstart" "kickstarter" ;
  kikarlins_nn_1_N = mkN "kikarlins" "kikarlinser" ;
  kikaert_nn_1_1_N = mkN "kikärt" "kikärter" ;
  kilometerskatt_nn_1_N = mkN "kilometerskatt" "kilometerskatter" ;
  kinaalkaloid_nn_1_N = mkN "kinaalkaloid" "kinaalkaloider" ;
  kinarestaurang_nn_1_N = mkN "kinarestaurang" "kinarestauranger" ;
  kines_nn_1_N = mkN "kines" "kineser" ;
  kiosk_nn_1_N = mkN "kiosk" "kiosker" ;
  kirgis_nn_1_N = mkN "kirgis" "kirgiser" ;
  kirgiz_nn_1_N = mkN "kirgiz" "kirgizer" ;
  kiropraktor_nn_1_N = mkN "kiropraktor" "kiropraktorer" ;
  kirurg_nn_1_N = mkN "kirurg" "kirurger" ;
  kirurgmask_nn_1_N = mkN "kirurgmask" "kirurgmasker" ;
  kis_nn_1_N = mkN "kis" "kiser" ;
  kiselalg_nn_1_N = mkN "kiselalg" "kiselalger" ;
  kiselkristall_nn_1_N = mkN "kiselkristall" "kiselkristaller" ;
  kiton_nn_1_N = mkN "kiton" "kitoner" ;
  kitslighet_nn_1_N = mkN "kitslighet" "kitsligheter" ;
  klad_nn_1_N = mkN "klad" "klader" ;
  klagoskrift_nn_1_N = mkN "klagoskrift" "klagoskrifter" ;
  klagosaang_nn_1_1_N = mkN "klagosång" "klagosånger" ;
  klagotid_nn_1_N = mkN "klagotid" "klagotider" ;
  klagoton_nn_1_N = mkN "klagoton" "klagotoner" ;
  klammerpistol_nn_1_N = mkN "klammerpistol" "klammerpistoler" ;
  klamydiavaccin_nn_1_N = mkN "klamydiavaccin" "klamydiavacciner" ;
  klan_nn_1_N = mkN "klan" "klaner" ;
  klangfaerg_nn_1_1_N = mkN "klangfärg" "klangfärger" ;
  klansoldat_nn_1_N = mkN "klansoldat" "klansoldater" ;
  klanstrid_nn_1_N = mkN "klanstrid" "klanstrider" ;
  klantighet_nn_1_N = mkN "klantighet" "klantigheter" ;
  klappjakt_nn_1_N = mkN "klappjakt" "klappjakter" ;
  klarhet_nn_1_N = mkN "klarhet" "klarheter" ;
  klarinettist_nn_1_N = mkN "klarinettist" "klarinettister" ;
  klarsignal_nn_1_N = mkN "klarsignal" "klarsignaler" ;
  klass_nn_1_N = mkN "klass" "klasser" ;
  klassbok_nn_1_N = mkN "klassbok" "klassböcker" ;
  klassicism_nn_1_N = mkN "klassicism" "klassicismer" ;
  klassicitet_nn_1_N = mkN "klassicitet" "klassiciteter" ;
  klassifikation_nn_1_N = mkN "klassifikation" "klassifikationer" ;
  klassik_nn_1_N = mkN "klassik" "klassiker" ;
  klasskillnad_nn_1_N = mkN "klasskillnad" "klasskillnader" ;
  klasskonferens_nn_1_N = mkN "klasskonferens" "klasskonferenser" ;
  klassmarkoer_nn_1_1_N = mkN "klassmarkör" "klassmarkörer" ;
  klassresenaer_nn_1_1_N = mkN "klassresenär" "klassresenärer" ;
  klasstruktur_nn_1_N = mkN "klasstruktur" "klasstrukturer" ;
  klatrat_nn_1_N = mkN "klatrat" "klatrater" ;
  klatrathydrat_nn_1_N = mkN "klatrathydrat" "klatrathydrater" ;
  klav_nn_1_N = mkN "klav" "klaver" ;
  klavecin_nn_1_N = mkN "klavecin" "klaveciner" ;
  klaviatur_nn_1_N = mkN "klaviatur" "klaviaturer" ;
  klementin_nn_1_N = mkN "klementin" "klementiner" ;
  klenod_nn_1_N = mkN "klenod" "klenoder" ;
  klensmed_nn_1_N = mkN "klensmed" "klensmeder" ;
  kleptoman_nn_1_N = mkN "kleptoman" "kleptomaner" ;
  klerikalism_nn_1_N = mkN "klerikalism" "klerikalismer" ;
  kletighet_nn_1_N = mkN "kletighet" "kletigheter" ;
  klich_e_nn_1_1_N = mkN "kliché" "klichéer" ;
  klimataktivist_nn_1_N = mkN "klimataktivist" "klimataktivister" ;
  klimatalarmist_nn_1_N = mkN "klimatalarmist" "klimatalarmister" ;
  klimatgraens_nn_1_1_N = mkN "klimatgräns" "klimatgränser" ;
  klimatkonferens_nn_1_N = mkN "klimatkonferens" "klimatkonferenser" ;
  klimatkris_nn_1_N = mkN "klimatkris" "klimatkriser" ;
  klimatmedvetenhet_nn_1_N = mkN "klimatmedvetenhet" "klimatmedvetenheter" ;
  klimatsmarthet_nn_1_N = mkN "klimatsmarthet" "klimatsmartheter" ;
  klimatvariation_nn_1_N = mkN "klimatvariation" "klimatvariationer" ;
  klimatzon_nn_1_N = mkN "klimatzon" "klimatzoner" ;
  klimataatgaerd_nn_1_1_N = mkN "klimatåtgärd" "klimatåtgärder" ;
  klippbredd_nn_1_N = mkN "klippbredd" "klippbredder" ;
  klippformation_nn_1_N = mkN "klippformation" "klippformationer" ;
  klipphoejd_nn_1_1_N = mkN "klipphöjd" "klipphöjder" ;
  klipskhet_nn_1_N = mkN "klipskhet" "klipskheter" ;
  klockklang_nn_1_N = mkN "klockklang" "klockklanger" ;
  klocksignal_nn_1_N = mkN "klocksignal" "klocksignaler" ;
  klokhet_nn_1_N = mkN "klokhet" "klokheter" ;
  klorfenol_nn_1_N = mkN "klorfenol" "klorfenoler" ;
  klorid_nn_1_N = mkN "klorid" "klorider" ;
  klosterruin_nn_1_N = mkN "klosterruin" "klosterruiner" ;
  klubblaengd_nn_1_1_N = mkN "klubblängd" "klubblängder" ;
  klumpighet_nn_1_N = mkN "klumpighet" "klumpigheter" ;
  klurighet_nn_1_N = mkN "klurighet" "klurigheter" ;
  klusterbomb_nn_1_N = mkN "klusterbomb" "klusterbomber" ;
  kluvenhet_nn_1_N = mkN "kluvenhet" "kluvenheter" ;
  klyvningsreaktion_nn_1_N = mkN "klyvningsreaktion" "klyvningsreaktioner" ;
  klaededraekt_nn_1_1_N = mkN "klädedräkt" "klädedräkter" ;
  klaednad_nn_1_1_N = mkN "klädnad" "klädnader" ;
  klaedsmak_nn_1_1_N = mkN "klädsmak" "klädsmaker" ;
  klaengvaext_nn_1_1_N = mkN "klängväxt" "klängväxter" ;
  klaerobskyr_nn_1_1_N = mkN "klärobskyr" "klärobskyrer" ;
  klaettervaext_nn_1_1_N = mkN "klätterväxt" "klätterväxter" ;
  kloevsadelbyggnad_nn_1_1_N = mkN "klövsadelbyggnad" "klövsadelbyggnader" ;
  kloevsadelsbyggnad_nn_1_1_N = mkN "klövsadelsbyggnad" "klövsadelsbyggnader" ;
  knagglighet_nn_1_N = mkN "knagglighet" "knaggligheter" ;
  knalltransport_nn_1_N = mkN "knalltransport" "knalltransporter" ;
  knapphet_nn_1_N = mkN "knapphet" "knappheter" ;
  knapptelefon_nn_1_N = mkN "knapptelefon" "knapptelefoner" ;
  knasighet_nn_1_N = mkN "knasighet" "knasigheter" ;
  knektmentalitet_nn_1_N = mkN "knektmentalitet" "knektmentaliteter" ;
  knepighet_nn_1_N = mkN "knepighet" "knepigheter" ;
  knivighet_nn_1_N = mkN "knivighet" "knivigheter" ;
  knivkontakt_nn_1_N = mkN "knivkontakt" "knivkontakter" ;
  knockdown_nn_1_N = mkN "knockdown" "knockdowner" ;
  knockout_nn_1_N = mkN "knockout" "knockouter" ;
  knollrighet_nn_1_N = mkN "knollrighet" "knollrigheter" ;
  knotighet_nn_1_N = mkN "knotighet" "knotigheter" ;
  knusslighet_nn_1_N = mkN "knusslighet" "knussligheter" ;
  knutpunkt_nn_1_N = mkN "knutpunkt" "knutpunkter" ;
  knypplingskurs_nn_1_N = mkN "knypplingskurs" "knypplingskurser" ;
  knaeled_nn_1_1_N = mkN "knäled" "knäleder" ;
  knaeoperation_nn_1_1_N = mkN "knäoperation" "knäoperationer" ;
  knaeppfamilj_nn_1_1_N = mkN "knäppfamilj" "knäppfamiljer" ;
  knaetrakt_nn_1_1_N = mkN "knätrakt" "knätrakter" ;
  knoelighet_nn_1_1_N = mkN "knölighet" "knöligheter" ;
  koaffyr_nn_1_N = mkN "koaffyr" "koaffyrer" ;
  koagulation_nn_1_N = mkN "koagulation" "koagulationer" ;
  koalition_nn_1_N = mkN "koalition" "koalitioner" ;
  kobolthalt_nn_1_N = mkN "kobolthalt" "kobolthalter" ;
  koboltjon_nn_1_N = mkN "koboltjon" "koboltjoner" ;
  kod_nn_1_N = mkN "kod" "koder" ;
  kodifikation_nn_1_N = mkN "kodifikation" "kodifikationer" ;
  kofferdist_nn_1_N = mkN "kofferdist" "kofferdister" ;
  kognat_nn_1_N = mkN "kognat" "kognater" ;
  kognition_nn_1_N = mkN "kognition" "kognitioner" ;
  kohesion_nn_1_N = mkN "kohesion" "kohesioner" ;
  kohort_nn_1_N = mkN "kohort" "kohorter" ;
  koj_nn_1_N = mkN "koj" "kojer" ;
  kokainism_nn_1_N = mkN "kokainism" "kokainismer" ;
  kokarreaktor_nn_1_N = mkN "kokarreaktor" "kokarreaktorer" ;
  kokbok_nn_1_N = mkN "kokbok" "kokböcker" ;
  kokboksstoeld_nn_1_1_N = mkN "kokboksstöld" "kokboksstölder" ;
  kolchos_nn_1_N = mkN "kolchos" "kolchoser" ;
  koldioxid_nn_1_N = mkN "koldioxid" "koldioxider" ;
  koldioxidhalt_nn_1_N = mkN "koldioxidhalt" "koldioxidhalter" ;
  koldioxidmolekyl_nn_1_N = mkN "koldioxidmolekyl" "koldioxidmolekyler" ;
  kolfloets_nn_1_1_N = mkN "kolflöts" "kolflötser" ;
  kolhalt_nn_1_N = mkN "kolhalt" "kolhalter" ;
  kolj_e_nn_1_1_N = mkN "koljé" "koljéer" ;
  kollaps_nn_1_N = mkN "kollaps" "kollapser" ;
  kollast_nn_1_N = mkN "kollast" "kollaster" ;
  kollation_nn_1_N = mkN "kollation" "kollationer" ;
  kollegialitet_nn_1_N = mkN "kollegialitet" "kollegialiteter" ;
  kollektion_nn_1_N = mkN "kollektion" "kollektioner" ;
  kollektivfil_nn_1_N = mkN "kollektivfil" "kollektivfiler" ;
  kollektivism_nn_1_N = mkN "kollektivism" "kollektivismer" ;
  kollektor_nn_1_N = mkN "kollektor" "kollektorer" ;
  kollision_nn_1_N = mkN "kollision" "kollisioner" ;
  kollisionskurs_nn_1_N = mkN "kollisionskurs" "kollisionskurser" ;
  kolloid_nn_1_N = mkN "kolloid" "kolloider" ;
  kollokation_nn_1_N = mkN "kollokation" "kollokationer" ;
  kollusion_nn_1_N = mkN "kollusion" "kollusioner" ;
  kolofon_nn_1_N = mkN "kolofon" "kolofoner" ;
  kolonialarm_e_nn_1_1_N = mkN "kolonialarmé" "kolonialarméer" ;
  kolonialexpansion_nn_1_N = mkN "kolonialexpansion" "kolonialexpansioner" ;
  kolonialiseringsprocess_nn_1_N = mkN "kolonialiseringsprocess" "kolonialiseringsprocesser" ;
  kolonialism_nn_1_N = mkN "kolonialism" "kolonialismer" ;
  kolonialmakt_nn_1_N = mkN "kolonialmakt" "kolonialmakter" ;
  kolonisation_nn_1_N = mkN "kolonisation" "kolonisationer" ;
  kolonisationstid_nn_1_N = mkN "kolonisationstid" "kolonisationstider" ;
  koloratur_nn_1_N = mkN "koloratur" "koloraturer" ;
  koloratursopran_nn_1_N = mkN "koloratursopran" "koloratursopraner" ;
  kolorism_nn_1_N = mkN "kolorism" "kolorismer" ;
  kolorist_nn_1_N = mkN "kolorist" "kolorister" ;
  kolorit_nn_1_N = mkN "kolorit" "koloriter" ;
  koloss_nn_1_N = mkN "koloss" "kolosser" ;
  kolskiss_nn_1_N = mkN "kolskiss" "kolskisser" ;
  kolsyraassimilation_nn_1_N = mkN "kolsyraassimilation" "kolsyraassimilationer" ;
  kolsyremaskin_nn_1_N = mkN "kolsyremaskin" "kolsyremaskiner" ;
  kolsyrepatron_nn_1_N = mkN "kolsyrepatron" "kolsyrepatroner" ;
  kolsyrepistol_nn_1_N = mkN "kolsyrepistol" "kolsyrepistoler" ;
  kolumnist_nn_1_N = mkN "kolumnist" "kolumnister" ;
  kolvmotor_nn_1_N = mkN "kolvmotor" "kolvmotorer" ;
  kombattant_nn_1_N = mkN "kombattant" "kombattanter" ;
  kombination_nn_1_N = mkN "kombination" "kombinationer" ;
  kombinationsmaattsats_nn_1_1_N = mkN "kombinationsmåttsats" "kombinationsmåttsatser" ;
  komediant_nn_1_N = mkN "komediant" "komedianter" ;
  komitativ_nn_1_N = mkN "komitativ" "komitativer" ;
  kommandoroest_nn_1_1_N = mkN "kommandoröst" "kommandoröster" ;
  kommendant_nn_1_N = mkN "kommendant" "kommendanter" ;
  kommendantur_nn_1_N = mkN "kommendantur" "kommendanturer" ;
  kommendoer_nn_1_1_N = mkN "kommendör" "kommendörer" ;
  kommentator_nn_1_N = mkN "kommentator" "kommentatorer" ;
  kommentatorsfunktion_nn_1_N = mkN "kommentatorsfunktion" "kommentatorsfunktioner" ;
  kommers_nn_1_N = mkN "kommers" "kommerser" ;
  kommission_nn_1_N = mkN "kommission" "kommissioner" ;
  kommissionaer_nn_1_1_N = mkN "kommissionär" "kommissionärer" ;
  kommitt_e_nn_1_1_N = mkN "kommitté" "kommittéer" ;
  kommunalnivaa_nn_1_1_N = mkN "kommunalnivå" "kommunalnivåer" ;
  kommunalnaemnd_nn_1_1_N = mkN "kommunalnämnd" "kommunalnämnder" ;
  kommunalskatt_nn_1_N = mkN "kommunalskatt" "kommunalskatter" ;
  kommunikant_nn_1_N = mkN "kommunikant" "kommunikanter" ;
  kommunikation_nn_1_N = mkN "kommunikation" "kommunikationer" ;
  kommunikationssatellit_nn_1_N = mkN "kommunikationssatellit" "kommunikationssatelliter" ;
  kommunikator_nn_1_N = mkN "kommunikator" "kommunikatorer" ;
  kommunik_e_nn_1_1_N = mkN "kommuniké" "kommunikéer" ;
  kommunion_nn_1_N = mkN "kommunion" "kommunioner" ;
  kommunism_nn_1_N = mkN "kommunism" "kommunismer" ;
  kommunist_nn_1_N = mkN "kommunist" "kommunister" ;
  kommunistdiktatur_nn_1_N = mkN "kommunistdiktatur" "kommunistdiktaturer" ;
  kommunistregim_nn_1_N = mkN "kommunistregim" "kommunistregimer" ;
  kommunnivaa_nn_1_1_N = mkN "kommunnivå" "kommunnivåer" ;
  kommunreform_nn_1_N = mkN "kommunreform" "kommunreformer" ;
  kommutator_nn_1_N = mkN "kommutator" "kommutatorer" ;
  kompanichef_nn_1_N = mkN "kompanichef" "kompanichefer" ;
  komparation_nn_1_N = mkN "komparation" "komparationer" ;
  komparativ_nn_1_N = mkN "komparativ" "komparativer" ;
  kompars_nn_1_N = mkN "kompars" "komparser" ;
  kompass_nn_1_N = mkN "kompass" "kompasser" ;
  kompasskurs_nn_1_N = mkN "kompasskurs" "kompasskurser" ;
  kompensation_nn_1_N = mkN "kompensation" "kompensationer" ;
  kompensator_nn_1_N = mkN "kompensator" "kompensatorer" ;
  kompetens_nn_1_N = mkN "kompetens" "kompetenser" ;
  kompilation_nn_1_N = mkN "kompilation" "kompilationer" ;
  kompilator_nn_1_N = mkN "kompilator" "kompilatorer" ;
  komplementfaerg_nn_1_1_N = mkN "komplementfärg" "komplementfärger" ;
  kompletteringsproposition_nn_1_N = mkN "kompletteringsproposition" "kompletteringspropositioner" ;
  komplexitet_nn_1_N = mkN "komplexitet" "komplexiteter" ;
  komplikation_nn_1_N = mkN "komplikation" "komplikationer" ;
  komplott_nn_1_N = mkN "komplott" "komplotter" ;
  komponent_nn_1_N = mkN "komponent" "komponenter" ;
  komponist_nn_1_N = mkN "komponist" "komponister" ;
  komposant_nn_1_N = mkN "komposant" "komposanter" ;
  komposit_nn_1_N = mkN "komposit" "kompositer" ;
  komposition_nn_1_N = mkN "komposition" "kompositioner" ;
  kompost_nn_1_N = mkN "kompost" "komposter" ;
  kompress_nn_1_N = mkN "kompress" "kompresser" ;
  kompression_nn_1_N = mkN "kompression" "kompressioner" ;
  kompressor_nn_1_N = mkN "kompressor" "kompressorer" ;
  komprimator_nn_1_N = mkN "komprimator" "komprimatorer" ;
  kompromiss_nn_1_N = mkN "kompromiss" "kompromisser" ;
  koncentration_nn_1_N = mkN "koncentration" "koncentrationer" ;
  koncentrationssvaarighet_nn_1_1_N = mkN "koncentrationssvårighet" "koncentrationssvårigheter" ;
  konception_nn_1_N = mkN "konception" "konceptioner" ;
  koncern_nn_1_N = mkN "koncern" "koncerner" ;
  koncernchef_nn_1_N = mkN "koncernchef" "koncernchefer" ;
  koncession_nn_1_N = mkN "koncession" "koncessioner" ;
  koncessionsavgift_nn_1_N = mkN "koncessionsavgift" "koncessionsavgifter" ;
  kondensation_nn_1_N = mkN "kondensation" "kondensationer" ;
  kondensator_nn_1_N = mkN "kondensator" "kondensatorer" ;
  kondensor_nn_1_N = mkN "kondensor" "kondensorer" ;
  kondition_nn_1_N = mkN "kondition" "konditioner" ;
  konditor_nn_1_N = mkN "konditor" "konditorer" ;
  kondoleans_nn_1_N = mkN "kondoleans" "kondoleanser" ;
  konduktivitet_nn_1_N = mkN "konduktivitet" "konduktiviteter" ;
  konduktor_nn_1_N = mkN "konduktor" "konduktorer" ;
  konduktoer_nn_1_1_N = mkN "konduktör" "konduktörer" ;
  konfederation_nn_1_N = mkN "konfederation" "konfederationer" ;
  konfektion_nn_1_N = mkN "konfektion" "konfektioner" ;
  konfektyrbutik_nn_1_N = mkN "konfektyrbutik" "konfektyrbutiker" ;
  konferens_nn_1_N = mkN "konferens" "konferenser" ;
  konfession_nn_1_N = mkN "konfession" "konfessioner" ;
  konfessionalism_nn_1_N = mkN "konfessionalism" "konfessionalismer" ;
  konfiguration_nn_1_N = mkN "konfiguration" "konfigurationer" ;
  konfirmandklass_nn_1_N = mkN "konfirmandklass" "konfirmandklasser" ;
  konfirmation_nn_1_N = mkN "konfirmation" "konfirmationer" ;
  konfirmationspraest_nn_1_1_N = mkN "konfirmationspräst" "konfirmationspräster" ;
  konfiskation_nn_1_N = mkN "konfiskation" "konfiskationer" ;
  konfliktdiamant_nn_1_N = mkN "konfliktdiamant" "konfliktdiamanter" ;
  konfliktregion_nn_1_N = mkN "konfliktregion" "konfliktregioner" ;
  konfliktsituation_nn_1_N = mkN "konfliktsituation" "konfliktsituationer" ;
  konformism_nn_1_N = mkN "konformism" "konformismer" ;
  konformist_nn_1_N = mkN "konformist" "konformister" ;
  konformitet_nn_1_N = mkN "konformitet" "konformiteter" ;
  konfrontation_nn_1_N = mkN "konfrontation" "konfrontationer" ;
  konfucianism_nn_1_N = mkN "konfucianism" "konfucianismer" ;
  konfusion_nn_1_N = mkN "konfusion" "konfusioner" ;
  kongoles_nn_1_N = mkN "kongoles" "kongoleser" ;
  kongregation_nn_1_N = mkN "kongregation" "kongregationer" ;
  kongress_nn_1_N = mkN "kongress" "kongresser" ;
  kongressplats_nn_1_N = mkN "kongressplats" "kongressplatser" ;
  kongruens_nn_1_N = mkN "kongruens" "kongruenser" ;
  konicitet_nn_1_N = mkN "konicitet" "koniciteter" ;
  konjak_nn_1_N = mkN "konjak" "konjaker" ;
  konjektur_nn_1_N = mkN "konjektur" "konjekturer" ;
  konjugation_nn_1_N = mkN "konjugation" "konjugationer" ;
  konjunktion_nn_1_N = mkN "konjunktion" "konjunktioner" ;
  konjunktiv_nn_1_N = mkN "konjunktiv" "konjunktiver" ;
  konjunktur_nn_1_N = mkN "konjunktur" "konjunkturer" ;
  konjunkturrapport_nn_1_N = mkN "konjunkturrapport" "konjunkturrapporter" ;
  konklusion_nn_1_N = mkN "konklusion" "konklusioner" ;
  konkordans_nn_1_N = mkN "konkordans" "konkordanser" ;
  konkretion_nn_1_N = mkN "konkretion" "konkretioner" ;
  konkretism_nn_1_N = mkN "konkretism" "konkretismer" ;
  konkubin_nn_1_N = mkN "konkubin" "konkubiner" ;
  konkurrensmarknad_nn_1_N = mkN "konkurrensmarknad" "konkurrensmarknader" ;
  konkurs_nn_1_N = mkN "konkurs" "konkurser" ;
  konkursrealisation_nn_1_N = mkN "konkursrealisation" "konkursrealisationer" ;
  konnotation_nn_1_N = mkN "konnotation" "konnotationer" ;
  konnaessans_nn_1_1_N = mkN "konnässans" "konnässanser" ;
  konsekvens_nn_1_N = mkN "konsekvens" "konsekvenser" ;
  konsekvensanalys_nn_1_N = mkN "konsekvensanalys" "konsekvensanalyser" ;
  konsensuskultur_nn_1_N = mkN "konsensuskultur" "konsensuskulturer" ;
  konsertaffisch_nn_1_N = mkN "konsertaffisch" "konsertaffischer" ;
  konsertturn_e_nn_1_1_N = mkN "konsertturné" "konsertturnéer" ;
  konservatism_nn_1_N = mkN "konservatism" "konservatismer" ;
  konservator_nn_1_N = mkN "konservator" "konservatorer" ;
  konservfabrik_nn_1_N = mkN "konservfabrik" "konservfabriker" ;
  konsideration_nn_1_N = mkN "konsideration" "konsiderationer" ;
  konsignation_nn_1_N = mkN "konsignation" "konsignationer" ;
  konsilians_nn_1_N = mkN "konsilians" "konsilianser" ;
  konsistens_nn_1_N = mkN "konsistens" "konsistenser" ;
  konsol_nn_1_N = mkN "konsol" "konsoler" ;
  konsomm_e_nn_1_1_N = mkN "konsommé" "konsomméer" ;
  konsonans_nn_1_N = mkN "konsonans" "konsonanser" ;
  konsonant_nn_1_N = mkN "konsonant" "konsonanter" ;
  konspiration_nn_1_N = mkN "konspiration" "konspirationer" ;
  konst_nn_1_N = mkN "konst" "konster" ;
  konstant_nn_1_N = mkN "konstant" "konstanter" ;
  konstellation_nn_1_N = mkN "konstellation" "konstellationer" ;
  konsternation_nn_1_N = mkN "konsternation" "konsternationer" ;
  konstform_nn_1_N = mkN "konstform" "konstformer" ;
  konstfullhet_nn_1_N = mkN "konstfullhet" "konstfullheter" ;
  konstfaerdighet_nn_1_1_N = mkN "konstfärdighet" "konstfärdigheter" ;
  konstfoervant_nn_1_1_N = mkN "konstförvant" "konstförvanter" ;
  konstighet_nn_1_N = mkN "konstighet" "konstigheter" ;
  konstituent_nn_1_N = mkN "konstituent" "konstituenter" ;
  konstitution_nn_1_N = mkN "konstitution" "konstitutioner" ;
  konstloeshet_nn_1_1_N = mkN "konstlöshet" "konstlösheter" ;
  konstnaer_nn_1_1_N = mkN "konstnär" "konstnärer" ;
  konstnaerslaegenhet_nn_1_1_N = mkN "konstnärslägenhet" "konstnärslägenheter" ;
  konstpaus_nn_1_N = mkN "konstpaus" "konstpauser" ;
  konstruktion_nn_1_N = mkN "konstruktion" "konstruktioner" ;
  konstruktionsdetalj_nn_1_N = mkN "konstruktionsdetalj" "konstruktionsdetaljer" ;
  konstruktoer_nn_1_1_N = mkN "konstruktör" "konstruktörer" ;
  konstsalong_nn_1_N = mkN "konstsalong" "konstsalonger" ;
  konsularjurisdiktion_nn_1_N = mkN "konsularjurisdiktion" "konsularjurisdiktioner" ;
  konsultation_nn_1_N = mkN "konsultation" "konsultationer" ;
  konsument_nn_1_N = mkN "konsument" "konsumenter" ;
  konsumentkooperation_nn_1_N = mkN "konsumentkooperation" "konsumentkooperationer" ;
  konsumtion_nn_1_N = mkN "konsumtion" "konsumtioner" ;
  konsumtionsmoejlighet_nn_1_1_N = mkN "konsumtionsmöjlighet" "konsumtionsmöjligheter" ;
  konsumtionsskatt_nn_1_N = mkN "konsumtionsskatt" "konsumtionsskatter" ;
  konsumtionsskillnad_nn_1_N = mkN "konsumtionsskillnad" "konsumtionsskillnader" ;
  kontakt_nn_1_N = mkN "kontakt" "kontakter" ;
  kontaktannons_nn_1_N = mkN "kontaktannons" "kontaktannonser" ;
  kontaktinfektion_nn_1_N = mkN "kontaktinfektion" "kontaktinfektioner" ;
  kontaktlins_nn_1_N = mkN "kontaktlins" "kontaktlinser" ;
  kontaktperson_nn_1_N = mkN "kontaktperson" "kontaktpersoner" ;
  kontamination_nn_1_N = mkN "kontamination" "kontaminationer" ;
  kontemplation_nn_1_N = mkN "kontemplation" "kontemplationer" ;
  kontinentalplataa_nn_1_1_N = mkN "kontinentalplatå" "kontinentalplatåer" ;
  kontinuitet_nn_1_N = mkN "kontinuitet" "kontinuiteter" ;
  kontokurant_nn_1_N = mkN "kontokurant" "kontokuranter" ;
  kontorist_nn_1_N = mkN "kontorist" "kontorister" ;
  kontorsbyggnad_nn_1_N = mkN "kontorsbyggnad" "kontorsbyggnader" ;
  kontorschef_nn_1_N = mkN "kontorschef" "kontorschefer" ;
  kontorsplats_nn_1_N = mkN "kontorsplats" "kontorsplatser" ;
  kontostoeld_nn_1_1_N = mkN "kontostöld" "kontostölder" ;
  kontrabok_nn_1_N = mkN "kontrabok" "kontraböcker" ;
  kontradans_nn_1_N = mkN "kontradans" "kontradanser" ;
  kontradiktion_nn_1_N = mkN "kontradiktion" "kontradiktioner" ;
  kontraindikation_nn_1_N = mkN "kontraindikation" "kontraindikationer" ;
  kontraktion_nn_1_N = mkN "kontraktion" "kontraktioner" ;
  kontraproposition_nn_1_N = mkN "kontraproposition" "kontrapropositioner" ;
  kontrarevolution_nn_1_N = mkN "kontrarevolution" "kontrarevolutioner" ;
  kontrast_nn_1_N = mkN "kontrast" "kontraster" ;
  kontribution_nn_1_N = mkN "kontribution" "kontributioner" ;
  kontroll_nn_2_N = mkN "kontroll" "kontroller" ;
  kontrollant_nn_1_N = mkN "kontrollant" "kontrollanter" ;
  kontrollavgift_nn_1_N = mkN "kontrollavgift" "kontrollavgifter" ;
  kontrollgrupp_nn_1_N = mkN "kontrollgrupp" "kontrollgrupper" ;
  kontrollikon_nn_1_N = mkN "kontrollikon" "kontrollikoner" ;
  kontrollmekanism_nn_1_N = mkN "kontrollmekanism" "kontrollmekanismer" ;
  kontrollrutin_nn_1_N = mkN "kontrollrutin" "kontrollrutiner" ;
  kontrollstation_nn_1_N = mkN "kontrollstation" "kontrollstationer" ;
  kontrolluppgift_nn_1_N = mkN "kontrolluppgift" "kontrolluppgifter" ;
  kontrolloer_nn_1_1_N = mkN "kontrollör" "kontrollörer" ;
  kontrovers_nn_1_N = mkN "kontrovers" "kontroverser" ;
  kontur_nn_1_N = mkN "kontur" "konturer" ;
  kontusion_nn_1_N = mkN "kontusion" "kontusioner" ;
  konungabok_nn_1_N = mkN "konungabok" "konungaböcker" ;
  konungaed_nn_1_N = mkN "konungaed" "konungaeder" ;
  konvalescenstid_nn_1_N = mkN "konvalescenstid" "konvalescenstider" ;
  konvalj_nn_1_N = mkN "konvalj" "konvaljer" ;
  konvektion_nn_1_N = mkN "konvektion" "konvektioner" ;
  konvektionszon_nn_1_N = mkN "konvektionszon" "konvektionszoner" ;
  konvention_nn_1_N = mkN "konvention" "konventioner" ;
  konventionalism_nn_1_N = mkN "konventionalism" "konventionalismer" ;
  konversation_nn_1_N = mkN "konversation" "konversationer" ;
  konversion_nn_1_N = mkN "konversion" "konversioner" ;
  konvertit_nn_1_N = mkN "konvertit" "konvertiter" ;
  konvoj_nn_1_N = mkN "konvoj" "konvojer" ;
  konvojattack_nn_1_N = mkN "konvojattack" "konvojattacker" ;
  konvulsion_nn_1_N = mkN "konvulsion" "konvulsioner" ;
  kooperation_nn_1_N = mkN "kooperation" "kooperationer" ;
  koordination_nn_1_N = mkN "koordination" "koordinationer" ;
  koordinator_nn_1_N = mkN "koordinator" "koordinatorer" ;
  kopiator_nn_1_N = mkN "kopiator" "kopiatorer" ;
  kopist_nn_1_N = mkN "kopist" "kopister" ;
  kopplingspedal_nn_1_N = mkN "kopplingspedal" "kopplingspedaler" ;
  kopplingston_nn_1_N = mkN "kopplingston" "kopplingstoner" ;
  kopt_nn_1_N = mkN "kopt" "kopter" ;
  kopulation_nn_1_N = mkN "kopulation" "kopulationer" ;
  koralbok_nn_1_N = mkN "koralbok" "koralböcker" ;
  korean_nn_1_N = mkN "korean" "koreaner" ;
  korist_nn_1_N = mkN "korist" "korister" ;
  korkapparat_nn_1_N = mkN "korkapparat" "korkapparater" ;
  korkcell_nn_1_N = mkN "korkcell" "korkceller" ;
  korkpistol_nn_1_N = mkN "korkpistol" "korkpistoler" ;
  korkvaevnad_nn_1_1_N = mkN "korkvävnad" "korkvävnader" ;
  kormoran_nn_1_N = mkN "kormoran" "kormoraner" ;
  kornettist_nn_1_N = mkN "kornettist" "kornettister" ;
  kornisch_nn_1_N = mkN "kornisch" "kornischer" ;
  korporation_nn_1_N = mkN "korporation" "korporationer" ;
  korporatism_nn_1_N = mkN "korporatism" "korporatismer" ;
  korporativism_nn_1_N = mkN "korporativism" "korporativismer" ;
  korrasion_nn_1_N = mkN "korrasion" "korrasioner" ;
  korrektion_nn_1_N = mkN "korrektion" "korrektioner" ;
  korrektionsanstalt_nn_1_N = mkN "korrektionsanstalt" "korrektionsanstalter" ;
  korrelation_nn_1_N = mkN "korrelation" "korrelationer" ;
  korrespondens_nn_1_N = mkN "korrespondens" "korrespondenser" ;
  korrespondenskurs_nn_1_N = mkN "korrespondenskurs" "korrespondenskurser" ;
  korrosion_nn_1_N = mkN "korrosion" "korrosioner" ;
  korrosionsinhibitor_nn_1_N = mkN "korrosionsinhibitor" "korrosionsinhibitorer" ;
  korruption_nn_1_N = mkN "korruption" "korruptioner" ;
  korruptionsnivaa_nn_1_1_N = mkN "korruptionsnivå" "korruptionsnivåer" ;
  korruptionsskandal_nn_1_N = mkN "korruptionsskandal" "korruptionsskandaler" ;
  korsfarararm_e_nn_1_1_N = mkN "korsfarararmé" "korsfarararméer" ;
  korsfararstat_nn_1_N = mkN "korsfararstat" "korsfararstater" ;
  korsikan_nn_1_N = mkN "korsikan" "korsikaner" ;
  korspollination_nn_1_N = mkN "korspollination" "korspollinationer" ;
  korsreferens_nn_1_N = mkN "korsreferens" "korsreferenser" ;
  korstaagskroenikoer_nn_1_1_N = mkN "korstågskrönikör" "korstågskrönikörer" ;
  kortdistans_nn_1_N = mkN "kortdistans" "kortdistanser" ;
  kortfilm_nn_1_N = mkN "kortfilm" "kortfilmer" ;
  kortform_nn_1_N = mkN "kortform" "kortformer" ;
  korthet_nn_1_N = mkN "korthet" "kortheter" ;
  kortisol_nn_1_N = mkN "kortisol" "kortisoler" ;
  kortkonst_nn_1_N = mkN "kortkonst" "kortkonster" ;
  kortroman_nn_1_N = mkN "kortroman" "kortromaner" ;
  kortstoeld_nn_1_1_N = mkN "kortstöld" "kortstölder" ;
  korvfabrik_nn_1_N = mkN "korvfabrik" "korvfabriker" ;
  korvfabrikoer_nn_1_1_N = mkN "korvfabrikör" "korvfabrikörer" ;
  korvkiosk_nn_1_N = mkN "korvkiosk" "korvkiosker" ;
  korvmaskin_nn_1_N = mkN "korvmaskin" "korvmaskiner" ;
  kosackdans_nn_1_N = mkN "kosackdans" "kosackdanser" ;
  kosackhetman_nn_1_N = mkN "kosackhetman" "kosackhetmaner" ;
  kosmetikaaffaer_nn_1_1_N = mkN "kosmetikaaffär" "kosmetikaaffärer" ;
  kosmetolog_nn_1_N = mkN "kosmetolog" "kosmetologer" ;
  kosmolog_nn_1_N = mkN "kosmolog" "kosmologer" ;
  kosmopolit_nn_1_N = mkN "kosmopolit" "kosmopoliter" ;
  kosovar_nn_1_N = mkN "kosovar" "kosovarer" ;
  kostbarhet_nn_1_N = mkN "kostbarhet" "kostbarheter" ;
  kostnad_nn_1_N = mkN "kostnad" "kostnader" ;
  kostymbal_nn_1_N = mkN "kostymbal" "kostymbaler" ;
  kostympjaes_nn_1_1_N = mkN "kostympjäs" "kostympjäser" ;
  kotled_nn_1_N = mkN "kotled" "kotleder" ;
  kotlettrad_nn_1_N = mkN "kotlettrad" "kotlettrader" ;
  koyot_nn_1_N = mkN "koyot" "koyoter" ;
  kraal_nn_1_N = mkN "kraal" "kraaler" ;
  kraft_nn_1_N = mkN "kraft" "krafter" ;
  kraftekvation_nn_1_N = mkN "kraftekvation" "kraftekvationer" ;
  kraftloeshet_nn_1_1_N = mkN "kraftlöshet" "kraftlösheter" ;
  kraftsport_nn_1_N = mkN "kraftsport" "kraftsporter" ;
  kraftstation_nn_1_N = mkN "kraftstation" "kraftstationer" ;
  kraftaatgaerd_nn_1_1_N = mkN "kraftåtgärd" "kraftåtgärder" ;
  kral_nn_1_N = mkN "kral" "kraler" ;
  krasch_nn_2_N = mkN "krasch" "krascher" ;
  kraschan_nn_1_N = mkN "kraschan" "kraschaner" ;
  krasslighet_nn_1_N = mkN "krasslighet" "krassligheter" ;
  kravall_nn_1_N = mkN "kravall" "kravaller" ;
  kravallpolis_nn_2_N = mkN "kravallpolis" "kravallpoliser" ;
  kravspecifikation_nn_1_N = mkN "kravspecifikation" "kravspecifikationer" ;
  kreation_nn_1_N = mkN "kreation" "kreationer" ;
  kreativitet_nn_1_N = mkN "kreativitet" "kreativiteter" ;
  kredit_nn_1_N = mkN "kredit" "krediter" ;
  kreditfoerlust_nn_1_1_N = mkN "kreditförlust" "kreditförluster" ;
  kreditmarknad_nn_1_N = mkN "kreditmarknad" "kreditmarknader" ;
  kreditor_nn_1_N = mkN "kreditor" "kreditorer" ;
  kremlolog_nn_1_N = mkN "kremlolog" "kremlologer" ;
  kreol_nn_1_N = mkN "kreol" "kreoler" ;
  kreolkultur_nn_1_N = mkN "kreolkultur" "kreolkulturer" ;
  kretin_nn_1_N = mkN "kretin" "kretiner" ;
  kretinism_nn_1_N = mkN "kretinism" "kretinismer" ;
  krigsdagbok_nn_1_N = mkN "krigsdagbok" "krigsdagböcker" ;
  krigsdans_nn_1_N = mkN "krigsdans" "krigsdanser" ;
  krigsdekoration_nn_1_N = mkN "krigsdekoration" "krigsdekorationer" ;
  krigsdiamant_nn_1_N = mkN "krigsdiamant" "krigsdiamanter" ;
  krigsinsats_nn_1_N = mkN "krigsinsats" "krigsinsatser" ;
  krigskolportoer_nn_1_1_N = mkN "krigskolportör" "krigskolportörer" ;
  krigskredit_nn_1_N = mkN "krigskredit" "krigskrediter" ;
  krigsmakt_nn_1_N = mkN "krigsmakt" "krigsmakter" ;
  krigsprofitoer_nn_1_1_N = mkN "krigsprofitör" "krigsprofitörer" ;
  krigsrisk_nn_1_N = mkN "krigsrisk" "krigsrisker" ;
  krigsroman_nn_1_N = mkN "krigsroman" "krigsromaner" ;
  krigsskaadeplats_nn_1_1_N = mkN "krigsskådeplats" "krigsskådeplatser" ;
  krigszon_nn_1_N = mkN "krigszon" "krigszoner" ;
  kriminalinspektoer_nn_1_1_N = mkN "kriminalinspektör" "kriminalinspektörer" ;
  kriminalitet_nn_1_N = mkN "kriminalitet" "kriminaliteter" ;
  kriminaljournalist_nn_1_N = mkN "kriminaljournalist" "kriminaljournalister" ;
  kriminalpolis_nn_2_N = mkN "kriminalpolis" "kriminalpoliser" ;
  kriminalroman_nn_1_N = mkN "kriminalroman" "kriminalromaner" ;
  kriminolog_nn_1_N = mkN "kriminolog" "kriminologer" ;
  kringelikrokighet_nn_1_N = mkN "kringelikrokighet" "kringelikrokigheter" ;
  kringelkrokighet_nn_1_N = mkN "kringelkrokighet" "kringelkrokigheter" ;
  kringinformation_nn_1_N = mkN "kringinformation" "kringinformationer" ;
  krinolin_nn_1_N = mkN "krinolin" "krinoliner" ;
  kris_nn_1_N = mkN "kris" "kriser" ;
  krisfond_nn_1_N = mkN "krisfond" "krisfonder" ;
  krisgrupp_nn_1_N = mkN "krisgrupp" "krisgrupper" ;
  kristall_nn_1_N = mkN "kristall" "kristaller" ;
  kristallform_nn_1_N = mkN "kristallform" "kristallformer" ;
  kristallins_nn_1_N = mkN "kristallins" "kristallinser" ;
  kristallisation_nn_1_N = mkN "kristallisation" "kristallisationer" ;
  kristdemokrat_nn_1_N = mkN "kristdemokrat" "kristdemokrater" ;
  kristelefon_nn_1_N = mkN "kristelefon" "kristelefoner" ;
  kristenhet_nn_1_N = mkN "kristenhet" "kristenheter" ;
  kristid_nn_1_N = mkN "kristid" "kristider" ;
  krisaatgaerd_nn_1_1_N = mkN "krisåtgärd" "krisåtgärder" ;
  kriticism_nn_1_N = mkN "kriticism" "kriticismer" ;
  kritik_nn_1_N = mkN "kritik" "kritiker" ;
  krogrond_nn_1_N = mkN "krogrond" "krogronder" ;
  krogvakt_nn_1_N = mkN "krogvakt" "krogvakter" ;
  krokan_nn_1_N = mkN "krokan" "krokaner" ;
  krokighet_nn_1_N = mkN "krokighet" "krokigheter" ;
  kromdetalj_nn_1_N = mkN "kromdetalj" "kromdetaljer" ;
  kromlist_nn_1_N = mkN "kromlist" "kromlister" ;
  kronjurist_nn_1_N = mkN "kronjurist" "kronjurister" ;
  kroppsbild_nn_1_N = mkN "kroppsbild" "kroppsbilder" ;
  kroppsbomb_nn_1_N = mkN "kroppsbomb" "kroppsbomber" ;
  kroppsbyggnad_nn_1_N = mkN "kroppsbyggnad" "kroppsbyggnader" ;
  kroppscell_nn_1_N = mkN "kroppscell" "kroppsceller" ;
  kroppsform_nn_1_N = mkN "kroppsform" "kroppsformer" ;
  kroppsfunktion_nn_1_N = mkN "kroppsfunktion" "kroppsfunktioner" ;
  kroppskonstitution_nn_1_N = mkN "kroppskonstitution" "kroppskonstitutioner" ;
  kroppslighet_nn_1_N = mkN "kroppslighet" "kroppsligheter" ;
  kroppsspraaksexpert_nn_1_1_N = mkN "kroppsspråksexpert" "kroppsspråksexperter" ;
  kroppstemperatur_nn_1_N = mkN "kroppstemperatur" "kroppstemperaturer" ;
  kroppsvikt_nn_1_N = mkN "kroppsvikt" "kroppsvikter" ;
  kroppsvisitation_nn_1_N = mkN "kroppsvisitation" "kroppsvisitationer" ;
  kroppsvaevnad_nn_1_1_N = mkN "kroppsvävnad" "kroppsvävnader" ;
  krukvaext_nn_1_1_N = mkN "krukväxt" "krukväxter" ;
  krumelur_nn_1_N = mkN "krumelur" "krumelurer" ;
  krutgas_nn_1_N = mkN "krutgas" "krutgaser" ;
  krutmotor_nn_1_N = mkN "krutmotor" "krutmotorer" ;
  krutsort_nn_1_N = mkN "krutsort" "krutsorter" ;
  kryddgroensak_nn_1_1_N = mkN "kryddgrönsak" "kryddgrönsaker" ;
  kryddsaas_nn_1_1_N = mkN "kryddsås" "kryddsåser" ;
  kryddvaext_nn_1_1_N = mkN "kryddväxt" "kryddväxter" ;
  kryddoert_nn_1_1_N = mkN "kryddört" "kryddörter" ;
  kryphaallfasthet_nn_1_1_N = mkN "kryphållfasthet" "kryphållfastheter" ;
  kryptofascist_nn_1_N = mkN "kryptofascist" "kryptofascister" ;
  kryptonazist_nn_1_N = mkN "kryptonazist" "kryptonazister" ;
  krysolit_nn_1_N = mkN "krysolit" "krysoliter" ;
  krysopras_nn_1_N = mkN "krysopras" "krysopraser" ;
  kryssmast_nn_1_N = mkN "kryssmast" "kryssmaster" ;
  kryssningsdestination_nn_1_N = mkN "kryssningsdestination" "kryssningsdestinationer" ;
  kryssningsmissil_nn_1_N = mkN "kryssningsmissil" "kryssningsmissiler" ;
  kryssroest_nn_1_1_N = mkN "kryssröst" "kryssröster" ;
  kraeftfaangst_nn_1_1_N = mkN "kräftfångst" "kräftfångster" ;
  kraeftpremiaer_nn_1_1_N = mkN "kräftpremiär" "kräftpremiärer" ;
  kraeftsvulst_nn_1_1_N = mkN "kräftsvulst" "kräftsvulster" ;
  kraeftsaesong_nn_1_1_N = mkN "kräftsäsong" "kräftsäsonger" ;
  kraeldjurstyp_nn_1_1_N = mkN "kräldjurstyp" "kräldjurstyper" ;
  kraenkningskaenslighet_nn_1_1_N = mkN "kränkningskänslighet" "kränkningskänsligheter" ;
  kraanglighet_nn_1_1_N = mkN "krånglighet" "krångligheter" ;
  kroenikebok_nn_1_1_N = mkN "krönikebok" "krönikeböcker" ;
  kroenikoer_nn_1_1_N = mkN "krönikör" "krönikörer" ;
  kuban_nn_1_N = mkN "kuban" "kubaner" ;
  kubism_nn_1_N = mkN "kubism" "kubismer" ;
  kubist_nn_1_N = mkN "kubist" "kubister" ;
  kuktrakt_nn_1_N = mkN "kuktrakt" "kuktrakter" ;
  kulighet_nn_1_N = mkN "kulighet" "kuligheter" ;
  kuliss_nn_1_N = mkN "kuliss" "kulisser" ;
  kulled_nn_1_N = mkN "kulled" "kulleder" ;
  kulmination_nn_1_N = mkN "kulmination" "kulminationer" ;
  kulsprutebataljon_nn_1_N = mkN "kulsprutebataljon" "kulsprutebataljoner" ;
  kulsprutepistol_nn_1_N = mkN "kulsprutepistol" "kulsprutepistoler" ;
  kultivator_nn_1_N = mkN "kultivator" "kultivatorer" ;
  kultplats_nn_1_N = mkN "kultplats" "kultplatser" ;
  kultur_nn_1_N = mkN "kultur" "kulturer" ;
  kulturaktivitet_nn_1_N = mkN "kulturaktivitet" "kulturaktiviteter" ;
  kulturattach_e_nn_1_1_N = mkN "kulturattaché" "kulturattachéer" ;
  kulturekonom_nn_1_N = mkN "kulturekonom" "kulturekonomer" ;
  kulturelit_nn_1_N = mkN "kulturelit" "kultureliter" ;
  kulturform_nn_1_N = mkN "kulturform" "kulturformer" ;
  kulturinstitution_nn_1_N = mkN "kulturinstitution" "kulturinstitutioner" ;
  kulturkollision_nn_1_N = mkN "kulturkollision" "kulturkollisioner" ;
  kulturperson_nn_1_N = mkN "kulturperson" "kulturpersoner" ;
  kulturpersonlighet_nn_1_N = mkN "kulturpersonlighet" "kulturpersonligheter" ;
  kulturredaktion_nn_1_N = mkN "kulturredaktion" "kulturredaktioner" ;
  kulturrelativism_nn_1_N = mkN "kulturrelativism" "kulturrelativismer" ;
  kulturrevolution_nn_1_N = mkN "kulturrevolution" "kulturrevolutioner" ;
  kulturskillnad_nn_1_N = mkN "kulturskillnad" "kulturskillnader" ;
  kulturvaext_nn_1_1_N = mkN "kulturväxt" "kulturväxter" ;
  kumpan_nn_1_N = mkN "kumpan" "kumpaner" ;
  kumulation_nn_1_N = mkN "kumulation" "kumulationer" ;
  kundnoejdhetsenkaet_nn_1_1_N = mkN "kundnöjdhetsenkät" "kundnöjdhetsenkäter" ;
  kundservicechef_nn_1_N = mkN "kundservicechef" "kundservicechefer" ;
  kungaed_nn_1_N = mkN "kungaed" "kungaeder" ;
  kungafamilj_nn_1_N = mkN "kungafamilj" "kungafamiljer" ;
  kungatron_nn_1_N = mkN "kungatron" "kungatroner" ;
  kunglighet_nn_1_N = mkN "kunglighet" "kungligheter" ;
  kunskapskontroll_nn_1_N = mkN "kunskapskontroll" "kunskapskontroller" ;
  kunskapsmaskin_nn_1_N = mkN "kunskapsmaskin" "kunskapsmaskiner" ;
  kunskapsnivaa_nn_1_1_N = mkN "kunskapsnivå" "kunskapsnivåer" ;
  kupidon_nn_1_N = mkN "kupidon" "kupidoner" ;
  kupol_nn_1_N = mkN "kupol" "kupoler" ;
  kupplan_nn_1_N = mkN "kupplan" "kupplaner" ;
  kup_e_nn_1_1_N = mkN "kupé" "kupéer" ;
  kuranstalt_nn_1_N = mkN "kuranstalt" "kuranstalter" ;
  kurator_nn_1_N = mkN "kurator" "kuratorer" ;
  kurd_nn_1_N = mkN "kurd" "kurder" ;
  kurgan_nn_1_N = mkN "kurgan" "kurganer" ;
  kuriositet_nn_1_N = mkN "kuriositet" "kuriositeter" ;
  kurir_nn_1_N = mkN "kurir" "kurirer" ;
  kurort_nn_1_N = mkN "kurort" "kurorter" ;
  kurragoemmajakt_nn_1_1_N = mkN "kurragömmajakt" "kurragömmajakter" ;
  kurs_nn_1_N = mkN "kurs" "kurser" ;
  kursiv_nn_1_N = mkN "kursiv" "kursiver" ;
  kursor_nn_1_N = mkN "kursor" "kursorer" ;
  kursplan_nn_1_N = mkN "kursplan" "kursplaner" ;
  kurtis_nn_1_N = mkN "kurtis" "kurtiser" ;
  kurtisan_nn_1_N = mkN "kurtisan" "kurtisaner" ;
  kurvatur_nn_1_N = mkN "kurvatur" "kurvaturer" ;
  kusin_nn_1_N = mkN "kusin" "kusiner" ;
  kuslighet_nn_1_N = mkN "kuslighet" "kusligheter" ;
  kust_nn_1_N = mkN "kust" "kuster" ;
  kustod_nn_1_N = mkN "kustod" "kustoder" ;
  kustort_nn_1_N = mkN "kustort" "kustorter" ;
  kutym_nn_1_N = mkN "kutym" "kutymer" ;
  kuvoes_nn_1_1_N = mkN "kuvös" "kuvöser" ;
  kvadrant_nn_1_N = mkN "kvadrant" "kvadranter" ;
  kvadriljon_nn_1_N = mkN "kvadriljon" "kvadriljoner" ;
  kvadrillion_nn_1_N = mkN "kvadrillion" "kvadrillioner" ;
  kvadrupelallians_nn_1_N = mkN "kvadrupelallians" "kvadrupelallianser" ;
  kvalifikation_nn_1_N = mkN "kvalifikation" "kvalifikationer" ;
  kvalitet_nn_1_N = mkN "kvalitet" "kvaliteter" ;
  kvalitetsauktion_nn_1_N = mkN "kvalitetsauktion" "kvalitetsauktioner" ;
  kvalitetsjournalistik_nn_1_N = mkN "kvalitetsjournalistik" "kvalitetsjournalistiker" ;
  kvalitetskontroll_nn_1_N = mkN "kvalitetskontroll" "kvalitetskontroller" ;
  kvalitetsnorm_nn_1_N = mkN "kvalitetsnorm" "kvalitetsnormer" ;
  kvalitetsprodukt_nn_1_N = mkN "kvalitetsprodukt" "kvalitetsprodukter" ;
  kvalit_e_nn_1_1_N = mkN "kvalité" "kvalitéer" ;
  kvalmighet_nn_1_N = mkN "kvalmighet" "kvalmigheter" ;
  kvantitet_nn_1_N = mkN "kvantitet" "kvantiteter" ;
  kvarskatt_nn_1_N = mkN "kvarskatt" "kvarskatter" ;
  kvarterspolis_nn_1_N = mkN "kvarterspolis" "kvarterspoliser" ;
  kvarts_nn_1_N = mkN "kvarts" "kvartser" ;
  kvartsbutelj_nn_1_N = mkN "kvartsbutelj" "kvartsbuteljer" ;
  kvartsfigur_nn_1_N = mkN "kvartsfigur" "kvartsfigurer" ;
  kvartsfinal_nn_1_N = mkN "kvartsfinal" "kvartsfinaler" ;
  kvartsit_nn_1_N = mkN "kvartsit" "kvartsiter" ;
  kvartskristall_nn_1_N = mkN "kvartskristall" "kvartskristaller" ;
  kvartslivskris_nn_1_N = mkN "kvartslivskris" "kvartslivskriser" ;
  kvartston_nn_1_N = mkN "kvartston" "kvartstoner" ;
  kvasar_nn_1_N = mkN "kvasar" "kvasarer" ;
  kvasikristall_nn_1_N = mkN "kvasikristall" "kvasikristaller" ;
  kverulant_nn_1_N = mkN "kverulant" "kverulanter" ;
  kvickhet_nn_1_N = mkN "kvickhet" "kvickheter" ;
  kvietism_nn_1_N = mkN "kvietism" "kvietismer" ;
  kvinnoaffaer_nn_1_1_N = mkN "kvinnoaffär" "kvinnoaffärer" ;
  kvinnobild_nn_1_N = mkN "kvinnobild" "kvinnobilder" ;
  kvinnodraekt_nn_1_1_N = mkN "kvinnodräkt" "kvinnodräkter" ;
  kvinnokoer_nn_1_1_N = mkN "kvinnokör" "kvinnokörer" ;
  kvinnonatur_nn_1_N = mkN "kvinnonatur" "kvinnonaturer" ;
  kvinnopraest_nn_1_1_N = mkN "kvinnopräst" "kvinnopräster" ;
  kvinnoroll_nn_1_N = mkN "kvinnoroll" "kvinnoroller" ;
  kvinnoraettsaktivist_nn_1_1_N = mkN "kvinnorättsaktivist" "kvinnorättsaktivister" ;
  kvinnoroest_nn_1_1_N = mkN "kvinnoröst" "kvinnoröster" ;
  kvinnoskulptur_nn_1_N = mkN "kvinnoskulptur" "kvinnoskulpturer" ;
  kvinnsperson_nn_1_N = mkN "kvinnsperson" "kvinnspersoner" ;
  kvittens_nn_1_N = mkN "kvittens" "kvittenser" ;
  kvot_nn_1_N = mkN "kvot" "kvoter" ;
  kvaellsignal_nn_1_1_N = mkN "kvällsignal" "kvällsignaler" ;
  kvaellskurs_nn_1_1_N = mkN "kvällskurs" "kvällskurser" ;
  kvaellsmaaltid_nn_1_1_N = mkN "kvällsmåltid" "kvällsmåltider" ;
  kvaellssammankomst_nn_1_1_N = mkN "kvällssammankomst" "kvällssammankomster" ;
  kvaellstidningsrubrik_nn_1_1_N = mkN "kvällstidningsrubrik" "kvällstidningsrubriker" ;
  kvaeveoxid_nn_1_1_N = mkN "kväveoxid" "kväveoxider" ;
  kylapparat_nn_1_N = mkN "kylapparat" "kylapparater" ;
  kylarglykol_nn_1_N = mkN "kylarglykol" "kylarglykoler" ;
  kylighet_nn_2_N = mkN "kylighet" "kyligheter" ;
  kylskaapsmagnet_nn_1_1_N = mkN "kylskåpsmagnet" "kylskåpsmagneter" ;
  kynolog_nn_1_N = mkN "kynolog" "kynologer" ;
  kyrass_nn_1_N = mkN "kyrass" "kyrasser" ;
  kyrkbok_nn_1_N = mkN "kyrkbok" "kyrkböcker" ;
  kyrkbyggnad_nn_1_N = mkN "kyrkbyggnad" "kyrkbyggnader" ;
  kyrkobok_nn_1_N = mkN "kyrkobok" "kyrkoböcker" ;
  kyrkohandbok_nn_1_N = mkN "kyrkohandbok" "kyrkohandböcker" ;
  kaellskatt_nn_1_1_N = mkN "källskatt" "källskatter" ;
  kaendismassoer_nn_1_1_N = mkN "kändismassör" "kändismassörer" ;
  kaeng_nn_1_1_N = mkN "käng" "känger" ;
  kaensloikon_nn_1_1_N = mkN "känsloikon" "känsloikoner" ;
  kaerlekskris_nn_1_1_N = mkN "kärlekskris" "kärlekskriser" ;
  kaerleksroman_nn_1_1_N = mkN "kärleksroman" "kärleksromaner" ;
  kaerleksstrejk_nn_1_1_N = mkN "kärleksstrejk" "kärleksstrejker" ;
  kaerlsvulst_nn_1_1_N = mkN "kärlsvulst" "kärlsvulster" ;
  kaernreaktor_nn_1_1_N = mkN "kärnreaktor" "kärnreaktorer" ;
  kaar_nn_1_1_N = mkN "kår" "kårer" ;
  koeksbordsturn_e_nn_1_1_N = mkN "köksbordsturné" "köksbordsturnéer" ;
  koeksvaext_nn_1_1_N = mkN "köksväxt" "köksväxter" ;
  koepenickiad_nn_1_1_N = mkN "köpenickiad" "köpenickiader" ;
  koepkurs_nn_1_1_N = mkN "köpkurs" "köpkurser" ;
  koettfaersskandal_nn_1_1_N = mkN "köttfärsskandal" "köttfärsskandaler" ;
  laborant_nn_1_N = mkN "laborant" "laboranter" ;
  laborator_nn_1_N = mkN "laborator" "laboratorer" ;
  laddningsregulator_nn_1_N = mkN "laddningsregulator" "laddningsregulatorer" ;
  laestadian_nn_1_N = mkN "laestadian" "laestadianer" ;
  laestadianism_nn_1_N = mkN "laestadianism" "laestadianismer" ;
  lagbok_nn_1_N = mkN "lagbok" "lagböcker" ;
  lagerbok_nn_1_N = mkN "lagerbok" "lagerböcker" ;
  lagringsfoerlust_nn_1_1_N = mkN "lagringsförlust" "lagringsförluster" ;
  lagtext_nn_1_N = mkN "lagtext" "lagtexter" ;
  lakonism_nn_1_N = mkN "lakonism" "lakonismer" ;
  laktovegetarian_nn_1_N = mkN "laktovegetarian" "laktovegetarianer" ;
  lamaism_nn_1_N = mkN "lamaism" "lamaismer" ;
  lammfaers_nn_1_1_N = mkN "lammfärs" "lammfärser" ;
  lam_e_nn_1_1_N = mkN "lamé" "laméer" ;
  lan_nn_1_N = mkN "lan" "laner" ;
  landningsfarkost_nn_1_N = mkN "landningsfarkost" "landningsfarkoster" ;
  landstingsdirektoer_nn_1_1_N = mkN "landstingsdirektör" "landstingsdirektörer" ;
  landtransport_nn_1_N = mkN "landtransport" "landtransporter" ;
  landaa_nn_1_1_N = mkN "landå" "landåer" ;
  langobard_nn_1_N = mkN "langobard" "langobarder" ;
  langust_nn_1_N = mkN "langust" "languster" ;
  lankes_nn_1_N = mkN "lankes" "lankeser" ;
  lantbruksdirektoer_nn_1_1_N = mkN "lantbruksdirektör" "lantbruksdirektörer" ;
  lanternin_nn_1_N = mkN "lanternin" "lanterniner" ;
  lantras_nn_1_N = mkN "lantras" "lantraser" ;
  larmrapport_nn_1_N = mkN "larmrapport" "larmrapporter" ;
  larmsignal_nn_1_N = mkN "larmsignal" "larmsignaler" ;
  larv_nn_1_N = mkN "larv" "larver" ;
  larvtraktor_nn_1_N = mkN "larvtraktor" "larvtraktorer" ;
  laryngit_nn_1_N = mkN "laryngit" "laryngiter" ;
  laryngolog_nn_1_N = mkN "laryngolog" "laryngologer" ;
  lasaron_nn_1_N = mkN "lasaron" "lasaroner" ;
  last_nn_1_N = mkN "last" "laster" ;
  lastageplats_nn_1_N = mkN "lastageplats" "lastageplatser" ;
  lastbilschauffoer_nn_1_1_N = mkN "lastbilschaufför" "lastbilschaufförer" ;
  lastbilstransport_nn_1_N = mkN "lastbilstransport" "lastbilstransporter" ;
  lasur_nn_1_N = mkN "lasur" "lasurer" ;
  latinamerikan_nn_1_N = mkN "latinamerikan" "latinamerikaner" ;
  latinism_nn_1_N = mkN "latinism" "latinismer" ;
  latinlektor_nn_1_N = mkN "latinlektor" "latinlektorer" ;
  lativ_nn_1_N = mkN "lativ" "lativer" ;
  latrin_nn_1_N = mkN "latrin" "latriner" ;
  lavin_nn_1_N = mkN "lavin" "laviner" ;
  laxfile_nn_1_N = mkN "laxfile" "laxfileer" ;
  laxfil_e_nn_1_1_N = mkN "laxfilé" "laxfiléer" ;
  lazzaron_nn_1_N = mkN "lazzaron" "lazzaroner" ;
  led_nn_1_N = mkN "led" "leder" ;
  ledarplats_nn_1_N = mkN "ledarplats" "ledarplatser" ;
  ledgaangsreumatism_nn_1_1_N = mkN "ledgångsreumatism" "ledgångsreumatismer" ;
  ledighetskommitt_e_nn_1_1_N = mkN "ledighetskommitté" "ledighetskommittéer" ;
  legend_nn_1_N = mkN "legend" "legender" ;
  legendar_nn_1_N = mkN "legendar" "legendarer" ;
  legislatur_nn_1_N = mkN "legislatur" "legislaturer" ;
  legitimist_nn_1_N = mkN "legitimist" "legitimister" ;
  legosoldat_nn_1_N = mkN "legosoldat" "legosoldater" ;
  leguan_nn_1_N = mkN "leguan" "leguaner" ;
  lekplats_nn_1_N = mkN "lekplats" "lekplatser" ;
  leksaksfigur_nn_1_N = mkN "leksaksfigur" "leksaksfigurer" ;
  leksakspistol_nn_1_N = mkN "leksakspistol" "leksakspistoler" ;
  lektor_nn_1_N = mkN "lektor" "lektorer" ;
  lektorstjaenst_nn_1_1_N = mkN "lektorstjänst" "lektorstjänster" ;
  lektris_nn_1_N = mkN "lektris" "lektriser" ;
  lemur_nn_1_N = mkN "lemur" "lemurer" ;
  leninism_nn_1_N = mkN "leninism" "leninismer" ;
  lergoeksroest_nn_1_1_N = mkN "lergöksröst" "lergöksröster" ;
  lestadian_nn_1_N = mkN "lestadian" "lestadianer" ;
  lestadianism_nn_1_N = mkN "lestadianism" "lestadianismer" ;
  levantin_nn_1_N = mkN "levantin" "levantiner" ;
  leverans_nn_1_N = mkN "leverans" "leveranser" ;
  leverpastej_nn_1_N = mkN "leverpastej" "leverpastejer" ;
  levit_nn_1_N = mkN "levit" "leviter" ;
  levnadsnivaa_nn_1_1_N = mkN "levnadsnivå" "levnadsnivåer" ;
  lexfras_nn_1_N = mkN "lexfras" "lexfraser" ;
  lexikolog_nn_1_N = mkN "lexikolog" "lexikologer" ;
  lexikonresurs_nn_1_N = mkN "lexikonresurs" "lexikonresurser" ;
  lian_nn_1_N = mkN "lian" "lianer" ;
  libanes_nn_1_N = mkN "libanes" "libaneser" ;
  liberal_nn_1_N = mkN "liberal" "liberaler" ;
  liberalism_nn_1_N = mkN "liberalism" "liberalismer" ;
  liberian_nn_1_N = mkN "liberian" "liberianer" ;
  libertin_nn_1_N = mkN "libertin" "libertiner" ;
  libertinism_nn_1_N = mkN "libertinism" "libertinismer" ;
  librettist_nn_1_N = mkN "librettist" "librettister" ;
  licens_nn_1_N = mkN "licens" "licenser" ;
  ligatur_nn_1_N = mkN "ligatur" "ligaturer" ;
  liggplats_nn_1_N = mkN "liggplats" "liggplatser" ;
  ligist_nn_1_N = mkN "ligist" "ligister" ;
  ligur_nn_1_N = mkN "ligur" "ligurer" ;
  liktor_nn_1_N = mkN "liktor" "liktorer" ;
  likvid_nn_1_N = mkN "likvid" "likvider" ;
  likvidator_nn_1_N = mkN "likvidator" "likvidatorer" ;
  liljekonvalj_nn_1_N = mkN "liljekonvalj" "liljekonvaljer" ;
  liljevaext_nn_1_1_N = mkN "liljeväxt" "liljeväxter" ;
  limousin_nn_1_N = mkN "limousin" "limousiner" ;
  lingvist_nn_1_N = mkN "lingvist" "lingvister" ;
  linnedamast_nn_1_N = mkN "linnedamast" "linnedamaster" ;
  lins_nn_1_N = mkN "lins" "linser" ;
  lipas_nn_1_N = mkN "lipas" "lipaser" ;
  lipid_nn_1_N = mkN "lipid" "lipider" ;
  list_nn_1_N = mkN "list" "lister" ;
  lisoes_nn_1_1_N = mkN "lisös" "lisöser" ;
  litotes_nn_1_N = mkN "litotes" "litoteser" ;
  litteratur_nn_1_N = mkN "litteratur" "litteraturer" ;
  litteraturingenjoer_nn_1_1_N = mkN "litteraturingenjör" "litteraturingenjörer" ;
  litteraturprofessor_nn_1_N = mkN "litteraturprofessor" "litteraturprofessorer" ;
  livdrabant_nn_1_N = mkN "livdrabant" "livdrabanter" ;
  livskris_nn_1_N = mkN "livskris" "livskriser" ;
  livsmedelskontroll_nn_1_N = mkN "livsmedelskontroll" "livsmedelskontroller" ;
  livsmedelskonvoj_nn_1_N = mkN "livsmedelskonvoj" "livsmedelskonvojer" ;
  livsmedelsproducent_nn_1_N = mkN "livsmedelsproducent" "livsmedelsproducenter" ;
  livsmedelstillsats_nn_1_N = mkN "livsmedelstillsats" "livsmedelstillsatser" ;
  livsnatur_nn_1_N = mkN "livsnatur" "livsnaturer" ;
  livsprincip_nn_1_N = mkN "livsprincip" "livsprinciper" ;
  livsprocess_nn_1_N = mkN "livsprocess" "livsprocesser" ;
  livsstilsfaktor_nn_1_N = mkN "livsstilsfaktor" "livsstilsfaktorer" ;
  livsstilsoas_nn_1_N = mkN "livsstilsoas" "livsstilsoaser" ;
  ljudbok_nn_1_N = mkN "ljudbok" "ljudböcker" ;
  ljudfrekvens_nn_1_N = mkN "ljudfrekvens" "ljudfrekvenser" ;
  ljudkuliss_nn_1_N = mkN "ljudkuliss" "ljudkulisser" ;
  ljudnivaa_nn_1_1_N = mkN "ljudnivå" "ljudnivåer" ;
  ljudsignal_nn_1_N = mkN "ljudsignal" "ljudsignaler" ;
  ljungvaext_nn_1_1_N = mkN "ljungväxt" "ljungväxter" ;
  ljuslist_nn_1_N = mkN "ljuslist" "ljuslister" ;
  ljussignal_nn_1_N = mkN "ljussignal" "ljussignaler" ;
  lobby_nn_1_N = mkN "lobby" "lobbyer" ;
  lobbyinsats_nn_1_N = mkN "lobbyinsats" "lobbyinsatser" ;
  loggbok_nn_1_N = mkN "loggbok" "loggböcker" ;
  logotyp_nn_1_N = mkN "logotyp" "logotyper" ;
  lokal_nn_1_N = mkN "lokal" "lokaler" ;
  lokalpatriot_nn_1_N = mkN "lokalpatriot" "lokalpatrioter" ;
  lokalredaktoer_nn_1_1_N = mkN "lokalredaktör" "lokalredaktörer" ;
  lokaltelefon_nn_1_N = mkN "lokaltelefon" "lokaltelefoner" ;
  lokativ_nn_1_N = mkN "lokativ" "lokativer" ;
  lokomobil_nn_1_N = mkN "lokomobil" "lokomobiler" ;
  lokomotor_nn_1_N = mkN "lokomotor" "lokomotorer" ;
  lotsplats_nn_1_N = mkN "lotsplats" "lotsplatser" ;
  lotssignal_nn_1_N = mkN "lotssignal" "lotssignaler" ;
  lottovinst_nn_1_N = mkN "lottovinst" "lottovinster" ;
  lubrikator_nn_1_N = mkN "lubrikator" "lubrikatorer" ;
  luciafest_nn_1_N = mkN "luciafest" "luciafester" ;
  luft_nn_2_N = mkN "luft" "lufter" ;
  luftfarkost_nn_1_N = mkN "luftfarkost" "luftfarkoster" ;
  luftkompressor_nn_1_N = mkN "luftkompressor" "luftkompressorer" ;
  luftkuddefarkost_nn_1_N = mkN "luftkuddefarkost" "luftkuddefarkoster" ;
  luftmadrass_nn_1_N = mkN "luftmadrass" "luftmadrasser" ;
  luftmast_nn_1_N = mkN "luftmast" "luftmaster" ;
  luftpistol_nn_1_N = mkN "luftpistol" "luftpistoler" ;
  luftroerskatarr_nn_1_1_N = mkN "luftrörskatarr" "luftrörskatarrer" ;
  lufttemperatur_nn_1_N = mkN "lufttemperatur" "lufttemperaturer" ;
  lufttransport_nn_1_N = mkN "lufttransport" "lufttransporter" ;
  lukt_nn_1_N = mkN "lukt" "lukter" ;
  lummervaext_nn_1_1_N = mkN "lummerväxt" "lummerväxter" ;
  lunch_nn_1_N = mkN "lunch" "luncher" ;
  lunchbuff_e_nn_1_1_N = mkN "lunchbuffé" "lunchbufféer" ;
  lunchrast_nn_1_N = mkN "lunchrast" "lunchraster" ;
  lunchrestaurang_nn_1_N = mkN "lunchrestaurang" "lunchrestauranger" ;
  lunett_nn_1_N = mkN "lunett" "lunetter" ;
  lungkatarr_nn_1_N = mkN "lungkatarr" "lungkatarrer" ;
  lupin_nn_1_N = mkN "lupin" "lupiner" ;
  lussefest_nn_1_N = mkN "lussefest" "lussefester" ;
  lustgas_nn_1_N = mkN "lustgas" "lustgaser" ;
  lustimpuls_nn_1_N = mkN "lustimpuls" "lustimpulser" ;
  lutheran_nn_1_N = mkN "lutheran" "lutheraner" ;
  lutheranism_nn_1_N = mkN "lutheranism" "lutheranismer" ;
  lynett_nn_1_N = mkN "lynett" "lynetter" ;
  lysdiod_nn_1_N = mkN "lysdiod" "lysdioder" ;
  lysgas_nn_1_N = mkN "lysgas" "lysgaser" ;
  lyspistol_nn_1_N = mkN "lyspistol" "lyspistoler" ;
  lysroersarmatur_nn_1_1_N = mkN "lysrörsarmatur" "lysrörsarmaturer" ;
  lyssats_nn_1_N = mkN "lyssats" "lyssatser" ;
  lyssnarpost_nn_1_N = mkN "lyssnarpost" "lyssnarposter" ;
  lyxklass_nn_1_N = mkN "lyxklass" "lyxklasser" ;
  lyxskatt_nn_1_N = mkN "lyxskatt" "lyxskatter" ;
  laegesanalys_nn_1_1_N = mkN "lägesanalys" "lägesanalyser" ;
  laegesrapport_nn_1_1_N = mkN "lägesrapport" "lägesrapporter" ;
  laegstanivaa_nn_1_1_N = mkN "lägstanivå" "lägstanivåer" ;
  laekarbok_nn_1_1_N = mkN "läkarbok" "läkarböcker" ;
  laekarpraktik_nn_1_1_N = mkN "läkarpraktik" "läkarpraktiker" ;
  laekemedelskontroll_nn_1_1_N = mkN "läkemedelskontroll" "läkemedelskontroller" ;
  laekevaext_nn_1_1_N = mkN "läkeväxt" "läkeväxter" ;
  laengd_nn_1_1_N = mkN "längd" "längder" ;
  laensarbetsdirektoer_nn_1_1_N = mkN "länsarbetsdirektör" "länsarbetsdirektörer" ;
  laensstolslingvist_nn_1_1_N = mkN "länsstolslingvist" "länsstolslingvister" ;
  laerarinneroest_nn_1_1_N = mkN "lärarinneröst" "lärarinneröster" ;
  laerdomsgigant_nn_1_1_N = mkN "lärdomsgigant" "lärdomsgiganter" ;
  laerobok_nn_1_1_N = mkN "lärobok" "läroböcker" ;
  laerobokssats_nn_1_1_N = mkN "lärobokssats" "lärobokssatser" ;
  laeroplan_nn_1_1_N = mkN "läroplan" "läroplaner" ;
  laerosats_nn_1_1_N = mkN "lärosats" "lärosatser" ;
  laesebok_nn_1_1_N = mkN "läsebok" "läseböcker" ;
  laeskedrycksannons_nn_1_1_N = mkN "läskedrycksannons" "läskedrycksannonser" ;
  laeskedrycksproducent_nn_1_1_N = mkN "läskedrycksproducent" "läskedrycksproducenter" ;
  laesklass_nn_1_1_N = mkN "läsklass" "läsklasser" ;
  laespraest_nn_1_1_N = mkN "läspräst" "läspräster" ;
  laest_nn_1_1_N = mkN "läst" "läster" ;
  laestadian_nn_1_1_N = mkN "lästadian" "lästadianer" ;
  laestadianism_nn_1_1_N = mkN "lästadianism" "lästadianismer" ;
  laettmatros_nn_1_1_N = mkN "lättmatros" "lättmatroser" ;
  laettvariant_nn_1_1_N = mkN "lättvariant" "lättvarianter" ;
  laettvattenreaktor_nn_1_1_N = mkN "lättvattenreaktor" "lättvattenreaktorer" ;
  laagbudgetturist_nn_1_1_N = mkN "lågbudgetturist" "lågbudgetturister" ;
  laagfrekvens_nn_1_1_N = mkN "lågfrekvens" "lågfrekvenser" ;
  laagkonjunktur_nn_1_1_N = mkN "lågkonjunktur" "lågkonjunkturer" ;
  laaglandsras_nn_1_1_N = mkN "låglandsras" "låglandsraser" ;
  laagsaesong_nn_1_1_N = mkN "lågsäsong" "lågsäsonger" ;
  laanefest_nn_1_1_N = mkN "lånefest" "lånefester" ;
  laangdans_nn_1_1_N = mkN "långdans" "långdanser" ;
  laangdistans_nn_1_1_N = mkN "långdistans" "långdistanser" ;
  laangkalsongsdebut_nn_1_1_N = mkN "långkalsongsdebut" "långkalsongsdebuter" ;
  laangmarsch_nn_1_1_N = mkN "långmarsch" "långmarscher" ;
  laangtidsprognos_nn_1_1_N = mkN "långtidsprognos" "långtidsprognoser" ;
  laangtradarchauffoer_nn_1_1_N = mkN "långtradarchaufför" "långtradarchaufförer" ;
  laangtradarmotor_nn_1_1_N = mkN "långtradarmotor" "långtradarmotorer" ;
  laatsasfigur_nn_1_1_N = mkN "låtsasfigur" "låtsasfigurer" ;
  laatsaskamrat_nn_1_1_N = mkN "låtsaskamrat" "låtsaskamrater" ;
  laattext_nn_1_1_N = mkN "låttext" "låttexter" ;
  lxstadian_nn_1_N = mkN "læstadian" "læstadianer" ;
  lxstadianism_nn_1_N = mkN "læstadianism" "læstadianismer" ;
  loegndetektor_nn_1_1_N = mkN "lögndetektor" "lögndetektorer" ;
  loegnkampanj_nn_1_1_N = mkN "lögnkampanj" "lögnkampanjer" ;
  loekkupol_nn_1_1_N = mkN "lökkupol" "lökkupoler" ;
  loeksaas_nn_1_1_N = mkN "löksås" "löksåser" ;
  loekvaext_nn_1_1_N = mkN "lökväxt" "lökväxter" ;
  loen_nn_1_1_N = mkN "lön" "löner" ;
  loeneklass_nn_1_1_N = mkN "löneklass" "löneklasser" ;
  loenenivaa_nn_1_1_N = mkN "lönenivå" "lönenivåer" ;
  loeneplan_nn_1_1_N = mkN "löneplan" "löneplaner" ;
  loeneprotest_nn_1_1_N = mkN "löneprotest" "löneprotester" ;
  loenerutin_nn_1_1_N = mkN "lönerutin" "lönerutiner" ;
  machiavellism_nn_1_N = mkN "machiavellism" "machiavellismer" ;
  madagask_nn_1_N = mkN "madagask" "madagasker" ;
  madrass_nn_1_N = mkN "madrass" "madrasser" ;
  magdans_nn_1_N = mkN "magdans" "magdanser" ;
  magdansoes_nn_1_1_N = mkN "magdansös" "magdansöser" ;
  magkatarr_nn_1_N = mkN "magkatarr" "magkatarrer" ;
  magmedicin_nn_1_N = mkN "magmedicin" "magmediciner" ;
  magnat_nn_1_N = mkN "magnat" "magnater" ;
  magnet_nn_1_N = mkN "magnet" "magneter" ;
  magnetism_nn_1_N = mkN "magnetism" "magnetismer" ;
  magnetkompass_nn_1_N = mkN "magnetkompass" "magnetkompasser" ;
  magnetofon_nn_1_N = mkN "magnetofon" "magnetofoner" ;
  magnetron_nn_1_N = mkN "magnetron" "magnetroner" ;
  magnumbutelj_nn_1_N = mkN "magnumbutelj" "magnumbuteljer" ;
  majonnaes_nn_1_1_N = mkN "majonnäs" "majonnäser" ;
  majonnaessaas_nn_1_1_N = mkN "majonnässås" "majonnässåser" ;
  major_nn_1_N = mkN "major" "majorer" ;
  makron_nn_1_N = mkN "makron" "makroner" ;
  makt_nn_2_N = mkN "makt" "makter" ;
  maktbalans_nn_1_N = mkN "maktbalans" "maktbalanser" ;
  maktbas_nn_1_N = mkN "maktbas" "maktbaser" ;
  maktfaktor_nn_1_N = mkN "maktfaktor" "maktfaktorer" ;
  maktsymbol_nn_1_N = mkN "maktsymbol" "maktsymboler" ;
  malaj_nn_1_N = mkN "malaj" "malajer" ;
  malakit_nn_1_N = mkN "malakit" "malakiter" ;
  malariaparasit_nn_1_N = mkN "malariaparasit" "malariaparasiter" ;
  malariavaccin_nn_1_N = mkN "malariavaccin" "malariavacciner" ;
  malmtransport_nn_1_N = mkN "malmtransport" "malmtransporter" ;
  maltes_nn_1_N = mkN "maltes" "malteser" ;
  manchesterkavaj_nn_1_N = mkN "manchesterkavaj" "manchesterkavajer" ;
  manchesterliberalism_nn_1_N = mkN "manchesterliberalism" "manchesterliberalismer" ;
  mandarin_nn_1_N = mkN "mandarin" "mandariner" ;
  mandolin_nn_1_N = mkN "mandolin" "mandoliner" ;
  manetdoktorand_nn_1_N = mkN "manetdoktorand" "manetdoktorander" ;
  manganin_nn_1_N = mkN "manganin" "manganiner" ;
  manierism_nn_1_N = mkN "manierism" "manierismer" ;
  manikeism_nn_1_N = mkN "manikeism" "manikeismer" ;
  manikur_nn_1_N = mkN "manikur" "manikurer" ;
  manikurist_nn_1_N = mkN "manikurist" "manikurister" ;
  manikyrist_nn_1_N = mkN "manikyrist" "manikyrister" ;
  manschauvinism_nn_1_N = mkN "manschauvinism" "manschauvinismer" ;
  mansroest_nn_1_1_N = mkN "mansröst" "mansröster" ;
  mantilj_nn_1_N = mkN "mantilj" "mantiljer" ;
  manufaktur_nn_1_N = mkN "manufaktur" "manufakturer" ;
  maoism_nn_1_N = mkN "maoism" "maoismer" ;
  mardroemsjulfest_nn_1_1_N = mkN "mardrömsjulfest" "mardrömsjulfester" ;
  marginalinkomst_nn_1_N = mkN "marginalinkomst" "marginalinkomster" ;
  marginalskatt_nn_1_N = mkN "marginalskatt" "marginalskatter" ;
  marin_nn_1_N = mkN "marin" "mariner" ;
  marinad_nn_1_N = mkN "marinad" "marinader" ;
  marinarkeolog_nn_1_N = mkN "marinarkeolog" "marinarkeologer" ;
  marinattach_e_nn_1_1_N = mkN "marinattaché" "marinattachéer" ;
  marinbiolog_nn_1_N = mkN "marinbiolog" "marinbiologer" ;
  marindirektoer_nn_1_1_N = mkN "marindirektör" "marindirektörer" ;
  marinsoldat_nn_1_N = mkN "marinsoldat" "marinsoldater" ;
  mark_nn_1_N = mkN "mark" "marker" ;
  markeffektfarkost_nn_1_N = mkN "markeffektfarkost" "markeffektfarkoster" ;
  markis_nn_1_N = mkN "markis" "markiser" ;
  marknadsfundamentalism_nn_1_N = mkN "marknadsfundamentalism" "marknadsfundamentalismer" ;
  marknadsplats_nn_1_N = mkN "marknadsplats" "marknadsplatser" ;
  marknivaa_nn_1_1_N = mkN "marknivå" "marknivåer" ;
  markorganism_nn_1_N = mkN "markorganism" "markorganismer" ;
  markplan_nn_1_N = mkN "markplan" "markplaner" ;
  marktjaenst_nn_1_1_N = mkN "marktjänst" "marktjänster" ;
  marmelad_nn_1_N = mkN "marmelad" "marmelader" ;
  marmorbyst_nn_1_N = mkN "marmorbyst" "marmorbyster" ;
  marockan_nn_1_N = mkN "marockan" "marockaner" ;
  marsch_nn_1_N = mkN "marsch" "marscher" ;
  marsian_nn_1_N = mkN "marsian" "marsianer" ;
  marsk_nn_1_N = mkN "marsk" "marsker" ;
  marxism_nn_1_N = mkN "marxism" "marxismer" ;
  marxist_nn_1_N = mkN "marxist" "marxister" ;
  maraengsviss_nn_1_1_N = mkN "marängsviss" "marängsvisser" ;
  mask_nn_2_N = mkN "mask" "masker" ;
  maskdiarr_e_nn_1_1_N = mkN "maskdiarré" "maskdiarréer" ;
  maskerad_nn_1_N = mkN "maskerad" "maskerader" ;
  maskin_nn_1_N = mkN "maskin" "maskiner" ;
  maskinist_nn_1_N = mkN "maskinist" "maskinister" ;
  maskinpistol_nn_1_N = mkN "maskinpistol" "maskinpistoler" ;
  maskintelegraf_nn_1_N = mkN "maskintelegraf" "maskintelegrafer" ;
  masochism_nn_1_N = mkN "masochism" "masochismer" ;
  masochist_nn_1_N = mkN "masochist" "masochister" ;
  massfaangst_nn_1_1_N = mkN "massfångst" "massfångster" ;
  masskonst_nn_1_N = mkN "masskonst" "masskonster" ;
  masskultur_nn_1_N = mkN "masskultur" "masskulturer" ;
  massprotest_nn_1_N = mkN "massprotest" "massprotester" ;
  masspsykos_nn_1_N = mkN "masspsykos" "masspsykoser" ;
  mast_nn_1_N = mkN "mast" "master" ;
  matalarmist_nn_1_N = mkN "matalarmist" "matalarmister" ;
  match_nn_1_N = mkN "match" "matcher" ;
  materialism_nn_1_N = mkN "materialism" "materialismer" ;
  materialist_nn_1_N = mkN "materialist" "materialister" ;
  materialkonstant_nn_1_N = mkN "materialkonstant" "materialkonstanter" ;
  materiegas_nn_1_N = mkN "materiegas" "materiegaser" ;
  materietransport_nn_1_N = mkN "materietransport" "materietransporter" ;
  matgaest_nn_1_1_N = mkN "matgäst" "matgäster" ;
  matin_e_nn_1_1_N = mkN "matiné" "matinéer" ;
  matkonserv_nn_1_N = mkN "matkonserv" "matkonserver" ;
  matkultur_nn_1_N = mkN "matkultur" "matkulturer" ;
  matlagningskonst_nn_1_N = mkN "matlagningskonst" "matlagningskonster" ;
  matlaadeleverans_nn_1_1_N = mkN "matlådeleverans" "matlådeleveranser" ;
  matpurist_nn_1_N = mkN "matpurist" "matpurister" ;
  matrast_nn_1_N = mkN "matrast" "matraster" ;
  matrest_nn_1_N = mkN "matrest" "matrester" ;
  matris_nn_1_N = mkN "matris" "matriser" ;
  matros_nn_1_N = mkN "matros" "matroser" ;
  matservis_nn_1_N = mkN "matservis" "matserviser" ;
  matutin_nn_1_N = mkN "matutin" "matutiner" ;
  mauserpistol_nn_1_N = mkN "mauserpistol" "mauserpistoler" ;
  maximitemperatur_nn_1_N = mkN "maximitemperatur" "maximitemperaturer" ;
  maxlast_nn_1_N = mkN "maxlast" "maxlaster" ;
  mazarin_nn_1_N = mkN "mazarin" "mazariner" ;
  medaljplats_nn_1_N = mkN "medaljplats" "medaljplatser" ;
  medeldistans_nn_1_N = mkN "medeldistans" "medeldistanser" ;
  medelinkomst_nn_1_N = mkN "medelinkomst" "medelinkomster" ;
  medelklass_nn_1_N = mkN "medelklass" "medelklasser" ;
  medelproportional_nn_1_N = mkN "medelproportional" "medelproportionaler" ;
  medeltemperatur_nn_1_N = mkN "medeltemperatur" "medeltemperaturer" ;
  medelaalderskris_nn_1_1_N = mkN "medelålderskris" "medelålderskriser" ;
  median_nn_1_N = mkN "median" "medianer" ;
  medicin_nn_1_N = mkN "medicin" "mediciner" ;
  medicinalvaext_nn_1_1_N = mkN "medicinalväxt" "medicinalväxter" ;
  medvetandenivaa_nn_1_1_N = mkN "medvetandenivå" "medvetandenivåer" ;
  megafon_nn_1_N = mkN "megafon" "megafoner" ;
  megalit_nn_1_N = mkN "megalit" "megaliter" ;
  megaloman_nn_1_N = mkN "megaloman" "megalomaner" ;
  mejerist_nn_1_N = mkN "mejerist" "mejerister" ;
  mekanism_nn_1_N = mkN "mekanism" "mekanismer" ;
  melatonin_nn_1_N = mkN "melatonin" "melatoniner" ;
  melatoninnivaa_nn_1_1_N = mkN "melatoninnivå" "melatoninnivåer" ;
  mellanbok_nn_1_N = mkN "mellanbok" "mellanböcker" ;
  mellankultur_nn_1_N = mkN "mellankultur" "mellankulturer" ;
  mellansubstans_nn_1_N = mkN "mellansubstans" "mellansubstanser" ;
  melodram_nn_1_N = mkN "melodram" "melodramer" ;
  melon_nn_1_N = mkN "melon" "meloner" ;
  memoarbok_nn_1_N = mkN "memoarbok" "memoarböcker" ;
  memorial_nn_1_N = mkN "memorial" "memorialer" ;
  mendelism_nn_1_N = mkN "mendelism" "mendelismer" ;
  menisk_nn_1_N = mkN "menisk" "menisker" ;
  menopaus_nn_1_N = mkN "menopaus" "menopauser" ;
  mensur_nn_1_N = mkN "mensur" "mensurer" ;
  mentalism_nn_1_N = mkN "mentalism" "mentalismer" ;
  mentor_nn_1_N = mkN "mentor" "mentorer" ;
  meny_nn_1_N = mkN "meny" "menyer" ;
  meridian_nn_1_N = mkN "meridian" "meridianer" ;
  merit_nn_1_N = mkN "merit" "meriter" ;
  merkantilism_nn_1_N = mkN "merkantilism" "merkantilismer" ;
  merkantilist_nn_1_N = mkN "merkantilist" "merkantilister" ;
  merkaptan_nn_1_N = mkN "merkaptan" "merkaptaner" ;
  meronym_nn_1_N = mkN "meronym" "meronymer" ;
  mervaerdesskatt_nn_1_1_N = mkN "mervärdesskatt" "mervärdesskatter" ;
  mesallians_nn_1_N = mkN "mesallians" "mesallianser" ;
  mesan_nn_1_N = mkN "mesan" "mesaner" ;
  mesanmast_nn_1_N = mkN "mesanmast" "mesanmaster" ;
  meson_nn_1_N = mkN "meson" "mesoner" ;
  mestis_nn_1_N = mkN "mestis" "mestiser" ;
  metabolism_nn_1_N = mkN "metabolism" "metabolismer" ;
  metalldetektor_nn_1_N = mkN "metalldetektor" "metalldetektorer" ;
  metalloid_nn_1_N = mkN "metalloid" "metalloider" ;
  metalloxid_nn_1_N = mkN "metalloxid" "metalloxider" ;
  metallrusch_nn_1_N = mkN "metallrusch" "metallruscher" ;
  metallspekulant_nn_1_N = mkN "metallspekulant" "metallspekulanter" ;
  metamorfos_nn_1_N = mkN "metamorfos" "metamorfoser" ;
  metastas_nn_1_N = mkN "metastas" "metastaser" ;
  metates_nn_1_N = mkN "metates" "metateser" ;
  meteorit_nn_1_N = mkN "meteorit" "meteoriter" ;
  meteorolog_nn_1_N = mkN "meteorolog" "meteorologer" ;
  metodiklektor_nn_1_N = mkN "metodiklektor" "metodiklektorer" ;
  metodism_nn_1_N = mkN "metodism" "metodismer" ;
  metodist_nn_1_N = mkN "metodist" "metodister" ;
  metropol_nn_1_N = mkN "metropol" "metropoler" ;
  metropolit_nn_1_N = mkN "metropolit" "metropoliter" ;
  mexikan_nn_1_N = mkN "mexikan" "mexikaner" ;
  mezzanin_nn_1_N = mkN "mezzanin" "mezzaniner" ;
  mezzosopran_nn_1_N = mkN "mezzosopran" "mezzosopraner" ;
  middagsgaest_nn_1_1_N = mkN "middagsgäst" "middagsgäster" ;
  middagsrast_nn_1_N = mkN "middagsrast" "middagsraster" ;
  migrant_nn_1_N = mkN "migrant" "migranter" ;
  mikrobiolog_nn_1_N = mkN "mikrobiolog" "mikrobiologer" ;
  mikrodator_nn_1_N = mkN "mikrodator" "mikrodatorer" ;
  mikrofon_nn_1_N = mkN "mikrofon" "mikrofoner" ;
  mikroorganism_nn_1_N = mkN "mikroorganism" "mikroorganismer" ;
  mikrotelefon_nn_1_N = mkN "mikrotelefon" "mikrotelefoner" ;
  milis_nn_1_N = mkN "milis" "miliser" ;
  militarism_nn_1_N = mkN "militarism" "militarismer" ;
  militarist_nn_1_N = mkN "militarist" "militarister" ;
  militaerallians_nn_1_1_N = mkN "militärallians" "militärallianser" ;
  militaerattach_e_nn_1_1_N = mkN "militärattaché" "militärattachéer" ;
  militaerbas_nn_1_1_N = mkN "militärbas" "militärbaser" ;
  militaerblockad_nn_1_1_N = mkN "militärblockad" "militärblockader" ;
  militaerdiktatur_nn_1_1_N = mkN "militärdiktatur" "militärdiktaturer" ;
  militaerkolonn_nn_1_1_N = mkN "militärkolonn" "militärkolonner" ;
  militaermarsch_nn_1_1_N = mkN "militärmarsch" "militärmarscher" ;
  militaerpolis_nn_2_1_N = mkN "militärpolis" "militärpoliser" ;
  miljard_nn_1_N = mkN "miljard" "miljarder" ;
  miljon_nn_1_N = mkN "miljon" "miljoner" ;
  miljonklass_nn_1_N = mkN "miljonklass" "miljonklasser" ;
  miljonloen_nn_1_1_N = mkN "miljonlön" "miljonlöner" ;
  miljoeaktivist_nn_1_1_N = mkN "miljöaktivist" "miljöaktivister" ;
  miljoekatastrof_nn_1_1_N = mkN "miljökatastrof" "miljökatastrofer" ;
  miljoekonsekvens_nn_1_1_N = mkN "miljökonsekvens" "miljökonsekvenser" ;
  miljoevinst_nn_1_1_N = mkN "miljövinst" "miljövinster" ;
  milliard_nn_1_N = mkN "milliard" "milliarder" ;
  million_nn_1_N = mkN "million" "millioner" ;
  mineraltillsats_nn_1_N = mkN "mineraltillsats" "mineraltillsatser" ;
  miniatyr_nn_1_N = mkN "miniatyr" "miniatyrer" ;
  minidator_nn_1_N = mkN "minidator" "minidatorer" ;
  minimitemperatur_nn_1_N = mkN "minimitemperatur" "minimitemperaturer" ;
  ministerialbok_nn_1_N = mkN "ministerialbok" "ministerialböcker" ;
  ministerpost_nn_1_N = mkN "ministerpost" "ministerposter" ;
  minnesbok_nn_1_N = mkN "minnesbok" "minnesböcker" ;
  minnesfest_nn_1_N = mkN "minnesfest" "minnesfester" ;
  minnesfoerlust_nn_1_1_N = mkN "minnesförlust" "minnesförluster" ;
  minnesgudstjaenst_nn_1_1_N = mkN "minnesgudstjänst" "minnesgudstjänster" ;
  minneskonst_nn_1_N = mkN "minneskonst" "minneskonster" ;
  minut_nn_2_N = mkN "minut" "minuter" ;
  mirakelmedicin_nn_1_N = mkN "mirakelmedicin" "mirakelmediciner" ;
  miss_nn_2_N = mkN "miss" "misser" ;
  missil_nn_1_N = mkN "missil" "missiler" ;
  missroman_nn_1_N = mkN "missroman" "missromaner" ;
  mixtur_nn_1_N = mkN "mixtur" "mixturer" ;
  mjoelkskandal_nn_1_1_N = mkN "mjölkskandal" "mjölkskandaler" ;
  moar_e_nn_1_1_N = mkN "moaré" "moaréer" ;
  mobbningskampanj_nn_1_N = mkN "mobbningskampanj" "mobbningskampanjer" ;
  mobil_nn_1_N = mkN "mobil" "mobiler" ;
  mobiliseringsplats_nn_1_N = mkN "mobiliseringsplats" "mobiliseringsplatser" ;
  mobiltelefon_nn_1_N = mkN "mobiltelefon" "mobiltelefoner" ;
  mockasin_nn_1_N = mkN "mockasin" "mockasiner" ;
  modeatelj_e_nn_1_1_N = mkN "modeateljé" "modeateljéer" ;
  modell_nn_1_N = mkN "modell" "modeller" ;
  moderat_nn_1_N = mkN "moderat" "moderater" ;
  moderator_nn_1_N = mkN "moderator" "moderatorer" ;
  modernism_nn_1_N = mkN "modernism" "modernismer" ;
  modernist_nn_1_N = mkN "modernist" "modernister" ;
  modist_nn_1_N = mkN "modist" "modister" ;
  modulator_nn_1_N = mkN "modulator" "modulatorer" ;
  mohammedan_nn_1_N = mkN "mohammedan" "mohammedaner" ;
  mohammedanism_nn_1_N = mkN "mohammedanism" "mohammedanismer" ;
  mohikan_nn_1_N = mkN "mohikan" "mohikaner" ;
  molekyl_nn_1_N = mkN "molekyl" "molekyler" ;
  molekylaerbiolog_nn_1_1_N = mkN "molekylärbiolog" "molekylärbiologer" ;
  mollusk_nn_1_N = mkN "mollusk" "mollusker" ;
  molnrest_nn_1_N = mkN "molnrest" "molnrester" ;
  monarkist_nn_1_N = mkN "monarkist" "monarkister" ;
  monegask_nn_1_N = mkN "monegask" "monegasker" ;
  mongol_nn_1_N = mkN "mongol" "mongoler" ;
  mongolism_nn_1_N = mkN "mongolism" "mongolismer" ;
  monism_nn_1_N = mkN "monism" "monismer" ;
  monist_nn_1_N = mkN "monist" "monister" ;
  monitor_nn_1_N = mkN "monitor" "monitorer" ;
  monokotyledon_nn_1_N = mkN "monokotyledon" "monokotyledoner" ;
  monokultur_nn_1_N = mkN "monokultur" "monokulturer" ;
  monolit_nn_1_N = mkN "monolit" "monoliter" ;
  monolog_nn_1_N = mkN "monolog" "monologer" ;
  monoman_nn_1_N = mkN "monoman" "monomaner" ;
  monopolism_nn_1_N = mkN "monopolism" "monopolismer" ;
  monopolist_nn_1_N = mkN "monopolist" "monopolister" ;
  monopolkapitalism_nn_1_N = mkN "monopolkapitalism" "monopolkapitalismer" ;
  monosackarid_nn_1_N = mkN "monosackarid" "monosackarider" ;
  monoteism_nn_1_N = mkN "monoteism" "monoteismer" ;
  monsterkultur_nn_1_N = mkN "monsterkultur" "monsterkulturer" ;
  monstrans_nn_1_N = mkN "monstrans" "monstranser" ;
  montenegrin_nn_1_N = mkN "montenegrin" "montenegriner" ;
  moped_nn_1_N = mkN "moped" "mopeder" ;
  mopedist_nn_1_N = mkN "mopedist" "mopedister" ;
  moralism_nn_1_N = mkN "moralism" "moralismer" ;
  moralist_nn_1_N = mkN "moralist" "moralister" ;
  moralnihilism_nn_1_N = mkN "moralnihilism" "moralnihilismer" ;
  morfemgraens_nn_1_1_N = mkN "morfemgräns" "morfemgränser" ;
  morfinist_nn_1_N = mkN "morfinist" "morfinister" ;
  morfogenes_nn_1_N = mkN "morfogenes" "morfogeneser" ;
  morgongudstjaenst_nn_1_1_N = mkN "morgongudstjänst" "morgongudstjänster" ;
  morian_nn_1_N = mkN "morian" "morianer" ;
  morisk_nn_1_N = mkN "morisk" "morisker" ;
  mormon_nn_1_N = mkN "mormon" "mormoner" ;
  mormonism_nn_1_N = mkN "mormonism" "mormonismer" ;
  morsesignal_nn_1_N = mkN "morsesignal" "morsesignaler" ;
  mosaik_nn_1_N = mkN "mosaik" "mosaiker" ;
  moskit_nn_1_N = mkN "moskit" "moskiter" ;
  moskovit_nn_1_N = mkN "moskovit" "moskoviter" ;
  mosk_e_nn_1_1_N = mkN "moské" "moskéer" ;
  mosk_evandal_nn_1_1_N = mkN "moskévandal" "moskévandaler" ;
  mosskultur_nn_1_N = mkN "mosskultur" "mosskulturer" ;
  motbok_nn_1_N = mkN "motbok" "motböcker" ;
  motdemonstrant_nn_1_N = mkN "motdemonstrant" "motdemonstranter" ;
  motett_nn_1_N = mkN "motett" "motetter" ;
  motivationskonsult_nn_1_N = mkN "motivationskonsult" "motivationskonsulter" ;
  motkultur_nn_1_N = mkN "motkultur" "motkulturer" ;
  motoffensiv_nn_1_N = mkN "motoffensiv" "motoffensiver" ;
  motor_nn_1_N = mkN "motor" "motorer" ;
  motorcykelpolis_nn_1_N = mkN "motorcykelpolis" "motorcykelpoliser" ;
  motorcyklist_nn_1_N = mkN "motorcyklist" "motorcyklister" ;
  motorism_nn_1_N = mkN "motorism" "motorismer" ;
  motorist_nn_1_N = mkN "motorist" "motorister" ;
  motrytm_nn_1_N = mkN "motrytm" "motrytmer" ;
  motsats_nn_1_N = mkN "motsats" "motsatser" ;
  motstaandarsoldat_nn_1_1_N = mkN "motståndarsoldat" "motståndarsoldater" ;
  mp3_bok_nn_1_N = mkN "mp3-bok" "mp3-böcker" ;
  mufflon_nn_1_N = mkN "mufflon" "muffloner" ;
  muhammedan_nn_1_N = mkN "muhammedan" "muhammedaner" ;
  muhammedanism_nn_1_N = mkN "muhammedanism" "muhammedanismer" ;
  multimiljardaer_nn_1_1_N = mkN "multimiljardär" "multimiljardärer" ;
  multimiljonaer_nn_1_1_N = mkN "multimiljonär" "multimiljonärer" ;
  multiplikator_nn_1_N = mkN "multiplikator" "multiplikatorer" ;
  musch_nn_1_N = mkN "musch" "muscher" ;
  muselman_nn_1_N = mkN "muselman" "muselmaner" ;
  musikant_nn_1_N = mkN "musikant" "musikanter" ;
  musikdirektoer_nn_1_1_N = mkN "musikdirektör" "musikdirektörer" ;
  musikfestival_nn_1_N = mkN "musikfestival" "musikfestivaler" ;
  musikgudstjaenst_nn_1_1_N = mkN "musikgudstjänst" "musikgudstjänster" ;
  musikolog_nn_1_N = mkN "musikolog" "musikologer" ;
  muskelreumatism_nn_1_N = mkN "muskelreumatism" "muskelreumatismer" ;
  muskulatur_nn_1_N = mkN "muskulatur" "muskulaturer" ;
  muslim_nn_1_N = mkN "muslim" "muslimer" ;
  musseron_nn_1_N = mkN "musseron" "musseroner" ;
  must_nn_1_N = mkN "must" "muster" ;
  mustasch_nn_1_N = mkN "mustasch" "mustascher" ;
  mutagen_nn_1_N = mkN "mutagen" "mutagener" ;
  mutant_nn_1_N = mkN "mutant" "mutanter" ;
  mutexpert_nn_1_N = mkN "mutexpert" "mutexperter" ;
  mutskandal_nn_1_N = mkN "mutskandal" "mutskandaler" ;
  mykolog_nn_1_N = mkN "mykolog" "mykologer" ;
  myndighetsrepresentant_nn_1_N = mkN "myndighetsrepresentant" "myndighetsrepresentanter" ;
  myon_nn_1_N = mkN "myon" "myoner" ;
  myrgaest_nn_1_1_N = mkN "myrgäst" "myrgäster" ;
  myrvaext_nn_1_1_N = mkN "myrväxt" "myrväxter" ;
  mysticism_nn_1_N = mkN "mysticism" "mysticismer" ;
  myterist_nn_1_N = mkN "myterist" "myterister" ;
  mytoman_nn_1_N = mkN "mytoman" "mytomaner" ;
  maeld_nn_1_1_N = mkN "mäld" "mälder" ;
  maengd_nn_1_1_N = mkN "mängd" "mängder" ;
  maenniskofigur_nn_1_1_N = mkN "människofigur" "människofigurer" ;
  maenniskoras_nn_1_1_N = mkN "människoras" "människoraser" ;
  maenniskoraettsaktivist_nn_1_1_N = mkN "människorättsaktivist" "människorättsaktivister" ;
  maenniskoroest_nn_1_1_N = mkN "människoröst" "människoröster" ;
  maessbok_nn_1_1_N = mkN "mässbok" "mässböcker" ;
  maessingsdetalj_nn_1_1_N = mkN "mässingsdetalj" "mässingsdetaljer" ;
  maestarklass_nn_1_1_N = mkN "mästarklass" "mästarklasser" ;
  maetapparatur_nn_1_1_N = mkN "mätapparatur" "mätapparaturer" ;
  maetress_nn_1_1_N = mkN "mätress" "mätresser" ;
  maalarbok_nn_1_1_N = mkN "målarbok" "målarböcker" ;
  maalbrottsroest_nn_1_1_N = mkN "målbrottsröst" "målbrottsröster" ;
  maalchans_nn_1_1_N = mkN "målchans" "målchanser" ;
  maalfigur_nn_1_1_N = mkN "målfigur" "målfigurer" ;
  maanadskontroll_nn_1_1_N = mkN "månadskontroll" "månadskontroller" ;
  maandistans_nn_1_1_N = mkN "måndistans" "måndistanser" ;
  maanfas_nn_1_1_N = mkN "månfas" "månfaser" ;
  maangmiljonaer_nn_1_1_N = mkN "mångmiljonär" "mångmiljonärer" ;
  maattsats_nn_1_1_N = mkN "måttsats" "måttsatser" ;
  moensterbok_nn_1_1_N = mkN "mönsterbok" "mönsterböcker" ;
  moetesplats_nn_1_1_N = mkN "mötesplats" "mötesplatser" ;
  naivism_nn_1_N = mkN "naivism" "naivismer" ;
  naivist_nn_1_N = mkN "naivist" "naivister" ;
  nakendans_nn_1_N = mkN "nakendans" "nakendanser" ;
  nakendansoes_nn_1_1_N = mkN "nakendansös" "nakendansöser" ;
  nakenkultur_nn_1_N = mkN "nakenkultur" "nakenkulturer" ;
  namnkredit_nn_1_N = mkN "namnkredit" "namnkrediter" ;
  narciss_nn_1_N = mkN "narciss" "narcisser" ;
  narcissism_nn_1_N = mkN "narcissism" "narcissismer" ;
  narkoanalys_nn_1_N = mkN "narkoanalys" "narkoanalyser" ;
  narkoman_nn_1_N = mkN "narkoman" "narkomaner" ;
  narkos_nn_1_N = mkN "narkos" "narkoser" ;
  nasal_nn_1_N = mkN "nasal" "nasaler" ;
  nationalekonom_nn_1_N = mkN "nationalekonom" "nationalekonomer" ;
  nationalinkomst_nn_1_N = mkN "nationalinkomst" "nationalinkomster" ;
  nationalism_nn_1_N = mkN "nationalism" "nationalismer" ;
  nationalist_nn_1_N = mkN "nationalist" "nationalister" ;
  nationalsocialism_nn_1_N = mkN "nationalsocialism" "nationalsocialismer" ;
  nationalsocialist_nn_1_N = mkN "nationalsocialist" "nationalsocialister" ;
  nationalstereotyp_nn_1_N = mkN "nationalstereotyp" "nationalstereotyper" ;
  nationsgraens_nn_1_1_N = mkN "nationsgräns" "nationsgränser" ;
  nationsinspektor_nn_1_N = mkN "nationsinspektor" "nationsinspektorer" ;
  nationskurator_nn_1_N = mkN "nationskurator" "nationskuratorer" ;
  natriumhydroxid_nn_1_N = mkN "natriumhydroxid" "natriumhydroxider" ;
  nattin_e_nn_1_1_N = mkN "nattiné" "nattinéer" ;
  nattmarsch_nn_1_N = mkN "nattmarsch" "nattmarscher" ;
  nattvardsgudstjaenst_nn_1_1_N = mkN "nattvardsgudstjänst" "nattvardsgudstjänster" ;
  natur_nn_2_N = mkN "natur" "naturer" ;
  naturalism_nn_1_N = mkN "naturalism" "naturalismer" ;
  naturalist_nn_1_N = mkN "naturalist" "naturalister" ;
  naturgas_nn_1_N = mkN "naturgas" "naturgaser" ;
  naturism_nn_1_N = mkN "naturism" "naturismer" ;
  naturist_nn_1_N = mkN "naturist" "naturister" ;
  naturkatastrof_nn_1_N = mkN "naturkatastrof" "naturkatastrofer" ;
  naturkonstant_nn_1_N = mkN "naturkonstant" "naturkonstanter" ;
  naturmedicin_nn_1_N = mkN "naturmedicin" "naturmediciner" ;
  naturresurs_nn_1_N = mkN "naturresurs" "naturresurser" ;
  navigationssatellit_nn_1_N = mkN "navigationssatellit" "navigationssatelliter" ;
  naziarkitektur_nn_1_N = mkN "naziarkitektur" "naziarkitekturer" ;
  nazism_nn_1_N = mkN "nazism" "nazismer" ;
  nazist_nn_1_N = mkN "nazist" "nazister" ;
  neapolitan_nn_1_N = mkN "neapolitan" "neapolitaner" ;
  nedslagsplats_nn_1_N = mkN "nedslagsplats" "nedslagsplatser" ;
  nefrit_nn_1_N = mkN "nefrit" "nefriter" ;
  negativism_nn_1_N = mkN "negativism" "negativismer" ;
  neglig_e_nn_1_1_N = mkN "negligé" "negligéer" ;
  negress_nn_1_N = mkN "negress" "negresser" ;
  negroid_nn_1_N = mkN "negroid" "negroider" ;
  nejd_nn_1_N = mkN "nejd" "nejder" ;
  nejlikvaext_nn_1_1_N = mkN "nejlikväxt" "nejlikväxter" ;
  nejroest_nn_1_1_N = mkN "nejröst" "nejröster" ;
  nekrofil_nn_1_N = mkN "nekrofil" "nekrofiler" ;
  nekrolog_nn_1_N = mkN "nekrolog" "nekrologer" ;
  nektarin_nn_1_N = mkN "nektarin" "nektariner" ;
  neodymmagnet_nn_1_N = mkN "neodymmagnet" "neodymmagneter" ;
  neoimpressionism_nn_1_N = mkN "neoimpressionism" "neoimpressionismer" ;
  neoklassicism_nn_1_N = mkN "neoklassicism" "neoklassicismer" ;
  neokolonialism_nn_1_N = mkN "neokolonialism" "neokolonialismer" ;
  neolog_nn_1_N = mkN "neolog" "neologer" ;
  neongas_nn_1_N = mkN "neongas" "neongaser" ;
  nepales_nn_1_N = mkN "nepales" "nepaleser" ;
  nepotism_nn_1_N = mkN "nepotism" "nepotismer" ;
  nereid_nn_1_N = mkN "nereid" "nereider" ;
  nerslagsplats_nn_1_N = mkN "nerslagsplats" "nerslagsplatser" ;
  nervgas_nn_1_N = mkN "nervgas" "nervgaser" ;
  nervimpuls_nn_1_N = mkN "nervimpuls" "nervimpulser" ;
  nervkollaps_nn_1_N = mkN "nervkollaps" "nervkollapser" ;
  nervmedicin_nn_1_N = mkN "nervmedicin" "nervmediciner" ;
  nervsignal_nn_1_N = mkN "nervsignal" "nervsignaler" ;
  nestorian_nn_1_N = mkN "nestorian" "nestorianer" ;
  nestorianism_nn_1_N = mkN "nestorianism" "nestorianismer" ;
  nettoinkomst_nn_1_N = mkN "nettoinkomst" "nettoinkomster" ;
  nettovinst_nn_1_N = mkN "nettovinst" "nettovinster" ;
  neurit_nn_1_N = mkN "neurit" "neuriter" ;
  neurofysiolog_nn_1_N = mkN "neurofysiolog" "neurofysiologer" ;
  neurolog_nn_1_N = mkN "neurolog" "neurologer" ;
  neuros_nn_1_N = mkN "neuros" "neuroser" ;
  neutralism_nn_1_N = mkN "neutralism" "neutralismer" ;
  neutralist_nn_1_N = mkN "neutralist" "neutralister" ;
  neutron_nn_1_N = mkN "neutron" "neutroner" ;
  nicaraguan_nn_1_N = mkN "nicaraguan" "nicaraguaner" ;
  nigerian_nn_1_N = mkN "nigerian" "nigerianer" ;
  nihilism_nn_1_N = mkN "nihilism" "nihilismer" ;
  nihilist_nn_1_N = mkN "nihilist" "nihilister" ;
  nikotinism_nn_1_N = mkN "nikotinism" "nikotinismer" ;
  nikotinist_nn_1_N = mkN "nikotinist" "nikotinister" ;
  niodagarsturn_e_nn_1_1_N = mkN "niodagarsturné" "niodagarsturnéer" ;
  niomannakommitt_e_nn_1_1_N = mkN "niomannakommitté" "niomannakommittéer" ;
  nisch_nn_1_N = mkN "nisch" "nischer" ;
  nittiotalism_nn_1_N = mkN "nittiotalism" "nittiotalismer" ;
  nittiotalist_nn_1_N = mkN "nittiotalist" "nittiotalister" ;
  nittitalism_nn_1_N = mkN "nittitalism" "nittitalismer" ;
  nittitalist_nn_1_N = mkN "nittitalist" "nittitalister" ;
  nivaa_nn_1_1_N = mkN "nivå" "nivåer" ;
  nockout_nn_1_N = mkN "nockout" "nockouter" ;
  nomad_nn_1_N = mkN "nomad" "nomader" ;
  nomenklatur_nn_1_N = mkN "nomenklatur" "nomenklaturer" ;
  nominalism_nn_1_N = mkN "nominalism" "nominalismer" ;
  nominalist_nn_1_N = mkN "nominalist" "nominalister" ;
  nominativ_nn_1_N = mkN "nominativ" "nominativer" ;
  nonkombattant_nn_1_N = mkN "nonkombattant" "nonkombattanter" ;
  nonkonformism_nn_1_N = mkN "nonkonformism" "nonkonformismer" ;
  nonkonformist_nn_1_N = mkN "nonkonformist" "nonkonformister" ;
  nonsensvers_nn_1_N = mkN "nonsensvers" "nonsensverser" ;
  nordamerikan_nn_1_N = mkN "nordamerikan" "nordamerikaner" ;
  nordgraens_nn_1_1_N = mkN "nordgräns" "nordgränser" ;
  nordism_nn_1_N = mkN "nordism" "nordismer" ;
  nordist_nn_1_N = mkN "nordist" "nordister" ;
  nordjemenit_nn_1_N = mkN "nordjemenit" "nordjemeniter" ;
  nordkorean_nn_1_N = mkN "nordkorean" "nordkoreaner" ;
  nordkust_nn_1_N = mkN "nordkust" "nordkuster" ;
  nordyemenit_nn_1_N = mkN "nordyemenit" "nordyemeniter" ;
  normaliseringsprocess_nn_1_N = mkN "normaliseringsprocess" "normaliseringsprocesser" ;
  norvagism_nn_1_N = mkN "norvagism" "norvagismer" ;
  nostalgipjaes_nn_1_1_N = mkN "nostalgipjäs" "nostalgipjäser" ;
  not_nn_1_N = mkN "not" "noter" ;
  notis_nn_1_N = mkN "notis" "notiser" ;
  nototenioid_nn_1_N = mkN "nototenioid" "nototenioider" ;
  nougat_nn_1_N = mkN "nougat" "nougater" ;
  novellist_nn_1_N = mkN "novellist" "novellister" ;
  novis_nn_1_N = mkN "novis" "noviser" ;
  nudism_nn_1_N = mkN "nudism" "nudismer" ;
  nudist_nn_1_N = mkN "nudist" "nudister" ;
  nugat_nn_1_N = mkN "nugat" "nugater" ;
  nukleid_nn_1_N = mkN "nukleid" "nukleider" ;
  nukleon_nn_1_N = mkN "nukleon" "nukleoner" ;
  nukleotid_nn_1_N = mkN "nukleotid" "nukleotider" ;
  nuklid_nn_1_N = mkN "nuklid" "nuklider" ;
  nummerbyraa_nn_1_1_N = mkN "nummerbyrå" "nummerbyråer" ;
  nummerrevy_nn_1_N = mkN "nummerrevy" "nummerrevyer" ;
  nunatack_nn_1_N = mkN "nunatack" "nunatacker" ;
  nunatak_nn_1_N = mkN "nunatak" "nunataker" ;
  nuntiatur_nn_1_N = mkN "nuntiatur" "nuntiaturer" ;
  nutritionist_nn_1_N = mkN "nutritionist" "nutritionister" ;
  nyans_nn_1_N = mkN "nyans" "nyanser" ;
  nyboerjarbok_nn_1_1_N = mkN "nybörjarbok" "nybörjarböcker" ;
  nyckelperson_nn_1_N = mkN "nyckelperson" "nyckelpersoner" ;
  nyckelroman_nn_1_N = mkN "nyckelroman" "nyckelromaner" ;
  nyfascism_nn_1_N = mkN "nyfascism" "nyfascismer" ;
  nyhetsbyraa_nn_1_1_N = mkN "nyhetsbyrå" "nyhetsbyråer" ;
  nyhumanism_nn_1_N = mkN "nyhumanism" "nyhumanismer" ;
  nyklassicism_nn_1_N = mkN "nyklassicism" "nyklassicismer" ;
  nykolonialism_nn_1_N = mkN "nykolonialism" "nykolonialismer" ;
  nykterism_nn_1_N = mkN "nykterism" "nykterismer" ;
  nykterist_nn_1_N = mkN "nykterist" "nykterister" ;
  nymfoman_nn_1_N = mkN "nymfoman" "nymfomaner" ;
  nynazism_nn_1_N = mkN "nynazism" "nynazismer" ;
  nynazist_nn_1_N = mkN "nynazist" "nynazister" ;
  nyplatonism_nn_1_N = mkN "nyplatonism" "nyplatonismer" ;
  nypremiaer_nn_1_1_N = mkN "nypremiär" "nypremiärer" ;
  nyrealism_nn_1_N = mkN "nyrealism" "nyrealismer" ;
  nyttjandefrekvens_nn_1_N = mkN "nyttjandefrekvens" "nyttjandefrekvenser" ;
  nyttovaext_nn_1_1_N = mkN "nyttoväxt" "nyttoväxter" ;
  nyaarsfest_nn_1_1_N = mkN "nyårsfest" "nyårsfester" ;
  naemnd_nn_1_1_N = mkN "nämnd" "nämnder" ;
  naeringsbrist_nn_1_1_N = mkN "näringsbrist" "näringsbrister" ;
  naeringslivskonsult_nn_1_1_N = mkN "näringslivskonsult" "näringslivskonsulter" ;
  naeringsprocess_nn_1_1_N = mkN "näringsprocess" "näringsprocesser" ;
  naeskatarr_nn_1_1_N = mkN "näskatarr" "näskatarrer" ;
  naestkusin_nn_1_1_N = mkN "nästkusin" "nästkusiner" ;
  naetkampanj_nn_1_1_N = mkN "nätkampanj" "nätkampanjer" ;
  naetkultur_nn_1_1_N = mkN "nätkultur" "nätkulturer" ;
  naetmelon_nn_1_1_N = mkN "nätmelon" "nätmeloner" ;
  naalmikrofon_nn_1_1_N = mkN "nålmikrofon" "nålmikrofoner" ;
  noedsignal_nn_1_1_N = mkN "nödsignal" "nödsignaler" ;
  noet_nn_1_1_N = mkN "nöt" "nötter" ;
  oas_nn_1_N = mkN "oas" "oaser" ;
  obduktionsrapport_nn_1_N = mkN "obduktionsrapport" "obduktionsrapporter" ;
  obelisk_nn_1_N = mkN "obelisk" "obelisker" ;
  obestaemdhetsprincip_nn_1_1_N = mkN "obestämdhetsprincip" "obestämdhetsprinciper" ;
  objektivism_nn_1_N = mkN "objektivism" "objektivismer" ;
  objektskatt_nn_1_N = mkN "objektskatt" "objektskatter" ;
  oblast_nn_1_N = mkN "oblast" "oblaster" ;
  obligat_nn_1_N = mkN "obligat" "obligater" ;
  oblik_nn_1_N = mkN "oblik" "obliker" ;
  obol_nn_1_N = mkN "obol" "oboler" ;
  observationsklass_nn_1_N = mkN "observationsklass" "observationsklasser" ;
  obsidian_nn_1_N = mkN "obsidian" "obsidianer" ;
  obsklass_nn_1_N = mkN "obsklass" "obsklasser" ;
  obskurant_nn_1_N = mkN "obskurant" "obskuranter" ;
  obskurantism_nn_1_N = mkN "obskurantism" "obskurantismer" ;
  obskurantist_nn_1_N = mkN "obskurantist" "obskurantister" ;
  ocean_nn_1_N = mkN "ocean" "oceaner" ;
  ockultism_nn_1_N = mkN "ockultism" "ockultismer" ;
  ockupant_nn_1_N = mkN "ockupant" "ockupanter" ;
  odalisk_nn_1_N = mkN "odalisk" "odalisker" ;
  odlingsgraens_nn_1_1_N = mkN "odlingsgräns" "odlingsgränser" ;
  odlingssaesong_nn_1_1_N = mkN "odlingssäsong" "odlingssäsonger" ;
  odontolog_nn_1_N = mkN "odontolog" "odontologer" ;
  offeranod_nn_1_N = mkN "offeranod" "offeranoder" ;
  offerfest_nn_1_N = mkN "offerfest" "offerfester" ;
  offerrit_nn_1_N = mkN "offerrit" "offerriter" ;
  officersaspirant_nn_1_N = mkN "officersaspirant" "officersaspiranter" ;
  officiant_nn_1_N = mkN "officiant" "officianter" ;
  officin_nn_1_N = mkN "officin" "officiner" ;
  oktanol_nn_1_N = mkN "oktanol" "oktanoler" ;
  oktant_nn_1_N = mkN "oktant" "oktanter" ;
  oktav_nn_1_N = mkN "oktav" "oktaver" ;
  oktod_nn_1_N = mkN "oktod" "oktoder" ;
  oktogon_nn_1_N = mkN "oktogon" "oktogoner" ;
  oktroj_nn_1_N = mkN "oktroj" "oktrojer" ;
  okynnesstrejk_nn_1_N = mkN "okynnesstrejk" "okynnesstrejker" ;
  oligark_nn_1_N = mkN "oligark" "oligarker" ;
  oljenivaa_nn_1_1_N = mkN "oljenivå" "oljenivåer" ;
  oljevaext_nn_1_1_N = mkN "oljeväxt" "oljeväxter" ;
  ollonpistol_nn_1_N = mkN "ollonpistol" "ollonpistoler" ;
  olvonvaext_nn_1_1_N = mkN "olvonväxt" "olvonväxter" ;
  olycksfallsfrekvens_nn_1_N = mkN "olycksfallsfrekvens" "olycksfallsfrekvenser" ;
  olyckskatastrof_nn_1_N = mkN "olyckskatastrof" "olyckskatastrofer" ;
  olycksplats_nn_1_N = mkN "olycksplats" "olycksplatser" ;
  olycksprofet_nn_1_N = mkN "olycksprofet" "olycksprofeter" ;
  omblandningsprocess_nn_1_N = mkN "omblandningsprocess" "omblandningsprocesser" ;
  omdoemesbrist_nn_1_1_N = mkN "omdömesbrist" "omdömesbrister" ;
  omslagsrevers_nn_1_N = mkN "omslagsrevers" "omslagsreverser" ;
  omsaettningsskatt_nn_1_1_N = mkN "omsättningsskatt" "omsättningsskatter" ;
  omvandlingsprocess_nn_1_N = mkN "omvandlingsprocess" "omvandlingsprocesser" ;
  onkolog_nn_1_N = mkN "onkolog" "onkologer" ;
  operationalism_nn_1_N = mkN "operationalism" "operationalismer" ;
  operationsbas_nn_1_N = mkN "operationsbas" "operationsbaser" ;
  operator_nn_1_N = mkN "operator" "operatorer" ;
  operatris_nn_1_N = mkN "operatris" "operatriser" ;
  operett_nn_1_N = mkN "operett" "operetter" ;
  opinionsanalys_nn_1_N = mkN "opinionsanalys" "opinionsanalyser" ;
  oppblaasningsfas_nn_1_1_N = mkN "oppblåsningsfas" "oppblåsningsfaser" ;
  opportunism_nn_1_N = mkN "opportunism" "opportunismer" ;
  opportunist_nn_1_N = mkN "opportunist" "opportunister" ;
  oppositionsaktivist_nn_1_N = mkN "oppositionsaktivist" "oppositionsaktivister" ;
  oppstaellningsplats_nn_1_1_N = mkN "oppställningsplats" "oppställningsplatser" ;
  oppstaellningssignal_nn_1_1_N = mkN "oppställningssignal" "oppställningssignaler" ;
  optant_nn_1_N = mkN "optant" "optanter" ;
  optativ_nn_1_N = mkN "optativ" "optativer" ;
  optimism_nn_1_N = mkN "optimism" "optimismer" ;
  optimist_nn_1_N = mkN "optimist" "optimister" ;
  optionsskandal_nn_1_N = mkN "optionsskandal" "optionsskandaler" ;
  orant_nn_1_N = mkN "orant" "oranter" ;
  orator_nn_1_N = mkN "orator" "oratorer" ;
  ordbok_nn_1_N = mkN "ordbok" "ordböcker" ;
  ordfoerekomst_nn_1_1_N = mkN "ordförekomst" "ordförekomster" ;
  ordklass_nn_1_N = mkN "ordklass" "ordklasser" ;
  ordningspolis_nn_2_N = mkN "ordningspolis" "ordningspoliser" ;
  ordningsprincip_nn_1_N = mkN "ordningsprincip" "ordningsprinciper" ;
  ordonnans_nn_1_N = mkN "ordonnans" "ordonnanser" ;
  orficism_nn_1_N = mkN "orficism" "orficismer" ;
  orfism_nn_1_N = mkN "orfism" "orfismer" ;
  organisationskommitt_e_nn_1_1_N = mkN "organisationskommitté" "organisationskommittéer" ;
  organisationsstruktur_nn_1_N = mkN "organisationsstruktur" "organisationsstrukturer" ;
  organism_nn_1_N = mkN "organism" "organismer" ;
  organist_nn_1_N = mkN "organist" "organister" ;
  orientalism_nn_1_N = mkN "orientalism" "orientalismer" ;
  orientalist_nn_1_N = mkN "orientalist" "orientalister" ;
  originaltext_nn_1_N = mkN "originaltext" "originaltexter" ;
  orkan_nn_1_N = mkN "orkan" "orkaner" ;
  orkesterplats_nn_1_N = mkN "orkesterplats" "orkesterplatser" ;
  orkid_e_nn_1_1_N = mkN "orkidé" "orkidéer" ;
  orkid_evaext_nn_1_1_N = mkN "orkidéväxt" "orkidéväxter" ;
  ormbunksvaext_nn_1_1_N = mkN "ormbunksväxt" "ormbunksväxter" ;
  ornamentist_nn_1_N = mkN "ornamentist" "ornamentister" ;
  ornitolog_nn_1_N = mkN "ornitolog" "ornitologer" ;
  ortikon_nn_1_N = mkN "ortikon" "ortikoner" ;
  ortoceratit_nn_1_N = mkN "ortoceratit" "ortoceratiter" ;
  ortodoxism_nn_1_N = mkN "ortodoxism" "ortodoxismer" ;
  ortolan_nn_1_N = mkN "ortolan" "ortolaner" ;
  ortoptist_nn_1_N = mkN "ortoptist" "ortoptister" ;
  ortoptris_nn_1_N = mkN "ortoptris" "ortoptriser" ;
  oryx_nn_1_N = mkN "oryx" "oryxer" ;
  oscillator_nn_1_N = mkN "oscillator" "oscillatorer" ;
  oskarian_nn_1_N = mkN "oskarian" "oskarianer" ;
  osman_nn_1_N = mkN "osman" "osmaner" ;
  osteolog_nn_1_N = mkN "osteolog" "osteologer" ;
  osteoporos_nn_1_N = mkN "osteoporos" "osteoporoser" ;
  ostjak_nn_1_N = mkN "ostjak" "ostjaker" ;
  ostkust_nn_1_N = mkN "ostkust" "ostkuster" ;
  ostracism_nn_1_N = mkN "ostracism" "ostracismer" ;
  ostrest_nn_1_N = mkN "ostrest" "ostrester" ;
  ostsaas_nn_1_1_N = mkN "ostsås" "ostsåser" ;
  otit_nn_1_N = mkN "otit" "otiter" ;
  otjaenst_nn_1_1_N = mkN "otjänst" "otjänster" ;
  otolog_nn_1_N = mkN "otolog" "otologer" ;
  otrohetsskandal_nn_1_N = mkN "otrohetsskandal" "otrohetsskandaler" ;
  ottoman_nn_1_N = mkN "ottoman" "ottomaner" ;
  ottomotor_nn_1_N = mkN "ottomotor" "ottomotorer" ;
  overhead_projektor_nn_1_N = mkN "overhead-projektor" "overhead-projektorer" ;
  overheadprojektor_nn_1_N = mkN "overheadprojektor" "overheadprojektorer" ;
  oxfil_e_nn_1_1_N = mkN "oxfilé" "oxfiléer" ;
  oxid_nn_1_N = mkN "oxid" "oxider" ;
  oxroulad_nn_1_N = mkN "oxroulad" "oxroulader" ;
  oxrullad_nn_1_N = mkN "oxrullad" "oxrullader" ;
  ozonmolekyl_nn_1_N = mkN "ozonmolekyl" "ozonmolekyler" ;
  p_plats_nn_1_N = mkN "p-plats" "p-platser" ;
  pacifism_nn_1_N = mkN "pacifism" "pacifismer" ;
  pacifist_nn_1_N = mkN "pacifist" "pacifister" ;
  pakistan_nn_1_N = mkN "pakistan" "pakistaner" ;
  paladin_nn_1_N = mkN "paladin" "paladiner" ;
  paleontolog_nn_1_N = mkN "paleontolog" "paleontologer" ;
  paletaa_nn_1_1_N = mkN "paletå" "paletåer" ;
  palimpsest_nn_1_N = mkN "palimpsest" "palimpsester" ;
  pallasch_nn_1_N = mkN "pallasch" "pallascher" ;
  pallplats_nn_1_N = mkN "pallplats" "pallplatser" ;
  pamflettist_nn_1_N = mkN "pamflettist" "pamflettister" ;
  pampusch_nn_1_N = mkN "pampusch" "pampuscher" ;
  panaman_nn_1_N = mkN "panaman" "panamaner" ;
  panasch_nn_1_N = mkN "panasch" "panascher" ;
  panel_nn_1_N = mkN "panel" "paneler" ;
  pangpjaes_nn_1_1_N = mkN "pangpjäs" "pangpjäser" ;
  panhellenism_nn_1_N = mkN "panhellenism" "panhellenismer" ;
  pankreatit_nn_1_N = mkN "pankreatit" "pankreatiter" ;
  pannaa_nn_1_1_N = mkN "pannå" "pannåer" ;
  panteism_nn_1_N = mkN "panteism" "panteismer" ;
  panteist_nn_1_N = mkN "panteist" "panteister" ;
  papegojtulpan_nn_1_N = mkN "papegojtulpan" "papegojtulpaner" ;
  papillon_nn_1_N = mkN "papillon" "papilloner" ;
  papism_nn_1_N = mkN "papism" "papismer" ;
  papuan_nn_1_N = mkN "papuan" "papuaner" ;
  papyross_nn_1_N = mkN "papyross" "papyrosser" ;
  papyrus_nn_1_N = mkN "papyrus" "papyrer" ;
  paracervikalblockad_nn_1_N = mkN "paracervikalblockad" "paracervikalblockader" ;
  parad_nn_1_N = mkN "parad" "parader" ;
  paradentit_nn_1_N = mkN "paradentit" "paradentiter" ;
  paradmarsch_nn_1_N = mkN "paradmarsch" "paradmarscher" ;
  paradox_nn_1_N = mkN "paradox" "paradoxer" ;
  parafras_nn_1_N = mkN "parafras" "parafraser" ;
  paragon_nn_1_N = mkN "paragon" "paragoner" ;
  paraguayan_nn_1_N = mkN "paraguayan" "paraguayaner" ;
  parallell_nn_1_N = mkN "parallell" "paralleller" ;
  parallellism_nn_1_N = mkN "parallellism" "parallellismer" ;
  parallellklass_nn_1_N = mkN "parallellklass" "parallellklasser" ;
  paralys_nn_1_N = mkN "paralys" "paralyser" ;
  parasit_nn_1_N = mkN "parasit" "parasiter" ;
  parasitism_nn_1_N = mkN "parasitism" "parasitismer" ;
  paravan_nn_1_N = mkN "paravan" "paravaner" ;
  pardans_nn_1_N = mkN "pardans" "pardanser" ;
  parentator_nn_1_N = mkN "parentator" "parentatorer" ;
  parentes_nn_1_N = mkN "parentes" "parenteser" ;
  pares_nn_1_N = mkN "pares" "pareser" ;
  parfait_nn_1_N = mkN "parfait" "parfaiter" ;
  parikurs_nn_1_N = mkN "parikurs" "parikurser" ;
  parkeringsplats_nn_1_N = mkN "parkeringsplats" "parkeringsplatser" ;
  parlamentarism_nn_1_N = mkN "parlamentarism" "parlamentarismer" ;
  parnass_nn_1_N = mkN "parnass" "parnasser" ;
  parodontit_nn_1_N = mkN "parodontit" "parodontiter" ;
  paronym_nn_1_N = mkN "paronym" "paronymer" ;
  partidisciplin_nn_1_N = mkN "partidisciplin" "partidiscipliner" ;
  partikelaccelerator_nn_1_N = mkN "partikelaccelerator" "partikelacceleratorer" ;
  partikongress_nn_1_N = mkN "partikongress" "partikongresser" ;
  partikularism_nn_1_N = mkN "partikularism" "partikularismer" ;
  partiledarpost_nn_1_N = mkN "partiledarpost" "partiledarposter" ;
  partisan_nn_1_N = mkN "partisan" "partisaner" ;
  partistrateg_nn_1_N = mkN "partistrateg" "partistrateger" ;
  partitiv_nn_1_N = mkN "partitiv" "partitiver" ;
  partonym_nn_1_N = mkN "partonym" "partonymer" ;
  parveny_nn_1_N = mkN "parveny" "parvenyer" ;
  passagerarplats_nn_1_N = mkN "passagerarplats" "passagerarplatser" ;
  passkontroll_nn_1_N = mkN "passkontroll" "passkontroller" ;
  pastagrataeng_nn_1_1_N = mkN "pastagratäng" "pastagratänger" ;
  pastisch_nn_1_N = mkN "pastisch" "pastischer" ;
  pastor_nn_1_N = mkN "pastor" "pastorer" ;
  patentmedicin_nn_1_N = mkN "patentmedicin" "patentmediciner" ;
  patiens_nn_1_N = mkN "patiens" "patienser" ;
  patientplats_nn_1_N = mkN "patientplats" "patientplatser" ;
  patogen_nn_1_N = mkN "patogen" "patogener" ;
  patolog_nn_1_N = mkN "patolog" "patologer" ;
  patriot_nn_1_N = mkN "patriot" "patrioter" ;
  patriotism_nn_1_N = mkN "patriotism" "patriotismer" ;
  patris_nn_1_N = mkN "patris" "patriser" ;
  patron_nn_2_N = mkN "patron" "patroner" ;
  patt_nn_1_N = mkN "patt" "patter" ;
  pat_e_nn_1_1_N = mkN "paté" "patéer" ;
  pauperism_nn_1_N = mkN "pauperism" "pauperismer" ;
  paus_nn_1_N = mkN "paus" "pauser" ;
  paussignal_nn_1_N = mkN "paussignal" "paussignaler" ;
  pedant_nn_1_N = mkN "pedant" "pedanter" ;
  pederast_nn_1_N = mkN "pederast" "pederaster" ;
  pedikurist_nn_1_N = mkN "pedikurist" "pedikurister" ;
  pedikyrist_nn_1_N = mkN "pedikyrist" "pedikyrister" ;
  pedofil_nn_1_N = mkN "pedofil" "pedofiler" ;
  pegas_nn_1_N = mkN "pegas" "pegaser" ;
  pegmatit_nn_1_N = mkN "pegmatit" "pegmatiter" ;
  pekbok_nn_1_N = mkN "pekbok" "pekböcker" ;
  pekines_nn_1_N = mkN "pekines" "pekineser" ;
  pekinges_nn_1_N = mkN "pekinges" "pekingeser" ;
  pekoralist_nn_1_N = mkN "pekoralist" "pekoralister" ;
  pelargon_nn_1_N = mkN "pelargon" "pelargoner" ;
  pelerin_nn_1_N = mkN "pelerin" "peleriner" ;
  pelikan_nn_1_N = mkN "pelikan" "pelikaner" ;
  peltonturbin_nn_1_N = mkN "peltonturbin" "peltonturbiner" ;
  pendeltaagsankomst_nn_1_1_N = mkN "pendeltågsankomst" "pendeltågsankomster" ;
  pendyl_nn_1_N = mkN "pendyl" "pendyler" ;
  pennalism_nn_1_N = mkN "pennalism" "pennalismer" ;
  pennalist_nn_1_N = mkN "pennalist" "pennalister" ;
  pens_e_nn_1_1_N = mkN "pensé" "penséer" ;
  peon_nn_1_N = mkN "peon" "peoner" ;
  perenn_nn_1_N = mkN "perenn" "perenner" ;
  perfektionism_nn_1_N = mkN "perfektionism" "perfektionismer" ;
  perfektionist_nn_1_N = mkN "perfektionist" "perfektionister" ;
  perforator_nn_1_N = mkN "perforator" "perforatorer" ;
  perifon_nn_1_N = mkN "perifon" "perifoner" ;
  perifras_nn_1_N = mkN "perifras" "perifraser" ;
  peristyl_nn_1_N = mkN "peristyl" "peristyler" ;
  peritonit_nn_1_N = mkN "peritonit" "peritoniter" ;
  perkolator_nn_1_N = mkN "perkolator" "perkolatorer" ;
  peroxid_nn_1_N = mkN "peroxid" "peroxider" ;
  persimon_nn_1_N = mkN "persimon" "persimoner" ;
  person_nn_1_N = mkN "person" "personer" ;
  personal_nn_1_N = mkN "personal" "personaler" ;
  personalism_nn_1_N = mkN "personalism" "personalismer" ;
  persondator_nn_1_N = mkN "persondator" "persondatorer" ;
  personvalskampanj_nn_1_N = mkN "personvalskampanj" "personvalskampanjer" ;
  peruan_nn_1_N = mkN "peruan" "peruaner" ;
  peruk_nn_1_N = mkN "peruk" "peruker" ;
  pessimism_nn_1_N = mkN "pessimism" "pessimismer" ;
  pessimist_nn_1_N = mkN "pessimist" "pessimister" ;
  pest_nn_1_N = mkN "pest" "pester" ;
  pesticid_nn_1_N = mkN "pesticid" "pesticider" ;
  pestilens_nn_1_N = mkN "pestilens" "pestilenser" ;
  petitess_nn_1_N = mkN "petitess" "petitesser" ;
  pianist_nn_1_N = mkN "pianist" "pianister" ;
  pianopedal_nn_1_N = mkN "pianopedal" "pianopedaler" ;
  pickadoll_nn_1_N = mkN "pickadoll" "pickadoller" ;
  pietism_nn_1_N = mkN "pietism" "pietismer" ;
  pietist_nn_1_N = mkN "pietist" "pietister" ;
  pigroman_nn_1_N = mkN "pigroman" "pigromaner" ;
  pikaresk_nn_1_N = mkN "pikaresk" "pikaresker" ;
  pikareskroman_nn_1_N = mkN "pikareskroman" "pikareskromaner" ;
  pikkadoll_nn_1_N = mkN "pikkadoll" "pikkadoller" ;
  piktur_nn_1_N = mkN "piktur" "pikturer" ;
  pik_e_nn_1_1_N = mkN "piké" "pikéer" ;
  pilall_e_nn_1_1_N = mkN "pilallé" "pilalléer" ;
  pilotstrejk_nn_1_N = mkN "pilotstrejk" "pilotstrejker" ;
  pincen_e_nn_1_1_N = mkN "pincené" "pincenéer" ;
  pingstpastor_nn_1_N = mkN "pingstpastor" "pingstpastorer" ;
  pingvin_nn_1_N = mkN "pingvin" "pingviner" ;
  pingvinturist_nn_1_N = mkN "pingvinturist" "pingvinturister" ;
  pinjong_nn_1_N = mkN "pinjong" "pinjonger" ;
  pion_nn_1_N = mkN "pion" "pioner" ;
  pirog_nn_1_N = mkN "pirog" "piroger" ;
  pist_nn_1_N = mkN "pist" "pister" ;
  pistasch_nn_1_N = mkN "pistasch" "pistascher" ;
  pistill_nn_1_N = mkN "pistill" "pistiller" ;
  pistol_nn_1_N = mkN "pistol" "pistoler" ;
  pivot_nn_1_N = mkN "pivot" "pivoter" ;
  pivaa_nn_1_1_N = mkN "pivå" "pivåer" ;
  pjaes_nn_1_1_N = mkN "pjäs" "pjäser" ;
  pladderkultur_nn_1_N = mkN "pladderkultur" "pladderkulturer" ;
  plafond_nn_1_N = mkN "plafond" "plafonder" ;
  plagiator_nn_1_N = mkN "plagiator" "plagiatorer" ;
  plaidoyer_nn_1_N = mkN "plaidoyer" "plaidoyerer" ;
  plakett_nn_1_N = mkN "plakett" "plaketter" ;
  plan_nn_1_N = mkN "plan" "planer" ;
  plan_nn_3_N = mkN "plan" "planer" ;
  planktonvaext_nn_1_1_N = mkN "planktonväxt" "planktonväxter" ;
  plansch_nn_1_N = mkN "plansch" "planscher" ;
  plast_nn_1_N = mkN "plast" "plaster" ;
  platan_nn_1_N = mkN "platan" "plataner" ;
  platonism_nn_1_N = mkN "platonism" "platonismer" ;
  plats_nn_1_N = mkN "plats" "platser" ;
  plattityd_nn_1_N = mkN "plattityd" "plattityder" ;
  plataa_nn_1_1_N = mkN "platå" "platåer" ;
  pleurit_nn_1_N = mkN "pleurit" "pleuriter" ;
  plikt_nn_1_N = mkN "plikt" "plikter" ;
  pliss_e_nn_1_1_N = mkN "plissé" "plisséer" ;
  plural_nn_1_N = mkN "plural" "pluraler" ;
  pluralism_nn_1_N = mkN "pluralism" "pluralismer" ;
  pluton_nn_1_N = mkN "pluton" "plutoner" ;
  plymasch_nn_1_N = mkN "plymasch" "plymascher" ;
  plymaa_nn_1_1_N = mkN "plymå" "plymåer" ;
  plysch_nn_1_N = mkN "plysch" "plyscher" ;
  plaedoaj_e_nn_1_1_N = mkN "plädoajé" "plädoajéer" ;
  plaanbok_nn_1_1_N = mkN "plånbok" "plånböcker" ;
  plaatlist_nn_1_1_N = mkN "plåtlist" "plåtlister" ;
  plaatpolis_nn_1_1_N = mkN "plåtpolis" "plåtpoliser" ;
  pocketbok_nn_1_N = mkN "pocketbok" "pocketböcker" ;
  podest_nn_1_N = mkN "podest" "podester" ;
  pointillism_nn_1_N = mkN "pointillism" "pointillismer" ;
  pojkbok_nn_1_N = mkN "pojkbok" "pojkböcker" ;
  pol_nn_1_N = mkN "pol" "poler" ;
  polarisator_nn_1_N = mkN "polarisator" "polarisatorer" ;
  polis_nn_2_N = mkN "polis" "poliser" ;
  polisarrest_nn_1_N = mkN "polisarrest" "polisarrester" ;
  polisaspirant_nn_1_N = mkN "polisaspirant" "polisaspiranter" ;
  polisnatur_nn_1_N = mkN "polisnatur" "polisnaturer" ;
  polistjaenst_nn_1_1_N = mkN "polistjänst" "polistjänster" ;
  politbyraa_nn_1_1_N = mkN "politbyrå" "politbyråer" ;
  pollenfoerekomst_nn_1_1_N = mkN "pollenförekomst" "pollenförekomster" ;
  polonaes_nn_1_1_N = mkN "polonäs" "polonäser" ;
  polyamid_nn_1_N = mkN "polyamid" "polyamider" ;
  polycentrism_nn_1_N = mkN "polycentrism" "polycentrismer" ;
  polyfosfat_nn_1_N = mkN "polyfosfat" "polyfosfater" ;
  polyglott_nn_1_N = mkN "polyglott" "polyglotter" ;
  polygon_nn_1_N = mkN "polygon" "polygoner" ;
  polyhistor_nn_1_N = mkN "polyhistor" "polyhistorer" ;
  polysyndes_nn_1_N = mkN "polysyndes" "polysyndeser" ;
  polyteism_nn_1_N = mkN "polyteism" "polyteismer" ;
  pomerans_nn_1_N = mkN "pomerans" "pomeranser" ;
  pomolog_nn_1_N = mkN "pomolog" "pomologer" ;
  ponton_nn_1_N = mkN "ponton" "pontoner" ;
  pool_nn_1_N = mkN "pool" "pooler" ;
  pop_nn_2_N = mkN "pop" "poper" ;
  popularisator_nn_1_N = mkN "popularisator" "popularisatorer" ;
  populism_nn_1_N = mkN "populism" "populismer" ;
  populist_nn_1_N = mkN "populist" "populister" ;
  populaerkultur_nn_1_1_N = mkN "populärkultur" "populärkulturer" ;
  porslinsfigur_nn_1_N = mkN "porslinsfigur" "porslinsfigurer" ;
  portal_nn_1_N = mkN "portal" "portaler" ;
  portalfigur_nn_1_N = mkN "portalfigur" "portalfigurer" ;
  portep_e_nn_1_1_N = mkN "portepé" "portepéer" ;
  portraettbyst_nn_1_1_N = mkN "porträttbyst" "porträttbyster" ;
  porttelefon_nn_1_N = mkN "porttelefon" "porttelefoner" ;
  portugis_nn_1_N = mkN "portugis" "portugiser" ;
  positiv_nn_2_N = mkN "positiv" "positiver" ;
  positivism_nn_1_N = mkN "positivism" "positivismer" ;
  positivist_nn_1_N = mkN "positivist" "positivister" ;
  positron_nn_1_N = mkN "positron" "positroner" ;
  post_nn_2_N = mkN "post" "poster" ;
  postadress_nn_1_N = mkN "postadress" "postadresser" ;
  postiljon_nn_1_N = mkN "postiljon" "postiljoner" ;
  postisch_nn_1_N = mkN "postisch" "postischer" ;
  postkup_e_nn_1_1_N = mkN "postkupé" "postkupéer" ;
  postmodernism_nn_1_N = mkN "postmodernism" "postmodernismer" ;
  postmodernist_nn_1_N = mkN "postmodernist" "postmodernister" ;
  postroest_nn_1_1_N = mkN "poströst" "poströster" ;
  potatispur_e_nn_1_1_N = mkN "potatispuré" "potatispuréer" ;
  potatisvaext_nn_1_1_N = mkN "potatisväxt" "potatisväxter" ;
  potemkinkuliss_nn_1_N = mkN "potemkinkuliss" "potemkinkulisser" ;
  potens_nn_1_N = mkN "potens" "potenser" ;
  pragmatism_nn_1_N = mkN "pragmatism" "pragmatismer" ;
  praktik_nn_1_N = mkN "praktik" "praktiker" ;
  praktikant_nn_1_N = mkN "praktikant" "praktikanter" ;
  praktikplats_nn_1_N = mkN "praktikplats" "praktikplatser" ;
  praktpjaes_nn_1_1_N = mkN "praktpjäs" "praktpjäser" ;
  pralin_nn_1_N = mkN "pralin" "praliner" ;
  preceptor_nn_1_N = mkN "preceptor" "preceptorer" ;
  preceptur_nn_1_N = mkN "preceptur" "precepturer" ;
  predator_nn_1_N = mkN "predator" "predatorer" ;
  predikant_nn_1_N = mkN "predikant" "predikanter" ;
  predikokonst_nn_1_N = mkN "predikokonst" "predikokonster" ;
  predikotext_nn_1_N = mkN "predikotext" "predikotexter" ;
  prefektur_nn_1_N = mkN "prefektur" "prefekturer" ;
  preferens_nn_1_N = mkN "preferens" "preferenser" ;
  preliminaerskatt_nn_1_1_N = mkN "preliminärskatt" "preliminärskatter" ;
  premiss_nn_1_N = mkN "premiss" "premisser" ;
  premiaerfaangst_nn_1_1_N = mkN "premiärfångst" "premiärfångster" ;
  premiaerministerpost_nn_1_1_N = mkN "premiärministerpost" "premiärministerposter" ;
  prenumerant_nn_1_N = mkN "prenumerant" "prenumeranter" ;
  preparator_nn_1_N = mkN "preparator" "preparatorer" ;
  preparatris_nn_1_N = mkN "preparatris" "preparatriser" ;
  presbyterian_nn_1_N = mkN "presbyterian" "presbyterianer" ;
  president_nn_1_N = mkN "president" "presidenter" ;
  presidentur_nn_1_N = mkN "presidentur" "presidenturer" ;
  presidentvalskampanj_nn_1_N = mkN "presidentvalskampanj" "presidentvalskampanjer" ;
  pressbyraa_nn_1_1_N = mkN "pressbyrå" "pressbyråer" ;
  presskonferens_nn_1_N = mkN "presskonferens" "presskonferenser" ;
  prestationsloen_nn_1_1_N = mkN "prestationslön" "prestationslöner" ;
  pretor_nn_1_N = mkN "pretor" "pretorer" ;
  pretorian_nn_1_N = mkN "pretorian" "pretorianer" ;
  primat_nn_2_N = mkN "primat" "primater" ;
  primatolog_nn_1_N = mkN "primatolog" "primatologer" ;
  primfaktor_nn_1_N = mkN "primfaktor" "primfaktorer" ;
  primitivism_nn_1_N = mkN "primitivism" "primitivismer" ;
  primogenitur_nn_1_N = mkN "primogenitur" "primogeniturer" ;
  primtalsfaktor_nn_1_N = mkN "primtalsfaktor" "primtalsfaktorer" ;
  primaerkredit_nn_1_1_N = mkN "primärkredit" "primärkrediter" ;
  princip_nn_1_N = mkN "princip" "principer" ;
  prior_nn_1_N = mkN "prior" "priorer" ;
  pris_nn_3_N = mkN "pris" "priser" ;
  prisfest_nn_1_N = mkN "prisfest" "prisfester" ;
  priskurant_nn_1_N = mkN "priskurant" "priskuranter" ;
  prisnivaa_nn_1_1_N = mkN "prisnivå" "prisnivåer" ;
  privatdetektiv_nn_1_N = mkN "privatdetektiv" "privatdetektiver" ;
  privatist_nn_1_N = mkN "privatist" "privatister" ;
  privatpraktik_nn_1_N = mkN "privatpraktik" "privatpraktiker" ;
  procedur_nn_1_N = mkN "procedur" "procedurer" ;
  process_nn_1_N = mkN "process" "processer" ;
  processingenjoer_nn_1_1_N = mkN "processingenjör" "processingenjörer" ;
  processor_nn_1_N = mkN "processor" "processorer" ;
  produktframtagningsprocess_nn_1_N = mkN "produktframtagningsprocess" "produktframtagningsprocesser" ;
  produktionsfaktor_nn_1_N = mkN "produktionsfaktor" "produktionsfaktorer" ;
  produktionsskatt_nn_1_N = mkN "produktionsskatt" "produktionsskatter" ;
  professionalism_nn_1_N = mkN "professionalism" "professionalismer" ;
  professor_nn_1_N = mkN "professor" "professorer" ;
  professur_nn_1_N = mkN "professur" "professurer" ;
  proffsdemonstrant_nn_1_N = mkN "proffsdemonstrant" "proffsdemonstranter" ;
  profil_nn_1_N = mkN "profil" "profiler" ;
  profit_nn_1_N = mkN "profit" "profiter" ;
  profoss_nn_1_N = mkN "profoss" "profosser" ;
  prognos_nn_1_N = mkN "prognos" "prognoser" ;
  proinspektor_nn_1_N = mkN "proinspektor" "proinspektorer" ;
  projektor_nn_1_N = mkN "projektor" "projektorer" ;
  prokurator_nn_1_N = mkN "prokurator" "prokuratorer" ;
  prokurist_nn_1_N = mkN "prokurist" "prokurister" ;
  prolaps_nn_1_N = mkN "prolaps" "prolapser" ;
  proletaer_nn_1_1_N = mkN "proletär" "proletärer" ;
  prolog_nn_1_N = mkN "prolog" "prologer" ;
  prominens_nn_1_N = mkN "prominens" "prominenser" ;
  promotor_nn_1_N = mkN "promotor" "promotorer" ;
  propagandist_nn_1_N = mkN "propagandist" "propagandister" ;
  proportionalism_nn_1_N = mkN "proportionalism" "proportionalismer" ;
  propyl_nn_1_N = mkN "propyl" "propyler" ;
  propaa_nn_1_1_N = mkN "propå" "propåer" ;
  prorektor_nn_1_N = mkN "prorektor" "prorektorer" ;
  prosaist_nn_1_N = mkN "prosaist" "prosaister" ;
  prosektor_nn_1_N = mkN "prosektor" "prosektorer" ;
  prostatit_nn_1_N = mkN "prostatit" "prostatiter" ;
  protagonist_nn_1_N = mkN "protagonist" "protagonister" ;
  proteinanalys_nn_1_N = mkN "proteinanalys" "proteinanalyser" ;
  proteinkemist_nn_1_N = mkN "proteinkemist" "proteinkemister" ;
  proteinmolekyl_nn_1_N = mkN "proteinmolekyl" "proteinmolekyler" ;
  protektionism_nn_1_N = mkN "protektionism" "protektionismer" ;
  protektor_nn_1_N = mkN "protektor" "protektorer" ;
  protes_nn_1_N = mkN "protes" "proteser" ;
  protest_nn_1_N = mkN "protest" "protester" ;
  protestant_nn_1_N = mkN "protestant" "protestanter" ;
  protestantism_nn_1_N = mkN "protestantism" "protestantismer" ;
  protestkultur_nn_1_N = mkN "protestkultur" "protestkulturer" ;
  protestroest_nn_1_1_N = mkN "proteströst" "proteströster" ;
  proteststrejk_nn_1_N = mkN "proteststrejk" "proteststrejker" ;
  protolys_nn_1_N = mkN "protolys" "protolyser" ;
  proton_nn_1_N = mkN "proton" "protoner" ;
  protonkarusell_nn_1_N = mkN "protonkarusell" "protonkaruseller" ;
  protuberans_nn_1_N = mkN "protuberans" "protuberanser" ;
  provanalys_nn_1_N = mkN "provanalys" "provanalyser" ;
  proveniens_nn_1_N = mkN "proveniens" "provenienser" ;
  provins_nn_1_N = mkN "provins" "provinser" ;
  provinsialism_nn_1_N = mkN "provinsialism" "provinsialismer" ;
  prydnadsdetalj_nn_1_N = mkN "prydnadsdetalj" "prydnadsdetaljer" ;
  prydnadsfigur_nn_1_N = mkN "prydnadsfigur" "prydnadsfigurer" ;
  prydnadslist_nn_1_N = mkN "prydnadslist" "prydnadslister" ;
  prydnadsvaext_nn_1_1_N = mkN "prydnadsväxt" "prydnadsväxter" ;
  praest_nn_1_1_N = mkN "präst" "präster" ;
  praestgaardsarrendator_nn_1_1_N = mkN "prästgårdsarrendator" "prästgårdsarrendatorer" ;
  psalmbok_nn_1_N = mkN "psalmbok" "psalmböcker" ;
  psalmist_nn_1_N = mkN "psalmist" "psalmister" ;
  psykoanalys_nn_1_N = mkN "psykoanalys" "psykoanalyser" ;
  psykolog_nn_1_N = mkN "psykolog" "psykologer" ;
  psykologiprofessor_nn_1_N = mkN "psykologiprofessor" "psykologiprofessorer" ;
  psykos_nn_1_N = mkN "psykos" "psykoser" ;
  publicist_nn_1_N = mkN "publicist" "publicister" ;
  publik_nn_1_N = mkN "publik" "publiker" ;
  publikan_nn_1_N = mkN "publikan" "publikaner" ;
  puckelpist_nn_1_N = mkN "puckelpist" "puckelpister" ;
  pugilism_nn_1_N = mkN "pugilism" "pugilismer" ;
  pugilist_nn_1_N = mkN "pugilist" "pugilister" ;
  puls_nn_1_N = mkN "puls" "pulser" ;
  pulsar_nn_1_N = mkN "pulsar" "pulsarer" ;
  pultron_nn_1_N = mkN "pultron" "pultroner" ;
  pumpmotor_nn_1_N = mkN "pumpmotor" "pumpmotorer" ;
  pumpsats_nn_1_N = mkN "pumpsats" "pumpsatser" ;
  pundkris_nn_1_N = mkN "pundkris" "pundkriser" ;
  punkt_nn_1_N = mkN "punkt" "punkter" ;
  punkteringssprej_nn_1_N = mkN "punkteringssprej" "punkteringssprejer" ;
  punktinsats_nn_1_N = mkN "punktinsats" "punktinsatser" ;
  punktskatt_nn_1_N = mkN "punktskatt" "punktskatter" ;
  punktur_nn_1_N = mkN "punktur" "punkturer" ;
  punschpralin_nn_1_N = mkN "punschpralin" "punschpraliner" ;
  purism_nn_1_N = mkN "purism" "purismer" ;
  purist_nn_1_N = mkN "purist" "purister" ;
  puritan_nn_1_N = mkN "puritan" "puritaner" ;
  puritanism_nn_1_N = mkN "puritanism" "puritanismer" ;
  pur_e_nn_1_1_N = mkN "puré" "puréer" ;
  putsch_nn_1_N = mkN "putsch" "putscher" ;
  pyelit_nn_1_N = mkN "pyelit" "pyeliter" ;
  pylon_nn_1_N = mkN "pylon" "pyloner" ;
  pyramid_nn_1_N = mkN "pyramid" "pyramider" ;
  pyrit_nn_1_N = mkN "pyrit" "pyriter" ;
  pyroklast_nn_1_N = mkN "pyroklast" "pyroklaster" ;
  pyroman_nn_1_N = mkN "pyroman" "pyromaner" ;
  paaannons_nn_1_1_N = mkN "påannons" "påannonser" ;
  paalmast_nn_1_1_N = mkN "pålmast" "pålmaster" ;
  paastaaendesats_nn_1_1_N = mkN "påståendesats" "påståendesatser" ;
  quenell_nn_1_N = mkN "quenell" "queneller" ;
  rabbin_nn_1_N = mkN "rabbin" "rabbiner" ;
  rabulism_nn_1_N = mkN "rabulism" "rabulismer" ;
  rabulist_nn_1_N = mkN "rabulist" "rabulister" ;
  rad_nn_1_N = mkN "rad" "rader" ;
  radannons_nn_1_N = mkN "radannons" "radannonser" ;
  radarreflektor_nn_1_N = mkN "radarreflektor" "radarreflektorer" ;
  radian_nn_1_N = mkN "radian" "radianer" ;
  radiator_nn_1_N = mkN "radiator" "radiatorer" ;
  radikal_nn_1_N = mkN "radikal" "radikaler" ;
  radikalism_nn_1_N = mkN "radikalism" "radikalismer" ;
  radiogrammofon_nn_1_N = mkN "radiogrammofon" "radiogrammofoner" ;
  radiolog_nn_1_N = mkN "radiolog" "radiologer" ;
  radiopjaes_nn_1_1_N = mkN "radiopjäs" "radiopjäser" ;
  radioroest_nn_1_1_N = mkN "radioröst" "radioröster" ;
  radiosignal_nn_1_N = mkN "radiosignal" "radiosignaler" ;
  radiotelefon_nn_1_N = mkN "radiotelefon" "radiotelefoner" ;
  radiotelegrafist_nn_1_N = mkN "radiotelegrafist" "radiotelegrafister" ;
  raggmunkmix_nn_1_N = mkN "raggmunkmix" "raggmunkmixer" ;
  raid_nn_1_N = mkN "raid" "raider" ;
  raketbas_nn_1_N = mkN "raketbas" "raketbaser" ;
  raketmotor_nn_1_N = mkN "raketmotor" "raketmotorer" ;
  ranch_nn_1_N = mkN "ranch" "rancher" ;
  randplataa_nn_1_1_N = mkN "randplatå" "randplatåer" ;
  rangplats_nn_1_N = mkN "rangplats" "rangplatser" ;
  ranson_nn_1_N = mkN "ranson" "ransoner" ;
  ranunkelvaext_nn_1_1_N = mkN "ranunkelväxt" "ranunkelväxter" ;
  rapport_nn_1_N = mkN "rapport" "rapporter" ;
  rapportbok_nn_1_N = mkN "rapportbok" "rapportböcker" ;
  ras_nn_1_N = mkN "ras" "raser" ;
  rasism_nn_1_N = mkN "rasism" "rasismer" ;
  rasist_nn_1_N = mkN "rasist" "rasister" ;
  rasistskandal_nn_1_N = mkN "rasistskandal" "rasistskandaler" ;
  rast_nn_1_N = mkN "rast" "raster" ;
  rastplats_nn_1_N = mkN "rastplats" "rastplatser" ;
  rationalism_nn_1_N = mkN "rationalism" "rationalismer" ;
  rationalist_nn_1_N = mkN "rationalist" "rationalister" ;
  rattfyllerist_nn_1_N = mkN "rattfyllerist" "rattfyllerister" ;
  ravefest_nn_1_N = mkN "ravefest" "ravefester" ;
  ravelin_nn_1_N = mkN "ravelin" "raveliner" ;
  reaktionsfas_nn_1_N = mkN "reaktionsfas" "reaktionsfaser" ;
  reaktionsmotor_nn_1_N = mkN "reaktionsmotor" "reaktionsmotorer" ;
  reaktionstemperatur_nn_1_N = mkN "reaktionstemperatur" "reaktionstemperaturer" ;
  reaktionaer_nn_1_1_N = mkN "reaktionär" "reaktionärer" ;
  reaktor_nn_1_N = mkN "reaktor" "reaktorer" ;
  reaktorkatastrof_nn_1_N = mkN "reaktorkatastrof" "reaktorkatastrofer" ;
  realisationsvinst_nn_1_N = mkN "realisationsvinst" "realisationsvinster" ;
  realism_nn_1_N = mkN "realism" "realismer" ;
  realist_nn_1_N = mkN "realist" "realister" ;
  reamotor_nn_1_N = mkN "reamotor" "reamotorer" ;
  reassurans_nn_1_N = mkN "reassurans" "reassuranser" ;
  recentior_nn_1_N = mkN "recentior" "recentiorer" ;
  receptdatabas_nn_1_N = mkN "receptdatabas" "receptdatabaser" ;
  receptionist_nn_1_N = mkN "receptionist" "receptionister" ;
  receptor_nn_1_N = mkN "receptor" "receptorer" ;
  receptur_nn_1_N = mkN "receptur" "recepturer" ;
  recess_nn_1_N = mkN "recess" "recesser" ;
  recherch_nn_1_N = mkN "recherch" "rechercher" ;
  recit_nn_1_N = mkN "recit" "reciter" ;
  redaktoer_nn_1_1_N = mkN "redaktör" "redaktörer" ;
  redikyl_nn_1_N = mkN "redikyl" "redikyler" ;
  redoxprocess_nn_1_N = mkN "redoxprocess" "redoxprocesser" ;
  referens_nn_1_N = mkN "referens" "referenser" ;
  reflektor_nn_1_N = mkN "reflektor" "reflektorer" ;
  reflex_nn_1_N = mkN "reflex" "reflexer" ;
  reform_nn_1_N = mkN "reform" "reformer" ;
  reformator_nn_1_N = mkN "reformator" "reformatorer" ;
  reformism_nn_1_N = mkN "reformism" "reformismer" ;
  reformist_nn_1_N = mkN "reformist" "reformister" ;
  refraktor_nn_1_N = mkN "refraktor" "refraktorer" ;
  regementspastor_nn_1_N = mkN "regementspastor" "regementspastorer" ;
  regenerator_nn_1_N = mkN "regenerator" "regeneratorer" ;
  regeringspost_nn_1_N = mkN "regeringspost" "regeringsposter" ;
  regim_nn_1_N = mkN "regim" "regimer" ;
  regionalism_nn_1_N = mkN "regionalism" "regionalismer" ;
  regionplan_nn_1_N = mkN "regionplan" "regionplaner" ;
  registrator_nn_1_N = mkN "registrator" "registratorer" ;
  regnoverall_nn_1_N = mkN "regnoverall" "regnoveraller" ;
  regolit_nn_1_N = mkN "regolit" "regoliter" ;
  regress_nn_1_N = mkN "regress" "regresser" ;
  regulator_nn_1_N = mkN "regulator" "regulatorer" ;
  rejvfest_nn_1_N = mkN "rejvfest" "rejvfester" ;
  reklamaffisch_nn_1_N = mkN "reklamaffisch" "reklamaffischer" ;
  reklambroschyr_nn_1_N = mkN "reklambroschyr" "reklambroschyrer" ;
  reklambyraa_nn_1_1_N = mkN "reklambyrå" "reklambyråer" ;
  reklampaus_nn_1_N = mkN "reklampaus" "reklampauser" ;
  rekordnivaa_nn_1_1_N = mkN "rekordnivå" "rekordnivåer" ;
  rektor_nn_1_N = mkN "rektor" "rektorer" ;
  rekurrens_nn_1_N = mkN "rekurrens" "rekurrenser" ;
  rekyl_nn_1_N = mkN "rekyl" "rekyler" ;
  relativism_nn_1_N = mkN "relativism" "relativismer" ;
  relativist_nn_1_N = mkN "relativist" "relativister" ;
  relativsats_nn_1_N = mkN "relativsats" "relativsatser" ;
  relik_nn_1_N = mkN "relik" "reliker" ;
  relikt_nn_1_N = mkN "relikt" "relikter" ;
  rembours_nn_1_N = mkN "rembours" "rembourser" ;
  rembrandt_nn_1_N = mkN "rembrandt" "rembrandter" ;
  remburs_nn_1_N = mkN "remburs" "remburser" ;
  reminiscens_nn_1_N = mkN "reminiscens" "reminiscenser" ;
  remis_nn_2_N = mkN "remis" "remiser" ;
  remiss_nn_1_N = mkN "remiss" "remisser" ;
  remissinstans_nn_1_N = mkN "remissinstans" "remissinstanser" ;
  remont_nn_1_N = mkN "remont" "remonter" ;
  remouladsaas_nn_1_1_N = mkN "remouladsås" "remouladsåser" ;
  remuladsaas_nn_1_1_N = mkN "remuladsås" "remuladsåser" ;
  rengoeringssats_nn_1_1_N = mkN "rengöringssats" "rengöringssatser" ;
  rentier_nn_1_N = mkN "rentier" "rentierer" ;
  rentj_e_nn_1_1_N = mkN "rentjé" "rentjéer" ;
  rentr_e_nn_1_1_N = mkN "rentré" "rentréer" ;
  renaessans_nn_1_1_N = mkN "renässans" "renässanser" ;
  renaessansarkitektur_nn_1_1_N = mkN "renässansarkitektur" "renässansarkitekturer" ;
  renaessanskonst_nn_1_1_N = mkN "renässanskonst" "renässanskonster" ;
  reol_nn_1_N = mkN "reol" "reoler" ;
  reportagebok_nn_1_N = mkN "reportagebok" "reportageböcker" ;
  reporterlegend_nn_1_N = mkN "reporterlegend" "reporterlegender" ;
  representant_nn_1_N = mkN "representant" "representanter" ;
  repris_nn_1_N = mkN "repris" "repriser" ;
  reptil_nn_1_N = mkN "reptil" "reptiler" ;
  republikan_nn_1_N = mkN "republikan" "republikaner" ;
  resandebok_nn_1_N = mkN "resandebok" "resandeböcker" ;
  research_nn_1_N = mkN "research" "researcher" ;
  resebyraa_nn_1_1_N = mkN "resebyrå" "resebyråer" ;
  resegrammofon_nn_1_N = mkN "resegrammofon" "resegrammofoner" ;
  resehandbok_nn_1_N = mkN "resehandbok" "resehandböcker" ;
  reservant_nn_1_N = mkN "reservant" "reservanter" ;
  resistor_nn_1_N = mkN "resistor" "resistorer" ;
  resklass_nn_1_N = mkN "resklass" "resklasser" ;
  resonemangskarusell_nn_1_N = mkN "resonemangskarusell" "resonemangskaruseller" ;
  respirator_nn_1_N = mkN "respirator" "respiratorer" ;
  respit_nn_1_N = mkN "respit" "respiter" ;
  rest_nn_1_N = mkN "rest" "rester" ;
  restaurang_nn_1_N = mkN "restaurang" "restauranger" ;
  restauranggaest_nn_1_1_N = mkN "restauranggäst" "restauranggäster" ;
  restaurant_nn_1_N = mkN "restaurant" "restauranter" ;
  restaurator_nn_1_N = mkN "restaurator" "restauratorer" ;
  restauratris_nn_1_N = mkN "restauratris" "restauratriser" ;
  restriktivitetsprincip_nn_1_N = mkN "restriktivitetsprincip" "restriktivitetsprinciper" ;
  restskatt_nn_1_N = mkN "restskatt" "restskatter" ;
  resultant_nn_1_N = mkN "resultant" "resultanter" ;
  resum_e_nn_1_1_N = mkN "resumé" "resuméer" ;
  resurs_nn_1_N = mkN "resurs" "resurser" ;
  resursbas_nn_1_N = mkN "resursbas" "resursbaser" ;
  resurskris_nn_1_N = mkN "resurskris" "resurskriser" ;
  resaarmadrass_nn_1_1_N = mkN "resårmadrass" "resårmadrasser" ;
  retor_nn_1_N = mkN "retor" "retorer" ;
  retorikexpert_nn_1_N = mkN "retorikexpert" "retorikexperter" ;
  retronym_nn_1_N = mkN "retronym" "retronymer" ;
  retraett_nn_1_1_N = mkN "reträtt" "reträtter" ;
  retraettplats_nn_1_1_N = mkN "reträttplats" "reträttplatser" ;
  retur_nn_1_N = mkN "retur" "returer" ;
  returmatch_nn_1_N = mkN "returmatch" "returmatcher" ;
  retusch_nn_1_N = mkN "retusch" "retuscher" ;
  reumatism_nn_1_N = mkN "reumatism" "reumatismer" ;
  reumatolog_nn_1_N = mkN "reumatolog" "reumatologer" ;
  revansch_nn_1_N = mkN "revansch" "revanscher" ;
  revanschism_nn_1_N = mkN "revanschism" "revanschismer" ;
  reveny_nn_1_N = mkN "reveny" "revenyer" ;
  reverens_nn_1_N = mkN "reverens" "reverenser" ;
  revers_nn_1_N = mkN "revers" "reverser" ;
  revisionism_nn_1_N = mkN "revisionism" "revisionismer" ;
  revisionist_nn_1_N = mkN "revisionist" "revisionister" ;
  revisor_nn_1_N = mkN "revisor" "revisorer" ;
  revolutionaer_nn_1_1_N = mkN "revolutionär" "revolutionärer" ;
  revy_nn_1_N = mkN "revy" "revyer" ;
  revyartist_nn_1_N = mkN "revyartist" "revyartister" ;
  rh_faktor_nn_1_N = mkN "rh-faktor" "rh-faktorer" ;
  riboflavin_nn_1_N = mkN "riboflavin" "riboflaviner" ;
  ridikyl_nn_1_N = mkN "ridikyl" "ridikyler" ;
  ridinstruktoer_nn_1_1_N = mkN "ridinstruktör" "ridinstruktörer" ;
  ridaa_nn_1_1_N = mkN "ridå" "ridåer" ;
  rigorism_nn_1_N = mkN "rigorism" "rigorismer" ;
  riksdagsplats_nn_1_N = mkN "riksdagsplats" "riksdagsplatser" ;
  riksgraens_nn_1_1_N = mkN "riksgräns" "riksgränser" ;
  riksskandal_nn_1_N = mkN "riksskandal" "riksskandaler" ;
  ringdans_nn_1_N = mkN "ringdans" "ringdanser" ;
  ringstruktur_nn_1_N = mkN "ringstruktur" "ringstrukturer" ;
  ripost_nn_1_N = mkN "ripost" "riposter" ;
  risk_nn_1_N = mkN "risk" "risker" ;
  riskanalys_nn_1_N = mkN "riskanalys" "riskanalyser" ;
  riskfaktor_nn_1_N = mkN "riskfaktor" "riskfaktorer" ;
  riskkapitalist_nn_1_N = mkN "riskkapitalist" "riskkapitalister" ;
  risknivaa_nn_1_1_N = mkN "risknivå" "risknivåer" ;
  ritt_nn_1_N = mkN "ritt" "ritter" ;
  ritualism_nn_1_N = mkN "ritualism" "ritualismer" ;
  rob_nn_1_N = mkN "rob" "rober" ;
  robotkrasch_nn_1_N = mkN "robotkrasch" "robotkrascher" ;
  robotroest_nn_1_1_N = mkN "robotröst" "robotröster" ;
  rockfestival_nn_1_N = mkN "rockfestival" "rockfestivaler" ;
  rojalism_nn_1_N = mkN "rojalism" "rojalismer" ;
  rojalist_nn_1_N = mkN "rojalist" "rojalister" ;
  roll_on_deodorant_nn_1_N = mkN "roll-on-deodorant" "roll-on-deodoranter" ;
  roll_nn_1_N = mkN "roll" "roller" ;
  rollator_nn_1_N = mkN "rollator" "rollatorer" ;
  rollfigur_nn_1_N = mkN "rollfigur" "rollfigurer" ;
  rom_nn_2_N = mkN "rom" "romer" ;
  roman_nn_1_N = mkN "roman" "romaner" ;
  romanist_nn_1_N = mkN "romanist" "romanister" ;
  romans_nn_1_N = mkN "romans" "romanser" ;
  romboid_nn_1_N = mkN "romboid" "romboider" ;
  rosmarin_nn_1_N = mkN "rosmarin" "rosmariner" ;
  rot_nn_1_N = mkN "rot" "rötter" ;
  rotationsmotor_nn_1_N = mkN "rotationsmotor" "rotationsmotorer" ;
  rotor_nn_1_N = mkN "rotor" "rotorer" ;
  roulad_nn_1_N = mkN "roulad" "roulader" ;
  roulett_nn_1_N = mkN "roulett" "rouletter" ;
  rousseauan_nn_1_N = mkN "rousseauan" "rousseauaner" ;
  rousseauanism_nn_1_N = mkN "rousseauanism" "rousseauanismer" ;
  rubin_nn_1_N = mkN "rubin" "rubiner" ;
  rubrik_nn_1_N = mkN "rubrik" "rubriker" ;
  ruderatvaext_nn_1_1_N = mkN "ruderatväxt" "ruderatväxter" ;
  ruin_nn_1_N = mkN "ruin" "ruiner" ;
  rulad_nn_1_N = mkN "rulad" "rulader" ;
  rulett_nn_1_N = mkN "rulett" "ruletter" ;
  rullad_nn_1_N = mkN "rullad" "rullader" ;
  rullator_nn_1_N = mkN "rullator" "rullatorer" ;
  rumslast_nn_1_N = mkN "rumslast" "rumslaster" ;
  rumstemperatur_nn_1_N = mkN "rumstemperatur" "rumstemperaturer" ;
  rundabordskonferens_nn_1_N = mkN "rundabordskonferens" "rundabordskonferenser" ;
  runolog_nn_1_N = mkN "runolog" "runologer" ;
  ruptur_nn_1_N = mkN "ruptur" "rupturer" ;
  rusch_nn_1_N = mkN "rusch" "ruscher" ;
  rush_nn_1_N = mkN "rush" "rusher" ;
  rutin_nn_1_N = mkN "rutin" "rutiner" ;
  rutt_nn_1_N = mkN "rutt" "rutter" ;
  ryggmuskelparalys_nn_1_N = mkN "ryggmuskelparalys" "ryggmuskelparalyser" ;
  ryggsaecksturist_nn_1_1_N = mkN "ryggsäcksturist" "ryggsäcksturister" ;
  rymdfarkost_nn_1_N = mkN "rymdfarkost" "rymdfarkoster" ;
  ryskkurs_nn_1_N = mkN "ryskkurs" "ryskkurser" ;
  ryttarstaty_nn_1_N = mkN "ryttarstaty" "ryttarstatyer" ;
  raed_nn_1_1_N = mkN "räd" "räder" ;
  raeddningsinsats_nn_1_1_N = mkN "räddningsinsats" "räddningsinsatser" ;
  raeddningsplan_nn_1_1_N = mkN "räddningsplan" "räddningsplaner" ;
  raeddningstjaenst_nn_1_1_N = mkN "räddningstjänst" "räddningstjänster" ;
  raefst_nn_1_1_N = mkN "räfst" "räfster" ;
  raentenivaa_nn_1_1_N = mkN "räntenivå" "räntenivåer" ;
  raentesats_nn_1_1_N = mkN "räntesats" "räntesatser" ;
  raett_nn_3_13_N = mkN "rätt" "rätter" ;
  raettshaverist_nn_1_1_N = mkN "rättshaverist" "rättshaverister" ;
  raettsprincip_nn_1_1_N = mkN "rättsprincip" "rättsprinciper" ;
  raettstvist_nn_1_1_N = mkN "rättstvist" "rättstvister" ;
  raaoljemotor_nn_1_1_N = mkN "råoljemotor" "råoljemotorer" ;
  roekdetektor_nn_1_1_N = mkN "rökdetektor" "rökdetektorer" ;
  roekgas_nn_1_1_N = mkN "rökgas" "rökgaser" ;
  roekkup_e_nn_1_1_N = mkN "rökkupé" "rökkupéer" ;
  roekmask_nn_1_1_N = mkN "rökmask" "rökmasker" ;
  roekridaa_nn_1_1_N = mkN "rökridå" "rökridåer" ;
  roektopas_nn_1_1_N = mkN "röktopas" "röktopaser" ;
  roerelsedetektor_nn_1_1_N = mkN "rörelsedetektor" "rörelsedetektorer" ;
  roerelseinkomst_nn_1_1_N = mkN "rörelseinkomst" "rörelseinkomster" ;
  roerelsevinst_nn_1_1_N = mkN "rörelsevinst" "rörelsevinster" ;
  roest_nn_1_1_N = mkN "röst" "röster" ;
  sabin_nn_1_N = mkN "sabin" "sabiner" ;
  sadelplats_nn_1_N = mkN "sadelplats" "sadelplatser" ;
  sadism_nn_1_N = mkN "sadism" "sadismer" ;
  sadist_nn_1_N = mkN "sadist" "sadister" ;
  sado_masochism_nn_1_N = mkN "sado-masochism" "sado-masochismer" ;
  saft_nn_1_N = mkN "saft" "safter" ;
  saftsaas_nn_1_1_N = mkN "saftsås" "saftsåser" ;
  sagesperson_nn_1_N = mkN "sagesperson" "sagespersoner" ;
  sagobok_nn_1_N = mkN "sagobok" "sagoböcker" ;
  sagofigur_nn_1_N = mkN "sagofigur" "sagofigurer" ;
  sahib_nn_1_N = mkN "sahib" "sahiber" ;
  sajt_nn_1_N = mkN "sajt" "sajter" ;
  sak_nn_1_N = mkN "sak" "saker" ;
  salin_nn_1_N = mkN "salin" "saliner" ;
  salmonellafaers_nn_1_1_N = mkN "salmonellafärs" "salmonellafärser" ;
  salongskommunist_nn_1_N = mkN "salongskommunist" "salongskommunister" ;
  saloon_nn_1_N = mkN "saloon" "salooner" ;
  salpingit_nn_1_N = mkN "salpingit" "salpingiter" ;
  saltkristall_nn_1_N = mkN "saltkristall" "saltkristaller" ;
  saltvaext_nn_1_1_N = mkN "saltväxt" "saltväxter" ;
  salvadoran_nn_1_N = mkN "salvadoran" "salvadoraner" ;
  salvationist_nn_1_N = mkN "salvationist" "salvationister" ;
  samarbetsplan_nn_1_N = mkN "samarbetsplan" "samarbetsplaner" ;
  samarit_nn_1_N = mkN "samarit" "samariter" ;
  samekultur_nn_1_N = mkN "samekultur" "samekulturer" ;
  samhaellsfasad_nn_1_1_N = mkN "samhällsfasad" "samhällsfasader" ;
  samhaellsinsats_nn_1_1_N = mkN "samhällsinsats" "samhällsinsatser" ;
  samhaellsklass_nn_1_1_N = mkN "samhällsklass" "samhällsklasser" ;
  samhaellspyramid_nn_1_1_N = mkN "samhällspyramid" "samhällspyramider" ;
  samhaellsrepresentant_nn_1_1_N = mkN "samhällsrepresentant" "samhällsrepresentanter" ;
  samhaellssymbol_nn_1_1_N = mkN "samhällssymbol" "samhällssymboler" ;
  samlingslins_nn_1_N = mkN "samlingslins" "samlingslinser" ;
  samlingsplats_nn_1_N = mkN "samlingsplats" "samlingsplatser" ;
  sammankomst_nn_1_N = mkN "sammankomst" "sammankomster" ;
  sammansaettningsanalys_nn_1_1_N = mkN "sammansättningsanalys" "sammansättningsanalyser" ;
  sammelplats_nn_1_N = mkN "sammelplats" "sammelplatser" ;
  samnit_nn_1_N = mkN "samnit" "samniter" ;
  samoan_nn_1_N = mkN "samoan" "samoaner" ;
  sampan_nn_1_N = mkN "sampan" "sampaner" ;
  sandvaext_nn_1_1_N = mkN "sandväxt" "sandväxter" ;
  saneringsplan_nn_1_N = mkN "saneringsplan" "saneringsplaner" ;
  sannolikhetskalkyl_nn_1_N = mkN "sannolikhetskalkyl" "sannolikhetskalkyler" ;
  sanskulott_nn_1_N = mkN "sanskulott" "sanskulotter" ;
  saotomean_nn_1_N = mkN "saotomean" "saotomeaner" ;
  sarafan_nn_1_N = mkN "sarafan" "sarafaner" ;
  sardin_nn_1_N = mkN "sardin" "sardiner" ;
  satanism_nn_1_N = mkN "satanism" "satanismer" ;
  satanist_nn_1_N = mkN "satanist" "satanister" ;
  satellit_nn_1_N = mkN "satellit" "satelliter" ;
  sats_nn_1_N = mkN "sats" "satser" ;
  satsanalys_nn_1_N = mkN "satsanalys" "satsanalyser" ;
  saturnaliefest_nn_1_N = mkN "saturnaliefest" "saturnaliefester" ;
  saturnism_nn_1_N = mkN "saturnism" "saturnismer" ;
  saut_e_nn_1_1_N = mkN "sauté" "sautéer" ;
  savarin_nn_1_N = mkN "savarin" "savariner" ;
  saxofon_nn_1_N = mkN "saxofon" "saxofoner" ;
  saxofonist_nn_1_N = mkN "saxofonist" "saxofonister" ;
  scen_nn_1_N = mkN "scen" "scener" ;
  schablon_nn_1_N = mkN "schablon" "schabloner" ;
  schackpjaes_nn_1_1_N = mkN "schackpjäs" "schackpjäser" ;
  schah_nn_1_N = mkN "schah" "schaher" ;
  schakal_nn_1_N = mkN "schakal" "schakaler" ;
  schakaa_nn_1_1_N = mkN "schakå" "schakåer" ;
  schaman_nn_1_N = mkN "schaman" "schamaner" ;
  schamanism_nn_1_N = mkN "schamanism" "schamanismer" ;
  schampopatron_nn_1_N = mkN "schampopatron" "schampopatroner" ;
  schartauan_nn_1_N = mkN "schartauan" "schartauaner" ;
  schartauanism_nn_1_N = mkN "schartauanism" "schartauanismer" ;
  schematism_nn_1_N = mkN "schematism" "schematismer" ;
  schersmin_nn_1_N = mkN "schersmin" "schersminer" ;
  schimpans_nn_1_N = mkN "schimpans" "schimpanser" ;
  schism_nn_1_N = mkN "schism" "schismer" ;
  schlagertext_nn_1_N = mkN "schlagertext" "schlagertexter" ;
  science_fictionroman_nn_1_N = mkN "science-fictionroman" "science-fictionromaner" ;
  scientist_nn_1_N = mkN "scientist" "scientister" ;
  scientolog_nn_1_N = mkN "scientolog" "scientologer" ;
  seans_nn_1_N = mkN "seans" "seanser" ;
  sed_nn_1_N = mkN "sed" "seder" ;
  sedan_nn_1_N = mkN "sedan" "sedaner" ;
  sederoman_nn_1_N = mkN "sederoman" "sederomaner" ;
  sedes_nn_1_N = mkN "sedes" "sedeser" ;
  sefyr_nn_1_N = mkN "sefyr" "sefyrer" ;
  segerfest_nn_1_N = mkN "segerfest" "segerfester" ;
  seglats_nn_1_N = mkN "seglats" "seglatser" ;
  sekant_nn_1_N = mkN "sekant" "sekanter" ;
  sekin_nn_1_N = mkN "sekin" "sekiner" ;
  sekond_nn_1_N = mkN "sekond" "sekonder" ;
  sekterism_nn_1_N = mkN "sekterism" "sekterismer" ;
  sektor_nn_1_N = mkN "sektor" "sektorer" ;
  sekularpraest_nn_1_1_N = mkN "sekularpräst" "sekularpräster" ;
  sekundant_nn_1_N = mkN "sekundant" "sekundanter" ;
  sekvens_nn_1_N = mkN "sekvens" "sekvenser" ;
  selot_nn_1_N = mkN "selot" "seloter" ;
  semesterplan_nn_1_N = mkN "semesterplan" "semesterplaner" ;
  semesterromans_nn_1_N = mkN "semesterromans" "semesterromanser" ;
  semifinal_nn_1_N = mkN "semifinal" "semifinaler" ;
  semifinalplats_nn_1_N = mkN "semifinalplats" "semifinalplatser" ;
  seminarist_nn_1_N = mkN "seminarist" "seminarister" ;
  semit_nn_1_N = mkN "semit" "semiter" ;
  semitist_nn_1_N = mkN "semitist" "semitister" ;
  senar_nn_1_N = mkN "senar" "senarer" ;
  senator_nn_1_N = mkN "senator" "senatorer" ;
  senegales_nn_1_N = mkN "senegales" "senegaleser" ;
  sensor_nn_1_N = mkN "sensor" "sensorer" ;
  sensualism_nn_1_N = mkN "sensualism" "sensualismer" ;
  sentens_nn_1_N = mkN "sentens" "sentenser" ;
  separatism_nn_1_N = mkN "separatism" "separatismer" ;
  separatist_nn_1_N = mkN "separatist" "separatister" ;
  separator_nn_1_N = mkN "separator" "separatorer" ;
  seriefigur_nn_1_N = mkN "seriefigur" "seriefigurer" ;
  seriematch_nn_1_N = mkN "seriematch" "seriematcher" ;
  serpentin_nn_1_N = mkN "serpentin" "serpentiner" ;
  serval_nn_1_N = mkN "serval" "servaler" ;
  servilism_nn_1_N = mkN "servilism" "servilismer" ;
  servis_nn_1_N = mkN "servis" "serviser" ;
  servitris_nn_1_N = mkN "servitris" "servitriser" ;
  servomotor_nn_1_N = mkN "servomotor" "servomotorer" ;
  sexdebut_nn_1_N = mkN "sexdebut" "sexdebuter" ;
  sexexpert_nn_1_N = mkN "sexexpert" "sexexperter" ;
  sexism_nn_1_N = mkN "sexism" "sexismer" ;
  sexolog_nn_1_N = mkN "sexolog" "sexologer" ;
  sexskandal_nn_1_N = mkN "sexskandal" "sexskandaler" ;
  sexsymbol_nn_1_N = mkN "sexsymbol" "sexsymboler" ;
  sextant_nn_1_N = mkN "sextant" "sextanter" ;
  sextjaenst_nn_1_1_N = mkN "sextjänst" "sextjänster" ;
  sextol_nn_1_N = mkN "sextol" "sextoler" ;
  sfinx_nn_1_N = mkN "sfinx" "sfinxer" ;
  sfaer_nn_1_1_N = mkN "sfär" "sfärer" ;
  sfaeroid_nn_1_1_N = mkN "sfäroid" "sfäroider" ;
  shah_nn_1_N = mkN "shah" "shaher" ;
  shaman_nn_1_N = mkN "shaman" "shamaner" ;
  shamanism_nn_1_N = mkN "shamanism" "shamanismer" ;
  shiamuslim_nn_1_N = mkN "shiamuslim" "shiamuslimer" ;
  shiit_nn_1_N = mkN "shiit" "shiiter" ;
  shintoism_nn_1_N = mkN "shintoism" "shintoismer" ;
  siames_nn_1_N = mkN "siames" "siameser" ;
  sicilian_nn_1_N = mkN "sicilian" "sicilianer" ;
  sidoentr_e_nn_1_1_N = mkN "sidoentré" "sidoentréer" ;
  sidoinkomst_nn_1_N = mkN "sidoinkomst" "sidoinkomster" ;
  sifon_nn_1_N = mkN "sifon" "sifoner" ;
  signal_nn_1_N = mkN "signal" "signaler" ;
  signalbok_nn_1_N = mkN "signalbok" "signalböcker" ;
  signalist_nn_1_N = mkN "signalist" "signalister" ;
  signalpistol_nn_1_N = mkN "signalpistol" "signalpistoler" ;
  signalsubstans_nn_1_N = mkN "signalsubstans" "signalsubstanser" ;
  signatur_nn_1_N = mkN "signatur" "signaturer" ;
  signifikans_nn_1_N = mkN "signifikans" "signifikanser" ;
  silikonlist_nn_1_N = mkN "silikonlist" "silikonlister" ;
  silkeskanin_nn_1_N = mkN "silkeskanin" "silkeskaniner" ;
  sillfil_e_nn_1_1_N = mkN "sillfilé" "sillfiléer" ;
  silverfasan_nn_1_N = mkN "silverfasan" "silverfasaner" ;
  silverpokal_nn_1_N = mkN "silverpokal" "silverpokaler" ;
  silverservis_nn_1_N = mkN "silverservis" "silverserviser" ;
  sims_nn_1_N = mkN "sims" "simser" ;
  simulant_nn_1_N = mkN "simulant" "simulanter" ;
  simulator_nn_1_N = mkN "simulator" "simulatorer" ;
  simultanism_nn_1_N = mkN "simultanism" "simultanismer" ;
  singales_nn_1_N = mkN "singales" "singaleser" ;
  singaporian_nn_1_N = mkN "singaporian" "singaporianer" ;
  singular_nn_1_N = mkN "singular" "singularer" ;
  sinkadus_nn_1_N = mkN "sinkadus" "sinkaduser" ;
  sinolog_nn_1_N = mkN "sinolog" "sinologer" ;
  sinuit_nn_1_N = mkN "sinuit" "sinuiter" ;
  sinusit_nn_1_N = mkN "sinusit" "sinusiter" ;
  sionism_nn_1_N = mkN "sionism" "sionismer" ;
  sionist_nn_1_N = mkN "sionist" "sionister" ;
  sioux_nn_1_N = mkN "sioux" "siouxer" ;
  sittplats_nn_1_N = mkN "sittplats" "sittplatser" ;
  sittstrejk_nn_1_N = mkN "sittstrejk" "sittstrejker" ;
  sjakal_nn_1_N = mkN "sjakal" "sjakaler" ;
  sjukdomsdiagnos_nn_1_N = mkN "sjukdomsdiagnos" "sjukdomsdiagnoser" ;
  sjukgymnast_nn_1_N = mkN "sjukgymnast" "sjukgymnaster" ;
  sjukhusdirektoer_nn_1_1_N = mkN "sjukhusdirektör" "sjukhusdirektörer" ;
  sjukhusentr_e_nn_1_1_N = mkN "sjukhusentré" "sjukhusentréer" ;
  sjuktransport_nn_1_N = mkN "sjuktransport" "sjuktransporter" ;
  sjundedagsadventist_nn_1_N = mkN "sjundedagsadventist" "sjundedagsadventister" ;
  sjuraettersmeny_nn_1_1_N = mkN "sjurättersmeny" "sjurättersmenyer" ;
  sjaelvanalys_nn_1_1_N = mkN "självanalys" "självanalyser" ;
  sjaelvhjaelpsbok_nn_1_1_N = mkN "självhjälpsbok" "självhjälpsböcker" ;
  sjaelvhjaelpsbransch_nn_1_1_N = mkN "självhjälpsbransch" "självhjälpsbranscher" ;
  sjaelvmordsrisk_nn_1_1_N = mkN "självmordsrisk" "självmordsrisker" ;
  sjaelvrisk_nn_1_1_N = mkN "självrisk" "självrisker" ;
  sjoeelefant_nn_1_1_N = mkN "sjöelefant" "sjöelefanter" ;
  sjoefyllerist_nn_1_1_N = mkN "sjöfyllerist" "sjöfyllerister" ;
  sjoeleopard_nn_1_1_N = mkN "sjöleopard" "sjöleoparder" ;
  sjoerapport_nn_1_1_N = mkN "sjörapport" "sjörapporter" ;
  sjoetransport_nn_1_1_N = mkN "sjötransport" "sjötransporter" ;
  skald_nn_1_N = mkN "skald" "skalder" ;
  skaldekonst_nn_1_N = mkN "skaldekonst" "skaldekonster" ;
  skaldjursrest_nn_1_N = mkN "skaldjursrest" "skaldjursrester" ;
  skallbas_nn_1_N = mkN "skallbas" "skallbaser" ;
  skalaer_nn_1_1_N = mkN "skalär" "skalärer" ;
  skandinavism_nn_1_N = mkN "skandinavism" "skandinavismer" ;
  skandinavist_nn_1_N = mkN "skandinavist" "skandinavister" ;
  skanism_nn_1_N = mkN "skanism" "skanismer" ;
  skarab_e_nn_1_1_N = mkN "skarabé" "skarabéer" ;
  skatt_nn_1_N = mkN "skatt" "skatter" ;
  skatt_nn_2_N = mkN "skatt" "skatter" ;
  skattebas_nn_1_N = mkN "skattebas" "skattebaser" ;
  skatteingenjoer_nn_1_1_N = mkN "skatteingenjör" "skatteingenjörer" ;
  skatteinkomst_nn_1_N = mkN "skatteinkomst" "skatteinkomster" ;
  skatteklass_nn_1_N = mkN "skatteklass" "skatteklasser" ;
  skattekverulant_nn_1_N = mkN "skattekverulant" "skattekverulanter" ;
  skattenivaa_nn_1_1_N = mkN "skattenivå" "skattenivåer" ;
  skatteprincip_nn_1_N = mkN "skatteprincip" "skatteprinciper" ;
  skatteprotest_nn_1_N = mkN "skatteprotest" "skatteprotester" ;
  skattesats_nn_1_N = mkN "skattesats" "skattesatser" ;
  skepticism_nn_1_N = mkN "skepticism" "skepticismer" ;
  sketch_nn_1_N = mkN "sketch" "sketcher" ;
  skidskyttestafett_nn_1_N = mkN "skidskyttestafett" "skidskyttestafetter" ;
  skinnkavaj_nn_1_N = mkN "skinnkavaj" "skinnkavajer" ;
  skipod_nn_1_N = mkN "skipod" "skipoder" ;
  skiss_nn_1_N = mkN "skiss" "skisser" ;
  skivbolagsdirektoer_nn_1_1_N = mkN "skivbolagsdirektör" "skivbolagsdirektörer" ;
  skjutjaernsjournalist_nn_1_1_N = mkN "skjutjärnsjournalist" "skjutjärnsjournalister" ;
  skleros_nn_1_N = mkN "skleros" "skleroser" ;
  skogskornell_nn_1_N = mkN "skogskornell" "skogskorneller" ;
  skolavslutningsfest_nn_1_N = mkN "skolavslutningsfest" "skolavslutningsfester" ;
  skolbok_nn_1_N = mkN "skolbok" "skolböcker" ;
  skoldans_nn_1_N = mkN "skoldans" "skoldanser" ;
  skoldirektoer_nn_1_1_N = mkN "skoldirektör" "skoldirektörer" ;
  skolinspektoer_nn_1_1_N = mkN "skolinspektör" "skolinspektörer" ;
  skolklass_nn_1_N = mkN "skolklass" "skolklasser" ;
  skollunch_nn_1_N = mkN "skollunch" "skolluncher" ;
  skolmognadsklass_nn_1_N = mkN "skolmognadsklass" "skolmognadsklasser" ;
  skolpolis_nn_1_N = mkN "skolpolis" "skolpoliser" ;
  skolt_nn_1_N = mkN "skolt" "skolter" ;
  skoluppsats_nn_1_N = mkN "skoluppsats" "skoluppsatser" ;
  skolaest_nn_1_1_N = mkN "skoläst" "skoläster" ;
  skomakarrealism_nn_1_N = mkN "skomakarrealism" "skomakarrealismer" ;
  skorpion_nn_1_N = mkN "skorpion" "skorpioner" ;
  skrattfest_nn_1_N = mkN "skrattfest" "skrattfester" ;
  skrattparoxysm_nn_1_N = mkN "skrattparoxysm" "skrattparoxysmer" ;
  skrift_nn_1_N = mkN "skrift" "skrifter" ;
  skriftkonst_nn_1_N = mkN "skriftkonst" "skriftkonster" ;
  skrivbok_nn_1_N = mkN "skrivbok" "skrivböcker" ;
  skrivbyraa_nn_1_1_N = mkN "skrivbyrå" "skrivbyråer" ;
  skrivkonst_nn_1_N = mkN "skrivkonst" "skrivkonster" ;
  skrivplats_nn_1_N = mkN "skrivplats" "skrivplatser" ;
  skrotskulptur_nn_1_N = mkN "skrotskulptur" "skrotskulpturer" ;
  skraelldus_nn_1_1_N = mkN "skrälldus" "skrällduser" ;
  skraellvinst_nn_1_1_N = mkN "skrällvinst" "skrällvinster" ;
  skraepkultur_nn_1_1_N = mkN "skräpkultur" "skräpkulturer" ;
  skuld_nn_1_N = mkN "skuld" "skulder" ;
  skuldkris_nn_1_N = mkN "skuldkris" "skuldkriser" ;
  skulptris_nn_1_N = mkN "skulptris" "skulptriser" ;
  skulptur_nn_1_N = mkN "skulptur" "skulpturer" ;
  skumgummimadrass_nn_1_N = mkN "skumgummimadrass" "skumgummimadrasser" ;
  skurkregim_nn_1_N = mkN "skurkregim" "skurkregimer" ;
  skvadron_nn_1_N = mkN "skvadron" "skvadroner" ;
  skyddsmask_nn_1_N = mkN "skyddsmask" "skyddsmasker" ;
  skyddsmekanism_nn_1_N = mkN "skyddsmekanism" "skyddsmekanismer" ;
  skyt_nn_1_N = mkN "skyt" "skyter" ;
  skaelmroman_nn_1_1_N = mkN "skälmroman" "skälmromaner" ;
  skaergaardsturist_nn_1_1_N = mkN "skärgårdsturist" "skärgårdsturister" ;
  skaadeplats_nn_1_1_N = mkN "skådeplats" "skådeplatser" ;
  skaadeprocess_nn_1_1_N = mkN "skådeprocess" "skådeprocesser" ;
  skoerdefest_nn_1_1_N = mkN "skördefest" "skördefester" ;
  slagmask_nn_1_N = mkN "slagmask" "slagmasker" ;
  slagskatt_nn_1_N = mkN "slagskatt" "slagskatter" ;
  slagskeppsmatros_nn_1_N = mkN "slagskeppsmatros" "slagskeppsmatroser" ;
  slakt_nn_1_N = mkN "slakt" "slakter" ;
  slaktmask_nn_1_N = mkN "slaktmask" "slaktmasker" ;
  slavism_nn_1_N = mkN "slavism" "slavismer" ;
  slavist_nn_1_N = mkN "slavist" "slavister" ;
  slidmotor_nn_1_N = mkN "slidmotor" "slidmotorer" ;
  slingervaext_nn_1_1_N = mkN "slingerväxt" "slingerväxter" ;
  slutfas_nn_1_N = mkN "slutfas" "slutfaser" ;
  slutoffensiv_nn_1_N = mkN "slutoffensiv" "slutoffensiver" ;
  slutsats_nn_1_N = mkN "slutsats" "slutsatser" ;
  slaekt_nn_1_1_N = mkN "släkt" "släkter" ;
  slaatterfest_nn_1_1_N = mkN "slåtterfest" "slåtterfester" ;
  smalmeny_nn_1_N = mkN "smalmeny" "smalmenyer" ;
  smed_nn_1_N = mkN "smed" "smeder" ;
  sminkexpert_nn_1_N = mkN "sminkexpert" "sminkexperter" ;
  sminkoes_nn_1_1_N = mkN "sminkös" "sminköser" ;
  smittkoppsvaccin_nn_1_N = mkN "smittkoppsvaccin" "smittkoppsvacciner" ;
  smittorisk_nn_1_N = mkN "smittorisk" "smittorisker" ;
  smutskastningskampanj_nn_1_N = mkN "smutskastningskampanj" "smutskastningskampanjer" ;
  smygimpuls_nn_1_N = mkN "smygimpuls" "smygimpulser" ;
  smygpremiaer_nn_1_1_N = mkN "smygpremiär" "smygpremiärer" ;
  smaertreceptor_nn_1_1_N = mkN "smärtreceptor" "smärtreceptorer" ;
  smaabarnsbok_nn_1_1_N = mkN "småbarnsbok" "småbarnsböcker" ;
  smaadetalj_nn_1_1_N = mkN "smådetalj" "smådetaljer" ;
  smaaligist_nn_1_1_N = mkN "småligist" "småligister" ;
  smaaorganism_nn_1_1_N = mkN "småorganism" "småorganismer" ;
  snabbkurs_nn_1_N = mkN "snabbkurs" "snabbkurser" ;
  snabblunch_nn_1_N = mkN "snabblunch" "snabbluncher" ;
  snabbmatsrestaurang_nn_1_N = mkN "snabbmatsrestaurang" "snabbmatsrestauranger" ;
  snabbregulator_nn_1_N = mkN "snabbregulator" "snabbregulatorer" ;
  snabbremiss_nn_1_N = mkN "snabbremiss" "snabbremisser" ;
  snabbrepris_nn_1_N = mkN "snabbrepris" "snabbrepriser" ;
  snabbskiss_nn_1_N = mkN "snabbskiss" "snabbskisser" ;
  snabbtelefon_nn_1_N = mkN "snabbtelefon" "snabbtelefoner" ;
  snabbvisit_nn_1_N = mkN "snabbvisit" "snabbvisiter" ;
  snobbism_nn_1_N = mkN "snobbism" "snobbismer" ;
  snyltgaest_nn_1_1_N = mkN "snyltgäst" "snyltgäster" ;
  snyltvaext_nn_1_1_N = mkN "snyltväxt" "snyltväxter" ;
  snoekristall_nn_1_1_N = mkN "snökristall" "snökristaller" ;
  snoeprognos_nn_1_1_N = mkN "snöprognos" "snöprognoser" ;
  snoerapport_nn_1_1_N = mkN "snörapport" "snörapporter" ;
  soar_e_nn_1_1_N = mkN "soaré" "soaréer" ;
  socialantropolog_nn_1_N = mkN "socialantropolog" "socialantropologer" ;
  socialbyraa_nn_1_1_N = mkN "socialbyrå" "socialbyråer" ;
  socialdemokrat_nn_1_N = mkN "socialdemokrat" "socialdemokrater" ;
  socialdirektoer_nn_1_1_N = mkN "socialdirektör" "socialdirektörer" ;
  socialism_nn_1_N = mkN "socialism" "socialismer" ;
  socialist_nn_1_N = mkN "socialist" "socialister" ;
  socialklass_nn_1_N = mkN "socialklass" "socialklasser" ;
  socialliberalism_nn_1_N = mkN "socialliberalism" "socialliberalismer" ;
  socialpsykolog_nn_1_N = mkN "socialpsykolog" "socialpsykologer" ;
  socialrealism_nn_1_N = mkN "socialrealism" "socialrealismer" ;
  sociolog_nn_1_N = mkN "sociolog" "sociologer" ;
  sockerkampanj_nn_1_N = mkN "sockerkampanj" "sockerkampanjer" ;
  sockermolekyl_nn_1_N = mkN "sockermolekyl" "sockermolekyler" ;
  soffit_nn_1_N = mkN "soffit" "soffiter" ;
  sofism_nn_1_N = mkN "sofism" "sofismer" ;
  sofist_nn_1_N = mkN "sofist" "sofister" ;
  soldatfigur_nn_1_N = mkN "soldatfigur" "soldatfigurer" ;
  solfest_nn_1_N = mkN "solfest" "solfester" ;
  solipsism_nn_1_N = mkN "solipsism" "solipsismer" ;
  solist_nn_1_N = mkN "solist" "solister" ;
  solitaer_nn_1_1_N = mkN "solitär" "solitärer" ;
  solreflex_nn_1_N = mkN "solreflex" "solreflexer" ;
  sommaradress_nn_1_N = mkN "sommaradress" "sommaradresser" ;
  sommargaest_nn_1_1_N = mkN "sommargäst" "sommargäster" ;
  somnambul_nn_1_N = mkN "somnambul" "somnambuler" ;
  somnambulism_nn_1_N = mkN "somnambulism" "somnambulismer" ;
  sonant_nn_1_N = mkN "sonant" "sonanter" ;
  sonatin_nn_1_N = mkN "sonatin" "sonatiner" ;
  sopran_nn_1_N = mkN "sopran" "sopraner" ;
  sordin_nn_1_N = mkN "sordin" "sordiner" ;
  sorg_nn_1_N = mkN "sorg" "sorger" ;
  sorgegudstjaenst_nn_1_1_N = mkN "sorgegudstjänst" "sorgegudstjänster" ;
  sorgeprocess_nn_1_N = mkN "sorgeprocess" "sorgeprocesser" ;
  sottis_nn_1_N = mkN "sottis" "sottiser" ;
  sousafon_nn_1_N = mkN "sousafon" "sousafoner" ;
  souterrain_nn_1_N = mkN "souterrain" "souterrainer" ;
  souterraeng_nn_1_1_N = mkN "souterräng" "souterränger" ;
  sovchos_nn_1_N = mkN "sovchos" "sovchoser" ;
  sovmask_nn_1_N = mkN "sovmask" "sovmasker" ;
  sovplats_nn_1_N = mkN "sovplats" "sovplatser" ;
  spalj_e_nn_1_1_N = mkN "spaljé" "spaljéer" ;
  spannmaalsleverans_nn_1_1_N = mkN "spannmålsleverans" "spannmålsleveranser" ;
  sparagmit_nn_1_N = mkN "sparagmit" "sparagmiter" ;
  sparbanksbok_nn_1_N = mkN "sparbanksbok" "sparbanksböcker" ;
  spartakist_nn_1_N = mkN "spartakist" "spartakister" ;
  spartan_nn_1_N = mkN "spartan" "spartaner" ;
  specerist_nn_1_N = mkN "specerist" "specerister" ;
  special_nn_1_N = mkN "special" "specialer" ;
  specialist_nn_1_N = mkN "specialist" "specialister" ;
  specialistkompetens_nn_1_N = mkN "specialistkompetens" "specialistkompetenser" ;
  specialklass_nn_1_N = mkN "specialklass" "specialklasser" ;
  spekulant_nn_1_N = mkN "spekulant" "spekulanter" ;
  spekulationskarusell_nn_1_N = mkN "spekulationskarusell" "spekulationskaruseller" ;
  speleolog_nn_1_N = mkN "speleolog" "speleologer" ;
  spelplan_nn_2_N = mkN "spelplan" "spelplaner" ;
  spens_nn_1_N = mkN "spens" "spenser" ;
  spermadonator_nn_1_N = mkN "spermadonator" "spermadonatorer" ;
  spermatozoid_nn_1_N = mkN "spermatozoid" "spermatozoider" ;
  spetskompetens_nn_1_N = mkN "spetskompetens" "spetskompetenser" ;
  spikpistol_nn_1_N = mkN "spikpistol" "spikpistoler" ;
  spion_nn_1_N = mkN "spion" "spioner" ;
  spiralgalax_nn_1_N = mkN "spiralgalax" "spiralgalaxer" ;
  spirant_nn_1_N = mkN "spirant" "spiranter" ;
  spiritism_nn_1_N = mkN "spiritism" "spiritismer" ;
  spiritist_nn_1_N = mkN "spiritist" "spiritister" ;
  spiritualism_nn_1_N = mkN "spiritualism" "spiritualismer" ;
  spiritualist_nn_1_N = mkN "spiritualist" "spiritualister" ;
  spondylit_nn_1_N = mkN "spondylit" "spondyliter" ;
  spond_e_nn_1_1_N = mkN "spondé" "spondéer" ;
  sponsor_nn_1_N = mkN "sponsor" "sponsorer" ;
  spont_nn_1_N = mkN "spont" "sponter" ;
  spontanism_nn_1_N = mkN "spontanism" "spontanismer" ;
  sport_nn_1_N = mkN "sport" "sporter" ;
  sportjournalist_nn_1_N = mkN "sportjournalist" "sportjournalister" ;
  sporvaext_nn_1_1_N = mkN "sporväxt" "sporväxter" ;
  spridningslins_nn_1_N = mkN "spridningslins" "spridningslinser" ;
  spritspion_nn_1_N = mkN "spritspion" "spritspioner" ;
  sprutnarkoman_nn_1_N = mkN "sprutnarkoman" "sprutnarkomaner" ;
  sprutpistol_nn_1_N = mkN "sprutpistol" "sprutpistoler" ;
  spraengarbetsplats_nn_1_1_N = mkN "sprängarbetsplats" "sprängarbetsplatser" ;
  spraenggas_nn_1_1_N = mkN "spränggas" "spränggaser" ;
  spraengaemnesmolekyl_nn_1_1_N = mkN "sprängämnesmolekyl" "sprängämnesmolekyler" ;
  spraakkonsult_nn_1_1_N = mkN "språkkonsult" "språkkonsulter" ;
  spraakkurs_nn_1_1_N = mkN "språkkurs" "språkkurser" ;
  spraakpolis_nn_1_1_N = mkN "språkpolis" "språkpoliser" ;
  spraakprofessor_nn_1_1_N = mkN "språkprofessor" "språkprofessorer" ;
  spraakresurs_nn_1_1_N = mkN "språkresurs" "språkresurser" ;
  spraangmarsch_nn_1_1_N = mkN "språngmarsch" "språngmarscher" ;
  spaenningsregulator_nn_1_1_N = mkN "spänningsregulator" "spänningsregulatorer" ;
  spaens_nn_1_1_N = mkN "späns" "spänser" ;
  spaerrdiod_nn_1_1_N = mkN "spärrdiod" "spärrdioder" ;
  spaadomskonst_nn_1_1_N = mkN "spådomskonst" "spådomskonster" ;
  spaant_nn_1_1_N = mkN "spånt" "spånter" ;
  spoekfigur_nn_1_1_N = mkN "spökfigur" "spökfigurer" ;
  squash_nn_2_N = mkN "squash" "squasher" ;
  srilankes_nn_1_N = mkN "srilankes" "srilankeser" ;
  stabilisator_nn_1_N = mkN "stabilisator" "stabilisatorer" ;
  stadsplan_nn_1_N = mkN "stadsplan" "stadsplaner" ;
  staffagefigur_nn_1_N = mkN "staffagefigur" "staffagefigurer" ;
  stalagmit_nn_1_N = mkN "stalagmit" "stalagmiter" ;
  stalaktit_nn_1_N = mkN "stalaktit" "stalaktiter" ;
  stalinism_nn_1_N = mkN "stalinism" "stalinismer" ;
  stalinist_nn_1_N = mkN "stalinist" "stalinister" ;
  stambok_nn_1_N = mkN "stambok" "stamböcker" ;
  stamgaest_nn_1_1_N = mkN "stamgäst" "stamgäster" ;
  stand_in_nn_1_N = mkN "stand-in" "stand-iner" ;
  standardingrediens_nn_1_N = mkN "standardingrediens" "standardingredienser" ;
  stans_nn_2_N = mkN "stans" "stanser" ;
  stapelplats_nn_1_N = mkN "stapelplats" "stapelplatser" ;
  startgenerator_nn_1_N = mkN "startgenerator" "startgeneratorer" ;
  startmotor_nn_1_N = mkN "startmotor" "startmotorer" ;
  startpistol_nn_1_N = mkN "startpistol" "startpistoler" ;
  stas_nn_1_N = mkN "stas" "staser" ;
  stationsinspektor_nn_1_N = mkN "stationsinspektor" "stationsinspektorer" ;
  statist_nn_1_N = mkN "statist" "statister" ;
  stativ_nn_2_N = mkN "stativ" "stativer" ;
  stator_nn_1_N = mkN "stator" "statorer" ;
  statsepidemolog_nn_1_N = mkN "statsepidemolog" "statsepidemologer" ;
  statsgeolog_nn_1_N = mkN "statsgeolog" "statsgeologer" ;
  statsrevisor_nn_1_N = mkN "statsrevisor" "statsrevisorer" ;
  statsraadslunch_nn_1_1_N = mkN "statsrådslunch" "statsrådsluncher" ;
  statur_nn_1_N = mkN "statur" "staturer" ;
  statussymbol_nn_1_N = mkN "statussymbol" "statussymboler" ;
  statut_nn_1_N = mkN "statut" "statuter" ;
  staty_nn_1_N = mkN "staty" "statyer" ;
  steglits_nn_1_N = mkN "steglits" "steglitser" ;
  stenos_nn_1_N = mkN "stenos" "stenoser" ;
  stentorsroest_nn_1_1_N = mkN "stentorsröst" "stentorsröster" ;
  stenaaldersnivaa_nn_1_1_N = mkN "stenåldersnivå" "stenåldersnivåer" ;
  steradian_nn_1_N = mkN "steradian" "steradianer" ;
  stereotyp_nn_1_N = mkN "stereotyp" "stereotyper" ;
  sterin_nn_1_N = mkN "sterin" "steriner" ;
  steroid_nn_1_N = mkN "steroid" "steroider" ;
  sterol_nn_1_N = mkN "sterol" "steroler" ;
  stilfigur_nn_1_N = mkN "stilfigur" "stilfigurer" ;
  stilikon_nn_1_N = mkN "stilikon" "stilikoner" ;
  stilist_nn_1_N = mkN "stilist" "stilister" ;
  stilkonsekvens_nn_1_N = mkN "stilkonsekvens" "stilkonsekvenser" ;
  stimulans_nn_1_N = mkN "stimulans" "stimulanser" ;
  stimulator_nn_1_N = mkN "stimulator" "stimulatorer" ;
  stirlingmotor_nn_1_N = mkN "stirlingmotor" "stirlingmotorer" ;
  stjaernfigur_nn_1_1_N = mkN "stjärnfigur" "stjärnfigurer" ;
  stjaernjurist_nn_1_1_N = mkN "stjärnjurist" "stjärnjurister" ;
  stjaernmotor_nn_1_1_N = mkN "stjärnmotor" "stjärnmotorer" ;
  stod_nn_1_N = mkN "stod" "stoder" ;
  stofil_nn_1_N = mkN "stofil" "stofiler" ;
  stoicism_nn_1_N = mkN "stoicism" "stoicismer" ;
  stomatit_nn_1_N = mkN "stomatit" "stomatiter" ;
  stoppsignal_nn_1_N = mkN "stoppsignal" "stoppsignaler" ;
  storasysterattityd_nn_1_N = mkN "storasysterattityd" "storasysterattityder" ;
  stordator_nn_1_N = mkN "stordator" "stordatorer" ;
  stordonator_nn_1_N = mkN "stordonator" "stordonatorer" ;
  storfavorit_nn_1_N = mkN "storfavorit" "storfavoriter" ;
  stormast_nn_1_N = mkN "stormast" "stormaster" ;
  storoffensiv_nn_1_N = mkN "storoffensiv" "storoffensiver" ;
  storstrejk_nn_1_N = mkN "storstrejk" "storstrejker" ;
  storvinst_nn_1_N = mkN "storvinst" "storvinster" ;
  story_nn_1_N = mkN "story" "storyer" ;
  strabism_nn_1_N = mkN "strabism" "strabismer" ;
  straffnivaa_nn_1_1_N = mkN "straffnivå" "straffnivåer" ;
  strandfavorit_nn_1_N = mkN "strandfavorit" "strandfavoriter" ;
  strandrestaurang_nn_1_N = mkN "strandrestaurang" "strandrestauranger" ;
  strandvaext_nn_1_1_N = mkN "strandväxt" "strandväxter" ;
  strapats_nn_1_N = mkN "strapats" "strapatser" ;
  strateg_nn_1_N = mkN "strateg" "strateger" ;
  stridsgas_nn_1_N = mkN "stridsgas" "stridsgaser" ;
  stridsplats_nn_1_N = mkN "stridsplats" "stridsplatser" ;
  strokekris_nn_1_N = mkN "strokekris" "strokekriser" ;
  struktur_nn_1_N = mkN "struktur" "strukturer" ;
  strukturalism_nn_1_N = mkN "strukturalism" "strukturalismer" ;
  strukturalist_nn_1_N = mkN "strukturalist" "strukturalister" ;
  strupkatarr_nn_1_N = mkN "strupkatarr" "strupkatarrer" ;
  stryknindos_nn_1_N = mkN "stryknindos" "stryknindoser" ;
  straaldos_nn_1_1_N = mkN "stråldos" "stråldoser" ;
  straalningsdos_nn_1_1_N = mkN "strålningsdos" "strålningsdoser" ;
  straalningskommitt_e_nn_1_1_N = mkN "strålningskommitté" "strålningskommittéer" ;
  straalrisk_nn_1_1_N = mkN "strålrisk" "strålrisker" ;
  stroekurs_nn_1_1_N = mkN "strökurs" "strökurser" ;
  stroemmingsfil_e_nn_1_1_N = mkN "strömmingsfilé" "strömmingsfiléer" ;
  stubin_nn_1_N = mkN "stubin" "stubiner" ;
  stuckatur_nn_1_N = mkN "stuckatur" "stuckaturer" ;
  studieplats_nn_1_N = mkN "studieplats" "studieplatser" ;
  studierektor_nn_1_N = mkN "studierektor" "studierektorer" ;
  stylit_nn_1_N = mkN "stylit" "styliter" ;
  styrelsepost_nn_1_N = mkN "styrelsepost" "styrelseposter" ;
  styrsignal_nn_1_N = mkN "styrsignal" "styrsignaler" ;
  staepp_nn_1_1_N = mkN "stäpp" "stäpper" ;
  staeppnomad_nn_1_1_N = mkN "stäppnomad" "stäppnomader" ;
  staaplats_nn_1_1_N = mkN "ståplats" "ståplatser" ;
  stoedfestival_nn_1_1_N = mkN "stödfestival" "stödfestivaler" ;
  stoedinsats_nn_1_1_N = mkN "stödinsats" "stödinsatser" ;
  stoeld_nn_1_1_N = mkN "stöld" "stölder" ;
  stoeldturn_e_nn_1_1_N = mkN "stöldturné" "stöldturnéer" ;
  stoevlett_nn_1_1_N = mkN "stövlett" "stövletter" ;
  subdominant_nn_1_N = mkN "subdominant" "subdominanter" ;
  subjektivism_nn_1_N = mkN "subjektivism" "subjektivismer" ;
  subkultur_nn_1_N = mkN "subkultur" "subkulturer" ;
  substans_nn_1_N = mkN "substans" "substanser" ;
  succe_es_nn_1_1_N = mkN "succeés" "succeéser" ;
  succ_e_nn_1_1_N = mkN "succé" "succéer" ;
  suckulent_nn_1_N = mkN "suckulent" "suckulenter" ;
  sudanes_nn_1_N = mkN "sudanes" "sudaneser" ;
  suffl_e_nn_1_1_N = mkN "sufflé" "suffléer" ;
  suffloes_nn_1_1_N = mkN "sufflös" "sufflöser" ;
  sugfas_nn_1_N = mkN "sugfas" "sugfaser" ;
  suicidrisk_nn_1_N = mkN "suicidrisk" "suicidrisker" ;
  sulfid_nn_1_N = mkN "sulfid" "sulfider" ;
  sulky_nn_1_N = mkN "sulky" "sulkyer" ;
  sultan_nn_1_N = mkN "sultan" "sultaner" ;
  sumer_nn_1_N = mkN "sumer" "sumerer" ;
  sunnimuslim_nn_1_N = mkN "sunnimuslim" "sunnimuslimer" ;
  sunnit_nn_1_N = mkN "sunnit" "sunniter" ;
  superdator_nn_1_N = mkN "superdator" "superdatorer" ;
  superegoism_nn_1_N = mkN "superegoism" "superegoismer" ;
  superellips_nn_1_N = mkN "superellips" "superellipser" ;
  superlativ_nn_1_N = mkN "superlativ" "superlativer" ;
  supermatch_nn_1_N = mkN "supermatch" "supermatcher" ;
  supervinst_nn_1_N = mkN "supervinst" "supervinster" ;
  suppleant_nn_1_N = mkN "suppleant" "suppleanter" ;
  supplikant_nn_1_N = mkN "supplikant" "supplikanter" ;
  supranaturalism_nn_1_N = mkN "supranaturalism" "supranaturalismer" ;
  suprematism_nn_1_N = mkN "suprematism" "suprematismer" ;
  sup_e_nn_1_1_N = mkN "supé" "supéer" ;
  surinames_nn_1_N = mkN "surinames" "surinameser" ;
  surpris_nn_1_N = mkN "surpris" "surpriser" ;
  surrealism_nn_1_N = mkN "surrealism" "surrealismer" ;
  suspensoar_nn_1_N = mkN "suspensoar" "suspensoarer" ;
  sutan_nn_1_N = mkN "sutan" "sutaner" ;
  suterraeng_nn_1_1_N = mkN "suterräng" "suterränger" ;
  sutur_nn_1_N = mkN "sutur" "suturer" ;
  suveraen_nn_1_1_N = mkN "suverän" "suveräner" ;
  svajmast_nn_1_N = mkN "svajmast" "svajmaster" ;
  svampparasit_nn_1_N = mkN "svampparasit" "svampparasiter" ;
  svampvaext_nn_1_1_N = mkN "svampväxt" "svampväxter" ;
  svansmotor_nn_1_N = mkN "svansmotor" "svansmotorer" ;
  svartkonst_nn_1_N = mkN "svartkonst" "svartkonster" ;
  svartlistningsgraens_nn_1_1_N = mkN "svartlistningsgräns" "svartlistningsgränser" ;
  svavelpredikant_nn_1_N = mkN "svavelpredikant" "svavelpredikanter" ;
  svecism_nn_1_N = mkN "svecism" "svecismer" ;
  svekoman_nn_1_N = mkN "svekoman" "svekomaner" ;
  svenskamerikan_nn_1_N = mkN "svenskamerikan" "svenskamerikaner" ;
  svenskkurs_nn_1_N = mkN "svenskkurs" "svenskkurser" ;
  svetselektrod_nn_1_N = mkN "svetselektrod" "svetselektroder" ;
  svulst_nn_1_N = mkN "svulst" "svulster" ;
  svaeltkatastrof_nn_1_1_N = mkN "svältkatastrof" "svältkatastrofer" ;
  svaenghjulsmagnet_nn_1_1_N = mkN "svänghjulsmagnet" "svänghjulsmagneter" ;
  svaerdsdans_nn_1_1_N = mkN "svärdsdans" "svärdsdanser" ;
  svaevfarkost_nn_1_1_N = mkN "svävfarkost" "svävfarkoster" ;
  sybarit_nn_1_N = mkN "sybarit" "sybariter" ;
  sydafrikan_nn_1_N = mkN "sydafrikan" "sydafrikaner" ;
  sydjemenit_nn_1_N = mkN "sydjemenit" "sydjemeniter" ;
  sydkorean_nn_1_N = mkN "sydkorean" "sydkoreaner" ;
  sydkust_nn_1_N = mkN "sydkust" "sydkuster" ;
  sydyemenit_nn_1_N = mkN "sydyemenit" "sydyemeniter" ;
  sykofant_nn_1_N = mkN "sykofant" "sykofanter" ;
  sylfid_nn_1_N = mkN "sylfid" "sylfider" ;
  syllogism_nn_1_N = mkN "syllogism" "syllogismer" ;
  sylt_nn_1_N = mkN "sylt" "sylter" ;
  symbiont_nn_1_N = mkN "symbiont" "symbionter" ;
  symbol_nn_1_N = mkN "symbol" "symboler" ;
  symbolism_nn_1_N = mkN "symbolism" "symbolismer" ;
  symbolist_nn_1_N = mkN "symbolist" "symbolister" ;
  symbolsekvens_nn_1_N = mkN "symbolsekvens" "symbolsekvenser" ;
  symbolskatt_nn_1_N = mkN "symbolskatt" "symbolskatter" ;
  symfys_nn_1_N = mkN "symfys" "symfyser" ;
  sympatistrejk_nn_1_N = mkN "sympatistrejk" "sympatistrejker" ;
  syn_nn_1_N = mkN "syn" "syner" ;
  synaps_nn_1_N = mkN "synaps" "synapser" ;
  syndikalism_nn_1_N = mkN "syndikalism" "syndikalismer" ;
  syndikalist_nn_1_N = mkN "syndikalist" "syndikalister" ;
  synergism_nn_1_N = mkN "synergism" "synergismer" ;
  synklinal_nn_1_N = mkN "synklinal" "synklinaler" ;
  synkpuls_nn_1_N = mkN "synkpuls" "synkpulser" ;
  synkretism_nn_1_N = mkN "synkretism" "synkretismer" ;
  synkronism_nn_1_N = mkN "synkronism" "synkronismer" ;
  synkrotron_nn_1_N = mkN "synkrotron" "synkrotroner" ;
  synonym_nn_1_N = mkN "synonym" "synonymer" ;
  synonymordbok_nn_1_N = mkN "synonymordbok" "synonymordböcker" ;
  synops_nn_1_N = mkN "synops" "synopser" ;
  syntax_nn_1_N = mkN "syntax" "syntaxer" ;
  syntaxanalys_nn_1_N = mkN "syntaxanalys" "syntaxanalyser" ;
  syntes_nn_1_N = mkN "syntes" "synteser" ;
  syntet_nn_1_N = mkN "syntet" "synteter" ;
  syremolekyl_nn_1_N = mkN "syremolekyl" "syremolekyler" ;
  syrenbersaa_nn_1_1_N = mkN "syrenberså" "syrenbersåer" ;
  syretransport_nn_1_N = mkN "syretransport" "syretransporter" ;
  syrgasmask_nn_1_N = mkN "syrgasmask" "syrgasmasker" ;
  syrgasmolekyl_nn_1_N = mkN "syrgasmolekyl" "syrgasmolekyler" ;
  saekerhetskontroll_nn_1_1_N = mkN "säkerhetskontroll" "säkerhetskontroller" ;
  saekerhetspolis_nn_2_1_N = mkN "säkerhetspolis" "säkerhetspoliser" ;
  saekerhetsrisk_nn_1_1_N = mkN "säkerhetsrisk" "säkerhetsrisker" ;
  saellskapsdans_nn_1_1_N = mkN "sällskapsdans" "sällskapsdanser" ;
  saengkammarfars_nn_1_1_N = mkN "sängkammarfars" "sängkammarfarser" ;
  saerklass_nn_2_1_N = mkN "särklass" "särklasser" ;
  saadd_nn_1_1_N = mkN "sådd" "sådder" ;
  saang_nn_1_1_N = mkN "sång" "sånger" ;
  saangtext_nn_1_1_N = mkN "sångtext" "sångtexter" ;
  saas_nn_1_1_N = mkN "sås" "såser" ;
  saat_e_nn_1_1_N = mkN "såté" "såtéer" ;
  soekmotor_nn_1_1_N = mkN "sökmotor" "sökmotorer" ;
  soemnapn_e_nn_1_1_N = mkN "sömnapné" "sömnapnéer" ;
  soergaardsidyll_nn_1_1_N = mkN "sörgårdsidyll" "sörgårdsidyller" ;
  tabellskatt_nn_1_N = mkN "tabellskatt" "tabellskatter" ;
  tablett_nn_1_N = mkN "tablett" "tabletter" ;
  tabloid_nn_1_N = mkN "tabloid" "tabloider" ;
  tablaa_nn_1_1_N = mkN "tablå" "tablåer" ;
  tabugraens_nn_1_1_N = mkN "tabugräns" "tabugränser" ;
  tabulator_nn_1_N = mkN "tabulator" "tabulatorer" ;
  tabulatur_nn_1_N = mkN "tabulatur" "tabulaturer" ;
  tacksaegelsefest_nn_1_1_N = mkN "tacksägelsefest" "tacksägelsefester" ;
  tacksaegelsegudstjaenst_nn_1_1_N = mkN "tacksägelsegudstjänst" "tacksägelsegudstjänster" ;
  tadzjik_nn_1_N = mkN "tadzjik" "tadzjiker" ;
  tagelmadrass_nn_1_N = mkN "tagelmadrass" "tagelmadrasser" ;
  taiwanes_nn_1_N = mkN "taiwanes" "taiwaneser" ;
  takaltan_nn_1_N = mkN "takaltan" "takaltaner" ;
  takfris_nn_1_N = mkN "takfris" "takfriser" ;
  takgesims_nn_1_N = mkN "takgesims" "takgesimser" ;
  taklagsfest_nn_1_N = mkN "taklagsfest" "taklagsfester" ;
  taklist_nn_1_N = mkN "taklist" "taklister" ;
  takt_nn_1_N = mkN "takt" "takter" ;
  taktik_nn_1_N = mkN "taktik" "taktiker" ;
  talbok_nn_1_N = mkN "talbok" "talböcker" ;
  talesperson_nn_1_N = mkN "talesperson" "talespersoner" ;
  taliban_nn_1_N = mkN "taliban" "talibaner" ;
  talibanrebell_nn_1_N = mkN "talibanrebell" "talibanrebeller" ;
  talisman_nn_1_N = mkN "talisman" "talismaner" ;
  talmanskonferens_nn_1_N = mkN "talmanskonferens" "talmanskonferenser" ;
  talpjaes_nn_1_1_N = mkN "talpjäs" "talpjäser" ;
  tamarisk_nn_1_N = mkN "tamarisk" "tamarisker" ;
  tambur_nn_1_N = mkN "tambur" "tamburer" ;
  tamburin_nn_1_N = mkN "tamburin" "tamburiner" ;
  tamburmajor_nn_1_N = mkN "tamburmajor" "tamburmajorer" ;
  tamil_nn_1_N = mkN "tamil" "tamiler" ;
  tandhygienist_nn_1_N = mkN "tandhygienist" "tandhygienister" ;
  tandlist_nn_1_N = mkN "tandlist" "tandlister" ;
  tandprotes_nn_1_N = mkN "tandprotes" "tandproteser" ;
  tangakalsong_nn_1_N = mkN "tangakalsong" "tangakalsonger" ;
  tangerin_nn_1_N = mkN "tangerin" "tangeriner" ;
  tangokavaljer_nn_1_N = mkN "tangokavaljer" "tangokavaljerer" ;
  tankefigur_nn_1_N = mkN "tankefigur" "tankefigurer" ;
  tankenoet_nn_1_1_N = mkN "tankenöt" "tankenötter" ;
  tankvolym_nn_1_N = mkN "tankvolym" "tankvolymer" ;
  taoism_nn_1_N = mkN "taoism" "taoismer" ;
  taoist_nn_1_N = mkN "taoist" "taoister" ;
  tapir_nn_1_N = mkN "tapir" "tapirer" ;
  tappt_nn_1_N = mkN "tappt" "tappter" ;
  tarmgas_nn_1_N = mkN "tarmgas" "tarmgaser" ;
  tarmkatarr_nn_1_N = mkN "tarmkatarr" "tarmkatarrer" ;
  tars_nn_1_N = mkN "tars" "tarser" ;
  tatar_nn_1_N = mkN "tatar" "tatarer" ;
  taxichauffoer_nn_1_1_N = mkN "taxichaufför" "taxichaufförer" ;
  teaterdirektoer_nn_1_1_N = mkN "teaterdirektör" "teaterdirektörer" ;
  teaterfigur_nn_1_N = mkN "teaterfigur" "teaterfigurer" ;
  teaterfoaj_e_nn_1_1_N = mkN "teaterfoajé" "teaterfoajéer" ;
  teatermaskinist_nn_1_N = mkN "teatermaskinist" "teatermaskinister" ;
  teaterpjaes_nn_1_1_N = mkN "teaterpjäs" "teaterpjäser" ;
  tegelstensroman_nn_1_N = mkN "tegelstensroman" "tegelstensromaner" ;
  teism_nn_1_N = mkN "teism" "teismer" ;
  teknik_nn_1_N = mkN "teknik" "tekniker" ;
  teknikbransch_nn_1_N = mkN "teknikbransch" "teknikbranscher" ;
  teknikjournalist_nn_1_N = mkN "teknikjournalist" "teknikjournalister" ;
  teknolog_nn_1_N = mkN "teknolog" "teknologer" ;
  telefon_nn_1_N = mkN "telefon" "telefoner" ;
  telefonist_nn_1_N = mkN "telefonist" "telefonister" ;
  telefonkiosk_nn_1_N = mkN "telefonkiosk" "telefonkiosker" ;
  telefonkonferens_nn_1_N = mkN "telefonkonferens" "telefonkonferenser" ;
  telefonsignal_nn_1_N = mkN "telefonsignal" "telefonsignaler" ;
  telegraf_nn_1_N = mkN "telegraf" "telegrafer" ;
  telegrafist_nn_1_N = mkN "telegrafist" "telegrafister" ;
  telegramadress_nn_1_N = mkN "telegramadress" "telegramadresser" ;
  telegrambyraa_nn_1_1_N = mkN "telegrambyrå" "telegrambyråer" ;
  telesatellit_nn_1_N = mkN "telesatellit" "telesatelliter" ;
  temperatur_nn_1_N = mkN "temperatur" "temperaturer" ;
  temperaturregulator_nn_1_N = mkN "temperaturregulator" "temperaturregulatorer" ;
  tendens_nn_1_N = mkN "tendens" "tendenser" ;
  tennisjournalist_nn_1_N = mkN "tennisjournalist" "tennisjournalister" ;
  tenorbaryton_nn_1_N = mkN "tenorbaryton" "tenorbarytoner" ;
  tenorsaxofon_nn_1_N = mkN "tenorsaxofon" "tenorsaxofoner" ;
  tensid_nn_1_N = mkN "tensid" "tensider" ;
  tentamensbok_nn_1_N = mkN "tentamensbok" "tentamensböcker" ;
  tentator_nn_1_N = mkN "tentator" "tentatorer" ;
  teodolit_nn_1_N = mkN "teodolit" "teodoliter" ;
  teolog_nn_1_N = mkN "teolog" "teologer" ;
  terass_nn_1_N = mkN "terass" "terasser" ;
  terminal_nn_1_N = mkN "terminal" "terminaler" ;
  terminolog_nn_1_N = mkN "terminolog" "terminologer" ;
  termistor_nn_1_N = mkN "termistor" "termistorer" ;
  termit_nn_1_N = mkN "termit" "termiter" ;
  termoplast_nn_1_N = mkN "termoplast" "termoplaster" ;
  termoregulator_nn_1_N = mkN "termoregulator" "termoregulatorer" ;
  terrakottasoldat_nn_1_N = mkN "terrakottasoldat" "terrakottasoldater" ;
  terrass_nn_1_N = mkN "terrass" "terrasser" ;
  terrin_nn_1_N = mkN "terrin" "terriner" ;
  territorialgraens_nn_1_1_N = mkN "territorialgräns" "territorialgränser" ;
  terrorism_nn_1_N = mkN "terrorism" "terrorismer" ;
  terrorist_nn_1_N = mkN "terrorist" "terrorister" ;
  terrorplan_nn_1_N = mkN "terrorplan" "terrorplaner" ;
  terraengfoerlust_nn_1_1_N = mkN "terrängförlust" "terrängförluster" ;
  terraengvinst_nn_1_1_N = mkN "terrängvinst" "terrängvinster" ;
  ters_nn_1_N = mkN "ters" "terser" ;
  terzin_nn_1_N = mkN "terzin" "terziner" ;
  tes_nn_1_N = mkN "tes" "teser" ;
  testamentsexekutor_nn_1_N = mkN "testamentsexekutor" "testamentsexekutorer" ;
  testator_nn_1_N = mkN "testator" "testatorer" ;
  testreaktor_nn_1_N = mkN "testreaktor" "testreaktorer" ;
  tetragon_nn_1_N = mkN "tetragon" "tetragoner" ;
  tetraklorid_nn_1_N = mkN "tetraklorid" "tetraklorider" ;
  tetrapod_nn_1_N = mkN "tetrapod" "tetrapoder" ;
  teuton_nn_1_N = mkN "teuton" "teutoner" ;
  teve_evangelist_nn_1_N = mkN "teve-evangelist" "teve-evangelister" ;
  teveevangelist_nn_1_N = mkN "teveevangelist" "teveevangelister" ;
  tevekonferens_nn_1_N = mkN "tevekonferens" "tevekonferenser" ;
  tevemast_nn_1_N = mkN "tevemast" "tevemaster" ;
  tevepredikant_nn_1_N = mkN "tevepredikant" "tevepredikanter" ;
  teveproducent_nn_1_N = mkN "teveproducent" "teveproducenter" ;
  teveprofil_nn_1_N = mkN "teveprofil" "teveprofiler" ;
  tevesignal_nn_1_N = mkN "tevesignal" "tevesignaler" ;
  textbok_nn_1_N = mkN "textbok" "textböcker" ;
  textfoerlust_nn_1_1_N = mkN "textförlust" "textförluster" ;
  textil_nn_1_N = mkN "textil" "textiler" ;
  textilkurs_nn_1_N = mkN "textilkurs" "textilkurser" ;
  textur_nn_1_N = mkN "textur" "texturer" ;
  thairestaurang_nn_1_N = mkN "thairestaurang" "thairestauranger" ;
  tiamin_nn_1_N = mkN "tiamin" "tiaminer" ;
  tibetan_nn_1_N = mkN "tibetan" "tibetaner" ;
  tidebok_nn_1_N = mkN "tidebok" "tideböcker" ;
  tidningskiosk_nn_1_N = mkN "tidningskiosk" "tidningskiosker" ;
  tidningsnotis_nn_1_N = mkN "tidningsnotis" "tidningsnotiser" ;
  tidsfaktor_nn_1_N = mkN "tidsfaktor" "tidsfaktorer" ;
  tidsfrist_nn_1_N = mkN "tidsfrist" "tidsfrister" ;
  tidsfoerlust_nn_1_1_N = mkN "tidsförlust" "tidsförluster" ;
  tidsgraens_nn_1_1_N = mkN "tidsgräns" "tidsgränser" ;
  tidsplan_nn_1_N = mkN "tidsplan" "tidsplaner" ;
  tidssignal_nn_1_N = mkN "tidssignal" "tidssignaler" ;
  tidsvinst_nn_1_N = mkN "tidsvinst" "tidsvinster" ;
  tillsats_nn_1_N = mkN "tillsats" "tillsatser" ;
  tillsatslins_nn_1_N = mkN "tillsatslins" "tillsatslinser" ;
  tillverkningsprocess_nn_1_N = mkN "tillverkningsprocess" "tillverkningsprocesser" ;
  tillvaextprognos_nn_1_1_N = mkN "tillväxtprognos" "tillväxtprognoser" ;
  tillaeggsplats_nn_1_1_N = mkN "tilläggsplats" "tilläggsplatser" ;
  timbal_nn_1_N = mkN "timbal" "timbaler" ;
  tinktur_nn_1_N = mkN "tinktur" "tinkturer" ;
  tiominutersrast_nn_1_N = mkN "tiominutersrast" "tiominutersraster" ;
  tiotalism_nn_1_N = mkN "tiotalism" "tiotalismer" ;
  tiotalist_nn_1_N = mkN "tiotalist" "tiotalister" ;
  tirad_nn_1_N = mkN "tirad" "tirader" ;
  titan_nn_1_N = mkN "titan" "titaner" ;
  titelmatch_nn_1_N = mkN "titelmatch" "titelmatcher" ;
  tittarsucc_e_nn_1_1_N = mkN "tittarsuccé" "tittarsuccéer" ;
  titulatur_nn_1_N = mkN "titulatur" "titulaturer" ;
  tjeck_nn_1_N = mkN "tjeck" "tjecker" ;
  tjejbacill_nn_1_N = mkN "tjejbacill" "tjejbaciller" ;
  tjejmagnet_nn_1_N = mkN "tjejmagnet" "tjejmagneter" ;
  tjetjen_nn_1_N = mkN "tjetjen" "tjetjener" ;
  tjurfaektningssaesong_nn_1_1_N = mkN "tjurfäktningssäsong" "tjurfäktningssäsonger" ;
  tjaenst_nn_1_1_N = mkN "tjänst" "tjänster" ;
  tjaenst_nn_2_1_N = mkN "tjänst" "tjänster" ;
  tjaenstesektor_nn_1_1_N = mkN "tjänstesektor" "tjänstesektorer" ;
  toalett_nn_1_N = mkN "toalett" "toaletter" ;
  tobakist_nn_1_N = mkN "tobakist" "tobakister" ;
  tobakskiosk_nn_1_N = mkN "tobakskiosk" "tobakskiosker" ;
  togoles_nn_1_N = mkN "togoles" "togoleser" ;
  tolerans_nn_1_N = mkN "tolerans" "toleranser" ;
  tolvmilsgraens_nn_1_1_N = mkN "tolvmilsgräns" "tolvmilsgränser" ;
  tomahawk_nn_1_N = mkN "tomahawk" "tomahawker" ;
  tomahaak_nn_1_1_N = mkN "tomahåk" "tomahåker" ;
  tomtemask_nn_1_N = mkN "tomtemask" "tomtemasker" ;
  tomtgraens_nn_1_1_N = mkN "tomtgräns" "tomtgränser" ;
  ton_nn_1_N = mkN "ton" "toner" ;
  tongan_nn_1_N = mkN "tongan" "tonganer" ;
  tonsur_nn_1_N = mkN "tonsur" "tonsurer" ;
  tonaarsabort_nn_1_1_N = mkN "tonårsabort" "tonårsaborter" ;
  tonaarsidol_nn_1_1_N = mkN "tonårsidol" "tonårsidoler" ;
  topas_nn_1_N = mkN "topas" "topaser" ;
  toppdomaen_nn_1_1_N = mkN "toppdomän" "toppdomäner" ;
  toppkonferens_nn_1_N = mkN "toppkonferens" "toppkonferenser" ;
  toppmast_nn_1_N = mkN "toppmast" "toppmaster" ;
  toppnivaa_nn_1_1_N = mkN "toppnivå" "toppnivåer" ;
  toppost_nn_1_N = mkN "toppost" "topposter" ;
  tordoensroest_nn_1_1_N = mkN "tordönsröst" "tordönsröster" ;
  torkcentrifug_nn_1_N = mkN "torkcentrifug" "torkcentrifuger" ;
  torkkatastrof_nn_1_N = mkN "torkkatastrof" "torkkatastrofer" ;
  tortyr_nn_1_N = mkN "tortyr" "tortyrer" ;
  tosk_nn_1_N = mkN "tosk" "tosker" ;
  totalisator_nn_1_N = mkN "totalisator" "totalisatorer" ;
  totalitarism_nn_1_N = mkN "totalitarism" "totalitarismer" ;
  totemism_nn_1_N = mkN "totemism" "totemismer" ;
  toup_e_nn_1_1_N = mkN "toupé" "toupéer" ;
  tour_nn_1_N = mkN "tour" "tourer" ;
  tournedos_nn_1_N = mkN "tournedos" "tournedoser" ;
  toxikolog_nn_1_N = mkN "toxikolog" "toxikologer" ;
  trad_nn_1_N = mkN "trad" "trader" ;
  traditionalism_nn_1_N = mkN "traditionalism" "traditionalismer" ;
  traditionalist_nn_1_N = mkN "traditionalist" "traditionalister" ;
  trafikant_nn_1_N = mkN "trafikant" "trafikanter" ;
  trafikexpert_nn_1_N = mkN "trafikexpert" "trafikexperter" ;
  trafikkontroll_nn_1_N = mkN "trafikkontroll" "trafikkontroller" ;
  trafikplats_nn_1_N = mkN "trafikplats" "trafikplatser" ;
  trafiksignal_nn_1_N = mkN "trafiksignal" "trafiksignaler" ;
  trakt_nn_1_N = mkN "trakt" "trakter" ;
  traktor_nn_1_N = mkN "traktor" "traktorer" ;
  traktur_nn_1_N = mkN "traktur" "trakturer" ;
  trak_e_nn_1_1_N = mkN "traké" "trakéer" ;
  trampolin_nn_1_N = mkN "trampolin" "trampoliner" ;
  tranch_nn_1_N = mkN "tranch" "trancher" ;
  transaktionsanalys_nn_1_N = mkN "transaktionsanalys" "transaktionsanalyser" ;
  transduktor_nn_1_N = mkN "transduktor" "transduktorer" ;
  transformator_nn_1_N = mkN "transformator" "transformatorer" ;
  transistor_nn_1_N = mkN "transistor" "transistorer" ;
  transitlast_nn_1_N = mkN "transitlast" "transitlaster" ;
  translativ_nn_1_N = mkN "translativ" "translativer" ;
  translator_nn_1_N = mkN "translator" "translatorer" ;
  transport_nn_1_N = mkN "transport" "transporter" ;
  transportmekanism_nn_1_N = mkN "transportmekanism" "transportmekanismer" ;
  transportprocess_nn_1_N = mkN "transportprocess" "transportprocesser" ;
  transversal_nn_1_N = mkN "transversal" "transversaler" ;
  transvestism_nn_1_N = mkN "transvestism" "transvestismer" ;
  transvestit_nn_1_N = mkN "transvestit" "transvestiter" ;
  transvestitism_nn_1_N = mkN "transvestitism" "transvestitismer" ;
  trapets_nn_1_N = mkN "trapets" "trapetser" ;
  trapetsoid_nn_1_N = mkN "trapetsoid" "trapetsoider" ;
  trappavsats_nn_1_N = mkN "trappavsats" "trappavsatser" ;
  trattkantarell_nn_1_N = mkN "trattkantarell" "trattkantareller" ;
  travers_nn_1_N = mkN "travers" "traverser" ;
  travsulky_nn_1_N = mkN "travsulky" "travsulkyer" ;
  trebetygskurs_nn_1_N = mkN "trebetygskurs" "trebetygskurser" ;
  tredagarskonferens_nn_1_N = mkN "tredagarskonferens" "tredagarskonferenser" ;
  tredjeplats_nn_1_N = mkN "tredjeplats" "tredjeplatser" ;
  tremilsgraens_nn_1_1_N = mkN "tremilsgräns" "tremilsgränser" ;
  tremulant_nn_1_N = mkN "tremulant" "tremulanter" ;
  trendanalys_nn_1_N = mkN "trendanalys" "trendanalyser" ;
  trepan_nn_1_N = mkN "trepan" "trepaner" ;
  treraettersmeny_nn_1_1_N = mkN "trerättersmeny" "trerättersmenyer" ;
  triangelmatch_nn_1_N = mkN "triangelmatch" "triangelmatcher" ;
  triangelreflex_nn_1_N = mkN "triangelreflex" "triangelreflexer" ;
  tribadism_nn_1_N = mkN "tribadism" "tribadismer" ;
  tribalism_nn_1_N = mkN "tribalism" "tribalismer" ;
  trikin_nn_1_N = mkN "trikin" "trikiner" ;
  trikaa_nn_1_1_N = mkN "trikå" "trikåer" ;
  triljon_nn_1_N = mkN "triljon" "triljoner" ;
  trillingkristall_nn_1_N = mkN "trillingkristall" "trillingkristaller" ;
  trillion_nn_1_N = mkN "trillion" "trillioner" ;
  trilobit_nn_1_N = mkN "trilobit" "trilobiter" ;
  triol_nn_1_N = mkN "triol" "trioler" ;
  triplett_nn_1_N = mkN "triplett" "tripletter" ;
  trippelallians_nn_1_N = mkN "trippelallians" "trippelallianser" ;
  trirem_nn_1_N = mkN "trirem" "triremer" ;
  triton_nn_1_N = mkN "triton" "tritoner" ;
  triumfator_nn_1_N = mkN "triumfator" "triumfatorer" ;
  trivselfaktor_nn_1_N = mkN "trivselfaktor" "trivselfaktorer" ;
  trioer_nn_1_1_N = mkN "triör" "triörer" ;
  trof_e_nn_1_1_N = mkN "trofé" "troféer" ;
  trojan_nn_1_N = mkN "trojan" "trojaner" ;
  trok_e_nn_1_1_N = mkN "troké" "trokéer" ;
  trolldomsrit_nn_1_N = mkN "trolldomsrit" "trolldomsriter" ;
  trollerikonst_nn_1_N = mkN "trollerikonst" "trollerikonster" ;
  trollkonst_nn_1_N = mkN "trollkonst" "trollkonster" ;
  trombon_nn_1_N = mkN "trombon" "tromboner" ;
  trombonist_nn_1_N = mkN "trombonist" "trombonister" ;
  trombos_nn_1_N = mkN "trombos" "tromboser" ;
  tron_nn_1_N = mkN "tron" "troner" ;
  tropism_nn_1_N = mkN "tropism" "tropismer" ;
  trossats_nn_1_N = mkN "trossats" "trossatser" ;
  trotskism_nn_1_N = mkN "trotskism" "trotskismer" ;
  trotskist_nn_1_N = mkN "trotskist" "trotskister" ;
  trubadur_nn_1_N = mkN "trubadur" "trubadurer" ;
  truism_nn_1_N = mkN "truism" "truismer" ;
  trumpet_nn_1_N = mkN "trumpet" "trumpeter" ;
  trumpetsignal_nn_1_N = mkN "trumpetsignal" "trumpetsignaler" ;
  trumrytm_nn_1_N = mkN "trumrytm" "trumrytmer" ;
  trupptransport_nn_1_N = mkN "trupptransport" "trupptransporter" ;
  trust_nn_1_N = mkN "trust" "truster" ;
  tryckkabin_nn_1_N = mkN "tryckkabin" "tryckkabiner" ;
  trycksats_nn_1_N = mkN "trycksats" "trycksatser" ;
  tryckvattenreaktor_nn_1_N = mkN "tryckvattenreaktor" "tryckvattenreaktorer" ;
  tryckvattensreaktor_nn_1_N = mkN "tryckvattensreaktor" "tryckvattensreaktorer" ;
  trygghetsnarkoman_nn_1_N = mkN "trygghetsnarkoman" "trygghetsnarkomaner" ;
  trymaa_nn_1_1_N = mkN "trymå" "trymåer" ;
  traedgraens_nn_1_1_N = mkN "trädgräns" "trädgränser" ;
  traedgaardsexpert_nn_1_1_N = mkN "trädgårdsexpert" "trädgårdsexperter" ;
  traedgaardstraktor_nn_1_1_N = mkN "trädgårdstraktor" "trädgårdstraktorer" ;
  traedstruktur_nn_1_1_N = mkN "trädstruktur" "trädstrukturer" ;
  traengselskatt_nn_1_1_N = mkN "trängselskatt" "trängselskatter" ;
  traeningsoverall_nn_1_1_N = mkN "träningsoverall" "träningsoveraller" ;
  traeskodans_nn_1_1_N = mkN "träskodans" "träskodanser" ;
  tsarregim_nn_1_N = mkN "tsarregim" "tsarregimer" ;
  tsunamikatastrof_nn_1_N = mkN "tsunamikatastrof" "tsunamikatastrofer" ;
  tuff_nn_1_N = mkN "tuff" "tuffer" ;
  tukan_nn_1_N = mkN "tukan" "tukaner" ;
  tullkontroll_nn_1_N = mkN "tullkontroll" "tullkontroller" ;
  tulpan_nn_1_N = mkN "tulpan" "tulpaner" ;
  tummelplats_nn_1_N = mkN "tummelplats" "tummelplatser" ;
  tungus_nn_1_N = mkN "tungus" "tunguser" ;
  tungvattenreaktor_nn_1_N = mkN "tungvattenreaktor" "tungvattenreaktorer" ;
  tunnelbanekiosk_nn_1_N = mkN "tunnelbanekiosk" "tunnelbanekiosker" ;
  tunneldiod_nn_1_N = mkN "tunneldiod" "tunneldioder" ;
  tup_e_nn_1_1_N = mkN "tupé" "tupéer" ;
  tur_nn_1_N = mkN "tur" "turer" ;
  turban_nn_1_N = mkN "turban" "turbaner" ;
  turbin_nn_1_N = mkN "turbin" "turbiner" ;
  turbinmotor_nn_1_N = mkN "turbinmotor" "turbinmotorer" ;
  turbojetmotor_nn_1_N = mkN "turbojetmotor" "turbojetmotorer" ;
  turbomotor_nn_1_N = mkN "turbomotor" "turbomotorer" ;
  turbopropmotor_nn_1_N = mkN "turbopropmotor" "turbopropmotorer" ;
  turism_nn_1_N = mkN "turism" "turismer" ;
  turist_nn_1_N = mkN "turist" "turister" ;
  turistbroschyr_nn_1_N = mkN "turistbroschyr" "turistbroschyrer" ;
  turistbyraa_nn_1_1_N = mkN "turistbyrå" "turistbyråer" ;
  turisthandbok_nn_1_N = mkN "turisthandbok" "turisthandböcker" ;
  turistklass_nn_1_N = mkN "turistklass" "turistklasser" ;
  turkmen_nn_1_N = mkN "turkmen" "turkmener" ;
  turkos_nn_1_N = mkN "turkos" "turkoser" ;
  turmalin_nn_1_N = mkN "turmalin" "turmaliner" ;
  turn_e_nn_1_1_N = mkN "turné" "turnéer" ;
  tuvaluan_nn_1_N = mkN "tuvaluan" "tuvaluaner" ;
  tv_evangelist_nn_1_N = mkN "tv-evangelist" "tv-evangelister" ;
  tv_konferens_nn_1_N = mkN "tv-konferens" "tv-konferenser" ;
  tv_predikant_nn_1_N = mkN "tv-predikant" "tv-predikanter" ;
  tv_producent_nn_1_N = mkN "tv-producent" "tv-producenter" ;
  tv_tablaa_nn_1_1_N = mkN "tv-tablå" "tv-tablåer" ;
  tvillingkristall_nn_1_N = mkN "tvillingkristall" "tvillingkristaller" ;
  tvist_nn_1_N = mkN "tvist" "tvister" ;
  tvaangsneuros_nn_1_1_N = mkN "tvångsneuros" "tvångsneuroser" ;
  tvaataktsmotor_nn_1_1_N = mkN "tvåtaktsmotor" "tvåtaktsmotorer" ;
  tweedkavaj_nn_1_N = mkN "tweedkavaj" "tweedkavajer" ;
  tyfon_nn_1_N = mkN "tyfon" "tyfoner" ;
  tygrest_nn_1_N = mkN "tygrest" "tygrester" ;
  tympanon_nn_1_N = mkN "tympanon" "tympanoner" ;
  tyngd_nn_1_N = mkN "tyngd" "tyngder" ;
  typograf_nn_1_N = mkN "typograf" "typografer" ;
  tyrann_nn_1_N = mkN "tyrann" "tyranner" ;
  tyristor_nn_1_N = mkN "tyristor" "tyristorer" ;
  tyskkurs_nn_1_N = mkN "tyskkurs" "tyskkurser" ;
  taeckadress_nn_1_1_N = mkN "täckadress" "täckadresser" ;
  taeljstenskamin_nn_1_1_N = mkN "täljstenskamin" "täljstenskaminer" ;
  taendkulemotor_nn_1_1_N = mkN "tändkulemotor" "tändkulemotorer" ;
  taendsats_nn_1_1_N = mkN "tändsats" "tändsatser" ;
  taenkebok_nn_1_1_N = mkN "tänkebok" "tänkeböcker" ;
  taetataet_nn_1_1_N = mkN "tätatät" "tätatäter" ;
  taetningslist_nn_1_1_N = mkN "tätningslist" "tätningslister" ;
  taetplats_nn_1_1_N = mkN "tätplats" "tätplatser" ;
  taevlingscyklist_nn_1_1_N = mkN "tävlingscyklist" "tävlingscyklister" ;
  taevlingsjury_nn_1_1_N = mkN "tävlingsjury" "tävlingsjuryer" ;
  taevlingsklass_nn_1_1_N = mkN "tävlingsklass" "tävlingsklasser" ;
  taagankomst_nn_1_1_N = mkN "tågankomst" "tågankomster" ;
  taagkup_e_nn_1_1_N = mkN "tågkupé" "tågkupéer" ;
  taagtransport_nn_1_1_N = mkN "tågtransport" "tågtransporter" ;
  toes_nn_1_1_N = mkN "tös" "töser" ;
  ubikvist_nn_1_N = mkN "ubikvist" "ubikvister" ;
  ukas_nn_1_N = mkN "ukas" "ukaser" ;
  ulan_nn_1_N = mkN "ulan" "ulaner" ;
  ultracentrifug_nn_1_N = mkN "ultracentrifug" "ultracentrifuger" ;
  ultramontanism_nn_1_N = mkN "ultramontanism" "ultramontanismer" ;
  ultranationalist_nn_1_N = mkN "ultranationalist" "ultranationalister" ;
  umbellat_nn_1_N = mkN "umbellat" "umbellater" ;
  undergaangsspekulant_nn_1_1_N = mkN "undergångsspekulant" "undergångsspekulanter" ;
  underhaallskolonn_nn_1_1_N = mkN "underhållskolonn" "underhållskolonner" ;
  underhaallstjaenst_nn_1_1_N = mkN "underhållstjänst" "underhållstjänster" ;
  underingenjoer_nn_1_1_N = mkN "underingenjör" "underingenjörer" ;
  underinstans_nn_1_N = mkN "underinstans" "underinstanser" ;
  underkurs_nn_1_N = mkN "underkurs" "underkurser" ;
  undermast_nn_1_N = mkN "undermast" "undermaster" ;
  undersats_nn_1_N = mkN "undersats" "undersatser" ;
  undervattensfarkost_nn_1_N = mkN "undervattensfarkost" "undervattensfarkoster" ;
  undin_nn_1_N = mkN "undin" "undiner" ;
  ungdomsbok_nn_1_N = mkN "ungdomsbok" "ungdomsböcker" ;
  ungdomskultur_nn_1_N = mkN "ungdomskultur" "ungdomskulturer" ;
  ungdomspraktik_nn_1_N = mkN "ungdomspraktik" "ungdomspraktiker" ;
  ungkommunist_nn_1_N = mkN "ungkommunist" "ungkommunister" ;
  ungsocialism_nn_1_N = mkN "ungsocialism" "ungsocialismer" ;
  unisexoverall_nn_1_N = mkN "unisexoverall" "unisexoveraller" ;
  unitarism_nn_1_N = mkN "unitarism" "unitarismer" ;
  unitarist_nn_1_N = mkN "unitarist" "unitarister" ;
  universalism_nn_1_N = mkN "universalism" "universalismer" ;
  universalist_nn_1_N = mkN "universalist" "universalister" ;
  universalsilikon_nn_1_N = mkN "universalsilikon" "universalsilikoner" ;
  universitetslektor_nn_1_N = mkN "universitetslektor" "universitetslektorer" ;
  universitetsrektor_nn_1_N = mkN "universitetsrektor" "universitetsrektorer" ;
  uppblaasningsfas_nn_1_1_N = mkN "uppblåsningsfas" "uppblåsningsfaser" ;
  uppbrottssignal_nn_1_N = mkN "uppbrottssignal" "uppbrottssignaler" ;
  uppboerdsbok_nn_1_1_N = mkN "uppbördsbok" "uppbördsböcker" ;
  uppenbarelsebok_nn_1_N = mkN "uppenbarelsebok" "uppenbarelseböcker" ;
  upplagringsplats_nn_1_N = mkN "upplagringsplats" "upplagringsplatser" ;
  upplagsplats_nn_1_N = mkN "upplagsplats" "upplagsplatser" ;
  uppmaningssats_nn_1_N = mkN "uppmaningssats" "uppmaningssatser" ;
  uppmarsch_nn_1_N = mkN "uppmarsch" "uppmarscher" ;
  uppsats_nn_1_N = mkN "uppsats" "uppsatser" ;
  uppslagsbok_nn_1_N = mkN "uppslagsbok" "uppslagsböcker" ;
  uppstaellningsplats_nn_1_1_N = mkN "uppställningsplats" "uppställningsplatser" ;
  uppstaellningssignal_nn_1_1_N = mkN "uppställningssignal" "uppställningssignaler" ;
  urarvakonkurs_nn_1_N = mkN "urarvakonkurs" "urarvakonkurser" ;
  urbanism_nn_1_N = mkN "urbanism" "urbanismer" ;
  urbergsplataa_nn_1_1_N = mkN "urbergsplatå" "urbergsplatåer" ;
  ureas_nn_1_N = mkN "ureas" "ureaser" ;
  uretanplast_nn_1_N = mkN "uretanplast" "uretanplaster" ;
  uridiot_nn_1_N = mkN "uridiot" "uridioter" ;
  urocean_nn_1_N = mkN "urocean" "uroceaner" ;
  urolog_nn_1_N = mkN "urolog" "urologer" ;
  urpremiaer_nn_1_1_N = mkN "urpremiär" "urpremiärer" ;
  ursprungsattest_nn_1_N = mkN "ursprungsattest" "ursprungsattester" ;
  urtext_nn_1_N = mkN "urtext" "urtexter" ;
  urvalsprocess_nn_1_N = mkN "urvalsprocess" "urvalsprocesser" ;
  usans_nn_1_N = mkN "usans" "usanser" ;
  usurpator_nn_1_N = mkN "usurpator" "usurpatorer" ;
  utbildningsnivaa_nn_1_1_N = mkN "utbildningsnivå" "utbildningsnivåer" ;
  uteplats_nn_1_N = mkN "uteplats" "uteplatser" ;
  utgiftspost_nn_1_N = mkN "utgiftspost" "utgiftsposter" ;
  utgiftsskatt_nn_1_N = mkN "utgiftsskatt" "utgiftsskatter" ;
  utgraevningsplats_nn_1_1_N = mkN "utgrävningsplats" "utgrävningsplatser" ;
  utgaangsmarsch_nn_1_1_N = mkN "utgångsmarsch" "utgångsmarscher" ;
  utilism_nn_1_N = mkN "utilism" "utilismer" ;
  utilist_nn_1_N = mkN "utilist" "utilister" ;
  utilitarism_nn_1_N = mkN "utilitarism" "utilitarismer" ;
  utilitarist_nn_1_N = mkN "utilitarist" "utilitarister" ;
  utkiksplats_nn_1_N = mkN "utkiksplats" "utkiksplatser" ;
  utkikspost_nn_1_N = mkN "utkikspost" "utkiksposter" ;
  utlandslektor_nn_1_N = mkN "utlandslektor" "utlandslektorer" ;
  utlandssoldat_nn_1_N = mkN "utlandssoldat" "utlandssoldater" ;
  utmarsch_nn_1_N = mkN "utmarsch" "utmarscher" ;
  utombordsmotor_nn_1_N = mkN "utombordsmotor" "utombordsmotorer" ;
  utopist_nn_1_N = mkN "utopist" "utopister" ;
  utpost_nn_1_N = mkN "utpost" "utposter" ;
  utslagningsmekanism_nn_1_N = mkN "utslagningsmekanism" "utslagningsmekanismer" ;
  utslagsroest_nn_1_1_N = mkN "utslagsröst" "utslagsröster" ;
  utslaeppsgraens_nn_1_1_N = mkN "utsläppsgräns" "utsläppsgränser" ;
  utvecklingsoptimism_nn_1_N = mkN "utvecklingsoptimism" "utvecklingsoptimismer" ;
  utvecklingspessimism_nn_1_N = mkN "utvecklingspessimism" "utvecklingspessimismer" ;
  utvecklingsprocess_nn_1_N = mkN "utvecklingsprocess" "utvecklingsprocesser" ;
  utvaext_nn_1_1_N = mkN "utväxt" "utväxter" ;
  uvular_nn_1_N = mkN "uvular" "uvularer" ;
  uzbek_nn_1_N = mkN "uzbek" "uzbeker" ;
  vacuumregulator_nn_1_N = mkN "vacuumregulator" "vacuumregulatorer" ;
  vagabondnatur_nn_1_N = mkN "vagabondnatur" "vagabondnaturer" ;
  vagant_nn_1_N = mkN "vagant" "vaganter" ;
  vaginism_nn_1_N = mkN "vaginism" "vaginismer" ;
  vagnslast_nn_1_N = mkN "vagnslast" "vagnslaster" ;
  vagong_nn_1_N = mkN "vagong" "vagonger" ;
  vakans_nn_1_N = mkN "vakans" "vakanser" ;
  vaktarrest_nn_1_N = mkN "vaktarrest" "vaktarrester" ;
  vaktpost_nn_1_N = mkN "vaktpost" "vaktposter" ;
  vakuumregulator_nn_1_N = mkN "vakuumregulator" "vakuumregulatorer" ;
  valaffisch_nn_1_N = mkN "valaffisch" "valaffischer" ;
  valbyraa_nn_1_1_N = mkN "valbyrå" "valbyråer" ;
  valens_nn_1_N = mkN "valens" "valenser" ;
  valenselektron_nn_1_N = mkN "valenselektron" "valenselektroner" ;
  valfoerlust_nn_1_1_N = mkN "valförlust" "valförluster" ;
  valkampanj_nn_1_N = mkN "valkampanj" "valkampanjer" ;
  vallmovaext_nn_1_1_N = mkN "vallmoväxt" "vallmoväxter" ;
  vallon_nn_1_N = mkN "vallon" "valloner" ;
  vallvaext_nn_1_1_N = mkN "vallväxt" "vallväxter" ;
  valmagnet_nn_1_N = mkN "valmagnet" "valmagneter" ;
  valplats_nn_1_N = mkN "valplats" "valplatser" ;
  valrossmustasch_nn_1_N = mkN "valrossmustasch" "valrossmustascher" ;
  vals_nn_2_N = mkN "vals" "valser" ;
  valstrateg_nn_1_N = mkN "valstrateg" "valstrateger" ;
  valstugeaktivist_nn_1_N = mkN "valstugeaktivist" "valstugeaktivister" ;
  valutakurs_nn_1_N = mkN "valutakurs" "valutakurser" ;
  valvinst_nn_1_N = mkN "valvinst" "valvinster" ;
  vampyrroman_nn_1_N = mkN "vampyrroman" "vampyrromaner" ;
  van_nn_1_N = mkN "van" "vaner" ;
  vandal_nn_1_N = mkN "vandal" "vandaler" ;
  vandalism_nn_1_N = mkN "vandalism" "vandalismer" ;
  vapenbok_nn_1_N = mkN "vapenbok" "vapenböcker" ;
  vapendans_nn_1_N = mkN "vapendans" "vapendanser" ;
  varan_nn_1_N = mkN "varan" "varaner" ;
  vardagsfest_nn_1_N = mkN "vardagsfest" "vardagsfester" ;
  vardagsfras_nn_1_N = mkN "vardagsfras" "vardagsfraser" ;
  vardagsmatin_e_nn_1_1_N = mkN "vardagsmatiné" "vardagsmatinéer" ;
  varians_nn_1_N = mkN "varians" "varianser" ;
  variant_nn_1_N = mkN "variant" "varianter" ;
  variator_nn_1_N = mkN "variator" "variatorer" ;
  variet_e_nn_1_1_N = mkN "varieté" "varietéer" ;
  variet_eartist_nn_1_1_N = mkN "varietéartist" "varietéartister" ;
  varmluftpistol_nn_1_N = mkN "varmluftpistol" "varmluftpistoler" ;
  varmluftsridaa_nn_1_1_N = mkN "varmluftsridå" "varmluftsridåer" ;
  varningssignal_nn_1_N = mkN "varningssignal" "varningssignaler" ;
  varseloverall_nn_1_N = mkN "varseloverall" "varseloveraller" ;
  varuskatt_nn_1_N = mkN "varuskatt" "varuskatter" ;
  varutransport_nn_1_N = mkN "varutransport" "varutransporter" ;
  vas_nn_1_N = mkN "vas" "vaser" ;
  vattenbrist_nn_1_N = mkN "vattenbrist" "vattenbrister" ;
  vattenfas_nn_1_N = mkN "vattenfas" "vattenfaser" ;
  vattenkonst_nn_1_N = mkN "vattenkonst" "vattenkonster" ;
  vattenkultur_nn_1_N = mkN "vattenkultur" "vattenkulturer" ;
  vattenlist_nn_1_N = mkN "vattenlist" "vattenlister" ;
  vattenmelon_nn_1_N = mkN "vattenmelon" "vattenmeloner" ;
  vattennivaa_nn_1_1_N = mkN "vattennivå" "vattennivåer" ;
  vattenorganism_nn_1_N = mkN "vattenorganism" "vattenorganismer" ;
  vattenpistol_nn_1_N = mkN "vattenpistol" "vattenpistoler" ;
  vattenpost_nn_1_N = mkN "vattenpost" "vattenposter" ;
  vattentemperatur_nn_1_N = mkN "vattentemperatur" "vattentemperaturer" ;
  vattentortyr_nn_1_N = mkN "vattentortyr" "vattentortyrer" ;
  vattentransport_nn_1_N = mkN "vattentransport" "vattentransporter" ;
  vattenturbin_nn_1_N = mkN "vattenturbin" "vattenturbiner" ;
  vattenvaext_nn_1_1_N = mkN "vattenväxt" "vattenväxter" ;
  vaxapplikator_nn_1_N = mkN "vaxapplikator" "vaxapplikatorer" ;
  vaxfigur_nn_1_N = mkN "vaxfigur" "vaxfigurer" ;
  vedkast_nn_1_N = mkN "vedkast" "vedkaster" ;
  vegan_nn_1_N = mkN "vegan" "veganer" ;
  veganism_nn_1_N = mkN "veganism" "veganismer" ;
  vegetarian_nn_1_N = mkN "vegetarian" "vegetarianer" ;
  vegetarianism_nn_1_N = mkN "vegetarianism" "vegetarianismer" ;
  vegetarism_nn_1_N = mkN "vegetarism" "vegetarismer" ;
  vektor_nn_1_N = mkN "vektor" "vektorer" ;
  velar_nn_1_N = mkN "velar" "velarer" ;
  vend_nn_1_N = mkN "vend" "vender" ;
  venereolog_nn_1_N = mkN "venereolog" "venereologer" ;
  venetian_nn_1_N = mkN "venetian" "venetianer" ;
  venezolan_nn_1_N = mkN "venezolan" "venezolaner" ;
  venezuelan_nn_1_N = mkN "venezuelan" "venezuelaner" ;
  ventil_nn_1_N = mkN "ventil" "ventiler" ;
  ventilator_nn_1_N = mkN "ventilator" "ventilatorer" ;
  verbalfaktor_nn_1_N = mkN "verbalfaktor" "verbalfaktorer" ;
  verbalism_nn_1_N = mkN "verbalism" "verbalismer" ;
  verifieringsprocess_nn_1_N = mkN "verifieringsprocess" "verifieringsprocesser" ;
  verism_nn_1_N = mkN "verism" "verismer" ;
  verktygssats_nn_1_N = mkN "verktygssats" "verktygssatser" ;
  vernissagefest_nn_1_N = mkN "vernissagefest" "vernissagefester" ;
  vesir_nn_1_N = mkN "vesir" "vesirer" ;
  vestibulit_nn_1_N = mkN "vestibulit" "vestibuliter" ;
  veteran_nn_1_N = mkN "veteran" "veteraner" ;
  veterinaerkontroll_nn_1_1_N = mkN "veterinärkontroll" "veterinärkontroller" ;
  vevgrammofon_nn_1_N = mkN "vevgrammofon" "vevgrammofoner" ;
  vibrafon_nn_1_N = mkN "vibrafon" "vibrafoner" ;
  vibrant_nn_1_N = mkN "vibrant" "vibranter" ;
  vibrator_nn_1_N = mkN "vibrator" "vibratorer" ;
  vibrion_nn_1_N = mkN "vibrion" "vibrioner" ;
  victorianism_nn_1_N = mkN "victorianism" "victorianismer" ;
  videosignal_nn_1_N = mkN "videosignal" "videosignaler" ;
  vietnames_nn_1_N = mkN "vietnames" "vietnameser" ;
  vigselannons_nn_1_N = mkN "vigselannons" "vigselannonser" ;
  vigvam_nn_1_N = mkN "vigvam" "vigvamer" ;
  vikt_nn_1_N = mkN "vikt" "vikter" ;
  viktfoerlust_nn_1_1_N = mkN "viktförlust" "viktförluster" ;
  viktklass_nn_1_N = mkN "viktklass" "viktklasser" ;
  viktorianism_nn_1_N = mkN "viktorianism" "viktorianismer" ;
  vildkanin_nn_1_N = mkN "vildkanin" "vildkaniner" ;
  villkorsbisats_nn_1_N = mkN "villkorsbisats" "villkorsbisatser" ;
  vilopaus_nn_1_N = mkN "vilopaus" "vilopauser" ;
  viloplats_nn_1_N = mkN "viloplats" "viloplatser" ;
  vindindustrilobby_nn_1_N = mkN "vindindustrilobby" "vindindustrilobbyer" ;
  vinfest_nn_1_N = mkN "vinfest" "vinfester" ;
  vinkaraff_nn_1_N = mkN "vinkaraff" "vinkaraffer" ;
  vinkellinjal_nn_1_N = mkN "vinkellinjal" "vinkellinjaler" ;
  vinkelpredikant_nn_1_N = mkN "vinkelpredikant" "vinkelpredikanter" ;
  vinproducent_nn_1_N = mkN "vinproducent" "vinproducenter" ;
  vinst_nn_1_N = mkN "vinst" "vinster" ;
  vinstchans_nn_1_N = mkN "vinstchans" "vinstchanser" ;
  vinstdelningsskatt_nn_1_N = mkN "vinstdelningsskatt" "vinstdelningsskatter" ;
  vinstkalkyl_nn_1_N = mkN "vinstkalkyl" "vinstkalkyler" ;
  vinstplan_nn_1_N = mkN "vinstplan" "vinstplaner" ;
  vinterfarkost_nn_1_N = mkN "vinterfarkost" "vinterfarkoster" ;
  vinterkampanj_nn_1_N = mkN "vinterkampanj" "vinterkampanjer" ;
  vinyl_nn_2_N = mkN "vinyl" "vinyler" ;
  violin_nn_1_N = mkN "violin" "violiner" ;
  violinist_nn_1_N = mkN "violinist" "violinister" ;
  violoncellist_nn_1_N = mkN "violoncellist" "violoncellister" ;
  virolog_nn_1_N = mkN "virolog" "virologer" ;
  virtuos_nn_1_N = mkN "virtuos" "virtuoser" ;
  virusrisk_nn_1_N = mkN "virusrisk" "virusrisker" ;
  visbok_nn_1_N = mkN "visbok" "visböcker" ;
  visir_nn_2_N = mkN "visir" "visirer" ;
  visit_nn_1_N = mkN "visit" "visiter" ;
  visitator_nn_1_N = mkN "visitator" "visitatorer" ;
  vitalism_nn_1_N = mkN "vitalism" "vitalismer" ;
  vitbok_nn_1_N = mkN "vitbok" "vitböcker" ;
  vitnosdelfin_nn_1_N = mkN "vitnosdelfin" "vitnosdelfiner" ;
  vitrin_nn_1_N = mkN "vitrin" "vitriner" ;
  voall_nn_1_N = mkN "voall" "voaller" ;
  vokalis_nn_1_N = mkN "vokalis" "vokaliser" ;
  vokalism_nn_1_N = mkN "vokalism" "vokalismer" ;
  vokalist_nn_1_N = mkN "vokalist" "vokalister" ;
  vokativ_nn_1_N = mkN "vokativ" "vokativer" ;
  volang_nn_1_N = mkN "volang" "volanger" ;
  volt_nn_2_N = mkN "volt" "volter" ;
  voltan_nn_1_N = mkN "voltan" "voltaner" ;
  voluntarism_nn_1_N = mkN "voluntarism" "voluntarismer" ;
  vombat_nn_1_N = mkN "vombat" "vombater" ;
  vrakrest_nn_1_N = mkN "vrakrest" "vrakrester" ;
  vrist_nn_1_N = mkN "vrist" "vrister" ;
  vulkan_nn_1_N = mkN "vulkan" "vulkaner" ;
  vulkanisator_nn_1_N = mkN "vulkanisator" "vulkanisatorer" ;
  vulkanism_nn_1_N = mkN "vulkanism" "vulkanismer" ;
  vulkanit_nn_1_N = mkN "vulkanit" "vulkaniter" ;
  vulst_nn_1_N = mkN "vulst" "vulster" ;
  vurm_nn_1_N = mkN "vurm" "vurmer" ;
  vuxendos_nn_1_N = mkN "vuxendos" "vuxendoser" ;
  vy_nn_1_N = mkN "vy" "vyer" ;
  vykortstext_nn_1_N = mkN "vykortstext" "vykortstexter" ;
  vykortsvy_nn_1_N = mkN "vykortsvy" "vykortsvyer" ;
  vaeckelsepredikant_nn_1_1_N = mkN "väckelsepredikant" "väckelsepredikanter" ;
  vaederleksrapport_nn_1_1_N = mkN "väderleksrapport" "väderleksrapporter" ;
  vaederprognos_nn_1_1_N = mkN "väderprognos" "väderprognoser" ;
  vaederrapport_nn_1_1_N = mkN "väderrapport" "väderrapporter" ;
  vaedersatellit_nn_1_1_N = mkN "vädersatellit" "vädersatelliter" ;
  vaeggtelefon_nn_1_1_N = mkN "väggtelefon" "väggtelefoner" ;
  vaelfaerdskris_nn_1_1_N = mkN "välfärdskris" "välfärdskriser" ;
  vaelkomstfest_nn_1_1_N = mkN "välkomstfest" "välkomstfester" ;
  vaendplats_nn_1_1_N = mkN "vändplats" "vändplatser" ;
  vaenskapsmatch_nn_1_1_N = mkN "vänskapsmatch" "vänskapsmatcher" ;
  vaensterkroenikoer_nn_1_1_N = mkN "vänsterkrönikör" "vänsterkrönikörer" ;
  vaensterprofessor_nn_1_1_N = mkN "vänsterprofessor" "vänsterprofessorer" ;
  vaensterrebell_nn_1_1_N = mkN "vänsterrebell" "vänsterrebeller" ;
  vaenstersocialism_nn_1_1_N = mkN "vänstersocialism" "vänstersocialismer" ;
  vaenstersocialist_nn_1_1_N = mkN "vänstersocialist" "vänstersocialister" ;
  vaentjaenst_nn_1_1_N = mkN "väntjänst" "väntjänster" ;
  vaerdeanalys_nn_1_1_N = mkN "värdeanalys" "värdeanalyser" ;
  vaerdefoerlust_nn_1_1_N = mkN "värdeförlust" "värdeförluster" ;
  vaerdenihilism_nn_1_1_N = mkN "värdenihilism" "värdenihilismer" ;
  vaerdestruktur_nn_1_1_N = mkN "värdestruktur" "värdestrukturer" ;
  vaerdetransport_nn_1_1_N = mkN "värdetransport" "värdetransporter" ;
  vaerdmolekyl_nn_1_1_N = mkN "värdmolekyl" "värdmolekyler" ;
  vaerdvaext_nn_1_1_N = mkN "värdväxt" "värdväxter" ;
  vaerldsartist_nn_1_1_N = mkN "världsartist" "världsartister" ;
  vaerldsatlas_nn_1_1_N = mkN "världsatlas" "världsatlaser" ;
  vaerldsfederalism_nn_1_1_N = mkN "världsfederalism" "världsfederalismer" ;
  vaerldskapitalism_nn_1_1_N = mkN "världskapitalism" "världskapitalismer" ;
  vaerldspremiaer_nn_1_1_N = mkN "världspremiär" "världspremiärer" ;
  vaerldssucc_e_nn_1_1_N = mkN "världssuccé" "världssuccéer" ;
  vaermefoerlust_nn_1_1_N = mkN "värmeförlust" "värmeförluster" ;
  vaermeisolator_nn_1_1_N = mkN "värmeisolator" "värmeisolatorer" ;
  vaermemotor_nn_1_1_N = mkN "värmemotor" "värmemotorer" ;
  vaermeradiator_nn_1_1_N = mkN "värmeradiator" "värmeradiatorer" ;
  vaernpliktsarm_e_nn_1_1_N = mkN "värnpliktsarmé" "värnpliktsarméer" ;
  vaervningskampanj_nn_1_1_N = mkN "värvningskampanj" "värvningskampanjer" ;
  vaestkust_nn_1_1_N = mkN "västkust" "västkuster" ;
  vaestkustaccent_nn_1_1_N = mkN "västkustaccent" "västkustaccenter" ;
  vaestsamoan_nn_1_1_N = mkN "västsamoan" "västsamoaner" ;
  vaetegenerator_nn_1_1_N = mkN "vätegenerator" "vätegeneratorer" ;
  vaetejon_nn_1_1_N = mkN "vätejon" "vätejoner" ;
  vaetekarbonatjon_nn_1_1_N = mkN "vätekarbonatjon" "vätekarbonatjoner" ;
  vaetgashybrid_nn_1_1_N = mkN "vätgashybrid" "vätgashybrider" ;
  vaetgasmolekyl_nn_1_1_N = mkN "vätgasmolekyl" "vätgasmolekyler" ;
  vaetskefoerlust_nn_1_1_N = mkN "vätskeförlust" "vätskeförluster" ;
  vaetskekontroll_nn_1_1_N = mkN "vätskekontroll" "vätskekontroller" ;
  vaetskenivaa_nn_1_1_N = mkN "vätskenivå" "vätskenivåer" ;
  vaevplast_nn_1_1_N = mkN "vävplast" "vävplaster" ;
  vaexelaccept_nn_1_1_N = mkN "växelaccept" "växelaccepter" ;
  vaexelkredit_nn_1_1_N = mkN "växelkredit" "växelkrediter" ;
  vaexelkurs_nn_1_1_N = mkN "växelkurs" "växelkurser" ;
  vaext_nn_1_1_N = mkN "växt" "växter" ;
  vaextbas_nn_1_1_N = mkN "växtbas" "växtbaser" ;
  vaextgraens_nn_1_1_N = mkN "växtgräns" "växtgränser" ;
  vaexthusgas_nn_1_1_N = mkN "växthusgas" "växthusgaser" ;
  vaextplats_nn_1_1_N = mkN "växtplats" "växtplatser" ;
  vaextsaesong_nn_1_1_N = mkN "växtsäsong" "växtsäsonger" ;
  vaad_nn_1_1_N = mkN "våd" "våder" ;
  vaadevill_nn_1_1_N = mkN "vådevill" "vådeviller" ;
  vaagbalans_nn_1_1_N = mkN "vågbalans" "vågbalanser" ;
  vaagnatur_nn_1_1_N = mkN "vågnatur" "vågnaturer" ;
  vaaldstendens_nn_1_1_N = mkN "våldstendens" "våldstendenser" ;
  vaard_nn_2_1_N = mkN "vård" "vårder" ;
  vaardpersonal_nn_1_1_N = mkN "vårdpersonal" "vårdpersonaler" ;
  vaardplats_nn_1_1_N = mkN "vårdplats" "vårdplatser" ;
  vaarvaext_nn_1_1_N = mkN "vårväxt" "vårväxter" ;
  wagon_nn_1_N = mkN "wagon" "wagoner" ;
  wankelmotor_nn_1_N = mkN "wankelmotor" "wankelmotorer" ;
  webbdomaen_nn_1_1_N = mkN "webbdomän" "webbdomäner" ;
  webbplats_nn_1_N = mkN "webbplats" "webbplatser" ;
  webbtjaenst_nn_1_1_N = mkN "webbtjänst" "webbtjänster" ;
  whiskybutelj_nn_1_N = mkN "whiskybutelj" "whiskybuteljer" ;
  wienervals_nn_1_N = mkN "wienervals" "wienervalser" ;
  wienklassicism_nn_1_N = mkN "wienklassicism" "wienklassicismer" ;
  wigwam_nn_1_N = mkN "wigwam" "wigwamer" ;
  worcestersaas_nn_1_1_N = mkN "worcestersås" "worcestersåser" ;
  x_koordinat_nn_1_N = mkN "x-koordinat" "x-koordinater" ;
  x_kromosom_nn_1_N = mkN "x-kromosom" "x-kromosomer" ;
  xylofon_nn_1_N = mkN "xylofon" "xylofoner" ;
  y_koordinat_nn_1_N = mkN "y-koordinat" "y-koordinater" ;
  y_kromosom_nn_1_N = mkN "y-kromosom" "y-kromosomer" ;
  yawl_nn_1_N = mkN "yawl" "yawler" ;
  yrkesarm_e_nn_1_1_N = mkN "yrkesarmé" "yrkesarméer" ;
  yrkespraktik_nn_1_N = mkN "yrkespraktik" "yrkespraktiker" ;
  ytstruktur_nn_1_N = mkN "ytstruktur" "ytstrukturer" ;
  yttriumoxid_nn_1_N = mkN "yttriumoxid" "yttriumoxider" ;
  zelot_nn_1_N = mkN "zelot" "zeloter" ;
  zenitdistans_nn_1_N = mkN "zenitdistans" "zenitdistanser" ;
  zigenarkaravan_nn_1_N = mkN "zigenarkaravan" "zigenarkaravaner" ;
  zirkon_nn_1_N = mkN "zirkon" "zirkoner" ;
  zirkoniumoxid_nn_1_N = mkN "zirkoniumoxid" "zirkoniumoxider" ;
  zon_nn_1_N = mkN "zon" "zoner" ;
  zoolog_nn_1_N = mkN "zoolog" "zoologer" ;
  aedelfasan_nn_1_1_N = mkN "ädelfasan" "ädelfasaner" ;
  aedelgas_nn_1_1_N = mkN "ädelgas" "ädelgaser" ;
  aektenskapsallians_nn_1_1_N = mkN "äktenskapsallians" "äktenskapsallianser" ;
  aektenskapsannons_nn_1_1_N = mkN "äktenskapsannons" "äktenskapsannonser" ;
  aektenskapsbyraa_nn_1_1_N = mkN "äktenskapsbyrå" "äktenskapsbyråer" ;
  aelgfigur_nn_1_1_N = mkN "älgfigur" "älgfigurer" ;
  aemneskonferens_nn_1_1_N = mkN "ämneskonferens" "ämneskonferenser" ;
  aenglafigur_nn_1_1_N = mkN "änglafigur" "änglafigurer" ;
  aerkekretin_nn_1_1_N = mkN "ärkekretin" "ärkekretiner" ;
  aerkereaktionaer_nn_1_1_N = mkN "ärkereaktionär" "ärkereaktionärer" ;
  aertpur_e_nn_1_1_N = mkN "ärtpuré" "ärtpuréer" ;
  aertvaext_nn_1_1_N = mkN "ärtväxt" "ärtväxter" ;
  aett_nn_1_1_N = mkN "ätt" "ätter" ;
  aeventyrsbok_nn_1_1_N = mkN "äventyrsbok" "äventyrsböcker" ;
  aeventyrsroman_nn_1_1_N = mkN "äventyrsroman" "äventyrsromaner" ;
  aahoerarplats_nn_1_1_N = mkN "åhörarplats" "åhörarplatser" ;
  aakervaext_nn_1_1_N = mkN "åkerväxt" "åkerväxter" ;
  aaldersgraens_nn_1_1_N = mkN "åldersgräns" "åldersgränser" ;
  aaldersklass_nn_1_1_N = mkN "åldersklass" "åldersklasser" ;
  aaldersstruktur_nn_1_1_N = mkN "åldersstruktur" "åldersstrukturer" ;
  aangackumulator_nn_1_1_N = mkN "ångackumulator" "ångackumulatorer" ;
  aangestneuros_nn_1_1_N = mkN "ångestneuros" "ångestneuroser" ;
  aanggenerator_nn_1_1_N = mkN "ånggenerator" "ånggeneratorer" ;
  aangturbin_nn_1_1_N = mkN "ångturbin" "ångturbiner" ;
  aarmiljon_nn_1_1_N = mkN "årmiljon" "årmiljoner" ;
  aarsbok_nn_1_1_N = mkN "årsbok" "årsböcker" ;
  aarsdos_nn_1_1_N = mkN "årsdos" "årsdoser" ;
  aarsinkomst_nn_1_1_N = mkN "årsinkomst" "årsinkomster" ;
  aarsklass_nn_1_1_N = mkN "årsklass" "årsklasser" ;
  aarskurs_nn_1_1_N = mkN "årskurs" "årskurser" ;
  aarsmedeltemperatur_nn_1_1_N = mkN "årsmedeltemperatur" "årsmedeltemperaturer" ;
  aartalsexercis_nn_1_1_N = mkN "årtalsexercis" "årtalsexerciser" ;
  aasiktsdiktatur_nn_1_1_N = mkN "åsiktsdiktatur" "åsiktsdiktaturer" ;
  aasiktspluralism_nn_1_1_N = mkN "åsiktspluralism" "åsiktspluralismer" ;
  aaterfoereningsprocess_nn_1_1_N = mkN "återföreningsprocess" "återföreningsprocesser" ;
  aaterhaemtningsfas_nn_1_1_N = mkN "återhämtningsfas" "återhämtningsfaser" ;
  aaterremiss_nn_1_1_N = mkN "återremiss" "återremisser" ;
  aatertjaenst_nn_1_1_N = mkN "återtjänst" "återtjänster" ;
  aattiotalism_nn_1_1_N = mkN "åttiotalism" "åttiotalismer" ;
  aattiotalist_nn_1_1_N = mkN "åttiotalist" "åttiotalister" ;
  aattitalism_nn_1_1_N = mkN "åttitalism" "åttitalismer" ;
  aattitalist_nn_1_1_N = mkN "åttitalist" "åttitalister" ;
  aattondelsfinal_nn_1_1_N = mkN "åttondelsfinal" "åttondelsfinaler" ;
  oegonprotes_nn_1_1_N = mkN "ögonprotes" "ögonproteser" ;
  oekenvaext_nn_1_1_N = mkN "ökenväxt" "ökenväxter" ;
  oeljett_nn_1_1_N = mkN "öljett" "öljetter" ;
  oenskesats_nn_1_1_N = mkN "önskesats" "önskesatser" ;
  oerlogsbas_nn_1_1_N = mkN "örlogsbas" "örlogsbaser" ;
  oerlogsmatros_nn_1_1_N = mkN "örlogsmatros" "örlogsmatroser" ;
  oert_nn_1_1_N = mkN "ört" "örter" ;
  oestkust_nn_1_1_N = mkN "östkust" "östkuster" ;
  oeverdirektoer_nn_1_1_N = mkN "överdirektör" "överdirektörer" ;
  oeverdos_nn_1_1_N = mkN "överdos" "överdoser" ;
  oeverfoeringskarakteristik_nn_1_1_N = mkN "överföringskarakteristik" "överföringskarakteristiker" ;
  oeverfoeringskaraktaeristik_nn_1_1_N = mkN "överföringskaraktäristik" "överföringskaraktäristiker" ;
  oevergaangsmetall_nn_1_1_N = mkN "övergångsmetall" "övergångsmetaller" ;
  oeverhetsperson_nn_1_1_N = mkN "överhetsperson" "överhetspersoner" ;
  oeveringenjoer_nn_1_1_N = mkN "överingenjör" "överingenjörer" ;
  oeverklass_nn_1_1_N = mkN "överklass" "överklasser" ;
  oeverklassaccent_nn_1_1_N = mkN "överklassaccent" "överklassaccenter" ;
  oeverkurs_nn_1_1_N = mkN "överkurs" "överkurser" ;
  oeverlast_nn_1_1_N = mkN "överlast" "överlaster" ;
  oeverlevnadschans_nn_1_1_N = mkN "överlevnadschans" "överlevnadschanser" ;
  oeverlevnadskurs_nn_1_1_N = mkN "överlevnadskurs" "överlevnadskurser" ;
  oeversiktsplan_nn_1_1_N = mkN "översiktsplan" "översiktsplaner" ;
  oeverstepraest_nn_1_1_N = mkN "överstepräst" "överstepräster" ;
  oeversitteri_nn_1_1_N = mkN "översitteri" "översitterit" "översitterier" "översitterierna" ;
  oevergaangsstadium_nn_1_1_N = mkN "övergångsstadium" "övergångsstadiet" "övergångsstadier" "övergångsstadierna" ;
  oeverdel_nn_1_1_N = mkN "överdel" "överdelen" "överdelar" "överdelarna" ;
  oestrogen_nn_1_1_N = mkN "östrogen" "östrogenet" "östrogener" "östrogenerna" ;
  oenskedroem_nn_1_1_N = mkN "önskedröm" "önskedrömmen" "önskedrömmar" "önskedrömmarna" ;
  oelkaf_e_nn_1_1_N = mkN "ölkafé" "ölkafét" "ölkaféer" "ölkaféerna" ;
  oelbryggeri_nn_1_1_N = mkN "ölbryggeri" "ölbryggerit" "ölbryggerier" "ölbryggerierna" ;
  oegonsten_nn_1_1_N = mkN "ögonsten" "ögonstenen" "ögonstenar" "ögonstenarna" ;
  aattondel_nn_1_1_N = mkN "åttondel" "åttondelen" "åttondelar" "åttondelarna" ;
  aattondedel_nn_1_1_N = mkN "åttondedel" "åttondedelen" "åttondedelar" "åttondedelarna" ;
  aattiondel_nn_1_1_N = mkN "åttiondel" "åttiondelen" "åttiondelar" "åttiondelarna" ;
  aarlom_nn_1_1_N = mkN "årlom" "årlommen" "årlommar" "årlommarna" ;
  aargaangsvin_nn_1_1_N = mkN "årgångsvin" "årgångsvinet" "årgångsviner" "årgångsvinerna" ;
  aangbageri_nn_1_1_N = mkN "ångbageri" "ångbagerit" "ångbagerier" "ångbagerierna" ;
  aaldersstadium_nn_1_1_N = mkN "åldersstadium" "åldersstadiet" "åldersstadier" "åldersstadierna" ;
  aakerren_nn_1_1_N = mkN "åkerren" "åkerrenen" "åkerrenar" "åkerrenarna" ;
  aakeri_nn_1_1_N = mkN "åkeri" "åkerit" "åkerier" "åkerierna" ;
  aakerfraeken_nn_1_1_N = mkN "åkerfräken" "åkerfräkenn" "åkerfräknar" "åkerfräknarna" ;
  aegodel_nn_1_1_N = mkN "ägodel" "ägodelen" "ägodelar" "ägodelarna" ;
  aeggtoddy_nn_1_1_N = mkN "äggtoddy" "äggtoddyn" "äggtoddyar" "äggtoddyarna" ;
  aegarandel_nn_1_1_N = mkN "ägarandel" "ägarandelen" "ägarandelar" "ägarandelarna" ;
  aedelsten_nn_1_1_N = mkN "ädelsten" "ädelstenen" "ädelstenar" "ädelstenarna" ;
  ytterlighetsparti_nn_1_N = mkN "ytterlighetsparti" "ytterlighetspartit" "ytterlighetspartier" "ytterlighetspartierna" ;
  yngelstadium_nn_1_N = mkN "yngelstadium" "yngelstadiet" "yngelstadier" "yngelstadierna" ;
  ympstam_nn_1_N = mkN "ympstam" "ympstammen" "ympstammar" "ympstammarna" ;
  yankeejib_nn_1_N = mkN "yankeejib" "yankeejibben" "yankeejibbar" "yankeejibbarna" ;
  vaam_nn_1_1_N = mkN "våm" "våmmen" "våmmar" "våmmarna" ;
  vaagkam_nn_1_1_N = mkN "vågkam" "vågkammen" "vågkammar" "vågkammarna" ;
  vaextstam_nn_1_1_N = mkN "växtstam" "växtstammen" "växtstammar" "växtstammarna" ;
  vaextgift_nn_1_1_N = mkN "växtgift" "växtgiftet" "växtgifter" "växtgifterna" ;
  vaextfett_nn_1_1_N = mkN "växtfett" "växtfettet" "växtfetter" "växtfetterna" ;
  vaexelstroem_nn_1_1_N = mkN "växelström" "växelströmmen" "växelströmmar" "växelströmmarna" ;
  vaevkam_nn_1_1_N = mkN "vävkam" "vävkammen" "vävkammar" "vävkammarna" ;
  vaeveri_nn_1_1_N = mkN "väveri" "väverit" "väverier" "väverierna" ;
  vaensterparti_nn_1_1_N = mkN "vänsterparti" "vänsterpartit" "vänsterpartier" "vänsterpartierna" ;
  vaegren_nn_1_1_N = mkN "vägren" "vägrenen" "vägrenar" "vägrenarna" ;
  vaegbom_nn_1_1_N = mkN "vägbom" "vägbommen" "vägbommar" "vägbommarna" ;
  vom_nn_1_N = mkN "vom" "vommen" "vommar" "vommarna" ;
  vitvin_nn_1_N = mkN "vitvin" "vitvinet" "vitviner" "vitvinerna" ;
  vittvin_nn_1_N = mkN "vittvin" "vittvinet" "vittviner" "vittvinerna" ;
  vitbroderi_nn_1_N = mkN "vitbroderi" "vitbroderit" "vitbroderier" "vitbroderierna" ;
  virvelstroem_nn_1_1_N = mkN "virvelström" "virvelströmmen" "virvelströmmar" "virvelströmmarna" ;
  vintagevin_nn_1_N = mkN "vintagevin" "vintagevinet" "vintageviner" "vintagevinerna" ;
  vinland_nn_1_N = mkN "vinland" "vinlandet" "vinländer" "vinländerna" ;
  vineri_nn_1_N = mkN "vineri" "vinerit" "vinerier" "vinerierna" ;
  vin_nn_1_N = mkN "vin" "vinet" "viner" "vinerna" ;
  vilostadium_nn_1_N = mkN "vilostadium" "vilostadiet" "vilostadier" "vilostadierna" ;
  vildstam_nn_1_N = mkN "vildstam" "vildstammen" "vildstammar" "vildstammarna" ;
  vildren_nn_1_N = mkN "vildren" "vildrenen" "vildrenar" "vildrenarna" ;
  vertikalstroem_nn_1_1_N = mkN "vertikalström" "vertikalströmmen" "vertikalströmmar" "vertikalströmmarna" ;
  verbstam_nn_1_N = mkN "verbstam" "verbstammen" "verbstammar" "verbstammarna" ;
  verbalstam_nn_1_N = mkN "verbalstam" "verbalstammen" "verbalstammar" "verbalstammarna" ;
  vedstam_nn_1_N = mkN "vedstam" "vedstammen" "vedstammar" "vedstammarna" ;
  vax_nn_1_N = mkN "vax" "vaxet" "vaxer" "vaxerna" ;
  vattenstroem_nn_1_1_N = mkN "vattenström" "vattenströmmen" "vattenströmmar" "vattenströmmarna" ;
  vattengel_nn_1_N = mkN "vattengel" "vattengelet" "vattengeler" "vattengelerna" ;
  vaterbom_nn_1_N = mkN "vaterbom" "vaterbommen" "vaterbommar" "vaterbommarna" ;
  varuparti_nn_1_N = mkN "varuparti" "varupartit" "varupartier" "varupartierna" ;
  varumaerkeshaveri_nn_1_1_N = mkN "varumärkeshaveri" "varumärkeshaverit" "varumärkeshaverier" "varumärkeshaverierna" ;
  varpbom_nn_1_N = mkN "varpbom" "varpbommen" "varpbommar" "varpbommarna" ;
  vapengren_nn_1_N = mkN "vapengren" "vapengrenen" "vapengrenar" "vapengrenarna" ;
  valmaskineri_nn_1_N = mkN "valmaskineri" "valmaskinerit" "valmaskinerier" "valmaskinerierna" ;
  valkokeri_nn_1_N = mkN "valkokeri" "valkokerit" "valkokerier" "valkokerierna" ;
  valkeri_nn_1_N = mkN "valkeri" "valkerit" "valkerier" "valkerierna" ;
  vaktmaesteri_nn_1_1_N = mkN "vaktmästeri" "vaktmästerit" "vaktmästerier" "vaktmästerierna" ;
  utvecklingsstadium_nn_1_N = mkN "utvecklingsstadium" "utvecklingsstadiet" "utvecklingsstadier" "utvecklingsstadierna" ;
  utvecklingsland_nn_1_N = mkN "utvecklingsland" "utvecklingslandet" "utvecklingsländer" "utvecklingsländerna" ;
  utslaeppsland_nn_1_1_N = mkN "utsläppsland" "utsläppslandet" "utsläppsländer" "utsläppsländerna" ;
  utdragssoem_nn_1_1_N = mkN "utdragssöm" "utdragssömmen" "utdragssömmar" "utdragssömmarna" ;
  ursprungsland_nn_1_N = mkN "ursprungsland" "ursprungslandet" "ursprungsländer" "ursprungsländerna" ;
  urmakeri_nn_1_N = mkN "urmakeri" "urmakerit" "urmakerier" "urmakerierna" ;
  uppstroem_nn_1_1_N = mkN "uppström" "uppströmmen" "uppströmmar" "uppströmmarna" ;
  universalgeni_nn_1_N = mkN "universalgeni" "universalgenit" "universalgenier" "universalgenierna" ;
  ungstadium_nn_1_N = mkN "ungstadium" "ungstadiet" "ungstadier" "ungstadierna" ;
  ungmor_nn_1_N = mkN "ungmoder" "ungmodern" "ungmödrar" "ungmödrarna" ;
  ungdomssvaermeri_nn_1_1_N = mkN "ungdomssvärmeri" "ungdomssvärmerit" "ungdomssvärmerier" "ungdomssvärmerierna" ;
  ungdomsfylleri_nn_1_N = mkN "ungdomsfylleri" "ungdomsfyllerit" "ungdomsfyllerier" "ungdomsfyllerierna" ;
  understroem_nn_1_1_N = mkN "underström" "underströmmen" "underströmmar" "underströmmarna" ;
  underdel_nn_1_N = mkN "underdel" "underdelen" "underdelar" "underdelarna" ;
  u_land_nn_1_N = mkN "u-land" "u-landet" "u-länder" "u-länderna" ;
  toem_nn_1_1_N = mkN "töm" "tömmen" "tömmar" "tömmarna" ;
  tygbom_nn_1_N = mkN "tygbom" "tygbommen" "tygbommar" "tygbommarna" ;
  tvaaondel_nn_1_1_N = mkN "tvåondel" "tvåondelen" "tvåondelar" "tvåondelarna" ;
  tvaaendel_nn_1_1_N = mkN "tvåendel" "tvåendelen" "tvåendelar" "tvåendelarna" ;
  tvaetteri_nn_1_1_N = mkN "tvätteri" "tvätterit" "tvätterier" "tvätterierna" ;
  tvistsoem_nn_1_1_N = mkN "tvistsöm" "tvistsömmen" "tvistsömmar" "tvistsömmarna" ;
  tusendel_nn_1_N = mkN "tusendel" "tusendelen" "tusendelar" "tusendelarna" ;
  tusendedel_nn_1_N = mkN "tusendedel" "tusendedelen" "tusendedelar" "tusendedelarna" ;
  turiststroem_nn_1_1_N = mkN "turistström" "turistströmmen" "turistströmmar" "turistströmmarna" ;
  turistland_nn_1_N = mkN "turistland" "turistlandet" "turistländer" "turistländerna" ;
  tuppkam_nn_1_N = mkN "tuppkam" "tuppkammen" "tuppkammar" "tuppkammarna" ;
  tunnbinderi_nn_1_N = mkN "tunnbinderi" "tunnbinderit" "tunnbinderier" "tunnbinderierna" ;
  traesnideri_nn_1_1_N = mkN "träsnideri" "träsniderit" "träsniderier" "träsniderierna" ;
  traedstam_nn_1_1_N = mkN "trädstam" "trädstammen" "trädstammar" "trädstammarna" ;
  trae_nn_1_1_N = mkN "trä" "trät" "träer" "träerna" ;
  tryckeri_nn_1_N = mkN "tryckeri" "tryckerit" "tryckerier" "tryckerierna" ;
  trolleri_nn_1_N = mkN "trolleri" "trollerit" "trollerier" "trollerierna" ;
  triljondel_nn_1_N = mkN "triljondel" "triljondelen" "triljondelar" "triljondelarna" ;
  trettondel_nn_1_N = mkN "trettondel" "trettondelen" "trettondelar" "trettondelarna" ;
  trettiondel_nn_1_N = mkN "trettiondel" "trettiondelen" "trettiondelar" "trettiondelarna" ;
  trefasstroem_nn_1_1_N = mkN "trefasström" "trefasströmmen" "trefasströmmar" "trefasströmmarna" ;
  tredjedel_nn_1_N = mkN "tredjedel" "tredjedelen" "tredjedelar" "tredjedelarna" ;
  transfett_nn_1_N = mkN "transfett" "transfettet" "transfetter" "transfetterna" ;
  trakasseri_nn_1_N = mkN "trakasseri" "trakasserit" "trakasserier" "trakasserierna" ;
  trafikstroem_nn_1_1_N = mkN "trafikström" "trafikströmmen" "trafikströmmar" "trafikströmmarna" ;
  toxafen_nn_1_N = mkN "toxafen" "toxafenet" "toxafener" "toxafenerna" ;
  totalhaveri_nn_1_N = mkN "totalhaveri" "totalhaverit" "totalhaverier" "totalhaverierna" ;
  torsdagsmorgon_nn_1_N = mkN "torsdagsmorgon" "torsdagsmorgonen" "torsdagsmorgnar" "torsdagsmorgnarna" ;
  torsdagmorgon_nn_1_N = mkN "torsdagmorgon" "torsdagmorgonen" "torsdagmorgnar" "torsdagmorgnarna" ;
  torrbatteri_nn_1_N = mkN "torrbatteri" "torrbatterit" "torrbatterier" "torrbatterierna" ;
  torkeri_nn_1_N = mkN "torkeri" "torkerit" "torkerier" "torkerierna" ;
  tolvvoltsbatteri_nn_1_N = mkN "tolvvoltsbatteri" "tolvvoltsbatterit" "tolvvoltsbatterier" "tolvvoltsbatterierna" ;
  tolftedel_nn_1_N = mkN "tolftedel" "tolftedelen" "tolftedelar" "tolftedelarna" ;
  tokeri_nn_1_N = mkN "tokeri" "tokerit" "tokerier" "tokerierna" ;
  toddy_nn_1_N = mkN "toddy" "toddyn" "toddyar" "toddyarna" ;
  tjyveri_nn_1_N = mkN "tjyveri" "tjyverit" "tjyverier" "tjyverierna" ;
  tjuveri_nn_1_N = mkN "tjuveri" "tjuverit" "tjuverier" "tjuverierna" ;
  tjugondel_nn_1_N = mkN "tjugondel" "tjugondelen" "tjugondelar" "tjugondelarna" ;
  tjugondedel_nn_1_N = mkN "tjugondedel" "tjugondedelen" "tjugondedelar" "tjugondedelarna" ;
  tisdagsmorgon_nn_1_N = mkN "tisdagsmorgon" "tisdagsmorgonen" "tisdagsmorgnar" "tisdagsmorgnarna" ;
  tisdagmorgon_nn_1_N = mkN "tisdagmorgon" "tisdagmorgonen" "tisdagmorgnar" "tisdagmorgnarna" ;
  tiondel_nn_1_N = mkN "tiondel" "tiondelen" "tiondelar" "tiondelarna" ;
  tiondedel_nn_1_N = mkN "tiondedel" "tiondedelen" "tiondedelar" "tiondedelarna" ;
  tiggeri_nn_1_N = mkN "tiggeri" "tiggerit" "tiggerier" "tiggerierna" ;
  tidvattenstroem_nn_1_1_N = mkN "tidvattenström" "tidvattenströmmen" "tidvattenströmmar" "tidvattenströmmarna" ;
  the_nn_1_N = mkN "the" "thet" "theer" "theerna" ;
  textparti_nn_1_N = mkN "textparti" "textpartit" "textpartier" "textpartierna" ;
  testimonium_nn_1_N = mkN "testimonium" "testimoniet" "testimonier" "testimonierna" ;
  testbatteri_nn_1_N = mkN "testbatteri" "testbatterit" "testbatterier" "testbatterierna" ;
  teslastroem_nn_1_1_N = mkN "teslaström" "teslaströmmen" "teslaströmmar" "teslaströmmarna" ;
  territorium_nn_1_N = mkN "territorium" "territoriet" "territorier" "territorierna" ;
  terrarium_nn_1_N = mkN "terrarium" "terrariet" "terrarier" "terrarierna" ;
  ten_nn_1_N = mkN "ten" "tenen" "tenar" "tenarna" ;
  tellurium_nn_1_N = mkN "tellurium" "telluriet" "tellurier" "tellurierna" ;
  teatermaskineri_nn_1_N = mkN "teatermaskineri" "teatermaskinerit" "teatermaskinerier" "teatermaskinerierna" ;
  te_nn_1_N = mkN "te" "teet" "teer" "teerna" ;
  tavelgalleri_nn_1_N = mkN "tavelgalleri" "tavelgallerit" "tavelgallerier" "tavelgallerierna" ;
  taskspeleri_nn_1_N = mkN "taskspeleri" "taskspelerit" "taskspelerier" "taskspelerierna" ;
  tapisseri_nn_1_N = mkN "tapisseri" "tapisserit" "tapisserier" "tapisserierna" ;
  tamren_nn_1_N = mkN "tamren" "tamrenen" "tamrenar" "tamrenarna" ;
  tambursoem_nn_1_1_N = mkN "tambursöm" "tambursömmen" "tambursömmar" "tambursömmarna" ;
  tallstam_nn_1_N = mkN "tallstam" "tallstammen" "tallstammar" "tallstammarna" ;
  taktdel_nn_1_N = mkN "taktdel" "taktdelen" "taktdelar" "taktdelarna" ;
  takkam_nn_1_N = mkN "takkam" "takkammen" "takkammar" "takkammarna" ;
  soendagsmorgon_nn_1_1_N = mkN "söndagsmorgon" "söndagsmorgonen" "söndagsmorgnar" "söndagsmorgnarna" ;
  soendagmorgon_nn_1_1_N = mkN "söndagmorgon" "söndagmorgonen" "söndagmorgnar" "söndagmorgnarna" ;
  soem_nn_1_1_N = mkN "söm" "sömmen" "sömmar" "sömmarna" ;
  saetteri_nn_1_1_N = mkN "sätteri" "sätterit" "sätterier" "sätterierna" ;
  saeteri_nn_1_1_N = mkN "säteri" "säterit" "säterier" "säterierna" ;
  saekerhetsrelae_nn_1_1_N = mkN "säkerhetsrelä" "säkerhetsrelät" "säkerhetsreläer" "säkerhetsreläerna" ;
  symposium_nn_1_N = mkN "symposium" "symposiet" "symposier" "symposierna" ;
  svaangrem_nn_1_1_N = mkN "svångrem" "svångremmen" "svångremmar" "svångremmarna" ;
  svaermorsdroem_nn_1_1_N = mkN "svärmorsdröm" "svärmorsdrömmen" "svärmorsdrömmar" "svärmorsdrömmarna" ;
  svaermor_nn_1_1_N = mkN "svärmoder" "svärmodern" "svärmödrar" "svärmödrarna" ;
  svaermeri_nn_1_1_N = mkN "svärmeri" "svärmerit" "svärmerier" "svärmerierna" ;
  svinfett_nn_1_N = mkN "svinfett" "svinfettet" "svinfetter" "svinfetterna" ;
  svineri_nn_1_N = mkN "svineri" "svinerit" "svinerier" "svinerierna" ;
  svindleri_nn_1_N = mkN "svindleri" "svindlerit" "svindlerier" "svindlerierna" ;
  svettrem_nn_1_N = mkN "svettrem" "svettremmen" "svettremmar" "svettremmarna" ;
  svagstroem_nn_1_1_N = mkN "svagström" "svagströmmen" "svagströmmar" "svagströmmarna" ;
  suppositorium_nn_1_N = mkN "suppositorium" "suppositoriet" "suppositorier" "suppositorierna" ;
  supinum_nn_1_N = mkN "supinum" "supinum" "supiner" "supinerna" ;
  summer_nn_1_N = mkN "summer" "summern" "sumrar" "sumrarna" ;
  styvmor_nn_1_N = mkN "styvmoder" "styvmodern" "styvmödrar" "styvmödrarna" ;
  stygger_nn_1_N = mkN "stygger" "styggern" "styggar" "styggarna" ;
  stuveri_nn_1_N = mkN "stuveri" "stuverit" "stuverier" "stuverierna" ;
  stuteri_nn_1_N = mkN "stuteri" "stuterit" "stuterier" "stuterierna" ;
  studium_nn_1_N = mkN "studium" "studiet" "studier" "studierna" ;
  stroem_nn_1_1_N = mkN "ström" "strömmen" "strömmar" "strömmarna" ;
  strike_nn_1_N = mkN "strike" "strikeen" "strikear" "strikearna" ;
  storslam_nn_1_N = mkN "storslam" "storslammen" "storslammar" "storslammarna" ;
  storsegelbom_nn_1_N = mkN "storsegelbom" "storsegelbommen" "storsegelbommar" "storsegelbommarna" ;
  stolleri_nn_1_N = mkN "stolleri" "stollerit" "stollerier" "stollerierna" ;
  stipendium_nn_1_N = mkN "stipendium" "stipendiet" "stipendier" "stipendierna" ;
  stenoeken_nn_1_1_N = mkN "stenöken" "stenökenn" "stenöknar" "stenöknarna" ;
  stenparti_nn_1_N = mkN "stenparti" "stenpartit" "stenpartier" "stenpartierna" ;
  stenhuggeri_nn_1_N = mkN "stenhuggeri" "stenhuggerit" "stenhuggerier" "stenhuggerierna" ;
  sten_nn_1_N = mkN "sten" "stenen" "stenar" "stenarna" ;
  startbatteri_nn_1_N = mkN "startbatteri" "startbatterit" "startbatterier" "startbatterierna" ;
  starkvin_nn_1_N = mkN "starkvin" "starkvinet" "starkviner" "starkvinerna" ;
  starkstroem_nn_1_1_N = mkN "starkström" "starkströmmen" "starkströmmar" "starkströmmarna" ;
  standardinventarium_nn_1_N = mkN "standardinventarium" "standardinventariet" "standardinventarier" "standardinventarierna" ;
  standardhyckleri_nn_1_N = mkN "standardhyckleri" "standardhycklerit" "standardhycklerier" "standardhycklerierna" ;
  stam_nn_1_N = mkN "stam" "stammen" "stammar" "stammarna" ;
  stadium_nn_1_N = mkN "stadium" "stadiet" "stadier" "stadierna" ;
  stadion_nn_2_N = mkN "stadium" "stadiet" "stadier" "stadierna" ;
  stabskompani_nn_1_N = mkN "stabskompani" "stabskompanit" "stabskompanier" "stabskompanierna" ;
  spoekeri_nn_1_1_N = mkN "spökeri" "spökerit" "spökerier" "spökerierna" ;
  spaerrbom_nn_1_1_N = mkN "spärrbom" "spärrbommen" "spärrbommar" "spärrbommarna" ;
  spaennrem_nn_1_1_N = mkN "spännrem" "spännremmen" "spännremmar" "spännremmarna" ;
  spraakstam_nn_1_1_N = mkN "språkstam" "språkstammen" "språkstammar" "språkstammarna" ;
  spraaklaboratorium_nn_1_1_N = mkN "språklaboratorium" "språklaboratoriet" "språklaboratorier" "språklaboratorierna" ;
  sportgren_nn_1_N = mkN "sportgren" "sportgrenen" "sportgrenar" "sportgrenarna" ;
  sporangium_nn_1_N = mkN "sporangium" "sporangiet" "sporangier" "sporangierna" ;
  spioneri_nn_1_N = mkN "spioneri" "spionerit" "spionerier" "spionerierna" ;
  spinneri_nn_1_N = mkN "spinneri" "spinnerit" "spinnerier" "spinnerierna" ;
  spinnakerbom_nn_1_N = mkN "spinnakerbom" "spinnakerbommen" "spinnakerbommar" "spinnakerbommarna" ;
  spegelfaekteri_nn_1_1_N = mkN "spegelfäkteri" "spegelfäkterit" "spegelfäkterier" "spegelfäkterierna" ;
  specialstudium_nn_1_N = mkN "specialstudium" "specialstudiet" "specialstudier" "specialstudierna" ;
  spatium_nn_1_N = mkN "spatium" "spatiet" "spatier" "spatierna" ;
  sovmorgon_nn_1_N = mkN "sovmorgon" "sovmorgonen" "sovmorgnar" "sovmorgnarna" ;
  solbatteri_nn_1_N = mkN "solbatteri" "solbatterit" "solbatterier" "solbatterierna" ;
  solarium_nn_1_N = mkN "solarium" "solariet" "solarier" "solarierna" ;
  sofisteri_nn_1_N = mkN "sofisteri" "sofisterit" "sofisterier" "sofisterierna" ;
  sockerraffinaderi_nn_1_N = mkN "sockerraffinaderi" "sockerraffinaderit" "sockerraffinaderier" "sockerraffinaderierna" ;
  sockerbageri_nn_1_N = mkN "sockerbageri" "sockerbagerit" "sockerbagerier" "sockerbagerierna" ;
  snoermakeri_nn_1_1_N = mkN "snörmakeri" "snörmakerit" "snörmakerier" "snörmakerierna" ;
  snuskhummer_nn_1_N = mkN "snuskhummer" "snuskhummern" "snuskhumrar" "snuskhumrarna" ;
  snus_nn_1_N = mkN "snus" "snuset" "snuser" "snuserna" ;
  snobberi_nn_1_N = mkN "snobberi" "snobberit" "snobberier" "snobberierna" ;
  snideri_nn_1_N = mkN "snideri" "sniderit" "sniderier" "sniderierna" ;
  snickeri_nn_1_N = mkN "snickeri" "snickerit" "snickerier" "snickerierna" ;
  snatteri_nn_1_N = mkN "snatteri" "snatterit" "snatterier" "snatterierna" ;
  snaskeri_nn_1_N = mkN "snaskeri" "snaskerit" "snaskerier" "snaskerierna" ;
  smoer_nn_1_1_N = mkN "smör" "smöret" "smör" "smören" ;
  smaatteri_nn_1_1_N = mkN "småtteri" "småtterit" "småtterier" "småtterierna" ;
  smaasven_nn_1_1_N = mkN "småsven" "småsvennen" "småsvennar" "småsvennarna" ;
  smaelteri_nn_1_1_N = mkN "smälteri" "smälterit" "smälterier" "smälterierna" ;
  smygsoem_nn_1_1_N = mkN "smygsöm" "smygsömmen" "smygsömmar" "smygsömmarna" ;
  smuggleri_nn_1_N = mkN "smuggleri" "smugglerit" "smugglerier" "smugglerierna" ;
  smink_nn_1_N = mkN "smink" "sminket" "sminker" "sminkerna" ;
  smideri_nn_1_N = mkN "smideri" "smiderit" "smiderier" "smiderierna" ;
  slaedparti_nn_1_1_N = mkN "slädparti" "slädpartit" "slädpartier" "slädpartierna" ;
  slutklaem_nn_1_1_N = mkN "slutkläm" "slutklämmen" "slutklämmar" "slutklämmarna" ;
  slottsvin_nn_1_N = mkN "slottsvin" "slottsvinet" "slottsviner" "slottsvinerna" ;
  slom_nn_1_N = mkN "slom" "slommen" "slommar" "slommarna" ;
  sliperi_nn_1_N = mkN "sliperi" "sliperit" "sliperier" "sliperierna" ;
  slarverland_nn_1_N = mkN "slarverland" "slarverlandet" "slarverländer" "slarverländerna" ;
  slam_nn_2_N = mkN "slam" "slammen" "slammar" "slammarna" ;
  slakteri_nn_1_N = mkN "slakteri" "slakterit" "slakterier" "slakterierna" ;
  slagbom_nn_1_N = mkN "slagbom" "slagbommen" "slagbommar" "slagbommarna" ;
  skaadespelardroem_nn_1_1_N = mkN "skådespelardröm" "skådespelardrömmen" "skådespelardrömmar" "skådespelardrömmarna" ;
  skaeggtoem_nn_1_1_N = mkN "skäggtöm" "skäggtömmen" "skäggtömmar" "skäggtömmarna" ;
  skymmel_nn_2_N = mkN "skymmel" "skymmeln" "skymlar" "skymlarna" ;
  skraedderi_nn_1_1_N = mkN "skrädderi" "skrädderit" "skrädderier" "skrädderierna" ;
  skrymteri_nn_1_N = mkN "skrymteri" "skrymterit" "skrymterier" "skrymterierna" ;
  skriveri_nn_1_N = mkN "skriveri" "skriverit" "skriverier" "skriverierna" ;
  skriftstaelleri_nn_1_1_N = mkN "skriftställeri" "skriftställerit" "skriftställerier" "skriftställerierna" ;
  skomakeri_nn_1_N = mkN "skomakeri" "skomakerit" "skomakerier" "skomakerierna" ;
  skojeri_nn_1_N = mkN "skojeri" "skojerit" "skojerier" "skojerierna" ;
  skogsparti_nn_1_N = mkN "skogsparti" "skogspartit" "skogspartier" "skogspartierna" ;
  skimmel_nn_1_N = mkN "skimmel" "skimmeln" "skimlar" "skimlarna" ;
  skidgymnasium_nn_1_N = mkN "skidgymnasium" "skidgymnasiet" "skidgymnasier" "skidgymnasierna" ;
  skeppsbyggeri_nn_1_N = mkN "skeppsbyggeri" "skeppsbyggerit" "skeppsbyggerier" "skeppsbyggerierna" ;
  skandalskriveri_nn_1_N = mkN "skandalskriveri" "skandalskriverit" "skandalskriverier" "skandalskriverierna" ;
  skafferi_nn_1_N = mkN "skafferi" "skafferit" "skafferier" "skafferierna" ;
  sjoeroeveri_nn_1_1_N = mkN "sjöröveri" "sjöröverit" "sjöröverier" "sjöröverierna" ;
  sjoefartsmuseum_nn_1_1_N = mkN "sjöfartsmuseum" "sjöfartsmuseet" "sjöfartsmuseer" "sjöfartsmuseerna" ;
  sjaaperi_nn_1_1_N = mkN "sjåperi" "sjåperit" "sjåperier" "sjåperierna" ;
  sjaettedel_nn_1_1_N = mkN "sjättedel" "sjättedelen" "sjättedelar" "sjättedelarna" ;
  sjaelvstudium_nn_1_1_N = mkN "självstudium" "självstudiet" "självstudier" "självstudierna" ;
  sjaelvplaageri_nn_1_1_N = mkN "självplågeri" "självplågerit" "självplågerier" "självplågerierna" ;
  sjaelvbedraegeri_nn_1_1_N = mkN "självbedrägeri" "självbedrägerit" "självbedrägerier" "självbedrägerierna" ;
  sjundedel_nn_1_N = mkN "sjundedel" "sjundedelen" "sjundedelar" "sjundedelarna" ;
  silversalt_nn_1_N = mkN "silversalt" "silversaltet" "silversalter" "silversalterna" ;
  signeri_nn_1_N = mkN "signeri" "signerit" "signerier" "signerierna" ;
  sidendraperi_nn_1_N = mkN "sidendraperi" "sidendraperit" "sidendraperier" "sidendraperierna" ;
  shoppingcenter_nn_1_N = mkN "shoppingcenter" "shoppingcentret" "shoppingcentra" "shoppingcentran" ;
  sextrakasseri_nn_1_N = mkN "sextrakasseri" "sextrakasserit" "sextrakasserier" "sextrakasserierna" ;
  sextiaarsjubileum_nn_1_1_N = mkN "sextiårsjubileum" "sextiårsjubileet" "sextiårsjubileer" "sextiårsjubileerna" ;
  sextioaarsjubileum_nn_1_1_N = mkN "sextioårsjubileum" "sextioårsjubileet" "sextioårsjubileer" "sextioårsjubileerna" ;
  septennium_nn_1_N = mkN "septennium" "septenniet" "septennier" "septennierna" ;
  seminarium_nn_1_N = mkN "seminarium" "seminariumet" "seminarier" "seminarierna" ;
  sekundaerstroem_nn_1_1_N = mkN "sekundärström" "sekundärströmmen" "sekundärströmmar" "sekundärströmmarna" ;
  sekundaerstadium_nn_1_1_N = mkN "sekundärstadium" "sekundärstadiet" "sekundärstadier" "sekundärstadierna" ;
  segelmakeri_nn_1_N = mkN "segelmakeri" "segelmakerit" "segelmakerier" "segelmakerierna" ;
  schaeferi_nn_1_1_N = mkN "schäferi" "schäferit" "schäferier" "schäferierna" ;
  schweizeri_nn_1_N = mkN "schweizeri" "schweizerit" "schweizerier" "schweizerierna" ;
  schattersoem_nn_1_1_N = mkN "schattersöm" "schattersömmen" "schattersömmar" "schattersömmarna" ;
  schackparti_nn_1_N = mkN "schackparti" "schackpartit" "schackpartier" "schackpartierna" ;
  sceneri_nn_1_N = mkN "sceneri" "scenerit" "scenerier" "scenerierna" ;
  satsdel_nn_1_N = mkN "satsdel" "satsdelen" "satsdelar" "satsdelarna" ;
  saponin_nn_1_N = mkN "saponin" "saponinet" "saponiner" "saponinerna" ;
  sanndroem_nn_1_1_N = mkN "sanndröm" "sanndrömmen" "sanndrömmar" "sanndrömmarna" ;
  sanktuarium_nn_1_N = mkN "sanktuarium" "sanktuariet" "sanktuarier" "sanktuarierna" ;
  sanitetskompani_nn_1_N = mkN "sanitetskompani" "sanitetskompanit" "sanitetskompanier" "sanitetskompanierna" ;
  sandoeken_nn_1_1_N = mkN "sandöken" "sandökenn" "sandöknar" "sandöknarna" ;
  sanatorium_nn_1_N = mkN "sanatorium" "sanatoriet" "sanatorier" "sanatorierna" ;
  sammelsurium_nn_1_N = mkN "sammelsurium" "sammelsuriet" "sammelsurier" "sammelsurierna" ;
  samlingsparti_nn_1_N = mkN "samlingsparti" "samlingspartit" "samlingspartier" "samlingspartierna" ;
  sameland_nn_1_N = mkN "sameland" "samelandet" "sameländer" "sameländerna" ;
  saltoeken_nn_1_1_N = mkN "saltöken" "saltökenn" "saltöknar" "saltöknarna" ;
  salteri_nn_1_N = mkN "salteri" "salterit" "salterier" "salterierna" ;
  salt_nn_2_N = mkN "salt" "saltet" "salter" "salterna" ;
  salpetersjuderi_nn_1_N = mkN "salpetersjuderi" "salpetersjuderit" "salpetersjuderier" "salpetersjuderierna" ;
  sakrilegium_nn_1_N = mkN "sakrilegium" "sakrilegiet" "sakrilegier" "sakrilegierna" ;
  sagoland_nn_1_N = mkN "sagoland" "sagolandet" "sagoländer" "sagoländerna" ;
  sadelmakeri_nn_1_N = mkN "sadelmakeri" "sadelmakerit" "sadelmakerier" "sadelmakerierna" ;
  sadelbom_nn_1_N = mkN "sadelbom" "sadelbommen" "sadelbommar" "sadelbommarna" ;
  roeveri_nn_1_1_N = mkN "röveri" "röverit" "röverier" "röverierna" ;
  roerdrom_nn_1_1_N = mkN "rördrom" "rördrommen" "rördrommar" "rördrommarna" ;
  roekeri_nn_1_1_N = mkN "rökeri" "rökerit" "rökerier" "rökerierna" ;
  roedvin_nn_1_1_N = mkN "rödvin" "rödvinet" "rödviner" "rödvinerna" ;
  raenksmideri_nn_1_1_N = mkN "ränksmideri" "ränksmiderit" "ränksmiderier" "ränksmiderierna" ;
  ryggparti_nn_1_N = mkN "ryggparti" "ryggpartit" "ryggpartier" "ryggpartierna" ;
  rundmun_nn_1_N = mkN "rundmun" "rundmunnen" "rundmunnar" "rundmunnarna" ;
  rovdjursstam_nn_1_N = mkN "rovdjursstam" "rovdjursstammen" "rovdjursstammar" "rovdjursstammarna" ;
  rotisseri_nn_1_N = mkN "rotisseri" "rotisserit" "rotisserier" "rotisserierna" ;
  ros_evin_nn_1_1_N = mkN "rosévin" "rosévinet" "roséviner" "rosévinerna" ;
  rosteri_nn_1_N = mkN "rosteri" "rosterit" "rosterier" "rosterierna" ;
  rosenmun_nn_1_N = mkN "rosenmun" "rosenmunnen" "rosenmunnar" "rosenmunnarna" ;
  rofferi_nn_1_N = mkN "rofferi" "rofferit" "rofferier" "rofferierna" ;
  roderhaveri_nn_1_N = mkN "roderhaveri" "roderhaverit" "roderhaverier" "roderhaverierna" ;
  riksmuseum_nn_1_N = mkN "riksmuseum" "riksmuseet" "riksmuseer" "riksmuseerna" ;
  riksdagsparti_nn_1_N = mkN "riksdagsparti" "riksdagspartit" "riksdagspartier" "riksdagspartierna" ;
  rhenvin_nn_1_N = mkN "rhenvin" "rhenvinet" "rhenviner" "rhenvinerna" ;
  resonemangsparti_nn_1_N = mkN "resonemangsparti" "resonemangspartit" "resonemangspartier" "resonemangspartierna" ;
  resestipendium_nn_1_N = mkN "resestipendium" "resestipendiet" "resestipendier" "resestipendierna" ;
  repetitorium_nn_1_N = mkN "repetitorium" "repetitoriet" "repetitorier" "repetitorierna" ;
  renseri_nn_1_N = mkN "renseri" "renserit" "renserier" "renserierna" ;
  renhetsdroem_nn_1_1_N = mkN "renhetsdröm" "renhetsdrömmen" "renhetsdrömmar" "renhetsdrömmarna" ;
  rendezvous_nn_1_N = mkN "rendezvous" "rendezvouset" "rendezvouser" "rendezvouserna" ;
  ren_nn_1_N = mkN "ren" "renen" "renar" "renarna" ;
  rem_nn_1_N = mkN "rem" "remmen" "remmar" "remmarna" ;
  relae_nn_1_1_N = mkN "relä" "relät" "reläer" "reläerna" ;
  rekryteringsland_nn_1_N = mkN "rekryteringsland" "rekryteringslandet" "rekryteringsländer" "rekryteringsländerna" ;
  regeringsparti_nn_1_N = mkN "regeringsparti" "regeringspartit" "regeringspartier" "regeringspartierna" ;
  regeringsmedlem_nn_1_N = mkN "regeringsmedlem" "regeringsmedlemmen" "regeringsmedlemmar" "regeringsmedlemmarna" ;
  regeringskansli_nn_1_N = mkN "regeringskansli" "regeringskanslit" "regeringskanslier" "regeringskanslierna" ;
  refektorium_nn_1_N = mkN "refektorium" "refektoriet" "refektorier" "refektorierna" ;
  rederi_nn_1_N = mkN "rederi" "rederit" "rederier" "rederierna" ;
  raljeri_nn_1_N = mkN "raljeri" "raljerit" "raljerier" "raljerierna" ;
  raffinaderi_nn_1_N = mkN "raffinaderi" "raffinaderit" "raffinaderier" "raffinaderierna" ;
  paerldraperi_nn_1_1_N = mkN "pärldraperi" "pärldraperit" "pärldraperier" "pärldraperierna" ;
  paerlbroderi_nn_1_1_N = mkN "pärlbroderi" "pärlbroderit" "pärlbroderier" "pärlbroderierna" ;
  praangleri_nn_1_1_N = mkN "prångleri" "prånglerit" "prånglerier" "prånglerierna" ;
  praestseminarium_nn_1_1_N = mkN "prästseminarium" "prästseminariet" "prästseminarier" "prästseminarierna" ;
  prydnadssoem_nn_1_1_N = mkN "prydnadssöm" "prydnadssömmen" "prydnadssömmar" "prydnadssömmarna" ;
  prydnadskam_nn_1_N = mkN "prydnadskam" "prydnadskammen" "prydnadskammar" "prydnadskammarna" ;
  provisorium_nn_1_N = mkN "provisorium" "provisoriet" "provisorier" "provisorierna" ;
  protein_nn_1_N = mkN "protein" "proteinet" "proteiner" "proteinerna" ;
  prosteri_nn_1_N = mkN "prosteri" "prosterit" "prosterier" "prosterierna" ;
  proseminarium_nn_1_N = mkN "proseminarium" "proseminariet" "proseminarier" "proseminarierna" ;
  proscenium_nn_1_N = mkN "proscenium" "prosceniet" "proscenier" "proscenierna" ;
  programland_nn_1_N = mkN "programland" "programlandet" "programländer" "programländerna" ;
  problemformuleringsprivilegium_nn_1_N = mkN "problemformuleringsprivilegium" "problemformuleringsprivilegiet" "problemformuleringsprivilegier" "problemformuleringsprivilegierna" ;
  privilegium_nn_1_N = mkN "privilegium" "privilegiet" "privilegier" "privilegierna" ;
  preteritum_nn_1_N = mkN "preteritum" "preteritum" "preteriter" "preteriterna" ;
  presseri_nn_1_N = mkN "presseri" "presserit" "presserier" "presserierna" ;
  presidium_nn_1_N = mkN "presidium" "presidiet" "presidier" "presidierna" ;
  premium_nn_1_N = mkN "premium" "premiet" "premier" "premierna" ;
  preludium_nn_1_N = mkN "preludium" "preludiet" "preludier" "preludierna" ;
  potpurri_nn_1_N = mkN "potpurri" "potpurrit" "potpurrier" "potpurrierna" ;
  postseminarium_nn_1_N = mkN "postseminarium" "postseminariet" "postseminarier" "postseminarierna" ;
  postludium_nn_1_N = mkN "postludium" "postludiet" "postludier" "postludierna" ;
  portvin_nn_1_N = mkN "portvin" "portvinet" "portviner" "portvinerna" ;
  portionssnus_nn_1_N = mkN "portionssnus" "portionssnuset" "portionssnuser" "portionssnuserna" ;
  porslin_nn_1_N = mkN "porslin" "porslinet" "porsliner" "porslinerna" ;
  pokerparti_nn_1_N = mkN "pokerparti" "pokerpartit" "pokerpartier" "pokerpartierna" ;
  podium_nn_1_N = mkN "podium" "podiet" "podier" "podierna" ;
  plaatslageri_nn_1_1_N = mkN "plåtslageri" "plåtslagerit" "plåtslagerier" "plåtslagerierna" ;
  plattsoem_nn_1_1_N = mkN "plattsöm" "plattsömmen" "plattsömmar" "plattsömmarna" ;
  planetarium_nn_1_N = mkN "planetarium" "planetariet" "planetarier" "planetarierna" ;
  pikanteri_nn_1_N = mkN "pikanteri" "pikanterit" "pikanterier" "pikanterierna" ;
  persongalleri_nn_1_N = mkN "persongalleri" "persongallerit" "persongallerier" "persongallerierna" ;
  perborat_nn_1_N = mkN "perborat" "perboratet" "perborater" "perboraterna" ;
  penninghaeleri_nn_1_1_N = mkN "penninghäleri" "penninghälerit" "penninghälerier" "penninghälerierna" ;
  pen_nn_1_N = mkN "pen" "penen" "penar" "penarna" ;
  pedofilhysteri_nn_1_N = mkN "pedofilhysteri" "pedofilhysterit" "pedofilhysterier" "pedofilhysterierna" ;
  pedanteri_nn_1_N = mkN "pedanteri" "pedanterit" "pedanterier" "pedanterierna" ;
  partnerskapsland_nn_1_N = mkN "partnerskapsland" "partnerskapslandet" "partnerskapsländer" "partnerskapsländerna" ;
  partimedlem_nn_1_N = mkN "partimedlem" "partimedlemmen" "partimedlemmar" "partimedlemmarna" ;
  partikelstroem_nn_1_1_N = mkN "partikelström" "partikelströmmen" "partikelströmmar" "partikelströmmarna" ;
  partikellaboratorium_nn_1_N = mkN "partikellaboratorium" "partikellaboratoriet" "partikellaboratorier" "partikellaboratorierna" ;
  parti_nn_1_N = mkN "parti" "partit" "partier" "partierna" ;
  parfymeri_nn_1_N = mkN "parfymeri" "parfymerit" "parfymerier" "parfymerierna" ;
  parallelltrapets_nn_1_N = mkN "parallelltrapets" "parallelltrapetset" "parallelltrapetser" "parallelltrapetserna" ;
  papeteri_nn_1_N = mkN "papeteri" "papeterit" "papeterier" "papeterierna" ;
  palae_nn_1_1_N = mkN "palä" "palät" "paläer" "paläerna" ;
  palmvin_nn_1_N = mkN "palmvin" "palmvinet" "palmviner" "palmvinerna" ;
  palliativ_nn_1_N = mkN "palliativ" "palliativet" "palliativer" "palliativerna" ;
  ovarium_nn_1_N = mkN "ovarium" "ovariet" "ovarier" "ovarierna" ;
  ovandel_nn_1_N = mkN "ovandel" "ovandelen" "ovandelar" "ovandelarna" ;
  ossuarium_nn_1_N = mkN "ossuarium" "ossuariet" "ossuarier" "ossuarierna" ;
  ormgift_nn_1_N = mkN "ormgift" "ormgiftet" "ormgifter" "ormgifterna" ;
  orkestermedlem_nn_1_N = mkN "orkestermedlem" "orkestermedlemmen" "orkestermedlemmar" "orkestermedlemmarna" ;
  orgelpreludium_nn_1_N = mkN "orgelpreludium" "orgelpreludiet" "orgelpreludier" "orgelpreludierna" ;
  orgelharmonium_nn_1_N = mkN "orgelharmonium" "orgelharmoniet" "orgelharmonier" "orgelharmonierna" ;
  ordstam_nn_1_N = mkN "ordstam" "ordstammen" "ordstammar" "ordstammarna" ;
  ordrytteri_nn_1_N = mkN "ordrytteri" "ordrytterit" "ordrytterier" "ordrytterierna" ;
  ordklyveri_nn_1_N = mkN "ordklyveri" "ordklyverit" "ordklyverier" "ordklyverierna" ;
  ordfoerandeland_nn_1_1_N = mkN "ordförandeland" "ordförandelandet" "ordförandeländer" "ordförandeländerna" ;
  ordensmedlem_nn_1_N = mkN "ordensmedlem" "ordensmedlemmen" "ordensmedlemmar" "ordensmedlemmarna" ;
  oratorium_nn_1_N = mkN "oratorium" "oratoriet" "oratorier" "oratorierna" ;
  orangeri_nn_1_N = mkN "orangeri" "orangerit" "orangerier" "orangerierna" ;
  oppstroem_nn_1_1_N = mkN "oppström" "oppströmmen" "oppströmmar" "oppströmmarna" ;
  oppositionsparti_nn_1_N = mkN "oppositionsparti" "oppositionspartit" "oppositionspartier" "oppositionspartierna" ;
  operettland_nn_1_N = mkN "operettland" "operettlandet" "operettländer" "operettländerna" ;
  onsdagsmorgon_nn_1_N = mkN "onsdagsmorgon" "onsdagsmorgonen" "onsdagsmorgnar" "onsdagsmorgnarna" ;
  onsdagmorgon_nn_1_N = mkN "onsdagmorgon" "onsdagmorgonen" "onsdagmorgnar" "onsdagmorgnarna" ;
  oljeslageri_nn_1_N = mkN "oljeslageri" "oljeslagerit" "oljeslagerier" "oljeslagerierna" ;
  oljeraffinaderi_nn_1_N = mkN "oljeraffinaderi" "oljeraffinaderit" "oljeraffinaderier" "oljeraffinaderierna" ;
  oljeland_nn_1_N = mkN "oljeland" "oljelandet" "oljeländer" "oljeländerna" ;
  offertorium_nn_1_N = mkN "offertorium" "offertoriet" "offertorier" "offertorierna" ;
  observatorium_nn_1_N = mkN "observatorium" "observatoriet" "observatorier" "observatorierna" ;
  obligatorium_nn_1_N = mkN "obligatorium" "obligatoriet" "obligatorier" "obligatorierna" ;
  noerderi_nn_1_1_N = mkN "nörderi" "nörderit" "nörderier" "nörderierna" ;
  naeversoem_nn_1_1_N = mkN "näversöm" "näversömmen" "näversömmar" "näversömmarna" ;
  naetbedraegeri_nn_1_1_N = mkN "nätbedrägeri" "nätbedrägerit" "nätbedrägerier" "nätbedrägerierna" ;
  naerstudium_nn_1_1_N = mkN "närstudium" "närstudiet" "närstudier" "närstudierna" ;
  naersalt_nn_1_1_N = mkN "närsalt" "närsaltet" "närsalter" "närsalterna" ;
  naeringssalt_nn_1_1_N = mkN "näringssalt" "näringssaltet" "näringssalter" "näringssalterna" ;
  naeringsgren_nn_1_1_N = mkN "näringsgren" "näringsgrenen" "näringsgrenar" "näringsgrenarna" ;
  niondel_nn_1_N = mkN "niondel" "niondelen" "niondelar" "niondelarna" ;
  niondedel_nn_1_N = mkN "niondedel" "niondedelen" "niondedelar" "niondedelarna" ;
  nervgift_nn_1_N = mkN "nervgift" "nervgiftet" "nervgifter" "nervgifterna" ;
  nektarium_nn_1_N = mkN "nektarium" "nektariet" "nektarier" "nektarierna" ;
  natursceneri_nn_1_N = mkN "natursceneri" "naturscenerit" "naturscenerier" "naturscenerierna" ;
  nattvardsvin_nn_1_N = mkN "nattvardsvin" "nattvardsvinet" "nattvardsviner" "nattvardsvinerna" ;
  nattfrieri_nn_1_N = mkN "nattfrieri" "nattfrierit" "nattfrierier" "nattfrierierna" ;
  nationalmuseum_nn_1_N = mkN "nationalmuseum" "nationalmuseet" "nationalmuseer" "nationalmuseerna" ;
  nationalgalleri_nn_1_N = mkN "nationalgalleri" "nationalgallerit" "nationalgallerier" "nationalgallerierna" ;
  nagelsoem_nn_1_1_N = mkN "nagelsöm" "nagelsömmen" "nagelsömmar" "nagelsömmarna" ;
  nackdel_nn_1_N = mkN "nackdel" "nackdelen" "nackdelar" "nackdelarna" ;
  moessrem_nn_1_1_N = mkN "mössrem" "mössremmen" "mössremmar" "mössremmarna" ;
  moebelsnickeri_nn_1_1_N = mkN "möbelsnickeri" "möbelsnickerit" "möbelsnickerier" "möbelsnickerierna" ;
  maandagsmorgon_nn_1_1_N = mkN "måndagsmorgon" "måndagsmorgonen" "måndagsmorgnar" "måndagsmorgnarna" ;
  maandagmorgon_nn_1_1_N = mkN "måndagmorgon" "måndagmorgonen" "måndagmorgnar" "måndagmorgnarna" ;
  maaleri_nn_1_1_N = mkN "måleri" "målerit" "målerier" "målerierna" ;
  maelteri_nn_1_1_N = mkN "mälteri" "mälterit" "mälterier" "mälterierna" ;
  myteri_nn_1_N = mkN "myteri" "myterit" "myterier" "myterierna" ;
  mysterium_nn_1_N = mkN "mysterium" "mysteriet" "mysterier" "mysterierna" ;
  myrten_nn_1_N = mkN "myrten" "myrtenn" "myrtnar" "myrtnarna" ;
  mycelium_nn_1_N = mkN "mycelium" "myceliet" "mycelier" "mycelierna" ;
  musteri_nn_1_N = mkN "musteri" "musterit" "musterier" "musterierna" ;
  musikkonservatorium_nn_1_N = mkN "musikkonservatorium" "musikkonservatoriet" "musikkonservatorier" "musikkonservatorierna" ;
  musikkaf_e_nn_1_1_N = mkN "musikkafé" "musikkafét" "musikkaféer" "musikkaféerna" ;
  musikgymnasium_nn_1_N = mkN "musikgymnasium" "musikgymnasiet" "musikgymnasier" "musikgymnasierna" ;
  museum_nn_1_N = mkN "museum" "museet" "museer" "museerna" ;
  municipium_nn_1_N = mkN "municipium" "municipiet" "municipier" "municipierna" ;
  mun_nn_1_N = mkN "mun" "munnen" "munnar" "munnarna" ;
  motstroem_nn_1_1_N = mkN "motström" "motströmmen" "motströmmar" "motströmmarna" ;
  motgift_nn_1_N = mkN "motgift" "motgiftet" "motgifter" "motgifterna" ;
  moselvin_nn_1_N = mkN "moselvin" "moselvinet" "moselviner" "moselvinerna" ;
  mosaiksoem_nn_1_1_N = mkN "mosaiksöm" "mosaiksömmen" "mosaiksömmar" "mosaiksömmarna" ;
  mormorsmor_nn_1_N = mkN "mormorsmoder" "mormorsmodern" "mormorsmödrar" "mormorsmödrarna" ;
  mormor_nn_1_N = mkN "mormoder" "mormodern" "mormödrar" "mormödrarna" ;
  morgon_nn_1_N = mkN "morgon" "morgonen" "morgnar" "morgnarna" ;
  moratorium_nn_1_N = mkN "moratorium" "moratoriet" "moratorier" "moratorierna" ;
  mor_nn_1_N = mkN "moder" "modern" "mödrar" "mödrarna" ;
  modermun_nn_1_N = mkN "modermun" "modermunnen" "modermunnar" "modermunnarna" ;
  moderland_nn_1_N = mkN "moderland" "moderlandet" "moderländer" "moderländerna" ;
  mjoel_nn_1_1_N = mkN "mjöl" "mjölet" "mjöler" "mjölerna" ;
  mjukdel_nn_1_N = mkN "mjukdel" "mjukdelen" "mjukdelar" "mjukdelarna" ;
  mittparti_nn_1_N = mkN "mittparti" "mittpartit" "mittpartier" "mittpartierna" ;
  mittenparti_nn_1_N = mkN "mittenparti" "mittenpartit" "mittenpartier" "mittenpartierna" ;
  missnoejesparti_nn_1_1_N = mkN "missnöjesparti" "missnöjespartit" "missnöjespartier" "missnöjespartierna" ;
  ministerium_nn_1_N = mkN "ministerium" "ministeriet" "ministerier" "ministerierna" ;
  mineralsalt_nn_1_N = mkN "mineralsalt" "mineralsaltet" "mineralsalter" "mineralsalterna" ;
  mineralmuseum_nn_1_N = mkN "mineralmuseum" "mineralmuseet" "mineralmuseer" "mineralmuseerna" ;
  millennium_nn_1_N = mkN "millennium" "millenniet" "millennier" "millennierna" ;
  miljoeministerium_nn_1_1_N = mkN "miljöministerium" "miljöministeriet" "miljöministerier" "miljöministerierna" ;
  miljoegift_nn_1_1_N = mkN "miljögift" "miljögiftet" "miljögifter" "miljögifterna" ;
  miljondel_nn_1_N = mkN "miljondel" "miljondelen" "miljondelar" "miljondelarna" ;
  miljonbedraegeri_nn_1_1_N = mkN "miljonbedrägeri" "miljonbedrägerit" "miljonbedrägerier" "miljonbedrägerierna" ;
  miljarddel_nn_1_N = mkN "miljarddel" "miljarddelen" "miljarddelar" "miljarddelarna" ;
  milennium_nn_1_N = mkN "milennium" "milenniet" "milennier" "milennierna" ;
  mikrofonbom_nn_1_N = mkN "mikrofonbom" "mikrofonbommen" "mikrofonbommar" "mikrofonbommarna" ;
  mikrobryggeri_nn_1_N = mkN "mikrobryggeri" "mikrobryggerit" "mikrobryggerier" "mikrobryggerierna" ;
  menageri_nn_1_N = mkN "menageri" "menagerit" "menagerier" "menagerierna" ;
  mellanstadium_nn_1_N = mkN "mellanstadium" "mellanstadiet" "mellanstadier" "mellanstadierna" ;
  mellanparti_nn_1_N = mkN "mellanparti" "mellanpartit" "mellanpartier" "mellanpartierna" ;
  mejeri_nn_1_N = mkN "mejeri" "mejerit" "mejerier" "mejerierna" ;
  medstroem_nn_1_1_N = mkN "medström" "medströmmen" "medströmmar" "medströmmarna" ;
  medlemsland_nn_1_N = mkN "medlemsland" "medlemslandet" "medlemsländer" "medlemsländerna" ;
  medlem_nn_1_N = mkN "medlem" "medlemmen" "medlemmar" "medlemmarna" ;
  mausoleum_nn_1_N = mkN "mausoleum" "mausoleet" "mausoleer" "mausoleerna" ;
  matland_nn_1_N = mkN "matland" "matlandet" "matländer" "matländerna" ;
  matfett_nn_1_N = mkN "matfett" "matfettet" "matfetter" "matfetterna" ;
  materiestroem_nn_1_1_N = mkN "materieström" "materieströmmen" "materieströmmar" "materieströmmarna" ;
  maskinhaveri_nn_1_N = mkN "maskinhaveri" "maskinhaverit" "maskinhaverier" "maskinhaverierna" ;
  maskineri_nn_1_N = mkN "maskineri" "maskinerit" "maskinerier" "maskinerierna" ;
  martyrium_nn_1_N = mkN "martyrium" "martyriet" "martyrier" "martyrierna" ;
  marketeri_nn_1_N = mkN "marketeri" "marketerit" "marketerier" "marketerierna" ;
  marketenteri_nn_1_N = mkN "marketenteri" "marketenterit" "marketenterier" "marketenterierna" ;
  mardroem_nn_1_1_N = mkN "mardröm" "mardrömmen" "mardrömmar" "mardrömmarna" ;
  manslem_nn_1_N = mkN "manslem" "manslemmen" "manslemmar" "manslemmarna" ;
  mammutstam_nn_1_N = mkN "mammutstam" "mammutstammen" "mammutstammar" "mammutstammarna" ;
  malstroem_nn_1_1_N = mkN "malström" "malströmmen" "malströmmar" "malströmmarna" ;
  majmorgon_nn_1_N = mkN "majmorgon" "majmorgonen" "majmorgnar" "majmorgnarna" ;
  magmun_nn_1_N = mkN "magmun" "magmunnen" "magmunnar" "magmunnarna" ;
  loesgom_nn_1_1_N = mkN "lösgom" "lösgommen" "lösgommar" "lösgommarna" ;
  loerdagsmorgon_nn_1_1_N = mkN "lördagsmorgon" "lördagsmorgonen" "lördagsmorgnar" "lördagsmorgnarna" ;
  loerdagmorgon_nn_1_1_N = mkN "lördagmorgon" "lördagmorgonen" "lördagmorgnar" "lördagmorgnarna" ;
  loekstam_nn_1_1_N = mkN "lökstam" "lökstammen" "lökstammar" "lökstammarna" ;
  laatsasland_nn_1_1_N = mkN "låtsasland" "låtsaslandet" "låtsasländer" "låtsasländerna" ;
  laagstadium_nn_1_1_N = mkN "lågstadium" "lågstadiet" "lågstadier" "lågstadierna" ;
  laadvin_nn_1_1_N = mkN "lådvin" "lådvinet" "lådviner" "lådvinerna" ;
  laettvin_nn_1_1_N = mkN "lättvin" "lättvinet" "lättviner" "lättvinerna" ;
  laettmargarin_nn_1_1_N = mkN "lättmargarin" "lättmargarinet" "lättmargariner" "lättmargarinerna" ;
  laerarkollegium_nn_1_1_N = mkN "lärarkollegium" "lärarkollegiet" "lärarkollegier" "lärarkollegierna" ;
  laeppsnus_nn_1_1_N = mkN "läppsnus" "läppsnuset" "läppsnuser" "läppsnuserna" ;
  laeppsmink_nn_1_1_N = mkN "läppsmink" "läppsminket" "läppsminker" "läppsminkerna" ;
  laemmel_nn_1_1_N = mkN "lämmel" "lämmeln" "lämlar" "lämlarna" ;
  laem_nn_1_1_N = mkN "läm" "lämmen" "lämmar" "lämmarna" ;
  laeckergom_nn_1_1_N = mkN "läckergom" "läckergommen" "läckergommar" "läckergommarna" ;
  lysin_nn_1_N = mkN "lysin" "lysinet" "lysiner" "lysinerna" ;
  lymmel_nn_1_N = mkN "lymmel" "lymmeln" "lymlar" "lymlarna" ;
  lyceum_nn_1_N = mkN "lyceum" "lyceet" "lyceer" "lyceerna" ;
  lurendrejeri_nn_1_N = mkN "lurendrejeri" "lurendrejerit" "lurendrejerier" "lurendrejerierna" ;
  luftstroem_nn_1_1_N = mkN "luftström" "luftströmmen" "luftströmmar" "luftströmmarna" ;
  luciamorgon_nn_1_N = mkN "luciamorgon" "luciamorgonen" "luciamorgnar" "luciamorgnarna" ;
  lotteri_nn_1_N = mkN "lotteri" "lotterit" "lotterier" "lotterierna" ;
  lom_nn_1_N = mkN "lom" "lommen" "lommar" "lommarna" ;
  livstidsmedlem_nn_1_N = mkN "livstidsmedlem" "livstidsmedlemmen" "livstidsmedlemmar" "livstidsmedlemmarna" ;
  livr_e_nn_1_1_N = mkN "livré" "livrét" "livréer" "livréerna" ;
  livrem_nn_1_N = mkN "livrem" "livremmen" "livremmar" "livremmarna" ;
  livmodermun_nn_1_N = mkN "livmodermun" "livmodermunnen" "livmodermunnar" "livmodermunnarna" ;
  litiumbatteri_nn_1_N = mkN "litiumbatteri" "litiumbatterit" "litiumbatterier" "litiumbatterierna" ;
  linspinneri_nn_1_N = mkN "linspinneri" "linspinnerit" "linspinnerier" "linspinnerierna" ;
  lingeri_nn_1_N = mkN "lingeri" "lingerit" "lingerier" "lingerierna" ;
  limkokeri_nn_1_N = mkN "limkokeri" "limkokerit" "limkokerier" "limkokerierna" ;
  lillslam_nn_1_N = mkN "lillslam" "lillslammen" "lillslammar" "lillslammarna" ;
  likstroem_nn_1_1_N = mkN "likström" "likströmmen" "likströmmar" "likströmmarna" ;
  likgift_nn_1_N = mkN "likgift" "likgiftet" "likgifter" "likgifterna" ;
  lem_nn_1_N = mkN "lem" "lemmen" "lemmar" "lemmarna" ;
  legendarium_nn_1_N = mkN "legendarium" "legendariet" "legendarier" "legendarierna" ;
  lantvin_nn_1_N = mkN "lantvin" "lantvinet" "lantviner" "lantvinerna" ;
  lantmaeteri_nn_1_1_N = mkN "lantmäteri" "lantmäterit" "lantmäterier" "lantmäterierna" ;
  langarn_nn_1_N = mkN "langarn" "langarnet" "langarner" "langarnerna" ;
  landskansli_nn_1_N = mkN "landskansli" "landskanslit" "landskanslier" "landskanslierna" ;
  landsfoerraederi_nn_1_1_N = mkN "landsförräderi" "landsförräderit" "landsförräderier" "landsförräderierna" ;
  land_nn_1_N = mkN "land" "landet" "länder" "länderna" ;
  laddstroem_nn_1_1_N = mkN "laddström" "laddströmmen" "laddströmmar" "laddströmmarna" ;
  laddningsstroem_nn_1_1_N = mkN "laddningsström" "laddningsströmmen" "laddningsströmmar" "laddningsströmmarna" ;
  laboratorium_nn_1_N = mkN "laboratorium" "laboratoriet" "laboratorier" "laboratorierna" ;
  koettvin_nn_1_1_N = mkN "köttvin" "köttvinet" "köttviner" "köttvinerna" ;
  kaaseri_nn_1_1_N = mkN "kåseri" "kåserit" "kåserier" "kåserierna" ;
  kaarobligatorium_nn_1_1_N = mkN "kårobligatorium" "kårobligatoriet" "kårobligatorier" "kårobligatorierna" ;
  kaetteri_nn_1_1_N = mkN "kätteri" "kätterit" "kätterier" "kätterierna" ;
  kaernkraftshaveri_nn_1_1_N = mkN "kärnkraftshaveri" "kärnkraftshaverit" "kärnkraftshaverier" "kärnkraftshaverierna" ;
  kaendiseri_nn_1_1_N = mkN "kändiseri" "kändiserit" "kändiserier" "kändiserierna" ;
  kaekrem_nn_1_1_N = mkN "käkrem" "käkremmen" "käkremmar" "käkremmarna" ;
  kaekparti_nn_1_1_N = mkN "käkparti" "käkpartit" "käkpartier" "käkpartierna" ;
  kyrksocken_nn_1_N = mkN "kyrksocken" "kyrksockenn" "kyrksocknar" "kyrksocknarna" ;
  kymation_nn_1_N = mkN "kymatium" "kymatiet" "kymatier" "kymatierna" ;
  kvacksalveri_nn_1_N = mkN "kvacksalveri" "kvacksalverit" "kvacksalverier" "kvacksalverierna" ;
  kummel_nn_2_N = mkN "kummel" "kummeln" "kumlar" "kumlarna" ;
  kulturland_nn_1_N = mkN "kulturland" "kulturlandet" "kulturländer" "kulturländerna" ;
  kryperi_nn_1_N = mkN "kryperi" "kryperit" "kryperier" "kryperierna" ;
  krukmakeri_nn_1_N = mkN "krukmakeri" "krukmakerit" "krukmakerier" "krukmakerierna" ;
  kroppsfett_nn_1_N = mkN "kroppsfett" "kroppsfettet" "kroppsfetter" "kroppsfetterna" ;
  kroppsdel_nn_1_N = mkN "kroppsdel" "kroppsdelen" "kroppsdelar" "kroppsdelarna" ;
  kriterium_nn_1_N = mkN "kriterium" "kriteriet" "kriterier" "kriterierna" ;
  krematorium_nn_1_N = mkN "krematorium" "krematoriet" "krematorier" "krematorierna" ;
  kranium_nn_1_N = mkN "kranium" "kraniet" "kranier" "kranierna" ;
  kotteri_nn_1_N = mkN "kotteri" "kotterit" "kotterier" "kotterierna" ;
  kortbedraegeri_nn_1_1_N = mkN "kortbedrägeri" "kortbedrägerit" "kortbedrägerier" "kortbedrägerierna" ;
  korollarium_nn_1_N = mkN "korollarium" "korollariet" "korollarier" "korollarierna" ;
  koppleri_nn_1_N = mkN "koppleri" "kopplerit" "kopplerier" "kopplerierna" ;
  konviktorium_nn_1_N = mkN "konviktorium" "konviktoriet" "konviktorier" "konviktorierna" ;
  konvenansparti_nn_1_N = mkN "konvenansparti" "konvenanspartit" "konvenanspartier" "konvenanspartierna" ;
  konstmuseum_nn_1_N = mkN "konstmuseum" "konstmuseet" "konstmuseer" "konstmuseerna" ;
  konstharts_nn_1_N = mkN "konstharts" "konsthartset" "konsthartser" "konsthartserna" ;
  konstgalleri_nn_1_N = mkN "konstgalleri" "konstgallerit" "konstgallerier" "konstgallerierna" ;
  konsortium_nn_1_N = mkN "konsortium" "konsortiet" "konsortier" "konsortierna" ;
  konsonantstam_nn_1_N = mkN "konsonantstam" "konsonantstammen" "konsonantstammar" "konsonantstammarna" ;
  konsistorium_nn_1_N = mkN "konsistorium" "konsistoriet" "konsistorier" "konsistorierna" ;
  konsilium_nn_1_N = mkN "konsilium" "konsiliet" "konsilier" "konsilierna" ;
  konservatorium_nn_1_N = mkN "konservatorium" "konservatoriet" "konservatorier" "konservatorierna" ;
  konditori_nn_1_N = mkN "konditori" "konditorit" "konditorier" "konditorierna" ;
  kompendium_nn_1_N = mkN "kompendium" "kompendiet" "kompendier" "kompendierna" ;
  kompani_nn_1_N = mkN "kompani" "kompanit" "kompanier" "kompanierna" ;
  kommunistparti_nn_1_N = mkN "kommunistparti" "kommunistpartit" "kommunistpartier" "kommunistpartierna" ;
  kommunistland_nn_1_N = mkN "kommunistland" "kommunistlandet" "kommunistländer" "kommunistländerna" ;
  kommerskollegium_nn_1_N = mkN "kommerskollegium" "kommerskollegiet" "kommerskollegier" "kommerskollegierna" ;
  kolumbarium_nn_1_N = mkN "kolumbarium" "kolumbariet" "kolumbarier" "kolumbarierna" ;
  kollokvium_nn_1_N = mkN "kollokvium" "kollokviet" "kollokvier" "kollokvierna" ;
  kollegium_nn_1_N = mkN "kollegium" "kollegiet" "kollegier" "kollegierna" ;
  kol_14_laboratorium_nn_1_N = mkN "kol-14-laboratorium" "kol-14-laboratoriet" "kol-14-laboratorier" "kol-14-laboratorierna" ;
  koketteri_nn_1_N = mkN "koketteri" "koketterit" "koketterier" "koketterierna" ;
  kokeri_nn_1_N = mkN "kokeri" "kokerit" "kokerier" "kokerierna" ;
  knoelstam_nn_1_1_N = mkN "knölstam" "knölstammen" "knölstammar" "knölstammarna" ;
  knutbroderi_nn_1_N = mkN "knutbroderi" "knutbroderit" "knutbroderier" "knutbroderierna" ;
  kloevjeren_nn_1_1_N = mkN "klövjeren" "klövjerenen" "klövjerenar" "klövjerenarna" ;
  klaem_nn_1_1_N = mkN "kläm" "klämmen" "klämmar" "klämmarna" ;
  klyvarbom_nn_1_N = mkN "klyvarbom" "klyvarbommen" "klyvarbommar" "klyvarbommarna" ;
  klumpsoem_nn_1_1_N = mkN "klumpsöm" "klumpsömmen" "klumpsömmar" "klumpsömmarna" ;
  klubbmedlem_nn_1_N = mkN "klubbmedlem" "klubbmedlemmen" "klubbmedlemmar" "klubbmedlemmarna" ;
  klassresedroem_nn_1_1_N = mkN "klassresedröm" "klassresedrömmen" "klassresedrömmar" "klassresedrömmarna" ;
  klarlack_nn_1_N = mkN "klarlack" "klarlacket" "klarlacker" "klarlackerna" ;
  klanteri_nn_1_N = mkN "klanteri" "klanterit" "klanterier" "klanterierna" ;
  klammeri_nn_1_N = mkN "klammeri" "klammerit" "klammerier" "klammerierna" ;
  klam_nn_1_N = mkN "klam" "klammen" "klammar" "klammarna" ;
  kineseri_nn_1_N = mkN "kineseri" "kineserit" "kineserier" "kineserierna" ;
  kilrem_nn_1_N = mkN "kilrem" "kilremmen" "kilremmar" "kilremmarna" ;
  kedjesoem_nn_1_1_N = mkN "kedjesöm" "kedjesömmen" "kedjesömmar" "kedjesömmarna" ;
  kavalleri_nn_1_N = mkN "kavalleri" "kavallerit" "kavallerier" "kavallerierna" ;
  katastrofsceneri_nn_1_N = mkN "katastrofsceneri" "katastrofscenerit" "katastrofscenerier" "katastrofscenerierna" ;
  kastsoem_nn_1_1_N = mkN "kastsöm" "kastsömmen" "kastsömmar" "kastsömmarna" ;
  karotin_nn_1_N = mkN "karotin" "karotinet" "karotiner" "karotinerna" ;
  karosseri_nn_1_N = mkN "karosseri" "karosserit" "karosserier" "karosserierna" ;
  kaperi_nn_1_N = mkN "kaperi" "kaperit" "kaperier" "kaperierna" ;
  kantsoem_nn_1_1_N = mkN "kantsöm" "kantsömmen" "kantsömmar" "kantsömmarna" ;
  kansli_nn_1_N = mkN "kansli" "kanslit" "kanslier" "kanslierna" ;
  kanongjuteri_nn_1_N = mkN "kanongjuteri" "kanongjuterit" "kanongjuterier" "kanongjuterierna" ;
  kannstoeperi_nn_1_1_N = mkN "kannstöperi" "kannstöperit" "kannstöperier" "kannstöperierna" ;
  kam_nn_1_N = mkN "kam" "kammen" "kammar" "kammarna" ;
  kalkbraenneri_nn_1_1_N = mkN "kalkbränneri" "kalkbrännerit" "kalkbrännerier" "kalkbrännerierna" ;
  kalisalt_nn_1_N = mkN "kalisalt" "kalisaltet" "kalisalter" "kalisalterna" ;
  kalenderbiteri_nn_1_N = mkN "kalenderbiteri" "kalenderbiterit" "kalenderbiterier" "kalenderbiterierna" ;
  kalendarium_nn_1_N = mkN "kalendarium" "kalendariet" "kalendarier" "kalendarierna" ;
  kaf_e_nn_1_1_N = mkN "kafé" "kafét" "kaféer" "kaféerna" ;
  kafferosteri_nn_1_N = mkN "kafferosteri" "kafferosterit" "kafferosterier" "kafferosterierna" ;
  kafe_nn_1_N = mkN "kafe" "kafet" "kafeer" "kafeerna" ;
  jaernsalt_nn_1_1_N = mkN "järnsalt" "järnsaltet" "järnsalter" "järnsalterna" ;
  jaegarkompani_nn_1_1_N = mkN "jägarkompani" "jägarkompanit" "jägarkompanier" "jägarkompanierna" ;
  julhysteri_nn_1_N = mkN "julhysteri" "julhysterit" "julhysterier" "julhysterierna" ;
  julevangelium_nn_1_N = mkN "julevangelium" "julevangeliet" "julevangelier" "julevangelierna" ;
  juldagsmorgon_nn_1_N = mkN "juldagsmorgon" "juldagsmorgonen" "juldagsmorgnar" "juldagsmorgnarna" ;
  jubileum_nn_1_N = mkN "jubileum" "jubileet" "jubileer" "jubileerna" ;
  jordstroem_nn_1_1_N = mkN "jordström" "jordströmmen" "jordströmmar" "jordströmmarna" ;
  jordstam_nn_1_N = mkN "jordstam" "jordstammen" "jordstammar" "jordstammarna" ;
  jobberi_nn_1_N = mkN "jobberi" "jobberit" "jobberier" "jobberierna" ;
  jetstroem_nn_1_1_N = mkN "jetström" "jetströmmen" "jetströmmar" "jetströmmarna" ;
  inventarium_nn_1_N = mkN "inventarium" "inventariet" "inventarier" "inventarierna" ;
  interludium_nn_1_N = mkN "interludium" "interludiet" "interludier" "interludierna" ;
  instroem_nn_1_1_N = mkN "inström" "inströmmen" "inströmmar" "inströmmarna" ;
  instrumentarium_nn_1_N = mkN "instrumentarium" "instrumentariet" "instrumentarier" "instrumentarierna" ;
  insomningsdroem_nn_1_1_N = mkN "insomningsdröm" "insomningsdrömmen" "insomningsdrömmar" "insomningsdrömmarna" ;
  insektsgift_nn_1_N = mkN "insektsgift" "insektsgiftet" "insektsgifter" "insektsgifterna" ;
  ingenium_nn_1_N = mkN "ingenium" "ingeniet" "ingenier" "ingenierna" ;
  infanterikompani_nn_1_N = mkN "infanterikompani" "infanterikompanit" "infanterikompanier" "infanterikompanierna" ;
  industriland_nn_1_N = mkN "industriland" "industrilandet" "industriländer" "industriländerna" ;
  indicium_nn_1_N = mkN "indicium" "indiciet" "indicier" "indicierna" ;
  indianstam_nn_1_N = mkN "indianstam" "indianstammen" "indianstammar" "indianstammarna" ;
  imperium_nn_1_N = mkN "imperium" "imperiet" "imperier" "imperierna" ;
  idrottskompani_nn_1_N = mkN "idrottskompani" "idrottskompanit" "idrottskompanier" "idrottskompanierna" ;
  idrottsgymnasium_nn_1_N = mkN "idrottsgymnasium" "idrottsgymnasiet" "idrottsgymnasier" "idrottsgymnasierna" ;
  idrottsgren_nn_1_N = mkN "idrottsgren" "idrottsgrenen" "idrottsgrenar" "idrottsgrenarna" ;
  i_land_nn_1_N = mkN "i-land" "i-landet" "i-länder" "i-länderna" ;
  hoenseri_nn_1_1_N = mkN "hönseri" "hönserit" "hönserier" "hönserierna" ;
  hoekeri_nn_1_1_N = mkN "hökeri" "hökerit" "hökerier" "hökerierna" ;
  hoegstadium_nn_1_1_N = mkN "högstadium" "högstadiet" "högstadier" "högstadierna" ;
  hoegland_nn_1_1_N = mkN "högland" "höglandet" "högländer" "högländerna" ;
  hoegglansvax_nn_1_1_N = mkN "högglansvax" "högglansvaxet" "högglansvaxer" "högglansvaxerna" ;
  hoegfoerraederi_nn_1_1_N = mkN "högförräderi" "högförräderit" "högförräderier" "högförräderierna" ;
  hoegerparti_nn_1_1_N = mkN "högerparti" "högerpartit" "högerpartier" "högerpartierna" ;
  hoeftparti_nn_1_1_N = mkN "höftparti" "höftpartit" "höftpartier" "höftpartierna" ;
  haarrem_nn_1_1_N = mkN "hårrem" "hårremmen" "hårremmar" "hårremmarna" ;
  haarklyveri_nn_1_1_N = mkN "hårklyveri" "hårklyverit" "hårklyverier" "hårklyverierna" ;
  haexeri_nn_1_1_N = mkN "häxeri" "häxerit" "häxerier" "häxerierna" ;
  haengparti_nn_1_1_N = mkN "hängparti" "hängpartit" "hängpartier" "hängpartierna" ;
  haelsocenter_nn_1_1_N = mkN "hälsocenter" "hälsocentret" "hälsocentrer" "hälsocentrerna" ;
  haeleri_nn_1_1_N = mkN "häleri" "hälerit" "hälerier" "hälerierna" ;
  hyckleri_nn_1_N = mkN "hyckleri" "hycklerit" "hycklerier" "hycklerierna" ;
  husmor_nn_1_N = mkN "husmoder" "husmodern" "husmödrar" "husmödrarna" ;
  hundraaarsjubileum_nn_1_1_N = mkN "hundraårsjubileum" "hundraårsjubileet" "hundraårsjubileer" "hundraårsjubileerna" ;
  hummer_nn_1_N = mkN "hummer" "hummern" "humrar" "humrarna" ;
  horologium_nn_1_N = mkN "horologium" "horologiet" "horologier" "horologierna" ;
  hjaernstam_nn_1_1_N = mkN "hjärnstam" "hjärnstammen" "hjärnstammar" "hjärnstammarna" ;
  hivstam_nn_1_N = mkN "hivstam" "hivstammen" "hivstammar" "hivstammarna" ;
  histamin_nn_1_N = mkN "histamin" "histaminet" "histaminer" "histaminerna" ;
  hetvin_nn_1_N = mkN "hetvin" "hetvinet" "hetviner" "hetvinerna" ;
  herbarium_nn_1_N = mkN "herbarium" "herbariet" "herbarier" "herbarierna" ;
  hen_nn_1_N = mkN "hen" "henen" "henar" "henarna" ;
  hemlighetsmakeri_nn_1_N = mkN "hemlighetsmakeri" "hemlighetsmakerit" "hemlighetsmakerier" "hemlighetsmakerierna" ;
  hemland_nn_1_N = mkN "hemland" "hemlandet" "hemländer" "hemländerna" ;
  hembageri_nn_1_N = mkN "hembageri" "hembagerit" "hembagerier" "hembagerierna" ;
  hedersmedlem_nn_1_N = mkN "hedersmedlem" "hedersmedlemmen" "hedersmedlemmar" "hedersmedlemmarna" ;
  hederskompani_nn_1_N = mkN "hederskompani" "hederskompanit" "hederskompanier" "hederskompanierna" ;
  havsstroem_nn_1_1_N = mkN "havsström" "havsströmmen" "havsströmmar" "havsströmmarna" ;
  haveri_nn_1_N = mkN "haveri" "haverit" "haverier" "haverierna" ;
  harts_nn_1_N = mkN "harts" "hartset" "hartser" "hartserna" ;
  harmonium_nn_1_N = mkN "harmonium" "harmoniet" "harmonier" "harmonierna" ;
  hardangersoem_nn_1_1_N = mkN "hardangersöm" "hardangersömmen" "hardangersömmar" "hardangersömmarna" ;
  handrem_nn_1_N = mkN "handrem" "handremmen" "handremmar" "handremmarna" ;
  handelskompani_nn_1_N = mkN "handelskompani" "handelskompanit" "handelskompanier" "handelskompanierna" ;
  handelsgymnasium_nn_1_N = mkN "handelsgymnasium" "handelsgymnasiet" "handelsgymnasier" "handelsgymnasierna" ;
  hammel_nn_1_N = mkN "hammel" "hammeln" "hamlar" "hamlarna" ;
  halsrem_nn_1_N = mkN "halsrem" "halsremmen" "halsremmar" "halsremmarna" ;
  goepen_nn_1_1_N = mkN "göpen" "göpenn" "göpnar" "göpnarna" ;
  gaestgiveri_nn_1_1_N = mkN "gästgiveri" "gästgiverit" "gästgiverier" "gästgiverierna" ;
  gaelbgjuteri_nn_1_1_N = mkN "gälbgjuteri" "gälbgjuterit" "gälbgjuterier" "gälbgjuterierna" ;
  gaeckeri_nn_1_1_N = mkN "gäckeri" "gäckerit" "gäckerier" "gäckerierna" ;
  gymnasium_nn_1_N = mkN "gymnasium" "gymnasiet" "gymnasier" "gymnasierna" ;
  gyckleri_nn_1_N = mkN "gyckleri" "gycklerit" "gycklerier" "gycklerierna" ;
  gummiharts_nn_1_N = mkN "gummiharts" "gummihartset" "gummihartser" "gummihartserna" ;
  guldslageri_nn_1_N = mkN "guldslageri" "guldslagerit" "guldslagerier" "guldslagerierna" ;
  guldmakeri_nn_1_N = mkN "guldmakeri" "guldmakerit" "guldmakerier" "guldmakerierna" ;
  gulddrageri_nn_1_N = mkN "gulddrageri" "gulddragerit" "gulddragerier" "gulddragerierna" ;
  gudmor_nn_1_N = mkN "gudmoder" "gudmodern" "gudmödrar" "gudmödrarna" ;
  guanin_nn_1_N = mkN "guanin" "guaninet" "guaniner" "guaninerna" ;
  graaskimmel_nn_1_1_N = mkN "gråskimmel" "gråskimmeln" "gråskimlar" "gråskimlarna" ;
  grundstam_nn_1_N = mkN "grundstam" "grundstammen" "grundstammar" "grundstammarna" ;
  grubbleri_nn_1_N = mkN "grubbleri" "grubblerit" "grubblerier" "grubblerierna" ;
  groteskeri_nn_1_N = mkN "groteskeri" "groteskerit" "groteskerier" "groteskerierna" ;
  grisplaageri_nn_1_1_N = mkN "grisplågeri" "grisplågerit" "grisplågerier" "grisplågerierna" ;
  griseri_nn_1_N = mkN "griseri" "griserit" "griserier" "griserierna" ;
  grillfaengeri_nn_1_1_N = mkN "grillfängeri" "grillfängerit" "grillfängerier" "grillfängerierna" ;
  gren_nn_1_N = mkN "gren" "grenen" "grenar" "grenarna" ;
  granstam_nn_1_N = mkN "granstam" "granstammen" "granstammar" "granstammarna" ;
  grannland_nn_1_N = mkN "grannland" "grannlandet" "grannländer" "grannländerna" ;
  gom_nn_1_N = mkN "gom" "gommen" "gommar" "gommarna" ;
  golvvax_nn_1_N = mkN "golvvax" "golvvaxet" "golvvaxer" "golvvaxerna" ;
  golvlack_nn_1_N = mkN "golvlack" "golvlacket" "golvlacker" "golvlackerna" ;
  gobelaengbroderi_nn_1_1_N = mkN "gobelängbroderi" "gobelängbroderit" "gobelängbroderier" "gobelängbroderierna" ;
  gloedstroem_nn_1_1_N = mkN "glödström" "glödströmmen" "glödströmmar" "glödströmmarna" ;
  glossarium_nn_1_N = mkN "glossarium" "glossariet" "glossarier" "glossarierna" ;
  glasmaesteri_nn_1_1_N = mkN "glasmästeri" "glasmästerit" "glasmästerier" "glasmästerierna" ;
  glasblaaseri_nn_1_1_N = mkN "glasblåseri" "glasblåserit" "glasblåserier" "glasblåserierna" ;
  gjuteri_nn_1_N = mkN "gjuteri" "gjuterit" "gjuterier" "gjuterierna" ;
  gift_nn_1_N = mkN "gift" "giftet" "gifter" "gifterna" ;
  gevaerskompani_nn_1_1_N = mkN "gevärskompani" "gevärskompanit" "gevärskompanier" "gevärskompanierna" ;
  gevaersfaktori_nn_1_1_N = mkN "gevärsfaktori" "gevärsfaktorit" "gevärsfaktorier" "gevärsfaktorierna" ;
  gerundivum_nn_1_N = mkN "gerundivum" "gerundivum" "gerundiver" "gerundiverna" ;
  gerundium_nn_1_N = mkN "gerundium" "gerundium" "gerundier" "gerundierna" ;
  germanstam_nn_1_N = mkN "germanstam" "germanstammen" "germanstammar" "germanstammarna" ;
  geni_nn_1_N = mkN "geni" "genit" "genier" "genierna" ;
  gelbgjuteri_nn_1_N = mkN "gelbgjuteri" "gelbgjuterit" "gelbgjuterier" "gelbgjuterierna" ;
  gel_nn_1_N = mkN "gel" "gelet" "geler" "gelerna" ;
  gasstroem_nn_1_1_N = mkN "gasström" "gasströmmen" "gasströmmar" "gasströmmarna" ;
  garveri_nn_1_N = mkN "garveri" "garverit" "garverier" "garverierna" ;
  garnbom_nn_1_N = mkN "garnbom" "garnbommen" "garnbommar" "garnbommarna" ;
  galleri_nn_1_N = mkN "galleri" "gallerit" "gallerier" "gallerierna" ;
  galanteri_nn_1_N = mkN "galanteri" "galanterit" "galanterier" "galanterierna" ;
  foersoeksgymnasium_nn_1_1_N = mkN "försöksgymnasium" "försöksgymnasiet" "försöksgymnasier" "försöksgymnasierna" ;
  foersaekringsbedraegeri_nn_1_1_N = mkN "försäkringsbedrägeri" "försäkringsbedrägerit" "försäkringsbedrägerier" "försäkringsbedrägerierna" ;
  foersvarsgren_nn_1_1_N = mkN "försvarsgren" "försvarsgrenen" "försvarsgrenar" "försvarsgrenarna" ;
  foerstadium_nn_1_1_N = mkN "förstadium" "förstadiet" "förstadier" "förstadierna" ;
  foersamlingsmedlem_nn_1_1_N = mkN "församlingsmedlem" "församlingsmedlemmen" "församlingsmedlemmar" "församlingsmedlemmarna" ;
  foerraederi_nn_1_1_N = mkN "förräderi" "förräderit" "förräderier" "förräderierna" ;
  foerintelsemuseum_nn_1_1_N = mkN "förintelsemuseum" "förintelsemuseet" "förintelsemuseer" "förintelsemuseerna" ;
  foerhoersrumssceneri_nn_1_1_N = mkN "förhörsrumssceneri" "förhörsrumsscenerit" "förhörsrumsscenerier" "förhörsrumsscenerierna" ;
  foerdel_nn_1_1_N = mkN "fördel" "fördelen" "fördelar" "fördelarna" ;
  foegderi_nn_1_1_N = mkN "fögderi" "fögderit" "fögderier" "fögderierna" ;
  foedgeni_nn_1_1_N = mkN "födgeni" "födgeniet" "födgenier" "födgenierna" ;
  faaneri_nn_1_1_N = mkN "fåneri" "fånerit" "fånerier" "fånerierna" ;
  faagelkam_nn_1_1_N = mkN "fågelkam" "fågelkammen" "fågelkammar" "fågelkammarna" ;
  faergeri_nn_1_1_N = mkN "färgeri" "färgerit" "färgerier" "färgerierna" ;
  faeltstudium_nn_1_1_N = mkN "fältstudium" "fältstudiet" "fältstudier" "fältstudierna" ;
  faedernesland_nn_1_1_N = mkN "fädernesland" "fäderneslandet" "fädernesländer" "fädernesländerna" ;
  fyrverkeri_nn_1_N = mkN "fyrverkeri" "fyrverkerit" "fyrverkerier" "fyrverkerierna" ;
  futurum_nn_1_N = mkN "futurum" "futurum" "futurer" "futurerna" ;
  froeparti_nn_1_1_N = mkN "fröparti" "fröpartit" "fröpartier" "fröpartierna" ;
  fraeken_nn_1_1_N = mkN "fräken" "fräkenn" "fräknar" "fräknarna" ;
  fryseri_nn_1_N = mkN "fryseri" "fryserit" "fryserier" "fryserierna" ;
  fruktvin_nn_1_N = mkN "fruktvin" "fruktvinet" "fruktviner" "fruktvinerna" ;
  friluftsmuseum_nn_1_N = mkN "friluftsmuseum" "friluftsmuseet" "friluftsmuseer" "friluftsmuseerna" ;
  frieri_nn_1_N = mkN "frieri" "frierit" "frierier" "frierierna" ;
  fribyteri_nn_1_N = mkN "fribyteri" "fribyterit" "fribyterier" "fribyterierna" ;
  fredagsmorgon_nn_1_N = mkN "fredagsmorgon" "fredagsmorgonen" "fredagsmorgnar" "fredagsmorgnarna" ;
  fredagmorgon_nn_1_N = mkN "fredagmorgon" "fredagmorgonen" "fredagmorgnar" "fredagmorgnarna" ;
  frasmakeri_nn_1_N = mkN "frasmakeri" "frasmakerit" "frasmakerier" "frasmakerierna" ;
  framtidsland_nn_1_N = mkN "framtidsland" "framtidslandet" "framtidsländer" "framtidsländerna" ;
  framtidsdroem_nn_1_1_N = mkN "framtidsdröm" "framtidsdrömmen" "framtidsdrömmar" "framtidsdrömmarna" ;
  framstegsparti_nn_1_N = mkN "framstegsparti" "framstegspartit" "framstegspartier" "framstegspartierna" ;
  framstam_nn_1_N = mkN "framstam" "framstammen" "framstammar" "framstammarna" ;
  fotografi_nn_1_N = mkN "fotografi" "fotografit" "fotografier" "fotografierna" ;
  fostermor_nn_1_N = mkN "fostermoder" "fostermodern" "fostermödrar" "fostermödrarna" ;
  fosterland_nn_1_N = mkN "fosterland" "fosterlandet" "fosterländer" "fosterländerna" ;
  forskningslaboratorium_nn_1_N = mkN "forskningslaboratorium" "forskningslaboratoriet" "forskningslaboratorier" "forskningslaboratorierna" ;
  forskningscenter_nn_1_N = mkN "forskningscenter" "forskningscentret" "forskningscentrer" "forskningscentrerna" ;
  folkstam_nn_1_N = mkN "folkstam" "folkstammen" "folkstammar" "folkstammarna" ;
  folkparti_nn_1_N = mkN "folkparti" "folkpartit" "folkpartier" "folkpartierna" ;
  folkland_nn_1_N = mkN "folkland" "folklandet" "folkländer" "folkländerna" ;
  flygfotografi_nn_1_N = mkN "flygfotografi" "flygfotografit" "flygfotografier" "flygfotografierna" ;
  florilegium_nn_1_N = mkN "florilegium" "florilegiet" "florilegier" "florilegierna" ;
  flerbarnsmor_nn_1_N = mkN "flerbarnsmoder" "flerbarnsmodern" "flerbarnsmödrar" "flerbarnsmödrarna" ;
  fjaellaemmel_nn_1_1_N = mkN "fjällämmel" "fjällämmeln" "fjällämlar" "fjällämlarna" ;
  fjaellparti_nn_1_1_N = mkN "fjällparti" "fjällpartit" "fjällpartier" "fjällpartierna" ;
  fjomperi_nn_1_N = mkN "fjomperi" "fjomperit" "fjomperier" "fjomperierna" ;
  fjolleri_nn_1_N = mkN "fjolleri" "fjollerit" "fjollerier" "fjollerierna" ;
  fjanteri_nn_1_N = mkN "fjanteri" "fjanterit" "fjanterier" "fjanterierna" ;
  fixkam_nn_1_N = mkN "fixkam" "fixkammen" "fixkammar" "fixkammarna" ;
  fiskvin_nn_1_N = mkN "fiskvin" "fiskvinet" "fiskviner" "fiskvinerna" ;
  fiskmun_nn_1_N = mkN "fiskmun" "fiskmunnen" "fiskmunnar" "fiskmunnarna" ;
  fiskeri_nn_1_N = mkN "fiskeri" "fiskerit" "fiskerier" "fiskerierna" ;
  finsnickeri_nn_1_N = mkN "finsnickeri" "finsnickerit" "finsnickerier" "finsnickerierna" ;
  fiendeland_nn_1_N = mkN "fiendeland" "fiendelandet" "fiendeländer" "fiendeländerna" ;
  fett_nn_1_N = mkN "fett" "fettet" "fetter" "fetterna" ;
  femtioaarsjubileum_nn_1_1_N = mkN "femtioårsjubileum" "femtioårsjubileet" "femtioårsjubileer" "femtioårsjubileerna" ;
  femtedel_nn_1_N = mkN "femtedel" "femtedelen" "femtedelar" "femtedelarna" ;
  feeri_nn_1_N = mkN "feeri" "feerit" "feerier" "feerierna" ;
  feberdroem_nn_1_1_N = mkN "feberdröm" "feberdrömmen" "feberdrömmar" "feberdrömmarna" ;
  farmor_nn_1_N = mkN "farmoder" "farmodern" "farmödrar" "farmödrarna" ;
  fantasteri_nn_1_N = mkN "fantasteri" "fantasterit" "fantasterier" "fantasterierna" ;
  familjemedlem_nn_1_N = mkN "familjemedlem" "familjemedlemmen" "familjemedlemmar" "familjemedlemmarna" ;
  falsarium_nn_1_N = mkN "falsarium" "falsariet" "falsarier" "falsarierna" ;
  faktori_nn_1_N = mkN "faktori" "faktorit" "faktorier" "faktorierna" ;
  experimentgymnasium_nn_1_N = mkN "experimentgymnasium" "experimentgymnasiet" "experimentgymnasier" "experimentgymnasierna" ;
  exkrement_nn_1_N = mkN "exkrement" "exkrementet" "exkrementer" "exkrementerna" ;
  examinatorium_nn_1_N = mkN "examinatorium" "examinatoriumet" "examinatorier" "examinatorierna" ;
  evangelium_nn_1_N = mkN "evangelium" "evangeliet" "evangelier" "evangelierna" ;
  euroland_nn_1_N = mkN "euroland" "eurolandet" "euroländer" "euroländerna" ;
  epitafium_nn_1_N = mkN "epitafium" "epitafiet" "epitafier" "epitafierna" ;
  epitaf_nn_1_N = mkN "epitaf" "epitafet" "epitafer" "epitaferna" ;
  enhetsparti_nn_1_N = mkN "enhetsparti" "enhetspartit" "enhetspartier" "enhetspartierna" ;
  enfraageparti_nn_1_1_N = mkN "enfrågeparti" "enfrågepartit" "enfrågepartier" "enfrågepartierna" ;
  endorfin_nn_1_N = mkN "endorfin" "endorfinet" "endorfiner" "endorfinerna" ;
  en_nn_1_N = mkN "en" "enen" "enar" "enarna" ;
  emaljlack_nn_1_N = mkN "emaljlack" "emaljlacket" "emaljlacker" "emaljlackerna" ;
  elstroem_nn_1_1_N = mkN "elström" "elströmmen" "elströmmar" "elströmmarna" ;
  ekvatorialstroem_nn_1_1_N = mkN "ekvatorialström" "ekvatorialströmmen" "ekvatorialströmmar" "ekvatorialströmmarna" ;
  ekovin_nn_1_N = mkN "ekovin" "ekovinet" "ekoviner" "ekovinerna" ;
  efterkrigsdecennium_nn_1_N = mkN "efterkrigsdecennium" "efterkrigsdecenniet" "efterkrigsdecennier" "efterkrigsdecennierna" ;
  effektsoekeri_nn_1_1_N = mkN "effektsökeri" "effektsökerit" "effektsökerier" "effektsökerierna" ;
  duschdraperi_nn_1_N = mkN "duschdraperi" "duschdraperit" "duschdraperier" "duschdraperierna" ;
  dummer_nn_1_N = mkN "dummer" "dummern" "dumrar" "dumrarna" ;
  dumbom_nn_1_N = mkN "dumbom" "dumbommen" "dumbommar" "dumbommarna" ;
  dubbelsalt_nn_1_N = mkN "dubbelsalt" "dubbelsaltet" "dubbelsalter" "dubbelsalterna" ;
  droemmeri_nn_1_1_N = mkN "drömmeri" "drömmerit" "drömmerier" "drömmerierna" ;
  droem_nn_1_1_N = mkN "dröm" "drömmen" "drömmar" "drömmarna" ;
  drummel_nn_1_N = mkN "drummel" "drummeln" "drumlar" "drumlarna" ;
  drogeri_nn_1_N = mkN "drogeri" "drogerit" "drogerier" "drogerierna" ;
  drivrem_nn_1_N = mkN "drivrem" "drivremmen" "drivremmar" "drivremmarna" ;
  draperi_nn_1_N = mkN "draperi" "draperit" "draperier" "draperierna" ;
  dormitorium_nn_1_N = mkN "dormitorium" "dormitoriet" "dormitorier" "dormitorierna" ;
  dominion_nn_1_N = mkN "dominion" "dominion" "dominier" "dominierna" ;
  diplomatarium_nn_1_N = mkN "diplomatarium" "diplomatariet" "diplomatarier" "diplomatarierna" ;
  dioxin_nn_1_N = mkN "dioxin" "dioxinet" "dioxiner" "dioxinerna" ;
  dilleri_nn_1_N = mkN "dilleri" "dillerit" "dillerier" "dillerierna" ;
  dikesren_nn_1_N = mkN "dikesren" "dikesrenen" "dikesrenar" "dikesrenarna" ;
  diarium_nn_1_N = mkN "diarium" "diariet" "diarier" "diarierna" ;
  dialogparti_nn_1_N = mkN "dialogparti" "dialogpartit" "dialogpartier" "dialogpartierna" ;
  detaljstudium_nn_1_N = mkN "detaljstudium" "detaljstudiet" "detaljstudier" "detaljstudierna" ;
  dessertvin_nn_1_N = mkN "dessertvin" "dessertvinet" "dessertviner" "dessertvinerna" ;
  del_nn_1_N = mkN "del" "delen" "delar" "delarna" ;
  decennium_nn_1_N = mkN "decennium" "decenniet" "decennier" "decennierna" ;
  datorhaveri_nn_1_N = mkN "datorhaveri" "datorhaverit" "datorhaverier" "datorhaverierna" ;
  datahaveri_nn_1_N = mkN "datahaveri" "datahaverit" "datahaverier" "datahaverierna" ;
  dagdroemmeri_nn_1_1_N = mkN "dagdrömmeri" "dagdrömmerit" "dagdrömmerier" "dagdrömmerierna" ;
  dagdroem_nn_1_1_N = mkN "dagdröm" "dagdrömmen" "dagdrömmar" "dagdrömmarna" ;
  corps_de_logi_nn_1_N = mkN "corps-de-logi" "corps-de-logit" "corps-de-logier" "corps-de-logierna" ;
  clowneri_nn_1_N = mkN "clowneri" "clownerit" "clownerier" "clownerierna" ;
  chassi_nn_1_N = mkN "chassi" "chassit" "chassier" "chassierna" ;
  charlataneri_nn_1_N = mkN "charlataneri" "charlatanerit" "charlatanerier" "charlatanerierna" ;
  charkuteri_nn_1_N = mkN "charkuteri" "charkuteriet" "charkuterier" "charkuterierna" ;
  certeparti_nn_1_N = mkN "certeparti" "certepartiet" "certepartier" "certepartierna" ;
  centerparti_nn_1_N = mkN "centerparti" "centerpartiet" "centerpartier" "centerpartierna" ;
  center_nn_2_N = mkN "center" "centret" "centra" "centran" ;
  cellgift_nn_1_N = mkN "cellgift" "cellgiftet" "cellgifter" "cellgifterna" ;
  caf_e_nn_1_1_N = mkN "café" "caféet" "caféer" "caféerna" ;
  cafe_nn_1_N = mkN "cafe" "cafet" "cafeer" "cafeerna" ;
  baatbyggeri_nn_1_1_N = mkN "båtbyggeri" "båtbyggerit" "båtbyggerier" "båtbyggerierna" ;
  baerrem_nn_1_1_N = mkN "bärrem" "bärremmen" "bärremmar" "bärremmarna" ;
  burleskeri_nn_1_N = mkN "burleskeri" "burleskerit" "burleskerier" "burleskerierna" ;
  broestparti_nn_1_1_N = mkN "bröstparti" "bröstpartit" "bröstpartier" "bröstpartierna" ;
  broedskriveri_nn_1_1_N = mkN "brödskriveri" "brödskriverit" "brödskriverier" "brödskriverierna" ;
  braennvinsdestilleri_nn_1_1_N = mkN "brännvinsdestilleri" "brännvinsdestillerit" "brännvinsdestillerier" "brännvinsdestillerierna" ;
  braennvinsbraenneri_nn_1_1_N = mkN "brännvinsbränneri" "brännvinsbrännerit" "brännvinsbrännerier" "brännvinsbrännerierna" ;
  braennvin_nn_1_1_N = mkN "brännvin" "brännvinet" "brännviner" "brännvinerna" ;
  braenneri_nn_1_1_N = mkN "bränneri" "brännerit" "brännerier" "brännerierna" ;
  bryggeri_nn_1_N = mkN "bryggeri" "bryggerit" "bryggerier" "bryggerierna" ;
  bryderi_nn_1_N = mkN "bryderi" "bryderit" "bryderier" "bryderierna" ;
  brudgum_nn_1_N = mkN "brudgum" "brudgummen" "brudgummar" "brudgummarna" ;
  brodersoem_nn_1_1_N = mkN "brodersöm" "brodersömmen" "brodersömmar" "brodersömmarna" ;
  broderland_nn_1_N = mkN "broderland" "broderlandet" "broderländer" "broderländerna" ;
  broderi_nn_1_N = mkN "broderi" "broderit" "broderier" "broderierna" ;
  breviarium_nn_1_N = mkN "breviarium" "breviariet" "breviarier" "breviarierna" ;
  bredmun_nn_1_N = mkN "bredmun" "bredmunnen" "bredmunnar" "bredmunnarna" ;
  bourgognevin_nn_1_N = mkN "bourgognevin" "bourgognevinet" "bourgogneviner" "bourgognevinerna" ;
  borstbinderi_nn_1_N = mkN "borstbinderi" "borstbinderit" "borstbinderier" "borstbinderierna" ;
  bordsvin_nn_1_N = mkN "bordsvin" "bordsvinet" "bordsviner" "bordsvinerna" ;
  bordsmargarin_nn_1_N = mkN "bordsmargarin" "bordsmargarinet" "bordsmargariner" "bordsmargarinerna" ;
  bordeauxvin_nn_1_N = mkN "bordeauxvin" "bordeauxvinet" "bordeauxviner" "bordeauxvinerna" ;
  bonvax_nn_1_N = mkN "bonvax" "bonvaxet" "bonvaxer" "bonvaxerna" ;
  bomullsspinneri_nn_1_N = mkN "bomullsspinneri" "bomullsspinnerit" "bomullsspinnerier" "bomullsspinnerierna" ;
  bom_nn_1_N = mkN "bom" "bommen" "bommar" "bommarna" ;
  boktryckeri_nn_1_N = mkN "boktryckeri" "boktryckerit" "boktryckerier" "boktryckerierna" ;
  bokstipendium_nn_1_N = mkN "bokstipendium" "bokstipendiet" "bokstipendier" "bokstipendierna" ;
  bokbinderi_nn_1_N = mkN "bokbinderi" "bokbinderit" "bokbinderier" "bokbinderierna" ;
  bodmeri_nn_1_N = mkN "bodmeri" "bodmerit" "bodmerier" "bodmerierna" ;
  blybatteri_nn_1_N = mkN "blybatteri" "blybatterit" "blybatterier" "blybatterierna" ;
  blodprotein_nn_1_N = mkN "blodprotein" "blodproteinet" "blodproteiner" "blodproteinerna" ;
  blindparti_nn_1_N = mkN "blindparti" "blindpartit" "blindpartier" "blindpartierna" ;
  blekeri_nn_1_N = mkN "blekeri" "blekerit" "blekerier" "blekerierna" ;
  bleckslageri_nn_1_N = mkN "bleckslageri" "bleckslagerit" "bleckslagerier" "bleckslagerierna" ;
  bistaandsland_nn_1_1_N = mkN "biståndsland" "biståndslandet" "biståndsländer" "biståndsländerna" ;
  bisarreri_nn_1_N = mkN "bisarreri" "bisarrerit" "bisarrerier" "bisarrerierna" ;
  binderi_nn_1_N = mkN "binderi" "binderit" "binderier" "binderierna" ;
  bilvax_nn_1_N = mkN "bilvax" "bilvaxet" "bilvaxer" "bilvaxerna" ;
  bildsnideri_nn_1_N = mkN "bildsnideri" "bildsniderit" "bildsniderier" "bildsniderierna" ;
  bildhuggeri_nn_1_N = mkN "bildhuggeri" "bildhuggerit" "bildhuggerier" "bildhuggerierna" ;
  bildgalleri_nn_1_N = mkN "bildgalleri" "bildgallerit" "bildgallerier" "bildgallerierna" ;
  bilbyggeri_nn_1_N = mkN "bilbyggeri" "bilbyggerit" "bilbyggerier" "bilbyggerierna" ;
  bilbatteri_nn_1_N = mkN "bilbatteri" "bilbatterit" "bilbatterier" "bilbatterierna" ;
  biland_nn_1_N = mkN "biland" "bilandet" "biländer" "biländerna" ;
  bigotteri_nn_1_N = mkN "bigotteri" "bigotterit" "bigotterier" "bigotterierna" ;
  bigift_nn_1_N = mkN "bigift" "bigiftet" "bigifter" "bigifterna" ;
  betongparti_nn_1_N = mkN "betongparti" "betongpartit" "betongpartier" "betongpartierna" ;
  besaettningsmedlem_nn_1_1_N = mkN "besättningsmedlem" "besättningsmedlemmen" "besättningsmedlemmar" "besättningsmedlemmarna" ;
  bestaandsdel_nn_1_1_N = mkN "beståndsdel" "beståndsdelen" "beståndsdelar" "beståndsdelarna" ;
  bergsstam_nn_1_N = mkN "bergsstam" "bergsstammen" "bergsstammar" "bergsstammarna" ;
  bergskam_nn_1_N = mkN "bergskam" "bergskammen" "bergskammar" "bergskammarna" ;
  bergkam_nn_1_N = mkN "bergkam" "bergkammen" "bergkammar" "bergkammarna" ;
  benporslin_nn_1_N = mkN "benporslin" "benporslinet" "benporsliner" "benporslinerna" ;
  beneficium_nn_1_N = mkN "beneficium" "beneficiet" "beneficier" "beneficierna" ;
  belysningsstroem_nn_1_1_N = mkN "belysningsström" "belysningsströmmen" "belysningsströmmar" "belysningsströmmarna" ;
  begynnelsestadium_nn_1_N = mkN "begynnelsestadium" "begynnelsestadiet" "begynnelsestadier" "begynnelsestadierna" ;
  bedraegeri_nn_1_1_N = mkN "bedrägeri" "bedrägerit" "bedrägerier" "bedrägerierna" ;
  batteri_nn_1_N = mkN "batteri" "batteriet" "batterier" "batterierna" ;
  bariumsalt_nn_1_N = mkN "bariumsalt" "bariumsaltet" "bariumsalter" "bariumsalterna" ;
  baptisterium_nn_1_N = mkN "baptisterium" "baptisteriet" "baptisterier" "baptisterierna" ;
  bandmedlem_nn_1_N = mkN "bandmedlem" "bandmedlemmen" "bandmedlemmar" "bandmedlemmarna" ;
  bakstroem_nn_1_1_N = mkN "bakström" "bakströmmen" "bakströmmar" "bakströmmarna" ;
  bagerimargarin_nn_1_N = mkN "bagerimargarin" "bagerimargarinet" "bagerimargariner" "bagerimargarinerna" ;
  bageri_nn_1_N = mkN "bageri" "bageriet" "bagerier" "bagerierna" ;
  badsalt_nn_1_N = mkN "badsalt" "badsaltet" "badsalter" "badsalterna" ;
  backstroem_nn_1_1_N = mkN "backström" "backströmmen" "backströmmar" "backströmmarna" ;
  backhammer_nn_1_N = mkN "backhammer" "backhammern" "backhamrar" "backhamrarna" ;
  axelrem_nn_1_N = mkN "axelrem" "axelremmen" "axelremmar" "axelremmarna" ;
  aviarium_nn_1_N = mkN "aviarium" "aviariet" "aviarier" "aviarierna" ;
  auditorium_nn_1_N = mkN "auditorium" "auditoriet" "auditorier" "auditorierna" ;
  atrium_nn_1_N = mkN "atrium" "atriet" "atrier" "atrierna" ;
  astrofotografi_nn_1_N = mkN "astrofotografi" "astrofotografit" "astrofotografier" "astrofotografierna" ;
  arvland_nn_1_N = mkN "arvland" "arvlandet" "arvländer" "arvländerna" ;
  arvedel_nn_1_N = mkN "arvedel" "arvedelen" "arvedelar" "arvedelarna" ;
  artilleribatteri_nn_1_N = mkN "artilleribatteri" "artilleribatterit" "artilleribatterier" "artilleribatterierna" ;
  arbetarstam_nn_1_N = mkN "arbetarstam" "arbetarstammen" "arbetarstammar" "arbetarstammarna" ;
  arbetarparti_nn_1_N = mkN "arbetarparti" "arbetarpartit" "arbetarpartier" "arbetarpartierna" ;
  arbetareparti_nn_1_N = mkN "arbetareparti" "arbetarepartit" "arbetarepartier" "arbetarepartierna" ;
  arabland_nn_1_N = mkN "arabland" "arablandet" "arabländer" "arabländerna" ;
  aphelium_nn_1_N = mkN "aphelium" "apheliet" "aphelier" "aphelierna" ;
  antihistamin_nn_1_N = mkN "antihistamin" "antihistaminet" "antihistaminer" "antihistaminerna" ;
  antidot_nn_1_N = mkN "antidot" "antidotet" "antidoter" "antidoterna" ;
  antependium_nn_1_N = mkN "antependium" "antependiet" "antependier" "antependierna" ;
  angiveri_nn_1_N = mkN "angiveri" "angiverit" "angiverier" "angiverierna" ;
  alpland_nn_1_N = mkN "alpland" "alplandet" "alpländer" "alpländerna" ;
  alluvium_nn_1_N = mkN "alluvium" "alluviumet" "alluvier" "alluvierna" ;
  allodium_nn_1_N = mkN "allodium" "allodiet" "allodier" "allodierna" ;
  allod_nn_1_N = mkN "allod" "allodet" "alloder" "alloderna" ;
  alliansparti_nn_1_N = mkN "alliansparti" "allianspartit" "allianspartier" "allianspartierna" ;
  alkali_nn_1_N = mkN "alkali" "alkalit" "alkalier" "alkalierna" ;
  akvarium_nn_1_N = mkN "akvarium" "akvariet" "akvarier" "akvarierna" ;
  aktionsstroem_nn_1_1_N = mkN "aktionsström" "aktionsströmmen" "aktionsströmmar" "aktionsströmmarna" ;
  akterdel_nn_1_N = mkN "akterdel" "akterdelen" "akterdelar" "akterdelarna" ;
  afrokam_nn_1_N = mkN "afrokam" "afrokammen" "afrokammar" "afrokammarna" ;
  afelium_nn_1_N = mkN "afelium" "afeliet" "afelier" "afelierna" ;
  adelsprivilegium_nn_1_N = mkN "adelsprivilegium" "adelsprivilegiet" "adelsprivilegier" "adelsprivilegierna" ;
  abstrakt_nn_1_N = mkN "abstrakt" "abstraktet" "abstrakter" "abstrakterna" ;
  _60_aarsjubileum_nn_1_1_N = mkN "60-årsjubileum" "60-årsjubileet" "60-årsjubileer" "60-årsjubileerna" ;
  _3_fasstroem_nn_1_1_N = mkN "3-fasström" "3-fasströmmen" "3-fasströmmar" "3-fasströmmarna" ;
  Vadstenadiarium_nn_1_N = mkN "Vadstenadiarium" "Vadstenadiariet" "Vadstenadiarier" "Vadstenadiarierna" ;
  U_land_nn_1_N = mkN "U-land" "U-landet" "U-länder" "U-länderna" ;
  OECD_land_nn_1_N = mkN "OECD-land" "OECD-landet" "OECD-länder" "OECD-länderna" ;
  Medelhavsland_nn_1_N = mkN "Medelhavsland" "Medelhavslandet" "Medelhavsländer" "Medelhavsländerna" ;
  Malmoekaf_e_nn_1_1_N = mkN "Malmökafé" "Malmökafét" "Malmökaféer" "Malmökaféerna" ;
  I_land_nn_1_N = mkN "I-land" "I-landet" "I-länder" "I-länderna" ;
  Efta_land_nn_1_N = mkN "Efta-land" "Efta-landet" "Efta-länder" "Efta-länderna" ;
  EU_land_nn_1_N = mkN "EU-land" "EU-landet" "EU-länder" "EU-länderna" ;
  Delftporslin_nn_1_N = mkN "Delftporslin" "Delftporslinet" "Delftporsliner" "Delftporslinerna" ;
  C_vitamin_nn_1_N = mkN "C-vitamin" "C-vitaminet" "C-vitaminer" "C-vitaminerna" ;
  B_vitamin_nn_1_N = mkN "B-vitamin" "B-vitaminet" "B-vitaminer" "B-vitaminerna" ;
  A_vitamin_nn_1_N = mkN "A-vitamin" "A-vitaminet" "A-vitaminer" "A-vitaminerna" ;
  Munchlitografi_nn_1_N = mkN "Munchlitografi" "Munchlitografier" ;
  abb_e_nn_1_1_N = mkN "abbé" "abbéer" ;
  abc_bok_nn_1_N = mkN "abc-bok" "abc-böcker" ;
  afasi_nn_1_N = mkN "afasi" "afasier" ;
  affaersid_e_nn_1_1_N = mkN "affärsidé" "affärsidéer" ;
  agnosi_nn_1_N = mkN "agnosi" "agnosier" ;
  agoni_nn_1_N = mkN "agoni" "agonier" ;
  akademi_nn_1_N = mkN "akademi" "akademier" ;
  akromegali_nn_1_N = mkN "akromegali" "akromegalier" ;
  alexi_nn_1_N = mkN "alexi" "alexier" ;
  allegori_nn_1_N = mkN "allegori" "allegorier" ;
  allergi_nn_1_N = mkN "allergi" "allergier" ;
  alpget_nn_1_N = mkN "alpget" "alpgetter" ;
  ami_nn_1_N = mkN "ami" "amier" ;
  amnesi_nn_1_N = mkN "amnesi" "amnesier" ;
  amnesti_nn_1_N = mkN "amnesti" "amnestier" ;
  amyotrofi_nn_1_N = mkN "amyotrofi" "amyotrofier" ;
  analogi_nn_1_N = mkN "analogi" "analogier" ;
  andaktsbok_nn_1_N = mkN "andaktsbok" "andaktsböcker" ;
  anemi_nn_1_N = mkN "anemi" "anemier" ;
  anestesi_nn_1_N = mkN "anestesi" "anestesier" ;
  angoraget_nn_1_N = mkN "angoraget" "angoragetter" ;
  annotationsbok_nn_1_N = mkN "annotationsbok" "annotationsböcker" ;
  anomali_nn_1_N = mkN "anomali" "anomalier" ;
  anomi_nn_1_N = mkN "anomi" "anomier" ;
  anorexi_nn_1_N = mkN "anorexi" "anorexier" ;
  anteckningsbok_nn_1_N = mkN "anteckningsbok" "anteckningsböcker" ;
  antifoni_nn_1_N = mkN "antifoni" "antifonier" ;
  antinomi_nn_1_N = mkN "antinomi" "antinomier" ;
  antipati_nn_1_N = mkN "antipati" "antipatier" ;
  antologi_nn_1_N = mkN "antologi" "antologier" ;
  apati_nn_1_N = mkN "apati" "apatier" ;
  apologi_nn_1_N = mkN "apologi" "apologier" ;
  apoplexi_nn_1_N = mkN "apoplexi" "apoplexier" ;
  approximationsteori_nn_1_N = mkN "approximationsteori" "approximationsteorier" ;
  arbetsbok_nn_1_N = mkN "arbetsbok" "arbetsböcker" ;
  aristokrati_nn_1_N = mkN "aristokrati" "aristokratier" ;
  arrowrot_nn_1_N = mkN "arrowrot" "arrowrötter" ;
  artbildningsteori_nn_1_N = mkN "artbildningsteori" "artbildningsteorier" ;
  arytmi_nn_1_N = mkN "arytmi" "arytmier" ;
  asteni_nn_1_N = mkN "asteni" "astenier" ;
  asymmetri_nn_1_N = mkN "asymmetri" "asymmetrier" ;
  ataxi_nn_1_N = mkN "ataxi" "ataxier" ;
  atomteori_nn_1_N = mkN "atomteori" "atomteorier" ;
  atoni_nn_1_N = mkN "atoni" "atonier" ;
  atrofi_nn_1_N = mkN "atrofi" "atrofier" ;
  atypi_nn_1_N = mkN "atypi" "atypier" ;
  autarki_nn_1_N = mkN "autarki" "autarkier" ;
  autopsi_nn_1_N = mkN "autopsi" "autopsier" ;
  autotypi_nn_1_N = mkN "autotypi" "autotypier" ;
  avi_nn_1_N = mkN "avi" "avier" ;
  avsnoerningsteori_nn_1_1_N = mkN "avsnörningsteori" "avsnörningsteorier" ;
  bakfot_nn_1_N = mkN "bakfot" "bakfötter" ;
  baklaengesordbok_nn_1_1_N = mkN "baklängesordbok" "baklängesordböcker" ;
  bankbok_nn_1_N = mkN "bankbok" "bankböcker" ;
  bankkamrer_nn_1_N = mkN "bankkamrer" "bankkamrerer" ;
  barnbok_nn_1_N = mkN "barnbok" "barnböcker" ;
  barnkoloni_nn_1_N = mkN "barnkoloni" "barnkolonier" ;
  begravningsbok_nn_1_N = mkN "begravningsbok" "begravningsböcker" ;
  begravningsceremoni_nn_1_N = mkN "begravningsceremoni" "begravningsceremonier" ;
  benget_nn_1_N = mkN "benget" "bengetter" ;
  bergsget_nn_1_N = mkN "bergsget" "bergsgetter" ;
  beslutshierarki_nn_1_N = mkN "beslutshierarki" "beslutshierarkier" ;
  besoeksbok_nn_1_1_N = mkN "besöksbok" "besöksböcker" ;
  betelnoet_nn_1_1_N = mkN "betelnöt" "betelnötter" ;
  betsockerindustri_nn_1_N = mkN "betsockerindustri" "betsockerindustrier" ;
  bibliografi_nn_1_N = mkN "bibliografi" "bibliografier" ;
  bilderbok_nn_1_N = mkN "bilderbok" "bilderböcker" ;
  bilindustri_nn_1_N = mkN "bilindustri" "bilindustrier" ;
  biljettbok_nn_1_N = mkN "biljettbok" "biljettböcker" ;
  biografi_nn_1_N = mkN "biografi" "biografier" ;
  biologibok_nn_1_N = mkN "biologibok" "biologiböcker" ;
  birot_nn_1_N = mkN "birot" "birötter" ;
  biskvi_nn_1_N = mkN "biskvi" "biskvier" ;
  bisturi_nn_1_N = mkN "bisturi" "bisturier" ;
  bladfot_nn_1_N = mkN "bladfot" "bladfötter" ;
  blandekonomi_nn_1_N = mkN "blandekonomi" "blandekonomier" ;
  blasfemi_nn_1_N = mkN "blasfemi" "blasfemier" ;
  blini_nn_1_N = mkN "blini" "blinier" ;
  blaedderbok_nn_1_1_N = mkN "blädderbok" "blädderböcker" ;
  bockfot_nn_1_N = mkN "bockfot" "bockfötter" ;
  bok_nn_1_N = mkN "bok" "böcker" ;
  bovfysionomi_nn_1_N = mkN "bovfysionomi" "bovfysionomier" ;
  broderbok_nn_1_N = mkN "broderbok" "broderböcker" ;
  bronkografi_nn_1_N = mkN "bronkografi" "bronkografier" ;
  bronkoskopi_nn_1_N = mkN "bronkoskopi" "bronkoskopier" ;
  bulimi_nn_1_N = mkN "bulimi" "bulimier" ;
  byggnadsindustri_nn_1_N = mkN "byggnadsindustri" "byggnadsindustrier" ;
  byraakrati_nn_1_1_N = mkN "byråkrati" "byråkratier" ;
  boenbok_nn_1_1_N = mkN "bönbok" "bönböcker" ;
  cashewnoet_nn_1_1_N = mkN "cashewnöt" "cashewnötter" ;
  cellulosaindustri_nn_1_N = mkN "cellulosaindustri" "cellulosaindustrier" ;
  ceremoni_nn_1_N = mkN "ceremoni" "ceremonier" ;
  chockterapi_nn_1_N = mkN "chockterapi" "chockterapier" ;
  cirkelperiferi_nn_1_N = mkN "cirkelperiferi" "cirkelperiferier" ;
  collier_nn_1_N = mkN "collier" "collierer" ;
  conferencier_nn_1_N = mkN "conferencier" "conferencierer" ;
  conf_erencier_nn_1_1_N = mkN "conférencier" "conférencierer" ;
  croupier_nn_1_N = mkN "croupier" "croupierer" ;
  cyberstrategi_nn_1_N = mkN "cyberstrategi" "cyberstrategier" ;
  cystoskopi_nn_1_N = mkN "cystoskopi" "cystoskopier" ;
  dagbok_nn_1_N = mkN "dagbok" "dagböcker" ;
  dagerrotypi_nn_1_N = mkN "dagerrotypi" "dagerrotypier" ;
  datortomografi_nn_1_N = mkN "datortomografi" "datortomografier" ;
  debutbok_nn_1_N = mkN "debutbok" "debutböcker" ;
  delkategori_nn_1_N = mkN "delkategori" "delkategorier" ;
  dementi_nn_1_N = mkN "dementi" "dementier" ;
  demokrati_nn_1_N = mkN "demokrati" "demokratier" ;
  deponi_nn_1_N = mkN "deponi" "deponier" ;
  despoti_nn_1_N = mkN "despoti" "despotier" ;
  dikotomi_nn_1_N = mkN "dikotomi" "dikotomier" ;
  dimorfi_nn_1_N = mkN "dimorfi" "dimorfier" ;
  dioptri_nn_1_N = mkN "dioptri" "dioptrier" ;
  disharmoni_nn_1_N = mkN "disharmoni" "disharmonier" ;
  djurfot_nn_1_N = mkN "djurfot" "djurfötter" ;
  dolikocefali_nn_1_N = mkN "dolikocefali" "dolikocefalier" ;
  dominoteori_nn_1_N = mkN "dominoteori" "dominoteorier" ;
  dubbelnoet_nn_1_1_N = mkN "dubbelnöt" "dubbelnötter" ;
  dynasti_nn_1_N = mkN "dynasti" "dynastier" ;
  dysenteri_nn_1_N = mkN "dysenteri" "dysenterier" ;
  dysfori_nn_1_N = mkN "dysfori" "dysforier" ;
  dyslexi_nn_1_N = mkN "dyslexi" "dyslexier" ;
  dyspepsi_nn_1_N = mkN "dyspepsi" "dyspepsier" ;
  dystopi_nn_1_N = mkN "dystopi" "dystopier" ;
  dystrofi_nn_1_N = mkN "dystrofi" "dystrofier" ;
  eklampsi_nn_1_N = mkN "eklampsi" "eklampsier" ;
  ekonomi_nn_1_N = mkN "ekonomi" "ekonomier" ;
  ektomi_nn_1_N = mkN "ektomi" "ektomier" ;
  elegi_nn_1_N = mkN "elegi" "elegier" ;
  elektroencefalografi_nn_1_N = mkN "elektroencefalografi" "elektroencefalografier" ;
  elektrokardiografi_nn_1_N = mkN "elektrokardiografi" "elektrokardiografier" ;
  elektronmikroskopi_nn_1_N = mkN "elektronmikroskopi" "elektronmikroskopier" ;
  elitteori_nn_1_N = mkN "elitteori" "elitteorier" ;
  emboli_nn_1_N = mkN "emboli" "embolier" ;
  encefalografi_nn_1_N = mkN "encefalografi" "encefalografier" ;
  encyklopedi_nn_1_N = mkN "encyklopedi" "encyklopedier" ;
  endemi_nn_1_N = mkN "endemi" "endemier" ;
  energi_nn_1_N = mkN "energi" "energier" ;
  energiteori_nn_1_N = mkN "energiteori" "energiteorier" ;
  envoy_e_nn_1_1_N = mkN "envoyé" "envoyéer" ;
  epidemi_nn_1_N = mkN "epidemi" "epidemier" ;
  epikur_e_nn_1_1_N = mkN "epikuré" "epikuréer" ;
  epilepsi_nn_1_N = mkN "epilepsi" "epilepsier" ;
  epizooti_nn_1_N = mkN "epizooti" "epizootier" ;
  espri_nn_2_N = mkN "espri" "esprier" ;
  essay_nn_1_N = mkN "essay" "essayer" ;
  etymologi_nn_1_N = mkN "etymologi" "etymologier" ;
  eufoni_nn_1_N = mkN "eufoni" "eufonier" ;
  eufori_nn_1_N = mkN "eufori" "euforier" ;
  europ_e_nn_1_1_N = mkN "europé" "européer" ;
  eurytmi_nn_1_N = mkN "eurytmi" "eurytmier" ;
  evolutionsteori_nn_1_N = mkN "evolutionsteori" "evolutionsteorier" ;
  fantasi_nn_1_N = mkN "fantasi" "fantasier" ;
  faris_e_nn_1_1_N = mkN "farisé" "fariséer" ;
  favoritmelodi_nn_1_N = mkN "favoritmelodi" "favoritmelodier" ;
  fe_nn_1_N = mkN "fe" "feer" ;
  feberepidemi_nn_1_N = mkN "feberepidemi" "feberepidemier" ;
  fetmaepidemi_nn_1_N = mkN "fetmaepidemi" "fetmaepidemier" ;
  filist_e_nn_1_1_N = mkN "filisté" "filistéer" ;
  filmkomedi_nn_1_N = mkN "filmkomedi" "filmkomedier" ;
  filologi_nn_1_N = mkN "filologi" "filologier" ;
  filosofi_nn_1_N = mkN "filosofi" "filosofier" ;
  flygindustri_nn_1_N = mkN "flygindustri" "flygindustrier" ;
  flaeskhare_nn_1_1_N = mkN "fläskhare" "fläskharar" ;
  fobi_nn_1_N = mkN "fobi" "fobier" ;
  folkdemokrati_nn_1_N = mkN "folkdemokrati" "folkdemokratier" ;
  folketymologi_nn_1_N = mkN "folketymologi" "folketymologier" ;
  folkhemsideologi_nn_1_N = mkN "folkhemsideologi" "folkhemsideologier" ;
  folkhemskoryf_e_nn_1_1_N = mkN "folkhemskoryfé" "folkhemskoryféer" ;
  folkhemsnostalgi_nn_1_N = mkN "folkhemsnostalgi" "folkhemsnostalgier" ;
  folkmelodi_nn_1_N = mkN "folkmelodi" "folkmelodier" ;
  framfot_nn_1_N = mkN "framfot" "framfötter" ;
  fysionomi_nn_1_N = mkN "fysionomi" "fysionomier" ;
  faelthare_nn_1_1_N = mkN "fälthare" "fältharar" ;
  faerglitografi_nn_1_1_N = mkN "färglitografi" "färglitografier" ;
  faagelfot_nn_1_1_N = mkN "fågelfot" "fågelfötter" ;
  foerestaellningskategori_nn_1_1_N = mkN "föreställningskategori" "föreställningskategorier" ;
  foerfoeljelsemani_nn_1_1_N = mkN "förföljelsemani" "förföljelsemanier" ;
  foerpackningsindustri_nn_1_1_N = mkN "förpackningsindustri" "förpackningsindustrier" ;
  foersvarsstrategi_nn_1_1_N = mkN "försvarsstrategi" "försvarsstrategier" ;
  galil_e_nn_1_1_N = mkN "galilé" "galiléer" ;
  garanti_nn_1_N = mkN "garanti" "garantier" ;
  gastroskopi_nn_1_N = mkN "gastroskopi" "gastroskopier" ;
  genealogi_nn_1_N = mkN "genealogi" "genealogier" ;
  genterapi_nn_1_N = mkN "genterapi" "genterapier" ;
  geometri_nn_1_N = mkN "geometri" "geometrier" ;
  glaci_nn_1_N = mkN "glaci" "glacier" ;
  glossolali_nn_1_N = mkN "glossolali" "glossolalier" ;
  grafteori_nn_1_N = mkN "grafteori" "grafteorier" ;
  gramkalori_nn_1_N = mkN "gramkalori" "gramkalorier" ;
  gripfot_nn_1_N = mkN "gripfot" "gripfötter" ;
  grundid_e_nn_1_1_N = mkN "grundidé" "grundidéer" ;
  grundteori_nn_1_N = mkN "grundteori" "grundteorier" ;
  gruppterapi_nn_1_N = mkN "gruppterapi" "gruppterapier" ;
  graesflaecksfobi_nn_1_1_N = mkN "gräsfläcksfobi" "gräsfläcksfobier" ;
  graesrot_nn_1_1_N = mkN "gräsrot" "gräsrötter" ;
  gaangfot_nn_1_1_N = mkN "gångfot" "gångfötter" ;
  gaasfot_nn_1_1_N = mkN "gåsfot" "gåsfötter" ;
  habitu_e_nn_1_1_N = mkN "habitué" "habituéer" ;
  hare_nn_1_N = mkN "hare" "harar" ;
  harmoni_nn_1_N = mkN "harmoni" "harmonier" ;
  hasselnoet_nn_1_1_N = mkN "hasselnöt" "hasselnötter" ;
  hebr_e_nn_1_1_N = mkN "hebré" "hebréer" ;
  hegemoni_nn_1_N = mkN "hegemoni" "hegemonier" ;
  heresi_nn_1_N = mkN "heresi" "heresier" ;
  hierarki_nn_1_N = mkN "hierarki" "hierarkier" ;
  hindu_nn_1_N = mkN "hindu" "hinduer" ;
  hjaernatrofi_nn_1_1_N = mkN "hjärnatrofi" "hjärnatrofier" ;
  hjaerterot_nn_1_1_N = mkN "hjärterot" "hjärterötter" ;
  hokus_pokusterapi_nn_1_N = mkN "hokus-pokusterapi" "hokus-pokusterapier" ;
  holonymi_nn_1_N = mkN "holonymi" "holonymier" ;
  homologi_nn_1_N = mkN "homologi" "homologier" ;
  homonymi_nn_1_N = mkN "homonymi" "homonymier" ;
  hundallergi_nn_1_N = mkN "hundallergi" "hundallergier" ;
  huvudideologi_nn_1_N = mkN "huvudideologi" "huvudideologier" ;
  hyllningsceremoni_nn_1_N = mkN "hyllningsceremoni" "hyllningsceremonier" ;
  hyperbor_e_nn_1_1_N = mkN "hyperboré" "hyperboréer" ;
  hypernymi_nn_1_N = mkN "hypernymi" "hypernymier" ;
  hyperonymi_nn_1_N = mkN "hyperonymi" "hyperonymier" ;
  hypertrofi_nn_1_N = mkN "hypertrofi" "hypertrofier" ;
  hypokondri_nn_1_N = mkN "hypokondri" "hypokondrier" ;
  hypomani_nn_1_N = mkN "hypomani" "hypomanier" ;
  hyponymi_nn_1_N = mkN "hyponymi" "hyponymier" ;
  haelsningsceremoni_nn_1_1_N = mkN "hälsningsceremoni" "hälsningsceremonier" ;
  haalfot_nn_1_1_N = mkN "hålfot" "hålfötter" ;
  hoegerfot_nn_1_1_N = mkN "högerfot" "högerfötter" ;
  hoegteknologi_nn_1_1_N = mkN "högteknologi" "högteknologier" ;
  ideologi_nn_1_N = mkN "ideologi" "ideologier" ;
  idiosynkrasi_nn_1_N = mkN "idiosynkrasi" "idiosynkrasier" ;
  idioti_nn_1_N = mkN "idioti" "idiotier" ;
  id_e_nn_1_1_N = mkN "idé" "idéer" ;
  indoeurop_e_nn_1_1_N = mkN "indoeuropé" "indoeuropéer" ;
  industri_nn_1_N = mkN "industri" "industrier" ;
  infami_nn_1_N = mkN "infami" "infamier" ;
  inflationsteori_nn_1_N = mkN "inflationsteori" "inflationsteorier" ;
  informationsteknologi_nn_1_N = mkN "informationsteknologi" "informationsteknologier" ;
  ingenjoersvetenskapsakademi_nn_1_1_N = mkN "ingenjörsvetenskapsakademi" "ingenjörsvetenskapsakademier" ;
  inkomstgaranti_nn_1_N = mkN "inkomstgaranti" "inkomstgarantier" ;
  ironi_nn_1_N = mkN "ironi" "ironier" ;
  ischuri_nn_1_N = mkN "ischuri" "ischurier" ;
  islamofobi_nn_1_N = mkN "islamofobi" "islamofobier" ;
  isomeri_nn_1_N = mkN "isomeri" "isomerier" ;
  isomorfi_nn_1_N = mkN "isomorfi" "isomorfier" ;
  jalusi_nn_1_N = mkN "jalusi" "jalusier" ;
  joniseringsenergi_nn_1_N = mkN "joniseringsenergi" "joniseringsenergier" ;
  jordnoet_nn_1_1_N = mkN "jordnöt" "jordnötter" ;
  julgransfot_nn_1_N = mkN "julgransfot" "julgransfötter" ;
  jaernindustri_nn_1_1_N = mkN "järnindustri" "järnindustrier" ;
  joenseri_nn_1_1_N = mkN "jönseri" "jönserier" ;
  kakafoni_nn_1_N = mkN "kakafoni" "kakafonier" ;
  kakofoni_nn_1_N = mkN "kakofoni" "kakofonier" ;
  kald_e_nn_1_1_N = mkN "kaldé" "kaldéer" ;
  kalkomani_nn_1_N = mkN "kalkomani" "kalkomanier" ;
  kalori_nn_1_N = mkN "kalori" "kalorier" ;
  kamelpoesi_nn_1_N = mkN "kamelpoesi" "kamelpoesier" ;
  kamrer_nn_1_N = mkN "kamrer" "kamrerer" ;
  kanan_e_nn_1_1_N = mkN "kanané" "kananéer" ;
  kasjunoet_nn_1_1_N = mkN "kasjunöt" "kasjunötter" ;
  katalepsi_nn_1_N = mkN "katalepsi" "katalepsier" ;
  katastrofteori_nn_1_N = mkN "katastrofteori" "katastrofteorier" ;
  kategori_nn_1_N = mkN "kategori" "kategorier" ;
  kemiindustri_nn_1_N = mkN "kemiindustri" "kemiindustrier" ;
  kemoterapi_nn_1_N = mkN "kemoterapi" "kemoterapier" ;
  klimatstrategi_nn_1_N = mkN "klimatstrategi" "klimatstrategier" ;
  klaetterfot_nn_1_1_N = mkN "klätterfot" "klätterfötter" ;
  knoelrot_nn_1_1_N = mkN "knölrot" "knölrötter" ;
  kokosnoet_nn_1_1_N = mkN "kokosnöt" "kokosnötter" ;
  koloni_nn_1_N = mkN "koloni" "kolonier" ;
  komedi_nn_1_N = mkN "komedi" "komedier" ;
  konferencier_nn_1_N = mkN "konferencier" "konferencierer" ;
  konferenciaer_nn_1_1_N = mkN "konferenciär" "konferenciärer" ;
  konspirationsteori_nn_1_N = mkN "konspirationsteori" "konspirationsteorier" ;
  konstakademi_nn_1_N = mkN "konstakademi" "konstakademier" ;
  konstindustri_nn_1_N = mkN "konstindustri" "konstindustrier" ;
  koryf_e_nn_1_1_N = mkN "koryfé" "koryféer" ;
  kosmogoni_nn_1_N = mkN "kosmogoni" "kosmogonier" ;
  kosmologi_nn_1_N = mkN "kosmologi" "kosmologier" ;
  krestomati_nn_1_N = mkN "krestomati" "krestomatier" ;
  krigshierarki_nn_1_N = mkN "krigshierarki" "krigshierarkier" ;
  krigsindustri_nn_1_N = mkN "krigsindustri" "krigsindustrier" ;
  kroki_nn_1_N = mkN "kroki" "krokier" ;
  kromolitografi_nn_1_N = mkN "kromolitografi" "kromolitografier" ;
  kronkoloni_nn_1_N = mkN "kronkoloni" "kronkolonier" ;
  kronologi_nn_1_N = mkN "kronologi" "kronologier" ;
  kubikrot_nn_1_N = mkN "kubikrot" "kubikrötter" ;
  kukrot_nn_1_N = mkN "kukrot" "kukrötter" ;
  kvadratrot_nn_1_N = mkN "kvadratrot" "kvadratrötter" ;
  kaernteknologi_nn_1_1_N = mkN "kärnteknologi" "kärnteknologier" ;
  kaernvapenstrategi_nn_1_1_N = mkN "kärnvapenstrategi" "kärnvapenstrategier" ;
  kaalrot_nn_1_1_N = mkN "kålrot" "kålrötter" ;
  lakritsrot_nn_1_N = mkN "lakritsrot" "lakritsrötter" ;
  lampfot_nn_1_N = mkN "lampfot" "lampfötter" ;
  laryngoskopi_nn_1_N = mkN "laryngoskopi" "laryngoskopier" ;
  lejonfot_nn_1_N = mkN "lejonfot" "lejonfötter" ;
  leukemi_nn_1_N = mkN "leukemi" "leukemier" ;
  litografi_nn_1_N = mkN "litografi" "litografier" ;
  liturgi_nn_1_N = mkN "liturgi" "liturgier" ;
  lobotomi_nn_1_N = mkN "lobotomi" "lobotomier" ;
  luftemboli_nn_1_N = mkN "luftemboli" "luftembolier" ;
  luftrot_nn_1_N = mkN "luftrot" "luftrötter" ;
  lungemboli_nn_1_N = mkN "lungemboli" "lungembolier" ;
  lungrot_nn_1_N = mkN "lungrot" "lungrötter" ;
  laanegaranti_nn_1_1_N = mkN "lånegaranti" "lånegarantier" ;
  loenegaranti_nn_1_1_N = mkN "lönegaranti" "lönegarantier" ;
  mammografi_nn_1_N = mkN "mammografi" "mammografier" ;
  mani_nn_1_N = mkN "mani" "manier" ;
  manik_e_nn_1_1_N = mkN "maniké" "manikéer" ;
  mardroemsfantasi_nn_1_1_N = mkN "mardrömsfantasi" "mardrömsfantasier" ;
  marknadsekonomi_nn_1_N = mkN "marknadsekonomi" "marknadsekonomier" ;
  maskopi_nn_1_N = mkN "maskopi" "maskopier" ;
  medaljceremoni_nn_1_N = mkN "medaljceremoni" "medaljceremonier" ;
  melodi_nn_1_N = mkN "melodi" "melodier" ;
  meronymi_nn_1_N = mkN "meronymi" "meronymier" ;
  metallfot_nn_1_N = mkN "metallfot" "metallfötter" ;
  metallindustri_nn_1_N = mkN "metallindustri" "metallindustrier" ;
  metodologi_nn_1_N = mkN "metodologi" "metodologier" ;
  metonymi_nn_1_N = mkN "metonymi" "metonymier" ;
  mjoelkallergi_nn_1_1_N = mkN "mjölkallergi" "mjölkallergier" ;
  moatj_e_nn_1_1_N = mkN "moatjé" "moatjéer" ;
  monarki_nn_1_N = mkN "monarki" "monarkier" ;
  monografi_nn_1_N = mkN "monografi" "monografier" ;
  morfologi_nn_1_N = mkN "morfologi" "morfologier" ;
  morot_nn_1_N = mkN "morot" "morötter" ;
  mossrot_nn_1_N = mkN "mossrot" "mossrötter" ;
  muskelatrofi_nn_1_N = mkN "muskelatrofi" "muskelatrofier" ;
  muskotnoet_nn_1_1_N = mkN "muskotnöt" "muskotnötter" ;
  mytologi_nn_1_N = mkN "mytologi" "mytologier" ;
  moebelfot_nn_1_1_N = mkN "möbelfot" "möbelfötter" ;
  nagelrot_nn_1_N = mkN "nagelrot" "nagelrötter" ;
  nanoteknologi_nn_1_N = mkN "nanoteknologi" "nanoteknologier" ;
  narkotikastrategi_nn_1_N = mkN "narkotikastrategi" "narkotikastrategier" ;
  nasar_e_nn_1_1_N = mkN "nasaré" "nasaréer" ;
  nedslagsteori_nn_1_N = mkN "nedslagsteori" "nedslagsteorier" ;
  nejlikrot_nn_1_N = mkN "nejlikrot" "nejlikrötter" ;
  nerslagsteori_nn_1_N = mkN "nerslagsteori" "nerslagsteorier" ;
  nostalgi_nn_1_N = mkN "nostalgi" "nostalgier" ;
  nyckelindustri_nn_1_N = mkN "nyckelindustri" "nyckelindustrier" ;
  naeckrosrot_nn_1_1_N = mkN "näckrosrot" "näckrosrötter" ;
  naesrot_nn_1_1_N = mkN "näsrot" "näsrötter" ;
  odyss_e_nn_1_1_N = mkN "odyssé" "odysséer" ;
  oftalmi_nn_1_N = mkN "oftalmi" "oftalmier" ;
  oligarki_nn_1_N = mkN "oligarki" "oligarkier" ;
  ontologi_nn_1_N = mkN "ontologi" "ontologier" ;
  ordfot_nn_1_N = mkN "ordfot" "ordfötter" ;
  ordrot_nn_1_N = mkN "ordrot" "ordrötter" ;
  orsakskategori_nn_1_N = mkN "orsakskategori" "orsakskategorier" ;
  ortodoxi_nn_1_N = mkN "ortodoxi" "ortodoxier" ;
  ortografi_nn_1_N = mkN "ortografi" "ortografier" ;
  ostalgi_nn_1_N = mkN "ostalgi" "ostalgier" ;
  ovariotomi_nn_1_N = mkN "ovariotomi" "ovariotomier" ;
  paddfot_nn_1_N = mkN "paddfot" "paddfötter" ;
  pandemi_nn_1_N = mkN "pandemi" "pandemier" ;
  pannkaksteori_nn_1_N = mkN "pannkaksteori" "pannkaksteorier" ;
  parafasi_nn_1_N = mkN "parafasi" "parafasier" ;
  paranoet_nn_1_1_N = mkN "paranöt" "paranötter" ;
  parodi_nn_1_N = mkN "parodi" "parodier" ;
  paronymi_nn_1_N = mkN "paronymi" "paronymier" ;
  partisympati_nn_1_N = mkN "partisympati" "partisympatier" ;
  partonymi_nn_1_N = mkN "partonymi" "partonymier" ;
  patologi_nn_1_N = mkN "patologi" "patologier" ;
  pekannoet_nn_1_1_N = mkN "pekannöt" "pekannötter" ;
  periferi_nn_1_N = mkN "periferi" "periferier" ;
  peripeti_nn_1_N = mkN "peripeti" "peripetier" ;
  pinjenoet_nn_1_1_N = mkN "pinjenöt" "pinjenötter" ;
  pistagenoet_nn_1_1_N = mkN "pistagenöt" "pistagenötter" ;
  pistaschnoet_nn_1_1_N = mkN "pistaschnöt" "pistaschnötter" ;
  planekonomi_nn_1_N = mkN "planekonomi" "planekonomier" ;
  plantageekonomi_nn_1_N = mkN "plantageekonomi" "plantageekonomier" ;
  plastindustri_nn_1_N = mkN "plastindustri" "plastindustrier" ;
  plutokrati_nn_1_N = mkN "plutokrati" "plutokratier" ;
  pneumoni_nn_1_N = mkN "pneumoni" "pneumonier" ;
  poesi_nn_1_N = mkN "poesi" "poesier" ;
  pollenallergi_nn_1_N = mkN "pollenallergi" "pollenallergier" ;
  polyfoni_nn_1_N = mkN "polyfoni" "polyfonier" ;
  portier_nn_1_N = mkN "portier" "portierer" ;
  prisceremoni_nn_1_N = mkN "prisceremoni" "prisceremonier" ;
  processindustri_nn_1_N = mkN "processindustri" "processindustrier" ;
  propyl_e_nn_1_1_N = mkN "propylé" "propyléer" ;
  prosodi_nn_1_N = mkN "prosodi" "prosodier" ;
  proteg_e_nn_1_1_N = mkN "protegé" "protegéer" ;
  psalmodi_nn_1_N = mkN "psalmodi" "psalmodier" ;
  psykopati_nn_1_N = mkN "psykopati" "psykopatier" ;
  psykoterapi_nn_1_N = mkN "psykoterapi" "psykoterapier" ;
  pygm_e_nn_1_1_N = mkN "pygmé" "pygméer" ;
  paelsallergi_nn_1_1_N = mkN "pälsallergi" "pälsallergier" ;
  paalrot_nn_1_1_N = mkN "pålrot" "pålrötter" ;
  paaskhare_nn_1_1_N = mkN "påskhare" "påskharar" ;
  rapsodi_nn_1_N = mkN "rapsodi" "rapsodier" ;
  religionsfilosofi_nn_1_N = mkN "religionsfilosofi" "religionsfilosofier" ;
  remi_nn_1_N = mkN "remi" "remier" ;
  restidsgaranti_nn_1_N = mkN "restidsgaranti" "restidsgarantier" ;
  rou_e_nn_1_1_N = mkN "roué" "rouéer" ;
  ryssfobi_nn_1_N = mkN "ryssfobi" "ryssfobier" ;
  raaget_nn_1_1_N = mkN "råget" "rågetter" ;
  raavaruekonomi_nn_1_1_N = mkN "råvaruekonomi" "råvaruekonomier" ;
  roekmani_nn_1_1_N = mkN "rökmani" "rökmanier" ;
  sadduc_e_nn_1_1_N = mkN "sadducé" "sadducéer" ;
  salongskomedi_nn_1_N = mkN "salongskomedi" "salongskomedier" ;
  samtidsdystopi_nn_1_N = mkN "samtidsdystopi" "samtidsdystopier" ;
  sannolikhetsteori_nn_1_N = mkN "sannolikhetsteori" "sannolikhetsteorier" ;
  satrapi_nn_1_N = mkN "satrapi" "satrapier" ;
  satsmelodi_nn_1_N = mkN "satsmelodi" "satsmelodier" ;
  schizofreni_nn_1_N = mkN "schizofreni" "schizofrenier" ;
  schweizernoet_nn_1_1_N = mkN "schweizernöt" "schweizernötter" ;
  seborr_e_nn_1_1_N = mkN "seborré" "seborréer" ;
  sedekomedi_nn_1_N = mkN "sedekomedi" "sedekomedier" ;
  serigrafi_nn_1_N = mkN "serigrafi" "serigrafier" ;
  sexfantasi_nn_1_N = mkN "sexfantasi" "sexfantasier" ;
  signaturmelodi_nn_1_N = mkN "signaturmelodi" "signaturmelodier" ;
  silkeshare_nn_1_N = mkN "silkeshare" "silkesharar" ;
  simfot_nn_1_N = mkN "simfot" "simfötter" ;
  sinnesanalogi_nn_1_N = mkN "sinnesanalogi" "sinnesanalogier" ;
  sjaelvbiografi_nn_1_1_N = mkN "självbiografi" "självbiografier" ;
  sjaelvhjaelpsindustri_nn_1_1_N = mkN "självhjälpsindustri" "självhjälpsindustrier" ;
  skogsindustri_nn_1_N = mkN "skogsindustri" "skogsindustrier" ;
  skuggindustri_nn_1_N = mkN "skuggindustri" "skuggindustrier" ;
  solenergiteknologi_nn_1_N = mkN "solenergiteknologi" "solenergiteknologier" ;
  sopprot_nn_1_N = mkN "sopprot" "sopprötter" ;
  sorti_nn_1_N = mkN "sorti" "sortier" ;
  spelmani_nn_1_N = mkN "spelmani" "spelmanier" ;
  spinalanestesi_nn_1_N = mkN "spinalanestesi" "spinalanestesier" ;
  spraakteknologi_nn_1_1_N = mkN "språkteknologi" "språkteknologier" ;
  spraakteori_nn_1_1_N = mkN "språkteori" "språkteorier" ;
  spaedget_nn_1_1_N = mkN "spädget" "spädgetter" ;
  stare_nn_1_N = mkN "stare" "starar" ;
  statushierarki_nn_1_N = mkN "statushierarki" "statushierarkier" ;
  stenget_nn_1_N = mkN "stenget" "stengetter" ;
  stereotypi_nn_1_N = mkN "stereotypi" "stereotypier" ;
  stomi_nn_1_N = mkN "stomi" "stomier" ;
  storindustri_nn_1_N = mkN "storindustri" "storindustrier" ;
  strategi_nn_1_N = mkN "strategi" "strategier" ;
  stroboskopi_nn_1_N = mkN "stroboskopi" "stroboskopier" ;
  strumpfot_nn_1_N = mkN "strumpfot" "strumpfötter" ;
  stroemstare_nn_1_1_N = mkN "strömstare" "strömstarar" ;
  styltrot_nn_1_N = mkN "styltrot" "styltrötter" ;
  svartfot_nn_1_N = mkN "svartfot" "svartfötter" ;
  sydoesteurop_e_nn_1_1_N = mkN "sydösteuropé" "sydösteuropéer" ;
  symfoni_nn_1_N = mkN "symfoni" "symfonier" ;
  symmetri_nn_1_N = mkN "symmetri" "symmetrier" ;
  sympati_nn_1_N = mkN "sympati" "sympatier" ;
  synestesi_nn_1_N = mkN "synestesi" "synestesier" ;
  synonymi_nn_1_N = mkN "synonymi" "synonymier" ;
  saekerhetsfilosofi_nn_1_1_N = mkN "säkerhetsfilosofi" "säkerhetsfilosofier" ;
  saengfot_nn_1_1_N = mkN "sängfot" "sängfötter" ;
  saagverksindustri_nn_1_1_N = mkN "sågverksindustri" "sågverksindustrier" ;
  takistoskopi_nn_1_N = mkN "takistoskopi" "takistoskopier" ;
  takykardi_nn_1_N = mkN "takykardi" "takykardier" ;
  talteknologi_nn_1_N = mkN "talteknologi" "talteknologier" ;
  tandrot_nn_1_N = mkN "tandrot" "tandrötter" ;
  tassfot_nn_1_N = mkN "tassfot" "tassfötter" ;
  tautologi_nn_1_N = mkN "tautologi" "tautologier" ;
  taxonomi_nn_1_N = mkN "taxonomi" "taxonomier" ;
  teaterhabitu_e_nn_1_1_N = mkN "teaterhabitué" "teaterhabituéer" ;
  teceremoni_nn_1_N = mkN "teceremoni" "teceremonier" ;
  teknokrati_nn_1_N = mkN "teknokrati" "teknokratier" ;
  teknologi_nn_1_N = mkN "teknologi" "teknologier" ;
  tekoindustri_nn_1_N = mkN "tekoindustri" "tekoindustrier" ;
  telepati_nn_1_N = mkN "telepati" "telepatier" ;
  teogoni_nn_1_N = mkN "teogoni" "teogonier" ;
  teokrati_nn_1_N = mkN "teokrati" "teokratier" ;
  teori_nn_1_N = mkN "teori" "teorier" ;
  terapi_nn_1_N = mkN "terapi" "terapier" ;
  terminologi_nn_1_N = mkN "terminologi" "terminologier" ;
  tetralogi_nn_1_N = mkN "tetralogi" "tetralogier" ;
  textilindustri_nn_1_N = mkN "textilindustri" "textilindustrier" ;
  tillverkningsindustri_nn_1_N = mkN "tillverkningsindustri" "tillverkningsindustrier" ;
  tomografi_nn_1_N = mkN "tomografi" "tomografier" ;
  topologi_nn_1_N = mkN "topologi" "topologier" ;
  toppenergi_nn_1_N = mkN "toppenergi" "toppenergier" ;
  tragedi_nn_1_N = mkN "tragedi" "tragedier" ;
  tragikomedi_nn_1_N = mkN "tragikomedi" "tragikomedier" ;
  travesti_nn_1_N = mkN "travesti" "travestier" ;
  trilogi_nn_1_N = mkN "trilogi" "trilogier" ;
  trollhare_nn_1_N = mkN "trollhare" "trollharar" ;
  trutkoloni_nn_1_N = mkN "trutkoloni" "trutkolonier" ;
  traedrot_nn_1_1_N = mkN "trädrot" "trädrötter" ;
  traeindustri_nn_1_1_N = mkN "träindustri" "träindustrier" ;
  tyfoidepidemi_nn_1_N = mkN "tyfoidepidemi" "tyfoidepidemier" ;
  typografi_nn_1_N = mkN "typografi" "typografier" ;
  typologi_nn_1_N = mkN "typologi" "typologier" ;
  tyskhare_nn_1_N = mkN "tyskhare" "tyskharar" ;
  undervisningsteknologi_nn_1_N = mkN "undervisningsteknologi" "undervisningsteknologier" ;
  upplysningsfilosofi_nn_1_N = mkN "upplysningsfilosofi" "upplysningsfilosofier" ;
  upplysningsid_e_nn_1_1_N = mkN "upplysningsidé" "upplysningsidéer" ;
  upptagningsceremoni_nn_1_N = mkN "upptagningsceremoni" "upptagningsceremonier" ;
  ursmaellsteori_nn_1_1_N = mkN "ursmällsteori" "ursmällsteorier" ;
  utopi_nn_1_N = mkN "utopi" "utopier" ;
  utsugarekonomi_nn_1_N = mkN "utsugarekonomi" "utsugarekonomier" ;
  vadfot_nn_1_N = mkN "vadfot" "vadfötter" ;
  valnoet_nn_1_1_N = mkN "valnöt" "valnötter" ;
  valsmelodi_nn_1_N = mkN "valsmelodi" "valsmelodier" ;
  valstrategi_nn_1_N = mkN "valstrategi" "valstrategier" ;
  varvsindustri_nn_1_N = mkN "varvsindustri" "varvsindustrier" ;
  vasektomi_nn_1_N = mkN "vasektomi" "vasektomier" ;
  verkstadsindustri_nn_1_N = mkN "verkstadsindustri" "verkstadsindustrier" ;
  versfot_nn_1_N = mkN "versfot" "versfötter" ;
  vetenskapsakademi_nn_1_N = mkN "vetenskapsakademi" "vetenskapsakademier" ;
  vindindustri_nn_1_N = mkN "vindindustri" "vindindustrier" ;
  virusepidemi_nn_1_N = mkN "virusepidemi" "virusepidemier" ;
  vokalharmoni_nn_1_N = mkN "vokalharmoni" "vokalharmonier" ;
  vaelfaerdsideologi_nn_1_1_N = mkN "välfärdsideologi" "välfärdsideologier" ;
  vaendelrot_nn_1_1_N = mkN "vändelrot" "vändelrötter" ;
  vaensterfot_nn_1_1_N = mkN "vänsterfot" "vänsterfötter" ;
  vaerdehierarki_nn_1_1_N = mkN "värdehierarki" "värdehierarkier" ;
  vaermeekonomi_nn_1_1_N = mkN "värmeekonomi" "värmeekonomier" ;
  vaevarstare_nn_1_1_N = mkN "vävarstare" "vävarstarar" ;
  vaardgaranti_nn_1_1_N = mkN "vårdgaranti" "vårdgarantier" ;
  vaardplatsgaranti_nn_1_1_N = mkN "vårdplatsgaranti" "vårdplatsgarantier" ;
  xylografi_nn_1_N = mkN "xylografi" "xylografier" ;
  yrkeskategori_nn_1_N = mkN "yrkeskategori" "yrkeskategorier" ;
  aelsklingsid_e_nn_1_1_N = mkN "älsklingsidé" "älsklingsidéer" ;
  aelsklingsmelodi_nn_1_1_N = mkN "älsklingsmelodi" "älsklingsmelodier" ;
  aalandsrot_nn_1_1_N = mkN "ålandsrot" "ålandsrötter" ;
  aarfot_nn_1_1_N = mkN "årfot" "årfötter" ;
  oeppningsceremoni_nn_1_1_N = mkN "öppningsceremoni" "öppningsceremonier" ;
  oevergaangsteknologi_nn_1_1_N = mkN "övergångsteknologi" "övergångsteknologier" ;
  Jupitermaane_nn_1_1_N = mkN "Jupitermåne" utrum  ;
  abborre_nn_1_N = mkN "abborre" utrum  ;
  abborrpinne_nn_1_N = mkN "abborrpinne" utrum  ;
  aborre_nn_1_N = mkN "aborre" utrum  ;
  actionrulle_nn_1_N = mkN "actionrulle" utrum  ;
  adventsljusstake_nn_1_N = mkN "adventsljusstake" utrum  ;
  adventsstake_nn_1_N = mkN "adventsstake" utrum  ;
  aftonhandske_nn_1_N = mkN "aftonhandske" utrum  ;
  albuske_nn_1_N = mkN "albuske" utrum  ;
  alfahanne_nn_1_N = mkN "alfahanne" utrum  ;
  alkotte_nn_1_N = mkN "alkotte" utrum  ;
  amorbaage_nn_1_1_N = mkN "amorbåge" utrum  ;
  andrake_nn_1_N = mkN "andrake" utrum  ;
  aortabaage_nn_1_1_N = mkN "aortabåge" utrum  ;
  arbetshandske_nn_1_N = mkN "arbetshandske" utrum  ;
  arbetstimme_nn_1_N = mkN "arbetstimme" utrum  ;
  armbaage_nn_1_1_N = mkN "armbåge" utrum  ;
  arve_nn_1_N = mkN "arve" utrum  ;
  asbagge_nn_1_N = mkN "asbagge" utrum  ;
  backe_nn_1_N = mkN "backe" utrum  ;
  badborste_nn_1_N = mkN "badborste" utrum  ;
  bagge_nn_1_N = mkN "bagge" utrum  ;
  baktanke_nn_1_N = mkN "baktanke" utrum  ;
  bakvinge_nn_1_N = mkN "bakvinge" utrum  ;
  bale_nn_1_N = mkN "bale" utrum  ;
  balle_nn_1_N = mkN "balle" utrum  ;
  ballongpojke_nn_1_N = mkN "ballongpojke" utrum  ;
  banknisse_nn_1_N = mkN "banknisse" utrum  ;
  bannstraale_nn_1_1_N = mkN "bannstråle" utrum  ;
  barkborre_nn_1_N = mkN "barkborre" utrum  ;
  barkspade_nn_1_N = mkN "barkspade" utrum  ;
  barrtraedskotte_nn_1_1_N = mkN "barrträdskotte" utrum  ;
  basse_nn_1_N = mkN "basse" utrum  ;
  benstomme_nn_1_N = mkN "benstomme" utrum  ;
  benstraale_nn_1_1_N = mkN "benstråle" utrum  ;
  bergknalle_nn_1_N = mkN "bergknalle" utrum  ;
  bergkulle_nn_1_N = mkN "bergkulle" utrum  ;
  bete_nn_2_N = mkN "bete" utrum  ;
  beteshage_nn_1_N = mkN "beteshage" utrum  ;
  betongpaale_nn_1_1_N = mkN "betongpåle" utrum  ;
  bildrulle_2_nn_1_N = mkN "bildrulle" utrum  ;
  biltvaettborste_nn_1_1_N = mkN "biltvättborste" utrum  ;
  bimaane_nn_1_1_N = mkN "bimåne" utrum  ;
  bindbjaelke_nn_1_1_N = mkN "bindbjälke" utrum  ;
  binge_nn_1_N = mkN "binge" utrum  ;
  bisamoxe_nn_1_N = mkN "bisamoxe" utrum  ;
  bisonoxe_nn_1_N = mkN "bisonoxe" utrum  ;
  bitanke_nn_1_N = mkN "bitanke" utrum  ;
  bjaelke_nn_1_1_N = mkN "bjälke" utrum  ;
  bjoerkhage_nn_1_1_N = mkN "björkhage" utrum  ;
  bjoernbaersbuske_nn_1_1_N = mkN "björnbärsbuske" utrum  ;
  bladbagge_nn_1_N = mkN "bladbagge" utrum  ;
  blankborste_nn_1_N = mkN "blankborste" utrum  ;
  blodsdroppe_nn_1_N = mkN "blodsdroppe" utrum  ;
  blomklase_nn_1_N = mkN "blomklase" utrum  ;
  blaavinge_nn_1_1_N = mkN "blåvinge" utrum  ;
  bogsergalge_nn_1_N = mkN "bogsergalge" utrum  ;
  bokkasse_nn_1_N = mkN "bokkasse" utrum  ;
  bokrulle_nn_1_N = mkN "bokrulle" utrum  ;
  boktrave_nn_1_N = mkN "boktrave" utrum  ;
  bollkalle_nn_1_N = mkN "bollkalle" utrum  ;
  bollpojke_nn_1_N = mkN "bollpojke" utrum  ;
  bomullsbuske_nn_1_N = mkN "bomullsbuske" utrum  ;
  bomullspinne_nn_1_N = mkN "bomullspinne" utrum  ;
  bordsgranne_nn_1_N = mkN "bordsgranne" utrum  ;
  borste_nn_1_N = mkN "borste" utrum  ;
  botanikspade_nn_1_N = mkN "botanikspade" utrum  ;
  botanistspade_nn_1_N = mkN "botanistspade" utrum  ;
  bottenbjaelke_nn_1_1_N = mkN "bottenbjälke" utrum  ;
  boxhandske_nn_1_N = mkN "boxhandske" utrum  ;
  brandstege_nn_1_N = mkN "brandstege" utrum  ;
  broderbaage_nn_1_1_N = mkN "broderbåge" utrum  ;
  bronsborste_nn_1_N = mkN "bronsborste" utrum  ;
  brudsporre_nn_1_N = mkN "brudsporre" utrum  ;
  brushane_nn_1_N = mkN "brushane" utrum  ;
  bryte_nn_1_N = mkN "bryte" utrum  ;
  braakstake_nn_1_1_N = mkN "bråkstake" utrum  ;
  broedbagge_nn_1_1_N = mkN "brödbagge" utrum  ;
  broedkavle_nn_1_1_N = mkN "brödkavle" utrum  ;
  broedspade_nn_1_1_N = mkN "brödspade" utrum  ;
  budkavle_nn_1_N = mkN "budkavle" utrum  ;
  bulle_nn_1_N = mkN "bulle" utrum  ;
  bunke_nn_1_N = mkN "bunke" utrum  ;
  buse_nn_1_N = mkN "buse" utrum  ;
  buske_nn_1_N = mkN "buske" utrum  ;
  buteljborste_nn_1_N = mkN "buteljborste" utrum  ;
  baelgvante_nn_1_1_N = mkN "bälgvante" utrum  ;
  baenkgranne_nn_1_1_N = mkN "bänkgranne" utrum  ;
  baerbjaelke_nn_1_1_N = mkN "bärbjälke" utrum  ;
  baerbuske_nn_1_1_N = mkN "bärbuske" utrum  ;
  baerkasse_nn_1_1_N = mkN "bärkasse" utrum  ;
  baerkotte_nn_1_1_N = mkN "bärkotte" utrum  ;
  baerpaase_nn_1_1_N = mkN "bärpåse" utrum  ;
  baade_nn_1_1_N = mkN "både" utrum  ;
  baage_nn_1_1_N = mkN "båge" utrum  ;
  cellgranne_nn_1_N = mkN "cellgranne" utrum  ;
  cirkelbaage_nn_1_1_N = mkN "cirkelbåge" utrum  ;
  collegepojke_nn_1_N = mkN "collegepojke" utrum  ;
  crosshandske_nn_1_N = mkN "crosshandske" utrum  ;
  daggdroppe_nn_1_N = mkN "daggdroppe" utrum  ;
  dammsugarpaase_nn_1_1_N = mkN "dammsugarpåse" utrum  ;
  deltavinge_nn_1_N = mkN "deltavinge" utrum  ;
  dimbaage_nn_1_1_N = mkN "dimbåge" utrum  ;
  dinge_nn_1_N = mkN "dinge" utrum  ;
  dokumentpacke_nn_1_N = mkN "dokumentpacke" utrum  ;
  domherre_nn_1_N = mkN "domherre" utrum  ;
  drake_nn_1_N = mkN "drake" utrum  ;
  droppe_nn_1_N = mkN "droppe" utrum  ;
  drulle_nn_1_N = mkN "drulle" utrum  ;
  druvklase_nn_1_N = mkN "druvklase" utrum  ;
  draase_nn_1_1_N = mkN "dråse" utrum  ;
  droese_nn_1_1_N = mkN "dröse" utrum  ;
  dubbeltimme_nn_1_N = mkN "dubbeltimme" utrum  ;
  dunge_nn_1_N = mkN "dunge" utrum  ;
  dvaergbuske_nn_1_1_N = mkN "dvärgbuske" utrum  ;
  dykarbagge_nn_1_N = mkN "dykarbagge" utrum  ;
  dynamitgubbe_nn_1_N = mkN "dynamitgubbe" utrum  ;
  dyngbagge_nn_1_N = mkN "dyngbagge" utrum  ;
  daeckpaase_nn_1_1_N = mkN "däckpåse" utrum  ;
  daare_nn_1_1_N = mkN "dåre" utrum  ;
  doerrstolpe_nn_1_1_N = mkN "dörrstolpe" utrum  ;
  eftermiddagstimme_nn_1_N = mkN "eftermiddagstimme" utrum  ;
  ekbacke_nn_1_N = mkN "ekbacke" utrum  ;
  ekorre_nn_1_N = mkN "ekorre" utrum  ;
  ekoxe_nn_1_N = mkN "ekoxe" utrum  ;
  elborste_nn_1_N = mkN "elborste" utrum  ;
  elefantbete_nn_1_N = mkN "elefantbete" utrum  ;
  elektronstraale_nn_1_1_N = mkN "elektronstråle" utrum  ;
  elstolpe_nn_1_N = mkN "elstolpe" utrum  ;
  enbacke_nn_1_N = mkN "enbacke" utrum  ;
  enbuske_nn_1_N = mkN "enbuske" utrum  ;
  enkeltimme_nn_1_N = mkN "enkeltimme" utrum  ;
  falafelbulle_nn_1_N = mkN "falafelbulle" utrum  ;
  farsgubbe_nn_1_N = mkN "farsgubbe" utrum  ;
  fartdaare_nn_1_1_N = mkN "fartdåre" utrum  ;
  fastlagsbulle_nn_1_N = mkN "fastlagsbulle" utrum  ;
  festprisse_nn_1_N = mkN "festprisse" utrum  ;
  fettisdagsbulle_nn_1_N = mkN "fettisdagsbulle" utrum  ;
  filbunke_nn_1_N = mkN "filbunke" utrum  ;
  filklove_nn_1_N = mkN "filklove" utrum  ;
  filmrulle_nn_1_N = mkN "filmrulle" utrum  ;
  filmtrave_nn_1_N = mkN "filmtrave" utrum  ;
  filterpaase_nn_1_1_N = mkN "filterpåse" utrum  ;
  fingervante_nn_1_N = mkN "fingervante" utrum  ;
  finne_nn_1_N = mkN "finne" utrum  ;
  finnjolle_nn_1_N = mkN "finnjolle" utrum  ;
  firre_nn_1_N = mkN "firre" utrum  ;
  fiskbulle_nn_1_N = mkN "fiskbulle" utrum  ;
  fiskgjuse_nn_1_N = mkN "fiskgjuse" utrum  ;
  fiskpinne_nn_1_N = mkN "fiskpinne" utrum  ;
  fjuttholme_nn_1_N = mkN "fjuttholme" utrum  ;
  fjaederbuske_nn_1_1_N = mkN "fjäderbuske" utrum  ;
  fjaedervinge_nn_1_1_N = mkN "fjädervinge" utrum  ;
  flakmoppe_nn_1_N = mkN "flakmoppe" utrum  ;
  flanellborste_nn_1_N = mkN "flanellborste" utrum  ;
  flaskborste_nn_1_N = mkN "flaskborste" utrum  ;
  flotte_nn_1_N = mkN "flotte" utrum  ;
  flygekorre_nn_1_N = mkN "flygekorre" utrum  ;
  flygplansvinge_nn_1_N = mkN "flygplansvinge" utrum  ;
  foderpaase_nn_1_1_N = mkN "foderpåse" utrum  ;
  framvinge_nn_1_N = mkN "framvinge" utrum  ;
  fruktpaase_nn_1_1_N = mkN "fruktpåse" utrum  ;
  fruktsporre_nn_1_N = mkN "fruktsporre" utrum  ;
  fullmaane_nn_1_1_N = mkN "fullmåne" utrum  ;
  faelgborste_nn_1_1_N = mkN "fälgborste" utrum  ;
  faagelvinge_nn_1_1_N = mkN "fågelvinge" utrum  ;
  faale_nn_1_1_N = mkN "fåle" utrum  ;
  faange_nn_1_1_N = mkN "fånge" utrum  ;
  faarahage_nn_1_1_N = mkN "fårahage" utrum  ;
  foensterbaage_nn_1_1_N = mkN "fönsterbåge" utrum  ;
  foensterstolpe_nn_1_1_N = mkN "fönsterstolpe" utrum  ;
  foerseningstimme_nn_1_1_N = mkN "förseningstimme" utrum  ;
  galgbacke_nn_1_N = mkN "galgbacke" utrum  ;
  galge_nn_1_N = mkN "galge" utrum  ;
  gammastraale_nn_1_1_N = mkN "gammastråle" utrum  ;
  garnspole_nn_1_N = mkN "garnspole" utrum  ;
  gatpojke_nn_1_N = mkN "gatpojke" utrum  ;
  gelike_nn_1_N = mkN "gelike" utrum  ;
  generaloeverste_nn_1_1_N = mkN "generalöverste" utrum  ;
  gesimsbaage_nn_1_1_N = mkN "gesimsbåge" utrum  ;
  gjuse_nn_1_N = mkN "gjuse" utrum  ;
  glac_ehandske_nn_1_1_N = mkN "glacéhandske" utrum  ;
  glansbagge_nn_1_N = mkN "glansbagge" utrum  ;
  glasspinne_nn_1_N = mkN "glasspinne" utrum  ;
  glasoegonbaage_nn_1_1_N = mkN "glasögonbåge" utrum  ;
  glidarkille_nn_1_N = mkN "glidarkille" utrum  ;
  gode_nn_1_N = mkN "gode" utrum  ;
  golvbjaelke_nn_1_1_N = mkN "golvbjälke" utrum  ;
  gombaage_nn_1_1_N = mkN "gombåge" utrum  ;
  gomspene_nn_1_N = mkN "gomspene" utrum  ;
  gosse_nn_1_N = mkN "gosse" utrum  ;
  grabbnaeve_nn_1_1_N = mkN "grabbnäve" utrum  ;
  granne_nn_1_N = mkN "granne" utrum  ;
  grannpojke_nn_1_N = mkN "grannpojke" utrum  ;
  grepe_nn_1_N = mkN "grepe" utrum  ;
  grepe_nn_2_N = mkN "grepe" utrum  ;
  greve_nn_1_N = mkN "greve" utrum  ;
  grilljanne_nn_1_N = mkN "grilljanne" utrum  ;
  grinolle_nn_1_N = mkN "grinolle" utrum  ;
  grundtanke_nn_1_N = mkN "grundtanke" utrum  ;
  gruvlave_nn_1_N = mkN "gruvlave" utrum  ;
  grymtoxe_nn_1_N = mkN "grymtoxe" utrum  ;
  gryningstimme_nn_1_N = mkN "gryningstimme" utrum  ;
  grytvante_nn_1_N = mkN "grytvante" utrum  ;
  graenspaale_nn_1_1_N = mkN "gränspåle" utrum  ;
  graalle_nn_1_1_N = mkN "grålle" utrum  ;
  graasosse_nn_1_1_N = mkN "gråsosse" utrum  ;
  gubbe_nn_1_N = mkN "gubbe" utrum  ;
  guldspade_nn_1_N = mkN "guldspade" utrum  ;
  gulsporre_nn_1_N = mkN "gulsporre" utrum  ;
  gummihandske_nn_1_N = mkN "gummihandske" utrum  ;
  gumse_nn_1_N = mkN "gumse" utrum  ;
  gute_nn_1_N = mkN "gute" utrum  ;
  gymnastiktimme_nn_1_N = mkN "gymnastiktimme" utrum  ;
  gaelbaage_nn_1_1_N = mkN "gälbåge" utrum  ;
  gaestrike_nn_1_1_N = mkN "gästrike" utrum  ;
  gaardskulle_nn_1_1_N = mkN "gårdskulle" utrum  ;
  gaase_nn_1_1_N = mkN "gåse" utrum  ;
  goerdelbaage_nn_1_1_N = mkN "gördelbåge" utrum  ;
  goesstake_nn_1_1_N = mkN "gösstake" utrum  ;
  hage_nn_1_N = mkN "hage" utrum  ;
  hake_nn_1_N = mkN "hake" utrum  ;
  hallonbuske_nn_1_N = mkN "hallonbuske" utrum  ;
  halskrage_nn_1_N = mkN "halskrage" utrum  ;
  halvbuske_nn_1_N = mkN "halvbuske" utrum  ;
  halvmaane_nn_1_1_N = mkN "halvmåne" utrum  ;
  halvtimme_nn_1_N = mkN "halvtimme" utrum  ;
  hanbjaelke_nn_1_1_N = mkN "hanbjälke" utrum  ;
  handklove_nn_1_N = mkN "handklove" utrum  ;
  handljusstake_nn_1_N = mkN "handljusstake" utrum  ;
  handlove_nn_1_N = mkN "handlove" utrum  ;
  handske_nn_1_N = mkN "handske" utrum  ;
  handskriftsrulle_nn_1_N = mkN "handskriftsrulle" utrum  ;
  hane_nn_1_N = mkN "hane" utrum  ;
  hanne_nn_1_N = mkN "hanne" utrum  ;
  harhanne_nn_1_N = mkN "harhanne" utrum  ;
  hattkulle_nn_1_N = mkN "hattkulle" utrum  ;
  havsabborre_nn_1_N = mkN "havsabborre" utrum  ;
  herdegosse_nn_1_N = mkN "herdegosse" utrum  ;
  herre_nn_1_N = mkN "herre" utrum  ;
  hetsporre_nn_1_N = mkN "hetsporre" utrum  ;
  himlastege_nn_1_N = mkN "himlastege" utrum  ;
  hjaelmpaase_nn_1_1_N = mkN "hjälmpåse" utrum  ;
  holme_nn_1_N = mkN "holme" utrum  ;
  hopp_i_landkalle_nn_1_N = mkN "hopp-i-landkalle" utrum  ;
  hoppbacke_nn_1_N = mkN "hoppbacke" utrum  ;
  hornbaage_nn_1_1_N = mkN "hornbåge" utrum  ;
  hotellpojke_nn_1_N = mkN "hotellpojke" utrum  ;
  huggkubbe_nn_1_N = mkN "huggkubbe" utrum  ;
  hundslaede_nn_1_1_N = mkN "hundsläde" utrum  ;
  hurtbulle_nn_1_N = mkN "hurtbulle" utrum  ;
  hushaallsrulle_nn_1_1_N = mkN "hushållsrulle" utrum  ;
  husse_nn_1_N = mkN "husse" utrum  ;
  huvudtanke_nn_1_N = mkN "huvudtanke" utrum  ;
  haestkrake_nn_1_1_N = mkN "hästkrake" utrum  ;
  haestskobaage_nn_1_1_N = mkN "hästskobåge" utrum  ;
  haaltimme_nn_1_1_N = mkN "håltimme" utrum  ;
  haarborste_nn_1_1_N = mkN "hårborste" utrum  ;
  haardhandske_nn_1_1_N = mkN "hårdhandske" utrum  ;
  haarrulle_nn_1_1_N = mkN "hårrulle" utrum  ;
  hoensarve_nn_1_1_N = mkN "hönsarve" utrum  ;
  hoeskulle_nn_1_1_N = mkN "höskulle" utrum  ;
  hoesaate_nn_1_1_N = mkN "hösåte" utrum  ;
  induktionsspole_nn_1_N = mkN "induktionsspole" utrum  ;
  infanterispade_nn_1_N = mkN "infanterispade" utrum  ;
  jakobsstege_nn_1_N = mkN "jakobsstege" utrum  ;
  jeppe_nn_1_N = mkN "jeppe" utrum  ;
  jolle_nn_1_N = mkN "jolle" utrum  ;
  jonstraale_nn_1_1_N = mkN "jonstråle" utrum  ;
  jordekorre_nn_1_N = mkN "jordekorre" utrum  ;
  jordgubbe_nn_1_N = mkN "jordgubbe" utrum  ;
  jordpaase_nn_1_1_N = mkN "jordpåse" utrum  ;
  julkasse_nn_1_N = mkN "julkasse" utrum  ;
  julkaerve_nn_1_1_N = mkN "julkärve" utrum  ;
  julle_nn_1_N = mkN "julle" utrum  ;
  jute_nn_2_N = mkN "jute" utrum  ;
  jycke_nn_1_N = mkN "jycke" utrum  ;
  jaemlike_nn_1_1_N = mkN "jämlike" utrum  ;
  jaemte_nn_1_1_N = mkN "jämte" utrum  ;
  jaernpinne_nn_1_1_N = mkN "järnpinne" utrum  ;
  jaerpe_nn_1_1_N = mkN "järpe" utrum  ;
  joesse_nn_1_1_N = mkN "jösse" utrum  ;
  kaffebuske_nn_1_N = mkN "kaffebuske" utrum  ;
  kagge_nn_1_N = mkN "kagge" utrum  ;
  kalkonrulle_nn_1_N = mkN "kalkonrulle" utrum  ;
  kalvjaerpe_nn_1_1_N = mkN "kalvjärpe" utrum  ;
  kanelbulle_nn_1_N = mkN "kanelbulle" utrum  ;
  kappe_nn_1_N = mkN "kappe" utrum  ;
  kardborre_nn_1_N = mkN "kardborre" utrum  ;
  karriaerstege_nn_1_1_N = mkN "karriärstege" utrum  ;
  kase_nn_1_N = mkN "kase" utrum  ;
  kasse_nn_1_N = mkN "kasse" utrum  ;
  katodstraale_nn_1_1_N = mkN "katodstråle" utrum  ;
  katse_nn_1_N = mkN "katse" utrum  ;
  kavajkrage_nn_1_N = mkN "kavajkrage" utrum  ;
  kavle_nn_1_N = mkN "kavle" utrum  ;
  kaxe_nn_1_N = mkN "kaxe" utrum  ;
  kikaertsbulle_nn_1_1_N = mkN "kikärtsbulle" utrum  ;
  kille_nn_1_N = mkN "kille" utrum  ;
  kindpaase_nn_1_1_N = mkN "kindpåse" utrum  ;
  kisse_nn_1_N = mkN "kisse" utrum  ;
  klabbe_nn_1_N = mkN "klabbe" utrum  ;
  klabbskoete_nn_1_1_N = mkN "klabbsköte" utrum  ;
  klase_nn_1_N = mkN "klase" utrum  ;
  klave_nn_1_N = mkN "klave" utrum  ;
  klove_nn_1_N = mkN "klove" utrum  ;
  knagge_nn_1_N = mkN "knagge" utrum  ;
  knalle_nn_1_N = mkN "knalle" utrum  ;
  knape_nn_1_N = mkN "knape" utrum  ;
  knatte_nn_1_N = mkN "knatte" utrum  ;
  knoge_nn_1_N = mkN "knoge" utrum  ;
  knorrhane_nn_1_N = mkN "knorrhane" utrum  ;
  knutte_nn_1_N = mkN "knutte" utrum  ;
  knytnaeve_nn_1_1_N = mkN "knytnäve" utrum  ;
  knaeppbagge_nn_1_1_N = mkN "knäppbagge" utrum  ;
  kobbe_nn_1_N = mkN "kobbe" utrum  ;
  kohage_nn_1_N = mkN "kohage" utrum  ;
  kolborste_nn_1_N = mkN "kolborste" utrum  ;
  kolbulle_nn_1_N = mkN "kolbulle" utrum  ;
  koloradoskalbagge_nn_1_N = mkN "koloradoskalbagge" utrum  ;
  kontaktborste_nn_1_N = mkN "kontaktborste" utrum  ;
  korpvinge_nn_1_N = mkN "korpvinge" utrum  ;
  kortoxe_nn_1_N = mkN "kortoxe" utrum  ;
  korvgubbe_nn_1_N = mkN "korvgubbe" utrum  ;
  kotte_nn_1_N = mkN "kotte" utrum  ;
  krage_nn_1_N = mkN "krage" utrum  ;
  kraghandske_nn_1_N = mkN "kraghandske" utrum  ;
  krake_nn_1_N = mkN "krake" utrum  ;
  kriminaldaare_nn_1_1_N = mkN "kriminaldåre" utrum  ;
  krusbaersbuske_nn_1_1_N = mkN "krusbärsbuske" utrum  ;
  krutgubbe_nn_1_N = mkN "krutgubbe" utrum  ;
  kubbe_nn_1_N = mkN "kubbe" utrum  ;
  kudde_nn_1_N = mkN "kudde" utrum  ;
  kugge_nn_1_N = mkN "kugge" utrum  ;
  kulkaerve_nn_1_1_N = mkN "kulkärve" utrum  ;
  kulle_nn_1_N = mkN "kulle" utrum  ;
  kulle_nn_2_N = mkN "kulle" utrum  ;
  kulturknutte_nn_1_N = mkN "kulturknutte" utrum  ;
  kungstanke_nn_1_N = mkN "kungstanke" utrum  ;
  kurre_nn_1_N = mkN "kurre" utrum  ;
  kuse_nn_1_N = mkN "kuse" utrum  ;
  kvarnvinge_nn_1_N = mkN "kvarnvinge" utrum  ;
  kyrkbacke_nn_1_N = mkN "kyrkbacke" utrum  ;
  kaeke_nn_1_1_N = mkN "käke" utrum  ;
  kaelkbacke_nn_1_1_N = mkN "kälkbacke" utrum  ;
  kaelke_nn_1_1_N = mkN "kälke" utrum  ;
  kaerngubbe_nn_1_1_N = mkN "kärngubbe" utrum  ;
  kaerve_nn_1_1_N = mkN "kärve" utrum  ;
  kaette_nn_1_1_N = mkN "kätte" utrum  ;
  kaaldolme_nn_1_1_N = mkN "kåldolme" utrum  ;
  kaare_nn_1_1_N = mkN "kåre" utrum  ;
  kaarknutte_nn_1_1_N = mkN "kårknutte" utrum  ;
  koeksrulle_nn_1_1_N = mkN "köksrulle" utrum  ;
  koettbulle_nn_1_1_N = mkN "köttbulle" utrum  ;
  labbe_nn_1_N = mkN "labbe" utrum  ;
  labradorhanne_nn_1_N = mkN "labradorhanne" utrum  ;
  lackrulle_nn_1_N = mkN "lackrulle" utrum  ;
  laddningsstolpe_nn_1_N = mkN "laddningsstolpe" utrum  ;
  laddstolpe_nn_1_N = mkN "laddstolpe" utrum  ;
  lagaardsbacke_nn_1_1_N = mkN "lagårdsbacke" utrum  ;
  lakanspaase_nn_1_1_N = mkN "lakanspåse" utrum  ;
  lake_nn_1_N = mkN "lake" utrum  ;
  lantgreve_nn_1_N = mkN "lantgreve" utrum  ;
  lappvante_nn_1_N = mkN "lappvante" utrum  ;
  latoxe_nn_1_N = mkN "latoxe" utrum  ;
  lave_nn_1_N = mkN "lave" utrum  ;
  ledningsstolpe_nn_1_N = mkN "ledningsstolpe" utrum  ;
  lektionstimme_nn_1_N = mkN "lektionstimme" utrum  ;
  lie_nn_1_N = mkN "lie" utrum  ;
  like_nn_1_N = mkN "like" utrum  ;
  liljekulle_nn_1_N = mkN "liljekulle" utrum  ;
  lillpojke_nn_1_N = mkN "lillpojke" utrum  ;
  limborste_nn_1_N = mkN "limborste" utrum  ;
  limpinne_nn_1_N = mkN "limpinne" utrum  ;
  lingonbuske_nn_1_N = mkN "lingonbuske" utrum  ;
  ljumske_nn_1_N = mkN "ljumske" utrum  ;
  ljusbaage_nn_1_1_N = mkN "ljusbåge" utrum  ;
  ljusstake_nn_1_N = mkN "ljusstake" utrum  ;
  ljusstraale_nn_1_1_N = mkN "ljusstråle" utrum  ;
  loge_nn_1_N = mkN "loge" utrum  ;
  love_nn_1_N = mkN "love" utrum  ;
  luftstrupe_nn_1_N = mkN "luftstrupe" utrum  ;
  lunchtimme_nn_1_N = mkN "lunchtimme" utrum  ;
  lunne_nn_1_N = mkN "lunne" utrum  ;
  lunnkaelke_nn_1_1_N = mkN "lunnkälke" utrum  ;
  lussebulle_nn_1_N = mkN "lussebulle" utrum  ;
  lustigkurre_nn_1_N = mkN "lustigkurre" utrum  ;
  lyktgubbe_nn_1_N = mkN "lyktgubbe" utrum  ;
  lyktstolpe_nn_1_N = mkN "lyktstolpe" utrum  ;
  laerkvinge_nn_1_1_N = mkN "lärkvinge" utrum  ;
  laerpojke_nn_1_1_N = mkN "lärpojke" utrum  ;
  laagmosse_nn_1_1_N = mkN "lågmosse" utrum  ;
  loevkasse_nn_1_1_N = mkN "lövkasse" utrum  ;
  mage_nn_1_N = mkN "mage" utrum  ;
  majbagge_nn_1_N = mkN "majbagge" utrum  ;
  malpaase_nn_1_1_N = mkN "malpåse" utrum  ;
  manke_nn_1_N = mkN "manke" utrum  ;
  markgreve_nn_1_N = mkN "markgreve" utrum  ;
  massbjaesse_nn_1_1_N = mkN "massbjässe" utrum  ;
  mastkrage_nn_1_N = mkN "mastkrage" utrum  ;
  matkasse_nn_1_N = mkN "matkasse" utrum  ;
  matstrupe_nn_1_N = mkN "matstrupe" utrum  ;
  matte_nn_2_N = mkN "matte" utrum  ;
  mede_nn_1_N = mkN "mede" utrum  ;
  metallbaage_nn_1_1_N = mkN "metallbåge" utrum  ;
  middagstimme_nn_1_N = mkN "middagstimme" utrum  ;
  milstolpe_nn_1_N = mkN "milstolpe" utrum  ;
  misse_nn_1_N = mkN "misse" utrum  ;
  mjukbagge_nn_1_N = mkN "mjukbagge" utrum  ;
  mjaelte_nn_1_1_N = mkN "mjälte" utrum  ;
  mjaerde_nn_1_1_N = mkN "mjärde" utrum  ;
  mjoelbagge_nn_1_1_N = mkN "mjölbagge" utrum  ;
  mjoelke_nn_1_1_N = mkN "mjölke" utrum  ;
  mjoelpaase_nn_1_1_N = mkN "mjölpåse" utrum  ;
  molngubbe_nn_1_N = mkN "molngubbe" utrum  ;
  moppe_nn_1_N = mkN "moppe" utrum  ;
  morgontimme_nn_1_N = mkN "morgontimme" utrum  ;
  mosse_nn_1_N = mkN "mosse" utrum  ;
  mule_nn_1_N = mkN "mule" utrum  ;
  multe_nn_1_N = mkN "multe" utrum  ;
  munkavle_nn_1_N = mkN "munkavle" utrum  ;
  murre_nn_1_N = mkN "murre" utrum  ;
  muskelknutte_nn_1_N = mkN "muskelknutte" utrum  ;
  muskelspole_nn_1_N = mkN "muskelspole" utrum  ;
  myrbagge_nn_1_N = mkN "myrbagge" utrum  ;
  myrholme_nn_1_N = mkN "myrholme" utrum  ;
  myskoxe_nn_1_N = mkN "myskoxe" utrum  ;
  maergstraale_nn_1_1_N = mkN "märgstråle" utrum  ;
  maesspojke_nn_1_1_N = mkN "mässpojke" utrum  ;
  maabaersbuske_nn_1_1_N = mkN "måbärsbuske" utrum  ;
  maalarborste_nn_1_1_N = mkN "målarborste" utrum  ;
  maalstolpe_nn_1_1_N = mkN "målstolpe" utrum  ;
  maane_nn_1_1_N = mkN "måne" utrum  ;
  nabbe_nn_1_N = mkN "nabbe" utrum  ;
  nacke_nn_1_N = mkN "nacke" utrum  ;
  namne_nn_1_N = mkN "namne" utrum  ;
  nate_nn_1_N = mkN "nate" utrum  ;
  nedfoersbacke_nn_1_1_N = mkN "nedförsbacke" utrum  ;
  nemesistanke_nn_1_N = mkN "nemesistanke" utrum  ;
  nerfoersbacke_nn_1_1_N = mkN "nerförsbacke" utrum  ;
  njure_nn_1_N = mkN "njure" utrum  ;
  norrbagge_nn_1_N = mkN "norrbagge" utrum  ;
  nubbe_nn_1_N = mkN "nubbe" utrum  ;
  nyboerjarbaage_nn_1_1_N = mkN "nybörjarbåge" utrum  ;
  nystpinne_nn_1_N = mkN "nystpinne" utrum  ;
  naesborre_nn_1_1_N = mkN "näsborre" utrum  ;
  naesvinge_nn_1_1_N = mkN "näsvinge" utrum  ;
  naetvinge_nn_1_1_N = mkN "nätvinge" utrum  ;
  naeve_nn_1_1_N = mkN "näve" utrum  ;
  odygdspaase_nn_1_1_N = mkN "odygdspåse" utrum  ;
  okbaage_nn_1_1_N = mkN "okbåge" utrum  ;
  oleanderbuske_nn_1_N = mkN "oleanderbuske" utrum  ;
  olle_nn_1_N = mkN "olle" utrum  ;
  ollonborre_nn_1_N = mkN "ollonborre" utrum  ;
  optimistjolle_nn_1_N = mkN "optimistjolle" utrum  ;
  ormbunke_nn_1_N = mkN "ormbunke" utrum  ;
  orne_nn_1_N = mkN "orne" utrum  ;
  orre_nn_1_N = mkN "orre" utrum  ;
  oxe_nn_1_N = mkN "oxe" utrum  ;
  oxjaerpe_nn_1_1_N = mkN "oxjärpe" utrum  ;
  p_rulle_nn_1_N = mkN "p-rulle" utrum  ;
  packe_nn_1_N = mkN "packe" utrum  ;
  papperskasse_nn_1_N = mkN "papperskasse" utrum  ;
  papperspelle_nn_1_N = mkN "papperspelle" utrum  ;
  papperspaase_nn_1_1_N = mkN "papperspåse" utrum  ;
  papyrusrulle_nn_1_N = mkN "papyrusrulle" utrum  ;
  partikelstraale_nn_1_1_N = mkN "partikelstråle" utrum  ;
  patte_nn_1_N = mkN "patte" utrum  ;
  pekpinne_nn_1_N = mkN "pekpinne" utrum  ;
  penningpaase_nn_1_1_N = mkN "penningpåse" utrum  ;
  pepparkaksgubbe_nn_1_N = mkN "pepparkaksgubbe" utrum  ;
  pergamentrulle_nn_1_N = mkN "pergamentrulle" utrum  ;
  persedelpaase_nn_1_1_N = mkN "persedelpåse" utrum  ;
  pilbaage_nn_1_1_N = mkN "pilbåge" utrum  ;
  pillerbagge_nn_1_N = mkN "pillerbagge" utrum  ;
  pinne_nn_1_N = mkN "pinne" utrum  ;
  pipkrage_nn_1_N = mkN "pipkrage" utrum  ;
  planteringsspade_nn_1_N = mkN "planteringsspade" utrum  ;
  plastbaage_nn_1_1_N = mkN "plastbåge" utrum  ;
  plastpaase_nn_1_1_N = mkN "plastpåse" utrum  ;
  plastsoppaase_nn_1_1_N = mkN "plastsoppåse" utrum  ;
  pojke_nn_1_N = mkN "pojke" utrum  ;
  polokrage_nn_1_N = mkN "polokrage" utrum  ;
  praktbagge_nn_1_N = mkN "praktbagge" utrum  ;
  pressgranne_nn_1_N = mkN "pressgranne" utrum  ;
  prisse_nn_1_N = mkN "prisse" utrum  ;
  prydnadsbuske_nn_1_N = mkN "prydnadsbuske" utrum  ;
  praelle_nn_1_1_N = mkN "prälle" utrum  ;
  praestkrage_nn_1_1_N = mkN "prästkrage" utrum  ;
  puckeloxe_nn_1_N = mkN "puckeloxe" utrum  ;
  puke_nn_1_N = mkN "puke" utrum  ;
  pulkabacke_nn_1_N = mkN "pulkabacke" utrum  ;
  putte_nn_1_N = mkN "putte" utrum  ;
  paale_nn_1_1_N = mkN "påle" utrum  ;
  paase_nn_1_1_N = mkN "påse" utrum  ;
  rackelhane_nn_1_N = mkN "rackelhane" utrum  ;
  rakborste_nn_1_N = mkN "rakborste" utrum  ;
  rapsbagge_nn_1_N = mkN "rapsbagge" utrum  ;
  rattkaelke_nn_1_1_N = mkN "rattkälke" utrum  ;
  regnbaage_nn_1_1_N = mkN "regnbåge" utrum  ;
  regndroppe_nn_1_N = mkN "regndroppe" utrum  ;
  renhaallningsgubbe_nn_1_1_N = mkN "renhållningsgubbe" utrum  ;
  renoxe_nn_1_N = mkN "renoxe" utrum  ;
  repstege_nn_1_N = mkN "repstege" utrum  ;
  rese_nn_1_N = mkN "rese" utrum  ;
  ricinbuske_nn_1_N = mkN "ricinbuske" utrum  ;
  riddarsporre_nn_1_N = mkN "riddarsporre" utrum  ;
  risvase_nn_1_N = mkN "risvase" utrum  ;
  rorpinne_nn_1_N = mkN "rorpinne" utrum  ;
  rosenbuske_nn_1_N = mkN "rosenbuske" utrum  ;
  rotborste_nn_1_N = mkN "rotborste" utrum  ;
  rugge_nn_1_N = mkN "rugge" utrum  ;
  rulle_nn_1_N = mkN "rulle" utrum  ;
  rumsgranne_nn_1_N = mkN "rumsgranne" utrum  ;
  rundbaage_nn_1_1_N = mkN "rundbåge" utrum  ;
  ryktborste_nn_1_N = mkN "ryktborste" utrum  ;
  ryssgubbe_nn_1_N = mkN "ryssgubbe" utrum  ;
  raetstege_nn_1_1_N = mkN "rätstege" utrum  ;
  raetvinge_nn_1_1_N = mkN "rätvinge" utrum  ;
  saffransbulle_nn_1_N = mkN "saffransbulle" utrum  ;
  salskrake_nn_1_N = mkN "salskrake" utrum  ;
  sate_nn_1_N = mkN "sate" utrum  ;
  schillerkrage_nn_1_N = mkN "schillerkrage" utrum  ;
  sci_fi_rulle_nn_1_N = mkN "sci-fi-rulle" utrum  ;
  segeljolle_nn_1_N = mkN "segeljolle" utrum  ;
  segmentbaage_nn_1_1_N = mkN "segmentbåge" utrum  ;
  sejte_nn_1_N = mkN "sejte" utrum  ;
  sekundaerspole_nn_1_1_N = mkN "sekundärspole" utrum  ;
  sele_nn_1_N = mkN "sele" utrum  ;
  serve_nn_1_N = mkN "serve" utrum  ;
  sexualdaare_nn_1_1_N = mkN "sexualdåre" utrum  ;
  signalspade_nn_1_N = mkN "signalspade" utrum  ;
  sillbulle_nn_1_N = mkN "sillbulle" utrum  ;
  sillmjoelke_nn_1_1_N = mkN "sillmjölke" utrum  ;
  simflotte_nn_1_N = mkN "simflotte" utrum  ;
  simplexpaale_nn_1_1_N = mkN "simplexpåle" utrum  ;
  sittpinne_nn_1_N = mkN "sittpinne" utrum  ;
  sjalkrage_nn_1_N = mkN "sjalkrage" utrum  ;
  sjoeborre_nn_1_1_N = mkN "sjöborre" utrum  ;
  sjoemanskrage_nn_1_1_N = mkN "sjömanskrage" utrum  ;
  sjoeorre_nn_1_1_N = mkN "sjöorre" utrum  ;
  skalbagge_nn_1_N = mkN "skalbagge" utrum  ;
  skalle_nn_1_N = mkN "skalle" utrum  ;
  skampaale_nn_1_1_N = mkN "skampåle" utrum  ;
  skarvrulle_nn_1_N = mkN "skarvrulle" utrum  ;
  skate_nn_1_N = mkN "skate" utrum  ;
  skeppspojke_nn_1_N = mkN "skeppspojke" utrum  ;
  skidbacke_nn_1_N = mkN "skidbacke" utrum  ;
  skidhandske_nn_1_N = mkN "skidhandske" utrum  ;
  skinnbagge_nn_1_N = mkN "skinnbagge" utrum  ;
  skinnkaelke_nn_1_1_N = mkN "skinnkälke" utrum  ;
  skitgubbe_nn_1_N = mkN "skitgubbe" utrum  ;
  skjortkrage_nn_1_N = mkN "skjortkrage" utrum  ;
  skjutskaare_nn_1_1_N = mkN "skjutskåre" utrum  ;
  skoborste_nn_1_N = mkN "skoborste" utrum  ;
  skogsbacke_nn_1_N = mkN "skogsbacke" utrum  ;
  skogsbagge_nn_1_N = mkN "skogsbagge" utrum  ;
  skolpojke_nn_1_N = mkN "skolpojke" utrum  ;
  skotte_nn_1_N = mkN "skotte" utrum  ;
  skottspole_nn_1_N = mkN "skottspole" utrum  ;
  skrake_nn_1_N = mkN "skrake" utrum  ;
  skrothaemtningsgubbe_nn_1_1_N = mkN "skrothämtningsgubbe" utrum  ;
  skulle_nn_1_N = mkN "skulle" utrum  ;
  skurborste_nn_1_N = mkN "skurborste" utrum  ;
  skvaltorre_nn_1_N = mkN "skvaltorre" utrum  ;
  skaare_nn_1_1_N = mkN "skåre" utrum  ;
  slagpaase_nn_1_1_N = mkN "slagpåse" utrum  ;
  slangbaage_nn_1_1_N = mkN "slangbåge" utrum  ;
  slase_nn_1_N = mkN "slase" utrum  ;
  slice_nn_1_N = mkN "slice" utrum  ;
  slickepinne_nn_1_N = mkN "slickepinne" utrum  ;
  slypinne_nn_1_N = mkN "slypinne" utrum  ;
  slaede_nn_1_1_N = mkN "släde" utrum  ;
  slaengkaelke_nn_1_1_N = mkN "slängkälke" utrum  ;
  slaanbaersbuske_nn_1_1_N = mkN "slånbärsbuske" utrum  ;
  smidesljusstake_nn_1_N = mkN "smidesljusstake" utrum  ;
  smutspaase_nn_1_1_N = mkN "smutspåse" utrum  ;
  smaapojke_nn_1_1_N = mkN "småpojke" utrum  ;
  smoergaasnisse_nn_1_1_N = mkN "smörgåsnisse" utrum  ;
  smoerspade_nn_1_1_N = mkN "smörspade" utrum  ;
  snapphane_nn_1_N = mkN "snapphane" utrum  ;
  snubbe_nn_1_N = mkN "snubbe" utrum  ;
  snusgubbe_nn_1_N = mkN "snusgubbe" utrum  ;
  snuskpelle_nn_1_N = mkN "snuskpelle" utrum  ;
  snytbagge_nn_1_N = mkN "snytbagge" utrum  ;
  snoebollsbuske_nn_1_1_N = mkN "snöbollsbuske" utrum  ;
  snoeborste_nn_1_1_N = mkN "snöborste" utrum  ;
  snoedroppe_nn_1_1_N = mkN "snödroppe" utrum  ;
  snoegubbe_nn_1_1_N = mkN "snögubbe" utrum  ;
  snoeslaede_nn_1_1_N = mkN "snösläde" utrum  ;
  societetsstege_nn_1_N = mkN "societetsstege" utrum  ;
  solstraale_nn_1_1_N = mkN "solstråle" utrum  ;
  soltimme_nn_1_N = mkN "soltimme" utrum  ;
  sopbacke_nn_1_N = mkN "sopbacke" utrum  ;
  sopborste_nn_1_N = mkN "sopborste" utrum  ;
  soppaase_nn_1_1_N = mkN "soppåse" utrum  ;
  sotarmurre_nn_1_N = mkN "sotarmurre" utrum  ;
  spade_nn_1_N = mkN "spade" utrum  ;
  sparre_nn_1_N = mkN "sparre" utrum  ;
  spene_nn_1_N = mkN "spene" utrum  ;
  spetsbaage_nn_1_1_N = mkN "spetsbåge" utrum  ;
  spinnrulle_nn_1_N = mkN "spinnrulle" utrum  ;
  spjaele_nn_1_1_N = mkN "spjäle" utrum  ;
  spole_nn_1_N = mkN "spole" utrum  ;
  sporre_nn_1_N = mkN "sporre" utrum  ;
  sprakfaale_nn_1_1_N = mkN "sprakfåle" utrum  ;
  sprattelgubbe_nn_1_N = mkN "sprattelgubbe" utrum  ;
  springpojke_nn_1_N = mkN "springpojke" utrum  ;
  spraettbaage_nn_1_1_N = mkN "sprättbåge" utrum  ;
  spypaase_nn_1_1_N = mkN "spypåse" utrum  ;
  spoektimme_nn_1_1_N = mkN "spöktimme" utrum  ;
  stabbe_nn_1_N = mkN "stabbe" utrum  ;
  stake_nn_1_N = mkN "stake" utrum  ;
  staketstolpe_nn_1_N = mkN "staketstolpe" utrum  ;
  stallbacke_nn_1_N = mkN "stallbacke" utrum  ;
  stege_nn_1_N = mkN "stege" utrum  ;
  stegpinne_nn_1_N = mkN "stegpinne" utrum  ;
  stekspade_nn_1_N = mkN "stekspade" utrum  ;
  stele_nn_1_N = mkN "stele" utrum  ;
  stingpinne_nn_1_N = mkN "stingpinne" utrum  ;
  stjaerngranne_nn_1_1_N = mkN "stjärngranne" utrum  ;
  stolle_nn_1_N = mkN "stolle" utrum  ;
  stolpe_nn_1_N = mkN "stolpe" utrum  ;
  stomme_nn_1_N = mkN "stomme" utrum  ;
  storskrake_nn_1_N = mkN "storskrake" utrum  ;
  storstadskille_nn_1_N = mkN "storstadskille" utrum  ;
  strandflate_nn_1_N = mkN "strandflate" utrum  ;
  streckgubbe_nn_1_N = mkN "streckgubbe" utrum  ;
  stridssele_nn_1_N = mkN "stridssele" utrum  ;
  strupe_nn_1_N = mkN "strupe" utrum  ;
  strykpojke_nn_1_N = mkN "strykpojke" utrum  ;
  straevbaage_nn_1_1_N = mkN "strävbåge" utrum  ;
  straake_nn_1_1_N = mkN "stråke" utrum  ;
  straale_nn_1_1_N = mkN "stråle" utrum  ;
  stubbe_nn_1_N = mkN "stubbe" utrum  ;
  staalborste_nn_1_1_N = mkN "stålborste" utrum  ;
  staandkrage_nn_1_1_N = mkN "ståndkrage" utrum  ;
  supermaane_nn_1_1_N = mkN "supermåne" utrum  ;
  svale_nn_1_N = mkN "svale" utrum  ;
  sverigefinne_nn_1_N = mkN "sverigefinne" utrum  ;
  svettdroppe_nn_1_N = mkN "svettdroppe" utrum  ;
  sybaage_nn_1_1_N = mkN "sybåge" utrum  ;
  saedeskaerve_nn_1_1_N = mkN "sädeskärve" utrum  ;
  saelgbuske_nn_1_1_N = mkN "sälgbuske" utrum  ;
  saelle_nn_1_1_N = mkN "sälle" utrum  ;
  saate_nn_1_1_N = mkN "såte" utrum  ;
  tabbe_nn_1_N = mkN "tabbe" utrum  ;
  taggstraale_nn_1_1_N = mkN "taggstråle" utrum  ;
  taggtraadsrulle_nn_1_1_N = mkN "taggtrådsrulle" utrum  ;
  takbjaelke_nn_1_1_N = mkN "takbjälke" utrum  ;
  taksparre_nn_1_N = mkN "taksparre" utrum  ;
  taktpinne_nn_1_N = mkN "taktpinne" utrum  ;
  talgoxe_nn_1_N = mkN "talgoxe" utrum  ;
  tandborste_nn_1_N = mkN "tandborste" utrum  ;
  tapetborste_nn_1_N = mkN "tapetborste" utrum  ;
  tebuske_nn_1_N = mkN "tebuske" utrum  ;
  tejprulle_nn_1_N = mkN "tejprulle" utrum  ;
  telefonstolpe_nn_1_N = mkN "telefonstolpe" utrum  ;
  tepaase_nn_1_1_N = mkN "tepåse" utrum  ;
  tidmaane_nn_1_1_N = mkN "tidmåne" utrum  ;
  tiggarpaase_nn_1_1_N = mkN "tiggarpåse" utrum  ;
  timme_nn_1_N = mkN "timme" utrum  ;
  timmerflotte_nn_1_N = mkN "timmerflotte" utrum  ;
  tinne_nn_1_N = mkN "tinne" utrum  ;
  tistelborre_nn_1_N = mkN "tistelborre" utrum  ;
  tjomme_nn_1_N = mkN "tjomme" utrum  ;
  tjurnacke_nn_1_N = mkN "tjurnacke" utrum  ;
  tjuvbagge_nn_1_N = mkN "tjuvbagge" utrum  ;
  tjuvpojke_nn_1_N = mkN "tjuvpojke" utrum  ;
  tokstolle_nn_1_N = mkN "tokstolle" utrum  ;
  tonaarspojke_nn_1_1_N = mkN "tonårspojke" utrum  ;
  tordmule_nn_1_N = mkN "tordmule" utrum  ;
  torvmosse_nn_1_N = mkN "torvmosse" utrum  ;
  torvspade_nn_1_N = mkN "torvspade" utrum  ;
  totempaale_nn_1_1_N = mkN "totempåle" utrum  ;
  trappstege_nn_1_N = mkN "trappstege" utrum  ;
  trave_nn_1_N = mkN "trave" utrum  ;
  trimmerspole_nn_1_N = mkN "trimmerspole" utrum  ;
  triumfbaage_nn_1_1_N = mkN "triumfbåge" utrum  ;
  trumpinne_nn_1_N = mkN "trumpinne" utrum  ;
  tryckfelsnisse_nn_1_N = mkN "tryckfelsnisse" utrum  ;
  traedgaardsbuske_nn_1_1_N = mkN "trädgårdsbuske" utrum  ;
  traedgaardsspade_nn_1_1_N = mkN "trädgårdsspade" utrum  ;
  traepinne_nn_1_1_N = mkN "träpinne" utrum  ;
  traadrulle_nn_1_1_N = mkN "trådrulle" utrum  ;
  tumme_nn_1_N = mkN "tumme" utrum  ;
  tumvante_nn_1_N = mkN "tumvante" utrum  ;
  tungspene_nn_1_N = mkN "tungspene" utrum  ;
  tutte_nn_1_N = mkN "tutte" utrum  ;
  tvaerbjaelke_nn_1_1_N = mkN "tvärbjälke" utrum  ;
  tvaangstanke_nn_1_1_N = mkN "tvångstanke" utrum  ;
  tvaavinge_nn_1_1_N = mkN "tvåvinge" utrum  ;
  tygrulle_nn_1_N = mkN "tygrulle" utrum  ;
  taeckvinge_nn_1_1_N = mkN "täckvinge" utrum  ;
  taeltpinne_nn_1_1_N = mkN "tältpinne" utrum  ;
  taendspole_nn_1_1_N = mkN "tändspole" utrum  ;
  taange_nn_1_1_N = mkN "tånge" utrum  ;
  taanglake_nn_1_1_N = mkN "tånglake" utrum  ;
  taartspade_nn_1_1_N = mkN "tårtspade" utrum  ;
  toernbuske_nn_1_1_N = mkN "törnbuske" utrum  ;
  udde_nn_1_N = mkN "udde" utrum  ;
  ugnsspade_nn_1_N = mkN "ugnsspade" utrum  ;
  underkaeke_nn_1_1_N = mkN "underkäke" utrum  ;
  undersaate_nn_1_1_N = mkN "undersåte" utrum  ;
  undervisningstimme_nn_1_N = mkN "undervisningstimme" utrum  ;
  unge_nn_1_N = mkN "unge" utrum  ;
  ungherre_nn_1_N = mkN "ungherre" utrum  ;
  uppfoersbacke_nn_1_1_N = mkN "uppförsbacke" utrum  ;
  uppsamlingsborste_nn_1_N = mkN "uppsamlingsborste" utrum  ;
  uppsamlingskasse_nn_1_N = mkN "uppsamlingskasse" utrum  ;
  urnkulle_nn_1_N = mkN "urnkulle" utrum  ;
  urormbunke_nn_1_N = mkN "urormbunke" utrum  ;
  uroxe_nn_1_N = mkN "uroxe" utrum  ;
  utfoersbacke_nn_1_1_N = mkN "utförsbacke" utrum  ;
  utvikningspojke_nn_1_N = mkN "utvikningspojke" utrum  ;
  vallpojke_nn_1_N = mkN "vallpojke" utrum  ;
  valvbaage_nn_1_1_N = mkN "valvbåge" utrum  ;
  vante_nn_1_N = mkN "vante" utrum  ;
  varde_nn_1_N = mkN "varde" utrum  ;
  vargtimme_nn_1_N = mkN "vargtimme" utrum  ;
  vase_nn_1_N = mkN "vase" utrum  ;
  vassrugge_nn_1_N = mkN "vassrugge" utrum  ;
  vattendroppe_nn_1_N = mkN "vattendroppe" utrum  ;
  vattenskinnbagge_nn_1_N = mkN "vattenskinnbagge" utrum  ;
  vattenstraale_nn_1_1_N = mkN "vattenstråle" utrum  ;
  veckotimme_nn_1_N = mkN "veckotimme" utrum  ;
  vedbacke_nn_1_N = mkN "vedbacke" utrum  ;
  vedborre_nn_1_N = mkN "vedborre" utrum  ;
  vederlike_nn_1_N = mkN "vederlike" utrum  ;
  vedpinne_nn_1_N = mkN "vedpinne" utrum  ;
  vedtrave_nn_1_N = mkN "vedtrave" utrum  ;
  veke_nn_1_N = mkN "veke" utrum  ;
  vele_nn_1_N = mkN "vele" utrum  ;
  vetebulle_nn_1_N = mkN "vetebulle" utrum  ;
  vette_nn_1_N = mkN "vette" utrum  ;
  vevstake_nn_1_N = mkN "vevstake" utrum  ;
  vigge_nn_1_N = mkN "vigge" utrum  ;
  vilde_nn_1_N = mkN "vilde" utrum  ;
  vinbaersbuske_nn_1_1_N = mkN "vinbärsbuske" utrum  ;
  vinge_nn_1_N = mkN "vinge" utrum  ;
  vingelpelle_nn_1_N = mkN "vingelpelle" utrum  ;
  vise_nn_1_N = mkN "vise" utrum  ;
  vitsippsbacke_nn_1_N = mkN "vitsippsbacke" utrum  ;
  vaestgoete_nn_1_1_N = mkN "västgöte" utrum  ;
  vaette_nn_1_1_N = mkN "vätte" utrum  ;
  vaale_nn_1_1_N = mkN "våle" utrum  ;
  vaardkase_nn_1_1_N = mkN "vårdkase" utrum  ;
  vaatarve_nn_1_1_N = mkN "våtarve" utrum  ;
  wire_nn_1_N = mkN "wire" utrum  ;
  aende_nn_1_1_N = mkN "ände" utrum  ;
  aetpinne_nn_1_1_N = mkN "ätpinne" utrum  ;
  aakpaase_nn_1_1_N = mkN "åkpåse" utrum  ;
  aarpinne_nn_1_1_N = mkN "årpinne" utrum  ;
  aaterfoereningstanke_nn_1_1_N = mkN "återföreningstanke" utrum  ;
  oelgubbe_nn_1_1_N = mkN "ölgubbe" utrum  ;
  oestgoete_nn_1_1_N = mkN "östgöte" utrum  ;
  oeverkaeke_nn_1_1_N = mkN "överkäke" utrum  ;
  oeverste_nn_1_1_N = mkN "överste" utrum  ;
  oeversaate_nn_1_1_N = mkN "översåte" utrum  ;
  ABS_broms_nn_1_N = mkN "ABS-broms" ;
  EU_minister_nn_1_N = mkN "EU-minister" ;
  Higgspartikel_nn_1_N = mkN "Higgspartikel" ;
  Mercedes_nn_1_N = mkN "Mercedes" ;
  Rolls_nn_1_N = mkN "Rolls" ;
  Saab_nn_1_N = mkN "Saab" ;
  T_shirt_nn_1_N = mkN "T-shirt" ;
  TV_skaerm_nn_1_1_N = mkN "TV-skärm" ;
  VAB_dag_nn_1_N = mkN "VAB-dag" ;
  VAB_nn_1_N = mkN "VAB" ;
  VABB_dag_nn_1_N = mkN "VABB-dag" ;
  VABB_nn_1_N = mkN "VABB" ;
  Volkswagenbuss_nn_1_N = mkN "Volkswagenbuss" ;
  Z_partikel_nn_1_N = mkN "Z-partikel" ;
  _5_punktslaser_nn_1_N = mkN "5-punktslaser" ;
  abborrfisk_nn_1_N = mkN "abborrfisk" ;
  abbot_nn_1_N = mkN "abbot" ;
  absorber_nn_1_N = mkN "absorber" ;
  ackommodationsvaexel_nn_1_1_N = mkN "ackommodationsväxel" ;
  adapter_nn_1_N = mkN "adapter" ;
  adelskalender_nn_1_N = mkN "adelskalender" ;
  adelskrets_nn_1_N = mkN "adelskrets" ;
  adonis_nn_1_N = mkN "adonis" ;
  adoptivfoeraelder_nn_1_1_N = mkN "adoptivförälder" ;
  adrenalinkick_nn_1_N = mkN "adrenalinkick" ;
  adressbuss_nn_1_N = mkN "adressbuss" ;
  adresskalender_nn_1_N = mkN "adresskalender" ;
  adventskalender_nn_1_N = mkN "adventskalender" ;
  advokatstorm_nn_1_N = mkN "advokatstorm" ;
  akantus_nn_1_N = mkN "akantus" ;
  akilleshael_nn_1_1_N = mkN "akilleshäl" ;
  akter_nn_1_N = mkN "akter" ;
  akterspegel_nn_1_N = mkN "akterspegel" ;
  akvariefisk_nn_1_N = mkN "akvariefisk" ;
  al_nn_1_N = mkN "al" ;
  alfapartikel_nn_1_N = mkN "alfapartikel" ;
  alfaagel_nn_1_1_N = mkN "alfågel" ;
  alkekung_nn_1_N = mkN "alkekung" ;
  alkfaagel_nn_1_1_N = mkN "alkfågel" ;
  alkoholometer_nn_1_N = mkN "alkoholometer" ;
  allhelgonadag_nn_1_N = mkN "allhelgonadag" ;
  allvaedersstoevel_nn_1_1_N = mkN "allvädersstövel" ;
  alm_nn_1_N = mkN "alm" ;
  aln_nn_1_N = mkN "aln" ;
  alt_nn_1_N = mkN "alt" ;
  alternatvinkel_nn_1_N = mkN "alternatvinkel" ;
  alunskiffer_nn_1_N = mkN "alunskiffer" ;
  alvplog_nn_1_N = mkN "alvplog" ;
  ambulanshelikopter_nn_1_N = mkN "ambulanshelikopter" ;
  amfiteater_nn_1_N = mkN "amfiteater" ;
  amiralstitel_nn_1_N = mkN "amiralstitel" ;
  ampel_nn_1_N = mkN "ampel" ;
  amperemeter_nn_1_N = mkN "amperemeter" ;
  analsfinkter_nn_1_N = mkN "analsfinkter" ;
  andfaagel_nn_1_1_N = mkN "andfågel" ;
  andrabas_nn_1_N = mkN "andrabas" ;
  andrebas_nn_1_N = mkN "andrebas" ;
  anemometer_nn_1_N = mkN "anemometer" ;
  aneroidbarometer_nn_1_N = mkN "aneroidbarometer" ;
  anfallsvinkel_nn_1_N = mkN "anfallsvinkel" ;
  angel_nn_1_N = mkN "angel" ;
  angorajumper_nn_1_N = mkN "angorajumper" ;
  ankarboj_nn_1_N = mkN "ankarboj" ;
  ankarkabel_nn_1_N = mkN "ankarkabel" ;
  ankel_nn_1_N = mkN "ankel" ;
  ankomsthall_nn_1_N = mkN "ankomsthall" ;
  anloppshamn_nn_1_N = mkN "anloppshamn" ;
  annandag_nn_1_N = mkN "annandag" ;
  ansedel_nn_1_N = mkN "ansedel" ;
  ansjovis_nn_1_N = mkN "ansjovis" ;
  anslutningsbox_nn_1_N = mkN "anslutningsbox" ;
  anslutningskabel_nn_1_N = mkN "anslutningskabel" ;
  anslutningsserver_nn_1_N = mkN "anslutningsserver" ;
  antennkabel_nn_1_N = mkN "antennkabel" ;
  antennkoertel_nn_1_1_N = mkN "antennkörtel" ;
  antibarbarus_nn_1_N = mkN "antibarbarus" ;
  antiklimax_nn_1_N = mkN "antiklimax" ;
  antikropp_nn_1_N = mkN "antikropp" ;
  antikvitetshandel_nn_1_N = mkN "antikvitetshandel" ;
  antipartikel_nn_1_N = mkN "antipartikel" ;
  aortaklaff_nn_1_N = mkN "aortaklaff" ;
  apel_nn_1_N = mkN "apel" ;
  apostel_nn_1_N = mkN "apostel" ;
  app_nn_1_N = mkN "app" ;
  arbetshaest_nn_1_1_N = mkN "arbetshäst" ;
  arbetsmarknadsminister_nn_1_N = mkN "arbetsmarknadsminister" ;
  arbetsseger_nn_1_N = mkN "arbetsseger" ;
  arborr_nn_1_N = mkN "arborr" ;
  arenateater_nn_1_N = mkN "arenateater" ;
  areometer_nn_1_N = mkN "areometer" ;
  arm_nn_1_N = mkN "arm" ;
  armbindel_nn_1_N = mkN "armbindel" ;
  armcylinder_nn_1_N = mkN "armcylinder" ;
  armstump_nn_1_N = mkN "armstump" ;
  arm_ehelikopter_nn_1_1_N = mkN "arméhelikopter" ;
  arm_ehaest_nn_1_1_N = mkN "arméhäst" ;
  artikel_nn_1_N = mkN "artikel" ;
  arvprins_nn_1_N = mkN "arvprins" ;
  as_nn_2_N = mkN "as" ;
  asfaagel_nn_1_1_N = mkN "asfågel" ;
  ask_nn_1_N = mkN "ask" ;
  askkopp_nn_1_N = mkN "askkopp" ;
  askonsdag_nn_1_N = mkN "askonsdag" ;
  askpartikel_nn_1_N = mkN "askpartikel" ;
  asp_nn_1_N = mkN "asp" ;
  aster_nn_1_N = mkN "aster" ;
  astralkropp_nn_1_N = mkN "astralkropp" ;
  atomubaat_nn_1_1_N = mkN "atomubåt" ;
  atomvinter_nn_1_N = mkN "atomvinter" ;
  attackhelikopter_nn_1_N = mkN "attackhelikopter" ;
  audiometer_nn_1_N = mkN "audiometer" ;
  audit_nn_1_N = mkN "audit" ;
  augustisol_nn_1_N = mkN "augustisol" ;
  avelshingst_nn_1_N = mkN "avelshingst" ;
  avenbok_nn_1_N = mkN "avenbok" ;
  avgaangshall_nn_1_1_N = mkN "avgångshall" ;
  avskedskyss_nn_1_N = mkN "avskedskyss" ;
  axel_nn_1_N = mkN "axel" ;
  axeldiameter_nn_1_N = mkN "axeldiameter" ;
  axelklaff_nn_1_N = mkN "axelklaff" ;
  axelmuff_nn_1_N = mkN "axelmuff" ;
  back_nn_1_N = mkN "back" ;
  backfisch_nn_1_N = mkN "backfisch" ;
  backspegel_nn_1_N = mkN "backspegel" ;
  backvaexel_nn_1_1_N = mkN "backväxel" ;
  baddjaevel_nn_1_1_N = mkN "baddjävel" ;
  badhandduk_nn_1_N = mkN "badhandduk" ;
  badmintonracket_nn_1_N = mkN "badmintonracket" ;
  badrumsspegel_nn_1_N = mkN "badrumsspegel" ;
  bag_in_box_nn_1_N = mkN "bag-in-box" ;
  bag_nn_1_N = mkN "bag" ;
  bagarbod_nn_1_N = mkN "bagarbod" ;
  bagg_nn_1_N = mkN "bagg" ;
  bajonettspets_nn_1_N = mkN "bajonettspets" ;
  bak_nn_1_N = mkN "bak" ;
  bakaxel_nn_1_N = mkN "bakaxel" ;
  bakaxelvaexel_nn_1_1_N = mkN "bakaxelväxel" ;
  bakflygel_nn_1_N = mkN "bakflygel" ;
  bakgaard_nn_1_1_N = mkN "bakgård" ;
  bakkropp_nn_1_N = mkN "bakkropp" ;
  bakplaat_nn_1_1_N = mkN "bakplåt" ;
  baktass_nn_1_N = mkN "baktass" ;
  bakteriehaerd_nn_1_1_N = mkN "bakteriehärd" ;
  bakugn_nn_1_N = mkN "bakugn" ;
  bal_nn_1_N = mkN "bal" ;
  balansplog_nn_1_N = mkN "balansplog" ;
  balk_nn_1_N = mkN "balk" ;
  ballongprick_nn_1_N = mkN "ballongprick" ;
  ban_nn_1_N = mkN "ban" ;
  bandhund_nn_1_N = mkN "bandhund" ;
  bandstump_nn_1_N = mkN "bandstump" ;
  bandvimpel_nn_1_N = mkN "bandvimpel" ;
  bang_nn_1_N = mkN "bang" ;
  bangaard_nn_1_1_N = mkN "bangård" ;
  banhall_nn_1_N = mkN "banhall" ;
  bank_nn_1_N = mkN "bank" ;
  bankvaexel_nn_1_1_N = mkN "bankväxel" ;
  banvagn_nn_1_N = mkN "banvagn" ;
  bardisk_nn_1_N = mkN "bardisk" ;
  bardval_nn_1_N = mkN "bardval" ;
  barkbaat_nn_1_1_N = mkN "barkbåt" ;
  barkis_nn_1_N = mkN "barkis" ;
  barlastkoel_nn_1_1_N = mkN "barlastköl" ;
  barm_nn_1_N = mkN "barm" ;
  barncykel_nn_1_N = mkN "barncykel" ;
  barndomskompis_nn_1_N = mkN "barndomskompis" ;
  barnkropp_nn_1_N = mkN "barnkropp" ;
  barnsaeng_nn_1_1_N = mkN "barnsäng" ;
  barockstil_nn_1_N = mkN "barockstil" ;
  barometer_nn_1_N = mkN "barometer" ;
  bartender_nn_1_N = mkN "bartender" ;
  barvinter_nn_1_N = mkN "barvinter" ;
  bas_nn_1_N = mkN "bas" ;
  basker_nn_1_N = mkN "basker" ;
  bastardnaektergal_nn_1_1_N = mkN "bastardnäktergal" ;
  basvinkel_nn_1_N = mkN "basvinkel" ;
  batting_nn_1_N = mkN "batting" ;
  beatnik_nn_1_N = mkN "beatnik" ;
  bebis_nn_1_N = mkN "bebis" ;
  befaestningsgrav_nn_1_1_N = mkN "befästningsgrav" ;
  begravningskrans_nn_1_N = mkN "begravningskrans" ;
  bekantskapskrets_nn_1_N = mkN "bekantskapskrets" ;
  belaeggningsstaempel_nn_1_1_N = mkN "beläggningsstämpel" ;
  benfisk_nn_1_N = mkN "benfisk" ;
  benjaminfikus_nn_1_N = mkN "benjaminfikus" ;
  benmaergscancer_nn_1_1_N = mkN "benmärgscancer" ;
  bensinmack_nn_1_N = mkN "bensinmack" ;
  bensintank_nn_1_N = mkN "bensintank" ;
  benspets_nn_1_N = mkN "benspets" ;
  benstamp_nn_1_N = mkN "benstamp" ;
  bergakung_nn_1_N = mkN "bergakung" ;
  bergborr_nn_1_N = mkN "bergborr" ;
  bergfink_nn_1_N = mkN "bergfink" ;
  berghaell_nn_1_1_N = mkN "berghäll" ;
  bergis_nn_1_N = mkN "bergis" ;
  bergklack_nn_1_N = mkN "bergklack" ;
  bergrygg_nn_1_N = mkN "bergrygg" ;
  bergsrygg_nn_1_N = mkN "bergsrygg" ;
  bergstopp_nn_1_N = mkN "bergstopp" ;
  bergtall_nn_1_N = mkN "bergtall" ;
  bergtopp_nn_1_N = mkN "bergtopp" ;
  berguv_nn_1_N = mkN "berguv" ;
  bergvaegg_nn_1_1_N = mkN "bergvägg" ;
  bergaas_nn_1_1_N = mkN "bergås" ;
  berkis_nn_1_N = mkN "berkis" ;
  bermudarigg_nn_1_N = mkN "bermudarigg" ;
  bertel_nn_1_N = mkN "bertel" ;
  besk_nn_1_N = mkN "besk" ;
  bessemerugn_nn_1_N = mkN "bessemerugn" ;
  best_nn_1_N = mkN "best" ;
  bet_nn_1_N = mkN "bet" ;
  betalartikel_nn_1_N = mkN "betalartikel" ;
  betapartikel_nn_1_N = mkN "betapartikel" ;
  beting_nn_2_N = mkN "beting" ;
  betongbaedd_nn_1_1_N = mkN "betongbädd" ;
  bettel_nn_1_N = mkN "bettel" ;
  bibel_nn_1_N = mkN "bibel" ;
  bidrottning_nn_1_N = mkN "bidrottning" ;
  biff_nn_1_N = mkN "biff" ;
  bigaard_nn_1_1_N = mkN "bigård" ;
  bikloev_nn_1_1_N = mkN "biklöv" ;
  biktstol_nn_1_N = mkN "biktstol" ;
  bil_nn_1_N = mkN "bil" ;
  bilbroms_nn_1_N = mkN "bilbroms" ;
  bildskaerm_nn_1_1_N = mkN "bildskärm" ;
  biljardkaepp_nn_1_1_N = mkN "biljardkäpp" ;
  bilklaedsel_nn_1_1_N = mkN "bilklädsel" ;
  bill_nn_1_N = mkN "bill" ;
  billots_nn_1_N = mkN "billots" ;
  bilnyckel_nn_1_N = mkN "bilnyckel" ;
  bilplaat_nn_1_1_N = mkN "bilplåt" ;
  bilrock_nn_1_N = mkN "bilrock" ;
  biltunnel_nn_1_N = mkN "biltunnel" ;
  bindel_nn_1_N = mkN "bindel" ;
  bindenyckel_nn_1_N = mkN "bindenyckel" ;
  bindesaeck_nn_1_1_N = mkN "bindesäck" ;
  bindvaev_nn_1_1_N = mkN "bindväv" ;
  bindvaevskapsel_nn_1_1_N = mkN "bindvävskapsel" ;
  bingel_nn_1_N = mkN "bingel" ;
  binnikemask_nn_1_N = mkN "binnikemask" ;
  bioduk_nn_1_N = mkN "bioduk" ;
  biograforgel_nn_1_N = mkN "biograforgel" ;
  biografteater_nn_1_N = mkN "biografteater" ;
  biskop_nn_1_N = mkN "biskop" ;
  biskopsskrud_nn_1_N = mkN "biskopsskrud" ;
  biskopsstav_nn_1_N = mkN "biskopsstav" ;
  biskoeldkoertel_nn_1_1_N = mkN "bisköldkörtel" ;
  bisol_nn_1_N = mkN "bisol" ;
  bisp_nn_1_N = mkN "bisp" ;
  bistaandsminister_nn_1_1_N = mkN "biståndsminister" ;
  bisvaerm_nn_1_1_N = mkN "bisvärm" ;
  bit_nn_1_N = mkN "bit" ;
  bitestikel_nn_1_N = mkN "bitestikel" ;
  bittermandel_nn_1_N = mkN "bittermandel" ;
  bitvarg_nn_1_N = mkN "bitvarg" ;
  bivraak_nn_1_1_N = mkN "bivråk" ;
  bjoerk_nn_1_1_N = mkN "björk" ;
  bjoerknaever_nn_1_1_N = mkN "björknäver" ;
  bjoerksopp_nn_1_1_N = mkN "björksopp" ;
  bjoerktrast_nn_1_1_N = mkN "björktrast" ;
  bjoern_nn_1_1_N = mkN "björn" ;
  bjoernhund_nn_1_1_N = mkN "björnhund" ;
  bjoernsax_nn_1_1_N = mkN "björnsax" ;
  black_nn_1_N = mkN "black" ;
  bladkrans_nn_1_N = mkN "bladkrans" ;
  bladstekel_nn_1_N = mkN "bladstekel" ;
  blandningskran_nn_1_N = mkN "blandningskran" ;
  blandrashund_nn_1_N = mkN "blandrashund" ;
  blanklax_nn_1_N = mkN "blanklax" ;
  blankovaexel_nn_1_1_N = mkN "blankoväxel" ;
  blanksej_nn_1_N = mkN "blanksej" ;
  blankaal_nn_1_1_N = mkN "blankål" ;
  blazer_nn_1_N = mkN "blazer" ;
  bleckplaat_nn_1_1_N = mkN "bleckplåt" ;
  blekfis_nn_1_N = mkN "blekfis" ;
  bleking_nn_1_N = mkN "bleking" ;
  bleknos_nn_1_N = mkN "bleknos" ;
  blick_nn_1_N = mkN "blick" ;
  blidvinter_nn_1_N = mkN "blidvinter" ;
  blindbock_nn_1_N = mkN "blindbock" ;
  blindbroms_nn_1_N = mkN "blindbroms" ;
  blindhund_nn_1_N = mkN "blindhund" ;
  blindtarm_nn_1_N = mkN "blindtarm" ;
  blink_nn_2_N = mkN "blink" ;
  blinkfyr_nn_1_N = mkN "blinkfyr" ;
  blip_nn_1_N = mkN "blip" ;
  blipp_nn_1_N = mkN "blipp" ;
  blixt_nn_1_N = mkN "blixt" ;
  blixtfyr_nn_1_N = mkN "blixtfyr" ;
  blodbok_nn_1_N = mkN "blodbok" ;
  blodhund_nn_1_N = mkN "blodhund" ;
  blodigel_nn_1_N = mkN "blodigel" ;
  blodkropp_nn_1_N = mkN "blodkropp" ;
  blodpalt_nn_1_N = mkN "blodpalt" ;
  blodplaett_nn_1_1_N = mkN "blodplätt" ;
  blodpoel_nn_1_1_N = mkN "blodpöl" ;
  blogg_nn_1_N = mkN "blogg" ;
  blomaxel_nn_1_N = mkN "blomaxel" ;
  blomholk_nn_1_N = mkN "blomholk" ;
  blomkalk_nn_1_N = mkN "blomkalk" ;
  blomknopp_nn_1_N = mkN "blomknopp" ;
  blomkolv_nn_1_N = mkN "blomkolv" ;
  blomkorg_nn_1_N = mkN "blomkorg" ;
  blomkrans_nn_1_N = mkN "blomkrans" ;
  blomkvast_nn_1_N = mkN "blomkvast" ;
  blomkaepp_nn_1_1_N = mkN "blomkäpp" ;
  blomkaalssvamp_nn_1_1_N = mkN "blomkålssvamp" ;
  blomsterbaedd_nn_1_1_N = mkN "blomsterbädd" ;
  blomsterhandel_nn_1_N = mkN "blomsterhandel" ;
  blomsterkrans_nn_1_N = mkN "blomsterkrans" ;
  blomsterkvast_nn_1_N = mkN "blomsterkvast" ;
  blomstjaelk_nn_1_1_N = mkN "blomstjälk" ;
  bluff_nn_1_N = mkN "bluff" ;
  blunder_nn_1_N = mkN "blunder" ;
  blus_nn_1_N = mkN "blus" ;
  blydagg_nn_1_N = mkN "blydagg" ;
  blyerts_nn_1_N = mkN "blyerts" ;
  blykoel_nn_1_1_N = mkN "blyköl" ;
  blymantel_nn_1_N = mkN "blymantel" ;
  blaeckfisk_nn_1_1_N = mkN "bläckfisk" ;
  blaeckkoertel_nn_1_1_N = mkN "bläckkörtel" ;
  blaeckplump_nn_1_1_N = mkN "bläckplump" ;
  blaecksvamp_nn_1_1_N = mkN "bläcksvamp" ;
  blaecksaeck_nn_1_1_N = mkN "bläcksäck" ;
  blaeng_nn_1_1_N = mkN "bläng" ;
  blaenkfyr_nn_1_1_N = mkN "blänkfyr" ;
  blaes_nn_1_1_N = mkN "bläs" ;
  blaesbock_nn_1_1_N = mkN "bläsbock" ;
  blaester_nn_1_1_N = mkN "bläster" ;
  blaesterugn_nn_1_1_N = mkN "blästerugn" ;
  blaahaj_nn_1_1_N = mkN "blåhaj" ;
  blaaklint_nn_1_1_N = mkN "blåklint" ;
  blaames_nn_1_1_N = mkN "blåmes" ;
  blaaraev_nn_1_1_N = mkN "blåräv" ;
  blaasbaelg_nn_1_1_N = mkN "blåsbälg" ;
  blaashals_nn_1_1_N = mkN "blåshals" ;
  blaashalskoertel_nn_1_1_N = mkN "blåshalskörtel" ;
  blaasmask_nn_1_1_N = mkN "blåsmask" ;
  blaasorkester_nn_1_1_N = mkN "blåsorkester" ;
  blaaval_nn_1_1_N = mkN "blåval" ;
  blaavitling_nn_1_1_N = mkN "blåvitling" ;
  bob_nn_1_N = mkN "bob" ;
  bobb_nn_1_N = mkN "bobb" ;
  bock_nn_1_N = mkN "bock" ;
  bockvinkel_nn_1_N = mkN "bockvinkel" ;
  bod_nn_1_N = mkN "bod" ;
  bodknodd_nn_1_N = mkN "bodknodd" ;
  bofink_nn_1_N = mkN "bofink" ;
  bog_nn_1_N = mkN "bog" ;
  bogpropeller_nn_1_N = mkN "bogpropeller" ;
  bogsertross_nn_1_N = mkN "bogsertross" ;
  boj_nn_1_N = mkN "boj" ;
  bok_nn_2_N = mkN "bok" ;
  bokbuss_nn_1_N = mkN "bokbuss" ;
  bokcirkel_nn_1_N = mkN "bokcirkel" ;
  bokhandel_nn_1_N = mkN "bokhandel" ;
  bokmal_nn_1_N = mkN "bokmal" ;
  bokrygg_nn_1_N = mkN "bokrygg" ;
  bokstavsstans_nn_1_N = mkN "bokstavsstans" ;
  bokstavstrael_nn_1_1_N = mkN "bokstavsträl" ;
  boktitel_nn_1_N = mkN "boktitel" ;
  boktrycksstil_nn_1_N = mkN "boktrycksstil" ;
  boll_nn_1_N = mkN "boll" ;
  bolmoertsskivling_nn_1_1_N = mkN "bolmörtsskivling" ;
  bombkrater_nn_1_N = mkN "bombkrater" ;
  bomcylinder_nn_1_N = mkN "bomcylinder" ;
  bomsadel_nn_1_N = mkN "bomsadel" ;
  bomullsbal_nn_1_N = mkN "bomullsbal" ;
  bomullstuss_nn_1_N = mkN "bomullstuss" ;
  bonddraeng_nn_1_1_N = mkN "bonddräng" ;
  bondehaer_nn_1_1_N = mkN "bondehär" ;
  bong_nn_1_N = mkN "bong" ;
  bonus_nn_1_N = mkN "bonus" ;
  bordhyvel_nn_1_N = mkN "bordhyvel" ;
  bordsfilt_nn_1_N = mkN "bordsfilt" ;
  bordsspegel_nn_1_N = mkN "bordsspegel" ;
  bordtennisracket_nn_1_N = mkN "bordtennisracket" ;
  borg_nn_1_N = mkN "borg" ;
  borggaard_nn_1_1_N = mkN "borggård" ;
  borr_nn_1_N = mkN "borr" ;
  borrchuck_nn_1_N = mkN "borrchuck" ;
  borrdiameter_nn_1_N = mkN "borrdiameter" ;
  borrjigg_nn_1_N = mkN "borrjigg" ;
  borrspindel_nn_1_N = mkN "borrspindel" ;
  borstmask_nn_1_N = mkN "borstmask" ;
  borstsvans_nn_1_N = mkN "borstsvans" ;
  bortaseger_nn_1_N = mkN "bortaseger" ;
  bortbyting_nn_1_N = mkN "bortbyting" ;
  boskapshjord_nn_1_N = mkN "boskapshjord" ;
  boss_nn_1_N = mkN "boss" ;
  bot_nn_2_N = mkN "bot" ;
  botdag_nn_1_N = mkN "botdag" ;
  bottenkran_nn_1_N = mkN "bottenkran" ;
  bottenskvaett_nn_1_1_N = mkN "bottenskvätt" ;
  bov_nn_1_N = mkN "bov" ;
  boveteplaett_nn_1_1_N = mkN "boveteplätt" ;
  bowlinghall_nn_1_N = mkN "bowlinghall" ;
  box_nn_1_N = mkN "box" ;
  boxer_nn_1_N = mkN "boxer" ;
  boxervalp_nn_1_N = mkN "boxervalp" ;
  brallis_nn_1_N = mkN "brallis" ;
  brandartikel_nn_1_N = mkN "brandartikel" ;
  brandgavel_nn_1_N = mkN "brandgavel" ;
  brandgrav_nn_1_N = mkN "brandgrav" ;
  brandhaerd_nn_1_1_N = mkN "brandhärd" ;
  brandmur_nn_1_N = mkN "brandmur" ;
  brandsvamp_nn_1_N = mkN "brandsvamp" ;
  brasklapp_nn_1_N = mkN "brasklapp" ;
  brat_nn_1_N = mkN "brat" ;
  bredspackel_nn_1_N = mkN "bredspackel" ;
  brems_nn_1_N = mkN "brems" ;
  brevpress_nn_1_N = mkN "brevpress" ;
  brigg_nn_1_N = mkN "brigg" ;
  brikettpress_nn_1_N = mkN "brikettpress" ;
  brikollstoet_nn_1_1_N = mkN "brikollstöt" ;
  brink_nn_1_N = mkN "brink" ;
  brissling_nn_1_N = mkN "brissling" ;
  brits_nn_1_N = mkN "brits" ;
  brobaenk_nn_1_1_N = mkN "brobänk" ;
  brock_nn_1_N = mkN "brock" ;
  brockfaagel_nn_1_1_N = mkN "brockfågel" ;
  brodd_nn_1_N = mkN "brodd" ;
  brodersax_nn_1_N = mkN "brodersax" ;
  brok_nn_1_N = mkN "brok" ;
  brokspett_nn_1_N = mkN "brokspett" ;
  broms_nn_1_N = mkN "broms" ;
  bromsback_nn_1_N = mkN "bromsback" ;
  bromscylinder_nn_1_N = mkN "bromscylinder" ;
  bromsklaff_nn_1_N = mkN "bromsklaff" ;
  bromskloss_nn_1_N = mkN "bromskloss" ;
  bromsskaerm_nn_1_1_N = mkN "bromsskärm" ;
  bromsvagn_nn_1_N = mkN "bromsvagn" ;
  bropeng_nn_1_N = mkN "bropeng" ;
  bropenning_nn_1_N = mkN "bropenning" ;
  brorskaal_nn_1_1_N = mkN "brorskål" ;
  brorsskaal_nn_1_1_N = mkN "brorsskål" ;
  broskfisk_nn_1_N = mkN "broskfisk" ;
  broskskivling_nn_1_N = mkN "broskskivling" ;
  brosksvamp_nn_1_N = mkN "brosksvamp" ;
  brotsch_nn_1_N = mkN "brotsch" ;
  brottsling_nn_1_N = mkN "brottsling" ;
  browning_nn_1_N = mkN "browning" ;
  brud_nn_1_N = mkN "brud" ;
  brudnaebb_nn_1_1_N = mkN "brudnäbb" ;
  brudpall_nn_1_N = mkN "brudpall" ;
  brudpaell_nn_1_1_N = mkN "brudpäll" ;
  brudstol_nn_1_N = mkN "brudstol" ;
  brudsaeng_nn_1_1_N = mkN "brudsäng" ;
  bruksartikel_nn_1_N = mkN "bruksartikel" ;
  brukshund_nn_1_N = mkN "brukshund" ;
  brul_epudding_nn_1_1_N = mkN "brulépudding" ;
  brumbas_nn_1_N = mkN "brumbas" ;
  brunn_nn_1_N = mkN "brunn" ;
  brunnssvaengel_nn_1_1_N = mkN "brunnssvängel" ;
  brylling_nn_1_N = mkN "brylling" ;
  bryl_epudding_nn_1_1_N = mkN "brylépudding" ;
  brysselspets_nn_1_N = mkN "brysselspets" ;
  brytningsvinkel_nn_1_N = mkN "brytningsvinkel" ;
  braedd_nn_1_1_N = mkN "brädd" ;
  braedgaard_nn_1_1_N = mkN "brädgård" ;
  braennvinsbas_nn_1_1_N = mkN "brännvinsbas" ;
  braenslestav_nn_1_1_N = mkN "bränslestav" ;
  braensletank_nn_1_1_N = mkN "bränsletank" ;
  broeding_nn_1_1_N = mkN "bröding" ;
  broedkavel_nn_1_1_N = mkN "brödkavel" ;
  broedkorg_nn_1_1_N = mkN "brödkorg" ;
  broednagg_nn_1_1_N = mkN "brödnagg" ;
  broedpudding_nn_1_1_N = mkN "brödpudding" ;
  broedrost_nn_1_1_N = mkN "brödrost" ;
  broellopsbuss_nn_1_1_N = mkN "bröllopsbuss" ;
  broestcancer_nn_1_1_N = mkN "bröstcancer" ;
  broestkorg_nn_1_1_N = mkN "bröstkorg" ;
  broestkoertel_nn_1_1_N = mkN "bröstkörtel" ;
  broestlapp_nn_1_1_N = mkN "bröstlapp" ;
  broestmur_nn_1_1_N = mkN "bröstmur" ;
  broet_nn_1_1_N = mkN "bröt" ;
  broetling_nn_1_1_N = mkN "brötling" ;
  budkavel_nn_1_N = mkN "budkavel" ;
  buff_nn_1_N = mkN "buff" ;
  buffel_nn_1_N = mkN "buffel" ;
  buffelhjord_nn_1_N = mkN "buffelhjord" ;
  buffert_nn_1_N = mkN "buffert" ;
  bug_nn_1_N = mkN "bug" ;
  bugg_nn_2_N = mkN "bugg" ;
  buggfix_nn_1_N = mkN "buggfix" ;
  buk_nn_1_N = mkN "buk" ;
  bukgjord_nn_1_N = mkN "bukgjord" ;
  bukspottkoertel_nn_1_1_N = mkN "bukspottkörtel" ;
  buksvaager_nn_1_1_N = mkN "buksvåger" ;
  bukvaegg_nn_1_1_N = mkN "bukvägg" ;
  bulldogg_nn_1_N = mkN "bulldogg" ;
  bullerbas_nn_1_N = mkN "bullerbas" ;
  bult_nn_1_N = mkN "bult" ;
  bultsax_nn_1_N = mkN "bultsax" ;
  bumling_nn_1_N = mkN "bumling" ;
  bunt_nn_1_N = mkN "bunt" ;
  bur_nn_1_N = mkN "bur" ;
  burfaagel_nn_1_1_N = mkN "burfågel" ;
  burk_nn_1_N = mkN "burk" ;
  business_nn_1_N = mkN "business" ;
  buss_nn_1_N = mkN "buss" ;
  butikstjuv_nn_1_N = mkN "butikstjuv" ;
  buxbom_nn_1_N = mkN "buxbom" ;
  bygel_nn_1_N = mkN "bygel" ;
  bygelhaest_nn_1_1_N = mkN "bygelhäst" ;
  byggkloss_nn_1_N = mkN "byggkloss" ;
  byggmiss_nn_1_N = mkN "byggmiss" ;
  byggnadssockel_nn_1_N = mkN "byggnadssockel" ;
  byggtork_nn_1_N = mkN "byggtork" ;
  byk_nn_1_N = mkN "byk" ;
  byling_nn_1_N = mkN "byling" ;
  bystdrottning_nn_1_N = mkN "bystdrottning" ;
  byting_nn_1_N = mkN "byting" ;
  byx_nn_1_N = mkN "byx" ;
  byxbak_nn_1_N = mkN "byxbak" ;
  byxholk_nn_1_N = mkN "byxholk" ;
  baebis_nn_1_1_N = mkN "bäbis" ;
  baeck_nn_1_1_N = mkN "bäck" ;
  baeckahaest_nn_1_1_N = mkN "bäckahäst" ;
  baeckroeding_nn_1_1_N = mkN "bäckröding" ;
  baeckoering_nn_1_1_N = mkN "bäcköring" ;
  baedd_nn_1_1_N = mkN "bädd" ;
  baegarsvamp_nn_1_1_N = mkN "bägarsvamp" ;
  baelg_nn_1_1_N = mkN "bälg" ;
  baendsel_nn_1_1_N = mkN "bändsel" ;
  baengel_nn_1_1_N = mkN "bängel" ;
  baenk_nn_1_1_N = mkN "bänk" ;
  baenkspis_nn_1_1_N = mkN "bänkspis" ;
  baensel_nn_1_1_N = mkN "bänsel" ;
  baerfis_nn_1_1_N = mkN "bärfis" ;
  baersaerk_nn_1_1_N = mkN "bärsärk" ;
  baestis_nn_1_1_N = mkN "bästis" ;
  baever_nn_1_1_N = mkN "bäver" ;
  baagfil_nn_1_1_N = mkN "bågfil" ;
  baagskytt_nn_1_1_N = mkN "bågskytt" ;
  baak_nn_1_1_N = mkN "båk" ;
  baal_nn_1_1_N = mkN "bål" ;
  baalgeting_nn_1_1_N = mkN "bålgeting" ;
  baar_nn_1_1_N = mkN "bår" ;
  baat_nn_1_1_N = mkN "båt" ;
  baatsmansstol_nn_1_1_N = mkN "båtsmansstol" ;
  boeckling_nn_1_1_N = mkN "böckling" ;
  boedel_nn_1_1_N = mkN "bödel" ;
  boedelsdraeng_nn_1_1_N = mkN "bödelsdräng" ;
  boeg_nn_1_1_N = mkN "bög" ;
  boej_nn_1_1_N = mkN "böj" ;
  boendag_nn_1_1_N = mkN "böndag" ;
  boengrodd_nn_1_1_N = mkN "böngrodd" ;
  boenhas_nn_1_1_N = mkN "bönhas" ;
  boers_nn_1_1_N = mkN "börs" ;
  boerting_nn_1_1_N = mkN "börting" ;
  cab_nn_1_N = mkN "cab" ;
  cabb_nn_1_N = mkN "cabb" ;
  camping_nn_1_N = mkN "camping" ;
  cancer_nn_1_N = mkN "cancer" ;
  cappuccinokopp_nn_1_N = mkN "cappuccinokopp" ;
  ceder_nn_1_N = mkN "ceder" ;
  celsiustermometer_nn_1_N = mkN "celsiustermometer" ;
  census_nn_1_N = mkN "census" ;
  center_nn_1_N = mkN "center" ;
  centerback_nn_1_N = mkN "centerback" ;
  champagnesabel_nn_1_N = mkN "champagnesabel" ;
  champagnevisp_nn_1_N = mkN "champagnevisp" ;
  champinjonbaedd_nn_1_1_N = mkN "champinjonbädd" ;
  chat_nn_1_N = mkN "chat" ;
  chatt_nn_1_N = mkN "chatt" ;
  cheddarost_nn_1_N = mkN "cheddarost" ;
  chiffernyckel_nn_1_N = mkN "chiffernyckel" ;
  chokladbit_nn_1_N = mkN "chokladbit" ;
  chokladglass_nn_1_N = mkN "chokladglass" ;
  chokladpudding_nn_1_N = mkN "chokladpudding" ;
  chuck_nn_1_N = mkN "chuck" ;
  cigarettfimp_nn_1_N = mkN "cigarettfimp" ;
  cigarettroek_nn_1_1_N = mkN "cigarettrök" ;
  cigarrettfimp_nn_1_N = mkN "cigarrettfimp" ;
  cigarrettroek_nn_1_1_N = mkN "cigarrettrök" ;
  ciklidfisk_nn_1_N = mkN "ciklidfisk" ;
  ciliarkropp_nn_1_N = mkN "ciliarkropp" ;
  cirkel_nn_1_N = mkN "cirkel" ;
  cirkus_nn_1_N = mkN "cirkus" ;
  cissus_nn_1_N = mkN "cissus" ;
  citrus_nn_1_N = mkN "citrus" ;
  civilminister_nn_1_N = mkN "civilminister" ;
  clitoris_nn_1_N = mkN "clitoris" ;
  club_blazer_nn_1_N = mkN "club-blazer" ;
  cockpit_nn_1_N = mkN "cockpit" ;
  codex_nn_1_N = mkN "codex" ;
  contortatall_nn_1_N = mkN "contortatall" ;
  cosinus_nn_1_N = mkN "cosinus" ;
  crosschecking_nn_1_N = mkN "crosschecking" ;
  cumulus_nn_1_N = mkN "cumulus" ;
  curlingfoeraelder_nn_1_1_N = mkN "curlingförälder" ;
  cykel_nn_1_N = mkN "cykel" ;
  cykelergometer_nn_1_N = mkN "cykelergometer" ;
  cykelnyckel_nn_1_N = mkN "cykelnyckel" ;
  cykelsadel_nn_1_N = mkN "cykelsadel" ;
  cyklometer_nn_1_N = mkN "cyklometer" ;
  cylinder_nn_1_N = mkN "cylinder" ;
  cylinderpress_nn_1_N = mkN "cylinderpress" ;
  dadel_nn_1_N = mkN "dadel" ;
  dagakarl_nn_1_N = mkN "dagakarl" ;
  dager_nn_1_N = mkN "dager" ;
  dagg_nn_2_N = mkN "dagg" ;
  daggert_nn_1_N = mkN "daggert" ;
  daggmask_nn_1_N = mkN "daggmask" ;
  dagkarl_nn_1_N = mkN "dagkarl" ;
  dagpenning_nn_1_N = mkN "dagpenning" ;
  dagsedel_nn_1_N = mkN "dagsedel" ;
  dal_nn_1_N = mkN "dal" ;
  dalahaest_nn_1_1_N = mkN "dalahäst" ;
  dalkarl_nn_1_N = mkN "dalkarl" ;
  dalmas_nn_1_N = mkN "dalmas" ;
  damcykel_nn_1_N = mkN "damcykel" ;
  damhatt_nn_1_N = mkN "damhatt" ;
  damm_nn_1_N = mkN "damm" ;
  dank_nn_1_N = mkN "dank" ;
  dansk_nn_1_N = mkN "dansk" ;
  danslek_nn_1_N = mkN "danslek" ;
  dansorkester_nn_1_N = mkN "dansorkester" ;
  darraal_nn_1_1_N = mkN "darrål" ;
  darwinfink_nn_1_N = mkN "darwinfink" ;
  dataskaerm_nn_1_1_N = mkN "dataskärm" ;
  datorvaexel_nn_1_1_N = mkN "datorväxel" ;
  datumstaempel_nn_1_1_N = mkN "datumstämpel" ;
  debattartikel_nn_1_N = mkN "debattartikel" ;
  debetsedel_nn_1_N = mkN "debetsedel" ;
  decemberkvaell_nn_1_1_N = mkN "decemberkväll" ;
  deg_nn_1_N = mkN "deg" ;
  degel_nn_1_N = mkN "degel" ;
  deklinationsnaal_nn_1_1_N = mkN "deklinationsnål" ;
  densitometer_nn_1_N = mkN "densitometer" ;
  densometer_nn_1_N = mkN "densometer" ;
  dessertgaffel_nn_1_N = mkN "dessertgaffel" ;
  dessertost_nn_1_N = mkN "dessertost" ;
  diamanttjuv_nn_1_N = mkN "diamanttjuv" ;
  diameter_nn_1_N = mkN "diameter" ;
  diesel_nn_1_N = mkN "diesel" ;
  differentialspaerr_nn_1_1_N = mkN "differentialspärr" ;
  differentialvaexel_nn_1_1_N = mkN "differentialväxel" ;
  digel_nn_1_N = mkN "digel" ;
  digelpress_nn_1_N = mkN "digelpress" ;
  digitalbox_nn_1_N = mkN "digitalbox" ;
  dilatationsfog_nn_1_N = mkN "dilatationsfog" ;
  dillkvist_nn_1_N = mkN "dillkvist" ;
  dimbank_nn_1_N = mkN "dimbank" ;
  diopter_nn_1_N = mkN "diopter" ;
  dip_nn_1_N = mkN "dip" ;
  diplomatkrets_nn_1_N = mkN "diplomatkrets" ;
  dipp_nn_1_N = mkN "dipp" ;
  direktvaexel_nn_1_1_N = mkN "direktväxel" ;
  dirk_nn_1_N = mkN "dirk" ;
  discipel_nn_1_N = mkN "discipel" ;
  disk_nn_1_N = mkN "disk" ;
  diskbaenk_nn_1_1_N = mkN "diskbänk" ;
  diskus_nn_1_N = mkN "diskus" ;
  distansbygel_nn_1_N = mkN "distansbygel" ;
  diversehandel_nn_1_N = mkN "diversehandel" ;
  djuphavsfisk_nn_1_N = mkN "djuphavsfisk" ;
  djuping_nn_1_N = mkN "djuping" ;
  djupmask_nn_1_N = mkN "djupmask" ;
  djurgaard_nn_1_1_N = mkN "djurgård" ;
  djurhud_nn_1_N = mkN "djurhud" ;
  djurkropp_nn_1_N = mkN "djurkropp" ;
  djurparksvarg_nn_1_N = mkN "djurparksvarg" ;
  djurtarm_nn_1_N = mkN "djurtarm" ;
  djaevel_nn_1_1_N = mkN "djävel" ;
  dockteater_nn_1_N = mkN "dockteater" ;
  dodekaeder_nn_1_N = mkN "dodekaeder" ;
  dogg_nn_1_N = mkN "dogg" ;
  dokusaapakaendis_nn_1_1_N = mkN "dokusåpakändis" ;
  doldis_nn_1_N = mkN "doldis" ;
  dolk_nn_1_N = mkN "dolk" ;
  dollarsedel_nn_1_N = mkN "dollarsedel" ;
  dom_nn_1_N = mkN "dom" ;
  dominikansyster_nn_1_N = mkN "dominikansyster" ;
  domkrets_nn_1_N = mkN "domkrets" ;
  domprost_nn_1_N = mkN "domprost" ;
  domssoendag_nn_1_1_N = mkN "domssöndag" ;
  domstol_nn_1_N = mkN "domstol" ;
  domsoendag_nn_1_1_N = mkN "domsöndag" ;
  doning_nn_1_N = mkN "doning" ;
  dopfunt_nn_1_N = mkN "dopfunt" ;
  dopping_nn_1_N = mkN "dopping" ;
  dopskaal_nn_1_1_N = mkN "dopskål" ;
  dorn_nn_1_N = mkN "dorn" ;
  dosbarometer_nn_1_N = mkN "dosbarometer" ;
  dosimeter_nn_1_N = mkN "dosimeter" ;
  dovhjort_nn_1_N = mkN "dovhjort" ;
  dragbil_nn_1_N = mkN "dragbil" ;
  dragbaenk_nn_1_1_N = mkN "dragbänk" ;
  dragg_nn_1_N = mkN "dragg" ;
  draghaest_nn_1_1_N = mkN "draghäst" ;
  dragnagel_nn_1_N = mkN "dragnagel" ;
  dragpress_nn_1_N = mkN "dragpress" ;
  drakhuvudfisk_nn_1_N = mkN "drakhuvudfisk" ;
  drakstjaert_nn_1_1_N = mkN "drakstjärt" ;
  dressing_nn_1_N = mkN "dressing" ;
  drever_nn_1_N = mkN "drever" ;
  drevhund_nn_1_N = mkN "drevhund" ;
  drevkarl_nn_1_N = mkN "drevkarl" ;
  drickspeng_nn_1_N = mkN "drickspeng" ;
  drill_nn_1_N = mkN "drill" ;
  drillborr_nn_1_N = mkN "drillborr" ;
  drilling_nn_1_N = mkN "drilling" ;
  drillstav_nn_1_N = mkN "drillstav" ;
  drink_nn_1_N = mkN "drink" ;
  drittel_nn_1_N = mkN "drittel" ;
  driv_nn_1_N = mkN "driv" ;
  drivaxel_nn_1_N = mkN "drivaxel" ;
  drivbaenk_nn_1_1_N = mkN "drivbänk" ;
  drivfjaeder_nn_1_1_N = mkN "drivfjäder" ;
  droghandel_nn_1_N = mkN "droghandel" ;
  droppspets_nn_1_N = mkN "droppspets" ;
  drossel_nn_1_N = mkN "drossel" ;
  drots_nn_1_N = mkN "drots" ;
  drott_nn_1_N = mkN "drott" ;
  drottning_nn_1_N = mkN "drottning" ;
  drufs_nn_1_N = mkN "drufs" ;
  drul_nn_1_N = mkN "drul" ;
  drullputt_nn_1_N = mkN "drullputt" ;
  druvflaeder_nn_1_1_N = mkN "druvfläder" ;
  draeng_nn_1_1_N = mkN "dräng" ;
  draett_nn_1_1_N = mkN "drätt" ;
  droeg_nn_1_1_N = mkN "drög" ;
  droeglapp_nn_1_1_N = mkN "dröglapp" ;
  droemdejt_nn_1_1_N = mkN "drömdejt" ;
  dubb_nn_1_N = mkN "dubb" ;
  dubbel_nn_1_N = mkN "dubbel" ;
  dubbelbiff_nn_1_N = mkN "dubbelbiff" ;
  dubbelsaeng_nn_1_1_N = mkN "dubbelsäng" ;
  dubbeltrast_nn_1_N = mkN "dubbeltrast" ;
  duffel_nn_1_N = mkN "duffel" ;
  duk_nn_1_N = mkN "duk" ;
  dummerjoens_nn_1_1_N = mkN "dummerjöns" ;
  dumming_nn_1_N = mkN "dumming" ;
  dumsnut_nn_1_N = mkN "dumsnut" ;
  dumstrut_nn_1_N = mkN "dumstrut" ;
  dunk_nn_1_N = mkN "dunk" ;
  duns_nn_1_N = mkN "duns" ;
  durk_nn_1_N = mkN "durk" ;
  dusch_nn_1_N = mkN "dusch" ;
  duschhandduk_nn_1_N = mkN "duschhandduk" ;
  duskaal_nn_1_1_N = mkN "duskål" ;
  duvfaagel_nn_1_1_N = mkN "duvfågel" ;
  duvhoek_nn_1_1_N = mkN "duvhök" ;
  duvjaevel_nn_1_1_N = mkN "duvjävel" ;
  dvaerg_nn_1_1_N = mkN "dvärg" ;
  dvaergbjoerk_nn_1_1_N = mkN "dvärgbjörk" ;
  dvaerghamster_nn_1_1_N = mkN "dvärghamster" ;
  dvaerghund_nn_1_1_N = mkN "dvärghund" ;
  dvaergmaas_nn_1_1_N = mkN "dvärgmås" ;
  dvaergtall_nn_1_1_N = mkN "dvärgtall" ;
  dyckert_nn_1_N = mkN "dyckert" ;
  dymling_nn_1_N = mkN "dymling" ;
  dymmelonsdag_nn_1_N = mkN "dymmelonsdag" ;
  dynamometer_nn_1_N = mkN "dynamometer" ;
  dyrgrip_nn_1_N = mkN "dyrgrip" ;
  dyrk_nn_1_N = mkN "dyrk" ;
  dysterkvist_nn_1_N = mkN "dysterkvist" ;
  dyvik_nn_1_N = mkN "dyvik" ;
  daeckel_nn_1_1_N = mkN "däckel" ;
  daempbox_nn_1_1_N = mkN "dämpbox" ;
  daevert_nn_1_1_N = mkN "dävert" ;
  daexel_nn_1_1_N = mkN "däxel" ;
  daarfink_nn_1_1_N = mkN "dårfink" ;
  doeding_nn_1_1_N = mkN "döding" ;
  doedsbaedd_nn_1_1_N = mkN "dödsbädd" ;
  doedsstoet_nn_1_1_N = mkN "dödsstöt" ;
  doedsaengel_nn_1_1_N = mkN "dödsängel" ;
  doegling_nn_1_1_N = mkN "dögling" ;
  doeing_nn_1_1_N = mkN "döing" ;
  doerj_nn_1_1_N = mkN "dörj" ;
  doerr_nn_1_1_N = mkN "dörr" ;
  doerrkarm_nn_1_1_N = mkN "dörrkarm" ;
  doerrkrans_nn_1_1_N = mkN "dörrkrans" ;
  doerrspegel_nn_1_1_N = mkN "dörrspegel" ;
  does_nn_1_1_N = mkN "dös" ;
  ebonitstav_nn_1_N = mkN "ebonitstav" ;
  ecklesiastikminister_nn_1_N = mkN "ecklesiastikminister" ;
  edamerost_nn_1_N = mkN "edamerost" ;
  efterhoest_nn_1_1_N = mkN "efterhöst" ;
  eftermiddagslur_nn_1_N = mkN "eftermiddagslur" ;
  eftersits_nn_1_N = mkN "eftersits" ;
  efterslaeng_nn_1_1_N = mkN "eftersläng" ;
  eftervinter_nn_1_N = mkN "eftervinter" ;
  egg_nn_1_N = mkN "egg" ;
  ejder_nn_1_N = mkN "ejder" ;
  ek_nn_1_N = mkN "ek" ;
  ekbock_nn_1_N = mkN "ekbock" ;
  eker_nn_1_N = mkN "eker" ;
  elaking_nn_1_N = mkN "elaking" ;
  eld_nn_2_N = mkN "eld" ;
  eldgaffel_nn_1_N = mkN "eldgaffel" ;
  eldhund_nn_1_N = mkN "eldhund" ;
  eldhaerd_nn_1_1_N = mkN "eldhärd" ;
  eldkvast_nn_1_N = mkN "eldkvast" ;
  eldsalamander_nn_1_N = mkN "eldsalamander" ;
  eldsjael_nn_1_1_N = mkN "eldsjäl" ;
  eldskur_nn_1_N = mkN "eldskur" ;
  eldstorm_nn_1_N = mkN "eldstorm" ;
  elektrikermejsel_nn_1_N = mkN "elektrikermejsel" ;
  elektrometer_nn_1_N = mkN "elektrometer" ;
  elektronblixt_nn_1_N = mkN "elektronblixt" ;
  elektronikmejsel_nn_1_N = mkN "elektronikmejsel" ;
  elektronugn_nn_1_N = mkN "elektronugn" ;
  elementarpartikel_nn_1_N = mkN "elementarpartikel" ;
  elementpensel_nn_1_N = mkN "elementpensel" ;
  elhyvel_nn_1_N = mkN "elhyvel" ;
  elkabel_nn_1_N = mkN "elkabel" ;
  elorgel_nn_1_N = mkN "elorgel" ;
  elpropp_nn_1_N = mkN "elpropp" ;
  elspis_nn_1_N = mkN "elspis" ;
  elvisp_nn_1_N = mkN "elvisp" ;
  embryosaeck_nn_1_1_N = mkN "embryosäck" ;
  emitter_nn_1_N = mkN "emitter" ;
  engaangsartikel_nn_1_1_N = mkN "engångsartikel" ;
  engaangshandduk_nn_1_1_N = mkN "engångshandduk" ;
  engaangsnaesduk_nn_1_1_N = mkN "engångsnäsduk" ;
  enhetscirkel_nn_1_N = mkN "enhetscirkel" ;
  enkelbiff_nn_1_N = mkN "enkelbiff" ;
  enkelsaeng_nn_1_1_N = mkN "enkelsäng" ;
  enmanslivbaat_nn_1_1_N = mkN "enmanslivbåt" ;
  enmansvalkrets_nn_1_N = mkN "enmansvalkrets" ;
  ensamfoeraelder_nn_1_1_N = mkN "ensamförälder" ;
  ensfyr_nn_1_N = mkN "ensfyr" ;
  ensling_nn_1_N = mkN "ensling" ;
  enstoering_nn_1_1_N = mkN "enstöring" ;
  entumsspik_nn_1_N = mkN "entumsspik" ;
  entypsbaat_nn_1_1_N = mkN "entypsbåt" ;
  enaeggstvilling_nn_1_1_N = mkN "enäggstvilling" ;
  epistel_nn_1_N = mkN "epistel" ;
  ergometer_nn_1_N = mkN "ergometer" ;
  ersaettningsbuss_nn_1_1_N = mkN "ersättningsbuss" ;
  eskader_nn_1_N = mkN "eskader" ;
  eskimaahund_nn_1_1_N = mkN "eskimåhund" ;
  ester_nn_1_N = mkN "ester" ;
  eter_nn_1_N = mkN "eter" ;
  evighetskalender_nn_1_N = mkN "evighetskalender" ;
  excenter_nn_1_N = mkN "excenter" ;
  exoftalmometer_nn_1_N = mkN "exoftalmometer" ;
  expertkrets_nn_1_N = mkN "expertkrets" ;
  explosionshaerd_nn_1_1_N = mkN "explosionshärd" ;
  exportartikel_nn_1_N = mkN "exportartikel" ;
  extrafilt_nn_1_N = mkN "extrafilt" ;
  extrasol_nn_1_N = mkN "extrasol" ;
  fackminister_nn_1_N = mkN "fackminister" ;
  fadder_nn_1_N = mkN "fadder" ;
  faktafolder_nn_1_N = mkN "faktafolder" ;
  falk_nn_1_N = mkN "falk" ;
  fallgrop_nn_1_N = mkN "fallgrop" ;
  fallos_nn_1_N = mkN "fallos" ;
  fallseger_nn_1_N = mkN "fallseger" ;
  fals_nn_1_N = mkN "fals" ;
  familjekrets_nn_1_N = mkN "familjekrets" ;
  famn_nn_1_N = mkN "famn" ;
  fanborg_nn_1_N = mkN "fanborg" ;
  farfoeraelder_nn_1_1_N = mkN "farförälder" ;
  fargalt_nn_1_N = mkN "fargalt" ;
  farlighetsstaempel_nn_1_1_N = mkN "farlighetsstämpel" ;
  fartygsorkester_nn_1_N = mkN "fartygsorkester" ;
  fasadpensel_nn_1_N = mkN "fasadpensel" ;
  faskikel_nn_1_N = mkN "faskikel" ;
  faster_nn_1_N = mkN "faster" ;
  fastlagssoendag_nn_1_1_N = mkN "fastlagssöndag" ;
  fataliedag_nn_1_N = mkN "fataliedag" ;
  fattiglapp_nn_1_N = mkN "fattiglapp" ;
  fax_nn_1_N = mkN "fax" ;
  feber_nn_1_N = mkN "feber" ;
  febertermometer_nn_1_N = mkN "febertermometer" ;
  febertopp_nn_1_N = mkN "febertopp" ;
  fegis_nn_1_N = mkN "fegis" ;
  felraekningspeng_nn_1_1_N = mkN "felräkningspeng" ;
  femhundrakronorssedel_nn_1_N = mkN "femhundrakronorssedel" ;
  femling_nn_1_N = mkN "femling" ;
  fempunktslaser_nn_1_N = mkN "fempunktslaser" ;
  femtidollarsedel_nn_1_N = mkN "femtidollarsedel" ;
  femtikronorssedel_nn_1_N = mkN "femtikronorssedel" ;
  femtilapp_nn_1_N = mkN "femtilapp" ;
  femtiodollarsedel_nn_1_N = mkN "femtiodollarsedel" ;
  femtiokronorssedel_nn_1_N = mkN "femtiokronorssedel" ;
  femtioaarsdag_nn_1_1_N = mkN "femtioårsdag" ;
  femtiaarsdag_nn_1_1_N = mkN "femtiårsdag" ;
  femtumsspik_nn_1_N = mkN "femtumsspik" ;
  fender_nn_1_N = mkN "fender" ;
  fendert_nn_1_N = mkN "fendert" ;
  fenkoel_nn_1_1_N = mkN "fenköl" ;
  fenval_nn_1_N = mkN "fenval" ;
  festkompis_nn_1_N = mkN "festkompis" ;
  festkvaell_nn_1_1_N = mkN "festkväll" ;
  festutstyrsel_nn_1_N = mkN "festutstyrsel" ;
  fetknopp_nn_1_N = mkN "fetknopp" ;
  fetsill_nn_1_N = mkN "fetsill" ;
  fetstil_nn_1_N = mkN "fetstil" ;
  fettisdag_nn_1_N = mkN "fettisdag" ;
  fettkoertel_nn_1_1_N = mkN "fettkörtel" ;
  fettlever_nn_1_N = mkN "fettlever" ;
  fettvalk_nn_1_N = mkN "fettvalk" ;
  fiberspik_nn_1_N = mkN "fiberspik" ;
  fickpeng_nn_1_N = mkN "fickpeng" ;
  fickspegel_nn_1_N = mkN "fickspegel" ;
  ficktjuv_nn_1_N = mkN "ficktjuv" ;
  fidus_nn_1_N = mkN "fidus" ;
  fikus_nn_1_N = mkN "fikus" ;
  fil_nn_2_N = mkN "fil" ;
  filibuster_nn_1_N = mkN "filibuster" ;
  filister_nn_1_N = mkN "filister" ;
  filt_nn_1_N = mkN "filt" ;
  filtspets_nn_1_N = mkN "filtspets" ;
  fimbulvinter_nn_1_N = mkN "fimbulvinter" ;
  fimp_nn_1_N = mkN "fimp" ;
  finalmiss_nn_1_N = mkN "finalmiss" ;
  finansminister_nn_1_N = mkN "finansminister" ;
  finansvalp_nn_1_N = mkN "finansvalp" ;
  finger_nn_1_N = mkN "finger" "fingret" "fingrar" "fingrarna" neutrum ;
  fingerborg_nn_1_N = mkN "fingerborg" ;
  fingerhud_nn_1_N = mkN "fingerhud" ;
  fingernagel_nn_1_N = mkN "fingernagel" ;
  fingersvamp_nn_1_N = mkN "fingersvamp" ;
  fingertopp_nn_1_N = mkN "fingertopp" ;
  finish_nn_1_N = mkN "finish" ;
  fink_nn_1_N = mkN "fink" ;
  finkfaagel_nn_1_1_N = mkN "finkfågel" ;
  finlandssvensk_nn_1_N = mkN "finlandssvensk" ;
  fis_nn_1_N = mkN "fis" ;
  fisk_nn_1_N = mkN "fisk" ;
  fiskebank_nn_1_N = mkN "fiskebank" ;
  fiskhamn_nn_1_N = mkN "fiskhamn" ;
  fiskmaas_nn_1_1_N = mkN "fiskmås" ;
  fisknot_nn_1_N = mkN "fisknot" ;
  fiskpudding_nn_1_N = mkN "fiskpudding" ;
  fisksump_nn_1_N = mkN "fisksump" ;
  fistel_nn_1_N = mkN "fistel" ;
  fix_nn_1_N = mkN "fix" ;
  fjant_nn_1_N = mkN "fjant" ;
  fjord_nn_1_N = mkN "fjord" ;
  fjordhaest_nn_1_1_N = mkN "fjordhäst" ;
  fjording_nn_1_N = mkN "fjording" ;
  fjaeder_nn_1_1_N = mkN "fjäder" ;
  fjaederpensel_nn_1_1_N = mkN "fjäderpensel" ;
  fjaederskrud_nn_1_1_N = mkN "fjäderskrud" ;
  fjaellbjoerk_nn_1_1_N = mkN "fjällbjörk" ;
  fjaellbrud_nn_1_1_N = mkN "fjällbrud" ;
  fjaellbaeck_nn_1_1_N = mkN "fjällbäck" ;
  fjaellraev_nn_1_1_N = mkN "fjällräv" ;
  fjaellsemester_nn_1_1_N = mkN "fjällsemester" ;
  fjaellskivling_nn_1_1_N = mkN "fjällskivling" ;
  fjaellvraak_nn_1_1_N = mkN "fjällvråk" ;
  fjaellvaerld_nn_1_1_N = mkN "fjällvärld" ;
  fjaerd_nn_1_1_N = mkN "fjärd" ;
  fjaerr_nn_1_1_N = mkN "fjärr" ;
  fjaerris_nn_1_1_N = mkN "fjärris" ;
  fjaersing_nn_1_1_N = mkN "fjärsing" ;
  fjaert_nn_1_1_N = mkN "fjärt" ;
  fjaesker_nn_1_1_N = mkN "fjäsker" ;
  fjoel_nn_1_1_N = mkN "fjöl" ;
  flabb_nn_1_N = mkN "flabb" ;
  flamugn_nn_1_N = mkN "flamugn" ;
  flark_nn_1_N = mkN "flark" ;
  flaskhals_nn_1_N = mkN "flaskhals" ;
  flaskkurbits_nn_1_N = mkN "flaskkurbits" ;
  flatfisk_nn_1_N = mkN "flatfisk" ;
  flax_nn_1_N = mkN "flax" ;
  flermansvalkrets_nn_1_N = mkN "flermansvalkrets" ;
  fles_nn_1_N = mkN "fles" ;
  flickkalv_nn_1_N = mkN "flickkalv" ;
  flik_nn_1_N = mkN "flik" ;
  flock_nn_1_N = mkN "flock" ;
  flodarm_nn_1_N = mkN "flodarm" ;
  flodbraedd_nn_1_1_N = mkN "flodbrädd" ;
  flodbaedd_nn_1_1_N = mkN "flodbädd" ;
  floddal_nn_1_N = mkN "floddal" ;
  flodhaest_nn_1_1_N = mkN "flodhäst" ;
  flodiller_nn_1_N = mkN "flodiller" ;
  flodkroek_nn_1_1_N = mkN "flodkrök" ;
  flogroenn_nn_1_1_N = mkN "flogrönn" ;
  flop_nn_1_N = mkN "flop" ;
  flopp_nn_1_N = mkN "flopp" ;
  flox_nn_1_N = mkN "flox" ;
  flukt_nn_1_N = mkN "flukt" ;
  flygbaat_nn_1_1_N = mkN "flygbåt" ;
  flygel_nn_1_N = mkN "flygel" ;
  flygfisk_nn_1_N = mkN "flygfisk" ;
  flyghund_nn_1_N = mkN "flyghund" ;
  flygkropp_nn_1_N = mkN "flygkropp" ;
  flygroenn_nn_1_1_N = mkN "flygrönn" ;
  flykting_nn_1_N = mkN "flykting" ;
  flytt_nn_1_N = mkN "flytt" ;
  flyttfaagel_nn_1_1_N = mkN "flyttfågel" ;
  flyttgroet_nn_1_1_N = mkN "flyttgröt" ;
  flyttkarl_nn_1_N = mkN "flyttkarl" ;
  flytvaest_nn_1_1_N = mkN "flytväst" ;
  flaeck_nn_1_1_N = mkN "fläck" ;
  flaeder_nn_1_1_N = mkN "fläder" ;
  flaekt_nn_1_1_N = mkN "fläkt" ;
  flaens_nn_1_1_N = mkN "fläns" ;
  flaerp_nn_1_1_N = mkN "flärp" ;
  flaesktaerning_nn_1_1_N = mkN "fläsktärning" ;
  flaeskaenger_nn_1_1_N = mkN "fläskänger" ;
  floej_nn_1_1_N = mkN "flöj" ;
  floejel_nn_1_1_N = mkN "flöjel" ;
  fnasker_nn_1_N = mkN "fnasker" ;
  fnoesksvamp_nn_1_1_N = mkN "fnösksvamp" ;
  fock_nn_1_N = mkN "fock" ;
  fodervaerd_nn_1_1_N = mkN "fodervärd" ;
  fog_nn_1_N = mkN "fog" ;
  fogsvans_nn_1_N = mkN "fogsvans" ;
  folder_nn_1_N = mkN "folder" ;
  folkbaat_nn_1_1_N = mkN "folkbåt" ;
  folkis_nn_1_N = mkN "folkis" ;
  folkparksorkester_nn_1_N = mkN "folkparksorkester" ;
  folkstorm_nn_1_N = mkN "folkstorm" ;
  follikel_nn_1_N = mkN "follikel" ;
  fondstaempel_nn_1_1_N = mkN "fondstämpel" ;
  form_nn_1_N = mkN "form" ;
  formelbil_nn_1_N = mkN "formelbil" ;
  fornborg_nn_1_N = mkN "fornborg" ;
  fors_nn_1_N = mkN "fors" ;
  fortel_nn_1_N = mkN "fortel" ;
  fossing_nn_1_N = mkN "fossing" ;
  fosterfoeraelder_nn_1_1_N = mkN "fosterförälder" ;
  fostersyster_nn_1_N = mkN "fostersyster" ;
  fotbroms_nn_1_N = mkN "fotbroms" ;
  fotknoel_nn_1_1_N = mkN "fotknöl" ;
  fotoblixt_nn_1_N = mkN "fotoblixt" ;
  fotografiplaat_nn_1_1_N = mkN "fotografiplåt" ;
  fotometer_nn_1_N = mkN "fotometer" ;
  fotsack_nn_1_N = mkN "fotsack" ;
  frack_nn_1_N = mkN "frack" ;
  fraktsedel_nn_1_N = mkN "fraktsedel" ;
  framaxel_nn_1_N = mkN "framaxel" ;
  framgaffel_nn_1_N = mkN "framgaffel" ;
  framstoet_nn_1_1_N = mkN "framstöt" ;
  framtass_nn_1_N = mkN "framtass" ;
  framvagn_nn_1_N = mkN "framvagn" ;
  frankostaempel_nn_1_1_N = mkN "frankostämpel" ;
  frans_nn_1_N = mkN "frans" ;
  freak_nn_1_N = mkN "freak" ;
  fredageftermiddag_nn_1_N = mkN "fredageftermiddag" ;
  fredagkvaell_nn_1_1_N = mkN "fredagkväll" ;
  fredagseftermiddag_nn_1_N = mkN "fredagseftermiddag" ;
  fredagskvaell_nn_1_1_N = mkN "fredagskväll" ;
  fredsaengel_nn_1_1_N = mkN "fredsängel" ;
  fregattfaagel_nn_1_1_N = mkN "fregattfågel" ;
  friggebod_nn_1_N = mkN "friggebod" ;
  frihamn_nn_1_N = mkN "frihamn" ;
  frihetsapostel_nn_1_N = mkN "frihetsapostel" ;
  frikrets_nn_1_N = mkN "frikrets" ;
  frilans_nn_1_N = mkN "frilans" ;
  friluftsdag_nn_1_N = mkN "friluftsdag" ;
  frimickel_nn_1_N = mkN "frimickel" ;
  friplaat_nn_1_1_N = mkN "friplåt" ;
  frisedel_nn_1_N = mkN "frisedel" ;
  friskus_nn_1_N = mkN "friskus" ;
  fritidsgaard_nn_1_1_N = mkN "fritidsgård" ;
  frott_ehandduk_nn_1_1_N = mkN "frottéhandduk" ;
  frukost_nn_1_N = mkN "frukost" ;
  frukostmiddag_nn_1_N = mkN "frukostmiddag" ;
  fruktvaegg_nn_1_1_N = mkN "fruktvägg" ;
  fruntimmerskarl_nn_1_N = mkN "fruntimmerskarl" ;
  frys_nn_1_N = mkN "frys" ;
  frysbox_nn_1_N = mkN "frysbox" ;
  frysdisk_nn_1_N = mkN "frysdisk" ;
  fraeckis_nn_1_1_N = mkN "fräckis" ;
  fraelsarkrans_nn_1_1_N = mkN "frälsarkrans" ;
  fraelsejord_nn_1_1_N = mkN "frälsejord" ;
  fraes_nn_1_1_N = mkN "fräs" ;
  froekapsel_nn_1_1_N = mkN "frökapsel" ;
  froetall_nn_1_1_N = mkN "frötall" ;
  ful_nn_1_N = mkN "ful" ;
  fuling_nn_1_N = mkN "fuling" ;
  fullblodshaest_nn_1_1_N = mkN "fullblodshäst" ;
  furstbiskop_nn_1_N = mkN "furstbiskop" ;
  furunkel_nn_1_N = mkN "furunkel" ;
  fuskpaels_nn_1_1_N = mkN "fuskpäls" ;
  futt_nn_1_N = mkN "futt" ;
  fux_nn_1_N = mkN "fux" ;
  fylking_nn_1_N = mkN "fylking" ;
  fyllbult_nn_1_N = mkN "fyllbult" ;
  fyr_nn_1_N = mkN "fyr" ;
  fyrbaak_nn_1_1_N = mkN "fyrbåk" ;
  fyrfoting_nn_1_N = mkN "fyrfoting" ;
  fyrk_nn_1_N = mkN "fyrk" ;
  fyrling_nn_1_N = mkN "fyrling" ;
  fyrmaenning_nn_1_1_N = mkN "fyrmänning" ;
  fyrtumsspik_nn_1_N = mkN "fyrtumsspik" ;
  fyrvaeppling_nn_1_1_N = mkN "fyrväppling" ;
  faebod_nn_1_1_N = mkN "fäbod" ;
  faelg_nn_1_1_N = mkN "fälg" ;
  faell_nn_1_1_N = mkN "fäll" ;
  faellkniv_nn_1_1_N = mkN "fällkniv" ;
  faellkoel_nn_1_1_N = mkN "fällköl" ;
  faeltmarskalk_nn_1_1_N = mkN "fältmarskalk" ;
  faenrik_nn_1_1_N = mkN "fänrik" ;
  faerdknaepp_nn_1_1_N = mkN "färdknäpp" ;
  faerghandel_nn_1_1_N = mkN "färghandel" ;
  faergklick_nn_1_1_N = mkN "färgklick" ;
  faering_nn_1_1_N = mkN "färing" ;
  faerskpotatis_nn_1_1_N = mkN "färskpotatis" ;
  faerskvarudisk_nn_1_1_N = mkN "färskvarudisk" ;
  faeroeing_nn_1_1_N = mkN "färöing" ;
  faesting_nn_1_1_N = mkN "fästing" ;
  faagel_nn_1_1_N = mkN "fågel" ;
  faagelbur_nn_1_1_N = mkN "fågelbur" ;
  faagelfjaeder_nn_1_1_N = mkN "fågelfjäder" ;
  faagelholk_nn_1_1_N = mkN "fågelholk" ;
  faagelhund_nn_1_1_N = mkN "fågelhund" ;
  faall_nn_1_1_N = mkN "fåll" ;
  faallbaenk_nn_1_1_N = mkN "fållbänk" ;
  faangstgrop_nn_1_1_N = mkN "fångstgrop" ;
  faarbogsaerm_nn_1_1_N = mkN "fårbogsärm" ;
  faarhjord_nn_1_1_N = mkN "fårhjord" ;
  faarhund_nn_1_1_N = mkN "fårhund" ;
  faarost_nn_1_1_N = mkN "fårost" ;
  foedopartikel_nn_1_1_N = mkN "födopartikel" ;
  foedsel_nn_1_1_N = mkN "födsel" ;
  foeljesedel_nn_1_1_N = mkN "följesedel" ;
  foensterbaenk_nn_1_1_N = mkN "fönsterbänk" ;
  foensterglugg_nn_1_1_N = mkN "fönsterglugg" ;
  foensterhasp_nn_1_1_N = mkN "fönsterhasp" ;
  foensterkarm_nn_1_1_N = mkN "fönsterkarm" ;
  foensterlav_nn_1_1_N = mkN "fönsterlav" ;
  foensterrektangel_nn_1_1_N = mkN "fönsterrektangel" ;
  foenstersmyg_nn_1_1_N = mkN "fönstersmyg" ;
  foer_nn_1_1_N = mkN "för" ;
  foerarsits_nn_1_1_N = mkN "förarsits" ;
  foerbandsartikel_nn_1_1_N = mkN "förbandsartikel" ;
  foerbrukningsartikel_nn_1_1_N = mkN "förbrukningsartikel" ;
  foerbundsdag_nn_1_1_N = mkN "förbundsdag" ;
  foerdetting_nn_1_1_N = mkN "fördetting" ;
  foerestaellningsvaerld_nn_1_1_N = mkN "föreställningsvärld" ;
  foergaard_nn_1_1_N = mkN "förgård" ;
  foerhall_nn_1_1_N = mkN "förhall" ;
  foerning_nn_1_1_N = mkN "förning" ;
  foerpik_nn_1_1_N = mkN "förpik" ;
  foerskoleaalder_nn_1_1_N = mkN "förskoleålder" ;
  foerskaerargaffel_nn_1_1_N = mkN "förskärargaffel" ;
  foerskaerarkniv_nn_1_1_N = mkN "förskärarkniv" ;
  foersommarkvaell_nn_1_1_N = mkN "försommarkväll" ;
  foerstling_nn_1_1_N = mkN "förstling" ;
  foerstugukvist_nn_1_1_N = mkN "förstugukvist" ;
  foerstukvist_nn_1_1_N = mkN "förstukvist" ;
  foerstaev_nn_1_1_N = mkN "förstäv" ;
  foersvarsminister_nn_1_1_N = mkN "försvarsminister" ;
  foersaekringspeng_nn_1_1_N = mkN "försäkringspeng" ;
  foersaeljningsdisk_nn_1_1_N = mkN "försäljningsdisk" ;
  foervaringsask_nn_1_1_N = mkN "förvaringsask" ;
  foervaringsbox_nn_1_1_N = mkN "förvaringsbox" ;
  foervinter_nn_1_1_N = mkN "förvinter" ;
  foeraelder_nn_1_1_N = mkN "förälder" ;
  foeraeldrabalk_nn_1_1_N = mkN "föräldrabalk" ;
  foeraeldradag_nn_1_1_N = mkN "föräldradag" ;
  gabonhuggorm_nn_1_N = mkN "gabonhuggorm" ;
  gadd_nn_1_N = mkN "gadd" ;
  gaddstekel_nn_1_N = mkN "gaddstekel" ;
  gaff_nn_1_N = mkN "gaff" ;
  gaffel_nn_1_N = mkN "gaffel" ;
  gaffelbit_nn_1_N = mkN "gaffelbit" ;
  gaffelbock_nn_1_N = mkN "gaffelbock" ;
  gaffelhjort_nn_1_N = mkN "gaffelhjort" ;
  gaffelrigg_nn_1_N = mkN "gaffelrigg" ;
  gaffeltruck_nn_1_N = mkN "gaffeltruck" ;
  gaj_nn_1_N = mkN "gaj" ;
  galder_nn_1_N = mkN "galder" ;
  galgfaagel_nn_1_1_N = mkN "galgfågel" ;
  gallstekel_nn_1_N = mkN "gallstekel" ;
  gallup_nn_1_N = mkN "gallup" ;
  galning_nn_1_N = mkN "galning" ;
  galt_nn_1_N = mkN "galt" ;
  galvanometer_nn_1_N = mkN "galvanometer" ;
  galaerslav_nn_1_1_N = mkN "galärslav" ;
  gam_nn_1_N = mkN "gam" ;
  gamling_nn_1_N = mkN "gamling" ;
  gaphals_nn_1_N = mkN "gaphals" ;
  gapsax_nn_1_N = mkN "gapsax" ;
  garfaagel_nn_1_1_N = mkN "garfågel" ;
  garnhank_nn_1_N = mkN "garnhank" ;
  gaskran_nn_1_N = mkN "gaskran" ;
  gaskropp_nn_1_N = mkN "gaskropp" ;
  gasometer_nn_1_N = mkN "gasometer" ;
  gasspis_nn_1_N = mkN "gasspis" ;
  gast_nn_1_N = mkN "gast" ;
  gatuteater_nn_1_N = mkN "gatuteater" ;
  gavel_nn_1_N = mkN "gavel" ;
  gejser_nn_1_N = mkN "gejser" ;
  gelatinkapsel_nn_1_N = mkN "gelatinkapsel" ;
  gel_esvamp_nn_1_1_N = mkN "gelésvamp" ;
  genomsnittssvensk_nn_1_N = mkN "genomsnittssvensk" ;
  genuafock_nn_1_N = mkN "genuafock" ;
  geodimeter_nn_1_N = mkN "geodimeter" ;
  gers_nn_1_N = mkN "gers" ;
  getabock_nn_1_N = mkN "getabock" ;
  getapel_nn_1_N = mkN "getapel" ;
  geting_nn_1_N = mkN "geting" ;
  getingsvaerm_nn_1_1_N = mkN "getingsvärm" ;
  getmjoelksost_nn_1_1_N = mkN "getmjölksost" ;
  getost_nn_1_N = mkN "getost" ;
  getvaeppling_nn_1_1_N = mkN "getväppling" ;
  gevaerskolv_nn_1_1_N = mkN "gevärskolv" ;
  giffel_nn_1_N = mkN "giffel" ;
  giftermaalsbalk_nn_1_1_N = mkN "giftermålsbalk" ;
  giftkapsel_nn_1_N = mkN "giftkapsel" ;
  giftkoertel_nn_1_1_N = mkN "giftkörtel" ;
  giftspindel_nn_1_N = mkN "giftspindel" ;
  gifttagg_nn_1_N = mkN "gifttagg" ;
  gigg_nn_1_N = mkN "gigg" ;
  ginbalk_nn_1_N = mkN "ginbalk" ;
  gip_nn_1_N = mkN "gip" ;
  gipp_nn_1_N = mkN "gipp" ;
  gir_nn_1_N = mkN "gir" ;
  gistgaard_nn_1_1_N = mkN "gistgård" ;
  giv_nn_1_N = mkN "giv" ;
  gjord_nn_1_N = mkN "gjord" ;
  glaciaeris_nn_1_1_N = mkN "glaciäris" ;
  glasbjoerk_nn_1_1_N = mkN "glasbjörk" ;
  glasbult_nn_1_N = mkN "glasbult" ;
  glashandduk_nn_1_N = mkN "glashandduk" ;
  glaskolv_nn_1_N = mkN "glaskolv" ;
  glaskropp_nn_1_N = mkN "glaskropp" ;
  glasmonter_nn_1_N = mkN "glasmonter" ;
  glasstrut_nn_1_N = mkN "glasstrut" ;
  glasvar_nn_1_N = mkN "glasvar" ;
  glasaal_nn_1_1_N = mkN "glasål" ;
  glattmask_nn_1_N = mkN "glattmask" ;
  glav_nn_1_N = mkN "glav" ;
  gletscher_nn_1_N = mkN "gletscher" ;
  glimt_nn_1_N = mkN "glimt" ;
  gliring_nn_1_N = mkN "gliring" ;
  glis_nn_2_N = mkN "glis" ;
  glop_nn_1_N = mkN "glop" ;
  glottisstoet_nn_1_1_N = mkN "glottisstöt" ;
  glugg_nn_1_N = mkN "glugg" ;
  glunt_nn_1_N = mkN "glunt" ;
  glytt_nn_1_N = mkN "glytt" ;
  gloedbaedd_nn_1_1_N = mkN "glödbädd" ;
  gloedkropp_nn_1_1_N = mkN "glödkropp" ;
  gloegg_nn_1_1_N = mkN "glögg" ;
  gnet_nn_2_N = mkN "gnet" ;
  gnoding_nn_1_N = mkN "gnoding" ;
  gnaellmaans_nn_1_1_N = mkN "gnällmåns" ;
  gnaellspik_nn_1_1_N = mkN "gnällspik" ;
  goddagspilt_nn_1_N = mkN "goddagspilt" ;
  goding_nn_1_N = mkN "goding" ;
  godis_nn_2_N = mkN "godis" ;
  godsvagn_nn_1_N = mkN "godsvagn" ;
  golvbrunn_nn_1_N = mkN "golvbrunn" ;
  golvbrunnssil_nn_1_N = mkN "golvbrunnssil" ;
  golvregel_nn_1_N = mkN "golvregel" ;
  golvsil_nn_1_N = mkN "golvsil" ;
  golvvaexel_nn_1_1_N = mkN "golvväxel" ;
  goniometer_nn_1_N = mkN "goniometer" ;
  gordonsetter_nn_1_N = mkN "gordonsetter" ;
  grabb_nn_1_N = mkN "grabb" ;
  gradmejsel_nn_1_N = mkN "gradmejsel" ;
  gradtapp_nn_1_N = mkN "gradtapp" ;
  grafitdegel_nn_1_N = mkN "grafitdegel" ;
  gran_nn_1_N = mkN "gran" ;
  gratisskjuts_nn_1_N = mkN "gratisskjuts" ;
  grav_nn_1_N = mkN "grav" ;
  gravimeter_nn_1_N = mkN "gravimeter" ;
  gravlax_nn_1_N = mkN "gravlax" ;
  gravstickel_nn_1_N = mkN "gravstickel" ;
  grenspets_nn_1_N = mkN "grenspets" ;
  grenvinkel_nn_1_N = mkN "grenvinkel" ;
  grevetitel_nn_1_N = mkN "grevetitel" ;
  griffel_nn_1_N = mkN "griffel" ;
  grill_nn_1_N = mkN "grill" ;
  grind_nn_1_N = mkN "grind" ;
  grindslant_nn_1_N = mkN "grindslant" ;
  grindval_nn_1_N = mkN "grindval" ;
  grip_nn_1_N = mkN "grip" ;
  gris_nn_1_N = mkN "gris" ;
  griskulting_nn_1_N = mkN "griskulting" ;
  grissel_nn_1_N = mkN "grissel" ;
  grissvans_nn_1_N = mkN "grissvans" ;
  grodd_nn_1_N = mkN "grodd" ;
  groddknopp_nn_1_N = mkN "groddknopp" ;
  grodfisk_nn_1_N = mkN "grodfisk" ;
  grogg_nn_1_N = mkN "grogg" ;
  grop_nn_1_N = mkN "grop" ;
  grovtarm_nn_1_N = mkN "grovtarm" ;
  grundbult_nn_1_N = mkN "grundbult" ;
  grundplaat_nn_1_1_N = mkN "grundplåt" ;
  grundval_nn_1_N = mkN "grundval" ;
  grusgrop_nn_1_N = mkN "grusgrop" ;
  gruvarbetarstoevel_nn_1_1_N = mkN "gruvarbetarstövel" ;
  gruvhund_nn_1_N = mkN "gruvhund" ;
  grythund_nn_1_N = mkN "grythund" ;
  grytlapp_nn_1_N = mkN "grytlapp" ;
  graeddvisp_nn_1_1_N = mkN "gräddvisp" ;
  graelmaans_nn_1_1_N = mkN "grälmåns" ;
  graeshoppssvaerm_nn_1_1_N = mkN "gräshoppssvärm" ;
  graesmask_nn_1_1_N = mkN "gräsmask" ;
  graevling_nn_1_1_N = mkN "grävling" ;
  graevlingshund_nn_1_1_N = mkN "grävlingshund" ;
  graaal_nn_1_1_N = mkN "gråal" ;
  graahund_nn_1_1_N = mkN "gråhund" ;
  graahaeger_nn_1_1_N = mkN "gråhäger" ;
  graalax_nn_1_1_N = mkN "grålax" ;
  graames_nn_1_1_N = mkN "gråmes" ;
  graasej_nn_1_1_N = mkN "gråsej" ;
  graasparv_nn_1_1_N = mkN "gråsparv" ;
  graaspett_nn_1_1_N = mkN "gråspett" ;
  graasael_nn_1_1_N = mkN "gråsäl" ;
  graatrut_nn_1_1_N = mkN "gråtrut" ;
  graaval_nn_1_1_N = mkN "gråval" ;
  groenfink_nn_1_1_N = mkN "grönfink" ;
  groening_nn_1_1_N = mkN "gröning" ;
  groenlandsval_nn_1_1_N = mkN "grönlandsval" ;
  groenling_nn_1_1_N = mkN "grönling" ;
  groenmoegelost_nn_1_1_N = mkN "grönmögelost" ;
  groenspett_nn_1_1_N = mkN "grönspett" ;
  groet_nn_1_1_N = mkN "gröt" ;
  groetfrukost_nn_1_1_N = mkN "grötfrukost" ;
  groetrock_nn_1_1_N = mkN "grötrock" ;
  gubbjaevel_nn_1_1_N = mkN "gubbjävel" ;
  gubbstrutt_nn_1_N = mkN "gubbstrutt" ;
  gud_nn_1_N = mkN "gud" ;
  guding_nn_1_N = mkN "guding" ;
  guldfisk_nn_1_N = mkN "guldfisk" ;
  guldfux_nn_1_N = mkN "guldfux" ;
  guldkalv_nn_1_N = mkN "guldkalv" ;
  guldklimp_nn_1_N = mkN "guldklimp" ;
  guldmakrill_nn_1_N = mkN "guldmakrill" ;
  guldplants_nn_1_N = mkN "guldplants" ;
  guldstekel_nn_1_N = mkN "guldstekel" ;
  guldstaempel_nn_1_1_N = mkN "guldstämpel" ;
  guldaalder_nn_1_1_N = mkN "guldålder" ;
  gulesaeck_nn_1_1_N = mkN "gulesäck" ;
  guling_nn_1_N = mkN "guling" ;
  gulkropp_nn_1_N = mkN "gulkropp" ;
  gullegris_nn_1_N = mkN "gullegris" ;
  gullgris_nn_1_N = mkN "gullgris" ;
  gulsparv_nn_1_N = mkN "gulsparv" ;
  gulsaeck_nn_1_1_N = mkN "gulsäck" ;
  gummikabel_nn_1_N = mkN "gummikabel" ;
  gummisnodd_nn_1_N = mkN "gummisnodd" ;
  gummistoevel_nn_1_1_N = mkN "gummistövel" ;
  gump_nn_1_N = mkN "gump" ;
  gumpkoertel_nn_1_1_N = mkN "gumpkörtel" ;
  gunghaest_nn_1_1_N = mkN "gunghäst" ;
  gunstling_nn_1_N = mkN "gunstling" ;
  gylf_nn_1_N = mkN "gylf" ;
  gylling_nn_1_N = mkN "gylling" ;
  gaeddsax_nn_1_1_N = mkN "gäddsax" ;
  gael_nn_1_1_N = mkN "gäl" ;
  gaengback_nn_1_1_N = mkN "gängback" ;
  gaengtapp_nn_1_1_N = mkN "gängtapp" ;
  gaengtolk_nn_1_1_N = mkN "gängtolk" ;
  gaerdesgaard_nn_1_1_N = mkN "gärdesgård" ;
  gaerdsgaard_nn_1_1_N = mkN "gärdsgård" ;
  gaerdsgaardsstoer_nn_1_1_N = mkN "gärdsgårdsstör" ;
  gaerdsmyg_nn_1_1_N = mkN "gärdsmyg" ;
  gaers_nn_1_1_N = mkN "gärs" ;
  gaessling_nn_1_1_N = mkN "gässling" ;
  gaestgivargaard_nn_1_1_N = mkN "gästgivargård" ;
  gaesthandduk_nn_1_1_N = mkN "gästhandduk" ;
  gaestring_nn_1_1_N = mkN "gästring" ;
  gaang_nn_1_1_N = mkN "gång" ;
  gaanglaat_nn_1_1_N = mkN "gånglåt" ;
  gaangstol_nn_1_1_N = mkN "gångstol" ;
  gaard_nn_1_1_N = mkN "gård" ;
  gaardag_nn_1_1_N = mkN "gårdag" ;
  gaardagskvaell_nn_1_1_N = mkN "gårdagskväll" ;
  gaarding_nn_1_1_N = mkN "gårding" ;
  gaardskarl_nn_1_1_N = mkN "gårdskarl" ;
  gaardvar_nn_1_1_N = mkN "gårdvar" ;
  gaasfjaeder_nn_1_1_N = mkN "gåsfjäder" ;
  gaaskarl_nn_1_1_N = mkN "gåskarl" ;
  gaastav_nn_1_1_N = mkN "gåstav" ;
  gaastol_nn_1_1_N = mkN "gåstol" ;
  gaat_nn_1_1_N = mkN "gåt" ;
  goedkyckling_nn_1_1_N = mkN "gödkyckling" ;
  goedselstack_nn_1_1_N = mkN "gödselstack" ;
  goek_nn_1_1_N = mkN "gök" ;
  goel_nn_1_1_N = mkN "göl" ;
  goeling_nn_1_1_N = mkN "göling" ;
  goerdel_nn_1_1_N = mkN "gördel" ;
  goes_nn_1_1_N = mkN "gös" ;
  goet_nn_1_1_N = mkN "göt" ;
  goeteborgsvits_nn_1_1_N = mkN "göteborgsvits" ;
  habitus_nn_1_N = mkN "habitus" ;
  hackkyckling_nn_1_N = mkN "hackkyckling" ;
  hackspett_nn_1_N = mkN "hackspett" ;
  hagtorn_nn_1_N = mkN "hagtorn" ;
  haj_nn_1_N = mkN "haj" ;
  hajk_nn_1_N = mkN "hajk" ;
  hajmal_nn_1_N = mkN "hajmal" ;
  haklapp_nn_1_N = mkN "haklapp" ;
  hakspets_nn_1_N = mkN "hakspets" ;
  hall_nn_1_N = mkN "hall" ;
  hallick_nn_1_N = mkN "hallick" ;
  halling_nn_1_N = mkN "halling" ;
  hallonmask_nn_1_N = mkN "hallonmask" ;
  hallspegel_nn_1_N = mkN "hallspegel" ;
  hallstaempel_nn_1_1_N = mkN "hallstämpel" ;
  halmstack_nn_1_N = mkN "halmstack" ;
  hals_nn_1_N = mkN "hals" ;
  halsduk_nn_1_N = mkN "halsduk" ;
  halsgrop_nn_1_N = mkN "halsgrop" ;
  halsmandel_nn_1_N = mkN "halsmandel" ;
  halvback_nn_1_N = mkN "halvback" ;
  halvcirkel_nn_1_N = mkN "halvcirkel" ;
  halvknop_nn_1_N = mkN "halvknop" ;
  halvsyster_nn_1_N = mkN "halvsyster" ;
  halvvaerld_nn_1_1_N = mkN "halvvärld" ;
  hammarhaj_nn_1_N = mkN "hammarhaj" ;
  hammelsadel_nn_1_N = mkN "hammelsadel" ;
  hammock_nn_1_N = mkN "hammock" ;
  hammondorgel_nn_1_N = mkN "hammondorgel" ;
  hamn_nn_1_N = mkN "hamn" ;
  hamster_nn_1_N = mkN "hamster" ;
  handbroms_nn_1_N = mkN "handbroms" ;
  handduk_nn_1_N = mkN "handduk" ;
  handel_nn_2_N = mkN "handel" ;
  handelsbod_nn_1_N = mkN "handelsbod" ;
  handelsminister_nn_1_N = mkN "handelsminister" ;
  handelstraedgaard_nn_1_1_N = mkN "handelsträdgård" ;
  handfull_nn_1_N = mkN "handfull" ;
  handkyss_nn_1_N = mkN "handkyss" ;
  handpenning_nn_1_N = mkN "handpenning" ;
  handspegel_nn_1_N = mkN "handspegel" ;
  handstil_nn_1_N = mkN "handstil" ;
  handvinsch_nn_1_N = mkN "handvinsch" ;
  hank_nn_1_N = mkN "hank" ;
  hantel_nn_1_N = mkN "hantel" ;
  harkrank_nn_1_N = mkN "harkrank" ;
  harpalt_nn_1_N = mkN "harpalt" ;
  harr_nn_1_N = mkN "harr" ;
  hartass_nn_1_N = mkN "hartass" ;
  harv_nn_1_N = mkN "harv" ;
  hasp_nn_1_N = mkN "hasp" ;
  haspel_nn_1_N = mkN "haspel" ;
  hassel_nn_1_N = mkN "hassel" ;
  hasselsnok_nn_1_N = mkN "hasselsnok" ;
  hatt_nn_1_N = mkN "hatt" ;
  hattask_nn_1_N = mkN "hattask" ;
  hattsvamp_nn_1_N = mkN "hattsvamp" ;
  haubitz_nn_1_N = mkN "haubitz" ;
  havregrynsgroet_nn_1_1_N = mkN "havregrynsgröt" ;
  havsborstmask_nn_1_N = mkN "havsborstmask" ;
  havsfaagel_nn_1_1_N = mkN "havsfågel" ;
  havsis_nn_1_N = mkN "havsis" ;
  havskraeftstjaert_nn_1_1_N = mkN "havskräftstjärt" ;
  havslax_nn_1_N = mkN "havslax" ;
  havsmus_nn_1_N = mkN "havsmus" ;
  havstrut_nn_1_N = mkN "havstrut" ;
  havsutter_nn_1_N = mkN "havsutter" ;
  havtorn_nn_1_N = mkN "havtorn" ;
  hearing_nn_1_N = mkN "hearing" ;
  hed_nn_1_N = mkN "hed" ;
  hedersknyffel_nn_1_N = mkN "hedersknyffel" ;
  hederskodex_nn_1_N = mkN "hederskodex" ;
  hedersmantel_nn_1_N = mkN "hedersmantel" ;
  hederstitel_nn_1_N = mkN "hederstitel" ;
  hedning_nn_1_N = mkN "hedning" ;
  hejduk_nn_1_N = mkN "hejduk" ;
  helgdag_nn_1_N = mkN "helgdag" ;
  helikopter_nn_1_N = mkN "helikopter" ;
  helkvaell_nn_1_1_N = mkN "helkväll" ;
  hembygdsgaard_nn_1_1_N = mkN "hembygdsgård" ;
  hemligstaempel_nn_1_1_N = mkN "hemligstämpel" ;
  hemlock_nn_1_N = mkN "hemlock" ;
  hemmakvaell_nn_1_1_N = mkN "hemmakväll" ;
  hemmarock_nn_1_N = mkN "hemmarock" ;
  hemmaseger_nn_1_N = mkN "hemmaseger" ;
  herrcykel_nn_1_N = mkN "herrcykel" ;
  herrdubbel_nn_1_N = mkN "herrdubbel" ;
  herrgaard_nn_1_1_N = mkN "herrgård" ;
  herrgaardsost_nn_1_1_N = mkN "herrgårdsost" ;
  herrgaardsvagn_nn_1_1_N = mkN "herrgårdsvagn" ;
  herrsingel_nn_1_N = mkN "herrsingel" ;
  hertig_nn_1_N = mkN "hertig" ;
  hexameter_nn_1_N = mkN "hexameter" ;
  hibiskus_nn_1_N = mkN "hibiskus" ;
  higgspartikel_nn_1_N = mkN "higgspartikel" ;
  himlakropp_nn_1_N = mkN "himlakropp" ;
  himmelssaeng_nn_1_1_N = mkN "himmelssäng" ;
  hind_nn_1_N = mkN "hind" ;
  hinderbock_nn_1_N = mkN "hinderbock" ;
  hingst_nn_1_N = mkN "hingst" ;
  hink_nn_1_N = mkN "hink" ;
  hiss_nn_1_N = mkN "hiss" ;
  hisskorg_nn_1_N = mkN "hisskorg" ;
  hjord_nn_1_N = mkN "hjord" ;
  hjort_nn_1_N = mkN "hjort" ;
  hjortsadel_nn_1_N = mkN "hjortsadel" ;
  hjulaxel_nn_1_N = mkN "hjulaxel" ;
  hjulmutter_nn_1_N = mkN "hjulmutter" ;
  hjaelm_nn_1_1_N = mkN "hjälm" ;
  hjaeltehund_nn_1_1_N = mkN "hjältehund" ;
  hjaernbalk_nn_1_1_N = mkN "hjärnbalk" ;
  hjaernskaal_nn_1_1_N = mkN "hjärnskål" ;
  hjaernstorm_nn_1_1_N = mkN "hjärnstorm" ;
  hjaertesuck_nn_1_1_N = mkN "hjärtesuck" ;
  hjaertklaff_nn_1_1_N = mkN "hjärtklaff" ;
  hjaertsaeck_nn_1_1_N = mkN "hjärtsäck" ;
  hoj_nn_1_N = mkN "hoj" ;
  holk_nn_1_N = mkN "holk" ;
  homovigsel_nn_1_N = mkN "homovigsel" ;
  honungsskivling_nn_1_N = mkN "honungsskivling" ;
  hop_nn_1_N = mkN "hop" ;
  hoppstjaert_nn_1_1_N = mkN "hoppstjärt" ;
  horbock_nn_1_N = mkN "horbock" ;
  horsgoek_nn_1_1_N = mkN "horsgök" ;
  horst_nn_1_N = mkN "horst" ;
  host_nn_1_N = mkN "host" ;
  hov_nn_1_N = mkN "hov" ;
  hovmarskalk_nn_1_N = mkN "hovmarskalk" ;
  hovnarr_nn_1_N = mkN "hovnarr" ;
  hovreporter_nn_1_N = mkN "hovreporter" ;
  hud_nn_1_N = mkN "hud" ;
  hudflik_nn_1_N = mkN "hudflik" ;
  hudflaeck_nn_1_1_N = mkN "hudfläck" ;
  huggmejsel_nn_1_N = mkN "huggmejsel" ;
  hulk_nn_1_N = mkN "hulk" ;
  hulling_nn_1_N = mkN "hulling" ;
  humbug_nn_1_N = mkN "humbug" ;
  hund_nn_1_N = mkN "hund" ;
  hundlort_nn_1_N = mkN "hundlort" ;
  hundrakronorssedel_nn_1_N = mkN "hundrakronorssedel" ;
  hundralapp_nn_1_N = mkN "hundralapp" ;
  hundring_nn_1_N = mkN "hundring" ;
  hundvalp_nn_1_N = mkN "hundvalp" ;
  hundaexing_nn_1_1_N = mkN "hundäxing" ;
  hunk_nn_1_N = mkN "hunk" ;
  hurts_nn_1_N = mkN "hurts" ;
  husbock_nn_1_N = mkN "husbock" ;
  husdjursartikel_nn_1_N = mkN "husdjursartikel" ;
  husgavel_nn_1_N = mkN "husgavel" ;
  husgud_nn_1_N = mkN "husgud" ;
  hushaallsgris_nn_1_1_N = mkN "hushållsgris" ;
  hushaallsost_nn_1_1_N = mkN "hushållsost" ;
  huskropp_nn_1_N = mkN "huskropp" ;
  husvagn_nn_1_N = mkN "husvagn" ;
  hutch_nn_1_N = mkN "hutch" ;
  hutt_nn_1_N = mkN "hutt" ;
  huv_nn_1_N = mkN "huv" ;
  huvudaxel_nn_1_N = mkN "huvudaxel" ;
  huvudnyckel_nn_1_N = mkN "huvudnyckel" ;
  huvudstol_nn_1_N = mkN "huvudstol" ;
  huvudsvaal_nn_1_1_N = mkN "huvudsvål" ;
  huvudtitel_nn_1_N = mkN "huvudtitel" ;
  hydrokopter_nn_1_N = mkN "hydrokopter" ;
  hygrometer_nn_1_N = mkN "hygrometer" ;
  hylsnyckel_nn_1_N = mkN "hylsnyckel" ;
  hyperlaenk_nn_1_1_N = mkN "hyperlänk" ;
  hypsometer_nn_1_N = mkN "hypsometer" ;
  hyreshaj_nn_1_N = mkN "hyreshaj" ;
  hyresvaerd_nn_1_1_N = mkN "hyresvärd" ;
  hyvel_nn_1_N = mkN "hyvel" ;
  hyvelbaenk_nn_1_1_N = mkN "hyvelbänk" ;
  haeck_nn_1_1_N = mkN "häck" ;
  haeckfaagel_nn_1_1_N = mkN "häckfågel" ;
  haecksax_nn_1_1_N = mkN "häcksax" ;
  haeger_nn_1_1_N = mkN "häger" ;
  haegg_nn_1_1_N = mkN "hägg" ;
  hael_nn_1_1_N = mkN "häl" ;
  haell_nn_1_1_N = mkN "häll" ;
  haelsing_nn_1_1_N = mkN "hälsing" ;
  haelsobrunn_nn_1_1_N = mkN "hälsobrunn" ;
  haempling_nn_1_1_N = mkN "hämpling" ;
  haengbjoerk_nn_1_1_N = mkN "hängbjörk" ;
  haengbuk_nn_1_1_N = mkN "hängbuk" ;
  haengdal_nn_1_1_N = mkN "hängdal" ;
  haer_nn_1_1_N = mkN "här" ;
  haeradshoevding_nn_1_1_N = mkN "häradshövding" ;
  haerd_nn_1_1_N = mkN "härd" ;
  haerfaagel_nn_1_1_N = mkN "härfågel" ;
  haerjedaling_nn_1_1_N = mkN "härjedaling" ;
  haerk_nn_1_1_N = mkN "härk" ;
  haermask_nn_1_1_N = mkN "härmask" ;
  haermfaagel_nn_1_1_N = mkN "härmfågel" ;
  haervel_nn_1_1_N = mkN "härvel" ;
  haest_nn_1_1_N = mkN "häst" ;
  haesthov_nn_1_1_N = mkN "hästhov" ;
  haestrygg_nn_1_1_N = mkN "hästrygg" ;
  haestskjuts_nn_1_1_N = mkN "hästskjuts" ;
  haestsvans_nn_1_1_N = mkN "hästsvans" ;
  haevarm_nn_1_1_N = mkN "hävarm" ;
  haevarmslyft_nn_1_1_N = mkN "hävarmslyft" ;
  haevel_nn_1_1_N = mkN "hävel" ;
  haevert_nn_1_1_N = mkN "hävert" ;
  haevstaangsarm_nn_1_1_N = mkN "hävstångsarm" ;
  haexkittel_nn_1_1_N = mkN "häxkittel" ;
  haabrand_nn_1_1_N = mkN "håbrand" ;
  haakaering_nn_1_1_N = mkN "håkäring" ;
  haalkael_nn_1_1_N = mkN "hålkäl" ;
  haalslev_nn_1_1_N = mkN "hålslev" ;
  haarddisk_nn_1_1_N = mkN "hårddisk" ;
  haarding_nn_1_1_N = mkN "hårding" ;
  haarfoen_nn_1_1_N = mkN "hårfön" ;
  haarnaal_nn_1_1_N = mkN "hårnål" ;
  haarpensel_nn_1_1_N = mkN "hårpensel" ;
  haarsaeck_nn_1_1_N = mkN "hårsäck" ;
  haartest_nn_1_1_N = mkN "hårtest" ;
  haartofs_nn_1_1_N = mkN "hårtofs" ;
  haartork_nn_1_1_N = mkN "hårtork" ;
  haartuss_nn_1_1_N = mkN "hårtuss" ;
  haav_nn_1_1_N = mkN "håv" ;
  hoeg_nn_1_1_N = mkN "hög" ;
  hoegaffel_nn_1_1_N = mkN "högaffel" ;
  hoegborg_nn_1_1_N = mkN "högborg" ;
  hoegbaenk_nn_1_1_N = mkN "högbänk" ;
  hoegerarm_nn_1_1_N = mkN "högerarm" ;
  hoegerflygel_nn_1_1_N = mkN "högerflygel" ;
  hoegergir_nn_1_1_N = mkN "högergir" ;
  hoeghastighetstunnel_nn_1_1_N = mkN "höghastighetstunnel" ;
  hoegrestaandskrets_nn_1_1_N = mkN "högreståndskrets" ;
  hoegtryckskabel_nn_1_1_N = mkN "högtryckskabel" ;
  hoegtrycksrygg_nn_1_1_N = mkN "högtrycksrygg" ;
  hoejdrygg_nn_1_1_N = mkN "höjdrygg" ;
  hoek_nn_1_1_N = mkN "hök" ;
  hoensbur_nn_1_1_N = mkN "hönsbur" ;
  hoensfaagel_nn_1_1_N = mkN "hönsfågel" ;
  hoensgaard_nn_1_1_N = mkN "hönsgård" ;
  hoerlur_nn_1_1_N = mkN "hörlur" ;
  hoest_nn_1_1_N = mkN "höst" ;
  hoestack_nn_1_1_N = mkN "höstack" ;
  hoeststorm_nn_1_1_N = mkN "höststorm" ;
  hoesaeck_nn_1_1_N = mkN "hösäck" ;
  hoetapp_nn_1_1_N = mkN "hötapp" ;
  hoetork_nn_1_1_N = mkN "hötork" ;
  hoevding_nn_1_1_N = mkN "hövding" ;
  ibis_nn_1_N = mkN "ibis" ;
  ibisfaagel_nn_1_1_N = mkN "ibisfågel" ;
  icing_nn_1_N = mkN "icing" ;
  id_nn_1_N = mkN "id" ;
  idegran_nn_1_N = mkN "idegran" ;
  idrottsdag_nn_1_N = mkN "idrottsdag" ;
  idrottshall_nn_1_N = mkN "idrottshall" ;
  id_evaerld_nn_1_1_N = mkN "idévärld" ;
  igel_nn_1_N = mkN "igel" ;
  igelkott_nn_1_N = mkN "igelkott" ;
  ikosaeder_nn_1_N = mkN "ikosaeder" ;
  il_nn_1_N = mkN "il" ;
  ilex_nn_1_N = mkN "ilex" ;
  illbatting_nn_1_N = mkN "illbatting" ;
  iller_nn_1_N = mkN "iller" ;
  imperialsaeng_nn_1_1_N = mkN "imperialsäng" ;
  imposttull_nn_1_N = mkN "imposttull" ;
  inbrottstjuv_nn_1_N = mkN "inbrottstjuv" ;
  industriminister_nn_1_N = mkN "industriminister" ;
  industrirobot_nn_1_N = mkN "industrirobot" ;
  industrisemester_nn_1_N = mkN "industrisemester" ;
  infallsvinkel_nn_1_N = mkN "infallsvinkel" ;
  infektionshaerd_nn_1_1_N = mkN "infektionshärd" ;
  inflammationshaerd_nn_1_1_N = mkN "inflammationshärd" ;
  informationsdisk_nn_1_N = mkN "informationsdisk" ;
  infrastrukturminister_nn_1_N = mkN "infrastrukturminister" ;
  infoeding_nn_1_1_N = mkN "inföding" ;
  inhamn_nn_1_N = mkN "inhamn" ;
  inhysing_nn_1_N = mkN "inhysing" ;
  ink_nn_1_N = mkN "ink" ;
  inklinationsnaal_nn_1_1_N = mkN "inklinationsnål" ;
  inlandsis_nn_1_N = mkN "inlandsis" ;
  inner_nn_1_N = mkN "inner" ;
  inrikesminister_nn_1_N = mkN "inrikesminister" ;
  inseglingsfyr_nn_1_N = mkN "inseglingsfyr" ;
  insektsnaal_nn_1_1_N = mkN "insektsnål" ;
  insektssax_nn_1_N = mkN "insektssax" ;
  insjoefisk_nn_1_1_N = mkN "insjöfisk" ;
  installationskabel_nn_1_N = mkN "installationskabel" ;
  institutionsteater_nn_1_N = mkN "institutionsteater" ;
  intelligensaalder_nn_1_1_N = mkN "intelligensålder" ;
  internetartikel_nn_1_N = mkN "internetartikel" ;
  invandrarteater_nn_1_N = mkN "invandrarteater" ;
  inaelvsmask_nn_1_1_N = mkN "inälvsmask" ;
  iris_nn_1_N = mkN "iris" ;
  is_nn_1_N = mkN "is" ;
  isbill_nn_1_N = mkN "isbill" ;
  isboj_nn_1_N = mkN "isboj" ;
  isbrodd_nn_1_N = mkN "isbrodd" ;
  isdubb_nn_1_N = mkN "isdubb" ;
  isfaagel_nn_1_1_N = mkN "isfågel" ;
  isglass_nn_1_N = mkN "isglass" ;
  ishall_nn_1_N = mkN "ishall" ;
  islandslav_nn_1_N = mkN "islandslav" ;
  islandssill_nn_1_N = mkN "islandssill" ;
  ispigg_nn_1_N = mkN "ispigg" ;
  ispik_nn_1_N = mkN "ispik" ;
  istapp_nn_1_N = mkN "istapp" ;
  isterbuk_nn_1_N = mkN "isterbuk" ;
  isvak_nn_1_N = mkN "isvak" ;
  jab_nn_1_N = mkN "jab" ;
  jabb_nn_1_N = mkN "jabb" ;
  jackpropp_nn_1_N = mkN "jackpropp" ;
  jaggernaut_nn_1_N = mkN "jaggernaut" ;
  jak_nn_1_N = mkN "jak" ;
  jaktfalk_nn_1_N = mkN "jaktfalk" ;
  jakthund_nn_1_N = mkN "jakthund" ;
  jaktrobot_nn_1_N = mkN "jaktrobot" ;
  jaktspindel_nn_1_N = mkN "jaktspindel" ;
  jan_nn_1_N = mkN "jan" ;
  jarl_nn_1_N = mkN "jarl" ;
  jaspis_nn_1_N = mkN "jaspis" ;
  jazzlaat_nn_1_1_N = mkN "jazzlåt" ;
  jazzorkester_nn_1_N = mkN "jazzorkester" ;
  jeep_nn_1_N = mkN "jeep" ;
  jig_nn_1_N = mkN "jig" ;
  jigg_nn_1_N = mkN "jigg" ;
  jobbarkompis_nn_1_N = mkN "jobbarkompis" ;
  jojk_nn_1_N = mkN "jojk" ;
  joker_nn_1_N = mkN "joker" ;
  jokk_nn_1_N = mkN "jokk" ;
  jolster_nn_1_N = mkN "jolster" ;
  jonflaeck_nn_1_1_N = mkN "jonfläck" ;
  jord_nn_1_N = mkN "jord" ;
  jordabalk_nn_1_N = mkN "jordabalk" ;
  jordborr_nn_1_N = mkN "jordborr" ;
  jordbruksminister_nn_1_N = mkN "jordbruksminister" ;
  jorddrott_nn_1_N = mkN "jorddrott" ;
  jordfraes_nn_1_1_N = mkN "jordfräs" ;
  jordgeting_nn_1_N = mkN "jordgeting" ;
  jordgubbsskoerd_nn_1_1_N = mkN "jordgubbsskörd" ;
  jordkabel_nn_1_N = mkN "jordkabel" ;
  jordpartikel_nn_1_N = mkN "jordpartikel" ;
  jordskredsseger_nn_1_N = mkN "jordskredsseger" ;
  jordstoet_nn_1_1_N = mkN "jordstöt" ;
  jubeldag_nn_1_N = mkN "jubeldag" ;
  judaskyss_nn_1_N = mkN "judaskyss" ;
  judaspeng_nn_1_N = mkN "judaspeng" ;
  jukebox_nn_1_N = mkN "jukebox" ;
  jul_nn_1_N = mkN "jul" ;
  julbock_nn_1_N = mkN "julbock" ;
  juldag_nn_1_N = mkN "juldag" ;
  julgran_nn_1_N = mkN "julgran" ;
  julgris_nn_1_N = mkN "julgris" ;
  julkaktus_nn_1_N = mkN "julkaktus" ;
  julkalender_nn_1_N = mkN "julkalender" ;
  julklapp_nn_1_N = mkN "julklapp" ;
  jullaat_nn_1_1_N = mkN "jullåt" ;
  julp_nn_1_N = mkN "julp" ;
  jumbojet_nn_1_N = mkN "jumbojet" ;
  jumper_nn_1_N = mkN "jumper" ;
  jungfrubur_nn_1_N = mkN "jungfrubur" ;
  jungfrufoedsel_nn_1_1_N = mkN "jungfrufödsel" ;
  jungfrusvaerm_nn_1_1_N = mkN "jungfrusvärm" ;
  junker_nn_1_N = mkN "junker" ;
  justitieminister_nn_1_N = mkN "justitieminister" ;
  jaegarbiff_nn_1_1_N = mkN "jägarbiff" ;
  jaekel_nn_1_1_N = mkN "jäkel" ;
  jaemmerdal_nn_1_1_N = mkN "jämmerdal" ;
  jaemstaelldhetsbonus_nn_1_1_N = mkN "jämställdhetsbonus" ;
  jaemthund_nn_1_1_N = mkN "jämthund" ;
  jaernbalk_nn_1_1_N = mkN "järnbalk" ;
  jaernek_nn_1_1_N = mkN "järnek" ;
  jaernekkrans_nn_1_1_N = mkN "järnekkrans" ;
  jaernhandel_nn_1_1_N = mkN "järnhandel" ;
  jaernplaat_nn_1_1_N = mkN "järnplåt" ;
  jaernsparv_nn_1_1_N = mkN "järnsparv" ;
  jaernspis_nn_1_1_N = mkN "järnspis" ;
  jaernvaruhandel_nn_1_1_N = mkN "järnvaruhandel" ;
  jaernvaegsraels_nn_1_1_N = mkN "järnvägsräls" ;
  jaerv_nn_1_1_N = mkN "järv" ;
  jaestsvamp_nn_1_1_N = mkN "jästsvamp" ;
  jaettegalt_nn_1_1_N = mkN "jättegalt" ;
  jaetteskraell_nn_1_1_N = mkN "jätteskräll" ;
  jaettespindel_nn_1_1_N = mkN "jättespindel" ;
  jaetteval_nn_1_1_N = mkN "jätteval" ;
  jaevel_nn_1_1_N = mkN "jävel" ;
  jaakk_nn_1_1_N = mkN "jåkk" ;
  joekel_nn_1_1_N = mkN "jökel" ;
  joens_nn_1_1_N = mkN "jöns" ;
  k_pist_nn_1_N = mkN "k-pist" ;
  kabar_eorkester_nn_1_1_N = mkN "kabaréorkester" ;
  kabel_nn_1_N = mkN "kabel" ;
  kabelbrunn_nn_1_N = mkN "kabelbrunn" ;
  kabinbaat_nn_1_1_N = mkN "kabinbåt" ;
  kaffebal_nn_1_N = mkN "kaffebal" ;
  kaffeduk_nn_1_N = mkN "kaffeduk" ;
  kaffegoek_nn_1_1_N = mkN "kaffegök" ;
  kaffekask_nn_1_N = mkN "kaffekask" ;
  kaffekittel_nn_1_N = mkN "kaffekittel" ;
  kaffekopp_nn_1_N = mkN "kaffekopp" ;
  kaffemoster_nn_1_N = mkN "kaffemoster" ;
  kaffepetter_nn_1_N = mkN "kaffepetter" ;
  kafferbuffel_nn_1_N = mkN "kafferbuffel" ;
  kaffetaar_nn_1_1_N = mkN "kaffetår" ;
  kaf_evagn_nn_1_1_N = mkN "kafévagn" ;
  kajsvaerm_nn_1_1_N = mkN "kajsvärm" ;
  kaktus_nn_1_N = mkN "kaktus" ;
  kalander_nn_1_N = mkN "kalander" ;
  kalender_nn_1_N = mkN "kalender" ;
  kalenderstav_nn_1_N = mkN "kalenderstav" ;
  kalibertolk_nn_1_N = mkN "kalibertolk" ;
  kalk_nn_2_N = mkN "kalk" ;
  kalkonsmoergaas_nn_1_1_N = mkN "kalkonsmörgås" ;
  kalkugn_nn_1_N = mkN "kalkugn" ;
  kallbaenk_nn_1_1_N = mkN "kallbänk" ;
  kalldusch_nn_1_N = mkN "kalldusch" ;
  kalling_nn_1_N = mkN "kalling" ;
  kallmangel_nn_1_N = mkN "kallmangel" ;
  kallnaal_nn_1_1_N = mkN "kallnål" ;
  kallskaenk_nn_1_1_N = mkN "kallskänk" ;
  kallsup_nn_1_N = mkN "kallsup" ;
  kalorimeter_nn_1_N = mkN "kalorimeter" ;
  kalv_nn_1_N = mkN "kalv" ;
  kamaxel_nn_1_N = mkN "kamaxel" ;
  kamelhjord_nn_1_N = mkN "kamelhjord" ;
  kamelsadel_nn_1_N = mkN "kamelsadel" ;
  kamelsaeck_nn_1_1_N = mkN "kamelsäck" ;
  kameravinkel_nn_1_N = mkN "kameravinkel" ;
  kammarorkester_nn_1_N = mkN "kammarorkester" ;
  kamp_nn_2_N = mkN "kamp" ;
  kampkonstkrets_nn_1_N = mkN "kampkonstkrets" ;
  kams_nn_1_N = mkN "kams" ;
  kanariefaagel_nn_1_1_N = mkN "kanariefågel" ;
  kandelaber_nn_1_N = mkN "kandelaber" ;
  kanister_nn_1_N = mkN "kanister" ;
  kanthyvel_nn_1_N = mkN "kanthyvel" ;
  kantnaal_nn_1_1_N = mkN "kantnål" ;
  kanvasduk_nn_1_N = mkN "kanvasduk" ;
  kapp_nn_1_N = mkN "kapp" ;
  kapprock_nn_1_N = mkN "kapprock" ;
  kappseglingsbaat_nn_1_1_N = mkN "kappseglingsbåt" ;
  kappsaeck_nn_1_1_N = mkN "kappsäck" ;
  kapsel_nn_1_N = mkN "kapsel" ;
  karamellpudding_nn_1_N = mkN "karamellpudding" ;
  karatstaempel_nn_1_1_N = mkN "karatstämpel" ;
  karbunkel_nn_1_N = mkN "karbunkel" ;
  kardanaxel_nn_1_N = mkN "kardanaxel" ;
  kardinalbiskop_nn_1_N = mkN "kardinalbiskop" ;
  kardnubb_nn_1_N = mkN "kardnubb" ;
  karljohanssvamp_nn_1_N = mkN "karljohanssvamp" ;
  karlslok_nn_1_N = mkN "karlslok" ;
  karm_nn_1_N = mkN "karm" ;
  karp_nn_1_N = mkN "karp" ;
  karpfisk_nn_1_N = mkN "karpfisk" ;
  kartnagel_nn_1_N = mkN "kartnagel" ;
  karusellhaest_nn_1_1_N = mkN "karusellhäst" ;
  kaschmirsjal_nn_1_N = mkN "kaschmirsjal" ;
  kaserngaard_nn_1_1_N = mkN "kaserngård" ;
  kashmirsjal_nn_1_N = mkN "kashmirsjal" ;
  kask_nn_1_N = mkN "kask" ;
  kasperteater_nn_1_N = mkN "kasperteater" ;
  kateder_nn_1_N = mkN "kateder" ;
  kateter_nn_1_N = mkN "kateter" ;
  kattass_nn_1_N = mkN "kattass" ;
  kattfisk_nn_1_N = mkN "kattfisk" ;
  kautschuk_nn_1_N = mkN "kautschuk" ;
  kavaljersflygel_nn_1_N = mkN "kavaljersflygel" ;
  kavel_nn_1_N = mkN "kavel" ;
  kavring_nn_1_N = mkN "kavring" ;
  kedjebroms_nn_1_N = mkN "kedjebroms" ;
  kedjevaexel_nn_1_1_N = mkN "kedjeväxel" ;
  kejsarhaer_nn_1_1_N = mkN "kejsarhär" ;
  kelgris_nn_1_N = mkN "kelgris" ;
  kennel_nn_1_N = mkN "kennel" ;
  kenning_nn_1_N = mkN "kenning" ;
  keps_nn_1_N = mkN "keps" ;
  kick_nn_1_N = mkN "kick" ;
  kikkran_nn_1_N = mkN "kikkran" ;
  kil_nn_1_N = mkN "kil" ;
  kilhael_nn_1_1_N = mkN "kilhäl" ;
  kilklack_nn_1_N = mkN "kilklack" ;
  killing_nn_1_N = mkN "killing" ;
  kilt_nn_1_N = mkN "kilt" ;
  kindpuss_nn_1_N = mkN "kindpuss" ;
  kindpust_nn_1_N = mkN "kindpust" ;
  kink_nn_1_N = mkN "kink" ;
  kip_nn_1_N = mkN "kip" ;
  kis_nn_2_N = mkN "kis" ;
  kissemiss_nn_1_N = mkN "kissemiss" ;
  kittel_nn_1_N = mkN "kittel" ;
  kitteldal_nn_1_N = mkN "kitteldal" ;
  kjol_nn_1_N = mkN "kjol" ;
  kjortel_nn_1_N = mkN "kjortel" ;
  klabb_nn_1_N = mkN "klabb" ;
  klabbskoet_nn_1_1_N = mkN "klabbsköt" ;
  klack_nn_1_N = mkN "klack" ;
  klackstoevel_nn_1_1_N = mkN "klackstövel" ;
  kladd_nn_1_N = mkN "kladd" ;
  klaff_nn_1_N = mkN "klaff" ;
  klagomur_nn_1_N = mkN "klagomur" ;
  klamp_nn_1_N = mkN "klamp" ;
  klant_nn_1_N = mkN "klant" ;
  klapp_nn_1_N = mkN "klapp" ;
  klatsch_nn_1_N = mkN "klatsch" ;
  klibbal_nn_1_N = mkN "klibbal" ;
  klick_nn_1_N = mkN "klick" ;
  klimax_nn_1_N = mkN "klimax" ;
  klimp_nn_1_N = mkN "klimp" ;
  klippdass_nn_1_N = mkN "klippdass" ;
  klipper_nn_1_N = mkN "klipper" ;
  klipperstaev_nn_1_1_N = mkN "klipperstäv" ;
  klippfisk_nn_1_N = mkN "klippfisk" ;
  klippfyr_nn_1_N = mkN "klippfyr" ;
  klipping_nn_1_N = mkN "klipping" ;
  klippspik_nn_1_N = mkN "klippspik" ;
  klippvaegg_nn_1_1_N = mkN "klippvägg" ;
  klitoris_nn_1_N = mkN "klitoris" ;
  klockboj_nn_1_N = mkN "klockboj" ;
  klockstapel_nn_1_N = mkN "klockstapel" ;
  klockstraeng_nn_1_1_N = mkN "klocksträng" ;
  kloss_nn_1_N = mkN "kloss" ;
  klostersyster_nn_1_N = mkN "klostersyster" ;
  klotblixt_nn_1_N = mkN "klotblixt" ;
  klots_nn_1_N = mkN "klots" ;
  klubb_nn_1_N = mkN "klubb" ;
  klubbsandwich_nn_1_N = mkN "klubbsandwich" ;
  kludd_nn_2_N = mkN "kludd" ;
  klump_nn_1_N = mkN "klump" ;
  klumpedump_nn_1_N = mkN "klumpedump" ;
  klumpeduns_nn_1_N = mkN "klumpeduns" ;
  klumpfisk_nn_1_N = mkN "klumpfisk" ;
  klunk_nn_1_N = mkN "klunk" ;
  kluns_nn_1_N = mkN "kluns" ;
  kluring_nn_1_N = mkN "kluring" ;
  klut_nn_1_N = mkN "klut" ;
  klyv_nn_1_N = mkN "klyv" ;
  klaedespersedel_nn_1_1_N = mkN "klädespersedel" ;
  klaedmal_nn_1_1_N = mkN "klädmal" ;
  klaedsel_nn_1_1_N = mkN "klädsel" ;
  klaepp_nn_1_1_N = mkN "kläpp" ;
  klaett_nn_1_1_N = mkN "klätt" ;
  klaetterfaagel_nn_1_1_N = mkN "klätterfågel" ;
  kloev_nn_1_1_N = mkN "klöv" ;
  kloevjesadel_nn_1_1_N = mkN "klövjesadel" ;
  kloevsadel_nn_1_1_N = mkN "klövsadel" ;
  knackvurst_nn_1_N = mkN "knackvurst" ;
  knall_nn_1_N = mkN "knall" ;
  knap_nn_1_N = mkN "knap" ;
  knapp_nn_1_N = mkN "knapp" ;
  knarkarkvart_nn_1_N = mkN "knarkarkvart" ;
  knarr_nn_2_N = mkN "knarr" ;
  knast_nn_1_N = mkN "knast" ;
  knatting_nn_1_N = mkN "knatting" ;
  knekt_nn_1_N = mkN "knekt" ;
  knick_nn_1_N = mkN "knick" ;
  kniv_nn_1_N = mkN "kniv" ;
  knivbroms_nn_1_N = mkN "knivbroms" ;
  knivrygg_nn_1_N = mkN "knivrygg" ;
  knivsrygg_nn_1_N = mkN "knivsrygg" ;
  knivsudd_nn_1_N = mkN "knivsudd" ;
  knix_nn_1_N = mkN "knix" ;
  knodd_nn_1_N = mkN "knodd" ;
  knop_nn_1_N = mkN "knop" ;
  knopp_nn_1_N = mkN "knopp" ;
  knorr_nn_1_N = mkN "knorr" ;
  knot_nn_1_N = mkN "knot" ;
  knubbsael_nn_1_1_N = mkN "knubbsäl" ;
  knuff_nn_1_N = mkN "knuff" ;
  knut_nn_1_N = mkN "knut" ;
  knyck_nn_1_N = mkN "knyck" ;
  knytblus_nn_1_N = mkN "knytblus" ;
  knaeck_nn_1_1_N = mkN "knäck" ;
  knaeckepil_nn_1_1_N = mkN "knäckepil" ;
  knaehund_nn_1_1_N = mkN "knähund" ;
  knaepp_nn_1_1_N = mkN "knäpp" ;
  knaeskaal_nn_1_1_N = mkN "knäskål" ;
  knaetofs_nn_1_1_N = mkN "knätofs" ;
  knaevelborr_nn_1_1_N = mkN "knävelborr" ;
  knaevring_nn_1_1_N = mkN "knävring" ;
  knoedel_nn_1_1_N = mkN "knödel" ;
  knoel_nn_1_1_N = mkN "knöl" ;
  knoelpaak_nn_1_1_N = mkN "knölpåk" ;
  knoelsvan_nn_1_1_N = mkN "knölsvan" ;
  knoes_nn_1_1_N = mkN "knös" ;
  koaxialkabel_nn_1_N = mkN "koaxialkabel" ;
  kobbel_nn_1_N = mkN "kobbel" ;
  kock_nn_1_N = mkN "kock" ;
  kodex_nn_1_N = mkN "kodex" ;
  koff_nn_1_N = mkN "koff" ;
  koffernagel_nn_1_N = mkN "koffernagel" ;
  koffert_nn_1_N = mkN "koffert" ;
  koffertfisk_nn_1_N = mkN "koffertfisk" ;
  kogg_nn_1_N = mkN "kogg" ;
  kohud_nn_1_N = mkN "kohud" ;
  kokalv_nn_1_N = mkN "kokalv" ;
  kokbarometer_nn_1_N = mkN "kokbarometer" ;
  kokgrop_nn_1_N = mkN "kokgrop" ;
  kokvagn_nn_1_N = mkN "kokvagn" ;
  kolbox_nn_1_N = mkN "kolbox" ;
  kolerakyrkogaard_nn_1_1_N = mkN "kolerakyrkogård" ;
  koling_nn_1_N = mkN "koling" ;
  koll_nn_1_N = mkN "koll" ;
  kolryss_nn_1_N = mkN "kolryss" ;
  kolt_nn_1_N = mkN "kolt" ;
  koltrast_nn_1_N = mkN "koltrast" ;
  kolumntitel_nn_1_N = mkN "kolumntitel" ;
  kolv_nn_1_N = mkN "kolv" ;
  kolvhals_nn_1_N = mkN "kolvhals" ;
  komissmantel_nn_1_N = mkN "komissmantel" ;
  komminister_nn_1_N = mkN "komminister" ;
  kommunikationsminister_nn_1_N = mkN "kommunikationsminister" ;
  kompassnaal_nn_1_1_N = mkN "kompassnål" ;
  kompis_nn_1_N = mkN "kompis" ;
  komplementvinkel_nn_1_N = mkN "komplementvinkel" ;
  koncentrationsdag_nn_1_N = mkN "koncentrationsdag" ;
  konfektskaal_nn_1_1_N = mkN "konfektskål" ;
  konfirmationsbibel_nn_1_N = mkN "konfirmationsbibel" ;
  konjakskrans_nn_1_N = mkN "konjakskrans" ;
  konprick_nn_1_N = mkN "konprick" ;
  konstapel_nn_1_N = mkN "konstapel" ;
  konsthall_nn_1_N = mkN "konsthall" ;
  konstnaerskrets_nn_1_1_N = mkN "konstnärskrets" ;
  konstnaerssjael_nn_1_1_N = mkN "konstnärssjäl" ;
  kontinentalsockel_nn_1_N = mkN "kontinentalsockel" ;
  kontorsslav_nn_1_N = mkN "kontorsslav" ;
  kontraalt_nn_1_N = mkN "kontraalt" ;
  kontrabas_nn_1_N = mkN "kontrabas" ;
  kontraktsprost_nn_1_N = mkN "kontraktsprost" ;
  kontrollstaempel_nn_1_1_N = mkN "kontrollstämpel" ;
  konventikel_nn_1_N = mkN "konventikel" ;
  konverter_nn_1_N = mkN "konverter" ;
  koordinataxel_nn_1_N = mkN "koordinataxel" ;
  kopiesvarv_nn_1_N = mkN "kopiesvarv" ;
  kopp_nn_1_N = mkN "kopp" ;
  kopparorm_nn_1_N = mkN "kopparorm" ;
  kopparplaat_nn_1_1_N = mkN "kopparplåt" ;
  korallorm_nn_1_N = mkN "korallorm" ;
  korg_nn_1_N = mkN "korg" ;
  kork_nn_1_N = mkN "kork" ;
  korkek_nn_1_N = mkN "korkek" ;
  korkskruv_nn_1_N = mkN "korkskruv" ;
  kornblixt_nn_1_N = mkN "kornblixt" ;
  kornbod_nn_1_N = mkN "kornbod" ;
  kornknarr_nn_1_N = mkN "kornknarr" ;
  kornaaker_nn_1_1_N = mkN "kornåker" ;
  korp_nn_1_N = mkN "korp" ;
  korsettfjaeder_nn_1_1_N = mkN "korsettfjäder" ;
  korsnaebb_nn_1_1_N = mkN "korsnäbb" ;
  korsrygg_nn_1_N = mkN "korsrygg" ;
  korsspindel_nn_1_N = mkN "korsspindel" ;
  korsvimpel_nn_1_N = mkN "korsvimpel" ;
  korv_nn_1_N = mkN "korv" ;
  korvmoj_nn_1_N = mkN "korvmoj" ;
  korvsmoergaas_nn_1_1_N = mkN "korvsmörgås" ;
  koster_nn_1_N = mkN "koster" ;
  kosvans_nn_1_N = mkN "kosvans" ;
  kotlettfisk_nn_1_N = mkN "kotlettfisk" ;
  kpist_nn_1_N = mkN "kpist" ;
  kraftkarl_nn_1_N = mkN "kraftkarl" ;
  kraftmejsel_nn_1_N = mkN "kraftmejsel" ;
  kraftpartikel_nn_1_N = mkN "kraftpartikel" ;
  kragsnibb_nn_1_N = mkN "kragsnibb" ;
  kragstoevel_nn_1_1_N = mkN "kragstövel" ;
  krakmandel_nn_1_N = mkN "krakmandel" ;
  kram_nn_1_N = mkN "kram" ;
  kramsfaagel_nn_1_1_N = mkN "kramsfågel" ;
  kran_nn_1_N = mkN "kran" ;
  kranbalk_nn_1_N = mkN "kranbalk" ;
  krankik_nn_1_N = mkN "krankik" ;
  krans_nn_1_N = mkN "krans" ;
  krater_nn_1_N = mkN "krater" ;
  krats_nn_1_N = mkN "krats" ;
  krets_nn_1_N = mkN "krets" ;
  krevadblixt_nn_1_N = mkN "krevadblixt" ;
  krigsbuss_nn_1_N = mkN "krigsbuss" ;
  kris_nn_2_N = mkN "kris" ;
  kristallaxel_nn_1_N = mkN "kristallaxel" ;
  kristallskaal_nn_1_1_N = mkN "kristallskål" ;
  kristtorn_nn_1_N = mkN "kristtorn" ;
  kritikstorm_nn_1_N = mkN "kritikstorm" ;
  krock_nn_1_N = mkN "krock" ;
  krog_nn_1_N = mkN "krog" ;
  krok_nn_1_N = mkN "krok" ;
  kroksabel_nn_1_N = mkN "kroksabel" ;
  krokus_nn_1_N = mkN "krokus" ;
  kronbrud_nn_1_N = mkN "kronbrud" ;
  kronhjort_nn_1_N = mkN "kronhjort" ;
  kronhaest_nn_1_1_N = mkN "kronhäst" ;
  kronmutter_nn_1_N = mkN "kronmutter" ;
  kronojord_nn_1_N = mkN "kronojord" ;
  kronometer_nn_1_N = mkN "kronometer" ;
  kronprins_nn_1_N = mkN "kronprins" ;
  kroppaas_nn_1_1_N = mkN "kroppås" ;
  kross_nn_1_N = mkN "kross" ;
  krumstav_nn_1_N = mkN "krumstav" ;
  krustaatel_nn_1_1_N = mkN "kruståtel" ;
  krutdurk_nn_1_N = mkN "krutdurk" ;
  krympling_nn_1_N = mkN "krympling" ;
  krypskytt_nn_1_N = mkN "krypskytt" ;
  kryssmejsel_nn_1_N = mkN "kryssmejsel" ;
  kryssningsrobot_nn_1_N = mkN "kryssningsrobot" ;
  kraeftbur_nn_1_1_N = mkN "kräftbur" ;
  kraeklatjuv_nn_1_1_N = mkN "kräklatjuv" ;
  kraakfaagel_nn_1_1_N = mkN "kråkfågel" ;
  kraasnaal_nn_1_1_N = mkN "kråsnål" ;
  kroek_nn_1_1_N = mkN "krök" ;
  kroesus_nn_1_1_N = mkN "krösus" ;
  kubb_nn_1_N = mkN "kubb" ;
  kuf_nn_1_N = mkN "kuf" ;
  kuggvaexel_nn_1_1_N = mkN "kuggväxel" ;
  kuk_nn_1_N = mkN "kuk" ;
  kuling_nn_1_N = mkN "kuling" ;
  kulkvarn_nn_1_N = mkN "kulkvarn" ;
  kull_nn_1_N = mkN "kull" ;
  kult_nn_2_N = mkN "kult" ;
  kulting_nn_1_N = mkN "kulting" ;
  kulturartikel_nn_1_N = mkN "kulturartikel" ;
  kulturkrets_nn_1_N = mkN "kulturkrets" ;
  kulvert_nn_1_N = mkN "kulvert" ;
  kundkrets_nn_1_N = mkN "kundkrets" ;
  kundvagn_nn_1_N = mkN "kundvagn" ;
  kungatitel_nn_1_N = mkN "kungatitel" ;
  kungsfaagel_nn_1_1_N = mkN "kungsfågel" ;
  kungshoeg_nn_1_1_N = mkN "kungshög" ;
  kungstiger_nn_1_N = mkN "kungstiger" ;
  kur_nn_2_N = mkN "kur" ;
  kusk_nn_1_N = mkN "kusk" ;
  kuskbock_nn_1_N = mkN "kuskbock" ;
  kustfisk_nn_1_N = mkN "kustfisk" ;
  kut_nn_1_N = mkN "kut" ;
  kutter_nn_2_N = mkN "kutter" ;
  kutting_nn_1_N = mkN "kutting" ;
  kvader_nn_1_N = mkN "kvader" ;
  kvark_nn_1_N = mkN "kvark" ;
  kvarkklimp_nn_1_N = mkN "kvarkklimp" ;
  kvarn_nn_1_N = mkN "kvarn" ;
  kvart_nn_3_N = mkN "kvart" ;
  kvarting_nn_1_N = mkN "kvarting" ;
  kvass_nn_1_N = mkN "kvass" ;
  kvast_nn_1_N = mkN "kvast" ;
  kvastfening_nn_1_N = mkN "kvastfening" ;
  kvastprick_nn_1_N = mkN "kvastprick" ;
  kvigkalv_nn_1_N = mkN "kvigkalv" ;
  kvist_nn_1_N = mkN "kvist" ;
  kvaell_nn_1_1_N = mkN "kväll" ;
  kyckling_nn_1_N = mkN "kyckling" ;
  kyl_nn_1_N = mkN "kyl" ;
  kylbox_nn_1_N = mkN "kylbox" ;
  kyldisk_nn_1_N = mkN "kyldisk" ;
  kylklamp_nn_1_N = mkN "kylklamp" ;
  kyp_nn_1_N = mkN "kyp" ;
  kypert_nn_1_N = mkN "kypert" ;
  kyrkbibel_nn_1_N = mkN "kyrkbibel" ;
  kyrkbaenk_nn_1_1_N = mkN "kyrkbänk" ;
  kyrkobibel_nn_1_N = mkN "kyrkobibel" ;
  kyrkogaard_nn_1_1_N = mkN "kyrkogård" ;
  kyrkstoet_nn_1_1_N = mkN "kyrkstöt" ;
  kyrktupp_nn_1_N = mkN "kyrktupp" ;
  kyrkvaerd_nn_1_1_N = mkN "kyrkvärd" ;
  kyss_nn_1_N = mkN "kyss" ;
  kaeft_nn_1_1_N = mkN "käft" ;
  kaegel_nn_1_1_N = mkN "kägel" ;
  kael_nn_1_1_N = mkN "käl" ;
  kaellarhals_nn_1_1_N = mkN "källarhals" ;
  kaelling_nn_1_1_N = mkN "källing" ;
  kaempagrav_nn_1_1_N = mkN "kämpagrav" ;
  kaempalek_nn_1_1_N = mkN "kämpalek" ;
  kaendis_nn_1_1_N = mkN "kändis" ;
  kaengurupung_nn_1_1_N = mkN "kängurupung" ;
  kaenning_nn_1_1_N = mkN "känning" ;
  kaenslostraeng_nn_1_1_N = mkN "känslosträng" ;
  kaepp_nn_1_1_N = mkN "käpp" ;
  kaepphaest_nn_1_1_N = mkN "käpphäst" ;
  kaering_nn_1_1_N = mkN "käring" ;
  kaeringknop_nn_1_1_N = mkN "käringknop" ;
  kaerlekstunnel_nn_1_1_N = mkN "kärlekstunnel" ;
  kaernpartikel_nn_1_1_N = mkN "kärnpartikel" ;
  kaernstridsspets_nn_1_1_N = mkN "kärnstridsspets" ;
  kaerrhoek_nn_1_1_N = mkN "kärrhök" ;
  kaerring_nn_1_1_N = mkN "kärring" ;
  kaetting_nn_1_1_N = mkN "kätting" ;
  kaettingdiameter_nn_1_1_N = mkN "kättingdiameter" ;
  kaak_nn_1_1_N = mkN "kåk" ;
  kaallapp_nn_1_1_N = mkN "kållapp" ;
  kaalmask_nn_1_1_N = mkN "kålmask" ;
  kaarpamp_nn_1_1_N = mkN "kårpamp" ;
  koeckenmoedding_nn_1_1_N = mkN "köckenmödding" ;
  koekkenmoedding_nn_1_1_N = mkN "kökkenmödding" ;
  koekshandduk_nn_1_1_N = mkN "kökshandduk" ;
  koekssax_nn_1_1_N = mkN "kökssax" ;
  koeksspis_nn_1_1_N = mkN "köksspis" ;
  koel_nn_1_1_N = mkN "köl" ;
  koeldknaepp_nn_1_1_N = mkN "köldknäpp" ;
  koenskoertel_nn_1_1_N = mkN "könskörtel" ;
  koeping_nn_1_1_N = mkN "köping" ;
  koerkarl_nn_1_1_N = mkN "körkarl" ;
  koertel_nn_1_1_N = mkN "körtel" ;
  koettbullssmoergaas_nn_1_1_N = mkN "köttbullssmörgås" ;
  lab_nn_1_N = mkN "lab" ;
  labb_nn_1_N = mkN "labb" ;
  laboratorierock_nn_1_N = mkN "laboratorierock" ;
  lackpensel_nn_1_N = mkN "lackpensel" ;
  lag_nn_1_N = mkN "lag" ;
  lagbalk_nn_1_N = mkN "lagbalk" ;
  lager_nn_2_N = mkN "lager" ;
  lagerbox_nn_1_N = mkN "lagerbox" ;
  lagerkrans_nn_1_N = mkN "lagerkrans" ;
  lagg_nn_1_N = mkN "lagg" ;
  lagkarl_nn_1_N = mkN "lagkarl" ;
  lakansspets_nn_1_N = mkN "lakansspets" ;
  lammsadel_nn_1_N = mkN "lammsadel" ;
  lampskaerm_nn_1_1_N = mkN "lampskärm" ;
  landborg_nn_1_N = mkN "landborg" ;
  landis_nn_1_N = mkN "landis" ;
  landnot_nn_1_N = mkN "landnot" ;
  landrygg_nn_1_N = mkN "landrygg" ;
  landshoevding_nn_1_1_N = mkN "landshövding" ;
  landsknekt_nn_1_N = mkN "landsknekt" ;
  landsvaegsbuss_nn_1_1_N = mkN "landsvägsbuss" ;
  landvad_nn_1_N = mkN "landvad" ;
  langos_nn_1_N = mkN "langos" ;
  lans_nn_1_N = mkN "lans" ;
  lansettfisk_nn_1_N = mkN "lansettfisk" ;
  lantdag_nn_1_N = mkN "lantdag" ;
  lanthandel_nn_1_N = mkN "lanthandel" ;
  lantis_nn_1_N = mkN "lantis" ;
  lantmarskalk_nn_1_N = mkN "lantmarskalk" ;
  lantrasgris_nn_1_N = mkN "lantrasgris" ;
  lapp_nn_1_N = mkN "lapp" ;
  lapphund_nn_1_N = mkN "lapphund" ;
  lapplandsgran_nn_1_N = mkN "lapplandsgran" ;
  lappsparv_nn_1_N = mkN "lappsparv" ;
  lapsus_nn_1_N = mkN "lapsus" ;
  larver_nn_1_N = mkN "larver" ;
  laser_nn_1_N = mkN "laser" ;
  lask_nn_1_N = mkN "lask" ;
  lastpall_nn_1_N = mkN "lastpall" ;
  lathund_nn_1_N = mkN "lathund" ;
  latmask_nn_1_N = mkN "latmask" ;
  lav_nn_1_N = mkN "lav" ;
  lavendeltvaal_nn_1_1_N = mkN "lavendeltvål" ;
  lavinhund_nn_1_N = mkN "lavinhund" ;
  lax_nn_1_N = mkN "lax" ;
  laxfisk_nn_1_N = mkN "laxfisk" ;
  laxgaard_nn_1_1_N = mkN "laxgård" ;
  laxstjaert_nn_1_1_N = mkN "laxstjärt" ;
  laxoering_nn_1_1_N = mkN "laxöring" ;
  leasing_nn_1_N = mkN "leasing" ;
  ledarhund_nn_1_N = mkN "ledarhund" ;
  ledfyr_nn_1_N = mkN "ledfyr" ;
  ledkapsel_nn_1_N = mkN "ledkapsel" ;
  ledskaal_nn_1_1_N = mkN "ledskål" ;
  legoknekt_nn_1_N = mkN "legoknekt" ;
  lejd_nn_1_N = mkN "lejd" ;
  lejdbaat_nn_1_1_N = mkN "lejdbåt" ;
  lejongrop_nn_1_N = mkN "lejongrop" ;
  lek_nn_1_N = mkN "lek" ;
  lekfisk_nn_1_N = mkN "lekfisk" ;
  leksakshaest_nn_1_1_N = mkN "leksakshäst" ;
  lercylinder_nn_1_N = mkN "lercylinder" ;
  lergoek_nn_1_1_N = mkN "lergök" ;
  lerhaerd_nn_1_1_N = mkN "lerhärd" ;
  lerjord_nn_1_N = mkN "lerjord" ;
  lerskiffer_nn_1_N = mkN "lerskiffer" ;
  leraaker_nn_1_1_N = mkN "leråker" ;
  lev_nn_1_N = mkN "lev" ;
  lever_nn_1_N = mkN "lever" ;
  leverflaeck_nn_1_1_N = mkN "leverfläck" ;
  leverpastejsmoergaas_nn_1_1_N = mkN "leverpastejsmörgås" ;
  levnadsaalder_nn_1_1_N = mkN "levnadsålder" ;
  lieknagg_nn_1_N = mkN "lieknagg" ;
  liggvagn_nn_1_N = mkN "liggvagn" ;
  liguster_nn_1_N = mkN "liguster" ;
  likflaeck_nn_1_1_N = mkN "likfläck" ;
  liksvamp_nn_1_N = mkN "liksvamp" ;
  liktorn_nn_1_N = mkN "liktorn" ;
  lillasyster_nn_1_N = mkN "lillasyster" ;
  lillaxel_nn_1_N = mkN "lillaxel" ;
  lillfinger_nn_1_N = mkN "lillfinger" ;
  lillfingertopp_nn_1_N = mkN "lillfingertopp" ;
  lillsemester_nn_1_N = mkN "lillsemester" ;
  limerick_nn_1_N = mkN "limerick" ;
  limgoerdel_nn_1_1_N = mkN "limgördel" ;
  lind_nn_1_N = mkN "lind" ;
  lindorm_nn_1_N = mkN "lindorm" ;
  linlugg_nn_1_N = mkN "linlugg" ;
  linsdiameter_nn_1_N = mkN "linsdiameter" ;
  lintott_nn_1_N = mkN "lintott" ;
  linaaker_nn_1_1_N = mkN "linåker" ;
  lipsill_nn_1_N = mkN "lipsill" ;
  liter_nn_2_N = mkN "liter" ;
  livboj_nn_1_N = mkN "livboj" ;
  livbaat_nn_1_1_N = mkN "livbåt" ;
  livmoderhals_nn_1_N = mkN "livmoderhals" ;
  livslust_nn_1_N = mkN "livslust" ;
  ljudbang_nn_1_N = mkN "ljudbang" ;
  ljudboj_nn_1_N = mkN "ljudboj" ;
  ljugarbaenk_nn_1_1_N = mkN "ljugarbänk" ;
  ljusblixt_nn_1_N = mkN "ljusblixt" ;
  ljusbrunn_nn_1_N = mkN "ljusbrunn" ;
  ljusglimt_nn_1_N = mkN "ljusglimt" ;
  ljusgaard_nn_1_1_N = mkN "ljusgård" ;
  ljuskrans_nn_1_N = mkN "ljuskrans" ;
  ljuskrets_nn_1_N = mkN "ljuskrets" ;
  ljusorgel_nn_1_N = mkN "ljusorgel" ;
  ljuspartikel_nn_1_N = mkN "ljuspartikel" ;
  ljusrektangel_nn_1_N = mkN "ljusrektangel" ;
  lobb_nn_1_N = mkN "lobb" ;
  lock_nn_1_N = mkN "lock" ;
  lockfaagel_nn_1_1_N = mkN "lockfågel" ;
  lodenrock_nn_1_N = mkN "lodenrock" ;
  lodis_nn_1_N = mkN "lodis" ;
  loftbod_nn_1_N = mkN "loftbod" ;
  logg_nn_1_N = mkN "logg" ;
  loggert_nn_1_N = mkN "loggert" ;
  look_nn_1_N = mkN "look" ;
  loop_nn_1_N = mkN "loop" ;
  looping_nn_1_N = mkN "looping" ;
  loppcirkus_nn_1_N = mkN "loppcirkus" ;
  loppis_nn_1_N = mkN "loppis" ;
  lort_nn_1_N = mkN "lort" ;
  lots_nn_1_N = mkN "lots" ;
  lottsedel_nn_1_N = mkN "lottsedel" ;
  lotus_nn_1_N = mkN "lotus" ;
  lov_nn_1_N = mkN "lov" ;
  lubb_nn_1_N = mkN "lubb" ;
  luciakrans_nn_1_N = mkN "luciakrans" ;
  luftgrop_nn_1_N = mkN "luftgrop" ;
  luftpropeller_nn_1_N = mkN "luftpropeller" ;
  luftsluss_nn_1_N = mkN "luftsluss" ;
  luftspaerr_nn_1_1_N = mkN "luftspärr" ;
  luftsaeck_nn_1_1_N = mkN "luftsäck" ;
  luftvaernsrobot_nn_1_1_N = mkN "luftvärnsrobot" ;
  lugg_nn_1_N = mkN "lugg" ;
  lumparkompis_nn_1_N = mkN "lumparkompis" ;
  lumpfisk_nn_1_N = mkN "lumpfisk" ;
  lungfisk_nn_1_N = mkN "lungfisk" ;
  lungsaeck_nn_1_1_N = mkN "lungsäck" ;
  lunnefaagel_nn_1_1_N = mkN "lunnefågel" ;
  luns_nn_1_N = mkN "luns" ;
  lur_nn_1_N = mkN "lur" ;
  lurifax_nn_1_N = mkN "lurifax" ;
  lurk_nn_1_N = mkN "lurk" ;
  luskung_nn_1_N = mkN "luskung" ;
  luspudel_nn_1_N = mkN "luspudel" ;
  lust_nn_1_N = mkN "lust" ;
  lustgaard_nn_1_1_N = mkN "lustgård" ;
  lut_nn_1_N = mkN "lut" ;
  lutfisk_nn_1_N = mkN "lutfisk" ;
  luv_nn_1_N = mkN "luv" ;
  luxmeter_nn_1_N = mkN "luxmeter" ;
  lyckoslant_nn_1_N = mkN "lyckoslant" ;
  lycktraeff_nn_1_1_N = mkN "lyckträff" ;
  lydkonung_nn_1_N = mkN "lydkonung" ;
  lydkung_nn_1_N = mkN "lydkung" ;
  lyftkran_nn_1_N = mkN "lyftkran" ;
  lyftsax_nn_1_N = mkN "lyftsax" ;
  lymfkoertel_nn_1_1_N = mkN "lymfkörtel" ;
  lyrfaagel_nn_1_1_N = mkN "lyrfågel" ;
  lyrtorsk_nn_1_N = mkN "lyrtorsk" ;
  lysboj_nn_1_N = mkN "lysboj" ;
  lysmask_nn_1_N = mkN "lysmask" ;
  lyxartikel_nn_1_N = mkN "lyxartikel" ;
  lyxsmoergaas_nn_1_1_N = mkN "lyxsmörgås" ;
  langos_nn_1_1_N = mkN "lángos" ;
  laederlapp_nn_1_1_N = mkN "läderlapp" ;
  laegel_nn_1_1_N = mkN "lägel" ;
  laegerboedel_nn_1_1_N = mkN "lägerbödel" ;
  laegg_nn_2_1_N = mkN "lägg" ;
  laekarrock_nn_1_1_N = mkN "läkarrock" ;
  laengdaxel_nn_1_1_N = mkN "längdaxel" ;
  laengsdal_nn_1_1_N = mkN "längsdal" ;
  laenk_nn_1_1_N = mkN "länk" ;
  laens_nn_1_1_N = mkN "läns" ;
  laepp_nn_1_1_N = mkN "läpp" ;
  laerk_nn_1_1_N = mkN "lärk" ;
  laerkfalk_nn_1_1_N = mkN "lärkfalk" ;
  laerostol_nn_1_1_N = mkN "lärostol" ;
  laerpeng_nn_1_1_N = mkN "lärpeng" ;
  laesarstorm_nn_1_1_N = mkN "läsarstorm" ;
  laesdag_nn_1_1_N = mkN "läsdag" ;
  laesecirkel_nn_1_1_N = mkN "läsecirkel" ;
  laesekrets_nn_1_1_N = mkN "läsekrets" ;
  laettgrogg_nn_1_1_N = mkN "lättgrogg" ;
  laetting_nn_1_1_N = mkN "lätting" ;
  laettjord_nn_1_1_N = mkN "lättjord" ;
  laettkloev_nn_1_1_N = mkN "lättklöv" ;
  laettviktsmotorcykel_nn_1_1_N = mkN "lättviktsmotorcykel" ;
  laadspik_nn_1_1_N = mkN "lådspik" ;
  laagsniff_nn_1_1_N = mkN "lågsniff" ;
  laangduk_nn_1_1_N = mkN "långduk" ;
  laangfinger_nn_1_1_N = mkN "långfinger" ;
  laangfredag_nn_1_1_N = mkN "långfredag" ;
  laangfaerdsbuss_nn_1_1_N = mkN "långfärdsbuss" ;
  laanggrogg_nn_1_1_N = mkN "långgrogg" ;
  laangnaebb_nn_1_1_N = mkN "långnäbb" ;
  laangrev_nn_1_1_N = mkN "långrev" ;
  laangschal_nn_1_1_N = mkN "långschal" ;
  laangsjal_nn_1_1_N = mkN "långsjal" ;
  laar_nn_2_1_N = mkN "lår" ;
  laarbenshals_nn_1_1_N = mkN "lårbenshals" ;
  laarding_nn_1_1_N = mkN "lårding" ;
  laaring_nn_1_1_N = mkN "låring" ;
  laaskolv_nn_1_1_N = mkN "låskolv" ;
  laasmutter_nn_1_1_N = mkN "låsmutter" ;
  laassprint_nn_1_1_N = mkN "låssprint" ;
  laat_nn_1_1_N = mkN "låt" ;
  loedfog_nn_1_1_N = mkN "lödfog" ;
  loedkolv_nn_1_1_N = mkN "lödkolv" ;
  loegnhals_nn_1_1_N = mkN "lögnhals" ;
  loek_nn_1_1_N = mkN "lök" ;
  loekknopp_nn_1_1_N = mkN "lökknopp" ;
  loenn_nn_1_1_N = mkN "lönn" ;
  loepeost_nn_1_1_N = mkN "löpeost" ;
  loepgrav_nn_1_1_N = mkN "löpgrav" ;
  loepost_nn_1_1_N = mkN "löpost" ;
  loepsedel_nn_1_1_N = mkN "löpsedel" ;
  loepvagn_nn_1_1_N = mkN "löpvagn" ;
  loerdageftermiddag_nn_1_1_N = mkN "lördageftermiddag" ;
  loerdagkvaell_nn_1_1_N = mkN "lördagkväll" ;
  loerdagseftermiddag_nn_1_1_N = mkN "lördagseftermiddag" ;
  loerdagskvaell_nn_1_1_N = mkN "lördagskväll" ;
  loesenpenning_nn_1_1_N = mkN "lösenpenning" ;
  loesenskilling_nn_1_1_N = mkN "lösenskilling" ;
  loesepenning_nn_1_1_N = mkN "lösepenning" ;
  loeseskilling_nn_1_1_N = mkN "löseskilling" ;
  loeshaest_nn_1_1_N = mkN "löshäst" ;
  loeskekarl_nn_1_1_N = mkN "löskekarl" ;
  loeskerkarl_nn_1_1_N = mkN "löskerkarl" ;
  loesrygg_nn_1_1_N = mkN "lösrygg" ;
  loessjord_nn_1_1_N = mkN "lössjord" ;
  loesoegonfrans_nn_1_1_N = mkN "lösögonfrans" ;
  loet_nn_1_1_N = mkN "löt" ;
  loevbiff_nn_1_1_N = mkN "lövbiff" ;
  loevblaas_nn_1_1_N = mkN "lövblås" ;
  loevjord_nn_1_1_N = mkN "lövjord" ;
  loevmask_nn_1_1_N = mkN "lövmask" ;
  loevsmyg_nn_1_1_N = mkN "lövsmyg" ;
  mack_nn_1_N = mkN "mack" ;
  maffiaboss_nn_1_N = mkN "maffiaboss" ;
  maggoerdel_nn_1_1_N = mkN "maggördel" ;
  magister_nn_1_N = mkN "magister" ;
  maglev_nn_1_N = mkN "maglev" ;
  magnetnaal_nn_1_1_N = mkN "magnetnål" ;
  majbrud_nn_1_N = mkN "majbrud" ;
  majsgroet_nn_1_1_N = mkN "majsgröt" ;
  majskolv_nn_1_N = mkN "majskolv" ;
  makrill_nn_1_N = mkN "makrill" ;
  maktkrets_nn_1_N = mkN "maktkrets" ;
  mal_nn_1_N = mkN "mal" ;
  mall_nn_1_N = mkN "mall" ;
  malm_nn_1_N = mkN "malm" ;
  malmkropp_nn_1_N = mkN "malmkropp" ;
  malmkross_nn_1_N = mkN "malmkross" ;
  malmkoertel_nn_1_1_N = mkN "malmkörtel" ;
  malteserhund_nn_1_N = mkN "malteserhund" ;
  mammonstrael_nn_1_1_N = mkN "mammonsträl" ;
  mammut_nn_1_N = mkN "mammut" ;
  man_nn_2_N = mkN "man" ;
  mandel_nn_1_N = mkN "mandel" ;
  mandelpotatis_nn_1_N = mkN "mandelpotatis" ;
  mangel_nn_1_N = mkN "mangel" ;
  mannagrynsgroet_nn_1_1_N = mkN "mannagrynsgröt" ;
  mannalav_nn_1_N = mkN "mannalav" ;
  mannaaalder_nn_1_1_N = mkN "mannaålder" ;
  manometer_nn_1_N = mkN "manometer" ;
  mansgris_nn_1_N = mkN "mansgris" ;
  mansaalder_nn_1_1_N = mkN "mansålder" ;
  mantel_nn_1_N = mkN "mantel" ;
  mapp_nn_1_N = mkN "mapp" ;
  marinminister_nn_1_N = mkN "marinminister" ;
  marionetteater_nn_1_N = mkN "marionetteater" ;
  marskalk_nn_1_N = mkN "marskalk" ;
  marskalkstav_nn_1_N = mkN "marskalkstav" ;
  martall_nn_1_N = mkN "martall" ;
  marulk_nn_1_N = mkN "marulk" ;
  mas_nn_1_N = mkN "mas" ;
  maser_nn_1_N = mkN "maser" ;
  mask_nn_1_N = mkN "mask" ;
  maskinhall_nn_1_N = mkN "maskinhall" ;
  maskinpress_nn_1_N = mkN "maskinpress" ;
  master_nn_1_N = mkN "master" ;
  mastfisk_nn_1_N = mkN "mastfisk" ;
  mastkorg_nn_1_N = mkN "mastkorg" ;
  masugn_nn_1_N = mkN "masugn" ;
  masurbjoerk_nn_1_1_N = mkN "masurbjörk" ;
  matarbuss_nn_1_N = mkN "matarbuss" ;
  matbit_nn_1_N = mkN "matbit" ;
  matjessill_nn_1_N = mkN "matjessill" ;
  matjord_nn_1_N = mkN "matjord" ;
  matpotatis_nn_1_N = mkN "matpotatis" ;
  matrikel_nn_1_N = mkN "matrikel" ;
  matsedel_nn_1_N = mkN "matsedel" ;
  matsvamp_nn_1_N = mkN "matsvamp" ;
  matsaeck_nn_1_1_N = mkN "matsäck" ;
  matsaeckssmoergaas_nn_1_1_N = mkN "matsäckssmörgås" ;
  matvaruhall_nn_1_N = mkN "matvaruhall" ;
  maximitermometer_nn_1_N = mkN "maximitermometer" ;
  meander_nn_1_N = mkN "meander" ;
  medbrottsling_nn_1_N = mkN "medbrottsling" ;
  medeldistansrobot_nn_1_N = mkN "medeldistansrobot" ;
  medelaalder_nn_1_1_N = mkN "medelålder" ;
  medicinreporter_nn_1_N = mkN "medicinreporter" ;
  mediecirkus_nn_1_N = mkN "mediecirkus" ;
  medlemstapp_nn_1_N = mkN "medlemstapp" ;
  medsyster_nn_1_N = mkN "medsyster" ;
  medvurst_nn_1_N = mkN "medvurst" ;
  megaskraell_nn_1_1_N = mkN "megaskräll" ;
  mejlbox_nn_1_N = mkN "mejlbox" ;
  mejsel_nn_1_N = mkN "mejsel" ;
  mellankropp_nn_1_N = mkN "mellankropp" ;
  mellanspett_nn_1_N = mkN "mellanspett" ;
  mellanvaerd_nn_1_1_N = mkN "mellanvärd" ;
  mentometer_nn_1_N = mkN "mentometer" ;
  mercedes_nn_1_N = mkN "mercedes" ;
  meridiancirkel_nn_1_N = mkN "meridiancirkel" ;
  mes_nn_1_N = mkN "mes" ;
  mesfaagel_nn_1_1_N = mkN "mesfågel" ;
  mesost_nn_1_N = mkN "mesost" ;
  metallhandel_nn_1_N = mkN "metallhandel" ;
  metallsvarv_nn_1_N = mkN "metallsvarv" ;
  meteorkrater_nn_1_N = mkN "meteorkrater" ;
  meter_nn_2_N = mkN "meter" ;
  meterstav_nn_1_N = mkN "meterstav" ;
  metmask_nn_1_N = mkN "metmask" ;
  metrev_nn_1_N = mkN "metrev" ;
  metvurst_nn_1_N = mkN "metvurst" ;
  mick_nn_1_N = mkN "mick" ;
  mickel_nn_1_N = mkN "mickel" ;
  microvaagsugn_nn_1_1_N = mkN "microvågsugn" ;
  middagslur_nn_1_N = mkN "middagslur" ;
  midfastosoendag_nn_1_1_N = mkN "midfastosöndag" ;
  midnattssol_nn_1_N = mkN "midnattssol" ;
  midsommardag_nn_1_N = mkN "midsommardag" ;
  midvinter_nn_1_N = mkN "midvinter" ;
  migrationsminister_nn_1_N = mkN "migrationsminister" ;
  mikrometer_nn_1_N = mkN "mikrometer" ;
  mikrovaagsugn_nn_1_1_N = mkN "mikrovågsugn" ;
  militaerorkester_nn_1_1_N = mkN "militärorkester" ;
  miljoebov_nn_1_1_N = mkN "miljöbov" ;
  miljoeminister_nn_1_1_N = mkN "miljöminister" ;
  miljoeskurk_nn_1_1_N = mkN "miljöskurk" ;
  minigran_nn_1_N = mkN "minigran" ;
  minimitermometer_nn_1_N = mkN "minimitermometer" ;
  minister_nn_1_N = mkN "minister" ;
  ministerbaenk_nn_1_1_N = mkN "ministerbänk" ;
  mink_nn_1_N = mkN "mink" ;
  minnesbuss_nn_1_N = mkN "minnesbuss" ;
  minneslund_nn_1_N = mkN "minneslund" ;
  minsting_nn_1_N = mkN "minsting" ;
  mispel_nn_1_N = mkN "mispel" ;
  miss_nn_1_N = mkN "miss" ;
  missgaerningsbalk_nn_1_1_N = mkN "missgärningsbalk" ;
  missionsbokhandel_nn_1_N = mkN "missionsbokhandel" ;
  mistel_nn_1_N = mkN "mistel" ;
  mistlur_nn_1_N = mkN "mistlur" ;
  mjukis_nn_1_N = mkN "mjukis" ;
  mjukost_nn_1_N = mkN "mjukost" ;
  mjoelkhink_nn_1_1_N = mkN "mjölkhink" ;
  mjoelkkoertel_nn_1_1_N = mkN "mjölkkörtel" ;
  mjoelkspegel_nn_1_1_N = mkN "mjölkspegel" ;
  mjoelskivling_nn_1_1_N = mkN "mjölskivling" ;
  mockakopp_nn_1_N = mkN "mockakopp" ;
  mockasked_nn_1_N = mkN "mockasked" ;
  moderlut_nn_1_N = mkN "moderlut" ;
  modersfamn_nn_1_N = mkN "modersfamn" ;
  moj_nn_2_N = mkN "moj" ;
  molnbank_nn_1_N = mkN "molnbank" ;
  molntapp_nn_1_N = mkN "molntapp" ;
  molohamn_nn_1_N = mkN "molohamn" ;
  momentnyckel_nn_1_N = mkN "momentnyckel" ;
  mongolflaeck_nn_1_1_N = mkN "mongolfläck" ;
  monstersvamp_nn_1_N = mkN "monstersvamp" ;
  mopp_nn_1_N = mkN "mopp" ;
  mops_nn_1_N = mkN "mops" ;
  mordaengel_nn_1_1_N = mkN "mordängel" ;
  morfoeraelder_nn_1_1_N = mkN "morförälder" ;
  morgondag_nn_1_N = mkN "morgondag" ;
  morgonrock_nn_1_N = mkN "morgonrock" ;
  moringsboj_nn_1_N = mkN "moringsboj" ;
  morsefyr_nn_1_N = mkN "morsefyr" ;
  morsgris_nn_1_N = mkN "morsgris" ;
  mortel_nn_1_N = mkN "mortel" ;
  moster_nn_1_N = mkN "moster" ;
  motionscykel_nn_1_N = mkN "motionscykel" ;
  motivkrets_nn_1_N = mkN "motivkrets" ;
  motorcykel_nn_1_N = mkN "motorcykel" ;
  motorcylinder_nn_1_N = mkN "motorcylinder" ;
  motortorpedbaat_nn_1_1_N = mkN "motortorpedbåt" ;
  motorvagn_nn_1_N = mkN "motorvagn" ;
  motorvaermarkabel_nn_1_1_N = mkN "motorvärmarkabel" ;
  motstoet_nn_1_1_N = mkN "motstöt" ;
  mudd_nn_1_N = mkN "mudd" ;
  muff_nn_1_N = mkN "muff" ;
  muffel_nn_1_N = mkN "muffel" ;
  muffelugn_nn_1_N = mkN "muffelugn" ;
  mugg_nn_1_N = mkN "mugg" ;
  mullbaenk_nn_1_1_N = mkN "mullbänk" ;
  mullsork_nn_1_N = mkN "mullsork" ;
  mumrik_nn_1_N = mkN "mumrik" ;
  munk_nn_1_N = mkN "munk" ;
  munkavel_nn_1_N = mkN "munkavel" ;
  munkorg_nn_1_N = mkN "munkorg" ;
  munsbit_nn_1_N = mkN "munsbit" ;
  muntergoek_nn_1_1_N = mkN "muntergök" ;
  munvinkel_nn_1_N = mkN "munvinkel" ;
  mupp_nn_1_N = mkN "mupp" ;
  mur_nn_1_N = mkN "mur" ;
  murfog_nn_1_N = mkN "murfog" ;
  murmel_nn_1_N = mkN "murmel" ;
  murslev_nn_1_N = mkN "murslev" ;
  murvel_nn_1_N = mkN "murvel" ;
  mus_nn_2_N = mkN "mus" ;
  museimonter_nn_1_N = mkN "museimonter" ;
  muskoetgaffel_nn_1_1_N = mkN "muskötgaffel" ;
  mutkolv_nn_1_N = mkN "mutkolv" ;
  mutsedel_nn_1_N = mkN "mutsedel" ;
  mutter_nn_1_N = mkN "mutter" ;
  myling_nn_1_N = mkN "myling" ;
  myndighetsaalder_nn_1_1_N = mkN "myndighetsålder" ;
  myndling_nn_1_N = mkN "myndling" ;
  mynningsarm_nn_1_N = mkN "mynningsarm" ;
  mynningsbroms_nn_1_N = mkN "mynningsbroms" ;
  myr_nn_1_N = mkN "myr" ;
  myrdrottning_nn_1_N = mkN "myrdrottning" ;
  myrkott_nn_1_N = mkN "myrkott" ;
  myrslok_nn_1_N = mkN "myrslok" ;
  myrspov_nn_1_N = mkN "myrspov" ;
  myrstack_nn_1_N = mkN "myrstack" ;
  myskhjort_nn_1_N = mkN "myskhjort" ;
  myskoxkalv_nn_1_N = mkN "myskoxkalv" ;
  maenniskohaj_nn_1_1_N = mkN "människohaj" ;
  maenniskohamn_nn_1_1_N = mkN "människohamn" ;
  maenniskokropp_nn_1_1_N = mkN "människokropp" ;
  maergelgrav_nn_1_1_N = mkN "märgelgrav" ;
  maergelskiffer_nn_1_1_N = mkN "märgelskiffer" ;
  maergflaeck_nn_1_1_N = mkN "märgfläck" ;
  maerkduk_nn_1_1_N = mkN "märkduk" ;
  maerr_nn_1_1_N = mkN "märr" ;
  maers_nn_1_1_N = mkN "märs" ;
  maess_nn_1_1_N = mkN "mäss" ;
  maessingsspik_nn_1_1_N = mkN "mässingsspik" ;
  maesskrud_nn_1_1_N = mkN "mässkrud" ;
  maesterlots_nn_1_1_N = mkN "mästerlots" ;
  maesterskapstitel_nn_1_1_N = mkN "mästerskapstitel" ;
  maag_nn_1_1_N = mkN "måg" ;
  maalarduk_nn_1_1_N = mkN "målarduk" ;
  maalarkludd_nn_1_1_N = mkN "målarkludd" ;
  maalarrock_nn_1_1_N = mkN "målarrock" ;
  maalbur_nn_1_1_N = mkN "målbur" ;
  maalgaard_nn_1_1_N = mkN "målgård" ;
  maalskytt_nn_1_1_N = mkN "målskytt" ;
  maandageftermiddag_nn_1_1_N = mkN "måndageftermiddag" ;
  maandagkvaell_nn_1_1_N = mkN "måndagkväll" ;
  maandagseftermiddag_nn_1_1_N = mkN "måndagseftermiddag" ;
  maandagskvaell_nn_1_1_N = mkN "måndagskväll" ;
  maangfaldsbarometer_nn_1_1_N = mkN "mångfaldsbarometer" ;
  maangfoting_nn_1_1_N = mkN "mångfoting" ;
  maangaard_nn_1_1_N = mkN "mångård" ;
  maankalender_nn_1_1_N = mkN "månkalender" ;
  maankrater_nn_1_1_N = mkN "månkrater" ;
  maard_nn_1_1_N = mkN "mård" ;
  maas_nn_1_1_N = mkN "mås" ;
  maasfaagel_nn_1_1_N = mkN "måsfågel" ;
  moebelbuss_nn_1_1_N = mkN "möbelbuss" ;
  moebelklaedsel_nn_1_1_N = mkN "möbelklädsel" ;
  moebelspik_nn_1_1_N = mkN "möbelspik" ;
  moebeltass_nn_1_1_N = mkN "möbeltass" ;
  moebelvinkel_nn_1_1_N = mkN "möbelvinkel" ;
  moegelost_nn_1_1_N = mkN "mögelost" ;
  moegelsvamp_nn_1_1_N = mkN "mögelsvamp" ;
  moenstergaard_nn_1_1_N = mkN "mönstergård" ;
  moerdarhund_nn_1_1_N = mkN "mördarhund" ;
  moerdarsnigel_nn_1_1_N = mkN "mördarsnigel" ;
  moerk_nn_1_1_N = mkN "mörk" ;
  moert_nn_1_1_N = mkN "mört" ;
  nackman_nn_1_N = mkN "nackman" ;
  nackspaerr_nn_1_1_N = mkN "nackspärr" ;
  nacktofs_nn_1_N = mkN "nacktofs" ;
  nagel_nn_1_N = mkN "nagel" ;
  nagelbaedd_nn_1_1_N = mkN "nagelbädd" ;
  nagelbaenk_nn_1_1_N = mkN "nagelbänk" ;
  nagelsax_nn_1_N = mkN "nagelsax" ;
  nagelspets_nn_1_N = mkN "nagelspets" ;
  nagg_nn_1_N = mkN "nagg" ;
  namnplaat_nn_1_1_N = mkN "namnplåt" ;
  namnsdag_nn_1_N = mkN "namnsdag" ;
  namnsedel_nn_1_N = mkN "namnsedel" ;
  namnstandert_nn_1_N = mkN "namnstandert" ;
  namnstaempel_nn_1_1_N = mkN "namnstämpel" ;
  nanobot_nn_1_N = mkN "nanobot" ;
  nanopartikel_nn_1_N = mkN "nanopartikel" ;
  napp_nn_2_N = mkN "napp" ;
  nar_nn_1_N = mkN "nar" ;
  narkotikahaj_nn_1_N = mkN "narkotikahaj" ;
  narkotikarotel_nn_1_N = mkN "narkotikarotel" ;
  narr_nn_1_N = mkN "narr" ;
  narrspegel_nn_1_N = mkN "narrspegel" ;
  nationaldag_nn_1_N = mkN "nationaldag" ;
  nationalitetsmatrikel_nn_1_N = mkN "nationalitetsmatrikel" ;
  nationalteater_nn_1_N = mkN "nationalteater" ;
  natronlut_nn_1_N = mkN "natronlut" ;
  nattfaagel_nn_1_1_N = mkN "nattfågel" ;
  natthamn_nn_1_N = mkN "natthamn" ;
  nattis_nn_1_N = mkN "nattis" ;
  nattklubb_nn_1_N = mkN "nattklubb" ;
  nattsmyg_nn_1_N = mkN "nattsmyg" ;
  nattstol_nn_1_N = mkN "nattstol" ;
  nattsyster_nn_1_N = mkN "nattsyster" ;
  nattsaeck_nn_1_1_N = mkN "nattsäck" ;
  nattvardskalk_nn_1_N = mkN "nattvardskalk" ;
  naturhamn_nn_1_N = mkN "naturhamn" ;
  navarborr_nn_1_N = mkN "navarborr" ;
  navel_nn_1_N = mkN "navel" ;
  navelflaeck_nn_1_1_N = mkN "navelfläck" ;
  navkapsel_nn_1_N = mkN "navkapsel" ;
  nedslagskrater_nn_1_N = mkN "nedslagskrater" ;
  nerslagskrater_nn_1_N = mkN "nerslagskrater" ;
  nervstump_nn_1_N = mkN "nervstump" ;
  neutrinopartikel_nn_1_N = mkN "neutrinopartikel" ;
  newfoundlandshund_nn_1_N = mkN "newfoundlandshund" ;
  nick_nn_1_N = mkN "nick" ;
  niding_nn_1_N = mkN "niding" ;
  nimrod_nn_1_N = mkN "nimrod" ;
  niotumsspik_nn_1_N = mkN "niotumsspik" ;
  nippel_nn_1_N = mkN "nippel" ;
  nit_nn_2_N = mkN "nit" ;
  nitnagel_nn_1_N = mkN "nitnagel" ;
  nitstamp_nn_1_N = mkN "nitstamp" ;
  nitstans_nn_1_N = mkN "nitstans" ;
  nobb_nn_1_N = mkN "nobb" ;
  nock_nn_1_N = mkN "nock" ;
  nollcirkel_nn_1_N = mkN "nollcirkel" ;
  nopp_nn_1_N = mkN "nopp" ;
  nordsvensk_nn_1_N = mkN "nordsvensk" ;
  norrgoek_nn_1_1_N = mkN "norrgök" ;
  norrkvint_nn_1_N = mkN "norrkvint" ;
  norrlandshaest_nn_1_1_N = mkN "norrlandshäst" ;
  nors_nn_1_N = mkN "nors" ;
  nos_nn_1_N = mkN "nos" ;
  noshoerningsbebis_nn_1_1_N = mkN "noshörningsbebis" ;
  noskorg_nn_1_N = mkN "noskorg" ;
  nosspets_nn_1_N = mkN "nosspets" ;
  not_nn_2_N = mkN "not" ;
  novemberkvaell_nn_1_1_N = mkN "novemberkväll" ;
  nubb_nn_1_N = mkN "nubb" ;
  nudel_nn_1_N = mkN "nudel" ;
  nudelwok_nn_1_N = mkN "nudelwok" ;
  nummerhaest_nn_1_1_N = mkN "nummerhäst" ;
  nummerplaat_nn_1_1_N = mkN "nummerplåt" ;
  nyckel_nn_1_N = mkN "nyckel" ;
  nyhetsreporter_nn_1_N = mkN "nyhetsreporter" ;
  nying_nn_1_N = mkN "nying" ;
  naebbknoel_nn_1_1_N = mkN "näbbknöl" ;
  naebbval_nn_1_1_N = mkN "näbbval" ;
  naektergal_nn_1_1_N = mkN "näktergal" ;
  naeringsminister_nn_1_1_N = mkN "näringsminister" ;
  naerking_nn_1_1_N = mkN "närking" ;
  naesduk_nn_1_1_N = mkN "näsduk" ;
  naesknaepp_nn_1_1_N = mkN "näsknäpp" ;
  naesrygg_nn_1_1_N = mkN "näsrygg" ;
  naesspets_nn_1_1_N = mkN "nässpets" ;
  naestipp_nn_1_1_N = mkN "nästipp" ;
  naetartikel_nn_1_1_N = mkN "nätartikel" ;
  naetbur_nn_1_1_N = mkN "nätbur" ;
  naetsax_nn_1_1_N = mkN "nätsax" ;
  naettelduk_nn_1_1_N = mkN "nättelduk" ;
  naetting_nn_1_1_N = mkN "nätting" ;
  naever_nn_1_1_N = mkN "näver" ;
  naad_nn_2_1_N = mkN "nåd" ;
  naal_nn_1_1_N = mkN "nål" ;
  naalpeng_nn_1_1_N = mkN "nålpeng" ;
  naalspets_nn_1_1_N = mkN "nålspets" ;
  naat_nn_1_1_N = mkN "nåt" ;
  noedbroms_nn_1_1_N = mkN "nödbroms" ;
  noedhamn_nn_1_1_N = mkN "nödhamn" ;
  noedvaendighetsartikel_nn_1_1_N = mkN "nödvändighetsartikel" ;
  noejeshall_nn_1_1_N = mkN "nöjeshall" ;
  noerd_nn_1_1_N = mkN "nörd" ;
  noetvivel_nn_1_1_N = mkN "nötvivel" ;
  odugling_nn_1_N = mkN "odugling" ;
  officersmaess_nn_1_1_N = mkN "officersmäss" ;
  ograesfisk_nn_1_1_N = mkN "ogräsfisk" ;
  oktaeder_nn_1_N = mkN "oktaeder" ;
  okynneshund_nn_1_N = mkN "okynneshund" ;
  oleander_nn_1_N = mkN "oleander" ;
  olivkvist_nn_1_N = mkN "olivkvist" ;
  oljebrunn_nn_1_N = mkN "oljebrunn" ;
  oljerock_nn_1_N = mkN "oljerock" ;
  oljeskiffer_nn_1_N = mkN "oljeskiffer" ;
  oljesump_nn_1_N = mkN "oljesump" ;
  oljevaev_nn_1_1_N = mkN "oljeväv" ;
  ollonmask_nn_1_N = mkN "ollonmask" ;
  olm_nn_1_N = mkN "olm" ;
  olycksfaagel_nn_1_1_N = mkN "olycksfågel" ;
  omgiv_nn_1_N = mkN "omgiv" ;
  omnibus_nn_1_N = mkN "omnibus" ;
  omnibuss_nn_1_N = mkN "omnibuss" ;
  omnifyr_nn_1_N = mkN "omnifyr" ;
  omsving_nn_1_N = mkN "omsving" ;
  onkel_nn_1_N = mkN "onkel" ;
  onsdageftermiddag_nn_1_N = mkN "onsdageftermiddag" ;
  onsdagkvaell_nn_1_1_N = mkN "onsdagkväll" ;
  onsdagseftermiddag_nn_1_N = mkN "onsdagseftermiddag" ;
  onsdagskvaell_nn_1_1_N = mkN "onsdagskväll" ;
  onyx_nn_1_N = mkN "onyx" ;
  operetteater_nn_1_N = mkN "operetteater" ;
  opossum_nn_1_N = mkN "opossum" ;
  ordlek_nn_1_N = mkN "ordlek" ;
  ordvirvel_nn_1_N = mkN "ordvirvel" ;
  ordvits_nn_1_N = mkN "ordvits" ;
  orgel_nn_1_N = mkN "orgel" ;
  orkester_nn_1_N = mkN "orkester" ;
  orlovssedel_nn_1_N = mkN "orlovssedel" ;
  orm_nn_1_N = mkN "orm" ;
  ormgran_nn_1_N = mkN "ormgran" ;
  ormgrop_nn_1_N = mkN "ormgrop" ;
  ormvraak_nn_1_1_N = mkN "ormvråk" ;
  ornaesbjoerk_nn_1_1_N = mkN "ornäsbjörk" ;
  oroshaerd_nn_1_1_N = mkN "oroshärd" ;
  orrfaagel_nn_1_1_N = mkN "orrfågel" ;
  ort_nn_2_N = mkN "ort" ;
  ortolansparv_nn_1_N = mkN "ortolansparv" ;
  ost_nn_1_N = mkN "ost" ;
  osthyvel_nn_1_N = mkN "osthyvel" ;
  ostmask_nn_1_N = mkN "ostmask" ;
  ostronbank_nn_1_N = mkN "ostronbank" ;
  ostskalk_nn_1_N = mkN "ostskalk" ;
  ostsmoergaas_nn_1_1_N = mkN "ostsmörgås" ;
  otaecking_nn_1_1_N = mkN "otäcking" ;
  oxel_nn_1_N = mkN "oxel" ;
  oxlaegg_nn_1_1_N = mkN "oxlägg" ;
  oxtungsvamp_nn_1_N = mkN "oxtungsvamp" ;
  packbox_nn_1_N = mkN "packbox" ;
  packlaar_nn_1_1_N = mkN "packlår" ;
  packsadel_nn_1_N = mkN "packsadel" ;
  packtross_nn_1_N = mkN "packtross" ;
  paddel_nn_1_N = mkN "paddel" ;
  paketeringsdisk_nn_1_N = mkN "paketeringsdisk" ;
  palestinasjal_nn_1_N = mkN "palestinasjal" ;
  pall_nn_1_N = mkN "pall" ;
  palmsoendag_nn_1_1_N = mkN "palmsöndag" ;
  pals_nn_1_N = mkN "pals" ;
  palt_nn_1_N = mkN "palt" ;
  pamp_nn_1_N = mkN "pamp" ;
  pankreaskoertel_nn_1_1_N = mkN "pankreaskörtel" ;
  pannbiff_nn_1_N = mkN "pannbiff" ;
  pannspegel_nn_1_N = mkN "pannspegel" ;
  pansarbil_nn_1_N = mkN "pansarbil" ;
  pansarmal_nn_1_N = mkN "pansarmal" ;
  pansarvagn_nn_1_N = mkN "pansarvagn" ;
  pansarvaernsrobot_nn_1_1_N = mkN "pansarvärnsrobot" ;
  panter_nn_1_N = mkN "panter" ;
  papegojfisk_nn_1_N = mkN "papegojfisk" ;
  pappershandduk_nn_1_N = mkN "pappershandduk" ;
  pappershandel_nn_1_N = mkN "pappershandel" ;
  papperskorg_nn_1_N = mkN "papperskorg" ;
  papperskvarn_nn_1_N = mkN "papperskvarn" ;
  pappersnaesduk_nn_1_1_N = mkN "pappersnäsduk" ;
  papperspeng_nn_1_N = mkN "papperspeng" ;
  papperssax_nn_1_N = mkN "papperssax" ;
  papperstiger_nn_1_N = mkN "papperstiger" ;
  papperstuss_nn_1_N = mkN "papperstuss" ;
  pappspik_nn_1_N = mkN "pappspik" ;
  parabellum_nn_1_N = mkN "parabellum" ;
  paradisfaagel_nn_1_1_N = mkN "paradisfågel" ;
  parallellcirkel_nn_1_N = mkN "parallellcirkel" ;
  parameter_nn_1_N = mkN "parameter" ;
  parerplaat_nn_1_1_N = mkN "parerplåt" ;
  parhaest_nn_1_1_N = mkN "parhäst" ;
  parisersmoergaas_nn_1_1_N = mkN "parisersmörgås" ;
  parkbaenk_nn_1_1_N = mkN "parkbänk" ;
  parkeringsbroms_nn_1_N = mkN "parkeringsbroms" ;
  parkettstav_nn_1_N = mkN "parkettstav" ;
  parningslek_nn_1_N = mkN "parningslek" ;
  partikel_nn_1_N = mkN "partikel" ;
  partikelkross_nn_1_N = mkN "partikelkross" ;
  parvel_nn_1_N = mkN "parvel" ;
  passbit_nn_1_N = mkN "passbit" ;
  passbaat_nn_1_1_N = mkN "passbåt" ;
  passersedel_nn_1_N = mkN "passersedel" ;
  passus_nn_1_N = mkN "passus" ;
  patentsmoergaas_nn_1_1_N = mkN "patentsmörgås" ;
  pater_nn_1_N = mkN "pater" ;
  paternosterhiss_nn_1_N = mkN "paternosterhiss" ;
  patientplaat_nn_1_1_N = mkN "patientplåt" ;
  patt_nn_2_N = mkN "patt" ;
  pausfaagel_nn_1_1_N = mkN "pausfågel" ;
  pegel_nn_1_N = mkN "pegel" ;
  pekfinger_nn_1_N = mkN "pekfinger" ;
  pekfingernagel_nn_1_N = mkN "pekfingernagel" ;
  pellejoens_nn_1_1_N = mkN "pellejöns" ;
  pendel_nn_1_N = mkN "pendel" ;
  peng_nn_1_N = mkN "peng" ;
  penning_nn_1_N = mkN "penning" ;
  pennkniv_nn_1_N = mkN "pennkniv" ;
  pensel_nn_1_N = mkN "pensel" ;
  pensionsaalder_nn_1_1_N = mkN "pensionsålder" ;
  pentameter_nn_1_N = mkN "pentameter" ;
  pepparkaksgris_nn_1_N = mkN "pepparkaksgris" ;
  perimeter_nn_1_N = mkN "perimeter" ;
  perpendikel_nn_1_N = mkN "perpendikel" ;
  persedel_nn_1_N = mkN "persedel" ;
  persianpaels_nn_1_1_N = mkN "persianpäls" ;
  personvagn_nn_1_N = mkN "personvagn" ;
  petimaeter_nn_1_1_N = mkN "petimäter" ;
  petmoj_nn_1_N = mkN "petmoj" ;
  physalis_nn_1_N = mkN "physalis" ;
  piasavakvast_nn_1_N = mkN "piasavakvast" ;
  piassavakvast_nn_1_N = mkN "piassavakvast" ;
  piaster_nn_1_N = mkN "piaster" ;
  pick_nn_1_N = mkN "pick" ;
  picknick_nn_1_N = mkN "picknick" ;
  piercing_nn_1_N = mkN "piercing" ;
  pigg_nn_1_N = mkN "pigg" ;
  pigghaj_nn_1_N = mkN "pigghaj" ;
  piggvar_nn_1_N = mkN "piggvar" ;
  pik_nn_1_N = mkN "pik" ;
  pikstav_nn_1_N = mkN "pikstav" ;
  pil_nn_1_N = mkN "pil" ;
  pilaster_nn_1_N = mkN "pilaster" ;
  pilfink_nn_1_N = mkN "pilfink" ;
  pilgrimsfalk_nn_1_N = mkN "pilgrimsfalk" ;
  pilgrimsstav_nn_1_N = mkN "pilgrimsstav" ;
  pilk_nn_1_N = mkN "pilk" ;
  pilspets_nn_1_N = mkN "pilspets" ;
  pilt_nn_1_N = mkN "pilt" ;
  pimpel_nn_1_N = mkN "pimpel" ;
  pingst_nn_1_N = mkN "pingst" ;
  pingstdag_nn_1_N = mkN "pingstdag" ;
  pinnharv_nn_1_N = mkN "pinnharv" ;
  pinscher_nn_1_N = mkN "pinscher" ;
  pip_nn_1_N = mkN "pip" ;
  pipping_nn_1_N = mkN "pipping" ;
  pipsvamp_nn_1_N = mkN "pipsvamp" ;
  pirk_nn_1_N = mkN "pirk" ;
  piskklatsch_nn_1_N = mkN "piskklatsch" ;
  piskmask_nn_1_N = mkN "piskmask" ;
  piskslaeng_nn_1_1_N = mkN "pisksläng" ;
  pisksnaert_nn_1_1_N = mkN "pisksnärt" ;
  pistagemandel_nn_1_N = mkN "pistagemandel" ;
  pistaschmandel_nn_1_N = mkN "pistaschmandel" ;
  pitt_nn_1_N = mkN "pitt" ;
  pivotvagn_nn_1_N = mkN "pivotvagn" ;
  pivaavagn_nn_1_1_N = mkN "pivåvagn" ;
  pjatt_nn_1_N = mkN "pjatt" ;
  planhyvel_nn_1_N = mkN "planhyvel" ;
  plants_nn_1_N = mkN "plants" ;
  plastcykel_nn_1_N = mkN "plastcykel" ;
  plastgaffel_nn_1_N = mkN "plastgaffel" ;
  plattfisk_nn_1_N = mkN "plattfisk" ;
  platting_nn_1_N = mkN "platting" ;
  plattmask_nn_1_N = mkN "plattmask" ;
  pligg_nn_1_N = mkN "pligg" ;
  plint_nn_1_N = mkN "plint" ;
  plister_nn_1_N = mkN "plister" ;
  plit_nn_2_N = mkN "plit" ;
  plog_nn_1_N = mkN "plog" ;
  plogbill_nn_1_N = mkN "plogbill" ;
  plugg_nn_2_N = mkN "plugg" ;
  plugghaest_nn_1_1_N = mkN "plugghäst" ;
  pluggskivling_nn_1_N = mkN "pluggskivling" ;
  plump_nn_1_N = mkN "plump" ;
  plumpudding_nn_1_N = mkN "plumpudding" ;
  pluring_nn_1_N = mkN "pluring" ;
  plutt_nn_1_N = mkN "plutt" ;
  plaett_nn_1_1_N = mkN "plätt" ;
  plaettlagg_nn_1_1_N = mkN "plättlagg" ;
  plaat_nn_1_1_N = mkN "plåt" ;
  plaatsax_nn_1_1_N = mkN "plåtsax" ;
  ploes_nn_1_1_N = mkN "plös" ;
  pocket_nn_1_N = mkN "pocket" ;
  pointer_nn_1_N = mkN "pointer" ;
  pojkbyting_nn_1_N = mkN "pojkbyting" ;
  pojkcykel_nn_1_N = mkN "pojkcykel" ;
  pojkfnasker_nn_1_N = mkN "pojkfnasker" ;
  pojkhals_nn_1_N = mkN "pojkhals" ;
  pojkorkester_nn_1_N = mkN "pojkorkester" ;
  pojkspoling_nn_1_N = mkN "pojkspoling" ;
  pojkvasker_nn_1_N = mkN "pojkvasker" ;
  polaris_nn_1_N = mkN "polaris" ;
  polarraev_nn_1_1_N = mkN "polarräv" ;
  polcirkel_nn_1_N = mkN "polcirkel" ;
  polder_nn_1_N = mkN "polder" ;
  polishelikopter_nn_1_N = mkN "polishelikopter" ;
  polishund_nn_1_N = mkN "polishund" ;
  poliskonstapel_nn_1_N = mkN "poliskonstapel" ;
  politikus_nn_1_N = mkN "politikus" ;
  polkagris_nn_1_N = mkN "polkagris" ;
  polkropp_nn_1_N = mkN "polkropp" ;
  polohaest_nn_1_1_N = mkN "polohäst" ;
  polyeder_nn_1_N = mkN "polyeder" ;
  polyester_nn_1_N = mkN "polyester" ;
  polyeter_nn_1_N = mkN "polyeter" ;
  poplinrock_nn_1_N = mkN "poplinrock" ;
  poplaat_nn_1_1_N = mkN "poplåt" ;
  poppel_nn_1_N = mkN "poppel" ;
  pormask_nn_1_N = mkN "pormask" ;
  porslinsdegel_nn_1_N = mkN "porslinsdegel" ;
  porslinsskaal_nn_1_1_N = mkN "porslinsskål" ;
  porsvamp_nn_1_N = mkN "porsvamp" ;
  port_nn_1_N = mkN "port" ;
  portklapp_nn_1_N = mkN "portklapp" ;
  portnyckel_nn_1_N = mkN "portnyckel" ;
  postbox_nn_1_N = mkN "postbox" ;
  postremissvaexel_nn_1_1_N = mkN "postremissväxel" ;
  poststaempel_nn_1_1_N = mkN "poststämpel" ;
  postvaexel_nn_1_1_N = mkN "postväxel" ;
  potatis_nn_1_N = mkN "potatis" ;
  potentiometer_nn_1_N = mkN "potentiometer" ;
  poaengseger_nn_1_1_N = mkN "poängseger" ;
  pratkvarn_nn_1_N = mkN "pratkvarn" ;
  precisionsmejsel_nn_1_N = mkN "precisionsmejsel" ;
  predikstol_nn_1_N = mkN "predikstol" ;
  premiaerminister_nn_1_1_N = mkN "premiärminister" ;
  presenning_nn_1_N = mkN "presenning" ;
  presentask_nn_1_N = mkN "presentask" ;
  press_nn_1_N = mkN "press" ;
  prick_nn_1_N = mkN "prick" ;
  prins_nn_1_N = mkN "prins" ;
  pris_nn_4_N = mkN "pris" ;
  prislapp_nn_1_N = mkN "prislapp" ;
  profithaj_nn_1_N = mkN "profithaj" ;
  prokrustesbaedd_nn_1_1_N = mkN "prokrustesbädd" ;
  promenadkaepp_nn_1_1_N = mkN "promenadkäpp" ;
  promenadseger_nn_1_N = mkN "promenadseger" ;
  propagandaminister_nn_1_N = mkN "propagandaminister" ;
  propeller_nn_1_N = mkN "propeller" ;
  propelleraxel_nn_1_N = mkN "propelleraxel" ;
  propp_nn_1_N = mkN "propp" ;
  prost_nn_1_N = mkN "prost" ;
  prostatacancer_nn_1_N = mkN "prostatacancer" ;
  proteststorm_nn_1_N = mkN "proteststorm" ;
  protonkniv_nn_1_N = mkN "protonkniv" ;
  prutt_nn_1_N = mkN "prutt" ;
  prydnadsartikel_nn_1_N = mkN "prydnadsartikel" ;
  prydnadsfjaeder_nn_1_1_N = mkN "prydnadsfjäder" ;
  prydnadsgavel_nn_1_N = mkN "prydnadsgavel" ;
  prydnadskrans_nn_1_N = mkN "prydnadskrans" ;
  prydnadsvaev_nn_1_1_N = mkN "prydnadsväv" ;
  pryl_nn_1_N = mkN "pryl" ;
  pryttel_nn_1_N = mkN "pryttel" ;
  praeriehund_nn_1_1_N = mkN "präriehund" ;
  praerievarg_nn_1_1_N = mkN "prärievarg" ;
  praestgaard_nn_1_1_N = mkN "prästgård" ;
  praestgaardslaenstol_nn_1_1_N = mkN "prästgårdslänstol" ;
  praestost_nn_1_1_N = mkN "prästost" ;
  praestrock_nn_1_1_N = mkN "prästrock" ;
  praestskrud_nn_1_1_N = mkN "prästskrud" ;
  praesttitel_nn_1_1_N = mkN "prästtitel" ;
  praam_nn_1_1_N = mkN "pråm" ;
  psykrometer_nn_1_N = mkN "psykrometer" ;
  pub_nn_1_N = mkN "pub" ;
  puck_nn_1_N = mkN "puck" ;
  puckel_nn_1_N = mkN "puckel" ;
  puckelrygg_nn_1_N = mkN "puckelrygg" ;
  pudding_nn_1_N = mkN "pudding" ;
  pudel_nn_1_N = mkN "pudel" ;
  puff_nn_1_N = mkN "puff" ;
  puffert_nn_1_N = mkN "puffert" ;
  pullmanvagn_nn_1_N = mkN "pullmanvagn" ;
  pullover_nn_1_N = mkN "pullover" ;
  pulpit_nn_1_N = mkN "pulpit" ;
  puls_nn_2_N = mkN "puls" ;
  pump_nn_1_N = mkN "pump" ;
  pumpernickel_nn_1_N = mkN "pumpernickel" ;
  pumpkolv_nn_1_N = mkN "pumpkolv" ;
  pumpstoevel_nn_1_1_N = mkN "pumpstövel" ;
  punch_nn_1_N = mkN "punch" ;
  pung_nn_1_N = mkN "pung" ;
  punggraevling_nn_1_1_N = mkN "punggrävling" ;
  pungmes_nn_1_N = mkN "pungmes" ;
  puns_nn_1_N = mkN "puns" ;
  puss_nn_1_N = mkN "puss" ;
  pust_nn_1_N = mkN "pust" ;
  putt_nn_1_N = mkN "putt" ;
  puttefnask_nn_1_N = mkN "puttefnask" ;
  putting_nn_1_N = mkN "putting" ;
  pyknometer_nn_1_N = mkN "pyknometer" ;
  pynt_nn_2_N = mkN "pynt" ;
  pyrometer_nn_1_N = mkN "pyrometer" ;
  pyrrhusseger_nn_1_N = mkN "pyrrhusseger" ;
  pyrrusseger_nn_1_N = mkN "pyrrusseger" ;
  pys_nn_1_N = mkN "pys" ;
  pyssling_nn_1_N = mkN "pyssling" ;
  pyts_nn_1_N = mkN "pyts" ;
  paell_nn_1_1_N = mkN "päll" ;
  paels_nn_1_1_N = mkN "päls" ;
  paelsfarm_nn_1_1_N = mkN "pälsfarm" ;
  paelssael_nn_1_1_N = mkN "pälssäl" ;
  paelsaenger_nn_1_1_N = mkN "pälsänger" ;
  paerlbaat_nn_1_1_N = mkN "pärlbåt" ;
  paerlspont_nn_1_1_N = mkN "pärlspont" ;
  paerlstav_nn_1_1_N = mkN "pärlstav" ;
  paerm_nn_1_1_N = mkN "pärm" ;
  paesk_nn_1_1_N = mkN "päsk" ;
  paafaagel_nn_1_1_N = mkN "påfågel" ;
  paafaagelsfjaeder_nn_1_1_N = mkN "påfågelsfjäder" ;
  paag_nn_1_1_N = mkN "påg" ;
  paahaengsvagn_nn_1_1_N = mkN "påhängsvagn" ;
  paak_nn_1_1_N = mkN "påk" ;
  paalaeggskalv_nn_1_1_N = mkN "påläggskalv" ;
  paask_nn_1_1_N = mkN "påsk" ;
  paaskdag_nn_1_1_N = mkN "påskdag" ;
  paaskkaering_nn_1_1_N = mkN "påskkäring" ;
  paaskkaerring_nn_1_1_N = mkN "påskkärring" ;
  paasksmaell_nn_1_1_N = mkN "påsksmäll" ;
  paataar_nn_1_1_N = mkN "påtår" ;
  poel_nn_1_1_N = mkN "pöl" ;
  quisling_nn_1_N = mkN "quisling" ;
  rabbis_nn_1_N = mkN "rabbis" ;
  racercykel_nn_1_N = mkN "racercykel" ;
  rack_nn_1_N = mkN "rack" ;
  racket_nn_1_N = mkN "racket" ;
  radarfyr_nn_1_N = mkN "radarfyr" ;
  radarskaerm_nn_1_1_N = mkN "radarskärm" ;
  radiofyr_nn_1_N = mkN "radiofyr" ;
  radiolaenk_nn_1_1_N = mkN "radiolänk" ;
  radiometer_nn_1_N = mkN "radiometer" ;
  radiotagg_nn_1_N = mkN "radiotagg" ;
  raggarbrud_nn_1_N = mkN "raggarbrud" ;
  rakhyvel_nn_1_N = mkN "rakhyvel" ;
  rakspegel_nn_1_N = mkN "rakspegel" ;
  rakstrigel_nn_1_N = mkN "rakstrigel" ;
  raktvaal_nn_1_1_N = mkN "raktvål" ;
  rall_nn_1_N = mkN "rall" ;
  rallarbas_nn_1_N = mkN "rallarbas" ;
  ram_nn_1_N = mkN "ram" ;
  ramm_nn_1_N = mkN "ramm" ;
  rangerbangaard_nn_1_1_N = mkN "rangerbangård" ;
  rankfoting_nn_1_N = mkN "rankfoting" ;
  rapp_nn_1_N = mkN "rapp" ;
  rapportkarl_nn_1_N = mkN "rapportkarl" ;
  rapsaaker_nn_1_1_N = mkN "rapsåker" ;
  raring_nn_1_N = mkN "raring" ;
  rasp_nn_1_N = mkN "rasp" ;
  rastgaard_nn_1_1_N = mkN "rastgård" ;
  ratt_nn_1_N = mkN "ratt" ;
  rattvaexel_nn_1_1_N = mkN "rattväxel" ;
  rauk_nn_1_N = mkN "rauk" ;
  ravaillac_nn_1_N = mkN "ravaillac" ;
  reaktorhaerd_nn_1_1_N = mkN "reaktorhärd" ;
  rebus_nn_1_N = mkN "rebus" ;
  receptionsdisk_nn_1_N = mkN "receptionsdisk" ;
  reflektometer_nn_1_N = mkN "reflektometer" ;
  regel_nn_2_N = mkN "regel" ;
  regelbaat_nn_1_1_N = mkN "regelbåt" ;
  regeringsbaenk_nn_1_1_N = mkN "regeringsbänk" ;
  regeringskrets_nn_1_N = mkN "regeringskrets" ;
  regnskur_nn_1_N = mkN "regnskur" ;
  reklampeng_nn_1_N = mkN "reklampeng" ;
  rekordbonus_nn_1_N = mkN "rekordbonus" ;
  rektangel_nn_1_N = mkN "rektangel" ;
  reling_nn_1_N = mkN "reling" ;
  renfaell_nn_1_1_N = mkN "renfäll" ;
  renhjord_nn_1_N = mkN "renhjord" ;
  renlav_nn_1_N = mkN "renlav" ;
  renskinnspaels_nn_1_1_N = mkN "renskinnspäls" ;
  rentjur_nn_1_N = mkN "rentjur" ;
  reporter_nn_1_N = mkN "reporter" ;
  restaurangvagn_nn_1_N = mkN "restaurangvagn" ;
  retriever_nn_1_N = mkN "retriever" ;
  returkapsel_nn_1_N = mkN "returkapsel" ;
  rev_nn_2_N = mkN "rev" ;
  revel_nn_1_N = mkN "revel" ;
  revolver_nn_1_N = mkN "revolver" ;
  revorm_nn_1_N = mkN "revorm" ;
  ribbstol_nn_1_N = mkN "ribbstol" ;
  ridhaest_nn_1_1_N = mkN "ridhäst" ;
  ridstoevel_nn_1_1_N = mkN "ridstövel" ;
  riesenschnauzer_nn_1_N = mkN "riesenschnauzer" ;
  rigel_nn_1_N = mkN "rigel" ;
  rigg_nn_1_N = mkN "rigg" ;
  riksdag_nn_1_N = mkN "riksdag" ;
  riksmarskalk_nn_1_N = mkN "riksmarskalk" ;
  riksnyckel_nn_1_N = mkN "riksnyckel" ;
  rikthyvel_nn_1_N = mkN "rikthyvel" ;
  riktkarl_nn_1_N = mkN "riktkarl" ;
  rimturs_nn_1_N = mkN "rimturs" ;
  ring_nn_1_N = mkN "ring" ;
  ringlek_nn_1_N = mkN "ringlek" ;
  ringmask_nn_1_N = mkN "ringmask" ;
  ringorm_nn_1_N = mkN "ringorm" ;
  ringpaerm_nn_1_1_N = mkN "ringpärm" ;
  ringraev_nn_1_1_N = mkN "ringräv" ;
  ringtrast_nn_1_N = mkN "ringtrast" ;
  rink_nn_1_N = mkN "rink" ;
  rippel_nn_1_N = mkN "rippel" ;
  rishoeg_nn_1_1_N = mkN "rishög" ;
  rivningskaak_nn_1_1_N = mkN "rivningskåk" ;
  robbert_nn_1_N = mkN "robbert" ;
  robot_nn_1_N = mkN "robot" ;
  rock_nn_1_N = mkN "rock" ;
  rockslusk_nn_1_N = mkN "rockslusk" ;
  roddarbaenk_nn_1_1_N = mkN "roddarbänk" ;
  roddarslav_nn_1_N = mkN "roddarslav" ;
  rodel_nn_1_N = mkN "rodel" ;
  rolighetsminister_nn_1_N = mkN "rolighetsminister" ;
  roll_nn_2_N = mkN "roll" ;
  rollmops_nn_1_N = mkN "rollmops" ;
  rolls_nn_1_N = mkN "rolls" ;
  romarhaer_nn_1_1_N = mkN "romarhär" ;
  roquefortost_nn_1_N = mkN "roquefortost" ;
  rorkult_nn_1_N = mkN "rorkult" ;
  rosenfink_nn_1_N = mkN "rosenfink" ;
  rosengaard_nn_1_1_N = mkN "rosengård" ;
  rosenkrans_nn_1_N = mkN "rosenkrans" ;
  roskarl_nn_1_N = mkN "roskarl" ;
  rosling_nn_1_N = mkN "rosling" ;
  rospigg_nn_1_N = mkN "rospigg" ;
  rost_nn_2_N = mkN "rost" ;
  rostbiff_nn_1_N = mkN "rostbiff" ;
  rostsvamp_nn_1_N = mkN "rostsvamp" ;
  rotationsaxel_nn_1_N = mkN "rotationsaxel" ;
  rotationspress_nn_1_N = mkN "rotationspress" ;
  rotel_nn_1_N = mkN "rotel" ;
  rotknoel_nn_1_1_N = mkN "rotknöl" ;
  rotting_nn_1_N = mkN "rotting" ;
  rough_nn_1_N = mkN "rough" ;
  rovfisk_nn_1_N = mkN "rovfisk" ;
  rovfaagel_nn_1_1_N = mkN "rovfågel" ;
  rubank_nn_1_N = mkN "rubank" ;
  rubrikstil_nn_1_N = mkN "rubrikstil" ;
  ruff_nn_1_N = mkN "ruff" ;
  rullstensaas_nn_1_1_N = mkN "rullstensås" ;
  rundel_nn_1_N = mkN "rundel" ;
  rundhaell_nn_1_1_N = mkN "rundhäll" ;
  rundmask_nn_1_N = mkN "rundmask" ;
  runometer_nn_1_N = mkN "runometer" ;
  runstav_nn_1_N = mkN "runstav" ;
  ruskprick_nn_1_N = mkN "ruskprick" ;
  rustibuss_nn_1_N = mkN "rustibuss" ;
  rutsch_nn_1_N = mkN "rutsch" ;
  rygg_nn_1_N = mkN "rygg" ;
  ryggbiff_nn_1_N = mkN "ryggbiff" ;
  ryggsaeck_nn_1_1_N = mkN "ryggsäck" ;
  rymdkapsel_nn_1_N = mkN "rymdkapsel" ;
  rymdvinkel_nn_1_N = mkN "rymdvinkel" ;
  rymling_nn_1_N = mkN "rymling" ;
  ryss_nn_1_N = mkN "ryss" ;
  raeddningshelikopter_nn_1_1_N = mkN "räddningshelikopter" ;
  raekel_nn_1_1_N = mkN "räkel" ;
  raeksmoergaas_nn_1_1_N = mkN "räksmörgås" ;
  raels_nn_1_1_N = mkN "räls" ;
  raelsbuss_nn_1_1_N = mkN "rälsbuss" ;
  raennil_nn_1_1_N = mkN "rännil" ;
  raenning_nn_1_1_N = mkN "ränning" ;
  raensel_nn_1_1_N = mkN "ränsel" ;
  raev_nn_1_1_N = mkN "räv" ;
  raevfarm_nn_1_1_N = mkN "rävfarm" ;
  raevhund_nn_1_1_N = mkN "rävhund" ;
  raevpaels_nn_1_1_N = mkN "rävpäls" ;
  raevsax_nn_1_1_N = mkN "rävsax" ;
  raevsvans_nn_1_1_N = mkN "rävsvans" ;
  raabandsknop_nn_1_1_N = mkN "råbandsknop" ;
  raabiff_nn_1_1_N = mkN "råbiff" ;
  raabock_nn_1_1_N = mkN "råbock" ;
  raadjurssadel_nn_1_1_N = mkN "rådjurssadel" ;
  raagaaker_nn_1_1_N = mkN "rågåker" ;
  raak_nn_1_1_N = mkN "råk" ;
  raanock_nn_1_1_N = mkN "rånock" ;
  raasop_nn_1_1_N = mkN "råsop" ;
  raattsvans_nn_1_1_N = mkN "råttsvans" ;
  roedbok_nn_1_1_N = mkN "rödbok" ;
  roeding_nn_1_1_N = mkN "röding" ;
  roedraev_nn_1_1_N = mkN "rödräv" ;
  roedspov_nn_1_1_N = mkN "rödspov" ;
  roedstjaert_nn_1_1_N = mkN "rödstjärt" ;
  roedvingetrast_nn_1_1_N = mkN "rödvingetrast" ;
  roedvaeppling_nn_1_1_N = mkN "rödväppling" ;
  roejel_nn_1_1_N = mkN "röjel" ;
  roek_nn_1_1_N = mkN "rök" ;
  roekgaard_nn_1_1_N = mkN "rökgård" ;
  roekrock_nn_1_1_N = mkN "rökrock" ;
  roeksvamp_nn_1_1_N = mkN "röksvamp" ;
  roenn_nn_1_1_N = mkN "rönn" ;
  roersopp_nn_1_1_N = mkN "rörsopp" ;
  roerspis_nn_1_1_N = mkN "rörspis" ;
  roersvamp_nn_1_1_N = mkN "rörsvamp" ;
  roestsedel_nn_1_1_N = mkN "röstsedel" ;
  roev_nn_1_1_N = mkN "röv" ;
  saab_nn_1_N = mkN "saab" ;
  sabbik_nn_1_N = mkN "sabbik" ;
  sabel_nn_1_N = mkN "sabel" ;
  sadel_nn_1_N = mkN "sadel" ;
  sadelfilt_nn_1_N = mkN "sadelfilt" ;
  sadelgjord_nn_1_N = mkN "sadelgjord" ;
  safirnaal_nn_1_1_N = mkN "safirnål" ;
  saftglass_nn_1_N = mkN "saftglass" ;
  saftpress_nn_1_N = mkN "saftpress" ;
  sagokrets_nn_1_N = mkN "sagokrets" ;
  sagoprins_nn_1_N = mkN "sagoprins" ;
  sal_nn_1_N = mkN "sal" ;
  salamander_nn_1_N = mkN "salamander" ;
  salladsskaal_nn_1_1_N = mkN "salladsskål" ;
  salongsbaat_nn_1_1_N = mkN "salongsbåt" ;
  salongsorkester_nn_1_N = mkN "salongsorkester" ;
  salongsruff_nn_1_N = mkN "salongsruff" ;
  salongsvagn_nn_1_N = mkN "salongsvagn" ;
  saltgrop_nn_1_N = mkN "saltgrop" ;
  saltvattensfisk_nn_1_N = mkN "saltvattensfisk" ;
  saluhall_nn_1_N = mkN "saluhall" ;
  samhaellskropp_nn_1_1_N = mkN "samhällskropp" ;
  samlingspaerm_nn_1_1_N = mkN "samlingspärm" ;
  samvetspeng_nn_1_N = mkN "samvetspeng" ;
  sandbank_nn_1_N = mkN "sandbank" ;
  sandblaester_nn_1_1_N = mkN "sandbläster" ;
  sandhed_nn_1_N = mkN "sandhed" ;
  sandjord_nn_1_N = mkN "sandjord" ;
  sandmask_nn_1_N = mkN "sandmask" ;
  sandrevel_nn_1_N = mkN "sandrevel" ;
  sandstorm_nn_1_N = mkN "sandstorm" ;
  sandwich_nn_1_N = mkN "sandwich" ;
  sanitetsartikel_nn_1_N = mkN "sanitetsartikel" ;
  sanitetshund_nn_1_N = mkN "sanitetshund" ;
  sanktbernhardshund_nn_1_N = mkN "sanktbernhardshund" ;
  sarv_nn_1_N = mkN "sarv" ;
  satkaering_nn_1_1_N = mkN "satkäring" ;
  satkaerring_nn_1_1_N = mkN "satkärring" ;
  sax_nn_1_N = mkN "sax" ;
  saxarm_nn_1_N = mkN "saxarm" ;
  saxnaebb_nn_1_1_N = mkN "saxnäbb" ;
  saxskalm_nn_1_N = mkN "saxskalm" ;
  saxskaenkel_nn_1_1_N = mkN "saxskänkel" ;
  saxsprint_nn_1_N = mkN "saxsprint" ;
  schackel_nn_1_N = mkN "schackel" ;
  schajas_nn_1_N = mkN "schajas" ;
  schaktugn_nn_1_N = mkN "schaktugn" ;
  schal_nn_1_N = mkN "schal" ;
  schnauzer_nn_1_N = mkN "schnauzer" ;
  schnitzel_nn_1_N = mkN "schnitzel" ;
  schottis_nn_1_N = mkN "schottis" ;
  schweizerost_nn_1_N = mkN "schweizerost" ;
  schaefer_nn_1_1_N = mkN "schäfer" ;
  schaeferhund_nn_1_1_N = mkN "schäferhund" ;
  schaefervalp_nn_1_1_N = mkN "schäfervalp" ;
  schaes_nn_1_1_N = mkN "schäs" ;
  scooter_nn_1_N = mkN "scooter" ;
  sedel_nn_1_N = mkN "sedel" ;
  sedelpress_nn_1_N = mkN "sedelpress" ;
  sedlighetsapostel_nn_1_N = mkN "sedlighetsapostel" ;
  sedlighetsrotel_nn_1_N = mkN "sedlighetsrotel" ;
  segelduk_nn_1_N = mkN "segelduk" ;
  seger_nn_1_N = mkN "seger" ;
  segerkrans_nn_1_N = mkN "segerkrans" ;
  segerkyss_nn_1_N = mkN "segerkyss" ;
  seglarstoevel_nn_1_1_N = mkN "seglarstövel" ;
  seismometer_nn_1_N = mkN "seismometer" ;
  sej_nn_1_N = mkN "sej" ;
  sejdel_nn_1_N = mkN "sejdel" ;
  sejsing_nn_1_N = mkN "sejsing" ;
  sekreterarfaagel_nn_1_1_N = mkN "sekreterarfågel" ;
  sektorfyr_nn_1_N = mkN "sektorfyr" ;
  semester_nn_1_N = mkN "semester" ;
  semesterpeng_nn_1_N = mkN "semesterpeng" ;
  senapsdeg_nn_1_N = mkN "senapsdeg" ;
  senhoest_nn_1_1_N = mkN "senhöst" ;
  senvinter_nn_1_N = mkN "senvinter" ;
  senvaar_nn_1_1_N = mkN "senvår" ;
  septiktank_nn_1_N = mkN "septiktank" ;
  seriekrock_nn_1_N = mkN "seriekrock" ;
  server_nn_1_N = mkN "server" ;
  serveringsvagn_nn_1_N = mkN "serveringsvagn" ;
  servicebox_nn_1_N = mkN "servicebox" ;
  servobroms_nn_1_N = mkN "servobroms" ;
  setter_nn_1_N = mkN "setter" ;
  sexfoting_nn_1_N = mkN "sexfoting" ;
  sexkantsnyckel_nn_1_N = mkN "sexkantsnyckel" ;
  sexling_nn_1_N = mkN "sexling" ;
  sexpack_nn_1_N = mkN "sexpack" ;
  sexslav_nn_1_N = mkN "sexslav" ;
  sextumsspik_nn_1_N = mkN "sextumsspik" ;
  sfinkter_nn_1_N = mkN "sfinkter" ;
  sfaerometer_nn_1_1_N = mkN "sfärometer" ;
  shop_nn_1_N = mkN "shop" ;
  shorting_nn_1_N = mkN "shorting" ;
  shunt_nn_1_N = mkN "shunt" ;
  sick_nn_1_N = mkN "sick" ;
  sickel_nn_1_N = mkN "sickel" ;
  sickling_nn_1_N = mkN "sickling" ;
  sidennaesduk_nn_1_1_N = mkN "sidennäsduk" ;
  sidenskaerm_nn_1_1_N = mkN "sidenskärm" ;
  sidensvans_nn_1_N = mkN "sidensvans" ;
  sidodal_nn_1_N = mkN "sidodal" ;
  sidovinkel_nn_1_N = mkN "sidovinkel" ;
  sidskruv_nn_1_N = mkN "sidskruv" ;
  sifferkarl_nn_1_N = mkN "sifferkarl" ;
  sifferstans_nn_1_N = mkN "sifferstans" ;
  sigillstamp_nn_1_N = mkN "sigillstamp" ;
  sigillstaempel_nn_1_1_N = mkN "sigillstämpel" ;
  sik_nn_1_N = mkN "sik" ;
  sikahjort_nn_1_N = mkN "sikahjort" ;
  sikel_nn_1_N = mkN "sikel" ;
  sikt_nn_2_N = mkN "sikt" ;
  sil_nn_1_N = mkN "sil" ;
  silkesmask_nn_1_N = mkN "silkesmask" ;
  silketass_nn_1_N = mkN "silketass" ;
  sill_nn_1_N = mkN "sill" ;
  sillbit_nn_1_N = mkN "sillbit" ;
  sillblixt_nn_1_N = mkN "sillblixt" ;
  sillfrukost_nn_1_N = mkN "sillfrukost" ;
  sillkung_nn_1_N = mkN "sillkung" ;
  sillpudding_nn_1_N = mkN "sillpudding" ;
  silltrut_nn_1_N = mkN "silltrut" ;
  sillval_nn_1_N = mkN "sillval" ;
  silverfisk_nn_1_N = mkN "silverfisk" ;
  silvergran_nn_1_N = mkN "silvergran" ;
  silvergrogg_nn_1_N = mkN "silvergrogg" ;
  silvermagister_nn_1_N = mkN "silvermagister" ;
  silverpeng_nn_1_N = mkN "silverpeng" ;
  silverpenning_nn_1_N = mkN "silverpenning" ;
  silverpoppel_nn_1_N = mkN "silverpoppel" ;
  silverraev_nn_1_1_N = mkN "silverräv" ;
  silverslev_nn_1_N = mkN "silverslev" ;
  silverstaempel_nn_1_1_N = mkN "silverstämpel" ;
  simfaagel_nn_1_1_N = mkN "simfågel" ;
  simhall_nn_1_N = mkN "simhall" ;
  simmagister_nn_1_N = mkN "simmagister" ;
  simshyvel_nn_1_N = mkN "simshyvel" ;
  simultantolk_nn_1_N = mkN "simultantolk" ;
  singel_nn_1_N = mkN "singel" ;
  sinus_nn_1_N = mkN "sinus" ;
  sisel_nn_1_N = mkN "sisel" ;
  sits_nn_1_N = mkN "sits" ;
  sittbrunn_nn_1_N = mkN "sittbrunn" ;
  sittopp_nn_1_N = mkN "sittopp" ;
  sittvagn_nn_1_N = mkN "sittvagn" ;
  sjajas_nn_1_N = mkN "sjajas" ;
  sjal_nn_1_N = mkN "sjal" ;
  sjasker_nn_1_N = mkN "sjasker" ;
  sjubb_nn_1_N = mkN "sjubb" ;
  sjukbaedd_nn_1_1_N = mkN "sjukbädd" ;
  sjukhusbaedd_nn_1_1_N = mkN "sjukhusbädd" ;
  sjukhusfoedsel_nn_1_1_N = mkN "sjukhusfödsel" ;
  sjukhussaeng_nn_1_1_N = mkN "sjukhussäng" ;
  sjukling_nn_1_N = mkN "sjukling" ;
  sjuksyster_nn_1_N = mkN "sjuksyster" ;
  sjukvaardsartikel_nn_1_1_N = mkN "sjukvårdsartikel" ;
  sjuling_nn_1_N = mkN "sjuling" ;
  sjurygg_nn_1_N = mkN "sjurygg" ;
  sjutumsspik_nn_1_N = mkN "sjutumsspik" ;
  sjael_nn_1_1_N = mkN "själ" ;
  sjaelvkem_nn_1_1_N = mkN "självkem" ;
  sjaelvlaens_nn_1_1_N = mkN "självläns" ;
  sjaelvspilling_nn_1_1_N = mkN "självspilling" ;
  sjoebod_nn_1_1_N = mkN "sjöbod" ;
  sjoebuss_nn_1_1_N = mkN "sjöbuss" ;
  sjoefaagel_nn_1_1_N = mkN "sjöfågel" ;
  sjoehaest_nn_1_1_N = mkN "sjöhäst" ;
  sjoekortsplotter_nn_1_1_N = mkN "sjökortsplotter" ;
  sjoemansblus_nn_1_1_N = mkN "sjömansblus" ;
  sjoemansknop_nn_1_1_N = mkN "sjömansknop" ;
  sjoeorm_nn_1_1_N = mkN "sjöorm" ;
  sjoepung_nn_1_1_N = mkN "sjöpung" ;
  sjoestoevel_nn_1_1_N = mkN "sjöstövel" ;
  skackel_nn_1_N = mkN "skackel" ;
  skakel_nn_1_N = mkN "skakel" ;
  skalk_nn_1_N = mkN "skalk" ;
  skalm_nn_1_N = mkN "skalm" ;
  skamflaeck_nn_1_1_N = mkN "skamfläck" ;
  skandalmiss_nn_1_N = mkN "skandalmiss" ;
  skans_nn_1_N = mkN "skans" ;
  skarf_nn_1_N = mkN "skarf" ;
  skarpsill_nn_1_N = mkN "skarpsill" ;
  skarv_nn_1_N = mkN "skarv" ;
  skattekil_nn_1_N = mkN "skattekil" ;
  skattesmaell_nn_1_1_N = mkN "skattesmäll" ;
  skattkammarvaexel_nn_1_1_N = mkN "skattkammarväxel" ;
  skattmas_nn_1_N = mkN "skattmas" ;
  skattsedel_nn_1_N = mkN "skattsedel" ;
  sked_nn_1_N = mkN "sked" ;
  skepparkrans_nn_1_N = mkN "skepparkrans" ;
  skeppsbaat_nn_1_1_N = mkN "skeppsbåt" ;
  skeppshandel_nn_1_N = mkN "skeppshandel" ;
  skeppsmask_nn_1_N = mkN "skeppsmask" ;
  skidsemester_nn_1_N = mkN "skidsemester" ;
  skidstav_nn_1_N = mkN "skidstav" ;
  skiffer_nn_1_N = mkN "skiffer" ;
  skiftnyckel_nn_1_N = mkN "skiftnyckel" ;
  skilling_nn_1_N = mkN "skilling" ;
  skilsmaessofoeraelder_nn_1_1_N = mkN "skilsmässoförälder" ;
  skinnerbur_nn_1_N = mkN "skinnerbur" ;
  skinnfaell_nn_1_1_N = mkN "skinnfäll" ;
  skinnklaedsel_nn_1_1_N = mkN "skinnklädsel" ;
  skinnpaj_nn_1_N = mkN "skinnpaj" ;
  skinnvaest_nn_1_1_N = mkN "skinnväst" ;
  skit_nn_1_N = mkN "skit" ;
  skitlaat_nn_1_1_N = mkN "skitlåt" ;
  skitstoevel_nn_1_1_N = mkN "skitstövel" ;
  skivbroms_nn_1_N = mkN "skivbroms" ;
  skivling_nn_1_N = mkN "skivling" ;
  skivsvamp_nn_1_N = mkN "skivsvamp" ;
  skjortblus_nn_1_N = mkN "skjortblus" ;
  skjuts_nn_1_N = mkN "skjuts" ;
  skjutvinkel_nn_1_N = mkN "skjutvinkel" ;
  skock_nn_1_N = mkN "skock" ;
  skog_nn_1_N = mkN "skog" ;
  skogsbaeck_nn_1_1_N = mkN "skogsbäck" ;
  skogsfaagel_nn_1_1_N = mkN "skogsfågel" ;
  skolbuss_nn_1_N = mkN "skolbuss" ;
  skolbaenk_nn_1_1_N = mkN "skolbänk" ;
  skolfux_nn_1_N = mkN "skolfux" ;
  skolgaard_nn_1_1_N = mkN "skolgård" ;
  skolmagister_nn_1_N = mkN "skolmagister" ;
  skolskjuts_nn_1_N = mkN "skolskjuts" ;
  skolsyster_nn_1_N = mkN "skolsyster" ;
  skopcylinder_nn_1_N = mkN "skopcylinder" ;
  skorv_nn_2_N = mkN "skorv" ;
  skoter_nn_1_N = mkN "skoter" ;
  skottglugg_nn_1_N = mkN "skottglugg" ;
  skovel_nn_1_N = mkN "skovel" ;
  skrattgrop_nn_1_N = mkN "skrattgrop" ;
  skrattmaas_nn_1_1_N = mkN "skrattmås" ;
  skrattspegel_nn_1_N = mkN "skrattspegel" ;
  skrikhals_nn_1_N = mkN "skrikhals" ;
  skrivstil_nn_1_N = mkN "skrivstil" ;
  skrothoeg_nn_1_1_N = mkN "skrothög" ;
  skrott_nn_1_N = mkN "skrott" ;
  skrubb_nn_1_N = mkN "skrubb" ;
  skrud_nn_1_N = mkN "skrud" ;
  skrutt_nn_2_N = mkN "skrutt" ;
  skruv_nn_1_N = mkN "skruv" ;
  skruvmejsel_nn_1_N = mkN "skruvmejsel" ;
  skruvnyckel_nn_1_N = mkN "skruvnyckel" ;
  skruvtving_nn_1_N = mkN "skruvtving" ;
  skrytmaans_nn_1_1_N = mkN "skrytmåns" ;
  skraeck_nn_1_1_N = mkN "skräck" ;
  skraell_nn_1_1_N = mkN "skräll" ;
  skraellseger_nn_1_1_N = mkN "skrällseger" ;
  skraapuk_nn_1_1_N = mkN "skråpuk" ;
  skuff_nn_1_N = mkN "skuff" ;
  skuffert_nn_1_N = mkN "skuffert" ;
  skuggspelsteater_nn_1_N = mkN "skuggspelsteater" ;
  skuldsedel_nn_1_N = mkN "skuldsedel" ;
  skult_nn_1_N = mkN "skult" ;
  skumgummiracket_nn_1_N = mkN "skumgummiracket" ;
  skummis_nn_1_N = mkN "skummis" ;
  skunk_nn_1_N = mkN "skunk" ;
  skur_nn_1_N = mkN "skur" ;
  skurduk_nn_1_N = mkN "skurduk" ;
  skurhink_nn_1_N = mkN "skurhink" ;
  skurk_nn_1_N = mkN "skurk" ;
  skvader_nn_1_N = mkN "skvader" ;
  skvalbank_nn_1_N = mkN "skvalbank" ;
  skvallerkaering_nn_1_1_N = mkN "skvallerkäring" ;
  skvallermoster_nn_1_N = mkN "skvallermoster" ;
  skvallerspegel_nn_1_N = mkN "skvallerspegel" ;
  skvaltkvarn_nn_1_N = mkN "skvaltkvarn" ;
  skvis_nn_1_N = mkN "skvis" ;
  skvaett_nn_1_1_N = mkN "skvätt" ;
  skyddsgrav_nn_1_N = mkN "skyddsgrav" ;
  skyddskropp_nn_1_N = mkN "skyddskropp" ;
  skyddsling_nn_1_N = mkN "skyddsling" ;
  skyddsrock_nn_1_N = mkN "skyddsrock" ;
  skyddstull_nn_1_N = mkN "skyddstull" ;
  skyddsaengel_nn_1_1_N = mkN "skyddsängel" ;
  skyffel_nn_1_N = mkN "skyffel" ;
  skygglapp_nn_1_N = mkN "skygglapp" ;
  skyl_nn_1_N = mkN "skyl" ;
  skyllerkur_nn_1_N = mkN "skyllerkur" ;
  skylt_nn_1_N = mkN "skylt" ;
  skyltdockekropp_nn_1_N = mkN "skyltdockekropp" ;
  skyltsoendag_nn_1_1_N = mkN "skyltsöndag" ;
  skylttjuv_nn_1_N = mkN "skylttjuv" ;
  skymt_nn_1_N = mkN "skymt" ;
  skytt_nn_1_N = mkN "skytt" ;
  skyttegrav_nn_1_N = mkN "skyttegrav" ;
  skyttegrop_nn_1_N = mkN "skyttegrop" ;
  skyttel_nn_1_N = mkN "skyttel" ;
  skaeck_nn_1_1_N = mkN "skäck" ;
  skaeggdopping_nn_1_1_N = mkN "skäggdopping" ;
  skaegglapp_nn_1_1_N = mkN "skägglapp" ;
  skaeggmunsmal_nn_1_1_N = mkN "skäggmunsmal" ;
  skaektstol_nn_1_1_N = mkN "skäktstol" ;
  skaelm_nn_1_1_N = mkN "skälm" ;
  skaenk_nn_1_1_N = mkN "skänk" ;
  skaenkel_nn_1_1_N = mkN "skänkel" ;
  skaergaard_nn_1_1_N = mkN "skärgård" ;
  skaergaardsis_nn_1_1_N = mkN "skärgårdsis" ;
  skaerkarl_nn_1_1_N = mkN "skärkarl" ;
  skaerkniv_nn_1_1_N = mkN "skärkniv" ;
  skaerm_nn_1_1_N = mkN "skärm" ;
  skaermytsel_nn_1_1_N = mkN "skärmytsel" ;
  skaermytsling_nn_1_1_N = mkN "skärmytsling" ;
  skaertorsdag_nn_1_1_N = mkN "skärtorsdag" ;
  skaerv_nn_1_1_N = mkN "skärv" ;
  skaadis_nn_1_1_N = mkN "skådis" ;
  skaal_nn_1_1_N = mkN "skål" ;
  skaalgrop_nn_1_1_N = mkN "skålgrop" ;
  skaalsvamp_nn_1_1_N = mkN "skålsvamp" ;
  skaaning_nn_1_1_N = mkN "skåning" ;
  skaank_nn_1_1_N = mkN "skånk" ;
  skaapbil_nn_1_1_N = mkN "skåpbil" ;
  skaapsaeng_nn_1_1_N = mkN "skåpsäng" ;
  skaapvagn_nn_1_1_N = mkN "skåpvagn" ;
  skoel_nn_1_1_N = mkN "sköl" ;
  skoeld_nn_1_1_N = mkN "sköld" ;
  skoeldborg_nn_1_1_N = mkN "sköldborg" ;
  skoeldkoertel_nn_1_1_N = mkN "sköldkörtel" ;
  skoeldkoertelcancer_nn_1_1_N = mkN "sköldkörtelcancer" ;
  skoeljkopp_nn_1_1_N = mkN "sköljkopp" ;
  skoelp_nn_1_1_N = mkN "skölp" ;
  skoenhetsdrottning_nn_1_1_N = mkN "skönhetsdrottning" ;
  skoenhetsflaeck_nn_1_1_N = mkN "skönhetsfläck" ;
  skoenhetsmiss_nn_1_1_N = mkN "skönhetsmiss" ;
  skoerd_nn_1_1_N = mkN "skörd" ;
  skoerpil_nn_1_1_N = mkN "skörpil" ;
  skoet_nn_1_1_N = mkN "sköt" ;
  sladd_nn_1_N = mkN "sladd" ;
  slaf_nn_1_N = mkN "slaf" ;
  slafs_nn_1_N = mkN "slafs" ;
  slagborr_nn_1_N = mkN "slagborr" ;
  slagfjaeder_nn_1_1_N = mkN "slagfjäder" ;
  slaghoek_nn_1_1_N = mkN "slaghök" ;
  slang_nn_1_N = mkN "slang" ;
  slant_nn_1_N = mkN "slant" ;
  slarver_nn_1_N = mkN "slarver" ;
  slash_nn_1_N = mkN "slash" ;
  slashas_nn_1_N = mkN "slashas" ;
  slask_nn_2_N = mkN "slask" ;
  slatt_nn_1_N = mkN "slatt" ;
  slav_nn_1_N = mkN "slav" ;
  slejs_nn_1_N = mkN "slejs" ;
  slemsvamp_nn_1_N = mkN "slemsvamp" ;
  slemsaeck_nn_1_1_N = mkN "slemsäck" ;
  slev_nn_1_N = mkN "slev" ;
  slick_nn_1_N = mkN "slick" ;
  slickepott_nn_1_N = mkN "slickepott" ;
  slidkrans_nn_1_N = mkN "slidkrans" ;
  slingerbult_nn_1_N = mkN "slingerbult" ;
  slingerkoel_nn_1_1_N = mkN "slingerköl" ;
  slip_nn_1_N = mkN "slip" ;
  sliper_nn_1_N = mkN "sliper" ;
  slipkloss_nn_1_N = mkN "slipkloss" ;
  slips_nn_1_N = mkN "slips" ;
  slits_nn_1_N = mkN "slits" ;
  slitvarg_nn_1_N = mkN "slitvarg" ;
  slog_nn_1_N = mkN "slog" ;
  slok_nn_1_N = mkN "slok" ;
  slottsknekt_nn_1_N = mkN "slottsknekt" ;
  slow_fox_nn_1_N = mkN "slow-fox" ;
  slubb_nn_1_N = mkN "slubb" ;
  slump_nn_2_N = mkN "slump" ;
  slumsyster_nn_1_N = mkN "slumsyster" ;
  slup_nn_1_N = mkN "slup" ;
  slurk_nn_1_N = mkN "slurk" ;
  slusk_nn_1_N = mkN "slusk" ;
  sluss_nn_1_N = mkN "sluss" ;
  slutartikel_nn_1_N = mkN "slutartikel" ;
  slyngel_nn_1_N = mkN "slyngel" ;
  slaedhund_nn_1_1_N = mkN "slädhund" ;
  slaedmed_nn_1_1_N = mkN "slädmed" ;
  slaekting_nn_1_1_N = mkN "släkting" ;
  slaeng_nn_1_1_N = mkN "släng" ;
  slaengkyss_nn_1_1_N = mkN "slängkyss" ;
  slaeplogg_nn_1_1_N = mkN "släplogg" ;
  slaepnot_nn_1_1_N = mkN "släpnot" ;
  slaepvad_nn_1_1_N = mkN "släpvad" ;
  slaetfog_nn_1_1_N = mkN "slätfog" ;
  slaetharv_nn_1_1_N = mkN "slätharv" ;
  slaetprick_nn_1_1_N = mkN "slätprick" ;
  slaetsvamp_nn_1_1_N = mkN "slätsvamp" ;
  slaetvar_nn_1_1_N = mkN "slätvar" ;
  slaatter_nn_1_1_N = mkN "slåtter" ;
  slaattermyr_nn_1_1_N = mkN "slåttermyr" ;
  sloefock_nn_1_1_N = mkN "slöfock" ;
  sloejdspaentkniv_nn_1_1_N = mkN "slöjdspäntkniv" ;
  sloejskivling_nn_1_1_N = mkN "slöjskivling" ;
  sloejstjaert_nn_1_1_N = mkN "slöjstjärt" ;
  smack_nn_1_N = mkN "smack" ;
  smalvaegg_nn_1_1_N = mkN "smalvägg" ;
  smash_nn_1_N = mkN "smash" ;
  smatt_nn_1_N = mkN "smatt" ;
  smidespust_nn_1_N = mkN "smidespust" ;
  smilfink_nn_1_N = mkN "smilfink" ;
  smilgrop_nn_1_N = mkN "smilgrop" ;
  smitthaerd_nn_1_1_N = mkN "smitthärd" ;
  smittohaerd_nn_1_1_N = mkN "smittohärd" ;
  smoking_nn_1_N = mkN "smoking" ;
  smulgraat_nn_1_1_N = mkN "smulgråt" ;
  smurf_nn_1_N = mkN "smurf" ;
  smutsgris_nn_1_N = mkN "smutsgris" ;
  smutstitel_nn_1_N = mkN "smutstitel" ;
  smutt_nn_1_N = mkN "smutt" ;
  smyg_nn_1_N = mkN "smyg" ;
  smygvinkel_nn_1_N = mkN "smygvinkel" ;
  smaeck_nn_1_1_N = mkN "smäck" ;
  smaell_nn_1_1_N = mkN "smäll" ;
  smaeltdegel_nn_1_1_N = mkN "smältdegel" ;
  smaeltost_nn_1_1_N = mkN "smältost" ;
  smaeltpropp_nn_1_1_N = mkN "smältpropp" ;
  smaeltugn_nn_1_1_N = mkN "smältugn" ;
  smaabarnsfoeraelder_nn_1_1_N = mkN "småbarnsförälder" ;
  smaabil_nn_1_1_N = mkN "småbil" ;
  smaabaatshamn_nn_1_1_N = mkN "småbåtshamn" ;
  smaacitrus_nn_1_1_N = mkN "småcitrus" ;
  smaadopping_nn_1_1_N = mkN "smådopping" ;
  smaaeker_nn_1_1_N = mkN "småeker" ;
  smaafaagel_nn_1_1_N = mkN "småfågel" ;
  smaagris_nn_1_1_N = mkN "smågris" ;
  smaapeng_nn_1_1_N = mkN "småpeng" ;
  smaaskrak_nn_1_1_N = mkN "småskrak" ;
  smaaspov_nn_1_1_N = mkN "småspov" ;
  smaatting_nn_1_1_N = mkN "småtting" ;
  smoerbult_nn_1_1_N = mkN "smörbult" ;
  smoergaas_nn_1_1_N = mkN "smörgås" ;
  smoergaasgaffel_nn_1_1_N = mkN "smörgåsgaffel" ;
  smoergaaskniv_nn_1_1_N = mkN "smörgåskniv" ;
  smoerjgrop_nn_1_1_N = mkN "smörjgrop" ;
  smoerjhall_nn_1_1_N = mkN "smörjhall" ;
  smoerkniv_nn_1_1_N = mkN "smörkniv" ;
  smoersopp_nn_1_1_N = mkN "smörsopp" ;
  smoersvamp_nn_1_1_N = mkN "smörsvamp" ;
  snabbuss_nn_1_N = mkN "snabbuss" ;
  snabel_nn_1_N = mkN "snabel" ;
  snackis_nn_1_N = mkN "snackis" ;
  snaps_nn_1_N = mkN "snaps" ;
  snasker_nn_1_N = mkN "snasker" ;
  snedhiss_nn_1_N = mkN "snedhiss" ;
  snes_nn_1_N = mkN "snes" ;
  snibb_nn_1_N = mkN "snibb" ;
  snibbskaal_nn_1_1_N = mkN "snibbskål" ;
  snickarbaenk_nn_1_1_N = mkN "snickarbänk" ;
  sniff_nn_1_N = mkN "sniff" ;
  snigel_nn_1_N = mkN "snigel" ;
  snilleblixt_nn_1_N = mkN "snilleblixt" ;
  snip_nn_1_N = mkN "snip" ;
  snirkel_nn_1_N = mkN "snirkel" ;
  snitsel_nn_1_N = mkN "snitsel" ;
  snitt_nn_2_N = mkN "snitt" ;
  snobb_nn_1_N = mkN "snobb" ;
  snodd_nn_1_N = mkN "snodd" ;
  snok_nn_1_N = mkN "snok" ;
  snopp_nn_1_N = mkN "snopp" ;
  snorbroms_nn_1_N = mkN "snorbroms" ;
  snorgers_nn_1_N = mkN "snorgers" ;
  snorgaers_nn_1_1_N = mkN "snorgärs" ;
  snork_nn_1_N = mkN "snork" ;
  snorkel_nn_1_N = mkN "snorkel" ;
  snorvalp_nn_1_N = mkN "snorvalp" ;
  snudd_nn_1_N = mkN "snudd" ;
  snurrevad_nn_1_N = mkN "snurrevad" ;
  snusker_nn_1_N = mkN "snusker" ;
  snusmumrik_nn_1_N = mkN "snusmumrik" ;
  snusnaesduk_nn_1_1_N = mkN "snusnäsduk" ;
  snut_nn_1_N = mkN "snut" ;
  snutt_nn_1_N = mkN "snutt" ;
  snuttefilt_nn_1_N = mkN "snuttefilt" ;
  snygging_nn_1_N = mkN "snygging" ;
  snyting_nn_1_N = mkN "snyting" ;
  snaeckskruv_nn_1_1_N = mkN "snäckskruv" ;
  snaeckvaexel_nn_1_1_N = mkN "snäckväxel" ;
  snaeppfaagel_nn_1_1_N = mkN "snäppfågel" ;
  snaert_nn_1_1_N = mkN "snärt" ;
  snaaljaap_nn_1_1_N = mkN "snåljåp" ;
  snaalmaans_nn_1_1_N = mkN "snålmåns" ;
  snaalvarg_nn_1_1_N = mkN "snålvarg" ;
  snoepegel_nn_1_1_N = mkN "snöpegel" ;
  snoeping_nn_1_1_N = mkN "snöping" ;
  snoeplog_nn_1_1_N = mkN "snöplog" ;
  snoerpvad_nn_1_1_N = mkN "snörpvad" ;
  snoerstump_nn_1_1_N = mkN "snörstump" ;
  snoerstoevel_nn_1_1_N = mkN "snörstövel" ;
  snoescooter_nn_1_1_N = mkN "snöscooter" ;
  snoeskoter_nn_1_1_N = mkN "snöskoter" ;
  snoeskrud_nn_1_1_N = mkN "snöskrud" ;
  snoeskyffel_nn_1_1_N = mkN "snöskyffel" ;
  snoesparv_nn_1_1_N = mkN "snösparv" ;
  snoestorm_nn_1_1_N = mkN "snöstorm" ;
  snoevinter_nn_1_1_N = mkN "snövinter" ;
  sobel_nn_1_N = mkN "sobel" ;
  socialfoersaekringsminister_nn_1_1_N = mkN "socialförsäkringsminister" ;
  socialminister_nn_1_N = mkN "socialminister" ;
  sockel_nn_1_N = mkN "sockel" ;
  sockerloenn_nn_1_1_N = mkN "sockerlönn" ;
  sockerskaal_nn_1_1_N = mkN "sockerskål" ;
  sockertopp_nn_1_N = mkN "sockertopp" ;
  soffpotatis_nn_1_N = mkN "soffpotatis" ;
  sojabiff_nn_1_N = mkN "sojabiff" ;
  sol_nn_2_N = mkN "sol" ;
  solavaexel_nn_1_1_N = mkN "solaväxel" ;
  solbaenk_nn_1_1_N = mkN "solbänk" ;
  solcirkel_nn_1_N = mkN "solcirkel" ;
  soldatrock_nn_1_N = mkN "soldatrock" ;
  solfjaeder_nn_1_1_N = mkN "solfjäder" ;
  solflaeck_nn_1_1_N = mkN "solfläck" ;
  solsemester_nn_1_N = mkN "solsemester" ;
  solsnibb_nn_1_N = mkN "solsnibb" ;
  solstol_nn_1_N = mkN "solstol" ;
  solvarg_nn_1_N = mkN "solvarg" ;
  solvkaepp_nn_1_1_N = mkN "solvkäpp" ;
  sommareftermiddag_nn_1_N = mkN "sommareftermiddag" ;
  sommarfaagel_nn_1_1_N = mkN "sommarfågel" ;
  sommargylling_nn_1_N = mkN "sommargylling" ;
  sommarpotatis_nn_1_N = mkN "sommarpotatis" ;
  sommarsemester_nn_1_N = mkN "sommarsemester" ;
  sop_nn_1_N = mkN "sop" ;
  sopkvast_nn_1_N = mkN "sopkvast" ;
  sopp_nn_1_N = mkN "sopp" ;
  soppskaal_nn_1_1_N = mkN "soppskål" ;
  soppslev_nn_1_N = mkN "soppslev" ;
  sopskyffel_nn_1_N = mkN "sopskyffel" ;
  soptipp_nn_1_N = mkN "soptipp" ;
  sorbetglass_nn_1_N = mkN "sorbetglass" ;
  sorgmantel_nn_1_N = mkN "sorgmantel" ;
  sorgpil_nn_1_N = mkN "sorgpil" ;
  sork_nn_1_N = mkN "sork" ;
  sortimentask_nn_1_N = mkN "sortimentask" ;
  sotpartikel_nn_1_N = mkN "sotpartikel" ;
  sotsvamp_nn_1_N = mkN "sotsvamp" ;
  sovbrits_nn_1_N = mkN "sovbrits" ;
  sovsaeck_nn_1_1_N = mkN "sovsäck" ;
  sovvagn_nn_1_N = mkN "sovvagn" ;
  spackel_nn_2_N = mkN "spackel" ;
  spak_nn_1_N = mkN "spak" ;
  spargris_nn_1_N = mkN "spargris" ;
  spark_nn_1_N = mkN "spark" ;
  sparkcykel_nn_1_N = mkN "sparkcykel" ;
  sparkstoetting_nn_1_1_N = mkN "sparkstötting" ;
  sparring_nn_1_N = mkN "sparring" ;
  sparris_nn_1_N = mkN "sparris" ;
  sparslant_nn_1_N = mkN "sparslant" ;
  sparv_nn_1_N = mkN "sparv" ;
  sparvfink_nn_1_N = mkN "sparvfink" ;
  sparvhoek_nn_1_1_N = mkN "sparvhök" ;
  spatel_nn_1_N = mkN "spatel" ;
  spefaagel_nn_1_1_N = mkN "spefågel" ;
  spegel_nn_1_N = mkN "spegel" ;
  spelevinker_nn_1_N = mkN "spelevinker" ;
  spermamottagarsaeck_nn_1_1_N = mkN "spermamottagarsäck" ;
  spets_nn_1_N = mkN "spets" ;
  spetsartikel_nn_1_N = mkN "spetsartikel" ;
  spetsbov_nn_1_N = mkN "spetsbov" ;
  spetsgavel_nn_1_N = mkN "spetsgavel" ;
  spetshund_nn_1_N = mkN "spetshund" ;
  spigg_nn_1_N = mkN "spigg" ;
  spik_nn_1_N = mkN "spik" ;
  spikspets_nn_1_N = mkN "spikspets" ;
  spilkum_nn_1_N = mkN "spilkum" ;
  spindel_nn_1_N = mkN "spindel" ;
  spindelbult_nn_1_N = mkN "spindelbult" ;
  spindelvaev_nn_1_1_N = mkN "spindelväv" ;
  spinnaker_nn_1_N = mkN "spinnaker" ;
  spinnrock_nn_1_N = mkN "spinnrock" ;
  spiralfjaeder_nn_1_1_N = mkN "spiralfjäder" ;
  spiralkabel_nn_1_N = mkN "spiralkabel" ;
  spis_nn_1_N = mkN "spis" ;
  spisel_nn_1_N = mkN "spisel" ;
  spiselkrans_nn_1_N = mkN "spiselkrans" ;
  spiskrans_nn_1_N = mkN "spiskrans" ;
  spjutspets_nn_1_N = mkN "spjutspets" ;
  spjuver_nn_1_N = mkN "spjuver" ;
  spjaelsaeng_nn_1_1_N = mkN "spjälsäng" ;
  splejk_nn_1_N = mkN "splejk" ;
  spliss_nn_1_N = mkN "spliss" ;
  splits_nn_1_N = mkN "splits" ;
  spoling_nn_1_N = mkN "spoling" ;
  spolmask_nn_1_N = mkN "spolmask" ;
  sporkapsel_nn_1_N = mkN "sporkapsel" ;
  sporsaeck_nn_1_1_N = mkN "sporsäck" ;
  sportreporter_nn_1_N = mkN "sportreporter" ;
  sportvagn_nn_1_N = mkN "sportvagn" ;
  spottkoertel_nn_1_1_N = mkN "spottkörtel" ;
  spottstrit_nn_1_N = mkN "spottstrit" ;
  spottstyver_nn_1_N = mkN "spottstyver" ;
  spov_nn_1_N = mkN "spov" ;
  sprickdal_nn_1_N = mkN "sprickdal" ;
  springbock_nn_1_N = mkN "springbock" ;
  springbrunn_nn_1_N = mkN "springbrunn" ;
  springmask_nn_1_N = mkN "springmask" ;
  springschas_nn_1_N = mkN "springschas" ;
  springsjas_nn_1_N = mkN "springsjas" ;
  sprint_nn_1_N = mkN "sprint" ;
  sprits_nn_1_N = mkN "sprits" ;
  sprittermometer_nn_1_N = mkN "sprittermometer" ;
  sprutspets_nn_1_N = mkN "sprutspets" ;
  sprygel_nn_1_N = mkN "sprygel" ;
  spraengkapsel_nn_1_1_N = mkN "sprängkapsel" ;
  spraett_nn_1_1_N = mkN "sprätt" ;
  spraetthoek_nn_1_1_N = mkN "sprätthök" ;
  sproejs_nn_1_1_N = mkN "spröjs" ;
  sputnik_nn_1_N = mkN "sputnik" ;
  spaedgris_nn_1_1_N = mkN "spädgris" ;
  spaennvinkel_nn_1_1_N = mkN "spännvinkel" ;
  spaerr_nn_1_1_N = mkN "spärr" ;
  spaarhund_nn_1_1_N = mkN "spårhund" ;
  spaarmejsel_nn_1_1_N = mkN "spårmejsel" ;
  spaarvagn_nn_1_1_N = mkN "spårvagn" ;
  spoekpartikel_nn_1_1_N = mkN "spökpartikel" ;
  squashracket_nn_1_N = mkN "squashracket" ;
  stabbur_nn_1_N = mkN "stabbur" ;
  stack_nn_1_N = mkN "stack" ;
  stadsbuss_nn_1_N = mkN "stadsbuss" ;
  stadsjeep_nn_1_N = mkN "stadsjeep" ;
  stadsteater_nn_1_N = mkN "stadsteater" ;
  stagg_nn_1_N = mkN "stagg" ;
  stall_nn_3_N = mkN "stall" ;
  stallknekt_nn_1_N = mkN "stallknekt" ;
  stamp_nn_1_N = mkN "stamp" ;
  stampkvarn_nn_1_N = mkN "stampkvarn" ;
  standert_nn_1_N = mkN "standert" ;
  stannfaagel_nn_1_1_N = mkN "stannfågel" ;
  stanning_nn_1_N = mkN "stanning" ;
  stans_nn_1_N = mkN "stans" ;
  stapel_nn_1_N = mkN "stapel" ;
  stapelbaedd_nn_1_1_N = mkN "stapelbädd" ;
  starbaat_nn_1_1_N = mkN "starbåt" ;
  startgrop_nn_1_N = mkN "startgrop" ;
  startkabel_nn_1_N = mkN "startkabel" ;
  startnyckel_nn_1_N = mkN "startnyckel" ;
  startvev_nn_1_N = mkN "startvev" ;
  stationsvagn_nn_1_N = mkN "stationsvagn" ;
  statsminister_nn_1_N = mkN "statsminister" ;
  stav_nn_1_N = mkN "stav" ;
  stegbil_nn_1_N = mkN "stegbil" ;
  stegbaat_nn_1_1_N = mkN "stegbåt" ;
  stek_nn_1_N = mkN "stek" ;
  stekel_nn_1_N = mkN "stekel" ;
  stenbit_nn_1_N = mkN "stenbit" ;
  stenbock_nn_1_N = mkN "stenbock" ;
  stenbumling_nn_1_N = mkN "stenbumling" ;
  stendoes_nn_1_1_N = mkN "stendös" ;
  stenfalk_nn_1_N = mkN "stenfalk" ;
  stenhaell_nn_1_1_N = mkN "stenhäll" ;
  stenknaeck_nn_1_1_N = mkN "stenknäck" ;
  stenkross_nn_1_N = mkN "stenkross" ;
  stensopp_nn_1_N = mkN "stensopp" ;
  stickel_nn_1_N = mkN "stickel" ;
  stickert_nn_1_N = mkN "stickert" ;
  stickling_nn_1_N = mkN "stickling" ;
  stig_nn_1_N = mkN "stig" ;
  stigbygel_nn_1_N = mkN "stigbygel" ;
  stil_nn_1_N = mkN "stil" ;
  stilettkaepp_nn_1_1_N = mkN "stilettkäpp" ;
  stilldrink_nn_1_N = mkN "stilldrink" ;
  stilton_nn_1_N = mkN "stilton" ;
  stinksvamp_nn_1_N = mkN "stinksvamp" ;
  stins_nn_1_N = mkN "stins" ;
  stirr_nn_1_N = mkN "stirr" ;
  stjaelk_nn_1_1_N = mkN "stjälk" ;
  stjaernkusk_nn_1_1_N = mkN "stjärnkusk" ;
  stjaernmejsel_nn_1_1_N = mkN "stjärnmejsel" ;
  stjaernskaadis_nn_1_1_N = mkN "stjärnskådis" ;
  stjaernsmaell_nn_1_1_N = mkN "stjärnsmäll" ;
  stjaert_nn_1_1_N = mkN "stjärt" ;
  stjaertfjaeder_nn_1_1_N = mkN "stjärtfjäder" ;
  stjaertmes_nn_1_1_N = mkN "stjärtmes" ;
  stock_nn_1_N = mkN "stock" ;
  stockfisk_nn_1_N = mkN "stockfisk" ;
  stoftpartikel_nn_1_N = mkN "stoftpartikel" ;
  stol_nn_1_N = mkN "stol" ;
  stoll_nn_1_N = mkN "stoll" ;
  stolpbod_nn_1_N = mkN "stolpbod" ;
  stolsits_nn_1_N = mkN "stolsits" ;
  stolsrygg_nn_1_N = mkN "stolsrygg" ;
  stomp_nn_1_N = mkN "stomp" ;
  stoppnaal_nn_1_1_N = mkN "stoppnål" ;
  storasyster_nn_1_N = mkN "storasyster" ;
  storbaat_nn_1_1_N = mkN "storbåt" ;
  storcirkel_nn_1_N = mkN "storcirkel" ;
  storhertig_nn_1_N = mkN "storhertig" ;
  stork_nn_1_N = mkN "stork" ;
  storm_nn_1_N = mkN "storm" ;
  stormbaat_nn_1_1_N = mkN "stormbåt" ;
  stormfaagel_nn_1_1_N = mkN "stormfågel" ;
  storspov_nn_1_N = mkN "storspov" ;
  storsvensk_nn_1_N = mkN "storsvensk" ;
  stortopp_nn_1_N = mkN "stortopp" ;
  stortaanagel_nn_1_1_N = mkN "stortånagel" ;
  storvaest_nn_1_1_N = mkN "storväst" ;
  straff_nn_2_N = mkN "straff" ;
  strandartikel_nn_1_N = mkN "strandartikel" ;
  streber_nn_1_N = mkN "streber" ;
  stridis_nn_1_N = mkN "stridis" ;
  stridsspets_nn_1_N = mkN "stridsspets" ;
  stridstupp_nn_1_N = mkN "stridstupp" ;
  stridsvagn_nn_1_N = mkN "stridsvagn" ;
  strigel_nn_1_N = mkN "strigel" ;
  stril_nn_1_N = mkN "stril" ;
  strit_nn_1_N = mkN "strit" ;
  stropp_nn_1_N = mkN "stropp" ;
  stross_nn_1_N = mkN "stross" ;
  strudel_nn_1_N = mkN "strudel" ;
  strumphael_nn_1_1_N = mkN "strumphäl" ;
  strupcancer_nn_1_N = mkN "strupcancer" ;
  strut_nn_1_N = mkN "strut" ;
  struts_nn_1_N = mkN "struts" ;
  strutsfjaeder_nn_1_1_N = mkN "strutsfjäder" ;
  strykfaagel_nn_1_1_N = mkN "strykfågel" ;
  straeckbaenk_nn_1_1_N = mkN "sträckbänk" ;
  straeng_nn_1_1_N = mkN "sträng" ;
  straakorkester_nn_1_1_N = mkN "stråkorkester" ;
  straalkropp_nn_1_1_N = mkN "strålkropp" ;
  stroemkrets_nn_1_1_N = mkN "strömkrets" ;
  stroemvirvel_nn_1_1_N = mkN "strömvirvel" ;
  stubb_nn_1_N = mkN "stubb" ;
  studentteater_nn_1_N = mkN "studentteater" ;
  studiecirkel_nn_1_N = mkN "studiecirkel" ;
  studiedag_nn_1_N = mkN "studiedag" ;
  studiepenning_nn_1_N = mkN "studiepenning" ;
  studs_nn_1_N = mkN "studs" ;
  stump_nn_1_N = mkN "stump" ;
  stuss_nn_1_N = mkN "stuss" ;
  stut_nn_1_N = mkN "stut" ;
  stuv_nn_1_N = mkN "stuv" ;
  stuvbit_nn_1_N = mkN "stuvbit" ;
  stygging_nn_1_N = mkN "stygging" ;
  styrfjaeder_nn_1_1_N = mkN "styrfjäder" ;
  styrketaar_nn_1_1_N = mkN "styrketår" ;
  styrstav_nn_1_N = mkN "styrstav" ;
  styrvaexel_nn_1_1_N = mkN "styrväxel" ;
  styvfoeraelder_nn_1_1_N = mkN "styvförälder" ;
  staellmutter_nn_1_1_N = mkN "ställmutter" ;
  staemgaffel_nn_1_1_N = mkN "stämgaffel" ;
  staempel_nn_1_1_N = mkN "stämpel" ;
  staengel_nn_1_1_N = mkN "stängel" ;
  staev_nn_1_1_N = mkN "stäv" ;
  staafraes_nn_1_1_N = mkN "ståfräs" ;
  staalfjaeder_nn_1_1_N = mkN "stålfjäder" ;
  staalspik_nn_1_1_N = mkN "stålspik" ;
  staaltingest_nn_1_1_N = mkN "ståltingest" ;
  staalvajer_nn_1_1_N = mkN "stålvajer" ;
  staandman_nn_1_1_N = mkN "ståndman" ;
  stoer_nn_1_1_N = mkN "stör" ;
  stoet_nn_1_1_N = mkN "stöt" ;
  stoevel_nn_1_1_N = mkN "stövel" ;
  stoevelklack_nn_1_1_N = mkN "stövelklack" ;
  stoevelspets_nn_1_1_N = mkN "stövelspets" ;
  suck_nn_1_N = mkN "suck" ;
  sudd_nn_1_N = mkN "sudd" ;
  sug_nn_1_N = mkN "sug" ;
  sugkopp_nn_1_N = mkN "sugkopp" ;
  sump_nn_2_N = mkN "sump" ;
  sumpbaever_nn_1_1_N = mkN "sumpbäver" ;
  sup_nn_1_N = mkN "sup" ;
  superjet_nn_1_N = mkN "superjet" ;
  superkarg_nn_1_N = mkN "superkarg" ;
  supplementvinkel_nn_1_N = mkN "supplementvinkel" ;
  supporter_nn_1_N = mkN "supporter" ;
  surapel_nn_1_N = mkN "surapel" ;
  svabb_nn_1_N = mkN "svabb" ;
  sval_nn_1_N = mkN "sval" ;
  svalgmandel_nn_1_N = mkN "svalgmandel" ;
  svalstjaert_nn_1_1_N = mkN "svalstjärt" ;
  svamp_nn_1_N = mkN "svamp" ;
  svanhals_nn_1_N = mkN "svanhals" ;
  svankrygg_nn_1_N = mkN "svankrygg" ;
  svans_nn_1_N = mkN "svans" ;
  svanstipp_nn_1_N = mkN "svanstipp" ;
  svartaboershaj_nn_1_1_N = mkN "svartabörshaj" ;
  svarthakedopping_nn_1_N = mkN "svarthakedopping" ;
  svarting_nn_1_N = mkN "svarting" ;
  svartrock_nn_1_N = mkN "svartrock" ;
  svarv_nn_1_N = mkN "svarv" ;
  svarvstol_nn_1_N = mkN "svarvstol" ;
  svavelroek_nn_1_1_N = mkN "svavelrök" ;
  svensk_nn_1_N = mkN "svensk" ;
  svets_nn_1_N = mkN "svets" ;
  svettkoertel_nn_1_1_N = mkN "svettkörtel" ;
  svibel_nn_1_N = mkN "svibel" ;
  svid_nn_1_N = mkN "svid" ;
  svikt_nn_1_N = mkN "svikt" ;
  sving_nn_2_N = mkN "sving" ;
  svinpaels_nn_1_1_N = mkN "svinpäls" ;
  svinrygg_nn_1_N = mkN "svinrygg" ;
  svirvel_nn_1_N = mkN "svirvel" ;
  svivel_nn_1_N = mkN "svivel" ;
  svaeng_nn_1_1_N = mkN "sväng" ;
  svaengel_nn_1_1_N = mkN "svängel" ;
  svaengningskrets_nn_1_1_N = mkN "svängningskrets" ;
  svaengom_nn_1_1_N = mkN "svängom" ;
  svaerdfisk_nn_1_1_N = mkN "svärdfisk" ;
  svaerfoeraelder_nn_1_1_N = mkN "svärförälder" ;
  svaerm_nn_1_1_N = mkN "svärm" ;
  svaager_nn_1_1_N = mkN "svåger" ;
  svaal_nn_1_1_N = mkN "svål" ;
  sweater_nn_1_N = mkN "sweater" ;
  swing_nn_2_N = mkN "swing" ;
  swingpjatt_nn_1_N = mkN "swingpjatt" ;
  sydvaest_nn_2_1_N = mkN "sydväst" ;
  syl_nn_1_N = mkN "syl" ;
  syll_nn_1_N = mkN "syll" ;
  symfoniorkester_nn_1_N = mkN "symfoniorkester" ;
  symmetriaxel_nn_1_N = mkN "symmetriaxel" ;
  syndabock_nn_1_N = mkN "syndabock" ;
  syndapeng_nn_1_N = mkN "syndapeng" ;
  synk_nn_1_N = mkN "synk" ;
  synt_nn_1_N = mkN "synt" ;
  syntetklaedsel_nn_1_1_N = mkN "syntetklädsel" ;
  synvinkel_nn_1_N = mkN "synvinkel" ;
  syrinx_nn_1_N = mkN "syrinx" ;
  syskonbaedd_nn_1_1_N = mkN "syskonbädd" ;
  syssling_nn_1_N = mkN "syssling" ;
  syster_nn_1_N = mkN "syster" ;
  saeck_nn_1_1_N = mkN "säck" ;
  saecksvamp_nn_1_1_N = mkN "säcksvamp" ;
  saedesskyl_nn_1_1_N = mkN "sädesskyl" ;
  saekerhetsbroms_nn_1_1_N = mkN "säkerhetsbroms" ;
  saekerhetssprint_nn_1_1_N = mkN "säkerhetssprint" ;
  sael_nn_1_1_N = mkN "säl" ;
  saelg_nn_1_1_N = mkN "sälg" ;
  saelkut_nn_1_1_N = mkN "sälkut" ;
  saeng_nn_1_1_N = mkN "säng" ;
  saenggavel_nn_1_1_N = mkN "sänggavel" ;
  saerk_nn_1_1_N = mkN "särk" ;
  saerling_nn_1_1_N = mkN "särling" ;
  saeter_nn_1_1_N = mkN "säter" ;
  saetesgaard_nn_1_1_N = mkN "sätesgård" ;
  saettpotatis_nn_1_1_N = mkN "sättpotatis" ;
  saag_nn_1_1_N = mkN "såg" ;
  saagbock_nn_1_1_N = mkN "sågbock" ;
  saagfisk_nn_1_1_N = mkN "sågfisk" ;
  saangarfaagel_nn_1_1_N = mkN "sångarfågel" ;
  saangfaagel_nn_1_1_N = mkN "sångfågel" ;
  saangsvan_nn_1_1_N = mkN "sångsvan" ;
  saapaskaadis_nn_1_1_N = mkN "såpaskådis" ;
  soedergoek_nn_1_1_N = mkN "södergök" ;
  soederkis_nn_1_1_N = mkN "söderkis" ;
  soedersol_nn_1_1_N = mkN "södersol" ;
  soendageftermiddag_nn_1_1_N = mkN "söndageftermiddag" ;
  soendagkvaell_nn_1_1_N = mkN "söndagkväll" ;
  soendagseftermiddag_nn_1_1_N = mkN "söndagseftermiddag" ;
  soendagskvaell_nn_1_1_N = mkN "söndagskväll" ;
  soetmandel_nn_1_1_N = mkN "sötmandel" ;
  soetnos_nn_1_1_N = mkN "sötnos" ;
  soetpotatis_nn_1_1_N = mkN "sötpotatis" ;
  t_shirt_nn_1_N = mkN "t-shirt" ;
  tacksaegelsedag_nn_1_1_N = mkN "tacksägelsedag" ;
  taffel_nn_1_N = mkN "taffel" ;
  tafs_nn_1_N = mkN "tafs" ;
  tagelmask_nn_1_N = mkN "tagelmask" ;
  tagetes_nn_1_N = mkN "tagetes" ;
  tagg_nn_1_N = mkN "tagg" ;
  taggfening_nn_1_N = mkN "taggfening" ;
  tagghuding_nn_1_N = mkN "tagghuding" ;
  taggsvamp_nn_1_N = mkN "taggsvamp" ;
  takbox_nn_1_N = mkN "takbox" ;
  taknock_nn_1_N = mkN "taknock" ;
  takometer_nn_1_N = mkN "takometer" ;
  takregel_nn_1_N = mkN "takregel" ;
  takymeter_nn_1_N = mkN "takymeter" ;
  takaas_nn_1_1_N = mkN "takås" ;
  talarstol_nn_1_N = mkN "talarstol" ;
  talgdank_nn_1_N = mkN "talgdank" ;
  talgkoertel_nn_1_1_N = mkN "talgkörtel" ;
  tall_nn_1_N = mkN "tall" ;
  tallbit_nn_1_N = mkN "tallbit" ;
  tallbock_nn_1_N = mkN "tallbock" ;
  tallkottkoertel_nn_1_1_N = mkN "tallkottkörtel" ;
  tallkottskoertel_nn_1_1_N = mkN "tallkottskörtel" ;
  tallriksharv_nn_1_N = mkN "tallriksharv" ;
  tallstekel_nn_1_N = mkN "tallstekel" ;
  taltrast_nn_1_N = mkN "taltrast" ;
  tamfaagel_nn_1_1_N = mkN "tamfågel" ;
  tamp_nn_1_N = mkN "tamp" ;
  tandemcykel_nn_1_N = mkN "tandemcykel" ;
  tandfistel_nn_1_N = mkN "tandfistel" ;
  tandhals_nn_1_N = mkN "tandhals" ;
  tandhyvel_nn_1_N = mkN "tandhyvel" ;
  tandhaevel_nn_1_1_N = mkN "tandhävel" ;
  tandval_nn_1_N = mkN "tandval" ;
  tank_nn_1_N = mkN "tank" ;
  tapisserinaal_nn_1_1_N = mkN "tapisserinål" ;
  tapp_nn_1_N = mkN "tapp" ;
  tappkran_nn_1_N = mkN "tappkran" ;
  tarantel_nn_1_N = mkN "tarantel" ;
  tarm_nn_1_N = mkN "tarm" ;
  tarmfistel_nn_1_N = mkN "tarmfistel" ;
  tartarbiff_nn_1_N = mkN "tartarbiff" ;
  tartarsmoergaas_nn_1_1_N = mkN "tartarsmörgås" ;
  task_nn_1_N = mkN "task" ;
  tass_nn_1_N = mkN "tass" ;
  tavelsudd_nn_1_N = mkN "tavelsudd" ;
  tax_nn_1_N = mkN "tax" ;
  taxameter_nn_1_N = mkN "taxameter" ;
  taxeringskalender_nn_1_N = mkN "taxeringskalender" ;
  taxibil_nn_1_N = mkN "taxibil" ;
  taxvalp_nn_1_N = mkN "taxvalp" ;
  teater_nn_1_N = mkN "teater" ;
  teg_nn_1_N = mkN "teg" ;
  tejst_nn_1_N = mkN "tejst" ;
  tekopp_nn_1_N = mkN "tekopp" ;
  telefonlur_nn_1_N = mkN "telefonlur" ;
  telefonvaexel_nn_1_1_N = mkN "telefonväxel" ;
  telegrafnyckel_nn_1_N = mkN "telegrafnyckel" ;
  telemeter_nn_1_N = mkN "telemeter" ;
  teleprinter_nn_1_N = mkN "teleprinter" ;
  telfer_nn_1_N = mkN "telfer" ;
  teln_nn_1_N = mkN "teln" ;
  temp_nn_1_N = mkN "temp" ;
  tender_nn_1_N = mkN "tender" ;
  tennisracket_nn_1_N = mkN "tennisracket" ;
  termometer_nn_1_N = mkN "termometer" ;
  termos_nn_1_N = mkN "termos" ;
  termostapel_nn_1_N = mkN "termostapel" ;
  terraengscooter_nn_1_1_N = mkN "terrängscooter" ;
  terraengskoter_nn_1_1_N = mkN "terrängskoter" ;
  terraengvinkel_nn_1_1_N = mkN "terrängvinkel" ;
  tesaurus_nn_1_N = mkN "tesaurus" ;
  test_nn_2_N = mkN "test" ;
  testcykel_nn_1_N = mkN "testcykel" ;
  testikel_nn_1_N = mkN "testikel" ;
  tetraeder_nn_1_N = mkN "tetraeder" ;
  tevagn_nn_1_N = mkN "tevagn" ;
  teveskaerm_nn_1_1_N = mkN "teveskärm" ;
  textskaerm_nn_1_1_N = mkN "textskärm" ;
  tidningsartikel_nn_1_N = mkN "tidningsartikel" ;
  tidningsblunder_nn_1_N = mkN "tidningsblunder" ;
  tidskriftsartikel_nn_1_N = mkN "tidskriftsartikel" ;
  tidsaalder_nn_1_1_N = mkN "tidsålder" ;
  tiger_nn_1_N = mkN "tiger" ;
  tigerhaj_nn_1_N = mkN "tigerhaj" ;
  tigerorm_nn_1_N = mkN "tigerorm" ;
  tik_nn_1_N = mkN "tik" ;
  tillhaallarfjaeder_nn_1_1_N = mkN "tillhållarfjäder" ;
  timcirkel_nn_1_N = mkN "timcirkel" ;
  timing_nn_1_N = mkN "timing" ;
  timmerbroet_nn_1_1_N = mkN "timmerbröt" ;
  timmerlaens_nn_1_1_N = mkN "timmerläns" ;
  timmersax_nn_1_N = mkN "timmersax" ;
  timmersvans_nn_1_N = mkN "timmersvans" ;
  tingest_nn_1_N = mkN "tingest" ;
  tinning_nn_1_N = mkN "tinning" ;
  tiofoting_nn_1_N = mkN "tiofoting" ;
  tiokronorssedel_nn_1_N = mkN "tiokronorssedel" ;
  tipp_nn_1_N = mkN "tipp" ;
  tir_nn_1_N = mkN "tir" ;
  tisdageftermiddag_nn_1_N = mkN "tisdageftermiddag" ;
  tisdagkvaell_nn_1_1_N = mkN "tisdagkväll" ;
  tisdagseftermiddag_nn_1_N = mkN "tisdagseftermiddag" ;
  tisdagskvaell_nn_1_1_N = mkN "tisdagskväll" ;
  tistel_nn_1_N = mkN "tistel" ;
  titel_nn_1_N = mkN "titel" ;
  titt_nn_1_N = mkN "titt" ;
  tittarstorm_nn_1_N = mkN "tittarstorm" ;
  tittglugg_nn_1_N = mkN "tittglugg" ;
  tjalk_nn_1_N = mkN "tjalk" ;
  tjejkompis_nn_1_N = mkN "tjejkompis" ;
  tjockhuding_nn_1_N = mkN "tjockhuding" ;
  tjockis_nn_1_N = mkN "tjockis" ;
  tjocktarm_nn_1_N = mkN "tjocktarm" ;
  tjugondedag_nn_1_N = mkN "tjugondedag" ;
  tjur_nn_1_N = mkN "tjur" ;
  tjuv_nn_1_N = mkN "tjuv" ;
  tjuvpojksglimt_nn_1_N = mkN "tjuvpojksglimt" ;
  tjuvskytt_nn_1_N = mkN "tjuvskytt" ;
  tjuvstryker_nn_1_N = mkN "tjuvstryker" ;
  tjuvtitt_nn_1_N = mkN "tjuvtitt" ;
  tjyv_nn_1_N = mkN "tjyv" ;
  tjyvtitt_nn_1_N = mkN "tjyvtitt" ;
  tjaeder_nn_1_1_N = mkN "tjäder" ;
  tjaedertupp_nn_1_1_N = mkN "tjädertupp" ;
  tjaerdal_nn_1_1_N = mkN "tjärdal" ;
  toalettartikel_nn_1_N = mkN "toalettartikel" ;
  toalettsits_nn_1_N = mkN "toalettsits" ;
  toalettvaal_nn_1_1_N = mkN "toalettvål" ;
  toastmaster_nn_1_N = mkN "toastmaster" ;
  tobis_nn_1_N = mkN "tobis" ;
  tobiskung_nn_1_N = mkN "tobiskung" ;
  tofs_nn_1_N = mkN "tofs" ;
  tofsmes_nn_1_N = mkN "tofsmes" ;
  tofsskivling_nn_1_N = mkN "tofsskivling" ;
  tok_nn_1_N = mkN "tok" ;
  toker_nn_1_N = mkN "toker" ;
  tolk_nn_1_N = mkN "tolk" ;
  tolvfingertarm_nn_1_N = mkN "tolvfingertarm" ;
  tolvskilling_nn_1_N = mkN "tolvskilling" ;
  tonarm_nn_1_N = mkN "tonarm" ;
  tonfisk_nn_1_N = mkN "tonfisk" ;
  topp_nn_1_N = mkN "topp" ;
  topphaest_nn_1_1_N = mkN "topphäst" ;
  topping_nn_1_N = mkN "topping" ;
  toppknopp_nn_1_N = mkN "toppknopp" ;
  tordyvel_nn_1_N = mkN "tordyvel" ;
  tork_nn_1_N = mkN "tork" ;
  torkhandduk_nn_1_N = mkN "torkhandduk" ;
  torn_nn_2_N = mkN "torn" ;
  tornfalk_nn_1_N = mkN "tornfalk" ;
  tornister_nn_1_N = mkN "tornister" ;
  torpedbaat_nn_1_1_N = mkN "torpedbåt" ;
  torris_nn_2_N = mkN "torris" ;
  torrnaal_nn_1_1_N = mkN "torrnål" ;
  torsdageftermiddag_nn_1_N = mkN "torsdageftermiddag" ;
  torsdagkvaell_nn_1_1_N = mkN "torsdagkväll" ;
  torsdagseftermiddag_nn_1_N = mkN "torsdagseftermiddag" ;
  torsdagskvaell_nn_1_1_N = mkN "torsdagskväll" ;
  torsk_nn_1_N = mkN "torsk" ;
  torskfisk_nn_1_N = mkN "torskfisk" ;
  torvjord_nn_1_N = mkN "torvjord" ;
  tosing_nn_1_N = mkN "tosing" ;
  tott_nn_1_N = mkN "tott" ;
  trafikfyr_nn_1_N = mkN "trafikfyr" ;
  trak_egael_nn_1_1_N = mkN "trakégäl" ;
  trall_nn_1_N = mkN "trall" ;
  trallvagn_nn_1_N = mkN "trallvagn" ;
  trampbil_nn_1_N = mkN "trampbil" ;
  trampcykel_nn_1_N = mkN "trampcykel" ;
  trampkvarn_nn_1_N = mkN "trampkvarn" ;
  trampsax_nn_1_N = mkN "trampsax" ;
  transithall_nn_1_N = mkN "transithall" ;
  transitohamn_nn_1_N = mkN "transitohamn" ;
  transmitter_nn_1_N = mkN "transmitter" ;
  transversalaxel_nn_1_N = mkN "transversalaxel" ;
  trapp_nn_1_N = mkN "trapp" ;
  trappgavel_nn_1_N = mkN "trappgavel" ;
  trappsmyg_nn_1_N = mkN "trappsmyg" ;
  trashank_nn_1_N = mkN "trashank" ;
  trasselsudd_nn_1_N = mkN "trasselsudd" ;
  trast_nn_1_N = mkN "trast" ;
  trastfaagel_nn_1_1_N = mkN "trastfågel" ;
  tratt_nn_1_N = mkN "tratt" ;
  trattprick_nn_1_N = mkN "trattprick" ;
  trattskivling_nn_1_N = mkN "trattskivling" ;
  travhaest_nn_1_1_N = mkN "travhäst" ;
  tredjedag_nn_1_N = mkN "tredjedag" ;
  trehjuling_nn_1_N = mkN "trehjuling" ;
  tremaenning_nn_1_1_N = mkN "tremänning" ;
  trench_nn_1_N = mkN "trench" ;
  trenchcoat_nn_1_N = mkN "trenchcoat" ;
  tresnibb_nn_1_N = mkN "tresnibb" ;
  tretumsspik_nn_1_N = mkN "tretumsspik" ;
  tretaar_nn_1_1_N = mkN "tretår" ;
  treudd_nn_1_N = mkN "treudd" ;
  trevaegskran_nn_1_1_N = mkN "trevägskran" ;
  triangel_nn_1_N = mkN "triangel" ;
  trilling_nn_1_N = mkN "trilling" ;
  trillingfoedsel_nn_1_1_N = mkN "trillingfödsel" ;
  trimeter_nn_1_N = mkN "trimeter" ;
  trimtank_nn_1_N = mkN "trimtank" ;
  trindmask_nn_1_N = mkN "trindmask" ;
  trippel_nn_2_N = mkN "trippel" ;
  trippelfoedsel_nn_1_1_N = mkN "trippelfödsel" ;
  trippelseger_nn_1_N = mkN "trippelseger" ;
  trips_nn_1_N = mkN "trips" ;
  trojeborg_nn_1_N = mkN "trojeborg" ;
  trolleybuss_nn_1_N = mkN "trolleybuss" ;
  trollkarl_nn_1_N = mkN "trollkarl" ;
  trollkaering_nn_1_1_N = mkN "trollkäring" ;
  trollkaerring_nn_1_1_N = mkN "trollkärring" ;
  trollstav_nn_1_N = mkN "trollstav" ;
  tropikfaagel_nn_1_1_N = mkN "tropikfågel" ;
  tropp_nn_1_N = mkN "tropp" ;
  trosartikel_nn_1_N = mkN "trosartikel" ;
  trosgoerdel_nn_1_1_N = mkN "trosgördel" ;
  tross_nn_1_N = mkN "tross" ;
  trosshaest_nn_1_1_N = mkN "trosshäst" ;
  trotsaalder_nn_1_1_N = mkN "trotsålder" ;
  trubbnos_nn_1_N = mkN "trubbnos" ;
  truck_nn_1_N = mkN "truck" ;
  truls_nn_1_N = mkN "truls" ;
  trumbroms_nn_1_N = mkN "trumbroms" ;
  trumvirvel_nn_1_N = mkN "trumvirvel" ;
  trunk_nn_1_N = mkN "trunk" ;
  trut_nn_1_N = mkN "trut" ;
  tryckpress_nn_1_N = mkN "tryckpress" ;
  tryckstil_nn_1_N = mkN "tryckstil" ;
  tryffel_nn_2_N = mkN "tryffel" ;
  tryffelsvamp_nn_1_N = mkN "tryffelsvamp" ;
  traebock_nn_1_1_N = mkN "träbock" ;
  traedgaard_nn_1_1_N = mkN "trädgård" ;
  traedgaardssax_nn_1_1_N = mkN "trädgårdssax" ;
  traedsvamp_nn_1_1_N = mkN "trädsvamp" ;
  traedtopp_nn_1_1_N = mkN "trädtopp" ;
  traeff_nn_1_1_N = mkN "träff" ;
  traefrack_nn_1_1_N = mkN "träfrack" ;
  traefraes_nn_1_1_N = mkN "träfräs" ;
  traehaest_nn_1_1_N = mkN "trähäst" ;
  traekarl_nn_1_1_N = mkN "träkarl" ;
  traekloss_nn_1_1_N = mkN "träkloss" ;
  trael_nn_1_1_N = mkN "träl" ;
  traemask_nn_1_1_N = mkN "trämask" ;
  traemortel_nn_1_1_N = mkN "trämortel" ;
  traens_nn_1_1_N = mkN "träns" ;
  traeskostoevel_nn_1_1_N = mkN "träskostövel" ;
  traeskaal_nn_1_1_N = mkN "träskål" ;
  traeslev_nn_1_1_N = mkN "träslev" ;
  traeslip_nn_1_1_N = mkN "träslip" ;
  traestav_nn_1_1_N = mkN "trästav" ;
  traesvarv_nn_1_1_N = mkN "träsvarv" ;
  traevaruhandel_nn_1_1_N = mkN "trävaruhandel" ;
  traad_nn_1_1_N = mkN "tråd" ;
  traadbuss_nn_1_1_N = mkN "trådbuss" ;
  traaddiameter_nn_1_1_N = mkN "tråddiameter" ;
  traadduk_nn_1_1_N = mkN "trådduk" ;
  traadmask_nn_1_1_N = mkN "trådmask" ;
  traadsax_nn_1_1_N = mkN "trådsax" ;
  traadskivling_nn_1_1_N = mkN "trådskivling" ;
  traadspik_nn_1_1_N = mkN "trådspik" ;
  traagdal_nn_1_1_N = mkN "trågdal" ;
  traak_nn_2_1_N = mkN "tråk" ;
  traakmaans_nn_1_1_N = mkN "tråkmåns" ;
  traal_nn_1_1_N = mkN "trål" ;
  troeskel_nn_1_1_N = mkN "tröskel" ;
  troest_nn_2_1_N = mkN "tröst" ;
  troestnapp_nn_1_1_N = mkN "tröstnapp" ;
  tuffing_nn_1_N = mkN "tuffing" ;
  tuggbuss_nn_1_N = mkN "tuggbuss" ;
  tull_nn_1_N = mkN "tull" ;
  tullmur_nn_1_N = mkN "tullmur" ;
  tummetott_nn_1_N = mkN "tummetott" ;
  tumnagel_nn_1_N = mkN "tumnagel" ;
  tumskruv_nn_1_N = mkN "tumskruv" ;
  tungmask_nn_1_N = mkN "tungmask" ;
  tungrygg_nn_1_N = mkN "tungrygg" ;
  tungspets_nn_1_N = mkN "tungspets" ;
  tunnel_nn_1_N = mkN "tunnel" ;
  tunnelugn_nn_1_N = mkN "tunnelugn" ;
  tunnstav_nn_1_N = mkN "tunnstav" ;
  tunntarm_nn_1_N = mkN "tunntarm" ;
  tupp_nn_1_N = mkN "tupp" ;
  tuppkyckling_nn_1_N = mkN "tuppkyckling" ;
  tupplur_nn_1_N = mkN "tupplur" ;
  turistsaeng_nn_1_1_N = mkN "turistsäng" ;
  turk_nn_1_N = mkN "turk" ;
  turn_ebuss_nn_1_1_N = mkN "turnébuss" ;
  turs_nn_1_N = mkN "turs" ;
  tusenfoting_nn_1_N = mkN "tusenfoting" ;
  tusenkronorssedel_nn_1_N = mkN "tusenkronorssedel" ;
  tusenlapp_nn_1_N = mkN "tusenlapp" ;
  tuss_nn_1_N = mkN "tuss" ;
  tut_nn_1_N = mkN "tut" ;
  tuting_nn_1_N = mkN "tuting" ;
  tutt_nn_1_N = mkN "tutt" ;
  tuvtaatel_nn_1_1_N = mkN "tuvtåtel" ;
  tv_skaerm_nn_1_1_N = mkN "tv-skärm" ;
  tvestjaert_nn_1_1_N = mkN "tvestjärt" ;
  tvilling_nn_1_N = mkN "tvilling" ;
  tvillingfoedsel_nn_1_1_N = mkN "tvillingfödsel" ;
  tvillingsyster_nn_1_N = mkN "tvillingsyster" ;
  tvillingvagn_nn_1_N = mkN "tvillingvagn" ;
  tving_nn_1_N = mkN "tving" ;
  tvaeraxel_nn_1_1_N = mkN "tväraxel" ;
  tvaerbalk_nn_1_1_N = mkN "tvärbalk" ;
  tvaernit_nn_1_1_N = mkN "tvärnit" ;
  tvaervigg_nn_1_1_N = mkN "tvärvigg" ;
  tvaett_nn_1_1_N = mkN "tvätt" ;
  tvaettlapp_nn_1_1_N = mkN "tvättlapp" ;
  tvaahjuling_nn_1_1_N = mkN "tvåhjuling" ;
  tvaal_nn_1_1_N = mkN "tvål" ;
  tvaalask_nn_1_1_N = mkN "tvålask" ;
  tvaalkopp_nn_1_1_N = mkN "tvålkopp" ;
  tvaamaenning_nn_1_1_N = mkN "tvåmänning" ;
  tvaatumsspik_nn_1_1_N = mkN "tvåtumsspik" ;
  tvaavaaningsbuss_nn_1_1_N = mkN "tvåvåningsbuss" ;
  tvaaaeggstvilling_nn_1_1_N = mkN "tvåäggstvilling" ;
  tygel_nn_1_N = mkN "tygel" ;
  tykobrahedag_nn_1_N = mkN "tykobrahedag" ;
  tyllschal_nn_1_N = mkN "tyllschal" ;
  tyllsjal_nn_1_N = mkN "tyllsjal" ;
  tysk_nn_1_N = mkN "tysk" ;
  taeckmantel_nn_1_1_N = mkN "täckmantel" ;
  taeltsaeng_nn_1_1_N = mkN "tältsäng" ;
  taendningsnyckel_nn_1_1_N = mkN "tändningsnyckel" ;
  taendsticksask_nn_1_1_N = mkN "tändsticksask" ;
  taethetstopp_nn_1_1_N = mkN "täthetstopp" ;
  taetting_nn_1_1_N = mkN "tätting" ;
  taettingfaagel_nn_1_1_N = mkN "tättingfågel" ;
  taanagel_nn_1_1_N = mkN "tånagel" ;
  taar_nn_1_1_N = mkN "tår" ;
  taaredal_nn_1_1_N = mkN "tåredal" ;
  taarkoertel_nn_1_1_N = mkN "tårkörtel" ;
  taarpil_nn_1_1_N = mkN "tårpil" ;
  taarsaeck_nn_1_1_N = mkN "tårsäck" ;
  taaspets_nn_1_1_N = mkN "tåspets" ;
  taat_nn_1_1_N = mkN "tåt" ;
  toelp_nn_1_1_N = mkN "tölp" ;
  toent_nn_1_1_N = mkN "tönt" ;
  toern_nn_1_1_N = mkN "törn" ;
  toerntagg_nn_1_1_N = mkN "törntagg" ;
  u_baat_nn_1_1_N = mkN "u-båt" ;
  ubaat_nn_1_1_N = mkN "ubåt" ;
  udd_nn_1_N = mkN "udd" ;
  ugn_nn_1_N = mkN "ugn" ;
  ugnsfisk_nn_1_N = mkN "ugnsfisk" ;
  ugnsplaat_nn_1_1_N = mkN "ugnsplåt" ;
  ulk_nn_1_N = mkN "ulk" ;
  ullsax_nn_1_N = mkN "ullsax" ;
  ulltork_nn_1_N = mkN "ulltork" ;
  ulltott_nn_1_N = mkN "ulltott" ;
  ulster_nn_1_N = mkN "ulster" ;
  ulv_nn_1_N = mkN "ulv" ;
  umgaengeskrets_nn_1_1_N = mkN "umgängeskrets" ;
  underarm_nn_1_N = mkN "underarm" ;
  underbaedd_nn_1_1_N = mkN "underbädd" ;
  underdomstol_nn_1_N = mkN "underdomstol" ;
  underhaallningsorkester_nn_1_1_N = mkN "underhållningsorkester" ;
  underkropp_nn_1_N = mkN "underkropp" ;
  undertitel_nn_1_N = mkN "undertitel" ;
  undervattenskropp_nn_1_N = mkN "undervattenskropp" ;
  undervattenstroeskel_nn_1_1_N = mkN "undervattenströskel" ;
  undsaettningshaer_nn_1_1_N = mkN "undsättningshär" ;
  ungdomsbrottsling_nn_1_N = mkN "ungdomsbrottsling" ;
  ungdomsgaard_nn_1_1_N = mkN "ungdomsgård" ;
  unghaest_nn_1_1_N = mkN "unghäst" ;
  ungkarl_nn_1_N = mkN "ungkarl" ;
  ungsvensk_nn_1_N = mkN "ungsvensk" ;
  ungtall_nn_1_N = mkN "ungtall" ;
  ungtupp_nn_1_N = mkN "ungtupp" ;
  ungturk_nn_1_N = mkN "ungturk" ;
  uniformsrock_nn_1_N = mkN "uniformsrock" ;
  uniformsslips_nn_1_N = mkN "uniformsslips" ;
  unikabox_nn_1_N = mkN "unikabox" ;
  universitetsbokhandel_nn_1_N = mkN "universitetsbokhandel" ;
  universitetsmatrikel_nn_1_N = mkN "universitetsmatrikel" ;
  uppesittarkvaell_nn_1_1_N = mkN "uppesittarkväll" ;
  upphalningsbaedd_nn_1_1_N = mkN "upphalningsbädd" ;
  upprorshaerd_nn_1_1_N = mkN "upprorshärd" ;
  uppsatstitel_nn_1_N = mkN "uppsatstitel" ;
  uppsittarkvaell_nn_1_1_N = mkN "uppsittarkväll" ;
  ur_nn_2_N = mkN "ur" ;
  uranstapel_nn_1_N = mkN "uranstapel" ;
  urfjaellsjord_nn_1_1_N = mkN "urfjällsjord" ;
  urfaagel_nn_1_1_N = mkN "urfågel" ;
  uribag_nn_1_N = mkN "uribag" ;
  urinbrunn_nn_1_N = mkN "urinbrunn" ;
  urinkur_nn_1_N = mkN "urinkur" ;
  urnebrandgrop_nn_1_N = mkN "urnebrandgrop" ;
  urnyckel_nn_1_N = mkN "urnyckel" ;
  ursmaell_nn_1_1_N = mkN "ursmäll" ;
  usling_nn_1_N = mkN "usling" ;
  utbildningsminister_nn_1_N = mkN "utbildningsminister" ;
  utbrytarkung_nn_1_N = mkN "utbrytarkung" ;
  utboeling_nn_1_1_N = mkN "utböling" ;
  utboerding_nn_1_1_N = mkN "utbörding" ;
  utegrill_nn_1_N = mkN "utegrill" ;
  utekvaell_nn_1_1_N = mkN "utekväll" ;
  utetermometer_nn_1_N = mkN "utetermometer" ;
  utgaard_nn_1_1_N = mkN "utgård" ;
  uthamn_nn_1_N = mkN "uthamn" ;
  uthusnyckel_nn_1_N = mkN "uthusnyckel" ;
  utkik_nn_1_N = mkN "utkik" ;
  utlandssvensk_nn_1_N = mkN "utlandssvensk" ;
  utrikeshandelsminister_nn_1_N = mkN "utrikeshandelsminister" ;
  utrikesminister_nn_1_N = mkN "utrikesminister" ;
  utstyrsel_nn_1_N = mkN "utstyrsel" ;
  utter_nn_1_N = mkN "utter" ;
  utvikningsbrud_nn_1_N = mkN "utvikningsbrud" ;
  utviksbrud_nn_1_N = mkN "utviksbrud" ;
  uv_nn_1_N = mkN "uv" ;
  vab_dag_nn_1_N = mkN "vab-dag" ;
  vab_nn_1_N = mkN "vab" ;
  vabb_dag_nn_1_N = mkN "vabb-dag" ;
  vabb_nn_1_N = mkN "vabb" ;
  vabbdag_nn_1_N = mkN "vabbdag" ;
  vabdag_nn_1_N = mkN "vabdag" ;
  vacuumbroms_nn_1_N = mkN "vacuumbroms" ;
  vacuummeter_nn_1_N = mkN "vacuummeter" ;
  vad_nn_3_N = mkN "vad" ;
  vadarfaagel_nn_1_1_N = mkN "vadarfågel" ;
  vadd_nn_1_N = mkN "vadd" ;
  vagel_nn_1_N = mkN "vagel" ;
  vagn_nn_1_N = mkN "vagn" ;
  vagnborg_nn_1_N = mkN "vagnborg" ;
  vagnhall_nn_1_N = mkN "vagnhall" ;
  vagnshaest_nn_1_1_N = mkN "vagnshäst" ;
  vagnskorg_nn_1_N = mkN "vagnskorg" ;
  vajer_nn_1_N = mkN "vajer" ;
  vak_nn_1_N = mkN "vak" ;
  vakfaagel_nn_1_1_N = mkN "vakfågel" ;
  vaktel_nn_1_N = mkN "vaktel" ;
  vakthund_nn_1_N = mkN "vakthund" ;
  vaktkur_nn_1_N = mkN "vaktkur" ;
  vakuumbroms_nn_1_N = mkN "vakuumbroms" ;
  vakuummeter_nn_1_N = mkN "vakuummeter" ;
  val_nn_2_N = mkN "val" ;
  valbarometer_nn_1_N = mkN "valbarometer" ;
  valbiskop_nn_1_N = mkN "valbiskop" ;
  valfisk_nn_1_N = mkN "valfisk" ;
  valk_nn_1_N = mkN "valk" ;
  valkrets_nn_1_N = mkN "valkrets" ;
  vall_nn_1_N = mkN "vall" ;
  vallgrav_nn_1_N = mkN "vallgrav" ;
  vallhund_nn_1_N = mkN "vallhund" ;
  valp_nn_1_N = mkN "valp" ;
  valross_nn_1_N = mkN "valross" ;
  vals_nn_1_N = mkN "vals" ;
  valsedel_nn_1_N = mkN "valsedel" ;
  valseger_nn_1_N = mkN "valseger" ;
  valskaerm_nn_1_1_N = mkN "valskärm" ;
  vandringsfisk_nn_1_N = mkN "vandringsfisk" ;
  vandringsstav_nn_1_N = mkN "vandringsstav" ;
  vaniljgiffel_nn_1_N = mkN "vaniljgiffel" ;
  vapenrock_nn_1_N = mkN "vapenrock" ;
  varbygel_nn_1_N = mkN "varbygel" ;
  vardagsfestutstyrsel_nn_1_N = mkN "vardagsfestutstyrsel" ;
  varfaagel_nn_1_1_N = mkN "varfågel" ;
  varg_nn_1_N = mkN "varg" ;
  vargavinter_nn_1_N = mkN "vargavinter" ;
  varggrop_nn_1_N = mkN "varggrop" ;
  varhaerd_nn_1_1_N = mkN "varhärd" ;
  variometer_nn_1_N = mkN "variometer" ;
  varningstriangel_nn_1_N = mkN "varningstriangel" ;
  varp_nn_1_N = mkN "varp" ;
  varubil_nn_1_N = mkN "varubil" ;
  varubuss_nn_1_N = mkN "varubuss" ;
  varuvagn_nn_1_N = mkN "varuvagn" ;
  vask_nn_1_N = mkN "vask" ;
  vasker_nn_1_N = mkN "vasker" ;
  vass_nn_1_N = mkN "vass" ;
  vattencykel_nn_1_N = mkN "vattencykel" ;
  vattenfaagel_nn_1_1_N = mkN "vattenfågel" ;
  vattenkran_nn_1_N = mkN "vattenkran" ;
  vattenpuss_nn_1_N = mkN "vattenpuss" ;
  vattenpoel_nn_1_1_N = mkN "vattenpöl" ;
  vattensalamander_nn_1_N = mkN "vattensalamander" ;
  vattenspindel_nn_1_N = mkN "vattenspindel" ;
  vattenstaempel_nn_1_1_N = mkN "vattenstämpel" ;
  vattensaeng_nn_1_1_N = mkN "vattensäng" ;
  vattentroeskel_nn_1_1_N = mkN "vattentröskel" ;
  vattenvirvel_nn_1_N = mkN "vattenvirvel" ;
  vaxskivling_nn_1_N = mkN "vaxskivling" ;
  vaxstapel_nn_1_N = mkN "vaxstapel" ;
  veckodag_nn_1_N = mkN "veckodag" ;
  veckopeng_nn_1_N = mkN "veckopeng" ;
  vedbod_nn_1_N = mkN "vedbod" ;
  vedettbaat_nn_1_1_N = mkN "vedettbåt" ;
  vedkap_nn_1_N = mkN "vedkap" ;
  vedlaar_nn_1_1_N = mkN "vedlår" ;
  vedspis_nn_1_N = mkN "vedspis" ;
  vegetationsknopp_nn_1_N = mkN "vegetationsknopp" ;
  vehikel_nn_1_N = mkN "vehikel" ;
  vekling_nn_1_N = mkN "vekling" ;
  veling_nn_1_N = mkN "veling" ;
  ventilfjaeder_nn_1_1_N = mkN "ventilfjäder" ;
  ventrikel_nn_1_N = mkN "ventrikel" ;
  verkningskrets_nn_1_N = mkN "verkningskrets" ;
  verksamhetskrets_nn_1_N = mkN "verksamhetskrets" ;
  verkstadsklubb_nn_1_N = mkN "verkstadsklubb" ;
  vertikalcirkel_nn_1_N = mkN "vertikalcirkel" ;
  vertikalvinkel_nn_1_N = mkN "vertikalvinkel" ;
  vertolhelikopter_nn_1_N = mkN "vertolhelikopter" ;
  vesper_nn_1_N = mkN "vesper" ;
  vetegrodd_nn_1_N = mkN "vetegrodd" ;
  vetekrans_nn_1_N = mkN "vetekrans" ;
  vettvilling_nn_1_N = mkN "vettvilling" ;
  vev_nn_1_N = mkN "vev" ;
  vevarm_nn_1_N = mkN "vevarm" ;
  vevaxel_nn_1_N = mkN "vevaxel" ;
  vevling_nn_1_N = mkN "vevling" ;
  vevtapp_nn_1_N = mkN "vevtapp" ;
  vicekonung_nn_1_N = mkN "vicekonung" ;
  vicekung_nn_1_N = mkN "vicekung" ;
  vicevaerd_nn_1_1_N = mkN "vicevärd" ;
  vickel_nn_1_N = mkN "vickel" ;
  videsparv_nn_1_N = mkN "videsparv" ;
  vigg_nn_1_N = mkN "vigg" ;
  vigkvast_nn_1_N = mkN "vigkvast" ;
  vigsel_nn_1_N = mkN "vigsel" ;
  vik_nn_1_N = mkN "vik" ;
  viking_nn_1_N = mkN "viking" ;
  vikskaerm_nn_1_1_N = mkN "vikskärm" ;
  viktigpetter_nn_1_N = mkN "viktigpetter" ;
  viktualiehandel_nn_1_N = mkN "viktualiehandel" ;
  vildapel_nn_1_N = mkN "vildapel" ;
  vildfaagel_nn_1_1_N = mkN "vildfågel" ;
  vilding_nn_1_N = mkN "vilding" ;
  vilodag_nn_1_N = mkN "vilodag" ;
  vilopuls_nn_1_N = mkN "vilopuls" ;
  viltspegel_nn_1_N = mkN "viltspegel" ;
  vimpel_nn_1_N = mkN "vimpel" ;
  vinbaal_nn_1_1_N = mkN "vinbål" ;
  vind_nn_1_N = mkN "vind" ;
  vindboejtel_nn_1_1_N = mkN "vindböjtel" ;
  vindel_nn_1_N = mkN "vindel" ;
  vindfloejel_nn_1_1_N = mkN "vindflöjel" ;
  vindil_nn_1_N = mkN "vindil" ;
  vindpust_nn_1_N = mkN "vindpust" ;
  vindskaerm_nn_1_1_N = mkN "vindskärm" ;
  vindstoet_nn_1_1_N = mkN "vindstöt" ;
  vindtunnel_nn_1_N = mkN "vindtunnel" ;
  ving_nn_1_N = mkN "ving" ;
  vingklaff_nn_1_N = mkN "vingklaff" ;
  vingmutter_nn_1_N = mkN "vingmutter" ;
  vingplog_nn_1_N = mkN "vingplog" ;
  vingspegel_nn_1_N = mkN "vingspegel" ;
  vingspets_nn_1_N = mkN "vingspets" ;
  vingaard_nn_1_1_N = mkN "vingård" ;
  vink_nn_1_N = mkN "vink" ;
  vinkel_nn_1_N = mkN "vinkel" ;
  vinkelarm_nn_1_N = mkN "vinkelarm" ;
  vinkelborr_nn_1_N = mkN "vinkelborr" ;
  vinkelroller_nn_1_N = mkN "vinkelroller" ;
  vinkelslip_nn_1_N = mkN "vinkelslip" ;
  vinkelspets_nn_1_N = mkN "vinkelspets" ;
  vinskaenk_nn_1_1_N = mkN "vinskänk" ;
  vinter_nn_1_N = mkN "vinter" ;
  vintereftermiddag_nn_1_N = mkN "vintereftermiddag" ;
  vinterkvaell_nn_1_1_N = mkN "vinterkväll" ;
  vinterspaarvagn_nn_1_1_N = mkN "vinterspårvagn" ;
  vinterstoevel_nn_1_1_N = mkN "vinterstövel" ;
  vintertraedgaard_nn_1_1_N = mkN "vinterträdgård" ;
  vinthund_nn_1_N = mkN "vinthund" ;
  vip_nn_1_N = mkN "vip" ;
  vipp_nn_1_N = mkN "vipp" ;
  vippstjaert_nn_1_1_N = mkN "vippstjärt" ;
  virginiahjort_nn_1_N = mkN "virginiahjort" ;
  virvel_nn_1_N = mkN "virvel" ;
  virvelstorm_nn_1_N = mkN "virvelstorm" ;
  visp_nn_1_N = mkN "visp" ;
  visper_nn_1_N = mkN "visper" ;
  visthusbod_nn_1_N = mkN "visthusbod" ;
  vitfisk_nn_1_N = mkN "vitfisk" ;
  vitling_nn_1_N = mkN "vitling" ;
  vitmoegelost_nn_1_1_N = mkN "vitmögelost" ;
  vitnos_nn_1_N = mkN "vitnos" ;
  vitplister_nn_1_N = mkN "vitplister" ;
  vitrock_nn_1_N = mkN "vitrock" ;
  vitryss_nn_1_N = mkN "vitryss" ;
  vitraev_nn_1_1_N = mkN "viträv" ;
  vits_nn_1_N = mkN "vits" ;
  vitsvanshjort_nn_1_N = mkN "vitsvanshjort" ;
  vittling_nn_1_N = mkN "vittling" ;
  vitval_nn_1_N = mkN "vitval" ;
  vivel_nn_1_N = mkN "vivel" ;
  vojlock_nn_1_N = mkN "vojlock" ;
  volm_nn_1_N = mkN "volm" ;
  voltmeter_nn_1_N = mkN "voltmeter" ;
  vomb_nn_1_N = mkN "vomb" ;
  vorstehhund_nn_1_N = mkN "vorstehhund" ;
  vraklax_nn_1_N = mkN "vraklax" ;
  vrestall_nn_1_N = mkN "vrestall" ;
  vret_nn_1_N = mkN "vret" ;
  vridningsaxel_nn_1_N = mkN "vridningsaxel" ;
  vril_nn_1_N = mkN "vril" ;
  vraak_nn_1_1_N = mkN "vråk" ;
  vulkankrater_nn_1_N = mkN "vulkankrater" ;
  vurst_nn_1_N = mkN "vurst" ;
  vaebel_nn_1_1_N = mkN "väbel" ;
  vaederil_nn_1_1_N = mkN "väderil" ;
  vaedersol_nn_1_1_N = mkN "vädersol" ;
  vaeg_nn_1_1_N = mkN "väg" ;
  vaegg_nn_1_1_N = mkN "vägg" ;
  vaeggregel_nn_1_1_N = mkN "väggregel" ;
  vaeghyvel_nn_1_1_N = mkN "väghyvel" ;
  vaegtistel_nn_1_1_N = mkN "vägtistel" ;
  vaegtorn_nn_1_1_N = mkN "vägtorn" ;
  vaegtull_nn_1_1_N = mkN "vägtull" ;
  vaegtunnel_nn_1_1_N = mkN "vägtunnel" ;
  vaeljarbarometer_nn_1_1_N = mkN "väljarbarometer" ;
  vaelkomstfrukost_nn_1_1_N = mkN "välkomstfrukost" ;
  vaelkomstskaal_nn_1_1_N = mkN "välkomstskål" ;
  vaell_nn_1_1_N = mkN "väll" ;
  vaelling_nn_1_1_N = mkN "välling" ;
  vaellusting_nn_1_1_N = mkN "vällusting" ;
  vaelt_nn_1_1_N = mkN "vält" ;
  vaendkrets_nn_1_1_N = mkN "vändkrets" ;
  vaenkrets_nn_1_1_N = mkN "vänkrets" ;
  vaensterarm_nn_1_1_N = mkN "vänsterarm" ;
  vaensterflygel_nn_1_1_N = mkN "vänsterflygel" ;
  vaenstergir_nn_1_1_N = mkN "vänstergir" ;
  vaenthall_nn_1_1_N = mkN "vänthall" ;
  vaeppling_nn_1_1_N = mkN "väppling" ;
  vaerd_nn_1_1_N = mkN "värd" ;
  vaering_nn_1_1_N = mkN "väring" ;
  vaerk_nn_1_1_N = mkN "värk" ;
  vaerldsaxel_nn_1_1_N = mkN "världsaxel" ;
  vaerldsaalder_nn_1_1_N = mkN "världsålder" ;
  vaernfaagel_nn_1_1_N = mkN "värnfågel" ;
  vaernpliktsriksdag_nn_1_1_N = mkN "värnpliktsriksdag" ;
  vaersting_nn_1_1_N = mkN "värsting" ;
  vaest_nn_1_1_N = mkN "väst" ;
  vaestergoek_nn_1_1_N = mkN "västergök" ;
  vaestgoetaklimax_nn_1_1_N = mkN "västgötaklimax" ;
  vaestgoetaspets_nn_1_1_N = mkN "västgötaspets" ;
  vaesttysk_nn_1_1_N = mkN "västtysk" ;
  vaetsketermometer_nn_1_1_N = mkN "vätsketermometer" ;
  vaetterroeding_nn_1_1_N = mkN "vätterröding" ;
  vaev_nn_1_1_N = mkN "väv" ;
  vaevarfink_nn_1_1_N = mkN "vävarfink" ;
  vaevarfaagel_nn_1_1_N = mkN "vävarfågel" ;
  vaevkaepp_nn_1_1_N = mkN "vävkäpp" ;
  vaevsked_nn_1_1_N = mkN "vävsked" ;
  vaevskyttel_nn_1_1_N = mkN "vävskyttel" ;
  vaevstol_nn_1_1_N = mkN "vävstol" ;
  vaexel_nn_1_1_N = mkN "växel" ;
  vaexelspak_nn_1_1_N = mkN "växelspak" ;
  vaextpress_nn_1_1_N = mkN "växtpress" ;
  vaextstekel_nn_1_1_N = mkN "växtstekel" ;
  vaag_nn_2_1_N = mkN "våg" ;
  vaagdal_nn_1_1_N = mkN "vågdal" ;
  vaaghals_nn_1_1_N = mkN "våghals" ;
  vaagtopp_nn_1_1_N = mkN "vågtopp" ;
  vaaldsbrottsling_nn_1_1_N = mkN "våldsbrottsling" ;
  vaaldsrotel_nn_1_1_N = mkN "våldsrotel" ;
  vaalm_nn_1_1_N = mkN "vålm" ;
  vaang_nn_1_1_N = mkN "vång" ;
  vaaningssaeng_nn_1_1_N = mkN "våningssäng" ;
  vaar_nn_1_1_N = mkN "vår" ;
  vaaradonis_nn_1_1_N = mkN "våradonis" ;
  vaard_nn_3_13_N = mkN "vård" ;
  vaarsol_nn_1_1_N = mkN "vårsol" ;
  vaartbjoerk_nn_1_1_N = mkN "vårtbjörk" ;
  vaartgaard_nn_1_1_N = mkN "vårtgård" ;
  vaartkaktus_nn_1_1_N = mkN "vårtkaktus" ;
  vaartsvets_nn_1_1_N = mkN "vårtsvets" ;
  vaarvinter_nn_1_1_N = mkN "vårvinter" ;
  webblaenk_nn_1_1_N = mkN "webblänk" ;
  whippet_nn_1_N = mkN "whippet" ;
  wienerschnitzel_nn_1_N = mkN "wienerschnitzel" ;
  wok_nn_1_N = mkN "wok" ;
  x_axel_nn_1_N = mkN "x-axel" ;
  y_axel_nn_1_N = mkN "y-axel" ;
  ymp_nn_1_N = mkN "ymp" ;
  ympkvist_nn_1_N = mkN "ympkvist" ;
  yngling_nn_1_N = mkN "yngling" ;
  ynkrygg_nn_1_N = mkN "ynkrygg" ;
  yrkeskodex_nn_1_N = mkN "yrkeskodex" ;
  yrkestitel_nn_1_N = mkN "yrkestitel" ;
  ytter_nn_1_N = mkN "ytter" ;
  ytterrock_nn_1_N = mkN "ytterrock" ;
  yttervinkel_nn_1_N = mkN "yttervinkel" ;
  aedelgran_nn_1_1_N = mkN "ädelgran" ;
  aedelost_nn_1_1_N = mkN "ädelost" ;
  aedling_nn_1_1_N = mkN "ädling" ;
  aefsing_nn_1_1_N = mkN "äfsing" ;
  aeggkastning_nn_1_1_N = mkN "äggkastning" ;
  aeggkokning_nn_1_1_N = mkN "äggkokning" ;
  aeggkopp_nn_1_1_N = mkN "äggkopp" ;
  aeggledartratt_nn_1_1_N = mkN "äggledartratt" ;
  aegglossning_nn_1_1_N = mkN "ägglossning" ;
  aeggost_nn_1_1_N = mkN "äggost" ;
  aeggsked_nn_1_1_N = mkN "äggsked" ;
  aeggsnodd_nn_1_1_N = mkN "äggsnodd" ;
  aeggstanning_nn_1_1_N = mkN "äggstanning" ;
  aeggstav_nn_1_1_N = mkN "äggstav" ;
  aeggstock_nn_1_1_N = mkN "äggstock" ;
  aeggsvamp_nn_1_1_N = mkN "äggsvamp" ;
  aeggsaeck_nn_1_1_N = mkN "äggsäck" ;
  aegodelning_nn_1_1_N = mkN "ägodelning" ;
  aegogradering_nn_1_1_N = mkN "ägogradering" ;
  aegretthaeger_nn_1_1_N = mkN "ägretthäger" ;
  aeldreminister_nn_1_1_N = mkN "äldreminister" ;
  aeldresatsning_nn_1_1_N = mkN "äldresatsning" ;
  aelg_nn_1_1_N = mkN "älg" ;
  aelgkalv_nn_1_1_N = mkN "älgkalv" ;
  aelgskog_nn_1_1_N = mkN "älgskog" ;
  aelgstek_nn_1_1_N = mkN "älgstek" ;
  aelgvarning_nn_1_1_N = mkN "älgvarning" ;
  aelling_nn_1_1_N = mkN "älling" ;
  aelskling_nn_1_1_N = mkN "älskling" ;
  aelsklingsost_nn_1_1_N = mkN "älsklingsost" ;
  aelv_nn_1_1_N = mkN "älv" ;
  aelvbrink_nn_1_1_N = mkN "älvbrink" ;
  aelvbaedd_nn_1_1_N = mkN "älvbädd" ;
  aelvdaling_nn_1_1_N = mkN "älvdaling" ;
  aelvdrottning_nn_1_1_N = mkN "älvdrottning" ;
  aelvkvarn_nn_1_1_N = mkN "älvkvarn" ;
  aelvmynning_nn_1_1_N = mkN "älvmynning" ;
  aembetsmannaregering_nn_1_1_N = mkN "ämbetsmannaregering" ;
  aembetsskrud_nn_1_1_N = mkN "ämbetsskrud" ;
  aembetsstaellning_nn_1_1_N = mkN "ämbetsställning" ;
  aembetstitel_nn_1_1_N = mkN "ämbetstitel" ;
  aemnesintegrering_nn_1_1_N = mkN "ämnesintegrering" ;
  aemnesomsaettning_nn_1_1_N = mkN "ämnesomsättning" ;
  aendring_nn_1_1_N = mkN "ändring" ;
  aendtarm_nn_1_1_N = mkN "ändtarm" ;
  aendvaendning_nn_1_1_N = mkN "ändvändning" ;
  aeng_nn_1_1_N = mkN "äng" ;
  aengel_nn_1_1_N = mkN "ängel" ;
  aenger_nn_1_1_N = mkN "änger" ;
  aengshoek_nn_1_1_N = mkN "ängshök" ;
  aengsknarr_nn_1_1_N = mkN "ängsknarr" ;
  aenkedrottning_nn_1_1_N = mkN "änkedrottning" ;
  aenkestoet_nn_1_1_N = mkN "änkestöt" ;
  aenkling_nn_1_1_N = mkN "änkling" ;
  aenterpik_nn_1_1_N = mkN "änterpik" ;
  aentring_nn_1_1_N = mkN "äntring" ;
  aeppelskrott_nn_1_1_N = mkN "äppelskrott" ;
  aeppelskrutt_nn_1_1_N = mkN "äppelskrutt" ;
  aeppleskrott_nn_1_1_N = mkN "äppleskrott" ;
  aerekraenkning_nn_1_1_N = mkN "ärekränkning" ;
  aerendehandlaeggning_nn_1_1_N = mkN "ärendehandläggning" ;
  aereport_nn_1_1_N = mkN "äreport" ;
  aereraeddning_nn_1_1_N = mkN "äreräddning" ;
  aeretitel_nn_1_1_N = mkN "äretitel" ;
  aerftlighetslag_nn_1_1_N = mkN "ärftlighetslag" ;
  aerjkrok_nn_1_1_N = mkN "ärjkrok" ;
  aerkebiskop_nn_1_1_N = mkN "ärkebiskop" ;
  aerkehertig_nn_1_1_N = mkN "ärkehertig" ;
  aerkeskurk_nn_1_1_N = mkN "ärkeskurk" ;
  aerkeaengel_nn_1_1_N = mkN "ärkeängel" ;
  aerm_nn_1_1_N = mkN "ärm" ;
  aermlinning_nn_1_1_N = mkN "ärmlinning" ;
  aerrbildning_nn_1_1_N = mkN "ärrbildning" ;
  aerrtatuering_nn_1_1_N = mkN "ärrtatuering" ;
  aesping_nn_1_1_N = mkN "äsping" ;
  aetning_nn_1_1_N = mkN "ätning" ;
  aetstoerning_nn_1_1_N = mkN "ätstörning" ;
  aettiksinlaeggning_nn_1_1_N = mkN "ättiksinläggning" ;
  aettling_nn_1_1_N = mkN "ättling" ;
  aexing_nn_1_1_N = mkN "äxing" ;
  aahoerardag_nn_1_1_N = mkN "åhörardag" ;
  aakarhaest_nn_1_1_N = mkN "åkarhäst" ;
  aakarkamp_nn_1_1_N = mkN "åkarkamp" ;
  aaker_nn_1_1_N = mkN "åker" ;
  aakerjord_nn_1_1_N = mkN "åkerjord" ;
  aakerlapp_nn_1_1_N = mkN "åkerlapp" ;
  aakersork_nn_1_1_N = mkN "åkersork" ;
  aakerspergel_nn_1_1_N = mkN "åkerspergel" ;
  aakerteg_nn_1_1_N = mkN "åkerteg" ;
  aakertistel_nn_1_1_N = mkN "åkertistel" ;
  aakroek_nn_1_1_N = mkN "åkrök" ;
  aal_nn_1_1_N = mkN "ål" ;
  aalder_nn_1_1_N = mkN "ålder" ;
  aaldersspaerr_nn_1_1_N = mkN "åldersspärr" ;
  aalspets_nn_1_1_N = mkN "ålspets" ;
  aam_nn_1_1_N = mkN "åm" ;
  aangblaester_nn_1_1_N = mkN "ångbläster" ;
  aangbaat_nn_1_1_N = mkN "ångbåt" ;
  aangslup_nn_1_1_N = mkN "ångslup" ;
  aangvinsch_nn_1_1_N = mkN "ångvinsch" ;
  aangvaelt_nn_1_1_N = mkN "ångvält" ;
  aarsdag_nn_1_1_N = mkN "årsdag" ;
  aarskull_nn_1_1_N = mkN "årskull" ;
  aartull_nn_1_1_N = mkN "årtull" ;
  aas_nn_1_1_N = mkN "ås" ;
  aasgrop_nn_1_1_N = mkN "åsgrop" ;
  aatel_nn_1_1_N = mkN "åtel" ;
  aaterupprepning_nn_1_1_N = mkN "återupprepning" ;
  aaterupptagning_nn_1_1_N = mkN "återupptagning" ;
  aaterverkning_nn_1_1_N = mkN "återverkning" ;
  aatervinning_nn_1_1_N = mkN "återvinning" ;
  aathutning_nn_1_1_N = mkN "åthutning" ;
  aatstramning_nn_1_1_N = mkN "åtstramning" ;
  aattatimmarsdag_nn_1_1_N = mkN "åttatimmarsdag" ;
  aattatumsspik_nn_1_1_N = mkN "åttatumsspik" ;
  aattaaaring_nn_1_1_N = mkN "åttaåring" ;
  aattling_nn_1_1_N = mkN "åttling" ;
  oedebygdsvaeg_nn_1_1_N = mkN "ödebygdsväg" ;
  oedegaard_nn_1_1_N = mkN "ödegård" ;
  oedesdag_nn_1_1_N = mkN "ödesdag" ;
  oegonbindel_nn_1_1_N = mkN "ögonbindel" ;
  oegonbrynshoejning_nn_1_1_N = mkN "ögonbrynshöjning" ;
  oegonfrans_nn_1_1_N = mkN "ögonfrans" ;
  oegonrullning_nn_1_1_N = mkN "ögonrullning" ;
  oegonsjukdom_nn_1_1_N = mkN "ögonsjukdom" ;
  oegonspegel_nn_1_1_N = mkN "ögonspegel" ;
  oegontagg_nn_1_1_N = mkN "ögontagg" ;
  oegonvinkel_nn_1_1_N = mkN "ögonvinkel" ;
  oegonvittnesskildring_nn_1_1_N = mkN "ögonvittnesskildring" ;
  oekenvandring_nn_1_1_N = mkN "ökenvandring" ;
  oekenvind_nn_1_1_N = mkN "ökenvind" ;
  oekning_nn_1_1_N = mkN "ökning" ;
  oekstock_nn_1_1_N = mkN "ökstock" ;
  oelandsgaard_nn_1_1_N = mkN "ölandsgård" ;
  oelandshaest_nn_1_1_N = mkN "ölandshäst" ;
  oelback_nn_1_1_N = mkN "ölback" ;
  oelburk_nn_1_1_N = mkN "ölburk" ;
  oelhall_nn_1_1_N = mkN "ölhall" ;
  oelservering_nn_1_1_N = mkN "ölservering" ;
  oeltillverkning_nn_1_1_N = mkN "öltillverkning" ;
  oeluff_nn_1_1_N = mkN "öluff" ;
  oelaenning_nn_1_1_N = mkN "ölänning" ;
  oemsning_nn_1_1_N = mkN "ömsning" ;
  oenskering_nn_1_1_N = mkN "önskering" ;
  oenskning_nn_1_1_N = mkN "önskning" ;
  oeppnaknapp_nn_1_1_N = mkN "öppnaknapp" ;
  oeppning_nn_1_1_N = mkN "öppning" ;
  oerfil_nn_1_1_N = mkN "örfil" ;
  oerfilsdom_nn_1_1_N = mkN "örfilsdom" ;
  oerflik_nn_1_1_N = mkN "örflik" ;
  oering_nn_1_1_N = mkN "öring" ;
  oern_nn_1_1_N = mkN "örn" ;
  oernblick_nn_1_1_N = mkN "örnblick" ;
  oerongaang_nn_1_1_N = mkN "örongång" ;
  oeronpropp_nn_1_1_N = mkN "öronpropp" ;
  oeronsjukdom_nn_1_1_N = mkN "öronsjukdom" ;
  oeronsnibb_nn_1_1_N = mkN "öronsnibb" ;
  oeronsusning_nn_1_1_N = mkN "öronsusning" ;
  oersnibb_nn_1_1_N = mkN "örsnibb" ;
  oertagaard_nn_1_1_N = mkN "örtagård" ;
  oertesaeng_nn_1_1_N = mkN "örtesäng" ;
  oertsaeng_nn_1_1_N = mkN "örtsäng" ;
  oertug_nn_1_1_N = mkN "örtug" ;
  oesning_nn_1_1_N = mkN "ösning" ;
  oesterbottning_nn_1_1_N = mkN "österbottning" ;
  oesterlaenning_nn_1_1_N = mkN "österlänning" ;
  oestersjoefisk_nn_1_1_N = mkN "östersjöfisk" ;
  oesttysk_nn_1_1_N = mkN "östtysk" ;
  oeveranstraengning_nn_1_1_N = mkN "överansträngning" ;
  oeveranvaendning_nn_1_1_N = mkN "överanvändning" ;
  oeverarbetning_nn_1_1_N = mkN "överarbetning" ;
  oeverarm_nn_1_1_N = mkN "överarm" ;
  oeverbefolkning_nn_1_1_N = mkN "överbefolkning" ;
  oeverbehandling_nn_1_1_N = mkN "överbehandling" ;
  oeverbelastning_nn_1_1_N = mkN "överbelastning" ;
  oeverbelaeggning_nn_1_1_N = mkN "överbeläggning" ;
  oeverbjudning_nn_1_1_N = mkN "överbjudning" ;
  oeverblick_nn_1_1_N = mkN "överblick" ;
  oeverbaedd_nn_1_1_N = mkN "överbädd" ;
  oeverdebitering_nn_1_1_N = mkN "överdebitering" ;
  oeverdimensionering_nn_1_1_N = mkN "överdimensionering" ;
  oeverdomstol_nn_1_1_N = mkN "överdomstol" ;
  oeverdosering_nn_1_1_N = mkN "överdosering" ;
  oeverensfyr_nn_1_1_N = mkN "överensfyr" ;
  oeverexponering_nn_1_1_N = mkN "överexponering" ;
  oeverflygning_nn_1_1_N = mkN "överflygning" ;
  oeverflyttning_nn_1_1_N = mkN "överflyttning" ;
  oeverfoering_nn_1_1_N = mkN "överföring" ;
  oevergaang_nn_1_1_N = mkN "övergång" ;
  oevergaangsstil_nn_1_1_N = mkN "övergångsstil" ;
  oevergaangsaalder_nn_1_1_N = mkN "övergångsålder" ;
  oeverhalning_nn_1_1_N = mkN "överhalning" ;
  oeverhandsfraes_nn_1_1_N = mkN "överhandsfräs" ;
  oeverhandsknop_nn_1_1_N = mkN "överhandsknop" ;
  oeverhettning_nn_1_1_N = mkN "överhettning" ;
  oeverhopning_nn_1_1_N = mkN "överhopning" ;
  oeverhoppning_nn_1_1_N = mkN "överhoppning" ;
  oeverhoeljning_nn_1_1_N = mkN "överhöljning" ;
  oeverilning_nn_1_1_N = mkN "överilning" ;
  oeverinlaerning_nn_1_1_N = mkN "överinlärning" ;
  oeverjaesning_nn_1_1_N = mkN "överjäsning" ;
  oeverkamning_nn_1_1_N = mkN "överkamning" ;
  oeverklivning_nn_1_1_N = mkN "överklivning" ;
  oeverkompensering_nn_1_1_N = mkN "överkompensering" ;
  oeverkorsning_nn_1_1_N = mkN "överkorsning" ;
  oeverkragning_nn_1_1_N = mkN "överkragning" ;
  oeverkropp_nn_1_1_N = mkN "överkropp" ;
  oeverlapp_nn_1_1_N = mkN "överlapp" ;
  oeverlappning_nn_1_1_N = mkN "överlappning" ;
  oeverloppsgaerning_nn_1_1_N = mkN "överloppsgärning" ;
  oeverlaeggning_nn_1_1_N = mkN "överläggning" ;
  oeverlaemning_nn_1_1_N = mkN "överlämning" ;
  oeverlaepp_nn_1_1_N = mkN "överläpp" ;
  oevernattning_nn_1_1_N = mkN "övernattning" ;
  oeverraskning_nn_1_1_N = mkN "överraskning" ;
  oeverrock_nn_1_1_N = mkN "överrock" ;
  oeverrumpling_nn_1_1_N = mkN "överrumpling" ;
  oeverraeckning_nn_1_1_N = mkN "överräckning" ;
  oeverroestning_nn_1_1_N = mkN "överröstning" ;
  oeverskattning_nn_1_1_N = mkN "överskattning" ;
  oeverskeppningsbaat_nn_1_1_N = mkN "överskeppningsbåt" ;
  oeverskjutning_nn_1_1_N = mkN "överskjutning" ;
  oeverskruv_nn_1_1_N = mkN "överskruv" ;
  oeverskuggning_nn_1_1_N = mkN "överskuggning" ;
  oeverskylning_nn_1_1_N = mkN "överskylning" ;
  oeverskoeljning_nn_1_1_N = mkN "översköljning" ;
  oeverslagsberaekning_nn_1_1_N = mkN "överslagsberäkning" ;
  oeverspaenning_nn_1_1_N = mkN "överspänning" ;
  oeverstigning_nn_1_1_N = mkN "överstigning" ;
  oeverstrykning_nn_1_1_N = mkN "överstrykning" ;
  oeverstroemning_nn_1_1_N = mkN "överströmning" ;
  oeversvaemning_nn_1_1_N = mkN "översvämning" ;
  oeversaendning_nn_1_1_N = mkN "översändning" ;
  oeversaettning_nn_1_1_N = mkN "översättning" ;
  oevertalning_nn_1_1_N = mkN "övertalning" ;
  oeverteckning_nn_1_1_N = mkN "överteckning" ;
  oevertrassering_nn_1_1_N = mkN "övertrassering" ;
  oevertaeckning_nn_1_1_N = mkN "övertäckning" ;
  oevervakning_nn_1_1_N = mkN "övervakning" ;
  oevervakningsutrustning_nn_1_1_N = mkN "övervakningsutrustning" ;
  oevervallning_nn_1_1_N = mkN "övervallning" ;
  oevervaegning_nn_1_1_N = mkN "övervägning" ;
  oevervaerdering_nn_1_1_N = mkN "övervärdering" ;
  oevervaexel_nn_1_1_N = mkN "överväxel" ;
  oevervaaning_nn_1_1_N = mkN "övervåning" ;
  oevning_nn_1_1_N = mkN "övning" ;
  oevningsrymning_nn_1_1_N = mkN "övningsrymning" ;
  oevningsskjutning_nn_1_1_N = mkN "övningsskjutning" ;
  oevaerld_nn_1_1_N = mkN "övärld" ;
  ytterdel_nn_1_N = mkN "ytterdel" "ytterdelen" "ytterdelar" "ytterdelarna" ;
  vaextdel_nn_1_1_N = mkN "växtdel" "växtdelen" "växtdelar" "växtdelarna" ;
  vaerldsdel_nn_1_1_N = mkN "världsdel" "världsdelen" "världsdelar" "världsdelarna" ;
  vaeljarandel_nn_1_1_N = mkN "väljarandel" "väljarandelen" "väljarandelar" "väljarandelarna" ;
  vinstandel_nn_1_N = mkN "vinstandel" "vinstandelen" "vinstandelar" "vinstandelarna" ;
  utvecklingsgren_nn_1_N = mkN "utvecklingsgren" "utvecklingsgrenen" "utvecklingsgrenar" "utvecklingsgrenarna" ;
  urkalksten_nn_1_N = mkN "urkalksten" "urkalkstenen" "urkalkstenar" "urkalkstenarna" ;
  traedgren_nn_1_1_N = mkN "trädgren" "trädgrenen" "trädgrenar" "trädgrenarna" ;
  trottoarsten_nn_1_N = mkN "trottoarsten" "trottoarstenen" "trottoarstenar" "trottoarstenarna" ;
  tegelsten_nn_1_N = mkN "tegelsten" "tegelstenen" "tegelstenar" "tegelstenarna" ;
  tegelskorsten_nn_1_N = mkN "tegelskorsten" "tegelskorstenen" "tegelskorstenar" "tegelskorstenarna" ;
  stoetesten_nn_1_1_N = mkN "stötesten" "stötestenen" "stötestenar" "stötestenarna" ;
  stordriftsfoerdel_nn_1_1_N = mkN "stordriftsfördel" "stordriftsfördelen" "stordriftsfördelar" "stordriftsfördelarna" ;
  stjaertdel_nn_1_1_N = mkN "stjärtdel" "stjärtdelen" "stjärtdelar" "stjärtdelarna" ;
  stadsdel_nn_1_N = mkN "stadsdel" "stadsdelen" "stadsdelar" "stadsdelarna" ;
  spraengsten_nn_1_1_N = mkN "sprängsten" "sprängstenen" "sprängstenar" "sprängstenarna" ;
  smaasten_nn_1_1_N = mkN "småsten" "småstenen" "småstenar" "småstenarna" ;
  smaadel_nn_1_1_N = mkN "smådel" "smådelen" "smådelar" "smådelarna" ;
  slutsten_nn_1_N = mkN "slutsten" "slutstenen" "slutstenar" "slutstenarna" ;
  slipsten_nn_1_N = mkN "slipsten" "slipstenen" "slipstenar" "slipstenarna" ;
  slicksten_nn_1_N = mkN "slicksten" "slickstenen" "slickstenar" "slickstenarna" ;
  skorsten_nn_1_N = mkN "skorsten" "skorstenen" "skorstenar" "skorstenarna" ;
  sextiondel_nn_1_N = mkN "sextiondel" "sextiondelen" "sextiondelar" "sextiondelarna" ;
  sextiondedel_nn_1_N = mkN "sextiondedel" "sextiondedelen" "sextiondedelar" "sextiondedelarna" ;
  raennsten_nn_1_1_N = mkN "rännsten" "rännstenen" "rännstenar" "rännstenarna" ;
  runsten_nn_1_N = mkN "runsten" "runstenen" "runstenar" "runstenarna" ;
  rullsten_nn_1_N = mkN "rullsten" "rullstenen" "rullstenar" "rullstenarna" ;
  reservdel_nn_1_N = mkN "reservdel" "reservdelen" "reservdelar" "reservdelarna" ;
  pungsten_nn_1_N = mkN "pungsten" "pungstenen" "pungstenar" "pungstenarna" ;
  oxalatsten_nn_1_N = mkN "oxalatsten" "oxalatstenen" "oxalatstenar" "oxalatstenarna" ;
  orddel_nn_1_N = mkN "orddel" "orddelen" "orddelar" "orddelarna" ;
  nyckelsten_nn_1_N = mkN "nyckelsten" "nyckelstenen" "nyckelstenar" "nyckelstenarna" ;
  njursten_nn_1_N = mkN "njursten" "njurstenen" "njurstenar" "njurstenarna" ;
  nervgren_nn_1_N = mkN "nervgren" "nervgrenen" "nervgrenar" "nervgrenarna" ;
  nederdel_nn_1_N = mkN "nederdel" "nederdelen" "nederdelar" "nederdelarna" ;
  natursten_nn_1_N = mkN "natursten" "naturstenen" "naturstenar" "naturstenarna" ;
  maansten_nn_1_1_N = mkN "månsten" "månstenen" "månstenar" "månstenarna" ;
  mursten_nn_1_N = mkN "mursten" "murstenen" "murstenar" "murstenarna" ;
  minnessten_nn_1_N = mkN "minnessten" "minnesstenen" "minnesstenar" "minnesstenarna" ;
  milsten_nn_1_N = mkN "milsten" "milstenen" "milstenar" "milstenarna" ;
  meteorsten_nn_1_N = mkN "meteorsten" "meteorstenen" "meteorstenar" "meteorstenarna" ;
  metalldel_nn_1_N = mkN "metalldel" "metalldelen" "metalldelar" "metalldelarna" ;
  mellandel_nn_1_N = mkN "mellandel" "mellandelen" "mellandelar" "mellandelarna" ;
  maskindel_nn_1_N = mkN "maskindel" "maskindelen" "maskindelar" "maskindelarna" ;
  marknadsandel_nn_1_N = mkN "marknadsandel" "marknadsandelen" "marknadsandelar" "marknadsandelarna" ;
  loepsten_nn_1_1_N = mkN "löpsten" "löpstenen" "löpstenar" "löpstenarna" ;
  loeparsten_nn_1_1_N = mkN "löparsten" "löparstenen" "löparstenar" "löparstenarna" ;
  landsdel_nn_1_N = mkN "landsdel" "landsdelen" "landsdelar" "landsdelarna" ;
  kvarnsten_nn_1_N = mkN "kvarnsten" "kvarnstenen" "kvarnstenar" "kvarnstenarna" ;
  kvadersten_nn_1_N = mkN "kvadersten" "kvaderstenen" "kvaderstenar" "kvaderstenarna" ;
  kulturdel_nn_1_N = mkN "kulturdel" "kulturdelen" "kulturdelar" "kulturdelarna" ;
  kullersten_nn_1_N = mkN "kullersten" "kullerstenen" "kullerstenar" "kullerstenarna" ;
  kragsten_nn_1_N = mkN "kragsten" "kragstenen" "kragstenar" "kragstenarna" ;
  konkurrensfoerdel_nn_1_1_N = mkN "konkurrensfördel" "konkurrensfördelen" "konkurrensfördelar" "konkurrensfördelarna" ;
  kommundel_nn_1_N = mkN "kommundel" "kommundelen" "kommundelar" "kommundelarna" ;
  klappersten_nn_1_N = mkN "klappersten" "klapperstenen" "klapperstenar" "klapperstenarna" ;
  kiselsten_nn_1_N = mkN "kiselsten" "kiselstenen" "kiselstenar" "kiselstenarna" ;
  kantsten_nn_1_N = mkN "kantsten" "kantstenen" "kantstenar" "kantstenarna" ;
  hoernsten_nn_1_1_N = mkN "hörnsten" "hörnstenen" "hörnstenar" "hörnstenarna" ;
  haelsofoerdel_nn_1_1_N = mkN "hälsofördel" "hälsofördelen" "hälsofördelar" "hälsofördelarna" ;
  huvuddel_nn_1_N = mkN "huvuddel" "huvuddelen" "huvuddelar" "huvuddelarna" ;
  hundradel_nn_1_N = mkN "hundradel" "hundradelen" "hundradelar" "hundradelarna" ;
  hundradedel_nn_1_N = mkN "hundradedel" "hundradedelen" "hundradedelar" "hundradedelarna" ;
  hjaerndel_nn_1_1_N = mkN "hjärndel" "hjärndelen" "hjärndelar" "hjärndelarna" ;
  halvaedelsten_nn_1_1_N = mkN "halvädelsten" "halvädelstenen" "halvädelstenar" "halvädelstenarna" ;
  graasten_nn_1_1_N = mkN "gråsten" "gråstenen" "gråstenar" "gråstenarna" ;
  graenssten_nn_1_1_N = mkN "gränssten" "gränsstenen" "gränsstenar" "gränsstenarna" ;
  grundsten_nn_1_N = mkN "grundsten" "grundstenen" "grundstenar" "grundstenarna" ;
  gravsten_nn_1_N = mkN "gravsten" "gravstenen" "gravstenar" "gravstenarna" ;
  grangren_nn_1_N = mkN "grangren" "grangrenen" "grangrenar" "grangrenarna" ;
  glaettsten_nn_1_1_N = mkN "glättsten" "glättstenen" "glättstenar" "glättstenarna" ;
  gatsten_nn_1_N = mkN "gatsten" "gatstenen" "gatstenar" "gatstenarna" ;
  gallsten_nn_1_N = mkN "gallsten" "gallstenen" "gallstenar" "gallstenarna" ;
  framdel_nn_1_N = mkN "framdel" "framdelen" "framdelar" "framdelarna" ;
  fjaerdedel_nn_1_1_N = mkN "fjärdedel" "fjärdedelen" "fjärdedelar" "fjärdedelarna" ;
  fabriksskorsten_nn_1_N = mkN "fabriksskorsten" "fabriksskorstenen" "fabriksskorstenar" "fabriksskorstenarna" ;
  droppsten_nn_1_N = mkN "droppsten" "droppstenen" "droppstenar" "droppstenarna" ;
  djurdel_nn_1_N = mkN "djurdel" "djurdelen" "djurdelar" "djurdelarna" ;
  byggsten_nn_1_N = mkN "byggsten" "byggstenen" "byggstenar" "byggstenarna" ;
  byggnadssten_nn_1_N = mkN "byggnadssten" "byggnadsstenen" "byggnadsstenar" "byggnadsstenarna" ;
  bullersten_nn_1_N = mkN "bullersten" "bullerstenen" "bullerstenar" "bullerstenarna" ;
  braakdel_nn_1_1_N = mkN "bråkdel" "bråkdelen" "bråkdelar" "bråkdelarna" ;
  brynsten_nn_1_N = mkN "brynsten" "brynstenen" "brynstenar" "brynstenarna" ;
  boutredare_nn_1_N = mkN "boutredare" "boutredareen" "boutredarear" "boutredarearna" ;
  blaassten_nn_1_1_N = mkN "blåssten" "blåsstenen" "blåsstenar" "blåsstenarna" ;
  bindsten_nn_1_N = mkN "bindsten" "bindstenen" "bindstenar" "bindstenarna" ;
  bildsten_nn_1_N = mkN "bildsten" "bildstenen" "bildstenar" "bildstenarna" ;
  bidragsdel_nn_1_N = mkN "bidragsdel" "bidragsdelen" "bidragsdelar" "bidragsdelarna" ;
  bautasten_nn_1_N = mkN "bautasten" "bautastenen" "bautastenar" "bautastenarna" ;
  bandel_nn_1_N = mkN "bandel" "bandelen" "bandelar" "bandelarna" ;
  bakdel_nn_1_N = mkN "bakdel" "bakdelen" "bakdelar" "bakdelarna" ;
  Berlinmur_nn_1_N = mkN "Berlinmur" ;
  DNA_sekvensering_nn_1_N = mkN "DNA-sekvensering" ;
  DNA_straeng_nn_1_1_N = mkN "DNA-sträng" ;
  DNA_testning_nn_1_N = mkN "DNA-testning" ;
  DNA_uppsaettning_nn_1_1_N = mkN "DNA-uppsättning" ;
  EU_utvidgning_nn_1_N = mkN "EU-utvidgning" ;
  Golgatavandring_nn_1_N = mkN "Golgatavandring" ;
  Jantelag_nn_1_N = mkN "Jantelag" ;
  Kafkastaemning_nn_1_1_N = mkN "Kafkastämning" ;
  Koranbraenning_nn_1_1_N = mkN "Koranbränning" ;
  LCD_skaerm_nn_1_1_N = mkN "LCD-skärm" ;
  LED_belysning_nn_1_N = mkN "LED-belysning" ;
  Oxfordkommatering_nn_1_N = mkN "Oxfordkommatering" ;
  PCB_foerening_nn_1_1_N = mkN "PCB-förening" ;
  PCB_foergiftning_nn_1_1_N = mkN "PCB-förgiftning" ;
  PVC_belaeggning_nn_1_1_N = mkN "PVC-beläggning" ;
  SIFO_undersoekning_nn_1_1_N = mkN "SIFO-undersökning" ;
  Sifoundersoekning_nn_1_1_N = mkN "Sifoundersökning" ;
  Statoilmack_nn_1_N = mkN "Statoilmack" ;
  Soedermalmvaaning_nn_1_1_N = mkN "Södermalmvåning" ;
  TV_saendning_nn_1_1_N = mkN "TV-sändning" ;
  TV_oevervakning_nn_1_1_N = mkN "TV-övervakning" ;
  USB_sladd_nn_1_N = mkN "USB-sladd" ;
  asgam_nn_1_N = mkN "asgam" ;
  askhoeg_nn_1_1_N = mkN "askhög" ;
  askpuff_nn_1_N = mkN "askpuff" ;
  asktipp_nn_1_N = mkN "asktipp" ;
  aspirering_nn_1_N = mkN "aspirering" ;
  assignering_nn_1_N = mkN "assignering" ;
  assimilering_nn_1_N = mkN "assimilering" ;
  assistering_nn_1_N = mkN "assistering" ;
  associering_nn_1_N = mkN "associering" ;
  assurering_nn_1_N = mkN "assurering" ;
  asylmottagning_nn_1_N = mkN "asylmottagning" ;
  atelj_evaaning_nn_1_1_N = mkN "ateljévåning" ;
  atlasbindning_nn_1_N = mkN "atlasbindning" ;
  atletklubb_nn_1_N = mkN "atletklubb" ;
  atombombsfaellning_nn_1_1_N = mkN "atombombsfällning" ;
  atrofiering_nn_1_N = mkN "atrofiering" ;
  attackering_nn_1_N = mkN "attackering" ;
  attestering_nn_1_N = mkN "attestering" ;
  attitydfoeraendring_nn_1_1_N = mkN "attitydförändring" ;
  attitydundersoekning_nn_1_1_N = mkN "attitydundersökning" ;
  attrahering_nn_1_N = mkN "attrahering" ;
  attrappering_nn_1_N = mkN "attrappering" ;
  attribuering_nn_1_N = mkN "attribuering" ;
  attributsamling_nn_1_N = mkN "attributsamling" ;
  auktionering_nn_1_N = mkN "auktionering" ;
  auktorisering_nn_1_N = mkN "auktorisering" ;
  auskultering_nn_1_N = mkN "auskultering" ;
  autenticering_nn_1_N = mkN "autenticering" ;
  autentifiering_nn_1_N = mkN "autentifiering" ;
  autentisering_nn_1_N = mkN "autentisering" ;
  automatisering_nn_1_N = mkN "automatisering" ;
  automatsaekring_nn_1_1_N = mkN "automatsäkring" ;
  avancering_nn_1_N = mkN "avancering" ;
  avannonsering_nn_1_N = mkN "avannonsering" ;
  avbalkning_nn_1_N = mkN "avbalkning" ;
  avbasning_nn_1_N = mkN "avbasning" ;
  avbestaellning_nn_1_1_N = mkN "avbeställning" ;
  avbetalning_nn_1_N = mkN "avbetalning" ;
  avbetingning_nn_1_N = mkN "avbetingning" ;
  avbetning_nn_1_N = mkN "avbetning" ;
  avbildning_nn_1_N = mkN "avbildning" ;
  avbindning_nn_1_N = mkN "avbindning" ;
  avbitning_nn_1_N = mkN "avbitning" ;
  avblaasning_nn_1_1_N = mkN "avblåsning" ;
  avbokning_nn_1_N = mkN "avbokning" ;
  avbrytning_nn_1_N = mkN "avbrytning" ;
  avbraenning_nn_1_1_N = mkN "avbränning" ;
  avbroestning_nn_1_1_N = mkN "avbröstning" ;
  avbaering_nn_1_1_N = mkN "avbäring" ;
  avbaerning_nn_1_1_N = mkN "avbärning" ;
  avboejning_nn_1_1_N = mkN "avböjning" ;
  avdelning_nn_1_N = mkN "avdelning" ;
  avdramatisering_nn_1_N = mkN "avdramatisering" ;
  avdunstning_nn_1_N = mkN "avdunstning" ;
  avfallsbrunn_nn_1_N = mkN "avfallsbrunn" ;
  avfallskvarn_nn_1_N = mkN "avfallskvarn" ;
  avfattning_nn_1_N = mkN "avfattning" ;
  avfettning_nn_1_N = mkN "avfettning" ;
  avflyttning_nn_1_N = mkN "avflyttning" ;
  avfolkning_nn_1_N = mkN "avfolkning" ;
  avfrostning_nn_1_N = mkN "avfrostning" ;
  avfyrning_nn_1_N = mkN "avfyrning" ;
  avfaelling_nn_1_1_N = mkN "avfälling" ;
  avfoering_nn_1_1_N = mkN "avföring" ;
  avgasfoergiftning_nn_1_1_N = mkN "avgasförgiftning" ;
  avgiftning_nn_1_N = mkN "avgiftning" ;
  avgjutning_nn_1_N = mkN "avgjutning" ;
  avgrening_nn_1_N = mkN "avgrening" ;
  avgraensning_nn_1_1_N = mkN "avgränsning" ;
  avgud_nn_1_N = mkN "avgud" ;
  avgaerdning_nn_1_1_N = mkN "avgärdning" ;
  avgaang_nn_1_1_N = mkN "avgång" ;
  avhandling_nn_1_N = mkN "avhandling" ;
  avhuggning_nn_1_N = mkN "avhuggning" ;
  avhyvling_nn_1_N = mkN "avhyvling" ;
  avhaellning_nn_1_1_N = mkN "avhällning" ;
  avhaellningsoeppning_nn_1_1_N = mkN "avhällningsöppning" ;
  avhaemtning_nn_1_1_N = mkN "avhämtning" ;
  avhaestning_nn_1_1_N = mkN "avhästning" ;
  avisering_nn_1_N = mkN "avisering" ;
  avisningsanlaeggning_nn_1_1_N = mkN "avisningsanläggning" ;
  avjaemning_nn_1_1_N = mkN "avjämning" ;
  avkastning_nn_1_N = mkN "avkastning" ;
  avklappning_nn_1_N = mkN "avklappning" ;
  avklippning_nn_1_N = mkN "avklippning" ;
  avklaedning_nn_1_1_N = mkN "avklädning" ;
  avknoppning_nn_1_N = mkN "avknoppning" ;
  avkolonisering_nn_1_N = mkN "avkolonisering" ;
  avkomling_nn_1_N = mkN "avkomling" ;
  avkoppling_nn_1_N = mkN "avkoppling" ;
  avkortning_nn_1_N = mkN "avkortning" ;
  avkriminalisering_nn_1_N = mkN "avkriminalisering" ;
  avkrok_nn_1_N = mkN "avkrok" ;
  avkraengning_nn_1_1_N = mkN "avkrängning" ;
  avkraevning_nn_1_1_N = mkN "avkrävning" ;
  avkylning_nn_1_N = mkN "avkylning" ;
  avlagring_nn_1_N = mkN "avlagring" ;
  avlastning_nn_1_N = mkN "avlastning" ;
  avledning_nn_1_N = mkN "avledning" ;
  avloppsbrunn_nn_1_N = mkN "avloppsbrunn" ;
  avloppsledning_nn_1_N = mkN "avloppsledning" ;
  avloppsrensning_nn_1_N = mkN "avloppsrensning" ;
  avloppsrensningsslang_nn_1_N = mkN "avloppsrensningsslang" ;
  avlusning_nn_1_N = mkN "avlusning" ;
  avlysning_nn_1_N = mkN "avlysning" ;
  avlyssning_nn_1_N = mkN "avlyssning" ;
  avlyssningsutrustning_nn_1_N = mkN "avlyssningsutrustning" ;
  avlaeggning_nn_1_1_N = mkN "avläggning" ;
  avlaemning_nn_1_1_N = mkN "avlämning" ;
  avlaesning_nn_1_1_N = mkN "avläsning" ;
  avloening_nn_1_1_N = mkN "avlöning" ;
  avloepning_nn_1_1_N = mkN "avlöpning" ;
  avloesning_nn_1_1_N = mkN "avlösning" ;
  avloevning_nn_1_1_N = mkN "avlövning" ;
  avmagnetisering_nn_1_N = mkN "avmagnetisering" ;
  avmagring_nn_1_N = mkN "avmagring" ;
  avmaskning_nn_1_N = mkN "avmaskning" ;
  avmattning_nn_1_N = mkN "avmattning" ;
  avmaetning_nn_1_1_N = mkN "avmätning" ;
  avmoenstring_nn_1_1_N = mkN "avmönstring" ;
  avnazifiering_nn_1_N = mkN "avnazifiering" ;
  avnypning_nn_1_N = mkN "avnypning" ;
  avpassning_nn_1_N = mkN "avpassning" ;
  avpatrullering_nn_1_N = mkN "avpatrullering" ;
  avplaning_nn_1_N = mkN "avplaning" ;
  avpolitisering_nn_1_N = mkN "avpolitisering" ;
  avpollettering_nn_1_N = mkN "avpollettering" ;
  avportraettering_nn_1_1_N = mkN "avporträttering" ;
  avreagering_nn_1_N = mkN "avreagering" ;
  avredning_nn_1_N = mkN "avredning" ;
  avregistrering_nn_1_N = mkN "avregistrering" ;
  avreglering_nn_1_N = mkN "avreglering" ;
  avringning_nn_1_N = mkN "avringning" ;
  avrinning_nn_1_N = mkN "avrinning" ;
  avritning_nn_1_N = mkN "avritning" ;
  avrivning_nn_1_N = mkN "avrivning" ;
  avromantisering_nn_1_N = mkN "avromantisering" ;
  avrundning_nn_1_N = mkN "avrundning" ;
  avrustning_nn_1_N = mkN "avrustning" ;
  avraekning_nn_1_1_N = mkN "avräkning" ;
  avraettning_nn_1_1_N = mkN "avrättning" ;
  avsaktning_nn_1_N = mkN "avsaktning" ;
  avsegling_nn_1_N = mkN "avsegling" ;
  avsiktsfoerklaring_nn_1_1_N = mkN "avsiktsförklaring" ;
  avsittning_nn_1_N = mkN "avsittning" ;
  avskaffning_nn_1_N = mkN "avskaffning" ;
  avskavning_nn_1_N = mkN "avskavning" ;
  avskedsfoerestaellning_nn_1_1_N = mkN "avskedsföreställning" ;
  avskedshaelsning_nn_1_1_N = mkN "avskedshälsning" ;
  avskedsmiddag_nn_1_N = mkN "avskedsmiddag" ;
  avskedsuppvaktning_nn_1_N = mkN "avskedsuppvaktning" ;
  avskjutning_nn_1_N = mkN "avskjutning" ;
  avskrivning_nn_1_N = mkN "avskrivning" ;
  avskraeckning_nn_1_1_N = mkN "avskräckning" ;
  avskraedeshoeg_nn_1_1_N = mkN "avskrädeshög" ;
  avskraedning_nn_1_1_N = mkN "avskrädning" ;
  avskaermning_nn_1_1_N = mkN "avskärmning" ;
  avskaerning_nn_1_1_N = mkN "avskärning" ;
  avslappning_nn_1_N = mkN "avslappning" ;
  avslappningsoevning_nn_1_1_N = mkN "avslappningsövning" ;
  avslipning_nn_1_N = mkN "avslipning" ;
  avslutning_nn_1_N = mkN "avslutning" ;
  avsloejning_nn_1_1_N = mkN "avslöjning" ;
  avsmakning_nn_1_N = mkN "avsmakning" ;
  avsmalning_nn_1_N = mkN "avsmalning" ;
  avsmaeltning_nn_1_1_N = mkN "avsmältning" ;
  avsnaesning_nn_1_1_N = mkN "avsnäsning" ;
  avsnoerning_nn_1_1_N = mkN "avsnörning" ;
  avsocialisering_nn_1_N = mkN "avsocialisering" ;
  avspark_nn_1_N = mkN "avspark" ;
  avspegling_nn_1_N = mkN "avspegling" ;
  avspelning_nn_1_N = mkN "avspelning" ;
  avspisning_nn_1_N = mkN "avspisning" ;
  avspaenning_nn_1_1_N = mkN "avspänning" ;
  avspaerrning_nn_1_1_N = mkN "avspärrning" ;
  avstalinisering_nn_1_N = mkN "avstalinisering" ;
  avstavning_nn_1_N = mkN "avstavning" ;
  avstickning_nn_1_N = mkN "avstickning" ;
  avstigning_nn_1_N = mkN "avstigning" ;
  avstjaelpning_nn_1_1_N = mkN "avstjälpning" ;
  avstyckning_nn_1_N = mkN "avstyckning" ;
  avstaellning_nn_1_1_N = mkN "avställning" ;
  avstaempling_nn_1_1_N = mkN "avstämpling" ;
  avstaengning_nn_1_1_N = mkN "avstängning" ;
  avstaandsbedoemning_nn_1_1_N = mkN "avståndsbedömning" ;
  avstaandsmaetning_nn_1_1_N = mkN "avståndsmätning" ;
  avstoetning_nn_1_1_N = mkN "avstötning" ;
  avsugning_nn_1_N = mkN "avsugning" ;
  avsvalkning_nn_1_N = mkN "avsvalkning" ;
  avsvalning_nn_1_N = mkN "avsvalning" ;
  avsvaerjning_nn_1_1_N = mkN "avsvärjning" ;
  avsyning_nn_1_N = mkN "avsyning" ;
  avsaendning_nn_1_1_N = mkN "avsändning" ;
  avsaettning_nn_1_1_N = mkN "avsättning" ;
  avsaagning_nn_1_1_N = mkN "avsågning" ;
  avsoendring_nn_1_1_N = mkN "avsöndring" ;
  avtackning_nn_1_N = mkN "avtackning" ;
  avtagning_nn_1_N = mkN "avtagning" ;
  avtagsvaeg_nn_1_1_N = mkN "avtagsväg" ;
  avtalsfoerhandling_nn_1_1_N = mkN "avtalsförhandling" ;
  avtappning_nn_1_N = mkN "avtappning" ;
  avteckning_nn_1_N = mkN "avteckning" ;
  avtoning_nn_1_N = mkN "avtoning" ;
  avtryckning_nn_1_N = mkN "avtryckning" ;
  avtunning_nn_1_N = mkN "avtunning" ;
  avtvagning_nn_1_N = mkN "avtvagning" ;
  avtyning_nn_1_N = mkN "avtyning" ;
  avtaeckning_nn_1_1_N = mkN "avtäckning" ;
  avveckling_nn_1_N = mkN "avveckling" ;
  avverkning_nn_1_N = mkN "avverkning" ;
  avvisning_nn_1_N = mkN "avvisning" ;
  avvaeg_nn_1_1_N = mkN "avväg" ;
  avvaegning_nn_1_1_N = mkN "avvägning" ;
  avvaendning_nn_1_1_N = mkN "avvändning" ;
  avvaenjning_nn_1_1_N = mkN "avvänjning" ;
  avvaerjning_nn_1_1_N = mkN "avvärjning" ;
  avaakning_nn_1_1_N = mkN "avåkning" ;
  axelkoppling_nn_1_N = mkN "axelkoppling" ;
  axelriktning_nn_1_N = mkN "axelriktning" ;
  axelryckning_nn_1_N = mkN "axelryckning" ;
  axiomatisering_nn_1_N = mkN "axiomatisering" ;
  axionfoertaetning_nn_1_1_N = mkN "axionförtätning" ;
  babianroev_nn_1_1_N = mkN "babianröv" ;
  backhoppning_nn_1_N = mkN "backhoppning" ;
  backning_nn_1_N = mkN "backning" ;
  badanlaeggning_nn_1_1_N = mkN "badanläggning" ;
  baddning_nn_1_N = mkN "baddning" ;
  badinraettning_nn_1_1_N = mkN "badinrättning" ;
  badmintonboll_nn_1_N = mkN "badmintonboll" ;
  badning_nn_1_N = mkN "badning" ;
  badrumsdoerr_nn_1_1_N = mkN "badrumsdörr" ;
  badrumsflaekt_nn_1_1_N = mkN "badrumsfläkt" ;
  bagageinlaemning_nn_1_1_N = mkN "bagageinlämning" ;
  bagagestropp_nn_1_N = mkN "bagagestropp" ;
  bagagevagn_nn_1_N = mkN "bagagevagn" ;
  bagatellisering_nn_1_N = mkN "bagatellisering" ;
  bajonettfattning_nn_1_N = mkN "bajonettfattning" ;
  bajshoeg_nn_1_1_N = mkN "bajshög" ;
  bakdoerr_nn_1_1_N = mkN "bakdörr" ;
  bakgrundsstraalning_nn_1_1_N = mkN "bakgrundsstrålning" ;
  bakladdning_nn_1_N = mkN "bakladdning" ;
  baklaengesvandring_nn_1_1_N = mkN "baklängesvandring" ;
  bakning_nn_1_N = mkN "bakning" ;
  bakport_nn_1_N = mkN "bakport" ;
  bakvagn_nn_1_N = mkN "bakvagn" ;
  bakvaeg_nn_1_1_N = mkN "bakväg" ;
  bakvaegg_nn_1_1_N = mkN "bakvägg" ;
  balansering_nn_1_N = mkN "balansering" ;
  balansrubbning_nn_1_N = mkN "balansrubbning" ;
  balansraekning_nn_1_1_N = mkN "balansräkning" ;
  balansvaag_nn_1_1_N = mkN "balansvåg" ;
  balkanisering_nn_1_N = mkN "balkanisering" ;
  balklaenning_nn_1_1_N = mkN "balklänning" ;
  balkongdoerr_nn_1_1_N = mkN "balkongdörr" ;
  ballongbluff_nn_1_N = mkN "ballongbluff" ;
  ballongboll_nn_1_N = mkN "ballongboll" ;
  ballotering_nn_1_N = mkN "ballotering" ;
  balsal_nn_1_N = mkN "balsal" ;
  balsamering_nn_1_N = mkN "balsamering" ;
  baltutlaemning_nn_1_1_N = mkN "baltutlämning" ;
  banalisering_nn_1_N = mkN "banalisering" ;
  bananstock_nn_1_N = mkN "bananstock" ;
  bandsaag_nn_1_1_N = mkN "bandsåg" ;
  bandupptagning_nn_1_N = mkN "bandupptagning" ;
  bandyboll_nn_1_N = mkN "bandyboll" ;
  baning_nn_1_N = mkN "baning" ;
  banklag_nn_1_N = mkN "banklag" ;
  bankruttering_nn_1_N = mkN "bankruttering" ;
  bankruttfoerklaring_nn_1_1_N = mkN "bankruttförklaring" ;
  banloepning_nn_1_1_N = mkN "banlöpning" ;
  bannlysning_nn_1_N = mkN "bannlysning" ;
  banskjutning_nn_1_N = mkN "banskjutning" ;
  bantning_nn_1_N = mkN "bantning" ;
  banvall_nn_1_N = mkN "banvall" ;
  barbarhoevding_nn_1_1_N = mkN "barbarhövding" ;
  barberarstol_nn_1_N = mkN "barberarstol" ;
  barfotaloepning_nn_1_1_N = mkN "barfotalöpning" ;
  barfotamunk_nn_1_N = mkN "barfotamunk" ;
  bariumfoerening_nn_1_1_N = mkN "bariumförening" ;
  barlastning_nn_1_N = mkN "barlastning" ;
  barmhaertighetsgaerning_nn_1_1_N = mkN "barmhärtighetsgärning" ;
  barnasjael_nn_1_1_N = mkN "barnasjäl" ;
  barnbegraensning_nn_1_1_N = mkN "barnbegränsning" ;
  barnbespisning_nn_1_N = mkN "barnbespisning" ;
  barncrosshjaelm_nn_1_1_N = mkN "barncrosshjälm" ;
  barndom_nn_1_N = mkN "barndom" ;
  barnfattigdom_nn_1_N = mkN "barnfattigdom" ;
  barnfoerlamning_nn_1_1_N = mkN "barnförlamning" ;
  barnhemsplacering_nn_1_N = mkN "barnhemsplacering" ;
  barnlek_nn_1_N = mkN "barnlek" ;
  barnparkering_nn_1_N = mkN "barnparkering" ;
  barnpassning_nn_1_N = mkN "barnpassning" ;
  barnsjukdom_nn_1_N = mkN "barnsjukdom" ;
  barnteckning_nn_1_N = mkN "barnteckning" ;
  barnvagn_nn_1_N = mkN "barnvagn" ;
  barrikadering_nn_1_N = mkN "barrikadering" ;
  barrskog_nn_1_N = mkN "barrskog" ;
  barservering_nn_1_N = mkN "barservering" ;
  barstol_nn_1_N = mkN "barstol" ;
  baseboll_nn_2_N = mkN "baseboll" ;
  basering_nn_1_N = mkN "basering" ;
  basketboll_nn_2_N = mkN "basketboll" ;
  basning_nn_1_N = mkN "basning" ;
  bassning_nn_1_N = mkN "bassning" ;
  bastingering_nn_1_N = mkN "bastingering" ;
  bastkjol_nn_1_N = mkN "bastkjol" ;
  bastufoerening_nn_1_1_N = mkN "bastuförening" ;
  bastuklubb_nn_1_N = mkN "bastuklubb" ;
  basunstoet_nn_1_1_N = mkN "basunstöt" ;
  basvaeg_nn_1_1_N = mkN "basväg" ;
  bataljmaalning_nn_1_1_N = mkN "bataljmålning" ;
  batteriladdning_nn_1_N = mkN "batteriladdning" ;
  batteritaendning_nn_1_1_N = mkN "batteritändning" ;
  bearbetning_nn_1_N = mkN "bearbetning" ;
  bebaadning_nn_1_1_N = mkN "bebådning" ;
  bedarrning_nn_1_N = mkN "bedarrning" ;
  bedoemning_nn_1_1_N = mkN "bedömning" ;
  bedoevning_nn_1_1_N = mkN "bedövning" ;
  befallning_nn_1_N = mkN "befallning" ;
  befattning_nn_1_N = mkN "befattning" ;
  befjaedring_nn_1_1_N = mkN "befjädring" ;
  befolkning_nn_1_N = mkN "befolkning" ;
  befolkningsundersoekning_nn_1_1_N = mkN "befolkningsundersökning" ;
  befolkningsoekning_nn_1_1_N = mkN "befolkningsökning" ;
  befordring_nn_1_N = mkN "befordring" ;
  befordringsgaang_nn_1_1_N = mkN "befordringsgång" ;
  befraktning_nn_1_N = mkN "befraktning" ;
  befruktning_nn_1_N = mkN "befruktning" ;
  befaelsfoering_nn_1_1_N = mkN "befälsföring" ;
  befaelsstaellning_nn_1_1_N = mkN "befälsställning" ;
  befaestning_nn_1_1_N = mkN "befästning" ;
  begapning_nn_1_N = mkN "begapning" ;
  begeistring_nn_1_N = mkN "begeistring" ;
  begjutning_nn_1_N = mkN "begjutning" ;
  beglaensning_nn_1_1_N = mkN "beglänsning" ;
  begravning_nn_1_N = mkN "begravning" ;
  begravningsdag_nn_1_N = mkN "begravningsdag" ;
  begreppsbestaemning_nn_1_1_N = mkN "begreppsbestämning" ;
  begreppsbildning_nn_1_N = mkN "begreppsbildning" ;
  begreppsfoervirring_nn_1_1_N = mkN "begreppsförvirring" ;
  begraensning_nn_1_1_N = mkN "begränsning" ;
  begaavning_nn_1_1_N = mkN "begåvning" ;
  behandling_nn_1_N = mkN "behandling" ;
  behovsproevning_nn_1_1_N = mkN "behovsprövning" ;
  behaengning_nn_1_1_N = mkN "behängning" ;
  behaerskning_nn_1_1_N = mkN "behärskning" ;
  behaallning_nn_1_1_N = mkN "behållning" ;
  behaaring_nn_1_1_N = mkN "behåring" ;
  bejakning_nn_1_N = mkN "bejakning" ;
  bekanting_nn_1_N = mkN "bekanting" ;
  beklaedning_nn_1_1_N = mkN "beklädning" ;
  beklaemning_nn_1_1_N = mkN "beklämning" ;
  bekransning_nn_1_N = mkN "bekransning" ;
  bekroening_nn_1_1_N = mkN "bekröning" ;
  bekvaemlighetsinraettning_nn_1_1_N = mkN "bekvämlighetsinrättning" ;
  bekaempning_nn_1_1_N = mkN "bekämpning" ;
  belastning_nn_1_N = mkN "belastning" ;
  beledsagning_nn_1_N = mkN "beledsagning" ;
  belysning_nn_1_N = mkN "belysning" ;
  belaeggning_nn_1_1_N = mkN "beläggning" ;
  belaeggningsring_nn_1_1_N = mkN "beläggningsring" ;
  belaegring_nn_1_1_N = mkN "belägring" ;
  belaaning_nn_1_1_N = mkN "belåning" ;
  beloening_nn_1_1_N = mkN "belöning" ;
  bemanning_nn_1_N = mkN "bemanning" ;
  benbildning_nn_1_N = mkN "benbildning" ;
  benediktinermunk_nn_1_N = mkN "benediktinermunk" ;
  benling_nn_1_N = mkN "benling" ;
  bensindunk_nn_1_N = mkN "bensindunk" ;
  bensinfoerbrukning_nn_1_1_N = mkN "bensinförbrukning" ;
  bensinpump_nn_1_N = mkN "bensinpump" ;
  bensinskattehoejning_nn_1_1_N = mkN "bensinskattehöjning" ;
  benaemning_nn_1_1_N = mkN "benämning" ;
  benaadning_nn_1_1_N = mkN "benådning" ;
  bepansring_nn_1_N = mkN "bepansring" ;
  beprisning_nn_1_N = mkN "beprisning" ;
  beredning_nn_1_N = mkN "beredning" ;
  beredskapslagring_nn_1_N = mkN "beredskapslagring" ;
  bergbestigning_nn_1_N = mkN "bergbestigning" ;
  bergborrning_nn_1_N = mkN "bergborrning" ;
  bergsbestigning_nn_1_N = mkN "bergsbestigning" ;
  bergshantering_nn_1_N = mkN "bergshantering" ;
  bergskedjebildning_nn_1_N = mkN "bergskedjebildning" ;
  bergsklaettring_nn_1_1_N = mkN "bergsklättring" ;
  bergssluttning_nn_1_N = mkN "bergssluttning" ;
  bergvind_nn_1_N = mkN "bergvind" ;
  beroendestaellning_nn_1_1_N = mkN "beroendeställning" ;
  berusning_nn_1_N = mkN "berusning" ;
  beraekning_nn_1_1_N = mkN "beräkning" ;
  beraettarbegaavning_nn_1_1_N = mkN "berättarbegåvning" ;
  beraettarstil_nn_1_1_N = mkN "berättarstil" ;
  beroering_nn_1_1_N = mkN "beröring" ;
  besiffring_nn_1_N = mkN "besiffring" ;
  besiktning_nn_1_N = mkN "besiktning" ;
  besinning_nn_1_N = mkN "besinning" ;
  besittning_nn_1_N = mkN "besittning" ;
  beskattning_nn_1_N = mkN "beskattning" ;
  beskickning_nn_1_N = mkN "beskickning" ;
  beskjutning_nn_1_N = mkN "beskjutning" ;
  beskrivning_nn_1_N = mkN "beskrivning" ;
  beskuggning_nn_1_N = mkN "beskuggning" ;
  beskyllning_nn_1_N = mkN "beskyllning" ;
  beskaerning_nn_1_1_N = mkN "beskärning" ;
  beskaadning_nn_1_1_N = mkN "beskådning" ;
  besloejning_nn_1_1_N = mkN "beslöjning" ;
  besmanskrok_nn_1_N = mkN "besmanskrok" ;
  besoldning_nn_1_N = mkN "besoldning" ;
  besparing_nn_1_N = mkN "besparing" ;
  besparingsskog_nn_1_N = mkN "besparingsskog" ;
  bespejning_nn_1_N = mkN "bespejning" ;
  bespisning_nn_1_N = mkN "bespisning" ;
  besprutning_nn_1_N = mkN "besprutning" ;
  bessemerblaasning_nn_1_1_N = mkN "bessemerblåsning" ;
  bestickfoering_nn_1_1_N = mkN "bestickföring" ;
  bestickning_nn_1_N = mkN "bestickning" ;
  bestigning_nn_1_N = mkN "bestigning" ;
  bestormning_nn_1_N = mkN "bestormning" ;
  bestraffning_nn_1_N = mkN "bestraffning" ;
  bestrykning_nn_1_N = mkN "bestrykning" ;
  bestraalning_nn_1_1_N = mkN "bestrålning" ;
  bestyckning_nn_1_N = mkN "bestyckning" ;
  bestaellning_nn_1_1_N = mkN "beställning" ;
  bestaemning_nn_1_1_N = mkN "bestämning" ;
  bestaenkning_nn_1_1_N = mkN "bestänkning" ;
  bestoertning_nn_1_1_N = mkN "bestörtning" ;
  besvaerjning_nn_1_1_N = mkN "besvärjning" ;
  besvaershandling_nn_1_1_N = mkN "besvärshandling" ;
  besvaershaenvisning_nn_1_1_N = mkN "besvärshänvisning" ;
  besaettning_nn_1_1_N = mkN "besättning" ;
  besoeksdag_nn_1_1_N = mkN "besöksdag" ;
  besoeksnaering_nn_1_1_N = mkN "besöksnäring" ;
  besoeksstol_nn_1_1_N = mkN "besöksstol" ;
  betalning_nn_1_N = mkN "betalning" ;
  betalningsanmaerkning_nn_1_1_N = mkN "betalningsanmärkning" ;
  betastraalning_nn_1_1_N = mkN "betastrålning" ;
  beteckning_nn_1_N = mkN "beteckning" ;
  beteendebehandling_nn_1_N = mkN "beteendebehandling" ;
  beteendeforskning_nn_1_N = mkN "beteendeforskning" ;
  beteenderubbning_nn_1_N = mkN "beteenderubbning" ;
  beteltuggning_nn_1_N = mkN "beteltuggning" ;
  betesgaang_nn_1_1_N = mkN "betesgång" ;
  betesslaepp_nn_1_1_N = mkN "betessläpp" ;
  betingning_nn_1_N = mkN "betingning" ;
  betingslaesning_nn_1_1_N = mkN "betingsläsning" ;
  betjaening_nn_1_1_N = mkN "betjäning" ;
  betning_nn_1_N = mkN "betning" ;
  betodling_nn_1_N = mkN "betodling" ;
  betongering_nn_1_N = mkN "betongering" ;
  betonghaeck_nn_1_1_N = mkN "betonghäck" ;
  betoning_nn_1_N = mkN "betoning" ;
  betsning_nn_1_N = mkN "betsning" ;
  betydelsefoerskjutning_nn_1_1_N = mkN "betydelseförskjutning" ;
  betydelsefoeraendring_nn_1_1_N = mkN "betydelseförändring" ;
  betydelseglidning_nn_1_N = mkN "betydelseglidning" ;
  betydelseutveckling_nn_1_N = mkN "betydelseutveckling" ;
  betyghoejning_nn_1_1_N = mkN "betyghöjning" ;
  betygshoejning_nn_1_1_N = mkN "betygshöjning" ;
  betygssaenkning_nn_1_1_N = mkN "betygssänkning" ;
  betygssaettning_nn_1_1_N = mkN "betygssättning" ;
  betygsaenkning_nn_1_1_N = mkN "betygsänkning" ;
  betygsaettning_nn_1_1_N = mkN "betygsättning" ;
  betaeckning_nn_1_1_N = mkN "betäckning" ;
  bevakning_nn_1_N = mkN "bevakning" ;
  bevattning_nn_1_N = mkN "bevattning" ;
  bevattningsanlaeggning_nn_1_1_N = mkN "bevattningsanläggning" ;
  bevillning_nn_1_N = mkN "bevillning" ;
  bevisfoering_nn_1_1_N = mkN "bevisföring" ;
  bevisfoervanskning_nn_1_1_N = mkN "bevisförvanskning" ;
  bevisning_nn_1_N = mkN "bevisning" ;
  bevisproevning_nn_1_1_N = mkN "bevisprövning" ;
  bevissaekring_nn_1_1_N = mkN "bevissäkring" ;
  bevisvaerdering_nn_1_1_N = mkN "bevisvärdering" ;
  bevaepning_nn_1_1_N = mkN "beväpning" ;
  bevaering_nn_1_1_N = mkN "beväring" ;
  bibelfoerklaring_nn_1_1_N = mkN "bibelförklaring" ;
  bibeltolkning_nn_1_N = mkN "bibeltolkning" ;
  bibeloeversaettning_nn_1_1_N = mkN "bibelöversättning" ;
  biblioteksbelysning_nn_1_N = mkN "biblioteksbelysning" ;
  biedermeierstil_nn_1_N = mkN "biedermeierstil" ;
  bifallsstorm_nn_1_N = mkN "bifallsstorm" ;
  bifallsyttring_nn_1_N = mkN "bifallsyttring" ;
  biffstek_nn_1_N = mkN "biffstek" ;
  bihandling_nn_1_N = mkN "bihandling" ;
  bilbesiktning_nn_1_N = mkN "bilbesiktning" ;
  bildhaallning_nn_1_1_N = mkN "bildhållning" ;
  bildning_nn_1_N = mkN "bildning" ;
  bildningsgaang_nn_1_1_N = mkN "bildningsgång" ;
  bildtolkning_nn_1_N = mkN "bildtolkning" ;
  bildoeverfoering_nn_1_1_N = mkN "bildöverföring" ;
  bilfoersaekring_nn_1_1_N = mkN "bilförsäkring" ;
  biljardboll_nn_1_N = mkN "biljardboll" ;
  biljettbokning_nn_1_N = mkN "biljettbokning" ;
  biljettfoersaeljning_nn_1_1_N = mkN "biljettförsäljning" ;
  biljettvisering_nn_1_N = mkN "biljettvisering" ;
  bilkrock_nn_1_N = mkN "bilkrock" ;
  bilkyrkogaard_nn_1_1_N = mkN "bilkyrkogård" ;
  bilkoerning_nn_1_1_N = mkN "bilkörning" ;
  bilparkering_nn_1_N = mkN "bilparkering" ;
  bilprovning_nn_1_N = mkN "bilprovning" ;
  bilratt_nn_1_N = mkN "bilratt" ;
  bilrengoering_nn_1_1_N = mkN "bilrengöring" ;
  bilring_nn_1_N = mkN "bilring" ;
  bilschamposvamp_nn_1_N = mkN "bilschamposvamp" ;
  bilskrot_nn_1_N = mkN "bilskrot" ;
  bilskrotning_nn_1_N = mkN "bilskrotning" ;
  bilstol_nn_1_N = mkN "bilstol" ;
  biltillverkning_nn_1_N = mkN "biltillverkning" ;
  biltvaett_nn_1_1_N = mkN "biltvätt" ;
  biltaevling_nn_1_1_N = mkN "biltävling" ;
  bilvaeg_nn_1_1_N = mkN "bilväg" ;
  bilaakning_nn_1_1_N = mkN "bilåkning" ;
  bindning_nn_1_N = mkN "bindning" ;
  bindnaal_nn_1_1_N = mkN "bindnål" ;
  bindvaevssaeck_nn_1_1_N = mkN "bindvävssäck" ;
  bindvaevstraad_nn_1_1_N = mkN "bindvävstråd" ;
  binaering_nn_1_1_N = mkN "binäring" ;
  biodling_nn_1_N = mkN "biodling" ;
  biofoerestaellning_nn_1_1_N = mkN "bioföreställning" ;
  biografering_nn_1_N = mkN "biografering" ;
  biskopsstol_nn_1_N = mkN "biskopsstol" ;
  bissering_nn_1_N = mkN "bissering" ;
  bistock_nn_1_N = mkN "bistock" ;
  bistaandsfoervaltning_nn_1_1_N = mkN "biståndsförvaltning" ;
  bisaettning_nn_1_1_N = mkN "bisättning" ;
  bivackering_nn_1_N = mkN "bivackering" ;
  biverkning_nn_1_N = mkN "biverkning" ;
  bivaeg_nn_1_1_N = mkN "biväg" ;
  bjudning_nn_1_N = mkN "bjudning" ;
  bjoernram_nn_1_1_N = mkN "björnram" ;
  bjoerntraad_nn_1_1_N = mkN "björntråd" ;
  bladfoting_nn_1_N = mkN "bladfoting" ;
  bladning_nn_1_N = mkN "bladning" ;
  bladstaellning_nn_1_1_N = mkN "bladställning" ;
  blanchering_nn_1_N = mkN "blanchering" ;
  blandning_nn_1_N = mkN "blandning" ;
  blandskog_nn_1_N = mkN "blandskog" ;
  blankning_nn_1_N = mkN "blankning" ;
  blankofoersaeljning_nn_1_1_N = mkN "blankoförsäljning" ;
  blankpolering_nn_1_N = mkN "blankpolering" ;
  blasonering_nn_1_N = mkN "blasonering" ;
  bleckburk_nn_1_N = mkN "bleckburk" ;
  blekning_nn_1_N = mkN "blekning" ;
  blessering_nn_1_N = mkN "blessering" ;
  blinddoerr_nn_1_1_N = mkN "blinddörr" ;
  blindering_nn_1_N = mkN "blindering" ;
  blindflygning_nn_1_N = mkN "blindflygning" ;
  blindlandning_nn_1_N = mkN "blindlandning" ;
  blindpressning_nn_1_N = mkN "blindpressning" ;
  blingning_nn_1_N = mkN "blingning" ;
  blinkning_nn_1_N = mkN "blinkning" ;
  blinning_nn_1_N = mkN "blinning" ;
  blippning_nn_1_N = mkN "blippning" ;
  blixtbelysning_nn_1_N = mkN "blixtbelysning" ;
  blixtfotografering_nn_1_N = mkN "blixtfotografering" ;
  blixtutryckning_nn_1_N = mkN "blixtutryckning" ;
  blockbildning_nn_1_N = mkN "blockbildning" ;
  blockering_nn_1_N = mkN "blockering" ;
  blockvagn_nn_1_N = mkN "blockvagn" ;
  bloddoping_nn_1_N = mkN "bloddoping" ;
  blodflaeck_nn_1_1_N = mkN "blodfläck" ;
  blodfoergiftning_nn_1_1_N = mkN "blodförgiftning" ;
  blodkorv_nn_1_N = mkN "blodkorv" ;
  blodkraekning_nn_1_1_N = mkN "blodkräkning" ;
  blodpropp_nn_1_N = mkN "blodpropp" ;
  blodprovstagning_nn_1_N = mkN "blodprovstagning" ;
  blodpudding_nn_1_N = mkN "blodpudding" ;
  blodpuddingsbit_nn_1_N = mkN "blodpuddingsbit" ;
  blodpump_nn_1_N = mkN "blodpump" ;
  blodsjukdom_nn_1_N = mkN "blodsjukdom" ;
  blodspenning_nn_1_N = mkN "blodspenning" ;
  blodspottning_nn_1_N = mkN "blodspottning" ;
  blodstallning_nn_1_N = mkN "blodstallning" ;
  blodstillning_nn_1_N = mkN "blodstillning" ;
  blodstockning_nn_1_N = mkN "blodstockning" ;
  blodstoertning_nn_1_1_N = mkN "blodstörtning" ;
  blodsvettning_nn_1_N = mkN "blodsvettning" ;
  blodtappning_nn_1_N = mkN "blodtappning" ;
  blodutgjutning_nn_1_N = mkN "blodutgjutning" ;
  blodvallning_nn_1_N = mkN "blodvallning" ;
  blodvittring_nn_1_N = mkN "blodvittring" ;
  blodoeverfoering_nn_1_1_N = mkN "blodöverföring" ;
  blombefruktning_nn_1_N = mkN "blombefruktning" ;
  blomflock_nn_1_N = mkN "blomflock" ;
  blommografering_nn_1_N = mkN "blommografering" ;
  blomning_nn_1_N = mkN "blomning" ;
  blomsterfoermedling_nn_1_1_N = mkN "blomsterförmedling" ;
  blomstergaard_nn_1_1_N = mkN "blomstergård" ;
  blomsterloek_nn_1_1_N = mkN "blomsterlök" ;
  blomsterodling_nn_1_N = mkN "blomsterodling" ;
  blomstertraedgaard_nn_1_1_N = mkN "blomsterträdgård" ;
  blomsteraeng_nn_1_1_N = mkN "blomsteräng" ;
  blomstring_nn_1_N = mkN "blomstring" ;
  blomstaellning_nn_1_1_N = mkN "blomställning" ;
  blondering_nn_1_N = mkN "blondering" ;
  blottlaeggning_nn_1_1_N = mkN "blottläggning" ;
  blyfoerening_nn_1_1_N = mkN "blyförening" ;
  blyfoergiftning_nn_1_1_N = mkN "blyförgiftning" ;
  blygdlaepp_nn_1_1_N = mkN "blygdläpp" ;
  blaeckflaeck_nn_1_1_N = mkN "bläckfläck" ;
  blaedning_nn_1_1_N = mkN "blädning" ;
  blaendning_nn_1_1_N = mkN "bländning" ;
  blaengning_nn_1_1_N = mkN "blängning" ;
  blaenkning_nn_1_1_N = mkN "blänkning" ;
  blaakopiering_nn_1_1_N = mkN "blåkopiering" ;
  blaasfoting_nn_1_1_N = mkN "blåsfoting" ;
  blaasning_nn_1_1_N = mkN "blåsning" ;
  bloedning_nn_1_1_N = mkN "blödning" ;
  bloetlaeggning_nn_1_1_N = mkN "blötläggning" ;
  bloetning_nn_1_1_N = mkN "blötning" ;
  boaorm_nn_1_N = mkN "boaorm" ;
  boasering_nn_1_N = mkN "boasering" ;
  boboll_nn_2_N = mkN "boboll" ;
  bockbraenning_nn_1_1_N = mkN "bockbränning" ;
  bockning_nn_1_N = mkN "bockning" ;
  bodelning_nn_1_N = mkN "bodelning" ;
  bodybuilding_nn_1_N = mkN "bodybuilding" ;
  boendesegregering_nn_1_N = mkN "boendesegregering" ;
  bogserbaat_nn_1_1_N = mkN "bogserbåt" ;
  bogsering_nn_1_N = mkN "bogsering" ;
  bohuslaening_nn_1_1_N = mkN "bohusläning" ;
  bohuslaenning_nn_1_1_N = mkN "bohuslänning" ;
  bojkottning_nn_1_N = mkN "bojkottning" ;
  bokbindning_nn_1_N = mkN "bokbindning" ;
  bokbraenning_nn_1_1_N = mkN "bokbränning" ;
  bokdamm_nn_1_N = mkN "bokdamm" ;
  bokfoering_nn_1_1_N = mkN "bokföring" ;
  bokklubb_nn_1_N = mkN "bokklubb" ;
  bokning_nn_1_N = mkN "bokning" ;
  boksamling_nn_1_N = mkN "boksamling" ;
  bokskog_nn_1_N = mkN "bokskog" ;
  bokstavering_nn_1_N = mkN "bokstavering" ;
  bokstavsbeteckning_nn_1_N = mkN "bokstavsbeteckning" ;
  bokstavsordning_nn_1_N = mkN "bokstavsordning" ;
  bolagsordning_nn_1_N = mkN "bolagsordning" ;
  bolagsskog_nn_1_N = mkN "bolagsskog" ;
  bollbehandling_nn_1_N = mkN "bollbehandling" ;
  bollning_nn_1_N = mkN "bollning" ;
  bolsterstock_nn_1_N = mkN "bolsterstock" ;
  bolstervagn_nn_1_N = mkN "bolstervagn" ;
  bombardering_nn_1_N = mkN "bombardering" ;
  bombering_nn_1_N = mkN "bombering" ;
  bombfaellning_nn_1_1_N = mkN "bombfällning" ;
  bombning_nn_1_N = mkN "bombning" ;
  bombtillverkning_nn_1_N = mkN "bombtillverkning" ;
  bomullsklaenning_nn_1_1_N = mkN "bomullsklänning" ;
  bomullstraad_nn_1_1_N = mkN "bomullstråd" ;
  bomullsvaev_nn_1_1_N = mkN "bomullsväv" ;
  bondebefolkning_nn_1_N = mkN "bondebefolkning" ;
  bondeskog_nn_1_N = mkN "bondeskog" ;
  bondgaard_nn_1_1_N = mkN "bondgård" ;
  bondlurk_nn_1_N = mkN "bondlurk" ;
  bondlaepp_nn_1_1_N = mkN "bondläpp" ;
  boning_nn_1_N = mkN "boning" ;
  bonitering_nn_1_N = mkN "bonitering" ;
  bonnlaepp_nn_1_1_N = mkN "bonnläpp" ;
  boplatsgraevning_nn_1_1_N = mkN "boplatsgrävning" ;
  bordduk_nn_1_N = mkN "bordduk" ;
  bordlaeggning_nn_1_1_N = mkN "bordläggning" ;
  bordning_nn_1_N = mkN "bordning" ;
  bordsbestaellning_nn_1_1_N = mkN "bordsbeställning" ;
  bordskniv_nn_1_N = mkN "bordskniv" ;
  borgarbevaepning_nn_1_1_N = mkN "borgarbeväpning" ;
  bornering_nn_1_N = mkN "bornering" ;
  borrhaalsvaegg_nn_1_1_N = mkN "borrhålsvägg" ;
  borrigg_nn_1_N = mkN "borrigg" ;
  borrning_nn_1_N = mkN "borrning" ;
  borrplattform_nn_1_N = mkN "borrplattform" ;
  borrsvaeng_nn_1_1_N = mkN "borrsväng" ;
  borrutrustning_nn_1_N = mkN "borrutrustning" ;
  borstning_nn_1_N = mkN "borstning" ;
  bortafoersaekring_nn_1_1_N = mkN "bortaförsäkring" ;
  bortarbetning_nn_1_N = mkN "bortarbetning" ;
  bortblaasning_nn_1_1_N = mkN "bortblåsning" ;
  bortdomning_nn_1_N = mkN "bortdomning" ;
  bortdrivning_nn_1_N = mkN "bortdrivning" ;
  bortdoemning_nn_1_1_N = mkN "bortdömning" ;
  bortforsling_nn_1_N = mkN "bortforsling" ;
  bortfoerklaring_nn_1_1_N = mkN "bortförklaring" ;
  bortlaeggning_nn_1_1_N = mkN "bortläggning" ;
  bortmotning_nn_1_N = mkN "bortmotning" ;
  bortodling_nn_1_N = mkN "bortodling" ;
  bortrationalisering_nn_1_N = mkN "bortrationalisering" ;
  bortresonering_nn_1_N = mkN "bortresonering" ;
  bortryckning_nn_1_N = mkN "bortryckning" ;
  bortskrivning_nn_1_N = mkN "bortskrivning" ;
  bortslumpning_nn_1_N = mkN "bortslumpning" ;
  bortspolning_nn_1_N = mkN "bortspolning" ;
  bortstoetning_nn_1_1_N = mkN "bortstötning" ;
  bortsaettning_nn_1_1_N = mkN "bortsättning" ;
  borttraengning_nn_1_1_N = mkN "bortträngning" ;
  borttvagning_nn_1_N = mkN "borttvagning" ;
  boskapsstock_nn_1_N = mkN "boskapsstock" ;
  boskapsuppfoedning_nn_1_1_N = mkN "boskapsuppfödning" ;
  bostadsfoermedling_nn_1_1_N = mkN "bostadsförmedling" ;
  bostadsraettsfoerening_nn_1_1_N = mkN "bostadsrättsförening" ;
  bosaettning_nn_1_1_N = mkN "bosättning" ;
  botanisering_nn_1_N = mkN "botanisering" ;
  botgoering_nn_1_1_N = mkN "botgöring" ;
  botoxfoerlamning_nn_1_1_N = mkN "botoxförlamning" ;
  bottenavlagring_nn_1_N = mkN "bottenavlagring" ;
  bottenfaellning_nn_1_1_N = mkN "bottenfällning" ;
  bottenkvark_nn_1_N = mkN "bottenkvark" ;
  bottenkaenning_nn_1_1_N = mkN "bottenkänning" ;
  bottenstock_nn_1_N = mkN "bottenstock" ;
  bottenvaaning_nn_1_1_N = mkN "bottenvåning" ;
  bottning_nn_1_N = mkN "bottning" ;
  bouppteckning_nn_1_N = mkN "bouppteckning" ;
  boutredning_nn_1_N = mkN "boutredning" ;
  boxboll_nn_1_N = mkN "boxboll" ;
  boxning_nn_1_N = mkN "boxning" ;
  boxningsring_nn_1_N = mkN "boxningsring" ;
  boxningstraening_nn_1_1_N = mkN "boxningsträning" ;
  brainstorming_nn_1_N = mkN "brainstorming" ;
  brakmiddag_nn_1_N = mkN "brakmiddag" ;
  brakskit_nn_1_N = mkN "brakskit" ;
  brandbil_nn_1_N = mkN "brandbil" ;
  branddoerr_nn_1_1_N = mkN "branddörr" ;
  brandfoersaekring_nn_1_1_N = mkN "brandförsäkring" ;
  brandkaarsutryckning_nn_1_1_N = mkN "brandkårsutryckning" ;
  brandskattning_nn_1_N = mkN "brandskattning" ;
  brandskyddslagstiftning_nn_1_N = mkN "brandskyddslagstiftning" ;
  brandslang_nn_1_N = mkN "brandslang" ;
  brandoevning_nn_1_1_N = mkN "brandövning" ;
  branschfoerening_nn_1_1_N = mkN "branschförening" ;
  branschtidning_nn_1_N = mkN "branschtidning" ;
  breddning_nn_1_N = mkN "breddning" ;
  bredvidlaesning_nn_1_1_N = mkN "bredvidläsning" ;
  brevbaering_nn_1_1_N = mkN "brevbäring" ;
  brevlapp_nn_1_N = mkN "brevlapp" ;
  brevlaadetoemning_nn_1_1_N = mkN "brevlådetömning" ;
  brevsamling_nn_1_N = mkN "brevsamling" ;
  brevskoerd_nn_1_1_N = mkN "brevskörd" ;
  brevstil_nn_1_N = mkN "brevstil" ;
  brevvaexling_nn_1_1_N = mkN "brevväxling" ;
  brevvaag_nn_1_1_N = mkN "brevvåg" ;
  brickduk_nn_1_N = mkN "brickduk" ;
  brickvaevning_nn_1_1_N = mkN "brickvävning" ;
  brikettering_nn_1_N = mkN "brikettering" ;
  briljering_nn_1_N = mkN "briljering" ;
  brisering_nn_1_N = mkN "brisering" ;
  bristning_nn_1_N = mkN "bristning" ;
  bristsjukdom_nn_1_N = mkN "bristsjukdom" ;
  brobelastning_nn_1_N = mkN "brobelastning" ;
  brodering_nn_1_N = mkN "brodering" ;
  brodernaal_nn_1_1_N = mkN "brodernål" ;
  broderskaerlek_nn_1_1_N = mkN "broderskärlek" ;
  bromering_nn_1_N = mkN "bromering" ;
  bromfoergiftning_nn_1_1_N = mkN "bromförgiftning" ;
  bromsfading_nn_1_N = mkN "bromsfading" ;
  bromsning_nn_1_N = mkN "bromsning" ;
  bromsstraalning_nn_1_1_N = mkN "bromsstrålning" ;
  bronsering_nn_1_N = mkN "bronsering" ;
  bronsknapp_nn_1_N = mkN "bronsknapp" ;
  bronsaaldersgrav_nn_1_1_N = mkN "bronsåldersgrav" ;
  broschering_nn_1_N = mkN "broschering" ;
  broslagning_nn_1_N = mkN "broslagning" ;
  brottning_nn_1_N = mkN "brottning" ;
  brottningsring_nn_1_N = mkN "brottningsring" ;
  brottsbevakning_nn_1_N = mkN "brottsbevakning" ;
  brottsplatsundersoekning_nn_1_1_N = mkN "brottsplatsundersökning" ;
  brottsrubricering_nn_1_N = mkN "brottsrubricering" ;
  brottsutredning_nn_1_N = mkN "brottsutredning" ;
  brooeppning_nn_1_1_N = mkN "broöppning" ;
  brudklaenning_nn_1_1_N = mkN "brudklänning" ;
  brudoeverlaemning_nn_1_1_N = mkN "brudöverlämning" ;
  brukning_nn_1_N = mkN "brukning" ;
  bruksanvisning_nn_1_N = mkN "bruksanvisning" ;
  brukslev_nn_1_N = mkN "brukslev" ;
  brumbjoern_nn_1_1_N = mkN "brumbjörn" ;
  brunering_nn_1_N = mkN "brunering" ;
  brunnsdrickning_nn_1_N = mkN "brunnsdrickning" ;
  brutalisering_nn_1_N = mkN "brutalisering" ;
  bruttobehaallning_nn_1_1_N = mkN "bruttobehållning" ;
  bryggarbil_nn_1_N = mkN "bryggarbil" ;
  bryggvaag_nn_1_1_N = mkN "bryggvåg" ;
  brytbladskniv_nn_1_N = mkN "brytbladskniv" ;
  brytning_nn_1_N = mkN "brytning" ;
  braeckkorv_nn_1_1_N = mkN "bräckkorv" ;
  braeckning_nn_1_1_N = mkN "bräckning" ;
  braedgaang_nn_1_1_N = mkN "brädgång" ;
  braedvaegg_nn_1_1_N = mkN "brädvägg" ;
  braekning_nn_1_1_N = mkN "bräkning" ;
  braennboll_nn_2_1_N = mkN "brännboll" ;
  braenning_nn_1_1_N = mkN "bränning" ;
  braennlackering_nn_1_1_N = mkN "brännlackering" ;
  braennmaerkning_nn_1_1_N = mkN "brännmärkning" ;
  braennugn_nn_1_1_N = mkN "brännugn" ;
  braennvinsdestillering_nn_1_1_N = mkN "brännvinsdestillering" ;
  braensleransonering_nn_1_1_N = mkN "bränsleransonering" ;
  braesering_nn_1_1_N = mkN "bräsering" ;
  broedbit_nn_1_1_N = mkN "brödbit" ;
  broedburk_nn_1_1_N = mkN "brödburk" ;
  broedkniv_nn_1_1_N = mkN "brödkniv" ;
  broellopsdag_nn_1_1_N = mkN "bröllopsdag" ;
  broellopsklaenning_nn_1_1_N = mkN "bröllopsklänning" ;
  broestfoerstoring_nn_1_1_N = mkN "bröstförstoring" ;
  broestgaang_nn_1_1_N = mkN "bröstgång" ;
  broestning_nn_1_1_N = mkN "bröstning" ;
  broestpump_nn_1_1_N = mkN "bröstpump" ;
  budgetering_nn_1_N = mkN "budgetering" ;
  budgivning_nn_1_N = mkN "budgivning" ;
  budkavleloepning_nn_1_1_N = mkN "budkavlelöpning" ;
  budning_nn_1_N = mkN "budning" ;
  buffertloesning_nn_1_1_N = mkN "buffertlösning" ;
  buggning_nn_1_N = mkN "buggning" ;
  bugning_nn_1_N = mkN "bugning" ;
  buktning_nn_1_N = mkN "buktning" ;
  buljongtaerning_nn_1_1_N = mkN "buljongtärning" ;
  bullerskaerm_nn_1_1_N = mkN "bullerskärm" ;
  bultning_nn_1_N = mkN "bultning" ;
  buntning_nn_1_N = mkN "buntning" ;
  burkslav_nn_1_N = mkN "burkslav" ;
  buskoerning_nn_1_1_N = mkN "buskörning" ;
  busringning_nn_1_N = mkN "busringning" ;
  bussavgaang_nn_1_1_N = mkN "bussavgång" ;
  busskrock_nn_1_N = mkN "busskrock" ;
  bussning_nn_1_N = mkN "bussning" ;
  busvissling_nn_1_N = mkN "busvissling" ;
  buteljering_nn_1_N = mkN "buteljering" ;
  butiksdoerr_nn_1_1_N = mkN "butiksdörr" ;
  butiksstaengningslag_nn_1_1_N = mkN "butiksstängningslag" ;
  bygdeborg_nn_1_N = mkN "bygdeborg" ;
  bygdegaard_nn_1_1_N = mkN "bygdegård" ;
  byggarbetskran_nn_1_N = mkN "byggarbetskran" ;
  byggflopp_nn_1_N = mkN "byggflopp" ;
  bygglag_nn_1_N = mkN "bygglag" ;
  byggnadsstil_nn_1_N = mkN "byggnadsstil" ;
  byggnadsstaellning_nn_1_1_N = mkN "byggnadsställning" ;
  byggning_nn_1_N = mkN "byggning" ;
  byggstaellning_nn_1_1_N = mkN "byggställning" ;
  byordning_nn_1_N = mkN "byordning" ;
  byraakratisering_nn_1_1_N = mkN "byråkratisering" ;
  bysaettning_nn_1_1_N = mkN "bysättning" ;
  byteshushaallning_nn_1_1_N = mkN "byteshushållning" ;
  byvaeg_nn_1_1_N = mkN "byväg" ;
  byxkjol_nn_1_N = mkN "byxkjol" ;
  baeckenfoertraengning_nn_1_1_N = mkN "bäckenförträngning" ;
  baeckmynning_nn_1_1_N = mkN "bäckmynning" ;
  baeddning_nn_1_1_N = mkN "bäddning" ;
  baeddutrustning_nn_1_1_N = mkN "bäddutrustning" ;
  baelteslaeggning_nn_1_1_N = mkN "bältesläggning" ;
  baendning_nn_1_1_N = mkN "bändning" ;
  baergning_nn_1_1_N = mkN "bärgning" ;
  baergningsbil_nn_1_1_N = mkN "bärgningsbil" ;
  baering_nn_1_1_N = mkN "bäring" ;
  baerplansbaat_nn_1_1_N = mkN "bärplansbåt" ;
  baerstol_nn_1_1_N = mkN "bärstol" ;
  baettring_nn_1_1_N = mkN "bättring" ;
  baevning_nn_1_1_N = mkN "bävning" ;
  baaggaang_nn_1_1_N = mkN "båggång" ;
  baagstraeng_nn_1_1_N = mkN "bågsträng" ;
  baagsvetsning_nn_1_1_N = mkN "bågsvetsning" ;
  baagsaag_nn_1_1_N = mkN "bågsåg" ;
  baalrullning_nn_1_1_N = mkN "bålrullning" ;
  baatavgaang_nn_1_1_N = mkN "båtavgång" ;
  baatgrav_nn_1_1_N = mkN "båtgrav" ;
  baatklubb_nn_1_1_N = mkN "båtklubb" ;
  baattaevling_nn_1_1_N = mkN "båttävling" ;
  boejning_nn_1_1_N = mkN "böjning" ;
  boekning_nn_1_1_N = mkN "bökning" ;
  boeljegaang_nn_1_1_N = mkN "böljegång" ;
  boelning_nn_1_1_N = mkN "bölning" ;
  boenesal_nn_1_1_N = mkN "bönesal" ;
  boenpall_nn_1_1_N = mkN "bönpall" ;
  boersnotering_nn_1_1_N = mkN "börsnotering" ;
  boersuppgaang_nn_1_1_N = mkN "börsuppgång" ;
  boessinsamling_nn_1_1_N = mkN "bössinsamling" ;
  calmettevaccinering_nn_1_N = mkN "calmettevaccinering" ;
  camouflering_nn_1_N = mkN "camouflering" ;
  cancerbehandling_nn_1_N = mkN "cancerbehandling" ;
  cancerforskning_nn_1_N = mkN "cancerforskning" ;
  canceruppfoeljning_nn_1_1_N = mkN "canceruppföljning" ;
  cannabisodling_nn_1_N = mkN "cannabisodling" ;
  canossavandring_nn_1_N = mkN "canossavandring" ;
  cedering_nn_1_N = mkN "cedering" ;
  cederskog_nn_1_N = mkN "cederskog" ;
  celebrering_nn_1_N = mkN "celebrering" ;
  cellandning_nn_1_N = mkN "cellandning" ;
  celldelning_nn_1_N = mkN "celldelning" ;
  cellgiftsbehandling_nn_1_N = mkN "cellgiftsbehandling" ;
  cellspaenning_nn_1_1_N = mkN "cellspänning" ;
  celltraad_nn_1_1_N = mkN "celltråd" ;
  cellulosafoertunning_nn_1_1_N = mkN "cellulosaförtunning" ;
  cellvaegg_nn_1_1_N = mkN "cellvägg" ;
  cembalotillverkning_nn_1_N = mkN "cembalotillverkning" ;
  cementering_nn_1_N = mkN "cementering" ;
  censurering_nn_1_N = mkN "censurering" ;
  centralfoervaltning_nn_1_1_N = mkN "centralförvaltning" ;
  centralisering_nn_1_N = mkN "centralisering" ;
  centralregering_nn_1_N = mkN "centralregering" ;
  centrering_nn_1_N = mkN "centrering" ;
  centrifugalpump_nn_1_N = mkN "centrifugalpump" ;
  centrifugering_nn_1_N = mkN "centrifugering" ;
  cernering_nn_1_N = mkN "cernering" ;
  certifiering_nn_1_N = mkN "certifiering" ;
  champagnebaergning_nn_1_1_N = mkN "champagnebärgning" ;
  champagnekork_nn_1_N = mkN "champagnekork" ;
  changering_nn_1_N = mkN "changering" ;
  changsering_nn_1_N = mkN "changsering" ;
  chansering_nn_1_N = mkN "chansering" ;
  chansning_nn_1_N = mkN "chansning" ;
  chanstagning_nn_1_N = mkN "chanstagning" ;
  chargering_nn_1_N = mkN "chargering" ;
  charmering_nn_1_N = mkN "charmering" ;
  charmkvark_nn_1_N = mkN "charmkvark" ;
  checkraekning_nn_1_1_N = mkN "checkräkning" ;
  chefsflytt_nn_1_N = mkN "chefsflytt" ;
  chefsstaellning_nn_1_1_N = mkN "chefsställning" ;
  chevrotering_nn_1_N = mkN "chevrotering" ;
  chiffonggarnering_nn_1_N = mkN "chiffonggarnering" ;
  chiffongklaenning_nn_1_1_N = mkN "chiffongklänning" ;
  chiffrering_nn_1_N = mkN "chiffrering" ;
  chikanering_nn_1_N = mkN "chikanering" ;
  chimpning_nn_1_N = mkN "chimpning" ;
  chockbehandling_nn_1_N = mkN "chockbehandling" ;
  chockering_nn_1_N = mkN "chockering" ;
  chokladboll_nn_1_N = mkN "chokladboll" ;
  cirkelsaag_nn_1_1_N = mkN "cirkelsåg" ;
  cirkulationspump_nn_1_N = mkN "cirkulationspump" ;
  cirkulationsrubbning_nn_1_N = mkN "cirkulationsrubbning" ;
  cirkulering_nn_1_N = mkN "cirkulering" ;
  cirkusfoerestaellning_nn_1_1_N = mkN "cirkusföreställning" ;
  cirkusvagn_nn_1_N = mkN "cirkusvagn" ;
  ciselering_nn_1_N = mkN "ciselering" ;
  cisterciensermunk_nn_1_N = mkN "cisterciensermunk" ;
  citering_nn_1_N = mkN "citering" ;
  civilbefolkning_nn_1_N = mkN "civilbefolkning" ;
  civilbegravning_nn_1_N = mkN "civilbegravning" ;
  civilisering_nn_1_N = mkN "civilisering" ;
  civillag_nn_1_N = mkN "civillag" ;
  cloisonvaegg_nn_1_1_N = mkN "cloisonvägg" ;
  clubstek_nn_1_N = mkN "clubstek" ;
  cocktailbjudning_nn_1_N = mkN "cocktailbjudning" ;
  cortisonbehandling_nn_1_N = mkN "cortisonbehandling" ;
  coverlaat_nn_1_1_N = mkN "coverlåt" ;
  cowboyhatt_nn_1_N = mkN "cowboyhatt" ;
  crosshjaelm_nn_1_1_N = mkN "crosshjälm" ;
  curlingtaevling_nn_1_1_N = mkN "curlingtävling" ;
  cykelhjaelm_nn_1_1_N = mkN "cykelhjälm" ;
  cykelkrock_nn_1_N = mkN "cykelkrock" ;
  cykelkrok_nn_1_N = mkN "cykelkrok" ;
  cykelpump_nn_1_N = mkN "cykelpump" ;
  cykelram_nn_1_N = mkN "cykelram" ;
  cykelslang_nn_1_N = mkN "cykelslang" ;
  cykeltaevling_nn_1_1_N = mkN "cykeltävling" ;
  cylinderhatt_nn_1_N = mkN "cylinderhatt" ;
  dagavdelning_nn_1_N = mkN "dagavdelning" ;
  dagboksanteckning_nn_1_N = mkN "dagboksanteckning" ;
  dagbrytning_nn_1_N = mkN "dagbrytning" ;
  dagbraeckning_nn_1_1_N = mkN "dagbräckning" ;
  dagenefterstaemning_nn_1_1_N = mkN "dagenefterstämning" ;
  daggryning_nn_1_N = mkN "daggryning" ;
  dagjaemning_nn_1_1_N = mkN "dagjämning" ;
  dagning_nn_1_N = mkN "dagning" ;
  dagordning_nn_1_N = mkN "dagordning" ;
  dagskryssning_nn_1_N = mkN "dagskryssning" ;
  dagstidning_nn_1_N = mkN "dagstidning" ;
  dagteckning_nn_1_N = mkN "dagteckning" ;
  dagoeppning_nn_1_1_N = mkN "dagöppning" ;
  dalgaang_nn_1_1_N = mkN "dalgång" ;
  dallring_nn_1_N = mkN "dallring" ;
  dalmaalning_nn_1_1_N = mkN "dalmålning" ;
  dalning_nn_1_N = mkN "dalning" ;
  dalsluttning_nn_1_N = mkN "dalsluttning" ;
  dalslaenning_nn_1_1_N = mkN "dalslänning" ;
  dalvind_nn_1_N = mkN "dalvind" ;
  damaskering_nn_1_N = mkN "damaskering" ;
  damastduk_nn_1_N = mkN "damastduk" ;
  dambjudning_nn_1_N = mkN "dambjudning" ;
  damfrisering_nn_1_N = mkN "damfrisering" ;
  dammanlaeggning_nn_1_1_N = mkN "dammanläggning" ;
  dammport_nn_1_N = mkN "dammport" ;
  dammpump_nn_1_N = mkN "dammpump" ;
  dammsugarfoersaeljning_nn_1_1_N = mkN "dammsugarförsäljning" ;
  dammsugning_nn_1_N = mkN "dammsugning" ;
  damning_nn_1_N = mkN "damning" ;
  damtidning_nn_1_N = mkN "damtidning" ;
  daning_nn_1_N = mkN "daning" ;
  danstillstaellning_nn_1_1_N = mkN "danstillställning" ;
  darrning_nn_1_N = mkN "darrning" ;
  dartpil_nn_1_N = mkN "dartpil" ;
  dataanlaeggning_nn_1_1_N = mkN "dataanläggning" ;
  databehandling_nn_1_N = mkN "databehandling" ;
  datainsamling_nn_1_N = mkN "datainsamling" ;
  datakoerning_nn_1_1_N = mkN "datakörning" ;
  datasimulering_nn_1_N = mkN "datasimulering" ;
  datering_nn_1_N = mkN "datering" ;
  datoranlaeggning_nn_1_1_N = mkN "datoranläggning" ;
  datorbehandling_nn_1_N = mkN "datorbehandling" ;
  datorberaekning_nn_1_1_N = mkN "datorberäkning" ;
  datorsimulering_nn_1_N = mkN "datorsimulering" ;
  datorsladd_nn_1_N = mkN "datorsladd" ;
  datorutrustning_nn_1_N = mkN "datorutrustning" ;
  datummaerkning_nn_1_1_N = mkN "datummärkning" ;
  datumparkering_nn_1_N = mkN "datumparkering" ;
  debarkering_nn_1_N = mkN "debarkering" ;
  debattering_nn_1_N = mkN "debattering" ;
  debitering_nn_1_N = mkN "debitering" ;
  debutering_nn_1_N = mkN "debutering" ;
  decentralisering_nn_1_N = mkN "decentralisering" ;
  dechiffrering_nn_1_N = mkN "dechiffrering" ;
  decimering_nn_1_N = mkN "decimering" ;
  deckardrottning_nn_1_N = mkN "deckardrottning" ;
  deckarkung_nn_1_N = mkN "deckarkung" ;
  dedicering_nn_1_N = mkN "dedicering" ;
  dedikering_nn_1_N = mkN "dedikering" ;
  deducering_nn_1_N = mkN "deducering" ;
  defilering_nn_1_N = mkN "defilering" ;
  definiering_nn_1_N = mkN "definiering" ;
  deflorering_nn_1_N = mkN "deflorering" ;
  deformering_nn_1_N = mkN "deformering" ;
  degenerering_nn_1_N = mkN "degenerering" ;
  degradering_nn_1_N = mkN "degradering" ;
  dekantering_nn_1_N = mkN "dekantering" ;
  dekapitering_nn_1_N = mkN "dekapitering" ;
  deklamering_nn_1_N = mkN "deklamering" ;
  deklarering_nn_1_N = mkN "deklarering" ;
  deklassering_nn_1_N = mkN "deklassering" ;
  deklinering_nn_1_N = mkN "deklinering" ;
  dekolletering_nn_1_N = mkN "dekolletering" ;
  dekorationsgran_nn_1_N = mkN "dekorationsgran" ;
  dekorationsmaalning_nn_1_1_N = mkN "dekorationsmålning" ;
  dekorering_nn_1_N = mkN "dekorering" ;
  dekouragering_nn_1_N = mkN "dekouragering" ;
  dekretering_nn_1_N = mkN "dekretering" ;
  delbetalning_nn_1_N = mkN "delbetalning" ;
  delegering_nn_1_N = mkN "delegering" ;
  delgivning_nn_1_N = mkN "delgivning" ;
  delkaskofoersaekring_nn_1_1_N = mkN "delkaskoförsäkring" ;
  delning_nn_1_N = mkN "delning" ;
  deltaevling_nn_1_1_N = mkN "deltävling" ;
  demaskering_nn_1_N = mkN "demaskering" ;
  demenssjukdom_nn_1_N = mkN "demenssjukdom" ;
  dementering_nn_1_N = mkN "dementering" ;
  demilitarisering_nn_1_N = mkN "demilitarisering" ;
  demissionering_nn_1_N = mkN "demissionering" ;
  demobilisering_nn_1_N = mkN "demobilisering" ;
  demoinspelning_nn_1_N = mkN "demoinspelning" ;
  demokratisering_nn_1_N = mkN "demokratisering" ;
  demokratiutveckling_nn_1_N = mkN "demokratiutveckling" ;
  demolering_nn_1_N = mkN "demolering" ;
  demonstrering_nn_1_N = mkN "demonstrering" ;
  demontering_nn_1_N = mkN "demontering" ;
  demoralisering_nn_1_N = mkN "demoralisering" ;
  denaturalisering_nn_1_N = mkN "denaturalisering" ;
  denaturering_nn_1_N = mkN "denaturering" ;
  denotering_nn_1_N = mkN "denotering" ;
  denudering_nn_1_N = mkN "denudering" ;
  denuklearisering_nn_1_N = mkN "denuklearisering" ;
  deodorisering_nn_1_N = mkN "deodorisering" ;
  depatriering_nn_1_N = mkN "depatriering" ;
  depensering_nn_1_N = mkN "depensering" ;
  deplacering_nn_1_N = mkN "deplacering" ;
  deponering_nn_1_N = mkN "deponering" ;
  deportering_nn_1_N = mkN "deportering" ;
  depreciering_nn_1_N = mkN "depreciering" ;
  derangering_nn_1_N = mkN "derangering" ;
  derivering_nn_1_N = mkN "derivering" ;
  desarmering_nn_1_N = mkN "desarmering" ;
  desavouering_nn_1_N = mkN "desavouering" ;
  desensibilisering_nn_1_N = mkN "desensibilisering" ;
  desertering_nn_1_N = mkN "desertering" ;
  designering_nn_1_N = mkN "designering" ;
  designtaevling_nn_1_1_N = mkN "designtävling" ;
  desinfektering_nn_1_N = mkN "desinfektering" ;
  desinficering_nn_1_N = mkN "desinficering" ;
  desinformering_nn_1_N = mkN "desinformering" ;
  desorganisering_nn_1_N = mkN "desorganisering" ;
  desorientering_nn_1_N = mkN "desorientering" ;
  dessertkniv_nn_1_N = mkN "dessertkniv" ;
  dessertsked_nn_1_N = mkN "dessertsked" ;
  desserttallrik_nn_1_N = mkN "desserttallrik" ;
  destillering_nn_1_N = mkN "destillering" ;
  destinering_nn_1_N = mkN "destinering" ;
  destruering_nn_1_N = mkN "destruering" ;
  destruktionsanlaeggning_nn_1_1_N = mkN "destruktionsanläggning" ;
  detachering_nn_1_N = mkN "detachering" ;
  detaljanmaerkning_nn_1_1_N = mkN "detaljanmärkning" ;
  detaljering_nn_1_N = mkN "detaljering" ;
  detaljkaennedom_nn_1_1_N = mkN "detaljkännedom" ;
  detaljrikedom_nn_1_N = mkN "detaljrikedom" ;
  detaljritning_nn_1_N = mkN "detaljritning" ;
  detektering_nn_1_N = mkN "detektering" ;
  determinering_nn_1_N = mkN "determinering" ;
  detonering_nn_1_N = mkN "detonering" ;
  detronisering_nn_1_N = mkN "detronisering" ;
  devalvering_nn_1_N = mkN "devalvering" ;
  deviering_nn_1_N = mkN "deviering" ;
  diagnosticering_nn_1_N = mkN "diagnosticering" ;
  diagnostisering_nn_1_N = mkN "diagnostisering" ;
  dialysering_nn_1_N = mkN "dialysering" ;
  diamantring_nn_1_N = mkN "diamantring" ;
  dieselpump_nn_1_N = mkN "dieselpump" ;
  differentiering_nn_1_N = mkN "differentiering" ;
  diffundering_nn_1_N = mkN "diffundering" ;
  diftongering_nn_1_N = mkN "diftongering" ;
  digerering_nn_1_N = mkN "digerering" ;
  digivning_nn_1_N = mkN "digivning" ;
  dikeskoerning_nn_1_1_N = mkN "dikeskörning" ;
  dikning_nn_1_N = mkN "dikning" ;
  diktarbegaavning_nn_1_1_N = mkN "diktarbegåvning" ;
  diktering_nn_1_N = mkN "diktering" ;
  diktning_nn_1_N = mkN "diktning" ;
  diktsamling_nn_1_N = mkN "diktsamling" ;
  dimbildning_nn_1_N = mkN "dimbildning" ;
  dimensionering_nn_1_N = mkN "dimensionering" ;
  dimensionsavverkning_nn_1_N = mkN "dimensionsavverkning" ;
  dinering_nn_1_N = mkN "dinering" ;
  diplomering_nn_1_N = mkN "diplomering" ;
  direktinsprutning_nn_1_N = mkN "direktinsprutning" ;
  direktsaendning_nn_1_1_N = mkN "direktsändning" ;
  direkttraeff_nn_1_1_N = mkN "direktträff" ;
  dirigering_nn_1_N = mkN "dirigering" ;
  disciplinering_nn_1_N = mkN "disciplinering" ;
  disharmoniering_nn_1_N = mkN "disharmoniering" ;
  diskning_nn_2_N = mkN "diskning" ;
  diskontering_nn_1_N = mkN "diskontering" ;
  diskreditering_nn_1_N = mkN "diskreditering" ;
  diskriminering_nn_1_N = mkN "diskriminering" ;
  diskrimineringslagstiftning_nn_1_N = mkN "diskrimineringslagstiftning" ;
  disktorkning_nn_1_N = mkN "disktorkning" ;
  diskuskastning_nn_1_N = mkN "diskuskastning" ;
  diskutering_nn_1_N = mkN "diskutering" ;
  diskvalificering_nn_1_N = mkN "diskvalificering" ;
  dispaschering_nn_1_N = mkN "dispaschering" ;
  dispensering_nn_1_N = mkN "dispensering" ;
  dispergering_nn_1_N = mkN "dispergering" ;
  disponering_nn_1_N = mkN "disponering" ;
  disputering_nn_1_N = mkN "disputering" ;
  dissekering_nn_1_N = mkN "dissekering" ;
  dissociering_nn_1_N = mkN "dissociering" ;
  dissonering_nn_1_N = mkN "dissonering" ;
  distansering_nn_1_N = mkN "distansering" ;
  distansflygning_nn_1_N = mkN "distansflygning" ;
  distansundervisning_nn_1_N = mkN "distansundervisning" ;
  distrahering_nn_1_N = mkN "distrahering" ;
  distribuering_nn_1_N = mkN "distribuering" ;
  divergering_nn_1_N = mkN "divergering" ;
  diversifiering_nn_1_N = mkN "diversifiering" ;
  dividering_nn_1_N = mkN "dividering" ;
  djupavslappning_nn_1_N = mkN "djupavslappning" ;
  djupborrning_nn_1_N = mkN "djupborrning" ;
  djupbrytning_nn_1_N = mkN "djupbrytning" ;
  djupdykning_nn_1_N = mkN "djupdykning" ;
  djuphavsgrav_nn_1_N = mkN "djuphavsgrav" ;
  djuplek_nn_1_N = mkN "djuplek" ;
  djuplodning_nn_1_N = mkN "djuplodning" ;
  djuptallrik_nn_1_N = mkN "djuptallrik" ;
  djupurladdning_nn_1_N = mkN "djupurladdning" ;
  djurfoeraedling_nn_1_1_N = mkN "djurförädling" ;
  djurskyddsfoerening_nn_1_1_N = mkN "djurskyddsförening" ;
  djurskyddslagstiftning_nn_1_N = mkN "djurskyddslagstiftning" ;
  djurutstaellning_nn_1_1_N = mkN "djurutställning" ;
  dna_sekvensering_nn_1_N = mkN "dna-sekvensering" ;
  dna_straeng_nn_1_1_N = mkN "dna-sträng" ;
  dna_testning_nn_1_N = mkN "dna-testning" ;
  dna_uppsaettning_nn_1_1_N = mkN "dna-uppsättning" ;
  docering_nn_2_N = mkN "docering" ;
  doftmarkering_nn_1_N = mkN "doftmarkering" ;
  dogmatisering_nn_1_N = mkN "dogmatisering" ;
  doktorering_nn_1_N = mkN "doktorering" ;
  doktorsavhandling_nn_1_N = mkN "doktorsavhandling" ;
  doktorshatt_nn_1_N = mkN "doktorshatt" ;
  doktorsring_nn_1_N = mkN "doktorsring" ;
  dokumentering_nn_1_N = mkN "dokumentering" ;
  dokumentsamling_nn_1_N = mkN "dokumentsamling" ;
  dolkstoet_nn_1_1_N = mkN "dolkstöt" ;
  domarring_nn_1_N = mkN "domarring" ;
  domdering_nn_1_N = mkN "domdering" ;
  domedagspredikning_nn_1_N = mkN "domedagspredikning" ;
  domedagsstaemning_nn_1_1_N = mkN "domedagsstämning" ;
  domesticering_nn_1_N = mkN "domesticering" ;
  domiciliering_nn_1_N = mkN "domiciliering" ;
  dominering_nn_1_N = mkN "dominering" ;
  dominikanermunk_nn_1_N = mkN "dominikanermunk" ;
  dominikanmunk_nn_1_N = mkN "dominikanmunk" ;
  domkyrkofoersamling_nn_1_1_N = mkN "domkyrkoförsamling" ;
  domning_nn_1_N = mkN "domning" ;
  domptering_nn_1_N = mkN "domptering" ;
  domstolsfoerhandling_nn_1_1_N = mkN "domstolsförhandling" ;
  donationsjord_nn_1_N = mkN "donationsjord" ;
  donering_nn_1_N = mkN "donering" ;
  dopning_nn_1_N = mkN "dopning" ;
  doppning_nn_1_N = mkN "doppning" ;
  dosering_nn_1_N = mkN "dosering" ;
  dossering_nn_1_N = mkN "dossering" ;
  dotering_nn_1_N = mkN "dotering" ;
  dotterfoersamling_nn_1_1_N = mkN "dotterförsamling" ;
  drabbning_nn_1_N = mkN "drabbning" ;
  dragering_nn_1_N = mkN "dragering" ;
  draggning_nn_1_N = mkN "draggning" ;
  dragkrok_nn_1_N = mkN "dragkrok" ;
  draglapp_nn_1_N = mkN "draglapp" ;
  dragning_nn_1_N = mkN "dragning" ;
  dragpressning_nn_1_N = mkN "dragpressning" ;
  dragupprepning_nn_1_N = mkN "dragupprepning" ;
  dragvaeg_nn_1_1_N = mkN "dragväg" ;
  dramatisering_nn_1_N = mkN "dramatisering" ;
  drapering_nn_1_N = mkN "drapering" ;
  dressering_nn_1_N = mkN "dressering" ;
  dressyrridning_nn_1_N = mkN "dressyrridning" ;
  dribbling_nn_1_N = mkN "dribbling" ;
  drickning_nn_1_N = mkN "drickning" ;
  drivning_nn_1_N = mkN "drivning" ;
  droppkork_nn_1_N = mkN "droppkork" ;
  droskbil_nn_1_N = mkN "droskbil" ;
  drullefoersaekring_nn_1_1_N = mkN "drulleförsäkring" ;
  drunkning_nn_1_N = mkN "drunkning" ;
  dryftning_nn_1_N = mkN "dryftning" ;
  drypning_nn_1_N = mkN "drypning" ;
  draenering_nn_1_1_N = mkN "dränering" ;
  droemtydning_nn_1_1_N = mkN "drömtydning" ;
  droemvaerld_nn_1_1_N = mkN "drömvärld" ;
  dubbelbindning_nn_1_N = mkN "dubbelbindning" ;
  dubbelbluff_nn_1_N = mkN "dubbelbluff" ;
  dubbelbrytning_nn_1_N = mkN "dubbelbrytning" ;
  dubbeldoerr_nn_1_1_N = mkN "dubbeldörr" ;
  dubbelexponering_nn_1_N = mkN "dubbelexponering" ;
  dubbelmening_nn_1_N = mkN "dubbelmening" ;
  dubbelsaekring_nn_1_1_N = mkN "dubbelsäkring" ;
  dubbeltraeff_nn_1_1_N = mkN "dubbelträff" ;
  dubbeloern_nn_1_1_N = mkN "dubbelörn" ;
  dubblering_nn_1_N = mkN "dubblering" ;
  dubbning_nn_1_N = mkN "dubbning" ;
  duellering_nn_1_N = mkN "duellering" ;
  dukagaang_nn_1_1_N = mkN "dukagång" ;
  dukning_nn_1_N = mkN "dukning" ;
  dumpning_nn_1_N = mkN "dumpning" ;
  dunboll_nn_1_N = mkN "dunboll" ;
  dundergud_nn_1_N = mkN "dundergud" ;
  dunkning_nn_1_N = mkN "dunkning" ;
  dupering_nn_1_N = mkN "dupering" ;
  duplicering_nn_1_N = mkN "duplicering" ;
  duschslang_nn_1_N = mkN "duschslang" ;
  duschvaegg_nn_1_1_N = mkN "duschvägg" ;
  duvning_nn_1_N = mkN "duvning" ;
  dygnsring_nn_1_N = mkN "dygnsring" ;
  dykarutrustning_nn_1_N = mkN "dykarutrustning" ;
  dykning_nn_1_N = mkN "dykning" ;
  dynggrep_nn_1_N = mkN "dynggrep" ;
  dyning_nn_1_N = mkN "dyning" ;
  dypoel_nn_1_1_N = mkN "dypöl" ;
  dyrortsgruppering_nn_1_N = mkN "dyrortsgruppering" ;
  dyvik_2_nn_1_N = mkN "dyvik" ;
  daeckmaerkning_nn_1_1_N = mkN "däckmärkning" ;
  daemning_nn_1_1_N = mkN "dämning" ;
  daempning_nn_1_1_N = mkN "dämpning" ;
  daaning_nn_1_1_N = mkN "dåning" ;
  doed_nn_1_1_N = mkN "död" ;
  doedsdom_nn_1_1_N = mkN "dödsdom" ;
  doedsflygning_nn_1_1_N = mkN "dödsflygning" ;
  doedsryckning_nn_1_1_N = mkN "dödsryckning" ;
  doedsskjutning_nn_1_1_N = mkN "dödsskjutning" ;
  doerroeppning_nn_1_1_N = mkN "dörröppning" ;
  doevning_nn_1_1_N = mkN "dövning" ;
  e_tidning_nn_1_N = mkN "e-tidning" ;
  edering_nn_1_N = mkN "edering" ;
  edgaang_nn_1_1_N = mkN "edgång" ;
  effacering_nn_1_N = mkN "effacering" ;
  effektivering_nn_1_N = mkN "effektivering" ;
  effektivisering_nn_1_N = mkN "effektivisering" ;
  effektuering_nn_1_N = mkN "effektuering" ;
  effektoekning_nn_1_1_N = mkN "effektökning" ;
  efterapning_nn_1_N = mkN "efterapning" ;
  efterbesiktning_nn_1_N = mkN "efterbesiktning" ;
  efterbeskattning_nn_1_N = mkN "efterbeskattning" ;
  efterbestaellning_nn_1_1_N = mkN "efterbeställning" ;
  efterbevakning_nn_1_N = mkN "efterbevakning" ;
  efterbildning_nn_1_N = mkN "efterbildning" ;
  efterblomning_nn_1_N = mkN "efterblomning" ;
  efterblomstring_nn_1_N = mkN "efterblomstring" ;
  efterbloedning_nn_1_1_N = mkN "efterblödning" ;
  efterdatering_nn_1_N = mkN "efterdatering" ;
  efterdebitering_nn_1_N = mkN "efterdebitering" ;
  efterdyning_nn_1_N = mkN "efterdyning" ;
  efterforskning_nn_1_N = mkN "efterforskning" ;
  efterfraagning_nn_1_1_N = mkN "efterfrågning" ;
  eftergranskning_nn_1_N = mkN "eftergranskning" ;
  efterhaermning_nn_1_1_N = mkN "efterhärmning" ;
  efterjaesning_nn_1_1_N = mkN "efterjäsning" ;
  efterkokning_nn_1_N = mkN "efterkokning" ;
  efterkaenning_nn_1_1_N = mkN "efterkänning" ;
  efterlysning_nn_1_N = mkN "efterlysning" ;
  efterlaemning_nn_1_1_N = mkN "efterlämning" ;
  eftermiddag_nn_1_N = mkN "eftermiddag" ;
  eftermiddagsrusning_nn_1_N = mkN "eftermiddagsrusning" ;
  efterproevning_nn_1_1_N = mkN "efterprövning" ;
  efterrationalisering_nn_1_N = mkN "efterrationalisering" ;
  efterraekning_nn_1_1_N = mkN "efterräkning" ;
  efterskalv_nn_1_N = mkN "efterskalv" ;
  efterslaeckning_nn_1_1_N = mkN "eftersläckning" ;
  efterslaepning_nn_1_1_N = mkN "eftersläpning" ;
  efterspaning_nn_1_N = mkN "efterspaning" ;
  efterstavning_nn_1_N = mkN "efterstavning" ;
  eftersupning_nn_1_N = mkN "eftersupning" ;
  eftersynkronisering_nn_1_N = mkN "eftersynkronisering" ;
  eftersaegning_nn_1_1_N = mkN "eftersägning" ;
  eftersaendning_nn_1_1_N = mkN "eftersändning" ;
  eftersoekning_nn_1_1_N = mkN "eftersökning" ;
  eftertaxering_nn_1_N = mkN "eftertaxering" ;
  efterundersoekning_nn_1_1_N = mkN "efterundersökning" ;
  efterutbildning_nn_1_N = mkN "efterutbildning" ;
  efterverkning_nn_1_N = mkN "efterverkning" ;
  egalisering_nn_1_N = mkN "egalisering" ;
  egendom_nn_1_N = mkN "egendom" ;
  egendomsfoersaekring_nn_1_1_N = mkN "egendomsförsäkring" ;
  egendomsfoersaeljning_nn_1_1_N = mkN "egendomsförsäljning" ;
  egenkaerlek_nn_1_1_N = mkN "egenkärlek" ;
  egensvaengning_nn_1_1_N = mkN "egensvängning" ;
  egoboostning_nn_1_N = mkN "egoboostning" ;
  ejakulering_nn_1_N = mkN "ejakulering" ;
  ekdoerr_nn_1_1_N = mkN "ekdörr" ;
  ekipering_nn_1_N = mkN "ekipering" ;
  eklatering_nn_1_N = mkN "eklatering" ;
  eklaerering_nn_1_1_N = mkN "eklärering" ;
  ekonomiavdelning_nn_1_N = mkN "ekonomiavdelning" ;
  ekonomifoerpackning_nn_1_1_N = mkN "ekonomiförpackning" ;
  ekonomisering_nn_1_N = mkN "ekonomisering" ;
  ekonomiutbildning_nn_1_N = mkN "ekonomiutbildning" ;
  ekonomutbildning_nn_1_N = mkN "ekonomutbildning" ;
  ekskog_nn_1_N = mkN "ekskog" ;
  ekstock_nn_1_N = mkN "ekstock" ;
  elaborering_nn_1_N = mkN "elaborering" ;
  elastisering_nn_1_N = mkN "elastisering" ;
  elavlaesning_nn_1_1_N = mkN "elavläsning" ;
  elbil_nn_1_N = mkN "elbil" ;
  eldgivning_nn_1_N = mkN "eldgivning" ;
  eldledning_nn_1_N = mkN "eldledning" ;
  eldning_nn_1_N = mkN "eldning" ;
  eldsignalering_nn_1_N = mkN "eldsignalering" ;
  eldslaeckning_nn_1_1_N = mkN "eldsläckning" ;
  eldstaellning_nn_1_1_N = mkN "eldställning" ;
  elektrificering_nn_1_N = mkN "elektrificering" ;
  elektrifiering_nn_1_N = mkN "elektrifiering" ;
  elektrisering_nn_1_N = mkN "elektrisering" ;
  elektronparbindning_nn_1_N = mkN "elektronparbindning" ;
  elementarladdning_nn_1_N = mkN "elementarladdning" ;
  elfenbensbit_nn_1_N = mkN "elfenbensbit" ;
  elfoerbrukning_nn_1_1_N = mkN "elförbrukning" ;
  elfoersoerjning_nn_1_1_N = mkN "elförsörjning" ;
  elhybridbil_nn_1_N = mkN "elhybridbil" ;
  elidering_nn_1_N = mkN "elidering" ;
  eliminering_nn_1_N = mkN "eliminering" ;
  elkedjesaag_nn_1_1_N = mkN "elkedjesåg" ;
  elkoppling_nn_1_N = mkN "elkoppling" ;
  elledning_nn_1_N = mkN "elledning" ;
  eloxering_nn_1_N = mkN "eloxering" ;
  eludering_nn_1_N = mkN "eludering" ;
  eluering_nn_1_N = mkN "eluering" ;
  elvaaaring_nn_1_1_N = mkN "elvaåring" ;
  elaendesskildring_nn_1_1_N = mkN "eländesskildring" ;
  emaljering_nn_1_N = mkN "emaljering" ;
  emaljfyllning_nn_1_N = mkN "emaljfyllning" ;
  emaljinlaeggning_nn_1_1_N = mkN "emaljinläggning" ;
  emaljmaalning_nn_1_1_N = mkN "emaljmålning" ;
  emancipering_nn_1_N = mkN "emancipering" ;
  emanering_nn_1_N = mkN "emanering" ;
  emballering_nn_1_N = mkN "emballering" ;
  embarkering_nn_1_N = mkN "embarkering" ;
  embellering_nn_1_N = mkN "embellering" ;
  emendering_nn_1_N = mkN "emendering" ;
  emigrering_nn_1_N = mkN "emigrering" ;
  emittering_nn_1_N = mkN "emittering" ;
  empirestil_nn_1_N = mkN "empirestil" ;
  emulgering_nn_1_N = mkN "emulgering" ;
  endossering_nn_1_N = mkN "endossering" ;
  energieffektivisering_nn_1_N = mkN "energieffektivisering" ;
  energifoersoerjning_nn_1_1_N = mkN "energiförsörjning" ;
  energiomstaellning_nn_1_1_N = mkN "energiomställning" ;
  energiomsaettning_nn_1_1_N = mkN "energiomsättning" ;
  energiomvandling_nn_1_N = mkN "energiomvandling" ;
  energiskog_nn_1_N = mkN "energiskog" ;
  energiutstraalning_nn_1_1_N = mkN "energiutstrålning" ;
  energiutveckling_nn_1_N = mkN "energiutveckling" ;
  enervering_nn_1_N = mkN "enervering" ;
  enfoting_nn_1_N = mkN "enfoting" ;
  engagering_nn_1_N = mkN "engagering" ;
  engaangstallrik_nn_1_1_N = mkN "engångstallrik" ;
  enhetsladdning_nn_1_N = mkN "enhetsladdning" ;
  enhjuling_nn_1_N = mkN "enhjuling" ;
  enhoerning_nn_1_1_N = mkN "enhörning" ;
  enkelknaeppning_nn_1_1_N = mkN "enkelknäppning" ;
  enkaetundersoekning_nn_1_1_N = mkN "enkätundersökning" ;
  enlevering_nn_1_N = mkN "enlevering" ;
  enmansfoerestaellning_nn_1_1_N = mkN "enmansföreställning" ;
  enmansgrav_nn_1_N = mkN "enmansgrav" ;
  enrollering_nn_1_N = mkN "enrollering" ;
  ensamflygning_nn_1_N = mkN "ensamflygning" ;
  ensamgaard_nn_1_1_N = mkN "ensamgård" ;
  ensamvarg_nn_1_N = mkN "ensamvarg" ;
  ensilering_nn_1_N = mkN "ensilering" ;
  enstensmur_nn_1_N = mkN "enstensmur" ;
  entr_edoerr_nn_1_1_N = mkN "entrédörr" ;
  entusiasmering_nn_1_N = mkN "entusiasmering" ;
  epilering_nn_1_N = mkN "epilering" ;
  erfarenhetsvaerld_nn_1_1_N = mkN "erfarenhetsvärld" ;
  erigering_nn_1_N = mkN "erigering" ;
  erinring_nn_1_N = mkN "erinring" ;
  erodering_nn_1_N = mkN "erodering" ;
  ersaettning_nn_1_1_N = mkN "ersättning" ;
  ertappning_nn_1_N = mkN "ertappning" ;
  eroevring_nn_1_1_N = mkN "erövring" ;
  eskalering_nn_1_N = mkN "eskalering" ;
  eskortering_nn_1_N = mkN "eskortering" ;
  essaysamling_nn_1_N = mkN "essaysamling" ;
  essaesamling_nn_1_1_N = mkN "essäsamling" ;
  esteticering_nn_1_N = mkN "esteticering" ;
  estetisering_nn_1_N = mkN "estetisering" ;
  estimering_nn_1_N = mkN "estimering" ;
  etablering_nn_1_N = mkN "etablering" ;
  etagevaaning_nn_1_1_N = mkN "etagevåning" ;
  etanolbil_nn_1_N = mkN "etanolbil" ;
  eterisering_nn_1_N = mkN "eterisering" ;
  etikettering_nn_1_N = mkN "etikettering" ;
  etiolering_nn_1_N = mkN "etiolering" ;
  etsning_nn_1_N = mkN "etsning" ;
  ettaaring_nn_1_1_N = mkN "ettåring" ;
  ettoering_nn_1_1_N = mkN "ettöring" ;
  etymologisering_nn_1_N = mkN "etymologisering" ;
  europavaeg_nn_1_1_N = mkN "europaväg" ;
  europeisering_nn_1_N = mkN "europeisering" ;
  evakuering_nn_1_N = mkN "evakuering" ;
  evaluering_nn_1_N = mkN "evaluering" ;
  evalvering_nn_1_N = mkN "evalvering" ;
  evangelisering_nn_1_N = mkN "evangelisering" ;
  evaporering_nn_1_N = mkN "evaporering" ;
  evolutionsforskning_nn_1_N = mkN "evolutionsforskning" ;
  examinering_nn_1_N = mkN "examinering" ;
  excellering_nn_1_N = mkN "excellering" ;
  excerpering_nn_1_N = mkN "excerpering" ;
  excitering_nn_1_N = mkN "excitering" ;
  exekvering_nn_1_N = mkN "exekvering" ;
  exempelsamling_nn_1_N = mkN "exempelsamling" ;
  exemplifiering_nn_1_N = mkN "exemplifiering" ;
  exercering_nn_1_N = mkN "exercering" ;
  exkludering_nn_1_N = mkN "exkludering" ;
  exkommunicering_nn_1_N = mkN "exkommunicering" ;
  exkung_nn_1_N = mkN "exkung" ;
  expandering_nn_1_N = mkN "expandering" ;
  expatriering_nn_1_N = mkN "expatriering" ;
  expediering_nn_1_N = mkN "expediering" ;
  expeditionsregering_nn_1_N = mkN "expeditionsregering" ;
  expektorering_nn_1_N = mkN "expektorering" ;
  experimentering_nn_1_N = mkN "experimentering" ;
  explicering_nn_1_N = mkN "explicering" ;
  exploatering_nn_1_N = mkN "exploatering" ;
  explodering_nn_1_N = mkN "explodering" ;
  exponering_nn_1_N = mkN "exponering" ;
  exportering_nn_1_N = mkN "exportering" ;
  expropriering_nn_1_N = mkN "expropriering" ;
  exstirpering_nn_1_N = mkN "exstirpering" ;
  extemporering_nn_1_N = mkN "extemporering" ;
  exterioerbedoemning_nn_1_1_N = mkN "exteriörbedömning" ;
  extrahering_nn_1_N = mkN "extrahering" ;
  extrapolering_nn_1_N = mkN "extrapolering" ;
  extremskidaakning_nn_1_1_N = mkN "extremskidåkning" ;
  fabricering_nn_1_N = mkN "fabricering" ;
  fabriksport_nn_1_N = mkN "fabriksport" ;
  fabulering_nn_1_N = mkN "fabulering" ;
  facettering_nn_1_N = mkN "facettering" ;
  fackfoerening_nn_1_1_N = mkN "fackförening" ;
  fackklubb_nn_1_N = mkN "fackklubb" ;
  faktagranskning_nn_1_N = mkN "faktagranskning" ;
  fakturering_nn_1_N = mkN "fakturering" ;
  fallbeskrivning_nn_1_N = mkN "fallbeskrivning" ;
  fallering_nn_1_N = mkN "fallering" ;
  fallskaerm_nn_1_1_N = mkN "fallskärm" ;
  fallvind_nn_1_N = mkN "fallvind" ;
  falsifiering_nn_1_N = mkN "falsifiering" ;
  falskskyltning_nn_1_N = mkN "falskskyltning" ;
  falukorv_nn_1_N = mkN "falukorv" ;
  familjegrav_nn_1_N = mkN "familjegrav" ;
  familjemiddag_nn_1_N = mkN "familjemiddag" ;
  familjepenning_nn_1_N = mkN "familjepenning" ;
  familjeplanering_nn_1_N = mkN "familjeplanering" ;
  familjeraadgivning_nn_1_1_N = mkN "familjerådgivning" ;
  familjeunderhaallning_nn_1_1_N = mkN "familjeunderhållning" ;
  fantasivaerld_nn_1_1_N = mkN "fantasivärld" ;
  fantisering_nn_1_N = mkN "fantisering" ;
  fardag_nn_1_N = mkN "fardag" ;
  fartminskning_nn_1_N = mkN "fartminskning" ;
  fartspaerr_nn_1_1_N = mkN "fartspärr" ;
  fartygsbesaettning_nn_1_1_N = mkN "fartygsbesättning" ;
  fartygsstormning_nn_1_N = mkN "fartygsstormning" ;
  fartygstjaenstgoering_nn_1_1_N = mkN "fartygstjänstgöring" ;
  fascinering_nn_1_N = mkN "fascinering" ;
  fasettering_nn_1_N = mkN "fasettering" ;
  fasfoerskjutning_nn_1_1_N = mkN "fasförskjutning" ;
  faskinkniv_nn_1_N = mkN "faskinkniv" ;
  fasonering_nn_1_N = mkN "fasonering" ;
  fasspaenning_nn_1_1_N = mkN "fasspänning" ;
  fastbindning_nn_1_N = mkN "fastbindning" ;
  fasthaallning_nn_1_1_N = mkN "fasthållning" ;
  fastighetsfoersaeljning_nn_1_1_N = mkN "fastighetsförsäljning" ;
  fastighetstaxering_nn_1_N = mkN "fastighetstaxering" ;
  fastlaenning_nn_1_1_N = mkN "fastlänning" ;
  fastsaettning_nn_1_1_N = mkN "fastsättning" ;
  fasttagning_nn_1_N = mkN "fasttagning" ;
  fattigdom_nn_1_N = mkN "fattigdom" ;
  fattigdomsminskning_nn_1_N = mkN "fattigdomsminskning" ;
  fattning_nn_1_N = mkN "fattning" ;
  favorisering_nn_1_N = mkN "favorisering" ;
  febersjukdom_nn_1_N = mkN "febersjukdom" ;
  fejning_nn_1_N = mkN "fejning" ;
  felbedoemning_nn_1_1_N = mkN "felbedömning" ;
  felbehandling_nn_1_N = mkN "felbehandling" ;
  felberaekning_nn_1_1_N = mkN "felberäkning" ;
  felhandling_nn_1_N = mkN "felhandling" ;
  felinvestering_nn_1_N = mkN "felinvestering" ;
  fellaesning_nn_1_1_N = mkN "felläsning" ;
  felnavigering_nn_1_N = mkN "felnavigering" ;
  felparkering_nn_1_N = mkN "felparkering" ;
  felraekning_nn_1_1_N = mkN "felräkning" ;
  felsatsning_nn_1_N = mkN "felsatsning" ;
  felskrivning_nn_1_N = mkN "felskrivning" ;
  felsaegning_nn_1_1_N = mkN "felsägning" ;
  feltolkning_nn_1_N = mkN "feltolkning" ;
  felutveckling_nn_1_N = mkN "felutveckling" ;
  femdelning_nn_1_N = mkN "femdelning" ;
  femtiooering_nn_1_1_N = mkN "femtioöring" ;
  femtioering_nn_1_1_N = mkN "femtiöring" ;
  femtonaaring_nn_1_1_N = mkN "femtonåring" ;
  femaaring_nn_1_1_N = mkN "femåring" ;
  femoering_nn_1_1_N = mkN "femöring" ;
  fermentering_nn_1_N = mkN "fermentering" ;
  ferrolegering_nn_1_N = mkN "ferrolegering" ;
  festdag_nn_1_N = mkN "festdag" ;
  festivalluff_nn_1_N = mkN "festivalluff" ;
  festklaenning_nn_1_1_N = mkN "festklänning" ;
  festmiddag_nn_1_N = mkN "festmiddag" ;
  festsal_nn_1_N = mkN "festsal" ;
  feststaemning_nn_1_1_N = mkN "feststämning" ;
  festvaaning_nn_1_1_N = mkN "festvåning" ;
  fetering_nn_1_N = mkN "fetering" ;
  fettfoerbraenning_nn_1_1_N = mkN "fettförbränning" ;
  fetthaerdning_nn_1_1_N = mkN "fetthärdning" ;
  fettklump_nn_1_N = mkN "fettklump" ;
  fiberblandning_nn_1_N = mkN "fiberblandning" ;
  fickkniv_nn_1_N = mkN "fickkniv" ;
  fickparkering_nn_1_N = mkN "fickparkering" ;
  figurering_nn_1_N = mkN "figurering" ;
  figurteckning_nn_1_N = mkN "figurteckning" ;
  figuraakning_nn_1_1_N = mkN "figuråkning" ;
  fildelning_nn_1_N = mkN "fildelning" ;
  filering_nn_1_N = mkN "filering" ;
  filibustring_nn_1_N = mkN "filibustring" ;
  filkoerning_nn_1_1_N = mkN "filkörning" ;
  filmatisering_nn_1_N = mkN "filmatisering" ;
  filmframkallning_nn_1_N = mkN "filmframkallning" ;
  filmgranskning_nn_1_N = mkN "filmgranskning" ;
  filminspelning_nn_1_N = mkN "filminspelning" ;
  filmklippning_nn_1_N = mkN "filmklippning" ;
  filmning_nn_1_N = mkN "filmning" ;
  filmsnutt_nn_1_N = mkN "filmsnutt" ;
  filmvisning_nn_1_N = mkN "filmvisning" ;
  filning_nn_1_N = mkN "filning" ;
  filosofering_nn_1_N = mkN "filosofering" ;
  filthatt_nn_1_N = mkN "filthatt" ;
  filtrering_nn_1_N = mkN "filtrering" ;
  fimpsug_nn_1_N = mkN "fimpsug" ;
  finansfoervaltning_nn_1_1_N = mkN "finansförvaltning" ;
  finanshaj_nn_1_N = mkN "finanshaj" ;
  finansiering_nn_1_N = mkN "finansiering" ;
  fingering_nn_1_N = mkN "fingering" ;
  fingerknaeppning_nn_1_1_N = mkN "fingerknäppning" ;
  fingerring_nn_1_N = mkN "fingerring" ;
  fingersaettning_nn_1_1_N = mkN "fingersättning" ;
  fingervisning_nn_1_N = mkN "fingervisning" ;
  finingaang_nn_1_1_N = mkN "finingång" ;
  finjustering_nn_1_N = mkN "finjustering" ;
  finkamning_nn_1_N = mkN "finkamning" ;
  finlandisering_nn_1_N = mkN "finlandisering" ;
  finlek_nn_1_N = mkN "finlek" ;
  fintvaett_nn_1_1_N = mkN "fintvätt" ;
  fiolstraeng_nn_1_1_N = mkN "fiolsträng" ;
  firmateckning_nn_1_N = mkN "firmateckning" ;
  firning_nn_1_N = mkN "firning" ;
  fiskdamm_nn_1_N = mkN "fiskdamm" ;
  fiskebaat_nn_1_1_N = mkN "fiskebåt" ;
  fiskebaatsbesaettning_nn_1_1_N = mkN "fiskebåtsbesättning" ;
  fiskekrok_nn_1_N = mkN "fiskekrok" ;
  fiskelag_nn_1_N = mkN "fiskelag" ;
  fiskkrok_nn_1_N = mkN "fiskkrok" ;
  fiskodling_nn_1_N = mkN "fiskodling" ;
  fiskstjaert_nn_1_1_N = mkN "fiskstjärt" ;
  fiskvandring_nn_1_N = mkN "fiskvandring" ;
  fixering_nn_1_N = mkN "fixering" ;
  fjortonaaring_nn_1_1_N = mkN "fjortonåring" ;
  fjaederboll_nn_1_1_N = mkN "fjäderboll" ;
  fjaedervaag_nn_1_1_N = mkN "fjädervåg" ;
  fjaedring_nn_1_1_N = mkN "fjädring" ;
  fjaellning_nn_1_1_N = mkN "fjällning" ;
  fjaellsluttning_nn_1_1_N = mkN "fjällsluttning" ;
  fjaelltopp_nn_1_1_N = mkN "fjälltopp" ;
  fjaellvandring_nn_1_1_N = mkN "fjällvandring" ;
  fjaerding_nn_1_1_N = mkN "fjärding" ;
  fjaerrblockering_nn_1_1_N = mkN "fjärrblockering" ;
  fjaerrvaermegranskning_nn_1_1_N = mkN "fjärrvärmegranskning" ;
  flaggbraenning_nn_1_1_N = mkN "flaggbränning" ;
  flaggdag_nn_1_N = mkN "flaggdag" ;
  flaggning_nn_1_N = mkN "flaggning" ;
  flaggskaendning_nn_1_1_N = mkN "flaggskändning" ;
  flaggviftning_nn_1_N = mkN "flaggviftning" ;
  flakvagn_nn_1_N = mkN "flakvagn" ;
  flambering_nn_1_N = mkN "flambering" ;
  flanering_nn_1_N = mkN "flanering" ;
  flankering_nn_1_N = mkN "flankering" ;
  flaskkastning_nn_1_N = mkN "flaskkastning" ;
  flaskoeppning_nn_1_1_N = mkN "flasköppning" ;
  flattering_nn_1_N = mkN "flattering" ;
  flaxning_nn_1_N = mkN "flaxning" ;
  flektering_nn_1_N = mkN "flektering" ;
  flerording_nn_1_N = mkN "flerording" ;
  flexislang_nn_1_N = mkN "flexislang" ;
  flodbaat_nn_1_1_N = mkN "flodbåt" ;
  flodgud_nn_1_N = mkN "flodgud" ;
  flodmynning_nn_1_N = mkN "flodmynning" ;
  floppsatsning_nn_1_N = mkN "floppsatsning" ;
  florering_nn_1_N = mkN "florering" ;
  florettfaektning_nn_1_1_N = mkN "florettfäktning" ;
  flottflaeck_nn_1_1_N = mkN "flottfläck" ;
  flottning_nn_1_N = mkN "flottning" ;
  flottoevning_nn_1_1_N = mkN "flottövning" ;
  flugsvamp_nn_1_N = mkN "flugsvamp" ;
  fluidisering_nn_1_N = mkN "fluidisering" ;
  fluktuering_nn_1_N = mkN "fluktuering" ;
  fluorbehandling_nn_1_N = mkN "fluorbehandling" ;
  fluorering_nn_1_N = mkN "fluorering" ;
  fluorescering_nn_1_N = mkN "fluorescering" ;
  fluoridering_nn_1_N = mkN "fluoridering" ;
  flygavgaang_nn_1_1_N = mkN "flygavgång" ;
  flygkapning_nn_1_N = mkN "flygkapning" ;
  flygledning_nn_1_N = mkN "flygledning" ;
  flygning_nn_1_N = mkN "flygning" ;
  flygplansbesaettning_nn_1_1_N = mkN "flygplansbesättning" ;
  flygplatsservering_nn_1_N = mkN "flygplatsservering" ;
  flygstol_nn_1_N = mkN "flygstol" ;
  flygstoerning_nn_1_1_N = mkN "flygstörning" ;
  flygutbildning_nn_1_N = mkN "flygutbildning" ;
  flygvaeg_nn_1_1_N = mkN "flygväg" ;
  flyktingmottagning_nn_1_N = mkN "flyktingmottagning" ;
  flyktvaeg_nn_1_1_N = mkN "flyktväg" ;
  flytning_nn_1_N = mkN "flytning" ;
  flyttning_nn_1_N = mkN "flyttning" ;
  flytvaestlag_nn_1_1_N = mkN "flytvästlag" ;
  flaeckborttagning_nn_1_1_N = mkN "fläckborttagning" ;
  flaekning_nn_1_1_N = mkN "fläkning" ;
  flaektning_nn_1_1_N = mkN "fläktning" ;
  flaemtning_nn_1_1_N = mkN "flämtning" ;
  flaengning_nn_1_1_N = mkN "flängning" ;
  flaeskkorv_nn_1_1_N = mkN "fläskkorv" ;
  flaesklaegg_nn_1_1_N = mkN "fläsklägg" ;
  flaesklaepp_nn_1_1_N = mkN "fläskläpp" ;
  flaetning_nn_1_1_N = mkN "flätning" ;
  flaahackning_nn_1_1_N = mkN "flåhackning" ;
  flaasning_nn_1_1_N = mkN "flåsning" ;
  fnissning_nn_1_N = mkN "fnissning" ;
  fnysning_nn_1_N = mkN "fnysning" ;
  fobitraening_nn_1_1_N = mkN "fobiträning" ;
  fockning_nn_1_N = mkN "fockning" ;
  fogning_nn_1_N = mkN "fogning" ;
  fogstrykning_nn_1_N = mkN "fogstrykning" ;
  fokusering_nn_1_N = mkN "fokusering" ;
  foliehatt_nn_1_N = mkN "foliehatt" ;
  foliering_nn_1_N = mkN "foliering" ;
  folkbildning_nn_1_N = mkN "folkbildning" ;
  folkbokfoering_nn_1_1_N = mkN "folkbokföring" ;
  folkdiktning_nn_1_N = mkN "folkdiktning" ;
  folkdomstol_nn_1_N = mkN "folkdomstol" ;
  folkfoerdrivning_nn_1_1_N = mkN "folkfördrivning" ;
  folkfoersamling_nn_1_1_N = mkN "folkförsamling" ;
  folkhop_nn_1_N = mkN "folkhop" ;
  folklek_nn_1_N = mkN "folklek" ;
  folklivsforskning_nn_1_N = mkN "folklivsforskning" ;
  folklivsskildring_nn_1_N = mkN "folklivsskildring" ;
  folkminskning_nn_1_N = mkN "folkminskning" ;
  folkomflyttning_nn_1_N = mkN "folkomflyttning" ;
  folkomroestning_nn_1_1_N = mkN "folkomröstning" ;
  folkresning_nn_1_N = mkN "folkresning" ;
  folkraekning_nn_1_1_N = mkN "folkräkning" ;
  folksamling_nn_1_N = mkN "folksamling" ;
  folksjukdom_nn_1_N = mkN "folksjukdom" ;
  folkvandring_nn_1_N = mkN "folkvandring" ;
  folkoekning_nn_1_1_N = mkN "folkökning" ;
  fondering_nn_1_N = mkN "fondering" ;
  fondmaalning_nn_1_1_N = mkN "fondmålning" ;
  fontaenkraekning_nn_1_1_N = mkN "fontänkräkning" ;
  fontaenpump_nn_1_1_N = mkN "fontänpump" ;
  forcering_nn_1_N = mkN "forcering" ;
  fordonsuppstaellning_nn_1_1_N = mkN "fordonsuppställning" ;
  fordring_nn_1_N = mkN "fordring" ;
  formalisering_nn_1_N = mkN "formalisering" ;
  formbildning_nn_1_N = mkN "formbildning" ;
  formering_nn_1_N = mkN "formering" ;
  formfullaendning_nn_1_1_N = mkN "formfulländning" ;
  formgivning_nn_1_N = mkN "formgivning" ;
  formning_nn_1_N = mkN "formning" ;
  formpressning_nn_1_N = mkN "formpressning" ;
  formrikedom_nn_1_N = mkN "formrikedom" ;
  formulering_nn_1_N = mkN "formulering" ;
  fornlaemning_nn_1_1_N = mkN "fornlämning" ;
  fornminnesfoerening_nn_1_1_N = mkN "fornminnesförening" ;
  fornminneslag_nn_1_N = mkN "fornminneslag" ;
  fornminnessamling_nn_1_N = mkN "fornminnessamling" ;
  fornminnesskylt_nn_1_N = mkN "fornminnesskylt" ;
  forskarutbildning_nn_1_N = mkN "forskarutbildning" ;
  forskning_nn_1_N = mkN "forskning" ;
  forskningsfinansiering_nn_1_N = mkN "forskningsfinansiering" ;
  forskningsinriktning_nn_1_N = mkN "forskningsinriktning" ;
  forsraenning_nn_1_1_N = mkN "forsränning" ;
  fortbildning_nn_1_N = mkN "fortbildning" ;
  fortifikationsfoervaltning_nn_1_1_N = mkN "fortifikationsförvaltning" ;
  fortkoerning_nn_1_1_N = mkN "fortkörning" ;
  fortplantning_nn_1_N = mkN "fortplantning" ;
  fortskridning_nn_1_N = mkN "fortskridning" ;
  fortsaettning_nn_1_1_N = mkN "fortsättning" ;
  forumtidning_nn_1_N = mkN "forumtidning" ;
  fosfatering_nn_1_N = mkN "fosfatering" ;
  fosforescering_nn_1_N = mkN "fosforescering" ;
  fossilgasledning_nn_1_N = mkN "fossilgasledning" ;
  fossilisering_nn_1_N = mkN "fossilisering" ;
  fossilminskning_nn_1_N = mkN "fossilminskning" ;
  fossilsamling_nn_1_N = mkN "fossilsamling" ;
  fosterfoerdrivning_nn_1_1_N = mkN "fosterfördrivning" ;
  fosterutveckling_nn_1_N = mkN "fosterutveckling" ;
  fotbjudning_nn_1_N = mkN "fotbjudning" ;
  fotboll_nn_2_N = mkN "fotboll" ;
  fotogendunk_nn_1_N = mkN "fotogendunk" ;
  fotografering_nn_1_N = mkN "fotografering" ;
  fotokopiering_nn_1_N = mkN "fotokopiering" ;
  fotostatkopiering_nn_1_N = mkN "fotostatkopiering" ;
  fotosaettning_nn_1_1_N = mkN "fotosättning" ;
  fotpall_nn_1_N = mkN "fotpall" ;
  fotstaellning_nn_1_1_N = mkN "fotställning" ;
  fotvandring_nn_1_N = mkN "fotvandring" ;
  fraktionering_nn_1_N = mkN "fraktionering" ;
  frakturstil_nn_1_N = mkN "frakturstil" ;
  frambesvaerjning_nn_1_1_N = mkN "frambesvärjning" ;
  framflyttning_nn_1_N = mkN "framflyttning" ;
  framfoerhaallning_nn_1_1_N = mkN "framförhållning" ;
  framgaang_nn_1_1_N = mkN "framgång" ;
  framgaangsvind_nn_1_1_N = mkN "framgångsvind" ;
  framkallning_nn_1_N = mkN "framkallning" ;
  framkropp_nn_1_N = mkN "framkropp" ;
  framkoerning_nn_1_1_N = mkN "framkörning" ;
  framladdning_nn_1_N = mkN "framladdning" ;
  framlaeggning_nn_1_1_N = mkN "framläggning" ;
  frammaning_nn_1_N = mkN "frammaning" ;
  frammatning_nn_1_N = mkN "frammatning" ;
  frampressning_nn_1_N = mkN "frampressning" ;
  framryckning_nn_1_N = mkN "framryckning" ;
  framskjutning_nn_1_N = mkN "framskjutning" ;
  framspelning_nn_1_N = mkN "framspelning" ;
  framstaellning_nn_1_1_N = mkN "framställning" ;
  framsaegning_nn_1_1_N = mkN "framsägning" ;
  framtagning_nn_1_N = mkN "framtagning" ;
  framtidsforskning_nn_1_N = mkN "framtidsforskning" ;
  framtidssatsning_nn_1_N = mkN "framtidssatsning" ;
  framtoning_nn_1_N = mkN "framtoning" ;
  framvisning_nn_1_N = mkN "framvisning" ;
  franciskanermunk_nn_1_N = mkN "franciskanermunk" ;
  frankering_nn_1_N = mkN "frankering" ;
  frappering_nn_1_N = mkN "frappering" ;
  frasering_nn_1_N = mkN "frasering" ;
  fraternisering_nn_1_N = mkN "fraternisering" ;
  fredag_nn_1_N = mkN "fredag" ;
  fredagsmiddag_nn_1_N = mkN "fredagsmiddag" ;
  fredsdomstol_nn_1_N = mkN "fredsdomstol" ;
  fredsforskning_nn_1_N = mkN "fredsforskning" ;
  fredsfoerening_nn_1_1_N = mkN "fredsförening" ;
  fredsfoerhandling_nn_1_1_N = mkN "fredsförhandling" ;
  frekvensmodulering_nn_1_N = mkN "frekvensmodulering" ;
  frekventering_nn_1_N = mkN "frekventering" ;
  freskomaalning_nn_1_1_N = mkN "freskomålning" ;
  fribrottning_nn_1_N = mkN "fribrottning" ;
  fridag_nn_1_N = mkN "fridag" ;
  fridlysning_nn_1_N = mkN "fridlysning" ;
  fridskraenkning_nn_1_1_N = mkN "fridskränkning" ;
  frifoersamling_nn_1_1_N = mkN "friförsamling" ;
  frigivning_nn_1_N = mkN "frigivning" ;
  frihandsteckning_nn_1_N = mkN "frihandsteckning" ;
  frikoppling_nn_1_N = mkN "frikoppling" ;
  frikyrkofoersamling_nn_1_1_N = mkN "frikyrkoförsamling" ;
  frikoepning_nn_1_1_N = mkN "friköpning" ;
  friluftsskog_nn_1_N = mkN "friluftsskog" ;
  frimaerkssamling_nn_1_1_N = mkN "frimärkssamling" ;
  frisering_nn_1_N = mkN "frisering" ;
  friskrivning_nn_1_N = mkN "friskrivning" ;
  friskytt_nn_1_N = mkN "friskytt" ;
  frispark_nn_1_N = mkN "frispark" ;
  frisoerstol_nn_1_1_N = mkN "frisörstol" ;
  fritagning_nn_1_N = mkN "fritagning" ;
  fritering_nn_1_N = mkN "fritering" ;
  fritidsbaat_nn_1_1_N = mkN "fritidsbåt" ;
  fritidsfoervaltning_nn_1_1_N = mkN "fritidsförvaltning" ;
  fritidssysselsaettning_nn_1_1_N = mkN "fritidssysselsättning" ;
  frityrdeg_nn_1_N = mkN "frityrdeg" ;
  friaakning_nn_1_1_N = mkN "friåkning" ;
  frondering_nn_1_N = mkN "frondering" ;
  frontalkrock_nn_1_N = mkN "frontalkrock" ;
  frontallobsstoerning_nn_1_1_N = mkN "frontallobsstörning" ;
  frontbildning_nn_1_N = mkN "frontbildning" ;
  frontkommendering_nn_1_N = mkN "frontkommendering" ;
  fronttjaenstgoering_nn_1_1_N = mkN "fronttjänstgöring" ;
  frossbrytning_nn_1_N = mkN "frossbrytning" ;
  frostspraengning_nn_1_1_N = mkN "frostsprängning" ;
  frottering_nn_1_N = mkN "frottering" ;
  frott_erock_nn_1_1_N = mkN "frottérock" ;
  frukostering_nn_1_N = mkN "frukostering" ;
  fruktbarhetsgud_nn_1_N = mkN "fruktbarhetsgud" ;
  fruktkniv_nn_1_N = mkN "fruktkniv" ;
  fruktkorg_nn_1_N = mkN "fruktkorg" ;
  fruktodling_nn_1_N = mkN "fruktodling" ;
  fruktskaal_nn_1_1_N = mkN "fruktskål" ;
  fruktsaettning_nn_1_1_N = mkN "fruktsättning" ;
  frukttraedgaard_nn_1_1_N = mkN "fruktträdgård" ;
  frusning_nn_1_N = mkN "frusning" ;
  frustning_nn_1_N = mkN "frustning" ;
  frustrering_nn_1_N = mkN "frustrering" ;
  frysfoerpackning_nn_1_1_N = mkN "frysförpackning" ;
  frysning_nn_1_N = mkN "frysning" ;
  fraelsning_nn_1_1_N = mkN "frälsning" ;
  fraemling_nn_1_1_N = mkN "främling" ;
  fraesning_nn_1_1_N = mkN "fräsning" ;
  fraetning_nn_1_1_N = mkN "frätning" ;
  fraagestaellning_nn_1_1_N = mkN "frågeställning" ;
  fraagetaevling_nn_1_1_N = mkN "frågetävling" ;
  fraanlandsvind_nn_1_1_N = mkN "frånlandsvind" ;
  fraanraekning_nn_1_1_N = mkN "frånräkning" ;
  fraanvarodag_nn_1_1_N = mkN "frånvarodag" ;
  froeodling_nn_1_1_N = mkN "fröodling" ;
  fuktflaeck_nn_1_1_N = mkN "fuktfläck" ;
  fuktning_nn_1_N = mkN "fuktning" ;
  fullkomning_nn_1_N = mkN "fullkomning" ;
  fullmaktslag_nn_1_N = mkN "fullmaktslag" ;
  fulltraeff_nn_1_1_N = mkN "fullträff" ;
  fullvaerdesfoersaekring_nn_1_1_N = mkN "fullvärdesförsäkring" ;
  fullaendning_nn_1_1_N = mkN "fulländning" ;
  fulvinkling_nn_1_N = mkN "fulvinkling" ;
  fundering_nn_1_N = mkN "fundering" ;
  funktionering_nn_1_N = mkN "funktionering" ;
  funktionsnedsaettning_nn_1_1_N = mkN "funktionsnedsättning" ;
  furnering_nn_1_N = mkN "furnering" ;
  fusionering_nn_1_N = mkN "fusionering" ;
  fuskflygning_nn_1_N = mkN "fuskflygning" ;
  fusklapp_nn_1_N = mkN "fusklapp" ;
  fyllhund_nn_1_N = mkN "fyllhund" ;
  fyllnadstjaenstgoering_nn_1_1_N = mkN "fyllnadstjänstgöring" ;
  fyllning_nn_1_N = mkN "fyllning" ;
  fyratimmarsflygning_nn_1_N = mkN "fyratimmarsflygning" ;
  fyraaaring_nn_1_1_N = mkN "fyraåring" ;
  fyrhandssaettning_nn_1_1_N = mkN "fyrhandssättning" ;
  fyrhjuling_nn_1_N = mkN "fyrhjuling" ;
  fyrhoerning_nn_1_1_N = mkN "fyrhörning" ;
  fyrsiding_nn_1_N = mkN "fyrsiding" ;
  fyrtioaaring_nn_1_1_N = mkN "fyrtioåring" ;
  fyrtiaaring_nn_1_1_N = mkN "fyrtiåring" ;
  fysikforskning_nn_1_N = mkN "fysikforskning" ;
  fysiljering_nn_1_N = mkN "fysiljering" ;
  faebodvall_nn_1_1_N = mkN "fäbodvall" ;
  faedernegaard_nn_1_1_N = mkN "fädernegård" ;
  faegring_nn_1_1_N = mkN "fägring" ;
  faehund_nn_1_1_N = mkN "fähund" ;
  faektning_nn_1_1_N = mkN "fäktning" ;
  faellkil_nn_1_1_N = mkN "fällkil" ;
  faellning_nn_1_1_N = mkN "fällning" ;
  faellstol_nn_1_1_N = mkN "fällstol" ;
  faeltbegravning_nn_1_1_N = mkN "fältbegravning" ;
  faeltmaetning_nn_1_1_N = mkN "fältmätning" ;
  faelttjaenstgoering_nn_1_1_N = mkN "fälttjänstgöring" ;
  faelttjaenstoevning_nn_1_1_N = mkN "fälttjänstövning" ;
  faengelsedom_nn_1_1_N = mkN "fängelsedom" ;
  faerdighetstraening_nn_1_1_N = mkN "färdighetsträning" ;
  faerdriktning_nn_1_1_N = mkN "färdriktning" ;
  faerdvaeg_nn_1_1_N = mkN "färdväg" ;
  faergblandning_nn_1_1_N = mkN "färgblandning" ;
  faergflaeck_nn_1_1_N = mkN "färgfläck" ;
  faergfoeraendring_nn_1_1_N = mkN "färgförändring" ;
  faerglaeggning_nn_1_1_N = mkN "färgläggning" ;
  faergning_nn_1_1_N = mkN "färgning" ;
  faergrivning_nn_1_1_N = mkN "färgrivning" ;
  faergsammansaettning_nn_1_1_N = mkN "färgsammansättning" ;
  faergskiftning_nn_1_1_N = mkN "färgskiftning" ;
  faergspridning_nn_1_1_N = mkN "färgspridning" ;
  faergsaettning_nn_1_1_N = mkN "färgsättning" ;
  faerjeavgaang_nn_1_1_N = mkN "färjeavgång" ;
  faersering_nn_1_1_N = mkN "färsering" ;
  faerskning_nn_1_1_N = mkN "färskning" ;
  faestanordning_nn_1_1_N = mkN "fästanordning" ;
  faestkrok_nn_1_1_N = mkN "fästkrok" ;
  faestning_nn_1_1_N = mkN "fästning" ;
  faestningsmur_nn_1_1_N = mkN "fästningsmur" ;
  faestningsvall_nn_1_1_N = mkN "fästningsvall" ;
  faestskruv_nn_1_1_N = mkN "fästskruv" ;
  faagelskaadning_nn_1_1_N = mkN "fågelskådning" ;
  faagelvurm_nn_1_1_N = mkN "fågelvurm" ;
  faallning_nn_1_1_N = mkN "fållning" ;
  faangeshandling_nn_1_1_N = mkN "fångeshandling" ;
  faangstanordning_nn_1_1_N = mkN "fångstanordning" ;
  faangstkrok_nn_1_1_N = mkN "fångstkrok" ;
  faangutvaexling_nn_1_1_N = mkN "fångutväxling" ;
  faantratt_nn_1_1_N = mkN "fåntratt" ;
  faarahjord_nn_1_1_N = mkN "fårahjord" ;
  foedelsedag_nn_1_1_N = mkN "födelsedag" ;
  foedelsedagsmiddag_nn_1_1_N = mkN "födelsedagsmiddag" ;
  foedkrok_nn_1_1_N = mkN "födkrok" ;
  foedslovaerk_nn_1_1_N = mkN "födslovärk" ;
  foegderifoervaltning_nn_1_1_N = mkN "fögderiförvaltning" ;
  foeljdsjukdom_nn_1_1_N = mkN "följdsjukdom" ;
  foeljdverkning_nn_1_1_N = mkN "följdverkning" ;
  foeljebil_nn_1_1_N = mkN "följebil" ;
  foelning_nn_1_1_N = mkN "fölning" ;
  foensterputsduk_nn_1_1_N = mkN "fönsterputsduk" ;
  foensteroeppning_nn_1_1_N = mkN "fönsteröppning" ;
  foeraning_nn_1_1_N = mkN "föraning" ;
  foerankring_nn_1_1_N = mkN "förankring" ;
  foeranledning_nn_1_1_N = mkN "föranledning" ;
  foeranmaelning_nn_1_1_N = mkN "föranmälning" ;
  foerannonsering_nn_1_1_N = mkN "förannonsering" ;
  foeranstaltning_nn_1_1_N = mkN "föranstaltning" ;
  foerbehandling_nn_1_1_N = mkN "förbehandling" ;
  foerbindelsegrav_nn_1_1_N = mkN "förbindelsegrav" ;
  foerbindelsegaang_nn_1_1_N = mkN "förbindelsegång" ;
  foerbindelselaenk_nn_1_1_N = mkN "förbindelselänk" ;
  foerbindning_nn_1_1_N = mkN "förbindning" ;
  foerbistring_nn_1_1_N = mkN "förbistring" ;
  foerbittring_nn_1_1_N = mkN "förbittring" ;
  foerblandning_nn_1_1_N = mkN "förblandning" ;
  foerbloedning_nn_1_1_N = mkN "förblödning" ;
  foerbrukning_nn_1_1_N = mkN "förbrukning" ;
  foerbraenning_nn_1_1_N = mkN "förbränning" ;
  foerbroedring_nn_1_1_N = mkN "förbrödring" ;
  foerbundsregering_nn_1_1_N = mkN "förbundsregering" ;
  foerbytning_nn_1_1_N = mkN "förbytning" ;
  foerbaettring_nn_1_1_N = mkN "förbättring" ;
  foerdelning_nn_1_1_N = mkN "fördelning" ;
  foerdjupning_nn_1_1_N = mkN "fördjupning" ;
  foerdom_nn_1_1_N = mkN "fördom" ;
  foerdrivning_nn_1_1_N = mkN "fördrivning" ;
  foerdroejning_nn_1_1_N = mkN "fördröjning" ;
  foerdubbling_nn_1_1_N = mkN "fördubbling" ;
  foerdyring_nn_1_1_N = mkN "fördyring" ;
  foerdaemning_nn_1_1_N = mkN "fördämning" ;
  foeredragning_nn_1_1_N = mkN "föredragning" ;
  foerelaesning_nn_1_1_N = mkN "föreläsning" ;
  foerelaesningssal_nn_1_1_N = mkN "föreläsningssal" ;
  foerening_nn_1_1_N = mkN "förening" ;
  foereningslaenk_nn_1_1_N = mkN "föreningslänk" ;
  foerenkling_nn_1_1_N = mkN "förenkling" ;
  foerespegling_nn_1_1_N = mkN "förespegling" ;
  foerestavning_nn_1_1_N = mkN "förestavning" ;
  foerestaellning_nn_1_1_N = mkN "föreställning" ;
  foeretagsledning_nn_1_1_N = mkN "företagsledning" ;
  foerevisning_nn_1_1_N = mkN "förevisning" ;
  foerevaendning_nn_1_1_N = mkN "förevändning" ;
  foerfallodag_nn_1_1_N = mkN "förfallodag" ;
  foerfalskning_nn_1_1_N = mkN "förfalskning" ;
  foerfattargaerning_nn_1_1_N = mkN "författargärning" ;
  foerfattarskildring_nn_1_1_N = mkN "författarskildring" ;
  foerfattning_nn_1_1_N = mkN "författning" ;
  foerfattningsdomstol_nn_1_1_N = mkN "författningsdomstol" ;
  foerfining_nn_1_1_N = mkN "förfining" ;
  foerflackning_nn_1_1_N = mkN "förflackning" ;
  foerflyttning_nn_1_1_N = mkN "förflyttning" ;
  foerfogandelag_nn_1_1_N = mkN "förfogandelag" ;
  foerfriskning_nn_1_1_N = mkN "förfriskning" ;
  foerfrysning_nn_1_1_N = mkN "förfrysning" ;
  foerfraagning_nn_1_1_N = mkN "förfrågning" ;
  foerfuskning_nn_1_1_N = mkN "förfuskning" ;
  foergasning_nn_1_1_N = mkN "förgasning" ;
  foergiftning_nn_1_1_N = mkN "förgiftning" ;
  foergrening_nn_1_1_N = mkN "förgrening" ;
  foergroning_nn_1_1_N = mkN "förgroning" ;
  foergubbning_nn_1_1_N = mkN "förgubbning" ;
  foergudning_nn_1_1_N = mkN "förgudning" ;
  foergyllning_nn_1_1_N = mkN "förgyllning" ;
  foergoerning_nn_1_1_N = mkN "förgörning" ;
  foerhalning_nn_1_1_N = mkN "förhalning" ;
  foerhandling_nn_1_1_N = mkN "förhandling" ;
  foerhandsbestaellning_nn_1_1_N = mkN "förhandsbeställning" ;
  foerhoppning_nn_1_1_N = mkN "förhoppning" ;
  foerhuggning_nn_1_1_N = mkN "förhuggning" ;
  foerhydning_nn_1_1_N = mkN "förhydning" ;
  foerhyrning_nn_1_1_N = mkN "förhyrning" ;
  foerhaerdning_nn_1_1_N = mkN "förhärdning" ;
  foerhaerjning_nn_1_1_N = mkN "förhärjning" ;
  foerhaexning_nn_1_1_N = mkN "förhäxning" ;
  foerhaallning_nn_1_1_N = mkN "förhållning" ;
  foerhaaning_nn_1_1_N = mkN "förhåning" ;
  foerhoejning_nn_1_1_N = mkN "förhöjning" ;
  foerkalkning_nn_1_1_N = mkN "förkalkning" ;
  foerkastelsedom_nn_1_1_N = mkN "förkastelsedom" ;
  foerkastning_nn_1_1_N = mkN "förkastning" ;
  foerklaring_nn_1_1_N = mkN "förklaring" ;
  foerklistring_nn_1_1_N = mkN "förklistring" ;
  foerklistring_2_nn_1_1_N = mkN "förklistring" ;
  foerklyftning_nn_1_1_N = mkN "förklyftning" ;
  foerklaedeskjol_nn_1_1_N = mkN "förklädeskjol" ;
  foerknippning_nn_1_1_N = mkN "förknippning" ;
  foerkolning_nn_1_1_N = mkN "förkolning" ;
  foerkonstling_nn_1_1_N = mkN "förkonstling" ;
  foerkortning_nn_1_1_N = mkN "förkortning" ;
  foerkroppning_nn_1_1_N = mkN "förkroppning" ;
  foerkrossning_nn_1_1_N = mkN "förkrossning" ;
  foerkrympning_nn_1_1_N = mkN "förkrympning" ;
  foerkvaevning_nn_1_1_N = mkN "förkvävning" ;
  foerkylning_nn_1_1_N = mkN "förkylning" ;
  foerkaenning_nn_1_1_N = mkN "förkänning" ;
  foerkaerlek_nn_1_1_N = mkN "förkärlek" ;
  foerladdning_nn_1_1_N = mkN "förladdning" ;
  foerlamning_nn_1_1_N = mkN "förlamning" ;
  foerlikning_nn_1_1_N = mkN "förlikning" ;
  foerlisning_nn_1_1_N = mkN "förlisning" ;
  foerlossning_nn_1_1_N = mkN "förlossning" ;
  foerlovning_nn_1_1_N = mkN "förlovning" ;
  foerlovningsring_nn_1_1_N = mkN "förlovningsring" ;
  foerlaeggning_nn_1_1_N = mkN "förläggning" ;
  foerlaengning_nn_1_1_N = mkN "förlängning" ;
  foerlaengningssladd_nn_1_1_N = mkN "förlängningssladd" ;
  foerlaening_nn_1_1_N = mkN "förläning" ;
  foerloepning_nn_1_1_N = mkN "förlöpning" ;
  foerloesning_nn_1_1_N = mkN "förlösning" ;
  foermaning_nn_1_1_N = mkN "förmaning" ;
  foermedling_nn_1_1_N = mkN "förmedling" ;
  foerminskning_nn_1_1_N = mkN "förminskning" ;
  foermultning_nn_1_1_N = mkN "förmultning" ;
  foermyndarregering_nn_1_1_N = mkN "förmyndarregering" ;
  foermaelning_nn_1_1_N = mkN "förmälning" ;
  foermoerkning_nn_1_1_N = mkN "förmörkning" ;
  foernagling_nn_1_1_N = mkN "förnagling" ;
  foernedring_nn_1_1_N = mkN "förnedring" ;
  foerolaempning_nn_1_1_N = mkN "förolämpning" ;
  foerordning_nn_1_1_N = mkN "förordning" ;
  foerorening_nn_1_1_N = mkN "förorening" ;
  foerortstraedgaard_nn_1_1_N = mkN "förortsträdgård" ;
  foerpackning_nn_1_1_N = mkN "förpackning" ;
  foerpaktning_nn_1_1_N = mkN "förpaktning" ;
  foerpantning_nn_1_1_N = mkN "förpantning" ;
  foerpassning_nn_1_1_N = mkN "förpassning" ;
  foerpestning_nn_1_1_N = mkN "förpestning" ;
  foerplaegning_nn_1_1_N = mkN "förplägning" ;
  foerpostfaektning_nn_1_1_N = mkN "förpostfäktning" ;
  foerprickning_nn_1_1_N = mkN "förprickning" ;
  foerpuppning_nn_1_1_N = mkN "förpuppning" ;
  foerregling_nn_1_1_N = mkN "förregling" ;
  foerryckning_nn_1_1_N = mkN "förryckning" ;
  foerraentning_nn_1_1_N = mkN "förräntning" ;
  foerraettning_nn_1_1_N = mkN "förrättning" ;
  foersamling_nn_1_1_N = mkN "församling" ;
  foersegling_nn_1_1_N = mkN "försegling" ;
  foersening_nn_1_1_N = mkN "försening" ;
  foersinkning_nn_1_1_N = mkN "försinkning" ;
  foersjunkning_nn_1_1_N = mkN "försjunkning" ;
  foerskansning_nn_1_1_N = mkN "förskansning" ;
  foerskiffring_nn_1_1_N = mkN "förskiffring" ;
  foerskingring_nn_1_1_N = mkN "förskingring" ;
  foerskjutning_nn_1_1_N = mkN "förskjutning" ;
  foerskoning_nn_1_1_N = mkN "förskoning" ;
  foerskottering_nn_1_1_N = mkN "förskottering" ;
  foerskrivning_nn_1_1_N = mkN "förskrivning" ;
  foerskaemning_nn_1_1_N = mkN "förskämning" ;
  foerskoening_nn_1_1_N = mkN "försköning" ;
  foerslappning_nn_1_1_N = mkN "förslappning" ;
  foerslavning_nn_1_1_N = mkN "förslavning" ;
  foerslitning_nn_1_1_N = mkN "förslitning" ;
  foerslutning_nn_1_1_N = mkN "förslutning" ;
  foersloesning_nn_1_1_N = mkN "förslösning" ;
  foersnillning_nn_1_1_N = mkN "försnillning" ;
  foersockring_nn_1_1_N = mkN "försockring" ;
  foersoning_nn_1_1_N = mkN "försoning" ;
  foerspaenning_nn_1_1_N = mkN "förspänning" ;
  foerstelning_nn_1_1_N = mkN "förstelning" ;
  foerstening_nn_1_1_N = mkN "förstening" ;
  foerstoppning_nn_1_1_N = mkN "förstoppning" ;
  foerstoring_nn_1_1_N = mkN "förstoring" ;
  foerstraeckning_nn_1_1_N = mkN "försträckning" ;
  foerstaellning_nn_1_1_N = mkN "förställning" ;
  foerstaemning_nn_1_1_N = mkN "förstämning" ;
  foerstaerkning_nn_1_1_N = mkN "förstärkning" ;
  foerstaaelseram_nn_1_1_N = mkN "förståelseram" ;
  foerstoering_nn_1_1_N = mkN "förstöring" ;
  foersumpning_nn_1_1_N = mkN "försumpning" ;
  foersurning_nn_1_1_N = mkN "försurning" ;
  foersvagning_nn_1_1_N = mkN "försvagning" ;
  foersvarsanlaeggning_nn_1_1_N = mkN "försvarsanläggning" ;
  foersvarsnedskaerning_nn_1_1_N = mkN "försvarsnedskärning" ;
  foersvarsplanering_nn_1_1_N = mkN "försvarsplanering" ;
  foersvarsstaellning_nn_1_1_N = mkN "försvarsställning" ;
  foersaegning_nn_1_1_N = mkN "försägning" ;
  foersaekring_nn_1_1_N = mkN "försäkring" ;
  foersaeljning_nn_1_1_N = mkN "försäljning" ;
  foersaeljningsdag_nn_1_1_N = mkN "försäljningsdag" ;
  foersaemring_nn_1_1_N = mkN "försämring" ;
  foersaendning_nn_1_1_N = mkN "försändning" ;
  foersaenkning_nn_1_1_N = mkN "försänkning" ;
  foersaettning_nn_1_1_N = mkN "försättning" ;
  foersaapning_nn_1_1_N = mkN "försåpning" ;
  foersoeksdamm_nn_1_1_N = mkN "försöksdamm" ;
  foersoerjning_nn_1_1_N = mkN "försörjning" ;
  foersoerjningsinraettning_nn_1_1_N = mkN "försörjningsinrättning" ;
  foerteckning_nn_1_1_N = mkN "förteckning" ;
  foertenning_nn_1_1_N = mkN "förtenning" ;
  foertidspensionering_nn_1_1_N = mkN "förtidspensionering" ;
  foertidsroestning_nn_1_1_N = mkN "förtidsröstning" ;
  foertimring_nn_1_1_N = mkN "förtimring" ;
  foertjockning_nn_1_1_N = mkN "förtjockning" ;
  foertjusning_nn_1_1_N = mkN "förtjusning" ;
  foertoning_nn_1_1_N = mkN "förtoning" ;
  foertorkning_nn_1_1_N = mkN "förtorkning" ;
  foertrampning_nn_1_1_N = mkN "förtrampning" ;
  foertroendemaetning_nn_1_1_N = mkN "förtroendemätning" ;
  foertroendeomroestning_nn_1_1_N = mkN "förtroendeomröstning" ;
  foertrollning_nn_1_1_N = mkN "förtrollning" ;
  foertryckning_nn_1_1_N = mkN "förtryckning" ;
  foertraengning_nn_1_1_N = mkN "förträngning" ;
  foertullning_nn_1_1_N = mkN "förtullning" ;
  foertunning_nn_1_1_N = mkN "förtunning" ;
  foertvining_nn_1_1_N = mkN "förtvining" ;
  foertvaett_nn_1_1_N = mkN "förtvätt" ;
  foertvaalning_nn_1_1_N = mkN "förtvålning" ;
  foertaendning_nn_1_1_N = mkN "förtändning" ;
  foertaering_nn_1_1_N = mkN "förtäring" ;
  foertaetning_nn_1_1_N = mkN "förtätning" ;
  foertoejning_nn_1_1_N = mkN "förtöjning" ;
  foertoejningsring_nn_1_1_N = mkN "förtöjningsring" ;
  foerundersoekning_nn_1_1_N = mkN "förundersökning" ;
  foerutsaettning_nn_1_1_N = mkN "förutsättning" ;
  foervaltning_nn_1_1_N = mkN "förvaltning" ;
  foervandling_nn_1_1_N = mkN "förvandling" ;
  foervanskning_nn_1_1_N = mkN "förvanskning" ;
  foervaring_nn_1_1_N = mkN "förvaring" ;
  foervaringsback_nn_1_1_N = mkN "förvaringsback" ;
  foervaringshall_nn_1_1_N = mkN "förvaringshall" ;
  foervaringskorg_nn_1_1_N = mkN "förvaringskorg" ;
  foervarning_nn_1_1_N = mkN "förvarning" ;
  foerveckling_nn_1_1_N = mkN "förveckling" ;
  foervedning_nn_1_1_N = mkN "förvedning" ;
  foervirring_nn_1_1_N = mkN "förvirring" ;
  foervisning_nn_1_1_N = mkN "förvisning" ;
  foervissning_nn_1_1_N = mkN "förvissning" ;
  foervittring_nn_1_1_N = mkN "förvittring" ;
  foervridning_nn_1_1_N = mkN "förvridning" ;
  foervraengning_nn_1_1_N = mkN "förvrängning" ;
  foervaellning_nn_1_1_N = mkN "förvällning" ;
  foervaendning_nn_1_1_N = mkN "förvändning" ;
  foervaentning_nn_1_1_N = mkN "förväntning" ;
  foervaerring_nn_1_1_N = mkN "förvärring" ;
  foervaexling_nn_1_1_N = mkN "förväxling" ;
  foervaexlingslek_nn_1_1_N = mkN "förväxlingslek" ;
  foervaaning_nn_1_1_N = mkN "förvåning" ;
  foeryngring_nn_1_1_N = mkN "föryngring" ;
  foeryngringsbeskaering_nn_1_1_N = mkN "föryngringsbeskäring" ;
  foerzinkning_nn_1_1_N = mkN "förzinkning" ;
  foeraedling_nn_1_1_N = mkN "förädling" ;
  foeraeldrafoersaekring_nn_1_1_N = mkN "föräldraförsäkring" ;
  foeraeldrapenning_nn_1_1_N = mkN "föräldrapenning" ;
  foeraendring_nn_1_1_N = mkN "förändring" ;
  foeroekning_nn_1_1_N = mkN "förökning" ;
  foeroevning_nn_1_1_N = mkN "förövning" ;
  foesning_nn_1_1_N = mkN "fösning" ;
  gabondoerr_nn_1_1_N = mkN "gabondörr" ;
  gaffellyft_nn_1_N = mkN "gaffellyft" ;
  galafoerestaellning_nn_1_1_N = mkN "galaföreställning" ;
  galamiddag_nn_1_N = mkN "galamiddag" ;
  galavagn_nn_1_N = mkN "galavagn" ;
  galaxbildning_nn_1_N = mkN "galaxbildning" ;
  galaxhop_nn_1_N = mkN "galaxhop" ;
  galaxvaerld_nn_1_1_N = mkN "galaxvärld" ;
  gallbildning_nn_1_N = mkN "gallbildning" ;
  gallerdurk_nn_1_N = mkN "gallerdurk" ;
  gallergrind_nn_1_N = mkN "gallergrind" ;
  galleriskog_nn_1_N = mkN "galleriskog" ;
  gallgaang_nn_1_1_N = mkN "gallgång" ;
  gallisering_nn_1_N = mkN "gallisering" ;
  gallring_nn_1_N = mkN "gallring" ;
  gallupmaetning_nn_1_1_N = mkN "gallupmätning" ;
  galoppering_nn_1_N = mkN "galoppering" ;
  galopptaevling_nn_1_1_N = mkN "galopptävling" ;
  galoschering_nn_1_N = mkN "galoschering" ;
  galvanisering_nn_1_N = mkN "galvanisering" ;
  gammalstavning_nn_1_N = mkN "gammalstavning" ;
  gammastraalning_nn_1_1_N = mkN "gammastrålning" ;
  gapning_nn_1_N = mkN "gapning" ;
  gapstock_nn_1_N = mkN "gapstock" ;
  garagering_nn_1_N = mkN "garagering" ;
  garantering_nn_1_N = mkN "garantering" ;
  garantifoersaekring_nn_1_1_N = mkN "garantiförsäkring" ;
  gardering_nn_1_N = mkN "gardering" ;
  garderobsdoerr_nn_1_1_N = mkN "garderobsdörr" ;
  gardinkrok_nn_1_N = mkN "gardinkrok" ;
  gardinring_nn_1_N = mkN "gardinring" ;
  garnering_nn_1_N = mkN "garnering" ;
  garnisonering_nn_1_N = mkN "garnisonering" ;
  garrottering_nn_1_N = mkN "garrottering" ;
  garvning_nn_1_N = mkN "garvning" ;
  gasbil_nn_1_N = mkN "gasbil" ;
  gasbilsfoersaeljning_nn_1_1_N = mkN "gasbilsförsäljning" ;
  gasblandning_nn_1_N = mkN "gasblandning" ;
  gasfoergiftning_nn_1_1_N = mkN "gasförgiftning" ;
  gasledning_nn_1_N = mkN "gasledning" ;
  gasolgrill_nn_1_N = mkN "gasolgrill" ;
  gasraekning_nn_1_1_N = mkN "gasräkning" ;
  gassvetsning_nn_1_N = mkN "gassvetsning" ;
  gastering_nn_1_N = mkN "gastering" ;
  gastkramning_nn_1_N = mkN "gastkramning" ;
  gastroskopering_nn_1_N = mkN "gastroskopering" ;
  gasurladdning_nn_1_N = mkN "gasurladdning" ;
  gatlaeggning_nn_1_1_N = mkN "gatläggning" ;
  gatubelysning_nn_1_N = mkN "gatubelysning" ;
  gatubelaeggning_nn_1_1_N = mkN "gatubeläggning" ;
  gatukorsning_nn_1_N = mkN "gatukorsning" ;
  gauffrering_nn_1_N = mkN "gauffrering" ;
  gel_eklump_nn_1_1_N = mkN "geléklump" ;
  gemensamhetsgrav_nn_1_N = mkN "gemensamhetsgrav" ;
  geminering_nn_1_N = mkN "geminering" ;
  gendrivning_nn_1_N = mkN "gendrivning" ;
  generalfoersamling_nn_1_1_N = mkN "generalförsamling" ;
  generalisering_nn_1_N = mkN "generalisering" ;
  generalmoenstring_nn_1_1_N = mkN "generalmönstring" ;
  generationsvaexling_nn_1_1_N = mkN "generationsväxling" ;
  generering_nn_1_N = mkN "generering" ;
  genering_nn_1_N = mkN "genering" ;
  genfordring_nn_1_N = mkN "genfordring" ;
  genfoeraendring_nn_1_1_N = mkN "genförändring" ;
  genmanipulering_nn_1_N = mkN "genmanipulering" ;
  genmodifiering_nn_1_N = mkN "genmodifiering" ;
  genomarbetning_nn_1_N = mkN "genomarbetning" ;
  genomblaeddring_nn_1_1_N = mkN "genombläddring" ;
  genombloedning_nn_1_1_N = mkN "genomblödning" ;
  genomborrning_nn_1_N = mkN "genomborrning" ;
  genombrytning_nn_1_N = mkN "genombrytning" ;
  genomfartsvaeg_nn_1_1_N = mkN "genomfartsväg" ;
  genomfoering_nn_1_1_N = mkN "genomföring" ;
  genomfoerning_nn_1_1_N = mkN "genomförning" ;
  genomgaang_nn_1_1_N = mkN "genomgång" ;
  genomklappning_nn_1_N = mkN "genomklappning" ;
  genomkorsning_nn_1_N = mkN "genomkorsning" ;
  genomlysning_nn_1_N = mkN "genomlysning" ;
  genomlaesning_nn_1_1_N = mkN "genomläsning" ;
  genommoenstring_nn_1_1_N = mkN "genommönstring" ;
  genomraekning_nn_1_1_N = mkN "genomräkning" ;
  genomsippring_nn_1_N = mkN "genomsippring" ;
  genomskaerning_nn_1_1_N = mkN "genomskärning" ;
  genomstroemning_nn_1_1_N = mkN "genomströmning" ;
  genomsyrning_nn_1_N = mkN "genomsyrning" ;
  genomsoekning_nn_1_1_N = mkN "genomsökning" ;
  genomtrampning_nn_1_N = mkN "genomtrampning" ;
  genomtraengning_nn_1_1_N = mkN "genomträngning" ;
  genskjutning_nn_1_N = mkN "genskjutning" ;
  genstaemning_nn_1_1_N = mkN "genstämning" ;
  genterapibehandling_nn_1_N = mkN "genterapibehandling" ;
  genvaeg_nn_1_1_N = mkN "genväg" ;
  geometrisering_nn_1_N = mkN "geometrisering" ;
  gering_nn_1_N = mkN "gering" ;
  geringssaag_nn_1_1_N = mkN "geringssåg" ;
  germanisering_nn_1_N = mkN "germanisering" ;
  gestaltning_nn_1_N = mkN "gestaltning" ;
  gestikulering_nn_1_N = mkN "gestikulering" ;
  gesaellvandring_nn_1_1_N = mkN "gesällvandring" ;
  gevaersmynning_nn_1_1_N = mkN "gevärsmynning" ;
  gevaersstock_nn_1_1_N = mkN "gevärsstock" ;
  giftavdunstning_nn_1_N = mkN "giftavdunstning" ;
  giftbetning_nn_1_N = mkN "giftbetning" ;
  giftorm_nn_1_N = mkN "giftorm" ;
  giktring_nn_1_N = mkN "giktring" ;
  giljotinering_nn_1_N = mkN "giljotinering" ;
  gindrink_nn_1_N = mkN "gindrink" ;
  ginvaeg_nn_1_1_N = mkN "ginväg" ;
  gipsavgjutning_nn_1_N = mkN "gipsavgjutning" ;
  gipsform_nn_1_N = mkN "gipsform" ;
  gipsklump_nn_1_N = mkN "gipsklump" ;
  gipsvaegg_nn_1_1_N = mkN "gipsvägg" ;
  girering_nn_1_N = mkN "girering" ;
  girigbuk_nn_1_N = mkN "girigbuk" ;
  girning_nn_1_N = mkN "girning" ;
  gissning_nn_1_N = mkN "gissning" ;
  gissningslek_nn_1_N = mkN "gissningslek" ;
  gissningstaevling_nn_1_1_N = mkN "gissningstävling" ;
  givning_nn_1_N = mkN "givning" ;
  gjutform_nn_1_N = mkN "gjutform" ;
  gjutning_nn_1_N = mkN "gjutning" ;
  glaciaerbrunn_nn_1_1_N = mkN "glaciärbrunn" ;
  glaciaerport_nn_1_1_N = mkN "glaciärport" ;
  glaciaeraelv_nn_1_1_N = mkN "glaciärälv" ;
  gladiatorgrav_nn_1_N = mkN "gladiatorgrav" ;
  glamorisering_nn_1_N = mkN "glamorisering" ;
  glamourisering_nn_1_N = mkN "glamourisering" ;
  glanskning_nn_1_N = mkN "glanskning" ;
  glansning_nn_1_N = mkN "glansning" ;
  glappning_nn_1_N = mkN "glappning" ;
  glasbit_nn_1_N = mkN "glasbit" ;
  glasblaasning_nn_1_1_N = mkN "glasblåsning" ;
  glasburk_nn_1_N = mkN "glasburk" ;
  glasdoerr_nn_1_1_N = mkN "glasdörr" ;
  glasering_nn_1_N = mkN "glasering" ;
  glasframstaellning_nn_1_1_N = mkN "glasframställning" ;
  glashuv_nn_1_N = mkN "glashuv" ;
  glasmaalning_nn_1_1_N = mkN "glasmålning" ;
  glasplaat_nn_1_1_N = mkN "glasplåt" ;
  glasskaal_nn_1_1_N = mkN "glasskål" ;
  glasvaegg_nn_1_1_N = mkN "glasvägg" ;
  glasoegonbjoern_nn_1_1_N = mkN "glasögonbjörn" ;
  glasoegonorm_nn_1_1_N = mkN "glasögonorm" ;
  glattning_nn_1_N = mkN "glattning" ;
  glidning_nn_1_N = mkN "glidning" ;
  glidtackling_nn_1_N = mkN "glidtackling" ;
  glorifiering_nn_1_N = mkN "glorifiering" ;
  glaedjebetygssaettning_nn_1_1_N = mkN "glädjebetygssättning" ;
  glaedjetaar_nn_1_1_N = mkN "glädjetår" ;
  glaedjeyttring_nn_1_1_N = mkN "glädjeyttring" ;
  glaefsning_nn_1_1_N = mkN "gläfsning" ;
  glaettning_nn_1_1_N = mkN "glättning" ;
  gloedgning_nn_1_1_N = mkN "glödgning" ;
  gloedhoeg_nn_1_1_N = mkN "glödhög" ;
  gloedning_nn_1_1_N = mkN "glödning" ;
  gloedritning_nn_1_1_N = mkN "glödritning" ;
  gloedtraad_nn_1_1_N = mkN "glödtråd" ;
  gnagning_nn_1_N = mkN "gnagning" ;
  gnidning_nn_1_N = mkN "gnidning" ;
  gnistbildning_nn_1_N = mkN "gnistbildning" ;
  gnisttaendning_nn_1_1_N = mkN "gnisttändning" ;
  gnuggning_nn_1_N = mkN "gnuggning" ;
  gnaeggning_nn_1_1_N = mkN "gnäggning" ;
  godbit_nn_1_N = mkN "godbit" ;
  godsmottagning_nn_1_N = mkN "godsmottagning" ;
  goffrering_nn_1_N = mkN "goffrering" ;
  golfboll_nn_1_N = mkN "golfboll" ;
  golfturnering_nn_1_N = mkN "golfturnering" ;
  golgatavandring_nn_1_N = mkN "golgatavandring" ;
  golvbelaeggning_nn_1_1_N = mkN "golvbeläggning" ;
  golvmopp_nn_1_N = mkN "golvmopp" ;
  gomklyvning_nn_1_N = mkN "gomklyvning" ;
  googling_nn_1_N = mkN "googling" ;
  gotlaenning_nn_1_1_N = mkN "gotlänning" ;
  gottkoepsfoerklaring_nn_1_1_N = mkN "gottköpsförklaring" ;
  goutering_nn_1_N = mkN "goutering" ;
  gradbeteckning_nn_1_N = mkN "gradbeteckning" ;
  gradboejning_nn_1_1_N = mkN "gradböjning" ;
  gradering_nn_1_N = mkN "gradering" ;
  gradmaetning_nn_1_1_N = mkN "gradmätning" ;
  gradsaag_nn_1_1_N = mkN "gradsåg" ;
  gradualavhandling_nn_1_N = mkN "gradualavhandling" ;
  graduering_nn_1_N = mkN "graduering" ;
  grafitering_nn_1_N = mkN "grafitering" ;
  granatbeskjutning_nn_1_N = mkN "granatbeskjutning" ;
  granattraeff_nn_1_1_N = mkN "granatträff" ;
  granhaeck_nn_1_1_N = mkN "granhäck" ;
  grannkung_nn_1_N = mkN "grannkung" ;
  granskning_nn_1_N = mkN "granskning" ;
  granskog_nn_1_N = mkN "granskog" ;
  granulering_nn_1_N = mkN "granulering" ;
  grassering_nn_1_N = mkN "grassering" ;
  gratinering_nn_1_N = mkN "gratinering" ;
  gratistidning_nn_1_N = mkN "gratistidning" ;
  gratulering_nn_1_N = mkN "gratulering" ;
  gravering_nn_1_N = mkN "gravering" ;
  gravhaell_nn_1_1_N = mkN "gravhäll" ;
  gravhoeg_nn_1_1_N = mkN "gravhög" ;
  gravitationslag_nn_1_N = mkN "gravitationslag" ;
  gravitationsstraalning_nn_1_1_N = mkN "gravitationsstrålning" ;
  gravitering_nn_1_N = mkN "gravitering" ;
  gravplundring_nn_1_N = mkN "gravplundring" ;
  gravskaendning_nn_1_1_N = mkN "gravskändning" ;
  gravsvepning_nn_1_N = mkN "gravsvepning" ;
  gravsaettning_nn_1_1_N = mkN "gravsättning" ;
  gravvaard_nn_1_1_N = mkN "gravvård" ;
  gravoeppning_nn_1_1_N = mkN "gravöppning" ;
  grenledning_nn_1_N = mkN "grenledning" ;
  griljering_nn_1_N = mkN "griljering" ;
  grimasering_nn_1_N = mkN "grimasering" ;
  grimering_nn_1_N = mkN "grimering" ;
  grindoeppning_nn_1_1_N = mkN "grindöppning" ;
  griskastrering_nn_1_N = mkN "griskastrering" ;
  grisning_nn_1_N = mkN "grisning" ;
  grizzlybjoern_nn_1_1_N = mkN "grizzlybjörn" ;
  groning_nn_1_N = mkN "groning" ;
  grottbjoern_nn_1_1_N = mkN "grottbjörn" ;
  grottforskning_nn_1_N = mkN "grottforskning" ;
  grottgaang_nn_1_1_N = mkN "grottgång" ;
  grottingaang_nn_1_1_N = mkN "grottingång" ;
  grottmynning_nn_1_N = mkN "grottmynning" ;
  grottmaalning_nn_1_1_N = mkN "grottmålning" ;
  grovlek_nn_1_N = mkN "grovlek" ;
  grovplanering_nn_1_N = mkN "grovplanering" ;
  grovsortering_nn_1_N = mkN "grovsortering" ;
  grumling_nn_1_N = mkN "grumling" ;
  grundering_nn_1_N = mkN "grundering" ;
  grundforskning_nn_1_N = mkN "grundforskning" ;
  grundfoerbaettring_nn_1_1_N = mkN "grundförbättring" ;
  grundkaenning_nn_1_1_N = mkN "grundkänning" ;
  grundlag_nn_1_N = mkN "grundlag" ;
  grundlagsaendring_nn_1_1_N = mkN "grundlagsändring" ;
  grundlaeggning_nn_1_1_N = mkN "grundläggning" ;
  grundmur_nn_1_N = mkN "grundmur" ;
  grundmaalning_nn_1_1_N = mkN "grundmålning" ;
  grundning_nn_1_N = mkN "grundning" ;
  grundstaellning_nn_1_1_N = mkN "grundställning" ;
  grundstaemning_nn_1_1_N = mkN "grundstämning" ;
  grundstoetning_nn_1_1_N = mkN "grundstötning" ;
  grundutbildning_nn_1_N = mkN "grundutbildning" ;
  gruppering_nn_1_N = mkN "gruppering" ;
  gruppfoersaekring_nn_1_1_N = mkN "gruppförsäkring" ;
  gruppsmoerjning_nn_1_1_N = mkN "gruppsmörjning" ;
  grusgaang_nn_1_1_N = mkN "grusgång" ;
  grusvaeg_nn_1_1_N = mkN "grusväg" ;
  gruvbrytning_nn_1_N = mkN "gruvbrytning" ;
  gruvgaang_nn_1_1_N = mkN "gruvgång" ;
  gruvoeppning_nn_1_1_N = mkN "gruvöppning" ;
  grymtning_nn_1_N = mkN "grymtning" ;
  gryning_nn_1_N = mkN "gryning" ;
  grynkorv_nn_1_N = mkN "grynkorv" ;
  grynvaelling_nn_1_1_N = mkN "grynvälling" ;
  grytstek_nn_1_N = mkN "grytstek" ;
  graeddning_nn_1_1_N = mkN "gräddning" ;
  graeddsaettning_nn_1_1_N = mkN "gräddsättning" ;
  graensbevakning_nn_1_1_N = mkN "gränsbevakning" ;
  graensdragning_nn_1_1_N = mkN "gränsdragning" ;
  graenspostering_nn_1_1_N = mkN "gränspostering" ;
  graenssaettning_nn_1_1_N = mkN "gränssättning" ;
  graesflaeck_nn_1_1_N = mkN "gräsfläck" ;
  graesklippning_nn_1_1_N = mkN "gräsklippning" ;
  graesplaett_nn_1_1_N = mkN "gräsplätt" ;
  graesstraeng_nn_1_1_N = mkN "grässträng" ;
  graesvall_nn_1_1_N = mkN "gräsvall" ;
  graesaenkling_nn_1_1_N = mkN "gräsänkling" ;
  graevblogg_nn_1_1_N = mkN "grävblogg" ;
  graevning_nn_1_1_N = mkN "grävning" ;
  graamunk_nn_1_1_N = mkN "gråmunk" ;
  groengoedsling_nn_1_1_N = mkN "gröngödsling" ;
  groengoeling_nn_1_1_N = mkN "gröngöling" ;
  groensaksblandning_nn_1_1_N = mkN "grönsaksblandning" ;
  groensaksodling_nn_1_1_N = mkN "grönsaksodling" ;
  groensakstallrik_nn_1_1_N = mkN "grönsakstallrik" ;
  groepning_nn_1_1_N = mkN "gröpning" ;
  gudaskymning_nn_1_N = mkN "gudaskymning" ;
  gudom_nn_1_N = mkN "gudom" ;
  gudsdom_nn_1_N = mkN "gudsdom" ;
  gudstjaenstordning_nn_1_1_N = mkN "gudstjänstordning" ;
  guldkran_nn_1_N = mkN "guldkran" ;
  guldkrog_nn_1_N = mkN "guldkrog" ;
  guldlegering_nn_1_N = mkN "guldlegering" ;
  guldpressning_nn_1_N = mkN "guldpressning" ;
  guldtraad_nn_1_1_N = mkN "guldtråd" ;
  guldtaeckning_nn_1_1_N = mkN "guldtäckning" ;
  guldvaskning_nn_1_N = mkN "guldvaskning" ;
  guldvaag_nn_1_1_N = mkN "guldvåg" ;
  gulfaergning_nn_1_1_N = mkN "gulfärgning" ;
  gulning_nn_1_N = mkN "gulning" ;
  gummering_nn_1_N = mkN "gummering" ;
  gummiboll_nn_1_N = mkN "gummiboll" ;
  gummibaat_nn_1_1_N = mkN "gummibåt" ;
  gummipigg_nn_1_N = mkN "gummipigg" ;
  gummipropp_nn_1_N = mkN "gummipropp" ;
  gummislang_nn_1_N = mkN "gummislang" ;
  gungning_nn_1_N = mkN "gungning" ;
  gungstol_nn_1_N = mkN "gungstol" ;
  gungstaellning_nn_1_1_N = mkN "gungställning" ;
  guppning_nn_1_N = mkN "guppning" ;
  gurkstav_nn_1_N = mkN "gurkstav" ;
  gutering_nn_1_N = mkN "gutering" ;
  gymnasieutbildning_nn_1_N = mkN "gymnasieutbildning" ;
  gymnastiksal_nn_1_N = mkN "gymnastiksal" ;
  gymnastisering_nn_1_N = mkN "gymnastisering" ;
  gyttring_nn_1_N = mkN "gyttring" ;
  gaengning_nn_1_1_N = mkN "gängning" ;
  gaengtatuering_nn_1_1_N = mkN "gängtatuering" ;
  gaerdning_nn_1_1_N = mkN "gärdning" ;
  gaerning_nn_1_1_N = mkN "gärning" ;
  gaespning_nn_1_1_N = mkN "gäspning" ;
  gaestning_nn_1_1_N = mkN "gästning" ;
  gaestriking_nn_1_1_N = mkN "gästriking" ;
  gaestriklaenning_nn_1_1_N = mkN "gästriklänning" ;
  gaestrumsdoerr_nn_1_1_N = mkN "gästrumsdörr" ;
  gaabock_nn_1_1_N = mkN "gåbock" ;
  gaangbock_nn_1_1_N = mkN "gångbock" ;
  gaangstig_nn_1_1_N = mkN "gångstig" ;
  gaangvaeg_nn_1_1_N = mkN "gångväg" ;
  gaavohandling_nn_1_1_N = mkN "gåvohandling" ;
  goedning_nn_1_1_N = mkN "gödning" ;
  goedsling_nn_1_1_N = mkN "gödsling" ;
  goerdelfaestning_nn_1_1_N = mkN "gördelfästning" ;
  habilitering_nn_1_N = mkN "habilitering" ;
  hackning_nn_1_N = mkN "hackning" ;
  hackordning_nn_1_N = mkN "hackordning" ;
  hagelskur_nn_1_N = mkN "hagelskur" ;
  hagelstorm_nn_1_N = mkN "hagelstorm" ;
  hagelsvaerm_nn_1_1_N = mkN "hagelsvärm" ;
  hagtornshaeck_nn_1_1_N = mkN "hagtornshäck" ;
  hakning_nn_1_N = mkN "hakning" ;
  halkkrock_nn_1_N = mkN "halkkrock" ;
  halkkoerning_nn_1_1_N = mkN "halkkörning" ;
  halkning_nn_1_N = mkN "halkning" ;
  halkvarning_nn_1_N = mkN "halkvarning" ;
  hallucinering_nn_1_N = mkN "hallucinering" ;
  hallaenning_nn_1_1_N = mkN "hallänning" ;
  halmhatt_nn_1_N = mkN "halmhatt" ;
  halning_nn_1_N = mkN "halning" ;
  halshuggning_nn_1_N = mkN "halshuggning" ;
  halsring_nn_1_N = mkN "halsring" ;
  haltning_nn_1_N = mkN "haltning" ;
  halvering_nn_1_N = mkN "halvering" ;
  halvgud_nn_1_N = mkN "halvgud" ;
  halvlek_nn_1_N = mkN "halvlek" ;
  halvsanning_nn_1_N = mkN "halvsanning" ;
  halvtidsfrigivning_nn_1_N = mkN "halvtidsfrigivning" ;
  halvviskning_nn_1_N = mkN "halvviskning" ;
  handboll_nn_2_N = mkN "handboll" ;
  handdukstork_nn_1_N = mkN "handdukstork" ;
  handklappning_nn_1_N = mkN "handklappning" ;
  handkvarn_nn_1_N = mkN "handkvarn" ;
  handledning_nn_1_N = mkN "handledning" ;
  handling_nn_1_N = mkN "handling" ;
  handlingsfoerlamning_nn_1_1_N = mkN "handlingsförlamning" ;
  handlaeggning_nn_1_1_N = mkN "handläggning" ;
  handpump_nn_1_N = mkN "handpump" ;
  handpaalaeggning_nn_1_1_N = mkN "handpåläggning" ;
  handrygg_nn_1_N = mkN "handrygg" ;
  handraeckning_nn_1_1_N = mkN "handräckning" ;
  handskakning_nn_1_N = mkN "handskakning" ;
  handskriftsavdelning_nn_1_N = mkN "handskriftsavdelning" ;
  handskriftssamling_nn_1_N = mkN "handskriftssamling" ;
  handsaag_nn_1_1_N = mkN "handsåg" ;
  handtryckning_nn_1_N = mkN "handtryckning" ;
  handtvagning_nn_1_N = mkN "handtvagning" ;
  handtvaett_nn_1_1_N = mkN "handtvätt" ;
  handuppraeckning_nn_1_1_N = mkN "handuppräckning" ;
  hantering_nn_1_N = mkN "hantering" ;
  hantverksfoerening_nn_1_1_N = mkN "hantverksförening" ;
  harangering_nn_1_N = mkN "harangering" ;
  harkling_nn_1_N = mkN "harkling" ;
  harlaepp_nn_1_1_N = mkN "harläpp" ;
  harmoniering_nn_1_N = mkN "harmoniering" ;
  harmonisering_nn_1_N = mkN "harmonisering" ;
  harpunering_nn_1_N = mkN "harpunering" ;
  harstig_nn_1_N = mkN "harstig" ;
  hartsning_nn_1_N = mkN "hartsning" ;
  hasardering_nn_1_N = mkN "hasardering" ;
  hastighetstaevling_nn_1_1_N = mkN "hastighetstävling" ;
  hastighetsaakning_nn_1_1_N = mkN "hastighetsåkning" ;
  hatkaerlek_nn_1_1_N = mkN "hatkärlek" ;
  hattstock_nn_1_N = mkN "hattstock" ;
  havandeskapsfoergiftning_nn_1_1_N = mkN "havandeskapsförgiftning" ;
  haverering_nn_1_N = mkN "haverering" ;
  havsarm_nn_1_N = mkN "havsarm" ;
  havsgud_nn_1_N = mkN "havsgud" ;
  havskappsegling_nn_1_N = mkN "havskappsegling" ;
  havsvik_nn_1_N = mkN "havsvik" ;
  havsvind_nn_1_N = mkN "havsvind" ;
  havsoern_nn_1_1_N = mkN "havsörn" ;
  hedendom_nn_1_N = mkN "hedendom" ;
  hedersbevisning_nn_1_N = mkN "hedersbevisning" ;
  hedersdomstol_nn_1_N = mkN "hedersdomstol" ;
  hejaklack_nn_1_N = mkN "hejaklack" ;
  hejarklack_nn_1_N = mkN "hejarklack" ;
  hektografering_nn_1_N = mkN "hektografering" ;
  heldag_nn_1_N = mkN "heldag" ;
  helfoersaekring_nn_1_1_N = mkN "helförsäkring" ;
  helgardering_nn_1_N = mkN "helgardering" ;
  helgedom_nn_1_N = mkN "helgedom" ;
  helgmaalsringning_nn_1_1_N = mkN "helgmålsringning" ;
  helgonfoerklaring_nn_1_1_N = mkN "helgonförklaring" ;
  helinackordering_nn_1_N = mkN "helinackordering" ;
  helomvaendning_nn_1_1_N = mkN "helomvändning" ;
  hembjudning_nn_1_N = mkN "hembjudning" ;
  hembraenning_nn_1_1_N = mkN "hembränning" ;
  hembygdsfoerening_nn_1_1_N = mkN "hembygdsförening" ;
  hemfoerlossning_nn_1_1_N = mkN "hemförlossning" ;
  hemfoerlovning_nn_1_1_N = mkN "hemförlovning" ;
  hemfoersaekring_nn_1_1_N = mkN "hemförsäkring" ;
  hemfoersaeljning_nn_1_1_N = mkN "hemförsäljning" ;
  hemgaang_nn_1_1_N = mkN "hemgång" ;
  hemhjaelp_nn_1_1_N = mkN "hemhjälp" ;
  heminredning_nn_1_N = mkN "heminredning" ;
  hemmansklyvning_nn_1_N = mkN "hemmansklyvning" ;
  hemstaellning_nn_1_1_N = mkN "hemställning" ;
  hemsoekning_nn_1_1_N = mkN "hemsökning" ;
  heroinkung_nn_1_N = mkN "heroinkung" ;
  heroisering_nn_1_N = mkN "heroisering" ;
  herrekipering_nn_1_N = mkN "herrekipering" ;
  herrhatt_nn_1_N = mkN "herrhatt" ;
  herrtidning_nn_1_N = mkN "herrtidning" ;
  hesitering_nn_1_N = mkN "hesitering" ;
  hetsning_nn_1_N = mkN "hetsning" ;
  hetvattentvaett_nn_1_1_N = mkN "hetvattentvätt" ;
  hetvaegg_nn_1_1_N = mkN "hetvägg" ;
  hibernering_nn_1_N = mkN "hibernering" ;
  hickning_nn_1_N = mkN "hickning" ;
  himladrottning_nn_1_N = mkN "himladrottning" ;
  hinderloepning_nn_1_1_N = mkN "hinderlöpning" ;
  hindersproevning_nn_1_1_N = mkN "hindersprövning" ;
  hissdoerr_nn_1_1_N = mkN "hissdörr" ;
  hisshall_nn_1_N = mkN "hisshall" ;
  historiefoerfalskning_nn_1_1_N = mkN "historieförfalskning" ;
  historiemaalning_nn_1_1_N = mkN "historiemålning" ;
  historiering_nn_1_N = mkN "historiering" ;
  historieskrivning_nn_1_N = mkN "historieskrivning" ;
  historisering_nn_1_N = mkN "historisering" ;
  hivlagstiftning_nn_1_N = mkN "hivlagstiftning" ;
  hivning_nn_1_N = mkN "hivning" ;
  hjortkalv_nn_1_N = mkN "hjortkalv" ;
  hjulfjaedring_nn_1_1_N = mkN "hjulfjädring" ;
  hjulning_nn_1_N = mkN "hjulning" ;
  hjulupphaengning_nn_1_1_N = mkN "hjulupphängning" ;
  hjaelpbaat_nn_1_1_N = mkN "hjälpbåt" ;
  hjaelpsaendning_nn_1_1_N = mkN "hjälpsändning" ;
  hjaeltedoed_nn_1_1_N = mkN "hjältedöd" ;
  hjaernbloedning_nn_1_1_N = mkN "hjärnblödning" ;
  hjaernsjukdom_nn_1_1_N = mkN "hjärnsjukdom" ;
  hjaernskakning_nn_1_1_N = mkN "hjärnskakning" ;
  hjaernvindling_nn_1_1_N = mkN "hjärnvindling" ;
  hjaertklappning_nn_1_1_N = mkN "hjärtklappning" ;
  hjaertsjukdom_nn_1_1_N = mkN "hjärtsjukdom" ;
  hjaertskoeld_nn_1_1_N = mkN "hjärtsköld" ;
  hjaessbjudning_nn_1_1_N = mkN "hjässbjudning" ;
  hobbyutbildning_nn_1_N = mkN "hobbyutbildning" ;
  hojtning_nn_1_N = mkN "hojtning" ;
  holmgaang_nn_1_1_N = mkN "holmgång" ;
  holografering_nn_1_N = mkN "holografering" ;
  homogenisering_nn_1_N = mkN "homogenisering" ;
  honorering_nn_1_N = mkN "honorering" ;
  honung_nn_1_N = mkN "honung" ;
  hopblandning_nn_1_N = mkN "hopblandning" ;
  hopbringning_nn_1_N = mkN "hopbringning" ;
  hopdragning_nn_1_N = mkN "hopdragning" ;
  hopfogning_nn_1_N = mkN "hopfogning" ;
  hopklumpning_nn_1_N = mkN "hopklumpning" ;
  hopknytning_nn_1_N = mkN "hopknytning" ;
  hopkoppling_nn_1_N = mkN "hopkoppling" ;
  hoplappning_nn_1_N = mkN "hoplappning" ;
  hopning_nn_1_N = mkN "hopning" ;
  hoppackning_nn_1_N = mkN "hoppackning" ;
  hoppsnurrspark_nn_1_N = mkN "hoppsnurrspark" ;
  hoppstaellning_nn_1_1_N = mkN "hoppställning" ;
  hopptraening_nn_1_1_N = mkN "hoppträning" ;
  hoprullning_nn_1_N = mkN "hoprullning" ;
  hopslagning_nn_1_N = mkN "hopslagning" ;
  hopsmaeltning_nn_2_1_N = mkN "hopsmältning" ;
  hopvikning_nn_1_N = mkN "hopvikning" ;
  hospitalisering_nn_1_N = mkN "hospitalisering" ;
  hostning_nn_1_N = mkN "hostning" ;
  hotellmatsal_nn_1_N = mkN "hotellmatsal" ;
  hotellvaerd_nn_1_1_N = mkN "hotellvärd" ;
  hottning_nn_1_N = mkN "hottning" ;
  hovnigning_nn_1_N = mkN "hovnigning" ;
  hudflaengning_nn_1_1_N = mkN "hudflängning" ;
  hudsjukdom_nn_1_N = mkN "hudsjukdom" ;
  hudoemsning_nn_1_1_N = mkN "hudömsning" ;
  huggkrok_nn_1_N = mkN "huggkrok" ;
  huggning_nn_1_N = mkN "huggning" ;
  huggorm_nn_1_N = mkN "huggorm" ;
  humanisering_nn_1_N = mkN "humanisering" ;
  humifiering_nn_1_N = mkN "humifiering" ;
  humusfoerening_nn_1_1_N = mkN "humusförening" ;
  hundblick_nn_1_N = mkN "hundblick" ;
  hundgaard_nn_1_1_N = mkN "hundgård" ;
  hundhetsning_nn_1_N = mkN "hundhetsning" ;
  hundkapploepning_nn_1_1_N = mkN "hundkapplöpning" ;
  hundraaaring_nn_1_1_N = mkN "hundraåring" ;
  hundsfottering_nn_1_N = mkN "hundsfottering" ;
  hundskit_nn_1_N = mkN "hundskit" ;
  husbil_nn_1_N = mkN "husbil" ;
  husbaat_nn_1_1_N = mkN "husbåt" ;
  husering_nn_1_N = mkN "husering" ;
  hushaallning_nn_1_1_N = mkN "hushållning" ;
  hushaallsvaag_nn_1_1_N = mkN "hushållsvåg" ;
  husknut_nn_1_N = mkN "husknut" ;
  husmorsfoerening_nn_1_1_N = mkN "husmorsförening" ;
  husrannsakning_nn_1_N = mkN "husrannsakning" ;
  husundersoekning_nn_1_1_N = mkN "husundersökning" ;
  husvaegg_nn_1_1_N = mkN "husvägg" ;
  husvaerd_nn_1_1_N = mkN "husvärd" ;
  huvudbjudning_nn_1_N = mkN "huvudbjudning" ;
  huvudduk_nn_1_N = mkN "huvudduk" ;
  huvudfoerhandling_nn_1_1_N = mkN "huvudförhandling" ;
  huvudgaard_nn_1_1_N = mkN "huvudgård" ;
  huvudingaang_nn_1_1_N = mkN "huvudingång" ;
  huvudledning_nn_1_N = mkN "huvudledning" ;
  huvudnaering_nn_1_1_N = mkN "huvudnäring" ;
  huvudraekning_nn_1_1_N = mkN "huvudräkning" ;
  huvudskakning_nn_1_N = mkN "huvudskakning" ;
  huvudskaal_nn_1_1_N = mkN "huvudskål" ;
  huvudvattenledning_nn_1_N = mkN "huvudvattenledning" ;
  huvudvridning_nn_1_N = mkN "huvudvridning" ;
  huvudvaeg_nn_1_1_N = mkN "huvudväg" ;
  hybridbil_nn_1_N = mkN "hybridbil" ;
  hybridisering_nn_1_N = mkN "hybridisering" ;
  hydratisering_nn_1_N = mkN "hydratisering" ;
  hydraullyft_nn_1_N = mkN "hydraullyft" ;
  hydrering_nn_1_N = mkN "hydrering" ;
  hydroforpump_nn_1_N = mkN "hydroforpump" ;
  hyggesbraenning_nn_1_1_N = mkN "hyggesbränning" ;
  hyllning_nn_1_N = mkN "hyllning" ;
  hypnotisering_nn_1_N = mkN "hypnotisering" ;
  hypoteksfoerening_nn_1_1_N = mkN "hypoteksförening" ;
  hypotisering_nn_1_N = mkN "hypotisering" ;
  hyresbetalning_nn_1_N = mkN "hyresbetalning" ;
  hyresgaestfoerening_nn_1_1_N = mkN "hyresgästförening" ;
  hyreslag_nn_1_N = mkN "hyreslag" ;
  hyresreglering_nn_1_N = mkN "hyresreglering" ;
  hyressaettning_nn_1_1_N = mkN "hyressättning" ;
  hyssjning_nn_1_N = mkN "hyssjning" ;
  hyvning_nn_1_N = mkN "hyvning" ;
  haeckloepning_nn_1_1_N = mkN "häcklöpning" ;
  haeckning_nn_1_1_N = mkN "häckning" ;
  haeftning_nn_1_1_N = mkN "häftning" ;
  haegring_nn_1_1_N = mkN "hägring" ;
  haektning_nn_1_1_N = mkN "häktning" ;
  haektningsfoerhandling_nn_1_1_N = mkN "häktningsförhandling" ;
  haellning_nn_1_1_N = mkN "hällning" ;
  haellristning_nn_1_1_N = mkN "hällristning" ;
  haelsning_nn_1_1_N = mkN "hälsning" ;
  haelsoraadgivning_nn_1_1_N = mkN "hälsorådgivning" ;
  haemning_nn_1_1_N = mkN "hämning" ;
  haemtning_nn_1_1_N = mkN "hämtning" ;
  haendelseutveckling_nn_1_1_N = mkN "händelseutveckling" ;
  haengning_nn_1_1_N = mkN "hängning" ;
  haengselkjol_nn_1_1_N = mkN "hängselkjol" ;
  haenryckning_nn_1_1_N = mkN "hänryckning" ;
  haensyftning_nn_1_1_N = mkN "hänsyftning" ;
  haentydning_nn_1_1_N = mkN "häntydning" ;
  haenvisning_nn_1_1_N = mkN "hänvisning" ;
  haerbaergering_nn_1_1_N = mkN "härbärgering" ;
  haerdning_nn_1_1_N = mkN "härdning" ;
  haerjning_nn_1_1_N = mkN "härjning" ;
  haerledning_nn_1_1_N = mkN "härledning" ;
  haermoenstring_nn_1_1_N = mkN "härmönstring" ;
  haerordning_nn_1_1_N = mkN "härordning" ;
  haerskning_nn_1_1_N = mkN "härskning" ;
  haerstamning_nn_1_1_N = mkN "härstamning" ;
  haessjning_nn_1_1_N = mkN "hässjning" ;
  haestkapploepning_nn_1_1_N = mkN "hästkapplöpning" ;
  haestspillning_nn_1_1_N = mkN "hästspillning" ;
  haestvagn_nn_1_1_N = mkN "hästvagn" ;
  haestvandring_nn_1_1_N = mkN "hästvandring" ;
  haevning_nn_1_1_N = mkN "hävning" ;
  haexring_nn_1_1_N = mkN "häxring" ;
  haallfasthetsberaekning_nn_1_1_N = mkN "hållfasthetsberäkning" ;
  haallning_nn_1_1_N = mkN "hållning" ;
  haalslagning_nn_1_1_N = mkN "hålslagning" ;
  haalvaeg_nn_1_1_N = mkN "hålväg" ;
  haardag_nn_1_1_N = mkN "hårdag" ;
  haardkorv_nn_1_1_N = mkN "hårdkorv" ;
  haardloedning_nn_1_1_N = mkN "hårdlödning" ;
  haardtraening_nn_1_1_N = mkN "hårdträning" ;
  haarfaellning_nn_1_1_N = mkN "hårfällning" ;
  haarfaergning_nn_1_1_N = mkN "hårfärgning" ;
  haarknut_nn_1_1_N = mkN "hårknut" ;
  haarlock_nn_1_1_N = mkN "hårlock" ;
  haarlaeggning_nn_1_1_N = mkN "hårläggning" ;
  haartott_nn_1_1_N = mkN "hårtott" ;
  haartvaett_nn_1_1_N = mkN "hårtvätt" ;
  haaruppsaettning_nn_1_1_N = mkN "håruppsättning" ;
  haavning_nn_1_1_N = mkN "håvning" ;
  hoeftvrickning_nn_1_1_N = mkN "höftvrickning" ;
  hoegaktning_nn_1_1_N = mkN "högaktning" ;
  hoegerknapp_nn_1_1_N = mkN "högerknapp" ;
  hoegerkrok_nn_1_1_N = mkN "högerkrok" ;
  hoegerregering_nn_1_1_N = mkN "högerregering" ;
  hoegersvaeng_nn_1_1_N = mkN "högersväng" ;
  hoegervind_nn_1_1_N = mkN "högervind" ;
  hoegervridning_nn_1_1_N = mkN "högervridning" ;
  hoeghastighetsjaernvaeg_nn_1_1_N = mkN "höghastighetsjärnväg" ;
  hoeglaesning_nn_1_1_N = mkN "högläsning" ;
  hoegskoleutbildning_nn_1_1_N = mkN "högskoleutbildning" ;
  hoegspaenning_nn_1_1_N = mkN "högspänning" ;
  hoegspaenningsledning_nn_1_1_N = mkN "högspänningsledning" ;
  hoegtidsdag_nn_1_1_N = mkN "högtidsdag" ;
  hoegtryckstvaett_nn_1_1_N = mkN "högtryckstvätt" ;
  hoegvall_nn_1_1_N = mkN "högvall" ;
  hoejdbestaemning_nn_1_1_N = mkN "höjdbestämning" ;
  hoejdhoppstaevling_nn_1_1_N = mkN "höjdhoppstävling" ;
  hoejdinstaellning_nn_1_1_N = mkN "höjdinställning" ;
  hoejdmaetning_nn_1_1_N = mkN "höjdmätning" ;
  hoejdstraeckning_nn_1_1_N = mkN "höjdsträckning" ;
  hoejning_nn_1_1_N = mkN "höjning" ;
  hoeljning_nn_1_1_N = mkN "höljning" ;
  hoersal_nn_1_1_N = mkN "hörsal" ;
  hoerselgaang_nn_1_1_N = mkN "hörselgång" ;
  hoestdagjaemning_nn_1_1_N = mkN "höstdagjämning" ;
  hoestorientering_nn_1_1_N = mkN "höstorientering" ;
  hoetorgsmaalning_nn_1_1_N = mkN "hötorgsmålning" ;
  hoevolm_nn_1_1_N = mkN "hövolm" ;
  hoevaalm_nn_1_1_N = mkN "hövålm" ;
  idealisering_nn_1_N = mkN "idealisering" ;
  idealvaerld_nn_1_1_N = mkN "idealvärld" ;
  identifiering_nn_1_N = mkN "identifiering" ;
  idrottsfoerening_nn_1_1_N = mkN "idrottsförening" ;
  idrottsklubb_nn_1_N = mkN "idrottsklubb" ;
  idrottstaevling_nn_1_1_N = mkN "idrottstävling" ;
  id_efattigdom_nn_1_1_N = mkN "idéfattigdom" ;
  id_eklaeckning_nn_1_1_N = mkN "idékläckning" ;
  id_erikedom_nn_1_1_N = mkN "idérikedom" ;
  ifyllning_nn_1_N = mkN "ifyllning" ;
  igentaeppning_nn_1_1_N = mkN "igentäppning" ;
  ignorering_nn_1_N = mkN "ignorering" ;
  igaangsaettning_nn_1_1_N = mkN "igångsättning" ;
  illgaerning_nn_1_1_N = mkN "illgärning" ;
  illudering_nn_1_N = mkN "illudering" ;
  illuminering_nn_1_N = mkN "illuminering" ;
  illustrering_nn_1_N = mkN "illustrering" ;
  ilning_nn_1_N = mkN "ilning" ;
  imitering_nn_1_N = mkN "imitering" ;
  immatrikulering_nn_1_N = mkN "immatrikulering" ;
  immigrering_nn_1_N = mkN "immigrering" ;
  immunbristsjukdom_nn_1_N = mkN "immunbristsjukdom" ;
  immunisering_nn_1_N = mkN "immunisering" ;
  implicering_nn_1_N = mkN "implicering" ;
  implodering_nn_1_N = mkN "implodering" ;
  imponering_nn_1_N = mkN "imponering" ;
  importering_nn_1_N = mkN "importering" ;
  impregnering_nn_1_N = mkN "impregnering" ;
  improvisering_nn_1_N = mkN "improvisering" ;
  inackordering_nn_1_N = mkN "inackordering" ;
  inandning_nn_1_N = mkN "inandning" ;
  inaugurering_nn_1_N = mkN "inaugurering" ;
  inberaekning_nn_1_1_N = mkN "inberäkning" ;
  inbesparing_nn_1_N = mkN "inbesparing" ;
  inbetalning_nn_1_N = mkN "inbetalning" ;
  inbillning_nn_1_N = mkN "inbillning" ;
  inbjudning_nn_1_N = mkN "inbjudning" ;
  inblandning_nn_1_N = mkN "inblandning" ;
  inblick_nn_1_N = mkN "inblick" ;
  inbokning_nn_1_N = mkN "inbokning" ;
  inbromsning_nn_1_N = mkN "inbromsning" ;
  inbrytning_nn_1_N = mkN "inbrytning" ;
  inbuktning_nn_1_N = mkN "inbuktning" ;
  inburning_nn_1_N = mkN "inburning" ;
  indelning_nn_1_N = mkN "indelning" ;
  indexering_nn_1_N = mkN "indexering" ;
  indexreglering_nn_1_N = mkN "indexreglering" ;
  indianhoevding_nn_1_1_N = mkN "indianhövding" ;
  indicering_nn_1_N = mkN "indicering" ;
  indikering_nn_1_N = mkN "indikering" ;
  individualisering_nn_1_N = mkN "individualisering" ;
  indoktrinering_nn_1_N = mkN "indoktrinering" ;
  indragning_nn_1_N = mkN "indragning" ;
  indrivning_nn_1_N = mkN "indrivning" ;
  indraenkning_nn_1_1_N = mkN "indränkning" ;
  inducering_nn_1_N = mkN "inducering" ;
  indunstning_nn_1_N = mkN "indunstning" ;
  industrialisering_nn_1_N = mkN "industrialisering" ;
  infartsport_nn_1_N = mkN "infartsport" ;
  infattning_nn_1_N = mkN "infattning" ;
  infektering_nn_1_N = mkN "infektering" ;
  infektionssjukdom_nn_1_N = mkN "infektionssjukdom" ;
  infiltrering_nn_1_N = mkN "infiltrering" ;
  inflammering_nn_1_N = mkN "inflammering" ;
  inflickning_nn_1_N = mkN "inflickning" ;
  influering_nn_1_N = mkN "influering" ;
  inflygning_nn_1_N = mkN "inflygning" ;
  inflyttning_nn_1_N = mkN "inflyttning" ;
  inflaetning_nn_1_1_N = mkN "inflätning" ;
  infogning_nn_1_N = mkN "infogning" ;
  infordring_nn_1_N = mkN "infordring" ;
  informationsbehandling_nn_1_N = mkN "informationsbehandling" ;
  informationssoekning_nn_1_1_N = mkN "informationssökning" ;
  informering_nn_1_N = mkN "informering" ;
  infragrill_nn_1_N = mkN "infragrill" ;
  infrastruktursatsning_nn_1_N = mkN "infrastruktursatsning" ;
  infrysning_nn_1_N = mkN "infrysning" ;
  infaestning_nn_1_1_N = mkN "infästning" ;
  infoerlivning_nn_1_1_N = mkN "införlivning" ;
  ingenjoersutbildning_nn_1_1_N = mkN "ingenjörsutbildning" ;
  ingjutning_nn_1_N = mkN "ingjutning" ;
  ingravering_nn_1_N = mkN "ingravering" ;
  ingaang_nn_1_1_N = mkN "ingång" ;
  ingaangsdoerr_nn_1_1_N = mkN "ingångsdörr" ;
  ingaangsspaenning_nn_1_1_N = mkN "ingångsspänning" ;
  inhalering_nn_1_N = mkN "inhalering" ;
  inhibering_nn_1_N = mkN "inhibering" ;
  inhibitering_nn_1_N = mkN "inhibitering" ;
  inhuggning_nn_1_N = mkN "inhuggning" ;
  inhysning_nn_1_N = mkN "inhysning" ;
  inhoestning_nn_1_1_N = mkN "inhöstning" ;
  initiering_nn_1_N = mkN "initiering" ;
  injektering_nn_1_N = mkN "injektering" ;
  injektionsnaal_nn_1_1_N = mkN "injektionsnål" ;
  injicering_nn_1_N = mkN "injicering" ;
  inkapsling_nn_1_N = mkN "inkapsling" ;
  inkarnering_nn_1_N = mkN "inkarnering" ;
  inkassering_nn_1_N = mkN "inkassering" ;
  inklarering_nn_1_N = mkN "inklarering" ;
  inkludering_nn_1_N = mkN "inkludering" ;
  inkomstbeskattning_nn_1_N = mkN "inkomstbeskattning" ;
  inkomstskattesaenkning_nn_1_1_N = mkN "inkomstskattesänkning" ;
  inkomsttaxering_nn_1_N = mkN "inkomsttaxering" ;
  inkomstoekning_nn_1_1_N = mkN "inkomstökning" ;
  inkoppling_nn_1_N = mkN "inkoppling" ;
  inkorg_nn_1_N = mkN "inkorg" ;
  inkorporering_nn_1_N = mkN "inkorporering" ;
  inkraektning_nn_1_1_N = mkN "inkräktning" ;
  inkvartering_nn_1_N = mkN "inkvartering" ;
  inkoepsavdelning_nn_1_1_N = mkN "inköpsavdelning" ;
  inkoerning_nn_1_1_N = mkN "inkörning" ;
  inkoersport_nn_1_1_N = mkN "inkörsport" ;
  inlasning_nn_1_N = mkN "inlasning" ;
  inledning_nn_1_N = mkN "inledning" ;
  inlindning_nn_1_N = mkN "inlindning" ;
  inloggning_nn_1_N = mkN "inloggning" ;
  inlaeggning_nn_1_1_N = mkN "inläggning" ;
  inlaemning_nn_1_1_N = mkN "inlämning" ;
  inlaerning_nn_1_1_N = mkN "inlärning" ;
  inlaesning_nn_1_1_N = mkN "inläsning" ;
  inlaaning_nn_1_1_N = mkN "inlåning" ;
  inlaasning_nn_1_1_N = mkN "inlåsning" ;
  inloepning_nn_1_1_N = mkN "inlöpning" ;
  inloesning_nn_1_1_N = mkN "inlösning" ;
  inmatning_nn_1_N = mkN "inmatning" ;
  inmutning_nn_1_N = mkN "inmutning" ;
  inmaengning_nn_1_1_N = mkN "inmängning" ;
  inmaetning_nn_1_1_N = mkN "inmätning" ;
  inmoenstring_nn_1_1_N = mkN "inmönstring" ;
  innanlaesning_nn_1_1_N = mkN "innanläsning" ;
  innehaallning_nn_1_1_N = mkN "innehållning" ;
  innehaallsfoerteckning_nn_1_1_N = mkN "innehållsförteckning" ;
  innekrog_nn_1_N = mkN "innekrog" ;
  innerdoerr_nn_1_1_N = mkN "innerdörr" ;
  innerslang_nn_1_N = mkN "innerslang" ;
  innervering_nn_1_N = mkN "innervering" ;
  innervaegg_nn_1_1_N = mkN "innervägg" ;
  inneslutning_nn_1_N = mkN "inneslutning" ;
  innoetning_nn_1_1_N = mkN "innötning" ;
  inokulering_nn_1_N = mkN "inokulering" ;
  inoljning_nn_1_N = mkN "inoljning" ;
  inomhusbelysning_nn_1_N = mkN "inomhusbelysning" ;
  inomhusforskning_nn_1_N = mkN "inomhusforskning" ;
  inpackning_nn_1_N = mkN "inpackning" ;
  inpassning_nn_1_N = mkN "inpassning" ;
  inpetning_nn_1_N = mkN "inpetning" ;
  inplantering_nn_1_N = mkN "inplantering" ;
  inplantning_nn_1_N = mkN "inplantning" ;
  inpluggning_nn_1_N = mkN "inpluggning" ;
  inpressning_nn_1_N = mkN "inpressning" ;
  inpraentning_nn_1_1_N = mkN "inpräntning" ;
  inramning_nn_1_N = mkN "inramning" ;
  inrangering_nn_1_N = mkN "inrangering" ;
  inrapportering_nn_1_N = mkN "inrapportering" ;
  inredning_nn_1_N = mkN "inredning" ;
  inregistrering_nn_1_N = mkN "inregistrering" ;
  inridning_nn_1_N = mkN "inridning" ;
  inrikesavgaang_nn_1_1_N = mkN "inrikesavgång" ;
  inriktning_nn_1_N = mkN "inriktning" ;
  inristning_nn_1_N = mkN "inristning" ;
  inropning_nn_1_N = mkN "inropning" ;
  inrusning_nn_1_N = mkN "inrusning" ;
  inryckning_nn_1_N = mkN "inryckning" ;
  inrymning_nn_1_N = mkN "inrymning" ;
  inraekning_nn_1_1_N = mkN "inräkning" ;
  inraettning_nn_1_1_N = mkN "inrättning" ;
  inroestning_nn_1_1_N = mkN "inröstning" ;
  insamling_nn_1_N = mkN "insamling" ;
  inscenering_nn_1_N = mkN "inscenering" ;
  insegling_nn_1_N = mkN "insegling" ;
  insektsbefruktning_nn_1_N = mkN "insektsbefruktning" ;
  insektssamling_nn_1_N = mkN "insektssamling" ;
  inseminering_nn_1_N = mkN "inseminering" ;
  insinuering_nn_1_N = mkN "insinuering" ;
  insistering_nn_1_N = mkN "insistering" ;
  insjungning_nn_1_N = mkN "insjungning" ;
  inskeppning_nn_1_N = mkN "inskeppning" ;
  inskjutning_nn_1_N = mkN "inskjutning" ;
  inskolning_nn_1_N = mkN "inskolning" ;
  inskrivning_nn_1_N = mkN "inskrivning" ;
  inskrivningsdag_nn_1_N = mkN "inskrivningsdag" ;
  inskraenkning_nn_1_1_N = mkN "inskränkning" ;
  inskaerning_nn_1_1_N = mkN "inskärning" ;
  inskaerpning_nn_1_1_N = mkN "inskärpning" ;
  insmuggling_nn_1_N = mkN "insmuggling" ;
  insmygning_nn_1_N = mkN "insmygning" ;
  insmoerjning_nn_1_1_N = mkN "insmörjning" ;
  inspark_nn_1_N = mkN "inspark" ;
  inspektering_nn_1_N = mkN "inspektering" ;
  inspelning_nn_1_N = mkN "inspelning" ;
  inspelningsknapp_nn_1_N = mkN "inspelningsknapp" ;
  inspirering_nn_1_N = mkN "inspirering" ;
  insprutning_nn_1_N = mkN "insprutning" ;
  inspaerrning_nn_1_1_N = mkN "inspärrning" ;
  installationsfoerelaesning_nn_1_1_N = mkN "installationsföreläsning" ;
  installering_nn_1_N = mkN "installering" ;
  instiftning_nn_1_N = mkN "instiftning" ;
  institutionalisering_nn_1_N = mkN "institutionalisering" ;
  instoppning_nn_1_N = mkN "instoppning" ;
  instroduktionsfoerelaesning_nn_1_1_N = mkN "instroduktionsföreläsning" ;
  instruering_nn_1_N = mkN "instruering" ;
  instrumentbelysning_nn_1_N = mkN "instrumentbelysning" ;
  instrumentering_nn_1_N = mkN "instrumentering" ;
  instrumentflygning_nn_1_N = mkN "instrumentflygning" ;
  instraalning_nn_1_1_N = mkN "instrålning" ;
  instudering_nn_1_N = mkN "instudering" ;
  instuvning_nn_1_N = mkN "instuvning" ;
  instaellning_nn_1_1_N = mkN "inställning" ;
  instaengning_nn_1_1_N = mkN "instängning" ;
  insugning_nn_1_N = mkN "insugning" ;
  insupning_nn_1_N = mkN "insupning" ;
  insvepning_nn_1_N = mkN "insvepning" ;
  insvaengning_nn_1_1_N = mkN "insvängning" ;
  insyltning_nn_1_N = mkN "insyltning" ;
  insaendning_nn_1_1_N = mkN "insändning" ;
  insaettning_nn_1_1_N = mkN "insättning" ;
  insoendring_nn_1_1_N = mkN "insöndring" ;
  intagning_nn_1_N = mkN "intagning" ;
  intagningshandling_nn_1_N = mkN "intagningshandling" ;
  intagsdamm_nn_1_N = mkN "intagsdamm" ;
  intalning_nn_1_N = mkN "intalning" ;
  inteckning_nn_1_N = mkN "inteckning" ;
  integralhjaelm_nn_1_1_N = mkN "integralhjälm" ;
  integrering_nn_1_N = mkN "integrering" ;
  intellektualisering_nn_1_N = mkN "intellektualisering" ;
  intelligensmaetning_nn_1_1_N = mkN "intelligensmätning" ;
  intensifiering_nn_1_N = mkN "intensifiering" ;
  intensivering_nn_1_N = mkN "intensivering" ;
  intensivundersoekning_nn_1_1_N = mkN "intensivundersökning" ;
  intensivvaardsavdelning_nn_1_1_N = mkN "intensivvårdsavdelning" ;
  intensivvaardsutrustning_nn_1_1_N = mkN "intensivvårdsutrustning" ;
  interagering_nn_1_N = mkN "interagering" ;
  interferering_nn_1_N = mkN "interferering" ;
  interfoliering_nn_1_N = mkN "interfoliering" ;
  interimsregering_nn_1_N = mkN "interimsregering" ;
  interioerbelysning_nn_1_1_N = mkN "interiörbelysning" ;
  internalisering_nn_1_N = mkN "internalisering" ;
  internationalisering_nn_1_N = mkN "internationalisering" ;
  internering_nn_1_N = mkN "internering" ;
  internutbildning_nn_1_N = mkN "internutbildning" ;
  internutredning_nn_1_N = mkN "internutredning" ;
  interpellering_nn_1_N = mkN "interpellering" ;
  interpolering_nn_1_N = mkN "interpolering" ;
  interpretering_nn_1_N = mkN "interpretering" ;
  interpunktering_nn_1_N = mkN "interpunktering" ;
  intervenering_nn_1_N = mkN "intervenering" ;
  intervjuundersoekning_nn_1_1_N = mkN "intervjuundersökning" ;
  intimitetsstoerning_nn_1_1_N = mkN "intimitetsstörning" ;
  intonering_nn_1_N = mkN "intonering" ;
  intorkning_nn_1_N = mkN "intorkning" ;
  intressering_nn_1_N = mkN "intressering" ;
  intrigering_nn_1_N = mkN "intrigering" ;
  intrimning_nn_1_N = mkN "intrimning" ;
  introducering_nn_1_N = mkN "introducering" ;
  intraengling_nn_1_1_N = mkN "inträngling" ;
  intumning_nn_1_N = mkN "intumning" ;
  intvaalning_nn_1_1_N = mkN "intvålning" ;
  invadering_nn_1_N = mkN "invadering" ;
  invalidisering_nn_1_N = mkN "invalidisering" ;
  invandrarbefolkning_nn_1_N = mkN "invandrarbefolkning" ;
  invandring_nn_1_N = mkN "invandring" ;
  invandringsvaeg_nn_1_1_N = mkN "invandringsväg" ;
  inventariefoerteckning_nn_1_1_N = mkN "inventarieförteckning" ;
  inventering_nn_1_N = mkN "inventering" ;
  inverkning_nn_1_N = mkN "inverkning" ;
  invertering_nn_1_N = mkN "invertering" ;
  investering_nn_1_N = mkN "investering" ;
  invigning_nn_1_N = mkN "invigning" ;
  invintring_nn_1_N = mkN "invintring" ;
  invitering_nn_1_N = mkN "invitering" ;
  involvering_nn_1_N = mkN "involvering" ;
  invaegning_nn_1_1_N = mkN "invägning" ;
  invaendning_nn_1_1_N = mkN "invändning" ;
  invaentning_nn_1_1_N = mkN "inväntning" ;
  invaevning_nn_1_1_N = mkN "invävning" ;
  inympning_nn_1_N = mkN "inympning" ;
  inoevning_nn_1_1_N = mkN "inövning" ;
  irisering_nn_1_N = mkN "irisering" ;
  ironisering_nn_1_N = mkN "ironisering" ;
  irrgaang_nn_1_1_N = mkN "irrgång" ;
  irritering_nn_1_N = mkN "irritering" ;
  isbildning_nn_1_N = mkN "isbildning" ;
  isbit_nn_1_N = mkN "isbit" ;
  isbjoern_nn_1_1_N = mkN "isbjörn" ;
  isbrytning_nn_1_N = mkN "isbrytning" ;
  iscensaettning_nn_1_1_N = mkN "iscensättning" ;
  ishink_nn_1_N = mkN "ishink" ;
  isklump_nn_1_N = mkN "isklump" ;
  iskravning_nn_1_N = mkN "iskravning" ;
  islossning_nn_1_N = mkN "islossning" ;
  islaenning_nn_1_1_N = mkN "islänning" ;
  isolering_nn_1_N = mkN "isolering" ;
  isoleringsavdelning_nn_1_N = mkN "isoleringsavdelning" ;
  isotopmaetning_nn_1_1_N = mkN "isotopmätning" ;
  ispropp_nn_1_N = mkN "ispropp" ;
  isskruvning_nn_1_N = mkN "isskruvning" ;
  issmaeltning_nn_1_1_N = mkN "issmältning" ;
  istaandsaettning_nn_1_1_N = mkN "iståndsättning" ;
  isvarning_nn_1_N = mkN "isvarning" ;
  isvind_nn_1_N = mkN "isvind" ;
  isaelv_nn_1_1_N = mkN "isälv" ;
  isaettning_nn_1_1_N = mkN "isättning" ;
  iterering_nn_1_N = mkN "iterering" ;
  jabirustork_nn_1_N = mkN "jabirustork" ;
  jagfoerestaellning_nn_1_1_N = mkN "jagföreställning" ;
  jagupploesning_nn_1_1_N = mkN "jagupplösning" ;
  jaktfoerordning_nn_1_1_N = mkN "jaktförordning" ;
  jaktkniv_nn_1_N = mkN "jaktkniv" ;
  jaktridning_nn_1_N = mkN "jaktridning" ;
  jamning_nn_1_N = mkN "jamning" ;
  jantelag_nn_1_N = mkN "jantelag" ;
  jazzifiering_nn_1_N = mkN "jazzifiering" ;
  jethjaelm_nn_1_1_N = mkN "jethjälm" ;
  jobbskattesaenkning_nn_1_1_N = mkN "jobbskattesänkning" ;
  jodering_nn_1_N = mkN "jodering" ;
  joggling_nn_1_N = mkN "joggling" ;
  jonbildning_nn_1_N = mkN "jonbildning" ;
  jonbindning_nn_1_N = mkN "jonbindning" ;
  jonfoerening_nn_1_1_N = mkN "jonförening" ;
  jonglering_nn_1_N = mkN "jonglering" ;
  jonisering_nn_1_N = mkN "jonisering" ;
  jordavsoendring_nn_1_1_N = mkN "jordavsöndring" ;
  jordbegravning_nn_1_N = mkN "jordbegravning" ;
  jordbruksbefolkning_nn_1_N = mkN "jordbruksbefolkning" ;
  jordbaevning_nn_1_1_N = mkN "jordbävning" ;
  jorddelning_nn_1_N = mkN "jorddelning" ;
  jordegendom_nn_1_N = mkN "jordegendom" ;
  jordflytning_nn_1_N = mkN "jordflytning" ;
  jordfaestning_nn_1_1_N = mkN "jordfästning" ;
  jordfoerbaettring_nn_1_1_N = mkN "jordförbättring" ;
  jordfoerstoering_nn_1_1_N = mkN "jordförstöring" ;
  jordledning_nn_1_N = mkN "jordledning" ;
  jordutdelning_nn_1_N = mkN "jordutdelning" ;
  jordvall_nn_1_N = mkN "jordvall" ;
  jordvaerdestegring_nn_1_1_N = mkN "jordvärdestegring" ;
  jubilering_nn_1_N = mkN "jubilering" ;
  judasgaerning_nn_1_1_N = mkN "judasgärning" ;
  judendom_nn_1_N = mkN "judendom" ;
  julbelysning_nn_1_N = mkN "julbelysning" ;
  julgransbelysning_nn_1_N = mkN "julgransbelysning" ;
  julgransplundring_nn_1_N = mkN "julgransplundring" ;
  julskyltning_nn_1_N = mkN "julskyltning" ;
  jultallrik_nn_1_N = mkN "jultallrik" ;
  jultidning_nn_1_N = mkN "jultidning" ;
  jungfrualstring_nn_1_N = mkN "jungfrualstring" ;
  jungfrudom_nn_1_N = mkN "jungfrudom" ;
  justerarm_nn_1_N = mkN "justerarm" ;
  justering_nn_1_N = mkN "justering" ;
  jyllaenning_nn_1_1_N = mkN "jyllänning" ;
  jaegarbefolkning_nn_1_1_N = mkN "jägarbefolkning" ;
  jaegarhatt_nn_1_1_N = mkN "jägarhatt" ;
  jaemkning_nn_1_1_N = mkN "jämkning" ;
  jaemtlaenning_nn_1_1_N = mkN "jämtlänning" ;
  jaerndoerr_nn_1_1_N = mkN "järndörr" ;
  jaernframstaellning_nn_1_1_N = mkN "järnframställning" ;
  jaerngrind_nn_1_1_N = mkN "järngrind" ;
  jaernhantering_nn_1_1_N = mkN "järnhantering" ;
  jaernhaell_nn_1_1_N = mkN "järnhäll" ;
  jaernklump_nn_1_1_N = mkN "järnklump" ;
  jaernlegering_nn_1_1_N = mkN "järnlegering" ;
  jaernring_nn_1_1_N = mkN "järnring" ;
  jaerntillverkning_nn_1_1_N = mkN "järntillverkning" ;
  jaerntraad_nn_1_1_N = mkN "järntråd" ;
  jaernvaeg_nn_1_1_N = mkN "järnväg" ;
  jaernvaegsinvestering_nn_1_1_N = mkN "järnvägsinvestering" ;
  jaernvaegsknut_nn_1_1_N = mkN "järnvägsknut" ;
  jaernvaegskorsning_nn_1_1_N = mkN "järnvägskorsning" ;
  jaernvaegsvagn_nn_1_1_N = mkN "järnvägsvagn" ;
  jaernvaegsoevergaang_nn_1_1_N = mkN "järnvägsövergång" ;
  jaesning_nn_1_1_N = mkN "jäsning" ;
  jaetteflopp_nn_1_1_N = mkN "jätteflopp" ;
  jaetteorm_nn_1_1_N = mkN "jätteorm" ;
  jaettesockerbit_nn_1_1_N = mkN "jättesockerbit" ;
  joekelport_nn_1_1_N = mkN "jökelport" ;
  kabelgenomfoering_nn_1_1_N = mkN "kabelgenomföring" ;
  kaderoevning_nn_1_1_N = mkN "kaderövning" ;
  kaffeersaettning_nn_1_1_N = mkN "kaffeersättning" ;
  kaffeflaeck_nn_1_1_N = mkN "kaffefläck" ;
  kaffekokning_nn_1_N = mkN "kaffekokning" ;
  kaffekvarn_nn_1_N = mkN "kaffekvarn" ;
  kaffeservering_nn_1_N = mkN "kaffeservering" ;
  kaffesked_nn_1_N = mkN "kaffesked" ;
  kafkastaemning_nn_1_1_N = mkN "kafkastämning" ;
  kajskoning_nn_1_N = mkN "kajskoning" ;
  kakburk_nn_1_N = mkN "kakburk" ;
  kakelugn_nn_1_N = mkN "kakelugn" ;
  kakform_nn_1_N = mkN "kakform" ;
  kalandrering_nn_1_N = mkN "kalandrering" ;
  kalcinering_nn_1_N = mkN "kalcinering" ;
  kalenderfotografering_nn_1_N = mkN "kalenderfotografering" ;
  kalfatring_nn_1_N = mkN "kalfatring" ;
  kalibrering_nn_1_N = mkN "kalibrering" ;
  kalibreringsknapp_nn_1_N = mkN "kalibreringsknapp" ;
  kalkanhopning_nn_1_N = mkN "kalkanhopning" ;
  kalkering_nn_1_N = mkN "kalkering" ;
  kalkmaalning_nn_1_1_N = mkN "kalkmålning" ;
  kalkstenshaell_nn_1_1_N = mkN "kalkstenshäll" ;
  kalkstenskaak_nn_1_1_N = mkN "kalkstenskåk" ;
  kalkstensvaegg_nn_1_1_N = mkN "kalkstensvägg" ;
  kalkylering_nn_1_N = mkN "kalkylering" ;
  kallelsegaerning_nn_1_1_N = mkN "kallelsegärning" ;
  kallmur_nn_1_N = mkN "kallmur" ;
  kallsaag_nn_1_1_N = mkN "kallsåg" ;
  kalluftsflaekt_nn_1_1_N = mkN "kalluftsfläkt" ;
  kalmering_nn_1_N = mkN "kalmering" ;
  kalvkyckling_nn_1_N = mkN "kalvkyckling" ;
  kalvlaegg_nn_1_1_N = mkN "kalvlägg" ;
  kalvning_nn_1_N = mkN "kalvning" ;
  kalvstek_nn_1_N = mkN "kalvstek" ;
  kalvstaellning_nn_1_1_N = mkN "kalvställning" ;
  kamelforskning_nn_1_N = mkN "kamelforskning" ;
  kammarskjutning_nn_1_N = mkN "kammarskjutning" ;
  kammarskruv_nn_1_N = mkN "kammarskruv" ;
  kamning_nn_1_N = mkN "kamning" ;
  kamouflering_nn_1_N = mkN "kamouflering" ;
  kampanjraekning_nn_1_1_N = mkN "kampanjräkning" ;
  kampering_nn_1_N = mkN "kampering" ;
  kamphund_nn_1_N = mkN "kamphund" ;
  kamratpaaverkning_nn_1_1_N = mkN "kamratpåverkning" ;
  kanalbaat_nn_1_1_N = mkN "kanalbåt" ;
  kanalisering_nn_1_N = mkN "kanalisering" ;
  kanalkrock_nn_1_N = mkN "kanalkrock" ;
  kandering_nn_1_N = mkN "kandering" ;
  kandidering_nn_1_N = mkN "kandidering" ;
  kannelering_nn_1_N = mkN "kannelering" ;
  kanonbaat_nn_1_1_N = mkN "kanonbåt" ;
  kanonisering_nn_1_N = mkN "kanonisering" ;
  kanonlock_nn_1_N = mkN "kanonlock" ;
  kanonport_nn_1_N = mkN "kanonport" ;
  kanthuggning_nn_1_N = mkN "kanthuggning" ;
  kantklippning_nn_1_N = mkN "kantklippning" ;
  kapacitetshoejning_nn_1_1_N = mkN "kapacitetshöjning" ;
  kapacitetsoekning_nn_1_1_N = mkN "kapacitetsökning" ;
  kapitalavkastning_nn_1_N = mkN "kapitalavkastning" ;
  kapitalbeskattning_nn_1_N = mkN "kapitalbeskattning" ;
  kapitalbildning_nn_1_N = mkN "kapitalbildning" ;
  kapitalfoerstoering_nn_1_1_N = mkN "kapitalförstöring" ;
  kapitalfoersaekring_nn_1_1_N = mkN "kapitalförsäkring" ;
  kapitalinkomstbeskattning_nn_1_N = mkN "kapitalinkomstbeskattning" ;
  kapitalinvestering_nn_1_N = mkN "kapitalinvestering" ;
  kapitalisering_nn_1_N = mkN "kapitalisering" ;
  kapitalplacering_nn_1_N = mkN "kapitalplacering" ;
  kapitelindelning_nn_1_N = mkN "kapitelindelning" ;
  kapitelsal_nn_1_N = mkN "kapitelsal" ;
  kapitulering_nn_1_N = mkN "kapitulering" ;
  kapning_nn_1_N = mkN "kapning" ;
  kappkoerning_nn_1_1_N = mkN "kappkörning" ;
  kapploepning_nn_1_1_N = mkN "kapplöpning" ;
  kapprustning_nn_1_N = mkN "kapprustning" ;
  kappsegling_nn_1_N = mkN "kappsegling" ;
  kappsimning_nn_1_N = mkN "kappsimning" ;
  kappvaendning_nn_1_1_N = mkN "kappvändning" ;
  kapsling_nn_1_N = mkN "kapsling" ;
  kapsaag_nn_1_1_N = mkN "kapsåg" ;
  karakolering_nn_1_N = mkN "karakolering" ;
  karakterisering_nn_1_N = mkN "karakterisering" ;
  karaktaerisering_nn_1_1_N = mkN "karaktärisering" ;
  karaktaersfoerdjupning_nn_1_1_N = mkN "karaktärsfördjupning" ;
  karaktaersskildring_nn_1_1_N = mkN "karaktärsskildring" ;
  karambolering_nn_1_N = mkN "karambolering" ;
  karatering_nn_1_N = mkN "karatering" ;
  karatespark_nn_1_N = mkN "karatespark" ;
  karborundumduk_nn_1_N = mkN "karborundumduk" ;
  kardanknut_nn_1_N = mkN "kardanknut" ;
  kardanupphaengning_nn_1_1_N = mkN "kardanupphängning" ;
  kardborreknaeppning_nn_1_1_N = mkN "kardborreknäppning" ;
  karensdag_nn_1_N = mkN "karensdag" ;
  karikering_nn_1_N = mkN "karikering" ;
  karmskruv_nn_1_N = mkN "karmskruv" ;
  karmstol_nn_1_N = mkN "karmstol" ;
  karriaerfoersaekring_nn_1_1_N = mkN "karriärförsäkring" ;
  karriaervaeg_nn_1_1_N = mkN "karriärväg" ;
  karstbildning_nn_1_N = mkN "karstbildning" ;
  kartanteckning_nn_1_N = mkN "kartanteckning" ;
  kartering_nn_1_N = mkN "kartering" ;
  kartlaeggning_nn_1_1_N = mkN "kartläggning" ;
  kartlaesning_nn_1_1_N = mkN "kartläsning" ;
  kartonnering_nn_1_N = mkN "kartonnering" ;
  karvstock_nn_1_N = mkN "karvstock" ;
  kaskadkoppling_nn_1_N = mkN "kaskadkoppling" ;
  kaskofoersaekring_nn_1_1_N = mkN "kaskoförsäkring" ;
  kassabehaallning_nn_1_1_N = mkN "kassabehållning" ;
  kassationsdomstol_nn_1_N = mkN "kassationsdomstol" ;
  kassering_nn_1_N = mkN "kassering" ;
  kastning_nn_1_N = mkN "kastning" ;
  kastrering_nn_1_N = mkN "kastrering" ;
  kastvind_nn_1_N = mkN "kastvind" ;
  kasusanvaendning_nn_1_1_N = mkN "kasusanvändning" ;
  katalogisering_nn_1_N = mkN "katalogisering" ;
  katalysering_nn_1_N = mkN "katalysering" ;
  katapultstol_nn_1_N = mkN "katapultstol" ;
  katastrofvarning_nn_1_N = mkN "katastrofvarning" ;
  katederundervisning_nn_1_N = mkN "katederundervisning" ;
  kategoriklyvning_nn_1_N = mkN "kategoriklyvning" ;
  kategorisering_nn_1_N = mkN "kategorisering" ;
  kateterisering_nn_1_N = mkN "kateterisering" ;
  katetrisering_nn_1_N = mkN "katetrisering" ;
  kattskit_nn_1_N = mkN "kattskit" ;
  kauterisering_nn_1_N = mkN "kauterisering" ;
  kedjefoering_nn_1_1_N = mkN "kedjeföring" ;
  kedjesaag_nn_1_1_N = mkN "kedjesåg" ;
  kejsaroern_nn_1_1_N = mkN "kejsarörn" ;
  kemtvaett_nn_1_1_N = mkN "kemtvätt" ;
  keramikform_nn_1_N = mkN "keramikform" ;
  kesning_nn_1_N = mkN "kesning" ;
  kidnappning_nn_1_N = mkN "kidnappning" ;
  kilram_nn_1_N = mkN "kilram" ;
  kilspaerr_nn_1_1_N = mkN "kilspärr" ;
  kiselfoerening_nn_1_1_N = mkN "kiselförening" ;
  kittling_nn_1_N = mkN "kittling" ;
  kittning_nn_1_N = mkN "kittning" ;
  kjolfaall_nn_1_1_N = mkN "kjolfåll" ;
  klabbstroemming_nn_1_1_N = mkN "klabbströmming" ;
  klackring_nn_1_N = mkN "klackring" ;
  klackspark_nn_1_N = mkN "klackspark" ;
  klanhoevding_nn_1_1_N = mkN "klanhövding" ;
  klappning_nn_1_N = mkN "klappning" ;
  klarering_nn_1_N = mkN "klarering" ;
  klarning_nn_1_N = mkN "klarning" ;
  klassificering_nn_1_N = mkN "klassificering" ;
  klassindelning_nn_1_N = mkN "klassindelning" ;
  klasslag_nn_1_N = mkN "klasslag" ;
  klassmotsaettning_nn_1_1_N = mkN "klassmotsättning" ;
  klassundervisning_nn_1_N = mkN "klassundervisning" ;
  klatschning_nn_1_N = mkN "klatschning" ;
  klenspaenning_nn_1_1_N = mkN "klenspänning" ;
  klickning_nn_1_N = mkN "klickning" ;
  klimakteriesvallning_nn_1_N = mkN "klimakteriesvallning" ;
  klimatanlaeggning_nn_1_1_N = mkN "klimatanläggning" ;
  klimatfoeraendring_nn_1_1_N = mkN "klimatförändring" ;
  klimatsvaengning_nn_1_1_N = mkN "klimatsvängning" ;
  klimatvaersting_nn_1_1_N = mkN "klimatvärsting" ;
  klimatvaexling_nn_1_1_N = mkN "klimatväxling" ;
  klimataendring_nn_1_1_N = mkN "klimatändring" ;
  klippgrav_nn_1_N = mkN "klippgrav" ;
  klippmaalning_nn_1_1_N = mkN "klippmålning" ;
  klippning_nn_1_N = mkN "klippning" ;
  klivning_nn_1_N = mkN "klivning" ;
  kloasongvaegg_nn_1_1_N = mkN "kloasongvägg" ;
  klockarkaerlek_nn_1_1_N = mkN "klockarkärlek" ;
  klockklaepp_nn_1_1_N = mkN "klockkläpp" ;
  klockringning_nn_1_N = mkN "klockringning" ;
  klonering_nn_1_N = mkN "klonering" ;
  klorering_nn_1_N = mkN "klorering" ;
  klostermur_nn_1_N = mkN "klostermur" ;
  klostertraedgaard_nn_1_1_N = mkN "klosterträdgård" ;
  klotgrill_nn_1_N = mkN "klotgrill" ;
  klotterutredning_nn_1_N = mkN "klotterutredning" ;
  kluckning_nn_1_N = mkN "kluckning" ;
  klunkning_nn_1_N = mkN "klunkning" ;
  klyvning_nn_1_N = mkN "klyvning" ;
  klyvsaag_nn_1_1_N = mkN "klyvsåg" ;
  klyvoeppning_nn_1_1_N = mkN "klyvöppning" ;
  klaeckning_nn_1_1_N = mkN "kläckning" ;
  klaedhoeg_nn_1_1_N = mkN "klädhög" ;
  klaedkorg_nn_1_1_N = mkN "klädkorg" ;
  klaedning_nn_1_1_N = mkN "klädning" ;
  klaedseltvaett_nn_1_1_N = mkN "klädseltvätt" ;
  klaedstorlek_nn_1_1_N = mkN "klädstorlek" ;
  klaedtvaett_nn_1_1_N = mkN "klädtvätt" ;
  klaemdag_nn_1_1_N = mkN "klämdag" ;
  klaemtning_nn_1_1_N = mkN "klämtning" ;
  klaengning_nn_1_1_N = mkN "klängning" ;
  klaenning_nn_1_1_N = mkN "klänning" ;
  klaetterstaellning_nn_1_1_N = mkN "klätterställning" ;
  klaettring_nn_1_1_N = mkN "klättring" ;
  kloesning_nn_1_1_N = mkN "klösning" ;
  knackkorv_nn_1_N = mkN "knackkorv" ;
  knackning_nn_1_N = mkN "knackning" ;
  knakning_nn_1_N = mkN "knakning" ;
  knallhatt_nn_1_N = mkN "knallhatt" ;
  knappnaal_nn_1_1_N = mkN "knappnål" ;
  knapptryckning_nn_1_N = mkN "knapptryckning" ;
  knarkarbrud_nn_1_N = mkN "knarkarbrud" ;
  knarkhund_nn_1_N = mkN "knarkhund" ;
  knarkning_nn_1_N = mkN "knarkning" ;
  knarrning_nn_1_N = mkN "knarrning" ;
  knasboll_nn_1_N = mkN "knasboll" ;
  knipning_nn_1_N = mkN "knipning" ;
  knivkastning_nn_1_N = mkN "knivkastning" ;
  knivsegg_nn_1_N = mkN "knivsegg" ;
  knixning_nn_1_N = mkN "knixning" ;
  knoppning_nn_1_N = mkN "knoppning" ;
  knoppsprickning_nn_1_N = mkN "knoppsprickning" ;
  knoppsaettning_nn_1_1_N = mkN "knoppsättning" ;
  knuffning_nn_1_N = mkN "knuffning" ;
  knyckning_nn_1_N = mkN "knyckning" ;
  knyppling_nn_1_N = mkN "knyppling" ;
  knytning_nn_1_N = mkN "knytning" ;
  knaeboejning_nn_1_1_N = mkN "knäböjning" ;
  knaeckform_nn_1_1_N = mkN "knäckform" ;
  knaeckning_nn_1_1_N = mkN "knäckning" ;
  knaeppgoek_nn_1_1_N = mkN "knäppgök" ;
  knaeppning_nn_1_1_N = mkN "knäppning" ;
  knaadning_nn_1_1_N = mkN "knådning" ;
  koaffering_nn_1_N = mkN "koaffering" ;
  koagulering_nn_1_N = mkN "koagulering" ;
  koalitionsregering_nn_1_N = mkN "koalitionsregering" ;
  kodifiering_nn_1_N = mkN "kodifiering" ;
  kodvaexling_nn_1_1_N = mkN "kodväxling" ;
  kofferdamm_nn_1_N = mkN "kofferdamm" ;
  kokettering_nn_1_N = mkN "kokettering" ;
  kokkorv_nn_1_N = mkN "kokkorv" ;
  kokning_nn_1_N = mkN "kokning" ;
  kokosboll_nn_1_N = mkN "kokosboll" ;
  koksning_nn_1_N = mkN "koksning" ;
  kolbit_nn_1_N = mkN "kolbit" ;
  kolboll_nn_1_N = mkN "kolboll" ;
  koleld_nn_1_N = mkN "koleld" ;
  kolfoerening_nn_1_1_N = mkN "kolförening" ;
  kolhoeg_nn_1_1_N = mkN "kolhög" ;
  kollabering_nn_1_N = mkN "kollabering" ;
  kollaborering_nn_1_N = mkN "kollaborering" ;
  kollationering_nn_1_N = mkN "kollationering" ;
  kollekthaav_nn_1_1_N = mkN "kollekthåv" ;
  kollektivanslutning_nn_1_N = mkN "kollektivanslutning" ;
  kollektivanstaellning_nn_1_1_N = mkN "kollektivanställning" ;
  kollektivfoersaekring_nn_1_1_N = mkN "kollektivförsäkring" ;
  kollektivisering_nn_1_N = mkN "kollektivisering" ;
  kollidering_nn_1_N = mkN "kollidering" ;
  kolmonoxidfoergiftning_nn_1_1_N = mkN "kolmonoxidförgiftning" ;
  kolning_nn_1_N = mkN "kolning" ;
  kolonisering_nn_1_N = mkN "kolonisering" ;
  kolonnordning_nn_1_N = mkN "kolonnordning" ;
  kolorering_nn_1_N = mkN "kolorering" ;
  kolosfoergiftning_nn_1_1_N = mkN "kolosförgiftning" ;
  koloxidfoergiftning_nn_1_1_N = mkN "koloxidförgiftning" ;
  kolportering_nn_1_N = mkN "kolportering" ;
  koltavdelning_nn_1_N = mkN "koltavdelning" ;
  kolteckning_nn_1_N = mkN "kolteckning" ;
  koltraad_nn_1_1_N = mkN "koltråd" ;
  kombinationstaevling_nn_1_1_N = mkN "kombinationstävling" ;
  kombinering_nn_1_N = mkN "kombinering" ;
  kommatering_nn_1_N = mkN "kommatering" ;
  kommendering_nn_1_N = mkN "kommendering" ;
  kommentering_nn_1_N = mkN "kommentering" ;
  kommersialisering_nn_1_N = mkN "kommersialisering" ;
  kommitt_efoerordning_nn_1_1_N = mkN "kommittéförordning" ;
  kommunalfoervaltning_nn_1_1_N = mkN "kommunalförvaltning" ;
  kommunalisering_nn_1_N = mkN "kommunalisering" ;
  kommunallag_nn_1_N = mkN "kommunallag" ;
  kommunicering_nn_1_N = mkN "kommunicering" ;
  kommunistvaerld_nn_1_1_N = mkN "kommunistvärld" ;
  kommunledning_nn_1_N = mkN "kommunledning" ;
  kommunsammanslagning_nn_1_N = mkN "kommunsammanslagning" ;
  kommutering_nn_1_N = mkN "kommutering" ;
  komparering_nn_1_N = mkN "komparering" ;
  kompassriktning_nn_1_N = mkN "kompassriktning" ;
  kompensering_nn_1_N = mkN "kompensering" ;
  kompilering_nn_1_N = mkN "kompilering" ;
  komplettering_nn_1_N = mkN "komplettering" ;
  komplicering_nn_1_N = mkN "komplicering" ;
  komplimentering_nn_1_N = mkN "komplimentering" ;
  komponering_nn_1_N = mkN "komponering" ;
  kompositstock_nn_1_N = mkN "kompositstock" ;
  kompostering_nn_1_N = mkN "kompostering" ;
  kompostkvarn_nn_1_N = mkN "kompostkvarn" ;
  komprimering_nn_1_N = mkN "komprimering" ;
  kompromettering_nn_1_N = mkN "kompromettering" ;
  koncentrationslaesning_nn_1_1_N = mkN "koncentrationsläsning" ;
  koncentrationsstoerning_nn_1_1_N = mkN "koncentrationsstörning" ;
  koncentrering_nn_1_N = mkN "koncentrering" ;
  koncernledning_nn_1_N = mkN "koncernledning" ;
  koncessionering_nn_1_N = mkN "koncessionering" ;
  koncipiering_nn_1_N = mkN "koncipiering" ;
  kondemnering_nn_1_N = mkN "kondemnering" ;
  kondensering_nn_1_N = mkN "kondensering" ;
  konditionering_nn_1_N = mkN "konditionering" ;
  kondolering_nn_1_N = mkN "kondolering" ;
  konferenstolk_nn_1_N = mkN "konferenstolk" ;
  konferering_nn_1_N = mkN "konferering" ;
  konfirmationsklaenning_nn_1_1_N = mkN "konfirmationsklänning" ;
  konfirmationsundervisning_nn_1_N = mkN "konfirmationsundervisning" ;
  konfirmering_nn_1_N = mkN "konfirmering" ;
  konfiskering_nn_1_N = mkN "konfiskering" ;
  konflikthaerd_nn_1_1_N = mkN "konflikthärd" ;
  konfrontering_nn_1_N = mkN "konfrontering" ;
  konfundering_nn_1_N = mkN "konfundering" ;
  kongruensboejning_nn_1_1_N = mkN "kongruensböjning" ;
  kongruering_nn_1_N = mkN "kongruering" ;
  konjugering_nn_1_N = mkN "konjugering" ;
  konjunkturfoerbaettring_nn_1_1_N = mkN "konjunkturförbättring" ;
  konkludering_nn_1_N = mkN "konkludering" ;
  konkning_nn_1_N = mkN "konkning" ;
  konkretisering_nn_1_N = mkN "konkretisering" ;
  konkurrering_nn_1_N = mkN "konkurrering" ;
  konkursbevakning_nn_1_N = mkN "konkursbevakning" ;
  konsertering_nn_1_N = mkN "konsertering" ;
  konserthall_nn_1_N = mkN "konserthall" ;
  konservburk_nn_1_N = mkN "konservburk" ;
  konservering_nn_1_N = mkN "konservering" ;
  konsignering_nn_1_N = mkN "konsignering" ;
  konsolidering_nn_1_N = mkN "konsolidering" ;
  konspirering_nn_1_N = mkN "konspirering" ;
  konstatering_nn_1_N = mkN "konstatering" ;
  konstbevattning_nn_1_N = mkN "konstbevattning" ;
  konsternering_nn_1_N = mkN "konsternering" ;
  konstflygning_nn_1_N = mkN "konstflygning" ;
  konstfoerelaesning_nn_1_1_N = mkN "konstföreläsning" ;
  konstfoerening_nn_1_1_N = mkN "konstförening" ;
  konstituering_nn_1_N = mkN "konstituering" ;
  konstlaederfoerstaerkning_nn_1_1_N = mkN "konstläderförstärkning" ;
  konstmaalning_nn_1_1_N = mkN "konstmålning" ;
  konstridning_nn_1_N = mkN "konstridning" ;
  konstriktning_nn_1_N = mkN "konstriktning" ;
  konstruering_nn_1_N = mkN "konstruering" ;
  konstruktionsritning_nn_1_N = mkN "konstruktionsritning" ;
  konstsamling_nn_1_N = mkN "konstsamling" ;
  konstsatsning_nn_1_N = mkN "konstsatsning" ;
  konststil_nn_1_N = mkN "konststil" ;
  konstutstaellning_nn_1_1_N = mkN "konstutställning" ;
  konstaakning_nn_1_1_N = mkN "konståkning" ;
  konsultering_nn_1_N = mkN "konsultering" ;
  konsumentfoerening_nn_1_1_N = mkN "konsumentförening" ;
  konsumentupplysning_nn_1_N = mkN "konsumentupplysning" ;
  konsumering_nn_1_N = mkN "konsumering" ;
  kontaktledning_nn_1_N = mkN "kontaktledning" ;
  kontaminering_nn_1_N = mkN "kontaminering" ;
  kontering_nn_1_N = mkN "kontering" ;
  kontingentering_nn_1_N = mkN "kontingentering" ;
  kontorisering_nn_1_N = mkN "kontorisering" ;
  kontorsdoerr_nn_1_1_N = mkN "kontorsdörr" ;
  kontorsstol_nn_1_N = mkN "kontorsstol" ;
  kontrahering_nn_1_N = mkN "kontrahering" ;
  kontraktering_nn_1_N = mkN "kontraktering" ;
  kontraktsfoerhandling_nn_1_1_N = mkN "kontraktsförhandling" ;
  kontramandering_nn_1_N = mkN "kontramandering" ;
  kontrasignering_nn_1_N = mkN "kontrasignering" ;
  kontrastering_nn_1_N = mkN "kontrastering" ;
  kontribuering_nn_1_N = mkN "kontribuering" ;
  kontring_nn_1_N = mkN "kontring" ;
  kontrollbesiktning_nn_1_N = mkN "kontrollbesiktning" ;
  kontrollering_nn_1_N = mkN "kontrollering" ;
  kontrollfreak_nn_1_N = mkN "kontrollfreak" ;
  kontrollundersoekning_nn_1_1_N = mkN "kontrollundersökning" ;
  kontrollvaegning_nn_1_1_N = mkN "kontrollvägning" ;
  kontumaciedom_nn_1_N = mkN "kontumaciedom" ;
  konturering_nn_1_N = mkN "konturering" ;
  kontursaag_nn_1_1_N = mkN "kontursåg" ;
  konung_nn_1_N = mkN "konung" ;
  konvergering_nn_1_N = mkN "konvergering" ;
  konversering_nn_1_N = mkN "konversering" ;
  konvertering_nn_1_N = mkN "konvertering" ;
  konvojering_nn_1_N = mkN "konvojering" ;
  kooperering_nn_1_N = mkN "kooperering" ;
  koordinering_nn_1_N = mkN "koordinering" ;
  kopiering_nn_1_N = mkN "kopiering" ;
  kopparledning_nn_1_N = mkN "kopparledning" ;
  koppling_nn_1_N = mkN "koppling" ;
  koppympning_nn_1_N = mkN "koppympning" ;
  kopulering_nn_1_N = mkN "kopulering" ;
  koravslutning_nn_1_N = mkN "koravslutning" ;
  kordongskruv_nn_1_N = mkN "kordongskruv" ;
  korgboll_nn_2_N = mkN "korgboll" ;
  korgstol_nn_1_N = mkN "korgstol" ;
  korkning_nn_1_N = mkN "korkning" ;
  korkskruvslock_nn_1_N = mkN "korkskruvslock" ;
  korkskoerd_nn_1_1_N = mkN "korkskörd" ;
  korngrynsvaelling_nn_1_1_N = mkN "korngrynsvälling" ;
  korpglugg_nn_1_N = mkN "korpglugg" ;
  korpning_nn_2_N = mkN "korpning" ;
  korpussoekning_nn_1_1_N = mkN "korpussökning" ;
  korrekturlaesning_nn_1_1_N = mkN "korrekturläsning" ;
  korrelering_nn_1_N = mkN "korrelering" ;
  korrespondensundervisning_nn_1_N = mkN "korrespondensundervisning" ;
  korrespondering_nn_1_N = mkN "korrespondering" ;
  korrigering_nn_1_N = mkN "korrigering" ;
  korrodering_nn_1_N = mkN "korrodering" ;
  korrugering_nn_1_N = mkN "korrugering" ;
  korrumpering_nn_1_N = mkN "korrumpering" ;
  korruptionsraettegaang_nn_1_1_N = mkN "korruptionsrättegång" ;
  korsbefruktning_nn_1_N = mkN "korsbefruktning" ;
  korseld_nn_1_N = mkN "korseld" ;
  korsettering_nn_1_N = mkN "korsettering" ;
  korsgaang_nn_1_1_N = mkN "korsgång" ;
  korshaenvisning_nn_1_1_N = mkN "korshänvisning" ;
  korsning_nn_1_N = mkN "korsning" ;
  korsordstidning_nn_1_N = mkN "korsordstidning" ;
  korsvaeg_nn_1_1_N = mkN "korsväg" ;
  kortegebil_nn_1_N = mkN "kortegebil" ;
  kortegevaeg_nn_1_1_N = mkN "kortegeväg" ;
  kortisonbehandling_nn_1_N = mkN "kortisonbehandling" ;
  kortlek_nn_1_N = mkN "kortlek" ;
  kortling_nn_1_N = mkN "kortling" ;
  kortpassning_nn_1_N = mkN "kortpassning" ;
  kortslutning_nn_1_N = mkN "kortslutning" ;
  korttidsparkering_nn_1_N = mkN "korttidsparkering" ;
  kortvaegg_nn_1_1_N = mkN "kortvägg" ;
  kortvaagsbehandling_nn_1_1_N = mkN "kortvågsbehandling" ;
  korvstoppning_nn_1_N = mkN "korvstoppning" ;
  korvtillverkning_nn_1_N = mkN "korvtillverkning" ;
  kosing_nn_1_N = mkN "kosing" ;
  kosterbaat_nn_1_1_N = mkN "kosterbåt" ;
  kosthaallning_nn_1_1_N = mkN "kosthållning" ;
  kostig_nn_1_N = mkN "kostig" ;
  kostnadsbesparing_nn_1_N = mkN "kostnadsbesparing" ;
  kostnadsersaettning_nn_1_1_N = mkN "kostnadsersättning" ;
  kostnadsram_nn_1_N = mkN "kostnadsram" ;
  kostnadsutveckling_nn_1_N = mkN "kostnadsutveckling" ;
  kostnadsoekning_nn_1_1_N = mkN "kostnadsökning" ;
  kostymering_nn_1_N = mkN "kostymering" ;
  kotknackning_nn_1_N = mkN "kotknackning" ;
  kovaendning_nn_1_1_N = mkN "kovändning" ;
  koxning_nn_1_N = mkN "koxning" ;
  krackelering_nn_1_N = mkN "krackelering" ;
  krackning_nn_1_N = mkN "krackning" ;
  krafsning_nn_1_N = mkN "krafsning" ;
  kraftanstraengning_nn_1_1_N = mkN "kraftansträngning" ;
  kraftfoerbrukning_nn_1_1_N = mkN "kraftförbrukning" ;
  kraftfoersoerjning_nn_1_1_N = mkN "kraftförsörjning" ;
  kraftledning_nn_1_N = mkN "kraftledning" ;
  kraftmaetning_nn_1_1_N = mkN "kraftmätning" ;
  kraftsamling_nn_1_N = mkN "kraftsamling" ;
  kraftverksdamm_nn_1_N = mkN "kraftverksdamm" ;
  kraftyttring_nn_1_N = mkN "kraftyttring" ;
  kraftoeverfoering_nn_1_1_N = mkN "kraftöverföring" ;
  kragknapp_nn_1_N = mkN "kragknapp" ;
  kramning_nn_1_N = mkN "kramning" ;
  krampryckning_nn_1_N = mkN "krampryckning" ;
  kransnedlaeggning_nn_1_1_N = mkN "kransnedläggning" ;
  kratervaegg_nn_1_1_N = mkN "kratervägg" ;
  krateroeppning_nn_1_1_N = mkN "krateröppning" ;
  kravallskoeld_nn_1_1_N = mkN "kravallsköld" ;
  kravattnaal_nn_1_1_N = mkN "kravattnål" ;
  kraxning_nn_1_N = mkN "kraxning" ;
  kreatursbesaettning_nn_1_1_N = mkN "kreatursbesättning" ;
  kredensning_nn_1_N = mkN "kredensning" ;
  kreditering_nn_1_N = mkN "kreditering" ;
  kreditgivning_nn_1_N = mkN "kreditgivning" ;
  kreditupplysning_nn_1_N = mkN "kreditupplysning" ;
  kreditupplysningslag_nn_1_N = mkN "kreditupplysningslag" ;
  kreditvaerdering_nn_1_1_N = mkN "kreditvärdering" ;
  kreditaatstramning_nn_1_1_N = mkN "kreditåtstramning" ;
  kreering_nn_1_N = mkN "kreering" ;
  kremering_nn_1_N = mkN "kremering" ;
  krenelering_nn_1_N = mkN "krenelering" ;
  krepering_nn_1_N = mkN "krepering" ;
  kretsgaang_nn_1_1_N = mkN "kretsgång" ;
  kretsning_nn_1_N = mkN "kretsning" ;
  krevering_nn_1_N = mkN "krevering" ;
  krigargrav_nn_1_N = mkN "krigargrav" ;
  krigfoering_nn_1_1_N = mkN "krigföring" ;
  krigsfoerklaring_nn_1_1_N = mkN "krigsförklaring" ;
  krigsgud_nn_1_N = mkN "krigsgud" ;
  krigshaerd_nn_1_1_N = mkN "krigshärd" ;
  krigsmaalning_nn_1_1_N = mkN "krigsmålning" ;
  krigsplacering_nn_1_N = mkN "krigsplacering" ;
  krigsskildring_nn_1_N = mkN "krigsskildring" ;
  krigstjaenstgoering_nn_1_1_N = mkN "krigstjänstgöring" ;
  kriminalisering_nn_1_N = mkN "kriminalisering" ;
  kringgaerdning_nn_1_1_N = mkN "kringgärdning" ;
  kringraenning_nn_1_1_N = mkN "kringränning" ;
  kringskansning_nn_1_N = mkN "kringskansning" ;
  kringskaerning_nn_1_1_N = mkN "kringskärning" ;
  kringutrustning_nn_1_N = mkN "kringutrustning" ;
  kringvaeg_nn_1_1_N = mkN "kringväg" ;
  krishushaallning_nn_1_1_N = mkN "krishushållning" ;
  krisstaemning_nn_1_1_N = mkN "krisstämning" ;
  kristallisering_nn_1_N = mkN "kristallisering" ;
  kristendom_nn_1_N = mkN "kristendom" ;
  kristendomsundervisning_nn_1_N = mkN "kristendomsundervisning" ;
  kristning_nn_1_N = mkN "kristning" ;
  kritisering_nn_1_N = mkN "kritisering" ;
  krogsvaeng_nn_1_1_N = mkN "krogsväng" ;
  krokvaeg_nn_1_1_N = mkN "krokväg" ;
  kromosomuppsaettning_nn_1_1_N = mkN "kromosomuppsättning" ;
  kronbjudning_nn_1_N = mkN "kronbjudning" ;
  kropp_nn_1_N = mkN "kropp" ;
  kroppsfixering_nn_1_N = mkN "kroppsfixering" ;
  kroppsstorlek_nn_1_N = mkN "kroppsstorlek" ;
  kroppsstaellning_nn_1_1_N = mkN "kroppsställning" ;
  kroppsvisitering_nn_1_N = mkN "kroppsvisitering" ;
  kroppsoeppning_nn_1_1_N = mkN "kroppsöppning" ;
  kroppsoevning_nn_1_1_N = mkN "kroppsövning" ;
  krossning_nn_1_N = mkN "krossning" ;
  krusning_nn_1_N = mkN "krusning" ;
  krutkaering_nn_1_1_N = mkN "krutkäring" ;
  krutkaerring_nn_1_1_N = mkN "krutkärring" ;
  kryddbod_nn_1_N = mkN "kryddbod" ;
  kryddning_nn_1_N = mkN "kryddning" ;
  krympning_nn_1_N = mkN "krympning" ;
  kryptering_nn_1_N = mkN "kryptering" ;
  kryssning_nn_1_N = mkN "kryssning" ;
  kryssroestning_nn_1_1_N = mkN "kryssröstning" ;
  krystning_nn_1_N = mkN "krystning" ;
  krystvaerk_nn_1_1_N = mkN "krystvärk" ;
  kraekning_nn_1_1_N = mkN "kräkning" ;
  kraengning_nn_1_1_N = mkN "krängning" ;
  kraenkning_nn_1_1_N = mkN "kränkning" ;
  kroekning_nn_1_1_N = mkN "krökning" ;
  kroening_nn_1_1_N = mkN "kröning" ;
  kubering_nn_1_N = mkN "kubering" ;
  kuggning_nn_1_N = mkN "kuggning" ;
  kujonering_nn_1_N = mkN "kujonering" ;
  kukring_nn_1_N = mkN "kukring" ;
  kulknapp_nn_1_N = mkN "kulknapp" ;
  kullbyttering_nn_1_N = mkN "kullbyttering" ;
  kullkastning_nn_1_N = mkN "kullkastning" ;
  kulminering_nn_1_N = mkN "kulminering" ;
  kulram_nn_1_N = mkN "kulram" ;
  kulsprutavdelning_nn_1_N = mkN "kulsprutavdelning" ;
  kulspruteskytt_nn_1_N = mkN "kulspruteskytt" ;
  kulstoetning_nn_1_1_N = mkN "kulstötning" ;
  kulthandling_nn_1_N = mkN "kulthandling" ;
  kultivering_nn_1_N = mkN "kultivering" ;
  kulturgaerning_nn_1_1_N = mkN "kulturgärning" ;
  kulturkrock_nn_1_N = mkN "kulturkrock" ;
  kulturskymning_nn_1_N = mkN "kulturskymning" ;
  kultursnobb_nn_1_N = mkN "kultursnobb" ;
  kultursponsring_nn_1_N = mkN "kultursponsring" ;
  kulturyttring_nn_1_N = mkN "kulturyttring" ;
  kuloertvaett_nn_1_1_N = mkN "kulörtvätt" ;
  kumulering_nn_1_N = mkN "kumulering" ;
  kung_nn_1_N = mkN "kung" ;
  kunglighetsvurm_nn_1_N = mkN "kunglighetsvurm" ;
  kungsgaard_nn_1_1_N = mkN "kungsgård" ;
  kungsvaeg_nn_1_1_N = mkN "kungsväg" ;
  kungsoern_nn_1_1_N = mkN "kungsörn" ;
  kunskapslyft_nn_1_N = mkN "kunskapslyft" ;
  kupering_nn_1_N = mkN "kupering" ;
  kupolgrav_nn_1_N = mkN "kupolgrav" ;
  kup_edoerr_nn_1_1_N = mkN "kupédörr" ;
  kurering_nn_1_N = mkN "kurering" ;
  kurirsaeck_nn_1_1_N = mkN "kurirsäck" ;
  kurragoemmalek_nn_1_1_N = mkN "kurragömmalek" ;
  kurrning_nn_1_N = mkN "kurrning" ;
  kursbeskrivning_nn_1_N = mkN "kursbeskrivning" ;
  kursering_nn_1_N = mkN "kursering" ;
  kursivering_nn_1_N = mkN "kursivering" ;
  kursnotering_nn_1_N = mkN "kursnotering" ;
  kursstegring_nn_1_N = mkN "kursstegring" ;
  kursutveckling_nn_1_N = mkN "kursutveckling" ;
  kursaendring_nn_1_1_N = mkN "kursändring" ;
  kurtisering_nn_1_N = mkN "kurtisering" ;
  kurvmall_nn_1_N = mkN "kurvmall" ;
  kurvtagning_nn_1_N = mkN "kurvtagning" ;
  kustbevakning_nn_1_N = mkN "kustbevakning" ;
  kuvertering_nn_1_N = mkN "kuvertering" ;
  kvadrering_nn_1_N = mkN "kvadrering" ;
  kvalificering_nn_1_N = mkN "kvalificering" ;
  kvalitetsgranskning_nn_1_N = mkN "kvalitetsgranskning" ;
  kvalitetssaekring_nn_1_1_N = mkN "kvalitetssäkring" ;
  kvantifiering_nn_1_N = mkN "kvantifiering" ;
  kvarndamm_nn_1_N = mkN "kvarndamm" ;
  kvarsittning_nn_1_N = mkN "kvarsittning" ;
  kvartsback_nn_1_N = mkN "kvartsback" ;
  kverulering_nn_1_N = mkN "kverulering" ;
  kvicksilverfoerening_nn_1_1_N = mkN "kvicksilverförening" ;
  kvinnofridskraenkning_nn_1_1_N = mkN "kvinnofridskränkning" ;
  kvinnofoernedring_nn_1_1_N = mkN "kvinnoförnedring" ;
  kvinnograv_nn_1_N = mkN "kvinnograv" ;
  kvinnosjukdom_nn_1_N = mkN "kvinnosjukdom" ;
  kvintilering_nn_1_N = mkN "kvintilering" ;
  kvittering_nn_1_N = mkN "kvittering" ;
  kvittning_nn_1_N = mkN "kvittning" ;
  kvotering_nn_1_N = mkN "kvotering" ;
  kvotflykting_nn_1_N = mkN "kvotflykting" ;
  kvaeljning_nn_1_1_N = mkN "kväljning" ;
  kvaellning_nn_1_1_N = mkN "kvällning" ;
  kvaellsfoerelaesning_nn_1_1_N = mkN "kvällsföreläsning" ;
  kvaellstidning_nn_1_1_N = mkN "kvällstidning" ;
  kvaellsunderhaallning_nn_1_1_N = mkN "kvällsunderhållning" ;
  kvaesning_nn_1_1_N = mkN "kväsning" ;
  kvaevning_nn_1_1_N = mkN "kvävning" ;
  kylflaeck_nn_1_1_N = mkN "kylfläck" ;
  kylflaekt_nn_1_1_N = mkN "kylfläkt" ;
  kylledning_nn_1_N = mkN "kylledning" ;
  kylning_nn_1_N = mkN "kylning" ;
  kylskaapsdoerr_nn_1_1_N = mkN "kylskåpsdörr" ;
  kylvagn_nn_1_N = mkN "kylvagn" ;
  kyrkbokfoering_nn_1_1_N = mkN "kyrkbokföring" ;
  kyrkbaat_nn_1_1_N = mkN "kyrkbåt" ;
  kyrkmur_nn_1_N = mkN "kyrkmur" ;
  kyrkobokfoering_nn_1_1_N = mkN "kyrkobokföring" ;
  kyrkogaardsfoervaltning_nn_1_1_N = mkN "kyrkogårdsförvaltning" ;
  kyrkohaell_nn_1_1_N = mkN "kyrkohäll" ;
  kyrkoledning_nn_1_N = mkN "kyrkoledning" ;
  kyrkoordning_nn_1_N = mkN "kyrkoordning" ;
  kyrkotagning_nn_1_N = mkN "kyrkotagning" ;
  kyrksal_nn_1_N = mkN "kyrksal" ;
  kyrktagning_nn_1_N = mkN "kyrktagning" ;
  kyssning_nn_1_N = mkN "kyssning" ;
  kaeftsmaell_nn_1_1_N = mkN "käftsmäll" ;
  kaellarvaaning_nn_1_1_N = mkN "källarvåning" ;
  kaellfoerteckning_nn_1_1_N = mkN "källförteckning" ;
  kaellhaenvisning_nn_1_1_N = mkN "källhänvisning" ;
  kaelning_nn_1_1_N = mkN "kälning" ;
  kaendisblogg_nn_1_1_N = mkN "kändisblogg" ;
  kaendispryl_nn_1_1_N = mkN "kändispryl" ;
  kaennedom_nn_1_1_N = mkN "kännedom" ;
  kaenslovaerld_nn_1_1_N = mkN "känslovärld" ;
  kaeringknut_nn_1_1_N = mkN "käringknut" ;
  kaerlek_nn_1_1_N = mkN "kärlek" ;
  kaerleksfoerklaring_nn_1_1_N = mkN "kärleksförklaring" ;
  kaerleksgud_nn_1_1_N = mkN "kärleksgud" ;
  kaerleksgaerning_nn_1_1_N = mkN "kärleksgärning" ;
  kaerlsjukdom_nn_1_1_N = mkN "kärlsjukdom" ;
  kaernforskning_nn_1_1_N = mkN "kärnforskning" ;
  kaernklyvning_nn_1_1_N = mkN "kärnklyvning" ;
  kaernkraftsnedlaeggning_nn_1_1_N = mkN "kärnkraftsnedläggning" ;
  kaernladdning_nn_1_1_N = mkN "kärnladdning" ;
  kaernvapenbegraensning_nn_1_1_N = mkN "kärnvapenbegränsning" ;
  kaernvapenprovspraengning_nn_1_1_N = mkN "kärnvapenprovsprängning" ;
  kaerraeng_nn_1_1_N = mkN "kärräng" ;
  kaakstrykning_nn_1_1_N = mkN "kåkstrykning" ;
  kaasering_nn_1_1_N = mkN "kåsering" ;
  kaaseristil_nn_1_1_N = mkN "kåseristil" ;
  kaatbock_nn_1_1_N = mkN "kåtbock" ;
  koeksdoerr_nn_1_1_N = mkN "köksdörr" ;
  koeksflaekt_nn_1_1_N = mkN "köksfläkt" ;
  koeksingaang_nn_1_1_N = mkN "köksingång" ;
  koeksstol_nn_1_1_N = mkN "köksstol" ;
  koekssvamp_nn_1_1_N = mkN "kökssvamp" ;
  koekstraedgaard_nn_1_1_N = mkN "köksträdgård" ;
  koelapp_nn_1_1_N = mkN "kölapp" ;
  koelbaat_nn_1_1_N = mkN "kölbåt" ;
  koeldblandning_nn_1_1_N = mkN "köldblandning" ;
  koelhalning_nn_1_1_N = mkN "kölhalning" ;
  koelstraeckning_nn_1_1_N = mkN "kölsträckning" ;
  koensdiskriminering_nn_1_1_N = mkN "könsdiskriminering" ;
  koensfoerdelning_nn_1_1_N = mkN "könsfördelning" ;
  koenskvotering_nn_1_1_N = mkN "könskvotering" ;
  koenssegregering_nn_1_1_N = mkN "könssegregering" ;
  koenssjukdom_nn_1_1_N = mkN "könssjukdom" ;
  koensutjaemning_nn_1_1_N = mkN "könsutjämning" ;
  koepeskilling_nn_1_1_N = mkN "köpeskilling" ;
  koerning_nn_1_1_N = mkN "körning" ;
  koerteloeppning_nn_1_1_N = mkN "körtelöppning" ;
  koervaeg_nn_1_1_N = mkN "körväg" ;
  koettkvarn_nn_1_1_N = mkN "köttkvarn" ;
  labialisering_nn_1_N = mkN "labialisering" ;
  laborering_nn_1_N = mkN "laborering" ;
  labourregering_nn_1_N = mkN "labourregering" ;
  lackering_nn_1_N = mkN "lackering" ;
  lackning_nn_1_N = mkN "lackning" ;
  laddindicering_nn_1_N = mkN "laddindicering" ;
  laddindikering_nn_1_N = mkN "laddindikering" ;
  laddning_nn_1_N = mkN "laddning" ;
  laddram_nn_1_N = mkN "laddram" ;
  laddstock_nn_1_N = mkN "laddstock" ;
  ladugaard_nn_1_1_N = mkN "ladugård" ;
  lagberedning_nn_1_N = mkN "lagberedning" ;
  lagergaang_nn_1_1_N = mkN "lagergång" ;
  lagerkroening_nn_1_1_N = mkN "lagerkröning" ;
  lagersmatt_nn_1_N = mkN "lagersmatt" ;
  lagfaestning_nn_1_1_N = mkN "lagfästning" ;
  lagkappsimning_nn_1_N = mkN "lagkappsimning" ;
  lagning_nn_1_N = mkN "lagning" ;
  lagskipning_nn_1_N = mkN "lagskipning" ;
  lagskaerpning_nn_1_1_N = mkN "lagskärpning" ;
  lagstiftning_nn_1_N = mkN "lagstiftning" ;
  lagsoekning_nn_1_1_N = mkN "lagsökning" ;
  lagtillaempning_nn_1_1_N = mkN "lagtillämpning" ;
  laguppstaellning_nn_1_1_N = mkN "laguppställning" ;
  lagaendring_nn_1_1_N = mkN "lagändring" ;
  lagaard_nn_1_1_N = mkN "lagård" ;
  lallning_nn_1_N = mkN "lallning" ;
  lamellkoppling_nn_1_N = mkN "lamellkoppling" ;
  lamentering_nn_1_N = mkN "lamentering" ;
  laminering_nn_1_N = mkN "laminering" ;
  lammkorv_nn_1_N = mkN "lammkorv" ;
  lamning_nn_1_N = mkN "lamning" ;
  lampanordning_nn_1_N = mkN "lampanordning" ;
  landgaang_nn_1_1_N = mkN "landgång" ;
  landhoejning_nn_1_1_N = mkN "landhöjning" ;
  landkaenning_nn_1_1_N = mkN "landkänning" ;
  landning_nn_1_N = mkN "landning" ;
  landsbygdsbefolkning_nn_1_N = mkN "landsbygdsbefolkning" ;
  landsflykting_nn_1_N = mkN "landsflykting" ;
  landsfoervisning_nn_1_1_N = mkN "landsförvisning" ;
  landskapslag_nn_1_N = mkN "landskapslag" ;
  landskapsskildring_nn_1_N = mkN "landskapsskildring" ;
  landslag_nn_2_N = mkN "landslag" ;
  landstigning_nn_1_N = mkN "landstigning" ;
  landstigningsbaat_nn_1_1_N = mkN "landstigningsbåt" ;
  landsvaeg_nn_1_1_N = mkN "landsväg" ;
  landsaettning_nn_1_1_N = mkN "landsättning" ;
  landvind_nn_1_N = mkN "landvind" ;
  landvinning_nn_1_N = mkN "landvinning" ;
  langettering_nn_1_N = mkN "langettering" ;
  langning_nn_1_N = mkN "langning" ;
  lansering_nn_1_N = mkN "lansering" ;
  lantegendom_nn_1_N = mkN "lantegendom" ;
  lantgaard_nn_1_1_N = mkN "lantgård" ;
  lanthushaallning_nn_1_1_N = mkN "lanthushållning" ;
  lapisering_nn_1_N = mkN "lapisering" ;
  lapplaenning_nn_1_1_N = mkN "lapplänning" ;
  lappning_nn_1_N = mkN "lappning" ;
  lappskrivning_nn_1_N = mkN "lappskrivning" ;
  larmfoerlaeggning_nn_1_1_N = mkN "larmförläggning" ;
  larmminering_nn_1_N = mkN "larmminering" ;
  lasering_nn_1_N = mkN "lasering" ;
  laserstraalning_nn_1_1_N = mkN "laserstrålning" ;
  laskning_nn_1_N = mkN "laskning" ;
  lassning_nn_1_N = mkN "lassning" ;
  lastbil_nn_1_N = mkN "lastbil" ;
  lastbilskrock_nn_1_N = mkN "lastbilskrock" ;
  lastkran_nn_1_N = mkN "lastkran" ;
  lastning_nn_1_N = mkN "lastning" ;
  lastport_nn_1_N = mkN "lastport" ;
  lastvagn_nn_1_N = mkN "lastvagn" ;
  latexmaalning_nn_1_1_N = mkN "latexmålning" ;
  latinisering_nn_1_N = mkN "latinisering" ;
  lavering_nn_1_N = mkN "lavering" ;
  laxering_nn_1_N = mkN "laxering" ;
  laxning_nn_1_N = mkN "laxning" ;
  lcd_skaerm_nn_1_1_N = mkN "lcd-skärm" ;
  ledarbegaavning_nn_1_1_N = mkN "ledarbegåvning" ;
  ledfoerslitning_nn_1_1_N = mkN "ledförslitning" ;
  ledgaang_nn_2_1_N = mkN "ledgång" ;
  ledning_nn_1_N = mkN "ledning" ;
  ledtraad_nn_1_1_N = mkN "ledtråd" ;
  legalisering_nn_1_N = mkN "legalisering" ;
  legering_nn_1_N = mkN "legering" ;
  legitimering_nn_1_N = mkN "legitimering" ;
  legobit_nn_1_N = mkN "legobit" ;
  legotillverkning_nn_1_N = mkN "legotillverkning" ;
  lejning_nn_1_N = mkN "lejning" ;
  lekboll_nn_1_N = mkN "lekboll" ;
  lekdamm_nn_1_N = mkN "lekdamm" ;
  leksaksbil_nn_1_N = mkN "leksaksbil" ;
  leksaksbjoern_nn_1_1_N = mkN "leksaksbjörn" ;
  leksaksbaat_nn_1_1_N = mkN "leksaksbåt" ;
  lekvandring_nn_1_N = mkN "lekvandring" ;
  lemlaestning_nn_1_1_N = mkN "lemlästning" ;
  lerklining_nn_1_N = mkN "lerklining" ;
  lervaegg_nn_1_1_N = mkN "lervägg" ;
  lervaelling_nn_1_1_N = mkN "lervälling" ;
  letning_nn_1_N = mkN "letning" ;
  leverering_nn_1_N = mkN "leverering" ;
  leverskrumpning_nn_1_N = mkN "leverskrumpning" ;
  levnadsbeskrivning_nn_1_N = mkN "levnadsbeskrivning" ;
  levnadsteckning_nn_1_N = mkN "levnadsteckning" ;
  levnadsvisdom_nn_1_N = mkN "levnadsvisdom" ;
  liberalisering_nn_1_N = mkN "liberalisering" ;
  licensering_nn_1_N = mkN "licensering" ;
  licensiering_nn_1_N = mkN "licensiering" ;
  licentiering_nn_1_N = mkN "licentiering" ;
  liering_nn_1_N = mkN "liering" ;
  liggning_nn_1_N = mkN "liggning" ;
  likbesiktning_nn_1_N = mkN "likbesiktning" ;
  likfoergiftning_nn_1_1_N = mkN "likförgiftning" ;
  likhoeg_nn_1_1_N = mkN "likhög" ;
  liksiding_nn_1_N = mkN "liksiding" ;
  likskaendning_nn_1_1_N = mkN "likskändning" ;
  likspaenning_nn_1_1_N = mkN "likspänning" ;
  liksvepning_nn_1_N = mkN "liksvepning" ;
  liktyding_nn_1_N = mkN "liktyding" ;
  likvagn_nn_1_N = mkN "likvagn" ;
  likvidering_nn_1_N = mkN "likvidering" ;
  limning_nn_1_N = mkN "limning" ;
  limpaastrykning_nn_1_1_N = mkN "limpåstrykning" ;
  limring_nn_1_N = mkN "limring" ;
  limtillverkning_nn_1_N = mkN "limtillverkning" ;
  linbraakning_nn_1_1_N = mkN "linbråkning" ;
  lindning_nn_1_N = mkN "lindning" ;
  lindring_nn_1_N = mkN "lindring" ;
  linearritning_nn_1_N = mkN "linearritning" ;
  linjeblockering_nn_1_N = mkN "linjeblockering" ;
  linjefoering_nn_1_1_N = mkN "linjeföring" ;
  linjering_nn_1_N = mkN "linjering" ;
  linneduk_nn_1_N = mkN "linneduk" ;
  linneklaenning_nn_1_1_N = mkN "linneklänning" ;
  linning_nn_1_N = mkN "linning" ;
  lirkning_nn_1_N = mkN "lirkning" ;
  lissering_nn_1_N = mkN "lissering" ;
  litografering_nn_1_N = mkN "litografering" ;
  litteraturanvisning_nn_1_N = mkN "litteraturanvisning" ;
  litteraturfoerteckning_nn_1_1_N = mkN "litteraturförteckning" ;
  litteraturhaenvisning_nn_1_1_N = mkN "litteraturhänvisning" ;
  litteratursoekning_nn_1_1_N = mkN "litteratursökning" ;
  livfoersaekring_nn_1_1_N = mkN "livförsäkring" ;
  livraeddning_nn_1_1_N = mkN "livräddning" ;
  livraeddningsbaat_nn_1_1_N = mkN "livräddningsbåt" ;
  livsfoering_nn_1_1_N = mkN "livsföring" ;
  livsgaerning_nn_1_1_N = mkN "livsgärning" ;
  livshaallning_nn_1_1_N = mkN "livshållning" ;
  livslag_nn_1_N = mkN "livslag" ;
  livsmedelsfoersoerjning_nn_1_1_N = mkN "livsmedelsförsörjning" ;
  livsmedelslag_nn_1_N = mkN "livsmedelslag" ;
  livsstil_nn_1_N = mkN "livsstil" ;
  livsstilsfoeraendring_nn_1_1_N = mkN "livsstilsförändring" ;
  livstidsdom_nn_1_N = mkN "livstidsdom" ;
  livstraad_nn_1_1_N = mkN "livstråd" ;
  livsutveckling_nn_1_N = mkN "livsutveckling" ;
  livsyttring_nn_1_N = mkN "livsyttring" ;
  livsaaskaadning_nn_1_1_N = mkN "livsåskådning" ;
  ljuddaempning_nn_1_1_N = mkN "ljuddämpning" ;
  ljudfoeraendring_nn_1_1_N = mkN "ljudförändring" ;
  ljudinspelning_nn_1_N = mkN "ljudinspelning" ;
  ljudisolering_nn_1_N = mkN "ljudisolering" ;
  ljudlag_nn_1_N = mkN "ljudlag" ;
  ljudskridning_nn_1_N = mkN "ljudskridning" ;
  ljudstoet_nn_1_1_N = mkN "ljudstöt" ;
  ljudupprepning_nn_1_N = mkN "ljudupprepning" ;
  ljudupptagning_nn_1_N = mkN "ljudupptagning" ;
  ljudvall_nn_1_N = mkN "ljudvall" ;
  ljudaatergivning_nn_1_1_N = mkN "ljudåtergivning" ;
  ljudoeverfoering_nn_1_1_N = mkN "ljudöverföring" ;
  ljungeld_nn_1_N = mkN "ljungeld" ;
  ljusbehandling_nn_1_N = mkN "ljusbehandling" ;
  ljusbrytning_nn_1_N = mkN "ljusbrytning" ;
  ljusflaeck_nn_1_1_N = mkN "ljusfläck" ;
  ljushuggning_nn_1_N = mkN "ljushuggning" ;
  ljuskopiering_nn_1_N = mkN "ljuskopiering" ;
  ljusning_nn_1_N = mkN "ljusning" ;
  ljusstraalning_nn_1_1_N = mkN "ljusstrålning" ;
  ljussaettning_nn_1_1_N = mkN "ljussättning" ;
  ljusutstraalning_nn_1_1_N = mkN "ljusutstrålning" ;
  lockning_nn_1_N = mkN "lockning" ;
  lodning_nn_1_N = mkN "lodning" ;
  loftgaang_nn_1_1_N = mkN "loftgång" ;
  logering_nn_1_N = mkN "logering" ;
  lojalitetsfoerklaring_nn_1_1_N = mkN "lojalitetsförklaring" ;
  lokalavdelning_nn_1_N = mkN "lokalavdelning" ;
  lokalbedoevning_nn_1_1_N = mkN "lokalbedövning" ;
  lokalbefolkning_nn_1_N = mkN "lokalbefolkning" ;
  lokalisering_nn_1_N = mkN "lokalisering" ;
  lokalkaennedom_nn_1_1_N = mkN "lokalkännedom" ;
  lokaltidning_nn_1_N = mkN "lokaltidning" ;
  loserstil_nn_1_N = mkN "loserstil" ;
  loservaerld_nn_1_1_N = mkN "loservärld" ;
  lossning_nn_1_N = mkN "lossning" ;
  lotsbaat_nn_1_1_N = mkN "lotsbåt" ;
  lotsning_nn_1_N = mkN "lotsning" ;
  lottdragning_nn_1_N = mkN "lottdragning" ;
  lotusstaellning_nn_1_1_N = mkN "lotusställning" ;
  lovning_nn_1_N = mkN "lovning" ;
  luftbevakning_nn_1_N = mkN "luftbevakning" ;
  luftboll_nn_1_N = mkN "luftboll" ;
  luftfjaedring_nn_1_1_N = mkN "luftfjädring" ;
  luftfoerorening_nn_1_1_N = mkN "luftförorening" ;
  luftgevaersskjutning_nn_1_1_N = mkN "luftgevärsskjutning" ;
  luftkonditionering_nn_1_N = mkN "luftkonditionering" ;
  luftledning_nn_1_N = mkN "luftledning" ;
  luftning_nn_1_N = mkN "luftning" ;
  luftpump_nn_1_N = mkN "luftpump" ;
  luftrumsring_nn_1_N = mkN "luftrumsring" ;
  lufttrycksfoeraendring_nn_1_1_N = mkN "lufttrycksförändring" ;
  luftvaeg_nn_1_1_N = mkN "luftväg" ;
  luftvaermepump_nn_1_1_N = mkN "luftvärmepump" ;
  luftvaexling_nn_1_1_N = mkN "luftväxling" ;
  lumbalbedoevning_nn_1_1_N = mkN "lumbalbedövning" ;
  lumpbod_nn_1_N = mkN "lumpbod" ;
  lunchrusning_nn_1_N = mkN "lunchrusning" ;
  lungsjukdom_nn_1_N = mkN "lungsjukdom" ;
  lurpassning_nn_1_N = mkN "lurpassning" ;
  lushund_nn_1_N = mkN "lushund" ;
  luteinisering_nn_1_N = mkN "luteinisering" ;
  lutherdom_nn_1_N = mkN "lutherdom" ;
  lutning_nn_1_N = mkN "lutning" ;
  lyckoenskning_nn_1_1_N = mkN "lyckönskning" ;
  lyftanordning_nn_1_N = mkN "lyftanordning" ;
  lyftarm_nn_1_N = mkN "lyftarm" ;
  lyftkrok_nn_1_N = mkN "lyftkrok" ;
  lyftning_nn_1_N = mkN "lyftning" ;
  lynchning_nn_1_N = mkN "lynchning" ;
  lynchstaemning_nn_1_1_N = mkN "lynchstämning" ;
  lysknapp_nn_1_N = mkN "lysknapp" ;
  lysning_nn_1_N = mkN "lysning" ;
  lysningsmottagning_nn_1_N = mkN "lysningsmottagning" ;
  lystring_nn_1_N = mkN "lystring" ;
  lyxbil_nn_1_N = mkN "lyxbil" ;
  lyxfoerpackning_nn_1_1_N = mkN "lyxförpackning" ;
  lyxgaard_nn_1_1_N = mkN "lyxgård" ;
  lyxkryssning_nn_1_N = mkN "lyxkryssning" ;
  lyxpryl_nn_1_N = mkN "lyxpryl" ;
  lyxrenovering_nn_1_N = mkN "lyxrenovering" ;
  lyxvaaning_nn_1_1_N = mkN "lyxvåning" ;
  laeckerbit_nn_1_1_N = mkN "läckerbit" ;
  laedering_nn_1_1_N = mkN "lädering" ;
  laegenhetsvisning_nn_1_1_N = mkN "lägenhetsvisning" ;
  laegereld_nn_1_1_N = mkN "lägereld" ;
  laegesbestaemning_nn_1_1_N = mkN "lägesbestämning" ;
  laegesfoeraendring_nn_1_1_N = mkN "lägesförändring" ;
  laegessummering_nn_1_1_N = mkN "lägessummering" ;
  laeggning_nn_1_1_N = mkN "läggning" ;
  laekarmottagning_nn_1_1_N = mkN "läkarmottagning" ;
  laekarundersoekning_nn_1_1_N = mkN "läkarundersökning" ;
  laekedom_nn_1_1_N = mkN "läkedom" ;
  laekemedelslag_nn_1_1_N = mkN "läkemedelslag" ;
  laekning_nn_1_1_N = mkN "läkning" ;
  laemning_nn_1_1_N = mkN "lämning" ;
  laemplighetsrpoevning_nn_1_1_N = mkN "lämplighetsrpövning" ;
  laengdloepning_nn_1_1_N = mkN "längdlöpning" ;
  laengdmarkering_nn_1_1_N = mkN "längdmarkering" ;
  laengdriktning_nn_1_1_N = mkN "längdriktning" ;
  laengdutvidgning_nn_1_1_N = mkN "längdutvidgning" ;
  laengdaakning_nn_1_1_N = mkN "längdåkning" ;
  laensbeteckning_nn_1_1_N = mkN "länsbeteckning" ;
  laensning_nn_1_1_N = mkN "länsning" ;
  laenspump_nn_1_1_N = mkN "länspump" ;
  laenstol_nn_1_1_N = mkN "länstol" ;
  laensvaeg_nn_1_1_N = mkN "länsväg" ;
  laeppavlaesning_nn_1_1_N = mkN "läppavläsning" ;
  laerarfortbildning_nn_1_1_N = mkN "lärarfortbildning" ;
  laerdom_nn_1_1_N = mkN "lärdom" ;
  laerftbindning_nn_1_1_N = mkN "lärftbindning" ;
  laerling_nn_1_1_N = mkN "lärling" ;
  laerlingsutbildning_nn_1_1_N = mkN "lärlingsutbildning" ;
  laerosal_nn_1_1_N = mkN "lärosal" ;
  laesbegaavning_nn_1_1_N = mkN "läsbegåvning" ;
  laesesal_nn_1_1_N = mkN "läsesal" ;
  laesning_nn_1_1_N = mkN "läsning" ;
  laespning_nn_1_1_N = mkN "läspning" ;
  laesoevning_nn_1_1_N = mkN "läsövning" ;
  laexlaesning_nn_1_1_N = mkN "läxläsning" ;
  laaghjuling_nn_1_1_N = mkN "låghjuling" ;
  laagspaenning_nn_1_1_N = mkN "lågspänning" ;
  laaneansoekning_nn_1_1_N = mkN "låneansökning" ;
  laangboll_nn_1_1_N = mkN "långboll" ;
  laangbaenk_nn_1_1_N = mkN "långbänk" ;
  laangdistansloepning_nn_1_1_N = mkN "långdistanslöpning" ;
  laanglotsning_nn_1_1_N = mkN "långlotsning" ;
  laangsalning_nn_1_1_N = mkN "långsalning" ;
  laangtidsbehandling_nn_1_1_N = mkN "långtidsbehandling" ;
  laangtidsfoervaring_nn_1_1_N = mkN "långtidsförvaring" ;
  laangtidsparkering_nn_1_1_N = mkN "långtidsparkering" ;
  laangvaegg_nn_1_1_N = mkN "långvägg" ;
  laaringsvind_nn_1_1_N = mkN "låringsvind" ;
  laasanordning_nn_1_1_N = mkN "låsanordning" ;
  laasning_nn_1_1_N = mkN "låsning" ;
  laassaslek_nn_1_1_N = mkN "låssaslek" ;
  laassasvaerld_nn_1_1_N = mkN "låssasvärld" ;
  laasskruv_nn_1_1_N = mkN "låsskruv" ;
  laatsasbrottning_nn_1_1_N = mkN "låtsasbrottning" ;
  laatsaslek_nn_1_1_N = mkN "låtsaslek" ;
  laatsasvaerld_nn_1_1_N = mkN "låtsasvärld" ;
  loedning_nn_1_1_N = mkN "lödning" ;
  loegning_nn_1_1_N = mkN "lögning" ;
  loeksill_nn_1_1_N = mkN "löksill" ;
  loenebildning_nn_1_1_N = mkN "lönebildning" ;
  loenedumpning_nn_1_1_N = mkN "lönedumpning" ;
  loenefoerhandling_nn_1_1_N = mkN "löneförhandling" ;
  loenefoerhoejning_nn_1_1_N = mkN "löneförhöjning" ;
  loeneglidning_nn_1_1_N = mkN "löneglidning" ;
  loenehoejning_nn_1_1_N = mkN "lönehöjning" ;
  loeneslav_nn_1_1_N = mkN "löneslav" ;
  loenesaettning_nn_1_1_N = mkN "lönesättning" ;
  loeneutveckling_nn_1_1_N = mkN "löneutveckling" ;
  loeneoekning_nn_1_1_N = mkN "löneökning" ;
  loening_nn_1_1_N = mkN "löning" ;
  loennbraenning_nn_1_1_N = mkN "lönnbränning" ;
  loenngaang_nn_1_1_N = mkN "lönngång" ;
  loennkrog_nn_1_1_N = mkN "lönnkrog" ;
  loepeld_nn_1_1_N = mkN "löpeld" ;
  loepknut_nn_1_1_N = mkN "löpknut" ;
  loepning_nn_1_1_N = mkN "löpning" ;
  loepring_nn_1_1_N = mkN "löpring" ;
  loeptik_nn_1_1_N = mkN "löptik" ;
  loerdag_nn_1_1_N = mkN "lördag" ;
  loesegendom_nn_1_1_N = mkN "lösegendom" ;
  loesning_nn_1_1_N = mkN "lösning" ;
  loesslaeppning_nn_1_1_N = mkN "lössläppning" ;
  loevblandskog_nn_1_1_N = mkN "lövblandskog" ;
  loevfaellning_nn_1_1_N = mkN "lövfällning" ;
  loevhoeg_nn_1_1_N = mkN "lövhög" ;
  loevsal_nn_1_1_N = mkN "lövsal" ;
  loevskog_nn_1_1_N = mkN "lövskog" ;
  loevsprickning_nn_1_1_N = mkN "lövsprickning" ;
  loevsug_nn_1_1_N = mkN "lövsug" ;
  loevsaag_nn_1_1_N = mkN "lövsåg" ;
  loevsaagning_nn_1_1_N = mkN "lövsågning" ;
  loevaeng_nn_1_1_N = mkN "löväng" ;
  madrassering_nn_1_N = mkN "madrassering" ;
  madrassnaal_nn_1_1_N = mkN "madrassnål" ;
  magasinering_nn_1_N = mkN "magasinering" ;
  maggrop_nn_1_N = mkN "maggrop" ;
  magnesiumlegering_nn_1_N = mkN "magnesiumlegering" ;
  magnetisering_nn_1_N = mkN "magnetisering" ;
  magnettaendning_nn_1_1_N = mkN "magnettändning" ;
  magsjukdom_nn_1_N = mkN "magsjukdom" ;
  magsaeck_nn_1_1_N = mkN "magsäck" ;
  magoevning_nn_1_1_N = mkN "magövning" ;
  mahognylaminatdoerr_nn_1_1_N = mkN "mahognylaminatdörr" ;
  majoritetsregering_nn_1_N = mkN "majoritetsregering" ;
  maktfoerdelning_nn_1_1_N = mkN "maktfördelning" ;
  maktfoerskjutning_nn_1_1_N = mkN "maktförskjutning" ;
  maktstaellning_nn_1_1_N = mkN "maktställning" ;
  makulering_nn_1_N = mkN "makulering" ;
  malfobering_nn_1_N = mkN "malfobering" ;
  malmgaard_nn_1_1_N = mkN "malmgård" ;
  malning_nn_1_N = mkN "malning" ;
  maltraetering_nn_1_1_N = mkN "malträtering" ;
  mammaklaenning_nn_1_1_N = mkN "mammaklänning" ;
  manchesterhaengselkjol_nn_1_1_N = mkN "manchesterhängselkjol" ;
  mandatfoerdelning_nn_1_1_N = mkN "mandatfördelning" ;
  mandom_nn_1_N = mkN "mandom" ;
  manifestering_nn_1_N = mkN "manifestering" ;
  manikurering_nn_1_N = mkN "manikurering" ;
  manikyrering_nn_1_N = mkN "manikyrering" ;
  maning_nn_1_N = mkN "maning" ;
  manipulering_nn_1_N = mkN "manipulering" ;
  mankering_nn_1_N = mkN "mankering" ;
  manschettknapp_nn_1_N = mkN "manschettknapp" ;
  mansgrav_nn_1_N = mkN "mansgrav" ;
  mantalsskrivning_nn_1_N = mkN "mantalsskrivning" ;
  mantelstyrning_nn_1_N = mkN "mantelstyrning" ;
  manusgenomgaang_nn_1_1_N = mkN "manusgenomgång" ;
  manoevrering_nn_1_1_N = mkN "manövrering" ;
  maratonfoerhandling_nn_1_1_N = mkN "maratonförhandling" ;
  marginalanteckning_nn_1_N = mkN "marginalanteckning" ;
  marginalbeskattning_nn_1_N = mkN "marginalbeskattning" ;
  marginaliseraing_nn_1_N = mkN "marginaliseraing" ;
  marinering_nn_1_N = mkN "marinering" ;
  marinledning_nn_1_N = mkN "marinledning" ;
  marinmaalning_nn_1_1_N = mkN "marinmålning" ;
  markegaang_nn_1_1_N = mkN "markegång" ;
  markering_nn_1_N = mkN "markering" ;
  marknadsfoering_nn_1_1_N = mkN "marknadsföring" ;
  marknadsundersoekning_nn_1_1_N = mkN "marknadsundersökning" ;
  marknadsvaerdering_nn_1_1_N = mkN "marknadsvärdering" ;
  markvaeg_nn_1_1_N = mkN "markväg" ;
  marmorering_nn_1_N = mkN "marmorering" ;
  marmorhaell_nn_1_1_N = mkN "marmorhäll" ;
  marodering_nn_1_N = mkN "marodering" ;
  marschdrill_nn_1_N = mkN "marschdrill" ;
  marschering_nn_1_N = mkN "marschering" ;
  marschriktning_nn_1_N = mkN "marschriktning" ;
  martering_nn_1_N = mkN "martering" ;
  maskering_nn_1_N = mkN "maskering" ;
  maskinskrivning_nn_1_N = mkN "maskinskrivning" ;
  maskintvaett_nn_1_1_N = mkN "maskintvätt" ;
  maskinoeversaettning_nn_1_1_N = mkN "maskinöversättning" ;
  maskning_nn_1_N = mkN "maskning" ;
  maskulinisering_nn_1_N = mkN "maskulinisering" ;
  massagestol_nn_1_N = mkN "massagestol" ;
  massakerskytt_nn_1_N = mkN "massakerskytt" ;
  massakrering_nn_1_N = mkN "massakrering" ;
  massarrestering_nn_1_N = mkN "massarrestering" ;
  massavraettning_nn_1_1_N = mkN "massavrättning" ;
  massavskedning_nn_1_N = mkN "massavskedning" ;
  massdoed_nn_1_1_N = mkN "massdöd" ;
  massering_nn_1_N = mkN "massering" ;
  massfattigdom_nn_1_N = mkN "massfattigdom" ;
  massgrav_nn_1_N = mkN "massgrav" ;
  masshaektning_nn_1_1_N = mkN "masshäktning" ;
  massraettegaang_nn_1_1_N = mkN "massrättegång" ;
  massuppsaegning_nn_1_1_N = mkN "massuppsägning" ;
  massvaccinering_nn_1_N = mkN "massvaccinering" ;
  masturbering_nn_1_N = mkN "masturbering" ;
  matarledning_nn_1_N = mkN "matarledning" ;
  matavfallskvarn_nn_1_N = mkN "matavfallskvarn" ;
  matchboll_nn_1_N = mkN "matchboll" ;
  matelassering_nn_1_N = mkN "matelassering" ;
  materialisering_nn_1_N = mkN "materialisering" ;
  materialsamling_nn_1_N = mkN "materialsamling" ;
  materieforskning_nn_1_N = mkN "materieforskning" ;
  matfoergiftning_nn_1_1_N = mkN "matförgiftning" ;
  mathaallning_nn_1_1_N = mkN "mathållning" ;
  matkorg_nn_1_N = mkN "matkorg" ;
  matlagning_nn_1_N = mkN "matlagning" ;
  matning_nn_1_N = mkN "matning" ;
  matsal_nn_1_N = mkN "matsal" ;
  matservering_nn_2_N = mkN "matservering" ;
  matsked_nn_1_N = mkN "matsked" ;
  matsmaeltning_nn_1_1_N = mkN "matsmältning" ;
  mattallrik_nn_1_N = mkN "mattallrik" ;
  mattering_nn_1_N = mkN "mattering" ;
  mattpiskning_nn_1_N = mkN "mattpiskning" ;
  mattpiskstaellning_nn_1_1_N = mkN "mattpiskställning" ;
  maxikjol_nn_1_N = mkN "maxikjol" ;
  maximering_nn_1_N = mkN "maximering" ;
  mc_lyft_nn_1_N = mkN "mc-lyft" ;
  medaljering_nn_1_N = mkN "medaljering" ;
  medaljutdelning_nn_1_N = mkN "medaljutdelning" ;
  medbestaemmandelag_nn_1_1_N = mkN "medbestämmandelag" ;
  medelklassfoerdom_nn_1_1_N = mkN "medelklassfördom" ;
  medelsanvisning_nn_1_N = mkN "medelsanvisning" ;
  medelskoerd_nn_1_1_N = mkN "medelskörd" ;
  medelstorlek_nn_1_N = mkN "medelstorlek" ;
  medeltidsmaalning_nn_1_1_N = mkN "medeltidsmålning" ;
  medelvaeg_nn_1_1_N = mkN "medelväg" ;
  medgaang_nn_1_1_N = mkN "medgång" ;
  medicinbluff_nn_1_N = mkN "medicinbluff" ;
  medicinboll_nn_1_N = mkN "medicinboll" ;
  medicinering_nn_1_N = mkN "medicinering" ;
  mediebevakning_nn_1_N = mkN "mediebevakning" ;
  mediedamm_nn_1_N = mkN "mediedamm" ;
  medisterkorv_nn_1_N = mkN "medisterkorv" ;
  meditering_nn_1_N = mkN "meditering" ;
  medlemsfoerhandling_nn_1_1_N = mkN "medlemsförhandling" ;
  medling_nn_1_N = mkN "medling" ;
  medvind_nn_1_N = mkN "medvind" ;
  mejerifoerening_nn_1_1_N = mkN "mejeriförening" ;
  mekanisering_nn_1_N = mkN "mekanisering" ;
  mellandag_nn_1_N = mkN "mellandag" ;
  mellanlandning_nn_1_N = mkN "mellanlandning" ;
  mellanriksvaeg_nn_1_1_N = mkN "mellanriksväg" ;
  mellanrumsfoerening_nn_1_1_N = mkN "mellanrumsförening" ;
  mellanvaeg_nn_1_1_N = mkN "mellanväg" ;
  mellanvaegg_nn_1_1_N = mkN "mellanvägg" ;
  mellanvaaning_nn_1_1_N = mkN "mellanvåning" ;
  memorering_nn_1_N = mkN "memorering" ;
  mening_nn_1_N = mkN "mening" ;
  meningsbrytning_nn_1_N = mkN "meningsbrytning" ;
  meningsriktning_nn_1_N = mkN "meningsriktning" ;
  meningsyttring_nn_1_N = mkN "meningsyttring" ;
  menstruering_nn_1_N = mkN "menstruering" ;
  mentalsjukdom_nn_1_N = mkN "mentalsjukdom" ;
  mentalvaardsinraettning_nn_1_1_N = mkN "mentalvårdsinrättning" ;
  mercerisering_nn_1_N = mkN "mercerisering" ;
  meritering_nn_1_N = mkN "meritering" ;
  meritfoerteckning_nn_1_1_N = mkN "meritförteckning" ;
  metallbit_nn_1_N = mkN "metallbit" ;
  metallfoergiftning_nn_1_1_N = mkN "metallförgiftning" ;
  metallgjutning_nn_1_N = mkN "metallgjutning" ;
  metallisering_nn_1_N = mkN "metallisering" ;
  metallkorg_nn_1_N = mkN "metallkorg" ;
  metallmugg_nn_1_N = mkN "metallmugg" ;
  metallring_nn_1_N = mkN "metallring" ;
  metallsaag_nn_1_1_N = mkN "metallsåg" ;
  metalltraad_nn_1_1_N = mkN "metalltråd" ;
  metkrok_nn_1_N = mkN "metkrok" ;
  metylering_nn_1_N = mkN "metylering" ;
  microhatt_nn_1_N = mkN "microhatt" ;
  middag_nn_1_N = mkN "middag" ;
  middagsbjudning_nn_1_N = mkN "middagsbjudning" ;
  middagsklaenning_nn_1_1_N = mkN "middagsklänning" ;
  midgetbil_nn_1_N = mkN "midgetbil" ;
  migrantbaat_nn_1_1_N = mkN "migrantbåt" ;
  mikrofiberduk_nn_1_N = mkN "mikrofiberduk" ;
  mikrofotografering_nn_1_N = mkN "mikrofotografering" ;
  mikrohatt_nn_1_N = mkN "mikrohatt" ;
  mikroskopering_nn_1_N = mkN "mikroskopering" ;
  mildring_nn_1_N = mkN "mildring" ;
  militarisering_nn_1_N = mkN "militarisering" ;
  militaerdomstol_nn_1_1_N = mkN "militärdomstol" ;
  militaerfoerlaeggning_nn_1_1_N = mkN "militärförläggning" ;
  militaerfoervaltning_nn_1_1_N = mkN "militärförvaltning" ;
  militaerpostering_nn_1_1_N = mkN "militärpostering" ;
  militaertjaenstgoering_nn_1_1_N = mkN "militärtjänstgöring" ;
  militaeroevning_nn_1_1_N = mkN "militärövning" ;
  miljardsatsning_nn_1_N = mkN "miljardsatsning" ;
  miljoninvestering_nn_1_N = mkN "miljoninvestering" ;
  miljoebil_nn_1_1_N = mkN "miljöbil" ;
  miljoebilssatsning_nn_1_1_N = mkN "miljöbilssatsning" ;
  miljoecertifiering_nn_1_1_N = mkN "miljöcertifiering" ;
  miljoefoerorening_nn_1_1_N = mkN "miljöförorening" ;
  miljoefoerstoering_nn_1_1_N = mkN "miljöförstöring" ;
  miljoefoersaemring_nn_1_1_N = mkN "miljöförsämring" ;
  miljoefoervaltning_nn_1_1_N = mkN "miljöförvaltning" ;
  miljoemaerkning_nn_1_1_N = mkN "miljömärkning" ;
  miljoeskildring_nn_1_1_N = mkN "miljöskildring" ;
  mineralgaang_nn_1_1_N = mkN "mineralgång" ;
  mineralisering_nn_1_N = mkN "mineralisering" ;
  mineralutvinning_nn_1_N = mkN "mineralutvinning" ;
  minering_nn_1_N = mkN "minering" ;
  mingaang_nn_1_1_N = mkN "mingång" ;
  miniatyrisering_nn_1_N = mkN "miniatyrisering" ;
  miniatyrmaalning_nn_1_1_N = mkN "miniatyrmålning" ;
  minibil_nn_1_N = mkN "minibil" ;
  miniersaettning_nn_1_1_N = mkN "miniersättning" ;
  minikjol_nn_1_N = mkN "minikjol" ;
  minimering_nn_1_N = mkN "minimering" ;
  minnesanteckning_nn_1_N = mkN "minnesanteckning" ;
  minnesteckning_nn_1_N = mkN "minnesteckning" ;
  minnesvaard_nn_2_1_N = mkN "minnesvård" ;
  minoritetsregering_nn_1_N = mkN "minoritetsregering" ;
  minoritetsstaellning_nn_1_1_N = mkN "minoritetsställning" ;
  minroejning_nn_1_1_N = mkN "minröjning" ;
  minskning_nn_1_N = mkN "minskning" ;
  minspaerr_nn_1_1_N = mkN "minspärr" ;
  minsvepning_nn_1_N = mkN "minsvepning" ;
  missaktning_nn_1_N = mkN "missaktning" ;
  missanpassning_nn_1_N = mkN "missanpassning" ;
  missbedoemning_nn_1_1_N = mkN "missbedömning" ;
  missbildning_nn_1_N = mkN "missbildning" ;
  missfaergning_nn_1_1_N = mkN "missfärgning" ;
  missgaerning_nn_1_1_N = mkN "missgärning" ;
  missionering_nn_1_N = mkN "missionering" ;
  missivering_nn_1_N = mkN "missivering" ;
  misskreditering_nn_1_N = mkN "misskreditering" ;
  missraekning_nn_1_1_N = mkN "missräkning" ;
  misstolkning_nn_1_N = mkN "misstolkning" ;
  misstroendefoerklaring_nn_1_1_N = mkN "misstroendeförklaring" ;
  misstydning_nn_1_N = mkN "misstydning" ;
  misstaemning_nn_1_1_N = mkN "misstämning" ;
  misstaenkliggoering_nn_1_1_N = mkN "misstänkliggöring" ;
  missuppfattning_nn_1_N = mkN "missuppfattning" ;
  missvisning_nn_1_N = mkN "missvisning" ;
  mistning_nn_1_N = mkN "mistning" ;
  mittelgaang_nn_1_1_N = mkN "mittelgång" ;
  mjukdelsbehandling_nn_1_N = mkN "mjukdelsbehandling" ;
  mjoelkflytning_nn_1_1_N = mkN "mjölkflytning" ;
  mjoelkfoerpackning_nn_1_1_N = mkN "mjölkförpackning" ;
  mjoelkgrymtning_nn_1_1_N = mkN "mjölkgrymtning" ;
  mjoelkgaang_nn_1_1_N = mkN "mjölkgång" ;
  mjoelkpall_nn_1_1_N = mkN "mjölkpall" ;
  mjoelkstockning_nn_1_1_N = mkN "mjölkstockning" ;
  mobilisering_nn_1_N = mkN "mobilisering" ;
  mobilraekning_nn_1_1_N = mkN "mobilräkning" ;
  modellberaekning_nn_1_1_N = mkN "modellberäkning" ;
  modellering_nn_1_N = mkN "modellering" ;
  modelljaernvaeg_nn_1_1_N = mkN "modelljärnväg" ;
  moderering_nn_1_N = mkN "moderering" ;
  modernisering_nn_1_N = mkN "modernisering" ;
  modernaering_nn_1_1_N = mkN "modernäring" ;
  modetidning_nn_1_N = mkN "modetidning" ;
  modeuppvisning_nn_1_N = mkN "modeuppvisning" ;
  modevisning_nn_1_N = mkN "modevisning" ;
  modifiering_nn_1_N = mkN "modifiering" ;
  modulering_nn_1_N = mkN "modulering" ;
  modaernisering_nn_1_1_N = mkN "modärnisering" ;
  molnbildning_nn_1_N = mkN "molnbildning" ;
  molnhop_nn_1_N = mkN "molnhop" ;
  molntott_nn_1_N = mkN "molntott" ;
  momsredovisning_nn_1_N = mkN "momsredovisning" ;
  monoftongering_nn_1_N = mkN "monoftongering" ;
  monopolisering_nn_1_N = mkN "monopolisering" ;
  monopolstaellning_nn_1_1_N = mkN "monopolställning" ;
  monsunkantring_nn_1_N = mkN "monsunkantring" ;
  montagearm_nn_1_N = mkN "montagearm" ;
  montering_nn_1_N = mkN "montering" ;
  monteringsanvisning_nn_1_N = mkN "monteringsanvisning" ;
  monteringsskruv_nn_1_N = mkN "monteringsskruv" ;
  morakniv_nn_1_N = mkN "morakniv" ;
  moralisering_nn_1_N = mkN "moralisering" ;
  morddom_nn_1_N = mkN "morddom" ;
  mordraettegaang_nn_1_1_N = mkN "mordrättegång" ;
  mordstaempling_nn_1_1_N = mkN "mordstämpling" ;
  morgonavgaang_nn_1_1_N = mkN "morgonavgång" ;
  morgonsamling_nn_1_N = mkN "morgonsamling" ;
  morgontidning_nn_1_N = mkN "morgontidning" ;
  morgonvind_nn_1_N = mkN "morgonvind" ;
  moring_nn_1_N = mkN "moring" ;
  morrning_nn_1_N = mkN "morrning" ;
  morsering_nn_1_N = mkN "morsering" ;
  mortelstoet_nn_1_1_N = mkN "mortelstöt" ;
  mortificering_nn_1_N = mkN "mortificering" ;
  mortifiering_nn_1_N = mkN "mortifiering" ;
  moraensluttning_nn_1_1_N = mkN "moränsluttning" ;
  motbevisning_nn_1_N = mkN "motbevisning" ;
  motgaang_nn_1_1_N = mkN "motgång" ;
  motionering_nn_1_N = mkN "motionering" ;
  motionsanlaeggning_nn_1_1_N = mkN "motionsanläggning" ;
  motionshall_nn_1_N = mkN "motionshall" ;
  motivering_nn_1_N = mkN "motivering" ;
  motlaesning_nn_1_1_N = mkN "motläsning" ;
  motorbaat_nn_1_1_N = mkN "motorbåt" ;
  motorcykelhjaelm_nn_1_1_N = mkN "motorcykelhjälm" ;
  motorcykellyft_nn_1_N = mkN "motorcykellyft" ;
  motorcykeltaevling_nn_1_1_N = mkN "motorcykeltävling" ;
  motorhuv_nn_1_N = mkN "motorhuv" ;
  motorisering_nn_1_N = mkN "motorisering" ;
  motorlyft_nn_1_N = mkN "motorlyft" ;
  motorsaag_nn_1_1_N = mkN "motorsåg" ;
  motorvaeg_nn_1_1_N = mkN "motorväg" ;
  motstaemning_nn_1_1_N = mkN "motstämning" ;
  motstaandshaerd_nn_1_1_N = mkN "motståndshärd" ;
  motstaandssvetsning_nn_1_1_N = mkN "motståndssvetsning" ;
  motsaettning_nn_1_1_N = mkN "motsättning" ;
  mottagarsaeck_nn_1_1_N = mkN "mottagarsäck" ;
  mottagning_nn_1_N = mkN "mottagning" ;
  motvind_nn_1_N = mkN "motvind" ;
  moussering_nn_1_N = mkN "moussering" ;
  muljering_nn_1_N = mkN "muljering" ;
  mullvad_nn_1_N = mkN "mullvad" ;
  mullvadshoeg_nn_1_1_N = mkN "mullvadshög" ;
  mulning_nn_1_N = mkN "mulning" ;
  multiplicering_nn_1_N = mkN "multiplicering" ;
  mumifiering_nn_1_N = mkN "mumifiering" ;
  mumsning_nn_1_N = mkN "mumsning" ;
  mun_mot_muninblaasning_nn_1_1_N = mkN "mun-mot-muninblåsning" ;
  mundering_nn_1_N = mkN "mundering" ;
  munfull_nn_1_N = mkN "munfull" ;
  munkorgslag_nn_1_N = mkN "munkorgslag" ;
  munkstol_nn_1_N = mkN "munkstol" ;
  munskaenk_nn_1_1_N = mkN "munskänk" ;
  muralmaalning_nn_1_1_N = mkN "muralmålning" ;
  murstock_nn_1_N = mkN "murstock" ;
  musarm_nn_1_N = mkN "musarm" ;
  museifoerening_nn_1_1_N = mkN "museiförening" ;
  museisal_nn_1_N = mkN "museisal" ;
  musicering_nn_1_N = mkN "musicering" ;
  musikanlaeggning_nn_1_1_N = mkN "musikanläggning" ;
  musikstil_nn_1_N = mkN "musikstil" ;
  muskelbristning_nn_1_N = mkN "muskelbristning" ;
  muskelbaat_nn_1_1_N = mkN "muskelbåt" ;
  muskelfoerlamning_nn_1_1_N = mkN "muskelförlamning" ;
  muskelfoertvining_nn_1_1_N = mkN "muskelförtvining" ;
  muskelring_nn_1_N = mkN "muskelring" ;
  muskelryckning_nn_1_N = mkN "muskelryckning" ;
  muskelsammandragning_nn_1_N = mkN "muskelsammandragning" ;
  muskelspaenning_nn_1_1_N = mkN "muskelspänning" ;
  muskelstraeckning_nn_1_1_N = mkN "muskelsträckning" ;
  muskeltraad_nn_1_1_N = mkN "muskeltråd" ;
  muslinsklaenning_nn_1_1_N = mkN "muslinsklänning" ;
  musselodling_nn_1_N = mkN "musselodling" ;
  mussering_nn_1_N = mkN "mussering" ;
  mutering_nn_1_N = mkN "mutering" ;
  myggnaetsdoerr_nn_1_1_N = mkN "myggnätsdörr" ;
  myndighetsfoerklaring_nn_1_1_N = mkN "myndighetsförklaring" ;
  mynning_nn_1_N = mkN "mynning" ;
  myntsamling_nn_1_N = mkN "myntsamling" ;
  myrkrypning_nn_1_N = mkN "myrkrypning" ;
  myrstig_nn_1_N = mkN "myrstig" ;
  mysning_nn_1_N = mkN "mysning" ;
  mystifiering_nn_1_N = mkN "mystifiering" ;
  mytbildning_nn_1_N = mkN "mytbildning" ;
  mytifiering_nn_1_N = mkN "mytifiering" ;
  mytspridning_nn_1_N = mkN "mytspridning" ;
  maenniskokaennedom_nn_1_1_N = mkN "människokännedom" ;
  maenniskokaerlek_nn_1_1_N = mkN "människokärlek" ;
  maenniskoomflyttning_nn_1_1_N = mkN "människoomflyttning" ;
  maenniskoskildring_nn_1_1_N = mkN "människoskildring" ;
  maenniskouppfattning_nn_1_1_N = mkN "människouppfattning" ;
  maerkesdag_nn_1_1_N = mkN "märkesdag" ;
  maerkning_nn_1_1_N = mkN "märkning" ;
  maerling_nn_1_1_N = mkN "märling" ;
  maerlspik_nn_1_1_N = mkN "märlspik" ;
  maeskning_nn_1_1_N = mkN "mäskning" ;
  maesshall_nn_1_1_N = mkN "mässhall" ;
  maessingsknapp_nn_1_1_N = mkN "mässingsknapp" ;
  maessingstraad_nn_1_1_N = mkN "mässingstråd" ;
  maetning_nn_1_1_N = mkN "mätning" ;
  maettning_nn_1_1_N = mkN "mättning" ;
  maalangivning_nn_1_1_N = mkN "målangivning" ;
  maalarkniv_nn_1_1_N = mkN "målarkniv" ;
  maalarstaellning_nn_1_1_N = mkN "målarställning" ;
  maalforskning_nn_1_1_N = mkN "målforskning" ;
  maalgaang_nn_1_1_N = mkN "målgång" ;
  maalkung_nn_1_1_N = mkN "målkung" ;
  maalning_nn_1_1_N = mkN "målning" ;
  maalskjutning_nn_1_1_N = mkN "målskjutning" ;
  maalspaning_nn_1_1_N = mkN "målspaning" ;
  maalstyrning_nn_1_1_N = mkN "målstyrning" ;
  maalstaellning_nn_1_1_N = mkN "målställning" ;
  maalsaettning_nn_1_1_N = mkN "målsättning" ;
  maanadspeng_nn_1_1_N = mkN "månadspeng" ;
  maanadspenning_nn_1_1_N = mkN "månadspenning" ;
  maanbaevning_nn_1_1_N = mkN "månbävning" ;
  maandag_nn_1_1_N = mkN "måndag" ;
  maanghoerning_nn_1_1_N = mkN "månghörning" ;
  maangmiljoninvestering_nn_1_1_N = mkN "mångmiljoninvestering" ;
  maangsiding_nn_1_1_N = mkN "mångsiding" ;
  maanlandning_nn_1_1_N = mkN "månlandning" ;
  maasflock_nn_1_1_N = mkN "måsflock" ;
  maattagning_nn_1_1_N = mkN "måttagning" ;
  maattstock_nn_1_1_N = mkN "måttstock" ;
  moebelflyttning_nn_1_1_N = mkN "möbelflyttning" ;
  moebelfoersaeljning_nn_1_1_N = mkN "möbelförsäljning" ;
  moebelstil_nn_1_1_N = mkN "möbelstil" ;
  moeblering_nn_1_1_N = mkN "möblering" ;
  moedom_nn_1_1_N = mkN "mödom" ;
  moegelhund_nn_1_1_N = mkN "mögelhund" ;
  moegeltraad_nn_1_1_N = mkN "mögeltråd" ;
  moenstring_nn_1_1_N = mkN "mönstring" ;
  moerbultning_nn_1_1_N = mkN "mörbultning" ;
  moerdeg_nn_1_1_N = mkN "mördeg" ;
  moerkerkoerning_nn_1_1_N = mkN "mörkerkörning" ;
  moerklaeggning_nn_1_1_N = mkN "mörkläggning" ;
  moerkning_nn_2_1_N = mkN "mörkning" ;
  moesskaerm_nn_1_1_N = mkN "mösskärm" ;
  nackbjudning_nn_1_N = mkN "nackbjudning" ;
  nackknut_nn_1_N = mkN "nackknut" ;
  nafsning_nn_1_N = mkN "nafsning" ;
  nagelbitning_nn_1_N = mkN "nagelbitning" ;
  nagelfil_nn_1_N = mkN "nagelfil" ;
  nagelklippning_nn_1_N = mkN "nagelklippning" ;
  naggning_nn_1_N = mkN "naggning" ;
  najoegonstropp_nn_1_1_N = mkN "najögonstropp" ;
  nakenblankning_nn_1_N = mkN "nakenblankning" ;
  namnberedning_nn_1_N = mkN "namnberedning" ;
  namnfoerklaring_nn_1_1_N = mkN "namnförklaring" ;
  namnfoeraendring_nn_1_1_N = mkN "namnförändring" ;
  namngivning_nn_1_N = mkN "namngivning" ;
  namninsamling_nn_1_N = mkN "namninsamling" ;
  namnlag_nn_1_N = mkN "namnlag" ;
  namnskylt_nn_1_N = mkN "namnskylt" ;
  namnteckning_nn_1_N = mkN "namnteckning" ;
  nanotraad_nn_1_1_N = mkN "nanotråd" ;
  narkotikafoersaeljning_nn_1_1_N = mkN "narkotikaförsäljning" ;
  narkotikahund_nn_1_N = mkN "narkotikahund" ;
  narkotikautredning_nn_1_N = mkN "narkotikautredning" ;
  narkotikautskrivning_nn_1_N = mkN "narkotikautskrivning" ;
  narval_nn_1_N = mkN "narval" ;
  nasalering_nn_1_N = mkN "nasalering" ;
  nasalisering_nn_1_N = mkN "nasalisering" ;
  nationalfoerening_nn_1_1_N = mkN "nationalförening" ;
  nationalfoersamling_nn_1_1_N = mkN "nationalförsamling" ;
  nationalisering_nn_1_N = mkN "nationalisering" ;
  nationalitetsbeteckning_nn_1_N = mkN "nationalitetsbeteckning" ;
  nationalitetshandling_nn_1_N = mkN "nationalitetshandling" ;
  nattkorv_nn_1_N = mkN "nattkorv" ;
  nattmangling_nn_1_N = mkN "nattmangling" ;
  nattorientering_nn_1_N = mkN "nattorientering" ;
  nattrock_nn_1_N = mkN "nattrock" ;
  nattstaellning_nn_1_1_N = mkN "nattställning" ;
  nattvardsgaang_nn_1_1_N = mkN "nattvardsgång" ;
  nattvardsundervisning_nn_1_N = mkN "nattvardsundervisning" ;
  naturahushaallning_nn_1_1_N = mkN "naturahushållning" ;
  naturalisering_nn_1_N = mkN "naturalisering" ;
  naturbegaavning_nn_1_1_N = mkN "naturbegåvning" ;
  naturbesjaelning_nn_1_1_N = mkN "naturbesjälning" ;
  naturlag_nn_1_N = mkN "naturlag" ;
  naturrikedom_nn_1_N = mkN "naturrikedom" ;
  naturskildring_nn_1_N = mkN "naturskildring" ;
  naturskog_nn_1_N = mkN "naturskog" ;
  naturstig_nn_1_N = mkN "naturstig" ;
  naturtillgaang_nn_1_1_N = mkN "naturtillgång" ;
  navelskaadning_nn_1_1_N = mkN "navelskådning" ;
  navelstraeng_nn_1_1_N = mkN "navelsträng" ;
  navigationsvarning_nn_1_N = mkN "navigationsvarning" ;
  navigering_nn_1_N = mkN "navigering" ;
  nedblodning_nn_1_N = mkN "nedblodning" ;
  nedbrytning_nn_1_N = mkN "nedbrytning" ;
  nedbraenning_nn_1_1_N = mkN "nedbränning" ;
  nedbusning_nn_1_N = mkN "nedbusning" ;
  nedbaeddning_nn_1_1_N = mkN "nedbäddning" ;
  neddragning_nn_1_N = mkN "neddragning" ;
  nederlagsstaemning_nn_1_1_N = mkN "nederlagsstämning" ;
  nedflyttning_nn_1_N = mkN "nedflyttning" ;
  nedfrysning_nn_1_N = mkN "nedfrysning" ;
  nedgraevning_nn_1_1_N = mkN "nedgrävning" ;
  nedgaang_nn_1_1_N = mkN "nedgång" ;
  nedhuggning_nn_1_N = mkN "nedhuggning" ;
  nedkastning_nn_1_N = mkN "nedkastning" ;
  nedladdning_nn_1_N = mkN "nedladdning" ;
  nedlaeggning_nn_1_1_N = mkN "nedläggning" ;
  nedmejning_nn_1_N = mkN "nedmejning" ;
  nedrustning_nn_1_N = mkN "nedrustning" ;
  nedraekning_nn_1_1_N = mkN "nedräkning" ;
  nedsaltning_nn_1_N = mkN "nedsaltning" ;
  nedskjutning_nn_1_N = mkN "nedskjutning" ;
  nedskrivning_nn_1_N = mkN "nedskrivning" ;
  nedskaerning_nn_1_1_N = mkN "nedskärning" ;
  nedslaktning_nn_1_N = mkN "nedslaktning" ;
  nedslaeckning_nn_1_1_N = mkN "nedsläckning" ;
  nedsmutsning_nn_1_N = mkN "nedsmutsning" ;
  nedstigning_nn_1_N = mkN "nedstigning" ;
  nedstrykning_nn_1_N = mkN "nedstrykning" ;
  nedsvaertning_nn_1_1_N = mkN "nedsvärtning" ;
  nedsaenkning_nn_1_1_N = mkN "nedsänkning" ;
  nedsaettning_nn_1_1_N = mkN "nedsättning" ;
  nedsoelning_nn_1_1_N = mkN "nedsölning" ;
  nedtagning_nn_1_N = mkN "nedtagning" ;
  nedtoning_nn_1_N = mkN "nedtoning" ;
  nedtransformering_nn_1_N = mkN "nedtransformering" ;
  nedtransponering_nn_1_N = mkN "nedtransponering" ;
  nedtrappning_nn_1_N = mkN "nedtrappning" ;
  nedtryckning_nn_1_N = mkN "nedtryckning" ;
  nedvaerdering_nn_1_1_N = mkN "nedvärdering" ;
  negerboll_nn_1_N = mkN "negerboll" ;
  negering_nn_1_N = mkN "negering" ;
  negligering_nn_1_N = mkN "negligering" ;
  negociering_nn_1_N = mkN "negociering" ;
  negotiering_nn_1_N = mkN "negotiering" ;
  neonskylt_nn_1_N = mkN "neonskylt" ;
  nerblodning_nn_1_N = mkN "nerblodning" ;
  nerbrytning_nn_1_N = mkN "nerbrytning" ;
  nerbraenning_nn_1_1_N = mkN "nerbränning" ;
  nerbusning_nn_1_N = mkN "nerbusning" ;
  nerbaeddning_nn_1_1_N = mkN "nerbäddning" ;
  nerdragning_nn_1_N = mkN "nerdragning" ;
  nerfrysning_nn_1_N = mkN "nerfrysning" ;
  nergraevning_nn_1_1_N = mkN "nergrävning" ;
  nergaang_nn_1_1_N = mkN "nergång" ;
  nerhuggning_nn_1_N = mkN "nerhuggning" ;
  nerkastning_nn_1_N = mkN "nerkastning" ;
  nerkvark_nn_1_N = mkN "nerkvark" ;
  nerladdning_nn_1_N = mkN "nerladdning" ;
  nerlaeggning_nn_1_1_N = mkN "nerläggning" ;
  nermejning_nn_1_N = mkN "nermejning" ;
  nerrustning_nn_1_N = mkN "nerrustning" ;
  nerraekning_nn_1_1_N = mkN "nerräkning" ;
  nersaltning_nn_1_N = mkN "nersaltning" ;
  nerskjutning_nn_1_N = mkN "nerskjutning" ;
  nerskaerning_nn_1_1_N = mkN "nerskärning" ;
  nerslaktning_nn_1_N = mkN "nerslaktning" ;
  nersmutsning_nn_1_N = mkN "nersmutsning" ;
  nerstigning_nn_1_N = mkN "nerstigning" ;
  nerstrykning_nn_1_N = mkN "nerstrykning" ;
  nersvaertning_nn_1_1_N = mkN "nersvärtning" ;
  nersaenkning_nn_1_1_N = mkN "nersänkning" ;
  nersaettning_nn_1_1_N = mkN "nersättning" ;
  nersoelning_nn_1_1_N = mkN "nersölning" ;
  nertagning_nn_1_N = mkN "nertagning" ;
  nertoning_nn_1_N = mkN "nertoning" ;
  nertransformering_nn_1_N = mkN "nertransformering" ;
  nertransponering_nn_1_N = mkN "nertransponering" ;
  nertrappning_nn_1_N = mkN "nertrappning" ;
  nertryckning_nn_1_N = mkN "nertryckning" ;
  nervkittling_nn_1_N = mkN "nervkittling" ;
  nervknut_nn_1_N = mkN "nervknut" ;
  nervretning_nn_1_N = mkN "nervretning" ;
  nervryckning_nn_1_N = mkN "nervryckning" ;
  nervsjukdom_nn_1_N = mkN "nervsjukdom" ;
  nervtraad_nn_1_1_N = mkN "nervtråd" ;
  nervaerdering_nn_1_1_N = mkN "nervärdering" ;
  nettobehaallning_nn_1_1_N = mkN "nettobehållning" ;
  neutralisering_nn_1_N = mkN "neutralisering" ;
  neutralitetsfoerklaring_nn_1_1_N = mkN "neutralitetsförklaring" ;
  neutrinofoertaetning_nn_1_1_N = mkN "neutrinoförtätning" ;
  neutronstraalning_nn_1_1_N = mkN "neutronstrålning" ;
  nickning_nn_1_N = mkN "nickning" ;
  nickpump_nn_1_N = mkN "nickpump" ;
  niellering_nn_1_N = mkN "niellering" ;
  nigning_nn_1_N = mkN "nigning" ;
  nioaaring_nn_1_1_N = mkN "nioåring" ;
  nitrering_nn_1_N = mkN "nitrering" ;
  nitrofoerening_nn_1_1_N = mkN "nitroförening" ;
  nittonaaring_nn_1_1_N = mkN "nittonåring" ;
  nivellering_nn_1_N = mkN "nivellering" ;
  nivaagruppering_nn_1_1_N = mkN "nivågruppering" ;
  njutning_nn_1_N = mkN "njutning" ;
  nobilisering_nn_1_N = mkN "nobilisering" ;
  nolledning_nn_1_N = mkN "nolledning" ;
  nollning_nn_1_N = mkN "nollning" ;
  nollspaenning_nn_1_1_N = mkN "nollspänning" ;
  nolltaxering_nn_1_N = mkN "nolltaxering" ;
  nomadisering_nn_1_N = mkN "nomadisering" ;
  nominering_nn_1_N = mkN "nominering" ;
  nonchalering_nn_1_N = mkN "nonchalering" ;
  nordanvind_nn_1_N = mkN "nordanvind" ;
  nordsluttning_nn_1_N = mkN "nordsluttning" ;
  normalfoerdelning_nn_1_1_N = mkN "normalfördelning" ;
  normalgaard_nn_1_1_N = mkN "normalgård" ;
  normalisering_nn_1_N = mkN "normalisering" ;
  normering_nn_1_N = mkN "normering" ;
  normupploesning_nn_1_1_N = mkN "normupplösning" ;
  norrbottning_nn_1_N = mkN "norrbottning" ;
  norrlandsaelv_nn_1_1_N = mkN "norrlandsälv" ;
  norrlaenning_nn_1_1_N = mkN "norrlänning" ;
  noshoerning_nn_1_1_N = mkN "noshörning" ;
  noshoerningskalv_nn_1_1_N = mkN "noshörningskalv" ;
  nosring_nn_1_N = mkN "nosring" ;
  notariatavdelning_nn_1_N = mkN "notariatavdelning" ;
  notdragning_nn_1_N = mkN "notdragning" ;
  notering_nn_1_N = mkN "notering" ;
  notificering_nn_1_N = mkN "notificering" ;
  notifiering_nn_1_N = mkN "notifiering" ;
  notisering_nn_1_N = mkN "notisering" ;
  notvaexling_nn_1_1_N = mkN "notväxling" ;
  novellpristaevling_nn_1_1_N = mkN "novellpristävling" ;
  novellsamling_nn_1_N = mkN "novellsamling" ;
  nummerkarl_nn_1_N = mkN "nummerkarl" ;
  nummerlapp_nn_1_N = mkN "nummerlapp" ;
  nummerskylt_nn_1_N = mkN "nummerskylt" ;
  nummerskyltsbelysning_nn_1_N = mkN "nummerskyltsbelysning" ;
  numrering_nn_1_N = mkN "numrering" ;
  nuppning_nn_1_N = mkN "nuppning" ;
  nutidsorientering_nn_1_N = mkN "nutidsorientering" ;
  nutidsskildring_nn_1_N = mkN "nutidsskildring" ;
  nyanlaeggning_nn_1_1_N = mkN "nyanläggning" ;
  nyansering_nn_1_N = mkN "nyansering" ;
  nyanskaffning_nn_1_N = mkN "nyanskaffning" ;
  nyanstaellning_nn_1_1_N = mkN "nyanställning" ;
  nybearbetning_nn_1_N = mkN "nybearbetning" ;
  nybildning_nn_1_N = mkN "nybildning" ;
  nyckelretning_nn_1_N = mkN "nyckelretning" ;
  nydaning_nn_1_N = mkN "nydaning" ;
  nyemittering_nn_1_N = mkN "nyemittering" ;
  nyeroevring_nn_1_1_N = mkN "nyerövring" ;
  nyetablering_nn_1_N = mkN "nyetablering" ;
  nyhetisering_nn_1_N = mkN "nyhetisering" ;
  nyhetsbevakning_nn_1_N = mkN "nyhetsbevakning" ;
  nyhetsfoermedling_nn_1_1_N = mkN "nyhetsförmedling" ;
  nyhetsvaerdering_nn_1_1_N = mkN "nyhetsvärdering" ;
  nyintagning_nn_1_N = mkN "nyintagning" ;
  nyinvestering_nn_1_N = mkN "nyinvestering" ;
  nykomling_nn_1_N = mkN "nykomling" ;
  nykterhetsfoerening_nn_1_1_N = mkN "nykterhetsförening" ;
  nylonstraeng_nn_1_1_N = mkN "nylonsträng" ;
  nylaenning_nn_1_1_N = mkN "nylänning" ;
  nylaesning_nn_1_1_N = mkN "nyläsning" ;
  nyodling_nn_1_N = mkN "nyodling" ;
  nyordning_nn_1_N = mkN "nyordning" ;
  nyorientering_nn_1_N = mkN "nyorientering" ;
  nyplantering_nn_1_N = mkN "nyplantering" ;
  nypning_nn_1_N = mkN "nypning" ;
  nyrekrytering_nn_1_N = mkN "nyrekrytering" ;
  nysning_nn_1_N = mkN "nysning" ;
  nystavning_nn_1_N = mkN "nystavning" ;
  nystning_nn_1_N = mkN "nystning" ;
  nytolkning_nn_1_N = mkN "nytolkning" ;
  nytaendning_nn_1_1_N = mkN "nytändning" ;
  nyuppsaettning_nn_1_1_N = mkN "nyuppsättning" ;
  nyzeelaenning_nn_1_1_N = mkN "nyzeelänning" ;
  nyaarsdag_nn_1_1_N = mkN "nyårsdag" ;
  naering_nn_1_1_N = mkN "näring" ;
  naeringslivstopp_nn_1_1_N = mkN "näringslivstopp" ;
  naeringsloesning_nn_1_1_N = mkN "näringslösning" ;
  naerspaning_nn_1_1_N = mkN "närspaning" ;
  naesandning_nn_1_1_N = mkN "näsandning" ;
  naesgaang_nn_1_1_N = mkN "näsgång" ;
  naesring_nn_1_1_N = mkN "näsring" ;
  naetbevakning_nn_1_1_N = mkN "nätbevakning" ;
  naetbluff_nn_1_1_N = mkN "nätbluff" ;
  naetbokning_nn_1_1_N = mkN "nätbokning" ;
  naetboll_nn_1_1_N = mkN "nätboll" ;
  naetdoerr_nn_1_1_N = mkN "nätdörr" ;
  naetspaenning_nn_1_1_N = mkN "nätspänning" ;
  naettidning_nn_1_1_N = mkN "nättidning" ;
  naettopp_nn_1_1_N = mkN "nättopp" ;
  naeverkorg_nn_1_1_N = mkN "näverkorg" ;
  naeverlur_nn_1_1_N = mkN "näverlur" ;
  naadastoet_nn_1_1_N = mkN "nådastöt" ;
  naadeansoekning_nn_1_1_N = mkN "nådeansökning" ;
  naadning_nn_1_1_N = mkN "nådning" ;
  naalfil_nn_1_1_N = mkN "nålfil" ;
  noedfallsutvaeg_nn_1_1_N = mkN "nödfallsutväg" ;
  noedlandning_nn_1_1_N = mkN "nödlandning" ;
  noedloesning_nn_1_1_N = mkN "nödlösning" ;
  noedsignalering_nn_1_1_N = mkN "nödsignalering" ;
  noedutgaang_nn_1_1_N = mkN "nödutgång" ;
  noejdfoerklaring_nn_1_1_N = mkN "nöjdförklaring" ;
  noejesbaat_nn_1_1_N = mkN "nöjesbåt" ;
  noejeskoerning_nn_1_1_N = mkN "nöjeskörning" ;
  noetning_nn_1_1_N = mkN "nötning" ;
  obducering_nn_1_N = mkN "obducering" ;
  obildning_nn_1_N = mkN "obildning" ;
  objektivering_nn_1_N = mkN "objektivering" ;
  obligering_nn_1_N = mkN "obligering" ;
  observering_nn_1_N = mkN "observering" ;
  obstruering_nn_1_N = mkN "obstruering" ;
  occidentalisering_nn_1_N = mkN "occidentalisering" ;
  ockupering_nn_1_N = mkN "ockupering" ;
  odling_nn_1_N = mkN "odling" ;
  offerering_nn_1_N = mkN "offerering" ;
  offerstock_nn_1_N = mkN "offerstock" ;
  officiering_nn_1_N = mkN "officiering" ;
  ograesbekaempning_nn_1_1_N = mkN "ogräsbekämpning" ;
  ogaerning_nn_1_1_N = mkN "ogärning" ;
  oktavering_nn_1_N = mkN "oktavering" ;
  oktrojering_nn_1_N = mkN "oktrojering" ;
  okulering_nn_1_N = mkN "okulering" ;
  oljebekaempning_nn_1_1_N = mkN "oljebekämpning" ;
  oljeborrning_nn_1_N = mkN "oljeborrning" ;
  oljeeldning_nn_1_N = mkN "oljeeldning" ;
  oljeinpackning_nn_1_N = mkN "oljeinpackning" ;
  oljeledning_nn_1_N = mkN "oljeledning" ;
  oljemaalning_nn_1_1_N = mkN "oljemålning" ;
  oljerigg_nn_1_N = mkN "oljerigg" ;
  oljering_nn_1_N = mkN "oljering" ;
  oljesanering_nn_1_N = mkN "oljesanering" ;
  oljeutvinning_nn_1_N = mkN "oljeutvinning" ;
  ollning_nn_1_N = mkN "ollning" ;
  ollonskog_nn_1_N = mkN "ollonskog" ;
  olycksfallsfoersaekring_nn_1_1_N = mkN "olycksfallsförsäkring" ;
  olyckskorp_nn_1_N = mkN "olyckskorp" ;
  omarbetning_nn_1_N = mkN "omarbetning" ;
  ombesoerjning_nn_1_1_N = mkN "ombesörjning" ;
  ombildning_nn_1_N = mkN "ombildning" ;
  omblandning_nn_1_N = mkN "omblandning" ;
  ombordlaeggning_nn_1_1_N = mkN "ombordläggning" ;
  ombrytning_nn_1_N = mkN "ombrytning" ;
  omdaning_nn_1_N = mkN "omdaning" ;
  omdirigering_nn_1_N = mkN "omdirigering" ;
  omfamning_nn_1_N = mkN "omfamning" ;
  omfattning_nn_1_N = mkN "omfattning" ;
  omflyttning_nn_1_N = mkN "omflyttning" ;
  omformning_nn_1_N = mkN "omformning" ;
  omfoerdelning_nn_1_1_N = mkN "omfördelning" ;
  omfoermaelning_nn_1_1_N = mkN "omförmälning" ;
  omgestaltning_nn_1_N = mkN "omgestaltning" ;
  omgivning_nn_1_N = mkN "omgivning" ;
  omgjutning_nn_1_N = mkN "omgjutning" ;
  omgruppering_nn_1_N = mkN "omgruppering" ;
  omgaerdning_nn_1_1_N = mkN "omgärdning" ;
  omgaang_nn_1_1_N = mkN "omgång" ;
  omhuldning_nn_1_N = mkN "omhuldning" ;
  omkalfatring_nn_1_N = mkN "omkalfatring" ;
  omkastning_nn_1_N = mkN "omkastning" ;
  omklaedning_nn_1_1_N = mkN "omklädning" ;
  omkostymering_nn_1_N = mkN "omkostymering" ;
  omkoerning_nn_1_1_N = mkN "omkörning" ;
  omladdning_nn_1_N = mkN "omladdning" ;
  omlaeggning_nn_1_1_N = mkN "omläggning" ;
  ommaalning_nn_1_1_N = mkN "ommålning" ;
  ommoeblering_nn_1_1_N = mkN "ommöblering" ;
  omorganisering_nn_1_N = mkN "omorganisering" ;
  omplacering_nn_1_N = mkN "omplacering" ;
  omplantering_nn_1_N = mkN "omplantering" ;
  omproevning_nn_1_1_N = mkN "omprövning" ;
  omramning_nn_1_N = mkN "omramning" ;
  omredigering_nn_1_N = mkN "omredigering" ;
  omreglering_nn_1_N = mkN "omreglering" ;
  omringning_nn_1_N = mkN "omringning" ;
  omraekning_nn_1_1_N = mkN "omräkning" ;
  omroering_nn_1_1_N = mkN "omröring" ;
  omroerning_nn_1_1_N = mkN "omrörning" ;
  omroestning_nn_1_1_N = mkN "omröstning" ;
  omsegling_nn_1_N = mkN "omsegling" ;
  omskolning_nn_1_N = mkN "omskolning" ;
  omskrivning_nn_1_N = mkN "omskrivning" ;
  omskulpturering_nn_1_N = mkN "omskulpturering" ;
  omslutning_nn_1_N = mkN "omslutning" ;
  omspinning_nn_1_N = mkN "omspinning" ;
  omspaenning_nn_1_1_N = mkN "omspänning" ;
  omstigning_nn_1_N = mkN "omstigning" ;
  omstrukturering_nn_1_N = mkN "omstrukturering" ;
  omstaellning_nn_1_1_N = mkN "omställning" ;
  omstoepning_nn_1_1_N = mkN "omstöpning" ;
  omsvaengning_nn_1_1_N = mkN "omsvängning" ;
  omsaettning_nn_1_1_N = mkN "omsättning" ;
  omsaettningstillgaang_nn_1_1_N = mkN "omsättningstillgång" ;
  omtagning_nn_1_N = mkN "omtagning" ;
  omtolkning_nn_1_N = mkN "omtolkning" ;
  omtuggning_nn_1_N = mkN "omtuggning" ;
  omvandling_nn_1_N = mkN "omvandling" ;
  omvaeg_nn_1_1_N = mkN "omväg" ;
  omvaeljning_nn_1_1_N = mkN "omväljning" ;
  omvaelvning_nn_1_1_N = mkN "omvälvning" ;
  omvaendning_nn_1_1_N = mkN "omvändning" ;
  omvaerdering_nn_1_1_N = mkN "omvärdering" ;
  omvaerld_nn_1_1_N = mkN "omvärld" ;
  omvaexling_nn_1_1_N = mkN "omväxling" ;
  omyndigfoerklaring_nn_1_1_N = mkN "omyndigförklaring" ;
  omyndighetsfoerklaring_nn_1_1_N = mkN "omyndighetsförklaring" ;
  onanering_nn_1_N = mkN "onanering" ;
  onanisering_nn_1_N = mkN "onanisering" ;
  ondulering_nn_1_N = mkN "ondulering" ;
  onsdag_nn_1_N = mkN "onsdag" ;
  oordning_nn_1_N = mkN "oordning" ;
  operationalisering_nn_1_N = mkN "operationalisering" ;
  operationsring_nn_1_N = mkN "operationsring" ;
  operationssal_nn_1_N = mkN "operationssal" ;
  operering_nn_1_N = mkN "operering" ;
  opinering_nn_1_N = mkN "opinering" ;
  opinionsbildning_nn_1_N = mkN "opinionsbildning" ;
  opinionsmaetning_nn_1_1_N = mkN "opinionsmätning" ;
  opinionssvaengning_nn_1_1_N = mkN "opinionssvängning" ;
  opinionsundersoekning_nn_1_1_N = mkN "opinionsundersökning" ;
  opinionsyttring_nn_1_N = mkN "opinionsyttring" ;
  opparbetning_nn_1_N = mkN "opparbetning" ;
  oppassning_nn_1_N = mkN "oppassning" ;
  oppbackning_nn_1_N = mkN "oppbackning" ;
  oppbindning_nn_1_N = mkN "oppbindning" ;
  oppblaasning_nn_1_1_N = mkN "oppblåsning" ;
  oppdatering_nn_1_N = mkN "oppdatering" ;
  oppdelning_nn_1_N = mkN "oppdelning" ;
  oppdukning_nn_1_N = mkN "oppdukning" ;
  oppfattning_nn_1_N = mkN "oppfattning" ;
  oppfinning_nn_1_N = mkN "oppfinning" ;
  oppfostring_nn_1_N = mkN "oppfostring" ;
  oppfoedning_nn_1_1_N = mkN "oppfödning" ;
  oppfoeljning_nn_1_1_N = mkN "oppföljning" ;
  oppgaang_nn_1_1_N = mkN "oppgång" ;
  opphetsning_nn_1_N = mkN "opphetsning" ;
  opphettning_nn_1_N = mkN "opphettning" ;
  opphostning_nn_1_N = mkN "opphostning" ;
  opphottning_nn_1_N = mkN "opphottning" ;
  opphaemtning_nn_1_1_N = mkN "opphämtning" ;
  opphaengning_nn_1_1_N = mkN "opphängning" ;
  opphoejning_nn_1_1_N = mkN "opphöjning" ;
  oppjustering_nn_1_N = mkN "oppjustering" ;
  oppkastning_nn_1_N = mkN "oppkastning" ;
  oppkoerning_nn_1_1_N = mkN "oppkörning" ;
  oppkoersvaeg_nn_1_1_N = mkN "oppkörsväg" ;
  oppladdning_nn_1_N = mkN "oppladdning" ;
  opplaeggning_nn_1_1_N = mkN "oppläggning" ;
  opponering_nn_1_N = mkN "opponering" ;
  oppraekning_nn_1_1_N = mkN "oppräkning" ;
  oppskjutning_nn_1_N = mkN "oppskjutning" ;
  oppskrivning_nn_1_N = mkN "oppskrivning" ;
  oppstaellning_nn_1_1_N = mkN "oppställning" ;
  oppstoetning_nn_1_1_N = mkN "oppstötning" ;
  oppsugning_nn_1_N = mkN "oppsugning" ;
  oppsummering_nn_1_N = mkN "oppsummering" ;
  opptagning_nn_1_N = mkN "opptagning" ;
  oppvaktning_nn_1_N = mkN "oppvaktning" ;
  oppvisning_nn_1_N = mkN "oppvisning" ;
  oppvaegning_nn_1_1_N = mkN "oppvägning" ;
  oppvaerdering_nn_1_1_N = mkN "oppvärdering" ;
  optering_nn_1_N = mkN "optering" ;
  optimering_nn_1_N = mkN "optimering" ;
  ordbehandling_nn_1_N = mkN "ordbehandling" ;
  ordbildning_nn_1_N = mkN "ordbildning" ;
  ordboejning_nn_1_1_N = mkN "ordböjning" ;
  orderstock_nn_1_N = mkN "orderstock" ;
  ordfogning_nn_1_N = mkN "ordfogning" ;
  ordfoerklaring_nn_1_1_N = mkN "ordförklaring" ;
  ordinering_nn_1_N = mkN "ordinering" ;
  ordklassindelning_nn_1_N = mkN "ordklassindelning" ;
  ordning_nn_1_N = mkN "ordning" ;
  ordrikedom_nn_1_N = mkN "ordrikedom" ;
  ordvaendning_nn_1_1_N = mkN "ordvändning" ;
  ordvaexling_nn_1_1_N = mkN "ordväxling" ;
  orering_nn_1_N = mkN "orering" ;
  organisering_nn_1_N = mkN "organisering" ;
  orientering_nn_1_N = mkN "orientering" ;
  orienteringstaevling_nn_1_1_N = mkN "orienteringstävling" ;
  orkesterfoerening_nn_1_1_N = mkN "orkesterförening" ;
  orkestrering_nn_1_N = mkN "orkestrering" ;
  ormknut_nn_1_N = mkN "ormknut" ;
  ormoern_nn_1_1_N = mkN "ormörn" ;
  ornamentering_nn_1_N = mkN "ornamentering" ;
  ornering_nn_1_N = mkN "ornering" ;
  ortnamnsforskning_nn_1_N = mkN "ortnamnsforskning" ;
  osanning_nn_1_N = mkN "osanning" ;
  oscillering_nn_1_N = mkN "oscillering" ;
  ostframstaellning_nn_1_1_N = mkN "ostframställning" ;
  ostkrok_nn_1_N = mkN "ostkrok" ;
  ostronfoergiftning_nn_1_1_N = mkN "ostronförgiftning" ;
  ostronkniv_nn_1_N = mkN "ostronkniv" ;
  osynliggoering_nn_1_1_N = mkN "osynliggöring" ;
  ovalsvarvning_nn_1_N = mkN "ovalsvarvning" ;
  ovanvaaning_nn_1_1_N = mkN "ovanvåning" ;
  oxidering_nn_1_N = mkN "oxidering" ;
  oxstek_nn_1_N = mkN "oxstek" ;
  oxvandring_nn_1_N = mkN "oxvandring" ;
  ozonminskning_nn_1_N = mkN "ozonminskning" ;
  pacificering_nn_1_N = mkN "pacificering" ;
  packkorg_nn_1_N = mkN "packkorg" ;
  packning_nn_1_N = mkN "packning" ;
  paginering_nn_1_N = mkN "paginering" ;
  pajdeg_nn_1_N = mkN "pajdeg" ;
  pajkastning_nn_1_N = mkN "pajkastning" ;
  paketering_nn_1_N = mkN "paketering" ;
  paketinlaemning_nn_1_1_N = mkN "paketinlämning" ;
  paketloesning_nn_1_1_N = mkN "paketlösning" ;
  paketutlaemning_nn_1_1_N = mkN "paketutlämning" ;
  palatalisering_nn_1_N = mkN "palatalisering" ;
  palatsmur_nn_1_N = mkN "palatsmur" ;
  palettkniv_nn_1_N = mkN "palettkniv" ;
  paljettering_nn_1_N = mkN "paljettering" ;
  paljettklaenning_nn_1_1_N = mkN "paljettklänning" ;
  palpering_nn_1_N = mkN "palpering" ;
  paltrockkvarn_nn_1_N = mkN "paltrockkvarn" ;
  panamahatt_nn_1_N = mkN "panamahatt" ;
  panaschering_nn_1_N = mkN "panaschering" ;
  panering_nn_1_N = mkN "panering" ;
  panorering_nn_1_N = mkN "panorering" ;
  pansarbaat_nn_1_1_N = mkN "pansarbåt" ;
  pansarplaat_nn_1_1_N = mkN "pansarplåt" ;
  pantburk_nn_1_N = mkN "pantburk" ;
  pantning_nn_1_N = mkN "pantning" ;
  pantografering_nn_1_N = mkN "pantografering" ;
  pappburk_nn_1_N = mkN "pappburk" ;
  pappersbit_nn_1_N = mkN "pappersbit" ;
  pappersbunt_nn_1_N = mkN "pappersbunt" ;
  pappersinsamling_nn_1_N = mkN "pappersinsamling" ;
  papperskniv_nn_1_N = mkN "papperskniv" ;
  papperslapp_nn_1_N = mkN "papperslapp" ;
  pappersmugg_nn_1_N = mkN "pappersmugg" ;
  papperssaeck_nn_1_1_N = mkN "papperssäck" ;
  papperstallrik_nn_1_N = mkN "papperstallrik" ;
  papperstidning_nn_1_N = mkN "papperstidning" ;
  papperstillverkning_nn_1_N = mkN "papperstillverkning" ;
  pappskylt_nn_1_N = mkN "pappskylt" ;
  papptallrik_nn_1_N = mkN "papptallrik" ;
  paprikaring_nn_1_N = mkN "paprikaring" ;
  paradering_nn_1_N = mkN "paradering" ;
  paradmaalning_nn_1_1_N = mkN "paradmålning" ;
  paraduppstaellning_nn_1_1_N = mkN "paraduppställning" ;
  parafering_nn_1_N = mkN "parafering" ;
  paraffinering_nn_1_N = mkN "paraffinering" ;
  parafrasering_nn_1_N = mkN "parafrasering" ;
  parallellisering_nn_1_N = mkN "parallellisering" ;
  parallellkoppling_nn_1_N = mkN "parallellkoppling" ;
  parallellvaerld_nn_1_1_N = mkN "parallellvärld" ;
  paralysering_nn_1_N = mkN "paralysering" ;
  parasitering_nn_1_N = mkN "parasitering" ;
  parentering_nn_1_N = mkN "parentering" ;
  parering_nn_1_N = mkN "parering" ;
  parfymering_nn_1_N = mkN "parfymering" ;
  parkering_nn_1_N = mkN "parkering" ;
  parkettering_nn_1_N = mkN "parkettering" ;
  parlamentering_nn_1_N = mkN "parlamentering" ;
  parlering_nn_1_N = mkN "parlering" ;
  parning_nn_1_N = mkN "parning" ;
  parodiering_nn_1_N = mkN "parodiering" ;
  partibildning_nn_1_N = mkN "partibildning" ;
  partikelstraalning_nn_1_1_N = mkN "partikelstrålning" ;
  partiledarutfraagning_nn_1_1_N = mkN "partiledarutfrågning" ;
  partiledning_nn_1_N = mkN "partiledning" ;
  partispraengning_nn_1_1_N = mkN "partisprängning" ;
  partispaerr_nn_1_1_N = mkN "partispärr" ;
  partisympatimaetning_nn_1_1_N = mkN "partisympatimätning" ;
  partitopp_nn_1_N = mkN "partitopp" ;
  paraakning_nn_1_1_N = mkN "paråkning" ;
  passadvind_nn_1_N = mkN "passadvind" ;
  passagerarbaat_nn_1_1_N = mkN "passagerarbåt" ;
  passagerarstol_nn_1_N = mkN "passagerarstol" ;
  passering_nn_1_N = mkN "passering" ;
  passivering_nn_1_N = mkN "passivering" ;
  passivisering_nn_1_N = mkN "passivisering" ;
  passning_nn_1_N = mkN "passning" ;
  pastellmaalning_nn_1_1_N = mkN "pastellmålning" ;
  pastoerisering_nn_1_1_N = mkN "pastörisering" ;
  patentering_nn_1_N = mkN "patentering" ;
  patinering_nn_1_N = mkN "patinering" ;
  patrullbil_nn_1_N = mkN "patrullbil" ;
  patrullbaat_nn_1_1_N = mkN "patrullbåt" ;
  patrullering_nn_1_N = mkN "patrullering" ;
  pauperisering_nn_1_N = mkN "pauperisering" ;
  pausering_nn_1_N = mkN "pausering" ;
  pauskommatering_nn_1_N = mkN "pauskommatering" ;
  pejling_nn_1_N = mkN "pejling" ;
  pekning_nn_1_N = mkN "pekning" ;
  pekskaerm_nn_1_1_N = mkN "pekskärm" ;
  pelargaang_nn_1_1_N = mkN "pelargång" ;
  pelarhall_nn_1_N = mkN "pelarhall" ;
  pelarsal_nn_1_N = mkN "pelarsal" ;
  pelletering_nn_1_N = mkN "pelletering" ;
  pendeltaagsavgaang_nn_1_1_N = mkN "pendeltågsavgång" ;
  penetrering_nn_1_N = mkN "penetrering" ;
  penisring_nn_1_N = mkN "penisring" ;
  penninghushaallning_nn_1_1_N = mkN "penninghushållning" ;
  penninginsamling_nn_1_N = mkN "penninginsamling" ;
  penningpung_nn_1_N = mkN "penningpung" ;
  penningtilldelning_nn_1_N = mkN "penningtilldelning" ;
  pennteckning_nn_1_N = mkN "pennteckning" ;
  penselfoering_nn_1_1_N = mkN "penselföring" ;
  pensionering_nn_1_N = mkN "pensionering" ;
  pensioneringsdag_nn_1_N = mkN "pensioneringsdag" ;
  pensionsfoersaekring_nn_1_1_N = mkN "pensionsförsäkring" ;
  pensionsinbetalning_nn_1_N = mkN "pensionsinbetalning" ;
  pensling_nn_1_N = mkN "pensling" ;
  pepparkaksdeg_nn_1_N = mkN "pepparkaksdeg" ;
  pepparkvarn_nn_1_N = mkN "pepparkvarn" ;
  perceptionsstoerning_nn_1_1_N = mkN "perceptionsstörning" ;
  percipiering_nn_1_N = mkN "percipiering" ;
  perennering_nn_1_N = mkN "perennering" ;
  perforering_nn_1_N = mkN "perforering" ;
  pergamentbit_nn_1_N = mkN "pergamentbit" ;
  periodindelning_nn_1_N = mkN "periodindelning" ;
  periodisering_nn_1_N = mkN "periodisering" ;
  permanentondulering_nn_1_N = mkN "permanentondulering" ;
  permittering_nn_1_N = mkN "permittering" ;
  permutering_nn_1_N = mkN "permutering" ;
  persiflering_nn_1_N = mkN "persiflering" ;
  personalavdelning_nn_1_N = mkN "personalavdelning" ;
  personalingaang_nn_1_1_N = mkN "personalingång" ;
  personalmatsal_nn_1_N = mkN "personalmatsal" ;
  personaltidning_nn_1_N = mkN "personaltidning" ;
  personalutbildning_nn_1_N = mkN "personalutbildning" ;
  personbeskrivning_nn_1_N = mkN "personbeskrivning" ;
  personbil_nn_1_N = mkN "personbil" ;
  personfoersaekring_nn_1_1_N = mkN "personförsäkring" ;
  personifiering_nn_1_N = mkN "personifiering" ;
  personkryssning_nn_1_N = mkN "personkryssning" ;
  personlighetsklyvning_nn_1_N = mkN "personlighetsklyvning" ;
  personlighetsstoerning_nn_1_1_N = mkN "personlighetsstörning" ;
  personsammansaettning_nn_1_1_N = mkN "personsammansättning" ;
  personundersoekning_nn_1_1_N = mkN "personundersökning" ;
  personvaag_nn_1_1_N = mkN "personvåg" ;
  perspektivfoerflyttning_nn_1_1_N = mkN "perspektivförflyttning" ;
  perspektivfoerskjutning_nn_1_1_N = mkN "perspektivförskjutning" ;
  persvadering_nn_1_N = mkN "persvadering" ;
  perukstock_nn_1_N = mkN "perukstock" ;
  pervertering_nn_1_N = mkN "pervertering" ;
  peterspenning_nn_1_N = mkN "peterspenning" ;
  petning_nn_1_N = mkN "petning" ;
  petrifiering_nn_1_N = mkN "petrifiering" ;
  pianospelning_nn_1_N = mkN "pianospelning" ;
  pianostol_nn_1_N = mkN "pianostol" ;
  pigmentering_nn_1_N = mkN "pigmentering" ;
  pikering_nn_1_N = mkN "pikering" ;
  piketbil_nn_1_N = mkN "piketbil" ;
  pilkastning_nn_1_N = mkN "pilkastning" ;
  pillerburk_nn_1_N = mkN "pillerburk" ;
  pilotundersoekning_nn_1_1_N = mkN "pilotundersökning" ;
  pilsnerkorv_nn_1_N = mkN "pilsnerkorv" ;
  pincering_nn_1_N = mkN "pincering" ;
  ping_pongboll_nn_1_N = mkN "ping-pongboll" ;
  pingpongboll_nn_1_N = mkN "pingpongboll" ;
  pinkning_nn_1_N = mkN "pinkning" ;
  pinnstol_nn_1_N = mkN "pinnstol" ;
  piruettering_nn_1_N = mkN "piruettering" ;
  piskning_nn_1_N = mkN "piskning" ;
  piskstaellning_nn_1_1_N = mkN "piskställning" ;
  pitepalt_nn_1_N = mkN "pitepalt" ;
  pivotering_nn_1_N = mkN "pivotering" ;
  pizzabit_nn_1_N = mkN "pizzabit" ;
  pjatthatt_nn_1_N = mkN "pjatthatt" ;
  placering_nn_1_N = mkN "placering" ;
  pladderblogg_nn_1_N = mkN "pladderblogg" ;
  plagiering_nn_1_N = mkN "plagiering" ;
  planering_nn_1_N = mkN "planering" ;
  planetbildning_nn_1_N = mkN "planetbildning" ;
  planhushaallning_nn_1_1_N = mkN "planhushållning" ;
  plankgaang_nn_1_1_N = mkN "plankgång" ;
  plankorsning_nn_1_N = mkN "plankorsning" ;
  plankstek_nn_1_N = mkN "plankstek" ;
  planlaeggning_nn_1_1_N = mkN "planläggning" ;
  planloesning_nn_1_1_N = mkN "planlösning" ;
  planmaetning_nn_1_1_N = mkN "planmätning" ;
  planritning_nn_1_N = mkN "planritning" ;
  plantering_nn_1_N = mkN "plantering" ;
  plaskdamm_nn_1_N = mkN "plaskdamm" ;
  plaskning_nn_1_N = mkN "plaskning" ;
  plastback_nn_1_N = mkN "plastback" ;
  plastdunk_nn_1_N = mkN "plastdunk" ;
  plastkork_nn_1_N = mkN "plastkork" ;
  plastlur_nn_1_N = mkN "plastlur" ;
  plastpil_nn_1_N = mkN "plastpil" ;
  plastpryl_nn_1_N = mkN "plastpryl" ;
  plastring_nn_1_N = mkN "plastring" ;
  plastsked_nn_1_N = mkN "plastsked" ;
  plastsaeck_nn_1_1_N = mkN "plastsäck" ;
  platinering_nn_1_N = mkN "platinering" ;
  platsansoekning_nn_1_1_N = mkN "platsansökning" ;
  plattfil_nn_1_N = mkN "plattfil" ;
  plattform_nn_1_N = mkN "plattform" ;
  plattfoting_nn_1_N = mkN "plattfoting" ;
  plattlaeggning_nn_1_1_N = mkN "plattläggning" ;
  pliggning_nn_1_N = mkN "pliggning" ;
  pliktfaellning_nn_1_1_N = mkN "pliktfällning" ;
  plissering_nn_1_N = mkN "plissering" ;
  plockning_nn_1_N = mkN "plockning" ;
  plombering_nn_1_N = mkN "plombering" ;
  pluggning_nn_1_N = mkN "pluggning" ;
  plumpning_nn_1_N = mkN "plumpning" ;
  plundring_nn_1_N = mkN "plundring" ;
  plaedering_nn_1_1_N = mkN "plädering" ;
  plaetering_nn_1_1_N = mkN "plätering" ;
  plaatfaelg_nn_1_1_N = mkN "plåtfälg" ;
  plaathuv_nn_1_1_N = mkN "plåthuv" ;
  ploejning_nn_1_1_N = mkN "plöjning" ;
  pochering_nn_1_N = mkN "pochering" ;
  poesilaesning_nn_1_1_N = mkN "poesiläsning" ;
  pointering_nn_1_N = mkN "pointering" ;
  pojkskildring_nn_1_N = mkN "pojkskildring" ;
  pojkvaerld_nn_1_1_N = mkN "pojkvärld" ;
  pokulering_nn_1_N = mkN "pokulering" ;
  polarforskning_nn_1_N = mkN "polarforskning" ;
  polarisering_nn_1_N = mkN "polarisering" ;
  polemisering_nn_1_N = mkN "polemisering" ;
  polerduk_nn_1_N = mkN "polerduk" ;
  polering_nn_1_N = mkN "polering" ;
  polersvamp_nn_1_N = mkN "polersvamp" ;
  polhemsknut_nn_1_N = mkN "polhemsknut" ;
  polisanmaelning_nn_1_1_N = mkN "polisanmälning" ;
  polisbevakning_nn_1_N = mkN "polisbevakning" ;
  polisbil_nn_1_N = mkN "polisbil" ;
  polisfoerordning_nn_1_1_N = mkN "polisförordning" ;
  polishjaelm_nn_1_1_N = mkN "polishjälm" ;
  polisspaning_nn_1_N = mkN "polisspaning" ;
  polistjaenstgoering_nn_1_1_N = mkN "polistjänstgöring" ;
  polisundersoekning_nn_1_1_N = mkN "polisundersökning" ;
  polisutryckning_nn_1_N = mkN "polisutryckning" ;
  politisering_nn_1_N = mkN "politisering" ;
  pollenslang_nn_1_N = mkN "pollenslang" ;
  pollettering_nn_1_N = mkN "pollettering" ;
  pollinering_nn_1_N = mkN "pollinering" ;
  poloboll_nn_1_N = mkN "poloboll" ;
  polvaendning_nn_1_1_N = mkN "polvändning" ;
  polymerbelaeggning_nn_1_1_N = mkN "polymerbeläggning" ;
  polymerloesning_nn_1_1_N = mkN "polymerlösning" ;
  pomadering_nn_1_N = mkN "pomadering" ;
  ponering_nn_1_N = mkN "ponering" ;
  popularisering_nn_1_N = mkN "popularisering" ;
  porrklubb_nn_1_N = mkN "porrklubb" ;
  porrtidning_nn_1_N = mkN "porrtidning" ;
  porslinskrossning_nn_1_N = mkN "porslinskrossning" ;
  porslinsmaalning_nn_1_1_N = mkN "porslinsmålning" ;
  porslinssaekring_nn_1_1_N = mkN "porslinssäkring" ;
  porslinstillverkning_nn_1_N = mkN "porslinstillverkning" ;
  portgaang_nn_1_1_N = mkN "portgång" ;
  portingaang_nn_1_1_N = mkN "portingång" ;
  portionering_nn_1_N = mkN "portionering" ;
  portraettering_nn_1_1_N = mkN "porträttering" ;
  portuppgaang_nn_1_1_N = mkN "portuppgång" ;
  posering_nn_1_N = mkN "posering" ;
  positionsbestaemning_nn_1_1_N = mkN "positionsbestämning" ;
  postanvisning_nn_1_N = mkN "postanvisning" ;
  postbaat_nn_1_1_N = mkN "postbåt" ;
  postdatering_nn_1_N = mkN "postdatering" ;
  postering_nn_1_N = mkN "postering" ;
  postponering_nn_1_N = mkN "postponering" ;
  postulering_nn_1_N = mkN "postulering" ;
  postutdelning_nn_1_N = mkN "postutdelning" ;
  potatisskoerd_nn_1_1_N = mkN "potatisskörd" ;
  poaengstaellning_nn_1_1_N = mkN "poängställning" ;
  poaengtering_nn_1_1_N = mkN "poängtering" ;
  praktiktjaenstgoering_nn_1_1_N = mkN "praktiktjänstgöring" ;
  praktisering_nn_1_N = mkN "praktisering" ;
  praktmaalning_nn_1_1_N = mkN "praktmålning" ;
  precisering_nn_1_N = mkN "precisering" ;
  precisionsskjutning_nn_1_N = mkN "precisionsskjutning" ;
  predestinering_nn_1_N = mkN "predestinering" ;
  predicering_nn_1_N = mkN "predicering" ;
  predikning_nn_1_N = mkN "predikning" ;
  predikosamling_nn_1_N = mkN "predikosamling" ;
  predisponering_nn_1_N = mkN "predisponering" ;
  predominering_nn_1_N = mkN "predominering" ;
  prefabricering_nn_1_N = mkN "prefabricering" ;
  prefigering_nn_1_N = mkN "prefigering" ;
  prejning_nn_1_N = mkN "prejning" ;
  preludiering_nn_1_N = mkN "preludiering" ;
  premiering_nn_1_N = mkN "premiering" ;
  prenumerering_nn_1_N = mkN "prenumerering" ;
  preparering_nn_1_N = mkN "preparering" ;
  presentering_nn_1_N = mkN "presentering" ;
  preservering_nn_1_N = mkN "preservering" ;
  presidering_nn_1_N = mkN "presidering" ;
  preskribering_nn_1_N = mkN "preskribering" ;
  presslaeggning_nn_1_1_N = mkN "pressläggning" ;
  pressmottagning_nn_1_N = mkN "pressmottagning" ;
  pressning_nn_1_N = mkN "pressning" ;
  presstraeff_nn_1_1_N = mkN "pressträff" ;
  prestavering_nn_1_N = mkN "prestavering" ;
  prestering_nn_1_N = mkN "prestering" ;
  presumering_nn_1_N = mkN "presumering" ;
  pretendering_nn_1_N = mkN "pretendering" ;
  prickning_nn_1_N = mkN "prickning" ;
  prickskytt_nn_1_N = mkN "prickskytt" ;
  principfoerklaring_nn_1_1_N = mkN "principförklaring" ;
  prinsessklaenning_nn_1_1_N = mkN "prinsessklänning" ;
  prinsesstaartbit_nn_1_1_N = mkN "prinsesstårtbit" ;
  prinskorv_nn_1_N = mkN "prinskorv" ;
  prioritering_nn_1_N = mkN "prioritering" ;
  prioritetsordning_nn_1_N = mkN "prioritetsordning" ;
  prisbeloening_nn_1_1_N = mkN "prisbelöning" ;
  prisbluff_nn_1_N = mkN "prisbluff" ;
  prisfoeraendring_nn_1_1_N = mkN "prisförändring" ;
  prisgivning_nn_1_N = mkN "prisgivning" ;
  prishoejning_nn_1_1_N = mkN "prishöjning" ;
  prispall_nn_1_N = mkN "prispall" ;
  prisreglering_nn_1_N = mkN "prisreglering" ;
  prisstegring_nn_1_N = mkN "prisstegring" ;
  prissaettning_nn_1_1_N = mkN "prissättning" ;
  pristaevling_nn_1_1_N = mkN "pristävling" ;
  prisutdelning_nn_1_N = mkN "prisutdelning" ;
  prisoekning_nn_1_1_N = mkN "prisökning" ;
  privatbil_nn_1_N = mkN "privatbil" ;
  privategendom_nn_1_N = mkN "privategendom" ;
  privatisering_nn_1_N = mkN "privatisering" ;
  privatsnok_nn_1_N = mkN "privatsnok" ;
  privatsnut_nn_1_N = mkN "privatsnut" ;
  privilegiering_nn_1_N = mkN "privilegiering" ;
  probering_nn_1_N = mkN "probering" ;
  problemanlaeggning_nn_1_1_N = mkN "problemanläggning" ;
  problematisering_nn_1_N = mkN "problematisering" ;
  problemdeg_nn_1_N = mkN "problemdeg" ;
  problemdiktning_nn_1_N = mkN "problemdiktning" ;
  problemformulering_nn_1_N = mkN "problemformulering" ;
  problemorientering_nn_1_N = mkN "problemorientering" ;
  problemstaellning_nn_1_1_N = mkN "problemställning" ;
  processordning_nn_1_N = mkN "processordning" ;
  producering_nn_1_N = mkN "producering" ;
  produktplanering_nn_1_N = mkN "produktplanering" ;
  profanering_nn_1_N = mkN "profanering" ;
  professionalisering_nn_1_N = mkN "professionalisering" ;
  professorstillsaettning_nn_1_1_N = mkN "professorstillsättning" ;
  profetering_nn_1_N = mkN "profetering" ;
  profilering_nn_1_N = mkN "profilering" ;
  profitering_nn_1_N = mkN "profitering" ;
  prognostisering_nn_1_N = mkN "prognostisering" ;
  programbudgetering_nn_1_N = mkN "programbudgetering" ;
  programfoerklaring_nn_1_1_N = mkN "programförklaring" ;
  programmering_nn_1_N = mkN "programmering" ;
  programstyrning_nn_1_N = mkN "programstyrning" ;
  programvaerd_nn_1_1_N = mkN "programvärd" ;
  progressivfjaedring_nn_1_1_N = mkN "progressivfjädring" ;
  projektering_nn_1_N = mkN "projektering" ;
  projicering_nn_1_N = mkN "projicering" ;
  proklamering_nn_1_N = mkN "proklamering" ;
  proletarisering_nn_1_N = mkN "proletarisering" ;
  prolongering_nn_1_N = mkN "prolongering" ;
  promenadstig_nn_1_N = mkN "promenadstig" ;
  promenadvaeg_nn_1_1_N = mkN "promenadväg" ;
  promenering_nn_1_N = mkN "promenering" ;
  promovering_nn_1_N = mkN "promovering" ;
  promulgering_nn_1_N = mkN "promulgering" ;
  prononcering_nn_1_N = mkN "prononcering" ;
  propagering_nn_1_N = mkN "propagering" ;
  proponering_nn_1_N = mkN "proponering" ;
  proportionering_nn_1_N = mkN "proportionering" ;
  proppsaekring_nn_1_1_N = mkN "proppsäkring" ;
  prosastil_nn_1_N = mkN "prosastil" ;
  proskribering_nn_1_N = mkN "proskribering" ;
  prospektering_nn_1_N = mkN "prospektering" ;
  prostgaard_nn_1_1_N = mkN "prostgård" ;
  prostituering_nn_1_N = mkN "prostituering" ;
  protegering_nn_1_N = mkN "protegering" ;
  proteinforskning_nn_1_N = mkN "proteinforskning" ;
  protestering_nn_1_N = mkN "protestering" ;
  protestklickning_nn_1_N = mkN "protestklickning" ;
  protokollering_nn_1_N = mkN "protokollering" ;
  protonladdning_nn_1_N = mkN "protonladdning" ;
  provanstaellning_nn_1_1_N = mkN "provanställning" ;
  provbit_nn_1_N = mkN "provbit" ;
  proviantering_nn_1_N = mkN "proviantering" ;
  provkoerning_nn_1_1_N = mkN "provkörning" ;
  provning_nn_1_N = mkN "provning" ;
  provocering_nn_1_N = mkN "provocering" ;
  provraekning_nn_1_1_N = mkN "provräkning" ;
  provroersbefruktning_nn_1_1_N = mkN "provrörsbefruktning" ;
  provskjutning_nn_1_N = mkN "provskjutning" ;
  provspraengning_nn_1_1_N = mkN "provsprängning" ;
  provtagning_nn_1_N = mkN "provtagning" ;
  provtjaenstgoering_nn_1_1_N = mkN "provtjänstgöring" ;
  provoeversaettning_nn_1_1_N = mkN "provöversättning" ;
  prustning_nn_1_N = mkN "prustning" ;
  prutning_nn_1_N = mkN "prutning" ;
  praegling_nn_1_1_N = mkN "prägling" ;
  praentning_nn_1_1_N = mkN "präntning" ;
  praestgaardstraedgaard_nn_1_1_N = mkN "prästgårdsträdgård" ;
  praesttillsaettning_nn_1_1_N = mkN "prästtillsättning" ;
  praestutbildning_nn_1_1_N = mkN "prästutbildning" ;
  praestvigning_nn_1_1_N = mkN "prästvigning" ;
  proevning_nn_1_1_N = mkN "prövning" ;
  psykoanalysering_nn_1_N = mkN "psykoanalysering" ;
  psykologisering_nn_1_N = mkN "psykologisering" ;
  pubertetsyngling_nn_1_N = mkN "pubertetsyngling" ;
  pubesring_nn_1_N = mkN "pubesring" ;
  pubisring_nn_1_N = mkN "pubisring" ;
  publicering_nn_1_N = mkN "publicering" ;
  puffaerm_nn_1_1_N = mkN "puffärm" ;
  pulsering_nn_1_N = mkN "pulsering" ;
  pulstagning_nn_1_N = mkN "pulstagning" ;
  pulverisering_nn_1_N = mkN "pulverisering" ;
  pulvrisering_nn_1_N = mkN "pulvrisering" ;
  pungbjoern_nn_1_1_N = mkN "pungbjörn" ;
  punktbevakning_nn_1_N = mkN "punktbevakning" ;
  punktering_nn_1_N = mkN "punktering" ;
  punsning_nn_1_N = mkN "punsning" ;
  purgering_nn_1_N = mkN "purgering" ;
  purjoloek_nn_1_1_N = mkN "purjolök" ;
  pusselbit_nn_1_N = mkN "pusselbit" ;
  pustning_nn_1_N = mkN "pustning" ;
  putsduk_nn_1_N = mkN "putsduk" ;
  putsning_nn_1_N = mkN "putsning" ;
  pyjamasgylf_nn_1_N = mkN "pyjamasgylf" ;
  pytonorm_nn_1_N = mkN "pytonorm" ;
  paelsboll_nn_1_1_N = mkN "pälsboll" ;
  paerlstickning_nn_1_1_N = mkN "pärlstickning" ;
  paaannonsering_nn_1_1_N = mkN "påannonsering" ;
  paabackning_nn_1_1_N = mkN "påbackning" ;
  paafrestning_nn_1_1_N = mkN "påfrestning" ;
  paafyllnadsfoerpackning_nn_1_1_N = mkN "påfyllnadsförpackning" ;
  paafyllning_nn_1_1_N = mkN "påfyllning" ;
  paafyllningspip_nn_1_1_N = mkN "påfyllningspip" ;
  paahaelsning_nn_1_1_N = mkN "påhälsning" ;
  paaknaeppning_nn_1_1_N = mkN "påknäppning" ;
  paakaenning_nn_1_1_N = mkN "påkänning" ;
  paakoerning_nn_1_1_N = mkN "påkörning" ;
  paalandsvind_nn_1_1_N = mkN "pålandsvind" ;
  paalkran_nn_1_1_N = mkN "pålkran" ;
  paalning_nn_1_1_N = mkN "pålning" ;
  paalaeggning_nn_1_1_N = mkN "påläggning" ;
  paapaelsning_nn_1_1_N = mkN "påpälsning" ;
  paaringning_nn_1_1_N = mkN "påringning" ;
  paaropning_nn_1_1_N = mkN "påropning" ;
  paasegling_nn_1_1_N = mkN "påsegling" ;
  paaskeld_nn_1_1_N = mkN "påskeld" ;
  paaskyndning_nn_1_1_N = mkN "påskyndning" ;
  paaspaedning_nn_1_1_N = mkN "påspädning" ;
  paastoetning_nn_1_1_N = mkN "påstötning" ;
  paasaettning_nn_1_1_N = mkN "påsättning" ;
  paatagning_nn_1_1_N = mkN "påtagning" ;
  paatryckning_nn_1_1_N = mkN "påtryckning" ;
  paataendning_nn_1_1_N = mkN "påtändning" ;
  paaverkning_nn_1_1_N = mkN "påverkning" ;
  paavisning_nn_1_1_N = mkN "påvisning" ;
  poebelhop_nn_1_1_N = mkN "pöbelhop" ;
  poesmunk_nn_1_1_N = mkN "pösmunk" ;
  poesning_nn_1_1_N = mkN "pösning" ;
  rabattering_nn_1_N = mkN "rabattering" ;
  racerbil_nn_1_N = mkN "racerbil" ;
  racerbaat_nn_1_1_N = mkN "racerbåt" ;
  racingbaat_nn_1_1_N = mkN "racingbåt" ;
  radering_nn_1_N = mkN "radering" ;
  raderkniv_nn_1_N = mkN "raderkniv" ;
  radiakbehandling_nn_1_N = mkN "radiakbehandling" ;
  radiering_nn_1_N = mkN "radiering" ;
  radikalisering_nn_1_N = mkN "radikalisering" ;
  radioavlyssning_nn_1_N = mkN "radioavlyssning" ;
  radiobil_nn_1_N = mkN "radiobil" ;
  radionavigering_nn_1_N = mkN "radionavigering" ;
  radiopejling_nn_1_N = mkN "radiopejling" ;
  radiostraalning_nn_1_1_N = mkN "radiostrålning" ;
  radiostyrning_nn_1_N = mkN "radiostyrning" ;
  radiostoerning_nn_1_1_N = mkN "radiostörning" ;
  radiosaendning_nn_1_1_N = mkN "radiosändning" ;
  radioutsaendning_nn_1_1_N = mkN "radioutsändning" ;
  raffinering_nn_1_N = mkN "raffinering" ;
  rafistulering_nn_1_N = mkN "rafistulering" ;
  raggarbil_nn_1_N = mkN "raggarbil" ;
  raggaraak_nn_1_1_N = mkN "raggaråk" ;
  raggmunk_nn_1_N = mkN "raggmunk" ;
  raglanaerm_nn_1_1_N = mkN "raglanärm" ;
  rakkniv_nn_1_N = mkN "rakkniv" ;
  rakning_nn_1_N = mkN "rakning" ;
  raljering_nn_1_N = mkN "raljering" ;
  rallarsving_nn_1_N = mkN "rallarsving" ;
  ramning_nn_1_N = mkN "ramning" ;
  ramponering_nn_1_N = mkN "ramponering" ;
  randanmaerkning_nn_1_1_N = mkN "randanmärkning" ;
  randanteckning_nn_1_N = mkN "randanteckning" ;
  randbildning_nn_1_N = mkN "randbildning" ;
  randning_nn_1_N = mkN "randning" ;
  rangering_nn_1_N = mkN "rangering" ;
  rangordning_nn_1_N = mkN "rangordning" ;
  rannsakning_nn_1_N = mkN "rannsakning" ;
  ransonering_nn_1_N = mkN "ransonering" ;
  rapning_nn_1_N = mkN "rapning" ;
  rappellering_nn_1_N = mkN "rappellering" ;
  rappning_nn_1_N = mkN "rappning" ;
  rapportering_nn_1_N = mkN "rapportering" ;
  rasblandning_nn_1_N = mkN "rasblandning" ;
  rasdiskriminering_nn_1_N = mkN "rasdiskriminering" ;
  rasering_nn_1_N = mkN "rasering" ;
  rasfoerdom_nn_1_1_N = mkN "rasfördom" ;
  raspning_nn_1_N = mkN "raspning" ;
  ratificering_nn_1_N = mkN "ratificering" ;
  rationalisering_nn_1_N = mkN "rationalisering" ;
  reagering_nn_1_N = mkN "reagering" ;
  reaktivering_nn_1_N = mkN "reaktivering" ;
  realisering_nn_1_N = mkN "realisering" ;
  realloenesaenkning_nn_1_1_N = mkN "reallönesänkning" ;
  realtidsbearbetning_nn_1_N = mkN "realtidsbearbetning" ;
  reassurering_nn_1_N = mkN "reassurering" ;
  rebellering_nn_1_N = mkN "rebellering" ;
  recensering_nn_1_N = mkN "recensering" ;
  recidivering_nn_1_N = mkN "recidivering" ;
  recipiering_nn_1_N = mkN "recipiering" ;
  recitering_nn_1_N = mkN "recitering" ;
  redigering_nn_1_N = mkN "redigering" ;
  redning_nn_1_N = mkN "redning" ;
  redovisning_nn_1_N = mkN "redovisning" ;
  reducering_nn_1_N = mkN "reducering" ;
  reduktionsdelning_nn_1_N = mkN "reduktionsdelning" ;
  referensram_nn_1_N = mkN "referensram" ;
  referering_nn_1_N = mkN "referering" ;
  reflektering_nn_1_N = mkN "reflektering" ;
  reformering_nn_1_N = mkN "reformering" ;
  refusering_nn_1_N = mkN "refusering" ;
  regalering_nn_1_N = mkN "regalering" ;
  regelutformning_nn_1_N = mkN "regelutformning" ;
  regenerering_nn_1_N = mkN "regenerering" ;
  regering_nn_1_N = mkN "regering" ;
  regeringsplattform_nn_1_N = mkN "regeringsplattform" ;
  regissering_nn_1_N = mkN "regissering" ;
  registerknapp_nn_1_N = mkN "registerknapp" ;
  registrering_nn_1_N = mkN "registrering" ;
  registreringsskylt_nn_1_N = mkN "registreringsskylt" ;
  reglementering_nn_1_N = mkN "reglementering" ;
  reglering_nn_1_N = mkN "reglering" ;
  regling_nn_1_N = mkN "regling" ;
  regnrock_nn_1_N = mkN "regnrock" ;
  regnskog_nn_1_N = mkN "regnskog" ;
  regnskogsskoevling_nn_1_1_N = mkN "regnskogsskövling" ;
  regummering_nn_1_N = mkN "regummering" ;
  rehabilitering_nn_1_N = mkN "rehabilitering" ;
  reinkarnering_nn_1_N = mkN "reinkarnering" ;
  rekapitulering_nn_1_N = mkN "rekapitulering" ;
  reklamering_nn_1_N = mkN "reklamering" ;
  rekognoscering_nn_1_N = mkN "rekognoscering" ;
  rekognosering_nn_1_N = mkN "rekognosering" ;
  rekommendering_nn_1_N = mkN "rekommendering" ;
  rekompensering_nn_1_N = mkN "rekompensering" ;
  rekonstruering_nn_1_N = mkN "rekonstruering" ;
  rekordsatsning_nn_1_N = mkN "rekordsatsning" ;
  rekreationsanlaeggning_nn_1_1_N = mkN "rekreationsanläggning" ;
  rekreationsskog_nn_1_N = mkN "rekreationsskog" ;
  rekrytering_nn_1_N = mkN "rekrytering" ;
  rektificering_nn_1_N = mkN "rektificering" ;
  rektifiering_nn_1_N = mkN "rektifiering" ;
  rekvirering_nn_1_N = mkN "rekvirering" ;
  rekylering_nn_1_N = mkN "rekylering" ;
  relatering_nn_1_N = mkN "relatering" ;
  relegering_nn_1_N = mkN "relegering" ;
  relingsmanning_nn_1_N = mkN "relingsmanning" ;
  remittering_nn_1_N = mkN "remittering" ;
  remontering_nn_1_N = mkN "remontering" ;
  remplacering_nn_1_N = mkN "remplacering" ;
  rendering_nn_1_N = mkN "rendering" ;
  rengoering_nn_1_1_N = mkN "rengöring" ;
  rengoeringsduk_nn_1_1_N = mkN "rengöringsduk" ;
  renhaallning_nn_1_1_N = mkN "renhållning" ;
  renovering_nn_1_N = mkN "renovering" ;
  renskiljning_nn_1_N = mkN "renskiljning" ;
  renskrivning_nn_1_N = mkN "renskrivning" ;
  rensning_nn_1_N = mkN "rensning" ;
  rensningsnaal_nn_1_1_N = mkN "rensningsnål" ;
  renstek_nn_1_N = mkN "renstek" ;
  renstratt_nn_1_N = mkN "renstratt" ;
  reorganisering_nn_1_N = mkN "reorganisering" ;
  reparering_nn_1_N = mkN "reparering" ;
  repartisering_nn_1_N = mkN "repartisering" ;
  repatriering_nn_1_N = mkN "repatriering" ;
  repellering_nn_1_N = mkN "repellering" ;
  repetering_nn_1_N = mkN "repetering" ;
  repetitionsoevning_nn_1_1_N = mkN "repetitionsövning" ;
  repliering_nn_1_N = mkN "repliering" ;
  replikering_nn_1_N = mkN "replikering" ;
  representering_nn_1_N = mkN "representering" ;
  reprisering_nn_1_N = mkN "reprisering" ;
  reproducering_nn_1_N = mkN "reproducering" ;
  repoevning_nn_1_1_N = mkN "repövning" ;
  resebeskrivning_nn_1_N = mkN "resebeskrivning" ;
  resemugg_nn_1_N = mkN "resemugg" ;
  reservering_nn_1_N = mkN "reservering" ;
  reservnaering_nn_1_1_N = mkN "reservnäring" ;
  reseraekning_nn_1_1_N = mkN "reseräkning" ;
  reseskildring_nn_1_N = mkN "reseskildring" ;
  resignering_nn_1_N = mkN "resignering" ;
  resning_nn_1_N = mkN "resning" ;
  resolvering_nn_1_N = mkN "resolvering" ;
  resonering_nn_1_N = mkN "resonering" ;
  resorbering_nn_1_N = mkN "resorbering" ;
  respektering_nn_1_N = mkN "respektering" ;
  respirering_nn_1_N = mkN "respirering" ;
  restaurangbaat_nn_1_1_N = mkN "restaurangbåt" ;
  restaurangmiddag_nn_1_N = mkN "restaurangmiddag" ;
  restaurering_nn_1_N = mkN "restaurering" ;
  restituering_nn_1_N = mkN "restituering" ;
  resultatfoerbaettring_nn_1_1_N = mkN "resultatförbättring" ;
  resultatredovisning_nn_1_N = mkN "resultatredovisning" ;
  resultatraekning_nn_1_1_N = mkN "resultaträkning" ;
  resultering_nn_1_N = mkN "resultering" ;
  resumering_nn_1_N = mkN "resumering" ;
  resursoeverfoering_nn_1_1_N = mkN "resursöverföring" ;
  resvaeg_nn_1_1_N = mkN "resväg" ;
  resaarstickning_nn_1_1_N = mkN "resårstickning" ;
  retablering_nn_1_N = mkN "retablering" ;
  retardering_nn_1_N = mkN "retardering" ;
  retirering_nn_1_N = mkN "retirering" ;
  retning_nn_1_N = mkN "retning" ;
  retrogradavledning_nn_1_N = mkN "retrogradavledning" ;
  returnering_nn_1_N = mkN "returnering" ;
  retuschering_nn_1_N = mkN "retuschering" ;
  revalvering_nn_1_N = mkN "revalvering" ;
  revetering_nn_1_N = mkN "revetering" ;
  revidering_nn_1_N = mkN "revidering" ;
  revirpinkning_nn_1_N = mkN "revirpinkning" ;
  revning_nn_1_N = mkN "revning" ;
  revoltering_nn_1_N = mkN "revoltering" ;
  revolutionering_nn_1_N = mkN "revolutionering" ;
  ridning_nn_1_N = mkN "ridning" ;
  ridtaevling_nn_1_1_N = mkN "ridtävling" ;
  ridvaeg_nn_1_1_N = mkN "ridväg" ;
  rigling_nn_1_N = mkN "rigling" ;
  rikedom_nn_1_N = mkN "rikedom" ;
  rikoschettering_nn_1_N = mkN "rikoschettering" ;
  riksdagsordning_nn_1_N = mkN "riksdagsordning" ;
  riksdagsspaerr_nn_1_1_N = mkN "riksdagsspärr" ;
  riksplanering_nn_1_N = mkN "riksplanering" ;
  rikssal_nn_1_N = mkN "rikssal" ;
  rikstidning_nn_1_N = mkN "rikstidning" ;
  riksvaeg_nn_1_1_N = mkN "riksväg" ;
  riktning_nn_1_N = mkN "riktning" ;
  rimflaetning_nn_1_1_N = mkN "rimflätning" ;
  ringaktning_nn_1_N = mkN "ringaktning" ;
  ringmur_nn_1_N = mkN "ringmur" ;
  ringning_nn_1_N = mkN "ringning" ;
  riojaprovning_nn_1_N = mkN "riojaprovning" ;
  ripostering_nn_1_N = mkN "ripostering" ;
  riskbedoemning_nn_1_1_N = mkN "riskbedömning" ;
  riskering_nn_1_N = mkN "riskering" ;
  riskspridning_nn_1_N = mkN "riskspridning" ;
  riskuppfattning_nn_1_N = mkN "riskuppfattning" ;
  rispning_nn_1_N = mkN "rispning" ;
  ristning_nn_1_N = mkN "ristning" ;
  ritning_nn_1_N = mkN "ritning" ;
  ritualisering_nn_1_N = mkN "ritualisering" ;
  rivalisering_nn_1_N = mkN "rivalisering" ;
  rivning_nn_1_N = mkN "rivning" ;
  robotisering_nn_1_N = mkN "robotisering" ;
  rockering_nn_1_N = mkN "rockering" ;
  rockring_nn_1_N = mkN "rockring" ;
  rockaerm_nn_1_1_N = mkN "rockärm" ;
  roddbaat_nn_1_1_N = mkN "roddbåt" ;
  roddtaevling_nn_1_1_N = mkN "roddtävling" ;
  rollbesaettning_nn_1_1_N = mkN "rollbesättning" ;
  romantisering_nn_1_N = mkN "romantisering" ;
  rondellhund_nn_1_N = mkN "rondellhund" ;
  rosenstock_nn_1_N = mkN "rosenstock" ;
  rossling_nn_1_N = mkN "rossling" ;
  rostflaeck_nn_1_1_N = mkN "rostfläck" ;
  rostning_nn_1_N = mkN "rostning" ;
  rostskyddsbehandling_nn_1_N = mkN "rostskyddsbehandling" ;
  rotering_nn_1_N = mkN "rotering" ;
  rotfyllning_nn_1_N = mkN "rotfyllning" ;
  rotstock_nn_1_N = mkN "rotstock" ;
  rottraad_nn_1_1_N = mkN "rottråd" ;
  rubbning_nn_1_N = mkN "rubbning" ;
  rubinsamling_nn_1_N = mkN "rubinsamling" ;
  rubricering_nn_1_N = mkN "rubricering" ;
  ruckning_nn_1_N = mkN "ruckning" ;
  ruggning_nn_1_N = mkN "ruggning" ;
  ruinering_nn_1_N = mkN "ruinering" ;
  ruinhoeg_nn_1_1_N = mkN "ruinhög" ;
  rullning_nn_1_N = mkN "rullning" ;
  rullstol_nn_1_N = mkN "rullstol" ;
  rullvagn_nn_1_N = mkN "rullvagn" ;
  rumpstek_nn_1_N = mkN "rumpstek" ;
  rumsbestaellning_nn_1_1_N = mkN "rumsbeställning" ;
  rumsfoermedling_nn_1_1_N = mkN "rumsförmedling" ;
  rumskroekning_nn_1_1_N = mkN "rumskrökning" ;
  rumstering_nn_1_N = mkN "rumstering" ;
  rumsuppfattning_nn_1_N = mkN "rumsuppfattning" ;
  rundfil_nn_1_N = mkN "rundfil" ;
  rundflygning_nn_1_N = mkN "rundflygning" ;
  rundfraagning_nn_1_1_N = mkN "rundfrågning" ;
  rundmaalning_nn_1_1_N = mkN "rundmålning" ;
  rundning_nn_1_N = mkN "rundning" ;
  rundringning_nn_1_N = mkN "rundringning" ;
  rundsmoerjning_nn_1_1_N = mkN "rundsmörjning" ;
  rundtoern_nn_1_1_N = mkN "rundtörn" ;
  rundvandring_nn_1_N = mkN "rundvandring" ;
  runkning_nn_1_N = mkN "runkning" ;
  ruskning_nn_1_N = mkN "ruskning" ;
  rusning_nn_1_N = mkN "rusning" ;
  russificering_nn_1_N = mkN "russificering" ;
  russifiering_nn_1_N = mkN "russifiering" ;
  rustning_nn_1_N = mkN "rustning" ;
  ruvning_nn_1_N = mkN "ruvning" ;
  ryckning_nn_1_N = mkN "ryckning" ;
  ryggdunkning_nn_1_N = mkN "ryggdunkning" ;
  ryggmaergsbedoevning_nn_1_1_N = mkN "ryggmärgsbedövning" ;
  ryggning_nn_1_N = mkN "ryggning" ;
  ryggskoeld_nn_1_1_N = mkN "ryggsköld" ;
  ryggstraeckning_nn_1_1_N = mkN "ryggsträckning" ;
  ryktespridning_nn_1_N = mkN "ryktespridning" ;
  ryktesspridning_nn_1_N = mkN "ryktesspridning" ;
  rymdsatsning_nn_1_N = mkN "rymdsatsning" ;
  rymning_nn_1_N = mkN "rymning" ;
  rynkning_nn_1_N = mkN "rynkning" ;
  rysning_nn_1_N = mkN "rysning" ;
  rytmisering_nn_1_N = mkN "rytmisering" ;
  ryttargaang_nn_1_1_N = mkN "ryttargång" ;
  ryttarlek_nn_1_N = mkN "ryttarlek" ;
  ryttaruppvisning_nn_1_N = mkN "ryttaruppvisning" ;
  raeckning_nn_1_1_N = mkN "räckning" ;
  raeddning_nn_1_1_N = mkN "räddning" ;
  raeffling_nn_1_1_N = mkN "räffling" ;
  raekkryssning_nn_1_1_N = mkN "räkkryssning" ;
  raekning_nn_1_1_N = mkN "räkning" ;
  raentehoejning_nn_1_1_N = mkN "räntehöjning" ;
  raetning_nn_1_1_N = mkN "rätning" ;
  raetstickning_nn_1_1_N = mkN "rätstickning" ;
  raettegaang_nn_1_1_N = mkN "rättegång" ;
  raettegaangsdag_nn_1_1_N = mkN "rättegångsdag" ;
  raettning_nn_1_1_N = mkN "rättning" ;
  raettskipning_nn_1_1_N = mkN "rättskipning" ;
  raettskrivning_nn_1_1_N = mkN "rättskrivning" ;
  raettskraenkning_nn_1_1_N = mkN "rättskränkning" ;
  raettsordning_nn_1_1_N = mkN "rättsordning" ;
  raettssal_nn_1_1_N = mkN "rättssal" ;
  raettsskipning_nn_1_1_N = mkN "rättsskipning" ;
  raettstavning_nn_1_1_N = mkN "rättstavning" ;
  raettstillaempning_nn_1_1_N = mkN "rättstillämpning" ;
  raettsuppfattning_nn_1_1_N = mkN "rättsuppfattning" ;
  raadbraakning_nn_1_1_N = mkN "rådbråkning" ;
  raadfraagning_nn_1_1_N = mkN "rådfrågning" ;
  raadgivning_nn_1_1_N = mkN "rådgivning" ;
  raadplaegning_nn_1_1_N = mkN "rådplägning" ;
  raadsfoersamling_nn_1_1_N = mkN "rådsförsamling" ;
  raagaang_nn_1_1_N = mkN "rågång" ;
  raamning_nn_1_1_N = mkN "råmning" ;
  raattskit_nn_1_1_N = mkN "råttskit" ;
  roedlistning_nn_1_1_N = mkN "rödlistning" ;
  roejning_nn_1_1_N = mkN "röjning" ;
  roejsaag_nn_1_1_N = mkN "röjsåg" ;
  roekdykning_nn_1_1_N = mkN "rökdykning" ;
  roekgaang_nn_1_1_N = mkN "rökgång" ;
  roekning_nn_1_1_N = mkN "rökning" ;
  roekpuff_nn_1_1_N = mkN "rökpuff" ;
  roekring_nn_1_1_N = mkN "rökring" ;
  roentgenbehandling_nn_1_1_N = mkN "röntgenbehandling" ;
  roentgenfotografering_nn_1_1_N = mkN "röntgenfotografering" ;
  roentgenstraalning_nn_1_1_N = mkN "röntgenstrålning" ;
  roentgenundersoekning_nn_1_1_N = mkN "röntgenundersökning" ;
  roerbrunn_nn_1_1_N = mkN "rörbrunn" ;
  roerelseriktning_nn_1_1_N = mkN "rörelseriktning" ;
  roerelsestoerning_nn_1_1_N = mkN "rörelsestörning" ;
  roering_nn_1_1_N = mkN "röring" ;
  roerledning_nn_1_1_N = mkN "rörledning" ;
  roesning_nn_1_1_N = mkN "rösning" ;
  roestmaximering_nn_1_1_N = mkN "röstmaximering" ;
  roestning_nn_1_1_N = mkN "röstning" ;
  roestraekning_nn_1_1_N = mkN "rösträkning" ;
  roevarhoevding_nn_1_1_N = mkN "rövarhövding" ;
  sabelfaektning_nn_1_1_N = mkN "sabelfäktning" ;
  sabotering_nn_1_N = mkN "sabotering" ;
  sabrering_nn_1_N = mkN "sabrering" ;
  sackning_nn_1_N = mkN "sackning" ;
  sadelknapp_nn_1_N = mkN "sadelknapp" ;
  sadelmakarnaal_nn_1_1_N = mkN "sadelmakarnål" ;
  saftspaenning_nn_1_1_N = mkN "saftspänning" ;
  saftstroemning_nn_1_1_N = mkN "saftströmning" ;
  sagosamling_nn_1_N = mkN "sagosamling" ;
  sagovaerld_nn_1_1_N = mkN "sagovärld" ;
  sakframstaellning_nn_1_1_N = mkN "sakframställning" ;
  sakfoerklaring_nn_1_1_N = mkN "sakförklaring" ;
  sakfoersaekring_nn_1_1_N = mkN "sakförsäkring" ;
  sakkunnigberedning_nn_1_N = mkN "sakkunnigberedning" ;
  sakkunnigproevning_nn_1_1_N = mkN "sakkunnigprövning" ;
  sakkaennedom_nn_1_1_N = mkN "sakkännedom" ;
  sakproevning_nn_1_1_N = mkN "sakprövning" ;
  sakupplysning_nn_1_N = mkN "sakupplysning" ;
  saldering_nn_1_N = mkN "saldering" ;
  saligfoerklaring_nn_1_1_N = mkN "saligförklaring" ;
  salighetsvaeg_nn_1_1_N = mkN "salighetsväg" ;
  saligprisning_nn_1_N = mkN "saligprisning" ;
  salivering_nn_1_N = mkN "salivering" ;
  salivsug_nn_1_N = mkN "salivsug" ;
  salning_nn_1_N = mkN "salning" ;
  saloondoerr_nn_1_1_N = mkN "saloondörr" ;
  saltavlagring_nn_1_N = mkN "saltavlagring" ;
  saltbil_nn_1_N = mkN "saltbil" ;
  saltdamm_nn_1_N = mkN "saltdamm" ;
  saltloesning_nn_1_1_N = mkN "saltlösning" ;
  saltutvinning_nn_1_N = mkN "saltutvinning" ;
  saltaeng_nn_1_1_N = mkN "saltäng" ;
  salutdag_nn_1_N = mkN "salutdag" ;
  salutering_nn_1_N = mkN "salutering" ;
  salutskjutning_nn_1_N = mkN "salutskjutning" ;
  sambeskattning_nn_1_N = mkN "sambeskattning" ;
  samhaellsbevakning_nn_1_1_N = mkN "samhällsbevakning" ;
  samhaellsordning_nn_1_1_N = mkN "samhällsordning" ;
  samhaellsplanering_nn_1_1_N = mkN "samhällsplanering" ;
  samhaellsskildring_nn_1_1_N = mkN "samhällsskildring" ;
  samhaellsstyrning_nn_1_1_N = mkN "samhällsstyrning" ;
  samhaellsstaellning_nn_1_1_N = mkN "samhällsställning" ;
  samhaellsutveckling_nn_1_1_N = mkN "samhällsutveckling" ;
  samhaellsoevervakning_nn_1_1_N = mkN "samhällsövervakning" ;
  samkoerning_nn_1_1_N = mkN "samkörning" ;
  samlagsstaellning_nn_1_1_N = mkN "samlagsställning" ;
  samling_nn_1_N = mkN "samling" ;
  samlingsregering_nn_1_N = mkN "samlingsregering" ;
  samlingssal_nn_1_N = mkN "samlingssal" ;
  sammanbindning_nn_1_N = mkN "sammanbindning" ;
  sammanblandning_nn_1_N = mkN "sammanblandning" ;
  sammandrabbning_nn_1_N = mkN "sammandrabbning" ;
  sammandragning_nn_1_N = mkN "sammandragning" ;
  sammanfattning_nn_1_N = mkN "sammanfattning" ;
  sammanfogning_nn_1_N = mkN "sammanfogning" ;
  sammanhopning_nn_1_N = mkN "sammanhopning" ;
  sammanhaallning_nn_1_1_N = mkN "sammanhållning" ;
  sammanjaemkning_nn_1_1_N = mkN "sammanjämkning" ;
  sammankoppling_nn_1_N = mkN "sammankoppling" ;
  sammanlaeggning_nn_1_1_N = mkN "sammanläggning" ;
  sammanlaeggningsavhandling_nn_1_1_N = mkN "sammanläggningsavhandling" ;
  sammanlaenkning_nn_1_1_N = mkN "sammanlänkning" ;
  sammanpackning_nn_1_N = mkN "sammanpackning" ;
  sammanringning_nn_1_N = mkN "sammanringning" ;
  sammanraekning_nn_1_1_N = mkN "sammanräkning" ;
  sammanskrivning_nn_1_N = mkN "sammanskrivning" ;
  sammanslagning_nn_1_N = mkN "sammanslagning" ;
  sammanslutning_nn_1_N = mkN "sammanslutning" ;
  sammansmaeltning_nn_1_1_N = mkN "sammansmältning" ;
  sammanstaellning_nn_1_1_N = mkN "sammanställning" ;
  sammanstoetning_nn_1_1_N = mkN "sammanstötning" ;
  sammansvetsning_nn_1_N = mkN "sammansvetsning" ;
  sammansvaerjning_nn_1_1_N = mkN "sammansvärjning" ;
  sammansaettning_nn_1_1_N = mkN "sammansättning" ;
  sammantraedesordning_nn_1_1_N = mkN "sammanträdesordning" ;
  sammanvaevning_nn_1_1_N = mkN "sammanvävning" ;
  sammanvaexning_nn_1_1_N = mkN "sammanväxning" ;
  samordning_nn_1_N = mkN "samordning" ;
  sampling_nn_1_N = mkN "sampling" ;
  samregering_nn_1_N = mkN "samregering" ;
  samsaendning_nn_1_1_N = mkN "samsändning" ;
  samtalsmarkering_nn_1_N = mkN "samtalsmarkering" ;
  samtaxering_nn_1_N = mkN "samtaxering" ;
  samtidsskildring_nn_1_N = mkN "samtidsskildring" ;
  sandblaestring_nn_1_1_N = mkN "sandblästring" ;
  sandform_nn_1_N = mkN "sandform" ;
  sandsaeck_nn_1_1_N = mkN "sandsäck" ;
  sanering_nn_1_N = mkN "sanering" ;
  sanforisering_nn_1_N = mkN "sanforisering" ;
  sanktifiering_nn_1_N = mkN "sanktifiering" ;
  sanktionering_nn_1_N = mkN "sanktionering" ;
  sanning_nn_1_N = mkN "sanning" ;
  sannolikhetsberaekning_nn_1_1_N = mkN "sannolikhetsberäkning" ;
  sansning_nn_1_N = mkN "sansning" ;
  saponifiering_nn_1_N = mkN "saponifiering" ;
  sardinburk_nn_1_N = mkN "sardinburk" ;
  sargning_nn_1_N = mkN "sargning" ;
  satinering_nn_1_N = mkN "satinering" ;
  satirisering_nn_1_N = mkN "satirisering" ;
  satisfiering_nn_1_N = mkN "satisfiering" ;
  satsbindning_nn_1_N = mkN "satsbindning" ;
  satsfogning_nn_1_N = mkN "satsfogning" ;
  satsfoerkortning_nn_1_1_N = mkN "satsförkortning" ;
  satskommatering_nn_1_N = mkN "satskommatering" ;
  satsloesning_nn_1_1_N = mkN "satslösning" ;
  satsning_nn_1_N = mkN "satsning" ;
  saturering_nn_1_N = mkN "saturering" ;
  sautering_nn_1_N = mkN "sautering" ;
  sauvering_nn_1_N = mkN "sauvering" ;
  savning_nn_1_N = mkN "savning" ;
  saxkrok_nn_1_N = mkN "saxkrok" ;
  saxning_nn_1_N = mkN "saxning" ;
  scanning_nn_1_N = mkN "scanning" ;
  scenanvisning_nn_1_N = mkN "scenanvisning" ;
  scenbearbetning_nn_1_N = mkN "scenbearbetning" ;
  scenfoeraendring_nn_1_1_N = mkN "scenförändring" ;
  sceningaang_nn_1_1_N = mkN "sceningång" ;
  scenuppsaettning_nn_1_1_N = mkN "scenuppsättning" ;
  scenvind_nn_1_N = mkN "scenvind" ;
  scenvaexling_nn_1_1_N = mkN "scenväxling" ;
  scenoeppning_nn_1_1_N = mkN "scenöppning" ;
  schablonering_nn_1_N = mkN "schablonering" ;
  schablonisering_nn_1_N = mkN "schablonisering" ;
  schablontaxering_nn_1_N = mkN "schablontaxering" ;
  schackturnering_nn_1_N = mkN "schackturnering" ;
  schalottenloek_nn_1_1_N = mkN "schalottenlök" ;
  schamponering_nn_1_N = mkN "schamponering" ;
  schanghajning_nn_1_N = mkN "schanghajning" ;
  schasning_nn_1_N = mkN "schasning" ;
  schattering_nn_1_N = mkN "schattering" ;
  schavottering_nn_1_N = mkN "schavottering" ;
  schematisering_nn_1_N = mkN "schematisering" ;
  schumring_nn_1_N = mkN "schumring" ;
  schaeferhatt_nn_1_1_N = mkN "schäferhatt" ;
  scouthaelsning_nn_1_1_N = mkN "scouthälsning" ;
  scoutlag_nn_1_N = mkN "scoutlag" ;
  seccomaalning_nn_1_1_N = mkN "seccomålning" ;
  sedelbraenning_nn_1_1_N = mkN "sedelbränning" ;
  sedelstock_nn_1_N = mkN "sedelstock" ;
  sedeltaeckning_nn_1_1_N = mkN "sedeltäckning" ;
  sedeskildring_nn_1_N = mkN "sedeskildring" ;
  sedimentering_nn_1_N = mkN "sedimentering" ;
  segelbaergning_nn_1_1_N = mkN "segelbärgning" ;
  segelbaat_nn_1_1_N = mkN "segelbåt" ;
  segelflygning_nn_1_N = mkN "segelflygning" ;
  segelfoering_nn_1_1_N = mkN "segelföring" ;
  segerstaemning_nn_1_1_N = mkN "segerstämning" ;
  segling_nn_1_N = mkN "segling" ;
  seglingsbeskrivning_nn_1_N = mkN "seglingsbeskrivning" ;
  segmentering_nn_1_N = mkN "segmentering" ;
  segregering_nn_1_N = mkN "segregering" ;
  segring_nn_1_N = mkN "segring" ;
  sejsning_nn_1_N = mkN "sejsning" ;
  sekondering_nn_1_N = mkN "sekondering" ;
  sekretessproevning_nn_1_1_N = mkN "sekretessprövning" ;
  sekretionsrubbning_nn_1_N = mkN "sekretionsrubbning" ;
  sektorport_nn_1_N = mkN "sektorport" ;
  sekularisering_nn_1_N = mkN "sekularisering" ;
  sekundering_nn_1_N = mkN "sekundering" ;
  sekundaerbelysning_nn_1_1_N = mkN "sekundärbelysning" ;
  sekvensering_nn_1_N = mkN "sekvensering" ;
  sekvestrering_nn_1_N = mkN "sekvestrering" ;
  selektering_nn_1_N = mkN "selektering" ;
  selning_nn_1_N = mkN "selning" ;
  semaforering_nn_1_N = mkN "semaforering" ;
  semesterdag_nn_1_N = mkN "semesterdag" ;
  semesterersaettning_nn_1_1_N = mkN "semesterersättning" ;
  seminering_nn_1_N = mkN "seminering" ;
  senarelaeggning_nn_1_1_N = mkN "senareläggning" ;
  senknut_nn_1_N = mkN "senknut" ;
  sensibilisering_nn_1_N = mkN "sensibilisering" ;
  sensitivitetstraening_nn_1_1_N = mkN "sensitivitetsträning" ;
  sensitraening_nn_1_1_N = mkN "sensiträning" ;
  sentering_nn_1_N = mkN "sentering" ;
  separatfjaedring_nn_1_1_N = mkN "separatfjädring" ;
  separatutstaellning_nn_1_1_N = mkN "separatutställning" ;
  separering_nn_1_N = mkN "separering" ;
  sepiatoning_nn_1_N = mkN "sepiatoning" ;
  serieinlaerning_nn_1_1_N = mkN "serieinlärning" ;
  seriekoppling_nn_1_N = mkN "seriekoppling" ;
  serietidning_nn_1_N = mkN "serietidning" ;
  serietidningstappning_nn_1_N = mkN "serietidningstappning" ;
  serietillverkning_nn_1_N = mkN "serietillverkning" ;
  serpentinisering_nn_1_N = mkN "serpentinisering" ;
  servboll_nn_1_N = mkN "servboll" ;
  serveboll_nn_1_N = mkN "serveboll" ;
  servering_nn_1_N = mkN "servering" ;
  serveringsgaang_nn_1_1_N = mkN "serveringsgång" ;
  serveringskork_nn_1_N = mkN "serveringskork" ;
  servettbrytning_nn_1_N = mkN "servettbrytning" ;
  servettring_nn_1_N = mkN "servettring" ;
  servicebil_nn_1_N = mkN "servicebil" ;
  serviceinraettning_nn_1_1_N = mkN "serviceinrättning" ;
  servicenaering_nn_1_1_N = mkN "servicenäring" ;
  servisledning_nn_1_N = mkN "servisledning" ;
  servitrisbak_nn_1_N = mkN "servitrisbak" ;
  servitrisklapp_nn_1_N = mkN "servitrisklapp" ;
  servostyrning_nn_1_N = mkN "servostyrning" ;
  setboll_nn_1_N = mkN "setboll" ;
  sexbrottsutredning_nn_1_N = mkN "sexbrottsutredning" ;
  sexkoepslag_nn_1_1_N = mkN "sexköpslag" ;
  sextiofemaarsdag_nn_1_1_N = mkN "sextiofemårsdag" ;
  sextioaarsdag_nn_1_1_N = mkN "sextioårsdag" ;
  sextonaaring_nn_1_1_N = mkN "sextonåring" ;
  sexualisering_nn_1_N = mkN "sexualisering" ;
  sexualupplysning_nn_1_N = mkN "sexualupplysning" ;
  sexaaring_nn_1_1_N = mkN "sexåring" ;
  shamponering_nn_1_N = mkN "shamponering" ;
  shanghajning_nn_1_N = mkN "shanghajning" ;
  shoppingvagn_nn_1_N = mkN "shoppingvagn" ;
  shortning_nn_1_N = mkN "shortning" ;
  showdrill_nn_1_N = mkN "showdrill" ;
  showvaerd_nn_1_1_N = mkN "showvärd" ;
  shuntkoppling_nn_1_N = mkN "shuntkoppling" ;
  sidnumrering_nn_1_N = mkN "sidnumrering" ;
  sidobelysning_nn_1_N = mkN "sidobelysning" ;
  sidoblick_nn_1_N = mkN "sidoblick" ;
  sidodoerr_nn_1_1_N = mkN "sidodörr" ;
  sidoingaang_nn_1_1_N = mkN "sidoingång" ;
  sidojustering_nn_1_N = mkN "sidojustering" ;
  sidovaeg_nn_1_1_N = mkN "sidoväg" ;
  sidovaegg_nn_1_1_N = mkN "sidovägg" ;
  sidvagn_nn_1_N = mkN "sidvagn" ;
  sidvall_nn_1_N = mkN "sidvall" ;
  sifferraekning_nn_1_1_N = mkN "sifferräkning" ;
  sifoundersoekning_nn_1_1_N = mkN "sifoundersökning" ;
  sightseeing_nn_1_N = mkN "sightseeing" ;
  sigillering_nn_1_N = mkN "sigillering" ;
  sigillring_nn_1_N = mkN "sigillring" ;
  signalduk_nn_1_N = mkN "signalduk" ;
  signaleld_nn_1_N = mkN "signaleld" ;
  signalering_nn_1_N = mkN "signalering" ;
  signalspaning_nn_1_N = mkN "signalspaning" ;
  signering_nn_1_N = mkN "signering" ;
  signetring_nn_1_N = mkN "signetring" ;
  signifikansproevning_nn_1_1_N = mkN "signifikansprövning" ;
  siktduk_nn_1_N = mkN "siktduk" ;
  siktning_nn_1_N = mkN "siktning" ;
  siktram_nn_1_N = mkN "siktram" ;
  silduk_nn_1_N = mkN "silduk" ;
  silhuettering_nn_1_N = mkN "silhuettering" ;
  silkesodling_nn_1_N = mkN "silkesodling" ;
  silkestraad_nn_1_1_N = mkN "silkestråd" ;
  sillhaj_nn_1_N = mkN "sillhaj" ;
  sillinlaeggning_nn_1_1_N = mkN "sillinläggning" ;
  sillvrakning_nn_1_N = mkN "sillvrakning" ;
  silning_nn_1_N = mkN "silning" ;
  siluettering_nn_1_N = mkN "siluettering" ;
  silverprobering_nn_1_N = mkN "silverprobering" ;
  silversked_nn_1_N = mkN "silversked" ;
  silvertraad_nn_1_1_N = mkN "silvertråd" ;
  simklubb_nn_1_N = mkN "simklubb" ;
  simning_nn_1_N = mkN "simning" ;
  simplifiering_nn_1_N = mkN "simplifiering" ;
  simtraening_nn_1_1_N = mkN "simträning" ;
  simtaevling_nn_1_1_N = mkN "simtävling" ;
  simulering_nn_1_N = mkN "simulering" ;
  simultantolkning_nn_1_N = mkN "simultantolkning" ;
  sinkning_nn_1_N = mkN "sinkning" ;
  sinnesfoerfattning_nn_1_1_N = mkN "sinnesförfattning" ;
  sinnesfoervirring_nn_1_1_N = mkN "sinnesförvirring" ;
  sinnesrubbning_nn_1_N = mkN "sinnesrubbning" ;
  sinnessjukdom_nn_1_N = mkN "sinnessjukdom" ;
  sinnesstaemning_nn_1_1_N = mkN "sinnesstämning" ;
  sinnesundersoekning_nn_1_1_N = mkN "sinnesundersökning" ;
  sinnesaendring_nn_1_1_N = mkN "sinnesändring" ;
  sittning_nn_1_N = mkN "sittning" ;
  sittstaellning_nn_1_1_N = mkN "sittställning" ;
  sjanghajning_nn_1_N = mkN "sjanghajning" ;
  sjangsering_nn_1_N = mkN "sjangsering" ;
  sjudning_nn_1_N = mkN "sjudning" ;
  sjuglasvagn_nn_1_N = mkN "sjuglasvagn" ;
  sjukdag_nn_1_N = mkN "sjukdag" ;
  sjukdom_nn_1_N = mkN "sjukdom" ;
  sjukdomsfoerklaring_nn_1_1_N = mkN "sjukdomsförklaring" ;
  sjukersaettning_nn_1_1_N = mkN "sjukersättning" ;
  sjukfoersaekring_nn_1_1_N = mkN "sjukförsäkring" ;
  sjukhusavdelning_nn_1_N = mkN "sjukhusavdelning" ;
  sjukhussal_nn_1_N = mkN "sjukhussal" ;
  sjukpenning_nn_1_N = mkN "sjukpenning" ;
  sjukpenningutbetalning_nn_1_N = mkN "sjukpenningutbetalning" ;
  sjukskrivning_nn_1_N = mkN "sjukskrivning" ;
  sjukskoeterskeutbildning_nn_1_1_N = mkN "sjuksköterskeutbildning" ;
  sjukvaardsfoersaekring_nn_1_1_N = mkN "sjukvårdsförsäkring" ;
  sjukvaardsutbildning_nn_1_1_N = mkN "sjukvårdsutbildning" ;
  sjukvaardsutrustning_nn_1_1_N = mkN "sjukvårdsutrustning" ;
  sjunkning_nn_1_N = mkN "sjunkning" ;
  sjuttonaaring_nn_1_1_N = mkN "sjuttonåring" ;
  sjuaaring_nn_1_1_N = mkN "sjuåring" ;
  sjaelaringning_nn_1_1_N = mkN "själaringning" ;
  sjaelavandring_nn_1_1_N = mkN "själavandring" ;
  sjaelssjukdom_nn_1_1_N = mkN "själssjukdom" ;
  sjaelvaktning_nn_1_1_N = mkN "självaktning" ;
  sjaelvalstring_nn_1_1_N = mkN "självalstring" ;
  sjaelvantaendning_nn_1_1_N = mkN "självantändning" ;
  sjaelvbefruktning_nn_1_1_N = mkN "självbefruktning" ;
  sjaelvbehaerskning_nn_1_1_N = mkN "självbehärskning" ;
  sjaelvbespegling_nn_1_1_N = mkN "självbespegling" ;
  sjaelvbetjaening_nn_1_1_N = mkN "självbetjäning" ;
  sjaelvbildning_nn_1_1_N = mkN "självbildning" ;
  sjaelvfinansiering_nn_1_1_N = mkN "självfinansiering" ;
  sjaelvfoeryngring_nn_1_1_N = mkN "självföryngring" ;
  sjaelvhushaallning_nn_1_1_N = mkN "självhushållning" ;
  sjaelvhaeckling_nn_1_1_N = mkN "självhäckling" ;
  sjaelvkaennedom_nn_1_1_N = mkN "självkännedom" ;
  sjaelvlaekning_nn_1_1_N = mkN "självläkning" ;
  sjaelvservering_nn_1_1_N = mkN "självservering" ;
  sjaelvspaekning_nn_1_1_N = mkN "självspäkning" ;
  sjaelvstaendighetsfoerklaring_nn_1_1_N = mkN "självständighetsförklaring" ;
  sjaelvtaendning_nn_1_1_N = mkN "självtändning" ;
  sjaelvuppfattning_nn_1_1_N = mkN "självuppfattning" ;
  sjaelvuppoffring_nn_1_1_N = mkN "självuppoffring" ;
  sjaelvurladdning_nn_1_1_N = mkN "självurladdning" ;
  sjaelvutplaaning_nn_1_1_N = mkN "självutplåning" ;
  sjoeavlagring_nn_1_1_N = mkN "sjöavlagring" ;
  sjoebjoern_nn_1_1_N = mkN "sjöbjörn" ;
  sjoefoerklaring_nn_1_1_N = mkN "sjöförklaring" ;
  sjoehaevning_nn_1_1_N = mkN "sjöhävning" ;
  sjoemaning_nn_1_1_N = mkN "sjömaning" ;
  sjoemansfoermedling_nn_1_1_N = mkN "sjömansförmedling" ;
  sjoemansklaenning_nn_1_1_N = mkN "sjömansklänning" ;
  sjoemanssaeck_nn_1_1_N = mkN "sjömanssäck" ;
  sjoemansutbildning_nn_1_1_N = mkN "sjömansutbildning" ;
  sjoemaetning_nn_1_1_N = mkN "sjömätning" ;
  sjoereglering_nn_1_1_N = mkN "sjöreglering" ;
  sjoeraeddning_nn_1_1_N = mkN "sjöräddning" ;
  sjoesaettning_nn_1_1_N = mkN "sjösättning" ;
  skadeersaettning_nn_1_1_N = mkN "skadeersättning" ;
  skadereglering_nn_1_N = mkN "skadereglering" ;
  skadeverkning_nn_1_N = mkN "skadeverkning" ;
  skadevaerdering_nn_1_1_N = mkN "skadevärdering" ;
  skaffning_nn_1_N = mkN "skaffning" ;
  skakning_nn_1_N = mkN "skakning" ;
  skallbloedning_nn_1_1_N = mkN "skallblödning" ;
  skallerorm_nn_1_N = mkN "skallerorm" ;
  skallgaang_nn_1_1_N = mkN "skallgång" ;
  skalning_nn_1_N = mkN "skalning" ;
  skalpering_nn_1_N = mkN "skalpering" ;
  skamfilning_nn_1_N = mkN "skamfilning" ;
  skamstock_nn_1_N = mkN "skamstock" ;
  skandalisering_nn_1_N = mkN "skandalisering" ;
  skandaltidning_nn_1_N = mkN "skandaltidning" ;
  skandering_nn_1_N = mkN "skandering" ;
  skanning_nn_1_N = mkN "skanning" ;
  skarpskytt_nn_1_N = mkN "skarpskytt" ;
  skarvsladd_nn_1_N = mkN "skarvsladd" ;
  skattebetalning_nn_1_N = mkN "skattebetalning" ;
  skattehoejning_nn_1_1_N = mkN "skattehöjning" ;
  skatteinbetalning_nn_1_N = mkN "skatteinbetalning" ;
  skattelag_nn_1_N = mkN "skattelag" ;
  skattepeng_nn_1_N = mkN "skattepeng" ;
  skatteplanering_nn_1_N = mkN "skatteplanering" ;
  skattesmitning_nn_1_N = mkN "skattesmitning" ;
  skattesaenkning_nn_1_1_N = mkN "skattesänkning" ;
  skatteutjaemning_nn_1_1_N = mkN "skatteutjämning" ;
  skattevaexling_nn_1_1_N = mkN "skatteväxling" ;
  skatteaaterbaering_nn_1_1_N = mkN "skatteåterbäring" ;
  skattlaeggning_nn_1_1_N = mkN "skattläggning" ;
  skattning_nn_1_N = mkN "skattning" ;
  skavning_nn_1_N = mkN "skavning" ;
  skedstork_nn_1_N = mkN "skedstork" ;
  skenavraettning_nn_1_1_N = mkN "skenavrättning" ;
  skendraenkning_nn_1_1_N = mkN "skendränkning" ;
  skenfaektning_nn_1_1_N = mkN "skenfäktning" ;
  skenraettegaang_nn_1_1_N = mkN "skenrättegång" ;
  skenskarv_nn_1_N = mkN "skenskarv" ;
  skenvaerld_nn_1_1_N = mkN "skenvärld" ;
  skeppning_nn_1_N = mkN "skeppning" ;
  skeppsmaetning_nn_1_1_N = mkN "skeppsmätning" ;
  skeppssaettning_nn_1_1_N = mkN "skeppssättning" ;
  skevning_nn_1_N = mkN "skevning" ;
  skickning_nn_1_N = mkN "skickning" ;
  skidanlaeggning_nn_1_1_N = mkN "skidanläggning" ;
  skiddrottning_nn_1_N = mkN "skiddrottning" ;
  skidhjaelm_nn_1_1_N = mkN "skidhjälm" ;
  skidhoppning_nn_1_N = mkN "skidhoppning" ;
  skidloepning_nn_1_1_N = mkN "skidlöpning" ;
  skidtaevling_nn_1_1_N = mkN "skidtävling" ;
  skidaakning_nn_1_1_N = mkN "skidåkning" ;
  skiftning_nn_1_N = mkN "skiftning" ;
  skiktning_nn_1_N = mkN "skiktning" ;
  skildring_nn_1_N = mkN "skildring" ;
  skiljedom_nn_1_N = mkN "skiljedom" ;
  skiljedomstol_nn_1_N = mkN "skiljedomstol" ;
  skiljemur_nn_1_N = mkN "skiljemur" ;
  skiljevaeg_nn_1_1_N = mkN "skiljeväg" ;
  skiljevaegg_nn_1_1_N = mkN "skiljevägg" ;
  skinnbit_nn_1_N = mkN "skinnbit" ;
  skirning_nn_1_N = mkN "skirning" ;
  skissering_nn_1_N = mkN "skissering" ;
  skitvaag_nn_1_1_N = mkN "skitvåg" ;
  skivinspelning_nn_1_N = mkN "skivinspelning" ;
  skivsamling_nn_1_N = mkN "skivsamling" ;
  skivtallrik_nn_1_N = mkN "skivtallrik" ;
  skjortaerm_nn_1_1_N = mkN "skjortärm" ;
  skjutdoerr_nn_1_1_N = mkN "skjutdörr" ;
  skjutning_nn_1_N = mkN "skjutning" ;
  skjutriktning_nn_1_N = mkN "skjutriktning" ;
  skjututbildning_nn_1_N = mkN "skjututbildning" ;
  skoborstning_nn_1_N = mkN "skoborstning" ;
  skogbit_nn_1_N = mkN "skogbit" ;
  skogsavverkning_nn_1_N = mkN "skogsavverkning" ;
  skogsfoerbaettring_nn_1_1_N = mkN "skogsförbättring" ;
  skogsfoervaltning_nn_1_1_N = mkN "skogsförvaltning" ;
  skogsgallring_nn_1_N = mkN "skogsgallring" ;
  skogsgud_nn_1_N = mkN "skogsgud" ;
  skogsskoevling_nn_1_1_N = mkN "skogsskövling" ;
  skogsvandring_nn_1_N = mkN "skogsvandring" ;
  skogsvaeg_nn_1_1_N = mkN "skogsväg" ;
  skolavslutning_nn_1_N = mkN "skolavslutning" ;
  skolbildning_nn_1_N = mkN "skolbildning" ;
  skoldag_nn_1_N = mkN "skoldag" ;
  skolfoervaltning_nn_1_1_N = mkN "skolförvaltning" ;
  skolgrind_nn_1_N = mkN "skolgrind" ;
  skoljazztaevling_nn_1_1_N = mkN "skoljazztävling" ;
  skolkning_nn_1_N = mkN "skolkning" ;
  skolning_nn_1_N = mkN "skolning" ;
  skolridning_nn_1_N = mkN "skolridning" ;
  skolsal_nn_1_N = mkN "skolsal" ;
  skolskjutning_nn_1_N = mkN "skolskjutning" ;
  skolundervisning_nn_1_N = mkN "skolundervisning" ;
  skolungdom_nn_1_N = mkN "skolungdom" ;
  skolutbildning_nn_1_N = mkN "skolutbildning" ;
  skolvaeg_nn_1_1_N = mkN "skolväg" ;
  skoloevning_nn_1_1_N = mkN "skolövning" ;
  skoning_nn_1_N = mkN "skoning" ;
  skorrning_nn_1_N = mkN "skorrning" ;
  skorstensmur_nn_1_N = mkN "skorstensmur" ;
  skottdag_nn_1_N = mkN "skottdag" ;
  skottlossning_nn_1_N = mkN "skottlossning" ;
  skottning_nn_1_N = mkN "skottning" ;
  skottpeng_nn_1_N = mkN "skottpeng" ;
  skottskog_nn_1_N = mkN "skottskog" ;
  skraffering_nn_1_N = mkN "skraffering" ;
  skrapning_nn_1_N = mkN "skrapning" ;
  skridning_nn_1_N = mkN "skridning" ;
  skridskosegling_nn_1_N = mkN "skridskosegling" ;
  skridskoaakning_nn_1_1_N = mkN "skridskoåkning" ;
  skrinlaeggning_nn_1_1_N = mkN "skrinläggning" ;
  skrivbordsstol_nn_1_N = mkN "skrivbordsstol" ;
  skrivmaskinsstol_nn_1_N = mkN "skrivmaskinsstol" ;
  skrivning_nn_1_N = mkN "skrivning" ;
  skrivsal_nn_1_N = mkN "skrivsal" ;
  skrivoevning_nn_1_1_N = mkN "skrivövning" ;
  skrockning_nn_1_N = mkN "skrockning" ;
  skrodering_nn_1_N = mkN "skrodering" ;
  skrotbil_nn_1_N = mkN "skrotbil" ;
  skrothaemtning_nn_1_1_N = mkN "skrothämtning" ;
  skrotning_nn_1_N = mkN "skrotning" ;
  skrubbning_nn_1_N = mkN "skrubbning" ;
  skruvkrok_nn_1_N = mkN "skruvkrok" ;
  skrynkling_nn_1_N = mkN "skrynkling" ;
  skraeckskildring_nn_1_1_N = mkN "skräckskildring" ;
  skraecktackling_nn_1_1_N = mkN "skräcktackling" ;
  skraedning_nn_1_1_N = mkN "skrädning" ;
  skraenfock_nn_1_1_N = mkN "skränfock" ;
  skraephoeg_nn_1_1_N = mkN "skräphög" ;
  skraepkorg_nn_1_1_N = mkN "skräpkorg" ;
  skubbning_nn_1_N = mkN "skubbning" ;
  skuggboxning_nn_1_N = mkN "skuggboxning" ;
  skuggloesning_nn_1_1_N = mkN "skugglösning" ;
  skuggning_nn_1_N = mkN "skuggning" ;
  skuggregering_nn_1_N = mkN "skuggregering" ;
  skuldavskrivning_nn_1_N = mkN "skuldavskrivning" ;
  skulptering_nn_1_N = mkN "skulptering" ;
  skulpturering_nn_1_N = mkN "skulpturering" ;
  skumpakork_nn_1_N = mkN "skumpakork" ;
  skumpning_nn_1_N = mkN "skumpning" ;
  skumtvaett_nn_1_1_N = mkN "skumtvätt" ;
  skumtvaettning_nn_1_1_N = mkN "skumtvättning" ;
  skumutrustning_nn_1_N = mkN "skumutrustning" ;
  skurning_nn_1_N = mkN "skurning" ;
  skyddsduk_nn_1_N = mkN "skyddsduk" ;
  skyddsgud_nn_1_N = mkN "skyddsgud" ;
  skyddsimpregnering_nn_1_N = mkN "skyddsimpregnering" ;
  skyddsmur_nn_1_N = mkN "skyddsmur" ;
  skyddsslang_nn_1_N = mkN "skyddsslang" ;
  skyltning_nn_1_N = mkN "skyltning" ;
  skymning_nn_1_N = mkN "skymning" ;
  skyttegaang_nn_1_1_N = mkN "skyttegång" ;
  skyttekung_nn_1_N = mkN "skyttekung" ;
  skaektkniv_nn_1_1_N = mkN "skäktkniv" ;
  skaellning_nn_1_1_N = mkN "skällning" ;
  skaelvning_nn_1_1_N = mkN "skälvning" ;
  skaemtteckning_nn_1_1_N = mkN "skämtteckning" ;
  skaendning_nn_1_1_N = mkN "skändning" ;
  skaepkorg_nn_1_1_N = mkN "skäpkorg" ;
  skaeregg_nn_1_1_N = mkN "skäregg" ;
  skaermbildsundersoekning_nn_1_1_N = mkN "skärmbildsundersökning" ;
  skaerning_nn_1_1_N = mkN "skärning" ;
  skaerskaadning_nn_1_1_N = mkN "skärskådning" ;
  skaerstock_nn_1_1_N = mkN "skärstock" ;
  skaallning_nn_1_1_N = mkN "skållning" ;
  skaapdoerr_nn_1_1_N = mkN "skåpdörr" ;
  skoeljning_nn_1_1_N = mkN "sköljning" ;
  skoenhetstaevling_nn_1_1_N = mkN "skönhetstävling" ;
  skoenmaalning_nn_1_1_N = mkN "skönmålning" ;
  skoenstaxering_nn_1_1_N = mkN "skönstaxering" ;
  skoentaxering_nn_1_1_N = mkN "sköntaxering" ;
  skoerdeuppskattning_nn_1_1_N = mkN "skördeuppskattning" ;
  skoevling_nn_1_1_N = mkN "skövling" ;
  slagbjoern_nn_1_1_N = mkN "slagbjörn" ;
  slaggfaerskning_nn_1_1_N = mkN "slaggfärskning" ;
  slagordning_nn_1_N = mkN "slagordning" ;
  slagvaexling_nn_1_1_N = mkN "slagväxling" ;
  slagaentring_nn_1_1_N = mkN "slagäntring" ;
  slaktning_nn_1_N = mkN "slaktning" ;
  slalomport_nn_1_N = mkN "slalomport" ;
  slamsugning_nn_1_N = mkN "slamsugning" ;
  slamsugningsbil_nn_1_N = mkN "slamsugningsbil" ;
  slangkoppling_nn_1_N = mkN "slangkoppling" ;
  slantsingling_nn_1_N = mkN "slantsingling" ;
  slaskhink_nn_1_N = mkN "slaskhink" ;
  slasktratt_nn_1_N = mkN "slasktratt" ;
  slavisering_nn_1_N = mkN "slavisering" ;
  slentrianfoerestaellning_nn_1_1_N = mkN "slentrianföreställning" ;
  slentrianmoerkning_nn_1_1_N = mkN "slentrianmörkning" ;
  slickning_nn_1_N = mkN "slickning" ;
  slidkniv_nn_1_N = mkN "slidkniv" ;
  slintning_nn_1_N = mkN "slintning" ;
  slipsknut_nn_1_N = mkN "slipsknut" ;
  slipsvamp_nn_1_N = mkN "slipsvamp" ;
  slirkoppling_nn_1_N = mkN "slirkoppling" ;
  slirning_nn_1_N = mkN "slirning" ;
  slitning_nn_1_N = mkN "slitning" ;
  slokhatt_nn_1_N = mkN "slokhatt" ;
  slopning_nn_1_N = mkN "slopning" ;
  slottssal_nn_1_N = mkN "slottssal" ;
  slottsstek_nn_1_N = mkN "slottsstek" ;
  slottsvallgrav_nn_1_N = mkN "slottsvallgrav" ;
  slungboll_nn_1_N = mkN "slungboll" ;
  slungning_nn_1_N = mkN "slungning" ;
  slussport_nn_1_N = mkN "slussport" ;
  slutfoervaring_nn_1_1_N = mkN "slutförvaring" ;
  slutledning_nn_1_N = mkN "slutledning" ;
  slutplaedering_nn_1_1_N = mkN "slutplädering" ;
  sluttning_nn_1_N = mkN "sluttning" ;
  slaeckning_nn_1_1_N = mkN "släckning" ;
  slaektforskning_nn_1_1_N = mkN "släktforskning" ;
  slaektgaard_nn_1_1_N = mkN "släktgård" ;
  slaektledning_nn_1_1_N = mkN "släktledning" ;
  slaengning_nn_1_1_N = mkN "slängning" ;
  slaepring_nn_1_1_N = mkN "släpring" ;
  slaepvagn_nn_1_1_N = mkN "släpvagn" ;
  slaepvagnskoppling_nn_1_1_N = mkN "släpvagnskoppling" ;
  slaetloepning_nn_1_1_N = mkN "slätlöpning" ;
  slaetning_nn_1_1_N = mkN "slätning" ;
  slaetstickning_nn_1_1_N = mkN "slätstickning" ;
  slaetvaelling_nn_1_1_N = mkN "slätvälling" ;
  slaatterkniv_nn_1_1_N = mkN "slåtterkniv" ;
  slaatteraeng_nn_1_1_N = mkN "slåtteräng" ;
  sloejdkniv_nn_1_1_N = mkN "slöjdkniv" ;
  smackning_nn_1_N = mkN "smackning" ;
  smakbit_nn_1_N = mkN "smakbit" ;
  smakloek_nn_1_1_N = mkN "smaklök" ;
  smakriktning_nn_1_N = mkN "smakriktning" ;
  smaskning_nn_1_N = mkN "smaskning" ;
  smedlaerling_nn_1_1_N = mkN "smedlärling" ;
  smedslaerling_nn_1_1_N = mkN "smedslärling" ;
  smekning_nn_1_N = mkN "smekning" ;
  smetning_nn_1_N = mkN "smetning" ;
  sminkning_nn_1_N = mkN "sminkning" ;
  smitning_nn_1_N = mkN "smitning" ;
  smittovaeg_nn_1_1_N = mkN "smittoväg" ;
  smittooevervakning_nn_1_1_N = mkN "smittoövervakning" ;
  smokingklaenning_nn_1_1_N = mkN "smokingklänning" ;
  smuggling_nn_1_N = mkN "smuggling" ;
  smygfilmning_nn_1_N = mkN "smygfilmning" ;
  smygvaeg_nn_1_1_N = mkN "smygväg" ;
  smaelek_nn_1_1_N = mkN "smälek" ;
  smaeltning_nn_1_1_N = mkN "smältning" ;
  smaeltsaekring_nn_1_1_N = mkN "smältsäkring" ;
  smaergelduk_nn_1_1_N = mkN "smärgelduk" ;
  smaertbehandling_nn_1_1_N = mkN "smärtbehandling" ;
  smaerthaemning_nn_1_1_N = mkN "smärthämning" ;
  smaertlindring_nn_1_1_N = mkN "smärtlindring" ;
  smaalaenning_nn_1_1_N = mkN "smålänning" ;
  smaaloek_nn_1_1_N = mkN "smålök" ;
  smaaskog_nn_1_1_N = mkN "småskog" ;
  smaatvaett_nn_1_1_N = mkN "småtvätt" ;
  smoerboll_nn_1_1_N = mkN "smörboll" ;
  smoerjanordning_nn_1_1_N = mkN "smörjanordning" ;
  smoerjning_nn_1_1_N = mkN "smörjning" ;
  smoerklick_nn_1_1_N = mkN "smörklick" ;
  snabbavveckling_nn_1_N = mkN "snabbavveckling" ;
  snabbkoppling_nn_1_N = mkN "snabbkoppling" ;
  snabbmiddag_nn_1_N = mkN "snabbmiddag" ;
  snarkning_nn_1_N = mkN "snarkning" ;
  snavning_nn_1_N = mkN "snavning" ;
  sneddning_nn_1_N = mkN "sneddning" ;
  snedfoerdelning_nn_1_1_N = mkN "snedfördelning" ;
  snedparkering_nn_1_N = mkN "snedparkering" ;
  snedrekrytering_nn_1_N = mkN "snedrekrytering" ;
  snedtaendning_nn_1_1_N = mkN "snedtändning" ;
  snedvridning_nn_1_N = mkN "snedvridning" ;
  snoppning_nn_1_N = mkN "snoppning" ;
  snortning_nn_1_N = mkN "snortning" ;
  snubbelsladd_nn_1_N = mkN "snubbelsladd" ;
  snubbeltraad_nn_1_1_N = mkN "snubbeltråd" ;
  snurrstol_nn_1_N = mkN "snurrstol" ;
  snustillverkning_nn_1_N = mkN "snustillverkning" ;
  snuthaeck_nn_1_1_N = mkN "snuthäck" ;
  snyftning_nn_1_N = mkN "snyftning" ;
  snytning_nn_1_N = mkN "snytning" ;
  snaerjning_nn_1_1_N = mkN "snärjning" ;
  snaarskog_nn_1_1_N = mkN "snårskog" ;
  snoeboll_nn_1_1_N = mkN "snöboll" ;
  snoemulning_nn_1_1_N = mkN "snömulning" ;
  snoeplogning_nn_1_1_N = mkN "snöplogning" ;
  snoepning_nn_1_1_N = mkN "snöpning" ;
  snoerning_nn_1_1_N = mkN "snörning" ;
  snoerpning_nn_1_1_N = mkN "snörpning" ;
  snoervling_nn_1_1_N = mkN "snörvling" ;
  snoeroejning_nn_1_1_N = mkN "snöröjning" ;
  snoesmaeltning_nn_1_1_N = mkN "snösmältning" ;
  snoetillgaang_nn_1_1_N = mkN "snötillgång" ;
  snoevall_nn_1_1_N = mkN "snövall" ;
  socialfoersaekring_nn_1_1_N = mkN "socialförsäkring" ;
  socialfoervaltning_nn_1_1_N = mkN "socialförvaltning" ;
  socialisering_nn_1_N = mkN "socialisering" ;
  sockerbildning_nn_1_N = mkN "sockerbildning" ;
  sockerbindning_nn_1_N = mkN "sockerbindning" ;
  sockerbit_nn_1_N = mkN "sockerbit" ;
  sockerroersodling_nn_1_1_N = mkN "sockerrörsodling" ;
  sockertillverkning_nn_1_N = mkN "sockertillverkning" ;
  solbelysning_nn_1_N = mkN "solbelysning" ;
  solbestraalning_nn_1_1_N = mkN "solbestrålning" ;
  solbaergning_nn_1_1_N = mkN "solbärgning" ;
  solcellsanlaeggning_nn_1_1_N = mkN "solcellsanläggning" ;
  soldag_nn_1_N = mkN "soldag" ;
  soldathop_nn_1_N = mkN "soldathop" ;
  soldatutrustning_nn_1_N = mkN "soldatutrustning" ;
  solgud_nn_1_N = mkN "solgud" ;
  solhatt_nn_1_N = mkN "solhatt" ;
  solinstraalning_nn_1_1_N = mkN "solinstrålning" ;
  solklaenning_nn_1_1_N = mkN "solklänning" ;
  solnedgaang_nn_1_1_N = mkN "solnedgång" ;
  solspraengning_nn_1_1_N = mkN "solsprängning" ;
  solstraalning_nn_1_1_N = mkN "solstrålning" ;
  soluppgaang_nn_1_1_N = mkN "soluppgång" ;
  solvering_nn_1_N = mkN "solvering" ;
  sommargotlaenning_nn_1_1_N = mkN "sommargotlänning" ;
  sommarhatt_nn_1_N = mkN "sommarhatt" ;
  sommarklaenning_nn_1_1_N = mkN "sommarklänning" ;
  sommarvind_nn_1_N = mkN "sommarvind" ;
  sommaraeng_nn_1_1_N = mkN "sommaräng" ;
  sondering_nn_1_N = mkN "sondering" ;
  sondmatning_nn_1_N = mkN "sondmatning" ;
  sopbil_nn_1_N = mkN "sopbil" ;
  soppfoerpackning_nn_1_1_N = mkN "soppförpackning" ;
  sopptallrik_nn_1_N = mkN "sopptallrik" ;
  sopsaeck_nn_1_1_N = mkN "sopsäck" ;
  sordinering_nn_1_N = mkN "sordinering" ;
  sorgedag_nn_1_N = mkN "sorgedag" ;
  sortering_nn_1_N = mkN "sortering" ;
  sotbildning_nn_1_N = mkN "sotbildning" ;
  soteld_nn_1_N = mkN "soteld" ;
  soulagering_nn_1_N = mkN "soulagering" ;
  souterrainvaaning_nn_1_1_N = mkN "souterrainvåning" ;
  souterraengvaaning_nn_1_1_N = mkN "souterrängvåning" ;
  sovjetisering_nn_1_N = mkN "sovjetisering" ;
  sovsal_nn_1_N = mkN "sovsal" ;
  sovstaellning_nn_1_1_N = mkN "sovställning" ;
  spackelkniv_nn_1_N = mkN "spackelkniv" ;
  spaljering_nn_1_N = mkN "spaljering" ;
  spallering_nn_1_N = mkN "spallering" ;
  spaning_nn_1_N = mkN "spaning" ;
  spankulering_nn_1_N = mkN "spankulering" ;
  spannmaalsskoerd_nn_1_1_N = mkN "spannmålsskörd" ;
  spatsering_nn_1_N = mkN "spatsering" ;
  specialbegaavning_nn_1_1_N = mkN "specialbegåvning" ;
  specialbestaellning_nn_1_1_N = mkN "specialbeställning" ;
  specialdomstol_nn_1_N = mkN "specialdomstol" ;
  specialisering_nn_1_N = mkN "specialisering" ;
  specialmotivering_nn_1_N = mkN "specialmotivering" ;
  specialundervisning_nn_1_N = mkN "specialundervisning" ;
  specificering_nn_1_N = mkN "specificering" ;
  speciminering_nn_1_N = mkN "speciminering" ;
  spegelfaektning_nn_1_1_N = mkN "spegelfäktning" ;
  spegling_nn_1_N = mkN "spegling" ;
  spekulering_nn_1_N = mkN "spekulering" ;
  spelning_nn_1_N = mkN "spelning" ;
  spelomgaang_nn_1_1_N = mkN "spelomgång" ;
  speloeppning_nn_1_1_N = mkN "spelöppning" ;
  spenordning_nn_1_N = mkN "spenordning" ;
  spermabildning_nn_1_N = mkN "spermabildning" ;
  spetsduk_nn_1_N = mkN "spetsduk" ;
  spetsning_nn_1_N = mkN "spetsning" ;
  spikning_nn_1_N = mkN "spikning" ;
  spillning_nn_1_N = mkN "spillning" ;
  spindeltraad_nn_1_1_N = mkN "spindeltråd" ;
  spionering_nn_1_N = mkN "spionering" ;
  spionflygning_nn_1_N = mkN "spionflygning" ;
  spiselhaell_nn_1_1_N = mkN "spiselhäll" ;
  spiselkrok_nn_1_N = mkN "spiselkrok" ;
  spiselmur_nn_1_N = mkN "spiselmur" ;
  spishaell_nn_1_1_N = mkN "spishäll" ;
  spiskrok_nn_1_N = mkN "spiskrok" ;
  spisning_nn_1_N = mkN "spisning" ;
  spjutkastning_nn_1_N = mkN "spjutkastning" ;
  spjaelgrind_nn_1_1_N = mkN "spjälgrind" ;
  spjaelkning_nn_1_1_N = mkN "spjälkning" ;
  spjaelning_nn_1_1_N = mkN "spjälning" ;
  splitsning_nn_1_N = mkN "splitsning" ;
  splittring_nn_1_N = mkN "splittring" ;
  spoliering_nn_1_N = mkN "spoliering" ;
  spolning_nn_1_N = mkN "spolning" ;
  sponsring_nn_1_N = mkN "sponsring" ;
  spontning_nn_1_N = mkN "spontning" ;
  sporrning_nn_1_N = mkN "sporrning" ;
  sportbil_nn_1_N = mkN "sportbil" ;
  sportdykning_nn_1_N = mkN "sportdykning" ;
  sporthall_nn_1_N = mkN "sporthall" ;
  sportklubb_nn_1_N = mkN "sportklubb" ;
  sprakning_nn_1_N = mkN "sprakning" ;
  sprickbildning_nn_1_N = mkN "sprickbildning" ;
  sprickning_nn_1_N = mkN "sprickning" ;
  spridarvagn_nn_1_N = mkN "spridarvagn" ;
  spridning_nn_1_N = mkN "spridning" ;
  springning_nn_1_N = mkN "springning" ;
  sprinkleranlaeggning_nn_1_1_N = mkN "sprinkleranläggning" ;
  spritning_nn_1_N = mkN "spritning" ;
  sprittning_nn_1_N = mkN "sprittning" ;
  sprutavraettning_nn_1_1_N = mkN "sprutavrättning" ;
  sprutlackering_nn_1_N = mkN "sprutlackering" ;
  sprutning_nn_1_N = mkN "sprutning" ;
  spraeckning_nn_1_1_N = mkN "spräckning" ;
  spraengladdning_nn_1_1_N = mkN "sprängladdning" ;
  spraengning_nn_1_1_N = mkN "sprängning" ;
  spraettning_nn_1_1_N = mkN "sprättning" ;
  spraakanvaendning_nn_1_1_N = mkN "språkanvändning" ;
  spraakbehandling_nn_1_1_N = mkN "språkbehandling" ;
  spraakfoerbistring_nn_1_1_N = mkN "språkförbistring" ;
  spraakinlaerning_nn_1_1_N = mkN "språkinlärning" ;
  spraakundervisning_nn_1_1_N = mkN "språkundervisning" ;
  spyboll_nn_1_N = mkN "spyboll" ;
  spaeckkorv_nn_1_1_N = mkN "späckkorv" ;
  spaeckning_nn_1_1_N = mkN "späckning" ;
  spaedning_nn_1_1_N = mkN "spädning" ;
  spaekning_nn_1_1_N = mkN "späkning" ;
  spaennarm_nn_1_1_N = mkN "spännarm" ;
  spaenning_nn_1_1_N = mkN "spänning" ;
  spaenningsjustering_nn_1_1_N = mkN "spänningsjustering" ;
  spaennram_nn_1_1_N = mkN "spännram" ;
  spaentning_nn_1_1_N = mkN "späntning" ;
  spaerrning_nn_1_1_N = mkN "spärrning" ;
  spaadom_nn_1_1_N = mkN "spådom" ;
  spaakaering_nn_1_1_N = mkN "spåkäring" ;
  spaankorg_nn_1_1_N = mkN "spånkorg" ;
  spaansug_nn_1_1_N = mkN "spånsug" ;
  spaantning_nn_1_1_N = mkN "spåntning" ;
  spaarning_nn_1_1_N = mkN "spårning" ;
  spaarsaekring_nn_1_1_N = mkN "spårsäkring" ;
  spaarvaeg_nn_1_1_N = mkN "spårväg" ;
  spoeslitning_nn_1_1_N = mkN "spöslitning" ;
  squashboll_nn_1_N = mkN "squashboll" ;
  stabilisering_nn_1_N = mkN "stabilisering" ;
  stackning_nn_1_N = mkN "stackning" ;
  stadsmur_nn_1_N = mkN "stadsmur" ;
  stadsplanering_nn_1_N = mkN "stadsplanering" ;
  stadsport_nn_1_N = mkN "stadsport" ;
  stadsskog_nn_1_N = mkN "stadsskog" ;
  stafettloepning_nn_1_1_N = mkN "stafettlöpning" ;
  staffering_nn_1_N = mkN "staffering" ;
  stafflimaalning_nn_1_1_N = mkN "stafflimålning" ;
  stagnering_nn_1_N = mkN "stagnering" ;
  stagvaendning_nn_1_1_N = mkN "stagvändning" ;
  stamhoevding_nn_1_1_N = mkN "stamhövding" ;
  stamning_nn_1_N = mkN "stamning" ;
  stampning_nn_1_N = mkN "stampning" ;
  standardhoejning_nn_1_1_N = mkN "standardhöjning" ;
  standardisering_nn_1_N = mkN "standardisering" ;
  standardloesning_nn_1_1_N = mkN "standardlösning" ;
  stansning_nn_1_N = mkN "stansning" ;
  stapelavloepning_nn_1_1_N = mkN "stapelavlöpning" ;
  startpall_nn_1_N = mkN "startpall" ;
  statering_nn_1_N = mkN "statering" ;
  stationering_nn_1_N = mkN "stationering" ;
  statsbegravning_nn_1_N = mkN "statsbegravning" ;
  statsbildning_nn_1_N = mkN "statsbildning" ;
  statsfoerfattning_nn_1_1_N = mkN "statsförfattning" ;
  statsfoervaltning_nn_1_1_N = mkN "statsförvaltning" ;
  statsraadsberedning_nn_1_1_N = mkN "statsrådsberedning" ;
  statsraadsbil_nn_1_1_N = mkN "statsrådsbil" ;
  statsraadsmiddag_nn_1_1_N = mkN "statsrådsmiddag" ;
  statsvaelvning_nn_1_1_N = mkN "statsvälvning" ;
  statuering_nn_1_N = mkN "statuering" ;
  stavning_nn_1_N = mkN "stavning" ;
  stegpall_nn_1_N = mkN "stegpall" ;
  stegring_nn_1_N = mkN "stegring" ;
  stegraeknartaevling_nn_1_1_N = mkN "stegräknartävling" ;
  stekning_nn_1_N = mkN "stekning" ;
  stelning_nn_1_N = mkN "stelning" ;
  stenansamling_nn_1_N = mkN "stenansamling" ;
  stenblick_nn_1_N = mkN "stenblick" ;
  stencilering_nn_1_N = mkN "stencilering" ;
  stenfaestning_nn_1_1_N = mkN "stenfästning" ;
  stening_nn_1_N = mkN "stening" ;
  stenkastning_nn_1_N = mkN "stenkastning" ;
  stenkolsbit_nn_1_N = mkN "stenkolsbit" ;
  stenlaeggning_nn_1_1_N = mkN "stenläggning" ;
  stenmur_nn_1_N = mkN "stenmur" ;
  stenografering_nn_1_N = mkN "stenografering" ;
  stensaettning_nn_1_1_N = mkN "stensättning" ;
  stenvaegg_nn_1_1_N = mkN "stenvägg" ;
  stenaaldersgrav_nn_1_1_N = mkN "stenåldersgrav" ;
  stereoanlaeggning_nn_1_1_N = mkN "stereoanläggning" ;
  stereofotografering_nn_1_N = mkN "stereofotografering" ;
  stereotypering_nn_1_N = mkN "stereotypering" ;
  sterilisering_nn_1_N = mkN "sterilisering" ;
  stickning_nn_1_N = mkN "stickning" ;
  stickpropp_nn_1_N = mkN "stickpropp" ;
  stickprovsundersoekning_nn_1_1_N = mkN "stickprovsundersökning" ;
  sticksaag_nn_1_1_N = mkN "sticksåg" ;
  stigarledning_nn_1_N = mkN "stigarledning" ;
  stigmatisering_nn_1_N = mkN "stigmatisering" ;
  stigning_nn_1_N = mkN "stigning" ;
  stilbrytning_nn_1_N = mkN "stilbrytning" ;
  stilisering_nn_1_N = mkN "stilisering" ;
  stilriktning_nn_1_N = mkN "stilriktning" ;
  stiloevning_nn_1_1_N = mkN "stilövning" ;
  stimulering_nn_1_N = mkN "stimulering" ;
  stipendiering_nn_1_N = mkN "stipendiering" ;
  stipulering_nn_1_N = mkN "stipulering" ;
  stjaelpning_nn_1_1_N = mkN "stjälpning" ;
  stjaernbetaeckning_nn_1_1_N = mkN "stjärnbetäckning" ;
  stjaernhop_nn_1_1_N = mkN "stjärnhop" ;
  stjaernkock_nn_1_1_N = mkN "stjärnkock" ;
  stjaernkoppling_nn_1_1_N = mkN "stjärnkoppling" ;
  stockbaat_nn_1_1_N = mkN "stockbåt" ;
  stockeld_nn_1_N = mkN "stockeld" ;
  stockning_nn_1_N = mkN "stockning" ;
  stoffering_nn_1_N = mkN "stoffering" ;
  stolgaang_nn_1_1_N = mkN "stolgång" ;
  stoltsering_nn_1_N = mkN "stoltsering" ;
  stoppboll_nn_1_N = mkN "stoppboll" ;
  stoppning_nn_1_N = mkN "stoppning" ;
  stoppskylt_nn_1_N = mkN "stoppskylt" ;
  stoppsvaeng_nn_1_1_N = mkN "stoppsväng" ;
  storbildskaerm_nn_1_1_N = mkN "storbildskärm" ;
  storcirkelsegling_nn_1_N = mkN "storcirkelsegling" ;
  storfoerpackning_nn_1_1_N = mkN "storförpackning" ;
  storhandling_nn_1_N = mkN "storhandling" ;
  storkning_nn_1_N = mkN "storkning" ;
  storlek_nn_1_N = mkN "storlek" ;
  storleksordning_nn_1_N = mkN "storleksordning" ;
  stormarskalk_nn_1_N = mkN "stormarskalk" ;
  stormavdelning_nn_1_N = mkN "stormavdelning" ;
  stormhatt_nn_1_N = mkN "stormhatt" ;
  stormil_nn_1_N = mkN "stormil" ;
  stormning_nn_1_N = mkN "stormning" ;
  stormvarning_nn_1_N = mkN "stormvarning" ;
  stormvind_nn_1_N = mkN "stormvind" ;
  storproviantering_nn_1_N = mkN "storproviantering" ;
  storsatsning_nn_1_N = mkN "storsatsning" ;
  storskog_nn_1_N = mkN "storskog" ;
  storstaedning_nn_1_1_N = mkN "storstädning" ;
  straffdom_nn_1_N = mkN "straffdom" ;
  strafflag_nn_1_N = mkN "strafflag" ;
  strafflindring_nn_1_N = mkN "strafflindring" ;
  stramning_nn_1_N = mkN "stramning" ;
  strandning_nn_1_N = mkN "strandning" ;
  strandsluttning_nn_1_N = mkN "strandsluttning" ;
  strandvall_nn_1_N = mkN "strandvall" ;
  strandaeng_nn_1_1_N = mkN "strandäng" ;
  strangulering_nn_1_N = mkN "strangulering" ;
  stratifiering_nn_1_N = mkN "stratifiering" ;
  stridsformering_nn_1_N = mkN "stridsformering" ;
  stridsgruppering_nn_1_N = mkN "stridsgruppering" ;
  stridsledning_nn_1_N = mkN "stridsledning" ;
  stridsmundering_nn_1_N = mkN "stridsmundering" ;
  stridsskjutning_nn_1_N = mkN "stridsskjutning" ;
  stridsstaellning_nn_1_1_N = mkN "stridsställning" ;
  stridsuppstaellning_nn_1_1_N = mkN "stridsuppställning" ;
  stridsvagnsdrivning_nn_1_N = mkN "stridsvagnsdrivning" ;
  strippklubb_nn_1_N = mkN "strippklubb" ;
  strippning_nn_1_N = mkN "strippning" ;
  strokebehandling_nn_1_N = mkN "strokebehandling" ;
  strontiumfoerening_nn_1_1_N = mkN "strontiumförening" ;
  strukturering_nn_1_N = mkN "strukturering" ;
  strukturfoeraendring_nn_1_1_N = mkN "strukturförändring" ;
  strukturomvandling_nn_1_N = mkN "strukturomvandling" ;
  strukturrationalisering_nn_1_N = mkN "strukturrationalisering" ;
  strykning_nn_1_N = mkN "strykning" ;
  stryktvaett_nn_1_1_N = mkN "stryktvätt" ;
  strypning_nn_1_N = mkN "strypning" ;
  straeckning_nn_1_1_N = mkN "sträckning" ;
  straabassjukdom_nn_1_1_N = mkN "stråbassjukdom" ;
  straahatt_nn_1_1_N = mkN "stråhatt" ;
  straalbehandling_nn_1_1_N = mkN "strålbehandling" ;
  straalkniv_nn_1_1_N = mkN "strålkniv" ;
  straalkonservering_nn_1_1_N = mkN "strålkonservering" ;
  straalning_nn_1_1_N = mkN "strålning" ;
  stroembrytarknapp_nn_1_1_N = mkN "strömbrytarknapp" ;
  stroemfoertraengning_nn_1_1_N = mkN "strömförträngning" ;
  stroemkantring_nn_1_1_N = mkN "strömkantring" ;
  stroemledning_nn_1_1_N = mkN "strömledning" ;
  stroemming_nn_1_1_N = mkN "strömming" ;
  stroemning_nn_1_1_N = mkN "strömning" ;
  stroemring_nn_1_1_N = mkN "strömring" ;
  stubbkvarn_nn_1_N = mkN "stubbkvarn" ;
  studering_nn_1_N = mkN "studering" ;
  studieorientering_nn_1_N = mkN "studieorientering" ;
  studievaeg_nn_1_1_N = mkN "studieväg" ;
  studioinspelning_nn_1_N = mkN "studioinspelning" ;
  studsning_nn_1_N = mkN "studsning" ;
  stugdoerr_nn_1_1_N = mkN "stugdörr" ;
  stugknut_nn_1_N = mkN "stugknut" ;
  stukning_nn_1_N = mkN "stukning" ;
  stupstock_nn_1_N = mkN "stupstock" ;
  stuvning_nn_1_N = mkN "stuvning" ;
  styckning_nn_1_N = mkN "styckning" ;
  stympning_nn_1_N = mkN "stympning" ;
  styrinraettning_nn_1_1_N = mkN "styrinrättning" ;
  styrketraening_nn_1_1_N = mkN "styrketräning" ;
  styrning_nn_1_N = mkN "styrning" ;
  styvning_nn_1_N = mkN "styvning" ;
  staeckning_nn_1_1_N = mkN "stäckning" ;
  staeddag_nn_1_1_N = mkN "städdag" ;
  staedning_nn_1_1_N = mkN "städning" ;
  staedvagn_nn_1_1_N = mkN "städvagn" ;
  staellning_nn_1_1_N = mkN "ställning" ;
  staemlaepp_nn_1_1_N = mkN "stämläpp" ;
  staemning_nn_1_1_N = mkN "stämning" ;
  staempling_nn_1_1_N = mkN "stämpling" ;
  staengning_nn_1_1_N = mkN "stängning" ;
  staenkskaerm_nn_1_1_N = mkN "stänkskärm" ;
  staalframstaellning_nn_1_1_N = mkN "stålframställning" ;
  staallegering_nn_1_1_N = mkN "stållegering" ;
  staalram_nn_1_1_N = mkN "stålram" ;
  staalring_nn_1_1_N = mkN "stålring" ;
  staalroersstol_nn_1_1_N = mkN "stålrörsstol" ;
  staalskoeld_nn_1_1_N = mkN "stålsköld" ;
  staaltraad_nn_1_1_N = mkN "ståltråd" ;
  staandkrok_nn_1_1_N = mkN "ståndkrok" ;
  staanggaang_nn_1_1_N = mkN "stånggång" ;
  staangkorv_nn_1_1_N = mkN "stångkorv" ;
  staangning_nn_1_1_N = mkN "stångning" ;
  staangstoertning_nn_1_1_N = mkN "stångstörtning" ;
  staankning_nn_1_1_N = mkN "stånkning" ;
  staauppfoerestaellning_nn_1_1_N = mkN "ståuppföreställning" ;
  stoedroestning_nn_1_1_N = mkN "stödröstning" ;
  stoedundervisning_nn_1_1_N = mkN "stödundervisning" ;
  stoerning_nn_1_1_N = mkN "störning" ;
  stoerthjaelm_nn_1_1_N = mkN "störthjälm" ;
  stoertning_nn_1_1_N = mkN "störtning" ;
  stoevelknekt_nn_1_1_N = mkN "stövelknekt" ;
  sublimering_nn_1_N = mkN "sublimering" ;
  subordinering_nn_1_N = mkN "subordinering" ;
  subsidiering_nn_1_N = mkN "subsidiering" ;
  subskribering_nn_1_N = mkN "subskribering" ;
  substantivering_nn_1_N = mkN "substantivering" ;
  substituering_nn_1_N = mkN "substituering" ;
  subsumering_nn_1_N = mkN "subsumering" ;
  subtrahering_nn_1_N = mkN "subtrahering" ;
  subventionering_nn_1_N = mkN "subventionering" ;
  succedering_nn_1_N = mkN "succedering" ;
  successionsordning_nn_1_N = mkN "successionsordning" ;
  suffigering_nn_1_N = mkN "suffigering" ;
  sufflering_nn_1_N = mkN "sufflering" ;
  suggerering_nn_1_N = mkN "suggerering" ;
  sugning_nn_1_N = mkN "sugning" ;
  summering_nn_1_N = mkN "summering" ;
  sumpskog_nn_1_N = mkN "sumpskog" ;
  superbil_nn_1_N = mkN "superbil" ;
  superflopp_nn_1_N = mkN "superflopp" ;
  superfoerening_nn_1_1_N = mkN "superförening" ;
  supergalaxhop_nn_1_N = mkN "supergalaxhop" ;
  superhop_nn_1_N = mkN "superhop" ;
  supering_nn_1_N = mkN "supering" ;
  superpamp_nn_1_N = mkN "superpamp" ;
  supersnut_nn_1_N = mkN "supersnut" ;
  supplering_nn_1_N = mkN "supplering" ;
  supponering_nn_1_N = mkN "supponering" ;
  supporterklubb_nn_1_N = mkN "supporterklubb" ;
  suppurering_nn_1_N = mkN "suppurering" ;
  supraledning_nn_1_N = mkN "supraledning" ;
  surbrunn_nn_1_N = mkN "surbrunn" ;
  surdeg_nn_1_N = mkN "surdeg" ;
  surfning_nn_1_N = mkN "surfning" ;
  surstek_nn_1_N = mkN "surstek" ;
  surstroemming_nn_1_1_N = mkN "surströmming" ;
  susning_nn_1_N = mkN "susning" ;
  suspendering_nn_1_N = mkN "suspendering" ;
  suterraengvaaning_nn_1_1_N = mkN "suterrängvåning" ;
  svackning_nn_1_N = mkN "svackning" ;
  svalgaang_nn_1_1_N = mkN "svalgång" ;
  svallning_nn_1_N = mkN "svallning" ;
  svampsjukdom_nn_1_N = mkN "svampsjukdom" ;
  svampskog_nn_1_N = mkN "svampskog" ;
  svamptraad_nn_1_1_N = mkN "svamptråd" ;
  svansfoering_nn_1_1_N = mkN "svansföring" ;
  svartlistning_nn_1_N = mkN "svartlistning" ;
  svartmaalning_nn_1_1_N = mkN "svartmålning" ;
  svarvning_nn_1_N = mkN "svarvning" ;
  svavelbindning_nn_1_N = mkN "svavelbindning" ;
  svavelfoerening_nn_1_1_N = mkN "svavelförening" ;
  svavelomsaettning_nn_1_1_N = mkN "svavelomsättning" ;
  svendom_nn_1_N = mkN "svendom" ;
  svennelur_nn_1_N = mkN "svennelur" ;
  svepning_nn_1_N = mkN "svepning" ;
  svetsning_nn_1_N = mkN "svetsning" ;
  svetsslang_nn_1_N = mkN "svetsslang" ;
  svetstraad_nn_1_1_N = mkN "svetstråd" ;
  svettflaeck_nn_1_1_N = mkN "svettfläck" ;
  svettning_nn_1_N = mkN "svettning" ;
  svimning_nn_1_N = mkN "svimning" ;
  svinbesaettning_nn_1_1_N = mkN "svinbesättning" ;
  svinuppfoedning_nn_1_1_N = mkN "svinuppfödning" ;
  svordom_nn_1_N = mkN "svordom" ;
  svaellning_nn_1_1_N = mkN "svällning" ;
  svaeltdoed_nn_1_1_N = mkN "svältdöd" ;
  svaengarm_nn_1_1_N = mkN "svängarm" ;
  svaengdoerr_nn_1_1_N = mkN "svängdörr" ;
  svaengning_nn_1_1_N = mkN "svängning" ;
  svaevning_nn_1_1_N = mkN "svävning" ;
  swingkung_nn_1_N = mkN "swingkung" ;
  sydlaenning_nn_1_1_N = mkN "sydlänning" ;
  syftning_nn_1_N = mkN "syftning" ;
  syfoerening_nn_1_1_N = mkN "syförening" ;
  syltberedning_nn_1_N = mkN "syltberedning" ;
  syltburk_nn_1_N = mkN "syltburk" ;
  syltloek_nn_1_1_N = mkN "syltlök" ;
  symbolhandling_nn_1_N = mkN "symbolhandling" ;
  symbolisering_nn_1_N = mkN "symbolisering" ;
  symboltolkning_nn_1_N = mkN "symboltolkning" ;
  sympatisering_nn_1_N = mkN "sympatisering" ;
  synkopering_nn_1_N = mkN "synkopering" ;
  synkronisering_nn_1_N = mkN "synkronisering" ;
  synkrotronljusring_nn_1_N = mkN "synkrotronljusring" ;
  synsjukdom_nn_1_N = mkN "synsjukdom" ;
  syntetisering_nn_1_N = mkN "syntetisering" ;
  synaal_nn_1_1_N = mkN "synål" ;
  syrenhaeck_nn_1_1_N = mkN "syrenhäck" ;
  syskonkaerlek_nn_1_1_N = mkN "syskonkärlek" ;
  sysselsaettning_nn_1_1_N = mkN "sysselsättning" ;
  systematisering_nn_1_N = mkN "systematisering" ;
  sytraad_nn_1_1_N = mkN "sytråd" ;
  saeckloepning_nn_1_1_N = mkN "säcklöpning" ;
  saedestork_nn_1_1_N = mkN "sädestork" ;
  saedesuttoemning_nn_1_1_N = mkN "sädesuttömning" ;
  saekerhetsanordning_nn_1_1_N = mkN "säkerhetsanordning" ;
  saekerhetskrok_nn_1_1_N = mkN "säkerhetskrok" ;
  saekerhetsnaal_nn_1_1_N = mkN "säkerhetsnål" ;
  saekerhetssal_nn_1_1_N = mkN "säkerhetssal" ;
  saekring_nn_1_1_N = mkN "säkring" ;
  saendning_nn_1_1_N = mkN "sändning" ;
  saenggrind_nn_1_1_N = mkN "sänggrind" ;
  saenkhaav_nn_1_1_N = mkN "sänkhåv" ;
  saenkning_nn_1_1_N = mkN "sänkning" ;
  saenkvaag_nn_1_1_N = mkN "sänkvåg" ;
  saerbeskattning_nn_1_1_N = mkN "särbeskattning" ;
  saerkvark_nn_1_1_N = mkN "särkvark" ;
  saerlevandeutredning_nn_1_1_N = mkN "särlevandeutredning" ;
  saerstaellning_nn_1_1_N = mkN "särställning" ;
  saetesbjudning_nn_1_1_N = mkN "sätesbjudning" ;
  saettning_nn_1_1_N = mkN "sättning" ;
  saevsparv_nn_1_1_N = mkN "sävsparv" ;
  saagkedjefil_nn_1_1_N = mkN "sågkedjefil" ;
  saagkvarn_nn_1_1_N = mkN "sågkvarn" ;
  saagning_nn_1_1_N = mkN "sågning" ;
  saallning_nn_1_1_N = mkN "sållning" ;
  saanglek_nn_1_1_N = mkN "sånglek" ;
  saangtaevling_nn_1_1_N = mkN "sångtävling" ;
  saangoevning_nn_1_1_N = mkN "sångövning" ;
  saaskopp_nn_1_1_N = mkN "såskopp" ;
  saatering_nn_1_1_N = mkN "såtering" ;
  saavering_nn_1_1_N = mkN "såvering" ;
  soeckendag_nn_1_1_N = mkN "söckendag" ;
  soedermanlaenning_nn_1_1_N = mkN "södermanlänning" ;
  soekning_nn_1_1_N = mkN "sökning" ;
  soelkorv_nn_1_1_N = mkN "sölkorv" ;
  soemnstoerning_nn_1_1_N = mkN "sömnstörning" ;
  soendag_nn_1_1_N = mkN "söndag" ;
  soendagskoerning_nn_1_1_N = mkN "söndagskörning" ;
  soenderdelning_nn_1_1_N = mkN "sönderdelning" ;
  soenderspraengning_nn_1_1_N = mkN "söndersprängning" ;
  soendring_nn_1_1_N = mkN "söndring" ;
  soerlaenning_nn_1_1_N = mkN "sörlänning" ;
  soermlaenning_nn_1_1_N = mkN "sörmlänning" ;
  soevning_nn_1_1_N = mkN "sövning" ;
  tabellering_nn_1_N = mkN "tabellering" ;
  tabuering_nn_1_N = mkN "tabuering" ;
  tabulering_nn_1_N = mkN "tabulering" ;
  tackling_nn_1_N = mkN "tackling" ;
  taffelvaag_nn_1_1_N = mkN "taffelvåg" ;
  taftbindning_nn_1_N = mkN "taftbindning" ;
  taggtraad_nn_1_1_N = mkN "taggtråd" ;
  tagning_nn_1_N = mkN "tagning" ;
  tajming_nn_1_N = mkN "tajming" ;
  takbrunn_nn_1_N = mkN "takbrunn" ;
  takflaekt_nn_1_1_N = mkN "takfläkt" ;
  takhuv_nn_1_N = mkN "takhuv" ;
  takresning_nn_1_N = mkN "takresning" ;
  takrygg_nn_1_N = mkN "takrygg" ;
  takstol_nn_1_N = mkN "takstol" ;
  taktbeteckning_nn_1_N = mkN "taktbeteckning" ;
  taktering_nn_1_N = mkN "taktering" ;
  taktikroestning_nn_1_1_N = mkN "taktikröstning" ;
  taktaeckning_nn_1_1_N = mkN "taktäckning" ;
  takvaaning_nn_1_1_N = mkN "takvåning" ;
  tallrik_nn_1_N = mkN "tallrik" ;
  tallskog_nn_1_N = mkN "tallskog" ;
  talrubbning_nn_1_N = mkN "talrubbning" ;
  taltratt_nn_1_N = mkN "taltratt" ;
  tamponering_nn_1_N = mkN "tamponering" ;
  tandborstmugg_nn_1_N = mkN "tandborstmugg" ;
  tandborstning_nn_1_N = mkN "tandborstning" ;
  tandemridning_nn_1_N = mkN "tandemridning" ;
  tandfyllning_nn_1_N = mkN "tandfyllning" ;
  tandfaellning_nn_1_1_N = mkN "tandfällning" ;
  tandlagning_nn_1_N = mkN "tandlagning" ;
  tandlossning_nn_1_N = mkN "tandlossning" ;
  tandlaekarskylt_nn_1_1_N = mkN "tandläkarskylt" ;
  tandlaekarstol_nn_1_1_N = mkN "tandläkarstol" ;
  tandlaekarundersoekning_nn_1_1_N = mkN "tandläkarundersökning" ;
  tandning_nn_1_N = mkN "tandning" ;
  tandreglering_nn_1_N = mkN "tandreglering" ;
  tandsprickning_nn_1_N = mkN "tandsprickning" ;
  tandstaellning_nn_1_1_N = mkN "tandställning" ;
  tandtraad_nn_1_1_N = mkN "tandtråd" ;
  tanduppsaettning_nn_1_1_N = mkN "tanduppsättning" ;
  tandutdragning_nn_1_N = mkN "tandutdragning" ;
  tandvall_nn_1_N = mkN "tandvall" ;
  tandvaardsfoersaekring_nn_1_1_N = mkN "tandvårdsförsäkring" ;
  tandoemsning_nn_1_1_N = mkN "tandömsning" ;
  tangering_nn_1_N = mkN "tangering" ;
  tankbil_nn_1_N = mkN "tankbil" ;
  tankebollning_nn_1_N = mkN "tankebollning" ;
  tankegaang_nn_1_1_N = mkN "tankegång" ;
  tankelag_nn_1_N = mkN "tankelag" ;
  tankelek_nn_1_N = mkN "tankelek" ;
  tankelaesning_nn_1_1_N = mkN "tankeläsning" ;
  tanketraad_nn_1_1_N = mkN "tanketråd" ;
  tankeoeverfoering_nn_1_1_N = mkN "tankeöverföring" ;
  tankeoevning_nn_1_1_N = mkN "tankeövning" ;
  tankning_nn_1_N = mkN "tankning" ;
  tankvagn_nn_1_N = mkN "tankvagn" ;
  tapetdoerr_nn_1_1_N = mkN "tapetdörr" ;
  tapetsering_nn_1_N = mkN "tapetsering" ;
  tappning_nn_1_N = mkN "tappning" ;
  tarering_nn_1_N = mkN "tarering" ;
  tariffering_nn_1_N = mkN "tariffering" ;
  tarmfoertraengning_nn_1_1_N = mkN "tarmförträngning" ;
  tarmskoeljning_nn_1_1_N = mkN "tarmsköljning" ;
  taskmoert_nn_1_1_N = mkN "taskmört" ;
  tatuering_nn_1_N = mkN "tatuering" ;
  taxering_nn_1_N = mkN "taxering" ;
  teaterfoerestaellning_nn_1_1_N = mkN "teaterföreställning" ;
  teaterviskning_nn_1_N = mkN "teaterviskning" ;
  tebjudning_nn_1_N = mkN "tebjudning" ;
  teckenfoerklaring_nn_1_1_N = mkN "teckenförklaring" ;
  teckengivning_nn_1_N = mkN "teckengivning" ;
  teckning_nn_1_N = mkN "teckning" ;
  teddybjoern_nn_1_1_N = mkN "teddybjörn" ;
  tedrickning_nn_1_N = mkN "tedrickning" ;
  tegelmur_nn_1_N = mkN "tegelmur" ;
  tegelugn_nn_1_N = mkN "tegelugn" ;
  tegelvaegg_nn_1_1_N = mkN "tegelvägg" ;
  tegploejning_nn_1_1_N = mkN "tegplöjning" ;
  tehuv_nn_1_N = mkN "tehuv" ;
  teknifiering_nn_1_N = mkN "teknifiering" ;
  teknikutveckling_nn_1_N = mkN "teknikutveckling" ;
  teknikoeverfoering_nn_1_1_N = mkN "tekniköverföring" ;
  tekning_nn_1_N = mkN "tekning" ;
  telefonavlyssning_nn_1_N = mkN "telefonavlyssning" ;
  telefonering_nn_1_N = mkN "telefonering" ;
  telefonledning_nn_1_N = mkN "telefonledning" ;
  telefonpaaringning_nn_1_1_N = mkN "telefonpåringning" ;
  telefonsladd_nn_1_N = mkN "telefonsladd" ;
  telefontraad_nn_1_1_N = mkN "telefontråd" ;
  telefonvaeckning_nn_1_1_N = mkN "telefonväckning" ;
  telegrafering_nn_1_N = mkN "telegrafering" ;
  telegrafutrustning_nn_1_N = mkN "telegrafutrustning" ;
  televisering_nn_1_N = mkN "televisering" ;
  telning_nn_1_N = mkN "telning" ;
  temadag_nn_1_N = mkN "temadag" ;
  tempelgaard_nn_1_1_N = mkN "tempelgård" ;
  temperaturfoerdelning_nn_1_1_N = mkN "temperaturfördelning" ;
  temperaturfoeraendring_nn_1_1_N = mkN "temperaturförändring" ;
  temperaturhoejning_nn_1_1_N = mkN "temperaturhöjning" ;
  temperaturstraalning_nn_1_1_N = mkN "temperaturstrålning" ;
  temperatursvaengning_nn_1_1_N = mkN "temperatursvängning" ;
  temperatursaenkning_nn_1_1_N = mkN "temperatursänkning" ;
  temperaturvaexling_nn_1_1_N = mkN "temperaturväxling" ;
  temperering_nn_2_N = mkN "temperering" ;
  tempering_nn_1_N = mkN "tempering" ;
  tempobeteckning_nn_1_N = mkN "tempobeteckning" ;
  tempusvaexling_nn_1_1_N = mkN "tempusväxling" ;
  tennisboll_nn_1_N = mkN "tennisboll" ;
  tennisframgaang_nn_1_1_N = mkN "tennisframgång" ;
  tentering_nn_1_N = mkN "tentering" ;
  teoretisering_nn_1_N = mkN "teoretisering" ;
  teoribildning_nn_1_N = mkN "teoribildning" ;
  terrassering_nn_1_N = mkN "terrassering" ;
  terrorbombning_nn_1_N = mkN "terrorbombning" ;
  terrorhotbedoemning_nn_1_1_N = mkN "terrorhotbedömning" ;
  terrorisering_nn_1_N = mkN "terrorisering" ;
  terroristlagstiftning_nn_1_N = mkN "terroristlagstiftning" ;
  terrorvarning_nn_1_N = mkN "terrorvarning" ;
  terraengbil_nn_1_1_N = mkN "terrängbil" ;
  terraengkoerning_nn_1_1_N = mkN "terrängkörning" ;
  terraengloepning_nn_1_1_N = mkN "terränglöpning" ;
  tesaurering_nn_1_N = mkN "tesaurering" ;
  tesked_nn_1_N = mkN "tesked" ;
  testamentering_nn_1_N = mkN "testamentering" ;
  testflygning_nn_1_N = mkN "testflygning" ;
  tevesaendning_nn_1_1_N = mkN "tevesändning" ;
  teveoevervakning_nn_1_1_N = mkN "teveövervakning" ;
  textbearbetning_nn_1_N = mkN "textbearbetning" ;
  textbehandling_nn_1_N = mkN "textbehandling" ;
  textning_nn_1_N = mkN "textning" ;
  texttolkning_nn_1_N = mkN "texttolkning" ;
  tideraekning_nn_1_1_N = mkN "tideräkning" ;
  tidjordsforskning_nn_1_N = mkN "tidjordsforskning" ;
  tidmaetning_nn_1_1_N = mkN "tidmätning" ;
  tidning_nn_1_N = mkN "tidning" ;
  tidningsbunt_nn_1_N = mkN "tidningsbunt" ;
  tidningsdrottning_nn_1_N = mkN "tidningsdrottning" ;
  tidningskung_nn_1_N = mkN "tidningskung" ;
  tidningsutbaerning_nn_1_1_N = mkN "tidningsutbärning" ;
  tidningsutgivning_nn_1_N = mkN "tidningsutgivning" ;
  tidsbefraktning_nn_1_N = mkN "tidsbefraktning" ;
  tidsberaekning_nn_1_1_N = mkN "tidsberäkning" ;
  tidsbesparing_nn_1_N = mkN "tidsbesparing" ;
  tidsbestaellning_nn_1_1_N = mkN "tidsbeställning" ;
  tidsbestaemning_nn_1_1_N = mkN "tidsbestämning" ;
  tidsdelning_nn_1_N = mkN "tidsdelning" ;
  tidsfoerskjutning_nn_1_1_N = mkN "tidsförskjutning" ;
  tidsomstaellning_nn_1_1_N = mkN "tidsomställning" ;
  tidspil_nn_1_N = mkN "tidspil" ;
  tidsriktning_nn_1_N = mkN "tidsriktning" ;
  tidsskildring_nn_1_N = mkN "tidsskildring" ;
  tidsuppfattning_nn_1_N = mkN "tidsuppfattning" ;
  tidtagning_nn_1_N = mkN "tidtagning" ;
  tigersaag_nn_1_1_N = mkN "tigersåg" ;
  tiggarmunk_nn_1_N = mkN "tiggarmunk" ;
  tiggarstav_nn_1_N = mkN "tiggarstav" ;
  tillagning_nn_1_N = mkN "tillagning" ;
  tillbakabildning_nn_1_N = mkN "tillbakabildning" ;
  tillbakablick_nn_1_N = mkN "tillbakablick" ;
  tillbakavisning_nn_1_N = mkN "tillbakavisning" ;
  tillblandning_nn_1_N = mkN "tillblandning" ;
  tilldelning_nn_1_N = mkN "tilldelning" ;
  tillfartsvaeg_nn_1_1_N = mkN "tillfartsväg" ;
  tillfogning_nn_1_N = mkN "tillfogning" ;
  tillfrysning_nn_1_N = mkN "tillfrysning" ;
  tillfaangatagning_nn_1_1_N = mkN "tillfångatagning" ;
  tillfoerlitlighetstaevling_nn_1_1_N = mkN "tillförlitlighetstävling" ;
  tillgaang_nn_1_1_N = mkN "tillgång" ;
  tilljaemning_nn_1_1_N = mkN "tilljämning" ;
  tillknaeppning_nn_1_1_N = mkN "tillknäppning" ;
  tillmakning_nn_1_N = mkN "tillmakning" ;
  tillnyktring_nn_1_N = mkN "tillnyktring" ;
  tillpassning_nn_1_N = mkN "tillpassning" ;
  tillplattning_nn_1_N = mkN "tillplattning" ;
  tillraettavisning_nn_1_1_N = mkN "tillrättavisning" ;
  tillskapning_nn_1_N = mkN "tillskapning" ;
  tillskjutning_nn_1_N = mkN "tillskjutning" ;
  tillskaerarkniv_nn_1_1_N = mkN "tillskärarkniv" ;
  tillskaerning_nn_1_1_N = mkN "tillskärning" ;
  tillslagning_nn_1_N = mkN "tillslagning" ;
  tillslutning_nn_1_N = mkN "tillslutning" ;
  tillspetsning_nn_1_N = mkN "tillspetsning" ;
  tillspillogivning_nn_1_N = mkN "tillspillogivning" ;
  tillstroemning_nn_1_1_N = mkN "tillströmning" ;
  tillstaellning_nn_1_1_N = mkN "tillställning" ;
  tillstaengning_nn_1_1_N = mkN "tillstängning" ;
  tillsaegning_nn_1_1_N = mkN "tillsägning" ;
  tillsaettning_nn_1_1_N = mkN "tillsättning" ;
  tilltvaalning_nn_1_1_N = mkN "tilltvålning" ;
  tilltaeppning_nn_1_1_N = mkN "tilltäppning" ;
  tillverkning_nn_1_N = mkN "tillverkning" ;
  tillverkningsutrustning_nn_1_N = mkN "tillverkningsutrustning" ;
  tillvaenjning_nn_1_1_N = mkN "tillvänjning" ;
  tillyxning_nn_1_N = mkN "tillyxning" ;
  tillaempning_nn_1_1_N = mkN "tillämpning" ;
  tilloekning_nn_1_1_N = mkN "tillökning" ;
  tilloenskning_nn_1_1_N = mkN "tillönskning" ;
  timmeravverkning_nn_1_N = mkN "timmeravverkning" ;
  timmerblaedning_nn_1_1_N = mkN "timmerblädning" ;
  timmerdoning_nn_1_N = mkN "timmerdoning" ;
  timmerflottning_nn_1_N = mkN "timmerflottning" ;
  timmerstock_nn_1_N = mkN "timmerstock" ;
  timpenning_nn_1_N = mkN "timpenning" ;
  tingsmeritering_nn_1_N = mkN "tingsmeritering" ;
  tingssal_nn_1_N = mkN "tingssal" ;
  tioaaring_nn_1_1_N = mkN "tioåring" ;
  tiooering_nn_1_1_N = mkN "tioöring" ;
  tippvagn_nn_1_N = mkN "tippvagn" ;
  tipstaevling_nn_1_1_N = mkN "tipstävling" ;
  tisdag_nn_1_N = mkN "tisdag" ;
  titanskruv_nn_1_N = mkN "titanskruv" ;
  titelbortlaeggning_nn_1_1_N = mkN "titelbortläggning" ;
  titrering_nn_1_N = mkN "titrering" ;
  tittarflopp_nn_1_N = mkN "tittarflopp" ;
  tittarframgaang_nn_1_1_N = mkN "tittarframgång" ;
  tittartaevling_nn_1_1_N = mkN "tittartävling" ;
  titulering_nn_1_N = mkN "titulering" ;
  tjocklek_nn_1_N = mkN "tjocklek" ;
  tjugoettaaring_nn_1_1_N = mkN "tjugoettåring" ;
  tjugofemaaring_nn_1_1_N = mkN "tjugofemåring" ;
  tjugofemoering_nn_1_1_N = mkN "tjugofemöring" ;
  tjugofyraaaring_nn_1_1_N = mkN "tjugofyraåring" ;
  tjugokilossaeck_nn_1_1_N = mkN "tjugokilossäck" ;
  tjugotreaaring_nn_1_1_N = mkN "tjugotreåring" ;
  tjugotvaaaaring_nn_1_1_N = mkN "tjugotvååring" ;
  tjugoaaring_nn_1_1_N = mkN "tjugoåring" ;
  tjugufemaaring_nn_1_1_N = mkN "tjugufemåring" ;
  tjugufemoering_nn_1_1_N = mkN "tjugufemöring" ;
  tjuguaaring_nn_1_1_N = mkN "tjuguåring" ;
  tjurfaektning_nn_1_1_N = mkN "tjurfäktning" ;
  tjurrusning_nn_1_N = mkN "tjurrusning" ;
  tjusarlock_nn_1_N = mkN "tjusarlock" ;
  tjusning_nn_1_N = mkN "tjusning" ;
  tjutning_nn_1_N = mkN "tjutning" ;
  tjuvkikning_nn_1_N = mkN "tjuvkikning" ;
  tjuvtankning_nn_1_N = mkN "tjuvtankning" ;
  tjyvkikning_nn_1_N = mkN "tjyvkikning" ;
  tjyvtankning_nn_1_N = mkN "tjyvtankning" ;
  tjaelknoel_nn_1_1_N = mkN "tjälknöl" ;
  tjaellossning_nn_1_1_N = mkN "tjällossning" ;
  tjaenstebil_nn_1_1_N = mkN "tjänstebil" ;
  tjaenstefoerraettning_nn_1_1_N = mkN "tjänsteförrättning" ;
  tjaenstestaellning_nn_1_1_N = mkN "tjänsteställning" ;
  tjaenstgoering_nn_1_1_N = mkN "tjänstgöring" ;
  tjaerframstaellning_nn_1_1_N = mkN "tjärframställning" ;
  toalettring_nn_1_N = mkN "toalettring" ;
  toalettstol_nn_1_N = mkN "toalettstol" ;
  tobaksodling_nn_1_N = mkN "tobaksodling" ;
  tolerering_nn_1_N = mkN "tolerering" ;
  tolkning_nn_1_N = mkN "tolkning" ;
  tolvhundratalsmunk_nn_1_N = mkN "tolvhundratalsmunk" ;
  tolvaaring_nn_1_1_N = mkN "tolvåring" ;
  tomatodling_nn_1_N = mkN "tomatodling" ;
  tomgaangsfoerbrukning_nn_1_1_N = mkN "tomgångsförbrukning" ;
  tomtning_nn_1_N = mkN "tomtning" ;
  tonbildning_nn_1_N = mkN "tonbildning" ;
  tonetsning_nn_1_N = mkN "tonetsning" ;
  tongaang_nn_1_1_N = mkN "tongång" ;
  toning_nn_1_N = mkN "toning" ;
  tonmaalning_nn_1_1_N = mkN "tonmålning" ;
  tonsaettning_nn_1_1_N = mkN "tonsättning" ;
  tontraeffning_nn_1_1_N = mkN "tonträffning" ;
  tonaaring_nn_1_1_N = mkN "tonåring" ;
  toppbefattning_nn_1_N = mkN "toppbefattning" ;
  toppbegaavning_nn_1_1_N = mkN "toppbegåvning" ;
  toppfoerstaerkning_nn_1_1_N = mkN "toppförstärkning" ;
  topphuggning_nn_1_N = mkN "topphuggning" ;
  toppkvark_nn_1_N = mkN "toppkvark" ;
  toppning_nn_1_N = mkN "toppning" ;
  toppridning_nn_1_N = mkN "toppridning" ;
  tordering_nn_1_N = mkN "tordering" ;
  torgdag_nn_1_N = mkN "torgdag" ;
  torkduk_nn_1_N = mkN "torkduk" ;
  torkflaeck_nn_1_1_N = mkN "torkfläck" ;
  torkhuv_nn_1_N = mkN "torkhuv" ;
  torkning_nn_1_N = mkN "torkning" ;
  torkugn_nn_1_N = mkN "torkugn" ;
  tornavslutning_nn_1_N = mkN "tornavslutning" ;
  tornering_nn_1_N = mkN "tornering" ;
  torpedering_nn_1_N = mkN "torpedering" ;
  torpedoevning_nn_1_1_N = mkN "torpedövning" ;
  torrboll_nn_1_N = mkN "torrboll" ;
  torrdestillering_nn_1_N = mkN "torrdestillering" ;
  torrlaeggning_nn_1_1_N = mkN "torrläggning" ;
  torrschamponering_nn_1_N = mkN "torrschamponering" ;
  torrskaffning_nn_1_N = mkN "torrskaffning" ;
  torsdag_nn_1_N = mkN "torsdag" ;
  torsdagstidning_nn_1_N = mkN "torsdagstidning" ;
  torsionsfjaedring_nn_1_1_N = mkN "torsionsfjädring" ;
  tortering_nn_1_N = mkN "tortering" ;
  torvgrav_nn_1_N = mkN "torvgrav" ;
  torvutvinning_nn_1_N = mkN "torvutvinning" ;
  totalfinansiering_nn_1_N = mkN "totalfinansiering" ;
  totalhaverering_nn_1_N = mkN "totalhaverering" ;
  totalkvaddning_nn_1_N = mkN "totalkvaddning" ;
  totalsabbning_nn_1_N = mkN "totalsabbning" ;
  touchering_nn_1_N = mkN "touchering" ;
  toupering_nn_1_N = mkN "toupering" ;
  tradering_nn_1_N = mkN "tradering" ;
  trafikering_nn_1_N = mkN "trafikering" ;
  trafikfoersaekring_nn_1_1_N = mkN "trafikförsäkring" ;
  trafikledning_nn_1_N = mkN "trafikledning" ;
  trafikreglering_nn_1_N = mkN "trafikreglering" ;
  trafikstockning_nn_1_N = mkN "trafikstockning" ;
  trafikvarning_nn_1_N = mkN "trafikvarning" ;
  trakassering_nn_1_N = mkN "trakassering" ;
  traktblaedning_nn_1_1_N = mkN "traktblädning" ;
  traktering_nn_1_N = mkN "traktering" ;
  traktorslaepvagn_nn_1_1_N = mkN "traktorsläpvagn" ;
  trampbaat_nn_1_1_N = mkN "trampbåt" ;
  trampning_nn_1_N = mkN "trampning" ;
  transferering_nn_1_N = mkN "transferering" ;
  transformering_nn_1_N = mkN "transformering" ;
  transitering_nn_1_N = mkN "transitering" ;
  transkribering_nn_1_N = mkN "transkribering" ;
  translitterering_nn_1_N = mkN "translitterering" ;
  transmittering_nn_1_N = mkN "transmittering" ;
  transmutering_nn_1_N = mkN "transmutering" ;
  transpirering_nn_1_N = mkN "transpirering" ;
  transplantering_nn_1_N = mkN "transplantering" ;
  transponering_nn_1_N = mkN "transponering" ;
  transportanordning_nn_1_N = mkN "transportanordning" ;
  transportering_nn_1_N = mkN "transportering" ;
  transportvagn_nn_1_N = mkN "transportvagn" ;
  transumering_nn_1_N = mkN "transumering" ;
  trappgrind_nn_1_N = mkN "trappgrind" ;
  trapphall_nn_1_N = mkN "trapphall" ;
  trappuppgaang_nn_1_1_N = mkN "trappuppgång" ;
  trassering_nn_1_N = mkN "trassering" ;
  travestering_nn_1_N = mkN "travestering" ;
  travtaevling_nn_1_1_N = mkN "travtävling" ;
  tredelning_nn_1_N = mkN "tredelning" ;
  tredjegaangstillsaettning_nn_1_1_N = mkN "tredjegångstillsättning" ;
  tredskodom_nn_1_N = mkN "tredskodom" ;
  trehoerning_nn_1_1_N = mkN "trehörning" ;
  tremiljarderssatsning_nn_1_N = mkN "tremiljarderssatsning" ;
  tremulering_nn_1_N = mkN "tremulering" ;
  trepanering_nn_1_N = mkN "trepanering" ;
  trepartiregering_nn_1_N = mkN "trepartiregering" ;
  trerading_nn_1_N = mkN "trerading" ;
  treraettersmiddag_nn_1_1_N = mkN "trerättersmiddag" ;
  trettonaaring_nn_1_1_N = mkN "trettonåring" ;
  treaaring_nn_1_1_N = mkN "treåring" ;
  triangelkoppling_nn_1_N = mkN "triangelkoppling" ;
  triangelmaetning_nn_1_1_N = mkN "triangelmätning" ;
  triangulering_nn_1_N = mkN "triangulering" ;
  triering_nn_1_N = mkN "triering" ;
  triggning_nn_1_N = mkN "triggning" ;
  trimmertraad_nn_1_1_N = mkN "trimmertråd" ;
  trimning_nn_1_N = mkN "trimning" ;
  trippelkrock_nn_1_N = mkN "trippelkrock" ;
  triumfering_nn_1_N = mkN "triumfering" ;
  triumfvagn_nn_1_N = mkN "triumfvagn" ;
  trivialisering_nn_1_N = mkN "trivialisering" ;
  trolldeg_nn_1_N = mkN "trolldeg" ;
  trolldom_nn_1_N = mkN "trolldom" ;
  trolovning_nn_1_N = mkN "trolovning" ;
  trolovningsring_nn_1_N = mkN "trolovningsring" ;
  tronbestigning_nn_1_N = mkN "tronbestigning" ;
  tronfoeljdsordning_nn_1_1_N = mkN "tronföljdsordning" ;
  tronsal_nn_1_N = mkN "tronsal" ;
  tropikhjaelm_nn_1_1_N = mkN "tropikhjälm" ;
  trosfoerestaellning_nn_1_1_N = mkN "trosföreställning" ;
  trosinriktning_nn_1_N = mkN "trosinriktning" ;
  trossfyllning_nn_1_N = mkN "trossfyllning" ;
  trossning_nn_1_N = mkN "trossning" ;
  trosuppfattning_nn_1_N = mkN "trosuppfattning" ;
  trottoarservering_nn_1_N = mkN "trottoarservering" ;
  trubadurdiktning_nn_1_N = mkN "trubadurdiktning" ;
  trugning_nn_1_N = mkN "trugning" ;
  trumpetstoet_nn_1_1_N = mkN "trumpetstöt" ;
  trumstock_nn_1_N = mkN "trumstock" ;
  truppfoerflyttning_nn_1_1_N = mkN "truppförflyttning" ;
  truppfoering_nn_1_1_N = mkN "truppföring" ;
  truppfoerstaerkning_nn_1_1_N = mkN "truppförstärkning" ;
  tryckform_nn_1_N = mkN "tryckform" ;
  tryckimpregnering_nn_1_N = mkN "tryckimpregnering" ;
  tryckknapp_nn_1_N = mkN "tryckknapp" ;
  tryckluftsavlaesning_nn_1_1_N = mkN "tryckluftsavläsning" ;
  tryckluftsslang_nn_1_N = mkN "tryckluftsslang" ;
  tryckning_nn_1_N = mkN "tryckning" ;
  tryckreducering_nn_1_N = mkN "tryckreducering" ;
  trycksmoerjning_nn_1_1_N = mkN "trycksmörjning" ;
  tryckoekning_nn_1_1_N = mkN "tryckökning" ;
  tryffelhund_nn_1_N = mkN "tryffelhund" ;
  tryffering_nn_1_N = mkN "tryffering" ;
  trygghetsfoersaekring_nn_1_1_N = mkN "trygghetsförsäkring" ;
  traebelaeggning_nn_1_1_N = mkN "träbeläggning" ;
  traebit_nn_1_1_N = mkN "träbit" ;
  traeckning_nn_1_1_N = mkN "träckning" ;
  traedfaellning_nn_1_1_N = mkN "trädfällning" ;
  traedgaardsanlaeggning_nn_1_1_N = mkN "trädgårdsanläggning" ;
  traedgaardsbelysning_nn_1_1_N = mkN "trädgårdsbelysning" ;
  traedgaardsdamm_nn_1_1_N = mkN "trädgårdsdamm" ;
  traedgaardsgaang_nn_1_1_N = mkN "trädgårdsgång" ;
  traedgaardsodling_nn_1_1_N = mkN "trädgårdsodling" ;
  traedgaardsslang_nn_1_1_N = mkN "trädgårdsslang" ;
  traedning_nn_1_1_N = mkN "trädning" ;
  traednaal_nn_1_1_N = mkN "trädnål" ;
  traedplantering_nn_1_1_N = mkN "trädplantering" ;
  traedplanteringsdag_nn_1_1_N = mkN "trädplanteringsdag" ;
  traeffning_nn_1_1_N = mkN "träffning" ;
  traefil_nn_1_1_N = mkN "träfil" ;
  traeform_nn_1_1_N = mkN "träform" ;
  traefoersockring_nn_1_1_N = mkN "träförsockring" ;
  traefoeraedling_nn_1_1_N = mkN "träförädling" ;
  traeklamp_nn_1_1_N = mkN "träklamp" ;
  traekaak_nn_1_1_N = mkN "träkåk" ;
  traeldom_nn_1_1_N = mkN "träldom" ;
  traengning_nn_1_1_N = mkN "trängning" ;
  traening_nn_1_1_N = mkN "träning" ;
  traeport_nn_1_1_N = mkN "träport" ;
  traeram_nn_1_1_N = mkN "träram" ;
  traesked_nn_1_1_N = mkN "träsked" ;
  traeskruv_nn_1_1_N = mkN "träskruv" ;
  traeslup_nn_1_1_N = mkN "träslup" ;
  traesnittsstock_nn_1_1_N = mkN "träsnittsstock" ;
  traackeltraad_nn_1_1_N = mkN "tråckeltråd" ;
  traackling_nn_1_1_N = mkN "tråckling" ;
  traadbindning_nn_1_1_N = mkN "trådbindning" ;
  traaddragning_nn_1_1_N = mkN "tråddragning" ;
  traadknapp_nn_1_1_N = mkN "trådknapp" ;
  traakning_nn_1_1_N = mkN "tråkning" ;
  troeghetsnavigering_nn_1_1_N = mkN "tröghetsnavigering" ;
  tsunamivarning_nn_1_N = mkN "tsunamivarning" ;
  tubbning_nn_1_N = mkN "tubbning" ;
  tudelning_nn_1_N = mkN "tudelning" ;
  tuggummibit_nn_1_N = mkN "tuggummibit" ;
  tullag_nn_1_N = mkN "tullag" ;
  tullbesiktning_nn_1_N = mkN "tullbesiktning" ;
  tullsnok_nn_1_N = mkN "tullsnok" ;
  tulpanloek_nn_1_1_N = mkN "tulpanlök" ;
  tulpanaeng_nn_1_1_N = mkN "tulpanäng" ;
  tumstock_nn_1_N = mkN "tumstock" ;
  tunnelbanebombning_nn_1_N = mkN "tunnelbanebombning" ;
  tupering_nn_1_N = mkN "tupering" ;
  tuppfaektning_nn_1_1_N = mkN "tuppfäktning" ;
  turistfoerening_nn_1_1_N = mkN "turistförening" ;
  turistnaering_nn_1_1_N = mkN "turistnäring" ;
  turnering_nn_1_N = mkN "turnering" ;
  turordning_nn_1_N = mkN "turordning" ;
  tuschering_nn_1_N = mkN "tuschering" ;
  tuschteckning_nn_1_N = mkN "tuschteckning" ;
  tussning_nn_1_N = mkN "tussning" ;
  tv_saendning_nn_1_1_N = mkN "tv-sändning" ;
  tvagning_nn_1_N = mkN "tvagning" ;
  tvivelshaallning_nn_1_1_N = mkN "tvivelshållning" ;
  tvaervaendning_nn_1_1_N = mkN "tvärvändning" ;
  tvaettbjoern_nn_1_1_N = mkN "tvättbjörn" ;
  tvaetthall_nn_1_1_N = mkN "tvätthall" ;
  tvaettinraettning_nn_1_1_N = mkN "tvättinrättning" ;
  tvaettkorg_nn_1_1_N = mkN "tvättkorg" ;
  tvaettsvamp_nn_1_1_N = mkN "tvättsvamp" ;
  tvaangsfoerestaellning_nn_1_1_N = mkN "tvångsföreställning" ;
  tvaangsintagning_nn_1_1_N = mkN "tvångsintagning" ;
  tvaangskommendering_nn_1_1_N = mkN "tvångskommendering" ;
  tvaangslag_nn_1_1_N = mkN "tvångslag" ;
  tvaangsrekrytering_nn_1_1_N = mkN "tvångsrekrytering" ;
  tvaarading_nn_1_1_N = mkN "tvårading" ;
  tvaaskaftsbindning_nn_1_1_N = mkN "tvåskaftsbindning" ;
  tvaaaaring_nn_1_1_N = mkN "tvååring" ;
  tvaaoering_nn_1_1_N = mkN "tvåöring" ;
  tydlighetskommatering_nn_1_N = mkN "tydlighetskommatering" ;
  tydning_nn_1_N = mkN "tydning" ;
  tygboll_nn_1_N = mkN "tygboll" ;
  tygbunt_nn_1_N = mkN "tygbunt" ;
  tyglapp_nn_1_N = mkN "tyglapp" ;
  tyngdkraftsstoerning_nn_1_1_N = mkN "tyngdkraftsstörning" ;
  tyngdlyftning_nn_1_N = mkN "tyngdlyftning" ;
  typbesiktning_nn_1_N = mkN "typbesiktning" ;
  typifiering_nn_1_N = mkN "typifiering" ;
  typisering_nn_1_N = mkN "typisering" ;
  tyrannisering_nn_1_N = mkN "tyrannisering" ;
  tyrolerhatt_nn_1_N = mkN "tyrolerhatt" ;
  taeckdikning_nn_1_1_N = mkN "täckdikning" ;
  taeckning_nn_1_1_N = mkN "täckning" ;
  taeljkniv_nn_1_1_N = mkN "täljkniv" ;
  taeltstol_nn_1_1_N = mkN "tältstol" ;
  taemjning_nn_1_1_N = mkN "tämjning" ;
  taendhatt_nn_1_1_N = mkN "tändhatt" ;
  taendning_nn_1_1_N = mkN "tändning" ;
  taenjning_nn_1_1_N = mkN "tänjning" ;
  taerning_nn_1_1_N = mkN "tärning" ;
  taetning_nn_1_1_N = mkN "tätning" ;
  taetplacering_nn_1_1_N = mkN "tätplacering" ;
  taevling_nn_1_1_N = mkN "tävling" ;
  taevlingsbil_nn_1_1_N = mkN "tävlingsbil" ;
  taevlingsledning_nn_1_1_N = mkN "tävlingsledning" ;
  taevlingslek_nn_1_1_N = mkN "tävlingslek" ;
  taevlingssegling_nn_1_1_N = mkN "tävlingssegling" ;
  taagavgaang_nn_1_1_N = mkN "tågavgång" ;
  taagkrock_nn_1_1_N = mkN "tågkrock" ;
  taagordning_nn_1_1_N = mkN "tågordning" ;
  taagurspaarning_nn_1_1_N = mkN "tågurspårning" ;
  taahaevning_nn_1_1_N = mkN "tåhävning" ;
  toejning_nn_1_1_N = mkN "töjning" ;
  toemning_nn_1_1_N = mkN "tömning" ;
  toemring_nn_1_1_N = mkN "tömring" ;
  uggleboll_nn_1_N = mkN "uggleboll" ;
  ugnshaell_nn_1_1_N = mkN "ugnshäll" ;
  ugnsinfodring_nn_1_N = mkN "ugnsinfodring" ;
  ugnskolning_nn_1_N = mkN "ugnskolning" ;
  ultrarapidfotografering_nn_1_N = mkN "ultrarapidfotografering" ;
  undanlaeggning_nn_1_1_N = mkN "undanläggning" ;
  undanroejning_nn_1_1_N = mkN "undanröjning" ;
  undanskuffning_nn_1_N = mkN "undanskuffning" ;
  undansnillning_nn_1_N = mkN "undansnillning" ;
  undantagslag_nn_1_N = mkN "undantagslag" ;
  undantagsstaellning_nn_1_1_N = mkN "undantagsställning" ;
  undantraengning_nn_1_1_N = mkN "undanträngning" ;
  undanvindsvaendning_nn_1_1_N = mkN "undanvindsvändning" ;
  underanvaendning_nn_1_1_N = mkN "underanvändning" ;
  underavdelning_nn_1_N = mkN "underavdelning" ;
  underbalansering_nn_1_N = mkN "underbalansering" ;
  underbefolkning_nn_1_N = mkN "underbefolkning" ;
  underbefaelsutbildning_nn_1_1_N = mkN "underbefälsutbildning" ;
  underbelaeggning_nn_1_1_N = mkN "underbeläggning" ;
  underbemanning_nn_1_N = mkN "underbemanning" ;
  underbetalning_nn_1_N = mkN "underbetalning" ;
  underbjudning_nn_1_N = mkN "underbjudning" ;
  underdimensionering_nn_1_N = mkN "underdimensionering" ;
  underexponering_nn_1_N = mkN "underexponering" ;
  undergraevning_nn_1_1_N = mkN "undergrävning" ;
  undergaang_nn_1_1_N = mkN "undergång" ;
  undergaangsstaemning_nn_1_1_N = mkN "undergångsstämning" ;
  underhandling_nn_1_N = mkN "underhandling" ;
  underhaallning_nn_1_1_N = mkN "underhållning" ;
  underjaesning_nn_1_1_N = mkN "underjäsning" ;
  underkjol_nn_1_N = mkN "underkjol" ;
  underklaenning_nn_1_1_N = mkN "underklänning" ;
  underkuvning_nn_1_N = mkN "underkuvning" ;
  underlaepp_nn_1_1_N = mkN "underläpp" ;
  underlaettning_nn_1_1_N = mkN "underlättning" ;
  undermedicinering_nn_1_N = mkN "undermedicinering" ;
  undermening_nn_1_N = mkN "undermening" ;
  underminering_nn_1_N = mkN "underminering" ;
  undermaalning_nn_1_1_N = mkN "undermålning" ;
  undernaering_nn_1_1_N = mkN "undernäring" ;
  underordning_nn_1_N = mkN "underordning" ;
  underredsbehandling_nn_1_N = mkN "underredsbehandling" ;
  underskattning_nn_1_N = mkN "underskattning" ;
  understrykning_nn_1_N = mkN "understrykning" ;
  understaellning_nn_1_1_N = mkN "underställning" ;
  understoedsfoerening_nn_1_1_N = mkN "understödsförening" ;
  understoet_nn_1_1_N = mkN "understöt" ;
  undersysselsaettning_nn_1_1_N = mkN "undersysselsättning" ;
  undersaeljning_nn_1_1_N = mkN "undersäljning" ;
  undersoekning_nn_1_1_N = mkN "undersökning" ;
  undertaxering_nn_1_N = mkN "undertaxering" ;
  undertraad_nn_1_1_N = mkN "undertråd" ;
  underutveckling_nn_1_N = mkN "underutveckling" ;
  undervattensbaat_nn_1_1_N = mkN "undervattensbåt" ;
  undervisning_nn_1_N = mkN "undervisning" ;
  undervaerdering_nn_1_1_N = mkN "undervärdering" ;
  undervaaning_nn_1_1_N = mkN "undervåning" ;
  undring_nn_1_N = mkN "undring" ;
  undskyllning_nn_1_N = mkN "undskyllning" ;
  undsaettning_nn_1_1_N = mkN "undsättning" ;
  undulering_nn_1_N = mkN "undulering" ;
  ungdom_nn_1_N = mkN "ungdom" ;
  ungdomsfoermedling_nn_1_1_N = mkN "ungdomsförmedling" ;
  ungdomskaerlek_nn_1_1_N = mkN "ungdomskärlek" ;
  ungskog_nn_1_N = mkN "ungskog" ;
  unifiering_nn_1_N = mkN "unifiering" ;
  uniformering_nn_1_N = mkN "uniformering" ;
  uniformsbeteckning_nn_1_N = mkN "uniformsbeteckning" ;
  uniformshatt_nn_1_N = mkN "uniformshatt" ;
  uniformsknapp_nn_1_N = mkN "uniformsknapp" ;
  unionsupploesning_nn_1_1_N = mkN "unionsupplösning" ;
  universalbegaavning_nn_1_1_N = mkN "universalbegåvning" ;
  universalkniv_nn_1_N = mkN "universalkniv" ;
  universalknut_nn_1_N = mkN "universalknut" ;
  universitetsutbildning_nn_1_N = mkN "universitetsutbildning" ;
  upparbetning_nn_1_N = mkN "upparbetning" ;
  uppassning_nn_1_N = mkN "uppassning" ;
  uppbackning_nn_1_N = mkN "uppbackning" ;
  uppbindning_nn_1_N = mkN "uppbindning" ;
  uppbjudning_nn_1_N = mkN "uppbjudning" ;
  uppblandning_nn_1_N = mkN "uppblandning" ;
  uppblomstring_nn_1_N = mkN "uppblomstring" ;
  uppblaasning_nn_1_1_N = mkN "uppblåsning" ;
  uppbringning_nn_1_N = mkN "uppbringning" ;
  uppbrottsstaemning_nn_1_1_N = mkN "uppbrottsstämning" ;
  uppbrusning_nn_1_N = mkN "uppbrusning" ;
  uppboerdsdag_nn_1_1_N = mkN "uppbördsdag" ;
  uppdatering_nn_1_N = mkN "uppdatering" ;
  uppdelning_nn_1_N = mkN "uppdelning" ;
  uppdragsforskning_nn_1_N = mkN "uppdragsforskning" ;
  uppdrivning_nn_1_N = mkN "uppdrivning" ;
  uppdukning_nn_1_N = mkN "uppdukning" ;
  uppdyrkning_nn_1_N = mkN "uppdyrkning" ;
  uppfartsvaeg_nn_1_1_N = mkN "uppfartsväg" ;
  uppfattning_nn_1_N = mkN "uppfattning" ;
  uppfinning_nn_1_N = mkN "uppfinning" ;
  uppfordring_nn_1_N = mkN "uppfordring" ;
  uppfostring_nn_1_N = mkN "uppfostring" ;
  uppfriskning_nn_1_N = mkN "uppfriskning" ;
  uppfoedning_nn_1_1_N = mkN "uppfödning" ;
  uppfoeljning_nn_1_1_N = mkN "uppföljning" ;
  uppgrundning_nn_1_N = mkN "uppgrundning" ;
  uppgaang_nn_1_1_N = mkN "uppgång" ;
  upphandling_nn_1_N = mkN "upphandling" ;
  upphetsning_nn_1_N = mkN "upphetsning" ;
  upphettning_nn_1_N = mkN "upphettning" ;
  upphostning_nn_1_N = mkN "upphostning" ;
  upphottning_nn_1_N = mkN "upphottning" ;
  upphaemtning_nn_1_1_N = mkN "upphämtning" ;
  upphaengning_nn_1_1_N = mkN "upphängning" ;
  upphaengningskrok_nn_1_1_N = mkN "upphängningskrok" ;
  upphoejning_nn_1_1_N = mkN "upphöjning" ;
  uppjustering_nn_1_N = mkN "uppjustering" ;
  uppkastning_nn_1_N = mkN "uppkastning" ;
  uppklarning_nn_1_N = mkN "uppklarning" ;
  uppkolning_nn_1_N = mkN "uppkolning" ;
  uppkomling_nn_1_N = mkN "uppkomling" ;
  uppkvark_nn_1_N = mkN "uppkvark" ;
  uppkoerning_nn_1_1_N = mkN "uppkörning" ;
  uppkoersvaeg_nn_1_1_N = mkN "uppkörsväg" ;
  uppladdning_nn_1_N = mkN "uppladdning" ;
  upplevelselaesning_nn_1_1_N = mkN "upplevelseläsning" ;
  upplevelsemaximering_nn_1_N = mkN "upplevelsemaximering" ;
  upplevelsevandring_nn_1_N = mkN "upplevelsevandring" ;
  upplivning_nn_1_N = mkN "upplivning" ;
  uppluckring_nn_1_N = mkN "uppluckring" ;
  upplysning_nn_1_N = mkN "upplysning" ;
  upplaeggning_nn_1_1_N = mkN "uppläggning" ;
  upplaenning_nn_1_1_N = mkN "upplänning" ;
  upplaesning_nn_1_1_N = mkN "uppläsning" ;
  upplaexning_nn_1_1_N = mkN "uppläxning" ;
  upplaaning_nn_1_1_N = mkN "upplåning" ;
  upploesning_nn_1_1_N = mkN "upplösning" ;
  uppmaning_nn_1_N = mkN "uppmaning" ;
  uppmjukning_nn_1_N = mkN "uppmjukning" ;
  uppmuntring_nn_1_N = mkN "uppmuntring" ;
  uppmaetning_nn_1_1_N = mkN "uppmätning" ;
  uppoffring_nn_1_N = mkN "uppoffring" ;
  uppreklamering_nn_1_N = mkN "uppreklamering" ;
  upprensning_nn_1_N = mkN "upprensning" ;
  upprepning_nn_1_N = mkN "upprepning" ;
  uppresning_nn_1_N = mkN "uppresning" ;
  uppretning_nn_1_N = mkN "uppretning" ;
  uppringning_nn_1_N = mkN "uppringning" ;
  upprinning_nn_1_N = mkN "upprinning" ;
  upprivning_nn_1_N = mkN "upprivning" ;
  upprullning_nn_1_N = mkN "upprullning" ;
  upprustning_nn_1_N = mkN "upprustning" ;
  uppryckning_nn_1_N = mkN "uppryckning" ;
  uppraekning_nn_1_1_N = mkN "uppräkning" ;
  uppraenning_nn_1_1_N = mkN "uppränning" ;
  upproejning_nn_1_1_N = mkN "uppröjning" ;
  uppsamling_nn_1_N = mkN "uppsamling" ;
  uppsamlingssaeck_nn_1_1_N = mkN "uppsamlingssäck" ;
  uppsittning_nn_1_N = mkN "uppsittning" ;
  uppsjungning_nn_1_N = mkN "uppsjungning" ;
  uppskalning_nn_1_N = mkN "uppskalning" ;
  uppskattning_nn_1_N = mkN "uppskattning" ;
  uppskjutning_nn_1_N = mkN "uppskjutning" ;
  uppskrivning_nn_1_N = mkN "uppskrivning" ;
  uppslukning_nn_1_N = mkN "uppslukning" ;
  uppslutning_nn_1_N = mkN "uppslutning" ;
  uppspaltning_nn_1_N = mkN "uppspaltning" ;
  uppspelning_nn_1_N = mkN "uppspelning" ;
  uppsplittring_nn_1_N = mkN "uppsplittring" ;
  uppspaerrning_nn_1_1_N = mkN "uppspärrning" ;
  uppstigning_nn_1_N = mkN "uppstigning" ;
  uppstoppning_nn_1_N = mkN "uppstoppning" ;
  uppstramning_nn_1_N = mkN "uppstramning" ;
  uppstraeckning_nn_1_1_N = mkN "uppsträckning" ;
  uppstaellning_nn_1_1_N = mkN "uppställning" ;
  uppstoetning_nn_1_1_N = mkN "uppstötning" ;
  uppsugning_nn_1_N = mkN "uppsugning" ;
  uppsummering_nn_1_N = mkN "uppsummering" ;
  uppsaegning_nn_1_1_N = mkN "uppsägning" ;
  uppsaegningsraekning_nn_1_1_N = mkN "uppsägningsräkning" ;
  uppsaettning_nn_1_1_N = mkN "uppsättning" ;
  uppsoekning_nn_1_1_N = mkN "uppsökning" ;
  upptagning_nn_1_N = mkN "upptagning" ;
  upptaxering_nn_1_N = mkN "upptaxering" ;
  uppteckning_nn_1_N = mkN "uppteckning" ;
  upptining_nn_1_N = mkN "upptining" ;
  upptrampning_nn_1_N = mkN "upptrampning" ;
  upptrappning_nn_1_N = mkN "upptrappning" ;
  upptryckning_nn_1_N = mkN "upptryckning" ;
  upptraedning_nn_1_1_N = mkN "uppträdning" ;
  uppvaktning_nn_1_N = mkN "uppvaktning" ;
  uppvigling_nn_1_N = mkN "uppvigling" ;
  uppvind_nn_1_N = mkN "uppvind" ;
  uppvisning_nn_1_N = mkN "uppvisning" ;
  uppvaegning_nn_1_1_N = mkN "uppvägning" ;
  uppvaerdering_nn_1_1_N = mkN "uppvärdering" ;
  uppvaermning_nn_1_1_N = mkN "uppvärmning" ;
  uppoevning_nn_1_1_N = mkN "uppövning" ;
  uralstring_nn_1_N = mkN "uralstring" ;
  uranbrytning_nn_1_N = mkN "uranbrytning" ;
  uranutvinning_nn_1_N = mkN "uranutvinning" ;
  urartning_nn_1_N = mkN "urartning" ;
  urbanisering_nn_1_N = mkN "urbanisering" ;
  urbefolkning_nn_1_N = mkN "urbefolkning" ;
  urbraenning_nn_1_1_N = mkN "urbränning" ;
  urgering_nn_1_N = mkN "urgering" ;
  urgroepning_nn_1_1_N = mkN "urgröpning" ;
  urholkning_nn_1_N = mkN "urholkning" ;
  urinavsoendring_nn_1_1_N = mkN "urinavsöndring" ;
  urinering_nn_1_N = mkN "urinering" ;
  urinfoergiftning_nn_1_1_N = mkN "urinförgiftning" ;
  urinstockning_nn_1_N = mkN "urinstockning" ;
  urintraengning_nn_1_1_N = mkN "urinträngning" ;
  urinvaeg_nn_1_1_N = mkN "urinväg" ;
  urkristendom_nn_1_N = mkN "urkristendom" ;
  urkundsforskning_nn_1_N = mkN "urkundsforskning" ;
  urkundsfoerfalskning_nn_1_1_N = mkN "urkundsförfalskning" ;
  urladdning_nn_1_N = mkN "urladdning" ;
  urlakning_nn_1_N = mkN "urlakning" ;
  urlastning_nn_1_N = mkN "urlastning" ;
  urledvrickning_nn_1_N = mkN "urledvrickning" ;
  urledvridning_nn_1_N = mkN "urledvridning" ;
  urnegrav_nn_1_N = mkN "urnegrav" ;
  urngrav_nn_1_N = mkN "urngrav" ;
  urnsaettning_nn_1_1_N = mkN "urnsättning" ;
  urogenitaloeppning_nn_1_1_N = mkN "urogenitalöppning" ;
  urringning_nn_1_N = mkN "urringning" ;
  urskiljning_nn_1_N = mkN "urskiljning" ;
  urskillning_nn_1_N = mkN "urskillning" ;
  urskog_nn_1_N = mkN "urskog" ;
  ursprungsbefolkning_nn_1_N = mkN "ursprungsbefolkning" ;
  ursprungsbeteckning_nn_1_N = mkN "ursprungsbeteckning" ;
  urspaarning_nn_1_1_N = mkN "urspårning" ;
  urtappning_nn_1_N = mkN "urtappning" ;
  urvalsundersoekning_nn_1_1_N = mkN "urvalsundersökning" ;
  usb_sladd_nn_1_N = mkN "usb-sladd" ;
  usurpering_nn_1_N = mkN "usurpering" ;
  utackordering_nn_1_N = mkN "utackordering" ;
  utandning_nn_1_N = mkN "utandning" ;
  utannonsering_nn_1_N = mkN "utannonsering" ;
  utanordning_nn_1_N = mkN "utanordning" ;
  utarbetning_nn_1_N = mkN "utarbetning" ;
  utarrendering_nn_1_N = mkN "utarrendering" ;
  utbalansering_nn_1_N = mkN "utbalansering" ;
  utbasunering_nn_1_N = mkN "utbasunering" ;
  utbasuning_nn_1_N = mkN "utbasuning" ;
  utbetalning_nn_1_N = mkN "utbetalning" ;
  utbildning_nn_1_N = mkN "utbildning" ;
  utbildningsvaeg_nn_1_1_N = mkN "utbildningsväg" ;
  utblick_nn_1_N = mkN "utblick" ;
  utblaasning_nn_1_1_N = mkN "utblåsning" ;
  utbredning_nn_1_N = mkN "utbredning" ;
  utbrodering_nn_1_N = mkN "utbrodering" ;
  utbrytning_nn_1_N = mkN "utbrytning" ;
  utbuktning_nn_1_N = mkN "utbuktning" ;
  utbytesbil_nn_1_N = mkN "utbytesbil" ;
  utbaering_nn_1_1_N = mkN "utbäring" ;
  utbaerning_nn_1_1_N = mkN "utbärning" ;
  utdebitering_nn_1_N = mkN "utdebitering" ;
  utdelning_nn_1_N = mkN "utdelning" ;
  utdikning_nn_1_N = mkN "utdikning" ;
  utdockning_nn_1_N = mkN "utdockning" ;
  utdragning_nn_1_N = mkN "utdragning" ;
  utdragssaeng_nn_1_1_N = mkN "utdragssäng" ;
  utdrivning_nn_1_N = mkN "utdrivning" ;
  utdunstning_nn_1_N = mkN "utdunstning" ;
  utdoemning_nn_1_1_N = mkN "utdömning" ;
  utelaemning_nn_1_1_N = mkN "utelämning" ;
  uteservering_nn_1_N = mkN "uteservering" ;
  uteslutning_nn_1_N = mkN "uteslutning" ;
  utestaengning_nn_1_1_N = mkN "utestängning" ;
  utexaminering_nn_1_N = mkN "utexaminering" ;
  utexperimentering_nn_1_N = mkN "utexperimentering" ;
  utfallsport_nn_1_N = mkN "utfallsport" ;
  utfartsvaeg_nn_1_1_N = mkN "utfartsväg" ;
  utflaggning_nn_1_N = mkN "utflaggning" ;
  utflyttning_nn_1_N = mkN "utflyttning" ;
  utflaekning_nn_1_1_N = mkN "utfläkning" ;
  utfodring_nn_1_N = mkN "utfodring" ;
  utformning_nn_1_N = mkN "utformning" ;
  utforskning_nn_1_N = mkN "utforskning" ;
  utfrysning_nn_1_N = mkN "utfrysning" ;
  utfraagning_nn_1_1_N = mkN "utfrågning" ;
  utfyllning_nn_1_N = mkN "utfyllning" ;
  utfaellning_nn_1_1_N = mkN "utfällning" ;
  utfoering_nn_1_1_N = mkN "utföring" ;
  utfoersaekring_nn_1_1_N = mkN "utförsäkring" ;
  utfoersaeljning_nn_1_1_N = mkN "utförsäljning" ;
  utfoersaakning_nn_1_1_N = mkN "utförsåkning" ;
  utgallring_nn_1_N = mkN "utgallring" ;
  utgivning_nn_1_N = mkN "utgivning" ;
  utgjutning_nn_1_N = mkN "utgjutning" ;
  utglesning_nn_1_N = mkN "utglesning" ;
  utgraevning_nn_1_1_N = mkN "utgrävning" ;
  utgaang_nn_1_1_N = mkN "utgång" ;
  utgaangsfoerutsaettning_nn_1_1_N = mkN "utgångsförutsättning" ;
  utgaangsstaellning_nn_1_1_N = mkN "utgångsställning" ;
  utgoedsling_nn_1_1_N = mkN "utgödsling" ;
  uthuggning_nn_1_N = mkN "uthuggning" ;
  uthungring_nn_1_N = mkN "uthungring" ;
  uthusvaegg_nn_1_1_N = mkN "uthusvägg" ;
  uthyrning_nn_1_N = mkN "uthyrning" ;
  uthaallighetsloepning_nn_1_1_N = mkN "uthållighetslöpning" ;
  uthaallighetstaevling_nn_1_1_N = mkN "uthållighetstävling" ;
  uthaallning_nn_1_1_N = mkN "uthållning" ;
  utjaemning_nn_1_1_N = mkN "utjämning" ;
  utkastning_nn_1_N = mkN "utkastning" ;
  utklarering_nn_1_N = mkN "utklarering" ;
  utklassning_nn_1_N = mkN "utklassning" ;
  utklaedning_nn_1_1_N = mkN "utklädning" ;
  utklaengning_nn_1_1_N = mkN "utklängning" ;
  utkommendering_nn_1_N = mkN "utkommendering" ;
  utkonkurrering_nn_1_N = mkN "utkonkurrering" ;
  utkragning_nn_1_N = mkN "utkragning" ;
  utkristallisering_nn_1_N = mkN "utkristallisering" ;
  utkraevning_nn_1_1_N = mkN "utkrävning" ;
  utkvittering_nn_1_N = mkN "utkvittering" ;
  utkvittning_nn_1_N = mkN "utkvittning" ;
  utkylning_nn_1_N = mkN "utkylning" ;
  utkoerning_nn_1_1_N = mkN "utkörning" ;
  utloggning_nn_1_N = mkN "utloggning" ;
  utlokalisering_nn_1_N = mkN "utlokalisering" ;
  utlysning_nn_1_N = mkN "utlysning" ;
  utlaeggning_nn_1_1_N = mkN "utläggning" ;
  utlaemning_nn_1_1_N = mkN "utlämning" ;
  utlaenning_nn_1_1_N = mkN "utlänning" ;
  utlaenningslag_nn_1_1_N = mkN "utlänningslag" ;
  utlaaning_nn_1_1_N = mkN "utlåning" ;
  utloesning_nn_1_1_N = mkN "utlösning" ;
  utmaning_nn_1_N = mkN "utmaning" ;
  utmanoevrering_nn_1_1_N = mkN "utmanövrering" ;
  utmatning_nn_1_N = mkN "utmatning" ;
  utmattning_nn_1_N = mkN "utmattning" ;
  utminutering_nn_1_N = mkN "utminutering" ;
  utmaerkning_nn_1_1_N = mkN "utmärkning" ;
  utmaetning_nn_1_1_N = mkN "utmätning" ;
  utmaalning_nn_1_1_N = mkN "utmålning" ;
  utnaemning_nn_1_1_N = mkN "utnämning" ;
  utnoetning_nn_1_1_N = mkN "utnötning" ;
  utomhusbelysning_nn_1_N = mkN "utomhusbelysning" ;
  utomjording_nn_1_N = mkN "utomjording" ;
  utpekning_nn_1_N = mkN "utpekning" ;
  utplacering_nn_1_N = mkN "utplacering" ;
  utplaaning_nn_1_1_N = mkN "utplåning" ;
  utpressning_nn_1_N = mkN "utpressning" ;
  utpressningsraettegaang_nn_1_1_N = mkN "utpressningsrättegång" ;
  utprickning_nn_1_N = mkN "utprickning" ;
  utradering_nn_1_N = mkN "utradering" ;
  utrangering_nn_1_N = mkN "utrangering" ;
  utredning_nn_1_N = mkN "utredning" ;
  utrensning_nn_1_N = mkN "utrensning" ;
  utrikesavgaang_nn_1_1_N = mkN "utrikesavgång" ;
  utrotning_nn_1_N = mkN "utrotning" ;
  utrullning_nn_1_N = mkN "utrullning" ;
  utrustning_nn_1_N = mkN "utrustning" ;
  utryckning_nn_1_N = mkN "utryckning" ;
  utrymning_nn_1_N = mkN "utrymning" ;
  utraekning_nn_1_1_N = mkN "uträkning" ;
  utraettning_nn_1_1_N = mkN "uträttning" ;
  utseendefixering_nn_1_N = mkN "utseendefixering" ;
  utsining_nn_1_N = mkN "utsining" ;
  utsirning_nn_1_N = mkN "utsirning" ;
  utskeppning_nn_1_N = mkN "utskeppning" ;
  utskiftning_nn_1_N = mkN "utskiftning" ;
  utskrivning_nn_1_N = mkN "utskrivning" ;
  utskaellning_nn_1_1_N = mkN "utskällning" ;
  utskaenkning_nn_1_1_N = mkN "utskänkning" ;
  utskaerning_nn_1_1_N = mkN "utskärning" ;
  utskaapning_nn_1_1_N = mkN "utskåpning" ;
  utslagning_nn_1_N = mkN "utslagning" ;
  utslagstaevling_nn_1_1_N = mkN "utslagstävling" ;
  utslungning_nn_1_N = mkN "utslungning" ;
  utslussning_nn_1_N = mkN "utslussning" ;
  utslutning_nn_1_N = mkN "utslutning" ;
  utslaeckning_nn_1_1_N = mkN "utsläckning" ;
  utslaeppsminskning_nn_1_1_N = mkN "utsläppsminskning" ;
  utslaetning_nn_1_1_N = mkN "utslätning" ;
  utsmyckning_nn_1_N = mkN "utsmyckning" ;
  utspaning_nn_1_N = mkN "utspaning" ;
  utspark_nn_1_N = mkN "utspark" ;
  utspisning_nn_1_N = mkN "utspisning" ;
  utspaedning_nn_1_1_N = mkN "utspädning" ;
  utspaenning_nn_1_1_N = mkN "utspänning" ;
  utspaerrning_nn_1_1_N = mkN "utspärrning" ;
  utstakning_nn_1_N = mkN "utstakning" ;
  utstoffering_nn_1_N = mkN "utstoffering" ;
  utstraeckning_nn_1_1_N = mkN "utsträckning" ;
  utstraalning_nn_1_1_N = mkN "utstrålning" ;
  utstaellning_nn_1_1_N = mkN "utställning" ;
  utstoetning_nn_1_1_N = mkN "utstötning" ;
  utsugning_nn_1_N = mkN "utsugning" ;
  utsvaellning_nn_1_1_N = mkN "utsvällning" ;
  utsvaevning_nn_1_1_N = mkN "utsvävning" ;
  utsyning_nn_1_N = mkN "utsyning" ;
  utsaegning_nn_1_1_N = mkN "utsägning" ;
  utsaendning_nn_1_1_N = mkN "utsändning" ;
  utsoekning_nn_1_1_N = mkN "utsökning" ;
  utsoendring_nn_1_1_N = mkN "utsöndring" ;
  uttagning_nn_1_N = mkN "uttagning" ;
  uttalsbeteckning_nn_1_N = mkN "uttalsbeteckning" ;
  uttaxering_nn_1_N = mkN "uttaxering" ;
  uttolkning_nn_1_N = mkN "uttolkning" ;
  uttorkning_nn_1_N = mkN "uttorkning" ;
  uttroettning_nn_1_1_N = mkN "uttröttning" ;
  uttydning_nn_1_N = mkN "uttydning" ;
  uttaenjning_nn_1_1_N = mkN "uttänjning" ;
  uttoemning_nn_1_1_N = mkN "uttömning" ;
  utvandring_nn_1_N = mkN "utvandring" ;
  utveckling_nn_1_N = mkN "utveckling" ;
  utvecklingsgaang_nn_1_1_N = mkN "utvecklingsgång" ;
  utvecklingsrubbning_nn_1_N = mkN "utvecklingsrubbning" ;
  utvecklingsstoerning_nn_1_1_N = mkN "utvecklingsstörning" ;
  utvecklingsvaeg_nn_1_1_N = mkN "utvecklingsväg" ;
  utvidgning_nn_1_N = mkN "utvidgning" ;
  utvikning_nn_1_N = mkN "utvikning" ;
  utvinning_nn_1_N = mkN "utvinning" ;
  utvisning_nn_1_N = mkN "utvisning" ;
  utvaeg_nn_1_1_N = mkN "utväg" ;
  utvaerdering_nn_1_1_N = mkN "utvärdering" ;
  utvaexling_nn_1_1_N = mkN "utväxling" ;
  utoekning_nn_1_1_N = mkN "utökning" ;
  vaccinering_nn_1_N = mkN "vaccinering" ;
  vacuumfoerpackning_nn_1_1_N = mkN "vacuumförpackning" ;
  vacuumpump_nn_1_N = mkN "vacuumpump" ;
  vacuumsug_nn_1_N = mkN "vacuumsug" ;
  vacuumtorkning_nn_1_N = mkN "vacuumtorkning" ;
  vaddering_nn_1_N = mkN "vaddering" ;
  vadhaallning_nn_1_1_N = mkN "vadhållning" ;
  vadhaallningslag_nn_1_1_N = mkN "vadhållningslag" ;
  vadning_nn_1_N = mkN "vadning" ;
  vadslagning_nn_1_N = mkN "vadslagning" ;
  vagabondering_nn_1_N = mkN "vagabondering" ;
  vagnbjoern_nn_1_1_N = mkN "vagnbjörn" ;
  vagnsdoerr_nn_1_1_N = mkN "vagnsdörr" ;
  vagnshaeck_nn_1_1_N = mkN "vagnshäck" ;
  vagnskadefoersaekring_nn_1_1_N = mkN "vagnskadeförsäkring" ;
  vagnsport_nn_1_N = mkN "vagnsport" ;
  vagnstock_nn_1_N = mkN "vagnstock" ;
  vaksinering_nn_1_N = mkN "vaksinering" ;
  vaktavloesning_nn_1_1_N = mkN "vaktavlösning" ;
  vakthaallning_nn_1_1_N = mkN "vakthållning" ;
  vakuumfoerpackning_nn_1_1_N = mkN "vakuumförpackning" ;
  vakuumpump_nn_1_N = mkN "vakuumpump" ;
  vakuumsug_nn_1_N = mkN "vakuumsug" ;
  vakuumtorkning_nn_1_N = mkN "vakuumtorkning" ;
  valberedning_nn_1_N = mkN "valberedning" ;
  valbod_nn_1_N = mkN "valbod" ;
  valgranskning_nn_1_N = mkN "valgranskning" ;
  vallmoodling_nn_1_N = mkN "vallmoodling" ;
  vallokalsundersoekning_nn_1_1_N = mkN "vallokalsundersökning" ;
  valomgaang_nn_1_1_N = mkN "valomgång" ;
  valpning_nn_1_N = mkN "valpning" ;
  valutareglering_nn_1_N = mkN "valutareglering" ;
  valutering_nn_1_N = mkN "valutering" ;
  valutgaang_nn_1_1_N = mkN "valutgång" ;
  valvering_nn_1_N = mkN "valvering" ;
  valvind_nn_1_N = mkN "valvind" ;
  valvport_nn_1_N = mkN "valvport" ;
  valvslagning_nn_1_N = mkN "valvslagning" ;
  vandalisering_nn_1_N = mkN "vandalisering" ;
  vandring_nn_1_N = mkN "vandring" ;
  vandringsutstaellning_nn_1_1_N = mkN "vandringsutställning" ;
  vanebildning_nn_1_N = mkN "vanebildning" ;
  vanfoerestaellning_nn_1_1_N = mkN "vanföreställning" ;
  vansinneskoerning_nn_1_1_N = mkN "vansinneskörning" ;
  vantolkning_nn_1_N = mkN "vantolkning" ;
  vantskruv_nn_1_N = mkN "vantskruv" ;
  vapenlek_nn_1_N = mkN "vapenlek" ;
  vapenskoeld_nn_1_1_N = mkN "vapensköld" ;
  varbildning_nn_1_N = mkN "varbildning" ;
  vardag_nn_1_N = mkN "vardag" ;
  vardagsmiddag_nn_1_N = mkN "vardagsmiddag" ;
  vargering_nn_1_N = mkN "vargering" ;
  vargflock_nn_1_N = mkN "vargflock" ;
  variering_nn_1_N = mkN "variering" ;
  varmhaallning_nn_1_1_N = mkN "varmhållning" ;
  varmluftsflaekt_nn_1_1_N = mkN "varmluftsfläkt" ;
  varning_nn_1_N = mkN "varning" ;
  varpning_nn_1_N = mkN "varpning" ;
  varptraad_nn_1_1_N = mkN "varptråd" ;
  varseblivning_nn_1_N = mkN "varseblivning" ;
  varubelaaning_nn_1_1_N = mkN "varubelåning" ;
  varubeteckning_nn_1_N = mkN "varubeteckning" ;
  varudeklarering_nn_1_N = mkN "varudeklarering" ;
  varulv_nn_1_N = mkN "varulv" ;
  varutransportbil_nn_1_N = mkN "varutransportbil" ;
  vattenavlaesning_nn_1_1_N = mkN "vattenavläsning" ;
  vattenavrinning_nn_1_N = mkN "vattenavrinning" ;
  vattenblomning_nn_1_N = mkN "vattenblomning" ;
  vattendomstol_nn_1_N = mkN "vattendomstol" ;
  vattenfoerorening_nn_1_1_N = mkN "vattenförorening" ;
  vattenkoppling_nn_1_N = mkN "vattenkoppling" ;
  vattenkvarn_nn_1_N = mkN "vattenkvarn" ;
  vattenledning_nn_1_N = mkN "vattenledning" ;
  vattenloesning_nn_1_1_N = mkN "vattenlösning" ;
  vattenpump_nn_1_N = mkN "vattenpump" ;
  vattenreglering_nn_1_N = mkN "vattenreglering" ;
  vattenrening_nn_1_N = mkN "vattenrening" ;
  vattenring_nn_1_N = mkN "vattenring" ;
  vattensamling_nn_1_N = mkN "vattensamling" ;
  vattenslang_nn_1_N = mkN "vattenslang" ;
  vattensork_nn_1_N = mkN "vattensork" ;
  vattensaeck_nn_1_1_N = mkN "vattensäck" ;
  vattentrampning_nn_1_N = mkN "vattentrampning" ;
  vattenvaeg_nn_1_1_N = mkN "vattenväg" ;
  vattenoesning_nn_1_1_N = mkN "vattenösning" ;
  vattring_nn_1_N = mkN "vattring" ;
  vattvaelling_nn_1_1_N = mkN "vattvälling" ;
  vaxduk_nn_1_N = mkN "vaxduk" ;
  vaxning_nn_1_N = mkN "vaxning" ;
  vaxpropp_nn_1_N = mkN "vaxpropp" ;
  veckning_nn_1_N = mkN "veckning" ;
  veckoavdelning_nn_1_N = mkN "veckoavdelning" ;
  veckohandling_nn_1_N = mkN "veckohandling" ;
  veckopendling_nn_1_N = mkN "veckopendling" ;
  veckotidning_nn_1_N = mkN "veckotidning" ;
  vedergaellning_nn_1_1_N = mkN "vedergällning" ;
  vedhuggning_nn_1_N = mkN "vedhuggning" ;
  vedhoeg_nn_1_1_N = mkN "vedhög" ;
  vedkapning_nn_1_N = mkN "vedkapning" ;
  vedkapsaag_nn_1_1_N = mkN "vedkapsåg" ;
  vedklyv_nn_1_N = mkN "vedklyv" ;
  vedsaag_nn_1_1_N = mkN "vedsåg" ;
  velourisering_nn_1_N = mkN "velourisering" ;
  ventilationsflaekt_nn_1_1_N = mkN "ventilationsfläkt" ;
  ventilering_nn_1_N = mkN "ventilering" ;
  ventilhatt_nn_1_N = mkN "ventilhatt" ;
  verandadoerr_nn_1_1_N = mkN "verandadörr" ;
  verbalisering_nn_1_N = mkN "verbalisering" ;
  verbhandling_nn_1_N = mkN "verbhandling" ;
  verbsammansaettning_nn_1_1_N = mkN "verbsammansättning" ;
  verifiering_nn_1_N = mkN "verifiering" ;
  verklighetsbeskrivning_nn_1_N = mkN "verklighetsbeskrivning" ;
  verkning_nn_1_N = mkN "verkning" ;
  verkstadsfoerening_nn_1_1_N = mkN "verkstadsförening" ;
  verkstadskran_nn_1_N = mkN "verkstadskran" ;
  verktygskrok_nn_1_N = mkN "verktygskrok" ;
  vernalisering_nn_1_N = mkN "vernalisering" ;
  versbindning_nn_1_N = mkN "versbindning" ;
  versifiering_nn_1_N = mkN "versifiering" ;
  veteranbil_nn_1_N = mkN "veteranbil" ;
  veterinaerbesiktning_nn_1_1_N = mkN "veterinärbesiktning" ;
  vibrering_nn_1_N = mkN "vibrering" ;
  vickning_nn_1_N = mkN "vickning" ;
  vidareutbildning_nn_1_N = mkN "vidareutbildning" ;
  vidareutveckling_nn_1_N = mkN "vidareutveckling" ;
  vidbraenning_nn_1_1_N = mkN "vidbränning" ;
  vidgning_nn_1_N = mkN "vidgning" ;
  vidhaeftning_nn_1_1_N = mkN "vidhäftning" ;
  vidhaengning_nn_1_1_N = mkN "vidhängning" ;
  vidimering_nn_1_N = mkN "vidimering" ;
  vidraekning_nn_1_1_N = mkN "vidräkning" ;
  viftning_nn_1_N = mkN "viftning" ;
  viggning_nn_1_N = mkN "viggning" ;
  vigilering_nn_1_N = mkN "vigilering" ;
  vigning_nn_1_N = mkN "vigning" ;
  vigselring_nn_1_N = mkN "vigselring" ;
  vikariering_nn_1_N = mkN "vikariering" ;
  vikdoerr_nn_1_1_N = mkN "vikdörr" ;
  vikingagrav_nn_1_N = mkN "vikingagrav" ;
  vikning_nn_1_N = mkN "vikning" ;
  viktkastning_nn_1_N = mkN "viktkastning" ;
  viktklubb_nn_1_N = mkN "viktklubb" ;
  viktminskning_nn_1_N = mkN "viktminskning" ;
  viktning_nn_1_N = mkN "viktning" ;
  viktoekning_nn_1_1_N = mkN "viktökning" ;
  vildsvinsflock_nn_1_N = mkN "vildsvinsflock" ;
  viljeanstraengning_nn_1_1_N = mkN "viljeansträngning" ;
  viljefoerklaring_nn_1_1_N = mkN "viljeförklaring" ;
  viljefoerlamning_nn_1_1_N = mkN "viljeförlamning" ;
  viljehandling_nn_1_N = mkN "viljehandling" ;
  viljeinriktning_nn_1_N = mkN "viljeinriktning" ;
  viljeriktning_nn_1_N = mkN "viljeriktning" ;
  viljeyttring_nn_1_N = mkN "viljeyttring" ;
  villovaeg_nn_1_1_N = mkN "villoväg" ;
  vilseledning_nn_1_N = mkN "vilseledning" ;
  vilstol_nn_1_N = mkN "vilstol" ;
  viltplantering_nn_1_N = mkN "viltplantering" ;
  vind_nn_2_N = mkN "vind" ;
  vindflaekt_nn_1_1_N = mkN "vindfläkt" ;
  vindicering_nn_1_N = mkN "vindicering" ;
  vindkantring_nn_1_N = mkN "vindkantring" ;
  vindling_nn_1_N = mkN "vindling" ;
  vindmaetning_nn_1_1_N = mkN "vindmätning" ;
  vindning_nn_1_N = mkN "vindning" ;
  vindpollinering_nn_1_N = mkN "vindpollinering" ;
  vindriktning_nn_1_N = mkN "vindriktning" ;
  vindvridning_nn_1_N = mkN "vindvridning" ;
  vindaendring_nn_1_1_N = mkN "vindändring" ;
  vingglidning_nn_1_N = mkN "vingglidning" ;
  vingteckning_nn_1_N = mkN "vingteckning" ;
  vingud_nn_1_N = mkN "vingud" ;
  vinkling_nn_1_N = mkN "vinkling" ;
  vinkning_nn_1_N = mkN "vinkning" ;
  vinkork_nn_1_N = mkN "vinkork" ;
  vinning_nn_1_N = mkN "vinning" ;
  vinodling_nn_1_N = mkN "vinodling" ;
  vinprovning_nn_1_N = mkN "vinprovning" ;
  vinservering_nn_1_N = mkN "vinservering" ;
  vinskoerd_nn_1_1_N = mkN "vinskörd" ;
  vinstdelning_nn_1_N = mkN "vinstdelning" ;
  vinstminskning_nn_1_N = mkN "vinstminskning" ;
  vinstock_nn_1_N = mkN "vinstock" ;
  vinstutdelning_nn_1_N = mkN "vinstutdelning" ;
  vinstvarning_nn_1_N = mkN "vinstvarning" ;
  vinterdag_nn_1_N = mkN "vinterdag" ;
  vinterhamn_nn_1_N = mkN "vinterhamn" ;
  vinterhaempling_nn_1_1_N = mkN "vinterhämpling" ;
  vinterlek_nn_1_N = mkN "vinterlek" ;
  vintervaeg_nn_1_1_N = mkN "vinterväg" ;
  vipparm_nn_1_N = mkN "vipparm" ;
  vippkoppling_nn_1_N = mkN "vippkoppling" ;
  virkesmaetning_nn_1_1_N = mkN "virkesmätning" ;
  virkkrok_nn_1_N = mkN "virkkrok" ;
  virkning_nn_1_N = mkN "virkning" ;
  virknaal_nn_1_1_N = mkN "virknål" ;
  virussjukdom_nn_1_N = mkN "virussjukdom" ;
  virvelvind_nn_1_N = mkN "virvelvind" ;
  visdom_nn_1_N = mkN "visdom" ;
  visering_nn_1_N = mkN "visering" ;
  visitering_nn_1_N = mkN "visitering" ;
  viskning_nn_1_N = mkN "viskning" ;
  visning_nn_1_N = mkN "visning" ;
  vissling_nn_1_N = mkN "vissling" ;
  visstidsanstaellning_nn_1_1_N = mkN "visstidsanställning" ;
  visualisering_nn_1_N = mkN "visualisering" ;
  vitalfaergning_nn_1_1_N = mkN "vitalfärgning" ;
  vitalisering_nn_1_N = mkN "vitalisering" ;
  vitaminburk_nn_1_N = mkN "vitaminburk" ;
  vitaminering_nn_1_N = mkN "vitaminering" ;
  vitaminisering_nn_1_N = mkN "vitaminisering" ;
  vitgloedgning_nn_1_1_N = mkN "vitglödgning" ;
  vitloek_nn_1_1_N = mkN "vitlök" ;
  vitmening_nn_1_N = mkN "vitmening" ;
  vitterlek_nn_1_N = mkN "vitterlek" ;
  vittring_nn_1_N = mkN "vittring" ;
  vokabelsamling_nn_1_N = mkN "vokabelsamling" ;
  vokalisering_nn_1_N = mkN "vokalisering" ;
  vokalvaexling_nn_1_1_N = mkN "vokalväxling" ;
  volframnaal_nn_1_1_N = mkN "volframnål" ;
  volleyboll_nn_2_N = mkN "volleyboll" ;
  volmning_nn_1_N = mkN "volmning" ;
  voltigering_nn_1_N = mkN "voltigering" ;
  vomering_nn_1_N = mkN "vomering" ;
  votering_nn_1_N = mkN "votering" ;
  voteringsskylt_nn_1_N = mkN "voteringsskylt" ;
  vrakning_nn_1_N = mkN "vrakning" ;
  vrakplundring_nn_1_N = mkN "vrakplundring" ;
  vrickning_nn_1_N = mkN "vrickning" ;
  vridning_nn_1_N = mkN "vridning" ;
  vristlaenk_nn_1_1_N = mkN "vristlänk" ;
  vraekning_nn_1_1_N = mkN "vräkning" ;
  vraengning_nn_1_1_N = mkN "vrängning" ;
  vulgarisering_nn_1_N = mkN "vulgarisering" ;
  vulkanisering_nn_1_N = mkN "vulkanisering" ;
  vulkanvarning_nn_1_N = mkN "vulkanvarning" ;
  vuxenvaerld_nn_1_1_N = mkN "vuxenvärld" ;
  vaeckning_nn_1_1_N = mkN "väckning" ;
  vaederkvarn_nn_1_1_N = mkN "väderkvarn" ;
  vaederlek_nn_1_1_N = mkN "väderlek" ;
  vaedermaetning_nn_1_1_N = mkN "vädermätning" ;
  vaederspaenning_nn_1_1_N = mkN "väderspänning" ;
  vaegbelaeggning_nn_1_1_N = mkN "vägbeläggning" ;
  vaegfoerening_nn_1_1_N = mkN "vägförening" ;
  vaegfoervaltning_nn_1_1_N = mkN "vägförvaltning" ;
  vaeggarm_nn_1_1_N = mkN "väggarm" ;
  vaeggmaalning_nn_1_1_N = mkN "väggmålning" ;
  vaeggtidning_nn_1_1_N = mkN "väggtidning" ;
  vaeghaallning_nn_1_1_N = mkN "väghållning" ;
  vaeginvestering_nn_1_1_N = mkN "väginvestering" ;
  vaegkorsning_nn_1_1_N = mkN "vägkorsning" ;
  vaegkrog_nn_1_1_N = mkN "vägkrog" ;
  vaeglag_nn_2_1_N = mkN "väglag" ;
  vaegledning_nn_1_1_N = mkN "vägledning" ;
  vaegning_nn_1_1_N = mkN "vägning" ;
  vaegport_nn_1_1_N = mkN "vägport" ;
  vaegskylt_nn_1_1_N = mkN "vägskylt" ;
  vaegspaerr_nn_1_1_N = mkN "vägspärr" ;
  vaejning_nn_1_1_N = mkN "väjning" ;
  vaelgaerning_nn_1_1_N = mkN "välgärning" ;
  vaeljarundersoekning_nn_1_1_N = mkN "väljarundersökning" ;
  vaelkomsthaelsning_nn_1_1_N = mkN "välkomsthälsning" ;
  vaelkomstmiddag_nn_1_1_N = mkN "välkomstmiddag" ;
  vaellning_nn_1_1_N = mkN "vällning" ;
  vaellsvetsning_nn_1_1_N = mkN "vällsvetsning" ;
  vaelskrivning_nn_1_1_N = mkN "välskrivning" ;
  vaelvning_nn_1_1_N = mkN "välvning" ;
  vaendning_nn_1_1_N = mkN "vändning" ;
  vaendrostning_nn_1_1_N = mkN "vändrostning" ;
  vaenskapskram_nn_1_1_N = mkN "vänskapskram" ;
  vaensterknapp_nn_1_1_N = mkN "vänsterknapp" ;
  vaensterregering_nn_1_1_N = mkN "vänsterregering" ;
  vaenstersvaeng_nn_1_1_N = mkN "vänstersväng" ;
  vaenstertidning_nn_1_1_N = mkN "vänstertidning" ;
  vaentsal_nn_1_1_N = mkN "väntsal" ;
  vaerdehandling_nn_1_1_N = mkN "värdehandling" ;
  vaerdeminskning_nn_1_1_N = mkN "värdeminskning" ;
  vaerdering_nn_1_1_N = mkN "värdering" ;
  vaerdestegring_nn_1_1_N = mkN "värdestegring" ;
  vaerdesaettning_nn_1_1_N = mkN "värdesättning" ;
  vaerdeoekning_nn_1_1_N = mkN "värdeökning" ;
  vaerdshusvaerd_nn_1_1_N = mkN "värdshusvärd" ;
  vaerdvaexling_nn_1_1_N = mkN "värdväxling" ;
  vaerld_nn_1_1_N = mkN "värld" ;
  vaerldsomsegling_nn_1_1_N = mkN "världsomsegling" ;
  vaerldsordning_nn_1_1_N = mkN "världsordning" ;
  vaerldsuppfattning_nn_1_1_N = mkN "världsuppfattning" ;
  vaerldsutstaellning_nn_1_1_N = mkN "världsutställning" ;
  vaerldsaaskaadning_nn_1_1_N = mkN "världsåskådning" ;
  vaermeanlaeggning_nn_1_1_N = mkN "värmeanläggning" ;
  vaermebehandling_nn_1_1_N = mkN "värmebehandling" ;
  vaermedaempning_nn_1_1_N = mkN "värmedämpning" ;
  vaermefotografering_nn_1_1_N = mkN "värmefotografering" ;
  vaermeisolering_nn_1_1_N = mkN "värmeisolering" ;
  vaermeledning_nn_1_1_N = mkN "värmeledning" ;
  vaermepump_nn_1_1_N = mkN "värmepump" ;
  vaermeskoeld_nn_1_1_N = mkN "värmesköld" ;
  vaermespridning_nn_1_1_N = mkN "värmespridning" ;
  vaermesterilisering_nn_1_1_N = mkN "värmesterilisering" ;
  vaermestraalning_nn_1_1_N = mkN "värmestrålning" ;
  vaermeutveckling_nn_1_1_N = mkN "värmeutveckling" ;
  vaermeutvidgning_nn_1_1_N = mkN "värmeutvidgning" ;
  vaermlaenning_nn_1_1_N = mkN "värmlänning" ;
  vaermning_nn_1_1_N = mkN "värmning" ;
  vaernpliktstjaenstgoering_nn_1_1_N = mkN "värnpliktstjänstgöring" ;
  vaervning_nn_1_1_N = mkN "värvning" ;
  vaesning_nn_1_1_N = mkN "väsning" ;
  vaessning_nn_1_1_N = mkN "vässning" ;
  vaestanflaekt_nn_1_1_N = mkN "västanfläkt" ;
  vaesterbottning_nn_1_1_N = mkN "västerbottning" ;
  vaesterlaenning_nn_1_1_N = mkN "västerlänning" ;
  vaestklaenning_nn_1_1_N = mkN "västklänning" ;
  vaestmanlaenning_nn_1_1_N = mkN "västmanlänning" ;
  vaestvind_nn_1_1_N = mkN "västvind" ;
  vaetgasbil_nn_1_1_N = mkN "vätgasbil" ;
  vaetning_nn_1_1_N = mkN "vätning" ;
  vaetskeansamling_nn_1_1_N = mkN "vätskeansamling" ;
  vaetskeersaettning_nn_1_1_N = mkN "vätskeersättning" ;
  vaetskefjaedring_nn_1_1_N = mkN "vätskefjädring" ;
  vaevbindning_nn_1_1_N = mkN "vävbindning" ;
  vaevknut_nn_1_1_N = mkN "vävknut" ;
  vaevnadsodling_nn_1_1_N = mkN "vävnadsodling" ;
  vaevning_nn_1_1_N = mkN "vävning" ;
  vaexelfoerregling_nn_1_1_N = mkN "växelförregling" ;
  vaexellaesning_nn_1_1_N = mkN "växelläsning" ;
  vaexellaadslyft_nn_1_1_N = mkN "växellådslyft" ;
  vaexelomsaettning_nn_1_1_N = mkN "växelomsättning" ;
  vaexelspaksknopp_nn_1_1_N = mkN "växelspaksknopp" ;
  vaexelspaenning_nn_1_1_N = mkN "växelspänning" ;
  vaexelundervisning_nn_1_1_N = mkN "växelundervisning" ;
  vaexling_nn_1_1_N = mkN "växling" ;
  vaextfaergning_nn_1_1_N = mkN "växtfärgning" ;
  vaextfoeraedling_nn_1_1_N = mkN "växtförädling" ;
  vaexthusodling_nn_1_1_N = mkN "växthusodling" ;
  vaextnaering_nn_1_1_N = mkN "växtnäring" ;
  vaextsjukdom_nn_1_1_N = mkN "växtsjukdom" ;
  vaexttraad_nn_1_1_N = mkN "växttråd" ;
  vaextvaerld_nn_1_1_N = mkN "växtvärld" ;
  vaadaskjutning_nn_1_1_N = mkN "vådaskjutning" ;
  vaadeld_nn_1_1_N = mkN "vådeld" ;
  vaaffelbindning_nn_1_1_N = mkN "våffelbindning" ;
  vaagskaal_nn_1_1_N = mkN "vågskål" ;
  vaaldgaestning_nn_1_1_N = mkN "våldgästning" ;
  vaaldsgaerning_nn_1_1_N = mkN "våldsgärning" ;
  vaaldshandling_nn_1_1_N = mkN "våldshandling" ;
  vaaldsskildring_nn_1_1_N = mkN "våldsskildring" ;
  vaaldtagning_nn_1_1_N = mkN "våldtagning" ;
  vaalmning_nn_1_1_N = mkN "vålmning" ;
  vaaning_nn_1_1_N = mkN "våning" ;
  vaarbrytning_nn_1_1_N = mkN "vårbrytning" ;
  vaarbaeck_nn_1_1_N = mkN "vårbäck" ;
  vaardag_nn_1_1_N = mkN "vårdag" ;
  vaardagjaemning_nn_1_1_N = mkN "vårdagjämning" ;
  vaardavdelning_nn_1_1_N = mkN "vårdavdelning" ;
  vaarloek_nn_1_1_N = mkN "vårlök" ;
  vaarriksdag_nn_1_1_N = mkN "vårriksdag" ;
  vaarstaedning_nn_1_1_N = mkN "vårstädning" ;
  vaaroeversvaemning_nn_1_1_N = mkN "våröversvämning" ;
  vaatsugning_nn_1_1_N = mkN "våtsugning" ;
  wienerkorv_nn_1_N = mkN "wienerkorv" ;
  ympning_nn_1_N = mkN "ympning" ;
  yngeldamm_nn_1_N = mkN "yngeldamm" ;
  ynkedom_nn_1_N = mkN "ynkedom" ;
  yrkesorientering_nn_1_N = mkN "yrkesorientering" ;
  yrkessjukdom_nn_1_N = mkN "yrkessjukdom" ;
  yrkesutbildning_nn_1_N = mkN "yrkesutbildning" ;
  yrkesvaegledning_nn_1_1_N = mkN "yrkesvägledning" ;
  ytavvaegning_nn_1_1_N = mkN "ytavvägning" ;
  ytspaenning_nn_1_1_N = mkN "ytspänning" ;
  ytterdoerr_nn_1_1_N = mkN "ytterdörr" ;
  ytterlighetsriktning_nn_1_N = mkN "ytterlighetsriktning" ;
  yttervaegg_nn_1_1_N = mkN "yttervägg" ;
  yttervaerld_nn_1_1_N = mkN "yttervärld" ;
  yttrandefrihetslag_nn_1_N = mkN "yttrandefrihetslag" ;
  yttring_nn_1_N = mkN "yttring" ;
  zappning_nn_1_N = mkN "zappning" ;
  zigenarhoevding_nn_1_1_N = mkN "zigenarhövding" ;
  aadal_nn_1_1_N = mkN "ådal" ;
  aaderfoerkalkning_nn_1_1_N = mkN "åderförkalkning" ;
  aaderlaatning_nn_1_1_N = mkN "åderlåtning" ;
  aadring_nn_1_1_N = mkN "ådring" ;
  aakerbit_nn_1_1_N = mkN "åkerbit" ;
  aakerstig_nn_1_1_N = mkN "åkerstig" ;
  aakervall_nn_1_1_N = mkN "åkervall" ;
  aaklapp_nn_1_1_N = mkN "åklapp" ;
  aakning_nn_1_1_N = mkN "åkning" ;
  aalderdom_nn_1_1_N = mkN "ålderdom" ;
  aalderdomsfoersaekring_nn_1_1_N = mkN "ålderdomsförsäkring" ;
  aaldersbestaemning_nn_1_1_N = mkN "åldersbestämning" ;
  aaldersdiskriminering_nn_1_1_N = mkN "åldersdiskriminering" ;
  aaldersforskning_nn_1_1_N = mkN "åldersforskning" ;
  aaldersfoerdelning_nn_1_1_N = mkN "åldersfördelning" ;
  aaldersfoeraendring_nn_1_1_N = mkN "åldersförändring" ;
  aalderssjukdom_nn_1_1_N = mkN "ålderssjukdom" ;
  aaldring_nn_1_1_N = mkN "åldring" ;
  aalning_nn_1_1_N = mkN "ålning" ;
  aalaenning_nn_1_1_N = mkN "ålänning" ;
  aamning_nn_1_1_N = mkN "åmning" ;
  aamynning_nn_1_1_N = mkN "åmynning" ;
  aanganlaeggning_nn_1_1_N = mkN "ånganläggning" ;
  aangbildning_nn_1_1_N = mkN "ångbildning" ;
  aangermanlaenning_nn_1_1_N = mkN "ångermanlänning" ;
  aangning_nn_1_1_N = mkN "ångning" ;
  aargaang_nn_1_1_N = mkN "årgång" ;
  aaring_nn_1_1_N = mkN "åring" ;
  aarskursintegrering_nn_1_1_N = mkN "årskursintegrering" ;
  aarsredovisning_nn_1_1_N = mkN "årsredovisning" ;
  aarsring_nn_1_1_N = mkN "årsring" ;
  aarstidsvind_nn_1_1_N = mkN "årstidsvind" ;
  aarstidsvaexling_nn_1_1_N = mkN "årstidsväxling" ;
  aasiktsbildning_nn_1_1_N = mkN "åsiktsbildning" ;
  aasiktsregistrering_nn_1_1_N = mkN "åsiktsregistrering" ;
  aasiktsriktning_nn_1_1_N = mkN "åsiktsriktning" ;
  aasiktsyttring_nn_1_1_N = mkN "åsiktsyttring" ;
  aaskknall_nn_1_1_N = mkN "åskknall" ;
  aaskaadarhop_nn_1_1_N = mkN "åskådarhop" ;
  aaskaadning_nn_1_1_N = mkN "åskådning" ;
  aaskaadningsundervisning_nn_1_1_N = mkN "åskådningsundervisning" ;
  aasnespark_nn_1_1_N = mkN "åsnespark" ;
  aatalsanmaelning_nn_1_1_N = mkN "åtalsanmälning" ;
  aatdragning_nn_1_1_N = mkN "åtdragning" ;
  aateranpassning_nn_1_1_N = mkN "återanpassning" ;
  aateranvaendning_nn_1_1_N = mkN "återanvändning" ;
  aaterbetalning_nn_1_1_N = mkN "återbetalning" ;
  aaterblick_nn_1_1_N = mkN "återblick" ;
  aaterbaering_nn_1_1_N = mkN "återbäring" ;
  aatereroevring_nn_1_1_N = mkN "återerövring" ;
  aaterflyttning_nn_1_1_N = mkN "återflyttning" ;
  aaterfoerening_nn_1_1_N = mkN "återförening" ;
  aaterfoering_nn_1_1_N = mkN "återföring" ;
  aaterfoersaekring_nn_1_1_N = mkN "återförsäkring" ;
  aaterfoersaeljning_nn_1_1_N = mkN "återförsäljning" ;
  aatergivning_nn_1_1_N = mkN "återgivning" ;
  aaterhaemtning_nn_1_1_N = mkN "återhämtning" ;
  aaterinsaettning_nn_1_1_N = mkN "återinsättning" ;
  aaterinvestering_nn_1_1_N = mkN "återinvestering" ;
  aaterkastning_nn_1_1_N = mkN "återkastning" ;
  aaterknytning_nn_1_1_N = mkN "återknytning" ;
  aaterkoppling_nn_1_1_N = mkN "återkoppling" ;
  aaterlaemning_nn_1_1_N = mkN "återlämning" ;
  aaterloesning_nn_1_1_N = mkN "återlösning" ;
  aaterplantering_nn_1_1_N = mkN "återplantering" ;
  aatersamling_nn_1_1_N = mkN "återsamling" ;
  aaterspegling_nn_1_1_N = mkN "återspegling" ;
  aaterstudsning_nn_1_1_N = mkN "återstudsning" ;
  aatersaendning_nn_1_1_N = mkN "återsändning" ;
  aatertagning_nn_1_1_N = mkN "återtagning" ;
  aaterupplivning_nn_1_1_N = mkN "återupplivning" ;
  aaskby_nn_1_1_N = mkN "åskby" "åskbyn" "åskbyar" "åskbyarna" ;
  aader_nn_1_1_N = mkN "åder" "ådern" "ådror" "ådrorna" ;
  vaexelfordran_nn_1_1_N = mkN "växelfordran" "växelfordran" "växelfordringar" "växelfordringarna" ;
  visafton_nn_1_N = mkN "visafton" "visaftonen" "visaftnar" "visaftnarna" ;
  vindby_nn_1_N = mkN "vindby" "vindbyn" "vindbyar" "vindbyarna" ;
  valborgsmaessoafton_nn_1_1_N = mkN "valborgsmässoafton" "valborgsmässoaftonen" "valborgsmässoaftnar" "valborgsmässoaftnarna" ;
  urmoder_nn_1_N = mkN "urmoder" "urmodern" "urmödrar" "urmödrarna" ;
  uppmuntran_nn_1_N = mkN "uppmuntran" "uppmuntran" "uppmuntringar" "uppmuntringarna" ;
  undran_nn_1_N = mkN "undran" "undran" "undringar" "undringarna" ;
  tsardotter_nn_1_N = mkN "tsardotter" "tsardottern" "tsardöttrar" "tsardöttrarna" ;
  traetoffel_nn_1_1_N = mkN "trätoffel" "trätoffeln" "trätofflor" "trätofflorna" ;
  trettondedagsafton_nn_1_N = mkN "trettondedagsafton" "trettondedagsaftonen" "trettondedagsaftnar" "trettondedagsaftnarna" ;
  trettondagsafton_nn_1_N = mkN "trettondagsafton" "trettondagsaftonen" "trettondagsaftnar" "trettondagsaftnarna" ;
  toffel_nn_1_N = mkN "toffel" "toffeln" "tofflor" "tofflorna" ;
  teateranmaelan_nn_1_1_N = mkN "teateranmälan" "teateranmälan" "teateranmälningar" "teateranmälningarna" ;
  systerdotter_nn_1_N = mkN "systerdotter" "systerdottern" "systerdöttrar" "systerdöttrarna" ;
  svaerdotter_nn_1_1_N = mkN "svärdotter" "svärdottern" "svärdöttrar" "svärdöttrarna" ;
  surrogatmoder_nn_1_N = mkN "surrogatmoder" "surrogatmodern" "surrogatmödrar" "surrogatmödrarna" ;
  styvdotter_nn_1_N = mkN "styvdotter" "styvdottern" "styvdöttrar" "styvdöttrarna" ;
  stugby_nn_1_N = mkN "stugby" "stugbyn" "stugbyar" "stugbyarna" ;
  stormby_nn_1_N = mkN "stormby" "stormbyn" "stormbyar" "stormbyarna" ;
  storby_nn_1_N = mkN "storby" "storbyn" "storbyar" "storbyarna" ;
  stammoder_nn_1_N = mkN "stammoder" "stammodern" "stammödrar" "stammödrarna" ;
  sondotter_nn_1_N = mkN "sondotter" "sondottern" "sondöttrar" "sondöttrarna" ;
  sommar_nn_1_N = mkN "sommar" "sommarn" "somrar" "somrarna" ;
  sky_nn_1_N = mkN "sky" "skyn" "skyar" "skyarna" ;
  sexbarnsmoder_nn_1_N = mkN "sexbarnsmoder" "sexbarnsmodern" "sexbarnsmödrar" "sexbarnsmödrarna" ;
  sensommar_nn_1_N = mkN "sensommar" "sensommarn" "sensomrar" "sensomrarna" ;
  semesterby_nn_1_N = mkN "semesterby" "semesterbyn" "semesterbyar" "semesterbyarna" ;
  sanningsfoersaekran_nn_1_1_N = mkN "sanningsförsäkran" "sanningsförsäkran" "sanningsförsäkringar" "sanningsförsäkringarna" ;
  sameby_nn_1_N = mkN "sameby" "samebyn" "samebyar" "samebyarna" ;
  radondotter_nn_1_N = mkN "radondotter" "radondottern" "radondöttrar" "radondöttrarna" ;
  paaskafton_nn_1_1_N = mkN "påskafton" "påskaftonen" "påskaftnar" "påskaftnarna" ;
  pulsaader_nn_1_1_N = mkN "pulsåder" "pulsådern" "pulsådror" "pulsådrorna" ;
  poesiafton_nn_1_N = mkN "poesiafton" "poesiaftonen" "poesiaftnar" "poesiaftnarna" ;
  pippi_nn_1_N = mkN "pippi" "pippin" "pippiar" "pippiarna" ;
  pingstafton_nn_1_N = mkN "pingstafton" "pingstaftonen" "pingstaftnar" "pingstaftnarna" ;
  nyaarsafton_nn_1_1_N = mkN "nyårsafton" "nyårsaftonen" "nyårsaftnar" "nyårsaftnarna" ;
  motfordran_nn_1_N = mkN "motfordran" "motfordran" "motfordringar" "motfordringarna" ;
  moder_nn_1_N = mkN "moder" "modern" "mödrar" "mödrarna" ;
  mjoelkaader_nn_1_1_N = mkN "mjölkåder" "mjölkådern" "mjölkådror" "mjölkådrorna" ;
  missnoejesanmaelan_nn_1_1_N = mkN "missnöjesanmälan" "missnöjesanmälan" "missnöjesanmälningar" "missnöjesanmälningarna" ;
  midsommarafton_nn_1_N = mkN "midsommarafton" "midsommaraftonen" "midsommaraftnar" "midsommaraftnarna" ;
  midsommar_nn_1_N = mkN "midsommar" "midsommarn" "midsomrar" "midsomrarna" ;
  laekardotter_nn_1_1_N = mkN "läkardotter" "läkardottern" "läkardöttrar" "läkardöttrarna" ;
  lungpulsaader_nn_1_1_N = mkN "lungpulsåder" "lungpulsådern" "lungpulsådror" "lungpulsådrorna" ;
  litteraturanmaelan_nn_1_1_N = mkN "litteraturanmälan" "litteraturanmälan" "litteraturanmälningar" "litteraturanmälningarna" ;
  kaellaader_nn_1_1_N = mkN "källåder" "källådern" "källådror" "källådrorna" ;
  kyrkby_nn_1_N = mkN "kyrkby" "kyrkbyn" "kyrkbyar" "kyrkbyarna" ;
  kycklingmoder_nn_1_N = mkN "kycklingmoder" "kycklingmodern" "kycklingmödrar" "kycklingmödrarna" ;
  klubbafton_nn_1_N = mkN "klubbafton" "klubbaftonen" "klubbaftnar" "klubbaftnarna" ;
  kastby_nn_1_N = mkN "kastby" "kastbyn" "kastbyar" "kastbyarna" ;
  julafton_nn_1_N = mkN "julafton" "julaftonen" "julaftnar" "julaftnarna" ;
  indiansommar_nn_1_N = mkN "indiansommar" "indiansommarn" "indiansomrar" "indiansomrarna" ;
  hoegsommar_nn_1_1_N = mkN "högsommar" "högsommarn" "högsomrar" "högsomrarna" ;
  hemmadotter_nn_1_N = mkN "hemmadotter" "hemmadottern" "hemmadöttrar" "hemmadöttrarna" ;
  helgdagsafton_nn_1_N = mkN "helgdagsafton" "helgdagsaftonen" "helgdagsaftnar" "helgdagsaftnarna" ;
  helafton_nn_1_N = mkN "helafton" "helaftonen" "helaftnar" "helaftnarna" ;
  guddotter_nn_1_N = mkN "guddotter" "guddottern" "guddöttrar" "guddöttrarna" ;
  gruvarbetardotter_nn_1_N = mkN "gruvarbetardotter" "gruvarbetardottern" "gruvarbetardöttrar" "gruvarbetardöttrarna" ;
  giftverkan_nn_1_N = mkN "giftverkan" "giftverkan" "giftverkningar" "giftverkningarna" ;
  genfordran_nn_1_N = mkN "genfordran" "genfordran" "genfordringar" "genfordringarna" ;
  foersaekran_nn_1_1_N = mkN "försäkran" "försäkran" "försäkringar" "försäkringarna" ;
  foersommar_nn_1_1_N = mkN "försommar" "försommarn" "försomrar" "försomrarna" ;
  faelttaevlan_nn_1_1_N = mkN "fälttävlan" "fälttävlan" "fälttävlningar" "fälttävlningarna" ;
  fritidsby_nn_1_N = mkN "fritidsby" "fritidsbyn" "fritidsbyar" "fritidsbyarna" ;
  framstaellan_nn_1_1_N = mkN "framställan" "framställan" "framställningar" "framställningarna" ;
  fosterdotter_nn_1_N = mkN "fosterdotter" "fosterdottern" "fosterdöttrar" "fosterdöttrarna" ;
  fordran_nn_1_N = mkN "fordran" "fordran" "fordringar" "fordringarna" ;
  foppatoffel_nn_1_N = mkN "foppatoffel" "foppatoffeln" "foppatofflor" "foppatofflorna" ;
  filttoffel_nn_1_N = mkN "filttoffel" "filttoffeln" "filttofflor" "filttofflorna" ;
  erinran_nn_1_N = mkN "erinran" "erinran" "erinringar" "erinringarna" ;
  eftersommar_nn_1_N = mkN "eftersommar" "eftersommarn" "eftersomrar" "eftersomrarna" ;
  dotterdotter_nn_1_N = mkN "dotterdotter" "dotterdottern" "dotterdöttrar" "dotterdöttrarna" ;
  dotter_nn_1_N = mkN "dotter" "dottern" "döttrar" "döttrarna" ;
  djaevul_nn_1_1_N = mkN "djävul" "djävulen" "djävlar" "djävlarna" ;
  diplomatdotter_nn_1_N = mkN "diplomatdotter" "diplomatdottern" "diplomatdöttrar" "diplomatdöttrarna" ;
  byggmaestardotter_nn_1_1_N = mkN "byggmästardotter" "byggmästardottern" "byggmästardöttrar" "byggmästardöttrarna" ;
  by_nn_1_N = mkN "by" "byn" "byar" "byarna" ;
  brorsdotter_nn_1_N = mkN "brorsdotter" "brorsdottern" "brorsdöttrar" "brorsdöttrarna" ;
  brittsommar_nn_1_N = mkN "brittsommar" "brittsommarn" "brittsomrar" "brittsomrarna" ;
  bokanmaelan_nn_1_1_N = mkN "bokanmälan" "bokanmälan" "bokanmälningar" "bokanmälningarna" ;
  blodaader_nn_1_1_N = mkN "blodåder" "blodådern" "blodådror" "blodådrorna" ;
  befordran_nn_1_N = mkN "befordran" "befordran" "befordringar" "befordringarna" ;
  barnby_nn_1_N = mkN "barnby" "barnbyn" "barnbyar" "barnbyarna" ;
  badtoffel_nn_1_N = mkN "badtoffel" "badtoffeln" "badtofflor" "badtofflorna" ;
  anmaelan_nn_2_1_N = mkN "anmälan" "anmälan" "anmälningar" "anmälningarna" ;
  anmoder_nn_1_N = mkN "anmoder" "anmodern" "anmödrar" "anmödrarna" ;
  andur_nn_1_N = mkN "andur" "anduren" "andrar" "andrarna" ;
  andel_nn_1_N = mkN "andel" "andelen" "andelar" "andelarna" ;
  afton_nn_1_N = mkN "afton" "aftonen" "aftnar" "aftnarna" ;
  Foppatoffel_nn_1_N = mkN "Foppatoffel" "Foppatoffeln" "Foppatofflor" "Foppatofflorna" ;
  alpros_nn_1_N = mkN "alpros" "alprosor" ;
  anfallsvaag_nn_1_1_N = mkN "anfallsvåg" "anfallsvågor" ;
  beostare_nn_1_N = mkN "beostare" "beostarar" ;
  blodvaag_nn_1_1_N = mkN "blodvåg" "blodvågor" ;
  baervaag_nn_1_1_N = mkN "bärvåg" "bärvågor" ;
  chockvaag_nn_1_1_N = mkN "chockvåg" "chockvågor" ;
  flodvaag_nn_1_1_N = mkN "flodvåg" "flodvågor" ;
  gravitationsvaag_nn_1_1_N = mkN "gravitationsvåg" "gravitationsvågor" ;
  havsvaag_nn_1_1_N = mkN "havsvåg" "havsvågor" ;
  hoegervaag_nn_1_1_N = mkN "högervåg" "högervågor" ;
  ibisros_nn_1_N = mkN "ibisros" "ibisrosor" ;
  julros_nn_1_N = mkN "julros" "julrosor" ;
  klaetterros_nn_1_1_N = mkN "klätterros" "klätterrosor" ;
  kompassros_nn_1_N = mkN "kompassros" "kompassrosor" ;
  kortvaag_nn_1_1_N = mkN "kortvåg" "kortvågor" ;
  ljudvaag_nn_1_1_N = mkN "ljudvåg" "ljudvågor" ;
  ljusvaag_nn_1_1_N = mkN "ljusvåg" "ljusvågor" ;
  luftvaag_nn_1_1_N = mkN "luftvåg" "luftvågor" ;
  lump_nn_1_N = mkN "lump" "lumpor" ;
  laangvaag_nn_1_1_N = mkN "långvåg" "långvågor" ;
  maskros_nn_1_N = mkN "maskros" "maskrosor" ;
  massakervaag_nn_1_1_N = mkN "massakervåg" "massakervågor" ;
  mellanvaag_nn_1_1_N = mkN "mellanvåg" "mellanvågor" ;
  mikrovaag_nn_1_1_N = mkN "mikrovåg" "mikrovågor" ;
  mossros_nn_1_N = mkN "mossros" "mossrosor" ;
  maanadsros_nn_1_1_N = mkN "månadsros" "månadsrosor" ;
  normaliseringsvaag_nn_1_1_N = mkN "normaliseringsvåg" "normaliseringsvågor" ;
  nyponros_nn_1_N = mkN "nyponros" "nyponrosor" ;
  naeckros_nn_1_1_N = mkN "näckros" "näckrosor" ;
  ordros_nn_1_N = mkN "ordros" "ordrosor" ;
  radarvaag_nn_1_1_N = mkN "radarvåg" "radarvågor" ;
  radiovaag_nn_1_1_N = mkN "radiovåg" "radiovågor" ;
  rallarros_nn_1_N = mkN "rallarros" "rallarrosor" ;
  ros_nn_1_N = mkN "ros" "rosor" ;
  raanvaag_nn_1_1_N = mkN "rånvåg" "rånvågor" ;
  sannolikhetsvaag_nn_1_1_N = mkN "sannolikhetsvåg" "sannolikhetsvågor" ;
  sidenros_nn_1_N = mkN "sidenros" "sidenrosor" ;
  silvervaag_nn_1_1_N = mkN "silvervåg" "silvervågor" ;
  sinusvaag_nn_1_1_N = mkN "sinusvåg" "sinusvågor" ;
  solros_nn_1_N = mkN "solros" "solrosor" ;
  spekulationsvaag_nn_1_1_N = mkN "spekulationsvåg" "spekulationsvågor" ;
  stockros_nn_1_N = mkN "stockros" "stockrosor" ;
  stoetvaag_nn_1_1_N = mkN "stötvåg" "stötvågor" ;
  svallvaag_nn_1_1_N = mkN "svallvåg" "svallvågor" ;
  svettros_nn_1_N = mkN "svettros" "svettrosor" ;
  teros_nn_1_N = mkN "teros" "terosor" ;
  tryckvaag_nn_1_1_N = mkN "tryckvåg" "tryckvågor" ;
  toernros_nn_1_1_N = mkN "törnros" "törnrosor" ;
  ultrakortvaag_nn_1_1_N = mkN "ultrakortvåg" "ultrakortvågor" ;
  vindros_nn_1_N = mkN "vindros" "vindrosor" ;
  vaetteros_nn_1_1_N = mkN "vätteros" "vätterosor" ;
  vaag_nn_1_1_N = mkN "våg" "vågor" ;
  vaaldsvaag_nn_1_1_N = mkN "våldsvåg" "våldsvågor" ;
  yllelump_nn_1_N = mkN "yllelump" "yllelumpor" ;
  trikloretylen_nn_1_N = mkN "trikloretylen" neutrum  ;
  terylen_nn_1_N = mkN "terylen" neutrum  ;
  styren_nn_1_N = mkN "styren" neutrum  ;
  selen_nn_1_N = mkN "selen" neutrum  ;
  propen_nn_1_N = mkN "propen" neutrum  ;
  polystyren_nn_1_N = mkN "polystyren" neutrum  ;
  polypropen_nn_1_N = mkN "polypropen" neutrum  ;
  polyeten_nn_1_N = mkN "polyeten" neutrum  ;
  naftalen_nn_1_N = mkN "naftalen" neutrum  ;
  molybden_nn_1_N = mkN "molybden" neutrum  ;
  metylen_nn_1_N = mkN "metylen" neutrum  ;
  fotogen_nn_1_N = mkN "fotogen" neutrum  ;
  flygfotogen_nn_1_N = mkN "flygfotogen" neutrum  ;
  etylen_nn_1_N = mkN "etylen" neutrum  ;
  eten_nn_1_N = mkN "eten" neutrum  ;
  bensen_nn_1_N = mkN "bensen" neutrum  ;
  acetylen_nn_1_N = mkN "acetylen" neutrum  ;
  IT_jaette_nn_1_1_N = mkN "IT-jätte" utrum  ;
  Linn_elaerjunge_nn_1_1_N = mkN "Linnélärjunge" utrum  ;
  Rikspolisstyrelse_nn_1_N = mkN "Rikspolisstyrelse" utrum  ;
  ande_nn_1_N = mkN "ande" utrum  ;
  ankunge_nn_1_N = mkN "ankunge" utrum  ;
  antihjaelte_nn_1_1_N = mkN "antihjälte" utrum  ;
  arvfurste_nn_1_N = mkN "arvfurste" utrum  ;
  arvinge_nn_1_N = mkN "arvinge" utrum  ;
  askunge_nn_1_N = mkN "askunge" utrum  ;
  aspdunge_nn_1_N = mkN "aspdunge" utrum  ;
  avgrundsande_nn_1_N = mkN "avgrundsande" utrum  ;
  bakarvinge_nn_1_N = mkN "bakarvinge" utrum  ;
  bakaende_nn_1_1_N = mkN "bakände" utrum  ;
  ballongmage_nn_1_N = mkN "ballongmage" utrum  ;
  barfotalasse_nn_1_N = mkN "barfotalasse" utrum  ;
  barnraettskaempe_nn_1_1_N = mkN "barnrättskämpe" utrum  ;
  barnunge_nn_1_N = mkN "barnunge" utrum  ;
  barrikadkaempe_nn_1_1_N = mkN "barrikadkämpe" utrum  ;
  beagle_nn_1_N = mkN "beagle" utrum  ;
  bildrulle_nn_1_N = mkN "bildrulle" utrum  ;
  binjure_nn_1_N = mkN "binjure" utrum  ;
  bjaesse_nn_1_1_N = mkN "bjässe" utrum  ;
  bladmage_nn_1_N = mkN "bladmage" utrum  ;
  blatte_nn_1_N = mkN "blatte" utrum  ;
  blindrote_nn_1_N = mkN "blindrote" utrum  ;
  blaadaare_nn_1_1_N = mkN "blådåre" utrum  ;
  blaahake_nn_1_1_N = mkN "blåhake" utrum  ;
  brosme_nn_1_N = mkN "brosme" utrum  ;
  brottsmisstanke_nn_1_N = mkN "brottsmisstanke" utrum  ;
  brudborste_nn_1_N = mkN "brudborste" utrum  ;
  brunte_nn_1_N = mkN "brunte" utrum  ;
  bryggerijaette_nn_1_1_N = mkN "bryggerijätte" utrum  ;
  broestarvinge_nn_1_1_N = mkN "bröstarvinge" utrum  ;
  broethake_nn_1_1_N = mkN "bröthake" utrum  ;
  bultskalle_nn_1_N = mkN "bultskalle" utrum  ;
  busunge_nn_1_N = mkN "busunge" utrum  ;
  byfogde_nn_1_N = mkN "byfogde" utrum  ;
  byfaane_nn_1_1_N = mkN "byfåne" utrum  ;
  byggherre_nn_1_N = mkN "byggherre" utrum  ;
  byggjaette_nn_1_1_N = mkN "byggjätte" utrum  ;
  byggnadsstomme_nn_1_N = mkN "byggnadsstomme" utrum  ;
  byaeldste_nn_1_1_N = mkN "byäldste" utrum  ;
  baatshake_nn_1_1_N = mkN "båtshake" utrum  ;
  chibbe_nn_1_N = mkN "chibbe" utrum  ;
  chirre_nn_1_N = mkN "chirre" utrum  ;
  choke_nn_1_N = mkN "choke" utrum  ;
  demokratifoerkaempe_nn_1_1_N = mkN "demokratiförkämpe" utrum  ;
  diktarfurste_nn_1_N = mkN "diktarfurste" utrum  ;
  djaekne_nn_1_1_N = mkN "djäkne" utrum  ;
  dockkudde_nn_1_N = mkN "dockkudde" utrum  ;
  dumskalle_nn_1_N = mkN "dumskalle" utrum  ;
  dununge_nn_1_N = mkN "dununge" utrum  ;
  duvunge_nn_1_N = mkN "duvunge" utrum  ;
  dyborre_nn_1_N = mkN "dyborre" utrum  ;
  daeggdjursunge_nn_1_1_N = mkN "däggdjursunge" utrum  ;
  doedskalle_nn_1_1_N = mkN "dödskalle" utrum  ;
  ejderdunskudde_nn_1_N = mkN "ejderdunskudde" utrum  ;
  ejderunge_nn_1_N = mkN "ejderunge" utrum  ;
  eldsvaadeunge_nn_1_1_N = mkN "eldsvådeunge" utrum  ;
  elementarande_nn_1_N = mkN "elementarande" utrum  ;
  feodalherre_nn_1_N = mkN "feodalherre" utrum  ;
  filttomte_nn_1_N = mkN "filttomte" utrum  ;
  finkunge_nn_1_N = mkN "finkunge" utrum  ;
  flickunge_nn_1_N = mkN "flickunge" utrum  ;
  flintskalle_nn_1_N = mkN "flintskalle" utrum  ;
  flodhaestunge_nn_1_1_N = mkN "flodhästunge" utrum  ;
  flaabuse_nn_1_1_N = mkN "flåbuse" utrum  ;
  fogde_nn_1_N = mkN "fogde" utrum  ;
  folkhjaelte_nn_1_1_N = mkN "folkhjälte" utrum  ;
  folle_nn_1_N = mkN "folle" utrum  ;
  fotaende_nn_1_1_N = mkN "fotände" utrum  ;
  fraktjaette_nn_1_1_N = mkN "fraktjätte" utrum  ;
  framaende_nn_1_1_N = mkN "framände" utrum  ;
  friherre_nn_1_N = mkN "friherre" utrum  ;
  frihetshjaelte_nn_1_1_N = mkN "frihetshjälte" utrum  ;
  frihetskaempe_nn_1_1_N = mkN "frihetskämpe" utrum  ;
  fraekne_nn_1_1_N = mkN "fräkne" utrum  ;
  furste_nn_1_N = mkN "furste" utrum  ;
  faeltherre_nn_1_1_N = mkN "fältherre" utrum  ;
  faagelunge_nn_1_1_N = mkN "fågelunge" utrum  ;
  faane_nn_1_1_N = mkN "fåne" utrum  ;
  faaraherde_nn_1_1_N = mkN "fåraherde" utrum  ;
  faarskalle_nn_1_1_N = mkN "fårskalle" utrum  ;
  foelunge_nn_1_1_N = mkN "fölunge" utrum  ;
  foerkaempe_nn_1_1_N = mkN "förkämpe" utrum  ;
  foerstaserve_nn_1_1_N = mkN "förstaserve" utrum  ;
  gatunge_nn_1_N = mkN "gatunge" utrum  ;
  gepardunge_nn_1_N = mkN "gepardunge" utrum  ;
  glarre_nn_1_N = mkN "glarre" utrum  ;
  godsherre_nn_1_N = mkN "godsherre" utrum  ;
  gorillaunge_nn_1_N = mkN "gorillaunge" utrum  ;
  gravidmage_nn_1_N = mkN "gravidmage" utrum  ;
  grisunge_nn_1_N = mkN "grisunge" utrum  ;
  grundstomme_nn_1_N = mkN "grundstomme" utrum  ;
  gruvfogde_nn_1_N = mkN "gruvfogde" utrum  ;
  graedde_nn_1_1_N = mkN "grädde" utrum  ;
  graagosse_nn_1_1_N = mkN "grågosse" utrum  ;
  gudunge_nn_1_N = mkN "gudunge" utrum  ;
  guldbagge_nn_1_N = mkN "guldbagge" utrum  ;
  gullgosse_nn_1_N = mkN "gullgosse" utrum  ;
  gaagosse_nn_1_1_N = mkN "gågosse" utrum  ;
  gaasunge_nn_1_1_N = mkN "gåsunge" utrum  ;
  goekunge_nn_1_1_N = mkN "gökunge" utrum  ;
  hamnbuse_nn_1_N = mkN "hamnbuse" utrum  ;
  hamnfogde_nn_1_N = mkN "hamnfogde" utrum  ;
  herde_nn_1_N = mkN "herde" utrum  ;
  herre_nn_2_N = mkN "herre" utrum  ;
  hjaelte_nn_1_1_N = mkN "hjälte" utrum  ;
  horunge_nn_1_N = mkN "horunge" utrum  ;
  hustomte_nn_1_N = mkN "hustomte" utrum  ;
  huvudkudde_nn_1_N = mkN "huvudkudde" utrum  ;
  haemndeande_nn_1_1_N = mkN "hämndeande" utrum  ;
  haengmage_nn_1_1_N = mkN "hängmage" utrum  ;
  haallhake_nn_1_1_N = mkN "hållhake" utrum  ;
  hoegstadieunge_nn_1_1_N = mkN "högstadieunge" utrum  ;
  isbjoernsunge_nn_1_1_N = mkN "isbjörnsunge" utrum  ;
  it_jaette_nn_1_1_N = mkN "it-jätte" utrum  ;
  jordande_nn_1_N = mkN "jordande" utrum  ;
  jude_nn_1_N = mkN "jude" utrum  ;
  jultomte_nn_1_N = mkN "jultomte" utrum  ;
  jaernhake_nn_1_1_N = mkN "järnhake" utrum  ;
  jaervunge_nn_1_1_N = mkN "järvunge" utrum  ;
  jaette_nn_1_1_N = mkN "jätte" utrum  ;
  kamelherde_nn_1_N = mkN "kamelherde" utrum  ;
  kammarherre_nn_1_N = mkN "kammarherre" utrum  ;
  karbinhake_nn_1_N = mkN "karbinhake" utrum  ;
  kattunge_nn_1_N = mkN "kattunge" utrum  ;
  keramiktomte_nn_1_N = mkN "keramiktomte" utrum  ;
  klantskalle_nn_1_N = mkN "klantskalle" utrum  ;
  knaeppskalle_nn_1_1_N = mkN "knäppskalle" utrum  ;
  konstfiberkudde_nn_1_N = mkN "konstfiberkudde" utrum  ;
  kopplerimisstanke_nn_1_N = mkN "kopplerimisstanke" utrum  ;
  korgosse_nn_1_N = mkN "korgosse" utrum  ;
  korre_nn_1_N = mkN "korre" utrum  ;
  korruptionsmisstanke_nn_1_N = mkN "korruptionsmisstanke" utrum  ;
  kortaende_nn_1_1_N = mkN "kortände" utrum  ;
  krigsfaange_nn_1_1_N = mkN "krigsfånge" utrum  ;
  krigsherre_nn_1_N = mkN "krigsherre" utrum  ;
  krigshjaelte_nn_1_1_N = mkN "krigshjälte" utrum  ;
  krockkudde_nn_1_N = mkN "krockkudde" utrum  ;
  kronofogde_nn_1_N = mkN "kronofogde" utrum  ;
  kulmage_nn_1_N = mkN "kulmage" utrum  ;
  kurfurste_nn_1_N = mkN "kurfurste" utrum  ;
  kyrkoherde_nn_1_N = mkN "kyrkoherde" utrum  ;
  kaempe_nn_1_1_N = mkN "kämpe" utrum  ;
  lammunge_nn_1_N = mkN "lammunge" utrum  ;
  landsfogde_nn_1_N = mkN "landsfogde" utrum  ;
  landsaende_nn_1_1_N = mkN "landsände" utrum  ;
  livsarvinge_nn_1_N = mkN "livsarvinge" utrum  ;
  livsmedelsjaette_nn_1_1_N = mkN "livsmedelsjätte" utrum  ;
  livstidsfaange_nn_1_1_N = mkN "livstidsfånge" utrum  ;
  luftande_nn_1_N = mkN "luftande" utrum  ;
  luftkudde_nn_1_N = mkN "luftkudde" utrum  ;
  luftskalle_nn_1_N = mkN "luftskalle" utrum  ;
  laekemedelsjaette_nn_1_1_N = mkN "läkemedelsjätte" utrum  ;
  laensherre_nn_1_1_N = mkN "länsherre" utrum  ;
  laerjunge_nn_1_1_N = mkN "lärjunge" utrum  ;
  laeskjaette_nn_1_1_N = mkN "läskjätte" utrum  ;
  laeskaende_nn_1_1_N = mkN "läskände" utrum  ;
  loepmage_nn_1_1_N = mkN "löpmage" utrum  ;
  loesmage_nn_1_1_N = mkN "lösmage" utrum  ;
  make_nn_1_N = mkN "make" utrum  ;
  markservice_nn_1_N = mkN "markservice" utrum  ;
  massage_nn_1_N = mkN "massage" utrum  ;
  massjaette_nn_1_1_N = mkN "massjätte" utrum  ;
  matchhjaelte_nn_1_1_N = mkN "matchhjälte" utrum  ;
  matte_nn_1_N = mkN "matte" utrum  ;
  meddelelse_nn_1_N = mkN "meddelelse" utrum  ;
  medfaange_nn_1_1_N = mkN "medfånge" utrum  ;
  miljoebuse_nn_1_1_N = mkN "miljöbuse" utrum  ;
  miljoefoerstoerelse_nn_1_1_N = mkN "miljöförstörelse" utrum  ;
  miljoehjaelte_nn_1_1_N = mkN "miljöhjälte" utrum  ;
  milkshake_nn_1_N = mkN "milkshake" utrum  ;
  minestrone_nn_1_N = mkN "minestrone" utrum  ;
  misstanke_nn_1_N = mkN "misstanke" utrum  ;
  mjukskalle_nn_1_N = mkN "mjukskalle" utrum  ;
  mjoelkmage_nn_1_1_N = mkN "mjölkmage" utrum  ;
  monke_nn_1_N = mkN "monke" utrum  ;
  musiktomte_nn_1_N = mkN "musiktomte" utrum  ;
  muskelmage_nn_1_N = mkN "muskelmage" utrum  ;
  mussemajje_nn_1_N = mkN "mussemajje" utrum  ;
  musunge_nn_1_N = mkN "musunge" utrum  ;
  mutgubbe_nn_1_N = mkN "mutgubbe" utrum  ;
  maenniskoande_nn_1_1_N = mkN "människoande" utrum  ;
  maenniskoraettskaempe_nn_1_1_N = mkN "människorättskämpe" utrum  ;
  maesshake_nn_1_1_N = mkN "mässhake" utrum  ;
  maangubbe_nn_1_1_N = mkN "mångubbe" utrum  ;
  maasunge_nn_1_1_N = mkN "måsunge" utrum  ;
  moebeljaette_nn_1_1_N = mkN "möbeljätte" utrum  ;
  moensterfaange_nn_1_1_N = mkN "mönsterfånge" utrum  ;
  moenstergosse_nn_1_1_N = mkN "mönstergosse" utrum  ;
  nalle_nn_1_N = mkN "nalle" utrum  ;
  nare_nn_1_N = mkN "nare" utrum  ;
  nasse_nn_1_N = mkN "nasse" utrum  ;
  nationalhjaelte_nn_1_1_N = mkN "nationalhjälte" utrum  ;
  nervaende_nn_1_1_N = mkN "nervände" utrum  ;
  nickhake_nn_1_N = mkN "nickhake" utrum  ;
  nisse_nn_1_N = mkN "nisse" utrum  ;
  nitskalle_nn_1_N = mkN "nitskalle" utrum  ;
  nonpareille_nn_1_N = mkN "nonpareille" utrum  ;
  nordostpassage_nn_1_N = mkN "nordostpassage" utrum  ;
  noshoerningsunge_nn_1_1_N = mkN "noshörningsunge" utrum  ;
  nymaane_nn_1_1_N = mkN "nymåne" utrum  ;
  naervarelse_nn_1_1_N = mkN "närvarelse" utrum  ;
  naestunge_nn_1_1_N = mkN "nästunge" utrum  ;
  naetmage_nn_1_1_N = mkN "nätmage" utrum  ;
  ofoerstaaelse_nn_1_1_N = mkN "oförståelse" utrum  ;
  omtanke_nn_1_N = mkN "omtanke" utrum  ;
  oppfyllelse_nn_1_N = mkN "oppfyllelse" utrum  ;
  ostbaage_nn_1_1_N = mkN "ostbåge" utrum  ;
  otillfredsstaellelse_nn_1_1_N = mkN "otillfredsställelse" utrum  ;
  oxfordroerelse_nn_1_1_N = mkN "oxfordrörelse" utrum  ;
  panikunge_nn_1_N = mkN "panikunge" utrum  ;
  pappskalle_nn_1_N = mkN "pappskalle" utrum  ;
  pingstroerelse_nn_1_1_N = mkN "pingströrelse" utrum  ;
  pinoande_nn_1_N = mkN "pinoande" utrum  ;
  pliktuppfyllelse_nn_1_N = mkN "pliktuppfyllelse" utrum  ;
  plaagoande_nn_1_1_N = mkN "plågoande" utrum  ;
  plaatmage_nn_1_1_N = mkN "plåtmage" utrum  ;
  pojkbokshjaelte_nn_1_1_N = mkN "pojkbokshjälte" utrum  ;
  prestige_nn_1_N = mkN "prestige" utrum  ;
  priffe_nn_1_N = mkN "priffe" utrum  ;
  prydnadskudde_nn_1_N = mkN "prydnadskudde" utrum  ;
  pubbeunge_nn_1_N = mkN "pubbeunge" utrum  ;
  putmage_nn_1_N = mkN "putmage" utrum  ;
  paalle_nn_1_1_N = mkN "pålle" utrum  ;
  paave_nn_1_1_N = mkN "påve" utrum  ;
  rackarunge_nn_1_N = mkN "rackarunge" utrum  ;
  ragtime_nn_1_N = mkN "ragtime" utrum  ;
  rasse_nn_1_N = mkN "rasse" utrum  ;
  rave_nn_1_N = mkN "rave" utrum  ;
  reggae_nn_1_N = mkN "reggae" utrum  ;
  renmage_nn_1_N = mkN "renmage" utrum  ;
  repaende_nn_1_1_N = mkN "repände" utrum  ;
  riksfurste_nn_1_N = mkN "riksfurste" utrum  ;
  rikspolisstyrelse_nn_1_N = mkN "rikspolisstyrelse" utrum  ;
  rote_nn_1_N = mkN "rote" utrum  ;
  ruelse_nn_1_N = mkN "ruelse" utrum  ;
  rumpnisse_nn_1_N = mkN "rumpnisse" utrum  ;
  raeknenisse_nn_1_1_N = mkN "räknenisse" utrum  ;
  raennstensunge_nn_1_1_N = mkN "rännstensunge" utrum  ;
  raettfaerdiggoerelse_nn_1_1_N = mkN "rättfärdiggörelse" utrum  ;
  raage_nn_1_1_N = mkN "råge" utrum  ;
  roedhake_nn_1_1_N = mkN "rödhake" utrum  ;
  roentgenstraale_nn_1_1_N = mkN "röntgenstråle" utrum  ;
  sagohjaelte_nn_1_1_N = mkN "sagohjälte" utrum  ;
  saltlake_nn_1_N = mkN "saltlake" utrum  ;
  salvelse_nn_1_N = mkN "salvelse" utrum  ;
  samhaellsservice_nn_1_1_N = mkN "samhällsservice" utrum  ;
  samvetsfaange_nn_1_1_N = mkN "samvetsfånge" utrum  ;
  sandhavre_nn_1_N = mkN "sandhavre" utrum  ;
  sandkrasse_nn_1_N = mkN "sandkrasse" utrum  ;
  sanningslidelse_nn_1_N = mkN "sanningslidelse" utrum  ;
  satunge_nn_1_N = mkN "satunge" utrum  ;
  scoutroerelse_nn_1_1_N = mkN "scoutrörelse" utrum  ;
  segerherre_nn_1_N = mkN "segerherre" utrum  ;
  segerhjaelte_nn_1_1_N = mkN "segerhjälte" utrum  ;
  service_nn_1_N = mkN "service" utrum  ;
  shake_nn_1_N = mkN "shake" utrum  ;
  sidenkudde_nn_1_N = mkN "sidenkudde" utrum  ;
  sidoarvinge_nn_1_N = mkN "sidoarvinge" utrum  ;
  sinnesglaedje_nn_1_1_N = mkN "sinnesglädje" utrum  ;
  sittkudde_nn_1_N = mkN "sittkudde" utrum  ;
  sjaelvhaevdelse_nn_1_1_N = mkN "självhävdelse" utrum  ;
  sjaelvstyrelse_nn_1_1_N = mkN "självstyrelse" utrum  ;
  sjaelvoevervinnelse_nn_1_1_N = mkN "självövervinnelse" utrum  ;
  skadeglaedje_nn_1_1_N = mkN "skadeglädje" utrum  ;
  skandalunge_nn_1_N = mkN "skandalunge" utrum  ;
  skare_nn_1_N = mkN "skare" utrum  ;
  skeppsgosse_nn_1_N = mkN "skeppsgosse" utrum  ;
  skiffle_nn_1_N = mkN "skiffle" utrum  ;
  skinnknutte_nn_1_N = mkN "skinnknutte" utrum  ;
  skinnskalle_nn_1_N = mkN "skinnskalle" utrum  ;
  skogsdunge_nn_1_N = mkN "skogsdunge" utrum  ;
  skolgosse_nn_1_N = mkN "skolgosse" utrum  ;
  skrumpnjure_nn_1_N = mkN "skrumpnjure" utrum  ;
  skruvskalle_nn_1_N = mkN "skruvskalle" utrum  ;
  skyddsande_nn_1_N = mkN "skyddsande" utrum  ;
  skoenande_nn_1_1_N = mkN "skönande" utrum  ;
  skoenhetsjaette_nn_1_1_N = mkN "skönhetsjätte" utrum  ;
  slagskaempe_nn_1_1_N = mkN "slagskämpe" utrum  ;
  slivovice_nn_1_N = mkN "slivovice" utrum  ;
  slottsherre_nn_1_N = mkN "slottsherre" utrum  ;
  smalaende_nn_1_1_N = mkN "smalände" utrum  ;
  smaapaave_nn_1_1_N = mkN "småpåve" utrum  ;
  smoergaaskrasse_nn_1_1_N = mkN "smörgåskrasse" utrum  ;
  snickarglaedje_nn_1_1_N = mkN "snickarglädje" utrum  ;
  snorre_nn_1_N = mkN "snorre" utrum  ;
  snorunge_nn_1_N = mkN "snorunge" utrum  ;
  snusjaette_nn_1_1_N = mkN "snusjätte" utrum  ;
  socialstyrelse_nn_1_N = mkN "socialstyrelse" utrum  ;
  software_nn_1_N = mkN "software" utrum  ;
  solvaerme_nn_1_1_N = mkN "solvärme" utrum  ;
  sosse_nn_1_N = mkN "sosse" utrum  ;
  spikskalle_nn_1_N = mkN "spikskalle" utrum  ;
  spiselvaerme_nn_1_1_N = mkN "spiselvärme" utrum  ;
  sportfaane_nn_1_1_N = mkN "sportfåne" utrum  ;
  sprue_nn_1_N = mkN "sprue" utrum  ;
  spaerrhake_nn_1_1_N = mkN "spärrhake" utrum  ;
  stiltje_nn_1_N = mkN "stiltje" utrum  ;
  stjaerngosse_nn_1_1_N = mkN "stjärngosse" utrum  ;
  stjaertgosse_nn_1_1_N = mkN "stjärtgosse" utrum  ;
  storfurste_nn_1_N = mkN "storfurste" utrum  ;
  straffaange_nn_1_1_N = mkN "straffånge" utrum  ;
  strip_tease_nn_1_N = mkN "strip-tease" utrum  ;
  striptease_nn_1_N = mkN "striptease" utrum  ;
  strutsmage_nn_1_N = mkN "strutsmage" utrum  ;
  stugvaerme_nn_1_1_N = mkN "stugvärme" utrum  ;
  staalstomme_nn_1_1_N = mkN "stålstomme" utrum  ;
  staalwire_nn_1_1_N = mkN "stålwire" utrum  ;
  svartskalle_nn_1_N = mkN "svartskalle" utrum  ;
  svenne_nn_1_N = mkN "svenne" utrum  ;
  syffe_nn_1_N = mkN "syffe" utrum  ;
  syndafoerlaatelse_nn_1_1_N = mkN "syndaförlåtelse" utrum  ;
  synekdoke_nn_1_N = mkN "synekdoke" utrum  ;
  synkope_nn_1_N = mkN "synkope" utrum  ;
  systole_nn_1_N = mkN "systole" utrum  ;
  saelunge_nn_1_1_N = mkN "sälunge" utrum  ;
  saengvaerme_nn_1_1_N = mkN "sängvärme" utrum  ;
  saetthake_nn_1_1_N = mkN "sätthake" utrum  ;
  talldunge_nn_1_N = mkN "talldunge" utrum  ;
  tanke_nn_1_N = mkN "tanke" utrum  ;
  tempelherre_nn_1_N = mkN "tempelherre" utrum  ;
  tillblivelse_nn_1_N = mkN "tillblivelse" utrum  ;
  tillfredsstaellelse_nn_1_1_N = mkN "tillfredsställelse" utrum  ;
  tillintetgoerelse_nn_1_1_N = mkN "tillintetgörelse" utrum  ;
  tillaegnelse_nn_1_1_N = mkN "tillägnelse" utrum  ;
  tillaatelse_nn_1_1_N = mkN "tillåtelse" utrum  ;
  timbre_nn_1_N = mkN "timbre" utrum  ;
  tjirre_nn_1_N = mkN "tjirre" utrum  ;
  tjockskalle_nn_1_N = mkN "tjockskalle" utrum  ;
  tjorre_nn_1_N = mkN "tjorre" utrum  ;
  tjurskalle_nn_1_N = mkN "tjurskalle" utrum  ;
  tjaele_nn_1_1_N = mkN "tjäle" utrum  ;
  tjaensteande_nn_1_1_N = mkN "tjänsteande" utrum  ;
  toffelhjaelte_nn_1_1_N = mkN "toffelhjälte" utrum  ;
  tomte_nn_1_N = mkN "tomte" utrum  ;
  tomtebisse_nn_1_N = mkN "tomtebisse" utrum  ;
  tomtegubbe_nn_1_N = mkN "tomtegubbe" utrum  ;
  tomtenisse_nn_1_N = mkN "tomtenisse" utrum  ;
  toppaende_nn_1_1_N = mkN "toppände" utrum  ;
  totalitetsbetydelse_nn_1_N = mkN "totalitetsbetydelse" utrum  ;
  trance_nn_1_N = mkN "trance" utrum  ;
  trasunge_nn_1_N = mkN "trasunge" utrum  ;
  trendnisse_nn_1_N = mkN "trendnisse" utrum  ;
  trollgubbe_nn_1_N = mkN "trollgubbe" utrum  ;
  trollunge_nn_1_N = mkN "trollunge" utrum  ;
  tronarvinge_nn_1_N = mkN "tronarvinge" utrum  ;
  traekarlsbridge_nn_1_1_N = mkN "träkarlsbridge" utrum  ;
  traeningsglaedje_nn_1_1_N = mkN "träningsglädje" utrum  ;
  traeskalle_nn_1_1_N = mkN "träskalle" utrum  ;
  taete_nn_1_1_N = mkN "täte" utrum  ;
  ugnsvaerme_nn_1_1_N = mkN "ugnsvärme" utrum  ;
  underkastelse_nn_1_N = mkN "underkastelse" utrum  ;
  undersoekningsfaange_nn_1_1_N = mkN "undersökningsfånge" utrum  ;
  undervaerme_nn_1_1_N = mkN "undervärme" utrum  ;
  ungkyrkoroerelse_nn_1_1_N = mkN "ungkyrkorörelse" utrum  ;
  universalarvinge_nn_1_N = mkN "universalarvinge" utrum  ;
  uppbyggelse_nn_1_N = mkN "uppbyggelse" utrum  ;
  uppfyllelse_nn_1_N = mkN "uppfyllelse" utrum  ;
  uppgivelse_nn_1_N = mkN "uppgivelse" utrum  ;
  uppslagsaende_nn_1_1_N = mkN "uppslagsände" utrum  ;
  uppstaandelse_nn_1_1_N = mkN "uppståndelse" utrum  ;
  upptaeckarglaedje_nn_1_1_N = mkN "upptäckarglädje" utrum  ;
  utlevelse_nn_1_N = mkN "utlevelse" utrum  ;
  valfurste_nn_1_N = mkN "valfurste" utrum  ;
  vallkrasse_nn_1_N = mkN "vallkrasse" utrum  ;
  vardagsfoerstaaelse_nn_1_1_N = mkN "vardagsförståelse" utrum  ;
  vargunge_nn_1_N = mkN "vargunge" utrum  ;
  vassle_nn_1_N = mkN "vassle" utrum  ;
  vattenaloe_nn_1_N = mkN "vattenaloe" utrum  ;
  vattenkrasse_nn_1_N = mkN "vattenkrasse" utrum  ;
  vattenskalle_nn_1_N = mkN "vattenskalle" utrum  ;
  veckoaende_nn_1_1_N = mkN "veckoände" utrum  ;
  veckaende_nn_1_1_N = mkN "veckände" utrum  ;
  vejde_nn_1_N = mkN "vejde" utrum  ;
  vildhavre_nn_1_N = mkN "vildhavre" utrum  ;
  vinkelhake_nn_1_N = mkN "vinkelhake" utrum  ;
  vinnarskalle_nn_1_N = mkN "vinnarskalle" utrum  ;
  visirlinje_nn_1_N = mkN "visirlinje" utrum  ;
  vispgraedde_nn_1_1_N = mkN "vispgrädde" utrum  ;
  voile_nn_1_N = mkN "voile" utrum  ;
  vovve_nn_1_N = mkN "vovve" utrum  ;
  vrede_nn_1_N = mkN "vrede" utrum  ;
  vaemjelse_nn_1_1_N = mkN "vämjelse" utrum  ;
  vaerldsberoemmelse_nn_1_1_N = mkN "världsberömmelse" utrum  ;
  vaerme_nn_1_1_N = mkN "värme" utrum  ;
  vaermeroerelse_nn_1_1_N = mkN "värmerörelse" utrum  ;
  vaextroerelse_nn_1_1_N = mkN "växtrörelse" utrum  ;
  aelsklingsnalle_nn_1_1_N = mkN "älsklingsnalle" utrum  ;
  aengsgroee_nn_1_1_N = mkN "ängsgröe" utrum  ;
  aenterhake_nn_1_1_N = mkN "änterhake" utrum  ;
  aaminnelse_nn_1_1_N = mkN "åminnelse" utrum  ;
  aangbildningsvaerme_nn_1_1_N = mkN "ångbildningsvärme" utrum  ;
  aaterfoedelse_nn_1_1_N = mkN "återfödelse" utrum  ;
  aaterstaellelse_nn_1_1_N = mkN "återställelse" utrum  ;
  aaterupplevelse_nn_1_1_N = mkN "återupplevelse" utrum  ;
  oelmage_nn_1_1_N = mkN "ölmage" utrum  ;
  oenskeuppfyllelse_nn_1_1_N = mkN "önskeuppfyllelse" utrum  ;
  oermage_nn_1_1_N = mkN "örmage" utrum  ;
  oernbraekne_nn_1_1_N = mkN "örnbräkne" utrum  ;
  oevervaerme_nn_1_1_N = mkN "övervärme" utrum  ;
  Almedalsvecka_nn_1_N = mkN "Almedalsvecka" ;
  Asien_rundresa_nn_1_N = mkN "Asien-rundresa" ;
  Bachfuga_nn_1_N = mkN "Bachfuga" ;
  Bromelia_nn_1_N = mkN "Bromelia" ;
  Brommamamma_nn_1_N = mkN "Brommamamma" ;
  C_durskala_nn_1_N = mkN "C-durskala" ;
  Centauristjaerna_nn_1_1_N = mkN "Centauristjärna" ;
  DNA_kedja_nn_1_N = mkN "DNA-kedja" ;
  Dubaifrossa_nn_1_N = mkN "Dubaifrossa" ;
  EHEC_smitta_nn_1_N = mkN "EHEC-smitta" ;
  Fia_nn_1_N = mkN "Fia" ;
  Frimurareorden_nn_1_N = mkN "Frimurareorden" ;
  Frimurarorden_nn_1_N = mkN "Frimurarorden" ;
  Gotlandsfaerja_nn_1_1_N = mkN "Gotlandsfärja" ;
  Hagasessa_nn_1_N = mkN "Hagasessa" ;
  Hollywoodfru_nn_1_N = mkN "Hollywoodfru" ;
  ID_bricka_nn_1_N = mkN "ID-bricka" ;
  Japanoro_nn_1_N = mkN "Japanoro" ;
  LED_lampa_nn_1_N = mkN "LED-lampa" ;
  Marsresa_nn_1_N = mkN "Marsresa" ;
  Merca_nn_1_N = mkN "Merca" ;
  Mersa_nn_1_N = mkN "Mersa" ;
  Montessoriskola_nn_1_N = mkN "Montessoriskola" ;
  Maangfaldsbarometer_nn_1_1_N = mkN "Mångfaldsbarometer" ;
  PCB_olja_nn_1_N = mkN "PCB-olja" ;
  Palestinafraaga_nn_1_1_N = mkN "Palestinafråga" ;
  SAS_flygvaerdinna_nn_1_1_N = mkN "SAS-flygvärdinna" ;
  Stockholmsarena_nn_1_N = mkN "Stockholmsarena" ;
  Strindbergsutgaava_nn_1_1_N = mkN "Strindbergsutgåva" ;
  T_troeja_nn_1_1_N = mkN "T-tröja" ;
  TV_kamera_nn_1_N = mkN "TV-kamera" ;
  TV_ruta_nn_1_N = mkN "TV-ruta" ;
  TV_soffa_nn_1_N = mkN "TV-soffa" ;
  TV_saapa_nn_1_1_N = mkN "TV-såpa" ;
  Tjernobylolycka_nn_1_N = mkN "Tjernobylolycka" ;
  Viagra_nn_1_N = mkN "Viagra" ;
  Visbyvecka_nn_1_N = mkN "Visbyvecka" ;
  Volvo_nn_1_N = mkN "Volvo" ;
  Vaetternrunda_nn_1_1_N = mkN "Vätternrunda" ;
  Zlatan_groda_nn_1_N = mkN "Zlatan-groda" ;
  _1_kanthylsa_nn_1_N = mkN "12-kanthylsa" ;
  _1_kantshylsa_nn_1_N = mkN "12-kantshylsa" ;
  _2_taktsolja_nn_1_N = mkN "2-taktsolja" ;
  _40_aaring_nn_1_1_N = mkN "40-åring" ;
  abbedissa_nn_1_N = mkN "abbedissa" ;
  abbreviering_nn_1_N = mkN "abbreviering" ;
  abdikering_nn_1_N = mkN "abdikering" ;
  abessinska_nn_1_N = mkN "abessinska" ;
  abonnering_nn_1_N = mkN "abonnering" ;
  abortering_nn_1_N = mkN "abortering" ;
  abortfraaga_nn_1_1_N = mkN "abortfråga" ;
  abortraadgivning_nn_2_1_N = mkN "abortrådgivning" ;
  abradering_nn_1_N = mkN "abradering" ;
  abskissa_nn_1_N = mkN "abskissa" ;
  absolvering_nn_1_N = mkN "absolvering" ;
  absorbering_nn_1_N = mkN "absorbering" ;
  absorberingsfoermaaga_nn_1_1_N = mkN "absorberingsförmåga" ;
  abstrahering_nn_1_N = mkN "abstrahering" ;
  abstraktionsfoermaaga_nn_1_1_N = mkN "abstraktionsförmåga" ;
  accedering_nn_1_N = mkN "accedering" ;
  accelerering_nn_1_N = mkN "accelerering" ;
  accentfoerskjutning_nn_1_1_N = mkN "accentförskjutning" ;
  accentuering_nn_1_N = mkN "accentuering" ;
  acceptering_nn_1_N = mkN "acceptering" ;
  aceton_nn_1_N = mkN "aceton" ;
  acetylenlampa_nn_1_N = mkN "acetylenlampa" ;
  acetylsalicylsyra_nn_1_N = mkN "acetylsalicylsyra" ;
  ackja_nn_1_N = mkN "ackja" ;
  acklimatisering_nn_1_N = mkN "acklimatisering" ;
  ackommodering_nn_1_N = mkN "ackommodering" ;
  ackompanjering_nn_1_N = mkN "ackompanjering" ;
  ackordering_nn_1_N = mkN "ackordering" ;
  ackordssaettning_nn_1_1_N = mkN "ackordssättning" ;
  ackordsaettning_nn_1_1_N = mkN "ackordsättning" ;
  ackreditering_nn_1_N = mkN "ackreditering" ;
  ackumulering_nn_1_N = mkN "ackumulering" ;
  ackuschoerska_nn_1_1_N = mkN "ackuschörska" ;
  ackvirering_nn_1_N = mkN "ackvirering" ;
  actionstjaerna_nn_1_1_N = mkN "actionstjärna" ;
  adaptering_nn_1_N = mkN "adaptering" ;
  addering_nn_1_N = mkN "addering" ;
  adel_nn_1_N = mkN "adel" ;
  adjungering_nn_1_N = mkN "adjungering" ;
  administrering_nn_1_N = mkN "administrering" ;
  adoptering_nn_1_N = mkN "adoptering" ;
  adressering_nn_1_N = mkN "adressering" ;
  adresslapp_nn_1_N = mkN "adresslapp" ;
  adsorbering_nn_1_N = mkN "adsorbering" ;
  aducering_nn_1_N = mkN "aducering" ;
  adventsstjaerna_nn_1_1_N = mkN "adventsstjärna" ;
  advocering_nn_1_N = mkN "advocering" ;
  adxukiboena_nn_1_1_N = mkN "adxukiböna" ;
  afficiering_nn_1_N = mkN "afficiering" ;
  affinering_nn_1_N = mkN "affinering" ;
  affischering_nn_1_N = mkN "affischering" ;
  affrikata_nn_1_N = mkN "affrikata" ;
  affaersbegaavning_nn_1_1_N = mkN "affärsbegåvning" ;
  affaersgata_nn_1_1_N = mkN "affärsgata" ;
  affaerskedja_nn_1_1_N = mkN "affärskedja" ;
  affaersresa_nn_1_1_N = mkN "affärsresa" ;
  affaersstaellning_nn_1_1_N = mkN "affärsställning" ;
  affaersvaerld_nn_1_1_N = mkN "affärsvärld" ;
  afghanska_nn_1_N = mkN "afghanska" ;
  afghanska_nn_2_N = mkN "afghanska" ;
  afrikanisering_nn_1_N = mkN "afrikanisering" ;
  afrikanska_nn_1_N = mkN "afrikanska" ;
  aftonklaenning_nn_1_1_N = mkN "aftonklänning" ;
  aftonskola_nn_1_N = mkN "aftonskola" ;
  aftonstjaerna_nn_1_1_N = mkN "aftonstjärna" ;
  aftontidning_nn_1_N = mkN "aftontidning" ;
  aga_nn_2_N = mkN "aga" ;
  agenda_nn_1_N = mkN "agenda" ;
  agglomerering_nn_1_N = mkN "agglomerering" ;
  agglutinering_nn_1_N = mkN "agglutinering" ;
  aggressionshaemning_nn_1_1_N = mkN "aggressionshämning" ;
  agitationsvisa_nn_1_N = mkN "agitationsvisa" ;
  agitering_nn_1_N = mkN "agitering" ;
  ajournering_nn_1_N = mkN "ajournering" ;
  akacia_nn_1_N = mkN "akacia" ;
  akillessena_nn_1_N = mkN "akillessena" ;
  akleja_nn_1_N = mkN "akleja" ;
  aktersnurra_nn_1_N = mkN "aktersnurra" ;
  akterstaev_nn_1_1_N = mkN "akterstäv" ;
  aktfoerklaring_nn_1_1_N = mkN "aktförklaring" ;
  aktgivning_nn_1_N = mkN "aktgivning" ;
  aktiehandel_nn_1_N = mkN "aktiehandel" ;
  aktiesparklubb_nn_1_N = mkN "aktiesparklubb" ;
  aktiestock_nn_1_N = mkN "aktiestock" ;
  aktieutdelning_nn_1_N = mkN "aktieutdelning" ;
  aktivering_nn_1_N = mkN "aktivering" ;
  aktivitetsersaettning_nn_1_1_N = mkN "aktivitetsersättning" ;
  aktning_nn_1_N = mkN "aktning" ;
  aktualisering_nn_1_N = mkN "aktualisering" ;
  akustikplatta_nn_1_N = mkN "akustikplatta" ;
  akutavdelning_nn_1_N = mkN "akutavdelning" ;
  akutmottagning_nn_1_N = mkN "akutmottagning" ;
  akvaplaning_nn_1_N = mkN "akvaplaning" ;
  akvarellutstaellning_nn_1_1_N = mkN "akvarellutställning" ;
  alarmering_nn_1_N = mkN "alarmering" ;
  alarmklocka_nn_1_N = mkN "alarmklocka" ;
  alba_nn_1_N = mkN "alba" ;
  albanska_nn_1_N = mkN "albanska" ;
  albanska_nn_2_N = mkN "albanska" ;
  alfabetisering_nn_1_N = mkN "alfabetisering" ;
  alfastraalning_nn_1_1_N = mkN "alfastrålning" ;
  algblomning_nn_1_N = mkN "algblomning" ;
  algebra_nn_1_N = mkN "algebra" ;
  algeriska_nn_1_N = mkN "algeriska" ;
  algmatta_nn_1_N = mkN "algmatta" ;
  algtvaett_nn_1_1_N = mkN "algtvätt" ;
  alienering_nn_1_N = mkN "alienering" ;
  alika_nn_1_N = mkN "alika" ;
  alisarin_nn_1_N = mkN "alisarin" ;
  alka_nn_1_N = mkN "alka" ;
  alkanna_nn_1_N = mkN "alkanna" ;
  alkoholfoertaering_nn_1_1_N = mkN "alkoholförtäring" ;
  alla_nn_1_N = mkN "alla" ;
  allegorisering_nn_1_N = mkN "allegorisering" ;
  allfarvaeg_nn_1_1_N = mkN "allfarväg" ;
  allhelgonamaessa_nn_1_1_N = mkN "allhelgonamässa" ;
  alliansring_nn_1_N = mkN "alliansring" ;
  alliering_nn_1_N = mkN "alliering" ;
  allitterering_nn_1_N = mkN "allitterering" ;
  allmosa_nn_1_N = mkN "allmosa" ;
  allmaenbegaavning_nn_1_1_N = mkN "allmänbegåvning" ;
  allmaenbildning_nn_1_1_N = mkN "allmänbildning" ;
  allmaenning_nn_1_1_N = mkN "allmänning" ;
  allmaentjaenstgoering_nn_1_1_N = mkN "allmäntjänstgöring" ;
  allokering_nn_1_N = mkN "allokering" ;
  allriskfoersaekring_nn_1_1_N = mkN "allriskförsäkring" ;
  allroundsaag_nn_1_1_N = mkN "allroundsåg" ;
  allsvenska_nn_1_N = mkN "allsvenska" ;
  alludering_nn_1_N = mkN "alludering" ;
  almanacka_nn_1_N = mkN "almanacka" ;
  alpacka_nn_1_N = mkN "alpacka" ;
  alruna_nn_1_N = mkN "alruna" ;
  alstring_nn_1_N = mkN "alstring" ;
  altanbraeda_nn_1_1_N = mkN "altanbräda" ;
  altandoerr_nn_1_1_N = mkN "altandörr" ;
  altarduk_nn_1_N = mkN "altarduk" ;
  altargaang_nn_1_1_N = mkN "altargång" ;
  altarlykta_nn_1_N = mkN "altarlykta" ;
  altarmaalning_nn_1_1_N = mkN "altarmålning" ;
  altarring_nn_1_N = mkN "altarring" ;
  altartavla_nn_1_N = mkN "altartavla" ;
  altea_nn_1_N = mkN "altea" ;
  alternativfraaga_nn_1_1_N = mkN "alternativfråga" ;
  alternering_nn_1_N = mkN "alternering" ;
  altita_nn_1_N = mkN "altita" ;
  altstaemma_nn_1_1_N = mkN "altstämma" ;
  aluminering_nn_1_N = mkN "aluminering" ;
  alun_nn_1_N = mkN "alun" ;
  alvar_nn_1_N = mkN "alvar" ;
  amalgamering_nn_1_N = mkN "amalgamering" ;
  amatoerbombtillverkning_nn_1_1_N = mkN "amatörbombtillverkning" ;
  ambulanssjukskoeterska_nn_1_1_N = mkN "ambulanssjuksköterska" ;
  ambulering_nn_1_N = mkN "ambulering" ;
  amerikanisering_nn_1_N = mkN "amerikanisering" ;
  amerikanska_nn_1_N = mkN "amerikanska" ;
  amerikanska_nn_2_N = mkN "amerikanska" ;
  amfora_nn_1_N = mkN "amfora" ;
  aminosyra_nn_1_N = mkN "aminosyra" ;
  amma_nn_1_N = mkN "amma" ;
  ammoniakloesning_nn_1_1_N = mkN "ammoniaklösning" ;
  ammoniumnitratloesning_nn_1_1_N = mkN "ammoniumnitratlösning" ;
  ammunitionsvaeska_nn_1_1_N = mkN "ammunitionsväska" ;
  amnestilag_nn_1_N = mkN "amnestilag" ;
  amortering_nn_1_N = mkN "amortering" ;
  amplifiering_nn_1_N = mkN "amplifiering" ;
  amplitudmodulering_nn_1_N = mkN "amplitudmodulering" ;
  amputering_nn_1_N = mkN "amputering" ;
  amsaga_nn_1_N = mkN "amsaga" ;
  amoeba_nn_1_1_N = mkN "amöba" ;
  anakonda_nn_1_N = mkN "anakonda" ;
  analfena_nn_1_N = mkN "analfena" ;
  analogibildning_nn_1_N = mkN "analogibildning" ;
  analysering_nn_1_N = mkN "analysering" ;
  analoeppning_nn_1_1_N = mkN "analöppning" ;
  anbefallning_nn_1_N = mkN "anbefallning" ;
  anblick_nn_1_N = mkN "anblick" ;
  anblaaspipa_nn_1_1_N = mkN "anblåspipa" ;
  anbringning_nn_1_N = mkN "anbringning" ;
  andefattigdom_nn_1_N = mkN "andefattigdom" ;
  andelsfoerening_nn_1_1_N = mkN "andelsförening" ;
  andemening_nn_1_N = mkN "andemening" ;
  andevaerld_nn_1_1_N = mkN "andevärld" ;
  andhaemtning_nn_1_1_N = mkN "andhämtning" ;
  andning_nn_1_N = mkN "andning" ;
  andorranska_nn_1_N = mkN "andorranska" ;
  andrabil_nn_1_N = mkN "andrabil" ;
  andraderivata_nn_1_N = mkN "andraderivata" ;
  andrahandskaella_nn_1_1_N = mkN "andrahandskälla" ;
  andraplacering_nn_1_N = mkN "andraplacering" ;
  andraslagsfoermaaga_nn_1_1_N = mkN "andraslagsförmåga" ;
  andratidning_nn_1_N = mkN "andratidning" ;
  anekdotflora_nn_1_N = mkN "anekdotflora" ;
  anflygning_nn_1_N = mkN "anflygning" ;
  anfraetning_nn_1_1_N = mkN "anfrätning" ;
  anfaektning_nn_1_1_N = mkN "anfäktning" ;
  anfoering_nn_1_1_N = mkN "anföring" ;
  angina_nn_1_N = mkN "angina" ;
  anglisering_nn_1_N = mkN "anglisering" ;
  angolanska_nn_1_N = mkN "angolanska" ;
  anhopning_nn_1_N = mkN "anhopning" ;
  anhaengarskara_nn_1_1_N = mkN "anhängarskara" ;
  anhoerigdag_nn_1_1_N = mkN "anhörigdag" ;
  anilin_nn_1_N = mkN "anilin" ;
  animering_nn_1_N = mkN "animering" ;
  aning_nn_1_N = mkN "aning" ;
  anisolja_nn_1_N = mkN "anisolja" ;
  anka_nn_1_N = mkN "anka" ;
  ankarkropp_nn_1_N = mkN "ankarkropp" ;
  ankarkaetting_nn_1_1_N = mkN "ankarkätting" ;
  ankarlindning_nn_1_N = mkN "ankarlindning" ;
  ankarstock_nn_1_N = mkN "ankarstock" ;
  ankdamm_nn_1_N = mkN "ankdamm" ;
  ankelsocka_nn_1_N = mkN "ankelsocka" ;
  anklaepp_nn_1_1_N = mkN "ankläpp" ;
  anknytning_nn_1_N = mkN "anknytning" ;
  ankring_nn_1_N = mkN "ankring" ;
  anledning_nn_1_N = mkN "anledning" ;
  anliggning_nn_1_N = mkN "anliggning" ;
  anliggningsyta_nn_1_N = mkN "anliggningsyta" ;
  anlaeggning_nn_1_1_N = mkN "anläggning" ;
  anlaeggningstillgaang_nn_1_1_N = mkN "anläggningstillgång" ;
  anlaeggningsyta_nn_1_1_N = mkN "anläggningsyta" ;
  anloepning_nn_1_1_N = mkN "anlöpning" ;
  anmaning_nn_1_N = mkN "anmaning" ;
  anmaelning_nn_1_1_N = mkN "anmälning" ;
  anmaerkning_nn_1_1_N = mkN "anmärkning" ;
  annektering_nn_1_N = mkN "annektering" ;
  annexfoersamling_nn_1_1_N = mkN "annexförsamling" ;
  annexkyrka_nn_1_N = mkN "annexkyrka" ;
  annihilering_nn_1_N = mkN "annihilering" ;
  annonsering_nn_1_N = mkN "annonsering" ;
  annonstavla_nn_1_N = mkN "annonstavla" ;
  annonstidning_nn_1_N = mkN "annonstidning" ;
  annotering_nn_1_N = mkN "annotering" ;
  annullering_nn_1_N = mkN "annullering" ;
  anodisering_nn_1_N = mkN "anodisering" ;
  anonymisering_nn_1_N = mkN "anonymisering" ;
  anordning_nn_1_N = mkN "anordning" ;
  anpassling_nn_1_N = mkN "anpassling" ;
  anpassning_nn_1_N = mkN "anpassning" ;
  anpassningsfoermaaga_nn_1_1_N = mkN "anpassningsförmåga" ;
  anrikning_nn_1_N = mkN "anrikning" ;
  anrikningsanlaeggning_nn_1_1_N = mkN "anrikningsanläggning" ;
  anropning_nn_1_N = mkN "anropning" ;
  anropsknapp_nn_1_N = mkN "anropsknapp" ;
  anraettning_nn_1_1_N = mkN "anrättning" ;
  ansamling_nn_1_N = mkN "ansamling" ;
  ansatsbana_nn_1_N = mkN "ansatsbana" ;
  ansiktsbjudning_nn_1_N = mkN "ansiktsbjudning" ;
  ansiktsfoerlamning_nn_1_1_N = mkN "ansiktsförlamning" ;
  ansiktslyftning_nn_1_N = mkN "ansiktslyftning" ;
  ansiktsskada_nn_1_N = mkN "ansiktsskada" ;
  anskaffning_nn_1_N = mkN "anskaffning" ;
  anslagsframstaellning_nn_1_1_N = mkN "anslagsframställning" ;
  anslagstavla_nn_1_N = mkN "anslagstavla" ;
  anslutning_nn_1_N = mkN "anslutning" ;
  anslutningssladd_nn_1_N = mkN "anslutningssladd" ;
  ansning_nn_1_N = mkN "ansning" ;
  anspelning_nn_1_N = mkN "anspelning" ;
  anspaenning_nn_1_1_N = mkN "anspänning" ;
  anstormning_nn_1_N = mkN "anstormning" ;
  anstrykning_nn_1_N = mkN "anstrykning" ;
  anstraengning_nn_1_1_N = mkN "ansträngning" ;
  anstaellning_nn_1_1_N = mkN "anställning" ;
  ansvarighetsfoersaekring_nn_1_1_N = mkN "ansvarighetsförsäkring" ;
  ansvaring_nn_1_N = mkN "ansvaring" ;
  ansvarsfoersaekring_nn_1_1_N = mkN "ansvarsförsäkring" ;
  ansvaellning_nn_1_1_N = mkN "ansvällning" ;
  ansaettning_nn_1_1_N = mkN "ansättning" ;
  ansaettningsskruv_nn_1_1_N = mkN "ansättningsskruv" ;
  ansoekning_nn_1_1_N = mkN "ansökning" ;
  ansoekningshandling_nn_1_1_N = mkN "ansökningshandling" ;
  antagning_nn_1_N = mkN "antagning" ;
  antavla_nn_1_N = mkN "antavla" ;
  antecipering_nn_1_N = mkN "antecipering" ;
  anteckning_nn_1_N = mkN "anteckning" ;
  antedatering_nn_1_N = mkN "antedatering" ;
  antepenultima_nn_1_N = mkN "antepenultima" ;
  antiabortlag_nn_1_N = mkN "antiabortlag" ;
  antibiotika_nn_1_N = mkN "antibiotika" ;
  antichambrering_nn_1_N = mkN "antichambrering" ;
  antiguanska_nn_1_N = mkN "antiguanska" ;
  antikisering_nn_1_N = mkN "antikisering" ;
  antikvitetssamling_nn_1_N = mkN "antikvitetssamling" ;
  antimon_nn_1_N = mkN "antimon" ;
  antiskating_nn_1_N = mkN "antiskating" ;
  antydning_nn_1_N = mkN "antydning" ;
  antaendning_nn_1_1_N = mkN "antändning" ;
  anvisning_nn_1_N = mkN "anvisning" ;
  anvaendning_nn_1_1_N = mkN "användning" ;
  anvaendningsloesning_nn_1_1_N = mkN "användningslösning" ;
  apa_nn_1_N = mkN "apa" ;
  apartheidlag_nn_1_N = mkN "apartheidlag" ;
  apelsinklyfta_nn_1_N = mkN "apelsinklyfta" ;
  apelsinmoussetaarta_nn_1_1_N = mkN "apelsinmoussetårta" ;
  aphjaerna_nn_1_1_N = mkN "aphjärna" ;
  aphona_nn_1_N = mkN "aphona" ;
  apmaenniska_nn_1_1_N = mkN "apmänniska" ;
  apollofjaeril_nn_1_1_N = mkN "apollofjäril" ;
  apostrofering_nn_1_N = mkN "apostrofering" ;
  apotekskedja_nn_1_N = mkN "apotekskedja" ;
  appellationsdomstol_nn_1_N = mkN "appellationsdomstol" ;
  appellering_nn_1_N = mkN "appellering" ;
  applicering_nn_1_N = mkN "applicering" ;
  applaadering_nn_1_1_N = mkN "applådering" ;
  applaadaaska_nn_1_1_N = mkN "applådåska" ;
  apportering_nn_1_N = mkN "apportering" ;
  appreciering_nn_1_N = mkN "appreciering" ;
  appretering_nn_1_N = mkN "appretering" ;
  approchering_nn_1_N = mkN "approchering" ;
  approximering_nn_1_N = mkN "approximering" ;
  aprildag_nn_1_N = mkN "aprildag" ;
  aptering_nn_1_N = mkN "aptering" ;
  ara_nn_1_N = mkN "ara" ;
  arabiska_nn_1_N = mkN "arabiska" ;
  arabiska_nn_2_N = mkN "arabiska" ;
  aralia_nn_1_N = mkN "aralia" ;
  arameiska_nn_1_N = mkN "arameiska" ;
  arbetarfoerening_nn_1_1_N = mkN "arbetarförening" ;
  arbetarregering_nn_1_N = mkN "arbetarregering" ;
  arbetsbelastning_nn_1_N = mkN "arbetsbelastning" ;
  arbetsbelysning_nn_1_N = mkN "arbetsbelysning" ;
  arbetsbeskrivning_nn_1_N = mkN "arbetsbeskrivning" ;
  arbetsbaenk_nn_1_1_N = mkN "arbetsbänk" ;
  arbetsboerda_nn_1_1_N = mkN "arbetsbörda" ;
  arbetsdag_nn_1_N = mkN "arbetsdag" ;
  arbetsdelning_nn_1_N = mkN "arbetsdelning" ;
  arbetsdomstol_nn_1_N = mkN "arbetsdomstol" ;
  arbetsfoermedling_nn_1_1_N = mkN "arbetsförmedling" ;
  arbetsfoermaaga_nn_1_1_N = mkN "arbetsförmåga" ;
  arbetsfoermaageutredning_nn_1_1_N = mkN "arbetsförmågeutredning" ;
  arbetsgivarefoerening_nn_1_1_N = mkN "arbetsgivareförening" ;
  arbetsgivarfoerening_nn_1_1_N = mkN "arbetsgivarförening" ;
  arbetsinraettning_nn_1_1_N = mkN "arbetsinrättning" ;
  arbetsjacka_nn_1_N = mkN "arbetsjacka" ;
  arbetskarl_nn_1_N = mkN "arbetskarl" ;
  arbetsmarknadsutbildning_nn_1_N = mkN "arbetsmarknadsutbildning" ;
  arbetsmyra_nn_1_N = mkN "arbetsmyra" ;
  arbetsmaetning_nn_1_1_N = mkN "arbetsmätning" ;
  arbetsordning_nn_1_N = mkN "arbetsordning" ;
  arbetsplatsolycka_nn_1_N = mkN "arbetsplatsolycka" ;
  arbetsskada_nn_1_N = mkN "arbetsskada" ;
  arbetsstyrka_nn_1_N = mkN "arbetsstyrka" ;
  arbetstidsreglering_nn_1_N = mkN "arbetstidsreglering" ;
  arbetstraening_nn_1_1_N = mkN "arbetsträning" ;
  arbetsvecka_nn_1_N = mkN "arbetsvecka" ;
  arbetsvilja_nn_1_N = mkN "arbetsvilja" ;
  arbetsvaerdering_nn_1_1_N = mkN "arbetsvärdering" ;
  area_nn_1_N = mkN "area" ;
  arena_nn_1_N = mkN "arena" ;
  argbigga_nn_1_N = mkN "argbigga" ;
  argentinska_nn_1_N = mkN "argentinska" ;
  argon_nn_1_N = mkN "argon" ;
  argumentering_nn_1_N = mkN "argumentering" ;
  aria_nn_1_N = mkN "aria" ;
  ariadnetraad_nn_1_1_N = mkN "ariadnetråd" ;
  arkaisering_nn_1_N = mkN "arkaisering" ;
  arkebusering_nn_1_N = mkN "arkebusering" ;
  arkivering_nn_1_N = mkN "arkivering" ;
  arkivsamling_nn_1_N = mkN "arkivsamling" ;
  armada_nn_1_N = mkN "armada" ;
  armborstpil_nn_1_N = mkN "armborstpil" ;
  armborstskytt_nn_1_N = mkN "armborstskytt" ;
  armbrytning_nn_1_N = mkN "armbrytning" ;
  armboejning_nn_1_1_N = mkN "armböjning" ;
  armeniska_nn_1_N = mkN "armeniska" ;
  armeniska_nn_2_N = mkN "armeniska" ;
  armering_nn_1_N = mkN "armering" ;
  armflaeta_nn_1_1_N = mkN "armfläta" ;
  armfoting_nn_1_N = mkN "armfoting" ;
  armfoering_nn_1_1_N = mkN "armföring" ;
  armhaevning_nn_1_1_N = mkN "armhävning" ;
  armhaala_nn_1_1_N = mkN "armhåla" ;
  armkrok_nn_1_N = mkN "armkrok" ;
  armring_nn_1_N = mkN "armring" ;
  armskada_nn_1_N = mkN "armskada" ;
  armstyrka_nn_1_N = mkN "armstyrka" ;
  arm_eavdelning_nn_1_1_N = mkN "arméavdelning" ;
  arm_efoerdelning_nn_1_1_N = mkN "arméfördelning" ;
  aromkupa_nn_1_N = mkN "aromkupa" ;
  arrangering_nn_1_N = mkN "arrangering" ;
  arrendering_nn_1_N = mkN "arrendering" ;
  arrestavdelning_nn_1_N = mkN "arrestavdelning" ;
  arrestering_nn_1_N = mkN "arrestering" ;
  arrondering_nn_1_N = mkN "arrondering" ;
  arsenikfoergiftning_nn_1_1_N = mkN "arsenikförgiftning" ;
  artbestaemning_nn_1_1_N = mkN "artbestämning" ;
  artbildning_nn_1_N = mkN "artbildning" ;
  artikulering_nn_1_N = mkN "artikulering" ;
  artilleribeskjutning_nn_1_N = mkN "artilleribeskjutning" ;
  artistbana_nn_1_N = mkN "artistbana" ;
  artonaaring_nn_1_1_N = mkN "artonåring" ;
  artonaarsdag_nn_1_1_N = mkN "artonårsdag" ;
  arvejord_nn_1_N = mkN "arvejord" ;
  arvfoerening_nn_1_1_N = mkN "arvförening" ;
  arvodering_nn_1_N = mkN "arvodering" ;
  arvsmassa_nn_1_N = mkN "arvsmassa" ;
  asagud_nn_1_N = mkN "asagud" ;
  asatro_nn_1_N = mkN "asatro" ;
  asbestcement_nn_1_N = mkN "asbestcement" ;
  asbestlunga_nn_1_N = mkN "asbestlunga" ;
  asbestplatta_nn_1_N = mkN "asbestplatta" ;
  asbestsanering_nn_1_N = mkN "asbestsanering" ;
  asfaltering_nn_1_N = mkN "asfaltering" ;
  asfaltplatta_nn_1_N = mkN "asfaltplatta" ;
  asfyxiskada_nn_1_N = mkN "asfyxiskada" ;
  asiatiska_nn_1_N = mkN "asiatiska" ;
  aska_nn_1_N = mkN "aska" ;
  askorbinsyra_nn_1_N = mkN "askorbinsyra" ;
  associationsbana_nn_1_N = mkN "associationsbana" ;
  associationskedja_nn_1_N = mkN "associationskedja" ;
  assuransspruta_nn_1_N = mkN "assuransspruta" ;
  assyriska_nn_1_N = mkN "assyriska" ;
  assyriska_nn_2_N = mkN "assyriska" ;
  asynja_nn_1_N = mkN "asynja" ;
  atlas_nn_2_N = mkN "atlas" ;
  atlaskota_nn_1_N = mkN "atlaskota" ;
  atombrygga_nn_1_N = mkN "atombrygga" ;
  atomklocka_nn_1_N = mkN "atomklocka" ;
  atomkaerna_nn_1_1_N = mkN "atomkärna" ;
  atommassa_nn_1_N = mkN "atommassa" ;
  atropin_nn_1_N = mkN "atropin" ;
  attach_evaeska_nn_1_1_N = mkN "attachéväska" ;
  attackfoermaaga_nn_1_1_N = mkN "attackförmåga" ;
  attika_nn_1_N = mkN "attika" ;
  attila_nn_1_N = mkN "attila" ;
  au_pair_flicka_nn_1_N = mkN "au-pair-flicka" ;
  auerlampa_nn_1_N = mkN "auerlampa" ;
  auerstrumpa_nn_1_N = mkN "auerstrumpa" ;
  augustidag_nn_1_N = mkN "augustidag" ;
  auktoritetstro_nn_1_N = mkN "auktoritetstro" ;
  aula_nn_1_N = mkN "aula" ;
  australiska_nn_1_N = mkN "australiska" ;
  autostrada_nn_1_N = mkN "autostrada" ;
  ava_nn_1_N = mkN "ava" ;
  avdelningsskoeterska_nn_1_1_N = mkN "avdelningssköterska" ;
  avel_nn_1_N = mkN "avel" ;
  avfallsraavara_nn_1_1_N = mkN "avfallsråvara" ;
  aviga_nn_1_N = mkN "aviga" ;
  avigsida_nn_1_N = mkN "avigsida" ;
  avisa_nn_1_N = mkN "avisa" ;
  avkomma_nn_1_N = mkN "avkomma" ;
  avresa_nn_1_N = mkN "avresa" ;
  avraekningsnota_nn_1_1_N = mkN "avräkningsnota" ;
  avraettningslista_nn_1_1_N = mkN "avrättningslista" ;
  avslappningsskiva_nn_1_N = mkN "avslappningsskiva" ;
  avstaellningsyta_nn_1_1_N = mkN "avställningsyta" ;
  axelboessa_nn_1_1_N = mkN "axelbössa" ;
  axelremsvaeska_nn_1_1_N = mkN "axelremsväska" ;
  axillarkrycka_nn_1_N = mkN "axillarkrycka" ;
  ayatolla_nn_1_N = mkN "ayatolla" ;
  azalea_nn_1_N = mkN "azalea" ;
  azerbajdzjanska_nn_1_N = mkN "azerbajdzjanska" ;
  azerbajdzjanska_nn_2_N = mkN "azerbajdzjanska" ;
  babordsaara_nn_1_1_N = mkN "babordsåra" ;
  babusjka_nn_1_N = mkN "babusjka" ;
  babybyxa_nn_1_N = mkN "babybyxa" ;
  babylycka_nn_1_N = mkN "babylycka" ;
  backa_nn_1_N = mkN "backa" ;
  backgammon_nn_1_N = mkN "backgammon" ;
  backsippa_nn_1_N = mkN "backsippa" ;
  backstuga_nn_1_N = mkN "backstuga" ;
  backsvala_nn_1_N = mkN "backsvala" ;
  backsoeta_nn_1_1_N = mkN "backsöta" ;
  bacon_nn_1_N = mkN "bacon" ;
  badbyxa_nn_1_N = mkN "badbyxa" ;
  badflicka_nn_1_N = mkN "badflicka" ;
  badkappa_nn_1_N = mkN "badkappa" ;
  badklippa_nn_1_N = mkN "badklippa" ;
  badminton_nn_1_N = mkN "badminton" ;
  badmoessa_nn_1_1_N = mkN "badmössa" ;
  badresa_nn_1_N = mkN "badresa" ;
  badsjoe_nn_1_1_N = mkN "badsjö" ;
  badstuga_nn_1_N = mkN "badstuga" ;
  bagage_nn_2_N = mkN "bagage" ;
  bagagekaerra_nn_1_1_N = mkN "bagagekärra" ;
  bagagelucka_nn_1_N = mkN "bagagelucka" ;
  bagarmoessa_nn_1_1_N = mkN "bagarmössa" ;
  bagarstuga_nn_1_N = mkN "bagarstuga" ;
  bahamanska_nn_1_N = mkN "bahamanska" ;
  bahrainska_nn_1_N = mkN "bahrainska" ;
  bajonettbalja_nn_1_N = mkN "bajonettbalja" ;
  bakficka_nn_1_N = mkN "bakficka" ;
  bakfylla_nn_1_N = mkN "bakfylla" ;
  bakgata_nn_1_N = mkN "bakgata" ;
  bakkappa_nn_1_N = mkN "bakkappa" ;
  baklampa_nn_1_N = mkN "baklampa" ;
  baklucka_nn_1_N = mkN "baklucka" ;
  baklaexa_nn_1_1_N = mkN "bakläxa" ;
  bakruta_nn_1_N = mkN "bakruta" ;
  baksida_nn_1_N = mkN "baksida" ;
  baksmaella_nn_1_1_N = mkN "baksmälla" ;
  bakaenda_nn_1_1_N = mkN "bakända" ;
  balalajka_nn_1_N = mkN "balalajka" ;
  balettflicka_nn_1_N = mkN "balettflicka" ;
  balja_nn_1_N = mkN "balja" ;
  ballerina_nn_1_N = mkN "ballerina" ;
  balsa_nn_1_N = mkN "balsa" ;
  baltiska_nn_1_N = mkN "baltiska" ;
  bamba_nn_1_N = mkN "bamba" ;
  bambusoffa_nn_1_N = mkN "bambusoffa" ;
  bana_nn_1_N = mkN "bana" ;
  bananfluga_nn_1_N = mkN "bananfluga" ;
  bandyklubba_nn_1_N = mkN "bandyklubba" ;
  bangladeshiska_nn_1_N = mkN "bangladeshiska" ;
  bankirfirma_nn_1_N = mkN "bankirfirma" ;
  bannbulla_nn_1_N = mkN "bannbulla" ;
  barbadiska_nn_1_N = mkN "barbadiska" ;
  barnafoederska_nn_1_1_N = mkN "barnaföderska" ;
  barnaskara_nn_1_N = mkN "barnaskara" ;
  barnatro_nn_1_N = mkN "barnatro" ;
  barnflicka_nn_1_N = mkN "barnflicka" ;
  barnkammarsaga_nn_1_N = mkN "barnkammarsaga" ;
  barnmisshandel_nn_1_N = mkN "barnmisshandel" ;
  barnmorska_nn_1_N = mkN "barnmorska" ;
  barnpiga_nn_1_N = mkN "barnpiga" ;
  barnporrhaerva_nn_1_1_N = mkN "barnporrhärva" ;
  barnsaga_nn_1_N = mkN "barnsaga" ;
  barnskottkaerra_nn_1_1_N = mkN "barnskottkärra" ;
  barnskoeterska_nn_1_1_N = mkN "barnsköterska" ;
  barnsmugglarliga_nn_1_N = mkN "barnsmugglarliga" ;
  barnsnor_nn_1_N = mkN "barnsnor" ;
  barnstuga_nn_1_N = mkN "barnstuga" ;
  barnsaengskvinna_nn_1_1_N = mkN "barnsängskvinna" ;
  barnvattenkanna_nn_1_N = mkN "barnvattenkanna" ;
  barnvisa_nn_1_N = mkN "barnvisa" ;
  barockpaerla_nn_1_1_N = mkN "barockpärla" ;
  baronessa_nn_1_N = mkN "baronessa" ;
  barrskogsnunna_nn_1_N = mkN "barrskogsnunna" ;
  barrtraedsplanta_nn_1_1_N = mkN "barrträdsplanta" ;
  basilika_nn_1_N = mkN "basilika" ;
  baskiska_nn_1_N = mkN "baskiska" ;
  baskiska_nn_2_N = mkN "baskiska" ;
  basplatta_nn_1_N = mkN "basplatta" ;
  basstraecka_nn_1_1_N = mkN "bassträcka" ;
  basstaemma_nn_1_1_N = mkN "basstämma" ;
  bastmatta_nn_1_N = mkN "bastmatta" ;
  bastrumma_nn_1_N = mkN "bastrumma" ;
  bastuba_nn_1_N = mkN "bastuba" ;
  basvara_nn_1_N = mkN "basvara" ;
  basyta_nn_1_N = mkN "basyta" ;
  batteriklaemma_nn_1_1_N = mkN "batteriklämma" ;
  bazooka_nn_1_N = mkN "bazooka" ;
  bea_nn_1_N = mkN "bea" ;
  bebaadelsedag_nn_1_1_N = mkN "bebådelsedag" ;
  beckpaerla_nn_1_1_N = mkN "beckpärla" ;
  bedragerska_nn_1_N = mkN "bedragerska" ;
  begonia_nn_1_N = mkN "begonia" ;
  begravningskassa_nn_1_N = mkN "begravningskassa" ;
  begraensningsyta_nn_1_1_N = mkN "begränsningsyta" ;
  behaa_nn_1_1_N = mkN "behå" ;
  bekymmersrynka_nn_1_N = mkN "bekymmersrynka" ;
  belastningsskada_nn_1_N = mkN "belastningsskada" ;
  belgiska_nn_1_N = mkN "belgiska" ;
  beliziska_nn_1_N = mkN "beliziska" ;
  belysningsmaessa_nn_1_1_N = mkN "belysningsmässa" ;
  belysningsstyrka_nn_1_N = mkN "belysningsstyrka" ;
  bemaerkelsedag_nn_1_1_N = mkN "bemärkelsedag" ;
  bena_nn_1_N = mkN "bena" ;
  benaska_nn_1_N = mkN "benaska" ;
  benediktinerorden_nn_1_N = mkN "benediktinerorden" ;
  benediktinorden_nn_1_N = mkN "benediktinorden" ;
  bengaedda_nn_1_1_N = mkN "bengädda" ;
  benhinna_nn_1_N = mkN "benhinna" ;
  beninska_nn_1_N = mkN "beninska" ;
  benknota_nn_1_N = mkN "benknota" ;
  benpipa_nn_1_N = mkN "benpipa" ;
  benroeta_nn_1_1_N = mkN "benröta" ;
  benskada_nn_1_N = mkN "benskada" ;
  benskena_nn_1_N = mkN "benskena" ;
  bensoesyra_nn_1_N = mkN "bensoesyra" ;
  berg_och_dalbana_nn_1_N = mkN "berg-och-dalbana" ;
  bergbana_nn_1_N = mkN "bergbana" ;
  berggylta_nn_1_N = mkN "berggylta" ;
  bergolja_nn_1_N = mkN "bergolja" ;
  bergsgorilla_nn_1_N = mkN "bergsgorilla" ;
  bergskedja_nn_1_N = mkN "bergskedja" ;
  bergsklyfta_nn_1_N = mkN "bergsklyfta" ;
  bergskreva_nn_1_N = mkN "bergskreva" ;
  bergssida_nn_1_N = mkN "bergssida" ;
  bergsskola_nn_1_N = mkN "bergsskola" ;
  bergsyra_nn_1_N = mkN "bergsyra" ;
  beraettarfoermaaga_nn_1_1_N = mkN "berättarförmåga" ;
  besksoeta_nn_1_1_N = mkN "besksöta" ;
  beslutsfoermaaga_nn_1_1_N = mkN "beslutsförmåga" ;
  besprutningsvaetska_nn_1_1_N = mkN "besprutningsvätska" ;
  besvaersinlaga_nn_1_1_N = mkN "besvärsinlaga" ;
  beta_nn_1_N = mkN "beta" ;
  betalningsdag_nn_1_N = mkN "betalningsdag" ;
  betalningsvilja_nn_1_N = mkN "betalningsvilja" ;
  betongsugga_nn_1_N = mkN "betongsugga" ;
  bettskena_nn_1_N = mkN "bettskena" ;
  betydelselaera_nn_1_1_N = mkN "betydelselära" ;
  betygsskala_nn_1_N = mkN "betygsskala" ;
  beundrarinna_nn_1_N = mkN "beundrarinna" ;
  bevakningsinlaga_nn_1_N = mkN "bevakningsinlaga" ;
  bevakningskedja_nn_1_N = mkN "bevakningskedja" ;
  bevisboerda_nn_1_1_N = mkN "bevisbörda" ;
  beviskedja_nn_1_N = mkN "beviskedja" ;
  bhutanesiska_nn_1_N = mkN "bhutanesiska" ;
  biavel_nn_1_N = mkN "biavel" ;
  bibana_nn_1_N = mkN "bibana" ;
  bibliofilupplaga_nn_1_N = mkN "bibliofilupplaga" ;
  bibliotekshoegskola_nn_1_1_N = mkN "bibliotekshögskola" ;
  biblomma_nn_1_N = mkN "biblomma" ;
  biceps_nn_1_N = mkN "biceps" ;
  bicepssena_nn_1_N = mkN "bicepssena" ;
  biffyxa_nn_1_N = mkN "biffyxa" ;
  bigata_nn_1_N = mkN "bigata" ;
  bihuva_nn_1_N = mkN "bihuva" ;
  bihaala_nn_1_1_N = mkN "bihåla" ;
  bikarbonat_nn_1_N = mkN "bikarbonat" ;
  bikrona_nn_1_N = mkN "bikrona" ;
  bikupa_nn_1_N = mkN "bikupa" ;
  bila_nn_1_N = mkN "bila" ;
  bilaga_nn_1_N = mkN "bilaga" ;
  bilbana_nn_1_N = mkN "bilbana" ;
  bildgaata_nn_1_1_N = mkN "bildgåta" ;
  bildkarta_nn_1_N = mkN "bildkarta" ;
  bildningsvaerme_nn_1_1_N = mkN "bildningsvärme" ;
  bildruta_nn_1_N = mkN "bildruta" ;
  bilfaerja_nn_1_1_N = mkN "bilfärja" ;
  biljettficka_nn_1_N = mkN "biljettficka" ;
  biljetthaerva_nn_1_1_N = mkN "biljetthärva" ;
  biljettlucka_nn_1_N = mkN "biljettlucka" ;
  bilkarta_nn_1_N = mkN "bilkarta" ;
  billa_nn_1_N = mkN "billa" ;
  billampa_nn_1_N = mkN "billampa" ;
  billighetsupplaga_nn_1_N = mkN "billighetsupplaga" ;
  billykta_nn_1_N = mkN "billykta" ;
  bilolycka_nn_1_N = mkN "bilolycka" ;
  bilruta_nn_1_N = mkN "bilruta" ;
  bilsjuka_nn_1_N = mkN "bilsjuka" ;
  bilskola_nn_1_N = mkN "bilskola" ;
  bilslaepkaerra_nn_1_1_N = mkN "bilsläpkärra" ;
  bilyxa_nn_1_N = mkN "bilyxa" ;
  binda_nn_1_N = mkN "binda" ;
  bindehinna_nn_1_N = mkN "bindehinna" ;
  bindsula_nn_1_N = mkN "bindsula" ;
  bindvaevshinna_nn_1_1_N = mkN "bindvävshinna" ;
  binga_nn_1_N = mkN "binga" ;
  bingobricka_nn_1_N = mkN "bingobricka" ;
  binka_nn_1_N = mkN "binka" ;
  biomassa_nn_1_N = mkN "biomassa" ;
  bira_nn_1_N = mkN "bira" ;
  bisamraatta_nn_1_1_N = mkN "bisamråtta" ;
  biskopskraeckla_nn_1_1_N = mkN "biskopskräckla" ;
  biskopskraekla_nn_1_1_N = mkN "biskopskräkla" ;
  biskopsmoessa_nn_1_1_N = mkN "biskopsmössa" ;
  bissauguineanska_nn_1_N = mkN "bissauguineanska" ;
  bisyssla_nn_1_N = mkN "bisyssla" ;
  bittermandelolja_nn_1_N = mkN "bittermandelolja" ;
  bittersoeta_nn_1_1_N = mkN "bittersöta" ;
  bjugg_nn_1_N = mkN "bjugg" ;
  bjaellra_nn_1_1_N = mkN "bjällra" ;
  bjoerkna_nn_1_1_N = mkN "björkna" ;
  bjoernfloka_nn_1_1_N = mkN "björnfloka" ;
  bjoernhona_nn_1_1_N = mkN "björnhona" ;
  bjoerninna_nn_1_1_N = mkN "björninna" ;
  bjoernloka_nn_1_1_N = mkN "björnloka" ;
  bjoernskinnsmoessa_nn_1_1_N = mkN "björnskinnsmössa" ;
  bladloppa_nn_1_N = mkN "bladloppa" ;
  bladmossa_nn_1_N = mkN "bladmossa" ;
  bladskaerarmyra_nn_1_1_N = mkN "bladskärarmyra" ;
  blaffa_nn_1_N = mkN "blaffa" ;
  blanddricka_nn_1_N = mkN "blanddricka" ;
  blanka_nn_1_N = mkN "blanka" ;
  blanksmoerja_nn_1_1_N = mkN "blanksmörja" ;
  blaska_nn_1_N = mkN "blaska" ;
  bleke_nn_1_N = mkN "bleke" ;
  blekingseka_nn_1_N = mkN "blekingseka" ;
  blekingska_nn_1_N = mkN "blekingska" ;
  blekingska_nn_2_N = mkN "blekingska" ;
  blekvaetska_nn_1_1_N = mkN "blekvätska" ;
  blemma_nn_1_N = mkN "blemma" ;
  blida_nn_1_N = mkN "blida" ;
  blinda_nn_1_N = mkN "blinda" ;
  blindbotten_nn_1_N = mkN "blindbotten" ;
  blindgata_nn_1_N = mkN "blindgata" ;
  blindkarta_nn_1_N = mkN "blindkarta" ;
  blindlykta_nn_1_N = mkN "blindlykta" ;
  blindnaessla_nn_1_1_N = mkN "blindnässla" ;
  blindpipa_nn_1_N = mkN "blindpipa" ;
  blindskola_nn_1_N = mkN "blindskola" ;
  blinkhinna_nn_1_N = mkN "blinkhinna" ;
  blixtlampa_nn_1_N = mkN "blixtlampa" ;
  blockalmanacka_nn_1_N = mkN "blockalmanacka" ;
  blockskiva_nn_1_N = mkN "blockskiva" ;
  blocktalja_nn_1_N = mkN "blocktalja" ;
  blocktrissa_nn_1_N = mkN "blocktrissa" ;
  blod_nn_1_N = mkN "blod" ;
  blodblaasa_nn_1_1_N = mkN "blodblåsa" ;
  blodnaeva_nn_1_1_N = mkN "blodnäva" ;
  blodplasma_nn_1_N = mkN "blodplasma" ;
  blodriska_nn_1_N = mkN "blodriska" ;
  blodsockersvacka_nn_1_N = mkN "blodsockersvacka" ;
  blodvaetska_nn_1_1_N = mkN "blodvätska" ;
  blombotten_nn_1_N = mkN "blombotten" ;
  blomkrona_nn_1_N = mkN "blomkrona" ;
  blomkruka_nn_1_N = mkN "blomkruka" ;
  blomlaada_nn_1_1_N = mkN "blomlåda" ;
  blomma_nn_1_N = mkN "blomma" ;
  blomplanta_nn_1_N = mkN "blomplanta" ;
  blomsterflicka_nn_1_N = mkN "blomsterflicka" ;
  blomsterfoersaeljerska_nn_1_1_N = mkN "blomsterförsäljerska" ;
  blomsterlaada_nn_1_1_N = mkN "blomsterlåda" ;
  blomsterspruta_nn_1_N = mkN "blomsterspruta" ;
  blotta_nn_1_N = mkN "blotta" ;
  bluffaktura_nn_1_N = mkN "bluffaktura" ;
  blunddocka_nn_1_N = mkN "blunddocka" ;
  blyaska_nn_1_N = mkN "blyaska" ;
  blyblomma_nn_1_N = mkN "blyblomma" ;
  blyertspenna_nn_1_N = mkN "blyertspenna" ;
  blyglete_nn_1_N = mkN "blyglete" ;
  blykula_nn_1_N = mkN "blykula" ;
  blaecka_nn_1_1_N = mkN "bläcka" ;
  blaeckblaasa_nn_1_1_N = mkN "bläckblåsa" ;
  blaeckpenna_nn_1_1_N = mkN "bläckpenna" ;
  blaeddra_nn_1_1_N = mkN "bläddra" ;
  blaendskiva_nn_1_1_N = mkN "bländskiva" ;
  blaabaerspannkaka_nn_1_1_N = mkN "blåbärspannkaka" ;
  blaaduva_nn_1_1_N = mkN "blåduva" ;
  blaaholts_nn_1_1_N = mkN "blåholts" ;
  blaajacka_nn_1_1_N = mkN "blåjacka" ;
  blaaklocka_nn_1_1_N = mkN "blåklocka" ;
  blaakopia_nn_1_1_N = mkN "blåkopia" ;
  blaakraaka_nn_1_1_N = mkN "blåkråka" ;
  blaamussla_nn_1_1_N = mkN "blåmussla" ;
  blaapenna_nn_1_1_N = mkN "blåpenna" ;
  blaasa_nn_1_1_N = mkN "blåsa" ;
  blaasippa_nn_1_1_N = mkN "blåsippa" ;
  blaaslampa_nn_1_1_N = mkN "blåslampa" ;
  blaastrumpa_nn_1_1_N = mkN "blåstrumpa" ;
  blaasyra_nn_1_1_N = mkN "blåsyra" ;
  blaatira_nn_1_1_N = mkN "blåtira" ;
  blaatunga_nn_1_1_N = mkN "blåtunga" ;
  bloeja_nn_1_1_N = mkN "blöja" ;
  bloejaalder_nn_1_1_N = mkN "blöjålder" ;
  bloetroeta_nn_1_1_N = mkN "blötröta" ;
  boa_nn_1_N = mkN "boa" ;
  bobba_nn_1_N = mkN "bobba" ;
  bockbro_nn_1_N = mkN "bockbro" ;
  bodega_nn_1_N = mkN "bodega" ;
  bodlaenga_nn_1_1_N = mkN "bodlänga" ;
  bogserlina_nn_1_N = mkN "bogserlina" ;
  bohuseka_nn_1_N = mkN "bohuseka" ;
  bohuslaenska_nn_1_1_N = mkN "bohuslänska" ;
  bohuslaenska_nn_2_1_N = mkN "bohuslänska" ;
  boja_nn_1_N = mkN "boja" ;
  bokhylla_nn_1_N = mkN "bokhylla" ;
  boklaada_nn_1_1_N = mkN "boklåda" ;
  bokmaessa_nn_1_1_N = mkN "bokmässa" ;
  bokrea_nn_1_N = mkN "bokrea" ;
  boksida_nn_1_N = mkN "boksida" ;
  bokstavstro_nn_1_N = mkN "bokstavstro" ;
  bolagsstaemma_nn_1_1_N = mkN "bolagsstämma" ;
  bolivianska_nn_1_N = mkN "bolivianska" ;
  bolaaneraenta_nn_1_1_N = mkN "bolåneränta" ;
  bombmatta_nn_1_N = mkN "bombmatta" ;
  bomolja_nn_1_N = mkN "bomolja" ;
  bomullsfroekaka_nn_1_1_N = mkN "bomullsfrökaka" ;
  bomullsfroeolja_nn_1_1_N = mkN "bomullsfröolja" ;
  bomullsskjorta_nn_1_N = mkN "bomullsskjorta" ;
  bondboena_nn_1_1_N = mkN "bondböna" ;
  bondepraktika_nn_1_N = mkN "bondepraktika" ;
  bondflicka_nn_1_N = mkN "bondflicka" ;
  bondmora_nn_1_N = mkN "bondmora" ;
  bondska_nn_1_N = mkN "bondska" ;
  bondstuga_nn_1_N = mkN "bondstuga" ;
  bondtolva_nn_1_N = mkN "bondtolva" ;
  bondvischa_nn_1_N = mkN "bondvischa" ;
  bongotrumma_nn_1_N = mkN "bongotrumma" ;
  boprisbubbla_nn_1_N = mkN "boprisbubbla" ;
  bordeauxvaetska_nn_1_1_N = mkN "bordeauxvätska" ;
  bordskiva_nn_1_N = mkN "bordskiva" ;
  bordskrydda_nn_1_N = mkN "bordskrydda" ;
  bordslampa_nn_1_N = mkN "bordslampa" ;
  bordsskiva_nn_1_N = mkN "bordsskiva" ;
  borgarskola_nn_1_N = mkN "borgarskola" ;
  borgenssumma_nn_1_N = mkN "borgenssumma" ;
  boricka_nn_1_N = mkN "boricka" ;
  borrklinka_nn_1_N = mkN "borrklinka" ;
  borrkrona_nn_1_N = mkN "borrkrona" ;
  borrkaerna_nn_1_1_N = mkN "borrkärna" ;
  borrmussla_nn_1_N = mkN "borrmussla" ;
  borrningsolycka_nn_1_N = mkN "borrningsolycka" ;
  borstnejlika_nn_1_N = mkN "borstnejlika" ;
  borsyra_nn_1_N = mkN "borsyra" ;
  bortresa_nn_1_N = mkN "bortresa" ;
  bortaenda_nn_1_1_N = mkN "bortända" ;
  bosniska_nn_1_N = mkN "bosniska" ;
  bostadsbubbla_nn_1_N = mkN "bostadsbubbla" ;
  bostadslaenga_nn_1_1_N = mkN "bostadslänga" ;
  bostongurka_nn_1_N = mkN "bostongurka" ;
  botox_nn_1_N = mkN "botox" ;
  botswanska_nn_1_N = mkN "botswanska" ;
  botten_nn_1_N = mkN "botten" ;
  bottenplatta_nn_1_N = mkN "bottenplatta" ;
  bottenskola_nn_1_N = mkN "bottenskola" ;
  bottenskrapa_nn_1_N = mkN "bottenskrapa" ;
  bottenskyla_nn_1_N = mkN "bottenskyla" ;
  bottenyta_nn_1_N = mkN "bottenyta" ;
  bowlingbana_nn_1_N = mkN "bowlingbana" ;
  bracka_nn_1_N = mkN "bracka" ;
  brakskiva_nn_1_N = mkN "brakskiva" ;
  bralla_nn_1_N = mkN "bralla" ;
  brandbotten_nn_1_N = mkN "brandbotten" ;
  brandfackla_nn_1_N = mkN "brandfackla" ;
  brandgata_nn_1_N = mkN "brandgata" ;
  brandskada_nn_1_N = mkN "brandskada" ;
  brandspruta_nn_1_N = mkN "brandspruta" ;
  brandstyrka_nn_1_N = mkN "brandstyrka" ;
  branschvana_nn_1_N = mkN "branschvana" ;
  brasa_nn_1_N = mkN "brasa" ;
  brasilianska_nn_1_N = mkN "brasilianska" ;
  bravuraria_nn_1_N = mkN "bravuraria" ;
  braxen_nn_1_N = mkN "braxen" ;
  braxenmygga_nn_1_N = mkN "braxenmygga" ;
  braxenpanka_nn_1_N = mkN "braxenpanka" ;
  breccia_nn_1_N = mkN "breccia" ;
  bredsida_nn_1_N = mkN "bredsida" ;
  bretagniska_nn_1_N = mkN "bretagniska" ;
  bretagniska_nn_2_N = mkN "bretagniska" ;
  bretonska_nn_1_N = mkN "bretonska" ;
  bretonska_nn_2_N = mkN "bretonska" ;
  brevduva_nn_1_N = mkN "brevduva" ;
  brevfraaga_nn_1_1_N = mkN "brevfråga" ;
  brevlaada_nn_1_1_N = mkN "brevlåda" ;
  brevskola_nn_1_N = mkN "brevskola" ;
  bricka_nn_1_N = mkN "bricka" ;
  briljantin_nn_1_N = mkN "briljantin" ;
  bringa_nn_1_N = mkN "bringa" ;
  brinnstraecka_nn_1_1_N = mkN "brinnsträcka" ;
  bristvara_nn_1_N = mkN "bristvara" ;
  brittiska_nn_1_N = mkN "brittiska" ;
  brittmaessa_nn_1_1_N = mkN "brittmässa" ;
  bro_nn_1_N = mkN "bro" ;
  brobana_nn_1_N = mkN "brobana" ;
  brokista_nn_1_N = mkN "brokista" ;
  brolla_nn_1_N = mkN "brolla" ;
  bromelia_nn_1_N = mkN "bromelia" ;
  bromsolja_nn_1_N = mkN "bromsolja" ;
  bromsskiva_nn_1_N = mkN "bromsskiva" ;
  bromsstraecka_nn_1_1_N = mkN "bromssträcka" ;
  bromstrumma_nn_1_N = mkN "bromstrumma" ;
  bromsvaetska_nn_1_1_N = mkN "bromsvätska" ;
  bromvaetesyra_nn_1_1_N = mkN "bromvätesyra" ;
  bronskanna_nn_1_N = mkN "bronskanna" ;
  bronstavla_nn_1_N = mkN "bronstavla" ;
  bronsaalder_nn_1_1_N = mkN "bronsålder" ;
  bronsaaldersmaenniska_nn_1_1_N = mkN "bronsåldersmänniska" ;
  broolycka_nn_1_N = mkN "broolycka" ;
  broplanka_nn_1_N = mkN "broplanka" ;
  brorsa_nn_1_N = mkN "brorsa" ;
  broskhinna_nn_1_N = mkN "broskhinna" ;
  broskskiva_nn_1_N = mkN "broskskiva" ;
  brottsjoe_nn_1_1_N = mkN "brottsjö" ;
  brottyta_nn_1_N = mkN "brottyta" ;
  brudfraemma_nn_1_1_N = mkN "brudfrämma" ;
  brudgaava_nn_1_1_N = mkN "brudgåva" ;
  brudkrona_nn_1_N = mkN "brudkrona" ;
  brudsloeja_nn_1_1_N = mkN "brudslöja" ;
  brudtaerna_nn_1_1_N = mkN "brudtärna" ;
  bruksvaerdeshyra_nn_1_1_N = mkN "bruksvärdeshyra" ;
  bruneiska_nn_1_N = mkN "bruneiska" ;
  brunkulla_nn_1_N = mkN "brunkulla" ;
  brunroeta_nn_1_1_N = mkN "brunröta" ;
  brunskjorta_nn_1_N = mkN "brunskjorta" ;
  brunskaera_nn_1_1_N = mkN "brunskära" ;
  brutta_nn_1_N = mkN "brutta" ;
  brygga_nn_1_N = mkN "brygga" ;
  brynja_nn_1_N = mkN "brynja" ;
  brysselmatta_nn_1_N = mkN "brysselmatta" ;
  brytboena_nn_1_1_N = mkN "brytböna" ;
  brytningsfoermaaga_nn_1_1_N = mkN "brytningsförmåga" ;
  braeken_nn_1_1_N = mkN "bräken" ;
  braennblaasa_nn_1_1_N = mkN "brännblåsa" ;
  braennlack_nn_1_1_N = mkN "brännlack" ;
  braennolja_nn_1_1_N = mkN "brännolja" ;
  braennskada_nn_1_1_N = mkN "brännskada" ;
  braennvinsnaesa_nn_1_1_N = mkN "brännvinsnäsa" ;
  braennyta_nn_1_1_N = mkN "brännyta" ;
  braennaessla_nn_1_1_N = mkN "brännässla" ;
  braesma_nn_1_1_N = mkN "bräsma" ;
  braess_nn_1_1_N = mkN "bräss" ;
  braaka_nn_1_1_N = mkN "bråka" ;
  braate_nn_1_1_N = mkN "bråte" ;
  broedkaka_nn_1_1_N = mkN "brödkaka" ;
  broedskiva_nn_1_1_N = mkN "brödskiva" ;
  broedsmula_nn_1_1_N = mkN "brödsmula" ;
  broellopsgaava_nn_1_1_N = mkN "bröllopsgåva" ;
  broellopsresa_nn_1_1_N = mkN "bröllopsresa" ;
  broellopstaarta_nn_1_1_N = mkN "bröllopstårta" ;
  broellopsyra_nn_1_1_N = mkN "bröllopsyra" ;
  broesta_nn_1_1_N = mkN "brösta" ;
  broestfena_nn_1_1_N = mkN "bröstfena" ;
  broestficka_nn_1_1_N = mkN "bröstficka" ;
  broesthaala_nn_1_1_N = mkN "brösthåla" ;
  broestkota_nn_1_1_N = mkN "bröstkota" ;
  broestvaarta_nn_1_1_N = mkN "bröstvårta" ;
  bubbla_nn_1_N = mkN "bubbla" ;
  buckla_nn_1_N = mkN "buckla" ;
  buddha_nn_1_N = mkN "buddha" ;
  budgetresa_nn_1_N = mkN "budgetresa" ;
  buffa_nn_1_N = mkN "buffa" ;
  buffaopera_nn_1_N = mkN "buffaopera" ;
  buffringsfoermaaga_nn_1_1_N = mkN "buffringsförmåga" ;
  bukhinna_nn_1_N = mkN "bukhinna" ;
  bukhaala_nn_1_1_N = mkN "bukhåla" ;
  bukspott_nn_1_N = mkN "bukspott" ;
  bula_nn_1_N = mkN "bula" ;
  buldan_nn_1_N = mkN "buldan" ;
  bulgariska_nn_1_N = mkN "bulgariska" ;
  bulgariska_nn_2_N = mkN "bulgariska" ;
  bulgur_nn_1_N = mkN "bulgur" ;
  bulla_nn_1_N = mkN "bulla" ;
  bullermatta_nn_1_N = mkN "bullermatta" ;
  bullerskada_nn_1_N = mkN "bullerskada" ;
  bullshit_nn_1_N = mkN "bullshit" ;
  bunkringsolja_nn_1_N = mkN "bunkringsolja" ;
  burka_nn_1_N = mkN "burka" ;
  burkinska_nn_1_N = mkN "burkinska" ;
  burmanska_nn_1_N = mkN "burmanska" ;
  burmanska_nn_2_N = mkN "burmanska" ;
  burmesiska_nn_1_N = mkN "burmesiska" ;
  burmesiska_nn_2_N = mkN "burmesiska" ;
  burundiska_nn_1_N = mkN "burundiska" ;
  buskskvaetta_nn_1_1_N = mkN "buskskvätta" ;
  bussresa_nn_1_N = mkN "bussresa" ;
  buteljbotten_nn_1_N = mkN "buteljbotten" ;
  butikskedja_nn_1_N = mkN "butikskedja" ;
  butterkaka_nn_1_N = mkN "butterkaka" ;
  bygata_nn_1_N = mkN "bygata" ;
  byggfirma_nn_1_N = mkN "byggfirma" ;
  bygglaada_nn_1_1_N = mkN "bygglåda" ;
  byggnadsbraate_nn_1_1_N = mkN "byggnadsbråte" ;
  byggnadsfirma_nn_1_N = mkN "byggnadsfirma" ;
  bykgryta_nn_1_N = mkN "bykgryta" ;
  byracka_nn_1_N = mkN "byracka" ;
  byraa_nn_1_1_N = mkN "byrå" ;
  byraalaada_nn_1_1_N = mkN "byrålåda" ;
  byskola_nn_1_N = mkN "byskola" ;
  byssja_nn_1_N = mkN "byssja" ;
  bystaemma_nn_1_1_N = mkN "bystämma" ;
  byteshandel_nn_1_N = mkN "byteshandel" ;
  bytesvara_nn_1_N = mkN "bytesvara" ;
  bytta_nn_1_N = mkN "bytta" ;
  byxa_nn_1_N = mkN "byxa" ;
  byxficka_nn_1_N = mkN "byxficka" ;
  byxhaella_nn_1_1_N = mkN "byxhälla" ;
  byxklaemma_nn_1_1_N = mkN "byxklämma" ;
  byxklaada_nn_1_1_N = mkN "byxklåda" ;
  baeddjacka_nn_1_1_N = mkN "bäddjacka" ;
  baeddsoffa_nn_1_1_N = mkN "bäddsoffa" ;
  baelgkamera_nn_1_1_N = mkN "bälgkamera" ;
  baelta_nn_1_1_N = mkN "bälta" ;
  baernstenssyra_nn_1_1_N = mkN "bärnstenssyra" ;
  baers_nn_1_1_N = mkN "bärs" ;
  baersa_nn_1_1_N = mkN "bärsa" ;
  baersa_nn_2_1_N = mkN "bärsa" ;
  baest_foere_dag_nn_1_1_N = mkN "bäst-före-dag" ;
  baestfoere_dag_nn_1_1_N = mkN "bästföre-dag" ;
  baestfoeredag_nn_1_1_N = mkN "bästföredag" ;
  baestsaeljarlista_nn_1_1_N = mkN "bästsäljarlista" ;
  baevergaell_nn_1_1_N = mkN "bävergäll" ;
  baevernylon_nn_1_1_N = mkN "bävernylon" ;
  baeverraatta_nn_1_1_N = mkN "bäverråtta" ;
  baada_nn_1_1_N = mkN "båda" ;
  baagbro_nn_1_1_N = mkN "bågbro" ;
  baaglampa_nn_1_1_N = mkN "båglampa" ;
  baarlaerka_nn_1_1_N = mkN "bårlärka" ;
  baatbotten_nn_1_1_N = mkN "båtbotten" ;
  baatbrygga_nn_1_1_N = mkN "båtbrygga" ;
  baatmaessa_nn_1_1_N = mkN "båtmässa" ;
  baatmoessa_nn_1_1_N = mkN "båtmössa" ;
  baatresa_nn_1_1_N = mkN "båtresa" ;
  baatvagga_nn_1_1_N = mkN "båtvagga" ;
  baatyxa_nn_1_1_N = mkN "båtyxa" ;
  boelja_nn_1_1_N = mkN "bölja" ;
  boena_nn_1_1_N = mkN "böna" ;
  boenematta_nn_1_1_N = mkN "bönematta" ;
  boenskida_nn_1_1_N = mkN "bönskida" ;
  boerda_nn_1_1_N = mkN "börda" ;
  boerdsadel_nn_1_1_N = mkN "bördsadel" ;
  boersoro_nn_1_1_N = mkN "börsoro" ;
  boersyra_nn_1_1_N = mkN "börsyra" ;
  boessa_nn_1_1_N = mkN "bössa" ;
  boetessumma_nn_1_1_N = mkN "bötessumma" ;
  boevel_nn_1_1_N = mkN "bövel" ;
  cafeteria_nn_1_N = mkN "cafeteria" ;
  caldera_nn_1_N = mkN "caldera" ;
  camorra_nn_1_N = mkN "camorra" ;
  campinglampa_nn_1_N = mkN "campinglampa" ;
  campingstuga_nn_1_N = mkN "campingstuga" ;
  cancerfara_nn_1_N = mkN "cancerfara" ;
  cantilena_nn_1_N = mkN "cantilena" ;
  casanova_nn_1_N = mkN "casanova" ;
  cavatina_nn_1_N = mkN "cavatina" ;
  cedroolja_nn_1_N = mkN "cedroolja" ;
  celesta_nn_1_N = mkN "celesta" ;
  cella_nn_1_N = mkN "cella" ;
  cellkaerna_nn_1_1_N = mkN "cellkärna" ;
  cellofan_nn_1_N = mkN "cellofan" ;
  cellstoff_nn_1_N = mkN "cellstoff" ;
  cement_nn_1_N = mkN "cement" ;
  centimeterskala_nn_1_N = mkN "centimeterskala" ;
  centralafrikanska_nn_1_N = mkN "centralafrikanska" ;
  centralkyrka_nn_1_N = mkN "centralkyrka" ;
  centralskola_nn_1_N = mkN "centralskola" ;
  cerebrospinalvaetska_nn_1_1_N = mkN "cerebrospinalvätska" ;
  chagrin_nn_1_N = mkN "chagrin" ;
  chagraeng_nn_1_1_N = mkN "chagräng" ;
  champagnebaksmaella_nn_1_1_N = mkN "champagnebaksmälla" ;
  champagneflaska_nn_1_N = mkN "champagneflaska" ;
  charkuterivara_nn_1_N = mkN "charkuterivara" ;
  charkvara_nn_1_N = mkN "charkvara" ;
  charterresa_nn_1_N = mkN "charterresa" ;
  checklista_nn_1_N = mkN "checklista" ;
  checksumma_nn_1_N = mkN "checksumma" ;
  chilenska_nn_1_N = mkN "chilenska" ;
  chinchilla_nn_1_N = mkN "chinchilla" ;
  chokladkaka_nn_1_N = mkN "chokladkaka" ;
  chokladlycka_nn_1_N = mkN "chokladlycka" ;
  chokladtaarta_nn_1_1_N = mkN "chokladtårta" ;
  cigarettlimpa_nn_1_N = mkN "cigarettlimpa" ;
  cigarrettlimpa_nn_1_N = mkN "cigarrettlimpa" ;
  cigarrlaada_nn_1_1_N = mkN "cigarrlåda" ;
  cikada_nn_1_N = mkN "cikada" ;
  ciklidfiskfauna_nn_1_N = mkN "ciklidfiskfauna" ;
  cineraria_nn_1_N = mkN "cineraria" ;
  cirkelbana_nn_1_N = mkN "cirkelbana" ;
  cirkusarena_nn_1_N = mkN "cirkusarena" ;
  cistercienserorden_nn_1_N = mkN "cistercienserorden" ;
  cisterciensorden_nn_1_N = mkN "cisterciensorden" ;
  citronfjaeril_nn_1_1_N = mkN "citronfjäril" ;
  citrongraesolja_nn_1_1_N = mkN "citrongräsolja" ;
  citronolja_nn_1_N = mkN "citronolja" ;
  citronsyra_nn_1_N = mkN "citronsyra" ;
  cittra_nn_1_N = mkN "cittra" ;
  cittra_nn_2_N = mkN "cittra" ;
  coca_nn_1_N = mkN "coca" ;
  cocacola_nn_1_N = mkN "cocacola" ;
  cokacola_nn_1_N = mkN "cokacola" ;
  cokakola_nn_1_N = mkN "cokakola" ;
  cola_nn_1_N = mkN "cola" ;
  collegeflicka_nn_1_N = mkN "collegeflicka" ;
  collegetroeja_nn_1_1_N = mkN "collegetröja" ;
  colombianska_nn_1_N = mkN "colombianska" ;
  comoriska_nn_1_N = mkN "comoriska" ;
  costaricanska_nn_1_N = mkN "costaricanska" ;
  couronne_nn_1_N = mkN "couronne" ;
  cous_cous_nn_1_N = mkN "cous-cous" ;
  couscous_nn_1_N = mkN "couscous" ;
  cricketklubba_nn_1_N = mkN "cricketklubba" ;
  curia_nn_1_N = mkN "curia" ;
  currygryta_nn_1_N = mkN "currygryta" ;
  cyan_nn_1_N = mkN "cyan" ;
  cyanvaetesyra_nn_1_1_N = mkN "cyanvätesyra" ;
  cykelbana_nn_1_N = mkN "cykelbana" ;
  cykelkedja_nn_1_N = mkN "cykelkedja" ;
  cykelklaemma_nn_1_1_N = mkN "cykelklämma" ;
  cykellykta_nn_1_N = mkN "cykellykta" ;
  cypriotiska_nn_1_N = mkN "cypriotiska" ;
  cysta_nn_1_N = mkN "cysta" ;
  cytoplasma_nn_1_N = mkN "cytoplasma" ;
  dadda_nn_1_N = mkN "dadda" ;
  dag_nn_1_N = mkN "dag" ;
  dagfjaeril_nn_1_1_N = mkN "dagfjäril" ;
  daggkaapa_nn_1_1_N = mkN "daggkåpa" ;
  dagisfroeken_nn_1_1_N = mkN "dagisfröken" ;
  daglega_nn_1_N = mkN "daglega" ;
  dagligstuga_nn_1_N = mkN "dagligstuga" ;
  dagligvara_nn_1_N = mkN "dagligvara" ;
  dagmamma_nn_1_N = mkN "dagmamma" ;
  dagskassa_nn_1_N = mkN "dagskassa" ;
  dagslaenda_nn_1_1_N = mkN "dagslända" ;
  dagsresa_nn_1_N = mkN "dagsresa" ;
  dahlia_nn_1_N = mkN "dahlia" ;
  dalbotten_nn_1_N = mkN "dalbotten" ;
  dalkjusa_nn_1_N = mkN "dalkjusa" ;
  dalkulla_nn_1_N = mkN "dalkulla" ;
  dalripa_nn_1_N = mkN "dalripa" ;
  dalska_nn_1_N = mkN "dalska" ;
  dalslaendska_nn_1_1_N = mkN "dalsländska" ;
  dalslaendska_nn_2_1_N = mkN "dalsländska" ;
  dalsaenka_nn_1_1_N = mkN "dalsänka" ;
  damaskenerklinga_nn_1_N = mkN "damaskenerklinga" ;
  dambinda_nn_1_N = mkN "dambinda" ;
  damfrisoerska_nn_1_1_N = mkN "damfrisörska" ;
  dammgoemma_nn_1_1_N = mkN "dammgömma" ;
  dammlucka_nn_1_N = mkN "dammlucka" ;
  dammlunga_nn_1_N = mkN "dammlunga" ;
  dammraatta_nn_1_1_N = mkN "dammråtta" ;
  dammtrasa_nn_1_N = mkN "dammtrasa" ;
  dammussla_nn_1_N = mkN "dammussla" ;
  dammvippa_nn_1_N = mkN "dammvippa" ;
  damsida_nn_1_N = mkN "damsida" ;
  damskjorta_nn_1_N = mkN "damskjorta" ;
  damstrumpa_nn_1_N = mkN "damstrumpa" ;
  damvaeska_nn_1_1_N = mkN "damväska" ;
  dansbana_nn_1_N = mkN "dansbana" ;
  dansbandsvecka_nn_1_N = mkN "dansbandsvecka" ;
  danska_nn_1_N = mkN "danska" ;
  danska_nn_2_N = mkN "danska" ;
  dansskola_nn_1_N = mkN "dansskola" ;
  darrocka_nn_1_N = mkN "darrocka" ;
  darttavla_nn_1_N = mkN "darttavla" ;
  data_nn_2_N = mkN "data" ;
  datormaessa_nn_1_1_N = mkN "datormässa" ;
  davidsstjaerna_nn_1_1_N = mkN "davidsstjärna" ;
  debetsida_nn_1_N = mkN "debetsida" ;
  deja_nn_1_N = mkN "deja" ;
  dekorationsbrasa_nn_1_N = mkN "dekorationsbrasa" ;
  delstraecka_nn_1_1_N = mkN "delsträcka" ;
  denim_nn_1_N = mkN "denim" ;
  derivata_nn_1_N = mkN "derivata" ;
  designskola_nn_1_N = mkN "designskola" ;
  detaljfraaga_nn_1_1_N = mkN "detaljfråga" ;
  detaljhandel_nn_1_N = mkN "detaljhandel" ;
  detaljkarta_nn_1_N = mkN "detaljkarta" ;
  dia_nn_1_N = mkN "dia" ;
  diakonissa_nn_1_N = mkN "diakonissa" ;
  dieselolja_nn_1_N = mkN "dieselolja" ;
  digitalkamera_nn_1_N = mkN "digitalkamera" ;
  digitallaada_nn_1_1_N = mkN "digitallåda" ;
  dildo_nn_1_N = mkN "dildo" ;
  dille_nn_1_N = mkN "dille" ;
  dillkrona_nn_1_N = mkN "dillkrona" ;
  dimma_nn_1_N = mkN "dimma" ;
  dimsloeja_nn_1_1_N = mkN "dimslöja" ;
  discokula_nn_1_N = mkN "discokula" ;
  diskbalja_nn_1_N = mkN "diskbalja" ;
  diskblomma_nn_1_N = mkN "diskblomma" ;
  diskho_nn_1_N = mkN "diskho" ;
  diskontnota_nn_1_N = mkN "diskontnota" ;
  disktrasa_nn_1_N = mkN "disktrasa" ;
  distanshoegskola_nn_1_1_N = mkN "distanshögskola" ;
  ditresa_nn_1_N = mkN "ditresa" ;
  diva_nn_1_N = mkN "diva" ;
  divisionsfana_nn_1_N = mkN "divisionsfana" ;
  djiboutiska_nn_1_N = mkN "djiboutiska" ;
  djuphavsbotten_nn_1_N = mkN "djuphavsbotten" ;
  djurblod_nn_1_N = mkN "djurblod" ;
  djurraettsfraaga_nn_1_1_N = mkN "djurrättsfråga" ;
  dna_kedja_nn_1_N = mkN "dna-kedja" ;
  docka_nn_1_N = mkN "docka" ;
  doft_nn_2_N = mkN "doft" ;
  doja_nn_1_N = mkN "doja" ;
  doktorska_nn_1_N = mkN "doktorska" ;
  dokusaapa_nn_1_1_N = mkN "dokusåpa" ;
  dollarprinsessa_nn_1_N = mkN "dollarprinsessa" ;
  dolma_nn_2_N = mkN "dolma" ;
  dominikanerorden_nn_1_N = mkN "dominikanerorden" ;
  dominikanorden_nn_1_N = mkN "dominikanorden" ;
  dominikanska_nn_1_N = mkN "dominikanska" ;
  dominikiska_nn_1_N = mkN "dominikiska" ;
  dominobricka_nn_1_N = mkN "dominobricka" ;
  domkraftsolja_nn_1_N = mkN "domkraftsolja" ;
  domkyrka_nn_1_N = mkN "domkyrka" ;
  domsaga_nn_1_N = mkN "domsaga" ;
  domvilla_nn_1_N = mkN "domvilla" ;
  dona_nn_1_N = mkN "dona" ;
  donkeypanna_nn_1_N = mkN "donkeypanna" ;
  donna_nn_1_N = mkN "donna" ;
  dopaminblaasa_nn_1_1_N = mkN "dopaminblåsa" ;
  dopinghaerva_nn_1_1_N = mkN "dopinghärva" ;
  dopningshaerva_nn_1_1_N = mkN "dopningshärva" ;
  dosa_nn_1_N = mkN "dosa" ;
  dragglina_nn_1_N = mkN "dragglina" ;
  dragharmonika_nn_1_N = mkN "dragharmonika" ;
  dragkedja_nn_1_N = mkN "dragkedja" ;
  dragkista_nn_1_N = mkN "dragkista" ;
  dragkaerra_nn_1_1_N = mkN "dragkärra" ;
  draglina_nn_1_N = mkN "draglina" ;
  dragningslista_nn_1_N = mkN "dragningslista" ;
  dragskiva_nn_1_N = mkN "dragskiva" ;
  dragstyrka_nn_1_N = mkN "dragstyrka" ;
  drakslinga_nn_1_N = mkN "drakslinga" ;
  drakoedla_nn_1_1_N = mkN "draködla" ;
  drapa_nn_1_N = mkN "drapa" ;
  drav_nn_1_N = mkN "drav" ;
  dregel_nn_1_N = mkN "dregel" ;
  drejskiva_nn_1_N = mkN "drejskiva" ;
  drevkedja_nn_1_N = mkN "drevkedja" ;
  dricka_nn_2_N = mkN "dricka" ;
  driftkucku_nn_1_N = mkN "driftkucku" ;
  drillflicka_nn_1_N = mkN "drillflicka" ;
  drillsnaeppa_nn_1_1_N = mkN "drillsnäppa" ;
  driva_nn_1_N = mkN "driva" ;
  drivhusplanta_nn_1_N = mkN "drivhusplanta" ;
  drivkedja_nn_1_N = mkN "drivkedja" ;
  drivlina_nn_1_N = mkN "drivlina" ;
  droppflaska_nn_1_N = mkN "droppflaska" ;
  droppnaesa_nn_1_1_N = mkN "droppnäsa" ;
  droska_nn_1_N = mkN "droska" ;
  drottningkrona_nn_1_N = mkN "drottningkrona" ;
  drunkningsolycka_nn_1_N = mkN "drunkningsolycka" ;
  druva_nn_1_N = mkN "druva" ;
  druvgurka_nn_1_N = mkN "druvgurka" ;
  dryckesvisa_nn_1_N = mkN "dryckesvisa" ;
  dryckjom_nn_1_N = mkN "dryckjom" ;
  draegel_nn_1_1_N = mkN "drägel" ;
  droejsmaalsraenta_nn_1_1_N = mkN "dröjsmålsränta" ;
  droemresa_nn_1_1_N = mkN "drömresa" ;
  droemrumpa_nn_1_1_N = mkN "drömrumpa" ;
  dubbelbotten_nn_1_N = mkN "dubbelbotten" ;
  dubbelboessa_nn_1_1_N = mkN "dubbelbössa" ;
  dubbelhaka_nn_1_N = mkN "dubbelhaka" ;
  dubbelstjaerna_nn_1_1_N = mkN "dubbelstjärna" ;
  duenna_nn_1_N = mkN "duenna" ;
  duma_nn_1_N = mkN "duma" ;
  dumdumkula_nn_1_N = mkN "dumdumkula" ;
  durra_nn_1_N = mkN "durra" ;
  durskala_nn_1_N = mkN "durskala" ;
  dussinmaenniska_nn_1_1_N = mkN "dussinmänniska" ;
  dussinvara_nn_1_N = mkN "dussinvara" ;
  duva_nn_1_N = mkN "duva" ;
  duvkulla_nn_1_N = mkN "duvkulla" ;
  dybotten_nn_1_N = mkN "dybotten" ;
  dykarklocka_nn_1_N = mkN "dykarklocka" ;
  dymmelvecka_nn_1_N = mkN "dymmelvecka" ;
  dyna_nn_1_N = mkN "dyna" ;
  dynt_nn_1_N = mkN "dynt" ;
  dysa_nn_1_N = mkN "dysa" ;
  dyscha_nn_1_N = mkN "dyscha" ;
  dyvika_nn_1_N = mkN "dyvika" ;
  daeckmaerkningsklaemma_nn_1_1_N = mkN "däckmärkningsklämma" ;
  daecksplanka_nn_1_1_N = mkN "däcksplanka" ;
  daadra_nn_1_1_N = mkN "dådra" ;
  doedsdag_nn_1_1_N = mkN "dödsdag" ;
  doedsfara_nn_1_1_N = mkN "dödsfara" ;
  doedsfaella_nn_1_1_N = mkN "dödsfälla" ;
  doedskallefjaeril_nn_1_1_N = mkN "dödskallefjäril" ;
  doedslista_nn_1_1_N = mkN "dödslista" ;
  doedsmisshandel_nn_1_1_N = mkN "dödsmisshandel" ;
  doedsolycka_nn_1_1_N = mkN "dödsolycka" ;
  doedsruna_nn_1_1_N = mkN "dödsruna" ;
  doedssiffra_nn_1_1_N = mkN "dödssiffra" ;
  doedsstjaerna_nn_1_1_N = mkN "dödsstjärna" ;
  doedsvaanda_nn_1_1_N = mkN "dödsvånda" ;
  doerrkedja_nn_1_1_N = mkN "dörrkedja" ;
  doerrklocka_nn_1_1_N = mkN "dörrklocka" ;
  doerrmatta_nn_1_1_N = mkN "dörrmatta" ;
  ebenholts_nn_1_N = mkN "ebenholts" ;
  ecuadorianska_nn_1_N = mkN "ecuadorianska" ;
  eda_nn_1_N = mkN "eda" ;
  edda_nn_1_N = mkN "edda" ;
  efterleverska_nn_1_N = mkN "efterleverska" ;
  efterraettssoppa_nn_1_1_N = mkN "efterrättssoppa" ;
  egennytta_nn_1_N = mkN "egennytta" ;
  egyptiska_nn_1_N = mkN "egyptiska" ;
  egyptiska_nn_2_N = mkN "egyptiska" ;
  ehec_smitta_nn_1_N = mkN "ehec-smitta" ;
  ejderhona_nn_1_N = mkN "ejderhona" ;
  eka_nn_1_N = mkN "eka" ;
  ekonomilaera_nn_1_1_N = mkN "ekonomilära" ;
  ekvatorialguineanska_nn_1_N = mkN "ekvatorialguineanska" ;
  ekvipotentialyta_nn_1_N = mkN "ekvipotentialyta" ;
  eldfluga_nn_1_N = mkN "eldfluga" ;
  eldkula_nn_1_N = mkN "eldkula" ;
  eldningsolja_nn_1_N = mkN "eldningsolja" ;
  eldslaaga_nn_1_1_N = mkN "eldslåga" ;
  eldspruta_nn_1_N = mkN "eldspruta" ;
  eldsvaada_nn_1_1_N = mkN "eldsvåda" ;
  eldyta_nn_1_N = mkN "eldyta" ;
  elefantskoeldpadda_nn_1_1_N = mkN "elefantsköldpadda" ;
  elektronbana_nn_1_N = mkN "elektronbana" ;
  elektronkamera_nn_1_N = mkN "elektronkamera" ;
  elementarskola_nn_1_N = mkN "elementarskola" ;
  elevlista_nn_1_N = mkN "elevlista" ;
  elevskola_nn_1_N = mkN "elevskola" ;
  elljusslinga_nn_1_N = mkN "elljusslinga" ;
  elplatta_nn_1_N = mkN "elplatta" ;
  elritsa_nn_1_N = mkN "elritsa" ;
  elva_nn_1_N = mkN "elva" ;
  embargo_nn_1_N = mkN "embargo" ;
  emiratiska_nn_1_N = mkN "emiratiska" ;
  emma_nn_1_N = mkN "emma" ;
  encyklika_nn_1_N = mkN "encyklika" ;
  energikaella_nn_1_1_N = mkN "energikälla" ;
  engelska_nn_1_N = mkN "engelska" ;
  engelska_nn_2_N = mkN "engelska" ;
  engaangsflaska_nn_1_1_N = mkN "engångsflaska" ;
  enkelstjaerna_nn_1_1_N = mkN "enkelstjärna" ;
  enkrona_nn_1_N = mkN "enkrona" ;
  enplansvilla_nn_1_N = mkN "enplansvilla" ;
  entita_nn_1_N = mkN "entita" ;
  eolsharpa_nn_1_N = mkN "eolsharpa" ;
  era_nn_1_N = mkN "era" ;
  eremitkraefta_nn_1_1_N = mkN "eremitkräfta" ;
  eriksgata_nn_1_N = mkN "eriksgata" ;
  eritreanska_nn_1_N = mkN "eritreanska" ;
  eritreanska_nn_2_N = mkN "eritreanska" ;
  erosionsskada_nn_1_N = mkN "erosionsskada" ;
  ersmaessa_nn_1_1_N = mkN "ersmässa" ;
  eskimaaiska_nn_1_1_N = mkN "eskimåiska" ;
  eskortflicka_nn_1_N = mkN "eskortflicka" ;
  eskortkvinna_nn_1_N = mkN "eskortkvinna" ;
  essaefraaga_nn_1_1_N = mkN "essäfråga" ;
  estlaendska_nn_1_1_N = mkN "estländska" ;
  estniska_nn_1_N = mkN "estniska" ;
  estniska_nn_2_N = mkN "estniska" ;
  eterflaska_nn_1_N = mkN "eterflaska" ;
  etiopiska_nn_1_N = mkN "etiopiska" ;
  etiopiska_nn_2_N = mkN "etiopiska" ;
  etruskiska_nn_1_N = mkN "etruskiska" ;
  etruskiska_nn_2_N = mkN "etruskiska" ;
  etta_nn_1_N = mkN "etta" ;
  ettermyra_nn_1_N = mkN "ettermyra" ;
  euforbia_nn_1_N = mkN "euforbia" ;
  eukalyptusolja_nn_1_N = mkN "eukalyptusolja" ;
  eurasiska_nn_1_N = mkN "eurasiska" ;
  europeiska_nn_1_N = mkN "europeiska" ;
  eva_nn_1_N = mkN "eva" ;
  evighetsblomma_nn_1_N = mkN "evighetsblomma" ;
  examensfraaga_nn_1_1_N = mkN "examensfråga" ;
  exfru_nn_1_N = mkN "exfru" ;
  expansionsvilja_nn_1_N = mkN "expansionsvilja" ;
  experimentlusta_nn_1_N = mkN "experimentlusta" ;
  exploateringsyta_nn_1_N = mkN "exploateringsyta" ;
  explosiva_nn_1_N = mkN "explosiva" ;
  extralampa_nn_1_N = mkN "extralampa" ;
  extraupplaga_nn_1_N = mkN "extraupplaga" ;
  fabrikslaenga_nn_1_1_N = mkN "fabrikslänga" ;
  fabrikspipa_nn_1_N = mkN "fabrikspipa" ;
  fackhoegskola_nn_1_1_N = mkN "fackhögskola" ;
  fackla_nn_1_N = mkN "fackla" ;
  fackprosa_nn_1_N = mkN "fackprosa" ;
  fackskola_nn_1_N = mkN "fackskola" ;
  faddergala_nn_1_N = mkN "faddergala" ;
  faddergaava_nn_1_1_N = mkN "faddergåva" ;
  fakta_nn_1_N = mkN "fakta" ;
  faktagroda_nn_1_N = mkN "faktagroda" ;
  faktura_nn_1_N = mkN "faktura" ;
  fallbila_nn_1_N = mkN "fallbila" ;
  fallmaalstavla_nn_1_1_N = mkN "fallmålstavla" ;
  fallolycka_nn_1_N = mkN "fallolycka" ;
  falltavla_nn_1_N = mkN "falltavla" ;
  fallucka_nn_1_N = mkN "fallucka" ;
  familjeflicka_nn_1_N = mkN "familjeflicka" ;
  fana_nn_1_N = mkN "fana" ;
  fantomsmaerta_nn_1_1_N = mkN "fantomsmärta" ;
  fara_nn_1_N = mkN "fara" ;
  farhaaga_nn_1_1_N = mkN "farhåga" ;
  farin_nn_1_N = mkN "farin" ;
  farsa_nn_1_N = mkN "farsa" ;
  farstutrappa_nn_1_N = mkN "farstutrappa" ;
  fartkamera_nn_1_N = mkN "fartkamera" ;
  fartygsbotten_nn_1_N = mkN "fartygsbotten" ;
  fartygslucka_nn_1_N = mkN "fartygslucka" ;
  fartygssida_nn_1_N = mkN "fartygssida" ;
  fasa_nn_1_N = mkN "fasa" ;
  fasadplatta_nn_1_N = mkN "fasadplatta" ;
  fasta_nn_1_N = mkN "fasta" ;
  fastedag_nn_1_N = mkN "fastedag" ;
  fastighetsbubbla_nn_1_N = mkN "fastighetsbubbla" ;
  fastkedja_nn_1_N = mkN "fastkedja" ;
  fastlagsbulla_nn_1_N = mkN "fastlagsbulla" ;
  fattigdomsfaella_nn_1_1_N = mkN "fattigdomsfälla" ;
  fattigstuga_nn_1_N = mkN "fattigstuga" ;
  fattningsfoermaaga_nn_1_1_N = mkN "fattningsförmåga" ;
  fattningsgaava_nn_1_1_N = mkN "fattningsgåva" ;
  fatwa_nn_1_N = mkN "fatwa" ;
  fauna_nn_1_N = mkN "fauna" ;
  favoritskaadespelerska_nn_1_1_N = mkN "favoritskådespelerska" ;
  feberkurva_nn_1_N = mkN "feberkurva" ;
  fela_nn_1_N = mkN "fela" ;
  felkaella_nn_1_1_N = mkN "felkälla" ;
  fembarnsmamma_nn_1_N = mkN "fembarnsmamma" ;
  femdagarsvecka_nn_1_N = mkN "femdagarsvecka" ;
  femetta_nn_1_N = mkN "femetta" ;
  femfemma_nn_1_N = mkN "femfemma" ;
  femkrona_nn_1_N = mkN "femkrona" ;
  femma_nn_1_N = mkN "femma" ;
  femtiometersstraecka_nn_1_1_N = mkN "femtiometerssträcka" ;
  fena_nn_1_N = mkN "fena" ;
  fenoxisyra_nn_1_N = mkN "fenoxisyra" ;
  ferieskola_nn_1_N = mkN "ferieskola" ;
  fernissa_nn_1_N = mkN "fernissa" ;
  ferritkaerna_nn_1_1_N = mkN "ferritkärna" ;
  festvaerdinna_nn_1_1_N = mkN "festvärdinna" ;
  fettisdagsbulla_nn_1_N = mkN "fettisdagsbulla" ;
  fettpaerla_nn_1_1_N = mkN "fettpärla" ;
  fettspruta_nn_1_N = mkN "fettspruta" ;
  fettsyra_nn_1_N = mkN "fettsyra" ;
  fia_nn_1_N = mkN "fia" ;
  fibbla_nn_1_N = mkN "fibbla" ;
  fiberplatta_nn_1_N = mkN "fiberplatta" ;
  fibula_nn_1_N = mkN "fibula" ;
  ficka_nn_1_N = mkN "ficka" ;
  ficklampa_nn_1_N = mkN "ficklampa" ;
  fickplunta_nn_1_N = mkN "fickplunta" ;
  fijianska_nn_1_N = mkN "fijianska" ;
  fijianska_nn_2_N = mkN "fijianska" ;
  fika_nn_1_N = mkN "fika" ;
  fikahoerna_nn_1_1_N = mkN "fikahörna" ;
  fiktionsprosa_nn_1_N = mkN "fiktionsprosa" ;
  filippinska_nn_1_N = mkN "filippinska" ;
  filmkamera_nn_1_N = mkN "filmkamera" ;
  filmskaadespelerska_nn_1_1_N = mkN "filmskådespelerska" ;
  filmstjaerna_nn_1_1_N = mkN "filmstjärna" ;
  filterludd_nn_1_N = mkN "filterludd" ;
  filtyta_nn_1_N = mkN "filtyta" ;
  fingerblomma_nn_1_N = mkN "fingerblomma" ;
  fingerborgsblomma_nn_1_N = mkN "fingerborgsblomma" ;
  fingerskiva_nn_1_N = mkN "fingerskiva" ;
  fingertuta_nn_1_N = mkN "fingertuta" ;
  finka_nn_1_N = mkN "finka" ;
  finkelolja_nn_1_N = mkN "finkelolja" ;
  finkaensla_nn_1_1_N = mkN "finkänsla" ;
  finlandssvenska_nn_1_N = mkN "finlandssvenska" ;
  finlandssvenska_nn_2_N = mkN "finlandssvenska" ;
  finlaendska_nn_1_1_N = mkN "finländska" ;
  finska_nn_1_N = mkN "finska" ;
  finska_nn_2_N = mkN "finska" ;
  fiollaada_nn_1_1_N = mkN "fiollåda" ;
  firma_nn_1_N = mkN "firma" ;
  fiskblaasa_nn_1_1_N = mkN "fiskblåsa" ;
  fiskelycka_nn_1_N = mkN "fiskelycka" ;
  fiskeolycka_nn_1_N = mkN "fiskeolycka" ;
  fiskestuga_nn_1_N = mkN "fiskestuga" ;
  fiskguano_nn_1_N = mkN "fiskguano" ;
  fiskleverolja_nn_1_N = mkN "fiskleverolja" ;
  fiskolja_nn_1_N = mkN "fiskolja" ;
  fisksoppa_nn_1_N = mkN "fisksoppa" ;
  fisktrappa_nn_1_N = mkN "fisktrappa" ;
  fisktaerna_nn_1_1_N = mkN "fisktärna" ;
  fiskaadra_nn_1_1_N = mkN "fiskådra" ;
  fiskoedla_nn_1_1_N = mkN "fisködla" ;
  fitta_nn_1_N = mkN "fitta" ;
  fixstjaerna_nn_1_1_N = mkN "fixstjärna" ;
  fjolla_nn_1_N = mkN "fjolla" ;
  fjong_nn_1_N = mkN "fjong" ;
  fjaederdosa_nn_1_1_N = mkN "fjäderdosa" ;
  fjaedermygga_nn_1_1_N = mkN "fjädermygga" ;
  fjaella_nn_1_1_N = mkN "fjälla" ;
  fjaellkedja_nn_1_1_N = mkN "fjällkedja" ;
  fjaellripa_nn_1_1_N = mkN "fjällripa" ;
  fjaellsjoe_nn_1_1_N = mkN "fjällsjö" ;
  fjaellstuga_nn_1_1_N = mkN "fjällstuga" ;
  fjaellsyra_nn_1_1_N = mkN "fjällsyra" ;
  fjaelluggla_nn_1_1_N = mkN "fjälluggla" ;
  fjaeril_nn_1_1_N = mkN "fjäril" ;
  fjaerilsblomma_nn_1_1_N = mkN "fjärilsblomma" ;
  flaga_nn_1_N = mkN "flaga" ;
  flagga_nn_1_N = mkN "flagga" ;
  flagglina_nn_1_N = mkN "flagglina" ;
  flamlaendska_nn_1_1_N = mkN "flamländska" ;
  flamlaendska_nn_2_1_N = mkN "flamländska" ;
  flamma_nn_1_N = mkN "flamma" ;
  flaska_nn_1_N = mkN "flaska" ;
  flata_nn_1_N = mkN "flata" ;
  fleece_nn_1_N = mkN "fleece" ;
  flerbarnsmamma_nn_1_N = mkN "flerbarnsmamma" ;
  flervalsfraaga_nn_1_1_N = mkN "flervalsfråga" ;
  flexklocka_nn_1_N = mkN "flexklocka" ;
  flicka_nn_1_N = mkN "flicka" ;
  flickbokshjaeltinna_nn_1_1_N = mkN "flickbokshjältinna" ;
  flickskola_nn_1_N = mkN "flickskola" ;
  flickslaenda_nn_1_1_N = mkN "flickslända" ;
  flinga_nn_1_N = mkN "flinga" ;
  flinta_nn_1_N = mkN "flinta" ;
  flintyxa_nn_1_N = mkN "flintyxa" ;
  flis_nn_1_N = mkN "flis" ;
  flisa_nn_1_N = mkN "flisa" ;
  flo_nn_1_N = mkN "flo" ;
  flodfaara_nn_1_1_N = mkN "flodfåra" ;
  flodkrabba_nn_1_N = mkN "flodkrabba" ;
  flora_nn_1_N = mkN "flora" ;
  flossa_nn_1_N = mkN "flossa" ;
  flotta_nn_1_N = mkN "flotta" ;
  flottbro_nn_1_N = mkN "flottbro" ;
  fluga_nn_1_N = mkN "fluga" ;
  flugsmaella_nn_1_1_N = mkN "flugsmälla" ;
  flugvifta_nn_1_N = mkN "flugvifta" ;
  flundra_nn_1_N = mkN "flundra" ;
  flunsa_nn_1_N = mkN "flunsa" ;
  fluor_nn_1_N = mkN "fluor" ;
  flygflotta_nn_1_N = mkN "flygflotta" ;
  flygmyra_nn_1_N = mkN "flygmyra" ;
  flygplanstoa_nn_1_N = mkN "flygplanstoa" ;
  flygvaerdinna_nn_1_1_N = mkN "flygvärdinna" ;
  flygoedla_nn_1_1_N = mkN "flygödla" ;
  flytdocka_nn_1_N = mkN "flytdocka" ;
  flyttlaada_nn_1_1_N = mkN "flyttlåda" ;
  flaedermaergskula_nn_1_1_N = mkN "flädermärgskula" ;
  flaerpa_nn_1_1_N = mkN "flärpa" ;
  flaeskpannkaka_nn_1_1_N = mkN "fläskpannkaka" ;
  flaeta_nn_1_1_N = mkN "fläta" ;
  flaahacka_nn_1_1_N = mkN "flåhacka" ;
  floertkula_nn_1_1_N = mkN "flörtkula" ;
  floertlampa_nn_1_1_N = mkN "flörtlampa" ;
  fnoeskticka_nn_1_1_N = mkN "fnöskticka" ;
  focus_nn_1_N = mkN "focus" ;
  foderbeta_nn_1_N = mkN "foderbeta" ;
  foderkaka_nn_1_N = mkN "foderkaka" ;
  foderlada_nn_1_N = mkN "foderlada" ;
  fogmassa_nn_1_N = mkN "fogmassa" ;
  fogspruta_nn_1_N = mkN "fogspruta" ;
  fokus_nn_1_N = mkN "fokus" ;
  folkhoegskola_nn_1_1_N = mkN "folkhögskola" ;
  folkmassa_nn_1_N = mkN "folkmassa" ;
  folkriksdag_nn_1_N = mkN "folkriksdag" ;
  folksaga_nn_1_N = mkN "folksaga" ;
  folkskola_nn_1_N = mkN "folkskola" ;
  folkspillra_nn_1_N = mkN "folkspillra" ;
  folktro_nn_1_N = mkN "folktro" ;
  folkvilja_nn_1_N = mkN "folkvilja" ;
  folkvisa_nn_1_N = mkN "folkvisa" ;
  fondmaeklarfirma_nn_1_1_N = mkN "fondmäklarfirma" ;
  fora_nn_1_N = mkN "fora" ;
  formalin_nn_1_N = mkN "formalin" ;
  formfraaga_nn_1_1_N = mkN "formfråga" ;
  formkurva_nn_1_N = mkN "formkurva" ;
  formlaera_nn_1_1_N = mkN "formlära" ;
  formsvacka_nn_1_N = mkN "formsvacka" ;
  fornegyptiska_nn_1_N = mkN "fornegyptiska" ;
  forskningsresa_nn_1_N = mkN "forskningsresa" ;
  forsythia_nn_1_N = mkN "forsythia" ;
  forsaerla_nn_1_1_N = mkN "forsärla" ;
  fortplantningsfoermaaga_nn_1_1_N = mkN "fortplantningsförmåga" ;
  fortsaettningsskola_nn_1_1_N = mkN "fortsättningsskola" ;
  fosforsyra_nn_1_N = mkN "fosforsyra" ;
  fosterhinna_nn_1_N = mkN "fosterhinna" ;
  fosterskada_nn_1_N = mkN "fosterskada" ;
  fotboja_nn_1_N = mkN "fotboja" ;
  fotbollsarena_nn_1_N = mkN "fotbollsarena" ;
  fotbollskedja_nn_1_N = mkN "fotbollskedja" ;
  fotbollsstjaerna_nn_1_1_N = mkN "fotbollsstjärna" ;
  fotbollstuta_nn_1_N = mkN "fotbollstuta" ;
  fotogenlampa_nn_1_N = mkN "fotogenlampa" ;
  fotokarta_nn_1_N = mkN "fotokarta" ;
  fotokopia_nn_1_N = mkN "fotokopia" ;
  fotostatkopia_nn_1_N = mkN "fotostatkopia" ;
  fotplatta_nn_1_N = mkN "fotplatta" ;
  fotskada_nn_1_N = mkN "fotskada" ;
  fotskrapa_nn_1_N = mkN "fotskrapa" ;
  fotsula_nn_1_N = mkN "fotsula" ;
  fotvaarta_nn_1_1_N = mkN "fotvårta" ;
  fotaenda_nn_1_1_N = mkN "fotända" ;
  fraktfirma_nn_1_N = mkN "fraktfirma" ;
  fralla_nn_1_N = mkN "fralla" ;
  framficka_nn_1_N = mkN "framficka" ;
  framgaangssaga_nn_1_1_N = mkN "framgångssaga" ;
  framsida_nn_1_N = mkN "framsida" ;
  framstegstro_nn_1_N = mkN "framstegstro" ;
  framtidsfraaga_nn_1_1_N = mkN "framtidsfråga" ;
  framtidstro_nn_1_N = mkN "framtidstro" ;
  framaenda_nn_1_1_N = mkN "framända" ;
  franciskanerorden_nn_1_N = mkN "franciskanerorden" ;
  franciskanorden_nn_1_N = mkN "franciskanorden" ;
  franska_nn_1_N = mkN "franska" ;
  fransyska_nn_1_N = mkN "fransyska" ;
  frasvaaffla_nn_1_1_N = mkN "frasvåffla" ;
  fredagsbilaga_nn_1_N = mkN "fredagsbilaga" ;
  fredsduva_nn_1_N = mkN "fredsduva" ;
  fredspipa_nn_1_N = mkN "fredspipa" ;
  fredsstyrka_nn_1_N = mkN "fredsstyrka" ;
  fresia_nn_1_N = mkN "fresia" ;
  frihandel_nn_1_N = mkN "frihandel" ;
  frikativa_nn_1_N = mkN "frikativa" ;
  friktionsvaerme_nn_1_1_N = mkN "friktionsvärme" ;
  frikyrka_nn_1_N = mkN "frikyrka" ;
  frilista_nn_1_N = mkN "frilista" ;
  frilla_nn_1_N = mkN "frilla" ;
  friluftsvana_nn_1_N = mkN "friluftsvana" ;
  frimurareorden_nn_1_N = mkN "frimurareorden" ;
  frimurarorden_nn_1_N = mkN "frimurarorden" ;
  frisiska_nn_1_N = mkN "frisiska" ;
  frisiska_nn_2_N = mkN "frisiska" ;
  friskola_nn_1_N = mkN "friskola" ;
  frissa_nn_1_N = mkN "frissa" ;
  frisoerska_nn_1_1_N = mkN "frisörska" ;
  fritidsstuga_nn_1_N = mkN "fritidsstuga" ;
  frossa_nn_1_N = mkN "frossa" ;
  frostdimma_nn_1_N = mkN "frostdimma" ;
  frostfjaeril_nn_1_1_N = mkN "frostfjäril" ;
  frostskada_nn_1_N = mkN "frostskada" ;
  frostskyddsvaetska_nn_1_1_N = mkN "frostskyddsvätska" ;
  fru_nn_1_N = mkN "fru" ;
  fruga_nn_1_N = mkN "fruga" ;
  frukostbricka_nn_1_N = mkN "frukostbricka" ;
  frukostvaerdinna_nn_1_1_N = mkN "frukostvärdinna" ;
  fruktkaka_nn_1_N = mkN "fruktkaka" ;
  fruktkaerna_nn_1_1_N = mkN "fruktkärna" ;
  fruktsoppa_nn_1_N = mkN "fruktsoppa" ;
  frysloppa_nn_1_N = mkN "frysloppa" ;
  fraenka_nn_1_1_N = mkN "fränka" ;
  fraeta_nn_1_1_N = mkN "fräta" ;
  fraetskada_nn_1_1_N = mkN "frätskada" ;
  fraaga_nn_1_1_N = mkN "fråga" ;
  fraansida_nn_1_1_N = mkN "frånsida" ;
  froeken_nn_1_1_N = mkN "fröken" ;
  froeplanta_nn_1_1_N = mkN "fröplanta" ;
  froevita_nn_1_1_N = mkN "frövita" ;
  ftalsyra_nn_1_N = mkN "ftalsyra" ;
  fuchsia_nn_1_N = mkN "fuchsia" ;
  fuga_nn_1_N = mkN "fuga" ;
  fuksin_nn_1_N = mkN "fuksin" ;
  fuktskada_nn_1_N = mkN "fuktskada" ;
  fura_nn_1_N = mkN "fura" ;
  furu_nn_1_N = mkN "furu" ;
  furuplanka_nn_1_N = mkN "furuplanka" ;
  fylgia_nn_1_N = mkN "fylgia" ;
  fylgja_nn_1_N = mkN "fylgja" ;
  fylla_nn_1_N = mkN "fylla" ;
  fylldille_nn_1_N = mkN "fylldille" ;
  fyllkaja_nn_1_N = mkN "fyllkaja" ;
  fyllnadsmassa_nn_1_N = mkN "fyllnadsmassa" ;
  fyndgruva_nn_1_N = mkN "fyndgruva" ;
  fyra_nn_1_N = mkN "fyra" ;
  fyrtiotimmarsvecka_nn_1_N = mkN "fyrtiotimmarsvecka" ;
  fyrtitimmarsvecka_nn_1_N = mkN "fyrtitimmarsvecka" ;
  faebodstinta_nn_1_1_N = mkN "fäbodstinta" ;
  faegata_nn_1_1_N = mkN "fägata" ;
  faella_nn_1_1_N = mkN "fälla" ;
  faeltflaska_nn_1_1_N = mkN "fältflaska" ;
  faeltmarskalkinna_nn_1_1_N = mkN "fältmarskalkinna" ;
  faeltstyrka_nn_1_1_N = mkN "fältstyrka" ;
  faengelsehaala_nn_1_1_N = mkN "fängelsehåla" ;
  faergkrita_nn_1_1_N = mkN "färgkrita" ;
  faerglaera_nn_1_1_N = mkN "färglära" ;
  faerglaada_nn_1_1_N = mkN "färglåda" ;
  faergpenna_nn_1_1_N = mkN "färgpenna" ;
  faergskala_nn_1_1_N = mkN "färgskala" ;
  faergskrapa_nn_1_1_N = mkN "färgskrapa" ;
  faergspruta_nn_1_1_N = mkN "färgspruta" ;
  faerja_nn_1_1_N = mkN "färja" ;
  faerjeolycka_nn_1_1_N = mkN "färjeolycka" ;
  faerla_nn_1_1_N = mkN "färla" ;
  faerna_nn_1_1_N = mkN "färna" ;
  faerskvara_nn_1_1_N = mkN "färskvara" ;
  faeroeiska_nn_1_1_N = mkN "färöiska" ;
  faeroeiska_nn_2_1_N = mkN "färöiska" ;
  faestmanssoffa_nn_1_1_N = mkN "fästmanssoffa" ;
  faestplatta_nn_1_1_N = mkN "fästplatta" ;
  faagelinfluensa_nn_1_1_N = mkN "fågelinfluensa" ;
  faagelskraemma_nn_1_1_N = mkN "fågelskrämma" ;
  faagelsnara_nn_1_1_N = mkN "fågelsnara" ;
  faageloe_nn_1_1_N = mkN "fågelö" ;
  faalla_nn_1_1_N = mkN "fålla" ;
  faanglina_nn_1_1_N = mkN "fånglina" ;
  faara_nn_1_1_N = mkN "fåra" ;
  faaravel_nn_1_1_N = mkN "fåravel" ;
  faarticka_nn_1_1_N = mkN "fårticka" ;
  foedelsedagsgaava_nn_1_1_N = mkN "födelsedagsgåva" ;
  foedelsedagstaarta_nn_1_1_N = mkN "födelsedagstårta" ;
  foedslovaanda_nn_1_1_N = mkN "födslovånda" ;
  foeljdfraaga_nn_1_1_N = mkN "följdfråga" ;
  foeljeslagarinna_nn_1_1_N = mkN "följeslagarinna" ;
  foensterbraeda_nn_1_1_N = mkN "fönsterbräda" ;
  foensterlucka_nn_1_1_N = mkN "fönsterlucka" ;
  foensterputs_nn_2_1_N = mkN "fönsterputs" ;
  foensterputsvaetska_nn_1_1_N = mkN "fönsterputsvätska" ;
  foensterruta_nn_1_1_N = mkN "fönsterruta" ;
  foerargelseklippa_nn_1_1_N = mkN "förargelseklippa" ;
  foerarruta_nn_1_1_N = mkN "förarruta" ;
  foerbandslaada_nn_1_1_N = mkN "förbandslåda" ;
  foeredragningslista_nn_1_1_N = mkN "föredragningslista" ;
  foerestaellningsfoermaaga_nn_1_1_N = mkN "föreställningsförmåga" ;
  foerestaandarinna_nn_1_1_N = mkN "föreståndarinna" ;
  foerfattarinna_nn_1_1_N = mkN "författarinna" ;
  foerhandlingsbricka_nn_1_1_N = mkN "förhandlingsbricka" ;
  foerhandlingsfraaga_nn_1_1_N = mkN "förhandlingsfråga" ;
  foerhandlingsrunda_nn_1_1_N = mkN "förhandlingsrunda" ;
  foerhandskopia_nn_1_1_N = mkN "förhandskopia" ;
  foerkaensla_nn_1_1_N = mkN "förkänsla" ;
  foerlaga_nn_1_1_N = mkN "förlaga" ;
  foerlossningsskada_nn_1_1_N = mkN "förlossningsskada" ;
  foermiddag_nn_1_1_N = mkN "förmiddag" ;
  foermaaga_nn_1_1_N = mkN "förmåga" ;
  foernuftstro_nn_1_1_N = mkN "förnuftstro" ;
  foerortslaerarinna_nn_1_1_N = mkN "förortslärarinna" ;
  foerortsskola_nn_1_1_N = mkN "förortsskola" ;
  foerskola_nn_1_1_N = mkN "förskola" ;
  foersoningsgaava_nn_1_1_N = mkN "försoningsgåva" ;
  foersoningslaera_nn_1_1_N = mkN "försoningslära" ;
  foerstadsvilla_nn_1_1_N = mkN "förstadsvilla" ;
  foerstamajblomma_nn_1_1_N = mkN "förstamajblomma" ;
  foerstaresa_nn_1_1_N = mkN "förstaresa" ;
  foerstasida_nn_1_1_N = mkN "förstasida" ;
  foerstaslagsfoermaaga_nn_1_1_N = mkN "förstaslagsförmåga" ;
  foerstaupplaga_nn_1_1_N = mkN "förstaupplaga" ;
  foerstfoederska_nn_1_1_N = mkN "förstföderska" ;
  foerstubro_nn_1_1_N = mkN "förstubro" ;
  foerstuga_nn_1_1_N = mkN "förstuga" ;
  foerstugubro_nn_1_1_N = mkN "förstugubro" ;
  foerstoerelselusta_nn_1_1_N = mkN "förstörelselusta" ;
  foersvarshoegskola_nn_1_1_N = mkN "försvarshögskola" ;
  foersvarsinlaga_nn_1_1_N = mkN "försvarsinlaga" ;
  foersaekringskassa_nn_1_1_N = mkN "försäkringskassa" ;
  foersaeljerska_nn_1_1_N = mkN "försäljerska" ;
  foersaeljningsvana_nn_1_1_N = mkN "försäljningsvana" ;
  foersoerjningsboerda_nn_1_1_N = mkN "försörjningsbörda" ;
  foertroendefraaga_nn_1_1_N = mkN "förtroendefråga" ;
  foertroendeklyfta_nn_1_1_N = mkN "förtroendeklyfta" ;
  foertoejningslina_nn_1_1_N = mkN "förtöjningslina" ;
  foervaervskaella_nn_1_1_N = mkN "förvärvskälla" ;
  foeryngringsyta_nn_1_1_N = mkN "föryngringsyta" ;
  gabardin_nn_1_N = mkN "gabardin" ;
  gabon_nn_1_N = mkN "gabon" ;
  gabonesiska_nn_1_N = mkN "gabonesiska" ;
  gaeliska_nn_1_N = mkN "gaeliska" ;
  gaeliska_nn_2_N = mkN "gaeliska" ;
  gaffelapa_nn_1_N = mkN "gaffelapa" ;
  gala_nn_1_N = mkN "gala" ;
  galeja_nn_1_N = mkN "galeja" ;
  galenpanna_nn_1_N = mkN "galenpanna" ;
  galla_nn_1_N = mkN "galla" ;
  gallblomma_nn_1_N = mkN "gallblomma" ;
  gallblaasa_nn_1_1_N = mkN "gallblåsa" ;
  galleria_nn_1_N = mkN "galleria" ;
  gallmygga_nn_1_N = mkN "gallmygga" ;
  gallsyra_nn_1_N = mkN "gallsyra" ;
  gallussyra_nn_1_N = mkN "gallussyra" ;
  galon_nn_1_N = mkN "galon" ;
  galoschhaka_nn_1_N = mkN "galoschhaka" ;
  galoschhylla_nn_1_N = mkN "galoschhylla" ;
  gambiska_nn_1_N = mkN "gambiska" ;
  gammakamera_nn_1_N = mkN "gammakamera" ;
  garantisumma_nn_1_N = mkN "garantisumma" ;
  gardenia_nn_1_N = mkN "gardenia" ;
  gardinkappa_nn_1_N = mkN "gardinkappa" ;
  gardinspringa_nn_1_N = mkN "gardinspringa" ;
  garndocka_nn_1_N = mkN "garndocka" ;
  garnhaerva_nn_1_1_N = mkN "garnhärva" ;
  garvsyra_nn_1_N = mkN "garvsyra" ;
  gasbinda_nn_1_N = mkN "gasbinda" ;
  gasbubbla_nn_1_N = mkN "gasbubbla" ;
  gasklocka_nn_1_N = mkN "gasklocka" ;
  gaslampa_nn_1_N = mkN "gaslampa" ;
  gaslykta_nn_1_N = mkN "gaslykta" ;
  gaslaecka_nn_1_1_N = mkN "gasläcka" ;
  gaslaera_nn_1_1_N = mkN "gaslära" ;
  gaslaaga_nn_1_1_N = mkN "gaslåga" ;
  gasmassa_nn_1_N = mkN "gasmassa" ;
  gasolin_nn_1_N = mkN "gasolin" ;
  gasskiva_nn_1_N = mkN "gasskiva" ;
  gata_nn_1_N = mkN "gata" ;
  gatflicka_nn_1_N = mkN "gatflicka" ;
  gatlykta_nn_1_N = mkN "gatlykta" ;
  gatslinka_nn_1_N = mkN "gatslinka" ;
  gausskurva_nn_1_N = mkN "gausskurva" ;
  geckooedla_nn_1_1_N = mkN "geckoödla" ;
  gegg_nn_1_N = mkN "gegg" ;
  geisha_nn_1_N = mkN "geisha" ;
  gelada_nn_1_N = mkN "gelada" ;
  gelatin_nn_1_N = mkN "gelatin" ;
  gel_eraatta_nn_1_1_N = mkN "geléråtta" ;
  generalska_nn_1_N = mkN "generalska" ;
  generalstabskarta_nn_1_N = mkN "generalstabskarta" ;
  generationsklyfta_nn_1_N = mkN "generationsklyfta" ;
  gengaava_nn_1_1_N = mkN "gengåva" ;
  genomfartsgata_nn_1_N = mkN "genomfartsgata" ;
  genomresa_nn_1_N = mkN "genomresa" ;
  genomslagsfoermaaga_nn_1_1_N = mkN "genomslagsförmåga" ;
  genomslagskopia_nn_1_N = mkN "genomslagskopia" ;
  genomtraengningsfoermaaga_nn_1_1_N = mkN "genomträngningsförmåga" ;
  gensaga_nn_1_N = mkN "gensaga" ;
  gentiana_nn_1_N = mkN "gentiana" ;
  genua_nn_1_N = mkN "genua" ;
  georgiska_nn_1_N = mkN "georgiska" ;
  georgiska_nn_2_N = mkN "georgiska" ;
  gerilla_nn_1_N = mkN "gerilla" ;
  geringslaada_nn_1_1_N = mkN "geringslåda" ;
  getingbilla_nn_1_N = mkN "getingbilla" ;
  getingmidja_nn_1_N = mkN "getingmidja" ;
  gevaerskula_nn_1_1_N = mkN "gevärskula" ;
  gevaersolja_nn_1_1_N = mkN "gevärsolja" ;
  gevaerspipa_nn_1_1_N = mkN "gevärspipa" ;
  gevaersvaeska_nn_1_1_N = mkN "gevärsväska" ;
  ghananska_nn_1_N = mkN "ghananska" ;
  giftblaasa_nn_1_1_N = mkN "giftblåsa" ;
  giftlaera_nn_1_1_N = mkN "giftlära" ;
  giftspruta_nn_1_N = mkN "giftspruta" ;
  giftstadga_nn_1_N = mkN "giftstadga" ;
  giga_nn_1_N = mkN "giga" ;
  gillesstuga_nn_1_N = mkN "gillesstuga" ;
  gillestuga_nn_1_N = mkN "gillestuga" ;
  gin_nn_1_N = mkN "gin" ;
  gina_nn_1_N = mkN "gina" ;
  gipa_nn_1_N = mkN "gipa" ;
  gipsplatta_nn_1_N = mkN "gipsplatta" ;
  gipsskiva_nn_1_N = mkN "gipsskiva" ;
  gjutflaska_nn_1_N = mkN "gjutflaska" ;
  gjutjaernsbro_nn_1_1_N = mkN "gjutjärnsbro" ;
  gjutjaernsgryta_nn_1_1_N = mkN "gjutjärnsgryta" ;
  gjutmassa_nn_1_N = mkN "gjutmassa" ;
  glacialraeffla_nn_1_1_N = mkN "glacialräffla" ;
  glaciaerraeffla_nn_1_1_N = mkN "glaciärräffla" ;
  glada_nn_1_N = mkN "glada" ;
  glasblaasarpipa_nn_1_1_N = mkN "glasblåsarpipa" ;
  glasflaska_nn_1_N = mkN "glasflaska" ;
  glasharmonika_nn_1_N = mkN "glasharmonika" ;
  glashylla_nn_1_N = mkN "glashylla" ;
  glashytta_nn_1_N = mkN "glashytta" ;
  glaskanna_nn_1_N = mkN "glaskanna" ;
  glasklocka_nn_1_N = mkN "glasklocka" ;
  glaskula_nn_1_N = mkN "glaskula" ;
  glasmassa_nn_1_N = mkN "glasmassa" ;
  glaspaerla_nn_1_1_N = mkN "glaspärla" ;
  glasruta_nn_1_N = mkN "glasruta" ;
  glasskiva_nn_1_N = mkN "glasskiva" ;
  glasslycka_nn_1_N = mkN "glasslycka" ;
  glasstaarta_nn_1_1_N = mkN "glasstårta" ;
  glasveranda_nn_1_N = mkN "glasveranda" ;
  glasvingefjaeril_nn_1_1_N = mkN "glasvingefjäril" ;
  glasvaetska_nn_1_1_N = mkN "glasvätska" ;
  glete_nn_1_N = mkN "glete" ;
  glidsalva_nn_1_N = mkN "glidsalva" ;
  glimlampa_nn_1_N = mkN "glimlampa" ;
  glipa_nn_1_N = mkN "glipa" ;
  gloria_nn_1_N = mkN "gloria" ;
  glosa_nn_1_N = mkN "glosa" ;
  glossa_nn_1_N = mkN "glossa" ;
  gloxinia_nn_1_N = mkN "gloxinia" ;
  glukos_nn_1_N = mkN "glukos" ;
  glutaminsyra_nn_1_N = mkN "glutaminsyra" ;
  gluttsnaeppa_nn_1_1_N = mkN "gluttsnäppa" ;
  glycerin_nn_1_N = mkN "glycerin" ;
  glykos_nn_1_N = mkN "glykos" ;
  glaedjedag_nn_1_1_N = mkN "glädjedag" ;
  glaedjeflicka_nn_1_1_N = mkN "glädjeflicka" ;
  glaedjefnatt_nn_1_1_N = mkN "glädjefnatt" ;
  glaedjeyra_nn_1_1_N = mkN "glädjeyra" ;
  glaenta_nn_1_1_N = mkN "glänta" ;
  gloedhoppa_nn_1_1_N = mkN "glödhoppa" ;
  gloedlampa_nn_1_1_N = mkN "glödlampa" ;
  gloedstrumpa_nn_1_1_N = mkN "glödstrumpa" ;
  gloeggpanna_nn_1_1_N = mkN "glöggpanna" ;
  gloeggryta_nn_1_1_N = mkN "glöggryta" ;
  gloemskekurva_nn_1_1_N = mkN "glömskekurva" ;
  gnista_nn_1_N = mkN "gnista" ;
  gnista_nn_2_N = mkN "gnista" ;
  gniststraecka_nn_1_1_N = mkN "gniststräcka" ;
  go_go_flicka_nn_1_N = mkN "go-go-flicka" ;
  godislycka_nn_1_N = mkN "godislycka" ;
  godnattsaga_nn_1_N = mkN "godnattsaga" ;
  godsfinka_nn_1_N = mkN "godsfinka" ;
  godsaegarinna_nn_1_1_N = mkN "godsägarinna" ;
  godtemplarorden_nn_1_N = mkN "godtemplarorden" ;
  goja_nn_2_N = mkN "goja" ;
  golfbana_nn_1_N = mkN "golfbana" ;
  golfbyxa_nn_1_N = mkN "golfbyxa" ;
  golfklubba_nn_1_N = mkN "golfklubba" ;
  golfresa_nn_1_N = mkN "golfresa" ;
  golfrunda_nn_1_N = mkN "golfrunda" ;
  golfskjorta_nn_1_N = mkN "golfskjorta" ;
  golfstjaerna_nn_1_1_N = mkN "golfstjärna" ;
  golvklocka_nn_1_N = mkN "golvklocka" ;
  golvlampa_nn_1_N = mkN "golvlampa" ;
  golvmatta_nn_1_N = mkN "golvmatta" ;
  golvtrasa_nn_1_N = mkN "golvtrasa" ;
  golvyta_nn_1_N = mkN "golvyta" ;
  gorgonzola_nn_1_N = mkN "gorgonzola" ;
  gorilla_nn_1_N = mkN "gorilla" ;
  gotiska_nn_1_N = mkN "gotiska" ;
  gotlaendska_nn_1_1_N = mkN "gotländska" ;
  gotlaendska_nn_2_1_N = mkN "gotländska" ;
  gottkoepsvara_nn_1_1_N = mkN "gottköpsvara" ;
  gradskiva_nn_1_N = mkN "gradskiva" ;
  grammatika_nn_1_N = mkN "grammatika" ;
  grammofonskiva_nn_1_N = mkN "grammofonskiva" ;
  granatskaerva_nn_1_1_N = mkN "granatskärva" ;
  granataeppelkaerna_nn_1_1_N = mkN "granatäppelkärna" ;
  grannosaemja_nn_1_1_N = mkN "grannosämja" ;
  grannsocken_nn_1_N = mkN "grannsocken" ;
  grannstjaerna_nn_1_1_N = mkN "grannstjärna" ;
  grannstuga_nn_1_N = mkN "grannstuga" ;
  granplanta_nn_1_N = mkN "granplanta" ;
  granspira_nn_1_N = mkN "granspira" ;
  gravgaava_nn_1_1_N = mkN "gravgåva" ;
  graviditetsvecka_nn_1_N = mkN "graviditetsvecka" ;
  gravkista_nn_1_N = mkN "gravkista" ;
  gravkyrka_nn_1_N = mkN "gravkyrka" ;
  gravsaenka_nn_1_1_N = mkN "gravsänka" ;
  gravurna_nn_1_N = mkN "gravurna" ;
  greja_nn_1_N = mkN "greja" ;
  grekinna_nn_1_N = mkN "grekinna" ;
  grekiska_nn_1_N = mkN "grekiska" ;
  grekiska_nn_2_N = mkN "grekiska" ;
  grenadiska_nn_1_N = mkN "grenadiska" ;
  grenklyka_nn_1_N = mkN "grenklyka" ;
  greppmatta_nn_1_N = mkN "greppmatta" ;
  greppyta_nn_1_N = mkN "greppyta" ;
  grevekrona_nn_1_N = mkN "grevekrona" ;
  grevinna_nn_1_N = mkN "grevinna" ;
  grevysebra_nn_1_N = mkN "grevysebra" ;
  grevyzebra_nn_1_N = mkN "grevyzebra" ;
  griffeltavla_nn_1_N = mkN "griffeltavla" ;
  grimma_nn_1_N = mkN "grimma" ;
  grindstuga_nn_1_N = mkN "grindstuga" ;
  grissla_nn_1_N = mkN "grissla" ;
  groda_nn_1_N = mkN "groda" ;
  groddplanta_nn_1_N = mkN "groddplanta" ;
  groploeja_nn_1_1_N = mkN "groplöja" ;
  grosshandel_nn_1_N = mkN "grosshandel" ;
  grosshandelsfirma_nn_1_N = mkN "grosshandelsfirma" ;
  grotta_nn_1_N = mkN "grotta" ;
  grottmaenniska_nn_1_1_N = mkN "grottmänniska" ;
  grottskreva_nn_1_N = mkN "grottskreva" ;
  grovsyssla_nn_1_N = mkN "grovsyssla" ;
  grubba_nn_1_N = mkN "grubba" ;
  grundhyra_nn_1_N = mkN "grundhyra" ;
  grundskola_nn_1_N = mkN "grundskola" ;
  grundsaerskola_nn_1_1_N = mkN "grundsärskola" ;
  grundyta_nn_1_N = mkN "grundyta" ;
  grunka_nn_1_N = mkN "grunka" ;
  gruppresa_nn_1_N = mkN "gruppresa" ;
  gruva_nn_1_N = mkN "gruva" ;
  gruvolycka_nn_1_N = mkN "gruvolycka" ;
  gruvstoetta_nn_1_1_N = mkN "gruvstötta" ;
  grynna_nn_1_N = mkN "grynna" ;
  gryta_nn_1_N = mkN "gryta" ;
  graebba_nn_1_1_N = mkN "gräbba" ;
  graeddsnipa_nn_1_1_N = mkN "gräddsnipa" ;
  graeddtaarta_nn_1_1_N = mkN "gräddtårta" ;
  graefta_nn_1_1_N = mkN "gräfta" ;
  graensdragningsfraaga_nn_1_1_N = mkN "gränsdragningsfråga" ;
  graensnytta_nn_1_1_N = mkN "gränsnytta" ;
  graesfjaeril_nn_1_1_N = mkN "gräsfjäril" ;
  graeshoppa_nn_1_1_N = mkN "gräshoppa" ;
  graesmatta_nn_1_1_N = mkN "gräsmatta" ;
  graesnejlika_nn_1_1_N = mkN "gräsnejlika" ;
  graestorva_nn_1_1_N = mkN "grästorva" ;
  graestuva_nn_1_1_N = mkN "grästuva" ;
  graesaenka_nn_1_1_N = mkN "gräsänka" ;
  graevskopa_nn_1_1_N = mkN "grävskopa" ;
  graalla_nn_1_1_N = mkN "grålla" ;
  graasalva_nn_1_1_N = mkN "gråsalva" ;
  graasida_nn_1_1_N = mkN "gråsida" ;
  graasiska_nn_1_1_N = mkN "gråsiska" ;
  graasugga_nn_1_1_N = mkN "gråsugga" ;
  graaterska_nn_1_1_N = mkN "gråterska" ;
  graatonsskala_nn_1_1_N = mkN "gråtonsskala" ;
  graavacka_nn_1_1_N = mkN "gråvacka" ;
  groeda_nn_1_1_N = mkN "gröda" ;
  groenbena_nn_1_1_N = mkN "grönbena" ;
  groenkulla_nn_1_1_N = mkN "grönkulla" ;
  groenlaendska_nn_1_1_N = mkN "grönländska" ;
  groenlaendska_nn_2_1_N = mkN "grönländska" ;
  groenmalt_nn_1_1_N = mkN "grönmalt" ;
  groensakssoppa_nn_1_1_N = mkN "grönsakssoppa" ;
  groensiska_nn_1_1_N = mkN "grönsiska" ;
  groenska_nn_1_1_N = mkN "grönska" ;
  groenyta_nn_1_1_N = mkN "grönyta" ;
  guano_nn_1_N = mkN "guano" ;
  guatemalanska_nn_1_N = mkN "guatemalanska" ;
  gudagaava_nn_1_1_N = mkN "gudagåva" ;
  gudalaera_nn_1_1_N = mkN "gudalära" ;
  gudasaga_nn_1_N = mkN "gudasaga" ;
  gudinna_nn_1_N = mkN "gudinna" ;
  gudstjaenstdag_nn_1_1_N = mkN "gudstjänstdag" ;
  gudstro_nn_1_N = mkN "gudstro" ;
  guineanska_nn_1_N = mkN "guineanska" ;
  gula_nn_1_N = mkN "gula" ;
  gulblaasa_nn_1_1_N = mkN "gulblåsa" ;
  guldbaggegala_nn_1_N = mkN "guldbaggegala" ;
  guldgruva_nn_1_N = mkN "guldgruva" ;
  guldhoena_nn_1_1_N = mkN "guldhöna" ;
  guldkedja_nn_1_N = mkN "guldkedja" ;
  guldklocka_nn_1_N = mkN "guldklocka" ;
  guldkrona_nn_1_N = mkN "guldkrona" ;
  guldpenna_nn_1_N = mkN "guldpenna" ;
  guldpaerla_nn_1_1_N = mkN "guldpärla" ;
  guldtacka_nn_1_N = mkN "guldtacka" ;
  gullhoena_nn_1_1_N = mkN "gullhöna" ;
  gullpudra_nn_1_N = mkN "gullpudra" ;
  gullviva_nn_1_N = mkN "gullviva" ;
  gulmaara_nn_1_1_N = mkN "gulmåra" ;
  gulsippa_nn_1_N = mkN "gulsippa" ;
  gulskiva_nn_1_N = mkN "gulskiva" ;
  gulaerla_nn_1_1_N = mkN "gulärla" ;
  gumma_nn_1_N = mkN "gumma" ;
  gummiplatta_nn_1_N = mkN "gummiplatta" ;
  gummislaegga_nn_1_1_N = mkN "gummislägga" ;
  gumphoena_nn_1_1_N = mkN "gumphöna" ;
  gunga_nn_1_N = mkN "gunga" ;
  gungbraeda_nn_1_1_N = mkN "gungbräda" ;
  gura_nn_1_N = mkN "gura" ;
  gurka_nn_1_N = mkN "gurka" ;
  gurkskiva_nn_1_N = mkN "gurkskiva" ;
  gutniska_nn_1_N = mkN "gutniska" ;
  guyananska_nn_1_N = mkN "guyananska" ;
  gydja_nn_1_N = mkN "gydja" ;
  gylta_nn_1_N = mkN "gylta" ;
  gymnasieskola_nn_1_N = mkN "gymnasieskola" ;
  gyttja_nn_1_N = mkN "gyttja" ;
  gaedda_nn_1_1_N = mkN "gädda" ;
  gaeldstuga_nn_1_1_N = mkN "gäldstuga" ;
  gaeliska_nn_1_1_N = mkN "gäliska" ;
  gaeliska_nn_2_1_N = mkN "gäliska" ;
  gaelspringa_nn_1_1_N = mkN "gälspringa" ;
  gaenga_nn_1_1_N = mkN "gänga" ;
  gaengkloppa_nn_1_1_N = mkN "gängkloppa" ;
  gaerningslaera_nn_1_1_N = mkN "gärningslära" ;
  gaestflagga_nn_1_1_N = mkN "gästflagga" ;
  gaestlista_nn_1_1_N = mkN "gästlista" ;
  gaestriklaendska_nn_1_1_N = mkN "gästrikländska" ;
  gaestrikska_nn_1_1_N = mkN "gästrikska" ;
  gaagata_nn_1_1_N = mkN "gågata" ;
  gaangbana_nn_1_1_N = mkN "gångbana" ;
  gaangbro_nn_1_1_N = mkN "gångbro" ;
  gaanggata_nn_1_1_N = mkN "gånggata" ;
  gaardfarihandel_nn_1_1_N = mkN "gårdfarihandel" ;
  gaardslykta_nn_1_1_N = mkN "gårdslykta" ;
  gaaspenna_nn_1_1_N = mkN "gåspenna" ;
  gaata_nn_1_1_N = mkN "gåta" ;
  gaava_nn_1_1_N = mkN "gåva" ;
  goedselraenna_nn_1_1_N = mkN "gödselränna" ;
  goekblomma_nn_1_1_N = mkN "gökblomma" ;
  goekklocka_nn_1_1_N = mkN "gökklocka" ;
  goekotta_nn_1_1_N = mkN "gökotta" ;
  goektyta_nn_1_1_N = mkN "göktyta" ;
  goemma_nn_1_1_N = mkN "gömma" ;
  goeteborgska_nn_1_1_N = mkN "göteborgska" ;
  goeteborgska_nn_2_1_N = mkN "göteborgska" ;
  hacka_nn_1_N = mkN "hacka" ;
  hagelboessa_nn_1_1_N = mkN "hagelbössa" ;
  hagga_nn_1_N = mkN "hagga" ;
  haitiska_nn_1_N = mkN "haitiska" ;
  haitiska_nn_2_N = mkN "haitiska" ;
  hajfena_nn_1_N = mkN "hajfena" ;
  haka_nn_1_N = mkN "haka" ;
  hakeboessa_nn_1_1_N = mkN "hakebössa" ;
  hakkorsflagga_nn_1_N = mkN "hakkorsflagga" ;
  halkbana_nn_1_N = mkN "halkbana" ;
  hallkyrka_nn_1_N = mkN "hallkyrka" ;
  hallmatta_nn_1_N = mkN "hallmatta" ;
  hallongrotta_nn_1_N = mkN "hallongrotta" ;
  hallaendska_nn_1_1_N = mkN "halländska" ;
  hallaendska_nn_2_1_N = mkN "halländska" ;
  hallaaa_nn_1_1_N = mkN "hallåa" ;
  halmplatta_nn_1_N = mkN "halmplatta" ;
  halogenlampa_nn_1_N = mkN "halogenlampa" ;
  halskedja_nn_1_N = mkN "halskedja" ;
  halskota_nn_1_N = mkN "halskota" ;
  halva_nn_1_N = mkN "halva" ;
  halvapa_nn_1_N = mkN "halvapa" ;
  halvflaska_nn_1_N = mkN "halvflaska" ;
  halvmara_nn_1_N = mkN "halvmara" ;
  halvpanna_nn_1_N = mkN "halvpanna" ;
  halvskugga_nn_1_N = mkN "halvskugga" ;
  halvstrumpa_nn_1_N = mkN "halvstrumpa" ;
  halvtrappa_nn_1_N = mkN "halvtrappa" ;
  halvoe_nn_1_1_N = mkN "halvö" ;
  hambostinta_nn_1_N = mkN "hambostinta" ;
  hanblomma_nn_1_N = mkN "hanblomma" ;
  handboja_nn_1_N = mkN "handboja" ;
  handel_nn_1_N = mkN "handel" ;
  handelsflotta_nn_1_N = mkN "handelsflotta" ;
  handelshoegskola_nn_1_1_N = mkN "handelshögskola" ;
  handelsresa_nn_1_N = mkN "handelsresa" ;
  handelsskola_nn_1_N = mkN "handelsskola" ;
  handelsvara_nn_1_N = mkN "handelsvara" ;
  handflata_nn_1_N = mkN "handflata" ;
  handikappfraaga_nn_1_1_N = mkN "handikappfråga" ;
  handkassa_nn_1_N = mkN "handkassa" ;
  handlampa_nn_1_N = mkN "handlampa" ;
  handlingsmaenniska_nn_1_1_N = mkN "handlingsmänniska" ;
  handtralla_nn_1_N = mkN "handtralla" ;
  handvaeska_nn_1_1_N = mkN "handväska" ;
  handyxa_nn_1_N = mkN "handyxa" ;
  hangarfartygsflotta_nn_1_N = mkN "hangarfartygsflotta" ;
  harhona_nn_1_N = mkN "harhona" ;
  harmonika_nn_1_N = mkN "harmonika" ;
  harmonilaera_nn_1_1_N = mkN "harmonilära" ;
  harpa_nn_1_N = mkN "harpa" ;
  harpya_nn_1_N = mkN "harpya" ;
  harpyja_nn_1_N = mkN "harpyja" ;
  harskramla_nn_1_N = mkN "harskramla" ;
  harsyra_nn_1_N = mkN "harsyra" ;
  hasch_nn_1_N = mkN "hasch" ;
  haschhisch_nn_1_N = mkN "haschhisch" ;
  haschisch_nn_1_N = mkN "haschisch" ;
  hatkaensla_nn_1_1_N = mkN "hatkänsla" ;
  hatthylla_nn_1_N = mkN "hatthylla" ;
  havrekaka_nn_1_N = mkN "havrekaka" ;
  havsbotten_nn_1_N = mkN "havsbotten" ;
  havsfru_nn_1_N = mkN "havsfru" ;
  havskraefta_nn_1_1_N = mkN "havskräfta" ;
  havssula_nn_1_N = mkN "havssula" ;
  havsyta_nn_1_N = mkN "havsyta" ;
  hebreiska_nn_1_N = mkN "hebreiska" ;
  heder_nn_1_N = mkN "heder" ;
  hedersgaava_nn_1_1_N = mkN "hedersgåva" ;
  hederskaensla_nn_1_1_N = mkN "hederskänsla" ;
  hederspascha_nn_1_N = mkN "hederspascha" ;
  hejaramsa_nn_1_N = mkN "hejaramsa" ;
  hela_nn_1_N = mkN "hela" ;
  helgeflundra_nn_1_N = mkN "helgeflundra" ;
  helgongloria_nn_1_N = mkN "helgongloria" ;
  helikopterplatta_nn_1_N = mkN "helikopterplatta" ;
  helsida_nn_1_N = mkN "helsida" ;
  heltaeckningsmatta_nn_1_1_N = mkN "heltäckningsmatta" ;
  hemfoederska_nn_1_1_N = mkN "hemföderska" ;
  hemlaexa_nn_1_1_N = mkN "hemläxa" ;
  hemmafru_nn_1_N = mkN "hemmafru" ;
  hemresa_nn_1_N = mkN "hemresa" ;
  hemsida_nn_1_N = mkN "hemsida" ;
  hemvaernsstyrka_nn_1_1_N = mkN "hemvärnsstyrka" ;
  herdepipa_nn_1_N = mkN "herdepipa" ;
  heroinhandel_nn_1_N = mkN "heroinhandel" ;
  herpessalva_nn_1_N = mkN "herpessalva" ;
  herrbyxa_nn_1_N = mkN "herrbyxa" ;
  herredag_nn_1_N = mkN "herredag" ;
  herrsida_nn_1_N = mkN "herrsida" ;
  hertiginna_nn_1_N = mkN "hertiginna" ;
  hettitiska_nn_1_N = mkN "hettitiska" ;
  himmel_nn_1_N = mkN "himmel" ;
  himmelsfaerdsdag_nn_1_1_N = mkN "himmelsfärdsdag" ;
  hinderbana_nn_1_N = mkN "hinderbana" ;
  hinna_nn_1_N = mkN "hinna" ;
  hinnkraefta_nn_1_1_N = mkN "hinnkräfta" ;
  hippa_nn_1_N = mkN "hippa" ;
  hispa_nn_1_N = mkN "hispa" ;
  hitlista_nn_1_N = mkN "hitlista" ;
  hitresa_nn_1_N = mkN "hitresa" ;
  hjulmutterhylsa_nn_1_N = mkN "hjulmutterhylsa" ;
  hjulsida_nn_1_N = mkN "hjulsida" ;
  hjaelpgumma_nn_1_1_N = mkN "hjälpgumma" ;
  hjaelpreda_nn_1_1_N = mkN "hjälpreda" ;
  hjaeltekista_nn_1_1_N = mkN "hjältekista" ;
  hjaeltesaga_nn_1_1_N = mkN "hjältesaga" ;
  hjaeltinna_nn_1_1_N = mkN "hjältinna" ;
  hjaerna_nn_1_1_N = mkN "hjärna" ;
  hjaerngympa_nn_1_1_N = mkN "hjärngympa" ;
  hjaernhalva_nn_1_1_N = mkN "hjärnhalva" ;
  hjaernhinna_nn_1_1_N = mkN "hjärnhinna" ;
  hjaernskada_nn_1_1_N = mkN "hjärnskada" ;
  hjaertefraaga_nn_1_1_N = mkN "hjärtefråga" ;
  hjaertmussla_nn_1_1_N = mkN "hjärtmussla" ;
  hjaertstilla_nn_1_1_N = mkN "hjärtstilla" ;
  hjaessa_nn_1_1_N = mkN "hjässa" ;
  ho_nn_1_N = mkN "ho" ;
  hockeyklubba_nn_1_N = mkN "hockeyklubba" ;
  hollaendska_nn_1_1_N = mkN "holländska" ;
  hollaendska_nn_2_1_N = mkN "holländska" ;
  homma_nn_1_N = mkN "homma" ;
  hona_nn_1_N = mkN "hona" ;
  honblomma_nn_1_N = mkN "honblomma" ;
  honduranska_nn_1_N = mkN "honduranska" ;
  honungskaka_nn_1_N = mkN "honungskaka" ;
  hoppjerka_nn_1_N = mkN "hoppjerka" ;
  hora_nn_1_N = mkN "hora" ;
  horngaedda_nn_1_1_N = mkN "horngädda" ;
  hornhinna_nn_1_N = mkN "hornhinna" ;
  hornkrona_nn_1_N = mkN "hornkrona" ;
  hornsugga_nn_1_N = mkN "hornsugga" ;
  hornuggla_nn_1_N = mkN "hornuggla" ;
  hortensia_nn_1_N = mkN "hortensia" ;
  hosta_nn_1_N = mkN "hosta" ;
  hostia_nn_1_N = mkN "hostia" ;
  hotellmatta_nn_1_N = mkN "hotellmatta" ;
  hotellstaederska_nn_1_1_N = mkN "hotellstäderska" ;
  hottentotska_nn_1_N = mkN "hottentotska" ;
  hottentotska_nn_2_N = mkN "hottentotska" ;
  hudficka_nn_1_N = mkN "hudficka" ;
  hudolja_nn_1_N = mkN "hudolja" ;
  hudsalva_nn_1_N = mkN "hudsalva" ;
  hudspricka_nn_1_N = mkN "hudspricka" ;
  huggsexa_nn_1_N = mkN "huggsexa" ;
  huldra_nn_1_N = mkN "huldra" ;
  humla_nn_1_N = mkN "humla" ;
  humle_nn_1_N = mkN "humle" ;
  humleblomma_nn_1_N = mkN "humleblomma" ;
  hummertina_nn_1_N = mkN "hummertina" ;
  humussyra_nn_1_N = mkN "humussyra" ;
  humoermaenniska_nn_1_1_N = mkN "humörmänniska" ;
  hundapa_nn_1_N = mkN "hundapa" ;
  hundkoja_nn_1_N = mkN "hundkoja" ;
  hundloka_nn_1_N = mkN "hundloka" ;
  hundracka_nn_1_N = mkN "hundracka" ;
  hundrova_nn_1_N = mkN "hundrova" ;
  hurril_nn_1_N = mkN "hurril" ;
  husa_nn_1_N = mkN "husa" ;
  husdjursavel_nn_1_N = mkN "husdjursavel" ;
  husfluga_nn_1_N = mkN "husfluga" ;
  husfru_nn_1_N = mkN "husfru" ;
  husfoerestaandarinna_nn_1_1_N = mkN "husföreståndarinna" ;
  hushaallerska_nn_1_1_N = mkN "hushållerska" ;
  hushaallskassa_nn_1_1_N = mkN "hushållskassa" ;
  hushaallssyssla_nn_1_1_N = mkN "hushållssyssla" ;
  huslaenga_nn_1_1_N = mkN "huslänga" ;
  hussvala_nn_1_N = mkN "hussvala" ;
  hustrumisshandel_nn_1_N = mkN "hustrumisshandel" ;
  huva_nn_1_N = mkN "huva" ;
  huvudfraaga_nn_1_1_N = mkN "huvudfråga" ;
  huvudgata_nn_1_N = mkN "huvudgata" ;
  huvudmassa_nn_1_N = mkN "huvudmassa" ;
  huvudstyrka_nn_1_N = mkN "huvudstyrka" ;
  hydda_nn_1_N = mkN "hydda" ;
  hydra_nn_1_N = mkN "hydra" ;
  hydraulolja_nn_1_N = mkN "hydraulolja" ;
  hyena_nn_1_N = mkN "hyena" ;
  hygienfraaga_nn_1_1_N = mkN "hygienfråga" ;
  hylla_nn_1_N = mkN "hylla" ;
  hylsa_nn_1_N = mkN "hylsa" ;
  hynda_nn_1_N = mkN "hynda" ;
  hypotenusa_nn_1_N = mkN "hypotenusa" ;
  hyra_nn_1_N = mkN "hyra" ;
  hyrestvaaa_nn_1_1_N = mkN "hyrestvåa" ;
  hyska_nn_1_N = mkN "hyska" ;
  hysteri_nn_1_N = mkN "hysteri" ;
  hysterika_nn_1_N = mkN "hysterika" ;
  hytta_nn_1_N = mkN "hytta" ;
  haeckla_nn_1_1_N = mkN "häckla" ;
  haeckloeperska_nn_1_1_N = mkN "häcklöperska" ;
  haekta_nn_1_1_N = mkN "häkta" ;
  haella_nn_1_1_N = mkN "hälla" ;
  haelleflundra_nn_1_1_N = mkN "hälleflundra" ;
  haellkista_nn_1_1_N = mkN "hällkista" ;
  haelsena_nn_1_1_N = mkN "hälsena" ;
  haelsingska_nn_1_1_N = mkN "hälsingska" ;
  haelsingska_nn_2_1_N = mkN "hälsingska" ;
  haelsofara_nn_1_1_N = mkN "hälsofara" ;
  haelsokaella_nn_1_1_N = mkN "hälsokälla" ;
  haelsolaera_nn_1_1_N = mkN "hälsolära" ;
  haelta_nn_1_1_N = mkN "hälta" ;
  haemndgudinna_nn_1_1_N = mkN "hämndgudinna" ;
  haemtpizza_nn_1_1_N = mkN "hämtpizza" ;
  haengbana_nn_1_1_N = mkN "hängbana" ;
  haengbro_nn_1_1_N = mkN "hängbro" ;
  haengmatta_nn_1_1_N = mkN "hängmatta" ;
  haengraenna_nn_1_1_N = mkN "hängränna" ;
  haerdsmaelta_nn_1_1_N = mkN "härdsmälta" ;
  haerjedalska_nn_1_1_N = mkN "härjedalska" ;
  haerjedalska_nn_2_1_N = mkN "härjedalska" ;
  haermapa_nn_1_1_N = mkN "härmapa" ;
  haerskara_nn_1_1_N = mkN "härskara" ;
  haerskarinna_nn_1_1_N = mkN "härskarinna" ;
  haerva_nn_1_1_N = mkN "härva" ;
  haessja_nn_1_1_N = mkN "hässja" ;
  haestgrimma_nn_1_1_N = mkN "hästgrimma" ;
  haestkapploepningsbana_nn_1_1_N = mkN "hästkapplöpningsbana" ;
  haestkaerra_nn_1_1_N = mkN "hästkärra" ;
  haestraefsa_nn_1_1_N = mkN "hästräfsa" ;
  haetta_nn_1_1_N = mkN "hätta" ;
  haexa_nn_1_1_N = mkN "häxa" ;
  haala_nn_1_1_N = mkN "håla" ;
  haallbarhetsdag_nn_1_1_N = mkN "hållbarhetsdag" ;
  haallfasthetslaera_nn_1_1_N = mkN "hållfasthetslära" ;
  haalremsa_nn_1_1_N = mkN "hålremsa" ;
  haalspetskula_nn_1_1_N = mkN "hålspetskula" ;
  haarbotten_nn_1_1_N = mkN "hårbotten" ;
  haardblykula_nn_1_1_N = mkN "hårdblykula" ;
  haardvaluta_nn_1_1_N = mkN "hårdvaluta" ;
  haardvara_nn_1_1_N = mkN "hårdvara" ;
  haarfrissa_nn_1_1_N = mkN "hårfrissa" ;
  haarfrisoerska_nn_1_1_N = mkN "hårfrisörska" ;
  haarnaalskurva_nn_1_1_N = mkN "hårnålskurva" ;
  haarolja_nn_1_1_N = mkN "hårolja" ;
  haarpiska_nn_1_1_N = mkN "hårpiska" ;
  haarsida_nn_1_1_N = mkN "hårsida" ;
  haarslinga_nn_1_1_N = mkN "hårslinga" ;
  hoeftkurva_nn_1_1_N = mkN "höftkurva" ;
  hoegadel_nn_1_1_N = mkN "högadel" ;
  hoegbana_nn_1_1_N = mkN "högbana" ;
  hoegerkurva_nn_1_1_N = mkN "högerkurva" ;
  hoegeraara_nn_1_1_N = mkN "högeråra" ;
  hoegfaerdsblaasa_nn_1_1_N = mkN "högfärdsblåsa" ;
  hoeghastighetsbana_nn_1_1_N = mkN "höghastighetsbana" ;
  hoeghastighetshandel_nn_1_1_N = mkN "höghastighetshandel" ;
  hoeghastighetskamera_nn_1_1_N = mkN "höghastighetskamera" ;
  hoegkinesiska_nn_1_1_N = mkN "högkinesiska" ;
  hoegmaessa_nn_1_1_N = mkN "högmässa" ;
  hoegprosa_nn_1_1_N = mkN "högprosa" ;
  hoegsjoeflotta_nn_1_1_N = mkN "högsjöflotta" ;
  hoegskola_nn_1_1_N = mkN "högskola" ;
  hoegtyska_nn_1_1_N = mkN "högtyska" ;
  hoejdkarta_nn_1_1_N = mkN "höjdkarta" ;
  hoejdkurva_nn_1_1_N = mkN "höjdkurva" ;
  hoekuggla_nn_1_1_N = mkN "hökuggla" ;
  hoelja_nn_1_1_N = mkN "hölja" ;
  hoena_nn_1_1_N = mkN "höna" ;
  hoensgryta_nn_1_1_N = mkN "hönsgryta" ;
  hoenshjaerna_nn_1_1_N = mkN "hönshjärna" ;
  hoerna_nn_1_1_N = mkN "hörna" ;
  hoernflagga_nn_1_1_N = mkN "hörnflagga" ;
  hoernlampa_nn_1_1_N = mkN "hörnlampa" ;
  hoersaga_nn_1_1_N = mkN "hörsaga" ;
  hoerselskada_nn_1_1_N = mkN "hörselskada" ;
  hoerselsnaecka_nn_1_1_N = mkN "hörselsnäcka" ;
  hoerselvilla_nn_1_1_N = mkN "hörselvilla" ;
  hoersnaecka_nn_1_1_N = mkN "hörsnäcka" ;
  hoestdag_nn_1_1_N = mkN "höstdag" ;
  hoestgryta_nn_1_1_N = mkN "höstgryta" ;
  hoestgyttja_nn_1_1_N = mkN "höstgyttja" ;
  hoestkyla_nn_1_1_N = mkN "höstkyla" ;
  hoetjuga_nn_1_1_N = mkN "hötjuga" ;
  iakttagelsefoermaaga_nn_1_1_N = mkN "iakttagelseförmåga" ;
  id_bricka_nn_1_N = mkN "id-bricka" ;
  id_nn_3_N = mkN "id" ;
  idealmaenniska_nn_1_1_N = mkN "idealmänniska" ;
  identitetsbricka_nn_1_N = mkN "identitetsbricka" ;
  idrottsarena_nn_1_N = mkN "idrottsarena" ;
  idrottskvinna_nn_1_N = mkN "idrottskvinna" ;
  idrottsstjaerna_nn_1_1_N = mkN "idrottsstjärna" ;
  id_elaera_nn_1_1_N = mkN "idélära" ;
  id_elaera_nn_2_1_N = mkN "idélära" ;
  id_espruta_nn_1_1_N = mkN "idéspruta" ;
  illvilja_nn_1_N = mkN "illvilja" ;
  importfirma_nn_1_N = mkN "importfirma" ;
  improvisationsfoermaaga_nn_1_1_N = mkN "improvisationsförmåga" ;
  imruta_nn_1_N = mkN "imruta" ;
  inavel_nn_1_N = mkN "inavel" ;
  indexsiffra_nn_1_N = mkN "indexsiffra" ;
  indianhydda_nn_1_N = mkN "indianhydda" ;
  indiankvinna_nn_1_N = mkN "indiankvinna" ;
  indianska_nn_1_N = mkN "indianska" ;
  indikatorlampa_nn_1_N = mkN "indikatorlampa" ;
  indiska_nn_1_N = mkN "indiska" ;
  indonesiska_nn_1_N = mkN "indonesiska" ;
  indonesiska_nn_2_N = mkN "indonesiska" ;
  industriolja_nn_1_N = mkN "industriolja" ;
  industriolycka_nn_1_N = mkN "industriolycka" ;
  infantinna_nn_1_N = mkN "infantinna" ;
  infartsraenna_nn_1_1_N = mkN "infartsränna" ;
  influensa_nn_1_N = mkN "influensa" ;
  infravaerme_nn_1_1_N = mkN "infravärme" ;
  injektionsspruta_nn_1_N = mkN "injektionsspruta" ;
  inkomstklyfta_nn_1_N = mkN "inkomstklyfta" ;
  inkomstkaella_nn_1_1_N = mkN "inkomstkälla" ;
  inkomstsumma_nn_1_N = mkN "inkomstsumma" ;
  inkoepslista_nn_1_1_N = mkN "inköpslista" ;
  inlaga_nn_1_N = mkN "inlaga" ;
  inlandsbana_nn_1_N = mkN "inlandsbana" ;
  inlevelsefoermaaga_nn_1_1_N = mkN "inlevelseförmåga" ;
  inlaeggningsgurka_nn_1_1_N = mkN "inläggningsgurka" ;
  inlaemningsdag_nn_1_1_N = mkN "inlämningsdag" ;
  inlaaningsraenta_nn_1_1_N = mkN "inlåningsränta" ;
  innerbana_nn_1_N = mkN "innerbana" ;
  innerficka_nn_1_N = mkN "innerficka" ;
  innerkurva_nn_1_N = mkN "innerkurva" ;
  innersida_nn_1_N = mkN "innersida" ;
  inresa_nn_1_N = mkN "inresa" ;
  insatsstyrka_nn_1_N = mkN "insatsstyrka" ;
  inseglingsraenna_nn_1_1_N = mkN "inseglingsränna" ;
  insektsblomma_nn_1_N = mkN "insektsblomma" ;
  insida_nn_1_N = mkN "insida" ;
  insjoe_nn_1_1_N = mkN "insjö" ;
  inspirationskaella_nn_1_1_N = mkN "inspirationskälla" ;
  institutionsskada_nn_1_N = mkN "institutionsskada" ;
  instrumentbraeda_nn_1_1_N = mkN "instrumentbräda" ;
  instrumentlaada_nn_1_1_N = mkN "instrumentlåda" ;
  instrumentvaeska_nn_1_1_N = mkN "instrumentväska" ;
  intarsia_nn_1_N = mkN "intarsia" ;
  intelligentsia_nn_1_N = mkN "intelligentsia" ;
  internatskola_nn_1_N = mkN "internatskola" ;
  internetsida_nn_1_N = mkN "internetsida" ;
  intervjufraaga_nn_1_1_N = mkN "intervjufråga" ;
  intressefokus_nn_1_N = mkN "intressefokus" ;
  inventarielista_nn_1_N = mkN "inventarielista" ;
  invertsaapa_nn_1_1_N = mkN "invertsåpa" ;
  inaega_nn_1_1_N = mkN "inäga" ;
  irakiska_nn_1_N = mkN "irakiska" ;
  iranska_nn_1_N = mkN "iranska" ;
  iranska_nn_2_N = mkN "iranska" ;
  iriska_nn_1_N = mkN "iriska" ;
  iriska_nn_2_N = mkN "iriska" ;
  irlaendska_nn_1_1_N = mkN "irländska" ;
  irlaendska_nn_2_1_N = mkN "irländska" ;
  irrlaera_nn_1_1_N = mkN "irrlära" ;
  isbana_nn_1_N = mkN "isbana" ;
  isbjoernshona_nn_1_1_N = mkN "isbjörnshona" ;
  isblomma_nn_1_N = mkN "isblomma" ;
  isblaasa_nn_1_1_N = mkN "isblåsa" ;
  isgata_nn_1_N = mkN "isgata" ;
  ishavsdimma_nn_1_N = mkN "ishavsdimma" ;
  ishockeyklubba_nn_1_N = mkN "ishockeyklubba" ;
  iskana_nn_1_N = mkN "iskana" ;
  islandstroeja_nn_1_1_N = mkN "islandströja" ;
  islaendska_nn_1_1_N = mkN "isländska" ;
  islaendska_nn_2_1_N = mkN "isländska" ;
  ismassa_nn_1_N = mkN "ismassa" ;
  isoleringsruta_nn_1_N = mkN "isoleringsruta" ;
  isprinsessa_nn_1_N = mkN "isprinsessa" ;
  israeliska_nn_1_N = mkN "israeliska" ;
  israeffla_nn_1_1_N = mkN "isräffla" ;
  israenna_nn_1_1_N = mkN "isränna" ;
  issjoe_nn_1_1_N = mkN "issjö" ;
  isskrapa_nn_1_N = mkN "isskrapa" ;
  isterhaka_nn_1_N = mkN "isterhaka" ;
  isyxa_nn_1_N = mkN "isyxa" ;
  italienska_nn_1_N = mkN "italienska" ;
  italienska_nn_2_N = mkN "italienska" ;
  ivorianska_nn_1_N = mkN "ivorianska" ;
  jacka_nn_1_N = mkN "jacka" ;
  jacketkrona_nn_1_N = mkN "jacketkrona" ;
  jackettbyxa_nn_1_N = mkN "jackettbyxa" ;
  jackficka_nn_1_N = mkN "jackficka" ;
  jaglina_nn_1_N = mkN "jaglina" ;
  jakobinmoessa_nn_1_1_N = mkN "jakobinmössa" ;
  jaktresa_nn_1_N = mkN "jaktresa" ;
  jaktvaeska_nn_1_1_N = mkN "jaktväska" ;
  jamaicanska_nn_1_N = mkN "jamaicanska" ;
  januarikyla_nn_1_N = mkN "januarikyla" ;
  japanska_nn_1_N = mkN "japanska" ;
  japanska_nn_2_N = mkN "japanska" ;
  jeansficka_nn_1_N = mkN "jeansficka" ;
  jemenitiska_nn_1_N = mkN "jemenitiska" ;
  jenka_nn_1_N = mkN "jenka" ;
  jesuitorden_nn_1_N = mkN "jesuitorden" ;
  jet_lag_nn_1_N = mkN "jet-lag" ;
  jet_lagg_nn_1_N = mkN "jet-lagg" ;
  jetlag_nn_1_N = mkN "jetlag" ;
  jetlagg_nn_1_N = mkN "jetlagg" ;
  jetslinga_nn_1_N = mkN "jetslinga" ;
  jetaalder_nn_1_1_N = mkN "jetålder" ;
  jockeymoessa_nn_1_1_N = mkN "jockeymössa" ;
  johanniterorden_nn_1_N = mkN "johanniterorden" ;
  johannitorden_nn_1_N = mkN "johannitorden" ;
  jonfaella_nn_1_1_N = mkN "jonfälla" ;
  jonkaella_nn_1_1_N = mkN "jonkälla" ;
  jordanska_nn_1_N = mkN "jordanska" ;
  jordbana_nn_1_N = mkN "jordbana" ;
  jordhacka_nn_1_N = mkN "jordhacka" ;
  jordhaala_nn_1_1_N = mkN "jordhåla" ;
  jordkula_nn_1_N = mkN "jordkula" ;
  jordkaerna_nn_1_1_N = mkN "jordkärna" ;
  jordlega_nn_1_N = mkN "jordlega" ;
  jordloppa_nn_1_N = mkN "jordloppa" ;
  jordremsa_nn_1_N = mkN "jordremsa" ;
  jordraenta_nn_1_1_N = mkN "jordränta" ;
  jordstjaerna_nn_1_1_N = mkN "jordstjärna" ;
  jorduggla_nn_1_N = mkN "jorduggla" ;
  jordyta_nn_1_N = mkN "jordyta" ;
  jordaertskocka_nn_1_1_N = mkN "jordärtskocka" ;
  jubelaasna_nn_1_1_N = mkN "jubelåsna" ;
  judetyska_nn_1_N = mkN "judetyska" ;
  judinna_nn_1_N = mkN "judinna" ;
  juft_nn_1_N = mkN "juft" ;
  juggemaffia_nn_1_N = mkN "juggemaffia" ;
  jugoslaviska_nn_1_N = mkN "jugoslaviska" ;
  julfemma_nn_1_N = mkN "julfemma" ;
  julgranskula_nn_1_N = mkN "julgranskula" ;
  julgransmatta_nn_1_N = mkN "julgransmatta" ;
  julgaava_nn_1_1_N = mkN "julgåva" ;
  julhandel_nn_1_N = mkN "julhandel" ;
  julifoermiddag_nn_1_1_N = mkN "juliförmiddag" ;
  juligroenska_nn_1_1_N = mkN "juligrönska" ;
  julkrubba_nn_1_N = mkN "julkrubba" ;
  julotta_nn_1_N = mkN "julotta" ;
  julskinka_nn_1_N = mkN "julskinka" ;
  julstjaerna_nn_1_1_N = mkN "julstjärna" ;
  julstrumpa_nn_1_N = mkN "julstrumpa" ;
  jungfruresa_nn_1_N = mkN "jungfruresa" ;
  jungfruslaenda_nn_1_1_N = mkN "jungfruslända" ;
  junta_nn_1_N = mkN "junta" ;
  jurta_nn_1_N = mkN "jurta" ;
  jute_nn_1_N = mkN "jute" ;
  jyllaendska_nn_1_1_N = mkN "jylländska" ;
  jyllaendska_nn_2_1_N = mkN "jylländska" ;
  jaegarstenaalder_nn_1_1_N = mkN "jägarstenålder" ;
  jaemstaelldhetsskilsmaessa_nn_1_1_N = mkN "jämställdhetsskilsmässa" ;
  jaemtlaendska_nn_1_1_N = mkN "jämtländska" ;
  jaemtlaendska_nn_2_1_N = mkN "jämtländska" ;
  jaemtska_nn_1_1_N = mkN "jämtska" ;
  jaemtska_nn_2_1_N = mkN "jämtska" ;
  jaenta_nn_1_1_N = mkN "jänta" ;
  jaernbana_nn_1_1_N = mkN "järnbana" ;
  jaernkaerna_nn_1_1_N = mkN "järnkärna" ;
  jaernlunga_nn_1_1_N = mkN "järnlunga" ;
  jaernsmaelta_nn_1_1_N = mkN "järnsmälta" ;
  jaernvara_nn_1_1_N = mkN "järnvara" ;
  jaernvilja_nn_1_1_N = mkN "järnvilja" ;
  jaernvaegsbro_nn_1_1_N = mkN "järnvägsbro" ;
  jaernvaegsskena_nn_1_1_N = mkN "järnvägsskena" ;
  jaernyxa_nn_1_1_N = mkN "järnyxa" ;
  jaernaalder_nn_1_1_N = mkN "järnålder" ;
  jaettebubbla_nn_1_1_N = mkN "jättebubbla" ;
  jaettegryta_nn_1_1_N = mkN "jättegryta" ;
  jaettekvinna_nn_1_1_N = mkN "jättekvinna" ;
  jaettestjaerna_nn_1_1_N = mkN "jättestjärna" ;
  jaetteoedla_nn_1_1_N = mkN "jätteödla" ;
  jaettinna_nn_1_1_N = mkN "jättinna" ;
  jaevsfraaga_nn_1_1_N = mkN "jävsfråga" ;
  kabbeleka_nn_1_N = mkN "kabbeleka" ;
  kabbleka_nn_1_N = mkN "kabbleka" ;
  kabelbro_nn_1_N = mkN "kabelbro" ;
  kabelvinda_nn_1_N = mkN "kabelvinda" ;
  kabinettsfraaga_nn_1_1_N = mkN "kabinettsfråga" ;
  kabinvaeska_nn_1_1_N = mkN "kabinväska" ;
  kackerlacka_nn_1_N = mkN "kackerlacka" ;
  kadettskola_nn_1_N = mkN "kadettskola" ;
  kafeteria_nn_1_N = mkN "kafeteria" ;
  kaffebricka_nn_1_N = mkN "kaffebricka" ;
  kaffeboena_nn_1_1_N = mkN "kaffeböna" ;
  kaffehalva_nn_1_N = mkN "kaffehalva" ;
  kaffehurra_nn_1_N = mkN "kaffehurra" ;
  kaffekanna_nn_1_N = mkN "kaffekanna" ;
  kaffepanna_nn_1_N = mkN "kaffepanna" ;
  kaja_nn_1_N = mkN "kaja" ;
  kajalpenna_nn_1_N = mkN "kajalpenna" ;
  kajuta_nn_1_N = mkN "kajuta" ;
  kaka_nn_1_N = mkN "kaka" ;
  kakadua_nn_1_N = mkN "kakadua" ;
  kakao_nn_1_N = mkN "kakao" ;
  kakaoboena_nn_1_1_N = mkN "kakaoböna" ;
  kakelplatta_nn_1_N = mkN "kakelplatta" ;
  kakelugnslucka_nn_1_N = mkN "kakelugnslucka" ;
  kalabasspumpa_nn_1_N = mkN "kalabasspumpa" ;
  kalasbyxa_nn_1_N = mkN "kalasbyxa" ;
  kalaskula_nn_1_N = mkN "kalaskula" ;
  kalaspingla_nn_1_N = mkN "kalaspingla" ;
  kalciumsulfat_nn_1_N = mkN "kalciumsulfat" ;
  kalebasspumpa_nn_1_N = mkN "kalebasspumpa" ;
  kalendervecka_nn_1_N = mkN "kalendervecka" ;
  kaliumsulfat_nn_1_N = mkN "kaliumsulfat" ;
  kalkerlaerft_nn_1_1_N = mkN "kalkerlärft" ;
  kalkstensplatta_nn_1_N = mkN "kalkstensplatta" ;
  kalla_nn_1_N = mkN "kalla" ;
  kallelselista_nn_1_N = mkN "kallelselista" ;
  kallhyra_nn_1_N = mkN "kallhyra" ;
  kallkaella_nn_1_1_N = mkN "kallkälla" ;
  kallskaenka_nn_1_1_N = mkN "kallskänka" ;
  kalvlaeggsgryta_nn_1_1_N = mkN "kalvläggsgryta" ;
  kalvsylta_nn_1_N = mkN "kalvsylta" ;
  kamarilla_nn_1_N = mkN "kamarilla" ;
  kambodjanska_nn_1_N = mkN "kambodjanska" ;
  kamelia_nn_1_N = mkN "kamelia" ;
  kamelklocka_nn_1_N = mkN "kamelklocka" ;
  kamera_nn_1_N = mkN "kamera" ;
  kamerunska_nn_1_N = mkN "kamerunska" ;
  kamkofta_nn_1_N = mkN "kamkofta" ;
  kammarfru_nn_1_N = mkN "kammarfru" ;
  kammussla_nn_1_N = mkN "kammussla" ;
  kampvilja_nn_1_N = mkN "kampvilja" ;
  kana_nn_1_N = mkN "kana" ;
  kanadensiska_nn_1_N = mkN "kanadensiska" ;
  kandidatlista_nn_1_N = mkN "kandidatlista" ;
  kanelbulla_nn_1_N = mkN "kanelbulla" ;
  kanelflaeta_nn_1_1_N = mkN "kanelfläta" ;
  kaninhaala_nn_1_1_N = mkN "kaninhåla" ;
  kanna_nn_1_N = mkN "kanna" ;
  kannibalgryta_nn_1_N = mkN "kannibalgryta" ;
  kanonkula_nn_1_N = mkN "kanonkula" ;
  kanonlucka_nn_1_N = mkN "kanonlucka" ;
  kanotresa_nn_1_N = mkN "kanotresa" ;
  kanslisvenska_nn_1_N = mkN "kanslisvenska" ;
  kantblomma_nn_1_N = mkN "kantblomma" ;
  kantilena_nn_1_N = mkN "kantilena" ;
  kaolin_nn_1_N = mkN "kaolin" ;
  kapduva_nn_1_N = mkN "kapduva" ;
  kapitalvara_nn_1_N = mkN "kapitalvara" ;
  kappa_nn_1_N = mkN "kappa" ;
  kapphylla_nn_1_N = mkN "kapphylla" ;
  kapskiva_nn_1_N = mkN "kapskiva" ;
  kapucinapa_nn_1_N = mkN "kapucinapa" ;
  kapucinerorden_nn_1_N = mkN "kapucinerorden" ;
  kapucinorden_nn_1_N = mkN "kapucinorden" ;
  kapverdiska_nn_1_N = mkN "kapverdiska" ;
  kapybara_nn_1_N = mkN "kapybara" ;
  kara_nn_1_N = mkN "kara" ;
  karakteristika_nn_1_N = mkN "karakteristika" ;
  karaktaeristika_nn_1_1_N = mkN "karaktäristika" ;
  karaktaersstyrka_nn_1_1_N = mkN "karaktärsstyrka" ;
  karbidlampa_nn_1_N = mkN "karbidlampa" ;
  karbolsyra_nn_1_N = mkN "karbolsyra" ;
  karbonkopia_nn_1_N = mkN "karbonkopia" ;
  karbonsyra_nn_1_N = mkN "karbonsyra" ;
  karboxylsyra_nn_1_N = mkN "karboxylsyra" ;
  karda_nn_1_N = mkN "karda" ;
  karduan_nn_1_N = mkN "karduan" ;
  karelska_nn_1_N = mkN "karelska" ;
  karelska_nn_2_N = mkN "karelska" ;
  kareta_nn_1_N = mkN "kareta" ;
  karl_nn_1_N = mkN "karl" ;
  karlakarl_nn_1_N = mkN "karlakarl" ;
  karljohanssoffa_nn_1_N = mkN "karljohanssoffa" ;
  karltorka_nn_1_N = mkN "karltorka" ;
  karmeliterorden_nn_1_N = mkN "karmeliterorden" ;
  karmelitorden_nn_1_N = mkN "karmelitorden" ;
  karmin_nn_1_N = mkN "karmin" ;
  karminsyra_nn_1_N = mkN "karminsyra" ;
  karmosin_nn_1_N = mkN "karmosin" ;
  karta_nn_1_N = mkN "karta" ;
  karteschkula_nn_1_N = mkN "karteschkula" ;
  kartlampa_nn_1_N = mkN "kartlampa" ;
  kartlaesarlampa_nn_1_1_N = mkN "kartläsarlampa" ;
  kartotekslaada_nn_1_1_N = mkN "kartotekslåda" ;
  kartusianerorden_nn_1_N = mkN "kartusianerorden" ;
  kartusianorden_nn_1_N = mkN "kartusianorden" ;
  kaschmir_nn_1_N = mkN "kaschmir" ;
  kaschmirtroeja_nn_1_1_N = mkN "kaschmirtröja" ;
  kashmirtroeja_nn_1_1_N = mkN "kashmirtröja" ;
  kasperdocka_nn_1_N = mkN "kasperdocka" ;
  kassa_nn_1_N = mkN "kassa" ;
  kassa_nn_2_N = mkN "kassa" ;
  kassakista_nn_1_N = mkN "kassakista" ;
  kassalaada_nn_1_1_N = mkN "kassalåda" ;
  kassoerska_nn_1_1_N = mkN "kassörska" ;
  kastbana_nn_1_N = mkN "kastbana" ;
  kastilianska_nn_1_N = mkN "kastilianska" ;
  kastilianska_nn_2_N = mkN "kastilianska" ;
  kasuslaera_nn_1_1_N = mkN "kasuslära" ;
  kat_nn_1_N = mkN "kat" ;
  katalanska_nn_1_N = mkN "katalanska" ;
  katalanska_nn_2_N = mkN "katalanska" ;
  kataloglaada_nn_1_1_N = mkN "kataloglåda" ;
  katastrofkaensla_nn_1_1_N = mkN "katastrofkänsla" ;
  katastrofsiffra_nn_1_N = mkN "katastrofsiffra" ;
  katedralsklocka_nn_1_N = mkN "katedralsklocka" ;
  katedralskola_nn_1_N = mkN "katedralskola" ;
  katsa_nn_1_N = mkN "katsa" ;
  katta_nn_1_N = mkN "katta" ;
  kattgina_nn_1_N = mkN "kattgina" ;
  kattlucka_nn_1_N = mkN "kattlucka" ;
  kattuggla_nn_1_N = mkN "kattuggla" ;
  kaukasiska_nn_1_N = mkN "kaukasiska" ;
  kaustika_nn_1_N = mkN "kaustika" ;
  kavajficka_nn_1_N = mkN "kavajficka" ;
  kavelbro_nn_1_N = mkN "kavelbro" ;
  kazakiska_nn_1_N = mkN "kazakiska" ;
  kazakiska_nn_2_N = mkN "kazakiska" ;
  kedja_nn_1_N = mkN "kedja" ;
  kejsarinna_nn_1_N = mkN "kejsarinna" ;
  kejsarkrona_nn_1_N = mkN "kejsarkrona" ;
  keltiska_nn_1_N = mkN "keltiska" ;
  keltiska_nn_2_N = mkN "keltiska" ;
  kenyanska_nn_1_N = mkN "kenyanska" ;
  keramikkruka_nn_1_N = mkN "keramikkruka" ;
  keramiklampa_nn_1_N = mkN "keramiklampa" ;
  keramikskaerva_nn_1_1_N = mkN "keramikskärva" ;
  kicka_nn_1_N = mkN "kicka" ;
  kilremsskiva_nn_1_N = mkN "kilremsskiva" ;
  kindkedja_nn_1_N = mkN "kindkedja" ;
  kindknota_nn_1_N = mkN "kindknota" ;
  kindkota_nn_1_N = mkN "kindkota" ;
  kinesiska_nn_1_N = mkN "kinesiska" ;
  kinesiska_nn_2_N = mkN "kinesiska" ;
  kinin_nn_1_N = mkN "kinin" ;
  kirgisiska_nn_1_N = mkN "kirgisiska" ;
  kirgisiska_nn_2_N = mkN "kirgisiska" ;
  kirgiziska_nn_1_N = mkN "kirgiziska" ;
  kirgiziska_nn_2_N = mkN "kirgiziska" ;
  kiribatiska_nn_1_N = mkN "kiribatiska" ;
  kisel_nn_1_N = mkN "kisel" ;
  kiselgur_nn_1_N = mkN "kiselgur" ;
  kiselplatta_nn_1_N = mkN "kiselplatta" ;
  kiselsyra_nn_1_N = mkN "kiselsyra" ;
  kista_nn_1_N = mkN "kista" ;
  kitin_nn_1_N = mkN "kitin" ;
  kitsch_nn_1_N = mkN "kitsch" ;
  kjusa_nn_1_N = mkN "kjusa" ;
  kladdkaka_nn_1_N = mkN "kladdkaka" ;
  klaffbro_nn_1_N = mkN "klaffbro" ;
  klagovisa_nn_1_N = mkN "klagovisa" ;
  klangbotten_nn_1_N = mkN "klangbotten" ;
  klappa_nn_1_N = mkN "klappa" ;
  klappbrygga_nn_1_N = mkN "klappbrygga" ;
  klappbraeda_nn_1_1_N = mkN "klappbräda" ;
  klassklyfta_nn_1_N = mkN "klassklyfta" ;
  klasslista_nn_1_N = mkN "klasslista" ;
  klassmamma_nn_1_N = mkN "klassmamma" ;
  klasspappa_nn_1_N = mkN "klasspappa" ;
  klassresa_nn_1_N = mkN "klassresa" ;
  klentro_nn_1_N = mkN "klentro" ;
  klimakteriehaexa_nn_1_1_N = mkN "klimakteriehäxa" ;
  klimatfraaga_nn_1_1_N = mkN "klimatfråga" ;
  klimatlaera_nn_1_1_N = mkN "klimatlära" ;
  klinga_nn_1_N = mkN "klinga" ;
  klinka_nn_1_N = mkN "klinka" ;
  klippa_nn_1_N = mkN "klippa" ;
  klippdocka_nn_1_N = mkN "klippdocka" ;
  klipphaala_nn_1_1_N = mkN "klipphåla" ;
  klippskreva_nn_1_N = mkN "klippskreva" ;
  klippstuga_nn_1_N = mkN "klippstuga" ;
  klisterremsa_nn_1_N = mkN "klisterremsa" ;
  klivstaetta_nn_1_1_N = mkN "klivstätta" ;
  klocka_nn_1_N = mkN "klocka" ;
  klockgroda_nn_1_N = mkN "klockgroda" ;
  klockkedja_nn_1_N = mkN "klockkedja" ;
  klorlaecka_nn_1_1_N = mkN "klorläcka" ;
  klorofyll_nn_1_N = mkN "klorofyll" ;
  klorsyra_nn_1_N = mkN "klorsyra" ;
  klorvaetesyra_nn_1_1_N = mkN "klorvätesyra" ;
  klosterkyrka_nn_1_N = mkN "klosterkyrka" ;
  klosterorden_nn_1_N = mkN "klosterorden" ;
  klotyta_nn_1_N = mkN "klotyta" ;
  klubba_nn_1_N = mkN "klubba" ;
  klubbjacka_nn_1_N = mkN "klubbjacka" ;
  klumpsumma_nn_1_N = mkN "klumpsumma" ;
  klunga_nn_1_N = mkN "klunga" ;
  klyfta_nn_1_N = mkN "klyfta" ;
  klyka_nn_1_N = mkN "klyka" ;
  klyscha_nn_1_N = mkN "klyscha" ;
  klyvyxa_nn_1_N = mkN "klyvyxa" ;
  klaednypa_nn_1_1_N = mkN "klädnypa" ;
  klaedtrasa_nn_1_1_N = mkN "klädtrasa" ;
  klaemma_nn_1_1_N = mkN "klämma" ;
  klaengranka_nn_1_1_N = mkN "klängranka" ;
  kloeversnaerja_nn_1_1_N = mkN "klöversnärja" ;
  kloevsadelkyrka_nn_1_1_N = mkN "klövsadelkyrka" ;
  kloevsadelskyrka_nn_1_1_N = mkN "klövsadelskyrka" ;
  knalldosa_nn_1_N = mkN "knalldosa" ;
  knapadel_nn_1_N = mkN "knapadel" ;
  knapphaalsblomma_nn_1_1_N = mkN "knapphålsblomma" ;
  knarkhandel_nn_1_N = mkN "knarkhandel" ;
  knarkhaerva_nn_1_1_N = mkN "knarkhärva" ;
  knipa_nn_1_N = mkN "knipa" ;
  knippa_nn_1_N = mkN "knippa" ;
  knivlaada_nn_1_1_N = mkN "knivlåda" ;
  knivslida_nn_1_N = mkN "knivslida" ;
  knota_nn_1_N = mkN "knota" ;
  knottra_nn_1_N = mkN "knottra" ;
  knuta_nn_1_N = mkN "knuta" ;
  knutlampa_nn_1_N = mkN "knutlampa" ;
  knutpiska_nn_1_N = mkN "knutpiska" ;
  knyppeldyna_nn_1_N = mkN "knyppeldyna" ;
  knaebyxa_nn_1_1_N = mkN "knäbyxa" ;
  knaeckfraaga_nn_1_1_N = mkN "knäckfråga" ;
  knaeppkaenga_nn_1_1_N = mkN "knäppkänga" ;
  knaeskada_nn_1_1_N = mkN "knäskada" ;
  knaestrumpa_nn_1_1_N = mkN "knästrumpa" ;
  koala_nn_1_N = mkN "koala" ;
  kobra_nn_1_N = mkN "kobra" ;
  kobrygga_nn_1_N = mkN "kobrygga" ;
  kocka_nn_1_N = mkN "kocka" ;
  kockmoessa_nn_1_1_N = mkN "kockmössa" ;
  kodein_nn_1_N = mkN "kodein" ;
  koffein_nn_1_N = mkN "koffein" ;
  kofferdiflotta_nn_1_N = mkN "kofferdiflotta" ;
  kofta_nn_1_N = mkN "kofta" ;
  kohandel_nn_1_N = mkN "kohandel" ;
  koine_nn_1_N = mkN "koine" ;
  koja_nn_1_N = mkN "koja" ;
  koka_nn_1_N = mkN "koka" ;
  kokain_nn_1_N = mkN "kokain" ;
  kokainhandel_nn_1_N = mkN "kokainhandel" ;
  kokainliga_nn_1_N = mkN "kokainliga" ;
  kokakola_nn_1_N = mkN "kokakola" ;
  kokerska_nn_1_N = mkN "kokerska" ;
  koklaada_nn_1_1_N = mkN "koklåda" ;
  koklaaga_nn_1_1_N = mkN "koklåga" ;
  kokoskaka_nn_1_N = mkN "kokoskaka" ;
  kokosmatta_nn_1_N = mkN "kokosmatta" ;
  kokplatta_nn_1_N = mkN "kokplatta" ;
  kola_nn_1_N = mkN "kola" ;
  kola_nn_2_N = mkN "kola" ;
  kolartro_nn_1_N = mkN "kolartro" ;
  kolbotten_nn_1_N = mkN "kolbotten" ;
  koleraflagga_nn_1_N = mkN "koleraflagga" ;
  kolesterol_nn_1_N = mkN "kolesterol" ;
  kolgruva_nn_1_N = mkN "kolgruva" ;
  kolgruveolycka_nn_1_N = mkN "kolgruveolycka" ;
  kolja_nn_1_N = mkN "kolja" ;
  kolmila_nn_1_N = mkN "kolmila" ;
  kolonialvara_nn_1_N = mkN "kolonialvara" ;
  kolonistuga_nn_1_N = mkN "kolonistuga" ;
  koloratursaangerska_nn_1_1_N = mkN "koloratursångerska" ;
  kolstybbsbana_nn_1_N = mkN "kolstybbsbana" ;
  kolsyra_nn_1_N = mkN "kolsyra" ;
  koltaalder_nn_1_1_N = mkN "koltålder" ;
  koma_nn_1_N = mkN "koma" ;
  kombinationsfoermaaga_nn_1_1_N = mkN "kombinationsförmåga" ;
  kommandobrygga_nn_1_N = mkN "kommandobrygga" ;
  kommunistgerilla_nn_1_N = mkN "kommunistgerilla" ;
  komocka_nn_1_N = mkN "komocka" ;
  komoriska_nn_1_N = mkN "komoriska" ;
  kompaktkamera_nn_1_N = mkN "kompaktkamera" ;
  kompaktskiva_nn_1_N = mkN "kompaktskiva" ;
  kompoundkaerna_nn_1_1_N = mkN "kompoundkärna" ;
  kompromissvilja_nn_1_N = mkN "kompromissvilja" ;
  kona_nn_1_N = mkN "kona" ;
  koncentrationsfoermaaga_nn_1_1_N = mkN "koncentrationsförmåga" ;
  kondens_nn_1_N = mkN "kondens" ;
  kondensationskaerna_nn_1_1_N = mkN "kondensationskärna" ;
  kondensstrimma_nn_1_N = mkN "kondensstrimma" ;
  konfirmandresa_nn_1_N = mkN "konfirmandresa" ;
  kongolesiska_nn_1_N = mkN "kongolesiska" ;
  konjakskupa_nn_1_N = mkN "konjakskupa" ;
  konjunkturkurva_nn_1_N = mkN "konjunkturkurva" ;
  konkursmassa_nn_1_N = mkN "konkursmassa" ;
  konstliga_nn_1_N = mkN "konstliga" ;
  konstmassa_nn_1_N = mkN "konstmassa" ;
  konstskola_nn_1_N = mkN "konstskola" ;
  konsulinna_nn_1_N = mkN "konsulinna" ;
  konsumentfraaga_nn_1_1_N = mkN "konsumentfråga" ;
  konsumtionsvara_nn_1_N = mkN "konsumtionsvara" ;
  kontaktkopia_nn_1_N = mkN "kontaktkopia" ;
  kontorsflicka_nn_1_N = mkN "kontorsflicka" ;
  kontorsraatta_nn_1_1_N = mkN "kontorsråtta" ;
  kontorsvana_nn_1_N = mkN "kontorsvana" ;
  konungakrona_nn_1_N = mkN "konungakrona" ;
  kopia_nn_1_N = mkN "kopia" ;
  koppa_nn_1_N = mkN "koppa" ;
  koppargruva_nn_1_N = mkN "koppargruva" ;
  kopparaalder_nn_1_1_N = mkN "kopparålder" ;
  kopparoedla_nn_1_1_N = mkN "kopparödla" ;
  koptiska_nn_1_N = mkN "koptiska" ;
  kopula_nn_1_N = mkN "kopula" ;
  koralloe_nn_1_1_N = mkN "korallö" ;
  korda_nn_1_N = mkN "korda" ;
  koreanska_nn_1_N = mkN "koreanska" ;
  koreanska_nn_2_N = mkN "koreanska" ;
  korkboessa_nn_1_1_N = mkN "korkbössa" ;
  korkmassa_nn_1_N = mkN "korkmassa" ;
  korkmatta_nn_1_N = mkN "korkmatta" ;
  korksula_nn_1_N = mkN "korksula" ;
  korniska_nn_1_N = mkN "korniska" ;
  korona_nn_1_N = mkN "korona" ;
  korruptionshaerva_nn_1_1_N = mkN "korruptionshärva" ;
  korsbensflaeta_nn_1_1_N = mkN "korsbensfläta" ;
  korsikanska_nn_1_N = mkN "korsikanska" ;
  korsikanska_nn_2_N = mkN "korsikanska" ;
  korskota_nn_1_N = mkN "korskota" ;
  korskyrka_nn_1_N = mkN "korskyrka" ;
  kortbyxa_nn_1_N = mkN "kortbyxa" ;
  kortlaada_nn_1_1_N = mkN "kortlåda" ;
  kortprosa_nn_1_N = mkN "kortprosa" ;
  kortrunda_nn_1_N = mkN "kortrunda" ;
  kortsida_nn_1_N = mkN "kortsida" ;
  korttidsvecka_nn_1_N = mkN "korttidsvecka" ;
  kortvara_nn_1_N = mkN "kortvara" ;
  kortaenda_nn_1_1_N = mkN "kortända" ;
  korvgryta_nn_1_N = mkN "korvgryta" ;
  korvkaka_nn_1_N = mkN "korvkaka" ;
  korvmacka_nn_1_N = mkN "korvmacka" ;
  korvsjoe_nn_1_1_N = mkN "korvsjö" ;
  korvskiva_nn_1_N = mkN "korvskiva" ;
  kosa_nn_1_N = mkN "kosa" ;
  koskaella_nn_1_1_N = mkN "koskälla" ;
  kosovanska_nn_1_N = mkN "kosovanska" ;
  kossa_nn_1_N = mkN "kossa" ;
  kostvana_nn_1_N = mkN "kostvana" ;
  kota_nn_1_N = mkN "kota" ;
  krabba_nn_1_N = mkN "krabba" ;
  krabbtaska_nn_1_N = mkN "krabbtaska" ;
  kraftkaella_nn_1_1_N = mkN "kraftkälla" ;
  kramla_nn_1_N = mkN "kramla" ;
  krampa_nn_1_N = mkN "krampa" ;
  kranskulla_nn_1_N = mkN "kranskulla" ;
  krasch_nn_1_N = mkN "krasch" ;
  kraterbotten_nn_1_N = mkN "kraterbotten" ;
  kratersjoe_nn_1_1_N = mkN "kratersjö" ;
  kratta_nn_1_N = mkN "kratta" ;
  kreditoro_nn_1_N = mkN "kreditoro" ;
  kremla_nn_1_N = mkN "kremla" ;
  kreolska_nn_1_N = mkN "kreolska" ;
  kreolska_nn_2_N = mkN "kreolska" ;
  kreosotolja_nn_1_N = mkN "kreosotolja" ;
  kria_nn_1_N = mkN "kria" ;
  kricka_nn_1_N = mkN "kricka" ;
  krigaradel_nn_1_N = mkN "krigaradel" ;
  krigsflotta_nn_1_N = mkN "krigsflotta" ;
  krigsgudinna_nn_1_N = mkN "krigsgudinna" ;
  krigssjukskoeterska_nn_1_1_N = mkN "krigssjuksköterska" ;
  krigsskada_nn_1_N = mkN "krigsskada" ;
  kringla_nn_1_N = mkN "kringla" ;
  kristallkrona_nn_1_N = mkN "kristallkrona" ;
  kristallkula_nn_1_N = mkN "kristallkula" ;
  kristallolja_nn_1_N = mkN "kristallolja" ;
  krita_nn_1_N = mkN "krita" ;
  kritpipa_nn_1_N = mkN "kritpipa" ;
  kroatiska_nn_1_N = mkN "kroatiska" ;
  kroatiska_nn_2_N = mkN "kroatiska" ;
  krogronda_nn_1_N = mkN "krogronda" ;
  krogrunda_nn_1_N = mkN "krogrunda" ;
  kroknaesa_nn_1_1_N = mkN "kroknäsa" ;
  krom_nn_1_N = mkN "krom" ;
  kromsyra_nn_1_N = mkN "kromsyra" ;
  krona_nn_1_N = mkN "krona" ;
  kronprinsessa_nn_1_N = mkN "kronprinsessa" ;
  kronaertskocka_nn_1_1_N = mkN "kronärtskocka" ;
  kronaertskocksbotten_nn_1_1_N = mkN "kronärtskocksbotten" ;
  kroppkaka_nn_1_N = mkN "kroppkaka" ;
  kroppshydda_nn_1_N = mkN "kroppshydda" ;
  kroppsskada_nn_1_N = mkN "kroppsskada" ;
  kroppsstrumpa_nn_1_N = mkN "kroppsstrumpa" ;
  kroppsstyrka_nn_1_N = mkN "kroppsstyrka" ;
  kroppsvaetska_nn_1_1_N = mkN "kroppsvätska" ;
  krosskada_nn_1_N = mkN "krosskada" ;
  krubba_nn_1_N = mkN "krubba" ;
  kruka_nn_1_N = mkN "kruka" ;
  krukskaerva_nn_1_1_N = mkN "krukskärva" ;
  krusta_nn_1_N = mkN "krusta" ;
  krycka_nn_1_N = mkN "krycka" ;
  krydda_nn_1_N = mkN "krydda" ;
  krydda_nn_2_N = mkN "krydda" ;
  kryddnejlika_nn_1_N = mkN "kryddnejlika" ;
  krypta_nn_1_N = mkN "krypta" ;
  krypton_nn_1_N = mkN "krypton" ;
  krysantemumplanta_nn_1_N = mkN "krysantemumplanta" ;
  kraeckla_nn_1_1_N = mkN "kräckla" ;
  kraefta_nn_1_1_N = mkN "kräfta" ;
  kraefta_nn_2_1_N = mkN "kräfta" ;
  kraeftskiva_nn_1_1_N = mkN "kräftskiva" ;
  kraekla_nn_1_1_N = mkN "kräkla" ;
  kraemla_nn_1_1_N = mkN "krämla" ;
  kraempa_nn_1_1_N = mkN "krämpa" ;
  kraeppnylon_nn_1_1_N = mkN "kräppnylon" ;
  kraeva_nn_1_1_N = mkN "kräva" ;
  kraaka_nn_1_1_N = mkN "kråka" ;
  kraaksyra_nn_1_1_N = mkN "kråksyra" ;
  kroenika_nn_1_1_N = mkN "krönika" ;
  kubanska_nn_1_N = mkN "kubanska" ;
  kuggfraaga_nn_1_1_N = mkN "kuggfråga" ;
  kula_nn_1_N = mkN "kula" ;
  kulbana_nn_1_N = mkN "kulbana" ;
  kulla_nn_1_N = mkN "kulla" ;
  kullerbytta_nn_1_N = mkN "kullerbytta" ;
  kulpenna_nn_1_N = mkN "kulpenna" ;
  kulspetspenna_nn_1_N = mkN "kulspetspenna" ;
  kulspruta_nn_1_N = mkN "kulspruta" ;
  kulturmaenniska_nn_1_1_N = mkN "kulturmänniska" ;
  kultursida_nn_1_N = mkN "kultursida" ;
  kummin_nn_1_N = mkN "kummin" ;
  kungakrona_nn_1_N = mkN "kungakrona" ;
  kungskrabba_nn_1_N = mkN "kungskrabba" ;
  kungsaengslilja_nn_1_1_N = mkN "kungsängslilja" ;
  kungsaadra_nn_1_1_N = mkN "kungsådra" ;
  kunskapskaella_nn_1_1_N = mkN "kunskapskälla" ;
  kupa_nn_1_N = mkN "kupa" ;
  kurdiska_nn_1_N = mkN "kurdiska" ;
  kurdiska_nn_2_N = mkN "kurdiska" ;
  kuria_nn_1_N = mkN "kuria" ;
  kurirresa_nn_1_N = mkN "kurirresa" ;
  kurva_nn_1_N = mkN "kurva" ;
  kustflotta_nn_1_N = mkN "kustflotta" ;
  kustremsa_nn_1_N = mkN "kustremsa" ;
  kustsnaeppa_nn_1_1_N = mkN "kustsnäppa" ;
  kuststraecka_nn_1_1_N = mkN "kuststräcka" ;
  kuvertvaeska_nn_1_1_N = mkN "kuvertväska" ;
  kuwaitiska_nn_1_N = mkN "kuwaitiska" ;
  kvagga_nn_1_N = mkN "kvagga" ;
  kvarleva_nn_1_N = mkN "kvarleva" ;
  kvartslampa_nn_1_N = mkN "kvartslampa" ;
  kvicksilvergruva_nn_1_N = mkN "kvicksilvergruva" ;
  kvicksilverlampa_nn_1_N = mkN "kvicksilverlampa" ;
  kviga_nn_1_N = mkN "kviga" ;
  kvinna_nn_1_N = mkN "kvinna" ;
  kvinnofraaga_nn_1_1_N = mkN "kvinnofråga" ;
  kvinnofaella_nn_1_1_N = mkN "kvinnofälla" ;
  kvinnosakskvinna_nn_1_N = mkN "kvinnosakskvinna" ;
  kvissla_nn_1_N = mkN "kvissla" ;
  kvistruna_nn_1_N = mkN "kvistruna" ;
  kvaellsdimma_nn_1_1_N = mkN "kvällsdimma" ;
  kvaellsfaerja_nn_1_1_N = mkN "kvällsfärja" ;
  kvaellskyla_nn_1_1_N = mkN "kvällskyla" ;
  kvaellsmaenniska_nn_1_1_N = mkN "kvällsmänniska" ;
  kvaevningsskada_nn_1_1_N = mkN "kvävningsskada" ;
  kyla_nn_1_N = mkN "kyla" ;
  kylarvaetska_nn_1_1_N = mkN "kylarvätska" ;
  kylskada_nn_1_N = mkN "kylskada" ;
  kylvaeska_nn_1_1_N = mkN "kylväska" ;
  kymriska_nn_1_N = mkN "kymriska" ;
  kyndelsmaessa_nn_1_1_N = mkN "kyndelsmässa" ;
  kyrka_nn_1_N = mkN "kyrka" ;
  kyrkklocka_nn_1_N = mkN "kyrkklocka" ;
  kyrkostaemma_nn_1_1_N = mkN "kyrkostämma" ;
  kyrkslaviska_nn_1_N = mkN "kyrkslaviska" ;
  kaegelbana_nn_1_1_N = mkN "kägelbana" ;
  kaegla_nn_1_1_N = mkN "kägla" ;
  kaekhaala_nn_1_1_N = mkN "käkhåla" ;
  kaella_nn_1_1_N = mkN "källa" ;
  kaellartrappa_nn_1_1_N = mkN "källartrappa" ;
  kaellsjoe_nn_1_1_N = mkN "källsjö" ;
  kaenga_nn_1_1_N = mkN "känga" ;
  kaensla_nn_1_1_N = mkN "känsla" ;
  kaenslokyla_nn_1_1_N = mkN "känslokyla" ;
  kaenslomaenniska_nn_1_1_N = mkN "känslomänniska" ;
  kaeppkrycka_nn_1_1_N = mkN "käppkrycka" ;
  kaeresta_nn_1_1_N = mkN "käresta" ;
  kaerleksgudinna_nn_1_1_N = mkN "kärleksgudinna" ;
  kaerlekssaga_nn_1_1_N = mkN "kärlekssaga" ;
  kaerleksvisa_nn_1_1_N = mkN "kärleksvisa" ;
  kaerna_nn_1_1_N = mkN "kärna" ;
  kaernfraaga_nn_1_1_N = mkN "kärnfråga" ;
  kaerngumma_nn_1_1_N = mkN "kärngumma" ;
  kaernkraftsolycka_nn_1_1_N = mkN "kärnkraftsolycka" ;
  kaernskugga_nn_1_1_N = mkN "kärnskugga" ;
  kaerra_nn_1_1_N = mkN "kärra" ;
  kaerrsnaeppa_nn_1_1_N = mkN "kärrsnäppa" ;
  kaada_nn_1_1_N = mkN "kåda" ;
  kaalfjaeril_nn_1_1_N = mkN "kålfjäril" ;
  kaalsoppa_nn_1_1_N = mkN "kålsoppa" ;
  kaapa_nn_1_1_N = mkN "kåpa" ;
  kaaranda_nn_1_1_N = mkN "kåranda" ;
  kaasa_nn_1_1_N = mkN "kåsa" ;
  kaasoerprosa_nn_1_1_N = mkN "kåsörprosa" ;
  kaata_nn_1_1_N = mkN "kåta" ;
  koebricka_nn_1_1_N = mkN "köbricka" ;
  koeksa_nn_1_1_N = mkN "köksa" ;
  koekssoffa_nn_1_1_N = mkN "kökssoffa" ;
  koeldskada_nn_1_1_N = mkN "köldskada" ;
  koelfena_nn_1_1_N = mkN "kölfena" ;
  koelna_nn_1_1_N = mkN "kölna" ;
  koelskena_nn_1_1_N = mkN "kölskena" ;
  koepesumma_nn_1_1_N = mkN "köpesumma" ;
  koeplada_nn_1_1_N = mkN "köplada" ;
  koerbana_nn_1_1_N = mkN "körbana" ;
  koerkortsaalder_nn_1_1_N = mkN "körkortsålder" ;
  koersla_nn_1_1_N = mkN "körsla" ;
  koerstraecka_nn_1_1_N = mkN "körsträcka" ;
  koervisa_nn_1_1_N = mkN "körvisa" ;
  koettfluga_nn_1_1_N = mkN "köttfluga" ;
  koettfaerslimpa_nn_1_1_N = mkN "köttfärslimpa" ;
  koettgryta_nn_1_1_N = mkN "köttgryta" ;
  koettsida_nn_1_1_N = mkN "köttsida" ;
  koettskada_nn_1_1_N = mkN "köttskada" ;
  koettskiva_nn_1_1_N = mkN "köttskiva" ;
  koettslamsa_nn_1_1_N = mkN "köttslamsa" ;
  koettsoppa_nn_1_1_N = mkN "köttsoppa" ;
  koettyxa_nn_1_1_N = mkN "köttyxa" ;
  labialpipa_nn_1_N = mkN "labialpipa" ;
  labialstaemma_nn_1_1_N = mkN "labialstämma" ;
  laboratoriekuriosa_nn_1_N = mkN "laboratoriekuriosa" ;
  laboratorieraatta_nn_1_1_N = mkN "laboratorieråtta" ;
  lada_nn_1_N = mkN "lada" ;
  ladusvala_nn_1_N = mkN "ladusvala" ;
  lagerkona_nn_1_N = mkN "lagerkona" ;
  lagsaga_nn_1_N = mkN "lagsaga" ;
  lagunsjoe_nn_1_1_N = mkN "lagunsjö" ;
  lakansremsa_nn_1_N = mkN "lakansremsa" ;
  lama_nn_1_N = mkN "lama" ;
  lama_nn_2_N = mkN "lama" ;
  lampa_nn_1_N = mkN "lampa" ;
  lampkupa_nn_1_N = mkN "lampkupa" ;
  lampolja_nn_1_N = mkN "lampolja" ;
  lana_nn_1_N = mkN "lana" ;
  landbrygga_nn_1_N = mkN "landbrygga" ;
  landkrabba_nn_1_N = mkN "landkrabba" ;
  landmassa_nn_1_N = mkN "landmassa" ;
  landmina_nn_1_N = mkN "landmina" ;
  landningsbana_nn_1_N = mkN "landningsbana" ;
  landremsa_nn_1_N = mkN "landremsa" ;
  landsida_nn_1_N = mkN "landsida" ;
  landskapsblomma_nn_1_N = mkN "landskapsblomma" ;
  landsmaninna_nn_1_N = mkN "landsmaninna" ;
  landsnaecka_nn_1_1_N = mkN "landsnäcka" ;
  landsplaaga_nn_1_1_N = mkN "landsplåga" ;
  landstraecka_nn_1_1_N = mkN "landsträcka" ;
  landsaenda_nn_1_1_N = mkN "landsända" ;
  landtunga_nn_1_N = mkN "landtunga" ;
  lanka_nn_1_N = mkN "lanka" ;
  lankesiska_nn_1_N = mkN "lankesiska" ;
  lanolin_nn_1_N = mkN "lanolin" ;
  lantan_nn_1_N = mkN "lantan" ;
  lanterna_nn_1_N = mkN "lanterna" ;
  lantlolla_nn_1_N = mkN "lantlolla" ;
  laotiska_nn_1_N = mkN "laotiska" ;
  laotiska_nn_2_N = mkN "laotiska" ;
  lapkojs_nn_1_N = mkN "lapkojs" ;
  lappkojs_nn_1_N = mkN "lappkojs" ;
  lapplisa_nn_1_N = mkN "lapplisa" ;
  lapplaendska_nn_1_1_N = mkN "lappländska" ;
  lappskojs_nn_1_N = mkN "lappskojs" ;
  lapska_nn_1_N = mkN "lapska" ;
  lapska_nn_2_N = mkN "lapska" ;
  lapskojs_nn_1_N = mkN "lapskojs" ;
  larmklocka_nn_1_N = mkN "larmklocka" ;
  larva_nn_1_N = mkN "larva" ;
  laserskiva_nn_1_N = mkN "laserskiva" ;
  lastbrygga_nn_1_N = mkN "lastbrygga" ;
  lastlucka_nn_1_N = mkN "lastlucka" ;
  lastplatta_nn_1_N = mkN "lastplatta" ;
  lastyta_nn_1_N = mkN "lastyta" ;
  lastaasna_nn_1_1_N = mkN "laståsna" ;
  latex_nn_1_N = mkN "latex" ;
  latinamerikanska_nn_1_N = mkN "latinamerikanska" ;
  latmaja_nn_1_N = mkN "latmaja" ;
  latta_nn_1_N = mkN "latta" ;
  laura_nn_1_N = mkN "laura" ;
  lava_nn_1_N = mkN "lava" ;
  lavasjoe_nn_1_1_N = mkN "lavasjö" ;
  lavskrika_nn_1_N = mkN "lavskrika" ;
  laxkista_nn_1_N = mkN "laxkista" ;
  laxraenna_nn_1_1_N = mkN "laxränna" ;
  laxsida_nn_1_N = mkN "laxsida" ;
  laxtrappa_nn_1_N = mkN "laxtrappa" ;
  ledarsida_nn_1_N = mkN "ledarsida" ;
  leddocka_nn_1_N = mkN "leddocka" ;
  ledningsfoermaaga_nn_1_1_N = mkN "ledningsförmåga" ;
  ledsagarinna_nn_1_N = mkN "ledsagarinna" ;
  ledstjaerna_nn_1_1_N = mkN "ledstjärna" ;
  ledvaetska_nn_1_1_N = mkN "ledvätska" ;
  ledyta_nn_1_N = mkN "ledyta" ;
  lega_nn_1_N = mkN "lega" ;
  leidenflaska_nn_1_N = mkN "leidenflaska" ;
  leidnerflaska_nn_1_N = mkN "leidnerflaska" ;
  lejoninna_nn_1_N = mkN "lejoninna" ;
  lejonkula_nn_1_N = mkN "lejonkula" ;
  lekattfaella_nn_1_1_N = mkN "lekattfälla" ;
  leksaksboessa_nn_1_1_N = mkN "leksaksbössa" ;
  lekskola_nn_1_N = mkN "lekskola" ;
  lekstuga_nn_1_N = mkN "lekstuga" ;
  lera_nn_1_N = mkN "lera" ;
  lerbotten_nn_1_N = mkN "lerbotten" ;
  lerduva_nn_1_N = mkN "lerduva" ;
  lerkruka_nn_1_N = mkN "lerkruka" ;
  lerskaerva_nn_1_1_N = mkN "lerskärva" ;
  lesothiska_nn_1_N = mkN "lesothiska" ;
  lettiska_nn_1_N = mkN "lettiska" ;
  lettiska_nn_2_N = mkN "lettiska" ;
  lettlaendska_nn_1_1_N = mkN "lettländska" ;
  lettlaendska_nn_2_1_N = mkN "lettländska" ;
  levermossa_nn_1_N = mkN "levermossa" ;
  leverpastejmacka_nn_1_N = mkN "leverpastejmacka" ;
  levnadsbana_nn_1_N = mkN "levnadsbana" ;
  levnadssaga_nn_1_N = mkN "levnadssaga" ;
  libanesiska_nn_1_N = mkN "libanesiska" ;
  libbsticka_nn_1_N = mkN "libbsticka" ;
  liberianska_nn_1_N = mkN "liberianska" ;
  libsticka_nn_1_N = mkN "libsticka" ;
  libyska_nn_1_N = mkN "libyska" ;
  liechtensteinska_nn_1_N = mkN "liechtensteinska" ;
  liga_nn_1_N = mkN "liga" ;
  ligghoena_nn_1_1_N = mkN "ligghöna" ;
  liggsoffa_nn_1_N = mkN "liggsoffa" ;
  ligusterfjaeril_nn_1_1_N = mkN "ligusterfjäril" ;
  likkista_nn_1_N = mkN "likkista" ;
  likvaka_nn_1_N = mkN "likvaka" ;
  likvida_nn_1_N = mkN "likvida" ;
  lilja_nn_1_N = mkN "lilja" ;
  lillflicka_nn_1_N = mkN "lillflicka" ;
  lillstuga_nn_1_N = mkN "lillstuga" ;
  lillvaerdinna_nn_1_1_N = mkN "lillvärdinna" ;
  limaboena_nn_1_1_N = mkN "limaböna" ;
  limklaemma_nn_1_1_N = mkN "limklämma" ;
  limpa_nn_1_N = mkN "limpa" ;
  limsticka_nn_1_N = mkN "limsticka" ;
  lina_nn_1_N = mkN "lina" ;
  linbana_nn_1_N = mkN "linbana" ;
  linda_nn_1_N = mkN "linda" ;
  lindblomma_nn_1_N = mkN "lindblomma" ;
  lingonmos_nn_1_N = mkN "lingonmos" ;
  lingonristuva_nn_1_N = mkN "lingonristuva" ;
  lingonruta_nn_1_N = mkN "lingonruta" ;
  linnea_nn_1_N = mkN "linnea" ;
  linolensyra_nn_1_N = mkN "linolensyra" ;
  linoleum_nn_1_N = mkN "linoleum" ;
  linoleummatta_nn_1_N = mkN "linoleummatta" ;
  linolja_nn_1_N = mkN "linolja" ;
  linolsyra_nn_1_N = mkN "linolsyra" ;
  linong_nn_1_N = mkN "linong" ;
  linskiva_nn_1_N = mkN "linskiva" ;
  linssoppa_nn_1_N = mkN "linssoppa" ;
  lira_nn_1_N = mkN "lira" ;
  lista_nn_1_N = mkN "lista" ;
  listetta_nn_1_N = mkN "listetta" ;
  litania_nn_1_N = mkN "litania" ;
  litauiska_nn_1_N = mkN "litauiska" ;
  litauiska_nn_2_N = mkN "litauiska" ;
  littera_nn_1_N = mkN "littera" ;
  livlina_nn_1_N = mkN "livlina" ;
  livmoderhaala_nn_1_1_N = mkN "livmoderhåla" ;
  livmodersslemhinna_nn_1_N = mkN "livmodersslemhinna" ;
  livraenta_nn_1_1_N = mkN "livränta" ;
  livs_nn_1_N = mkN "livs" ;
  livsfraaga_nn_1_1_N = mkN "livsfråga" ;
  livslaaga_nn_1_1_N = mkN "livslåga" ;
  livsmedelskedja_nn_1_N = mkN "livsmedelskedja" ;
  livstro_nn_1_N = mkN "livstro" ;
  livsvilja_nn_1_N = mkN "livsvilja" ;
  ljudkaella_nn_1_1_N = mkN "ljudkälla" ;
  ljudlaera_nn_1_1_N = mkN "ljudlära" ;
  ljudslinga_nn_1_N = mkN "ljudslinga" ;
  ljudspringa_nn_1_N = mkN "ljudspringa" ;
  ljudstyrka_nn_1_N = mkN "ljudstyrka" ;
  ljuskrona_nn_1_N = mkN "ljuskrona" ;
  ljuskaegla_nn_1_1_N = mkN "ljuskägla" ;
  ljuskaella_nn_1_1_N = mkN "ljuskälla" ;
  ljuslykta_nn_1_N = mkN "ljuslykta" ;
  ljuspenna_nn_1_N = mkN "ljuspenna" ;
  ljusslinga_nn_1_N = mkN "ljusslinga" ;
  ljusstyrka_nn_1_N = mkN "ljusstyrka" ;
  ljusterapilampa_nn_1_N = mkN "ljusterapilampa" ;
  ljustuta_nn_1_N = mkN "ljustuta" ;
  lo_nn_1_N = mkN "lo" ;
  lobelia_nn_1_N = mkN "lobelia" ;
  lodboessa_nn_1_1_N = mkN "lodbössa" ;
  lodlina_nn_1_N = mkN "lodlina" ;
  logga_nn_1_N = mkN "logga" ;
  loggia_nn_1_N = mkN "loggia" ;
  loggskaedda_nn_1_1_N = mkN "loggskädda" ;
  loka_nn_1_N = mkN "loka" ;
  lolla_nn_1_N = mkN "lolla" ;
  loppa_nn_1_N = mkN "loppa" ;
  loska_nn_1_N = mkN "loska" ;
  losta_nn_1_N = mkN "losta" ;
  lotta_nn_1_N = mkN "lotta" ;
  lucia_nn_1_N = mkN "lucia" ;
  luciakrona_nn_1_N = mkN "luciakrona" ;
  lucka_nn_1_N = mkN "lucka" ;
  ludd_nn_1_N = mkN "ludd" ;
  luftbro_nn_1_N = mkN "luftbro" ;
  luftbubbla_nn_1_N = mkN "luftbubbla" ;
  luftboessa_nn_1_1_N = mkN "luftbössa" ;
  luftflotta_nn_1_N = mkN "luftflotta" ;
  luftmaska_nn_1_N = mkN "luftmaska" ;
  luftmassa_nn_1_N = mkN "luftmassa" ;
  lufttrumma_nn_1_N = mkN "lufttrumma" ;
  luftvapenkula_nn_1_N = mkN "luftvapenkula" ;
  luktflaska_nn_1_N = mkN "luktflaska" ;
  luma_nn_1_N = mkN "luma" ;
  lumberjacka_nn_1_N = mkN "lumberjacka" ;
  lunchlaada_nn_1_1_N = mkN "lunchlåda" ;
  lunchvana_nn_1_N = mkN "lunchvana" ;
  lunga_nn_1_N = mkN "lunga" ;
  lungblaasa_nn_1_1_N = mkN "lungblåsa" ;
  lungroeta_nn_1_1_N = mkN "lungröta" ;
  lungsnaecka_nn_1_1_N = mkN "lungsnäcka" ;
  lunta_nn_1_N = mkN "lunta" ;
  lusekofta_nn_1_N = mkN "lusekofta" ;
  lussebulla_nn_1_N = mkN "lussebulla" ;
  lustkaensla_nn_1_1_N = mkN "lustkänsla" ;
  luta_nn_1_N = mkN "luta" ;
  luva_nn_1_N = mkN "luva" ;
  luxemburgska_nn_1_N = mkN "luxemburgska" ;
  lya_nn_1_N = mkN "lya" ;
  lycka_nn_2_N = mkN "lycka" ;
  lyckokaensla_nn_1_1_N = mkN "lyckokänsla" ;
  lyckostjaerna_nn_1_1_N = mkN "lyckostjärna" ;
  lyftbro_nn_1_N = mkN "lyftbro" ;
  lykta_nn_1_N = mkN "lykta" ;
  lyra_nn_1_N = mkN "lyra" ;
  lysraeka_nn_1_1_N = mkN "lysräka" ;
  lysroerslampa_nn_1_1_N = mkN "lysrörslampa" ;
  lyssnarskara_nn_1_N = mkN "lyssnarskara" ;
  lyxfaella_nn_1_1_N = mkN "lyxfälla" ;
  lyxlya_nn_1_N = mkN "lyxlya" ;
  lyxskinka_nn_1_N = mkN "lyxskinka" ;
  lyxvara_nn_1_N = mkN "lyxvara" ;
  lyxvilla_nn_1_N = mkN "lyxvilla" ;
  laebba_nn_1_1_N = mkN "läbba" ;
  laecka_nn_1_1_N = mkN "läcka" ;
  laederjacka_nn_1_1_N = mkN "läderjacka" ;
  laederkula_nn_1_1_N = mkN "läderkula" ;
  laederslida_nn_1_1_N = mkN "läderslida" ;
  laegda_nn_1_1_N = mkN "lägda" ;
  laegerskola_nn_1_1_N = mkN "lägerskola" ;
  laendflaeta_nn_1_1_N = mkN "ländfläta" ;
  laendkota_nn_1_1_N = mkN "ländkota" ;
  laenga_nn_1_1_N = mkN "länga" ;
  laengdspricka_nn_1_1_N = mkN "längdspricka" ;
  laenkroeta_nn_1_1_N = mkN "länkröta" ;
  laera_nn_1_1_N = mkN "lära" ;
  laerarhoegskola_nn_1_1_N = mkN "lärarhögskola" ;
  laerarinna_nn_1_1_N = mkN "lärarinna" ;
  laerdomsskola_nn_1_1_N = mkN "lärdomsskola" ;
  laerka_nn_1_1_N = mkN "lärka" ;
  laesarskara_nn_1_1_N = mkN "läsarskara" ;
  laesfoermaaga_nn_1_1_N = mkN "läsförmåga" ;
  laeshoerna_nn_1_1_N = mkN "läshörna" ;
  laesida_nn_1_1_N = mkN "läsida" ;
  laeskaenda_nn_1_1_N = mkN "läskända" ;
  laeslampa_nn_1_1_N = mkN "läslampa" ;
  laespenna_nn_1_1_N = mkN "läspenna" ;
  laesplatta_nn_1_1_N = mkN "läsplatta" ;
  laexa_nn_1_1_N = mkN "läxa" ;
  laada_nn_1_1_N = mkN "låda" ;
  laadkamera_nn_1_1_N = mkN "lådkamera" ;
  laaga_nn_1_1_N = mkN "låga" ;
  laagadel_nn_1_1_N = mkN "lågadel" ;
  laagbudgetdokusaapa_nn_1_1_N = mkN "lågbudgetdokusåpa" ;
  laagbudgetresa_nn_1_1_N = mkN "lågbudgetresa" ;
  laagenergilampa_nn_1_1_N = mkN "lågenergilampa" ;
  laagprosa_nn_1_1_N = mkN "lågprosa" ;
  laagtyska_nn_1_1_N = mkN "lågtyska" ;
  laanga_nn_1_1_N = mkN "långa" ;
  laangbyxa_nn_1_1_N = mkN "långbyxa" ;
  laangpanna_nn_1_1_N = mkN "långpanna" ;
  laangprosa_nn_1_1_N = mkN "långprosa" ;
  laangsida_nn_1_1_N = mkN "långsida" ;
  laangstrumpa_nn_1_1_N = mkN "långstrumpa" ;
  laarkaka_nn_1_1_N = mkN "lårkaka" ;
  laasbricka_nn_1_1_N = mkN "låsbricka" ;
  laasfirma_nn_1_1_N = mkN "låsfirma" ;
  laashylsa_nn_1_1_N = mkN "låshylsa" ;
  laasolja_nn_1_1_N = mkN "låsolja" ;
  laassaskaka_nn_1_1_N = mkN "låssaskaka" ;
  laatsaskaka_nn_1_1_N = mkN "låtsaskaka" ;
  loeddra_nn_1_1_N = mkN "löddra" ;
  loedpenna_nn_1_1_N = mkN "lödpenna" ;
  loeja_nn_1_1_N = mkN "löja" ;
  loeneklyfta_nn_1_1_N = mkN "löneklyfta" ;
  loennruna_nn_1_1_N = mkN "lönnruna" ;
  loepa_nn_1_1_N = mkN "löpa" ;
  loeparbana_nn_1_1_N = mkN "löparbana" ;
  loeplina_nn_1_1_N = mkN "löplina" ;
  loepmaska_nn_1_1_N = mkN "löpmaska" ;
  loepsedelsresa_nn_1_1_N = mkN "löpsedelsresa" ;
  loepsnara_nn_1_1_N = mkN "löpsnara" ;
  loerdagsbilaga_nn_1_1_N = mkN "lördagsbilaga" ;
  loerdagsfoermiddag_nn_1_1_N = mkN "lördagsförmiddag" ;
  loerdagshippa_nn_1_1_N = mkN "lördagshippa" ;
  loesensumma_nn_1_1_N = mkN "lösensumma" ;
  loesesumma_nn_1_1_N = mkN "lösesumma" ;
  loesnaesa_nn_1_1_N = mkN "lösnäsa" ;
  loevgroda_nn_1_1_N = mkN "lövgroda" ;
  loevkoja_nn_1_1_N = mkN "lövkoja" ;
  loevmossa_nn_1_1_N = mkN "lövmossa" ;
  loevruska_nn_1_1_N = mkN "lövruska" ;
  loevtraedsglaenta_nn_1_1_N = mkN "lövträdsglänta" ;
  macedonska_nn_1_N = mkN "macedonska" ;
  macedonska_nn_2_N = mkN "macedonska" ;
  macka_nn_1_N = mkN "macka" ;
  madagaskiska_nn_1_N = mkN "madagaskiska" ;
  madeleinekaka_nn_1_N = mkN "madeleinekaka" ;
  madonna_nn_1_N = mkN "madonna" ;
  madra_nn_1_N = mkN "madra" ;
  maduska_nn_1_N = mkN "maduska" ;
  maffia_nn_1_N = mkN "maffia" ;
  maffialiga_nn_1_N = mkN "maffialiga" ;
  magasinkaerra_nn_1_1_N = mkN "magasinkärra" ;
  magenta_nn_1_N = mkN "magenta" ;
  maginfluensa_nn_1_N = mkN "maginfluensa" ;
  magma_nn_1_N = mkN "magma" ;
  magnetkamera_nn_1_N = mkN "magnetkamera" ;
  magnetmina_nn_1_N = mkN "magnetmina" ;
  magnetremsa_nn_1_N = mkN "magnetremsa" ;
  magnetroentgenkamera_nn_1_1_N = mkN "magnetröntgenkamera" ;
  magnolia_nn_1_N = mkN "magnolia" ;
  magruta_nn_1_N = mkN "magruta" ;
  magsjuka_nn_1_N = mkN "magsjuka" ;
  magsmitta_nn_1_N = mkN "magsmitta" ;
  magsmaerta_nn_1_1_N = mkN "magsmärta" ;
  magsyra_nn_1_N = mkN "magsyra" ;
  maharadja_nn_1_N = mkN "maharadja" ;
  mahatma_nn_1_N = mkN "mahatma" ;
  mahognyyta_nn_1_N = mkN "mahognyyta" ;
  mahonia_nn_1_N = mkN "mahonia" ;
  majblomma_nn_1_N = mkN "majblomma" ;
  majdag_nn_1_N = mkN "majdag" ;
  majmorgonhimmel_nn_1_N = mkN "majmorgonhimmel" ;
  majsflinga_nn_1_N = mkN "majsflinga" ;
  majshylsa_nn_1_N = mkN "majshylsa" ;
  maka_nn_1_N = mkN "maka" ;
  makassarolja_nn_1_N = mkN "makassarolja" ;
  makedoniska_nn_2_N = mkN "makedoniska" ;
  makedonska_nn_1_N = mkN "makedonska" ;
  makedonska_nn_2_N = mkN "makedonska" ;
  maktfraaga_nn_1_1_N = mkN "maktfråga" ;
  maktmaenniska_nn_1_1_N = mkN "maktmänniska" ;
  malajiska_nn_1_N = mkN "malajiska" ;
  malajiska_nn_2_N = mkN "malajiska" ;
  malariamygga_nn_1_N = mkN "malariamygga" ;
  malawiska_nn_1_N = mkN "malawiska" ;
  malaysiska_nn_1_N = mkN "malaysiska" ;
  maldiviska_nn_1_N = mkN "maldiviska" ;
  maldiviska_nn_2_N = mkN "maldiviska" ;
  maliska_nn_1_N = mkN "maliska" ;
  malja_nn_1_N = mkN "malja" ;
  mallgroda_nn_1_N = mkN "mallgroda" ;
  malmficka_nn_1_N = mkN "malmficka" ;
  malmgruva_nn_1_N = mkN "malmgruva" ;
  malt_nn_1_N = mkN "malt" ;
  malteserorden_nn_1_N = mkN "malteserorden" ;
  maltesiska_nn_1_N = mkN "maltesiska" ;
  maltesiska_nn_2_N = mkN "maltesiska" ;
  malva_nn_1_N = mkN "malva" ;
  mamba_nn_1_N = mkN "mamba" ;
  mamma_nn_1_N = mkN "mamma" ;
  manchesterjacka_nn_1_N = mkN "manchesterjacka" ;
  manchuiska_nn_1_N = mkN "manchuiska" ;
  manchuiska_nn_2_N = mkN "manchuiska" ;
  mandelblomma_nn_1_N = mkN "mandelblomma" ;
  mandelkaka_nn_1_N = mkN "mandelkaka" ;
  mandelmassa_nn_1_N = mkN "mandelmassa" ;
  mandelolja_nn_1_N = mkN "mandelolja" ;
  mandorla_nn_1_N = mkN "mandorla" ;
  mandragora_nn_1_N = mkN "mandragora" ;
  mangan_nn_1_N = mkN "mangan" ;
  manlucka_nn_1_N = mkN "manlucka" ;
  manna_nn_1_N = mkN "manna" ;
  manslukerska_nn_1_N = mkN "manslukerska" ;
  manssida_nn_1_N = mkN "manssida" ;
  mansslukerska_nn_1_N = mkN "mansslukerska" ;
  mantelskura_nn_1_N = mkN "mantelskura" ;
  mantelyta_nn_1_N = mkN "mantelyta" ;
  mantissa_nn_1_N = mkN "mantissa" ;
  mara_nn_1_N = mkN "mara" ;
  mara_nn_2_N = mkN "mara" ;
  marihuana_nn_1_N = mkN "marihuana" ;
  marijuana_nn_1_N = mkN "marijuana" ;
  marimba_nn_1_N = mkN "marimba" ;
  marina_nn_1_N = mkN "marina" ;
  marinstyrka_nn_1_N = mkN "marinstyrka" ;
  markatta_nn_1_N = mkN "markatta" ;
  marklaera_nn_1_1_N = mkN "marklära" ;
  marknadshyra_nn_1_N = mkN "marknadshyra" ;
  marknadsraenta_nn_1_1_N = mkN "marknadsränta" ;
  markyta_nn_1_N = mkN "markyta" ;
  marleka_nn_1_N = mkN "marleka" ;
  marmorskiva_nn_1_N = mkN "marmorskiva" ;
  marmortrappa_nn_1_N = mkN "marmortrappa" ;
  marockanska_nn_1_N = mkN "marockanska" ;
  marsala_nn_1_N = mkN "marsala" ;
  marsipantaarta_nn_1_1_N = mkN "marsipantårta" ;
  martorn_nn_1_N = mkN "martorn" ;
  martyrgloria_nn_1_N = mkN "martyrgloria" ;
  martyrstaempel_nn_1_1_N = mkN "martyrstämpel" ;
  mascara_nn_1_N = mkN "mascara" ;
  maska_nn_1_N = mkN "maska" ;
  maskinvara_nn_1_N = mkN "maskinvara" ;
  massa_nn_1_N = mkN "massa" ;
  massa_nn_2_N = mkN "massa" ;
  masurka_nn_1_N = mkN "masurka" ;
  materieera_nn_1_N = mkN "materieera" ;
  matlaada_nn_1_1_N = mkN "matlåda" ;
  matmamma_nn_1_N = mkN "matmamma" ;
  matolja_nn_1_N = mkN "matolja" ;
  matro_nn_1_N = mkN "matro" ;
  matrona_nn_1_N = mkN "matrona" ;
  matsmaeltningsvaetska_nn_1_1_N = mkN "matsmältningsvätska" ;
  matsaecksvaeska_nn_1_1_N = mkN "matsäcksväska" ;
  matta_nn_1_N = mkN "matta" ;
  mattskiva_nn_1_N = mkN "mattskiva" ;
  matvana_nn_1_N = mkN "matvana" ;
  matvara_nn_1_N = mkN "matvara" ;
  matvarukedja_nn_1_N = mkN "matvarukedja" ;
  mauretanska_nn_1_N = mkN "mauretanska" ;
  mauritiska_nn_1_N = mkN "mauritiska" ;
  maxtaxa_nn_1_N = mkN "maxtaxa" ;
  mazurka_nn_1_N = mkN "mazurka" ;
  mc_byxa_nn_1_N = mkN "mc-byxa" ;
  meanderslinga_nn_1_N = mkN "meanderslinga" ;
  medaljliga_nn_1_N = mkN "medaljliga" ;
  medborgaranda_nn_1_N = mkN "medborgaranda" ;
  medelkoerstraecka_nn_1_1_N = mkN "medelkörsträcka" ;
  medelmaatta_nn_1_1_N = mkN "medelmåtta" ;
  medelpadska_nn_1_N = mkN "medelpadska" ;
  medelpadska_nn_2_N = mkN "medelpadska" ;
  medeltidsmaenniska_nn_1_1_N = mkN "medeltidsmänniska" ;
  medmaenniska_nn_1_1_N = mkN "medmänniska" ;
  medusa_nn_1_N = mkN "medusa" ;
  mefa_nn_1_N = mkN "mefa" ;
  megaera_nn_1_1_N = mkN "megära" ;
  melanesiska_nn_1_N = mkN "melanesiska" ;
  melitta_nn_1_N = mkN "melitta" ;
  mellanhjaerna_nn_1_1_N = mkN "mellanhjärna" ;
  mellanriksbana_nn_1_N = mkN "mellanriksbana" ;
  mellanskola_nn_1_N = mkN "mellanskola" ;
  melodiradio_nn_1_N = mkN "melodiradio" ;
  melodislinga_nn_1_N = mkN "melodislinga" ;
  melodistaemma_nn_1_1_N = mkN "melodistämma" ;
  membranskada_nn_1_N = mkN "membranskada" ;
  merca_nn_1_N = mkN "merca" ;
  meritlista_nn_1_N = mkN "meritlista" ;
  mersa_nn_1_N = mkN "mersa" ;
  mesopotamiska_nn_1_N = mkN "mesopotamiska" ;
  metallbricka_nn_1_N = mkN "metallbricka" ;
  metallkula_nn_1_N = mkN "metallkula" ;
  metervara_nn_1_N = mkN "metervara" ;
  metodlaera_nn_1_1_N = mkN "metodlära" ;
  mexikanska_nn_1_N = mkN "mexikanska" ;
  mexitegelvilla_nn_1_N = mkN "mexitegelvilla" ;
  mickelsmaessa_nn_1_1_N = mkN "mickelsmässa" ;
  middagstimma_nn_1_N = mkN "middagstimma" ;
  midja_nn_1_N = mkN "midja" ;
  mikronesiska_nn_1_N = mkN "mikronesiska" ;
  mila_nn_1_N = mkN "mila" ;
  militaerjunta_nn_1_1_N = mkN "militärjunta" ;
  militaerskola_nn_1_1_N = mkN "militärskola" ;
  miljoefraaga_nn_1_1_N = mkN "miljöfråga" ;
  miljoeskada_nn_1_1_N = mkN "miljöskada" ;
  millimeterraettvisa_nn_1_1_N = mkN "millimeterrättvisa" ;
  mimosa_nn_1_N = mkN "mimosa" ;
  mina_nn_1_N = mkN "mina" ;
  mindervaerdeskaensla_nn_1_1_N = mkN "mindervärdeskänsla" ;
  mineralolja_nn_1_N = mkN "mineralolja" ;
  mineralvattenflaska_nn_1_N = mkN "mineralvattenflaska" ;
  minestronesoppa_nn_1_N = mkN "minestronesoppa" ;
  miniatyrflaska_nn_1_N = mkN "miniatyrflaska" ;
  miniflaska_nn_1_N = mkN "miniflaska" ;
  minimisiffra_nn_1_N = mkN "minimisiffra" ;
  minnesbeta_nn_1_N = mkN "minnesbeta" ;
  minnesgaava_nn_1_1_N = mkN "minnesgåva" ;
  minnesruna_nn_1_N = mkN "minnesruna" ;
  minnessiffra_nn_1_N = mkN "minnessiffra" ;
  minnestavla_nn_1_N = mkN "minnestavla" ;
  minnesvilla_nn_1_N = mkN "minnesvilla" ;
  minussida_nn_1_N = mkN "minussida" ;
  minuthandel_nn_1_N = mkN "minuthandel" ;
  mirakelflicka_nn_1_N = mkN "mirakelflicka" ;
  missbruksfraaga_nn_1_1_N = mkN "missbruksfråga" ;
  misshandel_nn_1_N = mkN "misshandel" ;
  missionskyrka_nn_1_N = mkN "missionskyrka" ;
  misskoetsel_nn_1_1_N = mkN "misskötsel" ;
  missne_nn_1_N = mkN "missne" ;
  misstro_nn_1_N = mkN "misstro" ;
  missaemja_nn_1_1_N = mkN "missämja" ;
  mitella_nn_1_N = mkN "mitella" ;
  mitra_nn_1_N = mkN "mitra" ;
  mittbena_nn_1_N = mkN "mittbena" ;
  mittel_nn_1_N = mkN "mittel" ;
  mjukvaluta_nn_1_N = mkN "mjukvaluta" ;
  mjukvara_nn_1_N = mkN "mjukvara" ;
  mjaela_nn_1_1_N = mkN "mjäla" ;
  mjaell_nn_1_1_N = mkN "mjäll" ;
  mjoeldryga_nn_1_1_N = mkN "mjöldryga" ;
  mjoelkfeber_nn_1_1_N = mkN "mjölkfeber" ;
  mjoelkkossa_nn_1_1_N = mkN "mjölkkossa" ;
  mjoelksyra_nn_1_1_N = mkN "mjölksyra" ;
  mjoelktetra_nn_1_1_N = mkN "mjölktetra" ;
  mjoelnarmatte_nn_1_1_N = mkN "mjölnarmatte" ;
  mo_nn_1_N = mkN "mo" ;
  mocka_nn_1_N = mkN "mocka" ;
  modedocka_nn_1_N = mkN "modedocka" ;
  modekedja_nn_1_N = mkN "modekedja" ;
  modellera_nn_1_N = mkN "modellera" ;
  moderkaka_nn_1_N = mkN "moderkaka" ;
  moderniseringsagenda_nn_1_N = mkN "moderniseringsagenda" ;
  moderskaensla_nn_1_1_N = mkN "moderskänsla" ;
  moderstjaerna_nn_1_1_N = mkN "moderstjärna" ;
  moldaviska_nn_1_N = mkN "moldaviska" ;
  moldaviska_nn_2_N = mkN "moldaviska" ;
  molekylkedja_nn_1_N = mkN "molekylkedja" ;
  molnmassa_nn_1_N = mkN "molnmassa" ;
  monegaskiska_nn_1_N = mkN "monegaskiska" ;
  mongoliska_nn_1_N = mkN "mongoliska" ;
  mono_nn_1_N = mkN "mono" ;
  montenegrinska_nn_1_N = mkN "montenegrinska" ;
  mora_nn_1_N = mkN "mora" ;
  moraklocka_nn_1_N = mkN "moraklocka" ;
  moralkaka_nn_1_N = mkN "moralkaka" ;
  mordgaata_nn_1_1_N = mkN "mordgåta" ;
  morfin_nn_1_N = mkN "morfin" ;
  morgondimma_nn_1_N = mkN "morgondimma" ;
  morgongaava_nn_1_1_N = mkN "morgongåva" ;
  morgonmaenniska_nn_1_1_N = mkN "morgonmänniska" ;
  morgonstjaerna_nn_1_1_N = mkN "morgonstjärna" ;
  morkulla_nn_1_N = mkN "morkulla" ;
  morotbladloppa_nn_1_N = mkN "morotbladloppa" ;
  morotsfluga_nn_1_N = mkN "morotsfluga" ;
  morotskaka_nn_1_N = mkN "morotskaka" ;
  morsa_nn_1_N = mkN "morsa" ;
  morsgumma_nn_1_N = mkN "morsgumma" ;
  morssida_nn_1_N = mkN "morssida" ;
  mosel_nn_1_N = mkN "mosel" ;
  mosippa_nn_1_N = mkN "mosippa" ;
  mosnaeppa_nn_1_1_N = mkN "mosnäppa" ;
  mossa_nn_1_N = mkN "mossa" ;
  motfraaga_nn_1_1_N = mkN "motfråga" ;
  motionsvana_nn_1_N = mkN "motionsvana" ;
  motorcykelolycka_nn_1_N = mkN "motorcykelolycka" ;
  motorstyrka_nn_1_N = mkN "motorstyrka" ;
  motorsaagskedja_nn_1_1_N = mkN "motorsågskedja" ;
  motvilja_nn_1_N = mkN "motvilja" ;
  movipa_nn_1_N = mkN "movipa" ;
  mocambikiska_nn_1_1_N = mkN "moçambikiska" ;
  mula_nn_1_N = mkN "mula" ;
  mullsyra_nn_1_N = mkN "mullsyra" ;
  mulltoa_nn_1_N = mkN "mulltoa" ;
  mullvadssyrsa_nn_1_N = mkN "mullvadssyrsa" ;
  mulaasna_nn_1_1_N = mkN "mulåsna" ;
  mumma_nn_1_N = mkN "mumma" ;
  mungiga_nn_1_N = mkN "mungiga" ;
  mungipa_nn_1_N = mkN "mungipa" ;
  mungo_nn_2_N = mkN "mungo" ;
  munharmonika_nn_1_N = mkN "munharmonika" ;
  munhaefta_nn_1_1_N = mkN "munhäfta" ;
  munhaala_nn_1_1_N = mkN "munhåla" ;
  munkhaetta_nn_1_1_N = mkN "munkhätta" ;
  munkkaapa_nn_1_1_N = mkN "munkkåpa" ;
  munkorden_nn_1_N = mkN "munkorden" ;
  munlaesa_nn_1_1_N = mkN "munläsa" ;
  munslemhinna_nn_1_N = mkN "munslemhinna" ;
  munta_nn_1_N = mkN "munta" ;
  murarskjorta_nn_1_N = mkN "murarskjorta" ;
  murbraecka_nn_1_1_N = mkN "murbräcka" ;
  murgroena_nn_1_1_N = mkN "murgröna" ;
  murkla_nn_1_N = mkN "murkla" ;
  murkrona_nn_1_N = mkN "murkrona" ;
  mursida_nn_1_N = mkN "mursida" ;
  mushona_nn_1_N = mkN "mushona" ;
  musikhoegskola_nn_1_1_N = mkN "musikhögskola" ;
  musikskala_nn_1_N = mkN "musikskala" ;
  musikskola_nn_1_N = mkN "musikskola" ;
  musikstaemma_nn_1_1_N = mkN "musikstämma" ;
  muskatdruva_nn_1_N = mkN "muskatdruva" ;
  muskelmassa_nn_1_N = mkN "muskelmassa" ;
  muskelsena_nn_1_N = mkN "muskelsena" ;
  muskelstyrka_nn_1_N = mkN "muskelstyrka" ;
  muskotblomma_nn_1_N = mkN "muskotblomma" ;
  musmamma_nn_1_N = mkN "musmamma" ;
  mussla_nn_1_N = mkN "mussla" ;
  muta_nn_1_N = mkN "muta" ;
  muthaerva_nn_1_1_N = mkN "muthärva" ;
  mutterbricka_nn_1_N = mkN "mutterbricka" ;
  mygga_nn_1_N = mkN "mygga" ;
  mykorrhiza_nn_1_N = mkN "mykorrhiza" ;
  mylla_nn_1_N = mkN "mylla" ;
  mylta_nn_1_N = mkN "mylta" ;
  mynningsflamma_nn_1_N = mkN "mynningsflamma" ;
  mynta_nn_1_N = mkN "mynta" ;
  myntlucka_nn_1_N = mkN "myntlucka" ;
  myntlaada_nn_1_1_N = mkN "myntlåda" ;
  myra_nn_1_N = mkN "myra" ;
  myrlejonslaenda_nn_1_1_N = mkN "myrlejonslända" ;
  myrlilja_nn_1_N = mkN "myrlilja" ;
  myrra_nn_1_N = mkN "myrra" ;
  myrsyra_nn_1_N = mkN "myrsyra" ;
  myrtenkrona_nn_1_N = mkN "myrtenkrona" ;
  myskmadra_nn_1_N = mkN "myskmadra" ;
  myskolja_nn_1_N = mkN "myskolja" ;
  maelta_nn_1_1_N = mkN "mälta" ;
  maengdlaera_nn_1_1_N = mkN "mängdlära" ;
  maenniska_nn_1_1_N = mkN "människa" ;
  maenniskoapa_nn_1_1_N = mkN "människoapa" ;
  maenniskoboerda_nn_1_1_N = mkN "människobörda" ;
  maenniskofoeda_nn_1_1_N = mkN "människoföda" ;
  maenniskohandel_nn_1_1_N = mkN "människohandel" ;
  maenniskomassa_nn_1_1_N = mkN "människomassa" ;
  maenniskorovshaerva_nn_1_1_N = mkN "människorovshärva" ;
  maenska_nn_1_1_N = mkN "mänska" ;
  maergel_nn_1_1_N = mkN "märgel" ;
  maergpipa_nn_1_1_N = mkN "märgpipa" ;
  maergskida_nn_1_1_N = mkN "märgskida" ;
  maerkesskjorta_nn_1_1_N = mkN "märkesskjorta" ;
  maerkesvara_nn_1_1_N = mkN "märkesvara" ;
  maerkpenna_nn_1_1_N = mkN "märkpenna" ;
  maerkrulla_nn_1_1_N = mkN "märkrulla" ;
  maerla_nn_1_1_N = mkN "märla" ;
  maessa_nn_1_1_N = mkN "mässa" ;
  maessjacka_nn_1_1_N = mkN "mässjacka" ;
  maesskjorta_nn_1_1_N = mkN "mässkjorta" ;
  maestarinna_nn_1_1_N = mkN "mästarinna" ;
  maetarfjaeril_nn_1_1_N = mkN "mätarfjäril" ;
  maetsticka_nn_1_1_N = mkN "mätsticka" ;
  maalarskola_nn_1_1_N = mkN "målarskola" ;
  maalbrottsstaemma_nn_1_1_N = mkN "målbrottsstämma" ;
  maalkamera_nn_1_1_N = mkN "målkamera" ;
  maalla_nn_1_1_N = mkN "målla" ;
  maaltavla_nn_1_1_N = mkN "måltavla" ;
  maaltidsdricka_nn_1_1_N = mkN "måltidsdricka" ;
  maaltorka_nn_1_1_N = mkN "måltorka" ;
  maalyta_nn_1_1_N = mkN "målyta" ;
  maanbana_nn_1_1_N = mkN "månbana" ;
  maangata_nn_1_1_N = mkN "mångata" ;
  maanskiva_nn_1_1_N = mkN "månskiva" ;
  maanskugga_nn_1_1_N = mkN "månskugga" ;
  maanskaera_nn_1_1_N = mkN "månskära" ;
  maara_nn_1_1_N = mkN "måra" ;
  maatta_nn_1_1_N = mkN "måtta" ;
  moebelfirma_nn_1_1_N = mkN "möbelfirma" ;
  moebelmaessa_nn_1_1_N = mkN "möbelmässa" ;
  moebeltrissa_nn_1_1_N = mkN "möbeltrissa" ;
  moeda_nn_1_1_N = mkN "möda" ;
  moedomshinna_nn_1_1_N = mkN "mödomshinna" ;
  moehippa_nn_1_1_N = mkN "möhippa" ;
  moella_nn_1_1_N = mkN "mölla" ;
  moenja_nn_1_1_N = mkN "mönja" ;
  moensterkarta_nn_1_1_N = mkN "mönsterkarta" ;
  moerja_nn_1_1_N = mkN "mörja" ;
  moessa_nn_1_1_N = mkN "mössa" ;
  nackskada_nn_1_N = mkN "nackskada" ;
  nafta_nn_1_N = mkN "nafta" ;
  naftalin_nn_1_N = mkN "naftalin" ;
  nagajka_nn_1_N = mkN "nagajka" ;
  namibiska_nn_1_N = mkN "namibiska" ;
  namnlista_nn_1_N = mkN "namnlista" ;
  namntavla_nn_1_N = mkN "namntavla" ;
  nankin_nn_1_N = mkN "nankin" ;
  nanking_nn_1_N = mkN "nanking" ;
  nanoblomma_nn_1_N = mkN "nanoblomma" ;
  nappa_nn_1_N = mkN "nappa" ;
  nappflaska_nn_1_N = mkN "nappflaska" ;
  narduslilja_nn_1_N = mkN "narduslilja" ;
  narkotika_nn_1_N = mkN "narkotika" ;
  narkotikahandel_nn_1_N = mkN "narkotikahandel" ;
  narrkaapa_nn_1_1_N = mkN "narrkåpa" ;
  narrluva_nn_1_N = mkN "narrluva" ;
  nationalflagga_nn_1_N = mkN "nationalflagga" ;
  nationalitetsflagga_nn_1_N = mkN "nationalitetsflagga" ;
  nationalitetsspillra_nn_1_N = mkN "nationalitetsspillra" ;
  nationalkyrka_nn_1_N = mkN "nationalkyrka" ;
  nationsflagga_nn_1_N = mkN "nationsflagga" ;
  natriumbikarbonat_nn_1_N = mkN "natriumbikarbonat" ;
  natriumlampa_nn_1_N = mkN "natriumlampa" ;
  natroncellulosa_nn_1_N = mkN "natroncellulosa" ;
  natronsalpeter_nn_1_N = mkN "natronsalpeter" ;
  nattblacka_nn_1_N = mkN "nattblacka" ;
  nattblomma_nn_1_N = mkN "nattblomma" ;
  nattduksbordslaada_nn_1_1_N = mkN "nattduksbordslåda" ;
  nattfjaeril_nn_1_1_N = mkN "nattfjäril" ;
  natthimmel_nn_1_N = mkN "natthimmel" ;
  nattkappa_nn_1_N = mkN "nattkappa" ;
  nattklocka_nn_1_N = mkN "nattklocka" ;
  nattkyla_nn_1_N = mkN "nattkyla" ;
  nattlampa_nn_1_N = mkN "nattlampa" ;
  nattlucka_nn_1_N = mkN "nattlucka" ;
  nattmara_nn_1_N = mkN "nattmara" ;
  nattmoessa_nn_1_1_N = mkN "nattmössa" ;
  nattro_nn_1_N = mkN "nattro" ;
  nattsexa_nn_1_N = mkN "nattsexa" ;
  nattskatta_nn_1_N = mkN "nattskatta" ;
  nattskjorta_nn_1_N = mkN "nattskjorta" ;
  nattskaerra_nn_1_1_N = mkN "nattskärra" ;
  nattskoeterska_nn_1_1_N = mkN "nattsköterska" ;
  nattslaenda_nn_1_1_N = mkN "nattslända" ;
  nattuggla_nn_1_N = mkN "nattuggla" ;
  naturgoedsel_nn_1_1_N = mkN "naturgödsel" ;
  naturlaera_nn_1_1_N = mkN "naturlära" ;
  naturmaenniska_nn_1_1_N = mkN "naturmänniska" ;
  nauriska_nn_1_N = mkN "nauriska" ;
  navelbinda_nn_1_N = mkN "navelbinda" ;
  navelludd_nn_1_N = mkN "navelludd" ;
  naver_nn_1_N = mkN "naver" ;
  neandertalmaenniska_nn_1_1_N = mkN "neandertalmänniska" ;
  nebulosa_nn_1_N = mkN "nebulosa" ;
  nederlaendska_nn_1_1_N = mkN "nederländska" ;
  nederlaendska_nn_2_1_N = mkN "nederländska" ;
  nedresa_nn_1_N = mkN "nedresa" ;
  nejlika_nn_1_N = mkN "nejlika" ;
  nejlikolja_nn_1_N = mkN "nejlikolja" ;
  neodym_nn_1_N = mkN "neodym" ;
  nepalesiska_nn_1_N = mkN "nepalesiska" ;
  nepalesiska_nn_2_N = mkN "nepalesiska" ;
  nervbana_nn_1_N = mkN "nervbana" ;
  nervfeber_nn_1_N = mkN "nervfeber" ;
  nervskada_nn_1_N = mkN "nervskada" ;
  nervskida_nn_1_N = mkN "nervskida" ;
  nervsmaerta_nn_1_1_N = mkN "nervsmärta" ;
  nervaenda_nn_1_1_N = mkN "nervända" ;
  nesa_nn_1_N = mkN "nesa" ;
  neutrinofaella_nn_1_1_N = mkN "neutrinofälla" ;
  neutronstjaerna_nn_1_1_N = mkN "neutronstjärna" ;
  nia_nn_1_N = mkN "nia" ;
  nicaraguanska_nn_1_N = mkN "nicaraguanska" ;
  nickedocka_nn_1_N = mkN "nickedocka" ;
  nickel_nn_1_N = mkN "nickel" ;
  nidvisa_nn_1_N = mkN "nidvisa" ;
  nigerianska_nn_1_N = mkN "nigerianska" ;
  nigeriska_nn_1_N = mkN "nigeriska" ;
  nikotin_nn_1_N = mkN "nikotin" ;
  nikt_nn_1_N = mkN "nikt" ;
  niohaalsbana_nn_1_1_N = mkN "niohålsbana" ;
  nipa_nn_1_N = mkN "nipa" ;
  nippertippa_nn_1_N = mkN "nippertippa" ;
  nissa_nn_1_N = mkN "nissa" ;
  nisseflicka_nn_1_N = mkN "nisseflicka" ;
  nitbricka_nn_1_N = mkN "nitbricka" ;
  nitrocellulosa_nn_1_N = mkN "nitrocellulosa" ;
  niuiska_nn_1_N = mkN "niuiska" ;
  nivaakarta_nn_1_1_N = mkN "nivåkarta" ;
  nivaakurva_nn_1_1_N = mkN "nivåkurva" ;
  nivaayta_nn_1_1_N = mkN "nivåyta" ;
  njurskada_nn_1_N = mkN "njurskada" ;
  njutningsmaenniska_nn_1_1_N = mkN "njutningsmänniska" ;
  noja_nn_1_N = mkN "noja" ;
  nolla_nn_1_N = mkN "nolla" ;
  nolltaxa_nn_1_N = mkN "nolltaxa" ;
  nomadskola_nn_1_N = mkN "nomadskola" ;
  nona_nn_1_N = mkN "nona" ;
  nonsens_nn_1_N = mkN "nonsens" ;
  noppa_nn_1_N = mkN "noppa" ;
  noppra_nn_1_N = mkN "noppra" ;
  nordkoreanska_nn_1_N = mkN "nordkoreanska" ;
  nordsida_nn_1_N = mkN "nordsida" ;
  nordstjaerneorden_nn_1_1_N = mkN "nordstjärneorden" ;
  normalprosa_nn_1_N = mkN "normalprosa" ;
  norna_nn_1_N = mkN "norna" ;
  norna_nn_2_N = mkN "norna" ;
  norrbottniska_nn_1_N = mkN "norrbottniska" ;
  norrbottniska_nn_2_N = mkN "norrbottniska" ;
  norrkoepingsnaesa_nn_1_1_N = mkN "norrköpingsnäsa" ;
  norrlaendska_nn_1_1_N = mkN "norrländska" ;
  norrlaendska_nn_2_1_N = mkN "norrländska" ;
  norrsida_nn_1_N = mkN "norrsida" ;
  norska_nn_1_N = mkN "norska" ;
  norska_nn_2_N = mkN "norska" ;
  nosgrimma_nn_1_N = mkN "nosgrimma" ;
  nota_nn_1_N = mkN "nota" ;
  notsiffra_nn_1_N = mkN "notsiffra" ;
  nova_nn_1_N = mkN "nova" ;
  nubbevisa_nn_1_N = mkN "nubbevisa" ;
  nucka_nn_1_N = mkN "nucka" ;
  nuffra_nn_1_N = mkN "nuffra" ;
  nukleinsyra_nn_1_N = mkN "nukleinsyra" ;
  nummerbricka_nn_1_N = mkN "nummerbricka" ;
  nummerflicka_nn_1_N = mkN "nummerflicka" ;
  nummerskiva_nn_1_N = mkN "nummerskiva" ;
  nummertavla_nn_1_N = mkN "nummertavla" ;
  nuna_nn_1_N = mkN "nuna" ;
  nunna_nn_1_N = mkN "nunna" ;
  nunneorden_nn_1_N = mkN "nunneorden" ;
  nusvenska_nn_1_N = mkN "nusvenska" ;
  nutria_nn_1_N = mkN "nutria" ;
  nyckelharpa_nn_1_N = mkN "nyckelharpa" ;
  nyckelknippa_nn_1_N = mkN "nyckelknippa" ;
  nyckelpiga_nn_1_N = mkN "nyckelpiga" ;
  nygrekiska_nn_1_N = mkN "nygrekiska" ;
  nyhetstorka_nn_1_N = mkN "nyhetstorka" ;
  nyingsbrasa_nn_1_N = mkN "nyingsbrasa" ;
  nylon_nn_1_N = mkN "nylon" ;
  nylonskjorta_nn_1_N = mkN "nylonskjorta" ;
  nylonstrumpa_nn_1_N = mkN "nylonstrumpa" ;
  nylonutsida_nn_1_N = mkN "nylonutsida" ;
  nylaendska_nn_1_1_N = mkN "nyländska" ;
  nylaendska_nn_2_1_N = mkN "nyländska" ;
  nynorska_nn_1_N = mkN "nynorska" ;
  nypa_nn_1_N = mkN "nypa" ;
  nyponsoppa_nn_1_N = mkN "nyponsoppa" ;
  nyrokoko_nn_1_N = mkN "nyrokoko" ;
  nysnoe_nn_1_1_N = mkN "nysnö" ;
  nystkrona_nn_1_N = mkN "nystkrona" ;
  nyststjaerna_nn_1_1_N = mkN "nyststjärna" ;
  nystvinda_nn_1_N = mkN "nystvinda" ;
  nysvenska_nn_1_N = mkN "nysvenska" ;
  nytta_nn_1_N = mkN "nytta" ;
  nyutgaava_nn_1_1_N = mkN "nyutgåva" ;
  nyzeelaendska_nn_1_1_N = mkN "nyzeeländska" ;
  nyaarsgaava_nn_1_1_N = mkN "nyårsgåva" ;
  nyaarsvaka_nn_1_1_N = mkN "nyårsvaka" ;
  naebba_nn_1_1_N = mkN "näbba" ;
  naebbgaedda_nn_1_1_N = mkN "näbbgädda" ;
  naeringskedja_nn_1_1_N = mkN "näringskedja" ;
  naeringskaella_nn_1_1_N = mkN "näringskälla" ;
  naerkingska_nn_1_1_N = mkN "närkingska" ;
  naerkingska_nn_2_1_N = mkN "närkingska" ;
  naerradio_nn_1_1_N = mkN "närradio" ;
  naervaro_nn_1_1_N = mkN "närvaro" ;
  naesa_nn_1_1_N = mkN "näsa" ;
  naesbraenna_nn_1_1_N = mkN "näsbränna" ;
  naeshaala_nn_1_1_N = mkN "näshåla" ;
  naespaerla_nn_1_1_N = mkN "näspärla" ;
  naesselfeber_nn_1_1_N = mkN "nässelfeber" ;
  naesselfjaeril_nn_1_1_N = mkN "nässelfjäril" ;
  naesselsoppa_nn_1_1_N = mkN "nässelsoppa" ;
  naessla_nn_1_1_N = mkN "nässla" ;
  naesta_nn_1_1_N = mkN "nästa" ;
  naestaeppa_nn_1_1_N = mkN "nästäppa" ;
  naethandel_nn_1_1_N = mkN "näthandel" ;
  naethinna_nn_1_1_N = mkN "näthinna" ;
  naetmaska_nn_1_1_N = mkN "nätmaska" ;
  naetstrumpa_nn_1_1_N = mkN "nätstrumpa" ;
  naettroeja_nn_1_1_N = mkN "nättröja" ;
  naetupplaga_nn_1_1_N = mkN "nätupplaga" ;
  naetvana_nn_1_1_N = mkN "nätvana" ;
  naeva_nn_1_1_N = mkN "näva" ;
  naadegaava_nn_1_1_N = mkN "nådegåva" ;
  naaldyna_nn_1_1_N = mkN "nåldyna" ;
  naalfiltmatta_nn_1_1_N = mkN "nålfiltmatta" ;
  naalfiltsmatta_nn_1_1_N = mkN "nålfiltsmatta" ;
  noedsituationslampa_nn_1_1_N = mkN "nödsituationslampa" ;
  noedvaendighetsvara_nn_1_1_N = mkN "nödvändighetsvara" ;
  noejespappa_nn_1_1_N = mkN "nöjespappa" ;
  noejesresa_nn_1_1_N = mkN "nöjesresa" ;
  noetkraaka_nn_1_1_N = mkN "nötkråka" ;
  noetkaerna_nn_1_1_N = mkN "nötkärna" ;
  noetmassa_nn_1_1_N = mkN "nötmassa" ;
  noetolja_nn_1_1_N = mkN "nötolja" ;
  noetskrika_nn_1_1_N = mkN "nötskrika" ;
  noetvaecka_nn_1_1_N = mkN "nötväcka" ;
  ocarina_nn_1_N = mkN "ocarina" ;
  ockerhyra_nn_1_N = mkN "ockerhyra" ;
  ockerraenta_nn_1_1_N = mkN "ockerränta" ;
  ockra_nn_1_N = mkN "ockra" ;
  odal_nn_1_N = mkN "odal" ;
  odaaga_nn_1_1_N = mkN "odåga" ;
  oegennytta_nn_1_N = mkN "oegennytta" ;
  offergaava_nn_1_1_N = mkN "offergåva" ;
  offerkista_nn_1_N = mkN "offerkista" ;
  offerstaempel_nn_1_1_N = mkN "offerstämpel" ;
  ofoermaaga_nn_1_1_N = mkN "oförmåga" ;
  ohyra_nn_1_N = mkN "ohyra" ;
  okarina_nn_1_N = mkN "okarina" ;
  oktoberhimmel_nn_1_N = mkN "oktoberhimmel" ;
  okunnighetsstaempel_nn_1_1_N = mkN "okunnighetsstämpel" ;
  olein_nn_1_N = mkN "olein" ;
  olivolja_nn_1_N = mkN "olivolja" ;
  olja_nn_1_N = mkN "olja" ;
  oljedaadra_nn_1_1_N = mkN "oljedådra" ;
  oljefernissa_nn_1_N = mkN "oljefernissa" ;
  oljekaka_nn_1_N = mkN "oljekaka" ;
  oljekanna_nn_1_N = mkN "oljekanna" ;
  oljekaella_nn_1_1_N = mkN "oljekälla" ;
  oljelampa_nn_1_N = mkN "oljelampa" ;
  oljelykta_nn_1_N = mkN "oljelykta" ;
  oljelaecka_nn_1_1_N = mkN "oljeläcka" ;
  oljesyra_nn_1_N = mkN "oljesyra" ;
  olla_nn_1_N = mkN "olla" ;
  ollondroeppel_nn_1_1_N = mkN "ollondröppel" ;
  olofsmaessa_nn_1_1_N = mkN "olofsmässa" ;
  olsmaessa_nn_1_1_N = mkN "olsmässa" ;
  olustkaensla_nn_1_1_N = mkN "olustkänsla" ;
  olycka_nn_1_N = mkN "olycka" ;
  olycksdag_nn_1_N = mkN "olycksdag" ;
  olycksprofetia_nn_1_N = mkN "olycksprofetia" ;
  omanska_nn_1_N = mkN "omanska" ;
  omdoemesfraaga_nn_1_1_N = mkN "omdömesfråga" ;
  omdoemesfoermaaga_nn_1_1_N = mkN "omdömesförmåga" ;
  omfoederska_nn_1_1_N = mkN "omföderska" ;
  omloppsbana_nn_1_N = mkN "omloppsbana" ;
  omstaellningsfraaga_nn_1_1_N = mkN "omställningsfråga" ;
  omaenniska_nn_1_1_N = mkN "omänniska" ;
  ondska_nn_1_N = mkN "ondska" ;
  opera_nn_1_N = mkN "opera" ;
  operasaangerska_nn_1_1_N = mkN "operasångerska" ;
  opinionssiffra_nn_1_N = mkN "opinionssiffra" ;
  opiumhandel_nn_1_N = mkN "opiumhandel" ;
  opiumhaerva_nn_1_1_N = mkN "opiumhärva" ;
  opiumhaala_nn_1_1_N = mkN "opiumhåla" ;
  opiumpipa_nn_1_N = mkN "opiumpipa" ;
  oppfattningsfoermaaga_nn_1_1_N = mkN "oppfattningsförmåga" ;
  oppfinningsfoermaaga_nn_1_1_N = mkN "oppfinningsförmåga" ;
  opphaemta_nn_1_1_N = mkN "opphämta" ;
  orchestra_nn_1_N = mkN "orchestra" ;
  orden_nn_1_N = mkN "orden" ;
  ordensstjaerna_nn_1_1_N = mkN "ordensstjärna" ;
  ordflaeta_nn_1_1_N = mkN "ordfläta" ;
  ordfoerandeklubba_nn_1_1_N = mkN "ordförandeklubba" ;
  ordgaata_nn_1_1_N = mkN "ordgåta" ;
  ordinata_nn_1_N = mkN "ordinata" ;
  ordlista_nn_1_N = mkN "ordlista" ;
  ordningsfraaga_nn_1_1_N = mkN "ordningsfråga" ;
  ordningsmaenniska_nn_1_1_N = mkN "ordningsmänniska" ;
  ordningsstadga_nn_1_N = mkN "ordningsstadga" ;
  oreda_nn_1_N = mkN "oreda" ;
  oregano_nn_1_N = mkN "oregano" ;
  organza_nn_1_N = mkN "organza" ;
  orgelpipa_nn_1_N = mkN "orgelpipa" ;
  orgelstaemma_nn_1_1_N = mkN "orgelstämma" ;
  orienteringslampa_nn_1_N = mkN "orienteringslampa" ;
  orienteringstavla_nn_1_N = mkN "orienteringstavla" ;
  origo_nn_1_N = mkN "origo" ;
  orkanstyrka_nn_1_N = mkN "orkanstyrka" ;
  orkestra_nn_1_N = mkN "orkestra" ;
  ormblaasa_nn_1_1_N = mkN "ormblåsa" ;
  ormmaenniska_nn_1_1_N = mkN "ormmänniska" ;
  ormolja_nn_1_N = mkN "ormolja" ;
  ormslinga_nn_1_N = mkN "ormslinga" ;
  ormstjaerna_nn_1_1_N = mkN "ormstjärna" ;
  ormtunga_nn_1_N = mkN "ormtunga" ;
  oro_nn_1_N = mkN "oro" ;
  orsakskedja_nn_1_N = mkN "orsakskedja" ;
  ortsula_nn_1_N = mkN "ortsula" ;
  oraettvisa_nn_1_1_N = mkN "orättvisa" ;
  oskaerpa_nn_1_1_N = mkN "oskärpa" ;
  ossobuco_nn_1_N = mkN "ossobuco" ;
  ostbricka_nn_1_N = mkN "ostbricka" ;
  osteria_nn_1_N = mkN "osteria" ;
  ostfluga_nn_1_N = mkN "ostfluga" ;
  ostjakiska_nn_1_N = mkN "ostjakiska" ;
  ostkaka_nn_1_N = mkN "ostkaka" ;
  ostkupa_nn_1_N = mkN "ostkupa" ;
  ostmacka_nn_1_N = mkN "ostmacka" ;
  ostmassa_nn_1_N = mkN "ostmassa" ;
  ostra_nn_1_N = mkN "ostra" ;
  ostskiva_nn_1_N = mkN "ostskiva" ;
  ostvassla_nn_1_N = mkN "ostvassla" ;
  osaemja_nn_1_1_N = mkN "osämja" ;
  otrivsel_nn_1_N = mkN "otrivsel" ;
  otro_nn_1_N = mkN "otro" ;
  otta_nn_1_N = mkN "otta" ;
  otursdag_nn_1_N = mkN "otursdag" ;
  otaecka_nn_1_1_N = mkN "otäcka" ;
  ouzo_nn_1_N = mkN "ouzo" ;
  ovana_nn_1_N = mkN "ovana" ;
  ovandager_nn_1_N = mkN "ovandager" ;
  ovansida_nn_1_N = mkN "ovansida" ;
  ovilja_nn_1_N = mkN "ovilja" ;
  oxalsyra_nn_1_N = mkN "oxalsyra" ;
  oxalaettiksyra_nn_1_1_N = mkN "oxalättiksyra" ;
  oxfordskola_nn_1_N = mkN "oxfordskola" ;
  oxtunga_nn_1_N = mkN "oxtunga" ;
  oxvecka_nn_1_N = mkN "oxvecka" ;
  ozon_nn_1_N = mkN "ozon" ;
  p_ruta_nn_1_N = mkN "p-ruta" ;
  packningsdosa_nn_1_N = mkN "packningsdosa" ;
  packaasna_nn_1_1_N = mkN "packåsna" ;
  padda_nn_1_N = mkN "padda" ;
  paella_nn_1_N = mkN "paella" ;
  pagina_nn_1_N = mkN "pagina" ;
  paketkaerra_nn_1_1_N = mkN "paketkärra" ;
  paketresa_nn_1_N = mkN "paketresa" ;
  pakistanska_nn_1_N = mkN "pakistanska" ;
  palauiska_nn_1_N = mkN "palauiska" ;
  palauiska_nn_2_N = mkN "palauiska" ;
  palisander_nn_1_N = mkN "palisander" ;
  pall_nn_3_N = mkN "pall" ;
  palmitin_nn_1_N = mkN "palmitin" ;
  palmitinsyra_nn_1_N = mkN "palmitinsyra" ;
  palmkaerna_nn_1_1_N = mkN "palmkärna" ;
  palmolja_nn_1_N = mkN "palmolja" ;
  palsternacka_nn_1_N = mkN "palsternacka" ;
  paltkoma_nn_1_N = mkN "paltkoma" ;
  panama_nn_1_N = mkN "panama" ;
  panamanska_nn_1_N = mkN "panamanska" ;
  panda_nn_1_N = mkN "panda" ;
  panelhoena_nn_1_1_N = mkN "panelhöna" ;
  panka_nn_1_N = mkN "panka" ;
  panna_nn_1_N = mkN "panna" ;
  pannhaala_nn_1_1_N = mkN "pannhåla" ;
  pannkaka_nn_1_N = mkN "pannkaka" ;
  pannlampa_nn_1_N = mkN "pannlampa" ;
  panoramakamera_nn_1_N = mkN "panoramakamera" ;
  pansarskjorta_nn_1_N = mkN "pansarskjorta" ;
  papaya_nn_1_N = mkN "papaya" ;
  papegoja_nn_1_N = mkN "papegoja" ;
  papp_nn_1_N = mkN "papp" ;
  pappa_nn_1_N = mkN "pappa" ;
  pappersblomma_nn_1_N = mkN "pappersblomma" ;
  pappersklaemma_nn_1_1_N = mkN "pappersklämma" ;
  papperskula_nn_1_N = mkN "papperskula" ;
  pappersmassa_nn_1_N = mkN "pappersmassa" ;
  pappersremsa_nn_1_N = mkN "pappersremsa" ;
  pappersstjaerna_nn_1_1_N = mkN "pappersstjärna" ;
  papperssvala_nn_1_N = mkN "papperssvala" ;
  pappersupplaga_nn_1_N = mkN "pappersupplaga" ;
  papplaada_nn_1_1_N = mkN "papplåda" ;
  pappurna_nn_1_N = mkN "pappurna" ;
  paprika_nn_1_N = mkN "paprika" ;
  paradgata_nn_1_N = mkN "paradgata" ;
  paraffin_nn_1_N = mkN "paraffin" ;
  paraguayanska_nn_1_N = mkN "paraguayanska" ;
  paranoia_nn_1_N = mkN "paranoia" ;
  parasitfluga_nn_1_N = mkN "parasitfluga" ;
  parfymflaska_nn_1_N = mkN "parfymflaska" ;
  parkeringsficka_nn_1_N = mkN "parkeringsficka" ;
  parkeringslampa_nn_1_N = mkN "parkeringslampa" ;
  parkum_nn_1_N = mkN "parkum" ;
  parstuga_nn_1_N = mkN "parstuga" ;
  partianda_nn_1_N = mkN "partianda" ;
  partifaalla_nn_1_1_N = mkN "partifålla" ;
  partihandel_nn_1_N = mkN "partihandel" ;
  partipiska_nn_1_N = mkN "partipiska" ;
  partsinlaga_nn_1_N = mkN "partsinlaga" ;
  pascha_nn_1_N = mkN "pascha" ;
  pasma_nn_1_N = mkN "pasma" ;
  passagerarsiffra_nn_1_N = mkN "passagerarsiffra" ;
  passionsblomma_nn_1_N = mkN "passionsblomma" ;
  passionsvecka_nn_1_N = mkN "passionsvecka" ;
  pasta_nn_1_N = mkN "pasta" ;
  pasta_nn_2_N = mkN "pasta" ;
  pastramiskinka_nn_1_N = mkN "pastramiskinka" ;
  pata_nn_1_N = mkN "pata" ;
  patella_nn_1_N = mkN "patella" ;
  patina_nn_1_N = mkN "patina" ;
  patronhylsa_nn_1_N = mkN "patronhylsa" ;
  patronspruta_nn_1_N = mkN "patronspruta" ;
  patronvaeska_nn_1_1_N = mkN "patronväska" ;
  pava_nn_1_N = mkN "pava" ;
  pedofilhaerva_nn_1_1_N = mkN "pedofilhärva" ;
  pejlskiva_nn_1_N = mkN "pejlskiva" ;
  pellagra_nn_1_N = mkN "pellagra" ;
  pendel_nn_2_N = mkN "pendel" ;
  penis_nn_1_N = mkN "penis" ;
  penna_nn_1_N = mkN "penna" ;
  penningsumma_nn_1_N = mkN "penningsumma" ;
  pensionsfraaga_nn_1_1_N = mkN "pensionsfråga" ;
  pensionskassa_nn_1_N = mkN "pensionskassa" ;
  pensionaerstillvaro_nn_1_1_N = mkN "pensionärstillvaro" ;
  penultima_nn_1_N = mkN "penultima" ;
  pepparkaka_nn_1_N = mkN "pepparkaka" ;
  pepparmynta_nn_1_N = mkN "pepparmynta" ;
  pepparmyntsolja_nn_1_N = mkN "pepparmyntsolja" ;
  pepsin_nn_1_N = mkN "pepsin" ;
  perestrojka_nn_1_N = mkN "perestrojka" ;
  pergola_nn_1_N = mkN "pergola" ;
  periferivinkel_nn_1_N = mkN "periferivinkel" ;
  persika_nn_1_N = mkN "persika" ;
  persilja_nn_1_N = mkN "persilja" ;
  persiska_nn_1_N = mkN "persiska" ;
  persiska_nn_2_N = mkN "persiska" ;
  personalfraaga_nn_1_1_N = mkN "personalfråga" ;
  personalstyrka_nn_1_N = mkN "personalstyrka" ;
  personfraaga_nn_1_1_N = mkN "personfråga" ;
  personskada_nn_1_N = mkN "personskada" ;
  perstorpsplatta_nn_1_N = mkN "perstorpsplatta" ;
  perstorpsskiva_nn_1_N = mkN "perstorpsskiva" ;
  peruanska_nn_1_N = mkN "peruanska" ;
  petita_nn_1_N = mkN "petita" ;
  petroleum_nn_1_N = mkN "petroleum" ;
  petunia_nn_1_N = mkN "petunia" ;
  pianola_nn_1_N = mkN "pianola" ;
  piassava_nn_1_N = mkN "piassava" ;
  piazza_nn_1_N = mkN "piazza" ;
  piccola_nn_1_N = mkN "piccola" ;
  picka_nn_1_N = mkN "picka" ;
  pickelhuva_nn_1_N = mkN "pickelhuva" ;
  pidginengelska_nn_1_N = mkN "pidginengelska" ;
  piga_nn_1_N = mkN "piga" ;
  pikhacka_nn_1_N = mkN "pikhacka" ;
  pikrinsyra_nn_1_N = mkN "pikrinsyra" ;
  pikyxa_nn_1_N = mkN "pikyxa" ;
  pilotjacka_nn_1_N = mkN "pilotjacka" ;
  pilsnerflaska_nn_1_N = mkN "pilsnerflaska" ;
  pimpinella_nn_1_N = mkN "pimpinella" ;
  pina_nn_1_N = mkN "pina" ;
  pingla_nn_1_N = mkN "pingla" ;
  pingstlilja_nn_1_N = mkN "pingstlilja" ;
  pinnmo_nn_1_N = mkN "pinnmo" ;
  pinnsoffa_nn_1_N = mkN "pinnsoffa" ;
  pinuppa_nn_1_N = mkN "pinuppa" ;
  pipa_nn_1_N = mkN "pipa" ;
  piplaerka_nn_1_1_N = mkN "piplärka" ;
  pipolja_nn_1_N = mkN "pipolja" ;
  piratbyxa_nn_1_N = mkN "piratbyxa" ;
  piraya_nn_1_N = mkN "piraya" ;
  pirka_nn_1_N = mkN "pirka" ;
  pirra_nn_1_N = mkN "pirra" ;
  piska_nn_1_N = mkN "piska" ;
  pisksnaertskada_nn_1_1_N = mkN "pisksnärtskada" ;
  pisksnaertsskada_nn_1_1_N = mkN "pisksnärtsskada" ;
  pistolkula_nn_1_N = mkN "pistolkula" ;
  pistolvaeska_nn_1_1_N = mkN "pistolväska" ;
  pizza_nn_1_N = mkN "pizza" ;
  pizzeria_nn_1_N = mkN "pizzeria" ;
  pjaexa_nn_1_1_N = mkN "pjäxa" ;
  placebo_nn_1_N = mkN "placebo" ;
  placenta_nn_1_N = mkN "placenta" ;
  plack_nn_1_N = mkN "plack" ;
  pladuska_nn_1_N = mkN "pladuska" ;
  planetbana_nn_1_N = mkN "planetbana" ;
  planhalva_nn_1_N = mkN "planhalva" ;
  plank_nn_1_N = mkN "plank" ;
  planka_nn_1_N = mkN "planka" ;
  planta_nn_1_N = mkN "planta" ;
  plantskola_nn_1_N = mkN "plantskola" ;
  plastbalja_nn_1_N = mkN "plastbalja" ;
  plastellina_nn_1_N = mkN "plastellina" ;
  plastflaska_nn_1_N = mkN "plastflaska" ;
  plastpappa_nn_1_N = mkN "plastpappa" ;
  plastpulka_nn_1_N = mkN "plastpulka" ;
  plastraefsa_nn_1_1_N = mkN "plasträfsa" ;
  plastskiva_nn_1_N = mkN "plastskiva" ;
  plastaalder_nn_1_1_N = mkN "plastålder" ;
  platina_nn_1_N = mkN "platina" ;
  platssiffra_nn_1_N = mkN "platssiffra" ;
  platta_nn_1_N = mkN "platta" ;
  plattyska_nn_1_N = mkN "plattyska" ;
  pliktaara_nn_1_1_N = mkN "pliktåra" ;
  plita_nn_1_N = mkN "plita" ;
  plogfaara_nn_1_1_N = mkN "plogfåra" ;
  plogtilta_nn_1_N = mkN "plogtilta" ;
  plunta_nn_1_N = mkN "plunta" ;
  plaeter_nn_1_1_N = mkN "pläter" ;
  plaaga_nn_1_1_N = mkN "plåga" ;
  plaanboksfraaga_nn_1_1_N = mkN "plånboksfråga" ;
  plaatskada_nn_1_1_N = mkN "plåtskada" ;
  podager_nn_1_N = mkN "podager" ;
  poetissa_nn_1_N = mkN "poetissa" ;
  pojkflicka_nn_1_N = mkN "pojkflicka" ;
  poker_nn_1_N = mkN "poker" ;
  polardimma_nn_1_N = mkN "polardimma" ;
  polaroidkamera_nn_1_N = mkN "polaroidkamera" ;
  polarvinter_nn_1_N = mkN "polarvinter" ;
  polenta_nn_1_N = mkN "polenta" ;
  polerpasta_nn_1_N = mkN "polerpasta" ;
  polio_nn_1_N = mkN "polio" ;
  polisbricka_nn_1_N = mkN "polisbricka" ;
  poliskedja_nn_1_N = mkN "poliskedja" ;
  poliskvinna_nn_1_N = mkN "poliskvinna" ;
  polisstyrka_nn_1_N = mkN "polisstyrka" ;
  politikermisstro_nn_1_N = mkN "politikermisstro" ;
  politikervecka_nn_1_N = mkN "politikervecka" ;
  polka_nn_1_N = mkN "polka" ;
  pollenplaaga_nn_1_1_N = mkN "pollenplåga" ;
  polo_nn_1_N = mkN "polo" ;
  polo_nn_2_N = mkN "polo" ;
  poloklubba_nn_1_N = mkN "poloklubba" ;
  polotroeja_nn_1_1_N = mkN "polotröja" ;
  polska_nn_1_N = mkN "polska" ;
  polska_nn_2_N = mkN "polska" ;
  polynesiska_nn_1_N = mkN "polynesiska" ;
  polynia_nn_1_N = mkN "polynia" ;
  pomada_nn_1_N = mkN "pomada" ;
  pompa_nn_1_N = mkN "pompa" ;
  pontonbro_nn_1_N = mkN "pontonbro" ;
  pontonbrygga_nn_1_N = mkN "pontonbrygga" ;
  popdaenga_nn_1_1_N = mkN "popdänga" ;
  porrstjaerna_nn_1_1_N = mkN "porrstjärna" ;
  porslinsblomma_nn_1_N = mkN "porslinsblomma" ;
  porslinskula_nn_1_N = mkN "porslinskula" ;
  porslinsyta_nn_1_N = mkN "porslinsyta" ;
  portugisiska_nn_1_N = mkN "portugisiska" ;
  portugisiska_nn_2_N = mkN "portugisiska" ;
  portvaktssyssla_nn_1_N = mkN "portvaktssyssla" ;
  positivvisa_nn_1_N = mkN "positivvisa" ;
  postilla_nn_1_N = mkN "postilla" ;
  postlaada_nn_1_1_N = mkN "postlåda" ;
  postorder_nn_1_N = mkN "postorder" ;
  potatisklyfta_nn_1_N = mkN "potatisklyfta" ;
  potatisnaesa_nn_1_1_N = mkN "potatisnäsa" ;
  potentialyta_nn_1_N = mkN "potentialyta" ;
  potta_nn_1_N = mkN "potta" ;
  pottaska_nn_1_N = mkN "pottaska" ;
  pracka_nn_1_N = mkN "pracka" ;
  prao_nn_1_N = mkN "prao" ;
  prata_nn_1_N = mkN "prata" ;
  pratbubbla_nn_1_N = mkN "pratbubbla" ;
  pratsjuka_nn_1_N = mkN "pratsjuka" ;
  pratsoffa_nn_1_N = mkN "pratsoffa" ;
  presenterbricka_nn_1_N = mkN "presenterbricka" ;
  pressgurka_nn_1_N = mkN "pressgurka" ;
  pressylta_nn_1_N = mkN "pressylta" ;
  prestationsprinsessa_nn_1_N = mkN "prestationsprinsessa" ;
  prilla_nn_1_N = mkN "prilla" ;
  primadonna_nn_1_N = mkN "primadonna" ;
  primer_nn_1_N = mkN "primer" ;
  primklocka_nn_1_N = mkN "primklocka" ;
  primula_nn_1_N = mkN "primula" ;
  primaerkaella_nn_1_1_N = mkN "primärkälla" ;
  principfraaga_nn_1_1_N = mkN "principfråga" ;
  principmaenniska_nn_1_1_N = mkN "principmänniska" ;
  prinsessa_nn_1_N = mkN "prinsessa" ;
  prinsesstaarta_nn_1_1_N = mkN "prinsesstårta" ;
  priorinna_nn_1_N = mkN "priorinna" ;
  prioriteringsfraaga_nn_1_1_N = mkN "prioriteringsfråga" ;
  prislista_nn_1_N = mkN "prislista" ;
  privatskola_nn_1_N = mkN "privatskola" ;
  procentsiffra_nn_1_N = mkN "procentsiffra" ;
  professorska_nn_1_N = mkN "professorska" ;
  profetia_nn_1_N = mkN "profetia" ;
  progala_nn_1_N = mkN "progala" ;
  programvara_nn_1_N = mkN "programvara" ;
  projektilbana_nn_1_N = mkN "projektilbana" ;
  projektionsyta_nn_1_N = mkN "projektionsyta" ;
  prokura_nn_1_N = mkN "prokura" ;
  promemoria_nn_1_N = mkN "promemoria" ;
  promenadgata_nn_1_N = mkN "promenadgata" ;
  promenadlimpa_nn_1_N = mkN "promenadlimpa" ;
  propaganda_nn_1_N = mkN "propaganda" ;
  propan_nn_1_N = mkN "propan" ;
  prosa_nn_1_N = mkN "prosa" ;
  prostata_nn_1_N = mkN "prostata" ;
  prostitutionshaerva_nn_1_1_N = mkN "prostitutionshärva" ;
  proteinkedja_nn_1_N = mkN "proteinkedja" ;
  protestvilja_nn_1_N = mkN "protestvilja" ;
  protoplasma_nn_1_N = mkN "protoplasma" ;
  provdocka_nn_1_N = mkN "provdocka" ;
  provensalska_nn_1_N = mkN "provensalska" ;
  provensalska_nn_2_N = mkN "provensalska" ;
  proviantlista_nn_1_N = mkN "proviantlista" ;
  provkarta_nn_1_N = mkN "provkarta" ;
  prya_nn_1_N = mkN "prya" ;
  prydnadsblomma_nn_1_N = mkN "prydnadsblomma" ;
  prydnadsstjaerna_nn_1_1_N = mkN "prydnadsstjärna" ;
  praegel_nn_1_1_N = mkN "prägel" ;
  praestinna_nn_1_1_N = mkN "prästinna" ;
  praestkappa_nn_1_1_N = mkN "prästkappa" ;
  praestaenka_nn_1_1_N = mkN "prästänka" ;
  psykoanalyssoffa_nn_1_N = mkN "psykoanalyssoffa" ;
  pubertetsflicka_nn_1_N = mkN "pubertetsflicka" ;
  pudersnoe_nn_1_1_N = mkN "pudersnö" ;
  pudervippa_nn_1_N = mkN "pudervippa" ;
  puffra_nn_1_N = mkN "puffra" ;
  puka_nn_1_N = mkN "puka" ;
  pulka_nn_1_N = mkN "pulka" ;
  pulla_nn_1_N = mkN "pulla" ;
  pulpa_nn_1_N = mkN "pulpa" ;
  pulsklocka_nn_1_N = mkN "pulsklocka" ;
  pulversoppa_nn_1_N = mkN "pulversoppa" ;
  puma_nn_1_N = mkN "puma" ;
  pumpa_nn_1_N = mkN "pumpa" ;
  pungraatta_nn_1_1_N = mkN "pungråtta" ;
  punka_nn_1_N = mkN "punka" ;
  puppa_nn_1_N = mkN "puppa" ;
  purpursnaecka_nn_1_1_N = mkN "purpursnäcka" ;
  pusta_nn_1_N = mkN "pusta" ;
  puta_nn_1_N = mkN "puta" ;
  putstrasa_nn_1_N = mkN "putstrasa" ;
  pyjamasficka_nn_1_N = mkN "pyjamasficka" ;
  pyrola_nn_1_N = mkN "pyrola" ;
  pyspunka_nn_1_N = mkN "pyspunka" ;
  pyttipanna_nn_1_N = mkN "pyttipanna" ;
  paerla_nn_1_1_N = mkN "pärla" ;
  paerlemo_nn_1_1_N = mkN "pärlemo" ;
  paerlemorfjaeril_nn_1_1_N = mkN "pärlemorfjäril" ;
  paerlhoena_nn_1_1_N = mkN "pärlhöna" ;
  paerlmussla_nn_1_1_N = mkN "pärlmussla" ;
  paerlplatta_nn_1_1_N = mkN "pärlplatta" ;
  paerluggla_nn_1_1_N = mkN "pärluggla" ;
  paeronskiva_nn_1_1_N = mkN "päronskiva" ;
  paeronsoda_nn_1_1_N = mkN "päronsoda" ;
  paerta_nn_1_1_N = mkN "pärta" ;
  paaa_nn_1_1_N = mkN "påa" ;
  paalaga_nn_1_1_N = mkN "pålaga" ;
  paasklilja_nn_1_1_N = mkN "påsklilja" ;
  paaskvecka_nn_1_1_N = mkN "påskvecka" ;
  poebel_nn_1_1_N = mkN "pöbel" ;
  poelsa_nn_1_1_N = mkN "pölsa" ;
  qatariska_nn_1_N = mkN "qatariska" ;
  rabarber_nn_1_N = mkN "rabarber" ;
  rabarberkaka_nn_1_N = mkN "rabarberkaka" ;
  racka_nn_1_N = mkN "racka" ;
  radda_nn_1_N = mkN "radda" ;
  radiokaella_nn_1_1_N = mkN "radiokälla" ;
  radja_nn_1_N = mkN "radja" ;
  radon_nn_1_N = mkN "radon" ;
  raffel_nn_2_N = mkN "raffel" ;
  raga_nn_1_N = mkN "raga" ;
  ragata_nn_1_N = mkN "ragata" ;
  raggsocka_nn_1_N = mkN "raggsocka" ;
  raja_nn_1_N = mkN "raja" ;
  raka_nn_1_N = mkN "raka" ;
  rakstraecka_nn_1_1_N = mkN "raksträcka" ;
  ramloesa_nn_1_1_N = mkN "ramlösa" ;
  rampfeber_nn_1_N = mkN "rampfeber" ;
  ramsa_nn_1_N = mkN "ramsa" ;
  rana_nn_1_N = mkN "rana" ;
  randsjoe_nn_1_1_N = mkN "randsjö" ;
  rangrulla_nn_1_N = mkN "rangrulla" ;
  rangskala_nn_1_N = mkN "rangskala" ;
  ranka_nn_1_N = mkN "ranka" ;
  rankinglista_nn_1_N = mkN "rankinglista" ;
  rankningslista_nn_1_N = mkN "rankningslista" ;
  rappakalja_nn_1_N = mkN "rappakalja" ;
  rapphoena_nn_1_1_N = mkN "rapphöna" ;
  rapskaka_nn_1_N = mkN "rapskaka" ;
  rapsolja_nn_1_N = mkN "rapsolja" ;
  rapsplanta_nn_1_N = mkN "rapsplanta" ;
  rapstjaerna_nn_1_1_N = mkN "rapstjärna" ;
  rasfraaga_nn_1_1_N = mkN "rasfråga" ;
  rasmassa_nn_1_N = mkN "rasmassa" ;
  rattfylla_nn_1_N = mkN "rattfylla" ;
  razzia_nn_1_N = mkN "razzia" ;
  rea_nn_1_N = mkN "rea" ;
  reaktionsfoermaaga_nn_1_1_N = mkN "reaktionsförmåga" ;
  realskola_nn_1_N = mkN "realskola" ;
  reda_nn_1_N = mkN "reda" ;
  regatta_nn_1_N = mkN "regatta" ;
  regeringssida_nn_1_N = mkN "regeringssida" ;
  regnbaagshinna_nn_1_1_N = mkN "regnbågshinna" ;
  regnkappa_nn_1_N = mkN "regnkappa" ;
  regnskugga_nn_1_N = mkN "regnskugga" ;
  reklampenna_nn_1_N = mkN "reklampenna" ;
  reklamtillvaro_nn_1_N = mkN "reklamtillvaro" ;
  rekordsiffra_nn_1_N = mkN "rekordsiffra" ;
  rekvisita_nn_1_N = mkN "rekvisita" ;
  religionslaera_nn_1_1_N = mkN "religionslära" ;
  remissa_nn_1_N = mkN "remissa" ;
  remsa_nn_1_N = mkN "remsa" ;
  renat_nn_1_N = mkN "renat" ;
  renfana_nn_1_N = mkN "renfana" ;
  renlaerighetsiver_nn_1_1_N = mkN "renlärighetsiver" ;
  renskav_nn_1_N = mkN "renskav" ;
  renskoetsel_nn_1_1_N = mkN "renskötsel" ;
  renslucka_nn_1_N = mkN "renslucka" ;
  renaessansmaenniska_nn_1_1_N = mkN "renässansmänniska" ;
  repa_nn_1_N = mkN "repa" ;
  reptilhjaerna_nn_1_1_N = mkN "reptilhjärna" ;
  repaenda_nn_1_1_N = mkN "repända" ;
  resa_nn_1_N = mkN "resa" ;
  reseda_nn_1_N = mkN "reseda" ;
  reservoarpenna_nn_1_N = mkN "reservoarpenna" ;
  reservpappa_nn_1_N = mkN "reservpappa" ;
  resfeber_nn_1_N = mkN "resfeber" ;
  reskontra_nn_1_N = mkN "reskontra" ;
  resonansbotten_nn_1_N = mkN "resonansbotten" ;
  resonanslaada_nn_1_1_N = mkN "resonanslåda" ;
  resultatlista_nn_1_N = mkN "resultatlista" ;
  resvana_nn_1_N = mkN "resvana" ;
  resvaeska_nn_1_1_N = mkN "resväska" ;
  resaarbyxa_nn_1_1_N = mkN "resårbyxa" ;
  retina_nn_1_N = mkN "retina" ;
  retsina_nn_1_N = mkN "retsina" ;
  retsticka_nn_1_N = mkN "retsticka" ;
  returresa_nn_1_N = mkN "returresa" ;
  reva_nn_1_N = mkN "reva" ;
  revoltanda_nn_1_N = mkN "revoltanda" ;
  revsmoerblomma_nn_1_1_N = mkN "revsmörblomma" ;
  ria_nn_1_N = mkN "ria" ;
  ribba_nn_1_N = mkN "ribba" ;
  ricinolja_nn_1_N = mkN "ricinolja" ;
  ridbana_nn_1_N = mkN "ridbana" ;
  ridbyxa_nn_1_N = mkN "ridbyxa" ;
  riddarorden_nn_1_N = mkN "riddarorden" ;
  ridpiska_nn_1_N = mkN "ridpiska" ;
  ridskola_nn_1_N = mkN "ridskola" ;
  riksdagskvinna_nn_1_N = mkN "riksdagskvinna" ;
  riksha_nn_1_N = mkN "riksha" ;
  riksolycka_nn_1_N = mkN "riksolycka" ;
  riksstaemma_nn_1_1_N = mkN "riksstämma" ;
  rikssvenska_nn_1_N = mkN "rikssvenska" ;
  rimkroenika_nn_1_1_N = mkN "rimkrönika" ;
  ringblomma_nn_1_N = mkN "ringblomma" ;
  ringbrynja_nn_1_N = mkN "ringbrynja" ;
  ringduva_nn_1_N = mkN "ringduva" ;
  ringhoerna_nn_1_1_N = mkN "ringhörna" ;
  ringklocka_nn_1_N = mkN "ringklocka" ;
  ripa_nn_1_N = mkN "ripa" ;
  risbastu_nn_1_N = mkN "risbastu" ;
  riska_nn_1_N = mkN "riska" ;
  riskaka_nn_1_N = mkN "riskaka" ;
  risotto_nn_1_N = mkN "risotto" ;
  rispa_nn_1_N = mkN "rispa" ;
  rissla_nn_1_N = mkN "rissla" ;
  ro_nn_1_N = mkN "ro" ;
  robothandel_nn_1_N = mkN "robothandel" ;
  rocka_nn_1_N = mkN "rocka" ;
  rockficka_nn_1_N = mkN "rockficka" ;
  rokoko_nn_1_N = mkN "rokoko" ;
  rollista_nn_1_N = mkN "rollista" ;
  romarinna_nn_1_N = mkN "romarinna" ;
  rosenolja_nn_1_N = mkN "rosenolja" ;
  rotbloeta_nn_1_1_N = mkN "rotblöta" ;
  rottingsoffa_nn_1_N = mkN "rottingsoffa" ;
  rotunda_nn_1_N = mkN "rotunda" ;
  rotvaelska_nn_1_1_N = mkN "rotvälska" ;
  rotvaelta_nn_1_1_N = mkN "rotvälta" ;
  rova_nn_1_N = mkN "rova" ;
  ruda_nn_1_N = mkN "ruda" ;
  ruff_nn_2_N = mkN "ruff" ;
  ruffhaexa_nn_1_1_N = mkN "ruffhäxa" ;
  rulla_nn_1_N = mkN "rulla" ;
  rullbraeda_nn_1_1_N = mkN "rullbräda" ;
  rullskida_nn_1_N = mkN "rullskida" ;
  rullskridskobana_nn_1_N = mkN "rullskridskobana" ;
  rulltrappa_nn_1_N = mkN "rulltrappa" ;
  rulltaarta_nn_1_1_N = mkN "rulltårta" ;
  rulta_nn_1_N = mkN "rulta" ;
  rumba_nn_1_N = mkN "rumba" ;
  rumpa_nn_1_N = mkN "rumpa" ;
  rumaenska_nn_1_1_N = mkN "rumänska" ;
  rumaenska_nn_2_1_N = mkN "rumänska" ;
  runa_nn_1_N = mkN "runa" ;
  runda_nn_1_N = mkN "runda" ;
  rundfraaga_nn_1_1_N = mkN "rundfråga" ;
  rundkula_nn_1_N = mkN "rundkula" ;
  rundkyrka_nn_1_N = mkN "rundkyrka" ;
  rundradio_nn_1_N = mkN "rundradio" ;
  rundresa_nn_1_N = mkN "rundresa" ;
  rundsticka_nn_1_N = mkN "rundsticka" ;
  ruschelbana_nn_1_N = mkN "ruschelbana" ;
  ruschelkana_nn_1_N = mkN "ruschelkana" ;
  ruska_nn_1_N = mkN "ruska" ;
  ruta_nn_1_N = mkN "ruta" ;
  rutchbana_nn_1_N = mkN "rutchbana" ;
  rutchelbana_nn_1_N = mkN "rutchelbana" ;
  rutchelkana_nn_1_N = mkN "rutchelkana" ;
  rutchkana_nn_1_N = mkN "rutchkana" ;
  rutschbana_nn_1_N = mkN "rutschbana" ;
  rutschelbana_nn_1_N = mkN "rutschelbana" ;
  rutschelkana_nn_1_N = mkN "rutschelkana" ;
  rutschkana_nn_1_N = mkN "rutschkana" ;
  ruvlaada_nn_1_1_N = mkN "ruvlåda" ;
  rwandiska_nn_1_N = mkN "rwandiska" ;
  rya_nn_1_N = mkN "rya" ;
  rygga_nn_1_N = mkN "rygga" ;
  ryggfena_nn_1_N = mkN "ryggfena" ;
  ryggkota_nn_1_N = mkN "ryggkota" ;
  ryggtavla_nn_1_N = mkN "ryggtavla" ;
  ryggaasstuga_nn_1_1_N = mkN "ryggåsstuga" ;
  ryktskrapa_nn_1_N = mkN "ryktskrapa" ;
  rymdfaerja_nn_1_1_N = mkN "rymdfärja" ;
  rymdresa_nn_1_N = mkN "rymdresa" ;
  rymdaalder_nn_1_1_N = mkN "rymdålder" ;
  rynka_nn_1_N = mkN "rynka" ;
  ryska_nn_1_N = mkN "ryska" ;
  ryska_nn_2_N = mkN "ryska" ;
  ryssja_nn_1_N = mkN "ryssja" ;
  rysslaendska_nn_1_1_N = mkN "ryssländska" ;
  raecka_nn_1_1_N = mkN "räcka" ;
  raeddhaaga_nn_1_1_N = mkN "räddhåga" ;
  raeddningsklocka_nn_1_1_N = mkN "räddningsklocka" ;
  raeddningsplanka_nn_1_1_N = mkN "räddningsplanka" ;
  raeddningsstyrka_nn_1_1_N = mkN "räddningsstyrka" ;
  raedisa_nn_1_1_N = mkN "rädisa" ;
  raedsel_nn_1_1_N = mkN "rädsel" ;
  raeffla_nn_1_1_N = mkN "räffla" ;
  raefsa_nn_1_1_N = mkN "räfsa" ;
  raeka_nn_1_1_N = mkN "räka" ;
  raekfrossa_nn_1_1_N = mkN "räkfrossa" ;
  raekmacka_nn_1_1_N = mkN "räkmacka" ;
  raeknedosa_nn_1_1_N = mkN "räknedosa" ;
  raekneramsa_nn_1_1_N = mkN "räkneramsa" ;
  raeknesticka_nn_1_1_N = mkN "räknesticka" ;
  raemna_nn_1_1_N = mkN "rämna" ;
  raenna_nn_1_1_N = mkN "ränna" ;
  raennarbana_nn_1_1_N = mkN "rännarbana" ;
  raennsnara_nn_1_1_N = mkN "rännsnara" ;
  raenta_nn_1_1_N = mkN "ränta" ;
  raeta_nn_1_1_N = mkN "räta" ;
  raetoromanska_nn_1_1_N = mkN "rätoromanska" ;
  raetsida_nn_1_1_N = mkN "rätsida" ;
  raetskiva_nn_1_1_N = mkN "rätskiva" ;
  raettika_nn_1_1_N = mkN "rättika" ;
  raettsfraaga_nn_1_1_N = mkN "rättsfråga" ;
  raettsfoermaaga_nn_1_1_N = mkN "rättsförmåga" ;
  raettslaera_nn_1_1_N = mkN "rättslära" ;
  raettsroeta_nn_1_1_N = mkN "rättsröta" ;
  raettvisa_nn_1_1_N = mkN "rättvisa" ;
  raevrumpa_nn_1_1_N = mkN "rävrumpa" ;
  raadjursolycka_nn_1_1_N = mkN "rådjursolycka" ;
  raadstu_nn_1_1_N = mkN "rådstu" ;
  raadstuga_nn_1_1_N = mkN "rådstuga" ;
  raaglimpa_nn_1_1_N = mkN "råglimpa" ;
  raak_nn_2_1_N = mkN "råk" ;
  raaka_nn_1_1_N = mkN "råka" ;
  raakopia_nn_1_1_N = mkN "råkopia" ;
  raanarhuva_nn_1_1_N = mkN "rånarhuva" ;
  raanarluva_nn_1_1_N = mkN "rånarluva" ;
  raaolja_nn_1_1_N = mkN "råolja" ;
  raaraka_nn_1_1_N = mkN "råraka" ;
  raastyrka_nn_1_1_N = mkN "råstyrka" ;
  raatta_nn_1_1_N = mkN "råtta" ;
  raattfaella_nn_1_1_N = mkN "råttfälla" ;
  raavara_nn_1_1_N = mkN "råvara" ;
  roedbena_nn_1_1_N = mkN "rödbena" ;
  roedbeta_nn_1_1_N = mkN "rödbeta" ;
  roedkloever_nn_1_1_N = mkN "rödklöver" ;
  roedlista_nn_1_1_N = mkN "rödlista" ;
  roedmyra_nn_1_1_N = mkN "rödmyra" ;
  roedockra_nn_1_1_N = mkN "rödockra" ;
  roedpenna_nn_1_1_N = mkN "rödpenna" ;
  roedspotta_nn_1_1_N = mkN "rödspotta" ;
  roedspaetta_nn_1_1_N = mkN "rödspätta" ;
  roedstrumpa_nn_1_1_N = mkN "rödstrumpa" ;
  roedtunga_nn_1_1_N = mkN "rödtunga" ;
  roejarskiva_nn_1_1_N = mkN "röjarskiva" ;
  roekruta_nn_1_1_N = mkN "rökruta" ;
  roekslinga_nn_1_1_N = mkN "rökslinga" ;
  roekstrimma_nn_1_1_N = mkN "rökstrimma" ;
  roelleka_nn_1_1_N = mkN "rölleka" ;
  roellika_nn_1_1_N = mkN "röllika" ;
  roentgenkamera_nn_1_1_N = mkN "röntgenkamera" ;
  roera_nn_1_1_N = mkN "röra" ;
  roera_nn_2_1_N = mkN "röra" ;
  roerelsefoermaaga_nn_1_1_N = mkN "rörelseförmåga" ;
  roerhoena_nn_1_1_N = mkN "rörhöna" ;
  roestraettsfraaga_nn_1_1_N = mkN "rösträttsfråga" ;
  roestspringa_nn_1_1_N = mkN "röstspringa" ;
  roeststyrka_nn_1_1_N = mkN "röststyrka" ;
  roeta_nn_1_1_N = mkN "röta" ;
  s_kurva_nn_1_N = mkN "s-kurva" ;
  sabadillaettika_nn_1_1_N = mkN "sabadillättika" ;
  sabelbalja_nn_1_N = mkN "sabelbalja" ;
  sabelklinga_nn_1_N = mkN "sabelklinga" ;
  sabellilja_nn_1_N = mkN "sabellilja" ;
  sachertaarta_nn_1_1_N = mkN "sachertårta" ;
  sadeldyna_nn_1_N = mkN "sadeldyna" ;
  sadelnaesa_nn_1_1_N = mkN "sadelnäsa" ;
  sadelputa_nn_1_N = mkN "sadelputa" ;
  saffian_nn_1_N = mkN "saffian" ;
  saffran_nn_1_N = mkN "saffran" ;
  saffransbulla_nn_1_N = mkN "saffransbulla" ;
  saffranspannkaka_nn_1_N = mkN "saffranspannkaka" ;
  saftkanna_nn_1_N = mkN "saftkanna" ;
  saftsoppa_nn_1_N = mkN "saftsoppa" ;
  saga_nn_1_N = mkN "saga" ;
  sago_nn_1_N = mkN "sago" ;
  sagohoerna_nn_1_1_N = mkN "sagohörna" ;
  sagoprinsessa_nn_1_N = mkN "sagoprinsessa" ;
  sagosoppa_nn_1_N = mkN "sagosoppa" ;
  saiga_nn_1_N = mkN "saiga" ;
  saintpaulia_nn_1_N = mkN "saintpaulia" ;
  sakfraaga_nn_1_1_N = mkN "sakfråga" ;
  sakprosa_nn_1_N = mkN "sakprosa" ;
  sakristia_nn_1_N = mkN "sakristia" ;
  sakskada_nn_1_N = mkN "sakskada" ;
  salicylsyra_nn_1_N = mkN "salicylsyra" ;
  salighetslaera_nn_1_1_N = mkN "salighetslära" ;
  salladsgurka_nn_1_N = mkN "salladsgurka" ;
  salmonella_nn_1_N = mkN "salmonella" ;
  salomonska_nn_1_N = mkN "salomonska" ;
  salpeter_nn_1_N = mkN "salpeter" ;
  salpetergruva_nn_1_N = mkN "salpetergruva" ;
  salpetersyra_nn_1_N = mkN "salpetersyra" ;
  saltgruva_nn_1_N = mkN "saltgruva" ;
  saltgurka_nn_1_N = mkN "saltgurka" ;
  saltimbocca_nn_1_N = mkN "saltimbocca" ;
  saltkaella_nn_1_1_N = mkN "saltkälla" ;
  saltlaanga_nn_1_1_N = mkN "saltlånga" ;
  saltsjoe_nn_1_1_N = mkN "saltsjö" ;
  saltsjoebadsanda_nn_1_1_N = mkN "saltsjöbadsanda" ;
  saltsyra_nn_1_N = mkN "saltsyra" ;
  saltvattensnaecka_nn_1_1_N = mkN "saltvattensnäcka" ;
  salubrin_nn_1_N = mkN "salubrin" ;
  salva_nn_1_N = mkN "salva" ;
  salvadoranska_nn_1_N = mkN "salvadoranska" ;
  salvarsan_nn_1_N = mkN "salvarsan" ;
  salvia_nn_1_N = mkN "salvia" ;
  samaritlaada_nn_1_1_N = mkN "samaritlåda" ;
  samba_nn_1_N = mkN "samba" ;
  sambuca_nn_1_N = mkN "sambuca" ;
  sambuca_nn_2_N = mkN "sambuca" ;
  samfaerdsel_nn_1_1_N = mkN "samfärdsel" ;
  samhaellsanda_nn_1_1_N = mkN "samhällsanda" ;
  samhaellsfara_nn_1_1_N = mkN "samhällsfara" ;
  samhaellslaera_nn_1_1_N = mkN "samhällslära" ;
  samhaellsnytta_nn_1_1_N = mkN "samhällsnytta" ;
  samhoerighetskaensla_nn_1_1_N = mkN "samhörighetskänsla" ;
  samiska_nn_1_N = mkN "samiska" ;
  samlarsyssla_nn_1_N = mkN "samlarsyssla" ;
  samoanska_nn_1_N = mkN "samoanska" ;
  samoanska_nn_2_N = mkN "samoanska" ;
  samojediska_nn_1_N = mkN "samojediska" ;
  samsara_nn_1_N = mkN "samsara" ;
  samskola_nn_1_N = mkN "samskola" ;
  samsu_nn_1_N = mkN "samsu" ;
  samtidsprosa_nn_1_N = mkN "samtidsprosa" ;
  samvaro_nn_1_N = mkN "samvaro" ;
  samvetsfraaga_nn_1_1_N = mkN "samvetsfråga" ;
  samvetsro_nn_1_N = mkN "samvetsro" ;
  sandbotten_nn_1_N = mkN "sandbotten" ;
  sandel_nn_1_N = mkN "sandel" ;
  sandelolja_nn_1_N = mkN "sandelolja" ;
  sandfluga_nn_1_N = mkN "sandfluga" ;
  sandflundra_nn_1_N = mkN "sandflundra" ;
  sandkaka_nn_1_N = mkN "sandkaka" ;
  sandlilja_nn_1_N = mkN "sandlilja" ;
  sandloppa_nn_1_N = mkN "sandloppa" ;
  sandlaada_nn_1_1_N = mkN "sandlåda" ;
  sandmussla_nn_1_N = mkN "sandmussla" ;
  sandnejlika_nn_1_N = mkN "sandnejlika" ;
  sandnoerel_nn_1_1_N = mkN "sandnörel" ;
  sandpaerla_nn_1_1_N = mkN "sandpärla" ;
  sandraeka_nn_1_1_N = mkN "sandräka" ;
  sandskaedda_nn_1_1_N = mkN "sandskädda" ;
  sandstenstrappa_nn_1_N = mkN "sandstenstrappa" ;
  sandvita_nn_1_N = mkN "sandvita" ;
  sandoedla_nn_1_1_N = mkN "sandödla" ;
  saneringsfirma_nn_1_N = mkN "saneringsfirma" ;
  sangria_nn_1_N = mkN "sangria" ;
  sanitetsbinda_nn_1_N = mkN "sanitetsbinda" ;
  sanitetsflagga_nn_1_N = mkN "sanitetsflagga" ;
  sanktpaulia_nn_1_N = mkN "sanktpaulia" ;
  sanmarinska_nn_1_N = mkN "sanmarinska" ;
  sannsaga_nn_1_N = mkN "sannsaga" ;
  saotomeanska_nn_1_N = mkN "saotomeanska" ;
  sardiniska_nn_1_N = mkN "sardiniska" ;
  sardiniska_nn_2_N = mkN "sardiniska" ;
  sardinska_nn_1_N = mkN "sardinska" ;
  sardinska_nn_2_N = mkN "sardinska" ;
  sardiska_nn_1_N = mkN "sardiska" ;
  sardiska_nn_2_N = mkN "sardiska" ;
  sargasso_nn_1_N = mkN "sargasso" ;
  satellitbana_nn_1_N = mkN "satellitbana" ;
  satellitkamera_nn_1_N = mkN "satellitkamera" ;
  satellitkarta_nn_1_N = mkN "satellitkarta" ;
  satellitradio_nn_1_N = mkN "satellitradio" ;
  satmara_nn_1_N = mkN "satmara" ;
  satsbraeda_nn_1_1_N = mkN "satsbräda" ;
  satsflaeta_nn_1_1_N = mkN "satsfläta" ;
  satslaera_nn_1_1_N = mkN "satslära" ;
  satsyta_nn_1_N = mkN "satsyta" ;
  saudiarabiska_nn_1_N = mkN "saudiarabiska" ;
  sauna_nn_1_N = mkN "sauna" ;
  scarlatina_nn_1_N = mkN "scarlatina" ;
  scenskola_nn_1_N = mkN "scenskola" ;
  scenvana_nn_1_N = mkN "scenvana" ;
  schackbraeda_nn_1_1_N = mkN "schackbräda" ;
  schaktmassa_nn_1_N = mkN "schaktmassa" ;
  schanker_nn_1_N = mkN "schanker" ;
  scharlakansfeber_nn_1_N = mkN "scharlakansfeber" ;
  schwarzwaldtaarta_nn_1_1_N = mkN "schwarzwaldtårta" ;
  schweiziska_nn_1_N = mkN "schweiziska" ;
  scilla_nn_1_N = mkN "scilla" ;
  scripta_nn_1_N = mkN "scripta" ;
  sebra_nn_1_N = mkN "sebra" ;
  sedelaera_nn_1_1_N = mkN "sedelära" ;
  sedimentkaerna_nn_1_1_N = mkN "sedimentkärna" ;
  sedlighetsiver_nn_1_N = mkN "sedlighetsiver" ;
  sedvana_nn_1_N = mkN "sedvana" ;
  sedvaenja_nn_1_1_N = mkN "sedvänja" ;
  segelarea_nn_1_N = mkN "segelarea" ;
  segelraenna_nn_1_1_N = mkN "segelränna" ;
  segelskuta_nn_1_N = mkN "segelskuta" ;
  segelyta_nn_1_N = mkN "segelyta" ;
  segerhuva_nn_1_N = mkN "segerhuva" ;
  segeryra_nn_1_N = mkN "segeryra" ;
  seglarmoessa_nn_1_1_N = mkN "seglarmössa" ;
  sekter_nn_1_N = mkN "sekter" ;
  sekundaerskola_nn_1_1_N = mkN "sekundärskola" ;
  sekvester_nn_1_N = mkN "sekvester" ;
  selektionslaera_nn_1_1_N = mkN "selektionslära" ;
  selleribotten_nn_1_N = mkN "selleribotten" ;
  semaforflagga_nn_1_N = mkN "semaforflagga" ;
  semesterkamera_nn_1_N = mkN "semesterkamera" ;
  semesterkassa_nn_1_N = mkN "semesterkassa" ;
  seminavel_nn_1_N = mkN "seminavel" ;
  semla_nn_1_N = mkN "semla" ;
  sena_nn_1_N = mkN "sena" ;
  senegalesiska_nn_1_N = mkN "senegalesiska" ;
  senhinna_nn_1_N = mkN "senhinna" ;
  senna_nn_1_N = mkN "senna" ;
  sensitiva_nn_1_N = mkN "sensitiva" ;
  senskida_nn_1_N = mkN "senskida" ;
  sensommarfluga_nn_1_N = mkN "sensommarfluga" ;
  sepia_nn_1_N = mkN "sepia" ;
  septima_nn_1_N = mkN "septima" ;
  sequoia_nn_1_N = mkN "sequoia" ;
  serbiska_nn_1_N = mkN "serbiska" ;
  serbokroatiska_nn_1_N = mkN "serbokroatiska" ;
  serieruta_nn_1_N = mkN "serieruta" ;
  serveruta_nn_1_N = mkN "serveruta" ;
  servicelucka_nn_1_N = mkN "servicelucka" ;
  servruta_nn_1_N = mkN "servruta" ;
  sessa_nn_1_N = mkN "sessa" ;
  sexa_nn_1_N = mkN "sexa" ;
  sexhaerva_nn_1_1_N = mkN "sexhärva" ;
  seychelliska_nn_1_N = mkN "seychelliska" ;
  senora_nn_1_1_N = mkN "señora" ;
  senorita_nn_1_1_N = mkN "señorita" ;
  shetlandstroeja_nn_1_1_N = mkN "shetlandströja" ;
  shingel_nn_1_N = mkN "shingel" ;
  shoppinggalleria_nn_1_N = mkN "shoppinggalleria" ;
  shoppingrunda_nn_1_N = mkN "shoppingrunda" ;
  shoppingvaeska_nn_1_1_N = mkN "shoppingväska" ;
  showvaerdinna_nn_1_1_N = mkN "showvärdinna" ;
  sibetolja_nn_1_N = mkN "sibetolja" ;
  sibylla_nn_1_N = mkN "sibylla" ;
  sicilianska_nn_1_N = mkN "sicilianska" ;
  sida_nn_1_N = mkN "sida" ;
  sidbena_nn_1_N = mkN "sidbena" ;
  sidenapa_nn_1_N = mkN "sidenapa" ;
  sidobana_nn_1_N = mkN "sidobana" ;
  sidogata_nn_1_N = mkN "sidogata" ;
  sidolanterna_nn_1_N = mkN "sidolanterna" ;
  sidoruta_nn_1_N = mkN "sidoruta" ;
  siena_nn_1_N = mkN "siena" ;
  sierraleonska_nn_1_N = mkN "sierraleonska" ;
  sierska_nn_1_N = mkN "sierska" ;
  siesta_nn_1_N = mkN "siesta" ;
  siffersumma_nn_1_N = mkN "siffersumma" ;
  siffertavla_nn_1_N = mkN "siffertavla" ;
  siffra_nn_1_N = mkN "siffra" ;
  signalbana_nn_1_N = mkN "signalbana" ;
  signalflagga_nn_1_N = mkN "signalflagga" ;
  signalkraefta_nn_1_1_N = mkN "signalkräfta" ;
  signora_nn_1_N = mkN "signora" ;
  signorina_nn_1_N = mkN "signorina" ;
  sikloeja_nn_1_1_N = mkN "siklöja" ;
  siktkaka_nn_1_N = mkN "siktkaka" ;
  siktruta_nn_1_N = mkN "siktruta" ;
  siktskaara_nn_1_1_N = mkN "siktskåra" ;
  siktstraecka_nn_1_1_N = mkN "siktsträcka" ;
  silkeapa_nn_1_N = mkN "silkeapa" ;
  silkesapa_nn_1_N = mkN "silkesapa" ;
  silkesatlas_nn_1_N = mkN "silkesatlas" ;
  silkesbehaa_nn_1_1_N = mkN "silkesbehå" ;
  silkesfjaeril_nn_1_1_N = mkN "silkesfjäril" ;
  silkesstrumpa_nn_1_N = mkN "silkesstrumpa" ;
  silkestrumpa_nn_1_N = mkN "silkestrumpa" ;
  sillbricka_nn_1_N = mkN "sillbricka" ;
  sillgrissla_nn_1_N = mkN "sillgrissla" ;
  sillguano_nn_1_N = mkN "sillguano" ;
  sillaada_nn_1_1_N = mkN "sillåda" ;
  silverfemma_nn_1_N = mkN "silverfemma" ;
  silvergruva_nn_1_N = mkN "silvergruva" ;
  silvertacka_nn_1_N = mkN "silvertacka" ;
  silvertaerna_nn_1_1_N = mkN "silvertärna" ;
  simblaasa_nn_1_1_N = mkN "simblåsa" ;
  simbyxa_nn_1_N = mkN "simbyxa" ;
  simdyna_nn_1_N = mkN "simdyna" ;
  simfena_nn_1_N = mkN "simfena" ;
  simpa_nn_1_N = mkN "simpa" ;
  simskola_nn_1_N = mkN "simskola" ;
  simsnaeppa_nn_1_1_N = mkN "simsnäppa" ;
  sinfonia_nn_1_N = mkN "sinfonia" ;
  singalesiska_nn_1_N = mkN "singalesiska" ;
  singalesiska_nn_2_N = mkN "singalesiska" ;
  singaporianska_nn_1_N = mkN "singaporianska" ;
  singel_nn_2_N = mkN "singel" ;
  singelmamma_nn_1_N = mkN "singelmamma" ;
  singelolycka_nn_1_N = mkN "singelolycka" ;
  sinnesnaervaro_nn_1_1_N = mkN "sinnesnärvaro" ;
  sinnesro_nn_1_N = mkN "sinnesro" ;
  sinnesvilla_nn_1_N = mkN "sinnesvilla" ;
  sinter_nn_1_N = mkN "sinter" ;
  sinuskurva_nn_1_N = mkN "sinuskurva" ;
  sippa_nn_1_N = mkN "sippa" ;
  sirapslimpa_nn_1_N = mkN "sirapslimpa" ;
  sirocko_nn_1_N = mkN "sirocko" ;
  sisalhampa_nn_1_N = mkN "sisalhampa" ;
  siska_nn_1_N = mkN "siska" ;
  sista_minutenresa_nn_1_N = mkN "sista-minutenresa" ;
  sista_nn_1_N = mkN "sista" ;
  sisu_nn_1_N = mkN "sisu" ;
  sittbraeda_nn_1_1_N = mkN "sittbräda" ;
  sittdyna_nn_1_N = mkN "sittdyna" ;
  sjana_nn_1_N = mkN "sjana" ;
  sjua_nn_1_N = mkN "sjua" ;
  sjubarnspappa_nn_1_N = mkN "sjubarnspappa" ;
  sjudagarsvecka_nn_1_N = mkN "sjudagarsvecka" ;
  sjuka_nn_1_N = mkN "sjuka" ;
  sjukfraanvaro_nn_1_1_N = mkN "sjukfrånvaro" ;
  sjukkassa_nn_1_N = mkN "sjukkassa" ;
  sjukskoeterska_nn_1_1_N = mkN "sjuksköterska" ;
  sjukskoeterskeskola_nn_1_1_N = mkN "sjuksköterskeskola" ;
  sjukstuga_nn_1_N = mkN "sjukstuga" ;
  sjustjaerna_nn_1_1_N = mkN "sjustjärna" ;
  sjuttioaarsaalder_nn_1_1_N = mkN "sjuttioårsålder" ;
  sjaelamaessa_nn_1_1_N = mkN "själamässa" ;
  sjaelsadel_nn_1_1_N = mkN "själsadel" ;
  sjaelsfraanvaro_nn_1_1_N = mkN "själsfrånvaro" ;
  sjaelsnaervaro_nn_1_1_N = mkN "själsnärvaro" ;
  sjaelsro_nn_1_1_N = mkN "själsro" ;
  sjaelsstyrka_nn_1_1_N = mkN "själsstyrka" ;
  sjaelsvaanda_nn_1_1_N = mkN "själsvånda" ;
  sjaelvspricka_nn_1_1_N = mkN "självspricka" ;
  sjoe_nn_1_1_N = mkN "sjö" ;
  sjoebotten_nn_1_1_N = mkN "sjöbotten" ;
  sjoegurka_nn_1_1_N = mkN "sjögurka" ;
  sjoemansbyxa_nn_1_1_N = mkN "sjömansbyxa" ;
  sjoemanskista_nn_1_1_N = mkN "sjömanskista" ;
  sjoemansvisa_nn_1_1_N = mkN "sjömansvisa" ;
  sjoemina_nn_1_1_N = mkN "sjömina" ;
  sjoeolycka_nn_1_1_N = mkN "sjöolycka" ;
  sjoepenna_nn_1_1_N = mkN "sjöpenna" ;
  sjoestjaerna_nn_1_1_N = mkN "sjöstjärna" ;
  sjoetunga_nn_1_1_N = mkN "sjötunga" ;
  sjoevana_nn_1_1_N = mkN "sjövana" ;
  sjoeyta_nn_1_1_N = mkN "sjöyta" ;
  skada_nn_1_N = mkN "skada" ;
  skafferihylla_nn_1_N = mkN "skafferihylla" ;
  skala_nn_1_N = mkN "skala" ;
  skallra_nn_1_N = mkN "skallra" ;
  skallskada_nn_1_N = mkN "skallskada" ;
  skalmeja_nn_1_N = mkN "skalmeja" ;
  skamkaensla_nn_1_1_N = mkN "skamkänsla" ;
  skamvraa_nn_1_1_N = mkN "skamvrå" ;
  skaparanda_nn_1_N = mkN "skaparanda" ;
  skara_nn_1_N = mkN "skara" ;
  skarsnoe_nn_1_1_N = mkN "skarsnö" ;
  skarvklaemma_nn_1_1_N = mkN "skarvklämma" ;
  skata_nn_1_N = mkN "skata" ;
  skatnaeva_nn_1_1_N = mkN "skatnäva" ;
  skattefraaga_nn_1_1_N = mkN "skattefråga" ;
  skattefoermaaga_nn_1_1_N = mkN "skatteförmåga" ;
  skattekrona_nn_1_N = mkN "skattekrona" ;
  skatteskala_nn_1_N = mkN "skatteskala" ;
  skattgoemma_nn_1_1_N = mkN "skattgömma" ;
  skena_nn_1_N = mkN "skena" ;
  skepplista_nn_1_N = mkN "skepplista" ;
  skeppsbro_nn_1_N = mkN "skeppsbro" ;
  skeppsklocka_nn_1_N = mkN "skeppsklocka" ;
  skeppsskorpa_nn_1_N = mkN "skeppsskorpa" ;
  skida_nn_1_N = mkN "skida" ;
  skidresa_nn_1_N = mkN "skidresa" ;
  skifferolja_nn_1_N = mkN "skifferolja" ;
  skifferplatta_nn_1_N = mkN "skifferplatta" ;
  skilsmaessa_nn_1_1_N = mkN "skilsmässa" ;
  skinka_nn_1_N = mkN "skinka" ;
  skinnjacka_nn_1_N = mkN "skinnjacka" ;
  skinnsoffa_nn_1_N = mkN "skinnsoffa" ;
  skiva_nn_1_N = mkN "skiva" ;
  skjorta_nn_1_N = mkN "skjorta" ;
  skjutbana_nn_1_N = mkN "skjutbana" ;
  skjutlucka_nn_1_N = mkN "skjutlucka" ;
  skocka_nn_1_N = mkN "skocka" ;
  skogsblomma_nn_1_N = mkN "skogsblomma" ;
  skogsduva_nn_1_N = mkN "skogsduva" ;
  skogsfru_nn_1_N = mkN "skogsfru" ;
  skogsglaenta_nn_1_1_N = mkN "skogsglänta" ;
  skogshoegskola_nn_1_1_N = mkN "skogshögskola" ;
  skogsjacka_nn_1_N = mkN "skogsjacka" ;
  skogsmulleskola_nn_1_N = mkN "skogsmulleskola" ;
  skogsnaeva_nn_1_1_N = mkN "skogsnäva" ;
  skogsskoetsel_nn_1_1_N = mkN "skogsskötsel" ;
  skogssnuva_nn_1_N = mkN "skogssnuva" ;
  skogssnaeppa_nn_1_1_N = mkN "skogssnäppa" ;
  skogsstjaerna_nn_1_1_N = mkN "skogsstjärna" ;
  skola_nn_1_N = mkN "skola" ;
  skolflicka_nn_1_N = mkN "skolflicka" ;
  skolfranska_nn_1_N = mkN "skolfranska" ;
  skolfroeken_nn_1_1_N = mkN "skolfröken" ;
  skolmoessa_nn_1_1_N = mkN "skolmössa" ;
  skolradio_nn_1_N = mkN "skolradio" ;
  skolresa_nn_1_N = mkN "skolresa" ;
  skolskoeterska_nn_1_1_N = mkN "skolsköterska" ;
  skolaalder_nn_1_1_N = mkN "skolålder" ;
  skopa_nn_1_N = mkN "skopa" ;
  skorpa_nn_1_N = mkN "skorpa" ;
  skosmoerja_nn_1_1_N = mkN "skosmörja" ;
  skosula_nn_1_N = mkN "skosula" ;
  skoterkaenga_nn_1_1_N = mkN "skoterkänga" ;
  skotska_nn_1_N = mkN "skotska" ;
  skotska_nn_2_N = mkN "skotska" ;
  skottavla_nn_1_N = mkN "skottavla" ;
  skottkaerra_nn_1_1_N = mkN "skottkärra" ;
  skottningsolycka_nn_1_N = mkN "skottningsolycka" ;
  skottskada_nn_1_N = mkN "skottskada" ;
  skrabba_nn_1_N = mkN "skrabba" ;
  skramla_nn_1_N = mkN "skramla" ;
  skranka_nn_1_N = mkN "skranka" ;
  skrapa_nn_1_N = mkN "skrapa" ;
  skrattrynka_nn_1_N = mkN "skrattrynka" ;
  skrattsalva_nn_1_N = mkN "skrattsalva" ;
  skreva_nn_1_N = mkN "skreva" ;
  skridskobana_nn_1_N = mkN "skridskobana" ;
  skridskoprinsessa_nn_1_N = mkN "skridskoprinsessa" ;
  skrika_nn_1_N = mkN "skrika" ;
  skrinda_nn_1_N = mkN "skrinda" ;
  skripta_nn_1_N = mkN "skripta" ;
  skrivarfoermaaga_nn_1_1_N = mkN "skrivarförmåga" ;
  skrivbordslampa_nn_1_N = mkN "skrivbordslampa" ;
  skrivbordslaada_nn_1_1_N = mkN "skrivbordslåda" ;
  skrivfoermaaga_nn_1_1_N = mkN "skrivförmåga" ;
  skrivhoerna_nn_1_1_N = mkN "skrivhörna" ;
  skrivklaada_nn_1_1_N = mkN "skrivklåda" ;
  skrivtavla_nn_1_N = mkN "skrivtavla" ;
  skrubba_nn_1_N = mkN "skrubba" ;
  skrumplever_nn_1_N = mkN "skrumplever" ;
  skrutt_nn_1_N = mkN "skrutt" ;
  skrymsla_nn_1_N = mkN "skrymsla" ;
  skrymt_nn_2_N = mkN "skrymt" ;
  skrynkla_nn_1_N = mkN "skrynkla" ;
  skraeckpropaganda_nn_1_1_N = mkN "skräckpropaganda" ;
  skraeckoedla_nn_1_1_N = mkN "skräcködla" ;
  skraedyxa_nn_1_1_N = mkN "skrädyxa" ;
  skraemsel_nn_1_1_N = mkN "skrämsel" ;
  skraemselhicka_nn_1_1_N = mkN "skrämselhicka" ;
  skraemselpropaganda_nn_1_1_N = mkN "skrämselpropaganda" ;
  skraeppa_nn_1_1_N = mkN "skräppa" ;
  skraaanda_nn_1_1_N = mkN "skråanda" ;
  skraama_nn_1_1_N = mkN "skråma" ;
  skroena_nn_1_1_N = mkN "skröna" ;
  skugga_nn_1_N = mkN "skugga" ;
  skuggsida_nn_1_N = mkN "skuggsida" ;
  skuldboerda_nn_1_1_N = mkN "skuldbörda" ;
  skuldergoerdel_nn_1_1_N = mkN "skuldergördel" ;
  skuldfaella_nn_1_1_N = mkN "skuldfälla" ;
  skuldkaensla_nn_1_1_N = mkN "skuldkänsla" ;
  skuldra_nn_1_N = mkN "skuldra" ;
  skuldraenta_nn_1_1_N = mkN "skuldränta" ;
  skumbubbla_nn_1_N = mkN "skumbubbla" ;
  skumpa_nn_1_N = mkN "skumpa" ;
  skurgumma_nn_1_N = mkN "skurgumma" ;
  skurtrasa_nn_1_N = mkN "skurtrasa" ;
  skuta_nn_1_N = mkN "skuta" ;
  skvallerbytta_nn_1_N = mkN "skvallerbytta" ;
  skvallertacka_nn_1_N = mkN "skvallertacka" ;
  skvallertaska_nn_1_N = mkN "skvallertaska" ;
  skvalta_nn_1_N = mkN "skvalta" ;
  skvaetta_nn_1_1_N = mkN "skvätta" ;
  skyltdocka_nn_1_N = mkN "skyltdocka" ;
  skyltlaada_nn_1_1_N = mkN "skyltlåda" ;
  skyskrapa_nn_1_N = mkN "skyskrapa" ;
  skytteskaelva_nn_1_1_N = mkN "skytteskälva" ;
  skaedda_nn_1_1_N = mkN "skädda" ;
  skaeggbotten_nn_1_1_N = mkN "skäggbotten" ;
  skaeggvaarta_nn_1_1_N = mkN "skäggvårta" ;
  skaekta_nn_1_1_N = mkN "skäkta" ;
  skaella_nn_1_1_N = mkN "skälla" ;
  skaelva_nn_1_1_N = mkN "skälva" ;
  skaeppa_nn_1_1_N = mkN "skäppa" ;
  skaera_nn_1_1_N = mkN "skära" ;
  skaerbraeda_nn_1_1_N = mkN "skärbräda" ;
  skaerboena_nn_1_1_N = mkN "skärböna" ;
  skaerflaecka_nn_1_1_N = mkN "skärfläcka" ;
  skaergaardsoe_nn_1_1_N = mkN "skärgårdsö" ;
  skaerlaada_nn_1_1_N = mkN "skärlåda" ;
  skaermmoessa_nn_1_1_N = mkN "skärmmössa" ;
  skaerpa_nn_1_1_N = mkN "skärpa" ;
  skaerpiplaerka_nn_1_1_N = mkN "skärpiplärka" ;
  skaerra_nn_1_1_N = mkN "skärra" ;
  skaerva_nn_1_1_N = mkN "skärva" ;
  skaadebana_nn_1_1_N = mkN "skådebana" ;
  skaadespelerska_nn_1_1_N = mkN "skådespelerska" ;
  skaalsnaecka_nn_1_1_N = mkN "skålsnäcka" ;
  skaanska_nn_1_1_N = mkN "skånska" ;
  skaanska_nn_2_1_N = mkN "skånska" ;
  skaara_nn_1_1_N = mkN "skåra" ;
  skoeka_nn_1_1_N = mkN "sköka" ;
  skoeldpadda_nn_1_1_N = mkN "sköldpadda" ;
  skoeljkanna_nn_1_1_N = mkN "sköljkanna" ;
  skoenprosa_nn_1_1_N = mkN "skönprosa" ;
  skoera_nn_1_1_N = mkN "sköra" ;
  skoerdetroeska_nn_1_1_N = mkN "skördetröska" ;
  skoeterska_nn_1_1_N = mkN "sköterska" ;
  skoetsel_nn_1_1_N = mkN "skötsel" ;
  slabbertacka_nn_1_N = mkN "slabbertacka" ;
  slabbkista_nn_1_N = mkN "slabbkista" ;
  sladdklaemma_nn_1_1_N = mkN "sladdklämma" ;
  sladdlampa_nn_1_N = mkN "sladdlampa" ;
  slafsa_nn_1_N = mkN "slafsa" ;
  slaga_nn_1_N = mkN "slaga" ;
  slagdaenga_nn_1_1_N = mkN "slagdänga" ;
  slagruta_nn_1_N = mkN "slagruta" ;
  slagsida_nn_1_N = mkN "slagsida" ;
  slagskugga_nn_1_N = mkN "slagskugga" ;
  slaguggla_nn_1_N = mkN "slaguggla" ;
  slaksida_nn_1_N = mkN "slaksida" ;
  slalomskida_nn_1_N = mkN "slalomskida" ;
  slamfluga_nn_1_N = mkN "slamfluga" ;
  slampa_nn_1_N = mkN "slampa" ;
  slamsa_nn_1_N = mkN "slamsa" ;
  slana_nn_1_N = mkN "slana" ;
  slangbella_nn_1_N = mkN "slangbella" ;
  slanggurka_nn_1_N = mkN "slanggurka" ;
  slangklaemma_nn_1_1_N = mkN "slangklämma" ;
  slarva_nn_1_N = mkN "slarva" ;
  slarvpotta_nn_1_N = mkN "slarvpotta" ;
  slarvsylta_nn_1_N = mkN "slarvsylta" ;
  slavhandel_nn_1_N = mkN "slavhandel" ;
  slavinna_nn_1_N = mkN "slavinna" ;
  slavtillvaro_nn_1_N = mkN "slavtillvaro" ;
  slemhinna_nn_1_N = mkN "slemhinna" ;
  slida_nn_1_N = mkN "slida" ;
  slinga_nn_1_N = mkN "slinga" ;
  slinka_nn_1_N = mkN "slinka" ;
  slipersolja_nn_1_N = mkN "slipersolja" ;
  slipmassa_nn_1_N = mkN "slipmassa" ;
  slippasta_nn_1_N = mkN "slippasta" ;
  slira_nn_1_N = mkN "slira" ;
  slitbana_nn_1_N = mkN "slitbana" ;
  slityta_nn_1_N = mkN "slityta" ;
  slivovica_nn_1_N = mkN "slivovica" ;
  slottsfru_nn_1_N = mkN "slottsfru" ;
  slottskyrka_nn_1_N = mkN "slottskyrka" ;
  slovakiska_nn_1_N = mkN "slovakiska" ;
  slovakiska_nn_2_N = mkN "slovakiska" ;
  slovenska_nn_1_N = mkN "slovenska" ;
  slovenska_nn_2_N = mkN "slovenska" ;
  slunga_nn_1_N = mkN "slunga" ;
  slusstrappa_nn_1_N = mkN "slusstrappa" ;
  slutfaara_nn_1_1_N = mkN "slutfåra" ;
  slutnota_nn_1_N = mkN "slutnota" ;
  slutstraecka_nn_1_1_N = mkN "slutsträcka" ;
  slutsumma_nn_1_N = mkN "slutsumma" ;
  slya_nn_1_N = mkN "slya" ;
  slyklinga_nn_1_N = mkN "slyklinga" ;
  slyna_nn_1_N = mkN "slyna" ;
  slynga_nn_1_N = mkN "slynga" ;
  slaegga_nn_1_1_N = mkN "slägga" ;
  slaektkroenika_nn_1_1_N = mkN "släktkrönika" ;
  slaektsaga_nn_1_1_N = mkN "släktsaga" ;
  slaektskap_nn_1_1_N = mkN "släktskap" ;
  slaenda_nn_1_1_N = mkN "slända" ;
  slaendtrissa_nn_1_1_N = mkN "sländtrissa" ;
  slaenggunga_nn_1_1_N = mkN "slänggunga" ;
  slaengkappa_nn_1_1_N = mkN "slängkappa" ;
  slaengpolska_nn_1_1_N = mkN "slängpolska" ;
  slaepkaerra_nn_1_1_N = mkN "släpkärra" ;
  slaeplina_nn_1_1_N = mkN "släplina" ;
  slaetbana_nn_1_1_N = mkN "slätbana" ;
  slaa_nn_1_1_N = mkN "slå" ;
  slaan_nn_1_1_N = mkN "slån" ;
  slaatta_nn_1_1_N = mkN "slåtta" ;
  slaatterblomma_nn_1_1_N = mkN "slåtterblomma" ;
  sloedricka_nn_1_1_N = mkN "slödricka" ;
  sloeja_nn_1_1_N = mkN "slöja" ;
  smakfraaga_nn_1_1_N = mkN "smakfråga" ;
  smakstyrka_nn_1_N = mkN "smakstyrka" ;
  smalnaesapa_nn_1_1_N = mkN "smalnäsapa" ;
  smalaenda_nn_1_1_N = mkN "smalända" ;
  smedhalva_nn_1_N = mkN "smedhalva" ;
  smedja_nn_1_N = mkN "smedja" ;
  smegma_nn_1_N = mkN "smegma" ;
  smeka_nn_1_N = mkN "smeka" ;
  smetana_nn_1_N = mkN "smetana" ;
  sminkerska_nn_1_N = mkN "sminkerska" ;
  smita_nn_1_N = mkN "smita" ;
  smitningsolycka_nn_1_N = mkN "smitningsolycka" ;
  smitta_nn_1_N = mkN "smitta" ;
  smittkoppa_nn_1_N = mkN "smittkoppa" ;
  smittkaella_nn_1_1_N = mkN "smittkälla" ;
  smocka_nn_1_N = mkN "smocka" ;
  smokingskjorta_nn_1_N = mkN "smokingskjorta" ;
  smula_nn_1_N = mkN "smula" ;
  smultrontunga_nn_1_N = mkN "smultrontunga" ;
  smaella_nn_1_1_N = mkN "smälla" ;
  smaelta_nn_1_1_N = mkN "smälta" ;
  smaeltvaerme_nn_1_1_N = mkN "smältvärme" ;
  smaergel_nn_1_1_N = mkN "smärgel" ;
  smaerta_nn_1_1_N = mkN "smärta" ;
  smaerttroeskel_nn_1_1_N = mkN "smärttröskel" ;
  smaabarnsmamma_nn_1_1_N = mkN "småbarnsmamma" ;
  smaabildskamera_nn_1_1_N = mkN "småbildskamera" ;
  smaabrygga_nn_1_1_N = mkN "småbrygga" ;
  smaaflicka_nn_1_1_N = mkN "småflicka" ;
  smaakaka_nn_1_1_N = mkN "småkaka" ;
  smaalaendska_nn_1_1_N = mkN "småländska" ;
  smaalaendska_nn_2_1_N = mkN "småländska" ;
  smaaskola_nn_1_1_N = mkN "småskola" ;
  smaasnaeppa_nn_1_1_N = mkN "småsnäppa" ;
  smoerblomma_nn_1_1_N = mkN "smörblomma" ;
  smoergaasskinka_nn_1_1_N = mkN "smörgåsskinka" ;
  smoergaastaarta_nn_1_1_N = mkN "smörgåstårta" ;
  smoerja_nn_1_1_N = mkN "smörja" ;
  smoerjkanna_nn_1_1_N = mkN "smörjkanna" ;
  smoerjolja_nn_1_1_N = mkN "smörjolja" ;
  smoerkula_nn_1_1_N = mkN "smörkula" ;
  smoersyra_nn_1_1_N = mkN "smörsyra" ;
  snabbcement_nn_1_N = mkN "snabbcement" ;
  snabbkassa_nn_1_N = mkN "snabbkassa" ;
  snabbkoepskassa_nn_1_1_N = mkN "snabbköpskassa" ;
  snabbplatta_nn_1_N = mkN "snabbplatta" ;
  snabbskilsmaessa_nn_1_1_N = mkN "snabbskilsmässa" ;
  snapsvisa_nn_1_N = mkN "snapsvisa" ;
  snara_nn_1_N = mkN "snara" ;
  snarreva_nn_1_N = mkN "snarreva" ;
  snedbena_nn_1_N = mkN "snedbena" ;
  snedremsa_nn_1_N = mkN "snedremsa" ;
  snedruta_nn_1_N = mkN "snedruta" ;
  snedslaa_nn_1_1_N = mkN "snedslå" ;
  snilja_nn_1_N = mkN "snilja" ;
  sniljeflossa_nn_1_N = mkN "sniljeflossa" ;
  snipa_nn_1_N = mkN "snipa" ;
  snippa_nn_1_N = mkN "snippa" ;
  snittblomma_nn_1_N = mkN "snittblomma" ;
  snittyta_nn_1_N = mkN "snittyta" ;
  snoa_nn_1_N = mkN "snoa" ;
  snobbraenna_nn_1_1_N = mkN "snobbränna" ;
  snor_nn_1_N = mkN "snor" ;
  snubba_nn_1_N = mkN "snubba" ;
  snugga_nn_1_N = mkN "snugga" ;
  snultra_nn_1_N = mkN "snultra" ;
  snurra_nn_1_N = mkN "snurra" ;
  snusdosa_nn_1_N = mkN "snusdosa" ;
  snuva_nn_1_N = mkN "snuva" ;
  snyggma_nn_1_N = mkN "snyggma" ;
  snaecka_nn_1_1_N = mkN "snäcka" ;
  snaeckmaergel_nn_1_1_N = mkN "snäckmärgel" ;
  snaeppa_nn_1_1_N = mkN "snäppa" ;
  snaerja_nn_1_1_N = mkN "snärja" ;
  snaerjmaara_nn_1_1_N = mkN "snärjmåra" ;
  snaerpa_nn_1_1_N = mkN "snärpa" ;
  snaerta_nn_1_1_N = mkN "snärta" ;
  snaesa_nn_1_1_N = mkN "snäsa" ;
  snaarvinda_nn_1_1_N = mkN "snårvinda" ;
  snoe_nn_1_1_N = mkN "snö" ;
  snoebraeda_nn_1_1_N = mkN "snöbräda" ;
  snoedriva_nn_1_1_N = mkN "snödriva" ;
  snoeflinga_nn_1_1_N = mkN "snöflinga" ;
  snoehalka_nn_1_1_N = mkN "snöhalka" ;
  snoekedja_nn_1_1_N = mkN "snökedja" ;
  snoeklocka_nn_1_1_N = mkN "snöklocka" ;
  snoelega_nn_1_1_N = mkN "snölega" ;
  snoelykta_nn_1_1_N = mkN "snölykta" ;
  snoeripa_nn_1_1_N = mkN "snöripa" ;
  snoerkaenga_nn_1_1_N = mkN "snörkänga" ;
  snoeskata_nn_1_1_N = mkN "snöskata" ;
  snoeskorpa_nn_1_1_N = mkN "snöskorpa" ;
  snoeslunga_nn_1_1_N = mkN "snöslunga" ;
  snoestjaerna_nn_1_1_N = mkN "snöstjärna" ;
  snoeyra_nn_1_1_N = mkN "snöyra" ;
  so_nn_1_N = mkN "so" ;
  socialhoegskola_nn_1_1_N = mkN "socialhögskola" ;
  socka_nn_1_N = mkN "socka" ;
  socken_nn_1_N = mkN "socken" ;
  sockenstuga_nn_1_N = mkN "sockenstuga" ;
  sockerbeta_nn_1_N = mkN "sockerbeta" ;
  sockerdricka_nn_1_N = mkN "sockerdricka" ;
  sockerkaka_nn_1_N = mkN "sockerkaka" ;
  sockerpulla_nn_1_N = mkN "sockerpulla" ;
  sockerskorpa_nn_1_N = mkN "sockerskorpa" ;
  soda_nn_1_N = mkN "soda" ;
  sodamassa_nn_1_N = mkN "sodamassa" ;
  soffa_nn_1_N = mkN "soffa" ;
  soja_nn_1_N = mkN "soja" ;
  sojaboena_nn_1_1_N = mkN "sojaböna" ;
  sojakaka_nn_1_N = mkN "sojakaka" ;
  solariehoena_nn_1_1_N = mkN "solariehöna" ;
  solbraenna_nn_1_1_N = mkN "solbränna" ;
  solcellsvaeska_nn_1_1_N = mkN "solcellsväska" ;
  soldatkappa_nn_1_N = mkN "soldatkappa" ;
  soldataenka_nn_1_1_N = mkN "soldatänka" ;
  solgata_nn_1_N = mkN "solgata" ;
  solkurva_nn_1_N = mkN "solkurva" ;
  sollampa_nn_1_N = mkN "sollampa" ;
  sololja_nn_1_N = mkN "sololja" ;
  solresa_nn_1_N = mkN "solresa" ;
  solsida_nn_1_N = mkN "solsida" ;
  solskensdag_nn_1_N = mkN "solskensdag" ;
  solstrimma_nn_1_N = mkN "solstrimma" ;
  soltimma_nn_1_N = mkN "soltimma" ;
  solveranda_nn_1_N = mkN "solveranda" ;
  solvaenda_nn_1_1_N = mkN "solvända" ;
  somaliska_nn_1_N = mkN "somaliska" ;
  somaliska_nn_2_N = mkN "somaliska" ;
  sommardag_nn_1_N = mkN "sommardag" ;
  sommardimma_nn_1_N = mkN "sommardimma" ;
  sommarfjaeril_nn_1_1_N = mkN "sommarfjäril" ;
  sommarhetta_nn_1_N = mkN "sommarhetta" ;
  sommarstuga_nn_1_N = mkN "sommarstuga" ;
  sommartorka_nn_1_N = mkN "sommartorka" ;
  sommarvecka_nn_1_N = mkN "sommarvecka" ;
  sommarvilla_nn_1_N = mkN "sommarvilla" ;
  sopa_nn_1_N = mkN "sopa" ;
  sopmaja_nn_1_N = mkN "sopmaja" ;
  soppa_nn_1_N = mkN "soppa" ;
  soppa_nn_2_N = mkN "soppa" ;
  sopsaeckskaerra_nn_1_1_N = mkN "sopsäckskärra" ;
  soptunna_nn_1_N = mkN "soptunna" ;
  sorgsloeja_nn_1_1_N = mkN "sorgslöja" ;
  sossekvinna_nn_1_N = mkN "sossekvinna" ;
  sothoena_nn_1_1_N = mkN "sothöna" ;
  spanjorska_nn_1_N = mkN "spanjorska" ;
  spanska_nn_1_N = mkN "spanska" ;
  sparboessa_nn_1_1_N = mkN "sparbössa" ;
  sparkassa_nn_1_N = mkN "sparkassa" ;
  sparkbyxa_nn_1_N = mkN "sparkbyxa" ;
  sparlakanslaexa_nn_1_1_N = mkN "sparlakansläxa" ;
  sparlaaga_nn_1_1_N = mkN "sparlåga" ;
  sparrissoppa_nn_1_N = mkN "sparrissoppa" ;
  sparvuggla_nn_1_N = mkN "sparvuggla" ;
  specialkarta_nn_1_N = mkN "specialkarta" ;
  specialskola_nn_1_N = mkN "specialskola" ;
  specialstyrka_nn_1_N = mkN "specialstyrka" ;
  speed_nn_1_N = mkN "speed" ;
  speedwaybana_nn_1_N = mkN "speedwaybana" ;
  spegelkaerna_nn_1_1_N = mkN "spegelkärna" ;
  spegelreflexkamera_nn_1_N = mkN "spegelreflexkamera" ;
  spelbricka_nn_1_N = mkN "spelbricka" ;
  speldosa_nn_1_N = mkN "speldosa" ;
  spelhaala_nn_1_1_N = mkN "spelhåla" ;
  spelmansstaemma_nn_1_1_N = mkN "spelmansstämma" ;
  spelrazzia_nn_1_N = mkN "spelrazzia" ;
  sperma_nn_1_N = mkN "sperma" ;
  speta_nn_1_N = mkN "speta" ;
  spetsbyxa_nn_1_N = mkN "spetsbyxa" ;
  spettekaka_nn_1_N = mkN "spettekaka" ;
  spettkaka_nn_1_N = mkN "spettkaka" ;
  spetaelska_nn_1_1_N = mkN "spetälska" ;
  spikklubba_nn_1_N = mkN "spikklubba" ;
  spikmatta_nn_1_N = mkN "spikmatta" ;
  spillkraaka_nn_1_1_N = mkN "spillkråka" ;
  spillolja_nn_1_N = mkN "spillolja" ;
  spillra_nn_1_N = mkN "spillra" ;
  spillaanga_nn_1_1_N = mkN "spillånga" ;
  spilta_nn_1_N = mkN "spilta" ;
  spilaapipa_nn_1_1_N = mkN "spilåpipa" ;
  spindelapa_nn_1_N = mkN "spindelapa" ;
  spindelhona_nn_1_N = mkN "spindelhona" ;
  spinnarfjaeril_nn_1_1_N = mkN "spinnarfjäril" ;
  spionkamera_nn_1_N = mkN "spionkamera" ;
  spira_nn_1_N = mkN "spira" ;
  spiralbotten_nn_1_N = mkN "spiralbotten" ;
  spiralnebulosa_nn_1_N = mkN "spiralnebulosa" ;
  spiraltrappa_nn_1_N = mkN "spiraltrappa" ;
  spirea_nn_1_N = mkN "spirea" ;
  spirituosa_nn_1_N = mkN "spirituosa" ;
  spirlaanga_nn_1_1_N = mkN "spirlånga" ;
  spiselhylla_nn_1_N = mkN "spiselhylla" ;
  spishylla_nn_1_N = mkN "spishylla" ;
  spiskupa_nn_1_N = mkN "spiskupa" ;
  spiskaapa_nn_1_1_N = mkN "spiskåpa" ;
  spisplatta_nn_1_N = mkN "spisplatta" ;
  spjaela_nn_1_1_N = mkN "spjäla" ;
  spjaellaada_nn_1_1_N = mkN "spjällåda" ;
  splittra_nn_1_N = mkN "splittra" ;
  spolarvaetska_nn_1_1_N = mkN "spolarvätska" ;
  sponk_nn_1_N = mkN "sponk" ;
  sportarena_nn_1_N = mkN "sportarena" ;
  sportlovsstuga_nn_1_N = mkN "sportlovsstuga" ;
  sportmoessa_nn_1_1_N = mkN "sportmössa" ;
  sportsida_nn_1_N = mkN "sportsida" ;
  sportstuga_nn_1_N = mkN "sportstuga" ;
  spottloska_nn_1_N = mkN "spottloska" ;
  spovsnaeppa_nn_1_1_N = mkN "spovsnäppa" ;
  sprayflaska_nn_1_N = mkN "sprayflaska" ;
  sprejflaska_nn_1_N = mkN "sprejflaska" ;
  spricka_nn_1_N = mkN "spricka" ;
  spridningskaella_nn_1_1_N = mkN "spridningskälla" ;
  springa_nn_1_N = mkN "springa" ;
  springflicka_nn_1_N = mkN "springflicka" ;
  springkaella_nn_1_1_N = mkN "springkälla" ;
  springnota_nn_1_N = mkN "springnota" ;
  spritpenna_nn_1_N = mkN "spritpenna" ;
  spruta_nn_1_N = mkN "spruta" ;
  spraenglista_nn_1_1_N = mkN "spränglista" ;
  spraakfakta_nn_1_1_N = mkN "språkfakta" ;
  spraaklaera_nn_1_1_N = mkN "språklära" ;
  spraakresa_nn_1_1_N = mkN "språkresa" ;
  spraangbraeda_nn_1_1_N = mkN "språngbräda" ;
  spya_nn_1_N = mkN "spya" ;
  spyfluga_nn_1_N = mkN "spyfluga" ;
  spaeddricka_nn_1_1_N = mkN "späddricka" ;
  spaennbuckla_nn_1_1_N = mkN "spännbuckla" ;
  spaerrlista_nn_1_1_N = mkN "spärrlista" ;
  spaetta_nn_1_1_N = mkN "spätta" ;
  spaagumma_nn_1_1_N = mkN "spågumma" ;
  spaakvinna_nn_1_1_N = mkN "spåkvinna" ;
  spaana_nn_1_1_N = mkN "spåna" ;
  spaank_nn_1_1_N = mkN "spånk" ;
  spaanplatta_nn_1_1_N = mkN "spånplatta" ;
  spaanskiva_nn_1_1_N = mkN "spånskiva" ;
  spoektimma_nn_1_1_N = mkN "spöktimma" ;
  srilankesiska_nn_1_N = mkN "srilankesiska" ;
  stabiliseringsfena_nn_1_N = mkN "stabiliseringsfena" ;
  stabskarta_nn_1_N = mkN "stabskarta" ;
  stackmyra_nn_1_N = mkN "stackmyra" ;
  stadga_nn_1_N = mkN "stadga" ;
  stadga_nn_2_N = mkN "stadga" ;
  stadiontuta_nn_1_N = mkN "stadiontuta" ;
  stadsgroenska_nn_1_1_N = mkN "stadsgrönska" ;
  stadskaerna_nn_1_1_N = mkN "stadskärna" ;
  stadsresa_nn_1_N = mkN "stadsresa" ;
  stallykta_nn_1_N = mkN "stallykta" ;
  stambana_nn_1_N = mkN "stambana" ;
  stamtavla_nn_1_N = mkN "stamtavla" ;
  stamvoertstyrka_nn_1_1_N = mkN "stamvörtstyrka" ;
  standardklyscha_nn_1_N = mkN "standardklyscha" ;
  stapelvara_nn_1_N = mkN "stapelvara" ;
  starkvara_nn_1_N = mkN "starkvara" ;
  startbana_nn_1_N = mkN "startbana" ;
  startfaalla_nn_1_1_N = mkN "startfålla" ;
  startstraecka_nn_1_1_N = mkN "startsträcka" ;
  statsfru_nn_1_N = mkN "statsfru" ;
  statskassa_nn_1_N = mkN "statskassa" ;
  statskvinna_nn_1_N = mkN "statskvinna" ;
  statsnytta_nn_1_N = mkN "statsnytta" ;
  status_nn_1_N = mkN "status" ;
  stavkyrka_nn_1_N = mkN "stavkyrka" ;
  stavlampa_nn_1_N = mkN "stavlampa" ;
  stearin_nn_1_N = mkN "stearin" ;
  stearinsyra_nn_1_N = mkN "stearinsyra" ;
  steglitsa_nn_1_N = mkN "steglitsa" ;
  stekpanna_nn_1_N = mkN "stekpanna" ;
  stekyta_nn_1_N = mkN "stekyta" ;
  stenbotten_nn_1_N = mkN "stenbotten" ;
  stenbraecka_nn_1_1_N = mkN "stenbräcka" ;
  stendammlunga_nn_1_N = mkN "stendammlunga" ;
  stenflisa_nn_1_N = mkN "stenflisa" ;
  stenkaka_nn_1_N = mkN "stenkaka" ;
  stenkista_nn_1_N = mkN "stenkista" ;
  stenkolstjaera_nn_1_1_N = mkN "stenkolstjära" ;
  stenlunga_nn_1_N = mkN "stenlunga" ;
  stenplatta_nn_1_N = mkN "stenplatta" ;
  stenskvaetta_nn_1_1_N = mkN "stenskvätta" ;
  stensoeta_nn_1_1_N = mkN "stensöta" ;
  stentavla_nn_1_N = mkN "stentavla" ;
  stentorsstaemma_nn_1_1_N = mkN "stentorsstämma" ;
  stentrappa_nn_1_N = mkN "stentrappa" ;
  stenyxa_nn_1_N = mkN "stenyxa" ;
  stenaalder_nn_1_1_N = mkN "stenålder" ;
  stenaaldershjaerna_nn_1_1_N = mkN "stenåldershjärna" ;
  stenaaldersyxa_nn_1_1_N = mkN "stenåldersyxa" ;
  stereo_nn_1_N = mkN "stereo" "stereon" "stereor" "stereorna" ;
  stia_nn_1_N = mkN "stia" ;
  sticka_nn_1_N = mkN "sticka" ;
  stiftsfroeken_nn_1_1_N = mkN "stiftsfröken" ;
  stilblomma_nn_1_N = mkN "stilblomma" ;
  stinta_nn_1_N = mkN "stinta" ;
  stjaerna_nn_1_1_N = mkN "stjärna" ;
  stjaernblomma_nn_1_1_N = mkN "stjärnblomma" ;
  stjaernhimmel_nn_1_1_N = mkN "stjärnhimmel" ;
  stjaernkarta_nn_1_1_N = mkN "stjärnkarta" ;
  stjaertfena_nn_1_1_N = mkN "stjärtfena" ;
  stjaertgympa_nn_1_1_N = mkN "stjärtgympa" ;
  stoa_nn_1_N = mkN "stoa" ;
  stockholmska_nn_1_N = mkN "stockholmska" ;
  stockholmska_nn_2_N = mkN "stockholmska" ;
  stofthydda_nn_1_N = mkN "stofthydda" ;
  stoftsloeja_nn_1_1_N = mkN "stoftslöja" ;
  stola_nn_1_N = mkN "stola" ;
  stolla_nn_1_N = mkN "stolla" ;
  stolsdyna_nn_1_N = mkN "stolsdyna" ;
  stopplykta_nn_1_N = mkN "stopplykta" ;
  storbedragerska_nn_1_N = mkN "storbedragerska" ;
  stordia_nn_1_N = mkN "stordia" ;
  storhjaerna_nn_1_1_N = mkN "storhjärna" ;
  storkova_nn_1_N = mkN "storkova" ;
  stormlykta_nn_1_N = mkN "stormlykta" ;
  stormstyrka_nn_1_N = mkN "stormstyrka" ;
  stormsvala_nn_1_N = mkN "stormsvala" ;
  storskotsskena_nn_1_N = mkN "storskotsskena" ;
  storstjaerna_nn_1_1_N = mkN "storstjärna" ;
  storstuga_nn_1_N = mkN "storstuga" ;
  stortavla_nn_1_N = mkN "stortavla" ;
  stortroeja_nn_1_1_N = mkN "stortröja" ;
  straffskala_nn_1_N = mkN "straffskala" ;
  strandskata_nn_1_N = mkN "strandskata" ;
  strandsnaecka_nn_1_1_N = mkN "strandsnäcka" ;
  strega_nn_1_N = mkN "strega" ;
  stridsfraaga_nn_1_1_N = mkN "stridsfråga" ;
  stridsklubba_nn_1_N = mkN "stridsklubba" ;
  stridsvana_nn_1_N = mkN "stridsvana" ;
  stridsyxa_nn_1_N = mkN "stridsyxa" ;
  striga_nn_1_N = mkN "striga" ;
  strimla_nn_1_N = mkN "strimla" ;
  strimma_nn_1_N = mkN "strimma" ;
  stripa_nn_1_N = mkN "stripa" ;
  strippa_nn_1_N = mkN "strippa" ;
  struma_nn_1_N = mkN "struma" ;
  strumpa_nn_1_N = mkN "strumpa" ;
  strumpbyxa_nn_1_N = mkN "strumpbyxa" ;
  strumpebandsorden_nn_1_N = mkN "strumpebandsorden" ;
  strumpsticka_nn_1_N = mkN "strumpsticka" ;
  struntsumma_nn_1_N = mkN "struntsumma" ;
  struva_nn_1_N = mkN "struva" ;
  strykbraeda_nn_1_1_N = mkN "strykbräda" ;
  strykerska_nn_1_N = mkN "strykerska" ;
  strykkappa_nn_1_N = mkN "strykkappa" ;
  stryknin_nn_1_N = mkN "stryknin" ;
  stryksticka_nn_1_N = mkN "stryksticka" ;
  straecka_nn_1_1_N = mkN "sträcka" ;
  straeva_nn_1_1_N = mkN "sträva" ;
  straalblomma_nn_1_1_N = mkN "strålblomma" ;
  straalningsera_nn_1_1_N = mkN "strålningsera" ;
  straalputa_nn_1_1_N = mkN "strålputa" ;
  straalskada_nn_1_1_N = mkN "strålskada" ;
  straamatta_nn_1_1_N = mkN "stråmatta" ;
  straaroeta_nn_1_1_N = mkN "stråröta" ;
  stroemfaara_nn_1_1_N = mkN "strömfåra" ;
  stroemkaella_nn_1_1_N = mkN "strömkälla" ;
  stroemmingsflundra_nn_1_1_N = mkN "strömmingsflundra" ;
  stroemstyrka_nn_1_1_N = mkN "strömstyrka" ;
  stroemvaerme_nn_1_1_N = mkN "strömvärme" ;
  stroessel_nn_1_1_N = mkN "strössel" ;
  studentmoessa_nn_1_1_N = mkN "studentmössa" ;
  studieovana_nn_1_N = mkN "studieovana" ;
  studieresa_nn_1_N = mkN "studieresa" ;
  studsmatta_nn_1_N = mkN "studsmatta" ;
  stuga_nn_1_N = mkN "stuga" ;
  stulta_nn_1_N = mkN "stulta" ;
  stumpa_nn_1_N = mkN "stumpa" ;
  stupa_nn_1_N = mkN "stupa" ;
  stupa_nn_2_N = mkN "stupa" ;
  stupraenna_nn_1_1_N = mkN "stupränna" ;
  stybb_nn_1_N = mkN "stybb" ;
  stylta_nn_1_N = mkN "stylta" ;
  styrka_nn_1_N = mkN "styrka" ;
  styrlina_nn_1_N = mkN "styrlina" ;
  styrsel_nn_1_N = mkN "styrsel" ;
  styvmamma_nn_1_N = mkN "styvmamma" ;
  styvpappa_nn_1_N = mkN "styvpappa" ;
  staederska_nn_1_1_N = mkN "städerska" ;
  staedfru_nn_1_1_N = mkN "städfru" ;
  staedgumma_nn_1_1_N = mkN "städgumma" ;
  staemma_nn_1_1_N = mkN "stämma" ;
  staempel_nn_2_1_N = mkN "stämpel" ;
  staempeldyna_nn_1_1_N = mkN "stämpeldyna" ;
  staempelklocka_nn_1_1_N = mkN "stämpelklocka" ;
  staetta_nn_1_1_N = mkN "stätta" ;
  staeva_nn_1_1_N = mkN "stäva" ;
  staafela_nn_1_1_N = mkN "ståfela" ;
  staalpenna_nn_1_1_N = mkN "stålpenna" ;
  staalpipa_nn_1_1_N = mkN "stålpipa" ;
  staalrundkula_nn_1_1_N = mkN "stålrundkula" ;
  staalskena_nn_1_1_N = mkN "stålskena" ;
  staangpiska_nn_1_1_N = mkN "stångpiska" ;
  staanka_nn_1_1_N = mkN "stånka" ;
  stoedgala_nn_1_1_N = mkN "stödgala" ;
  stoeldliga_nn_1_1_N = mkN "stöldliga" ;
  stoerboena_nn_1_1_N = mkN "störböna" ;
  stoetsida_nn_1_1_N = mkN "stötsida" ;
  stoetta_nn_1_1_N = mkN "stötta" ;
  subba_nn_1_N = mkN "subba" ;
  sublimat_nn_1_N = mkN "sublimat" ;
  suckat_nn_1_N = mkN "suckat" ;
  sudanesiska_nn_1_N = mkN "sudanesiska" ;
  sugga_nn_1_N = mkN "sugga" ;
  sula_nn_1_N = mkN "sula" ;
  sulfa_nn_1_N = mkN "sulfa" ;
  sulfatmassa_nn_1_N = mkN "sulfatmassa" ;
  summa_nn_1_N = mkN "summa" ;
  sumo_nn_1_N = mkN "sumo" ;
  sumphoena_nn_1_1_N = mkN "sumphöna" ;
  superdiva_nn_1_N = mkN "superdiva" ;
  superhopslinga_nn_1_N = mkN "superhopslinga" ;
  supernova_nn_1_N = mkN "supernova" ;
  superstjaerna_nn_1_1_N = mkN "superstjärna" ;
  supervaetska_nn_1_1_N = mkN "supervätska" ;
  sura_nn_1_N = mkN "sura" ;
  surfbraeda_nn_1_1_N = mkN "surfbräda" ;
  surfingbraeda_nn_1_1_N = mkN "surfingbräda" ;
  surfplatta_nn_1_N = mkN "surfplatta" ;
  surinamesiska_nn_1_N = mkN "surinamesiska" ;
  surpuppa_nn_1_N = mkN "surpuppa" ;
  surrogatmamma_nn_1_N = mkN "surrogatmamma" ;
  svacka_nn_1_N = mkN "svacka" ;
  svada_nn_1_N = mkN "svada" ;
  svagdricka_nn_1_N = mkN "svagdricka" ;
  svala_nn_1_N = mkN "svala" ;
  svalka_nn_1_N = mkN "svalka" ;
  svanskota_nn_1_N = mkN "svanskota" ;
  svanoedla_nn_1_1_N = mkN "svanödla" ;
  svarthaetta_nn_1_1_N = mkN "svarthätta" ;
  svartmyra_nn_1_N = mkN "svartmyra" ;
  svartskjorta_nn_1_N = mkN "svartskjorta" ;
  svartsnaeppa_nn_1_1_N = mkN "svartsnäppa" ;
  svartsoppa_nn_1_N = mkN "svartsoppa" ;
  svastika_nn_1_N = mkN "svastika" ;
  svavelblomma_nn_1_N = mkN "svavelblomma" ;
  svavelsticka_nn_1_N = mkN "svavelsticka" ;
  svavelsyra_nn_1_N = mkN "svavelsyra" ;
  svecia_nn_1_N = mkN "svecia" ;
  sveda_nn_1_N = mkN "sveda" ;
  svedja_nn_1_N = mkN "svedja" ;
  svengelska_nn_1_N = mkN "svengelska" ;
  svensexa_nn_1_N = mkN "svensexa" ;
  svenska_nn_1_N = mkN "svenska" ;
  svenska_nn_2_N = mkN "svenska" ;
  svenskmannaanda_nn_1_N = mkN "svenskmannaanda" ;
  svetsloppa_nn_1_N = mkN "svetsloppa" ;
  svettpaerla_nn_1_1_N = mkN "svettpärla" ;
  svicka_nn_1_N = mkN "svicka" ;
  svindel_nn_1_N = mkN "svindel" ;
  svindlerihaerva_nn_1_1_N = mkN "svindlerihärva" ;
  svingel_nn_1_N = mkN "svingel" ;
  svininfluensa_nn_1_N = mkN "svininfluensa" ;
  svinmaalla_nn_1_1_N = mkN "svinmålla" ;
  svinotta_nn_1_N = mkN "svinotta" ;
  svinskoetsel_nn_1_1_N = mkN "svinskötsel" ;
  svaegerska_nn_1_1_N = mkN "svägerska" ;
  svaengbro_nn_1_1_N = mkN "svängbro" ;
  svaerdsklinga_nn_1_1_N = mkN "svärdsklinga" ;
  svaerdslilja_nn_1_1_N = mkN "svärdslilja" ;
  svaerta_nn_1_1_N = mkN "svärta" ;
  swastika_nn_1_N = mkN "swastika" ;
  swazilaendska_nn_1_1_N = mkN "swaziländska" ;
  sydafrikanska_nn_1_N = mkN "sydafrikanska" ;
  sydkoreanska_nn_1_N = mkN "sydkoreanska" ;
  sydsida_nn_1_N = mkN "sydsida" ;
  syjunta_nn_1_N = mkN "syjunta" ;
  sylta_nn_1_N = mkN "sylta" ;
  syltgurka_nn_1_N = mkN "syltgurka" ;
  syltkaka_nn_1_N = mkN "syltkaka" ;
  symaskinsolja_nn_1_N = mkN "symaskinsolja" ;
  synagoga_nn_1_N = mkN "synagoga" ;
  synfoermaaga_nn_1_1_N = mkN "synförmåga" ;
  synvilla_nn_1_N = mkN "synvilla" ;
  syra_nn_1_N = mkN "syra" ;
  syreupptagningsfoermaaga_nn_1_1_N = mkN "syreupptagningsförmåga" ;
  syriska_nn_1_N = mkN "syriska" ;
  syriska_nn_2_N = mkN "syriska" ;
  syrra_nn_1_N = mkN "syrra" ;
  syrsa_nn_1_N = mkN "syrsa" ;
  syskonskara_nn_1_N = mkN "syskonskara" ;
  syssla_nn_1_N = mkN "syssla" ;
  syssla_nn_2_N = mkN "syssla" ;
  systemkamera_nn_1_N = mkN "systemkamera" ;
  saeckkaerra_nn_1_1_N = mkN "säckkärra" ;
  saeckpipa_nn_1_1_N = mkN "säckpipa" ;
  saed_nn_1_1_N = mkN "säd" ;
  saedesblaasa_nn_1_1_N = mkN "sädesblåsa" ;
  saedeskaerna_nn_1_1_N = mkN "sädeskärna" ;
  saedesvaetska_nn_1_1_N = mkN "sädesvätska" ;
  saedesaerla_nn_1_1_N = mkN "sädesärla" ;
  saekerhetskedja_nn_1_1_N = mkN "säkerhetskedja" ;
  saekerhetslampa_nn_1_1_N = mkN "säkerhetslampa" ;
  saekerhetslina_nn_1_1_N = mkN "säkerhetslina" ;
  saekerhetsmassa_nn_1_1_N = mkN "säkerhetsmassa" ;
  saekerhetstaendsticka_nn_1_1_N = mkN "säkerhetständsticka" ;
  saellskapsmaenniska_nn_1_1_N = mkN "sällskapsmänniska" ;
  saellskapsresa_nn_1_1_N = mkN "sällskapsresa" ;
  saelta_nn_1_1_N = mkN "sälta" ;
  saemja_nn_1_1_N = mkN "sämja" ;
  saenghimmel_nn_1_1_N = mkN "sänghimmel" ;
  saenglampa_nn_1_1_N = mkN "sänglampa" ;
  saenka_nn_1_1_N = mkN "sänka" ;
  saerfraaga_nn_1_1_N = mkN "särfråga" ;
  saerpraegel_nn_1_1_N = mkN "särprägel" ;
  saerskola_nn_1_1_N = mkN "särskola" ;
  saesongsinfluensa_nn_1_1_N = mkN "säsongsinfluensa" ;
  saa_nn_1_1_N = mkN "så" ;
  saagkedja_nn_1_1_N = mkN "sågkedja" ;
  saagklinga_nn_1_1_N = mkN "sågklinga" ;
  saangerska_nn_1_1_N = mkN "sångerska" ;
  saanggudinna_nn_1_1_N = mkN "sånggudinna" ;
  saanglaerka_nn_1_1_N = mkN "sånglärka" ;
  saapa_nn_1_1_N = mkN "såpa" ;
  saapbubbla_nn_1_1_N = mkN "såpbubbla" ;
  saapopera_nn_1_1_N = mkN "såpopera" ;
  saarskada_nn_1_1_N = mkN "sårskada" ;
  saarskorpa_nn_1_1_N = mkN "sårskorpa" ;
  saaskanna_nn_1_1_N = mkN "såskanna" ;
  soeder_nn_1_1_N = mkN "söder" ;
  soedermanlaendska_nn_1_1_N = mkN "södermanländska" ;
  soedermanlaendska_nn_2_1_N = mkN "södermanländska" ;
  soedersida_nn_1_1_N = mkN "södersida" ;
  soelja_nn_1_1_N = mkN "sölja" ;
  soemmerska_nn_1_1_N = mkN "sömmerska" ;
  soemntuta_nn_1_1_N = mkN "sömntuta" ;
  soendagsbilaga_nn_1_1_N = mkN "söndagsbilaga" ;
  soendagspappa_nn_1_1_N = mkN "söndagspappa" ;
  soendagsskola_nn_1_1_N = mkN "söndagsskola" ;
  soendagsskolefroeken_nn_1_1_N = mkN "söndagsskolefröken" ;
  soerja_nn_1_1_N = mkN "sörja" ;
  soermlaendska_nn_1_1_N = mkN "sörmländska" ;
  soermlaendska_nn_2_1_N = mkN "sörmländska" ;
  soerpa_nn_1_1_N = mkN "sörpa" ;
  soetma_nn_1_1_N = mkN "sötma" ;
  soetvattensnaecka_nn_1_1_N = mkN "sötvattensnäcka" ;
  t_troeja_nn_1_1_N = mkN "t-tröja" ;
  tabasco_nn_1_N = mkN "tabasco" ;
  tacka_nn_1_N = mkN "tacka" ;
  tadzjikiska_nn_1_N = mkN "tadzjikiska" ;
  tadzjikiska_nn_2_N = mkN "tadzjikiska" ;
  taft_nn_1_N = mkN "taft" ;
  tagelskjorta_nn_1_N = mkN "tagelskjorta" ;
  taggbraeken_nn_1_1_N = mkN "taggbräken" ;
  taiga_nn_1_N = mkN "taiga" ;
  taiwanesiska_nn_1_N = mkN "taiwanesiska" ;
  taiwanesiska_nn_2_N = mkN "taiwanesiska" ;
  tajga_nn_1_N = mkN "tajga" ;
  takhimmel_nn_1_N = mkN "takhimmel" ;
  takkrona_nn_1_N = mkN "takkrona" ;
  taklampa_nn_1_N = mkN "taklampa" ;
  takpanna_nn_1_N = mkN "takpanna" ;
  takpapp_nn_1_N = mkN "takpapp" ;
  takplatta_nn_1_N = mkN "takplatta" ;
  takraenna_nn_1_1_N = mkN "takränna" ;
  talarlista_nn_1_N = mkN "talarlista" ;
  talegaava_nn_1_1_N = mkN "talegåva" ;
  taleskvinna_nn_1_N = mkN "taleskvinna" ;
  talfoermaaga_nn_1_1_N = mkN "talförmåga" ;
  talja_nn_1_N = mkN "talja" ;
  talkskiffer_nn_1_N = mkN "talkskiffer" ;
  tallbarrsolja_nn_1_N = mkN "tallbarrsolja" ;
  tallolja_nn_1_N = mkN "tallolja" ;
  tallplanta_nn_1_N = mkN "tallplanta" ;
  tallticka_nn_1_N = mkN "tallticka" ;
  talltita_nn_1_N = mkN "talltita" ;
  tamduva_nn_1_N = mkN "tamduva" ;
  tana_nn_1_N = mkN "tana" ;
  tandbrygga_nn_1_N = mkN "tandbrygga" ;
  tandhaala_nn_1_1_N = mkN "tandhåla" ;
  tandkrona_nn_1_N = mkN "tandkrona" ;
  tandpasta_nn_1_N = mkN "tandpasta" ;
  tandpulpa_nn_1_N = mkN "tandpulpa" ;
  tandroeta_nn_1_1_N = mkN "tandröta" ;
  tandskoeterska_nn_1_1_N = mkN "tandsköterska" ;
  tandsticka_nn_1_N = mkN "tandsticka" ;
  tandyta_nn_1_N = mkN "tandyta" ;
  tankebana_nn_1_N = mkN "tankebana" ;
  tankekedja_nn_1_N = mkN "tankekedja" ;
  tankemoeda_nn_1_1_N = mkN "tankemöda" ;
  tankereda_nn_1_N = mkN "tankereda" ;
  tankeskaerpa_nn_1_1_N = mkN "tankeskärpa" ;
  tankesmedja_nn_1_N = mkN "tankesmedja" ;
  tankevilla_nn_1_N = mkN "tankevilla" ;
  tankevurpa_nn_1_N = mkN "tankevurpa" ;
  tanks_nn_1_N = mkN "tanks" ;
  tannin_nn_1_N = mkN "tannin" ;
  tantal_nn_1_N = mkN "tantal" ;
  tanzaniska_nn_1_N = mkN "tanzaniska" ;
  tapioka_nn_1_N = mkN "tapioka" ;
  tara_nn_1_N = mkN "tara" ;
  tarantella_nn_1_N = mkN "tarantella" ;
  tarlatan_nn_1_N = mkN "tarlatan" ;
  tarmludd_nn_1_N = mkN "tarmludd" ;
  taro_nn_1_N = mkN "taro" ;
  tartan_nn_1_N = mkN "tartan" ;
  taska_nn_1_N = mkN "taska" ;
  taverna_nn_1_N = mkN "taverna" ;
  tavla_nn_1_N = mkN "tavla" ;
  taxa_nn_1_N = mkN "taxa" ;
  taxiresa_nn_1_N = mkN "taxiresa" ;
  tchadiska_nn_1_N = mkN "tchadiska" ;
  teaterapa_nn_1_N = mkN "teaterapa" ;
  teatervana_nn_1_N = mkN "teatervana" ;
  techno_nn_1_N = mkN "techno" ;
  teckenruta_nn_1_N = mkN "teckenruta" ;
  teckningslista_nn_1_N = mkN "teckningslista" ;
  teflonhjaerna_nn_1_1_N = mkN "teflonhjärna" ;
  tefra_nn_1_N = mkN "tefra" ;
  tegellera_nn_1_N = mkN "tegellera" ;
  tegelpanna_nn_1_N = mkN "tegelpanna" ;
  tegelplatta_nn_1_N = mkN "tegelplatta" ;
  tegfaara_nn_1_1_N = mkN "tegfåra" ;
  tehuva_nn_1_N = mkN "tehuva" ;
  tekaka_nn_1_N = mkN "tekaka" ;
  tekanna_nn_1_N = mkN "tekanna" ;
  telefonfroeken_nn_1_1_N = mkN "telefonfröken" ;
  telegrafremsa_nn_1_N = mkN "telegrafremsa" ;
  televisionskamera_nn_1_N = mkN "televisionskamera" ;
  tellur_nn_1_N = mkN "tellur" ;
  tempelherreorden_nn_1_N = mkN "tempelherreorden" ;
  tempera_nn_1_N = mkN "tempera" ;
  temperamentsmaenniska_nn_1_1_N = mkN "temperamentsmänniska" ;
  temperaturskala_nn_1_N = mkN "temperaturskala" ;
  tennbricka_nn_1_N = mkN "tennbricka" ;
  tennisbana_nn_1_N = mkN "tennisbana" ;
  tenorstaemma_nn_1_1_N = mkN "tenorstämma" ;
  tenta_nn_1_N = mkN "tenta" ;
  tequila_nn_1_N = mkN "tequila" ;
  terapisoffa_nn_1_N = mkN "terapisoffa" ;
  terminologifraaga_nn_1_1_N = mkN "terminologifråga" ;
  termobyxa_nn_1_N = mkN "termobyxa" ;
  termokappa_nn_1_N = mkN "termokappa" ;
  terpentin_nn_1_N = mkN "terpentin" ;
  terrakotta_nn_1_N = mkN "terrakotta" ;
  terraengbana_nn_1_1_N = mkN "terrängbana" ;
  tespiskaerra_nn_1_1_N = mkN "tespiskärra" ;
  testikelcancer_nn_1_N = mkN "testikelcancer" ;
  tetra_nn_1_N = mkN "tetra" ;
  tevekamera_nn_1_N = mkN "tevekamera" ;
  teveronika_nn_1_N = mkN "teveronika" ;
  teveruta_nn_1_N = mkN "teveruta" ;
  tevesoffa_nn_1_N = mkN "tevesoffa" ;
  tevesaapa_nn_1_1_N = mkN "tevesåpa" ;
  textyta_nn_1_N = mkN "textyta" ;
  thailaendska_nn_1_1_N = mkN "thailändska" ;
  thinner_nn_1_N = mkN "thinner" ;
  tia_nn_1_N = mkN "tia" ;
  tiara_nn_1_N = mkN "tiara" ;
  tibetanska_nn_1_N = mkN "tibetanska" ;
  tibetanska_nn_2_N = mkN "tibetanska" ;
  ticka_nn_1_N = mkN "ticka" ;
  tidloesa_nn_1_1_N = mkN "tidlösa" ;
  tidningsanka_nn_1_N = mkN "tidningsanka" ;
  tidningsbilaga_nn_1_N = mkN "tidningsbilaga" ;
  tidningssida_nn_1_N = mkN "tidningssida" ;
  tidningsupplaga_nn_1_N = mkN "tidningsupplaga" ;
  tidsanda_nn_1_N = mkN "tidsanda" ;
  tidsaxel_nn_1_N = mkN "tidsaxel" ;
  tidsfraaga_nn_1_1_N = mkN "tidsfråga" ;
  tidsskala_nn_1_N = mkN "tidsskala" ;
  tigerkaka_nn_1_N = mkN "tigerkaka" ;
  tigerlilja_nn_1_N = mkN "tigerlilja" ;
  tiggarliga_nn_1_N = mkN "tiggarliga" ;
  tiggarorden_nn_1_N = mkN "tiggarorden" ;
  tilja_nn_1_N = mkN "tilja" ;
  tillfoersel_nn_1_1_N = mkN "tillförsel" ;
  tilltro_nn_1_N = mkN "tilltro" ;
  tillvaro_nn_1_N = mkN "tillvaro" ;
  tillvaextfraaga_nn_1_1_N = mkN "tillväxtfråga" ;
  tillvaextfoermaaga_nn_1_1_N = mkN "tillväxtförmåga" ;
  tillvaextkurva_nn_1_1_N = mkN "tillväxtkurva" ;
  tillvaextstyrka_nn_1_1_N = mkN "tillväxtstyrka" ;
  tilt_nn_1_N = mkN "tilt" ;
  tilta_nn_1_N = mkN "tilta" ;
  timaxel_nn_1_N = mkN "timaxel" ;
  timer_nn_1_N = mkN "timer" ;
  timma_nn_1_N = mkN "timma" ;
  timmerkoja_nn_1_N = mkN "timmerkoja" ;
  timmerlaensa_nn_1_1_N = mkN "timmerlänsa" ;
  tina_nn_1_N = mkN "tina" ;
  tinner_nn_1_N = mkN "tinner" ;
  tiokrona_nn_1_N = mkN "tiokrona" ;
  tiosyra_nn_1_N = mkN "tiosyra" ;
  tipsrunda_nn_1_N = mkN "tipsrunda" ;
  tischa_nn_1_N = mkN "tischa" ;
  tisdagssoppa_nn_1_N = mkN "tisdagssoppa" ;
  tisha_nn_1_N = mkN "tisha" ;
  tita_nn_1_N = mkN "tita" ;
  titan_nn_2_N = mkN "titan" ;
  titelsida_nn_1_N = mkN "titelsida" ;
  tjeckiska_nn_1_N = mkN "tjeckiska" ;
  tjeckiska_nn_2_N = mkN "tjeckiska" ;
  tjeckoslovakiska_nn_1_N = mkN "tjeckoslovakiska" ;
  tjeka_nn_1_N = mkN "tjeka" ;
  tjetjenska_nn_1_N = mkN "tjetjenska" ;
  tjetjenska_nn_2_N = mkN "tjetjenska" ;
  tjocka_nn_1_N = mkN "tjocka" ;
  tjockolja_nn_1_N = mkN "tjockolja" ;
  tjocktroeja_nn_1_1_N = mkN "tjocktröja" ;
  tjuga_nn_1_N = mkN "tjuga" ;
  tjugoaattaaarsaalder_nn_1_1_N = mkN "tjugoåttaårsålder" ;
  tjuvgoemma_nn_1_1_N = mkN "tjuvgömma" ;
  tjuvsena_nn_1_N = mkN "tjuvsena" ;
  tjaenarinna_nn_1_1_N = mkN "tjänarinna" ;
  tjaensteflicka_nn_1_1_N = mkN "tjänsteflicka" ;
  tjaenstekvinna_nn_1_1_N = mkN "tjänstekvinna" ;
  tjaenstepiga_nn_1_1_N = mkN "tjänstepiga" ;
  tjaensteresa_nn_1_1_N = mkN "tjänsteresa" ;
  tjaera_nn_1_1_N = mkN "tjära" ;
  toa_nn_1_N = mkN "toa" ;
  tobakspipa_nn_1_N = mkN "tobakspipa" ;
  tobaksplanta_nn_1_N = mkN "tobaksplanta" ;
  tobaksstrimla_nn_1_N = mkN "tobaksstrimla" ;
  tobaksvara_nn_1_N = mkN "tobaksvara" ;
  tobisgrissla_nn_1_N = mkN "tobisgrissla" ;
  toccata_nn_1_N = mkN "toccata" ;
  toffelblomma_nn_1_N = mkN "toffelblomma" ;
  tofslaerka_nn_1_1_N = mkN "tofslärka" ;
  tofsvipa_nn_1_N = mkN "tofsvipa" ;
  tofu_nn_1_N = mkN "tofu" ;
  toga_nn_1_N = mkN "toga" ;
  togolesiska_nn_1_N = mkN "togolesiska" ;
  toka_nn_1_N = mkN "toka" ;
  tokajer_nn_1_N = mkN "tokajer" ;
  tokmorsa_nn_1_N = mkN "tokmorsa" ;
  tokvaenster_nn_1_1_N = mkN "tokvänster" ;
  tolklina_nn_1_N = mkN "tolklina" ;
  tolkningsfraaga_nn_1_1_N = mkN "tolkningsfråga" ;
  tolta_nn_1_N = mkN "tolta" ;
  tolva_nn_1_N = mkN "tolva" ;
  tolvkanthylsa_nn_1_N = mkN "tolvkanthylsa" ;
  tolvkantshylsa_nn_1_N = mkN "tolvkantshylsa" ;
  tolvaarsaalder_nn_1_1_N = mkN "tolvårsålder" ;
  tombola_nn_1_N = mkN "tombola" ;
  tomflaska_nn_1_N = mkN "tomflaska" ;
  tomlaada_nn_1_1_N = mkN "tomlåda" ;
  tomteluva_nn_1_N = mkN "tomteluva" ;
  tomtyta_nn_1_N = mkN "tomtyta" ;
  tonganska_nn_1_N = mkN "tonganska" ;
  tonganska_nn_2_N = mkN "tonganska" ;
  tonika_nn_1_N = mkN "tonika" ;
  tonskala_nn_1_N = mkN "tonskala" ;
  tonstyrka_nn_1_N = mkN "tonstyrka" ;
  tonaarsflicka_nn_1_1_N = mkN "tonårsflicka" ;
  topplanterna_nn_1_N = mkN "topplanterna" ;
  toppluva_nn_1_N = mkN "toppluva" ;
  topplaenta_nn_1_1_N = mkN "topplänta" ;
  topplaerka_nn_1_1_N = mkN "topplärka" ;
  topploesa_nn_1_1_N = mkN "topplösa" ;
  toppmurkla_nn_1_N = mkN "toppmurkla" ;
  topproeta_nn_1_1_N = mkN "toppröta" ;
  toppaenda_nn_1_1_N = mkN "toppända" ;
  tordoensstaemma_nn_1_1_N = mkN "tordönsstämma" ;
  torggumma_nn_1_N = mkN "torggumma" ;
  torghandel_nn_1_N = mkN "torghandel" ;
  torka_nn_1_N = mkN "torka" ;
  torklina_nn_1_N = mkN "torklina" ;
  torklaada_nn_1_1_N = mkN "torklåda" ;
  torktumlarludd_nn_1_N = mkN "torktumlarludd" ;
  tornsnaecka_nn_1_1_N = mkN "tornsnäcka" ;
  tornspira_nn_1_N = mkN "tornspira" ;
  tornsvala_nn_1_N = mkN "tornsvala" ;
  tornuggla_nn_1_N = mkN "tornuggla" ;
  torpedkula_nn_1_N = mkN "torpedkula" ;
  torpstuga_nn_1_N = mkN "torpstuga" ;
  torraka_nn_1_N = mkN "torraka" ;
  torrdocka_nn_1_N = mkN "torrdocka" ;
  torrfluga_nn_1_N = mkN "torrfluga" ;
  torrspricka_nn_1_N = mkN "torrspricka" ;
  torrvedssticka_nn_1_N = mkN "torrvedssticka" ;
  torroeta_nn_1_1_N = mkN "torröta" ;
  torskleverolja_nn_1_N = mkN "torskleverolja" ;
  torta_nn_1_N = mkN "torta" ;
  torva_nn_1_N = mkN "torva" ;
  tosa_nn_1_N = mkN "tosa" ;
  tossa_nn_1_N = mkN "tossa" ;
  totalskugga_nn_1_N = mkN "totalskugga" ;
  totalyta_nn_1_N = mkN "totalyta" ;
  totem_nn_1_N = mkN "totem" ;
  toto_nn_1_N = mkN "toto" ;
  tova_nn_1_N = mkN "tova" ;
  toxin_nn_1_N = mkN "toxin" ;
  trafikolycka_nn_1_N = mkN "trafikolycka" ;
  trafikpulsaader_nn_1_1_N = mkN "trafikpulsåder" ;
  traktorkaerra_nn_1_1_N = mkN "traktorkärra" ;
  traktoerpanna_nn_1_1_N = mkN "traktörpanna" ;
  tralla_nn_1_N = mkN "tralla" ;
  trampa_nn_1_N = mkN "trampa" ;
  trampdyna_nn_1_N = mkN "trampdyna" ;
  trampmina_nn_1_N = mkN "trampmina" ;
  trana_nn_1_N = mkN "trana" ;
  tranlampa_nn_1_N = mkN "tranlampa" ;
  transa_nn_1_N = mkN "transa" ;
  transfer_nn_1_N = mkN "transfer" ;
  transhora_nn_1_N = mkN "transhora" ;
  transistorradio_nn_1_N = mkN "transistorradio" ;
  transitresa_nn_1_N = mkN "transitresa" ;
  transportbana_nn_1_N = mkN "transportbana" ;
  transportkaerra_nn_1_1_N = mkN "transportkärra" ;
  transportstraecka_nn_1_1_N = mkN "transportsträcka" ;
  transsubstantiationslaera_nn_1_1_N = mkN "transsubstantiationslära" ;
  transubstantiationslaera_nn_1_1_N = mkN "transubstantiationslära" ;
  trappa_nn_1_N = mkN "trappa" ;
  trappkaerra_nn_1_1_N = mkN "trappkärra" ;
  trappskiva_nn_1_N = mkN "trappskiva" ;
  trasa_nn_1_N = mkN "trasa" ;
  trasdocka_nn_1_N = mkN "trasdocka" ;
  trasmaja_nn_1_N = mkN "trasmaja" ;
  trasmatta_nn_1_N = mkN "trasmatta" ;
  tratta_nn_1_N = mkN "tratta" ;
  trav_nn_1_N = mkN "trav" ;
  travbana_nn_1_N = mkN "travbana" ;
  trea_nn_1_N = mkN "trea" ;
  tredagarsfeber_nn_1_N = mkN "tredagarsfeber" ;
  tredjedagsfrossa_nn_1_N = mkN "tredjedagsfrossa" ;
  tredska_nn_1_N = mkN "tredska" ;
  trekarlspolska_nn_1_N = mkN "trekarlspolska" ;
  trekloever_nn_1_1_N = mkN "treklöver" ;
  trekvartsstrumpa_nn_1_N = mkN "trekvartsstrumpa" ;
  trettifemaarsaalder_nn_1_1_N = mkN "trettifemårsålder" ;
  trettiofemaarsaalder_nn_1_1_N = mkN "trettiofemårsålder" ;
  triangelsida_nn_1_N = mkN "triangelsida" ;
  trikaavara_nn_1_1_N = mkN "trikåvara" ;
  trilla_nn_1_N = mkN "trilla" ;
  trilska_nn_1_N = mkN "trilska" ;
  trindsnoe_nn_1_1_N = mkN "trindsnö" ;
  trindyxa_nn_1_N = mkN "trindyxa" ;
  trinidadiska_nn_1_N = mkN "trinidadiska" ;
  trippel_nn_1_N = mkN "trippel" ;
  trippelstjaerna_nn_1_1_N = mkN "trippelstjärna" ;
  trippelvaccin_nn_1_N = mkN "trippelvaccin" ;
  trissa_nn_1_N = mkN "trissa" ;
  trivialskola_nn_1_N = mkN "trivialskola" ;
  trivsel_nn_1_N = mkN "trivsel" ;
  tro_nn_1_N = mkN "tro" ;
  trojka_nn_1_N = mkN "trojka" ;
  trollcirkel_nn_1_N = mkN "trollcirkel" ;
  trollhoppa_nn_1_N = mkN "trollhoppa" ;
  trollkvinna_nn_1_N = mkN "trollkvinna" ;
  trollpacka_nn_1_N = mkN "trollpacka" ;
  trollruna_nn_1_N = mkN "trollruna" ;
  trollslaenda_nn_1_1_N = mkN "trollslända" ;
  trolltrumma_nn_1_N = mkN "trolltrumma" ;
  tromla_nn_1_N = mkN "tromla" ;
  tronfoeljerska_nn_1_1_N = mkN "tronföljerska" ;
  tronhimmel_nn_1_N = mkN "tronhimmel" ;
  trosa_nn_1_N = mkN "trosa" ;
  troslaera_nn_1_1_N = mkN "troslära" ;
  trossbotten_nn_1_N = mkN "trossbotten" ;
  trosskvinna_nn_1_N = mkN "trosskvinna" ;
  trubbnaesa_nn_1_1_N = mkN "trubbnäsa" ;
  truga_nn_1_N = mkN "truga" ;
  trumhinna_nn_1_N = mkN "trumhinna" ;
  trumhaala_nn_1_1_N = mkN "trumhåla" ;
  trumma_nn_1_N = mkN "trumma" ;
  trumpetblomma_nn_1_N = mkN "trumpetblomma" ;
  truppnaervaro_nn_1_1_N = mkN "truppnärvaro" ;
  truppstyrka_nn_1_N = mkN "truppstyrka" ;
  tryckspruta_nn_1_N = mkN "tryckspruta" ;
  tryckstyrka_nn_1_N = mkN "tryckstyrka" ;
  tryckyta_nn_1_N = mkN "tryckyta" ;
  tryffel_nn_1_N = mkN "tryffel" ;
  tryga_nn_1_N = mkN "tryga" ;
  trygghetskaensla_nn_1_1_N = mkN "trygghetskänsla" ;
  traecellulosa_nn_1_1_N = mkN "träcellulosa" ;
  traeda_nn_1_1_N = mkN "träda" ;
  traedflora_nn_1_1_N = mkN "trädflora" ;
  traedgaardsblomma_nn_1_1_N = mkN "trädgårdsblomma" ;
  traedgaardsboena_nn_1_1_N = mkN "trädgårdsböna" ;
  traedgaardskratta_nn_1_1_N = mkN "trädgårdskratta" ;
  traedgaardsmaestarfru_nn_1_1_N = mkN "trädgårdsmästarfru" ;
  traedgaardsnejlika_nn_1_1_N = mkN "trädgårdsnejlika" ;
  traedgaardspiga_nn_1_1_N = mkN "trädgårdspiga" ;
  traedgaardsskoetsel_nn_1_1_N = mkN "trädgårdsskötsel" ;
  traedgaardssnaecka_nn_1_1_N = mkN "trädgårdssnäcka" ;
  traedgaardstaeppa_nn_1_1_N = mkN "trädgårdstäppa" ;
  traedkoja_nn_1_1_N = mkN "trädkoja" ;
  traedkrona_nn_1_1_N = mkN "trädkrona" ;
  traedlaerka_nn_1_1_N = mkN "trädlärka" ;
  traedocka_nn_1_1_N = mkN "trädocka" ;
  traedpiplaerka_nn_1_1_N = mkN "trädpiplärka" ;
  traefibermassa_nn_1_1_N = mkN "träfibermassa" ;
  traefiberplatta_nn_1_1_N = mkN "träfiberplatta" ;
  traefiberskiva_nn_1_1_N = mkN "träfiberskiva" ;
  traeflisa_nn_1_1_N = mkN "träflisa" ;
  traemassa_nn_1_1_N = mkN "trämassa" ;
  traengsel_nn_1_1_N = mkN "trängsel" ;
  traeningsskola_nn_1_1_N = mkN "träningsskola" ;
  traeplanka_nn_1_1_N = mkN "träplanka" ;
  traeplatta_nn_1_1_N = mkN "träplatta" ;
  traeribba_nn_1_1_N = mkN "träribba" ;
  traeskfeber_nn_1_1_N = mkN "träskfeber" ;
  traeskiva_nn_1_1_N = mkN "träskiva" ;
  traeskrinda_nn_1_1_N = mkN "träskrinda" ;
  traesnipa_nn_1_1_N = mkN "träsnipa" ;
  traespillra_nn_1_1_N = mkN "träspillra" ;
  traeta_nn_1_1_N = mkN "träta" ;
  traetjaera_nn_1_1_N = mkN "trätjära" ;
  traevara_nn_1_1_N = mkN "trävara" ;
  traeyta_nn_1_1_N = mkN "träyta" ;
  traadmina_nn_1_1_N = mkN "trådmina" ;
  traadradio_nn_1_1_N = mkN "trådradio" ;
  troeja_nn_1_1_N = mkN "tröja" ;
  troejficka_nn_1_1_N = mkN "tröjficka" ;
  troeska_nn_1_1_N = mkN "tröska" ;
  troeskellaada_nn_1_1_N = mkN "tröskellåda" ;
  troesklada_nn_1_1_N = mkN "trösklada" ;
  troetthetskaensla_nn_1_1_N = mkN "trötthetskänsla" ;
  tsetsefluga_nn_1_N = mkN "tsetsefluga" ;
  tuba_nn_1_N = mkN "tuba" ;
  tuftmatta_nn_1_N = mkN "tuftmatta" ;
  tugga_nn_1_N = mkN "tugga" ;
  tuggyta_nn_1_N = mkN "tuggyta" ;
  tuja_nn_1_N = mkN "tuja" ;
  tullstadga_nn_1_N = mkN "tullstadga" ;
  tulta_nn_1_N = mkN "tulta" ;
  tumskala_nn_1_N = mkN "tumskala" ;
  tundra_nn_1_N = mkN "tundra" ;
  tunga_nn_1_N = mkN "tunga" ;
  tunghaefta_nn_1_1_N = mkN "tunghäfta" ;
  tungsida_nn_1_N = mkN "tungsida" ;
  tunika_nn_1_N = mkN "tunika" ;
  tunisiska_nn_1_N = mkN "tunisiska" ;
  tunna_nn_1_N = mkN "tunna" ;
  tunnelbana_nn_1_N = mkN "tunnelbana" ;
  tunnpannkaka_nn_1_N = mkN "tunnpannkaka" ;
  turiststuga_nn_1_N = mkN "turiststuga" ;
  turistvaluta_nn_1_N = mkN "turistvaluta" ;
  turistoe_nn_1_1_N = mkN "turistö" ;
  turkiska_nn_1_N = mkN "turkiska" ;
  turkiska_nn_2_N = mkN "turkiska" ;
  turkmenska_nn_1_N = mkN "turkmenska" ;
  turkmenska_nn_2_N = mkN "turkmenska" ;
  turksadel_nn_1_N = mkN "turksadel" ;
  turlista_nn_1_N = mkN "turlista" ;
  turturduva_nn_1_N = mkN "turturduva" ;
  tusch_nn_1_N = mkN "tusch" ;
  tuschpenna_nn_1_N = mkN "tuschpenna" ;
  tusenbladstaarta_nn_1_1_N = mkN "tusenbladstårta" ;
  tusenskoena_nn_1_1_N = mkN "tusensköna" ;
  tuta_nn_1_N = mkN "tuta" ;
  tutta_nn_1_N = mkN "tutta" ;
  tuva_nn_1_N = mkN "tuva" ;
  tuvaluanska_nn_1_N = mkN "tuvaluanska" ;
  tuvaluanska_nn_2_N = mkN "tuvaluanska" ;
  tv_kamera_nn_1_N = mkN "tv-kamera" ;
  tv_ruta_nn_1_N = mkN "tv-ruta" ;
  tvaga_nn_1_N = mkN "tvaga" ;
  tvillingflicka_nn_1_N = mkN "tvillingflicka" ;
  tvillingkaerna_nn_1_1_N = mkN "tvillingkärna" ;
  tvillingstjaerna_nn_1_1_N = mkN "tvillingstjärna" ;
  tvistefraaga_nn_1_1_N = mkN "tvistefråga" ;
  tvaerficka_nn_1_1_N = mkN "tvärficka" ;
  tvaergata_nn_1_1_N = mkN "tvärgata" ;
  tvaerslaa_nn_1_1_N = mkN "tvärslå" ;
  tvaettbraeda_nn_1_1_N = mkN "tvättbräda" ;
  tvaettklaemma_nn_1_1_N = mkN "tvättklämma" ;
  tvaettlina_nn_1_1_N = mkN "tvättlina" ;
  tvaettstuga_nn_1_1_N = mkN "tvättstuga" ;
  tvaaa_nn_1_1_N = mkN "tvåa" ;
  tvaabarnspappa_nn_1_1_N = mkN "tvåbarnspappa" ;
  tvaakammarlykta_nn_1_1_N = mkN "tvåkammarlykta" ;
  tvaakrona_nn_1_1_N = mkN "tvåkrona" ;
  tvaalflinga_nn_1_1_N = mkN "tvålflinga" ;
  tvaalopera_nn_1_1_N = mkN "tvålopera" ;
  tvaangstroeja_nn_1_1_N = mkN "tvångströja" ;
  tvaasitssoffa_nn_1_1_N = mkN "tvåsitssoffa" ;
  tvaataktsolja_nn_1_1_N = mkN "tvåtaktsolja" ;
  tyda_nn_1_N = mkN "tyda" ;
  tyfoidfeber_nn_1_N = mkN "tyfoidfeber" ;
  tygremsa_nn_1_N = mkN "tygremsa" ;
  tygtrasa_nn_1_N = mkN "tygtrasa" ;
  tyll_nn_1_N = mkN "tyll" ;
  tyrolska_nn_1_N = mkN "tyrolska" ;
  tyska_nn_1_N = mkN "tyska" ;
  tyska_nn_2_N = mkN "tyska" ;
  taeckjacka_nn_1_1_N = mkN "täckjacka" ;
  taeckmatta_nn_1_1_N = mkN "täckmatta" ;
  taendsticka_nn_1_1_N = mkN "tändsticka" ;
  taendstiftshylsa_nn_1_1_N = mkN "tändstiftshylsa" ;
  taendvaetska_nn_1_1_N = mkN "tändvätska" ;
  taenkarpanna_nn_1_1_N = mkN "tänkarpanna" ;
  taennlika_nn_1_1_N = mkN "tännlika" ;
  taeppa_nn_1_1_N = mkN "täppa" ;
  taerna_nn_1_1_N = mkN "tärna" ;
  taetningsmassa_nn_1_1_N = mkN "tätningsmassa" ;
  taevlingsbana_nn_1_1_N = mkN "tävlingsbana" ;
  taevlingsmaenniska_nn_1_1_N = mkN "tävlingsmänniska" ;
  taaga_nn_1_1_N = mkN "tåga" ;
  taagresa_nn_1_1_N = mkN "tågresa" ;
  taagstraecka_nn_1_1_N = mkN "tågsträcka" ;
  taagvaerdinna_nn_1_1_N = mkN "tågvärdinna" ;
  taahaetta_nn_1_1_N = mkN "tåhätta" ;
  taangraeka_nn_1_1_N = mkN "tångräka" ;
  taargasdimma_nn_1_1_N = mkN "tårgasdimma" ;
  taarta_nn_1_1_N = mkN "tårta" ;
  taartbotten_nn_1_1_N = mkN "tårtbotten" ;
  toe_nn_1_1_N = mkN "tö" ;
  toerel_nn_1_1_N = mkN "törel" ;
  toernekrona_nn_1_1_N = mkN "törnekrona" ;
  toernskata_nn_1_1_N = mkN "törnskata" ;
  ubaatsfaella_nn_1_1_N = mkN "ubåtsfälla" ;
  ubaatsklocka_nn_1_1_N = mkN "ubåtsklocka" ;
  uddabyxa_nn_1_N = mkN "uddabyxa" ;
  ugandiska_nn_1_N = mkN "ugandiska" ;
  uggla_nn_1_N = mkN "uggla" ;
  ugnskappa_nn_1_N = mkN "ugnskappa" ;
  ugnskaapa_nn_1_1_N = mkN "ugnskåpa" ;
  ugnslucka_nn_1_N = mkN "ugnslucka" ;
  ugnspannkaka_nn_1_N = mkN "ugnspannkaka" ;
  ugnssvaerta_nn_1_1_N = mkN "ugnssvärta" ;
  ugnstjaera_nn_1_1_N = mkN "ugnstjära" ;
  ukrainska_nn_1_N = mkN "ukrainska" ;
  ukrainska_nn_2_N = mkN "ukrainska" ;
  ullapa_nn_1_N = mkN "ullapa" ;
  ullhandskrabba_nn_1_N = mkN "ullhandskrabba" ;
  ullolja_nn_1_N = mkN "ullolja" ;
  ullsida_nn_1_N = mkN "ullsida" ;
  ullstrumpa_nn_1_N = mkN "ullstrumpa" ;
  ultima_nn_1_N = mkN "ultima" ;
  ultrahoeger_nn_1_1_N = mkN "ultrahöger" ;
  umbra_nn_1_N = mkN "umbra" ;
  undantagsmaenniska_nn_1_1_N = mkN "undantagsmänniska" ;
  undantagstillvaro_nn_1_N = mkN "undantagstillvaro" ;
  underarmskrycka_nn_1_N = mkN "underarmskrycka" ;
  underblomma_nn_1_N = mkN "underblomma" ;
  underbyxa_nn_1_N = mkN "underbyxa" ;
  undergaangsprofetia_nn_1_1_N = mkN "undergångsprofetia" ;
  underlagskarta_nn_1_N = mkN "underlagskarta" ;
  undersida_nn_1_N = mkN "undersida" ;
  underskoeterska_nn_1_1_N = mkN "undersköterska" ;
  understaemma_nn_1_1_N = mkN "understämma" ;
  understoedskassa_nn_1_1_N = mkN "understödskassa" ;
  understoedstagaranda_nn_1_1_N = mkN "understödstagaranda" ;
  undertroeja_nn_1_1_N = mkN "undertröja" ;
  undervattensboelja_nn_1_1_N = mkN "undervattensbölja" ;
  undervattenskamera_nn_1_N = mkN "undervattenskamera" ;
  undervisningstimma_nn_1_N = mkN "undervisningstimma" ;
  undsaettningsstyrka_nn_1_1_N = mkN "undsättningsstyrka" ;
  undulantfeber_nn_1_N = mkN "undulantfeber" ;
  ungdomsflamma_nn_1_N = mkN "ungdomsflamma" ;
  ungdomsfraaga_nn_1_1_N = mkN "ungdomsfråga" ;
  ungdomskaella_nn_1_1_N = mkN "ungdomskälla" ;
  ungdomsskola_nn_1_N = mkN "ungdomsskola" ;
  ungdomsvaardsskola_nn_1_1_N = mkN "ungdomsvårdsskola" ;
  ungerska_nn_1_N = mkN "ungerska" ;
  ungerska_nn_2_N = mkN "ungerska" ;
  ungkarlsflicka_nn_1_N = mkN "ungkarlsflicka" ;
  ungkarlsvana_nn_1_N = mkN "ungkarlsvana" ;
  unglotta_nn_1_N = mkN "unglotta" ;
  ungsugga_nn_1_N = mkN "ungsugga" ;
  uniformsbyxa_nn_1_N = mkN "uniformsbyxa" ;
  uniformsjacka_nn_1_N = mkN "uniformsjacka" ;
  uniformsmoessa_nn_1_1_N = mkN "uniformsmössa" ;
  unika_nn_1_N = mkN "unika" ;
  universalkarta_nn_1_N = mkN "universalkarta" ;
  uppenbarelsetro_nn_1_N = mkN "uppenbarelsetro" ;
  uppfattningsfoermaaga_nn_1_1_N = mkN "uppfattningsförmåga" ;
  uppfinningsfoermaaga_nn_1_1_N = mkN "uppfinningsförmåga" ;
  upphaemta_nn_1_1_N = mkN "upphämta" ;
  upphaengningsoegla_nn_1_1_N = mkN "upphängningsögla" ;
  upplaga_nn_1_N = mkN "upplaga" ;
  upplagesiffra_nn_1_N = mkN "upplagesiffra" ;
  upplandskyrka_nn_1_N = mkN "upplandskyrka" ;
  upplega_nn_1_N = mkN "upplega" ;
  upplaendska_nn_1_1_N = mkN "uppländska" ;
  upplaendska_nn_2_1_N = mkN "uppländska" ;
  upploesningsfoermaaga_nn_1_1_N = mkN "upplösningsförmåga" ;
  uppmaerksamhetsfoermaaga_nn_1_1_N = mkN "uppmärksamhetsförmåga" ;
  uppnaesa_nn_1_1_N = mkN "uppnäsa" ;
  uppropslista_nn_1_N = mkN "uppropslista" ;
  upprorsanda_nn_1_N = mkN "upprorsanda" ;
  uppskovsraenta_nn_1_1_N = mkN "uppskovsränta" ;
  uppslagsaenda_nn_1_1_N = mkN "uppslagsända" ;
  uppsugningsfoermaaga_nn_1_1_N = mkN "uppsugningsförmåga" ;
  uppsvenska_nn_1_N = mkN "uppsvenska" ;
  upptaecktsresa_nn_1_1_N = mkN "upptäcktsresa" ;
  uran_nn_1_N = mkN "uran" ;
  urea_nn_1_N = mkN "urea" ;
  urfinska_nn_1_N = mkN "urfinska" ;
  urgermanska_nn_1_N = mkN "urgermanska" ;
  urinblaasa_nn_1_1_N = mkN "urinblåsa" ;
  urinstaemma_nn_1_1_N = mkN "urinstämma" ;
  urinsyra_nn_1_N = mkN "urinsyra" ;
  urmaenniska_nn_1_1_N = mkN "urmänniska" ;
  urna_nn_1_N = mkN "urna" ;
  urnordiska_nn_1_N = mkN "urnordiska" ;
  urskiljningsfoermaaga_nn_1_1_N = mkN "urskiljningsförmåga" ;
  urskillningsfoermaaga_nn_1_1_N = mkN "urskillningsförmåga" ;
  ursoppa_nn_1_N = mkN "ursoppa" ;
  urtavla_nn_1_N = mkN "urtavla" ;
  uruguayanska_nn_1_N = mkN "uruguayanska" ;
  utanfoerskapskaensla_nn_1_1_N = mkN "utanförskapskänsla" ;
  utanlaexa_nn_1_1_N = mkN "utanläxa" ;
  utanpaaskjorta_nn_1_1_N = mkN "utanpåskjorta" ;
  utantillaexa_nn_1_1_N = mkN "utantilläxa" ;
  utbildningsklyfta_nn_1_N = mkN "utbildningsklyfta" ;
  utdragslaada_nn_1_1_N = mkN "utdragslåda" ;
  utdragssoffa_nn_1_N = mkN "utdragssoffa" ;
  utevaro_nn_1_N = mkN "utevaro" ;
  utfoersel_nn_1_1_N = mkN "utförsel" ;
  utfoersgaava_nn_1_1_N = mkN "utförsgåva" ;
  utfoersloepa_nn_1_1_N = mkN "utförslöpa" ;
  utgaava_nn_1_1_N = mkN "utgåva" ;
  utklaedsel_nn_1_1_N = mkN "utklädsel" ;
  utlandsresa_nn_1_N = mkN "utlandsresa" ;
  utlandssvenska_nn_1_N = mkN "utlandssvenska" ;
  utlaendska_nn_1_1_N = mkN "utländska" ;
  utlaendska_nn_2_1_N = mkN "utländska" ;
  utmattningsskada_nn_1_N = mkN "utmattningsskada" ;
  utomhuslampa_nn_1_N = mkN "utomhuslampa" ;
  utresa_nn_1_N = mkN "utresa" ;
  utrikeshandel_nn_1_N = mkN "utrikeshandel" ;
  utrikiska_nn_1_N = mkN "utrikiska" ;
  utsaga_nn_1_N = mkN "utsaga" ;
  utsida_nn_1_N = mkN "utsida" ;
  utskottsvara_nn_1_N = mkN "utskottsvara" ;
  utslagsfraaga_nn_1_1_N = mkN "utslagsfråga" ;
  utvecklingslaera_nn_1_1_N = mkN "utvecklingslära" ;
  utvecklingstrappa_nn_1_N = mkN "utvecklingstrappa" ;
  utaega_nn_1_1_N = mkN "utäga" ;
  uzbekiska_nn_1_N = mkN "uzbekiska" ;
  uzbekiska_nn_2_N = mkN "uzbekiska" ;
  vacuumklocka_nn_1_N = mkN "vacuumklocka" ;
  vacuumlampa_nn_1_N = mkN "vacuumlampa" ;
  vadeinlaga_nn_1_N = mkN "vadeinlaga" ;
  vademecum_nn_1_N = mkN "vademecum" ;
  vadmal_nn_1_N = mkN "vadmal" ;
  vagga_nn_1_N = mkN "vagga" ;
  vaggvisa_nn_1_N = mkN "vaggvisa" ;
  vagina_nn_1_N = mkN "vagina" ;
  vaja_nn_1_N = mkN "vaja" ;
  vaka_nn_1_N = mkN "vaka" ;
  vaktbricka_nn_1_N = mkN "vaktbricka" ;
  vaktstyrka_nn_1_N = mkN "vaktstyrka" ;
  vakuumklocka_nn_1_N = mkN "vakuumklocka" ;
  vakuumlampa_nn_1_N = mkN "vakuumlampa" ;
  vala_nn_1_N = mkN "vala" ;
  valeriana_nn_1_N = mkN "valeriana" ;
  valkyria_nn_1_N = mkN "valkyria" ;
  valkyrja_nn_1_N = mkN "valkyrja" ;
  valla_nn_1_N = mkN "valla" ;
  vallflicka_nn_1_N = mkN "vallflicka" ;
  vallista_nn_1_N = mkN "vallista" ;
  vallmoblomma_nn_1_N = mkN "vallmoblomma" ;
  valmar_nn_1_N = mkN "valmar" ;
  valnoetstaarta_nn_1_1_N = mkN "valnötstårta" ;
  valpropaganda_nn_1_N = mkN "valpropaganda" ;
  valstuga_nn_1_N = mkN "valstuga" ;
  valurna_nn_1_N = mkN "valurna" ;
  valuta_nn_1_N = mkN "valuta" ;
  valutahandel_nn_1_N = mkN "valutahandel" ;
  valutaoro_nn_1_N = mkN "valutaoro" ;
  vana_nn_1_N = mkN "vana" ;
  vanadin_nn_1_N = mkN "vanadin" ;
  vandel_nn_1_N = mkN "vandel" ;
  vandrarkaenga_nn_1_1_N = mkN "vandrarkänga" ;
  vanemaenniska_nn_1_1_N = mkN "vanemänniska" ;
  vanheder_nn_1_N = mkN "vanheder" ;
  vaniljvisp_nn_1_N = mkN "vaniljvisp" ;
  vanna_nn_1_N = mkN "vanna" ;
  vanskoetsel_nn_1_1_N = mkN "vanskötsel" ;
  vantrivsel_nn_1_N = mkN "vantrivsel" ;
  vantro_nn_1_N = mkN "vantro" ;
  vanuatiska_nn_1_N = mkN "vanuatiska" ;
  vanuatiska_nn_2_N = mkN "vanuatiska" ;
  vanaera_nn_1_1_N = mkN "vanära" ;
  vapenembargo_nn_1_N = mkN "vapenembargo" ;
  vapenvila_nn_1_N = mkN "vapenvila" ;
  vara_nn_1_N = mkN "vara" ;
  varblaasa_nn_1_1_N = mkN "varblåsa" ;
  vardagsmaenniska_nn_1_1_N = mkN "vardagsmänniska" ;
  vardagsprosa_nn_1_N = mkN "vardagsprosa" ;
  vardagsrekvisita_nn_1_N = mkN "vardagsrekvisita" ;
  varghona_nn_1_N = mkN "varghona" ;
  varginna_nn_1_N = mkN "varginna" ;
  vargtimma_nn_1_N = mkN "vargtimma" ;
  varningsflagga_nn_1_N = mkN "varningsflagga" ;
  varningsklocka_nn_1_N = mkN "varningsklocka" ;
  varningslampa_nn_1_N = mkN "varningslampa" ;
  varpa_nn_1_N = mkN "varpa" ;
  varpsticka_nn_1_N = mkN "varpsticka" ;
  varptrikaa_nn_1_1_N = mkN "varptrikå" ;
  varuhylla_nn_1_N = mkN "varuhylla" ;
  varvsfluga_nn_1_N = mkN "varvsfluga" ;
  vasaorden_nn_1_N = mkN "vasaorden" ;
  vaselin_nn_1_N = mkN "vaselin" ;
  vassla_nn_1_N = mkN "vassla" ;
  vattenblaasa_nn_1_1_N = mkN "vattenblåsa" ;
  vattenflaska_nn_1_N = mkN "vattenflaska" ;
  vattenkanna_nn_1_N = mkN "vattenkanna" ;
  vattenkloever_nn_1_1_N = mkN "vattenklöver" ;
  vattenkaella_nn_1_1_N = mkN "vattenkälla" ;
  vattenloppa_nn_1_N = mkN "vattenloppa" ;
  vattenlaecka_nn_1_1_N = mkN "vattenläcka" ;
  vattenmassa_nn_1_N = mkN "vattenmassa" ;
  vattenpipa_nn_1_N = mkN "vattenpipa" ;
  vattenpolo_nn_1_N = mkN "vattenpolo" ;
  vattenraenna_nn_1_1_N = mkN "vattenränna" ;
  vattenskada_nn_1_N = mkN "vattenskada" ;
  vattenskida_nn_1_N = mkN "vattenskida" ;
  vattenspegel_nn_1_N = mkN "vattenspegel" ;
  vattenspruta_nn_1_N = mkN "vattenspruta" ;
  vattentunna_nn_1_N = mkN "vattentunna" ;
  vattenyta_nn_1_N = mkN "vattenyta" ;
  vattenaanga_nn_1_1_N = mkN "vattenånga" ;
  vattenoedla_nn_1_1_N = mkN "vattenödla" ;
  vaxblomma_nn_1_N = mkN "vaxblomma" ;
  vaxboena_nn_1_1_N = mkN "vaxböna" ;
  vaxdocka_nn_1_N = mkN "vaxdocka" ;
  vaxkaka_nn_1_N = mkN "vaxkaka" ;
  vaxtavla_nn_1_N = mkN "vaxtavla" ;
  vecka_nn_1_N = mkN "vecka" ;
  veckobilaga_nn_1_N = mkN "veckobilaga" ;
  veckotimma_nn_1_N = mkN "veckotimma" ;
  veckoaenda_nn_1_1_N = mkN "veckoända" ;
  veckaenda_nn_1_1_N = mkN "veckända" ;
  vedergaellningsfoermaaga_nn_1_1_N = mkN "vedergällningsförmåga" ;
  vedergaellningslaera_nn_1_1_N = mkN "vedergällningslära" ;
  vedermoeda_nn_1_1_N = mkN "vedermöda" ;
  vedervilja_nn_1_N = mkN "vedervilja" ;
  vegamoessa_nn_1_1_N = mkN "vegamössa" ;
  vela_nn_1_N = mkN "vela" ;
  velourpappa_nn_1_N = mkN "velourpappa" ;
  velvetin_nn_1_N = mkN "velvetin" ;
  vendetta_nn_1_N = mkN "vendetta" ;
  ventilruta_nn_1_N = mkN "ventilruta" ;
  vepa_nn_1_N = mkN "vepa" ;
  veranda_nn_1_N = mkN "veranda" ;
  verandatrappa_nn_1_N = mkN "verandatrappa" ;
  verbena_nn_1_N = mkN "verbena" ;
  verktygslaada_nn_1_1_N = mkN "verktygslåda" ;
  verktygsvaeska_nn_1_1_N = mkN "verktygsväska" ;
  verslaera_nn_1_1_N = mkN "verslära" ;
  vespa_nn_1_N = mkN "vespa" ;
  vessla_nn_1_N = mkN "vessla" ;
  vetebulla_nn_1_N = mkN "vetebulla" ;
  veteflaeta_nn_1_1_N = mkN "vetefläta" ;
  vetekaka_nn_1_N = mkN "vetekaka" ;
  veteskiva_nn_1_N = mkN "veteskiva" ;
  viagra_nn_1_N = mkN "viagra" ;
  vicker_nn_1_N = mkN "vicker" ;
  vidja_nn_1_N = mkN "vidja" ;
  vietnamesiska_nn_1_N = mkN "vietnamesiska" ;
  vietnamesiska_nn_2_N = mkN "vietnamesiska" ;
  vigilia_nn_1_N = mkN "vigilia" ;
  viktoria_nn_1_N = mkN "viktoria" ;
  vikunja_nn_1_N = mkN "vikunja" ;
  vila_nn_1_N = mkN "vila" ;
  vildavel_nn_1_N = mkN "vildavel" ;
  vildbana_nn_1_N = mkN "vildbana" ;
  vildhjaerna_nn_1_1_N = mkN "vildhjärna" ;
  vildpersilja_nn_1_N = mkN "vildpersilja" ;
  vildsvinsolycka_nn_1_N = mkN "vildsvinsolycka" ;
  vilja_nn_1_N = mkN "vilja" ;
  viljemaenniska_nn_1_1_N = mkN "viljemänniska" ;
  viljestyrka_nn_1_N = mkN "viljestyrka" ;
  villa_nn_1_N = mkN "villa" ;
  villa_nn_2_N = mkN "villa" ;
  villervalla_nn_1_N = mkN "villervalla" ;
  villolaera_nn_1_1_N = mkN "villolära" ;
  vilomassa_nn_1_N = mkN "vilomassa" ;
  viltbana_nn_1_N = mkN "viltbana" ;
  vimba_nn_1_N = mkN "vimba" ;
  vimma_nn_1_N = mkN "vimma" ;
  vina_nn_1_N = mkN "vina" ;
  vinbergssnaecka_nn_1_1_N = mkN "vinbergssnäcka" ;
  vinda_nn_1_N = mkN "vinda" ;
  vindblomma_nn_1_N = mkN "vindblomma" ;
  vindbro_nn_1_N = mkN "vindbro" ;
  vindbrygga_nn_1_N = mkN "vindbrygga" ;
  vindeltrappa_nn_1_N = mkN "vindeltrappa" ;
  vindjacka_nn_1_N = mkN "vindjacka" ;
  vindruta_nn_1_N = mkN "vindruta" ;
  vindruva_nn_1_N = mkN "vindruva" ;
  vindsida_nn_1_N = mkN "vindsida" ;
  vindskala_nn_1_N = mkN "vindskala" ;
  vindskida_nn_1_N = mkN "vindskida" ;
  vindskiva_nn_1_N = mkN "vindskiva" ;
  vindskupa_nn_1_N = mkN "vindskupa" ;
  vindstilla_nn_1_N = mkN "vindstilla" ;
  vindstrappa_nn_1_N = mkN "vindstrappa" ;
  vindstyrka_nn_1_N = mkN "vindstyrka" ;
  vindtygsjacka_nn_1_N = mkN "vindtygsjacka" ;
  vinflaska_nn_1_N = mkN "vinflaska" ;
  vingpenna_nn_1_N = mkN "vingpenna" ;
  vinkelsumma_nn_1_N = mkN "vinkelsumma" ;
  vinlista_nn_1_N = mkN "vinlista" ;
  vinranka_nn_1_N = mkN "vinranka" ;
  vinruta_nn_1_N = mkN "vinruta" ;
  vinstlista_nn_1_N = mkN "vinstlista" ;
  vinstuga_nn_1_N = mkN "vinstuga" ;
  vinsyra_nn_1_N = mkN "vinsyra" ;
  vinterdvala_nn_1_N = mkN "vinterdvala" ;
  vintergata_nn_1_N = mkN "vintergata" ;
  vintergroena_nn_1_1_N = mkN "vintergröna" ;
  vinterhimmel_nn_1_N = mkN "vinterhimmel" ;
  vinterkraek_nn_1_1_N = mkN "vinterkräk" ;
  vinterkraeksjuka_nn_1_1_N = mkN "vinterkräksjuka" ;
  vinterkyla_nn_1_N = mkN "vinterkyla" ;
  vinterstjaerna_nn_1_1_N = mkN "vinterstjärna" ;
  vintervila_nn_1_N = mkN "vintervila" ;
  vinaeger_nn_1_1_N = mkN "vinäger" ;
  vinaettika_nn_1_1_N = mkN "vinättika" ;
  viola_nn_1_N = mkN "viola" ;
  vipa_nn_1_N = mkN "vipa" ;
  vippa_nn_1_N = mkN "vippa" ;
  vippbraeda_nn_1_1_N = mkN "vippbräda" ;
  vira_nn_1_N = mkN "vira" ;
  vira_nn_2_N = mkN "vira" ;
  virrhjaerna_nn_1_1_N = mkN "virrhjärna" ;
  virrpanna_nn_1_N = mkN "virrpanna" ;
  visa_nn_1_N = mkN "visa" ;
  vischa_nn_1_N = mkN "vischa" ;
  visdomskaella_nn_1_1_N = mkN "visdomskälla" ;
  vishetslaera_nn_1_1_N = mkN "vishetslära" ;
  visirskiva_nn_1_N = mkN "visirskiva" ;
  viska_nn_1_N = mkN "viska" ;
  visp_nn_2_N = mkN "visp" ;
  visselpipa_nn_1_N = mkN "visselpipa" ;
  vissla_nn_1_N = mkN "vissla" ;
  vita_nn_1_N = mkN "vita" ;
  vitbeta_nn_1_N = mkN "vitbeta" ;
  vitiligo_nn_1_N = mkN "vitiligo" ;
  vitkloever_nn_1_1_N = mkN "vitklöver" ;
  vitlinglyra_nn_1_N = mkN "vitlinglyra" ;
  vitloeksklyfta_nn_1_1_N = mkN "vitlöksklyfta" ;
  vitmossa_nn_1_N = mkN "vitmossa" ;
  vitmaara_nn_1_1_N = mkN "vitmåra" ;
  vitriol_nn_1_N = mkN "vitriol" ;
  vitriololja_nn_1_N = mkN "vitriololja" ;
  vitryska_nn_1_N = mkN "vitryska" ;
  vitryska_nn_2_N = mkN "vitryska" ;
  vitsippa_nn_1_N = mkN "vitsippa" ;
  vittlinglyra_nn_1_N = mkN "vittlinglyra" ;
  vittnesutsaga_nn_1_N = mkN "vittnesutsaga" ;
  vittra_nn_1_N = mkN "vittra" ;
  vitvara_nn_1_N = mkN "vitvara" ;
  viva_nn_1_N = mkN "viva" ;
  vodka_nn_1_N = mkN "vodka" ;
  voffla_nn_1_N = mkN "voffla" ;
  vokalissa_nn_1_N = mkN "vokalissa" ;
  volfram_nn_1_N = mkN "volfram" ;
  volta_nn_1_N = mkN "volta" ;
  volvo_nn_1_N = mkN "volvo" ;
  voodoo_nn_1_N = mkN "voodoo" ;
  votivgaava_nn_1_1_N = mkN "votivgåva" ;
  vrakeka_nn_1_N = mkN "vrakeka" ;
  vrakspillra_nn_1_N = mkN "vrakspillra" ;
  vraalapa_nn_1_1_N = mkN "vrålapa" ;
  vulkanaska_nn_1_N = mkN "vulkanaska" ;
  vulkankaegla_nn_1_1_N = mkN "vulkankägla" ;
  vulkanoe_nn_1_1_N = mkN "vulkanö" ;
  vulva_nn_1_N = mkN "vulva" ;
  vurpa_nn_1_N = mkN "vurpa" ;
  vuvuzela_nn_1_N = mkN "vuvuzela" ;
  vaecka_nn_1_1_N = mkN "väcka" ;
  vaeckarklocka_nn_1_1_N = mkN "väckarklocka" ;
  vaedergalla_nn_1_1_N = mkN "vädergalla" ;
  vaederkarta_nn_1_1_N = mkN "väderkarta" ;
  vaederlaada_nn_1_1_N = mkN "väderlåda" ;
  vaedjobana_nn_1_1_N = mkN "vädjobana" ;
  vaedur_nn_1_1_N = mkN "vädur" ;
  vaegbana_nn_1_1_N = mkN "vägbana" ;
  vaegbro_nn_1_1_N = mkN "vägbro" ;
  vaegbula_nn_1_1_N = mkN "vägbula" ;
  vaegfaerja_nn_1_1_N = mkN "vägfärja" ;
  vaegghylla_nn_1_1_N = mkN "vägghylla" ;
  vaeggklocka_nn_1_1_N = mkN "väggklocka" ;
  vaeggmossa_nn_1_1_N = mkN "väggmossa" ;
  vaeggplatta_nn_1_1_N = mkN "väggplatta" ;
  vaeggyta_nn_1_1_N = mkN "väggyta" ;
  vaegkurva_nn_1_1_N = mkN "vägkurva" ;
  vaegskrapa_nn_1_1_N = mkN "vägskrapa" ;
  vaegstraecka_nn_1_1_N = mkN "vägsträcka" ;
  vaegtrumma_nn_1_1_N = mkN "vägtrumma" ;
  vaegvaarda_nn_1_1_N = mkN "vägvårda" ;
  vaeljarskara_nn_1_1_N = mkN "väljarskara" ;
  vaelkomma_nn_1_1_N = mkN "välkomma" ;
  vaellingklocka_nn_1_1_N = mkN "vällingklocka" ;
  vaelmaaga_nn_1_1_N = mkN "välmåga" ;
  vaelskrivningsfroeken_nn_1_1_N = mkN "välskrivningsfröken" ;
  vaelta_nn_1_1_N = mkN "välta" ;
  vaelvilja_nn_1_1_N = mkN "välvilja" ;
  vaenda_nn_1_1_N = mkN "vända" ;
  vaendskiva_nn_1_1_N = mkN "vändskiva" ;
  vaengaava_nn_1_1_N = mkN "vängåva" ;
  vaeninna_nn_1_1_N = mkN "väninna" ;
  vaenster_nn_2_1_N = mkN "vänster" ;
  vaensterkurva_nn_1_1_N = mkN "vänsterkurva" ;
  vaenstersida_nn_1_1_N = mkN "vänstersida" ;
  vaensteraara_nn_1_1_N = mkN "vänsteråra" ;
  vaentelista_nn_1_1_N = mkN "väntelista" ;
  vaerdegrundsfraaga_nn_1_1_N = mkN "värdegrundsfråga" ;
  vaerdelaera_nn_1_1_N = mkN "värdelära" ;
  vaerdepappershandel_nn_1_1_N = mkN "värdepappershandel" ;
  vaerdeskala_nn_1_1_N = mkN "värdeskala" ;
  vaerdinna_nn_1_1_N = mkN "värdinna" ;
  vaerja_nn_1_1_N = mkN "värja" ;
  vaerjningsskada_nn_1_1_N = mkN "värjningsskada" ;
  vaerldsetta_nn_1_1_N = mkN "världsetta" ;
  vaerldsgaata_nn_1_1_N = mkN "världsgåta" ;
  vaerldshandel_nn_1_1_N = mkN "världshandel" ;
  vaerldskarta_nn_1_1_N = mkN "världskarta" ;
  vaerldsmaestarinna_nn_1_1_N = mkN "världsmästarinna" ;
  vaerldssmaerta_nn_1_1_N = mkN "världssmärta" ;
  vaerldstrea_nn_1_1_N = mkN "världstrea" ;
  vaerldsvana_nn_1_1_N = mkN "världsvana" ;
  vaerma_nn_1_1_N = mkN "värma" ;
  vaerme_nn_2_1_N = mkN "värme" ;
  vaermebildskamera_nn_1_1_N = mkN "värmebildskamera" ;
  vaermeblemma_nn_1_1_N = mkN "värmeblemma" ;
  vaermeboelja_nn_1_1_N = mkN "värmebölja" ;
  vaermedyna_nn_1_1_N = mkN "värmedyna" ;
  vaermeflaska_nn_1_1_N = mkN "värmeflaska" ;
  vaermekamera_nn_1_1_N = mkN "värmekamera" ;
  vaermekaella_nn_1_1_N = mkN "värmekälla" ;
  vaermelampa_nn_1_1_N = mkN "värmelampa" ;
  vaermeledningspanna_nn_1_1_N = mkN "värmeledningspanna" ;
  vaermelaera_nn_1_1_N = mkN "värmelära" ;
  vaermepanna_nn_1_1_N = mkN "värmepanna" ;
  vaermeplatta_nn_1_1_N = mkN "värmeplatta" ;
  vaermeslinga_nn_1_1_N = mkN "värmeslinga" ;
  vaermestuga_nn_1_1_N = mkN "värmestuga" ;
  vaermetillfoersel_nn_1_1_N = mkN "värmetillförsel" ;
  vaermlaendska_nn_1_1_N = mkN "värmländska" ;
  vaermlaendska_nn_2_1_N = mkN "värmländska" ;
  vaeska_nn_1_1_N = mkN "väska" ;
  vaester_nn_1_1_N = mkN "väster" ;
  vaesteraasgurka_nn_1_1_N = mkN "västeråsgurka" ;
  vaestgotiska_nn_1_1_N = mkN "västgotiska" ;
  vaestgoetska_nn_1_1_N = mkN "västgötska" ;
  vaestgoetska_nn_2_1_N = mkN "västgötska" ;
  vaestmanlaendska_nn_1_1_N = mkN "västmanländska" ;
  vaestmanlaendska_nn_2_1_N = mkN "västmanländska" ;
  vaeta_nn_1_1_N = mkN "väta" ;
  vaetekaerna_nn_1_1_N = mkN "vätekärna" ;
  vaetska_nn_1_1_N = mkN "vätska" ;
  vaetsketillfoersel_nn_1_1_N = mkN "vätsketillförsel" ;
  vaeverska_nn_1_1_N = mkN "väverska" ;
  vaevnadsvaetska_nn_1_1_N = mkN "vävnadsvätska" ;
  vaevsolv_nn_1_1_N = mkN "vävsolv" ;
  vaexelkassa_nn_1_1_N = mkN "växelkassa" ;
  vaexellaada_nn_1_1_N = mkN "växellåda" ;
  vaexeltunga_nn_1_1_N = mkN "växeltunga" ;
  vaada_nn_1_1_N = mkN "våda" ;
  vaaffla_nn_1_1_N = mkN "våffla" ;
  vaagpapp_nn_1_1_N = mkN "vågpapp" ;
  vaaldsporr_nn_1_1_N = mkN "våldsporr" ;
  vaanda_nn_1_1_N = mkN "vånda" ;
  vaarblomma_nn_1_1_N = mkN "vårblomma" ;
  vaardarinna_nn_1_1_N = mkN "vårdarinna" ;
  vaardskada_nn_1_1_N = mkN "vårdskada" ;
  vaarkaensla_nn_1_1_N = mkN "vårkänsla" ;
  vaarsoppa_nn_1_1_N = mkN "vårsoppa" ;
  vaarta_nn_1_1_N = mkN "vårta" ;
  vaarvintervecka_nn_1_1_N = mkN "vårvintervecka" ;
  vaatmassa_nn_1_1_N = mkN "våtmassa" ;
  vaatskrapa_nn_1_1_N = mkN "våtskrapa" ;
  vaatvara_nn_1_1_N = mkN "våtvara" ;
  voertstyrka_nn_1_1_N = mkN "vörtstyrka" ;
  walesiska_nn_1_N = mkN "walesiska" ;
  walesiska_nn_2_N = mkN "walesiska" ;
  walkover_nn_1_N = mkN "walkover" ;
  webbkamera_nn_1_N = mkN "webbkamera" ;
  webbsida_nn_1_N = mkN "webbsida" ;
  wiltonmatta_nn_1_N = mkN "wiltonmatta" ;
  wolfram_nn_1_N = mkN "wolfram" ;
  xantippa_nn_1_N = mkN "xantippa" ;
  xerotin_nn_1_N = mkN "xerotin" ;
  yakuza_nn_1_N = mkN "yakuza" ;
  yllestrumpa_nn_1_N = mkN "yllestrumpa" ;
  yngelkaka_nn_1_N = mkN "yngelkaka" ;
  yngelroeta_nn_1_1_N = mkN "yngelröta" ;
  ynk_nn_1_N = mkN "ynk" ;
  yoga_nn_1_N = mkN "yoga" ;
  yra_nn_1_N = mkN "yra" ;
  yrhaetta_nn_1_1_N = mkN "yrhätta" ;
  yrkesheder_nn_1_N = mkN "yrkesheder" ;
  yrkeskvinna_nn_1_N = mkN "yrkeskvinna" ;
  yrkesskada_nn_1_N = mkN "yrkesskada" ;
  yrkesskola_nn_1_N = mkN "yrkesskola" ;
  yrsel_nn_1_N = mkN "yrsel" ;
  yrsnoe_nn_1_1_N = mkN "yrsnö" ;
  yta_nn_1_N = mkN "yta" ;
  ytterbana_nn_1_N = mkN "ytterbana" ;
  ytterficka_nn_1_N = mkN "ytterficka" ;
  ytterkurva_nn_1_N = mkN "ytterkurva" ;
  yttersida_nn_1_N = mkN "yttersida" ;
  yttersula_nn_1_N = mkN "yttersula" ;
  yttrandefrihetsfraaga_nn_1_1_N = mkN "yttrandefrihetsfråga" ;
  yxa_nn_1_N = mkN "yxa" ;
  zebra_nn_1_N = mkN "zebra" ;
  zigenarflicka_nn_1_N = mkN "zigenarflicka" ;
  zigenska_nn_1_N = mkN "zigenska" ;
  zinkfeber_nn_1_N = mkN "zinkfeber" ;
  zinksalva_nn_1_N = mkN "zinksalva" ;
  zinkaanga_nn_1_1_N = mkN "zinkånga" ;
  zinnia_nn_1_N = mkN "zinnia" ;
  zontaxa_nn_1_N = mkN "zontaxa" ;
  aeckelkaensla_nn_1_1_N = mkN "äckelkänsla" ;
  aedelskaanska_nn_1_1_N = mkN "ädelskånska" ;
  aega_nn_1_1_N = mkN "äga" ;
  aeggblaasa_nn_1_1_N = mkN "äggblåsa" ;
  aegghinna_nn_1_1_N = mkN "ägghinna" ;
  aegghoena_nn_1_1_N = mkN "ägghöna" ;
  aeggkaka_nn_1_1_N = mkN "äggkaka" ;
  aeggklocka_nn_1_1_N = mkN "äggklocka" ;
  aegglaada_nn_1_1_N = mkN "ägglåda" ;
  aeggplanta_nn_1_1_N = mkN "äggplanta" ;
  aeggroera_nn_1_1_N = mkN "äggröra" ;
  aeggstockscancer_nn_1_1_N = mkN "äggstockscancer" ;
  aeggula_nn_1_1_N = mkN "äggula" ;
  aeggvita_nn_1_1_N = mkN "äggvita" ;
  aeggvitegiva_nn_1_1_N = mkN "äggvitegiva" ;
  aektenskapsaalder_nn_1_1_N = mkN "äktenskapsålder" ;
  aelgskav_nn_1_1_N = mkN "älgskav" ;
  aelskarinna_nn_1_1_N = mkN "älskarinna" ;
  aelsklingsblomma_nn_1_1_N = mkN "älsklingsblomma" ;
  aelta_nn_1_1_N = mkN "älta" ;
  aelva_nn_1_1_N = mkN "älva" ;
  aelvfaara_nn_1_1_N = mkN "älvfåra" ;
  aembetsadel_nn_1_1_N = mkN "ämbetsadel" ;
  aembetsmannaadel_nn_1_1_N = mkN "ämbetsmannaadel" ;
  aenda_nn_1_1_N = mkN "ända" ;
  aenda_nn_2_1_N = mkN "ända" ;
  aendyta_nn_1_1_N = mkN "ändyta" ;
  aenglamakerska_nn_1_1_N = mkN "änglamakerska" ;
  aenglaskara_nn_1_1_N = mkN "änglaskara" ;
  aengsblomma_nn_1_1_N = mkN "ängsblomma" ;
  aengspiplaerka_nn_1_1_N = mkN "ängspiplärka" ;
  aengsruta_nn_1_1_N = mkN "ängsruta" ;
  aengsskaera_nn_1_1_N = mkN "ängsskära" ;
  aengssyra_nn_1_1_N = mkN "ängssyra" ;
  aenka_nn_1_1_N = mkN "änka" ;
  aenkefru_nn_1_1_N = mkN "änkefru" ;
  aenterbila_nn_1_1_N = mkN "änterbila" ;
  aeppelkaka_nn_1_1_N = mkN "äppelkaka" ;
  aeppelmos_nn_1_1_N = mkN "äppelmos" ;
  aeppelsyra_nn_1_1_N = mkN "äppelsyra" ;
  aepplekaka_nn_1_1_N = mkN "äpplekaka" ;
  aepplemos_nn_1_1_N = mkN "äpplemos" ;
  aepplesyra_nn_1_1_N = mkN "äpplesyra" ;
  aera_nn_1_1_N = mkN "ära" ;
  aerftlighetslaera_nn_1_1_N = mkN "ärftlighetslära" ;
  aeril_nn_1_1_N = mkN "äril" ;
  aerla_nn_1_1_N = mkN "ärla" ;
  aermbraeda_nn_1_1_N = mkN "ärmbräda" ;
  aertbalja_nn_1_1_N = mkN "ärtbalja" ;
  aerthjaerna_nn_1_1_N = mkN "ärthjärna" ;
  aertreva_nn_1_1_N = mkN "ärtreva" ;
  aertskida_nn_1_1_N = mkN "ärtskida" ;
  aertskocka_nn_1_1_N = mkN "ärtskocka" ;
  aertsoppa_nn_1_1_N = mkN "ärtsoppa" ;
  aessja_nn_1_1_N = mkN "ässja" ;
  aettartavla_nn_1_1_N = mkN "ättartavla" ;
  aettestupa_nn_1_1_N = mkN "ättestupa" ;
  aettetavla_nn_1_1_N = mkN "ättetavla" ;
  aettika_nn_1_1_N = mkN "ättika" ;
  aettiksgurka_nn_1_1_N = mkN "ättiksgurka" ;
  aettiksyra_nn_1_1_N = mkN "ättiksyra" ;
  aeventyrslusta_nn_1_1_N = mkN "äventyrslusta" ;
  aevja_nn_1_1_N = mkN "ävja" ;
  aa_nn_2_1_N = mkN "å" ;
  aada_nn_1_1_N = mkN "åda" ;
  aaderhinna_nn_1_1_N = mkN "åderhinna" ;
  aadra_nn_1_1_N = mkN "ådra" ;
  aahaaga_nn_1_1_N = mkN "åhåga" ;
  aakarbrasa_nn_1_1_N = mkN "åkarbrasa" ;
  aakerbinda_nn_1_1_N = mkN "åkerbinda" ;
  aakerhoena_nn_1_1_N = mkN "åkerhöna" ;
  aakervinda_nn_1_1_N = mkN "åkervinda" ;
  aakomma_nn_1_1_N = mkN "åkomma" ;
  aalderdomskraempa_nn_1_1_N = mkN "ålderdomskrämpa" ;
  aalderskraempa_nn_1_1_N = mkN "ålderskrämpa" ;
  aaldfru_nn_1_1_N = mkN "åldfru" ;
  aalhomma_nn_1_1_N = mkN "ålhomma" ;
  aalkista_nn_1_1_N = mkN "ålkista" ;
  aalkusa_nn_1_1_N = mkN "ålkusa" ;
  aalla_nn_1_1_N = mkN "ålla" ;
  aalaendska_nn_1_1_N = mkN "åländska" ;
  aalaendska_nn_2_1_N = mkN "åländska" ;
  aaminnelsedag_nn_1_1_N = mkN "åminnelsedag" ;
  aanga_nn_1_1_N = mkN "ånga" ;
  aangbaatsbrygga_nn_1_1_N = mkN "ångbåtsbrygga" ;
  aangbaatsraenna_nn_1_1_N = mkN "ångbåtsränna" ;
  aangbaatsvissla_nn_1_1_N = mkN "ångbåtsvissla" ;
  aanger_nn_1_1_N = mkN "ånger" ;
  aangervecka_nn_1_1_N = mkN "ångervecka" ;
  aangestkaensla_nn_1_1_N = mkN "ångestkänsla" ;
  aangpanna_nn_1_1_N = mkN "ångpanna" ;
  aangradio_nn_1_1_N = mkN "ångradio" ;
  aangvissla_nn_1_1_N = mkN "ångvissla" ;
  aara_nn_1_1_N = mkN "åra" ;
  aaretruntolja_nn_1_1_N = mkN "åretruntolja" ;
  aarklyka_nn_1_1_N = mkN "årklyka" ;
  aarsstaemma_nn_1_1_N = mkN "årsstämma" ;
  aarta_nn_1_1_N = mkN "årta" ;
  aaska_nn_1_1_N = mkN "åska" ;
  aaskaadarmassa_nn_1_1_N = mkN "åskådarmassa" ;
  aasna_nn_1_1_N = mkN "åsna" ;
  aasnebrygga_nn_1_1_N = mkN "åsnebrygga" ;
  aaterfallsfeber_nn_1_1_N = mkN "återfallsfeber" ;
  aaterfoederska_nn_1_1_N = mkN "återföderska" ;
  aaterresa_nn_1_1_N = mkN "återresa" ;
  aatervaendsgata_nn_1_1_N = mkN "återvändsgata" ;
  aatraa_nn_1_1_N = mkN "åtrå" ;
  aatsida_nn_1_1_N = mkN "åtsida" ;
  aatta_nn_1_1_N = mkN "åtta" ;
  aattlingmamma_nn_1_1_N = mkN "åttlingmamma" ;
  oe_nn_2_1_N = mkN "ö" ;
  oedekyrka_nn_1_1_N = mkN "ödekyrka" ;
  oedesfraaga_nn_1_1_N = mkN "ödesfråga" ;
  oedesgudinna_nn_1_1_N = mkN "ödesgudinna" ;
  oedestro_nn_1_1_N = mkN "ödestro" ;
  oedestuga_nn_1_1_N = mkN "ödestuga" ;
  oedla_nn_1_1_N = mkN "ödla" ;
  oegla_nn_1_1_N = mkN "ögla" ;
  oegonbotten_nn_1_1_N = mkN "ögonbotten" ;
  oegonhinna_nn_1_1_N = mkN "ögonhinna" ;
  oegonhaala_nn_1_1_N = mkN "ögonhåla" ;
  oegonkamera_nn_1_1_N = mkN "ögonkamera" ;
  oegonskugga_nn_1_1_N = mkN "ögonskugga" ;
  oegonvita_nn_1_1_N = mkN "ögonvita" ;
  oeken_nn_1_1_N = mkN "öken" ;
  oekenhetta_nn_1_1_N = mkN "ökenhetta" ;
  oekenraatta_nn_1_1_N = mkN "ökenråtta" ;
  oekenstjaerna_nn_1_1_N = mkN "ökenstjärna" ;
  oelandsvaenda_nn_1_1_N = mkN "ölandsvända" ;
  oelflaska_nn_1_1_N = mkN "ölflaska" ;
  oelstuga_nn_1_1_N = mkN "ölstuga" ;
  oelsupa_nn_1_1_N = mkN "ölsupa" ;
  oelaendska_nn_1_1_N = mkN "öländska" ;
  oelaendska_nn_2_1_N = mkN "öländska" ;
  oemkyla_nn_1_1_N = mkN "ömkyla" ;
  oenskelista_nn_1_1_N = mkN "önskelista" ;
  oerlig_nn_1_1_N = mkN "örlig" ;
  oerlog_nn_1_1_N = mkN "örlog" ;
  oerlogsflagga_nn_1_1_N = mkN "örlogsflagga" ;
  oernbraeken_nn_1_1_N = mkN "örnbräken" ;
  oernnaesa_nn_1_1_N = mkN "örnnäsa" ;
  oeronmussla_nn_1_1_N = mkN "öronmussla" ;
  oeronsnaecka_nn_1_1_N = mkN "öronsnäcka" ;
  oertkrydda_nn_1_1_N = mkN "örtkrydda" ;
  oester_nn_1_1_N = mkN "öster" ;
  oestgotiska_nn_1_1_N = mkN "östgotiska" ;
  oestgoetska_nn_1_1_N = mkN "östgötska" ;
  oestgoetska_nn_2_1_N = mkN "östgötska" ;
  oeverfralla_nn_1_1_N = mkN "överfralla" ;
  oeverklassflicka_nn_1_1_N = mkN "överklassflicka" ;
  oeverklasspraegel_nn_1_1_N = mkN "överklassprägel" ;
  oeverkucku_nn_1_1_N = mkN "överkucku" ;
  oeverleva_nn_1_1_N = mkN "överleva" ;
  oeverlevnadsficka_nn_1_1_N = mkN "överlevnadsficka" ;
  oeverlevnadsfoermaaga_nn_1_1_N = mkN "överlevnadsförmåga" ;
  oevermaenniska_nn_1_1_N = mkN "övermänniska" ;
  oevernit_nn_1_1_N = mkN "övernit" ;
  oeverresa_nn_1_1_N = mkN "överresa" ;
  oeversida_nn_1_1_N = mkN "översida" ;
  oeverskottsaanga_nn_1_1_N = mkN "överskottsånga" ;
  oeverskoeterska_nn_1_1_N = mkN "översköterska" ;
  oeverstrykningspenna_nn_1_1_N = mkN "överstrykningspenna" ;
  oevertalningsfoermaaga_nn_1_1_N = mkN "övertalningsförmåga" ;
  oevertro_nn_1_1_N = mkN "övertro" ;
  oevervakningskamera_nn_1_1_N = mkN "övervakningskamera" ;
  Calzone_nn_1_N = mkN "Calzone" utrum  ;
  acne_nn_1_N = mkN "acne" utrum  ;
  akne_nn_1_N = mkN "akne" utrum  ;
  allmoge_nn_1_N = mkN "allmoge" utrum  ;
  anstiftelse_nn_1_N = mkN "anstiftelse" utrum  ;
  apokope_nn_1_N = mkN "apokope" utrum  ;
  arbetarskyddsstyrelse_nn_1_N = mkN "arbetarskyddsstyrelse" utrum  ;
  arbetsglaedje_nn_1_1_N = mkN "arbetsglädje" utrum  ;
  arbetsmarknadsstyrelse_nn_1_N = mkN "arbetsmarknadsstyrelse" utrum  ;
  auktionsbridge_nn_1_N = mkN "auktionsbridge" utrum  ;
  avlelse_nn_1_N = mkN "avlelse" utrum  ;
  bastuvaerme_nn_1_1_N = mkN "bastuvärme" utrum  ;
  bensoe_nn_1_N = mkN "bensoe" utrum  ;
  beraettarglaedje_nn_1_1_N = mkN "berättarglädje" utrum  ;
  beroemmelse_nn_1_1_N = mkN "berömmelse" utrum  ;
  besique_nn_1_N = mkN "besique" utrum  ;
  bezique_nn_1_N = mkN "bezique" utrum  ;
  blankooeverlaatelse_nn_1_1_N = mkN "blankoöverlåtelse" utrum  ;
  blaaelse_nn_1_1_N = mkN "blåelse" utrum  ;
  blaavaerme_nn_1_1_N = mkN "blåvärme" utrum  ;
  borstnate_nn_1_N = mkN "borstnate" utrum  ;
  bortaende_nn_1_1_N = mkN "bortände" utrum  ;
  bouillabaisse_nn_1_N = mkN "bouillabaisse" utrum  ;
  boule_nn_1_N = mkN "boule" utrum  ;
  bourgeoisie_nn_1_N = mkN "bourgeoisie" utrum  ;
  breakdance_nn_1_N = mkN "breakdance" utrum  ;
  bridge_nn_1_N = mkN "bridge" utrum  ;
  calzone_nn_1_N = mkN "calzone" utrum  ;
  carambole_nn_1_N = mkN "carambole" utrum  ;
  centralvaerme_nn_1_1_N = mkN "centralvärme" utrum  ;
  chamotte_nn_1_N = mkN "chamotte" utrum  ;
  charmeuse_nn_1_N = mkN "charmeuse" utrum  ;
  clairvoyance_nn_1_N = mkN "clairvoyance" utrum  ;
  cre_me_de_la_cre_me_nn_1_1_N = mkN "crème-de-la-crème" utrum  ;
  deadline_nn_1_N = mkN "deadline" utrum  ;
  duchesse_nn_1_N = mkN "duchesse" utrum  ;
  d_etente_nn_1_1_N = mkN "détente" utrum  ;
  doepelse_nn_1_1_N = mkN "döpelse" utrum  ;
  eau_de_cologne_nn_1_N = mkN "eau-de-cologne" utrum  ;
  eau_de_toilette_nn_1_N = mkN "eau-de-toilette" utrum  ;
  eau_de_vie_nn_1_N = mkN "eau-de-vie" utrum  ;
  eftermassage_nn_1_N = mkN "eftermassage" utrum  ;
  efterraettelse_nn_1_1_N = mkN "efterrättelse" utrum  ;
  eftertanke_nn_1_N = mkN "eftertanke" utrum  ;
  eftervaerme_nn_1_1_N = mkN "eftervärme" utrum  ;
  egenroerelse_nn_1_1_N = mkN "egenrörelse" utrum  ;
  elvaerme_nn_1_1_N = mkN "elvärme" utrum  ;
  empire_nn_1_N = mkN "empire" utrum  ;
  festglaedje_nn_1_1_N = mkN "festglädje" utrum  ;
  fjaerrvaerme_nn_1_1_N = mkN "fjärrvärme" utrum  ;
  flyghavre_nn_1_N = mkN "flyghavre" utrum  ;
  folklore_nn_1_N = mkN "folklore" utrum  ;
  frigoerelse_nn_1_1_N = mkN "frigörelse" utrum  ;
  furore_nn_1_N = mkN "furore" utrum  ;
  faergskalle_nn_1_1_N = mkN "färgskalle" utrum  ;
  foerargelse_nn_1_1_N = mkN "förargelse" utrum  ;
  foerbudslinje_nn_1_1_N = mkN "förbudslinje" utrum  ;
  foerdoemelse_nn_1_1_N = mkN "fördömelse" utrum  ;
  foerfoerstaaelse_nn_1_1_N = mkN "förförståelse" utrum  ;
  foergaengelse_nn_1_1_N = mkN "förgängelse" utrum  ;
  foerintelse_nn_1_1_N = mkN "förintelse" utrum  ;
  foerkastelse_nn_1_1_N = mkN "förkastelse" utrum  ;
  foerkrosselse_nn_1_1_N = mkN "förkrosselse" utrum  ;
  foerlaatelse_nn_1_1_N = mkN "förlåtelse" utrum  ;
  foerruttnelse_nn_1_1_N = mkN "förruttnelse" utrum  ;
  foerstockelse_nn_1_1_N = mkN "förstockelse" utrum  ;
  foerstaaelse_nn_1_1_N = mkN "förståelse" utrum  ;
  foertappelse_nn_1_1_N = mkN "förtappelse" utrum  ;
  foertrytelse_nn_1_1_N = mkN "förtrytelse" utrum  ;
  georgette_nn_1_N = mkN "georgette" utrum  ;
  geovaerme_nn_1_1_N = mkN "geovärme" utrum  ;
  glace_nn_1_N = mkN "glace" utrum  ;
  glaedje_nn_1_1_N = mkN "glädje" utrum  ;
  golvvaerme_nn_1_1_N = mkN "golvvärme" utrum  ;
  grodnate_nn_1_N = mkN "grodnate" utrum  ;
  grunge_nn_1_N = mkN "grunge" utrum  ;
  gruyere_nn_1_N = mkN "gruyere" utrum  ;
  groee_nn_1_1_N = mkN "gröe" utrum  ;
  gaeddnate_nn_1_1_N = mkN "gäddnate" utrum  ;
  hackelse_nn_1_N = mkN "hackelse" utrum  ;
  hardcore_nn_1_N = mkN "hardcore" utrum  ;
  havre_nn_1_N = mkN "havre" utrum  ;
  helgelse_nn_1_N = mkN "helgelse" utrum  ;
  herrgaardsallmoge_nn_1_1_N = mkN "herrgårdsallmoge" utrum  ;
  historiefoerstaaelse_nn_1_1_N = mkN "historieförståelse" utrum  ;
  hjaertmassage_nn_1_1_N = mkN "hjärtmassage" utrum  ;
  hollandaise_nn_1_N = mkN "hollandaise" utrum  ;
  house_nn_1_N = mkN "house" utrum  ;
  haenfoerelse_nn_1_1_N = mkN "hänförelse" utrum  ;
  haengivelse_nn_1_1_N = mkN "hängivelse" utrum  ;
  haevdelse_nn_1_1_N = mkN "hävdelse" utrum  ;
  image_nn_1_N = mkN "image" utrum  ;
  inlevelse_nn_1_N = mkN "inlevelse" utrum  ;
  jade_nn_1_N = mkN "jade" utrum  ;
  jordvaerme_nn_1_1_N = mkN "jordvärme" utrum  ;
  juvermassage_nn_1_N = mkN "juvermassage" utrum  ;
  kaffegraedde_nn_1_1_N = mkN "kaffegrädde" utrum  ;
  karaoke_nn_1_N = mkN "karaoke" utrum  ;
  karate_nn_1_N = mkN "karate" utrum  ;
  kille_nn_2_N = mkN "kille" utrum  ;
  knylhavre_nn_1_N = mkN "knylhavre" utrum  ;
  kontraktsbridge_nn_1_N = mkN "kontraktsbridge" utrum  ;
  krasse_nn_1_N = mkN "krasse" utrum  ;
  kroppsvaerme_nn_1_1_N = mkN "kroppsvärme" utrum  ;
  kryddkrasse_nn_1_N = mkN "kryddkrasse" utrum  ;
  kultje_nn_1_N = mkN "kultje" utrum  ;
  kundservice_nn_1_N = mkN "kundservice" utrum  ;
  kunskapslidelse_nn_1_N = mkN "kunskapslidelse" utrum  ;
  kvanne_nn_1_N = mkN "kvanne" utrum  ;
  kaeraste_nn_1_1_N = mkN "käraste" utrum  ;
  lasagne_nn_1_N = mkN "lasagne" utrum  ;
  levnadsglaedje_nn_1_1_N = mkN "levnadsglädje" utrum  ;
  livsande_nn_1_N = mkN "livsande" utrum  ;
  livsbejakelse_nn_1_N = mkN "livsbejakelse" utrum  ;
  livsglaedje_nn_1_1_N = mkN "livsglädje" utrum  ;
  lomme_nn_1_N = mkN "lomme" utrum  ;
  laesfoerstaaelse_nn_1_1_N = mkN "läsförståelse" utrum  ;
  Afghanistaninsats_nn_1_N = mkN "Afghanistaninsats" ;
  BNP_tillvaext_nn_1_1_N = mkN "BNP-tillväxt" ;
  Banverkspersonal_nn_1_N = mkN "Banverkspersonal" ;
  Bonnierkoncern_nn_1_N = mkN "Bonnierkoncern" ;
  C_dur_nn_1_N = mkN "C-dur" ;
  Cointreau_nn_1_N = mkN "Cointreau" ;
  EHEC_nn_1_N = mkN "EHEC" ;
  Gnosjoeanda_nn_1_1_N = mkN "Gnosjöanda" ;
  Greenwichmeridian_nn_1_N = mkN "Greenwichmeridian" ;
  Hultsfredsfestival_nn_1_N = mkN "Hultsfredsfestival" ;
  Haargalaat_nn_1_1_N = mkN "Hårgalåt" ;
  Kevlar_nn_1_N = mkN "Kevlar" ;
  Kirunatrakt_nn_1_N = mkN "Kirunatrakt" ;
  Kleopatragestalt_nn_1_N = mkN "Kleopatragestalt" ;
  Kramforstrakt_nn_1_N = mkN "Kramforstrakt" ;
  LKAB_konflikt_nn_1_N = mkN "LKAB-konflikt" ;
  Mellanoesternkonflikt_nn_1_1_N = mkN "Mellanösternkonflikt" ;
  Melodifestival_nn_1_N = mkN "Melodifestival" ;
  Miljoefoervaltning_nn_1_1_N = mkN "Miljöförvaltning" ;
  Mississippiflod_nn_1_N = mkN "Mississippiflod" ;
  Missouriflod_nn_1_N = mkN "Missouriflod" ;
  Moskvatrogenhet_nn_1_N = mkN "Moskvatrogenhet" ;
  Moskvavaenlighet_nn_1_1_N = mkN "Moskvavänlighet" ;
  Newcastlesjuka_nn_1_N = mkN "Newcastlesjuka" ;
  Newcastlesmitta_nn_1_N = mkN "Newcastlesmitta" ;
  Sheratonstil_nn_1_N = mkN "Sheratonstil" ;
  Sir_nn_1_N = mkN "Sir" ;
  Skolinspektion_nn_1_N = mkN "Skolinspektion" ;
  Stockholmsboers_nn_1_1_N = mkN "Stockholmsbörs" ;
  Stockholmsregion_nn_1_N = mkN "Stockholmsregion" ;
  Stockholmstrakt_nn_1_N = mkN "Stockholmstrakt" ;
  Straalsaekerhetsmyndighet_nn_1_1_N = mkN "Strålsäkerhetsmyndighet" ;
  T_sprit_nn_1_N = mkN "T-sprit" ;
  TV_reklam_nn_1_N = mkN "TV-reklam" ;
  Tokyoboers_nn_1_1_N = mkN "Tokyobörs" ;
  USA_vaenlighet_nn_1_1_N = mkN "USA-vänlighet" ;
  Vaxholmskonflikt_nn_1_N = mkN "Vaxholmskonflikt" ;
  Vietnampolitik_nn_1_N = mkN "Vietnampolitik" ;
  Vaerldsbank_nn_1_1_N = mkN "Världsbank" ;
  Vaerldsnaturfond_nn_1_1_N = mkN "Världsnaturfond" ;
  Vaexjoetrakt_nn_1_1_N = mkN "Växjötrakt" ;
  abandon_nn_1_N = mkN "abandon" ;
  abstinens_nn_1_N = mkN "abstinens" ;
  abundans_nn_1_N = mkN "abundans" ;
  acetylengas_nn_1_N = mkN "acetylengas" ;
  ackordshets_nn_1_N = mkN "ackordshets" ;
  ackuratess_nn_1_N = mkN "ackuratess" ;
  action_nn_1_N = mkN "action" ;
  adelskultur_nn_1_N = mkN "adelskultur" ;
  administratoersstatus_nn_1_1_N = mkN "administratörsstatus" ;
  adolescens_nn_1_N = mkN "adolescens" ;
  aerodynamik_nn_1_N = mkN "aerodynamik" ;
  aeronautik_nn_1_N = mkN "aeronautik" ;
  affaersmoral_nn_1_1_N = mkN "affärsmoral" ;
  ag_nn_1_N = mkN "ag" ;
  aga_nn_1_N = mkN "aga" ;
  agnrost_nn_1_N = mkN "agnrost" ;
  agrikultur_nn_1_N = mkN "agrikultur" ;
  aids_nn_1_N = mkN "aids" ;
  aikido_nn_1_N = mkN "aikido" ;
  akrobatik_nn_1_N = mkN "akrobatik" ;
  akryl_nn_1_N = mkN "akryl" ;
  aktualism_nn_1_N = mkN "aktualism" ;
  aktualitetspress_nn_1_N = mkN "aktualitetspress" ;
  akupunktur_nn_1_N = mkN "akupunktur" ;
  akustik_nn_1_N = mkN "akustik" ;
  akvaristik_nn_1_N = mkN "akvaristik" ;
  alabaster_nn_1_N = mkN "alabaster" ;
  alarmism_nn_1_N = mkN "alarmism" ;
  alcantara_nn_1_N = mkN "alcantara" ;
  alfalfa_nn_1_N = mkN "alfalfa" ;
  alkoholpolitik_nn_1_N = mkN "alkoholpolitik" ;
  allfader_nn_1_N = mkN "allfader" ;
  allmaenanda_nn_1_1_N = mkN "allmänanda" ;
  almsav_nn_1_N = mkN "almsav" ;
  almsjuka_nn_1_N = mkN "almsjuka" ;
  alpacka_nn_2_N = mkN "alpacka" ;
  alsikekloever_nn_1_1_N = mkN "alsikeklöver" ;
  alunit_nn_1_N = mkN "alunit" ;
  alv_nn_1_N = mkN "alv" ;
  alzheimer_nn_1_N = mkN "alzheimer" ;
  ambivalens_nn_1_N = mkN "ambivalens" ;
  ambra_nn_1_N = mkN "ambra" ;
  ambrosia_nn_1_N = mkN "ambrosia" ;
  ambulanspersonal_nn_1_N = mkN "ambulanspersonal" ;
  ammoniak_nn_1_N = mkN "ammoniak" ;
  ammoniumklorid_nn_1_N = mkN "ammoniumklorid" ;
  analeptik_nn_1_N = mkN "analeptik" ;
  and_nn_2_N = mkN "and" ;
  anda_nn_1_N = mkN "anda" ;
  andaktslitteratur_nn_1_N = mkN "andaktslitteratur" ;
  andtaeppa_nn_1_1_N = mkN "andtäppa" ;
  angostura_nn_1_N = mkN "angostura" ;
  anis_nn_1_N = mkN "anis" ;
  ankism_nn_1_N = mkN "ankism" ;
  annatto_nn_1_N = mkN "annatto" ;
  anorexihets_nn_1_N = mkN "anorexihets" ;
  ans_nn_1_N = mkN "ans" ;
  anstoet_nn_1_1_N = mkN "anstöt" ;
  ansvarskaensla_nn_1_1_N = mkN "ansvarskänsla" ;
  antabus_nn_1_N = mkN "antabus" ;
  antibiotikaresistens_nn_1_N = mkN "antibiotikaresistens" ;
  antietablissemangsretorik_nn_1_N = mkN "antietablissemangsretorik" ;
  antik_nn_1_N = mkN "antik" ;
  antikrist_nn_1_N = mkN "antikrist" ;
  antikva_nn_1_N = mkN "antikva" ;
  antimonglans_nn_1_N = mkN "antimonglans" ;
  antiseptik_nn_1_N = mkN "antiseptik" ;
  antracit_nn_1_N = mkN "antracit" ;
  anus_nn_1_N = mkN "anus" ;
  apartheid_nn_1_N = mkN "apartheid" ;
  apatit_nn_1_N = mkN "apatit" ;
  aplomb_nn_1_N = mkN "aplomb" ;
  apologetik_nn_1_N = mkN "apologetik" ;
  april_nn_1_N = mkN "april" ;
  aptit_nn_1_N = mkN "aptit" "aptiter" ;
  arbetsbrist_nn_1_N = mkN "arbetsbrist" ;
  arbetsiver_nn_1_N = mkN "arbetsiver" ;
  arbetslust_nn_1_N = mkN "arbetslust" ;
  arbetsmarknadspolitik_nn_1_N = mkN "arbetsmarknadspolitik" ;
  arbetsmarknadsstatistik_nn_1_N = mkN "arbetsmarknadsstatistik" ;
  arbetsro_nn_1_N = mkN "arbetsro" ;
  argot_nn_1_N = mkN "argot" ;
  argumentationsanalys_nn_1_N = mkN "argumentationsanalys" ;
  aritmetik_nn_1_N = mkN "aritmetik" ;
  ark_nn_2_N = mkN "ark" ;
  arkitektonik_nn_1_N = mkN "arkitektonik" ;
  arkitekturpolitik_nn_1_N = mkN "arkitekturpolitik" ;
  armagnac_nn_1_N = mkN "armagnac" ;
  arrak_nn_1_N = mkN "arrak" ;
  arrakpunch_nn_1_N = mkN "arrakpunch" ;
  arrakpunsch_nn_1_N = mkN "arrakpunsch" ;
  arrogans_nn_1_N = mkN "arrogans" ;
  arsenik_nn_1_N = mkN "arsenik" ;
  asbest_nn_1_N = mkN "asbest" ;
  asbestos_nn_1_N = mkN "asbestos" ;
  aseptik_nn_1_N = mkN "aseptik" ;
  askes_nn_1_N = mkN "askes" ;
  astat_nn_1_N = mkN "astat" ;
  astma_nn_1_N = mkN "astma" ;
  astrofysik_nn_1_N = mkN "astrofysik" ;
  atomfysik_nn_1_N = mkN "atomfysik" ;
  atomkraft_nn_1_N = mkN "atomkraft" ;
  attan_nn_1_N = mkN "attan" ;
  aubergin_nn_1_N = mkN "aubergin" ;
  augusti_nn_1_N = mkN "augusti" ;
  aura_nn_1_N = mkN "aura" ;
  automatik_nn_1_N = mkN "automatik" ;
  avdrift_nn_1_N = mkN "avdrift" ;
  avfoeda_nn_1_1_N = mkN "avföda" ;
  avglans_nn_1_N = mkN "avglans" ;
  aviatik_nn_1_N = mkN "aviatik" ;
  avkomst_nn_1_N = mkN "avkomst" ;
  avrad_nn_1_N = mkN "avrad" ;
  avskraeckningspolitik_nn_1_1_N = mkN "avskräckningspolitik" ;
  avund_nn_1_N = mkN "avund" ;
  avundsjuka_nn_1_N = mkN "avundsjuka" ;
  axsvingel_nn_1_N = mkN "axsvingel" ;
  ayahuasca_nn_1_N = mkN "ayahuasca" ;
  azimut_nn_1_N = mkN "azimut" ;
  baccarat_nn_1_N = mkN "baccarat" ;
  backanis_nn_1_N = mkN "backanis" ;
  backhand_nn_1_N = mkN "backhand" ;
  backpacking_nn_1_N = mkN "backpacking" ;
  backtimjan_nn_1_N = mkN "backtimjan" ;
  bakelit_nn_1_N = mkN "bakelit" ;
  bakgrundsmusik_nn_1_N = mkN "bakgrundsmusik" ;
  baksidesreklam_nn_1_N = mkN "baksidesreklam" ;
  balata_nn_1_N = mkN "balata" ;
  ballistik_nn_1_N = mkN "ballistik" ;
  bambu_nn_1_N = mkN "bambu" ;
  bane_nn_1_N = mkN "bane" ;
  bangolf_nn_1_N = mkN "bangolf" ;
  banverkspersonal_nn_1_N = mkN "banverkspersonal" ;
  barfrost_nn_1_N = mkN "barfrost" ;
  barnfetma_nn_1_N = mkN "barnfetma" ;
  barnporr_nn_1_N = mkN "barnporr" ;
  barnsaengsfeber_nn_1_1_N = mkN "barnsängsfeber" ;
  barock_nn_1_N = mkN "barock" ;
  barocklyrik_nn_1_N = mkN "barocklyrik" ;
  barockmusik_nn_1_N = mkN "barockmusik" ;
  baryt_nn_1_N = mkN "baryt" ;
  basalt_nn_1_N = mkN "basalt" ;
  baseball_nn_1_N = mkN "baseball" ;
  baseboll_nn_1_N = mkN "baseboll" ;
  basedow_nn_1_N = mkN "basedow" ;
  basfoeda_nn_1_1_N = mkN "basföda" ;
  basis_nn_1_N = mkN "basis" ;
  basket_nn_1_N = mkN "basket" ;
  basketboll_nn_1_N = mkN "basketboll" ;
  batik_nn_1_N = mkN "batik" ;
  batteridrift_nn_1_N = mkN "batteridrift" ;
  batterield_nn_1_N = mkN "batterield" ;
  batteriradio_nn_1_N = mkN "batteriradio" ;
  bauxit_nn_1_N = mkN "bauxit" ;
  bebop_nn_1_N = mkN "bebop" ;
  becherovka_nn_1_N = mkN "becherovka" ;
  befolkningspolitik_nn_1_N = mkN "befolkningspolitik" ;
  befolkningstillvaext_nn_1_1_N = mkN "befolkningstillväxt" ;
  befaestningskonst_nn_1_1_N = mkN "befästningskonst" ;
  behagsjuka_nn_1_N = mkN "behagsjuka" ;
  beige_nn_1_N = mkN "beige" ;
  belladonna_nn_1_N = mkN "belladonna" ;
  bellit_nn_1_N = mkN "bellit" ;
  belaegringskonst_nn_1_1_N = mkN "belägringskonst" ;
  benjamin_nn_1_N = mkN "benjamin" ;
  bensin_nn_1_N = mkN "bensin" ;
  bensinbrist_nn_1_N = mkN "bensinbrist" ;
  bensol_nn_1_N = mkN "bensol" ;
  bentuberkulos_nn_1_N = mkN "bentuberkulos" ;
  bentyl_nn_1_N = mkN "bentyl" ;
  benved_nn_1_N = mkN "benved" ;
  berberis_nn_1_N = mkN "berberis" ;
  besick_nn_1_N = mkN "besick" ;
  beska_nn_1_N = mkN "beska" ;
  beskaellaresjuka_nn_1_1_N = mkN "beskällaresjuka" ;
  beskaellarsjuka_nn_1_1_N = mkN "beskällarsjuka" ;
  beslutsaangest_nn_1_1_N = mkN "beslutsångest" ;
  betel_nn_1_N = mkN "betel" ;
  betygshets_nn_1_N = mkN "betygshets" ;
  betygsstress_nn_1_N = mkN "betygsstress" ;
  bibelkritik_nn_1_N = mkN "bibelkritik" ;
  bilbingo_nn_1_N = mkN "bilbingo" ;
  bilbransch_nn_1_N = mkN "bilbransch" ;
  bildhuggarkonst_nn_1_N = mkN "bildhuggarkonst" ;
  bildningstoerst_nn_1_1_N = mkN "bildningstörst" ;
  bildradio_nn_1_N = mkN "bildradio" ;
  bildskaerpa_nn_1_1_N = mkN "bildskärpa" ;
  biltrafik_nn_1_N = mkN "biltrafik" ;
  bingo_nn_1_N = mkN "bingo" ;
  bio_nn_1_N = mkN "bio" ;
  biodynamik_nn_1_N = mkN "biodynamik" ;
  biofysik_nn_1_N = mkN "biofysik" ;
  biogenes_nn_1_N = mkN "biogenes" ;
  biografpublik_nn_1_N = mkN "biografpublik" ;
  biomedicin_nn_1_N = mkN "biomedicin" ;
  biorytm_nn_1_N = mkN "biorytm" ;
  bisam_nn_1_N = mkN "bisam" ;
  bischoff_nn_1_N = mkN "bischoff" ;
  biskoetsel_nn_1_1_N = mkN "biskötsel" ;
  bison_nn_1_N = mkN "bison" ;
  bistaandspolitik_nn_1_1_N = mkN "biståndspolitik" ;
  bjaellerklang_nn_1_1_N = mkN "bjällerklang" ;
  bjoerkgraens_nn_1_1_N = mkN "björkgräns" ;
  bjoerksav_nn_1_1_N = mkN "björksav" ;
  bjoernmossa_nn_1_1_N = mkN "björnmossa" ;
  bladkaal_nn_1_1_N = mkN "bladkål" ;
  bladmetall_nn_1_N = mkN "bladmetall" ;
  bladrullsjuka_nn_1_N = mkN "bladrullsjuka" ;
  blandsaed_nn_1_1_N = mkN "blandsäd" ;
  blankis_nn_1_N = mkN "blankis" ;
  blanksvaerta_nn_1_1_N = mkN "blanksvärta" ;
  blankvers_nn_1_N = mkN "blankvers" ;
  blast_nn_1_N = mkN "blast" ;
  blastula_nn_1_N = mkN "blastula" ;
  bleckmusik_nn_1_N = mkN "bleckmusik" ;
  blixthalka_nn_1_N = mkN "blixthalka" ;
  blockchoklad_nn_1_N = mkN "blockchoklad" ;
  blockpolitik_nn_1_N = mkN "blockpolitik" ;
  blodbrist_nn_1_N = mkN "blodbrist" ;
  blodcancer_nn_1_N = mkN "blodcancer" ;
  blodfoerlust_nn_1_1_N = mkN "blodförlust" ;
  blodhosta_nn_1_N = mkN "blodhosta" ;
  blodkraefta_nn_1_1_N = mkN "blodkräfta" ;
  blodsmystik_nn_1_N = mkN "blodsmystik" ;
  blodsaenka_nn_1_1_N = mkN "blodsänka" ;
  blodtoerst_nn_1_1_N = mkN "blodtörst" ;
  blomkaal_nn_1_1_N = mkN "blomkål" ;
  blomst_nn_1_N = mkN "blomst" ;
  blomvass_nn_1_N = mkN "blomvass" ;
  blues_nn_1_N = mkN "blues" ;
  blund_nn_1_N = mkN "blund" ;
  blygd_nn_1_N = mkN "blygd" ;
  blyglans_nn_1_N = mkN "blyglans" ;
  blygsel_nn_1_N = mkN "blygsel" ;
  blymoenja_nn_1_1_N = mkN "blymönja" ;
  blysalva_nn_1_N = mkN "blysalva" ;
  blytetraetyl_nn_1_N = mkN "blytetraetyl" ;
  blyaettika_nn_1_1_N = mkN "blyättika" ;
  blaabaerssoppa_nn_1_1_N = mkN "blåbärssoppa" ;
  blaaeld_nn_1_1_N = mkN "blåeld" ;
  blaais_nn_1_1_N = mkN "blåis" ;
  blaakaal_nn_1_1_N = mkN "blåkål" ;
  blaalera_nn_1_1_N = mkN "blålera" ;
  blaasjuka_nn_1_1_N = mkN "blåsjuka" ;
  blaast_nn_1_1_N = mkN "blåst" ;
  blaataatel_nn_1_1_N = mkN "blåtåtel" ;
  blaaved_nn_1_1_N = mkN "blåved" ;
  bloedarsjuka_nn_1_1_N = mkN "blödarsjuka" ;
  bloeta_nn_1_1_N = mkN "blöta" ;
  bloetsnoe_nn_1_1_N = mkN "blötsnö" ;
  board_nn_1_N = mkN "board" ;
  boccia_nn_1_N = mkN "boccia" ;
  bockhornskloever_nn_1_1_N = mkN "bockhornsklöver" ;
  bokmakulatur_nn_1_N = mkN "bokmakulatur" ;
  bokstavsmystik_nn_1_N = mkN "bokstavsmystik" ;
  boktryckarkonst_nn_1_N = mkN "boktryckarkonst" ;
  bomullstrikaa_nn_1_1_N = mkN "bomullstrikå" ;
  bondkomik_nn_1_N = mkN "bondkomik" ;
  bondaanger_nn_1_1_N = mkN "bondånger" ;
  bor_nn_1_N = mkN "bor" ;
  borax_nn_1_N = mkN "borax" ;
  bordtennis_nn_1_N = mkN "bordtennis" ;
  borgarpress_nn_1_N = mkN "borgarpress" ;
  borgis_nn_1_N = mkN "borgis" ;
  bornyr_nn_1_N = mkN "bornyr" ;
  borsjtj_nn_1_N = mkN "borsjtj" ;
  bortavaro_nn_1_N = mkN "bortavaro" ;
  bortovaro_nn_1_N = mkN "bortovaro" ;
  bortsida_nn_1_N = mkN "bortsida" ;
  boskapsdrift_nn_1_N = mkN "boskapsdrift" ;
  boskapspest_nn_1_N = mkN "boskapspest" ;
  boskapsskoetsel_nn_1_1_N = mkN "boskapsskötsel" ;
  bostadsbrist_nn_1_N = mkN "bostadsbrist" ;
  bostadspolitik_nn_1_N = mkN "bostadspolitik" ;
  boston_nn_1_N = mkN "boston" ;
  bot_nn_1_N = mkN "bot" ;
  botanik_nn_1_N = mkN "botanik" ;
  bottenis_nn_1_N = mkN "bottenis" ;
  bottenmoraen_nn_1_1_N = mkN "bottenmorän" ;
  boulevardpress_nn_1_N = mkN "boulevardpress" ;
  bourbon_nn_1_N = mkN "bourbon" ;
  bowling_nn_1_N = mkN "bowling" ;
  brakved_nn_1_N = mkN "brakved" ;
  brandfara_nn_1_N = mkN "brandfara" ;
  bravur_nn_1_N = mkN "bravur" ;
  bredsaadd_nn_1_1_N = mkN "bredsådd" ;
  bresilja_nn_1_N = mkN "bresilja" ;
  brevcensur_nn_1_N = mkN "brevcensur" ;
  briljans_nn_1_N = mkN "briljans" ;
  brilliant_nn_1_N = mkN "brilliant" ;
  brio_nn_1_N = mkN "brio" ;
  bristningsgraens_nn_1_1_N = mkN "bristningsgräns" ;
  britanniametall_nn_1_N = mkN "britanniametall" ;
  brom_nn_1_N = mkN "brom" ;
  bromsservo_nn_1_N = mkN "bromsservo" ;
  bromyl_nn_1_N = mkN "bromyl" ;
  bronkialastma_nn_1_N = mkN "bronkialastma" ;
  brottsjournalistik_nn_1_N = mkN "brottsjournalistik" ;
  brottskonkurrens_nn_1_N = mkN "brottskonkurrens" ;
  brudmystik_nn_1_N = mkN "brudmystik" ;
  brukskonst_nn_1_N = mkN "brukskonst" ;
  brunkaal_nn_1_1_N = mkN "brunkål" ;
  brunockra_nn_1_N = mkN "brunockra" ;
  brunrost_nn_1_N = mkN "brunrost" ;
  brunst_nn_1_N = mkN "brunst" ;
  bryggdans_nn_1_N = mkN "bryggdans" ;
  bryggerijaest_nn_1_1_N = mkN "bryggerijäst" ;
  bryggjaest_nn_1_1_N = mkN "bryggjäst" ;
  brysselkaal_nn_1_1_N = mkN "brysselkål" ;
  brytningsgraens_nn_1_1_N = mkN "brytningsgräns" ;
  braenslebrist_nn_1_1_N = mkN "bränslebrist" ;
  braadska_nn_1_1_N = mkN "brådska" ;
  broedfoeda_nn_1_1_N = mkN "brödföda" ;
  broedsaed_nn_1_1_N = mkN "brödsäd" ;
  broedtext_nn_1_1_N = mkN "brödtext" ;
  broestmjoelk_nn_1_1_N = mkN "bröstmjölk" ;
  buckram_nn_1_N = mkN "buckram" ;
  budgetdisciplin_nn_1_N = mkN "budgetdisciplin" ;
  budgetpolitik_nn_1_N = mkN "budgetpolitik" ;
  budo_nn_1_N = mkN "budo" ;
  bugg_nn_1_N = mkN "bugg" ;
  bukfetma_nn_1_N = mkN "bukfetma" ;
  bukfylla_nn_1_N = mkN "bukfylla" ;
  bulk_nn_1_N = mkN "bulk" ;
  bush_nn_1_N = mkN "bush" ;
  buskis_nn_1_N = mkN "buskis" ;
  buskteater_nn_1_N = mkN "buskteater" ;
  busstrafik_nn_1_N = mkN "busstrafik" ;
  butanol_nn_1_N = mkN "butanol" ;
  butylalkohol_nn_1_N = mkN "butylalkohol" ;
  byggnadskonst_nn_1_N = mkN "byggnadskonst" ;
  bytesbalans_nn_1_N = mkN "bytesbalans" ;
  byxaangest_nn_1_1_N = mkN "byxångest" ;
  baeltros_nn_1_1_N = mkN "bältros" ;
  baenkpress_nn_1_1_N = mkN "bänkpress" ;
  baerkraft_nn_1_1_N = mkN "bärkraft" ;
  baestsaeljarism_nn_1_1_N = mkN "bästsäljarism" ;
  baattrafik_nn_1_1_N = mkN "båttrafik" ;
  boeldpest_nn_1_1_N = mkN "böldpest" ;
  calypso_nn_1_N = mkN "calypso" ;
  camembert_nn_1_N = mkN "camembert" ;
  canasta_nn_1_N = mkN "canasta" ;
  cancan_nn_1_N = mkN "cancan" ;
  cannabis_nn_1_N = mkN "cannabis" ;
  casting_nn_1_N = mkN "casting" ;
  catering_nn_1_N = mkN "catering" ;
  cateringbransch_nn_1_N = mkN "cateringbransch" ;
  catgut_nn_1_N = mkN "catgut" ;
  celebritetsjournalistik_nn_1_N = mkN "celebritetsjournalistik" ;
  cellini_nn_1_N = mkN "cellini" ;
  cellulas_nn_1_N = mkN "cellulas" ;
  celluloid_nn_1_N = mkN "celluloid" ;
  cellulosa_nn_1_N = mkN "cellulosa" ;
  cellulosavadd_nn_1_N = mkN "cellulosavadd" ;
  celsiusskala_nn_1_N = mkN "celsiusskala" ;
  censur_nn_1_N = mkN "censur" ;
  centercourt_nn_1_N = mkN "centercourt" ;
  centrallyrik_nn_1_N = mkN "centrallyrik" ;
  centralradio_nn_1_N = mkN "centralradio" ;
  centrecourt_nn_1_N = mkN "centrecourt" ;
  cha_cha_nn_1_N = mkN "cha-cha" ;
  chark_nn_1_N = mkN "chark" ;
  charleston_nn_1_N = mkN "charleston" ;
  charm_nn_1_N = mkN "charm" ;
  charta_nn_1_N = mkN "charta" ;
  charter_nn_1_N = mkN "charter" ;
  cherimoya_nn_1_N = mkN "cherimoya" ;
  chevreau_nn_1_N = mkN "chevreau" ;
  chilesalpeter_nn_1_N = mkN "chilesalpeter" ;
  chilisaas_nn_1_1_N = mkN "chilisås" ;
  chimping_nn_1_N = mkN "chimping" ;
  chintz_nn_1_N = mkN "chintz" ;
  cicero_nn_1_N = mkN "cicero" ;
  cider_nn_1_N = mkN "cider" ;
  cikoria_nn_1_N = mkN "cikoria" ;
  cinnober_nn_1_N = mkN "cinnober" ;
  cirrus_nn_1_N = mkN "cirrus" ;
  citronmeliss_nn_1_N = mkN "citronmeliss" ;
  citronsorbet_nn_1_N = mkN "citronsorbet" ;
  civilfoersvarspersonal_nn_1_1_N = mkN "civilförsvarspersonal" ;
  clearing_nn_1_N = mkN "clearing" ;
  clinch_nn_1_N = mkN "clinch" ;
  clou_nn_1_N = mkN "clou" ;
  cocktailmusik_nn_1_N = mkN "cocktailmusik" ;
  cointreau_nn_1_N = mkN "cointreau" ;
  coitus_nn_1_N = mkN "coitus" ;
  consensus_nn_1_N = mkN "consensus" ;
  copyright_nn_1_N = mkN "copyright" ;
  cortex_nn_1_N = mkN "cortex" ;
  cotangens_nn_1_N = mkN "cotangens" ;
  countrymusik_nn_1_N = mkN "countrymusik" "countrymusiker" ;
  crawl_nn_1_N = mkN "crawl" ;
  cred_nn_1_N = mkN "cred" ;
  credd_nn_1_N = mkN "credd" ;
  creme_nn_2_N = mkN "creme" ;
  cricket_nn_1_N = mkN "cricket" ;
  crust_nn_1_N = mkN "crust" ;
  cre_me_nn_2_1_N = mkN "crème" ;
  csardas_nn_1_N = mkN "csardas" ;
  curacao_nn_1_1_N = mkN "curaçao" ;
  curling_nn_1_N = mkN "curling" ;
  cyanos_nn_1_N = mkN "cyanos" ;
  cybernetik_nn_1_N = mkN "cybernetik" ;
  cyklamat_nn_1_N = mkN "cyklamat" ;
  dagg_nn_1_N = mkN "dagg" ;
  dagsmeja_nn_1_N = mkN "dagsmeja" ;
  dagspress_nn_1_N = mkN "dagspress" ;
  dalskida_nn_1_N = mkN "dalskida" ;
  damslalom_nn_1_N = mkN "damslalom" ;
  dansmusik_nn_1_N = mkN "dansmusik" ;
  danssjuka_nn_1_N = mkN "danssjuka" ;
  dart_nn_1_N = mkN "dart" ;
  datakraft_nn_1_N = mkN "datakraft" ;
  datalingvistik_nn_1_N = mkN "datalingvistik" ;
  datapolitik_nn_1_N = mkN "datapolitik" ;
  datavision_nn_1_N = mkN "datavision" ;
  datordrift_nn_1_N = mkN "datordrift" ;
  datorlingvistik_nn_1_N = mkN "datorlingvistik" ;
  datten_nn_1_N = mkN "datten" ;
  december_nn_1_N = mkN "december" ;
  defensiv_nn_1_N = mkN "defensiv" ;
  deg_nn_2_N = mkN "deg" ;
  dekadans_nn_1_N = mkN "dekadans" ;
  dekadens_nn_1_N = mkN "dekadens" ;
  dekalog_nn_1_N = mkN "dekalog" ;
  dekanus_nn_1_N = mkN "dekanus" ;
  dekorglans_nn_1_N = mkN "dekorglans" ;
  dekorputs_nn_1_N = mkN "dekorputs" ;
  demens_nn_1_N = mkN "demens" ;
  demi_sec_nn_1_N = mkN "demi-sec" ;
  descendens_nn_1_N = mkN "descendens" ;
  design_nn_1_N = mkN "design" ;
  detaljskaerpa_nn_1_1_N = mkN "detaljskärpa" ;
  diagnostik_nn_1_N = mkN "diagnostik" ;
  dialektik_nn_1_N = mkN "dialektik" ;
  dialogpedagogik_nn_1_N = mkN "dialogpedagogik" ;
  diaspora_nn_1_N = mkN "diaspora" ;
  didaktik_nn_1_N = mkN "didaktik" ;
  dietetik_nn_1_N = mkN "dietetik" ;
  dietik_nn_1_N = mkN "dietik" ;
  digitalis_nn_1_N = mkN "digitalis" ;
  diktan_nn_1_N = mkN "diktan" ;
  diktkonst_nn_1_N = mkN "diktkonst" ;
  dill_nn_1_N = mkN "dill" ;
  dimfrost_nn_1_N = mkN "dimfrost" ;
  dioptrik_nn_1_N = mkN "dioptrik" ;
  diplomatik_nn_1_N = mkN "diplomatik" ;
  diplomatpost_nn_1_N = mkN "diplomatpost" ;
  dipmix_nn_1_N = mkN "dipmix" ;
  direktreklam_nn_1_N = mkN "direktreklam" ;
  disciplinstress_nn_1_N = mkN "disciplinstress" ;
  disco_nn_2_N = mkN "disco" ;
  discomusik_nn_1_N = mkN "discomusik" ;
  disko_nn_2_N = mkN "disko" ;
  diskomusik_nn_1_N = mkN "diskomusik" ;
  dixieland_nn_1_N = mkN "dixieland" ;
  djupkultur_nn_1_N = mkN "djupkultur" ;
  djurhaelsa_nn_1_1_N = mkN "djurhälsa" ;
  djurkrets_nn_1_N = mkN "djurkrets" ;
  djurmat_nn_1_N = mkN "djurmat" ;
  djurornamentik_nn_1_N = mkN "djurornamentik" ;
  djurskoetsel_nn_1_1_N = mkN "djurskötsel" ;
  dogmatik_nn_1_N = mkN "dogmatik" ;
  dominans_nn_1_N = mkN "dominans" ;
  domvaerjo_nn_1_1_N = mkN "domvärjo" ;
  don_nn_2_N = mkN "don" ;
  doping_nn_1_N = mkN "doping" ;
  dopplereffekt_nn_1_N = mkN "dopplereffekt" ;
  dragkraft_nn_1_N = mkN "dragkraft" ;
  dragracing_nn_1_N = mkN "dragracing" ;
  dragspelsmusik_nn_1_N = mkN "dragspelsmusik" ;
  dram_nn_1_N = mkN "dram" ;
  dramatik_nn_1_N = mkN "dramatik" ;
  drank_nn_1_N = mkN "drank" ;
  dricks_nn_1_N = mkN "dricks" ;
  drift_nn_1_N = mkN "drift" ;
  drivhuseffekt_nn_1_N = mkN "drivhuseffekt" ;
  drivis_nn_1_N = mkN "drivis" ;
  drivsand_nn_1_N = mkN "drivsand" ;
  drivsnoe_nn_1_1_N = mkN "drivsnö" ;
  drivved_nn_1_N = mkN "drivved" ;
  drygsel_nn_1_N = mkN "drygsel" ;
  draegg_nn_1_1_N = mkN "drägg" ;
  draell_nn_1_1_N = mkN "dräll" ;
  draetsel_nn_1_1_N = mkN "drätsel" ;
  droeppel_nn_1_1_N = mkN "dröppel" ;
  dualis_nn_1_N = mkN "dualis" ;
  dubbelmoral_nn_1_N = mkN "dubbelmoral" ;
  dubbeltimma_nn_1_N = mkN "dubbeltimma" ;
  dur_nn_1_N = mkN "dur" ;
  duvpolitik_nn_1_N = mkN "duvpolitik" ;
  dvala_nn_1_N = mkN "dvala" ;
  dvaergvaext_nn_1_1_N = mkN "dvärgväxt" ;
  dygnsvila_nn_1_N = mkN "dygnsvila" ;
  dykarsjuka_nn_1_N = mkN "dykarsjuka" ;
  dynamik_nn_1_N = mkN "dynamik" ;
  dynamit_nn_1_N = mkN "dynamit" ;
  dynga_nn_1_N = mkN "dynga" ;
  daeckglans_nn_1_1_N = mkN "däckglans" ;
  daan_nn_2_1_N = mkN "dån" ;
  doedis_nn_1_1_N = mkN "dödis" ;
  doedsjoe_nn_1_1_N = mkN "dödsjö" ;
  doedsmetal_nn_1_1_N = mkN "dödsmetal" ;
  doedsmetall_nn_1_1_N = mkN "dödsmetall" ;
  doedsskugga_nn_1_1_N = mkN "dödsskugga" ;
  doedsaangest_nn_1_1_N = mkN "dödsångest" ;
  e_mail_nn_1_N = mkN "e-mail" ;
  ebb_nn_1_N = mkN "ebb" ;
  ebonit_nn_1_N = mkN "ebonit" ;
  edelweiss_nn_1_N = mkN "edelweiss" ;
  efterglans_nn_1_N = mkN "efterglans" ;
  efterkultur_nn_1_N = mkN "efterkultur" ;
  eftermiddagstrafik_nn_1_N = mkN "eftermiddagstrafik" ;
  efterputs_nn_1_N = mkN "efterputs" ;
  eftervaext_nn_1_1_N = mkN "efterväxt" ;
  egard_nn_1_N = mkN "egard" ;
  egid_nn_1_N = mkN "egid" ;
  egyptienne_nn_1_N = mkN "egyptienne" ;
  ehec_nn_1_N = mkN "ehec" ;
  eidetik_nn_1_N = mkN "eidetik" ;
  ekliptika_nn_1_N = mkN "ekliptika" ;
  ekonomiklass_nn_1_N = mkN "ekonomiklass" ;
  ekonomipersonal_nn_1_N = mkN "ekonomipersonal" ;
  ekumenik_nn_1_N = mkN "ekumenik" ;
  ekvidistans_nn_1_N = mkN "ekvidistans" ;
  ekvilibristik_nn_1_N = mkN "ekvilibristik" ;
  ekvivalens_nn_1_N = mkN "ekvivalens" ;
  eld_nn_1_N = mkN "eld" ;
  eld_nn_3_N = mkN "eld" ;
  elddisciplin_nn_1_N = mkN "elddisciplin" ;
  eldfara_nn_1_N = mkN "eldfara" ;
  eldrift_nn_1_N = mkN "eldrift" ;
  elefantsjuka_nn_1_N = mkN "elefantsjuka" ;
  elegans_nn_1_N = mkN "elegans" ;
  elektroakustik_nn_1_N = mkN "elektroakustik" ;
  elektrodynamik_nn_1_N = mkN "elektrodynamik" ;
  elektrofores_nn_1_N = mkN "elektrofores" ;
  elektrofysik_nn_1_N = mkN "elektrofysik" ;
  elektronik_nn_1_N = mkN "elektronik" ;
  elektrostatik_nn_1_N = mkN "elektrostatik" ;
  elektroteknik_nn_1_N = mkN "elektroteknik" ;
  elementaranalys_nn_1_N = mkN "elementaranalys" ;
  elfenbenssvaerta_nn_1_1_N = mkN "elfenbenssvärta" ;
  elitgymnastik_nn_1_N = mkN "elitgymnastik" ;
  elmotordrift_nn_1_N = mkN "elmotordrift" ;
  elokvens_nn_1_N = mkN "elokvens" ;
  eloquentia_nn_1_N = mkN "eloquentia" ;
  elvaaarsgraens_nn_1_1_N = mkN "elvaårsgräns" ;
  email_nn_1_N = mkN "email" ;
  emblematik_nn_1_N = mkN "emblematik" ;
  embonpoint_nn_1_N = mkN "embonpoint" ;
  emfas_nn_1_N = mkN "emfas" ;
  emmentaler_nn_1_N = mkN "emmentaler" ;
  empir_nn_1_N = mkN "empir" ;
  energipolitik_nn_1_N = mkN "energipolitik" ;
  engaangsnatur_nn_1_1_N = mkN "engångsnatur" ;
  enhetsskola_nn_1_N = mkN "enhetsskola" ;
  enkeltimma_nn_1_N = mkN "enkeltimma" ;
  enmansteater_nn_1_N = mkN "enmansteater" ;
  entusiasm_nn_1_N = mkN "entusiasm" ;
  epigrafik_nn_1_N = mkN "epigrafik" ;
  epik_nn_1_N = mkN "epik" ;
  episkopalkyrka_nn_1_N = mkN "episkopalkyrka" ;
  erkaensla_nn_1_1_N = mkN "erkänsla" ;
  erotik_nn_1_N = mkN "erotik" ;
  esparto_nn_1_N = mkN "esparto" ;
  espresso_nn_1_N = mkN "espresso" ;
  esprit_nn_1_N = mkN "esprit" ;
  essens_nn_1_N = mkN "essens" ;
  essaeistik_nn_1_1_N = mkN "essäistik" ;
  estetik_nn_1_N = mkN "estetik" ;
  etanol_nn_1_N = mkN "etanol" ;
  etenplast_nn_1_N = mkN "etenplast" ;
  etik_nn_1_N = mkN "etik" ;
  etyl_nn_1_N = mkN "etyl" ;
  etylalkohol_nn_1_N = mkN "etylalkohol" ;
  eugenik_nn_1_N = mkN "eugenik" ;
  eukalyptus_nn_1_N = mkN "eukalyptus" ;
  euroislam_nn_1_N = mkN "euroislam" ;
  eurovaluta_nn_1_N = mkN "eurovaluta" ;
  evidens_nn_1_N = mkN "evidens" ;
  exeges_nn_1_N = mkN "exeges" ;
  exegetik_nn_1_N = mkN "exegetik" ;
  exil_nn_1_N = mkN "exil" ;
  exoftalmus_nn_1_N = mkN "exoftalmus" ;
  expertis_nn_1_N = mkN "expertis" ;
  exportsprit_nn_1_N = mkN "exportsprit" ;
  exspektans_nn_1_N = mkN "exspektans" ;
  extas_nn_1_N = mkN "extas" ;
  extrapersonal_nn_1_N = mkN "extrapersonal" ;
  extremhoeger_nn_1_1_N = mkN "extremhöger" ;
  extremvaenster_nn_1_1_N = mkN "extremvänster" ;
  facklitteratur_nn_1_N = mkN "facklitteratur" ;
  fackpress_nn_1_N = mkN "fackpress" ;
  factoring_nn_1_N = mkN "factoring" ;
  fading_nn_1_N = mkN "fading" ;
  faktur_nn_1_N = mkN "faktur" ;
  falerner_nn_1_N = mkN "falerner" ;
  fallandesjuka_nn_1_N = mkN "fallandesjuka" ;
  fallfara_nn_1_N = mkN "fallfara" ;
  falsett_nn_1_N = mkN "falsett" ;
  familjekaensla_nn_1_1_N = mkN "familjekänsla" ;
  familjepolitik_nn_1_N = mkN "familjepolitik" ;
  fanken_nn_1_N = mkN "fanken" ;
  fantastik_nn_1_N = mkN "fantastik" ;
  fartygstrafik_nn_1_N = mkN "fartygstrafik" ;
  fasen_nn_1_N = mkN "fasen" ;
  fasingen_nn_1_N = mkN "fasingen" ;
  faunistik_nn_1_N = mkN "faunistik" ;
  feberhetta_nn_1_N = mkN "feberhetta" ;
  februari_nn_1_N = mkN "februari" ;
  feedback_nn_1_N = mkN "feedback" ;
  femkort_nn_1_N = mkN "femkort" ;
  fetaost_nn_1_N = mkN "fetaost" ;
  fetma_nn_1_N = mkN "fetma" ;
  fiberoptik_nn_1_N = mkN "fiberoptik" ;
  fickparkerbarhet_nn_1_N = mkN "fickparkerbarhet" ;
  fiction_nn_1_N = mkN "fiction" ;
  figurlighet_nn_1_N = mkN "figurlighet" ;
  fikenhet_nn_1_N = mkN "fikenhet" ;
  fil_nn_3_N = mkN "fil" ;
  filerbarhet_nn_1_N = mkN "filerbarhet" ;
  filering_nn_2_N = mkN "filering" ;
  filler_nn_1_N = mkN "filler" ;
  filmatiserbarhet_nn_1_N = mkN "filmatiserbarhet" ;
  filmcensur_nn_1_N = mkN "filmcensur" ;
  filmjoelk_nn_1_1_N = mkN "filmjölk" ;
  filmmusik_nn_1_N = mkN "filmmusik" ;
  filtrerbarhet_nn_1_N = mkN "filtrerbarhet" ;
  finansierbarhet_nn_1_N = mkN "finansierbarhet" ;
  finanspolitik_nn_1_N = mkN "finanspolitik" ;
  finansraett_nn_1_1_N = mkN "finansrätt" ;
  fingerbarhet_nn_1_N = mkN "fingerbarhet" ;
  fingerfaerdighet_nn_1_1_N = mkN "fingerfärdighet" ;
  fingerkrok_nn_1_N = mkN "fingerkrok" ;
  fingertoppskaensla_nn_1_1_N = mkN "fingertoppskänsla" ;
  finhet_nn_1_N = mkN "finhet" ;
  finhyllthet_nn_1_N = mkN "finhyllthet" ;
  finjusterbarhet_nn_1_N = mkN "finjusterbarhet" ;
  finkalibrighet_nn_1_N = mkN "finkalibrighet" ;
  finkel_nn_1_N = mkN "finkel" ;
  finklaeddhet_nn_1_1_N = mkN "finkläddhet" ;
  finkornighet_nn_1_N = mkN "finkornighet" ;
  finkultur_nn_1_N = mkN "finkultur" ;
  finlandiserbarhet_nn_1_N = mkN "finlandiserbarhet" ;
  finmaskighet_nn_1_N = mkN "finmaskighet" ;
  finmat_nn_1_N = mkN "finmat" ;
  finmotorik_nn_1_N = mkN "finmotorik" ;
  finnighet_nn_1_N = mkN "finnighet" ;
  finputs_nn_1_N = mkN "finputs" ;
  finsprit_nn_1_N = mkN "finsprit" ;
  finstil_nn_1_N = mkN "finstil" ;
  finstaemdhet_nn_1_1_N = mkN "finstämdhet" ;
  fipplighet_nn_1_N = mkN "fipplighet" ;
  firn_nn_1_N = mkN "firn" ;
  fisfoernaemhet_nn_1_1_N = mkN "fisförnämhet" ;
  fiskdoed_nn_1_1_N = mkN "fiskdöd" ;
  fiskevaard_nn_1_1_N = mkN "fiskevård" ;
  fisklikhet_nn_1_N = mkN "fisklikhet" ;
  fisktomhet_nn_1_N = mkN "fisktomhet" ;
  fixerbarhet_nn_1_N = mkN "fixerbarhet" ;
  fixhet_nn_1_N = mkN "fixhet" ;
  fjantighet_nn_1_N = mkN "fjantighet" ;
  fjantstaempel_nn_1_1_N = mkN "fjantstämpel" ;
  fjompighet_nn_1_N = mkN "fjompighet" ;
  fjuttighet_nn_1_N = mkN "fjuttighet" ;
  fjaederlaetthet_nn_1_1_N = mkN "fjäderlätthet" ;
  fjaedervikt_nn_1_1_N = mkN "fjädervikt" ;
  fjaedringskapacitet_nn_1_1_N = mkN "fjädringskapacitet" ;
  fjaellighet_nn_1_1_N = mkN "fjällighet" ;
  fjaellikhet_nn_1_1_N = mkN "fjällikhet" ;
  fjaellnatur_nn_1_1_N = mkN "fjällnatur" ;
  fjaelluft_nn_1_1_N = mkN "fjälluft" ;
  fjaerhet_nn_1_1_N = mkN "fjärhet" ;
  fjaerilseffekt_nn_1_1_N = mkN "fjärilseffekt" ;
  fjaerrblockerbarhet_nn_1_1_N = mkN "fjärrblockerbarhet" ;
  fjaerrtrafik_nn_1_1_N = mkN "fjärrtrafik" ;
  fjaeskighet_nn_1_1_N = mkN "fjäskighet" ;
  flabbighet_nn_1_N = mkN "flabbighet" ;
  flackeld_nn_1_N = mkN "flackeld" ;
  flackhet_nn_1_N = mkN "flackhet" ;
  fladdrighet_nn_1_N = mkN "fladdrighet" ;
  flagg_nn_1_N = mkN "flagg" ;
  flaggduk_nn_1_N = mkN "flaggduk" ;
  flamberbarhet_nn_1_N = mkN "flamberbarhet" ;
  flammighet_nn_1_N = mkN "flammighet" ;
  flamsighet_nn_1_N = mkN "flamsighet" ;
  flamskhet_nn_1_N = mkN "flamskhet" ;
  flankerbarhet_nn_1_N = mkN "flankerbarhet" ;
  flaskbrist_nn_1_N = mkN "flaskbrist" ;
  flaskpost_nn_1_N = mkN "flaskpost" ;
  flathet_nn_1_N = mkN "flathet" ;
  flatterbarhet_nn_1_N = mkN "flatterbarhet" ;
  flaxighet_nn_1_N = mkN "flaxighet" ;
  flegma_nn_1_N = mkN "flegma" ;
  flekterbarhet_nn_1_N = mkN "flekterbarhet" ;
  flensost_nn_1_N = mkN "flensost" ;
  flercellighet_nn_1_N = mkN "flercellighet" ;
  flerspraakighet_nn_1_1_N = mkN "flerspråkighet" ;
  flerstaemmighet_nn_1_1_N = mkN "flerstämmighet" ;
  flertydighet_nn_1_N = mkN "flertydighet" ;
  flexibilitet_nn_1_N = mkN "flexibilitet" ;
  flickaktighet_nn_1_N = mkN "flickaktighet" ;
  flikighet_nn_1_N = mkN "flikighet" ;
  flimrighet_nn_1_N = mkN "flimrighet" ;
  flinkhet_nn_1_N = mkN "flinkhet" ;
  flint_nn_1_N = mkN "flint" ;
  flintskallighet_nn_1_N = mkN "flintskallighet" ;
  flirt_nn_1_N = mkN "flirt" ;
  flirtighet_nn_1_N = mkN "flirtighet" ;
  flisighet_nn_1_N = mkN "flisighet" ;
  flit_nn_1_N = mkN "flit" ;
  flockighet_nn_1_N = mkN "flockighet" ;
  floristik_nn_1_N = mkN "floristik" ;
  flotthet_nn_1_N = mkN "flotthet" ;
  flottighet_nn_1_N = mkN "flottighet" ;
  flugvikt_nn_1_N = mkN "flugvikt" ;
  fluidiserbarhet_nn_1_N = mkN "fluidiserbarhet" ;
  flummighet_nn_1_N = mkN "flummighet" ;
  flumpedagogik_nn_1_N = mkN "flumpedagogik" ;
  fluorerbarhet_nn_1_N = mkN "fluorerbarhet" ;
  fluorescens_nn_1_N = mkN "fluorescens" ;
  fluoriderbarhet_nn_1_N = mkN "fluoriderbarhet" ;
  flusspat_nn_1_N = mkN "flusspat" ;
  flyfotadhet_nn_1_N = mkN "flyfotadhet" ;
  flygbensin_nn_1_N = mkN "flygbensin" ;
  flygfaerdighet_nn_1_1_N = mkN "flygfärdighet" ;
  flygghet_nn_1_N = mkN "flygghet" ;
  flygpersonal_nn_1_N = mkN "flygpersonal" ;
  flygplansluft_nn_1_N = mkN "flygplansluft" ;
  flygpost_nn_1_N = mkN "flygpost" ;
  flygsand_nn_1_N = mkN "flygsand" ;
  flygsaekerhet_nn_1_1_N = mkN "flygsäkerhet" ;
  flygtrafik_nn_1_N = mkN "flygtrafik" ;
  flyhaenthet_nn_1_1_N = mkN "flyhänthet" ;
  flykt_nn_2_N = mkN "flykt" ;
  flyktfara_nn_1_N = mkN "flyktfara" ;
  flyktighet_nn_1_N = mkN "flyktighet" ;
  flyktingpolitik_nn_1_N = mkN "flyktingpolitik" ;
  flythjaelp_nn_1_1_N = mkN "flythjälp" ;
  flytjord_nn_1_N = mkN "flytjord" ;
  flytsand_nn_1_N = mkN "flytsand" ;
  flyttbarhet_nn_1_N = mkN "flyttbarhet" ;
  flyttlasspolitik_nn_1_N = mkN "flyttlasspolitik" ;
  flytungadhet_nn_1_N = mkN "flytungadhet" ;
  flaeckfeber_nn_1_1_N = mkN "fläckfeber" ;
  flaeckfrihet_nn_1_1_N = mkN "fläckfrihet" ;
  flaeckighet_nn_1_1_N = mkN "fläckighet" ;
  flaecktyfus_nn_1_1_N = mkN "fläcktyfus" ;
  flaedermaerg_nn_1_1_N = mkN "flädermärg" ;
  flaenghet_nn_1_1_N = mkN "flänghet" ;
  flaengighet_nn_1_1_N = mkN "flängighet" ;
  flaerd_nn_1_1_N = mkN "flärd" ;
  flaerdfrihet_nn_1_1_N = mkN "flärdfrihet" ;
  flaeskighet_nn_1_1_N = mkN "fläskighet" ;
  floertighet_nn_1_1_N = mkN "flörtighet" ;
  fnatt_nn_1_N = mkN "fnatt" ;
  fnissighet_nn_1_N = mkN "fnissighet" ;
  fnittrighet_nn_1_N = mkN "fnittrighet" ;
  fodersaed_nn_1_1_N = mkN "fodersäd" ;
  foglighet_nn_1_N = mkN "foglighet" ;
  fokuserbarhet_nn_1_N = mkN "fokuserbarhet" ;
  folierbarhet_nn_1_N = mkN "folierbarhet" ;
  folio_nn_1_N = mkN "folio" ;
  folkfoersoerjning_nn_1_1_N = mkN "folkförsörjning" ;
  folkhaelsa_nn_1_1_N = mkN "folkhälsa" ;
  folkilskenhet_nn_1_N = mkN "folkilskenhet" ;
  folkkonst_nn_1_N = mkN "folkkonst" ;
  folkloristik_nn_1_N = mkN "folkloristik" ;
  folkmakt_nn_1_N = mkN "folkmakt" ;
  folkmedicin_nn_1_N = mkN "folkmedicin" ;
  folkmusik_nn_1_N = mkN "folkmusik" ;
  folkrikhet_nn_1_N = mkN "folkrikhet" ;
  folkraett_nn_1_1_N = mkN "folkrätt" ;
  folkskygghet_nn_1_N = mkN "folkskygghet" ;
  folktandvaard_nn_1_1_N = mkN "folktandvård" ;
  folkteater_nn_1_N = mkN "folkteater" ;
  folktomhet_nn_1_N = mkN "folktomhet" ;
  folkton_nn_1_N = mkN "folkton" ;
  folktraengsel_nn_1_1_N = mkN "folkträngsel" ;
  folkundervisning_nn_1_N = mkN "folkundervisning" ;
  folkupplysning_nn_1_N = mkN "folkupplysning" ;
  folkvandringstid_nn_1_N = mkN "folkvandringstid" ;
  fonderbarhet_nn_1_N = mkN "fonderbarhet" ;
  fondmaeklarbransch_nn_1_1_N = mkN "fondmäklarbransch" ;
  fonetik_nn_1_N = mkN "fonetik" ;
  foniatrik_nn_1_N = mkN "foniatrik" ;
  forcerbarhet_nn_1_N = mkN "forcerbarhet" ;
  fordringsfullhet_nn_1_N = mkN "fordringsfullhet" ;
  forehand_nn_1_N = mkN "forehand" ;
  form_nn_3_N = mkN "form" ;
  formaliserbarhet_nn_1_N = mkN "formaliserbarhet" ;
  formbarhet_nn_1_N = mkN "formbarhet" ;
  formbundenhet_nn_1_N = mkN "formbundenhet" ;
  formerbarhet_nn_1_N = mkN "formerbarhet" ;
  formlighet_nn_1_N = mkN "formlighet" ;
  formloeshet_nn_1_1_N = mkN "formlöshet" ;
  formmaessighet_nn_1_1_N = mkN "formmässighet" ;
  formrikhet_nn_1_N = mkN "formrikhet" ;
  formsand_nn_1_N = mkN "formsand" ;
  formskoenhet_nn_1_1_N = mkN "formskönhet" ;
  formula_nn_1_N = mkN "formula" ;
  formulerbarhet_nn_1_N = mkN "formulerbarhet" ;
  fornforskning_nn_1_N = mkN "fornforskning" ;
  fornhet_nn_1_N = mkN "fornhet" ;
  fornkunskap_nn_1_N = mkN "fornkunskap" ;
  forskarvaerld_nn_1_1_N = mkN "forskarvärld" ;
  forskningspolitik_nn_1_N = mkN "forskningspolitik" ;
  fortfaerdighet_nn_1_1_N = mkN "fortfärdighet" ;
  fortgaang_nn_1_1_N = mkN "fortgång" ;
  fortvaro_nn_1_N = mkN "fortvaro" ;
  fosfaterbarhet_nn_1_N = mkN "fosfaterbarhet" ;
  fosforescens_nn_1_N = mkN "fosforescens" ;
  fossilbransch_nn_1_N = mkN "fossilbransch" ;
  fossilfoersaeljning_nn_1_1_N = mkN "fossilförsäljning" ;
  fossilgas_nn_1_N = mkN "fossilgas" ;
  fossiliserbarhet_nn_1_N = mkN "fossiliserbarhet" ;
  fosterjord_nn_1_N = mkN "fosterjord" ;
  fosterlandskaerlek_nn_1_1_N = mkN "fosterlandskärlek" ;
  fosterlaendskhet_nn_1_1_N = mkN "fosterländskhet" ;
  fosterstaellning_nn_1_1_N = mkN "fosterställning" ;
  fotboll_nn_1_N = mkN "fotboll" ;
  fotbollsfeber_nn_1_N = mkN "fotbollsfeber" ;
  fotograferbarhet_nn_1_N = mkN "fotograferbarhet" ;
  fotografik_nn_1_N = mkN "fotografik" ;
  fotokonst_nn_1_N = mkN "fotokonst" ;
  fotokopierbarhet_nn_1_N = mkN "fotokopierbarhet" ;
  fotostatkopierbarhet_nn_1_N = mkN "fotostatkopierbarhet" ;
  fotriktighet_nn_1_N = mkN "fotriktighet" ;
  fotsvett_nn_1_N = mkN "fotsvett" ;
  fottvagning_nn_1_N = mkN "fottvagning" ;
  fotvaenlighet_nn_1_1_N = mkN "fotvänlighet" ;
  fotvaard_nn_1_1_N = mkN "fotvård" ;
  foulard_nn_1_N = mkN "foulard" ;
  foxtrottakt_nn_1_N = mkN "foxtrottakt" ;
  fradga_nn_1_N = mkN "fradga" ;
  fragmenterbarhet_nn_1_N = mkN "fragmenterbarhet" ;
  fragmentering_nn_1_N = mkN "fragmentering" ;
  fragmentisering_nn_1_N = mkN "fragmentisering" ;
  fraktionerbarhet_nn_1_N = mkN "fraktionerbarhet" ;
  fraktur_nn_1_N = mkN "fraktur" ;
  framdrivning_nn_1_N = mkN "framdrivning" ;
  framfart_nn_1_N = mkN "framfart" ;
  framfusighet_nn_1_N = mkN "framfusighet" ;
  framgaangsrikhet_nn_1_1_N = mkN "framgångsrikhet" ;
  framkomst_nn_1_N = mkN "framkomst" ;
  framstegsanda_nn_1_N = mkN "framstegsanda" ;
  framstegsvaenlighet_nn_1_1_N = mkN "framstegsvänlighet" ;
  framstaellningskonst_nn_1_1_N = mkN "framställningskonst" ;
  framsynthet_nn_1_N = mkN "framsynthet" ;
  framtunghet_nn_1_N = mkN "framtunghet" ;
  framvaext_nn_1_1_N = mkN "framväxt" ;
  framaatanda_nn_1_1_N = mkN "framåtanda" ;
  franchising_nn_1_N = mkN "franchising" ;
  frangulabark_nn_1_N = mkN "frangulabark" ;
  frankerbarhet_nn_1_N = mkN "frankerbarhet" ;
  frankhet_nn_1_N = mkN "frankhet" ;
  fransighet_nn_1_N = mkN "fransighet" ;
  franskhet_nn_1_N = mkN "franskhet" ;
  franskspraakighet_nn_1_1_N = mkN "franskspråkighet" ;
  franskundervisning_nn_1_N = mkN "franskundervisning" ;
  fraserbarhet_nn_1_N = mkN "fraserbarhet" ;
  fredlighet_nn_1_N = mkN "fredlighet" ;
  fredloeshet_nn_1_1_N = mkN "fredlöshet" ;
  fredsplikt_nn_1_N = mkN "fredsplikt" ;
  fredsvaenlighet_nn_1_1_N = mkN "fredsvänlighet" ;
  frejd_nn_1_N = mkN "frejd" ;
  frejdighet_nn_1_N = mkN "frejdighet" ;
  frekvensmodulerbarhet_nn_1_N = mkN "frekvensmodulerbarhet" ;
  frekventerbarhet_nn_1_N = mkN "frekventerbarhet" ;
  fridfullhet_nn_1_N = mkN "fridfullhet" ;
  fridloeshet_nn_1_1_N = mkN "fridlöshet" ;
  fridsamhet_nn_1_N = mkN "fridsamhet" ;
  frifraesighet_nn_1_1_N = mkN "frifräsighet" ;
  frigaang_nn_1_1_N = mkN "frigång" ;
  frihetlighet_nn_1_N = mkN "frihetlighet" ;
  frihetstid_nn_1_N = mkN "frihetstid" ;
  frikostighet_nn_1_N = mkN "frikostighet" ;
  friktionsvaexling_nn_1_1_N = mkN "friktionsväxling" ;
  frilanstillvaro_nn_1_N = mkN "frilanstillvaro" ;
  frimodighet_nn_1_N = mkN "frimodighet" ;
  fris_nn_2_N = mkN "fris" ;
  friserbarhet_nn_1_N = mkN "friserbarhet" ;
  friskhet_nn_1_N = mkN "friskhet" ;
  friskluft_nn_1_N = mkN "friskluft" ;
  friskluftsventilation_nn_1_N = mkN "friskluftsventilation" ;
  frisksport_nn_1_N = mkN "frisksport" ;
  friskvaard_nn_1_1_N = mkN "friskvård" ;
  fristil_nn_1_N = mkN "fristil" ;
  friterbarhet_nn_1_N = mkN "friterbarhet" ;
  fritid_nn_1_N = mkN "fritid" "fritider"  ;
  fritidspolitik_nn_1_N = mkN "fritidspolitik" ;
  frivilligtjaenst_nn_1_1_N = mkN "frivilligtjänst" ;
  frivaard_nn_1_1_N = mkN "frivård" ;
  frodighet_nn_1_N = mkN "frodighet" ;
  fromhet_nn_2_N = mkN "fromhet" ;
  fromhetsiver_nn_1_N = mkN "fromhetsiver" ;
  fromsinthet_nn_1_N = mkN "fromsinthet" ;
  fronderbarhet_nn_1_N = mkN "fronderbarhet" ;
  frontnederboerd_nn_1_1_N = mkN "frontnederbörd" ;
  fronttjaenst_nn_1_1_N = mkN "fronttjänst" ;
  frost_nn_1_N = mkN "frost" ;
  frostighet_nn_1_N = mkN "frostighet" ;
  frosttaalighet_nn_1_1_N = mkN "frosttålighet" ;
  frotterbarhet_nn_1_N = mkN "frotterbarhet" ;
  fruktansvaerdhet_nn_1_1_N = mkN "fruktansvärdhet" ;
  fruktighet_nn_1_N = mkN "fruktighet" ;
  fruktloeshet_nn_1_1_N = mkN "fruktlöshet" ;
  fruktos_nn_1_N = mkN "fruktos" ;
  fruktsamhet_nn_1_N = mkN "fruktsamhet" ;
  fruktskorv_nn_1_N = mkN "fruktskorv" ;
  fruktved_nn_1_N = mkN "fruktved" ;
  fruntimmersvecka_nn_1_N = mkN "fruntimmersvecka" ;
  frusenhet_nn_1_N = mkN "frusenhet" ;
  frustrerbarhet_nn_1_N = mkN "frustrerbarhet" ;
  frystejp_nn_1_N = mkN "frystejp" ;
  frystaalighet_nn_1_1_N = mkN "frystålighet" ;
  fraeknighet_nn_1_1_N = mkN "fräknighet" ;
  fraelsthet_nn_1_1_N = mkN "frälsthet" ;
  fraemlingsfientlighet_nn_1_1_N = mkN "främlingsfientlighet" ;
  fraenhet_nn_1_1_N = mkN "fränhet" ;
  fraeschhet_nn_1_1_N = mkN "fräschhet" ;
  fraeschoer_nn_1_1_N = mkN "fräschör" ;
  fraagvishet_nn_1_1_N = mkN "frågvishet" ;
  fraandockning_nn_1_1_N = mkN "fråndockning" ;
  fraanskiljning_nn_1_1_N = mkN "frånskiljning" ;
  fraanvaro_nn_1_1_N = mkN "frånvaro" ;
  froejdefullhet_nn_1_1_N = mkN "fröjdefullhet" ;
  fugu_nn_1_N = mkN "fugu" ;
  fukt_nn_1_N = mkN "fukt" ;
  fullfoeljd_nn_1_1_N = mkN "fullföljd" ;
  fullgodhet_nn_1_N = mkN "fullgodhet" ;
  fullgaangenhet_nn_1_1_N = mkN "fullgångenhet" ;
  fullhet_nn_1_N = mkN "fullhet" ;
  fullmogenhet_nn_1_N = mkN "fullmogenhet" ;
  fullproppning_nn_1_N = mkN "fullproppning" ;
  fullskalighet_nn_1_N = mkN "fullskalighet" ;
  fullstaemmighet_nn_1_1_N = mkN "fullstämmighet" ;
  fulltalighet_nn_1_N = mkN "fulltalighet" ;
  fulltonighet_nn_1_N = mkN "fulltonighet" ;
  fullvuxenhet_nn_1_N = mkN "fullvuxenhet" ;
  fullvaerdighet_nn_1_1_N = mkN "fullvärdighet" ;
  fulsnygghet_nn_1_N = mkN "fulsnygghet" ;
  fundersamhet_nn_1_N = mkN "fundersamhet" ;
  funk_nn_1_N = mkN "funk" ;
  funkis_nn_1_N = mkN "funkis" ;
  funktionsduglighet_nn_1_N = mkN "funktionsduglighet" ;
  funktionsoduglighet_nn_1_N = mkN "funktionsoduglighet" ;
  fur_nn_1_N = mkN "fur" ;
  furnerbarhet_nn_1_N = mkN "furnerbarhet" ;
  furor_nn_1_N = mkN "furor" ;
  furst_nn_1_N = mkN "furst" ;
  fusionerbarhet_nn_1_N = mkN "fusionerbarhet" ;
  fyllighet_nn_1_N = mkN "fyllighet" ;
  fyndjakt_nn_1_N = mkN "fyndjakt" ;
  fyraprocentsspaerr_nn_1_1_N = mkN "fyraprocentsspärr" ;
  fyrdelning_nn_1_N = mkN "fyrdelning" ;
  fyrdubbling_nn_1_N = mkN "fyrdubbling" ;
  fyrfilighet_nn_1_N = mkN "fyrfilighet" ;
  fyrgradighet_nn_1_N = mkN "fyrgradighet" ;
  fyrhjulighet_nn_1_N = mkN "fyrhjulighet" ;
  fyrkloever_nn_1_1_N = mkN "fyrklöver" ;
  fysik_nn_1_N = mkN "fysik" ;
  fysiljerbarhet_nn_1_N = mkN "fysiljerbarhet" ;
  faeaktighet_nn_1_1_N = mkN "fäaktighet" ;
  faelb_nn_1_1_N = mkN "fälb" ;
  faelgrengoering_nn_1_1_N = mkN "fälgrengöring" ;
  faelgtvaett_nn_1_1_N = mkN "fälgtvätt" ;
  faellbarhet_nn_1_1_N = mkN "fällbarhet" ;
  faeltmaessighet_nn_1_1_N = mkN "fältmässighet" ;
  faeltpost_nn_1_1_N = mkN "fältpost" ;
  faeltpostcensur_nn_1_1_N = mkN "fältpostcensur" ;
  faelttjaenst_nn_1_1_N = mkN "fälttjänst" ;
  faenkaal_nn_1_1_N = mkN "fänkål" ;
  faerdigjaesning_nn_1_1_N = mkN "färdigjäsning" ;
  faerdigmat_nn_1_1_N = mkN "färdigmat" ;
  faerdkost_nn_1_1_N = mkN "färdkost" ;
  faerdtjaenst_nn_1_1_N = mkN "färdtjänst" ;
  faergbehandling_nn_1_1_N = mkN "färgbehandling" ;
  faergbestaendighet_nn_1_1_N = mkN "färgbeständighet" ;
  faergblindhet_nn_1_1_N = mkN "färgblindhet" ;
  faergborttagning_nn_1_1_N = mkN "färgborttagning" ;
  faergglans_nn_1_1_N = mkN "färgglans" ;
  faerggrannhet_nn_1_1_N = mkN "färggrannhet" ;
  faergkonstans_nn_1_1_N = mkN "färgkonstans" ;
  faergloeshet_nn_1_1_N = mkN "färglöshet" ;
  faergprakt_nn_1_1_N = mkN "färgprakt" ;
  faergrikedom_nn_1_1_N = mkN "färgrikedom" ;
  faergrikhet_nn_1_1_N = mkN "färgrikhet" ;
  faergsprutning_nn_1_1_N = mkN "färgsprutning" ;
  faergstarkhet_nn_1_1_N = mkN "färgstarkhet" ;
  faerjetrafik_nn_1_1_N = mkN "färjetrafik" ;
  faernbock_nn_1_1_N = mkN "färnbock" ;
  faerserbarhet_nn_1_1_N = mkN "färserbarhet" ;
  faerskhet_nn_1_1_N = mkN "färskhet" ;
  faerskmat_nn_1_1_N = mkN "färskmat" ;
  faafaenga_nn_1_1_N = mkN "fåfänga" ;
  faafaenghet_nn_1_1_N = mkN "fåfänghet" ;
  faagelkunnighet_nn_1_1_N = mkN "fågelkunnighet" ;
  faagelmat_nn_1_1_N = mkN "fågelmat" ;
  faagelsaang_nn_1_1_N = mkN "fågelsång" ;
  faageltraeck_nn_1_1_N = mkN "fågelträck" ;
  faaglalaat_nn_1_1_N = mkN "fåglalåt" ;
  faakunnighet_nn_1_1_N = mkN "fåkunnighet" ;
  faamaeldhet_nn_1_1_N = mkN "fåmäldhet" ;
  faang_nn_2_1_N = mkN "fång" ;
  faangenskap_nn_1_1_N = mkN "fångenskap" ;
  faangvaard_nn_1_1_N = mkN "fångvård" ;
  faaordighet_nn_1_1_N = mkN "fåordighet" ;
  faaraktighet_nn_1_1_N = mkN "fåraktighet" ;
  faarsvingel_nn_1_1_N = mkN "fårsvingel" ;
  faarull_nn_1_1_N = mkN "fårull" ;
  faatalighet_nn_1_1_N = mkN "fåtalighet" ;
  faavitskhet_nn_1_1_N = mkN "fåvitskhet" ;
  foeda_nn_1_1_N = mkN "föda" ;
  foehn_nn_1_1_N = mkN "föhn" ;
  foeljdenlighet_nn_1_1_N = mkN "följdenlighet" ;
  foeljdriktighet_nn_1_1_N = mkN "följdriktighet" ;
  foen_nn_1_1_N = mkN "fön" ;
  foensterputs_nn_1_1_N = mkN "fönsterputs" ;
  foensterputsning_nn_1_1_N = mkN "fönsterputsning" ;
  foerannonserbarhet_nn_1_1_N = mkN "förannonserbarhet" ;
  foerbehaallsloeshet_nn_1_1_N = mkN "förbehållslöshet" ;
  foerbindlighet_nn_1_1_N = mkN "förbindlighet" ;
  foerbjudenhet_nn_1_1_N = mkN "förbjudenhet" ;
  foerbudslagstiftning_nn_1_1_N = mkN "förbudslagstiftning" ;
  foerbundenhet_nn_1_1_N = mkN "förbundenhet" ;
  foerbundsark_nn_1_1_N = mkN "förbundsark" ;
  foerbaetterlighet_nn_1_1_N = mkN "förbätterlighet" ;
  foerdelaktighet_nn_1_1_N = mkN "fördelaktighet" ;
  foerdelningspolitik_nn_1_1_N = mkN "fördelningspolitik" ;
  foerdoldhet_nn_1_1_N = mkN "fördoldhet" ;
  foerdomsfrihet_nn_1_1_N = mkN "fördomsfrihet" ;
  foerdragenhet_nn_1_1_N = mkN "fördragenhet" ;
  foerdunstning_nn_1_1_N = mkN "fördunstning" ;
  foerdaervlighet_nn_1_1_N = mkN "fördärvlighet" ;
  foerdoemdhet_nn_1_1_N = mkN "fördömdhet" ;
  foerdoemlighet_nn_1_1_N = mkN "fördömlighet" ;
  foerebildlighet_nn_1_1_N = mkN "förebildlighet" ;
  foeredoemlighet_nn_1_1_N = mkN "föredömlighet" ;
  foerefintlighet_nn_1_1_N = mkN "förefintlighet" ;
  foereningsraett_nn_1_1_N = mkN "föreningsrätt" ;
  foeretagaranda_nn_1_1_N = mkN "företagaranda" ;
  foeretagsbot_nn_1_1_N = mkN "företagsbot" ;
  foeretagshaelsovaard_nn_1_1_N = mkN "företagshälsovård" ;
  foeretagstaethet_nn_1_1_N = mkN "företagstäthet" ;
  foeretraedesraett_nn_1_1_N = mkN "företrädesrätt" ;
  foerfallenhet_nn_1_1_N = mkN "förfallenhet" ;
  foerfarenhet_nn_1_1_N = mkN "förfarenhet" ;
  foerflugenhet_nn_1_1_N = mkN "förflugenhet" ;
  foerfoganderaett_nn_1_1_N = mkN "förfoganderätt" ;
  foergraemdhet_nn_1_1_N = mkN "förgrämdhet" ;
  foergraatenhet_nn_1_1_N = mkN "förgråtenhet" ;
  foerhandenvaro_nn_1_1_N = mkN "förhandenvaro" ;
  foerhandlingsbarhet_nn_1_1_N = mkN "förhandlingsbarhet" ;
  foerhandlingsraett_nn_1_1_N = mkN "förhandlingsrätt" ;
  foerhandscensur_nn_1_1_N = mkN "förhandscensur" ;
  foerhoppningsfullhet_nn_1_1_N = mkN "förhoppningsfullhet" ;
  foerhud_nn_1_1_N = mkN "förhud" ;
  foerhudsfoertraengning_nn_1_1_N = mkN "förhudsförträngning" ;
  foerhydningspapp_nn_1_1_N = mkN "förhydningspapp" ;
  foerkastlighet_nn_1_1_N = mkN "förkastlighet" ;
  foerklaringskraft_nn_1_1_N = mkN "förklaringskraft" ;
  foerklarlighet_nn_1_1_N = mkN "förklarlighet" ;
  foerklaeddhet_nn_1_1_N = mkN "förkläddhet" ;
  foerkommenhet_nn_1_1_N = mkN "förkommenhet" ;
  foerkromning_nn_1_1_N = mkN "förkromning" ;
  foerkrympthet_nn_1_1_N = mkN "förkrympthet" ;
  foerkyldhet_nn_1_1_N = mkN "förkyldhet" ;
  foerkoepsraett_nn_1_1_N = mkN "förköpsrätt" ;
  foerkoersraett_nn_1_1_N = mkN "förkörsrätt" ;
  foerljugenhet_nn_1_1_N = mkN "förljugenhet" ;
  foerlustighet_nn_1_1_N = mkN "förlustighet" ;
  foerlustrikedom_nn_1_1_N = mkN "förlustrikedom" ;
  foerlaesthet_nn_1_1_N = mkN "förlästhet" ;
  foerlaatlighet_nn_1_1_N = mkN "förlåtlighet" ;
  foermedvetenhet_nn_1_1_N = mkN "förmedvetenhet" ;
  foermyndaraktighet_nn_1_1_N = mkN "förmyndaraktighet" ;
  foermaetenhet_nn_1_1_N = mkN "förmätenhet" ;
  foermaanlighet_nn_1_1_N = mkN "förmånlighet" ;
  foermaansraett_nn_1_1_N = mkN "förmånsrätt" ;
  foerna_nn_1_1_N = mkN "förna" ;
  foernuftighet_nn_1_1_N = mkN "förnuftighet" ;
  foernuftsstridighet_nn_1_1_N = mkN "förnuftsstridighet" ;
  foernuftsvidrighet_nn_1_1_N = mkN "förnuftsvidrighet" ;
  foernybarhet_nn_1_1_N = mkN "förnybarhet" ;
  foernyelsebarhet_nn_1_1_N = mkN "förnyelsebarhet" ;
  foernaemlighet_nn_1_1_N = mkN "förnämlighet" ;
  foernoejdhet_nn_1_1_N = mkN "förnöjdhet" ;
  foernoejsamhet_nn_1_1_N = mkN "förnöjsamhet" ;
  foerromantik_nn_1_1_N = mkN "förromantik" ;
  foerryckthet_nn_1_1_N = mkN "förryckthet" ;
  foersagdhet_nn_1_1_N = mkN "försagdhet" ;
  foersigkommenhet_nn_1_1_N = mkN "försigkommenhet" ;
  foersjunkenhet_nn_1_1_N = mkN "försjunkenhet" ;
  foerskotterbarhet_nn_1_1_N = mkN "förskotterbarhet" ;
  foerskraeckthet_nn_1_1_N = mkN "förskräckthet" ;
  foerskraemdhet_nn_1_1_N = mkN "förskrämdhet" ;
  foerskaemdhet_nn_1_1_N = mkN "förskämdhet" ;
  foerslagenhet_nn_1_1_N = mkN "förslagenhet" ;
  foersmak_nn_1_1_N = mkN "försmak" ;
  foersmaedlighet_nn_1_1_N = mkN "försmädlighet" ;
  foersoffning_nn_1_1_N = mkN "försoffning" ;
  foersonlighet_nn_1_1_N = mkN "försonlighet" ;
  foersorg_nn_1_1_N = mkN "försorg" ;
  foerstfoedsloraett_nn_1_1_N = mkN "förstfödslorätt" ;
  foerstklassighet_nn_1_1_N = mkN "förstklassighet" ;
  foerstroeddhet_nn_1_1_N = mkN "förströddhet" ;
  foerstuckenhet_nn_1_1_N = mkN "förstuckenhet" ;
  foerstulenhet_nn_1_1_N = mkN "förstulenhet" ;
  foerstaemdhet_nn_1_1_N = mkN "förstämdhet" ;
  foerstaaelighet_nn_1_1_N = mkN "förståelighet" ;
  foerstaandighet_nn_1_1_N = mkN "förståndighet" ;
  foerstoerdhet_nn_1_1_N = mkN "förstördhet" ;
  foersumbarhet_nn_1_1_N = mkN "försumbarhet" ;
  foersupenhet_nn_1_1_N = mkN "försupenhet" ;
  foersvarbarhet_nn_1_1_N = mkN "försvarbarhet" ;
  foersvarlighet_nn_1_1_N = mkN "försvarlighet" ;
  foersvarsberedskap_nn_1_1_N = mkN "försvarsberedskap" ;
  foersvarsloeshet_nn_1_1_N = mkN "försvarslöshet" ;
  foersvarsmakt_nn_1_1_N = mkN "försvarsmakt" ;
  foersvarspolitik_nn_1_1_N = mkN "försvarspolitik" ;
  foersyn_nn_1_1_N = mkN "försyn" ;
  foersynthet_nn_1_1_N = mkN "försynthet" ;
  foersoerjningsbalans_nn_1_1_N = mkN "försörjningsbalans" ;
  foersoerjningspolitik_nn_1_1_N = mkN "försörjningspolitik" ;
  foertegenhet_nn_1_1_N = mkN "förtegenhet" ;
  foertidspensionerbarhet_nn_1_1_N = mkN "förtidspensionerbarhet" ;
  foertjaenstfullhet_nn_1_1_N = mkN "förtjänstfullhet" ;
  foertret_nn_1_1_N = mkN "förtret" ;
  foertroendearbetstid_nn_1_1_N = mkN "förtroendearbetstid" ;
  foertroendefullhet_nn_1_1_N = mkN "förtroendefullhet" ;
  foertrytsamhet_nn_1_1_N = mkN "förtrytsamhet" ;
  foertur_nn_1_1_N = mkN "förtur" ;
  foertaenksamhet_nn_1_1_N = mkN "förtänksamhet" ;
  foerundersoekningssekretess_nn_1_1_N = mkN "förundersökningssekretess" ;
  foerundransvaerdhet_nn_1_1_N = mkN "förundransvärdhet" ;
  foerutbestaemdhet_nn_1_1_N = mkN "förutbestämdhet" ;
  foerutsaegbarhet_nn_1_1_N = mkN "förutsägbarhet" ;
  foerutsaegelsekraft_nn_1_1_N = mkN "förutsägelsekraft" ;
  foerutsaettningsloeshet_nn_1_1_N = mkN "förutsättningslöshet" ;
  foervetenhet_nn_1_1_N = mkN "förvetenhet" ;
  foervuxenhet_nn_1_1_N = mkN "förvuxenhet" ;
  foervaegenhet_nn_1_1_N = mkN "förvägenhet" ;
  foervaendhet_nn_1_1_N = mkN "förvändhet" ;
  foervaentansfullhet_nn_1_1_N = mkN "förväntansfullhet" ;
  foervaervslystenhet_nn_1_1_N = mkN "förvärvslystenhet" ;
  foeraektenskaplighet_nn_1_1_N = mkN "föräktenskaplighet" ;
  foeraeldrakaerlek_nn_1_1_N = mkN "föräldrakärlek" ;
  foeraeldraloeshet_nn_1_1_N = mkN "föräldralöshet" ;
  foeraenderlighet_nn_1_1_N = mkN "föränderlighet" ;
  gabbro_nn_1_N = mkN "gabbro" ;
  gaddloeshet_nn_1_1_N = mkN "gaddlöshet" ;
  gaggighet_nn_1_N = mkN "gaggighet" ;
  gagnerikhet_nn_1_N = mkN "gagnerikhet" ;
  gagnloeshet_nn_1_1_N = mkN "gagnlöshet" ;
  gagnrikhet_nn_1_N = mkN "gagnrikhet" ;
  gala_nn_2_N = mkN "gala" ;
  galaktos_nn_1_N = mkN "galaktos" ;
  galalit_nn_1_N = mkN "galalit" ;
  galenhet_nn_1_N = mkN "galenhet" ;
  galgenfrist_nn_1_N = mkN "galgenfrist" ;
  galla_nn_2_N = mkN "galla" ;
  gallfeber_nn_1_N = mkN "gallfeber" ;
  gallimatias_nn_1_N = mkN "gallimatias" ;
  gallimattias_nn_1_N = mkN "gallimattias" ;
  galliserbarhet_nn_1_N = mkN "galliserbarhet" ;
  gallisering_nn_2_N = mkN "gallisering" ;
  gallsjukhet_nn_1_N = mkN "gallsjukhet" ;
  gallspraengdhet_nn_1_1_N = mkN "gallsprängdhet" ;
  galmeja_nn_1_N = mkN "galmeja" ;
  galoppsport_nn_1_N = mkN "galoppsport" ;
  galoscherbarhet_nn_1_N = mkN "galoscherbarhet" ;
  galtlukt_nn_1_N = mkN "galtlukt" ;
  galvaniserbarhet_nn_1_N = mkN "galvaniserbarhet" ;
  galvanoplastik_nn_1_N = mkN "galvanoplastik" ;
  galvanoteknik_nn_1_N = mkN "galvanoteknik" ;
  gammalhoeger_nn_1_1_N = mkN "gammalhöger" ;
  gammalkristenhet_nn_1_N = mkN "gammalkristenhet" ;
  gammalkyrklighet_nn_1_N = mkN "gammalkyrklighet" ;
  gammalmodighet_nn_1_N = mkN "gammalmodighet" ;
  gammaltestamentlighet_nn_1_N = mkN "gammaltestamentlighet" ;
  gamman_nn_1_N = mkN "gamman" ;
  gangraen_nn_1_1_N = mkN "gangrän" ;
  gangsterromantik_nn_1_N = mkN "gangsterromantik" ;
  gapighet_nn_1_N = mkN "gapighet" ;
  garagerbarhet_nn_1_N = mkN "garagerbarhet" ;
  garanterbarhet_nn_1_N = mkN "garanterbarhet" ;
  garderbarhet_nn_1_N = mkN "garderbarhet" ;
  garderobssorg_nn_1_N = mkN "garderobssorg" ;
  garnerbarhet_nn_1_N = mkN "garnerbarhet" ;
  garnisonerbarhet_nn_1_N = mkN "garnisonerbarhet" ;
  garrotterbarhet_nn_1_N = mkN "garrotterbarhet" ;
  gasbetong_nn_1_N = mkN "gasbetong" ;
  gasbrand_nn_1_N = mkN "gasbrand" ;
  gasbrist_nn_1_N = mkN "gasbrist" ;
  gasdynamik_nn_1_N = mkN "gasdynamik" ;
  gasform_nn_1_N = mkN "gasform" ;
  gasol_nn_1_N = mkN "gasol" ;
  gasrikedom_nn_1_N = mkN "gasrikedom" ;
  gassighet_nn_1_N = mkN "gassighet" ;
  gastroskoperbarhet_nn_1_N = mkN "gastroskoperbarhet" ;
  gastrulering_nn_1_N = mkN "gastrulering" ;
  gatufred_nn_1_N = mkN "gatufred" ;
  gatufrid_nn_1_N = mkN "gatufrid" ;
  gatumusik_nn_1_N = mkN "gatumusik" ;
  gauffrerbarhet_nn_1_N = mkN "gauffrerbarhet" ;
  gedigenhet_nn_1_N = mkN "gedigenhet" ;
  gegga_nn_1_N = mkN "gegga" ;
  geggamoja_nn_1_N = mkN "geggamoja" ;
  geggighet_nn_1_N = mkN "geggighet" ;
  geist_nn_1_N = mkN "geist" ;
  gelatinerbarhet_nn_1_N = mkN "gelatinerbarhet" ;
  gelatinering_nn_1_N = mkN "gelatinering" ;
  gelcoat_nn_1_N = mkN "gelcoat" ;
  gelform_nn_1_N = mkN "gelform" ;
  gemensamhetskaensla_nn_1_1_N = mkN "gemensamhetskänsla" ;
  gemenskap_nn_1_N = mkN "gemenskap" ;
  geminerbarhet_nn_1_N = mkN "geminerbarhet" ;
  genans_nn_1_N = mkN "genans" ;
  genbankning_nn_1_N = mkN "genbankning" ;
  generalbas_nn_1_N = mkN "generalbas" ;
  generaliserbarhet_nn_1_N = mkN "generaliserbarhet" ;
  generalissimus_nn_1_N = mkN "generalissimus" ;
  generatorgas_nn_1_N = mkN "generatorgas" ;
  generbarhet_nn_1_N = mkN "generbarhet" ;
  genererbarhet_nn_1_N = mkN "genererbarhet" ;
  genes_nn_1_N = mkN "genes" ;
  genetik_nn_1_N = mkN "genetik" ;
  genever_nn_1_N = mkN "genever" ;
  gengas_nn_1_N = mkN "gengas" ;
  gengaangarlikhet_nn_1_1_N = mkN "gengångarlikhet" ;
  genius_nn_1_N = mkN "genius" ;
  genklang_nn_1_N = mkN "genklang" ;
  genmanipulerbarhet_nn_1_N = mkN "genmanipulerbarhet" ;
  genomdumhet_nn_1_N = mkN "genomdumhet" ;
  genomfaerd_nn_1_1_N = mkN "genomfärd" ;
  genomfoerbarhet_nn_1_1_N = mkN "genomförbarhet" ;
  genomskinlighet_nn_1_N = mkN "genomskinlighet" ;
  genomslagskraft_nn_1_N = mkN "genomslagskraft" ;
  genomsnittlighet_nn_1_N = mkN "genomsnittlighet" ;
  genomsvettighet_nn_1_N = mkN "genomsvettighet" ;
  genomtraenglighet_nn_1_1_N = mkN "genomtränglighet" ;
  genomtaenkthet_nn_1_1_N = mkN "genomtänkthet" ;
  genstridighet_nn_1_N = mkN "genstridighet" ;
  genstraevighet_nn_1_1_N = mkN "gensträvighet" ;
  genstoertighet_nn_1_1_N = mkN "genstörtighet" ;
  genteknik_nn_1_N = mkN "genteknik" ;
  gentiljess_nn_1_N = mkN "gentiljess" ;
  genusforskning_nn_1_N = mkN "genusforskning" ;
  geodynamik_nn_1_N = mkN "geodynamik" ;
  geofysik_nn_1_N = mkN "geofysik" ;
  geoid_nn_1_N = mkN "geoid" ;
  geometriserbarhet_nn_1_N = mkN "geometriserbarhet" ;
  geopolitik_nn_1_N = mkN "geopolitik" ;
  georgianskhet_nn_1_N = mkN "georgianskhet" ;
  geoteknik_nn_1_N = mkN "geoteknik" ;
  geriatrik_nn_1_N = mkN "geriatrik" ;
  germaniserbarhet_nn_1_N = mkN "germaniserbarhet" ;
  germanistik_nn_1_N = mkN "germanistik" ;
  gestik_nn_1_N = mkN "gestik" ;
  getmjoelk_nn_1_1_N = mkN "getmjölk" ;
  getpors_nn_1_N = mkN "getpors" ;
  getrams_nn_1_N = mkN "getrams" ;
  gettofiering_nn_1_N = mkN "gettofiering" ;
  giftasvuxenhet_nn_1_N = mkN "giftasvuxenhet" ;
  giftoraett_nn_1_1_N = mkN "giftorätt" ;
  gikt_nn_1_N = mkN "gikt" ;
  giktbrutenhet_nn_1_N = mkN "giktbrutenhet" ;
  giljarstraat_nn_1_1_N = mkN "giljarstråt" ;
  giljotinerbarhet_nn_1_N = mkN "giljotinerbarhet" ;
  gillhet_nn_1_N = mkN "gillhet" ;
  ginseng_nn_1_N = mkN "ginseng" ;
  gipsputs_nn_1_N = mkN "gipsputs" ;
  girerbarhet_nn_1_N = mkN "girerbarhet" ;
  gisslan_nn_1_N = mkN "gisslan" ;
  gistenhet_nn_1_N = mkN "gistenhet" ;
  gitarrmusik_nn_1_N = mkN "gitarrmusik" ;
  givenhet_nn_1_N = mkN "givenhet" ;
  gjutbarhet_nn_1_N = mkN "gjutbarhet" ;
  gjutbetong_nn_1_N = mkN "gjutbetong" ;
  gjutsand_nn_1_N = mkN "gjutsand" ;
  glaciaersmaeltning_nn_1_1_N = mkN "glaciärsmältning" ;
  gladhet_nn_1_N = mkN "gladhet" ;
  gladlynthet_nn_1_N = mkN "gladlynthet" ;
  gladporr_nn_1_N = mkN "gladporr" ;
  glammighet_nn_1_N = mkN "glammighet" ;
  glamoriserbarhet_nn_1_N = mkN "glamoriserbarhet" ;
  glamour_nn_1_N = mkN "glamour" ;
  glamouriserbarhet_nn_1_N = mkN "glamouriserbarhet" ;
  glans_nn_1_N = mkN "glans" ;
  glansfullhet_nn_1_N = mkN "glansfullhet" ;
  glansighet_nn_1_N = mkN "glansighet" ;
  glansis_nn_1_N = mkN "glansis" ;
  glanskhet_nn_1_N = mkN "glanskhet" ;
  glanskis_nn_1_N = mkN "glanskis" ;
  glansloeshet_nn_1_1_N = mkN "glanslöshet" ;
  glansull_nn_1_N = mkN "glansull" ;
  glapphet_nn_1_N = mkN "glapphet" ;
  glaserbarhet_nn_1_N = mkN "glaserbarhet" ;
  glasfiberull_nn_1_N = mkN "glasfiberull" ;
  glasfibervaev_nn_1_1_N = mkN "glasfiberväv" ;
  glasfluss_nn_1_N = mkN "glasfluss" ;
  glasmaestarsill_nn_1_1_N = mkN "glasmästarsill" ;
  glasnost_nn_1_N = mkN "glasnost" ;
  glasrengoering_nn_1_1_N = mkN "glasrengöring" ;
  glassighet_nn_1_N = mkN "glassighet" ;
  glasull_nn_1_N = mkN "glasull" ;
  glasoert_nn_1_1_N = mkN "glasört" ;
  glatthet_nn_1_N = mkN "glatthet" ;
  glattis_nn_1_N = mkN "glattis" ;
  glencheck_nn_1_N = mkN "glencheck" ;
  gleshet_nn_1_N = mkN "gleshet" ;
  glia_nn_1_N = mkN "glia" ;
  glidflygning_nn_1_N = mkN "glidflygning" ;
  glidflykt_nn_1_N = mkN "glidflykt" ;
  glima_nn_1_N = mkN "glima" ;
  glis_nn_1_N = mkN "glis" ;
  glittrighet_nn_1_N = mkN "glittrighet" ;
  globalisering_nn_1_N = mkN "globalisering" ;
  glorifierbarhet_nn_1_N = mkN "glorifierbarhet" ;
  glosoegdhet_nn_1_1_N = mkN "glosögdhet" ;
  glupskhet_nn_1_N = mkN "glupskhet" ;
  glutenintolerans_nn_1_N = mkN "glutenintolerans" ;
  glycerol_nn_1_N = mkN "glycerol" ;
  glykolys_nn_1_N = mkN "glykolys" ;
  glyptik_nn_1_N = mkN "glyptik" ;
  glyttighet_nn_1_N = mkN "glyttighet" ;
  glaedjefylldhet_nn_1_1_N = mkN "glädjefylldhet" ;
  glaedjerusighet_nn_1_1_N = mkN "glädjerusighet" ;
  gloeggsoerpling_nn_1_1_N = mkN "glöggsörpling" ;
  gloemska_nn_1_1_N = mkN "glömska" ;
  gloemskhet_nn_1_1_N = mkN "glömskhet" ;
  gnatighet_nn_1_N = mkN "gnatighet" ;
  gnetighet_nn_1_N = mkN "gnetighet" ;
  gnidenhet_nn_1_N = mkN "gnidenhet" ;
  gnist_nn_1_N = mkN "gnist" ;
  gnistrighet_nn_1_N = mkN "gnistrighet" ;
  gnosis_nn_1_N = mkN "gnosis" ;
  gnuss_nn_1_N = mkN "gnuss" ;
  gnutta_nn_1_N = mkN "gnutta" ;
  gnaellighet_nn_1_1_N = mkN "gnällighet" ;
  go_nn_1_N = mkN "go" ;
  godhetsfullhet_nn_1_N = mkN "godhetsfullhet" ;
  godhaellighet_nn_1_1_N = mkN "godhällighet" ;
  godisjakt_nn_1_N = mkN "godisjakt" ;
  godispanik_nn_1_N = mkN "godispanik" ;
  godissugenhet_nn_1_N = mkN "godissugenhet" ;
  godlynthet_nn_1_N = mkN "godlynthet" ;
  godmodighet_nn_1_N = mkN "godmodighet" ;
  godsinthet_nn_1_N = mkN "godsinthet" ;
  godstrafik_nn_1_N = mkN "godstrafik" ;
  godsaegarstil_nn_1_1_N = mkN "godsägarstil" ;
  godtagbarhet_nn_1_N = mkN "godtagbarhet" ;
  godtrogenhet_nn_1_N = mkN "godtrogenhet" ;
  godvillighet_nn_1_N = mkN "godvillighet" ;
  goffrerbarhet_nn_1_N = mkN "goffrerbarhet" ;
  goja_nn_1_N = mkN "goja" ;
  golf_nn_1_N = mkN "golf" ;
  gomspalt_nn_1_N = mkN "gomspalt" ;
  goodwill_nn_1_N = mkN "goodwill" ;
  googlingsbarhet_nn_1_N = mkN "googlingsbarhet" ;
  gossamer_nn_1_N = mkN "gossamer" ;
  gotik_nn_1_N = mkN "gotik" ;
  gotlaendskhet_nn_1_1_N = mkN "gotländskhet" ;
  gotskhet_nn_1_N = mkN "gotskhet" ;
  gouterbarhet_nn_1_N = mkN "gouterbarhet" ;
  graderbarhet_nn_1_N = mkN "graderbarhet" ;
  gradhet_nn_1_N = mkN "gradhet" ;
  graduerbarhet_nn_1_N = mkN "graduerbarhet" ;
  grafik_nn_1_N = mkN "grafik" ;
  grafiterbarhet_nn_1_N = mkN "grafiterbarhet" ;
  grain_nn_1_N = mkN "grain" ;
  granateld_nn_1_N = mkN "granateld" ;
  granbark_nn_1_N = mkN "granbark" ;
  grand_guignol_nn_1_N = mkN "grand-guignol" ;
  grandezza_nn_1_N = mkN "grandezza" ;
  grandioshet_nn_1_N = mkN "grandioshet" ;
  granitkeramik_nn_1_N = mkN "granitkeramik" ;
  grannhet_nn_1_N = mkN "grannhet" ;
  grannsynthet_nn_1_N = mkN "grannsynthet" ;
  grannsaemja_nn_1_1_N = mkN "grannsämja" ;
  granntyckthet_nn_1_N = mkN "granntyckthet" ;
  granulerbarhet_nn_1_N = mkN "granulerbarhet" ;
  granved_nn_1_N = mkN "granved" ;
  gratinerbarhet_nn_1_N = mkN "gratinerbarhet" ;
  gratulerbarhet_nn_1_N = mkN "gratulerbarhet" ;
  gravallvarlighet_nn_1_N = mkN "gravallvarlighet" ;
  graverbarhet_nn_1_N = mkN "graverbarhet" ;
  gravhet_nn_1_N = mkN "gravhet" ;
  gravis_nn_1_N = mkN "gravis" ;
  gravlikhet_nn_1_N = mkN "gravlikhet" ;
  gravor_nn_1_N = mkN "gravor" ;
  gravrost_nn_1_N = mkN "gravrost" ;
  gravyrkonst_nn_1_N = mkN "gravyrkonst" ;
  grenighet_nn_1_N = mkN "grenighet" ;
  greppbarhet_nn_1_N = mkN "greppbarhet" ;
  greppriktighet_nn_1_N = mkN "greppriktighet" ;
  greppvaenlighet_nn_1_1_N = mkN "greppvänlighet" ;
  grevlighet_nn_1_N = mkN "grevlighet" ;
  griftefrid_nn_1_N = mkN "griftefrid" ;
  griljerbarhet_nn_1_N = mkN "griljerbarhet" ;
  grimerbarhet_nn_1_N = mkN "grimerbarhet" ;
  gripbarhet_nn_1_N = mkN "gripbarhet" ;
  gripenhet_nn_1_N = mkN "gripenhet" ;
  gripreflex_nn_1_N = mkN "gripreflex" ;
  grismat_nn_1_N = mkN "grismat" ;
  grisuppfoedning_nn_1_1_N = mkN "grisuppfödning" ;
  gropemalj_nn_1_N = mkN "gropemalj" ;
  gropighet_nn_1_N = mkN "gropighet" ;
  grottekvarn_nn_1_N = mkN "grottekvarn" ;
  grovhuggenhet_nn_1_N = mkN "grovhuggenhet" ;
  grovkalibrighet_nn_1_N = mkN "grovkalibrighet" ;
  grovkornighet_nn_1_N = mkN "grovkornighet" ;
  grovplanerbarhet_nn_1_N = mkN "grovplanerbarhet" ;
  grovsorterbarhet_nn_1_N = mkN "grovsorterbarhet" ;
  grumsighet_nn_1_N = mkN "grumsighet" ;
  grunderbarhet_nn_1_N = mkN "grunderbarhet" ;
  grundfoersoerjning_nn_1_1_N = mkN "grundförsörjning" ;
  grundhet_nn_1_N = mkN "grundhet" ;
  grundloeshet_nn_1_1_N = mkN "grundlöshet" ;
  grundsyn_nn_1_N = mkN "grundsyn" ;
  gruppdynamik_nn_1_N = mkN "gruppdynamik" ;
  grupperbarhet_nn_1_N = mkN "grupperbarhet" ;
  grupptillhoerighet_nn_1_1_N = mkN "grupptillhörighet" ;
  gruvgas_nn_1_N = mkN "gruvgas" ;
  gruvsamhet_nn_1_N = mkN "gruvsamhet" ;
  grymhet_nn_2_N = mkN "grymhet" ;
  grytfot_nn_1_N = mkN "grytfot" ;
  graedda_nn_1_1_N = mkN "grädda" ;
  graeddfil_nn_1_1_N = mkN "gräddfil" ;
  graeddighet_nn_1_1_N = mkN "gräddighet" ;
  graelaktighet_nn_1_1_N = mkN "grälaktighet" ;
  graelighet_nn_1_1_N = mkN "grälighet" ;
  graellhet_nn_1_1_N = mkN "grällhet" ;
  graelsjuka_nn_1_1_N = mkN "grälsjuka" ;
  graelsjukhet_nn_1_1_N = mkN "grälsjukhet" ;
  graeng_nn_1_1_N = mkN "gräng" ;
  graensloeshet_nn_1_1_N = mkN "gränslöshet" ;
  graenspolis_nn_1_1_N = mkN "gränspolis" ;
  graensvaag_nn_1_1_N = mkN "gränsvåg" ;
  graeshalm_nn_1_1_N = mkN "gräshalm" ;
  graesloek_nn_1_1_N = mkN "gräslök" ;
  graesrotsnivaa_nn_1_1_N = mkN "gräsrotsnivå" ;
  graessvaal_nn_1_1_N = mkN "grässvål" ;
  graestorv_nn_1_1_N = mkN "grästorv" ;
  graesvaext_nn_2_1_N = mkN "gräsväxt" ;
  graettenhet_nn_1_1_N = mkN "grättenhet" ;
  graevarjournalistik_nn_1_1_N = mkN "grävarjournalistik" ;
  graevjournalistik_nn_1_1_N = mkN "grävjournalistik" ;
  graevlingsjakt_nn_1_1_N = mkN "grävlingsjakt" ;
  graaaktighet_nn_1_1_N = mkN "gråaktighet" ;
  graablekhet_nn_1_1_N = mkN "gråblekhet" ;
  graadaskighet_nn_1_1_N = mkN "grådaskighet" ;
  graahaarighet_nn_1_1_N = mkN "gråhårighet" ;
  graakallhet_nn_1_1_N = mkN "gråkallhet" ;
  graakil_nn_1_1_N = mkN "gråkil" ;
  graamurrighet_nn_1_1_N = mkN "gråmurrighet" ;
  graaregnighet_nn_1_1_N = mkN "gråregnighet" ;
  graaskala_nn_1_1_N = mkN "gråskala" ;
  graaskimlighet_nn_1_1_N = mkN "gråskimlighet" ;
  graaspraengdhet_nn_1_1_N = mkN "gråsprängdhet" ;
  graastarr_nn_1_1_N = mkN "gråstarr" ;
  graat_nn_1_1_N = mkN "gråt" ;
  graatfaerdighet_nn_1_1_N = mkN "gråtfärdighet" ;
  graatmildhet_nn_1_1_N = mkN "gråtmildhet" ;
  graaaert_nn_1_1_N = mkN "gråärt" ;
  groenaktighet_nn_1_1_N = mkN "grönaktighet" ;
  groenblekhet_nn_1_1_N = mkN "grönblekhet" ;
  groenblindhet_nn_1_1_N = mkN "grönblindhet" ;
  groenhet_nn_1_1_N = mkN "grönhet" ;
  groenkaal_nn_1_1_N = mkN "grönkål" ;
  groenkoeping_nn_1_1_N = mkN "grönköping" ;
  groenkoepingsmaessighet_nn_1_1_N = mkN "grönköpingsmässighet" ;
  groensoppa_nn_1_1_N = mkN "grönsoppa" ;
  groenstarr_nn_1_1_N = mkN "grönstarr" ;
  groenaadrighet_nn_1_1_N = mkN "grönådrighet" ;
  groetighet_nn_1_1_N = mkN "grötighet" ;
  groetlunk_nn_1_1_N = mkN "grötlunk" ;
  groetmyndighet_nn_1_1_N = mkN "grötmyndighet" ;
  guarani_nn_1_N = mkN "guarani" ;
  gubbighet_nn_1_N = mkN "gubbighet" ;
  gubbknarrighet_nn_1_N = mkN "gubbknarrighet" ;
  gubbsjuka_nn_1_N = mkN "gubbsjuka" ;
  gubbsjukhet_nn_1_N = mkN "gubbsjukhet" ;
  gudaktighet_nn_1_N = mkN "gudaktighet" ;
  gudamakt_nn_1_N = mkN "gudamakt" ;
  gudelighet_nn_1_N = mkN "gudelighet" ;
  gudfruktighet_nn_1_N = mkN "gudfruktighet" ;
  gudlighet_nn_1_N = mkN "gudlighet" ;
  gudloeshet_nn_1_1_N = mkN "gudlöshet" ;
  gudomliggoering_nn_1_1_N = mkN "gudomliggöring" ;
  gudsfred_nn_1_N = mkN "gudsfred" ;
  gudsfoergaetenhet_nn_1_1_N = mkN "gudsförgätenhet" ;
  gudsnaadelighet_nn_1_1_N = mkN "gudsnådelighet" ;
  gudsnaadlighet_nn_1_1_N = mkN "gudsnådlighet" ;
  gulaktighet_nn_1_N = mkN "gulaktighet" ;
  gulasch_nn_1_N = mkN "gulasch" ;
  gulblekhet_nn_1_N = mkN "gulblekhet" ;
  guldfeber_nn_1_N = mkN "guldfeber" ;
  guldglans_nn_1_N = mkN "guldglans" ;
  guldmyntfot_nn_1_N = mkN "guldmyntfot" ;
  guldpunkt_nn_1_N = mkN "guldpunkt" ;
  guldsand_nn_1_N = mkN "guldsand" ;
  guldtoerst_nn_1_1_N = mkN "guldtörst" ;
  gullebrand_nn_1_N = mkN "gullebrand" ;
  gulltrav_nn_1_N = mkN "gulltrav" ;
  gulmetall_nn_1_N = mkN "gulmetall" ;
  gulockra_nn_1_N = mkN "gulockra" ;
  gulsiktighet_nn_1_N = mkN "gulsiktighet" ;
  gulsot_nn_1_N = mkN "gulsot" ;
  gulvial_nn_1_N = mkN "gulvial" ;
  gummerbarhet_nn_1_N = mkN "gummerbarhet" ;
  gummigutta_nn_1_N = mkN "gummigutta" ;
  gungighet_nn_1_N = mkN "gungighet" ;
  gunstbenaegenhet_nn_1_1_N = mkN "gunstbenägenhet" ;
  gunstighet_nn_1_N = mkN "gunstighet" ;
  guppighet_nn_1_N = mkN "guppighet" ;
  gurkmeja_nn_1_N = mkN "gurkmeja" ;
  gut_nn_1_N = mkN "gut" ;
  guterbarhet_nn_1_N = mkN "guterbarhet" ;
  gutt_nn_1_N = mkN "gutt" ;
  guttaperka_nn_1_N = mkN "guttaperka" ;
  gyllenduk_nn_1_N = mkN "gyllenduk" ;
  gyllenlack_nn_1_N = mkN "gyllenlack" ;
  gymnastik_nn_1_N = mkN "gymnastik" ;
  gymnastiserbarhet_nn_1_N = mkN "gymnastiserbarhet" ;
  gympa_nn_1_N = mkN "gympa" ;
  gymping_nn_1_N = mkN "gymping" ;
  gynnsamhet_nn_1_N = mkN "gynnsamhet" ;
  gyroprincip_nn_1_N = mkN "gyroprincip" ;
  gyttjighet_nn_1_N = mkN "gyttjighet" ;
  gyttrighet_nn_1_N = mkN "gyttrighet" ;
  gaecksamhet_nn_1_1_N = mkN "gäcksamhet" ;
  gaeld_nn_1_1_N = mkN "gäld" ;
  gaellenhet_nn_1_1_N = mkN "gällenhet" ;
  gaellhet_nn_1_1_N = mkN "gällhet" ;
  gaenglighet_nn_1_1_N = mkN "gänglighet" ;
  gaespighet_nn_1_1_N = mkN "gäspighet" ;
  gaestfrihet_nn_1_1_N = mkN "gästfrihet" ;
  gaestvaenlighet_nn_1_1_N = mkN "gästvänlighet" ;
  gaangbarhet_nn_1_1_N = mkN "gångbarhet" ;
  gaapaaighet_nn_1_1_N = mkN "gåpåighet" ;
  gaardsfoersaeljning_nn_1_1_N = mkN "gårdsförsäljning" ;
  gaardsstaedning_nn_1_1_N = mkN "gårdsstädning" ;
  gaashud_nn_1_1_N = mkN "gåshud" ;
  gaaslever_nn_1_1_N = mkN "gåslever" ;
  gaasmarsch_nn_1_1_N = mkN "gåsmarsch" ;
  gaasoert_nn_1_1_N = mkN "gåsört" ;
  goedsel_nn_1_1_N = mkN "gödsel" ;
  goekmat_nn_1_1_N = mkN "gökmat" ;
  goekaert_nn_1_1_N = mkN "gökärt" ;
  goerlighet_nn_1_1_N = mkN "görlighet" ;
  goetmetall_nn_1_1_N = mkN "götmetall" ;
  goetterdaemmerung_nn_1_1_N = mkN "götterdämmerung" ;
  hackhosta_nn_1_N = mkN "hackhosta" ;
  hackighet_nn_1_N = mkN "hackighet" ;
  hackmat_nn_1_N = mkN "hackmat" ;
  hafsighet_nn_1_N = mkN "hafsighet" ;
  hagalenhet_nn_1_N = mkN "hagalenhet" ;
  hajj_nn_1_N = mkN "hajj" ;
  hajjakt_nn_1_N = mkN "hajjakt" ;
  halhet_nn_1_N = mkN "halhet" ;
  halka_nn_1_N = mkN "halka" ;
  halkighet_nn_1_N = mkN "halkighet" ;
  halkskyddstejp_nn_1_N = mkN "halkskyddstejp" ;
  hallraett_nn_1_1_N = mkN "hallrätt" ;
  hallucinerbarhet_nn_1_N = mkN "hallucinerbarhet" ;
  halm_nn_1_N = mkN "halm" ;
  halsbraenna_nn_1_1_N = mkN "halsbränna" ;
  halsstarrighet_nn_1_N = mkN "halsstarrighet" ;
  halthet_nn_1_N = mkN "halthet" ;
  haltloeshet_nn_1_1_N = mkN "haltlöshet" ;
  halvbildning_nn_1_N = mkN "halvbildning" ;
  halvblindhet_nn_1_N = mkN "halvblindhet" ;
  halvdager_nn_1_N = mkN "halvdager" ;
  halvdvala_nn_1_N = mkN "halvdvala" ;
  halvdoedhet_nn_1_1_N = mkN "halvdödhet" ;
  halverbarhet_nn_1_N = mkN "halverbarhet" ;
  halveringstid_nn_1_N = mkN "halveringstid" ;
  halvgenomskinlighet_nn_1_N = mkN "halvgenomskinlighet" ;
  halvgaangenhet_nn_1_1_N = mkN "halvgångenhet" ;
  halvklotformighet_nn_1_N = mkN "halvklotformighet" ;
  halvkvaedenhet_nn_1_1_N = mkN "halvkvädenhet" ;
  halvnakenhet_nn_1_N = mkN "halvnakenhet" ;
  halvruttenhet_nn_1_N = mkN "halvruttenhet" ;
  halvskymning_nn_1_N = mkN "halvskymning" ;
  halvslutenhet_nn_1_N = mkN "halvslutenhet" ;
  halvsnagg_nn_1_N = mkN "halvsnagg" ;
  halvspraakighet_nn_1_1_N = mkN "halvspråkighet" ;
  halvstatlighet_nn_1_N = mkN "halvstatlighet" ;
  halvsoemn_nn_1_1_N = mkN "halvsömn" ;
  halvtimma_nn_1_N = mkN "halvtimma" ;
  halvvuxenhet_nn_1_N = mkN "halvvuxenhet" ;
  halvoeppenhet_nn_1_1_N = mkN "halvöppenhet" ;
  hamling_nn_1_N = mkN "hamling" ;
  hampa_nn_1_N = mkN "hampa" ;
  hampdaan_nn_1_1_N = mkN "hampdån" ;
  handbojning_nn_1_N = mkN "handbojning" ;
  handboll_nn_1_N = mkN "handboll" ;
  handelsbalans_nn_1_N = mkN "handelsbalans" ;
  handelspolitik_nn_1_N = mkN "handelspolitik" ;
  handelsraett_nn_1_1_N = mkN "handelsrätt" ;
  handfasthet_nn_1_N = mkN "handfasthet" ;
  handgriplighet_nn_2_N = mkN "handgriplighet" ;
  handikappolitik_nn_1_N = mkN "handikappolitik" ;
  handikappvaard_nn_1_1_N = mkN "handikappvård" ;
  handkraft_nn_1_N = mkN "handkraft" ;
  handlingsberedskap_nn_1_N = mkN "handlingsberedskap" ;
  handlingskraft_nn_1_N = mkN "handlingskraft" ;
  handlingskraftighet_nn_1_N = mkN "handlingskraftighet" ;
  hands_nn_1_N = mkN "hands" ;
  handsvett_nn_1_N = mkN "handsvett" ;
  handtvaett_nn_2_1_N = mkN "handtvätt" ;
  hanfot_nn_1_N = mkN "hanfot" ;
  hanterbarhet_nn_1_N = mkN "hanterbarhet" ;
  hanterlighet_nn_1_N = mkN "hanterlighet" ;
  hantverksmaessighet_nn_1_1_N = mkN "hantverksmässighet" ;
  harangerbarhet_nn_1_N = mkN "harangerbarhet" ;
  harkloever_nn_1_1_N = mkN "harklöver" ;
  harm_nn_1_N = mkN "harm" ;
  harmfullhet_nn_1_N = mkN "harmfullhet" ;
  harmfylldhet_nn_1_N = mkN "harmfylldhet" ;
  harmlighet_nn_1_N = mkN "harmlighet" ;
  harmonik_nn_1_N = mkN "harmonik" ;
  harmoniserbarhet_nn_1_N = mkN "harmoniserbarhet" ;
  harmsenhet_nn_1_N = mkN "harmsenhet" ;
  harmynthet_nn_1_N = mkN "harmynthet" ;
  harpest_nn_1_N = mkN "harpest" ;
  harpunerbarhet_nn_1_N = mkN "harpunerbarhet" ;
  hasard_nn_1_N = mkN "hasard" ;
  hasarderbarhet_nn_1_N = mkN "hasarderbarhet" ;
  haschroekning_nn_1_1_N = mkN "haschrökning" ;
  hatfullhet_nn_1_N = mkN "hatfullhet" ;
  hatfylldhet_nn_1_N = mkN "hatfylldhet" ;
  hatstaemning_nn_1_1_N = mkN "hatstämning" ;
  hattighet_nn_1_N = mkN "hattighet" ;
  hausa_nn_1_N = mkN "hausa" ;
  havererbarhet_nn_1_N = mkN "havererbarhet" ;
  haverrot_nn_1_N = mkN "haverrot" ;
  havremust_nn_1_N = mkN "havremust" ;
  havresoppa_nn_1_N = mkN "havresoppa" ;
  havsluft_nn_1_N = mkN "havsluft" ;
  havsraett_nn_1_1_N = mkN "havsrätt" ;
  havsutsikt_nn_1_N = mkN "havsutsikt" ;
  hedenhet_nn_1_N = mkN "hedenhet" ;
  hedenhoes_nn_1_1_N = mkN "hedenhös" ;
  hederlighet_nn_1_N = mkN "hederlighet" ;
  hedersamhet_nn_1_N = mkN "hedersamhet" ;
  hedervaerdhet_nn_1_1_N = mkN "hedervärdhet" ;
  hektograferbarhet_nn_1_N = mkN "hektograferbarhet" ;
  helgarderbarhet_nn_1_N = mkN "helgarderbarhet" ;
  helgd_nn_1_N = mkN "helgd" ;
  helgjutenhet_nn_1_N = mkN "helgjutenhet" ;
  helgtrafik_nn_1_N = mkN "helgtrafik" ;
  helicobacter_nn_1_N = mkN "helicobacter" ;
  helicobakter_nn_1_N = mkN "helicobakter" ;
  helikobacter_nn_1_N = mkN "helikobacter" ;
  helikobakter_nn_1_N = mkN "helikobakter" ;
  helinackorderbarhet_nn_1_N = mkN "helinackorderbarhet" ;
  helnykterhet_nn_1_N = mkN "helnykterhet" ;
  helskotta_nn_1_N = mkN "helskotta" ;
  helstatlighet_nn_1_N = mkN "helstatlighet" ;
  hembryggning_nn_1_N = mkN "hembryggning" ;
  hembygdsromantik_nn_1_N = mkN "hembygdsromantik" ;
  hemfrid_nn_1_N = mkN "hemfrid" ;
  hemkomst_nn_1_N = mkN "hemkomst" ;
  hemkunskap_nn_1_N = mkN "hemkunskap" ;
  hemkaensla_nn_1_1_N = mkN "hemkänsla" ;
  hemlighetsfullhet_nn_1_N = mkN "hemlighetsfullhet" ;
  hemloeshet_nn_1_1_N = mkN "hemlöshet" ;
  hemmablindhet_nn_1_N = mkN "hemmablindhet" ;
  hemmafront_nn_1_N = mkN "hemmafront" ;
  hemmastaddhet_nn_1_N = mkN "hemmastaddhet" ;
  hemortsraett_nn_1_1_N = mkN "hemortsrätt" ;
  hemsjuka_nn_1_N = mkN "hemsjuka" ;
  hemsjukvaard_nn_1_1_N = mkN "hemsjukvård" ;
  hemskhet_nn_2_N = mkN "hemskhet" ;
  hemsloejd_nn_1_1_N = mkN "hemslöjd" ;
  hemtamhet_nn_1_N = mkN "hemtamhet" ;
  hemtrevnad_nn_1_N = mkN "hemtrevnad" ;
  hemvaeg_nn_1_1_N = mkN "hemväg" ;
  hemvaevdhet_nn_1_1_N = mkN "hemvävdhet" ;
  hemvaard_nn_1_1_N = mkN "hemvård" ;
  henna_nn_1_N = mkN "henna" ;
  heraldik_nn_1_N = mkN "heraldik" ;
  hermeneutik_nn_1_N = mkN "hermeneutik" ;
  heroinbranch_nn_1_N = mkN "heroinbranch" ;
  heroinproduktion_nn_1_N = mkN "heroinproduktion" ;
  heroinsmuggling_nn_1_N = mkN "heroinsmuggling" ;
  heroiserbarhet_nn_1_N = mkN "heroiserbarhet" ;
  herpes_nn_1_N = mkN "herpes" ;
  herreloeshet_nn_1_1_N = mkN "herrelöshet" ;
  herrgaardsdrift_nn_1_1_N = mkN "herrgårdsdrift" ;
  heterogenhet_nn_1_N = mkN "heterogenhet" ;
  heterogenitet_nn_1_N = mkN "heterogenitet" ;
  heterosexualitet_nn_1_N = mkN "heterosexualitet" ;
  hetluft_nn_1_N = mkN "hetluft" ;
  hets_nn_1_N = mkN "hets" ;
  hetspolitik_nn_1_N = mkN "hetspolitik" ;
  hetsaetning_nn_1_1_N = mkN "hetsätning" ;
  hetta_nn_1_N = mkN "hetta" ;
  heuristik_nn_1_N = mkN "heuristik" ;
  hiatus_nn_1_N = mkN "hiatus" ;
  hicka_nn_1_N = mkN "hicka" ;
  himlapaell_nn_1_1_N = mkN "himlapäll" ;
  himlarand_nn_1_N = mkN "himlarand" ;
  himmelsmekanik_nn_1_N = mkN "himmelsmekanik" ;
  hin_nn_1_N = mkN "hin" ;
  hinderloeshet_nn_1_1_N = mkN "hinderlöshet" ;
  hindersamhet_nn_1_N = mkN "hindersamhet" ;
  hindersloeshet_nn_1_1_N = mkN "hinderslöshet" ;
  hinsida_nn_1_N = mkN "hinsida" ;
  hipphet_nn_1_N = mkN "hipphet" ;
  hirs_nn_1_N = mkN "hirs" ;
  hispighet_nn_1_N = mkN "hispighet" ;
  historieloeshet_nn_1_1_N = mkN "historielöshet" ;
  historierbarhet_nn_1_N = mkN "historierbarhet" ;
  historiserbarhet_nn_1_N = mkN "historiserbarhet" ;
  hjordinstinkt_nn_1_N = mkN "hjordinstinkt" ;
  hjulbenthet_nn_1_N = mkN "hjulbenthet" ;
  hjaelp_nn_1_1_N = mkN "hjälp" ;
  hjaelplighet_nn_1_1_N = mkN "hjälplighet" ;
  hjaelploeshet_nn_1_1_N = mkN "hjälplöshet" ;
  hjaeltemodighet_nn_1_1_N = mkN "hjältemodighet" ;
  hjaeltestatus_nn_1_1_N = mkN "hjältestatus" ;
  hjaernbark_nn_1_1_N = mkN "hjärnbark" ;
  hjaerndoed_nn_1_1_N = mkN "hjärndöd" ;
  hjaernforskning_nn_1_1_N = mkN "hjärnforskning" ;
  hjaerngymnastik_nn_1_1_N = mkN "hjärngymnastik" ;
  hjaernsubstans_nn_1_1_N = mkN "hjärnsubstans" ;
  hjaerntvaett_nn_1_1_N = mkN "hjärntvätt" ;
  hjaert_lungraeddning_nn_1_1_N = mkN "hjärt-lungräddning" ;
  hjaertansfroejd_nn_1_1_N = mkN "hjärtansfröjd" ;
  hjaertanskaer_nn_1_1_N = mkN "hjärtanskär" ;
  hjaertegodhet_nn_1_1_N = mkN "hjärtegodhet" ;
  hjaertform_nn_1_1_N = mkN "hjärtform" ;
  hjaertinsufficiens_nn_1_1_N = mkN "hjärtinsufficiens" ;
  hjaertnupenhet_nn_1_1_N = mkN "hjärtnupenhet" ;
  hjaertsvikt_nn_1_1_N = mkN "hjärtsvikt" ;
  hjaertaengslighet_nn_1_1_N = mkN "hjärtängslighet" ;
  holograferbarhet_nn_1_N = mkN "holograferbarhet" ;
  homiletik_nn_1_N = mkN "homiletik" ;
  homo_nn_1_N = mkN "homo" ;
  homogenhet_nn_1_N = mkN "homogenhet" ;
  homogeniserbarhet_nn_1_N = mkN "homogeniserbarhet" ;
  honorerbarhet_nn_1_N = mkN "honorerbarhet" ;
  honungslenhet_nn_1_N = mkN "honungslenhet" ;
  hopbitenhet_nn_1_N = mkN "hopbitenhet" ;
  hopfaellbarhet_nn_1_1_N = mkN "hopfällbarhet" ;
  hopkrympning_nn_1_N = mkN "hopkrympning" ;
  hoppighet_nn_1_N = mkN "hoppighet" ;
  hopsmaeltning_nn_1_1_N = mkN "hopsmältning" ;
  hoptryckbarhet_nn_1_N = mkN "hoptryckbarhet" ;
  hornboskap_nn_1_N = mkN "hornboskap" ;
  hornhud_nn_1_N = mkN "hornhud" ;
  hornloeshet_nn_1_1_N = mkN "hornlöshet" ;
  hornmusik_nn_1_N = mkN "hornmusik" ;
  hortikultur_nn_1_N = mkN "hortikultur" ;
  hospitaliserbarhet_nn_1_N = mkN "hospitaliserbarhet" ;
  hospitaliseringseffekt_nn_1_N = mkN "hospitaliseringseffekt" ;
  hostighet_nn_1_N = mkN "hostighet" ;
  hot_nn_2_N = mkN "hot" ;
  hotchpotchsoppa_nn_1_N = mkN "hotchpotchsoppa" ;
  hovnarrstaempel_nn_1_1_N = mkN "hovnarrstämpel" ;
  hovsamhet_nn_1_N = mkN "hovsamhet" ;
  hudcancer_nn_1_N = mkN "hudcancer" ;
  hudloeshet_nn_1_1_N = mkN "hudlöshet" ;
  hudvaenlighet_nn_1_1_N = mkN "hudvänlighet" ;
  hug_nn_1_N = mkN "hug" ;
  hugnesamhet_nn_1_N = mkN "hugnesamhet" ;
  hula_hula_nn_1_N = mkN "hula-hula" ;
  huldhet_nn_1_N = mkN "huldhet" ;
  humaniserbarhet_nn_1_N = mkN "humaniserbarhet" ;
  hummus_nn_1_N = mkN "hummus" ;
  humus_nn_1_N = mkN "humus" ;
  humusbundenhet_nn_1_N = mkN "humusbundenhet" ;
  hundkaex_nn_1_1_N = mkN "hundkäx" ;
  hundmat_nn_1_N = mkN "hundmat" ;
  hundsfotterbarhet_nn_1_N = mkN "hundsfotterbarhet" ;
  hunger_nn_1_N = mkN "hunger" ;
  hungersnoed_nn_1_1_N = mkN "hungersnöd" ;
  hungrighet_nn_1_N = mkN "hungrighet" ;
  hurtighet_nn_1_N = mkN "hurtighet" ;
  husarrest_nn_1_N = mkN "husarrest" ;
  husdjursskoetsel_nn_1_1_N = mkN "husdjursskötsel" ;
  huserbarhet_nn_1_N = mkN "huserbarhet" ;
  husfrid_nn_1_N = mkN "husfrid" ;
  huslighet_nn_1_N = mkN "huslighet" ;
  huslaekekonst_nn_1_1_N = mkN "husläkekonst" ;
  husmanskost_nn_1_N = mkN "husmanskost" ;
  husvillhet_nn_1_N = mkN "husvillhet" ;
  huvudfoeda_nn_1_1_N = mkN "huvudföda" ;
  huvudjakt_nn_1_N = mkN "huvudjakt" ;
  huvudpart_nn_1_N = mkN "huvudpart" ;
  huvudvaerk_nn_1_1_N = mkN "huvudvärk" ;
  hybridiserbarhet_nn_1_N = mkN "hybridiserbarhet" ;
  hybris_nn_1_N = mkN "hybris" ;
  hydraulik_nn_1_N = mkN "hydraulik" ;
  hydrerbarhet_nn_1_N = mkN "hydrerbarhet" ;
  hydrodynamik_nn_1_N = mkN "hydrodynamik" ;
  hydrokinon_nn_1_N = mkN "hydrokinon" ;
  hydrosfaer_nn_1_1_N = mkN "hydrosfär" ;
  hydrostatik_nn_1_N = mkN "hydrostatik" ;
  hyfs_nn_1_N = mkN "hyfs" ;
  hyfsning_nn_1_N = mkN "hyfsning" ;
  hyperkorrekthet_nn_1_N = mkN "hyperkorrekthet" ;
  hyperkaenslighet_nn_1_1_N = mkN "hyperkänslighet" ;
  hypermodernhet_nn_1_N = mkN "hypermodernhet" ;
  hypnotiserbarhet_nn_1_N = mkN "hypnotiserbarhet" ;
  hypotalamus_nn_1_N = mkN "hypotalamus" ;
  hypotax_nn_1_N = mkN "hypotax" ;
  hypotiserbarhet_nn_1_N = mkN "hypotiserbarhet" ;
  hysbarhet_nn_1_N = mkN "hysbarhet" ;
  haeckling_nn_1_1_N = mkN "häckling" ;
  haediskhet_nn_1_1_N = mkN "hädiskhet" ;
  haeftighet_nn_1_1_N = mkN "häftighet" ;
  haelleflinta_nn_1_1_N = mkN "hälleflinta" ;
  haelsa_nn_1_1_N = mkN "hälsa" ;
  haelsokost_nn_1_1_N = mkN "hälsokost" ;
  haelsomedvetenhet_nn_1_1_N = mkN "hälsomedvetenhet" ;
  haelsopolitik_nn_1_1_N = mkN "hälsopolitik" ;
  haelsosamhet_nn_1_1_N = mkN "hälsosamhet" ;
  haelsovaard_nn_1_1_N = mkN "hälsovård" ;
  haemnd_nn_1_1_N = mkN "hämnd" ;
  haemndgirighet_nn_1_1_N = mkN "hämndgirighet" ;
  haemndlystenhet_nn_1_1_N = mkN "hämndlystenhet" ;
  haemtmat_nn_1_1_N = mkN "hämtmat" ;
  haendelsefattighet_nn_1_1_N = mkN "händelsefattighet" ;
  haendelseloeshet_nn_1_1_N = mkN "händelselöshet" ;
  haendelserikhet_nn_1_1_N = mkN "händelserikhet" ;
  haendighet_nn_1_1_N = mkN "händighet" ;
  haenfoerdhet_nn_1_1_N = mkN "hänfördhet" ;
  haengighet_nn_1_1_N = mkN "hängighet" ;
  haengivenhet_nn_1_1_N = mkN "hängivenhet" ;
  haenryckthet_nn_1_1_N = mkN "hänryckthet" ;
  haensjunkenhet_nn_1_1_N = mkN "hänsjunkenhet" ;
  haepenhet_nn_1_1_N = mkN "häpenhet" ;
  haerbaergerbarhet_nn_1_1_N = mkN "härbärgerbarhet" ;
  haerkomst_nn_1_1_N = mkN "härkomst" ;
  haerlighet_nn_2_1_N = mkN "härlighet" ;
  haermning_nn_1_1_N = mkN "härmning" ;
  haerskenhet_nn_1_1_N = mkN "härskenhet" ;
  haersklystenhet_nn_1_1_N = mkN "härsklystenhet" ;
  haestpolo_nn_1_1_N = mkN "hästpolo" ;
  haestskoetsel_nn_1_1_N = mkN "hästskötsel" ;
  haevdvunnenhet_nn_1_1_N = mkN "hävdvunnenhet" ;
  haag_nn_1_1_N = mkN "håg" ;
  haagloeshet_nn_1_1_N = mkN "håglöshet" ;
  haallningsloeshet_nn_1_1_N = mkN "hållningslöshet" ;
  haalspetsammunition_nn_1_1_N = mkN "hålspetsammunition" ;
  haaltimma_nn_1_1_N = mkN "håltimma" ;
  haaloegdhet_nn_1_1_N = mkN "hålögdhet" ;
  haarbevuxenhet_nn_1_1_N = mkN "hårbevuxenhet" ;
  haardfoerhet_nn_1_1_N = mkN "hårdförhet" ;
  haardhet_nn_1_1_N = mkN "hårdhet" ;
  haardhjaertenhet_nn_1_1_N = mkN "hårdhjärtenhet" ;
  haardhaenthet_nn_1_1_N = mkN "hårdhänthet" ;
  haardkokthet_nn_1_1_N = mkN "hårdkokthet" ;
  haardnackenhet_nn_1_1_N = mkN "hårdnackenhet" ;
  haardporr_nn_1_1_N = mkN "hårdporr" ;
  haardrock_nn_1_1_N = mkN "hårdrock" ;
  haardsmaelthet_nn_1_1_N = mkN "hårdsmälthet" ;
  haarighet_nn_1_1_N = mkN "hårighet" ;
  haarloeshet_nn_1_1_N = mkN "hårlöshet" ;
  haarroerskraft_nn_1_1_N = mkN "hårrörskraft" ;
  haarsmaan_nn_1_1_N = mkN "hårsmån" ;
  haarvaext_nn_1_1_N = mkN "hårväxt" ;
  haarvaard_nn_1_1_N = mkN "hårvård" ;
  hoefeber_nn_1_1_N = mkN "höfeber" ;
  hoegaktningsfullhet_nn_1_1_N = mkN "högaktningsfullhet" ;
  hoegborenhet_nn_1_1_N = mkN "högborenhet" ;
  hoegborgerlighet_nn_1_1_N = mkN "högborgerlighet" ;
  hoegdragenhet_nn_1_1_N = mkN "högdragenhet" ;
  hoeger_nn_2_1_N = mkN "höger" ;
  hoegerextremism_nn_1_1_N = mkN "högerextremism" ;
  hoegerhaenthet_nn_1_1_N = mkN "högerhänthet" ;
  hoegerkristenhet_nn_1_1_N = mkN "högerkristenhet" ;
  hoegerpolitik_nn_1_1_N = mkN "högerpolitik" ;
  hoegerpopulism_nn_1_1_N = mkN "högerpopulism" ;
  hoegerregel_nn_1_1_N = mkN "högerregel" ;
  hoegertrafik_nn_1_1_N = mkN "högertrafik" ;
  hoegflod_nn_1_1_N = mkN "högflod" ;
  hoegform_nn_1_1_N = mkN "högform" ;
  hoegfaerd_nn_1_1_N = mkN "högfärd" ;
  hoegfaerdighet_nn_1_1_N = mkN "högfärdighet" ;
  hoegfaerdsdjaevul_nn_1_1_N = mkN "högfärdsdjävul" ;
  hoegfoernaemhet_nn_1_1_N = mkN "högförnämhet" ;
  hoegglans_nn_1_1_N = mkN "högglans" ;
  hoegklassighet_nn_1_1_N = mkN "högklassighet" ;
  hoegkyrklighet_nn_1_1_N = mkN "högkyrklighet" ;
  hoegljuddhet_nn_1_1_N = mkN "högljuddhet" ;
  hoeglaenthet_nn_1_1_N = mkN "höglänthet" ;
  hoegmodighet_nn_1_1_N = mkN "högmodighet" ;
  hoegresthet_nn_1_1_N = mkN "högresthet" ;
  hoegsinthet_nn_1_1_N = mkN "högsinthet" ;
  hoegstatus_nn_1_1_N = mkN "högstatus" ;
  hoegstaemdhet_nn_1_1_N = mkN "högstämdhet" ;
  hoegtrafik_nn_1_1_N = mkN "högtrafik" ;
  hoegvuxenhet_nn_1_1_N = mkN "högvuxenhet" ;
  hoegvaelborenhet_nn_1_1_N = mkN "högvälborenhet" ;
  hoegvaerdighet_nn_1_1_N = mkN "högvärdighet" ;
  hoegvaexthet_nn_1_1_N = mkN "högväxthet" ;
  hoegoensklighet_nn_1_1_N = mkN "högönsklighet" ;
  hoejdled_nn_1_1_N = mkN "höjdled" ;
  hoekpolitik_nn_1_1_N = mkN "hökpolitik" ;
  hoensighet_nn_1_1_N = mkN "hönsighet" ;
  hoerbarhetstroeskel_nn_1_1_N = mkN "hörbarhetströskel" ;
  hoersamhet_nn_1_1_N = mkN "hörsamhet" ;
  hoersel_nn_1_1_N = mkN "hörsel" ;
  hoesnuva_nn_1_1_N = mkN "hösnuva" ;
  hoestfrost_nn_1_1_N = mkN "höstfrost" ;
  hoestsol_nn_1_1_N = mkN "höstsol" ;
  hoestsaed_nn_1_1_N = mkN "höstsäd" ;
  hoestsaadd_nn_1_1_N = mkN "höstsådd" ;
  hoetorgskonst_nn_1_1_N = mkN "hötorgskonst" ;
  iblandning_nn_1_N = mkN "iblandning" ;
  id_nn_2_N = mkN "id" ;
  idealiserbarhet_nn_1_N = mkN "idealiserbarhet" ;
  idelighet_nn_1_N = mkN "idelighet" ;
  identifierbarhet_nn_1_N = mkN "identifierbarhet" ;
  idiotsaekerhet_nn_1_1_N = mkN "idiotsäkerhet" ;
  idoghet_nn_1_N = mkN "idoghet" ;
  idrottsgymnastik_nn_1_N = mkN "idrottsgymnastik" ;
  idrottslighet_nn_1_N = mkN "idrottslighet" ;
  idrottsmedicin_nn_1_N = mkN "idrottsmedicin" ;
  id_efattighet_nn_1_1_N = mkN "idéfattighet" ;
  id_eflykt_nn_1_1_N = mkN "idéflykt" ;
  id_erikhet_nn_1_1_N = mkN "idérikhet" ;
  igenkaenning_nn_1_1_N = mkN "igenkänning" ;
  igenkaennlighet_nn_1_1_N = mkN "igenkännlighet" ;
  igensaettning_nn_1_1_N = mkN "igensättning" ;
  ignorans_nn_1_N = mkN "ignorans" ;
  ignorerbarhet_nn_1_N = mkN "ignorerbarhet" ;
  ihopfaellbarhet_nn_1_1_N = mkN "ihopfällbarhet" ;
  ihaerdighet_nn_1_1_N = mkN "ihärdighet" ;
  ihaallighet_nn_1_1_N = mkN "ihållighet" ;
  ikat_nn_1_N = mkN "ikat" ;
  ilastning_nn_1_N = mkN "ilastning" ;
  ilfart_nn_1_N = mkN "ilfart" ;
  illavulenhet_nn_1_N = mkN "illavulenhet" ;
  illfundighet_nn_1_N = mkN "illfundighet" ;
  illistighet_nn_1_N = mkN "illistighet" ;
  illmarighet_nn_1_N = mkN "illmarighet" ;
  illparighet_nn_1_N = mkN "illparighet" ;
  illuminerbarhet_nn_1_N = mkN "illuminerbarhet" ;
  illustrerbarhet_nn_1_N = mkN "illustrerbarhet" ;
  ilska_nn_1_N = mkN "ilska" ;
  ilskenhet_nn_1_N = mkN "ilskenhet" ;
  ilskhet_nn_1_N = mkN "ilskhet" ;
  imbecillhet_nn_1_N = mkN "imbecillhet" ;
  imiterbarhet_nn_1_N = mkN "imiterbarhet" ;
  imma_nn_1_N = mkN "imma" ;
  immanens_nn_1_N = mkN "immanens" ;
  immaterialraett_nn_1_1_N = mkN "immaterialrätt" ;
  immatrikulerbarhet_nn_1_N = mkN "immatrikulerbarhet" ;
  immighet_nn_1_N = mkN "immighet" ;
  immigrerbarhet_nn_1_N = mkN "immigrerbarhet" ;
  immuniserbarhet_nn_1_N = mkN "immuniserbarhet" ;
  impedans_nn_1_N = mkN "impedans" ;
  impetigo_nn_1_N = mkN "impetigo" ;
  implanterbarhet_nn_1_N = mkN "implanterbarhet" ;
  implicerbarhet_nn_1_N = mkN "implicerbarhet" ;
  implicithet_nn_1_N = mkN "implicithet" ;
  imploderbarhet_nn_1_N = mkN "imploderbarhet" ;
  imponerbarhet_nn_1_N = mkN "imponerbarhet" ;
  importerbarhet_nn_1_N = mkN "importerbarhet" ;
  impotens_nn_1_N = mkN "impotens" ;
  impregnerbarhet_nn_1_N = mkN "impregnerbarhet" ;
  improviserbarhet_nn_1_N = mkN "improviserbarhet" ;
  impulskontroll_nn_1_N = mkN "impulskontroll" ;
  inackorderbarhet_nn_1_N = mkN "inackorderbarhet" ;
  inaugurerbarhet_nn_1_N = mkN "inaugurerbarhet" ;
  inbillningssjukhet_nn_1_N = mkN "inbillningssjukhet" ;
  inbitenhet_nn_1_N = mkN "inbitenhet" ;
  inblaasning_nn_1_1_N = mkN "inblåsning" ;
  inbundenhet_nn_1_N = mkN "inbundenhet" ;
  incidentberedskap_nn_1_N = mkN "incidentberedskap" ;
  indefinithet_nn_1_N = mkN "indefinithet" ;
  indexerbarhet_nn_1_N = mkN "indexerbarhet" ;
  indexreglerbarhet_nn_1_N = mkN "indexreglerbarhet" ;
  indicerbarhet_nn_1_N = mkN "indicerbarhet" ;
  indifferens_nn_1_N = mkN "indifferens" ;
  indigenatsraett_nn_1_1_N = mkN "indigenatsrätt" ;
  indignationslitteratur_nn_1_N = mkN "indignationslitteratur" ;
  indigo_nn_1_N = mkN "indigo" ;
  indikerbarhet_nn_1_N = mkN "indikerbarhet" ;
  indirekthet_nn_1_N = mkN "indirekthet" ;
  indiskrethet_nn_1_N = mkN "indiskrethet" ;
  individualiserbarhet_nn_1_N = mkN "individualiserbarhet" ;
  indoktrinerbarhet_nn_1_N = mkN "indoktrinerbarhet" ;
  indolens_nn_1_N = mkN "indolens" ;
  indragenhet_nn_1_N = mkN "indragenhet" ;
  indraektighet_nn_1_1_N = mkN "indräktighet" ;
  inducerbarhet_nn_1_N = mkN "inducerbarhet" ;
  induktans_nn_1_N = mkN "induktans" ;
  industrialiserbarhet_nn_1_N = mkN "industrialiserbarhet" ;
  industridoed_nn_1_1_N = mkN "industridöd" ;
  industripolitik_nn_1_N = mkN "industripolitik" ;
  inexakthet_nn_1_N = mkN "inexakthet" ;
  infallsrikhet_nn_1_N = mkN "infallsrikhet" ;
  infantiliserbarhet_nn_1_N = mkN "infantiliserbarhet" ;
  infantilisering_nn_1_N = mkN "infantilisering" ;
  infekterbarhet_nn_1_N = mkN "infekterbarhet" ;
  infiltrerbarhet_nn_1_N = mkN "infiltrerbarhet" ;
  infinithet_nn_1_N = mkN "infinithet" ;
  inflammerbarhet_nn_1_N = mkN "inflammerbarhet" ;
  influerbarhet_nn_1_N = mkN "influerbarhet" ;
  inflytelserikhet_nn_1_N = mkN "inflytelserikhet" ;
  informationskrigfoering_nn_1_1_N = mkN "informationskrigföring" ;
  informationsplikt_nn_1_N = mkN "informationsplikt" ;
  informationsrikhet_nn_1_N = mkN "informationsrikhet" ;
  informationsstress_nn_1_N = mkN "informationsstress" ;
  informerbarhet_nn_1_N = mkN "informerbarhet" ;
  infrastrukturalitet_nn_1_N = mkN "infrastrukturalitet" ;
  infoeddhet_nn_1_1_N = mkN "inföddhet" ;
  infoersel_nn_1_1_N = mkN "införsel" ;
  ingefaera_nn_1_1_N = mkN "ingefära" ;
  ingefaersdricka_nn_1_1_N = mkN "ingefärsdricka" ;
  ingraverbarhet_nn_1_N = mkN "ingraverbarhet" ;
  ingroddhet_nn_1_N = mkN "ingroddhet" ;
  inhalerbarhet_nn_1_N = mkN "inhalerbarhet" ;
  inhiberbarhet_nn_1_N = mkN "inhiberbarhet" ;
  inhibiterbarhet_nn_1_N = mkN "inhibiterbarhet" ;
  initiativkraft_nn_1_N = mkN "initiativkraft" ;
  initiativrikhet_nn_1_N = mkN "initiativrikhet" ;
  initierbarhet_nn_1_N = mkN "initierbarhet" ;
  injekterbarhet_nn_1_N = mkN "injekterbarhet" ;
  injicerbarhet_nn_1_N = mkN "injicerbarhet" ;
  inkarnerbarhet_nn_1_N = mkN "inkarnerbarhet" ;
  inkasserbarhet_nn_1_N = mkN "inkasserbarhet" ;
  inklarerbarhet_nn_1_N = mkN "inklarerbarhet" ;
  inkluderbarhet_nn_1_N = mkN "inkluderbarhet" ;
  inknappning_nn_1_N = mkN "inknappning" ;
  inkompetens_nn_1_N = mkN "inkompetens" ;
  inkomsttaxerbarhet_nn_1_N = mkN "inkomsttaxerbarhet" ;
  inkontinens_nn_1_N = mkN "inkontinens" ;
  inkorporerbarhet_nn_1_N = mkN "inkorporerbarhet" ;
  inkorrekthet_nn_1_N = mkN "inkorrekthet" ;
  inkroekthet_nn_1_1_N = mkN "inkrökthet" ;
  inkvarterbarhet_nn_1_N = mkN "inkvarterbarhet" ;
  inlaerningssvaarighet_nn_1_1_N = mkN "inlärningssvårighet" ;
  innehaallslighet_nn_1_1_N = mkN "innehållslighet" ;
  innehaallsloeshet_nn_1_1_N = mkN "innehållslöshet" ;
  innehaallsmaessighet_nn_1_1_N = mkN "innehållsmässighet" ;
  innehaallsrikhet_nn_1_1_N = mkN "innehållsrikhet" ;
  innehaallstomhet_nn_1_1_N = mkN "innehållstomhet" ;
  innerhand_nn_1_N = mkN "innerhand" ;
  innerlighet_nn_1_N = mkN "innerlighet" ;
  innerverbarhet_nn_1_N = mkN "innerverbarhet" ;
  inokulerbarhet_nn_1_N = mkN "inokulerbarhet" ;
  inomhusluft_nn_1_N = mkN "inomhusluft" ;
  inomvetenskaplighet_nn_1_N = mkN "inomvetenskaplighet" ;
  inplanterbarhet_nn_1_N = mkN "inplanterbarhet" ;
  inprogrammering_nn_1_N = mkN "inprogrammering" ;
  input_nn_1_N = mkN "input" ;
  inpyrdhet_nn_1_N = mkN "inpyrdhet" ;
  inrangerbarhet_nn_1_N = mkN "inrangerbarhet" ;
  inrapporterbarhet_nn_1_N = mkN "inrapporterbarhet" ;
  inregistrerbarhet_nn_1_N = mkN "inregistrerbarhet" ;
  inrikespolitik_nn_1_N = mkN "inrikespolitik" ;
  inrikestrafik_nn_1_N = mkN "inrikestrafik" ;
  inringning_nn_1_N = mkN "inringning" ;
  inraettning_nn_2_1_N = mkN "inrättning" ;
  inscenerbarhet_nn_1_N = mkN "inscenerbarhet" ;
  insektskunnighet_nn_1_N = mkN "insektskunnighet" ;
  inseminerbarhet_nn_1_N = mkN "inseminerbarhet" ;
  insiktsfullhet_nn_1_N = mkN "insiktsfullhet" ;
  insinuerbarhet_nn_1_N = mkN "insinuerbarhet" ;
  insolvens_nn_1_N = mkN "insolvens" ;
  inspekterbarhet_nn_1_N = mkN "inspekterbarhet" ;
  inspirerbarhet_nn_1_N = mkN "inspirerbarhet" ;
  installerbarhet_nn_1_N = mkN "installerbarhet" ;
  institutionaliserbarhet_nn_1_N = mkN "institutionaliserbarhet" ;
  instruerbarhet_nn_1_N = mkN "instruerbarhet" ;
  instrumentalis_nn_1_N = mkN "instrumentalis" ;
  instrumentalmusik_nn_1_N = mkN "instrumentalmusik" ;
  instrumenterbarhet_nn_1_N = mkN "instrumenterbarhet" ;
  instuderbarhet_nn_1_N = mkN "instuderbarhet" ;
  instaellbarhet_nn_1_1_N = mkN "inställbarhet" ;
  instaellningsbarhet_nn_1_1_N = mkN "inställningsbarhet" ;
  instaengdhet_nn_1_1_N = mkN "instängdhet" ;
  insyn_nn_1_N = mkN "insyn" ;
  intagsluft_nn_1_N = mkN "intagsluft" ;
  integrationspolitik_nn_1_N = mkN "integrationspolitik" ;
  integrerbarhet_nn_1_N = mkN "integrerbarhet" ;
  intellektualiserbarhet_nn_1_N = mkN "intellektualiserbarhet" ;
  intelligentia_nn_1_N = mkN "intelligentia" ;
  intensifierbarhet_nn_1_N = mkN "intensifierbarhet" ;
  intensiverbarhet_nn_1_N = mkN "intensiverbarhet" ;
  intensivvaard_nn_1_1_N = mkN "intensivvård" ;
  interfolierbarhet_nn_1_N = mkN "interfolierbarhet" ;
  internaliserbarhet_nn_1_N = mkN "internaliserbarhet" ;
  internationaliserbarhet_nn_1_N = mkN "internationaliserbarhet" ;
  internerbarhet_nn_1_N = mkN "internerbarhet" ;
  interpellerbarhet_nn_1_N = mkN "interpellerbarhet" ;
  interpolerbarhet_nn_1_N = mkN "interpolerbarhet" ;
  interpreterbarhet_nn_1_N = mkN "interpreterbarhet" ;
  interpunkterbarhet_nn_1_N = mkN "interpunkterbarhet" ;
  intervenerbarhet_nn_1_N = mkN "intervenerbarhet" ;
  intimisering_nn_1_N = mkN "intimisering" ;
  intimrakning_nn_1_N = mkN "intimrakning" ;
  intimsfaer_nn_1_1_N = mkN "intimsfär" ;
  intolerans_nn_1_N = mkN "intolerans" ;
  intonerbarhet_nn_1_N = mkN "intonerbarhet" ;
  intresseloeshet_nn_1_1_N = mkN "intresselöshet" ;
  intresserbarhet_nn_1_N = mkN "intresserbarhet" ;
  introducerbarhet_nn_1_N = mkN "introducerbarhet" ;
  introverthet_nn_1_N = mkN "introverthet" ;
  invaderbarhet_nn_1_N = mkN "invaderbarhet" ;
  invalidiserbarhet_nn_1_N = mkN "invalidiserbarhet" ;
  invallning_nn_1_N = mkN "invallning" ;
  invandhet_nn_1_N = mkN "invandhet" ;
  invandrarfientlighet_nn_1_N = mkN "invandrarfientlighet" ;
  invandrarpolitik_nn_1_N = mkN "invandrarpolitik" ;
  invandrartaethet_nn_1_1_N = mkN "invandrartäthet" ;
  invandrarundervisning_nn_1_N = mkN "invandrarundervisning" ;
  invandringspolitik_nn_1_N = mkN "invandringspolitik" ;
  inventerbarhet_nn_1_N = mkN "inventerbarhet" ;
  inverterbarhet_nn_1_N = mkN "inverterbarhet" ;
  investerbarhet_nn_1_N = mkN "investerbarhet" ;
  investeringspolitik_nn_1_N = mkN "investeringspolitik" ;
  investitur_nn_1_N = mkN "investitur" ;
  inviterbarhet_nn_1_N = mkN "inviterbarhet" ;
  involverbarhet_nn_1_N = mkN "involverbarhet" ;
  inaelvskorv_nn_1_1_N = mkN "inälvskorv" ;
  inaatvaendhet_nn_1_1_N = mkN "inåtvändhet" ;
  irrelevans_nn_1_N = mkN "irrelevans" ;
  irriterbarhet_nn_1_N = mkN "irriterbarhet" ;
  irrlaerighet_nn_1_1_N = mkN "irrlärighet" ;
  isabellafaerg_nn_1_1_N = mkN "isabellafärg" ;
  isagogik_nn_1_N = mkN "isagogik" ;
  isbark_nn_1_N = mkN "isbark" ;
  isbergssallad_nn_1_N = mkN "isbergssallad" ;
  isbraenna_nn_1_1_N = mkN "isbränna" ;
  ischias_nn_1_N = mkN "ischias" ;
  ischoklad_nn_1_N = mkN "ischoklad" ;
  isdans_nn_1_N = mkN "isdans" ;
  ishalka_nn_1_N = mkN "ishalka" ;
  iskyla_nn_1_N = mkN "iskyla" ;
  islam_nn_1_N = mkN "islam" ;
  islamiserbarhet_nn_1_N = mkN "islamiserbarhet" ;
  islamisering_nn_1_N = mkN "islamisering" ;
  isolerbarhet_nn_1_N = mkN "isolerbarhet" ;
  isop_nn_1_N = mkN "isop" ;
  isracing_nn_1_N = mkN "isracing" ;
  issoerja_nn_1_1_N = mkN "issörja" ;
  istadaraett_nn_1_1_N = mkN "istadarätt" ;
  istadighet_nn_1_N = mkN "istadighet" ;
  itererbarhet_nn_1_N = mkN "itererbarhet" ;
  iver_nn_1_N = mkN "iver" ;
  ivrighet_nn_1_N = mkN "ivrighet" ;
  jackighet_nn_1_N = mkN "jackighet" ;
  jacquard_nn_1_N = mkN "jacquard" ;
  jadeit_nn_1_N = mkN "jadeit" ;
  jagdrift_nn_1_N = mkN "jagdrift" ;
  jagform_nn_1_N = mkN "jagform" ;
  jagkaensla_nn_1_1_N = mkN "jagkänsla" ;
  jakaranda_nn_1_N = mkN "jakaranda" ;
  jaktbarhet_nn_1_N = mkN "jaktbarhet" ;
  jaktlycka_nn_1_N = mkN "jaktlycka" ;
  jaktraett_nn_1_1_N = mkN "jakträtt" ;
  jaktvaard_nn_1_1_N = mkN "jaktvård" ;
  jams_nn_1_N = mkN "jams" ;
  jamsrot_nn_1_N = mkN "jamsrot" ;
  janitsjarmusik_nn_1_N = mkN "janitsjarmusik" ;
  januari_nn_1_N = mkN "januari" ;
  jass_nn_1_N = mkN "jass" ;
  java_nn_1_N = mkN "java" ;
  jazz_nn_1_N = mkN "jazz" ;
  jazzifierbarhet_nn_1_N = mkN "jazzifierbarhet" ;
  jazzighet_nn_1_N = mkN "jazzighet" ;
  jerikoros_nn_1_N = mkN "jerikoros" ;
  jet_nn_1_N = mkN "jet" ;
  jetdrift_nn_1_N = mkN "jetdrift" ;
  jiddisch_nn_1_N = mkN "jiddisch" ;
  jiujitsu_nn_1_N = mkN "jiujitsu" ;
  jobbcoachning_nn_1_N = mkN "jobbcoachning" ;
  jobbighet_nn_1_N = mkN "jobbighet" ;
  jod_nn_1_N = mkN "jod" ;
  joderbarhet_nn_1_N = mkN "joderbarhet" ;
  jodoform_nn_1_N = mkN "jodoform" ;
  jodsprit_nn_1_N = mkN "jodsprit" ;
  jogging_nn_1_N = mkN "jogging" ;
  joggning_nn_1_N = mkN "joggning" ;
  jolmighet_nn_1_N = mkN "jolmighet" ;
  jonglerbarhet_nn_1_N = mkN "jonglerbarhet" ;
  joniserbarhet_nn_1_N = mkN "joniserbarhet" ;
  jonosfaer_nn_1_1_N = mkN "jonosfär" ;
  jordaxel_nn_1_N = mkN "jordaxel" ;
  jordbruksforskning_nn_1_N = mkN "jordbruksforskning" ;
  jordbrukspolitik_nn_1_N = mkN "jordbrukspolitik" ;
  jordbundenhet_nn_1_N = mkN "jordbundenhet" ;
  jordbaevningssaekerhet_nn_1_1_N = mkN "jordbävningssäkerhet" ;
  jordemoder_nn_1_N = mkN "jordemoder" ;
  jordflykt_nn_1_N = mkN "jordflykt" ;
  jordgubbssmak_nn_1_N = mkN "jordgubbssmak" ;
  jordighet_nn_1_N = mkN "jordighet" ;
  jordlikhet_nn_1_N = mkN "jordlikhet" ;
  jordmantel_nn_1_N = mkN "jordmantel" ;
  jordmaan_nn_1_1_N = mkN "jordmån" ;
  jordroek_nn_1_1_N = mkN "jordrök" ;
  jordskorpa_nn_1_N = mkN "jordskorpa" ;
  jordskugga_nn_1_N = mkN "jordskugga" ;
  jota_nn_2_N = mkN "jota" ;
  journalistik_nn_1_N = mkN "journalistik" ;
  jourtjaenst_nn_1_1_N = mkN "jourtjänst" ;
  judekristenhet_nn_1_N = mkN "judekristenhet" ;
  judo_nn_1_N = mkN "judo" ;
  jugendstil_nn_1_N = mkN "jugendstil" ;
  julfoersaeljning_nn_1_1_N = mkN "julförsäljning" ;
  juli_nn_1_N = mkN "juli" ;
  julledighet_nn_1_N = mkN "julledighet" ;
  julmust_nn_1_N = mkN "julmust" ;
  julstaemning_nn_1_1_N = mkN "julstämning" ;
  jultrafik_nn_1_N = mkN "jultrafik" ;
  jumpa_nn_1_N = mkN "jumpa" ;
  jungfrulighet_nn_1_N = mkN "jungfrulighet" ;
  juni_nn_1_N = mkN "juni" ;
  juridik_nn_1_N = mkN "juridik" ;
  jurisprudens_nn_1_N = mkN "jurisprudens" ;
  justehet_nn_1_N = mkN "justehet" ;
  justess_nn_1_N = mkN "justess" ;
  justhet_nn_1_N = mkN "justhet" ;
  justis_nn_1_N = mkN "justis" ;
  justitiekansler_nn_1_N = mkN "justitiekansler" ;
  jutskhet_nn_1_N = mkN "jutskhet" ;
  juvelornamentik_nn_1_N = mkN "juvelornamentik" ;
  jympa_nn_1_N = mkN "jympa" ;
  jymping_nn_1_N = mkN "jymping" ;
  jaektighet_nn_1_1_N = mkN "jäktighet" ;
  jaemboerdighet_nn_1_1_N = mkN "jämbördighet" ;
  jaemfoerbarhet_nn_1_1_N = mkN "jämförbarhet" ;
  jaemfoerlighet_nn_1_1_N = mkN "jämförlighet" ;
  jaemgodhet_nn_1_1_N = mkN "jämgodhet" ;
  jaemmerlaat_nn_1_1_N = mkN "jämmerlåt" ;
  jaemngodhet_nn_1_1_N = mkN "jämngodhet" ;
  jaemnhet_nn_1_1_N = mkN "jämnhet" ;
  jaemnstarkhet_nn_1_1_N = mkN "jämnstarkhet" ;
  jaemnstorhet_nn_1_1_N = mkN "jämnstorhet" ;
  jaemntjockhet_nn_1_1_N = mkN "jämntjockhet" ;
  jaemnvarmhet_nn_1_1_N = mkN "jämnvarmhet" ;
  jaemnvikt_nn_1_1_N = mkN "jämnvikt" ;
  jaemnaarighet_nn_1_1_N = mkN "jämnårighet" ;
  jaemspelthet_nn_1_1_N = mkN "jämspelthet" ;
  jaemstarkhet_nn_1_1_N = mkN "jämstarkhet" ;
  jaemstorhet_nn_1_1_N = mkN "jämstorhet" ;
  jaemstaelldhetspolitik_nn_1_1_N = mkN "jämställdhetspolitik" ;
  jaemtjockhet_nn_1_1_N = mkN "jämtjockhet" ;
  jaemtskhet_nn_1_1_N = mkN "jämtskhet" ;
  jaemvikt_nn_1_1_N = mkN "jämvikt" ;
  jaernbetong_nn_1_1_N = mkN "järnbetong" ;
  jaernbrist_nn_1_1_N = mkN "järnbrist" ;
  jaernboerd_nn_1_1_N = mkN "järnbörd" ;
  jaernfysik_nn_1_1_N = mkN "järnfysik" ;
  jaernglans_nn_1_1_N = mkN "järnglans" ;
  jaernhaelsa_nn_1_1_N = mkN "järnhälsa" ;
  jaernhaardhet_nn_1_1_N = mkN "järnhårdhet" ;
  jaernkoll_nn_1_1_N = mkN "järnkoll" ;
  jaernockra_nn_1_1_N = mkN "järnockra" ;
  jaernrikhet_nn_1_1_N = mkN "järnrikhet" ;
  jaernspat_nn_1_1_N = mkN "järnspat" ;
  jaernsvamp_nn_1_1_N = mkN "järnsvamp" ;
  jaernvitriol_nn_1_1_N = mkN "järnvitriol" ;
  jaernvaegspolitik_nn_1_1_N = mkN "järnvägspolitik" ;
  jaernvaegstrafik_nn_1_1_N = mkN "järnvägstrafik" ;
  jaest_nn_1_1_N = mkN "jäst" ;
  jaettedumhet_nn_1_1_N = mkN "jättedumhet" ;
  jaettesnygghet_nn_1_1_N = mkN "jättesnygghet" ;
  jaettesnaellhet_nn_1_1_N = mkN "jättesnällhet" ;
  jaettestorhet_nn_1_1_N = mkN "jättestorhet" ;
  jaettevaext_nn_1_1_N = mkN "jätteväxt" ;
  jaevighet_nn_1_1_N = mkN "jävighet" ;
  joensighet_nn_1_1_N = mkN "jönsighet" ;
  kabbala_nn_1_N = mkN "kabbala" ;
  kabel_teve_nn_1_N = mkN "kabel-teve" ;
  kabeljo_nn_1_N = mkN "kabeljo" ;
  kabelteve_nn_1_N = mkN "kabelteve" ;
  kabinettspolitik_nn_1_N = mkN "kabinettspolitik" ;
  kabinpersonal_nn_1_N = mkN "kabinpersonal" ;
  kadaverdisciplin_nn_1_N = mkN "kadaverdisciplin" ;
  kaffesugenhet_nn_1_N = mkN "kaffesugenhet" ;
  kaffesump_nn_1_N = mkN "kaffesump" ;
  kaffeved_nn_1_N = mkN "kaffeved" ;
  kalandrerbarhet_nn_1_N = mkN "kalandrerbarhet" ;
  kalasmat_nn_1_N = mkN "kalasmat" ;
  kalcinerbarhet_nn_1_N = mkN "kalcinerbarhet" ;
  kalciumklorid_nn_1_N = mkN "kalciumklorid" ;
  kalhet_nn_1_N = mkN "kalhet" ;
  kalibrerbarhet_nn_1_N = mkN "kalibrerbarhet" ;
  kaliforniskhet_nn_1_N = mkN "kaliforniskhet" ;
  kalihunger_nn_1_N = mkN "kalihunger" ;
  kalikaa_nn_1_1_N = mkN "kalikå" ;
  kalilut_nn_1_N = mkN "kalilut" ;
  kalisalpeter_nn_1_N = mkN "kalisalpeter" ;
  kaliumklorid_nn_1_N = mkN "kaliumklorid" ;
  kalkerbarhet_nn_1_N = mkN "kalkerbarhet" ;
  kalkfattighet_nn_1_N = mkN "kalkfattighet" ;
  kalkmjoelk_nn_1_1_N = mkN "kalkmjölk" ;
  kalkputs_nn_1_N = mkN "kalkputs" ;
  kalkrikhet_nn_1_N = mkN "kalkrikhet" ;
  kalkspat_nn_1_N = mkN "kalkspat" ;
  kalkylerbarhet_nn_1_N = mkN "kalkylerbarhet" ;
  kallavfettning_nn_1_N = mkN "kallavfettning" ;
  kallbrand_nn_1_N = mkN "kallbrand" ;
  kallbraecka_nn_1_1_N = mkN "kallbräcka" ;
  kallelseraett_nn_1_1_N = mkN "kallelserätt" ;
  kalljord_nn_1_N = mkN "kalljord" ;
  kallpermanent_nn_1_N = mkN "kallpermanent" ;
  kallsinnighet_nn_1_N = mkN "kallsinnighet" ;
  kallskaal_nn_1_1_N = mkN "kallskål" ;
  kallsvett_nn_1_N = mkN "kallsvett" ;
  kalluft_nn_1_N = mkN "kalluft" ;
  kalmerbarhet_nn_1_N = mkN "kalmerbarhet" ;
  kalmus_nn_1_N = mkN "kalmus" ;
  kalops_nn_1_N = mkN "kalops" ;
  kalorifattighet_nn_1_N = mkN "kalorifattighet" ;
  kaloririkhet_nn_1_N = mkN "kaloririkhet" ;
  kaluv_nn_1_N = mkN "kaluv" ;
  kalvbraess_nn_1_1_N = mkN "kalvbräss" ;
  kalvdans_nn_1_N = mkN "kalvdans" ;
  kalvkyl_nn_1_N = mkN "kalvkyl" ;
  kalvningsfeber_nn_1_N = mkN "kalvningsfeber" ;
  kalvost_nn_1_N = mkN "kalvost" ;
  kambrik_nn_1_N = mkN "kambrik" ;
  kameleontiskhet_nn_1_N = mkN "kameleontiskhet" ;
  kamelmjoelk_nn_1_1_N = mkN "kamelmjölk" ;
  kamelskoetsel_nn_1_1_N = mkN "kamelskötsel" ;
  kamelull_nn_1_N = mkN "kamelull" ;
  kameraoevervakning_nn_1_1_N = mkN "kameraövervakning" ;
  kamfer_nn_1_N = mkN "kamfer" ;
  kamlott_nn_1_N = mkN "kamlott" ;
  kammarduk_nn_1_N = mkN "kammarduk" ;
  kammarmusik_nn_1_N = mkN "kammarmusik" ;
  kamouflerbarhet_nn_1_N = mkN "kamouflerbarhet" ;
  kampanjjournalistik_nn_1_N = mkN "kampanjjournalistik" ;
  kampesch_nn_1_N = mkN "kampesch" ;
  kampkonstnaerlighet_nn_1_1_N = mkN "kampkonstnärlighet" ;
  kampoduglighet_nn_1_N = mkN "kampoduglighet" ;
  kamratanda_nn_1_N = mkN "kamratanda" ;
  kamratkaensla_nn_1_1_N = mkN "kamratkänsla" ;
  kanaliserbarhet_nn_1_N = mkN "kanaliserbarhet" ;
  kanderbarhet_nn_1_N = mkN "kanderbarhet" ;
  kandiderbarhet_nn_1_N = mkN "kandiderbarhet" ;
  kanelbullsdoft_nn_1_N = mkN "kanelbullsdoft" ;
  kangas_nn_1_N = mkN "kangas" ;
  kaninpuls_nn_1_N = mkN "kaninpuls" ;
  kannelerbarhet_nn_1_N = mkN "kannelerbarhet" ;
  kanoneld_nn_1_N = mkN "kanoneld" ;
  kanonfoeda_nn_1_1_N = mkN "kanonföda" ;
  kanoniserbarhet_nn_1_N = mkN "kanoniserbarhet" ;
  kanonmat_nn_1_N = mkN "kanonmat" ;
  kanotpaddling_nn_1_N = mkN "kanotpaddling" ;
  kanslistil_nn_1_N = mkN "kanslistil" ;
  kantighet_nn_1_N = mkN "kantighet" ;
  kantning_nn_1_N = mkN "kantning" ;
  kantstoetthet_nn_1_1_N = mkN "kantstötthet" ;
  kanvas_nn_1_N = mkN "kanvas" ;
  kap_nn_1_N = mkN "kap" ;
  kapacitans_nn_1_N = mkN "kapacitans" ;
  kapillaerkraft_nn_1_1_N = mkN "kapillärkraft" ;
  kapitalexport_nn_1_N = mkN "kapitalexport" ;
  kapitalflykt_nn_1_N = mkN "kapitalflykt" ;
  kapitaliserbarhet_nn_1_N = mkN "kapitaliserbarhet" ;
  kapitalstinnhet_nn_1_N = mkN "kapitalstinnhet" ;
  kapock_nn_1_N = mkN "kapock" ;
  kapprakhet_nn_1_N = mkN "kapprakhet" ;
  kapris_nn_2_N = mkN "kapris" ;
  kaptenloejtnant_nn_1_1_N = mkN "kaptenlöjtnant" ;
  karakteriserbarhet_nn_1_N = mkN "karakteriserbarhet" ;
  karaktaeriserbarhet_nn_1_1_N = mkN "karaktäriserbarhet" ;
  karaktaersfasthet_nn_1_1_N = mkN "karaktärsfasthet" ;
  karaktaersloeshet_nn_1_1_N = mkN "karaktärslöshet" ;
  karambolerbarhet_nn_1_N = mkN "karambolerbarhet" ;
  karamboll_nn_1_N = mkN "karamboll" ;
  karantaensflagg_nn_1_1_N = mkN "karantänsflagg" ;
  karbol_nn_1_N = mkN "karbol" ;
  karboniserbarhet_nn_1_N = mkN "karboniserbarhet" ;
  karbonisering_nn_1_N = mkN "karbonisering" ;
  karburatorsprit_nn_1_N = mkN "karburatorsprit" ;
  kardemumma_nn_1_N = mkN "kardemumma" ;
  kardull_nn_1_N = mkN "kardull" ;
  karens_nn_1_N = mkN "karens" ;
  karenstid_nn_1_N = mkN "karenstid" ;
  karghet_nn_1_N = mkN "karghet" ;
  karies_nn_1_N = mkN "karies" ;
  karikerbarhet_nn_1_N = mkN "karikerbarhet" ;
  karlaktighet_nn_1_N = mkN "karlaktighet" ;
  karlavulenhet_nn_1_N = mkN "karlavulenhet" ;
  karlgalenhet_nn_1_N = mkN "karlgalenhet" ;
  karljohan_nn_1_N = mkN "karljohan" ;
  karljohansstil_nn_1_N = mkN "karljohansstil" ;
  karltokighet_nn_1_N = mkN "karltokighet" ;
  karriaerlystnad_nn_1_1_N = mkN "karriärlystnad" ;
  karskhet_nn_1_N = mkN "karskhet" ;
  karterbarhet_nn_1_N = mkN "karterbarhet" ;
  kartighet_nn_1_N = mkN "kartighet" ;
  kartong_nn_2_N = mkN "kartong" ;
  kartonnerbarhet_nn_1_N = mkN "kartonnerbarhet" ;
  kasper_nn_1_N = mkN "kasper" ;
  kassava_nn_1_N = mkN "kassava" ;
  kasseler_nn_1_N = mkN "kasseler" ;
  kasserbarhet_nn_1_N = mkN "kasserbarhet" ;
  kassettradio_nn_1_N = mkN "kassettradio" ;
  kasshet_nn_1_N = mkN "kasshet" ;
  kassler_nn_1_N = mkN "kassler" ;
  kassunsjuka_nn_1_N = mkN "kassunsjuka" ;
  kasteld_nn_1_N = mkN "kasteld" ;
  kastloeshet_nn_1_1_N = mkN "kastlöshet" ;
  kastor_nn_1_N = mkN "kastor" ;
  kastrerbarhet_nn_1_N = mkN "kastrerbarhet" ;
  kastsjuka_nn_1_N = mkN "kastsjuka" ;
  kasuistik_nn_1_N = mkN "kasuistik" ;
  kasunsjuka_nn_1_N = mkN "kasunsjuka" ;
  katalogiserbarhet_nn_1_N = mkN "katalogiserbarhet" ;
  katalys_nn_1_N = mkN "katalys" ;
  katalyserbarhet_nn_1_N = mkN "katalyserbarhet" ;
  katastrofhantering_nn_1_N = mkN "katastrofhantering" ;
  kategoriserbarhet_nn_1_N = mkN "kategoriserbarhet" ;
  kateteriserbarhet_nn_1_N = mkN "kateteriserbarhet" ;
  katetriserbarhet_nn_1_N = mkN "katetriserbarhet" ;
  katgut_nn_1_N = mkN "katgut" ;
  katighet_nn_1_N = mkN "katighet" ;
  katt_nn_2_N = mkN "katt" ;
  kattaktighet_nn_1_N = mkN "kattaktighet" ;
  kattblick_nn_1_N = mkN "kattblick" ;
  kattfot_nn_1_N = mkN "kattfot" ;
  kattmat_nn_1_N = mkN "kattmat" ;
  kattmynta_nn_1_N = mkN "kattmynta" ;
  kattost_nn_1_N = mkN "kattost" ;
  kattpest_nn_1_N = mkN "kattpest" ;
  kattsand_nn_1_N = mkN "kattsand" ;
  kauteriserbarhet_nn_1_N = mkN "kauteriserbarhet" ;
  kaxighet_nn_1_N = mkN "kaxighet" ;
  kedjehastighet_nn_1_N = mkN "kedjehastighet" ;
  kedjespaenning_nn_1_1_N = mkN "kedjespänning" ;
  kejsar_nn_1_N = mkN "kejsar" ;
  kejsarlikhet_nn_1_N = mkN "kejsarlikhet" ;
  kejsarstil_nn_1_N = mkN "kejsarstil" ;
  kejserlighet_nn_1_N = mkN "kejserlighet" ;
  kelenhet_nn_1_N = mkN "kelenhet" ;
  kelighet_nn_1_N = mkN "kelighet" ;
  kelp_nn_1_N = mkN "kelp" ;
  kelsjukhet_nn_1_N = mkN "kelsjukhet" ;
  kemiteknik_nn_1_N = mkN "kemiteknik" ;
  keramik_nn_1_N = mkN "keramik" ;
  keso_nn_1_N = mkN "keso" ;
  ketchup_nn_1_N = mkN "ketchup" ;
  kevlar_nn_1_N = mkN "kevlar" ;
  kick_off_nn_1_N = mkN "kick-off" ;
  kikhosta_nn_1_N = mkN "kikhosta" ;
  kiliasm_nn_1_N = mkN "kiliasm" ;
  killerinstinkt_nn_1_N = mkN "killerinstinkt" ;
  killighet_nn_1_N = mkN "killighet" ;
  killkaerlek_nn_1_1_N = mkN "killkärlek" ;
  kilskrift_nn_1_N = mkN "kilskrift" ;
  kimroek_nn_1_1_N = mkN "kimrök" ;
  kina_nn_1_N = mkN "kina" ;
  kinabark_nn_1_N = mkN "kinabark" ;
  kinamat_nn_1_N = mkN "kinamat" ;
  kindergarten_nn_1_N = mkN "kindergarten" ;
  kinematik_nn_1_N = mkN "kinematik" ;
  kinetik_nn_1_N = mkN "kinetik" ;
  kinkighet_nn_1_N = mkN "kinkighet" ;
  kiosklitteratur_nn_1_N = mkN "kiosklitteratur" ;
  kiropraktik_nn_1_N = mkN "kiropraktik" ;
  kirskaal_nn_1_1_N = mkN "kirskål" ;
  kiselkarbid_nn_1_N = mkN "kiselkarbid" ;
  kissnoedighet_nn_1_1_N = mkN "kissnödighet" ;
  kittlighet_nn_1_N = mkN "kittlighet" ;
  kjolloeshet_nn_1_1_N = mkN "kjollöshet" ;
  kladdighet_nn_1_N = mkN "kladdighet" ;
  kladistik_nn_1_N = mkN "kladistik" ;
  klagolaat_nn_1_1_N = mkN "klagolåt" ;
  klamydia_nn_1_N = mkN "klamydia" ;
  klandervaerdhet_nn_1_1_N = mkN "klandervärdhet" ;
  klangfullhet_nn_1_N = mkN "klangfullhet" ;
  klangloeshet_nn_1_1_N = mkN "klanglöshet" ;
  klapper_nn_2_N = mkN "klapper" ;
  klappgroet_nn_1_1_N = mkN "klappgröt" ;
  klappshopping_nn_1_N = mkN "klappshopping" ;
  klarerbarhet_nn_1_N = mkN "klarerbarhet" ;
  klarsyn_nn_1_N = mkN "klarsyn" ;
  klarsynthet_nn_1_N = mkN "klarsynthet" ;
  klartext_nn_1_N = mkN "klartext" ;
  klartaenkthet_nn_1_1_N = mkN "klartänkthet" ;
  klarvakenhet_nn_1_N = mkN "klarvakenhet" ;
  klaroegdhet_nn_1_1_N = mkN "klarögdhet" ;
  klassificerbarhet_nn_1_N = mkN "klassificerbarhet" ;
  klassloeshet_nn_1_1_N = mkN "klasslöshet" ;
  klassmedvetenhet_nn_1_N = mkN "klassmedvetenhet" ;
  klasstillhoerighet_nn_1_1_N = mkN "klasstillhörighet" ;
  klatschighet_nn_1_N = mkN "klatschighet" ;
  klemighet_nn_1_N = mkN "klemighet" ;
  klenhet_nn_1_N = mkN "klenhet" ;
  klenmodighet_nn_1_N = mkN "klenmodighet" ;
  klentrogenhet_nn_1_N = mkN "klentrogenhet" ;
  klenvuxenhet_nn_1_N = mkN "klenvuxenhet" ;
  klibbighet_nn_1_N = mkN "klibbighet" ;
  klimatalarmism_nn_1_N = mkN "klimatalarmism" ;
  klimatforskning_nn_1_N = mkN "klimatforskning" ;
  klimatstatistik_nn_1_N = mkN "klimatstatistik" ;
  klimataangest_nn_1_1_N = mkN "klimatångest" ;
  klippighet_nn_1_N = mkN "klippighet" ;
  klistervalla_nn_1_N = mkN "klistervalla" ;
  klistrighet_nn_1_N = mkN "klistrighet" ;
  klockarfar_nn_1_N = mkN "klockarfar" ;
  klockform_nn_1_N = mkN "klockform" ;
  klockljung_nn_1_N = mkN "klockljung" ;
  klockradio_nn_1_N = mkN "klockradio" ;
  klockrenhet_nn_1_N = mkN "klockrenhet" ;
  klor_nn_1_N = mkN "klor" ;
  klorerbarhet_nn_1_N = mkN "klorerbarhet" ;
  klorex_nn_1_N = mkN "klorex" ;
  klorkalk_nn_1_N = mkN "klorkalk" ;
  kloroform_nn_1_N = mkN "kloroform" ;
  klossighet_nn_1_N = mkN "klossighet" ;
  klot_nn_2_N = mkN "klot" ;
  klotrundhet_nn_1_N = mkN "klotrundhet" ;
  klotsporighet_nn_1_N = mkN "klotsporighet" ;
  klottrighet_nn_1_N = mkN "klottrighet" ;
  klumpfot_nn_1_N = mkN "klumpfot" ;
  klunsighet_nn_1_N = mkN "klunsighet" ;
  klyftighet_nn_1_N = mkN "klyftighet" ;
  klyftpotatis_nn_1_N = mkN "klyftpotatis" ;
  klyschighet_nn_1_N = mkN "klyschighet" ;
  klyvbarhet_nn_1_N = mkN "klyvbarhet" ;
  klaedgalenhet_nn_1_1_N = mkN "klädgalenhet" ;
  klaedpoker_nn_1_1_N = mkN "klädpoker" ;
  klaedsamhet_nn_1_1_N = mkN "klädsamhet" ;
  klaedsoemnad_nn_1_1_N = mkN "klädsömnad" ;
  klaemmighet_nn_1_1_N = mkN "klämmighet" ;
  klaengighet_nn_1_1_N = mkN "klängighet" ;
  klaervoajans_nn_1_1_N = mkN "klärvoajans" ;
  klaada_nn_1_1_N = mkN "klåda" ;
  klaafingrighet_nn_1_1_N = mkN "klåfingrighet" ;
  kloevertroetthet_nn_1_1_N = mkN "klövertrötthet" ;
  knack_nn_2_N = mkN "knack" ;
  knackighet_nn_1_N = mkN "knackighet" ;
  knalhet_nn_1_N = mkN "knalhet" ;
  knallgas_nn_1_N = mkN "knallgas" ;
  knallhet_nn_1_N = mkN "knallhet" ;
  knapphaendighet_nn_1_1_N = mkN "knapphändighet" ;
  knaprighet_nn_1_N = mkN "knaprighet" ;
  knarkbekaempning_nn_1_1_N = mkN "knarkbekämpning" ;
  knarklangning_nn_1_N = mkN "knarklangning" ;
  knarksmuggling_nn_1_N = mkN "knarksmuggling" ;
  knarrighet_nn_1_N = mkN "knarrighet" ;
  knasprighet_nn_1_N = mkN "knasprighet" ;
  knastrighet_nn_1_N = mkN "knastrighet" ;
  knipslughet_nn_1_N = mkN "knipslughet" ;
  knittel_nn_1_N = mkN "knittel" ;
  knivskarphet_nn_1_N = mkN "knivskarphet" ;
  knoppighet_nn_1_N = mkN "knoppighet" ;
  knottrighet_nn_1_N = mkN "knottrighet" ;
  knubbighet_nn_1_N = mkN "knubbighet" ;
  knyckighet_nn_1_N = mkN "knyckighet" ;
  knaeckthet_nn_1_1_N = mkN "knäckthet" ;
  knaepphet_nn_1_1_N = mkN "knäpphet" ;
  knaesittning_nn_1_1_N = mkN "knäsittning" ;
  knaesvaghet_nn_1_1_N = mkN "knäsvaghet" ;
  knaadbarhet_nn_1_1_N = mkN "knådbarhet" ;
  knoekfullhet_nn_1_1_N = mkN "knökfullhet" ;
  knoelaktighet_nn_1_1_N = mkN "knölaktighet" ;
  knoelros_nn_1_1_N = mkN "knölros" ;
  koafferbarhet_nn_1_N = mkN "koafferbarhet" ;
  koagulerbarhet_nn_1_N = mkN "koagulerbarhet" ;
  kobenthet_nn_1_N = mkN "kobenthet" ;
  kobingo_nn_1_N = mkN "kobingo" ;
  kobolt_nn_1_N = mkN "kobolt" ;
  koboltglans_nn_1_N = mkN "koboltglans" ;
  kod_nn_2_N = mkN "kod" ;
  kodifierbarhet_nn_1_N = mkN "kodifierbarhet" ;
  kodilj_nn_1_N = mkN "kodilj" ;
  koexistens_nn_1_N = mkN "koexistens" ;
  koherens_nn_1_N = mkN "koherens" ;
  koineisering_nn_1_N = mkN "koineisering" ;
  koka_nn_2_N = mkN "koka" ;
  koketthet_nn_1_N = mkN "koketthet" ;
  kokkonst_nn_1_N = mkN "kokkonst" ;
  kokos_nn_1_N = mkN "kokos" ;
  kokosmjoelk_nn_1_1_N = mkN "kokosmjölk" ;
  koks_nn_1_N = mkN "koks" ;
  kol_14_metod_nn_1_N = mkN "kol-14-metod" ;
  koldioxidavskiljning_nn_1_N = mkN "koldioxidavskiljning" ;
  koldioxidlagring_nn_1_N = mkN "koldioxidlagring" ;
  koldisulfid_nn_1_N = mkN "koldisulfid" ;
  kolera_nn_1_N = mkN "kolera" ;
  kolik_nn_1_N = mkN "kolik" ;
  kolit_nn_1_N = mkN "kolit" ;
  koll_nn_2_N = mkN "koll" ;
  kollastkapacitet_nn_1_N = mkN "kollastkapacitet" ;
  kollationerbarhet_nn_1_N = mkN "kollationerbarhet" ;
  kollekta_nn_1_N = mkN "kollekta" ;
  kollektiviserbarhet_nn_1_N = mkN "kollektiviserbarhet" ;
  kollektivtrafik_nn_1_N = mkN "kollektivtrafik" ;
  koller_nn_1_N = mkN "koller" ;
  kollrighet_nn_1_N = mkN "kollrighet" ;
  kolm_nn_1_N = mkN "kolm" ;
  kolmilning_nn_1_N = mkN "kolmilning" ;
  kolmonoxid_nn_1_N = mkN "kolmonoxid" ;
  kolon_nn_2_N = mkN "kolon" ;
  kolonialpolitik_nn_1_N = mkN "kolonialpolitik" ;
  kolonialstil_nn_1_N = mkN "kolonialstil" ;
  kolonialtid_nn_1_N = mkN "kolonialtid" ;
  koloniserbarhet_nn_1_N = mkN "koloniserbarhet" ;
  kolorerbarhet_nn_1_N = mkN "kolorerbarhet" ;
  koloxid_nn_1_N = mkN "koloxid" ;
  kolportagemaessighet_nn_1_1_N = mkN "kolportagemässighet" ;
  kolporterbarhet_nn_1_N = mkN "kolporterbarhet" ;
  kolstybb_nn_1_N = mkN "kolstybb" ;
  kolsvavla_nn_1_N = mkN "kolsvavla" ;
  kolsyresnoe_nn_1_1_N = mkN "kolsyresnö" ;
  koltetraklorid_nn_1_N = mkN "koltetraklorid" ;
  kombinabilitet_nn_1_N = mkN "kombinabilitet" ;
  kombinerbarhet_nn_1_N = mkN "kombinerbarhet" ;
  komfort_nn_1_N = mkN "komfort" ;
  komik_nn_1_N = mkN "komik" ;
  komjoelk_nn_1_1_N = mkN "komjölk" ;
  kommandoton_nn_1_N = mkN "kommandoton" ;
  kommaterbarhet_nn_1_N = mkN "kommaterbarhet" ;
  kommenderbarhet_nn_1_N = mkN "kommenderbarhet" ;
  kommenterbarhet_nn_1_N = mkN "kommenterbarhet" ;
  kommersialiserbarhet_nn_1_N = mkN "kommersialiserbarhet" ;
  kommiss_nn_1_N = mkN "kommiss" ;
  kommunaliserbarhet_nn_1_N = mkN "kommunaliserbarhet" ;
  kommunicerbarhet_nn_1_N = mkN "kommunicerbarhet" ;
  kommuterbarhet_nn_1_N = mkN "kommuterbarhet" ;
  kompakthet_nn_1_N = mkN "kompakthet" ;
  kompanjonskap_nn_1_N = mkN "kompanjonskap" ;
  komparerbarhet_nn_1_N = mkN "komparerbarhet" ;
  kompenserbarhet_nn_1_N = mkN "kompenserbarhet" ;
  kompetensutveckling_nn_1_N = mkN "kompetensutveckling" ;
  kompilerbarhet_nn_1_N = mkN "kompilerbarhet" ;
  kompledighet_nn_1_N = mkN "kompledighet" ;
  kompletterbarhet_nn_1_N = mkN "kompletterbarhet" ;
  kompletthet_nn_1_N = mkN "kompletthet" ;
  komplexhet_nn_1_N = mkN "komplexhet" ;
  komplicerbarhet_nn_1_N = mkN "komplicerbarhet" ;
  komplimenterbarhet_nn_1_N = mkN "komplimenterbarhet" ;
  komponerbarhet_nn_1_N = mkN "komponerbarhet" ;
  komposterbarhet_nn_1_N = mkN "komposterbarhet" ;
  komposteringsbarhet_nn_1_N = mkN "komposteringsbarhet" ;
  komprimerbarhet_nn_1_N = mkN "komprimerbarhet" ;
  komprometterbarhet_nn_1_N = mkN "komprometterbarhet" ;
  kompromissloeshet_nn_1_1_N = mkN "kompromisslöshet" ;
  koncentrerbarhet_nn_1_N = mkN "koncentrerbarhet" ;
  koncessionerbarhet_nn_1_N = mkN "koncessionerbarhet" ;
  koncilians_nn_1_N = mkN "koncilians" ;
  koncipierbarhet_nn_1_N = mkN "koncipierbarhet" ;
  koncishet_nn_1_N = mkN "koncishet" ;
  kondemnerbarhet_nn_1_N = mkN "kondemnerbarhet" ;
  kondenserbarhet_nn_1_N = mkN "kondenserbarhet" ;
  kondis_nn_2_N = mkN "kondis" ;
  konditionerbarhet_nn_1_N = mkN "konditionerbarhet" ;
  kondolerbarhet_nn_1_N = mkN "kondolerbarhet" ;
  konduktans_nn_1_N = mkN "konduktans" ;
  konfekt_nn_1_N = mkN "konfekt" ;
  konfessionsloeshet_nn_1_1_N = mkN "konfessionslöshet" ;
  konfirmandundervisning_nn_1_N = mkN "konfirmandundervisning" ;
  konfirmerbarhet_nn_1_N = mkN "konfirmerbarhet" ;
  konfiskerbarhet_nn_1_N = mkN "konfiskerbarhet" ;
  konfliktraedsla_nn_1_1_N = mkN "konflikträdsla" ;
  konfliktskygghet_nn_1_N = mkN "konfliktskygghet" ;
  konfronterbarhet_nn_1_N = mkN "konfronterbarhet" ;
  konfunderbarhet_nn_1_N = mkN "konfunderbarhet" ;
  kongruenthet_nn_1_N = mkN "kongruenthet" ;
  kongruerbarhet_nn_1_N = mkN "kongruerbarhet" ;
  konjugerbarhet_nn_1_N = mkN "konjugerbarhet" ;
  konjunktivit_nn_1_N = mkN "konjunktivit" ;
  konjunkturpolitik_nn_1_N = mkN "konjunkturpolitik" ;
  konkluderbarhet_nn_1_N = mkN "konkluderbarhet" ;
  konkrethet_nn_1_N = mkN "konkrethet" ;
  konkretiserbarhet_nn_1_N = mkN "konkretiserbarhet" ;
  konkurrens_nn_1_N = mkN "konkurrens" ;
  konkurrenskraft_nn_1_N = mkN "konkurrenskraft" ;
  konkurrensutsatthet_nn_1_N = mkN "konkurrensutsatthet" ;
  konkursmaessighet_nn_1_1_N = mkN "konkursmässighet" ;
  konsekventhet_nn_1_N = mkN "konsekventhet" ;
  konsensus_nn_1_N = mkN "konsensus" ;
  konserverbarhet_nn_1_N = mkN "konserverbarhet" ;
  konsignerbarhet_nn_1_N = mkN "konsignerbarhet" ;
  konsoliderbarhet_nn_1_N = mkN "konsoliderbarhet" ;
  konstans_nn_1_N = mkN "konstans" ;
  konstaterbarhet_nn_1_N = mkN "konstaterbarhet" ;
  konsternerbarhet_nn_1_N = mkN "konsternerbarhet" ;
  konstflit_nn_1_N = mkN "konstflit" ;
  konstfoerfarenhet_nn_1_1_N = mkN "konstförfarenhet" ;
  konstgjordhet_nn_1_N = mkN "konstgjordhet" ;
  konstgoedsel_nn_1_1_N = mkN "konstgödsel" ;
  konstituerbarhet_nn_1_N = mkN "konstituerbarhet" ;
  konstkritik_nn_1_N = mkN "konstkritik" ;
  konstmusik_nn_1_N = mkN "konstmusik" ;
  konstmaessighet_nn_1_1_N = mkN "konstmässighet" ;
  konstnaerlighet_nn_1_1_N = mkN "konstnärlighet" ;
  konstnaersblick_nn_1_1_N = mkN "konstnärsblick" ;
  konstnaerstaethet_nn_1_1_N = mkN "konstnärstäthet" ;
  konstrikhet_nn_1_N = mkN "konstrikhet" ;
  konstruerbarhet_nn_1_N = mkN "konstruerbarhet" ;
  konstskicklighet_nn_1_N = mkN "konstskicklighet" ;
  konstsloejd_nn_1_1_N = mkN "konstslöjd" ;
  konsulterbarhet_nn_1_N = mkN "konsulterbarhet" ;
  konsumentpolitik_nn_1_N = mkN "konsumentpolitik" ;
  konsumerbarhet_nn_1_N = mkN "konsumerbarhet" ;
  kontaminerbarhet_nn_1_N = mkN "kontaminerbarhet" ;
  kontenans_nn_1_N = mkN "kontenans" ;
  kontenta_nn_1_N = mkN "kontenta" ;
  konterbarhet_nn_1_N = mkN "konterbarhet" ;
  kontinentaldrift_nn_1_N = mkN "kontinentaldrift" ;
  kontingenterbarhet_nn_1_N = mkN "kontingenterbarhet" ;
  kontinuerlighet_nn_1_N = mkN "kontinuerlighet" ;
  kontoriserbarhet_nn_1_N = mkN "kontoriserbarhet" ;
  kontraherbarhet_nn_1_N = mkN "kontraherbarhet" ;
  kontrakterbarhet_nn_1_N = mkN "kontrakterbarhet" ;
  kontraktsenlighet_nn_1_N = mkN "kontraktsenlighet" ;
  kontraktsvidrighet_nn_1_N = mkN "kontraktsvidrighet" ;
  kontramanderbarhet_nn_1_N = mkN "kontramanderbarhet" ;
  kontraoktav_nn_1_N = mkN "kontraoktav" ;
  kontrapunkt_nn_1_N = mkN "kontrapunkt" ;
  kontrasignerbarhet_nn_1_N = mkN "kontrasignerbarhet" ;
  kontrasterbarhet_nn_1_N = mkN "kontrasterbarhet" ;
  kontribuerbarhet_nn_1_N = mkN "kontribuerbarhet" ;
  kontroll_nn_1_N = mkN "kontroll" ;
  kontrollerbarhet_nn_1_N = mkN "kontrollerbarhet" ;
  konturerbarhet_nn_1_N = mkN "konturerbarhet" ;
  konturloeshet_nn_1_1_N = mkN "konturlöshet" ;
  konturskarphet_nn_1_N = mkN "konturskarphet" ;
  konungslighet_nn_1_N = mkN "konungslighet" ;
  konvalescens_nn_1_N = mkN "konvalescens" ;
  konvenans_nn_1_N = mkN "konvenans" ;
  konvergens_nn_1_N = mkN "konvergens" ;
  konvergerbarhet_nn_1_N = mkN "konvergerbarhet" ;
  konverserbarhet_nn_1_N = mkN "konverserbarhet" ;
  konverterbarhet_nn_1_N = mkN "konverterbarhet" ;
  konvojerbarhet_nn_1_N = mkN "konvojerbarhet" ;
  koordinerbarhet_nn_1_N = mkN "koordinerbarhet" ;
  kopierbarhet_nn_1_N = mkN "kopierbarhet" ;
  kopparglans_nn_1_N = mkN "kopparglans" ;
  kopparkis_nn_1_N = mkN "kopparkis" ;
  kopparaerg_nn_1_1_N = mkN "kopparärg" ;
  koppaerrighet_nn_1_1_N = mkN "koppärrighet" ;
  kopra_nn_1_N = mkN "kopra" ;
  koran_nn_1_N = mkN "koran" ;
  kord_nn_1_N = mkN "kord" ;
  korderoj_nn_1_N = mkN "korderoj" ;
  korgboll_nn_1_N = mkN "korgboll" ;
  koriander_nn_1_N = mkN "koriander" ;
  korndraell_nn_1_1_N = mkN "korndräll" ;
  kornighet_nn_1_N = mkN "kornighet" ;
  kornsnoe_nn_1_1_N = mkN "kornsnö" ;
  koronarskleros_nn_1_N = mkN "koronarskleros" ;
  korplaat_nn_1_1_N = mkN "korplåt" ;
  korpning_nn_1_N = mkN "korpning" ;
  korporationsidrott_nn_1_N = mkN "korporationsidrott" ;
  korpulens_nn_1_N = mkN "korpulens" ;
  korpuslingvistik_nn_1_N = mkN "korpuslingvistik" ;
  korrekthet_nn_1_N = mkN "korrekthet" ;
  korrelerbarhet_nn_1_N = mkN "korrelerbarhet" ;
  korridorpolitik_nn_1_N = mkN "korridorpolitik" ;
  korrigerbarhet_nn_1_N = mkN "korrigerbarhet" ;
  korroderbarhet_nn_1_N = mkN "korroderbarhet" ;
  korrugerbarhet_nn_1_N = mkN "korrugerbarhet" ;
  korrumperbarhet_nn_1_N = mkN "korrumperbarhet" ;
  korrupthet_nn_1_N = mkN "korrupthet" ;
  korruptionsbekaempning_nn_1_1_N = mkN "korruptionsbekämpning" ;
  korsetterbarhet_nn_1_N = mkN "korsetterbarhet" ;
  korsvaedring_nn_1_1_N = mkN "korsvädring" ;
  kortbenthet_nn_1_N = mkN "kortbenthet" ;
  kortfristighet_nn_1_N = mkN "kortfristighet" ;
  korthuggenhet_nn_1_N = mkN "korthuggenhet" ;
  korthaarighet_nn_1_1_N = mkN "korthårighet" ;
  kortklippning_nn_1_N = mkN "kortklippning" ;
  kortklippthet_nn_1_N = mkN "kortklippthet" ;
  kortsiktighet_nn_1_N = mkN "kortsiktighet" ;
  kortskallighet_nn_1_N = mkN "kortskallighet" ;
  kortsynthet_nn_1_N = mkN "kortsynthet" ;
  korttidsfoervaring_nn_1_1_N = mkN "korttidsförvaring" ;
  korttaenkthet_nn_1_1_N = mkN "korttänkthet" ;
  kortvarighet_nn_1_N = mkN "kortvarighet" ;
  kortvuxenhet_nn_1_N = mkN "kortvuxenhet" ;
  kortvaexthet_nn_1_1_N = mkN "kortväxthet" ;
  korvighet_nn_1_N = mkN "korvighet" ;
  kosa_nn_2_N = mkN "kosa" ;
  koschenill_nn_1_N = mkN "koschenill" ;
  koskit_nn_1_N = mkN "koskit" ;
  kosmetik_nn_1_N = mkN "kosmetik" ;
  kosmetika_nn_1_N = mkN "kosmetika" ;
  kost_nn_1_N = mkN "kost" ;
  kostlighet_nn_1_N = mkN "kostlighet" ;
  kostsamhet_nn_1_N = mkN "kostsamhet" ;
  kostymerbarhet_nn_1_N = mkN "kostymerbarhet" ;
  kova_nn_1_N = mkN "kova" ;
  kox_nn_1_N = mkN "kox" ;
  kooegdhet_nn_1_1_N = mkN "koögdhet" ;
  krabbhet_nn_1_N = mkN "krabbhet" ;
  krackelerbarhet_nn_1_N = mkN "krackelerbarhet" ;
  krackelyr_nn_1_N = mkN "krackelyr" ;
  krafsighet_nn_1_N = mkN "krafsighet" ;
  kraftfullhet_nn_1_N = mkN "kraftfullhet" ;
  kraftighet_nn_1_N = mkN "kraftighet" ;
  kraftnedsaettning_nn_1_1_N = mkN "kraftnedsättning" ;
  kraftutveckling_nn_1_N = mkN "kraftutveckling" ;
  kragloeshet_nn_1_1_N = mkN "kraglöshet" ;
  kramhet_nn_1_N = mkN "kramhet" ;
  krampaktighet_nn_1_N = mkN "krampaktighet" ;
  kramsnoe_nn_1_1_N = mkN "kramsnö" ;
  krankhet_nn_1_N = mkN "krankhet" ;
  krapp_nn_1_N = mkN "krapp" ;
  krasshet_nn_1_N = mkN "krasshet" ;
  kravallpolis_nn_1_N = mkN "kravallpolis" ;
  kravloeshet_nn_1_1_N = mkN "kravlöshet" ;
  kravretorik_nn_1_N = mkN "kravretorik" ;
  kreationism_nn_1_N = mkN "kreationism" ;
  kreatursloeshet_nn_1_1_N = mkN "kreaturslöshet" ;
  kreatursskoetsel_nn_1_1_N = mkN "kreatursskötsel" ;
  kredd_nn_1_N = mkN "kredd" ;
  kreddighet_nn_1_N = mkN "kreddighet" ;
  krediterbarhet_nn_1_N = mkN "krediterbarhet" ;
  kreerbarhet_nn_1_N = mkN "kreerbarhet" ;
  kremerbarhet_nn_1_N = mkN "kremerbarhet" ;
  kremlvaenlighet_nn_1_1_N = mkN "kremlvänlighet" ;
  kreolisering_nn_1_N = mkN "kreolisering" ;
  kreoliseringsforskning_nn_1_N = mkN "kreoliseringsforskning" ;
  kreperbarhet_nn_1_N = mkN "kreperbarhet" ;
  kreverbarhet_nn_1_N = mkN "kreverbarhet" ;
  kricket_nn_1_N = mkN "kricket" ;
  krigarkast_nn_1_N = mkN "krigarkast" ;
  krigsiver_nn_1_N = mkN "krigsiver" ;
  krigskonst_nn_1_N = mkN "krigskonst" ;
  krigslist_nn_1_N = mkN "krigslist" ;
  krigslycka_nn_1_N = mkN "krigslycka" ;
  krigsplacerbarhet_nn_1_N = mkN "krigsplacerbarhet" ;
  krigspropaganda_nn_1_N = mkN "krigspropaganda" ;
  krigsraett_nn_1_1_N = mkN "krigsrätt" ;
  krigstjaenst_nn_1_1_N = mkN "krigstjänst" ;
  krigstroetthet_nn_1_1_N = mkN "krigströtthet" ;
  krill_nn_1_N = mkN "krill" ;
  kriminaliserbarhet_nn_1_N = mkN "kriminaliserbarhet" ;
  kriminalistik_nn_1_N = mkN "kriminalistik" ;
  kriminaljournalistik_nn_1_N = mkN "kriminaljournalistik" ;
  kriminalpolis_nn_1_N = mkN "kriminalpolis" ;
  kriminalpolitik_nn_1_N = mkN "kriminalpolitik" ;
  kriminalteknik_nn_1_N = mkN "kriminalteknik" ;
  kriminalvaard_nn_1_1_N = mkN "kriminalvård" ;
  kringsjuka_nn_1_N = mkN "kringsjuka" ;
  kringsyn_nn_1_N = mkN "kringsyn" ;
  kringsynthet_nn_1_N = mkN "kringsynthet" ;
  krishantering_nn_1_N = mkN "krishantering" ;
  krishjaelp_nn_1_1_N = mkN "krishjälp" ;
  krismedvetenhet_nn_1_N = mkN "krismedvetenhet" ;
  krispighet_nn_1_N = mkN "krispighet" ;
  krispolitik_nn_1_N = mkN "krispolitik" ;
  kristalliserbarhet_nn_1_N = mkN "kristalliserbarhet" ;
  kristallos_nn_1_N = mkN "kristallos" ;
  kristlighet_nn_1_N = mkN "kristlighet" ;
  kristtrogenhet_nn_1_N = mkN "kristtrogenhet" ;
  kristyr_nn_1_N = mkN "kristyr" ;
  kritiklust_nn_1_N = mkN "kritiklust" ;
  kritikloeshet_nn_1_1_N = mkN "kritiklöshet" ;
  kritiserbarhet_nn_1_N = mkN "kritiserbarhet" ;
  krittid_nn_1_N = mkN "krittid" ;
  krocket_nn_1_N = mkN "krocket" ;
  krokant_nn_1_N = mkN "krokant" ;
  kroknaesthet_nn_1_1_N = mkN "kroknästhet" ;
  krokryggighet_nn_1_N = mkN "krokryggighet" ;
  krokvuxenhet_nn_1_N = mkN "krokvuxenhet" ;
  krollsplint_nn_1_N = mkN "krollsplint" ;
  kromatik_nn_1_N = mkN "kromatik" ;
  kromning_nn_1_N = mkN "kromning" ;
  kroppsaga_nn_1_N = mkN "kroppsaga" ;
  kroppsbehaaring_nn_1_1_N = mkN "kroppsbehåring" ;
  kroppskontakt_nn_1_N = mkN "kroppskontakt" ;
  kroppskontroll_nn_1_N = mkN "kroppskontroll" ;
  kroppskultur_nn_1_N = mkN "kroppskultur" ;
  kroppslighet_nn_2_N = mkN "kroppslighet" ;
  kroppspulsaader_nn_1_1_N = mkN "kroppspulsåder" ;
  kroppstyngd_nn_1_N = mkN "kroppstyngd" ;
  kroppsvisiterbarhet_nn_1_N = mkN "kroppsvisiterbarhet" ;
  krullhaarighet_nn_1_1_N = mkN "krullhårighet" ;
  krullighet_nn_1_N = mkN "krullighet" ;
  krumhet_nn_1_N = mkN "krumhet" ;
  krumpenhet_nn_1_N = mkN "krumpenhet" ;
  krupp_nn_1_N = mkN "krupp" ;
  kruserlighet_nn_1_N = mkN "kruserlighet" ;
  krushaarighet_nn_1_1_N = mkN "krushårighet" ;
  krusidullighet_nn_1_N = mkN "krusidullighet" ;
  kruska_nn_1_N = mkN "kruska" ;
  kruskaal_nn_1_1_N = mkN "kruskål" ;
  krusmynta_nn_1_N = mkN "krusmynta" ;
  kruspersilja_nn_1_N = mkN "kruspersilja" ;
  krutroek_nn_1_1_N = mkN "krutrök" ;
  kruttorrhet_nn_1_N = mkN "kruttorrhet" ;
  kryckestaat_nn_1_1_N = mkN "kryckeståt" ;
  kryckighet_nn_1_N = mkN "kryckighet" ;
  kryhet_nn_1_N = mkN "kryhet" ;
  kryolit_nn_1_N = mkN "kryolit" ;
  krypterbarhet_nn_1_N = mkN "krypterbarhet" ;
  kryss_nn_2_N = mkN "kryss" ;
  kraeftgaang_nn_1_1_N = mkN "kräftgång" ;
  kraeftpest_nn_1_1_N = mkN "kräftpest" ;
  kraekfaerdighet_nn_1_1_N = mkN "kräkfärdighet" ;
  kraem_nn_2_1_N = mkN "kräm" ;
  kraepp_nn_1_1_N = mkN "kräpp" ;
  kraesenhet_nn_1_1_N = mkN "kräsenhet" ;
  kraeslighet_nn_1_1_N = mkN "kräslighet" ;
  kraakspark_nn_1_1_N = mkN "kråkspark" ;
  kraaksaang_nn_1_1_N = mkN "kråksång" ;
  kraakvicker_nn_1_1_N = mkN "kråkvicker" ;
  kraakvinkel_nn_1_1_N = mkN "kråkvinkel" ;
  kraamning_nn_1_1_N = mkN "kråmning" ;
  kroekthet_nn_1_1_N = mkN "krökthet" ;
  kuberbarhet_nn_1_N = mkN "kuberbarhet" ;
  kujonerbarhet_nn_1_N = mkN "kujonerbarhet" ;
  kulenhet_nn_1_N = mkN "kulenhet" ;
  kull_nn_2_N = mkN "kull" ;
  kullighet_nn_1_N = mkN "kullighet" ;
  kullrighet_nn_1_N = mkN "kullrighet" ;
  kulsinter_nn_1_N = mkN "kulsinter" ;
  kultis_nn_1_N = mkN "kultis" ;
  kultiverbarhet_nn_1_N = mkN "kultiverbarhet" ;
  kulturarrogans_nn_1_N = mkN "kulturarrogans" ;
  kulturfientlighet_nn_1_N = mkN "kulturfientlighet" ;
  kulturjournalistik_nn_1_N = mkN "kulturjournalistik" ;
  kulturminnesvaard_nn_1_1_N = mkN "kulturminnesvård" ;
  kulturpolitik_nn_1_N = mkN "kulturpolitik" ;
  kultursvaeng_nn_1_1_N = mkN "kultursväng" ;
  kuloerthet_nn_1_1_N = mkN "kulörthet" ;
  kumulerbarhet_nn_1_N = mkN "kumulerbarhet" ;
  kumys_nn_1_N = mkN "kumys" ;
  kundnoejdhet_nn_1_1_N = mkN "kundnöjdhet" ;
  kundtjaenst_nn_1_1_N = mkN "kundtjänst" ;
  kungaglans_nn_1_N = mkN "kungaglans" ;
  kunnighet_nn_1_N = mkN "kunnighet" ;
  kunskapshunger_nn_1_N = mkN "kunskapshunger" ;
  kunskapstoerst_nn_1_1_N = mkN "kunskapstörst" ;
  kuperbarhet_nn_1_N = mkN "kuperbarhet" ;
  kupighet_nn_1_N = mkN "kupighet" ;
  kupolformighet_nn_1_N = mkN "kupolformighet" ;
  kuppberedskap_nn_1_N = mkN "kuppberedskap" ;
  kuraterbarhet_nn_1_N = mkN "kuraterbarhet" ;
  kurerbarhet_nn_1_N = mkN "kurerbarhet" ;
  kurialstil_nn_1_N = mkN "kurialstil" ;
  kurra_nn_1_N = mkN "kurra" ;
  kurragoemma_nn_1_1_N = mkN "kurragömma" ;
  kursiverbarhet_nn_1_N = mkN "kursiverbarhet" ;
  kurtiserbarhet_nn_1_N = mkN "kurtiserbarhet" ;
  kurvighet_nn_1_N = mkN "kurvighet" ;
  kurvteknik_nn_1_N = mkN "kurvteknik" ;
  kustfart_nn_1_N = mkN "kustfart" ;
  kustradio_nn_1_N = mkN "kustradio" ;
  kusttrafik_nn_1_N = mkN "kusttrafik" ;
  kutryggighet_nn_1_N = mkN "kutryggighet" ;
  kuverterbarhet_nn_1_N = mkN "kuverterbarhet" ;
  kvacksalverilagstiftning_nn_1_N = mkN "kvacksalverilagstiftning" ;
  kvadratur_nn_1_N = mkN "kvadratur" ;
  kvadrerbarhet_nn_1_N = mkN "kvadrerbarhet" ;
  kvalfullhet_nn_1_N = mkN "kvalfullhet" ;
  kvalfylldhet_nn_1_N = mkN "kvalfylldhet" ;
  kvalificerbarhet_nn_1_N = mkN "kvalificerbarhet" ;
  kvalitetstid_nn_1_N = mkN "kvalitetstid" ;
  kvantelektrodynamik_nn_1_N = mkN "kvantelektrodynamik" ;
  kvantfysik_nn_1_N = mkN "kvantfysik" ;
  kvantifierbarhet_nn_1_N = mkN "kvantifierbarhet" ;
  kvantmekanik_nn_1_N = mkN "kvantmekanik" ;
  kvarg_nn_1_N = mkN "kvarg" ;
  kvark_nn_2_N = mkN "kvark" ;
  kvarka_nn_1_N = mkN "kvarka" ;
  kvarlaatenskap_nn_1_1_N = mkN "kvarlåtenskap" ;
  kvarto_nn_1_N = mkN "kvarto" ;
  kvass_nn_2_N = mkN "kvass" ;
  kvassia_nn_1_N = mkN "kvassia" ;
  kvavhet_nn_1_N = mkN "kvavhet" ;
  kverulans_nn_1_N = mkN "kverulans" ;
  kvickrot_nn_1_N = mkN "kvickrot" ;
  kvicksand_nn_1_N = mkN "kvicksand" ;
  kvicktaenkthet_nn_1_1_N = mkN "kvicktänkthet" ;
  kvickoegdhet_nn_1_1_N = mkN "kvickögdhet" ;
  kvillajabark_nn_1_N = mkN "kvillajabark" ;
  kvinnlighet_nn_1_N = mkN "kvinnlighet" ;
  kvinnofientlighet_nn_1_N = mkN "kvinnofientlighet" ;
  kvinnofrid_nn_1_N = mkN "kvinnofrid" ;
  kvinnokamp_nn_1_N = mkN "kvinnokamp" ;
  kvinnopolitik_nn_1_N = mkN "kvinnopolitik" ;
  kvinnosak_nn_1_N = mkN "kvinnosak" ;
  kvinnosida_nn_1_N = mkN "kvinnosida" ;
  kvintessens_nn_1_N = mkN "kvintessens" ;
  kvisslighet_nn_1_N = mkN "kvisslighet" ;
  kvistighet_nn_1_N = mkN "kvistighet" ;
  kvistloeshet_nn_1_1_N = mkN "kvistlöshet" ;
  kvistning_nn_1_N = mkN "kvistning" ;
  kvitterbarhet_nn_1_N = mkN "kvitterbarhet" ;
  kvittrighet_nn_1_N = mkN "kvittrighet" ;
  kvoterbarhet_nn_1_N = mkN "kvoterbarhet" ;
  kvaellslighet_nn_1_1_N = mkN "kvällslighet" ;
  kvaellsluft_nn_1_1_N = mkN "kvällsluft" ;
  kvaellsmat_nn_1_1_N = mkN "kvällsmat" ;
  kvaellspress_nn_1_1_N = mkN "kvällspress" ;
  kvaevebalans_nn_1_1_N = mkN "kvävebalans" ;
  kvaevgas_nn_1_1_N = mkN "kvävgas" ;
  kyffighet_nn_1_N = mkN "kyffighet" ;
  kylighet_nn_1_N = mkN "kylighet" ;
  kylsighet_nn_1_N = mkN "kylsighet" ;
  kylslagenhet_nn_1_N = mkN "kylslagenhet" ;
  kyndel_nn_1_N = mkN "kyndel" ;
  kyrklighet_nn_1_N = mkN "kyrklighet" ;
  kyrkofrid_nn_1_N = mkN "kyrkofrid" ;
  kyrkogaang_nn_1_1_N = mkN "kyrkogång" ;
  kyrkomusik_nn_1_N = mkN "kyrkomusik" ;
  kyrkostat_nn_1_N = mkN "kyrkostat" ;
  kyrkotukt_nn_1_N = mkN "kyrkotukt" ;
  kyrksamhet_nn_1_N = mkN "kyrksamhet" ;
  kysstaeckhet_nn_1_1_N = mkN "kysstäckhet" ;
  kyssaekerhet_nn_1_1_N = mkN "kyssäkerhet" ;
  kaegelformighet_nn_1_1_N = mkN "kägelformighet" ;
  kaelkborgerlighet_nn_1_1_N = mkN "kälkborgerlighet" ;
  kaellforskning_nn_1_1_N = mkN "källforskning" ;
  kaellkod_nn_1_1_N = mkN "källkod" ;
  kaellkritik_nn_1_1_N = mkN "källkritik" ;
  kaellsorterbarhet_nn_1_1_N = mkN "källsorterbarhet" ;
  kaellsortering_nn_1_1_N = mkN "källsortering" ;
  kaempighet_nn_1_1_N = mkN "kämpighet" ;
  kaendhet_nn_1_1_N = mkN "kändhet" ;
  kaeng_nn_2_1_N = mkN "käng" ;
  kaennarblick_nn_1_1_N = mkN "kännarblick" ;
  kaennarmin_nn_1_1_N = mkN "kännarmin" ;
  kaennbarhet_nn_1_1_N = mkN "kännbarhet" ;
  kaensel_nn_1_1_N = mkN "känsel" ;
  kaenslofylldhet_nn_1_1_N = mkN "känslofylldhet" ;
  kaensloloeshet_nn_2_1_N = mkN "känslolöshet" ;
  kaenslomaessighet_nn_1_1_N = mkN "känslomässighet" ;
  kaerhet_nn_1_1_N = mkN "kärhet" ;
  kaeringtand_nn_1_1_N = mkN "käringtand" ;
  kaerkommenhet_nn_1_1_N = mkN "kärkommenhet" ;
  kaerleksfullhet_nn_1_1_N = mkN "kärleksfullhet" ;
  kaerlekskrankhet_nn_1_1_N = mkN "kärlekskrankhet" ;
  kaerlekslycka_nn_1_1_N = mkN "kärlekslycka" ;
  kaerlekslyrik_nn_1_1_N = mkN "kärlekslyrik" ;
  kaerleksloeshet_nn_1_1_N = mkN "kärlekslöshet" ;
  kaerleksoert_nn_1_1_N = mkN "kärleksört" ;
  kaerlighet_nn_1_1_N = mkN "kärlighet" ;
  kaerlkramp_nn_1_1_N = mkN "kärlkramp" ;
  kaernbraenslehantering_nn_1_1_N = mkN "kärnbränslehantering" ;
  kaernfur_nn_1_1_N = mkN "kärnfur" ;
  kaernfysik_nn_1_1_N = mkN "kärnfysik" ;
  kaernis_nn_1_1_N = mkN "kärnis" ;
  kaernkraft_nn_1_1_N = mkN "kärnkraft" ;
  kaernkraftskapacitet_nn_1_1_N = mkN "kärnkraftskapacitet" ;
  kaernkraftsutbyggnad_nn_1_1_N = mkN "kärnkraftsutbyggnad" ;
  kaernmjoelk_nn_1_1_N = mkN "kärnmjölk" ;
  kaernteknik_nn_1_1_N = mkN "kärnteknik" ;
  kaernved_nn_1_1_N = mkN "kärnved" ;
  kaervhet_nn_1_1_N = mkN "kärvhet" ;
  kaeraelskelighet_nn_1_1_N = mkN "kärälskelighet" ;
  kaeraelsklighet_nn_1_1_N = mkN "kärälsklighet" ;
  kaettja_nn_1_1_N = mkN "kättja" ;
  kaettjefullhet_nn_1_1_N = mkN "kättjefullhet" ;
  kaadrikhet_nn_1_1_N = mkN "kådrikhet" ;
  kaal_nn_1_1_N = mkN "kål" ;
  kaathet_nn_1_1_N = mkN "kåthet" ;
  kaatma_nn_1_1_N = mkN "kåtma" ;
  koeld_nn_1_1_N = mkN "köld" ;
  koeldbestaendighet_nn_1_1_N = mkN "köldbeständighet" ;
  koeldhaerdighet_nn_1_1_N = mkN "köldhärdighet" ;
  koenlighet_nn_1_1_N = mkN "könlighet" ;
  koenloeshet_nn_1_1_N = mkN "könlöshet" ;
  koensapartheid_nn_1_1_N = mkN "könsapartheid" ;
  koensbehaaring_nn_1_1_N = mkN "könsbehåring" ;
  koensbundenhet_nn_1_1_N = mkN "könsbundenhet" ;
  koensdiskriminerbarhet_nn_1_1_N = mkN "könsdiskriminerbarhet" ;
  koensdrift_nn_1_1_N = mkN "könsdrift" ;
  koenskvoterbarhet_nn_1_1_N = mkN "könskvoterbarhet" ;
  koenskyla_nn_1_1_N = mkN "könskyla" ;
  koenslighet_nn_1_1_N = mkN "könslighet" ;
  koensmakt_nn_1_1_N = mkN "könsmakt" ;
  koensmaktsordning_nn_1_1_N = mkN "könsmaktsordning" ;
  koensmogenhet_nn_1_1_N = mkN "könsmogenhet" ;
  koenspanik_nn_1_1_N = mkN "könspanik" ;
  koensstympning_nn_1_1_N = mkN "könsstympning" ;
  koephets_nn_1_1_N = mkN "köphets" ;
  koepkraft_nn_1_1_N = mkN "köpkraft" ;
  koeplust_nn_1_1_N = mkN "köplust" ;
  koerbarhet_nn_1_1_N = mkN "körbarhet" ;
  koerdhet_nn_1_1_N = mkN "kördhet" ;
  koersel_nn_1_1_N = mkN "körsel" ;
  koersaang_nn_1_1_N = mkN "körsång" ;
  koervel_nn_1_1_N = mkN "körvel" ;
  koettboskap_nn_1_1_N = mkN "köttboskap" ;
  koettfaers_nn_1_1_N = mkN "köttfärs" ;
  koettighet_nn_1_1_N = mkN "köttighet" ;
  koettproduktion_nn_1_1_N = mkN "köttproduktion" ;
  koettslighet_nn_1_1_N = mkN "köttslighet" ;
  labialiserbarhet_nn_1_N = mkN "labialiserbarhet" ;
  labrador_nn_2_N = mkN "labrador" ;
  lack_nn_2_N = mkN "lack" ;
  lackerbarhet_nn_1_N = mkN "lackerbarhet" ;
  lackmus_nn_1_N = mkN "lackmus" ;
  lacknafta_nn_1_N = mkN "lacknafta" ;
  ladylikhet_nn_1_N = mkN "ladylikhet" ;
  lafsighet_nn_1_N = mkN "lafsighet" ;
  lag_nn_3_N = mkN "lag" ;
  laganda_nn_1_N = mkN "laganda" ;
  lagenlighet_nn_1_N = mkN "lagenlighet" ;
  lager_nn_3_N = mkN "lager" ;
  lagerkoers_nn_1_1_N = mkN "lagerkörs" ;
  lagfarenhet_nn_1_N = mkN "lagfarenhet" ;
  lagiskhet_nn_1_N = mkN "lagiskhet" ;
  lagklokhet_nn_1_N = mkN "lagklokhet" ;
  lagkunskap_nn_1_N = mkN "lagkunskap" ;
  laglydighet_nn_1_N = mkN "laglydighet" ;
  laglydnad_nn_1_N = mkN "laglydnad" ;
  lagomhet_nn_1_N = mkN "lagomhet" ;
  lagring_nn_1_N = mkN "lagring" ;
  lagstridighet_nn_1_N = mkN "lagstridighet" ;
  lakka_nn_1_N = mkN "lakka" ;
  lakrits_nn_1_N = mkN "lakrits" ;
  laktos_nn_1_N = mkN "laktos" ;
  laktosintolerans_nn_1_N = mkN "laktosintolerans" ;
  lambada_nn_1_N = mkN "lambada" ;
  lamenterbarhet_nn_1_N = mkN "lamenterbarhet" ;
  lamhet_nn_1_N = mkN "lamhet" ;
  laminerbarhet_nn_1_N = mkN "laminerbarhet" ;
  landsbygd_nn_1_N = mkN "landsbygd" ;
  landsflykt_nn_1_N = mkN "landsflykt" ;
  landsfoerraediskhet_nn_1_1_N = mkN "landsförrädiskhet" ;
  landslagstraening_nn_1_1_N = mkN "landslagsträning" ;
  landsort_nn_1_N = mkN "landsort" ;
  landsortsmaessighet_nn_1_1_N = mkN "landsortsmässighet" ;
  landsraett_nn_1_1_N = mkN "landsrätt" ;
  landssorg_nn_1_N = mkN "landssorg" ;
  landstorm_nn_1_N = mkN "landstorm" ;
  langetterbarhet_nn_1_N = mkN "langetterbarhet" ;
  lank_nn_1_N = mkN "lank" ;
  lanserbarhet_nn_1_N = mkN "lanserbarhet" ;
  lantlighet_nn_1_N = mkN "lantlighet" ;
  lantluft_nn_1_N = mkN "lantluft" ;
  lapidarstil_nn_1_N = mkN "lapidarstil" ;
  lapis_nn_1_N = mkN "lapis" ;
  lapiserbarhet_nn_1_N = mkN "lapiserbarhet" ;
  lappsjuka_nn_1_N = mkN "lappsjuka" ;
  lapskhet_nn_1_N = mkN "lapskhet" ;
  larmberedskap_nn_1_N = mkN "larmberedskap" ;
  larvighet_nn_1_N = mkN "larvighet" ;
  laserbarhet_nn_1_N = mkN "laserbarhet" ;
  lastelighet_nn_1_N = mkN "lastelighet" ;
  lastfullhet_nn_1_N = mkN "lastfullhet" ;
  lasting_nn_1_N = mkN "lasting" ;
  latens_nn_1_N = mkN "latens" ;
  latenthet_nn_1_N = mkN "latenthet" ;
  lathet_nn_1_N = mkN "lathet" ;
  latiniserbarhet_nn_1_N = mkN "latiniserbarhet" ;
  latinkunnighet_nn_1_N = mkN "latinkunnighet" ;
  lavendel_nn_1_N = mkN "lavendel" ;
  laverbarhet_nn_1_N = mkN "laverbarhet" ;
  lavinfara_nn_1_N = mkN "lavinfara" ;
  lavinrisk_nn_1_N = mkN "lavinrisk" ;
  lealoeshet_nn_1_1_N = mkN "lealöshet" ;
  leda_nn_1_N = mkN "leda" ;
  ledbrutenhet_nn_1_N = mkN "ledbrutenhet" ;
  ledgaang_nn_1_1_N = mkN "ledgång" ;
  ledhet_nn_1_N = mkN "ledhet" ;
  ledsyn_nn_1_N = mkN "ledsyn" ;
  ledung_nn_1_N = mkN "ledung" ;
  legaliserbarhet_nn_1_N = mkN "legaliserbarhet" ;
  legerbarhet_nn_1_N = mkN "legerbarhet" ;
  legitimerbarhet_nn_1_N = mkN "legitimerbarhet" ;
  legitimitetsprincip_nn_1_N = mkN "legitimitetsprincip" ;
  lehet_nn_1_N = mkN "lehet" ;
  lejdtrafik_nn_1_N = mkN "lejdtrafik" ;
  lejonpart_nn_1_N = mkN "lejonpart" ;
  lekamlighet_nn_1_N = mkN "lekamlighet" ;
  lekfaerdighet_nn_1_1_N = mkN "lekfärdighet" ;
  leklystenhet_nn_1_N = mkN "leklystenhet" ;
  lektionstimma_nn_1_N = mkN "lektionstimma" ;
  lektyr_nn_1_N = mkN "lektyr" ;
  lemmalytthet_nn_1_N = mkN "lemmalytthet" ;
  lenhet_nn_1_N = mkN "lenhet" ;
  lepra_nn_1_N = mkN "lepra" ;
  leptit_nn_1_N = mkN "leptit" ;
  leveranssaekerhet_nn_1_1_N = mkN "leveranssäkerhet" ;
  levererbarhet_nn_1_N = mkN "levererbarhet" ;
  levertran_nn_1_N = mkN "levertran" ;
  levnadsafton_nn_1_N = mkN "levnadsafton" ;
  levnadsfoering_nn_1_1_N = mkN "levnadsföring" ;
  levnadskonst_nn_1_N = mkN "levnadskonst" ;
  levnadslust_nn_1_N = mkN "levnadslust" ;
  levnadsstandard_nn_1_N = mkN "levnadsstandard" ;
  levnadstroetthet_nn_1_1_N = mkN "levnadströtthet" ;
  lex_nn_1_N = mkN "lex" ;
  lexikostatistik_nn_1_N = mkN "lexikostatistik" ;
  lias_nn_1_N = mkN "lias" ;
  liberaliserbarhet_nn_1_N = mkN "liberaliserbarhet" ;
  licenserbarhet_nn_1_N = mkN "licenserbarhet" ;
  licensierbarhet_nn_1_N = mkN "licensierbarhet" ;
  licentierbarhet_nn_1_N = mkN "licentierbarhet" ;
  lidelsefrihet_nn_1_N = mkN "lidelsefrihet" ;
  lierbarhet_nn_1_N = mkN "lierbarhet" ;
  liggriktighet_nn_1_N = mkN "liggriktighet" ;
  liggsaed_nn_1_1_N = mkN "liggsäd" ;
  likbenthet_nn_1_N = mkN "likbenthet" ;
  likblekhet_nn_1_N = mkN "likblekhet" ;
  liklukt_nn_1_N = mkN "liklukt" ;
  liknoejdhet_nn_1_1_N = mkN "liknöjdhet" ;
  likriktning_nn_1_N = mkN "likriktning" ;
  liksidighet_nn_1_N = mkN "liksidighet" ;
  likstyckning_nn_1_N = mkN "likstyckning" ;
  liktydighet_nn_1_N = mkN "liktydighet" ;
  likviderbarhet_nn_1_N = mkN "likviderbarhet" ;
  likvaerdhet_nn_1_1_N = mkN "likvärdhet" ;
  likvaerdighet_nn_1_1_N = mkN "likvärdighet" ;
  lillebror_nn_1_N = mkN "lillebror" ;
  lillefar_nn_1_N = mkN "lillefar" ;
  lillhjaerna_nn_1_1_N = mkN "lillhjärna" ;
  limonit_nn_1_N = mkN "limonit" ;
  lindans_nn_1_N = mkN "lindans" ;
  lindrighet_nn_1_N = mkN "lindrighet" ;
  lingondricka_nn_1_N = mkN "lingondricka" ;
  lingvistik_nn_1_N = mkN "lingvistik" ;
  linhaarighet_nn_1_1_N = mkN "linhårighet" ;
  linjefart_nn_1_N = mkN "linjefart" ;
  linjerbarhet_nn_1_N = mkN "linjerbarhet" ;
  linjerenhet_nn_1_N = mkN "linjerenhet" ;
  linjetrafik_nn_1_N = mkN "linjetrafik" ;
  lisa_nn_1_N = mkN "lisa" ;
  lisserbarhet_nn_1_N = mkN "lisserbarhet" ;
  listighet_nn_1_N = mkN "listighet" ;
  litervikt_nn_1_N = mkN "litervikt" ;
  litograferbarhet_nn_1_N = mkN "litograferbarhet" ;
  litosfaer_nn_1_1_N = mkN "litosfär" ;
  litteraturkritik_nn_1_N = mkN "litteraturkritik" ;
  litteraturvetenskap_nn_1_N = mkN "litteraturvetenskap" ;
  livaktighet_nn_1_N = mkN "livaktighet" ;
  livegenhet_nn_1_N = mkN "livegenhet" ;
  livegenskap_nn_1_N = mkN "livegenskap" ;
  livfullhet_nn_1_N = mkN "livfullhet" ;
  livhank_nn_1_N = mkN "livhank" ;
  livloeshet_nn_1_1_N = mkN "livlöshet" ;
  livmoder_nn_1_N = mkN "livmoder" ;
  livsduglighet_nn_1_N = mkN "livsduglighet" ;
  livsfara_nn_1_N = mkN "livsfara" ;
  livskraft_nn_1_N = mkN "livskraft" ;
  livskraftighet_nn_1_N = mkN "livskraftighet" ;
  livskaensla_nn_1_1_N = mkN "livskänsla" ;
  livsleda_nn_1_N = mkN "livsleda" ;
  livsluft_nn_1_N = mkN "livsluft" ;
  livsmedelsbrist_nn_1_N = mkN "livsmedelsbrist" ;
  livsmedelspolitik_nn_1_N = mkN "livsmedelspolitik" ;
  livsmedelsproduktion_nn_1_N = mkN "livsmedelsproduktion" ;
  livsnjutartillvaro_nn_1_N = mkN "livsnjutartillvaro" ;
  livsnoedvaendighet_nn_1_1_N = mkN "livsnödvändighet" ;
  livstid_nn_1_N = mkN "livstid" ;
  livsviktighet_nn_1_N = mkN "livsviktighet" ;
  livsvaenlighet_nn_1_1_N = mkN "livsvänlighet" ;
  ljudenlighet_nn_1_N = mkN "ljudenlighet" ;
  ljudisolerbarhet_nn_1_N = mkN "ljudisolerbarhet" ;
  ljudlighet_nn_1_N = mkN "ljudlighet" ;
  ljudloeshet_nn_1_1_N = mkN "ljudlöshet" ;
  ljudradio_nn_1_N = mkN "ljudradio" ;
  ljudsvaghet_nn_1_N = mkN "ljudsvaghet" ;
  ljudsymbolik_nn_1_N = mkN "ljudsymbolik" ;
  ljumhet_nn_2_N = mkN "ljumhet" ;
  ljummenhet_nn_1_N = mkN "ljummenhet" ;
  ljung_nn_1_N = mkN "ljung" ;
  ljusbestaendighet_nn_1_1_N = mkN "ljusbeständighet" ;
  ljusblindhet_nn_1_N = mkN "ljusblindhet" ;
  ljusbrist_nn_1_N = mkN "ljusbrist" ;
  ljusfoering_nn_1_1_N = mkN "ljusföring" ;
  ljushet_nn_1_N = mkN "ljushet" ;
  ljushyllthet_nn_1_N = mkN "ljushyllthet" ;
  ljushaarighet_nn_1_1_N = mkN "ljushårighet" ;
  ljuskopierbarhet_nn_1_N = mkN "ljuskopierbarhet" ;
  ljuslagdhet_nn_1_N = mkN "ljuslagdhet" ;
  ljuslockighet_nn_1_N = mkN "ljuslockighet" ;
  ljuslaetthet_nn_1_1_N = mkN "ljuslätthet" ;
  ljusreklam_nn_1_N = mkN "ljusreklam" ;
  ljussvaghet_nn_1_N = mkN "ljussvaghet" ;
  ljusvall_nn_1_N = mkN "ljusvall" ;
  lockighet_nn_1_N = mkN "lockighet" ;
  lodbarhet_nn_1_N = mkN "lodbarhet" ;
  lodraethet_nn_1_1_N = mkN "lodräthet" ;
  logerbarhet_nn_1_N = mkN "logerbarhet" ;
  logik_nn_1_N = mkN "logik" ;
  logistik_nn_1_N = mkN "logistik" ;
  lojhet_nn_1_N = mkN "lojhet" ;
  lokaliserbarhet_nn_1_N = mkN "lokaliserbarhet" ;
  lokaliseringspolitik_nn_1_N = mkN "lokaliseringspolitik" ;
  lokalpolitik_nn_1_N = mkN "lokalpolitik" ;
  lokalpress_nn_1_N = mkN "lokalpress" ;
  lokalradio_nn_1_N = mkN "lokalradio" ;
  lokaltrafik_nn_1_N = mkN "lokaltrafik" ;
  lokalvaard_nn_1_1_N = mkN "lokalvård" ;
  lomhoerdhet_nn_1_1_N = mkN "lomhördhet" ;
  loran_nn_1_N = mkN "loran" ;
  lortighet_nn_1_N = mkN "lortighet" ;
  lotshjaelp_nn_1_1_N = mkN "lotshjälp" ;
  lotsplikt_nn_1_N = mkN "lotsplikt" ;
  lottloeshet_nn_1_1_N = mkN "lottlöshet" ;
  lovgirighet_nn_1_N = mkN "lovgirighet" ;
  lovlighet_nn_1_N = mkN "lovlighet" ;
  lovvaerdhet_nn_1_1_N = mkN "lovvärdhet" ;
  lucia_nn_2_N = mkN "lucia" ;
  luckerhet_nn_1_N = mkN "luckerhet" ;
  ludenhet_nn_1_N = mkN "ludenhet" ;
  luff_nn_1_N = mkN "luff" ;
  lufsighet_nn_1_N = mkN "lufsighet" ;
  luft_nn_1_N = mkN "luft" ;
  luftfart_nn_1_N = mkN "luftfart" ;
  luftpost_nn_1_N = mkN "luftpost" ;
  lufttillfoersel_nn_1_1_N = mkN "lufttillförsel" ;
  lufttomhet_nn_1_N = mkN "lufttomhet" ;
  lufttaethet_nn_1_1_N = mkN "lufttäthet" ;
  luftvaernseld_nn_1_1_N = mkN "luftvärnseld" ;
  lugg_nn_2_N = mkN "lugg" ;
  luggighet_nn_1_N = mkN "luggighet" ;
  luggslitenhet_nn_1_N = mkN "luggslitenhet" ;
  lugnhet_nn_1_N = mkN "lugnhet" ;
  luktfrihet_nn_1_N = mkN "luktfrihet" ;
  luktloeshet_nn_1_1_N = mkN "luktlöshet" ;
  luktsvaghet_nn_1_N = mkN "luktsvaghet" ;
  lullighet_nn_1_N = mkN "lullighet" ;
  lumbago_nn_1_N = mkN "lumbago" ;
  luminiscens_nn_1_N = mkN "luminiscens" ;
  lummighet_nn_1_N = mkN "lummighet" ;
  lump_nn_2_N = mkN "lump" ;
  lumpenhet_nn_1_N = mkN "lumpenhet" ;
  lumpighet_nn_1_N = mkN "lumpighet" ;
  lumpull_nn_1_N = mkN "lumpull" ;
  lungbrand_nn_1_N = mkN "lungbrand" ;
  lungcancer_nn_1_N = mkN "lungcancer" ;
  lungpaj_nn_1_N = mkN "lungpaj" ;
  lungsjuka_nn_1_N = mkN "lungsjuka" ;
  lungsjukhet_nn_1_N = mkN "lungsjukhet" ;
  lungsot_nn_1_N = mkN "lungsot" ;
  lungtuberkulos_nn_1_N = mkN "lungtuberkulos" ;
  lunk_nn_1_N = mkN "lunk" ;
  lunsighet_nn_1_N = mkN "lunsighet" ;
  lupus_nn_1_N = mkN "lupus" ;
  lurvighet_nn_1_N = mkN "lurvighet" ;
  luspankhet_nn_1_N = mkN "luspankhet" ;
  lusse_nn_1_N = mkN "lusse" ;
  lusta_nn_1_N = mkN "lusta" ;
  lustelighet_nn_1_N = mkN "lustelighet" ;
  lustfylldhet_nn_1_N = mkN "lustfylldhet" ;
  luteiniserbarhet_nn_1_N = mkN "luteiniserbarhet" ;
  lycka_nn_1_N = mkN "lycka" ;
  lyckosamhet_nn_1_N = mkN "lyckosamhet" ;
  lycksalighet_nn_1_N = mkN "lycksalighet" ;
  lydaktighet_nn_1_N = mkN "lydaktighet" ;
  lydnad_nn_1_N = mkN "lydnad" ;
  lyhoerdhet_nn_1_1_N = mkN "lyhördhet" ;
  lymfa_nn_1_N = mkN "lymfa" ;
  lymmelaktighet_nn_1_N = mkN "lymmelaktighet" ;
  lynchmobb_nn_1_N = mkN "lynchmobb" ;
  lynnighet_nn_1_N = mkN "lynnighet" ;
  lyrik_nn_1_N = mkN "lyrik" ;
  lyrism_nn_1_N = mkN "lyrism" ;
  lyskraft_nn_1_N = mkN "lyskraft" ;
  lysol_nn_1_N = mkN "lysol" ;
  lystenhet_nn_1_N = mkN "lystenhet" ;
  lysved_nn_1_N = mkN "lysved" ;
  lyteskomik_nn_1_N = mkN "lyteskomik" ;
  lytthet_nn_1_N = mkN "lytthet" ;
  lyx_nn_1_N = mkN "lyx" ;
  lyxkonsumering_nn_1_N = mkN "lyxkonsumering" ;
  lyxmat_nn_1_N = mkN "lyxmat" ;
  lyxrenoverbarhet_nn_1_N = mkN "lyxrenoverbarhet" ;
  laederbarhet_nn_1_1_N = mkN "läderbarhet" ;
  laederhud_nn_1_1_N = mkN "läderhud" ;
  laeglighet_nn_1_1_N = mkN "läglighet" ;
  laekarhjaelp_nn_1_1_N = mkN "läkarhjälp" ;
  laekarvetenskap_nn_1_1_N = mkN "läkarvetenskap" ;
  laekarvaard_nn_1_1_N = mkN "läkarvård" ;
  laekekonst_nn_1_1_N = mkN "läkekonst" ;
  laekepedagogik_nn_1_1_N = mkN "läkepedagogik" ;
  laemplighetsproevning_nn_1_1_N = mkN "lämplighetsprövning" ;
  laengtansfullhet_nn_1_1_N = mkN "längtansfullhet" ;
  laenskriminal_nn_1_1_N = mkN "länskriminal" ;
  laenspolis_nn_1_1_N = mkN "länspolis" ;
  laenspumpning_nn_1_1_N = mkN "länspumpning" ;
  laeppglans_nn_1_1_N = mkN "läppglans" ;
  laeraktighet_nn_1_1_N = mkN "läraktighet" ;
  laerarloeshet_nn_1_1_N = mkN "lärarlöshet" ;
  laerdhet_nn_1_1_N = mkN "lärdhet" ;
  laerlingstid_nn_1_1_N = mkN "lärlingstid" ;
  laeroboksaktighet_nn_1_1_N = mkN "läroboksaktighet" ;
  laerorikhet_nn_1_1_N = mkN "lärorikhet" ;
  laerotid_nn_1_1_N = mkN "lärotid" ;
  laeslighet_nn_1_1_N = mkN "läslighet" ;
  laeslust_nn_1_1_N = mkN "läslust" ;
  laessvaghet_nn_1_1_N = mkN "lässvaghet" ;
  laesvaenlighet_nn_1_1_N = mkN "läsvänlighet" ;
  laettantaendlighet_nn_1_1_N = mkN "lättantändlighet" ;
  laettbegriplighet_nn_1_1_N = mkN "lättbegriplighet" ;
  laettbetong_nn_1_1_N = mkN "lättbetong" ;
  laettfattlighet_nn_1_1_N = mkN "lättfattlighet" ;
  laettfil_nn_1_1_N = mkN "lättfil" ;
  laettflyktighet_nn_1_1_N = mkN "lättflyktighet" ;
  laettframkomlighet_nn_1_1_N = mkN "lättframkomlighet" ;
  laettfoerklarlighet_nn_1_1_N = mkN "lättförklarlighet" ;
  laettfoerstaaelighet_nn_1_1_N = mkN "lättförståelighet" ;
  laetthanterlighet_nn_1_1_N = mkN "lätthanterlighet" ;
  laetthet_nn_1_1_N = mkN "lätthet" ;
  laettillgaenglighet_nn_1_1_N = mkN "lättillgänglighet" ;
  laettja_nn_1_1_N = mkN "lättja" ;
  laettjefullhet_nn_1_1_N = mkN "lättjefullhet" ;
  laettklaeddhet_nn_1_1_N = mkN "lättkläddhet" ;
  laettkokthet_nn_1_1_N = mkN "lättkokthet" ;
  laettkoepthet_nn_1_1_N = mkN "lättköpthet" ;
  laettleddhet_nn_1_1_N = mkN "lättleddhet" ;
  laettlaesthet_nn_1_1_N = mkN "lättlästhet" ;
  laettloeslighet_nn_1_1_N = mkN "lättlöslighet" ;
  laettloesthet_nn_1_1_N = mkN "lättlösthet" ;
  laettmjoelk_nn_1_1_N = mkN "lättmjölk" ;
  laettretlighet_nn_1_1_N = mkN "lättretlighet" ;
  laettrogenhet_nn_1_1_N = mkN "lättrogenhet" ;
  laettroerdhet_nn_1_1_N = mkN "lättrördhet" ;
  laettroerlighet_nn_1_1_N = mkN "lättrörlighet" ;
  laettskraemdhet_nn_1_1_N = mkN "lättskrämdhet" ;
  laettskoetthet_nn_1_1_N = mkN "lättskötthet" ;
  laettsmaelthet_nn_1_1_N = mkN "lättsmälthet" ;
  laettstekthet_nn_1_1_N = mkN "lättstekthet" ;
  laettstoetthet_nn_1_1_N = mkN "lättstötthet" ;
  laettvikt_nn_1_1_N = mkN "lättvikt" ;
  laettviktighet_nn_1_1_N = mkN "lättviktighet" ;
  laettvindighet_nn_1_1_N = mkN "lättvindighet" ;
  laettoemdhet_nn_1_1_N = mkN "lättömdhet" ;
  laettoeverskaadlighet_nn_1_1_N = mkN "lättöverskådlighet" ;
  laagbudgetturism_nn_1_1_N = mkN "lågbudgetturism" ;
  laaghjulighet_nn_1_1_N = mkN "låghjulighet" ;
  laagkyrklighet_nn_1_1_N = mkN "lågkyrklighet" ;
  laaglandsboskap_nn_1_1_N = mkN "låglandsboskap" ;
  laaglaenthet_nn_1_1_N = mkN "låglänthet" ;
  laagmaeldhet_nn_1_1_N = mkN "lågmäldhet" ;
  laagprioriterbarhet_nn_1_1_N = mkN "lågprioriterbarhet" ;
  laagpriskonkurrens_nn_1_1_N = mkN "lågpriskonkurrens" ;
  laagsinthet_nn_1_1_N = mkN "lågsinthet" ;
  laagstatus_nn_1_1_N = mkN "lågstatus" ;
  laagsvavlighet_nn_1_1_N = mkN "lågsvavlighet" ;
  laagvuxenhet_nn_1_1_N = mkN "lågvuxenhet" ;
  laagvaerdighet_nn_1_1_N = mkN "lågvärdighet" ;
  laagvaexthet_nn_1_1_N = mkN "lågväxthet" ;
  laangbenthet_nn_1_1_N = mkN "långbenthet" ;
  laangdragenhet_nn_1_1_N = mkN "långdragenhet" ;
  laangfristighet_nn_1_1_N = mkN "långfristighet" ;
  laanggrundhet_nn_1_1_N = mkN "långgrundhet" ;
  laanghaarighet_nn_1_1_N = mkN "långhårighet" ;
  laangkatekes_nn_1_1_N = mkN "långkatekes" ;
  laanglighet_nn_1_1_N = mkN "långlighet" ;
  laangmjoelk_nn_1_1_N = mkN "långmjölk" ;
  laangmodighet_nn_1_1_N = mkN "långmodighet" ;
  laangnaesthet_nn_1_1_N = mkN "långnästhet" ;
  laangrandighet_nn_1_1_N = mkN "långrandighet" ;
  laangsamhet_nn_1_1_N = mkN "långsamhet" ;
  laangsiktighet_nn_1_1_N = mkN "långsiktighet" ;
  laangsinthet_nn_1_1_N = mkN "långsinthet" ;
  laangskallighet_nn_1_1_N = mkN "långskallighet" ;
  laangsoekthet_nn_1_1_N = mkN "långsökthet" ;
  laangtidsparkerbarhet_nn_1_1_N = mkN "långtidsparkerbarhet" ;
  laangtidssjukfraanvaro_nn_1_1_N = mkN "långtidssjukfrånvaro" ;
  laangtidssjukhet_nn_1_1_N = mkN "långtidssjukhet" ;
  laangtradighet_nn_1_1_N = mkN "långtradighet" ;
  laangtraadighet_nn_1_1_N = mkN "långtrådighet" ;
  laangtraakighet_nn_1_1_N = mkN "långtråkighet" ;
  laangvarighet_nn_1_1_N = mkN "långvarighet" ;
  laangved_nn_1_1_N = mkN "långved" ;
  laangvaard_nn_1_1_N = mkN "långvård" ;
  laasbarhet_nn_1_1_N = mkN "låsbarhet" ;
  laat_nn_2_1_N = mkN "låt" ;
  laatgaapolitik_nn_1_1_N = mkN "låtgåpolitik" ;
  loeddrighet_nn_1_1_N = mkN "löddrighet" ;
  loedighet_nn_1_1_N = mkN "lödighet" ;
  loeftesrikhet_nn_1_1_N = mkN "löftesrikhet" ;
  loemskhet_nn_1_1_N = mkN "lömskhet" ;
  loenedumpningspolitik_nn_1_1_N = mkN "lönedumpningspolitik" ;
  loenepolitik_nn_1_1_N = mkN "lönepolitik" ;
  loeneraettvisa_nn_1_1_N = mkN "lönerättvisa" ;
  loenloeshet_nn_1_1_N = mkN "lönlöshet" ;
  loennlighet_nn_1_1_N = mkN "lönnlighet" ;
  loennskrift_nn_1_1_N = mkN "lönnskrift" ;
  loepskhet_nn_1_1_N = mkN "löpskhet" ;
  loeptraening_nn_1_1_N = mkN "löpträning" ;
  loerdagstrafik_nn_1_1_N = mkN "lördagstrafik" ;
  loesaktighet_nn_1_1_N = mkN "lösaktighet" ;
  loesbarhet_nn_1_1_N = mkN "lösbarhet" ;
  loesdrift_nn_1_1_N = mkN "lösdrift" ;
  loeshet_nn_1_1_N = mkN "löshet" ;
  loeslighet_nn_1_1_N = mkN "löslighet" ;
  loesmynthet_nn_1_1_N = mkN "lösmynthet" ;
  loesningsraett_nn_1_1_N = mkN "lösningsrätt" ;
  loesnummerfoersaeljning_nn_1_1_N = mkN "lösnummerförsäljning" ;
  loesryckthet_nn_1_1_N = mkN "lösryckthet" ;
  loess_nn_1_1_N = mkN "löss" ;
  loesslaeppthet_nn_1_1_N = mkN "lössläppthet" ;
  loessnoe_nn_1_1_N = mkN "lössnö" ;
  loestagbarhet_nn_1_1_N = mkN "löstagbarhet" ;
  loevrikedom_nn_1_1_N = mkN "lövrikedom" ;
  loevtunnhet_nn_1_1_N = mkN "lövtunnhet" ;
  macchiato_nn_1_N = mkN "macchiato" ;
  madeira_nn_1_N = mkN "madeira" ;
  madrasserbarhet_nn_1_N = mkN "madrasserbarhet" ;
  maestro_nn_1_N = mkN "maestro" ;
  maffighet_nn_1_N = mkN "maffighet" ;
  magasinerbarhet_nn_1_N = mkN "magasinerbarhet" ;
  magerhet_nn_1_N = mkN "magerhet" ;
  magerlagdhet_nn_1_N = mkN "magerlagdhet" ;
  magkaensla_nn_1_1_N = mkN "magkänsla" ;
  magnesit_nn_1_N = mkN "magnesit" ;
  magnetiserbarhet_nn_1_N = mkN "magnetiserbarhet" ;
  magnetit_nn_1_N = mkN "magnetit" ;
  magnificens_nn_1_N = mkN "magnificens" ;
  magstarkhet_nn_1_N = mkN "magstarkhet" ;
  magsurhet_nn_1_N = mkN "magsurhet" ;
  mahjong_nn_1_N = mkN "mahjong" ;
  mail_nn_1_N = mkN "mail" ;
  maj_nn_1_N = mkN "maj" ;
  maj_nn_2_N = mkN "maj" ;
  majestaetlighet_nn_1_1_N = mkN "majestätlighet" ;
  majolika_nn_1_N = mkN "majolika" ;
  majs_nn_1_N = mkN "majs" ;
  majsena_nn_1_N = mkN "majsena" ;
  majsjuka_nn_1_N = mkN "majsjuka" ;
  majsol_nn_1_N = mkN "majsol" ;
  makaberhet_nn_1_N = mkN "makaberhet" ;
  makadam_nn_1_N = mkN "makadam" ;
  makaloeshet_nn_1_1_N = mkN "makalöshet" ;
  maklighet_nn_1_N = mkN "maklighet" ;
  mako_nn_1_N = mkN "mako" ;
  makt_nn_1_N = mkN "makt" ;
  maktfullkomlighet_nn_1_N = mkN "maktfullkomlighet" ;
  makthunger_nn_1_N = mkN "makthunger" ;
  maktlystenhet_nn_1_N = mkN "maktlystenhet" ;
  maktloeshet_nn_1_1_N = mkN "maktlöshet" ;
  maktpolitik_nn_1_N = mkN "maktpolitik" ;
  maktstinnhet_nn_1_N = mkN "maktstinnhet" ;
  maktutoevning_nn_1_1_N = mkN "maktutövning" ;
  makulatur_nn_1_N = mkN "makulatur" ;
  makulerbarhet_nn_1_N = mkN "makulerbarhet" ;
  malaga_nn_1_N = mkN "malaga" ;
  malaria_nn_1_N = mkN "malaria" ;
  malfoberbarhet_nn_1_N = mkN "malfoberbarhet" ;
  malis_nn_1_N = mkN "malis" ;
  mallighet_nn_1_N = mkN "mallighet" ;
  malmslig_nn_1_N = mkN "malmslig" ;
  maltos_nn_1_N = mkN "maltos" ;
  maltraeterbarhet_nn_1_1_N = mkN "malträterbarhet" ;
  malvasir_nn_1_N = mkN "malvasir" ;
  malaetenhet_nn_1_1_N = mkN "malätenhet" ;
  maloert_nn_1_1_N = mkN "malört" ;
  mammaledighet_nn_1_N = mkN "mammaledighet" ;
  mammighet_nn_1_N = mkN "mammighet" ;
  mammon_nn_1_N = mkN "mammon" ;
  mammutjakt_nn_1_N = mkN "mammutjakt" ;
  mana_nn_1_N = mkN "mana" ;
  manbarhet_nn_1_N = mkN "manbarhet" ;
  manchester_nn_1_N = mkN "manchester" ;
  manetforskning_nn_1_N = mkN "manetforskning" ;
  mangold_nn_1_N = mkN "mangold" ;
  manhaftighet_nn_1_N = mkN "manhaftighet" ;
  manifesterbarhet_nn_1_N = mkN "manifesterbarhet" ;
  manikurerbarhet_nn_1_N = mkN "manikurerbarhet" ;
  manikyr_nn_1_N = mkN "manikyr" ;
  manikyrerbarhet_nn_1_N = mkN "manikyrerbarhet" ;
  manilla_nn_1_N = mkN "manilla" ;
  maniok_nn_1_N = mkN "maniok" ;
  manipulerbarhet_nn_1_N = mkN "manipulerbarhet" ;
  manlighet_nn_1_N = mkN "manlighet" ;
  mannakraft_nn_1_N = mkN "mannakraft" ;
  mansbot_nn_1_N = mkN "mansbot" ;
  mansdominans_nn_1_N = mkN "mansdominans" ;
  manstukt_nn_1_N = mkN "manstukt" ;
  manoeverduglighet_nn_1_1_N = mkN "manöverduglighet" ;
  manoevrerbarhet_nn_1_1_N = mkN "manövrerbarhet" ;
  maraskino_nn_1_N = mkN "maraskino" ;
  marasm_nn_1_N = mkN "marasm" ;
  mardroemslikhet_nn_1_1_N = mkN "mardrömslikhet" ;
  mareld_nn_1_N = mkN "mareld" ;
  marginaliserbarhet_nn_1_N = mkN "marginaliserbarhet" ;
  marinerbarhet_nn_1_N = mkN "marinerbarhet" ;
  markavvattning_nn_1_N = mkN "markavvattning" ;
  markerbarhet_nn_1_N = mkN "markerbarhet" ;
  marketing_nn_1_N = mkN "marketing" ;
  marknadsvaerderbarhet_nn_1_1_N = mkN "marknadsvärderbarhet" ;
  marmorerbarhet_nn_1_N = mkN "marmorerbarhet" ;
  marokaeng_nn_1_1_N = mkN "marokäng" ;
  mars_nn_1_N = mkN "mars" ;
  marscherbarhet_nn_1_N = mkN "marscherbarhet" ;
  marschmusik_nn_1_N = mkN "marschmusik" ;
  marschtakt_nn_1_N = mkN "marschtakt" ;
  marseljaes_nn_1_1_N = mkN "marseljäs" ;
  marsipan_nn_1_N = mkN "marsipan" ;
  marterbarhet_nn_1_N = mkN "marterbarhet" ;
  martyrdoed_nn_1_1_N = mkN "martyrdöd" ;
  mas_nn_2_N = mkN "mas" ;
  maskerbarhet_nn_1_N = mkN "maskerbarhet" ;
  maskeringstejp_nn_1_N = mkN "maskeringstejp" ;
  maskinlaesbarhet_nn_1_1_N = mkN "maskinläsbarhet" ;
  maskinmaessighet_nn_1_1_N = mkN "maskinmässighet" ;
  maskinskrift_nn_1_N = mkN "maskinskrift" ;
  maskuliniserbarhet_nn_1_N = mkN "maskuliniserbarhet" ;
  masonit_nn_1_N = mkN "masonit" ;
  massakrerbarhet_nn_1_N = mkN "massakrerbarhet" ;
  massarbetsloeshet_nn_1_1_N = mkN "massarbetslöshet" ;
  massaved_nn_1_N = mkN "massaved" ;
  masserbarhet_nn_1_N = mkN "masserbarhet" ;
  massinvandring_nn_1_N = mkN "massinvandring" ;
  massloeshet_nn_1_1_N = mkN "masslöshet" ;
  massproduktion_nn_1_N = mkN "massproduktion" ;
  massvaelt_nn_1_1_N = mkN "massvält" ;
  mastighet_nn_1_N = mkN "mastighet" ;
  mastix_nn_1_N = mkN "mastix" ;
  mat_nn_1_N = mkN "mat" ;
  matbrist_nn_1_N = mkN "matbrist" ;
  matchning_nn_1_N = mkN "matchning" ;
  matelasserbarhet_nn_1_N = mkN "matelasserbarhet" ;
  matematik_nn_1_N = mkN "matematik" ;
  materialiserbarhet_nn_1_N = mkN "materialiserbarhet" ;
  matlust_nn_1_N = mkN "matlust" ;
  matmor_nn_1_N = mkN "matmor" ;
  matservering_nn_1_N = mkN "matservering" ;
  mattbrottning_nn_1_N = mkN "mattbrottning" ;
  mattejp_nn_1_N = mkN "mattejp" ;
  matterbarhet_nn_1_N = mkN "matterbarhet" ;
  matthet_nn_2_N = mkN "matthet" ;
  mattram_nn_1_N = mkN "mattram" ;
  maximerbarhet_nn_1_N = mkN "maximerbarhet" ;
  mc_aakning_nn_1_1_N = mkN "mc-åkning" ;
  medaljerbarhet_nn_1_N = mkN "medaljerbarhet" ;
  medansvarighet_nn_1_N = mkN "medansvarighet" ;
  medborgarraett_nn_1_1_N = mkN "medborgarrätt" ;
  medborgerlighet_nn_1_N = mkN "medborgerlighet" ;
  medbrottslighet_nn_1_N = mkN "medbrottslighet" ;
  meddelaktighet_nn_1_N = mkN "meddelaktighet" ;
  meddelandeplikt_nn_1_N = mkN "meddelandeplikt" ;
  meddelsamhet_nn_1_N = mkN "meddelsamhet" ;
  medelbarhet_nn_1_N = mkN "medelbarhet" ;
  medelloeshet_nn_1_1_N = mkN "medellöshet" ;
  medelmaattighet_nn_1_1_N = mkN "medelmåttighet" ;
  medelsol_nn_1_N = mkN "medelsol" ;
  medeltid_nn_1_N = mkN "medeltid" ;
  medfarenhet_nn_1_N = mkN "medfarenhet" ;
  medfoeddhet_nn_1_1_N = mkN "medföddhet" ;
  medgoerlighet_nn_1_1_N = mkN "medgörlighet" ;
  medhjaelp_nn_1_1_N = mkN "medhjälp" ;
  mediamakt_nn_1_N = mkN "mediamakt" ;
  mediapolitik_nn_1_N = mkN "mediapolitik" ;
  medicinalvikt_nn_1_N = mkN "medicinalvikt" ;
  medicinerbarhet_nn_1_N = mkN "medicinerbarhet" ;
  medielogik_nn_1_N = mkN "medielogik" ;
  mediemakt_nn_1_N = mkN "mediemakt" ;
  mediepolitik_nn_1_N = mkN "mediepolitik" ;
  medierapportering_nn_1_N = mkN "medierapportering" ;
  mediokerhet_nn_1_N = mkN "mediokerhet" ;
  medkaensla_nn_1_1_N = mkN "medkänsla" ;
  medlidsamhet_nn_1_N = mkN "medlidsamhet" ;
  medmaensklighet_nn_1_1_N = mkN "medmänsklighet" ;
  medskyldighet_nn_1_N = mkN "medskyldighet" ;
  medtagenhet_nn_1_N = mkN "medtagenhet" ;
  medvetandegoering_nn_1_1_N = mkN "medvetandegöring" ;
  medvetsloeshet_nn_1_1_N = mkN "medvetslöshet" ;
  mejl_nn_1_N = mkN "mejl" ;
  mejram_nn_1_N = mkN "mejram" ;
  mekanik_nn_1_N = mkN "mekanik" ;
  mekaniserbarhet_nn_1_N = mkN "mekaniserbarhet" ;
  mekvaenlighet_nn_1_1_N = mkN "mekvänlighet" ;
  melass_nn_1_N = mkN "melass" ;
  melinit_nn_1_N = mkN "melinit" ;
  mellankalv_nn_1_N = mkN "mellankalv" ;
  mellankomst_nn_1_N = mkN "mellankomst" ;
  mellanmaensklighet_nn_1_1_N = mkN "mellanmänsklighet" ;
  mellanvikt_nn_1_N = mkN "mellanvikt" ;
  melodik_nn_1_N = mkN "melodik" ;
  memorerbarhet_nn_1_N = mkN "memorerbarhet" ;
  meningit_nn_1_N = mkN "meningit" ;
  meningsfullhet_nn_1_N = mkN "meningsfullhet" ;
  meningsfylldhet_nn_1_N = mkN "meningsfylldhet" ;
  menlighet_nn_1_N = mkN "menlighet" ;
  mens_nn_1_N = mkN "mens" ;
  mensvaerk_nn_1_1_N = mkN "mensvärk" ;
  mentalsjukhet_nn_1_N = mkN "mentalsjukhet" ;
  mentalvaard_nn_1_1_N = mkN "mentalvård" ;
  mentol_nn_1_N = mkN "mentol" ;
  merceriserbarhet_nn_1_N = mkN "merceriserbarhet" ;
  meriterbarhet_nn_1_N = mkN "meriterbarhet" ;
  merpart_nn_1_N = mkN "merpart" ;
  mersmak_nn_1_N = mkN "mersmak" ;
  mesaktighet_nn_1_N = mkN "mesaktighet" ;
  mesighet_nn_1_N = mkN "mesighet" ;
  metaforik_nn_1_N = mkN "metaforik" ;
  metafysik_nn_1_N = mkN "metafysik" ;
  metalliserbarhet_nn_1_N = mkN "metalliserbarhet" ;
  metallsloejd_nn_1_1_N = mkN "metallslöjd" ;
  metallsmak_nn_1_N = mkN "metallsmak" ;
  metangas_nn_1_N = mkN "metangas" ;
  metanhydrat_nn_1_N = mkN "metanhydrat" ;
  metanis_nn_1_N = mkN "metanis" ;
  metanklatrat_nn_1_N = mkN "metanklatrat" ;
  metanol_nn_1_N = mkN "metanol" ;
  metodik_nn_1_N = mkN "metodik" ;
  metrik_nn_1_N = mkN "metrik" ;
  metyl_nn_1_N = mkN "metyl" ;
  metylalkohol_nn_1_N = mkN "metylalkohol" ;
  middagsmat_nn_1_N = mkN "middagsmat" ;
  middagssol_nn_1_N = mkN "middagssol" ;
  midnatt_nn_1_N = mkN "midnatt" "midnätter" ;
  migraen_nn_1_1_N = mkN "migrän" ;
  mikroelektronik_nn_1_N = mkN "mikroelektronik" ;
  mikrofotograferbarhet_nn_1_N = mkN "mikrofotograferbarhet" ;
  mikroskoperbarhet_nn_1_N = mkN "mikroskoperbarhet" ;
  mikrosoemn_nn_1_1_N = mkN "mikrosömn" ;
  milanesiskhet_nn_1_N = mkN "milanesiskhet" ;
  mildsinthet_nn_1_N = mkN "mildsinthet" ;
  mildoegdhet_nn_1_1_N = mkN "mildögdhet" ;
  miliartuberkulos_nn_1_N = mkN "miliartuberkulos" ;
  militariserbarhet_nn_1_N = mkN "militariserbarhet" ;
  militaermusik_nn_1_1_N = mkN "militärmusik" ;
  militaerpolis_nn_1_1_N = mkN "militärpolis" ;
  militaertjaenst_nn_1_1_N = mkN "militärtjänst" ;
  miljoebalk_nn_1_1_N = mkN "miljöbalk" ;
  miljoefarlighet_nn_1_1_N = mkN "miljöfarlighet" ;
  miljoemedvetenhet_nn_1_1_N = mkN "miljömedvetenhet" ;
  miljoemaessighet_nn_1_1_N = mkN "miljömässighet" ;
  miljoepolitik_nn_1_1_N = mkN "miljöpolitik" ;
  miljoeskydd_nn_1_1_N = mkN "miljöskydd" ;
  miljoevaenlighet_nn_1_1_N = mkN "miljövänlighet" ;
  miljoevaard_nn_1_1_N = mkN "miljövård" ;
  mimik_nn_1_N = mkN "mimik" ;
  mindervaerdighet_nn_1_1_N = mkN "mindervärdighet" ;
  minderaarighet_nn_1_1_N = mkN "minderårighet" ;
  mineraliserbarhet_nn_1_N = mkN "mineraliserbarhet" ;
  mineralull_nn_1_N = mkN "mineralull" ;
  minerbarhet_nn_1_N = mkN "minerbarhet" ;
  minett_nn_1_N = mkN "minett" ;
  miniatyriserbarhet_nn_1_N = mkN "miniatyriserbarhet" ;
  minigolf_nn_1_N = mkN "minigolf" ;
  minimerbarhet_nn_1_N = mkN "minimerbarhet" ;
  minnesgodhet_nn_1_N = mkN "minnesgodhet" ;
  minneskonst_nn_2_N = mkN "minneskonst" ;
  minnesrikhet_nn_1_N = mkN "minnesrikhet" ;
  minnesvaerdhet_nn_1_1_N = mkN "minnesvärdhet" ;
  minnesvaard_nn_1_1_N = mkN "minnesvård" ;
  minoritetsforskning_nn_1_N = mkN "minoritetsforskning" ;
  minskhet_nn_1_N = mkN "minskhet" ;
  mint_nn_1_N = mkN "mint" ;
  minutlaeggning_nn_1_1_N = mkN "minutläggning" ;
  missbelaatenhet_nn_1_1_N = mkN "missbelåtenhet" ;
  misshaglighet_nn_1_N = mkN "misshaglighet" ;
  misshushaallning_nn_1_1_N = mkN "misshushållning" ;
  missionsdag_nn_1_N = mkN "missionsdag" ;
  missis_nn_1_N = mkN "missis" ;
  missiverbarhet_nn_1_N = mkN "missiverbarhet" ;
  missklaedsamhet_nn_1_1_N = mkN "missklädsamhet" ;
  misskrediterbarhet_nn_1_N = mkN "misskrediterbarhet" ;
  misskund_nn_1_N = mkN "misskund" ;
  misskundsamhet_nn_1_N = mkN "misskundsamhet" ;
  misskoetsamhet_nn_1_1_N = mkN "misskötsamhet" ;
  missledning_nn_1_N = mkN "missledning" ;
  misslynthet_nn_1_N = mkN "misslynthet" ;
  missmodighet_nn_1_N = mkN "missmodighet" ;
  missnoejdhet_nn_1_1_N = mkN "missnöjdhet" ;
  missnoejesretorik_nn_1_1_N = mkN "missnöjesretorik" ;
  missriktning_nn_1_N = mkN "missriktning" ;
  misstrogenhet_nn_1_N = mkN "misstrogenhet" ;
  missunnsamhet_nn_1_N = mkN "missunnsamhet" ;
  missvaext_nn_1_1_N = mkN "missväxt" ;
  mist_nn_1_N = mkN "mist" ;
  mister_nn_1_N = mkN "mister" ;
  mistighet_nn_1_N = mkN "mistighet" ;
  mistral_nn_1_N = mkN "mistral" ;
  mitt_nn_1_N = mkN "mitt" ;
  mixed_nn_1_N = mkN "mixed" ;
  mjukporr_nn_1_N = mkN "mjukporr" ;
  mjaekighet_nn_1_1_N = mkN "mjäkighet" ;
  mjaellhet_nn_1_1_N = mkN "mjällhet" ;
  mjaellighet_nn_1_1_N = mkN "mjällighet" ;
  mjaeltbrand_nn_1_1_N = mkN "mjältbrand" ;
  mjaeltsjuka_nn_1_1_N = mkN "mjältsjuka" ;
  mjaeltsjukhet_nn_1_1_N = mkN "mjältsjukhet" ;
  mjoeldagg_nn_1_1_N = mkN "mjöldagg" ;
  mjoelighet_nn_1_1_N = mkN "mjölighet" ;
  mjoelk_nn_1_1_N = mkN "mjölk" ;
  mjoelkboskap_nn_1_1_N = mkN "mjölkboskap" ;
  mjoelkchoklad_nn_1_1_N = mkN "mjölkchoklad" ;
  mjoelkighet_nn_1_1_N = mkN "mjölkighet" ;
  mjoelkskorv_nn_1_1_N = mkN "mjölkskorv" ;
  mjoelkstinnhet_nn_1_1_N = mkN "mjölkstinnhet" ;
  mjoelksvullenhet_nn_1_1_N = mkN "mjölksvullenhet" ;
  mnemoteknik_nn_1_N = mkN "mnemoteknik" ;
  mobb_nn_1_N = mkN "mobb" ;
  mobbing_nn_1_N = mkN "mobbing" ;
  mobbning_nn_1_N = mkN "mobbning" ;
  mobilfoersaeljning_nn_1_1_N = mkN "mobilförsäljning" ;
  mobiliserbarhet_nn_1_N = mkN "mobiliserbarhet" ;
  modallogik_nn_1_N = mkN "modallogik" ;
  modd_nn_1_N = mkN "modd" ;
  modellerbarhet_nn_1_N = mkN "modellerbarhet" ;
  modererbarhet_nn_1_N = mkN "modererbarhet" ;
  moderiktighet_nn_1_N = mkN "moderiktighet" ;
  moderlighet_nn_1_N = mkN "moderlighet" ;
  moderniserbarhet_nn_1_N = mkN "moderniserbarhet" ;
  moderraett_nn_1_1_N = mkN "moderrätt" ;
  moderskaerlek_nn_1_1_N = mkN "moderskärlek" ;
  modersmjoelk_nn_1_1_N = mkN "modersmjölk" ;
  modesthet_nn_1_N = mkN "modesthet" ;
  modevaerld_nn_1_1_N = mkN "modevärld" ;
  modfaelldhet_nn_1_1_N = mkN "modfälldhet" ;
  modifierbarhet_nn_1_N = mkN "modifierbarhet" ;
  modloeshet_nn_1_1_N = mkN "modlöshet" ;
  modstulenhet_nn_1_N = mkN "modstulenhet" ;
  modulerbarhet_nn_1_N = mkN "modulerbarhet" ;
  modaerniserbarhet_nn_1_1_N = mkN "modärniserbarhet" ;
  mohair_nn_1_N = mkN "mohair" ;
  mohaer_nn_1_1_N = mkN "mohär" ;
  mojhet_nn_1_N = mkN "mojhet" ;
  mol_nn_1_N = mkN "mol" ;
  moll_nn_1_N = mkN "moll" ;
  mollstaemdhet_nn_1_1_N = mkN "mollstämdhet" ;
  molok_nn_1_N = mkN "molok" ;
  molokenhet_nn_1_N = mkN "molokenhet" ;
  molybdenglans_nn_1_N = mkN "molybdenglans" ;
  moms_nn_1_N = mkN "moms" ;
  monoftongerbarhet_nn_1_N = mkN "monoftongerbarhet" ;
  monopoliserbarhet_nn_1_N = mkN "monopoliserbarhet" ;
  monsieur_nn_1_N = mkN "monsieur" ;
  monterbarhet_nn_1_N = mkN "monterbarhet" ;
  monteringstejp_nn_1_N = mkN "monteringstejp" ;
  monumentalkonst_nn_1_N = mkN "monumentalkonst" ;
  mopsighet_nn_1_N = mkN "mopsighet" ;
  moralpanik_nn_1_N = mkN "moralpanik" ;
  mordlust_nn_1_N = mkN "mordlust" ;
  mordlystenhet_nn_1_N = mkN "mordlystenhet" ;
  morgonpigghet_nn_1_N = mkN "morgonpigghet" ;
  morgonrusning_nn_1_N = mkN "morgonrusning" ;
  morgonsol_nn_1_N = mkN "morgonsol" ;
  morgontroetthet_nn_1_1_N = mkN "morgontrötthet" ;
  morgonvaekt_nn_1_1_N = mkN "morgonväkt" ;
  morron_nn_1_N = mkN "morron" ;
  morserbarhet_nn_1_N = mkN "morserbarhet" ;
  morskhet_nn_1_N = mkN "morskhet" ;
  mortificerbarhet_nn_1_N = mkN "mortificerbarhet" ;
  mortifierbarhet_nn_1_N = mkN "mortifierbarhet" ;
  mosaiksjuka_nn_1_N = mkN "mosaiksjuka" ;
  mosighet_nn_1_N = mkN "mosighet" ;
  mosning_nn_1_N = mkN "mosning" ;
  mossbelupenhet_nn_1_N = mkN "mossbelupenhet" ;
  mossighet_nn_1_N = mkN "mossighet" ;
  mossljung_nn_1_N = mkN "mossljung" ;
  mosstorv_nn_1_N = mkN "mosstorv" ;
  mosterlighet_nn_1_N = mkN "mosterlighet" ;
  moteld_nn_1_N = mkN "moteld" ;
  motionsgymnastik_nn_1_N = mkN "motionsgymnastik" ;
  motionsraett_nn_1_1_N = mkN "motionsrätt" ;
  motiverbarhet_nn_1_N = mkN "motiverbarhet" ;
  motocross_nn_1_N = mkN "motocross" ;
  motorik_nn_1_N = mkN "motorik" ;
  motoriserbarhet_nn_1_N = mkN "motoriserbarhet" ;
  motorrengoering_nn_1_1_N = mkN "motorrengöring" ;
  motorsport_nn_1_N = mkN "motorsport" ;
  motortvaett_nn_1_1_N = mkN "motortvätt" ;
  motspaenstighet_nn_1_1_N = mkN "motspänstighet" ;
  motstridighet_nn_1_N = mkN "motstridighet" ;
  motstraevighet_nn_1_1_N = mkN "motsträvighet" ;
  motstaandskraft_nn_1_1_N = mkN "motståndskraft" ;
  motstaandsloeshet_nn_1_1_N = mkN "motståndslöshet" ;
  motsaegelsefullhet_nn_1_1_N = mkN "motsägelsefullhet" ;
  motsaettlighet_nn_1_1_N = mkN "motsättlighet" ;
  mottaglighet_nn_1_N = mkN "mottaglighet" ;
  motvillighet_nn_1_N = mkN "motvillighet" ;
  motyl_nn_1_N = mkN "motyl" ;
  muck_nn_2_N = mkN "muck" ;
  muddrighet_nn_1_N = mkN "muddrighet" ;
  mugg_nn_2_N = mkN "mugg" ;
  mulenhet_nn_1_N = mkN "mulenhet" ;
  muljerbarhet_nn_1_N = mkN "muljerbarhet" ;
  mull_nn_1_N = mkN "mull" ;
  mullighet_nn_1_N = mkN "mullighet" ;
  multegroet_nn_1_1_N = mkN "multegröt" ;
  multenhet_nn_1_N = mkN "multenhet" ;
  multikonst_nn_1_N = mkN "multikonst" ;
  multiplicerbarhet_nn_1_N = mkN "multiplicerbarhet" ;
  multiresistens_nn_1_N = mkN "multiresistens" ;
  multisjukhet_nn_1_N = mkN "multisjukhet" ;
  mumifierbarhet_nn_1_N = mkN "mumifierbarhet" ;
  mumsighet_nn_1_N = mkN "mumsighet" ;
  munblaast_nn_1_1_N = mkN "munblåst" ;
  munkskrift_nn_1_N = mkN "munkskrift" ;
  muntlighet_nn_1_N = mkN "muntlighet" ;
  munvighet_nn_1_N = mkN "munvighet" ;
  muppighet_nn_1_N = mkN "muppighet" ;
  murkenhet_nn_1_N = mkN "murkenhet" ;
  murrighet_nn_1_N = mkN "murrighet" ;
  museimaessighet_nn_1_1_N = mkN "museimässighet" ;
  musik_nn_1_N = mkN "musik" "musiker" ;
  muskat_nn_1_N = mkN "muskat" ;
  muskatell_nn_1_N = mkN "muskatell" ;
  muskelvaerk_nn_1_1_N = mkN "muskelvärk" ;
  muskot_nn_1_N = mkN "muskot" ;
  must_nn_2_N = mkN "must" ;
  mustighet_nn_1_N = mkN "mustighet" ;
  muterbarhet_nn_1_N = mkN "muterbarhet" ;
  muzak_nn_1_N = mkN "muzak" ;
  myllighet_nn_1_N = mkN "myllighet" ;
  myndighetsutoevning_nn_1_1_N = mkN "myndighetsutövning" ;
  myntfot_nn_1_N = mkN "myntfot" ;
  mysk_nn_1_N = mkN "mysk" ;
  mystifierbarhet_nn_1_N = mkN "mystifierbarhet" ;
  mystik_nn_1_N = mkN "mystik" ;
  maell_nn_1_1_N = mkN "mäll" ;
  maenniskofientlighet_nn_1_1_N = mkN "människofientlighet" ;
  maenniskolikhet_nn_1_1_N = mkN "människolikhet" ;
  maenniskoraettskamp_nn_1_1_N = mkN "människorättskamp" ;
  maenniskosmuggling_nn_1_1_N = mkN "människosmuggling" ;
  maenniskoson_nn_1_1_N = mkN "människoson" ;
  maenniskosyn_nn_1_1_N = mkN "människosyn" ;
  maenniskovaerdighet_nn_1_1_N = mkN "människovärdighet" ;
  maerg_nn_1_1_N = mkN "märg" ;
  maergfullhet_nn_1_1_N = mkN "märgfullhet" ;
  maergloeshet_nn_1_1_N = mkN "märglöshet" ;
  maerkbarhet_nn_1_1_N = mkN "märkbarhet" ;
  maerkesmystik_nn_1_1_N = mkN "märkesmystik" ;
  maerkesraett_nn_1_1_N = mkN "märkesrätt" ;
  maesk_nn_1_1_N = mkN "mäsk" ;
  maessing_nn_1_1_N = mkN "mässing" ;
  maessingsmusik_nn_1_1_N = mkN "mässingsmusik" ;
  maessling_nn_1_1_N = mkN "mässling" ;
  maester_nn_1_1_N = mkN "mäster" ;
  maesterlighet_nn_1_1_N = mkN "mästerlighet" ;
  maestersaang_nn_1_1_N = mkN "mästersång" ;
  maetthet_nn_1_1_N = mkN "mätthet" ;
  maettsamhet_nn_1_1_N = mkN "mättsamhet" ;
  maalfarlighet_nn_1_1_N = mkN "målfarlighet" ;
  maalloeshet_nn_1_1_N = mkN "mållöshet" ;
  maalmedvetenhet_nn_1_1_N = mkN "målmedvetenhet" ;
  maanformighet_nn_1_1_N = mkN "månformighet" ;
  maangfaldighet_nn_1_1_N = mkN "mångfaldighet" ;
  maanggestaltning_nn_1_1_N = mkN "månggestaltning" ;
  maangkunnighet_nn_1_1_N = mkN "mångkunnighet" ;
  maangordighet_nn_1_1_N = mkN "mångordighet" ;
  maangspraakighet_nn_1_1_N = mkN "mångspråkighet" ;
  maangstavighet_nn_1_1_N = mkN "mångstavighet" ;
  maangstaemmighet_nn_1_1_N = mkN "mångstämmighet" ;
  maangvetenskaplighet_nn_1_1_N = mkN "mångvetenskaplighet" ;
  maangaarighet_nn_1_1_N = mkN "mångårighet" ;
  maanhet_nn_1_1_N = mkN "månhet" ;
  maanmark_nn_1_1_N = mkN "månmark" ;
  maansing_nn_1_1_N = mkN "månsing" ;
  maar_nn_1_1_N = mkN "mår" ;
  maarten_nn_1_1_N = mkN "mårten" ;
  maartensgaas_nn_1_1_N = mkN "mårtensgås" ;
  maattfullhet_nn_1_1_N = mkN "måttfullhet" ;
  maattlighet_nn_1_1_N = mkN "måttlighet" ;
  maattloeshet_nn_1_1_N = mkN "måttlöshet" ;
  moeblerbarhet_nn_1_1_N = mkN "möblerbarhet" ;
  moedosamhet_nn_1_1_N = mkN "mödosamhet" ;
  moedravaard_nn_1_1_N = mkN "mödravård" ;
  moegeltvaett_nn_1_1_N = mkN "mögeltvätt" ;
  moeglighet_nn_1_1_N = mkN "möglighet" ;
  moenstergillhet_nn_1_1_N = mkN "mönstergillhet" ;
  moerhet_nn_1_1_N = mkN "mörhet" ;
  moerjighet_nn_1_1_N = mkN "mörjighet" ;
  moerkblondhet_nn_1_1_N = mkN "mörkblondhet" ;
  moerkerdoed_nn_1_1_N = mkN "mörkerdöd" ;
  moerkhet_nn_1_1_N = mkN "mörkhet" ;
  moerkhaarighet_nn_1_1_N = mkN "mörkhårighet" ;
  moerkning_nn_1_1_N = mkN "mörkning" ;
  moerkraedsla_nn_1_1_N = mkN "mörkrädsla" ;
  moerksyn_nn_1_1_N = mkN "mörksyn" ;
  naboraett_nn_1_1_N = mkN "naborätt" ;
  nackstyvhet_nn_1_N = mkN "nackstyvhet" ;
  nackvaerk_nn_1_1_N = mkN "nackvärk" ;
  nadir_nn_1_N = mkN "nadir" ;
  naivhet_nn_1_N = mkN "naivhet" ;
  namnfrejd_nn_1_N = mkN "namnfrejd" ;
  namnloeshet_nn_1_1_N = mkN "namnlöshet" ;
  nanoteknik_nn_1_N = mkN "nanoteknik" ;
  napalm_nn_1_N = mkN "napalm" ;
  nardus_nn_1_N = mkN "nardus" ;
  narkomanvaard_nn_1_1_N = mkN "narkomanvård" ;
  narkotikabekaempning_nn_1_1_N = mkN "narkotikabekämpning" ;
  narkotikasmuggling_nn_1_N = mkN "narkotikasmuggling" ;
  narraktighet_nn_1_N = mkN "narraktighet" ;
  narv_nn_1_N = mkN "narv" ;
  nasalerbarhet_nn_1_N = mkN "nasalerbarhet" ;
  nasaliserbarhet_nn_1_N = mkN "nasaliserbarhet" ;
  nationaliserbarhet_nn_1_N = mkN "nationaliserbarhet" ;
  nationalitetsprincip_nn_1_N = mkN "nationalitetsprincip" ;
  nationalkaensla_nn_1_1_N = mkN "nationalkänsla" ;
  nationalromantik_nn_1_N = mkN "nationalromantik" ;
  natriumklorid_nn_1_N = mkN "natriumklorid" ;
  natteffekt_nn_1_N = mkN "natteffekt" ;
  nattfrost_nn_1_N = mkN "nattfrost" ;
  nattkvist_nn_1_N = mkN "nattkvist" ;
  nattluft_nn_1_N = mkN "nattluft" ;
  nattsvarthet_nn_1_N = mkN "nattsvarthet" ;
  nattsoemn_nn_1_1_N = mkN "nattsömn" ;
  nattvardsgemenskap_nn_1_N = mkN "nattvardsgemenskap" ;
  nattvila_nn_1_N = mkN "nattvila" ;
  natur_nn_1_N = mkN "natur" ;
  naturaliserbarhet_nn_1_N = mkN "naturaliserbarhet" ;
  naturenlighet_nn_1_N = mkN "naturenlighet" ;
  naturis_nn_1_N = mkN "naturis" ;
  naturkosmetik_nn_1_N = mkN "naturkosmetik" ;
  naturkunskap_nn_1_N = mkN "naturkunskap" ;
  naturkunskapsundervisning_nn_1_N = mkN "naturkunskapsundervisning" ;
  naturlighet_nn_1_N = mkN "naturlighet" ;
  naturmetaforik_nn_1_N = mkN "naturmetaforik" ;
  naturmystik_nn_1_N = mkN "naturmystik" ;
  naturraett_nn_1_1_N = mkN "naturrätt" ;
  naturskoenhet_nn_1_1_N = mkN "naturskönhet" ;
  naturstridighet_nn_1_N = mkN "naturstridighet" ;
  naturvetenskaplighet_nn_1_N = mkN "naturvetenskaplighet" ;
  naturvidrighet_nn_1_N = mkN "naturvidrighet" ;
  naturvaard_nn_1_1_N = mkN "naturvård" ;
  nautik_nn_1_N = mkN "nautik" ;
  navalmedicin_nn_1_N = mkN "navalmedicin" ;
  navigerbarhet_nn_1_N = mkN "navigerbarhet" ;
  nedbrytbarhet_nn_1_N = mkN "nedbrytbarhet" ;
  nederboerd_nn_1_1_N = mkN "nederbörd" ;
  nedkomst_nn_1_N = mkN "nedkomst" ;
  nedslagenhet_nn_1_N = mkN "nedslagenhet" ;
  nedstaemdhet_nn_1_1_N = mkN "nedstämdhet" ;
  nedstoertning_nn_1_1_N = mkN "nedstörtning" ;
  nedtransformerbarhet_nn_1_N = mkN "nedtransformerbarhet" ;
  nedtransponerbarhet_nn_1_N = mkN "nedtransponerbarhet" ;
  nedtryckthet_nn_1_N = mkN "nedtryckthet" ;
  nedtystning_nn_1_N = mkN "nedtystning" ;
  nedvaerderbarhet_nn_1_1_N = mkN "nedvärderbarhet" ;
  nedaatgaang_nn_1_1_N = mkN "nedåtgång" ;
  negerbarhet_nn_1_N = mkN "negerbarhet" ;
  negligerbarhet_nn_1_N = mkN "negligerbarhet" ;
  negocierbarhet_nn_1_N = mkN "negocierbarhet" ;
  negotierbarhet_nn_1_N = mkN "negotierbarhet" ;
  nekros_nn_1_N = mkN "nekros" ;
  nemesis_nn_1_N = mkN "nemesis" ;
  nerkomst_nn_1_N = mkN "nerkomst" ;
  nertid_nn_1_N = mkN "nertid" ;
  nertransformerbarhet_nn_1_N = mkN "nertransformerbarhet" ;
  nertransponerbarhet_nn_1_N = mkN "nertransponerbarhet" ;
  nerts_nn_1_N = mkN "nerts" ;
  nertsbisam_nn_1_N = mkN "nertsbisam" ;
  nertystning_nn_1_N = mkN "nertystning" ;
  nertz_nn_1_N = mkN "nertz" ;
  nertzbisam_nn_1_N = mkN "nertzbisam" ;
  nervighet_nn_1_N = mkN "nervighet" ;
  nervpress_nn_1_N = mkN "nervpress" ;
  nervaerderbarhet_nn_1_1_N = mkN "nervärderbarhet" ;
  nerz_nn_1_N = mkN "nerz" ;
  nerzbisam_nn_1_N = mkN "nerzbisam" ;
  neraatgaang_nn_1_1_N = mkN "neråtgång" ;
  nessosdraekt_nn_1_1_N = mkN "nessosdräkt" ;
  nessusdraekt_nn_1_1_N = mkN "nessusdräkt" ;
  nettovikt_nn_1_N = mkN "nettovikt" ;
  neuralisering_nn_1_N = mkN "neuralisering" ;
  neurotisering_nn_1_N = mkN "neurotisering" ;
  neutraliserbarhet_nn_1_N = mkN "neutraliserbarhet" ;
  nidskhet_nn_1_N = mkN "nidskhet" ;
  niellerbarhet_nn_1_N = mkN "niellerbarhet" ;
  nimbus_nn_1_N = mkN "nimbus" ;
  niob_nn_1_N = mkN "niob" ;
  nipprighet_nn_1_N = mkN "nipprighet" ;
  nitiskhet_nn_1_N = mkN "nitiskhet" ;
  nitrerbarhet_nn_1_N = mkN "nitrerbarhet" ;
  nitrolit_nn_1_N = mkN "nitrolit" ;
  nivellerbarhet_nn_1_N = mkN "nivellerbarhet" ;
  nivaagrupperbarhet_nn_1_1_N = mkN "nivågrupperbarhet" ;
  njugghet_nn_1_N = mkN "njugghet" ;
  njugghaenthet_nn_1_1_N = mkN "njugghänthet" ;
  njurtalg_nn_1_N = mkN "njurtalg" ;
  njutbarhet_nn_1_N = mkN "njutbarhet" ;
  njutningsfullhet_nn_1_N = mkN "njutningsfullhet" ;
  njutningsrikedom_nn_1_N = mkN "njutningsrikedom" ;
  nobiliserbarhet_nn_1_N = mkN "nobiliserbarhet" ;
  nobless_nn_1_N = mkN "nobless" ;
  nollmeridian_nn_1_N = mkN "nollmeridian" ;
  nolltillvaext_nn_1_1_N = mkN "nolltillväxt" ;
  nolltolerans_nn_1_N = mkN "nolltolerans" ;
  noltighet_nn_1_N = mkN "noltighet" ;
  nominerbarhet_nn_1_N = mkN "nominerbarhet" ;
  nonchalans_nn_1_N = mkN "nonchalans" ;
  nonchalerbarhet_nn_1_N = mkN "nonchalerbarhet" ;
  nonpareil_nn_1_N = mkN "nonpareil" ;
  noppighet_nn_1_N = mkN "noppighet" ;
  nord_nn_1_N = mkN "nord" ;
  nordost_nn_1_N = mkN "nordost" ;
  nordsjoefart_nn_1_1_N = mkN "nordsjöfart" ;
  nordvaest_nn_1_1_N = mkN "nordväst" ;
  nordoest_nn_1_1_N = mkN "nordöst" ;
  normalblyghet_nn_1_N = mkN "normalblyghet" ;
  normaliserbarhet_nn_1_N = mkN "normaliserbarhet" ;
  normalkraft_nn_1_N = mkN "normalkraft" ;
  normalpotential_nn_1_N = mkN "normalpotential" ;
  normalskolekompetens_nn_1_N = mkN "normalskolekompetens" ;
  normerbarhet_nn_1_N = mkN "normerbarhet" ;
  norskhet_nn_1_N = mkN "norskhet" ;
  nosserot_nn_1_N = mkN "nosserot" ;
  noterbarhet_nn_1_N = mkN "noterbarhet" ;
  notificerbarhet_nn_1_N = mkN "notificerbarhet" ;
  notifierbarhet_nn_1_N = mkN "notifierbarhet" ;
  notiserbarhet_nn_1_N = mkN "notiserbarhet" ;
  notskrift_nn_1_N = mkN "notskrift" ;
  notsaekerhet_nn_1_1_N = mkN "notsäkerhet" ;
  novellistik_nn_1_N = mkN "novellistik" ;
  november_nn_1_N = mkN "november" ;
  novemberskymning_nn_1_N = mkN "novemberskymning" ;
  nuckighet_nn_1_N = mkN "nuckighet" ;
  numismatik_nn_1_N = mkN "numismatik" ;
  nummerordning_nn_1_N = mkN "nummerordning" ;
  numrerbarhet_nn_1_N = mkN "numrerbarhet" ;
  nutid_nn_1_N = mkN "nutid" ;
  nyanserbarhet_nn_1_N = mkN "nyanserbarhet" ;
  nyantik_nn_1_N = mkN "nyantik" ;
  nyemitterbarhet_nn_1_N = mkN "nyemitterbarhet" ;
  nyetablerbarhet_nn_1_N = mkN "nyetablerbarhet" ;
  nygotik_nn_1_N = mkN "nygotik" ;
  nyhetsbrist_nn_1_N = mkN "nyhetsbrist" ;
  nyhetsjakt_nn_1_N = mkN "nyhetsjakt" ;
  nyinvesterbarhet_nn_1_N = mkN "nyinvesterbarhet" ;
  nykterhetsvaard_nn_1_1_N = mkN "nykterhetsvård" ;
  nyliberalism_nn_1_N = mkN "nyliberalism" ;
  nyplanterbarhet_nn_1_N = mkN "nyplanterbarhet" ;
  nyrikhet_nn_1_N = mkN "nyrikhet" ;
  nyromantik_nn_1_N = mkN "nyromantik" ;
  nyterhet_nn_1_N = mkN "nyterhet" ;
  nytestamentlighet_nn_1_N = mkN "nytestamentlighet" ;
  nyttighetsmoral_nn_1_N = mkN "nyttighetsmoral" ;
  nyttjanderaett_nn_1_1_N = mkN "nyttjanderätt" ;
  nyttokonst_nn_1_N = mkN "nyttokonst" ;
  nyttomoral_nn_1_N = mkN "nyttomoral" ;
  nyttotrafik_nn_1_N = mkN "nyttotrafik" ;
  naebbighet_nn_1_1_N = mkN "näbbighet" ;
  naeck_nn_1_1_N = mkN "näck" ;
  naeckning_nn_1_1_N = mkN "näckning" ;
  naemnbarhet_nn_1_1_N = mkN "nämnbarhet" ;
  naemnvaerdhet_nn_1_1_N = mkN "nämnvärdhet" ;
  naepst_nn_1_1_N = mkN "näpst" ;
  naerighet_nn_1_1_N = mkN "närighet" ;
  naeringsflit_nn_1_1_N = mkN "näringsflit" ;
  naeringslivspolitik_nn_1_1_N = mkN "näringslivspolitik" ;
  naeringspolitik_nn_1_1_N = mkN "näringspolitik" ;
  naeringsrikhet_nn_1_1_N = mkN "näringsrikhet" ;
  naerkontakt_nn_1_1_N = mkN "närkontakt" ;
  naerskyldhet_nn_1_1_N = mkN "närskyldhet" ;
  naerstudering_nn_1_1_N = mkN "närstudering" ;
  naervarorapportering_nn_1_1_N = mkN "närvarorapportering" ;
  naesselkaal_nn_1_1_N = mkN "nässelkål" ;
  naeston_nn_1_1_N = mkN "näston" ;
  naesvishet_nn_1_1_N = mkN "näsvishet" ;
  naetcensur_nn_1_1_N = mkN "nätcensur" ;
  naetdrift_nn_1_1_N = mkN "nätdrift" ;
  naetformighet_nn_1_1_N = mkN "nätformighet" ;
  naethinneavlossning_nn_1_1_N = mkN "näthinneavlossning" ;
  naetporr_nn_1_1_N = mkN "nätporr" ;
  naetthet_nn_1_1_N = mkN "nätthet" ;
  naetverksforskning_nn_1_1_N = mkN "nätverksforskning" ;
  naevgroet_nn_1_1_N = mkN "nävgröt" ;
  naevraett_nn_1_1_N = mkN "nävrätt" ;
  naad_nn_1_1_N = mkN "nåd" ;
  naadastol_nn_1_1_N = mkN "nådastol" ;
  naadatid_nn_1_1_N = mkN "nådatid" ;
  naadelighet_nn_1_1_N = mkN "nådelighet" ;
  noed_nn_1_1_N = mkN "nöd" ;
  noedbeddhet_nn_1_1_N = mkN "nödbeddhet" ;
  noeddhet_nn_1_1_N = mkN "nöddhet" ;
  noedflagg_nn_1_1_N = mkN "nödflagg" ;
  noedhjaelp_nn_1_1_N = mkN "nödhjälp" ;
  noedproviant_nn_1_1_N = mkN "nödproviant" ;
  noedraett_nn_1_1_N = mkN "nödrätt" ;
  noedslakt_nn_1_1_N = mkN "nödslakt" ;
  noedstaelldhet_nn_1_1_N = mkN "nödställdhet" ;
  noedtorft_nn_1_1_N = mkN "nödtorft" ;
  noedvaernsraett_nn_1_1_N = mkN "nödvärnsrätt" ;
  noejaktighet_nn_1_1_N = mkN "nöjaktighet" ;
  noejdhet_nn_1_1_N = mkN "nöjdhet" ;
  noejesbransch_nn_1_1_N = mkN "nöjesbransch" ;
  noejesjakt_nn_1_1_N = mkN "nöjesjakt" ;
  noejsamhet_nn_1_1_N = mkN "nöjsamhet" ;
  noerdighet_nn_1_1_N = mkN "nördighet" ;
  noetboskap_nn_1_1_N = mkN "nötboskap" ;
  noetchoklad_nn_1_1_N = mkN "nötchoklad" ;
  noetkreatursdrift_nn_1_1_N = mkN "nötkreatursdrift" ;
  noetningsbestaendighet_nn_1_1_N = mkN "nötningsbeständighet" ;
  noetningsresistans_nn_1_1_N = mkN "nötningsresistans" ;
  oabbrevierbarhet_nn_1_N = mkN "oabbrevierbarhet" ;
  oabdikerbarhet_nn_1_N = mkN "oabdikerbarhet" ;
  oabonnerbarhet_nn_1_N = mkN "oabonnerbarhet" ;
  oaborterbarhet_nn_1_N = mkN "oaborterbarhet" ;
  oabraderbarhet_nn_1_N = mkN "oabraderbarhet" ;
  oabsolverbarhet_nn_1_N = mkN "oabsolverbarhet" ;
  oabsorberbarhet_nn_1_N = mkN "oabsorberbarhet" ;
  oabstraherbarhet_nn_1_N = mkN "oabstraherbarhet" ;
  oaccederbarhet_nn_1_N = mkN "oaccederbarhet" ;
  oaccelererbarhet_nn_1_N = mkN "oaccelererbarhet" ;
  oaccentuerbarhet_nn_1_N = mkN "oaccentuerbarhet" ;
  oaccepterbarhet_nn_1_N = mkN "oaccepterbarhet" ;
  oacklimatiserbarhet_nn_1_N = mkN "oacklimatiserbarhet" ;
  oackommoderbarhet_nn_1_N = mkN "oackommoderbarhet" ;
  oackompanjerbarhet_nn_1_N = mkN "oackompanjerbarhet" ;
  oackorderbarhet_nn_1_N = mkN "oackorderbarhet" ;
  oackrediterbarhet_nn_1_N = mkN "oackrediterbarhet" ;
  oackumulerbarhet_nn_1_N = mkN "oackumulerbarhet" ;
  oackvirerbarhet_nn_1_N = mkN "oackvirerbarhet" ;
  oadapterbarhet_nn_1_N = mkN "oadapterbarhet" ;
  oadderbarhet_nn_1_N = mkN "oadderbarhet" ;
  oadjungerbarhet_nn_1_N = mkN "oadjungerbarhet" ;
  oadministrerbarhet_nn_1_N = mkN "oadministrerbarhet" ;
  oadopterbarhet_nn_1_N = mkN "oadopterbarhet" ;
  oadresserbarhet_nn_1_N = mkN "oadresserbarhet" ;
  oadsorberbarhet_nn_1_N = mkN "oadsorberbarhet" ;
  oaducerbarhet_nn_1_N = mkN "oaducerbarhet" ;
  oadvocerbarhet_nn_1_N = mkN "oadvocerbarhet" ;
  oafficierbarhet_nn_1_N = mkN "oafficierbarhet" ;
  oaffinerbarhet_nn_1_N = mkN "oaffinerbarhet" ;
  oaffischerbarhet_nn_1_N = mkN "oaffischerbarhet" ;
  oafrikaniserbarhet_nn_1_N = mkN "oafrikaniserbarhet" ;
  oagerbarhet_nn_1_N = mkN "oagerbarhet" ;
  oagglomererbarhet_nn_1_N = mkN "oagglomererbarhet" ;
  oagglutinerbarhet_nn_1_N = mkN "oagglutinerbarhet" ;
  oagiterbarhet_nn_1_N = mkN "oagiterbarhet" ;
  oajournerbarhet_nn_1_N = mkN "oajournerbarhet" ;
  oaktiverbarhet_nn_1_N = mkN "oaktiverbarhet" ;
  oaktualiserbarhet_nn_1_N = mkN "oaktualiserbarhet" ;
  oalarmerbarhet_nn_1_N = mkN "oalarmerbarhet" ;
  oalfabetiserbarhet_nn_1_N = mkN "oalfabetiserbarhet" ;
  oalienerbarhet_nn_1_N = mkN "oalienerbarhet" ;
  oallegoriserbarhet_nn_1_N = mkN "oallegoriserbarhet" ;
  oallierbarhet_nn_1_N = mkN "oallierbarhet" ;
  oallittererbarhet_nn_1_N = mkN "oallittererbarhet" ;
  oallokerbarhet_nn_1_N = mkN "oallokerbarhet" ;
  oalluderbarhet_nn_1_N = mkN "oalluderbarhet" ;
  oalternerbarhet_nn_1_N = mkN "oalternerbarhet" ;
  oaluminerbarhet_nn_1_N = mkN "oaluminerbarhet" ;
  oamalgamerbarhet_nn_1_N = mkN "oamalgamerbarhet" ;
  oambulerbarhet_nn_1_N = mkN "oambulerbarhet" ;
  oamerikaniserbarhet_nn_1_N = mkN "oamerikaniserbarhet" ;
  oamorterbarhet_nn_1_N = mkN "oamorterbarhet" ;
  oamplifierbarhet_nn_1_N = mkN "oamplifierbarhet" ;
  oamputerbarhet_nn_1_N = mkN "oamputerbarhet" ;
  oanalyserbarhet_nn_1_N = mkN "oanalyserbarhet" ;
  oandlighet_nn_1_N = mkN "oandlighet" ;
  oanfraetthet_nn_1_1_N = mkN "oanfrätthet" ;
  oangenaemhet_nn_1_1_N = mkN "oangenämhet" ;
  oangliserbarhet_nn_1_N = mkN "oangliserbarhet" ;
  oangripbarhet_nn_1_N = mkN "oangripbarhet" ;
  oangriplighet_nn_1_N = mkN "oangriplighet" ;
  oanimerbarhet_nn_1_N = mkN "oanimerbarhet" ;
  oannekterbarhet_nn_1_N = mkN "oannekterbarhet" ;
  oannihilerbarhet_nn_1_N = mkN "oannihilerbarhet" ;
  oannonserbarhet_nn_1_N = mkN "oannonserbarhet" ;
  oannoterbarhet_nn_1_N = mkN "oannoterbarhet" ;
  oannullerbarhet_nn_1_N = mkN "oannullerbarhet" ;
  oanodiserbarhet_nn_1_N = mkN "oanodiserbarhet" ;
  oanonymiserbarhet_nn_1_N = mkN "oanonymiserbarhet" ;
  oansenlighet_nn_1_N = mkN "oansenlighet" ;
  oansvarighet_nn_1_N = mkN "oansvarighet" ;
  oantagbarhet_nn_1_N = mkN "oantagbarhet" ;
  oantaglighet_nn_1_N = mkN "oantaglighet" ;
  oanteciperbarhet_nn_1_N = mkN "oanteciperbarhet" ;
  oantedaterbarhet_nn_1_N = mkN "oantedaterbarhet" ;
  oantichambrerbarhet_nn_1_N = mkN "oantichambrerbarhet" ;
  oantikiserbarhet_nn_1_N = mkN "oantikiserbarhet" ;
  oantraeffbarhet_nn_1_1_N = mkN "oanträffbarhet" ;
  oanvaendbarhet_nn_1_1_N = mkN "oanvändbarhet" ;
  oapostroferbarhet_nn_1_N = mkN "oapostroferbarhet" ;
  oappellerbarhet_nn_1_N = mkN "oappellerbarhet" ;
  oapplicerbarhet_nn_1_N = mkN "oapplicerbarhet" ;
  oapplaaderbarhet_nn_1_1_N = mkN "oapplåderbarhet" ;
  oapporterbarhet_nn_1_N = mkN "oapporterbarhet" ;
  oapprecierbarhet_nn_1_N = mkN "oapprecierbarhet" ;
  oappreterbarhet_nn_1_N = mkN "oappreterbarhet" ;
  oapprocherbarhet_nn_1_N = mkN "oapprocherbarhet" ;
  oapproximerbarhet_nn_1_N = mkN "oapproximerbarhet" ;
  oapterbarhet_nn_1_N = mkN "oapterbarhet" ;
  oaptitlighet_nn_1_N = mkN "oaptitlighet" ;
  oargumenterbarhet_nn_1_N = mkN "oargumenterbarhet" ;
  oarkaiserbarhet_nn_1_N = mkN "oarkaiserbarhet" ;
  oarkebuserbarhet_nn_1_N = mkN "oarkebuserbarhet" ;
  oarkiverbarhet_nn_1_N = mkN "oarkiverbarhet" ;
  oarmerbarhet_nn_1_N = mkN "oarmerbarhet" ;
  oarrangerbarhet_nn_1_N = mkN "oarrangerbarhet" ;
  oarrenderbarhet_nn_1_N = mkN "oarrenderbarhet" ;
  oarresterbarhet_nn_1_N = mkN "oarresterbarhet" ;
  oarronderbarhet_nn_1_N = mkN "oarronderbarhet" ;
  oartikulerbarhet_nn_1_N = mkN "oartikulerbarhet" ;
  oarvoderbarhet_nn_1_N = mkN "oarvoderbarhet" ;
  oasfalterbarhet_nn_1_N = mkN "oasfalterbarhet" ;
  oaspirerbarhet_nn_1_N = mkN "oaspirerbarhet" ;
  oassignerbarhet_nn_1_N = mkN "oassignerbarhet" ;
  oassimilerbarhet_nn_1_N = mkN "oassimilerbarhet" ;
  oassisterbarhet_nn_1_N = mkN "oassisterbarhet" ;
  oassocierbarhet_nn_1_N = mkN "oassocierbarhet" ;
  oassurerbarhet_nn_1_N = mkN "oassurerbarhet" ;
  oatrofierbarhet_nn_1_N = mkN "oatrofierbarhet" ;
  oattackerbarhet_nn_1_N = mkN "oattackerbarhet" ;
  oattesterbarhet_nn_1_N = mkN "oattesterbarhet" ;
  oattraherbarhet_nn_1_N = mkN "oattraherbarhet" ;
  oattrapperbarhet_nn_1_N = mkN "oattrapperbarhet" ;
  oattribuerbarhet_nn_1_N = mkN "oattribuerbarhet" ;
  oauktionerbarhet_nn_1_N = mkN "oauktionerbarhet" ;
  oauktoriserbarhet_nn_1_N = mkN "oauktoriserbarhet" ;
  oauskulterbarhet_nn_1_N = mkN "oauskulterbarhet" ;
  oautenticerbarhet_nn_1_N = mkN "oautenticerbarhet" ;
  oautentifierbarhet_nn_1_N = mkN "oautentifierbarhet" ;
  oautentiserbarhet_nn_1_N = mkN "oautentiserbarhet" ;
  oautomatiserbarhet_nn_1_N = mkN "oautomatiserbarhet" ;
  oavancerbarhet_nn_1_N = mkN "oavancerbarhet" ;
  oavannonserbarhet_nn_1_N = mkN "oavannonserbarhet" ;
  oavdramatiserbarhet_nn_1_N = mkN "oavdramatiserbarhet" ;
  oaviserbarhet_nn_1_N = mkN "oaviserbarhet" ;
  oavkoloniserbarhet_nn_1_N = mkN "oavkoloniserbarhet" ;
  oavkriminaliserbarhet_nn_1_N = mkN "oavkriminaliserbarhet" ;
  oavlaatlighet_nn_1_1_N = mkN "oavlåtlighet" ;
  oavmagnetiserbarhet_nn_1_N = mkN "oavmagnetiserbarhet" ;
  oavmystifierbarhet_nn_1_N = mkN "oavmystifierbarhet" ;
  oavmaetthet_nn_1_1_N = mkN "oavmätthet" ;
  oavnazifierbarhet_nn_1_N = mkN "oavnazifierbarhet" ;
  oavpatrullerbarhet_nn_1_N = mkN "oavpatrullerbarhet" ;
  oavpolitiserbarhet_nn_1_N = mkN "oavpolitiserbarhet" ;
  oavpolletterbarhet_nn_1_N = mkN "oavpolletterbarhet" ;
  oavportraetterbarhet_nn_1_1_N = mkN "oavporträtterbarhet" ;
  oavreagerbarhet_nn_1_N = mkN "oavreagerbarhet" ;
  oavregistrerbarhet_nn_1_N = mkN "oavregistrerbarhet" ;
  oavreglerbarhet_nn_1_N = mkN "oavreglerbarhet" ;
  oavromantiserbarhet_nn_1_N = mkN "oavromantiserbarhet" ;
  oavsiktlighet_nn_1_N = mkN "oavsiktlighet" ;
  oavsocialiserbarhet_nn_1_N = mkN "oavsocialiserbarhet" ;
  oavstaliniserbarhet_nn_1_N = mkN "oavstaliniserbarhet" ;
  oavsaettlighet_nn_1_1_N = mkN "oavsättlighet" ;
  oavvisbarhet_nn_1_N = mkN "oavvisbarhet" ;
  oavvislighet_nn_1_N = mkN "oavvislighet" ;
  oavytterlighet_nn_1_N = mkN "oavytterlighet" ;
  oaxiomatiserbarhet_nn_1_N = mkN "oaxiomatiserbarhet" ;
  obagatelliserbarhet_nn_1_N = mkN "obagatelliserbarhet" ;
  obalans_nn_1_N = mkN "obalans" ;
  obalanserbarhet_nn_1_N = mkN "obalanserbarhet" ;
  oballoterbarhet_nn_1_N = mkN "oballoterbarhet" ;
  obalsamerbarhet_nn_1_N = mkN "obalsamerbarhet" ;
  obanaliserbarhet_nn_1_N = mkN "obanaliserbarhet" ;
  obankrutterbarhet_nn_1_N = mkN "obankrutterbarhet" ;
  obarmhaertighet_nn_1_1_N = mkN "obarmhärtighet" ;
  obarrikaderbarhet_nn_1_N = mkN "obarrikaderbarhet" ;
  obaserbarhet_nn_1_N = mkN "obaserbarhet" ;
  obducerbarhet_nn_1_N = mkN "obducerbarhet" ;
  obeatifierbarhet_nn_1_N = mkN "obeatifierbarhet" ;
  obeboelighet_nn_1_N = mkN "obeboelighet" ;
  obefintlighet_nn_1_N = mkN "obefintlighet" ;
  obehoerighet_nn_1_1_N = mkN "obehörighet" ;
  obenaegenhet_nn_1_1_N = mkN "obenägenhet" ;
  obereddhet_nn_1_N = mkN "obereddhet" ;
  oberaeknelighet_nn_1_1_N = mkN "oberäknelighet" ;
  oberoemdhet_nn_1_1_N = mkN "oberömdhet" ;
  oberoerbarhet_nn_1_1_N = mkN "oberörbarhet" ;
  obesatthet_nn_1_N = mkN "obesatthet" ;
  obeskrivbarhet_nn_1_N = mkN "obeskrivbarhet" ;
  obeskrivlighet_nn_1_N = mkN "obeskrivlighet" ;
  obesticklighet_nn_1_N = mkN "obesticklighet" ;
  obestridlighet_nn_1_N = mkN "obestridlighet" ;
  obestaellbarhet_nn_1_1_N = mkN "obeställbarhet" ;
  obetalbarhet_nn_1_N = mkN "obetalbarhet" ;
  obetongerbarhet_nn_1_N = mkN "obetongerbarhet" ;
  obetvinglighet_nn_1_N = mkN "obetvinglighet" ;
  obetaenksamhet_nn_1_1_N = mkN "obetänksamhet" ;
  obetaenkthet_nn_1_1_N = mkN "obetänkthet" ;
  obeveklighet_nn_1_N = mkN "obeveklighet" ;
  obildbarhet_nn_1_N = mkN "obildbarhet" ;
  obiograferbarhet_nn_1_N = mkN "obiograferbarhet" ;
  obisserbarhet_nn_1_N = mkN "obisserbarhet" ;
  obivackerbarhet_nn_1_N = mkN "obivackerbarhet" ;
  objektfoerlust_nn_1_1_N = mkN "objektförlust" ;
  objektiverbarhet_nn_1_N = mkN "objektiverbarhet" ;
  oblancherbarhet_nn_1_N = mkN "oblancherbarhet" ;
  oblankpolerbarhet_nn_1_N = mkN "oblankpolerbarhet" ;
  oblesserbarhet_nn_1_N = mkN "oblesserbarhet" ;
  oblidhet_nn_1_N = mkN "oblidhet" ;
  oblidkelighet_nn_1_N = mkN "oblidkelighet" ;
  obligerbarhet_nn_1_N = mkN "obligerbarhet" ;
  oblikhet_nn_1_N = mkN "oblikhet" ;
  oblinderbarhet_nn_1_N = mkN "oblinderbarhet" ;
  oblockerbarhet_nn_1_N = mkN "oblockerbarhet" ;
  oblodighet_nn_1_N = mkN "oblodighet" ;
  oblommograferbarhet_nn_1_N = mkN "oblommograferbarhet" ;
  oblonderbarhet_nn_1_N = mkN "oblonderbarhet" ;
  oblyghet_nn_1_N = mkN "oblyghet" ;
  oboaserbarhet_nn_1_N = mkN "oboaserbarhet" ;
  obogserbarhet_nn_1_N = mkN "obogserbarhet" ;
  obokstaverbarhet_nn_1_N = mkN "obokstaverbarhet" ;
  obombarderbarhet_nn_1_N = mkN "obombarderbarhet" ;
  oboniterbarhet_nn_1_N = mkN "oboniterbarhet" ;
  obortresonerbarhet_nn_1_N = mkN "obortresonerbarhet" ;
  obotfaerdighet_nn_1_1_N = mkN "obotfärdighet" ;
  obotlighet_nn_1_N = mkN "obotlighet" ;
  obriketterbarhet_nn_1_N = mkN "obriketterbarhet" ;
  obriserbarhet_nn_1_N = mkN "obriserbarhet" ;
  obroderbarhet_nn_1_N = mkN "obroderbarhet" ;
  obromerbarhet_nn_1_N = mkN "obromerbarhet" ;
  obronserbarhet_nn_1_N = mkN "obronserbarhet" ;
  obroscherbarhet_nn_1_N = mkN "obroscherbarhet" ;
  obrottslighet_nn_1_N = mkN "obrottslighet" ;
  obrukbarhet_nn_1_N = mkN "obrukbarhet" ;
  obruklighet_nn_1_N = mkN "obruklighet" ;
  obrunerbarhet_nn_1_N = mkN "obrunerbarhet" ;
  obrutaliserbarhet_nn_1_N = mkN "obrutaliserbarhet" ;
  obrytbarhet_nn_1_N = mkN "obrytbarhet" ;
  obraeserbarhet_nn_1_1_N = mkN "obräserbarhet" ;
  observans_nn_1_N = mkN "observans" ;
  observerbarhet_nn_1_N = mkN "observerbarhet" ;
  obskurhet_nn_1_N = mkN "obskurhet" ;
  obskyrhet_nn_1_N = mkN "obskyrhet" ;
  obsolethet_nn_1_N = mkN "obsolethet" ;
  obstetrik_nn_1_N = mkN "obstetrik" ;
  obstruktionspolitik_nn_1_N = mkN "obstruktionspolitik" ;
  obudgeterbarhet_nn_1_N = mkN "obudgeterbarhet" ;
  obundenhet_nn_1_N = mkN "obundenhet" ;
  obuteljerbarhet_nn_1_N = mkN "obuteljerbarhet" ;
  obyraakratiserbarhet_nn_1_1_N = mkN "obyråkratiserbarhet" ;
  obaendighet_nn_1_1_N = mkN "obändighet" ;
  oboejlighet_nn_1_1_N = mkN "oböjlighet" ;
  ocamouflerbarhet_nn_1_N = mkN "ocamouflerbarhet" ;
  occident_nn_1_N = mkN "occident" ;
  occidentaliserbarhet_nn_1_N = mkN "occidentaliserbarhet" ;
  ocederbarhet_nn_1_N = mkN "ocederbarhet" ;
  ocelebrerbarhet_nn_1_N = mkN "ocelebrerbarhet" ;
  ocementerbarhet_nn_1_N = mkN "ocementerbarhet" ;
  ocensurerbarhet_nn_1_N = mkN "ocensurerbarhet" ;
  ocentraliserbarhet_nn_1_N = mkN "ocentraliserbarhet" ;
  ocentrerbarhet_nn_1_N = mkN "ocentrerbarhet" ;
  ocentrifugerbarhet_nn_1_N = mkN "ocentrifugerbarhet" ;
  ocernerbarhet_nn_1_N = mkN "ocernerbarhet" ;
  ochargerbarhet_nn_1_N = mkN "ochargerbarhet" ;
  ocharmerbarhet_nn_1_N = mkN "ocharmerbarhet" ;
  ochevroterbarhet_nn_1_N = mkN "ochevroterbarhet" ;
  ochiffrerbarhet_nn_1_N = mkN "ochiffrerbarhet" ;
  ochikanerbarhet_nn_1_N = mkN "ochikanerbarhet" ;
  ochockerbarhet_nn_1_N = mkN "ochockerbarhet" ;
  ocirkulerbarhet_nn_1_N = mkN "ocirkulerbarhet" ;
  ociselerbarhet_nn_1_N = mkN "ociselerbarhet" ;
  ociterbarhet_nn_1_N = mkN "ociterbarhet" ;
  ociviliserbarhet_nn_1_N = mkN "ociviliserbarhet" ;
  ockulthet_nn_1_N = mkN "ockulthet" ;
  ockupationspolitik_nn_1_N = mkN "ockupationspolitik" ;
  ockuperbarhet_nn_1_N = mkN "ockuperbarhet" ;
  ocuraterbarhet_nn_1_N = mkN "ocuraterbarhet" ;
  ocurerbarhet_nn_1_N = mkN "ocurerbarhet" ;
  odaterbarhet_nn_1_N = mkN "odaterbarhet" ;
  odatoriserbarhet_nn_1_N = mkN "odatoriserbarhet" ;
  odebarkerbarhet_nn_1_N = mkN "odebarkerbarhet" ;
  odebatterbarhet_nn_1_N = mkN "odebatterbarhet" ;
  odebiterbarhet_nn_1_N = mkN "odebiterbarhet" ;
  odecentraliserbarhet_nn_1_N = mkN "odecentraliserbarhet" ;
  odechiffrerbarhet_nn_1_N = mkN "odechiffrerbarhet" ;
  odecimerbarhet_nn_1_N = mkN "odecimerbarhet" ;
  odedicerbarhet_nn_1_N = mkN "odedicerbarhet" ;
  odedikerbarhet_nn_1_N = mkN "odedikerbarhet" ;
  odeducerbarhet_nn_1_N = mkN "odeducerbarhet" ;
  odefilerbarhet_nn_1_N = mkN "odefilerbarhet" ;
  odefinierbarhet_nn_1_N = mkN "odefinierbarhet" ;
  odeflorerbarhet_nn_1_N = mkN "odeflorerbarhet" ;
  odeformerbarhet_nn_1_N = mkN "odeformerbarhet" ;
  odegenererbarhet_nn_1_N = mkN "odegenererbarhet" ;
  odegraderbarhet_nn_1_N = mkN "odegraderbarhet" ;
  odekanterbarhet_nn_1_N = mkN "odekanterbarhet" ;
  odekapiterbarhet_nn_1_N = mkN "odekapiterbarhet" ;
  odeklamerbarhet_nn_1_N = mkN "odeklamerbarhet" ;
  odeklarerbarhet_nn_1_N = mkN "odeklarerbarhet" ;
  odeklasserbarhet_nn_1_N = mkN "odeklasserbarhet" ;
  odeklinerbarhet_nn_1_N = mkN "odeklinerbarhet" ;
  odekorerbarhet_nn_1_N = mkN "odekorerbarhet" ;
  odekouragerbarhet_nn_1_N = mkN "odekouragerbarhet" ;
  odekreterbarhet_nn_1_N = mkN "odekreterbarhet" ;
  odelbarhet_nn_1_N = mkN "odelbarhet" ;
  odelegerbarhet_nn_1_N = mkN "odelegerbarhet" ;
  odemaskerbarhet_nn_1_N = mkN "odemaskerbarhet" ;
  odementerbarhet_nn_1_N = mkN "odementerbarhet" ;
  odemilitariserbarhet_nn_1_N = mkN "odemilitariserbarhet" ;
  odemobiliserbarhet_nn_1_N = mkN "odemobiliserbarhet" ;
  odemokratiserbarhet_nn_1_N = mkN "odemokratiserbarhet" ;
  odemolerbarhet_nn_1_N = mkN "odemolerbarhet" ;
  odemoniserbarhet_nn_1_N = mkN "odemoniserbarhet" ;
  odemonstrerbarhet_nn_1_N = mkN "odemonstrerbarhet" ;
  odemonterbarhet_nn_1_N = mkN "odemonterbarhet" ;
  odemoraliserbarhet_nn_1_N = mkN "odemoraliserbarhet" ;
  odenaturaliserbarhet_nn_1_N = mkN "odenaturaliserbarhet" ;
  odenaturerbarhet_nn_1_N = mkN "odenaturerbarhet" ;
  odenoterbarhet_nn_1_N = mkN "odenoterbarhet" ;
  odenuderbarhet_nn_1_N = mkN "odenuderbarhet" ;
  odeodoriserbarhet_nn_1_N = mkN "odeodoriserbarhet" ;
  odepatrierbarhet_nn_1_N = mkN "odepatrierbarhet" ;
  odepenserbarhet_nn_1_N = mkN "odepenserbarhet" ;
  odeplacerbarhet_nn_1_N = mkN "odeplacerbarhet" ;
  odeponerbarhet_nn_1_N = mkN "odeponerbarhet" ;
  odeporterbarhet_nn_1_N = mkN "odeporterbarhet" ;
  odeprecierbarhet_nn_1_N = mkN "odeprecierbarhet" ;
  oderangerbarhet_nn_1_N = mkN "oderangerbarhet" ;
  oderiverbarhet_nn_1_N = mkN "oderiverbarhet" ;
  odesarmerbarhet_nn_1_N = mkN "odesarmerbarhet" ;
  odesavouerbarhet_nn_1_N = mkN "odesavouerbarhet" ;
  odesensibiliserbarhet_nn_1_N = mkN "odesensibiliserbarhet" ;
  odesignerbarhet_nn_1_N = mkN "odesignerbarhet" ;
  odesinfekterbarhet_nn_1_N = mkN "odesinfekterbarhet" ;
  odesinficerbarhet_nn_1_N = mkN "odesinficerbarhet" ;
  odesinformerbarhet_nn_1_N = mkN "odesinformerbarhet" ;
  odesorganiserbarhet_nn_1_N = mkN "odesorganiserbarhet" ;
  odestabiliserbarhet_nn_1_N = mkN "odestabiliserbarhet" ;
  odestillerbarhet_nn_1_N = mkN "odestillerbarhet" ;
  odestinerbarhet_nn_1_N = mkN "odestinerbarhet" ;
  odestruerbarhet_nn_1_N = mkN "odestruerbarhet" ;
  odetacherbarhet_nn_1_N = mkN "odetacherbarhet" ;
  odetekterbarhet_nn_1_N = mkN "odetekterbarhet" ;
  odeterminerbarhet_nn_1_N = mkN "odeterminerbarhet" ;
  odetonerbarhet_nn_1_N = mkN "odetonerbarhet" ;
  odetroniserbarhet_nn_1_N = mkN "odetroniserbarhet" ;
  odevalverbarhet_nn_1_N = mkN "odevalverbarhet" ;
  odiagnosticerbarhet_nn_1_N = mkN "odiagnosticerbarhet" ;
  odiagnostiserbarhet_nn_1_N = mkN "odiagnostiserbarhet" ;
  odialyserbarhet_nn_1_N = mkN "odialyserbarhet" ;
  odifferentierbarhet_nn_1_N = mkN "odifferentierbarhet" ;
  odiffunderbarhet_nn_1_N = mkN "odiffunderbarhet" ;
  odiftongerbarhet_nn_1_N = mkN "odiftongerbarhet" ;
  odigererbarhet_nn_1_N = mkN "odigererbarhet" ;
  odikterbarhet_nn_1_N = mkN "odikterbarhet" ;
  odimensionerbarhet_nn_1_N = mkN "odimensionerbarhet" ;
  odiplomerbarhet_nn_1_N = mkN "odiplomerbarhet" ;
  odirigerbarhet_nn_1_N = mkN "odirigerbarhet" ;
  odisambiguerbarhet_nn_1_N = mkN "odisambiguerbarhet" ;
  odisciplinerbarhet_nn_1_N = mkN "odisciplinerbarhet" ;
  odisharmonierbarhet_nn_1_N = mkN "odisharmonierbarhet" ;
  odiskonterbarhet_nn_1_N = mkN "odiskonterbarhet" ;
  odiskrediterbarhet_nn_1_N = mkN "odiskrediterbarhet" ;
  odiskriminerbarhet_nn_1_N = mkN "odiskriminerbarhet" ;
  odiskuterbarhet_nn_1_N = mkN "odiskuterbarhet" ;
  odiskvalificerbarhet_nn_1_N = mkN "odiskvalificerbarhet" ;
  odispascherbarhet_nn_1_N = mkN "odispascherbarhet" ;
  odispenserbarhet_nn_1_N = mkN "odispenserbarhet" ;
  odispergerbarhet_nn_1_N = mkN "odispergerbarhet" ;
  odisponerbarhet_nn_1_N = mkN "odisponerbarhet" ;
  odisputerbarhet_nn_1_N = mkN "odisputerbarhet" ;
  odissekerbarhet_nn_1_N = mkN "odissekerbarhet" ;
  odissimilerbarhet_nn_1_N = mkN "odissimilerbarhet" ;
  odissocierbarhet_nn_1_N = mkN "odissocierbarhet" ;
  odistanserbarhet_nn_1_N = mkN "odistanserbarhet" ;
  odistraherbarhet_nn_1_N = mkN "odistraherbarhet" ;
  odistribuerbarhet_nn_1_N = mkN "odistribuerbarhet" ;
  odivergerbarhet_nn_1_N = mkN "odivergerbarhet" ;
  odiversifierbarhet_nn_1_N = mkN "odiversifierbarhet" ;
  odividerbarhet_nn_1_N = mkN "odividerbarhet" ;
  odlingsbarhet_nn_1_N = mkN "odlingsbarhet" ;
  odocerbarhet_nn_1_N = mkN "odocerbarhet" ;
  odogmatiserbarhet_nn_1_N = mkN "odogmatiserbarhet" ;
  odokumenterbarhet_nn_1_N = mkN "odokumenterbarhet" ;
  odomesticerbarhet_nn_1_N = mkN "odomesticerbarhet" ;
  odomicilierbarhet_nn_1_N = mkN "odomicilierbarhet" ;
  odominerbarhet_nn_1_N = mkN "odominerbarhet" ;
  odompterbarhet_nn_1_N = mkN "odompterbarhet" ;
  odonerbarhet_nn_1_N = mkN "odonerbarhet" ;
  odoserbarhet_nn_1_N = mkN "odoserbarhet" ;
  odosserbarhet_nn_1_N = mkN "odosserbarhet" ;
  odoterbarhet_nn_1_N = mkN "odoterbarhet" ;
  odragerbarhet_nn_1_N = mkN "odragerbarhet" ;
  odramatiserbarhet_nn_1_N = mkN "odramatiserbarhet" ;
  odraperbarhet_nn_1_N = mkN "odraperbarhet" ;
  odresserbarhet_nn_1_N = mkN "odresserbarhet" ;
  odryghet_nn_1_N = mkN "odryghet" ;
  odraeglighet_nn_1_1_N = mkN "odräglighet" ;
  odraenerbarhet_nn_1_1_N = mkN "odränerbarhet" ;
  odubblerbarhet_nn_1_N = mkN "odubblerbarhet" ;
  oduglighet_nn_1_N = mkN "oduglighet" ;
  oduperbarhet_nn_1_N = mkN "oduperbarhet" ;
  oduplicerbarhet_nn_1_N = mkN "oduplicerbarhet" ;
  odygd_nn_1_N = mkN "odygd" ;
  odygdighet_nn_1_N = mkN "odygdighet" ;
  odoedlighet_nn_1_1_N = mkN "odödlighet" ;
  odoert_nn_1_1_N = mkN "odört" ;
  oederbarhet_nn_1_N = mkN "oederbarhet" ;
  oeffacerbarhet_nn_1_N = mkN "oeffacerbarhet" ;
  oeffektiverbarhet_nn_1_N = mkN "oeffektiverbarhet" ;
  oeffektiviserbarhet_nn_1_N = mkN "oeffektiviserbarhet" ;
  oeffektuerbarhet_nn_1_N = mkN "oeffektuerbarhet" ;
  oefterdaterbarhet_nn_1_N = mkN "oefterdaterbarhet" ;
  oefterdebiterbarhet_nn_1_N = mkN "oefterdebiterbarhet" ;
  oeftergivlighet_nn_1_N = mkN "oeftergivlighet" ;
  oefterhaermlighet_nn_1_1_N = mkN "oefterhärmlighet" ;
  oefterrationaliserbarhet_nn_1_N = mkN "oefterrationaliserbarhet" ;
  oefterraettlighet_nn_1_1_N = mkN "oefterrättlighet" ;
  oeftersynkroniserbarhet_nn_1_N = mkN "oeftersynkroniserbarhet" ;
  oeftertaxerbarhet_nn_1_N = mkN "oeftertaxerbarhet" ;
  oegaliserbarhet_nn_1_N = mkN "oegaliserbarhet" ;
  oegennyttighet_nn_1_N = mkN "oegennyttighet" ;
  oegentlighet_nn_2_N = mkN "oegentlighet" ;
  oekiperbarhet_nn_1_N = mkN "oekiperbarhet" ;
  oeklaterbarhet_nn_1_N = mkN "oeklaterbarhet" ;
  oeklaererbarhet_nn_1_1_N = mkN "oeklärerbarhet" ;
  oekonomiserbarhet_nn_1_N = mkN "oekonomiserbarhet" ;
  oelaborerbarhet_nn_1_N = mkN "oelaborerbarhet" ;
  oelastiserbarhet_nn_1_N = mkN "oelastiserbarhet" ;
  oelektrificerbarhet_nn_1_N = mkN "oelektrificerbarhet" ;
  oelektrifierbarhet_nn_1_N = mkN "oelektrifierbarhet" ;
  oelektriserbarhet_nn_1_N = mkN "oelektriserbarhet" ;
  oeliderbarhet_nn_1_N = mkN "oeliderbarhet" ;
  oeliminerbarhet_nn_1_N = mkN "oeliminerbarhet" ;
  oeloxerbarhet_nn_1_N = mkN "oeloxerbarhet" ;
  oeluderbarhet_nn_1_N = mkN "oeluderbarhet" ;
  oeluerbarhet_nn_1_N = mkN "oeluerbarhet" ;
  oemaljerbarhet_nn_1_N = mkN "oemaljerbarhet" ;
  oemanciperbarhet_nn_1_N = mkN "oemanciperbarhet" ;
  oemballerbarhet_nn_1_N = mkN "oemballerbarhet" ;
  oembarkerbarhet_nn_1_N = mkN "oembarkerbarhet" ;
  oembellerbarhet_nn_1_N = mkN "oembellerbarhet" ;
  oemenderbarhet_nn_1_N = mkN "oemenderbarhet" ;
  oemigrerbarhet_nn_1_N = mkN "oemigrerbarhet" ;
  oemitterbarhet_nn_1_N = mkN "oemitterbarhet" ;
  oemotstaandlighet_nn_1_1_N = mkN "oemotståndlighet" ;
  oemotsaeglighet_nn_1_1_N = mkN "oemotsäglighet" ;
  oemottaglighet_nn_1_N = mkN "oemottaglighet" ;
  oemulgerbarhet_nn_1_N = mkN "oemulgerbarhet" ;
  oendosserbarhet_nn_1_N = mkN "oendosserbarhet" ;
  oenerverbarhet_nn_1_N = mkN "oenerverbarhet" ;
  oengagerbarhet_nn_1_N = mkN "oengagerbarhet" ;
  oenleverbarhet_nn_1_N = mkN "oenleverbarhet" ;
  oenrollerbarhet_nn_1_N = mkN "oenrollerbarhet" ;
  oensilerbarhet_nn_1_N = mkN "oensilerbarhet" ;
  oentusiasmerbarhet_nn_1_N = mkN "oentusiasmerbarhet" ;
  oepilerbarhet_nn_1_N = mkN "oepilerbarhet" ;
  oerfarenhet_nn_1_N = mkN "oerfarenhet" ;
  oerhoerdhet_nn_1_1_N = mkN "oerhördhet" ;
  oerigerbarhet_nn_1_N = mkN "oerigerbarhet" ;
  oeroderbarhet_nn_1_N = mkN "oeroderbarhet" ;
  oersaettlighet_nn_1_1_N = mkN "oersättlighet" ;
  oeskalerbarhet_nn_1_N = mkN "oeskalerbarhet" ;
  oeskorterbarhet_nn_1_N = mkN "oeskorterbarhet" ;
  oesteticerbarhet_nn_1_N = mkN "oesteticerbarhet" ;
  oestetiserbarhet_nn_1_N = mkN "oestetiserbarhet" ;
  oestimerbarhet_nn_1_N = mkN "oestimerbarhet" ;
  oetablerbarhet_nn_1_N = mkN "oetablerbarhet" ;
  oeteriserbarhet_nn_1_N = mkN "oeteriserbarhet" ;
  oetiketterbarhet_nn_1_N = mkN "oetiketterbarhet" ;
  oetymologiserbarhet_nn_1_N = mkN "oetymologiserbarhet" ;
  oeuropeiserbarhet_nn_1_N = mkN "oeuropeiserbarhet" ;
  oevakuerbarhet_nn_1_N = mkN "oevakuerbarhet" ;
  oevaluerbarhet_nn_1_N = mkN "oevaluerbarhet" ;
  oevalverbarhet_nn_1_N = mkN "oevalverbarhet" ;
  oevaporerbarhet_nn_1_N = mkN "oevaporerbarhet" ;
  oexaminerbarhet_nn_1_N = mkN "oexaminerbarhet" ;
  oexcerperbarhet_nn_1_N = mkN "oexcerperbarhet" ;
  oexciterbarhet_nn_1_N = mkN "oexciterbarhet" ;
  oexekverbarhet_nn_1_N = mkN "oexekverbarhet" ;
  oexemplifierbarhet_nn_1_N = mkN "oexemplifierbarhet" ;
  oexercerbarhet_nn_1_N = mkN "oexercerbarhet" ;
  oexkluderbarhet_nn_1_N = mkN "oexkluderbarhet" ;
  oexkommunicerbarhet_nn_1_N = mkN "oexkommunicerbarhet" ;
  oexpanderbarhet_nn_1_N = mkN "oexpanderbarhet" ;
  oexpatrierbarhet_nn_1_N = mkN "oexpatrierbarhet" ;
  oexpedierbarhet_nn_1_N = mkN "oexpedierbarhet" ;
  oexpektorerbarhet_nn_1_N = mkN "oexpektorerbarhet" ;
  oexplicerbarhet_nn_1_N = mkN "oexplicerbarhet" ;
  oexploaterbarhet_nn_1_N = mkN "oexploaterbarhet" ;
  oexploderbarhet_nn_1_N = mkN "oexploderbarhet" ;
  oexponerbarhet_nn_1_N = mkN "oexponerbarhet" ;
  oexporterbarhet_nn_1_N = mkN "oexporterbarhet" ;
  oexproprierbarhet_nn_1_N = mkN "oexproprierbarhet" ;
  oexstirperbarhet_nn_1_N = mkN "oexstirperbarhet" ;
  oextemporerbarhet_nn_1_N = mkN "oextemporerbarhet" ;
  oextraherbarhet_nn_1_N = mkN "oextraherbarhet" ;
  oextrapolerbarhet_nn_1_N = mkN "oextrapolerbarhet" ;
  ofabricerbarhet_nn_1_N = mkN "ofabricerbarhet" ;
  ofabulerbarhet_nn_1_N = mkN "ofabulerbarhet" ;
  ofacetterbarhet_nn_1_N = mkN "ofacetterbarhet" ;
  ofakturerbarhet_nn_1_N = mkN "ofakturerbarhet" ;
  ofalsifierbarhet_nn_1_N = mkN "ofalsifierbarhet" ;
  ofantiserbarhet_nn_1_N = mkN "ofantiserbarhet" ;
  ofantlighet_nn_1_N = mkN "ofantlighet" ;
  ofascinerbarhet_nn_1_N = mkN "ofascinerbarhet" ;
  ofasetterbarhet_nn_1_N = mkN "ofasetterbarhet" ;
  ofasonerbarhet_nn_1_N = mkN "ofasonerbarhet" ;
  ofattbarhet_nn_1_N = mkN "ofattbarhet" ;
  ofattlighet_nn_1_N = mkN "ofattlighet" ;
  ofavoriserbarhet_nn_1_N = mkN "ofavoriserbarhet" ;
  ofelbarhet_nn_1_N = mkN "ofelbarhet" ;
  ofermenterbarhet_nn_1_N = mkN "ofermenterbarhet" ;
  ofeterbarhet_nn_1_N = mkN "ofeterbarhet" ;
  offentlighetsprincip_nn_1_N = mkN "offentlighetsprincip" ;
  offentligraettslighet_nn_1_1_N = mkN "offentligrättslighet" ;
  offererbarhet_nn_1_N = mkN "offererbarhet" ;
  offergaerd_nn_1_1_N = mkN "offergärd" ;
  offset_nn_1_N = mkN "offset" ;
  ofilerbarhet_nn_1_N = mkN "ofilerbarhet" ;
  ofilmatiserbarhet_nn_1_N = mkN "ofilmatiserbarhet" ;
  ofiltrerbarhet_nn_1_N = mkN "ofiltrerbarhet" ;
  ofinansierbarhet_nn_1_N = mkN "ofinansierbarhet" ;
  ofingerbarhet_nn_1_N = mkN "ofingerbarhet" ;
  ofinjusterbarhet_nn_1_N = mkN "ofinjusterbarhet" ;
  ofinlandiserbarhet_nn_1_N = mkN "ofinlandiserbarhet" ;
  ofixerbarhet_nn_1_N = mkN "ofixerbarhet" ;
  oflamberbarhet_nn_1_N = mkN "oflamberbarhet" ;
  oflankerbarhet_nn_1_N = mkN "oflankerbarhet" ;
  oflatterbarhet_nn_1_N = mkN "oflatterbarhet" ;
  oflekterbarhet_nn_1_N = mkN "oflekterbarhet" ;
  ofluidiserbarhet_nn_1_N = mkN "ofluidiserbarhet" ;
  ofluorerbarhet_nn_1_N = mkN "ofluorerbarhet" ;
  ofluoriderbarhet_nn_1_N = mkN "ofluoriderbarhet" ;
  ofokuserbarhet_nn_1_N = mkN "ofokuserbarhet" ;
  ofolierbarhet_nn_1_N = mkN "ofolierbarhet" ;
  ofonderbarhet_nn_1_N = mkN "ofonderbarhet" ;
  oforcerbarhet_nn_1_N = mkN "oforcerbarhet" ;
  oformaliserbarhet_nn_1_N = mkN "oformaliserbarhet" ;
  oformerbarhet_nn_1_N = mkN "oformerbarhet" ;
  oformulerbarhet_nn_1_N = mkN "oformulerbarhet" ;
  ofosfaterbarhet_nn_1_N = mkN "ofosfaterbarhet" ;
  ofossiliserbarhet_nn_1_N = mkN "ofossiliserbarhet" ;
  ofotograferbarhet_nn_1_N = mkN "ofotograferbarhet" ;
  ofragmenterbarhet_nn_1_N = mkN "ofragmenterbarhet" ;
  ofraktionerbarhet_nn_1_N = mkN "ofraktionerbarhet" ;
  oframkomlighet_nn_1_N = mkN "oframkomlighet" ;
  ofrankerbarhet_nn_1_N = mkN "ofrankerbarhet" ;
  ofraserbarhet_nn_1_N = mkN "ofraserbarhet" ;
  ofred_nn_1_N = mkN "ofred" ;
  ofrekventerbarhet_nn_1_N = mkN "ofrekventerbarhet" ;
  ofrid_nn_1_N = mkN "ofrid" ;
  ofriserbarhet_nn_1_N = mkN "ofriserbarhet" ;
  ofriterbarhet_nn_1_N = mkN "ofriterbarhet" ;
  ofrivillighet_nn_1_N = mkN "ofrivillighet" ;
  ofronderbarhet_nn_1_N = mkN "ofronderbarhet" ;
  ofrotterbarhet_nn_1_N = mkN "ofrotterbarhet" ;
  ofruktbarhet_nn_1_N = mkN "ofruktbarhet" ;
  ofruktsamhet_nn_1_N = mkN "ofruktsamhet" ;
  ofrustrerbarhet_nn_1_N = mkN "ofrustrerbarhet" ;
  ofraankomlighet_nn_1_1_N = mkN "ofrånkomlighet" ;
  oftalmiatrik_nn_1_N = mkN "oftalmiatrik" ;
  ofullgaangenhet_nn_1_1_N = mkN "ofullgångenhet" ;
  ofurnerbarhet_nn_1_N = mkN "ofurnerbarhet" ;
  ofusionerbarhet_nn_1_N = mkN "ofusionerbarhet" ;
  ofysiljerbarhet_nn_1_N = mkN "ofysiljerbarhet" ;
  ofaerd_nn_1_1_N = mkN "ofärd" ;
  ofaerdighet_nn_1_1_N = mkN "ofärdighet" ;
  ofaerserbarhet_nn_1_1_N = mkN "ofärserbarhet" ;
  ofoerannonserbarhet_nn_1_1_N = mkN "oförannonserbarhet" ;
  ofoerbehaallsamhet_nn_1_1_N = mkN "oförbehållsamhet" ;
  ofoerbereddhet_nn_1_1_N = mkN "oförbereddhet" ;
  ofoerbraennelighet_nn_1_1_N = mkN "oförbrännelighet" ;
  ofoerbaetterlighet_nn_1_1_N = mkN "oförbätterlighet" ;
  ofoerdelaktighet_nn_1_1_N = mkN "ofördelaktighet" ;
  ofoerdragsamhet_nn_1_1_N = mkN "ofördragsamhet" ;
  ofoeretagsamhet_nn_1_1_N = mkN "oföretagsamhet" ;
  ofoergriplighet_nn_1_1_N = mkN "oförgriplighet" ;
  ofoergaetlighet_nn_1_1_N = mkN "oförgätlighet" ;
  ofoerhet_nn_1_1_N = mkN "oförhet" ;
  ofoerliknelighet_nn_1_1_N = mkN "oförliknelighet" ;
  ofoerlaatlighet_nn_1_1_N = mkN "oförlåtlighet" ;
  ofoermaerkthet_nn_1_1_N = mkN "oförmärkthet" ;
  ofoermoegenhet_nn_1_1_N = mkN "oförmögenhet" ;
  ofoerneklighet_nn_1_1_N = mkN "oförneklighet" ;
  ofoernoejdhet_nn_1_1_N = mkN "oförnöjdhet" ;
  ofoerryckthet_nn_1_1_N = mkN "oförryckthet" ;
  ofoersiktighet_nn_1_1_N = mkN "oförsiktighet" ;
  ofoerskotterbarhet_nn_1_1_N = mkN "oförskotterbarhet" ;
  ofoerskraeckthet_nn_1_1_N = mkN "oförskräckthet" ;
  ofoerskylldhet_nn_1_1_N = mkN "oförskylldhet" ;
  ofoersonlighet_nn_1_1_N = mkN "oförsonlighet" ;
  ofoerstaelldhet_nn_1_1_N = mkN "oförställdhet" ;
  ofoerstaemdhet_nn_1_1_N = mkN "oförstämdhet" ;
  ofoerstaandighet_nn_1_1_N = mkN "oförståndighet" ;
  ofoerstoerbarhet_nn_1_1_N = mkN "oförstörbarhet" ;
  ofoerstoerdhet_nn_1_1_N = mkN "oförstördhet" ;
  ofoersvarlighet_nn_1_1_N = mkN "oförsvarlighet" ;
  ofoersynthet_nn_1_1_N = mkN "oförsynthet" ;
  ofoertjusthet_nn_1_1_N = mkN "oförtjusthet" ;
  ofoertjaenthet_nn_1_1_N = mkN "oförtjänthet" ;
  ofoertrutenhet_nn_1_1_N = mkN "oförtrutenhet" ;
  ofoertroettlighet_nn_1_1_N = mkN "oförtröttlighet" ;
  ofoertydbarhet_nn_1_1_N = mkN "oförtydbarhet" ;
  ofoertaeckthet_nn_1_1_N = mkN "oförtäckthet" ;
  ofoerutbestaemdhet_nn_1_1_N = mkN "oförutbestämdhet" ;
  ofoerutsebarhet_nn_1_1_N = mkN "oförutsebarhet" ;
  ofoerutseddhet_nn_1_1_N = mkN "oförutseddhet" ;
  ofoerutspaaddhet_nn_1_1_N = mkN "oförutspåddhet" ;
  ofoerutsaegbarhet_nn_1_1_N = mkN "oförutsägbarhet" ;
  ofoervitlighet_nn_1_1_N = mkN "oförvitlighet" ;
  ofoerytterlighet_nn_1_1_N = mkN "oförytterlighet" ;
  ogalliserbarhet_nn_1_N = mkN "ogalliserbarhet" ;
  ogaloscherbarhet_nn_1_N = mkN "ogaloscherbarhet" ;
  ogalvaniserbarhet_nn_1_N = mkN "ogalvaniserbarhet" ;
  ogaragerbarhet_nn_1_N = mkN "ogaragerbarhet" ;
  ogaranterbarhet_nn_1_N = mkN "ogaranterbarhet" ;
  ogarderbarhet_nn_1_N = mkN "ogarderbarhet" ;
  ogarnerbarhet_nn_1_N = mkN "ogarnerbarhet" ;
  ogarnisonerbarhet_nn_1_N = mkN "ogarnisonerbarhet" ;
  ogarrotterbarhet_nn_1_N = mkN "ogarrotterbarhet" ;
  ogastroskoperbarhet_nn_1_N = mkN "ogastroskoperbarhet" ;
  ogauffrerbarhet_nn_1_N = mkN "ogauffrerbarhet" ;
  ogelatinerbarhet_nn_1_N = mkN "ogelatinerbarhet" ;
  ogeminerbarhet_nn_1_N = mkN "ogeminerbarhet" ;
  ogeneraliserbarhet_nn_1_N = mkN "ogeneraliserbarhet" ;
  ogenerbarhet_nn_1_N = mkN "ogenerbarhet" ;
  ogenererbarhet_nn_1_N = mkN "ogenererbarhet" ;
  ogenomfoerbarhet_nn_1_1_N = mkN "ogenomförbarhet" ;
  ogenomskinlighet_nn_1_N = mkN "ogenomskinlighet" ;
  ogenomslaepplighet_nn_1_1_N = mkN "ogenomsläpplighet" ;
  ogenomtraenglighet_nn_1_1_N = mkN "ogenomtränglighet" ;
  ogenomtaenkthet_nn_1_1_N = mkN "ogenomtänkthet" ;
  ogensaeglighet_nn_1_1_N = mkN "ogensäglighet" ;
  ogeometriserbarhet_nn_1_N = mkN "ogeometriserbarhet" ;
  ogermaniserbarhet_nn_1_N = mkN "ogermaniserbarhet" ;
  ogiftighet_nn_1_N = mkN "ogiftighet" ;
  ogiljotinerbarhet_nn_1_N = mkN "ogiljotinerbarhet" ;
  ogillhet_nn_1_N = mkN "ogillhet" ;
  ogiltighet_nn_1_N = mkN "ogiltighet" ;
  ogirerbarhet_nn_1_N = mkN "ogirerbarhet" ;
  oglamoriserbarhet_nn_1_N = mkN "oglamoriserbarhet" ;
  oglamouriserbarhet_nn_1_N = mkN "oglamouriserbarhet" ;
  oglaserbarhet_nn_1_N = mkN "oglaserbarhet" ;
  oglorifierbarhet_nn_1_N = mkN "oglorifierbarhet" ;
  ogoffrerbarhet_nn_1_N = mkN "ogoffrerbarhet" ;
  ogouterbarhet_nn_1_N = mkN "ogouterbarhet" ;
  ograderbarhet_nn_1_N = mkN "ograderbarhet" ;
  ograduerbarhet_nn_1_N = mkN "ograduerbarhet" ;
  ografiterbarhet_nn_1_N = mkN "ografiterbarhet" ;
  ogranulerbarhet_nn_1_N = mkN "ogranulerbarhet" ;
  ogratinerbarhet_nn_1_N = mkN "ogratinerbarhet" ;
  ogratulerbarhet_nn_1_N = mkN "ogratulerbarhet" ;
  ograverbarhet_nn_1_N = mkN "ograverbarhet" ;
  ogriljerbarhet_nn_1_N = mkN "ogriljerbarhet" ;
  ogrimerbarhet_nn_1_N = mkN "ogrimerbarhet" ;
  ogripbarhet_nn_1_N = mkN "ogripbarhet" ;
  ogrunderbarhet_nn_1_N = mkN "ogrunderbarhet" ;
  ogrupperbarhet_nn_1_N = mkN "ogrupperbarhet" ;
  ogudaktighet_nn_1_N = mkN "ogudaktighet" ;
  ogudlighet_nn_1_N = mkN "ogudlighet" ;
  ogummerbarhet_nn_1_N = mkN "ogummerbarhet" ;
  ogunstighet_nn_1_N = mkN "ogunstighet" ;
  oguterbarhet_nn_1_N = mkN "oguterbarhet" ;
  ogymnastiserbarhet_nn_1_N = mkN "ogymnastiserbarhet" ;
  ogynnsamhet_nn_1_N = mkN "ogynnsamhet" ;
  ogaestvaenlighet_nn_1_1_N = mkN "ogästvänlighet" ;
  ogoerlighet_nn_1_1_N = mkN "ogörlighet" ;
  ohallucinerbarhet_nn_1_N = mkN "ohallucinerbarhet" ;
  ohalverbarhet_nn_1_N = mkN "ohalverbarhet" ;
  ohanterbarhet_nn_1_N = mkN "ohanterbarhet" ;
  ohanterlighet_nn_1_N = mkN "ohanterlighet" ;
  oharangerbarhet_nn_1_N = mkN "oharangerbarhet" ;
  oharmoniserbarhet_nn_1_N = mkN "oharmoniserbarhet" ;
  oharpunerbarhet_nn_1_N = mkN "oharpunerbarhet" ;
  ohasarderbarhet_nn_1_N = mkN "ohasarderbarhet" ;
  ohavererbarhet_nn_1_N = mkN "ohavererbarhet" ;
  ohektograferbarhet_nn_1_N = mkN "ohektograferbarhet" ;
  ohelighet_nn_1_N = mkN "ohelighet" ;
  oheroiserbarhet_nn_1_N = mkN "oheroiserbarhet" ;
  ohistorierbarhet_nn_1_N = mkN "ohistorierbarhet" ;
  ohistoriserbarhet_nn_1_N = mkN "ohistoriserbarhet" ;
  ohjaelplighet_nn_1_1_N = mkN "ohjälplighet" ;
  oholograferbarhet_nn_1_N = mkN "oholograferbarhet" ;
  ohomogeniserbarhet_nn_1_N = mkN "ohomogeniserbarhet" ;
  ohonorerbarhet_nn_1_N = mkN "ohonorerbarhet" ;
  ohospitaliserbarhet_nn_1_N = mkN "ohospitaliserbarhet" ;
  ohumaniserbarhet_nn_1_N = mkN "ohumaniserbarhet" ;
  ohundsfotterbarhet_nn_1_N = mkN "ohundsfotterbarhet" ;
  ohuserbarhet_nn_1_N = mkN "ohuserbarhet" ;
  ohybridiserbarhet_nn_1_N = mkN "ohybridiserbarhet" ;
  ohydrerbarhet_nn_1_N = mkN "ohydrerbarhet" ;
  ohypnotiserbarhet_nn_1_N = mkN "ohypnotiserbarhet" ;
  ohypotiserbarhet_nn_1_N = mkN "ohypotiserbarhet" ;
  ohysbarhet_nn_1_N = mkN "ohysbarhet" ;
  ohaelsa_nn_1_1_N = mkN "ohälsa" ;
  ohaelsosamhet_nn_1_1_N = mkN "ohälsosamhet" ;
  ohaengdhet_nn_1_1_N = mkN "ohängdhet" ;
  ohaerbaergerbarhet_nn_1_1_N = mkN "ohärbärgerbarhet" ;
  ohoeljdhet_nn_1_1_N = mkN "ohöljdhet" ;
  ohoersamhet_nn_1_1_N = mkN "ohörsamhet" ;
  ohoevlighet_nn_1_1_N = mkN "ohövlighet" ;
  oidealiserbarhet_nn_1_N = mkN "oidealiserbarhet" ;
  oidentifierbarhet_nn_1_N = mkN "oidentifierbarhet" ;
  oigenkaennlighet_nn_1_1_N = mkN "oigenkännlighet" ;
  oignorerbarhet_nn_1_N = mkN "oignorerbarhet" ;
  oilluminerbarhet_nn_1_N = mkN "oilluminerbarhet" ;
  oillustrerbarhet_nn_1_N = mkN "oillustrerbarhet" ;
  oimiterbarhet_nn_1_N = mkN "oimiterbarhet" ;
  oimmatrikulerbarhet_nn_1_N = mkN "oimmatrikulerbarhet" ;
  oimmigrerbarhet_nn_1_N = mkN "oimmigrerbarhet" ;
  oimmuniserbarhet_nn_1_N = mkN "oimmuniserbarhet" ;
  oimplanterbarhet_nn_1_N = mkN "oimplanterbarhet" ;
  oimplicerbarhet_nn_1_N = mkN "oimplicerbarhet" ;
  oimploderbarhet_nn_1_N = mkN "oimploderbarhet" ;
  oimponerbarhet_nn_1_N = mkN "oimponerbarhet" ;
  oimporterbarhet_nn_1_N = mkN "oimporterbarhet" ;
  oimpregnerbarhet_nn_1_N = mkN "oimpregnerbarhet" ;
  oimproviserbarhet_nn_1_N = mkN "oimproviserbarhet" ;
  oinackorderbarhet_nn_1_N = mkN "oinackorderbarhet" ;
  oinaugurerbarhet_nn_1_N = mkN "oinaugurerbarhet" ;
  oindexerbarhet_nn_1_N = mkN "oindexerbarhet" ;
  oindexreglerbarhet_nn_1_N = mkN "oindexreglerbarhet" ;
  oindicerbarhet_nn_1_N = mkN "oindicerbarhet" ;
  oindikerbarhet_nn_1_N = mkN "oindikerbarhet" ;
  oindividualiserbarhet_nn_1_N = mkN "oindividualiserbarhet" ;
  oindoktrinerbarhet_nn_1_N = mkN "oindoktrinerbarhet" ;
  oinducerbarhet_nn_1_N = mkN "oinducerbarhet" ;
  oindustrialiserbarhet_nn_1_N = mkN "oindustrialiserbarhet" ;
  oinfantiliserbarhet_nn_1_N = mkN "oinfantiliserbarhet" ;
  oinfekterbarhet_nn_1_N = mkN "oinfekterbarhet" ;
  oinfiltrerbarhet_nn_1_N = mkN "oinfiltrerbarhet" ;
  oinflammerbarhet_nn_1_N = mkN "oinflammerbarhet" ;
  oinfluerbarhet_nn_1_N = mkN "oinfluerbarhet" ;
  oinformerbarhet_nn_1_N = mkN "oinformerbarhet" ;
  oingraverbarhet_nn_1_N = mkN "oingraverbarhet" ;
  oinhalerbarhet_nn_1_N = mkN "oinhalerbarhet" ;
  oinhiberbarhet_nn_1_N = mkN "oinhiberbarhet" ;
  oinhibiterbarhet_nn_1_N = mkN "oinhibiterbarhet" ;
  oinitierbarhet_nn_1_N = mkN "oinitierbarhet" ;
  oinjekterbarhet_nn_1_N = mkN "oinjekterbarhet" ;
  oinjicerbarhet_nn_1_N = mkN "oinjicerbarhet" ;
  oinkarnerbarhet_nn_1_N = mkN "oinkarnerbarhet" ;
  oinkasserbarhet_nn_1_N = mkN "oinkasserbarhet" ;
  oinklarerbarhet_nn_1_N = mkN "oinklarerbarhet" ;
  oinkluderbarhet_nn_1_N = mkN "oinkluderbarhet" ;
  oinkorporerbarhet_nn_1_N = mkN "oinkorporerbarhet" ;
  oinkvarterbarhet_nn_1_N = mkN "oinkvarterbarhet" ;
  oinnerverbarhet_nn_1_N = mkN "oinnerverbarhet" ;
  oinnestaengdhet_nn_1_1_N = mkN "oinnestängdhet" ;
  oinokulerbarhet_nn_1_N = mkN "oinokulerbarhet" ;
  oinplanterbarhet_nn_1_N = mkN "oinplanterbarhet" ;
  oinrangerbarhet_nn_1_N = mkN "oinrangerbarhet" ;
  oinrapporterbarhet_nn_1_N = mkN "oinrapporterbarhet" ;
  oinregistrerbarhet_nn_1_N = mkN "oinregistrerbarhet" ;
  oinscenerbarhet_nn_1_N = mkN "oinscenerbarhet" ;
  oinseminerbarhet_nn_1_N = mkN "oinseminerbarhet" ;
  oinsinuerbarhet_nn_1_N = mkN "oinsinuerbarhet" ;
  oinskraenkthet_nn_1_1_N = mkN "oinskränkthet" ;
  oinspekterbarhet_nn_1_N = mkN "oinspekterbarhet" ;
  oinspirerbarhet_nn_1_N = mkN "oinspirerbarhet" ;
  oinstallerbarhet_nn_1_N = mkN "oinstallerbarhet" ;
  oinstitutionaliserbarhet_nn_1_N = mkN "oinstitutionaliserbarhet" ;
  oinstruerbarhet_nn_1_N = mkN "oinstruerbarhet" ;
  oinstrumenterbarhet_nn_1_N = mkN "oinstrumenterbarhet" ;
  oinstuderbarhet_nn_1_N = mkN "oinstuderbarhet" ;
  oinstaengdhet_nn_1_1_N = mkN "oinstängdhet" ;
  ointaglighet_nn_1_N = mkN "ointaglighet" ;
  ointegrerbarhet_nn_1_N = mkN "ointegrerbarhet" ;
  ointellektualiserbarhet_nn_1_N = mkN "ointellektualiserbarhet" ;
  ointelligenthet_nn_1_N = mkN "ointelligenthet" ;
  ointensifierbarhet_nn_1_N = mkN "ointensifierbarhet" ;
  ointensiverbarhet_nn_1_N = mkN "ointensiverbarhet" ;
  ointerfolierbarhet_nn_1_N = mkN "ointerfolierbarhet" ;
  ointernaliserbarhet_nn_1_N = mkN "ointernaliserbarhet" ;
  ointernationaliserbarhet_nn_1_N = mkN "ointernationaliserbarhet" ;
  ointernerbarhet_nn_1_N = mkN "ointernerbarhet" ;
  ointerpellerbarhet_nn_1_N = mkN "ointerpellerbarhet" ;
  ointerpolerbarhet_nn_1_N = mkN "ointerpolerbarhet" ;
  ointerpreterbarhet_nn_1_N = mkN "ointerpreterbarhet" ;
  ointerpunkterbarhet_nn_1_N = mkN "ointerpunkterbarhet" ;
  ointervenerbarhet_nn_1_N = mkN "ointervenerbarhet" ;
  ointonerbarhet_nn_1_N = mkN "ointonerbarhet" ;
  ointresserbarhet_nn_1_N = mkN "ointresserbarhet" ;
  ointroducerbarhet_nn_1_N = mkN "ointroducerbarhet" ;
  oinvaderbarhet_nn_1_N = mkN "oinvaderbarhet" ;
  oinvalidiserbarhet_nn_1_N = mkN "oinvalidiserbarhet" ;
  oinventerbarhet_nn_1_N = mkN "oinventerbarhet" ;
  oinverterbarhet_nn_1_N = mkN "oinverterbarhet" ;
  oinvesterbarhet_nn_1_N = mkN "oinvesterbarhet" ;
  oinvigdhet_nn_1_N = mkN "oinvigdhet" ;
  oinviterbarhet_nn_1_N = mkN "oinviterbarhet" ;
  oinvolverbarhet_nn_1_N = mkN "oinvolverbarhet" ;
  oirriterbarhet_nn_1_N = mkN "oirriterbarhet" ;
  oislamiserbarhet_nn_1_N = mkN "oislamiserbarhet" ;
  oisolerbarhet_nn_1_N = mkN "oisolerbarhet" ;
  oitererbarhet_nn_1_N = mkN "oitererbarhet" ;
  ojazzifierbarhet_nn_1_N = mkN "ojazzifierbarhet" ;
  ojoderbarhet_nn_1_N = mkN "ojoderbarhet" ;
  ojonglerbarhet_nn_1_N = mkN "ojonglerbarhet" ;
  ojoniserbarhet_nn_1_N = mkN "ojoniserbarhet" ;
  ojusterbarhet_nn_1_N = mkN "ojusterbarhet" ;
  ojaemfoerbarhet_nn_1_1_N = mkN "ojämförbarhet" ;
  ojaemfoerlighet_nn_1_1_N = mkN "ojämförlighet" ;
  ojaemstaelldhet_nn_1_1_N = mkN "ojämställdhet" ;
  ojaevighet_nn_1_1_N = mkN "ojävighet" ;
  okalandrerbarhet_nn_1_N = mkN "okalandrerbarhet" ;
  okalcinerbarhet_nn_1_N = mkN "okalcinerbarhet" ;
  okalibrerbarhet_nn_1_N = mkN "okalibrerbarhet" ;
  okalkerbarhet_nn_1_N = mkN "okalkerbarhet" ;
  okalkylerbarhet_nn_1_N = mkN "okalkylerbarhet" ;
  okalmerbarhet_nn_1_N = mkN "okalmerbarhet" ;
  okamouflerbarhet_nn_1_N = mkN "okamouflerbarhet" ;
  okanaliserbarhet_nn_1_N = mkN "okanaliserbarhet" ;
  okanderbarhet_nn_1_N = mkN "okanderbarhet" ;
  okandiderbarhet_nn_1_N = mkN "okandiderbarhet" ;
  okannelerbarhet_nn_1_N = mkN "okannelerbarhet" ;
  okanoniserbarhet_nn_1_N = mkN "okanoniserbarhet" ;
  okapitaliserbarhet_nn_1_N = mkN "okapitaliserbarhet" ;
  okarakteriserbarhet_nn_1_N = mkN "okarakteriserbarhet" ;
  okaraktaeriserbarhet_nn_1_1_N = mkN "okaraktäriserbarhet" ;
  okarambolerbarhet_nn_1_N = mkN "okarambolerbarhet" ;
  okarboniserbarhet_nn_1_N = mkN "okarboniserbarhet" ;
  okarikerbarhet_nn_1_N = mkN "okarikerbarhet" ;
  okarterbarhet_nn_1_N = mkN "okarterbarhet" ;
  okartonnerbarhet_nn_1_N = mkN "okartonnerbarhet" ;
  okasserbarhet_nn_1_N = mkN "okasserbarhet" ;
  okastrerbarhet_nn_1_N = mkN "okastrerbarhet" ;
  okatalogiserbarhet_nn_1_N = mkN "okatalogiserbarhet" ;
  okatalyserbarhet_nn_1_N = mkN "okatalyserbarhet" ;
  okategoriserbarhet_nn_1_N = mkN "okategoriserbarhet" ;
  okateteriserbarhet_nn_1_N = mkN "okateteriserbarhet" ;
  okatetriserbarhet_nn_1_N = mkN "okatetriserbarhet" ;
  okauteriserbarhet_nn_1_N = mkN "okauteriserbarhet" ;
  oklanderlighet_nn_1_N = mkN "oklanderlighet" ;
  oklarerbarhet_nn_1_N = mkN "oklarerbarhet" ;
  oklassificerbarhet_nn_1_N = mkN "oklassificerbarhet" ;
  oklokhet_nn_1_N = mkN "oklokhet" ;
  oklorerbarhet_nn_1_N = mkN "oklorerbarhet" ;
  oklaeddhet_nn_1_1_N = mkN "okläddhet" ;
  okoafferbarhet_nn_1_N = mkN "okoafferbarhet" ;
  okoagulerbarhet_nn_1_N = mkN "okoagulerbarhet" ;
  okodifierbarhet_nn_1_N = mkN "okodifierbarhet" ;
  okollationerbarhet_nn_1_N = mkN "okollationerbarhet" ;
  okollektiviserbarhet_nn_1_N = mkN "okollektiviserbarhet" ;
  okoloniserbarhet_nn_1_N = mkN "okoloniserbarhet" ;
  okolorerbarhet_nn_1_N = mkN "okolorerbarhet" ;
  okolporterbarhet_nn_1_N = mkN "okolporterbarhet" ;
  okombinerbarhet_nn_1_N = mkN "okombinerbarhet" ;
  okommaterbarhet_nn_1_N = mkN "okommaterbarhet" ;
  okommenderbarhet_nn_1_N = mkN "okommenderbarhet" ;
  okommenterbarhet_nn_1_N = mkN "okommenterbarhet" ;
  okommersialiserbarhet_nn_1_N = mkN "okommersialiserbarhet" ;
  okommunaliserbarhet_nn_1_N = mkN "okommunaliserbarhet" ;
  okommunicerbarhet_nn_1_N = mkN "okommunicerbarhet" ;
  okommuterbarhet_nn_1_N = mkN "okommuterbarhet" ;
  okomparerbarhet_nn_1_N = mkN "okomparerbarhet" ;
  okompenserbarhet_nn_1_N = mkN "okompenserbarhet" ;
  okompilerbarhet_nn_1_N = mkN "okompilerbarhet" ;
  okompletterbarhet_nn_1_N = mkN "okompletterbarhet" ;
  okomplicerbarhet_nn_1_N = mkN "okomplicerbarhet" ;
  okomplimenterbarhet_nn_1_N = mkN "okomplimenterbarhet" ;
  okomponerbarhet_nn_1_N = mkN "okomponerbarhet" ;
  okomposterbarhet_nn_1_N = mkN "okomposterbarhet" ;
  okomprimerbarhet_nn_1_N = mkN "okomprimerbarhet" ;
  okomprometterbarhet_nn_1_N = mkN "okomprometterbarhet" ;
  okoncentrerbarhet_nn_1_N = mkN "okoncentrerbarhet" ;
  okoncessionerbarhet_nn_1_N = mkN "okoncessionerbarhet" ;
  okoncipierbarhet_nn_1_N = mkN "okoncipierbarhet" ;
  okondemnerbarhet_nn_1_N = mkN "okondemnerbarhet" ;
  okondenserbarhet_nn_1_N = mkN "okondenserbarhet" ;
  okonditionerbarhet_nn_1_N = mkN "okonditionerbarhet" ;
  okondolerbarhet_nn_1_N = mkN "okondolerbarhet" ;
  okonfirmerbarhet_nn_1_N = mkN "okonfirmerbarhet" ;
  okonfiskerbarhet_nn_1_N = mkN "okonfiskerbarhet" ;
  okonfronterbarhet_nn_1_N = mkN "okonfronterbarhet" ;
  okonfunderbarhet_nn_1_N = mkN "okonfunderbarhet" ;
  okongruerbarhet_nn_1_N = mkN "okongruerbarhet" ;
  okonjugerbarhet_nn_1_N = mkN "okonjugerbarhet" ;
  okonkluderbarhet_nn_1_N = mkN "okonkluderbarhet" ;
  okonkretiserbarhet_nn_1_N = mkN "okonkretiserbarhet" ;
  okonserverbarhet_nn_1_N = mkN "okonserverbarhet" ;
  okonsignerbarhet_nn_1_N = mkN "okonsignerbarhet" ;
  okonsoliderbarhet_nn_1_N = mkN "okonsoliderbarhet" ;
  okonstaterbarhet_nn_1_N = mkN "okonstaterbarhet" ;
  okonsternerbarhet_nn_1_N = mkN "okonsternerbarhet" ;
  okonstituerbarhet_nn_1_N = mkN "okonstituerbarhet" ;
  okonstruerbarhet_nn_1_N = mkN "okonstruerbarhet" ;
  okonsulterbarhet_nn_1_N = mkN "okonsulterbarhet" ;
  okonsumerbarhet_nn_1_N = mkN "okonsumerbarhet" ;
  okontaminerbarhet_nn_1_N = mkN "okontaminerbarhet" ;
  okonterbarhet_nn_1_N = mkN "okonterbarhet" ;
  okontingenterbarhet_nn_1_N = mkN "okontingenterbarhet" ;
  okontoriserbarhet_nn_1_N = mkN "okontoriserbarhet" ;
  okontraherbarhet_nn_1_N = mkN "okontraherbarhet" ;
  okontrakterbarhet_nn_1_N = mkN "okontrakterbarhet" ;
  okontramanderbarhet_nn_1_N = mkN "okontramanderbarhet" ;
  okontrasignerbarhet_nn_1_N = mkN "okontrasignerbarhet" ;
  okontrasterbarhet_nn_1_N = mkN "okontrasterbarhet" ;
  okontribuerbarhet_nn_1_N = mkN "okontribuerbarhet" ;
  okontrollerbarhet_nn_1_N = mkN "okontrollerbarhet" ;
  okonturerbarhet_nn_1_N = mkN "okonturerbarhet" ;
  okonvergerbarhet_nn_1_N = mkN "okonvergerbarhet" ;
  okonverserbarhet_nn_1_N = mkN "okonverserbarhet" ;
  okonverterbarhet_nn_1_N = mkN "okonverterbarhet" ;
  okonvojerbarhet_nn_1_N = mkN "okonvojerbarhet" ;
  okoordinerbarhet_nn_1_N = mkN "okoordinerbarhet" ;
  okopierbarhet_nn_1_N = mkN "okopierbarhet" ;
  okorrelerbarhet_nn_1_N = mkN "okorrelerbarhet" ;
  okorrigerbarhet_nn_1_N = mkN "okorrigerbarhet" ;
  okorroderbarhet_nn_1_N = mkN "okorroderbarhet" ;
  okorrugerbarhet_nn_1_N = mkN "okorrugerbarhet" ;
  okorrumperbarhet_nn_1_N = mkN "okorrumperbarhet" ;
  okorsetterbarhet_nn_1_N = mkN "okorsetterbarhet" ;
  okostymerbarhet_nn_1_N = mkN "okostymerbarhet" ;
  okrackelerbarhet_nn_1_N = mkN "okrackelerbarhet" ;
  okrediterbarhet_nn_1_N = mkN "okrediterbarhet" ;
  okreerbarhet_nn_1_N = mkN "okreerbarhet" ;
  okremerbarhet_nn_1_N = mkN "okremerbarhet" ;
  okreperbarhet_nn_1_N = mkN "okreperbarhet" ;
  okreverbarhet_nn_1_N = mkN "okreverbarhet" ;
  okriminaliserbarhet_nn_1_N = mkN "okriminaliserbarhet" ;
  okristalliserbarhet_nn_1_N = mkN "okristalliserbarhet" ;
  okritiserbarhet_nn_1_N = mkN "okritiserbarhet" ;
  okroppslighet_nn_1_N = mkN "okroppslighet" ;
  okrossbarhet_nn_1_N = mkN "okrossbarhet" ;
  okrypterbarhet_nn_1_N = mkN "okrypterbarhet" ;
  okraenkbarhet_nn_1_1_N = mkN "okränkbarhet" ;
  oktober_nn_1_N = mkN "oktober" ;
  oktrojerbarhet_nn_1_N = mkN "oktrojerbarhet" ;
  okuberbarhet_nn_1_N = mkN "okuberbarhet" ;
  okujonerbarhet_nn_1_N = mkN "okujonerbarhet" ;
  okulerbarhet_nn_1_N = mkN "okulerbarhet" ;
  okultiverbarhet_nn_1_N = mkN "okultiverbarhet" ;
  okultur_nn_1_N = mkN "okultur" ;
  okumulerbarhet_nn_1_N = mkN "okumulerbarhet" ;
  okunskap_nn_1_N = mkN "okunskap" ;
  okuperbarhet_nn_1_N = mkN "okuperbarhet" ;
  okuraterbarhet_nn_1_N = mkN "okuraterbarhet" ;
  okurerbarhet_nn_1_N = mkN "okurerbarhet" ;
  okursiverbarhet_nn_1_N = mkN "okursiverbarhet" ;
  okurtiserbarhet_nn_1_N = mkN "okurtiserbarhet" ;
  okuverterbarhet_nn_1_N = mkN "okuverterbarhet" ;
  okuvlighet_nn_1_N = mkN "okuvlighet" ;
  okvadrerbarhet_nn_1_N = mkN "okvadrerbarhet" ;
  okvalificerbarhet_nn_1_N = mkN "okvalificerbarhet" ;
  okvantifierbarhet_nn_1_N = mkN "okvantifierbarhet" ;
  okvinnlighet_nn_1_N = mkN "okvinnlighet" ;
  okvitterbarhet_nn_1_N = mkN "okvitterbarhet" ;
  okvoterbarhet_nn_1_N = mkN "okvoterbarhet" ;
  okynnighet_nn_1_N = mkN "okynnighet" ;
  okyrklighet_nn_1_N = mkN "okyrklighet" ;
  okaendhet_nn_1_1_N = mkN "okändhet" ;
  olabialiserbarhet_nn_1_N = mkN "olabialiserbarhet" ;
  olackerbarhet_nn_1_N = mkN "olackerbarhet" ;
  olamenterbarhet_nn_1_N = mkN "olamenterbarhet" ;
  olaminerbarhet_nn_1_N = mkN "olaminerbarhet" ;
  olangetterbarhet_nn_1_N = mkN "olangetterbarhet" ;
  olanserbarhet_nn_1_N = mkN "olanserbarhet" ;
  olapiserbarhet_nn_1_N = mkN "olapiserbarhet" ;
  olaserbarhet_nn_1_N = mkN "olaserbarhet" ;
  olatiniserbarhet_nn_1_N = mkN "olatiniserbarhet" ;
  olaverbarhet_nn_1_N = mkN "olaverbarhet" ;
  olegaliserbarhet_nn_1_N = mkN "olegaliserbarhet" ;
  olegerbarhet_nn_1_N = mkN "olegerbarhet" ;
  olegitimerbarhet_nn_1_N = mkN "olegitimerbarhet" ;
  olevererbarhet_nn_1_N = mkN "olevererbarhet" ;
  oliberaliserbarhet_nn_1_N = mkN "oliberaliserbarhet" ;
  olicenserbarhet_nn_1_N = mkN "olicenserbarhet" ;
  olicensierbarhet_nn_1_N = mkN "olicensierbarhet" ;
  olicentierbarhet_nn_1_N = mkN "olicentierbarhet" ;
  olierbarhet_nn_1_N = mkN "olierbarhet" ;
  olikviderbarhet_nn_1_N = mkN "olikviderbarhet" ;
  olinjerbarhet_nn_1_N = mkN "olinjerbarhet" ;
  olisserbarhet_nn_1_N = mkN "olisserbarhet" ;
  olitograferbarhet_nn_1_N = mkN "olitograferbarhet" ;
  oljebekaempningsberedskap_nn_1_1_N = mkN "oljebekämpningsberedskap" ;
  oljebestaendighet_nn_1_1_N = mkN "oljebeständighet" ;
  oljeduk_nn_1_N = mkN "oljeduk" ;
  oljedoed_nn_1_1_N = mkN "oljedöd" ;
  oljefilm_nn_1_N = mkN "oljefilm" ;
  oljekonsumtion_nn_1_N = mkN "oljekonsumtion" ;
  oljerikhet_nn_1_N = mkN "oljerikhet" ;
  oljighet_nn_1_N = mkN "oljighet" ;
  ologerbarhet_nn_1_N = mkN "ologerbarhet" ;
  ologiskhet_nn_1_N = mkN "ologiskhet" ;
  olokaliserbarhet_nn_1_N = mkN "olokaliserbarhet" ;
  olust_nn_1_N = mkN "olust" ;
  olustighet_nn_1_N = mkN "olustighet" ;
  oluteiniserbarhet_nn_1_N = mkN "oluteiniserbarhet" ;
  olycklighet_nn_1_N = mkN "olycklighet" ;
  olycksalighet_nn_1_N = mkN "olycksalighet" ;
  olycksdigerhet_nn_1_N = mkN "olycksdigerhet" ;
  olyxrenoverbarhet_nn_1_N = mkN "olyxrenoverbarhet" ;
  olaederbarhet_nn_1_1_N = mkN "oläderbarhet" ;
  olaeklighet_nn_1_1_N = mkN "oläklighet" ;
  olaemplighet_nn_1_1_N = mkN "olämplighet" ;
  olaendighet_nn_1_1_N = mkN "oländighet" ;
  olaengdhet_nn_1_1_N = mkN "olängdhet" ;
  olaerdhet_nn_1_1_N = mkN "olärdhet" ;
  olaesbarhet_nn_1_1_N = mkN "oläsbarhet" ;
  olaeslighet_nn_1_1_N = mkN "oläslighet" ;
  olaat_nn_1_1_N = mkN "olåt" ;
  oloensamhet_nn_1_1_N = mkN "olönsamhet" ;
  oloesbarhet_nn_1_1_N = mkN "olösbarhet" ;
  oloeslighet_nn_1_1_N = mkN "olöslighet" ;
  omadrasserbarhet_nn_1_N = mkN "omadrasserbarhet" ;
  omagasinerbarhet_nn_1_N = mkN "omagasinerbarhet" ;
  omagnetiserbarhet_nn_1_N = mkN "omagnetiserbarhet" ;
  omakulerbarhet_nn_1_N = mkN "omakulerbarhet" ;
  omalfoberbarhet_nn_1_N = mkN "omalfoberbarhet" ;
  omaltraeterbarhet_nn_1_1_N = mkN "omalträterbarhet" ;
  omanifesterbarhet_nn_1_N = mkN "omanifesterbarhet" ;
  omanikurerbarhet_nn_1_N = mkN "omanikurerbarhet" ;
  omanikyrerbarhet_nn_1_N = mkN "omanikyrerbarhet" ;
  omanipulerbarhet_nn_1_N = mkN "omanipulerbarhet" ;
  omanlighet_nn_1_N = mkN "omanlighet" ;
  omanoevrerbarhet_nn_1_1_N = mkN "omanövrerbarhet" ;
  omarginaliserbarhet_nn_1_N = mkN "omarginaliserbarhet" ;
  omarinerbarhet_nn_1_N = mkN "omarinerbarhet" ;
  omarkerbarhet_nn_1_N = mkN "omarkerbarhet" ;
  omarmorerbarhet_nn_1_N = mkN "omarmorerbarhet" ;
  omarscherbarhet_nn_1_N = mkN "omarscherbarhet" ;
  omarterbarhet_nn_1_N = mkN "omarterbarhet" ;
  omaskerbarhet_nn_1_N = mkN "omaskerbarhet" ;
  omaskuliniserbarhet_nn_1_N = mkN "omaskuliniserbarhet" ;
  omassakrerbarhet_nn_1_N = mkN "omassakrerbarhet" ;
  omasserbarhet_nn_1_N = mkN "omasserbarhet" ;
  omatelasserbarhet_nn_1_N = mkN "omatelasserbarhet" ;
  omaterialiserbarhet_nn_1_N = mkN "omaterialiserbarhet" ;
  omatterbarhet_nn_1_N = mkN "omatterbarhet" ;
  omaximerbarhet_nn_1_N = mkN "omaximerbarhet" ;
  ombytlighet_nn_1_N = mkN "ombytlighet" ;
  omdirigerbarhet_nn_1_N = mkN "omdirigerbarhet" ;
  omedaljerbarhet_nn_1_N = mkN "omedaljerbarhet" ;
  omedelbarhet_nn_1_N = mkN "omedelbarhet" ;
  omedgoerlighet_nn_1_1_N = mkN "omedgörlighet" ;
  omedicinerbarhet_nn_1_N = mkN "omedicinerbarhet" ;
  omekaniserbarhet_nn_1_N = mkN "omekaniserbarhet" ;
  omemorerbarhet_nn_1_N = mkN "omemorerbarhet" ;
  omerceriserbarhet_nn_1_N = mkN "omerceriserbarhet" ;
  omeriterbarhet_nn_1_N = mkN "omeriterbarhet" ;
  ometalliserbarhet_nn_1_N = mkN "ometalliserbarhet" ;
  omfaangsrikhet_nn_1_1_N = mkN "omfångsrikhet" ;
  omikroskoperbarhet_nn_1_N = mkN "omikroskoperbarhet" ;
  omildhet_nn_1_N = mkN "omildhet" ;
  omilitariserbarhet_nn_1_N = mkN "omilitariserbarhet" ;
  omineraliserbarhet_nn_1_N = mkN "omineraliserbarhet" ;
  ominerbarhet_nn_1_N = mkN "ominerbarhet" ;
  ominiatyriserbarhet_nn_1_N = mkN "ominiatyriserbarhet" ;
  ominimerbarhet_nn_1_N = mkN "ominimerbarhet" ;
  omissiverbarhet_nn_1_N = mkN "omissiverbarhet" ;
  omisskrediterbarhet_nn_1_N = mkN "omisskrediterbarhet" ;
  omisskaennelighet_nn_1_1_N = mkN "omisskännelighet" ;
  omisskaennlighet_nn_1_1_N = mkN "omisskännlighet" ;
  omisstaenksamhet_nn_1_1_N = mkN "omisstänksamhet" ;
  omkrets_nn_1_N = mkN "omkrets" ;
  ommoeblerbarhet_nn_1_1_N = mkN "ommöblerbarhet" ;
  omnejd_nn_1_N = mkN "omnejd" ;
  omnipotens_nn_1_N = mkN "omnipotens" ;
  omobiliserbarhet_nn_1_N = mkN "omobiliserbarhet" ;
  omodellerbarhet_nn_1_N = mkN "omodellerbarhet" ;
  omodererbarhet_nn_1_N = mkN "omodererbarhet" ;
  omoderniserbarhet_nn_1_N = mkN "omoderniserbarhet" ;
  omodifierbarhet_nn_1_N = mkN "omodifierbarhet" ;
  omodulerbarhet_nn_1_N = mkN "omodulerbarhet" ;
  omodaerniserbarhet_nn_1_1_N = mkN "omodärniserbarhet" ;
  omonoftongerbarhet_nn_1_N = mkN "omonoftongerbarhet" ;
  omonopoliserbarhet_nn_1_N = mkN "omonopoliserbarhet" ;
  omonterbarhet_nn_1_N = mkN "omonterbarhet" ;
  omoral_nn_1_N = mkN "omoral" ;
  omorganisation_nn_1_N = mkN "omorganisation" ;
  omorganiserbarhet_nn_1_N = mkN "omorganiserbarhet" ;
  omorserbarhet_nn_1_N = mkN "omorserbarhet" ;
  omortificerbarhet_nn_1_N = mkN "omortificerbarhet" ;
  omortifierbarhet_nn_1_N = mkN "omortifierbarhet" ;
  omotiverbarhet_nn_1_N = mkN "omotiverbarhet" ;
  omotoriserbarhet_nn_1_N = mkN "omotoriserbarhet" ;
  omotstaandlighet_nn_1_1_N = mkN "omotståndlighet" ;
  omotsaeglighet_nn_1_1_N = mkN "omotsäglighet" ;
  omottaglighet_nn_1_N = mkN "omottaglighet" ;
  omplacerbarhet_nn_1_N = mkN "omplacerbarhet" ;
  oms_nn_1_N = mkN "oms" ;
  omskulpturerbarhet_nn_1_N = mkN "omskulpturerbarhet" ;
  omsorgsvaard_nn_1_1_N = mkN "omsorgsvård" ;
  omstriddhet_nn_1_N = mkN "omstriddhet" ;
  omstrukturerbarhet_nn_1_N = mkN "omstrukturerbarhet" ;
  omstaendlighet_nn_1_1_N = mkN "omständlighet" ;
  omstoertning_nn_1_1_N = mkN "omstörtning" ;
  omsyn_nn_1_N = mkN "omsyn" ;
  omtyckthet_nn_1_N = mkN "omtyckthet" ;
  omtaenksamhet_nn_1_1_N = mkN "omtänksamhet" ;
  omuljerbarhet_nn_1_N = mkN "omuljerbarhet" ;
  omultiplicerbarhet_nn_1_N = mkN "omultiplicerbarhet" ;
  omumifierbarhet_nn_1_N = mkN "omumifierbarhet" ;
  omutbarhet_nn_1_N = mkN "omutbarhet" ;
  omuterbarhet_nn_1_N = mkN "omuterbarhet" ;
  omutlighet_nn_1_N = mkN "omutlighet" ;
  omvaendbarhet_nn_1_1_N = mkN "omvändbarhet" ;
  omvaerderbarhet_nn_1_1_N = mkN "omvärderbarhet" ;
  omyndighet_nn_1_N = mkN "omyndighet" ;
  omystifierbarhet_nn_1_N = mkN "omystifierbarhet" ;
  omaengdhet_nn_1_1_N = mkN "omängdhet" ;
  omaerklighet_nn_1_1_N = mkN "omärklighet" ;
  omaetlighet_nn_1_1_N = mkN "omätlighet" ;
  omaettlighet_nn_1_1_N = mkN "omättlighet" ;
  omoeblerbarhet_nn_1_1_N = mkN "omöblerbarhet" ;
  onasalerbarhet_nn_1_N = mkN "onasalerbarhet" ;
  onasaliserbarhet_nn_1_N = mkN "onasaliserbarhet" ;
  onationaliserbarhet_nn_1_N = mkN "onationaliserbarhet" ;
  onatur_nn_1_N = mkN "onatur" ;
  onaturaliserbarhet_nn_1_N = mkN "onaturaliserbarhet" ;
  onavigerbarhet_nn_1_N = mkN "onavigerbarhet" ;
  ondsinthet_nn_1_N = mkN "ondsinthet" ;
  ondulerbarhet_nn_1_N = mkN "ondulerbarhet" ;
  one_step_nn_1_N = mkN "one-step" ;
  onedtransformerbarhet_nn_1_N = mkN "onedtransformerbarhet" ;
  onedtransponerbarhet_nn_1_N = mkN "onedtransponerbarhet" ;
  onedvaerderbarhet_nn_1_1_N = mkN "onedvärderbarhet" ;
  onegerbarhet_nn_1_N = mkN "onegerbarhet" ;
  onegligerbarhet_nn_1_N = mkN "onegligerbarhet" ;
  onegocierbarhet_nn_1_N = mkN "onegocierbarhet" ;
  onegotierbarhet_nn_1_N = mkN "onegotierbarhet" ;
  oneklighet_nn_1_N = mkN "oneklighet" ;
  onertransformerbarhet_nn_1_N = mkN "onertransformerbarhet" ;
  onertransponerbarhet_nn_1_N = mkN "onertransponerbarhet" ;
  onervaerderbarhet_nn_1_1_N = mkN "onervärderbarhet" ;
  onestep_nn_1_N = mkN "onestep" ;
  oneutraliserbarhet_nn_1_N = mkN "oneutraliserbarhet" ;
  oniellerbarhet_nn_1_N = mkN "oniellerbarhet" ;
  onitrerbarhet_nn_1_N = mkN "onitrerbarhet" ;
  onivellerbarhet_nn_1_N = mkN "onivellerbarhet" ;
  onobiliserbarhet_nn_1_N = mkN "onobiliserbarhet" ;
  onominerbarhet_nn_1_N = mkN "onominerbarhet" ;
  ononchalerbarhet_nn_1_N = mkN "ononchalerbarhet" ;
  onormaliserbarhet_nn_1_N = mkN "onormaliserbarhet" ;
  onormerbarhet_nn_1_N = mkN "onormerbarhet" ;
  onoslighet_nn_1_N = mkN "onoslighet" ;
  onoterbarhet_nn_1_N = mkN "onoterbarhet" ;
  onotificerbarhet_nn_1_N = mkN "onotificerbarhet" ;
  onotifierbarhet_nn_1_N = mkN "onotifierbarhet" ;
  onotiserbarhet_nn_1_N = mkN "onotiserbarhet" ;
  onumrerbarhet_nn_1_N = mkN "onumrerbarhet" ;
  onyanserbarhet_nn_1_N = mkN "onyanserbarhet" ;
  onaemnbarhet_nn_1_1_N = mkN "onämnbarhet" ;
  onaabarhet_nn_1_1_N = mkN "onåbarhet" ;
  onaad_nn_1_1_N = mkN "onåd" ;
  onaadighet_nn_1_1_N = mkN "onådighet" ;
  onoejaktighet_nn_1_1_N = mkN "onöjaktighet" ;
  oobducerbarhet_nn_1_N = mkN "oobducerbarhet" ;
  oobjektiverbarhet_nn_1_N = mkN "oobjektiverbarhet" ;
  oobligerbarhet_nn_1_N = mkN "oobligerbarhet" ;
  oobserverbarhet_nn_1_N = mkN "oobserverbarhet" ;
  ooccidentaliserbarhet_nn_1_N = mkN "ooccidentaliserbarhet" ;
  oockuperbarhet_nn_1_N = mkN "oockuperbarhet" ;
  ooffererbarhet_nn_1_N = mkN "ooffererbarhet" ;
  ooktrojerbarhet_nn_1_N = mkN "ooktrojerbarhet" ;
  ookulerbarhet_nn_1_N = mkN "ookulerbarhet" ;
  oolit_nn_1_N = mkN "oolit" ;
  oombeddhet_nn_1_N = mkN "oombeddhet" ;
  oomdirigerbarhet_nn_1_N = mkN "oomdirigerbarhet" ;
  oomkullkastlighet_nn_1_N = mkN "oomkullkastlighet" ;
  oomkullrunkelighet_nn_1_N = mkN "oomkullrunkelighet" ;
  oommoeblerbarhet_nn_1_1_N = mkN "oommöblerbarhet" ;
  oomorganiserbarhet_nn_1_N = mkN "oomorganiserbarhet" ;
  oomplacerbarhet_nn_1_N = mkN "oomplacerbarhet" ;
  oomskulpturerbarhet_nn_1_N = mkN "oomskulpturerbarhet" ;
  oomstrukturerbarhet_nn_1_N = mkN "oomstrukturerbarhet" ;
  oomtvistlighet_nn_1_N = mkN "oomtvistlighet" ;
  oomvaerderbarhet_nn_1_1_N = mkN "oomvärderbarhet" ;
  oondulerbarhet_nn_1_N = mkN "oondulerbarhet" ;
  ooperationaliserbarhet_nn_1_N = mkN "ooperationaliserbarhet" ;
  oopererbarhet_nn_1_N = mkN "oopererbarhet" ;
  oopponerbarhet_nn_1_N = mkN "oopponerbarhet" ;
  ooptimerbarhet_nn_1_N = mkN "ooptimerbarhet" ;
  oordentlighet_nn_1_N = mkN "oordentlighet" ;
  oordinerbarhet_nn_1_N = mkN "oordinerbarhet" ;
  oorganiserbarhet_nn_1_N = mkN "oorganiserbarhet" ;
  oorganiskhet_nn_1_N = mkN "oorganiskhet" ;
  oorienterbarhet_nn_1_N = mkN "oorienterbarhet" ;
  oorkestrerbarhet_nn_1_N = mkN "oorkestrerbarhet" ;
  oornamenterbarhet_nn_1_N = mkN "oornamenterbarhet" ;
  oornerbarhet_nn_1_N = mkN "oornerbarhet" ;
  oortodoxhet_nn_1_N = mkN "oortodoxhet" ;
  ooxiderbarhet_nn_1_N = mkN "ooxiderbarhet" ;
  opacificerbarhet_nn_1_N = mkN "opacificerbarhet" ;
  opaginerbarhet_nn_1_N = mkN "opaginerbarhet" ;
  opaketerbarhet_nn_1_N = mkN "opaketerbarhet" ;
  opakteknik_nn_1_N = mkN "opakteknik" ;
  opalataliserbarhet_nn_1_N = mkN "opalataliserbarhet" ;
  opalescens_nn_1_N = mkN "opalescens" ;
  opaljetterbarhet_nn_1_N = mkN "opaljetterbarhet" ;
  opalperbarhet_nn_1_N = mkN "opalperbarhet" ;
  opanerbarhet_nn_1_N = mkN "opanerbarhet" ;
  opanorerbarhet_nn_1_N = mkN "opanorerbarhet" ;
  opantograferbarhet_nn_1_N = mkN "opantograferbarhet" ;
  oparaderbarhet_nn_1_N = mkN "oparaderbarhet" ;
  oparaferbarhet_nn_1_N = mkN "oparaferbarhet" ;
  oparaffinerbarhet_nn_1_N = mkN "oparaffinerbarhet" ;
  oparafraserbarhet_nn_1_N = mkN "oparafraserbarhet" ;
  oparallelliserbarhet_nn_1_N = mkN "oparallelliserbarhet" ;
  oparalyserbarhet_nn_1_N = mkN "oparalyserbarhet" ;
  oparerbarhet_nn_1_N = mkN "oparerbarhet" ;
  oparfymerbarhet_nn_1_N = mkN "oparfymerbarhet" ;
  oparkerbarhet_nn_1_N = mkN "oparkerbarhet" ;
  oparketterbarhet_nn_1_N = mkN "oparketterbarhet" ;
  oparodierbarhet_nn_1_N = mkN "oparodierbarhet" ;
  opartiskhet_nn_1_N = mkN "opartiskhet" ;
  opasserbarhet_nn_1_N = mkN "opasserbarhet" ;
  opassiverbarhet_nn_1_N = mkN "opassiverbarhet" ;
  opassiviserbarhet_nn_1_N = mkN "opassiviserbarhet" ;
  opasslighet_nn_1_N = mkN "opasslighet" ;
  opastoeriserbarhet_nn_1_1_N = mkN "opastöriserbarhet" ;
  opatenterbarhet_nn_1_N = mkN "opatenterbarhet" ;
  opatinerbarhet_nn_1_N = mkN "opatinerbarhet" ;
  opatrullerbarhet_nn_1_N = mkN "opatrullerbarhet" ;
  opauperiserbarhet_nn_1_N = mkN "opauperiserbarhet" ;
  opauserbarhet_nn_1_N = mkN "opauserbarhet" ;
  opelleterbarhet_nn_1_N = mkN "opelleterbarhet" ;
  openetrerbarhet_nn_1_N = mkN "openetrerbarhet" ;
  opensionerbarhet_nn_1_N = mkN "opensionerbarhet" ;
  operapublik_nn_1_N = mkN "operapublik" ;
  operationaliserbarhet_nn_1_N = mkN "operationaliserbarhet" ;
  operationsanalys_nn_1_N = mkN "operationsanalys" ;
  opercipierbarhet_nn_1_N = mkN "opercipierbarhet" ;
  opererbarhet_nn_1_N = mkN "opererbarhet" ;
  operforerbarhet_nn_1_N = mkN "operforerbarhet" ;
  operiodiserbarhet_nn_1_N = mkN "operiodiserbarhet" ;
  opermitterbarhet_nn_1_N = mkN "opermitterbarhet" ;
  opermuterbarhet_nn_1_N = mkN "opermuterbarhet" ;
  opersiflerbarhet_nn_1_N = mkN "opersiflerbarhet" ;
  opersonifierbarhet_nn_1_N = mkN "opersonifierbarhet" ;
  opersonlighet_nn_1_N = mkN "opersonlighet" ;
  opersvaderbarhet_nn_1_N = mkN "opersvaderbarhet" ;
  operverterbarhet_nn_1_N = mkN "operverterbarhet" ;
  opetrifierbarhet_nn_1_N = mkN "opetrifierbarhet" ;
  opikerbarhet_nn_1_N = mkN "opikerbarhet" ;
  opincerbarhet_nn_1_N = mkN "opincerbarhet" ;
  opiumroekning_nn_1_1_N = mkN "opiumrökning" ;
  opkonst_nn_1_N = mkN "opkonst" ;
  oplacerbarhet_nn_1_N = mkN "oplacerbarhet" ;
  oplagierbarhet_nn_1_N = mkN "oplagierbarhet" ;
  oplanerbarhet_nn_1_N = mkN "oplanerbarhet" ;
  oplanterbarhet_nn_1_N = mkN "oplanterbarhet" ;
  oplatinerbarhet_nn_1_N = mkN "oplatinerbarhet" ;
  oplisserbarhet_nn_1_N = mkN "oplisserbarhet" ;
  oplomberbarhet_nn_1_N = mkN "oplomberbarhet" ;
  oplaeterbarhet_nn_1_1_N = mkN "opläterbarhet" ;
  opocherbarhet_nn_1_N = mkN "opocherbarhet" ;
  opointerbarhet_nn_1_N = mkN "opointerbarhet" ;
  opolariserbarhet_nn_1_N = mkN "opolariserbarhet" ;
  opolerbarhet_nn_1_N = mkN "opolerbarhet" ;
  opolitiserbarhet_nn_1_N = mkN "opolitiserbarhet" ;
  opolletterbarhet_nn_1_N = mkN "opolletterbarhet" ;
  opollinerbarhet_nn_1_N = mkN "opollinerbarhet" ;
  opomaderbarhet_nn_1_N = mkN "opomaderbarhet" ;
  opopulariserbarhet_nn_1_N = mkN "opopulariserbarhet" ;
  oportionerbarhet_nn_1_N = mkN "oportionerbarhet" ;
  oportraetterbarhet_nn_1_1_N = mkN "oporträtterbarhet" ;
  opostdaterbarhet_nn_1_N = mkN "opostdaterbarhet" ;
  oposterbarhet_nn_1_N = mkN "oposterbarhet" ;
  opostponerbarhet_nn_1_N = mkN "opostponerbarhet" ;
  opostulerbarhet_nn_1_N = mkN "opostulerbarhet" ;
  opoaengterbarhet_nn_1_1_N = mkN "opoängterbarhet" ;
  oppfinningsrikhet_nn_1_N = mkN "oppfinningsrikhet" ;
  oppfaellbarhet_nn_1_1_N = mkN "oppfällbarhet" ;
  opphinnelighet_nn_1_N = mkN "opphinnelighet" ;
  oppjusterbarhet_nn_1_N = mkN "oppjusterbarhet" ;
  oppklaeddhet_nn_1_1_N = mkN "oppkläddhet" ;
  oppknaeppthet_nn_1_1_N = mkN "oppknäppthet" ;
  oppkoerdhet_nn_1_1_N = mkN "oppkördhet" ;
  oppochnedvaendhet_nn_1_1_N = mkN "oppochnedvändhet" ;
  oppochnervaendhet_nn_1_1_N = mkN "oppochnervändhet" ;
  opponerbarhet_nn_1_N = mkN "opponerbarhet" ;
  opportunhet_nn_1_N = mkN "opportunhet" ;
  opportunitetsprincip_nn_1_N = mkN "opportunitetsprincip" ;
  oppsummerbarhet_nn_1_N = mkN "oppsummerbarhet" ;
  oppvaerderbarhet_nn_1_1_N = mkN "oppvärderbarhet" ;
  oppvaext_nn_1_1_N = mkN "oppväxt" ;
  oppaanedvaendhet_nn_1_1_N = mkN "oppånedvändhet" ;
  oppaanervaendhet_nn_1_1_N = mkN "oppånervändhet" ;
  opraktiserbarhet_nn_1_N = mkN "opraktiserbarhet" ;
  opraktiskhet_nn_1_N = mkN "opraktiskhet" ;
  opreciserbarhet_nn_1_N = mkN "opreciserbarhet" ;
  oprecishet_nn_1_N = mkN "oprecishet" ;
  opredestinerbarhet_nn_1_N = mkN "opredestinerbarhet" ;
  opredicerbarhet_nn_1_N = mkN "opredicerbarhet" ;
  opredisponerbarhet_nn_1_N = mkN "opredisponerbarhet" ;
  oprefabricerbarhet_nn_1_N = mkN "oprefabricerbarhet" ;
  oprefererbarhet_nn_1_N = mkN "oprefererbarhet" ;
  oprefigerbarhet_nn_1_N = mkN "oprefigerbarhet" ;
  opreludierbarhet_nn_1_N = mkN "opreludierbarhet" ;
  opremierbarhet_nn_1_N = mkN "opremierbarhet" ;
  opreparerbarhet_nn_1_N = mkN "opreparerbarhet" ;
  opresenterbarhet_nn_1_N = mkN "opresenterbarhet" ;
  opreserverbarhet_nn_1_N = mkN "opreserverbarhet" ;
  opreskriberbarhet_nn_1_N = mkN "opreskriberbarhet" ;
  opresterbarhet_nn_1_N = mkN "opresterbarhet" ;
  opresumerbarhet_nn_1_N = mkN "opresumerbarhet" ;
  oprioriterbarhet_nn_1_N = mkN "oprioriterbarhet" ;
  oprivatiserbarhet_nn_1_N = mkN "oprivatiserbarhet" ;
  oprivilegierbarhet_nn_1_N = mkN "oprivilegierbarhet" ;
  oproberbarhet_nn_1_N = mkN "oproberbarhet" ;
  oproblematiserbarhet_nn_1_N = mkN "oproblematiserbarhet" ;
  oproducerbarhet_nn_1_N = mkN "oproducerbarhet" ;
  oprofanerbarhet_nn_1_N = mkN "oprofanerbarhet" ;
  oprofessionaliserbarhet_nn_1_N = mkN "oprofessionaliserbarhet" ;
  oprofilerbarhet_nn_1_N = mkN "oprofilerbarhet" ;
  oprognostiserbarhet_nn_1_N = mkN "oprognostiserbarhet" ;
  oprogrammerbarhet_nn_1_N = mkN "oprogrammerbarhet" ;
  oprojekterbarhet_nn_1_N = mkN "oprojekterbarhet" ;
  oprojicerbarhet_nn_1_N = mkN "oprojicerbarhet" ;
  oproklamerbarhet_nn_1_N = mkN "oproklamerbarhet" ;
  oproletariserbarhet_nn_1_N = mkN "oproletariserbarhet" ;
  oprolongerbarhet_nn_1_N = mkN "oprolongerbarhet" ;
  opromoverbarhet_nn_1_N = mkN "opromoverbarhet" ;
  opromulgerbarhet_nn_1_N = mkN "opromulgerbarhet" ;
  oprononcerbarhet_nn_1_N = mkN "oprononcerbarhet" ;
  oproponerbarhet_nn_1_N = mkN "oproponerbarhet" ;
  oproportionerbarhet_nn_1_N = mkN "oproportionerbarhet" ;
  oproportionerlighet_nn_1_N = mkN "oproportionerlighet" ;
  oproskriberbarhet_nn_1_N = mkN "oproskriberbarhet" ;
  oprospekterbarhet_nn_1_N = mkN "oprospekterbarhet" ;
  oprotegerbarhet_nn_1_N = mkN "oprotegerbarhet" ;
  oprotokollerbarhet_nn_1_N = mkN "oprotokollerbarhet" ;
  oprovocerbarhet_nn_1_N = mkN "oprovocerbarhet" ;
  opsykologiserbarhet_nn_1_N = mkN "opsykologiserbarhet" ;
  optik_nn_1_N = mkN "optik" ;
  optimerbarhet_nn_1_N = mkN "optimerbarhet" ;
  optoelektronik_nn_1_N = mkN "optoelektronik" ;
  opublicerbarhet_nn_1_N = mkN "opublicerbarhet" ;
  opulens_nn_1_N = mkN "opulens" ;
  opulveriserbarhet_nn_1_N = mkN "opulveriserbarhet" ;
  opulvriserbarhet_nn_1_N = mkN "opulvriserbarhet" ;
  opunkterbarhet_nn_1_N = mkN "opunkterbarhet" ;
  opurgerbarhet_nn_1_N = mkN "opurgerbarhet" ;
  opaaannonserbarhet_nn_1_1_N = mkN "opåannonserbarhet" ;
  opaalitlighet_nn_1_1_N = mkN "opålitlighet" ;
  opaaverkbarhet_nn_1_1_N = mkN "opåverkbarhet" ;
  orabatterbarhet_nn_1_N = mkN "orabatterbarhet" ;
  oraderbarhet_nn_1_N = mkN "oraderbarhet" ;
  oradierbarhet_nn_1_N = mkN "oradierbarhet" ;
  oradikaliserbarhet_nn_1_N = mkN "oradikaliserbarhet" ;
  oraffinerbarhet_nn_1_N = mkN "oraffinerbarhet" ;
  oramponerbarhet_nn_1_N = mkN "oramponerbarhet" ;
  orangerbarhet_nn_1_N = mkN "orangerbarhet" ;
  oransonerbarhet_nn_1_N = mkN "oransonerbarhet" ;
  orappellerbarhet_nn_1_N = mkN "orappellerbarhet" ;
  orapporterbarhet_nn_1_N = mkN "orapporterbarhet" ;
  oraserbarhet_nn_1_N = mkN "oraserbarhet" ;
  oratificerbarhet_nn_1_N = mkN "oratificerbarhet" ;
  orationaliserbarhet_nn_1_N = mkN "orationaliserbarhet" ;
  ordagrannhet_nn_1_N = mkN "ordagrannhet" ;
  orddoevhet_nn_1_1_N = mkN "orddövhet" ;
  ordentlighet_nn_1_N = mkN "ordentlighet" ;
  ordfattighet_nn_1_N = mkN "ordfattighet" ;
  ordhaallighet_nn_1_1_N = mkN "ordhållighet" ;
  ordinerbarhet_nn_1_N = mkN "ordinerbarhet" ;
  ordkarghet_nn_1_N = mkN "ordkarghet" ;
  ordknapphet_nn_1_N = mkN "ordknapphet" ;
  ordloeshet_nn_1_1_N = mkN "ordlöshet" ;
  ordningsamhet_nn_1_N = mkN "ordningsamhet" ;
  ordningsbot_nn_1_N = mkN "ordningsbot" ;
  ordningsmakt_nn_1_N = mkN "ordningsmakt" ;
  ordningspolis_nn_1_N = mkN "ordningspolis" ;
  ordrikhet_nn_1_N = mkN "ordrikhet" ;
  ordsemantik_nn_1_N = mkN "ordsemantik" ;
  ordstumhet_nn_1_N = mkN "ordstumhet" ;
  oreaktiverbarhet_nn_1_N = mkN "oreaktiverbarhet" ;
  orealiserbarhet_nn_1_N = mkN "orealiserbarhet" ;
  oreassurerbarhet_nn_1_N = mkN "oreassurerbarhet" ;
  orecenserbarhet_nn_1_N = mkN "orecenserbarhet" ;
  orecipierbarhet_nn_1_N = mkN "orecipierbarhet" ;
  oreciterbarhet_nn_1_N = mkN "oreciterbarhet" ;
  oredigerbarhet_nn_1_N = mkN "oredigerbarhet" ;
  oredighet_nn_1_N = mkN "oredighet" ;
  oreducerbarhet_nn_1_N = mkN "oreducerbarhet" ;
  orefererbarhet_nn_1_N = mkN "orefererbarhet" ;
  oreflekterbarhet_nn_1_N = mkN "oreflekterbarhet" ;
  oreformerbarhet_nn_1_N = mkN "oreformerbarhet" ;
  orefuserbarhet_nn_1_N = mkN "orefuserbarhet" ;
  oregalerbarhet_nn_1_N = mkN "oregalerbarhet" ;
  oregenererbarhet_nn_1_N = mkN "oregenererbarhet" ;
  oregerbarhet_nn_1_N = mkN "oregerbarhet" ;
  oregerlighet_nn_1_N = mkN "oregerlighet" ;
  oregisserbarhet_nn_1_N = mkN "oregisserbarhet" ;
  oregistrerbarhet_nn_1_N = mkN "oregistrerbarhet" ;
  oreglementerbarhet_nn_1_N = mkN "oreglementerbarhet" ;
  oreglerbarhet_nn_1_N = mkN "oreglerbarhet" ;
  oregummerbarhet_nn_1_N = mkN "oregummerbarhet" ;
  orehabiliterbarhet_nn_1_N = mkN "orehabiliterbarhet" ;
  oreinkarnerbarhet_nn_1_N = mkN "oreinkarnerbarhet" ;
  orekapitulerbarhet_nn_1_N = mkN "orekapitulerbarhet" ;
  oreklamerbarhet_nn_1_N = mkN "oreklamerbarhet" ;
  orekognoscerbarhet_nn_1_N = mkN "orekognoscerbarhet" ;
  orekognoserbarhet_nn_1_N = mkN "orekognoserbarhet" ;
  orekommenderbarhet_nn_1_N = mkN "orekommenderbarhet" ;
  orekompenserbarhet_nn_1_N = mkN "orekompenserbarhet" ;
  orekonstruerbarhet_nn_1_N = mkN "orekonstruerbarhet" ;
  orekryterbarhet_nn_1_N = mkN "orekryterbarhet" ;
  orektificerbarhet_nn_1_N = mkN "orektificerbarhet" ;
  orektifierbarhet_nn_1_N = mkN "orektifierbarhet" ;
  orekvirerbarhet_nn_1_N = mkN "orekvirerbarhet" ;
  orelaterbarhet_nn_1_N = mkN "orelaterbarhet" ;
  orelegerbarhet_nn_1_N = mkN "orelegerbarhet" ;
  oremitterbarhet_nn_1_N = mkN "oremitterbarhet" ;
  oremplacerbarhet_nn_1_N = mkN "oremplacerbarhet" ;
  orenderbarhet_nn_1_N = mkN "orenderbarhet" ;
  orenoverbarhet_nn_1_N = mkN "orenoverbarhet" ;
  oreorganiserbarhet_nn_1_N = mkN "oreorganiserbarhet" ;
  oreparerbarhet_nn_1_N = mkN "oreparerbarhet" ;
  orepartiserbarhet_nn_1_N = mkN "orepartiserbarhet" ;
  orepatrierbarhet_nn_1_N = mkN "orepatrierbarhet" ;
  orepellerbarhet_nn_1_N = mkN "orepellerbarhet" ;
  orepeterbarhet_nn_1_N = mkN "orepeterbarhet" ;
  orepresenterbarhet_nn_1_N = mkN "orepresenterbarhet" ;
  orepriserbarhet_nn_1_N = mkN "orepriserbarhet" ;
  oreproducerbarhet_nn_1_N = mkN "oreproducerbarhet" ;
  oreserverbarhet_nn_1_N = mkN "oreserverbarhet" ;
  oresolverbarhet_nn_1_N = mkN "oresolverbarhet" ;
  oresonlighet_nn_1_N = mkN "oresonlighet" ;
  oresorberbarhet_nn_1_N = mkN "oresorberbarhet" ;
  orespekterbarhet_nn_1_N = mkN "orespekterbarhet" ;
  orespirerbarhet_nn_1_N = mkN "orespirerbarhet" ;
  orestaurerbarhet_nn_1_N = mkN "orestaurerbarhet" ;
  orestituerbarhet_nn_1_N = mkN "orestituerbarhet" ;
  oresumerbarhet_nn_1_N = mkN "oresumerbarhet" ;
  oretablerbarhet_nn_1_N = mkN "oretablerbarhet" ;
  oretarderbarhet_nn_1_N = mkN "oretarderbarhet" ;
  oreturnerbarhet_nn_1_N = mkN "oreturnerbarhet" ;
  oretuscherbarhet_nn_1_N = mkN "oretuscherbarhet" ;
  orevalverbarhet_nn_1_N = mkN "orevalverbarhet" ;
  oreveterbarhet_nn_1_N = mkN "oreveterbarhet" ;
  oreviderbarhet_nn_1_N = mkN "oreviderbarhet" ;
  orevolutionerbarhet_nn_1_N = mkN "orevolutionerbarhet" ;
  organisation_nn_2_N = mkN "organisation" ;
  organiserbarhet_nn_1_N = mkN "organiserbarhet" ;
  orgelmusik_nn_1_N = mkN "orgelmusik" ;
  orgelpunkt_nn_1_N = mkN "orgelpunkt" ;
  orgiasm_nn_1_N = mkN "orgiasm" ;
  orient_nn_1_N = mkN "orient" ;
  orientalistik_nn_1_N = mkN "orientalistik" ;
  orienterbarhet_nn_1_N = mkN "orienterbarhet" ;
  oritualiserbarhet_nn_1_N = mkN "oritualiserbarhet" ;
  ork_nn_1_N = mkN "ork" ;
  orkesloeshet_nn_1_1_N = mkN "orkeslöshet" ;
  orkestermusik_nn_1_N = mkN "orkestermusik" ;
  orkestik_nn_1_N = mkN "orkestik" ;
  orkestrerbarhet_nn_1_N = mkN "orkestrerbarhet" ;
  orkloeshet_nn_1_1_N = mkN "orklöshet" ;
  ormrot_nn_1_N = mkN "ormrot" ;
  ornamenterbarhet_nn_1_N = mkN "ornamenterbarhet" ;
  ornamentik_nn_1_N = mkN "ornamentik" ;
  ornerbarhet_nn_1_N = mkN "ornerbarhet" ;
  orobotiserbarhet_nn_1_N = mkN "orobotiserbarhet" ;
  orockerbarhet_nn_1_N = mkN "orockerbarhet" ;
  orogenes_nn_1_N = mkN "orogenes" ;
  oromantiserbarhet_nn_1_N = mkN "oromantiserbarhet" ;
  oroterbarhet_nn_1_N = mkN "oroterbarhet" ;
  orsaklighet_nn_1_N = mkN "orsaklighet" ;
  orsaksbestaemdhet_nn_1_1_N = mkN "orsaksbestämdhet" ;
  orsaksmaessighet_nn_1_1_N = mkN "orsaksmässighet" ;
  orselj_nn_1_N = mkN "orselj" ;
  ortodoxhet_nn_1_N = mkN "ortodoxhet" ;
  ortoklas_nn_1_N = mkN "ortoklas" ;
  orubblighet_nn_1_N = mkN "orubblighet" ;
  orubricerbarhet_nn_1_N = mkN "orubricerbarhet" ;
  oruinerbarhet_nn_1_N = mkN "oruinerbarhet" ;
  orundhet_nn_1_N = mkN "orundhet" ;
  orussificerbarhet_nn_1_N = mkN "orussificerbarhet" ;
  orussifierbarhet_nn_1_N = mkN "orussifierbarhet" ;
  orygglighet_nn_1_N = mkN "orygglighet" ;
  orytmiserbarhet_nn_1_N = mkN "orytmiserbarhet" ;
  oraeddhet_nn_1_1_N = mkN "oräddhet" ;
  oraeknelighet_nn_1_1_N = mkN "oräknelighet" ;
  oraettmaetighet_nn_1_1_N = mkN "orättmätighet" ;
  oraettraadighet_nn_1_1_N = mkN "orättrådighet" ;
  oroerbarhet_nn_1_1_N = mkN "orörbarhet" ;
  oroerdhet_nn_1_1_N = mkN "orördhet" ;
  oroerlighet_nn_1_1_N = mkN "orörlighet" ;
  osaboterbarhet_nn_1_N = mkN "osaboterbarhet" ;
  osabrerbarhet_nn_1_N = mkN "osabrerbarhet" ;
  osakkunnighet_nn_1_N = mkN "osakkunnighet" ;
  osalderbarhet_nn_1_N = mkN "osalderbarhet" ;
  osalighet_nn_1_N = mkN "osalighet" ;
  osaluterbarhet_nn_1_N = mkN "osaluterbarhet" ;
  osamtaxerbarhet_nn_1_N = mkN "osamtaxerbarhet" ;
  osanerbarhet_nn_1_N = mkN "osanerbarhet" ;
  osanforiserbarhet_nn_1_N = mkN "osanforiserbarhet" ;
  osanktifierbarhet_nn_1_N = mkN "osanktifierbarhet" ;
  osanktionerbarhet_nn_1_N = mkN "osanktionerbarhet" ;
  osannfaerdighet_nn_1_1_N = mkN "osannfärdighet" ;
  osannolikhet_nn_1_N = mkN "osannolikhet" ;
  osaponifierbarhet_nn_1_N = mkN "osaponifierbarhet" ;
  osatinerbarhet_nn_1_N = mkN "osatinerbarhet" ;
  osatisfierbarhet_nn_1_N = mkN "osatisfierbarhet" ;
  osaturerbarhet_nn_1_N = mkN "osaturerbarhet" ;
  osauterbarhet_nn_1_N = mkN "osauterbarhet" ;
  osauverbarhet_nn_1_N = mkN "osauverbarhet" ;
  oschablonerbarhet_nn_1_N = mkN "oschablonerbarhet" ;
  oschabloniserbarhet_nn_1_N = mkN "oschabloniserbarhet" ;
  oschamponerbarhet_nn_1_N = mkN "oschamponerbarhet" ;
  oschatterbarhet_nn_1_N = mkN "oschatterbarhet" ;
  oschematiserbarhet_nn_1_N = mkN "oschematiserbarhet" ;
  osedimenterbarhet_nn_1_N = mkN "osedimenterbarhet" ;
  osedvanlighet_nn_1_N = mkN "osedvanlighet" ;
  osegmenterbarhet_nn_1_N = mkN "osegmenterbarhet" ;
  osegregerbarhet_nn_1_N = mkN "osegregerbarhet" ;
  osekonderbarhet_nn_1_N = mkN "osekonderbarhet" ;
  osekulariserbarhet_nn_1_N = mkN "osekulariserbarhet" ;
  osekunderbarhet_nn_1_N = mkN "osekunderbarhet" ;
  osekvestrerbarhet_nn_1_N = mkN "osekvestrerbarhet" ;
  oselekterbarhet_nn_1_N = mkN "oselekterbarhet" ;
  osemaforerbarhet_nn_1_N = mkN "osemaforerbarhet" ;
  oseminerbarhet_nn_1_N = mkN "oseminerbarhet" ;
  osensibiliserbarhet_nn_1_N = mkN "osensibiliserbarhet" ;
  osenterbarhet_nn_1_N = mkN "osenterbarhet" ;
  oseparerbarhet_nn_1_N = mkN "oseparerbarhet" ;
  oserverbarhet_nn_1_N = mkN "oserverbarhet" ;
  osexualiserbarhet_nn_1_N = mkN "osexualiserbarhet" ;
  oshamponerbarhet_nn_1_N = mkN "oshamponerbarhet" ;
  osigillerbarhet_nn_1_N = mkN "osigillerbarhet" ;
  osignalerbarhet_nn_1_N = mkN "osignalerbarhet" ;
  osignerbarhet_nn_1_N = mkN "osignerbarhet" ;
  osiktbarhet_nn_1_N = mkN "osiktbarhet" ;
  osiktighet_nn_1_N = mkN "osiktighet" ;
  osilhuetterbarhet_nn_1_N = mkN "osilhuetterbarhet" ;
  osiluetterbarhet_nn_1_N = mkN "osiluetterbarhet" ;
  osimplifierbarhet_nn_1_N = mkN "osimplifierbarhet" ;
  osimulerbarhet_nn_1_N = mkN "osimulerbarhet" ;
  osinlighet_nn_1_N = mkN "osinlighet" ;
  osinnlighet_nn_1_N = mkN "osinnlighet" ;
  osis_nn_1_N = mkN "osis" ;
  oskadlighet_nn_1_N = mkN "oskadlighet" ;
  oskalperbarhet_nn_1_N = mkN "oskalperbarhet" ;
  oskandaliserbarhet_nn_1_N = mkN "oskandaliserbarhet" ;
  oskanderbarhet_nn_1_N = mkN "oskanderbarhet" ;
  oskaplighet_nn_1_N = mkN "oskaplighet" ;
  oskarphet_nn_1_N = mkN "oskarphet" ;
  oskattbarhet_nn_1_N = mkN "oskattbarhet" ;
  oskicklighet_nn_1_N = mkN "oskicklighet" ;
  oskisserbarhet_nn_1_N = mkN "oskisserbarhet" ;
  oskrafferbarhet_nn_1_N = mkN "oskrafferbarhet" ;
  oskuldsfullhet_nn_1_N = mkN "oskuldsfullhet" ;
  oskulpterbarhet_nn_1_N = mkN "oskulpterbarhet" ;
  oskulpturerbarhet_nn_1_N = mkN "oskulpturerbarhet" ;
  oskyldighet_nn_1_N = mkN "oskyldighet" ;
  oskaelighet_nn_1_1_N = mkN "oskälighet" ;
  oskoenhet_nn_1_1_N = mkN "oskönhet" ;
  oslagbarhet_nn_1_N = mkN "oslagbarhet" ;
  oslaviserbarhet_nn_1_N = mkN "oslaviserbarhet" ;
  oslaecklighet_nn_1_1_N = mkN "osläcklighet" ;
  osmak_nn_1_N = mkN "osmak" ;
  osmidbarhet_nn_1_N = mkN "osmidbarhet" ;
  osmos_nn_1_N = mkN "osmos" ;
  osmund_nn_1_N = mkN "osmund" ;
  osmaeltbarhet_nn_1_1_N = mkN "osmältbarhet" ;
  osnedrekryterbarhet_nn_1_N = mkN "osnedrekryterbarhet" ;
  osnygghet_nn_1_N = mkN "osnygghet" ;
  osocialiserbarhet_nn_1_N = mkN "osocialiserbarhet" ;
  osolverbarhet_nn_1_N = mkN "osolverbarhet" ;
  osonderbarhet_nn_1_N = mkN "osonderbarhet" ;
  osordinerbarhet_nn_1_N = mkN "osordinerbarhet" ;
  osorterbarhet_nn_1_N = mkN "osorterbarhet" ;
  osoulagerbarhet_nn_1_N = mkN "osoulagerbarhet" ;
  osovjetiserbarhet_nn_1_N = mkN "osovjetiserbarhet" ;
  ospaljerbarhet_nn_1_N = mkN "ospaljerbarhet" ;
  ospallerbarhet_nn_1_N = mkN "ospallerbarhet" ;
  ospecialiserbarhet_nn_1_N = mkN "ospecialiserbarhet" ;
  ospecificerbarhet_nn_1_N = mkN "ospecificerbarhet" ;
  ospeciminerbarhet_nn_1_N = mkN "ospeciminerbarhet" ;
  ospekulerbarhet_nn_1_N = mkN "ospekulerbarhet" ;
  ospelbarhet_nn_1_N = mkN "ospelbarhet" ;
  ospenderbarhet_nn_1_N = mkN "ospenderbarhet" ;
  ospolierbarhet_nn_1_N = mkN "ospolierbarhet" ;
  ost_nn_2_N = mkN "ost" ;
  ostabiliserbarhet_nn_1_N = mkN "ostabiliserbarhet" ;
  ostadighet_nn_1_N = mkN "ostadighet" ;
  ostafferbarhet_nn_1_N = mkN "ostafferbarhet" ;
  ostan_nn_1_N = mkN "ostan" ;
  ostandardiserbarhet_nn_1_N = mkN "ostandardiserbarhet" ;
  ostationerbarhet_nn_1_N = mkN "ostationerbarhet" ;
  ostatuerbarhet_nn_1_N = mkN "ostatuerbarhet" ;
  ostencilerbarhet_nn_1_N = mkN "ostencilerbarhet" ;
  ostenograferbarhet_nn_1_N = mkN "ostenograferbarhet" ;
  ostereotyperbarhet_nn_1_N = mkN "ostereotyperbarhet" ;
  osteriliserbarhet_nn_1_N = mkN "osteriliserbarhet" ;
  osthyvelsprincip_nn_1_N = mkN "osthyvelsprincip" ;
  ostighet_nn_1_N = mkN "ostighet" ;
  ostigmatiserbarhet_nn_1_N = mkN "ostigmatiserbarhet" ;
  ostiliserbarhet_nn_1_N = mkN "ostiliserbarhet" ;
  ostimulerbarhet_nn_1_N = mkN "ostimulerbarhet" ;
  ostipendierbarhet_nn_1_N = mkN "ostipendierbarhet" ;
  ostipulerbarhet_nn_1_N = mkN "ostipulerbarhet" ;
  ostofferbarhet_nn_1_N = mkN "ostofferbarhet" ;
  ostrafflighet_nn_1_N = mkN "ostrafflighet" ;
  ostrangulerbarhet_nn_1_N = mkN "ostrangulerbarhet" ;
  ostratifierbarhet_nn_1_N = mkN "ostratifierbarhet" ;
  ostridighet_nn_1_N = mkN "ostridighet" ;
  ostronoert_nn_1_1_N = mkN "ostronört" ;
  ostrukturerbarhet_nn_1_N = mkN "ostrukturerbarhet" ;
  ostuderbarhet_nn_1_N = mkN "ostuderbarhet" ;
  ostyrighet_nn_1_N = mkN "ostyrighet" ;
  ostaemdhet_nn_1_1_N = mkN "ostämdhet" ;
  ostoerdhet_nn_1_1_N = mkN "ostördhet" ;
  osublimerbarhet_nn_1_N = mkN "osublimerbarhet" ;
  osubordinerbarhet_nn_1_N = mkN "osubordinerbarhet" ;
  osubsidierbarhet_nn_1_N = mkN "osubsidierbarhet" ;
  osubskriberbarhet_nn_1_N = mkN "osubskriberbarhet" ;
  osubstantiverbarhet_nn_1_N = mkN "osubstantiverbarhet" ;
  osubstituerbarhet_nn_1_N = mkN "osubstituerbarhet" ;
  osubsumerbarhet_nn_1_N = mkN "osubsumerbarhet" ;
  osubtraherbarhet_nn_1_N = mkN "osubtraherbarhet" ;
  osubventionerbarhet_nn_1_N = mkN "osubventionerbarhet" ;
  osuccederbarhet_nn_1_N = mkN "osuccederbarhet" ;
  osuffigerbarhet_nn_1_N = mkN "osuffigerbarhet" ;
  osufflerbarhet_nn_1_N = mkN "osufflerbarhet" ;
  osuggererbarhet_nn_1_N = mkN "osuggererbarhet" ;
  osummerbarhet_nn_1_N = mkN "osummerbarhet" ;
  osupplerbarhet_nn_1_N = mkN "osupplerbarhet" ;
  osupponerbarhet_nn_1_N = mkN "osupponerbarhet" ;
  osurfbarhet_nn_1_N = mkN "osurfbarhet" ;
  osuspenderbarhet_nn_1_N = mkN "osuspenderbarhet" ;
  osviklighet_nn_1_N = mkN "osviklighet" ;
  osymboliserbarhet_nn_1_N = mkN "osymboliserbarhet" ;
  osynkoperbarhet_nn_1_N = mkN "osynkoperbarhet" ;
  osynkroniserbarhet_nn_1_N = mkN "osynkroniserbarhet" ;
  osyntetiserbarhet_nn_1_N = mkN "osyntetiserbarhet" ;
  osystematiserbarhet_nn_1_N = mkN "osystematiserbarhet" ;
  osaegbarhet_nn_1_1_N = mkN "osägbarhet" ;
  osaeglighet_nn_1_1_N = mkN "osäglighet" ;
  osaeljbarhet_nn_1_1_N = mkN "osäljbarhet" ;
  osaellhet_nn_1_1_N = mkN "osällhet" ;
  osaellskaplighet_nn_1_1_N = mkN "osällskaplighet" ;
  osaenkbarhet_nn_1_1_N = mkN "osänkbarhet" ;
  osaarbarhet_nn_1_1_N = mkN "osårbarhet" ;
  osaaterbarhet_nn_1_1_N = mkN "osåterbarhet" ;
  osaaverbarhet_nn_1_1_N = mkN "osåverbarhet" ;
  osoekthet_nn_1_1_N = mkN "osökthet" ;
  otabellerbarhet_nn_1_N = mkN "otabellerbarhet" ;
  otabuerbarhet_nn_1_N = mkN "otabuerbarhet" ;
  otacksamhet_nn_1_N = mkN "otacksamhet" ;
  otadlighet_nn_1_N = mkN "otadlighet" ;
  otalighet_nn_1_N = mkN "otalighet" ;
  otamponerbarhet_nn_1_N = mkN "otamponerbarhet" ;
  otangerbarhet_nn_1_N = mkN "otangerbarhet" ;
  otapetserbarhet_nn_1_N = mkN "otapetserbarhet" ;
  otarerbarhet_nn_1_N = mkN "otarerbarhet" ;
  otarifferbarhet_nn_1_N = mkN "otarifferbarhet" ;
  otatuerbarhet_nn_1_N = mkN "otatuerbarhet" ;
  otaxerbarhet_nn_1_N = mkN "otaxerbarhet" ;
  oteknifierbarhet_nn_1_N = mkN "oteknifierbarhet" ;
  otelefonerbarhet_nn_1_N = mkN "otelefonerbarhet" ;
  otelegraferbarhet_nn_1_N = mkN "otelegraferbarhet" ;
  oteleviserbarhet_nn_1_N = mkN "oteleviserbarhet" ;
  otemperbarhet_nn_1_N = mkN "otemperbarhet" ;
  otempererbarhet_nn_1_N = mkN "otempererbarhet" ;
  otenterbarhet_nn_1_N = mkN "otenterbarhet" ;
  oterrasserbarhet_nn_1_N = mkN "oterrasserbarhet" ;
  oterroriserbarhet_nn_1_N = mkN "oterroriserbarhet" ;
  otesaurerbarhet_nn_1_N = mkN "otesaurerbarhet" ;
  otestamenterbarhet_nn_1_N = mkN "otestamenterbarhet" ;
  otillfoerlitlighet_nn_1_1_N = mkN "otillförlitlighet" ;
  otillraecklighet_nn_1_1_N = mkN "otillräcklighet" ;
  otillraeknelighet_nn_1_1_N = mkN "otillräknelighet" ;
  otillstaendighet_nn_1_1_N = mkN "otillständighet" ;
  otillaemplighet_nn_1_1_N = mkN "otillämplighet" ;
  otillaatlighet_nn_1_1_N = mkN "otillåtlighet" ;
  otitrerbarhet_nn_1_N = mkN "otitrerbarhet" ;
  otitulerbarhet_nn_1_N = mkN "otitulerbarhet" ;
  otjusighet_nn_1_N = mkN "otjusighet" ;
  otjaenlighet_nn_1_1_N = mkN "otjänlighet" ;
  otolererbarhet_nn_1_N = mkN "otolererbarhet" ;
  otorderbarhet_nn_1_N = mkN "otorderbarhet" ;
  otorpederbarhet_nn_1_N = mkN "otorpederbarhet" ;
  otorterbarhet_nn_1_N = mkN "otorterbarhet" ;
  otoucherbarhet_nn_1_N = mkN "otoucherbarhet" ;
  otouperbarhet_nn_1_N = mkN "otouperbarhet" ;
  otraderbarhet_nn_1_N = mkN "otraderbarhet" ;
  otrafikerbarhet_nn_1_N = mkN "otrafikerbarhet" ;
  otrakasserbarhet_nn_1_N = mkN "otrakasserbarhet" ;
  otrakterbarhet_nn_1_N = mkN "otrakterbarhet" ;
  otrancherbarhet_nn_1_N = mkN "otrancherbarhet" ;
  otransfererbarhet_nn_1_N = mkN "otransfererbarhet" ;
  otransformerbarhet_nn_1_N = mkN "otransformerbarhet" ;
  otransiterbarhet_nn_1_N = mkN "otransiterbarhet" ;
  otranskriberbarhet_nn_1_N = mkN "otranskriberbarhet" ;
  otranslittererbarhet_nn_1_N = mkN "otranslittererbarhet" ;
  otransmitterbarhet_nn_1_N = mkN "otransmitterbarhet" ;
  otransmuterbarhet_nn_1_N = mkN "otransmuterbarhet" ;
  otransplanterbarhet_nn_1_N = mkN "otransplanterbarhet" ;
  otransponerbarhet_nn_1_N = mkN "otransponerbarhet" ;
  otransporterbarhet_nn_1_N = mkN "otransporterbarhet" ;
  otransumerbarhet_nn_1_N = mkN "otransumerbarhet" ;
  otrasserbarhet_nn_1_N = mkN "otrasserbarhet" ;
  otravesterbarhet_nn_1_N = mkN "otravesterbarhet" ;
  otrepanerbarhet_nn_1_N = mkN "otrepanerbarhet" ;
  otriangulerbarhet_nn_1_N = mkN "otriangulerbarhet" ;
  otrierbarhet_nn_1_N = mkN "otrierbarhet" ;
  otrivialiserbarhet_nn_1_N = mkN "otrivialiserbarhet" ;
  otrivsamhet_nn_1_N = mkN "otrivsamhet" ;
  otryfferbarhet_nn_1_N = mkN "otryfferbarhet" ;
  otrygghet_nn_1_N = mkN "otrygghet" ;
  otroestlighet_nn_1_1_N = mkN "otröstlighet" ;
  otroettlighet_nn_1_1_N = mkN "otröttlighet" ;
  ottesaang_nn_1_1_N = mkN "ottesång" ;
  otukt_nn_1_N = mkN "otukt" ;
  otuperbarhet_nn_1_N = mkN "otuperbarhet" ;
  otur_nn_1_N = mkN "otur" ;
  oturlighet_nn_1_N = mkN "oturlighet" ;
  oturnerbarhet_nn_1_N = mkN "oturnerbarhet" ;
  otursamhet_nn_1_N = mkN "otursamhet" ;
  otursfoerfoeljdhet_nn_1_1_N = mkN "otursförföljdhet" ;
  otuscherbarhet_nn_1_N = mkN "otuscherbarhet" ;
  otvetydighet_nn_1_N = mkN "otvetydighet" ;
  otvivelaktighet_nn_1_N = mkN "otvivelaktighet" ;
  otvungenhet_nn_1_N = mkN "otvungenhet" ;
  otydbarhet_nn_1_N = mkN "otydbarhet" ;
  otypifierbarhet_nn_1_N = mkN "otypifierbarhet" ;
  otypiserbarhet_nn_1_N = mkN "otypiserbarhet" ;
  otyranniserbarhet_nn_1_N = mkN "otyranniserbarhet" ;
  otaemjbarhet_nn_1_1_N = mkN "otämjbarhet" ;
  otaenjbarhet_nn_1_1_N = mkN "otänjbarhet" ;
  otaenkbarhet_nn_1_1_N = mkN "otänkbarhet" ;
  otaalighet_nn_1_1_N = mkN "otålighet" ;
  otoerstighet_nn_1_1_N = mkN "otörstighet" ;
  oumbaerlighet_nn_1_1_N = mkN "oumbärlighet" ;
  ounderbalanserbarhet_nn_1_N = mkN "ounderbalanserbarhet" ;
  ounderdimensionerbarhet_nn_1_N = mkN "ounderdimensionerbarhet" ;
  ounderexponerbarhet_nn_1_N = mkN "ounderexponerbarhet" ;
  ounderminerbarhet_nn_1_N = mkN "ounderminerbarhet" ;
  oundertaxerbarhet_nn_1_N = mkN "oundertaxerbarhet" ;
  oundervaerderbarhet_nn_1_1_N = mkN "oundervärderbarhet" ;
  oundgaenglighet_nn_1_1_N = mkN "oundgänglighet" ;
  oundviklighet_nn_1_N = mkN "oundviklighet" ;
  ounifierbarhet_nn_1_N = mkN "ounifierbarhet" ;
  ouniformerbarhet_nn_1_N = mkN "ouniformerbarhet" ;
  ouppdaterbarhet_nn_1_N = mkN "ouppdaterbarhet" ;
  ouppfattbarhet_nn_1_N = mkN "ouppfattbarhet" ;
  ouppgraderbarhet_nn_1_N = mkN "ouppgraderbarhet" ;
  oupphinnelighet_nn_1_N = mkN "oupphinnelighet" ;
  oupphoerlighet_nn_1_1_N = mkN "oupphörlighet" ;
  ouppjusterbarhet_nn_1_N = mkN "ouppjusterbarhet" ;
  oupplysthet_nn_1_N = mkN "oupplysthet" ;
  oupploeslighet_nn_1_1_N = mkN "oupplöslighet" ;
  ouppmaerksamhet_nn_1_1_N = mkN "ouppmärksamhet" ;
  ouppnaaelighet_nn_1_1_N = mkN "ouppnåelighet" ;
  ouppreklamerbarhet_nn_1_N = mkN "ouppreklamerbarhet" ;
  ouppraeknelighet_nn_1_1_N = mkN "ouppräknelighet" ;
  ouppskattbarhet_nn_1_N = mkN "ouppskattbarhet" ;
  ouppsummerbarhet_nn_1_N = mkN "ouppsummerbarhet" ;
  ouppsaegbarhet_nn_1_1_N = mkN "ouppsägbarhet" ;
  ouppsaatlighet_nn_1_1_N = mkN "ouppsåtlighet" ;
  oupptaxerbarhet_nn_1_N = mkN "oupptaxerbarhet" ;
  ouppvaerderbarhet_nn_1_1_N = mkN "ouppvärderbarhet" ;
  ourbaniserbarhet_nn_1_N = mkN "ourbaniserbarhet" ;
  oursaektlighet_nn_1_1_N = mkN "oursäktlighet" ;
  ousurperbarhet_nn_1_N = mkN "ousurperbarhet" ;
  outackorderbarhet_nn_1_N = mkN "outackorderbarhet" ;
  outannonserbarhet_nn_1_N = mkN "outannonserbarhet" ;
  outarrenderbarhet_nn_1_N = mkN "outarrenderbarhet" ;
  outbalanserbarhet_nn_1_N = mkN "outbalanserbarhet" ;
  outbasunerbarhet_nn_1_N = mkN "outbasunerbarhet" ;
  outbroderbarhet_nn_1_N = mkN "outbroderbarhet" ;
  outdebiterbarhet_nn_1_N = mkN "outdebiterbarhet" ;
  outexaminerbarhet_nn_1_N = mkN "outexaminerbarhet" ;
  outexperimenterbarhet_nn_1_N = mkN "outexperimenterbarhet" ;
  outfoerbarhet_nn_1_1_N = mkN "outförbarhet" ;
  outgrundlighet_nn_1_N = mkN "outgrundlighet" ;
  outhaerdlighet_nn_1_1_N = mkN "outhärdlighet" ;
  outklarerbarhet_nn_1_N = mkN "outklarerbarhet" ;
  outkommenderbarhet_nn_1_N = mkN "outkommenderbarhet" ;
  outkonkurrerbarhet_nn_1_N = mkN "outkonkurrerbarhet" ;
  outkristalliserbarhet_nn_1_N = mkN "outkristalliserbarhet" ;
  outkvitterbarhet_nn_1_N = mkN "outkvitterbarhet" ;
  outlokaliserbarhet_nn_1_N = mkN "outlokaliserbarhet" ;
  outmanoevrerbarhet_nn_1_1_N = mkN "outmanövrerbarhet" ;
  outminuterbarhet_nn_1_N = mkN "outminuterbarhet" ;
  outplacerbarhet_nn_1_N = mkN "outplacerbarhet" ;
  outplaanlighet_nn_1_1_N = mkN "outplånlighet" ;
  outposterbarhet_nn_1_N = mkN "outposterbarhet" ;
  output_nn_1_N = mkN "output" ;
  outraderbarhet_nn_1_N = mkN "outraderbarhet" ;
  outrangerbarhet_nn_1_N = mkN "outrangerbarhet" ;
  outrannsaklighet_nn_1_N = mkN "outrannsaklighet" ;
  outrotlighet_nn_1_N = mkN "outrotlighet" ;
  outsagdhet_nn_1_N = mkN "outsagdhet" ;
  outsinlighet_nn_1_N = mkN "outsinlighet" ;
  outslitlighet_nn_1_N = mkN "outslitlighet" ;
  outslaecklighet_nn_1_1_N = mkN "outsläcklighet" ;
  outstofferbarhet_nn_1_N = mkN "outstofferbarhet" ;
  outsaegbarhet_nn_1_1_N = mkN "outsägbarhet" ;
  outsaeglighet_nn_1_1_N = mkN "outsäglighet" ;
  outtalbarhet_nn_1_N = mkN "outtalbarhet" ;
  outtaxerbarhet_nn_1_N = mkN "outtaxerbarhet" ;
  outtroettlighet_nn_1_1_N = mkN "outtröttlighet" ;
  outtoemlighet_nn_1_1_N = mkN "outtömlighet" ;
  outvaerderbarhet_nn_1_1_N = mkN "outvärderbarhet" ;
  ovaccinerbarhet_nn_1_N = mkN "ovaccinerbarhet" ;
  ovadderbarhet_nn_1_N = mkN "ovadderbarhet" ;
  ovaksinerbarhet_nn_1_N = mkN "ovaksinerbarhet" ;
  ovaluterbarhet_nn_1_N = mkN "ovaluterbarhet" ;
  ovalverbarhet_nn_1_N = mkN "ovalverbarhet" ;
  ovandaliserbarhet_nn_1_N = mkN "ovandaliserbarhet" ;
  ovansklighet_nn_1_N = mkN "ovansklighet" ;
  ovarierbarhet_nn_1_N = mkN "ovarierbarhet" ;
  ovarsamhet_nn_1_N = mkN "ovarsamhet" ;
  ovederhaeftighet_nn_1_1_N = mkN "ovederhäftighet" ;
  ovederlaegglighet_nn_1_1_N = mkN "ovederlägglighet" ;
  ovedersaeglighet_nn_1_1_N = mkN "ovedersäglighet" ;
  ovelouriserbarhet_nn_1_N = mkN "ovelouriserbarhet" ;
  oventilerbarhet_nn_1_N = mkN "oventilerbarhet" ;
  overbaliserbarhet_nn_1_N = mkN "overbaliserbarhet" ;
  overhead_nn_1_N = mkN "overhead" ;
  overifierbarhet_nn_1_N = mkN "overifierbarhet" ;
  overklighet_nn_1_N = mkN "overklighet" ;
  oversifierbarhet_nn_1_N = mkN "oversifierbarhet" ;
  ovetbarhet_nn_1_N = mkN "ovetbarhet" ;
  ovetenskaplighet_nn_1_N = mkN "ovetenskaplighet" ;
  ovetskap_nn_1_N = mkN "ovetskap" ;
  ovidimerbarhet_nn_1_N = mkN "ovidimerbarhet" ;
  ovighet_nn_1_N = mkN "ovighet" ;
  oviktighet_nn_1_N = mkN "oviktighet" ;
  ovillighet_nn_1_N = mkN "ovillighet" ;
  ovillkorlighet_nn_1_N = mkN "ovillkorlighet" ;
  ovindicerbarhet_nn_1_N = mkN "ovindicerbarhet" ;
  oviserbarhet_nn_1_N = mkN "oviserbarhet" ;
  ovishet_nn_1_N = mkN "ovishet" ;
  ovisiterbarhet_nn_1_N = mkN "ovisiterbarhet" ;
  ovisualiserbarhet_nn_1_N = mkN "ovisualiserbarhet" ;
  ovitaliserbarhet_nn_1_N = mkN "ovitaliserbarhet" ;
  ovitaminerbarhet_nn_1_N = mkN "ovitaminerbarhet" ;
  ovitaminiserbarhet_nn_1_N = mkN "ovitaminiserbarhet" ;
  ovokaliserbarhet_nn_1_N = mkN "ovokaliserbarhet" ;
  ovulgariserbarhet_nn_1_N = mkN "ovulgariserbarhet" ;
  ovulkaniserbarhet_nn_1_N = mkN "ovulkaniserbarhet" ;
  ovaeld_nn_1_1_N = mkN "oväld" ;
  ovaeldighet_nn_1_1_N = mkN "oväldighet" ;
  ovaerderbarhet_nn_1_1_N = mkN "ovärderbarhet" ;
  ovaerderlighet_nn_1_1_N = mkN "ovärderlighet" ;
  ovaerdighet_nn_1_1_N = mkN "ovärdighet" ;
  ovaerldslighet_nn_1_1_N = mkN "ovärldslighet" ;
  ovaalighet_nn_1_1_N = mkN "ovålighet" ;
  oxdans_nn_1_N = mkN "oxdans" ;
  oxdrift_nn_1_N = mkN "oxdrift" ;
  oxiderbarhet_nn_1_N = mkN "oxiderbarhet" ;
  ozokerit_nn_1_N = mkN "ozokerit" ;
  oaetbarhet_nn_1_1_N = mkN "oätbarhet" ;
  oaetlighet_nn_1_1_N = mkN "oätlighet" ;
  oaaterinstallerbarhet_nn_1_1_N = mkN "oåterinstallerbarhet" ;
  oaaterkallelighet_nn_1_1_N = mkN "oåterkallelighet" ;
  ooemhet_nn_1_1_N = mkN "oömhet" ;
  ooeverbryggbarhet_nn_1_1_N = mkN "oöverbryggbarhet" ;
  ooeverbrygglighet_nn_1_1_N = mkN "oöverbrygglighet" ;
  ooeverdimensionerbarhet_nn_1_1_N = mkN "oöverdimensionerbarhet" ;
  ooeverdoserbarhet_nn_1_1_N = mkN "oöverdoserbarhet" ;
  ooeverexponerbarhet_nn_1_1_N = mkN "oöverexponerbarhet" ;
  ooeverkomlighet_nn_1_1_N = mkN "oöverkomlighet" ;
  ooeverkompenserbarhet_nn_1_1_N = mkN "oöverkompenserbarhet" ;
  ooeverlagdhet_nn_1_1_N = mkN "oöverlagdhet" ;
  ooeverskaadlighet_nn_1_1_N = mkN "oöverskådlighet" ;
  ooeverstiglighet_nn_1_1_N = mkN "oöverstiglighet" ;
  ooeversaettlighet_nn_1_1_N = mkN "oöversättlighet" ;
  ooevertrasserbarhet_nn_1_1_N = mkN "oövertrasserbarhet" ;
  ooevertraefflighet_nn_1_1_N = mkN "oöverträfflighet" ;
  ooevertaenkthet_nn_1_1_N = mkN "oövertänkthet" ;
  ooevervinnelighet_nn_1_1_N = mkN "oövervinnelighet" ;
  ooevervinnerlighet_nn_1_1_N = mkN "oövervinnerlighet" ;
  ooevervinnlighet_nn_1_1_N = mkN "oövervinnlighet" ;
  ooevervaerderbarhet_nn_1_1_N = mkN "oövervärderbarhet" ;
  pacificerbarhet_nn_1_N = mkN "pacificerbarhet" ;
  packis_nn_1_N = mkN "packis" ;
  paddling_nn_1_N = mkN "paddling" ;
  paddslakt_nn_1_N = mkN "paddslakt" ;
  paffhet_nn_1_N = mkN "paffhet" ;
  paginerbarhet_nn_1_N = mkN "paginerbarhet" ;
  pajighet_nn_1_N = mkN "pajighet" ;
  paketerbarhet_nn_1_N = mkN "paketerbarhet" ;
  palataliserbarhet_nn_1_N = mkN "palataliserbarhet" ;
  paljetterbarhet_nn_1_N = mkN "paljetterbarhet" ;
  palperbarhet_nn_1_N = mkN "palperbarhet" ;
  paltighet_nn_1_N = mkN "paltighet" ;
  pampas_nn_1_N = mkN "pampas" ;
  pampighet_nn_1_N = mkN "pampighet" ;
  panerbarhet_nn_1_N = mkN "panerbarhet" ;
  pangasius_nn_1_N = mkN "pangasius" ;
  panik_nn_1_N = mkN "panik" ;
  panikmejl_nn_1_N = mkN "panikmejl" ;
  panikaangest_nn_1_1_N = mkN "panikångest" ;
  pankhet_nn_1_N = mkN "pankhet" ;
  panorerbarhet_nn_1_N = mkN "panorerbarhet" ;
  pansarfaerg_nn_1_1_N = mkN "pansarfärg" ;
  pansarsjael_nn_1_1_N = mkN "pansarsjäl" ;
  pantograferbarhet_nn_1_N = mkN "pantograferbarhet" ;
  papegojsjuka_nn_1_N = mkN "papegojsjuka" ;
  paperback_nn_1_N = mkN "paperback" ;
  pappaledighet_nn_1_N = mkN "pappaledighet" ;
  pappersexercis_nn_1_N = mkN "pappersexercis" ;
  papperslump_nn_1_N = mkN "papperslump" ;
  pappersmyntfot_nn_1_N = mkN "pappersmyntfot" ;
  pappighet_nn_1_N = mkN "pappighet" ;
  pappsloejd_nn_1_1_N = mkN "pappslöjd" ;
  paraderbarhet_nn_1_N = mkN "paraderbarhet" ;
  paraferbarhet_nn_1_N = mkN "paraferbarhet" ;
  paraffinerbarhet_nn_1_N = mkN "paraffinerbarhet" ;
  parafraserbarhet_nn_1_N = mkN "parafraserbarhet" ;
  parallax_nn_1_N = mkN "parallax" ;
  parallelliserbarhet_nn_1_N = mkN "parallelliserbarhet" ;
  paralyserbarhet_nn_1_N = mkN "paralyserbarhet" ;
  parasoemn_nn_1_1_N = mkN "parasömn" ;
  paratax_nn_1_N = mkN "paratax" ;
  paratyfus_nn_1_N = mkN "paratyfus" ;
  pardon_nn_1_N = mkN "pardon" ;
  parerbarhet_nn_1_N = mkN "parerbarhet" ;
  parfymerbarhet_nn_1_N = mkN "parfymerbarhet" ;
  parian_nn_1_N = mkN "parian" ;
  parkerbarhet_nn_1_N = mkN "parkerbarhet" ;
  parketterbarhet_nn_1_N = mkN "parketterbarhet" ;
  parklek_nn_1_N = mkN "parklek" ;
  parmesanost_nn_1_N = mkN "parmesanost" ;
  parodierbarhet_nn_1_N = mkN "parodierbarhet" ;
  parsing_nn_1_N = mkN "parsing" ;
  parsning_nn_1_N = mkN "parsning" ;
  partenogenes_nn_1_N = mkN "partenogenes" ;
  partigaengarjournalistik_nn_1_1_N = mkN "partigängarjournalistik" ;
  partiloeshet_nn_1_1_N = mkN "partilöshet" ;
  partisplittring_nn_1_N = mkN "partisplittring" ;
  partitillhoerighet_nn_1_1_N = mkN "partitillhörighet" ;
  passerbarhet_nn_1_N = mkN "passerbarhet" ;
  passform_nn_1_N = mkN "passform" ;
  passgaang_nn_1_1_N = mkN "passgång" ;
  passiverbarhet_nn_1_N = mkN "passiverbarhet" ;
  passiviserbarhet_nn_1_N = mkN "passiviserbarhet" ;
  passlighet_nn_1_N = mkN "passlighet" ;
  pastis_nn_1_N = mkN "pastis" ;
  pastischkaraktaer_nn_1_1_N = mkN "pastischkaraktär" ;
  pastoeriserbarhet_nn_1_1_N = mkN "pastöriserbarhet" ;
  patellarreflex_nn_1_N = mkN "patellarreflex" ;
  patenterbarhet_nn_1_N = mkN "patenterbarhet" ;
  patentfaerg_nn_1_1_N = mkN "patentfärg" ;
  patetik_nn_1_N = mkN "patetik" ;
  patientsekretess_nn_1_N = mkN "patientsekretess" ;
  patinerbarhet_nn_1_N = mkN "patinerbarhet" ;
  patristik_nn_1_N = mkN "patristik" ;
  patronatsraett_nn_1_1_N = mkN "patronatsrätt" ;
  patrullerbarhet_nn_1_N = mkN "patrullerbarhet" ;
  pauperiserbarhet_nn_1_N = mkN "pauperiserbarhet" ;
  pauserbarhet_nn_1_N = mkN "pauserbarhet" ;
  pauskommaterbarhet_nn_1_N = mkN "pauskommaterbarhet" ;
  peakning_nn_1_N = mkN "peakning" ;
  pedagogik_nn_1_N = mkN "pedagogik" ;
  pediatrik_nn_1_N = mkN "pediatrik" ;
  pedikur_nn_1_N = mkN "pedikur" ;
  pedikyr_nn_1_N = mkN "pedikyr" ;
  pedofilskraeck_nn_1_1_N = mkN "pedofilskräck" ;
  peeling_nn_1_N = mkN "peeling" ;
  pegamoid_nn_1_N = mkN "pegamoid" ;
  pekfingervals_nn_1_N = mkN "pekfingervals" ;
  pelleterbarhet_nn_1_N = mkN "pelleterbarhet" ;
  pelota_nn_1_N = mkN "pelota" ;
  pemmikan_nn_1_N = mkN "pemmikan" ;
  pendeltrafik_nn_1_N = mkN "pendeltrafik" ;
  pendeltaagstrafik_nn_1_1_N = mkN "pendeltågstrafik" ;
  penetrerbarhet_nn_1_N = mkN "penetrerbarhet" ;
  pengabrist_nn_1_N = mkN "pengabrist" ;
  pengarullning_nn_1_N = mkN "pengarullning" ;
  pengastinnhet_nn_1_N = mkN "pengastinnhet" ;
  penisavund_nn_1_N = mkN "penisavund" ;
  penitens_nn_1_N = mkN "penitens" ;
  penningbrist_nn_1_N = mkN "penningbrist" ;
  penningpolitik_nn_1_N = mkN "penningpolitik" ;
  penningstinnhet_nn_1_N = mkN "penningstinnhet" ;
  penningtvaett_nn_1_1_N = mkN "penningtvätt" ;
  penningoert_nn_1_1_N = mkN "penningört" ;
  pensionerbarhet_nn_1_N = mkN "pensionerbarhet" ;
  pensionsraett_nn_1_1_N = mkN "pensionsrätt" ;
  pentateuk_nn_1_N = mkN "pentateuk" ;
  pentatonik_nn_1_N = mkN "pentatonik" ;
  pepita_nn_1_N = mkN "pepita" ;
  pepitarutighet_nn_1_N = mkN "pepitarutighet" ;
  pepparmint_nn_1_N = mkN "pepparmint" ;
  pepparmynt_nn_1_N = mkN "pepparmynt" ;
  pepparrot_nn_1_N = mkN "pepparrot" ;
  pepparsprej_nn_1_N = mkN "pepparsprej" ;
  percipierbarhet_nn_1_N = mkN "percipierbarhet" ;
  perfekthet_nn_1_N = mkN "perfekthet" ;
  perforerbarhet_nn_1_N = mkN "perforerbarhet" ;
  periferhet_nn_1_N = mkN "periferhet" ;
  periodiserbarhet_nn_1_N = mkN "periodiserbarhet" ;
  peristaltik_nn_1_N = mkN "peristaltik" ;
  permafrost_nn_1_N = mkN "permafrost" ;
  permanens_nn_1_N = mkN "permanens" ;
  permanent_nn_1_N = mkN "permanent" ;
  permanenthet_nn_1_N = mkN "permanenthet" ;
  permanentning_nn_1_N = mkN "permanentning" ;
  permanentondulerbarhet_nn_1_N = mkN "permanentondulerbarhet" ;
  permitterbarhet_nn_1_N = mkN "permitterbarhet" ;
  permutationsraett_nn_1_1_N = mkN "permutationsrätt" ;
  permuterbarhet_nn_1_N = mkN "permuterbarhet" ;
  perplexhet_nn_1_N = mkN "perplexhet" ;
  persedelvaard_nn_1_1_N = mkN "persedelvård" ;
  persian_nn_1_N = mkN "persian" ;
  persiflerbarhet_nn_1_N = mkN "persiflerbarhet" ;
  personalbrist_nn_1_N = mkN "personalbrist" ;
  personalpolitik_nn_1_N = mkN "personalpolitik" ;
  personalvaard_nn_1_1_N = mkN "personalvård" ;
  personifierbarhet_nn_1_N = mkN "personifierbarhet" ;
  personlighet_nn_2_N = mkN "personlighet" ;
  personpolitik_nn_1_N = mkN "personpolitik" ;
  persontrafik_nn_1_N = mkN "persontrafik" ;
  perspektivloeshet_nn_1_1_N = mkN "perspektivlöshet" ;
  persvaderbarhet_nn_1_N = mkN "persvaderbarhet" ;
  pervershet_nn_1_N = mkN "pervershet" ;
  perverterbarhet_nn_1_N = mkN "perverterbarhet" ;
  pestilensrot_nn_1_N = mkN "pestilensrot" ;
  pestskraap_nn_1_1_N = mkN "pestskråp" ;
  petighet_nn_1_N = mkN "petighet" ;
  petit_nn_1_N = mkN "petit" ;
  petrifierbarhet_nn_1_N = mkN "petrifierbarhet" ;
  petsaekerhet_nn_1_1_N = mkN "petsäkerhet" ;
  petting_nn_1_N = mkN "petting" ;
  pianomusik_nn_1_N = mkN "pianomusik" ;
  pietetsfullhet_nn_1_N = mkN "pietetsfullhet" ;
  pietetsloeshet_nn_1_1_N = mkN "pietetslöshet" ;
  piff_nn_1_N = mkN "piff" ;
  piffighet_nn_1_N = mkN "piffighet" ;
  pigghet_nn_1_N = mkN "pigghet" ;
  pikantsaas_nn_1_1_N = mkN "pikantsås" ;
  pikerbarhet_nn_1_N = mkN "pikerbarhet" ;
  pillrighet_nn_1_N = mkN "pillrighet" ;
  pilskhet_nn_1_N = mkN "pilskhet" ;
  pilsnabbhet_nn_1_N = mkN "pilsnabbhet" ;
  piloert_nn_1_1_N = mkN "pilört" ;
  pimpinetthet_nn_1_N = mkN "pimpinetthet" ;
  pincerbarhet_nn_1_N = mkN "pincerbarhet" ;
  ping_pong_nn_1_N = mkN "ping-pong" ;
  pingis_nn_1_N = mkN "pingis" ;
  pingpong_nn_1_N = mkN "pingpong" ;
  pingstvaenlighet_nn_1_1_N = mkN "pingstvänlighet" ;
  pinknoedighet_nn_1_1_N = mkN "pinknödighet" ;
  pinnighet_nn_1_N = mkN "pinnighet" ;
  pinnved_nn_1_N = mkN "pinnved" ;
  pinroek_nn_1_1_N = mkN "pinrök" ;
  piphas_nn_1_N = mkN "piphas" ;
  pipighet_nn_1_N = mkN "pipighet" ;
  piptobak_nn_1_N = mkN "piptobak" ;
  pirrighet_nn_1_N = mkN "pirrighet" ;
  pissighet_nn_1_N = mkN "pissighet" ;
  pitprops_nn_1_N = mkN "pitprops" ;
  pjoskighet_nn_1_N = mkN "pjoskighet" ;
  pjunkighet_nn_1_N = mkN "pjunkighet" ;
  pjaakighet_nn_1_1_N = mkN "pjåkighet" ;
  placerbarhet_nn_1_N = mkN "placerbarhet" ;
  pladdrighet_nn_1_N = mkN "pladdrighet" ;
  plagierbarhet_nn_1_N = mkN "plagierbarhet" ;
  planenlighet_nn_1_N = mkN "planenlighet" ;
  planerbarhet_nn_1_N = mkN "planerbarhet" ;
  planhet_nn_1_N = mkN "planhet" ;
  planloeshet_nn_1_1_N = mkN "planlöshet" ;
  planmaessighet_nn_1_1_N = mkN "planmässighet" ;
  planterbarhet_nn_1_N = mkN "planterbarhet" ;
  plastellin_nn_1_N = mkN "plastellin" ;
  plastik_nn_1_N = mkN "plastik" ;
  platinablondhet_nn_1_N = mkN "platinablondhet" ;
  platinerbarhet_nn_1_N = mkN "platinerbarhet" ;
  platsbrist_nn_1_N = mkN "platsbrist" ;
  plattektonik_nn_1_N = mkN "plattektonik" ;
  plattfot_nn_1_N = mkN "plattfot" ;
  platthet_nn_1_N = mkN "platthet" ;
  playback_nn_1_N = mkN "playback" ;
  plebs_nn_1_N = mkN "plebs" ;
  pliktfoergaetenhet_nn_1_1_N = mkN "pliktförgätenhet" ;
  pliktkaensla_nn_1_1_N = mkN "pliktkänsla" ;
  pliktskyldighet_nn_1_N = mkN "pliktskyldighet" ;
  plikttrogenhet_nn_1_N = mkN "plikttrogenhet" ;
  plikttrohet_nn_1_N = mkN "plikttrohet" ;
  plisserbarhet_nn_1_N = mkN "plisserbarhet" ;
  plockighet_nn_1_N = mkN "plockighet" ;
  plockmat_nn_1_N = mkN "plockmat" ;
  plomberbarhet_nn_1_N = mkN "plomberbarhet" ;
  plottrighet_nn_1_N = mkN "plottrighet" ;
  plufsighet_nn_1_N = mkN "plufsighet" ;
  pluralis_nn_1_N = mkN "pluralis" ;
  plussighet_nn_1_N = mkN "plussighet" ;
  pluttighet_nn_1_N = mkN "pluttighet" ;
  plywood_nn_1_N = mkN "plywood" ;
  plaegning_nn_1_1_N = mkN "plägning" ;
  plaeterbarhet_nn_1_1_N = mkN "pläterbarhet" ;
  plaatbearbetning_nn_1_1_N = mkN "plåtbearbetning" ;
  ploeroes_nn_1_1_N = mkN "plörös" ;
  pneumatik_nn_1_N = mkN "pneumatik" ;
  pocherbarhet_nn_1_N = mkN "pocherbarhet" ;
  pocker_nn_1_N = mkN "pocker" ;
  podsoljord_nn_1_N = mkN "podsoljord" ;
  poetik_nn_1_N = mkN "poetik" ;
  pointerbarhet_nn_1_N = mkN "pointerbarhet" ;
  pojkaktighet_nn_1_N = mkN "pojkaktighet" ;
  polardag_nn_1_N = mkN "polardag" ;
  polariserbarhet_nn_1_N = mkN "polariserbarhet" ;
  polarluft_nn_1_N = mkN "polarluft" ;
  polarnatt_nn_1_N = mkN "polarnatt" ;
  polerbarhet_nn_1_N = mkN "polerbarhet" ;
  polhoejd_nn_1_1_N = mkN "polhöjd" ;
  poliomyelit_nn_1_N = mkN "poliomyelit" ;
  polis_nn_1_N = mkN "polis" ;
  polish_nn_1_N = mkN "polish" ;
  polismakt_nn_1_N = mkN "polismakt" ;
  polistejp_nn_1_N = mkN "polistejp" ;
  politess_nn_1_N = mkN "politess" ;
  politik_nn_1_N = mkN "politik" ;
  politiserbarhet_nn_1_N = mkN "politiserbarhet" ;
  pollenanalys_nn_1_N = mkN "pollenanalys" ;
  polletterbarhet_nn_1_N = mkN "polletterbarhet" ;
  pollinerbarhet_nn_1_N = mkN "pollinerbarhet" ;
  polskhet_nn_1_N = mkN "polskhet" ;
  polyuretan_nn_1_N = mkN "polyuretan" ;
  polyvinylklorid_nn_1_N = mkN "polyvinylklorid" ;
  pomaderbarhet_nn_1_N = mkN "pomaderbarhet" ;
  pomp_nn_1_N = mkN "pomp" ;
  pomperipossaeffekt_nn_1_N = mkN "pomperipossaeffekt" ;
  pondus_nn_1_N = mkN "pondus" ;
  pop_nn_1_N = mkN "pop" ;
  popkonst_nn_1_N = mkN "popkonst" ;
  popmusik_nn_1_N = mkN "popmusik" ;
  popp_nn_1_N = mkN "popp" ;
  poppighet_nn_1_N = mkN "poppighet" ;
  populariserbarhet_nn_1_N = mkN "populariserbarhet" ;
  populas_nn_1_N = mkN "populas" ;
  populaerkulturalitet_nn_1_1_N = mkN "populärkulturalitet" ;
  populaermusik_nn_1_1_N = mkN "populärmusik" ;
  populaerpress_nn_1_1_N = mkN "populärpress" ;
  populaervetenskap_nn_1_1_N = mkN "populärvetenskap" ;
  populaervetenskaplighet_nn_1_1_N = mkN "populärvetenskaplighet" ;
  porr_nn_1_N = mkN "porr" ;
  porrighet_nn_1_N = mkN "porrighet" ;
  pors_nn_1_N = mkN "pors" ;
  portionerbarhet_nn_1_N = mkN "portionerbarhet" ;
  portofrihet_nn_1_N = mkN "portofrihet" ;
  portraetterbarhet_nn_1_1_N = mkN "porträtterbarhet" ;
  portraettlikhet_nn_1_1_N = mkN "porträttlikhet" ;
  post_nn_1_N = mkN "post" ;
  postdaterbarhet_nn_1_N = mkN "postdaterbarhet" ;
  posterbarhet_nn_1_N = mkN "posterbarhet" ;
  posterioritet_nn_1_N = mkN "posterioritet" ;
  postgaang_nn_1_1_N = mkN "postgång" ;
  postponerbarhet_nn_1_N = mkN "postponerbarhet" ;
  postulerbarhet_nn_1_N = mkN "postulerbarhet" ;
  potkes_nn_1_N = mkN "potkes" ;
  potkaes_nn_1_1_N = mkN "potkäs" ;
  pottraening_nn_1_1_N = mkN "potträning" ;
  pottskraeck_nn_1_1_N = mkN "pottskräck" ;
  poaengloeshet_nn_1_1_N = mkN "poänglöshet" ;
  poaengterbarhet_nn_1_1_N = mkN "poängterbarhet" ;
  pragmatik_nn_1_N = mkN "pragmatik" ;
  prakt_nn_1_N = mkN "prakt" ;
  praktiserbarhet_nn_1_N = mkN "praktiserbarhet" ;
  praktiskhet_nn_1_N = mkN "praktiskhet" ;
  pratsamhet_nn_1_N = mkN "pratsamhet" ;
  pratsjukhet_nn_1_N = mkN "pratsjukhet" ;
  praxis_nn_1_N = mkN "praxis" ;
  precedens_nn_1_N = mkN "precedens" ;
  preciserbarhet_nn_1_N = mkN "preciserbarhet" ;
  predestinerbarhet_nn_1_N = mkN "predestinerbarhet" ;
  predicerbarhet_nn_1_N = mkN "predicerbarhet" ;
  predikatlogik_nn_1_N = mkN "predikatlogik" ;
  predisponerbarhet_nn_1_N = mkN "predisponerbarhet" ;
  preexistens_nn_1_N = mkN "preexistens" ;
  prefabricerbarhet_nn_1_N = mkN "prefabricerbarhet" ;
  prefererbarhet_nn_1_N = mkN "prefererbarhet" ;
  prefigerbarhet_nn_1_N = mkN "prefigerbarhet" ;
  pregnans_nn_1_N = mkN "pregnans" ;
  preludierbarhet_nn_1_N = mkN "preludierbarhet" ;
  premierbarhet_nn_1_N = mkN "premierbarhet" ;
  premium_nn_2_N = mkN "premium" ;
  preparerbarhet_nn_1_N = mkN "preparerbarhet" ;
  presenterbarhet_nn_1_N = mkN "presenterbarhet" ;
  preserverbarhet_nn_1_N = mkN "preserverbarhet" ;
  preskriberbarhet_nn_1_N = mkN "preskriberbarhet" ;
  press_nn_2_N = mkN "press" ;
  pressdetalj_nn_1_N = mkN "pressdetalj" ;
  pressetik_nn_1_N = mkN "pressetik" ;
  pressfrihet_nn_1_N = mkN "pressfrihet" ;
  presspan_nn_1_N = mkN "presspan" ;
  prestationsaangest_nn_1_1_N = mkN "prestationsångest" ;
  presterbarhet_nn_1_N = mkN "presterbarhet" ;
  prestigefylldhet_nn_1_N = mkN "prestigefylldhet" ;
  presumerbarhet_nn_1_N = mkN "presumerbarhet" ;
  prevention_nn_1_N = mkN "prevention" ;
  prickighet_nn_1_N = mkN "prickighet" ;
  pricksaekerhet_nn_1_1_N = mkN "pricksäkerhet" ;
  primtalsdifferentiering_nn_1_N = mkN "primtalsdifferentiering" ;
  primaervaard_nn_1_1_N = mkN "primärvård" ;
  principfasthet_nn_1_N = mkN "principfasthet" ;
  principloeshet_nn_1_1_N = mkN "principlöshet" ;
  prioriterbarhet_nn_1_N = mkN "prioriterbarhet" ;
  prisbillighet_nn_1_N = mkN "prisbillighet" ;
  priskontroll_nn_1_N = mkN "priskontroll" ;
  prispress_nn_1_N = mkN "prispress" ;
  prisreglerbarhet_nn_1_N = mkN "prisreglerbarhet" ;
  prisvaerdhet_nn_1_1_N = mkN "prisvärdhet" ;
  privatiserbarhet_nn_1_N = mkN "privatiserbarhet" ;
  privatraett_nn_1_1_N = mkN "privaträtt" ;
  privilegierbarhet_nn_1_N = mkN "privilegierbarhet" ;
  proamerikanskhet_nn_1_N = mkN "proamerikanskhet" ;
  proberbarhet_nn_1_N = mkN "proberbarhet" ;
  problematik_nn_1_N = mkN "problematik" ;
  problematiserbarhet_nn_1_N = mkN "problematiserbarhet" ;
  processraett_nn_1_1_N = mkN "processrätt" ;
  producerbarhet_nn_1_N = mkN "producerbarhet" ;
  produktframtagning_nn_1_N = mkN "produktframtagning" ;
  produktutveckling_nn_1_N = mkN "produktutveckling" ;
  profanerbarhet_nn_1_N = mkN "profanerbarhet" ;
  professionaliserbarhet_nn_1_N = mkN "professionaliserbarhet" ;
  professionalitet_nn_1_N = mkN "professionalitet" ;
  professorlighet_nn_1_N = mkN "professorlighet" ;
  proffsighet_nn_1_N = mkN "proffsighet" ;
  profilerbarhet_nn_1_N = mkN "profilerbarhet" ;
  profylax_nn_1_N = mkN "profylax" ;
  prog_nn_1_N = mkN "prog" ;
  progg_nn_1_N = mkN "progg" ;
  prognostiserbarhet_nn_1_N = mkN "prognostiserbarhet" ;
  programenlighet_nn_1_N = mkN "programenlighet" ;
  programkod_nn_1_N = mkN "programkod" ;
  programmerbarhet_nn_1_N = mkN "programmerbarhet" ;
  programmusik_nn_1_N = mkN "programmusik" ;
  progress_nn_1_N = mkN "progress" ;
  proisraeliskhet_nn_1_N = mkN "proisraeliskhet" ;
  projekterbarhet_nn_1_N = mkN "projekterbarhet" ;
  projicerbarhet_nn_1_N = mkN "projicerbarhet" ;
  proklamerbarhet_nn_1_N = mkN "proklamerbarhet" ;
  prokurdiskhet_nn_1_N = mkN "prokurdiskhet" ;
  proletariserbarhet_nn_1_N = mkN "proletariserbarhet" ;
  prolongerbarhet_nn_1_N = mkN "prolongerbarhet" ;
  promenadtakt_nn_1_N = mkN "promenadtakt" ;
  promoverbarhet_nn_1_N = mkN "promoverbarhet" ;
  proms_nn_1_N = mkN "proms" ;
  promulgerbarhet_nn_1_N = mkN "promulgerbarhet" ;
  prononcerbarhet_nn_1_N = mkN "prononcerbarhet" ;
  propalestinskhet_nn_1_N = mkN "propalestinskhet" ;
  propanol_nn_1_N = mkN "propanol" ;
  propedeutik_nn_1_N = mkN "propedeutik" ;
  propenplast_nn_1_N = mkN "propenplast" ;
  proponerbarhet_nn_1_N = mkN "proponerbarhet" ;
  proportionerbarhet_nn_1_N = mkN "proportionerbarhet" ;
  proportionerlighet_nn_1_N = mkN "proportionerlighet" ;
  proppmaetthet_nn_1_1_N = mkN "proppmätthet" ;
  props_nn_1_N = mkN "props" ;
  proskriberbarhet_nn_1_N = mkN "proskriberbarhet" ;
  prospekterbarhet_nn_1_N = mkN "prospekterbarhet" ;
  protegerbarhet_nn_1_N = mkN "protegerbarhet" ;
  proteinrikhet_nn_1_N = mkN "proteinrikhet" ;
  protetik_nn_1_N = mkN "protetik" ;
  protokollerbarhet_nn_1_N = mkN "protokollerbarhet" ;
  proviant_nn_1_N = mkN "proviant" ;
  provocerbarhet_nn_1_N = mkN "provocerbarhet" ;
  prustrot_nn_1_N = mkN "prustrot" ;
  prutmaan_nn_1_1_N = mkN "prutmån" ;
  pruttighet_nn_1_N = mkN "pruttighet" ;
  prydlighet_nn_1_N = mkN "prydlighet" ;
  pryltokighet_nn_1_N = mkN "pryltokighet" ;
  praektighet_nn_1_1_N = mkN "präktighet" ;
  praesterlighet_nn_1_1_N = mkN "prästerlighet" ;
  psittakos_nn_1_N = mkN "psittakos" ;
  psoriasis_nn_1_N = mkN "psoriasis" ;
  psykoanalyserbarhet_nn_1_N = mkN "psykoanalyserbarhet" ;
  psykofysik_nn_1_N = mkN "psykofysik" ;
  psykolingvistik_nn_1_N = mkN "psykolingvistik" ;
  psykologhjaelp_nn_1_1_N = mkN "psykologhjälp" ;
  psykologiserbarhet_nn_1_N = mkN "psykologiserbarhet" ;
  psykoprofylax_nn_1_N = mkN "psykoprofylax" ;
  psykoteknik_nn_1_N = mkN "psykoteknik" ;
  psykotropiskhet_nn_1_N = mkN "psykotropiskhet" ;
  publicerbarhet_nn_1_N = mkN "publicerbarhet" ;
  publicistik_nn_1_N = mkN "publicistik" ;
  puckelryggighet_nn_1_N = mkN "puckelryggighet" ;
  pucklighet_nn_1_N = mkN "pucklighet" ;
  pudrett_nn_1_N = mkN "pudrett" ;
  pudrighet_nn_1_N = mkN "pudrighet" ;
  puertoricanskhet_nn_1_N = mkN "puertoricanskhet" ;
  pugilistik_nn_1_N = mkN "pugilistik" ;
  pulkaakning_nn_1_1_N = mkN "pulkåkning" ;
  pulverform_nn_1_N = mkN "pulverform" ;
  pulveriserbarhet_nn_1_N = mkN "pulveriserbarhet" ;
  pulverlackerbarhet_nn_1_N = mkN "pulverlackerbarhet" ;
  pulvriserbarhet_nn_1_N = mkN "pulvriserbarhet" ;
  pundighet_nn_1_N = mkN "pundighet" ;
  pungdjaevul_nn_1_1_N = mkN "pungdjävul" ;
  punk_nn_1_N = mkN "punk" ;
  punkterbarhet_nn_1_N = mkN "punkterbarhet" ;
  punktgravyr_nn_1_N = mkN "punktgravyr" ;
  punktlighet_nn_1_N = mkN "punktlighet" ;
  punktmusik_nn_1_N = mkN "punktmusik" ;
  punktskrift_nn_1_N = mkN "punktskrift" ;
  punsch_nn_1_N = mkN "punsch" ;
  purgerbarhet_nn_1_N = mkN "purgerbarhet" ;
  purhet_nn_1_N = mkN "purhet" ;
  purkenhet_nn_1_N = mkN "purkenhet" ;
  pussighet_nn_1_N = mkN "pussighet" ;
  puts_nn_1_N = mkN "puts" ;
  putthet_nn_1_N = mkN "putthet" ;
  puttrighet_nn_1_N = mkN "puttrighet" ;
  pyroteknik_nn_1_N = mkN "pyroteknik" ;
  pyrschjakt_nn_1_N = mkN "pyrschjakt" ;
  pysslighet_nn_1_N = mkN "pysslighet" ;
  pyton_nn_1_N = mkN "pyton" ;
  pytt_nn_1_N = mkN "pytt" ;
  paelsdesign_nn_1_1_N = mkN "pälsdesign" ;
  paerk_nn_1_1_N = mkN "pärk" ;
  paeronsmak_nn_1_1_N = mkN "päronsmak" ;
  paaannonserbarhet_nn_1_1_N = mkN "påannonserbarhet" ;
  paadrivning_nn_1_1_N = mkN "pådrivning" ;
  paaflugenhet_nn_1_1_N = mkN "påflugenhet" ;
  paaklaeddhet_nn_1_1_N = mkN "påkläddhet" ;
  paaklaedning_nn_1_1_N = mkN "påklädning" ;
  paalitlighet_nn_1_1_N = mkN "pålitlighet" ;
  paapasslighet_nn_1_1_N = mkN "påpasslighet" ;
  paaskledighet_nn_1_1_N = mkN "påskledighet" ;
  paasktrafik_nn_1_1_N = mkN "påsktrafik" ;
  paassjuka_nn_1_1_N = mkN "påssjuka" ;
  paastridighet_nn_1_1_N = mkN "påstridighet" ;
  paastrykning_nn_1_1_N = mkN "påstrykning" ;
  paastaaelighet_nn_1_1_N = mkN "påståelighet" ;
  paasyn_nn_1_1_N = mkN "påsyn" ;
  paatagbarhet_nn_1_1_N = mkN "påtagbarhet" ;
  paataglighet_nn_1_1_N = mkN "påtaglighet" ;
  paataendhet_nn_1_1_N = mkN "påtändhet" ;
  paavekyrka_nn_1_1_N = mkN "påvekyrka" ;
  paaverkbarhet_nn_1_1_N = mkN "påverkbarhet" ;
  paavestol_nn_1_1_N = mkN "påvestol" ;
  paavisbarhet_nn_1_1_N = mkN "påvisbarhet" ;
  paavislighet_nn_1_1_N = mkN "påvislighet" ;
  paavlighet_nn_1_1_N = mkN "påvlighet" ;
  paavaext_nn_1_1_N = mkN "påväxt" ;
  paaoekt_nn_1_1_N = mkN "påökt" ;
  poelsighet_nn_1_1_N = mkN "pölsighet" ;
  poesighet_nn_1_1_N = mkN "pösighet" ;
  rabatterbarhet_nn_1_N = mkN "rabatterbarhet" ;
  rabies_nn_1_N = mkN "rabies" ;
  rabiesskraeck_nn_1_1_N = mkN "rabiesskräck" ;
  racing_nn_1_N = mkN "racing" ;
  rackaraktighet_nn_1_N = mkN "rackaraktighet" ;
  racklighet_nn_1_N = mkN "racklighet" ;
  radarkommunikation_nn_1_N = mkN "radarkommunikation" ;
  raderbarhet_nn_1_N = mkN "raderbarhet" ;
  radiak_nn_1_N = mkN "radiak" ;
  radierbarhet_nn_1_N = mkN "radierbarhet" ;
  radikaliserbarhet_nn_1_N = mkN "radikaliserbarhet" ;
  radiodramatik_nn_1_N = mkN "radiodramatik" ;
  radiofysik_nn_1_N = mkN "radiofysik" ;
  radiokommunikation_nn_1_N = mkN "radiokommunikation" ;
  radiolag_nn_1_N = mkN "radiolag" ;
  radionavigerbarhet_nn_1_N = mkN "radionavigerbarhet" ;
  radionaemnd_nn_1_1_N = mkN "radionämnd" ;
  radiotrafik_nn_1_N = mkN "radiotrafik" ;
  raffighet_nn_1_N = mkN "raffighet" ;
  raffinerbarhet_nn_1_N = mkN "raffinerbarhet" ;
  rafflighet_nn_1_N = mkN "rafflighet" ;
  ragg_nn_1_N = mkN "ragg" ;
  raggighet_nn_1_N = mkN "raggighet" ;
  raglan_nn_1_N = mkN "raglan" ;
  raketdrift_nn_1_N = mkN "raketdrift" ;
  raketfart_nn_1_N = mkN "raketfart" ;
  rakhet_nn_1_N = mkN "rakhet" ;
  rakitis_nn_1_N = mkN "rakitis" ;
  raklinjighet_nn_1_N = mkN "raklinjighet" ;
  raljans_nn_1_N = mkN "raljans" ;
  rallycross_nn_1_N = mkN "rallycross" ;
  ramadan_nn_1_N = mkN "ramadan" ;
  rammelbuljong_nn_1_N = mkN "rammelbuljong" ;
  ramponerbarhet_nn_1_N = mkN "ramponerbarhet" ;
  rams_nn_1_N = mkN "rams" ;
  ramstarkhet_nn_1_N = mkN "ramstarkhet" ;
  randighet_nn_1_N = mkN "randighet" ;
  randomiserbarhet_nn_1_N = mkN "randomiserbarhet" ;
  rang_nn_1_N = mkN "rang" ;
  rangerbarhet_nn_1_N = mkN "rangerbarhet" ;
  ranglighet_nn_1_N = mkN "ranglighet" ;
  rankhet_nn_1_N = mkN "rankhet" ;
  rankighet_nn_1_N = mkN "rankighet" ;
  ransonerbarhet_nn_1_N = mkN "ransonerbarhet" ;
  rap_nn_2_N = mkN "rap" ;
  rapmusik_nn_1_N = mkN "rapmusik" "rapmusiker" ;
  rapp_nn_3_N = mkN "rapp" ;
  rappellerbarhet_nn_1_N = mkN "rappellerbarhet" ;
  rapphet_nn_1_N = mkN "rapphet" ;
  rapporterbarhet_nn_1_N = mkN "rapporterbarhet" ;
  rapporteringsplikt_nn_1_N = mkN "rapporteringsplikt" ;
  raps_nn_1_N = mkN "raps" ;
  rarhet_nn_1_N = mkN "rarhet" ;
  rasdiskriminerbarhet_nn_1_N = mkN "rasdiskriminerbarhet" ;
  raserbarhet_nn_1_N = mkN "raserbarhet" ;
  rashets_nn_1_N = mkN "rashets" ;
  raskhet_nn_1_N = mkN "raskhet" ;
  raspighet_nn_1_N = mkN "raspighet" ;
  rassegregation_nn_1_N = mkN "rassegregation" ;
  rastafarisekt_nn_1_N = mkN "rastafarisekt" ;
  rastloeshet_nn_1_1_N = mkN "rastlöshet" ;
  rasaatskillnad_nn_1_1_N = mkN "rasåtskillnad" ;
  ratificerbarhet_nn_1_N = mkN "ratificerbarhet" ;
  rationaliserbarhet_nn_1_N = mkN "rationaliserbarhet" ;
  rationalitetsskepsis_nn_1_N = mkN "rationalitetsskepsis" ;
  rayonull_nn_1_N = mkN "rayonull" ;
  reaktionsdrift_nn_1_N = mkN "reaktionsdrift" ;
  reaktiverbarhet_nn_1_N = mkN "reaktiverbarhet" ;
  reaktorfysik_nn_1_N = mkN "reaktorfysik" ;
  real_nn_1_N = mkN "real" ;
  realiserbarhet_nn_1_N = mkN "realiserbarhet" ;
  realpolitik_nn_1_N = mkN "realpolitik" ;
  reassurerbarhet_nn_1_N = mkN "reassurerbarhet" ;
  recenserbarhet_nn_1_N = mkN "recenserbarhet" ;
  recipierbarhet_nn_1_N = mkN "recipierbarhet" ;
  reciterbarhet_nn_1_N = mkN "reciterbarhet" ;
  redbarhet_nn_1_N = mkN "redbarhet" ;
  redigerbarhet_nn_1_N = mkN "redigerbarhet" ;
  redighet_nn_1_N = mkN "redighet" ;
  redloeshet_nn_1_1_N = mkN "redlöshet" ;
  redobogenhet_nn_1_N = mkN "redobogenhet" ;
  redskapsgymnastik_nn_1_N = mkN "redskapsgymnastik" ;
  reducerbarhet_nn_1_N = mkN "reducerbarhet" ;
  redundans_nn_1_N = mkN "redundans" ;
  reexport_nn_1_N = mkN "reexport" ;
  referenslitteratur_nn_1_N = mkN "referenslitteratur" ;
  refererbarhet_nn_1_N = mkN "refererbarhet" ;
  reflekterbarhet_nn_1_N = mkN "reflekterbarhet" ;
  reflexionsloeshet_nn_1_1_N = mkN "reflexionslöshet" ;
  reflexivitet_nn_1_N = mkN "reflexivitet" ;
  reflexmaessighet_nn_1_1_N = mkN "reflexmässighet" ;
  reformerbarhet_nn_1_N = mkN "reformerbarhet" ;
  reformpolitik_nn_1_N = mkN "reformpolitik" ;
  reformvaenlighet_nn_1_1_N = mkN "reformvänlighet" ;
  refuserbarhet_nn_1_N = mkN "refuserbarhet" ;
  regalerbarhet_nn_1_N = mkN "regalerbarhet" ;
  regelloeshet_nn_1_1_N = mkN "regellöshet" ;
  regelraetthet_nn_1_1_N = mkN "regelrätthet" ;
  regenererbarhet_nn_1_N = mkN "regenererbarhet" ;
  regerbarhet_nn_1_N = mkN "regerbarhet" ;
  regeringsduglighet_nn_1_N = mkN "regeringsduglighet" ;
  regeringsstaellning_nn_1_1_N = mkN "regeringsställning" ;
  regeringsstaellning_nn_2_1_N = mkN "regeringsställning" ;
  regerlighet_nn_1_N = mkN "regerlighet" ;
  regimkritiskhet_nn_1_N = mkN "regimkritiskhet" ;
  regionalpolitik_nn_1_N = mkN "regionalpolitik" ;
  regionmusik_nn_1_N = mkN "regionmusik" ;
  regionpolitik_nn_1_N = mkN "regionpolitik" ;
  regionspolitik_nn_1_N = mkN "regionspolitik" ;
  regisserbarhet_nn_1_N = mkN "regisserbarhet" ;
  registrerbarhet_nn_1_N = mkN "registrerbarhet" ;
  reglementerbarhet_nn_1_N = mkN "reglementerbarhet" ;
  reglementsenlighet_nn_1_N = mkN "reglementsenlighet" ;
  reglementsvidrighet_nn_1_N = mkN "reglementsvidrighet" ;
  reglerbarhet_nn_1_N = mkN "reglerbarhet" ;
  reglerteknik_nn_1_N = mkN "reglerteknik" ;
  regnighet_nn_1_N = mkN "regnighet" ;
  regntunghet_nn_1_N = mkN "regntunghet" ;
  regntaethet_nn_1_1_N = mkN "regntäthet" ;
  regular_nn_1_N = mkN "regular" ;
  regummerbarhet_nn_1_N = mkN "regummerbarhet" ;
  rehabiliterbarhet_nn_1_N = mkN "rehabiliterbarhet" ;
  reinkarnerbarhet_nn_1_N = mkN "reinkarnerbarhet" ;
  rejv_nn_1_N = mkN "rejv" ;
  rekapitulerbarhet_nn_1_N = mkN "rekapitulerbarhet" ;
  reklambransch_nn_1_N = mkN "reklambransch" ;
  reklamerbarhet_nn_1_N = mkN "reklamerbarhet" ;
  rekognoscerbarhet_nn_1_N = mkN "rekognoscerbarhet" ;
  rekognoserbarhet_nn_1_N = mkN "rekognoserbarhet" ;
  rekommenderbarhet_nn_1_N = mkN "rekommenderbarhet" ;
  rekompenserbarhet_nn_1_N = mkN "rekompenserbarhet" ;
  rekonstruerbarhet_nn_1_N = mkN "rekonstruerbarhet" ;
  rekonvalescens_nn_1_N = mkN "rekonvalescens" ;
  rekorderlighet_nn_1_N = mkN "rekorderlighet" ;
  rekordfart_nn_1_N = mkN "rekordfart" ;
  rekordform_nn_1_N = mkN "rekordform" ;
  rekreationspolitik_nn_1_N = mkN "rekreationspolitik" ;
  rekryterbarhet_nn_1_N = mkN "rekryterbarhet" ;
  rektificerbarhet_nn_1_N = mkN "rektificerbarhet" ;
  rektifierbarhet_nn_1_N = mkN "rektifierbarhet" ;
  rekvirerbarhet_nn_1_N = mkN "rekvirerbarhet" ;
  relaterbarhet_nn_1_N = mkN "relaterbarhet" ;
  relegerbarhet_nn_1_N = mkN "relegerbarhet" ;
  relevans_nn_1_N = mkN "relevans" ;
  religionskunskap_nn_1_N = mkN "religionskunskap" ;
  religionstillhoerighet_nn_1_1_N = mkN "religionstillhörighet" ;
  religionsutoevning_nn_1_1_N = mkN "religionsutövning" ;
  remanens_nn_1_N = mkN "remanens" ;
  remissbehandling_nn_1_N = mkN "remissbehandling" ;
  remitterbarhet_nn_1_N = mkN "remitterbarhet" ;
  remplacerbarhet_nn_1_N = mkN "remplacerbarhet" ;
  renderbarhet_nn_1_N = mkN "renderbarhet" ;
  rendrift_nn_1_N = mkN "rendrift" ;
  renhaarighet_nn_1_1_N = mkN "renhårighet" ;
  rening_nn_1_N = mkN "rening" ;
  renodling_nn_1_N = mkN "renodling" ;
  renoverbarhet_nn_1_N = mkN "renoverbarhet" ;
  renrasighet_nn_1_N = mkN "renrasighet" ;
  rensbarhet_nn_1_N = mkN "rensbarhet" ;
  reorganiserbarhet_nn_1_N = mkN "reorganiserbarhet" ;
  reparerbarhet_nn_1_N = mkN "reparerbarhet" ;
  repartiserbarhet_nn_1_N = mkN "repartiserbarhet" ;
  repatrierbarhet_nn_1_N = mkN "repatrierbarhet" ;
  repellerbarhet_nn_1_N = mkN "repellerbarhet" ;
  repeterbarhet_nn_1_N = mkN "repeterbarhet" ;
  representerbarhet_nn_1_N = mkN "representerbarhet" ;
  repriserbarhet_nn_1_N = mkN "repriserbarhet" ;
  reproducerbarhet_nn_1_N = mkN "reproducerbarhet" ;
  reproducering_nn_2_N = mkN "reproducering" ;
  reputerlighet_nn_1_N = mkN "reputerlighet" ;
  resejournalistik_nn_1_N = mkN "resejournalistik" ;
  reserverbarhet_nn_1_N = mkN "reserverbarhet" ;
  resistans_nn_1_N = mkN "resistans" ;
  resistens_nn_1_N = mkN "resistens" ;
  resistenthet_nn_1_N = mkN "resistenthet" ;
  reslighet_nn_1_N = mkN "reslighet" ;
  resoluthet_nn_1_N = mkN "resoluthet" ;
  resolverbarhet_nn_1_N = mkN "resolverbarhet" ;
  reson_nn_1_N = mkN "reson" ;
  resonans_nn_1_N = mkN "resonans" ;
  resonlighet_nn_1_N = mkN "resonlighet" ;
  resorberbarhet_nn_1_N = mkN "resorberbarhet" ;
  respekt_nn_1_N = mkN "respekt" ;
  respekterbarhet_nn_1_N = mkN "respekterbarhet" ;
  respirerbarhet_nn_1_N = mkN "respirerbarhet" ;
  respons_nn_1_N = mkN "respons" ;
  restaurangbransch_nn_1_N = mkN "restaurangbransch" ;
  restauranghypotes_nn_1_N = mkN "restauranghypotes" ;
  restaurerbarhet_nn_1_N = mkN "restaurerbarhet" ;
  restituerbarhet_nn_1_N = mkN "restituerbarhet" ;
  restloeshet_nn_1_1_N = mkN "restlöshet" ;
  restriktivitet_nn_1_N = mkN "restriktivitet" ;
  resultatloeshet_nn_1_1_N = mkN "resultatlöshet" ;
  resumerbarhet_nn_1_N = mkN "resumerbarhet" ;
  resursbrist_nn_1_N = mkN "resursbrist" ;
  retablerbarhet_nn_1_N = mkN "retablerbarhet" ;
  retarderbarhet_nn_1_N = mkN "retarderbarhet" ;
  retentionsraett_nn_1_1_N = mkN "retentionsrätt" ;
  retfullhet_nn_1_N = mkN "retfullhet" ;
  rethosta_nn_1_N = mkN "rethosta" ;
  retlighet_nn_1_N = mkN "retlighet" ;
  retorik_nn_1_N = mkN "retorik" ;
  returnerbarhet_nn_1_N = mkN "returnerbarhet" ;
  retuscherbarhet_nn_1_N = mkN "retuscherbarhet" ;
  revalverbarhet_nn_1_N = mkN "revalverbarhet" ;
  reveterbarhet_nn_1_N = mkN "reveterbarhet" ;
  reviderbarhet_nn_1_N = mkN "reviderbarhet" ;
  revolutionerbarhet_nn_1_N = mkN "revolutionerbarhet" ;
  rhenskhet_nn_1_N = mkN "rhenskhet" ;
  rhythm_and_blues_nn_1_N = mkN "rhythm-and-blues" ;
  ribb_nn_1_N = mkN "ribb" ;
  ribos_nn_1_N = mkN "ribos" ;
  rickighet_nn_1_N = mkN "rickighet" ;
  ridderlighet_nn_1_N = mkN "ridderlighet" ;
  ridsport_nn_1_N = mkN "ridsport" ;
  rikhaltighet_nn_1_N = mkN "rikhaltighet" ;
  rikhet_nn_1_N = mkN "rikhet" ;
  riklighet_nn_1_N = mkN "riklighet" ;
  riksgaeld_nn_1_1_N = mkN "riksgäld" ;
  rikspolitik_nn_1_N = mkN "rikspolitik" ;
  riksstat_nn_1_N = mkN "riksstat" ;
  riksviktighet_nn_1_N = mkN "riksviktighet" ;
  rimfrost_nn_1_N = mkN "rimfrost" ;
  ringformighet_nn_1_N = mkN "ringformighet" ;
  ringrostighet_nn_1_N = mkN "ringrostighet" ;
  ringside_nn_1_N = mkN "ringside" ;
  risgrynsgroet_nn_1_1_N = mkN "risgrynsgröt" ;
  riskfrihet_nn_1_N = mkN "riskfrihet" ;
  riskfylldhet_nn_1_N = mkN "riskfylldhet" ;
  riskvillighet_nn_1_N = mkN "riskvillighet" ;
  ritualiserbarhet_nn_1_N = mkN "ritualiserbarhet" ;
  robotiserbarhet_nn_1_N = mkN "robotiserbarhet" ;
  robusthet_nn_1_N = mkN "robusthet" ;
  rock_n_roll_nn_1_N = mkN "rock'n'roll" ;
  rock_nn_2_N = mkN "rock" ;
  rockerbarhet_nn_1_N = mkN "rockerbarhet" ;
  rockmusik_nn_1_N = mkN "rockmusik" ;
  roderloeshet_nn_1_1_N = mkN "roderlöshet" ;
  rofylldhet_nn_1_N = mkN "rofylldhet" ;
  roloeshet_nn_1_1_N = mkN "rolöshet" ;
  romantik_nn_1_N = mkN "romantik" ;
  romantiserbarhet_nn_1_N = mkN "romantiserbarhet" ;
  rondoer_nn_1_1_N = mkN "rondör" ;
  roquefort_nn_1_N = mkN "roquefort" ;
  rosenaktighet_nn_1_N = mkN "rosenaktighet" ;
  rosengaang_nn_1_1_N = mkN "rosengång" ;
  rosenkaal_nn_1_1_N = mkN "rosenkål" ;
  rosslighet_nn_1_N = mkN "rosslighet" ;
  rost_nn_1_N = mkN "rost" ;
  rostighet_nn_1_N = mkN "rostighet" ;
  rotfasthet_nn_1_N = mkN "rotfasthet" ;
  rotloeshet_nn_1_1_N = mkN "rotlöshet" ;
  rots_nn_1_N = mkN "rots" ;
  rottingflaetning_nn_1_1_N = mkN "rottingflätning" ;
  rovdrift_nn_1_N = mkN "rovdrift" ;
  rovgirighet_nn_1_N = mkN "rovgirighet" ;
  rubbing_nn_1_N = mkN "rubbing" ;
  rubricerbarhet_nn_1_N = mkN "rubricerbarhet" ;
  rucklighet_nn_1_N = mkN "rucklighet" ;
  ruffighet_nn_1_N = mkN "ruffighet" ;
  rufsighet_nn_1_N = mkN "rufsighet" ;
  ruggighet_nn_1_N = mkN "ruggighet" ;
  ruinerbarhet_nn_1_N = mkN "ruinerbarhet" ;
  ruljangs_nn_1_N = mkN "ruljangs" ;
  rullbarhet_nn_1_N = mkN "rullbarhet" ;
  rultighet_nn_1_N = mkN "rultighet" ;
  rumhet_nn_1_N = mkN "rumhet" ;
  rumsarrest_nn_1_N = mkN "rumsarrest" ;
  rumstid_nn_1_N = mkN "rumstid" ;
  rumtid_nn_1_N = mkN "rumtid" ;
  rundgaang_nn_1_1_N = mkN "rundgång" ;
  rundhyllthet_nn_1_N = mkN "rundhyllthet" ;
  rundhaenthet_nn_1_1_N = mkN "rundhänthet" ;
  rundkullighet_nn_1_N = mkN "rundkullighet" ;
  rundlagdhet_nn_1_N = mkN "rundlagdhet" ;
  rundlighet_nn_1_N = mkN "rundlighet" ;
  rundnaetthet_nn_1_1_N = mkN "rundnätthet" ;
  ruschighet_nn_1_N = mkN "ruschighet" ;
  rusighet_nn_1_N = mkN "rusighet" ;
  rusningstrafik_nn_1_N = mkN "rusningstrafik" ;
  russificerbarhet_nn_1_N = mkN "russificerbarhet" ;
  russifierbarhet_nn_1_N = mkN "russifierbarhet" ;
  rusttjaenst_nn_1_1_N = mkN "rusttjänst" ;
  rutighet_nn_1_N = mkN "rutighet" ;
  ruttenhet_nn_1_N = mkN "ruttenhet" ;
  rybs_nn_1_N = mkN "rybs" ;
  ryckighet_nn_1_N = mkN "ryckighet" ;
  ryggmaerg_nn_1_1_N = mkN "ryggmärg" ;
  ryggradsloeshet_nn_1_1_N = mkN "ryggradslöshet" ;
  ryggsaecksturism_nn_1_1_N = mkN "ryggsäcksturism" ;
  rykt_nn_1_N = mkN "rykt" ;
  rykteskarusell_nn_1_N = mkN "rykteskarusell" ;
  rymdfart_nn_1_N = mkN "rymdfart" ;
  rymdkapploepning_nn_1_1_N = mkN "rymdkapplöpning" ;
  rymdmedicin_nn_1_N = mkN "rymdmedicin" ;
  rymdtrafik_nn_1_N = mkN "rymdtrafik" ;
  rymdvikt_nn_1_N = mkN "rymdvikt" ;
  rymlighet_nn_1_N = mkN "rymlighet" ;
  rymningssaekerhet_nn_1_1_N = mkN "rymningssäkerhet" ;
  rynkfrihet_nn_1_N = mkN "rynkfrihet" ;
  rynkighet_nn_1_N = mkN "rynkighet" ;
  ryps_nn_1_N = mkN "ryps" ;
  rysansvaerdhet_nn_1_1_N = mkN "rysansvärdhet" ;
  ryschighet_nn_1_N = mkN "ryschighet" ;
  ryskhet_nn_1_N = mkN "ryskhet" ;
  ryskspraakighet_nn_1_1_N = mkN "ryskspråkighet" ;
  ryskundervisning_nn_1_N = mkN "ryskundervisning" ;
  ryskvaenlighet_nn_1_1_N = mkN "ryskvänlighet" ;
  rysskraeck_nn_1_1_N = mkN "rysskräck" ;
  rytmik_nn_1_N = mkN "rytmik" ;
  rytmiserbarhet_nn_1_N = mkN "rytmiserbarhet" ;
  raeddhet_nn_1_1_N = mkN "räddhet" ;
  raeddningsloeshet_nn_1_1_N = mkN "räddningslöshet" ;
  raedsla_nn_1_1_N = mkN "rädsla" ;
  raekenskap_nn_1_1_N = mkN "räkenskap" ;
  raentefot_nn_1_1_N = mkN "räntefot" ;
  raethet_nn_1_1_N = mkN "räthet" ;
  raetlinjighet_nn_1_1_N = mkN "rätlinjighet" ;
  raett_nn_1_1_N = mkN "rätt" ;
  raetthet_nn_1_1_N = mkN "rätthet" ;
  raettmaetighet_nn_1_1_N = mkN "rättmätighet" ;
  raettrogenhet_nn_1_1_N = mkN "rättrogenhet" ;
  raettraadighet_nn_1_1_N = mkN "rättrådighet" ;
  raettsenlighet_nn_1_1_N = mkN "rättsenlighet" ;
  raettshaveristiskhet_nn_1_1_N = mkN "rättshaveristiskhet" ;
  raettshjaelp_nn_1_1_N = mkN "rättshjälp" ;
  raettsinnighet_nn_1_1_N = mkN "rättsinnighet" ;
  raettskaffenhet_nn_1_1_N = mkN "rättskaffenhet" ;
  raettskaensla_nn_1_1_N = mkN "rättskänsla" ;
  raettslighet_nn_1_1_N = mkN "rättslighet" ;
  raettsloeshet_nn_1_1_N = mkN "rättslöshet" ;
  raettsmedicin_nn_1_1_N = mkN "rättsmedicin" ;
  raettspolitik_nn_1_1_N = mkN "rättspolitik" ;
  raettsstridighet_nn_1_1_N = mkN "rättsstridighet" ;
  raettsvetenskap_nn_1_1_N = mkN "rättsvetenskap" ;
  raettsvidrighet_nn_1_1_N = mkN "rättsvidrighet" ;
  raetvinklighet_nn_1_1_N = mkN "rätvinklighet" ;
  raaddighet_nn_1_1_N = mkN "råddighet" ;
  raadighet_nn_1_1_N = mkN "rådighet" ;
  raadjursjakt_nn_1_1_N = mkN "rådjursjakt" ;
  raadlighet_nn_1_1_N = mkN "rådlighet" ;
  raadloeshet_nn_1_1_N = mkN "rådlöshet" ;
  raadvillhet_nn_1_1_N = mkN "rådvillhet" ;
  raag_nn_1_1_N = mkN "råg" ;
  raagblondhet_nn_1_1_N = mkN "rågblondhet" ;
  raagmjoelsgroet_nn_1_1_N = mkN "rågmjölsgröt" ;
  raagsikt_nn_1_1_N = mkN "rågsikt" ;
  raakost_nn_1_1_N = mkN "råkost" ;
  raamjoelk_nn_1_1_N = mkN "råmjölk" ;
  raanutveckling_nn_1_1_N = mkN "rånutveckling" ;
  raavarufoersoerjning_nn_1_1_N = mkN "råvaruförsörjning" ;
  roedaktighet_nn_1_1_N = mkN "rödaktighet" ;
  roedblindhet_nn_1_1_N = mkN "rödblindhet" ;
  roedblondhet_nn_1_1_N = mkN "rödblondhet" ;
  roedbrusighet_nn_1_1_N = mkN "rödbrusighet" ;
  roedflammighet_nn_1_1_N = mkN "rödflammighet" ;
  roedfaerg_nn_1_1_N = mkN "rödfärg" ;
  roedfoerskjutning_nn_1_1_N = mkN "rödförskjutning" ;
  roedgroenblindhet_nn_1_1_N = mkN "rödgrönblindhet" ;
  roedhaarighet_nn_1_1_N = mkN "rödhårighet" ;
  roedklint_nn_1_1_N = mkN "rödklint" ;
  roedkaal_nn_1_1_N = mkN "rödkål" ;
  roedlaetthet_nn_1_1_N = mkN "rödlätthet" ;
  roedloek_nn_1_1_N = mkN "rödlök" ;
  roedmosighet_nn_1_1_N = mkN "rödmosighet" ;
  roednaesthet_nn_1_1_N = mkN "rödnästhet" ;
  roedsot_nn_1_1_N = mkN "rödsot" ;
  roedsprit_nn_1_1_N = mkN "rödsprit" ;
  roedspraengdhet_nn_1_1_N = mkN "rödsprängdhet" ;
  roedoegdhet_nn_1_1_N = mkN "rödögdhet" ;
  roekavvaenjning_nn_1_1_N = mkN "rökavvänjning" ;
  roekhosta_nn_1_1_N = mkN "rökhosta" ;
  roekighet_nn_1_1_N = mkN "rökighet" ;
  roeklukt_nn_1_1_N = mkN "röklukt" ;
  roeksvaghet_nn_1_1_N = mkN "röksvaghet" ;
  roekthet_nn_1_1_N = mkN "rökthet" ;
  roekutveckling_nn_1_1_N = mkN "rökutveckling" ;
  roentgenblick_nn_1_1_N = mkN "röntgenblick" ;
  roentgendiagnostik_nn_1_1_N = mkN "röntgendiagnostik" ;
  roentgenfotograferbarhet_nn_1_1_N = mkN "röntgenfotograferbarhet" ;
  roer_mig_ej_nn_1_1_N = mkN "rör-mig-ej" ;
  roerdhet_nn_1_1_N = mkN "rördhet" ;
  roerelsesjuka_nn_1_1_N = mkN "rörelsesjuka" ;
  roermigej_nn_1_1_N = mkN "rörmigej" ;
  roerpost_nn_1_1_N = mkN "rörpost" ;
  roestklang_nn_1_1_N = mkN "röstklang" ;
  roestraett_nn_1_1_N = mkN "rösträtt" ;
  roestskolkning_nn_1_1_N = mkN "röstskolkning" ;
  sabelbenthet_nn_1_N = mkN "sabelbenthet" ;
  saboterbarhet_nn_1_N = mkN "saboterbarhet" ;
  sabrerbarhet_nn_1_N = mkN "sabrerbarhet" ;
  sackaros_nn_1_N = mkN "sackaros" ;
  sadelformighet_nn_1_N = mkN "sadelformighet" ;
  sadelstad_nn_1_N = mkN "sadelstad" ;
  saffransfaerg_nn_1_1_N = mkN "saffransfärg" ;
  saftighet_nn_1_N = mkN "saftighet" ;
  saftloeshet_nn_1_1_N = mkN "saftlöshet" ;
  sagalitteratur_nn_1_N = mkN "sagalitteratur" ;
  sagatid_nn_1_N = mkN "sagatid" ;
  sagolikhet_nn_1_N = mkN "sagolikhet" ;
  saint_nn_1_N = mkN "saint" ;
  sakfoerstaandighet_nn_1_1_N = mkN "sakförståndighet" ;
  sakkunnighet_nn_1_N = mkN "sakkunnighet" ;
  sakkunskap_nn_1_N = mkN "sakkunskap" ;
  sakloeshet_nn_1_1_N = mkN "saklöshet" ;
  sakpolitik_nn_1_N = mkN "sakpolitik" ;
  sakrosankthet_nn_1_N = mkN "sakrosankthet" ;
  sakraett_nn_1_1_N = mkN "sakrätt" ;
  saktfaerdighet_nn_1_1_N = mkN "saktfärdighet" ;
  saktmodighet_nn_1_N = mkN "saktmodighet" ;
  salat_nn_1_N = mkN "salat" ;
  salderbarhet_nn_1_N = mkN "salderbarhet" ;
  salep_nn_1_N = mkN "salep" ;
  salepsrot_nn_1_N = mkN "salepsrot" ;
  salicylbomull_nn_1_N = mkN "salicylbomull" ;
  salighet_nn_2_N = mkN "salighet" ;
  saliv_nn_1_N = mkN "saliv" ;
  sallat_nn_1_N = mkN "sallat" ;
  salmiak_nn_1_N = mkN "salmiak" ;
  salmiaksprit_nn_1_N = mkN "salmiaksprit" ;
  salongsfaehighet_nn_1_1_N = mkN "salongsfähighet" ;
  salongsmusik_nn_1_N = mkN "salongsmusik" ;
  saltbemaengdhet_nn_1_1_N = mkN "saltbemängdhet" ;
  saltfisk_nn_1_N = mkN "saltfisk" ;
  saltglasyr_nn_1_N = mkN "saltglasyr" ;
  salthet_nn_1_N = mkN "salthet" ;
  saltighet_nn_1_N = mkN "saltighet" ;
  saltstaenkthet_nn_1_1_N = mkN "saltstänkthet" ;
  saluterbarhet_nn_1_N = mkN "saluterbarhet" ;
  salveld_nn_1_N = mkN "salveld" ;
  samarbetsvillighet_nn_1_N = mkN "samarbetsvillighet" ;
  samdraekt_nn_1_1_N = mkN "samdräkt" ;
  samexistens_nn_1_N = mkN "samexistens" ;
  samfaellighet_nn_2_1_N = mkN "samfällighet" ;
  samfaerd_nn_1_1_N = mkN "samfärd" ;
  samhaellelighet_nn_1_1_N = mkN "samhällelighet" ;
  samhaellsfarlighet_nn_1_1_N = mkN "samhällsfarlighet" ;
  samhaellsfientlighet_nn_1_1_N = mkN "samhällsfientlighet" ;
  samhaellsfraanvaendhet_nn_1_1_N = mkN "samhällsfrånvändhet" ;
  samhaellshjaelp_nn_1_1_N = mkN "samhällshjälp" ;
  samhaellsjournalistik_nn_1_1_N = mkN "samhällsjournalistik" ;
  samhaellskritik_nn_1_1_N = mkN "samhällskritik" ;
  samhaellskunskap_nn_1_1_N = mkN "samhällskunskap" ;
  samhaellsnyttighet_nn_1_1_N = mkN "samhällsnyttighet" ;
  samhaellspolitik_nn_1_1_N = mkN "samhällspolitik" ;
  samhaellstillvaendhet_nn_1_1_N = mkN "samhällstillvändhet" ;
  samhaellsvetenskaplighet_nn_1_1_N = mkN "samhällsvetenskaplighet" ;
  samhaellsvaard_nn_1_1_N = mkN "samhällsvård" ;
  samklang_nn_1_N = mkN "samklang" ;
  samkaensla_nn_1_1_N = mkN "samkänsla" ;
  samlagsdebut_nn_1_N = mkN "samlagsdebut" ;
  samlarinstinkt_nn_1_N = mkN "samlarinstinkt" ;
  sammanhaallighet_nn_1_1_N = mkN "sammanhållighet" ;
  sammansatthet_nn_1_N = mkN "sammansatthet" ;
  sammanstoertning_nn_1_1_N = mkN "sammanstörtning" ;
  sammet_nn_1_N = mkN "sammet" ;
  sammetsmjukhet_nn_1_N = mkN "sammetsmjukhet" ;
  sammaeld_nn_1_1_N = mkN "sammäld" ;
  samraadsraett_nn_1_1_N = mkN "samrådsrätt" ;
  samsikt_nn_1_N = mkN "samsikt" ;
  samspelthet_nn_1_N = mkN "samspelthet" ;
  samstaemdhet_nn_1_1_N = mkN "samstämdhet" ;
  samstaemmighet_nn_1_1_N = mkN "samstämmighet" ;
  samsyn_nn_1_N = mkN "samsyn" ;
  samtalston_nn_1_N = mkN "samtalston" ;
  samtaxerbarhet_nn_1_N = mkN "samtaxerbarhet" ;
  samtid_nn_1_N = mkN "samtid" ;
  samtidskaensla_nn_1_1_N = mkN "samtidskänsla" ;
  samtrafik_nn_1_N = mkN "samtrafik" ;
  samum_nn_1_N = mkN "samum" ;
  samvetsfrid_nn_1_N = mkN "samvetsfrid" ;
  samvetsgrannhet_nn_1_N = mkN "samvetsgrannhet" ;
  samvetsnoed_nn_1_1_N = mkN "samvetsnöd" ;
  samvetsoemhet_nn_1_1_N = mkN "samvetsömhet" ;
  samaeganderaett_nn_1_1_N = mkN "samäganderätt" ;
  sand_nn_1_N = mkN "sand" ;
  sandflykt_nn_1_N = mkN "sandflykt" ;
  sandighet_nn_1_N = mkN "sandighet" ;
  sandnarv_nn_1_N = mkN "sandnarv" ;
  sandtrav_nn_1_N = mkN "sandtrav" ;
  sanerbarhet_nn_1_N = mkN "sanerbarhet" ;
  sanforiserbarhet_nn_1_N = mkN "sanforiserbarhet" ;
  sanitetsteknik_nn_1_N = mkN "sanitetsteknik" ;
  sankhet_nn_1_N = mkN "sankhet" ;
  sanktifierbarhet_nn_1_N = mkN "sanktifierbarhet" ;
  sanktionerbarhet_nn_1_N = mkN "sanktionerbarhet" ;
  sanktionspolitik_nn_1_N = mkN "sanktionspolitik" ;
  sannfaerdighet_nn_1_1_N = mkN "sannfärdighet" ;
  sannhet_nn_1_N = mkN "sannhet" ;
  sanningsenlighet_nn_1_N = mkN "sanningsenlighet" ;
  sanningshalt_nn_1_N = mkN "sanningshalt" ;
  sanningskaerlek_nn_1_1_N = mkN "sanningskärlek" ;
  sanningsloeshet_nn_1_1_N = mkN "sanningslöshet" ;
  sannskyldighet_nn_1_N = mkN "sannskyldighet" ;
  sannspaaddhet_nn_1_1_N = mkN "sannspåddhet" ;
  sans_nn_1_N = mkN "sans" ;
  sanskrit_nn_1_N = mkN "sanskrit" ;
  sansloeshet_nn_1_1_N = mkN "sanslöshet" ;
  saponifierbarhet_nn_1_N = mkN "saponifierbarhet" ;
  sardonyx_nn_1_N = mkN "sardonyx" ;
  sargassotaang_nn_1_1_N = mkN "sargassotång" ;
  satanskult_nn_1_N = mkN "satanskult" ;
  satinerbarhet_nn_1_N = mkN "satinerbarhet" ;
  satisfierbarhet_nn_1_N = mkN "satisfierbarhet" ;
  satthet_nn_1_N = mkN "satthet" ;
  saturerbarhet_nn_1_N = mkN "saturerbarhet" ;
  satyriasis_nn_1_N = mkN "satyriasis" ;
  satyriskhet_nn_1_N = mkN "satyriskhet" ;
  sauerkraut_nn_1_N = mkN "sauerkraut" ;
  sauterbarhet_nn_1_N = mkN "sauterbarhet" ;
  sauternes_nn_1_N = mkN "sauternes" ;
  sauverbarhet_nn_1_N = mkN "sauverbarhet" ;
  sav_nn_1_N = mkN "sav" ;
  savoir_faire_nn_1_N = mkN "savoir-faire" ;
  savojkaal_nn_1_1_N = mkN "savojkål" ;
  saxformighet_nn_1_N = mkN "saxformighet" ;
  scatsaang_nn_1_1_N = mkN "scatsång" ;
  scenkonst_nn_1_N = mkN "scenkonst" ;
  scenskraeck_nn_1_1_N = mkN "scenskräck" ;
  schablonerbarhet_nn_1_N = mkN "schablonerbarhet" ;
  schabloniserbarhet_nn_1_N = mkN "schabloniserbarhet" ;
  schablonmaessighet_nn_1_1_N = mkN "schablonmässighet" ;
  schablontaxerbarhet_nn_1_N = mkN "schablontaxerbarhet" ;
  schamponerbarhet_nn_1_N = mkN "schamponerbarhet" ;
  schatterbarhet_nn_1_N = mkN "schatterbarhet" ;
  schau_nn_1_N = mkN "schau" ;
  schellack_nn_1_N = mkN "schellack" ;
  schematiserbarhet_nn_1_N = mkN "schematiserbarhet" ;
  schizzighet_nn_1_N = mkN "schizzighet" ;
  schlagermusik_nn_1_N = mkN "schlagermusik" ;
  schnellklops_nn_1_N = mkN "schnellklops" ;
  schrammelmusik_nn_1_N = mkN "schrammelmusik" ;
  schvaback_nn_1_N = mkN "schvaback" ;
  schvung_nn_1_N = mkN "schvung" ;
  schvungfullhet_nn_1_N = mkN "schvungfullhet" ;
  schvungighet_nn_1_N = mkN "schvungighet" ;
  schwabach_nn_1_N = mkN "schwabach" ;
  schwung_nn_1_N = mkN "schwung" ;
  schwungfullhet_nn_1_N = mkN "schwungfullhet" ;
  schwungighet_nn_1_N = mkN "schwungighet" ;
  schyssthet_nn_1_N = mkN "schyssthet" ;
  schysthet_nn_1_N = mkN "schysthet" ;
  sciencefictionlitteratur_nn_1_N = mkN "sciencefictionlitteratur" ;
  scouting_nn_1_N = mkN "scouting" ;
  scrotum_nn_1_N = mkN "scrotum" ;
  sebarhet_nn_1_N = mkN "sebarhet" ;
  sedesamhet_nn_1_N = mkN "sedesamhet" ;
  sedesloeshet_nn_1_1_N = mkN "sedeslöshet" ;
  sedighet_nn_1_N = mkN "sedighet" ;
  sedimenterbarhet_nn_1_N = mkN "sedimenterbarhet" ;
  sedum_nn_1_N = mkN "sedum" ;
  sedvaneraett_nn_1_1_N = mkN "sedvanerätt" ;
  sedvanlighet_nn_1_N = mkN "sedvanlighet" ;
  sefir_nn_1_N = mkN "sefir" ;
  segelbarhet_nn_1_N = mkN "segelbarhet" ;
  segelfart_nn_1_N = mkN "segelfart" ;
  segelflykt_nn_1_N = mkN "segelflykt" ;
  segelsport_nn_1_N = mkN "segelsport" ;
  segerrikhet_nn_1_N = mkN "segerrikhet" ;
  segerrusighet_nn_1_N = mkN "segerrusighet" ;
  segersaellhet_nn_1_1_N = mkN "segersällhet" ;
  segervisshet_nn_1_N = mkN "segervisshet" ;
  segmenterbarhet_nn_1_N = mkN "segmenterbarhet" ;
  segregerbarhet_nn_1_N = mkN "segregerbarhet" ;
  sejd_nn_1_N = mkN "sejd" ;
  sejm_nn_1_N = mkN "sejm" ;
  sekonderbarhet_nn_1_N = mkN "sekonderbarhet" ;
  sekretess_nn_1_N = mkN "sekretess" ;
  sekt_nn_2_N = mkN "sekt" ;
  sekulariserbarhet_nn_1_N = mkN "sekulariserbarhet" ;
  sekunderbarhet_nn_1_N = mkN "sekunderbarhet" ;
  sekundaerluft_nn_1_1_N = mkN "sekundärluft" ;
  sekvestrerbarhet_nn_1_N = mkN "sekvestrerbarhet" ;
  selekterbarhet_nn_1_N = mkN "selekterbarhet" ;
  sellerikaal_nn_1_1_N = mkN "sellerikål" ;
  semaforerbarhet_nn_1_N = mkN "semaforerbarhet" ;
  semantik_nn_1_N = mkN "semantik" ;
  seminerbarhet_nn_1_N = mkN "seminerbarhet" ;
  semiotik_nn_1_N = mkN "semiotik" ;
  senantik_nn_1_N = mkN "senantik" ;
  senap_nn_1_N = mkN "senap" ;
  senapsgas_nn_1_N = mkN "senapsgas" ;
  senfaerdighet_nn_1_1_N = mkN "senfärdighet" ;
  sengaangaraktighet_nn_1_1_N = mkN "sengångaraktighet" ;
  senhet_nn_1_N = mkN "senhet" ;
  senighet_nn_1_N = mkN "senighet" ;
  senior_nn_2_N = mkN "senior" ;
  senklapp_nn_1_N = mkN "senklapp" ;
  senrenaessans_nn_1_1_N = mkN "senrenässans" ;
  sensationsjournalistik_nn_1_N = mkN "sensationsjournalistik" ;
  sensationslystnad_nn_1_N = mkN "sensationslystnad" ;
  sensibiliserbarhet_nn_1_N = mkN "sensibiliserbarhet" ;
  senterbarhet_nn_1_N = mkN "senterbarhet" ;
  separationsaangest_nn_1_1_N = mkN "separationsångest" ;
  separerbarhet_nn_1_N = mkN "separerbarhet" ;
  sepsis_nn_1_N = mkN "sepsis" ;
  september_nn_1_N = mkN "september" ;
  septuagesima_nn_1_N = mkN "septuagesima" ;
  serumdiagnostik_nn_1_N = mkN "serumdiagnostik" ;
  serverbarhet_nn_1_N = mkN "serverbarhet" ;
  servicekaensla_nn_1_1_N = mkN "servicekänsla" ;
  sesam_nn_1_N = mkN "sesam" ;
  sexagesima_nn_1_N = mkN "sexagesima" ;
  sexdubbling_nn_1_N = mkN "sexdubbling" ;
  sexlust_nn_1_N = mkN "sexlust" ;
  sexmobbing_nn_1_N = mkN "sexmobbing" ;
  sexualiserbarhet_nn_1_N = mkN "sexualiserbarhet" ;
  sexualkunskap_nn_1_N = mkN "sexualkunskap" ;
  sexualradikalitet_nn_1_N = mkN "sexualradikalitet" ;
  sfragistik_nn_1_N = mkN "sfragistik" ;
  shag_nn_1_N = mkN "shag" ;
  shamponerbarhet_nn_1_N = mkN "shamponerbarhet" ;
  shantung_nn_1_N = mkN "shantung" ;
  shelf_nn_1_N = mkN "shelf" ;
  shelfis_nn_1_N = mkN "shelfis" ;
  shetlandsull_nn_1_N = mkN "shetlandsull" ;
  shia_nn_1_N = mkN "shia" ;
  shipping_nn_1_N = mkN "shipping" ;
  shirting_nn_1_N = mkN "shirting" ;
  shopping_nn_1_N = mkN "shopping" ;
  showbiz_nn_1_N = mkN "showbiz" ;
  sial_nn_1_N = mkN "sial" ;
  sicksack_nn_2_N = mkN "sicksack" ;
  siderit_nn_1_N = mkN "siderit" ;
  sideros_nn_1_N = mkN "sideros" ;
  sidnumrerbarhet_nn_1_N = mkN "sidnumrerbarhet" ;
  sidohaensyn_nn_1_1_N = mkN "sidohänsyn" ;
  sifferblindhet_nn_1_N = mkN "sifferblindhet" ;
  sigillerbarhet_nn_1_N = mkN "sigillerbarhet" ;
  signalerbarhet_nn_1_N = mkN "signalerbarhet" ;
  signaltjaenst_nn_1_1_N = mkN "signaltjänst" ;
  signaloeverfoering_nn_1_1_N = mkN "signalöverföring" ;
  signerbarhet_nn_1_N = mkN "signerbarhet" ;
  sikt_nn_1_N = mkN "sikt" ;
  siktbarhet_nn_1_N = mkN "siktbarhet" ;
  siktighet_nn_1_N = mkN "siktighet" ;
  silhuetterbarhet_nn_1_N = mkN "silhuetterbarhet" ;
  silikos_nn_1_N = mkN "silikos" ;
  silkesbomull_nn_1_N = mkN "silkesbomull" ;
  silkighet_nn_1_N = mkN "silkighet" ;
  silt_nn_1_N = mkN "silt" ;
  siluetterbarhet_nn_1_N = mkN "siluetterbarhet" ;
  silverblondhet_nn_1_N = mkN "silverblondhet" ;
  silverbromid_nn_1_N = mkN "silverbromid" ;
  silverglans_nn_1_N = mkN "silverglans" ;
  silverklang_nn_1_N = mkN "silverklang" ;
  silverklorid_nn_1_N = mkN "silverklorid" ;
  silverputs_nn_1_N = mkN "silverputs" ;
  silvertejp_nn_1_N = mkN "silvertejp" ;
  silveroert_nn_1_1_N = mkN "silverört" ;
  silvrighet_nn_1_N = mkN "silvrighet" ;
  simhud_nn_1_N = mkN "simhud" ;
  simkunnighet_nn_1_N = mkN "simkunnighet" ;
  simmighet_nn_1_N = mkN "simmighet" ;
  simplextrafik_nn_1_N = mkN "simplextrafik" ;
  simplifierbarhet_nn_1_N = mkN "simplifierbarhet" ;
  simulerbarhet_nn_1_N = mkN "simulerbarhet" ;
  singularis_nn_1_N = mkN "singularis" ;
  sinisterhet_nn_1_N = mkN "sinisterhet" ;
  sinnesfrid_nn_1_N = mkN "sinnesfrid" ;
  sinnessjukhet_nn_1_N = mkN "sinnessjukhet" ;
  sinnessjukvaard_nn_1_1_N = mkN "sinnessjukvård" ;
  sinnessloehet_nn_1_1_N = mkN "sinnesslöhet" ;
  sinnessvaghet_nn_1_N = mkN "sinnessvaghet" ;
  sinnevaerld_nn_1_1_N = mkN "sinnevärld" ;
  sinnrikhet_nn_1_N = mkN "sinnrikhet" ;
  sipphet_nn_1_N = mkN "sipphet" ;
  sir_nn_2_N = mkN "sir" ;
  sirap_nn_1_N = mkN "sirap" ;
  sirapssoethet_nn_1_1_N = mkN "sirapssöthet" ;
  siratlighet_nn_1_N = mkN "siratlighet" ;
  sisal_nn_1_N = mkN "sisal" ;
  sittriktighet_nn_1_N = mkN "sittriktighet" ;
  sittvaenlighet_nn_1_1_N = mkN "sittvänlighet" ;
  situationskomik_nn_1_N = mkN "situationskomik" ;
  sjabbighet_nn_1_N = mkN "sjabbighet" ;
  sjaslik_nn_1_N = mkN "sjaslik" ;
  sjavighet_nn_1_N = mkN "sjavighet" ;
  sjukgymnastik_nn_1_N = mkN "sjukgymnastik" ;
  sjukhussjuka_nn_1_N = mkN "sjukhussjuka" ;
  sjukhusvaard_nn_1_1_N = mkN "sjukhusvård" ;
  sjukpeng_nn_1_N = mkN "sjukpeng" ;
  sjukvaard_nn_1_1_N = mkN "sjukvård" ;
  sjukvaardspersonal_nn_1_1_N = mkN "sjukvårdspersonal" ;
  sjukvaardspolitik_nn_1_1_N = mkN "sjukvårdspolitik" ;
  sjysthet_nn_1_N = mkN "sjysthet" ;
  sjaelanoed_nn_1_1_N = mkN "själanöd" ;
  sjaelavaard_nn_1_1_N = mkN "själavård" ;
  sjaelfullhet_nn_1_1_N = mkN "själfullhet" ;
  sjaelsfinhet_nn_1_1_N = mkN "själsfinhet" ;
  sjaelslighet_nn_1_1_N = mkN "själslighet" ;
  sjaelsnoed_nn_1_1_N = mkN "själsnöd" ;
  sjaelssjukhet_nn_1_1_N = mkN "själssjukhet" ;
  sjaelvbevarelsedrift_nn_1_1_N = mkN "självbevarelsedrift" ;
  sjaelvdisciplin_nn_1_1_N = mkN "självdisciplin" ;
  sjaelvfinansierbarhet_nn_1_1_N = mkN "självfinansierbarhet" ;
  sjaelvfoerbraenning_nn_1_1_N = mkN "självförbränning" ;
  sjaelvfoernedring_nn_1_1_N = mkN "självförnedring" ;
  sjaelvfoersoerjning_nn_1_1_N = mkN "självförsörjning" ;
  sjaelvhjaelp_nn_1_1_N = mkN "självhjälp" ;
  sjaelvhjaelpslitteratur_nn_1_1_N = mkN "självhjälpslitteratur" ;
  sjaelvhaerlighet_nn_1_1_N = mkN "självhärlighet" ;
  sjaelvkontroll_nn_1_1_N = mkN "självkontroll" ;
  sjaelvkritik_nn_1_1_N = mkN "självkritik" ;
  sjaelvkaensla_nn_1_1_N = mkN "självkänsla" ;
  sjaelvkaerlek_nn_1_1_N = mkN "självkärlek" ;
  sjaelvlaerdhet_nn_1_1_N = mkN "självlärdhet" ;
  sjaelvraettfaerdighet_nn_1_1_N = mkN "självrättfärdighet" ;
  sjaelvraadighet_nn_1_1_N = mkN "självrådighet" ;
  sjaelvskrivenhet_nn_1_1_N = mkN "självskrivenhet" ;
  sjaelvstart_nn_1_1_N = mkN "självstart" ;
  sjaelvsvaaldighet_nn_1_1_N = mkN "självsvåldighet" ;
  sjaelvsaadd_nn_1_1_N = mkN "självsådd" ;
  sjaelvtillit_nn_1_1_N = mkN "självtillit" ;
  sjaelvtillraecklighet_nn_1_1_N = mkN "självtillräcklighet" ;
  sjaelvtaekt_nn_1_1_N = mkN "självtäkt" ;
  sjaelvupplevdhet_nn_1_1_N = mkN "självupplevdhet" ;
  sjaelvupptagenhet_nn_1_1_N = mkN "självupptagenhet" ;
  sjaelvverksamhet_nn_1_1_N = mkN "självverksamhet" ;
  sjaapighet_nn_1_1_N = mkN "sjåpighet" ;
  sjoebris_nn_1_1_N = mkN "sjöbris" ;
  sjoeduglighet_nn_1_1_N = mkN "sjöduglighet" ;
  sjoefart_nn_1_1_N = mkN "sjöfart" ;
  sjoefartspolitik_nn_1_1_N = mkN "sjöfartspolitik" ;
  sjoegaang_nn_1_1_N = mkN "sjögång" ;
  sjoeluft_nn_1_1_N = mkN "sjöluft" ;
  sjoemalm_nn_1_1_N = mkN "sjömalm" ;
  sjoemansbiff_nn_1_1_N = mkN "sjömansbiff" ;
  sjoenoed_nn_1_1_N = mkN "sjönöd" ;
  sjoenoet_nn_1_1_N = mkN "sjönöt" ;
  sjoeraett_nn_1_1_N = mkN "sjörätt" ;
  sjoeroek_nn_1_1_N = mkN "sjörök" ;
  sjoesjuka_nn_1_1_N = mkN "sjösjuka" ;
  sjoesjukhet_nn_1_1_N = mkN "sjösjukhet" ;
  sjoesaekerhet_nn_1_1_N = mkN "sjösäkerhet" ;
  sjoeutsikt_nn_1_1_N = mkN "sjöutsikt" ;
  sjoevildhet_nn_1_1_N = mkN "sjövildhet" ;
  sjoevaeg_nn_1_1_N = mkN "sjöväg" ;
  skabb_nn_1_N = mkN "skabb" ;
  skabbighet_nn_1_N = mkN "skabbighet" ;
  skadedjursbekaempning_nn_1_1_N = mkN "skadedjursbekämpning" ;
  skadereglerbarhet_nn_1_N = mkN "skadereglerbarhet" ;
  skadesloeshet_nn_1_1_N = mkN "skadeslöshet" ;
  skadestaandsskyldighet_nn_1_1_N = mkN "skadeståndsskyldighet" ;
  skaktaalighet_nn_1_1_N = mkN "skaktålighet" ;
  skaldegaava_nn_1_1_N = mkN "skaldegåva" ;
  skalenlighet_nn_1_N = mkN "skalenlighet" ;
  skalkaktighet_nn_1_N = mkN "skalkaktighet" ;
  skallighet_nn_1_N = mkN "skallighet" ;
  skalloeshet_nn_1_1_N = mkN "skallöshet" ;
  skalperbarhet_nn_1_N = mkN "skalperbarhet" ;
  skamsenhet_nn_1_N = mkN "skamsenhet" ;
  skandaliserbarhet_nn_1_N = mkN "skandaliserbarhet" ;
  skanderbarhet_nn_1_N = mkN "skanderbarhet" ;
  skaplighet_nn_1_N = mkN "skaplighet" ;
  skarpblick_nn_1_N = mkN "skarpblick" ;
  skarphet_nn_1_N = mkN "skarphet" ;
  skarpsinnighet_nn_1_N = mkN "skarpsinnighet" ;
  skarpsynthet_nn_1_N = mkN "skarpsynthet" ;
  skarpsaas_nn_1_1_N = mkN "skarpsås" ;
  skarpoegdhet_nn_1_1_N = mkN "skarpögdhet" ;
  skatteflykt_nn_1_N = mkN "skatteflykt" ;
  skatteplanerbarhet_nn_1_N = mkN "skatteplanerbarhet" ;
  skatteplikt_nn_1_N = mkN "skatteplikt" ;
  skattepliktighet_nn_1_N = mkN "skattepliktighet" ;
  skattepolitik_nn_1_N = mkN "skattepolitik" ;
  skattepopulism_nn_1_N = mkN "skattepopulism" ;
  skattskyldighet_nn_1_N = mkN "skattskyldighet" ;
  skavllerpress_nn_1_N = mkN "skavllerpress" ;
  skedsovning_nn_1_N = mkN "skedsovning" ;
  skeleton_nn_1_N = mkN "skeleton" ;
  skelettmuskulatur_nn_1_N = mkN "skelettmuskulatur" ;
  skeloert_nn_1_1_N = mkN "skelört" ;
  skenbarhet_nn_1_N = mkN "skenbarhet" ;
  skendoedhet_nn_1_1_N = mkN "skendödhet" ;
  skenplockning_nn_1_N = mkN "skenplockning" ;
  skeppsfart_nn_1_N = mkN "skeppsfart" ;
  skeppsproviant_nn_1_N = mkN "skeppsproviant" ;
  skepsis_nn_1_N = mkN "skepsis" ;
  skiffrighet_nn_1_N = mkN "skiffrighet" ;
  skiljbarhet_nn_1_N = mkN "skiljbarhet" ;
  skineffekt_nn_1_N = mkN "skineffekt" ;
  skinntorrhet_nn_1_N = mkN "skinntorrhet" ;
  skirhet_nn_1_N = mkN "skirhet" ;
  skisserbarhet_nn_1_N = mkN "skisserbarhet" ;
  skitfoernaemhet_nn_1_1_N = mkN "skitförnämhet" ;
  skitnoedighet_nn_1_1_N = mkN "skitnödighet" ;
  skitsnygghet_nn_1_N = mkN "skitsnygghet" ;
  skittraakighet_nn_1_1_N = mkN "skittråkighet" ;
  skitviktighet_nn_1_N = mkN "skitviktighet" ;
  skjutbarhet_nn_1_N = mkN "skjutbarhet" ;
  skogfattighet_nn_1_N = mkN "skogfattighet" ;
  skogighet_nn_1_N = mkN "skogighet" ;
  skogklaeddhet_nn_1_1_N = mkN "skogkläddhet" ;
  skogloeshet_nn_1_1_N = mkN "skoglöshet" ;
  skogsdoed_nn_1_1_N = mkN "skogsdöd" ;
  skogsgenetik_nn_1_N = mkN "skogsgenetik" ;
  skogsgraens_nn_1_1_N = mkN "skogsgräns" ;
  skogshushaallning_nn_1_1_N = mkN "skogshushållning" ;
  skogsrand_nn_1_N = mkN "skogsrand" ;
  skogsterraeng_nn_1_1_N = mkN "skogsterräng" ;
  skogsvaard_nn_1_1_N = mkN "skogsvård" ;
  skolastik_nn_1_N = mkN "skolastik" ;
  skolgaang_nn_1_1_N = mkN "skolgång" ;
  skolhaelsovaard_nn_1_1_N = mkN "skolhälsovård" ;
  skolios_nn_1_N = mkN "skolios" ;
  skoljazz_nn_1_N = mkN "skoljazz" ;
  skolmat_nn_1_N = mkN "skolmat" ;
  skolmatematik_nn_1_N = mkN "skolmatematik" ;
  skolmaestaraktighet_nn_1_1_N = mkN "skolmästaraktighet" ;
  skolpersonal_nn_1_N = mkN "skolpersonal" ;
  skolpolitik_nn_1_N = mkN "skolpolitik" ;
  skolsjukhet_nn_1_N = mkN "skolsjukhet" ;
  skoltroetthet_nn_1_1_N = mkN "skoltrötthet" ;
  skongaang_nn_1_1_N = mkN "skongång" ;
  skonsamhet_nn_1_N = mkN "skonsamhet" ;
  skorbut_nn_1_N = mkN "skorbut" ;
  skorstensroek_nn_1_1_N = mkN "skorstensrök" ;
  skorv_nn_1_N = mkN "skorv" ;
  skorvighet_nn_1_N = mkN "skorvighet" ;
  skotskhet_nn_1_N = mkN "skotskhet" ;
  skottfrihet_nn_1_N = mkN "skottfrihet" ;
  skottraeddhet_nn_1_1_N = mkN "skotträddhet" ;
  skottsaekerhet_nn_1_1_N = mkN "skottsäkerhet" ;
  skrabbighet_nn_1_N = mkN "skrabbighet" ;
  skrafferbarhet_nn_1_N = mkN "skrafferbarhet" ;
  skrajhet_nn_1_N = mkN "skrajhet" ;
  skralhet_nn_1_N = mkN "skralhet" ;
  skraltighet_nn_1_N = mkN "skraltighet" ;
  skramlighet_nn_1_N = mkN "skramlighet" ;
  skranglighet_nn_1_N = mkN "skranglighet" ;
  skrapnos_nn_1_N = mkN "skrapnos" ;
  skrattlust_nn_1_N = mkN "skrattlust" ;
  skriftlighet_nn_1_N = mkN "skriftlighet" ;
  skrikighet_nn_1_N = mkN "skrikighet" ;
  skritt_nn_1_N = mkN "skritt" ;
  skrivbordsjournalistik_nn_1_N = mkN "skrivbordsjournalistik" ;
  skrivbordstjaenst_nn_1_1_N = mkN "skrivbordstjänst" ;
  skrivkramp_nn_1_N = mkN "skrivkramp" ;
  skrivkunnighet_nn_1_N = mkN "skrivkunnighet" ;
  skrot_nn_2_N = mkN "skrot" ;
  skrumpenhet_nn_1_N = mkN "skrumpenhet" ;
  skruttighet_nn_1_N = mkN "skruttighet" ;
  skruvis_nn_1_N = mkN "skruvis" ;
  skrynklighet_nn_1_N = mkN "skrynklighet" ;
  skrytsamhet_nn_1_N = mkN "skrytsamhet" ;
  skraellhosta_nn_1_1_N = mkN "skrällhosta" ;
  skraellighet_nn_1_1_N = mkN "skrällighet" ;
  skraepighet_nn_1_1_N = mkN "skräpighet" ;
  skraepmat_nn_1_1_N = mkN "skräpmat" ;
  skraepplockning_nn_1_1_N = mkN "skräpplockning" ;
  skraeppost_nn_1_1_N = mkN "skräppost" ;
  skraevlighet_nn_1_1_N = mkN "skrävlighet" ;
  skuggighet_nn_1_N = mkN "skuggighet" ;
  skuggloeshet_nn_1_1_N = mkN "skugglöshet" ;
  skuldfrihet_nn_1_N = mkN "skuldfrihet" ;
  skuldloeshet_nn_1_1_N = mkN "skuldlöshet" ;
  skuldsatthet_nn_1_N = mkN "skuldsatthet" ;
  skuldsaettning_nn_1_1_N = mkN "skuldsättning" ;
  skuldtyngdhet_nn_1_N = mkN "skuldtyngdhet" ;
  skulpterbarhet_nn_1_N = mkN "skulpterbarhet" ;
  skulpturerbarhet_nn_1_N = mkN "skulpturerbarhet" ;
  skumhet_nn_1_N = mkN "skumhet" ;
  skummighet_nn_1_N = mkN "skummighet" ;
  skummjoelk_nn_1_1_N = mkN "skummjölk" ;
  skumpighet_nn_1_N = mkN "skumpighet" ;
  skumplast_nn_1_N = mkN "skumplast" ;
  skumplasttejp_nn_1_N = mkN "skumplasttejp" ;
  skumoegdhet_nn_1_1_N = mkN "skumögdhet" ;
  skvalleraktighet_nn_1_N = mkN "skvalleraktighet" ;
  skvallerkaal_nn_1_1_N = mkN "skvallerkål" ;
  skvallrighet_nn_1_N = mkN "skvallrighet" ;
  skvalmusik_nn_1_N = mkN "skvalmusik" ;
  skvalpighet_nn_1_N = mkN "skvalpighet" ;
  skvattram_nn_1_N = mkN "skvattram" ;
  skyddsimpregnerbarhet_nn_1_N = mkN "skyddsimpregnerbarhet" ;
  skyddsloeshet_nn_1_1_N = mkN "skyddslöshet" ;
  skyddstillsyn_nn_1_N = mkN "skyddstillsyn" ;
  skyddstjaenst_nn_1_1_N = mkN "skyddstjänst" ;
  skygghet_nn_1_N = mkN "skygghet" ;
  skyighet_nn_1_N = mkN "skyighet" ;
  skymflighet_nn_1_N = mkN "skymflighet" ;
  skyndsamhet_nn_1_N = mkN "skyndsamhet" ;
  skytteltrafik_nn_1_N = mkN "skytteltrafik" ;
  skaeckighet_nn_1_1_N = mkN "skäckighet" ;
  skaeftighet_nn_1_1_N = mkN "skäftighet" ;
  skaeggighet_nn_1_1_N = mkN "skäggighet" ;
  skaegglav_nn_1_1_N = mkN "skägglav" ;
  skaeggloeshet_nn_1_1_N = mkN "skägglöshet" ;
  skaeggstubb_nn_1_1_N = mkN "skäggstubb" ;
  skaeggsvamp_nn_1_1_N = mkN "skäggsvamp" ;
  skaekt_nn_1_1_N = mkN "skäkt" ;
  skaelighet_nn_1_1_N = mkN "skälighet" ;
  skaelmaktighet_nn_1_1_N = mkN "skälmaktighet" ;
  skaelmskhet_nn_1_1_N = mkN "skälmskhet" ;
  skaelvesot_nn_1_1_N = mkN "skälvesot" ;
  skaelvosot_nn_1_1_N = mkN "skälvosot" ;
  skaemdhet_nn_1_1_N = mkN "skämdhet" ;
  skaemmighet_nn_1_1_N = mkN "skämmighet" ;
  skaenkelhjaelp_nn_1_1_N = mkN "skänkelhjälp" ;
  skaerhet_nn_1_1_N = mkN "skärhet" ;
  skaerkapacitet_nn_1_1_N = mkN "skärkapacitet" ;
  skaerpning_nn_1_1_N = mkN "skärpning" ;
  skaerpthet_nn_1_1_N = mkN "skärpthet" ;
  skaerseld_nn_1_1_N = mkN "skärseld" ;
  skaertorv_nn_1_1_N = mkN "skärtorv" ;
  skaadespelarkonst_nn_1_1_N = mkN "skådespelarkonst" ;
  skaalformighet_nn_1_1_N = mkN "skålformighet" ;
  skaalighet_nn_1_1_N = mkN "skålighet" ;
  skaalrost_nn_1_1_N = mkN "skålrost" ;
  skaanskhet_nn_1_1_N = mkN "skånskhet" ;
  skaapmat_nn_1_1_N = mkN "skåpmat" ;
  skoeldpadd_nn_1_1_N = mkN "sköldpadd" ;
  skoeldpaddsjakt_nn_1_1_N = mkN "sköldpaddsjakt" ;
  skoenhet_nn_2_1_N = mkN "skönhet" ;
  skoenhetssoemn_nn_1_1_N = mkN "skönhetssömn" ;
  skoenhetsvaard_nn_1_1_N = mkN "skönhetsvård" ;
  skoenjbarhet_nn_1_1_N = mkN "skönjbarhet" ;
  skoenlitteratur_nn_1_1_N = mkN "skönlitteratur" ;
  skoenlockighet_nn_1_1_N = mkN "skönlockighet" ;
  skoenskrift_nn_1_1_N = mkN "skönskrift" ;
  skoenstaxerbarhet_nn_1_1_N = mkN "skönstaxerbarhet" ;
  skoentaxerbarhet_nn_1_1_N = mkN "sköntaxerbarhet" ;
  skoerbjugg_nn_1_1_N = mkN "skörbjugg" ;
  skoerbjuggsoert_nn_1_1_N = mkN "skörbjuggsört" ;
  skoerdeand_nn_1_1_N = mkN "skördeand" ;
  skoerhet_nn_1_1_N = mkN "skörhet" ;
  skoerl_nn_1_1_N = mkN "skörl" ;
  skoetsamhet_nn_1_1_N = mkN "skötsamhet" ;
  slabbhet_nn_1_N = mkN "slabbhet" ;
  slabbighet_nn_1_N = mkN "slabbighet" ;
  slackhet_nn_1_N = mkN "slackhet" ;
  sladdighet_nn_1_N = mkN "sladdighet" ;
  sladdrighet_nn_1_N = mkN "sladdrighet" ;
  slafsighet_nn_1_N = mkN "slafsighet" ;
  slagfaerdighet_nn_1_1_N = mkN "slagfärdighet" ;
  slaggighet_nn_1_N = mkN "slaggighet" ;
  slagkraft_nn_1_N = mkN "slagkraft" ;
  slagkraftighet_nn_1_N = mkN "slagkraftighet" ;
  slagordsmaessighet_nn_1_1_N = mkN "slagordsmässighet" ;
  slagrodd_nn_1_N = mkN "slagrodd" ;
  slagtaalighet_nn_1_1_N = mkN "slagtålighet" ;
  slagvolym_nn_1_N = mkN "slagvolym" ;
  slakhet_nn_1_N = mkN "slakhet" ;
  slaktvikt_nn_1_N = mkN "slaktvikt" ;
  slalom_nn_1_N = mkN "slalom" ;
  slamfaerg_nn_1_1_N = mkN "slamfärg" ;
  slammighet_nn_1_N = mkN "slammighet" ;
  slampighet_nn_1_N = mkN "slampighet" ;
  slamsighet_nn_1_N = mkN "slamsighet" ;
  slang_nn_2_N = mkN "slang" ;
  slangloeshet_nn_1_1_N = mkN "slanglöshet" ;
  slangning_nn_1_N = mkN "slangning" ;
  slankhet_nn_1_N = mkN "slankhet" ;
  slankighet_nn_1_N = mkN "slankighet" ;
  slapphet_nn_1_N = mkN "slapphet" ;
  slapphaenthet_nn_1_1_N = mkN "slapphänthet" ;
  slappzappning_nn_1_N = mkN "slappzappning" ;
  slapstick_nn_1_N = mkN "slapstick" ;
  slaskighet_nn_1_N = mkN "slaskighet" ;
  slattrighet_nn_1_N = mkN "slattrighet" ;
  slaviserbarhet_nn_1_N = mkN "slaviserbarhet" ;
  slaviskhet_nn_1_N = mkN "slaviskhet" ;
  slavistik_nn_1_N = mkN "slavistik" ;
  slemhet_nn_1_N = mkN "slemhet" ;
  slemloesning_nn_1_1_N = mkN "slemlösning" ;
  slemmighet_nn_1_N = mkN "slemmighet" ;
  slentrian_nn_1_N = mkN "slentrian" ;
  sliddrighet_nn_1_N = mkN "sliddrighet" ;
  slig_nn_1_N = mkN "slig" ;
  slingrighet_nn_1_N = mkN "slingrighet" ;
  slinkighet_nn_1_N = mkN "slinkighet" ;
  slipning_nn_1_N = mkN "slipning" ;
  slirighet_nn_1_N = mkN "slirighet" ;
  sliskighet_nn_1_N = mkN "sliskighet" ;
  slitsamhet_nn_1_N = mkN "slitsamhet" ;
  slitstarkhet_nn_1_N = mkN "slitstarkhet" ;
  slittaalighet_nn_1_1_N = mkN "slittålighet" ;
  slivovits_nn_1_N = mkN "slivovits" ;
  slivovitz_nn_1_N = mkN "slivovitz" ;
  sliwowitz_nn_1_N = mkN "sliwowitz" ;
  slosill_nn_1_N = mkN "slosill" ;
  slottslikhet_nn_1_N = mkN "slottslikhet" ;
  sluddrighet_nn_1_N = mkN "sluddrighet" ;
  slumpmaessighet_nn_1_1_N = mkN "slumpmässighet" ;
  sluring_nn_1_N = mkN "sluring" ;
  slurpning_nn_1_N = mkN "slurpning" ;
  sluskighet_nn_1_N = mkN "sluskighet" ;
  slutenhet_nn_1_N = mkN "slutenhet" ;
  slutenvaard_nn_1_1_N = mkN "slutenvård" ;
  slutgiltighet_nn_1_N = mkN "slutgiltighet" ;
  slutkoerdhet_nn_1_1_N = mkN "slutkördhet" ;
  slutlighet_nn_1_N = mkN "slutlighet" ;
  sluttamp_nn_1_N = mkN "sluttamp" ;
  slaengighet_nn_1_1_N = mkN "slängighet" ;
  slaepighet_nn_1_1_N = mkN "släpighet" ;
  slaepphaenthet_nn_1_1_N = mkN "släpphänthet" ;
  slaepsamhet_nn_1_1_N = mkN "släpsamhet" ;
  slaethet_nn_1_1_N = mkN "släthet" ;
  slaethaarighet_nn_1_1_N = mkN "släthårighet" ;
  sloedryck_nn_1_1_N = mkN "slödryck" ;
  sloehet_nn_2_1_N = mkN "slöhet" ;
  sloer_nn_1_1_N = mkN "slör" ;
  sloesaktighet_nn_1_1_N = mkN "slösaktighet" ;
  sloesinthet_nn_1_1_N = mkN "slösinthet" ;
  sloesaed_nn_1_1_N = mkN "slösäd" ;
  smalhet_nn_1_N = mkN "smalhet" ;
  smalspaarighet_nn_1_1_N = mkN "smalspårighet" ;
  smalt_nn_1_N = mkN "smalt" ;
  smalts_nn_1_N = mkN "smalts" ;
  smarrighet_nn_1_N = mkN "smarrighet" ;
  smekmaanadslyx_nn_1_1_N = mkN "smekmånadslyx" ;
  smeksamhet_nn_1_N = mkN "smeksamhet" ;
  smetighet_nn_1_N = mkN "smetighet" ;
  smidbarhet_nn_1_N = mkN "smidbarhet" ;
  smidighet_nn_1_N = mkN "smidighet" ;
  smilighet_nn_1_N = mkN "smilighet" ;
  smilskhet_nn_1_N = mkN "smilskhet" ;
  sminkrot_nn_1_N = mkN "sminkrot" ;
  smittfrihet_nn_1_N = mkN "smittfrihet" ;
  smittosamhet_nn_1_N = mkN "smittosamhet" ;
  smittsamhet_nn_1_N = mkN "smittsamhet" ;
  smittspridning_nn_1_N = mkN "smittspridning" ;
  smittspaarning_nn_1_1_N = mkN "smittspårning" ;
  smock_nn_1_N = mkN "smock" ;
  smockfullhet_nn_1_N = mkN "smockfullhet" ;
  smog_nn_1_N = mkN "smog" ;
  smolt_nn_1_N = mkN "smolt" ;
  smuggelsprit_nn_1_N = mkN "smuggelsprit" ;
  smulighet_nn_1_N = mkN "smulighet" ;
  smuts_nn_1_N = mkN "smuts" ;
  smutsighet_nn_1_N = mkN "smutsighet" ;
  smutskastning_nn_1_N = mkN "smutskastning" ;
  smutslitteratur_nn_1_N = mkN "smutslitteratur" ;
  smutstvaett_nn_1_1_N = mkN "smutstvätt" ;
  smygislamisering_nn_1_N = mkN "smygislamisering" ;
  smygroekning_nn_1_1_N = mkN "smygrökning" ;
  smaeckerhet_nn_1_1_N = mkN "smäckerhet" ;
  smaeckfethet_nn_1_1_N = mkN "smäckfethet" ;
  smaeckfullhet_nn_1_1_N = mkN "smäckfullhet" ;
  smaeckighet_nn_1_1_N = mkN "smäckighet" ;
  smaellfethet_nn_1_1_N = mkN "smällfethet" ;
  smaeltmetall_nn_1_1_N = mkN "smältmetall" ;
  smaertaktivering_nn_1_1_N = mkN "smärtaktivering" ;
  smaertfrihet_nn_1_1_N = mkN "smärtfrihet" ;
  smaertgraens_nn_1_1_N = mkN "smärtgräns" ;
  smaerthet_nn_1_1_N = mkN "smärthet" ;
  smaerting_nn_1_1_N = mkN "smärting" ;
  smaertsamhet_nn_1_1_N = mkN "smärtsamhet" ;
  smaerttaalighet_nn_1_1_N = mkN "smärttålighet" ;
  smaaelakhet_nn_1_1_N = mkN "småelakhet" ;
  smaagnabbighet_nn_1_1_N = mkN "smågnabbighet" ;
  smaakornighet_nn_1_1_N = mkN "småkornighet" ;
  smaasinthet_nn_1_1_N = mkN "småsinthet" ;
  smaaskalighet_nn_1_1_N = mkN "småskalighet" ;
  smaaviktighet_nn_1_1_N = mkN "småviktighet" ;
  smaavaexthet_nn_1_1_N = mkN "småväxthet" ;
  smoerdeg_nn_1_1_N = mkN "smördeg" ;
  smoergaasmat_nn_1_1_N = mkN "smörgåsmat" ;
  smoerjighet_nn_1_1_N = mkN "smörjighet" ;
  smoerkraem_nn_1_1_N = mkN "smörkräm" ;
  smoersaang_nn_1_1_N = mkN "smörsång" ;
  snabbeld_nn_1_N = mkN "snabbeld" ;
  snabbloeslighet_nn_1_1_N = mkN "snabblöslighet" ;
  snabbmat_nn_1_N = mkN "snabbmat" "snabbmater" ;
  snabbskrift_nn_1_N = mkN "snabbskrift" ;
  snabbtaenkthet_nn_1_1_N = mkN "snabbtänkthet" ;
  snackesalighet_nn_1_N = mkN "snackesalighet" ;
  snacksalighet_nn_1_N = mkN "snacksalighet" ;
  snagg_nn_1_N = mkN "snagg" ;
  snarfagerhet_nn_1_N = mkN "snarfagerhet" ;
  snarfyndighet_nn_1_N = mkN "snarfyndighet" ;
  snarfaerdighet_nn_1_1_N = mkN "snarfärdighet" ;
  snarhet_nn_1_N = mkN "snarhet" ;
  snarlighet_nn_1_N = mkN "snarlighet" ;
  snarlikhet_nn_1_N = mkN "snarlikhet" ;
  snarstuckenhet_nn_1_N = mkN "snarstuckenhet" ;
  snartaenkthet_nn_1_1_N = mkN "snartänkthet" ;
  snarvackerhet_nn_1_N = mkN "snarvackerhet" ;
  snedparkerbarhet_nn_1_N = mkN "snedparkerbarhet" ;
  snedrekryterbarhet_nn_1_N = mkN "snedrekryterbarhet" ;
  snedrygg_nn_1_N = mkN "snedrygg" ;
  snedvinklighet_nn_1_N = mkN "snedvinklighet" ;
  snedoegdhet_nn_1_1_N = mkN "snedögdhet" ;
  snibbighet_nn_1_N = mkN "snibbighet" ;
  snigelfart_nn_1_N = mkN "snigelfart" ;
  snigelpost_nn_1_N = mkN "snigelpost" ;
  snikenhet_nn_1_N = mkN "snikenhet" ;
  snip_nn_2_N = mkN "snip" ;
  snirklighet_nn_1_N = mkN "snirklighet" ;
  snits_nn_1_N = mkN "snits" ;
  snitsighet_nn_1_N = mkN "snitsighet" ;
  snobbighet_nn_1_N = mkN "snobbighet" ;
  snofsighet_nn_1_N = mkN "snofsighet" ;
  snopenhet_nn_1_N = mkN "snopenhet" ;
  snorighet_nn_1_N = mkN "snorighet" ;
  snorkighet_nn_1_N = mkN "snorkighet" ;
  snubblighet_nn_1_N = mkN "snubblighet" ;
  snurr_nn_1_N = mkN "snurr" ;
  snurrbarhet_nn_1_N = mkN "snurrbarhet" ;
  snusfoernuftighet_nn_1_1_N = mkN "snusförnuftighet" ;
  snustorrhet_nn_1_N = mkN "snustorrhet" ;
  snut_nn_2_N = mkN "snut" ;
  snutfagerhet_nn_1_N = mkN "snutfagerhet" ;
  snutmoral_nn_1_N = mkN "snutmoral" ;
  snuttifiering_nn_1_N = mkN "snuttifiering" ;
  snygghet_nn_1_N = mkN "snygghet" ;
  snyltrot_nn_1_N = mkN "snyltrot" ;
  snaerjighet_nn_1_1_N = mkN "snärjighet" ;
  snaertighet_nn_1_1_N = mkN "snärtighet" ;
  snaesighet_nn_1_1_N = mkN "snäsighet" ;
  snaevhet_nn_1_1_N = mkN "snävhet" ;
  snaalblaast_nn_1_1_N = mkN "snålblåst" ;
  snaalhet_nn_1_1_N = mkN "snålhet" ;
  snaalskjuts_nn_1_1_N = mkN "snålskjuts" ;
  snoebark_nn_1_1_N = mkN "snöbark" ;
  snoedhet_nn_1_1_N = mkN "snödhet" ;
  snoedrift_nn_1_1_N = mkN "snödrift" ;
  snoegraens_nn_1_1_N = mkN "snögräns" ;
  snoemodd_nn_1_1_N = mkN "snömodd" ;
  snoeplighet_nn_1_1_N = mkN "snöplighet" ;
  snoerikhet_nn_1_1_N = mkN "snörikhet" ;
  snoerpighet_nn_1_1_N = mkN "snörpighet" ;
  snoerraethet_nn_1_1_N = mkN "snörräthet" ;
  snoervlighet_nn_1_1_N = mkN "snörvlighet" ;
  snoeroejningskapacitet_nn_1_1_N = mkN "snöröjningskapacitet" ;
  snoeroejningspersonal_nn_1_1_N = mkN "snöröjningspersonal" ;
  snoeskottning_nn_1_1_N = mkN "snöskottning" ;
  snoesvaeng_nn_1_1_N = mkN "snösväng" ;
  socialhjaelp_nn_1_1_N = mkN "socialhjälp" ;
  socialiserbarhet_nn_1_N = mkN "socialiserbarhet" ;
  socialmedicin_nn_1_N = mkN "socialmedicin" ;
  socialpolitik_nn_1_N = mkN "socialpolitik" ;
  socialtjaenst_nn_1_1_N = mkN "socialtjänst" ;
  socialvaard_nn_1_1_N = mkN "socialvård" ;
  sociolingvistik_nn_1_N = mkN "sociolingvistik" ;
  sockengaang_nn_1_1_N = mkN "sockengång" ;
  sockerhaltighet_nn_1_N = mkN "sockerhaltighet" ;
  sockerkakssmet_nn_1_N = mkN "sockerkakssmet" ;
  sockerkist_nn_1_N = mkN "sockerkist" ;
  sockerkuloer_nn_1_1_N = mkN "sockerkulör" ;
  sockerlag_nn_1_N = mkN "sockerlag" ;
  sockerrikhet_nn_1_N = mkN "sockerrikhet" ;
  sockerrot_nn_1_N = mkN "sockerrot" ;
  sockerroersproduktion_nn_1_1_N = mkN "sockerrörsproduktion" ;
  sockersjuka_nn_1_N = mkN "sockersjuka" ;
  sockersoethet_nn_1_1_N = mkN "sockersöthet" ;
  sockrighet_nn_1_N = mkN "sockrighet" ;
  sodaoert_nn_1_1_N = mkN "sodaört" ;
  sofistik_nn_1_N = mkN "sofistik" ;
  softball_nn_1_N = mkN "softball" ;
  sojamjoelk_nn_1_1_N = mkN "sojamjölk" ;
  sol_nn_1_N = mkN "sol" ;
  solarplexus_nn_1_N = mkN "solarplexus" ;
  solbraendhet_nn_1_1_N = mkN "solbrändhet" ;
  sold_nn_1_N = mkN "sold" ;
  soldatesk_nn_1_N = mkN "soldatesk" ;
  solfattighet_nn_1_N = mkN "solfattighet" ;
  solgaard_nn_1_1_N = mkN "solgård" ;
  solhoejd_nn_1_1_N = mkN "solhöjd" ;
  solighet_nn_1_N = mkN "solighet" ;
  solkighet_nn_1_N = mkN "solkighet" ;
  solkust_nn_1_N = mkN "solkust" ;
  solosaang_nn_1_1_N = mkN "solosång" ;
  solring_nn_1_N = mkN "solring" ;
  solroek_nn_1_1_N = mkN "solrök" ;
  soltid_nn_1_N = mkN "soltid" ;
  solvens_nn_1_N = mkN "solvens" ;
  solverbarhet_nn_1_N = mkN "solverbarhet" ;
  solvind_nn_1_N = mkN "solvind" ;
  sommaraktighet_nn_1_N = mkN "sommaraktighet" ;
  sommardraekt_nn_1_1_N = mkN "sommardräkt" ;
  sommarsjuka_nn_1_N = mkN "sommarsjuka" ;
  sommarsvettighet_nn_1_N = mkN "sommarsvettighet" ;
  sommartid_nn_1_N = mkN "sommartid" ;
  somrighet_nn_1_N = mkN "somrighet" ;
  sonatform_nn_1_N = mkN "sonatform" ;
  sonderbarhet_nn_1_N = mkN "sonderbarhet" ;
  sonlighet_nn_1_N = mkN "sonlighet" ;
  soppatorsk_nn_1_N = mkN "soppatorsk" ;
  soppighet_nn_1_N = mkN "soppighet" ;
  sopranklav_nn_1_N = mkN "sopranklav" ;
  sopsortering_nn_1_N = mkN "sopsortering" ;
  sorbet_nn_1_N = mkN "sorbet" ;
  sordinerbarhet_nn_1_N = mkN "sordinerbarhet" ;
  sorgbundenhet_nn_1_N = mkN "sorgbundenhet" ;
  sorgelaat_nn_1_1_N = mkN "sorgelåt" ;
  sorgemusik_nn_1_N = mkN "sorgemusik" ;
  sorgesamhet_nn_1_N = mkN "sorgesamhet" ;
  sorgetid_nn_1_N = mkN "sorgetid" ;
  sorgfrihet_nn_1_N = mkN "sorgfrihet" ;
  sorgfaellighet_nn_1_1_N = mkN "sorgfällighet" ;
  sorglustighet_nn_1_N = mkN "sorglustighet" ;
  sorgmodighet_nn_1_N = mkN "sorgmodighet" ;
  sorgmusik_nn_1_N = mkN "sorgmusik" ;
  sorgsenhet_nn_1_N = mkN "sorgsenhet" ;
  sorgtyngdhet_nn_1_N = mkN "sorgtyngdhet" ;
  sorterbarhet_nn_1_N = mkN "sorterbarhet" ;
  sot_nn_2_N = mkN "sot" ;
  sotdoed_nn_1_1_N = mkN "sotdöd" ;
  sotsaeng_nn_1_1_N = mkN "sotsäng" ;
  soul_nn_1_N = mkN "soul" ;
  soulagerbarhet_nn_1_N = mkN "soulagerbarhet" ;
  soulmusik_nn_1_N = mkN "soulmusik" ;
  soumak_nn_1_N = mkN "soumak" ;
  sovjetiserbarhet_nn_1_N = mkN "sovjetiserbarhet" ;
  spagat_nn_1_N = mkN "spagat" ;
  spakhet_nn_1_N = mkN "spakhet" ;
  spaljerbarhet_nn_1_N = mkN "spaljerbarhet" ;
  spallation_nn_1_N = mkN "spallation" ;
  spallerbarhet_nn_1_N = mkN "spallerbarhet" ;
  spannmaal_nn_1_1_N = mkN "spannmål" ;
  spannmaalsfoersoerjning_nn_1_1_N = mkN "spannmålsförsörjning" ;
  spannmaalssmuggling_nn_1_1_N = mkN "spannmålssmuggling" ;
  spanskhet_nn_1_N = mkN "spanskhet" ;
  spanskspraakighet_nn_1_1_N = mkN "spanskspråkighet" ;
  sparsamhet_nn_1_N = mkN "sparsamhet" ;
  spatt_nn_1_N = mkN "spatt" ;
  spearing_nn_1_N = mkN "spearing" ;
  specialiserbarhet_nn_1_N = mkN "specialiserbarhet" ;
  specialistvaard_nn_1_1_N = mkN "specialistvård" ;
  specificerbarhet_nn_1_N = mkN "specificerbarhet" ;
  speciminerbarhet_nn_1_N = mkN "speciminerbarhet" ;
  specnaz_nn_1_N = mkN "specnaz" ;
  speedway_nn_1_N = mkN "speedway" ;
  spefylldhet_nn_1_N = mkN "spefylldhet" ;
  spegelblankhet_nn_1_N = mkN "spegelblankhet" ;
  spegelskrift_nn_1_N = mkN "spegelskrift" ;
  spektralanalys_nn_1_N = mkN "spektralanalys" ;
  spekulerbarhet_nn_1_N = mkN "spekulerbarhet" ;
  spelbarhet_nn_1_N = mkN "spelbarhet" ;
  speldjaevul_nn_1_1_N = mkN "speldjävul" ;
  spenat_nn_1_N = mkN "spenat" ;
  spenderbarhet_nn_1_N = mkN "spenderbarhet" ;
  spenslighet_nn_1_N = mkN "spenslighet" ;
  spetsbaagestil_nn_1_1_N = mkN "spetsbågestil" ;
  spetsbaagsstil_nn_1_1_N = mkN "spetsbågsstil" ;
  spetsforskning_nn_1_N = mkN "spetsforskning" ;
  spetsfot_nn_1_N = mkN "spetsfot" ;
  spetsighet_nn_1_N = mkN "spetsighet" ;
  spetsnaz_nn_1_N = mkN "spetsnaz" ;
  spetsvinklighet_nn_1_N = mkN "spetsvinklighet" ;
  spikrakhet_nn_1_N = mkN "spikrakhet" ;
  spiksaekerhet_nn_1_1_N = mkN "spiksäkerhet" ;
  spilltid_nn_1_N = mkN "spilltid" ;
  spindellikhet_nn_1_N = mkN "spindellikhet" ;
  spindeltunnhet_nn_1_N = mkN "spindeltunnhet" ;
  spindelvaevsaktighet_nn_1_1_N = mkN "spindelvävsaktighet" ;
  spindelvaevstunnhet_nn_1_1_N = mkN "spindelvävstunnhet" ;
  spinkighet_nn_1_N = mkN "spinkighet" ;
  spioneriverksamhet_nn_1_N = mkN "spioneriverksamhet" ;
  spionskraeck_nn_1_1_N = mkN "spionskräck" ;
  spiritus_nn_1_N = mkN "spiritus" ;
  spis_nn_2_N = mkN "spis" ;
  splint_nn_1_N = mkN "splint" ;
  splitcane_nn_1_N = mkN "splitcane" ;
  spolformighet_nn_1_N = mkN "spolformighet" ;
  spolierbarhet_nn_1_N = mkN "spolierbarhet" ;
  spondylos_nn_1_N = mkN "spondylos" ;
  sportighet_nn_1_N = mkN "sportighet" ;
  sportlovstrafik_nn_1_N = mkN "sportlovstrafik" ;
  sportslighet_nn_1_N = mkN "sportslighet" ;
  spotskhet_nn_1_N = mkN "spotskhet" ;
  sprallighet_nn_1_N = mkN "sprallighet" ;
  sprayhood_nn_1_N = mkN "sprayhood" ;
  sprickfaerdighet_nn_1_1_N = mkN "sprickfärdighet" ;
  sprickighet_nn_1_N = mkN "sprickighet" ;
  spriddhet_nn_1_N = mkN "spriddhet" ;
  springflod_nn_1_N = mkN "springflod" ;
  sprit_nn_1_N = mkN "sprit" ;
  spritlukt_nn_1_N = mkN "spritlukt" ;
  sprutlackerbarhet_nn_1_N = mkN "sprutlackerbarhet" ;
  sprutt_nn_1_N = mkN "sprutt" ;
  spraecklighet_nn_1_1_N = mkN "spräcklighet" ;
  spraengdeg_nn_1_1_N = mkN "sprängdeg" ;
  spraengfullhet_nn_1_1_N = mkN "sprängfullhet" ;
  spraengfylldhet_nn_1_1_N = mkN "sprängfylldhet" ;
  spraengkraft_nn_1_1_N = mkN "sprängkraft" ;
  spraenglaerdhet_nn_1_1_N = mkN "spränglärdhet" ;
  spraettighet_nn_1_1_N = mkN "sprättighet" ;
  spraakkunnighet_nn_1_1_N = mkN "språkkunnighet" ;
  spraakkaensla_nn_1_1_N = mkN "språkkänsla" ;
  spraaksamhet_nn_1_1_N = mkN "språksamhet" ;
  spraakslaektskap_nn_1_1_N = mkN "språksläktskap" ;
  spraakvaard_nn_1_1_N = mkN "språkvård" ;
  sproedhet_nn_1_1_N = mkN "sprödhet" ;
  spyfaerdighet_nn_1_1_N = mkN "spyfärdighet" ;
  spaeddryck_nn_1_1_N = mkN "späddryck" ;
  spaedhet_nn_1_1_N = mkN "spädhet" ;
  spaendhet_nn_1_1_N = mkN "spändhet" ;
  spaennbetong_nn_1_1_N = mkN "spännbetong" ;
  spaenning_nn_2_1_N = mkN "spänning" ;
  spaenst_nn_1_1_N = mkN "spänst" ;
  spaenstighet_nn_1_1_N = mkN "spänstighet" ;
  spaerreld_nn_1_1_N = mkN "spärreld" ;
  spaetlese_nn_1_1_N = mkN "spätlese" ;
  spaarkapacitet_nn_1_1_N = mkN "spårkapacitet" ;
  spaarloeshet_nn_1_1_N = mkN "spårlöshet" ;
  spaarmetall_nn_1_1_N = mkN "spårmetall" ;
  spoekaktighet_nn_1_1_N = mkN "spökaktighet" ;
  spoeklikhet_nn_1_1_N = mkN "spöklikhet" ;
  squash_nn_1_N = mkN "squash" ;
  stabbighet_nn_1_N = mkN "stabbighet" ;
  stabiliserbarhet_nn_1_N = mkN "stabiliserbarhet" ;
  stadighet_nn_1_N = mkN "stadighet" ;
  stadsbyggnad_nn_1_N = mkN "stadsbyggnad" ;
  stadsgas_nn_1_N = mkN "stadsgas" ;
  stadsplanerbarhet_nn_1_N = mkN "stadsplanerbarhet" ;
  stafferbarhet_nn_1_N = mkN "stafferbarhet" ;
  stajling_nn_1_N = mkN "stajling" ;
  stalking_nn_1_N = mkN "stalking" ;
  stalkning_nn_1_N = mkN "stalkning" ;
  standardiserbarhet_nn_1_N = mkN "standardiserbarhet" ;
  standardislam_nn_1_N = mkN "standardislam" ;
  stanniol_nn_1_N = mkN "stanniol" ;
  star_nn_1_N = mkN "star" ;
  starkhet_nn_1_N = mkN "starkhet" ;
  starksprit_nn_1_N = mkN "starksprit" ;
  starr_nn_1_N = mkN "starr" ;
  stass_nn_1_N = mkN "stass" ;
  statik_nn_1_N = mkN "statik" ;
  stationerbarhet_nn_1_N = mkN "stationerbarhet" ;
  statlighet_nn_1_N = mkN "statlighet" ;
  statskunskap_nn_1_N = mkN "statskunskap" ;
  statskyrka_nn_1_N = mkN "statskyrka" ;
  statsloeshet_nn_1_1_N = mkN "statslöshet" ;
  statsmakt_nn_1_N = mkN "statsmakt" ;
  statsraett_nn_1_1_N = mkN "statsrätt" ;
  statuerbarhet_nn_1_N = mkN "statuerbarhet" ;
  stegloeshet_nn_1_1_N = mkN "steglöshet" ;
  stelkramp_nn_1_N = mkN "stelkramp" ;
  stencilerbarhet_nn_1_N = mkN "stencilerbarhet" ;
  stendoedhet_nn_1_1_N = mkN "stendödhet" ;
  stendoevhet_nn_1_1_N = mkN "stendövhet" ;
  stenhaardhet_nn_1_1_N = mkN "stenhårdhet" ;
  stenkoll_nn_1_N = mkN "stenkoll" ;
  stenkolsperiod_nn_1_N = mkN "stenkolsperiod" ;
  stenograferbarhet_nn_1_N = mkN "stenograferbarhet" ;
  stenstil_nn_1_N = mkN "stenstil" ;
  step_nn_1_N = mkN "step" ;
  stepp_nn_1_N = mkN "stepp" ;
  stereofotograferbarhet_nn_1_N = mkN "stereofotograferbarhet" ;
  stereotyperbarhet_nn_1_N = mkN "stereotyperbarhet" ;
  steriliserbarhet_nn_1_N = mkN "steriliserbarhet" ;
  sterling_nn_1_N = mkN "sterling" ;
  sternum_nn_1_N = mkN "sternum" ;
  stickighet_nn_1_N = mkN "stickighet" ;
  stigloeshet_nn_1_1_N = mkN "stiglöshet" ;
  stigmatiserbarhet_nn_1_N = mkN "stigmatiserbarhet" ;
  stilenlighet_nn_1_N = mkN "stilenlighet" ;
  stilighet_nn_1_N = mkN "stilighet" ;
  stiliserbarhet_nn_1_N = mkN "stiliserbarhet" ;
  stilistik_nn_1_N = mkN "stilistik" ;
  stilkaensla_nn_1_1_N = mkN "stilkänsla" ;
  stillsamhet_nn_1_N = mkN "stillsamhet" ;
  stilrenhet_nn_1_N = mkN "stilrenhet" ;
  stimmighet_nn_1_N = mkN "stimmighet" ;
  stimulerbarhet_nn_1_N = mkN "stimulerbarhet" ;
  stinnhet_nn_1_N = mkN "stinnhet" ;
  stipendierbarhet_nn_1_N = mkN "stipendierbarhet" ;
  stipulerbarhet_nn_1_N = mkN "stipulerbarhet" ;
  stirrighet_nn_1_N = mkN "stirrighet" ;
  stjaern_nn_1_1_N = mkN "stjärn" ;
  stjaernevaerld_nn_1_1_N = mkN "stjärnevärld" ;
  stjaernformighet_nn_1_1_N = mkN "stjärnformighet" ;
  stjaernlikhet_nn_1_1_N = mkN "stjärnlikhet" ;
  stjaernstatus_nn_1_1_N = mkN "stjärnstatus" ;
  stjaerntid_nn_1_1_N = mkN "stjärntid" ;
  stjaernoegdhet_nn_1_1_N = mkN "stjärnögdhet" ;
  stock_car_nn_1_N = mkN "stock-car" ;
  stockdumhet_nn_1_N = mkN "stockdumhet" ;
  stofferbarhet_nn_1_N = mkN "stofferbarhet" ;
  stoiskhet_nn_1_N = mkN "stoiskhet" ;
  stomjoelk_nn_1_1_N = mkN "stomjölk" ;
  stopplikt_nn_1_N = mkN "stopplikt" ;
  stor_nn_1_N = mkN "stor" ;
  stordrift_nn_1_N = mkN "stordrift" ;
  storebror_nn_1_N = mkN "storebror" ;
  storfinans_nn_1_N = mkN "storfinans" ;
  storkoeksmat_nn_1_1_N = mkN "storköksmat" ;
  stormaktspolitik_nn_1_N = mkN "stormaktspolitik" ;
  stormeld_nn_1_N = mkN "stormeld" ;
  stormfrihet_nn_1_N = mkN "stormfrihet" ;
  stormighet_nn_1_N = mkN "stormighet" ;
  stormrikhet_nn_1_N = mkN "stormrikhet" ;
  stormsaekerhet_nn_1_1_N = mkN "stormsäkerhet" ;
  storordighet_nn_1_N = mkN "storordighet" ;
  storpublik_nn_1_N = mkN "storpublik" ;
  storrutighet_nn_1_N = mkN "storrutighet" ;
  storsinthet_nn_1_N = mkN "storsinthet" ;
  storskalighet_nn_1_N = mkN "storskalighet" ;
  storslagenhet_nn_1_N = mkN "storslagenhet" ;
  storslalom_nn_1_N = mkN "storslalom" ;
  storstadsskymning_nn_1_N = mkN "storstadsskymning" ;
  storstilthet_nn_1_N = mkN "storstilthet" ;
  storvaexthet_nn_1_1_N = mkN "storväxthet" ;
  storoegdhet_nn_1_1_N = mkN "storögdhet" ;
  straffbarhet_nn_1_N = mkN "straffbarhet" ;
  straffloeshet_nn_1_1_N = mkN "strafflöshet" ;
  straffrabatt_nn_1_N = mkN "straffrabatt" ;
  straffraett_nn_1_1_N = mkN "straffrätt" ;
  strakbenthet_nn_1_N = mkN "strakbenthet" ;
  strakhet_nn_1_N = mkN "strakhet" ;
  stramhet_nn_1_N = mkN "stramhet" ;
  strandraett_nn_1_1_N = mkN "strandrätt" ;
  strandraag_nn_1_1_N = mkN "strandråg" ;
  strangulerbarhet_nn_1_N = mkN "strangulerbarhet" ;
  strass_nn_1_N = mkN "strass" ;
  stratifierbarhet_nn_1_N = mkN "stratifierbarhet" ;
  stratosfaer_nn_1_1_N = mkN "stratosfär" ;
  stratus_nn_1_N = mkN "stratus" ;
  stress_nn_1_N = mkN "stress" ;
  stressighet_nn_1_N = mkN "stressighet" ;
  stresstaalighet_nn_1_1_N = mkN "stresstålighet" ;
  stridbarhet_nn_1_N = mkN "stridbarhet" ;
  stridhet_nn_1_N = mkN "stridhet" ;
  stridsberedskap_nn_1_N = mkN "stridsberedskap" ;
  stridsduglighet_nn_1_N = mkN "stridsduglighet" ;
  stridsformerbarhet_nn_1_N = mkN "stridsformerbarhet" ;
  stridsgrupperbarhet_nn_1_N = mkN "stridsgrupperbarhet" ;
  stridskraft_nn_1_N = mkN "stridskraft" ;
  stridslust_nn_1_N = mkN "stridslust" ;
  stridslystnad_nn_1_N = mkN "stridslystnad" ;
  strikthet_nn_1_N = mkN "strikthet" ;
  strimmighet_nn_1_N = mkN "strimmighet" ;
  stringens_nn_1_N = mkN "stringens" ;
  stringenthet_nn_1_N = mkN "stringenthet" ;
  stripp_nn_1_N = mkN "stripp" ;
  stronghet_nn_1_N = mkN "stronghet" ;
  stroppighet_nn_1_N = mkN "stroppighet" ;
  strukturerbarhet_nn_1_N = mkN "strukturerbarhet" ;
  strukturrationaliserbarhet_nn_1_N = mkN "strukturrationaliserbarhet" ;
  struntfoernaemhet_nn_1_1_N = mkN "struntförnämhet" ;
  struntviktighet_nn_1_N = mkN "struntviktighet" ;
  strutspolitik_nn_1_N = mkN "strutspolitik" ;
  struttighet_nn_1_N = mkN "struttighet" ;
  strykraeddhet_nn_1_1_N = mkN "strykräddhet" ;
  stryktaeckhet_nn_1_1_N = mkN "stryktäckhet" ;
  stryktaalighet_nn_1_1_N = mkN "stryktålighet" ;
  strypsjuka_nn_1_N = mkN "strypsjuka" ;
  straenghet_nn_1_1_N = mkN "stränghet" ;
  straevhet_nn_1_1_N = mkN "strävhet" ;
  straevhaarighet_nn_1_1_N = mkN "strävhårighet" ;
  straevsamhet_nn_1_1_N = mkN "strävsamhet" ;
  straadoed_nn_1_1_N = mkN "strådöd" ;
  straakmusik_nn_1_1_N = mkN "stråkmusik" ;
  straalglans_nn_1_1_N = mkN "strålglans" ;
  straalkonserverbarhet_nn_1_1_N = mkN "strålkonserverbarhet" ;
  straalningssaekerhet_nn_1_1_N = mkN "strålningssäkerhet" ;
  straalsjuka_nn_1_1_N = mkN "strålsjuka" ;
  straalsvamp_nn_1_1_N = mkN "strålsvamp" ;
  straasaed_nn_1_1_N = mkN "stråsäd" ;
  straat_nn_1_1_N = mkN "stråt" ;
  stroemkarl_nn_1_1_N = mkN "strömkarl" ;
  stroemloeshet_nn_1_1_N = mkN "strömlöshet" ;
  stubbighet_nn_1_N = mkN "stubbighet" ;
  stuckenhet_nn_1_N = mkN "stuckenhet" ;
  studenttillstroemning_nn_1_1_N = mkN "studenttillströmning" ;
  studerbarhet_nn_1_N = mkN "studerbarhet" ;
  studiehjaelp_nn_1_1_N = mkN "studiehjälp" ;
  studieorienterbarhet_nn_1_N = mkN "studieorienterbarhet" ;
  stundlighet_nn_1_N = mkN "stundlighet" ;
  stuns_nn_1_N = mkN "stuns" ;
  stupfullhet_nn_1_N = mkN "stupfullhet" ;
  stupor_nn_1_N = mkN "stupor" ;
  sturskhet_nn_1_N = mkN "sturskhet" ;
  stut_nn_2_N = mkN "stut" ;
  stygghet_nn_1_N = mkN "stygghet" ;
  styling_nn_1_N = mkN "styling" ;
  styrbarhet_nn_1_N = mkN "styrbarhet" ;
  styrenplast_nn_1_N = mkN "styrenplast" ;
  styrfart_nn_1_N = mkN "styrfart" ;
  styrol_nn_1_N = mkN "styrol" ;
  styvmoderlighet_nn_1_N = mkN "styvmoderlighet" ;
  styvsinthet_nn_1_N = mkN "styvsinthet" ;
  staemningsfullhet_nn_1_1_N = mkN "stämningsfullhet" ;
  staendighet_nn_1_1_N = mkN "ständighet" ;
  staerkelserikhet_nn_1_1_N = mkN "stärkelserikhet" ;
  staalhaardhet_nn_1_1_N = mkN "stålhårdhet" ;
  staalull_nn_1_1_N = mkN "stålull" ;
  staandaktighet_nn_1_1_N = mkN "ståndaktighet" ;
  staandmaessighet_nn_1_1_N = mkN "ståndmässighet" ;
  staandsmaessighet_nn_1_1_N = mkN "ståndsmässighet" ;
  staat_nn_1_1_N = mkN "ståt" ;
  staatlighet_nn_1_1_N = mkN "ståtlighet" ;
  stoeddighet_nn_1_1_N = mkN "stöddighet" ;
  stoeldsaekerhet_nn_1_1_N = mkN "stöldsäkerhet" ;
  stoepis_nn_1_1_N = mkN "stöpis" ;
  stoerighet_nn_1_1_N = mkN "störighet" ;
  stoetthet_nn_1_1_N = mkN "stötthet" ;
  stoettaalighet_nn_1_1_N = mkN "stöttålighet" ;
  subbighet_nn_1_N = mkN "subbighet" ;
  sublimerbarhet_nn_1_N = mkN "sublimerbarhet" ;
  sublimering_nn_2_N = mkN "sublimering" ;
  sublimhet_nn_1_N = mkN "sublimhet" ;
  subordinerbarhet_nn_1_N = mkN "subordinerbarhet" ;
  subsidierbarhet_nn_1_N = mkN "subsidierbarhet" ;
  subsistens_nn_1_N = mkN "subsistens" ;
  subskriberbarhet_nn_1_N = mkN "subskriberbarhet" ;
  substantiverbarhet_nn_1_N = mkN "substantiverbarhet" ;
  substantivsjuka_nn_1_N = mkN "substantivsjuka" ;
  substituerbarhet_nn_1_N = mkN "substituerbarhet" ;
  subsumerbarhet_nn_1_N = mkN "subsumerbarhet" ;
  subtraherbarhet_nn_1_N = mkN "subtraherbarhet" ;
  subventionerbarhet_nn_1_N = mkN "subventionerbarhet" ;
  succederbarhet_nn_1_N = mkN "succederbarhet" ;
  suffigerbarhet_nn_1_N = mkN "suffigerbarhet" ;
  suffisans_nn_1_N = mkN "suffisans" ;
  sufflerbarhet_nn_1_N = mkN "sufflerbarhet" ;
  suggererbarhet_nn_1_N = mkN "suggererbarhet" ;
  sughoejd_nn_1_1_N = mkN "sughöjd" ;
  summerbarhet_nn_1_N = mkN "summerbarhet" ;
  sump_nn_1_N = mkN "sump" ;
  sumpgas_nn_1_N = mkN "sumpgas" ;
  sumpighet_nn_1_N = mkN "sumpighet" ;
  sundhet_nn_1_N = mkN "sundhet" ;
  sunna_nn_1_N = mkN "sunna" ;
  sunni_nn_1_N = mkN "sunni" ;
  superbhet_nn_1_N = mkN "superbhet" ;
  supermaktsstatus_nn_1_N = mkN "supermaktsstatus" ;
  supermarket_nn_1_N = mkN "supermarket" ;
  supersmaskighet_nn_1_N = mkN "supersmaskighet" ;
  supersnabbhet_nn_1_N = mkN "supersnabbhet" ;
  superspeed_nn_1_N = mkN "superspeed" ;
  superstarkhet_nn_1_N = mkN "superstarkhet" ;
  supertungvikt_nn_1_N = mkN "supertungvikt" ;
  superviktighet_nn_1_N = mkN "superviktighet" ;
  supplerbarhet_nn_1_N = mkN "supplerbarhet" ;
  supponerbarhet_nn_1_N = mkN "supponerbarhet" ;
  support_nn_1_N = mkN "support" ;
  surf_nn_1_N = mkN "surf" ;
  surfbarhet_nn_1_N = mkN "surfbarhet" ;
  surfing_nn_1_N = mkN "surfing" ;
  surhet_nn_2_N = mkN "surhet" ;
  surkaal_nn_1_1_N = mkN "surkål" ;
  surmjoelk_nn_1_1_N = mkN "surmjölk" ;
  surmulenhet_nn_1_N = mkN "surmulenhet" ;
  suroegdhet_nn_1_1_N = mkN "surögdhet" ;
  suspekthet_nn_1_N = mkN "suspekthet" ;
  suspenderbarhet_nn_1_N = mkN "suspenderbarhet" ;
  svackighet_nn_1_N = mkN "svackighet" ;
  svagsinthet_nn_1_N = mkN "svagsinthet" ;
  svagsynthet_nn_1_N = mkN "svagsynthet" ;
  svagtonighet_nn_1_N = mkN "svagtonighet" ;
  svajning_nn_1_N = mkN "svajning" ;
  svalhet_nn_1_N = mkN "svalhet" ;
  svallis_nn_1_N = mkN "svallis" ;
  svaloert_nn_1_1_N = mkN "svalört" ;
  svampighet_nn_1_N = mkN "svampighet" ;
  svanesaang_nn_1_1_N = mkN "svanesång" ;
  svankighet_nn_1_N = mkN "svankighet" ;
  svarsloeshet_nn_1_1_N = mkN "svarslöshet" ;
  svartmalm_nn_1_N = mkN "svartmalm" ;
  svartmuskighet_nn_1_N = mkN "svartmuskighet" ;
  svartrost_nn_1_N = mkN "svartrost" ;
  svartrot_nn_1_N = mkN "svartrot" ;
  svartsjuka_nn_1_N = mkN "svartsjuka" ;
  svartsjukhet_nn_1_N = mkN "svartsjukhet" ;
  svartsprit_nn_1_N = mkN "svartsprit" ;
  svartsyn_nn_1_N = mkN "svartsyn" ;
  svaveldioxid_nn_1_N = mkN "svaveldioxid" ;
  svavelkis_nn_1_N = mkN "svavelkis" ;
  svekfrihet_nn_1_N = mkN "svekfrihet" ;
  sveklighet_nn_1_N = mkN "sveklighet" ;
  svekloeshet_nn_1_1_N = mkN "sveklöshet" ;
  svenskhetsvurm_nn_1_N = mkN "svenskhetsvurm" ;
  svenskspraakighet_nn_1_1_N = mkN "svenskspråkighet" ;
  svensktoppsmusik_nn_1_N = mkN "svensktoppsmusik" ;
  svenskull_nn_1_N = mkN "svenskull" ;
  svenskundervisning_nn_1_N = mkN "svenskundervisning" ;
  svett_nn_1_N = mkN "svett" ;
  svetthet_nn_1_N = mkN "svetthet" ;
  svettighet_nn_1_N = mkN "svettighet" ;
  sviklighet_nn_1_N = mkN "sviklighet" ;
  svimfaerdighet_nn_1_1_N = mkN "svimfärdighet" ;
  svindyrhet_nn_1_N = mkN "svindyrhet" ;
  svinkallhet_nn_1_N = mkN "svinkallhet" ;
  svintur_nn_1_N = mkN "svintur" ;
  svunnenhet_nn_1_N = mkN "svunnenhet" ;
  svaelt_nn_1_1_N = mkN "svält" ;
  svaeltfoeddhet_nn_1_1_N = mkN "svältföddhet" ;
  svaeltgraens_nn_1_1_N = mkN "svältgräns" ;
  svaeltkost_nn_1_1_N = mkN "svältkost" ;
  svaengbarhet_nn_1_1_N = mkN "svängbarhet" ;
  svaengdhet_nn_1_1_N = mkN "svängdhet" ;
  svaengighet_nn_1_1_N = mkN "svängighet" ;
  svaerdlikhet_nn_1_1_N = mkN "svärdlikhet" ;
  svaerdlaengd_nn_1_1_N = mkN "svärdlängd" ;
  svaerdsloeshet_nn_1_1_N = mkN "svärdslöshet" ;
  svaagerpolitik_nn_1_1_N = mkN "svågerpolitik" ;
  svaangremspolitik_nn_1_1_N = mkN "svångremspolitik" ;
  svaaravvislighet_nn_1_1_N = mkN "svåravvislighet" ;
  svaarbedoemdhet_nn_1_1_N = mkN "svårbedömdhet" ;
  svaardefinierbarhet_nn_1_1_N = mkN "svårdefinierbarhet" ;
  svaarframkomlighet_nn_1_1_N = mkN "svårframkomlighet" ;
  svaarfoerenlighet_nn_1_1_N = mkN "svårförenlighet" ;
  svaargenomtraenglighet_nn_1_1_N = mkN "svårgenomtränglighet" ;
  svaarhanterlighet_nn_1_1_N = mkN "svårhanterlighet" ;
  svaarhet_nn_1_1_N = mkN "svårhet" ;
  svaarintaglighet_nn_1_1_N = mkN "svårintaglighet" ;
  svaarlaesthet_nn_1_1_N = mkN "svårlästhet" ;
  svaarloesthet_nn_1_1_N = mkN "svårlösthet" ;
  svaarmodighet_nn_1_1_N = mkN "svårmodighet" ;
  svaarpaavisbarhet_nn_1_1_N = mkN "svårpåvisbarhet" ;
  svaarsmaelthet_nn_1_1_N = mkN "svårsmälthet" ;
  svaarsaaldhet_nn_1_1_N = mkN "svårsåldhet" ;
  svaartillgaenglighet_nn_1_1_N = mkN "svårtillgänglighet" ;
  svaaroeverblickbarhet_nn_1_1_N = mkN "svåröverblickbarhet" ;
  svaaroeverskaadlighet_nn_1_1_N = mkN "svåröverskådlighet" ;
  sweepstake_nn_1_N = mkN "sweepstake" ;
  swing_nn_1_N = mkN "swing" ;
  swingball_nn_1_N = mkN "swingball" ;
  swingmusik_nn_1_N = mkN "swingmusik" ;
  sydost_nn_1_N = mkN "sydost" ;
  sydvaest_nn_1_1_N = mkN "sydväst" ;
  sydoest_nn_1_1_N = mkN "sydöst" ;
  syffisans_nn_1_N = mkN "syffisans" ;
  syfilis_nn_1_N = mkN "syfilis" ;
  sylfidiskhet_nn_1_N = mkN "sylfidiskhet" ;
  symbios_nn_1_N = mkN "symbios" ;
  symbolik_nn_1_N = mkN "symbolik" ;
  symboliserbarhet_nn_1_N = mkN "symboliserbarhet" ;
  symptomfrihet_nn_1_N = mkN "symptomfrihet" ;
  symtomfrihet_nn_1_N = mkN "symtomfrihet" ;
  syn_nn_2_N = mkN "syn" ;
  synbarhet_nn_1_N = mkN "synbarhet" ;
  synbarlighet_nn_1_N = mkN "synbarlighet" ;
  syndfullhet_nn_1_N = mkN "syndfullhet" ;
  syndighet_nn_1_N = mkN "syndighet" ;
  synkning_nn_1_N = mkN "synkning" ;
  synkoperbarhet_nn_1_N = mkN "synkoperbarhet" ;
  synkroniserbarhet_nn_1_N = mkN "synkroniserbarhet" ;
  synrand_nn_1_N = mkN "synrand" ;
  synskhet_nn_1_N = mkN "synskhet" ;
  syntetiserbarhet_nn_1_N = mkN "syntetiserbarhet" ;
  syperbhet_nn_1_N = mkN "syperbhet" ;
  syrafasthet_nn_1_N = mkN "syrafasthet" ;
  syrebrist_nn_1_N = mkN "syrebrist" ;
  syrefattighet_nn_1_N = mkN "syrefattighet" ;
  syrerikhet_nn_1_N = mkN "syrerikhet" ;
  syreupptagning_nn_1_N = mkN "syreupptagning" ;
  syrgas_nn_1_N = mkN "syrgas" ;
  syrlighet_nn_1_N = mkN "syrlighet" ;
  sysselsaettningspolitik_nn_1_1_N = mkN "sysselsättningspolitik" ;
  syssloloeshet_nn_1_1_N = mkN "sysslolöshet" ;
  systemanalys_nn_1_N = mkN "systemanalys" ;
  systematik_nn_1_N = mkN "systematik" ;
  systematiserbarhet_nn_1_N = mkN "systematiserbarhet" ;
  systemering_nn_1_N = mkN "systemering" ;
  saeckighet_nn_1_1_N = mkN "säckighet" ;
  saeckvaev_nn_1_1_N = mkN "säckväv" ;
  saekerhetsbalans_nn_1_1_N = mkN "säkerhetsbalans" ;
  saekerhetspersonal_nn_1_1_N = mkN "säkerhetspersonal" ;
  saekerhetspolis_nn_1_1_N = mkN "säkerhetspolis" ;
  saekerhetspolitik_nn_1_1_N = mkN "säkerhetspolitik" ;
  saeljakt_nn_1_1_N = mkN "säljakt" ;
  saeljbarhet_nn_1_1_N = mkN "säljbarhet" ;
  saellskaplighet_nn_1_1_N = mkN "sällskaplighet" ;
  saellskapsgraat_nn_1_1_N = mkN "sällskapsgråt" ;
  saellskapssjukhet_nn_1_1_N = mkN "sällskapssjukhet" ;
  saellspordhet_nn_1_1_N = mkN "sällspordhet" ;
  saenghalm_nn_1_1_N = mkN "sänghalm" ;
  saerart_nn_1_1_N = mkN "särart" ;
  saerklassighet_nn_1_1_N = mkN "särklassighet" ;
  saerskildhet_nn_1_1_N = mkN "särskildhet" ;
  saev_nn_1_1_N = mkN "säv" ;
  saevlighet_nn_1_1_N = mkN "sävlighet" ;
  saallningsprocedur_nn_1_1_N = mkN "sållningsprocedur" ;
  saang_nn_2_1_N = mkN "sång" ;
  saangbarhet_nn_1_1_N = mkN "sångbarhet" ;
  saanglighet_nn_1_1_N = mkN "sånglighet" ;
  saangroest_nn_1_1_N = mkN "sångröst" ;
  saasighet_nn_1_1_N = mkN "såsighet" ;
  saaterbarhet_nn_1_1_N = mkN "såterbarhet" ;
  saaverbarhet_nn_1_1_N = mkN "såverbarhet" ;
  soekbarhet_nn_1_1_N = mkN "sökbarhet" ;
  soekthet_nn_1_1_N = mkN "sökthet" ;
  soelighet_nn_1_1_N = mkN "sölighet" ;
  soemn_nn_1_1_N = mkN "sömn" ;
  soemnbrist_nn_1_1_N = mkN "sömnbrist" ;
  soemngaangaraktighet_nn_1_1_N = mkN "sömngångaraktighet" ;
  soemnighet_nn_1_1_N = mkN "sömnighet" ;
  soemnloeshet_nn_1_1_N = mkN "sömnlöshet" ;
  soemnsjuka_nn_1_1_N = mkN "sömnsjuka" ;
  soemntunghet_nn_1_1_N = mkN "sömntunghet" ;
  soenderbraendhet_nn_1_1_N = mkN "sönderbrändhet" ;
  soendrighet_nn_1_1_N = mkN "söndrighet" ;
  soetaktighet_nn_1_1_N = mkN "sötaktighet" ;
  soethet_nn_1_1_N = mkN "söthet" ;
  soetmjoelk_nn_1_1_N = mkN "sötmjölk" ;
  soetsliskighet_nn_1_1_N = mkN "sötsliskighet" ;
  soetsurhet_nn_1_1_N = mkN "sötsurhet" ;
  tabellerbarhet_nn_1_N = mkN "tabellerbarhet" ;
  tablettform_nn_1_N = mkN "tablettform" ;
  tabubelaeggning_nn_1_1_N = mkN "tabubeläggning" ;
  tabuerbarhet_nn_1_N = mkN "tabuerbarhet" ;
  tacknaemlighet_nn_1_1_N = mkN "tacknämlighet" ;
  tacksamhetsskuld_nn_1_N = mkN "tacksamhetsskuld" ;
  tafatt_nn_1_N = mkN "tafatt" ;
  tafatthet_nn_1_N = mkN "tafatthet" ;
  taffelmusik_nn_1_N = mkN "taffelmusik" ;
  tafsighet_nn_1_N = mkN "tafsighet" ;
  taggfenighet_nn_1_N = mkN "taggfenighet" ;
  taggighet_nn_1_N = mkN "taggighet" ;
  tajning_nn_1_N = mkN "tajning" ;
  tajthet_nn_1_N = mkN "tajthet" ;
  takfot_nn_1_N = mkN "takfot" ;
  takloek_nn_1_1_N = mkN "taklök" ;
  takt_nn_2_N = mkN "takt" ;
  taktfasthet_nn_1_N = mkN "taktfasthet" ;
  taktfullhet_nn_1_N = mkN "taktfullhet" ;
  taktkaensla_nn_1_1_N = mkN "taktkänsla" ;
  talangfullhet_nn_1_N = mkN "talangfullhet" ;
  talangloeshet_nn_1_1_N = mkN "talanglöshet" ;
  talarkonst_nn_1_N = mkN "talarkonst" ;
  talekonst_nn_1_N = mkN "talekonst" ;
  taleraett_nn_1_1_N = mkN "talerätt" ;
  talfoerhet_nn_1_1_N = mkN "talförhet" ;
  talg_nn_1_N = mkN "talg" ;
  talgighet_nn_1_N = mkN "talgighet" ;
  talgoegdhet_nn_1_1_N = mkN "talgögdhet" ;
  talk_nn_1_N = mkN "talk" ;
  talkighet_nn_1_N = mkN "talkighet" ;
  tallbark_nn_1_N = mkN "tallbark" ;
  tallrikhet_nn_1_N = mkN "tallrikhet" ;
  tallriksis_nn_1_N = mkN "tallriksis" ;
  tallstrunt_nn_1_N = mkN "tallstrunt" ;
  talloeshet_nn_1_1_N = mkN "tallöshet" ;
  talmystik_nn_1_N = mkN "talmystik" ;
  talrikhet_nn_1_N = mkN "talrikhet" ;
  talsymbolik_nn_1_N = mkN "talsymbolik" ;
  talsyntes_nn_1_N = mkN "talsyntes" ;
  talteknik_nn_1_N = mkN "talteknik" ;
  taltraengdhet_nn_1_1_N = mkN "talträngdhet" ;
  talvaard_nn_1_1_N = mkN "talvård" ;
  tamhet_nn_1_N = mkN "tamhet" ;
  tamponerbarhet_nn_1_N = mkN "tamponerbarhet" ;
  tampongsjuka_nn_1_N = mkN "tampongsjuka" ;
  tandlikhet_nn_1_N = mkN "tandlikhet" ;
  tandloeshet_nn_1_1_N = mkN "tandlöshet" ;
  tandstatus_nn_1_N = mkN "tandstatus" ;
  tandtraadning_nn_1_1_N = mkN "tandtrådning" ;
  tandvaenlighet_nn_1_1_N = mkN "tandvänlighet" ;
  tandvaerk_nn_1_1_N = mkN "tandvärk" ;
  tandvaard_nn_1_1_N = mkN "tandvård" ;
  tangens_nn_1_N = mkN "tangens" ;
  tangerbarhet_nn_1_N = mkN "tangerbarhet" ;
  tankedigerhet_nn_1_N = mkN "tankedigerhet" ;
  tankeflykt_nn_1_N = mkN "tankeflykt" ;
  tankelyrik_nn_1_N = mkN "tankelyrik" ;
  tankemaessighet_nn_1_1_N = mkN "tankemässighet" ;
  tankeverksamhet_nn_1_N = mkN "tankeverksamhet" ;
  tankevaerld_nn_1_1_N = mkN "tankevärld" ;
  tankfullhet_nn_1_N = mkN "tankfullhet" ;
  tankspriddhet_nn_1_N = mkN "tankspriddhet" ;
  tantaktighet_nn_1_N = mkN "tantaktighet" ;
  tantalit_nn_1_N = mkN "tantalit" ;
  tantighet_nn_1_N = mkN "tantighet" ;
  tapetserbarhet_nn_1_N = mkN "tapetserbarhet" ;
  tarerbarhet_nn_1_N = mkN "tarerbarhet" ;
  tarifferbarhet_nn_1_N = mkN "tarifferbarhet" ;
  tarok_nn_1_N = mkN "tarok" ;
  tartar_nn_1_N = mkN "tartar" ;
  tartarsaas_nn_1_1_N = mkN "tartarsås" ;
  tatuerbarhet_nn_1_N = mkN "tatuerbarhet" ;
  tax_free_nn_1_N = mkN "tax-free" ;
  taxerbarhet_nn_1_N = mkN "taxerbarhet" ;
  taxis_nn_1_N = mkN "taxis" ;
  teak_nn_1_N = mkN "teak" ;
  teaterkritik_nn_1_N = mkN "teaterkritik" ;
  teaterpublik_nn_1_N = mkN "teaterpublik" ;
  teckentolkning_nn_1_N = mkN "teckentolkning" ;
  teckningsraett_nn_1_1_N = mkN "teckningsrätt" ;
  tegelfaerg_nn_1_1_N = mkN "tegelfärg" ;
  teint_nn_1_N = mkN "teint" ;
  teknifierbarhet_nn_1_N = mkN "teknifierbarhet" ;
  tektonik_nn_1_N = mkN "tektonik" ;
  telefonerbarhet_nn_1_N = mkN "telefonerbarhet" ;
  telefonjour_nn_1_N = mkN "telefonjour" ;
  telegraferbarhet_nn_1_N = mkN "telegraferbarhet" ;
  telegramstil_nn_1_N = mkN "telegramstil" ;
  telematik_nn_1_N = mkN "telematik" ;
  teletex_nn_1_N = mkN "teletex" ;
  televiserbarhet_nn_1_N = mkN "televiserbarhet" ;
  television_nn_1_N = mkN "television" ;
  telex_nn_1_N = mkN "telex" ;
  tematik_nn_1_N = mkN "tematik" ;
  temperamentsfullhet_nn_1_N = mkN "temperamentsfullhet" ;
  temperaturbestaendighet_nn_1_1_N = mkN "temperaturbeständighet" ;
  temperaturkaenslighet_nn_1_1_N = mkN "temperaturkänslighet" ;
  temperaturutveckling_nn_1_N = mkN "temperaturutveckling" ;
  temperbarhet_nn_1_N = mkN "temperbarhet" ;
  tempererbarhet_nn_1_N = mkN "tempererbarhet" ;
  temperering_nn_1_N = mkN "temperering" ;
  tennis_nn_1_N = mkN "tennis" ;
  tennisarm_nn_1_N = mkN "tennisarm" ;
  tennpest_nn_1_N = mkN "tennpest" ;
  tenterbarhet_nn_1_N = mkN "tenterbarhet" ;
  terasstvaett_nn_1_1_N = mkN "terasstvätt" ;
  termik_nn_1_N = mkN "termik" ;
  terminalvaard_nn_1_1_N = mkN "terminalvård" ;
  termit_nn_2_N = mkN "termit" ;
  termodynamik_nn_1_N = mkN "termodynamik" ;
  terrasserbarhet_nn_1_N = mkN "terrasserbarhet" ;
  territ_nn_1_N = mkN "territ" ;
  terrorbalans_nn_1_N = mkN "terrorbalans" ;
  terrorberedskap_nn_1_N = mkN "terrorberedskap" ;
  terroriserbarhet_nn_1_N = mkN "terroriserbarhet" ;
  terroristspaarning_nn_1_1_N = mkN "terroristspårning" ;
  tertiaerperiod_nn_1_1_N = mkN "tertiärperiod" ;
  tertiaertid_nn_1_1_N = mkN "tertiärtid" ;
  tesaurerbarhet_nn_1_N = mkN "tesaurerbarhet" ;
  testamenterbarhet_nn_1_N = mkN "testamenterbarhet" ;
  testighet_nn_1_N = mkN "testighet" ;
  tetanus_nn_1_N = mkN "tetanus" ;
  teutoniskhet_nn_1_N = mkN "teutoniskhet" ;
  teve_nn_1_N = mkN "teve" ;
  tevereklam_nn_1_N = mkN "tevereklam" ;
  textilkonst_nn_1_N = mkN "textilkonst" ;
  textilsloejd_nn_1_1_N = mkN "textilslöjd" ;
  textkritik_nn_1_N = mkN "textkritik" ;
  textreklam_nn_1_N = mkN "textreklam" ;
  teaerenpris_nn_1_1_N = mkN "teärenpris" ;
  thai_nn_1_N = mkN "thai" ;
  thaimat_nn_1_N = mkN "thaimat" ;
  thalamus_nn_1_N = mkN "thalamus" ;
  thorax_nn_1_N = mkN "thorax" ;
  thymus_nn_1_N = mkN "thymus" ;
  tibast_nn_1_N = mkN "tibast" ;
  tidigarelaeggning_nn_1_1_N = mkN "tidigareläggning" ;
  tidighet_nn_1_N = mkN "tidighet" ;
  tidjord_nn_1_N = mkN "tidjord" ;
  tidlighet_nn_1_N = mkN "tidlighet" ;
  tidningsbransch_nn_1_N = mkN "tidningsbransch" ;
  tidningsdoed_nn_1_1_N = mkN "tidningsdöd" ;
  tidsenlighet_nn_1_N = mkN "tidsenlighet" ;
  tidslighet_nn_1_N = mkN "tidslighet" ;
  tidsnoed_nn_1_1_N = mkN "tidsnöd" ;
  tidspress_nn_1_N = mkN "tidspress" ;
  tidsriktning_nn_2_N = mkN "tidsriktning" ;
  tidsutdraekt_nn_1_1_N = mkN "tidsutdräkt" ;
  tidsaatgaang_nn_1_1_N = mkN "tidsåtgång" ;
  tigerrandighet_nn_1_N = mkN "tigerrandighet" ;
  tigerstrimmighet_nn_1_N = mkN "tigerstrimmighet" ;
  tighthet_nn_1_N = mkN "tighthet" ;
  tillbakadragenhet_nn_1_N = mkN "tillbakadragenhet" ;
  tillbakagaang_nn_1_1_N = mkN "tillbakagång" ;
  tillboerlighet_nn_1_1_N = mkN "tillbörlighet" ;
  tillflykt_nn_1_N = mkN "tillflykt" ;
  tillfriskning_nn_1_N = mkN "tillfriskning" ;
  tillfaelleslitteratur_nn_1_1_N = mkN "tillfälleslitteratur" ;
  tillfoersikt_nn_1_1_N = mkN "tillförsikt" ;
  tillgift_nn_1_N = mkN "tillgift" ;
  tillgaenglighet_nn_1_1_N = mkN "tillgänglighet" ;
  tillhjaelp_nn_1_1_N = mkN "tillhjälp" ;
  tillit_nn_1_N = mkN "tillit" ;
  tillitsfullhet_nn_1_N = mkN "tillitsfullhet" ;
  tillknaeppthet_nn_1_1_N = mkN "tillknäppthet" ;
  tillkomst_nn_1_N = mkN "tillkomst" ;
  tillraecklighet_nn_1_1_N = mkN "tillräcklighet" ;
  tillraeknelighet_nn_1_1_N = mkN "tillräknelighet" ;
  tillraadlighet_nn_1_1_N = mkN "tillrådlighet" ;
  tillstaendighet_nn_1_1_N = mkN "tillständighet" ;
  tillsyn_nn_1_N = mkN "tillsyn" ;
  tilltagsenhet_nn_1_N = mkN "tilltagsenhet" ;
  tilltaenkthet_nn_1_1_N = mkN "tilltänkthet" ;
  tilluft_nn_1_N = mkN "tilluft" ;
  tillvandhet_nn_1_N = mkN "tillvandhet" ;
  tillvaext_nn_1_1_N = mkN "tillväxt" ;
  tillvaextkritik_nn_1_1_N = mkN "tillväxtkritik" ;
  tillaeggsstat_nn_1_1_N = mkN "tilläggsstat" ;
  tillaemplighet_nn_1_1_N = mkN "tillämplighet" ;
  tillaatlighet_nn_1_1_N = mkN "tillåtlighet" ;
  timjan_nn_1_N = mkN "timjan" ;
  timotej_nn_1_N = mkN "timotej" ;
  tingsraettspersonal_nn_1_1_N = mkN "tingsrättspersonal" ;
  tipstjaenst_nn_1_1_N = mkN "tipstjänst" ;
  titelsjuka_nn_1_N = mkN "titelsjuka" ;
  titelsjukhet_nn_1_N = mkN "titelsjukhet" ;
  titrerbarhet_nn_1_N = mkN "titrerbarhet" ;
  tittut_nn_1_N = mkN "tittut" ;
  titulerbarhet_nn_1_N = mkN "titulerbarhet" ;
  tjafsighet_nn_1_N = mkN "tjafsighet" ;
  tjockhet_nn_1_N = mkN "tjockhet" ;
  tjockmjoelk_nn_1_1_N = mkN "tjockmjölk" ;
  tjugoett_nn_1_N = mkN "tjugoett" ;
  tjugondag_nn_1_N = mkN "tjugondag" ;
  tjurighet_nn_1_N = mkN "tjurighet" ;
  tjurved_nn_1_N = mkN "tjurved" ;
  tjuskraft_nn_1_N = mkN "tjuskraft" ;
  tjuvaktighet_nn_1_N = mkN "tjuvaktighet" ;
  tjuvfiskning_nn_1_N = mkN "tjuvfiskning" ;
  tjuvjakt_nn_1_N = mkN "tjuvjakt" ;
  tjuvroekning_nn_1_1_N = mkN "tjuvrökning" ;
  tjuvtittning_nn_1_N = mkN "tjuvtittning" ;
  tjuvtjockhet_nn_1_N = mkN "tjuvtjockhet" ;
  tjyvaktighet_nn_1_N = mkN "tjyvaktighet" ;
  tjyvjakt_nn_1_N = mkN "tjyvjakt" ;
  tjyvroekning_nn_1_1_N = mkN "tjyvrökning" ;
  tjyvtittning_nn_1_N = mkN "tjyvtittning" ;
  tjyvtjockhet_nn_1_N = mkN "tjyvtjockhet" ;
  tjaenlighet_nn_1_1_N = mkN "tjänlighet" ;
  tjaenstaktighet_nn_1_1_N = mkN "tjänstaktighet" ;
  tjaenstbarhet_nn_1_1_N = mkN "tjänstbarhet" ;
  tjaensteplikt_nn_1_1_N = mkN "tjänsteplikt" ;
  tjaenstevikt_nn_1_1_N = mkN "tjänstevikt" ;
  tjaenstfrihet_nn_1_1_N = mkN "tjänstfrihet" ;
  tjaenstvillighet_nn_1_1_N = mkN "tjänstvillighet" ;
  tjaerimpregnering_nn_1_1_N = mkN "tjärimpregnering" ;
  tjaerpapp_nn_1_1_N = mkN "tjärpapp" ;
  tjaerved_nn_1_1_N = mkN "tjärved" ;
  toast_nn_1_N = mkN "toast" ;
  tobak_nn_1_N = mkN "tobak" ;
  tobleronepolitik_nn_1_N = mkN "tobleronepolitik" ;
  tofsighet_nn_1_N = mkN "tofsighet" ;
  tolererbarhet_nn_1_N = mkN "tolererbarhet" ;
  tolvfaldighet_nn_1_N = mkN "tolvfaldighet" ;
  tolvtonsmusik_nn_1_N = mkN "tolvtonsmusik" ;
  tomatsaas_nn_1_1_N = mkN "tomatsås" ;
  tombak_nn_1_N = mkN "tombak" ;
  tomgaang_nn_1_1_N = mkN "tomgång" ;
  tomgaangskoerning_nn_1_1_N = mkN "tomgångskörning" ;
  tomhetskaensla_nn_1_1_N = mkN "tomhetskänsla" ;
  tomhaenthet_nn_1_1_N = mkN "tomhänthet" ;
  tomtebolycka_nn_1_N = mkN "tomtebolycka" ;
  tomtefar_nn_1_N = mkN "tomtefar" ;
  tomtraett_nn_1_1_N = mkN "tomträtt" ;
  tondoevhet_nn_1_1_N = mkN "tondövhet" ;
  tonic_nn_1_N = mkN "tonic" ;
  tonkonst_nn_1_N = mkN "tonkonst" ;
  tonloeshet_nn_1_1_N = mkN "tonlöshet" ;
  tonsaekerhet_nn_1_1_N = mkN "tonsäkerhet" ;
  tonus_nn_1_N = mkN "tonus" ;
  tonvikt_nn_1_N = mkN "tonvikt" ;
  toppbrand_nn_1_N = mkN "toppbrand" ;
  toppeld_nn_1_N = mkN "toppeld" ;
  toppfart_nn_1_N = mkN "toppfart" ;
  toppform_nn_1_N = mkN "toppform" ;
  toppformighet_nn_1_N = mkN "toppformighet" ;
  toppighet_nn_1_N = mkN "toppighet" ;
  toppklass_nn_1_N = mkN "toppklass" ;
  toppstyrdhet_nn_1_N = mkN "toppstyrdhet" ;
  topsning_nn_1_N = mkN "topsning" ;
  torderbarhet_nn_1_N = mkN "torderbarhet" ;
  torgskraeck_nn_1_1_N = mkN "torgskräck" ;
  torpederbarhet_nn_1_N = mkN "torpederbarhet" ;
  torrdestillerbarhet_nn_1_N = mkN "torrdestillerbarhet" ;
  torrfisk_nn_1_N = mkN "torrfisk" ;
  torrhet_nn_1_N = mkN "torrhet" ;
  torrhosta_nn_1_N = mkN "torrhosta" ;
  torris_nn_1_N = mkN "torris" ;
  torrjaest_nn_1_1_N = mkN "torrjäst" ;
  torrmjoelk_nn_1_1_N = mkN "torrmjölk" ;
  torrnaalsgravyr_nn_1_1_N = mkN "torrnålsgravyr" ;
  torrschamponerbarhet_nn_1_N = mkN "torrschamponerbarhet" ;
  torrskoddhet_nn_1_N = mkN "torrskoddhet" ;
  torrsprit_nn_1_N = mkN "torrsprit" ;
  torrsubstans_nn_1_N = mkN "torrsubstans" ;
  torrved_nn_1_N = mkN "torrved" ;
  torroegdhet_nn_1_1_N = mkN "torrögdhet" ;
  torsk_nn_2_N = mkN "torsk" ;
  torterbarhet_nn_1_N = mkN "torterbarhet" ;
  torv_nn_1_N = mkN "torv" ;
  torvaktighet_nn_1_N = mkN "torvaktighet" ;
  torvmull_nn_1_N = mkN "torvmull" ;
  totalfinansierbarhet_nn_1_N = mkN "totalfinansierbarhet" ;
  totalfotboll_nn_1_N = mkN "totalfotboll" ;
  toucherbarhet_nn_1_N = mkN "toucherbarhet" ;
  touchmetod_nn_1_N = mkN "touchmetod" ;
  touperbarhet_nn_1_N = mkN "touperbarhet" ;
  tovighet_nn_1_N = mkN "tovighet" ;
  traderbarhet_nn_1_N = mkN "traderbarhet" ;
  traditionsenlighet_nn_1_N = mkN "traditionsenlighet" ;
  tradjazz_nn_1_N = mkN "tradjazz" ;
  trafficking_nn_1_N = mkN "trafficking" ;
  trafik_nn_1_N = mkN "trafik" "trafiker" ;
  trafikdoed_nn_1_1_N = mkN "trafikdöd" ;
  trafikerbarhet_nn_1_N = mkN "trafikerbarhet" ;
  trafikfarlighet_nn_1_N = mkN "trafikfarlighet" ;
  trafikpolitik_nn_1_N = mkN "trafikpolitik" ;
  trafikreglerbarhet_nn_1_N = mkN "trafikreglerbarhet" ;
  tragglighet_nn_1_N = mkN "tragglighet" ;
  tragik_nn_1_N = mkN "tragik" ;
  trakasserbarhet_nn_1_N = mkN "trakasserbarhet" ;
  traktan_nn_1_N = mkN "traktan" ;
  trakterbarhet_nn_1_N = mkN "trakterbarhet" ;
  trampfart_nn_1_N = mkN "trampfart" ;
  tran_nn_1_N = mkN "tran" ;
  trancherbarhet_nn_1_N = mkN "trancherbarhet" ;
  trandans_nn_1_N = mkN "trandans" ;
  tranedans_nn_1_N = mkN "tranedans" ;
  trans_nn_1_N = mkN "trans" ;
  transcendens_nn_1_N = mkN "transcendens" ;
  transcendenthet_nn_1_N = mkN "transcendenthet" ;
  transfererbarhet_nn_1_N = mkN "transfererbarhet" ;
  transformerbarhet_nn_1_N = mkN "transformerbarhet" ;
  transiterbarhet_nn_1_N = mkN "transiterbarhet" ;
  transitivitet_nn_1_N = mkN "transitivitet" ;
  transkriberbarhet_nn_1_N = mkN "transkriberbarhet" ;
  translittererbarhet_nn_1_N = mkN "translittererbarhet" ;
  transmitterbarhet_nn_1_N = mkN "transmitterbarhet" ;
  transmuterbarhet_nn_1_N = mkN "transmuterbarhet" ;
  transnationalitet_nn_1_N = mkN "transnationalitet" ;
  transparenthet_nn_1_N = mkN "transparenthet" ;
  transplanterbarhet_nn_1_N = mkN "transplanterbarhet" ;
  transponerbarhet_nn_1_N = mkN "transponerbarhet" ;
  transporterbarhet_nn_1_N = mkN "transporterbarhet" ;
  transsylvanskhet_nn_1_N = mkN "transsylvanskhet" ;
  transumerbarhet_nn_1_N = mkN "transumerbarhet" ;
  trapp_nn_2_N = mkN "trapp" ;
  trappstaedning_nn_1_1_N = mkN "trappstädning" ;
  traselegans_nn_1_N = mkN "traselegans" ;
  trasighet_nn_1_N = mkN "trasighet" ;
  trasserbarhet_nn_1_N = mkN "trasserbarhet" ;
  trattformighet_nn_1_N = mkN "trattformighet" ;
  trav_nn_2_N = mkN "trav" ;
  travesterbarhet_nn_1_N = mkN "travesterbarhet" ;
  travsport_nn_1_N = mkN "travsport" ;
  trebenthet_nn_1_N = mkN "trebenthet" ;
  tredskhet_nn_1_N = mkN "tredskhet" ;
  tredubbling_nn_1_N = mkN "tredubbling" ;
  treenighetsmystik_nn_1_N = mkN "treenighetsmystik" ;
  trefaldighetssoendag_nn_1_1_N = mkN "trefaldighetssöndag" ;
  trefilighet_nn_1_N = mkN "trefilighet" ;
  trefjaerdedelstakt_nn_1_1_N = mkN "trefjärdedelstakt" ;
  trefot_nn_1_N = mkN "trefot" ;
  trendkaenslighet_nn_1_1_N = mkN "trendkänslighet" ;
  trendriktighet_nn_1_N = mkN "trendriktighet" ;
  trepanerbarhet_nn_1_N = mkN "trepanerbarhet" ;
  trestavighet_nn_1_N = mkN "trestavighet" ;
  tretakt_nn_1_N = mkN "tretakt" ;
  tretand_nn_1_N = mkN "tretand" ;
  trettondag_nn_1_N = mkN "trettondag" ;
  trettondedag_nn_1_N = mkN "trettondedag" ;
  trevinklighet_nn_1_N = mkN "trevinklighet" ;
  trial_and_error_nn_1_N = mkN "trial-and-error" ;
  trial_nn_1_N = mkN "trial" ;
  triangulerbarhet_nn_1_N = mkN "triangulerbarhet" ;
  trierbarhet_nn_1_N = mkN "trierbarhet" ;
  trift_nn_1_N = mkN "trift" ;
  trikinos_nn_1_N = mkN "trikinos" ;
  trilskhet_nn_1_N = mkN "trilskhet" ;
  trindhet_nn_1_N = mkN "trindhet" ;
  trindsaed_nn_1_1_N = mkN "trindsäd" ;
  triss_nn_1_N = mkN "triss" ;
  tristess_nn_1_N = mkN "tristess" "tristesser" ;
  tristhet_nn_1_N = mkN "tristhet" "tristheter" ;
  trivialiserbarhet_nn_1_N = mkN "trivialiserbarhet" ;
  trixighet_nn_2_N = mkN "trixighet" ;
  trolighet_nn_1_N = mkN "trolighet" ;
  trollkraft_nn_1_N = mkN "trollkraft" ;
  trollkrets_nn_1_N = mkN "trollkrets" ;
  trollkunnighet_nn_1_N = mkN "trollkunnighet" ;
  trollmakt_nn_1_N = mkN "trollmakt" ;
  trolskhet_nn_1_N = mkN "trolskhet" ;
  trosfasthet_nn_1_N = mkN "trosfasthet" ;
  trosfrid_nn_1_N = mkN "trosfrid" ;
  trosgloed_nn_1_1_N = mkN "trosglöd" ;
  troskyldighet_nn_1_N = mkN "troskyldighet" ;
  trostolerans_nn_1_N = mkN "trostolerans" ;
  trosvisshet_nn_1_N = mkN "trosvisshet" ;
  trotsighet_nn_1_N = mkN "trotsighet" ;
  trottoarhyfs_nn_1_N = mkN "trottoarhyfs" ;
  trotyl_nn_1_N = mkN "trotyl" ;
  trovaerdhet_nn_1_1_N = mkN "trovärdhet" ;
  trovaerdighet_nn_1_1_N = mkN "trovärdighet" ;
  trubbighet_nn_1_N = mkN "trubbighet" ;
  trubbnosighet_nn_1_N = mkN "trubbnosighet" ;
  trubbnaesthet_nn_1_1_N = mkN "trubbnästhet" ;
  trubbvinklighet_nn_1_N = mkN "trubbvinklighet" ;
  trulighet_nn_1_N = mkN "trulighet" ;
  trulsighet_nn_1_N = mkN "trulsighet" ;
  trumeld_nn_1_N = mkN "trumeld" ;
  trumpenhet_nn_1_N = mkN "trumpenhet" ;
  trumsjuka_nn_1_N = mkN "trumsjuka" ;
  trupptjaenst_nn_1_1_N = mkN "trupptjänst" ;
  tryckbarhet_nn_1_N = mkN "tryckbarhet" ;
  tryckimpregnerbarhet_nn_1_N = mkN "tryckimpregnerbarhet" ;
  tryckkaenslighet_nn_1_1_N = mkN "tryckkänslighet" ;
  tryckluft_nn_1_N = mkN "tryckluft" ;
  tryckstarkhet_nn_1_N = mkN "tryckstarkhet" ;
  trycksvaghet_nn_1_N = mkN "trycksvaghet" ;
  trycksvaerta_nn_1_1_N = mkN "trycksvärta" ;
  trycksaekerhet_nn_1_1_N = mkN "trycksäkerhet" ;
  tryckthet_nn_1_N = mkN "tryckthet" ;
  tryfferbarhet_nn_1_N = mkN "tryfferbarhet" ;
  trygghet_nn_2_N = mkN "trygghet" ;
  traeaktighet_nn_1_1_N = mkN "träaktighet" ;
  traeck_nn_1_1_N = mkN "träck" ;
  traedgaardskonst_nn_1_1_N = mkN "trädgårdskonst" ;
  traeflis_nn_1_1_N = mkN "träflis" ;
  traegenhet_nn_1_1_N = mkN "trägenhet" ;
  traeighet_nn_1_1_N = mkN "träighet" ;
  traelighet_nn_1_1_N = mkN "trälighet" ;
  traeng_nn_1_1_N = mkN "träng" ;
  traengdhet_nn_1_1_N = mkN "trängdhet" ;
  traeskallighet_nn_1_1_N = mkN "träskallighet" ;
  traesloejd_nn_1_1_N = mkN "träslöjd" ;
  traesmak_nn_1_1_N = mkN "träsmak" ;
  traesprit_nn_1_1_N = mkN "träsprit" ;
  traetgirighet_nn_1_1_N = mkN "trätgirighet" ;
  traeull_nn_1_1_N = mkN "träull" ;
  traadformighet_nn_1_1_N = mkN "trådformighet" ;
  traadloeshet_nn_1_1_N = mkN "trådlöshet" ;
  traadmatning_nn_1_1_N = mkN "trådmatning" ;
  traakfotboll_nn_1_1_N = mkN "tråkfotboll" ;
  traangboddhet_nn_1_1_N = mkN "trångboddhet" ;
  traanghet_nn_1_1_N = mkN "trånghet" ;
  traangsinthet_nn_1_1_N = mkN "trångsinthet" ;
  traangsyn_nn_1_1_N = mkN "trångsyn" ;
  traangsynthet_nn_1_1_N = mkN "trångsynthet" ;
  traansjukhet_nn_1_1_N = mkN "trånsjukhet" ;
  troegbeddhet_nn_1_1_N = mkN "trögbeddhet" ;
  troeghet_nn_1_1_N = mkN "tröghet" ;
  troeghetskraft_nn_1_1_N = mkN "tröghetskraft" ;
  troeghetslag_nn_1_1_N = mkN "tröghetslag" ;
  troeghetsnavigerbarhet_nn_1_1_N = mkN "tröghetsnavigerbarhet" ;
  troeglaesthet_nn_1_1_N = mkN "tröglästhet" ;
  troegroerlighet_nn_1_1_N = mkN "trögrörlighet" ;
  troegtaenkthet_nn_1_1_N = mkN "trögtänkthet" ;
  troest_nn_1_1_N = mkN "tröst" ;
  troesterikhet_nn_1_1_N = mkN "trösterikhet" ;
  troestloeshet_nn_1_1_N = mkN "tröstlöshet" ;
  troestrikhet_nn_1_1_N = mkN "tröstrikhet" ;
  troetthet_nn_1_1_N = mkN "trötthet" ;
  troettkoerdhet_nn_1_1_N = mkN "tröttkördhet" ;
  troettsamhet_nn_1_1_N = mkN "tröttsamhet" ;
  tuberkulos_nn_1_N = mkN "tuberkulos" ;
  tuffhet_nn_1_N = mkN "tuffhet" ;
  tufsighet_nn_1_N = mkN "tufsighet" ;
  tuggtobak_nn_1_N = mkN "tuggtobak" ;
  tukt_nn_1_N = mkN "tukt" ;
  tuktighet_nn_1_N = mkN "tuktighet" ;
  tulipanaros_nn_1_N = mkN "tulipanaros" ;
  tullfrihet_nn_1_N = mkN "tullfrihet" ;
  tullpliktighet_nn_1_N = mkN "tullpliktighet" ;
  tullpolitik_nn_1_N = mkN "tullpolitik" ;
  tummeliten_nn_1_N = mkN "tummeliten" ;
  tumrullning_nn_1_N = mkN "tumrullning" ;
  tungkoerdhet_nn_1_1_N = mkN "tungkördhet" ;
  tunglaesthet_nn_1_1_N = mkN "tunglästhet" ;
  tungroddhet_nn_1_N = mkN "tungroddhet" ;
  tungrot_nn_1_N = mkN "tungrot" ;
  tungsamhet_nn_1_N = mkN "tungsamhet" ;
  tungspat_nn_1_N = mkN "tungspat" ;
  tungsoevdhet_nn_1_1_N = mkN "tungsövdhet" ;
  tungvikt_nn_1_N = mkN "tungvikt" ;
  tunnhet_nn_1_N = mkN "tunnhet" ;
  tunnhaarighet_nn_1_1_N = mkN "tunnhårighet" ;
  tunnklaeddhet_nn_1_1_N = mkN "tunnkläddhet" ;
  tunnplaat_nn_1_1_N = mkN "tunnplåt" ;
  tunnsaaddhet_nn_1_1_N = mkN "tunnsåddhet" ;
  tuperbarhet_nn_1_N = mkN "tuperbarhet" ;
  tur_nn_2_N = mkN "tur" ;
  turbulens_nn_1_N = mkN "turbulens" ;
  turf_nn_1_N = mkN "turf" ;
  turisttaethet_nn_1_1_N = mkN "turisttäthet" ;
  turlighet_nn_1_N = mkN "turlighet" ;
  turnerbarhet_nn_1_N = mkN "turnerbarhet" ;
  tursamhet_nn_1_N = mkN "tursamhet" ;
  tuscherbarhet_nn_1_N = mkN "tuscherbarhet" ;
  tuvstarr_nn_1_N = mkN "tuvstarr" ;
  tv_reklam_nn_1_N = mkN "tv-reklam" ;
  tvedraekt_nn_1_1_N = mkN "tvedräkt" ;
  tvehaagsenhet_nn_1_1_N = mkN "tvehågsenhet" ;
  tvekloeshet_nn_1_1_N = mkN "tveklöshet" ;
  tvillinglikhet_nn_1_N = mkN "tvillinglikhet" ;
  tvills_nn_1_N = mkN "tvills" ;
  tvinsot_nn_1_N = mkN "tvinsot" ;
  tvivelaktighet_nn_1_N = mkN "tvivelaktighet" ;
  tvivelsamhet_nn_1_N = mkN "tvivelsamhet" ;
  tvivelsjukhet_nn_1_N = mkN "tvivelsjukhet" ;
  tvaerarghet_nn_1_1_N = mkN "tvärarghet" ;
  tvaerbranthet_nn_1_1_N = mkN "tvärbranthet" ;
  tvaerfacklighet_nn_1_1_N = mkN "tvärfacklighet" ;
  tvaerhand_nn_1_1_N = mkN "tvärhand" ;
  tvaerhet_nn_1_1_N = mkN "tvärhet" ;
  tvaermaetthet_nn_1_1_N = mkN "tvärmätthet" ;
  tvaerrandighet_nn_1_1_N = mkN "tvärrandighet" ;
  tvaerspagat_nn_1_1_N = mkN "tvärspagat" ;
  tvaersaekerhet_nn_1_1_N = mkN "tvärsäkerhet" ;
  tvaervetenskaplighet_nn_1_1_N = mkN "tvärvetenskaplighet" ;
  tvaettbarhet_nn_1_1_N = mkN "tvättbarhet" ;
  tvaafjaerdedelstakt_nn_1_1_N = mkN "tvåfjärdedelstakt" ;
  tvaaformighet_nn_1_1_N = mkN "tvåformighet" ;
  tvaahjulighet_nn_1_1_N = mkN "tvåhjulighet" ;
  tvaahaenthet_nn_1_1_N = mkN "tvåhänthet" ;
  tvaalfagerhet_nn_1_1_N = mkN "tvålfagerhet" ;
  tvaalighet_nn_1_1_N = mkN "tvålighet" ;
  tvaangfrihet_nn_1_1_N = mkN "tvångfrihet" ;
  tvaangskommenderbarhet_nn_1_1_N = mkN "tvångskommenderbarhet" ;
  tvaangsrekryterbarhet_nn_1_1_N = mkN "tvångsrekryterbarhet" ;
  tvaangstatuerbarhet_nn_1_1_N = mkN "tvångstatuerbarhet" ;
  tvaangsvaard_nn_1_1_N = mkN "tvångsvård" ;
  tvaaspraakighet_nn_1_1_N = mkN "tvåspråkighet" ;
  tvaastavighet_nn_1_1_N = mkN "tvåstavighet" ;
  tweed_nn_1_N = mkN "tweed" ;
  twill_nn_1_N = mkN "twill" ;
  twist_nn_1_N = mkN "twist" ;
  tyckmyckenhet_nn_1_N = mkN "tyckmyckenhet" ;
  tydbarhet_nn_1_N = mkN "tydbarhet" ;
  tydlighet_nn_1_N = mkN "tydlighet" ;
  tyfus_nn_1_N = mkN "tyfus" ;
  tygelloeshet_nn_1_1_N = mkN "tygellöshet" ;
  tygtjaenst_nn_1_1_N = mkN "tygtjänst" ;
  tymus_nn_1_N = mkN "tymus" ;
  tyngdkraft_nn_1_N = mkN "tyngdkraft" ;
  tyngdlag_nn_1_N = mkN "tyngdlag" ;
  typifierbarhet_nn_1_N = mkN "typifierbarhet" ;
  typiserbarhet_nn_1_N = mkN "typiserbarhet" ;
  typiskhet_nn_1_N = mkN "typiskhet" ;
  tyranniserbarhet_nn_1_N = mkN "tyranniserbarhet" ;
  tyskhet_nn_1_N = mkN "tyskhet" ;
  tyskspraakighet_nn_1_1_N = mkN "tyskspråkighet" ;
  tyskundervisning_nn_1_N = mkN "tyskundervisning" ;
  tystlaatenhet_nn_1_1_N = mkN "tystlåtenhet" ;
  tystnadsed_nn_1_N = mkN "tystnadsed" ;
  tystnadsplikt_nn_1_N = mkN "tystnadsplikt" ;
  taeckelighet_nn_1_1_N = mkN "täckelighet" ;
  taeckhet_nn_1_1_N = mkN "täckhet" ;
  taeltduk_nn_1_1_N = mkN "tältduk" ;
  taenjbarhet_nn_1_1_N = mkN "tänjbarhet" ;
  taerdhet_nn_1_1_N = mkN "tärdhet" ;
  taethet_nn_1_1_N = mkN "täthet" ;
  taetmjoelk_nn_1_1_N = mkN "tätmjölk" ;
  taetortstrafik_nn_1_1_N = mkN "tätortstrafik" ;
  taettbebyggdhet_nn_1_1_N = mkN "tättbebyggdhet" ;
  taettklippthet_nn_1_1_N = mkN "tättklippthet" ;
  taetoert_nn_1_1_N = mkN "tätört" ;
  taagtrafik_nn_1_1_N = mkN "tågtrafik" ;
  taalighet_nn_1_1_N = mkN "tålighet" ;
  taalmodighet_nn_1_1_N = mkN "tålmodighet" ;
  taang_nn_2_1_N = mkN "tång" ;
  taardraenkthet_nn_1_1_N = mkN "tårdränkthet" ;
  taargas_nn_1_1_N = mkN "tårgas" ;
  taartspadeprincip_nn_1_1_N = mkN "tårtspadeprincip" ;
  taaroegdhet_nn_1_1_N = mkN "tårögdhet" ;
  taaspetsdans_nn_1_1_N = mkN "tåspetsdans" ;
  toecknighet_nn_1_1_N = mkN "töcknighet" ;
  toelpaktighet_nn_1_1_N = mkN "tölpaktighet" ;
  toelpighet_nn_1_1_N = mkN "tölpighet" ;
  toelt_nn_1_1_N = mkN "tölt" ;
  toernighet_nn_1_1_N = mkN "törnighet" ;
  toernrosasoemn_nn_1_1_N = mkN "törnrosasömn" ;
  toerst_nn_1_1_N = mkN "törst" ;
  toerstighet_nn_1_1_N = mkN "törstighet" ;
  u_hjaelp_nn_1_1_N = mkN "u-hjälp" ;
  uddighet_nn_1_N = mkN "uddighet" ;
  uddloeshet_nn_1_1_N = mkN "uddlöshet" ;
  uggleved_nn_1_N = mkN "uggleved" ;
  ugnseldfasthet_nn_1_N = mkN "ugnseldfasthet" ;
  ull_nn_1_N = mkN "ull" ;
  ullhaarighet_nn_1_1_N = mkN "ullhårighet" ;
  ullighet_nn_1_N = mkN "ullighet" ;
  ullsvett_nn_1_N = mkN "ullsvett" ;
  ultrarapidfotograferbarhet_nn_1_N = mkN "ultrarapidfotograferbarhet" ;
  ultrasnabbhet_nn_1_N = mkN "ultrasnabbhet" ;
  umgaengeskonst_nn_1_1_N = mkN "umgängeskonst" ;
  umgaengesraett_nn_1_1_N = mkN "umgängesrätt" ;
  umgaengeston_nn_1_1_N = mkN "umgängeston" ;
  undandraekt_nn_1_1_N = mkN "undandräkt" ;
  undangoemdhet_nn_1_1_N = mkN "undangömdhet" ;
  undanskymdhet_nn_1_N = mkN "undanskymdhet" ;
  undantagsloeshet_nn_1_1_N = mkN "undantagslöshet" ;
  underarmsmuskulatur_nn_1_N = mkN "underarmsmuskulatur" ;
  underbalans_nn_1_N = mkN "underbalans" ;
  underbalanserbarhet_nn_1_N = mkN "underbalanserbarhet" ;
  underbarhet_nn_1_N = mkN "underbarhet" ;
  underdimensionerbarhet_nn_1_N = mkN "underdimensionerbarhet" ;
  underexponerbarhet_nn_1_N = mkN "underexponerbarhet" ;
  underfullhet_nn_1_N = mkN "underfullhet" ;
  underfoerstaaddhet_nn_1_1_N = mkN "underförståddhet" ;
  undergivenhet_nn_1_N = mkN "undergivenhet" ;
  undergroundmusik_nn_1_N = mkN "undergroundmusik" ;
  undergaangsromantik_nn_1_1_N = mkN "undergångsromantik" ;
  underhaltighet_nn_1_N = mkN "underhaltighet" ;
  underhud_nn_1_N = mkN "underhud" ;
  underhaallningsbransch_nn_1_1_N = mkN "underhållningsbransch" ;
  underjaest_nn_1_1_N = mkN "underjäst" ;
  underklass_nn_1_N = mkN "underklass" ;
  underklassighet_nn_1_N = mkN "underklassighet" ;
  undermedvetenhet_nn_1_N = mkN "undermedvetenhet" ;
  underminerbarhet_nn_1_N = mkN "underminerbarhet" ;
  undermaensklighet_nn_1_1_N = mkN "undermänsklighet" ;
  undernaerdhet_nn_1_1_N = mkN "undernärdhet" ;
  underrapportering_nn_1_N = mkN "underrapportering" ;
  underraettelsetjaenst_nn_1_1_N = mkN "underrättelsetjänst" ;
  undersamhet_nn_1_N = mkN "undersamhet" ;
  underskog_nn_1_N = mkN "underskog" ;
  underskoenhet_nn_1_1_N = mkN "underskönhet" ;
  understyrdhet_nn_1_N = mkN "understyrdhet" ;
  undersaetsighet_nn_1_1_N = mkN "undersätsighet" ;
  undersaatlighet_nn_1_1_N = mkN "undersåtlighet" ;
  undersoekningsmetod_nn_2_1_N = mkN "undersökningsmetod" ;
  undersoekningsplikt_nn_1_1_N = mkN "undersökningsplikt" ;
  undertalighet_nn_1_N = mkN "undertalighet" ;
  undertaxerbarhet_nn_1_N = mkN "undertaxerbarhet" ;
  undervattensgaang_nn_1_1_N = mkN "undervattensgång" ;
  undervikt_nn_1_N = mkN "undervikt" ;
  underviktighet_nn_1_N = mkN "underviktighet" ;
  undervisningsmetodik_nn_1_N = mkN "undervisningsmetodik" ;
  undervaerderbarhet_nn_1_1_N = mkN "undervärderbarhet" ;
  underaarighet_nn_1_1_N = mkN "underårighet" ;
  undfallenhetspolitik_nn_1_N = mkN "undfallenhetspolitik" ;
  undransvaerdhet_nn_1_1_N = mkN "undransvärdhet" ;
  ungdomlighet_nn_1_N = mkN "ungdomlighet" ;
  ungdomspolis_nn_1_N = mkN "ungdomspolis" ;
  ungdomspolitik_nn_1_N = mkN "ungdomspolitik" ;
  ungdomsvaard_nn_1_1_N = mkN "ungdomsvård" ;
  ungefaerlighet_nn_1_1_N = mkN "ungefärlighet" ;
  ungflicksaktighet_nn_1_N = mkN "ungflicksaktighet" ;
  ungkyrklighet_nn_1_N = mkN "ungkyrklighet" ;
  ungrenaessans_nn_1_1_N = mkN "ungrenässans" ;
  unifierbarhet_nn_1_N = mkN "unifierbarhet" ;
  uniformerbarhet_nn_1_N = mkN "uniformerbarhet" ;
  uniformhet_nn_1_N = mkN "uniformhet" ;
  uniformsplikt_nn_1_N = mkN "uniformsplikt" ;
  universaltid_nn_1_N = mkN "universaltid" ;
  unkenhet_nn_1_N = mkN "unkenhet" ;
  uppblaasthet_nn_1_1_N = mkN "uppblåsthet" ;
  uppbragthet_nn_1_N = mkN "uppbragthet" ;
  uppbyggelselitteratur_nn_1_N = mkN "uppbyggelselitteratur" ;
  uppbygglighet_nn_1_N = mkN "uppbygglighet" ;
  uppdaterbarhet_nn_1_N = mkN "uppdaterbarhet" ;
  uppenbarhet_nn_1_N = mkN "uppenbarhet" ;
  uppfattning_nn_2_N = mkN "uppfattning" ;
  uppfinningsrikhet_nn_1_N = mkN "uppfinningsrikhet" ;
  uppfaellbarhet_nn_1_1_N = mkN "uppfällbarhet" ;
  uppgraderbarhet_nn_1_N = mkN "uppgraderbarhet" ;
  upphinnelighet_nn_1_N = mkN "upphinnelighet" ;
  upphovsmannaraett_nn_1_1_N = mkN "upphovsmannarätt" ;
  upphovsraett_nn_1_1_N = mkN "upphovsrätt" ;
  uppjusterbarhet_nn_1_N = mkN "uppjusterbarhet" ;
  uppklaeddhet_nn_1_1_N = mkN "uppkläddhet" ;
  uppknaeppthet_nn_1_1_N = mkN "uppknäppthet" ;
  uppkomst_nn_1_N = mkN "uppkomst" ;
  uppkoerdhet_nn_1_1_N = mkN "uppkördhet" ;
  upplagespiral_nn_1_N = mkN "upplagespiral" ;
  upplagsnaering_nn_1_1_N = mkN "upplagsnäring" ;
  upplysningstid_nn_1_N = mkN "upplysningstid" ;
  upplysthet_nn_1_N = mkN "upplysthet" ;
  uppmjukningspolitik_nn_1_N = mkN "uppmjukningspolitik" ;
  uppnosighet_nn_1_N = mkN "uppnosighet" ;
  uppnaesthet_nn_1_1_N = mkN "uppnästhet" ;
  uppnaaelighet_nn_1_1_N = mkN "uppnåelighet" ;
  uppochnedvaendhet_nn_1_1_N = mkN "uppochnedvändhet" ;
  uppochnervaendhet_nn_1_1_N = mkN "uppochnervändhet" ;
  uppreklamerbarhet_nn_1_N = mkN "uppreklamerbarhet" ;
  upprymdhet_nn_1_N = mkN "upprymdhet" ;
  upproerdhet_nn_1_1_N = mkN "upprördhet" ;
  uppsikt_nn_1_N = mkN "uppsikt" ;
  uppskraemdhet_nn_1_1_N = mkN "uppskrämdhet" ;
  uppslagsrikhet_nn_1_N = mkN "uppslagsrikhet" ;
  uppsluppenhet_nn_1_N = mkN "uppsluppenhet" ;
  uppspelthet_nn_1_N = mkN "uppspelthet" ;
  uppstraeckthet_nn_1_1_N = mkN "uppsträckthet" ;
  uppstudsighet_nn_1_N = mkN "uppstudsighet" ;
  uppsummerbarhet_nn_1_N = mkN "uppsummerbarhet" ;
  uppsvaelldhet_nn_1_1_N = mkN "uppsvälldhet" ;
  uppsaendning_nn_1_1_N = mkN "uppsändning" ;
  uppsaatlighet_nn_1_1_N = mkN "uppsåtlighet" ;
  upptaxerbarhet_nn_1_N = mkN "upptaxerbarhet" ;
  upptorkning_nn_1_N = mkN "upptorkning" ;
  upptaendhet_nn_1_1_N = mkN "upptändhet" ;
  uppvaerderbarhet_nn_1_1_N = mkN "uppvärderbarhet" ;
  uppvaext_nn_1_1_N = mkN "uppväxt" ;
  uppaanedvaendhet_nn_1_1_N = mkN "uppånedvändhet" ;
  uppaanervaendhet_nn_1_1_N = mkN "uppånervändhet" ;
  ur_nn_3_N = mkN "ur" ;
  urbaniserbarhet_nn_1_N = mkN "urbaniserbarhet" ;
  uretan_nn_1_N = mkN "uretan" ;
  urfaanighet_nn_1_1_N = mkN "urfånighet" ;
  urholkning_nn_2_N = mkN "urholkning" ;
  urin_nn_1_N = mkN "urin" ;
  urkundlighet_nn_1_N = mkN "urkundlighet" ;
  urmodighet_nn_1_N = mkN "urmodighet" ;
  ursinnighet_nn_1_N = mkN "ursinnighet" ;
  urskiljbarhet_nn_1_N = mkN "urskiljbarhet" ;
  urskiljningsloeshet_nn_1_1_N = mkN "urskiljningslöshet" ;
  urskillningsloeshet_nn_1_1_N = mkN "urskillningslöshet" ;
  ursnygghet_nn_1_N = mkN "ursnygghet" ;
  ursprunglighet_nn_1_N = mkN "ursprunglighet" ;
  urstyvhet_nn_1_N = mkN "urstyvhet" ;
  ursaektlighet_nn_1_1_N = mkN "ursäktlighet" ;
  urtagbarhet_nn_1_N = mkN "urtagbarhet" ;
  urtid_nn_1_N = mkN "urtid" ;
  urtjusighet_nn_1_N = mkN "urtjusighet" ;
  urvattning_nn_1_N = mkN "urvattning" ;
  uraaldrighet_nn_1_1_N = mkN "uråldrighet" ;
  usurperbarhet_nn_1_N = mkN "usurperbarhet" ;
  utackorderbarhet_nn_1_N = mkN "utackorderbarhet" ;
  utandningsluft_nn_1_N = mkN "utandningsluft" ;
  utannonserbarhet_nn_1_N = mkN "utannonserbarhet" ;
  utarrenderbarhet_nn_1_N = mkN "utarrenderbarhet" ;
  utbalanserbarhet_nn_1_N = mkN "utbalanserbarhet" ;
  utbasunerbarhet_nn_1_N = mkN "utbasunerbarhet" ;
  utbildningspolitik_nn_1_N = mkN "utbildningspolitik" ;
  utbreddhet_nn_1_N = mkN "utbreddhet" ;
  utbroderbarhet_nn_1_N = mkN "utbroderbarhet" ;
  utbraendhet_nn_1_1_N = mkN "utbrändhet" ;
  utbudspolitik_nn_1_N = mkN "utbudspolitik" ;
  utbyggbarhet_nn_1_N = mkN "utbyggbarhet" ;
  utdebiterbarhet_nn_1_N = mkN "utdebiterbarhet" ;
  utdragbarhet_nn_1_N = mkN "utdragbarhet" ;
  utdoedhet_nn_1_1_N = mkN "utdödhet" ;
  uteffekt_nn_1_N = mkN "uteffekt" ;
  uteslutningsmetod_nn_1_N = mkN "uteslutningsmetod" ;
  utexaminerbarhet_nn_1_N = mkN "utexaminerbarhet" ;
  utexperimenterbarhet_nn_1_N = mkN "utexperimenterbarhet" ;
  utfattighet_nn_1_N = mkN "utfattighet" ;
  utfiskning_nn_1_N = mkN "utfiskning" ;
  utfrysthet_nn_1_N = mkN "utfrysthet" ;
  utfaellbarhet_nn_1_1_N = mkN "utfällbarhet" ;
  utfoerbarhet_nn_1_1_N = mkN "utförbarhet" ;
  utfoerlighet_nn_1_1_N = mkN "utförlighet" ;
  utgiftsdisciplin_nn_1_N = mkN "utgiftsdisciplin" ;
  utgrening_nn_1_N = mkN "utgrening" ;
  uthaerdlighet_nn_1_1_N = mkN "uthärdlighet" ;
  utjord_nn_1_N = mkN "utjord" ;
  utklarerbarhet_nn_1_N = mkN "utklarerbarhet" ;
  utkommenderbarhet_nn_1_N = mkN "utkommenderbarhet" ;
  utkomst_nn_1_N = mkN "utkomst" ;
  utkonkurrerbarhet_nn_1_N = mkN "utkonkurrerbarhet" ;
  utkristalliserbarhet_nn_1_N = mkN "utkristalliserbarhet" ;
  utkvitterbarhet_nn_1_N = mkN "utkvitterbarhet" ;
  utkyldhet_nn_1_N = mkN "utkyldhet" ;
  utkoerdhet_nn_1_1_N = mkN "utkördhet" ;
  utlandsfoersaeljning_nn_1_1_N = mkN "utlandsförsäljning" ;
  utlandstjaenst_nn_1_1_N = mkN "utlandstjänst" ;
  utledhet_nn_1_N = mkN "utledhet" ;
  utlokaliserbarhet_nn_1_N = mkN "utlokaliserbarhet" ;
  utmanoevrerbarhet_nn_1_1_N = mkN "utmanövrerbarhet" ;
  utminuterbarhet_nn_1_N = mkN "utminuterbarhet" ;
  utmaergling_nn_1_1_N = mkN "utmärgling" ;
  utmaerkthet_nn_1_1_N = mkN "utmärkthet" ;
  utnoetthet_nn_1_1_N = mkN "utnötthet" ;
  utomhusloepning_nn_1_1_N = mkN "utomhuslöpning" ;
  utomkroppslighet_nn_1_N = mkN "utomkroppslighet" ;
  utommaensklighet_nn_1_1_N = mkN "utommänsklighet" ;
  utomordentlighet_nn_1_N = mkN "utomordentlighet" ;
  utomaektenskaplighet_nn_1_1_N = mkN "utomäktenskaplighet" ;
  utplacerbarhet_nn_1_N = mkN "utplacerbarhet" ;
  utplattning_nn_1_N = mkN "utplattning" ;
  utposterbarhet_nn_1_N = mkN "utposterbarhet" ;
  utraderbarhet_nn_1_N = mkN "utraderbarhet" ;
  utrangerbarhet_nn_1_N = mkN "utrangerbarhet" ;
  utrikespolitik_nn_1_N = mkN "utrikespolitik" ;
  utrikestrafik_nn_1_N = mkN "utrikestrafik" ;
  utrymmesbrist_nn_1_N = mkN "utrymmesbrist" ;
  utsago_nn_1_N = mkN "utsago" ;
  utsatthet_nn_1_N = mkN "utsatthet" ;
  utsiktsloeshet_nn_1_1_N = mkN "utsiktslöshet" ;
  utskaemdhet_nn_1_1_N = mkN "utskämdhet" ;
  utskaergaard_nn_1_1_N = mkN "utskärgård" ;
  utsot_nn_1_N = mkN "utsot" ;
  utspriddhet_nn_1_N = mkN "utspriddhet" ;
  utspridning_nn_1_N = mkN "utspridning" ;
  utspaeddhet_nn_1_1_N = mkN "utspäddhet" ;
  utspaendhet_nn_1_1_N = mkN "utspändhet" ;
  utstofferbarhet_nn_1_N = mkN "utstofferbarhet" ;
  utstoetthet_nn_1_1_N = mkN "utstötthet" ;
  utsvaengdhet_nn_1_1_N = mkN "utsvängdhet" ;
  utsoevdhet_nn_1_1_N = mkN "utsövdhet" ;
  uttagsbeskattning_nn_1_N = mkN "uttagsbeskattning" ;
  uttalsenlighet_nn_1_N = mkN "uttalsenlighet" ;
  uttaxerbarhet_nn_1_N = mkN "uttaxerbarhet" ;
  uttjaenthet_nn_1_1_N = mkN "uttjänthet" ;
  uttryckbarhet_nn_1_N = mkN "uttryckbarhet" ;
  uttrycklighet_nn_1_N = mkN "uttrycklighet" ;
  uttrycksfullhet_nn_1_N = mkN "uttrycksfullhet" ;
  uttrycksloeshet_nn_1_1_N = mkN "uttryckslöshet" ;
  uttaenjbarhet_nn_1_1_N = mkN "uttänjbarhet" ;
  uttaenkthet_nn_1_1_N = mkN "uttänkthet" ;
  utvaldhet_nn_1_N = mkN "utvaldhet" ;
  utvecklingsmaessighet_nn_1_1_N = mkN "utvecklingsmässighet" ;
  utvidgningspolitik_nn_1_N = mkN "utvidgningspolitik" ;
  utvaendighet_nn_1_1_N = mkN "utvändighet" ;
  utvaerderbarhet_nn_1_1_N = mkN "utvärderbarhet" ;
  utaatvaendhet_nn_1_1_N = mkN "utåtvändhet" ;
  utoevning_nn_1_1_N = mkN "utövning" ;
  vaccinbrist_nn_1_N = mkN "vaccinbrist" ;
  vaccinerbarhet_nn_1_N = mkN "vaccinerbarhet" ;
  vaccineringsturbulens_nn_1_N = mkN "vaccineringsturbulens" ;
  vackerhet_nn_1_N = mkN "vackerhet" ;
  vadbarhet_nn_1_N = mkN "vadbarhet" ;
  vadderbarhet_nn_1_N = mkN "vadderbarhet" ;
  vaghet_nn_1_N = mkN "vaghet" ;
  vakenhet_nn_1_N = mkN "vakenhet" ;
  vaksamhet_nn_1_N = mkN "vaksamhet" ;
  vaksinerbarhet_nn_1_N = mkN "vaksinerbarhet" ;
  valbarhet_nn_1_N = mkN "valbarhet" ;
  valborg_nn_1_N = mkN "valborg" ;
  valborgsmaess_nn_1_1_N = mkN "valborgsmäss" ;
  valboskap_nn_1_N = mkN "valboskap" ;
  valfaangst_nn_1_1_N = mkN "valfångst" ;
  valfoervantskap_nn_1_1_N = mkN "valförvantskap" ;
  valkighet_nn_1_N = mkN "valkighet" ;
  valkning_nn_1_N = mkN "valkning" ;
  valmatematik_nn_1_N = mkN "valmatematik" ;
  valpaktighet_nn_1_N = mkN "valpaktighet" ;
  valpighet_nn_1_N = mkN "valpighet" ;
  valpsjuka_nn_1_N = mkN "valpsjuka" ;
  valrav_nn_1_N = mkN "valrav" ;
  valraett_nn_1_1_N = mkN "valrätt" ;
  valtran_nn_1_N = mkN "valtran" ;
  valutapolitik_nn_1_N = mkN "valutapolitik" ;
  valuterbarhet_nn_1_N = mkN "valuterbarhet" ;
  valverbarhet_nn_1_N = mkN "valverbarhet" ;
  vampighet_nn_1_N = mkN "vampighet" ;
  vanadinbrytning_nn_1_N = mkN "vanadinbrytning" ;
  vanartighet_nn_1_N = mkN "vanartighet" ;
  vandaliserbarhet_nn_1_N = mkN "vandaliserbarhet" ;
  vandringslust_nn_1_N = mkN "vandringslust" ;
  vanemaessighet_nn_1_1_N = mkN "vanemässighet" ;
  vanfrejd_nn_1_N = mkN "vanfrejd" ;
  vanhederlighet_nn_1_N = mkN "vanhederlighet" ;
  vanhelgd_nn_1_N = mkN "vanhelgd" ;
  vanhet_nn_1_N = mkN "vanhet" ;
  vanhaevd_nn_1_1_N = mkN "vanhävd" ;
  vanilj_nn_1_N = mkN "vanilj" ;
  vankelmodighet_nn_1_N = mkN "vankelmodighet" ;
  vanmakt_nn_1_N = mkN "vanmakt" ;
  vanmaektighet_nn_1_1_N = mkN "vanmäktighet" ;
  vanskaplighet_nn_1_N = mkN "vanskaplighet" ;
  vanstarkhet_nn_1_N = mkN "vanstarkhet" ;
  vanstaellning_nn_1_1_N = mkN "vanställning" ;
  vantrogenhet_nn_1_N = mkN "vantrogenhet" ;
  vanvaard_nn_1_1_N = mkN "vanvård" ;
  vanvoerdighet_nn_1_1_N = mkN "vanvördighet" ;
  vapenfoerhet_nn_1_1_N = mkN "vapenförhet" ;
  vapenloeshet_nn_1_1_N = mkN "vapenlöshet" ;
  vapenmakt_nn_1_N = mkN "vapenmakt" ;
  vapentjaenst_nn_1_1_N = mkN "vapentjänst" ;
  vapentraening_nn_1_1_N = mkN "vapenträning" ;
  vapenvaard_nn_1_1_N = mkN "vapenvård" ;
  vardagslunk_nn_1_N = mkN "vardagslunk" ;
  vardagslyx_nn_1_N = mkN "vardagslyx" ;
  vardagsmat_nn_1_N = mkN "vardagsmat" ;
  vardagsrasism_nn_1_N = mkN "vardagsrasism" ;
  vargflocksjakt_nn_1_N = mkN "vargflocksjakt" ;
  vargtaethet_nn_1_1_N = mkN "vargtäthet" ;
  vargurin_nn_1_N = mkN "vargurin" ;
  variansanalys_nn_1_N = mkN "variansanalys" ;
  variationskalkyl_nn_1_N = mkN "variationskalkyl" ;
  varierbarhet_nn_1_N = mkN "varierbarhet" ;
  varkunnsamhet_nn_1_N = mkN "varkunnsamhet" ;
  varlighet_nn_1_N = mkN "varlighet" ;
  varmblodighet_nn_1_N = mkN "varmblodighet" ;
  varmgaang_nn_1_1_N = mkN "varmgång" ;
  varmhet_nn_1_N = mkN "varmhet" ;
  varmluft_nn_1_N = mkN "varmluft" ;
  varsamhet_nn_1_N = mkN "varsamhet" ;
  varudeklarationsnaemnd_nn_1_1_N = mkN "varudeklarationsnämnd" ;
  varudeklarerbarhet_nn_1_N = mkN "varudeklarerbarhet" ;
  varukaennedom_nn_1_1_N = mkN "varukännedom" ;
  varvighet_nn_1_N = mkN "varvighet" ;
  vaskmalm_nn_1_N = mkN "vaskmalm" ;
  vaskning_nn_1_N = mkN "vaskning" ;
  vassbuk_nn_1_N = mkN "vassbuk" ;
  vasshet_nn_1_N = mkN "vasshet" ;
  vasslighet_nn_1_N = mkN "vasslighet" ;
  vattenbyggnadskonst_nn_1_N = mkN "vattenbyggnadskonst" ;
  vattenfasthet_nn_1_N = mkN "vattenfasthet" ;
  vattenfoerbrukning_nn_1_1_N = mkN "vattenförbrukning" ;
  vattenfoersoerjning_nn_1_1_N = mkN "vattenförsörjning" ;
  vattenkastning_nn_1_N = mkN "vattenkastning" ;
  vattenkraft_nn_1_N = mkN "vattenkraft" ;
  vattenkaenslighet_nn_1_1_N = mkN "vattenkänslighet" ;
  vattenpest_nn_1_N = mkN "vattenpest" ;
  vattenplaning_nn_1_N = mkN "vattenplaning" ;
  vattenraett_nn_1_1_N = mkN "vattenrätt" ;
  vattensjukhet_nn_1_N = mkN "vattensjukhet" ;
  vattentaethet_nn_1_1_N = mkN "vattentäthet" ;
  vattentaalighet_nn_1_1_N = mkN "vattentålighet" ;
  vattgroet_nn_1_1_N = mkN "vattgröt" ;
  vattnighet_nn_1_N = mkN "vattnighet" ;
  vattning_nn_1_N = mkN "vattning" ;
  vattrighet_nn_1_N = mkN "vattrighet" ;
  vattsot_nn_1_N = mkN "vattsot" ;
  vattuskraeck_nn_1_1_N = mkN "vattuskräck" ;
  vattusot_nn_1_N = mkN "vattusot" ;
  vaxblekhet_nn_1_N = mkN "vaxblekhet" ;
  veckighet_nn_1_N = mkN "veckighet" ;
  veckopress_nn_1_N = mkN "veckopress" ;
  veckoslutstrafik_nn_1_N = mkN "veckoslutstrafik" ;
  veckovillhet_nn_1_N = mkN "veckovillhet" ;
  ved_nn_1_N = mkN "ved" ;
  vederhaeftighet_nn_1_1_N = mkN "vederhäftighet" ;
  vederlaeggning_nn_1_1_N = mkN "vederläggning" ;
  vegetering_nn_1_N = mkN "vegetering" ;
  vekhet_nn_1_N = mkN "vekhet" ;
  velour_nn_1_N = mkN "velour" ;
  velouriserbarhet_nn_1_N = mkN "velouriserbarhet" ;
  velaeng_nn_1_1_N = mkN "veläng" ;
  vemodighet_nn_1_N = mkN "vemodighet" ;
  ventilerbarhet_nn_1_N = mkN "ventilerbarhet" ;
  verbaliserbarhet_nn_1_N = mkN "verbaliserbarhet" ;
  verifierbarhet_nn_1_N = mkN "verifierbarhet" ;
  verkanseld_nn_1_N = mkN "verkanseld" ;
  verkhelighet_nn_1_N = mkN "verkhelighet" ;
  verklighetsflykt_nn_1_N = mkN "verklighetsflykt" ;
  verkningseld_nn_1_N = mkN "verkningseld" ;
  verkningsfullhet_nn_1_N = mkN "verkningsfullhet" ;
  verkningsloeshet_nn_1_1_N = mkN "verkningslöshet" ;
  vermouth_nn_1_N = mkN "vermouth" ;
  vermut_nn_1_N = mkN "vermut" ;
  versifierbarhet_nn_1_N = mkN "versifierbarhet" ;
  verv_nn_1_N = mkN "verv" ;
  vetbarhet_nn_1_N = mkN "vetbarhet" ;
  vetenskaplighet_nn_1_N = mkN "vetenskaplighet" ;
  veteranpolitik_nn_1_N = mkN "veteranpolitik" ;
  veterinaermedicin_nn_1_1_N = mkN "veterinärmedicin" ;
  vetgirighet_nn_1_N = mkN "vetgirighet" ;
  vetoraett_nn_1_1_N = mkN "vetorätt" ;
  vetskap_nn_1_N = mkN "vetskap" ;
  vettskraemdhet_nn_1_1_N = mkN "vettskrämdhet" ;
  vickighet_nn_1_N = mkN "vickighet" ;
  vidbraendhet_nn_1_1_N = mkN "vidbrändhet" ;
  videoert_nn_1_1_N = mkN "videört" ;
  vidhet_nn_1_N = mkN "vidhet" ;
  vidimerbarhet_nn_1_N = mkN "vidimerbarhet" ;
  vidstraeckthet_nn_1_1_N = mkN "vidsträckthet" ;
  vidsyn_nn_1_N = mkN "vidsyn" ;
  vighet_nn_1_N = mkN "vighet" ;
  vigilans_nn_1_N = mkN "vigilans" ;
  vigoer_nn_1_1_N = mkN "vigör" ;
  vikingatid_nn_1_N = mkN "vikingatid" ;
  viktloeshet_nn_1_1_N = mkN "viktlöshet" ;
  viktnedgaang_nn_1_1_N = mkN "viktnedgång" ;
  viktualievikt_nn_1_N = mkN "viktualievikt" ;
  vikunjaull_nn_1_N = mkN "vikunjaull" ;
  vildhet_nn_1_N = mkN "vildhet" ;
  vildhonung_nn_1_N = mkN "vildhonung" ;
  vildsinthet_nn_1_N = mkN "vildsinthet" ;
  vildsvinsjakt_nn_1_N = mkN "vildsvinsjakt" ;
  viljekraft_nn_1_N = mkN "viljekraft" ;
  viljeloeshet_nn_1_1_N = mkN "viljelöshet" ;
  viljemaessighet_nn_1_1_N = mkN "viljemässighet" ;
  viljestarkhet_nn_1_N = mkN "viljestarkhet" ;
  viljesvaghet_nn_1_N = mkN "viljesvaghet" ;
  villighet_nn_1_N = mkN "villighet" ;
  villkorlighet_nn_1_N = mkN "villkorlighet" ;
  villkorsloeshet_nn_1_1_N = mkN "villkorslöshet" ;
  villraadighet_nn_1_1_N = mkN "villrådighet" ;
  villsamhet_nn_1_N = mkN "villsamhet" ;
  vilostad_nn_1_N = mkN "vilostad" ;
  vilsamhet_nn_1_N = mkN "vilsamhet" ;
  viltsmak_nn_1_N = mkN "viltsmak" ;
  viltvaard_nn_1_1_N = mkN "viltvård" ;
  vimmelkantighet_nn_1_N = mkN "vimmelkantighet" ;
  vimsighet_nn_1_N = mkN "vimsighet" ;
  vinbransch_nn_1_N = mkN "vinbransch" ;
  vindhet_nn_1_N = mkN "vindhet" ;
  vindicerbarhet_nn_1_N = mkN "vindicerbarhet" ;
  vindkraft_nn_1_N = mkN "vindkraft" ;
  vindpollinerbarhet_nn_1_N = mkN "vindpollinerbarhet" ;
  vindoegdhet_nn_1_1_N = mkN "vindögdhet" ;
  vingklippning_nn_1_N = mkN "vingklippning" ;
  vinglighet_nn_1_N = mkN "vinglighet" ;
  vingloeshet_nn_1_1_N = mkN "vinglöshet" ;
  vinjaest_nn_1_1_N = mkN "vinjäst" ;
  vinkonsumtion_nn_1_N = mkN "vinkonsumtion" ;
  vinproduktion_nn_1_N = mkN "vinproduktion" ;
  vinstmaximerbarhet_nn_1_N = mkN "vinstmaximerbarhet" ;
  vintercykling_nn_1_N = mkN "vintercykling" ;
  vintergaeck_nn_1_1_N = mkN "vintergäck" ;
  vinterhaerdighet_nn_1_1_N = mkN "vinterhärdighet" ;
  vinterkoeld_nn_1_1_N = mkN "vinterköld" ;
  vinterlighet_nn_1_N = mkN "vinterlighet" ;
  vintersol_nn_1_N = mkN "vintersol" ;
  vintersaed_nn_1_1_N = mkN "vintersäd" ;
  vintersoemn_nn_1_1_N = mkN "vintersömn" ;
  vintertid_nn_1_N = mkN "vintertid" ;
  vintrighet_nn_1_N = mkN "vintrighet" ;
  vinyl_nn_1_N = mkN "vinyl" ;
  vinylglans_nn_1_N = mkN "vinylglans" ;
  vinylklorid_nn_1_N = mkN "vinylklorid" ;
  vinaegrett_nn_1_1_N = mkN "vinägrett" ;
  violdoft_nn_1_N = mkN "violdoft" ;
  vippighet_nn_1_N = mkN "vippighet" ;
  virak_nn_1_N = mkN "virak" ;
  virkesfaangst_nn_1_1_N = mkN "virkesfångst" ;
  virtuosmaessighet_nn_1_1_N = mkN "virtuosmässighet" ;
  virulens_nn_1_N = mkN "virulens" ;
  viserbarhet_nn_1_N = mkN "viserbarhet" ;
  visionsloeshet_nn_1_1_N = mkN "visionslöshet" ;
  visiterbarhet_nn_1_N = mkN "visiterbarhet" ;
  viskos_nn_1_N = mkN "viskos" ;
  vislighet_nn_1_N = mkN "vislighet" ;
  vismut_nn_1_N = mkN "vismut" ;
  vispighet_nn_1_N = mkN "vispighet" ;
  vissnesjuka_nn_1_N = mkN "vissnesjuka" ;
  vissaang_nn_1_1_N = mkN "vissång" ;
  visualiserbarhet_nn_1_N = mkN "visualiserbarhet" ;
  vitaktighet_nn_1_N = mkN "vitaktighet" ;
  vitaliserbarhet_nn_1_N = mkN "vitaliserbarhet" ;
  vitalkraft_nn_1_N = mkN "vitalkraft" ;
  vitaminerbarhet_nn_1_N = mkN "vitaminerbarhet" ;
  vitaminiserbarhet_nn_1_N = mkN "vitaminiserbarhet" ;
  vitaminrikhet_nn_1_N = mkN "vitaminrikhet" ;
  vitaxighet_nn_1_N = mkN "vitaxighet" ;
  vithyllthet_nn_1_N = mkN "vithyllthet" ;
  vithaarighet_nn_1_1_N = mkN "vithårighet" ;
  vitkaal_nn_1_1_N = mkN "vitkål" ;
  vitmaessing_nn_1_1_N = mkN "vitmässing" ;
  vitskaeggighet_nn_1_1_N = mkN "vitskäggighet" ;
  vittberesthet_nn_1_N = mkN "vittberesthet" ;
  vittberoemdhet_nn_1_1_N = mkN "vittberömdhet" ;
  vittnesgillhet_nn_1_N = mkN "vittnesgillhet" ;
  vittvaett_nn_1_1_N = mkN "vittvätt" ;
  vitved_nn_1_N = mkN "vitved" ;
  vivianit_nn_1_N = mkN "vivianit" ;
  vokalbalans_nn_1_N = mkN "vokalbalans" ;
  vokaliserbarhet_nn_1_N = mkN "vokaliserbarhet" ;
  vokalmusik_nn_1_N = mkN "vokalmusik" ;
  volleyboll_nn_1_N = mkN "volleyboll" ;
  volontering_nn_1_N = mkN "volontering" ;
  volymvikt_nn_1_N = mkN "volymvikt" ;
  voyeuristiskhet_nn_1_N = mkN "voyeuristiskhet" ;
  vredhet_nn_1_N = mkN "vredhet" ;
  vrenskhet_nn_1_N = mkN "vrenskhet" ;
  vresved_nn_1_N = mkN "vresved" ;
  vridbarhet_nn_1_N = mkN "vridbarhet" ;
  vridenhet_nn_1_N = mkN "vridenhet" ;
  vraalflotthet_nn_1_1_N = mkN "vrålflotthet" ;
  vraangvishet_nn_1_1_N = mkN "vrångvishet" ;
  vulgariserbarhet_nn_1_N = mkN "vulgariserbarhet" ;
  vulkaniserbarhet_nn_1_N = mkN "vulkaniserbarhet" ;
  vulstighet_nn_1_N = mkN "vulstighet" ;
  vuxenmobbning_nn_1_N = mkN "vuxenmobbning" ;
  vaedd_nn_1_1_N = mkN "vädd" ;
  vaederbestaendighet_nn_1_1_N = mkN "väderbeständighet" ;
  vaederlekstjaenst_nn_1_1_N = mkN "väderlekstjänst" ;
  vaederspaendhet_nn_1_1_N = mkN "väderspändhet" ;
  vaederstinnhet_nn_1_1_N = mkN "väderstinnhet" ;
  vaedertjaenst_nn_1_1_N = mkN "vädertjänst" ;
  vaeft_nn_1_1_N = mkN "väft" ;
  vaegdoed_nn_1_1_N = mkN "vägdöd" ;
  vaeggmonterbarhet_nn_1_1_N = mkN "väggmonterbarhet" ;
  vaegkost_nn_1_1_N = mkN "vägkost" ;
  vaegtrafik_nn_1_1_N = mkN "vägtrafik" ;
  vaegvillhet_nn_1_1_N = mkN "vägvillhet" ;
  vaelavvaegdhet_nn_1_1_N = mkN "välavvägdhet" ;
  vaelbegriplighet_nn_1_1_N = mkN "välbegriplighet" ;
  vaelbehoevlighet_nn_1_1_N = mkN "välbehövlighet" ;
  vaelbestaelldhet_nn_1_1_N = mkN "välbeställdhet" ;
  vaelbesoekthet_nn_1_1_N = mkN "välbesökthet" ;
  vaelbetaldhet_nn_1_1_N = mkN "välbetaldhet" ;
  vaelbetaenkthet_nn_1_1_N = mkN "välbetänkthet" ;
  vaeld_nn_1_1_N = mkN "väld" ;
  vaelfaerd_nn_1_1_N = mkN "välfärd" ;
  vaelfaerdspolitik_nn_1_1_N = mkN "välfärdspolitik" ;
  vaelfoerenlighet_nn_1_1_N = mkN "välförenlighet" ;
  vaelfoerklarlighet_nn_1_1_N = mkN "välförklarlighet" ;
  vaelfoerstaaelighet_nn_1_1_N = mkN "välförståelighet" ;
  vaelfoerstaandighet_nn_1_1_N = mkN "välförståndighet" ;
  vaelfoertjaenthet_nn_1_1_N = mkN "välförtjänthet" ;
  vaelgaang_nn_1_1_N = mkN "välgång" ;
  vaelklaeddhet_nn_1_1_N = mkN "välkläddhet" ;
  vaelkaendhet_nn_1_1_N = mkN "välkändhet" ;
  vaellovlighet_nn_1_1_N = mkN "vällovlighet" ;
  vaellukt_nn_1_1_N = mkN "vällukt" ;
  vaellust_nn_1_1_N = mkN "vällust" ;
  vaellustighet_nn_1_1_N = mkN "vällustighet" ;
  vaelmening_nn_1_1_N = mkN "välmening" ;
  vaelmenthet_nn_1_1_N = mkN "välmenthet" ;
  vaelnaerdhet_nn_1_1_N = mkN "välnärdhet" ;
  vaelskapthet_nn_1_1_N = mkN "välskapthet" ;
  vaelskhet_nn_1_1_N = mkN "välskhet" ;
  vaelskoetthet_nn_1_1_N = mkN "välskötthet" ;
  vaelsmordhet_nn_1_1_N = mkN "välsmordhet" ;
  vaelstaelldhet_nn_1_1_N = mkN "välställdhet" ;
  vaelvdhet_nn_1_1_N = mkN "välvdhet" ;
  vaelvishet_nn_1_1_N = mkN "välvishet" ;
  vaelvaexthet_nn_1_1_N = mkN "välväxthet" ;
  vaendbarhet_nn_1_1_N = mkN "vändbarhet" ;
  vaenfasthet_nn_1_1_N = mkN "vänfasthet" ;
  vaenhet_nn_1_1_N = mkN "vänhet" ;
  vaenlighet_nn_2_1_N = mkN "vänlighet" ;
  vaenskap_nn_1_1_N = mkN "vänskap" ;
  vaensterextremism_nn_1_1_N = mkN "vänsterextremism" ;
  vaensterhaenthet_nn_1_1_N = mkN "vänsterhänthet" ;
  vaensterpolitik_nn_1_1_N = mkN "vänsterpolitik" ;
  vaenstervridning_nn_1_1_N = mkN "vänstervridning" ;
  vaensaellhet_nn_1_1_N = mkN "vänsällhet" ;
  vaerdebestaendighet_nn_1_1_N = mkN "värdebeständighet" ;
  vaerdefasthet_nn_1_1_N = mkN "värdefasthet" ;
  vaerdegemenskap_nn_1_1_N = mkN "värdegemenskap" ;
  vaerdeloeshet_nn_1_1_N = mkN "värdelöshet" ;
  vaerdemaessighet_nn_1_1_N = mkN "värdemässighet" ;
  vaerdepost_nn_1_1_N = mkN "värdepost" ;
  vaerderbarhet_nn_1_1_N = mkN "värderbarhet" ;
  vaerdesaekerhet_nn_1_1_N = mkN "värdesäkerhet" ;
  vaerdhet_nn_1_1_N = mkN "värdhet" ;
  vaerjo_nn_1_1_N = mkN "värjo" ;
  vaerldsbank_nn_1_1_N = mkN "världsbank" ;
  vaerldserfarenhet_nn_1_1_N = mkN "världserfarenhet" ;
  vaerldsfientlighet_nn_1_1_N = mkN "världsfientlighet" ;
  vaerldsfred_nn_1_1_N = mkN "världsfred" ;
  vaerldsfraanvaendhet_nn_1_1_N = mkN "världsfrånvändhet" ;
  vaerldsfoersaeljning_nn_1_1_N = mkN "världsförsäljning" ;
  vaerldsklokhet_nn_1_1_N = mkN "världsklokhet" ;
  vaerldskaendhet_nn_1_1_N = mkN "världskändhet" ;
  vaerldskaennedom_nn_1_1_N = mkN "världskännedom" ;
  vaerldslitteratur_nn_1_1_N = mkN "världslitteratur" ;
  vaerldsnaturfond_nn_1_1_N = mkN "världsnaturfond" ;
  vaerldspolitik_nn_1_1_N = mkN "världspolitik" ;
  vaerldspress_nn_1_1_N = mkN "världspress" ;
  vaerldssjael_nn_1_1_N = mkN "världssjäl" ;
  vaerldsvishet_nn_1_1_N = mkN "världsvishet" ;
  vaermebestaendighet_nn_1_1_N = mkN "värmebeständighet" ;
  vaermeeffekt_nn_1_1_N = mkN "värmeeffekt" ;
  vaermeekvivalent_nn_1_1_N = mkN "värmeekvivalent" ;
  vaermefotograferbarhet_nn_1_1_N = mkN "värmefotograferbarhet" ;
  vaermegenomgaang_nn_1_1_N = mkN "värmegenomgång" ;
  vaermeisolerbarhet_nn_1_1_N = mkN "värmeisolerbarhet" ;
  vaermesteriliserbarhet_nn_1_1_N = mkN "värmesteriliserbarhet" ;
  vaermetaalighet_nn_1_1_N = mkN "värmetålighet" ;
  vaernkraft_nn_1_1_N = mkN "värnkraft" ;
  vaernloeshet_nn_1_1_N = mkN "värnlöshet" ;
  vaernplikt_nn_1_1_N = mkN "värnplikt" ;
  vaernpliktstid_nn_1_1_N = mkN "värnpliktstid" ;
  vaerpsjuka_nn_1_1_N = mkN "värpsjuka" ;
  vaerpsjukhet_nn_1_1_N = mkN "värpsjukhet" ;
  vaest_nn_2_1_N = mkN "väst" ;
  vaestanvind_nn_1_1_N = mkN "västanvind" ;
  vaestvinddrift_nn_1_1_N = mkN "västvinddrift" ;
  vaestvaerld_nn_1_1_N = mkN "västvärld" ;
  vaetekraft_nn_1_1_N = mkN "vätekraft" ;
  vaeteperoxid_nn_1_1_N = mkN "väteperoxid" ;
  vaetesulfid_nn_1_1_N = mkN "vätesulfid" ;
  vaetesuperoxid_nn_1_1_N = mkN "vätesuperoxid" ;
  vaetgas_nn_1_1_N = mkN "vätgas" ;
  vaetgasdrift_nn_1_1_N = mkN "vätgasdrift" ;
  vaetgasrikhet_nn_1_1_N = mkN "vätgasrikhet" ;
  vaetskebalans_nn_1_1_N = mkN "vätskebalans" ;
  vaetskebrist_nn_1_1_N = mkN "vätskebrist" ;
  vaetskeform_nn_1_1_N = mkN "vätskeform" ;
  vaetskekultur_nn_1_1_N = mkN "vätskekultur" ;
  vaetskighet_nn_1_1_N = mkN "vätskighet" ;
  vaexkraft_nn_1_1_N = mkN "växkraft" ;
  vaexlingsrikhet_nn_1_1_N = mkN "växlingsrikhet" ;
  vaexthuseffekt_nn_1_1_N = mkN "växthuseffekt" ;
  vaextkraft_nn_1_1_N = mkN "växtkraft" ;
  vaextkraftighet_nn_1_1_N = mkN "växtkraftighet" ;
  vaextvaerk_nn_1_1_N = mkN "växtvärk" ;
  vaexvaerk_nn_1_1_N = mkN "växvärk" ;
  vaadlighet_nn_1_1_N = mkN "vådlighet" ;
  vaaffeldag_nn_1_1_N = mkN "våffeldag" ;
  vaagformighet_nn_1_1_N = mkN "vågformighet" ;
  vaagighet_nn_1_1_N = mkN "vågighet" ;
  vaagkraft_nn_1_1_N = mkN "vågkraft" ;
  vaagmekanik_nn_1_1_N = mkN "vågmekanik" ;
  vaagmaestarpolitik_nn_1_1_N = mkN "vågmästarpolitik" ;
  vaagraethet_nn_1_1_N = mkN "vågräthet" ;
  vaagsamhet_nn_1_1_N = mkN "vågsamhet" ;
  vaaldsutsatthet_nn_1_1_N = mkN "våldsutsatthet" ;
  vaapighet_nn_1_1_N = mkN "våpighet" ;
  vaarbrodd_nn_1_1_N = mkN "vårbrodd" ;
  vaard_nn_1_1_N = mkN "vård" ;
  vaardagjaemningspunkt_nn_1_1_N = mkN "vårdagjämningspunkt" ;
  vaardsamhet_nn_1_1_N = mkN "vårdsamhet" ;
  vaarflod_nn_1_1_N = mkN "vårflod" ;
  vaarfrost_nn_1_1_N = mkN "vårfrost" ;
  vaarfrudag_nn_1_1_N = mkN "vårfrudag" ;
  vaarluft_nn_1_1_N = mkN "vårluft" ;
  vaarsaed_nn_1_1_N = mkN "vårsäd" ;
  vaartighet_nn_1_1_N = mkN "vårtighet" ;
  vaathet_nn_1_1_N = mkN "våthet" ;
  vaatstarkhet_nn_1_1_N = mkN "våtstarkhet" ;
  vaatvarmhet_nn_1_1_N = mkN "våtvarmhet" ;
  voerdighet_nn_1_1_N = mkN "vördighet" ;
  voerdnadsfullhet_nn_1_1_N = mkN "vördnadsfullhet" ;
  voerdnadsvaerdhet_nn_1_1_N = mkN "vördnadsvärdhet" ;
  voerdsamhet_nn_1_1_N = mkN "vördsamhet" ;
  voert_nn_1_1_N = mkN "vört" ;
  wajang_nn_1_N = mkN "wajang" ;
  waldorfpedagogik_nn_1_N = mkN "waldorfpedagogik" ;
  wallraffning_nn_1_N = mkN "wallraffning" ;
  web_nn_1_N = mkN "web" ;
  webb_nn_1_N = mkN "webb" ;
  webbsupport_nn_1_N = mkN "webbsupport" ;
  webbtelevision_nn_1_N = mkN "webbtelevision" ;
  webbteve_nn_1_N = mkN "webbteve" ;
  wellpapp_nn_1_N = mkN "wellpapp" ;
  weltervikt_nn_1_N = mkN "weltervikt" ;
  weltschmerz_nn_1_N = mkN "weltschmerz" ;
  whist_nn_1_N = mkN "whist" ;
  ymnighet_nn_1_N = mkN "ymnighet" ;
  ympningsplikt_nn_1_N = mkN "ympningsplikt" ;
  ynkansvaerdhet_nn_1_1_N = mkN "ynkansvärdhet" ;
  ynklighet_nn_1_N = mkN "ynklighet" ;
  ynnest_nn_1_N = mkN "ynnest" ;
  yoghurt_nn_1_N = mkN "yoghurt" ;
  yppighet_nn_1_N = mkN "yppighet" ;
  yrhet_nn_1_N = mkN "yrhet" ;
  yrkesmaessighet_nn_1_1_N = mkN "yrkesmässighet" ;
  yrkesskicklighet_nn_1_N = mkN "yrkesskicklighet" ;
  yrkestrafik_nn_1_N = mkN "yrkestrafik" ;
  yrkesverksamhet_nn_1_N = mkN "yrkesverksamhet" ;
  yrvakenhet_nn_1_N = mkN "yrvakenhet" ;
  ysterhet_nn_1_N = mkN "ysterhet" ;
  yteld_nn_1_N = mkN "yteld" ;
  ytterhud_nn_1_N = mkN "ytterhud" ;
  yttranderaett_nn_1_1_N = mkN "yttranderätt" ;
  ytved_nn_1_N = mkN "ytved" ;
  yvighet_nn_1_N = mkN "yvighet" ;
  yxlaegg_nn_1_1_N = mkN "yxlägg" ;
  zenit_nn_1_N = mkN "zenit" ;
  zeolit_nn_1_N = mkN "zeolit" ;
  zigenarmusik_nn_1_N = mkN "zigenarmusik" ;
  zink_nn_1_N = mkN "zink" ;
  zinkspat_nn_1_N = mkN "zinkspat" ;
  zodiak_nn_1_N = mkN "zodiak" ;
  zontid_nn_1_N = mkN "zontid" ;
  zoom_nn_1_N = mkN "zoom" ;
  aedelfisk_nn_1_1_N = mkN "ädelfisk" ;
  aedelhet_nn_1_1_N = mkN "ädelhet" ;
  aedelkorall_nn_1_1_N = mkN "ädelkorall" ;
  aedelmodighet_nn_1_1_N = mkN "ädelmodighet" ;
  aedelaerg_nn_1_1_N = mkN "ädelärg" ;
  aeganderaett_nn_1_1_N = mkN "äganderätt" ;
  aeggfaerg_nn_1_1_N = mkN "äggfärg" ;
  aegglaeggning_nn_1_1_N = mkN "äggläggning" ;
  aeggsjukhet_nn_1_1_N = mkN "äggsjukhet" ;
  aegofred_nn_1_1_N = mkN "ägofred" ;
  aektenskaplighet_nn_1_1_N = mkN "äktenskaplighet" ;
  aeldreomsorg_nn_1_1_N = mkN "äldreomsorg" ;
  aeldrevaard_nn_1_1_N = mkN "äldrevård" ;
  aelghud_nn_1_1_N = mkN "älghud" ;
  aelskog_nn_1_1_N = mkN "älskog" ;
  aelskogskrankhet_nn_1_1_N = mkN "älskogskrankhet" ;
  aelvaexing_nn_1_1_N = mkN "älväxing" ;
  aemnesintegrerbarhet_nn_1_1_N = mkN "ämnesintegrerbarhet" ;
  aemnesmetodik_nn_1_1_N = mkN "ämnesmetodik" ;
  aendalykt_nn_1_1_N = mkN "ändalykt" ;
  aendamaalsloeshet_nn_1_1_N = mkN "ändamålslöshet" ;
  aendlighet_nn_1_1_N = mkN "ändlighet" ;
  aendloeshet_nn_1_1_N = mkN "ändlöshet" ;
  aenglalikhet_nn_1_1_N = mkN "änglalikhet" ;
  aenglamat_nn_1_1_N = mkN "änglamat" ;
  aenglavakt_nn_1_1_N = mkN "änglavakt" ;
  aengsboll_nn_1_1_N = mkN "ängsboll" ;
  aengslighet_nn_1_1_N = mkN "ängslighet" ;
  aengsull_nn_1_1_N = mkN "ängsull" ;
  aeppelpraektighet_nn_1_1_N = mkN "äppelpräktighet" ;
  aeppelskorv_nn_1_1_N = mkN "äppelskorv" ;
  aeppleskorv_nn_1_1_N = mkN "äppleskorv" ;
  aerbarhet_nn_1_1_N = mkN "ärbarhet" ;
  aerefoergaetenhet_nn_1_1_N = mkN "äreförgätenhet" ;
  aeregirighet_nn_1_1_N = mkN "äregirighet" ;
  aereloeshet_nn_1_1_N = mkN "ärelöshet" ;
  aerenpris_nn_1_1_N = mkN "ärenpris" ;
  aerevoerdighet_nn_1_1_N = mkN "ärevördighet" ;
  aerftlighetsforskning_nn_1_1_N = mkN "ärftlighetsforskning" ;
  aerg_nn_1_1_N = mkN "ärg" ;
  aergighet_nn_1_1_N = mkN "ärgighet" ;
  aering_nn_1_1_N = mkN "äring" ;
  aermloeshet_nn_1_1_N = mkN "ärmlöshet" ;
  aerofullhet_nn_1_1_N = mkN "ärofullhet" ;
  aerofylldhet_nn_1_1_N = mkN "ärofylldhet" ;
  aerorikhet_nn_1_1_N = mkN "ärorikhet" ;
  aerrighet_nn_1_1_N = mkN "ärrighet" ;
  aertighet_nn_1_1_N = mkN "ärtighet" ;
  aervdabalk_nn_1_1_N = mkN "ärvdabalk" ;
  aetbarhet_nn_1_1_N = mkN "ätbarhet" ;
  aettiksprit_nn_1_1_N = mkN "ättiksprit" ;
  aaboraett_nn_1_1_N = mkN "åborätt" ;
  aabrodd_nn_1_1_N = mkN "åbrodd" ;
  aabaekighet_nn_1_1_N = mkN "åbäkighet" ;
  aabaeklighet_nn_1_1_N = mkN "åbäklighet" ;
  aadrighet_nn_1_1_N = mkN "ådrighet" ;
  aagren_nn_1_1_N = mkN "ågren" ;
  aakersenap_nn_1_1_N = mkN "åkersenap" ;
  aaksjuka_nn_1_1_N = mkN "åksjuka" ;
  aaksjukhet_nn_1_1_N = mkN "åksjukhet" ;
  aalderssvaghet_nn_1_1_N = mkN "ålderssvaghet" ;
  aalderstyngdhet_nn_1_1_N = mkN "ålderstyngdhet" ;
  aaldrighet_nn_1_1_N = mkN "åldrighet" ;
  aaldringsvaard_nn_1_1_N = mkN "åldringsvård" ;
  aangdrift_nn_1_1_N = mkN "ångdrift" ;
  aangerfrist_nn_1_1_N = mkN "ångerfrist" ;
  aangerfullhet_nn_1_1_N = mkN "ångerfullhet" ;
  aangerkoepthet_nn_1_1_N = mkN "ångerköpthet" ;
  aangest_nn_1_1_N = mkN "ångest" ;
  aangestfullhet_nn_1_1_N = mkN "ångestfullhet" ;
  aangestfylldhet_nn_1_1_N = mkN "ångestfylldhet" ;
  aangestsvett_nn_1_1_N = mkN "ångestsvett" ;
  aangkraft_nn_1_1_N = mkN "ångkraft" ;
  aarbraeckthet_nn_1_1_N = mkN "årbräckthet" ;
  aarsgaang_nn_1_1_N = mkN "årsgång" ;
  aarsmoraen_nn_1_1_N = mkN "årsmorän" ;
  aarsvaext_nn_1_1_N = mkN "årsväxt" ;
  aasiktsgemenskap_nn_1_1_N = mkN "åsiktsgemenskap" ;
  aasiktsmaessighet_nn_1_1_N = mkN "åsiktsmässighet" ;
  aasiktsregistrerbarhet_nn_1_1_N = mkN "åsiktsregistrerbarhet" ;
  aasklikhet_nn_1_1_N = mkN "åsklikhet" ;
  aasnemjoelk_nn_1_1_N = mkN "åsnemjölk" ;
  aasyn_nn_1_1_N = mkN "åsyn" ;
  aatalbarhet_nn_1_1_N = mkN "åtalbarhet" ;
  aatalseftergift_nn_1_1_N = mkN "åtalseftergift" ;
  aatalsraett_nn_1_1_N = mkN "åtalsrätt" ;
  aateljakt_nn_1_1_N = mkN "åteljakt" ;
  aaterbetalningsraett_nn_1_1_N = mkN "återbetalningsrätt" ;
  aaterbetalningstakt_nn_1_1_N = mkN "återbetalningstakt" ;
  aaterglans_nn_1_1_N = mkN "återglans" ;
  aatergaang_nn_1_1_N = mkN "återgång" ;
  aatergaangstull_nn_1_1_N = mkN "återgångstull" ;
  aaterinstallerbarhet_nn_1_1_N = mkN "återinstallerbarhet" ;
  aaterklang_nn_1_1_N = mkN "återklang" ;
  aaterkomst_nn_1_1_N = mkN "återkomst" ;
  aaterkoepsraett_nn_1_1_N = mkN "återköpsrätt" ;
  aatervandring_nn_1_1_N = mkN "återvandring" ;
  aatervaeg_nn_1_1_N = mkN "återväg" ;
  aatervaext_nn_1_1_N = mkN "återväxt" ;
  aatgaang_nn_1_1_N = mkN "åtgång" ;
  aatkomlighet_nn_1_1_N = mkN "åtkomlighet" ;
  aatkomst_nn_1_1_N = mkN "åtkomst" ;
  aatraavaerdhet_nn_1_1_N = mkN "åtråvärdhet" ;
  aatskillnadsloeshet_nn_1_1_N = mkN "åtskillnadslöshet" ;
  aattkantighet_nn_1_1_N = mkN "åttkantighet" ;
  _elan_nn_1_1_N = mkN "élan" ;
  oedesbestaemdhet_nn_1_1_N = mkN "ödesbestämdhet" ;
  oedesdigerhet_nn_1_1_N = mkN "ödesdigerhet" ;
  oedesgemenskap_nn_1_1_N = mkN "ödesgemenskap" ;
  oegonblicklighet_nn_1_1_N = mkN "ögonblicklighet" ;
  oegondiagnostik_nn_1_1_N = mkN "ögondiagnostik" ;
  oegonskenlighet_nn_1_1_N = mkN "ögonskenlighet" ;
  oegontroest_nn_1_1_N = mkN "ögontröst" ;
  oekensand_nn_1_1_N = mkN "ökensand" ;
  oekaendhet_nn_1_1_N = mkN "ökändhet" ;
  oelandstok_nn_1_1_N = mkN "ölandstok" ;
  oeldrickning_nn_1_1_N = mkN "öldrickning" ;
  oelost_nn_1_1_N = mkN "ölost" ;
  oemhet_nn_2_1_N = mkN "ömhet" ;
  oemkansvaerdhet_nn_1_1_N = mkN "ömkansvärdhet" ;
  oemsesidighet_nn_1_1_N = mkN "ömsesidighet" ;
  oemsinthet_nn_1_1_N = mkN "ömsinthet" ;
  oensklighet_nn_1_1_N = mkN "önsklighet" ;
  oenskvaerdhet_nn_1_1_N = mkN "önskvärdhet" ;
  oeppenhjaertighet_nn_1_1_N = mkN "öppenhjärtighet" ;
  oeppenhjaertlighet_nn_1_1_N = mkN "öppenhjärtlighet" ;
  oeppenvaard_nn_1_1_N = mkN "öppenvård" ;
  oer_nn_1_1_N = mkN "ör" ;
  oerlogsflagg_nn_1_1_N = mkN "örlogsflagg" ;
  oernkoll_nn_1_1_N = mkN "örnkoll" ;
  oerraag_nn_1_1_N = mkN "örråg" ;
  oest_nn_1_1_N = mkN "öst" ;
  oestanvind_nn_1_1_N = mkN "östanvind" ;
  oestergoek_nn_1_1_N = mkN "östergök" ;
  oeveraktivitet_nn_1_1_N = mkN "överaktivitet" ;
  oeverbetoning_nn_1_1_N = mkN "överbetoning" ;
  oeverbevisning_nn_1_1_N = mkN "överbevisning" ;
  oeverblickbarhet_nn_1_1_N = mkN "överblickbarhet" ;
  oeverbudspolitik_nn_1_1_N = mkN "överbudspolitik" ;
  oeverdiagnostik_nn_1_1_N = mkN "överdiagnostik" ;
  oeverdimensionerbarhet_nn_1_1_N = mkN "överdimensionerbarhet" ;
  oeverdoserbarhet_nn_1_1_N = mkN "överdoserbarhet" ;
  oeverdaadighet_nn_1_1_N = mkN "överdådighet" ;
  oeverexponerbarhet_nn_1_1_N = mkN "överexponerbarhet" ;
  oeverfiskning_nn_1_1_N = mkN "överfiskning" ;
  oeverfloedighet_nn_1_1_N = mkN "överflödighet" ;
  oeverfullhet_nn_1_1_N = mkN "överfullhet" ;
  oeverfylldhet_nn_1_1_N = mkN "överfylldhet" ;
  oeverfoertjusthet_nn_1_1_N = mkN "överförtjusthet" ;
  oevergivenhet_nn_1_1_N = mkN "övergivenhet" ;
  oevergaangsstat_nn_1_1_N = mkN "övergångsstat" ;
  oeverhand_nn_1_1_N = mkN "överhand" ;
  oeverhetlighet_nn_1_1_N = mkN "överhetlighet" ;
  oeverhud_nn_1_1_N = mkN "överhud" ;
  oeverhaerdighet_nn_1_1_N = mkN "överhärdighet" ;
  oeverjordiskhet_nn_1_1_N = mkN "överjordiskhet" ;
  oeverklassighet_nn_1_1_N = mkN "överklassighet" ;
  oeverkomlighet_nn_1_1_N = mkN "överkomlighet" ;
  oeverkompenserbarhet_nn_1_1_N = mkN "överkompenserbarhet" ;
  oeverlackerbarhet_nn_1_1_N = mkN "överlackerbarhet" ;
  oeverlackeringsbarhet_nn_1_1_N = mkN "överlackeringsbarhet" ;
  oeverladdning_nn_1_1_N = mkN "överladdning" ;
  oeverlagdhet_nn_1_1_N = mkN "överlagdhet" ;
  oeverlastning_nn_1_1_N = mkN "överlastning" ;
  oeverlevnadsdrift_nn_1_1_N = mkN "överlevnadsdrift" ;
  oeverlevnadsaangest_nn_1_1_N = mkN "överlevnadsångest" ;
  oeverlycklighet_nn_1_1_N = mkN "överlycklighet" ;
  oevermakt_nn_1_1_N = mkN "övermakt" ;
  oevermodighet_nn_1_1_N = mkN "övermodighet" ;
  oevermognad_nn_1_1_N = mkN "övermognad" ;
  oevermaektighet_nn_1_1_N = mkN "övermäktighet" ;
  oevermaensklighet_nn_1_1_N = mkN "övermänsklighet" ;
  oevermaetthet_nn_1_1_N = mkN "övermätthet" ;
  oevermaettnad_nn_1_1_N = mkN "övermättnad" ;
  oevermaalningsbarhet_nn_1_1_N = mkN "övermålningsbarhet" ;
  oeversiktlighet_nn_1_1_N = mkN "översiktlighet" ;
  oeversinnlighet_nn_1_1_N = mkN "översinnlighet" ;
  oeverskaadlighet_nn_1_1_N = mkN "överskådlighet" ;
  oeverskoeljningssaekerhet_nn_1_1_N = mkN "översköljningssäkerhet" ;
  oeverstiglighet_nn_1_1_N = mkN "överstiglighet" ;
  oeverstyrdhet_nn_1_1_N = mkN "överstyrdhet" ;
  oeversvinnelighet_nn_1_1_N = mkN "översvinnelighet" ;
  oeversvinnlighet_nn_1_1_N = mkN "översvinnlighet" ;
  oeversynthet_nn_1_1_N = mkN "översynthet" ;
  oeversaettningskvalitet_nn_1_1_N = mkN "översättningskvalitet" ;
  oevertalighet_nn_1_1_N = mkN "övertalighet" ;
  oevertid_nn_1_1_N = mkN "övertid" ;
  oevertrasserbarhet_nn_1_1_N = mkN "övertrasserbarhet" ;
  oevertaenkthet_nn_1_1_N = mkN "övertänkthet" ;
  oevervikt_nn_1_1_N = mkN "övervikt" ;
  oeverviktighet_nn_1_1_N = mkN "överviktighet" ;
  oevervaerderbarhet_nn_1_1_N = mkN "övervärderbarhet" ;
  oevervaext_nn_1_1_N = mkN "överväxt" ;
  oeveraarighet_nn_1_1_N = mkN "överårighet" ;
  oeveroesning_nn_1_1_N = mkN "överösning" ;
  oevlighet_nn_1_1_N = mkN "övlighet" ;
  aktsam_av_1_A = mkA "aktsam" "aktsamt" "aktsamma" "aktsamma" "aktsammare" "aktsammast" "aktsammaste" ;
  allmaen_av_1_1_A = mkA "allmän" "allmänt" "allmänna" "allmänna" "allmännare" "allmännast" "allmännaste" ;
  allvarsam_av_1_A = mkA "allvarsam" "allvarsamt" "allvarsamma" "allvarsamma" "allvarsammare" "allvarsammast" "allvarsammaste" ;
  ankommen_av_1_A = mkA "ankommen" "ankommet" "ankomna" "ankomna" "ankomnare" "ankomnast" "ankomnaste" ;
  arbetsam_av_1_A = mkA "arbetsam" "arbetsamt" "arbetsamma" "arbetsamma" "arbetsammare" "arbetsammast" "arbetsammaste" ;
  avhaallsam_av_1_1_A = mkA "avhållsam" "avhållsamt" "avhållsamma" "avhållsamma" "avhållsammare" "avhållsammast" "avhållsammaste" ;
  avsigkommen_av_1_A = mkA "avsigkommen" "avsigkommet" "avsigkomna" "avsigkomna" "avsigkomnare" "avsigkomnast" "avsigkomnaste" ;
  avundsam_av_1_A = mkA "avundsam" "avundsamt" "avundsamma" "avundsamma" "avundsammare" "avundsammast" "avundsammaste" ;
  bekymmersam_av_1_A = mkA "bekymmersam" "bekymmersamt" "bekymmersamma" "bekymmersamma" "bekymmersammare" "bekymmersammast" "bekymmersammaste" ;
  beslutsam_av_1_A = mkA "beslutsam" "beslutsamt" "beslutsamma" "beslutsamma" "beslutsammare" "beslutsammast" "beslutsammaste" ;
  bestaellsam_av_1_1_A = mkA "beställsam" "beställsamt" "beställsamma" "beställsamma" "beställsammare" "beställsammast" "beställsammaste" ;
  betaenksam_av_1_1_A = mkA "betänksam" "betänksamt" "betänksamma" "betänksamma" "betänksammare" "betänksammast" "betänksammaste" ;
  blygsam_av_1_A = mkA "blygsam" "blygsamt" "blygsamma" "blygsamma" "blygsammare" "blygsammast" "blygsammaste" ;
  bortkommen_av_1_A = mkA "bortkommen" "bortkommet" "bortkomna" "bortkomna" "bortkomnare" "bortkomnast" "bortkomnaste" ;
  brydsam_av_1_A = mkA "brydsam" "brydsamt" "brydsamma" "brydsamma" "brydsammare" "brydsammast" "brydsammaste" ;
  bullersam_av_1_A = mkA "bullersam" "bullersamt" "bullersamma" "bullersamma" "bullersammare" "bullersammast" "bullersammaste" ;
  dum_av_1_A = mkA "dum" "dumt" "dumma" "dumma" "dummare" "dummast" "dummaste" ;
  doevstum_av_1_1_A = mkA "dövstum" "dövstumt" "dövstumma" "dövstumma" "dövstummare" "dövstummast" "dövstummaste" ;
  eftertaenksam_av_1_1_A = mkA "eftertänksam" "eftertänksamt" "eftertänksamma" "eftertänksamma" "eftertänksammare" "eftertänksammast" "eftertänksammaste" ;
  ensam_av_1_A = mkA "ensam" "ensamt" "ensamma" "ensamma" "ensammare" "ensammast" "ensammaste" ;
  erkaennsam_av_1_1_A = mkA "erkännsam" "erkännsamt" "erkännsamma" "erkännsamma" "erkännsammare" "erkännsammast" "erkännsammaste" ;
  finspunnen_av_1_A = mkA "finspunnen" "finspunnet" "finspunna" "finspunna" "finspunnare" "finspunnast" "finspunnaste" ;
  fisktom_av_1_A = mkA "fisktom" "fisktomt" "fisktomma" "fisktomma" "fisktommare" "fisktommast" "fisktommaste" ;
  folktom_av_1_A = mkA "folktom" "folktomt" "folktomma" "folktomma" "folktommare" "folktommast" "folktommaste" ;
  fridsam_av_1_A = mkA "fridsam" "fridsamt" "fridsamma" "fridsamma" "fridsammare" "fridsammast" "fridsammaste" ;
  from_av_1_A = mkA "from" "fromt" "fromma" "fromma" "frommare" "frommast" "frommaste" ;
  fruktsam_av_1_A = mkA "fruktsam" "fruktsamt" "fruktsamma" "fruktsamma" "fruktsammare" "fruktsammast" "fruktsammaste" ;
  fundersam_av_1_A = mkA "fundersam" "fundersamt" "fundersamma" "fundersamma" "fundersammare" "fundersammast" "fundersammaste" ;
  faegnesam_av_1_1_A = mkA "fägnesam" "fägnesamt" "fägnesamma" "fägnesamma" "fägnesammare" "fägnesammast" "fägnesammaste" ;
  faageltom_av_1_1_A = mkA "fågeltom" "fågeltomt" "fågeltomma" "fågeltomma" "fågeltommare" "fågeltommast" "fågeltommaste" ;
  foeljsam_av_1_1_A = mkA "följsam" "följsamt" "följsamma" "följsamma" "följsammare" "följsammast" "följsammaste" ;
  foerbehaallsam_av_1_1_A = mkA "förbehållsam" "förbehållsamt" "förbehållsamma" "förbehållsamma" "förbehållsammare" "förbehållsammast" "förbehållsammaste" ;
  foerdragsam_av_1_1_A = mkA "fördragsam" "fördragsamt" "fördragsamma" "fördragsamma" "fördragsammare" "fördragsammast" "fördragsammaste" ;
  foeretagsam_av_1_1_A = mkA "företagsam" "företagsamt" "företagsamma" "företagsamma" "företagsammare" "företagsammast" "företagsammaste" ;
  foerkommen_av_1_1_A = mkA "förkommen" "förkommet" "förkomna" "förkomna" "förkomnare" "förkomnast" "förkomnaste" ;
  foernoejsam_av_1_1_A = mkA "förnöjsam" "förnöjsamt" "förnöjsamma" "förnöjsamma" "förnöjsammare" "förnöjsammast" "förnöjsammaste" ;
  foersigkommen_av_1_1_A = mkA "försigkommen" "försigkommet" "försigkomna" "försigkomna" "försigkomnare" "försigkomnast" "försigkomnaste" ;
  foertrytsam_av_1_1_A = mkA "förtrytsam" "förtrytsamt" "förtrytsamma" "förtrytsamma" "förtrytsammare" "förtrytsammast" "förtrytsammaste" ;
  foertaenksam_av_1_1_A = mkA "förtänksam" "förtänksamt" "förtänksamma" "förtänksamma" "förtänksammare" "förtänksammast" "förtänksammaste" ;
  foervunnen_av_1_1_A = mkA "förvunnen" "förvunnet" "förvunna" "förvunna" "förvunnare" "förvunnast" "förvunnaste" ;
  gemensam_av_1_A = mkA "gemensam" "gemensamt" "gemensamma" "gemensamma" "gemensammare" "gemensammast" "gemensammaste" ;
  genomdum_av_1_A = mkA "genomdum" "genomdumt" "genomdumma" "genomdumma" "genomdummare" "genomdummast" "genomdummaste" ;
  gruvsam_av_1_A = mkA "gruvsam" "gruvsamt" "gruvsamma" "gruvsamma" "gruvsammare" "gruvsammast" "gruvsammaste" ;
  grym_av_1_A = mkA "grym" "grymt" "grymma" "grymma" "grymmare" "grymmast" "grymmaste" ;
  gynnsam_av_1_A = mkA "gynnsam" "gynnsamt" "gynnsamma" "gynnsamma" "gynnsammare" "gynnsammast" "gynnsammaste" ;
  gaecksam_av_1_1_A = mkA "gäcksam" "gäcksamt" "gäcksamma" "gäcksamma" "gäcksammare" "gäcksammast" "gäcksammaste" ;
  hedersam_av_1_A = mkA "hedersam" "hedersamt" "hedersamma" "hedersamma" "hedersammare" "hedersammast" "hedersammaste" ;
  hindersam_av_1_A = mkA "hindersam" "hindersamt" "hindersamma" "hindersamma" "hindersammare" "hindersammast" "hindersammaste" ;
  hjaelpsam_av_1_1_A = mkA "hjälpsam" "hjälpsamt" "hjälpsamma" "hjälpsamma" "hjälpsammare" "hjälpsammast" "hjälpsammaste" ;
  hopkommen_av_1_A = mkA "hopkommen" "hopkommet" "hopkomna" "hopkomna" "hopkomnare" "hopkomnast" "hopkomnaste" ;
  hovsam_av_1_A = mkA "hovsam" "hovsamt" "hovsamma" "hovsamma" "hovsammare" "hovsammast" "hovsammaste" ;
  hugnesam_av_1_A = mkA "hugnesam" "hugnesamt" "hugnesamma" "hugnesamma" "hugnesammare" "hugnesammast" "hugnesammaste" ;
  haelsosam_av_1_1_A = mkA "hälsosam" "hälsosamt" "hälsosamma" "hälsosamma" "hälsosammare" "hälsosammast" "hälsosammaste" ;
  haevdvunnen_av_1_1_A = mkA "hävdvunnen" "hävdvunnet" "hävdvunna" "hävdvunna" "hävdvunnare" "hävdvunnast" "hävdvunnaste" ;
  hoersam_av_1_1_A = mkA "hörsam" "hörsamt" "hörsamma" "hörsamma" "hörsammare" "hörsammast" "hörsammaste" ;
  innehaallstom_av_1_1_A = mkA "innehållstom" "innehållstomt" "innehållstomma" "innehållstomma" "innehållstommare" "innehållstommast" "innehållstommaste" ;
  instaellsam_av_1_1_A = mkA "inställsam" "inställsamt" "inställsamma" "inställsamma" "inställsammare" "inställsammast" "inställsammaste" ;
  jaettedum_av_1_1_A = mkA "jättedum" "jättedumt" "jättedumma" "jättedumma" "jättedummare" "jättedummast" "jättedummaste" ;
  klaedsam_av_1_1_A = mkA "klädsam" "klädsamt" "klädsamma" "klädsamma" "klädsammare" "klädsammast" "klädsammaste" ;
  kostsam_av_1_A = mkA "kostsam" "kostsamt" "kostsamma" "kostsamma" "kostsammare" "kostsammast" "kostsammaste" ;
  kraftvunnen_av_1_A = mkA "kraftvunnen" "kraftvunnet" "kraftvunna" "kraftvunna" "kraftvunnare" "kraftvunnast" "kraftvunnaste" ;
  krum_av_1_A = mkA "krum" "krumt" "krumma" "krumma" "krummare" "krummast" "krummaste" ;
  kyrksam_av_1_A = mkA "kyrksam" "kyrksamt" "kyrksamma" "kyrksamma" "kyrksammare" "kyrksammast" "kyrksammaste" ;
  kaenslosam_av_1_1_A = mkA "känslosam" "känslosamt" "känslosamma" "känslosamma" "känslosammare" "känslosammast" "känslosammaste" ;
  kaerkommen_av_1_1_A = mkA "kärkommen" "kärkommet" "kärkomna" "kärkomna" "kärkomnare" "kärkomnast" "kärkomnaste" ;
  lagvunnen_av_1_A = mkA "lagvunnen" "lagvunnet" "lagvunna" "lagvunna" "lagvunnare" "lagvunnast" "lagvunnaste" ;
  ledsam_av_1_A = mkA "ledsam" "ledsamt" "ledsamma" "ledsamma" "ledsammare" "ledsammast" "ledsammaste" ;
  legendomspunnen_av_1_A = mkA "legendomspunnen" "legendomspunnet" "legendomspunna" "legendomspunna" "legendomspunnare" "legendomspunnast" "legendomspunnaste" ;
  liten_av_1_A = mkA "liten" "litet" "lilla" "små" "mindre" "minst" "minsta" ;
  ljum_av_1_A = mkA "ljum" "ljumt" "ljumma" "ljumma" "ljummare" "ljummast" "ljummaste" ;
  ljummen_av_1_A = mkA "ljummen" "ljummet" "ljumna" "ljumna" "ljumnare" "ljumnast" "ljumnaste" ;
  lufttom_av_1_A = mkA "lufttom" "lufttomt" "lufttomma" "lufttomma" "lufttommare" "lufttommast" "lufttommaste" ;
  lyckosam_av_1_A = mkA "lyckosam" "lyckosamt" "lyckosamma" "lyckosamma" "lyckosammare" "lyckosammast" "lyckosammaste" ;
  laettfunnen_av_1_1_A = mkA "lättfunnen" "lättfunnet" "lättfunna" "lättfunna" "lättfunnare" "lättfunnast" "lättfunnaste" ;
  laettsam_av_1_1_A = mkA "lättsam" "lättsamt" "lättsamma" "lättsamma" "lättsammare" "lättsammast" "lättsammaste" ;
  laettvunnen_av_1_1_A = mkA "lättvunnen" "lättvunnet" "lättvunna" "lättvunna" "lättvunnare" "lättvunnast" "lättvunnaste" ;
  laangsam_av_1_1_A = mkA "långsam" "långsamt" "långsamma" "långsamma" "långsammare" "långsammast" "långsammaste" ;
  loensam_av_1_1_A = mkA "lönsam" "lönsamt" "lönsamma" "lönsamma" "lönsammare" "lönsammast" "lönsammaste" ;
  meddelsam_av_1_A = mkA "meddelsam" "meddelsamt" "meddelsamma" "meddelsamma" "meddelsammare" "meddelsammast" "meddelsammaste" ;
  medlidsam_av_1_A = mkA "medlidsam" "medlidsamt" "medlidsamma" "medlidsamma" "medlidsammare" "medlidsammast" "medlidsammaste" ;
  missgynnsam_av_1_A = mkA "missgynnsam" "missgynnsamt" "missgynnsamma" "missgynnsamma" "missgynnsammare" "missgynnsammast" "missgynnsammaste" ;
  missklaedsam_av_1_1_A = mkA "missklädsam" "missklädsamt" "missklädsamma" "missklädsamma" "missklädsammare" "missklädsammast" "missklädsammaste" ;
  misskundsam_av_1_A = mkA "misskundsam" "misskundsamt" "misskundsamma" "misskundsamma" "misskundsammare" "misskundsammast" "misskundsammaste" ;
  misskoetsam_av_1_1_A = mkA "misskötsam" "misskötsamt" "misskötsamma" "misskötsamma" "misskötsammare" "misskötsammast" "misskötsammaste" ;
  misstaenksam_av_1_1_A = mkA "misstänksam" "misstänksamt" "misstänksamma" "misstänksamma" "misstänksammare" "misstänksammast" "misstänksammaste" ;
  missunnsam_av_1_A = mkA "missunnsam" "missunnsamt" "missunnsamma" "missunnsamma" "missunnsammare" "missunnsammast" "missunnsammaste" ;
  mytomspunnen_av_1_A = mkA "mytomspunnen" "mytomspunnet" "mytomspunna" "mytomspunna" "mytomspunnare" "mytomspunnast" "mytomspunnaste" ;
  maettsam_av_1_1_A = mkA "mättsam" "mättsamt" "mättsamma" "mättsamma" "mättsammare" "mättsammast" "mättsammaste" ;
  moedosam_av_1_1_A = mkA "mödosam" "mödosamt" "mödosamma" "mödosamma" "mödosammare" "mödosammast" "mödosammaste" ;
  nummen_av_1_A = mkA "nummen" "nummet" "numna" "numna" "numnare" "numnast" "numnaste" ;
  nytillkommen_av_1_A = mkA "nytillkommen" "nytillkommet" "nytillkomna" "nytillkomna" "nytillkomnare" "nytillkomnast" "nytillkomnaste" ;
  nyutkommen_av_1_A = mkA "nyutkommen" "nyutkommet" "nyutkomna" "nyutkomna" "nyutkomnare" "nyutkomnast" "nyutkomnaste" ;
  nyvunnen_av_1_A = mkA "nyvunnen" "nyvunnet" "nyvunna" "nyvunna" "nyvunnare" "nyvunnast" "nyvunnaste" ;
  noejsam_av_1_1_A = mkA "nöjsam" "nöjsamt" "nöjsamma" "nöjsamma" "nöjsammare" "nöjsammast" "nöjsammaste" ;
  oaktsam_av_1_A = mkA "oaktsam" "oaktsamt" "oaktsamma" "oaktsamma" "oaktsammare" "oaktsammast" "oaktsammaste" ;
  obeslutsam_av_1_A = mkA "obeslutsam" "obeslutsamt" "obeslutsamma" "obeslutsamma" "obeslutsammare" "obeslutsammast" "obeslutsammaste" ;
  obetaenksam_av_1_1_A = mkA "obetänksam" "obetänksamt" "obetänksamma" "obetänksamma" "obetänksammare" "obetänksammast" "obetänksammaste" ;
  obrunnen_av_1_A = mkA "obrunnen" "obrunnet" "obrunna" "obrunna" "obrunnare" "obrunnast" "obrunnaste" ;
  ofruktsam_av_1_A = mkA "ofruktsam" "ofruktsamt" "ofruktsamma" "ofruktsamma" "ofruktsammare" "ofruktsammast" "ofruktsammaste" ;
  ofoerbehaallsam_av_1_1_A = mkA "oförbehållsam" "oförbehållsamt" "oförbehållsamma" "oförbehållsamma" "oförbehållsammare" "oförbehållsammast" "oförbehållsammaste" ;
  ofoerdragsam_av_1_1_A = mkA "ofördragsam" "ofördragsamt" "ofördragsamma" "ofördragsamma" "ofördragsammare" "ofördragsammast" "ofördragsammaste" ;
  ofoeretagsam_av_1_1_A = mkA "oföretagsam" "oföretagsamt" "oföretagsamma" "oföretagsamma" "oföretagsammare" "oföretagsammast" "oföretagsammaste" ;
  ogynnsam_av_1_A = mkA "ogynnsam" "ogynnsamt" "ogynnsamma" "ogynnsamma" "ogynnsammare" "ogynnsammast" "ogynnsammaste" ;
  ohaelsosam_av_1_1_A = mkA "ohälsosam" "ohälsosamt" "ohälsosamma" "ohälsosamma" "ohälsosammare" "ohälsosammast" "ohälsosammaste" ;
  ohoersam_av_1_1_A = mkA "ohörsam" "ohörsamt" "ohörsamma" "ohörsamma" "ohörsammare" "ohörsammast" "ohörsammaste" ;
  oloensam_av_1_1_A = mkA "olönsam" "olönsamt" "olönsamma" "olönsamma" "olönsammare" "olönsammast" "olönsammaste" ;
  omisstaenksam_av_1_1_A = mkA "omisstänksam" "omisstänksamt" "omisstänksamma" "omisstänksamma" "omisstänksammare" "omisstänksammast" "omisstänksammaste" ;
  omtaenksam_av_1_1_A = mkA "omtänksam" "omtänksamt" "omtänksamma" "omtänksamma" "omtänksammare" "omtänksammast" "omtänksammaste" ;
  ordningsam_av_1_A = mkA "ordningsam" "ordningsamt" "ordningsamma" "ordningsamma" "ordningsammare" "ordningsammast" "ordningsammaste" ;
  ordstum_av_1_A = mkA "ordstum" "ordstumt" "ordstumma" "ordstumma" "ordstummare" "ordstummast" "ordstummaste" ;
  otacksam_av_1_A = mkA "otacksam" "otacksamt" "otacksamma" "otacksamma" "otacksammare" "otacksammast" "otacksammaste" ;
  otrivsam_av_1_A = mkA "otrivsam" "otrivsamt" "otrivsamma" "otrivsamma" "otrivsammare" "otrivsammast" "otrivsammaste" ;
  otursam_av_1_A = mkA "otursam" "otursamt" "otursamma" "otursamma" "otursammare" "otursammast" "otursammaste" ;
  ouppmaerksam_av_1_1_A = mkA "ouppmärksam" "ouppmärksamt" "ouppmärksamma" "ouppmärksamma" "ouppmärksammare" "ouppmärksammast" "ouppmärksammaste" ;
  ovarsam_av_1_A = mkA "ovarsam" "ovarsamt" "ovarsamma" "ovarsamma" "ovarsammare" "ovarsammast" "ovarsammaste" ;
  overksam_av_1_A = mkA "overksam" "overksamt" "overksamma" "overksamma" "overksammare" "overksammast" "overksammaste" ;
  ovaelkommen_av_1_1_A = mkA "ovälkommen" "ovälkommet" "ovälkomna" "ovälkomna" "ovälkomnare" "ovälkomnast" "ovälkomnaste" ;
  ooem_av_1_1_A = mkA "oöm" "oömt" "oömma" "oömma" "oömmare" "oömmast" "oömmaste" ;
  passagerartom_av_1_A = mkA "passagerartom" "passagerartomt" "passagerartomma" "passagerartomma" "passagerartommare" "passagerartommast" "passagerartommaste" ;
  pinsam_av_1_A = mkA "pinsam" "pinsamt" "pinsamma" "pinsamma" "pinsammare" "pinsammast" "pinsammaste" ;
  plaagsam_av_1_1_A = mkA "plågsam" "plågsamt" "plågsamma" "plågsamma" "plågsammare" "plågsammast" "plågsammaste" ;
  pratsam_av_1_A = mkA "pratsam" "pratsamt" "pratsamma" "pratsamma" "pratsammare" "pratsammast" "pratsammaste" ;
  paakommen_av_1_1_A = mkA "påkommen" "påkommet" "påkomna" "påkomna" "påkomnare" "påkomnast" "påkomnaste" ;
  retsam_av_1_A = mkA "retsam" "retsamt" "retsamma" "retsamma" "retsammare" "retsammast" "retsammaste" ;
  rum_av_1_A = mkA "rum" "rumt" "rumma" "rumma" "rummare" "rummast" "rummaste" ;
  raettfram_av_1_1_A = mkA "rättfram" "rättframt" "rättframma" "rättframma" "rättframmare" "rättframmast" "rättframmaste" ;
  sagoomspunnen_av_1_A = mkA "sagoomspunnen" "sagoomspunnet" "sagoomspunna" "sagoomspunna" "sagoomspunnare" "sagoomspunnast" "sagoomspunnaste" ;
  samvetsoem_av_1_1_A = mkA "samvetsöm" "samvetsömt" "samvetsömma" "samvetsömma" "samvetsömmare" "samvetsömmast" "samvetsömmaste" ;
  sedesam_av_1_A = mkA "sedesam" "sedesamt" "sedesamma" "sedesamma" "sedesammare" "sedesammast" "sedesammaste" ;
  senkommen_av_1_A = mkA "senkommen" "senkommet" "senkomna" "senkomna" "senkomnare" "senkomnast" "senkomnaste" ;
  skonsam_av_1_A = mkA "skonsam" "skonsamt" "skonsamma" "skonsamma" "skonsammare" "skonsammast" "skonsammaste" ;
  skrytsam_av_1_A = mkA "skrytsam" "skrytsamt" "skrytsamma" "skrytsamma" "skrytsammare" "skrytsammast" "skrytsammaste" ;
  skum_av_1_A = mkA "skum" "skumt" "skumma" "skumma" "skummare" "skummast" "skummaste" ;
  skyndsam_av_1_A = mkA "skyndsam" "skyndsamt" "skyndsamma" "skyndsamma" "skyndsammare" "skyndsammast" "skyndsammaste" ;
  skaemtsam_av_1_1_A = mkA "skämtsam" "skämtsamt" "skämtsamma" "skämtsamma" "skämtsammare" "skämtsammast" "skämtsammaste" ;
  skaaltom_av_1_1_A = mkA "skåltom" "skåltomt" "skåltomma" "skåltomma" "skåltommare" "skåltommast" "skåltommaste" ;
  skoetsam_av_1_1_A = mkA "skötsam" "skötsamt" "skötsamma" "skötsamma" "skötsammare" "skötsammast" "skötsammaste" ;
  slem_av_1_A = mkA "slem" "slemt" "slemma" "slemma" "slemmare" "slemmast" "slemmaste" ;
  slitsam_av_1_A = mkA "slitsam" "slitsamt" "slitsamma" "slitsamma" "slitsammare" "slitsammast" "slitsammaste" ;
  slaepsam_av_1_1_A = mkA "släpsam" "släpsamt" "släpsamma" "släpsamma" "släpsammare" "släpsammast" "släpsammaste" ;
  smeksam_av_1_A = mkA "smeksam" "smeksamt" "smeksamma" "smeksamma" "smeksammare" "smeksammast" "smeksammaste" ;
  smittosam_av_1_A = mkA "smittosam" "smittosamt" "smittosamma" "smittosamma" "smittosammare" "smittosammast" "smittosammaste" ;
  smittsam_av_1_A = mkA "smittsam" "smittsamt" "smittsamma" "smittsamma" "smittsammare" "smittsammast" "smittsammaste" ;
  smaertsam_av_1_1_A = mkA "smärtsam" "smärtsamt" "smärtsamma" "smärtsamma" "smärtsammare" "smärtsammast" "smärtsammaste" ;
  sorgesam_av_1_A = mkA "sorgesam" "sorgesamt" "sorgesamma" "sorgesamma" "sorgesammare" "sorgesammast" "sorgesammaste" ;
  sparsam_av_1_A = mkA "sparsam" "sparsamt" "sparsamma" "sparsamma" "sparsammare" "sparsammast" "sparsammaste" ;
  spraaksam_av_1_1_A = mkA "språksam" "språksamt" "språksamma" "språksamma" "språksammare" "språksammast" "språksammaste" ;
  stillsam_av_1_A = mkA "stillsam" "stillsamt" "stillsamma" "stillsamma" "stillsammare" "stillsammast" "stillsammaste" ;
  stockdum_av_1_A = mkA "stockdum" "stockdumt" "stockdumma" "stockdumma" "stockdummare" "stockdummast" "stockdummaste" ;
  straevsam_av_1_1_A = mkA "strävsam" "strävsamt" "strävsamma" "strävsamma" "strävsammare" "strävsammast" "strävsammaste" ;
  stum_av_1_A = mkA "stum" "stumt" "stumma" "stumma" "stummare" "stummast" "stummaste" ;
  svaarfunnen_av_1_1_A = mkA "svårfunnen" "svårfunnet" "svårfunna" "svårfunna" "svårfunnare" "svårfunnast" "svårfunnaste" ;
  saegenomspunnen_av_1_1_A = mkA "sägenomspunnen" "sägenomspunnet" "sägenomspunna" "sägenomspunna" "sägenomspunnare" "sägenomspunnast" "sägenomspunnaste" ;
  saellsam_av_1_1_A = mkA "sällsam" "sällsamt" "sällsamma" "sällsamma" "sällsammare" "sällsammast" "sällsammaste" ;
  tacksam_av_1_A = mkA "tacksam" "tacksamt" "tacksamma" "tacksamma" "tacksammare" "tacksammast" "tacksammaste" ;
  tanketom_av_1_A = mkA "tanketom" "tanketomt" "tanketomma" "tanketomma" "tanketommare" "tanketommast" "tanketommaste" ;
  tom_av_1_A = mkA "tom" "tomt" "tomma" "tomma" "tommare" "tommast" "tommaste" ;
  trivsam_av_1_A = mkA "trivsam" "trivsamt" "trivsamma" "trivsamma" "trivsammare" "trivsammast" "trivsammaste" ;
  troettsam_av_1_1_A = mkA "tröttsam" "tröttsamt" "tröttsamma" "tröttsamma" "tröttsammare" "tröttsammast" "tröttsammaste" ;
  tungsam_av_1_A = mkA "tungsam" "tungsamt" "tungsamma" "tungsamma" "tungsammare" "tungsammast" "tungsammaste" ;
  tursam_av_1_A = mkA "tursam" "tursamt" "tursamma" "tursamma" "tursammare" "tursammast" "tursammaste" ;
  tveksam_av_1_A = mkA "tveksam" "tveksamt" "tveksamma" "tveksamma" "tveksammare" "tveksammast" "tveksammaste" ;
  tvivelsam_av_1_A = mkA "tvivelsam" "tvivelsamt" "tvivelsamma" "tvivelsamma" "tvivelsammare" "tvivelsammast" "tvivelsammaste" ;
  undersam_av_1_A = mkA "undersam" "undersamt" "undersamma" "undersamma" "undersammare" "undersammast" "undersammaste" ;
  uppmaerksam_av_1_1_A = mkA "uppmärksam" "uppmärksamt" "uppmärksamma" "uppmärksamma" "uppmärksammare" "uppmärksammast" "uppmärksammaste" ;
  utbrunnen_av_1_A = mkA "utbrunnen" "utbrunnet" "utbrunna" "utbrunna" "utbrunnare" "utbrunnast" "utbrunnaste" ;
  vaksam_av_1_A = mkA "vaksam" "vaksamt" "vaksamma" "vaksamma" "vaksammare" "vaksammast" "vaksammaste" ;
  varkunnsam_av_1_A = mkA "varkunnsam" "varkunnsamt" "varkunnsamma" "varkunnsamma" "varkunnsammare" "varkunnsammast" "varkunnsammaste" ;
  varsam_av_1_A = mkA "varsam" "varsamt" "varsamma" "varsamma" "varsammare" "varsammast" "varsammaste" ;
  verksam_av_1_A = mkA "verksam" "verksamt" "verksamma" "verksamma" "verksammare" "verksammast" "verksammaste" ;
  villsam_av_1_A = mkA "villsam" "villsamt" "villsamma" "villsamma" "villsammare" "villsammast" "villsammaste" ;
  vilsam_av_1_A = mkA "vilsam" "vilsamt" "vilsamma" "vilsamma" "vilsammare" "vilsammast" "vilsammaste" ;
  vilsekommen_av_1_A = mkA "vilsekommen" "vilsekommet" "vilsekomna" "vilsekomna" "vilsekomnare" "vilsekomnast" "vilsekomnaste" ;
  vaelfunnen_av_1_1_A = mkA "välfunnen" "välfunnet" "välfunna" "välfunna" "välfunnare" "välfunnast" "välfunnaste" ;
  vaelkommen_av_1_1_A = mkA "välkommen" "välkommet" "välkomna" "välkomna" "välkomnare" "välkomnast" "välkomnaste" ;
  vaagsam_av_1_1_A = mkA "vågsam" "vågsamt" "vågsamma" "vågsamma" "vågsammare" "vågsammast" "vågsammaste" ;
  vaaldsam_av_1_1_A = mkA "våldsam" "våldsamt" "våldsamma" "våldsamma" "våldsammare" "våldsammast" "våldsammaste" ;
  vaardsam_av_1_1_A = mkA "vårdsam" "vårdsamt" "vårdsamma" "vårdsamma" "vårdsammare" "vårdsammast" "vårdsammaste" ;
  voerdsam_av_1_1_A = mkA "vördsam" "vördsamt" "vördsamma" "vördsamma" "vördsammare" "vördsammast" "vördsammaste" ;
  yrkesverksam_av_1_A = mkA "yrkesverksam" "yrkesverksamt" "yrkesverksamma" "yrkesverksamma" "yrkesverksammare" "yrkesverksammast" "yrkesverksammaste" ;
  aaterhaallsam_av_1_1_A = mkA "återhållsam" "återhållsamt" "återhållsamma" "återhållsamma" "återhållsammare" "återhållsammast" "återhållsammaste" ;
  oem_av_1_1_A = mkA "öm" "ömt" "ömma" "ömma" "ömmare" "ömmast" "ömmaste" ;
  bra_av_1_A = mkA "bra" "bra" "bra" "bättre" "bäst" ;
  faa_av_1_1_A = mkA "få" "få" "få" "färre" "färst" ;
  gammal_av_1_A = mkA "gammal" "gammalt" "gamla" "äldre" "äldst" ;
  naera_av_1_1_A = mkA "nära" "nära" "nära" "närmare" "närmast" ;
  rekordfaa_av_1_1_A = mkA "rekordfå" "rekordfå" "rekordfå" "rekordfärre" "rekordfärst" ;
  urgammal_av_1_A = mkA "urgammal" "urgammalt" "urgamla" "uräldre" "uräldst" ;
  oevervaald_nn_1_1_N = mkN "övervåld" neutrum  ;
  oevertryck_nn_1_1_N = mkN "övertryck" neutrum  ;
  oevermaatt_nn_1_1_N = mkN "övermått" neutrum  ;
  oevermod_nn_1_1_N = mkN "övermod" neutrum  ;
  oeverjag_nn_1_1_N = mkN "överjag" neutrum  ;
  oeverhus_nn_1_1_N = mkN "överhus" neutrum  ;
  oeverhetsfjaesk_nn_1_1_N = mkN "överhetsfjäsk" neutrum  ;
  oeverfloed_nn_1_1_N = mkN "överflöd" neutrum  ;
  oeverbruk_nn_1_1_N = mkN "överbruk" neutrum  ;
  oeverbett_nn_1_1_N = mkN "överbett" neutrum  ;
  oestron_nn_1_1_N = mkN "östron" neutrum  ;
  oesterland_nn_1_1_N = mkN "österland" neutrum  ;
  oestblock_nn_1_1_N = mkN "östblock" neutrum  ;
  oes_nn_1_1_N = mkN "ös" neutrum  ;
  oerspraang_nn_1_1_N = mkN "örsprång" neutrum  ;
  oeronvax_nn_1_1_N = mkN "öronvax" neutrum  ;
  oekenklimat_nn_1_1_N = mkN "ökenklimat" neutrum  ;
  oegonmaatt_nn_1_1_N = mkN "ögonmått" neutrum  ;
  oegondropp_nn_1_1_N = mkN "ögondropp" neutrum  ;
  aattital_nn_1_1_N = mkN "åttital" neutrum  ;
  aattiotal_nn_1_1_N = mkN "åttiotal" neutrum  ;
  aatersken_nn_1_1_N = mkN "återsken" neutrum  ;
  aaterbruk_nn_1_1_N = mkN "återbruk" neutrum  ;
  aat_nn_1_1_N = mkN "åt" neutrum  ;
  aaskaadningsmaterial_nn_1_1_N = mkN "åskådningsmaterial" neutrum  ;
  aaskmuller_nn_1_1_N = mkN "åskmuller" neutrum  ;
  aasiktsfoertryck_nn_1_1_N = mkN "åsiktsförtryck" neutrum  ;
  aalmoerker_nn_1_1_N = mkN "ålmörker" neutrum  ;
  aaldersstreck_nn_1_1_N = mkN "åldersstreck" neutrum  ;
  aalamoerker_nn_1_1_N = mkN "ålamörker" neutrum  ;
  aakerograes_nn_1_1_N = mkN "åkerogräs" neutrum  ;
  aendtrae_nn_1_1_N = mkN "ändträ" neutrum  ;
  aemnesinnehaall_nn_1_1_N = mkN "ämnesinnehåll" neutrum  ;
  aembetsmannaansvar_nn_1_1_N = mkN "ämbetsmannaansvar" neutrum  ;
  aembetsansvar_nn_1_1_N = mkN "ämbetsansvar" neutrum  ;
  aeltgraes_nn_1_1_N = mkN "ältgräs" neutrum  ;
  aelgkoett_nn_1_1_N = mkN "älgkött" neutrum  ;
  aelggraes_nn_1_1_N = mkN "älggräs" neutrum  ;
  aeldrehat_nn_1_1_N = mkN "äldrehat" neutrum  ;
  aeggvitebehov_nn_1_1_N = mkN "äggvitebehov" neutrum  ;
  aeggpulver_nn_1_1_N = mkN "äggpulver" neutrum  ;
  aedeltrae_nn_1_1_N = mkN "ädelträ" neutrum  ;
  aedelmod_nn_1_1_N = mkN "ädelmod" neutrum  ;
  zodiakalljus_nn_1_N = mkN "zodiakalljus" neutrum  ;
  zirkonium_nn_1_N = mkN "zirkonium" neutrum  ;
  yttrium_nn_1_N = mkN "yttrium" neutrum  ;
  ytterspaar_nn_1_1_N = mkN "ytterspår" neutrum  ;
  ytterbium_nn_1_N = mkN "ytterbium" neutrum  ;
  yppandefoerbud_nn_1_1_N = mkN "yppandeförbud" neutrum  ;
  yl_nn_1_N = mkN "yl" neutrum  ;
  xenon_nn_1_N = mkN "xenon" neutrum  ;
  xantofyll_nn_1_N = mkN "xantofyll" neutrum  ;
  vaatrumssilikon_nn_1_1_N = mkN "våtrumssilikon" neutrum  ;
  vaarbruk_nn_1_1_N = mkN "vårbruk" neutrum  ;
  vaald_nn_1_1_N = mkN "våld" neutrum  ;
  vaagmaesteri_nn_1_1_N = mkN "vågmästeri" neutrum  ;
  vaextskydd_nn_1_1_N = mkN "växtskydd" neutrum  ;
  vaextliv_nn_1_1_N = mkN "växtliv" neutrum  ;
  vaexelrytteri_nn_1_1_N = mkN "växelrytteri" neutrum  ;
  vaexelbruk_nn_1_1_N = mkN "växelbruk" neutrum  ;
  vaestficksformat_nn_1_1_N = mkN "västficksformat" neutrum  ;
  vaesterland_nn_1_1_N = mkN "västerland" neutrum  ;
  vaesterhav_nn_1_1_N = mkN "västerhav" neutrum  ;
  vaestblock_nn_1_1_N = mkN "västblock" neutrum  ;
  vaermeslag_nn_1_1_N = mkN "värmeslag" neutrum  ;
  vaermedis_nn_1_1_N = mkN "värmedis" neutrum  ;
  vaerldsfoerakt_nn_1_1_N = mkN "världsförakt" neutrum  ;
  vaerldsallt_nn_1_1_N = mkN "världsallt" neutrum  ;
  vaerdskap_nn_1_1_N = mkN "värdskap" neutrum  ;
  vaensterprassel_nn_1_1_N = mkN "vänsterprassel" neutrum  ;
  vaelstaand_nn_1_1_N = mkN "välstånd" neutrum  ;
  vaellstaal_nn_1_1_N = mkN "vällstål" neutrum  ;
  vaelljud_nn_1_1_N = mkN "välljud" neutrum  ;
  vaelbehag_nn_1_1_N = mkN "välbehag" neutrum  ;
  vaegverk_nn_1_1_N = mkN "vägverk" neutrum  ;
  vaegsmuts_nn_1_1_N = mkN "vägsmuts" neutrum  ;
  vaegsalt_nn_1_1_N = mkN "vägsalt" neutrum  ;
  vaeggrepp_nn_1_1_N = mkN "väggrepp" neutrum  ;
  vaederkorn_nn_1_1_N = mkN "väderkorn" neutrum  ;
  vuxenstudiestoed_nn_1_1_N = mkN "vuxenstudiestöd" neutrum  ;
  vurmeri_nn_1_N = mkN "vurmeri" neutrum  ;
  vulgaerlatin_nn_1_1_N = mkN "vulgärlatin" neutrum  ;
  vroevel_nn_1_1_N = mkN "vrövel" neutrum  ;
  vredesmod_nn_1_N = mkN "vredesmod" neutrum  ;
  vrakjaern_nn_1_1_N = mkN "vrakjärn" neutrum  ;
  vrakgods_nn_1_N = mkN "vrakgods" neutrum  ;
  vokalmummel_nn_1_N = mkN "vokalmummel" neutrum  ;
  vitterfolk_nn_1_N = mkN "vitterfolk" neutrum  ;
  vitbleck_nn_1_N = mkN "vitbleck" neutrum  ;
  virrvarr_nn_1_N = mkN "virrvarr" neutrum  ;
  vintersolstaand_nn_1_1_N = mkN "vintersolstånd" neutrum  ;
  vinstbegaer_nn_1_1_N = mkN "vinstbegär" neutrum  ;
  vingleri_nn_1_N = mkN "vingleri" neutrum  ;
  vingel_nn_1_N = mkN "vingel" neutrum  ;
  vingbrus_nn_1_N = mkN "vingbrus" neutrum  ;
  vindtyg_nn_1_N = mkN "vindtyg" neutrum  ;
  vindsus_nn_1_N = mkN "vindsus" neutrum  ;
  vindrufs_nn_1_N = mkN "vindrufs" neutrum  ;
  vin_nn_2_N = mkN "vin" neutrum  ;
  vimmel_nn_1_N = mkN "vimmel" neutrum  ;
  vilt_nn_1_N = mkN "vilt" neutrum  ;
  villabyggnadsraseri_nn_1_N = mkN "villabyggnadsraseri" neutrum  ;
  vildvin_nn_1_N = mkN "vildvin" neutrum  ;
  vi_nn_1_N = mkN "vi" neutrum  ;
  vett_nn_1_N = mkN "vett" neutrum  ;
  vetemjoelsklister_nn_1_1_N = mkN "vetemjölsklister" neutrum  ;
  vetemjoel_nn_1_1_N = mkN "vetemjöl" neutrum  ;
  vetekli_nn_1_N = mkN "vetekli" neutrum  ;
  verktygsstaal_nn_1_1_N = mkN "verktygsstål" neutrum  ;
  verkskydd_nn_1_N = mkN "verkskydd" neutrum  ;
  verksamhetsbegaer_nn_1_1_N = mkN "verksamhetsbegär" neutrum  ;
  verkbly_nn_1_N = mkN "verkbly" neutrum  ;
  venushaar_nn_1_1_N = mkN "venushår" neutrum  ;
  vemod_nn_1_N = mkN "vemod" neutrum  ;
  velum_nn_1_N = mkN "velum" neutrum  ;
  vedmaatt_nn_1_1_N = mkN "vedmått" neutrum  ;
  vederlagsgods_nn_1_N = mkN "vederlagsgods" neutrum  ;
  vattningsfoerbud_nn_1_1_N = mkN "vattningsförbud" neutrum  ;
  vattenmotstaand_nn_1_1_N = mkN "vattenmotstånd" neutrum  ;
  vattenliv_nn_1_N = mkN "vattenliv" neutrum  ;
  vattenbryn_nn_1_N = mkN "vattenbryn" neutrum  ;
  vattenblask_nn_1_N = mkN "vattenblask" neutrum  ;
  vask_nn_2_N = mkN "vask" neutrum  ;
  varuoeverfloed_nn_1_1_N = mkN "varuöverflöd" neutrum  ;
  vardagsbruk_nn_1_N = mkN "vardagsbruk" neutrum  ;
  var_nn_1_N = mkN "var" neutrum  ;
  vapenunderhaall_nn_1_1_N = mkN "vapenunderhåll" neutrum  ;
  vapenskrammel_nn_1_N = mkN "vapenskrammel" neutrum  ;
  vapenfett_nn_1_N = mkN "vapenfett" neutrum  ;
  vapenbrak_nn_1_N = mkN "vapenbrak" neutrum  ;
  vanvett_nn_1_N = mkN "vanvett" neutrum  ;
  vankelmod_nn_1_N = mkN "vankelmod" neutrum  ;
  vaniljsocker_nn_1_N = mkN "vaniljsocker" neutrum  ;
  valoertryck_nn_1_1_N = mkN "valörtryck" neutrum  ;
  valoermaaleri_nn_1_1_N = mkN "valörmåleri" neutrum  ;
  valskolk_nn_1_N = mkN "valskolk" neutrum  ;
  valsjaern_nn_1_1_N = mkN "valsjärn" neutrum  ;
  valnoetstrae_nn_1_1_N = mkN "valnötsträ" neutrum  ;
  vallhoe_nn_1_1_N = mkN "vallhö" neutrum  ;
  valfusk_nn_1_N = mkN "valfusk" neutrum  ;
  valflaesk_nn_1_1_N = mkN "valfläsk" neutrum  ;
  valfiffel_nn_1_N = mkN "valfiffel" neutrum  ;
  vak_nn_2_N = mkN "vak" neutrum  ;
  vagabondliv_nn_1_N = mkN "vagabondliv" neutrum  ;
  vaccinationstvaang_nn_1_1_N = mkN "vaccinationstvång" neutrum  ;
  utsugeri_nn_1_N = mkN "utsugeri" neutrum  ;
  utrum_nn_1_N = mkN "utrum" neutrum  ;
  utrikesflyg_nn_2_N = mkN "utrikesflyg" neutrum  ;
  utredningsmaterial_nn_1_N = mkN "utredningsmaterial" neutrum  ;
  utomhusbruk_nn_1_N = mkN "utomhusbruk" neutrum  ;
  utland_nn_1_N = mkN "utland" neutrum  ;
  uteliv_nn_1_N = mkN "uteliv" neutrum  ;
  utefoersvar_nn_1_1_N = mkN "uteförsvar" neutrum  ;
  utebruk_nn_1_N = mkN "utebruk" neutrum  ;
  urplock_nn_1_N = mkN "urplock" neutrum  ;
  urberg_nn_1_N = mkN "urberg" neutrum  ;
  uranbly_nn_1_N = mkN "uranbly" neutrum  ;
  upptag_nn_1_N = mkN "upptag" neutrum  ;
  upphovsraettsjidder_nn_1_1_N = mkN "upphovsrättsjidder" neutrum  ;
  upphov_nn_1_N = mkN "upphov" neutrum  ;
  uppboerdsverk_nn_1_1_N = mkN "uppbördsverk" neutrum  ;
  ungkarlsliv_nn_1_N = mkN "ungkarlsliv" neutrum  ;
  ung_av_1_A = mkA "ung" "yngre" "yngst" ;
  undervisningsbruk_nn_1_N = mkN "undervisningsbruk" neutrum  ;
  undertryck_nn_1_N = mkN "undertryck" neutrum  ;
  understoedsrytteri_nn_1_1_N = mkN "understödsrytteri" neutrum  ;
  understoed_nn_1_1_N = mkN "understöd" neutrum  ;
  undermaal_nn_1_1_N = mkN "undermål" neutrum  ;
  underlaeder_nn_1_1_N = mkN "underläder" neutrum  ;
  underland_nn_1_N = mkN "underland" neutrum  ;
  underhaallningsvaald_nn_1_1_N = mkN "underhållningsvåld" neutrum  ;
  umgaengesvett_nn_1_1_N = mkN "umgängesvett" neutrum  ;
  umgaengesliv_nn_1_1_N = mkN "umgängesliv" neutrum  ;
  ullhaar_nn_1_1_N = mkN "ullhår" neutrum  ;
  ullgarn_nn_1_N = mkN "ullgarn" neutrum  ;
  ullfett_nn_1_N = mkN "ullfett" neutrum  ;
  taalamod_nn_1_1_N = mkN "tålamod" neutrum  ;
  taenk_nn_1_1_N = mkN "tänk" neutrum  ;
  tyskhat_nn_1_N = mkN "tyskhat" neutrum  ;
  tyranni_nn_1_N = mkN "tyranni" neutrum  ;
  tvaatusental_nn_1_1_N = mkN "tvåtusental" neutrum  ;
  tvaatal_nn_1_1_N = mkN "tvåtal" neutrum  ;
  tvaaskift_nn_1_1_N = mkN "tvåskift" neutrum  ;
  tvaang_nn_1_1_N = mkN "tvång" neutrum  ;
  tvaalloedder_nn_1_1_N = mkN "tvållödder" neutrum  ;
  tvaaledarsystem_nn_1_1_N = mkN "tvåledarsystem" neutrum  ;
  tvaahundratal_nn_1_1_N = mkN "tvåhundratal" neutrum  ;
  tvaerdrag_nn_1_1_N = mkN "tvärdrag" neutrum  ;
  tvivelsmaal_nn_1_1_N = mkN "tvivelsmål" neutrum  ;
  tungel_nn_1_N = mkN "tungel" neutrum  ;
  tung_av_1_A = mkA "tung" "tyngre" "tyngst" ;
  tummel_nn_1_N = mkN "tummel" neutrum  ;
  tullvaesen_nn_1_1_N = mkN "tullväsen" neutrum  ;
  tulium_nn_1_N = mkN "tulium" neutrum  ;
  tugg_nn_1_N = mkN "tugg" neutrum  ;
  traak_nn_1_1_N = mkN "tråk" neutrum  ;
  traadglas_nn_1_1_N = mkN "trådglas" neutrum  ;
  traetugg_nn_1_1_N = mkN "trätugg" neutrum  ;
  traesocker_nn_1_1_N = mkN "träsocker" neutrum  ;
  traesk_nn_2_1_N = mkN "träsk" neutrum  ;
  traejon_nn_1_1_N = mkN "träjon" neutrum  ;
  traeavfall_nn_1_1_N = mkN "träavfall" neutrum  ;
  trycktrae_nn_1_1_N = mkN "tryckträ" neutrum  ;
  trug_nn_1_N = mkN "trug" neutrum  ;
  trots_nn_1_N = mkN "trots" neutrum  ;
  trollmos_nn_1_N = mkN "trollmos" neutrum  ;
  tritium_nn_1_N = mkN "tritium" neutrum  ;
  trettonhundratal_nn_1_N = mkN "trettonhundratal" neutrum  ;
  tresteg_nn_1_N = mkN "tresteg" neutrum  ;
  treskiftesbruk_nn_1_N = mkN "treskiftesbruk" neutrum  ;
  treskift_nn_1_N = mkN "treskift" neutrum  ;
  trehundratal_nn_1_N = mkN "trehundratal" neutrum  ;
  trassel_nn_1_N = mkN "trassel" neutrum  ;
  trasproletariat_nn_1_N = mkN "trasproletariat" neutrum  ;
  transportvaesen_nn_1_1_N = mkN "transportväsen" neutrum  ;
  trams_nn_1_N = mkN "trams" neutrum  ;
  trampgraes_nn_1_1_N = mkN "trampgräs" neutrum  ;
  tramp_nn_1_N = mkN "tramp" neutrum  ;
  traggel_nn_1_N = mkN "traggel" neutrum  ;
  trafikflyg_nn_1_N = mkN "trafikflyg" neutrum  ;
  trafikbuller_nn_1_N = mkN "trafikbuller" neutrum  ;
  trafikbrus_nn_1_N = mkN "trafikbrus" neutrum  ;
  totalintryck_nn_1_N = mkN "totalintryck" neutrum  ;
  totalfoersvar_nn_1_1_N = mkN "totalförsvar" neutrum  ;
  torvstroe_nn_1_1_N = mkN "torvströ" neutrum  ;
  torsklevertran_nn_1_N = mkN "torsklevertran" neutrum  ;
  torrfoder_nn_1_N = mkN "torrfoder" neutrum  ;
  torrdis_nn_1_N = mkN "torrdis" neutrum  ;
  torium_nn_1_N = mkN "torium" neutrum  ;
  torgvimmel_nn_1_N = mkN "torgvimmel" neutrum  ;
  tonval_nn_1_N = mkN "tonval" neutrum  ;
  tomtjobberi_nn_1_N = mkN "tomtjobberi" neutrum  ;
  tolvhundratal_nn_1_N = mkN "tolvhundratal" neutrum  ;
  toluen_nn_1_N = mkN "toluen" neutrum  ;
  tokprat_nn_1_N = mkN "tokprat" neutrum  ;
  tobaksbruk_nn_1_N = mkN "tobaksbruk" neutrum  ;
  toapapper_nn_1_N = mkN "toapapper" neutrum  ;
  toalettpapper_nn_1_N = mkN "toalettpapper" neutrum  ;
  tjaerdrev_nn_1_1_N = mkN "tjärdrev" neutrum  ;
  tjaenstefolk_nn_1_1_N = mkN "tjänstefolk" neutrum  ;
  tjuvspraak_nn_1_1_N = mkN "tjuvspråk" neutrum  ;
  tjuvgods_nn_1_N = mkN "tjuvgods" neutrum  ;
  tjurfaektningsfoersvar_nn_1_1_N = mkN "tjurfäktningsförsvar" neutrum  ;
  tjugohundratal_nn_1_N = mkN "tjugohundratal" neutrum  ;
  tjo_nn_1_N = mkN "tjo" neutrum  ;
  tjatter_nn_1_N = mkN "tjatter" neutrum  ;
  tjat_nn_1_N = mkN "tjat" neutrum  ;
  tjall_nn_1_N = mkN "tjall" neutrum  ;
  tjafs_nn_1_N = mkN "tjafs" neutrum  ;
  tissel_nn_1_N = mkN "tissel" neutrum  ;
  tiohundratal_nn_1_N = mkN "tiohundratal" neutrum  ;
  tingeltangel_nn_1_N = mkN "tingeltangel" neutrum  ;
  tilltugg_nn_1_N = mkN "tilltugg" neutrum  ;
  tilltal_nn_1_N = mkN "tilltal" neutrum  ;
  tillsynsansvar_nn_1_N = mkN "tillsynsansvar" neutrum  ;
  tidningspapper_nn_1_N = mkN "tidningspapper" neutrum  ;
  tidelagsfoerbud_nn_1_1_N = mkN "tidelagsförbud" neutrum  ;
  thomasfosfat_nn_1_N = mkN "thomasfosfat" neutrum  ;
  thaisiden_nn_1_N = mkN "thaisiden" neutrum  ;
  textilspill_nn_1_N = mkN "textilspill" neutrum  ;
  tetraetylbly_nn_1_N = mkN "tetraetylbly" neutrum  ;
  testosteron_nn_1_N = mkN "testosteron" neutrum  ;
  tertiaersystem_nn_1_1_N = mkN "tertiärsystem" neutrum  ;
  terbium_nn_1_N = mkN "terbium" neutrum  ;
  tennlod_nn_1_N = mkN "tennlod" neutrum  ;
  tenn_nn_1_N = mkN "tenn" neutrum  ;
  teleschack_nn_1_N = mkN "teleschack" neutrum  ;
  telegramspraak_nn_1_1_N = mkN "telegramspråk" neutrum  ;
  telefax_nn_1_N = mkN "telefax" neutrum  ;
  telefaksimil_nn_1_N = mkN "telefaksimil" neutrum  ;
  teknetium_nn_1_N = mkN "teknetium" neutrum  ;
  teflon_nn_1_N = mkN "teflon" neutrum  ;
  teblask_nn_1_N = mkN "teblask" neutrum  ;
  tassel_nn_1_N = mkN "tassel" neutrum  ;
  tarv_nn_1_N = mkN "tarv" neutrum  ;
  tantsnusk_nn_1_N = mkN "tantsnusk" neutrum  ;
  tankeliv_nn_1_N = mkN "tankeliv" neutrum  ;
  tankeinnehaall_nn_1_1_N = mkN "tankeinnehåll" neutrum  ;
  tankegods_nn_1_N = mkN "tankegods" neutrum  ;
  tankedjup_nn_1_N = mkN "tankedjup" neutrum  ;
  tandvaardsstoed_nn_1_1_N = mkN "tandvårdsstöd" neutrum  ;
  tandkoett_nn_1_1_N = mkN "tandkött" neutrum  ;
  tandkitt_nn_1_N = mkN "tandkitt" neutrum  ;
  tandguld_nn_1_N = mkN "tandguld" neutrum  ;
  tandem_nn_1_N = mkN "tandem" neutrum  ;
  tandben_nn_1_N = mkN "tandben" neutrum  ;
  tamiflu_nn_1_N = mkN "tamiflu" neutrum  ;
  tallium_nn_1_N = mkN "tallium" neutrum  ;
  tal_nn_2_N = mkN "tal" neutrum  ;
  takdropp_nn_1_N = mkN "takdropp" neutrum  ;
  taglingsgarn_nn_1_N = mkN "taglingsgarn" neutrum  ;
  tag_nn_2_N = mkN "tag" neutrum  ;
  taffelland_nn_1_N = mkN "taffelland" neutrum  ;
  tadel_nn_1_N = mkN "tadel" neutrum  ;
  tackjaern_nn_1_1_N = mkN "tackjärn" neutrum  ;
  soetsug_nn_1_1_N = mkN "sötsug" neutrum  ;
  soenderfall_nn_1_1_N = mkN "sönderfall" neutrum  ;
  soel_nn_1_1_N = mkN "söl" neutrum  ;
  soek_nn_1_1_N = mkN "sök" neutrum  ;
  saekerhetstaenk_nn_1_1_N = mkN "säkerhetstänk" neutrum  ;
  saekerhetsraad_nn_1_1_N = mkN "säkerhetsråd" neutrum  ;
  saedesbruk_nn_1_1_N = mkN "sädesbruk" neutrum  ;
  systerskap_nn_1_N = mkN "systerskap" neutrum  ;
  syskonskap_nn_1_N = mkN "syskonskap" neutrum  ;
  syndetikon_nn_1_N = mkN "syndetikon" neutrum  ;
  svaarmod_nn_1_1_N = mkN "svårmod" neutrum  ;
  svaagerskap_nn_1_1_N = mkN "svågerskap" neutrum  ;
  svaagerlag_nn_1_1_N = mkN "svågerlag" neutrum  ;
  svisch_nn_1_N = mkN "svisch" neutrum  ;
  svir_nn_1_N = mkN "svir" neutrum  ;
  svinlaeder_nn_1_1_N = mkN "svinläder" neutrum  ;
  svinblod_nn_1_N = mkN "svinblod" neutrum  ;
  svenskhat_nn_1_N = mkN "svenskhat" neutrum  ;
  svedjebruk_nn_1_N = mkN "svedjebruk" neutrum  ;
  svavel_nn_1_N = mkN "svavel" neutrum  ;
  svartkrut_nn_1_N = mkN "svartkrut" neutrum  ;
  svammel_nn_1_N = mkN "svammel" neutrum  ;
  svaj_nn_1_N = mkN "svaj" neutrum  ;
  sus_nn_1_N = mkN "sus" neutrum  ;
  surr_nn_1_N = mkN "surr" neutrum  ;
  superi_nn_1_N = mkN "superi" neutrum  ;
  superfosfat_nn_1_N = mkN "superfosfat" neutrum  ;
  sunk_nn_1_N = mkN "sunk" neutrum  ;
  sug_nn_2_N = mkN "sug" neutrum  ;
  sudderi_nn_1_N = mkN "sudderi" neutrum  ;
  sudd_nn_2_N = mkN "sudd" neutrum  ;
  stoeveltramp_nn_1_1_N = mkN "stöveltramp" neutrum  ;
  stoev_nn_1_1_N = mkN "stöv" neutrum  ;
  stoeldgods_nn_1_1_N = mkN "stöldgods" neutrum  ;
  stoek_nn_1_1_N = mkN "stök" neutrum  ;
  staank_nn_1_1_N = mkN "stånk" neutrum  ;
  staangjaern_nn_1_1_N = mkN "stångjärn" neutrum  ;
  staahej_nn_1_1_N = mkN "ståhej" neutrum  ;
  staerkelseklister_nn_1_1_N = mkN "stärkelseklister" neutrum  ;
  staengningsdags_nn_1_1_N = mkN "stängningsdags" neutrum  ;
  styckverk_nn_1_N = mkN "styckverk" neutrum  ;
  styckegods_nn_1_N = mkN "styckegods" neutrum  ;
  studiestoed_nn_1_1_N = mkN "studiestöd" neutrum  ;
  studentliv_nn_1_N = mkN "studentliv" neutrum  ;
  stroeveri_nn_1_1_N = mkN "ströveri" neutrum  ;
  stroesocker_nn_1_1_N = mkN "strösocker" neutrum  ;
  stroemningsmotstaand_nn_1_1_N = mkN "strömningsmotstånd" neutrum  ;
  stroebroed_nn_1_1_N = mkN "ströbröd" neutrum  ;
  stroe_nn_1_1_N = mkN "strö" neutrum  ;
  straalskydd_nn_1_1_N = mkN "strålskydd" neutrum  ;
  straalningstryck_nn_1_1_N = mkN "strålningstryck" neutrum  ;
  straalkastarsken_nn_1_1_N = mkN "strålkastarsken" neutrum  ;
  straalkastarljus_nn_2_1_N = mkN "strålkastarljus" neutrum  ;
  straafoder_nn_1_1_N = mkN "stråfoder" neutrum  ;
  stryktips_nn_1_N = mkN "stryktips" neutrum  ;
  stryk_nn_1_N = mkN "stryk" neutrum  ;
  struntprat_nn_1_N = mkN "struntprat" neutrum  ;
  strunt_nn_1_N = mkN "strunt" neutrum  ;
  strul_nn_1_N = mkN "strul" neutrum  ;
  strontium_nn_1_N = mkN "strontium" neutrum  ;
  stridstummel_nn_1_N = mkN "stridstummel" neutrum  ;
  stridsbuller_nn_1_N = mkN "stridsbuller" neutrum  ;
  strandskydd_nn_1_N = mkN "strandskydd" neutrum  ;
  storvilt_nn_1_N = mkN "storvilt" neutrum  ;
  storting_nn_1_N = mkN "storting" neutrum  ;
  stor_av_1_A = mkA "stor" "större" "störst" ;
  stoj_nn_1_N = mkN "stoj" neutrum  ;
  stjaernstoff_nn_1_1_N = mkN "stjärnstoff" neutrum  ;
  stjaernkoett_nn_1_1_N = mkN "stjärnkött" neutrum  ;
  stiftsband_nn_1_N = mkN "stiftsband" neutrum  ;
  stensalt_nn_1_N = mkN "stensalt" neutrum  ;
  stengods_nn_1_N = mkN "stengods" neutrum  ;
  stekflaesk_nn_1_1_N = mkN "stekfläsk" neutrum  ;
  statsverk_nn_1_N = mkN "statsverk" neutrum  ;
  startkapital_nn_1_N = mkN "startkapital" neutrum  ;
  stamp_nn_3_N = mkN "stamp" neutrum  ;
  stadsliv_nn_1_N = mkN "stadsliv" neutrum  ;
  spoeregn_nn_1_1_N = mkN "spöregn" neutrum  ;
  spaeck_nn_1_1_N = mkN "späck" neutrum  ;
  spraakbruk_nn_1_1_N = mkN "språkbruk" neutrum  ;
  spritmissbruk_nn_1_N = mkN "spritmissbruk" neutrum  ;
  spring_nn_1_N = mkN "spring" neutrum  ;
  sprattel_nn_1_N = mkN "sprattel" neutrum  ;
  spott_nn_1_N = mkN "spott" neutrum  ;
  sportsmanship_nn_1_N = mkN "sportsmanship" neutrum  ;
  sportliv_nn_1_N = mkN "sportliv" neutrum  ;
  sporrstraeck_nn_1_1_N = mkN "sporrsträck" neutrum  ;
  split_nn_1_N = mkN "split" neutrum  ;
  spisbroed_nn_1_1_N = mkN "spisbröd" neutrum  ;
  spill_nn_1_N = mkN "spill" neutrum  ;
  specialstaal_nn_1_1_N = mkN "specialstål" neutrum  ;
  spaltlaeder_nn_1_1_N = mkN "spaltläder" neutrum  ;
  spad_nn_1_N = mkN "spad" neutrum  ;
  spackel_nn_1_N = mkN "spackel" neutrum  ;
  sovel_nn_1_N = mkN "sovel" neutrum  ;
  sotarspraak_nn_1_1_N = mkN "sotarspråk" neutrum  ;
  sot_nn_1_N = mkN "sot" neutrum  ;
  sorl_nn_1_N = mkN "sorl" neutrum  ;
  sorgmod_nn_1_N = mkN "sorgmod" neutrum  ;
  sommarsolstaand_nn_1_1_N = mkN "sommarsolstånd" neutrum  ;
  sommarmoerker_nn_1_1_N = mkN "sommarmörker" neutrum  ;
  sommargraes_nn_1_1_N = mkN "sommargräs" neutrum  ;
  solsting_nn_1_N = mkN "solsting" neutrum  ;
  solsken_nn_1_N = mkN "solsken" neutrum  ;
  solregn_nn_1_N = mkN "solregn" neutrum  ;
  solnedgaangsljus_nn_1_1_N = mkN "solnedgångsljus" neutrum  ;
  solk_nn_1_N = mkN "solk" neutrum  ;
  solgass_nn_1_N = mkN "solgass" neutrum  ;
  soldis_nn_1_N = mkN "soldis" neutrum  ;
  soldatmaterial_nn_1_N = mkN "soldatmaterial" neutrum  ;
  sojamjoel_nn_1_1_N = mkN "sojamjöl" neutrum  ;
  sockersug_nn_1_N = mkN "sockersug" neutrum  ;
  socker_nn_1_N = mkN "socker" neutrum  ;
  snoeslask_nn_1_1_N = mkN "snöslask" neutrum  ;
  snoeregn_nn_1_1_N = mkN "snöregn" neutrum  ;
  snoemoegel_nn_1_1_N = mkN "snömögel" neutrum  ;
  snoemos_nn_1_1_N = mkN "snömos" neutrum  ;
  snoeglopp_nn_1_1_N = mkN "snöglopp" neutrum  ;
  snoedrev_nn_1_1_N = mkN "snödrev" neutrum  ;
  snaerp_nn_1_1_N = mkN "snärp" neutrum  ;
  snaerjgraes_nn_1_1_N = mkN "snärjgräs" neutrum  ;
  snaerj_nn_1_1_N = mkN "snärj" neutrum  ;
  snaellod_nn_1_1_N = mkN "snällod" neutrum  ;
  snusk_nn_1_N = mkN "snusk" neutrum  ;
  snusfoernuft_nn_1_1_N = mkN "snusförnuft" neutrum  ;
  sniff_nn_2_N = mkN "sniff" neutrum  ;
  snicksnack_nn_1_N = mkN "snicksnack" neutrum  ;
  snatter_nn_1_N = mkN "snatter" neutrum  ;
  snask_nn_1_N = mkN "snask" neutrum  ;
  snapphaneri_nn_1_N = mkN "snapphaneri" neutrum  ;
  snafs_nn_1_N = mkN "snafs" neutrum  ;
  snack_nn_1_N = mkN "snack" neutrum  ;
  snabbsvarvstaal_nn_1_1_N = mkN "snabbsvarvstål" neutrum  ;
  snabbstaal_nn_1_1_N = mkN "snabbstål" neutrum  ;
  snabblaan_nn_1_1_N = mkN "snabblån" neutrum  ;
  smoerpapper_nn_1_1_N = mkN "smörpapper" neutrum  ;
  smoerjfett_nn_1_1_N = mkN "smörjfett" neutrum  ;
  smoerj_nn_1_1_N = mkN "smörj" neutrum  ;
  smoergaaspapper_nn_1_1_N = mkN "smörgåspapper" neutrum  ;
  smaavilt_nn_1_1_N = mkN "småvilt" neutrum  ;
  smaaprat_nn_1_1_N = mkN "småprat" neutrum  ;
  smaaplock_nn_1_1_N = mkN "småplock" neutrum  ;
  smaakrafs_nn_1_1_N = mkN "småkrafs" neutrum  ;
  smaafolk_nn_1_1_N = mkN "småfolk" neutrum  ;
  smaabroed_nn_1_1_N = mkN "småbröd" neutrum  ;
  smaaborgerskap_nn_1_1_N = mkN "småborgerskap" neutrum  ;
  smaell_nn_2_1_N = mkN "smäll" neutrum  ;
  smaeck_nn_2_1_N = mkN "smäck" neutrum  ;
  smussel_nn_1_N = mkN "smussel" neutrum  ;
  smult_nn_1_N = mkN "smult" neutrum  ;
  smuggel_nn_1_N = mkN "smuggel" neutrum  ;
  smorlaeder_nn_1_1_N = mkN "smorläder" neutrum  ;
  smolk_nn_1_N = mkN "smolk" neutrum  ;
  smittskydd_nn_1_N = mkN "smittskydd" neutrum  ;
  smisk_nn_1_N = mkN "smisk" neutrum  ;
  smidesjaern_nn_1_1_N = mkN "smidesjärn" neutrum  ;
  smicker_nn_1_N = mkN "smicker" neutrum  ;
  smek_nn_1_N = mkN "smek" neutrum  ;
  smatter_nn_1_N = mkN "smatter" neutrum  ;
  smask_nn_1_N = mkN "smask" neutrum  ;
  smack_nn_2_N = mkN "smack" neutrum  ;
  sloeseri_nn_1_1_N = mkN "slöseri" neutrum  ;
  sloekorn_nn_1_1_N = mkN "slökorn" neutrum  ;
  sloejfoerbud_nn_1_1_N = mkN "slöjförbud" neutrum  ;
  sloedder_nn_1_1_N = mkN "slödder" neutrum  ;
  slaepljus_nn_1_1_N = mkN "släpljus" neutrum  ;
  sludder_nn_1_N = mkN "sludder" neutrum  ;
  slit_nn_1_N = mkN "slit" neutrum  ;
  slisk_nn_1_N = mkN "slisk" neutrum  ;
  slipstvaang_nn_1_1_N = mkN "slipstvång" neutrum  ;
  slidder_nn_1_N = mkN "slidder" neutrum  ;
  slaveri_nn_1_N = mkN "slaveri" neutrum  ;
  slask_nn_1_N = mkN "slask" neutrum  ;
  slarv_nn_1_N = mkN "slarv" neutrum  ;
  slams_nn_1_N = mkN "slams" neutrum  ;
  slammer_nn_1_N = mkN "slammer" neutrum  ;
  slaktavfall_nn_1_N = mkN "slaktavfall" neutrum  ;
  slaglod_nn_1_N = mkN "slaglod" neutrum  ;
  slafs_nn_2_N = mkN "slafs" neutrum  ;
  sladder_nn_1_N = mkN "sladder" neutrum  ;
  slack_nn_1_N = mkN "slack" neutrum  ;
  slabb_nn_1_N = mkN "slabb" neutrum  ;
  skoeldbrosk_nn_1_1_N = mkN "sköldbrosk" neutrum  ;
  skaadespeleri_nn_1_1_N = mkN "skådespeleri" neutrum  ;
  skaadebroed_nn_1_1_N = mkN "skådebröd" neutrum  ;
  skaervfroe_nn_1_1_N = mkN "skärvfrö" neutrum  ;
  skaell_nn_1_1_N = mkN "skäll" neutrum  ;
  skymningsland_nn_1_N = mkN "skymningsland" neutrum  ;
  skymningsdunkel_nn_1_N = mkN "skymningsdunkel" neutrum  ;
  skymmel_nn_1_N = mkN "skymmel" neutrum  ;
  skygd_nn_1_N = mkN "skygd" neutrum  ;
  skydd_nn_1_N = mkN "skydd" neutrum  ;
  skvalp_nn_1_N = mkN "skvalp" neutrum  ;
  skvaller_nn_1_N = mkN "skvaller" neutrum  ;
  skval_nn_1_N = mkN "skval" neutrum  ;
  skumrask_nn_1_N = mkN "skumrask" neutrum  ;
  skraavaesen_nn_1_1_N = mkN "skråväsen" neutrum  ;
  skraevel_nn_1_1_N = mkN "skrävel" neutrum  ;
  skraep_nn_1_1_N = mkN "skräp" neutrum  ;
  skraeckel_nn_1_1_N = mkN "skräckel" neutrum  ;
  skryt_nn_1_N = mkN "skryt" neutrum  ;
  skrot_nn_1_N = mkN "skrot" neutrum  ;
  skrock_nn_1_N = mkN "skrock" neutrum  ;
  skrivmaskinsknatter_nn_1_N = mkN "skrivmaskinsknatter" neutrum  ;
  skravel_nn_1_N = mkN "skravel" neutrum  ;
  skrap_nn_1_N = mkN "skrap" neutrum  ;
  skrammel_nn_1_N = mkN "skrammel" neutrum  ;
  skotthaall_nn_1_1_N = mkN "skotthåll" neutrum  ;
  skoskav_nn_1_N = mkN "skoskav" neutrum  ;
  skorr_nn_1_N = mkN "skorr" neutrum  ;
  skorpmjoel_nn_1_1_N = mkN "skorpmjöl" neutrum  ;
  skolvaesen_nn_1_1_N = mkN "skolväsen" neutrum  ;
  skolk_nn_1_N = mkN "skolk" neutrum  ;
  skogsland_nn_1_N = mkN "skogsland" neutrum  ;
  skogsbryn_nn_1_N = mkN "skogsbryn" neutrum  ;
  skogsbruk_nn_1_N = mkN "skogsbruk" neutrum  ;
  skitsnack_nn_1_N = mkN "skitsnack" neutrum  ;
  skitprat_nn_1_N = mkN "skitprat" neutrum  ;
  skinneri_nn_1_N = mkN "skinneri" neutrum  ;
  skimmer_nn_1_N = mkN "skimmer" neutrum  ;
  skiftesbruk_nn_1_N = mkN "skiftesbruk" neutrum  ;
  skattefusk_nn_1_N = mkN "skattefusk" neutrum  ;
  skattefiffel_nn_1_N = mkN "skattefiffel" neutrum  ;
  skandium_nn_1_N = mkN "skandium" neutrum  ;
  skaller_nn_1_N = mkN "skaller" neutrum  ;
  skadestaandsansvar_nn_1_1_N = mkN "skadeståndsansvar" neutrum  ;
  sjoemanskap_nn_1_1_N = mkN "sjömanskap" neutrum  ;
  sjoegraes_nn_1_1_N = mkN "sjögräs" neutrum  ;
  sjoefylleri_nn_1_1_N = mkN "sjöfylleri" neutrum  ;
  sjoefolk_nn_1_1_N = mkN "sjöfolk" neutrum  ;
  sjoefartsverk_nn_1_1_N = mkN "sjöfartsverk" neutrum  ;
  sjoebefael_nn_1_1_N = mkN "sjöbefäl" neutrum  ;
  sjoeartilleri_nn_1_1_N = mkN "sjöartilleri" neutrum  ;
  sjaa_nn_1_1_N = mkN "sjå" neutrum  ;
  sjaelvsvaald_nn_1_1_N = mkN "självsvåld" neutrum  ;
  sjaelvskryt_nn_1_1_N = mkN "självskryt" neutrum  ;
  sjaelvkostnadspris_nn_1_1_N = mkN "självkostnadspris" neutrum  ;
  sjaelvhushaall_nn_1_1_N = mkN "självhushåll" neutrum  ;
  sjaelvfoersvar_nn_1_1_N = mkN "självförsvar" neutrum  ;
  sjaelvfoerakt_nn_1_1_N = mkN "självförakt" neutrum  ;
  sjaelsliv_nn_1_1_N = mkN "själsliv" neutrum  ;
  sjaelataag_nn_1_1_N = mkN "själatåg" neutrum  ;
  sjuttonhundratal_nn_1_N = mkN "sjuttonhundratal" neutrum  ;
  sjuttital_nn_1_N = mkN "sjuttital" neutrum  ;
  sjuttiotal_nn_1_N = mkN "sjuttiotal" neutrum  ;
  sittflaesk_nn_1_1_N = mkN "sittfläsk" neutrum  ;
  sis_nn_1_N = mkN "sis" neutrum  ;
  sirp_nn_1_N = mkN "sirp" neutrum  ;
  sir_nn_1_N = mkN "sir" neutrum  ;
  sinnestillstaand_nn_1_1_N = mkN "sinnestillstånd" neutrum  ;
  sinneslugn_nn_1_N = mkN "sinneslugn" neutrum  ;
  sinnelag_nn_1_N = mkN "sinnelag" neutrum  ;
  sink_nn_1_N = mkN "sink" neutrum  ;
  simultanschack_nn_1_N = mkN "simultanschack" neutrum  ;
  simpelkort_nn_1_N = mkN "simpelkort" neutrum  ;
  silvernitrat_nn_1_N = mkN "silvernitrat" neutrum  ;
  silverblad_nn_1_N = mkN "silverblad" neutrum  ;
  sillmjoel_nn_1_1_N = mkN "sillmjöl" neutrum  ;
  sillavfall_nn_1_N = mkN "sillavfall" neutrum  ;
  silkespapper_nn_1_N = mkN "silkespapper" neutrum  ;
  silicium_nn_1_N = mkN "silicium" neutrum  ;
  sileshaar_nn_1_1_N = mkN "sileshår" neutrum  ;
  siktmjoel_nn_1_1_N = mkN "siktmjöl" neutrum  ;
  siktdjup_nn_1_N = mkN "siktdjup" neutrum  ;
  signalskydd_nn_1_N = mkN "signalskydd" neutrum  ;
  siffertips_nn_1_N = mkN "siffertips" neutrum  ;
  sidflaesk_nn_1_1_N = mkN "sidfläsk" neutrum  ;
  sidentrae_nn_1_1_N = mkN "sidenträ" neutrum  ;
  siden_nn_1_N = mkN "siden" neutrum  ;
  sexualsystem_nn_1_N = mkN "sexualsystem" neutrum  ;
  sexualliv_nn_1_N = mkN "sexualliv" neutrum  ;
  sextonhundratal_nn_1_N = mkN "sextonhundratal" neutrum  ;
  sextital_nn_1_N = mkN "sextital" neutrum  ;
  sextiotal_nn_1_N = mkN "sextiotal" neutrum  ;
  sexmissbruk_nn_1_N = mkN "sexmissbruk" neutrum  ;
  sex_nn_1_N = mkN "sex" neutrum  ;
  senknarr_nn_1_N = mkN "senknarr" neutrum  ;
  seniorat_nn_1_N = mkN "seniorat" neutrum  ;
  sendrag_nn_1_N = mkN "sendrag" neutrum  ;
  segelgarn_nn_1_N = mkN "segelgarn" neutrum  ;
  sefirgarn_nn_1_N = mkN "sefirgarn" neutrum  ;
  sedefoerfall_nn_1_1_N = mkN "sedeförfall" neutrum  ;
  sedefoerdaerv_nn_1_1_N = mkN "sedefördärv" neutrum  ;
  screentryck_nn_1_N = mkN "screentryck" neutrum  ;
  schaa_nn_1_1_N = mkN "schå" neutrum  ;
  scharlakan_nn_1_N = mkN "scharlakan" neutrum  ;
  schacker_nn_1_N = mkN "schacker" neutrum  ;
  schack_nn_1_N = mkN "schack" neutrum  ;
  schabbelverk_nn_1_N = mkN "schabbelverk" neutrum  ;
  scenuttal_nn_1_N = mkN "scenuttal" neutrum  ;
  sanningsserum_nn_1_N = mkN "sanningsserum" neutrum  ;
  sanitetsporslin_nn_1_N = mkN "sanitetsporslin" neutrum  ;
  sanitetsgods_nn_1_N = mkN "sanitetsgods" neutrum  ;
  sandeltrae_nn_1_1_N = mkN "sandelträ" neutrum  ;
  samvetstvaang_nn_1_1_N = mkN "samvetstvång" neutrum  ;
  samtalsspraak_nn_1_1_N = mkN "samtalsspråk" neutrum  ;
  samspraak_nn_1_1_N = mkN "samspråk" neutrum  ;
  samordningsansvar_nn_1_N = mkN "samordningsansvar" neutrum  ;
  samliv_nn_1_N = mkN "samliv" neutrum  ;
  samhaellsstoed_nn_1_1_N = mkN "samhällsstöd" neutrum  ;
  samhaellsmaskineri_nn_1_1_N = mkN "samhällsmaskineri" neutrum  ;
  samhaellsliv_nn_1_1_N = mkN "samhällsliv" neutrum  ;
  samfoerstaand_nn_1_1_N = mkN "samförstånd" neutrum  ;
  sambruk_nn_1_N = mkN "sambruk" neutrum  ;
  sambovaald_nn_1_1_N = mkN "sambovåld" neutrum  ;
  samarium_nn_1_N = mkN "samarium" neutrum  ;
  saltspad_nn_1_N = mkN "saltspad" neutrum  ;
  salt_nn_1_N = mkN "salt" neutrum  ;
  salicylsyrepulver_nn_1_N = mkN "salicylsyrepulver" neutrum  ;
  saktmod_nn_1_N = mkN "saktmod" neutrum  ;
  saksoekeri_nn_1_1_N = mkN "saksökeri" neutrum  ;
  sakocker_nn_1_N = mkN "sakocker" neutrum  ;
  sakfoerstaand_nn_1_1_N = mkN "sakförstånd" neutrum  ;
  sagoskimmer_nn_1_N = mkN "sagoskimmer" neutrum  ;
  sagomjoel_nn_1_1_N = mkN "sagomjöl" neutrum  ;
  sagg_nn_1_N = mkN "sagg" neutrum  ;
  saftfoder_nn_1_N = mkN "saftfoder" neutrum  ;
  sadeltryck_nn_1_N = mkN "sadeltryck" neutrum  ;
  sabelskrammel_nn_1_N = mkN "sabelskrammel" neutrum  ;
  sabb_nn_1_N = mkN "sabb" neutrum  ;
  roevslickeri_nn_1_1_N = mkN "rövslickeri" neutrum  ;
  roevarspraak_nn_1_1_N = mkN "rövarspråk" neutrum  ;
  roevarliv_nn_1_1_N = mkN "rövarliv" neutrum  ;
  roestskolk_nn_1_1_N = mkN "röstskolk" neutrum  ;
  roersocker_nn_1_1_N = mkN "rörsocker" neutrum  ;
  roellakan_nn_1_1_N = mkN "röllakan" neutrum  ;
  roelakan_nn_1_1_N = mkN "rölakan" neutrum  ;
  roekverk_nn_1_1_N = mkN "rökverk" neutrum  ;
  raattgift_nn_1_1_N = mkN "råttgift" neutrum  ;
  raattfrat_nn_1_1_N = mkN "råttfrat" neutrum  ;
  raasocker_nn_1_1_N = mkN "råsocker" neutrum  ;
  raasiden_nn_1_1_N = mkN "råsiden" neutrum  ;
  raaris_nn_1_1_N = mkN "råris" neutrum  ;
  raaplugg_nn_1_1_N = mkN "råplugg" neutrum  ;
  raagmjoel_nn_1_1_N = mkN "rågmjöl" neutrum  ;
  raaglas_nn_1_1_N = mkN "råglas" neutrum  ;
  raevgift_nn_1_1_N = mkN "rävgift" neutrum  ;
  raettvisepatos_nn_1_1_N = mkN "rättvisepatos" neutrum  ;
  raettsvaesen_nn_1_1_N = mkN "rättsväsen" neutrum  ;
  raettsmedicinalverk_nn_1_1_N = mkN "rättsmedicinalverk" neutrum  ;
  raettshaveri_nn_1_1_N = mkN "rättshaveri" neutrum  ;
  rytteri_nn_1_N = mkN "rytteri" neutrum  ;
  rysslaeder_nn_1_1_N = mkN "ryssläder" neutrum  ;
  rysshat_nn_1_N = mkN "rysshat" neutrum  ;
  rymdskrot_nn_1_N = mkN "rymdskrot" neutrum  ;
  rymdgrus_nn_1_N = mkN "rymdgrus" neutrum  ;
  rutenium_nn_1_N = mkN "rutenium" neutrum  ;
  rusk_nn_1_N = mkN "rusk" neutrum  ;
  runtknulleri_nn_1_N = mkN "runtknulleri" neutrum  ;
  rundsnack_nn_1_N = mkN "rundsnack" neutrum  ;
  rummel_nn_1_N = mkN "rummel" neutrum  ;
  rufs_nn_1_N = mkN "rufs" neutrum  ;
  ruffel_nn_1_N = mkN "ruffel" neutrum  ;
  rubinglas_nn_1_N = mkN "rubinglas" neutrum  ;
  rubidium_nn_1_N = mkN "rubidium" neutrum  ;
  rottryck_nn_1_N = mkN "rottryck" neutrum  ;
  rotmos_nn_1_N = mkN "rotmos" neutrum  ;
  rotenon_nn_1_N = mkN "rotenon" neutrum  ;
  rosentrae_nn_1_1_N = mkN "rosenträ" neutrum  ;
  ros_nn_2_N = mkN "ros" neutrum  ;
  rodium_nn_1_N = mkN "rodium" neutrum  ;
  rivebroed_nn_1_1_N = mkN "rivebröd" neutrum  ;
  riv_nn_1_N = mkN "riv" neutrum  ;
  ritsch_nn_1_N = mkN "ritsch" neutrum  ;
  rispapper_nn_1_N = mkN "rispapper" neutrum  ;
  riskkapital_nn_1_N = mkN "riskkapital" neutrum  ;
  risbraennvin_nn_1_1_N = mkN "risbrännvin" neutrum  ;
  ris_nn_2_N = mkN "ris" neutrum  ;
  ring_nn_2_N = mkN "ring" neutrum  ;
  rindlaeder_nn_1_1_N = mkN "rindläder" neutrum  ;
  rimmeri_nn_1_N = mkN "rimmeri" neutrum  ;
  rikssvaerd_nn_1_1_N = mkN "rikssvärd" neutrum  ;
  riksplan_nn_1_N = mkN "riksplan" neutrum  ;
  riksmaal_nn_1_1_N = mkN "riksmål" neutrum  ;
  ridderskap_nn_1_N = mkN "ridderskap" neutrum  ;
  rhenium_nn_1_N = mkN "rhenium" neutrum  ;
  resgods_nn_1_N = mkN "resgods" neutrum  ;
  reptrick_nn_1_N = mkN "reptrick" neutrum  ;
  representanthus_nn_1_N = mkN "representanthus" neutrum  ;
  renomm_e_nn_1_1_N = mkN "renommé" neutrum  ;
  renkoett_nn_1_1_N = mkN "renkött" neutrum  ;
  realgenus_nn_1_N = mkN "realgenus" neutrum  ;
  rayon_nn_1_N = mkN "rayon" neutrum  ;
  rattfylleri_nn_1_N = mkN "rattfylleri" neutrum  ;
  rassel_nn_1_N = mkN "rassel" neutrum  ;
  rasp_nn_2_N = mkN "rasp" neutrum  ;
  rashat_nn_1_N = mkN "rashat" neutrum  ;
  raseri_nn_1_N = mkN "raseri" neutrum  ;
  rampljus_nn_1_N = mkN "rampljus" neutrum  ;
  rakloedder_nn_1_1_N = mkN "raklödder" neutrum  ;
  rajgraes_nn_1_1_N = mkN "rajgräs" neutrum  ;
  raffel_nn_1_N = mkN "raffel" neutrum  ;
  radium_nn_1_N = mkN "radium" neutrum  ;
  radiokol_nn_1_N = mkN "radiokol" neutrum  ;
  radiobrus_nn_1_N = mkN "radiobrus" neutrum  ;
  rabbel_nn_1_N = mkN "rabbel" neutrum  ;
  rabalder_nn_1_N = mkN "rabalder" neutrum  ;
  paat_nn_1_1_N = mkN "påt" neutrum  ;
  paaskris_nn_1_1_N = mkN "påskris" neutrum  ;
  paaskpyssel_nn_1_1_N = mkN "påskpyssel" neutrum  ;
  paahaeng_nn_1_1_N = mkN "påhäng" neutrum  ;
  paabroed_nn_1_1_N = mkN "påbröd" neutrum  ;
  paabraa_nn_1_1_N = mkN "påbrå" neutrum  ;
  paerlsocker_nn_1_1_N = mkN "pärlsocker" neutrum  ;
  paerlgarn_nn_1_1_N = mkN "pärlgarn" neutrum  ;
  paelsverk_nn_1_1_N = mkN "pälsverk" neutrum  ;
  pyssel_nn_1_N = mkN "pyssel" neutrum  ;
  pynt_nn_1_N = mkN "pynt" neutrum  ;
  pyngel_nn_1_N = mkN "pyngel" neutrum  ;
  putter_nn_1_N = mkN "putter" neutrum  ;
  punktalglas_nn_1_N = mkN "punktalglas" neutrum  ;
  pulsval_nn_1_N = mkN "pulsval" neutrum  ;
  pudersocker_nn_1_N = mkN "pudersocker" neutrum  ;
  puder_nn_1_N = mkN "puder" neutrum  ;
  puckel_nn_2_N = mkN "puckel" neutrum  ;
  publiktryck_nn_1_N = mkN "publiktryck" neutrum  ;
  publikhav_nn_1_N = mkN "publikhav" neutrum  ;
  pubeshaar_nn_1_1_N = mkN "pubeshår" neutrum  ;
  proejs_nn_1_1_N = mkN "pröjs" neutrum  ;
  praal_nn_1_1_N = mkN "prål" neutrum  ;
  praeststaand_nn_1_1_N = mkN "präststånd" neutrum  ;
  praestestaand_nn_1_1_N = mkN "prästestånd" neutrum  ;
  praesterskap_nn_1_1_N = mkN "prästerskap" neutrum  ;
  prygel_nn_1_N = mkN "prygel" neutrum  ;
  pryderi_nn_1_N = mkN "pryderi" neutrum  ;
  prunk_nn_1_N = mkN "prunk" neutrum  ;
  protokoll_nn_2_N = mkN "protokoll" neutrum  ;
  protaktinium_nn_1_N = mkN "protaktinium" neutrum  ;
  prometium_nn_1_N = mkN "prometium" neutrum  ;
  promenadavstaand_nn_1_1_N = mkN "promenadavstånd" neutrum  ;
  proletariat_nn_1_N = mkN "proletariat" neutrum  ;
  progesteron_nn_1_N = mkN "progesteron" neutrum  ;
  profiljaern_nn_1_1_N = mkN "profiljärn" neutrum  ;
  procenteri_nn_1_N = mkN "procenteri" neutrum  ;
  privatliv_nn_1_N = mkN "privatliv" neutrum  ;
  pris_nn_2_N = mkN "pris" neutrum  ;
  primat_nn_1_N = mkN "primat" neutrum  ;
  preusseri_nn_1_N = mkN "preusseri" neutrum  ;
  presstoed_nn_1_1_N = mkN "presstöd" neutrum  ;
  pressglas_nn_1_N = mkN "pressglas" neutrum  ;
  pressfoder_nn_1_N = mkN "pressfoder" neutrum  ;
  presidentmaterial_nn_1_N = mkN "presidentmaterial" neutrum  ;
  prejeri_nn_1_N = mkN "prejeri" neutrum  ;
  pratbehov_nn_1_N = mkN "pratbehov" neutrum  ;
  prassel_nn_1_N = mkN "prassel" neutrum  ;
  praseodym_nn_1_N = mkN "praseodym" neutrum  ;
  potatismos_nn_1_N = mkN "potatismos" neutrum  ;
  potatismjoel_nn_1_1_N = mkN "potatismjöl" neutrum  ;
  potatisbraennvin_nn_1_1_N = mkN "potatisbrännvin" neutrum  ;
  porl_nn_1_N = mkN "porl" neutrum  ;
  polonium_nn_1_N = mkN "polonium" neutrum  ;
  pollen_nn_1_N = mkN "pollen" neutrum  ;
  polkahaar_nn_1_1_N = mkN "polkahår" neutrum  ;
  politikerfoerakt_nn_1_1_N = mkN "politikerförakt" neutrum  ;
  polertrassel_nn_1_N = mkN "polertrassel" neutrum  ;
  polarsken_nn_1_N = mkN "polarsken" neutrum  ;
  pock_nn_1_N = mkN "pock" neutrum  ;
  plaatskrammel_nn_1_1_N = mkN "plåtskrammel" neutrum  ;
  plutonium_nn_1_N = mkN "plutonium" neutrum  ;
  plut_nn_1_N = mkN "plut" neutrum  ;
  plurr_nn_1_N = mkN "plurr" neutrum  ;
  plotter_nn_1_N = mkN "plotter" neutrum  ;
  plommonbraennvin_nn_1_1_N = mkN "plommonbrännvin" neutrum  ;
  plock_nn_1_N = mkN "plock" neutrum  ;
  plit_nn_1_N = mkN "plit" neutrum  ;
  plexiglas_nn_1_N = mkN "plexiglas" neutrum  ;
  plask_nn_1_N = mkN "plask" neutrum  ;
  plantryck_nn_1_N = mkN "plantryck" neutrum  ;
  pladder_nn_1_N = mkN "pladder" neutrum  ;
  pjunk_nn_1_N = mkN "pjunk" neutrum  ;
  pjosk_nn_1_N = mkN "pjosk" neutrum  ;
  pjoller_nn_1_N = mkN "pjoller" neutrum  ;
  piss_nn_1_N = mkN "piss" neutrum  ;
  pisk_nn_1_N = mkN "pisk" neutrum  ;
  pipverk_nn_1_N = mkN "pipverk" neutrum  ;
  pink_nn_1_N = mkN "pink" neutrum  ;
  pingel_nn_1_N = mkN "pingel" neutrum  ;
  pill_nn_1_N = mkN "pill" neutrum  ;
  pilgift_nn_1_N = mkN "pilgift" neutrum  ;
  pet_nn_1_N = mkN "pet" neutrum  ;
  personalbehov_nn_1_N = mkN "personalbehov" neutrum  ;
  personalansvar_nn_1_N = mkN "personalansvar" neutrum  ;
  persiljesmoer_nn_1_1_N = mkN "persiljesmör" neutrum  ;
  perihelium_nn_1_N = mkN "perihelium" neutrum  ;
  perigeum_nn_1_N = mkN "perigeum" neutrum  ;
  pentylpulver_nn_1_N = mkN "pentylpulver" neutrum  ;
  penningvaesen_nn_1_1_N = mkN "penningväsen" neutrum  ;
  penninglotteri_nn_1_N = mkN "penninglotteri" neutrum  ;
  penninggraes_nn_1_1_N = mkN "penninggräs" neutrum  ;
  pengaslarv_nn_1_N = mkN "pengaslarv" neutrum  ;
  penetrationstvaang_nn_1_1_N = mkN "penetrationstvång" neutrum  ;
  peneplan_nn_1_N = mkN "peneplan" neutrum  ;
  pdf_format_nn_1_N = mkN "pdf-format" neutrum  ;
  patriarkskaegg_nn_1_1_N = mkN "patriarkskägg" neutrum  ;
  patrask_nn_1_N = mkN "patrask" neutrum  ;
  patos_nn_1_N = mkN "patos" neutrum  ;
  passtvaang_nn_1_1_N = mkN "passtvång" neutrum  ;
  partistoed_nn_1_1_N = mkN "partistöd" neutrum  ;
  pariserliv_nn_1_N = mkN "pariserliv" neutrum  ;
  parenkym_nn_1_N = mkN "parenkym" neutrum  ;
  parallellaxiom_nn_1_N = mkN "parallellaxiom" neutrum  ;
  pampasgraes_nn_1_1_N = mkN "pampasgräs" neutrum  ;
  palmfett_nn_1_N = mkN "palmfett" neutrum  ;
  palladium_nn_1_N = mkN "palladium" neutrum  ;
  paketgods_nn_1_N = mkN "paketgods" neutrum  ;
  pack_nn_1_N = mkN "pack" neutrum  ;
  oxygen_nn_1_N = mkN "oxygen" neutrum  ;
  oxlaeder_nn_1_1_N = mkN "oxläder" neutrum  ;
  oxkoett_nn_1_1_N = mkN "oxkött" neutrum  ;
  oxblod_nn_1_N = mkN "oxblod" neutrum  ;
  ovaesen_nn_1_1_N = mkN "oväsen" neutrum  ;
  ovett_nn_1_N = mkN "ovett" neutrum  ;
  ovanlaeder_nn_1_1_N = mkN "ovanläder" neutrum  ;
  otyg_nn_1_N = mkN "otyg" neutrum  ;
  otium_nn_1_N = mkN "otium" neutrum  ;
  otack_nn_1_N = mkN "otack" neutrum  ;
  osmium_nn_1_N = mkN "osmium" neutrum  ;
  os_nn_1_N = mkN "os" neutrum  ;
  ormspott_nn_1_N = mkN "ormspott" neutrum  ;
  ormserum_nn_1_N = mkN "ormserum" neutrum  ;
  ormetter_nn_1_N = mkN "ormetter" neutrum  ;
  orlov_nn_1_N = mkN "orlov" neutrum  ;
  ordbajs_nn_1_N = mkN "ordbajs" neutrum  ;
  oralsex_nn_1_N = mkN "oralsex" neutrum  ;
  orakelspraak_nn_1_1_N = mkN "orakelspråk" neutrum  ;
  opris_nn_1_N = mkN "opris" neutrum  ;
  opptag_nn_1_N = mkN "opptag" neutrum  ;
  opium_nn_1_N = mkN "opium" neutrum  ;
  opalglas_nn_1_N = mkN "opalglas" neutrum  ;
  omland_nn_1_N = mkN "omland" neutrum  ;
  omfaang_nn_1_1_N = mkN "omfång" neutrum  ;
  omak_nn_1_N = mkN "omak" neutrum  ;
  oljetyg_nn_1_N = mkN "oljetyg" neutrum  ;
  oljespill_nn_1_N = mkN "oljespill" neutrum  ;
  oljepapper_nn_1_N = mkN "oljepapper" neutrum  ;
  oljekraftfoder_nn_1_N = mkN "oljekraftfoder" neutrum  ;
  oljegrus_nn_1_N = mkN "oljegrus" neutrum  ;
  oktogen_nn_1_N = mkN "oktogen" neutrum  ;
  oknytt_nn_1_N = mkN "oknytt" neutrum  ;
  oidipuskomplex_nn_1_N = mkN "oidipuskomplex" neutrum  ;
  ohaegn_nn_1_1_N = mkN "ohägn" neutrum  ;
  ograes_nn_1_1_N = mkN "ogräs" neutrum  ;
  ofoerstaand_nn_1_1_N = mkN "oförstånd" neutrum  ;
  ofoernuft_nn_1_1_N = mkN "oförnuft" neutrum  ;
  oflyt_nn_1_N = mkN "oflyt" neutrum  ;
  odelsting_nn_1_N = mkN "odelsting" neutrum  ;
  ocker_nn_1_N = mkN "ocker" neutrum  ;
  noetkoett_nn_1_1_N = mkN "nötkött" neutrum  ;
  noethaar_nn_1_1_N = mkN "nöthår" neutrum  ;
  noetfnas_nn_1_1_N = mkN "nötfnas" neutrum  ;
  noejesliv_nn_1_1_N = mkN "nöjesliv" neutrum  ;
  noedtvaang_nn_1_1_N = mkN "nödtvång" neutrum  ;
  naadebroed_nn_1_1_N = mkN "nådebröd" neutrum  ;
  naethat_nn_1_1_N = mkN "näthat" neutrum  ;
  naesblod_nn_1_1_N = mkN "näsblod" neutrum  ;
  naeringsliv_nn_1_1_N = mkN "näringsliv" neutrum  ;
  naerfoersvar_nn_1_1_N = mkN "närförsvar" neutrum  ;
  nyspulver_nn_1_N = mkN "nyspulver" neutrum  ;
  nysilver_nn_1_N = mkN "nysilver" neutrum  ;
  nys_nn_1_N = mkN "nys" neutrum  ;
  nylatin_nn_1_N = mkN "nylatin" neutrum  ;
  nyhetsmakeri_nn_1_N = mkN "nyhetsmakeri" neutrum  ;
  nu_nn_1_N = mkN "nu" neutrum  ;
  novembermoerker_nn_1_1_N = mkN "novembermörker" neutrum  ;
  norrsken_nn_1_N = mkN "norrsken" neutrum  ;
  normaltryck_nn_1_N = mkN "normaltryck" neutrum  ;
  nomadliv_nn_1_N = mkN "nomadliv" neutrum  ;
  nollnolltal_nn_1_N = mkN "nollnolltal" neutrum  ;
  nollnoll_tal_nn_1_N = mkN "nollnoll-tal" neutrum  ;
  nojs_nn_1_N = mkN "nojs" neutrum  ;
  nobelium_nn_1_N = mkN "nobelium" neutrum  ;
  nittonhundraaattiotal_nn_1_1_N = mkN "nittonhundraåttiotal" neutrum  ;
  nittonhundratrettiotal_nn_1_N = mkN "nittonhundratrettiotal" neutrum  ;
  nittonhundratjugotal_nn_1_N = mkN "nittonhundratjugotal" neutrum  ;
  nittonhundratiotal_nn_1_N = mkN "nittonhundratiotal" neutrum  ;
  nittonhundratal_nn_1_N = mkN "nittonhundratal" neutrum  ;
  nittonhundrasjuttiotal_nn_1_N = mkN "nittonhundrasjuttiotal" neutrum  ;
  nittonhundrasextiotal_nn_1_N = mkN "nittonhundrasextiotal" neutrum  ;
  nittonhundranittiotal_nn_1_N = mkN "nittonhundranittiotal" neutrum  ;
  nittonhundrafyrtiotal_nn_1_N = mkN "nittonhundrafyrtiotal" neutrum  ;
  nittonhundrafemtiotal_nn_1_N = mkN "nittonhundrafemtiotal" neutrum  ;
  nittital_nn_1_N = mkN "nittital" neutrum  ;
  nittiotal_nn_1_N = mkN "nittiotal" neutrum  ;
  nitrogen_nn_1_N = mkN "nitrogen" neutrum  ;
  nitrerstaal_nn_1_1_N = mkN "nitrerstål" neutrum  ;
  nit_nn_1_N = mkN "nit" neutrum  ;
  nickelstaal_nn_1_1_N = mkN "nickelstål" neutrum  ;
  nickelkromstaal_nn_1_1_N = mkN "nickelkromstål" neutrum  ;
  neurosedyn_nn_1_N = mkN "neurosedyn" neutrum  ;
  neptunium_nn_1_N = mkN "neptunium" neutrum  ;
  neon_nn_1_N = mkN "neon" neutrum  ;
  negerkorn_nn_1_N = mkN "negerkorn" neutrum  ;
  negerblod_nn_1_N = mkN "negerblod" neutrum  ;
  naturtrae_nn_1_1_N = mkN "naturträ" neutrum  ;
  naturskydd_nn_1_N = mkN "naturskydd" neutrum  ;
  naturliv_nn_1_N = mkN "naturliv" neutrum  ;
  nattsudd_nn_1_N = mkN "nattsudd" neutrum  ;
  nattmoerker_nn_1_1_N = mkN "nattmörker" neutrum  ;
  nattlogi_nn_1_N = mkN "nattlogi" neutrum  ;
  nattliv_nn_1_N = mkN "nattliv" neutrum  ;
  natronglas_nn_1_N = mkN "natronglas" neutrum  ;
  natron_nn_1_N = mkN "natron" neutrum  ;
  natrium_nn_1_N = mkN "natrium" neutrum  ;
  namnblaeck_nn_1_1_N = mkN "namnbläck" neutrum  ;
  namnam_nn_1_N = mkN "namnam" neutrum  ;
  naketmaaleri_nn_1_1_N = mkN "naketmåleri" neutrum  ;
  nageltraang_nn_1_1_N = mkN "nageltrång" neutrum  ;
  nackhaar_nn_1_1_N = mkN "nackhår" neutrum  ;
  nabolag_nn_1_N = mkN "nabolag" neutrum  ;
  moessparti_nn_1_1_N = mkN "mössparti" neutrum  ;
  moegel_nn_1_1_N = mkN "mögel" neutrum  ;
  maansken_nn_1_1_N = mkN "månsken" neutrum  ;
  maanljus_nn_1_1_N = mkN "månljus" neutrum  ;
  maangsyssleri_nn_1_1_N = mkN "mångsyssleri" neutrum  ;
  maangskriveri_nn_1_1_N = mkN "mångskriveri" neutrum  ;
  maangleri_nn_1_1_N = mkN "mångleri" neutrum  ;
  maangguderi_nn_1_1_N = mkN "mångguderi" neutrum  ;
  maaltidstvaang_nn_1_1_N = mkN "måltidstvång" neutrum  ;
  maalbrott_nn_1_1_N = mkN "målbrott" neutrum  ;
  maessingsblaenk_nn_1_1_N = mkN "mässingsblänk" neutrum  ;
  maerkblaeck_nn_1_1_N = mkN "märkbläck" neutrum  ;
  maenniskomaterial_nn_1_1_N = mkN "människomaterial" neutrum  ;
  maenniskofoerakt_nn_1_1_N = mkN "människoförakt" neutrum  ;
  maenniskoblod_nn_1_1_N = mkN "människoblod" neutrum  ;
  myxoedem_nn_1_1_N = mkN "myxödem" neutrum  ;
  myogen_nn_1_N = mkN "myogen" neutrum  ;
  myntvaesen_nn_1_1_N = mkN "myntväsen" neutrum  ;
  myndighetssnack_nn_1_N = mkN "myndighetssnack" neutrum  ;
  myller_nn_1_N = mkN "myller" neutrum  ;
  mygel_nn_1_N = mkN "mygel" neutrum  ;
  musivguld_nn_1_N = mkN "musivguld" neutrum  ;
  murr_nn_1_N = mkN "murr" neutrum  ;
  murbruk_nn_1_N = mkN "murbruk" neutrum  ;
  munklatin_nn_1_N = mkN "munklatin" neutrum  ;
  mummel_nn_1_N = mkN "mummel" neutrum  ;
  muller_nn_1_N = mkN "muller" neutrum  ;
  mudder_nn_1_N = mkN "mudder" neutrum  ;
  moulin_egarn_nn_1_1_N = mkN "moulinégarn" neutrum  ;
  mottryck_nn_1_N = mkN "mottryck" neutrum  ;
  motorbuller_nn_1_N = mkN "motorbuller" neutrum  ;
  motljus_nn_1_N = mkN "motljus" neutrum  ;
  mos_nn_1_N = mkN "mos" neutrum  ;
  morsealfabet_nn_1_N = mkN "morsealfabet" neutrum  ;
  morr_nn_1_N = mkN "morr" neutrum  ;
  morgonhumoer_nn_1_1_N = mkN "morgonhumör" neutrum  ;
  moras_nn_2_N = mkN "moras" neutrum  ;
  monopol_nn_2_N = mkN "monopol" neutrum  ;
  mollskinn_nn_1_N = mkN "mollskinn" neutrum  ;
  moj_nn_1_N = mkN "moj" neutrum  ;
  moderskap_nn_1_N = mkN "moderskap" neutrum  ;
  mod_nn_1_N = mkN "mod" neutrum  ;
  mobilprat_nn_1_N = mkN "mobilprat" neutrum  ;
  mjoelksocker_nn_1_1_N = mkN "mjölksocker" neutrum  ;
  mjoelkglas_nn_1_1_N = mkN "mjölkglas" neutrum  ;
  mjoelkfett_nn_1_1_N = mkN "mjölkfett" neutrum  ;
  mjoeldamm_nn_1_1_N = mkN "mjöldamm" neutrum  ;
  mjoed_nn_1_1_N = mkN "mjöd" neutrum  ;
  mjuklod_nn_1_N = mkN "mjuklod" neutrum  ;
  missmod_nn_1_N = mkN "missmod" neutrum  ;
  misshumoer_nn_1_1_N = mkN "misshumör" neutrum  ;
  misshag_nn_1_N = mkN "misshag" neutrum  ;
  mischmasch_nn_1_N = mkN "mischmasch" neutrum  ;
  minoritetsfoertryck_nn_1_1_N = mkN "minoritetsförtryck" neutrum  ;
  minnesstoed_nn_1_1_N = mkN "minnesstöd" neutrum  ;
  miljoevaern_nn_1_1_N = mkN "miljövärn" neutrum  ;
  migrationsverk_nn_1_N = mkN "migrationsverk" neutrum  ;
  middagsvett_nn_1_N = mkN "middagsvett" neutrum  ;
  meteorstoft_nn_1_N = mkN "meteorstoft" neutrum  ;
  metadon_nn_1_N = mkN "metadon" neutrum  ;
  messmoer_nn_1_1_N = mkN "messmör" neutrum  ;
  mendelevium_nn_1_N = mkN "mendelevium" neutrum  ;
  mellanguld_nn_1_N = mkN "mellanguld" neutrum  ;
  medloeperi_nn_1_1_N = mkN "medlöperi" neutrum  ;
  medieetablissemang_nn_1_N = mkN "medieetablissemang" neutrum  ;
  medhaall_nn_1_1_N = mkN "medhåll" neutrum  ;
  medeltidslatin_nn_1_N = mkN "medeltidslatin" neutrum  ;
  medansvar_nn_1_N = mkN "medansvar" neutrum  ;
  max_nn_1_N = mkN "max" neutrum  ;
  matsvinn_nn_1_N = mkN "matsvinn" neutrum  ;
  matsmoer_nn_1_1_N = mkN "matsmör" neutrum  ;
  matsilver_nn_1_N = mkN "matsilver" neutrum  ;
  matriarkat_nn_1_N = mkN "matriarkat" neutrum  ;
  matos_nn_1_N = mkN "matos" neutrum  ;
  matklet_nn_1_N = mkN "matklet" neutrum  ;
  matavfall_nn_1_N = mkN "matavfall" neutrum  ;
  maskfrat_nn_1_N = mkN "maskfrat" neutrum  ;
  marskland_nn_1_N = mkN "marskland" neutrum  ;
  marknadsgyckel_nn_1_N = mkN "marknadsgyckel" neutrum  ;
  margraes_nn_1_1_N = mkN "margräs" neutrum  ;
  manschettproletariat_nn_1_N = mkN "manschettproletariat" neutrum  ;
  mannamod_nn_1_N = mkN "mannamod" neutrum  ;
  mannagraes_nn_1_1_N = mkN "mannagräs" neutrum  ;
  maltsocker_nn_1_N = mkN "maltsocker" neutrum  ;
  maktspraak_nn_1_1_N = mkN "maktspråk" neutrum  ;
  maktmissbruk_nn_1_N = mkN "maktmissbruk" neutrum  ;
  maktbegaer_nn_1_1_N = mkN "maktbegär" neutrum  ;
  majsmjoel_nn_1_1_N = mkN "majsmjöl" neutrum  ;
  majoritetsfoertryck_nn_1_1_N = mkN "majoritetsförtryck" neutrum  ;
  magnesium_nn_1_N = mkN "magnesium" neutrum  ;
  magknip_nn_1_N = mkN "magknip" neutrum  ;
  mackel_nn_1_N = mkN "mackel" neutrum  ;
  loevtrae_nn_1_1_N = mkN "lövträ" neutrum  ;
  loevsly_nn_1_1_N = mkN "lövsly" neutrum  ;
  loesgodis_nn_1_1_N = mkN "lösgodis" neutrum  ;
  loerdagsgodis_nn_1_1_N = mkN "lördagsgodis" neutrum  ;
  loedder_nn_1_1_N = mkN "lödder" neutrum  ;
  loed_nn_1_1_N = mkN "löd" neutrum  ;
  laangmod_nn_1_1_N = mkN "långmod" neutrum  ;
  laang_av_1_1_A = mkA "lång" "längre" "längst" ;
  laagland_nn_1_1_N = mkN "lågland" neutrum  ;
  laag_av_1_1_A = mkA "låg" "lägre" "lägst" ;
  laettspackel_nn_1_1_N = mkN "lättspackel" neutrum  ;
  laess_nn_1_1_N = mkN "läss" neutrum  ;
  laeskeblask_nn_1_1_N = mkN "läskeblask" neutrum  ;
  laeseri_nn_1_1_N = mkN "läseri" neutrum  ;
  laerktrae_nn_1_1_N = mkN "lärkträ" neutrum  ;
  laerjungaskap_nn_1_1_N = mkN "lärjungaskap" neutrum  ;
  laensvaesen_nn_1_1_N = mkN "länsväsen" neutrum  ;
  laektarvaald_nn_1_1_N = mkN "läktarvåld" neutrum  ;
  laekkoett_nn_1_1_N = mkN "läkkött" neutrum  ;
  laekarslarv_nn_1_1_N = mkN "läkarslarv" neutrum  ;
  laegerliv_nn_1_1_N = mkN "lägerliv" neutrum  ;
  laeder_nn_1_1_N = mkN "läder" neutrum  ;
  ly_nn_1_N = mkN "ly" neutrum  ;
  lutetium_nn_1_N = mkN "lutetium" neutrum  ;
  lungmos_nn_1_N = mkN "lungmos" neutrum  ;
  lumppapper_nn_1_N = mkN "lumppapper" neutrum  ;
  lullull_nn_1_N = mkN "lullull" neutrum  ;
  luktsalt_nn_1_N = mkN "luktsalt" neutrum  ;
  lugn_nn_1_N = mkN "lugn" neutrum  ;
  luftmotstaand_nn_1_1_N = mkN "luftmotstånd" neutrum  ;
  luftfoersvar_nn_1_1_N = mkN "luftförsvar" neutrum  ;
  luffarschack_nn_1_N = mkN "luffarschack" neutrum  ;
  lov_nn_4_N = mkN "lov" neutrum  ;
  lokalfoersvar_nn_1_1_N = mkN "lokalförsvar" neutrum  ;
  loden_nn_1_N = mkN "loden" neutrum  ;
  ljusskimmer_nn_1_N = mkN "ljusskimmer" neutrum  ;
  ljusglitter_nn_1_N = mkN "ljusglitter" neutrum  ;
  ljusdunkel_nn_1_N = mkN "ljusdunkel" neutrum  ;
  ljug_nn_1_N = mkN "ljug" neutrum  ;
  livsmod_nn_1_N = mkN "livsmod" neutrum  ;
  livsmedelsverk_nn_1_N = mkN "livsmedelsverk" neutrum  ;
  livsmedelsavfall_nn_1_N = mkN "livsmedelsavfall" neutrum  ;
  litium_nn_1_N = mkN "litium" neutrum  ;
  lismeri_nn_1_N = mkN "lismeri" neutrum  ;
  lir_nn_1_N = mkN "lir" neutrum  ;
  linjeflyg_nn_1_N = mkN "linjeflyg" neutrum  ;
  lingonris_nn_1_N = mkN "lingonris" neutrum  ;
  lin_nn_1_N = mkN "lin" neutrum  ;
  liggegods_nn_1_N = mkN "liggegods" neutrum  ;
  levnadsvett_nn_1_N = mkN "levnadsvett" neutrum  ;
  levebroed_nn_1_1_N = mkN "levebröd" neutrum  ;
  lergods_nn_1_N = mkN "lergods" neutrum  ;
  lekmannafoerstaand_nn_1_1_N = mkN "lekmannaförstånd" neutrum  ;
  ledarskap_nn_1_N = mkN "ledarskap" neutrum  ;
  laurentium_nn_1_N = mkN "laurentium" neutrum  ;
  latin_nn_1_N = mkN "latin" neutrum  ;
  larv_nn_2_N = mkN "larv" neutrum  ;
  lantsmoer_nn_1_1_N = mkN "lantsmör" neutrum  ;
  lantmannaparti_nn_1_N = mkN "lantmannaparti" neutrum  ;
  land_nn_3_N = mkN "land" neutrum  ;
  lammkoett_nn_1_1_N = mkN "lammkött" neutrum  ;
  lamelltrae_nn_1_1_N = mkN "lamellträ" neutrum  ;
  lafs_nn_1_N = mkN "lafs" neutrum  ;
  koettvilt_nn_1_1_N = mkN "köttvilt" neutrum  ;
  koettklister_nn_1_1_N = mkN "köttklister" neutrum  ;
  koettberg_nn_1_1_N = mkN "köttberg" neutrum  ;
  koettben_nn_2_1_N = mkN "köttben" neutrum  ;
  koett_nn_1_1_N = mkN "kött" neutrum  ;
  koersbaerstrae_nn_1_1_N = mkN "körsbärsträ" neutrum  ;
  koensliv_nn_1_1_N = mkN "könsliv" neutrum  ;
  koenshaar_nn_1_1_N = mkN "könshår" neutrum  ;
  koekslatin_nn_1_1_N = mkN "kökslatin" neutrum  ;
  koeksavfall_nn_1_1_N = mkN "köksavfall" neutrum  ;
  kaalsuperi_nn_1_1_N = mkN "kålsuperi" neutrum  ;
  kaex_nn_2_1_N = mkN "käx" neutrum  ;
  kaernvetemjoel_nn_1_1_N = mkN "kärnvetemjöl" neutrum  ;
  kaernkraftsmotstaand_nn_1_1_N = mkN "kärnkraftsmotstånd" neutrum  ;
  kaernkraftsavfall_nn_1_1_N = mkN "kärnkraftsavfall" neutrum  ;
  kaernbraensleavfall_nn_1_1_N = mkN "kärnbränsleavfall" neutrum  ;
  kaerleksliv_nn_1_1_N = mkN "kärleksliv" neutrum  ;
  kaerleksgnabb_nn_1_1_N = mkN "kärleksgnabb" neutrum  ;
  kaeringprat_nn_1_1_N = mkN "käringprat" neutrum  ;
  kaenslopjunk_nn_1_1_N = mkN "känslopjunk" neutrum  ;
  kaensloliv_nn_1_1_N = mkN "känsloliv" neutrum  ;
  kaendisskap_nn_1_1_N = mkN "kändisskap" neutrum  ;
  kaempahumoer_nn_1_1_N = mkN "kämpahumör" neutrum  ;
  kaelt_nn_1_1_N = mkN "kält" neutrum  ;
  kaek_nn_1_1_N = mkN "käk" neutrum  ;
  kaebbleri_nn_1_1_N = mkN "käbbleri" neutrum  ;
  kaebbel_nn_1_1_N = mkN "käbbel" neutrum  ;
  kyrksilver_nn_1_N = mkN "kyrksilver" neutrum  ;
  kyrkolatin_nn_1_N = mkN "kyrkolatin" neutrum  ;
  kvitter_nn_1_N = mkN "kvitter" neutrum  ;
  kvinnovaald_nn_1_1_N = mkN "kvinnovåld" neutrum  ;
  kvinnospraak_nn_1_1_N = mkN "kvinnospråk" neutrum  ;
  kvinnokoen_nn_1_1_N = mkN "kvinnokön" neutrum  ;
  kvinnohat_nn_1_N = mkN "kvinnohat" neutrum  ;
  kvinnofoertryck_nn_1_1_N = mkN "kvinnoförtryck" neutrum  ;
  kvicksilver_nn_1_N = mkN "kvicksilver" neutrum  ;
  kvickdrag_nn_1_N = mkN "kvickdrag" neutrum  ;
  kvalm_nn_1_N = mkN "kvalm" neutrum  ;
  kutter_nn_1_N = mkN "kutter" neutrum  ;
  kustland_nn_1_N = mkN "kustland" neutrum  ;
  kustklimat_nn_1_N = mkN "kustklimat" neutrum  ;
  kustband_nn_1_N = mkN "kustband" neutrum  ;
  kustartilleri_nn_1_N = mkN "kustartilleri" neutrum  ;
  kurr_nn_1_N = mkN "kurr" neutrum  ;
  kunskapsbegaer_nn_1_1_N = mkN "kunskapsbegär" neutrum  ;
  kulturliv_nn_1_N = mkN "kulturliv" neutrum  ;
  kulturfoerakt_nn_1_1_N = mkN "kulturförakt" neutrum  ;
  kucku_nn_1_N = mkN "kucku" neutrum  ;
  kuckeliku_nn_1_N = mkN "kuckeliku" neutrum  ;
  kuckel_nn_1_N = mkN "kuckel" neutrum  ;
  kubikmaatt_nn_1_1_N = mkN "kubikmått" neutrum  ;
  kroesamos_nn_1_1_N = mkN "krösamos" neutrum  ;
  kroeneri_nn_1_1_N = mkN "kröneri" neutrum  ;
  kraas_nn_1_1_N = mkN "krås" neutrum  ;
  kraangel_nn_1_1_N = mkN "krångel" neutrum  ;
  kraeks_nn_1_1_N = mkN "kräks" neutrum  ;
  kraeftsmoer_nn_1_1_N = mkN "kräftsmör" neutrum  ;
  kryddsalt_nn_1_N = mkN "kryddsalt" neutrum  ;
  krut_nn_1_N = mkN "krut" neutrum  ;
  krus_nn_2_N = mkN "krus" neutrum  ;
  krullhaar_nn_1_1_N = mkN "krullhår" neutrum  ;
  krull_nn_1_N = mkN "krull" neutrum  ;
  krubb_nn_1_N = mkN "krubb" neutrum  ;
  kross_nn_2_N = mkN "kross" neutrum  ;
  kroppsspraak_nn_1_1_N = mkN "kroppsspråk" neutrum  ;
  kroppshaar_nn_1_1_N = mkN "kroppshår" neutrum  ;
  kroppsfoerakt_nn_1_1_N = mkN "kroppsförakt" neutrum  ;
  kromlaeder_nn_1_1_N = mkN "kromläder" neutrum  ;
  krogsorl_nn_1_N = mkN "krogsorl" neutrum  ;
  kringsnack_nn_1_N = mkN "kringsnack" neutrum  ;
  krimskrams_nn_1_N = mkN "krimskrams" neutrum  ;
  krigsvaesen_nn_1_1_N = mkN "krigsväsen" neutrum  ;
  krigskontraband_nn_1_N = mkN "krigskontraband" neutrum  ;
  kreditvaesen_nn_1_1_N = mkN "kreditväsen" neutrum  ;
  kras_nn_1_N = mkN "kras" neutrum  ;
  krams_nn_1_N = mkN "krams" neutrum  ;
  kram_nn_2_N = mkN "kram" neutrum  ;
  kraftspraak_nn_1_1_N = mkN "kraftspråk" neutrum  ;
  kraftpapper_nn_1_N = mkN "kraftpapper" neutrum  ;
  krafs_nn_1_N = mkN "krafs" neutrum  ;
  krabbasnaar_nn_1_1_N = mkN "krabbasnår" neutrum  ;
  korsdrag_nn_1_N = mkN "korsdrag" neutrum  ;
  korridorsnack_nn_1_N = mkN "korridorsnack" neutrum  ;
  kontrollbehov_nn_1_N = mkN "kontrollbehov" neutrum  ;
  kontraband_nn_1_N = mkN "kontraband" neutrum  ;
  kontinentalklimat_nn_1_N = mkN "kontinentalklimat" neutrum  ;
  kontaktbehov_nn_1_N = mkN "kontaktbehov" neutrum  ;
  konsumtionsfrosseri_nn_1_N = mkN "konsumtionsfrosseri" neutrum  ;
  konsum_nn_1_N = mkN "konsum" neutrum  ;
  konstsiden_nn_1_N = mkN "konstsiden" neutrum  ;
  konstnaerskap_nn_1_1_N = mkN "konstnärskap" neutrum  ;
  konstlaeder_nn_1_1_N = mkN "konstläder" neutrum  ;
  konstklotter_nn_1_N = mkN "konstklotter" neutrum  ;
  konstglas_nn_1_N = mkN "konstglas" neutrum  ;
  konsistensfett_nn_1_N = mkN "konsistensfett" neutrum  ;
  konkurrensverk_nn_1_N = mkN "konkurrensverk" neutrum  ;
  komp_nn_1_N = mkN "komp" neutrum  ;
  komissbroed_nn_1_1_N = mkN "komissbröd" neutrum  ;
  komihaag_nn_1_1_N = mkN "komihåg" neutrum  ;
  kolos_nn_1_N = mkN "kolos" neutrum  ;
  kolmoerker_nn_1_1_N = mkN "kolmörker" neutrum  ;
  kolifej_nn_1_N = mkN "kolifej" neutrum  ;
  koksalt_nn_1_N = mkN "koksalt" neutrum  ;
  kokoshaar_nn_1_1_N = mkN "kokoshår" neutrum  ;
  kokosfett_nn_1_N = mkN "kokosfett" neutrum  ;
  kokkoett_nn_1_1_N = mkN "kokkött" neutrum  ;
  knaap_nn_1_1_N = mkN "knåp" neutrum  ;
  knussel_nn_1_N = mkN "knussel" neutrum  ;
  know_how_nn_1_N = mkN "know-how" neutrum  ;
  knotter_nn_1_N = mkN "knotter" neutrum  ;
  knot_nn_2_N = mkN "knot" neutrum  ;
  knorr_nn_2_N = mkN "knorr" neutrum  ;
  knivavstaand_nn_1_1_N = mkN "knivavstånd" neutrum  ;
  knitter_nn_1_N = mkN "knitter" neutrum  ;
  knirr_nn_1_N = mkN "knirr" neutrum  ;
  knirk_nn_1_N = mkN "knirk" neutrum  ;
  knatter_nn_1_N = mkN "knatter" neutrum  ;
  knaster_nn_1_N = mkN "knaster" neutrum  ;
  knarr_nn_1_N = mkN "knarr" neutrum  ;
  knark_nn_1_N = mkN "knark" neutrum  ;
  knallpulver_nn_1_N = mkN "knallpulver" neutrum  ;
  knallkvicksilver_nn_1_N = mkN "knallkvicksilver" neutrum  ;
  knak_nn_1_N = mkN "knak" neutrum  ;
  kloes_nn_1_1_N = mkN "klös" neutrum  ;
  klaaperi_nn_1_1_N = mkN "klåperi" neutrum  ;
  klaemkaeckhet_nn_1_1_N = mkN "klämkäckhet" neutrum  ;
  kludderi_nn_1_N = mkN "kludderi" neutrum  ;
  kludder_nn_1_N = mkN "kludder" neutrum  ;
  kludd_nn_1_N = mkN "kludd" neutrum  ;
  kluck_nn_1_N = mkN "kluck" neutrum  ;
  klotter_nn_1_N = mkN "klotter" neutrum  ;
  klokskap_nn_1_N = mkN "klokskap" neutrum  ;
  klister_nn_1_N = mkN "klister" neutrum  ;
  klirr_nn_1_N = mkN "klirr" neutrum  ;
  klipulver_nn_1_N = mkN "klipulver" neutrum  ;
  klink_nn_2_N = mkN "klink" neutrum  ;
  kling_nn_1_N = mkN "kling" neutrum  ;
  klimatavtryck_nn_1_N = mkN "klimatavtryck" neutrum  ;
  klifs_nn_1_N = mkN "klifs" neutrum  ;
  klibb_nn_1_N = mkN "klibb" neutrum  ;
  kli_nn_1_N = mkN "kli" neutrum  ;
  klet_nn_1_N = mkN "klet" neutrum  ;
  kleresi_nn_1_N = mkN "kleresi" neutrum  ;
  klenmod_nn_1_N = mkN "klenmod" neutrum  ;
  klasstryk_nn_1_N = mkN "klasstryk" neutrum  ;
  klasshat_nn_1_N = mkN "klasshat" neutrum  ;
  klarspraak_nn_1_1_N = mkN "klarspråk" neutrum  ;
  klapper_nn_1_N = mkN "klapper" neutrum  ;
  klank_nn_1_N = mkN "klank" neutrum  ;
  klander_nn_1_N = mkN "klander" neutrum  ;
  klamp_nn_2_N = mkN "klamp" neutrum  ;
  klafs_nn_1_N = mkN "klafs" neutrum  ;
  kladd_nn_2_N = mkN "kladd" neutrum  ;
  klabb_nn_2_N = mkN "klabb" neutrum  ;
  kiv_nn_1_N = mkN "kiv" neutrum  ;
  kitt_nn_1_N = mkN "kitt" neutrum  ;
  kiss_nn_1_N = mkN "kiss" neutrum  ;
  kiseldamm_nn_1_N = mkN "kiseldamm" neutrum  ;
  kink_nn_2_N = mkN "kink" neutrum  ;
  kinaschack_nn_1_N = mkN "kinaschack" neutrum  ;
  kel_nn_1_N = mkN "kel" neutrum  ;
  kaveldun_nn_1_N = mkN "kaveldun" neutrum  ;
  kattsilver_nn_1_N = mkN "kattsilver" neutrum  ;
  kattguld_nn_1_N = mkN "kattguld" neutrum  ;
  kassaklirr_nn_1_N = mkN "kassaklirr" neutrum  ;
  karlsbadersalt_nn_1_N = mkN "karlsbadersalt" neutrum  ;
  kardgarn_nn_1_N = mkN "kardgarn" neutrum  ;
  karborundum_nn_1_N = mkN "karborundum" neutrum  ;
  karbonsystem_nn_1_N = mkN "karbonsystem" neutrum  ;
  kaos_nn_1_N = mkN "kaos" neutrum  ;
  kanslispraak_nn_1_1_N = mkN "kanslispråk" neutrum  ;
  kanslihus_nn_1_N = mkN "kanslihus" neutrum  ;
  kandisocker_nn_1_N = mkN "kandisocker" neutrum  ;
  kanariegraes_nn_1_1_N = mkN "kanariegräs" neutrum  ;
  kamratskap_nn_1_N = mkN "kamratskap" neutrum  ;
  kamgarn_nn_1_N = mkN "kamgarn" neutrum  ;
  kamferliniment_nn_1_N = mkN "kamferliniment" neutrum  ;
  kamelhaar_nn_1_1_N = mkN "kamelhår" neutrum  ;
  kamelgarn_nn_1_N = mkN "kamelgarn" neutrum  ;
  kamaraderi_nn_1_N = mkN "kamaraderi" neutrum  ;
  kalvkoett_nn_1_1_N = mkN "kalvkött" neutrum  ;
  kallprat_nn_1_N = mkN "kallprat" neutrum  ;
  kalkstroe_nn_1_1_N = mkN "kalkströ" neutrum  ;
  kalkonkoett_nn_1_1_N = mkN "kalkonkött" neutrum  ;
  kalkmjoel_nn_1_1_N = mkN "kalkmjöl" neutrum  ;
  kalkljus_nn_1_N = mkN "kalkljus" neutrum  ;
  kaliumpermanganat_nn_1_N = mkN "kaliumpermanganat" neutrum  ;
  kaliumnitrat_nn_1_N = mkN "kaliumnitrat" neutrum  ;
  kaliumkarbonat_nn_1_N = mkN "kaliumkarbonat" neutrum  ;
  kalium_nn_1_N = mkN "kalium" neutrum  ;
  kalciumkarbonat_nn_1_N = mkN "kalciumkarbonat" neutrum  ;
  kalciumfosfat_nn_1_N = mkN "kalciumfosfat" neutrum  ;
  kalcium_nn_1_N = mkN "kalcium" neutrum  ;
  kakaosmoer_nn_1_1_N = mkN "kakaosmör" neutrum  ;
  kakaopulver_nn_1_N = mkN "kakaopulver" neutrum  ;
  kakaofett_nn_1_N = mkN "kakaofett" neutrum  ;
  kafferkorn_nn_1_N = mkN "kafferkorn" neutrum  ;
  kaffedopp_nn_1_N = mkN "kaffedopp" neutrum  ;
  kaffebroed_nn_1_1_N = mkN "kaffebröd" neutrum  ;
  kadmium_nn_1_N = mkN "kadmium" neutrum  ;
  kadettyg_nn_1_N = mkN "kadettyg" neutrum  ;
  kackel_nn_1_N = mkN "kackel" neutrum  ;
  kackalorum_nn_1_N = mkN "kackalorum" neutrum  ;
  kabintryck_nn_1_N = mkN "kabintryck" neutrum  ;
  jaestgrums_nn_1_1_N = mkN "jästgrums" neutrum  ;
  jaesfoder_nn_1_1_N = mkN "jäsfoder" neutrum  ;
  jaernskrot_nn_1_1_N = mkN "järnskrot" neutrum  ;
  jaernpulver_nn_1_1_N = mkN "järnpulver" neutrum  ;
  jaernkitt_nn_1_1_N = mkN "järnkitt" neutrum  ;
  jaemnmod_nn_1_1_N = mkN "jämnmod" neutrum  ;
  jaekt_nn_1_1_N = mkN "jäkt" neutrum  ;
  jungfruvax_nn_1_N = mkN "jungfruvax" neutrum  ;
  jungfrustaand_nn_1_1_N = mkN "jungfrustånd" neutrum  ;
  jungfrulin_nn_1_N = mkN "jungfrulin" neutrum  ;
  juloel_nn_1_1_N = mkN "julöl" neutrum  ;
  julpyssel_nn_1_N = mkN "julpyssel" neutrum  ;
  judehat_nn_1_N = mkN "judehat" neutrum  ;
  judafolk_nn_1_N = mkN "judafolk" neutrum  ;
  jubel_nn_1_N = mkN "jubel" neutrum  ;
  jox_nn_1_N = mkN "jox" neutrum  ;
  jordvax_nn_1_N = mkN "jordvax" neutrum  ;
  jordslag_nn_1_N = mkN "jordslag" neutrum  ;
  jordsken_nn_1_N = mkN "jordsken" neutrum  ;
  jordnoetssmoer_nn_1_1_N = mkN "jordnötssmör" neutrum  ;
  jordklot_nn_1_N = mkN "jordklot" neutrum  ;
  jordeliv_nn_1_N = mkN "jordeliv" neutrum  ;
  jordbeck_nn_1_N = mkN "jordbeck" neutrum  ;
  joller_nn_1_N = mkN "joller" neutrum  ;
  johannesbroed_nn_1_1_N = mkN "johannesbröd" neutrum  ;
  joddel_nn_1_N = mkN "joddel" neutrum  ;
  jidder_nn_1_N = mkN "jidder" neutrum  ;
  jam_nn_1_N = mkN "jam" neutrum  ;
  jaktflyg_nn_1_N = mkN "jaktflyg" neutrum  ;
  isterflott_nn_1_N = mkN "isterflott" neutrum  ;
  ister_nn_1_N = mkN "ister" neutrum  ;
  iridium_nn_1_N = mkN "iridium" neutrum  ;
  invertsocker_nn_1_N = mkN "invertsocker" neutrum  ;
  intraang_nn_1_1_N = mkN "intrång" neutrum  ;
  interferon_nn_1_N = mkN "interferon" neutrum  ;
  integritetsskydd_nn_1_N = mkN "integritetsskydd" neutrum  ;
  instinktliv_nn_1_N = mkN "instinktliv" neutrum  ;
  inrikesflyg_nn_1_N = mkN "inrikesflyg" neutrum  ;
  inresefoerbud_nn_1_1_N = mkN "inreseförbud" neutrum  ;
  inomhusbruk_nn_1_N = mkN "inomhusbruk" neutrum  ;
  innebruk_nn_1_N = mkN "innebruk" neutrum  ;
  inlandsklimat_nn_1_N = mkN "inlandsklimat" neutrum  ;
  inland_nn_1_N = mkN "inland" neutrum  ;
  inkraam_nn_1_1_N = mkN "inkråm" neutrum  ;
  inkafolk_nn_1_N = mkN "inkafolk" neutrum  ;
  ingenmansland_nn_1_N = mkN "ingenmansland" neutrum  ;
  infanteri_nn_1_N = mkN "infanteri" neutrum  ;
  indium_nn_1_N = mkN "indium" neutrum  ;
  indianliv_nn_1_N = mkN "indianliv" neutrum  ;
  indelningsverk_nn_1_N = mkN "indelningsverk" neutrum  ;
  immunfoersvar_nn_1_1_N = mkN "immunförsvar" neutrum  ;
  ilgods_nn_1_N = mkN "ilgods" neutrum  ;
  igelkottsfoersvar_nn_1_1_N = mkN "igelkottsförsvar" neutrum  ;
  ickevaald_nn_1_1_N = mkN "ickevåld" neutrum  ;
  icke_vaald_nn_1_1_N = mkN "icke-våld" neutrum  ;
  hoestrusk_nn_1_1_N = mkN "höstrusk" neutrum  ;
  hoestmoerker_nn_1_1_N = mkN "höstmörker" neutrum  ;
  hoestbruk_nn_1_1_N = mkN "höstbruk" neutrum  ;
  hoegvilt_nn_1_1_N = mkN "högvilt" neutrum  ;
  hoegsommarljus_nn_1_1_N = mkN "högsommarljus" neutrum  ;
  hoegmod_nn_1_1_N = mkN "högmod" neutrum  ;
  hoeg_av_1_1_A = mkA "hög" "högre" "högst" ;
  hoeftmaatt_nn_1_1_N = mkN "höftmått" neutrum  ;
  hoe_nn_1_1_N = mkN "hö" neutrum  ;
  haardlod_nn_1_1_N = mkN "hårdlod" neutrum  ;
  haardbly_nn_1_1_N = mkN "hårdbly" neutrum  ;
  haarburr_nn_1_1_N = mkN "hårburr" neutrum  ;
  haaravfall_nn_1_1_N = mkN "håravfall" neutrum  ;
  haar_nn_1_1_N = mkN "hår" neutrum  ;
  haangel_nn_1_1_N = mkN "hångel" neutrum  ;
  haan_nn_1_1_N = mkN "hån" neutrum  ;
  haaltegel_nn_1_1_N = mkN "håltegel" neutrum  ;
  haestbajs_nn_1_1_N = mkN "hästbajs" neutrum  ;
  haeng_nn_1_1_N = mkN "häng" neutrum  ;
  haemndbegaer_nn_1_1_N = mkN "hämndbegär" neutrum  ;
  haelsotillstaand_nn_1_1_N = mkN "hälsotillstånd" neutrum  ;
  haelsoskydd_nn_1_1_N = mkN "hälsoskydd" neutrum  ;
  haelleberg_nn_1_1_N = mkN "hälleberg" neutrum  ;
  haegn_nn_1_1_N = mkN "hägn" neutrum  ;
  hysch_hysch_nn_1_N = mkN "hysch-hysch" neutrum  ;
  hyckel_nn_1_N = mkN "hyckel" neutrum  ;
  huvudtryck_nn_1_N = mkN "huvudtryck" neutrum  ;
  huvudmannaskap_nn_1_N = mkN "huvudmannaskap" neutrum  ;
  huvudbry_nn_1_N = mkN "huvudbry" neutrum  ;
  huvudansvar_nn_1_N = mkN "huvudansvar" neutrum  ;
  huttleri_nn_1_N = mkN "huttleri" neutrum  ;
  husmansfolk_nn_1_N = mkN "husmansfolk" neutrum  ;
  hushaallspapper_nn_1_1_N = mkN "hushållspapper" neutrum  ;
  husfolk_nn_1_N = mkN "husfolk" neutrum  ;
  husbondfolk_nn_1_N = mkN "husbondfolk" neutrum  ;
  hundliv_nn_1_N = mkN "hundliv" neutrum  ;
  hundbajs_nn_1_N = mkN "hundbajs" neutrum  ;
  hull_nn_1_N = mkN "hull" neutrum  ;
  hornlager_nn_1_N = mkN "hornlager" neutrum  ;
  hormoslyr_nn_1_N = mkN "hormoslyr" neutrum  ;
  hor_nn_1_N = mkN "hor" neutrum  ;
  hopplock_nn_1_N = mkN "hopplock" neutrum  ;
  honkoen_nn_1_1_N = mkN "honkön" neutrum  ;
  homosex_nn_1_N = mkN "homosex" neutrum  ;
  holmium_nn_1_N = mkN "holmium" neutrum  ;
  hokuspokus_nn_1_N = mkN "hokuspokus" neutrum  ;
  hjaertflimmer_nn_1_1_N = mkN "hjärtflimmer" neutrum  ;
  hjaertelag_nn_2_1_N = mkN "hjärtelag" neutrum  ;
  hjaerteblod_nn_1_1_N = mkN "hjärteblod" neutrum  ;
  hjaertblod_nn_1_1_N = mkN "hjärtblod" neutrum  ;
  hjaeltemod_nn_1_1_N = mkN "hjältemod" neutrum  ;
  hjaelmtvaang_nn_1_1_N = mkN "hjälmtvång" neutrum  ;
  hjorthornssalt_nn_1_N = mkN "hjorthornssalt" neutrum  ;
  hittegods_nn_1_N = mkN "hittegods" neutrum  ;
  historiemaaleri_nn_1_1_N = mkN "historiemåleri" neutrum  ;
  himlavalv_nn_1_N = mkN "himlavalv" neutrum  ;
  heterosex_nn_1_N = mkN "heterosex" neutrum  ;
  hemmaliv_nn_1_N = mkN "hemmaliv" neutrum  ;
  hemmabruk_nn_1_N = mkN "hemmabruk" neutrum  ;
  hemliv_nn_1_N = mkN "hemliv" neutrum  ;
  helaar_nn_1_1_N = mkN "helår" neutrum  ;
  helium_nn_1_N = mkN "helium" neutrum  ;
  helikopterbuller_nn_1_N = mkN "helikopterbuller" neutrum  ;
  havssalt_nn_1_N = mkN "havssalt" neutrum  ;
  havsklimat_nn_1_N = mkN "havsklimat" neutrum  ;
  havsglitter_nn_1_N = mkN "havsglitter" neutrum  ;
  havsbryn_nn_1_N = mkN "havsbryn" neutrum  ;
  havsbrus_nn_1_N = mkN "havsbrus" neutrum  ;
  havsband_nn_1_N = mkN "havsband" neutrum  ;
  havremjoel_nn_1_1_N = mkN "havremjöl" neutrum  ;
  hattparti_nn_1_N = mkN "hattparti" neutrum  ;
  hat_nn_1_N = mkN "hat" neutrum  ;
  hankoen_nn_1_1_N = mkN "hankön" neutrum  ;
  handlag_nn_1_N = mkN "handlag" neutrum  ;
  hamburgerkoett_nn_1_1_N = mkN "hamburgerkött" neutrum  ;
  halvsiden_nn_1_N = mkN "halvsiden" neutrum  ;
  halvmoerker_nn_1_1_N = mkN "halvmörker" neutrum  ;
  halvdunkel_nn_1_N = mkN "halvdunkel" neutrum  ;
  hallaa_nn_1_1_N = mkN "hallå" neutrum  ;
  haikuformat_nn_1_N = mkN "haikuformat" neutrum  ;
  hafs_nn_1_N = mkN "hafs" neutrum  ;
  hafnium_nn_1_N = mkN "hafnium" neutrum  ;
  habegaer_nn_1_1_N = mkN "habegär" neutrum  ;
  gaardsfolk_nn_1_1_N = mkN "gårdsfolk" neutrum  ;
  gytter_nn_1_N = mkN "gytter" neutrum  ;
  gyllenlaeder_nn_1_1_N = mkN "gyllenläder" neutrum  ;
  gyckel_nn_1_N = mkN "gyckel" neutrum  ;
  gurkmejpapper_nn_1_N = mkN "gurkmejpapper" neutrum  ;
  gung_nn_1_N = mkN "gung" neutrum  ;
  gullris_nn_1_N = mkN "gullris" neutrum  ;
  gullregn_nn_1_N = mkN "gullregn" neutrum  ;
  guldregn_nn_1_N = mkN "guldregn" neutrum  ;
  groenmoegel_nn_1_1_N = mkN "grönmögel" neutrum  ;
  groengraes_nn_1_1_N = mkN "gröngräs" neutrum  ;
  groenfoder_nn_1_1_N = mkN "grönfoder" neutrum  ;
  graaverk_nn_1_1_N = mkN "gråverk" neutrum  ;
  graapapper_nn_1_1_N = mkN "gråpapper" neutrum  ;
  graadask_nn_1_1_N = mkN "grådask" neutrum  ;
  graaberg_nn_1_1_N = mkN "gråberg" neutrum  ;
  graeddvisp_nn_2_1_N = mkN "gräddvisp" neutrum  ;
  gryningsljus_nn_1_N = mkN "gryningsljus" neutrum  ;
  grymt_nn_1_N = mkN "grymt" neutrum  ;
  gry_nn_1_N = mkN "gry" neutrum  ;
  grus_nn_1_N = mkN "grus" neutrum  ;
  grupptryck_nn_1_N = mkN "grupptryck" neutrum  ;
  gruppsex_nn_1_N = mkN "gruppsex" neutrum  ;
  grundkapital_nn_1_N = mkN "grundkapital" neutrum  ;
  grums_nn_1_N = mkN "grums" neutrum  ;
  grummel_nn_1_N = mkN "grummel" neutrum  ;
  grubbel_nn_1_N = mkN "grubbel" neutrum  ;
  grovspackel_nn_1_N = mkN "grovspackel" neutrum  ;
  grovsalt_nn_1_N = mkN "grovsalt" neutrum  ;
  grovfoder_nn_1_N = mkN "grovfoder" neutrum  ;
  grov_av_1_A = mkA "grov" "grövre" "grövst" ;
  groll_nn_1_N = mkN "groll" neutrum  ;
  grodspott_nn_1_N = mkN "grodspott" neutrum  ;
  grodperspektiv_nn_1_N = mkN "grodperspektiv" neutrum  ;
  grenverk_nn_1_N = mkN "grenverk" neutrum  ;
  grejs_nn_1_N = mkN "grejs" neutrum  ;
  gravgods_nn_1_N = mkN "gravgods" neutrum  ;
  gravallvar_nn_1_N = mkN "gravallvar" neutrum  ;
  granulom_nn_1_N = mkN "granulom" neutrum  ;
  granpollen_nn_1_N = mkN "granpollen" neutrum  ;
  grannelag_nn_1_N = mkN "grannelag" neutrum  ;
  grann_nn_1_N = mkN "grann" neutrum  ;
  grand_nn_1_N = mkN "grand" neutrum  ;
  grahamsmjoel_nn_1_1_N = mkN "grahamsmjöl" neutrum  ;
  gottis_nn_1_N = mkN "gottis" neutrum  ;
  gorr_nn_1_N = mkN "gorr" neutrum  ;
  golvdrag_nn_1_N = mkN "golvdrag" neutrum  ;
  godis_nn_1_N = mkN "godis" neutrum  ;
  godemanskap_nn_1_N = mkN "godemanskap" neutrum  ;
  gnoel_nn_1_1_N = mkN "gnöl" neutrum  ;
  gnaell_nn_1_1_N = mkN "gnäll" neutrum  ;
  gnaegg_nn_1_1_N = mkN "gnägg" neutrum  ;
  gny_nn_1_N = mkN "gny" neutrum  ;
  gnistregn_nn_1_N = mkN "gnistregn" neutrum  ;
  gnissel_nn_1_N = mkN "gnissel" neutrum  ;
  gnideri_nn_1_N = mkN "gnideri" neutrum  ;
  gnat_nn_1_N = mkN "gnat" neutrum  ;
  gnag_nn_1_N = mkN "gnag" neutrum  ;
  gloedljus_nn_1_1_N = mkN "glödljus" neutrum  ;
  glaefs_nn_1_1_N = mkN "gläfs" neutrum  ;
  glykogen_nn_1_N = mkN "glykogen" neutrum  ;
  glycerylnitrat_nn_1_N = mkN "glycerylnitrat" neutrum  ;
  gluten_nn_1_N = mkN "gluten" neutrum  ;
  glopp_nn_1_N = mkN "glopp" neutrum  ;
  glittertryck_nn_1_N = mkN "glittertryck" neutrum  ;
  glitter_nn_1_N = mkN "glitter" neutrum  ;
  glimmer_nn_2_N = mkN "glimmer" neutrum  ;
  glimljus_nn_1_N = mkN "glimljus" neutrum  ;
  glaukom_nn_1_N = mkN "glaukom" neutrum  ;
  glaubersalt_nn_1_N = mkN "glaubersalt" neutrum  ;
  glasmaaleri_nn_1_1_N = mkN "glasmåleri" neutrum  ;
  glanssot_nn_1_N = mkN "glanssot" neutrum  ;
  gjutstaal_nn_1_1_N = mkN "gjutstål" neutrum  ;
  gjutjaern_nn_1_1_N = mkN "gjutjärn" neutrum  ;
  gjutgods_nn_1_N = mkN "gjutgods" neutrum  ;
  gipsmurbruk_nn_1_N = mkN "gipsmurbruk" neutrum  ;
  gipsbruk_nn_1_N = mkN "gipsbruk" neutrum  ;
  germanium_nn_1_N = mkN "germanium" neutrum  ;
  gepaeck_nn_1_1_N = mkN "gepäck" neutrum  ;
  gentlemannablod_nn_1_N = mkN "gentlemannablod" neutrum  ;
  gensvar_nn_1_N = mkN "gensvar" neutrum  ;
  genljud_nn_1_N = mkN "genljud" neutrum  ;
  generalitet_nn_1_N = mkN "generalitet" neutrum  ;
  gendarmeri_nn_1_N = mkN "gendarmeri" neutrum  ;
  gehoer_nn_1_1_N = mkN "gehör" neutrum  ;
  gatuvaald_nn_1_1_N = mkN "gatuvåld" neutrum  ;
  gatuvimmel_nn_1_N = mkN "gatuvimmel" neutrum  ;
  gass_nn_1_N = mkN "gass" neutrum  ;
  gap_nn_2_N = mkN "gap" neutrum  ;
  galoschbett_nn_1_N = mkN "galoschbett" neutrum  ;
  gallium_nn_1_N = mkN "gallium" neutrum  ;
  galej_nn_1_N = mkN "galej" neutrum  ;
  gagn_nn_1_N = mkN "gagn" neutrum  ;
  gagg_nn_1_N = mkN "gagg" neutrum  ;
  gadolinium_nn_1_N = mkN "gadolinium" neutrum  ;
  foeraeldraskap_nn_1_1_N = mkN "föräldraskap" neutrum  ;
  foeraeldraansvar_nn_1_1_N = mkN "föräldraansvar" neutrum  ;
  foervaervsliv_nn_1_1_N = mkN "förvärvsliv" neutrum  ;
  foervar_nn_1_1_N = mkN "förvar" neutrum  ;
  foervaltarskap_nn_1_1_N = mkN "förvaltarskap" neutrum  ;
  foertryck_nn_1_1_N = mkN "förtryck" neutrum  ;
  foertal_nn_1_1_N = mkN "förtal" neutrum  ;
  foersoerjningsstoed_nn_1_1_N = mkN "försörjningsstöd" neutrum  ;
  foersvarsvaesen_nn_1_1_N = mkN "försvarsväsen" neutrum  ;
  foersvar_nn_1_1_N = mkN "försvar" neutrum  ;
  foerstaand_nn_1_1_N = mkN "förstånd" neutrum  ;
  foerspraang_nn_1_1_N = mkN "försprång" neutrum  ;
  foersamlingsliv_nn_1_1_N = mkN "församlingsliv" neutrum  ;
  foernaem_av_1_1_A = mkA "förnäm" "förnämare" "förnämst" ;
  foernuft_nn_1_1_N = mkN "förnuft" neutrum  ;
  foermynderskap_nn_1_1_N = mkN "förmynderskap" neutrum  ;
  foermynderi_nn_1_1_N = mkN "förmynderi" neutrum  ;
  foermaksflimmer_nn_1_1_N = mkN "förmaksflimmer" neutrum  ;
  foerfattarskap_nn_1_1_N = mkN "författarskap" neutrum  ;
  foerfall_nn_1_1_N = mkN "förfall" neutrum  ;
  foereningsliv_nn_1_1_N = mkN "föreningsliv" neutrum  ;
  foerdaerv_nn_1_1_N = mkN "fördärv" neutrum  ;
  foerakt_nn_1_1_N = mkN "förakt" neutrum  ;
  faarsex_nn_1_1_N = mkN "fårsex" neutrum  ;
  faarkoett_nn_1_1_N = mkN "fårkött" neutrum  ;
  faagelkvitter_nn_1_1_N = mkN "fågelkvitter" neutrum  ;
  faestfolk_nn_1_1_N = mkN "fästfolk" neutrum  ;
  faeltartilleri_nn_1_1_N = mkN "fältartilleri" neutrum  ;
  fyrvaesen_nn_1_1_N = mkN "fyrväsen" neutrum  ;
  fyrtital_nn_1_N = mkN "fyrtital" neutrum  ;
  fyrtiotal_nn_1_N = mkN "fyrtiotal" neutrum  ;
  fylleri_nn_1_N = mkN "fylleri" neutrum  ;
  fuskeri_nn_1_N = mkN "fuskeri" neutrum  ;
  fusk_nn_1_N = mkN "fusk" neutrum  ;
  furutrae_nn_1_1_N = mkN "furuträ" neutrum  ;
  furan_nn_1_N = mkN "furan" neutrum  ;
  fullkornsmjoel_nn_1_1_N = mkN "fullkornsmjöl" neutrum  ;
  fullkorn_nn_1_N = mkN "fullkorn" neutrum  ;
  fubb_nn_1_N = mkN "fubb" neutrum  ;
  froemjoel_nn_1_1_N = mkN "frömjöl" neutrum  ;
  fraes_nn_2_1_N = mkN "fräs" neutrum  ;
  fraemlingskap_nn_1_1_N = mkN "främlingskap" neutrum  ;
  fraemlingshat_nn_1_1_N = mkN "främlingshat" neutrum  ;
  fruktsocker_nn_1_N = mkN "fruktsocker" neutrum  ;
  fruktsalt_nn_1_N = mkN "fruktsalt" neutrum  ;
  fruktkoett_nn_1_1_N = mkN "fruktkött" neutrum  ;
  frosseri_nn_1_N = mkN "frosseri" neutrum  ;
  fromleri_nn_1_N = mkN "fromleri" neutrum  ;
  fritaenkeri_nn_1_1_N = mkN "fritänkeri" neutrum  ;
  friteringsfett_nn_1_N = mkN "friteringsfett" neutrum  ;
  frimureri_nn_1_N = mkN "frimureri" neutrum  ;
  friluftsliv_nn_1_N = mkN "friluftsliv" neutrum  ;
  friluftshaall_nn_1_1_N = mkN "friluftshåll" neutrum  ;
  frihetsbegaer_nn_1_1_N = mkN "frihetsbegär" neutrum  ;
  frat_nn_1_N = mkN "frat" neutrum  ;
  fras_nn_2_N = mkN "fras" neutrum  ;
  francium_nn_1_N = mkN "francium" neutrum  ;
  fraktgods_nn_1_N = mkN "fraktgods" neutrum  ;
  fotfolk_nn_1_N = mkN "fotfolk" neutrum  ;
  fortsaettningskrig_nn_1_1_N = mkN "fortsättningskrig" neutrum  ;
  fortbestaand_nn_1_1_N = mkN "fortbestånd" neutrum  ;
  forstvaesen_nn_1_1_N = mkN "forstväsen" neutrum  ;
  fornyrdislag_nn_1_N = mkN "fornyrdislag" neutrum  ;
  formgods_nn_1_N = mkN "formgods" neutrum  ;
  fondmaekleri_nn_1_1_N = mkN "fondmäkleri" neutrum  ;
  folkvimmel_nn_1_N = mkN "folkvimmel" neutrum  ;
  folkvett_nn_1_N = mkN "folkvett" neutrum  ;
  folkliv_nn_1_N = mkN "folkliv" neutrum  ;
  folkfoerakt_nn_1_1_N = mkN "folkförakt" neutrum  ;
  fnitter_nn_1_N = mkN "fnitter" neutrum  ;
  fnas_nn_1_N = mkN "fnas" neutrum  ;
  flaaspatos_nn_1_1_N = mkN "flåspatos" neutrum  ;
  flaas_nn_1_1_N = mkN "flås" neutrum  ;
  flaeskkoett_nn_1_1_N = mkN "fläskkött" neutrum  ;
  flaesk_nn_1_1_N = mkN "fläsk" neutrum  ;
  flaeng_nn_1_1_N = mkN "fläng" neutrum  ;
  flyttningsfoerbud_nn_1_1_N = mkN "flyttningsförbud" neutrum  ;
  flyt_nn_1_N = mkN "flyt" neutrum  ;
  flyg_nn_2_N = mkN "flyg" neutrum  ;
  flussglas_nn_1_N = mkN "flussglas" neutrum  ;
  flott_nn_1_N = mkN "flott" neutrum  ;
  florsocker_nn_1_N = mkN "florsocker" neutrum  ;
  flock_nn_2_N = mkN "flock" neutrum  ;
  floatglas_nn_1_N = mkN "floatglas" neutrum  ;
  flintgods_nn_1_N = mkN "flintgods" neutrum  ;
  flimmer_nn_1_N = mkN "flimmer" neutrum  ;
  flertal_nn_1_N = mkN "flertal" neutrum  ;
  flax_nn_2_N = mkN "flax" neutrum  ;
  flams_nn_1_N = mkN "flams" neutrum  ;
  fladder_nn_1_N = mkN "fladder" neutrum  ;
  fjaesk_nn_1_1_N = mkN "fjäsk" neutrum  ;
  fjaederstaal_nn_1_1_N = mkN "fjäderstål" neutrum  ;
  fjaedergraes_nn_1_1_N = mkN "fjädergräs" neutrum  ;
  fjortonhundratal_nn_1_N = mkN "fjortonhundratal" neutrum  ;
  fjant_nn_2_N = mkN "fjant" neutrum  ;
  fiskrens_nn_1_N = mkN "fiskrens" neutrum  ;
  fiskmjoel_nn_1_1_N = mkN "fiskmjöl" neutrum  ;
  fisklir_nn_1_N = mkN "fisklir" neutrum  ;
  firmament_nn_1_N = mkN "firmament" neutrum  ;
  finspackel_nn_1_N = mkN "finspackel" neutrum  ;
  fingerblaeck_nn_1_1_N = mkN "fingerbläck" neutrum  ;
  fiffel_nn_1_N = mkN "fiffel" neutrum  ;
  ferrum_nn_1_N = mkN "ferrum" neutrum  ;
  fermium_nn_1_N = mkN "fermium" neutrum  ;
  feodalvaesen_nn_1_1_N = mkN "feodalväsen" neutrum  ;
  femtontal_nn_1_N = mkN "femtontal" neutrum  ;
  femtonhundratal_nn_1_N = mkN "femtonhundratal" neutrum  ;
  feministtjafs_nn_1_N = mkN "feministtjafs" neutrum  ;
  felfinneri_nn_1_N = mkN "felfinneri" neutrum  ;
  fel_nn_2_N = mkN "fel" neutrum  ;
  fatoel_nn_1_1_N = mkN "fatöl" neutrum  ;
  fattigunderstoed_nn_1_1_N = mkN "fattigunderstöd" neutrum  ;
  fastlandsklimat_nn_1_N = mkN "fastlandsklimat" neutrum  ;
  fastland_nn_1_N = mkN "fastland" neutrum  ;
  farinsocker_nn_1_N = mkN "farinsocker" neutrum  ;
  faderskap_nn_1_N = mkN "faderskap" neutrum  ;
  fackelsken_nn_1_N = mkN "fackelsken" neutrum  ;
  exportoel_nn_1_1_N = mkN "exportöl" neutrum  ;
  exportfoerbud_nn_1_1_N = mkN "exportförbud" neutrum  ;
  etyn_nn_1_N = mkN "etyn" neutrum  ;
  etter_nn_1_N = mkN "etter" neutrum  ;
  etappvaesen_nn_1_1_N = mkN "etappväsen" neutrum  ;
  espartograes_nn_1_1_N = mkN "espartogräs" neutrum  ;
  ersaettningsansvar_nn_1_1_N = mkN "ersättningsansvar" neutrum  ;
  eremitliv_nn_1_N = mkN "eremitliv" neutrum  ;
  erbium_nn_1_N = mkN "erbium" neutrum  ;
  epigoneri_nn_1_N = mkN "epigoneri" neutrum  ;
  enspann_nn_1_N = mkN "enspann" neutrum  ;
  enkorn_nn_1_N = mkN "enkorn" neutrum  ;
  emsersalt_nn_1_N = mkN "emsersalt" neutrum  ;
  emaljglas_nn_1_N = mkN "emaljglas" neutrum  ;
  elvahundratal_nn_1_N = mkN "elvahundratal" neutrum  ;
  elskrot_nn_1_N = mkN "elskrot" neutrum  ;
  elljus_nn_1_N = mkN "elljus" neutrum  ;
  elfenbenspapper_nn_1_N = mkN "elfenbenspapper" neutrum  ;
  elfenben_nn_1_N = mkN "elfenben" neutrum  ;
  elektrostaal_nn_1_1_N = mkN "elektrostål" neutrum  ;
  elektron_nn_2_N = mkN "elektron" neutrum  ;
  elefantgraes_nn_1_1_N = mkN "elefantgräs" neutrum  ;
  eldunderstoed_nn_1_1_N = mkN "eldunderstöd" neutrum  ;
  eldskydd_nn_1_N = mkN "eldskydd" neutrum  ;
  eldhav_nn_1_N = mkN "eldhav" neutrum  ;
  ektoderm_nn_1_N = mkN "ektoderm" neutrum  ;
  ekorrhjul_nn_1_N = mkN "ekorrhjul" neutrum  ;
  einsteinium_nn_1_N = mkN "einsteinium" neutrum  ;
  egendomsfolk_nn_1_N = mkN "egendomsfolk" neutrum  ;
  eftertrav_nn_1_N = mkN "eftertrav" neutrum  ;
  eftersoek_nn_1_1_N = mkN "eftersök" neutrum  ;
  eftersnack_nn_1_N = mkN "eftersnack" neutrum  ;
  efterplock_nn_1_N = mkN "efterplock" neutrum  ;
  efterlevandeskydd_nn_1_N = mkN "efterlevandeskydd" neutrum  ;
  effektgarn_nn_1_N = mkN "effektgarn" neutrum  ;
  edsansvar_nn_1_N = mkN "edsansvar" neutrum  ;
  doesnack_nn_1_1_N = mkN "dösnack" neutrum  ;
  doen_nn_1_1_N = mkN "dön" neutrum  ;
  doedsfoerakt_nn_1_1_N = mkN "dödsförakt" neutrum  ;
  doedkoett_nn_1_1_N = mkN "dödkött" neutrum  ;
  daas_nn_1_1_N = mkN "dås" neutrum  ;
  daeng_nn_1_1_N = mkN "däng" neutrum  ;
  dysprosium_nn_1_N = mkN "dysprosium" neutrum  ;
  dykeri_nn_1_N = mkN "dykeri" neutrum  ;
  dusk_nn_1_N = mkN "dusk" neutrum  ;
  duraluminium_nn_1_N = mkN "duraluminium" neutrum  ;
  duodesformat_nn_1_N = mkN "duodesformat" neutrum  ;
  dunkel_nn_1_N = mkN "dunkel" neutrum  ;
  dunk_nn_2_N = mkN "dunk" neutrum  ;
  dubbfoerbud_nn_1_1_N = mkN "dubbförbud" neutrum  ;
  dubbelliv_nn_1_N = mkN "dubbelliv" neutrum  ;
  dubbdaecksfoerbud_nn_1_1_N = mkN "dubbdäcksförbud" neutrum  ;
  droenarliv_nn_1_1_N = mkN "drönarliv" neutrum  ;
  druvsocker_nn_1_N = mkN "druvsocker" neutrum  ;
  dropp_nn_1_N = mkN "dropp" neutrum  ;
  drogsug_nn_1_N = mkN "drogsug" neutrum  ;
  drivhusklimat_nn_1_N = mkN "drivhusklimat" neutrum  ;
  driveri_nn_1_N = mkN "driveri" neutrum  ;
  driftvaern_nn_1_1_N = mkN "driftvärn" neutrum  ;
  driftliv_nn_1_N = mkN "driftliv" neutrum  ;
  drev_nn_2_N = mkN "drev" neutrum  ;
  dravel_nn_1_N = mkN "dravel" neutrum  ;
  drakblod_nn_1_N = mkN "drakblod" neutrum  ;
  drag_nn_2_N = mkN "drag" neutrum  ;
  dotterskap_nn_1_N = mkN "dotterskap" neutrum  ;
  dopp_nn_2_N = mkN "dopp" neutrum  ;
  donk_nn_1_N = mkN "donk" neutrum  ;
  dokumentpapper_nn_1_N = mkN "dokumentpapper" neutrum  ;
  dobbel_nn_1_N = mkN "dobbel" neutrum  ;
  djurskydd_nn_1_N = mkN "djurskydd" neutrum  ;
  djurplaageri_nn_1_1_N = mkN "djurplågeri" neutrum  ;
  djurliv_nn_1_N = mkN "djurliv" neutrum  ;
  djurfoerbud_nn_1_1_N = mkN "djurförbud" neutrum  ;
  djuphav_nn_1_N = mkN "djuphav" neutrum  ;
  dis_nn_1_N = mkN "dis" neutrum  ;
  direktflyg_nn_1_N = mkN "direktflyg" neutrum  ;
  dipsan_nn_1_N = mkN "dipsan" neutrum  ;
  dingeldangel_nn_1_N = mkN "dingeldangel" neutrum  ;
  dillkoett_nn_1_1_N = mkN "dillkött" neutrum  ;
  dilettanteri_nn_1_N = mkN "dilettanteri" neutrum  ;
  deuterium_nn_1_N = mkN "deuterium" neutrum  ;
  desengagemang_nn_1_N = mkN "desengagemang" neutrum  ;
  depaastoed_nn_1_1_N = mkN "depåstöd" neutrum  ;
  deplacement_nn_1_N = mkN "deplacement" neutrum  ;
  dekorum_nn_1_N = mkN "dekorum" neutrum  ;
  dasspapper_nn_1_N = mkN "dasspapper" neutrum  ;
  dask_nn_1_N = mkN "dask" neutrum  ;
  darrgraes_nn_1_1_N = mkN "darrgräs" neutrum  ;
  darr_nn_1_N = mkN "darr" neutrum  ;
  dansvimmel_nn_1_N = mkN "dansvimmel" neutrum  ;
  danskhat_nn_1_N = mkN "danskhat" neutrum  ;
  dansfoerbud_nn_1_1_N = mkN "dansförbud" neutrum  ;
  damm_nn_2_N = mkN "damm" neutrum  ;
  damaskenerstaal_nn_1_1_N = mkN "damaskenerstål" neutrum  ;
  dalt_nn_1_N = mkN "dalt" neutrum  ;
  dallergraes_nn_1_1_N = mkN "dallergräs" neutrum  ;
  daller_nn_1_N = mkN "daller" neutrum  ;
  dalj_nn_1_N = mkN "dalj" neutrum  ;
  dagslaendeliv_nn_1_1_N = mkN "dagsländeliv" neutrum  ;
  dagsljus_nn_1_N = mkN "dagsljus" neutrum  ;
  dagdriveri_nn_1_N = mkN "dagdriveri" neutrum  ;
  dagdrivarliv_nn_1_N = mkN "dagdrivarliv" neutrum  ;
  cylinderglas_nn_1_N = mkN "cylinderglas" neutrum  ;
  cybersex_nn_1_N = mkN "cybersex" neutrum  ;
  cyankalium_nn_1_N = mkN "cyankalium" neutrum  ;
  curium_nn_1_N = mkN "curium" neutrum  ;
  civilmotstaand_nn_1_1_N = mkN "civilmotstånd" neutrum  ;
  civilfoersvar_nn_1_1_N = mkN "civilförsvar" neutrum  ;
  civilflyg_nn_1_N = mkN "civilflyg" neutrum  ;
  cityliv_nn_1_N = mkN "cityliv" neutrum  ;
  citrat_nn_1_N = mkN "citrat" neutrum  ;
  chipssug_nn_1_N = mkN "chipssug" neutrum  ;
  chefsskap_nn_1_N = mkN "chefsskap" neutrum  ;
  chefskap_nn_1_N = mkN "chefskap" neutrum  ;
  charpi_nn_1_N = mkN "charpi" neutrum  ;
  cesium_nn_1_N = mkN "cesium" neutrum  ;
  cerium_nn_1_N = mkN "cerium" neutrum  ;
  centralfoersvar_nn_1_1_N = mkN "centralförsvar" neutrum  ;
  cedrat_nn_1_N = mkN "cedrat" neutrum  ;
  californium_nn_1_N = mkN "californium" neutrum  ;
  boel_nn_1_1_N = mkN "böl" neutrum  ;
  boek_nn_1_1_N = mkN "bök" neutrum  ;
  boejtrae_nn_1_1_N = mkN "böjträ" neutrum  ;
  baagljus_nn_1_1_N = mkN "bågljus" neutrum  ;
  baag_nn_1_1_N = mkN "båg" neutrum  ;
  baersaerkaraseri_nn_1_1_N = mkN "bärsärkaraseri" neutrum  ;
  baergningsvaeder_nn_1_1_N = mkN "bärgningsväder" neutrum  ;
  byggdamm_nn_1_N = mkN "byggdamm" neutrum  ;
  buteljlack_nn_1_N = mkN "buteljlack" neutrum  ;
  buteljglas_nn_1_N = mkN "buteljglas" neutrum  ;
  butadien_nn_1_N = mkN "butadien" neutrum  ;
  busliv_nn_1_N = mkN "busliv" neutrum  ;
  bus_nn_1_N = mkN "bus" neutrum  ;
  burskap_nn_1_N = mkN "burskap" neutrum  ;
  burkafoerbud_nn_1_1_N = mkN "burkaförbud" neutrum  ;
  bunkstaal_nn_1_1_N = mkN "bunkstål" neutrum  ;
  buljongkoett_nn_1_1_N = mkN "buljongkött" neutrum  ;
  buktaleri_nn_1_N = mkN "buktaleri" neutrum  ;
  bukfett_nn_1_N = mkN "bukfett" neutrum  ;
  bubbel_nn_1_N = mkN "bubbel" neutrum  ;
  broestsocker_nn_1_1_N = mkN "bröstsocker" neutrum  ;
  braennstaal_nn_1_1_N = mkN "brännstål" neutrum  ;
  braeck_nn_1_1_N = mkN "bräck" neutrum  ;
  bry_nn_1_N = mkN "bry" neutrum  ;
  brus_nn_1_N = mkN "brus" neutrum  ;
  brudbroed_nn_1_1_N = mkN "brudbröd" neutrum  ;
  bromural_nn_1_N = mkN "bromural" neutrum  ;
  brodergarn_nn_1_N = mkN "brodergarn" neutrum  ;
  briljantglas_nn_1_N = mkN "briljantglas" neutrum  ;
  braxengraes_nn_1_1_N = mkN "braxengräs" neutrum  ;
  brass_nn_1_N = mkN "brass" neutrum  ;
  brandvaesen_nn_1_1_N = mkN "brandväsen" neutrum  ;
  brandskydd_nn_1_N = mkN "brandskydd" neutrum  ;
  brandmansgrepp_nn_1_N = mkN "brandmansgrepp" neutrum  ;
  brandfoersvar_nn_1_1_N = mkN "brandförsvar" neutrum  ;
  brak_nn_1_N = mkN "brak" neutrum  ;
  box_nn_2_N = mkN "box" neutrum  ;
  botulin_nn_1_N = mkN "botulin" neutrum  ;
  bottentryck_nn_1_N = mkN "bottentryck" neutrum  ;
  bottenskrap_nn_1_N = mkN "bottenskrap" neutrum  ;
  bostadsbestaand_nn_1_1_N = mkN "bostadsbestånd" neutrum  ;
  boss_nn_2_N = mkN "boss" neutrum  ;
  bosch_nn_1_N = mkN "bosch" neutrum  ;
  borgarstaand_nn_1_1_N = mkN "borgarstånd" neutrum  ;
  bordssilver_nn_1_N = mkN "bordssilver" neutrum  ;
  bordssalt_nn_1_N = mkN "bordssalt" neutrum  ;
  bordsilver_nn_1_N = mkN "bordsilver" neutrum  ;
  bondland_nn_1_N = mkN "bondland" neutrum  ;
  bondfoerstaand_nn_1_1_N = mkN "bondförstånd" neutrum  ;
  bondfoernuft_nn_1_1_N = mkN "bondförnuft" neutrum  ;
  bondestaand_nn_1_1_N = mkN "bondestånd" neutrum  ;
  bomullstrassel_nn_1_N = mkN "bomullstrassel" neutrum  ;
  bomullskrut_nn_1_N = mkN "bomullskrut" neutrum  ;
  bombflyg_nn_1_N = mkN "bombflyg" neutrum  ;
  boleri_nn_1_N = mkN "boleri" neutrum  ;
  boktryck_nn_1_N = mkN "boktryck" neutrum  ;
  bokmaal_nn_1_1_N = mkN "bokmål" neutrum  ;
  bokhantverk_nn_1_N = mkN "bokhantverk" neutrum  ;
  bohemliv_nn_1_N = mkN "bohemliv" neutrum  ;
  bockoel_nn_1_1_N = mkN "bocköl" neutrum  ;
  bloetfoder_nn_1_1_N = mkN "blötfoder" neutrum  ;
  blaatrae_nn_1_1_N = mkN "blåträ" neutrum  ;
  blaaregn_nn_1_1_N = mkN "blåregn" neutrum  ;
  blaeckpulver_nn_1_1_N = mkN "bläckpulver" neutrum  ;
  blaeck_nn_1_1_N = mkN "bläck" neutrum  ;
  blysocker_nn_1_N = mkN "blysocker" neutrum  ;
  blyglas_nn_1_N = mkN "blyglas" neutrum  ;
  blygdhaar_nn_1_1_N = mkN "blygdhår" neutrum  ;
  bly_nn_1_N = mkN "bly" neutrum  ;
  bludder_nn_1_N = mkN "bludder" neutrum  ;
  blomstoft_nn_1_N = mkN "blomstoft" neutrum  ;
  blomsterspraak_nn_1_1_N = mkN "blomsterspråk" neutrum  ;
  blodsocker_nn_1_N = mkN "blodsocker" neutrum  ;
  blodserum_nn_1_N = mkN "blodserum" neutrum  ;
  blodregn_nn_1_N = mkN "blodregn" neutrum  ;
  blodomlopp_nn_1_N = mkN "blodomlopp" neutrum  ;
  blodlutssalt_nn_1_N = mkN "blodlutssalt" neutrum  ;
  blodlutsalt_nn_1_N = mkN "blodlutsalt" neutrum  ;
  blixtpulver_nn_1_N = mkN "blixtpulver" neutrum  ;
  blixtljus_nn_1_N = mkN "blixtljus" neutrum  ;
  bling_nn_1_N = mkN "bling" neutrum  ;
  bling_bling_nn_1_N = mkN "bling-bling" neutrum  ;
  blindschack_nn_1_N = mkN "blindschack" neutrum  ;
  blig_nn_1_N = mkN "blig" neutrum  ;
  blask_nn_1_N = mkN "blask" neutrum  ;
  blarr_nn_1_N = mkN "blarr" neutrum  ;
  blankskinn_nn_1_N = mkN "blankskinn" neutrum  ;
  blankningsfoerbud_nn_1_1_N = mkN "blankningsförbud" neutrum  ;
  blanklaeder_nn_1_1_N = mkN "blankläder" neutrum  ;
  blankettraseri_nn_1_N = mkN "blankettraseri" neutrum  ;
  blandfoder_nn_1_N = mkN "blandfoder" neutrum  ;
  blaj_nn_1_N = mkN "blaj" neutrum  ;
  blaggarn_nn_1_N = mkN "blaggarn" neutrum  ;
  bladverk_nn_1_N = mkN "bladverk" neutrum  ;
  bladsilver_nn_1_N = mkN "bladsilver" neutrum  ;
  bladmoegel_nn_1_1_N = mkN "bladmögel" neutrum  ;
  bladguld_nn_1_N = mkN "bladguld" neutrum  ;
  bladder_nn_1_N = mkN "bladder" neutrum  ;
  bjoerksly_nn_1_1_N = mkN "björksly" neutrum  ;
  bjoerkpollen_nn_1_1_N = mkN "björkpollen" neutrum  ;
  bjaefs_nn_1_1_N = mkN "bjäfs" neutrum  ;
  bjaebb_nn_1_1_N = mkN "bjäbb" neutrum  ;
  bivax_nn_1_N = mkN "bivax" neutrum  ;
  bittersalt_nn_1_N = mkN "bittersalt" neutrum  ;
  bitsocker_nn_1_N = mkN "bitsocker" neutrum  ;
  bitryck_nn_1_N = mkN "bitryck" neutrum  ;
  bistaand_nn_1_1_N = mkN "bistånd" neutrum  ;
  bister_nn_1_N = mkN "bister" neutrum  ;
  bir_nn_1_N = mkN "bir" neutrum  ;
  bevattningsfoerbud_nn_1_1_N = mkN "bevattningsförbud" neutrum  ;
  bettleri_nn_1_N = mkN "bettleri" neutrum  ;
  betsocker_nn_1_N = mkN "betsocker" neutrum  ;
  betryck_nn_1_N = mkN "betryck" neutrum  ;
  betalsex_nn_1_N = mkN "betalsex" neutrum  ;
  beskaerm_nn_1_1_N = mkN "beskärm" neutrum  ;
  beskydd_nn_1_N = mkN "beskydd" neutrum  ;
  beryllium_nn_1_N = mkN "beryllium" neutrum  ;
  berkelium_nn_1_N = mkN "berkelium" neutrum  ;
  bergsklimat_nn_1_N = mkN "bergsklimat" neutrum  ;
  bergsbruk_nn_1_N = mkN "bergsbruk" neutrum  ;
  bergsartilleri_nn_1_N = mkN "bergsartilleri" neutrum  ;
  bergland_nn_1_N = mkN "bergland" neutrum  ;
  benmjoel_nn_1_1_N = mkN "benmjöl" neutrum  ;
  belaegringsartilleri_nn_1_1_N = mkN "belägringsartilleri" neutrum  ;
  beknip_nn_1_N = mkN "beknip" neutrum  ;
  begabberi_nn_1_N = mkN "begabberi" neutrum  ;
  befael_nn_2_1_N = mkN "befäl" neutrum  ;
  beckmoerker_nn_1_1_N = mkN "beckmörker" neutrum  ;
  beck_nn_1_N = mkN "beck" neutrum  ;
  bast_nn_1_N = mkN "bast" neutrum  ;
  barnplaageri_nn_1_1_N = mkN "barnplågeri" neutrum  ;
  barnbeck_nn_1_N = mkN "barnbeck" neutrum  ;
  barium_nn_1_N = mkN "barium" neutrum  ;
  barbari_nn_1_N = mkN "barbari" neutrum  ;
  banverk_nn_1_N = mkN "banverk" neutrum  ;
  banunderhaall_nn_1_1_N = mkN "banunderhåll" neutrum  ;
  bankvaesen_nn_1_1_N = mkN "bankväsen" neutrum  ;
  balsatrae_nn_1_1_N = mkN "balsaträ" neutrum  ;
  baktal_nn_1_N = mkN "baktal" neutrum  ;
  bakland_nn_1_N = mkN "bakland" neutrum  ;
  bakgrundssorl_nn_1_N = mkN "bakgrundssorl" neutrum  ;
  bakdanteri_nn_1_N = mkN "bakdanteri" neutrum  ;
  bajs_nn_1_N = mkN "bajs" neutrum  ;
  baggboeleri_nn_1_1_N = mkN "baggböleri" neutrum  ;
  badortsliv_nn_1_N = mkN "badortsliv" neutrum  ;
  badfoerbud_nn_1_1_N = mkN "badförbud" neutrum  ;
  babbel_nn_1_N = mkN "babbel" neutrum  ;
  ax_nn_2_N = mkN "ax" neutrum  ;
  avskrap_nn_1_N = mkN "avskrap" neutrum  ;
  avsidesliv_nn_1_N = mkN "avsidesliv" neutrum  ;
  avrens_nn_1_N = mkN "avrens" neutrum  ;
  avguderi_nn_1_N = mkN "avguderi" neutrum  ;
  avfallsfoder_nn_1_N = mkN "avfallsfoder" neutrum  ;
  augustimaansken_nn_1_1_N = mkN "augustimånsken" neutrum  ;
  atmosfaertryck_nn_1_1_N = mkN "atmosfärtryck" neutrum  ;
  asktrae_nn_1_1_N = mkN "askträ" neutrum  ;
  arvegods_nn_1_N = mkN "arvegods" neutrum  ;
  artonhundraaattiotal_nn_1_1_N = mkN "artonhundraåttiotal" neutrum  ;
  artonhundratal_nn_1_N = mkN "artonhundratal" neutrum  ;
  artonhundrasjuttiotal_nn_1_N = mkN "artonhundrasjuttiotal" neutrum  ;
  artonhundranittiotal_nn_1_N = mkN "artonhundranittiotal" neutrum  ;
  artistliv_nn_1_N = mkN "artistliv" neutrum  ;
  artisteri_nn_1_N = mkN "artisteri" neutrum  ;
  artilleri_nn_1_N = mkN "artilleri" neutrum  ;
  arm_eunderstoed_nn_1_1_N = mkN "arméunderstöd" neutrum  ;
  armod_nn_1_N = mkN "armod" neutrum  ;
  arbetsliv_nn_1_N = mkN "arbetsliv" neutrum  ;
  arbetsfolk_nn_1_N = mkN "arbetsfolk" neutrum  ;
  arbetarskydd_nn_1_N = mkN "arbetarskydd" neutrum  ;
  apogeum_nn_1_N = mkN "apogeum" neutrum  ;
  apex_nn_1_N = mkN "apex" neutrum  ;
  ansvar_nn_1_N = mkN "ansvar" neutrum  ;
  angoragarn_nn_1_N = mkN "angoragarn" neutrum  ;
  analsex_nn_1_N = mkN "analsex" neutrum  ;
  amningsfoerakt_nn_1_1_N = mkN "amningsförakt" neutrum  ;
  ammonium_nn_1_N = mkN "ammonium" neutrum  ;
  amiralitet_nn_1_N = mkN "amiralitet" neutrum  ;
  americium_nn_1_N = mkN "americium" neutrum  ;
  aluminium_nn_1_N = mkN "aluminium" neutrum  ;
  allvar_nn_1_N = mkN "allvar" neutrum  ;
  allt_nn_1_N = mkN "allt" neutrum  ;
  allmaengods_nn_1_1_N = mkN "allmängods" neutrum  ;
  alkoholmissbruk_nn_1_N = mkN "alkoholmissbruk" neutrum  ;
  alfapet_nn_1_N = mkN "alfapet" neutrum  ;
  alexanderhugg_nn_1_N = mkN "alexanderhugg" neutrum  ;
  aktinium_nn_1_N = mkN "aktinium" neutrum  ;
  agg_nn_1_N = mkN "agg" neutrum  ;
  agatglas_nn_1_N = mkN "agatglas" neutrum  ;
  advent_nn_1_N = mkN "advent" neutrum  ;
  adertonhundratal_nn_1_N = mkN "adertonhundratal" neutrum  ;
  adelsstaand_nn_1_1_N = mkN "adelsstånd" neutrum  ;
  adelskap_nn_1_N = mkN "adelskap" neutrum  ;
  _90_tal_nn_1_N = mkN "90-tal" neutrum  ;
  _80_tal_nn_1_N = mkN "80-tal" neutrum  ;
  _70_tal_nn_1_N = mkN "70-tal" neutrum  ;
  _60_tal_nn_1_N = mkN "60-tal" neutrum  ;
  _50_tal_nn_1_N = mkN "50-tal" neutrum  ;
  _40_tal_nn_1_N = mkN "40-tal" neutrum  ;
  _30_tal_nn_1_N = mkN "30-tal" neutrum  ;
  _2000_tal_nn_1_N = mkN "2000-tal" neutrum  ;
  _20_tal_nn_1_N = mkN "20-tal" neutrum  ;
  _1990_tal_nn_1_N = mkN "1990-tal" neutrum  ;
  _1980_tal_nn_1_N = mkN "1980-tal" neutrum  ;
  _1970_tal_nn_1_N = mkN "1970-tal" neutrum  ;
  _1960_tal_nn_1_N = mkN "1960-tal" neutrum  ;
  _1950_tal_nn_1_N = mkN "1950-tal" neutrum  ;
  _1940_tal_nn_1_N = mkN "1940-tal" neutrum  ;
  _1930_tal_nn_1_N = mkN "1930-tal" neutrum  ;
  _1920_tal_nn_1_N = mkN "1920-tal" neutrum  ;
  _1910_tal_nn_1_N = mkN "1910-tal" neutrum  ;
  _1900_tal_nn_1_N = mkN "1900-tal" neutrum  ;
  _1890_tal_nn_1_N = mkN "1890-tal" neutrum  ;
  _1880_tal_nn_1_N = mkN "1880-tal" neutrum  ;
  _1870_tal_nn_1_N = mkN "1870-tal" neutrum  ;
  _1800_tal_nn_1_N = mkN "1800-tal" neutrum  ;
  _1700_tal_nn_1_N = mkN "1700-tal" neutrum  ;
  _1600_tal_nn_1_N = mkN "1600-tal" neutrum  ;
  _1500_tal_nn_1_N = mkN "1500-tal" neutrum  ;
  _1400_tal_nn_1_N = mkN "1400-tal" neutrum  ;
  _1300_tal_nn_1_N = mkN "1300-tal" neutrum  ;
  _1200_tal_nn_1_N = mkN "1200-tal" neutrum  ;
  _1100_tal_nn_1_N = mkN "1100-tal" neutrum  ;
  _00_tal_nn_1_N = mkN "00-tal" neutrum  ;
  Vaegverk_nn_1_1_N = mkN "Vägverk" neutrum  ;
  Trafiksaekerhetsverk_nn_1_1_N = mkN "Trafiksäkerhetsverk" neutrum  ;
  Trafikkontor_nn_1_N = mkN "Trafikkontor" neutrum  ;
  Teutoburgerslag_nn_1_N = mkN "Teutoburgerslag" neutrum  ;
  Stockholmssyndrom_nn_1_N = mkN "Stockholmssyndrom" neutrum  ;
  Stadsbyggnadskontor_nn_1_N = mkN "Stadsbyggnadskontor" neutrum  ;
  Sovjetsystem_nn_1_N = mkN "Sovjetsystem" neutrum  ;
  Skolverk_nn_1_N = mkN "Skolverk" neutrum  ;
  Sjoefartsverk_nn_1_1_N = mkN "Sjöfartsverk" neutrum  ;
  Patentverk_nn_1_N = mkN "Patentverk" neutrum  ;
  Palmehat_nn_1_N = mkN "Palmehat" neutrum  ;
  Norrmalmstorgssyndrom_nn_1_N = mkN "Norrmalmstorgssyndrom" neutrum  ;
  Naturvaardsverk_nn_1_1_N = mkN "Naturvårdsverk" neutrum  ;
  Monopol_nn_1_N = mkN "Monopol" neutrum  ;
  Migrationsverk_nn_1_N = mkN "Migrationsverk" neutrum  ;
  Livsmedelsverk_nn_1_N = mkN "Livsmedelsverk" neutrum  ;
  Lissabonfoerdrag_nn_1_1_N = mkN "Lissabonfördrag" neutrum  ;
  Krimkrig_nn_1_N = mkN "Krimkrig" neutrum  ;
  Koreakrig_nn_1_N = mkN "Koreakrig" neutrum  ;
  Europaraadsparlament_nn_1_1_N = mkN "Europarådsparlament" neutrum  ;
  Europaraad_nn_1_1_N = mkN "Europaråd" neutrum  ;
  Europaparlament_nn_1_N = mkN "Europaparlament" neutrum  ;
  Banverk_nn_1_N = mkN "Banverk" neutrum  ;
  Alfapet_nn_1_N = mkN "Alfapet" neutrum  ;
  Moskvatrogen_av_1_A = mkA "Moskvatrogen" "Moskvatroget" ;
  Stasianstaelld_av_1_1_A = mkA "Stasianställd" "Stasianställt" ;
  Volvoanstaelld_av_1_1_A = mkA "Volvoanställd" "Volvoanställt" ;
  absurd_av_1_A = mkA "absurd" "absurt" ;
  aktningsvaerd_av_1_1_A = mkA "aktningsvärd" "aktningsvärt" ;
  alkoholfri_av_1_A = mkA "alkoholfri" "alkoholfritt" ;
  alliansfri_av_1_A = mkA "alliansfri" "alliansfritt" ;
  allvarstyngd_av_1_A = mkA "allvarstyngd" "allvarstyngt" ;
  amorteringsfri_av_1_A = mkA "amorteringsfri" "amorteringsfritt" ;
  andtruten_av_1_A = mkA "andtruten" "andtrutet" ;
  angelaegen_av_1_1_A = mkA "angelägen" "angeläget" ;
  anlupen_av_1_A = mkA "anlupen" "anlupet" ;
  anmaerkningsvaerd_av_1_1_A = mkA "anmärkningsvärd" "anmärkningsvärt" ;
  anskriven_av_1_A = mkA "anskriven" "anskrivet" ;
  anstruken_av_1_A = mkA "anstruken" "anstruket" ;
  anstraengd_av_1_1_A = mkA "ansträngd" "ansträngt" ;
  anstucken_av_1_A = mkA "anstucken" "anstucket" ;
  anstaelld_av_1_1_A = mkA "anställd" "anställt" ;
  ansvaelld_av_1_1_A = mkA "ansvälld" "ansvällt" ;
  arbetsfri_av_1_A = mkA "arbetsfri" "arbetsfritt" ;
  artegen_av_1_A = mkA "artegen" "arteget" ;
  artskild_av_1_A = mkA "artskild" "artskilt" ;
  askfri_av_1_A = mkA "askfri" "askfritt" ;
  auktoritetsbunden_av_1_A = mkA "auktoritetsbunden" "auktoritetsbundet" ;
  avfallen_av_1_A = mkA "avfallen" "avfallet" ;
  avgiftsfri_av_1_A = mkA "avgiftsfri" "avgiftsfritt" ;
  avgjord_av_1_A = mkA "avgjord" "avgjort" ;
  avhaengd_av_1_1_A = mkA "avhängd" "avhängt" ;
  avhaallen_av_1_1_A = mkA "avhållen" "avhållet" ;
  avlagd_av_1_A = mkA "avlagd" "avlagt" ;
  avlaegsen_av_1_1_A = mkA "avlägsen" "avlägset" ;
  avsevaerd_av_1_1_A = mkA "avsevärd" "avsevärt" ;
  avskild_av_1_A = mkA "avskild" "avskilt" ;
  avskyvaerd_av_1_1_A = mkA "avskyvärd" "avskyvärt" ;
  avslagen_av_1_A = mkA "avslagen" "avslaget" ;
  avtaerd_av_1_1_A = mkA "avtärd" "avtärt" ;
  avundsvaerd_av_1_1_A = mkA "avundsvärd" "avundsvärt" ;
  barnfoerbjuden_av_1_1_A = mkA "barnförbjuden" "barnförbjudet" ;
  barntillaaten_av_1_1_A = mkA "barntillåten" "barntillåtet" ;
  beaktansvaerd_av_1_1_A = mkA "beaktansvärd" "beaktansvärt" ;
  befaren_av_1_A = mkA "befaren" "befaret" ;
  befaengd_av_1_1_A = mkA "befängd" "befängt" ;
  begiven_av_1_A = mkA "begiven" "begivet" ;
  behjaertansvaerd_av_1_1_A = mkA "behjärtansvärd" "behjärtansvärt" ;
  beklagansvaerd_av_1_1_A = mkA "beklagansvärd" "beklagansvärt" ;
  beklaemd_av_1_1_A = mkA "beklämd" "beklämt" ;
  bekymmerfri_av_1_A = mkA "bekymmerfri" "bekymmerfritt" ;
  bekymmersfri_av_1_A = mkA "bekymmersfri" "bekymmersfritt" ;
  belaegen_av_1_1_A = mkA "belägen" "beläget" ;
  belaaten_av_1_1_A = mkA "belåten" "belåtet" ;
  benfri_av_1_A = mkA "benfri" "benfritt" ;
  benhaard_av_1_1_A = mkA "benhård" "benhårt" ;
  benaegen_av_1_1_A = mkA "benägen" "benäget" ;
  bergtagen_av_1_A = mkA "bergtagen" "bergtaget" ;
  beriden_av_1_A = mkA "beriden" "beridet" ;
  beroemd_av_1_1_A = mkA "berömd" "berömt" ;
  beroemvaerd_av_1_1_A = mkA "berömvärd" "berömvärt" ;
  beroerd_av_1_1_A = mkA "berörd" "berört" ;
  beroeringsfri_av_1_1_A = mkA "beröringsfri" "beröringsfritt" ;
  beskaerd_av_1_1_A = mkA "beskärd" "beskärt" ;
  besluten_av_1_A = mkA "besluten" "beslutet" ;
  bestaemd_av_1_1_A = mkA "bestämd" "bestämt" ;
  besutten_av_1_A = mkA "besutten" "besuttet" ;
  besviken_av_1_A = mkA "besviken" "besviket" ;
  besvaersfri_av_1_1_A = mkA "besvärsfri" "besvärsfritt" ;
  betagen_av_1_A = mkA "betagen" "betaget" ;
  betalningsfri_av_1_A = mkA "betalningsfri" "betalningsfritt" ;
  betraengd_av_1_1_A = mkA "beträngd" "beträngt" ;
  betygsfri_av_1_A = mkA "betygsfri" "betygsfritt" ;
  beundransvaerd_av_1_1_A = mkA "beundransvärd" "beundransvärt" ;
  bevuxen_av_1_A = mkA "bevuxen" "bevuxet" ;
  bevaagen_av_1_1_A = mkA "bevågen" "bevåget" ;
  bibehaallen_av_1_1_A = mkA "bibehållen" "bibehållet" ;
  bibelkristen_av_1_A = mkA "bibelkristen" "bibelkristet" ;
  bibelspraengd_av_1_1_A = mkA "bibelsprängd" "bibelsprängt" ;
  bibeltrogen_av_1_A = mkA "bibeltrogen" "bibeltroget" ;
  bienn_av_1_A = mkA "bienn" "bient" ;
  bilburen_av_1_A = mkA "bilburen" "bilburet" ;
  bilfri_av_1_A = mkA "bilfri" "bilfritt" ;
  bindgalen_av_1_A = mkA "bindgalen" "bindgalet" ;
  bingosugen_av_1_A = mkA "bingosugen" "bingosuget" ;
  biten_av_1_A = mkA "biten" "bitet" ;
  blanksliten_av_1_A = mkA "blanksliten" "blankslitet" ;
  bleklagd_av_1_A = mkA "bleklagd" "bleklagt" ;
  blodspraengd_av_1_1_A = mkA "blodsprängd" "blodsprängt" ;
  blodstinn_av_1_A = mkA "blodstinn" "blodstint" ;
  blottstaelld_av_1_1_A = mkA "blottställd" "blottställt" ;
  blyfri_av_1_A = mkA "blyfri" "blyfritt" ;
  blykyld_av_1_A = mkA "blykyld" "blykylt" ;
  blaendfri_av_1_1_A = mkA "bländfri" "bländfritt" ;
  blaaanlupen_av_1_1_A = mkA "blåanlupen" "blåanlupet" ;
  blaafrusen_av_1_1_A = mkA "blåfrusen" "blåfruset" ;
  blaaoegd_av_1_1_A = mkA "blåögd" "blåögt" ;
  bogbruten_av_1_A = mkA "bogbruten" "bogbrutet" ;
  boken_av_1_A = mkA "boken" "boket" ;
  boklaerd_av_1_1_A = mkA "boklärd" "boklärt" ;
  bokstavstrogen_av_1_A = mkA "bokstavstrogen" "bokstavstroget" ;
  boren_av_1_A = mkA "boren" "boret" ;
  bortbjuden_av_1_A = mkA "bortbjuden" "bortbjudet" ;
  bortgloemd_av_1_1_A = mkA "bortglömd" "bortglömt" ;
  bortkoerd_av_1_1_A = mkA "bortkörd" "bortkört" ;
  brickvaevd_av_1_1_A = mkA "brickvävd" "brickvävt" ;
  brisken_av_1_A = mkA "brisken" "brisket" ;
  brunoegd_av_1_1_A = mkA "brunögd" "brunögt" ;
  brusten_av_1_A = mkA "brusten" "brustet" ;
  bruten_av_1_A = mkA "bruten" "brutet" ;
  bryggmald_av_1_A = mkA "bryggmald" "bryggmalt" ;
  bryggmalen_av_1_A = mkA "bryggmalen" "bryggmalet" ;
  braeddfylld_av_1_1_A = mkA "bräddfylld" "bräddfyllt" ;
  braadmogen_av_1_1_A = mkA "brådmogen" "brådmoget" ;
  bukstinn_av_1_A = mkA "bukstinn" "bukstint" ;
  bunden_av_1_A = mkA "bunden" "bundet" ;
  burgen_av_1_A = mkA "burgen" "burget" ;
  butiksanstaelld_av_1_1_A = mkA "butiksanställd" "butiksanställt" ;
  baald_av_1_1_A = mkA "båld" "bålt" ;
  boejd_av_1_1_A = mkA "böjd" "böjt" ;
  centralstyrd_av_1_A = mkA "centralstyrd" "centralstyrt" ;
  chosefri_av_1_A = mkA "chosefri" "chosefritt" ;
  civilanstaelld_av_1_1_A = mkA "civilanställd" "civilanställt" ;
  danskaegd_av_1_1_A = mkA "danskägd" "danskägt" ;
  deltidsanstaelld_av_1_1_A = mkA "deltidsanställd" "deltidsanställt" ;
  diamantbelagd_av_1_A = mkA "diamantbelagd" "diamantbelagt" ;
  dimhoeljd_av_1_1_A = mkA "dimhöljd" "dimhöljt" ;
  dold_av_1_A = mkA "dold" "dolt" ;
  dragen_av_1_A = mkA "dragen" "draget" ;
  dragfri_av_1_A = mkA "dragfri" "dragfritt" ;
  driven_av_1_A = mkA "driven" "drivet" ;
  droppfri_av_1_A = mkA "droppfri" "droppfritt" ;
  drucken_av_1_A = mkA "drucken" "drucket" ;
  durkdriven_av_1_A = mkA "durkdriven" "durkdrivet" ;
  duven_av_1_A = mkA "duven" "duvet" ;
  dygnetruntoeppen_av_1_1_A = mkA "dygnetruntöppen" "dygnetruntöppet" ;
  dyrkansvaerd_av_1_1_A = mkA "dyrkansvärd" "dyrkansvärt" ;
  dyrkfri_av_1_A = mkA "dyrkfri" "dyrkfritt" ;
  daeven_av_1_1_A = mkA "däven" "dävet" ;
  doedsdoemd_av_1_1_A = mkA "dödsdömd" "dödsdömt" ;
  edsvuren_av_1_A = mkA "edsvuren" "edsvuret" ;
  efterbliven_av_1_A = mkA "efterbliven" "efterblivet" ;
  efterfoeljansvaerd_av_1_1_A = mkA "efterföljansvärd" "efterföljansvärt" ;
  eftergiven_av_1_A = mkA "eftergiven" "eftergivet" ;
  eftergjord_av_1_A = mkA "eftergjord" "eftergjort" ;
  efterhaengsen_av_1_1_A = mkA "efterhängsen" "efterhängset" ;
  efterlaaten_av_1_1_A = mkA "efterlåten" "efterlåtet" ;
  efterstraevansvaerd_av_1_1_A = mkA "eftersträvansvärd" "eftersträvansvärt" ;
  efterstaelld_av_1_1_A = mkA "efterställd" "efterställt" ;
  eftertraktansvaerd_av_1_1_A = mkA "eftertraktansvärd" "eftertraktansvärt" ;
  egen_av_1_A = mkA "egen" "eget" ;
  eldfaengd_av_1_1_A = mkA "eldfängd" "eldfängt" ;
  empatistoerd_av_1_1_A = mkA "empatistörd" "empatistört" ;
  enskild_av_1_A = mkA "enskild" "enskilt" ;
  entraegen_av_1_1_A = mkA "enträgen" "enträget" ;
  enveten_av_1_A = mkA "enveten" "envetet" ;
  envaerd_av_1_1_A = mkA "envärd" "envärt" ;
  enoegd_av_1_1_A = mkA "enögd" "enögt" ;
  erfaren_av_1_A = mkA "erfaren" "erfaret" ;
  ettstruken_av_1_A = mkA "ettstruken" "ettstruket" ;
  fabriksny_av_1_A = mkA "fabriksny" "fabriksnytt" ;
  fallen_av_1_A = mkA "fallen" "fallet" ;
  farofylld_av_1_A = mkA "farofylld" "farofyllt" ;
  fartfylld_av_1_A = mkA "fartfylld" "fartfyllt" ;
  fastfrusen_av_1_A = mkA "fastfrusen" "fastfruset" ;
  feberfri_av_1_A = mkA "feberfri" "feberfritt" ;
  felfri_av_1_A = mkA "felfri" "felfritt" ;
  felslagen_av_1_A = mkA "felslagen" "felslaget" ;
  felstaelld_av_1_1_A = mkA "felställd" "felställt" ;
  fetlagd_av_1_A = mkA "fetlagd" "fetlagt" ;
  fiken_av_1_A = mkA "fiken" "fiket" ;
  finskuren_av_1_A = mkA "finskuren" "finskuret" ;
  finskaegd_av_1_1_A = mkA "finskägd" "finskägt" ;
  finstaemd_av_1_1_A = mkA "finstämd" "finstämt" ;
  fjaerrstyrd_av_1_1_A = mkA "fjärrstyrd" "fjärrstyrt" ;
  flaeckfri_av_1_1_A = mkA "fläckfri" "fläckfritt" ;
  flaerdfri_av_1_1_A = mkA "flärdfri" "flärdfritt" ;
  folkilsken_av_1_A = mkA "folkilsken" "folkilsket" ;
  folkvald_av_1_A = mkA "folkvald" "folkvalt" ;
  formbunden_av_1_A = mkA "formbunden" "formbundet" ;
  fossilfri_av_1_A = mkA "fossilfri" "fossilfritt" ;
  framliden_av_1_A = mkA "framliden" "framlidet" ;
  framskjuten_av_1_A = mkA "framskjuten" "framskjutet" ;
  framskriden_av_1_A = mkA "framskriden" "framskridet" ;
  framaatboejd_av_1_1_A = mkA "framåtböjd" "framåtböjt" ;
  franskstyrd_av_1_A = mkA "franskstyrd" "franskstyrt" ;
  fri_av_1_A = mkA "fri" "fritt" ;
  friboren_av_1_A = mkA "friboren" "friboret" ;
  frigjord_av_1_A = mkA "frigjord" "frigjort" ;
  friktionsfri_av_1_A = mkA "friktionsfri" "friktionsfritt" ;
  friskriven_av_1_A = mkA "friskriven" "friskrivet" ;
  frostbiten_av_1_A = mkA "frostbiten" "frostbitet" ;
  frostfri_av_1_A = mkA "frostfri" "frostfritt" ;
  fruktansvaerd_av_1_1_A = mkA "fruktansvärd" "fruktansvärt" ;
  frusen_av_1_A = mkA "frusen" "fruset" ;
  fraankoerd_av_1_1_A = mkA "frånkörd" "frånkört" ;
  fraanskild_av_1_1_A = mkA "frånskild" "frånskilt" ;
  fullbelagd_av_1_A = mkA "fullbelagd" "fullbelagt" ;
  fullbetald_av_1_A = mkA "fullbetald" "fullbetalt" ;
  fullgaangen_av_1_1_A = mkA "fullgången" "fullgånget" ;
  fullmogen_av_1_A = mkA "fullmogen" "fullmoget" ;
  fullvuxen_av_1_A = mkA "fullvuxen" "fullvuxet" ;
  fylld_av_1_A = mkA "fylld" "fyllt" ;
  faengelsedoemd_av_1_1_A = mkA "fängelsedömd" "fängelsedömt" ;
  faerggrann_av_1_1_A = mkA "färggrann" "färggrant" ;
  faagelfri_av_1_1_A = mkA "fågelfri" "fågelfritt" ;
  faamaeld_av_1_1_A = mkA "fåmäld" "fåmält" ;
  faangen_av_1_1_A = mkA "fången" "fånget" ;
  foerbigaangen_av_1_1_A = mkA "förbigången" "förbigånget" ;
  foerbjuden_av_1_1_A = mkA "förbjuden" "förbjudet" ;
  foerbunden_av_1_1_A = mkA "förbunden" "förbundet" ;
  foerdold_av_1_1_A = mkA "fördold" "fördolt" ;
  foerdomsfri_av_1_1_A = mkA "fördomsfri" "fördomsfritt" ;
  foerdragen_av_1_1_A = mkA "fördragen" "fördraget" ;
  foerdroemd_av_1_1_A = mkA "fördrömd" "fördrömt" ;
  foerdoemd_av_1_1_A = mkA "fördömd" "fördömt" ;
  foerfallen_av_1_1_A = mkA "förfallen" "förfallet" ;
  foerfaren_av_1_1_A = mkA "förfaren" "förfaret" ;
  foerflugen_av_1_1_A = mkA "förflugen" "förfluget" ;
  foerfluten_av_1_1_A = mkA "förfluten" "förflutet" ;
  foerfrusen_av_1_1_A = mkA "förfrusen" "förfruset" ;
  foergjord_av_1_1_A = mkA "förgjord" "förgjort" ;
  foergraemd_av_1_1_A = mkA "förgrämd" "förgrämt" ;
  foergraaten_av_1_1_A = mkA "förgråten" "förgråtet" ;
  foerkristen_av_1_1_A = mkA "förkristen" "förkristet" ;
  foerkyld_av_1_1_A = mkA "förkyld" "förkylt" ;
  foerliden_av_1_1_A = mkA "förliden" "förlidet" ;
  foerljugen_av_1_1_A = mkA "förljugen" "förljuget" ;
  foerlupen_av_1_1_A = mkA "förlupen" "förlupet" ;
  foerlaegen_av_1_1_A = mkA "förlägen" "förläget" ;
  foermedveten_av_1_1_A = mkA "förmedveten" "förmedvetet" ;
  foermaeld_av_1_1_A = mkA "förmäld" "förmält" ;
  foermaeten_av_1_1_A = mkA "förmäten" "förmätet" ;
  foermoegen_av_1_1_A = mkA "förmögen" "förmöget" ;
  foernoejd_av_1_1_A = mkA "förnöjd" "förnöjt" ;
  foerrymd_av_1_1_A = mkA "förrymd" "förrymt" ;
  foersagd_av_1_1_A = mkA "försagd" "försagt" ;
  foersjunken_av_1_1_A = mkA "försjunken" "försjunket" ;
  foerskraemd_av_1_1_A = mkA "förskrämd" "förskrämt" ;
  foerskaemd_av_1_1_A = mkA "förskämd" "förskämt" ;
  foerslagen_av_1_1_A = mkA "förslagen" "förslaget" ;
  foerstucken_av_1_1_A = mkA "förstucken" "förstucket" ;
  foerstulen_av_1_1_A = mkA "förstulen" "förstulet" ;
  foerstaemd_av_1_1_A = mkA "förstämd" "förstämt" ;
  foerstoerd_av_1_1_A = mkA "förstörd" "förstört" ;
  foersupen_av_1_1_A = mkA "försupen" "försupet" ;
  foertegen_av_1_1_A = mkA "förtegen" "förteget" ;
  foertroendevald_av_1_1_A = mkA "förtroendevald" "förtroendevalt" ;
  foertrogen_av_1_1_A = mkA "förtrogen" "förtroget" ;
  foerundransvaerd_av_1_1_A = mkA "förundransvärd" "förundransvärt" ;
  foerutbestaemd_av_1_1_A = mkA "förutbestämd" "förutbestämt" ;
  foerveten_av_1_1_A = mkA "förveten" "förvetet" ;
  foervuxen_av_1_1_A = mkA "förvuxen" "förvuxet" ;
  foervaegen_av_1_1_A = mkA "förvägen" "förväget" ;
  foervaervslysten_av_1_1_A = mkA "förvärvslysten" "förvärvslystet" ;
  foervaanansvaerd_av_1_1_A = mkA "förvånansvärd" "förvånansvärt" ;
  foeraeldrafri_av_1_1_A = mkA "föräldrafri" "föräldrafritt" ;
  galen_av_1_A = mkA "galen" "galet" ;
  gallspraengd_av_1_1_A = mkA "gallsprängd" "gallsprängt" ;
  gammalkristen_av_1_A = mkA "gammalkristen" "gammalkristet" ;
  gedigen_av_1_A = mkA "gedigen" "gediget" ;
  genombruten_av_1_A = mkA "genombruten" "genombrutet" ;
  genomfoerkyld_av_1_1_A = mkA "genomförkyld" "genomförkylt" ;
  genomvaevd_av_1_1_A = mkA "genomvävd" "genomvävt" ;
  giftasvuxen_av_1_A = mkA "giftasvuxen" "giftasvuxet" ;
  giftfri_av_1_A = mkA "giftfri" "giftfritt" ;
  giktbruten_av_1_A = mkA "giktbruten" "giktbrutet" ;
  girvuxen_av_1_A = mkA "girvuxen" "girvuxet" ;
  gisten_av_1_A = mkA "gisten" "gistet" ;
  given_av_1_A = mkA "given" "givet" ;
  givmild_av_1_A = mkA "givmild" "givmilt" ;
  glosoegd_av_1_1_A = mkA "glosögd" "glosögt" ;
  glutenfri_av_1_A = mkA "glutenfri" "glutenfritt" ;
  glaedjefylld_av_1_1_A = mkA "glädjefylld" "glädjefyllt" ;
  gniden_av_1_A = mkA "gniden" "gnidet" ;
  godissugen_av_1_A = mkA "godissugen" "godissuget" ;
  godtrogen_av_1_A = mkA "godtrogen" "godtroget" ;
  grann_av_1_A = mkA "grann" "grant" ;
  gripen_av_1_A = mkA "gripen" "gripet" ;
  grovhuggen_av_1_A = mkA "grovhuggen" "grovhugget" ;
  grundlaerd_av_1_1_A = mkA "grundlärd" "grundlärt" ;
  graetten_av_1_1_A = mkA "grätten" "grättet" ;
  graaspraengd_av_1_1_A = mkA "gråsprängd" "gråsprängt" ;
  graatmild_av_1_1_A = mkA "gråtmild" "gråtmilt" ;
  groenmogen_av_1_1_A = mkA "grönmogen" "grönmoget" ;
  gudsfoergaeten_av_1_1_A = mkA "gudsförgäten" "gudsförgätet" ;
  gunstbenaegen_av_1_1_A = mkA "gunstbenägen" "gunstbenäget" ;
  gaeldbunden_av_1_1_A = mkA "gäldbunden" "gäldbundet" ;
  gaellen_av_1_1_A = mkA "gällen" "gället" ;
  gaestfri_av_1_1_A = mkA "gästfri" "gästfritt" ;
  hagalen_av_1_A = mkA "hagalen" "hagalet" ;
  halkfri_av_1_A = mkA "halkfri" "halkfritt" ;
  halvenskild_av_1_A = mkA "halvenskild" "halvenskilt" ;
  halvfylld_av_1_A = mkA "halvfylld" "halvfyllt" ;
  halvgaangen_av_1_1_A = mkA "halvgången" "halvgånget" ;
  halvkvaeden_av_1_1_A = mkA "halvkväden" "halvkvädet" ;
  halvkvaevd_av_1_1_A = mkA "halvkvävd" "halvkvävt" ;
  halvnaken_av_1_A = mkA "halvnaken" "halvnaket" ;
  halvsluten_av_1_A = mkA "halvsluten" "halvslutet" ;
  halvvuxen_av_1_A = mkA "halvvuxen" "halvvuxet" ;
  halvoeppen_av_1_1_A = mkA "halvöppen" "halvöppet" ;
  handfallen_av_1_A = mkA "handfallen" "handfallet" ;
  handgjord_av_1_A = mkA "handgjord" "handgjort" ;
  handgaangen_av_1_1_A = mkA "handgången" "handgånget" ;
  handskriven_av_1_A = mkA "handskriven" "handskrivet" ;
  harmfylld_av_1_A = mkA "harmfylld" "harmfyllt" ;
  harmsen_av_1_A = mkA "harmsen" "harmset" ;
  hatfylld_av_1_A = mkA "hatfylld" "hatfyllt" ;
  heden_av_1_A = mkA "heden" "hedet" ;
  hedervaerd_av_1_1_A = mkA "hedervärd" "hedervärt" ;
  hejvild_av_1_A = mkA "hejvild" "hejvilt" ;
  heldragen_av_1_A = mkA "heldragen" "heldraget" ;
  helgfri_av_1_A = mkA "helgfri" "helgfritt" ;
  helgjuten_av_1_A = mkA "helgjuten" "helgjutet" ;
  heliumfylld_av_1_A = mkA "heliumfylld" "heliumfyllt" ;
  heltidsanstaelld_av_1_1_A = mkA "heltidsanställd" "heltidsanställt" ;
  helaegd_av_1_1_A = mkA "helägd" "helägt" ;
  hembryggd_av_1_A = mkA "hembryggd" "hembryggt" ;
  hemgjord_av_1_A = mkA "hemgjord" "hemgjort" ;
  hemkoerd_av_1_1_A = mkA "hemkörd" "hemkört" ;
  hemmabyggd_av_1_A = mkA "hemmabyggd" "hemmabyggt" ;
  hemmagjord_av_1_A = mkA "hemmagjord" "hemmagjort" ;
  hemvaevd_av_1_1_A = mkA "hemvävd" "hemvävt" ;
  himlaboren_av_1_A = mkA "himlaboren" "himlaboret" ;
  hjaertnupen_av_1_1_A = mkA "hjärtnupen" "hjärtnupet" ;
  hopbiten_av_1_A = mkA "hopbiten" "hopbitet" ;
  hopbyggd_av_1_A = mkA "hopbyggd" "hopbyggt" ;
  hopfaelld_av_1_1_A = mkA "hopfälld" "hopfällt" ;
  hopkrupen_av_1_A = mkA "hopkrupen" "hopkrupet" ;
  hopsjunken_av_1_A = mkA "hopsjunken" "hopsjunket" ;
  hopslagen_av_1_A = mkA "hopslagen" "hopslaget" ;
  hopsnoerd_av_1_1_A = mkA "hopsnörd" "hopsnört" ;
  hopvuxen_av_1_A = mkA "hopvuxen" "hopvuxet" ;
  huld_av_1_A = mkA "huld" "hult" ;
  humusbunden_av_1_A = mkA "humusbunden" "humusbundet" ;
  haelsomedveten_av_1_1_A = mkA "hälsomedveten" "hälsomedvetet" ;
  haemndlysten_av_1_1_A = mkA "hämndlysten" "hämndlystet" ;
  haenfoerd_av_1_1_A = mkA "hänförd" "hänfört" ;
  haengiven_av_1_1_A = mkA "hängiven" "hängivet" ;
  haensjunken_av_1_1_A = mkA "hänsjunken" "hänsjunket" ;
  haensoven_av_1_1_A = mkA "hänsoven" "hänsovet" ;
  haepen_av_1_1_A = mkA "häpen" "häpet" ;
  haersken_av_1_1_A = mkA "härsken" "härsket" ;
  haersklysten_av_1_1_A = mkA "härsklysten" "härsklystet" ;
  haertagen_av_1_1_A = mkA "härtagen" "härtaget" ;
  haestdragen_av_1_1_A = mkA "hästdragen" "hästdraget" ;
  haallen_av_1_1_A = mkA "hållen" "hållet" ;
  haaloegd_av_1_1_A = mkA "hålögd" "hålögt" ;
  haarbevuxen_av_1_1_A = mkA "hårbevuxen" "hårbevuxet" ;
  haard_av_1_1_A = mkA "hård" "hårt" ;
  haardfrusen_av_1_1_A = mkA "hårdfrusen" "hårdfruset" ;
  hoegboren_av_1_1_A = mkA "högboren" "högboret" ;
  hoegburen_av_1_1_A = mkA "högburen" "högburet" ;
  hoegdragen_av_1_1_A = mkA "högdragen" "högdraget" ;
  hoegerkristen_av_1_1_A = mkA "högerkristen" "högerkristet" ;
  hoegfaerdsgalen_av_1_1_A = mkA "högfärdsgalen" "högfärdsgalet" ;
  hoegstaemd_av_1_1_A = mkA "högstämd" "högstämt" ;
  hoegvuxen_av_1_1_A = mkA "högvuxen" "högvuxet" ;
  hoegvaelboren_av_1_1_A = mkA "högvälboren" "högvälboret" ;
  icke_kristen_av_1_A = mkA "icke-kristen" "icke-kristet" ;
  ifoerd_av_1_1_A = mkA "iförd" "ifört" ;
  igenmulen_av_1_A = mkA "igenmulen" "igenmulet" ;
  igenvuxen_av_1_A = mkA "igenvuxen" "igenvuxet" ;
  ihjaelskraemd_av_1_1_A = mkA "ihjälskrämd" "ihjälskrämt" ;
  ihopfaelld_av_1_1_A = mkA "ihopfälld" "ihopfällt" ;
  ihoplagd_av_1_A = mkA "ihoplagd" "ihoplagt" ;
  illavulen_av_1_A = mkA "illavulen" "illavulet" ;
  illusionsfri_av_1_A = mkA "illusionsfri" "illusionsfritt" ;
  ilsken_av_1_A = mkA "ilsken" "ilsket" ;
  impulsstyrd_av_1_A = mkA "impulsstyrd" "impulsstyrt" ;
  inbegripen_av_1_A = mkA "inbegripen" "inbegripet" ;
  inbiten_av_1_A = mkA "inbiten" "inbitet" ;
  inbunden_av_1_A = mkA "inbunden" "inbundet" ;
  inbyggd_av_1_A = mkA "inbyggd" "inbyggt" ;
  indragen_av_1_A = mkA "indragen" "indraget" ;
  infallen_av_1_A = mkA "infallen" "infallet" ;
  infrusen_av_1_A = mkA "infrusen" "infruset" ;
  infaelld_av_1_1_A = mkA "infälld" "infällt" ;
  inkoerd_av_1_1_A = mkA "inkörd" "inkört" ;
  inlagd_av_1_A = mkA "inlagd" "inlagt" ;
  inlaerd_av_1_1_A = mkA "inlärd" "inlärt" ;
  inpyrd_av_1_A = mkA "inpyrd" "inpyrt" ;
  insjunken_av_1_A = mkA "insjunken" "insjunket" ;
  inslagen_av_1_A = mkA "inslagen" "inslaget" ;
  insnaerjd_av_1_1_A = mkA "insnärjd" "insnärjt" ;
  inspraengd_av_1_1_A = mkA "insprängd" "insprängt" ;
  instaelld_av_1_1_A = mkA "inställd" "inställt" ;
  instaengd_av_1_1_A = mkA "instängd" "instängt" ;
  insvaengd_av_1_1_A = mkA "insvängd" "insvängt" ;
  intagen_av_1_A = mkA "intagen" "intaget" ;
  invaendningsfri_av_1_1_A = mkA "invändningsfri" "invändningsfritt" ;
  inaatboejd_av_1_1_A = mkA "inåtböjd" "inåtböjt" ;
  isfri_av_1_A = mkA "isfri" "isfritt" ;
  iskyld_av_1_A = mkA "iskyld" "iskylt" ;
  jordbunden_av_1_A = mkA "jordbunden" "jordbundet" ;
  judekristen_av_1_A = mkA "judekristen" "judekristet" ;
  jaemstaelld_av_1_1_A = mkA "jämställd" "jämställt" ;
  jaernhaard_av_1_1_A = mkA "järnhård" "järnhårt" ;
  jaettenoejd_av_1_1_A = mkA "jättenöjd" "jättenöjt" ;
  kabelslagen_av_1_A = mkA "kabelslagen" "kabelslaget" ;
  kaffesugen_av_1_A = mkA "kaffesugen" "kaffesuget" ;
  kallskuren_av_1_A = mkA "kallskuren" "kallskuret" ;
  kammarlaerd_av_1_1_A = mkA "kammarlärd" "kammarlärt" ;
  kapitalstinn_av_1_A = mkA "kapitalstinn" "kapitalstint" ;
  karlavulen_av_1_A = mkA "karlavulen" "karlavulet" ;
  karlgalen_av_1_A = mkA "karlgalen" "karlgalet" ;
  karriaerlysten_av_1_1_A = mkA "karriärlysten" "karriärlystet" ;
  kelen_av_1_A = mkA "kelen" "kelet" ;
  klanderfri_av_1_A = mkA "klanderfri" "klanderfritt" ;
  klandervaerd_av_1_1_A = mkA "klandervärd" "klandervärt" ;
  klarvaken_av_1_A = mkA "klarvaken" "klarvaket" ;
  klaroegd_av_1_1_A = mkA "klarögd" "klarögt" ;
  klassmedveten_av_1_A = mkA "klassmedveten" "klassmedvetet" ;
  klentrogen_av_1_A = mkA "klentrogen" "klentroget" ;
  klenvuxen_av_1_A = mkA "klenvuxen" "klenvuxet" ;
  klimatmedveten_av_1_A = mkA "klimatmedveten" "klimatmedvetet" ;
  klinkbyggd_av_1_A = mkA "klinkbyggd" "klinkbyggt" ;
  kluven_av_1_A = mkA "kluven" "kluvet" ;
  klaedgalen_av_1_1_A = mkA "klädgalen" "klädgalet" ;
  knall_av_1_A = mkA "knall" "knall" ;
  knallhaard_av_1_1_A = mkA "knallhård" "knallhårt" ;
  knallorange_av_1_A = mkA "knallorange" "knallorange" ;
  knivskuren_av_1_A = mkA "knivskuren" "knivskuret" ;
  knuten_av_1_A = mkA "knuten" "knutet" ;
  kokmald_av_1_A = mkA "kokmald" "kokmalt" ;
  koldioxidfri_av_1_A = mkA "koldioxidfri" "koldioxidfritt" ;
  kollektivanstaelld_av_1_1_A = mkA "kollektivanställd" "kollektivanställt" ;
  kommunaegd_av_1_1_A = mkA "kommunägd" "kommunägt" ;
  konfliktfylld_av_1_A = mkA "konfliktfylld" "konfliktfyllt" ;
  konfliktstoerd_av_1_1_A = mkA "konfliktstörd" "konfliktstört" ;
  konstfrusen_av_1_A = mkA "konstfrusen" "konstfruset" ;
  konstfoerfaren_av_1_1_A = mkA "konstförfaren" "konstförfaret" ;
  konstgjord_av_1_A = mkA "konstgjord" "konstgjort" ;
  konstvaevd_av_1_1_A = mkA "konstvävd" "konstvävt" ;
  korthuggen_av_1_A = mkA "korthuggen" "korthugget" ;
  kortvuxen_av_1_A = mkA "kortvuxen" "kortvuxet" ;
  kostnadsfri_av_1_A = mkA "kostnadsfri" "kostnadsfritt" ;
  kooegd_av_1_1_A = mkA "koögd" "koögt" ;
  kringbyggd_av_1_A = mkA "kringbyggd" "kringbyggt" ;
  kringvaervd_av_1_1_A = mkA "kringvärvd" "kringvärvt" ;
  krismedveten_av_1_A = mkA "krismedveten" "krismedvetet" ;
  kristen_av_1_A = mkA "kristen" "kristet" ;
  kristtrogen_av_1_A = mkA "kristtrogen" "kristtroget" ;
  krokvuxen_av_1_A = mkA "krokvuxen" "krokvuxet" ;
  krossfri_av_1_A = mkA "krossfri" "krossfritt" ;
  krumpen_av_1_A = mkA "krumpen" "krumpet" ;
  kry_av_1_A = mkA "kry" "krytt" ;
  krympfri_av_1_A = mkA "krympfri" "krympfritt" ;
  kraesen_av_1_1_A = mkA "kräsen" "kräset" ;
  kulen_av_1_A = mkA "kulen" "kulet" ;
  kvalfylld_av_1_A = mkA "kvalfylld" "kvalfyllt" ;
  kvargloemd_av_1_1_A = mkA "kvarglömd" "kvarglömt" ;
  kvickoegd_av_1_1_A = mkA "kvickögd" "kvickögt" ;
  kvistfri_av_1_A = mkA "kvistfri" "kvistfritt" ;
  kvaellsoeppen_av_1_1_A = mkA "kvällsöppen" "kvällsöppet" ;
  kylslagen_av_1_A = mkA "kylslagen" "kylslaget" ;
  kaenslofylld_av_1_1_A = mkA "känslofylld" "känslofyllt" ;
  kaernfri_av_1_1_A = mkA "kärnfri" "kärnfritt" ;
  kaernvapenfri_av_1_1_A = mkA "kärnvapenfri" "kärnvapenfritt" ;
  koensbunden_av_1_1_A = mkA "könsbunden" "könsbundet" ;
  koensmogen_av_1_1_A = mkA "könsmogen" "könsmoget" ;
  koepgalen_av_1_1_A = mkA "köpgalen" "köpgalet" ;
  koerd_av_1_1_A = mkA "körd" "kört" ;
  lagbunden_av_1_A = mkA "lagbunden" "lagbundet" ;
  lagd_av_1_A = mkA "lagd" "lagt" ;
  lagfaren_av_1_A = mkA "lagfaren" "lagfaret" ;
  lagfaangen_av_1_1_A = mkA "lagfången" "lagfånget" ;
  lagvigd_av_1_A = mkA "lagvigd" "lagvigt" ;
  laktosfri_av_1_A = mkA "laktosfri" "laktosfritt" ;
  laserstyrd_av_1_A = mkA "laserstyrd" "laserstyrt" ;
  le_av_1_A = mkA "le" "lett" ;
  ledbruten_av_1_A = mkA "ledbruten" "ledbrutet" ;
  ledsen_av_1_A = mkA "ledsen" "ledset" ;
  leklysten_av_1_A = mkA "leklysten" "leklystet" ;
  lessen_av_1_A = mkA "lessen" "lesset" ;
  licensfri_av_1_A = mkA "licensfri" "licensfritt" ;
  lidelsefri_av_1_A = mkA "lidelsefri" "lidelsefritt" ;
  liknoejd_av_1_1_A = mkA "liknöjd" "liknöjt" ;
  likvaerd_av_1_1_A = mkA "likvärd" "likvärt" ;
  livdoemd_av_1_1_A = mkA "livdömd" "livdömt" ;
  livegen_av_1_A = mkA "livegen" "liveget" ;
  livstidsdoemd_av_1_1_A = mkA "livstidsdömd" "livstidsdömt" ;
  ljuslagd_av_1_A = mkA "ljuslagd" "ljuslagt" ;
  lomhoerd_av_1_1_A = mkA "lomhörd" "lomhört" ;
  lovvaerd_av_1_1_A = mkA "lovvärd" "lovvärt" ;
  luddfri_av_1_A = mkA "luddfri" "luddfritt" ;
  luden_av_1_A = mkA "luden" "ludet" ;
  luftburen_av_1_A = mkA "luftburen" "luftburet" ;
  luftkyld_av_1_A = mkA "luftkyld" "luftkylt" ;
  luggsliten_av_1_A = mkA "luggsliten" "luggslitet" ;
  luktfri_av_1_A = mkA "luktfri" "luktfritt" ;
  lumpen_av_1_A = mkA "lumpen" "lumpet" ;
  lustfylld_av_1_A = mkA "lustfylld" "lustfyllt" ;
  lyhoerd_av_1_1_A = mkA "lyhörd" "lyhört" ;
  lysten_av_1_A = mkA "lysten" "lystet" ;
  laengstfoerfluten_av_1_1_A = mkA "längstförfluten" "längstförflutet" ;
  laerd_av_1_1_A = mkA "lärd" "lärt" ;
  laesvaerd_av_1_1_A = mkA "läsvärd" "läsvärt" ;
  laettfaangen_av_1_1_A = mkA "lättfången" "lättfånget" ;
  laettkoerd_av_1_1_A = mkA "lättkörd" "lättkört" ;
  laettrogen_av_1_1_A = mkA "lättrogen" "lättroget" ;
  laettroerd_av_1_1_A = mkA "lättrörd" "lättrört" ;
  laettskraemd_av_1_1_A = mkA "lättskrämd" "lättskrämt" ;
  laettstyrd_av_1_1_A = mkA "lättstyrd" "lättstyrt" ;
  laettoemd_av_1_1_A = mkA "lättömd" "lättömt" ;
  laagmaeld_av_1_1_A = mkA "lågmäld" "lågmält" ;
  laagvuxen_av_1_1_A = mkA "lågvuxen" "lågvuxet" ;
  laanfaangen_av_1_1_A = mkA "lånfången" "lånfånget" ;
  laangdragen_av_1_1_A = mkA "långdragen" "långdraget" ;
  laasningsfri_av_1_1_A = mkA "låsningsfri" "låsningsfritt" ;
  loerdagsstaengd_av_1_1_A = mkA "lördagsstängd" "lördagsstängt" ;
  loerdagsoeppen_av_1_1_A = mkA "lördagsöppen" "lördagsöppet" ;
  loevtunn_av_1_1_A = mkA "lövtunn" "lövtunt" ;
  magerlagd_av_1_A = mkA "magerlagd" "magerlagt" ;
  maktlysten_av_1_A = mkA "maktlysten" "maktlystet" ;
  maktstinn_av_1_A = mkA "maktstinn" "maktstint" ;
  malaeten_av_1_1_A = mkA "maläten" "malätet" ;
  mandeloegd_av_1_1_A = mkA "mandelögd" "mandelögt" ;
  mangrann_av_1_A = mkA "mangrann" "mangrant" ;
  mantalsskriven_av_1_A = mkA "mantalsskriven" "mantalsskrivet" ;
  maskinskriven_av_1_A = mkA "maskinskriven" "maskinskrivet" ;
  maskstungen_av_1_A = mkA "maskstungen" "maskstunget" ;
  maskaeten_av_1_1_A = mkA "maskäten" "maskätet" ;
  mattbelagd_av_1_A = mkA "mattbelagd" "mattbelagt" ;
  medfaren_av_1_A = mkA "medfaren" "medfaret" ;
  medhavd_av_1_A = mkA "medhavd" "medhavt" ;
  medtagen_av_1_A = mkA "medtagen" "medtaget" ;
  medveten_av_1_A = mkA "medveten" "medvetet" ;
  meningsfylld_av_1_A = mkA "meningsfylld" "meningsfyllt" ;
  merbemaeld_av_1_1_A = mkA "merbemäld" "merbemält" ;
  mild_av_1_A = mkA "mild" "milt" ;
  mildoegd_av_1_1_A = mkA "mildögd" "mildögt" ;
  miljoemedveten_av_1_1_A = mkA "miljömedveten" "miljömedvetet" ;
  minnesvaerd_av_1_1_A = mkA "minnesvärd" "minnesvärt" ;
  missbelaaten_av_1_1_A = mkA "missbelåten" "missbelåtet" ;
  missnoejd_av_1_1_A = mkA "missnöjd" "missnöjt" ;
  misstrogen_av_1_A = mkA "misstrogen" "misstroget" ;
  mjoelkstinn_av_1_1_A = mkA "mjölkstinn" "mjölkstint" ;
  modfaelld_av_1_1_A = mkA "modfälld" "modfällt" ;
  modstulen_av_1_A = mkA "modstulen" "modstulet" ;
  mogen_av_1_A = mkA "mogen" "moget" ;
  mollstaemd_av_1_1_A = mkA "mollstämd" "mollstämt" ;
  molnfri_av_1_A = mkA "molnfri" "molnfritt" ;
  molnhoeljd_av_1_1_A = mkA "molnhöljd" "molnhöljt" ;
  moloken_av_1_A = mkA "moloken" "moloket" ;
  morddoemd_av_1_1_A = mkA "morddömd" "morddömt" ;
  mordlysten_av_1_A = mkA "mordlysten" "mordlystet" ;
  mossbelupen_av_1_A = mkA "mossbelupen" "mossbelupet" ;
  mulen_av_1_A = mkA "mulen" "mulet" ;
  multen_av_1_A = mkA "multen" "multet" ;
  murken_av_1_A = mkA "murken" "murket" ;
  maalmedveten_av_1_1_A = mkA "målmedveten" "målmedvetet" ;
  maangbesjungen_av_1_1_A = mkA "mångbesjungen" "mångbesjunget" ;
  maattbestaelld_av_1_1_A = mkA "måttbeställd" "måttbeställt" ;
  moedofylld_av_1_1_A = mkA "mödofylld" "mödofyllt" ;
  moenstervaevd_av_1_1_A = mkA "mönstervävd" "mönstervävt" ;
  moerklagd_av_1_1_A = mkA "mörklagd" "mörklagt" ;
  naken_av_1_A = mkA "naken" "naket" ;
  namnkristen_av_1_A = mkA "namnkristen" "namnkristet" ;
  narvhuggen_av_1_A = mkA "narvhuggen" "narvhugget" ;
  natriumkyld_av_1_A = mkA "natriumkyld" "natriumkylt" ;
  nattfrusen_av_1_A = mkA "nattfrusen" "nattfruset" ;
  nattgaangen_av_1_1_A = mkA "nattgången" "nattgånget" ;
  nattstaanden_av_1_1_A = mkA "nattstånden" "nattståndet" ;
  naturbunden_av_1_A = mkA "naturbunden" "naturbundet" ;
  naturtrogen_av_1_A = mkA "naturtrogen" "naturtroget" ;
  nedbruten_av_1_A = mkA "nedbruten" "nedbrutet" ;
  neddragen_av_1_A = mkA "neddragen" "neddraget" ;
  nederlagstyngd_av_1_A = mkA "nederlagstyngd" "nederlagstyngt" ;
  nedfaelld_av_1_1_A = mkA "nedfälld" "nedfällt" ;
  nedgaangen_av_1_1_A = mkA "nedgången" "nedgånget" ;
  nedlaaten_av_1_1_A = mkA "nedlåten" "nedlåtet" ;
  nedringd_av_1_A = mkA "nedringd" "nedringt" ;
  nedskaelld_av_1_1_A = mkA "nedskälld" "nedskällt" ;
  nedslagen_av_1_A = mkA "nedslagen" "nedslaget" ;
  nedsliten_av_1_A = mkA "nedsliten" "nedslitet" ;
  nedsmord_av_1_A = mkA "nedsmord" "nedsmort" ;
  nedspilld_av_1_A = mkA "nedspilld" "nedspillt" ;
  nedstaemd_av_1_1_A = mkA "nedstämd" "nedstämt" ;
  nedsupen_av_1_A = mkA "nedsupen" "nedsupet" ;
  nedsutten_av_1_A = mkA "nedsutten" "nedsuttet" ;
  nedaervd_av_1_1_A = mkA "nedärvd" "nedärvt" ;
  nedaatboejd_av_1_1_A = mkA "nedåtböjd" "nedåtböjt" ;
  nerbruten_av_1_A = mkA "nerbruten" "nerbrutet" ;
  nerdragen_av_1_A = mkA "nerdragen" "nerdraget" ;
  nerfaelld_av_1_1_A = mkA "nerfälld" "nerfällt" ;
  nergaangen_av_1_1_A = mkA "nergången" "nergånget" ;
  nerlaaten_av_1_1_A = mkA "nerlåten" "nerlåtet" ;
  nerringd_av_1_A = mkA "nerringd" "nerringt" ;
  nerskaelld_av_1_1_A = mkA "nerskälld" "nerskällt" ;
  nerslagen_av_1_A = mkA "nerslagen" "nerslaget" ;
  nersliten_av_1_A = mkA "nersliten" "nerslitet" ;
  nersmord_av_1_A = mkA "nersmord" "nersmort" ;
  nerspilld_av_1_A = mkA "nerspilld" "nerspillt" ;
  nerstaemd_av_1_1_A = mkA "nerstämd" "nerstämt" ;
  nersupen_av_1_A = mkA "nersupen" "nersupet" ;
  nersutten_av_1_A = mkA "nersutten" "nersuttet" ;
  neraervd_av_1_1_A = mkA "nerärvd" "nerärvt" ;
  neraatboejd_av_1_1_A = mkA "neråtböjd" "neråtböjt" ;
  njutningslysten_av_1_A = mkA "njutningslysten" "njutningslystet" ;
  noggrann_av_1_A = mkA "noggrann" "noggrant" ;
  norskaegd_av_1_1_A = mkA "norskägd" "norskägt" ;
  ny_av_1_A = mkA "ny" "nytt" ;
  nybliven_av_1_A = mkA "nybliven" "nyblivet" ;
  nybruten_av_1_A = mkA "nybruten" "nybrutet" ;
  nybryggd_av_1_A = mkA "nybryggd" "nybryggt" ;
  nyburen_av_1_A = mkA "nyburen" "nyburet" ;
  nybyggd_av_1_A = mkA "nybyggd" "nybyggt" ;
  nyfallen_av_1_A = mkA "nyfallen" "nyfallet" ;
  nyfiken_av_1_A = mkA "nyfiken" "nyfiket" ;
  nygaangen_av_1_1_A = mkA "nygången" "nygånget" ;
  nylagd_av_1_A = mkA "nylagd" "nylagt" ;
  nytaeljd_av_1_1_A = mkA "nytäljd" "nytäljt" ;
  nyuppfoerd_av_1_1_A = mkA "nyuppförd" "nyuppfört" ;
  nyupphaengd_av_1_1_A = mkA "nyupphängd" "nyupphängt" ;
  nyutslagen_av_1_A = mkA "nyutslagen" "nyutslaget" ;
  nyutsprungen_av_1_A = mkA "nyutsprungen" "nyutsprunget" ;
  nyvald_av_1_A = mkA "nyvald" "nyvalt" ;
  nyvorden_av_1_A = mkA "nyvorden" "nyvordet" ;
  naemnvaerd_av_1_1_A = mkA "nämnvärd" "nämnvärt" ;
  naepen_av_1_1_A = mkA "näpen" "näpet" ;
  naerbelaegen_av_1_1_A = mkA "närbelägen" "närbeläget" ;
  naergaangen_av_1_1_A = mkA "närgången" "närgånget" ;
  naerlagd_av_1_1_A = mkA "närlagd" "närlagt" ;
  naerskyld_av_1_1_A = mkA "närskyld" "närskylt" ;
  naestliden_av_1_1_A = mkA "nästliden" "nästlidet" ;
  naetansluten_av_1_1_A = mkA "nätansluten" "nätanslutet" ;
  noedbjuden_av_1_1_A = mkA "nödbjuden" "nödbjudet" ;
  noedstaelld_av_1_1_A = mkA "nödställd" "nödställt" ;
  noedtvungen_av_1_1_A = mkA "nödtvungen" "nödtvunget" ;
  noedvuxen_av_1_1_A = mkA "nödvuxen" "nödvuxet" ;
  noejd_av_1_1_A = mkA "nöjd" "nöjt" ;
  noejeslysten_av_1_1_A = mkA "nöjeslysten" "nöjeslystet" ;
  oanbefalld_av_1_A = mkA "oanbefalld" "oanbefallt" ;
  oanfoerd_av_1_1_A = mkA "oanförd" "oanfört" ;
  oanmaeld_av_1_1_A = mkA "oanmäld" "oanmält" ;
  oanstraengd_av_1_1_A = mkA "oansträngd" "oansträngt" ;
  oanstaelld_av_1_1_A = mkA "oanställd" "oanställt" ;
  oansvaelld_av_1_1_A = mkA "oansvälld" "oansvällt" ;
  oavbestaelld_av_1_1_A = mkA "oavbeställd" "oavbeställt" ;
  oavbruten_av_1_A = mkA "oavbruten" "oavbrutet" ;
  oavboejd_av_1_1_A = mkA "oavböjd" "oavböjt" ;
  oavdaemd_av_1_1_A = mkA "oavdämd" "oavdämt" ;
  oavdoemd_av_1_1_A = mkA "oavdömd" "oavdömt" ;
  oavfoerd_av_1_1_A = mkA "oavförd" "oavfört" ;
  oavgjord_av_1_A = mkA "oavgjord" "oavgjort" ;
  oavhaengd_av_1_1_A = mkA "oavhängd" "oavhängt" ;
  oavhoerd_av_1_1_A = mkA "oavhörd" "oavhört" ;
  oavkraevd_av_1_1_A = mkA "oavkrävd" "oavkrävt" ;
  oavkyld_av_1_A = mkA "oavkyld" "oavkylt" ;
  oavskavd_av_1_A = mkA "oavskavd" "oavskavt" ;
  oavsnoerd_av_1_1_A = mkA "oavsnörd" "oavsnört" ;
  oavstyrd_av_1_A = mkA "oavstyrd" "oavstyrt" ;
  oavstaelld_av_1_1_A = mkA "oavställd" "oavställt" ;
  oavstaemd_av_1_1_A = mkA "oavstämd" "oavstämt" ;
  oavstoerd_av_1_1_A = mkA "oavstörd" "oavstört" ;
  oavvaegd_av_1_1_A = mkA "oavvägd" "oavvägt" ;
  oavvaerjd_av_1_1_A = mkA "oavvärjd" "oavvärjt" ;
  obebyggd_av_1_A = mkA "obebyggd" "obebyggt" ;
  obedoemd_av_1_1_A = mkA "obedömd" "obedömt" ;
  obefalld_av_1_A = mkA "obefalld" "obefallt" ;
  obefaren_av_1_A = mkA "obefaren" "obefaret" ;
  obegaerd_av_1_1_A = mkA "obegärd" "obegärt" ;
  obehaengd_av_1_1_A = mkA "obehängd" "obehängt" ;
  obehoevd_av_1_1_A = mkA "obehövd" "obehövt" ;
  obemaengd_av_1_1_A = mkA "obemängd" "obemängt" ;
  obenaegen_av_1_1_A = mkA "obenägen" "obenäget" ;
  oberoemd_av_1_1_A = mkA "oberömd" "oberömt" ;
  oberoerd_av_1_1_A = mkA "oberörd" "oberört" ;
  obeskuren_av_1_A = mkA "obeskuren" "obeskuret" ;
  obeskylld_av_1_A = mkA "obeskylld" "obeskyllt" ;
  obestaelld_av_1_1_A = mkA "obeställd" "obeställt" ;
  obestaemd_av_1_1_A = mkA "obestämd" "obestämt" ;
  obesoerjd_av_1_1_A = mkA "obesörjd" "obesörjt" ;
  obetagen_av_1_A = mkA "obetagen" "obetaget" ;
  obetald_av_1_A = mkA "obetald" "obetalt" ;
  objuden_av_1_A = mkA "objuden" "objudet" ;
  obokfoerd_av_1_1_A = mkA "obokförd" "obokfört" ;
  obortfoerd_av_1_1_A = mkA "obortförd" "obortfört" ;
  obruten_av_1_A = mkA "obruten" "obrutet" ;
  obryggd_av_1_A = mkA "obryggd" "obryggt" ;
  obunden_av_1_A = mkA "obunden" "obundet" ;
  obyggd_av_1_A = mkA "obyggd" "obyggt" ;
  oboejd_av_1_1_A = mkA "oböjd" "oböjt" ;
  oboenhoerd_av_1_1_A = mkA "obönhörd" "obönhört" ;
  odraemd_av_1_1_A = mkA "odrämd" "odrämt" ;
  odroemd_av_1_1_A = mkA "odrömd" "odrömt" ;
  odaemd_av_1_1_A = mkA "odämd" "odämt" ;
  odaengd_av_1_1_A = mkA "odängd" "odängt" ;
  odoemd_av_1_1_A = mkA "odömd" "odömt" ;
  oefterfoeljd_av_1_1_A = mkA "oefterföljd" "oefterföljt" ;
  oefterhoerd_av_1_1_A = mkA "oefterhörd" "oefterhört" ;
  oemotsagd_av_1_A = mkA "oemotsagd" "oemotsagt" ;
  oerfaren_av_1_A = mkA "oerfaren" "oerfaret" ;
  oerhoerd_av_1_1_A = mkA "oerhörd" "oerhört" ;
  ofarliggjord_av_1_A = mkA "ofarliggjord" "ofarliggjort" ;
  offentliganstaelld_av_1_1_A = mkA "offentliganställd" "offentliganställt" ;
  oflaengd_av_1_1_A = mkA "oflängd" "oflängt" ;
  oframfoerd_av_1_1_A = mkA "oframförd" "oframfört" ;
  oframhaevd_av_1_1_A = mkA "oframhävd" "oframhävt" ;
  oframstaelld_av_1_1_A = mkA "oframställd" "oframställt" ;
  oframtraengd_av_1_1_A = mkA "oframträngd" "oframträngt" ;
  ofri_av_1_A = mkA "ofri" "ofritt" ;
  ofullfoeljd_av_1_1_A = mkA "ofullföljd" "ofullföljt" ;
  ofullgaangen_av_1_1_A = mkA "ofullgången" "ofullgånget" ;
  ofylld_av_1_A = mkA "ofylld" "ofyllt" ;
  ofaelld_av_1_1_A = mkA "ofälld" "ofällt" ;
  ofoeljd_av_1_1_A = mkA "oföljd" "oföljt" ;
  ofoeranmaeld_av_1_1_A = mkA "oföranmäld" "oföranmält" ;
  ofoerbyggd_av_1_1_A = mkA "oförbyggd" "oförbyggt" ;
  ofoerd_av_1_1_A = mkA "oförd" "ofört" ;
  ofoerdroejd_av_1_1_A = mkA "ofördröjd" "ofördröjt" ;
  ofoerdaemd_av_1_1_A = mkA "ofördämd" "ofördämt" ;
  ofoerdoemd_av_1_1_A = mkA "ofördömd" "ofördömt" ;
  ofoerebyggd_av_1_1_A = mkA "oförebyggd" "oförebyggt" ;
  ofoerestaelld_av_1_1_A = mkA "oföreställd" "oföreställt" ;
  ofoerfoeljd_av_1_1_A = mkA "oförföljd" "oförföljt" ;
  ofoerfoerd_av_1_1_A = mkA "oförförd" "oförfört" ;
  ofoergloemd_av_1_1_A = mkA "oförglömd" "oförglömt" ;
  ofoergylld_av_1_1_A = mkA "oförgylld" "oförgyllt" ;
  ofoerhyrd_av_1_1_A = mkA "oförhyrd" "oförhyrt" ;
  ofoerhoejd_av_1_1_A = mkA "oförhöjd" "oförhöjt" ;
  ofoerhoerd_av_1_1_A = mkA "oförhörd" "oförhört" ;
  ofoerkvaevd_av_1_1_A = mkA "oförkvävd" "oförkvävt" ;
  ofoerlaengd_av_1_1_A = mkA "oförlängd" "oförlängt" ;
  ofoermaeld_av_1_1_A = mkA "oförmäld" "oförmält" ;
  ofoermoegen_av_1_1_A = mkA "oförmögen" "oförmöget" ;
  ofoernoejd_av_1_1_A = mkA "oförnöjd" "oförnöjt" ;
  ofoerskylld_av_1_1_A = mkA "oförskylld" "oförskyllt" ;
  ofoerskaemd_av_1_1_A = mkA "oförskämd" "oförskämt" ;
  ofoerspilld_av_1_1_A = mkA "oförspilld" "oförspillt" ;
  ofoerstaelld_av_1_1_A = mkA "oförställd" "oförställt" ;
  ofoerstaemd_av_1_1_A = mkA "oförstämd" "oförstämt" ;
  ofoerstoerd_av_1_1_A = mkA "oförstörd" "oförstört" ;
  ofoersoerjd_av_1_1_A = mkA "oförsörjd" "oförsörjt" ;
  ofoertruten_av_1_1_A = mkA "oförtruten" "oförtrutet" ;
  ofoertraengd_av_1_1_A = mkA "oförträngd" "oförträngt" ;
  ofoertaerd_av_1_1_A = mkA "oförtärd" "oförtärt" ;
  ofoertoejd_av_1_1_A = mkA "oförtöjd" "oförtöjt" ;
  ofoerutbestaemd_av_1_1_A = mkA "oförutbestämd" "oförutbestämt" ;
  ofoervraengd_av_1_1_A = mkA "oförvrängd" "oförvrängt" ;
  ofoervaegen_av_1_1_A = mkA "oförvägen" "oförväget" ;
  ofoervaelld_av_1_1_A = mkA "oförvälld" "oförvällt" ;
  ogenomfoerd_av_1_1_A = mkA "ogenomförd" "ogenomfört" ;
  ogenomskoeljd_av_1_1_A = mkA "ogenomsköljd" "ogenomsköljt" ;
  ogenomtraengd_av_1_1_A = mkA "ogenomträngd" "ogenomträngt" ;
  ogjord_av_1_A = mkA "ogjord" "ogjort" ;
  ogloemd_av_1_1_A = mkA "oglömd" "oglömt" ;
  ognagd_av_1_A = mkA "ognagd" "ognagt" ;
  ognavd_av_1_A = mkA "ognavd" "ognavt" ;
  ograevd_av_1_1_A = mkA "ogrävd" "ogrävt" ;
  ogoemd_av_1_1_A = mkA "ogömd" "ogömt" ;
  ohyrd_av_1_A = mkA "ohyrd" "ohyrt" ;
  ohaelld_av_1_1_A = mkA "ohälld" "ohällt" ;
  ohaenfoerd_av_1_1_A = mkA "ohänförd" "ohänfört" ;
  ohaengd_av_1_1_A = mkA "ohängd" "ohängt" ;
  ohaevd_av_1_1_A = mkA "ohävd" "ohävt" ;
  ohoejd_av_1_1_A = mkA "ohöjd" "ohöjt" ;
  ohoeljd_av_1_1_A = mkA "ohöljd" "ohöljt" ;
  ohoerd_av_1_1_A = mkA "ohörd" "ohört" ;
  oinbunden_av_1_A = mkA "oinbunden" "oinbundet" ;
  oinbyggd_av_1_A = mkA "oinbyggd" "oinbyggt" ;
  oinfoerd_av_1_1_A = mkA "oinförd" "oinfört" ;
  oinkraevd_av_1_1_A = mkA "oinkrävd" "oinkrävt" ;
  oinlaerd_av_1_1_A = mkA "oinlärd" "oinlärt" ;
  oinmaengd_av_1_1_A = mkA "oinmängd" "oinmängt" ;
  oinnestaengd_av_1_1_A = mkA "oinnestängd" "oinnestängt" ;
  oinrymd_av_1_A = mkA "oinrymd" "oinrymt" ;
  oinstaemd_av_1_1_A = mkA "oinstämd" "oinstämt" ;
  oinstaengd_av_1_1_A = mkA "oinstängd" "oinstängt" ;
  ointraengd_av_1_1_A = mkA "ointrängd" "ointrängt" ;
  oinvigd_av_1_A = mkA "oinvigd" "oinvigt" ;
  oinvaevd_av_1_1_A = mkA "oinvävd" "oinvävt" ;
  ojaemfoerd_av_1_1_A = mkA "ojämförd" "ojämfört" ;
  ojaemstaelld_av_1_1_A = mkA "ojämställd" "ojämställt" ;
  oklaemd_av_1_1_A = mkA "oklämd" "oklämt" ;
  oklaengd_av_1_1_A = mkA "oklängd" "oklängt" ;
  oknaeboejd_av_1_1_A = mkA "oknäböjd" "oknäböjt" ;
  okorsfoerhoerd_av_1_1_A = mkA "okorsförhörd" "okorsförhört" ;
  okraengd_av_1_1_A = mkA "okrängd" "okrängt" ;
  okraevd_av_1_1_A = mkA "okrävd" "okrävt" ;
  okvald_av_1_A = mkA "okvald" "okvalt" ;
  okvardroejd_av_1_1_A = mkA "okvardröjd" "okvardröjt" ;
  okvaeden_av_1_1_A = mkA "okväden" "okvädet" ;
  okvaevd_av_1_1_A = mkA "okvävd" "okvävt" ;
  okyld_av_1_A = mkA "okyld" "okylt" ;
  okoerd_av_1_1_A = mkA "okörd" "okört" ;
  okoevd_av_1_1_A = mkA "okövd" "okövt" ;
  olejd_av_1_A = mkA "olejd" "olejt" ;
  oljefri_av_1_A = mkA "oljefri" "oljefritt" ;
  oljeriven_av_1_A = mkA "oljeriven" "oljerivet" ;
  olaengd_av_1_1_A = mkA "olängd" "olängt" ;
  olaerd_av_1_1_A = mkA "olärd" "olärt" ;
  omedfoerd_av_1_1_A = mkA "omedförd" "omedfört" ;
  omedveten_av_1_A = mkA "omedveten" "omedvetet" ;
  omgjord_av_1_A = mkA "omgjord" "omgjort" ;
  omild_av_1_A = mkA "omild" "omilt" ;
  omogen_av_1_A = mkA "omogen" "omoget" ;
  omotsagd_av_1_A = mkA "omotsagd" "omotsagt" ;
  omotvaegd_av_1_1_A = mkA "omotvägd" "omotvägt" ;
  omskriven_av_1_A = mkA "omskriven" "omskrivet" ;
  omskruten_av_1_A = mkA "omskruten" "omskrutet" ;
  omaengd_av_1_1_A = mkA "omängd" "omängt" ;
  onaerd_av_1_1_A = mkA "onärd" "onärt" ;
  oombestyrd_av_1_A = mkA "oombestyrd" "oombestyrt" ;
  oombesoerjd_av_1_1_A = mkA "oombesörjd" "oombesörjt" ;
  oomfoerd_av_1_1_A = mkA "oomförd" "oomfört" ;
  oomhoeljd_av_1_1_A = mkA "oomhöljd" "oomhöljt" ;
  oomskuren_av_1_A = mkA "oomskuren" "oomskuret" ;
  oomvaelvd_av_1_1_A = mkA "oomvälvd" "oomvälvt" ;
  oomvaervd_av_1_1_A = mkA "oomvärvd" "oomvärvt" ;
  oploejd_av_1_1_A = mkA "oplöjd" "oplöjt" ;
  oppbunden_av_1_A = mkA "oppbunden" "oppbundet" ;
  oppflugen_av_1_A = mkA "oppflugen" "oppfluget" ;
  oppfaelld_av_1_1_A = mkA "oppfälld" "oppfällt" ;
  oppgjord_av_1_A = mkA "oppgjord" "oppgjort" ;
  opphoejd_av_1_1_A = mkA "opphöjd" "opphöjt" ;
  oppknuten_av_1_A = mkA "oppknuten" "oppknutet" ;
  oppkoerd_av_1_1_A = mkA "oppkörd" "oppkört" ;
  opplagd_av_1_A = mkA "opplagd" "opplagt" ;
  opptagen_av_1_A = mkA "opptagen" "opptaget" ;
  oppvuxen_av_1_A = mkA "oppvuxen" "oppvuxet" ;
  opaafoerd_av_1_1_A = mkA "opåförd" "opåfört" ;
  opaatald_av_1_1_A = mkA "opåtald" "opåtalt" ;
  orange_av_1_A = mkA "orange" "orange" ;
  ordagrann_av_1_A = mkA "ordagrann" "ordagrant" ;
  ordtrogen_av_1_A = mkA "ordtrogen" "ordtroget" ;
  oregelbunden_av_1_A = mkA "oregelbunden" "oregelbundet" ;
  oringd_av_1_A = mkA "oringd" "oringt" ;
  orsaksbestaemd_av_1_1_A = mkA "orsaksbestämd" "orsaksbestämt" ;
  orymd_av_1_A = mkA "orymd" "orymt" ;
  oraettfaangen_av_1_1_A = mkA "orättfången" "orättfånget" ;
  oroejd_av_1_1_A = mkA "oröjd" "oröjt" ;
  oroerd_av_1_1_A = mkA "orörd" "orört" ;
  osagd_av_1_A = mkA "osagd" "osagt" ;
  osamkoerd_av_1_1_A = mkA "osamkörd" "osamkört" ;
  osammanfoerd_av_1_1_A = mkA "osammanförd" "osammanfört" ;
  osammanringd_av_1_A = mkA "osammanringd" "osammanringt" ;
  osammanstaelld_av_1_1_A = mkA "osammanställd" "osammanställt" ;
  osammanvaevd_av_1_1_A = mkA "osammanvävd" "osammanvävt" ;
  osann_av_1_A = mkA "osann" "osant" ;
  oskavd_av_1_A = mkA "oskavd" "oskavt" ;
  oskriven_av_1_A = mkA "oskriven" "oskrivet" ;
  oskyld_av_1_A = mkA "oskyld" "oskylt" ;
  oskyld_2_av_1_A = mkA "oskyld" "oskylt" ;
  oslagen_av_1_A = mkA "oslagen" "oslaget" ;
  osmord_av_1_A = mkA "osmord" "osmort" ;
  osnuten_av_1_A = mkA "osnuten" "osnutet" ;
  ospard_av_1_A = mkA "ospard" "ospart" ;
  ostruken_av_1_A = mkA "ostruken" "ostruket" ;
  ostaemd_av_1_1_A = mkA "ostämd" "ostämt" ;
  ostoerd_av_1_1_A = mkA "ostörd" "ostört" ;
  osvuren_av_1_A = mkA "osvuren" "osvuret" ;
  osaald_av_1_1_A = mkA "osåld" "osålt" ;
  otillfredsstaelld_av_1_1_A = mkA "otillfredsställd" "otillfredsställt" ;
  otillaaten_av_1_1_A = mkA "otillåten" "otillåtet" ;
  otrogen_av_1_A = mkA "otrogen" "otroget" ;
  otursfoerfoeljd_av_1_1_A = mkA "otursförföljd" "otursförföljt" ;
  otvungen_av_1_A = mkA "otvungen" "otvunget" ;
  otaemd_av_1_1_A = mkA "otämd" "otämt" ;
  otaemjd_av_1_1_A = mkA "otämjd" "otämjt" ;
  ouppfylld_av_1_A = mkA "ouppfylld" "ouppfyllt" ;
  ouppgjord_av_1_A = mkA "ouppgjord" "ouppgjort" ;
  ouppskuren_av_1_A = mkA "ouppskuren" "ouppskuret" ;
  ouppvaermd_av_1_1_A = mkA "ouppvärmd" "ouppvärmt" ;
  outgiven_av_1_A = mkA "outgiven" "outgivet" ;
  outhyrd_av_1_A = mkA "outhyrd" "outhyrt" ;
  outsagd_av_1_A = mkA "outsagd" "outsagt" ;
  outvuxen_av_1_A = mkA "outvuxen" "outvuxet" ;
  oveten_av_1_A = mkA "oveten" "ovetet" ;
  ovigd_av_1_A = mkA "ovigd" "ovigt" ;
  ooeverlagd_av_1_1_A = mkA "oöverlagd" "oöverlagt" ;
  ooevervaegd_av_1_1_A = mkA "oövervägd" "oövervägt" ;
  panikslagen_av_1_A = mkA "panikslagen" "panikslaget" ;
  pengastinn_av_1_A = mkA "pengastinn" "pengastint" ;
  penningstinn_av_1_A = mkA "penningstinn" "penningstint" ;
  perenn_av_1_A = mkA "perenn" "perent" ;
  pivothaengd_av_1_1_A = mkA "pivothängd" "pivothängt" ;
  pivaahaengd_av_1_1_A = mkA "pivåhängd" "pivåhängt" ;
  planskild_av_1_A = mkA "planskild" "planskilt" ;
  plastbunden_av_1_A = mkA "plastbunden" "plastbundet" ;
  pliktfoergaeten_av_1_1_A = mkA "pliktförgäten" "pliktförgätet" ;
  pliktmedveten_av_1_A = mkA "pliktmedveten" "pliktmedvetet" ;
  plikttrogen_av_1_A = mkA "plikttrogen" "plikttroget" ;
  portofri_av_1_A = mkA "portofri" "portofritt" ;
  prestigefylld_av_1_A = mkA "prestigefylld" "prestigefyllt" ;
  prickfri_av_1_A = mkA "prickfri" "prickfritt" ;
  prismedveten_av_1_A = mkA "prismedveten" "prismedvetet" ;
  prisvaerd_av_1_1_A = mkA "prisvärd" "prisvärt" ;
  privatanstaelld_av_1_1_A = mkA "privatanställd" "privatanställt" ;
  privataegd_av_1_1_A = mkA "privatägd" "privatägt" ;
  problemfri_av_1_A = mkA "problemfri" "problemfritt" ;
  purken_av_1_A = mkA "purken" "purket" ;
  paaflugen_av_1_1_A = mkA "påflugen" "påfluget" ;
  paastruken_av_1_1_A = mkA "påstruken" "påstruket" ;
  radiostyrd_av_1_A = mkA "radiostyrd" "radiostyrt" ;
  reaktionsbenaegen_av_1_1_A = mkA "reaktionsbenägen" "reaktionsbenäget" ;
  receptbelagd_av_1_A = mkA "receptbelagd" "receptbelagt" ;
  receptfri_av_1_A = mkA "receptfri" "receptfritt" ;
  redobogen_av_1_A = mkA "redobogen" "redoboget" ;
  reformbenaegen_av_1_1_A = mkA "reformbenägen" "reformbenäget" ;
  regelbunden_av_1_A = mkA "regelbunden" "regelbundet" ;
  regeringsstyrd_av_1_A = mkA "regeringsstyrd" "regeringsstyrt" ;
  ressugen_av_1_A = mkA "ressugen" "ressuget" ;
  revanschlysten_av_1_A = mkA "revanschlysten" "revanschlystet" ;
  revanschsugen_av_1_A = mkA "revanschsugen" "revanschsuget" ;
  riskfri_av_1_A = mkA "riskfri" "riskfritt" ;
  riskfylld_av_1_A = mkA "riskfylld" "riskfyllt" ;
  rofylld_av_1_A = mkA "rofylld" "rofyllt" ;
  rosettstaelld_av_1_1_A = mkA "rosettställd" "rosettställt" ;
  rostfri_av_1_A = mkA "rostfri" "rostfritt" ;
  rovlysten_av_1_A = mkA "rovlysten" "rovlystet" ;
  rullstolsbunden_av_1_A = mkA "rullstolsbunden" "rullstolsbundet" ;
  rundlagd_av_1_A = mkA "rundlagd" "rundlagt" ;
  rutten_av_1_A = mkA "rutten" "ruttet" ;
  rynkfri_av_1_A = mkA "rynkfri" "rynkfritt" ;
  rysansvaerd_av_1_1_A = mkA "rysansvärd" "rysansvärt" ;
  raeddhaagsen_av_1_1_A = mkA "räddhågsen" "räddhågset" ;
  raettrogen_av_1_1_A = mkA "rättrogen" "rättroget" ;
  raa_av_1_1_A = mkA "rå" "rått" ;
  raaroerd_av_1_1_A = mkA "rårörd" "rårört" ;
  raattaeten_av_1_1_A = mkA "råttäten" "råttätet" ;
  roedgraaten_av_1_1_A = mkA "rödgråten" "rödgråtet" ;
  roedspraengd_av_1_1_A = mkA "rödsprängd" "rödsprängt" ;
  roedoegd_av_1_1_A = mkA "rödögd" "rödögt" ;
  roekfri_av_1_1_A = mkA "rökfri" "rökfritt" ;
  roeksugen_av_1_1_A = mkA "röksugen" "röksuget" ;
  roerd_av_1_1_A = mkA "rörd" "rört" ;
  sadelbruten_av_1_A = mkA "sadelbruten" "sadelbrutet" ;
  saltbemaengd_av_1_1_A = mkA "saltbemängd" "saltbemängt" ;
  samfaelld_av_1_1_A = mkA "samfälld" "samfällt" ;
  sammald_av_1_A = mkA "sammald" "sammalt" ;
  sammalen_av_1_A = mkA "sammalen" "sammalet" ;
  sammanbiten_av_1_A = mkA "sammanbiten" "sammanbitet" ;
  sammanhaallen_av_1_1_A = mkA "sammanhållen" "sammanhållet" ;
  sammanlagd_av_1_A = mkA "sammanlagd" "sammanlagt" ;
  sammanslagen_av_1_A = mkA "sammanslagen" "sammanslaget" ;
  sammantagen_av_1_A = mkA "sammantagen" "sammantaget" ;
  samstaemd_av_1_1_A = mkA "samstämd" "samstämt" ;
  samvetsgrann_av_1_A = mkA "samvetsgrann" "samvetsgrant" ;
  sann_av_1_A = mkA "sann" "sant" ;
  schemabunden_av_1_A = mkA "schemabunden" "schemabundet" ;
  schemalagd_av_1_A = mkA "schemalagd" "schemalagt" ;
  segdragen_av_1_A = mkA "segdragen" "segdraget" ;
  segelfri_av_1_A = mkA "segelfri" "segelfritt" ;
  seglingsfri_av_1_A = mkA "seglingsfri" "seglingsfritt" ;
  segmogen_av_1_A = mkA "segmogen" "segmoget" ;
  segsliten_av_1_A = mkA "segsliten" "segslitet" ;
  selbruten_av_1_A = mkA "selbruten" "selbrutet" ;
  semesterstaengd_av_1_1_A = mkA "semesterstängd" "semesterstängt" ;
  sensationslysten_av_1_A = mkA "sensationslysten" "sensationslystet" ;
  sevaerd_av_1_1_A = mkA "sevärd" "sevärt" ;
  sicken_av_1_A = mkA "sicken" "sicket" ;
  sinnessloe_av_1_1_A = mkA "sinnesslö" "sinnesslött" ;
  sistliden_av_1_A = mkA "sistliden" "sistlidet" ;
  sjaelvbelaaten_av_1_1_A = mkA "självbelåten" "självbelåtet" ;
  sjaelvfallen_av_1_1_A = mkA "självfallen" "självfallet" ;
  sjaelvlaerd_av_1_1_A = mkA "självlärd" "självlärt" ;
  sjaelvmedveten_av_1_1_A = mkA "självmedveten" "självmedvetet" ;
  sjaelvmordsbenaegen_av_1_1_A = mkA "självmordsbenägen" "självmordsbenäget" ;
  sjaelvpaatagen_av_1_1_A = mkA "självpåtagen" "självpåtaget" ;
  sjaelvskriven_av_1_1_A = mkA "självskriven" "självskrivet" ;
  sjaelvupplevd_av_1_1_A = mkA "självupplevd" "självupplevt" ;
  sjaelvupptagen_av_1_1_A = mkA "självupptagen" "självupptaget" ;
  sjaelvvald_av_1_1_A = mkA "självvald" "självvalt" ;
  sjoevild_av_1_1_A = mkA "sjövild" "sjövilt" ;
  skambelagd_av_1_A = mkA "skambelagd" "skambelagt" ;
  skamsen_av_1_A = mkA "skamsen" "skamset" ;
  skarpskuren_av_1_A = mkA "skarpskuren" "skarpskuret" ;
  skarpoegd_av_1_1_A = mkA "skarpögd" "skarpögt" ;
  skattefri_av_1_A = mkA "skattefri" "skattefritt" ;
  skeloegd_av_1_1_A = mkA "skelögd" "skelögt" ;
  skeppsbruten_av_1_A = mkA "skeppsbruten" "skeppsbrutet" ;
  sketen_av_1_A = mkA "sketen" "sketet" ;
  skild_av_1_A = mkA "skild" "skilt" ;
  skogbevuxen_av_1_A = mkA "skogbevuxen" "skogbevuxet" ;
  skolmogen_av_1_A = mkA "skolmogen" "skolmoget" ;
  skrajsen_av_1_A = mkA "skrajsen" "skrajset" ;
  skrattlysten_av_1_A = mkA "skrattlysten" "skrattlystet" ;
  skriftlaerd_av_1_1_A = mkA "skriftlärd" "skriftlärt" ;
  skrumpen_av_1_A = mkA "skrumpen" "skrumpet" ;
  skrupelfri_av_1_A = mkA "skrupelfri" "skrupelfritt" ;
  skrynkelfri_av_1_A = mkA "skrynkelfri" "skrynkelfritt" ;
  skraeckfylld_av_1_1_A = mkA "skräckfylld" "skräckfyllt" ;
  skraeckslagen_av_1_1_A = mkA "skräckslagen" "skräckslaget" ;
  skraa_av_1_1_A = mkA "skrå" "skrått" ;
  skuldfri_av_1_A = mkA "skuldfri" "skuldfritt" ;
  skuldmedveten_av_1_A = mkA "skuldmedveten" "skuldmedvetet" ;
  skuldtyngd_av_1_A = mkA "skuldtyngd" "skuldtyngt" ;
  skumoegd_av_1_1_A = mkA "skumögd" "skumögt" ;
  skyddsvaerd_av_1_1_A = mkA "skyddsvärd" "skyddsvärt" ;
  skyld_av_1_A = mkA "skyld" "skylt" ;
  skaemd_av_1_1_A = mkA "skämd" "skämt" ;
  slagroerd_av_1_1_A = mkA "slagrörd" "slagrört" ;
  sliten_av_1_A = mkA "sliten" "slitet" ;
  sluten_av_1_A = mkA "sluten" "slutet" ;
  slutkoerd_av_1_1_A = mkA "slutkörd" "slutkört" ;
  slutsaald_av_1_1_A = mkA "slutsåld" "slutsålt" ;
  slaengd_av_1_1_A = mkA "slängd" "slängt" ;
  slaetstruken_av_1_1_A = mkA "slätstruken" "slätstruket" ;
  sloe_av_1_1_A = mkA "slö" "slött" ;
  smittfri_av_1_A = mkA "smittfri" "smittfritt" ;
  smutsorange_av_1_A = mkA "smutsorange" "smutsorange" ;
  smaertfri_av_1_1_A = mkA "smärtfri" "smärtfritt" ;
  smaaskuren_av_1_1_A = mkA "småskuren" "småskuret" ;
  smaavuxen_av_1_1_A = mkA "småvuxen" "småvuxet" ;
  snabbgjord_av_1_A = mkA "snabbgjord" "snabbgjort" ;
  snarkfri_av_1_A = mkA "snarkfri" "snarkfritt" ;
  snarstucken_av_1_A = mkA "snarstucken" "snarstucket" ;
  snedgaangen_av_1_1_A = mkA "snedgången" "snedgånget" ;
  snedskuren_av_1_A = mkA "snedskuren" "snedskuret" ;
  snedoegd_av_1_1_A = mkA "snedögd" "snedögt" ;
  sniken_av_1_A = mkA "sniken" "sniket" ;
  snopen_av_1_A = mkA "snopen" "snopet" ;
  snoetyngd_av_1_1_A = mkA "snötyngd" "snötyngt" ;
  sockerfri_av_1_A = mkA "sockerfri" "sockerfritt" ;
  soldrucken_av_1_A = mkA "soldrucken" "soldrucket" ;
  solenn_av_1_A = mkA "solenn" "solent" ;
  solmogen_av_1_A = mkA "solmogen" "solmoget" ;
  soluppvaermd_av_1_1_A = mkA "soluppvärmd" "soluppvärmt" ;
  sorgbunden_av_1_A = mkA "sorgbunden" "sorgbundet" ;
  sorgfri_av_1_A = mkA "sorgfri" "sorgfritt" ;
  sorgsen_av_1_A = mkA "sorgsen" "sorgset" ;
  sorgtyngd_av_1_A = mkA "sorgtyngd" "sorgtyngt" ;
  spefylld_av_1_A = mkA "spefylld" "spefyllt" ;
  spelsugen_av_1_A = mkA "spelsugen" "spelsuget" ;
  spicken_av_1_A = mkA "spicken" "spicket" ;
  spindeltunn_av_1_A = mkA "spindeltunn" "spindeltunt" ;
  spindelvaevstunn_av_1_1_A = mkA "spindelvävstunn" "spindelvävstunt" ;
  splitterny_av_1_A = mkA "splitterny" "splitternytt" ;
  spraengfylld_av_1_1_A = mkA "sprängfylld" "sprängfyllt" ;
  spraenglaerd_av_1_1_A = mkA "spränglärd" "spränglärt" ;
  stamanstaelld_av_1_1_A = mkA "stamanställd" "stamanställt" ;
  statsanstaelld_av_1_1_A = mkA "statsanställd" "statsanställt" ;
  statsaegd_av_1_1_A = mkA "statsägd" "statsägt" ;
  stelfrusen_av_1_A = mkA "stelfrusen" "stelfruset" ;
  stenhaard_av_1_1_A = mkA "stenhård" "stenhårt" ;
  steningsdoemd_av_1_1_A = mkA "steningsdömd" "steningsdömt" ;
  stenlagd_av_1_A = mkA "stenlagd" "stenlagt" ;
  stinn_av_1_A = mkA "stinn" "stint" ;
  stjaernoegd_av_1_1_A = mkA "stjärnögd" "stjärnögt" ;
  stoftfylld_av_1_A = mkA "stoftfylld" "stoftfyllt" ;
  storslagen_av_1_A = mkA "storslagen" "storslaget" ;
  storvulen_av_1_A = mkA "storvulen" "storvulet" ;
  storvuxen_av_1_A = mkA "storvuxen" "storvuxet" ;
  storoegd_av_1_1_A = mkA "storögd" "storögt" ;
  straffri_av_1_A = mkA "straffri" "straffritt" ;
  stridslysten_av_1_A = mkA "stridslysten" "stridslystet" ;
  strykfri_av_1_A = mkA "strykfri" "strykfritt" ;
  stucken_av_1_A = mkA "stucken" "stucket" ;
  staelld_av_1_1_A = mkA "ställd" "ställt" ;
  staemningstyngd_av_1_1_A = mkA "stämningstyngd" "stämningstyngt" ;
  staalhaard_av_1_1_A = mkA "stålhård" "stålhårt" ;
  sugen_av_1_A = mkA "sugen" "suget" ;
  surmulen_av_1_A = mkA "surmulen" "surmulet" ;
  suroegd_av_1_1_A = mkA "surögd" "surögt" ;
  svenskaegd_av_1_1_A = mkA "svenskägd" "svenskägt" ;
  svullen_av_1_A = mkA "svullen" "svullet" ;
  svulten_av_1_A = mkA "svulten" "svultet" ;
  svuren_av_1_A = mkA "svuren" "svuret" ;
  svaengd_av_1_1_A = mkA "svängd" "svängt" ;
  svaarbedoemd_av_1_1_A = mkA "svårbedömd" "svårbedömt" ;
  svaarsjungen_av_1_1_A = mkA "svårsjungen" "svårsjunget" ;
  svaarsaald_av_1_1_A = mkA "svårsåld" "svårsålt" ;
  symptomfri_av_1_A = mkA "symptomfri" "symptomfritt" ;
  symtomfri_av_1_A = mkA "symtomfri" "symtomfritt" ;
  syndfri_av_1_A = mkA "syndfri" "syndfritt" ;
  saellspord_av_1_1_A = mkA "sällspord" "sällsport" ;
  saeregen_av_1_1_A = mkA "säregen" "säreget" ;
  saerskild_av_1_1_A = mkA "särskild" "särskilt" ;
  saald_av_1_1_A = mkA "såld" "sålt" ;
  soemndrucken_av_1_1_A = mkA "sömndrucken" "sömndrucket" ;
  soenderkoerd_av_1_1_A = mkA "sönderkörd" "sönderkört" ;
  tabubelagd_av_1_A = mkA "tabubelagd" "tabubelagt" ;
  tadelfri_av_1_A = mkA "tadelfri" "tadelfritt" ;
  tagen_av_1_A = mkA "tagen" "taget" ;
  talgoegd_av_1_1_A = mkA "talgögd" "talgögt" ;
  taltraengd_av_1_1_A = mkA "talträngd" "talträngt" ;
  temperamentsfri_av_1_A = mkA "temperamentsfri" "temperamentsfritt" ;
  tidsbunden_av_1_A = mkA "tidsbunden" "tidsbundet" ;
  tidsinstaelld_av_1_1_A = mkA "tidsinställd" "tidsinställt" ;
  tidsmedveten_av_1_A = mkA "tidsmedveten" "tidsmedvetet" ;
  tidstrogen_av_1_A = mkA "tidstrogen" "tidstroget" ;
  tillbakadragen_av_1_A = mkA "tillbakadragen" "tillbakadraget" ;
  tillbyggd_av_1_A = mkA "tillbyggd" "tillbyggt" ;
  tillfredsstaelld_av_1_1_A = mkA "tillfredsställd" "tillfredsställt" ;
  tillgiven_av_1_A = mkA "tillgiven" "tillgivet" ;
  tillgjord_av_1_A = mkA "tillgjord" "tillgjort" ;
  tillintetgjord_av_1_A = mkA "tillintetgjord" "tillintetgjort" ;
  tillsammantagen_av_1_A = mkA "tillsammantagen" "tillsammantaget" ;
  tillslagen_av_1_A = mkA "tillslagen" "tillslaget" ;
  tillspillogiven_av_1_A = mkA "tillspillogiven" "tillspillogivet" ;
  tilltagen_av_1_A = mkA "tilltagen" "tilltaget" ;
  tilltagsen_av_1_A = mkA "tilltagsen" "tilltagset" ;
  tillaendalupen_av_1_1_A = mkA "tilländalupen" "tilländalupet" ;
  tillaaten_av_1_1_A = mkA "tillåten" "tillåtet" ;
  tjaelfri_av_1_1_A = mkA "tjälfri" "tjälfritt" ;
  tjaelfrusen_av_1_1_A = mkA "tjälfrusen" "tjälfruset" ;
  tocken_av_1_A = mkA "tocken" "tocket" ;
  tomoegd_av_1_1_A = mkA "tomögd" "tomögt" ;
  toppen_av_1_A = mkA "toppen" "toppet" ;
  toppstyrd_av_1_A = mkA "toppstyrd" "toppstyrt" ;
  torroegd_av_1_1_A = mkA "torrögd" "torrögt" ;
  traditionsbunden_av_1_A = mkA "traditionsbunden" "traditionsbundet" ;
  traditionstyngd_av_1_A = mkA "traditionstyngd" "traditionstyngt" ;
  trasgrann_av_1_A = mkA "trasgrann" "trasgrant" ;
  trestruken_av_1_A = mkA "trestruken" "trestruket" ;
  treven_av_1_A = mkA "treven" "trevet" ;
  trilsken_av_1_A = mkA "trilsken" "trilsket" ;
  trogen_av_1_A = mkA "trogen" "troget" ;
  trosslagen_av_1_A = mkA "trosslagen" "trosslaget" ;
  trovaerd_av_1_1_A = mkA "trovärd" "trovärt" ;
  trumpen_av_1_A = mkA "trumpen" "trumpet" ;
  traedmogen_av_1_1_A = mkA "trädmogen" "trädmoget" ;
  traefri_av_1_1_A = mkA "träfri" "träfritt" ;
  traegen_av_1_1_A = mkA "trägen" "träget" ;
  traengd_av_1_1_A = mkA "trängd" "trängt" ;
  traetlysten_av_1_1_A = mkA "trätlysten" "trätlystet" ;
  traadsliten_av_1_1_A = mkA "trådsliten" "trådslitet" ;
  troettkoerd_av_1_1_A = mkA "tröttkörd" "tröttkört" ;
  tullfri_av_1_A = mkA "tullfri" "tullfritt" ;
  tungkoerd_av_1_1_A = mkA "tungkörd" "tungkört" ;
  tungsoevd_av_1_1_A = mkA "tungsövd" "tungsövt" ;
  tunn_av_1_A = mkA "tunn" "tunt" ;
  tunnsliten_av_1_A = mkA "tunnsliten" "tunnslitet" ;
  tvehaagsen_av_1_1_A = mkA "tvehågsen" "tvehågset" ;
  tvungen_av_1_A = mkA "tvungen" "tvunget" ;
  tvaerhuggen_av_1_1_A = mkA "tvärhuggen" "tvärhugget" ;
  tvaerilsken_av_1_1_A = mkA "tvärilsken" "tvärilsket" ;
  tvaerskuren_av_1_1_A = mkA "tvärskuren" "tvärskuret" ;
  tvaastruken_av_1_1_A = mkA "tvåstruken" "tvåstruket" ;
  tyckmycken_av_1_A = mkA "tyckmycken" "tyckmycket" ;
  tyken_av_1_A = mkA "tyken" "tyket" ;
  tystlaaten_av_1_1_A = mkA "tystlåten" "tystlåtet" ;
  taenkvaerd_av_1_1_A = mkA "tänkvärd" "tänkvärt" ;
  taerd_av_1_1_A = mkA "tärd" "tärt" ;
  taettbebyggd_av_1_1_A = mkA "tättbebyggd" "tättbebyggt" ;
  taettskriven_av_1_1_A = mkA "tättskriven" "tättskrivet" ;
  taaroegd_av_1_1_A = mkA "tårögd" "tårögt" ;
  toeckenhoeljd_av_1_1_A = mkA "töckenhöljd" "töckenhöljt" ;
  undangjord_av_1_A = mkA "undangjord" "undangjort" ;
  undangoemd_av_1_1_A = mkA "undangömd" "undangömt" ;
  undanlagd_av_1_A = mkA "undanlagd" "undanlagt" ;
  undanskymd_av_1_A = mkA "undanskymd" "undanskymt" ;
  undanstaelld_av_1_1_A = mkA "undanställd" "undanställt" ;
  undantagsfri_av_1_A = mkA "undantagsfri" "undantagsfritt" ;
  underfoersoerjd_av_1_1_A = mkA "underförsörjd" "underförsörjt" ;
  undergiven_av_1_A = mkA "undergiven" "undergivet" ;
  underhaallsfri_av_1_1_A = mkA "underhållsfri" "underhållsfritt" ;
  underkyld_av_1_A = mkA "underkyld" "underkylt" ;
  underlaegsen_av_1_1_A = mkA "underlägsen" "underlägset" ;
  undermedveten_av_1_A = mkA "undermedveten" "undermedvetet" ;
  undernaerd_av_1_1_A = mkA "undernärd" "undernärt" ;
  understucken_av_1_A = mkA "understucken" "understucket" ;
  understyrd_av_1_A = mkA "understyrd" "understyrt" ;
  undfallen_av_1_A = mkA "undfallen" "undfallet" ;
  undransvaerd_av_1_1_A = mkA "undransvärd" "undransvärt" ;
  unken_av_1_A = mkA "unken" "unket" ;
  uppbunden_av_1_A = mkA "uppbunden" "uppbundet" ;
  uppburen_av_1_A = mkA "uppburen" "uppburet" ;
  uppdaemd_av_1_1_A = mkA "uppdämd" "uppdämt" ;
  uppflugen_av_1_A = mkA "uppflugen" "uppfluget" ;
  uppfaelld_av_1_1_A = mkA "uppfälld" "uppfällt" ;
  uppgiven_av_1_A = mkA "uppgiven" "uppgivet" ;
  uppgjord_av_1_A = mkA "uppgjord" "uppgjort" ;
  upphoejd_av_1_1_A = mkA "upphöjd" "upphöjt" ;
  uppknuten_av_1_A = mkA "uppknuten" "uppknutet" ;
  uppkoerd_av_1_1_A = mkA "uppkörd" "uppkört" ;
  upplagd_av_1_A = mkA "upplagd" "upplagt" ;
  upplupen_av_1_A = mkA "upplupen" "upplupet" ;
  upploejd_av_1_1_A = mkA "upplöjd" "upplöjt" ;
  uppringd_av_1_A = mkA "uppringd" "uppringt" ;
  uppriven_av_1_A = mkA "uppriven" "upprivet" ;
  upprutten_av_1_A = mkA "upprutten" "uppruttet" ;
  upprymd_av_1_A = mkA "upprymd" "upprymt" ;
  upproerd_av_1_1_A = mkA "upprörd" "upprört" ;
  uppsagd_av_1_A = mkA "uppsagd" "uppsagt" ;
  uppskraemd_av_1_1_A = mkA "uppskrämd" "uppskrämt" ;
  uppsluppen_av_1_A = mkA "uppsluppen" "uppsluppet" ;
  uppstaanden_av_1_1_A = mkA "uppstånden" "uppståndet" ;
  uppsvullen_av_1_A = mkA "uppsvullen" "uppsvullet" ;
  uppsvaelld_av_1_1_A = mkA "uppsvälld" "uppsvällt" ;
  upptagen_av_1_A = mkA "upptagen" "upptaget" ;
  uppvuxen_av_1_A = mkA "uppvuxen" "uppvuxet" ;
  uppaatboejd_av_1_1_A = mkA "uppåtböjd" "uppåtböjt" ;
  urfaelld_av_1_1_A = mkA "urfälld" "urfällt" ;
  urnupen_av_1_A = mkA "urnupen" "urnupet" ;
  urtagen_av_1_A = mkA "urtagen" "urtaget" ;
  urvuxen_av_1_A = mkA "urvuxen" "urvuxet" ;
  utbyggd_av_1_A = mkA "utbyggd" "utbyggt" ;
  utdragen_av_1_A = mkA "utdragen" "utdraget" ;
  utdrucken_av_1_A = mkA "utdrucken" "utdrucket" ;
  utflugen_av_1_A = mkA "utflugen" "utfluget" ;
  utfrusen_av_1_A = mkA "utfrusen" "utfruset" ;
  utkyld_av_1_A = mkA "utkyld" "utkylt" ;
  utkoerd_av_1_1_A = mkA "utkörd" "utkört" ;
  utledsen_av_1_A = mkA "utledsen" "utledset" ;
  utlaerd_av_1_1_A = mkA "utlärd" "utlärt" ;
  utsagd_av_1_A = mkA "utsagd" "utsagt" ;
  utskaelld_av_1_1_A = mkA "utskälld" "utskällt" ;
  utskaemd_av_1_1_A = mkA "utskämd" "utskämt" ;
  utslagen_av_1_A = mkA "utslagen" "utslaget" ;
  utsliten_av_1_A = mkA "utsliten" "utslitet" ;
  utsprungen_av_1_A = mkA "utsprungen" "utsprunget" ;
  utstyrd_av_1_A = mkA "utstyrd" "utstyrt" ;
  utstaelld_av_1_1_A = mkA "utställd" "utställt" ;
  utsvulten_av_1_A = mkA "utsvulten" "utsvultet" ;
  utsvaengd_av_1_1_A = mkA "utsvängd" "utsvängt" ;
  utsaald_av_1_1_A = mkA "utsåld" "utsålt" ;
  utsoevd_av_1_1_A = mkA "utsövd" "utsövt" ;
  uttaenjd_av_1_1_A = mkA "uttänjd" "uttänjt" ;
  uttoejd_av_1_1_A = mkA "uttöjd" "uttöjt" ;
  utvald_av_1_A = mkA "utvald" "utvalt" ;
  utvecklingsstoerd_av_1_1_A = mkA "utvecklingsstörd" "utvecklingsstört" ;
  utaatboejd_av_1_1_A = mkA "utåtböjd" "utåtböjt" ;
  vaken_av_1_A = mkA "vaken" "vaket" ;
  valen_av_1_A = mkA "valen" "valet" ;
  valfri_av_1_A = mkA "valfri" "valfritt" ;
  vanekristen_av_1_A = mkA "vanekristen" "vanekristet" ;
  vantrogen_av_1_A = mkA "vantrogen" "vantroget" ;
  vapenfri_av_1_A = mkA "vapenfri" "vapenfritt" ;
  vattenburen_av_1_A = mkA "vattenburen" "vattenburet" ;
  vattenfri_av_1_A = mkA "vattenfri" "vattenfritt" ;
  vattenfylld_av_1_A = mkA "vattenfylld" "vattenfyllt" ;
  vattenkyld_av_1_A = mkA "vattenkyld" "vattenkylt" ;
  veckony_av_1_A = mkA "veckony" "veckonytt" ;
  vedertagen_av_1_A = mkA "vedertagen" "vedertaget" ;
  verklighetstrogen_av_1_A = mkA "verklighetstrogen" "verklighetstroget" ;
  vettskraemd_av_1_1_A = mkA "vettskrämd" "vettskrämt" ;
  vidoeppen_av_1_1_A = mkA "vidöppen" "vidöppet" ;
  vild_av_1_A = mkA "vild" "vilt" ;
  vildvuxen_av_1_A = mkA "vildvuxen" "vildvuxet" ;
  vilsegaangen_av_1_1_A = mkA "vilsegången" "vilsegånget" ;
  vilsen_av_1_A = mkA "vilsen" "vilset" ;
  vinddriven_av_1_A = mkA "vinddriven" "vinddrivet" ;
  vindoegd_av_1_1_A = mkA "vindögd" "vindögt" ;
  vingbruten_av_1_A = mkA "vingbruten" "vingbrutet" ;
  vinningslysten_av_1_A = mkA "vinningslysten" "vinningslystet" ;
  vissen_av_1_A = mkA "vissen" "visset" ;
  vittberoemd_av_1_1_A = mkA "vittberömd" "vittberömt" ;
  vriden_av_1_A = mkA "vriden" "vridet" ;
  vuxen_av_1_A = mkA "vuxen" "vuxet" ;
  vaederbiten_av_1_1_A = mkA "väderbiten" "väderbitet" ;
  vaederstinn_av_1_1_A = mkA "väderstinn" "väderstint" ;
  vaelavvaegd_av_1_1_A = mkA "välavvägd" "välavvägt" ;
  vaelbehaallen_av_1_1_A = mkA "välbehållen" "välbehållet" ;
  vaelbelaegen_av_1_1_A = mkA "välbelägen" "välbeläget" ;
  vaelbestaelld_av_1_1_A = mkA "välbeställd" "välbeställt" ;
  vaelbetald_av_1_1_A = mkA "välbetald" "välbetalt" ;
  vaelboren_av_1_1_A = mkA "välboren" "välboret" ;
  vaelbyggd_av_1_1_A = mkA "välbyggd" "välbyggt" ;
  vaelfylld_av_1_1_A = mkA "välfylld" "välfyllt" ;
  vaelgjord_av_1_1_A = mkA "välgjord" "välgjort" ;
  vaelhaengd_av_1_1_A = mkA "välhängd" "välhängt" ;
  vaelhaallen_av_1_1_A = mkA "välhållen" "välhållet" ;
  vaelnaerd_av_1_1_A = mkA "välnärd" "välnärt" ;
  vaelploejd_av_1_1_A = mkA "välplöjd" "välplöjt" ;
  vaelskriven_av_1_1_A = mkA "välskriven" "välskrivet" ;
  vaelskuren_av_1_1_A = mkA "välskuren" "välskuret" ;
  vaelsmord_av_1_1_A = mkA "välsmord" "välsmort" ;
  vaelstaelld_av_1_1_A = mkA "välställd" "välställt" ;
  vaeltagen_av_1_1_A = mkA "vältagen" "vältaget" ;
  vaelvd_av_1_1_A = mkA "välvd" "välvt" ;
  vaelvuxen_av_1_1_A = mkA "välvuxen" "välvuxet" ;
  vaenstervriden_av_1_1_A = mkA "vänstervriden" "vänstervridet" ;
  vaerd_av_1_1_A = mkA "värd" "värt" ;
  vaerderingsfri_av_1_1_A = mkA "värderingsfri" "värderingsfritt" ;
  vaerkbruten_av_1_1_A = mkA "värkbruten" "värkbrutet" ;
  vaerldsberoemd_av_1_1_A = mkA "världsberömd" "världsberömt" ;
  vaerldserfaren_av_1_1_A = mkA "världserfaren" "världserfaret" ;
  vaesensskild_av_1_1_A = mkA "väsensskild" "väsensskilt" ;
  vaetskefylld_av_1_1_A = mkA "vätskefylld" "vätskefyllt" ;
  vaevburen_av_1_1_A = mkA "vävburen" "vävburet" ;
  vaaldtaektsdoemd_av_1_1_A = mkA "våldtäktsdömd" "våldtäktsdömt" ;
  voerdnadsvaerd_av_1_1_A = mkA "vördnadsvärd" "vördnadsvärt" ;
  whiskysprucken_av_1_A = mkA "whiskysprucken" "whiskysprucket" ;
  yllen_av_1_A = mkA "yllen" "yllet" ;
  ynkansvaerd_av_1_1_A = mkA "ynkansvärd" "ynkansvärt" ;
  yrvaken_av_1_A = mkA "yrvaken" "yrvaket" ;
  yverboren_av_1_A = mkA "yverboren" "yverboret" ;
  aelskvaerd_av_1_1_A = mkA "älskvärd" "älskvärt" ;
  aerefoergaeten_av_1_1_A = mkA "äreförgäten" "äreförgätet" ;
  aerelysten_av_1_1_A = mkA "ärelysten" "ärelystet" ;
  aerofylld_av_1_1_A = mkA "ärofylld" "ärofyllt" ;
  aeventyrslysten_av_1_1_A = mkA "äventyrslysten" "äventyrslystet" ;
  aalderstigen_av_1_1_A = mkA "ålderstigen" "ålderstiget" ;
  aalderstyngd_av_1_1_A = mkA "ålderstyngd" "ålderstyngt" ;
  aangestfylld_av_1_1_A = mkA "ångestfylld" "ångestfyllt" ;
  aapen_av_1_1_A = mkA "åpen" "åpet" ;
  aatgaangen_av_1_1_A = mkA "åtgången" "åtgånget" ;
  aatraavaerd_av_1_1_A = mkA "åtråvärd" "åtråvärt" ;
  oedesbestaemd_av_1_1_A = mkA "ödesbestämd" "ödesbestämt" ;
  oemkansvaerd_av_1_1_A = mkA "ömkansvärd" "ömkansvärt" ;
  oenskvaerd_av_1_1_A = mkA "önskvärd" "önskvärt" ;
  oeppen_av_1_1_A = mkA "öppen" "öppet" ;
  oeverbliven_av_1_1_A = mkA "överbliven" "överblivet" ;
  oeverbyggd_av_1_1_A = mkA "överbyggd" "överbyggt" ;
  oeverdriven_av_1_1_A = mkA "överdriven" "överdrivet" ;
  oeverfylld_av_1_1_A = mkA "överfylld" "överfyllt" ;
  oeverfoerd_av_1_1_A = mkA "överförd" "överfört" ;
  oevergiven_av_1_1_A = mkA "övergiven" "övergivet" ;
  oeverkoerd_av_1_1_A = mkA "överkörd" "överkört" ;
  oeverlagd_av_1_1_A = mkA "överlagd" "överlagt" ;
  oeverlupen_av_1_1_A = mkA "överlupen" "överlupet" ;
  oeverlaegsen_av_1_1_A = mkA "överlägsen" "överlägset" ;
  oevermogen_av_1_1_A = mkA "övermogen" "övermoget" ;
  oeversiggiven_av_1_1_A = mkA "översiggiven" "översiggivet" ;
  oeverstyrd_av_1_1_A = mkA "överstyrd" "överstyrt" ;
  oeverstaanden_av_1_1_A = mkA "överstånden" "överståndet" ;
  oevervuxen_av_1_1_A = mkA "övervuxen" "övervuxet" ;
  Bristoltrakt_nn_1_N = mkN "Bristoltrakt" ;
  C14_metod_nn_1_N = mkN "C14-metod" ;
  E_godkaend_av_1_1_A = mkA "E-godkänd" ;
  Eisenhowerepok_nn_1_N = mkN "Eisenhowerepok" ;
  Europaunion_nn_1_N = mkN "Europaunion" ;
  IB_avsloejande_nn_1_1_N = mkN "IB-avslöjande" ;
  Internet_nn_1_N = mkN "Internet" ;
  Ljubjankafaengelse_nn_1_1_N = mkN "Ljubjankafängelse" ;
  Nationalencyklopedi_nn_1_N = mkN "Nationalencyklopedi" ;
  OCR_ande_nn_1_N = mkN "OCR-ande" ;
  OCRande_nn_1_N = mkN "OCR:ande" ;
  OK_av_1_A = mkA "OK" ;
  Risk_nn_1_N = mkN "Risk" ;
  Stillahavsfiske_nn_1_N = mkN "Stillahavsfiske" ;
  Stockholmsomraade_nn_1_1_N = mkN "Stockholmsområde" ;
  USA_vaenlig_av_1_1_A = mkA "USA-vänlig" ;
  abbrevierbarhet_nn_1_N = mkN "abbrevierbarhet" ;
  abdikerbarhet_nn_1_N = mkN "abdikerbarhet" ;
  abonnerbarhet_nn_1_N = mkN "abonnerbarhet" ;
  aborterbarhet_nn_1_N = mkN "aborterbarhet" ;
  abortraadgivning_nn_1_1_N = mkN "abortrådgivning" ;
  abraderbarhet_nn_1_N = mkN "abraderbarhet" ;
  abrupthet_nn_1_N = mkN "abrupthet" ;
  absoluthet_nn_1_N = mkN "absoluthet" ;
  absolverbarhet_nn_1_N = mkN "absolverbarhet" ;
  absorberbarhet_nn_1_N = mkN "absorberbarhet" ;
  abstraherbarhet_nn_1_N = mkN "abstraherbarhet" ;
  abstrakthet_nn_1_N = mkN "abstrakthet" ;
  absurdhet_nn_1_N = mkN "absurdhet" ;
  accederbarhet_nn_1_N = mkN "accederbarhet" ;
  accelererbarhet_nn_1_N = mkN "accelererbarhet" ;
  accentuerbarhet_nn_1_N = mkN "accentuerbarhet" ;
  accepterbarhet_nn_1_N = mkN "accepterbarhet" ;
  acklimatiserbarhet_nn_1_N = mkN "acklimatiserbarhet" ;
  ackommoderbarhet_nn_1_N = mkN "ackommoderbarhet" ;
  ackompanjerbarhet_nn_1_N = mkN "ackompanjerbarhet" ;
  ackorderbarhet_nn_1_N = mkN "ackorderbarhet" ;
  ackrediterbarhet_nn_1_N = mkN "ackrediterbarhet" ;
  ackumulerbarhet_nn_1_N = mkN "ackumulerbarhet" ;
  ackvirerbarhet_nn_1_N = mkN "ackvirerbarhet" ;
  adamsdraekt_nn_1_1_N = mkN "adamsdräkt" ;
  adapterbarhet_nn_1_N = mkN "adapterbarhet" ;
  adderbarhet_nn_1_N = mkN "adderbarhet" ;
  adelshoegfaerd_nn_1_1_N = mkN "adelshögfärd" ;
  adenoid_av_1_A = mkA "adenoid" ;
  adjungerbarhet_nn_1_N = mkN "adjungerbarhet" ;
  adlighet_nn_1_N = mkN "adlighet" ;
  administrerbarhet_nn_1_N = mkN "administrerbarhet" ;
  adopterbarhet_nn_1_N = mkN "adopterbarhet" ;
  adresserbarhet_nn_1_N = mkN "adresserbarhet" ;
  adsorberbarhet_nn_1_N = mkN "adsorberbarhet" ;
  adstringerande_av_1_A = mkA "adstringerande" ;
  aducerbarhet_nn_1_N = mkN "aducerbarhet" ;
  advocerbarhet_nn_1_N = mkN "advocerbarhet" ;
  advokathjaelp_nn_1_1_N = mkN "advokathjälp" ;
  aerologi_nn_1_N = mkN "aerologi" ;
  aerosolform_nn_1_N = mkN "aerosolform" ;
  afficierbarhet_nn_1_N = mkN "afficierbarhet" ;
  affinerbarhet_nn_1_N = mkN "affinerbarhet" ;
  affischerbarhet_nn_1_N = mkN "affischerbarhet" ;
  affaersdrivande_av_1_1_A = mkA "affärsdrivande" ;
  affaersmaessighet_nn_1_1_N = mkN "affärsmässighet" ;
  afrikaans_nn_1_N = mkN "afrikaans" ;
  afrikaniserbarhet_nn_1_N = mkN "afrikaniserbarhet" ;
  agerbarhet_nn_1_N = mkN "agerbarhet" ;
  aggande_av_1_A = mkA "aggande" ;
  agglomererbarhet_nn_1_N = mkN "agglomererbarhet" ;
  agglutinerbarhet_nn_1_N = mkN "agglutinerbarhet" ;
  agiterbarhet_nn_1_N = mkN "agiterbarhet" ;
  agorafobi_nn_1_N = mkN "agorafobi" ;
  agrikulturkemi_nn_1_N = mkN "agrikulturkemi" ;
  agronomi_nn_1_N = mkN "agronomi" ;
  ajour_av_1_A = mkA "ajour" ;
  ajournerbarhet_nn_1_N = mkN "ajournerbarhet" ;
  akribi_nn_1_N = mkN "akribi" ;
  aktiesparande_nn_1_N = mkN "aktiesparande" ;
  aktiverbarhet_nn_1_N = mkN "aktiverbarhet" ;
  aktningsfullhet_nn_1_N = mkN "aktningsfullhet" ;
  aktningsvaerdhet_nn_1_1_N = mkN "aktningsvärdhet" ;
  aktualiserbarhet_nn_1_N = mkN "aktualiserbarhet" ;
  akuthjaelp_nn_1_1_N = mkN "akuthjälp" ;
  akutvaard_nn_1_1_N = mkN "akutvård" ;
  alabasterliknande_av_1_A = mkA "alabasterliknande" ;
  alarmerande_av_1_A = mkA "alarmerande" ;
  alarmerbarhet_nn_1_N = mkN "alarmerbarhet" ;
  albuminuri_nn_1_N = mkN "albuminuri" ;
  ale_nn_1_N = mkN "ale" ;
  alfabetiserbarhet_nn_1_N = mkN "alfabetiserbarhet" ;
  algologi_nn_1_N = mkN "algologi" ;
  algonk_nn_1_N = mkN "algonk" ;
  alienerbarhet_nn_1_N = mkN "alienerbarhet" ;
  alkaliblaatt_nn_1_1_N = mkN "alkaliblått" ;
  alkemi_nn_1_N = mkN "alkemi" ;
  alkoholmissbrukande_nn_1_N = mkN "alkoholmissbrukande" ;
  alkoholsvaghet_nn_1_N = mkN "alkoholsvaghet" ;
  alldaglighet_nn_1_N = mkN "alldaglighet" ;
  allegoriserbarhet_nn_1_N = mkN "allegoriserbarhet" ;
  allehanda_av_1_A = mkA "allehanda" ;
  allemansraett_nn_1_1_N = mkN "allemansrätt" ;
  allen_av_1_A = mkA "allen" ;
  allena_av_1_A = mkA "allena" ;
  allenaraadande_av_1_1_A = mkA "allenarådande" ;
  allergologi_nn_1_N = mkN "allergologi" ;
  allierbarhet_nn_1_N = mkN "allierbarhet" ;
  allittererbarhet_nn_1_N = mkN "allittererbarhet" ;
  allmakt_nn_1_N = mkN "allmakt" ;
  allmaenfarlighet_nn_1_1_N = mkN "allmänfarlighet" ;
  allmaenmaensklighet_nn_1_1_N = mkN "allmänmänsklighet" ;
  allmaennelighet_nn_1_1_N = mkN "allmännelighet" ;
  allmaennyttighet_nn_1_1_N = mkN "allmännyttighet" ;
  allmaenpraktiserande_av_1_1_A = mkA "allmänpraktiserande" ;
  allokerbarhet_nn_1_N = mkN "allokerbarhet" ;
  allomfattande_av_1_A = mkA "allomfattande" ;
  allopati_nn_1_N = mkN "allopati" ;
  allraheligaste_av_1_A = mkA "allraheligaste" ;
  allround_av_1_A = mkA "allround" ;
  allseende_av_1_A = mkA "allseende" ;
  allsidighet_nn_1_N = mkN "allsidighet" ;
  allskoens_av_1_1_A = mkA "allsköns" ;
  allsmaektighet_nn_1_1_N = mkN "allsmäktighet" ;
  allsvaaldighet_nn_1_1_N = mkN "allsvåldighet" ;
  alltomfattande_av_1_A = mkA "alltomfattande" ;
  alluderbarhet_nn_1_N = mkN "alluderbarhet" ;
  allvarlighet_nn_1_N = mkN "allvarlighet" ;
  allvarstyngdhet_nn_1_N = mkN "allvarstyngdhet" ;
  allvetande_av_1_A = mkA "allvetande" ;
  allvishet_nn_1_N = mkN "allvishet" ;
  allvaeders_av_1_1_A = mkA "allväders" ;
  alme_nn_1_N = mkN "alme" ;
  alteasirap_nn_1_N = mkN "alteasirap" ;
  alternerbarhet_nn_1_N = mkN "alternerbarhet" ;
  aluminerbarhet_nn_1_N = mkN "aluminerbarhet" ;
  amalgamerbarhet_nn_1_N = mkN "amalgamerbarhet" ;
  amatoermaessighet_nn_1_1_N = mkN "amatörmässighet" ;
  ambidextri_nn_1_N = mkN "ambidextri" ;
  ambiofoni_nn_1_N = mkN "ambiofoni" ;
  ambulerbarhet_nn_1_N = mkN "ambulerbarhet" ;
  amerikaniserbarhet_nn_1_N = mkN "amerikaniserbarhet" ;
  amning_nn_1_N = mkN "amning" ;
  amorterbarhet_nn_1_N = mkN "amorterbarhet" ;
  amperhet_nn_1_N = mkN "amperhet" ;
  amplifierbarhet_nn_1_N = mkN "amplifierbarhet" ;
  amplitudmodulerbarhet_nn_1_N = mkN "amplitudmodulerbarhet" ;
  amputerbarhet_nn_1_N = mkN "amputerbarhet" ;
  analyserbarhet_nn_1_N = mkN "analyserbarhet" ;
  anarki_nn_1_N = mkN "anarki" ;
  anatomi_nn_1_N = mkN "anatomi" ;
  andaktsfullhet_nn_1_N = mkN "andaktsfullhet" ;
  andaktsutoevning_nn_1_1_N = mkN "andaktsutövning" ;
  andefattighet_nn_1_N = mkN "andefattighet" ;
  andeloeshet_nn_1_1_N = mkN "andelöshet" ;
  andfaaddhet_nn_1_1_N = mkN "andfåddhet" ;
  andlighet_nn_1_N = mkN "andlighet" ;
  andloeshet_nn_1_1_N = mkN "andlöshet" ;
  andmat_nn_1_N = mkN "andmat" ;
  andnoed_nn_1_1_N = mkN "andnöd" ;
  andraplans_av_1_A = mkA "andraplans" ;
  androfobi_nn_1_N = mkN "androfobi" ;
  androgynhet_nn_1_N = mkN "androgynhet" ;
  andryghet_nn_1_N = mkN "andryghet" ;
  andtrutenhet_nn_1_N = mkN "andtrutenhet" ;
  andaektighet_nn_1_1_N = mkN "andäktighet" ;
  anestesiologi_nn_1_N = mkN "anestesiologi" ;
  angelologi_nn_1_N = mkN "angelologi" ;
  angenaemhet_nn_1_1_N = mkN "angenämhet" ;
  angiografi_nn_1_N = mkN "angiografi" ;
  angiologi_nn_1_N = mkN "angiologi" ;
  angiverilag_nn_1_N = mkN "angiverilag" ;
  angliserbarhet_nn_1_N = mkN "angliserbarhet" ;
  angoraull_nn_1_N = mkN "angoraull" ;
  angraensande_av_1_1_A = mkA "angränsande" ;
  anhoerighet_nn_1_1_N = mkN "anhörighet" ;
  anhoeriginvandring_nn_1_1_N = mkN "anhöriginvandring" ;
  animerbarhet_nn_1_N = mkN "animerbarhet" ;
  ankommenhet_nn_1_N = mkN "ankommenhet" ;
  anlupenhet_nn_1_N = mkN "anlupenhet" ;
  anlaeggande_nn_1_1_N = mkN "anläggande" ;
  anlaeggning_nn_2_1_N = mkN "anläggning" ;
  anmaelningsplikt_nn_1_1_N = mkN "anmälningsplikt" ;
  anmaerkningsvaerdhet_nn_1_1_N = mkN "anmärkningsvärdhet" ;
  annalkande_av_1_A = mkA "annalkande" ;
  annalkande_nn_1_N = mkN "annalkande" ;
  annekterbarhet_nn_1_N = mkN "annekterbarhet" ;
  annihilerbarhet_nn_1_N = mkN "annihilerbarhet" ;
  annonserbarhet_nn_1_N = mkN "annonserbarhet" ;
  annorlunda_av_1_A = mkA "annorlunda" ;
  annoterbarhet_nn_1_N = mkN "annoterbarhet" ;
  annullerbarhet_nn_1_N = mkN "annullerbarhet" ;
  anodiserbarhet_nn_1_N = mkN "anodiserbarhet" ;
  anonymhet_nn_1_N = mkN "anonymhet" ;
  anonymiserbarhet_nn_1_N = mkN "anonymiserbarhet" ;
  anorektiskhet_nn_1_N = mkN "anorektiskhet" ;
  anpart_nn_1_N = mkN "anpart" ;
  anpassbarhet_nn_1_N = mkN "anpassbarhet" ;
  anpasslighet_nn_1_N = mkN "anpasslighet" ;
  anrikhet_nn_1_N = mkN "anrikhet" ;
  anseddhet_nn_1_N = mkN "anseddhet" ;
  ansenlighet_nn_1_N = mkN "ansenlighet" ;
  ansiktsblind_av_1_A = mkA "ansiktsblind" ;
  ansiktsigenkaenning_nn_1_1_N = mkN "ansiktsigenkänning" ;
  anslagsbeviljande_av_1_A = mkA "anslagsbeviljande" ;
  anslagsgivande_av_1_A = mkA "anslagsgivande" ;
  anslaaende_av_1_1_A = mkA "anslående" ;
  anspraaksfullhet_nn_1_1_N = mkN "anspråksfullhet" ;
  anspaend_av_1_1_A = mkA "anspänd" ;
  anspaendhet_nn_1_1_N = mkN "anspändhet" ;
  anstaltsvaard_nn_1_1_N = mkN "anstaltsvård" ;
  anstrukenhet_nn_1_N = mkN "anstrukenhet" ;
  anstraengande_av_1_1_A = mkA "ansträngande" ;
  anstraengdhet_nn_1_1_N = mkN "ansträngdhet" ;
  anstuckenhet_nn_1_N = mkN "anstuckenhet" ;
  anstaellningstrygghet_nn_1_1_N = mkN "anställningstrygghet" ;
  ansvarighet_nn_1_N = mkN "ansvarighet" ;
  ansvarsfullhet_nn_1_N = mkN "ansvarsfullhet" ;
  ansvarskaennande_av_1_1_A = mkA "ansvarskännande" ;
  ansvarskaennande_nn_1_1_N = mkN "ansvarskännande" ;
  ansvarsloeshet_nn_1_1_N = mkN "ansvarslöshet" ;
  ansvarstagande_av_1_A = mkA "ansvarstagande" ;
  ansvarstagande_nn_1_N = mkN "ansvarstagande" ;
  ansvaelldhet_nn_1_1_N = mkN "ansvälldhet" ;
  antaglighet_nn_1_N = mkN "antaglighet" ;
  anteciperbarhet_nn_1_N = mkN "anteciperbarhet" ;
  antedaterbarhet_nn_1_N = mkN "antedaterbarhet" ;
  anti_av_1_A = mkA "anti" ;
  antichambrerbarhet_nn_1_N = mkN "antichambrerbarhet" ;
  antikiserbarhet_nn_1_N = mkN "antikiserbarhet" ;
  antimateria_nn_1_N = mkN "antimateria" ;
  antipsykiatri_nn_1_N = mkN "antipsykiatri" ;
  antropofagi_nn_1_N = mkN "antropofagi" ;
  antropologi_nn_1_N = mkN "antropologi" ;
  antroposofi_nn_1_N = mkN "antroposofi" ;
  antraeffbarhet_nn_1_1_N = mkN "anträffbarhet" ;
  anvaendarvaenlighet_nn_1_1_N = mkN "användarvänlighet" ;
  aorta_nn_1_N = mkN "aorta" ;
  apa_av_1_A = mkA "apa" ;
  apliknande_av_1_A = mkA "apliknande" ;
  apostroferbarhet_nn_1_N = mkN "apostroferbarhet" ;
  appellerbarhet_nn_1_N = mkN "appellerbarhet" ;
  applicerbarhet_nn_1_N = mkN "applicerbarhet" ;
  applaaderbarhet_nn_1_1_N = mkN "applåderbarhet" ;
  apporterbarhet_nn_1_N = mkN "apporterbarhet" ;
  apprecierbarhet_nn_1_N = mkN "apprecierbarhet" ;
  appreterbarhet_nn_1_N = mkN "appreterbarhet" ;
  approcherbarhet_nn_1_N = mkN "approcherbarhet" ;
  approximerbarhet_nn_1_N = mkN "approximerbarhet" ;
  apterbarhet_nn_1_N = mkN "apterbarhet" ;
  aptitretande_av_1_A = mkA "aptitretande" ;
  arabisktalande_av_1_A = mkA "arabisktalande" ;
  arabvaerld_nn_1_1_N = mkN "arabvärld" ;
  arbetsamhet_nn_1_N = mkN "arbetsamhet" ;
  arbetsbesparande_av_1_A = mkA "arbetsbesparande" ;
  arbetsduglighet_nn_1_N = mkN "arbetsduglighet" ;
  arbetsform_nn_1_N = mkN "arbetsform" ;
  arbetsfred_nn_1_N = mkN "arbetsfred" ;
  arbetsfoerdelning_nn_1_1_N = mkN "arbetsfördelning" ;
  arbetsfoerhet_nn_1_1_N = mkN "arbetsförhet" ;
  arbetsintensitet_nn_1_N = mkN "arbetsintensitet" ;
  arbetskraft_nn_1_N = mkN "arbetskraft" ;
  arbetskraftsinvandring_nn_1_N = mkN "arbetskraftsinvandring" ;
  arbetsorganisation_nn_1_N = mkN "arbetsorganisation" ;
  arbetsraett_nn_1_1_N = mkN "arbetsrätt" ;
  arbetsskraeck_nn_1_1_N = mkN "arbetsskräck" ;
  arbetsskygghet_nn_1_N = mkN "arbetsskygghet" ;
  arbetstakt_nn_1_N = mkN "arbetstakt" ;
  arbetsterapi_nn_1_N = mkN "arbetsterapi" ;
  arbetsvillighet_nn_1_N = mkN "arbetsvillighet" ;
  arbetsvaard_nn_1_1_N = mkN "arbetsvård" ;
  arbitrage_nn_1_N = mkN "arbitrage" ;
  arghet_nn_1_N = mkN "arghet" ;
  argsinthet_nn_1_N = mkN "argsinthet" ;
  argumenterbarhet_nn_1_N = mkN "argumenterbarhet" ;
  argumentrikedom_nn_1_N = mkN "argumentrikedom" ;
  arid_av_1_A = mkA "arid" ;
  arkaiserbarhet_nn_1_N = mkN "arkaiserbarhet" ;
  arkebuserbarhet_nn_1_N = mkN "arkebuserbarhet" ;
  arkeikum_nn_1_N = mkN "arkeikum" ;
  arkeologi_nn_1_N = mkN "arkeologi" ;
  arkiverbarhet_nn_1_N = mkN "arkiverbarhet" ;
  arkivforskning_nn_1_N = mkN "arkivforskning" ;
  armerbarhet_nn_1_N = mkN "armerbarhet" ;
  armgaang_nn_1_1_N = mkN "armgång" ;
  armhet_nn_1_N = mkN "armhet" ;
  armsvett_nn_1_N = mkN "armsvett" ;
  arrangerbarhet_nn_1_N = mkN "arrangerbarhet" ;
  arrenderbarhet_nn_1_N = mkN "arrenderbarhet" ;
  arresterbarhet_nn_1_N = mkN "arresterbarhet" ;
  arronderbarhet_nn_1_N = mkN "arronderbarhet" ;
  arsenikvaete_nn_1_1_N = mkN "arsenikväte" ;
  artegenhet_nn_1_N = mkN "artegenhet" ;
  artfraemmande_av_1_1_A = mkA "artfrämmande" ;
  artikulerbarhet_nn_1_N = mkN "artikulerbarhet" ;
  artillerield_nn_1_N = mkN "artillerield" ;
  artonaarsmyndighet_nn_1_1_N = mkN "artonårsmyndighet" ;
  artrikhet_nn_1_N = mkN "artrikhet" ;
  artskildhet_nn_1_N = mkN "artskildhet" ;
  arvloeshet_nn_1_1_N = mkN "arvlöshet" ;
  arvoderbarhet_nn_1_N = mkN "arvoderbarhet" ;
  asatroende_av_1_A = mkA "asatroende" ;
  asfalterbarhet_nn_1_N = mkN "asfalterbarhet" ;
  askblond_av_1_A = mkA "askblond" ;
  aske_nn_1_N = mkN "aske" ;
  askfrihet_nn_1_N = mkN "askfrihet" ;
  askspridning_nn_1_N = mkN "askspridning" ;
  aspbark_nn_1_N = mkN "aspbark" ;
  aspe_nn_1_N = mkN "aspe" ;
  aspirerbarhet_nn_1_N = mkN "aspirerbarhet" ;
  assignerbarhet_nn_1_N = mkN "assignerbarhet" ;
  assimilerbarhet_nn_1_N = mkN "assimilerbarhet" ;
  assisterbarhet_nn_1_N = mkN "assisterbarhet" ;
  associationspsykologi_nn_1_N = mkN "associationspsykologi" ;
  associationsrikedom_nn_1_N = mkN "associationsrikedom" ;
  associerbarhet_nn_1_N = mkN "associerbarhet" ;
  assurerbarhet_nn_1_N = mkN "assurerbarhet" ;
  astrologi_nn_1_N = mkN "astrologi" ;
  astronomi_nn_1_N = mkN "astronomi" ;
  asylraett_nn_1_1_N = mkN "asylrätt" ;
  ataraxi_nn_1_N = mkN "ataraxi" ;
  atomenergi_nn_1_N = mkN "atomenergi" ;
  atrofierbarhet_nn_1_N = mkN "atrofierbarhet" ;
  attackerbarhet_nn_1_N = mkN "attackerbarhet" ;
  attesterbarhet_nn_1_N = mkN "attesterbarhet" ;
  attraherbarhet_nn_1_N = mkN "attraherbarhet" ;
  attrapperbarhet_nn_1_N = mkN "attrapperbarhet" ;
  attribuerbarhet_nn_1_N = mkN "attribuerbarhet" ;
  audiologi_nn_1_N = mkN "audiologi" ;
  auktionerbarhet_nn_1_N = mkN "auktionerbarhet" ;
  auktoriserbarhet_nn_1_N = mkN "auktoriserbarhet" ;
  auktoritetsbundenhet_nn_1_N = mkN "auktoritetsbundenhet" ;
  auktorraett_nn_1_1_N = mkN "auktorrätt" ;
  auktorsraett_nn_1_1_N = mkN "auktorsrätt" ;
  auskulterbarhet_nn_1_N = mkN "auskulterbarhet" ;
  autenticerbarhet_nn_1_N = mkN "autenticerbarhet" ;
  autentifierbarhet_nn_1_N = mkN "autentifierbarhet" ;
  autentiserbarhet_nn_1_N = mkN "autentiserbarhet" ;
  automatateori_nn_1_N = mkN "automatateori" ;
  automateld_nn_1_N = mkN "automateld" ;
  automatiserbarhet_nn_1_N = mkN "automatiserbarhet" ;
  automatteori_nn_1_N = mkN "automatteori" ;
  autonomi_nn_1_N = mkN "autonomi" ;
  av_av_1_A = mkA "av" ;
  avancerbarhet_nn_1_N = mkN "avancerbarhet" ;
  avannonserbarhet_nn_1_N = mkN "avannonserbarhet" ;
  avantgarde_nn_1_N = mkN "avantgarde" ;
  avbindande_nn_1_N = mkN "avbindande" ;
  avblaendning_nn_1_1_N = mkN "avbländning" ;
  avdragsraett_nn_1_1_N = mkN "avdragsrätt" ;
  avdramatiserbarhet_nn_1_N = mkN "avdramatiserbarhet" ;
  aversionsterapi_nn_1_N = mkN "aversionsterapi" ;
  avfallsvirke_nn_1_N = mkN "avfallsvirke" ;
  avfaellighet_nn_1_1_N = mkN "avfällighet" ;
  avgasrening_nn_1_N = mkN "avgasrening" ;
  avgiftsfrihet_nn_1_N = mkN "avgiftsfrihet" ;
  avgoerande_av_1_1_A = mkA "avgörande" ;
  avhumaniserande_nn_1_N = mkN "avhumaniserande" ;
  avhumanisering_nn_1_N = mkN "avhumanisering" ;
  avhysning_nn_1_N = mkN "avhysning" ;
  avhaengighet_nn_1_1_N = mkN "avhängighet" ;
  avhaallsamhet_nn_1_1_N = mkN "avhållsamhet" ;
  aviserbarhet_nn_1_N = mkN "aviserbarhet" ;
  avisning_nn_1_N = mkN "avisning" ;
  avkoloniserbarhet_nn_1_N = mkN "avkoloniserbarhet" ;
  avkomstraett_nn_1_1_N = mkN "avkomsträtt" ;
  avkriminaliserbarhet_nn_1_N = mkN "avkriminaliserbarhet" ;
  avkristning_nn_1_N = mkN "avkristning" ;
  avlat_nn_1_N = mkN "avlat" ;
  avlaegsenhet_nn_1_1_N = mkN "avlägsenhet" ;
  avlaesbarhet_nn_1_1_N = mkN "avläsbarhet" ;
  avlaanghet_nn_1_1_N = mkN "avlånghet" ;
  avmagnetiserbarhet_nn_1_N = mkN "avmagnetiserbarhet" ;
  avmystifierande_nn_1_N = mkN "avmystifierande" ;
  avmystifierbarhet_nn_1_N = mkN "avmystifierbarhet" ;
  avmystifiering_nn_1_N = mkN "avmystifiering" ;
  avmaetthet_nn_1_1_N = mkN "avmätthet" ;
  avnazifierbarhet_nn_1_N = mkN "avnazifierbarhet" ;
  avoghet_nn_1_N = mkN "avoghet" ;
  avpatrullerbarhet_nn_1_N = mkN "avpatrullerbarhet" ;
  avpersonifierande_nn_1_N = mkN "avpersonifierande" ;
  avpersonifiering_nn_1_N = mkN "avpersonifiering" ;
  avpolitiserbarhet_nn_1_N = mkN "avpolitiserbarhet" ;
  avpolletterbarhet_nn_1_N = mkN "avpolletterbarhet" ;
  avportraetterbarhet_nn_1_1_N = mkN "avporträtterbarhet" ;
  avprickning_nn_1_N = mkN "avprickning" ;
  avradikaliserande_nn_1_N = mkN "avradikaliserande" ;
  avradikalisering_nn_1_N = mkN "avradikalisering" ;
  avreagerbarhet_nn_1_N = mkN "avreagerbarhet" ;
  avregistrerbarhet_nn_1_N = mkN "avregistrerbarhet" ;
  avreglerbarhet_nn_1_N = mkN "avreglerbarhet" ;
  avromantiserbarhet_nn_1_N = mkN "avromantiserbarhet" ;
  avsides_av_1_A = mkA "avsides" ;
  avsigkommenhet_nn_1_N = mkN "avsigkommenhet" ;
  avsiktlighet_nn_1_N = mkN "avsiktlighet" ;
  avskiljning_nn_1_N = mkN "avskiljning" ;
  avskogning_nn_1_N = mkN "avskogning" ;
  avskyvaerdhet_nn_1_1_N = mkN "avskyvärdhet" ;
  avslagenhet_nn_1_N = mkN "avslagenhet" ;
  avsmak_nn_1_N = mkN "avsmak" ;
  avsocialiserbarhet_nn_1_N = mkN "avsocialiserbarhet" ;
  avspaend_av_1_1_A = mkA "avspänd" ;
  avspaendhet_nn_1_1_N = mkN "avspändhet" ;
  avstaliniserbarhet_nn_1_N = mkN "avstaliniserbarhet" ;
  avsaettande_nn_1_1_N = mkN "avsättande" ;
  avsaettlighet_nn_1_1_N = mkN "avsättlighet" ;
  avtagande_av_1_A = mkA "avtagande" ;
  avtagande_nn_1_N = mkN "avtagande" ;
  avtagbarhet_nn_1_N = mkN "avtagbarhet" ;
  avtalsenlighet_nn_1_N = mkN "avtalsenlighet" ;
  avtalsraett_nn_1_1_N = mkN "avtalsrätt" ;
  avtalsslutande_av_1_A = mkA "avtalsslutande" ;
  avtorkning_nn_1_N = mkN "avtorkning" ;
  avtrubbning_nn_1_N = mkN "avtrubbning" ;
  avtaerdhet_nn_1_1_N = mkN "avtärdhet" ;
  avundsamhet_nn_1_N = mkN "avundsamhet" ;
  avundsjukhet_nn_1_N = mkN "avundsjukhet" ;
  avundsvaerdhet_nn_1_1_N = mkN "avundsvärdhet" ;
  avvattning_nn_1_N = mkN "avvattning" ;
  avvikande_av_1_A = mkA "avvikande" ;
  avvaepnande_av_1_1_A = mkA "avväpnande" ;
  avytterlighet_nn_1_N = mkN "avytterlighet" ;
  axande_nn_1_N = mkN "axande" ;
  axiomatiserbarhet_nn_1_N = mkN "axiomatiserbarhet" ;
  ayrshireboskap_nn_1_N = mkN "ayrshireboskap" ;
  azur_nn_1_N = mkN "azur" ;
  bacillskraeck_nn_1_1_N = mkN "bacillskräck" ;
  backighet_nn_1_N = mkN "backighet" ;
  bagage_nn_1_N = mkN "bagage" ;
  bagatelliserbarhet_nn_1_N = mkN "bagatelliserbarhet" ;
  bajskorv_nn_1_N = mkN "bajskorv" ;
  bakdantande_nn_1_N = mkN "bakdantande" ;
  bakersta_av_1_A = mkA "bakersta" ;
  bakfullhet_nn_1_N = mkN "bakfullhet" ;
  bakis_av_1_A = mkA "bakis" ;
  bakom_av_1_A = mkA "bakom" ;
  bakomliggande_av_1_A = mkA "bakomliggande" ;
  bakomsittande_av_1_A = mkA "bakomsittande" ;
  bakslughet_nn_1_N = mkN "bakslughet" ;
  baktericid_av_1_A = mkA "baktericid" ;
  bakteriedoedande_av_1_1_A = mkA "bakteriedödande" ;
  bakteriologi_nn_1_N = mkN "bakteriologi" ;
  baktunghet_nn_1_N = mkN "baktunghet" ;
  bakvaend_av_1_1_A = mkA "bakvänd" ;
  bakvaendhet_nn_1_1_N = mkN "bakvändhet" ;
  bakaatblickande_av_1_1_A = mkA "bakåtblickande" ;
  bakaatraeknande_av_1_1_A = mkA "bakåträknande" ;
  bakaatstraevande_av_1_1_A = mkA "bakåtsträvande" ;
  balanserbarhet_nn_1_N = mkN "balanserbarhet" ;
  balansgaang_nn_1_1_N = mkN "balansgång" ;
  ballhet_nn_1_N = mkN "ballhet" ;
  balloterbarhet_nn_1_N = mkN "balloterbarhet" ;
  balneologi_nn_1_N = mkN "balneologi" ;
  balsamdoftande_av_1_A = mkA "balsamdoftande" ;
  balsamerbarhet_nn_1_N = mkN "balsamerbarhet" ;
  banaliserbarhet_nn_1_N = mkN "banaliserbarhet" ;
  banbrytande_av_1_A = mkA "banbrytande" ;
  bandkantning_nn_1_N = mkN "bandkantning" ;
  banghet_nn_1_N = mkN "banghet" ;
  bankrutterbarhet_nn_1_N = mkN "bankrutterbarhet" ;
  banskytte_nn_1_N = mkN "banskytte" ;
  bantamvikt_nn_1_N = mkN "bantamvikt" ;
  bantningshysteri_nn_1_N = mkN "bantningshysteri" ;
  barfota_av_1_A = mkA "barfota" ;
  barhet_nn_1_N = mkN "barhet" ;
  barklag_nn_1_N = mkN "barklag" ;
  barnarbetskraft_nn_1_N = mkN "barnarbetskraft" ;
  barnavaard_nn_1_1_N = mkN "barnavård" ;
  barndomsforskning_nn_1_N = mkN "barndomsforskning" ;
  barndomsminne_nn_1_N = mkN "barndomsminne" ;
  barnfoerbjudenhet_nn_1_1_N = mkN "barnförbjudenhet" ;
  barnledighet_nn_1_N = mkN "barnledighet" ;
  barnloeshet_nn_1_1_N = mkN "barnlöshet" ;
  barnomsorg_nn_1_N = mkN "barnomsorg" ;
  barnpornografi_nn_1_N = mkN "barnpornografi" ;
  barnsmuggling_nn_1_N = mkN "barnsmuggling" ;
  barnsnoed_nn_1_1_N = mkN "barnsnöd" ;
  barnsaekerhet_nn_1_1_N = mkN "barnsäkerhet" ;
  barntillsyn_nn_1_N = mkN "barntillsyn" ;
  barntillaatenhet_nn_1_1_N = mkN "barntillåtenhet" ;
  barrikaderbarhet_nn_1_N = mkN "barrikaderbarhet" ;
  barrved_nn_1_N = mkN "barrved" ;
  barskhet_nn_1_N = mkN "barskhet" ;
  baserbarhet_nn_1_N = mkN "baserbarhet" ;
  bastanthet_nn_1_N = mkN "bastanthet" ;
  batongsvingande_av_1_A = mkA "batongsvingande" ;
  beaktande_nn_1_N = mkN "beaktande" ;
  beatifierande_nn_1_N = mkN "beatifierande" ;
  beatifierbarhet_nn_1_N = mkN "beatifierbarhet" ;
  beatifiering_nn_1_N = mkN "beatifiering" ;
  beboelighet_nn_1_N = mkN "beboelighet" ;
  bebolighet_nn_1_N = mkN "bebolighet" ;
  beckighet_nn_1_N = mkN "beckighet" ;
  bedjande_av_1_A = mkA "bedjande" ;
  bedjande_nn_1_N = mkN "bedjande" ;
  bedaarande_av_1_1_A = mkA "bedårande" ;
  beende_av_1_A = mkA "beende" ;
  beende_nn_1_N = mkN "beende" ;
  befallande_av_1_A = mkA "befallande" ;
  befinnande_nn_1_N = mkN "befinnande" ;
  befriande_av_1_A = mkA "befriande" ;
  befaelhavande_av_1_1_A = mkA "befälhavande" ;
  begabbande_nn_1_N = mkN "begabbande" ;
  begivenhet_nn_2_N = mkN "begivenhet" ;
  begravningshjaelp_nn_1_1_N = mkN "begravningshjälp" ;
  begravningspoesi_nn_1_N = mkN "begravningspoesi" ;
  begreppslighet_nn_1_N = mkN "begreppslighet" ;
  begreppsmaessighet_nn_1_1_N = mkN "begreppsmässighet" ;
  behagsjukhet_nn_1_N = mkN "behagsjukhet" ;
  behandlingsbarhet_nn_1_N = mkN "behandlingsbarhet" ;
  behjaelplighet_nn_1_1_N = mkN "behjälplighet" ;
  behaendighet_nn_1_1_N = mkN "behändighet" ;
  behoevande_av_1_1_A = mkA "behövande" ;
  behoevlighet_nn_1_1_N = mkN "behövlighet" ;
  beklaglighet_nn_1_N = mkN "beklaglighet" ;
  beklaemdhet_nn_1_1_N = mkN "beklämdhet" ;
  beklaemmande_av_1_1_A = mkA "beklämmande" ;
  bekvaemhet_nn_1_1_N = mkN "bekvämhet" ;
  bekvaemlighetsflagg_nn_1_1_N = mkN "bekvämlighetsflagg" ;
  bekymmersamhet_nn_1_N = mkN "bekymmersamhet" ;
  bekymmersloeshet_nn_1_1_N = mkN "bekymmerslöshet" ;
  belysande_av_1_A = mkA "belysande" ;
  bemaelde_av_1_1_A = mkA "bemälde" ;
  bemaerkthet_nn_1_1_N = mkN "bemärkthet" ;
  bemoetande_nn_1_1_N = mkN "bemötande" ;
  benhaardhet_nn_1_1_N = mkN "benhårdhet" ;
  benmaerg_nn_1_1_N = mkN "benmärg" ;
  bensinfoersaeljning_nn_1_1_N = mkN "bensinförsäljning" ;
  bensinslukande_av_1_A = mkA "bensinslukande" ;
  bensinsnaalhet_nn_1_1_N = mkN "bensinsnålhet" ;
  beresthet_nn_1_N = mkN "beresthet" ;
  bergighet_nn_1_N = mkN "bergighet" ;
  bergis_av_1_A = mkA "bergis" ;
  bergsaekerhet_nn_1_1_N = mkN "bergsäkerhet" ;
  berlinerblaatt_nn_1_1_N = mkN "berlinerblått" ;
  beroende_av_1_A = mkA "beroende" ;
  beroende_nn_1_N = mkN "beroende" ;
  beroendeframkallande_av_1_A = mkA "beroendeframkallande" ;
  berusande_av_1_A = mkA "berusande" ;
  beraeknande_av_1_1_A = mkA "beräknande" ;
  beraeknelighet_nn_1_1_N = mkN "beräknelighet" ;
  beraettande_av_1_1_A = mkA "berättande" ;
  beraettigande_nn_1_1_N = mkN "berättigande" ;
  beroemvaerdhet_nn_1_1_N = mkN "berömvärdhet" ;
  beroeringsskraeck_nn_1_1_N = mkN "beröringsskräck" ;
  beseende_nn_1_N = mkN "beseende" ;
  besinningsfullhet_nn_1_N = mkN "besinningsfullhet" ;
  besittningstagande_nn_1_N = mkN "besittningstagande" ;
  beskattningsbarhet_nn_1_N = mkN "beskattningsbarhet" ;
  beskattningsgrundande_av_1_A = mkA "beskattningsgrundande" ;
  beskattningsmakt_nn_1_N = mkN "beskattningsmakt" ;
  beskattningsraett_nn_1_1_N = mkN "beskattningsrätt" ;
  beskedlighet_nn_1_N = mkN "beskedlighet" ;
  beskrivande_av_1_A = mkA "beskrivande" ;
  beskrivbarhet_nn_1_N = mkN "beskrivbarhet" ;
  beskaadande_nn_1_1_N = mkN "beskådande" ;
  beslagsraett_nn_1_1_N = mkN "beslagsrätt" ;
  beslutanderaett_nn_1_1_N = mkN "beslutanderätt" ;
  beslutenhet_nn_1_N = mkN "beslutenhet" ;
  beslutenlighet_nn_1_N = mkN "beslutenlighet" ;
  beslutfattande_av_1_A = mkA "beslutfattande" ;
  beslutfattande_nn_1_N = mkN "beslutfattande" ;
  beslutfoerhet_nn_1_1_N = mkN "beslutförhet" ;
  beslutmaessighet_nn_1_1_N = mkN "beslutmässighet" ;
  beslutsenlighet_nn_1_N = mkN "beslutsenlighet" ;
  beslutsfattande_av_1_A = mkA "beslutsfattande" ;
  beslutsfattande_nn_1_N = mkN "beslutsfattande" ;
  beslutsfoerhet_nn_1_1_N = mkN "beslutsförhet" ;
  beslutsmaessighet_nn_1_1_N = mkN "beslutsmässighet" ;
  beslutsraett_nn_1_1_N = mkN "beslutsrätt" ;
  besserwissrande_nn_1_N = mkN "besserwissrande" ;
  bestickande_av_1_A = mkA "bestickande" ;
  besticklighet_nn_1_N = mkN "besticklighet" ;
  bestaellsamhet_nn_1_1_N = mkN "beställsamhet" ;
  bestaellt_av_1_1_A = mkA "beställt" ;
  bestaembarhet_nn_1_1_N = mkN "bestämbarhet" ;
  bestaemdhet_nn_1_1_N = mkN "bestämdhet" ;
  bestaemmanderaett_nn_1_1_N = mkN "bestämmanderätt" ;
  bestaaende_av_1_1_A = mkA "bestående" ;
  bestaandande_av_1_1_A = mkA "beståndande" ;
  bestaandsbildande_av_1_1_A = mkA "beståndsbildande" ;
  bestoerthet_nn_1_1_N = mkN "bestörthet" ;
  besudlande_nn_1_N = mkN "besudlande" ;
  besudling_nn_1_N = mkN "besudling" ;
  besuttenhet_nn_1_N = mkN "besuttenhet" ;
  besvikenhet_nn_1_N = mkN "besvikenhet" ;
  besvaerande_av_1_1_A = mkA "besvärande" ;
  besvaersraett_nn_1_1_N = mkN "besvärsrätt" ;
  betagande_av_1_A = mkA "betagande" ;
  betagenhet_nn_1_N = mkN "betagenhet" ;
  betalbarhet_nn_1_N = mkN "betalbarhet" ;
  betalningsskyldighet_nn_1_N = mkN "betalningsskyldighet" ;
  betastraalande_av_1_1_A = mkA "betastrålande" ;
  betecknande_av_1_A = mkA "betecknande" ;
  beteendepsykologi_nn_1_N = mkN "beteendepsykologi" ;
  beteendeterapi_nn_1_N = mkN "beteendeterapi" ;
  betongerbarhet_nn_1_N = mkN "betongerbarhet" ;
  betraktande_nn_1_N = mkN "betraktande" ;
  betroddhet_nn_1_N = mkN "betroddhet" ;
  betryckthet_nn_1_N = mkN "betryckthet" ;
  betryggande_av_1_A = mkA "betryggande" ;
  betraengdhet_nn_1_1_N = mkN "beträngdhet" ;
  betungande_av_1_A = mkA "betungande" ;
  betvingande_av_1_A = mkA "betvingande" ;
  betydande_av_1_A = mkA "betydande" ;
  betydelsebaerande_av_1_1_A = mkA "betydelsebärande" ;
  betydelsefullhet_nn_1_N = mkN "betydelsefullhet" ;
  betydelseloeshet_nn_1_1_N = mkN "betydelselöshet" ;
  betydlighet_nn_1_N = mkN "betydlighet" ;
  betygsjaekt_nn_1_1_N = mkN "betygsjäkt" ;
  betaenksamhet_nn_1_1_N = mkN "betänksamhet" ;
  beundransvaerdhet_nn_1_1_N = mkN "beundransvärdhet" ;
  bevekande_av_1_A = mkA "bevekande" ;
  bevisbarhet_nn_1_N = mkN "bevisbarhet" ;
  beviskraftighet_nn_1_N = mkN "beviskraftighet" ;
  bevislighet_nn_1_N = mkN "bevislighet" ;
  bevisskyldighet_nn_1_N = mkN "bevisskyldighet" ;
  bi_av_1_A = mkA "bi" ;
  bibelforskning_nn_1_N = mkN "bibelforskning" ;
  bibelkristenhet_nn_1_N = mkN "bibelkristenhet" ;
  bibelkunnighet_nn_1_N = mkN "bibelkunnighet" ;
  bibelspraengdhet_nn_1_1_N = mkN "bibelsprängdhet" ;
  bibeltrogenhet_nn_1_N = mkN "bibeltrogenhet" ;
  bibliomani_nn_1_N = mkN "bibliomani" ;
  bibliometri_nn_1_N = mkN "bibliometri" ;
  bidragande_av_1_A = mkA "bidragande" ;
  biff_av_1_A = mkA "biff" ;
  biffighet_nn_1_N = mkN "biffighet" ;
  bigami_nn_1_N = mkN "bigami" ;
  bildande_av_1_A = mkA "bildande" ;
  bildbarhet_nn_1_N = mkN "bildbarhet" ;
  bildlighet_nn_1_N = mkN "bildlighet" ;
  bildlikhet_nn_1_N = mkN "bildlikhet" ;
  bildminne_nn_1_N = mkN "bildminne" ;
  bildmaessighet_nn_1_1_N = mkN "bildmässighet" ;
  bildningshoegfaerd_nn_1_1_N = mkN "bildningshögfärd" ;
  bildprakt_nn_1_N = mkN "bildprakt" ;
  bildrikedom_nn_1_N = mkN "bildrikedom" ;
  bildskoenhet_nn_1_1_N = mkN "bildskönhet" ;
  bildtelegrafi_nn_1_N = mkN "bildtelegrafi" ;
  billighet_nn_2_N = mkN "billighet" ;
  bilning_nn_1_N = mkN "bilning" ;
  bilsjukhet_nn_1_N = mkN "bilsjukhet" ;
  biltoghet_nn_1_N = mkN "biltoghet" ;
  bilaeggning_nn_1_1_N = mkN "biläggning" ;
  bindande_av_1_A = mkA "bindande" ;
  bindgalenhet_nn_1_N = mkN "bindgalenhet" ;
  bingosugenhet_nn_1_N = mkN "bingosugenhet" ;
  binjurebark_nn_1_N = mkN "binjurebark" ;
  biobankning_nn_1_N = mkN "biobankning" ;
  biogasproduktion_nn_1_N = mkN "biogasproduktion" ;
  biogasrening_nn_1_N = mkN "biogasrening" ;
  biogeografi_nn_1_N = mkN "biogeografi" ;
  biograferbarhet_nn_1_N = mkN "biograferbarhet" ;
  biokemi_nn_1_N = mkN "biokemi" ;
  bioklimatologi_nn_1_N = mkN "bioklimatologi" ;
  biokronologi_nn_1_N = mkN "biokronologi" ;
  biologi_nn_1_N = mkN "biologi" ;
  biometri_nn_1_N = mkN "biometri" ;
  bisarrhet_nn_1_N = mkN "bisarrhet" ;
  biskoplighet_nn_1_N = mkN "biskoplighet" ;
  bisserbarhet_nn_1_N = mkN "bisserbarhet" ;
  bisterhet_nn_1_N = mkN "bisterhet" ;
  bitande_av_1_A = mkA "bitande" ;
  bitraedande_av_1_1_A = mkA "biträdande" ;
  bitskhet_nn_1_N = mkN "bitskhet" ;
  bittelitenhet_nn_1_N = mkN "bittelitenhet" ;
  bitterljuvhet_nn_1_N = mkN "bitterljuvhet" ;
  bittersta_av_1_A = mkA "bittersta" ;
  bivackerbarhet_nn_1_N = mkN "bivackerbarhet" ;
  bjaerthet_nn_1_1_N = mkN "bjärthet" ;
  bjoerke_nn_1_1_N = mkN "björke" ;
  bjoerklag_nn_1_1_N = mkN "björklag" ;
  bjoerkved_nn_1_1_N = mkN "björkved" ;
  bjoernliknande_av_1_1_A = mkA "björnliknande" ;
  blackhet_nn_1_N = mkN "blackhet" ;
  blackighet_nn_1_N = mkN "blackighet" ;
  bladroett_nn_1_1_N = mkN "bladrött" ;
  bladspaenning_nn_1_1_N = mkN "bladspänning" ;
  blancherbarhet_nn_1_N = mkN "blancherbarhet" ;
  blanddryck_nn_1_N = mkN "blanddryck" ;
  blankhet_nn_1_N = mkN "blankhet" ;
  blankpolerbarhet_nn_1_N = mkN "blankpolerbarhet" ;
  blaskighet_nn_1_N = mkN "blaskighet" ;
  blas_e_av_1_1_A = mkA "blasé" ;
  blecksmak_nn_1_N = mkN "blecksmak" ;
  blekfethet_nn_1_N = mkN "blekfethet" ;
  blekjord_nn_1_N = mkN "blekjord" ;
  bleklagdhet_nn_1_N = mkN "bleklagdhet" ;
  bleksiktighet_nn_1_N = mkN "bleksiktighet" ;
  bleksot_nn_1_N = mkN "bleksot" ;
  blesserbarhet_nn_1_N = mkN "blesserbarhet" ;
  blickpunkt_nn_1_N = mkN "blickpunkt" ;
  blickstilla_av_1_A = mkA "blickstilla" ;
  blidhet_nn_1_N = mkN "blidhet" ;
  blind_av_1_A = mkA "blind" ;
  blinderbarhet_nn_1_N = mkN "blinderbarhet" ;
  blindhet_nn_1_N = mkN "blindhet" ;
  blindskrift_nn_1_N = mkN "blindskrift" ;
  blingande_nn_1_N = mkN "blingande" ;
  blivande_av_1_A = mkA "blivande" ;
  blixtfotograferbarhet_nn_1_N = mkN "blixtfotograferbarhet" ;
  blixtrande_av_1_A = mkA "blixtrande" ;
  blixtsnabbhet_nn_1_N = mkN "blixtsnabbhet" ;
  blockerbarhet_nn_1_N = mkN "blockerbarhet" ;
  blockighet_nn_1_N = mkN "blockighet" ;
  blockmark_nn_1_N = mkN "blockmark" ;
  blocktaenkande_nn_1_1_N = mkN "blocktänkande" ;
  blockoeverskridande_av_1_1_A = mkA "blocköverskridande" ;
  bloddrypande_av_1_A = mkA "bloddrypande" ;
  blodfattighet_nn_1_N = mkN "blodfattighet" ;
  blodfullhet_nn_1_N = mkN "blodfullhet" ;
  blodgivning_nn_1_N = mkN "blodgivning" ;
  blodgaang_nn_1_1_N = mkN "blodgång" ;
  blodisande_av_1_A = mkA "blodisande" ;
  blodloeshet_nn_1_1_N = mkN "blodlöshet" ;
  blodmat_nn_1_N = mkN "blodmat" ;
  blodrot_nn_1_N = mkN "blodrot" ;
  blodshaemnd_nn_1_1_N = mkN "blodshämnd" ;
  blodsmak_nn_1_N = mkN "blodsmak" ;
  blodspraengdhet_nn_1_1_N = mkN "blodsprängdhet" ;
  blodstensmalm_nn_1_N = mkN "blodstensmalm" ;
  blodstillande_av_1_A = mkA "blodstillande" ;
  blodstinnhet_nn_1_N = mkN "blodstinnhet" ;
  blodsugande_av_1_A = mkA "blodsugande" ;
  blodtoerstighet_nn_1_1_N = mkN "blodtörstighet" ;
  blomjord_nn_1_N = mkN "blomjord" ;
  blommograferbarhet_nn_1_N = mkN "blommograferbarhet" ;
  blomsterhonung_nn_1_N = mkN "blomsterhonung" ;
  blomsterprakt_nn_1_N = mkN "blomsterprakt" ;
  blond_av_1_A = mkA "blond" ;
  blonderbarhet_nn_1_N = mkN "blonderbarhet" ;
  blondhet_nn_1_N = mkN "blondhet" ;
  blottstaelldhet_nn_1_1_N = mkN "blottställdhet" ;
  blygult_nn_1_N = mkN "blygult" ;
  blytunghet_nn_1_N = mkN "blytunghet" ;
  blyvitt_nn_1_N = mkN "blyvitt" ;
  blaendande_av_1_1_A = mkA "bländande" ;
  blaaaktighet_nn_1_1_N = mkN "blåaktighet" ;
  blaablodighet_nn_1_1_N = mkN "blåblodighet" ;
  blaafoerskjutning_nn_1_1_N = mkN "blåförskjutning" ;
  blaahet_nn_1_1_N = mkN "blåhet" ;
  blaajord_nn_1_1_N = mkN "blåjord" ;
  blaakopierbarhet_nn_1_1_N = mkN "blåkopierbarhet" ;
  blaasprit_nn_1_1_N = mkN "blåsprit" ;
  blaasthet_nn_1_1_N = mkN "blåsthet" ;
  blaastaang_nn_1_1_N = mkN "blåstång" ;
  blaasurhet_nn_1_1_N = mkN "blåsurhet" ;
  blaasoert_nn_1_1_N = mkN "blåsört" ;
  blaaoegdhet_nn_1_1_N = mkN "blåögdhet" ;
  bloethet_nn_1_1_N = mkN "blöthet" ;
  boaserbarhet_nn_1_N = mkN "boaserbarhet" ;
  boboll_nn_1_N = mkN "boboll" ;
  bockbenthet_nn_1_N = mkN "bockbenthet" ;
  bocktoerne_nn_1_1_N = mkN "bocktörne" ;
  bodraekt_nn_1_1_N = mkN "bodräkt" ;
  bofasthet_nn_1_N = mkN "bofasthet" ;
  bofaellighet_nn_1_1_N = mkN "bofällighet" ;
  bogserbarhet_nn_1_N = mkN "bogserbarhet" ;
  boke_nn_1_N = mkN "boke" ;
  bokenhet_nn_1_N = mkN "bokenhet" ;
  bokform_nn_1_N = mkN "bokform" ;
  bokfoeringsmaessighet_nn_1_1_N = mkN "bokföringsmässighet" ;
  bokfoeringsplikt_nn_1_1_N = mkN "bokföringsplikt" ;
  boklighet_nn_1_N = mkN "boklighet" ;
  boklaerdhet_nn_1_1_N = mkN "boklärdhet" ;
  boklaesande_av_1_1_A = mkA "bokläsande" ;
  boklaesande_nn_1_1_N = mkN "bokläsande" ;
  bokskrivande_av_1_A = mkA "bokskrivande" ;
  bokskrivande_nn_1_N = mkN "bokskrivande" ;
  bokstaverbarhet_nn_1_N = mkN "bokstaverbarhet" ;
  bokstavsskrift_nn_1_N = mkN "bokstavsskrift" ;
  bokstavstrogenhet_nn_1_N = mkN "bokstavstrogenhet" ;
  boksynthet_nn_1_N = mkN "boksynthet" ;
  bolmoert_nn_1_1_N = mkN "bolmört" ;
  bombarderbarhet_nn_1_N = mkN "bombarderbarhet" ;
  bombfasthet_nn_1_N = mkN "bombfasthet" ;
  bombsaekerhet_nn_1_1_N = mkN "bombsäkerhet" ;
  bomull_nn_1_N = mkN "bomull" ;
  bonddryghet_nn_1_N = mkN "bonddryghet" ;
  bondesjael_nn_1_1_N = mkN "bondesjäl" ;
  bondskhet_nn_1_N = mkN "bondskhet" ;
  bondslughet_nn_1_N = mkN "bondslughet" ;
  bondtur_nn_1_N = mkN "bondtur" ;
  boniterbarhet_nn_1_N = mkN "boniterbarhet" ;
  bordslinne_nn_1_N = mkN "bordslinne" ;
  borgerlighet_nn_2_N = mkN "borgerlighet" ;
  borstighet_nn_1_N = mkN "borstighet" ;
  borstloeshet_nn_1_1_N = mkN "borstlöshet" ;
  bortfoerklaringsteologi_nn_1_1_N = mkN "bortförklaringsteologi" ;
  bortgivande_nn_1_N = mkN "bortgivande" ;
  bortgloemdhet_nn_1_1_N = mkN "bortglömdhet" ;
  bortgaang_nn_1_1_N = mkN "bortgång" ;
  bortkommenhet_nn_1_N = mkN "bortkommenhet" ;
  bortresonerbarhet_nn_1_N = mkN "bortresonerbarhet" ;
  bortresthet_nn_1_N = mkN "bortresthet" ;
  bortskaffande_nn_1_N = mkN "bortskaffande" ;
  bortskaffning_nn_1_N = mkN "bortskaffning" ;
  borttagning_nn_1_N = mkN "borttagning" ;
  bortvikt_nn_1_N = mkN "bortvikt" ;
  bortvaend_av_1_1_A = mkA "bortvänd" ;
  boskap_nn_1_N = mkN "boskap" ;
  boskapsskoetande_av_1_1_A = mkA "boskapsskötande" ;
  bossighet_nn_1_N = mkN "bossighet" ;
  bostadsloeshet_nn_1_1_N = mkN "bostadslöshet" ;
  bostadssparande_nn_1_N = mkN "bostadssparande" ;
  botfaerdighet_nn_1_1_N = mkN "botfärdighet" ;
  botlighet_nn_1_N = mkN "botlighet" ;
  botten_av_1_A = mkA "botten" ;
  bottendaalighet_nn_1_1_N = mkN "bottendålighet" ;
  bottenhederlighet_nn_1_N = mkN "bottenhederlighet" ;
  bottenlevande_av_1_A = mkA "bottenlevande" ;
  bovaktighet_nn_1_N = mkN "bovaktighet" ;
  bovete_nn_1_N = mkN "bovete" ;
  boxkalv_nn_1_N = mkN "boxkalv" ;
  bra_av_2_A = mkA "bra" ;
  brackighet_nn_1_N = mkN "brackighet" ;
  brackvattenlevande_av_1_A = mkA "brackvattenlevande" ;
  brailleskrift_nn_1_N = mkN "brailleskrift" ;
  brakycefali_nn_1_N = mkN "brakycefali" ;
  brandfarlighet_nn_1_N = mkN "brandfarlighet" ;
  brandhaerdighet_nn_1_1_N = mkN "brandhärdighet" ;
  brandlukt_nn_1_N = mkN "brandlukt" ;
  brandroek_nn_1_1_N = mkN "brandrök" ;
  brandstod_nn_1_N = mkN "brandstod" ;
  brandsaekerhet_nn_1_1_N = mkN "brandsäkerhet" ;
  branschledande_av_1_A = mkA "branschledande" ;
  branthet_nn_1_N = mkN "branthet" ;
  braskande_av_1_A = mkA "braskande" ;
  brasved_nn_1_N = mkN "brasved" ;
  bredbarhet_nn_1_N = mkN "bredbarhet" ;
  bredbenthet_nn_1_N = mkN "bredbenthet" ;
  bredbladighet_nn_1_N = mkN "bredbladighet" ;
  bredbraettighet_nn_1_1_N = mkN "bredbrättighet" ;
  bredhet_nn_1_N = mkN "bredhet" ;
  bredmynthet_nn_1_N = mkN "bredmynthet" ;
  bredrandighet_nn_1_N = mkN "bredrandighet" ;
  bredskyggighet_nn_1_N = mkN "bredskyggighet" ;
  bredspaarighet_nn_1_1_N = mkN "bredspårighet" ;
  bremsande_nn_1_N = mkN "bremsande" ;
  bremsning_nn_1_N = mkN "bremsning" ;
  brevlaadeliknande_av_1_1_A = mkA "brevlådeliknande" ;
  brevskrivande_av_1_A = mkA "brevskrivande" ;
  brevskrivande_nn_1_N = mkN "brevskrivande" ;
  briketterbarhet_nn_1_N = mkN "briketterbarhet" ;
  brinnande_av_1_A = mkA "brinnande" ;
  briserbarhet_nn_1_N = mkN "briserbarhet" ;
  briskenhet_nn_1_N = mkN "briskenhet" ;
  bristande_av_1_A = mkA "bristande" ;
  brobyggnad_nn_1_N = mkN "brobyggnad" ;
  broderbarhet_nn_1_N = mkN "broderbarhet" ;
  broderlighet_nn_1_N = mkN "broderlighet" ;
  brodersilke_nn_1_N = mkN "brodersilke" ;
  brokbladighet_nn_1_N = mkN "brokbladighet" ;
  brokblommighet_nn_1_N = mkN "brokblommighet" ;
  bromerbarhet_nn_1_N = mkN "bromerbarhet" ;
  bromskraft_nn_1_N = mkN "bromskraft" ;
  bromtymolblaatt_nn_1_1_N = mkN "bromtymolblått" ;
  bromvaete_nn_1_1_N = mkN "bromväte" ;
  bronserbarhet_nn_1_N = mkN "bronserbarhet" ;
  bronsfaerg_nn_1_1_N = mkN "bronsfärg" ;
  broscherbarhet_nn_1_N = mkN "broscherbarhet" ;
  brottsbalk_nn_1_N = mkN "brottsbalk" ;
  brottsbekaempning_nn_1_1_N = mkN "brottsbekämpning" ;
  brottsfoerebyggande_av_1_1_A = mkA "brottsförebyggande" ;
  brottshistoria_nn_1_N = mkN "brottshistoria" ;
  brottsutredande_nn_1_N = mkN "brottsutredande" ;
  brukbarhet_nn_1_N = mkN "brukbarhet" ;
  brunaktighet_nn_1_N = mkN "brunaktighet" ;
  brunbraend_av_1_1_A = mkA "brunbränd" ;
  brunerbarhet_nn_1_N = mkN "brunerbarhet" ;
  brunglaensande_av_1_1_A = mkA "brunglänsande" ;
  brunhet_nn_1_N = mkN "brunhet" ;
  brunhaarighet_nn_1_1_N = mkN "brunhårighet" ;
  brunjord_nn_1_N = mkN "brunjord" ;
  brunmurrighet_nn_1_N = mkN "brunmurrighet" ;
  brunrutighet_nn_1_N = mkN "brunrutighet" ;
  brunstighet_nn_1_N = mkN "brunstighet" ;
  brunoegdhet_nn_1_1_N = mkN "brunögdhet" ;
  brustenhet_nn_1_N = mkN "brustenhet" ;
  brutaliserbarhet_nn_1_N = mkN "brutaliserbarhet" ;
  bruttovikt_nn_1_N = mkN "bruttovikt" ;
  bryddhet_nn_1_N = mkN "bryddhet" ;
  brydsamhet_nn_1_N = mkN "brydsamhet" ;
  bryologi_nn_1_N = mkN "bryologi" ;
  bryskhet_nn_1_N = mkN "bryskhet" ;
  braeckage_nn_1_1_N = mkN "bräckage" ;
  braecklighet_nn_1_1_N = mkN "bräcklighet" ;
  braeckthet_nn_1_1_N = mkN "bräckthet" ;
  braeddfullhet_nn_1_1_N = mkN "bräddfullhet" ;
  braeddfylldhet_nn_1_1_N = mkN "bräddfylldhet" ;
  braennande_av_1_1_A = mkA "brännande" ;
  braennbarhet_nn_1_1_N = mkN "brännbarhet" ;
  braennboll_nn_1_1_N = mkN "brännboll" ;
  braenne_nn_1_1_N = mkN "bränne" ;
  braennlackerbarhet_nn_1_1_N = mkN "brännlackerbarhet" ;
  braenntorv_nn_1_1_N = mkN "bränntorv" ;
  braenslefoerbrukning_nn_1_1_N = mkN "bränsleförbrukning" ;
  braenslesnaalhet_nn_1_1_N = mkN "bränslesnålhet" ;
  braensleaatgaang_nn_1_1_N = mkN "bränsleåtgång" ;
  braeserbarhet_nn_1_1_N = mkN "bräserbarhet" ;
  braaddjuphet_nn_1_1_N = mkN "bråddjuphet" ;
  braadhet_nn_1_1_N = mkN "brådhet" ;
  braadmogenhet_nn_1_1_N = mkN "brådmogenhet" ;
  braadskande_av_1_1_A = mkA "brådskande" ;
  braakighet_nn_1_1_N = mkN "bråkighet" ;
  braattom_av_1_1_A = mkA "bråttom" ;
  broedloeshet_nn_1_1_N = mkN "brödlöshet" ;
  broedstil_nn_1_1_N = mkN "brödstil" ;
  broestklang_nn_1_1_N = mkN "bröstklang" ;
  broestlidande_nn_1_1_N = mkN "bröstlidande" ;
  broestsugande_av_1_1_A = mkA "bröstsugande" ;
  bubblighet_nn_1_N = mkN "bubblighet" ;
  bucklighet_nn_1_N = mkN "bucklighet" ;
  budgeterbarhet_nn_1_N = mkN "budgeterbarhet" ;
  buffelaktighet_nn_1_N = mkN "buffelaktighet" ;
  bukighet_nn_1_N = mkN "bukighet" ;
  bukstinnhet_nn_1_N = mkN "bukstinnhet" ;
  buktighet_nn_1_N = mkN "buktighet" ;
  bullerdaempande_av_1_1_A = mkA "bullerdämpande" ;
  bullerdaempning_nn_1_1_N = mkN "bullerdämpning" ;
  bullerfoerminskande_av_1_1_A = mkA "bullerförminskande" ;
  bullersamhet_nn_1_N = mkN "bullersamhet" ;
  bullighet_nn_1_N = mkN "bullighet" ;
  bullrighet_nn_1_N = mkN "bullrighet" ;
  bulsighet_nn_1_N = mkN "bulsighet" ;
  bundenhet_nn_1_N = mkN "bundenhet" ;
  bunkrande_nn_1_N = mkN "bunkrande" ;
  bunkring_nn_1_N = mkN "bunkring" ;
  burgenhet_nn_1_N = mkN "burgenhet" ;
  burkmat_nn_1_N = mkN "burkmat" ;
  burrighet_nn_1_N = mkN "burrighet" ;
  busighet_nn_1_N = mkN "busighet" ;
  buskablyghet_nn_1_N = mkN "buskablyghet" ;
  buskighet_nn_1_N = mkN "buskighet" ;
  buskliknande_av_1_A = mkA "buskliknande" ;
  buss_av_1_A = mkA "buss" ;
  bussighet_nn_1_N = mkN "bussighet" ;
  buteljerbarhet_nn_1_N = mkN "buteljerbarhet" ;
  butterhet_nn_1_N = mkN "butterhet" ;
  byggande_nn_1_N = mkN "byggande" ;
  byggenskap_nn_1_N = mkN "byggenskap" ;
  byggnadsvirke_nn_1_N = mkN "byggnadsvirke" ;
  byke_nn_1_N = mkN "byke" ;
  bylsighet_nn_1_N = mkN "bylsighet" ;
  byraakratiserbarhet_nn_1_1_N = mkN "byråkratiserbarhet" ;
  byxis_av_1_A = mkA "byxis" ;
  byxloeshet_nn_1_1_N = mkN "byxlöshet" ;
  baelgliknande_av_1_1_A = mkA "bälgliknande" ;
  baenghet_nn_1_1_N = mkN "bänghet" ;
  baerande_av_1_1_A = mkA "bärande" ;
  baerbarhet_nn_1_1_N = mkN "bärbarhet" ;
  baerhjaelp_nn_1_1_N = mkN "bärhjälp" ;
  baerighet_nn_1_1_N = mkN "bärighet" ;
  baerkraftighet_nn_1_1_N = mkN "bärkraftighet" ;
  baerplockning_nn_1_1_N = mkN "bärplockning" ;
  baersaerkagaang_nn_1_1_N = mkN "bärsärkagång" ;
  baagformighet_nn_1_1_N = mkN "bågformighet" ;
  baagskytte_nn_1_1_N = mkN "bågskytte" ;
  baaldhet_nn_1_1_N = mkN "båldhet" ;
  baangstyrighet_nn_1_1_N = mkN "bångstyrighet" ;
  baarbaerning_nn_1_1_N = mkN "bårbärning" ;
  baatfart_nn_1_1_N = mkN "båtfart" ;
  baatliknande_av_1_1_A = mkA "båtliknande" ;
  baatvaard_nn_1_1_N = mkN "båtvård" ;
  boegdoed_nn_1_1_N = mkN "bögdöd" ;
  boejbarhet_nn_1_1_N = mkN "böjbarhet" ;
  boejdhet_nn_1_1_N = mkN "böjdhet" ;
  boejlighet_nn_1_1_N = mkN "böjlighet" ;
  boenkaffe_nn_1_1_N = mkN "bönkaffe" ;
  boerd_nn_1_1_N = mkN "börd" ;
  boerdighet_nn_1_1_N = mkN "bördighet" ;
  boerdshoegfaerd_nn_1_1_N = mkN "bördshögfärd" ;
  boerdsraett_nn_1_1_N = mkN "bördsrätt" ;
  boerdsstolthet_nn_1_1_N = mkN "bördsstolthet" ;
  boersnoterbarhet_nn_1_1_N = mkN "börsnoterbarhet" ;
  boersutveckling_nn_1_1_N = mkN "börsutveckling" ;
  cabotage_nn_1_N = mkN "cabotage" ;
  camouflerbarhet_nn_1_N = mkN "camouflerbarhet" ;
  camphet_nn_1_N = mkN "camphet" ;
  cancerbekaempning_nn_1_1_N = mkN "cancerbekämpning" ;
  cancerframkallande_av_1_A = mkA "cancerframkallande" ;
  cancerspridning_nn_1_N = mkN "cancerspridning" ;
  catch_as_catch_can_nn_1_N = mkN "catch-as-catch-can" ;
  cederbarhet_nn_1_N = mkN "cederbarhet" ;
  celebrerbarhet_nn_1_N = mkN "celebrerbarhet" ;
  cellbiologi_nn_1_N = mkN "cellbiologi" ;
  cellskraeck_nn_1_1_N = mkN "cellskräck" ;
  cellterapi_nn_1_N = mkN "cellterapi" ;
  cementerbarhet_nn_1_N = mkN "cementerbarhet" ;
  cendr_e_av_1_1_A = mkA "cendré" ;
  censurerbarhet_nn_1_N = mkN "censurerbarhet" ;
  centraliserbarhet_nn_1_N = mkN "centraliserbarhet" ;
  centralstimulerande_av_1_A = mkA "centralstimulerande" ;
  centrerbarhet_nn_1_N = mkN "centrerbarhet" ;
  centrifugalkraft_nn_1_N = mkN "centrifugalkraft" ;
  centrifugerbarhet_nn_1_N = mkN "centrifugerbarhet" ;
  centripetalkraft_nn_1_N = mkN "centripetalkraft" ;
  cepe_av_1_A = mkA "cepe" ;
  cerise_av_1_A = mkA "cerise" ;
  cernerbarhet_nn_1_N = mkN "cernerbarhet" ;
  cervelatkorv_nn_1_N = mkN "cervelatkorv" ;
  champagnesprutande_av_1_A = mkA "champagnesprutande" ;
  chansloeshet_nn_1_1_N = mkN "chanslöshet" ;
  chargerbarhet_nn_1_N = mkN "chargerbarhet" ;
  charmerbarhet_nn_1_N = mkN "charmerbarhet" ;
  charmfullhet_nn_1_N = mkN "charmfullhet" ;
  charmighet_nn_1_N = mkN "charmighet" ;
  chef_d_oeuvre_nn_1_N = mkN "chef-d'oeuvre" ;
  chevroterbarhet_nn_1_N = mkN "chevroterbarhet" ;
  chichet_nn_1_N = mkN "chichet" ;
  chiffrerbarhet_nn_1_N = mkN "chiffrerbarhet" ;
  chikanerbarhet_nn_1_N = mkN "chikanerbarhet" ;
  chimpande_nn_1_N = mkN "chimpande" ;
  chockerbarhet_nn_1_N = mkN "chockerbarhet" ;
  chockrosa_av_1_A = mkA "chockrosa" ;
  cigarettfoersaeljning_nn_1_1_N = mkN "cigarettförsäljning" ;
  cigarettroekning_nn_1_1_N = mkN "cigarettrökning" ;
  cirkelform_nn_1_N = mkN "cirkelform" ;
  cirkelgaang_nn_1_1_N = mkN "cirkelgång" ;
  cirkelrund_av_1_A = mkA "cirkelrund" ;
  cirkelrundhet_nn_1_N = mkN "cirkelrundhet" ;
  cirkulerbarhet_nn_1_N = mkN "cirkulerbarhet" ;
  ciselerbarhet_nn_1_N = mkN "ciselerbarhet" ;
  citerbarhet_nn_1_N = mkN "citerbarhet" ;
  citrussmak_nn_1_N = mkN "citrussmak" ;
  civiliserbarhet_nn_1_N = mkN "civiliserbarhet" ;
  civilkurage_nn_1_N = mkN "civilkurage" ;
  civilraett_nn_1_1_N = mkN "civilrätt" ;
  coolhet_nn_1_N = mkN "coolhet" ;
  corioliskraft_nn_1_N = mkN "corioliskraft" ;
  courtage_nn_1_N = mkN "courtage" ;
  crazy_av_1_A = mkA "crazy" ;
  curare_nn_1_N = mkN "curare" ;
  curaterbarhet_nn_1_N = mkN "curaterbarhet" ;
  curerbarhet_nn_1_N = mkN "curerbarhet" ;
  cyanvaete_nn_1_1_N = mkN "cyanväte" ;
  cyberrymd_nn_1_N = mkN "cyberrymd" ;
  cybervaerld_nn_1_1_N = mkN "cybervärld" ;
  cykelaakning_nn_1_1_N = mkN "cykelåkning" ;
  cykling_nn_1_N = mkN "cykling" ;
  cytologi_nn_1_N = mkN "cytologi" ;
  dagblind_av_1_A = mkA "dagblind" ;
  dagblindhet_nn_1_N = mkN "dagblindhet" ;
  dagenefterhuvudvaerk_nn_1_1_N = mkN "dagenefterhuvudvärk" ;
  daggighet_nn_1_N = mkN "daggighet" ;
  daghavande_av_1_A = mkA "daghavande" ;
  dagjaemningspunkt_nn_1_1_N = mkN "dagjämningspunkt" ;
  daglighet_nn_1_N = mkN "daglighet" ;
  dagsens_av_1_A = mkA "dagsens" ;
  dagslaege_nn_1_1_N = mkN "dagsläge" ;
  dagvill_av_1_A = mkA "dagvill" ;
  dagvillhet_nn_1_N = mkN "dagvillhet" ;
  dagvaard_nn_1_1_N = mkN "dagvård" ;
  damfotboll_nn_1_N = mkN "damfotboll" ;
  dammighet_nn_1_N = mkN "dammighet" ;
  dammsaekerhet_nn_1_1_N = mkN "dammsäkerhet" ;
  dan_av_1_A = mkA "dan" ;
  dann_av_1_A = mkA "dann" ;
  danskhet_nn_1_N = mkN "danskhet" ;
  dansktalande_av_1_A = mkA "dansktalande" ;
  dansundervisning_nn_1_N = mkN "dansundervisning" ;
  darrande_av_1_A = mkA "darrande" ;
  darrhaenthet_nn_1_1_N = mkN "darrhänthet" ;
  darrighet_nn_1_N = mkN "darrighet" ;
  daskighet_nn_1_N = mkN "daskighet" ;
  dassighet_nn_1_N = mkN "dassighet" ;
  datalagring_nn_1_N = mkN "datalagring" ;
  datalogi_nn_1_N = mkN "datalogi" ;
  daterbarhet_nn_1_N = mkN "daterbarhet" ;
  datorfoersaeljning_nn_1_1_N = mkN "datorförsäljning" ;
  datoriserbarhet_nn_1_N = mkN "datoriserbarhet" ;
  datorisering_nn_1_N = mkN "datorisering" ;
  datorkommunikation_nn_1_N = mkN "datorkommunikation" ;
  datorkraft_nn_1_N = mkN "datorkraft" ;
  datumparkerbarhet_nn_1_N = mkN "datumparkerbarhet" ;
  debarkerbarhet_nn_1_N = mkN "debarkerbarhet" ;
  debatterbarhet_nn_1_N = mkN "debatterbarhet" ;
  debiterbarhet_nn_1_N = mkN "debiterbarhet" ;
  decentraliserbarhet_nn_1_N = mkN "decentraliserbarhet" ;
  dechiffrerbarhet_nn_1_N = mkN "dechiffrerbarhet" ;
  decimerbarhet_nn_1_N = mkN "decimerbarhet" ;
  dedicerbarhet_nn_1_N = mkN "dedicerbarhet" ;
  dedikerbarhet_nn_1_N = mkN "dedikerbarhet" ;
  deducerbarhet_nn_1_N = mkN "deducerbarhet" ;
  defilerbarhet_nn_1_N = mkN "defilerbarhet" ;
  definierbarhet_nn_1_N = mkN "definierbarhet" ;
  definithet_nn_1_N = mkN "definithet" ;
  definitionsmaessighet_nn_1_1_N = mkN "definitionsmässighet" ;
  deflorerbarhet_nn_1_N = mkN "deflorerbarhet" ;
  deformerbarhet_nn_1_N = mkN "deformerbarhet" ;
  degenererbarhet_nn_1_N = mkN "degenererbarhet" ;
  degraderbarhet_nn_1_N = mkN "degraderbarhet" ;
  dejlighet_nn_1_N = mkN "dejlighet" ;
  dejting_nn_1_N = mkN "dejting" ;
  dekalkomani_nn_1_N = mkN "dekalkomani" ;
  dekanterbarhet_nn_1_N = mkN "dekanterbarhet" ;
  dekapiterbarhet_nn_1_N = mkN "dekapiterbarhet" ;
  deklamerbarhet_nn_1_N = mkN "deklamerbarhet" ;
  deklarerbarhet_nn_1_N = mkN "deklarerbarhet" ;
  deklasserbarhet_nn_1_N = mkN "deklasserbarhet" ;
  deklinerbarhet_nn_1_N = mkN "deklinerbarhet" ;
  dekomposition_nn_1_N = mkN "dekomposition" ;
  dekorerbarhet_nn_1_N = mkN "dekorerbarhet" ;
  dekouragerbarhet_nn_1_N = mkN "dekouragerbarhet" ;
  dekreterbarhet_nn_1_N = mkN "dekreterbarhet" ;
  delbarhet_nn_1_N = mkN "delbarhet" ;
  delegerbarhet_nn_1_N = mkN "delegerbarhet" ;
  delfaaende_nn_1_1_N = mkN "delfående" ;
  deltagande_av_1_A = mkA "deltagande" ;
  deltagande_nn_1_N = mkN "deltagande" ;
  deltidsarbetande_av_1_A = mkA "deltidsarbetande" ;
  demagogi_nn_1_N = mkN "demagogi" ;
  demaskerbarhet_nn_1_N = mkN "demaskerbarhet" ;
  demensutveckling_nn_1_N = mkN "demensutveckling" ;
  dementerbarhet_nn_1_N = mkN "dementerbarhet" ;
  demeriterande_av_1_A = mkA "demeriterande" ;
  demilitariserbarhet_nn_1_N = mkN "demilitariserbarhet" ;
  demobiliserbarhet_nn_1_N = mkN "demobiliserbarhet" ;
  demografi_nn_1_N = mkN "demografi" ;
  demokratiserbarhet_nn_1_N = mkN "demokratiserbarhet" ;
  demolerbarhet_nn_1_N = mkN "demolerbarhet" ;
  demoni_nn_1_N = mkN "demoni" ;
  demoniserbarhet_nn_1_N = mkN "demoniserbarhet" ;
  demonisering_nn_1_N = mkN "demonisering" ;
  demonologi_nn_1_N = mkN "demonologi" ;
  demonstrerbarhet_nn_1_N = mkN "demonstrerbarhet" ;
  demonterbarhet_nn_1_N = mkN "demonterbarhet" ;
  demoraliserbarhet_nn_1_N = mkN "demoraliserbarhet" ;
  denaturaliserbarhet_nn_1_N = mkN "denaturaliserbarhet" ;
  denaturerbarhet_nn_1_N = mkN "denaturerbarhet" ;
  dendrokronologi_nn_1_N = mkN "dendrokronologi" ;
  dendrologi_nn_1_N = mkN "dendrologi" ;
  denoterbarhet_nn_1_N = mkN "denoterbarhet" ;
  denuderbarhet_nn_1_N = mkN "denuderbarhet" ;
  deodoriserbarhet_nn_1_N = mkN "deodoriserbarhet" ;
  depatrierbarhet_nn_1_N = mkN "depatrierbarhet" ;
  depenserbarhet_nn_1_N = mkN "depenserbarhet" ;
  deplacerbarhet_nn_1_N = mkN "deplacerbarhet" ;
  deponerbarhet_nn_1_N = mkN "deponerbarhet" ;
  deporterbarhet_nn_1_N = mkN "deporterbarhet" ;
  deppighet_nn_1_N = mkN "deppighet" ;
  deprecierbarhet_nn_1_N = mkN "deprecierbarhet" ;
  deprimerande_av_1_A = mkA "deprimerande" ;
  derangerbarhet_nn_1_N = mkN "derangerbarhet" ;
  deriverbarhet_nn_1_N = mkN "deriverbarhet" ;
  dermatologi_nn_1_N = mkN "dermatologi" ;
  desarmerbarhet_nn_1_N = mkN "desarmerbarhet" ;
  desavouerbarhet_nn_1_N = mkN "desavouerbarhet" ;
  desensibiliserbarhet_nn_1_N = mkN "desensibiliserbarhet" ;
  designerbarhet_nn_1_N = mkN "designerbarhet" ;
  desinfekterbarhet_nn_1_N = mkN "desinfekterbarhet" ;
  desinficerbarhet_nn_1_N = mkN "desinficerbarhet" ;
  desinformerbarhet_nn_1_N = mkN "desinformerbarhet" ;
  desorganiserbarhet_nn_1_N = mkN "desorganiserbarhet" ;
  destabiliserande_av_1_A = mkA "destabiliserande" ;
  destabiliserbarhet_nn_1_N = mkN "destabiliserbarhet" ;
  destillerbarhet_nn_1_N = mkN "destillerbarhet" ;
  destinerbarhet_nn_1_N = mkN "destinerbarhet" ;
  destruerbarhet_nn_1_N = mkN "destruerbarhet" ;
  detacherbarhet_nn_1_N = mkN "detacherbarhet" ;
  detaljrikhet_nn_1_N = mkN "detaljrikhet" ;
  detekterbarhet_nn_1_N = mkN "detekterbarhet" ;
  determinerbarhet_nn_1_N = mkN "determinerbarhet" ;
  detonerbarhet_nn_1_N = mkN "detonerbarhet" ;
  detroniserbarhet_nn_1_N = mkN "detroniserbarhet" ;
  devalverbarhet_nn_1_N = mkN "devalverbarhet" ;
  devon_nn_1_N = mkN "devon" ;
  dhivehi_nn_1_N = mkN "dhivehi" ;
  diagnosticerbarhet_nn_1_N = mkN "diagnosticerbarhet" ;
  diagnostiserbarhet_nn_1_N = mkN "diagnostiserbarhet" ;
  diakoni_nn_1_N = mkN "diakoni" ;
  dialektforskning_nn_1_N = mkN "dialektforskning" ;
  dialektgeografi_nn_1_N = mkN "dialektgeografi" ;
  dialektologi_nn_1_N = mkN "dialektologi" ;
  dialogform_nn_1_N = mkN "dialogform" ;
  dialyserbarhet_nn_1_N = mkN "dialyserbarhet" ;
  diatermi_nn_1_N = mkN "diatermi" ;
  diddling_nn_1_N = mkN "diddling" ;
  dieselmotorrengoering_nn_1_1_N = mkN "dieselmotorrengöring" ;
  differentierbarhet_nn_1_N = mkN "differentierbarhet" ;
  diffunderbarhet_nn_1_N = mkN "diffunderbarhet" ;
  difteri_nn_1_N = mkN "difteri" ;
  diftongerbarhet_nn_1_N = mkN "diftongerbarhet" ;
  digerdoed_nn_1_1_N = mkN "digerdöd" ;
  digererbarhet_nn_1_N = mkN "digererbarhet" ;
  diglossi_nn_1_N = mkN "diglossi" ;
  dikterbarhet_nn_1_N = mkN "dikterbarhet" ;
  dilande_nn_1_N = mkN "dilande" ;
  dilettantmaessighet_nn_1_1_N = mkN "dilettantmässighet" ;
  dimensionerbarhet_nn_1_N = mkN "dimensionerbarhet" ;
  dimmighet_nn_1_N = mkN "dimmighet" ;
  ding_av_1_A = mkA "ding" ;
  dinghet_nn_1_N = mkN "dinghet" ;
  dinkel_nn_1_N = mkN "dinkel" ;
  diploid_av_1_A = mkA "diploid" ;
  diplomati_nn_1_N = mkN "diplomati" ;
  diplomerbarhet_nn_1_N = mkN "diplomerbarhet" ;
  dipsomani_nn_1_N = mkN "dipsomani" ;
  direktdemokrati_nn_1_N = mkN "direktdemokrati" ;
  direktionskraft_nn_1_N = mkN "direktionskraft" ;
  direktlyftande_av_1_A = mkA "direktlyftande" ;
  direktsaendande_nn_1_1_N = mkN "direktsändande" ;
  direktverkande_av_1_A = mkA "direktverkande" ;
  dirigerbarhet_nn_1_N = mkN "dirigerbarhet" ;
  disambiguerbarhet_nn_1_N = mkN "disambiguerbarhet" ;
  disciplinerbarhet_nn_1_N = mkN "disciplinerbarhet" ;
  disharmonierbarhet_nn_1_N = mkN "disharmonierbarhet" ;
  disighet_nn_1_N = mkN "disighet" ;
  diskning_nn_1_N = mkN "diskning" ;
  diskonterbarhet_nn_1_N = mkN "diskonterbarhet" ;
  diskontinuerlighet_nn_1_N = mkN "diskontinuerlighet" ;
  diskrediterbarhet_nn_1_N = mkN "diskrediterbarhet" ;
  diskriminerbarhet_nn_1_N = mkN "diskriminerbarhet" ;
  diskrimineringsbekaempning_nn_1_1_N = mkN "diskrimineringsbekämpning" ;
  diskuterbarhet_nn_1_N = mkN "diskuterbarhet" ;
  diskvalificerbarhet_nn_1_N = mkN "diskvalificerbarhet" ;
  dispascherbarhet_nn_1_N = mkN "dispascherbarhet" ;
  dispenserbarhet_nn_1_N = mkN "dispenserbarhet" ;
  dispergerbarhet_nn_1_N = mkN "dispergerbarhet" ;
  disponerbarhet_nn_1_N = mkN "disponerbarhet" ;
  dispositionsraett_nn_1_1_N = mkN "dispositionsrätt" ;
  disproportionerlighet_nn_1_N = mkN "disproportionerlighet" ;
  disputerbarhet_nn_1_N = mkN "disputerbarhet" ;
  dissekerbarhet_nn_1_N = mkN "dissekerbarhet" ;
  dissimilerbarhet_nn_1_N = mkN "dissimilerbarhet" ;
  dissimilering_nn_1_N = mkN "dissimilering" ;
  dissocierbarhet_nn_1_N = mkN "dissocierbarhet" ;
  distanserbarhet_nn_1_N = mkN "distanserbarhet" ;
  distansritt_nn_1_N = mkN "distansritt" ;
  distraherbarhet_nn_1_N = mkN "distraherbarhet" ;
  distribuerbarhet_nn_1_N = mkN "distribuerbarhet" ;
  distrae_av_1_1_A = mkA "disträ" ;
  dithoerande_av_1_1_A = mkA "dithörande" ;
  dito_av_1_A = mkA "dito" ;
  dittillsvarande_av_1_A = mkA "dittillsvarande" ;
  divergerbarhet_nn_1_N = mkN "divergerbarhet" ;
  diverse_av_1_A = mkA "diverse" ;
  diversifierbarhet_nn_1_N = mkN "diversifierbarhet" ;
  dividerbarhet_nn_1_N = mkN "dividerbarhet" ;
  djungeltelegraf_nn_1_N = mkN "djungeltelegraf" ;
  djupborrande_av_1_A = mkA "djupborrande" ;
  djupfuktande_av_1_A = mkA "djupfuktande" ;
  djupgaaende_av_1_1_A = mkA "djupgående" ;
  djupgaaende_nn_1_1_N = mkN "djupgående" ;
  djuphet_nn_1_N = mkN "djuphet" ;
  djuplodande_av_1_A = mkA "djuplodande" ;
  djuppsykologi_nn_1_N = mkN "djuppsykologi" ;
  djupsoemn_nn_1_1_N = mkN "djupsömn" ;
  djuptaenkthet_nn_1_1_N = mkN "djuptänkthet" ;
  djuranatomi_nn_1_N = mkN "djuranatomi" ;
  djurgeografi_nn_1_N = mkN "djurgeografi" ;
  djurhaallning_nn_1_1_N = mkN "djurhållning" ;
  djuriskhet_nn_1_N = mkN "djuriskhet" ;
  djurliknande_av_1_A = mkA "djurliknande" ;
  djurpsykologi_nn_1_N = mkN "djurpsykologi" ;
  djurrike_nn_1_N = mkN "djurrike" ;
  djurtillsyn_nn_1_N = mkN "djurtillsyn" ;
  djuruppfoedning_nn_1_1_N = mkN "djuruppfödning" ;
  djurvaenlighet_nn_1_1_N = mkN "djurvänlighet" ;
  djurvaerld_nn_1_1_N = mkN "djurvärld" ;
  djaevla_av_1_1_A = mkA "djävla" ;
  dna_testande_nn_1_N = mkN "dna-testande" ;
  docerbarhet_nn_1_N = mkN "docerbarhet" ;
  docering_nn_1_N = mkN "docering" ;
  dockaktighet_nn_1_N = mkN "dockaktighet" ;
  doftloeshet_nn_1_1_N = mkN "doftlöshet" ;
  doftmarkerbarhet_nn_1_N = mkN "doftmarkerbarhet" ;
  doftsvaghet_nn_1_N = mkN "doftsvaghet" ;
  dogmatiserbarhet_nn_1_N = mkN "dogmatiserbarhet" ;
  dokumenterbarhet_nn_1_N = mkN "dokumenterbarhet" ;
  doldhet_nn_1_N = mkN "doldhet" ;
  dollardiplomati_nn_1_N = mkN "dollardiplomati" ;
  dolskhet_nn_1_N = mkN "dolskhet" ;
  domedag_nn_1_N = mkN "domedag" ;
  domesticerbarhet_nn_1_N = mkN "domesticerbarhet" ;
  domhavande_av_1_A = mkA "domhavande" ;
  domicilierbarhet_nn_1_N = mkN "domicilierbarhet" ;
  dominerande_av_1_A = mkA "dominerande" ;
  dominerbarhet_nn_1_N = mkN "dominerbarhet" ;
  dompterbarhet_nn_1_N = mkN "dompterbarhet" ;
  domsraett_nn_1_1_N = mkN "domsrätt" ;
  donerbarhet_nn_1_N = mkN "donerbarhet" ;
  dopaminkaenslighet_nn_1_1_N = mkN "dopaminkänslighet" ;
  doppardag_nn_1_N = mkN "doppardag" ;
  dopparedag_nn_1_N = mkN "dopparedag" ;
  dorskhet_nn_1_N = mkN "dorskhet" ;
  doserbarhet_nn_1_N = mkN "doserbarhet" ;
  dosimetri_nn_1_N = mkN "dosimetri" ;
  dosserbarhet_nn_1_N = mkN "dosserbarhet" ;
  doterbarhet_nn_1_N = mkN "doterbarhet" ;
  dotterlighet_nn_1_N = mkN "dotterlighet" ;
  dovhet_nn_1_N = mkN "dovhet" ;
  dragenhet_nn_1_N = mkN "dragenhet" ;
  dragerbarhet_nn_1_N = mkN "dragerbarhet" ;
  draghjaelp_nn_1_1_N = mkN "draghjälp" ;
  draglaege_nn_1_1_N = mkN "dragläge" ;
  dragningskraft_nn_1_N = mkN "dragningskraft" ;
  dramatiserbarhet_nn_1_N = mkN "dramatiserbarhet" ;
  draperbarhet_nn_1_N = mkN "draperbarhet" ;
  dresserbarhet_nn_1_N = mkN "dresserbarhet" ;
  drickbarhet_nn_1_N = mkN "drickbarhet" ;
  driftande_nn_1_N = mkN "driftande" ;
  driftighet_nn_1_N = mkN "driftighet" ;
  driftning_nn_1_N = mkN "driftning" ;
  driftsaekerhet_nn_1_1_N = mkN "driftsäkerhet" ;
  dristighet_nn_1_N = mkN "dristighet" ;
  drivande_av_1_A = mkA "drivande" ;
  drivenhet_nn_1_N = mkN "drivenhet" ;
  drivflykt_nn_1_N = mkN "drivflykt" ;
  drogberoende_nn_1_N = mkN "drogberoende" ;
  drogmissbrukande_av_1_A = mkA "drogmissbrukande" ;
  druckenhet_nn_1_N = mkN "druckenhet" ;
  drummelaktighet_nn_1_N = mkN "drummelaktighet" ;
  dryckenskap_nn_1_N = mkN "dryckenskap" ;
  draeglighet_nn_1_1_N = mkN "dräglighet" ;
  draenage_nn_1_1_N = mkN "dränage" ;
  draenerbarhet_nn_1_1_N = mkN "dränerbarhet" ;
  draenkbarhet_nn_1_1_N = mkN "dränkbarhet" ;
  draenkning_nn_1_1_N = mkN "dränkning" ;
  draepande_av_1_1_A = mkA "dräpande" ;
  droemlikhet_nn_1_1_N = mkN "drömlikhet" ;
  droemliknande_av_1_1_A = mkA "drömliknande" ;
  droemmil_nn_1_1_N = mkN "drömmil" ;
  droemskhet_nn_1_1_N = mkN "drömskhet" ;
  droemsoemn_nn_1_1_N = mkN "drömsömn" ;
  dubbelarbetande_av_1_A = mkA "dubbelarbetande" ;
  dubbelexponerbarhet_nn_1_N = mkN "dubbelexponerbarhet" ;
  dubbelhandsfattning_nn_1_N = mkN "dubbelhandsfattning" ;
  dubbelhaeftande_av_1_1_A = mkA "dubbelhäftande" ;
  dubbelseende_nn_1_N = mkN "dubbelseende" ;
  dubbelsyn_nn_1_N = mkN "dubbelsyn" ;
  dubbeltydighet_nn_1_N = mkN "dubbeltydighet" ;
  dubbelverkande_av_1_A = mkA "dubbelverkande" ;
  dubblerbarhet_nn_1_N = mkN "dubblerbarhet" ;
  dubbslitage_nn_1_N = mkN "dubbslitage" ;
  duettsaang_nn_1_1_N = mkN "duettsång" ;
  dugande_av_1_A = mkA "dugande" ;
  duktighet_nn_1_N = mkN "duktighet" ;
  dumdristighet_nn_1_N = mkN "dumdristighet" ;
  dumdryghet_nn_1_N = mkN "dumdryghet" ;
  dumkaat_av_1_1_A = mkA "dumkåt" ;
  dunderhonung_nn_1_N = mkN "dunderhonung" ;
  dunstighet_nn_1_N = mkN "dunstighet" ;
  duperbarhet_nn_1_N = mkN "duperbarhet" ;
  duplicerbarhet_nn_1_N = mkN "duplicerbarhet" ;
  durumvete_nn_1_N = mkN "durumvete" ;
  duvenhet_nn_1_N = mkN "duvenhet" ;
  dvaergaktighet_nn_1_1_N = mkN "dvärgaktighet" ;
  dvaergalaat_nn_1_1_N = mkN "dvärgalåt" ;
  dybloethet_nn_1_1_N = mkN "dyblöthet" ;
  dygdighet_nn_1_N = mkN "dygdighet" ;
  dygnsvill_av_1_A = mkA "dygnsvill" ;
  dygnsvillhet_nn_1_N = mkN "dygnsvillhet" ;
  dyighet_nn_1_N = mkN "dyighet" ;
  dyngsurhet_nn_1_N = mkN "dyngsurhet" ;
  dyrhet_nn_1_N = mkN "dyrhet" ;
  dyrkansvaerdhet_nn_1_1_N = mkN "dyrkansvärdhet" ;
  dyrkoepthet_nn_1_1_N = mkN "dyrköpthet" ;
  dystopiskhet_nn_1_N = mkN "dystopiskhet" ;
  dyvelstraeck_nn_1_1_N = mkN "dyvelsträck" ;
  daeckavtagning_nn_1_1_N = mkN "däckavtagning" ;
  daesthet_nn_1_1_N = mkN "dästhet" ;
  daevenhet_nn_1_1_N = mkN "dävenhet" ;
  daadkraft_nn_1_1_N = mkN "dådkraft" ;
  daadloeshet_nn_1_1_N = mkN "dådlöshet" ;
  daalig_av_1_1_A = mkA "dålig" ;
  daatid_nn_1_1_N = mkN "dåtid" ;
  daatida_av_1_1_A = mkA "dåtida" ;
  daavarande_av_1_1_A = mkA "dåvarande" ;
  doe_av_1_1_A = mkA "dö" ;
  doeblekhet_nn_1_1_N = mkN "döblekhet" ;
  doedande_av_1_1_A = mkA "dödande" ;
  doedande_nn_1_1_N = mkN "dödande" ;
  doedbraend_av_1_1_A = mkA "dödbränd" ;
  doedhet_nn_1_1_N = mkN "dödhet" ;
  doedlighet_nn_2_1_N = mkN "dödlighet" ;
  doedsblekhet_nn_1_1_N = mkN "dödsblekhet" ;
  doedsfoeraktande_av_1_1_A = mkA "dödsföraktande" ;
  doedshjaelp_nn_1_1_N = mkN "dödshjälp" ;
  doedssjukhet_nn_1_1_N = mkN "dödssjukhet" ;
  doedstraakighet_nn_1_1_N = mkN "dödstråkighet" ;
  doedstroetthet_nn_1_1_N = mkN "dödströtthet" ;
  doedtid_nn_1_1_N = mkN "dödtid" ;
  doedvikt_nn_1_1_N = mkN "dödvikt" ;
  doerrknackning_nn_1_1_N = mkN "dörrknackning" ;
  doevblind_av_1_1_A = mkA "dövblind" ;
  doevblindhet_nn_1_1_N = mkN "dövblindhet" ;
  doevstumhet_nn_1_1_N = mkN "dövstumhet" ;
  ederbarhet_nn_1_N = mkN "ederbarhet" ;
  edlighet_nn_1_N = mkN "edlighet" ;
  edsoere_nn_1_1_N = mkN "edsöre" ;
  efemeridtid_nn_1_N = mkN "efemeridtid" ;
  effacerbarhet_nn_1_N = mkN "effacerbarhet" ;
  effektfullhet_nn_1_N = mkN "effektfullhet" ;
  effektiverbarhet_nn_1_N = mkN "effektiverbarhet" ;
  effektiviserbarhet_nn_1_N = mkN "effektiviserbarhet" ;
  effektloeshet_nn_1_1_N = mkN "effektlöshet" ;
  effektskapande_av_1_A = mkA "effektskapande" ;
  effektuerbarhet_nn_1_N = mkN "effektuerbarhet" ;
  efter_av_1_A = mkA "efter" ;
  efterblivenhet_nn_1_N = mkN "efterblivenhet" ;
  efterdaterbarhet_nn_1_N = mkN "efterdaterbarhet" ;
  efterdebiterbarhet_nn_1_N = mkN "efterdebiterbarhet" ;
  efterdoemlighet_nn_1_1_N = mkN "efterdömlighet" ;
  efterfoeljd_nn_1_1_N = mkN "efterföljd" ;
  eftergivlighet_nn_1_N = mkN "eftergivlighet" ;
  efterhand_nn_1_N = mkN "efterhand" ;
  efterhaengsenhet_nn_1_1_N = mkN "efterhängsenhet" ;
  efterklokhet_nn_1_N = mkN "efterklokhet" ;
  efterlevande_av_1_A = mkA "efterlevande" ;
  efterliggande_av_1_A = mkA "efterliggande" ;
  efterlaatenhet_nn_1_1_N = mkN "efterlåtenhet" ;
  eftermiddagskaffe_nn_1_N = mkN "eftermiddagskaffe" ;
  efternatt_nn_1_N = mkN "efternatt" ;
  efterrationaliserbarhet_nn_1_N = mkN "efterrationaliserbarhet" ;
  eftersaknad_nn_1_N = mkN "eftersaknad" ;
  eftersinnande_av_1_A = mkA "eftersinnande" ;
  efterskaenkande_nn_1_1_N = mkN "efterskänkande" ;
  efterskaenkning_nn_1_1_N = mkN "efterskänkning" ;
  efterskoerd_nn_1_1_N = mkN "efterskörd" ;
  efterslaentrande_av_1_1_A = mkA "eftersläntrande" ;
  eftersmak_nn_1_N = mkN "eftersmak" ;
  efterstraevansvaerdhet_nn_1_1_N = mkN "eftersträvansvärdhet" ;
  eftersyn_nn_1_N = mkN "eftersyn" ;
  eftersynkroniserbarhet_nn_1_N = mkN "eftersynkroniserbarhet" ;
  eftersoekthet_nn_1_1_N = mkN "eftersökthet" ;
  eftertaxerbarhet_nn_1_N = mkN "eftertaxerbarhet" ;
  eftertorkning_nn_1_N = mkN "eftertorkning" ;
  eftertraktansvaerdhet_nn_1_1_N = mkN "eftertraktansvärdhet" ;
  eftertrycklighet_nn_1_N = mkN "eftertrycklighet" ;
  eftertaenksamhet_nn_1_1_N = mkN "eftertänksamhet" ;
  eftervishet_nn_1_N = mkN "eftervishet" ;
  eftervaerld_nn_1_1_N = mkN "eftervärld" ;
  eftervaard_nn_1_1_N = mkN "eftervård" ;
  egaliserbarhet_nn_1_N = mkN "egaliserbarhet" ;
  egenart_nn_1_N = mkN "egenart" ;
  egendomsgemenskap_nn_1_N = mkN "egendomsgemenskap" ;
  egendomsloeshet_nn_1_1_N = mkN "egendomslöshet" ;
  egenhaendighet_nn_1_1_N = mkN "egenhändighet" ;
  egenmaektighet_nn_1_1_N = mkN "egenmäktighet" ;
  egennyttighet_nn_1_N = mkN "egennyttighet" ;
  egenraettfaerdighet_nn_1_1_N = mkN "egenrättfärdighet" ;
  egenraadighet_nn_1_1_N = mkN "egenrådighet" ;
  egensinnighet_nn_1_N = mkN "egensinnighet" ;
  egenvaerde_nn_1_1_N = mkN "egenvärde" ;
  egoboostande_nn_1_N = mkN "egoboostande" ;
  egyptologi_nn_1_N = mkN "egyptologi" ;
  eke_nn_1_N = mkN "eke" ;
  ekiperbarhet_nn_1_N = mkN "ekiperbarhet" ;
  eklaterbarhet_nn_1_N = mkN "eklaterbarhet" ;
  eklut_nn_1_N = mkN "eklut" ;
  eklaererbarhet_nn_1_1_N = mkN "eklärerbarhet" ;
  ekologi_nn_1_N = mkN "ekologi" ;
  ekonometri_nn_1_N = mkN "ekonometri" ;
  ekonomie_av_1_A = mkA "ekonomie" ;
  ekonomiraett_nn_1_1_N = mkN "ekonomirätt" ;
  ekonomiserbarhet_nn_1_N = mkN "ekonomiserbarhet" ;
  ekorrliknande_av_1_A = mkA "ekorrliknande" ;
  ekvatorshoejd_nn_1_1_N = mkN "ekvatorshöjd" ;
  ekvirke_nn_1_N = mkN "ekvirke" ;
  elaborerbarhet_nn_1_N = mkN "elaborerbarhet" ;
  elastiserbarhet_nn_1_N = mkN "elastiserbarhet" ;
  eldfarlighet_nn_1_N = mkN "eldfarlighet" ;
  eldfasthet_nn_1_N = mkN "eldfasthet" ;
  eldfaengdhet_nn_1_1_N = mkN "eldfängdhet" ;
  eldhaerdighet_nn_1_1_N = mkN "eldhärdighet" ;
  eldighet_nn_1_N = mkN "eldighet" ;
  eldkraft_nn_1_N = mkN "eldkraft" ;
  eldskrift_nn_1_N = mkN "eldskrift" ;
  eldsprutande_av_1_A = mkA "eldsprutande" ;
  eldsaekerhet_nn_1_1_N = mkN "eldsäkerhet" ;
  elefanthud_nn_1_N = mkN "elefanthud" ;
  elektrificerbarhet_nn_1_N = mkN "elektrificerbarhet" ;
  elektrifierbarhet_nn_1_N = mkN "elektrifierbarhet" ;
  elektriserbarhet_nn_1_N = mkN "elektriserbarhet" ;
  elektrokemi_nn_1_N = mkN "elektrokemi" ;
  elektrometallurgi_nn_1_N = mkN "elektrometallurgi" ;
  elektroterapi_nn_1_N = mkN "elektroterapi" ;
  elenergi_nn_1_N = mkN "elenergi" ;
  elevhaelsovaard_nn_1_1_N = mkN "elevhälsovård" ;
  elevvaard_nn_1_1_N = mkN "elevvård" ;
  eliderbarhet_nn_1_N = mkN "eliderbarhet" ;
  eliminerbarhet_nn_1_N = mkN "eliminerbarhet" ;
  elittaenkande_nn_1_1_N = mkN "elittänkande" ;
  elkonsumtion_nn_1_N = mkN "elkonsumtion" ;
  elkraft_nn_1_N = mkN "elkraft" ;
  elmseld_nn_1_N = mkN "elmseld" ;
  eloxerbarhet_nn_1_N = mkN "eloxerbarhet" ;
  eltejp_nn_1_N = mkN "eltejp" ;
  eluderbarhet_nn_1_N = mkN "eluderbarhet" ;
  eluerbarhet_nn_1_N = mkN "eluerbarhet" ;
  eluvium_nn_1_N = mkN "eluvium" ;
  elaenda_av_1_1_A = mkA "elända" ;
  elaendighet_nn_1_1_N = mkN "eländighet" ;
  emaljerbarhet_nn_1_N = mkN "emaljerbarhet" ;
  emanciperbarhet_nn_1_N = mkN "emanciperbarhet" ;
  emballerbarhet_nn_1_N = mkN "emballerbarhet" ;
  embarkerbarhet_nn_1_N = mkN "embarkerbarhet" ;
  embellerbarhet_nn_1_N = mkN "embellerbarhet" ;
  emblematiskhet_nn_1_N = mkN "emblematiskhet" ;
  embryologi_nn_1_N = mkN "embryologi" ;
  emenderbarhet_nn_1_N = mkN "emenderbarhet" ;
  emigrerbarhet_nn_1_N = mkN "emigrerbarhet" ;
  eminenthet_nn_1_N = mkN "eminenthet" ;
  emitterbarhet_nn_1_N = mkN "emitterbarhet" ;
  emmervete_nn_1_N = mkN "emmervete" ;
  emotionaliserande_nn_1_N = mkN "emotionaliserande" ;
  emotionalisering_nn_1_N = mkN "emotionalisering" ;
  empati_nn_1_N = mkN "empati" ;
  empiri_nn_1_N = mkN "empiri" ;
  emulgerbarhet_nn_1_N = mkN "emulgerbarhet" ;
  enahanda_av_1_A = mkA "enahanda" ;
  enaraadande_av_1_1_A = mkA "enarådande" ;
  enastaaende_av_1_1_A = mkA "enastående" ;
  enaxlighet_nn_1_N = mkN "enaxlighet" ;
  enbenthet_nn_1_N = mkN "enbenthet" ;
  encellighet_nn_1_N = mkN "encellighet" ;
  endaste_av_1_A = mkA "endaste" ;
  endokrinologi_nn_1_N = mkN "endokrinologi" ;
  endosserbarhet_nn_1_N = mkN "endosserbarhet" ;
  endraekt_nn_1_1_N = mkN "endräkt" ;
  ene_nn_1_N = mkN "ene" ;
  energibesparande_av_1_A = mkA "energibesparande" ;
  energifoerbrukning_nn_1_1_N = mkN "energiförbrukning" ;
  energikraevande_av_1_1_A = mkA "energikrävande" ;
  energiprincip_nn_1_N = mkN "energiprincip" ;
  energirikhet_nn_1_N = mkN "energirikhet" ;
  energisparande_av_1_A = mkA "energisparande" ;
  energiupptagande_av_1_A = mkA "energiupptagande" ;
  enerverbarhet_nn_1_N = mkN "enerverbarhet" ;
  enfald_nn_1_N = mkN "enfald" ;
  enfaldighet_nn_1_N = mkN "enfaldighet" ;
  enfas_av_1_A = mkA "enfas" ;
  enformighet_nn_1_N = mkN "enformighet" ;
  engagerbarhet_nn_1_N = mkN "engagerbarhet" ;
  engelskaundervisning_nn_1_N = mkN "engelskaundervisning" ;
  engelskspraakighet_nn_1_1_N = mkN "engelskspråkighet" ;
  engelskspaakighet_nn_1_1_N = mkN "engelskspåkighet" ;
  engelsktalande_av_1_A = mkA "engelsktalande" ;
  engelskundervisning_nn_1_N = mkN "engelskundervisning" ;
  engifte_nn_1_N = mkN "engifte" ;
  engaangs_av_1_1_A = mkA "engångs" ;
  engaangskaraktaer_nn_1_1_N = mkN "engångskaraktär" ;
  enhetlighet_nn_1_N = mkN "enhetlighet" ;
  enhjulighet_nn_1_N = mkN "enhjulighet" ;
  enhaellighet_nn_1_1_N = mkN "enhällighet" ;
  enkelspaarighet_nn_1_1_N = mkN "enkelspårighet" ;
  enklang_nn_1_N = mkN "enklang" ;
  enklavisering_nn_1_N = mkN "enklavisering" ;
  enkomponents_av_1_A = mkA "enkomponents" ;
  enleverbarhet_nn_1_N = mkN "enleverbarhet" ;
  enormhet_nn_1_N = mkN "enormhet" ;
  enpolighet_nn_1_N = mkN "enpolighet" ;
  enpucklighet_nn_1_N = mkN "enpucklighet" ;
  enrollerbarhet_nn_1_N = mkN "enrollerbarhet" ;
  ens_av_1_A = mkA "ens" ;
  ensamanlaendande_av_1_1_A = mkA "ensamanländande" ;
  ensamkommande_av_1_A = mkA "ensamkommande" ;
  ensamstaaende_av_1_1_A = mkA "ensamstående" ;
  ense_av_1_A = mkA "ense" ;
  ensidighet_nn_1_N = mkN "ensidighet" ;
  ensilage_nn_1_N = mkN "ensilage" ;
  ensilerbarhet_nn_1_N = mkN "ensilerbarhet" ;
  enskifte_nn_1_N = mkN "enskifte" ;
  enslighet_nn_1_N = mkN "enslighet" ;
  enspraakighet_nn_1_1_N = mkN "enspråkighet" ;
  enspaend_av_1_1_A = mkA "enspänd" ;
  enstaka_av_1_A = mkA "enstaka" ;
  enstavighet_nn_1_N = mkN "enstavighet" ;
  enstavighetsaccent_nn_1_N = mkN "enstavighetsaccent" ;
  enstaemmighet_nn_1_1_N = mkN "enstämmighet" ;
  enstaendighet_nn_1_1_N = mkN "enständighet" ;
  enstoerighet_nn_1_1_N = mkN "enstörighet" ;
  entalpi_nn_1_N = mkN "entalpi" ;
  entomologi_nn_1_N = mkN "entomologi" ;
  entonighet_nn_1_N = mkN "entonighet" ;
  entropi_nn_1_N = mkN "entropi" ;
  entraegenhet_nn_1_1_N = mkN "enträgenhet" ;
  entusiasmerbarhet_nn_1_N = mkN "entusiasmerbarhet" ;
  envetenhet_nn_1_N = mkN "envetenhet" ;
  envishet_nn_1_N = mkN "envishet" ;
  envaelde_nn_1_1_N = mkN "envälde" ;
  envaeldighet_nn_1_1_N = mkN "enväldighet" ;
  envaaldsmakt_nn_1_1_N = mkN "envåldsmakt" ;
  enoegdhet_nn_1_1_N = mkN "enögdhet" ;
  eoarkeikum_nn_1_N = mkN "eoarkeikum" ;
  eocen_nn_1_N = mkN "eocen" ;
  epidemiologi_nn_1_N = mkN "epidemiologi" ;
  epilerbarhet_nn_1_N = mkN "epilerbarhet" ;
  epistemologi_nn_1_N = mkN "epistemologi" ;
  epokgoerande_av_1_1_A = mkA "epokgörande" ;
  erfarenhetsmaessighet_nn_1_1_N = mkN "erfarenhetsmässighet" ;
  erforderlighet_nn_1_N = mkN "erforderlighet" ;
  ergonomi_nn_1_N = mkN "ergonomi" ;
  erigerbarhet_nn_1_N = mkN "erigerbarhet" ;
  erisaepple_nn_1_1_N = mkN "erisäpple" ;
  erkaend_av_1_1_A = mkA "erkänd" ;
  erkaendhet_nn_1_1_N = mkN "erkändhet" ;
  erkaennsamhet_nn_1_1_N = mkN "erkännsamhet" ;
  eroderbarhet_nn_1_N = mkN "eroderbarhet" ;
  erotiserande_nn_1_N = mkN "erotiserande" ;
  erotisering_nn_1_N = mkN "erotisering" ;
  erotomani_nn_1_N = mkN "erotomani" ;
  ersaettlighet_nn_1_1_N = mkN "ersättlighet" ;
  ersaettningsskyldighet_nn_1_1_N = mkN "ersättningsskyldighet" ;
  eskalerbarhet_nn_1_N = mkN "eskalerbarhet" ;
  eskatologi_nn_1_N = mkN "eskatologi" ;
  eskorterbarhet_nn_1_N = mkN "eskorterbarhet" ;
  esperanto_nn_1_N = mkN "esperanto" ;
  espri_nn_1_N = mkN "espri" ;
  esteticerbarhet_nn_1_N = mkN "esteticerbarhet" ;
  estetiserbarhet_nn_1_N = mkN "estetiserbarhet" ;
  estimerbarhet_nn_1_N = mkN "estimerbarhet" ;
  etablerbarhet_nn_1_N = mkN "etablerbarhet" ;
  eteriserbarhet_nn_1_N = mkN "eteriserbarhet" ;
  etiketterbarhet_nn_1_N = mkN "etiketterbarhet" ;
  etiologi_nn_1_N = mkN "etiologi" ;
  etnografi_nn_1_N = mkN "etnografi" ;
  etnologi_nn_1_N = mkN "etnologi" ;
  etologi_nn_1_N = mkN "etologi" ;
  etruskologi_nn_1_N = mkN "etruskologi" ;
  ettrighet_nn_1_N = mkN "ettrighet" ;
  etymologiserbarhet_nn_1_N = mkN "etymologiserbarhet" ;
  eukalyptusdoftande_av_1_A = mkA "eukalyptusdoftande" ;
  europeiserbarhet_nn_1_N = mkN "europeiserbarhet" ;
  europid_av_1_A = mkA "europid" ;
  europium_nn_1_N = mkN "europium" ;
  eutanasi_nn_1_N = mkN "eutanasi" ;
  evakuerbarhet_nn_1_N = mkN "evakuerbarhet" ;
  evaluerbarhet_nn_1_N = mkN "evaluerbarhet" ;
  evalverbarhet_nn_1_N = mkN "evalverbarhet" ;
  evaporerbarhet_nn_1_N = mkN "evaporerbarhet" ;
  evinnerlighet_nn_1_N = mkN "evinnerlighet" ;
  evolutionsmaessighet_nn_1_1_N = mkN "evolutionsmässighet" ;
  evaerdlighet_nn_1_1_N = mkN "evärdlighet" ;
  examinerbarhet_nn_1_N = mkN "examinerbarhet" ;
  excerperbarhet_nn_1_N = mkN "excerperbarhet" ;
  exciterbarhet_nn_1_N = mkN "exciterbarhet" ;
  exekverbarhet_nn_1_N = mkN "exekverbarhet" ;
  exemplifierbarhet_nn_1_N = mkN "exemplifierbarhet" ;
  exercerbarhet_nn_1_N = mkN "exercerbarhet" ;
  existensberaettigande_nn_1_1_N = mkN "existensberättigande" ;
  exkluderbarhet_nn_1_N = mkN "exkluderbarhet" ;
  exkommunicerbarhet_nn_1_N = mkN "exkommunicerbarhet" ;
  expanderbarhet_nn_1_N = mkN "expanderbarhet" ;
  expansionstakt_nn_1_N = mkN "expansionstakt" ;
  expatrierbarhet_nn_1_N = mkN "expatrierbarhet" ;
  expedierbarhet_nn_1_N = mkN "expedierbarhet" ;
  expektorerbarhet_nn_1_N = mkN "expektorerbarhet" ;
  experimentalkirurgi_nn_1_N = mkN "experimentalkirurgi" ;
  explicerbarhet_nn_1_N = mkN "explicerbarhet" ;
  explicithet_nn_1_N = mkN "explicithet" ;
  exploaterbarhet_nn_1_N = mkN "exploaterbarhet" ;
  exploderbarhet_nn_1_N = mkN "exploderbarhet" ;
  exponerbarhet_nn_1_N = mkN "exponerbarhet" ;
  exporterbarhet_nn_1_N = mkN "exporterbarhet" ;
  exproprierbarhet_nn_1_N = mkN "exproprierbarhet" ;
  exstirperbarhet_nn_1_N = mkN "exstirperbarhet" ;
  extemporerbarhet_nn_1_N = mkN "extemporerbarhet" ;
  exterritorialraett_nn_1_1_N = mkN "exterritorialrätt" ;
  extra_av_1_A = mkA "extra" ;
  extraherbarhet_nn_1_N = mkN "extraherbarhet" ;
  extrahud_nn_1_N = mkN "extrahud" ;
  extraordinarie_av_1_A = mkA "extraordinarie" ;
  extrapolerbarhet_nn_1_N = mkN "extrapolerbarhet" ;
  extroverthet_nn_1_N = mkN "extroverthet" ;
  fabelaktighet_nn_1_N = mkN "fabelaktighet" ;
  fabricerbarhet_nn_1_N = mkN "fabricerbarhet" ;
  fabriksarbetande_av_1_A = mkA "fabriksarbetande" ;
  fabriksmaessighet_nn_1_1_N = mkN "fabriksmässighet" ;
  fabulerbarhet_nn_1_N = mkN "fabulerbarhet" ;
  facetterbarhet_nn_1_N = mkN "facetterbarhet" ;
  fackkunnighet_nn_1_N = mkN "fackkunnighet" ;
  facklighet_nn_1_N = mkN "facklighet" ;
  fackmaessighet_nn_1_1_N = mkN "fackmässighet" ;
  fadd_av_1_A = mkA "fadd" ;
  faddhet_nn_1_N = mkN "faddhet" ;
  faderlighet_nn_1_N = mkN "faderlighet" ;
  faderskaerlek_nn_1_1_N = mkN "faderskärlek" ;
  faktakoll_nn_1_N = mkN "faktakoll" ;
  faktiskhet_nn_1_N = mkN "faktiskhet" ;
  fakturerbarhet_nn_1_N = mkN "fakturerbarhet" ;
  falhet_nn_1_N = mkN "falhet" ;
  falkblick_nn_1_N = mkN "falkblick" ;
  fallandesot_nn_1_N = mkN "fallandesot" ;
  fallfaerdighet_nn_1_1_N = mkN "fallfärdighet" ;
  fallskaermsliknande_av_1_1_A = mkA "fallskärmsliknande" ;
  falsifierbarhet_nn_1_N = mkN "falsifierbarhet" ;
  familjeraett_nn_1_1_N = mkN "familjerätt" ;
  familjeterapi_nn_1_N = mkN "familjeterapi" ;
  familjetillhoerighet_nn_1_1_N = mkN "familjetillhörighet" ;
  familjevaard_nn_1_1_N = mkN "familjevård" ;
  famlande_av_1_A = mkA "famlande" ;
  fanflykt_nn_1_N = mkN "fanflykt" ;
  fantasieggande_av_1_A = mkA "fantasieggande" ;
  fantasikraft_nn_1_N = mkN "fantasikraft" ;
  fantasirikedom_nn_1_N = mkN "fantasirikedom" ;
  fantasirikhet_nn_1_N = mkN "fantasirikhet" ;
  fantiserbarhet_nn_1_N = mkN "fantiserbarhet" ;
  fantomsnygghet_nn_1_N = mkN "fantomsnygghet" ;
  farbarhet_nn_1_N = mkN "farbarhet" ;
  farbroderlighet_nn_1_N = mkN "farbroderlighet" ;
  farmaci_nn_1_N = mkN "farmaci" ;
  farmacie_av_1_A = mkA "farmacie" ;
  farmakognosi_nn_1_N = mkN "farmakognosi" ;
  farmakologi_nn_1_N = mkN "farmakologi" ;
  farofylldhet_nn_1_N = mkN "farofylldhet" ;
  farsi_nn_1_N = mkN "farsi" ;
  fartblind_av_1_A = mkA "fartblind" ;
  fartblindhet_nn_1_N = mkN "fartblindhet" ;
  fartfylldhet_nn_1_N = mkN "fartfylldhet" ;
  fartvind_nn_1_N = mkN "fartvind" ;
  fartygsflagg_nn_1_N = mkN "fartygsflagg" ;
  fartygsproviant_nn_1_N = mkN "fartygsproviant" ;
  fasavaeckande_av_1_1_A = mkA "fasaväckande" ;
  fascinerbarhet_nn_1_N = mkN "fascinerbarhet" ;
  fascistoid_av_1_A = mkA "fascistoid" ;
  fasetterbarhet_nn_1_N = mkN "fasetterbarhet" ;
  fasonerbarhet_nn_1_N = mkN "fasonerbarhet" ;
  fastighetstaxerbarhet_nn_1_N = mkN "fastighetstaxerbarhet" ;
  fastlag_nn_1_N = mkN "fastlag" ;
  fastspaenning_nn_1_1_N = mkN "fastspänning" ;
  fatt_av_1_A = mkA "fatt" ;
  fattighjaelp_nn_1_1_N = mkN "fattighjälp" ;
  fattigvaard_nn_1_1_N = mkN "fattigvård" ;
  fattlighet_nn_1_N = mkN "fattlighet" ;
  favoriserbarhet_nn_1_N = mkN "favoriserbarhet" ;
  febrighet_nn_1_N = mkN "febrighet" ;
  fel_av_1_A = invarA "fel" ;
  felfrihet_nn_1_N = mkN "felfrihet" ;
  felnavigerande_nn_1_N = mkN "felnavigerande" ;
  felparkerbarhet_nn_1_N = mkN "felparkerbarhet" ;
  felsyn_nn_1_N = mkN "felsyn" ;
  femdubblande_nn_1_N = mkN "femdubblande" ;
  femdubbling_nn_1_N = mkN "femdubbling" ;
  femfaldigande_nn_1_N = mkN "femfaldigande" ;
  femmarkerkorv_nn_1_N = mkN "femmarkerkorv" ;
  femmil_nn_1_N = mkN "femmil" ;
  fena_av_1_A = mkA "fena" ;
  fennomani_nn_1_N = mkN "fennomani" ;
  fenomenologi_nn_1_N = mkN "fenomenologi" ;
  fermenterbarhet_nn_1_N = mkN "fermenterbarhet" ;
  fermhet_nn_1_N = mkN "fermhet" ;
  festlighet_nn_2_N = mkN "festlighet" ;
  festplanering_nn_1_N = mkN "festplanering" ;
  feterbarhet_nn_1_N = mkN "feterbarhet" ;
  fethet_nn_1_N = mkN "fethet" ;
  fetlagdhet_nn_1_N = mkN "fetlagdhet" ;
  fetthaltighet_nn_1_N = mkN "fetthaltighet" ;
  fettloesande_av_1_1_A = mkA "fettlösande" ;
  fettrikhet_nn_1_N = mkN "fettrikhet" ;
  fettsot_nn_1_N = mkN "fettsot" ;
  fettvaev_nn_1_1_N = mkN "fettväv" ;
  fetvadd_nn_1_N = mkN "fetvadd" ;
  fiberrikhet_nn_1_N = mkN "fiberrikhet" ;
  fibrighet_nn_1_N = mkN "fibrighet" ;
  filantropi_nn_1_N = mkN "filantropi" ;
  filateli_nn_1_N = mkN "filateli" ;
  filharmoni_nn_1_N = mkN "filharmoni" ;
  filosofie_av_1_A = mkA "filosofie" ;
  finemang_av_1_A = mkA "finemang" ;
  finsktalande_av_1_A = mkA "finsktalande" ;
  fiske_nn_1_N = mkN "fiske" ;
  fiskaetande_nn_1_1_N = mkN "fiskätande" ;
  fjaederliknande_av_1_1_A = mkA "fjäderliknande" ;
  fjaellnaera_av_1_1_A = mkA "fjällnära" ;
  fjaerran_av_1_1_A = mkA "fjärran" ;
  fjaerrseende_av_1_1_A = mkA "fjärrseende" ;
  fjaerrskaadande_av_1_1_A = mkA "fjärrskådande" ;
  fladdermusliknande_av_1_A = mkA "fladdermusliknande" ;
  flaggviftande_av_1_A = mkA "flaggviftande" ;
  flat_av_1_A = mkA "flat" ;
  flau_av_1_A = mkA "flau" ;
  flergaangs_av_1_1_A = mkA "flergångs" ;
  flicktycke_nn_1_N = mkN "flicktycke" ;
  flugfiske_nn_1_N = mkN "flugfiske" ;
  flyktingmottagande_nn_1_N = mkN "flyktingmottagande" ;
  folkomroestande_nn_1_1_N = mkN "folkomröstande" ;
  folkpoesi_nn_1_N = mkN "folkpoesi" ;
  follikelstimulerande_av_1_A = mkA "follikelstimulerande" ;
  foniatri_nn_1_N = mkN "foniatri" ;
  fonologi_nn_1_N = mkN "fonologi" ;
  fordrande_av_1_A = mkA "fordrande" ;
  forntida_av_1_A = mkA "forntida" ;
  forskningsforskningsstoedjande_av_1_1_A = mkA "forskningsforskningsstödjande" ;
  fortgaaende_av_1_1_A = mkA "fortgående" ;
  fortis_av_1_A = mkA "fortis" ;
  fortloepande_av_1_1_A = mkA "fortlöpande" ;
  fortran_nn_1_N = mkN "fortran" ;
  fortuna_nn_1_N = mkN "fortuna" ;
  fossilletande_nn_1_N = mkN "fossilletande" ;
  fotabjaelle_nn_1_1_N = mkN "fotabjälle" ;
  fotfaeste_nn_1_1_N = mkN "fotfäste" ;
  fotogenique_av_1_A = mkA "fotogenique" ;
  fotogrammetri_nn_1_N = mkN "fotogrammetri" ;
  fotointresse_nn_1_N = mkN "fotointresse" ;
  fotokemi_nn_1_N = mkN "fotokemi" ;
  fotometri_nn_1_N = mkN "fotometri" ;
  framdrivande_nn_1_N = mkN "framdrivande" ;
  framfoersittande_av_1_1_A = mkA "framförsittande" ;
  framfoervarande_av_1_1_A = mkA "framförvarande" ;
  framgaangsteologi_nn_1_1_N = mkN "framgångsteologi" ;
  framrusande_av_1_A = mkA "framrusande" ;
  framskjutande_av_1_A = mkA "framskjutande" ;
  framspringande_av_1_A = mkA "framspringande" ;
  framstaaende_av_1_1_A = mkA "framstående" ;
  framtida_av_1_A = mkA "framtida" ;
  framtraedande_av_1_1_A = mkA "framträdande" ;
  framtraengande_av_1_1_A = mkA "framträngande" ;
  framtraengande_nn_1_1_N = mkN "framträngande" ;
  framaatblickande_av_1_1_A = mkA "framåtblickande" ;
  framaatskridande_nn_1_1_N = mkN "framåtskridande" ;
  framaatsyftande_av_1_1_A = mkA "framåtsyftande" ;
  fransktalande_av_1_A = mkA "fransktalande" ;
  frapperande_av_1_A = mkA "frapperande" ;
  fraseologi_nn_1_N = mkN "fraseologi" ;
  fredsbefraemjande_av_1_1_A = mkA "fredsbefrämjande" ;
  fredsbevarande_av_1_A = mkA "fredsbevarande" ;
  fredstida_av_1_A = mkA "fredstida" ;
  fredsaelskande_av_1_1_A = mkA "fredsälskande" ;
  frenesi_nn_1_N = mkN "frenesi" ;
  frenologi_nn_1_N = mkN "frenologi" ;
  frestande_av_1_A = mkA "frestande" ;
  fribaerande_av_1_1_A = mkA "fribärande" ;
  frigid_av_1_A = mkA "frigid" ;
  frigaaende_av_1_1_A = mkA "frigående" ;
  frihetsfoerkvaevande_av_1_1_A = mkA "frihetsförkvävande" ;
  frihetslaengtande_av_1_1_A = mkA "frihetslängtande" ;
  frilevande_av_1_A = mkA "frilevande" ;
  friserande_nn_1_N = mkN "friserande" ;
  fristaaende_av_1_1_A = mkA "fristående" ;
  fruktbringande_av_1_A = mkA "fruktbringande" ;
  fruktbaerande_av_1_1_A = mkA "fruktbärande" ;
  fruktliknande_av_1_A = mkA "fruktliknande" ;
  fraelse_av_1_1_A = mkA "frälse" ;
  fraelse_nn_1_1_N = mkN "frälse" ;
  fraemmande_av_1_1_A = mkA "främmande" ;
  fraemmat_av_1_1_A = mkA "främmat" ;
  fraemre_av_1_1_A = mkA "främre" ;
  fraetande_av_1_1_A = mkA "frätande" ;
  fraanskiljande_nn_1_1_N = mkN "frånskiljande" ;
  fraanstoetande_av_1_1_A = mkA "frånstötande" ;
  fraantraede_nn_1_1_N = mkN "frånträde" ;
  fraanvarande_av_1_1_A = mkA "frånvarande" ;
  fraanvaend_av_1_1_A = mkA "frånvänd" ;
  fullproppande_nn_1_N = mkN "fullproppande" ;
  fulvinklande_nn_1_N = mkN "fulvinklande" ;
  furage_nn_1_N = mkN "furage" ;
  futurologi_nn_1_N = mkN "futurologi" ;
  fylogeni_nn_1_N = mkN "fylogeni" ;
  fyrdelande_nn_1_N = mkN "fyrdelande" ;
  fyrdubblande_nn_1_N = mkN "fyrdubblande" ;
  fyrfaldigande_nn_1_N = mkN "fyrfaldigande" ;
  fyrfota_av_1_A = mkA "fyrfota" ;
  fysiologi_nn_1_N = mkN "fysiologi" ;
  faederne_nn_1_1_N = mkN "fäderne" ;
  faeltbiologi_nn_1_1_N = mkN "fältbiologi" ;
  faeltskytte_nn_1_1_N = mkN "fältskytte" ;
  faengslande_av_1_1_A = mkA "fängslande" ;
  faerdigjaesande_nn_1_1_N = mkN "färdigjäsande" ;
  faergblind_av_1_1_A = mkA "färgblind" ;
  faergflagnande_av_1_1_A = mkA "färgflagnande" ;
  faergseende_nn_1_1_N = mkN "färgseende" ;
  faergsprakande_av_1_1_A = mkA "färgsprakande" ;
  faergaekta_av_1_1_A = mkA "färgäkta" ;
  faersksmide_nn_1_1_N = mkN "färsksmide" ;
  faestningsliknande_av_1_1_A = mkA "fästningsliknande" ;
  foega_av_1_1_A = mkA "föga" ;
  foeljande_av_1_1_A = mkA "följande" ;
  foerargelsevaeckande_av_1_1_A = mkA "förargelseväckande" ;
  foerbarmande_nn_1_1_N = mkN "förbarmande" ;
  foerbemaelde_av_1_1_A = mkA "förbemälde" ;
  foerberedande_av_1_1_A = mkA "förberedande" ;
  foerbi_av_1_1_A = mkA "förbi" ;
  foerbipasserande_av_1_1_A = mkA "förbipasserande" ;
  foerbiskyndande_av_1_1_A = mkA "förbiskyndande" ;
  foerbisvepande_av_1_1_A = mkA "förbisvepande" ;
  foerbisvischande_av_1_1_A = mkA "förbisvischande" ;
  foerblivande_av_1_1_A = mkA "förblivande" ;
  foerbluffande_av_1_1_A = mkA "förbluffande" ;
  foerdetta_av_1_1_A = mkA "fördetta" ;
  foerdomsalstrande_av_1_1_A = mkA "fördomsalstrande" ;
  foerdunstande_nn_1_1_N = mkN "fördunstande" ;
  foeregaaende_av_1_1_A = mkA "föregående" ;
  foeregaaende_nn_1_1_N = mkN "föregående" ;
  foerekommande_av_1_1_A = mkA "förekommande" ;
  foerestaellande_av_1_1_A = mkA "föreställande" ;
  foerestaaende_av_1_1_A = mkA "förestående" ;
  foeretagsdemokrati_nn_1_1_N = mkN "företagsdemokrati" ;
  foeretagsekonomi_nn_1_1_N = mkN "företagsekonomi" ;
  foerevarande_av_1_1_A = mkA "förevarande" ;
  foerhanden_av_1_1_A = mkA "förhanden" ;
  foerhandenvarande_av_1_1_A = mkA "förhandenvarande" ;
  foerhistoria_nn_1_1_N = mkN "förhistoria" ;
  foerhaerskande_av_1_1_A = mkA "förhärskande" ;
  foerintande_av_1_1_A = mkA "förintande" ;
  foerklenande_av_1_1_A = mkA "förklenande" ;
  foerkrossande_av_1_1_A = mkA "förkrossande" ;
  foerledande_av_1_1_A = mkA "förledande" ;
  foerlitande_nn_1_1_N = mkN "förlitande" ;
  foerlustbringande_av_1_1_A = mkA "förlustbringande" ;
  foermedlande_av_1_1_A = mkA "förmedlande" ;
  foermenande_nn_1_1_N = mkN "förmenande" ;
  foermer_av_1_1_A = mkA "förmer" ;
  foermera_av_1_1_A = mkA "förmera" ;
  foermildrande_av_1_1_A = mkA "förmildrande" ;
  foernaglande_nn_1_1_N = mkN "förnaglande" ;
  foerpliktande_av_1_1_A = mkA "förpliktande" ;
  foerrfoerra_av_1_1_A = mkA "förrförra" ;
  foersoffande_nn_1_1_N = mkN "försoffande" ;
  foersonande_av_1_1_A = mkA "försonande" ;
  foerspaend_av_1_1_A = mkA "förspänd" ;
  foerstbemaelde_av_1_1_A = mkA "förstbemälde" ;
  foerstnaemnd_av_1_1_A = mkA "förstnämnd" ;
  foerstaaende_av_1_1_A = mkA "förstående" ;
  foersvaarande_av_1_1_A = mkA "försvårande" ;
  foertida_av_1_1_A = mkA "förtida" ;
  foertingligande_nn_1_1_N = mkN "förtingligande" ;
  foertjusande_av_1_1_A = mkA "förtjusande" ;
  foertroendeingivande_av_1_1_A = mkA "förtroendeingivande" ;
  foertrollande_av_1_1_A = mkA "förtrollande" ;
  foerutseende_av_1_1_A = mkA "förutseende" ;
  foerutseende_nn_1_1_N = mkN "förutseende" ;
  foerutvarande_av_1_1_A = mkA "förutvarande" ;
  foervikingatida_av_1_1_A = mkA "förvikingatida" ;
  foervirrande_av_1_1_A = mkA "förvirrande" ;
  foervaend_av_1_1_A = mkA "förvänd" ;
  foervaallande_nn_1_1_N = mkN "förvållande" ;
  foeryngringsbeskaerande_nn_1_1_N = mkN "föryngringsbeskärande" ;
  foeroedande_av_1_1_A = mkA "förödande" ;
  gagnvirke_nn_1_N = mkN "gagnvirke" ;
  gall_av_1_A = mkA "gall" ;
  galldrivande_av_1_A = mkA "galldrivande" ;
  galvanostegi_nn_1_N = mkN "galvanostegi" ;
  galvanotypi_nn_1_N = mkN "galvanotypi" ;
  gammaldags_av_1_A = mkA "gammaldags" ;
  gammalrosa_av_1_A = mkA "gammalrosa" ;
  gaskromatografi_nn_1_N = mkN "gaskromatografi" ;
  gastronomi_nn_1_N = mkN "gastronomi" ;
  gatupoesi_nn_1_N = mkN "gatupoesi" ;
  gematri_nn_1_N = mkN "gematri" ;
  gemmologi_nn_1_N = mkN "gemmologi" ;
  generande_av_1_A = mkA "generande" ;
  genomgripande_av_1_A = mkA "genomgripande" ;
  genomgaaende_av_1_1_A = mkA "genomgående" ;
  genomlysande_av_1_A = mkA "genomlysande" ;
  genomtraengande_av_1_1_A = mkA "genomträngande" ;
  genretaenjande_av_1_1_A = mkA "genretänjande" ;
  geodesi_nn_1_N = mkN "geodesi" ;
  geografi_nn_1_N = mkN "geografi" ;
  geokemi_nn_1_N = mkN "geokemi" ;
  geokronologi_nn_1_N = mkN "geokronologi" ;
  geologi_nn_1_N = mkN "geologi" ;
  geomorfologi_nn_1_N = mkN "geomorfologi" ;
  geotermi_nn_1_N = mkN "geotermi" ;
  geriatri_nn_1_N = mkN "geriatri" ;
  gerontologi_nn_1_N = mkN "gerontologi" ;
  gestaltpsykologi_nn_1_N = mkN "gestaltpsykologi" ;
  giraffliknande_av_1_A = mkA "giraffliknande" ;
  givande_av_1_A = mkA "givande" ;
  glaciologi_nn_1_N = mkN "glaciologi" ;
  glasvete_nn_1_N = mkN "glasvete" ;
  glottokronologi_nn_1_N = mkN "glottokronologi" ;
  glupande_av_1_A = mkA "glupande" ;
  gluten_av_1_A = mkA "gluten" ;
  glaedjande_av_1_1_A = mkA "glädjande" ;
  glaedjestraalande_av_1_1_A = mkA "glädjestrålande" ;
  glaensande_av_1_1_A = mkA "glänsande" ;
  gloedande_av_1_1_A = mkA "glödande" ;
  gnagarliknande_av_1_A = mkA "gnagarliknande" ;
  god_av_1_A = mkA "god" ;
  godkaend_av_1_1_A = mkA "godkänd" ;
  godtycke_nn_1_N = mkN "godtycke" ;
  goticerande_av_1_A = mkA "goticerande" ;
  gotiserande_av_1_A = mkA "gotiserande" ;
  gott_av_1_A = mkA "gott" ;
  gottfinnande_nn_1_N = mkN "gottfinnande" ;
  grad_av_1_A = mkA "grad" ;
  grafologi_nn_1_N = mkN "grafologi" ;
  grafonomi_nn_1_N = mkN "grafonomi" ;
  gramse_av_1_A = mkA "gramse" ;
  granatbeskjutande_nn_1_N = mkN "granatbeskjutande" ;
  grannlaga_av_1_A = mkA "grannlaga" ;
  graverande_av_1_A = mkA "graverande" ;
  gravid_av_1_A = mkA "gravid" ;
  grekisktalande_av_1_A = mkA "grekisktalande" ;
  grenstaaende_av_1_1_A = mkA "grenstående" ;
  gripande_av_1_A = mkA "gripande" ;
  groggvirke_nn_1_N = mkN "groggvirke" ;
  groggy_av_1_A = mkA "groggy" ;
  grovsmide_nn_1_N = mkN "grovsmide" ;
  grund_av_1_A = mkA "grund" ;
  grundlaeggande_av_1_1_A = mkA "grundläggande" ;
  gruppsykologi_nn_1_N = mkN "gruppsykologi" ;
  gryne_nn_1_N = mkN "gryne" ;
  gryningsgroggy_av_1_A = mkA "gryningsgroggy" ;
  graenstaenjande_av_1_1_A = mkA "gränstänjande" ;
  graensoeverskridande_av_1_1_A = mkA "gränsöverskridande" ;
  graeshoppeliknande_av_1_1_A = mkA "gräshoppeliknande" ;
  graesliknande_av_1_1_A = mkA "gräsliknande" ;
  graavide_nn_1_1_N = mkN "gråvide" ;
  groenbete_nn_1_1_N = mkN "grönbete" ;
  groenblind_av_1_1_A = mkA "grönblind" ;
  groepe_nn_1_1_N = mkN "gröpe" ;
  gudaliknande_av_1_A = mkA "gudaliknande" ;
  gudasaend_av_1_1_A = mkA "gudasänd" ;
  gudomliggoerande_nn_1_1_N = mkN "gudomliggörande" ;
  gudstroende_av_1_A = mkA "gudstroende" ;
  gujarati_nn_1_N = mkN "gujarati" ;
  guldglaensande_av_1_1_A = mkA "guldglänsande" ;
  guldliknande_av_1_A = mkA "guldliknande" ;
  gultoerne_nn_1_1_N = mkN "gultörne" ;
  gylfputande_av_1_A = mkA "gylfputande" ;
  gyllene_av_1_A = mkA "gyllene" ;
  gyllenglaensande_av_1_1_A = mkA "gyllenglänsande" ;
  gyllne_av_1_A = mkA "gyllne" ;
  gynekologi_nn_1_N = mkN "gynekologi" ;
  gaengse_av_1_1_A = mkA "gängse" ;
  gaavodiplomati_nn_1_1_N = mkN "gåvodiplomati" ;
  haj_av_1_A = mkA "haj" ;
  halal_av_1_A = mkA "halal" ;
  halma_nn_1_N = mkN "halma" ;
  halsbrytande_av_1_A = mkA "halsbrytande" ;
  halt_nn_2_N = mkN "halt" ;
  halvblind_av_1_A = mkA "halvblind" ;
  halvflytande_av_1_A = mkA "halvflytande" ;
  halvlinne_nn_1_N = mkN "halvlinne" ;
  halvnaeck_av_1_1_A = mkA "halvnäck" ;
  halvrund_av_1_A = mkA "halvrund" ;
  halvtidsarbetande_av_1_A = mkA "halvtidsarbetande" ;
  halvylle_nn_1_N = mkN "halvylle" ;
  handbojande_nn_1_N = mkN "handbojande" ;
  haploid_av_1_A = mkA "haploid" ;
  harpunliknande_av_1_A = mkA "harpunliknande" ;
  haspelfiske_nn_1_N = mkN "haspelfiske" ;
  hausa_nn_2_N = mkN "hausa" ;
  havande_av_1_A = mkA "havande" ;
  havreliknande_av_1_A = mkA "havreliknande" ;
  havsfiske_nn_1_N = mkN "havsfiske" ;
  havsgaaende_av_1_1_A = mkA "havsgående" ;
  hedrande_av_1_A = mkA "hedrande" ;
  hejdundrande_av_1_A = mkA "hejdundrande" ;
  helbraegda_av_1_1_A = mkA "helbrägda" ;
  heltidsarbetande_av_1_A = mkA "heltidsarbetande" ;
  heltaeckande_av_1_1_A = mkA "heltäckande" ;
  helvetes_av_1_A = mkA "helvetes" ;
  helylle_nn_1_N = mkN "helylle" ;
  hemarbetande_av_1_A = mkA "hemarbetande" ;
  hematologi_nn_1_N = mkN "hematologi" ;
  hembraend_av_1_1_A = mkA "hembränd" ;
  hemdragande_av_1_A = mkA "hemdragande" ;
  hemma_av_1_A = mkA "hemma" ;
  hemmablind_av_1_A = mkA "hemmablind" ;
  hemmaboende_av_1_A = mkA "hemmaboende" ;
  hemmahoerande_av_1_1_A = mkA "hemmahörande" ;
  hemvaendande_av_1_1_A = mkA "hemvändande" ;
  herpetologi_nn_1_N = mkN "herpetologi" ;
  hetero_av_1_A = mkA "hetero" ;
  himlastormande_av_1_A = mkA "himlastormande" ;
  himmelrike_nn_1_N = mkN "himmelrike" ;
  himmelsskriande_av_1_A = mkA "himmelsskriande" ;
  hindi_nn_1_N = mkN "hindi" ;
  hindrande_av_1_A = mkA "hindrande" ;
  hinneliknande_av_1_A = mkA "hinneliknande" ;
  hippologi_nn_1_N = mkN "hippologi" ;
  histologi_nn_1_N = mkN "histologi" ;
  historieberaettande_av_1_1_A = mkA "historieberättande" ;
  historieintresse_nn_1_N = mkN "historieintresse" ;
  hithoerande_av_1_1_A = mkA "hithörande" ;
  hittillsvarande_av_1_A = mkA "hittillsvarande" ;
  hjaelpbehoevande_av_1_1_A = mkA "hjälpbehövande" ;
  hjaelpsoekande_av_1_1_A = mkA "hjälpsökande" ;
  hjaertas_av_1_1_A = mkA "hjärtas" ;
  hjaertknipande_av_1_1_A = mkA "hjärtknipande" ;
  hjaertskaerande_av_1_1_A = mkA "hjärtskärande" ;
  hjaertslitande_av_1_1_A = mkA "hjärtslitande" ;
  hjaertstillande_av_1_1_A = mkA "hjärtstillande" ;
  holocen_nn_1_N = mkN "holocen" ;
  holografi_nn_1_N = mkN "holografi" ;
  homeopati_nn_1_N = mkN "homeopati" ;
  homo_av_1_A = mkA "homo" ;
  hoppingivande_av_1_A = mkA "hoppingivande" ;
  hoprullande_nn_1_N = mkN "hoprullande" ;
  hornblaende_nn_1_1_N = mkN "hornblände" ;
  hornliknande_av_1_A = mkA "hornliknande" ;
  hornaemne_nn_1_1_N = mkN "hornämne" ;
  hudnaera_av_1_1_A = mkA "hudnära" ;
  humanekologi_nn_1_N = mkN "humanekologi" ;
  humid_av_1_A = mkA "humid" ;
  hundra_av_1_A = mkA "hundra" ;
  hundraedd_av_1_1_A = mkA "hundrädd" ;
  hushaallsnaera_av_1_1_A = mkA "hushållsnära" ;
  hybrid_av_1_A = mkA "hybrid" ;
  hycklande_av_1_A = mkA "hycklande" ;
  hydrografi_nn_1_N = mkN "hydrografi" ;
  hydrologi_nn_1_N = mkN "hydrologi" ;
  hymnologi_nn_1_N = mkN "hymnologi" ;
  hypertoni_nn_1_N = mkN "hypertoni" ;
  hyvens_av_1_A = mkA "hyvens" ;
  haelsobringande_av_1_1_A = mkA "hälsobringande" ;
  haelsofraemjande_av_1_1_A = mkA "hälsofrämjande" ;
  haenfoerande_av_1_1_A = mkA "hänförande" ;
  haepnadsvaeckande_av_1_1_A = mkA "häpnadsväckande" ;
  haestliknande_av_1_1_A = mkA "hästliknande" ;
  haestminne_nn_1_1_N = mkN "hästminne" ;
  haesttaemjande_nn_1_1_N = mkN "hästtämjande" ;
  haardloedande_nn_1_1_N = mkN "hårdlödande" ;
  haarliknande_av_1_1_A = mkA "hårliknande" ;
  haarresande_av_1_1_A = mkA "hårresande" ;
  hoeftfaeste_nn_1_1_N = mkN "höftfäste" ;
  hoegenergi_nn_1_1_N = mkN "högenergi" ;
  hoeggravid_av_1_1_A = mkA "höggravid" ;
  hoeglaege_nn_1_1_N = mkN "högläge" ;
  hoegpresterande_av_1_1_A = mkA "högpresterande" ;
  hoegspaend_av_1_1_A = mkA "högspänd" ;
  hoegstbjudande_av_1_1_A = mkA "högstbjudande" ;
  hoegstraevande_av_1_1_A = mkA "högsträvande" ;
  hoegtflygande_av_1_1_A = mkA "högtflygande" ;
  hoegtravande_av_1_1_A = mkA "högtravande" ;
  hoegtstaaende_av_1_1_A = mkA "högtstående" ;
  hoegtaeckande_av_1_1_A = mkA "högtäckande" ;
  hoensminne_nn_1_1_N = mkN "hönsminne" ;
  icke_existerande_av_1_A = mkA "icke-existerande" ;
  identitetssoekande_av_1_1_A = mkA "identitetssökande" ;
  ideografi_nn_1_N = mkN "ideografi" ;
  idiopati_nn_1_N = mkN "idiopati" ;
  ido_nn_1_N = mkN "ido" ;
  id_ehistoria_nn_1_1_N = mkN "idéhistoria" ;
  ifraagavarande_av_1_1_A = mkA "ifrågavarande" ;
  igenkaennande_av_1_1_A = mkA "igenkännande" ;
  igenkaennande_nn_1_1_N = mkN "igenkännande" ;
  igensaettande_nn_1_1_N = mkN "igensättande" ;
  ihaallande_av_1_1_A = mkA "ihållande" ;
  ikonografi_nn_1_N = mkN "ikonografi" ;
  iktyologi_nn_1_N = mkN "iktyologi" ;
  illaluktande_av_1_A = mkA "illaluktande" ;
  illamaaende_av_1_1_A = mkA "illamående" ;
  illamaaende_nn_1_1_N = mkN "illamående" ;
  illasmakande_av_1_A = mkA "illasmakande" ;
  illavarslande_av_1_A = mkA "illavarslande" ;
  immunologi_nn_1_N = mkN "immunologi" ;
  imponerande_av_1_A = mkA "imponerande" ;
  inbjudande_av_1_A = mkA "inbjudande" ;
  inbringande_av_1_A = mkA "inbringande" ;
  inboerdes_av_1_1_A = mkA "inbördes" ;
  indianliknande_av_1_A = mkA "indianliknande" ;
  individualpsykologi_nn_1_N = mkN "individualpsykologi" ;
  indologi_nn_1_N = mkN "indologi" ;
  industrispionage_nn_1_N = mkN "industrispionage" ;
  infantiliserande_nn_1_N = mkN "infantiliserande" ;
  inflationsdrivande_av_1_A = mkA "inflationsdrivande" ;
  influensaliknande_av_1_A = mkA "influensaliknande" ;
  informationsteori_nn_1_N = mkN "informationsteori" ;
  ingredierande_av_1_A = mkA "ingredierande" ;
  ingaaende_av_1_1_A = mkA "ingående" ;
  inkomstberoende_av_1_A = mkA "inkomstberoende" ;
  inkomstbringande_av_1_A = mkA "inkomstbringande" ;
  inkaennande_av_1_1_A = mkA "inkännande" ;
  inkaennande_nn_1_1_N = mkN "inkännande" ;
  inledande_av_1_A = mkA "inledande" ;
  inne_av_1_A = mkA "inne" ;
  innebandyspelande_av_1_A = mkA "innebandyspelande" ;
  inneboende_av_1_A = mkA "inneboende" ;
  inneliggande_av_1_A = mkA "inneliggande" ;
  innestaaende_av_1_1_A = mkA "innestående" ;
  innevarande_av_1_A = mkA "innevarande" ;
  inprogrammerande_nn_1_N = mkN "inprogrammerande" ;
  inrikes_av_1_A = mkA "inrikes" ;
  inrusande_nn_1_N = mkN "inrusande" ;
  inseende_nn_1_N = mkN "inseende" ;
  insektsaetande_av_1_1_A = mkA "insektsätande" ;
  insjoefiske_nn_1_1_N = mkN "insjöfiske" ;
  insmickrande_av_1_A = mkA "insmickrande" ;
  intagande_av_1_A = mkA "intagande" ;
  integrerande_av_1_A = mkA "integrerande" ;
  internet_nn_1_N = mkN "internet" ;
  intet_nn_1_N = mkN "intet" ;
  intetsaegande_av_1_1_A = mkA "intetsägande" ;
  intilliggande_av_1_A = mkA "intilliggande" ;
  intimiserande_nn_1_N = mkN "intimiserande" ;
  intresse_nn_2_N = mkN "intresse" ;
  intressevaeckande_av_1_1_A = mkA "intresseväckande" ;
  intrigflaetande_av_1_1_A = mkA "intrigflätande" ;
  intraengande_av_1_1_A = mkA "inträngande" ;
  invand_av_1_A = mkA "invand" ;
  invaertes_av_1_1_A = mkA "invärtes" ;
  inaakande_av_1_1_A = mkA "inåkande" ;
  inaatvaend_av_1_1_A = mkA "inåtvänd" ;
  isfiske_nn_1_N = mkN "isfiske" ;
  islaege_nn_1_1_N = mkN "isläge" ;
  isskimrande_av_1_A = mkA "isskimrande" ;
  istaand_av_1_1_A = mkA "istånd" ;
  ioegonenfallande_av_1_1_A = mkA "iögonenfallande" ;
  ioegonfallande_av_1_1_A = mkA "iögonfallande" ;
  jakande_av_1_A = mkA "jakande" ;
  jaktskytte_nn_1_N = mkN "jaktskytte" ;
  jalu_av_1_A = mkA "jalu" ;
  jordnaera_av_1_1_A = mkA "jordnära" ;
  jourhavande_av_1_A = mkA "jourhavande" ;
  jublande_av_1_A = mkA "jublande" ;
  jura_nn_1_N = mkN "jura" ;
  juris_av_1_A = mkA "juris" ;
  juste_av_1_A = mkA "juste" ;
  jaedra_av_1_1_A = mkA "jädra" ;
  jaedrans_av_1_1_A = mkA "jädrans" ;
  jaekla_av_1_1_A = mkA "jäkla" ;
  jaemfoerande_av_1_1_A = mkA "jämförande" ;
  jaernmetallurgi_nn_1_1_N = mkN "järnmetallurgi" ;
  jaettebra_av_1_1_A = mkA "jättebra" ;
  jaettekul_av_1_1_A = mkA "jättekul" ;
  jaetteraedd_av_1_1_A = mkA "jätterädd" ;
  jaevla_av_1_1_A = mkA "jävla" ;
  kadmiumgult_nn_1_N = mkN "kadmiumgult" ;
  kadmiumroett_nn_1_1_N = mkN "kadmiumrött" ;
  kainsmaerke_nn_1_1_N = mkN "kainsmärke" ;
  kakdoppande_av_1_A = mkA "kakdoppande" ;
  kalkkvaeve_nn_1_1_N = mkN "kalkkväve" ;
  kalkliknande_av_1_A = mkA "kalkliknande" ;
  kallflytande_av_1_A = mkA "kallflytande" ;
  kalligrafi_nn_1_N = mkN "kalligrafi" ;
  kambrium_nn_1_N = mkN "kambrium" ;
  kambrosilur_nn_1_N = mkN "kambrosilur" ;
  kameraoevervakande_nn_1_1_N = mkN "kameraövervakande" ;
  kamferdoftande_av_1_A = mkA "kamferdoftande" ;
  kamouflage_nn_1_N = mkN "kamouflage" ;
  kanon_av_1_A = mkA "kanon" ;
  kanonbra_av_1_A = mkA "kanonbra" ;
  kanonbaatsdiplomati_nn_1_1_N = mkN "kanonbåtsdiplomati" ;
  kaosteori_nn_1_N = mkN "kaosteori" ;
  kaputt_av_1_A = mkA "kaputt" ;
  karakterologi_nn_1_N = mkN "karakterologi" ;
  karaktaerologi_nn_1_1_N = mkN "karaktärologi" ;
  karambolage_nn_1_N = mkN "karambolage" ;
  karbon_nn_1_N = mkN "karbon" ;
  kardborrliknande_av_1_A = mkA "kardborrliknande" ;
  kardiologi_nn_1_N = mkN "kardiologi" ;
  kartografi_nn_1_N = mkN "kartografi" ;
  katatoni_nn_1_N = mkN "katatoni" ;
  kattrakande_nn_1_N = mkN "kattrakande" ;
  kaviar_nn_1_N = mkN "kaviar" ;
  kefir_nn_1_N = mkN "kefir" ;
  kemi_nn_1_N = mkN "kemi" ;
  kemigrafi_nn_1_N = mkN "kemigrafi" ;
  kemikum_nn_1_N = mkN "kemikum" ;
  kenozoikum_nn_1_N = mkN "kenozoikum" ;
  kindpussande_nn_1_N = mkN "kindpussande" ;
  king_size_av_1_A = mkA "king-size" ;
  kiromanti_nn_1_N = mkN "kiromanti" ;
  kirurgi_nn_1_N = mkN "kirurgi" ;
  klappkanon_av_1_A = mkA "klappkanon" ;
  klassiserande_av_1_A = mkA "klassiserande" ;
  klassmedvetande_nn_1_N = mkN "klassmedvetande" ;
  klaustrofobi_nn_1_N = mkN "klaustrofobi" ;
  kleptomani_nn_1_N = mkN "kleptomani" ;
  klimathysteri_nn_1_N = mkN "klimathysteri" ;
  klimatologi_nn_1_N = mkN "klimatologi" ;
  klimatoterapi_nn_1_N = mkN "klimatoterapi" ;
  klimattroende_av_1_A = mkA "klimattroende" ;
  klingon_nn_1_N = mkN "klingon" ;
  klorvaete_nn_1_1_N = mkN "klorväte" ;
  klotrund_av_1_A = mkA "klotrund" ;
  kloeverliknande_av_1_1_A = mkA "klöverliknande" ;
  knakande_nn_1_N = mkN "knakande" ;
  knappologi_nn_1_N = mkN "knappologi" ;
  knapptryckande_av_1_A = mkA "knapptryckande" ;
  knivdoedande_nn_1_1_N = mkN "knivdödande" ;
  knaestaaende_nn_1_1_N = mkN "knästående" ;
  koboltblaatt_nn_1_1_N = mkN "koboltblått" ;
  kocko_av_1_A = mkA "kocko" ;
  kodvaexlande_nn_1_1_N = mkN "kodväxlande" ;
  koko_av_1_A = mkA "koko" ;
  koldioxidfoerorenande_av_1_1_A = mkA "koldioxidförorenande" ;
  kollisionsenergi_nn_1_N = mkN "kollisionsenergi" ;
  kolportage_nn_1_N = mkN "kolportage" ;
  kommande_av_1_A = mkA "kommande" ;
  kommunikationsteori_nn_1_N = mkN "kommunikationsteori" ;
  konfliktkraedd_av_1_1_A = mkA "konfliktkrädd" ;
  konfliktraedd_av_1_1_A = mkA "konflikträdd" ;
  konsthistoria_nn_1_N = mkN "konsthistoria" ;
  konstsilke_nn_1_N = mkN "konstsilke" ;
  konstsmide_nn_1_N = mkN "konstsmide" ;
  konstteori_nn_1_N = mkN "konstteori" ;
  konsulterande_av_1_A = mkA "konsulterande" ;
  kontraspionage_nn_1_N = mkN "kontraspionage" ;
  konvalescerande_nn_1_N = mkN "konvalescerande" ;
  koppar_nn_1_N = mkN "koppar" ;
  koralliknande_av_1_A = mkA "koralliknande" ;
  koreografi_nn_1_N = mkN "koreografi" ;
  korksmakande_av_1_A = mkA "korksmakande" ;
  korpande_nn_1_N = mkN "korpande" ;
  korrosionsskyddande_av_1_A = mkA "korrosionsskyddande" ;
  korsvaedrande_nn_1_1_N = mkN "korsvädrande" ;
  korsaegande_nn_1_1_N = mkN "korsägande" ;
  kortklippande_nn_1_N = mkN "kortklippande" ;
  korttidsminne_nn_1_N = mkN "korttidsminne" ;
  koscher_av_1_A = mkA "koscher" ;
  kostnadskraevande_av_1_1_A = mkA "kostnadskrävande" ;
  kostnadssaenkande_av_1_1_A = mkA "kostnadssänkande" ;
  krabb_av_1_A = mkA "krabb" ;
  kraftkraevande_av_1_1_A = mkA "kraftkrävande" ;
  kramploesande_av_1_1_A = mkA "kramplösande" ;
  krampstillande_av_1_A = mkA "krampstillande" ;
  kremservitt_nn_1_N = mkN "kremservitt" ;
  kreoliserande_nn_1_N = mkN "kreoliserande" ;
  kretsloppstaenkande_nn_1_1_N = mkN "kretsloppstänkande" ;
  krigfoerande_av_1_1_A = mkA "krigförande" ;
  krigshetsande_av_1_A = mkA "krigshetsande" ;
  krigshetsande_nn_1_N = mkN "krigshetsande" ;
  krigsliknande_av_1_A = mkA "krigsliknande" ;
  krigsminne_nn_1_N = mkN "krigsminne" ;
  krigsraedd_av_1_1_A = mkA "krigsrädd" ;
  krillfiske_nn_1_N = mkN "krillfiske" ;
  kriminologi_nn_1_N = mkN "kriminologi" ;
  kringboende_av_1_A = mkA "kringboende" ;
  kringfarande_av_1_A = mkA "kringfarande" ;
  kringflackande_av_1_A = mkA "kringflackande" ;
  kringkuskande_nn_1_N = mkN "kringkuskande" ;
  kringliggande_av_1_A = mkA "kringliggande" ;
  kringresande_av_1_A = mkA "kringresande" ;
  kringsimmande_av_1_A = mkA "kringsimmande" ;
  kringsimmande_nn_1_N = mkN "kringsimmande" ;
  kringspringande_av_1_A = mkA "kringspringande" ;
  kringstaaende_av_1_1_A = mkA "kringstående" ;
  kringsvirrande_av_1_A = mkA "kringsvirrande" ;
  kringsvirrande_nn_1_N = mkN "kringsvirrande" ;
  kringvandrande_av_1_A = mkA "kringvandrande" ;
  krismedvetande_nn_1_N = mkN "krismedvetande" ;
  kristallografi_nn_1_N = mkN "kristallografi" ;
  kristologi_nn_1_N = mkN "kristologi" ;
  krita_nn_2_N = mkN "krita" ;
  kroknande_nn_1_N = mkN "kroknande" ;
  kromgult_nn_1_N = mkN "kromgult" ;
  kroppsbyggande_nn_1_N = mkN "kroppsbyggande" ;
  kroppsminne_nn_1_N = mkN "kroppsminne" ;
  kroppsnaera_av_1_1_A = mkA "kroppsnära" ;
  kryddande_nn_1_N = mkN "kryddande" ;
  krypskytte_nn_1_N = mkN "krypskytte" ;
  kryptografi_nn_1_N = mkN "kryptografi" ;
  kraenkande_av_1_1_A = mkA "kränkande" ;
  kraevande_av_1_1_A = mkA "krävande" ;
  kraakliknande_av_1_1_A = mkA "kråkliknande" ;
  kul_av_1_A = mkA "kul" ;
  kulturgeografi_nn_1_N = mkN "kulturgeografi" ;
  kulturhistoria_nn_1_N = mkN "kulturhistoria" ;
  kunnande_nn_1_N = mkN "kunnande" ;
  kunskapssoekande_av_1_1_A = mkA "kunskapssökande" ;
  kunskapsteori_nn_1_N = mkN "kunskapsteori" ;
  kurage_nn_1_N = mkN "kurage" ;
  kurare_nn_1_N = mkN "kurare" ;
  kvantitetsteori_nn_1_N = mkN "kvantitetsteori" ;
  kvantteori_nn_1_N = mkN "kvantteori" ;
  kvarhaengande_av_1_1_A = mkA "kvarhängande" ;
  kvartaer_nn_1_1_N = mkN "kvartär" ;
  kvarvarande_av_1_A = mkA "kvarvarande" ;
  kvarvarande_nn_1_N = mkN "kvarvarande" ;
  kvinnofoertryckande_av_1_1_A = mkA "kvinnoförtryckande" ;
  kvinnotycke_nn_1_N = mkN "kvinnotycke" ;
  kvistliknande_av_1_A = mkA "kvistliknande" ;
  kvitt_av_1_A = mkA "kvitt" ;
  kvaevande_av_1_1_A = mkA "kvävande" ;
  kvaeve_nn_1_1_N = mkN "kväve" ;
  kynologi_nn_1_N = mkN "kynologi" ;
  kyrkkaffe_nn_1_N = mkN "kyrkkaffe" ;
  kyrkobyggande_nn_1_N = mkN "kyrkobyggande" ;
  kyrkohistoria_nn_1_N = mkN "kyrkohistoria" ;
  kyssaekta_av_1_1_A = mkA "kyssäkta" ;
  kaend_av_1_1_A = mkA "känd" ;
  kaendiskaat_av_1_1_A = mkA "kändiskåt" ;
  kaenslotaenkande_nn_1_1_N = mkN "känslotänkande" ;
  kaerleksmelankoli_nn_1_1_N = mkN "kärleksmelankoli" ;
  kaerlekstoerstande_av_1_1_A = mkA "kärlekstörstande" ;
  kaernenergi_nn_1_1_N = mkN "kärnenergi" ;
  kaernfoerande_av_1_1_A = mkA "kärnförande" ;
  kaernkemi_nn_1_1_N = mkN "kärnkemi" ;
  kaernvapenbaerande_av_1_1_A = mkA "kärnvapenbärande" ;
  kaernvirke_nn_1_1_N = mkN "kärnvirke" ;
  kaat_av_1_1_A = mkA "kåt" ;
  koensoeverskridande_av_1_1_A = mkA "könsöverskridande" ;
  koepslaaende_nn_1_1_N = mkN "köpslående" ;
  koettaetande_av_1_1_A = mkA "köttätande" ;
  labiologi_nn_1_N = mkN "labiologi" ;
  labour_nn_1_N = mkN "labour" ;
  lack_av_1_A = mkA "lack" ;
  laga_av_1_A = mkA "laga" ;
  lagtima_av_1_A = mkA "lagtima" ;
  laktos_av_1_A = mkA "laktos" ;
  lampsvart_nn_1_N = mkN "lampsvart" ;
  landsomfattande_av_1_A = mkA "landsomfattande" ;
  laparoskopi_nn_1_N = mkN "laparoskopi" ;
  laryngologi_nn_1_N = mkN "laryngologi" ;
  laserpekande_nn_1_N = mkN "laserpekande" ;
  lat_av_1_A = mkA "lat" ;
  latintalande_av_1_A = mkA "latintalande" ;
  lattedrickande_av_1_A = mkA "lattedrickande" ;
  lattedrickande_nn_1_N = mkN "lattedrickande" ;
  lattjo_av_1_A = mkA "lattjo" ;
  lavendeldoftande_av_1_A = mkA "lavendeldoftande" ;
  laxfiske_nn_1_N = mkN "laxfiske" ;
  leds_av_1_A = mkA "leds" ;
  legio_av_1_A = mkA "legio" ;
  lek_av_1_A = mkA "lek" ;
  lekfiske_nn_1_N = mkN "lekfiske" ;
  leklynne_nn_1_N = mkN "leklynne" ;
  lekt_av_1_A = mkA "lekt" ;
  lenis_av_1_A = mkA "lenis" ;
  lerduveskytte_nn_1_N = mkN "lerduveskytte" ;
  less_av_1_A = mkA "less" ;
  letargi_nn_1_N = mkN "letargi" ;
  levande_av_1_A = mkA "levande" ;
  leverne_nn_1_N = mkN "leverne" ;
  lexikografi_nn_1_N = mkN "lexikografi" ;
  lexikologi_nn_1_N = mkN "lexikologi" ;
  lidande_av_1_A = mkA "lidande" ;
  liggvirke_nn_1_N = mkN "liggvirke" ;
  light_av_1_A = mkA "light" ;
  lika_av_1_A = mkA "lika" ;
  likaberaettigande_nn_1_1_N = mkN "likaberättigande" ;
  likalydande_av_1_A = mkA "likalydande" ;
  likljudande_av_1_A = mkA "likljudande" ;
  liknande_av_1_A = mkA "liknande" ;
  liksvaevande_av_1_1_A = mkA "liksvävande" ;
  liktaenkande_av_1_1_A = mkA "liktänkande" ;
  likvid_av_1_A = mkA "likvid" ;
  lila_av_1_A = mkA "lila" ;
  lila_nn_1_N = mkN "lila" ;
  limnologi_nn_1_N = mkN "limnologi" ;
  lindblomste_nn_1_N = mkN "lindblomste" ;
  linne_nn_1_N = mkN "linne" ;
  lismande_av_1_A = mkA "lismande" ;
  litteraturhistoria_nn_1_N = mkN "litteraturhistoria" ;
  litteratursociologi_nn_1_N = mkN "litteratursociologi" ;
  live_av_1_A = mkA "live" ;
  livgivande_av_1_A = mkA "livgivande" ;
  livraedd_av_1_1_A = mkA "livrädd" ;
  livs_av_1_A = mkA "livs" ;
  livsavgoerande_av_1_1_A = mkA "livsavgörande" ;
  livsbefraemjande_av_1_1_A = mkA "livsbefrämjande" ;
  livsbejakande_av_1_A = mkA "livsbejakande" ;
  livsenergi_nn_1_N = mkN "livsenergi" ;
  livshotande_av_1_A = mkA "livshotande" ;
  livslevande_av_1_A = mkA "livslevande" ;
  livsmedelskemi_nn_1_N = mkN "livsmedelskemi" ;
  livsuppehaelle_nn_1_1_N = mkN "livsuppehälle" ;
  livsuppehaallande_av_1_1_A = mkA "livsuppehållande" ;
  ljudande_av_1_A = mkA "ljudande" ;
  ljuddaempande_av_1_1_A = mkA "ljuddämpande" ;
  ljudhaermande_av_1_1_A = mkA "ljudhärmande" ;
  ljusblind_av_1_A = mkA "ljusblind" ;
  ljusenergi_nn_1_N = mkN "ljusenergi" ;
  ljuskraevande_av_1_1_A = mkA "ljuskrävande" ;
  ljusterapi_nn_1_N = mkN "ljusterapi" ;
  ljusaekta_av_1_1_A = mkA "ljusäkta" ;
  ljusaelskande_av_1_1_A = mkA "ljusälskande" ;
  lockande_av_1_A = mkA "lockande" ;
  logopedi_nn_1_N = mkN "logopedi" ;
  loss_av_1_A = mkA "loss" ;
  lovande_av_1_A = mkA "lovande" ;
  luftfarande_av_1_A = mkA "luftfarande" ;
  luftherravaelde_nn_1_1_N = mkN "luftherravälde" ;
  lufthaerdande_av_1_1_A = mkA "lufthärdande" ;
  luftskytte_nn_1_N = mkN "luftskytte" ;
  lugnande_av_1_A = mkA "lugnande" ;
  lunchkaffe_nn_1_N = mkN "lunchkaffe" ;
  lungandande_av_1_A = mkA "lungandande" ;
  lutter_av_1_A = mkA "lutter" ;
  lyckobringande_av_1_A = mkA "lyckobringande" ;
  lymfliknande_av_1_A = mkA "lymfliknande" ;
  lysande_av_1_A = mkA "lysande" ;
  lytt_av_2_A = mkA "lytt" ;
  lyxkonsumerande_nn_1_N = mkN "lyxkonsumerande" ;
  lae_nn_1_1_N = mkN "lä" ;
  laeck_av_1_1_A = mkA "läck" ;
  laegesenergi_nn_1_1_N = mkN "lägesenergi" ;
  laengsgaaende_av_1_1_A = mkA "längsgående" ;
  laens_av_1_1_A = mkA "läns" ;
  laenspumpande_nn_1_1_N = mkN "länspumpande" ;
  laerdomshistoria_nn_1_1_N = mkN "lärdomshistoria" ;
  laettflytande_av_1_1_A = mkA "lättflytande" ;
  laadliknande_av_1_1_A = mkA "lådliknande" ;
  laagpresterande_av_1_1_A = mkA "lågpresterande" ;
  laagspaend_av_1_1_A = mkA "lågspänd" ;
  laagtstaaende_av_1_1_A = mkA "lågtstående" ;
  laanggrund_av_1_1_A = mkA "långgrund" ;
  laangivande_av_1_1_A = mkA "långivande" ;
  laangtgaaende_av_1_1_A = mkA "långtgående" ;
  laangtidsminne_nn_1_1_N = mkN "långtidsminne" ;
  laangtidsverkande_av_1_1_A = mkA "långtidsverkande" ;
  laangvirke_nn_1_1_N = mkN "långvirke" ;
  laangvaega_av_1_1_A = mkA "långväga" ;
  laatsasdemokrati_nn_1_1_N = mkN "låtsasdemokrati" ;
  loejevaeckande_av_1_1_A = mkA "löjeväckande" ;
  loenande_av_1_1_A = mkA "lönande" ;
  loepande_av_1_1_A = mkA "löpande" ;
  loepe_nn_1_1_N = mkN "löpe" ;
  loesan_av_1_1_A = mkA "lösan" ;
  loesande_av_1_1_A = mkA "lösande" ;
  loesdriveri_nn_1_1_N = mkN "lösdriveri" ;
  loesgaaende_av_1_1_A = mkA "lösgående" ;
  macho_av_1_A = mkA "macho" ;
  magdansande_av_1_A = mkA "magdansande" ;
  magi_nn_1_N = mkN "magi" ;
  magnificus_av_1_A = mkA "magnificus" ;
  magnum_av_1_A = mkA "magnum" ;
  mahognyliknande_av_1_A = mkA "mahognyliknande" ;
  maka_av_1_A = mkA "maka" ;
  makrokosmos_nn_1_N = mkN "makrokosmos" ;
  maktfilosofi_nn_1_N = mkN "maktfilosofi" ;
  maktpaaliggande_av_1_1_A = mkA "maktpåliggande" ;
  maktunderlaege_nn_1_1_N = mkN "maktunderläge" ;
  maktutoevande_nn_1_1_N = mkN "maktutövande" ;
  malakitgroent_nn_1_1_N = mkN "malakitgrönt" ;
  malmfoerande_av_1_1_A = mkA "malmförande" ;
  management_nn_1_N = mkN "management" ;
  mandarin_nn_2_N = mkN "mandarin" ;
  maranata_nn_1_N = mkN "maranata" ;
  mardroemsliknande_av_1_1_A = mkA "mardrömsliknande" ;
  marinarkeologi_nn_1_N = mkN "marinarkeologi" ;
  marinbiologi_nn_1_N = mkN "marinbiologi" ;
  marklevande_av_1_A = mkA "marklevande" ;
  marknadsledande_av_1_A = mkA "marknadsledande" ;
  marmorliknande_av_1_A = mkA "marmorliknande" ;
  marmorskinande_av_1_A = mkA "marmorskinande" ;
  maskliknande_av_1_A = mkA "maskliknande" ;
  masspsykologi_nn_1_N = mkN "masspsykologi" ;
  mate_nn_1_N = mkN "mate" ;
  matt_av_2_A = mkA "matt" ;
  matte_nn_3_N = mkN "matte" ;
  medbestaemmande_nn_1_1_N = mkN "medbestämmande" ;
  medel_av_1_A = mkA "medel" ;
  medelklasstaenkande_nn_1_1_N = mkN "medelklasstänkande" ;
  medeltida_av_1_A = mkA "medeltida" ;
  medelaalders_av_1_1_A = mkA "medelålders" ;
  medicinhistoria_nn_1_N = mkN "medicinhistoria" ;
  medinflytande_nn_1_N = mkN "medinflytande" ;
  medkaennande_av_1_1_A = mkA "medkännande" ;
  medlidande_nn_1_N = mkN "medlidande" ;
  medryckande_av_1_A = mkA "medryckande" ;
  medverkande_av_1_A = mkA "medverkande" ;
  medvetande_nn_1_N = mkN "medvetande" ;
  medvetandegoerande_nn_1_1_N = mkN "medvetandegörande" ;
  medvetandehoejande_av_1_1_A = mkA "medvetandehöjande" ;
  megalomani_nn_1_N = mkN "megalomani" ;
  melankoli_nn_1_N = mkN "melankoli" ;
  mellankommande_av_1_A = mkA "mellankommande" ;
  mellanliggande_av_1_A = mkA "mellanliggande" ;
  menande_av_1_A = mkA "menande" ;
  mensande_nn_1_N = mkN "mensande" ;
  meritokrati_nn_1_N = mkN "meritokrati" ;
  mesoarkeikum_nn_1_N = mkN "mesoarkeikum" ;
  mesozoikum_nn_1_N = mkN "mesozoikum" ;
  metallglaensande_av_1_1_A = mkA "metallglänsande" ;
  metallografi_nn_1_N = mkN "metallografi" ;
  metallurgi_nn_1_N = mkN "metallurgi" ;
  meteorologi_nn_1_N = mkN "meteorologi" ;
  metrologi_nn_1_N = mkN "metrologi" ;
  metylenblaatt_nn_1_1_N = mkN "metylenblått" ;
  mikrobiologi_nn_1_N = mkN "mikrobiologi" ;
  mikroneurografi_nn_1_N = mkN "mikroneurografi" ;
  mikroskopi_nn_1_N = mkN "mikroskopi" ;
  militaerhistoria_nn_1_1_N = mkN "militärhistoria" ;
  miljoevurmande_av_1_1_A = mkA "miljövurmande" ;
  mineralogi_nn_1_N = mkN "mineralogi" ;
  mineralrike_nn_1_N = mkN "mineralrike" ;
  miocen_nn_1_N = mkN "miocen" ;
  misantropi_nn_1_N = mkN "misantropi" ;
  misshushaallande_nn_1_1_N = mkN "misshushållande" ;
  misskaend_av_1_1_A = mkA "misskänd" ;
  missledande_av_1_A = mkA "missledande" ;
  misstycke_nn_1_N = mkN "misstycke" ;
  missvisande_av_1_A = mkA "missvisande" ;
  mjoelkbildande_av_1_1_A = mkA "mjölkbildande" ;
  mobiltelefoni_nn_1_N = mkN "mobiltelefoni" ;
  mockaliknande_av_1_A = mkA "mockaliknande" ;
  molekylaerbiologi_nn_1_1_N = mkN "molekylärbiologi" ;
  mongoloid_av_1_A = mkA "mongoloid" ;
  monogami_nn_1_N = mkN "monogami" ;
  monomani_nn_1_N = mkN "monomani" ;
  monotoni_nn_1_N = mkN "monotoni" ;
  monstrum_nn_1_N = mkN "monstrum" ;
  moralfilosofi_nn_1_N = mkN "moralfilosofi" ;
  morbid_av_1_A = mkA "morbid" ;
  morgonkaffe_nn_1_N = mkN "morgonkaffe" ;
  motbjudande_av_1_A = mkA "motbjudande" ;
  motstridande_av_1_A = mkA "motstridande" ;
  motstaaende_av_1_1_A = mkA "motstående" ;
  motsvarande_av_1_A = mkA "motsvarande" ;
  motvalls_av_1_A = mkA "motvalls" ;
  mumsfilibaba_av_1_A = mkA "mumsfilibaba" ;
  mumsfilibabba_av_1_A = mkA "mumsfilibabba" ;
  mumsfillibaba_av_1_A = mkA "mumsfillibaba" ;
  mumsfillibabba_av_1_A = mkA "mumsfillibabba" ;
  murkelliknande_av_1_A = mkA "murkelliknande" ;
  mykologi_nn_1_N = mkN "mykologi" ;
  myopi_nn_1_N = mkN "myopi" ;
  mysko_av_1_A = mkA "mysko" ;
  mytifierande_nn_1_N = mkN "mytifierande" ;
  mytomani_nn_1_N = mkN "mytomani" ;
  maenniskointresse_nn_1_1_N = mkN "människointresse" ;
  maenniskoliknande_av_1_1_A = mkA "människoliknande" ;
  maenniskoaetande_av_1_1_A = mkA "människoätande" ;
  maessingsblaenkande_av_1_1_A = mkA "mässingsblänkande" ;
  maestrande_av_1_1_A = mkA "mästrande" ;
  maalande_av_1_1_A = mkA "målande" ;
  maalfoere_nn_1_1_N = mkN "målföre" ;
  maalgivande_av_1_1_A = mkA "målgivande" ;
  maalsoekande_av_1_1_A = mkA "målsökande" ;
  maanadsrasande_av_1_1_A = mkA "månadsrasande" ;
  maangahanda_av_1_1_A = mkA "mångahanda" ;
  maangfrestande_av_1_1_A = mkA "mångfrestande" ;
  maanggifte_nn_1_1_N = mkN "månggifte" ;
  maangskiftande_av_1_1_A = mkA "mångskiftande" ;
  maanliknande_av_1_1_A = mkA "månliknande" ;
  moederne_nn_1_1_N = mkN "möderne" ;
  moegelhindrande_av_1_1_A = mkA "mögelhindrande" ;
  moerdande_av_1_1_A = mkA "mördande" ;
  moerkblond_av_1_1_A = mkA "mörkblond" ;
  moerkerseende_nn_1_1_N = mkN "mörkerseende" ;
  moerkraedd_av_1_1_A = mkA "mörkrädd" ;
  moerksens_av_1_1_A = mkA "mörksens" ;
  namnminne_nn_1_N = mkN "namnminne" ;
  narkomani_nn_1_N = mkN "narkomani" ;
  nationalekonomi_nn_1_N = mkN "nationalekonomi" ;
  nattblind_av_1_A = mkA "nattblind" ;
  nattfraemmande_nn_1_1_N = mkN "nattfrämmande" ;
  nattyxne_nn_1_N = mkN "nattyxne" ;
  naturalhistoria_nn_1_N = mkN "naturalhistoria" ;
  naturfilosofi_nn_1_N = mkN "naturfilosofi" ;
  naturgeografi_nn_1_N = mkN "naturgeografi" ;
  naturhistoria_nn_1_N = mkN "naturhistoria" ;
  naturmagi_nn_1_N = mkN "naturmagi" ;
  naturnaera_av_1_1_A = mkA "naturnära" ;
  naturorienterande_av_1_A = mkA "naturorienterande" ;
  naturpoesi_nn_1_N = mkN "naturpoesi" ;
  navelskaadande_av_1_1_A = mkA "navelskådande" ;
  nedanstaaende_av_1_1_A = mkA "nedanstående" ;
  nedgaaende_nn_1_1_N = mkN "nedgående" ;
  nedhaengande_av_1_1_A = mkA "nedhängande" ;
  nedlaatande_av_1_1_A = mkA "nedlåtande" ;
  nedra_av_1_A = mkA "nedra" ;
  nedrans_av_1_A = mkA "nedrans" ;
  nedslaaende_av_1_1_A = mkA "nedslående" ;
  nedstaemmande_av_1_1_A = mkA "nedstämmande" ;
  nedsaettande_av_1_1_A = mkA "nedsättande" ;
  nedtystande_nn_1_N = mkN "nedtystande" ;
  nedaatgaaende_av_1_1_A = mkA "nedåtgående" ;
  nedaatgaaende_nn_1_1_N = mkN "nedåtgående" ;
  negationsmonotoni_nn_1_N = mkN "negationsmonotoni" ;
  nekrofili_nn_1_N = mkN "nekrofili" ;
  neoarkeikum_nn_1_N = mkN "neoarkeikum" ;
  neofili_nn_1_N = mkN "neofili" ;
  neogen_nn_1_N = mkN "neogen" ;
  neologi_nn_1_N = mkN "neologi" ;
  nepali_nn_1_N = mkN "nepali" ;
  nere_av_1_A = mkA "nere" ;
  nergaaende_nn_1_1_N = mkN "nergående" ;
  nerhaengande_av_1_1_A = mkA "nerhängande" ;
  nerlaatande_av_1_1_A = mkA "nerlåtande" ;
  nerslaaende_av_1_1_A = mkA "nerslående" ;
  nersaettande_av_1_1_A = mkA "nersättande" ;
  nertystande_nn_1_N = mkN "nertystande" ;
  nervkittlande_av_1_A = mkA "nervkittlande" ;
  nervpirrande_av_1_A = mkA "nervpirrande" ;
  nervpaafrestande_av_1_1_A = mkA "nervpåfrestande" ;
  nervskyddande_av_1_A = mkA "nervskyddande" ;
  neraatgaaende_av_1_1_A = mkA "neråtgående" ;
  neraatgaaende_nn_1_1_N = mkN "neråtgående" ;
  nettotonnage_nn_1_N = mkN "nettotonnage" ;
  neuralgi_nn_1_N = mkN "neuralgi" ;
  neurasteni_nn_1_N = mkN "neurasteni" ;
  neurofysiologi_nn_1_N = mkN "neurofysiologi" ;
  neurografi_nn_1_N = mkN "neurografi" ;
  neurologi_nn_1_N = mkN "neurologi" ;
  neuropati_nn_1_N = mkN "neuropati" ;
  neurotiserande_nn_1_N = mkN "neurotiserande" ;
  nigsittande_av_1_A = mkA "nigsittande" ;
  nigstaaende_av_1_1_A = mkA "nigstående" ;
  nitid_av_1_A = mkA "nitid" ;
  njutningsfilosofi_nn_1_N = mkN "njutningsfilosofi" ;
  noga_av_1_A = mkA "noga" ;
  nojande_nn_1_N = mkN "nojande" ;
  nomografi_nn_1_N = mkN "nomografi" ;
  non_iron_av_1_A = mkA "non-iron" ;
  nordvaestra_av_1_1_A = mkA "nordvästra" ;
  nordoestra_av_1_1_A = mkA "nordöstra" ;
  normerande_av_1_A = mkA "normerande" ;
  normgivande_av_1_A = mkA "normgivande" ;
  norra_av_1_A = mkA "norra" ;
  norrgaaende_av_1_1_A = mkA "norrgående" ;
  norsktalande_av_1_A = mkA "norsktalande" ;
  nulaege_nn_1_1_N = mkN "nuläge" ;
  numen_nn_1_N = mkN "numen" ;
  nuppande_nn_1_N = mkN "nuppande" ;
  nutida_av_1_A = mkA "nutida" ;
  nuvarande_av_1_A = mkA "nuvarande" ;
  nyanlaend_av_1_1_A = mkA "nyanländ" ;
  nyhetsvaerde_nn_1_1_N = mkN "nyhetsvärde" ;
  nyktofobi_nn_1_N = mkN "nyktofobi" ;
  nymfomani_nn_1_N = mkN "nymfomani" ;
  nyponte_nn_1_N = mkN "nyponte" ;
  nysande_nn_1_N = mkN "nysande" ;
  nyskapande_nn_1_N = mkN "nyskapande" ;
  nytaend_av_1_1_A = mkA "nytänd" ;
  nytaenkande_nn_1_1_N = mkN "nytänkande" ;
  nyvaelle_nn_1_1_N = mkN "nyvälle" ;
  naeck_av_1_1_A = mkA "näck" ;
  naeckande_nn_1_1_N = mkN "näckande" ;
  naeraliggande_av_1_1_A = mkA "näraliggande" ;
  naerande_av_1_1_A = mkA "närande" ;
  naerboende_av_1_1_A = mkA "närboende" ;
  naerdemokrati_nn_1_1_N = mkN "närdemokrati" ;
  naeringsfysiologi_nn_1_1_N = mkN "näringsfysiologi" ;
  naeringsgeografi_nn_1_1_N = mkN "näringsgeografi" ;
  naeringslivsfraemjande_av_1_1_A = mkA "näringslivsfrämjande" ;
  naerliggande_av_1_1_A = mkA "närliggande" ;
  naerminne_nn_1_1_N = mkN "närminne" ;
  naerstuderande_nn_1_1_N = mkN "närstuderande" ;
  naerstaaende_av_1_1_A = mkA "närstående" ;
  naervarande_av_1_1_A = mkA "närvarande" ;
  naestfoeljande_av_1_1_A = mkA "nästföljande" ;
  naestkommande_av_1_1_A = mkA "nästkommande" ;
  naetanvaendande_nn_1_1_N = mkN "nätanvändande" ;
  naetfiske_nn_1_1_N = mkN "nätfiske" ;
  naetkommunicerande_nn_1_1_N = mkN "nätkommunicerande" ;
  noedlidande_av_1_1_A = mkA "nödlidande" ;
  noejesfiske_nn_1_1_N = mkN "nöjesfiske" ;
  noetliknande_av_1_1_A = mkA "nötliknande" ;
  oanlaend_av_1_1_A = mkA "oanländ" ;
  oantaend_av_1_1_A = mkA "oantänd" ;
  oanvaend_av_1_1_A = mkA "oanvänd" ;
  oavkaend_av_1_1_A = mkA "oavkänd" ;
  oavsaend_av_1_1_A = mkA "oavsänd" ;
  oavvaend_av_1_1_A = mkA "oavvänd" ;
  obekaend_av_1_1_A = mkA "obekänd" ;
  obenaemnd_av_1_1_A = mkA "obenämnd" ;
  oberoende_av_1_A = mkA "oberoende" ;
  oberoende_nn_1_N = mkN "oberoende" ;
  obraend_av_1_1_A = mkA "obränd" ;
  oceangaaende_av_1_1_A = mkA "oceangående" ;
  oceanografi_nn_1_N = mkN "oceanografi" ;
  odlingsvaerde_nn_1_1_N = mkN "odlingsvärde" ;
  odontologi_nn_1_N = mkN "odontologi" ;
  odontologie_av_1_A = mkA "odontologie" ;
  oeftersaend_av_1_1_A = mkA "oeftersänd" ;
  oense_av_1_A = mkA "oense" ;
  oerkaend_av_1_1_A = mkA "oerkänd" ;
  off_white_av_1_A = mkA "off-white" ;
  offshore_av_1_A = mkA "offshore" ;
  ofraelse_av_1_1_A = mkA "ofrälse" ;
  oftalmologi_nn_1_N = mkN "oftalmologi" ;
  oftalmoskopi_nn_1_N = mkN "oftalmoskopi" ;
  ofoerbraend_av_1_1_A = mkA "oförbränd" ;
  ofoere_nn_1_1_N = mkN "oföre" ;
  ofoerstaaende_av_1_1_A = mkA "oförstående" ;
  ofoersaend_av_1_1_A = mkA "oförsänd" ;
  ofoervaend_av_1_1_A = mkA "oförvänd" ;
  ogodkaend_av_1_1_A = mkA "ogodkänd" ;
  oherrans_av_1_A = mkA "oherrans" ;
  oinsaend_av_1_1_A = mkA "oinsänd" ;
  ointresse_nn_1_N = mkN "ointresse" ;
  ojuste_av_1_A = mkA "ojuste" ;
  ok_av_1_A = mkA "ok" ;
  okay_av_1_A = mkA "okay" ;
  okej_av_1_A = mkA "okej" ;
  okey_av_1_A = mkA "okey" ;
  okringraend_av_1_1_A = mkA "okringränd" ;
  okynne_nn_1_N = mkN "okynne" ;
  okynnesstrejkande_nn_1_N = mkN "okynnesstrejkande" ;
  okaend_av_1_1_A = mkA "okänd" ;
  olaga_av_1_A = mkA "olaga" ;
  oligocen_nn_1_N = mkN "oligocen" ;
  oligofreni_nn_1_N = mkN "oligofreni" ;
  oliktaenkande_av_1_1_A = mkA "oliktänkande" ;
  oljeberoende_nn_1_N = mkN "oljeberoende" ;
  oljeaekta_av_1_1_A = mkA "oljeäkta" ;
  olycksbringande_av_1_A = mkA "olycksbringande" ;
  olycksbaadande_av_1_1_A = mkA "olycksbådande" ;
  omaka_av_1_A = mkA "omaka" ;
  omfattande_av_1_A = mkA "omfattande" ;
  omkostymerande_nn_1_N = mkN "omkostymerande" ;
  omkringliggande_av_1_A = mkA "omkringliggande" ;
  omsams_av_1_A = mkA "omsams" ;
  omskakande_av_1_A = mkA "omskakande" ;
  omstaaende_av_1_1_A = mkA "omstående" ;
  omstoertande_av_1_1_A = mkA "omstörtande" ;
  omtumlande_av_1_A = mkA "omtumlande" ;
  omvaend_av_1_1_A = mkA "omvänd" ;
  omvaexlande_av_1_1_A = mkA "omväxlande" ;
  onani_nn_1_N = mkN "onani" ;
  ond_av_1_A = mkA "ond" ;
  oneiromanti_nn_1_N = mkN "oneiromanti" ;
  onkologi_nn_1_N = mkN "onkologi" ;
  onomatologi_nn_1_N = mkN "onomatologi" ;
  onomatopoesi_nn_1_N = mkN "onomatopoesi" ;
  ont_av_1_A = mkA "ont" ;
  ontogeni_nn_1_N = mkN "ontogeni" ;
  onaemnd_av_1_1_A = mkA "onämnd" ;
  oogami_nn_1_N = mkN "oogami" ;
  oomnaemnd_av_1_1_A = mkA "oomnämnd" ;
  oomspaend_av_1_1_A = mkA "oomspänd" ;
  oomvaend_av_1_1_A = mkA "oomvänd" ;
  opaliserande_av_1_A = mkA "opaliserande" ;
  opalskimrande_av_1_A = mkA "opalskimrande" ;
  opassande_av_1_A = mkA "opassande" ;
  open_av_1_A = mkA "open" ;
  opiumliknande_av_1_A = mkA "opiumliknande" ;
  oppbaerande_nn_1_1_N = mkN "oppbärande" ;
  oppflammande_av_1_A = mkA "oppflammande" ;
  oppfriskande_av_1_A = mkA "oppfriskande" ;
  oppiggande_av_1_A = mkA "oppiggande" ;
  oppochnedvaend_av_1_1_A = mkA "oppochnedvänd" ;
  oppochnervaend_av_1_1_A = mkA "oppochnervänd" ;
  oppvaknande_nn_1_N = mkN "oppvaknande" ;
  oppaanedvaend_av_1_1_A = mkA "oppånedvänd" ;
  oppaanervaend_av_1_1_A = mkA "oppånervänd" ;
  oppaat_av_1_1_A = mkA "oppåt" ;
  oppaatgaaende_av_1_1_A = mkA "oppåtgående" ;
  oppaatgaaende_nn_1_1_N = mkN "oppåtgående" ;
  oppaatstigande_av_1_1_A = mkA "oppåtstigande" ;
  oppaatstraevande_av_1_1_A = mkA "oppåtsträvande" ;
  opaamind_av_1_1_A = mkA "opåmind" ;
  ordblind_av_1_A = mkA "ordblind" ;
  ordgeografi_nn_1_N = mkN "ordgeografi" ;
  ordinarie_av_1_A = mkA "ordinarie" ;
  ordovicium_nn_1_N = mkN "ordovicium" ;
  organdi_nn_1_N = mkN "organdi" ;
  orgelliknande_av_1_A = mkA "orgelliknande" ;
  ormliknande_av_1_A = mkA "ormliknande" ;
  ornitologi_nn_1_N = mkN "ornitologi" ;
  oroande_av_1_A = mkA "oroande" ;
  orografi_nn_1_N = mkN "orografi" ;
  orovaeckande_av_1_1_A = mkA "oroväckande" ;
  ortodonti_nn_1_N = mkN "ortodonti" ;
  ortopedi_nn_1_N = mkN "ortopedi" ;
  orund_av_1_A = mkA "orund" ;
  oraedd_av_1_1_A = mkA "orädd" ;
  osammanhaengande_av_1_1_A = mkA "osammanhängande" ;
  osams_av_1_A = mkA "osams" ;
  oseende_av_1_A = mkA "oseende" ;
  osteologi_nn_1_N = mkN "osteologi" ;
  ostliknande_av_1_A = mkA "ostliknande" ;
  ostloepe_nn_1_1_N = mkN "ostlöpe" ;
  ostaemne_nn_1_1_N = mkN "ostämne" ;
  osund_av_1_A = mkA "osund" ;
  otalt_av_1_A = mkA "otalt" ;
  otillfreds_av_1_A = mkA "otillfreds" ;
  otillfredsstaellande_av_1_1_A = mkA "otillfredsställande" ;
  otologi_nn_1_N = mkN "otologi" ;
  otaend_av_1_1_A = mkA "otänd" ;
  outstanding_av_1_A = mkA "outstanding" ;
  ovannaemnd_av_1_1_A = mkA "ovannämnd" ;
  ovanstaaende_av_1_1_A = mkA "ovanstående" ;
  ovetande_av_1_A = mkA "ovetande" ;
  ovetandes_av_1_A = mkA "ovetandes" ;
  ovidkommande_av_1_A = mkA "ovidkommande" ;
  oaekta_av_1_1_A = mkA "oäkta" ;
  paddelliknande_av_1_A = mkA "paddelliknande" ;
  paddlande_nn_1_N = mkN "paddlande" ;
  paj_av_1_A = mkA "paj" ;
  paleoarkeikum_nn_1_N = mkN "paleoarkeikum" ;
  paleocen_nn_1_N = mkN "paleocen" ;
  paleogen_nn_1_N = mkN "paleogen" ;
  paleografi_nn_1_N = mkN "paleografi" ;
  paleontologi_nn_1_N = mkN "paleontologi" ;
  paleozoikum_nn_1_N = mkN "paleozoikum" ;
  pansarbrytande_av_1_A = mkA "pansarbrytande" ;
  papegojliknande_av_1_A = mkA "papegojliknande" ;
  papyrologi_nn_1_N = mkN "papyrologi" ;
  paraguayte_nn_1_N = mkN "paraguayte" ;
  paranoid_av_1_A = mkA "paranoid" ;
  paraplyliknande_av_1_A = mkA "paraplyliknande" ;
  parapsykologi_nn_1_N = mkN "parapsykologi" ;
  passande_av_1_A = mkA "passande" ;
  pass_e_av_1_1_A = mkA "passé" ;
  patientbemoetande_nn_1_1_N = mkN "patientbemötande" ;
  patofysiologi_nn_1_N = mkN "patofysiologi" ;
  peakande_nn_1_N = mkN "peakande" ;
  pechblaende_nn_1_1_N = mkN "pechblände" ;
  pederasti_nn_1_N = mkN "pederasti" ;
  pedofili_nn_1_N = mkN "pedofili" ;
  pedologi_nn_1_N = mkN "pedologi" ;
  pengaslukande_av_1_A = mkA "pengaslukande" ;
  penningvaerde_nn_1_1_N = mkN "penningvärde" ;
  pennliknande_av_1_A = mkA "pennliknande" ;
  pennsylvan_nn_1_N = mkN "pennsylvan" ;
  pensionsgrundande_av_1_A = mkA "pensionsgrundande" ;
  perfid_av_1_A = mkA "perfid" ;
  perm_nn_1_N = mkN "perm" ;
  persiflage_nn_1_N = mkN "persiflage" ;
  personhistoria_nn_1_N = mkN "personhistoria" ;
  personkemi_nn_1_N = mkN "personkemi" ;
  perspektivskapande_av_1_A = mkA "perspektivskapande" ;
  petnoga_av_1_A = mkA "petnoga" ;
  petrografi_nn_1_N = mkN "petrografi" ;
  piercande_nn_1_N = mkN "piercande" ;
  piggelin_av_1_A = mkA "piggelin" ;
  pimpelfiske_nn_1_N = mkN "pimpelfiske" ;
  pinande_av_1_A = mkA "pinande" ;
  piproekande_av_1_1_A = mkA "piprökande" ;
  piproekande_nn_1_1_N = mkN "piprökande" ;
  pirum_av_1_A = mkA "pirum" ;
  pistolliknande_av_1_A = mkA "pistolliknande" ;
  pistolskytte_nn_1_N = mkN "pistolskytte" ;
  plakat_av_1_A = mkA "plakat" ;
  plangeometri_nn_1_N = mkN "plangeometri" ;
  planimetri_nn_1_N = mkN "planimetri" ;
  plastikkirurgi_nn_1_N = mkN "plastikkirurgi" ;
  plastliknande_av_1_A = mkA "plastliknande" ;
  platinablond_av_1_A = mkA "platinablond" ;
  platssoekande_av_1_1_A = mkA "platssökande" ;
  pleistocen_nn_1_N = mkN "pleistocen" ;
  pliocen_nn_1_N = mkN "pliocen" ;
  pojktycke_nn_1_N = mkN "pojktycke" ;
  pokerface_nn_1_N = mkN "pokerface" ;
  polyandri_nn_1_N = mkN "polyandri" ;
  polygami_nn_1_N = mkN "polygami" ;
  pomologi_nn_1_N = mkN "pomologi" ;
  poppis_av_1_A = mkA "poppis" ;
  pornografi_nn_1_N = mkN "pornografi" ;
  portfoere_nn_1_1_N = mkN "portföre" ;
  potatisliknande_av_1_A = mkA "potatisliknande" ;
  poaengvaerde_nn_1_1_N = mkN "poängvärde" ;
  precisionsskytte_nn_1_N = mkN "precisionsskytte" ;
  prejudicerande_av_1_A = mkA "prejudicerande" ;
  pressande_av_1_A = mkA "pressande" ;
  pretto_av_1_A = mkA "pretto" ;
  prickskytte_nn_1_N = mkN "prickskytte" ;
  prima_av_1_A = mkA "prima" ;
  primalterapi_nn_1_N = mkN "primalterapi" ;
  privatpraktiserande_av_1_A = mkA "privatpraktiserande" ;
  privilegieutjaemnande_av_1_1_A = mkA "privilegieutjämnande" ;
  prostatahypertrofi_nn_1_N = mkN "prostatahypertrofi" ;
  proteinnerbrytande_av_1_A = mkA "proteinnerbrytande" ;
  protonterapi_nn_1_N = mkN "protonterapi" ;
  provroersbefruktande_nn_1_1_N = mkN "provrörsbefruktande" ;
  proevande_av_1_1_A = mkA "prövande" ;
  psykiatri_nn_1_N = mkN "psykiatri" ;
  psykokirurgi_nn_1_N = mkN "psykokirurgi" ;
  psykologi_nn_1_N = mkN "psykologi" ;
  psykometri_nn_1_N = mkN "psykometri" ;
  psykopatologi_nn_1_N = mkN "psykopatologi" ;
  publikdragande_av_1_A = mkA "publikdragande" ;
  publikfriande_av_1_A = mkA "publikfriande" ;
  publikum_nn_1_N = mkN "publikum" ;
  pulverkaffe_nn_1_N = mkN "pulverkaffe" ;
  pulvermetallurgi_nn_1_N = mkN "pulvermetallurgi" ;
  punghaallande_nn_1_1_N = mkN "punghållande" ;
  punktbevakande_nn_1_N = mkN "punktbevakande" ;
  pupillfoerstorande_av_1_1_A = mkA "pupillförstorande" ;
  putrid_av_1_A = mkA "putrid" ;
  pyromani_nn_1_N = mkN "pyromani" ;
  pyton_av_1_A = mkA "pyton" ;
  pytte_av_1_A = mkA "pytte" ;
  paerlemorskimrande_av_1_1_A = mkA "pärlemorskimrande" ;
  paa_av_1_1_A = mkA "på" ;
  paadrivande_av_1_1_A = mkA "pådrivande" ;
  paafallande_av_1_1_A = mkA "påfallande" ;
  paafrestande_av_1_1_A = mkA "påfrestande" ;
  paafoeljande_av_1_1_A = mkA "påföljande" ;
  paagaaende_av_1_1_A = mkA "pågående" ;
  paakostande_av_1_1_A = mkA "påkostande" ;
  paaseende_nn_1_1_N = mkN "påseende" ;
  paaskfirande_av_1_1_A = mkA "påskfirande" ;
  paaskfirande_nn_1_1_N = mkN "påskfirande" ;
  paatraengande_av_1_1_A = mkA "påträngande" ;
  paataend_av_1_1_A = mkA "påtänd" ;
  rabblande_nn_1_N = mkN "rabblande" ;
  rackarns_av_1_A = mkA "rackarns" ;
  radioastronomi_nn_1_N = mkN "radioastronomi" ;
  radiobiologi_nn_1_N = mkN "radiobiologi" ;
  radiologi_nn_1_N = mkN "radiologi" ;
  radiotelegrafi_nn_1_N = mkN "radiotelegrafi" ;
  radioterapi_nn_1_N = mkN "radioterapi" ;
  rafflande_av_1_A = mkA "rafflande" ;
  rapid_av_1_A = mkA "rapid" ;
  rasande_av_1_A = mkA "rasande" ;
  rasbiologi_nn_1_N = mkN "rasbiologi" ;
  raspande_av_1_A = mkA "raspande" ;
  redo_av_1_A = mkA "redo" ;
  regi_nn_1_N = mkN "regi" ;
  reglande_nn_1_N = mkN "reglande" ;
  reguladetri_nn_1_N = mkN "reguladetri" ;
  reko_av_1_A = mkA "reko" ;
  relativitetsteori_nn_1_N = mkN "relativitetsteori" ;
  remissbehandlande_nn_1_N = mkN "remissbehandlande" ;
  renons_av_1_A = mkA "renons" ;
  reologi_nn_1_N = mkN "reologi" ;
  repe_nn_1_N = mkN "repe" ;
  reprografi_nn_1_N = mkN "reprografi" ;
  reptilliknande_av_1_A = mkA "reptilliknande" ;
  resande_nn_2_N = mkN "resande" ;
  respektingivande_av_1_A = mkA "respektingivande" ;
  respektive_av_1_A = mkA "respektive" ;
  resurskraevande_av_1_1_A = mkA "resurskrävande" ;
  retro_av_1_A = mkA "retro" ;
  retrograd_av_1_A = mkA "retrograd" ;
  reumatologi_nn_1_N = mkN "reumatologi" ;
  revolutionerande_av_1_A = mkA "revolutionerande" ;
  rhinologi_nn_1_N = mkN "rhinologi" ;
  rigid_av_1_A = mkA "rigid" ;
  riglande_nn_1_N = mkN "riglande" ;
  riksomfattande_av_1_A = mkA "riksomfattande" ;
  rikstaeckande_av_1_1_A = mkA "rikstäckande" ;
  riksaepple_nn_1_1_N = mkN "riksäpple" ;
  ringa_av_1_A = mkA "ringa" ;
  rogivande_av_1_A = mkA "rogivande" ;
  rollbesaettande_nn_1_1_N = mkN "rollbesättande" ;
  romarrike_nn_1_N = mkN "romarrike" ;
  rosa_av_1_A = mkA "rosa" ;
  rosende_av_1_A = mkA "rosende" ;
  rosenrasande_av_1_A = mkA "rosenrasande" ;
  rotationsenergi_nn_1_N = mkN "rotationsenergi" ;
  rouge_nn_1_N = mkN "rouge" ;
  rovfiske_nn_1_N = mkN "rovfiske" ;
  rudis_av_1_A = mkA "rudis" ;
  rund_av_1_A = mkA "rund" ;
  rundvirke_nn_1_N = mkN "rundvirke" ;
  runologi_nn_1_N = mkN "runologi" ;
  rymdbiologi_nn_1_N = mkN "rymdbiologi" ;
  rymdgeometri_nn_1_N = mkN "rymdgeometri" ;
  rysktalande_av_1_A = mkA "rysktalande" ;
  raedd_av_1_1_A = mkA "rädd" ;
  raekfiske_nn_1_1_N = mkN "räkfiske" ;
  raentebaerande_av_1_1_A = mkA "räntebärande" ;
  raet_av_1_1_A = mkA "rät" ;
  raettroende_av_1_1_A = mkA "rättroende" ;
  raettsfilosofi_nn_1_1_N = mkN "rättsfilosofi" ;
  raettskaffens_av_1_1_A = mkA "rättskaffens" ;
  raettskemi_nn_1_1_N = mkN "rättskemi" ;
  raettspsykiatri_nn_1_1_N = mkN "rättspsykiatri" ;
  raettvisande_av_1_1_A = mkA "rättvisande" ;
  raettvisekraevande_av_1_1_A = mkA "rättvisekrävande" ;
  raettaenkande_av_1_1_A = mkA "rättänkande" ;
  raadande_av_1_1_A = mkA "rådande" ;
  raadgivande_av_1_1_A = mkA "rådgivande" ;
  raagblond_av_1_1_A = mkA "rågblond" ;
  roedblind_av_1_1_A = mkA "rödblind" ;
  roedblond_av_1_1_A = mkA "rödblond" ;
  roedbraend_av_1_1_A = mkA "rödbränd" ;
  roedgroenblind_av_1_1_A = mkA "rödgrönblind" ;
  roedlila_av_1_1_A = mkA "rödlila" ;
  roedskimrande_av_1_1_A = mkA "rödskimrande" ;
  roennbaersfilosofi_nn_1_1_N = mkN "rönnbärsfilosofi" ;
  roentgenstraalande_av_1_1_A = mkA "röntgenstrålande" ;
  roerande_av_1_1_A = mkA "rörande" ;
  roerelseenergi_nn_1_1_N = mkN "rörelseenergi" ;
  roestfiske_nn_1_1_N = mkN "röstfiske" ;
  roestskolkande_nn_1_1_N = mkN "röstskolkande" ;
  sabla_av_1_A = mkA "sabla" ;
  sagoskimrande_av_1_A = mkA "sagoskimrande" ;
  saker_av_1_A = mkA "saker" ;
  saklaege_nn_1_1_N = mkN "sakläge" ;
  saksoekande_av_1_1_A = mkA "saksökande" ;
  saksoekande_nn_1_1_N = mkN "saksökande" ;
  sakta_av_1_A = mkA "sakta" ;
  saltaelskande_av_1_1_A = mkA "saltälskande" ;
  samarva_av_1_A = mkA "samarva" ;
  samboende_av_1_A = mkA "samboende" ;
  samboende_nn_1_N = mkN "samboende" ;
  samgaaende_nn_1_1_N = mkN "samgående" ;
  samhaellsbevarande_av_1_1_A = mkA "samhällsbevarande" ;
  samhaellsbildande_av_1_1_A = mkA "samhällsbildande" ;
  samhaellsbaerande_av_1_1_A = mkA "samhällsbärande" ;
  samhaellsekonomi_nn_1_1_N = mkN "samhällsekonomi" ;
  samhaellsfraanvaend_av_1_1_A = mkA "samhällsfrånvänd" ;
  samhaellsinflytande_nn_1_1_N = mkN "samhällsinflytande" ;
  samhaellsomstoertande_av_1_1_A = mkA "samhällsomstörtande" ;
  samhaellsorienterande_av_1_1_A = mkA "samhällsorienterande" ;
  samhaellstillvaend_av_1_1_A = mkA "samhällstillvänd" ;
  samhoerande_av_1_1_A = mkA "samhörande" ;
  samlarvaerde_nn_1_1_N = mkN "samlarvärde" ;
  sammanboende_av_1_A = mkA "sammanboende" ;
  sammankallande_av_1_A = mkA "sammankallande" ;
  sammanstoertande_nn_1_1_N = mkN "sammanstörtande" ;
  samroere_nn_1_1_N = mkN "samröre" ;
  sams_av_1_A = mkA "sams" ;
  samtalsterapi_nn_1_N = mkN "samtalsterapi" ;
  samtida_av_1_A = mkA "samtida" ;
  samtidsarkeologi_nn_1_N = mkN "samtidsarkeologi" ;
  samtidshistoria_nn_1_N = mkN "samtidshistoria" ;
  samaegande_nn_1_1_N = mkN "samägande" ;
  sandbindande_av_1_A = mkA "sandbindande" ;
  sanningsvaerde_nn_1_1_N = mkN "sanningsvärde" ;
  sannolikhetsberaeknande_nn_1_1_N = mkN "sannolikhetsberäknande" ;
  satans_av_1_A = mkA "satans" ;
  savoir_vivre_nn_1_N = mkN "savoir-vivre" ;
  saxliknande_av_1_A = mkA "saxliknande" ;
  scenografi_nn_1_N = mkN "scenografi" ;
  schack_av_1_A = mkA "schack" ;
  schackmatt_av_1_A = mkA "schackmatt" ;
  scharlakansroett_nn_1_1_N = mkN "scharlakansrött" ;
  schizoid_av_1_A = mkA "schizoid" ;
  schizotymi_nn_1_N = mkN "schizotymi" ;
  schlaraffenland_nn_1_N = mkN "schlaraffenland" ;
  schwyzerdutsch_nn_1_1_N = mkN "schwyzerdütsch" ;
  schwyzertutsch_nn_1_1_N = mkN "schwyzertütsch" ;
  scientologi_nn_1_N = mkN "scientologi" ;
  scintigrafi_nn_1_N = mkN "scintigrafi" ;
  sedelaerande_av_1_1_A = mkA "sedelärande" ;
  sedimentfoerande_av_1_1_A = mkA "sedimentförande" ;
  sedlighetssaarande_av_1_1_A = mkA "sedlighetssårande" ;
  seende_av_1_A = mkA "seende" ;
  seismologi_nn_1_N = mkN "seismologi" ;
  sekunda_av_1_A = mkA "sekunda" ;
  selfmade_av_1_A = mkA "selfmade" ;
  semasiologi_nn_1_N = mkN "semasiologi" ;
  semesterfirande_av_1_A = mkA "semesterfirande" ;
  semesterfirande_nn_1_N = mkN "semesterfirande" ;
  semiologi_nn_1_N = mkN "semiologi" ;
  semologi_nn_1_N = mkN "semologi" ;
  senare_av_1_A = mkA "senare" ;
  senmedeltida_av_1_A = mkA "senmedeltida" ;
  sentida_av_1_A = mkA "sentida" ;
  sentima_av_1_A = mkA "sentima" ;
  serieledande_av_1_A = mkA "serieledande" ;
  serologi_nn_1_N = mkN "serologi" ;
  serotoninhoejande_av_1_1_A = mkA "serotoninhöjande" ;
  serumterapi_nn_1_N = mkN "serumterapi" ;
  sesam_nn_2_N = mkN "sesam" ;
  sexdubblande_nn_1_N = mkN "sexdubblande" ;
  sexfaldigande_nn_1_N = mkN "sexfaldigande" ;
  sexologi_nn_1_N = mkN "sexologi" ;
  sexuologi_nn_1_N = mkN "sexuologi" ;
  sexvaegrande_nn_1_1_N = mkN "sexvägrande" ;
  sfumato_nn_1_N = mkN "sfumato" ;
  sgraffito_nn_1_N = mkN "sgraffito" ;
  sicklecellsanemi_nn_1_N = mkN "sicklecellsanemi" ;
  sidenliknande_av_1_A = mkA "sidenliknande" ;
  siderurgi_nn_1_N = mkN "siderurgi" ;
  sidlaend_av_1_1_A = mkA "sidländ" ;
  sidoinflytande_nn_1_N = mkN "sidoinflytande" ;
  sifferblind_av_1_A = mkA "sifferblind" ;
  sifferminne_nn_1_N = mkN "sifferminne" ;
  sigillografi_nn_1_N = mkN "sigillografi" ;
  signalroett_nn_1_1_N = mkN "signalrött" ;
  silur_nn_1_N = mkN "silur" ;
  silverblond_av_1_A = mkA "silverblond" ;
  silverblaenkande_av_1_1_A = mkA "silverblänkande" ;
  silverglaensande_av_1_1_A = mkA "silverglänsande" ;
  silverliknande_av_1_A = mkA "silverliknande" ;
  silverne_av_1_A = mkA "silverne" ;
  silverskimrande_av_1_A = mkA "silverskimrande" ;
  silverte_nn_1_N = mkN "silverte" ;
  silvervitt_nn_1_N = mkN "silvervitt" ;
  simoni_nn_1_N = mkN "simoni" ;
  simplextelegrafi_nn_1_N = mkN "simplextelegrafi" ;
  sinkabirum_nn_1_N = mkN "sinkabirum" ;
  sinologi_nn_1_N = mkN "sinologi" ;
  sirapsliknande_av_1_A = mkA "sirapsliknande" ;
  sjudundrande_av_1_A = mkA "sjudundrande" ;
  sjufaldigande_nn_1_N = mkN "sjufaldigande" ;
  sjuhelvetes_av_1_A = mkA "sjuhelvetes" ;
  sjukdomsalstrande_av_1_A = mkA "sjukdomsalstrande" ;
  sjukpenninggrundande_av_1_A = mkA "sjukpenninggrundande" ;
  sjungande_nn_1_N = mkN "sjungande" ;
  sjaelsdoedande_av_1_1_A = mkA "själsdödande" ;
  sjaelsfraanvarande_av_1_1_A = mkA "själsfrånvarande" ;
  sjaelvbespeglande_av_1_1_A = mkA "självbespeglande" ;
  sjaelvbestaemmande_nn_1_1_N = mkN "självbestämmande" ;
  sjaelvbevarande_av_1_1_A = mkA "självbevarande" ;
  sjaelvbaerande_av_1_1_A = mkA "självbärande" ;
  sjaelvfoergloemmande_av_1_1_A = mkA "självförglömmande" ;
  sjaelvfoerhaerligande_av_1_1_A = mkA "självförhärligande" ;
  sjaelvfoersoerjande_av_1_1_A = mkA "självförsörjande" ;
  sjaelvfoertroende_nn_1_1_N = mkN "självförtroende" ;
  sjaelvfoerverkligande_nn_1_1_N = mkN "självförverkligande" ;
  sjaelvhushaallande_nn_1_1_N = mkN "självhushållande" ;
  sjaelvhaeftande_av_1_1_A = mkA "självhäftande" ;
  sjaelvinstruerande_av_1_1_A = mkA "självinstruerande" ;
  sjaelvironi_nn_1_1_N = mkN "självironi" ;
  sjaelvklistrande_av_1_1_A = mkA "självklistrande" ;
  sjaelvlysande_av_1_1_A = mkA "självlysande" ;
  sjaelvreglerande_av_1_1_A = mkA "självreglerande" ;
  sjaelvrepellerande_av_1_1_A = mkA "självrepellerande" ;
  sjaelvspelande_av_1_1_A = mkA "självspelande" ;
  sjaelvstyrande_av_1_1_A = mkA "självstyrande" ;
  sjaelvstaengande_av_1_1_A = mkA "självstängande" ;
  sjaelvtvivlande_av_1_1_A = mkA "självtvivlande" ;
  sjaelvuppfyllande_av_1_1_A = mkA "självuppfyllande" ;
  sjaelvuppoffrande_av_1_1_A = mkA "självuppoffrande" ;
  sjaelvutnaemnd_av_1_1_A = mkA "självutnämnd" ;
  sjaelvutplaanande_av_1_1_A = mkA "självutplånande" ;
  sjaelvaegande_av_1_1_A = mkA "självägande" ;
  sjoefarande_av_1_1_A = mkA "sjöfarande" ;
  skada_av_1_A = mkA "skada" ;
  skakande_av_1_A = mkA "skakande" ;
  skakis_av_1_A = mkA "skakis" ;
  skamflat_av_1_A = mkA "skamflat" ;
  skapande_av_1_A = mkA "skapande" ;
  skenplockande_nn_1_N = mkN "skenplockande" ;
  skidskytte_nn_1_N = mkN "skidskytte" ;
  skinkbluffande_av_1_A = mkA "skinkbluffande" ;
  skitbra_av_1_A = mkA "skitbra" ;
  skitkul_av_1_A = mkA "skitkul" ;
  skitond_av_1_A = mkA "skitond" ;
  skitraedd_av_1_1_A = mkA "skiträdd" ;
  skitsamma_av_1_A = mkA "skitsamma" ;
  skoj_av_1_A = mkA "skoj" ;
  skolgaardsminne_nn_1_1_N = mkN "skolgårdsminne" ;
  skopofili_nn_1_N = mkN "skopofili" ;
  skoptofili_nn_1_N = mkN "skoptofili" ;
  skottraedd_av_1_1_A = mkA "skotträdd" ;
  skrattretande_av_1_A = mkA "skrattretande" ;
  skriande_av_1_A = mkA "skriande" ;
  skrotvaerde_nn_1_1_N = mkN "skrotvärde" ;
  skrubbliknande_av_1_A = mkA "skrubbliknande" ;
  skrymmande_av_1_A = mkA "skrymmande" ;
  skraeckinjagande_av_1_1_A = mkA "skräckinjagande" ;
  skraeckregemente_nn_1_1_N = mkN "skräckregemente" ;
  skraemmande_av_1_1_A = mkA "skrämmande" ;
  skuldsaettande_nn_1_1_N = mkN "skuldsättande" ;
  skumliknande_av_1_A = mkA "skumliknande" ;
  skaemtlynne_nn_1_1_N = mkN "skämtlynne" ;
  skaerande_av_1_1_A = mkA "skärande" ;
  skaalvirke_nn_1_1_N = mkN "skålvirke" ;
  skaapliknande_av_1_1_A = mkA "skåpliknande" ;
  skoen_nn_1_1_N = mkN "skön" ;
  skoensjungande_av_1_1_A = mkA "skönsjungande" ;
  skoere_nn_1_1_N = mkN "sköre" ;
  slags_av_1_A = mkA "slags" ;
  slangande_nn_1_N = mkN "slangande" ;
  slappzappande_nn_1_N = mkN "slappzappande" ;
  slavliknande_av_1_A = mkA "slavliknande" ;
  slemloesande_av_1_1_A = mkA "slemlösande" ;
  slitage_nn_1_N = mkN "slitage" ;
  slumrande_av_1_A = mkA "slumrande" ;
  slurpande_nn_1_N = mkN "slurpande" ;
  slut_av_1_A = mkA "slut" ;
  slutfoervarande_nn_1_1_N = mkN "slutförvarande" ;
  slaedfoere_nn_1_1_N = mkN "slädföre" ;
  slaekt_av_1_1_A = mkA "släkt" ;
  slaekttycke_nn_1_1_N = mkN "släkttycke" ;
  slaaende_av_1_1_A = mkA "slående" ;
  sloejliknande_av_1_1_A = mkA "slöjliknande" ;
  sloesande_av_1_1_A = mkA "slösande" ;
  smaskens_av_1_A = mkA "smaskens" ;
  smickrande_av_1_A = mkA "smickrande" ;
  smittbaerande_av_1_1_A = mkA "smittbärande" ;
  smittspaarande_nn_1_1_N = mkN "smittspårande" ;
  smutsavvisande_av_1_A = mkA "smutsavvisande" ;
  smygislamiserande_nn_1_N = mkN "smygislamiserande" ;
  smygroekande_nn_1_1_N = mkN "smygrökande" ;
  smaektande_av_1_1_A = mkA "smäktande" ;
  smaertstillande_av_1_1_A = mkA "smärtstillande" ;
  smaakaat_av_1_1_A = mkA "småkåt" ;
  smaaleende_av_1_1_A = mkA "småleende" ;
  smaatt_av_1_1_A = mkA "smått" ;
  snabbgaaende_av_1_1_A = mkA "snabbgående" ;
  snabbkaffe_nn_1_N = mkN "snabbkaffe" ;
  snabbseparerande_av_1_A = mkA "snabbseparerande" ;
  snabbtorkande_av_1_A = mkA "snabbtorkande" ;
  snabbtoerstande_nn_1_1_N = mkN "snabbtörstande" ;
  snabbvaexande_av_1_1_A = mkA "snabbväxande" ;
  snabelliknande_av_1_A = mkA "snabelliknande" ;
  snurrefiske_nn_1_N = mkN "snurrefiske" ;
  snyftande_av_1_A = mkA "snyftande" ;
  snaellgaaende_av_1_1_A = mkA "snällgående" ;
  snoeblind_av_1_1_A = mkA "snöblind" ;
  snoed_av_1_1_A = mkA "snöd" ;
  snoeskytte_nn_1_1_N = mkN "snöskytte" ;
  socialantropologi_nn_1_N = mkN "socialantropologi" ;
  socialdemokrati_nn_1_N = mkN "socialdemokrati" ;
  socialpornografi_nn_1_N = mkN "socialpornografi" ;
  socialpsykologi_nn_1_N = mkN "socialpsykologi" ;
  sociologi_nn_1_N = mkN "sociologi" ;
  socioterapi_nn_1_N = mkN "socioterapi" ;
  sodomi_nn_1_N = mkN "sodomi" ;
  solblind_av_1_A = mkA "solblind" ;
  solbraend_av_1_1_A = mkA "solbränd" ;
  solenergi_nn_1_N = mkN "solenergi" ;
  solliknande_av_1_A = mkA "solliknande" ;
  solljusreflekterande_av_1_A = mkA "solljusreflekterande" ;
  solo_av_1_A = mkA "solo" ;
  solokvist_av_1_A = mkA "solokvist" ;
  solskifte_nn_1_N = mkN "solskifte" ;
  solterapi_nn_1_N = mkN "solterapi" ;
  solaekta_av_1_1_A = mkA "soläkta" ;
  sorts_av_1_A = mkA "sorts" ;
  sotis_av_1_A = mkA "sotis" ;
  spansktalande_av_1_A = mkA "spansktalande" ;
  spe_nn_1_N = mkN "spe" ;
  specialbestaellande_nn_1_1_N = mkN "specialbeställande" ;
  spegelvaend_av_1_1_A = mkA "spegelvänd" ;
  spektroskopi_nn_1_N = mkN "spektroskopi" ;
  spelberoende_av_1_A = mkA "spelberoende" ;
  speleologi_nn_1_N = mkN "speleologi" ;
  spelteori_nn_1_N = mkN "spelteori" ;
  spinnfiske_nn_1_N = mkN "spinnfiske" ;
  spionage_nn_1_N = mkN "spionage" ;
  spionhysteri_nn_1_N = mkN "spionhysteri" ;
  spirometri_nn_1_N = mkN "spirometri" ;
  spontankaat_av_1_1_A = mkA "spontankåt" ;
  sporbildande_av_1_A = mkA "sporbildande" ;
  sportfiske_nn_1_N = mkN "sportfiske" ;
  sprillan_av_1_A = mkA "sprillan" ;
  sprillans_av_1_A = mkA "sprillans" ;
  spraengkaat_av_1_1_A = mkA "sprängkåt" ;
  spraakfilosofi_nn_1_1_N = mkN "språkfilosofi" ;
  spraakhistoria_nn_1_1_N = mkN "språkhistoria" ;
  spraakpsykologi_nn_1_1_N = mkN "språkpsykologi" ;
  spraaksociologi_nn_1_1_N = mkN "språksociologi" ;
  sputum_nn_1_N = mkN "sputum" ;
  spaend_av_1_1_A = mkA "spänd" ;
  spaennande_av_1_1_A = mkA "spännande" ;
  spaarande_nn_1_1_N = mkN "spårande" ;
  stackars_av_1_A = mkA "stackars" ;
  stadigvarande_av_1_A = mkA "stadigvarande" ;
  staffage_nn_1_N = mkN "staffage" ;
  stajlande_nn_1_N = mkN "stajlande" ;
  startenergi_nn_1_N = mkN "startenergi" ;
  statsbaerande_av_1_1_A = mkA "statsbärande" ;
  stavelsebildande_av_1_A = mkA "stavelsebildande" ;
  stellarastronomi_nn_1_N = mkN "stellarastronomi" ;
  stenkastande_av_1_A = mkA "stenkastande" ;
  stenografi_nn_1_N = mkN "stenografi" ;
  stereofoni_nn_1_N = mkN "stereofoni" ;
  stereoisomeri_nn_1_N = mkN "stereoisomeri" ;
  stereokemi_nn_1_N = mkN "stereokemi" ;
  stereometri_nn_1_N = mkN "stereometri" ;
  stereoseende_nn_1_N = mkN "stereoseende" ;
  stereoskopi_nn_1_N = mkN "stereoskopi" ;
  stickande_av_1_A = mkA "stickande" ;
  stilbildande_av_1_A = mkA "stilbildande" ;
  stilla_av_1_A = mkA "stilla" ;
  stillasittande_av_1_A = mkA "stillasittande" ;
  stillasittande_nn_1_N = mkN "stillasittande" ;
  stillastaaende_av_1_1_A = mkA "stillastående" ;
  stillastaaende_nn_1_1_N = mkN "stillastående" ;
  stillatigande_av_1_A = mkA "stillatigande" ;
  stinkande_av_1_A = mkA "stinkande" ;
  stolts_av_1_A = mkA "stolts" ;
  stoppande_av_1_A = mkA "stoppande" ;
  storfraemmande_nn_1_1_N = mkN "storfrämmande" ;
  storsjoefiske_nn_1_1_N = mkN "storsjöfiske" ;
  storskifte_nn_1_N = mkN "storskifte" ;
  straight_av_1_A = mkA "straight" ;
  stratigrafi_nn_1_N = mkN "stratigrafi" ;
  struntsamma_av_1_A = mkA "struntsamma" ;
  strykraedd_av_1_1_A = mkA "strykrädd" ;
  straalande_av_1_1_A = mkA "strålande" ;
  straalningsbiologi_nn_1_1_N = mkN "strålningsbiologi" ;
  straalningskemi_nn_1_1_N = mkN "strålningskemi" ;
  stroemfoerande_av_1_1_A = mkA "strömförande" ;
  stroemledande_av_1_1_A = mkA "strömledande" ;
  stroemmingsfiske_nn_1_1_N = mkN "strömmingsfiske" ;
  stupid_av_1_A = mkA "stupid" ;
  stylande_nn_1_N = mkN "stylande" ;
  staellfoeretraedande_av_1_1_A = mkA "ställföreträdande" ;
  staemningsspridande_av_1_1_A = mkA "stämningsspridande" ;
  staerkande_av_1_1_A = mkA "stärkande" ;
  staaende_av_1_1_A = mkA "stående" ;
  stoekiometri_nn_1_1_N = mkN "stökiometri" ;
  stoetdaempande_av_1_1_A = mkA "stötdämpande" ;
  substitutionskryptografi_nn_1_N = mkN "substitutionskryptografi" ;
  sugande_av_1_A = mkA "sugande" ;
  sund_av_1_A = mkA "sund" ;
  superkul_av_1_A = mkA "superkul" ;
  supraledande_av_1_A = mkA "supraledande" ;
  supremati_nn_1_N = mkN "supremati" ;
  svackande_nn_1_N = mkN "svackande" ;
  svaglysande_av_1_A = mkA "svaglysande" ;
  svagpresterande_av_1_A = mkA "svagpresterande" ;
  svalliknande_av_1_A = mkA "svalliknande" ;
  svampliknande_av_1_A = mkA "svampliknande" ;
  svartglaensande_av_1_1_A = mkA "svartglänsande" ;
  svartmaalande_nn_1_1_N = mkN "svartmålande" ;
  svartskimrande_av_1_A = mkA "svartskimrande" ;
  svavelosande_av_1_A = mkA "svavelosande" ;
  svavelvaete_nn_1_1_N = mkN "svavelväte" ;
  svavelvaeteproducerande_av_1_1_A = mkA "svavelväteproducerande" ;
  svensktalande_av_1_A = mkA "svensktalande" ;
  svepande_av_1_A = mkA "svepande" ;
  svettdoftande_av_1_A = mkA "svettdoftande" ;
  svettdrypande_av_1_A = mkA "svettdrypande" ;
  svindlande_av_1_A = mkA "svindlande" ;
  svinliknande_av_1_A = mkA "svinliknande" ;
  svaerdliknande_av_1_1_A = mkA "svärdliknande" ;
  svaevande_av_1_1_A = mkA "svävande" ;
  swahili_nn_1_N = mkN "swahili" ;
  sweet_av_1_A = mkA "sweet" ;
  sydgaaende_av_1_1_A = mkA "sydgående" ;
  sydvaestra_av_1_1_A = mkA "sydvästra" ;
  sydoestra_av_1_1_A = mkA "sydöstra" ;
  symptomlindrande_av_1_A = mkA "symptomlindrande" ;
  symtomlindrande_av_1_A = mkA "symtomlindrande" ;
  synd_av_1_A = mkA "synd" ;
  synliggoerande_nn_1_1_N = mkN "synliggörande" ;
  syrak_av_1_A = mkA "syrak" ;
  syre_nn_1_N = mkN "syre" ;
  syrefordrande_av_1_A = mkA "syrefordrande" ;
  syreproducerande_av_1_A = mkA "syreproducerande" ;
  syreupptagande_av_1_A = mkA "syreupptagande" ;
  sysilke_nn_1_N = mkN "sysilke" ;
  syskontycke_nn_1_N = mkN "syskontycke" ;
  sysselsaettningsskapande_av_1_1_A = mkA "sysselsättningsskapande" ;
  saeckliknande_av_1_1_A = mkA "säckliknande" ;
  saellskapsgraatande_nn_1_1_N = mkN "sällskapsgråtande" ;
  saelskytte_nn_1_1_N = mkN "sälskytte" ;
  saengliggande_av_1_1_A = mkA "sängliggande" ;
  saenglinne_nn_1_1_N = mkN "sänglinne" ;
  saenglaege_nn_1_1_N = mkN "sängläge" ;
  saer_av_1_1_A = mkA "sär" ;
  saerlevande_av_1_1_A = mkA "särlevande" ;
  saadaer_av_1_1_A = mkA "sådär" ;
  saarande_av_1_1_A = mkA "sårande" ;
  saat_av_1_1_A = mkA "såt" ;
  soedergaaende_av_1_1_A = mkA "södergående" ;
  soedra_av_1_1_A = mkA "södra" ;
  soendagskoerande_nn_1_1_N = mkN "söndagskörande" ;
  soenderbraend_av_1_1_A = mkA "sönderbränd" ;
  tabu_av_1_A = mkA "tabu" ;
  tabubelaeggande_nn_1_1_N = mkN "tabubeläggande" ;
  tacklage_nn_1_N = mkN "tacklage" ;
  tajande_nn_1_N = mkN "tajande" ;
  taktikroestande_nn_1_1_N = mkN "taktikröstande" ;
  talande_av_1_A = mkA "talande" ;
  tallriksliknande_av_1_A = mkA "tallriksliknande" ;
  talteori_nn_1_N = mkN "talteori" ;
  tamil_nn_2_N = mkN "tamil" ;
  tandtraadande_nn_1_1_N = mkN "tandtrådande" ;
  tankeherravaelde_nn_1_1_N = mkN "tankeherravälde" ;
  tankevaeckande_av_1_1_A = mkA "tankeväckande" ;
  tassliknande_av_1_A = mkA "tassliknande" ;
  tautomeri_nn_1_N = mkN "tautomeri" ;
  tax_free_av_1_A = mkA "tax-free" ;
  tedrickande_nn_1_N = mkN "tedrickande" ;
  tefrokronologi_nn_1_N = mkN "tefrokronologi" ;
  tegelliknande_av_1_A = mkA "tegelliknande" ;
  tegskifte_nn_1_N = mkN "tegskifte" ;
  teknologie_av_1_A = mkA "teknologie" ;
  telefoni_nn_1_N = mkN "telefoni" ;
  telegrafi_nn_1_N = mkN "telegrafi" ;
  telekinesi_nn_1_N = mkN "telekinesi" ;
  teleologi_nn_1_N = mkN "teleologi" ;
  teleskopi_nn_1_N = mkN "teleskopi" ;
  teleskopliknande_av_1_A = mkA "teleskopliknande" ;
  teologi_nn_1_N = mkN "teologi" ;
  teologie_av_1_A = mkA "teologie" ;
  teosofi_nn_1_N = mkN "teosofi" ;
  termografi_nn_1_N = mkN "termografi" ;
  termokemi_nn_1_N = mkN "termokemi" ;
  terraenggaaende_av_1_1_A = mkA "terränggående" ;
  tertiaer_nn_1_1_N = mkN "tertiär" ;
  testflygande_nn_1_N = mkN "testflygande" ;
  tetani_nn_1_N = mkN "tetani" ;
  tetraploid_av_1_A = mkA "tetraploid" ;
  textilaetande_av_1_1_A = mkA "textilätande" ;
  teaelskande_av_1_1_A = mkA "teälskande" ;
  tidigmedeltida_av_1_A = mkA "tidigmedeltida" ;
  tidningslaesande_av_1_1_A = mkA "tidningsläsande" ;
  tidningslaesande_nn_1_1_N = mkN "tidningsläsande" ;
  tidsberaeknande_nn_1_1_N = mkN "tidsberäknande" ;
  tidskraevande_av_1_1_A = mkA "tidskrävande" ;
  tidsoedande_av_1_1_A = mkA "tidsödande" ;
  tillbakadragande_nn_1_N = mkN "tillbakadragande" ;
  tillbakagaaende_av_1_1_A = mkA "tillbakagående" ;
  tillbakasyftande_av_1_A = mkA "tillbakasyftande" ;
  tilldragande_av_1_A = mkA "tilldragande" ;
  tillfreds_av_1_A = mkA "tillfreds" ;
  tillfredsstaellande_av_1_1_A = mkA "tillfredsställande" ;
  tillfrisknande_nn_1_N = mkN "tillfrisknande" ;
  tillhoerande_av_1_1_A = mkA "tillhörande" ;
  tillintetgoerande_av_1_1_A = mkA "tillintetgörande" ;
  tillkommande_av_1_A = mkA "tillkommande" ;
  tillmoetesgaaende_av_1_1_A = mkA "tillmötesgående" ;
  tillmoetesgaaende_nn_1_1_N = mkN "tillmötesgående" ;
  tillstaandsgivande_av_1_1_A = mkA "tillståndsgivande" ;
  tilltagande_av_1_A = mkA "tilltagande" ;
  tilltagande_nn_1_N = mkN "tilltagande" ;
  tilltalande_av_1_A = mkA "tilltalande" ;
  tillvand_av_1_A = mkA "tillvand" ;
  timid_av_1_A = mkA "timid" ;
  tiomila_av_1_A = mkA "tiomila" ;
  tionde_nn_1_N = mkN "tionde" ;
  tipptopp_av_1_A = mkA "tipptopp" ;
  tiptop_av_1_A = mkA "tiptop" ;
  titanvitt_nn_1_N = mkN "titanvitt" ;
  titthaalskirurgi_nn_1_1_N = mkN "titthålskirurgi" ;
  tjockflytande_av_1_A = mkA "tjockflytande" ;
  tjuvfiskande_nn_1_N = mkN "tjuvfiskande" ;
  tjuvfiske_nn_1_N = mkN "tjuvfiske" ;
  tjuvjagande_nn_1_N = mkN "tjuvjagande" ;
  tjuvkikande_nn_1_N = mkN "tjuvkikande" ;
  tjuvroekande_nn_1_1_N = mkN "tjuvrökande" ;
  tjuvskytte_nn_1_N = mkN "tjuvskytte" ;
  tjuvtittande_nn_1_N = mkN "tjuvtittande" ;
  tjyvfiskande_nn_1_N = mkN "tjyvfiskande" ;
  tjyvfiske_nn_1_N = mkN "tjyvfiske" ;
  tjyvjagande_nn_1_N = mkN "tjyvjagande" ;
  tjyvkikande_nn_1_N = mkN "tjyvkikande" ;
  tjyvroekande_nn_1_1_N = mkN "tjyvrökande" ;
  tjyvtittande_nn_1_N = mkN "tjyvtittande" ;
  tjaenis_av_1_1_A = mkA "tjänis" ;
  tjaenstefoerraettande_av_1_1_A = mkA "tjänsteförrättande" ;
  tolkningsfoeretraede_nn_1_1_N = mkN "tolkningsföreträde" ;
  tolvfaldigande_nn_1_N = mkN "tolvfaldigande" ;
  tonande_av_1_A = mkA "tonande" ;
  tongivande_av_1_A = mkA "tongivande" ;
  tonnage_nn_1_N = mkN "tonnage" ;
  topless_av_1_A = mkA "topless" ;
  topografi_nn_1_N = mkN "topografi" ;
  toppenbra_av_1_A = mkA "toppenbra" ;
  torraemne_nn_1_1_N = mkN "torrämne" ;
  totalkvaddande_nn_1_N = mkN "totalkvaddande" ;
  totalsabbande_nn_1_N = mkN "totalsabbande" ;
  toujours_av_1_A = mkA "toujours" ;
  toxikologi_nn_1_N = mkN "toxikologi" ;
  toxikomani_nn_1_N = mkN "toxikomani" ;
  trafikledande_nn_1_N = mkN "trafikledande" ;
  transportberoende_av_1_A = mkA "transportberoende" ;
  trappliknande_av_1_A = mkA "trappliknande" ;
  trattliknande_av_1_A = mkA "trattliknande" ;
  tredubblande_nn_1_N = mkN "tredubblande" ;
  trefaldigande_nn_1_N = mkN "trefaldigande" ;
  trefas_av_1_A = mkA "trefas" ;
  treskifte_nn_1_N = mkN "treskifte" ;
  trespaend_av_1_1_A = mkA "trespänd" ;
  trevande_av_1_A = mkA "trevande" ;
  trias_nn_1_N = mkN "trias" ;
  trigonometri_nn_1_N = mkN "trigonometri" ;
  trikotage_nn_1_N = mkN "trikotage" ;
  trilskande_av_1_A = mkA "trilskande" ;
  trind_av_1_A = mkA "trind" ;
  triploid_av_1_A = mkA "triploid" ;
  troende_av_1_A = mkA "troende" ;
  trumfmatt_av_1_A = mkA "trumfmatt" ;
  trupptillbakadragande_nn_1_N = mkN "trupptillbakadragande" ;
  tryckande_av_1_A = mkA "tryckande" ;
  trygghetsnarkomani_nn_1_N = mkN "trygghetsnarkomani" ;
  traedliknande_av_1_1_A = mkA "trädliknande" ;
  traeffande_av_1_1_A = mkA "träffande" ;
  traengande_av_1_1_A = mkA "trängande" ;
  traevirke_nn_1_1_N = mkN "trävirke" ;
  traadliknande_av_1_1_A = mkA "trådliknande" ;
  traalfiske_nn_1_1_N = mkN "trålfiske" ;
  traang_av_1_1_A = mkA "trång" ;
  troegflytande_av_1_1_A = mkA "trögflytande" ;
  tularemi_nn_1_N = mkN "tularemi" ;
  tungomaalstalande_av_1_1_A = mkA "tungomålstalande" ;
  tungomaalstalande_nn_1_1_N = mkN "tungomålstalande" ;
  tungvrickande_av_1_A = mkA "tungvrickande" ;
  tunnelliknande_av_1_A = mkA "tunnelliknande" ;
  tusenaara_av_1_1_A = mkA "tusenåra" ;
  tvagande_nn_1_N = mkN "tvagande" ;
  tvingande_av_1_A = mkA "tvingande" ;
  tvaergaaende_av_1_1_A = mkA "tvärgående" ;
  tvaettaekta_av_1_1_A = mkA "tvättäkta" ;
  tvaamans_av_1_1_A = mkA "tvåmans" ;
  tvaangssparande_nn_1_1_N = mkN "tvångssparande" ;
  tvaaspaend_av_1_1_A = mkA "tvåspänd" ;
  typbildande_av_1_A = mkA "typbildande" ;
  tyre_nn_1_N = mkN "tyre" ;
  tysktalande_av_1_A = mkA "tysktalande" ;
  tystgaaende_av_1_1_A = mkA "tystgående" ;
  taerande_av_1_1_A = mkA "tärande" ;
  taetortsnaera_av_1_1_A = mkA "tätortsnära" ;
  taettsittande_av_1_1_A = mkA "tättsittande" ;
  taettslutande_av_1_1_A = mkA "tättslutande" ;
  taagvirke_nn_1_1_N = mkN "tågvirke" ;
  taalamodsproevande_av_1_1_A = mkA "tålamodsprövande" ;
  taardrypande_av_1_1_A = mkA "tårdrypande" ;
  toere_nn_1_1_N = mkN "töre" ;
  toerstslaeckande_av_1_1_A = mkA "törstsläckande" ;
  u_formig_av_1_A = mkA "u-formig" ;
  udda_av_1_A = mkA "udda" ;
  uddloes_av_1_1_A = mkA "uddlös" ;
  ugandisk_av_1_A = mkA "ugandisk" ;
  uggleliknande_av_1_A = mkA "uggleliknande" ;
  ugnsvarm_av_1_A = mkA "ugnsvarm" ;
  ukrainsk_av_1_A = mkA "ukrainsk" ;
  ulceroes_av_1_1_A = mkA "ulcerös" ;
  ullhaarig_av_1_1_A = mkA "ullhårig" ;
  ullig_av_1_A = mkA "ullig" ;
  ulliknande_av_1_A = mkA "ulliknande" ;
  ultimativ_av_1_A = mkA "ultimativ" ;
  ultrakonservativ_av_1_A = mkA "ultrakonservativ" ;
  ultramarin_av_1_A = mkA "ultramarin" ;
  ultramontan_av_1_A = mkA "ultramontan" ;
  ultrarapid_av_1_A = mkA "ultrarapid" ;
  ultrarapidfotograferbar_av_1_A = mkA "ultrarapidfotograferbar" ;
  ultrasnabb_av_1_A = mkA "ultrasnabb" ;
  umbaerlig_av_1_1_A = mkA "umbärlig" ;
  undanglidande_av_1_A = mkA "undanglidande" ;
  undanskuffande_nn_1_N = mkN "undanskuffande" ;
  undantagsloes_av_1_1_A = mkA "undantagslös" ;
  underbalanserbar_av_1_A = mkA "underbalanserbar" ;
  underbar_av_1_A = mkA "underbar" ;
  underdimensionerbar_av_1_A = mkA "underdimensionerbar" ;
  underdaanig_av_1_1_A = mkA "underdånig" ;
  underexponerbar_av_1_A = mkA "underexponerbar" ;
  underfull_av_1_A = mkA "underfull" ;
  underfundig_av_1_A = mkA "underfundig" ;
  undergoerande_av_1_1_A = mkA "undergörande" ;
  underhaltig_av_1_A = mkA "underhaltig" ;
  underhaerdig_av_1_1_A = mkA "underhärdig" ;
  underhaallande_av_1_1_A = mkA "underhållande" ;
  underhaallningsmaessig_av_1_1_A = mkA "underhållningsmässig" ;
  underjordisk_av_1_A = mkA "underjordisk" ;
  underklassig_av_1_A = mkA "underklassig" ;
  underkunnig_av_1_A = mkA "underkunnig" ;
  underkaend_av_1_1_A = mkA "underkänd" ;
  underlig_av_1_A = mkA "underlig" ;
  underliggande_av_1_A = mkA "underliggande" ;
  underlydande_av_1_A = mkA "underlydande" ;
  underlaege_nn_1_1_N = mkN "underläge" ;
  undermedvetande_nn_1_N = mkN "undermedvetande" ;
  underminerbar_av_1_A = mkA "underminerbar" ;
  undermaensklig_av_1_1_A = mkA "undermänsklig" ;
  undermaalig_av_1_1_A = mkA "undermålig" ;
  underordnande_av_1_A = mkA "underordnande" ;
  underskoen_av_1_1_A = mkA "underskön" ;
  understaaende_av_1_1_A = mkA "understående" ;
  undersaetsig_av_1_1_A = mkA "undersätsig" ;
  undersaatlig_av_1_1_A = mkA "undersåtlig" ;
  undertalig_av_1_A = mkA "undertalig" ;
  undertaxerbar_av_1_A = mkA "undertaxerbar" ;
  undervattensarkeologi_nn_1_N = mkN "undervattensarkeologi" ;
  undervattenslaege_nn_1_1_N = mkN "undervattensläge" ;
  underviktig_av_1_A = mkA "underviktig" ;
  undervaerderbar_av_1_1_A = mkA "undervärderbar" ;
  undfallande_av_1_A = mkA "undfallande" ;
  undflyende_nn_1_N = mkN "undflyende" ;
  undrande_av_1_A = mkA "undrande" ;
  undulatorisk_av_1_A = mkA "undulatorisk" ;
  undvikande_av_1_A = mkA "undvikande" ;
  ungdomlig_av_1_A = mkA "ungdomlig" ;
  ungefaerlig_av_1_1_A = mkA "ungefärlig" ;
  ungersk_av_1_A = mkA "ungersk" ;
  ungflicksaktig_av_1_A = mkA "ungflicksaktig" ;
  ungkyrklig_av_1_A = mkA "ungkyrklig" ;
  ungsvensk_av_1_A = mkA "ungsvensk" ;
  unifierbar_av_1_A = mkA "unifierbar" ;
  uniform_av_1_A = mkA "uniform" ;
  uniformerbar_av_1_A = mkA "uniformerbar" ;
  uniformsliknande_av_1_A = mkA "uniformsliknande" ;
  unik_av_1_A = mkA "unik" ;
  unilateral_av_1_A = mkA "unilateral" ;
  unionell_av_1_A = mkA "unionell" ;
  unisex_av_1_A = mkA "unisex" ;
  unison_av_1_A = mkA "unison" ;
  unitarisk_av_1_A = mkA "unitarisk" ;
  universalistisk_av_1_A = mkA "universalistisk" ;
  universell_av_1_A = mkA "universell" ;
  up_to_date_av_1_A = mkA "up-to-date" ;
  uppblossande_av_1_A = mkA "uppblossande" ;
  uppbygglig_av_1_A = mkA "uppbygglig" ;
  uppbaerande_nn_1_1_N = mkN "uppbärande" ;
  uppdaterbar_av_1_A = mkA "uppdaterbar" ;
  uppdragsarkeologi_nn_1_N = mkN "uppdragsarkeologi" ;
  uppdykande_av_1_A = mkA "uppdykande" ;
  uppehaelle_nn_1_1_N = mkN "uppehälle" ;
  uppenbar_av_1_A = mkA "uppenbar" ;
  uppfinningsrik_av_1_A = mkA "uppfinningsrik" ;
  uppflammande_av_1_A = mkA "uppflammande" ;
  uppfriskande_av_1_A = mkA "uppfriskande" ;
  uppfaellbar_av_1_1_A = mkA "uppfällbar" ;
  uppfoeljande_av_1_1_A = mkA "uppföljande" ;
  uppgraderbar_av_1_A = mkA "uppgraderbar" ;
  upphinnelig_av_1_A = mkA "upphinnelig" ;
  uppiggande_av_1_A = mkA "uppiggande" ;
  uppjusterbar_av_1_A = mkA "uppjusterbar" ;
  uppkaeftig_av_1_1_A = mkA "uppkäftig" ;
  upplagemaessig_av_1_1_A = mkA "upplagemässig" ;
  upplevelsemaessig_av_1_1_A = mkA "upplevelsemässig" ;
  upplyftande_av_1_A = mkA "upplyftande" ;
  upplysningstaenkande_nn_1_1_N = mkN "upplysningstänkande" ;
  upplaendsk_av_1_1_A = mkA "uppländsk" ;
  uppmaerksamhetskaat_av_1_1_A = mkA "uppmärksamhetskåt" ;
  uppmaerksamhetsvaerde_nn_1_1_N = mkN "uppmärksamhetsvärde" ;
  uppnosig_av_1_A = mkA "uppnosig" ;
  uppnaaelig_av_1_1_A = mkA "uppnåelig" ;
  uppochnedvaend_av_1_1_A = mkA "uppochnedvänd" ;
  uppochnervaend_av_1_1_A = mkA "uppochnervänd" ;
  uppoffrande_av_1_A = mkA "uppoffrande" ;
  uppreklamerbar_av_1_A = mkA "uppreklamerbar" ;
  uppriktig_av_1_A = mkA "uppriktig" ;
  upprivande_av_1_A = mkA "upprivande" ;
  upprorisk_av_1_A = mkA "upprorisk" ;
  upprullande_nn_1_N = mkN "upprullande" ;
  uppraettstaaende_av_1_1_A = mkA "upprättstående" ;
  upproerande_av_1_1_A = mkA "upprörande" ;
  uppseende_nn_1_N = mkN "uppseende" ;
  uppseendevaeckande_av_1_1_A = mkA "uppseendeväckande" ;
  uppskakande_av_1_A = mkA "uppskakande" ;
  uppslagsrik_av_1_A = mkA "uppslagsrik" ;
  uppslitande_av_1_A = mkA "uppslitande" ;
  uppstudsig_av_1_A = mkA "uppstudsig" ;
  uppstaaende_av_1_1_A = mkA "uppstående" ;
  uppsummerbar_av_1_A = mkA "uppsummerbar" ;
  uppsvensk_av_1_A = mkA "uppsvensk" ;
  uppsaatlig_av_1_1_A = mkA "uppsåtlig" ;
  uppsoekande_av_1_1_A = mkA "uppsökande" ;
  upptaxerbar_av_1_A = mkA "upptaxerbar" ;
  upptaend_av_1_1_A = mkA "upptänd" ;
  upptaenklig_av_1_1_A = mkA "upptänklig" ;
  uppvaknande_nn_1_N = mkN "uppvaknande" ;
  uppvaerderbar_av_1_1_A = mkA "uppvärderbar" ;
  uppaanedvaend_av_1_1_A = mkA "uppånedvänd" ;
  uppaanervaend_av_1_1_A = mkA "uppånervänd" ;
  uppaat_av_1_1_A = mkA "uppåt" ;
  uppaatgaaende_av_1_1_A = mkA "uppåtgående" ;
  uppaatgaaende_nn_1_1_N = mkN "uppåtgående" ;
  uppaatstigande_av_1_1_A = mkA "uppåtstigande" ;
  uppaatstraevande_av_1_1_A = mkA "uppåtsträvande" ;
  uralisk_av_1_A = mkA "uralisk" ;
  uralsk_av_1_A = mkA "uralsk" ;
  urarva_av_1_A = mkA "urarva" ;
  urban_av_1_A = mkA "urban" ;
  urbaniserbar_av_1_A = mkA "urbaniserbar" ;
  urbanistisk_av_1_A = mkA "urbanistisk" ;
  urdu_nn_1_N = mkN "urdu" ;
  urdyr_av_1_A = mkA "urdyr" ;
  urdaalig_av_1_1_A = mkA "urdålig" ;
  uremi_nn_1_N = mkN "uremi" ;
  urfolklig_av_1_A = mkA "urfolklig" ;
  urfaanig_av_1_1_A = mkA "urfånig" ;
  urgermansk_av_1_A = mkA "urgermansk" ;
  urholkande_nn_1_N = mkN "urholkande" ;
  urindoeuropeisk_av_1_A = mkA "urindoeuropeisk" ;
  urindrivande_av_1_A = mkA "urindrivande" ;
  urinaemne_nn_1_1_N = mkN "urinämne" ;
  urkundlig_av_1_A = mkA "urkundlig" ;
  urminnes_av_1_A = mkA "urminnes" ;
  urmodig_av_1_A = mkA "urmodig" ;
  urnordisk_av_1_A = mkA "urnordisk" ;
  urografi_nn_1_N = mkN "urografi" ;
  urologi_nn_1_N = mkN "urologi" ;
  urologisk_av_1_A = mkA "urologisk" ;
  ursinnig_av_1_A = mkA "ursinnig" ;
  ursinningsloes_av_1_1_A = mkA "ursinningslös" ;
  urskiljbar_av_1_A = mkA "urskiljbar" ;
  urskiljningsloes_av_1_1_A = mkA "urskiljningslös" ;
  urskillningsloes_av_1_1_A = mkA "urskillningslös" ;
  ursnygg_av_1_A = mkA "ursnygg" ;
  ursprunglig_av_1_A = mkA "ursprunglig" ;
  urspraaklig_av_1_1_A = mkA "urspråklig" ;
  urstyv_av_1_A = mkA "urstyv" ;
  ursaektlig_av_1_1_A = mkA "ursäktlig" ;
  urtagbar_av_1_A = mkA "urtagbar" ;
  urtida_av_1_A = mkA "urtida" ;
  urtima_av_1_A = mkA "urtima" ;
  urtjusig_av_1_A = mkA "urtjusig" ;
  urtjuva_av_1_A = mkA "urtjuva" ;
  uruguayansk_av_1_A = mkA "uruguayansk" ;
  uruguaysk_av_1_A = mkA "uruguaysk" ;
  uraaldrig_av_1_1_A = mkA "uråldrig" ;
  uschlig_av_1_A = mkA "uschlig" ;
  uslig_av_1_A = mkA "uslig" ;
  usuell_av_1_A = mkA "usuell" ;
  usurperbar_av_1_A = mkA "usurperbar" ;
  utackorderbar_av_1_A = mkA "utackorderbar" ;
  utanfoerstaaende_av_1_1_A = mkA "utanförstående" ;
  utannonserbar_av_1_A = mkA "utannonserbar" ;
  utantillmaessig_av_1_1_A = mkA "utantillmässig" ;
  utarrenderbar_av_1_A = mkA "utarrenderbar" ;
  utbalanserbar_av_1_A = mkA "utbalanserbar" ;
  utbasunerbar_av_1_A = mkA "utbasunerbar" ;
  utbildningsmaessig_av_1_1_A = mkA "utbildningsmässig" ;
  utbroderbar_av_1_A = mkA "utbroderbar" ;
  utbraend_av_1_1_A = mkA "utbränd" ;
  utbuktande_av_1_A = mkA "utbuktande" ;
  utbyggbar_av_1_A = mkA "utbyggbar" ;
  utbytbar_av_1_A = mkA "utbytbar" ;
  utdebiterbar_av_1_A = mkA "utdebiterbar" ;
  utdragbar_av_1_A = mkA "utdragbar" ;
  utdoeende_nn_1_1_N = mkN "utdöende" ;
  ute_av_1_A = mkA "ute" ;
  uteliggande_av_1_A = mkA "uteliggande" ;
  uteloepande_av_1_1_A = mkA "utelöpande" ;
  utestaaende_av_1_1_A = mkA "utestående" ;
  utexaminerbar_av_1_A = mkA "utexaminerbar" ;
  utexperimenterbar_av_1_A = mkA "utexperimenterbar" ;
  utfattig_av_1_A = mkA "utfattig" ;
  utfaellbar_av_1_1_A = mkA "utfällbar" ;
  utfoerbar_av_1_1_A = mkA "utförbar" ;
  utfoerlig_av_1_1_A = mkA "utförlig" ;
  utgaaende_av_1_1_A = mkA "utgående" ;
  uthaerdlig_av_1_1_A = mkA "uthärdlig" ;
  uthaallig_av_1_1_A = mkA "uthållig" ;
  utilistisk_av_1_A = mkA "utilistisk" ;
  utilitaristisk_av_1_A = mkA "utilitaristisk" ;
  utklarerbar_av_1_A = mkA "utklarerbar" ;
  utkommenderbar_av_1_A = mkA "utkommenderbar" ;
  utkonkurrerbar_av_1_A = mkA "utkonkurrerbar" ;
  utkristalliserbar_av_1_A = mkA "utkristalliserbar" ;
  utkvitterbar_av_1_A = mkA "utkvitterbar" ;
  utlevande_av_1_A = mkA "utlevande" ;
  utlokaliserbar_av_1_A = mkA "utlokaliserbar" ;
  utlaendsk_av_1_1_A = mkA "utländsk" ;
  utmanande_av_1_A = mkA "utmanande" ;
  utmanoevrerbar_av_1_1_A = mkA "utmanövrerbar" ;
  utminuterbar_av_1_A = mkA "utminuterbar" ;
  utmaerkande_av_1_1_A = mkA "utmärkande" ;
  utomeuropeisk_av_1_A = mkA "utomeuropeisk" ;
  utomjordisk_av_1_A = mkA "utomjordisk" ;
  utomordentlig_av_1_A = mkA "utomordentlig" ;
  utomparlamentarisk_av_1_A = mkA "utomparlamentarisk" ;
  utomstaaende_av_1_1_A = mkA "utomstående" ;
  utomaektenskaplig_av_1_1_A = mkA "utomäktenskaplig" ;
  utopisk_av_1_A = mkA "utopisk" ;
  utplacerbar_av_1_A = mkA "utplacerbar" ;
  utplattande_nn_1_N = mkN "utplattande" ;
  utposterbar_av_1_A = mkA "utposterbar" ;
  utraderbar_av_1_A = mkA "utraderbar" ;
  utrangerbar_av_1_A = mkA "utrangerbar" ;
  utredningsmaessig_av_1_1_A = mkA "utredningsmässig" ;
  utrikes_av_1_A = mkA "utrikes" ;
  utrikespolitisk_av_1_A = mkA "utrikespolitisk" ;
  utrikisk_av_1_A = mkA "utrikisk" ;
  utrullande_nn_1_N = mkN "utrullande" ;
  utrymmesmaessig_av_1_1_A = mkA "utrymmesmässig" ;
  utseendemaessig_av_1_1_A = mkA "utseendemässig" ;
  utsiktsloes_av_1_1_A = mkA "utsiktslös" ;
  utsjoefiske_nn_1_1_N = mkN "utsjöfiske" ;
  utskjutande_av_1_A = mkA "utskjutande" ;
  utskottsvirke_nn_1_N = mkN "utskottsvirke" ;
  utskaerande_nn_1_1_N = mkN "utskärande" ;
  utslagsgivande_av_1_A = mkA "utslagsgivande" ;
  utslocknande_nn_1_N = mkN "utslocknande" ;
  utsocknes_av_1_A = mkA "utsocknes" ;
  utspringande_av_1_A = mkA "utspringande" ;
  utspaend_av_1_1_A = mkA "utspänd" ;
  utstofferbar_av_1_A = mkA "utstofferbar" ;
  utstaaende_av_1_1_A = mkA "utstående" ;
  utsvaellande_nn_1_1_N = mkN "utsvällande" ;
  utsvaevande_av_1_1_A = mkA "utsvävande" ;
  uttalsenlig_av_1_A = mkA "uttalsenlig" ;
  uttaxerbar_av_1_A = mkA "uttaxerbar" ;
  uttrycklig_av_1_A = mkA "uttrycklig" ;
  uttrycksfull_av_1_A = mkA "uttrycksfull" ;
  uttrycksloes_av_1_1_A = mkA "uttryckslös" ;
  uttrycksmaessig_av_1_1_A = mkA "uttrycksmässig" ;
  uttaenjbar_av_1_1_A = mkA "uttänjbar" ;
  uttoemmande_av_1_1_A = mkA "uttömmande" ;
  utvecklingshistoria_nn_1_N = mkN "utvecklingshistoria" ;
  utvecklingsmaessig_av_1_1_A = mkA "utvecklingsmässig" ;
  utvaendig_av_1_1_A = mkA "utvändig" ;
  utvaerderbar_av_1_1_A = mkA "utvärderbar" ;
  utvaertes_av_1_1_A = mkA "utvärtes" ;
  utaatvaend_av_1_1_A = mkA "utåtvänd" ;
  uvular_av_1_A = mkA "uvular" ;
  uzbekisk_av_1_A = mkA "uzbekisk" ;
  vaccinerbar_av_1_A = mkA "vaccinerbar" ;
  vaccineringshysteri_nn_1_N = mkN "vaccineringshysteri" ;
  vadbar_av_1_A = mkA "vadbar" ;
  vadderbar_av_1_A = mkA "vadderbar" ;
  vadlaang_av_1_1_A = mkA "vadlång" ;
  vados_av_1_A = mkA "vados" ;
  vag_av_1_A = mkA "vag" ;
  vaginal_av_1_A = mkA "vaginal" ;
  vaksinerbar_av_1_A = mkA "vaksinerbar" ;
  vakthavande_av_1_A = mkA "vakthavande" ;
  valbar_av_1_A = mkA "valbar" ;
  valid_av_1_A = mkA "valid" ;
  valkig_av_1_A = mkA "valkig" ;
  vallmote_nn_1_N = mkN "vallmote" ;
  vallonsk_av_1_A = mkA "vallonsk" ;
  vallonsmide_nn_1_N = mkN "vallonsmide" ;
  valnoetsliknande_av_1_1_A = mkA "valnötsliknande" ;
  valpaktig_av_1_A = mkA "valpaktig" ;
  valpig_av_1_A = mkA "valpig" ;
  valutamaessig_av_1_1_A = mkA "valutamässig" ;
  valuterbar_av_1_A = mkA "valuterbar" ;
  valverbar_av_1_A = mkA "valverbar" ;
  valvstupstaaende_nn_1_1_N = mkN "valvstupstående" ;
  vampig_av_1_A = mkA "vampig" ;
  van_av_1_A = mkA "van" ;
  vanartig_av_1_A = mkA "vanartig" ;
  vandaliserbar_av_1_A = mkA "vandaliserbar" ;
  vandalisk_av_1_A = mkA "vandalisk" ;
  vanebildande_av_1_A = mkA "vanebildande" ;
  vanemaessig_av_1_1_A = mkA "vanemässig" ;
  vanetaenkande_nn_1_1_N = mkN "vanetänkande" ;
  vanfoer_av_1_1_A = mkA "vanför" ;
  vanhederlig_av_1_A = mkA "vanhederlig" ;
  vankelmodig_av_1_A = mkA "vankelmodig" ;
  vanlig_av_1_A = mkA "vanlig" ;
  vanmaektig_av_1_1_A = mkA "vanmäktig" ;
  vansinnig_av_1_A = mkA "vansinnig" ;
  vanskaplig_av_1_A = mkA "vanskaplig" ;
  vansklig_av_1_A = mkA "vansklig" ;
  vanstark_av_1_A = mkA "vanstark" ;
  vanuatisk_av_1_A = mkA "vanuatisk" ;
  vanvettig_av_1_A = mkA "vanvettig" ;
  vanvoerdig_av_1_1_A = mkA "vanvördig" ;
  vanaerande_av_1_1_A = mkA "vanärande" ;
  vapenfoer_av_1_1_A = mkA "vapenför" ;
  vapenloes_av_1_1_A = mkA "vapenlös" ;
  vapenmaessig_av_1_1_A = mkA "vapenmässig" ;
  vapensmide_nn_1_N = mkN "vapensmide" ;
  vapensmugglande_av_1_A = mkA "vapensmugglande" ;
  var_av_1_A = mkA "var" ;
  varaktig_av_1_A = mkA "varaktig" ;
  vardaglig_av_1_A = mkA "vardaglig" ;
  vardagsmaessig_av_1_1_A = mkA "vardagsmässig" ;
  vargtaet_av_1_1_A = mkA "vargtät" ;
  varierbar_av_1_A = mkA "varierbar" ;
  varig_av_1_A = mkA "varig" ;
  varjehanda_av_1_A = mkA "varjehanda" ;
  varlig_av_1_A = mkA "varlig" ;
  varm_av_1_A = mkA "varm" ;
  varmblodig_av_1_A = mkA "varmblodig" ;
  varse_av_1_A = mkA "varse" ;
  varudeklarerbar_av_1_A = mkA "varudeklarerbar" ;
  varvig_av_1_A = mkA "varvig" ;
  vaskulaer_av_1_1_A = mkA "vaskulär" ;
  vasografi_nn_1_N = mkN "vasografi" ;
  vasomotorisk_av_1_A = mkA "vasomotorisk" ;
  vass_av_1_A = mkA "vass" ;
  vasslig_av_1_A = mkA "vasslig" ;
  vatikansk_av_1_A = mkA "vatikansk" ;
  vattenavstoetande_av_1_1_A = mkA "vattenavstötande" ;
  vattenavvisande_av_1_A = mkA "vattenavvisande" ;
  vattendrivande_av_1_A = mkA "vattendrivande" ;
  vattenkaenslig_av_1_1_A = mkA "vattenkänslig" ;
  vattenlevande_av_1_A = mkA "vattenlevande" ;
  vattenloeslig_av_1_1_A = mkA "vattenlöslig" ;
  vattensjuk_av_1_A = mkA "vattensjuk" ;
  vattentaet_av_1_1_A = mkA "vattentät" ;
  vattentaalig_av_1_1_A = mkA "vattentålig" ;
  vattnig_av_1_A = mkA "vattnig" ;
  vattrig_av_1_A = mkA "vattrig" ;
  vaxblek_av_1_A = mkA "vaxblek" ;
  vaxliknande_av_1_A = mkA "vaxliknande" ;
  ve_nn_1_N = mkN "ve" ;
  veckig_av_1_A = mkA "veckig" ;
  veckovill_av_1_A = mkA "veckovill" ;
  vederboerande_av_1_1_A = mkA "vederbörande" ;
  vederboerlig_av_1_1_A = mkA "vederbörlig" ;
  vederfaaende_nn_1_1_N = mkN "vederfående" ;
  vederhaeftig_av_1_1_A = mkA "vederhäftig" ;
  vederlaeggande_nn_1_1_N = mkN "vederläggande" ;
  vederstygglig_av_1_A = mkA "vederstygglig" ;
  vedervaerdig_av_1_1_A = mkA "vedervärdig" ;
  vedisk_av_1_A = mkA "vedisk" ;
  vedaemne_nn_1_1_N = mkN "vedämne" ;
  vegan_av_1_A = mkA "vegan" ;
  vegetabilisk_av_1_A = mkA "vegetabilisk" ;
  vegetariansk_av_1_A = mkA "vegetariansk" ;
  vegetarisk_av_1_A = mkA "vegetarisk" ;
  vegetationsloes_av_1_1_A = mkA "vegetationslös" ;
  vegetativ_av_1_A = mkA "vegetativ" ;
  vek_av_1_A = mkA "vek" ;
  veklig_av_1_A = mkA "veklig" ;
  velar_av_1_A = mkA "velar" ;
  velig_av_1_A = mkA "velig" ;
  velouriserbar_av_1_A = mkA "velouriserbar" ;
  vemodig_av_1_A = mkA "vemodig" ;
  vemodsfull_av_1_A = mkA "vemodsfull" ;
  vendisk_av_1_A = mkA "vendisk" ;
  venereologi_nn_1_N = mkN "venereologi" ;
  venereologisk_av_1_A = mkA "venereologisk" ;
  venerisk_av_1_A = mkA "venerisk" ;
  venetiansk_av_1_A = mkA "venetiansk" ;
  ventilerbar_av_1_A = mkA "ventilerbar" ;
  venoes_av_1_1_A = mkA "venös" ;
  verbal_av_1_A = mkA "verbal" ;
  verbaliserbar_av_1_A = mkA "verbaliserbar" ;
  verifierbar_av_1_A = mkA "verifierbar" ;
  verkhelig_av_1_A = mkA "verkhelig" ;
  verklig_av_1_A = mkA "verklig" ;
  verklighetsfraemmande_av_1_1_A = mkA "verklighetsfrämmande" ;
  verklighetsfraanvaend_av_1_1_A = mkA "verklighetsfrånvänd" ;
  verklighetsnaera_av_1_1_A = mkA "verklighetsnära" ;
  verkningsfull_av_1_A = mkA "verkningsfull" ;
  verkningsloes_av_1_1_A = mkA "verkningslös" ;
  verksamhetsmaessig_av_1_1_A = mkA "verksamhetsmässig" ;
  verkstaellande_av_1_1_A = mkA "verkställande" ;
  versatil_av_1_A = mkA "versatil" ;
  versifierbar_av_1_A = mkA "versifierbar" ;
  vertikal_av_1_A = mkA "vertikal" ;
  vestalisk_av_1_A = mkA "vestalisk" ;
  vesaell_av_1_1_A = mkA "vesäll" ;
  vetande_av_1_A = mkA "vetande" ;
  vetande_nn_1_N = mkN "vetande" ;
  vetbar_av_1_A = mkA "vetbar" ;
  vete_nn_1_N = mkN "vete" ;
  vetenskaplig_av_1_A = mkA "vetenskaplig" ;
  vetenskapshistoria_nn_1_N = mkN "vetenskapshistoria" ;
  vetenskapsteori_nn_1_N = mkN "vetenskapsteori" ;
  vetgirig_av_1_A = mkA "vetgirig" ;
  vettig_av_1_A = mkA "vettig" ;
  vettloes_av_1_1_A = mkA "vettlös" ;
  vettvillig_av_1_A = mkA "vettvillig" ;
  vibrationsdaempande_av_1_1_A = mkA "vibrationsdämpande" ;
  vice_av_1_A = mkA "vice" ;
  vickig_av_1_A = mkA "vickig" ;
  victoriansk_av_1_A = mkA "victoriansk" ;
  vidare_av_1_A = mkA "vidare" ;
  vidarerapporterande_nn_1_N = mkN "vidarerapporterande" ;
  vidbraend_av_1_1_A = mkA "vidbränd" ;
  vidimerbar_av_1_A = mkA "vidimerbar" ;
  vidlyftig_av_1_A = mkA "vidlyftig" ;
  vidrig_av_1_A = mkA "vidrig" ;
  vidskeplig_av_1_A = mkA "vidskeplig" ;
  vidstaaende_av_1_1_A = mkA "vidstående" ;
  vidunderlig_av_1_A = mkA "vidunderlig" ;
  vietnamesisk_av_1_A = mkA "vietnamesisk" ;
  vig_av_1_A = mkA "vig" ;
  vikarierande_av_1_A = mkA "vikarierande" ;
  vikingatida_av_1_A = mkA "vikingatida" ;
  viktig_av_1_A = mkA "viktig" ;
  viktloes_av_1_1_A = mkA "viktlös" ;
  viktmaessig_av_1_1_A = mkA "viktmässig" ;
  viktoriansk_av_1_A = mkA "viktoriansk" ;
  viljeloes_av_1_1_A = mkA "viljelös" ;
  viljemaessig_av_1_1_A = mkA "viljemässig" ;
  viljestark_av_1_A = mkA "viljestark" ;
  viljesvag_av_1_A = mkA "viljesvag" ;
  villabyggande_nn_1_N = mkN "villabyggande" ;
  villande_av_1_A = mkA "villande" ;
  villig_av_1_A = mkA "villig" ;
  villkorlig_av_1_A = mkA "villkorlig" ;
  villkorsloes_av_1_1_A = mkA "villkorslös" ;
  villraadig_av_1_1_A = mkA "villrådig" ;
  vilseledande_av_1_A = mkA "vilseledande" ;
  viltmaalskytte_nn_1_1_N = mkN "viltmålskytte" ;
  vimmelkantig_av_1_A = mkA "vimmelkantig" ;
  vimsig_av_1_A = mkA "vimsig" ;
  vind_av_1_A = mkA "vind" ;
  vindicerbar_av_1_A = mkA "vindicerbar" ;
  vindpollinerbar_av_1_A = mkA "vindpollinerbar" ;
  vindstilla_av_1_A = mkA "vindstilla" ;
  vindtaet_av_1_1_A = mkA "vindtät" ;
  vingklippande_nn_1_N = mkN "vingklippande" ;
  vinglig_av_1_A = mkA "vinglig" ;
  vingloes_av_1_1_A = mkA "vinglös" ;
  vinkelraet_av_1_1_A = mkA "vinkelrät" ;
  vinnande_av_1_A = mkA "vinnande" ;
  vinodlingskunnig_av_1_A = mkA "vinodlingskunnig" ;
  vinstbringande_av_1_A = mkA "vinstbringande" ;
  vinstdrivande_av_1_A = mkA "vinstdrivande" ;
  vinstgivande_av_1_A = mkA "vinstgivande" ;
  vinstintresse_nn_1_N = mkN "vinstintresse" ;
  vinstmaximerbar_av_1_A = mkA "vinstmaximerbar" ;
  vintercyklande_nn_1_N = mkN "vintercyklande" ;
  vintergroen_av_1_1_A = mkA "vintergrön" ;
  vinterhaerdig_av_1_1_A = mkA "vinterhärdig" ;
  vinterlig_av_1_A = mkA "vinterlig" ;
  vintrig_av_1_A = mkA "vintrig" ;
  vippig_av_1_A = mkA "vippig" ;
  viril_av_1_A = mkA "viril" ;
  virke_nn_1_N = mkN "virke" ;
  virologi_nn_1_N = mkN "virologi" ;
  virrig_av_1_A = mkA "virrig" ;
  virtuell_av_1_A = mkA "virtuell" ;
  virtuos_av_1_A = mkA "virtuos" ;
  virtuosmaessig_av_1_1_A = mkA "virtuosmässig" ;
  vis_av_1_A = mkA "vis" ;
  viserbar_av_1_A = mkA "viserbar" ;
  visionsloes_av_1_1_A = mkA "visionslös" ;
  visionaer_av_1_1_A = mkA "visionär" ;
  visiterbar_av_1_A = mkA "visiterbar" ;
  viskoes_av_1_1_A = mkA "viskös" ;
  vislig_av_1_A = mkA "vislig" ;
  vispig_av_1_A = mkA "vispig" ;
  viss_av_1_A = mkA "viss" ;
  vistande_nn_1_N = mkN "vistande" ;
  visualiserbar_av_1_A = mkA "visualiserbar" ;
  visuell_av_1_A = mkA "visuell" ;
  vit_av_1_A = mkA "vit" ;
  vitaktig_av_1_A = mkA "vitaktig" ;
  vital_av_1_A = mkA "vital" ;
  vitaliserbar_av_1_A = mkA "vitaliserbar" ;
  vitaminerbar_av_1_A = mkA "vitaminerbar" ;
  vitaminiserbar_av_1_A = mkA "vitaminiserbar" ;
  vitaminrik_av_1_A = mkA "vitaminrik" ;
  vitgloedande_av_1_1_A = mkA "vitglödande" ;
  vitgroen_av_1_1_A = mkA "vitgrön" ;
  vithaarig_av_1_1_A = mkA "vithårig" ;
  vitrysk_av_1_A = mkA "vitrysk" ;
  vitsig_av_1_A = mkA "vitsig" ;
  vittfamnande_av_1_A = mkA "vittfamnande" ;
  vittflygande_av_1_A = mkA "vittflygande" ;
  vittgaaende_av_1_1_A = mkA "vittgående" ;
  vittnesgill_av_1_A = mkA "vittnesgill" ;
  vittnespsykologi_nn_1_N = mkN "vittnespsykologi" ;
  vittomfattande_av_1_A = mkA "vittomfattande" ;
  vivipar_av_1_A = mkA "vivipar" ;
  vokal_av_1_A = mkA "vokal" ;
  vokaliserbar_av_1_A = mkA "vokaliserbar" ;
  vokalisk_av_1_A = mkA "vokalisk" ;
  volapuk_nn_1_1_N = mkN "volapük" ;
  volonterande_nn_1_N = mkN "volonterande" ;
  voluminoes_av_1_1_A = mkA "voluminös" ;
  volymmaessig_av_1_1_A = mkA "volymmässig" ;
  voyeuristisk_av_1_A = mkA "voyeuristisk" ;
  vrakvirke_nn_1_N = mkN "vrakvirke" ;
  vred_av_1_A = mkA "vred" ;
  vrensk_av_1_A = mkA "vrensk" ;
  vresig_av_1_A = mkA "vresig" ;
  vridbar_av_1_A = mkA "vridbar" ;
  vraekig_av_1_1_A = mkA "vräkig" ;
  vraang_av_1_1_A = mkA "vrång" ;
  vraangvis_av_1_1_A = mkA "vrångvis" ;
  vulgariserbar_av_1_A = mkA "vulgariserbar" ;
  vulgo_av_1_A = mkA "vulgo" ;
  vulgaer_av_1_1_A = mkA "vulgär" ;
  vulkaniserbar_av_1_A = mkA "vulkaniserbar" ;
  vulkanisk_av_1_A = mkA "vulkanisk" ;
  vulstig_av_1_A = mkA "vulstig" ;
  vuvuzelatutande_av_1_A = mkA "vuvuzelatutande" ;
  vuvuzelatutande_nn_1_N = mkN "vuvuzelatutande" ;
  vaeck_av_1_1_A = mkA "väck" ;
  vaederbestaendig_av_1_1_A = mkA "väderbeständig" ;
  vaederleksmaessig_av_1_1_A = mkA "väderleksmässig" ;
  vaederlaege_nn_1_1_N = mkN "väderläge" ;
  vaedermaessig_av_1_1_A = mkA "vädermässig" ;
  vaederspaend_av_1_1_A = mkA "väderspänd" ;
  vaeggmonterbar_av_1_1_A = mkA "väggmonterbar" ;
  vaegledande_av_1_1_A = mkA "vägledande" ;
  vaegslitage_nn_1_1_N = mkN "vägslitage" ;
  vaegvill_av_1_1_A = mkA "vägvill" ;
  vaegvinnande_av_1_1_A = mkA "vägvinnande" ;
  vael_nn_1_1_N = mkN "väl" ;
  vaelbefinnande_nn_1_1_N = mkN "välbefinnande" ;
  vaelbegriplig_av_1_1_A = mkA "välbegriplig" ;
  vaelbehaglig_av_1_1_A = mkA "välbehaglig" ;
  vaelbehoevlig_av_1_1_A = mkA "välbehövlig" ;
  vaeldig_av_1_1_A = mkA "väldig" ;
  vaeldoftande_av_1_1_A = mkA "väldoftande" ;
  vaelfungerande_av_1_1_A = mkA "välfungerande" ;
  vaelfoerenlig_av_1_1_A = mkA "välförenlig" ;
  vaelfoerhaallande_nn_1_1_N = mkN "välförhållande" ;
  vaelfoerklarlig_av_1_1_A = mkA "välförklarlig" ;
  vaelfoerstaaelig_av_1_1_A = mkA "välförståelig" ;
  vaelfoerstaandig_av_1_1_A = mkA "välförståndig" ;
  vaelgoerande_av_1_1_A = mkA "välgörande" ;
  vaelklingande_av_1_1_A = mkA "välklingande" ;
  vaelkomnande_nn_1_1_N = mkN "välkomnande" ;
  vaelkaend_av_1_1_A = mkA "välkänd" ;
  vaellingliknande_av_1_1_A = mkA "vällingliknande" ;
  vaelljudande_av_1_1_A = mkA "välljudande" ;
  vaellovlig_av_1_1_A = mkA "vällovlig" ;
  vaelluktande_av_1_1_A = mkA "välluktande" ;
  vaellustig_av_1_1_A = mkA "vällustig" ;
  vaelmenande_av_1_1_A = mkA "välmenande" ;
  vaelmaaende_av_1_1_A = mkA "välmående" ;
  vaelsignelsebringande_av_1_1_A = mkA "välsignelsebringande" ;
  vaelsittande_av_1_1_A = mkA "välsittande" ;
  vaelsk_av_1_1_A = mkA "välsk" ;
  vaelskjutande_av_1_1_A = mkA "välskjutande" ;
  vaelsmakande_av_1_1_A = mkA "välsmakande" ;
  vaeltalig_av_1_1_A = mkA "vältalig" ;
  vaelvillig_av_1_1_A = mkA "välvillig" ;
  vaelvis_av_1_1_A = mkA "välvis" ;
  vaemjelig_av_1_1_A = mkA "vämjelig" ;
  vaen_av_1_1_A = mkA "vän" ;
  vaendbar_av_1_1_A = mkA "vändbar" ;
  vaenlig_av_1_1_A = mkA "vänlig" ;
  vaenskaplig_av_1_1_A = mkA "vänskaplig" ;
  vaenskapsfull_av_1_1_A = mkA "vänskapsfull" ;
  vaenslande_nn_1_1_N = mkN "vänslande" ;
  vaensterextrem_av_1_1_A = mkA "vänsterextrem" ;
  vaensterextremistisk_av_1_1_A = mkA "vänsterextremistisk" ;
  vaensterradikal_av_1_1_A = mkA "vänsterradikal" ;
  vaenstersympatiserande_av_1_1_A = mkA "vänstersympatiserande" ;
  vaensaell_av_1_1_A = mkA "vänsäll" ;
  vaerdebestaendig_av_1_1_A = mkA "värdebeständig" ;
  vaerdefilosofi_nn_1_1_N = mkN "värdefilosofi" ;
  vaerdefull_av_1_1_A = mkA "värdefull" ;
  vaerdeloes_av_1_1_A = mkA "värdelös" ;
  vaerdemaessig_av_1_1_A = mkA "värdemässig" ;
  vaerderbar_av_1_1_A = mkA "värderbar" ;
  vaerderingsmaessig_av_1_1_A = mkA "värderingsmässig" ;
  vaerdeteori_nn_1_1_N = mkN "värdeteori" ;
  vaerdig_av_1_1_A = mkA "värdig" ;
  vaerdsomspaennande_av_1_1_A = mkA "värdsomspännande" ;
  vaerldsfientlig_av_1_1_A = mkA "världsfientlig" ;
  vaerldsfraemmande_av_1_1_A = mkA "världsfrämmande" ;
  vaerldsfraanvarande_av_1_1_A = mkA "världsfrånvarande" ;
  vaerldsfraanvaend_av_1_1_A = mkA "världsfrånvänd" ;
  vaerldshistoria_nn_1_1_N = mkN "världshistoria" ;
  vaerldshistorisk_av_1_1_A = mkA "världshistorisk" ;
  vaerldsklok_av_1_1_A = mkA "världsklok" ;
  vaerldskaend_av_1_1_A = mkA "världskänd" ;
  vaerldsledande_av_1_1_A = mkA "världsledande" ;
  vaerldslig_av_1_1_A = mkA "världslig" ;
  vaerldsmannamaessig_av_1_1_A = mkA "världsmannamässig" ;
  vaerldsmedvetande_nn_1_1_N = mkN "världsmedvetande" ;
  vaerldsomfattande_av_1_1_A = mkA "världsomfattande" ;
  vaerldsomspaennande_av_1_1_A = mkA "världsomspännande" ;
  vaerldsomstoertande_av_1_1_A = mkA "världsomstörtande" ;
  vaerldsomvaelvande_av_1_1_A = mkA "världsomvälvande" ;
  vaerldsrykte_nn_1_1_N = mkN "världsrykte" ;
  vaerldssamvete_nn_1_1_N = mkN "världssamvete" ;
  vaerldsvan_av_1_1_A = mkA "världsvan" ;
  vaerldsvis_av_1_1_A = mkA "världsvis" ;
  vaermebestaendig_av_1_1_A = mkA "värmebeständig" ;
  vaermeenergi_nn_1_1_N = mkN "värmeenergi" ;
  vaermefotograferbar_av_1_1_A = mkA "värmefotograferbar" ;
  vaermeisolerande_av_1_1_A = mkA "värmeisolerande" ;
  vaermeisolerbar_av_1_1_A = mkA "värmeisolerbar" ;
  vaermesteriliserbar_av_1_1_A = mkA "värmesteriliserbar" ;
  vaermeterapi_nn_1_1_N = mkN "värmeterapi" ;
  vaermetaalig_av_1_1_A = mkA "värmetålig" ;
  vaermevaerde_nn_1_1_N = mkN "värmevärde" ;
  vaermeaelskande_av_1_1_A = mkA "värmeälskande" ;
  vaermlaendsk_av_1_1_A = mkA "värmländsk" ;
  vaernloes_av_1_1_A = mkA "värnlös" ;
  vaernpliktig_av_1_1_A = mkA "värnpliktig" ;
  vaerpsjuk_av_1_1_A = mkA "värpsjuk" ;
  vaersta_av_1_1_A = mkA "värsta" ;
  vaesande_nn_1_1_N = mkN "väsande" ;
  vaesentlig_av_1_1_A = mkA "väsentlig" ;
  vaesterbottnisk_av_1_1_A = mkA "västerbottnisk" ;
  vaesterlaendsk_av_1_1_A = mkA "västerländsk" ;
  vaesteuropeisk_av_1_1_A = mkA "västeuropeisk" ;
  vaestgotisk_av_1_1_A = mkA "västgotisk" ;
  vaestgoetsk_av_1_1_A = mkA "västgötsk" ;
  vaestindisk_av_1_1_A = mkA "västindisk" ;
  vaestkritisk_av_1_1_A = mkA "västkritisk" ;
  vaestlig_av_1_1_A = mkA "västlig" ;
  vaestmanlaendsk_av_1_1_A = mkA "västmanländsk" ;
  vaestra_av_1_1_A = mkA "västra" ;
  vaestslavisk_av_1_1_A = mkA "västslavisk" ;
  vaestsvensk_av_1_1_A = mkA "västsvensk" ;
  vaesttysk_av_1_1_A = mkA "västtysk" ;
  vaete_nn_1_1_N = mkN "väte" ;
  vaetgasrik_av_1_1_A = mkA "vätgasrik" ;
  vaetskig_av_1_1_A = mkA "vätskig" ;
  vaexelvarm_av_1_1_A = mkA "växelvarm" ;
  vaexlande_av_1_1_A = mkA "växlande" ;
  vaexlingsrik_av_1_1_A = mkA "växlingsrik" ;
  vaextanatomi_nn_1_1_N = mkN "växtanatomi" ;
  vaextbiologi_nn_1_1_N = mkN "växtbiologi" ;
  vaextfysiologi_nn_1_1_N = mkN "växtfysiologi" ;
  vaextgeografi_nn_1_1_N = mkN "växtgeografi" ;
  vaexthaemmande_av_1_1_A = mkA "växthämmande" ;
  vaextkraftig_av_1_1_A = mkA "växtkraftig" ;
  vaextlig_av_1_1_A = mkA "växtlig" ;
  vaextrike_nn_1_1_N = mkN "växtrike" ;
  vaextsilke_nn_1_1_N = mkN "växtsilke" ;
  vaextaetande_av_1_1_A = mkA "växtätande" ;
  vaadlig_av_1_1_A = mkA "vådlig" ;
  vaagformig_av_1_1_A = mkA "vågformig" ;
  vaaghalsig_av_1_1_A = mkA "våghalsig" ;
  vaagig_av_1_1_A = mkA "vågig" ;
  vaagraet_av_1_1_A = mkA "vågrät" ;
  vaaldfoerande_nn_1_1_N = mkN "våldförande" ;
  vaaldsfoerhaerligande_nn_1_1_N = mkN "våldsförhärligande" ;
  vaaldspornografi_nn_1_1_N = mkN "våldspornografi" ;
  vaallande_nn_1_1_N = mkN "vållande" ;
  vaapig_av_1_1_A = mkA "våpig" ;
  vaardbehoevande_av_1_1_A = mkA "vårdbehövande" ;
  vaardberoende_av_1_1_A = mkA "vårdberoende" ;
  vaardintygsmaessig_av_1_1_A = mkA "vårdintygsmässig" ;
  vaardmaessig_av_1_1_A = mkA "vårdmässig" ;
  vaardsloes_av_1_1_A = mkA "vårdslös" ;
  vaargroen_av_1_1_A = mkA "vårgrön" ;
  vaarlig_av_1_1_A = mkA "vårlig" ;
  vaarstaedande_nn_1_1_N = mkN "vårstädande" ;
  vaartig_av_1_1_A = mkA "vårtig" ;
  vaarvete_nn_1_1_N = mkN "vårvete" ;
  vaat_av_1_1_A = mkA "våt" ;
  vaatstark_av_1_1_A = mkA "våtstark" ;
  vaatvarm_av_1_1_A = mkA "våtvarm" ;
  vaatvaermande_av_1_1_A = mkA "våtvärmande" ;
  voerdig_av_1_1_A = mkA "vördig" ;
  voerdnadsbjudande_av_1_1_A = mkA "vördnadsbjudande" ;
  voerdnadsfull_av_1_1_A = mkA "vördnadsfull" ;
  walesisk_av_1_A = mkA "walesisk" ;
  waterloo_nn_1_N = mkN "waterloo" ;
  wenlock_nn_1_N = mkN "wenlock" ;
  xenofobi_nn_1_N = mkN "xenofobi" ;
  xerografi_nn_1_N = mkN "xerografi" ;
  ylle_nn_1_N = mkN "ylle" ;
  ymnig_av_1_A = mkA "ymnig" ;
  ynka_av_1_A = mkA "ynka" ;
  ynklig_av_1_A = mkA "ynklig" ;
  ynnestfull_av_1_A = mkA "ynnestfull" ;
  yogande_nn_1_N = mkN "yogande" ;
  ypperlig_av_1_A = mkA "ypperlig" ;
  yppig_av_1_A = mkA "yppig" ;
  yr_av_1_A = mkA "yr" ;
  yrkesarbetande_av_1_A = mkA "yrkesarbetande" ;
  yrkesarbetande_nn_1_N = mkN "yrkesarbetande" ;
  yrkesetisk_av_1_A = mkA "yrkesetisk" ;
  yrkesfiske_nn_1_N = mkN "yrkesfiske" ;
  yrkesfoerberedande_av_1_1_A = mkA "yrkesförberedande" ;
  yrkesmaessig_av_1_1_A = mkA "yrkesmässig" ;
  yrkesskicklig_av_1_A = mkA "yrkesskicklig" ;
  ytaktiv_av_1_A = mkA "ytaktiv" ;
  ytlig_av_1_A = mkA "ytlig" ;
  ytmaessig_av_1_1_A = mkA "ytmässig" ;
  ytterlig_av_1_A = mkA "ytterlig" ;
  ytterligare_av_1_A = mkA "ytterligare" ;
  yttre_nn_1_N = mkN "yttre" ;
  yvig_av_1_A = mkA "yvig" ;
  yxne_nn_1_N = mkN "yxne" ;
  zairisk_av_1_A = mkA "zairisk" ;
  zambisk_av_1_A = mkA "zambisk" ;
  zigensk_av_1_A = mkA "zigensk" ;
  zimbabwisk_av_1_A = mkA "zimbabwisk" ;
  zinkblaende_nn_1_1_N = mkN "zinkblände" ;
  zinkgult_nn_1_N = mkN "zinkgult" ;
  zinkvitt_nn_1_N = mkN "zinkvitt" ;
  zonterapi_nn_1_N = mkN "zonterapi" ;
  zoofysiologi_nn_1_N = mkN "zoofysiologi" ;
  zoologi_nn_1_N = mkN "zoologi" ;
  zoologisk_av_1_A = mkA "zoologisk" ;
  zootomi_nn_1_N = mkN "zootomi" ;
  aecklig_av_1_1_A = mkA "äcklig" ;
  aedelmodig_av_1_1_A = mkA "ädelmodig" ;
  aegardemokrati_nn_1_1_N = mkN "ägardemokrati" ;
  aegarmaessig_av_1_1_A = mkA "ägarmässig" ;
  aeggliknande_av_1_1_A = mkA "äggliknande" ;
  aeggrund_av_1_1_A = mkA "äggrund" ;
  aeggsjuk_av_1_1_A = mkA "äggsjuk" ;
  aegig_av_1_1_A = mkA "ägig" ;
  aekta_av_1_1_A = mkA "äkta" ;
  aektenskaplig_av_1_1_A = mkA "äktenskaplig" ;
  aektenskapstycke_nn_1_1_N = mkN "äktenskapstycke" ;
  aektsvensk_av_1_1_A = mkA "äktsvensk" ;
  aelsklig_av_1_1_A = mkA "älsklig" ;
  aelskogskrank_av_1_1_A = mkA "älskogskrank" ;
  aembetsmannamaessig_av_1_1_A = mkA "ämbetsmannamässig" ;
  aembetsmaessig_av_1_1_A = mkA "ämbetsmässig" ;
  aemnesintegrerbar_av_1_1_A = mkA "ämnesintegrerbar" ;
  aemnesmaessig_av_1_1_A = mkA "ämnesmässig" ;
  aemnesoeverskridande_av_1_1_A = mkA "ämnesöverskridande" ;
  aendamaalsenlig_av_1_1_A = mkA "ändamålsenlig" ;
  aendamaalsloes_av_1_1_A = mkA "ändamålslös" ;
  aendlig_av_1_1_A = mkA "ändlig" ;
  aendloes_av_1_1_A = mkA "ändlös" ;
  aenglalik_av_1_1_A = mkA "änglalik" ;
  aengslig_av_1_1_A = mkA "ängslig" ;
  aeppelpraektig_av_1_1_A = mkA "äppelpräktig" ;
  aeppleliknande_av_1_1_A = mkA "äppleliknande" ;
  aerbar_av_1_1_A = mkA "ärbar" ;
  aeregirig_av_1_1_A = mkA "äregirig" ;
  aereloes_av_1_1_A = mkA "ärelös" ;
  aereroerig_av_1_1_A = mkA "ärerörig" ;
  aerevoerdig_av_1_1_A = mkA "ärevördig" ;
  aerftlig_av_1_1_A = mkA "ärftlig" ;
  aerggroen_av_1_1_A = mkA "ärggrön" ;
  aergig_av_1_1_A = mkA "ärgig" ;
  aerkebiskoplig_av_1_1_A = mkA "ärkebiskoplig" ;
  aerkekonservativ_av_1_1_A = mkA "ärkekonservativ" ;
  aerlig_av_1_1_A = mkA "ärlig" ;
  aermloes_av_1_1_A = mkA "ärmlös" ;
  aerofull_av_1_1_A = mkA "ärofull" ;
  aerorik_av_1_1_A = mkA "ärorik" ;
  aerrig_av_1_1_A = mkA "ärrig" ;
  aertgroen_av_1_1_A = mkA "ärtgrön" ;
  aertig_av_1_1_A = mkA "ärtig" ;
  aetbar_av_1_1_A = mkA "ätbar" ;
  aetlig_av_1_1_A = mkA "ätlig" ;
  aeventyrlig_av_1_1_A = mkA "äventyrlig" ;
  aabaekig_av_1_1_A = mkA "åbäkig" ;
  aabaeklig_av_1_1_A = mkA "åbäklig" ;
  aadrig_av_1_1_A = mkA "ådrig" ;
  aakmaessig_av_1_1_A = mkA "åkmässig" ;
  aaksjuk_av_1_1_A = mkA "åksjuk" ;
  aalderdomlig_av_1_1_A = mkA "ålderdomlig" ;
  aalderdomssvag_av_1_1_A = mkA "ålderdomssvag" ;
  aaldersmaessig_av_1_1_A = mkA "åldersmässig" ;
  aalderssvag_av_1_1_A = mkA "ålderssvag" ;
  aaldrande_nn_1_1_N = mkN "åldrande" ;
  aaldrig_av_1_1_A = mkA "åldrig" ;
  aalfiske_nn_1_1_N = mkN "ålfiske" ;
  aalaendsk_av_1_1_A = mkA "åländsk" ;
  aamig_av_1_1_A = mkA "åmig" ;
  aangerfull_av_1_1_A = mkA "ångerfull" ;
  aangermanlaendsk_av_1_1_A = mkA "ångermanländsk" ;
  aangestfull_av_1_1_A = mkA "ångestfull" ;
  aangestskapande_av_1_1_A = mkA "ångestskapande" ;
  aarlig_av_1_1_A = mkA "årlig" ;
  aarsbaesta_av_1_1_A = mkA "årsbästa" ;
  aasiktsmaessig_av_1_1_A = mkA "åsiktsmässig" ;
  aasiktsregistrerbar_av_1_1_A = mkA "åsiktsregistrerbar" ;
  aaskraedd_av_1_1_A = mkA "åskrädd" ;
  aaskaadlig_av_1_1_A = mkA "åskådlig" ;
  aaskaadningsmaessig_av_1_1_A = mkA "åskådningsmässig" ;
  aateranskaffningsvaerde_nn_1_1_N = mkN "återanskaffningsvärde" ;
  aaterinstallerbar_av_1_1_A = mkA "återinstallerbar" ;
  aaterinvesterande_nn_1_1_N = mkN "återinvesterande" ;
  aaterkommande_av_1_1_A = mkA "återkommande" ;
  aaterseende_nn_1_1_N = mkN "återseende" ;
  aaterupplevande_nn_1_1_N = mkN "återupplevande" ;
  aatkomlig_av_1_1_A = mkA "åtkomlig" ;
  aatloeje_nn_1_1_N = mkN "åtlöje" ;
  aatnjutande_nn_1_1_N = mkN "åtnjutande" ;
  aatsittande_av_1_1_A = mkA "åtsittande" ;
  aatskillnadsloes_av_1_1_A = mkA "åtskillnadslös" ;
  aatsmitande_av_1_1_A = mkA "åtsmitande" ;
  aattahoernig_av_1_1_A = mkA "åttahörnig" ;
  oede_av_1_1_A = mkA "öde" ;
  oedematoes_av_1_1_A = mkA "ödematös" ;
  oedmjuk_av_1_1_A = mkA "ödmjuk" ;
  oedslig_av_1_1_A = mkA "ödslig" ;
  oegonblicklig_av_1_1_A = mkA "ögonblicklig" ;
  oegonskenlig_av_1_1_A = mkA "ögonskenlig" ;
  oekaend_av_1_1_A = mkA "ökänd" ;
  oeldrickande_av_1_1_A = mkA "öldrickande" ;
  oeldrickande_nn_1_1_N = mkN "öldrickande" ;
  oelaendsk_av_1_1_A = mkA "öländsk" ;
  oemklig_av_1_1_A = mkA "ömklig" ;
  oemmande_av_1_1_A = mkA "ömmande" ;
  oemsesidig_av_1_1_A = mkA "ömsesidig" ;
  oemtaalig_av_1_1_A = mkA "ömtålig" ;
  oensketaenkande_nn_1_1_N = mkN "önsketänkande" ;
  oensklig_av_1_1_A = mkA "önsklig" ;
  oeppenhjaertig_av_1_1_A = mkA "öppenhjärtig" ;
  oeppenhjaertlig_av_1_1_A = mkA "öppenhjärtlig" ;
  oeppethaallande_nn_1_1_N = mkN "öppethållande" ;
  oeronbedoevande_av_1_1_A = mkA "öronbedövande" ;
  oertte_nn_1_1_N = mkN "örtte" ;
  oest_vaestlig_av_1_1_A = mkA "öst-västlig" ;
  oesterbottnisk_av_1_1_A = mkA "österbottnisk" ;
  oesterlaendsk_av_1_1_A = mkA "österländsk" ;
  oesterrikisk_av_1_1_A = mkA "österrikisk" ;
  oestersjoefiske_nn_1_1_N = mkN "östersjöfiske" ;
  oesteuropeisk_av_1_1_A = mkA "östeuropeisk" ;
  oestgotisk_av_1_1_A = mkA "östgotisk" ;
  oestgoetsk_av_1_1_A = mkA "östgötsk" ;
  oestlig_av_1_1_A = mkA "östlig" ;
  oestra_av_1_1_A = mkA "östra" ;
  oesttysk_av_1_1_A = mkA "östtysk" ;
  oeveraktiv_av_1_1_A = mkA "överaktiv" ;
  oeverambitioes_av_1_1_A = mkA "överambitiös" ;
  oeverbelastande_nn_1_1_N = mkN "överbelastande" ;
  oeverbelaeggande_nn_1_1_N = mkN "överbeläggande" ;
  oeverbeskyddande_nn_1_1_N = mkN "överbeskyddande" ;
  oeverbetonande_nn_1_1_N = mkN "överbetonande" ;
  oeverblickbar_av_1_1_A = mkA "överblickbar" ;
  oeverdebiterande_nn_1_1_N = mkN "överdebiterande" ;
  oeverdimensionerbar_av_1_1_A = mkA "överdimensionerbar" ;
  oeverdoserbar_av_1_1_A = mkA "överdoserbar" ;
  oeverdaadig_av_1_1_A = mkA "överdådig" ;
  oeverens_av_1_1_A = mkA "överens" ;
  oeverexponerbar_av_1_1_A = mkA "överexponerbar" ;
  oeverfiske_nn_1_1_N = mkN "överfiske" ;
  oeverfloedig_av_1_1_A = mkA "överflödig" ;
  oeverfull_av_1_1_A = mkA "överfull" ;
  oevergripande_av_1_1_A = mkA "övergripande" ;
  oevergaaende_av_1_1_A = mkA "övergående" ;
  oeverhetlig_av_1_1_A = mkA "överhetlig" ;
  oeverhaengande_av_1_1_A = mkA "överhängande" ;
  oeverhaerdig_av_1_1_A = mkA "överhärdig" ;
  oeverinseende_nn_1_1_N = mkN "överinseende" ;
  oeverjordisk_av_1_1_A = mkA "överjordisk" ;
  oeverklassig_av_1_1_A = mkA "överklassig" ;
  oeverkomlig_av_1_1_A = mkA "överkomlig" ;
  oeverkompenserbar_av_1_1_A = mkA "överkompenserbar" ;
  oeverkaenslig_av_1_1_A = mkA "överkänslig" ;
  oeverlackerbar_av_1_1_A = mkA "överlackerbar" ;
  oeverlackeringsbar_av_1_1_A = mkA "överlackeringsbar" ;
  oeverlevande_av_1_1_A = mkA "överlevande" ;
  oeverlevnadsvaerde_nn_1_1_N = mkN "överlevnadsvärde" ;
  oeverliggande_av_1_1_A = mkA "överliggande" ;
  oeverloppsenergi_nn_1_1_N = mkN "överloppsenergi" ;
  oeverlutande_av_1_1_A = mkA "överlutande" ;
  oeverlycklig_av_1_1_A = mkA "överlycklig" ;
  oevermaga_av_1_1_A = mkA "övermaga" ;
  oevermodig_av_1_1_A = mkA "övermodig" ;
  oevermaektig_av_1_1_A = mkA "övermäktig" ;
  oevermaensklig_av_1_1_A = mkA "övermänsklig" ;
  oevermaalningsbar_av_1_1_A = mkA "övermålningsbar" ;
  oevernationell_av_1_1_A = mkA "övernationell" ;
  oevernaturlig_av_1_1_A = mkA "övernaturlig" ;
  oevernitisk_av_1_1_A = mkA "övernitisk" ;
  oeverraskande_av_1_1_A = mkA "överraskande" ;
  oeverseende_av_1_1_A = mkA "överseende" ;
  oeversiktlig_av_1_1_A = mkA "översiktlig" ;
  oeversinnlig_av_1_1_A = mkA "översinnlig" ;
  oeverskattande_nn_1_1_N = mkN "överskattande" ;
  oeverskjutande_av_1_1_A = mkA "överskjutande" ;
  oeverskaadlig_av_1_1_A = mkA "överskådlig" ;
  oeverslagsmaessig_av_1_1_A = mkA "överslagsmässig" ;
  oeverslaetande_av_1_1_A = mkA "överslätande" ;
  oeverspaend_av_1_1_A = mkA "överspänd" ;
  oeverstiglig_av_1_1_A = mkA "överstiglig" ;
  oeverstyr_av_1_1_A = mkA "överstyr" ;
  oeversvallande_av_1_1_A = mkA "översvallande" ;
  oeversvinnelig_av_1_1_A = mkA "översvinnelig" ;
  oeversvinnlig_av_1_1_A = mkA "översvinnlig" ;
  oevertalig_av_1_1_A = mkA "övertalig" ;
  oevertrasserbar_av_1_1_A = mkA "övertrasserbar" ;
  oevertydlig_av_1_1_A = mkA "övertydlig" ;
  oevertygande_av_1_1_A = mkA "övertygande" ;
  oevertaend_av_1_1_A = mkA "övertänd" ;
  oevervattenslaege_nn_1_1_N = mkN "övervattensläge" ;
  oeverviktig_av_1_1_A = mkA "överviktig" ;
  oevervaegande_av_1_1_A = mkA "övervägande" ;
  oevervaeldigande_av_1_1_A = mkA "överväldigande" ;
  oevervaerderbar_av_1_1_A = mkA "övervärderbar" ;
  oeveraarig_av_1_1_A = mkA "överårig" ;
  oeveroesande_nn_1_1_N = mkN "överösande" ;
  oevlig_av_1_1_A = mkA "övlig" ;
  isomer_av_1_A = mkA "isomer" "isomert" ;
  karcinogen_av_1_A = mkA "karcinogen" "karcinogent" ;
  klockren_av_1_A = mkA "klockren" "klockrent" ;
  kryogen_av_1_A = mkA "kryogen" "kryogent" ;
  linjeren_av_1_A = mkA "linjeren" "linjerent" ;
  mutagen_av_1_A = mkA "mutagen" "mutagent" ;
  navigabel_av_1_A = mkA "navigabel" "navigabelt" ;
  nervklen_av_1_A = mkA "nervklen" "nervklent" ;
  obscen_av_1_A = mkA "obscen" "obscent" ;
  ogemen_av_1_A = mkA "ogemen" "ogement" ;
  oresonabel_av_1_A = mkA "oresonabel" "oresonabelt" ;
  organogen_av_1_A = mkA "organogen" "organogent" ;
  oaedel_av_1_1_A = mkA "oädel" "oädelt" ;
  patogen_av_1_A = mkA "patogen" "patogent" ;
  perifer_av_1_A = mkA "perifer" "perifert" ;
  psykogen_av_1_A = mkA "psykogen" "psykogent" ;
  rasren_av_1_A = mkA "rasren" "rasrent" ;
  rumsren_av_1_A = mkA "rumsren" "rumsrent" ;
  sammetslen_av_1_A = mkA "sammetslen" "sammetslent" ;
  saprogen_av_1_A = mkA "saprogen" "saprogent" ;
  schangdobel_av_1_A = mkA "schangdobel" "schangdobelt" ;
  schizofren_av_1_A = mkA "schizofren" "schizofrent" ;
  seren_av_1_A = mkA "seren" "serent" ;
  silkeslen_av_1_A = mkA "silkeslen" "silkeslent" ;
  sirapslen_av_1_A = mkA "sirapslen" "sirapslent" ;
  sjukhusren_av_1_A = mkA "sjukhusren" "sjukhusrent" ;
  stilren_av_1_A = mkA "stilren" "stilrent" ;
  superlen_av_1_A = mkA "superlen" "superlent" ;
  terrigen_av_1_A = mkA "terrigen" "terrigent" ;
  transgen_av_1_A = mkA "transgen" "transgent" ;
  Kafkaesk_av_1_A = mkA "Kafkaesk" ;
  Kafkalik_av_1_A = mkA "Kafkalik" ;
  Moskvavaenlig_av_1_1_A = mkA "Moskvavänlig" ;
  Stockholmsmaessig_av_1_1_A = mkA "Stockholmsmässig" ;
  intonerbar_av_1_A = mkA "intonerbar" ;
  intransitiv_av_1_A = mkA "intransitiv" ;
  intravenoes_av_1_1_A = mkA "intravenös" ;
  intresseloes_av_1_1_A = mkA "intresselös" ;
  intressemaessig_av_1_1_A = mkA "intressemässig" ;
  intresserbar_av_1_A = mkA "intresserbar" ;
  intrigmaessig_av_1_1_A = mkA "intrigmässig" ;
  introducerbar_av_1_A = mkA "introducerbar" ;
  introspektiv_av_1_A = mkA "introspektiv" ;
  intuitiv_av_1_A = mkA "intuitiv" ;
  invaderbar_av_1_A = mkA "invaderbar" ;
  invalidiserbar_av_1_A = mkA "invalidiserbar" ;
  invandrarfientlig_av_1_A = mkA "invandrarfientlig" ;
  invandrartaet_av_1_1_A = mkA "invandrartät" ;
  invandringskritisk_av_1_A = mkA "invandringskritisk" ;
  inventerbar_av_1_A = mkA "inventerbar" ;
  inventioes_av_1_1_A = mkA "inventiös" ;
  inverterbar_av_1_A = mkA "inverterbar" ;
  investerbar_av_1_A = mkA "investerbar" ;
  inviterbar_av_1_A = mkA "inviterbar" ;
  involverbar_av_1_A = mkA "involverbar" ;
  invaendig_av_1_1_A = mkA "invändig" ;
  irakisk_av_1_A = mkA "irakisk" ;
  iransk_av_1_A = mkA "iransk" ;
  irisk_av_1_A = mkA "irisk" ;
  irlaendsk_av_1_1_A = mkA "irländsk" ;
  ironisk_av_1_A = mkA "ironisk" ;
  irrationell_av_1_A = mkA "irrationell" ;
  irreal_av_1_A = mkA "irreal" ;
  irreell_av_1_A = mkA "irreell" ;
  irreguljaer_av_1_1_A = mkA "irreguljär" ;
  irriterbar_av_1_A = mkA "irriterbar" ;
  irrlaerig_av_1_1_A = mkA "irrlärig" ;
  isagogisk_av_1_A = mkA "isagogisk" ;
  ishal_av_1_A = mkA "ishal" ;
  ishockeymaessig_av_1_1_A = mkA "ishockeymässig" ;
  isig_av_1_A = mkA "isig" ;
  iskall_av_1_A = mkA "iskall" ;
  islamiserbar_av_1_A = mkA "islamiserbar" ;
  islamisk_av_1_A = mkA "islamisk" ;
  islamistisk_av_1_A = mkA "islamistisk" ;
  islamsk_av_1_A = mkA "islamsk" ;
  islaendsk_av_1_1_A = mkA "isländsk" ;
  isolationistisk_av_1_A = mkA "isolationistisk" ;
  isolerbar_av_1_A = mkA "isolerbar" ;
  isomorf_av_1_A = mkA "isomorf" ;
  israelisk_av_1_A = mkA "israelisk" ;
  israelitisk_av_1_A = mkA "israelitisk" ;
  istadig_av_1_A = mkA "istadig" ;
  italiensk_av_1_A = mkA "italiensk" ;
  italisk_av_1_A = mkA "italisk" ;
  iterativ_av_1_A = mkA "iterativ" ;
  itererbar_av_1_A = mkA "itererbar" ;
  ivoriansk_av_1_A = mkA "ivoriansk" ;
  ivrig_av_1_A = mkA "ivrig" ;
  jackig_av_1_A = mkA "jackig" ;
  jadegroen_av_1_1_A = mkA "jadegrön" ;
  jagisk_av_1_A = mkA "jagisk" ;
  jaktbar_av_1_A = mkA "jaktbar" ;
  jaktlig_av_1_A = mkA "jaktlig" ;
  jamaicansk_av_1_A = mkA "jamaicansk" ;
  jamaikansk_av_1_A = mkA "jamaikansk" ;
  jambisk_av_1_A = mkA "jambisk" ;
  japansk_av_1_A = mkA "japansk" ;
  jargongmaessig_av_1_1_A = mkA "jargongmässig" ;
  javanesisk_av_1_A = mkA "javanesisk" ;
  javansk_av_1_A = mkA "javansk" ;
  jazzifierbar_av_1_A = mkA "jazzifierbar" ;
  jazzig_av_1_A = mkA "jazzig" ;
  jazzmaessig_av_1_1_A = mkA "jazzmässig" ;
  jemenitisk_av_1_A = mkA "jemenitisk" ;
  jesuitisk_av_1_A = mkA "jesuitisk" ;
  jobbig_av_1_A = mkA "jobbig" ;
  joderbar_av_1_A = mkA "joderbar" ;
  jolmig_av_1_A = mkA "jolmig" ;
  jonglerbar_av_1_A = mkA "jonglerbar" ;
  joniserbar_av_1_A = mkA "joniserbar" ;
  jonisk_av_1_A = mkA "jonisk" ;
  jordansk_av_1_A = mkA "jordansk" ;
  jordbruksmaessig_av_1_1_A = mkA "jordbruksmässig" ;
  jordig_av_1_A = mkA "jordig" ;
  jordisk_av_1_A = mkA "jordisk" ;
  jordlik_av_1_A = mkA "jordlik" ;
  journalistisk_av_1_A = mkA "journalistisk" ;
  jovial_av_1_A = mkA "jovial" ;
  jovialisk_av_1_A = mkA "jovialisk" ;
  joxig_av_1_A = mkA "joxig" ;
  judiciell_av_1_A = mkA "judiciell" ;
  judisk_av_1_A = mkA "judisk" ;
  jugoslavisk_av_1_A = mkA "jugoslavisk" ;
  juliansk_av_1_A = mkA "juliansk" ;
  julledig_av_1_A = mkA "julledig" ;
  jungfrulig_av_1_A = mkA "jungfrulig" ;
  junior_av_1_A = mkA "junior" ;
  juniormaessig_av_1_1_A = mkA "juniormässig" ;
  junonisk_av_1_A = mkA "junonisk" ;
  juridisk_av_1_A = mkA "juridisk" ;
  jutlaendsk_av_1_1_A = mkA "jutländsk" ;
  jutsk_av_1_A = mkA "jutsk" ;
  juvenil_av_1_A = mkA "juvenil" ;
  jyllaendsk_av_1_1_A = mkA "jylländsk" ;
  jaeklig_av_1_1_A = mkA "jäklig" ;
  jaektig_av_1_1_A = mkA "jäktig" ;
  jaemboerdig_av_1_1_A = mkA "jämbördig" ;
  jaemfoerbar_av_1_1_A = mkA "jämförbar" ;
  jaemfoerlig_av_1_1_A = mkA "jämförlig" ;
  jaemlik_av_1_1_A = mkA "jämlik" ;
  jaemmerfull_av_1_1_A = mkA "jämmerfull" ;
  jaemmerlig_av_1_1_A = mkA "jämmerlig" ;
  jaemn_av_1_1_A = mkA "jämn" ;
  jaemnboerdig_av_1_1_A = mkA "jämnbördig" ;
  jaemnstark_av_1_1_A = mkA "jämnstark" ;
  jaemnstor_av_1_1_A = mkA "jämnstor" ;
  jaemntjock_av_1_1_A = mkA "jämntjock" ;
  jaemnvarm_av_1_1_A = mkA "jämnvarm" ;
  jaemstark_av_1_1_A = mkA "jämstark" ;
  jaemtjock_av_1_1_A = mkA "jämtjock" ;
  jaemtlaendsk_av_1_1_A = mkA "jämtländsk" ;
  jaemtsk_av_1_1_A = mkA "jämtsk" ;
  jaernrik_av_1_1_A = mkA "järnrik" ;
  jaesig_av_1_1_A = mkA "jäsig" ;
  jaettedyr_av_1_1_A = mkA "jättedyr" ;
  jaettekaer_av_1_1_A = mkA "jättekär" ;
  jaettelik_av_1_1_A = mkA "jättelik" ;
  jaettesnygg_av_1_1_A = mkA "jättesnygg" ;
  jaettesnaell_av_1_1_A = mkA "jättesnäll" ;
  jaevelsk_av_1_1_A = mkA "jävelsk" ;
  jaevig_av_1_1_A = mkA "jävig" ;
  jaevlig_av_1_1_A = mkA "jävlig" ;
  jaevulsk_av_1_1_A = mkA "jävulsk" ;
  joensig_av_1_1_A = mkA "jönsig" ;
  kabylisk_av_1_A = mkA "kabylisk" ;
  kadmiumgul_av_1_A = mkA "kadmiumgul" ;
  kaffebrun_av_1_A = mkA "kaffebrun" ;
  kafkaesk_av_1_A = mkA "kafkaesk" ;
  kafkalik_av_1_A = mkA "kafkalik" ;
  kakuminal_av_1_A = mkA "kakuminal" ;
  kal_av_1_A = mkA "kal" ;
  kalandrerbar_av_1_A = mkA "kalandrerbar" ;
  kalcinerbar_av_1_A = mkA "kalcinerbar" ;
  kaledonisk_av_1_A = mkA "kaledonisk" ;
  kaleidoskopisk_av_1_A = mkA "kaleidoskopisk" ;
  kalejdoskopisk_av_1_A = mkA "kalejdoskopisk" ;
  kalendarisk_av_1_A = mkA "kalendarisk" ;
  kalibrerbar_av_1_A = mkA "kalibrerbar" ;
  kalifornisk_av_1_A = mkA "kalifornisk" ;
  kalkerbar_av_1_A = mkA "kalkerbar" ;
  kalkfattig_av_1_A = mkA "kalkfattig" ;
  kalkhaltig_av_1_A = mkA "kalkhaltig" ;
  kalkonmaessig_av_1_1_A = mkA "kalkonmässig" ;
  kalkrik_av_1_A = mkA "kalkrik" ;
  kalkvattenbestaendig_av_1_1_A = mkA "kalkvattenbeständig" ;
  kalkvit_av_1_A = mkA "kalkvit" ;
  kalkylerbar_av_1_A = mkA "kalkylerbar" ;
  kalkylmaessig_av_1_1_A = mkA "kalkylmässig" ;
  kall_av_1_A = mkA "kall" ;
  kallblodig_av_1_A = mkA "kallblodig" ;
  kallsinnig_av_1_A = mkA "kallsinnig" ;
  kalmerbar_av_1_A = mkA "kalmerbar" ;
  kalorifattig_av_1_A = mkA "kalorifattig" ;
  kaloririk_av_1_A = mkA "kaloririk" ;
  kalstammig_av_1_A = mkA "kalstammig" ;
  kalvfaerdig_av_1_1_A = mkA "kalvfärdig" ;
  kalvinistisk_av_1_A = mkA "kalvinistisk" ;
  kalvinsk_av_1_A = mkA "kalvinsk" ;
  kambrisk_av_1_A = mkA "kambrisk" ;
  kameleontisk_av_1_A = mkA "kameleontisk" ;
  kameral_av_1_A = mkA "kameral" ;
  kamerunsk_av_1_A = mkA "kamerunsk" ;
  kamouflerbar_av_1_A = mkA "kamouflerbar" ;
  kampucheansk_av_1_A = mkA "kampucheansk" ;
  kamratlig_av_1_A = mkA "kamratlig" ;
  kamrermaessig_av_1_1_A = mkA "kamrermässig" ;
  kanadensisk_av_1_A = mkA "kanadensisk" ;
  kanaliserbar_av_1_A = mkA "kanaliserbar" ;
  kanariegul_av_1_A = mkA "kanariegul" ;
  kanderbar_av_1_A = mkA "kanderbar" ;
  kandiderbar_av_1_A = mkA "kandiderbar" ;
  kanelbrun_av_1_A = mkA "kanelbrun" ;
  kannelerbar_av_1_A = mkA "kannelerbar" ;
  kannibalisk_av_1_A = mkA "kannibalisk" ;
  kanoniserbar_av_1_A = mkA "kanoniserbar" ;
  kanonisk_av_1_A = mkA "kanonisk" ;
  kanslimaessig_av_1_1_A = mkA "kanslimässig" ;
  kantig_av_1_A = mkA "kantig" ;
  kaotisk_av_1_A = mkA "kaotisk" ;
  kapillaer_av_1_1_A = mkA "kapillär" ;
  kapital_av_1_A = mkA "kapital" ;
  kapitalintensiv_av_1_A = mkA "kapitalintensiv" ;
  kapitaliserbar_av_1_A = mkA "kapitaliserbar" ;
  kapitalistisk_av_1_A = mkA "kapitalistisk" ;
  kapitalmaessig_av_1_1_A = mkA "kapitalmässig" ;
  kapprak_av_1_A = mkA "kapprak" ;
  kapricioes_av_1_1_A = mkA "kapriciös" ;
  kapverdisk_av_1_A = mkA "kapverdisk" ;
  karakteriserbar_av_1_A = mkA "karakteriserbar" ;
  karakteristisk_av_1_A = mkA "karakteristisk" ;
  karaktaeriserbar_av_1_1_A = mkA "karaktäriserbar" ;
  karaktaeristisk_av_1_1_A = mkA "karaktäristisk" ;
  karaktaersmaessig_av_1_1_A = mkA "karaktärsmässig" ;
  karaktaersstark_av_1_1_A = mkA "karaktärsstark" ;
  karambolerbar_av_1_A = mkA "karambolerbar" ;
  karboniserbar_av_1_A = mkA "karboniserbar" ;
  kardansk_av_1_A = mkA "kardansk" ;
  karelsk_av_1_A = mkA "karelsk" ;
  karg_av_1_A = mkA "karg" ;
  karikatyrmaessig_av_1_1_A = mkA "karikatyrmässig" ;
  karikerbar_av_1_A = mkA "karikerbar" ;
  karismatisk_av_1_A = mkA "karismatisk" ;
  karlaktig_av_1_A = mkA "karlaktig" ;
  karltokig_av_1_A = mkA "karltokig" ;
  karolinsk_av_1_A = mkA "karolinsk" ;
  karriaermaessig_av_1_1_A = mkA "karriärmässig" ;
  karsk_av_1_A = mkA "karsk" ;
  kartagisk_av_1_A = mkA "kartagisk" ;
  kartellmaessig_av_1_1_A = mkA "kartellmässig" ;
  karterbar_av_1_A = mkA "karterbar" ;
  kartig_av_1_A = mkA "kartig" ;
  kartonnerbar_av_1_A = mkA "kartonnerbar" ;
  kass_av_1_A = mkA "kass" ;
  kassamaessig_av_1_1_A = mkA "kassamässig" ;
  kasserbar_av_1_A = mkA "kasserbar" ;
  kastiliansk_av_1_A = mkA "kastiliansk" ;
  kastloes_av_1_1_A = mkA "kastlös" ;
  kastrerbar_av_1_A = mkA "kastrerbar" ;
  kasuell_av_1_A = mkA "kasuell" ;
  katabatisk_av_1_A = mkA "katabatisk" ;
  kataforisk_av_1_A = mkA "kataforisk" ;
  katalansk_av_1_A = mkA "katalansk" ;
  katalektisk_av_1_A = mkA "katalektisk" ;
  katalogiserbar_av_1_A = mkA "katalogiserbar" ;
  katalyserbar_av_1_A = mkA "katalyserbar" ;
  katalytisk_av_1_A = mkA "katalytisk" ;
  katastrofal_av_1_A = mkA "katastrofal" ;
  kategoriserbar_av_1_A = mkA "kategoriserbar" ;
  kategorisk_av_1_A = mkA "kategorisk" ;
  kateketisk_av_1_A = mkA "kateketisk" ;
  kateteriserbar_av_1_A = mkA "kateteriserbar" ;
  katetriserbar_av_1_A = mkA "katetriserbar" ;
  katig_av_1_A = mkA "katig" ;
  katolsk_av_1_A = mkA "katolsk" ;
  kattaktig_av_1_A = mkA "kattaktig" ;
  kaukasisk_av_1_A = mkA "kaukasisk" ;
  kausal_av_1_A = mkA "kausal" ;
  kausativ_av_1_A = mkA "kausativ" ;
  kaustik_av_1_A = mkA "kaustik" ;
  kauteriserbar_av_1_A = mkA "kauteriserbar" ;
  kaxig_av_1_A = mkA "kaxig" ;
  kazakisk_av_1_A = mkA "kazakisk" ;
  keff_av_1_A = mkA "keff" ;
  kejserlig_av_1_A = mkA "kejserlig" ;
  kelig_av_1_A = mkA "kelig" ;
  kelsjuk_av_1_A = mkA "kelsjuk" ;
  keltisk_av_1_A = mkA "keltisk" ;
  kemisk_av_1_A = mkA "kemisk" ;
  kenyansk_av_1_A = mkA "kenyansk" ;
  khakigroen_av_1_1_A = mkA "khakigrön" ;
  killig_av_1_A = mkA "killig" ;
  kilometertjock_av_1_A = mkA "kilometertjock" ;
  kinesisk_av_1_A = mkA "kinesisk" ;
  kinestetisk_av_1_A = mkA "kinestetisk" ;
  kinetisk_av_1_A = mkA "kinetisk" ;
  kinkig_av_1_A = mkA "kinkig" ;
  kiribatisk_av_1_A = mkA "kiribatisk" ;
  kirurgisk_av_1_A = mkA "kirurgisk" ;
  kissnoedig_av_1_1_A = mkA "kissnödig" ;
  kitslig_av_1_A = mkA "kitslig" ;
  kittlig_av_1_A = mkA "kittlig" ;
  kladdig_av_1_A = mkA "kladdig" ;
  klangfull_av_1_A = mkA "klangfull" ;
  klanglig_av_1_A = mkA "klanglig" ;
  klangloes_av_1_1_A = mkA "klanglös" ;
  klangmaessig_av_1_1_A = mkA "klangmässig" ;
  klangrik_av_1_A = mkA "klangrik" ;
  klanmaessig_av_1_1_A = mkA "klanmässig" ;
  klantig_av_1_A = mkA "klantig" ;
  klar_av_1_A = mkA "klar" ;
  klarerbar_av_1_A = mkA "klarerbar" ;
  klargul_av_1_A = mkA "klargul" ;
  klassificerbar_av_1_A = mkA "klassificerbar" ;
  klassisk_av_1_A = mkA "klassisk" ;
  klassloes_av_1_1_A = mkA "klasslös" ;
  klassmaessig_av_1_1_A = mkA "klassmässig" ;
  klatschig_av_1_A = mkA "klatschig" ;
  klemig_av_1_A = mkA "klemig" ;
  klen_av_1_A = mkA "klen" ;
  klenmodig_av_1_A = mkA "klenmodig" ;
  klerikal_av_1_A = mkA "klerikal" ;
  kletig_av_1_A = mkA "kletig" ;
  klibbig_av_1_A = mkA "klibbig" ;
  klich_emaessig_av_1_1_A = mkA "klichémässig" ;
  klimatmaessig_av_1_1_A = mkA "klimatmässig" ;
  klimatologisk_av_1_A = mkA "klimatologisk" ;
  klinisk_av_1_A = mkA "klinisk" ;
  klippig_av_1_A = mkA "klippig" ;
  klipsk_av_1_A = mkA "klipsk" ;
  klistrig_av_1_A = mkA "klistrig" ;
  klockformig_av_1_A = mkA "klockformig" ;
  klok_av_1_A = mkA "klok" ;
  klorerbar_av_1_A = mkA "klorerbar" ;
  klossig_av_1_A = mkA "klossig" ;
  klosterlig_av_1_A = mkA "klosterlig" ;
  klottrig_av_1_A = mkA "klottrig" ;
  klumpig_av_1_A = mkA "klumpig" ;
  klunsig_av_1_A = mkA "klunsig" ;
  klurig_av_1_A = mkA "klurig" ;
  klyftig_av_1_A = mkA "klyftig" ;
  klyschig_av_1_A = mkA "klyschig" ;
  klyvbar_av_1_A = mkA "klyvbar" ;
  klaedesmaessig_av_1_1_A = mkA "klädesmässig" ;
  klaemmig_av_1_1_A = mkA "klämmig" ;
  klaengig_av_1_1_A = mkA "klängig" ;
  klaafingrig_av_1_1_A = mkA "klåfingrig" ;
  knackig_av_1_A = mkA "knackig" ;
  knagglig_av_1_A = mkA "knagglig" ;
  knal_av_1_A = mkA "knal" ;
  knapp_av_1_A = mkA "knapp" ;
  knapphaendig_av_1_1_A = mkA "knapphändig" ;
  knaprig_av_1_A = mkA "knaprig" ;
  knarrig_av_1_A = mkA "knarrig" ;
  knasig_av_1_A = mkA "knasig" ;
  knasprig_av_1_A = mkA "knasprig" ;
  knastrig_av_1_A = mkA "knastrig" ;
  knepig_av_1_A = mkA "knepig" ;
  knipslug_av_1_A = mkA "knipslug" ;
  knivbladslik_av_1_A = mkA "knivbladslik" ;
  knivig_av_1_A = mkA "knivig" ;
  knivskarp_av_1_A = mkA "knivskarp" ;
  knoddaen_av_1_1_A = mkA "knoddän" ;
  knogig_av_1_A = mkA "knogig" ;
  knollrig_av_1_A = mkA "knollrig" ;
  knoppig_av_1_A = mkA "knoppig" ;
  knotig_av_1_A = mkA "knotig" ;
  knottrig_av_1_A = mkA "knottrig" ;
  knubbig_av_1_A = mkA "knubbig" ;
  knusslig_av_1_A = mkA "knusslig" ;
  knutig_av_1_A = mkA "knutig" ;
  knyckig_av_1_A = mkA "knyckig" ;
  knaehoeg_av_1_1_A = mkA "knähög" ;
  knaelaang_av_1_1_A = mkA "knälång" ;
  knaepp_av_1_1_A = mkA "knäpp" ;
  knaesvag_av_1_1_A = mkA "knäsvag" ;
  knoekfull_av_1_1_A = mkA "knökfull" ;
  knoelaktig_av_1_1_A = mkA "knölaktig" ;
  knoelig_av_1_1_A = mkA "knölig" ;
  koafferbar_av_1_A = mkA "koafferbar" ;
  koagulerbar_av_1_A = mkA "koagulerbar" ;
  kobolthaltig_av_1_A = mkA "kobolthaltig" ;
  kodifierbar_av_1_A = mkA "kodifierbar" ;
  kognatisk_av_1_A = mkA "kognatisk" ;
  kognitiv_av_1_A = mkA "kognitiv" ;
  kokhet_av_1_A = mkA "kokhet" ;
  kolerisk_av_1_A = mkA "kolerisk" ;
  kolhaltig_av_1_A = mkA "kolhaltig" ;
  kollationerbar_av_1_A = mkA "kollationerbar" ;
  kollegial_av_1_A = mkA "kollegial" ;
  kollektiv_av_1_A = mkA "kollektiv" ;
  kollektiviserbar_av_1_A = mkA "kollektiviserbar" ;
  kolloidal_av_1_A = mkA "kolloidal" ;
  kollrig_av_1_A = mkA "kollrig" ;
  kolmoerk_av_1_1_A = mkA "kolmörk" ;
  kolonial_av_1_A = mkA "kolonial" ;
  koloniserbar_av_1_A = mkA "koloniserbar" ;
  kolorerbar_av_1_A = mkA "kolorerbar" ;
  kolossal_av_1_A = mkA "kolossal" ;
  kolportagemaessig_av_1_1_A = mkA "kolportagemässig" ;
  kolporterbar_av_1_A = mkA "kolporterbar" ;
  kolugn_av_1_A = mkA "kolugn" ;
  komatoes_av_1_1_A = mkA "komatös" ;
  kombinatorisk_av_1_A = mkA "kombinatorisk" ;
  kombinerbar_av_1_A = mkA "kombinerbar" ;
  komisk_av_1_A = mkA "komisk" ;
  kommaterbar_av_1_A = mkA "kommaterbar" ;
  kommenderbar_av_1_A = mkA "kommenderbar" ;
  kommenterbar_av_1_A = mkA "kommenterbar" ;
  kommersialiserbar_av_1_A = mkA "kommersialiserbar" ;
  kommersiell_av_1_A = mkA "kommersiell" ;
  kommunal_av_1_A = mkA "kommunal" ;
  kommunaliserbar_av_1_A = mkA "kommunaliserbar" ;
  kommunalpolitisk_av_1_A = mkA "kommunalpolitisk" ;
  kommunicerbar_av_1_A = mkA "kommunicerbar" ;
  kommunikationsmaessig_av_1_1_A = mkA "kommunikationsmässig" ;
  kommunikativ_av_1_A = mkA "kommunikativ" ;
  kommunistisk_av_1_A = mkA "kommunistisk" ;
  kommutativ_av_1_A = mkA "kommutativ" ;
  kommuterbar_av_1_A = mkA "kommuterbar" ;
  komorisk_av_1_A = mkA "komorisk" ;
  komparativ_av_1_A = mkA "komparativ" ;
  komparerbar_av_1_A = mkA "komparerbar" ;
  kompensatorisk_av_1_A = mkA "kompensatorisk" ;
  kompenserbar_av_1_A = mkA "kompenserbar" ;
  kompetensmaessig_av_1_1_A = mkA "kompetensmässig" ;
  kompilerbar_av_1_A = mkA "kompilerbar" ;
  kompledig_av_1_A = mkA "kompledig" ;
  komplementaer_av_1_1_A = mkA "komplementär" ;
  kompletterbar_av_1_A = mkA "kompletterbar" ;
  komplex_av_1_A = mkA "komplex" ;
  komplexig_av_1_A = mkA "komplexig" ;
  komplicerbar_av_1_A = mkA "komplicerbar" ;
  komplimenterbar_av_1_A = mkA "komplimenterbar" ;
  komponerbar_av_1_A = mkA "komponerbar" ;
  komposterbar_av_1_A = mkA "komposterbar" ;
  komposteringsbar_av_1_A = mkA "komposteringsbar" ;
  komprimerbar_av_1_A = mkA "komprimerbar" ;
  komprometterbar_av_1_A = mkA "komprometterbar" ;
  kompromissloes_av_1_1_A = mkA "kompromisslös" ;
  kompulsiv_av_1_A = mkA "kompulsiv" ;
  komputationell_av_1_A = mkA "komputationell" ;
  koncentrerbar_av_1_A = mkA "koncentrerbar" ;
  koncentrisk_av_1_A = mkA "koncentrisk" ;
  konceptiv_av_1_A = mkA "konceptiv" ;
  konceptuell_av_1_A = mkA "konceptuell" ;
  koncernmaessig_av_1_1_A = mkA "koncernmässig" ;
  koncessionerbar_av_1_A = mkA "koncessionerbar" ;
  koncessiv_av_1_A = mkA "koncessiv" ;
  koncipierbar_av_1_A = mkA "koncipierbar" ;
  koncis_av_1_A = mkA "koncis" ;
  kondemnerbar_av_1_A = mkA "kondemnerbar" ;
  kondenserbar_av_1_A = mkA "kondenserbar" ;
  konditional_av_1_A = mkA "konditional" ;
  konditionerbar_av_1_A = mkA "konditionerbar" ;
  konditionsmaessig_av_1_1_A = mkA "konditionsmässig" ;
  kondolerbar_av_1_A = mkA "kondolerbar" ;
  konfederal_av_1_A = mkA "konfederal" ;
  konfektionsmaessig_av_1_1_A = mkA "konfektionsmässig" ;
  konfessionell_av_1_A = mkA "konfessionell" ;
  konfessionsloes_av_1_1_A = mkA "konfessionslös" ;
  konfidentiell_av_1_A = mkA "konfidentiell" ;
  konfirmerbar_av_1_A = mkA "konfirmerbar" ;
  konfiskatorisk_av_1_A = mkA "konfiskatorisk" ;
  konfiskerbar_av_1_A = mkA "konfiskerbar" ;
  konform_av_1_A = mkA "konform" ;
  konformig_av_1_A = mkA "konformig" ;
  konfronterbar_av_1_A = mkA "konfronterbar" ;
  konfunderbar_av_1_A = mkA "konfunderbar" ;
  konfys_av_1_A = mkA "konfys" ;
  kongenial_av_1_A = mkA "kongenial" ;
  kongenital_av_1_A = mkA "kongenital" ;
  kongolesisk_av_1_A = mkA "kongolesisk" ;
  kongruerbar_av_1_A = mkA "kongruerbar" ;
  konisk_av_1_A = mkA "konisk" ;
  konjugerbar_av_1_A = mkA "konjugerbar" ;
  konjunkturmaessig_av_1_1_A = mkA "konjunkturmässig" ;
  konkav_av_1_A = mkA "konkav" ;
  konkavkonvex_av_1_A = mkA "konkavkonvex" ;
  konkluderbar_av_1_A = mkA "konkluderbar" ;
  konklusiv_av_1_A = mkA "konklusiv" ;
  konkretiserbar_av_1_A = mkA "konkretiserbar" ;
  konkurrensduglig_av_1_A = mkA "konkurrensduglig" ;
  konkurrenskraftig_av_1_A = mkA "konkurrenskraftig" ;
  konkurrensmaessig_av_1_1_A = mkA "konkurrensmässig" ;
  konkursmaessig_av_1_1_A = mkA "konkursmässig" ;
  konnotativ_av_1_A = mkA "konnotativ" ;
  konsekutiv_av_1_A = mkA "konsekutiv" ;
  konservativ_av_1_A = mkA "konservativ" ;
  konserverbar_av_1_A = mkA "konserverbar" ;
  konsignerbar_av_1_A = mkA "konsignerbar" ;
  konsistorial_av_1_A = mkA "konsistorial" ;
  konsoliderbar_av_1_A = mkA "konsoliderbar" ;
  konspirativ_av_1_A = mkA "konspirativ" ;
  konspiratorisk_av_1_A = mkA "konspiratorisk" ;
  konstaterbar_av_1_A = mkA "konstaterbar" ;
  konsternerbar_av_1_A = mkA "konsternerbar" ;
  konstfull_av_1_A = mkA "konstfull" ;
  konstfaerdig_av_1_1_A = mkA "konstfärdig" ;
  konsthantverksmaessig_av_1_1_A = mkA "konsthantverksmässig" ;
  konsthistorisk_av_1_A = mkA "konsthistorisk" ;
  konstifik_av_1_A = mkA "konstifik" ;
  konstig_av_1_A = mkA "konstig" ;
  konstituerbar_av_1_A = mkA "konstituerbar" ;
  konstitutionell_av_1_A = mkA "konstitutionell" ;
  konstitutiv_av_1_A = mkA "konstitutiv" ;
  konstloes_av_1_1_A = mkA "konstlös" ;
  konstmaessig_av_1_1_A = mkA "konstmässig" ;
  konstnaerlig_av_1_1_A = mkA "konstnärlig" ;
  konstnaerstaet_av_1_1_A = mkA "konstnärstät" ;
  konstrik_av_1_A = mkA "konstrik" ;
  konstruerbar_av_1_A = mkA "konstruerbar" ;
  konstruktionsmaessig_av_1_1_A = mkA "konstruktionsmässig" ;
  konstruktiv_av_1_A = mkA "konstruktiv" ;
  konstskicklig_av_1_A = mkA "konstskicklig" ;
  konsultativ_av_1_A = mkA "konsultativ" ;
  konsulterbar_av_1_A = mkA "konsulterbar" ;
  konsulaer_av_1_1_A = mkA "konsulär" ;
  konsumerbar_av_1_A = mkA "konsumerbar" ;
  kontagioes_av_1_1_A = mkA "kontagiös" ;
  kontaminerbar_av_1_A = mkA "kontaminerbar" ;
  kontemplativ_av_1_A = mkA "kontemplativ" ;
  konterbar_av_1_A = mkA "konterbar" ;
  kontinental_av_1_A = mkA "kontinental" ;
  kontingenterbar_av_1_A = mkA "kontingenterbar" ;
  kontinuerlig_av_1_A = mkA "kontinuerlig" ;
  kontoriserbar_av_1_A = mkA "kontoriserbar" ;
  kontorsmaessig_av_1_1_A = mkA "kontorsmässig" ;
  kontradiktorisk_av_1_A = mkA "kontradiktorisk" ;
  kontraherbar_av_1_A = mkA "kontraherbar" ;
  kontrakterbar_av_1_A = mkA "kontrakterbar" ;
  kontraktil_av_1_A = mkA "kontraktil" ;
  kontraktsenlig_av_1_A = mkA "kontraktsenlig" ;
  kontraktsmaessig_av_1_1_A = mkA "kontraktsmässig" ;
  kontraktsvidrig_av_1_A = mkA "kontraktsvidrig" ;
  kontramanderbar_av_1_A = mkA "kontramanderbar" ;
  kontraproduktiv_av_1_A = mkA "kontraproduktiv" ;
  kontrasignerbar_av_1_A = mkA "kontrasignerbar" ;
  kontrasterbar_av_1_A = mkA "kontrasterbar" ;
  kontribuerbar_av_1_A = mkA "kontribuerbar" ;
  kontrollerbar_av_1_A = mkA "kontrollerbar" ;
  kontroversiell_av_1_A = mkA "kontroversiell" ;
  kontraer_av_1_1_A = mkA "konträr" ;
  konturerbar_av_1_A = mkA "konturerbar" ;
  konturloes_av_1_1_A = mkA "konturlös" ;
  konturskarp_av_1_A = mkA "konturskarp" ;
  konungsk_av_1_A = mkA "konungsk" ;
  konungslig_av_1_A = mkA "konungslig" ;
  konventionell_av_1_A = mkA "konventionell" ;
  konvergerbar_av_1_A = mkA "konvergerbar" ;
  konverserbar_av_1_A = mkA "konverserbar" ;
  konversiv_av_1_A = mkA "konversiv" ;
  konverterbar_av_1_A = mkA "konverterbar" ;
  konvex_av_1_A = mkA "konvex" ;
  konvexkonkav_av_1_A = mkA "konvexkonkav" ;
  konvojerbar_av_1_A = mkA "konvojerbar" ;
  konvulsivisk_av_1_A = mkA "konvulsivisk" ;
  kooperativ_av_1_A = mkA "kooperativ" ;
  koordinerbar_av_1_A = mkA "koordinerbar" ;
  kopernikansk_av_1_A = mkA "kopernikansk" ;
  kopierbar_av_1_A = mkA "kopierbar" ;
  kopioes_av_1_1_A = mkA "kopiös" ;
  kopparbrun_av_1_A = mkA "kopparbrun" ;
  koppelvan_av_1_A = mkA "koppelvan" ;
  koppaerrig_av_1_1_A = mkA "koppärrig" ;
  koptisk_av_1_A = mkA "koptisk" ;
  kopulativ_av_1_A = mkA "kopulativ" ;
  kordial_av_1_A = mkA "kordial" ;
  koreansk_av_1_A = mkA "koreansk" ;
  koreografisk_av_1_A = mkA "koreografisk" ;
  korgblommig_av_1_A = mkA "korgblommig" ;
  korintisk_av_1_A = mkA "korintisk" ;
  korngul_av_1_A = mkA "korngul" ;
  kornig_av_1_A = mkA "kornig" ;
  korporativ_av_1_A = mkA "korporativ" ;
  korrelerbar_av_1_A = mkA "korrelerbar" ;
  korrigerbar_av_1_A = mkA "korrigerbar" ;
  korroderbar_av_1_A = mkA "korroderbar" ;
  korrugerbar_av_1_A = mkA "korrugerbar" ;
  korrumperbar_av_1_A = mkA "korrumperbar" ;
  korsblommig_av_1_A = mkA "korsblommig" ;
  korsetterbar_av_1_A = mkA "korsetterbar" ;
  korsikansk_av_1_A = mkA "korsikansk" ;
  korsordsmaessig_av_1_1_A = mkA "korsordsmässig" ;
  kortfristig_av_1_A = mkA "kortfristig" ;
  korthaarig_av_1_1_A = mkA "korthårig" ;
  kortpipig_av_1_A = mkA "kortpipig" ;
  kortsiktig_av_1_A = mkA "kortsiktig" ;
  kortskallig_av_1_A = mkA "kortskallig" ;
  kortvarig_av_1_A = mkA "kortvarig" ;
  korvig_av_1_A = mkA "korvig" ;
  kosmetisk_av_1_A = mkA "kosmetisk" ;
  kosmisk_av_1_A = mkA "kosmisk" ;
  kosmologisk_av_1_A = mkA "kosmologisk" ;
  kosmopolitisk_av_1_A = mkA "kosmopolitisk" ;
  kosovansk_av_1_A = mkA "kosovansk" ;
  kostbar_av_1_A = mkA "kostbar" ;
  kostlig_av_1_A = mkA "kostlig" ;
  kostnadseffektiv_av_1_A = mkA "kostnadseffektiv" ;
  kostnadsmaessig_av_1_1_A = mkA "kostnadsmässig" ;
  kostymerbar_av_1_A = mkA "kostymerbar" ;
  krackelerbar_av_1_A = mkA "krackelerbar" ;
  krafsig_av_1_A = mkA "krafsig" ;
  kraftfull_av_1_A = mkA "kraftfull" ;
  kraftig_av_1_A = mkA "kraftig" ;
  kraftloes_av_1_1_A = mkA "kraftlös" ;
  kragloes_av_1_1_A = mkA "kraglös" ;
  kram_av_1_A = mkA "kram" ;
  krampaktig_av_1_A = mkA "krampaktig" ;
  krank_av_1_A = mkA "krank" ;
  krass_av_1_A = mkA "krass" ;
  krasslig_av_1_A = mkA "krasslig" ;
  kravloes_av_1_1_A = mkA "kravlös" ;
  kreativ_av_1_A = mkA "kreativ" ;
  kreatursloes_av_1_1_A = mkA "kreaturslös" ;
  kreddig_av_1_A = mkA "kreddig" ;
  krediterbar_av_1_A = mkA "krediterbar" ;
  kreerbar_av_1_A = mkA "kreerbar" ;
  kremerbar_av_1_A = mkA "kremerbar" ;
  kremlvaenlig_av_1_1_A = mkA "kremlvänlig" ;
  kreperbar_av_1_A = mkA "kreperbar" ;
  kretensisk_av_1_A = mkA "kretensisk" ;
  kretisk_av_1_A = mkA "kretisk" ;
  kreverbar_av_1_A = mkA "kreverbar" ;
  krigisk_av_1_A = mkA "krigisk" ;
  krigsmaessig_av_1_1_A = mkA "krigsmässig" ;
  krigsplacerbar_av_1_A = mkA "krigsplacerbar" ;
  kriminaliserbar_av_1_A = mkA "kriminaliserbar" ;
  kriminell_av_1_A = mkA "kriminell" ;
  kriminologisk_av_1_A = mkA "kriminologisk" ;
  kringelikrokig_av_1_A = mkA "kringelikrokig" ;
  kringelkrokig_av_1_A = mkA "kringelkrokig" ;
  kringsjuk_av_1_A = mkA "kringsjuk" ;
  krispig_av_1_A = mkA "krispig" ;
  kristallin_av_1_A = mkA "kristallin" ;
  kristallinisk_av_1_A = mkA "kristallinisk" ;
  kristalliserbar_av_1_A = mkA "kristalliserbar" ;
  kristallisk_av_1_A = mkA "kristallisk" ;
  kristallklar_av_1_A = mkA "kristallklar" ;
  kristallografisk_av_1_A = mkA "kristallografisk" ;
  kristlig_av_1_A = mkA "kristlig" ;
  kritig_av_1_A = mkA "kritig" ;
  kritikermaessig_av_1_1_A = mkA "kritikermässig" ;
  kritikloes_av_1_1_A = mkA "kritiklös" ;
  kritiserbar_av_1_A = mkA "kritiserbar" ;
  kritisk_av_1_A = mkA "kritisk" ;
  kritstrecksrandig_av_1_A = mkA "kritstrecksrandig" ;
  kritvit_av_1_A = mkA "kritvit" ;
  kroatisk_av_1_A = mkA "kroatisk" ;
  krokig_av_1_A = mkA "krokig" ;
  krokryggig_av_1_A = mkA "krokryggig" ;
  kronisk_av_1_A = mkA "kronisk" ;
  kronologisk_av_1_A = mkA "kronologisk" ;
  kroppslig_av_1_A = mkA "kroppslig" ;
  kroppsvisiterbar_av_1_A = mkA "kroppsvisiterbar" ;
  krullhaarig_av_1_1_A = mkA "krullhårig" ;
  krullig_av_1_A = mkA "krullig" ;
  kruserlig_av_1_A = mkA "kruserlig" ;
  krushaarig_av_1_1_A = mkA "krushårig" ;
  krusidullig_av_1_A = mkA "krusidullig" ;
  krusig_av_1_A = mkA "krusig" ;
  kruttorr_av_1_A = mkA "kruttorr" ;
  kryckig_av_1_A = mkA "kryckig" ;
  kryddbrun_av_1_A = mkA "kryddbrun" ;
  kryddig_av_1_A = mkA "kryddig" ;
  kryddstark_av_1_A = mkA "kryddstark" ;
  krypterbar_av_1_A = mkA "krypterbar" ;
  kryptisk_av_1_A = mkA "kryptisk" ;
  kryptogam_av_1_A = mkA "kryptogam" ;
  kryssmaessig_av_1_1_A = mkA "kryssmässig" ;
  kraekfaerdig_av_1_1_A = mkA "kräkfärdig" ;
  kraemig_av_1_1_A = mkA "krämig" ;
  kraeslig_av_1_1_A = mkA "kräslig" ;
  kraanglig_av_1_1_A = mkA "krånglig" ;
  kubansk_av_1_A = mkA "kubansk" ;
  kuberbar_av_1_A = mkA "kuberbar" ;
  kubistisk_av_1_A = mkA "kubistisk" ;
  kufisk_av_1_A = mkA "kufisk" ;
  kujonerbar_av_1_A = mkA "kujonerbar" ;
  kulig_av_1_A = mkA "kulig" ;
  kulinarisk_av_1_A = mkA "kulinarisk" ;
  kullig_av_1_A = mkA "kullig" ;
  kullrig_av_1_A = mkA "kullrig" ;
  kultisk_av_1_A = mkA "kultisk" ;
  kultiverbar_av_1_A = mkA "kultiverbar" ;
  kulturell_av_1_A = mkA "kulturell" ;
  kulturfientlig_av_1_A = mkA "kulturfientlig" ;
  kulturhistorisk_av_1_A = mkA "kulturhistorisk" ;
  kumulativ_av_1_A = mkA "kumulativ" ;
  kumulerbar_av_1_A = mkA "kumulerbar" ;
  kunglig_av_1_A = mkA "kunglig" ;
  kunnig_av_1_A = mkA "kunnig" ;
  kunskapsmaessig_av_1_1_A = mkA "kunskapsmässig" ;
  kunskapsrik_av_1_A = mkA "kunskapsrik" ;
  kuperbar_av_1_A = mkA "kuperbar" ;
  kupig_av_1_A = mkA "kupig" ;
  kupolformig_av_1_A = mkA "kupolformig" ;
  kuraterbar_av_1_A = mkA "kuraterbar" ;
  kurativ_av_1_A = mkA "kurativ" ;
  kurdisk_av_1_A = mkA "kurdisk" ;
  kurerbar_av_1_A = mkA "kurerbar" ;
  kurioes_av_1_1_A = mkA "kuriös" ;
  kursiv_av_1_A = mkA "kursiv" ;
  kursiverbar_av_1_A = mkA "kursiverbar" ;
  kursmaessig_av_1_1_A = mkA "kursmässig" ;
  kursorisk_av_1_A = mkA "kursorisk" ;
  kurtiserbar_av_1_A = mkA "kurtiserbar" ;
  kurvig_av_1_A = mkA "kurvig" ;
  kurvstabil_av_1_A = mkA "kurvstabil" ;
  kuslig_av_1_A = mkA "kuslig" ;
  kutig_av_1_A = mkA "kutig" ;
  kutryggig_av_1_A = mkA "kutryggig" ;
  kuverterbar_av_1_A = mkA "kuverterbar" ;
  kuwaitisk_av_1_A = mkA "kuwaitisk" ;
  kvadrerbar_av_1_A = mkA "kvadrerbar" ;
  kvalfri_av_1_A = mkA "kvalfri" ;
  kvalfull_av_1_A = mkA "kvalfull" ;
  kvalificerbar_av_1_A = mkA "kvalificerbar" ;
  kvalitativ_av_1_A = mkA "kvalitativ" ;
  kvalitetsmaessig_av_1_1_A = mkA "kvalitetsmässig" ;
  kvalmig_av_1_A = mkA "kvalmig" ;
  kvantifierbar_av_1_A = mkA "kvantifierbar" ;
  kvantitativ_av_1_A = mkA "kvantitativ" ;
  kvav_av_1_A = mkA "kvav" ;
  kverulantisk_av_1_A = mkA "kverulantisk" ;
  kvick_av_1_A = mkA "kvick" ;
  kvinnlig_av_1_A = mkA "kvinnlig" ;
  kvinnofientlig_av_1_A = mkA "kvinnofientlig" ;
  kvisslig_av_1_A = mkA "kvisslig" ;
  kvistig_av_1_A = mkA "kvistig" ;
  kvistloes_av_1_1_A = mkA "kvistlös" ;
  kvitterbar_av_1_A = mkA "kvitterbar" ;
  kvittrig_av_1_A = mkA "kvittrig" ;
  kvoterbar_av_1_A = mkA "kvoterbar" ;
  kvaellslig_av_1_1_A = mkA "kvällslig" ;
  kvaellstidningsmaessig_av_1_1_A = mkA "kvällstidningsmässig" ;
  kybernetisk_av_1_A = mkA "kybernetisk" ;
  kyffig_av_1_A = mkA "kyffig" ;
  kylig_av_1_A = mkA "kylig" ;
  kylsig_av_1_A = mkA "kylsig" ;
  kymig_av_1_A = mkA "kymig" ;
  kynisk_av_1_A = mkA "kynisk" ;
  kyrillisk_av_1_A = mkA "kyrillisk" ;
  kyrklig_av_1_A = mkA "kyrklig" ;
  kysk_av_1_A = mkA "kysk" ;
  kysstaeck_av_1_1_A = mkA "kysstäck" ;
  kaeck_av_1_1_A = mkA "käck" ;
  kaegelformig_av_1_1_A = mkA "kägelformig" ;
  kaelkborgerlig_av_1_1_A = mkA "kälkborgerlig" ;
  kaellsorterbar_av_1_1_A = mkA "källsorterbar" ;
  kaempalik_av_1_1_A = mkA "kämpalik" ;
  kaempamaessig_av_1_1_A = mkA "kämpamässig" ;
  kaempig_av_1_1_A = mkA "kämpig" ;
  kaennbar_av_1_1_A = mkA "kännbar" ;
  kaenslig_av_1_1_A = mkA "känslig" ;
  kaenslokall_av_1_1_A = mkA "känslokall" ;
  kaensloloes_av_1_1_A = mkA "känslolös" ;
  kaenslomaessig_av_1_1_A = mkA "känslomässig" ;
  kaepprak_av_1_1_A = mkA "käpprak" ;
  kaer_av_1_1_A = mkA "kär" ;
  kaerleksfull_av_1_1_A = mkA "kärleksfull" ;
  kaerlekskrank_av_1_1_A = mkA "kärlekskrank" ;
  kaerleksloes_av_1_1_A = mkA "kärlekslös" ;
  kaerlig_av_1_1_A = mkA "kärlig" ;
  kaernfrisk_av_1_1_A = mkA "kärnfrisk" ;
  kaernfull_av_1_1_A = mkA "kärnfull" ;
  kaernvapenmaessig_av_1_1_A = mkA "kärnvapenmässig" ;
  kaerv_av_1_1_A = mkA "kärv" ;
  kaervaenlig_av_1_1_A = mkA "kärvänlig" ;
  kaeraelskelig_av_1_1_A = mkA "kärälskelig" ;
  kaeraelsklig_av_1_1_A = mkA "kärälsklig" ;
  kaettersk_av_1_1_A = mkA "kättersk" ;
  kaettjefull_av_1_1_A = mkA "kättjefull" ;
  kaadig_av_1_1_A = mkA "kådig" ;
  kaadrik_av_1_1_A = mkA "kådrik" ;
  koeldbestaendig_av_1_1_A = mkA "köldbeständig" ;
  koeldhaerdig_av_1_1_A = mkA "köldhärdig" ;
  koenlig_av_1_1_A = mkA "könlig" ;
  koenloes_av_1_1_A = mkA "könlös" ;
  koensdiskriminerbar_av_1_1_A = mkA "könsdiskriminerbar" ;
  koenskvoterbar_av_1_1_A = mkA "könskvoterbar" ;
  koenslig_av_1_1_A = mkA "könslig" ;
  koensmaessig_av_1_1_A = mkA "könsmässig" ;
  koepstark_av_1_1_A = mkA "köpstark" ;
  koerbar_av_1_1_A = mkA "körbar" ;
  koerig_av_1_1_A = mkA "körig" ;
  koettig_av_1_1_A = mkA "köttig" ;
  koettloes_av_1_1_A = mkA "köttlös" ;
  koettslig_av_1_1_A = mkA "köttslig" ;
  labial_av_1_A = mkA "labial" ;
  labialiserbar_av_1_A = mkA "labialiserbar" ;
  labil_av_1_A = mkA "labil" ;
  labiodental_av_1_A = mkA "labiodental" ;
  laborativ_av_1_A = mkA "laborativ" ;
  laboratoriemaessig_av_1_1_A = mkA "laboratoriemässig" ;
  labyrintisk_av_1_A = mkA "labyrintisk" ;
  lackerbar_av_1_A = mkA "lackerbar" ;
  ladylik_av_1_A = mkA "ladylik" ;
  lafsig_av_1_A = mkA "lafsig" ;
  lagenlig_av_1_A = mkA "lagenlig" ;
  lagisk_av_1_A = mkA "lagisk" ;
  lagklok_av_1_A = mkA "lagklok" ;
  laglig_av_1_A = mkA "laglig" ;
  laglydig_av_1_A = mkA "laglydig" ;
  lagloes_av_1_1_A = mkA "laglös" ;
  lagmaessig_av_1_1_A = mkA "lagmässig" ;
  lagom_av_1_A = mkA "lagom" ;
  lagstiftningsmaessig_av_1_1_A = mkA "lagstiftningsmässig" ;
  lagstridig_av_1_A = mkA "lagstridig" ;
  lakonisk_av_1_A = mkA "lakonisk" ;
  lam_av_1_A = mkA "lam" ;
  lamenterbar_av_1_A = mkA "lamenterbar" ;
  laminerbar_av_1_A = mkA "laminerbar" ;
  laminaer_av_1_1_A = mkA "laminär" ;
  landloes_av_1_1_A = mkA "landlös" ;
  landsfaderlig_av_1_A = mkA "landsfaderlig" ;
  landsflyktig_av_1_A = mkA "landsflyktig" ;
  landsfoerraedisk_av_1_1_A = mkA "landsförrädisk" ;
  landskapsmaessig_av_1_1_A = mkA "landskapsmässig" ;
  landslagsmaessig_av_1_1_A = mkA "landslagsmässig" ;
  landsortsmaessig_av_1_1_A = mkA "landsortsmässig" ;
  langetterbar_av_1_A = mkA "langetterbar" ;
  lankesisk_av_1_A = mkA "lankesisk" ;
  lanserbar_av_1_A = mkA "lanserbar" ;
  lantlig_av_1_A = mkA "lantlig" ;
  lantmaessig_av_1_1_A = mkA "lantmässig" ;
  laotisk_av_1_A = mkA "laotisk" ;
  lapidarisk_av_1_A = mkA "lapidarisk" ;
  lapiserbar_av_1_A = mkA "lapiserbar" ;
  lapplaendsk_av_1_1_A = mkA "lappländsk" ;
  lapsk_av_1_A = mkA "lapsk" ;
  larvig_av_1_A = mkA "larvig" ;
  laryngal_av_1_A = mkA "laryngal" ;
  lasciv_av_1_A = mkA "lasciv" ;
  laserbar_av_1_A = mkA "laserbar" ;
  lastbar_av_1_A = mkA "lastbar" ;
  lastdryg_av_1_A = mkA "lastdryg" ;
  lastelig_av_1_A = mkA "lastelig" ;
  lastfull_av_1_A = mkA "lastfull" ;
  lastklar_av_1_A = mkA "lastklar" ;
  lateral_av_1_A = mkA "lateral" ;
  latin_amerikansk_av_1_A = mkA "latin-amerikansk" ;
  latinamerikansk_av_1_A = mkA "latinamerikansk" ;
  latiniserbar_av_1_A = mkA "latiniserbar" ;
  latinkunnig_av_1_A = mkA "latinkunnig" ;
  latinsk_av_1_A = mkA "latinsk" ;
  laverbar_av_1_A = mkA "laverbar" ;
  layoutmaessig_av_1_1_A = mkA "layoutmässig" ;
  lealoes_av_1_1_A = mkA "lealös" ;
  ledarskapsmaessig_av_1_1_A = mkA "ledarskapsmässig" ;
  ledig_av_1_A = mkA "ledig" ;
  ledningsmaessig_av_1_1_A = mkA "ledningsmässig" ;
  legal_av_1_A = mkA "legal" ;
  legaliserbar_av_1_A = mkA "legaliserbar" ;
  legendarisk_av_1_A = mkA "legendarisk" ;
  legerbar_av_1_A = mkA "legerbar" ;
  legislativ_av_1_A = mkA "legislativ" ;
  legitim_av_1_A = mkA "legitim" ;
  legitimerbar_av_1_A = mkA "legitimerbar" ;
  legaer_av_1_1_A = mkA "legär" ;
  lekamlig_av_1_A = mkA "lekamlig" ;
  lekfull_av_1_A = mkA "lekfull" ;
  lekfaerdig_av_1_1_A = mkA "lekfärdig" ;
  lekmannamaessig_av_1_1_A = mkA "lekmannamässig" ;
  len_av_1_A = mkA "len" ;
  leninistisk_av_1_A = mkA "leninistisk" ;
  leproes_av_1_1_A = mkA "leprös" ;
  leptosom_av_1_A = mkA "leptosom" ;
  lerhaltig_av_1_A = mkA "lerhaltig" ;
  lerig_av_1_A = mkA "lerig" ;
  lesbisk_av_1_A = mkA "lesbisk" ;
  lesothisk_av_1_A = mkA "lesothisk" ;
  letal_av_1_A = mkA "letal" ;
  letargisk_av_1_A = mkA "letargisk" ;
  lettisk_av_1_A = mkA "lettisk" ;
  leveransklar_av_1_A = mkA "leveransklar" ;
  leverbrun_av_1_A = mkA "leverbrun" ;
  levererbar_av_1_A = mkA "levererbar" ;
  lexikal_av_1_A = mkA "lexikal" ;
  lexikalisk_av_1_A = mkA "lexikalisk" ;
  lexikografisk_av_1_A = mkA "lexikografisk" ;
  lexikologisk_av_1_A = mkA "lexikologisk" ;
  lexikostatistisk_av_1_A = mkA "lexikostatistisk" ;
  libanesisk_av_1_A = mkA "libanesisk" ;
  liberal_av_1_A = mkA "liberal" ;
  liberaliserbar_av_1_A = mkA "liberaliserbar" ;
  liberiansk_av_1_A = mkA "liberiansk" ;
  liberisk_av_1_A = mkA "liberisk" ;
  libysk_av_1_A = mkA "libysk" ;
  licenserbar_av_1_A = mkA "licenserbar" ;
  licensierbar_av_1_A = mkA "licensierbar" ;
  licentierbar_av_1_A = mkA "licentierbar" ;
  lidelsefull_av_1_A = mkA "lidelsefull" ;
  liderlig_av_1_A = mkA "liderlig" ;
  liechtensteinsk_av_1_A = mkA "liechtensteinsk" ;
  lierbar_av_1_A = mkA "lierbar" ;
  liggriktig_av_1_A = mkA "liggriktig" ;
  liggsjuk_av_1_A = mkA "liggsjuk" ;
  ligurisk_av_1_A = mkA "ligurisk" ;
  lik_av_1_A = mkA "lik" ;
  likadan_av_1_A = mkA "likadan" ;
  likblek_av_1_A = mkA "likblek" ;
  likformig_av_1_A = mkA "likformig" ;
  likgiltig_av_1_A = mkA "likgiltig" ;
  liknaemnig_av_1_1_A = mkA "liknämnig" ;
  liksidig_av_1_A = mkA "liksidig" ;
  likstaellig_av_1_1_A = mkA "likställig" ;
  likstaemmig_av_1_1_A = mkA "likstämmig" ;
  liktydig_av_1_A = mkA "liktydig" ;
  likviderbar_av_1_A = mkA "likviderbar" ;
  likvaerdig_av_1_1_A = mkA "likvärdig" ;
  liljevit_av_1_A = mkA "liljevit" ;
  limitativ_av_1_A = mkA "limitativ" ;
  limnisk_av_1_A = mkA "limnisk" ;
  limnologisk_av_1_A = mkA "limnologisk" ;
  lindrig_av_1_A = mkA "lindrig" ;
  lineaer_av_1_1_A = mkA "lineär" ;
  lingul_av_1_A = mkA "lingul" ;
  lingvistisk_av_1_A = mkA "lingvistisk" ;
  linhaarig_av_1_1_A = mkA "linhårig" ;
  linjerbar_av_1_A = mkA "linjerbar" ;
  linjaer_av_1_1_A = mkA "linjär" ;
  linvit_av_1_A = mkA "linvit" ;
  lipig_av_1_A = mkA "lipig" ;
  lisserbar_av_1_A = mkA "lisserbar" ;
  listig_av_1_A = mkA "listig" ;
  litauisk_av_1_A = mkA "litauisk" ;
  litograferbar_av_1_A = mkA "litograferbar" ;
  litoral_av_1_A = mkA "litoral" ;
  litteraturhistorisk_av_1_A = mkA "litteraturhistorisk" ;
  litteraer_av_1_1_A = mkA "litterär" ;
  liturgisk_av_1_A = mkA "liturgisk" ;
  livaktig_av_1_A = mkA "livaktig" ;
  livfull_av_1_A = mkA "livfull" ;
  livlig_av_1_A = mkA "livlig" ;
  livloes_av_1_1_A = mkA "livlös" ;
  livsduglig_av_1_A = mkA "livsduglig" ;
  livsfarlig_av_1_A = mkA "livsfarlig" ;
  livskraftig_av_1_A = mkA "livskraftig" ;
  livslaang_av_1_1_A = mkA "livslång" ;
  livsnoedvaendig_av_1_1_A = mkA "livsnödvändig" ;
  livsviktig_av_1_A = mkA "livsviktig" ;
  livsvaenlig_av_1_1_A = mkA "livsvänlig" ;
  livsaaskaadningsmaessig_av_1_1_A = mkA "livsåskådningsmässig" ;
  ljudenlig_av_1_A = mkA "ljudenlig" ;
  ljudisolerbar_av_1_A = mkA "ljudisolerbar" ;
  ljudlig_av_1_A = mkA "ljudlig" ;
  ljudloes_av_1_1_A = mkA "ljudlös" ;
  ljudmaessig_av_1_1_A = mkA "ljudmässig" ;
  ljudsvag_av_1_A = mkA "ljudsvag" ;
  ljus_av_1_A = mkA "ljus" ;
  ljusbestaendig_av_1_1_A = mkA "ljusbeständig" ;
  ljusbrun_av_1_A = mkA "ljusbrun" ;
  ljusgroen_av_1_1_A = mkA "ljusgrön" ;
  ljusgul_av_1_A = mkA "ljusgul" ;
  ljushaarig_av_1_1_A = mkA "ljushårig" ;
  ljuskopierbar_av_1_A = mkA "ljuskopierbar" ;
  ljuskaenslig_av_1_1_A = mkA "ljuskänslig" ;
  ljuslockig_av_1_A = mkA "ljuslockig" ;
  ljusmaessig_av_1_1_A = mkA "ljusmässig" ;
  ljusskygg_av_1_A = mkA "ljusskygg" ;
  ljusstark_av_1_A = mkA "ljusstark" ;
  ljussvag_av_1_A = mkA "ljussvag" ;
  ljuv_av_1_A = mkA "ljuv" ;
  ljuvlig_av_1_A = mkA "ljuvlig" ;
  lockig_av_1_A = mkA "lockig" ;
  lodbar_av_1_A = mkA "lodbar" ;
  lodraet_av_1_1_A = mkA "lodrät" ;
  logaritmisk_av_1_A = mkA "logaritmisk" ;
  logerbar_av_1_A = mkA "logerbar" ;
  logisk_av_1_A = mkA "logisk" ;
  logografisk_av_1_A = mkA "logografisk" ;
  logopedisk_av_1_A = mkA "logopedisk" ;
  loj_av_1_A = mkA "loj" ;
  lojal_av_1_A = mkA "lojal" ;
  lokal_av_1_A = mkA "lokal" ;
  lokaliserbar_av_1_A = mkA "lokaliserbar" ;
  lokalmaessig_av_1_1_A = mkA "lokalmässig" ;
  longitudinal_av_1_A = mkA "longitudinal" ;
  longitudinell_av_1_A = mkA "longitudinell" ;
  lortig_av_1_A = mkA "lortig" ;
  lottloes_av_1_1_A = mkA "lottlös" ;
  lovgirig_av_1_A = mkA "lovgirig" ;
  lovlig_av_1_A = mkA "lovlig" ;
  luddig_av_1_A = mkA "luddig" ;
  luetisk_av_1_A = mkA "luetisk" ;
  lufsig_av_1_A = mkA "lufsig" ;
  luftig_av_1_A = mkA "luftig" ;
  lufttaet_av_1_1_A = mkA "lufttät" ;
  luggig_av_1_A = mkA "luggig" ;
  lugn_av_1_A = mkA "lugn" ;
  lukrativ_av_1_A = mkA "lukrativ" ;
  luktloes_av_1_1_A = mkA "luktlös" ;
  luktsvag_av_1_A = mkA "luktsvag" ;
  lukullisk_av_1_A = mkA "lukullisk" ;
  lullig_av_1_A = mkA "lullig" ;
  lumbal_av_1_A = mkA "lumbal" ;
  luminoes_av_1_1_A = mkA "luminös" ;
  lummig_av_1_A = mkA "lummig" ;
  lumpig_av_1_A = mkA "lumpig" ;
  lunar_av_1_A = mkA "lunar" ;
  lunarisk_av_1_A = mkA "lunarisk" ;
  lundensisk_av_1_A = mkA "lundensisk" ;
  lungsiktig_av_1_A = mkA "lungsiktig" ;
  lungsjuk_av_1_A = mkA "lungsjuk" ;
  lunsig_av_1_A = mkA "lunsig" ;
  lurig_av_1_A = mkA "lurig" ;
  lurvig_av_1_A = mkA "lurvig" ;
  lusfattig_av_1_A = mkA "lusfattig" ;
  lusig_av_1_A = mkA "lusig" ;
  luspank_av_1_A = mkA "luspank" ;
  lustelig_av_1_A = mkA "lustelig" ;
  lustig_av_1_A = mkA "lustig" ;
  luteiniserbar_av_1_A = mkA "luteiniserbar" ;
  luthersk_av_1_A = mkA "luthersk" ;
  luxemburgsk_av_1_A = mkA "luxemburgsk" ;
  luxuoes_av_1_1_A = mkA "luxuös" ;
  lycklig_av_1_A = mkA "lycklig" ;
  lycksalig_av_1_A = mkA "lycksalig" ;
  lydaktig_av_1_A = mkA "lydaktig" ;
  lydig_av_1_A = mkA "lydig" ;
  lymfatisk_av_1_A = mkA "lymfatisk" ;
  lymmelaktig_av_1_A = mkA "lymmelaktig" ;
  lynnig_av_1_A = mkA "lynnig" ;
  lyrisk_av_1_A = mkA "lyrisk" ;
  lyxig_av_1_A = mkA "lyxig" ;
  lyxrenoverbar_av_1_A = mkA "lyxrenoverbar" ;
  laebbig_av_1_1_A = mkA "läbbig" ;
  laederbar_av_1_1_A = mkA "läderbar" ;
  laederbrun_av_1_1_A = mkA "läderbrun" ;
  laeglig_av_1_1_A = mkA "läglig" ;
  laemplig_av_1_1_A = mkA "lämplig" ;
  laengtansfull_av_1_1_A = mkA "längtansfull" ;
  laeraktig_av_1_1_A = mkA "läraktig" ;
  laerarloes_av_1_1_A = mkA "lärarlös" ;
  laeroboksaktig_av_1_1_A = mkA "läroboksaktig" ;
  laeroboksmaessig_av_1_1_A = mkA "läroboksmässig" ;
  laeromaessig_av_1_1_A = mkA "läromässig" ;
  laerorik_av_1_1_A = mkA "lärorik" ;
  laesbar_av_1_1_A = mkA "läsbar" ;
  laeskig_av_1_1_A = mkA "läskig" ;
  laeskunnig_av_1_1_A = mkA "läskunnig" ;
  laeslig_av_1_1_A = mkA "läslig" ;
  laessvag_av_1_1_A = mkA "lässvag" ;
  laesvaenlig_av_1_1_A = mkA "läsvänlig" ;
  laettantaendlig_av_1_1_A = mkA "lättantändlig" ;
  laettbegriplig_av_1_1_A = mkA "lättbegriplig" ;
  laettfattlig_av_1_1_A = mkA "lättfattlig" ;
  laettflyktig_av_1_1_A = mkA "lättflyktig" ;
  laettframkomlig_av_1_1_A = mkA "lättframkomlig" ;
  laettfaerdig_av_1_1_A = mkA "lättfärdig" ;
  laettfoerklarlig_av_1_1_A = mkA "lättförklarlig" ;
  laettfoerstaaelig_av_1_1_A = mkA "lättförståelig" ;
  laetthanterlig_av_1_1_A = mkA "lätthanterlig" ;
  laettillgaenglig_av_1_1_A = mkA "lättillgänglig" ;
  laettjefull_av_1_1_A = mkA "lättjefull" ;
  laettloeslig_av_1_1_A = mkA "lättlöslig" ;
  laettretlig_av_1_1_A = mkA "lättretlig" ;
  laettroerlig_av_1_1_A = mkA "lättrörlig" ;
  laettsinnig_av_1_1_A = mkA "lättsinnig" ;
  laettviktig_av_1_1_A = mkA "lättviktig" ;
  laettvindig_av_1_1_A = mkA "lättvindig" ;
  laettoeverskaadlig_av_1_1_A = mkA "lättöverskådlig" ;
  laaghjulig_av_1_1_A = mkA "låghjulig" ;
  laagkyrklig_av_1_1_A = mkA "lågkyrklig" ;
  laagprioriterbar_av_1_1_A = mkA "lågprioriterbar" ;
  laagproduktiv_av_1_1_A = mkA "lågproduktiv" ;
  laagsvavlig_av_1_1_A = mkA "lågsvavlig" ;
  laagtysk_av_1_1_A = mkA "lågtysk" ;
  laagvaerdig_av_1_1_A = mkA "lågvärdig" ;
  laangfristig_av_1_1_A = mkA "långfristig" ;
  laanghornig_av_1_1_A = mkA "långhornig" ;
  laanghaarig_av_1_1_A = mkA "långhårig" ;
  laangledig_av_1_1_A = mkA "långledig" ;
  laanglig_av_1_1_A = mkA "långlig" ;
  laangmodig_av_1_1_A = mkA "långmodig" ;
  laangrandig_av_1_1_A = mkA "långrandig" ;
  laangsiktig_av_1_1_A = mkA "långsiktig" ;
  laangskallig_av_1_1_A = mkA "långskallig" ;
  laangsmal_av_1_1_A = mkA "långsmal" ;
  laangtidsparkerbar_av_1_1_A = mkA "långtidsparkerbar" ;
  laangtidssjuk_av_1_1_A = mkA "långtidssjuk" ;
  laangtradig_av_1_1_A = mkA "långtradig" ;
  laangtraadig_av_1_1_A = mkA "långtrådig" ;
  laangtraakig_av_1_1_A = mkA "långtråkig" ;
  laangvarig_av_1_1_A = mkA "långvarig" ;
  laangvaagig_av_1_1_A = mkA "långvågig" ;
  laasbar_av_1_1_A = mkA "låsbar" ;
  laatmaessig_av_1_1_A = mkA "låtmässig" ;
  loeddrig_av_1_1_A = mkA "löddrig" ;
  loedig_av_1_1_A = mkA "lödig" ;
  loeftesrik_av_1_1_A = mkA "löftesrik" ;
  loegnaktig_av_1_1_A = mkA "lögnaktig" ;
  loejlig_av_1_1_A = mkA "löjlig" ;
  loekformig_av_1_1_A = mkA "lökformig" ;
  loekig_av_1_1_A = mkA "lökig" ;
  loemsk_av_1_1_A = mkA "lömsk" ;
  loenemaessig_av_1_1_A = mkA "lönemässig" ;
  loenloes_av_1_1_A = mkA "lönlös" ;
  loennfet_av_1_1_A = mkA "lönnfet" ;
  loennlig_av_1_1_A = mkA "lönnlig" ;
  loepmaessig_av_1_1_A = mkA "löpmässig" ;
  loepsk_av_1_1_A = mkA "löpsk" ;
  loes_av_1_1_A = mkA "lös" ;
  loesaktig_av_1_1_A = mkA "lösaktig" ;
  loesbar_av_1_1_A = mkA "lösbar" ;
  loeslig_av_1_1_A = mkA "löslig" ;
  loestagbar_av_1_1_A = mkA "löstagbar" ;
  loevrik_av_1_1_A = mkA "lövrik" ;
  macedonisk_av_1_A = mkA "macedonisk" ;
  macedonsk_av_1_A = mkA "macedonsk" ;
  machiavellisk_av_1_A = mkA "machiavellisk" ;
  machiavellistisk_av_1_A = mkA "machiavellistisk" ;
  madagaskisk_av_1_A = mkA "madagaskisk" ;
  madrasserbar_av_1_A = mkA "madrasserbar" ;
  maffiamaessig_av_1_1_A = mkA "maffiamässig" ;
  maffig_av_1_A = mkA "maffig" ;
  magasinerbar_av_1_A = mkA "magasinerbar" ;
  magisk_av_1_A = mkA "magisk" ;
  magistral_av_1_A = mkA "magistral" ;
  magnetiserbar_av_1_A = mkA "magnetiserbar" ;
  magnetisk_av_1_A = mkA "magnetisk" ;
  magnifik_av_1_A = mkA "magnifik" ;
  magstark_av_1_A = mkA "magstark" ;
  magsur_av_1_A = mkA "magsur" ;
  majestaetisk_av_1_1_A = mkA "majestätisk" ;
  majestaetlig_av_1_1_A = mkA "majestätlig" ;
  makaloes_av_1_1_A = mkA "makalös" ;
  makedonisk_av_1_A = mkA "makedonisk" ;
  makedonsk_av_1_A = mkA "makedonsk" ;
  maklig_av_1_A = mkA "maklig" ;
  makroskopisk_av_1_A = mkA "makroskopisk" ;
  maktfullkomlig_av_1_A = mkA "maktfullkomlig" ;
  maktloes_av_1_1_A = mkA "maktlös" ;
  maktmaessig_av_1_1_A = mkA "maktmässig" ;
  makulerbar_av_1_A = mkA "makulerbar" ;
  malajisk_av_1_A = mkA "malajisk" ;
  malawisk_av_1_A = mkA "malawisk" ;
  malaysisk_av_1_A = mkA "malaysisk" ;
  maldivisk_av_1_A = mkA "maldivisk" ;
  malfoberbar_av_1_A = mkA "malfoberbar" ;
  malicioes_av_1_1_A = mkA "maliciös" ;
  malign_av_1_A = mkA "malign" ;
  malisk_av_1_A = mkA "malisk" ;
  mallig_av_1_A = mkA "mallig" ;
  malmfyndig_av_1_A = mkA "malmfyndig" ;
  maltesisk_av_1_A = mkA "maltesisk" ;
  maltraeterbar_av_1_1_A = mkA "malträterbar" ;
  mammaledig_av_1_A = mkA "mammaledig" ;
  mammig_av_1_A = mkA "mammig" ;
  manbar_av_1_A = mkA "manbar" ;
  manchuisk_av_1_A = mkA "manchuisk" ;
  mandelgroen_av_1_1_A = mkA "mandelgrön" ;
  manhaftig_av_1_A = mkA "manhaftig" ;
  maniakalisk_av_1_A = mkA "maniakalisk" ;
  manifesterbar_av_1_A = mkA "manifesterbar" ;
  manikurerbar_av_1_A = mkA "manikurerbar" ;
  manikyrerbar_av_1_A = mkA "manikyrerbar" ;
  manipulerbar_av_1_A = mkA "manipulerbar" ;
  manisk_depressiv_av_1_A = mkA "manisk-depressiv" ;
  manisk_av_1_A = mkA "manisk" ;
  manlig_av_1_A = mkA "manlig" ;
  manodepressiv_av_1_A = mkA "manodepressiv" ;
  manstark_av_1_A = mkA "manstark" ;
  manuell_av_1_A = mkA "manuell" ;
  manoeverduglig_av_1_1_A = mkA "manöverduglig" ;
  manoevrerbar_av_1_1_A = mkA "manövrerbar" ;
  maorisk_av_1_A = mkA "maorisk" ;
  mardroemslik_av_1_1_A = mkA "mardrömslik" ;
  margfaldig_av_1_A = mkA "margfaldig" ;
  marginaliserbar_av_1_A = mkA "marginaliserbar" ;
  marginell_av_1_A = mkA "marginell" ;
  marig_av_1_A = mkA "marig" ;
  marin_av_1_A = mkA "marin" ;
  marinbiologisk_av_1_A = mkA "marinbiologisk" ;
  marinerbar_av_1_A = mkA "marinerbar" ;
  maritim_av_1_A = mkA "maritim" ;
  markerbar_av_1_A = mkA "markerbar" ;
  marknadsekonomisk_av_1_A = mkA "marknadsekonomisk" ;
  marknadsfoeringsmaessig_av_1_1_A = mkA "marknadsföringsmässig" ;
  marknadskapitalistisk_av_1_A = mkA "marknadskapitalistisk" ;
  marknadsmaessig_av_1_1_A = mkA "marknadsmässig" ;
  marknadsvaerderbar_av_1_1_A = mkA "marknadsvärderbar" ;
  marmorerbar_av_1_A = mkA "marmorerbar" ;
  marockansk_av_1_A = mkA "marockansk" ;
  marscherbar_av_1_A = mkA "marscherbar" ;
  marterbar_av_1_A = mkA "marterbar" ;
  martialisk_av_1_A = mkA "martialisk" ;
  marxistisk_av_1_A = mkA "marxistisk" ;
  masig_av_1_A = mkA "masig" ;
  maskerbar_av_1_A = mkA "maskerbar" ;
  maskformig_av_1_A = mkA "maskformig" ;
  maskinell_av_1_A = mkA "maskinell" ;
  maskinlaesbar_av_1_1_A = mkA "maskinläsbar" ;
  maskinmaessig_av_1_1_A = mkA "maskinmässig" ;
  maskulin_av_1_A = mkA "maskulin" ;
  maskuliniserbar_av_1_A = mkA "maskuliniserbar" ;
  massakrerbar_av_1_A = mkA "massakrerbar" ;
  masserbar_av_1_A = mkA "masserbar" ;
  massiv_av_1_A = mkA "massiv" ;
  massloes_av_1_1_A = mkA "masslös" ;
  massmedial_av_1_A = mkA "massmedial" ;
  mastig_av_1_A = mkA "mastig" ;
  mastodontisk_av_1_A = mkA "mastodontisk" ;
  matelasserbar_av_1_A = mkA "matelasserbar" ;
  matematisk_naturvetenskaplig_av_1_A = mkA "matematisk-naturvetenskaplig" ;
  matematisk_av_1_A = mkA "matematisk" ;
  materialiserbar_av_1_A = mkA "materialiserbar" ;
  materialistisk_av_1_A = mkA "materialistisk" ;
  materialmaessig_av_1_1_A = mkA "materialmässig" ;
  materiell_av_1_A = mkA "materiell" ;
  matfrisk_av_1_A = mkA "matfrisk" ;
  matig_av_1_A = mkA "matig" ;
  matmaessig_av_1_1_A = mkA "matmässig" ;
  matnyttig_av_1_A = mkA "matnyttig" ;
  matriarkal_av_1_A = mkA "matriarkal" ;
  matriarkalisk_av_1_A = mkA "matriarkalisk" ;
  matterbar_av_1_A = mkA "matterbar" ;
  mauretansk_av_1_A = mkA "mauretansk" ;
  mauritisk_av_1_A = mkA "mauritisk" ;
  maximal_av_1_A = mkA "maximal" ;
  maximerbar_av_1_A = mkA "maximerbar" ;
  medaljerbar_av_1_A = mkA "medaljerbar" ;
  medaljmaessig_av_1_1_A = mkA "medaljmässig" ;
  medansvarig_av_1_A = mkA "medansvarig" ;
  medborgerlig_av_1_A = mkA "medborgerlig" ;
  medbrottslig_av_1_A = mkA "medbrottslig" ;
  meddelaktig_av_1_A = mkA "meddelaktig" ;
  medelbar_av_1_A = mkA "medelbar" ;
  medelindisk_av_1_A = mkA "medelindisk" ;
  medelloes_av_1_1_A = mkA "medellös" ;
  medelmaattig_av_1_1_A = mkA "medelmåttig" ;
  medelpadsk_av_1_A = mkA "medelpadsk" ;
  medeltidsmaessig_av_1_1_A = mkA "medeltidsmässig" ;
  medgoerlig_av_1_1_A = mkA "medgörlig" ;
  medial_av_1_A = mkA "medial" ;
  mediamaessig_av_1_1_A = mkA "mediamässig" ;
  medicinerbar_av_1_A = mkA "medicinerbar" ;
  medicinsk_av_1_A = mkA "medicinsk" ;
  mediekritisk_av_1_A = mkA "mediekritisk" ;
  mediemaessig_av_1_1_A = mkA "mediemässig" ;
  meditativ_av_1_A = mkA "meditativ" ;
  mediterran_av_1_A = mkA "mediterran" ;
  medlemsantalsmaessig_av_1_1_A = mkA "medlemsantalsmässig" ;
  medlemsmaessig_av_1_1_A = mkA "medlemsmässig" ;
  medmaensklig_av_1_1_A = mkA "medmänsklig" ;
  medskyldig_av_1_A = mkA "medskyldig" ;
  medvetsloes_av_1_1_A = mkA "medvetslös" ;
  mefistofelisk_av_1_A = mkA "mefistofelisk" ;
  mefitisk_av_1_A = mkA "mefitisk" ;
  mekaniserbar_av_1_A = mkA "mekaniserbar" ;
  mekanisk_av_1_A = mkA "mekanisk" ;
  mekanistisk_av_1_A = mkA "mekanistisk" ;
  mekvaenlig_av_1_1_A = mkA "mekvänlig" ;
  melanesisk_av_1_A = mkA "melanesisk" ;
  melankolisk_av_1_A = mkA "melankolisk" ;
  mellanfolklig_av_1_A = mkA "mellanfolklig" ;
  mellankommunal_av_1_A = mkA "mellankommunal" ;
  mellanstatlig_av_1_A = mkA "mellanstatlig" ;
  mellansvensk_av_1_A = mkA "mellansvensk" ;
  melodisk_av_1_A = mkA "melodisk" ;
  melodioes_av_1_1_A = mkA "melodiös" ;
  melodramatisk_av_1_A = mkA "melodramatisk" ;
  memorerbar_av_1_A = mkA "memorerbar" ;
  mendelistisk_av_1_A = mkA "mendelistisk" ;
  mendelsk_av_1_A = mkA "mendelsk" ;
  menig_av_1_A = mkA "menig" ;
  meningsfull_av_1_A = mkA "meningsfull" ;
  meningsloes_av_1_1_A = mkA "meningslös" ;
  menlig_av_1_A = mkA "menlig" ;
  menloes_av_1_1_A = mkA "menlös" ;
  mental_av_1_A = mkA "mental" ;
  mentalsjuk_av_1_A = mkA "mentalsjuk" ;
  merceriserbar_av_1_A = mkA "merceriserbar" ;
  meriterbar_av_1_A = mkA "meriterbar" ;
  meritmaessig_av_1_1_A = mkA "meritmässig" ;
  merkantil_av_1_A = mkA "merkantil" ;
  mesaktig_av_1_A = mkA "mesaktig" ;
  mesig_av_1_A = mkA "mesig" ;
  mesopotamisk_av_1_A = mkA "mesopotamisk" ;
  mesozoisk_av_1_A = mkA "mesozoisk" ;
  messiansk_av_1_A = mkA "messiansk" ;
  metaforisk_av_1_A = mkA "metaforisk" ;
  metafysisk_av_1_A = mkA "metafysisk" ;
  metalliserbar_av_1_A = mkA "metalliserbar" ;
  metallisk_av_1_A = mkA "metallisk" ;
  metallografisk_av_1_A = mkA "metallografisk" ;
  metallurgisk_av_1_A = mkA "metallurgisk" ;
  metamorf_av_1_A = mkA "metamorf" ;
  metastatisk_av_1_A = mkA "metastatisk" ;
  meteorologisk_av_1_A = mkA "meteorologisk" ;
  metertjock_av_1_A = mkA "metertjock" ;
  metodisk_av_1_A = mkA "metodisk" ;
  metodmaessig_av_1_1_A = mkA "metodmässig" ;
  metodologisk_av_1_A = mkA "metodologisk" ;
  metrisk_av_1_A = mkA "metrisk" ;
  metrologisk_av_1_A = mkA "metrologisk" ;
  mexikansk_av_1_A = mkA "mexikansk" ;
  mikrobiologisk_av_1_A = mkA "mikrobiologisk" ;
  mikrofotograferbar_av_1_A = mkA "mikrofotograferbar" ;
  mikronesisk_av_1_A = mkA "mikronesisk" ;
  mikroskoperbar_av_1_A = mkA "mikroskoperbar" ;
  mikroskopisk_av_1_A = mkA "mikroskopisk" ;
  milanesisk_av_1_A = mkA "milanesisk" ;
  militariserbar_av_1_A = mkA "militariserbar" ;
  militaristisk_av_1_A = mkA "militaristisk" ;
  militaer_av_1_1_A = mkA "militär" ;
  militaerisk_av_1_1_A = mkA "militärisk" ;
  miljoefarlig_av_1_1_A = mkA "miljöfarlig" ;
  miljoeliberal_av_1_1_A = mkA "miljöliberal" ;
  miljoemaessig_av_1_1_A = mkA "miljömässig" ;
  miljoevaenlig_av_1_1_A = mkA "miljövänlig" ;
  millimetertjock_av_1_A = mkA "millimetertjock" ;
  mimisk_av_1_A = mkA "mimisk" ;
  mindervaerdig_av_1_1_A = mkA "mindervärdig" ;
  minderaarig_av_1_1_A = mkA "minderårig" ;
  mineralhaltig_av_1_A = mkA "mineralhaltig" ;
  mineraliserbar_av_1_A = mkA "mineraliserbar" ;
  mineralogisk_av_1_A = mkA "mineralogisk" ;
  minerbar_av_1_A = mkA "minerbar" ;
  miniatyriserbar_av_1_A = mkA "miniatyriserbar" ;
  miniatyrmaessig_av_1_1_A = mkA "miniatyrmässig" ;
  minimal_av_1_A = mkA "minimal" ;
  minimerbar_av_1_A = mkA "minimerbar" ;
  ministeriell_av_1_A = mkA "ministeriell" ;
  minnesloes_av_1_1_A = mkA "minneslös" ;
  minnesrik_av_1_A = mkA "minnesrik" ;
  minnig_av_1_A = mkA "minnig" ;
  minoisk_av_1_A = mkA "minoisk" ;
  minsk_av_1_A = mkA "minsk" ;
  minutioes_av_1_1_A = mkA "minutiös" ;
  minutlig_av_1_A = mkA "minutlig" ;
  mirakuloes_av_1_1_A = mkA "mirakulös" ;
  misantropisk_av_1_A = mkA "misantropisk" ;
  misshaglig_av_1_A = mkA "misshaglig" ;
  missiverbar_av_1_A = mkA "missiverbar" ;
  misskrediterbar_av_1_A = mkA "misskrediterbar" ;
  missmodig_av_1_A = mkA "missmodig" ;
  mistig_av_1_A = mkA "mistig" ;
  mistlig_av_1_A = mkA "mistlig" ;
  mjuk_av_1_A = mkA "mjuk" ;
  mjaekig_av_1_1_A = mkA "mjäkig" ;
  mjaell_av_1_1_A = mkA "mjäll" ;
  mjaellig_av_1_1_A = mkA "mjällig" ;
  mjaeltsjuk_av_1_1_A = mkA "mjältsjuk" ;
  mjoelig_av_1_1_A = mkA "mjölig" ;
  mjoelkig_av_1_1_A = mkA "mjölkig" ;
  mjoelkvit_av_1_1_A = mkA "mjölkvit" ;
  mnemoteknisk_av_1_A = mkA "mnemoteknisk" ;
  mobil_av_1_A = mkA "mobil" ;
  mobiliserbar_av_1_A = mkA "mobiliserbar" ;
  mocambikisk_av_1_A = mkA "mocambikisk" ;
  modal_av_1_A = mkA "modal" ;
  modellerbar_av_1_A = mkA "modellerbar" ;
  modemaessig_av_1_1_A = mkA "modemässig" ;
  modererbar_av_1_A = mkA "modererbar" ;
  moderiktig_av_1_A = mkA "moderiktig" ;
  moderlig_av_1_A = mkA "moderlig" ;
  modern_av_1_A = mkA "modern" ;
  moderniserbar_av_1_A = mkA "moderniserbar" ;
  modernistisk_av_1_A = mkA "modernistisk" ;
  modifierbar_av_1_A = mkA "modifierbar" ;
  modig_av_1_A = mkA "modig" ;
  modloes_av_1_1_A = mkA "modlös" ;
  modulerbar_av_1_A = mkA "modulerbar" ;
  modaern_av_1_1_A = mkA "modärn" ;
  modaerniserbar_av_1_1_A = mkA "modärniserbar" ;
  mohammedansk_av_1_A = mkA "mohammedansk" ;
  moj_av_1_A = mkA "moj" ;
  moldavisk_av_1_A = mkA "moldavisk" ;
  molekylaer_av_1_1_A = mkA "molekylär" ;
  molnig_av_1_A = mkA "molnig" ;
  momentan_av_1_A = mkA "momentan" ;
  monarkisk_av_1_A = mkA "monarkisk" ;
  mondial_av_1_A = mkA "mondial" ;
  mondaen_av_1_1_A = mkA "mondän" ;
  monegaskisk_av_1_A = mkA "monegaskisk" ;
  monetaer_av_1_1_A = mkA "monetär" ;
  mongolisk_av_1_A = mkA "mongolisk" ;
  monoftongerbar_av_1_A = mkA "monoftongerbar" ;
  monogam_av_1_A = mkA "monogam" ;
  monoklin_av_1_A = mkA "monoklin" ;
  monokrom_av_1_A = mkA "monokrom" ;
  monokromatisk_av_1_A = mkA "monokromatisk" ;
  monolitisk_av_1_A = mkA "monolitisk" ;
  monoman_av_1_A = mkA "monoman" ;
  monopoliserbar_av_1_A = mkA "monopoliserbar" ;
  monopolkapitalistisk_av_1_A = mkA "monopolkapitalistisk" ;
  monosyllabisk_av_1_A = mkA "monosyllabisk" ;
  monoton_av_1_A = mkA "monoton" ;
  monstruoes_av_1_1_A = mkA "monstruös" ;
  montenegrinsk_av_1_A = mkA "montenegrinsk" ;
  monterbar_av_1_A = mkA "monterbar" ;
  monteringsfaerdig_av_1_1_A = mkA "monteringsfärdig" ;
  monumental_av_1_A = mkA "monumental" ;
  mopsig_av_1_A = mkA "mopsig" ;
  moralisk_av_1_A = mkA "moralisk" ;
  mordisk_av_1_A = mkA "mordisk" ;
  morfologisk_av_1_A = mkA "morfologisk" ;
  morganatisk_av_1_A = mkA "morganatisk" ;
  morgonpigg_av_1_A = mkA "morgonpigg" ;
  morisk_av_1_A = mkA "morisk" ;
  mormonsk_av_1_A = mkA "mormonsk" ;
  morserbar_av_1_A = mkA "morserbar" ;
  morsk_av_1_A = mkA "morsk" ;
  mortificerbar_av_1_A = mkA "mortificerbar" ;
  mortifierbar_av_1_A = mkA "mortifierbar" ;
  mosaisk_av_1_A = mkA "mosaisk" ;
  mosig_av_1_A = mkA "mosig" ;
  moskovitisk_av_1_A = mkA "moskovitisk" ;
  mossgroen_av_1_1_A = mkA "mossgrön" ;
  mossig_av_1_A = mkA "mossig" ;
  mosterlig_av_1_A = mkA "mosterlig" ;
  motig_av_1_A = mkA "motig" ;
  motivationsmaessig_av_1_1_A = mkA "motivationsmässig" ;
  motiverbar_av_1_A = mkA "motiverbar" ;
  motivisk_av_1_A = mkA "motivisk" ;
  motivmaessig_av_1_1_A = mkA "motivmässig" ;
  motoriserbar_av_1_A = mkA "motoriserbar" ;
  motorisk_av_1_A = mkA "motorisk" ;
  motorvaegsmaessig_av_1_1_A = mkA "motorvägsmässig" ;
  motspaenstig_av_1_1_A = mkA "motspänstig" ;
  motstridig_av_1_A = mkA "motstridig" ;
  motstraevig_av_1_1_A = mkA "motsträvig" ;
  motstaandskraftig_av_1_1_A = mkA "motståndskraftig" ;
  motstaandsloes_av_1_1_A = mkA "motståndslös" ;
  motsaegelsefull_av_1_1_A = mkA "motsägelsefull" ;
  motsaegelseloes_av_1_1_A = mkA "motsägelselös" ;
  motsaettlig_av_1_1_A = mkA "motsättlig" ;
  mottaglig_av_1_A = mkA "mottaglig" ;
  motvillig_av_1_A = mkA "motvillig" ;
  mocambikisk_av_1_1_A = mkA "moçambikisk" ;
  muddrig_av_1_A = mkA "muddrig" ;
  muhammedansk_av_1_A = mkA "muhammedansk" ;
  muljerbar_av_1_A = mkA "muljerbar" ;
  mullig_av_1_A = mkA "mullig" ;
  mullrik_av_1_A = mkA "mullrik" ;
  multikulturell_av_1_A = mkA "multikulturell" ;
  multilateral_av_1_A = mkA "multilateral" ;
  multinationell_av_1_A = mkA "multinationell" ;
  multiplicerbar_av_1_A = mkA "multiplicerbar" ;
  mumifierbar_av_1_A = mkA "mumifierbar" ;
  mumsig_av_1_A = mkA "mumsig" ;
  munartlig_av_1_A = mkA "munartlig" ;
  municipal_av_1_A = mkA "municipal" ;
  muntlig_av_1_A = mkA "muntlig" ;
  munvig_av_1_A = mkA "munvig" ;
  muppig_av_1_A = mkA "muppig" ;
  mural_av_1_A = mkA "mural" ;
  murrig_av_1_A = mkA "murrig" ;
  museal_av_1_A = mkA "museal" ;
  museimaessig_av_1_1_A = mkA "museimässig" ;
  muselmansk_av_1_A = mkA "muselmansk" ;
  musikal_av_1_A = mkA "musikal" ;
  musikalisk_av_1_A = mkA "musikalisk" ;
  musikmaessig_av_1_1_A = mkA "musikmässig" ;
  musisk_av_1_A = mkA "musisk" ;
  muskelstark_av_1_A = mkA "muskelstark" ;
  muskuloes_av_1_1_A = mkA "muskulös" ;
  muslimsk_av_1_A = mkA "muslimsk" ;
  mustig_av_1_A = mkA "mustig" ;
  muterbar_av_1_A = mkA "muterbar" ;
  mykologisk_av_1_A = mkA "mykologisk" ;
  myllig_av_1_A = mkA "myllig" ;
  myndig_av_1_A = mkA "myndig" ;
  myopisk_av_1_A = mkA "myopisk" ;
  mysig_av_1_A = mkA "mysig" ;
  mysterioes_av_1_1_A = mkA "mysteriös" ;
  mystifierbar_av_1_A = mkA "mystifierbar" ;
  mystifik_av_1_A = mkA "mystifik" ;
  mystisk_av_1_A = mkA "mystisk" ;
  mytisk_av_1_A = mkA "mytisk" ;
  mytologisk_av_1_A = mkA "mytologisk" ;
  maektig_av_1_1_A = mkA "mäktig" ;
  maenniskofientlig_av_1_1_A = mkA "människofientlig" ;
  maenniskolik_av_1_1_A = mkA "människolik" ;
  maenniskovaenlig_av_1_1_A = mkA "människovänlig" ;
  maenniskovaerdig_av_1_1_A = mkA "människovärdig" ;
  maensklig_av_1_1_A = mkA "mänsklig" ;
  maergfull_av_1_1_A = mkA "märgfull" ;
  maerglig_av_1_1_A = mkA "märglig" ;
  maergloes_av_1_1_A = mkA "märglös" ;
  maerkbar_av_1_1_A = mkA "märkbar" ;
  maerklig_av_1_1_A = mkA "märklig" ;
  maerkvaerdig_av_1_1_A = mkA "märkvärdig" ;
  maesterlig_av_1_1_A = mkA "mästerlig" ;
  maetbar_av_1_1_A = mkA "mätbar" ;
  maetmaessig_av_1_1_A = mkA "mätmässig" ;
  maalerisk_av_1_1_A = mkA "målerisk" ;
  maalfarlig_av_1_1_A = mkA "målfarlig" ;
  maalloes_av_1_1_A = mkA "mållös" ;
  maalmaessig_av_1_1_A = mkA "målmässig" ;
  maan_av_1_1_A = mkA "mån" ;
  maanatlig_av_1_1_A = mkA "månatlig" ;
  maangfaldig_av_1_1_A = mkA "mångfaldig" ;
  maangformig_av_1_1_A = mkA "mångformig" ;
  maangkulturell_av_1_1_A = mkA "mångkulturell" ;
  maangkunnig_av_1_1_A = mkA "mångkunnig" ;
  maangordig_av_1_1_A = mkA "mångordig" ;
  maangsidig_av_1_1_A = mkA "mångsidig" ;
  maangspraakig_av_1_1_A = mkA "mångspråkig" ;
  maangstavig_av_1_1_A = mkA "mångstavig" ;
  maangstaemmig_av_1_1_A = mkA "mångstämmig" ;
  maangtydig_av_1_1_A = mkA "mångtydig" ;
  maangvetenskaplig_av_1_1_A = mkA "mångvetenskaplig" ;
  maanljus_av_1_1_A = mkA "månljus" ;
  maattfull_av_1_1_A = mkA "måttfull" ;
  maattlig_av_1_1_A = mkA "måttlig" ;
  maattloes_av_1_1_A = mkA "måttlös" ;
  moeblerbar_av_1_1_A = mkA "möblerbar" ;
  moeglig_av_1_1_A = mkA "möglig" ;
  moejlig_av_1_1_A = mkA "möjlig" ;
  moenstergill_av_1_1_A = mkA "mönstergill" ;
  moer_av_1_1_A = mkA "mör" ;
  moerjig_av_1_1_A = mkA "mörjig" ;
  moerk_av_1_1_A = mkA "mörk" ;
  moerkbrun_av_1_1_A = mkA "mörkbrun" ;
  moerkgroen_av_1_1_A = mkA "mörkgrön" ;
  moerkgul_av_1_1_A = mkA "mörkgul" ;
  moerkhaarig_av_1_1_A = mkA "mörkhårig" ;
  moerklockig_av_1_1_A = mkA "mörklockig" ;
  nackstyv_av_1_A = mkA "nackstyv" ;
  naiv_av_1_A = mkA "naiv" ;
  naivistisk_av_1_A = mkA "naivistisk" ;
  nakenfroeig_av_1_1_A = mkA "nakenfröig" ;
  namibisk_av_1_A = mkA "namibisk" ;
  namnkunnig_av_1_A = mkA "namnkunnig" ;
  namnloes_av_1_1_A = mkA "namnlös" ;
  namnmaessig_av_1_1_A = mkA "namnmässig" ;
  napolitansk_av_1_A = mkA "napolitansk" ;
  narig_av_1_A = mkA "narig" ;
  narkotisk_av_1_A = mkA "narkotisk" ;
  narraktig_av_1_A = mkA "narraktig" ;
  narrativ_av_1_A = mkA "narrativ" ;
  nasal_av_1_A = mkA "nasal" ;
  nasalerbar_av_1_A = mkA "nasalerbar" ;
  nasaliserbar_av_1_A = mkA "nasaliserbar" ;
  nationalekonomisk_av_1_A = mkA "nationalekonomisk" ;
  nationaliserbar_av_1_A = mkA "nationaliserbar" ;
  nationalistisk_av_1_A = mkA "nationalistisk" ;
  nationalromantisk_av_1_A = mkA "nationalromantisk" ;
  nationalsocialistisk_av_1_A = mkA "nationalsocialistisk" ;
  nationell_av_1_A = mkA "nationell" ;
  nativ_av_1_A = mkA "nativ" ;
  nattaktiv_av_1_A = mkA "nattaktiv" ;
  nattlig_av_1_A = mkA "nattlig" ;
  nattlik_av_1_A = mkA "nattlik" ;
  naturaliserbar_av_1_A = mkA "naturaliserbar" ;
  naturalistisk_av_1_A = mkA "naturalistisk" ;
  naturell_av_1_A = mkA "naturell" ;
  naturenlig_av_1_A = mkA "naturenlig" ;
  naturhistorisk_av_1_A = mkA "naturhistorisk" ;
  naturlig_av_1_A = mkA "naturlig" ;
  naturmaessig_av_1_1_A = mkA "naturmässig" ;
  naturnoedvaendig_av_1_1_A = mkA "naturnödvändig" ;
  naturskoen_av_1_1_A = mkA "naturskön" ;
  naturstridig_av_1_A = mkA "naturstridig" ;
  naturvetenskaplig_av_1_A = mkA "naturvetenskaplig" ;
  naturvidrig_av_1_A = mkA "naturvidrig" ;
  naurisk_av_1_A = mkA "naurisk" ;
  nautisk_av_1_A = mkA "nautisk" ;
  navalmedicinsk_av_1_A = mkA "navalmedicinsk" ;
  navigerbar_av_1_A = mkA "navigerbar" ;
  nazistisk_av_1_A = mkA "nazistisk" ;
  neapolitansk_av_1_A = mkA "neapolitansk" ;
  nebuloes_av_1_1_A = mkA "nebulös" ;
  nederlaendsk_av_1_1_A = mkA "nederländsk" ;
  nedmoerk_av_1_1_A = mkA "nedmörk" ;
  nedrig_av_1_A = mkA "nedrig" ;
  nedtransformerbar_av_1_A = mkA "nedtransformerbar" ;
  nedtransponerbar_av_1_A = mkA "nedtransponerbar" ;
  nedvaerderbar_av_1_1_A = mkA "nedvärderbar" ;
  nefritisk_av_1_A = mkA "nefritisk" ;
  negativ_av_1_A = mkA "negativ" ;
  negerbar_av_1_A = mkA "negerbar" ;
  negligerbar_av_1_A = mkA "negligerbar" ;
  negocierbar_av_1_A = mkA "negocierbar" ;
  negotierbar_av_1_A = mkA "negotierbar" ;
  neokolonialistisk_av_1_A = mkA "neokolonialistisk" ;
  neolitisk_av_1_A = mkA "neolitisk" ;
  neotektonisk_av_1_A = mkA "neotektonisk" ;
  nepalesisk_av_1_A = mkA "nepalesisk" ;
  neptunisk_av_1_A = mkA "neptunisk" ;
  nermoerk_av_1_1_A = mkA "nermörk" ;
  nertransformerbar_av_1_A = mkA "nertransformerbar" ;
  nertransponerbar_av_1_A = mkA "nertransponerbar" ;
  nervig_av_1_A = mkA "nervig" ;
  nervaerderbar_av_1_1_A = mkA "nervärderbar" ;
  nervoes_av_1_1_A = mkA "nervös" ;
  neslig_av_1_A = mkA "neslig" ;
  nestoriansk_av_1_A = mkA "nestoriansk" ;
  neuralgisk_av_1_A = mkA "neuralgisk" ;
  neurologisk_av_1_A = mkA "neurologisk" ;
  neurotisk_av_1_A = mkA "neurotisk" ;
  neutral_av_1_A = mkA "neutral" ;
  neutraliserbar_av_1_A = mkA "neutraliserbar" ;
  neutralistisk_av_1_A = mkA "neutralistisk" ;
  newfoundlaendsk_av_1_1_A = mkA "newfoundländsk" ;
  nicaraguansk_av_1_A = mkA "nicaraguansk" ;
  nidsk_av_1_A = mkA "nidsk" ;
  niellerbar_av_1_A = mkA "niellerbar" ;
  nigeriansk_av_1_A = mkA "nigeriansk" ;
  nigerisk_av_1_A = mkA "nigerisk" ;
  nihilistisk_av_1_A = mkA "nihilistisk" ;
  nikotingul_av_1_A = mkA "nikotingul" ;
  nipig_av_1_A = mkA "nipig" ;
  nipprig_av_1_A = mkA "nipprig" ;
  nitfull_av_1_A = mkA "nitfull" ;
  nitisk_av_1_A = mkA "nitisk" ;
  nitrerbar_av_1_A = mkA "nitrerbar" ;
  nitroes_av_1_1_A = mkA "nitrös" ;
  nittiofemoktanig_av_1_A = mkA "nittiofemoktanig" ;
  nittiosexprocentig_av_1_A = mkA "nittiosexprocentig" ;
  nittisexprocentig_av_1_A = mkA "nittisexprocentig" ;
  nivellerbar_av_1_A = mkA "nivellerbar" ;
  nivaagrupperbar_av_1_1_A = mkA "nivågrupperbar" ;
  njugg_av_1_A = mkA "njugg" ;
  njutbar_av_1_A = mkA "njutbar" ;
  njutningsfull_av_1_A = mkA "njutningsfull" ;
  njutningsmaessig_av_1_1_A = mkA "njutningsmässig" ;
  njutningsrik_av_1_A = mkA "njutningsrik" ;
  nobiliserbar_av_1_A = mkA "nobiliserbar" ;
  nojig_av_1_A = mkA "nojig" ;
  noltig_av_1_A = mkA "noltig" ;
  nomadisk_av_1_A = mkA "nomadisk" ;
  nominal_av_1_A = mkA "nominal" ;
  nominalistisk_av_1_A = mkA "nominalistisk" ;
  nominell_av_1_A = mkA "nominell" ;
  nominerbar_av_1_A = mkA "nominerbar" ;
  nonchalerbar_av_1_A = mkA "nonchalerbar" ;
  nonfigurativ_av_1_A = mkA "nonfigurativ" ;
  noppig_av_1_A = mkA "noppig" ;
  nopprig_av_1_A = mkA "nopprig" ;
  nord_sydlig_av_1_A = mkA "nord-sydlig" ;
  nordafrikansk_av_1_A = mkA "nordafrikansk" ;
  nordamerikansk_av_1_A = mkA "nordamerikansk" ;
  nordisk_av_1_A = mkA "nordisk" ;
  nordkoreansk_av_1_A = mkA "nordkoreansk" ;
  nordlig_av_1_A = mkA "nordlig" ;
  nordtysk_av_1_A = mkA "nordtysk" ;
  nordvietnamesisk_av_1_A = mkA "nordvietnamesisk" ;
  normal_av_1_A = mkA "normal" ;
  normaliserbar_av_1_A = mkA "normaliserbar" ;
  normalspaarig_av_1_1_A = mkA "normalspårig" ;
  normandisk_av_1_A = mkA "normandisk" ;
  normativ_av_1_A = mkA "normativ" ;
  normerbar_av_1_A = mkA "normerbar" ;
  normloes_av_1_1_A = mkA "normlös" ;
  norrbottnisk_av_1_A = mkA "norrbottnisk" ;
  norrlaendsk_av_1_1_A = mkA "norrländsk" ;
  norroen_av_1_1_A = mkA "norrön" ;
  norsk_av_1_A = mkA "norsk" ;
  nosig_av_1_A = mkA "nosig" ;
  noskig_av_1_A = mkA "noskig" ;
  nostalgisk_av_1_A = mkA "nostalgisk" ;
  noterbar_av_1_A = mkA "noterbar" ;
  notificerbar_av_1_A = mkA "notificerbar" ;
  notifierbar_av_1_A = mkA "notifierbar" ;
  notiserbar_av_1_A = mkA "notiserbar" ;
  notorisk_av_1_A = mkA "notorisk" ;
  novantik_av_1_A = mkA "novantik" ;
  novellistisk_av_1_A = mkA "novellistisk" ;
  nubisk_av_1_A = mkA "nubisk" ;
  nuckig_av_1_A = mkA "nuckig" ;
  nudistisk_av_1_A = mkA "nudistisk" ;
  nukleaer_av_1_1_A = mkA "nukleär" ;
  numerisk_av_1_A = mkA "numerisk" ;
  numeraer_av_1_1_A = mkA "numerär" ;
  numinoes_av_1_1_A = mkA "numinös" ;
  numismatisk_av_1_A = mkA "numismatisk" ;
  numrerbar_av_1_A = mkA "numrerbar" ;
  nuspraaklig_av_1_1_A = mkA "nuspråklig" ;
  nusvensk_av_1_A = mkA "nusvensk" ;
  nutritiv_av_1_A = mkA "nutritiv" ;
  nuvig_av_1_A = mkA "nuvig" ;
  nyanserbar_av_1_A = mkA "nyanserbar" ;
  nyansloes_av_1_1_A = mkA "nyanslös" ;
  nyantik_av_1_A = mkA "nyantik" ;
  nyckelfaerdig_av_1_1_A = mkA "nyckelfärdig" ;
  nyckfull_av_1_A = mkA "nyckfull" ;
  nyemitterbar_av_1_A = mkA "nyemitterbar" ;
  nyetablerbar_av_1_A = mkA "nyetablerbar" ;
  nyhetsmaessig_av_1_1_A = mkA "nyhetsmässig" ;
  nyinvesterbar_av_1_A = mkA "nyinvesterbar" ;
  nyklassicistisk_av_1_A = mkA "nyklassicistisk" ;
  nyklassisk_av_1_A = mkA "nyklassisk" ;
  nyliberal_av_1_A = mkA "nyliberal" ;
  nylaendsk_av_1_1_A = mkA "nyländsk" ;
  nymodig_av_1_A = mkA "nymodig" ;
  nynorsk_av_1_A = mkA "nynorsk" ;
  nyplanterbar_av_1_A = mkA "nyplanterbar" ;
  nyplatonsk_av_1_A = mkA "nyplatonsk" ;
  nyrik_av_1_A = mkA "nyrik" ;
  nysvensk_av_1_A = mkA "nysvensk" ;
  nytestamentlig_av_1_A = mkA "nytestamentlig" ;
  nyttig_av_1_A = mkA "nyttig" ;
  nyzeelaendsk_av_1_1_A = mkA "nyzeeländsk" ;
  naebbig_av_1_1_A = mkA "näbbig" ;
  naemnbar_av_1_1_A = mkA "nämnbar" ;
  naerig_av_1_1_A = mkA "närig" ;
  naeringsfattig_av_1_1_A = mkA "näringsfattig" ;
  naeringsfysiologisk_av_1_1_A = mkA "näringsfysiologisk" ;
  naeringslivsmaessig_av_1_1_A = mkA "näringslivsmässig" ;
  naeringsmaessig_av_1_1_A = mkA "näringsmässig" ;
  naeringsrik_av_1_1_A = mkA "näringsrik" ;
  naerkingsk_av_1_1_A = mkA "närkingsk" ;
  naesvis_av_1_1_A = mkA "näsvis" ;
  naetformig_av_1_1_A = mkA "nätformig" ;
  naetvan_av_1_1_A = mkA "nätvan" ;
  naadelig_av_1_1_A = mkA "nådelig" ;
  naadig_av_1_1_A = mkA "nådig" ;
  naalfin_av_1_1_A = mkA "nålfin" ;
  noedig_av_1_1_A = mkA "nödig" ;
  noedtorftig_av_1_1_A = mkA "nödtorftig" ;
  noedvaendig_av_1_1_A = mkA "nödvändig" ;
  noejaktig_av_1_1_A = mkA "nöjaktig" ;
  noerdig_av_1_1_A = mkA "nördig" ;
  noetbrun_av_1_1_A = mkA "nötbrun" ;
  noetningsbestaendig_av_1_1_A = mkA "nötningsbeständig" ;
  noetningsresistent_av_1_1_A = mkA "nötningsresistent" ;
  oabbrevierbar_av_1_A = mkA "oabbrevierbar" ;
  oabdikerbar_av_1_A = mkA "oabdikerbar" ;
  oabonnerbar_av_1_A = mkA "oabonnerbar" ;
  oaborterbar_av_1_A = mkA "oaborterbar" ;
  oabraderbar_av_1_A = mkA "oabraderbar" ;
  oabsolverbar_av_1_A = mkA "oabsolverbar" ;
  oabsorberbar_av_1_A = mkA "oabsorberbar" ;
  oabstraherbar_av_1_A = mkA "oabstraherbar" ;
  oaccederbar_av_1_A = mkA "oaccederbar" ;
  oaccelererbar_av_1_A = mkA "oaccelererbar" ;
  oaccentuerbar_av_1_A = mkA "oaccentuerbar" ;
  oaccepterbar_av_1_A = mkA "oaccepterbar" ;
  oacklimatiserbar_av_1_A = mkA "oacklimatiserbar" ;
  oackommoderbar_av_1_A = mkA "oackommoderbar" ;
  oackompanjerbar_av_1_A = mkA "oackompanjerbar" ;
  oackorderbar_av_1_A = mkA "oackorderbar" ;
  oackrediterbar_av_1_A = mkA "oackrediterbar" ;
  oackumulerbar_av_1_A = mkA "oackumulerbar" ;
  oackvirerbar_av_1_A = mkA "oackvirerbar" ;
  oadapterbar_av_1_A = mkA "oadapterbar" ;
  oadderbar_av_1_A = mkA "oadderbar" ;
  oadjungerbar_av_1_A = mkA "oadjungerbar" ;
  oadministrerbar_av_1_A = mkA "oadministrerbar" ;
  oadopterbar_av_1_A = mkA "oadopterbar" ;
  oadresserbar_av_1_A = mkA "oadresserbar" ;
  oadsorberbar_av_1_A = mkA "oadsorberbar" ;
  oaducerbar_av_1_A = mkA "oaducerbar" ;
  oadvocerbar_av_1_A = mkA "oadvocerbar" ;
  oafficierbar_av_1_A = mkA "oafficierbar" ;
  oaffinerbar_av_1_A = mkA "oaffinerbar" ;
  oaffischerbar_av_1_A = mkA "oaffischerbar" ;
  oafrikaniserbar_av_1_A = mkA "oafrikaniserbar" ;
  oagerbar_av_1_A = mkA "oagerbar" ;
  oagglomererbar_av_1_A = mkA "oagglomererbar" ;
  oagglutinerbar_av_1_A = mkA "oagglutinerbar" ;
  oagiterbar_av_1_A = mkA "oagiterbar" ;
  oajournerbar_av_1_A = mkA "oajournerbar" ;
  oaktiverbar_av_1_A = mkA "oaktiverbar" ;
  oaktualiserbar_av_1_A = mkA "oaktualiserbar" ;
  oalarmerbar_av_1_A = mkA "oalarmerbar" ;
  oalfabetiserbar_av_1_A = mkA "oalfabetiserbar" ;
  oalienerbar_av_1_A = mkA "oalienerbar" ;
  oallegoriserbar_av_1_A = mkA "oallegoriserbar" ;
  oallierbar_av_1_A = mkA "oallierbar" ;
  oallittererbar_av_1_A = mkA "oallittererbar" ;
  oallokerbar_av_1_A = mkA "oallokerbar" ;
  oalluderbar_av_1_A = mkA "oalluderbar" ;
  oalternerbar_av_1_A = mkA "oalternerbar" ;
  oaluminerbar_av_1_A = mkA "oaluminerbar" ;
  oamalgamerbar_av_1_A = mkA "oamalgamerbar" ;
  oambulerbar_av_1_A = mkA "oambulerbar" ;
  oamerikaniserbar_av_1_A = mkA "oamerikaniserbar" ;
  oamerikansk_av_1_A = mkA "oamerikansk" ;
  oamorterbar_av_1_A = mkA "oamorterbar" ;
  oamplifierbar_av_1_A = mkA "oamplifierbar" ;
  oamputerbar_av_1_A = mkA "oamputerbar" ;
  oanalyserbar_av_1_A = mkA "oanalyserbar" ;
  oandlig_av_1_A = mkA "oandlig" ;
  oanfaektbar_av_1_1_A = mkA "oanfäktbar" ;
  oanfaektlig_av_1_1_A = mkA "oanfäktlig" ;
  oangenaem_av_1_1_A = mkA "oangenäm" ;
  oangliserbar_av_1_A = mkA "oangliserbar" ;
  oangripbar_av_1_A = mkA "oangripbar" ;
  oangriplig_av_1_A = mkA "oangriplig" ;
  oanimerbar_av_1_A = mkA "oanimerbar" ;
  oannekterbar_av_1_A = mkA "oannekterbar" ;
  oannihilerbar_av_1_A = mkA "oannihilerbar" ;
  oannonserbar_av_1_A = mkA "oannonserbar" ;
  oannoterbar_av_1_A = mkA "oannoterbar" ;
  oannullerbar_av_1_A = mkA "oannullerbar" ;
  oanodiserbar_av_1_A = mkA "oanodiserbar" ;
  oanonymiserbar_av_1_A = mkA "oanonymiserbar" ;
  oansenlig_av_1_A = mkA "oansenlig" ;
  oanstaendig_av_1_1_A = mkA "oanständig" ;
  oansvarig_av_1_A = mkA "oansvarig" ;
  oantagbar_av_1_A = mkA "oantagbar" ;
  oantaglig_av_1_A = mkA "oantaglig" ;
  oantastbar_av_1_A = mkA "oantastbar" ;
  oantastlig_av_1_A = mkA "oantastlig" ;
  oanteciperbar_av_1_A = mkA "oanteciperbar" ;
  oantedaterbar_av_1_A = mkA "oantedaterbar" ;
  oantichambrerbar_av_1_A = mkA "oantichambrerbar" ;
  oantikiserbar_av_1_A = mkA "oantikiserbar" ;
  oantraeffbar_av_1_1_A = mkA "oanträffbar" ;
  oanvaendbar_av_1_1_A = mkA "oanvändbar" ;
  oapostroferbar_av_1_A = mkA "oapostroferbar" ;
  oappellerbar_av_1_A = mkA "oappellerbar" ;
  oapplicerbar_av_1_A = mkA "oapplicerbar" ;
  oapplaaderbar_av_1_1_A = mkA "oapplåderbar" ;
  oapporterbar_av_1_A = mkA "oapporterbar" ;
  oapprecierbar_av_1_A = mkA "oapprecierbar" ;
  oappreterbar_av_1_A = mkA "oappreterbar" ;
  oapprocherbar_av_1_A = mkA "oapprocherbar" ;
  oapproximerbar_av_1_A = mkA "oapproximerbar" ;
  oapterbar_av_1_A = mkA "oapterbar" ;
  oaptitlig_av_1_A = mkA "oaptitlig" ;
  oargumenterbar_av_1_A = mkA "oargumenterbar" ;
  oarkaiserbar_av_1_A = mkA "oarkaiserbar" ;
  oarkebuserbar_av_1_A = mkA "oarkebuserbar" ;
  oarkiverbar_av_1_A = mkA "oarkiverbar" ;
  oarmerbar_av_1_A = mkA "oarmerbar" ;
  oarrangerbar_av_1_A = mkA "oarrangerbar" ;
  oarrenderbar_av_1_A = mkA "oarrenderbar" ;
  oarresterbar_av_1_A = mkA "oarresterbar" ;
  oarronderbar_av_1_A = mkA "oarronderbar" ;
  oartig_av_1_A = mkA "oartig" ;
  oartikulerbar_av_1_A = mkA "oartikulerbar" ;
  oarvoderbar_av_1_A = mkA "oarvoderbar" ;
  oasfalterbar_av_1_A = mkA "oasfalterbar" ;
  oaspirerbar_av_1_A = mkA "oaspirerbar" ;
  oassignerbar_av_1_A = mkA "oassignerbar" ;
  oassimilerbar_av_1_A = mkA "oassimilerbar" ;
  oassisterbar_av_1_A = mkA "oassisterbar" ;
  oassocierbar_av_1_A = mkA "oassocierbar" ;
  oassurerbar_av_1_A = mkA "oassurerbar" ;
  oatrofierbar_av_1_A = mkA "oatrofierbar" ;
  oattackerbar_av_1_A = mkA "oattackerbar" ;
  oattesterbar_av_1_A = mkA "oattesterbar" ;
  oattraherbar_av_1_A = mkA "oattraherbar" ;
  oattrapperbar_av_1_A = mkA "oattrapperbar" ;
  oattribuerbar_av_1_A = mkA "oattribuerbar" ;
  oauktionerbar_av_1_A = mkA "oauktionerbar" ;
  oauktoriserbar_av_1_A = mkA "oauktoriserbar" ;
  oauskulterbar_av_1_A = mkA "oauskulterbar" ;
  oautenticerbar_av_1_A = mkA "oautenticerbar" ;
  oautentifierbar_av_1_A = mkA "oautentifierbar" ;
  oautentiserbar_av_1_A = mkA "oautentiserbar" ;
  oautomatiserbar_av_1_A = mkA "oautomatiserbar" ;
  oavancerbar_av_1_A = mkA "oavancerbar" ;
  oavannonserbar_av_1_A = mkA "oavannonserbar" ;
  oavdramatiserbar_av_1_A = mkA "oavdramatiserbar" ;
  oavhaengig_av_1_1_A = mkA "oavhängig" ;
  oaviserbar_av_1_A = mkA "oaviserbar" ;
  oavkoloniserbar_av_1_A = mkA "oavkoloniserbar" ;
  oavkriminaliserbar_av_1_A = mkA "oavkriminaliserbar" ;
  oavlaatlig_av_1_1_A = mkA "oavlåtlig" ;
  oavmagnetiserbar_av_1_A = mkA "oavmagnetiserbar" ;
  oavmystifierbar_av_1_A = mkA "oavmystifierbar" ;
  oavnazifierbar_av_1_A = mkA "oavnazifierbar" ;
  oavpatrullerbar_av_1_A = mkA "oavpatrullerbar" ;
  oavpolitiserbar_av_1_A = mkA "oavpolitiserbar" ;
  oavpolletterbar_av_1_A = mkA "oavpolletterbar" ;
  oavportraetterbar_av_1_1_A = mkA "oavporträtterbar" ;
  oavreagerbar_av_1_A = mkA "oavreagerbar" ;
  oavregistrerbar_av_1_A = mkA "oavregistrerbar" ;
  oavreglerbar_av_1_A = mkA "oavreglerbar" ;
  oavromantiserbar_av_1_A = mkA "oavromantiserbar" ;
  oavsiktlig_av_1_A = mkA "oavsiktlig" ;
  oavsocialiserbar_av_1_A = mkA "oavsocialiserbar" ;
  oavstaliniserbar_av_1_A = mkA "oavstaliniserbar" ;
  oavsaettlig_av_1_1_A = mkA "oavsättlig" ;
  oavvisbar_av_1_A = mkA "oavvisbar" ;
  oavvislig_av_1_A = mkA "oavvislig" ;
  oavytterlig_av_1_A = mkA "oavytterlig" ;
  oaxiomatiserbar_av_1_A = mkA "oaxiomatiserbar" ;
  obagatelliserbar_av_1_A = mkA "obagatelliserbar" ;
  obalanserbar_av_1_A = mkA "obalanserbar" ;
  oballoterbar_av_1_A = mkA "oballoterbar" ;
  obalsamerbar_av_1_A = mkA "obalsamerbar" ;
  obanaliserbar_av_1_A = mkA "obanaliserbar" ;
  obankrutterbar_av_1_A = mkA "obankrutterbar" ;
  obarmhaertig_av_1_1_A = mkA "obarmhärtig" ;
  obarrikaderbar_av_1_A = mkA "obarrikaderbar" ;
  obaserbar_av_1_A = mkA "obaserbar" ;
  obducerbar_av_1_A = mkA "obducerbar" ;
  obeatifierbar_av_1_A = mkA "obeatifierbar" ;
  obeboelig_av_1_A = mkA "obeboelig" ;
  obefintlig_av_1_A = mkA "obefintlig" ;
  obegriplig_av_1_A = mkA "obegriplig" ;
  obehaglig_av_1_A = mkA "obehaglig" ;
  obehoerig_av_1_1_A = mkA "obehörig" ;
  obehoevlig_av_1_1_A = mkA "obehövlig" ;
  obekvaem_av_1_1_A = mkA "obekväm" ;
  oberaeknelig_av_1_1_A = mkA "oberäknelig" ;
  oberoerbar_av_1_1_A = mkA "oberörbar" ;
  obeskrivbar_av_1_A = mkA "obeskrivbar" ;
  obeskrivlig_av_1_A = mkA "obeskrivlig" ;
  obesticklig_av_1_A = mkA "obesticklig" ;
  obestridlig_av_1_A = mkA "obestridlig" ;
  obestaellbar_av_1_1_A = mkA "obeställbar" ;
  obestaembar_av_1_1_A = mkA "obestämbar" ;
  obestaendig_av_1_1_A = mkA "obeständig" ;
  obetalbar_av_1_A = mkA "obetalbar" ;
  obetongerbar_av_1_A = mkA "obetongerbar" ;
  obetvinglig_av_1_A = mkA "obetvinglig" ;
  obetydlig_av_1_A = mkA "obetydlig" ;
  obeveklig_av_1_A = mkA "obeveklig" ;
  obildbar_av_1_A = mkA "obildbar" ;
  obillig_av_1_A = mkA "obillig" ;
  obiograferbar_av_1_A = mkA "obiograferbar" ;
  obisserbar_av_1_A = mkA "obisserbar" ;
  obivackerbar_av_1_A = mkA "obivackerbar" ;
  objektiv_av_1_A = mkA "objektiv" ;
  objektiverbar_av_1_A = mkA "objektiverbar" ;
  oblancherbar_av_1_A = mkA "oblancherbar" ;
  oblankpolerbar_av_1_A = mkA "oblankpolerbar" ;
  oblesserbar_av_1_A = mkA "oblesserbar" ;
  oblidkelig_av_1_A = mkA "oblidkelig" ;
  obligatorisk_av_1_A = mkA "obligatorisk" ;
  obligerbar_av_1_A = mkA "obligerbar" ;
  oblik_av_1_A = mkA "oblik" ;
  oblinderbar_av_1_A = mkA "oblinderbar" ;
  oblockerbar_av_1_A = mkA "oblockerbar" ;
  oblodig_av_1_A = mkA "oblodig" ;
  oblommograferbar_av_1_A = mkA "oblommograferbar" ;
  oblonderbar_av_1_A = mkA "oblonderbar" ;
  oblyg_av_1_A = mkA "oblyg" ;
  oboaserbar_av_1_A = mkA "oboaserbar" ;
  obogserbar_av_1_A = mkA "obogserbar" ;
  obokstaverbar_av_1_A = mkA "obokstaverbar" ;
  obombarderbar_av_1_A = mkA "obombarderbar" ;
  oboniterbar_av_1_A = mkA "oboniterbar" ;
  obortresonerbar_av_1_A = mkA "obortresonerbar" ;
  obotfaerdig_av_1_1_A = mkA "obotfärdig" ;
  obotlig_av_1_A = mkA "obotlig" ;
  obriketterbar_av_1_A = mkA "obriketterbar" ;
  obriserbar_av_1_A = mkA "obriserbar" ;
  obroderbar_av_1_A = mkA "obroderbar" ;
  obromerbar_av_1_A = mkA "obromerbar" ;
  obronserbar_av_1_A = mkA "obronserbar" ;
  obroscherbar_av_1_A = mkA "obroscherbar" ;
  obrottslig_av_1_A = mkA "obrottslig" ;
  obrukbar_av_1_A = mkA "obrukbar" ;
  obruklig_av_1_A = mkA "obruklig" ;
  obrunerbar_av_1_A = mkA "obrunerbar" ;
  obrutaliserbar_av_1_A = mkA "obrutaliserbar" ;
  obrytbar_av_1_A = mkA "obrytbar" ;
  obraeserbar_av_1_1_A = mkA "obräserbar" ;
  observerbar_av_1_A = mkA "observerbar" ;
  obskur_av_1_A = mkA "obskur" ;
  obskyr_av_1_A = mkA "obskyr" ;
  obstetrisk_av_1_A = mkA "obstetrisk" ;
  obudgeterbar_av_1_A = mkA "obudgeterbar" ;
  obuteljerbar_av_1_A = mkA "obuteljerbar" ;
  obyraakratiserbar_av_1_1_A = mkA "obyråkratiserbar" ;
  obaendig_av_1_1_A = mkA "obändig" ;
  oboejlig_av_1_1_A = mkA "oböjlig" ;
  oboenhoerlig_av_1_1_A = mkA "obönhörlig" ;
  ocamouflerbar_av_1_A = mkA "ocamouflerbar" ;
  occidental_av_1_A = mkA "occidental" ;
  occidentaliserbar_av_1_A = mkA "occidentaliserbar" ;
  occidentalisk_av_1_A = mkA "occidentalisk" ;
  oceanisk_av_1_A = mkA "oceanisk" ;
  oceanografisk_av_1_A = mkA "oceanografisk" ;
  ocederbar_av_1_A = mkA "ocederbar" ;
  ocelebrerbar_av_1_A = mkA "ocelebrerbar" ;
  ocementerbar_av_1_A = mkA "ocementerbar" ;
  ocensurerbar_av_1_A = mkA "ocensurerbar" ;
  ocentraliserbar_av_1_A = mkA "ocentraliserbar" ;
  ocentrerbar_av_1_A = mkA "ocentrerbar" ;
  ocentrifugerbar_av_1_A = mkA "ocentrifugerbar" ;
  ocernerbar_av_1_A = mkA "ocernerbar" ;
  ochargerbar_av_1_A = mkA "ochargerbar" ;
  ocharmerbar_av_1_A = mkA "ocharmerbar" ;
  ochevroterbar_av_1_A = mkA "ochevroterbar" ;
  ochiffrerbar_av_1_A = mkA "ochiffrerbar" ;
  ochikanerbar_av_1_A = mkA "ochikanerbar" ;
  ochockerbar_av_1_A = mkA "ochockerbar" ;
  ocirkulerbar_av_1_A = mkA "ocirkulerbar" ;
  ociselerbar_av_1_A = mkA "ociselerbar" ;
  ociterbar_av_1_A = mkA "ociterbar" ;
  ociviliserbar_av_1_A = mkA "ociviliserbar" ;
  ockasionell_av_1_A = mkA "ockasionell" ;
  ockuperbar_av_1_A = mkA "ockuperbar" ;
  ocuraterbar_av_1_A = mkA "ocuraterbar" ;
  ocurerbar_av_1_A = mkA "ocurerbar" ;
  odaterbar_av_1_A = mkA "odaterbar" ;
  odatoriserbar_av_1_A = mkA "odatoriserbar" ;
  odebarkerbar_av_1_A = mkA "odebarkerbar" ;
  odebatterbar_av_1_A = mkA "odebatterbar" ;
  odebiterbar_av_1_A = mkA "odebiterbar" ;
  odecentraliserbar_av_1_A = mkA "odecentraliserbar" ;
  odechiffrerbar_av_1_A = mkA "odechiffrerbar" ;
  odecimerbar_av_1_A = mkA "odecimerbar" ;
  odedicerbar_av_1_A = mkA "odedicerbar" ;
  odedikerbar_av_1_A = mkA "odedikerbar" ;
  odeducerbar_av_1_A = mkA "odeducerbar" ;
  odefilerbar_av_1_A = mkA "odefilerbar" ;
  odefinierbar_av_1_A = mkA "odefinierbar" ;
  odeflorerbar_av_1_A = mkA "odeflorerbar" ;
  odeformerbar_av_1_A = mkA "odeformerbar" ;
  odegenererbar_av_1_A = mkA "odegenererbar" ;
  odegraderbar_av_1_A = mkA "odegraderbar" ;
  odekanterbar_av_1_A = mkA "odekanterbar" ;
  odekapiterbar_av_1_A = mkA "odekapiterbar" ;
  odeklamerbar_av_1_A = mkA "odeklamerbar" ;
  odeklarerbar_av_1_A = mkA "odeklarerbar" ;
  odeklasserbar_av_1_A = mkA "odeklasserbar" ;
  odeklinerbar_av_1_A = mkA "odeklinerbar" ;
  odekorerbar_av_1_A = mkA "odekorerbar" ;
  odekouragerbar_av_1_A = mkA "odekouragerbar" ;
  odekreterbar_av_1_A = mkA "odekreterbar" ;
  odelbar_av_1_A = mkA "odelbar" ;
  odelegerbar_av_1_A = mkA "odelegerbar" ;
  odemaskerbar_av_1_A = mkA "odemaskerbar" ;
  odementerbar_av_1_A = mkA "odementerbar" ;
  odemilitariserbar_av_1_A = mkA "odemilitariserbar" ;
  odemobiliserbar_av_1_A = mkA "odemobiliserbar" ;
  odemokratiserbar_av_1_A = mkA "odemokratiserbar" ;
  odemokratisk_av_1_A = mkA "odemokratisk" ;
  odemolerbar_av_1_A = mkA "odemolerbar" ;
  odemoniserbar_av_1_A = mkA "odemoniserbar" ;
  odemonstrerbar_av_1_A = mkA "odemonstrerbar" ;
  odemonterbar_av_1_A = mkA "odemonterbar" ;
  odemoraliserbar_av_1_A = mkA "odemoraliserbar" ;
  odenaturaliserbar_av_1_A = mkA "odenaturaliserbar" ;
  odenaturerbar_av_1_A = mkA "odenaturerbar" ;
  odenoterbar_av_1_A = mkA "odenoterbar" ;
  odenuderbar_av_1_A = mkA "odenuderbar" ;
  odeodoriserbar_av_1_A = mkA "odeodoriserbar" ;
  odepatrierbar_av_1_A = mkA "odepatrierbar" ;
  odepenserbar_av_1_A = mkA "odepenserbar" ;
  odeplacerbar_av_1_A = mkA "odeplacerbar" ;
  odeponerbar_av_1_A = mkA "odeponerbar" ;
  odeporterbar_av_1_A = mkA "odeporterbar" ;
  odeprecierbar_av_1_A = mkA "odeprecierbar" ;
  oderangerbar_av_1_A = mkA "oderangerbar" ;
  oderiverbar_av_1_A = mkA "oderiverbar" ;
  odesarmerbar_av_1_A = mkA "odesarmerbar" ;
  odesavouerbar_av_1_A = mkA "odesavouerbar" ;
  odesensibiliserbar_av_1_A = mkA "odesensibiliserbar" ;
  odesignerbar_av_1_A = mkA "odesignerbar" ;
  odesinfekterbar_av_1_A = mkA "odesinfekterbar" ;
  odesinficerbar_av_1_A = mkA "odesinficerbar" ;
  odesinformerbar_av_1_A = mkA "odesinformerbar" ;
  odesorganiserbar_av_1_A = mkA "odesorganiserbar" ;
  odestabiliserbar_av_1_A = mkA "odestabiliserbar" ;
  odestillerbar_av_1_A = mkA "odestillerbar" ;
  odestinerbar_av_1_A = mkA "odestinerbar" ;
  odestruerbar_av_1_A = mkA "odestruerbar" ;
  odetacherbar_av_1_A = mkA "odetacherbar" ;
  odetekterbar_av_1_A = mkA "odetekterbar" ;
  odeterminerbar_av_1_A = mkA "odeterminerbar" ;
  odetonerbar_av_1_A = mkA "odetonerbar" ;
  odetroniserbar_av_1_A = mkA "odetroniserbar" ;
  odevalverbar_av_1_A = mkA "odevalverbar" ;
  odiagnosticerbar_av_1_A = mkA "odiagnosticerbar" ;
  odiagnostiserbar_av_1_A = mkA "odiagnostiserbar" ;
  odialyserbar_av_1_A = mkA "odialyserbar" ;
  odifferentierbar_av_1_A = mkA "odifferentierbar" ;
  odiffunderbar_av_1_A = mkA "odiffunderbar" ;
  odiftongerbar_av_1_A = mkA "odiftongerbar" ;
  odigererbar_av_1_A = mkA "odigererbar" ;
  odikterbar_av_1_A = mkA "odikterbar" ;
  odimensionerbar_av_1_A = mkA "odimensionerbar" ;
  odiplomatisk_av_1_A = mkA "odiplomatisk" ;
  odiplomerbar_av_1_A = mkA "odiplomerbar" ;
  odirigerbar_av_1_A = mkA "odirigerbar" ;
  odisambiguerbar_av_1_A = mkA "odisambiguerbar" ;
  odisciplinerbar_av_1_A = mkA "odisciplinerbar" ;
  odisharmonierbar_av_1_A = mkA "odisharmonierbar" ;
  odiskonterbar_av_1_A = mkA "odiskonterbar" ;
  odiskrediterbar_av_1_A = mkA "odiskrediterbar" ;
  odiskriminerbar_av_1_A = mkA "odiskriminerbar" ;
  odiskuterbar_av_1_A = mkA "odiskuterbar" ;
  odiskvalificerbar_av_1_A = mkA "odiskvalificerbar" ;
  odispascherbar_av_1_A = mkA "odispascherbar" ;
  odispenserbar_av_1_A = mkA "odispenserbar" ;
  odispergerbar_av_1_A = mkA "odispergerbar" ;
  odisponerbar_av_1_A = mkA "odisponerbar" ;
  odisputerbar_av_1_A = mkA "odisputerbar" ;
  odissekerbar_av_1_A = mkA "odissekerbar" ;
  odissimilerbar_av_1_A = mkA "odissimilerbar" ;
  odissocierbar_av_1_A = mkA "odissocierbar" ;
  odistanserbar_av_1_A = mkA "odistanserbar" ;
  odistraherbar_av_1_A = mkA "odistraherbar" ;
  odistribuerbar_av_1_A = mkA "odistribuerbar" ;
  odivergerbar_av_1_A = mkA "odivergerbar" ;
  odiversifierbar_av_1_A = mkA "odiversifierbar" ;
  odividerbar_av_1_A = mkA "odividerbar" ;
  odioes_av_1_1_A = mkA "odiös" ;
  odlingsbar_av_1_A = mkA "odlingsbar" ;
  odocerbar_av_1_A = mkA "odocerbar" ;
  odogmatiserbar_av_1_A = mkA "odogmatiserbar" ;
  odogmatisk_av_1_A = mkA "odogmatisk" ;
  odokumenterbar_av_1_A = mkA "odokumenterbar" ;
  odomesticerbar_av_1_A = mkA "odomesticerbar" ;
  odomicilierbar_av_1_A = mkA "odomicilierbar" ;
  odominerbar_av_1_A = mkA "odominerbar" ;
  odompterbar_av_1_A = mkA "odompterbar" ;
  odonerbar_av_1_A = mkA "odonerbar" ;
  odontologisk_av_1_A = mkA "odontologisk" ;
  odoserbar_av_1_A = mkA "odoserbar" ;
  odosserbar_av_1_A = mkA "odosserbar" ;
  odoterbar_av_1_A = mkA "odoterbar" ;
  odragerbar_av_1_A = mkA "odragerbar" ;
  odramatiserbar_av_1_A = mkA "odramatiserbar" ;
  odramatisk_av_1_A = mkA "odramatisk" ;
  odraperbar_av_1_A = mkA "odraperbar" ;
  odresserbar_av_1_A = mkA "odresserbar" ;
  odrickbar_av_1_A = mkA "odrickbar" ;
  odryg_av_1_A = mkA "odryg" ;
  odraeglig_av_1_1_A = mkA "odräglig" ;
  odraenerbar_av_1_1_A = mkA "odränerbar" ;
  odubblerbar_av_1_A = mkA "odubblerbar" ;
  oduglig_av_1_A = mkA "oduglig" ;
  oduperbar_av_1_A = mkA "oduperbar" ;
  oduplicerbar_av_1_A = mkA "oduplicerbar" ;
  odygdig_av_1_A = mkA "odygdig" ;
  odoedlig_av_1_1_A = mkA "odödlig" ;
  oederbar_av_1_A = mkA "oederbar" ;
  oeffacerbar_av_1_A = mkA "oeffacerbar" ;
  oeffektiverbar_av_1_A = mkA "oeffektiverbar" ;
  oeffektiviserbar_av_1_A = mkA "oeffektiviserbar" ;
  oeffektuerbar_av_1_A = mkA "oeffektuerbar" ;
  oefterdaterbar_av_1_A = mkA "oefterdaterbar" ;
  oefterdebiterbar_av_1_A = mkA "oefterdebiterbar" ;
  oeftergivlig_av_1_A = mkA "oeftergivlig" ;
  oefterhaermlig_av_1_1_A = mkA "oefterhärmlig" ;
  oefterrationaliserbar_av_1_A = mkA "oefterrationaliserbar" ;
  oefterraettlig_av_1_1_A = mkA "oefterrättlig" ;
  oeftersynkroniserbar_av_1_A = mkA "oeftersynkroniserbar" ;
  oeftertaxerbar_av_1_A = mkA "oeftertaxerbar" ;
  oegaliserbar_av_1_A = mkA "oegaliserbar" ;
  oegennyttig_av_1_A = mkA "oegennyttig" ;
  oegentlig_av_1_A = mkA "oegentlig" ;
  oekiperbar_av_1_A = mkA "oekiperbar" ;
  oeklaterbar_av_1_A = mkA "oeklaterbar" ;
  oeklaererbar_av_1_1_A = mkA "oeklärerbar" ;
  oekonomiserbar_av_1_A = mkA "oekonomiserbar" ;
  oekonomisk_av_1_A = mkA "oekonomisk" ;
  oelaborerbar_av_1_A = mkA "oelaborerbar" ;
  oelastiserbar_av_1_A = mkA "oelastiserbar" ;
  oelektrificerbar_av_1_A = mkA "oelektrificerbar" ;
  oelektrifierbar_av_1_A = mkA "oelektrifierbar" ;
  oelektriserbar_av_1_A = mkA "oelektriserbar" ;
  oeliderbar_av_1_A = mkA "oeliderbar" ;
  oeliminerbar_av_1_A = mkA "oeliminerbar" ;
  oeloxerbar_av_1_A = mkA "oeloxerbar" ;
  oeluderbar_av_1_A = mkA "oeluderbar" ;
  oeluerbar_av_1_A = mkA "oeluerbar" ;
  oemaljerbar_av_1_A = mkA "oemaljerbar" ;
  oemanciperbar_av_1_A = mkA "oemanciperbar" ;
  oemballerbar_av_1_A = mkA "oemballerbar" ;
  oembarkerbar_av_1_A = mkA "oembarkerbar" ;
  oembellerbar_av_1_A = mkA "oembellerbar" ;
  oemenderbar_av_1_A = mkA "oemenderbar" ;
  oemigrerbar_av_1_A = mkA "oemigrerbar" ;
  oemitterbar_av_1_A = mkA "oemitterbar" ;
  oemotstaandlig_av_1_1_A = mkA "oemotståndlig" ;
  oemotsaeglig_av_1_1_A = mkA "oemotsäglig" ;
  oemottaglig_av_1_A = mkA "oemottaglig" ;
  oemulgerbar_av_1_A = mkA "oemulgerbar" ;
  oendosserbar_av_1_A = mkA "oendosserbar" ;
  oenerverbar_av_1_A = mkA "oenerverbar" ;
  oengagerbar_av_1_A = mkA "oengagerbar" ;
  oenig_av_1_A = mkA "oenig" ;
  oenleverbar_av_1_A = mkA "oenleverbar" ;
  oenrollerbar_av_1_A = mkA "oenrollerbar" ;
  oensilerbar_av_1_A = mkA "oensilerbar" ;
  oentusiasmerbar_av_1_A = mkA "oentusiasmerbar" ;
  oepilerbar_av_1_A = mkA "oepilerbar" ;
  oerigerbar_av_1_A = mkA "oerigerbar" ;
  oeroderbar_av_1_A = mkA "oeroderbar" ;
  oersaettlig_av_1_1_A = mkA "oersättlig" ;
  oeskalerbar_av_1_A = mkA "oeskalerbar" ;
  oeskorterbar_av_1_A = mkA "oeskorterbar" ;
  oesteticerbar_av_1_A = mkA "oesteticerbar" ;
  oestetiserbar_av_1_A = mkA "oestetiserbar" ;
  oestetisk_av_1_A = mkA "oestetisk" ;
  oestimerbar_av_1_A = mkA "oestimerbar" ;
  oetablerbar_av_1_A = mkA "oetablerbar" ;
  oeteriserbar_av_1_A = mkA "oeteriserbar" ;
  oetiketterbar_av_1_A = mkA "oetiketterbar" ;
  oetisk_av_1_A = mkA "oetisk" ;
  oetymologiserbar_av_1_A = mkA "oetymologiserbar" ;
  oeuropeiserbar_av_1_A = mkA "oeuropeiserbar" ;
  oevakuerbar_av_1_A = mkA "oevakuerbar" ;
  oevaluerbar_av_1_A = mkA "oevaluerbar" ;
  oevalverbar_av_1_A = mkA "oevalverbar" ;
  oevaporerbar_av_1_A = mkA "oevaporerbar" ;
  oexaminerbar_av_1_A = mkA "oexaminerbar" ;
  oexcerperbar_av_1_A = mkA "oexcerperbar" ;
  oexciterbar_av_1_A = mkA "oexciterbar" ;
  oexekverbar_av_1_A = mkA "oexekverbar" ;
  oexemplifierbar_av_1_A = mkA "oexemplifierbar" ;
  oexercerbar_av_1_A = mkA "oexercerbar" ;
  oexkluderbar_av_1_A = mkA "oexkluderbar" ;
  oexkommunicerbar_av_1_A = mkA "oexkommunicerbar" ;
  oexpanderbar_av_1_A = mkA "oexpanderbar" ;
  oexpatrierbar_av_1_A = mkA "oexpatrierbar" ;
  oexpedierbar_av_1_A = mkA "oexpedierbar" ;
  oexpektorerbar_av_1_A = mkA "oexpektorerbar" ;
  oexplicerbar_av_1_A = mkA "oexplicerbar" ;
  oexploaterbar_av_1_A = mkA "oexploaterbar" ;
  oexploderbar_av_1_A = mkA "oexploderbar" ;
  oexponerbar_av_1_A = mkA "oexponerbar" ;
  oexporterbar_av_1_A = mkA "oexporterbar" ;
  oexproprierbar_av_1_A = mkA "oexproprierbar" ;
  oexstirperbar_av_1_A = mkA "oexstirperbar" ;
  oextemporerbar_av_1_A = mkA "oextemporerbar" ;
  oextraherbar_av_1_A = mkA "oextraherbar" ;
  oextrapolerbar_av_1_A = mkA "oextrapolerbar" ;
  ofabricerbar_av_1_A = mkA "ofabricerbar" ;
  ofabulerbar_av_1_A = mkA "ofabulerbar" ;
  ofacetterbar_av_1_A = mkA "ofacetterbar" ;
  ofakturerbar_av_1_A = mkA "ofakturerbar" ;
  ofalsifierbar_av_1_A = mkA "ofalsifierbar" ;
  ofantiserbar_av_1_A = mkA "ofantiserbar" ;
  ofantlig_av_1_A = mkA "ofantlig" ;
  ofarlig_av_1_A = mkA "ofarlig" ;
  ofascinerbar_av_1_A = mkA "ofascinerbar" ;
  ofasetterbar_av_1_A = mkA "ofasetterbar" ;
  ofasonerbar_av_1_A = mkA "ofasonerbar" ;
  ofattbar_av_1_A = mkA "ofattbar" ;
  ofattlig_av_1_A = mkA "ofattlig" ;
  ofavoriserbar_av_1_A = mkA "ofavoriserbar" ;
  ofelbar_av_1_A = mkA "ofelbar" ;
  ofermenterbar_av_1_A = mkA "ofermenterbar" ;
  ofeterbar_av_1_A = mkA "ofeterbar" ;
  offensiv_av_1_A = mkA "offensiv" ;
  offentlig_av_1_A = mkA "offentlig" ;
  offererbar_av_1_A = mkA "offererbar" ;
  officiell_av_1_A = mkA "officiell" ;
  officinell_av_1_A = mkA "officinell" ;
  officioes_av_1_1_A = mkA "officiös" ;
  ofilerbar_av_1_A = mkA "ofilerbar" ;
  ofilmatiserbar_av_1_A = mkA "ofilmatiserbar" ;
  ofiltrerbar_av_1_A = mkA "ofiltrerbar" ;
  ofin_av_1_A = mkA "ofin" ;
  ofinansierbar_av_1_A = mkA "ofinansierbar" ;
  ofingerbar_av_1_A = mkA "ofingerbar" ;
  ofinjusterbar_av_1_A = mkA "ofinjusterbar" ;
  ofinlandiserbar_av_1_A = mkA "ofinlandiserbar" ;
  ofixerbar_av_1_A = mkA "ofixerbar" ;
  oflamberbar_av_1_A = mkA "oflamberbar" ;
  oflankerbar_av_1_A = mkA "oflankerbar" ;
  oflatterbar_av_1_A = mkA "oflatterbar" ;
  oflekterbar_av_1_A = mkA "oflekterbar" ;
  ofluidiserbar_av_1_A = mkA "ofluidiserbar" ;
  ofluorerbar_av_1_A = mkA "ofluorerbar" ;
  ofluoriderbar_av_1_A = mkA "ofluoriderbar" ;
  ofokuserbar_av_1_A = mkA "ofokuserbar" ;
  ofolierbar_av_1_A = mkA "ofolierbar" ;
  ofonderbar_av_1_A = mkA "ofonderbar" ;
  oforcerbar_av_1_A = mkA "oforcerbar" ;
  oformaliserbar_av_1_A = mkA "oformaliserbar" ;
  oformerbar_av_1_A = mkA "oformerbar" ;
  oformlig_av_1_A = mkA "oformlig" ;
  oformulerbar_av_1_A = mkA "oformulerbar" ;
  ofosfaterbar_av_1_A = mkA "ofosfaterbar" ;
  ofossiliserbar_av_1_A = mkA "ofossiliserbar" ;
  ofotograferbar_av_1_A = mkA "ofotograferbar" ;
  ofragmenterbar_av_1_A = mkA "ofragmenterbar" ;
  ofraktionerbar_av_1_A = mkA "ofraktionerbar" ;
  oframkomlig_av_1_A = mkA "oframkomlig" ;
  ofrankerbar_av_1_A = mkA "ofrankerbar" ;
  ofraserbar_av_1_A = mkA "ofraserbar" ;
  ofrekventerbar_av_1_A = mkA "ofrekventerbar" ;
  ofriserbar_av_1_A = mkA "ofriserbar" ;
  ofriterbar_av_1_A = mkA "ofriterbar" ;
  ofrivillig_av_1_A = mkA "ofrivillig" ;
  ofronderbar_av_1_A = mkA "ofronderbar" ;
  ofrotterbar_av_1_A = mkA "ofrotterbar" ;
  ofruktbar_av_1_A = mkA "ofruktbar" ;
  ofrustrerbar_av_1_A = mkA "ofrustrerbar" ;
  ofraankomlig_av_1_1_A = mkA "ofrånkomlig" ;
  oftalmologisk_av_1_A = mkA "oftalmologisk" ;
  ofullkomlig_av_1_A = mkA "ofullkomlig" ;
  ofullstaendig_av_1_1_A = mkA "ofullständig" ;
  ofurnerbar_av_1_A = mkA "ofurnerbar" ;
  ofusionerbar_av_1_A = mkA "ofusionerbar" ;
  ofyndig_av_1_A = mkA "ofyndig" ;
  ofysiljerbar_av_1_A = mkA "ofysiljerbar" ;
  ofaerdig_av_1_1_A = mkA "ofärdig" ;
  ofaerserbar_av_1_1_A = mkA "ofärserbar" ;
  ofoer_av_1_1_A = mkA "oför" ;
  ofoerannonserbar_av_1_1_A = mkA "oförannonserbar" ;
  ofoerarglig_av_1_1_A = mkA "oförarglig" ;
  ofoerbraennelig_av_1_1_A = mkA "oförbrännelig" ;
  ofoerbaetterlig_av_1_1_A = mkA "oförbätterlig" ;
  ofoerdelaktig_av_1_1_A = mkA "ofördelaktig" ;
  ofoerenlig_av_1_1_A = mkA "oförenlig" ;
  ofoergloemlig_av_1_1_A = mkA "oförglömlig" ;
  ofoergriplig_av_1_1_A = mkA "oförgriplig" ;
  ofoergaetlig_av_1_1_A = mkA "oförgätlig" ;
  ofoerklarlig_av_1_1_A = mkA "oförklarlig" ;
  ofoerliknelig_av_1_1_A = mkA "oförliknelig" ;
  ofoerlaatlig_av_1_1_A = mkA "oförlåtlig" ;
  ofoerneklig_av_1_1_A = mkA "oförneklig" ;
  ofoernuftig_av_1_1_A = mkA "oförnuftig" ;
  ofoersiktig_av_1_1_A = mkA "oförsiktig" ;
  ofoerskotterbar_av_1_1_A = mkA "oförskotterbar" ;
  ofoersonlig_av_1_1_A = mkA "oförsonlig" ;
  ofoerstaaelig_av_1_1_A = mkA "oförståelig" ;
  ofoerstaandig_av_1_1_A = mkA "oförståndig" ;
  ofoerstoerbar_av_1_1_A = mkA "oförstörbar" ;
  ofoersvarlig_av_1_1_A = mkA "oförsvarlig" ;
  ofoertroettlig_av_1_1_A = mkA "oförtröttlig" ;
  ofoertydbar_av_1_1_A = mkA "oförtydbar" ;
  ofoerutsebar_av_1_1_A = mkA "oförutsebar" ;
  ofoerutsaegbar_av_1_1_A = mkA "oförutsägbar" ;
  ofoervitlig_av_1_1_A = mkA "oförvitlig" ;
  ofoerytterlig_av_1_1_A = mkA "oförytterlig" ;
  ofoeraenderlig_av_1_1_A = mkA "oföränderlig" ;
  ogalliserbar_av_1_A = mkA "ogalliserbar" ;
  ogaloscherbar_av_1_A = mkA "ogaloscherbar" ;
  ogalvaniserbar_av_1_A = mkA "ogalvaniserbar" ;
  ogaragerbar_av_1_A = mkA "ogaragerbar" ;
  ogaranterbar_av_1_A = mkA "ogaranterbar" ;
  ogarderbar_av_1_A = mkA "ogarderbar" ;
  ogarnerbar_av_1_A = mkA "ogarnerbar" ;
  ogarnisonerbar_av_1_A = mkA "ogarnisonerbar" ;
  ogarrotterbar_av_1_A = mkA "ogarrotterbar" ;
  ogastroskoperbar_av_1_A = mkA "ogastroskoperbar" ;
  ogauffrerbar_av_1_A = mkA "ogauffrerbar" ;
  ogelatinerbar_av_1_A = mkA "ogelatinerbar" ;
  ogeminerbar_av_1_A = mkA "ogeminerbar" ;
  ogeneraliserbar_av_1_A = mkA "ogeneraliserbar" ;
  ogenerbar_av_1_A = mkA "ogenerbar" ;
  ogenererbar_av_1_A = mkA "ogenererbar" ;
  ogenomfoerbar_av_1_1_A = mkA "ogenomförbar" ;
  ogenomskinlig_av_1_A = mkA "ogenomskinlig" ;
  ogenomslaepplig_av_1_1_A = mkA "ogenomsläpplig" ;
  ogenomtraenglig_av_1_1_A = mkA "ogenomtränglig" ;
  ogensaeglig_av_1_1_A = mkA "ogensäglig" ;
  ogeometriserbar_av_1_A = mkA "ogeometriserbar" ;
  ogermaniserbar_av_1_A = mkA "ogermaniserbar" ;
  ogiftig_av_1_A = mkA "ogiftig" ;
  ogiljotinerbar_av_1_A = mkA "ogiljotinerbar" ;
  ogill_av_1_A = mkA "ogill" ;
  ogiltig_av_1_A = mkA "ogiltig" ;
  ogin_av_1_A = mkA "ogin" ;
  ogirerbar_av_1_A = mkA "ogirerbar" ;
  oglamoriserbar_av_1_A = mkA "oglamoriserbar" ;
  oglamouriserbar_av_1_A = mkA "oglamouriserbar" ;
  oglaserbar_av_1_A = mkA "oglaserbar" ;
  oglorifierbar_av_1_A = mkA "oglorifierbar" ;
  ogoffrerbar_av_1_A = mkA "ogoffrerbar" ;
  ogouterbar_av_1_A = mkA "ogouterbar" ;
  ograderbar_av_1_A = mkA "ograderbar" ;
  ograduerbar_av_1_A = mkA "ograduerbar" ;
  ografiterbar_av_1_A = mkA "ografiterbar" ;
  ogrammatikalisk_av_1_A = mkA "ogrammatikalisk" ;
  ogrammatisk_av_1_A = mkA "ogrammatisk" ;
  ogranulerbar_av_1_A = mkA "ogranulerbar" ;
  ogratinerbar_av_1_A = mkA "ogratinerbar" ;
  ogratulerbar_av_1_A = mkA "ogratulerbar" ;
  ograverbar_av_1_A = mkA "ograverbar" ;
  ogriljerbar_av_1_A = mkA "ogriljerbar" ;
  ogrimerbar_av_1_A = mkA "ogrimerbar" ;
  ogripbar_av_1_A = mkA "ogripbar" ;
  ogrunderbar_av_1_A = mkA "ogrunderbar" ;
  ogrupperbar_av_1_A = mkA "ogrupperbar" ;
  ogudaktig_av_1_A = mkA "ogudaktig" ;
  ogudlig_av_1_A = mkA "ogudlig" ;
  ogummerbar_av_1_A = mkA "ogummerbar" ;
  ogunstig_av_1_A = mkA "ogunstig" ;
  oguterbar_av_1_A = mkA "oguterbar" ;
  ogymnastiserbar_av_1_A = mkA "ogymnastiserbar" ;
  ogaestvaenlig_av_1_1_A = mkA "ogästvänlig" ;
  ogoerlig_av_1_1_A = mkA "ogörlig" ;
  ohallucinerbar_av_1_A = mkA "ohallucinerbar" ;
  ohalverbar_av_1_A = mkA "ohalverbar" ;
  ohanterbar_av_1_A = mkA "ohanterbar" ;
  ohanterlig_av_1_A = mkA "ohanterlig" ;
  oharangerbar_av_1_A = mkA "oharangerbar" ;
  oharmoniserbar_av_1_A = mkA "oharmoniserbar" ;
  oharmonisk_av_1_A = mkA "oharmonisk" ;
  oharpunerbar_av_1_A = mkA "oharpunerbar" ;
  ohasarderbar_av_1_A = mkA "ohasarderbar" ;
  ohavererbar_av_1_A = mkA "ohavererbar" ;
  ohederlig_av_1_A = mkA "ohederlig" ;
  ohektograferbar_av_1_A = mkA "ohektograferbar" ;
  ohelig_av_1_A = mkA "ohelig" ;
  ohemul_av_1_A = mkA "ohemul" ;
  oheroiserbar_av_1_A = mkA "oheroiserbar" ;
  ohistorierbar_av_1_A = mkA "ohistorierbar" ;
  ohistoriserbar_av_1_A = mkA "ohistoriserbar" ;
  ohistorisk_av_1_A = mkA "ohistorisk" ;
  ohjaelplig_av_1_1_A = mkA "ohjälplig" ;
  oholograferbar_av_1_A = mkA "oholograferbar" ;
  ohomogeniserbar_av_1_A = mkA "ohomogeniserbar" ;
  ohonorerbar_av_1_A = mkA "ohonorerbar" ;
  ohospitaliserbar_av_1_A = mkA "ohospitaliserbar" ;
  ohumaniserbar_av_1_A = mkA "ohumaniserbar" ;
  ohundsfotterbar_av_1_A = mkA "ohundsfotterbar" ;
  ohuserbar_av_1_A = mkA "ohuserbar" ;
  ohybridiserbar_av_1_A = mkA "ohybridiserbar" ;
  ohydrerbar_av_1_A = mkA "ohydrerbar" ;
  ohygglig_av_1_A = mkA "ohygglig" ;
  ohygienisk_av_1_A = mkA "ohygienisk" ;
  ohypnotiserbar_av_1_A = mkA "ohypnotiserbar" ;
  ohypotiserbar_av_1_A = mkA "ohypotiserbar" ;
  ohysbar_av_1_A = mkA "ohysbar" ;
  ohaerbaergerbar_av_1_1_A = mkA "ohärbärgerbar" ;
  ohaallbar_av_1_1_A = mkA "ohållbar" ;
  ohoerbar_av_1_1_A = mkA "ohörbar" ;
  ohoevlig_av_1_1_A = mkA "ohövlig" ;
  oidealiserbar_av_1_A = mkA "oidealiserbar" ;
  oidentifierbar_av_1_A = mkA "oidentifierbar" ;
  oigenkaennlig_av_1_1_A = mkA "oigenkännlig" ;
  oignorerbar_av_1_A = mkA "oignorerbar" ;
  oilluminerbar_av_1_A = mkA "oilluminerbar" ;
  oillustrerbar_av_1_A = mkA "oillustrerbar" ;
  oimiterbar_av_1_A = mkA "oimiterbar" ;
  oimmatrikulerbar_av_1_A = mkA "oimmatrikulerbar" ;
  oimmigrerbar_av_1_A = mkA "oimmigrerbar" ;
  oimmuniserbar_av_1_A = mkA "oimmuniserbar" ;
  oimplanterbar_av_1_A = mkA "oimplanterbar" ;
  oimplicerbar_av_1_A = mkA "oimplicerbar" ;
  oimploderbar_av_1_A = mkA "oimploderbar" ;
  oimponerbar_av_1_A = mkA "oimponerbar" ;
  oimporterbar_av_1_A = mkA "oimporterbar" ;
  oimpregnerbar_av_1_A = mkA "oimpregnerbar" ;
  oimproviserbar_av_1_A = mkA "oimproviserbar" ;
  oinackorderbar_av_1_A = mkA "oinackorderbar" ;
  oinaugurerbar_av_1_A = mkA "oinaugurerbar" ;
  oindexerbar_av_1_A = mkA "oindexerbar" ;
  oindexreglerbar_av_1_A = mkA "oindexreglerbar" ;
  oindicerbar_av_1_A = mkA "oindicerbar" ;
  oindikerbar_av_1_A = mkA "oindikerbar" ;
  oindividualiserbar_av_1_A = mkA "oindividualiserbar" ;
  oindoktrinerbar_av_1_A = mkA "oindoktrinerbar" ;
  oinducerbar_av_1_A = mkA "oinducerbar" ;
  oindustrialiserbar_av_1_A = mkA "oindustrialiserbar" ;
  oinfantiliserbar_av_1_A = mkA "oinfantiliserbar" ;
  oinfekterbar_av_1_A = mkA "oinfekterbar" ;
  oinfiltrerbar_av_1_A = mkA "oinfiltrerbar" ;
  oinflammerbar_av_1_A = mkA "oinflammerbar" ;
  oinfluerbar_av_1_A = mkA "oinfluerbar" ;
  oinformerbar_av_1_A = mkA "oinformerbar" ;
  oingraverbar_av_1_A = mkA "oingraverbar" ;
  oinhalerbar_av_1_A = mkA "oinhalerbar" ;
  oinhiberbar_av_1_A = mkA "oinhiberbar" ;
  oinhibiterbar_av_1_A = mkA "oinhibiterbar" ;
  oinitierbar_av_1_A = mkA "oinitierbar" ;
  oinjekterbar_av_1_A = mkA "oinjekterbar" ;
  oinjicerbar_av_1_A = mkA "oinjicerbar" ;
  oinkarnerbar_av_1_A = mkA "oinkarnerbar" ;
  oinkasserbar_av_1_A = mkA "oinkasserbar" ;
  oinklarerbar_av_1_A = mkA "oinklarerbar" ;
  oinkluderbar_av_1_A = mkA "oinkluderbar" ;
  oinkorporerbar_av_1_A = mkA "oinkorporerbar" ;
  oinkvarterbar_av_1_A = mkA "oinkvarterbar" ;
  oinnerverbar_av_1_A = mkA "oinnerverbar" ;
  oinokulerbar_av_1_A = mkA "oinokulerbar" ;
  oinplanterbar_av_1_A = mkA "oinplanterbar" ;
  oinrangerbar_av_1_A = mkA "oinrangerbar" ;
  oinrapporterbar_av_1_A = mkA "oinrapporterbar" ;
  oinregistrerbar_av_1_A = mkA "oinregistrerbar" ;
  oinscenerbar_av_1_A = mkA "oinscenerbar" ;
  oinseminerbar_av_1_A = mkA "oinseminerbar" ;
  oinsinuerbar_av_1_A = mkA "oinsinuerbar" ;
  oinspekterbar_av_1_A = mkA "oinspekterbar" ;
  oinspirerbar_av_1_A = mkA "oinspirerbar" ;
  oinstallerbar_av_1_A = mkA "oinstallerbar" ;
  oinstitutionaliserbar_av_1_A = mkA "oinstitutionaliserbar" ;
  oinstruerbar_av_1_A = mkA "oinstruerbar" ;
  oinstrumenterbar_av_1_A = mkA "oinstrumenterbar" ;
  oinstuderbar_av_1_A = mkA "oinstuderbar" ;
  ointaglig_av_1_A = mkA "ointaglig" ;
  ointegrerbar_av_1_A = mkA "ointegrerbar" ;
  ointellektualiserbar_av_1_A = mkA "ointellektualiserbar" ;
  ointensifierbar_av_1_A = mkA "ointensifierbar" ;
  ointensiverbar_av_1_A = mkA "ointensiverbar" ;
  ointerfolierbar_av_1_A = mkA "ointerfolierbar" ;
  ointernaliserbar_av_1_A = mkA "ointernaliserbar" ;
  ointernationaliserbar_av_1_A = mkA "ointernationaliserbar" ;
  ointernerbar_av_1_A = mkA "ointernerbar" ;
  ointerpellerbar_av_1_A = mkA "ointerpellerbar" ;
  ointerpolerbar_av_1_A = mkA "ointerpolerbar" ;
  ointerpreterbar_av_1_A = mkA "ointerpreterbar" ;
  ointerpunkterbar_av_1_A = mkA "ointerpunkterbar" ;
  ointervenerbar_av_1_A = mkA "ointervenerbar" ;
  ointonerbar_av_1_A = mkA "ointonerbar" ;
  ointresserbar_av_1_A = mkA "ointresserbar" ;
  ointroducerbar_av_1_A = mkA "ointroducerbar" ;
  oinvaderbar_av_1_A = mkA "oinvaderbar" ;
  oinvalidiserbar_av_1_A = mkA "oinvalidiserbar" ;
  oinventerbar_av_1_A = mkA "oinventerbar" ;
  oinverterbar_av_1_A = mkA "oinverterbar" ;
  oinvesterbar_av_1_A = mkA "oinvesterbar" ;
  oinviterbar_av_1_A = mkA "oinviterbar" ;
  oinvolverbar_av_1_A = mkA "oinvolverbar" ;
  oirriterbar_av_1_A = mkA "oirriterbar" ;
  oislamiserbar_av_1_A = mkA "oislamiserbar" ;
  oisolerbar_av_1_A = mkA "oisolerbar" ;
  oitererbar_av_1_A = mkA "oitererbar" ;
  ojazzifierbar_av_1_A = mkA "ojazzifierbar" ;
  ojoderbar_av_1_A = mkA "ojoderbar" ;
  ojonglerbar_av_1_A = mkA "ojonglerbar" ;
  ojoniserbar_av_1_A = mkA "ojoniserbar" ;
  ojusterbar_av_1_A = mkA "ojusterbar" ;
  ojaemfoerbar_av_1_1_A = mkA "ojämförbar" ;
  ojaemfoerlig_av_1_1_A = mkA "ojämförlig" ;
  ojaemlik_av_1_1_A = mkA "ojämlik" ;
  ojaemn_av_1_1_A = mkA "ojämn" ;
  ojaevig_av_1_1_A = mkA "ojävig" ;
  okalandrerbar_av_1_A = mkA "okalandrerbar" ;
  okalcinerbar_av_1_A = mkA "okalcinerbar" ;
  okalibrerbar_av_1_A = mkA "okalibrerbar" ;
  okalkerbar_av_1_A = mkA "okalkerbar" ;
  okalkylerbar_av_1_A = mkA "okalkylerbar" ;
  okalmerbar_av_1_A = mkA "okalmerbar" ;
  okamouflerbar_av_1_A = mkA "okamouflerbar" ;
  okamratlig_av_1_A = mkA "okamratlig" ;
  okanaliserbar_av_1_A = mkA "okanaliserbar" ;
  okanderbar_av_1_A = mkA "okanderbar" ;
  okandiderbar_av_1_A = mkA "okandiderbar" ;
  okannelerbar_av_1_A = mkA "okannelerbar" ;
  okanoniserbar_av_1_A = mkA "okanoniserbar" ;
  okapitaliserbar_av_1_A = mkA "okapitaliserbar" ;
  okarakteriserbar_av_1_A = mkA "okarakteriserbar" ;
  okaraktaeriserbar_av_1_1_A = mkA "okaraktäriserbar" ;
  okarambolerbar_av_1_A = mkA "okarambolerbar" ;
  okarboniserbar_av_1_A = mkA "okarboniserbar" ;
  okarikerbar_av_1_A = mkA "okarikerbar" ;
  okarterbar_av_1_A = mkA "okarterbar" ;
  okartonnerbar_av_1_A = mkA "okartonnerbar" ;
  okasserbar_av_1_A = mkA "okasserbar" ;
  okastrerbar_av_1_A = mkA "okastrerbar" ;
  okatalogiserbar_av_1_A = mkA "okatalogiserbar" ;
  okatalyserbar_av_1_A = mkA "okatalyserbar" ;
  okategoriserbar_av_1_A = mkA "okategoriserbar" ;
  okateteriserbar_av_1_A = mkA "okateteriserbar" ;
  okatetriserbar_av_1_A = mkA "okatetriserbar" ;
  okauteriserbar_av_1_A = mkA "okauteriserbar" ;
  oklanderlig_av_1_A = mkA "oklanderlig" ;
  oklar_av_1_A = mkA "oklar" ;
  oklarerbar_av_1_A = mkA "oklarerbar" ;
  oklassificerbar_av_1_A = mkA "oklassificerbar" ;
  oklok_av_1_A = mkA "oklok" ;
  oklorerbar_av_1_A = mkA "oklorerbar" ;
  okoafferbar_av_1_A = mkA "okoafferbar" ;
  okoagulerbar_av_1_A = mkA "okoagulerbar" ;
  okodifierbar_av_1_A = mkA "okodifierbar" ;
  okollationerbar_av_1_A = mkA "okollationerbar" ;
  okollektiviserbar_av_1_A = mkA "okollektiviserbar" ;
  okoloniserbar_av_1_A = mkA "okoloniserbar" ;
  okolorerbar_av_1_A = mkA "okolorerbar" ;
  okolporterbar_av_1_A = mkA "okolporterbar" ;
  okombinerbar_av_1_A = mkA "okombinerbar" ;
  okommaterbar_av_1_A = mkA "okommaterbar" ;
  okommenderbar_av_1_A = mkA "okommenderbar" ;
  okommenterbar_av_1_A = mkA "okommenterbar" ;
  okommersialiserbar_av_1_A = mkA "okommersialiserbar" ;
  okommunaliserbar_av_1_A = mkA "okommunaliserbar" ;
  okommunicerbar_av_1_A = mkA "okommunicerbar" ;
  okommuterbar_av_1_A = mkA "okommuterbar" ;
  okomparerbar_av_1_A = mkA "okomparerbar" ;
  okompenserbar_av_1_A = mkA "okompenserbar" ;
  okompilerbar_av_1_A = mkA "okompilerbar" ;
  okompletterbar_av_1_A = mkA "okompletterbar" ;
  okomplicerbar_av_1_A = mkA "okomplicerbar" ;
  okomplimenterbar_av_1_A = mkA "okomplimenterbar" ;
  okomponerbar_av_1_A = mkA "okomponerbar" ;
  okomposterbar_av_1_A = mkA "okomposterbar" ;
  okomprimerbar_av_1_A = mkA "okomprimerbar" ;
  okomprometterbar_av_1_A = mkA "okomprometterbar" ;
  okoncentrerbar_av_1_A = mkA "okoncentrerbar" ;
  okoncessionerbar_av_1_A = mkA "okoncessionerbar" ;
  okoncipierbar_av_1_A = mkA "okoncipierbar" ;
  okondemnerbar_av_1_A = mkA "okondemnerbar" ;
  okondenserbar_av_1_A = mkA "okondenserbar" ;
  okonditionerbar_av_1_A = mkA "okonditionerbar" ;
  okondolerbar_av_1_A = mkA "okondolerbar" ;
  okonfirmerbar_av_1_A = mkA "okonfirmerbar" ;
  okonfiskerbar_av_1_A = mkA "okonfiskerbar" ;
  okonfronterbar_av_1_A = mkA "okonfronterbar" ;
  okonfunderbar_av_1_A = mkA "okonfunderbar" ;
  okongruerbar_av_1_A = mkA "okongruerbar" ;
  okonjugerbar_av_1_A = mkA "okonjugerbar" ;
  okonkluderbar_av_1_A = mkA "okonkluderbar" ;
  okonkretiserbar_av_1_A = mkA "okonkretiserbar" ;
  okonserverbar_av_1_A = mkA "okonserverbar" ;
  okonsignerbar_av_1_A = mkA "okonsignerbar" ;
  okonsoliderbar_av_1_A = mkA "okonsoliderbar" ;
  okonstaterbar_av_1_A = mkA "okonstaterbar" ;
  okonsternerbar_av_1_A = mkA "okonsternerbar" ;
  okonstituerbar_av_1_A = mkA "okonstituerbar" ;
  okonstruerbar_av_1_A = mkA "okonstruerbar" ;
  okonsulterbar_av_1_A = mkA "okonsulterbar" ;
  okonsumerbar_av_1_A = mkA "okonsumerbar" ;
  okontaminerbar_av_1_A = mkA "okontaminerbar" ;
  okonterbar_av_1_A = mkA "okonterbar" ;
  okontingenterbar_av_1_A = mkA "okontingenterbar" ;
  okontoriserbar_av_1_A = mkA "okontoriserbar" ;
  okontraherbar_av_1_A = mkA "okontraherbar" ;
  okontrakterbar_av_1_A = mkA "okontrakterbar" ;
  okontramanderbar_av_1_A = mkA "okontramanderbar" ;
  okontrasignerbar_av_1_A = mkA "okontrasignerbar" ;
  okontrasterbar_av_1_A = mkA "okontrasterbar" ;
  okontribuerbar_av_1_A = mkA "okontribuerbar" ;
  okontrollerbar_av_1_A = mkA "okontrollerbar" ;
  okontroversiell_av_1_A = mkA "okontroversiell" ;
  okonturerbar_av_1_A = mkA "okonturerbar" ;
  okonventionell_av_1_A = mkA "okonventionell" ;
  okonvergerbar_av_1_A = mkA "okonvergerbar" ;
  okonverserbar_av_1_A = mkA "okonverserbar" ;
  okonverterbar_av_1_A = mkA "okonverterbar" ;
  okonvojerbar_av_1_A = mkA "okonvojerbar" ;
  okoordinerbar_av_1_A = mkA "okoordinerbar" ;
  okopierbar_av_1_A = mkA "okopierbar" ;
  okorrelerbar_av_1_A = mkA "okorrelerbar" ;
  okorrigerbar_av_1_A = mkA "okorrigerbar" ;
  okorroderbar_av_1_A = mkA "okorroderbar" ;
  okorrugerbar_av_1_A = mkA "okorrugerbar" ;
  okorrumperbar_av_1_A = mkA "okorrumperbar" ;
  okorsetterbar_av_1_A = mkA "okorsetterbar" ;
  okostymerbar_av_1_A = mkA "okostymerbar" ;
  okrackelerbar_av_1_A = mkA "okrackelerbar" ;
  okrediterbar_av_1_A = mkA "okrediterbar" ;
  okreerbar_av_1_A = mkA "okreerbar" ;
  okremerbar_av_1_A = mkA "okremerbar" ;
  okreperbar_av_1_A = mkA "okreperbar" ;
  okreverbar_av_1_A = mkA "okreverbar" ;
  okriminaliserbar_av_1_A = mkA "okriminaliserbar" ;
  okristalliserbar_av_1_A = mkA "okristalliserbar" ;
  okristlig_av_1_A = mkA "okristlig" ;
  okritiserbar_av_1_A = mkA "okritiserbar" ;
  okritisk_av_1_A = mkA "okritisk" ;
  okroppslig_av_1_A = mkA "okroppslig" ;
  okrossbar_av_1_A = mkA "okrossbar" ;
  okrypterbar_av_1_A = mkA "okrypterbar" ;
  okraenkbar_av_1_1_A = mkA "okränkbar" ;
  oktrojerbar_av_1_A = mkA "oktrojerbar" ;
  okuberbar_av_1_A = mkA "okuberbar" ;
  okujonerbar_av_1_A = mkA "okujonerbar" ;
  okular_av_1_A = mkA "okular" ;
  okulerbar_av_1_A = mkA "okulerbar" ;
  okultiverbar_av_1_A = mkA "okultiverbar" ;
  okulaer_av_1_1_A = mkA "okulär" ;
  okumulerbar_av_1_A = mkA "okumulerbar" ;
  okunnig_av_1_A = mkA "okunnig" ;
  okuperbar_av_1_A = mkA "okuperbar" ;
  okuraterbar_av_1_A = mkA "okuraterbar" ;
  okurerbar_av_1_A = mkA "okurerbar" ;
  okursiverbar_av_1_A = mkA "okursiverbar" ;
  okurtiserbar_av_1_A = mkA "okurtiserbar" ;
  okuverterbar_av_1_A = mkA "okuverterbar" ;
  okuvlig_av_1_A = mkA "okuvlig" ;
  okvadrerbar_av_1_A = mkA "okvadrerbar" ;
  okvalificerbar_av_1_A = mkA "okvalificerbar" ;
  okvantifierbar_av_1_A = mkA "okvantifierbar" ;
  okvinnlig_av_1_A = mkA "okvinnlig" ;
  okvitterbar_av_1_A = mkA "okvitterbar" ;
  okvoterbar_av_1_A = mkA "okvoterbar" ;
  okynnig_av_1_A = mkA "okynnig" ;
  okyrklig_av_1_A = mkA "okyrklig" ;
  okysk_av_1_A = mkA "okysk" ;
  okaenslig_av_1_1_A = mkA "okänslig" ;
  okaer_av_1_1_A = mkA "okär" ;
  olabialiserbar_av_1_A = mkA "olabialiserbar" ;
  olackerbar_av_1_A = mkA "olackerbar" ;
  olaglig_av_1_A = mkA "olaglig" ;
  olamenterbar_av_1_A = mkA "olamenterbar" ;
  olaminerbar_av_1_A = mkA "olaminerbar" ;
  olangetterbar_av_1_A = mkA "olangetterbar" ;
  olanserbar_av_1_A = mkA "olanserbar" ;
  olapiserbar_av_1_A = mkA "olapiserbar" ;
  olaserbar_av_1_A = mkA "olaserbar" ;
  olatiniserbar_av_1_A = mkA "olatiniserbar" ;
  olaverbar_av_1_A = mkA "olaverbar" ;
  olegaliserbar_av_1_A = mkA "olegaliserbar" ;
  olegerbar_av_1_A = mkA "olegerbar" ;
  olegitimerbar_av_1_A = mkA "olegitimerbar" ;
  olevererbar_av_1_A = mkA "olevererbar" ;
  oliberaliserbar_av_1_A = mkA "oliberaliserbar" ;
  olicenserbar_av_1_A = mkA "olicenserbar" ;
  olicensierbar_av_1_A = mkA "olicensierbar" ;
  olicentierbar_av_1_A = mkA "olicentierbar" ;
  olidlig_av_1_A = mkA "olidlig" ;
  olierbar_av_1_A = mkA "olierbar" ;
  oligofag_av_1_A = mkA "oligofag" ;
  oligotrof_av_1_A = mkA "oligotrof" ;
  olik_av_1_A = mkA "olik" ;
  olikformig_av_1_A = mkA "olikformig" ;
  olikstor_av_1_A = mkA "olikstor" ;
  olikviderbar_av_1_A = mkA "olikviderbar" ;
  olinjerbar_av_1_A = mkA "olinjerbar" ;
  olisserbar_av_1_A = mkA "olisserbar" ;
  olitograferbar_av_1_A = mkA "olitograferbar" ;
  olivgroen_av_1_1_A = mkA "olivgrön" ;
  oljebestaendig_av_1_1_A = mkA "oljebeständig" ;
  oljerik_av_1_A = mkA "oljerik" ;
  oljig_av_1_A = mkA "oljig" ;
  ologerbar_av_1_A = mkA "ologerbar" ;
  ologisk_av_1_A = mkA "ologisk" ;
  olokaliserbar_av_1_A = mkA "olokaliserbar" ;
  olovlig_av_1_A = mkA "olovlig" ;
  olustig_av_1_A = mkA "olustig" ;
  oluteiniserbar_av_1_A = mkA "oluteiniserbar" ;
  olycklig_av_1_A = mkA "olycklig" ;
  olycksalig_av_1_A = mkA "olycksalig" ;
  olydig_av_1_A = mkA "olydig" ;
  olympisk_av_1_A = mkA "olympisk" ;
  olyxrenoverbar_av_1_A = mkA "olyxrenoverbar" ;
  olaederbar_av_1_1_A = mkA "oläderbar" ;
  olaeglig_av_1_1_A = mkA "oläglig" ;
  olaeklig_av_1_1_A = mkA "oläklig" ;
  olaemplig_av_1_1_A = mkA "olämplig" ;
  olaendig_av_1_1_A = mkA "oländig" ;
  olaesbar_av_1_1_A = mkA "oläsbar" ;
  olaeslig_av_1_1_A = mkA "oläslig" ;
  oloesbar_av_1_1_A = mkA "olösbar" ;
  oloeslig_av_1_1_A = mkA "olöslig" ;
  omadrasserbar_av_1_A = mkA "omadrasserbar" ;
  omagasinerbar_av_1_A = mkA "omagasinerbar" ;
  omagnetiserbar_av_1_A = mkA "omagnetiserbar" ;
  omakulerbar_av_1_A = mkA "omakulerbar" ;
  omalfoberbar_av_1_A = mkA "omalfoberbar" ;
  omaltraeterbar_av_1_1_A = mkA "omalträterbar" ;
  omanifesterbar_av_1_A = mkA "omanifesterbar" ;
  omanikurerbar_av_1_A = mkA "omanikurerbar" ;
  omanikyrerbar_av_1_A = mkA "omanikyrerbar" ;
  omanipulerbar_av_1_A = mkA "omanipulerbar" ;
  omanlig_av_1_A = mkA "omanlig" ;
  omansk_av_1_A = mkA "omansk" ;
  omanoevrerbar_av_1_1_A = mkA "omanövrerbar" ;
  omarginaliserbar_av_1_A = mkA "omarginaliserbar" ;
  omarinerbar_av_1_A = mkA "omarinerbar" ;
  omarkerbar_av_1_A = mkA "omarkerbar" ;
  omarmorerbar_av_1_A = mkA "omarmorerbar" ;
  omarscherbar_av_1_A = mkA "omarscherbar" ;
  omarterbar_av_1_A = mkA "omarterbar" ;
  omaskerbar_av_1_A = mkA "omaskerbar" ;
  omaskuliniserbar_av_1_A = mkA "omaskuliniserbar" ;
  omassakrerbar_av_1_A = mkA "omassakrerbar" ;
  omasserbar_av_1_A = mkA "omasserbar" ;
  omatelasserbar_av_1_A = mkA "omatelasserbar" ;
  omaterialiserbar_av_1_A = mkA "omaterialiserbar" ;
  omatterbar_av_1_A = mkA "omatterbar" ;
  omaximerbar_av_1_A = mkA "omaximerbar" ;
  ombytlig_av_1_A = mkA "ombytlig" ;
  omdirigerbar_av_1_A = mkA "omdirigerbar" ;
  omdoemesgill_av_1_1_A = mkA "omdömesgill" ;
  omdoemesloes_av_1_1_A = mkA "omdömeslös" ;
  omedaljerbar_av_1_A = mkA "omedaljerbar" ;
  omedelbar_av_1_A = mkA "omedelbar" ;
  omedgoerlig_av_1_1_A = mkA "omedgörlig" ;
  omedicinerbar_av_1_A = mkA "omedicinerbar" ;
  omekaniserbar_av_1_A = mkA "omekaniserbar" ;
  omemorerbar_av_1_A = mkA "omemorerbar" ;
  omerceriserbar_av_1_A = mkA "omerceriserbar" ;
  omeriterbar_av_1_A = mkA "omeriterbar" ;
  ometalliserbar_av_1_A = mkA "ometalliserbar" ;
  omfaangsrik_av_1_1_A = mkA "omfångsrik" ;
  omikroskoperbar_av_1_A = mkA "omikroskoperbar" ;
  omilitariserbar_av_1_A = mkA "omilitariserbar" ;
  omineraliserbar_av_1_A = mkA "omineraliserbar" ;
  ominerbar_av_1_A = mkA "ominerbar" ;
  ominiatyriserbar_av_1_A = mkA "ominiatyriserbar" ;
  ominimerbar_av_1_A = mkA "ominimerbar" ;
  ominoes_av_1_1_A = mkA "ominös" ;
  omissiverbar_av_1_A = mkA "omissiverbar" ;
  omisskrediterbar_av_1_A = mkA "omisskrediterbar" ;
  omisskaennelig_av_1_1_A = mkA "omisskännelig" ;
  omisskaennlig_av_1_1_A = mkA "omisskännlig" ;
  omistlig_av_1_A = mkA "omistlig" ;
  ommoeblerbar_av_1_1_A = mkA "ommöblerbar" ;
  omnipotent_av_1_A = mkA "omnipotent" ;
  omobiliserbar_av_1_A = mkA "omobiliserbar" ;
  omodellerbar_av_1_A = mkA "omodellerbar" ;
  omodererbar_av_1_A = mkA "omodererbar" ;
  omodern_av_1_A = mkA "omodern" ;
  omoderniserbar_av_1_A = mkA "omoderniserbar" ;
  omodifierbar_av_1_A = mkA "omodifierbar" ;
  omodulerbar_av_1_A = mkA "omodulerbar" ;
  omodaerniserbar_av_1_1_A = mkA "omodärniserbar" ;
  omonoftongerbar_av_1_A = mkA "omonoftongerbar" ;
  omonopoliserbar_av_1_A = mkA "omonopoliserbar" ;
  omonterbar_av_1_A = mkA "omonterbar" ;
  omoralisk_av_1_A = mkA "omoralisk" ;
  omorganiserbar_av_1_A = mkA "omorganiserbar" ;
  omorserbar_av_1_A = mkA "omorserbar" ;
  omortificerbar_av_1_A = mkA "omortificerbar" ;
  omortifierbar_av_1_A = mkA "omortifierbar" ;
  omotiverbar_av_1_A = mkA "omotiverbar" ;
  omotoriserbar_av_1_A = mkA "omotoriserbar" ;
  omotstaandlig_av_1_1_A = mkA "omotståndlig" ;
  omotsaeglig_av_1_1_A = mkA "omotsäglig" ;
  omottaglig_av_1_A = mkA "omottaglig" ;
  omplacerbar_av_1_A = mkA "omplacerbar" ;
  omskulpturerbar_av_1_A = mkA "omskulpturerbar" ;
  omsorgsfull_av_1_A = mkA "omsorgsfull" ;
  omstrukturerbar_av_1_A = mkA "omstrukturerbar" ;
  omstaendig_av_1_1_A = mkA "omständig" ;
  omstaendlig_av_1_1_A = mkA "omständlig" ;
  omuljerbar_av_1_A = mkA "omuljerbar" ;
  omultiplicerbar_av_1_A = mkA "omultiplicerbar" ;
  omumifierbar_av_1_A = mkA "omumifierbar" ;
  omusikalisk_av_1_A = mkA "omusikalisk" ;
  omutbar_av_1_A = mkA "omutbar" ;
  omuterbar_av_1_A = mkA "omuterbar" ;
  omutlig_av_1_A = mkA "omutlig" ;
  omvaendbar_av_1_1_A = mkA "omvändbar" ;
  omvaerderbar_av_1_1_A = mkA "omvärderbar" ;
  omvaardnadsmaessig_av_1_1_A = mkA "omvårdnadsmässig" ;
  omyndig_av_1_A = mkA "omyndig" ;
  omystifierbar_av_1_A = mkA "omystifierbar" ;
  omaensklig_av_1_1_A = mkA "omänsklig" ;
  omaerklig_av_1_1_A = mkA "omärklig" ;
  omaetlig_av_1_1_A = mkA "omätlig" ;
  omaettlig_av_1_1_A = mkA "omättlig" ;
  omaattlig_av_1_1_A = mkA "omåttlig" ;
  omoeblerbar_av_1_1_A = mkA "omöblerbar" ;
  omoejlig_av_1_1_A = mkA "omöjlig" ;
  onasalerbar_av_1_A = mkA "onasalerbar" ;
  onasaliserbar_av_1_A = mkA "onasaliserbar" ;
  onationaliserbar_av_1_A = mkA "onationaliserbar" ;
  onaturaliserbar_av_1_A = mkA "onaturaliserbar" ;
  onaturlig_av_1_A = mkA "onaturlig" ;
  onavigerbar_av_1_A = mkA "onavigerbar" ;
  ondskefull_av_1_A = mkA "ondskefull" ;
  ondulerbar_av_1_A = mkA "ondulerbar" ;
  onedtransformerbar_av_1_A = mkA "onedtransformerbar" ;
  onedtransponerbar_av_1_A = mkA "onedtransponerbar" ;
  onedvaerderbar_av_1_1_A = mkA "onedvärderbar" ;
  onegerbar_av_1_A = mkA "onegerbar" ;
  onegligerbar_av_1_A = mkA "onegligerbar" ;
  onegocierbar_av_1_A = mkA "onegocierbar" ;
  onegotierbar_av_1_A = mkA "onegotierbar" ;
  oneklig_av_1_A = mkA "oneklig" ;
  onertransformerbar_av_1_A = mkA "onertransformerbar" ;
  onertransponerbar_av_1_A = mkA "onertransponerbar" ;
  onervaerderbar_av_1_1_A = mkA "onervärderbar" ;
  oneutraliserbar_av_1_A = mkA "oneutraliserbar" ;
  oniellerbar_av_1_A = mkA "oniellerbar" ;
  onitrerbar_av_1_A = mkA "onitrerbar" ;
  onivellerbar_av_1_A = mkA "onivellerbar" ;
  onobiliserbar_av_1_A = mkA "onobiliserbar" ;
  onomastisk_av_1_A = mkA "onomastisk" ;
  onomatopoetisk_av_1_A = mkA "onomatopoetisk" ;
  onominerbar_av_1_A = mkA "onominerbar" ;
  ononchalerbar_av_1_A = mkA "ononchalerbar" ;
  onormal_av_1_A = mkA "onormal" ;
  onormaliserbar_av_1_A = mkA "onormaliserbar" ;
  onormerbar_av_1_A = mkA "onormerbar" ;
  onoslig_av_1_A = mkA "onoslig" ;
  onoterbar_av_1_A = mkA "onoterbar" ;
  onotificerbar_av_1_A = mkA "onotificerbar" ;
  onotifierbar_av_1_A = mkA "onotifierbar" ;
  onotiserbar_av_1_A = mkA "onotiserbar" ;
  ontogenetisk_av_1_A = mkA "ontogenetisk" ;
  ontologisk_av_1_A = mkA "ontologisk" ;
  onumrerbar_av_1_A = mkA "onumrerbar" ;
  onyanserbar_av_1_A = mkA "onyanserbar" ;
  onyttig_av_1_A = mkA "onyttig" ;
  onaemnbar_av_1_1_A = mkA "onämnbar" ;
  onaabar_av_1_1_A = mkA "onåbar" ;
  onaadig_av_1_1_A = mkA "onådig" ;
  onoedig_av_1_1_A = mkA "onödig" ;
  onoejaktig_av_1_1_A = mkA "onöjaktig" ;
  oobducerbar_av_1_A = mkA "oobducerbar" ;
  oobjektiverbar_av_1_A = mkA "oobjektiverbar" ;
  oobligerbar_av_1_A = mkA "oobligerbar" ;
  oobserverbar_av_1_A = mkA "oobserverbar" ;
  ooccidentaliserbar_av_1_A = mkA "ooccidentaliserbar" ;
  oockuperbar_av_1_A = mkA "oockuperbar" ;
  ooffererbar_av_1_A = mkA "ooffererbar" ;
  ooktrojerbar_av_1_A = mkA "ooktrojerbar" ;
  ookulerbar_av_1_A = mkA "ookulerbar" ;
  oomdirigerbar_av_1_A = mkA "oomdirigerbar" ;
  oomkullkastlig_av_1_A = mkA "oomkullkastlig" ;
  oomkullrunkelig_av_1_A = mkA "oomkullrunkelig" ;
  oommoeblerbar_av_1_1_A = mkA "oommöblerbar" ;
  oomorganiserbar_av_1_A = mkA "oomorganiserbar" ;
  oomplacerbar_av_1_A = mkA "oomplacerbar" ;
  oomskulpturerbar_av_1_A = mkA "oomskulpturerbar" ;
  oomstrukturerbar_av_1_A = mkA "oomstrukturerbar" ;
  oomtvistlig_av_1_A = mkA "oomtvistlig" ;
  oomvaerderbar_av_1_1_A = mkA "oomvärderbar" ;
  oondulerbar_av_1_A = mkA "oondulerbar" ;
  ooperationaliserbar_av_1_A = mkA "ooperationaliserbar" ;
  oopererbar_av_1_A = mkA "oopererbar" ;
  oopponerbar_av_1_A = mkA "oopponerbar" ;
  ooptimerbar_av_1_A = mkA "ooptimerbar" ;
  oordentlig_av_1_A = mkA "oordentlig" ;
  oordinerbar_av_1_A = mkA "oordinerbar" ;
  oorganiserbar_av_1_A = mkA "oorganiserbar" ;
  oorganisk_av_1_A = mkA "oorganisk" ;
  oorienterbar_av_1_A = mkA "oorienterbar" ;
  oorkestrerbar_av_1_A = mkA "oorkestrerbar" ;
  oornamenterbar_av_1_A = mkA "oornamenterbar" ;
  oornerbar_av_1_A = mkA "oornerbar" ;
  oortodox_av_1_A = mkA "oortodox" ;
  ooxiderbar_av_1_A = mkA "ooxiderbar" ;
  opacificerbar_av_1_A = mkA "opacificerbar" ;
  opaginerbar_av_1_A = mkA "opaginerbar" ;
  opak_av_1_A = mkA "opak" ;
  opaketerbar_av_1_A = mkA "opaketerbar" ;
  opalataliserbar_av_1_A = mkA "opalataliserbar" ;
  opaljetterbar_av_1_A = mkA "opaljetterbar" ;
  opalperbar_av_1_A = mkA "opalperbar" ;
  opanerbar_av_1_A = mkA "opanerbar" ;
  opanorerbar_av_1_A = mkA "opanorerbar" ;
  opantograferbar_av_1_A = mkA "opantograferbar" ;
  oparaderbar_av_1_A = mkA "oparaderbar" ;
  oparaferbar_av_1_A = mkA "oparaferbar" ;
  oparaffinerbar_av_1_A = mkA "oparaffinerbar" ;
  oparafraserbar_av_1_A = mkA "oparafraserbar" ;
  oparallelliserbar_av_1_A = mkA "oparallelliserbar" ;
  oparalyserbar_av_1_A = mkA "oparalyserbar" ;
  oparerbar_av_1_A = mkA "oparerbar" ;
  oparfymerbar_av_1_A = mkA "oparfymerbar" ;
  oparkerbar_av_1_A = mkA "oparkerbar" ;
  oparketterbar_av_1_A = mkA "oparketterbar" ;
  oparlamentarisk_av_1_A = mkA "oparlamentarisk" ;
  oparodierbar_av_1_A = mkA "oparodierbar" ;
  opartisk_av_1_A = mkA "opartisk" ;
  opasserbar_av_1_A = mkA "opasserbar" ;
  opassiverbar_av_1_A = mkA "opassiverbar" ;
  opassiviserbar_av_1_A = mkA "opassiviserbar" ;
  opasslig_av_1_A = mkA "opasslig" ;
  opastoeriserbar_av_1_1_A = mkA "opastöriserbar" ;
  opatenterbar_av_1_A = mkA "opatenterbar" ;
  opatinerbar_av_1_A = mkA "opatinerbar" ;
  opatrullerbar_av_1_A = mkA "opatrullerbar" ;
  opauperiserbar_av_1_A = mkA "opauperiserbar" ;
  opauserbar_av_1_A = mkA "opauserbar" ;
  opedagogisk_av_1_A = mkA "opedagogisk" ;
  opelleterbar_av_1_A = mkA "opelleterbar" ;
  openetrerbar_av_1_A = mkA "openetrerbar" ;
  opensionerbar_av_1_A = mkA "opensionerbar" ;
  operamaessig_av_1_1_A = mkA "operamässig" ;
  operationaliserbar_av_1_A = mkA "operationaliserbar" ;
  operationell_av_1_A = mkA "operationell" ;
  operativ_av_1_A = mkA "operativ" ;
  opercipierbar_av_1_A = mkA "opercipierbar" ;
  opererbar_av_1_A = mkA "opererbar" ;
  operforerbar_av_1_A = mkA "operforerbar" ;
  operiodiserbar_av_1_A = mkA "operiodiserbar" ;
  opermitterbar_av_1_A = mkA "opermitterbar" ;
  opermuterbar_av_1_A = mkA "opermuterbar" ;
  opersiflerbar_av_1_A = mkA "opersiflerbar" ;
  opersonifierbar_av_1_A = mkA "opersonifierbar" ;
  opersonlig_av_1_A = mkA "opersonlig" ;
  opersvaderbar_av_1_A = mkA "opersvaderbar" ;
  operverterbar_av_1_A = mkA "operverterbar" ;
  opetrifierbar_av_1_A = mkA "opetrifierbar" ;
  opikerbar_av_1_A = mkA "opikerbar" ;
  opincerbar_av_1_A = mkA "opincerbar" ;
  opinionsmaessig_av_1_1_A = mkA "opinionsmässig" ;
  oplacerbar_av_1_A = mkA "oplacerbar" ;
  oplagierbar_av_1_A = mkA "oplagierbar" ;
  oplanerbar_av_1_A = mkA "oplanerbar" ;
  oplanterbar_av_1_A = mkA "oplanterbar" ;
  oplatinerbar_av_1_A = mkA "oplatinerbar" ;
  oplisserbar_av_1_A = mkA "oplisserbar" ;
  oplomberbar_av_1_A = mkA "oplomberbar" ;
  oplaeterbar_av_1_1_A = mkA "opläterbar" ;
  opocherbar_av_1_A = mkA "opocherbar" ;
  opointerbar_av_1_A = mkA "opointerbar" ;
  opolariserbar_av_1_A = mkA "opolariserbar" ;
  opolerbar_av_1_A = mkA "opolerbar" ;
  opolitiserbar_av_1_A = mkA "opolitiserbar" ;
  opolitisk_av_1_A = mkA "opolitisk" ;
  opolletterbar_av_1_A = mkA "opolletterbar" ;
  opollinerbar_av_1_A = mkA "opollinerbar" ;
  opomaderbar_av_1_A = mkA "opomaderbar" ;
  opopulariserbar_av_1_A = mkA "opopulariserbar" ;
  oportionerbar_av_1_A = mkA "oportionerbar" ;
  oportraetterbar_av_1_1_A = mkA "oporträtterbar" ;
  opostdaterbar_av_1_A = mkA "opostdaterbar" ;
  oposterbar_av_1_A = mkA "oposterbar" ;
  opostponerbar_av_1_A = mkA "opostponerbar" ;
  opostulerbar_av_1_A = mkA "opostulerbar" ;
  opoaengterbar_av_1_1_A = mkA "opoängterbar" ;
  oppfinningsrik_av_1_A = mkA "oppfinningsrik" ;
  oppfaellbar_av_1_1_A = mkA "oppfällbar" ;
  opphinnelig_av_1_A = mkA "opphinnelig" ;
  oppjusterbar_av_1_A = mkA "oppjusterbar" ;
  oppkaeftig_av_1_1_A = mkA "oppkäftig" ;
  opponerbar_av_1_A = mkA "opponerbar" ;
  opportun_av_1_A = mkA "opportun" ;
  opportunistisk_av_1_A = mkA "opportunistisk" ;
  oppositionell_av_1_A = mkA "oppositionell" ;
  oppsummerbar_av_1_A = mkA "oppsummerbar" ;
  oppvaerderbar_av_1_1_A = mkA "oppvärderbar" ;
  opraktiserbar_av_1_A = mkA "opraktiserbar" ;
  opraktisk_av_1_A = mkA "opraktisk" ;
  oprecis_av_1_A = mkA "oprecis" ;
  opreciserbar_av_1_A = mkA "opreciserbar" ;
  opredestinerbar_av_1_A = mkA "opredestinerbar" ;
  opredicerbar_av_1_A = mkA "opredicerbar" ;
  opredisponerbar_av_1_A = mkA "opredisponerbar" ;
  oprefabricerbar_av_1_A = mkA "oprefabricerbar" ;
  oprefererbar_av_1_A = mkA "oprefererbar" ;
  oprefigerbar_av_1_A = mkA "oprefigerbar" ;
  opreludierbar_av_1_A = mkA "opreludierbar" ;
  opremierbar_av_1_A = mkA "opremierbar" ;
  opreparerbar_av_1_A = mkA "opreparerbar" ;
  opresenterbar_av_1_A = mkA "opresenterbar" ;
  opreserverbar_av_1_A = mkA "opreserverbar" ;
  opreskriberbar_av_1_A = mkA "opreskriberbar" ;
  opresterbar_av_1_A = mkA "opresterbar" ;
  opresumerbar_av_1_A = mkA "opresumerbar" ;
  opretentioes_av_1_1_A = mkA "opretentiös" ;
  oprioriterbar_av_1_A = mkA "oprioriterbar" ;
  oprivatiserbar_av_1_A = mkA "oprivatiserbar" ;
  oprivilegierbar_av_1_A = mkA "oprivilegierbar" ;
  oproberbar_av_1_A = mkA "oproberbar" ;
  oproblematiserbar_av_1_A = mkA "oproblematiserbar" ;
  oproducerbar_av_1_A = mkA "oproducerbar" ;
  oprofanerbar_av_1_A = mkA "oprofanerbar" ;
  oprofessionaliserbar_av_1_A = mkA "oprofessionaliserbar" ;
  oprofilerbar_av_1_A = mkA "oprofilerbar" ;
  oprognostiserbar_av_1_A = mkA "oprognostiserbar" ;
  oprogrammerbar_av_1_A = mkA "oprogrammerbar" ;
  oprojekterbar_av_1_A = mkA "oprojekterbar" ;
  oprojicerbar_av_1_A = mkA "oprojicerbar" ;
  oproklamerbar_av_1_A = mkA "oproklamerbar" ;
  oproletariserbar_av_1_A = mkA "oproletariserbar" ;
  oprolongerbar_av_1_A = mkA "oprolongerbar" ;
  opromoverbar_av_1_A = mkA "opromoverbar" ;
  opromulgerbar_av_1_A = mkA "opromulgerbar" ;
  oprononcerbar_av_1_A = mkA "oprononcerbar" ;
  oproponerbar_av_1_A = mkA "oproponerbar" ;
  oproportionerbar_av_1_A = mkA "oproportionerbar" ;
  oproportionerlig_av_1_A = mkA "oproportionerlig" ;
  oproskriberbar_av_1_A = mkA "oproskriberbar" ;
  oprospekterbar_av_1_A = mkA "oprospekterbar" ;
  oprotegerbar_av_1_A = mkA "oprotegerbar" ;
  oprotokollerbar_av_1_A = mkA "oprotokollerbar" ;
  oprovocerbar_av_1_A = mkA "oprovocerbar" ;
  opsykologiserbar_av_1_A = mkA "opsykologiserbar" ;
  opsykologisk_av_1_A = mkA "opsykologisk" ;
  optativ_av_1_A = mkA "optativ" ;
  optimal_av_1_A = mkA "optimal" ;
  optimerbar_av_1_A = mkA "optimerbar" ;
  optimistisk_av_1_A = mkA "optimistisk" ;
  optisk_av_1_A = mkA "optisk" ;
  opublicerbar_av_1_A = mkA "opublicerbar" ;
  opulveriserbar_av_1_A = mkA "opulveriserbar" ;
  opulvriserbar_av_1_A = mkA "opulvriserbar" ;
  opunkterbar_av_1_A = mkA "opunkterbar" ;
  opurgerbar_av_1_A = mkA "opurgerbar" ;
  opaaannonserbar_av_1_1_A = mkA "opåannonserbar" ;
  opaalitlig_av_1_1_A = mkA "opålitlig" ;
  opaaverkbar_av_1_1_A = mkA "opåverkbar" ;
  orabatterbar_av_1_A = mkA "orabatterbar" ;
  oraderbar_av_1_A = mkA "oraderbar" ;
  oradierbar_av_1_A = mkA "oradierbar" ;
  oradikaliserbar_av_1_A = mkA "oradikaliserbar" ;
  oraffinerbar_av_1_A = mkA "oraffinerbar" ;
  orakelmaessig_av_1_1_A = mkA "orakelmässig" ;
  oral_av_1_A = mkA "oral" ;
  oramponerbar_av_1_A = mkA "oramponerbar" ;
  orangerbar_av_1_A = mkA "orangerbar" ;
  oransonerbar_av_1_A = mkA "oransonerbar" ;
  orappellerbar_av_1_A = mkA "orappellerbar" ;
  orapporterbar_av_1_A = mkA "orapporterbar" ;
  oraserbar_av_1_A = mkA "oraserbar" ;
  oratificerbar_av_1_A = mkA "oratificerbar" ;
  orationaliserbar_av_1_A = mkA "orationaliserbar" ;
  orationell_av_1_A = mkA "orationell" ;
  oratorisk_av_1_A = mkA "oratorisk" ;
  orddoev_av_1_1_A = mkA "orddöv" ;
  ordentlig_av_1_A = mkA "ordentlig" ;
  ordfattig_av_1_A = mkA "ordfattig" ;
  ordhaallig_av_1_1_A = mkA "ordhållig" ;
  ordinerbar_av_1_A = mkA "ordinerbar" ;
  ordinaer_av_1_1_A = mkA "ordinär" ;
  ordkarg_av_1_A = mkA "ordkarg" ;
  ordknapp_av_1_A = mkA "ordknapp" ;
  ordloes_av_1_1_A = mkA "ordlös" ;
  ordrik_av_1_A = mkA "ordrik" ;
  ordspraaksmaessig_av_1_1_A = mkA "ordspråksmässig" ;
  oreaktiverbar_av_1_A = mkA "oreaktiverbar" ;
  orealiserbar_av_1_A = mkA "orealiserbar" ;
  orealistisk_av_1_A = mkA "orealistisk" ;
  oreassurerbar_av_1_A = mkA "oreassurerbar" ;
  orecenserbar_av_1_A = mkA "orecenserbar" ;
  orecipierbar_av_1_A = mkA "orecipierbar" ;
  oreciterbar_av_1_A = mkA "oreciterbar" ;
  oredig_av_1_A = mkA "oredig" ;
  oredigerbar_av_1_A = mkA "oredigerbar" ;
  oredlig_av_1_A = mkA "oredlig" ;
  oreducerbar_av_1_A = mkA "oreducerbar" ;
  orefererbar_av_1_A = mkA "orefererbar" ;
  oreflekterbar_av_1_A = mkA "oreflekterbar" ;
  oreformerbar_av_1_A = mkA "oreformerbar" ;
  orefuserbar_av_1_A = mkA "orefuserbar" ;
  oregalerbar_av_1_A = mkA "oregalerbar" ;
  oregelmaessig_av_1_1_A = mkA "oregelmässig" ;
  oregenererbar_av_1_A = mkA "oregenererbar" ;
  oregerbar_av_1_A = mkA "oregerbar" ;
  oregerlig_av_1_A = mkA "oregerlig" ;
  oregisserbar_av_1_A = mkA "oregisserbar" ;
  oregistrerbar_av_1_A = mkA "oregistrerbar" ;
  oreglementerbar_av_1_A = mkA "oreglementerbar" ;
  oreglerbar_av_1_A = mkA "oreglerbar" ;
  oregummerbar_av_1_A = mkA "oregummerbar" ;
  orehabiliterbar_av_1_A = mkA "orehabiliterbar" ;
  oreinkarnerbar_av_1_A = mkA "oreinkarnerbar" ;
  orekapitulerbar_av_1_A = mkA "orekapitulerbar" ;
  oreklamerbar_av_1_A = mkA "oreklamerbar" ;
  orekognoscerbar_av_1_A = mkA "orekognoscerbar" ;
  orekognoserbar_av_1_A = mkA "orekognoserbar" ;
  orekommenderbar_av_1_A = mkA "orekommenderbar" ;
  orekompenserbar_av_1_A = mkA "orekompenserbar" ;
  orekonstruerbar_av_1_A = mkA "orekonstruerbar" ;
  orekryterbar_av_1_A = mkA "orekryterbar" ;
  orektificerbar_av_1_A = mkA "orektificerbar" ;
  orektifierbar_av_1_A = mkA "orektifierbar" ;
  orekvirerbar_av_1_A = mkA "orekvirerbar" ;
  orelaterbar_av_1_A = mkA "orelaterbar" ;
  orelegerbar_av_1_A = mkA "orelegerbar" ;
  oremitterbar_av_1_A = mkA "oremitterbar" ;
  oremplacerbar_av_1_A = mkA "oremplacerbar" ;
  oren_av_1_A = mkA "oren" ;
  orenderbar_av_1_A = mkA "orenderbar" ;
  orenlig_av_1_A = mkA "orenlig" ;
  orenoverbar_av_1_A = mkA "orenoverbar" ;
  oreorganiserbar_av_1_A = mkA "oreorganiserbar" ;
  oreparerbar_av_1_A = mkA "oreparerbar" ;
  orepartiserbar_av_1_A = mkA "orepartiserbar" ;
  orepatrierbar_av_1_A = mkA "orepatrierbar" ;
  orepellerbar_av_1_A = mkA "orepellerbar" ;
  orepeterbar_av_1_A = mkA "orepeterbar" ;
  orepresenterbar_av_1_A = mkA "orepresenterbar" ;
  orepriserbar_av_1_A = mkA "orepriserbar" ;
  oreproducerbar_av_1_A = mkA "oreproducerbar" ;
  oreserverbar_av_1_A = mkA "oreserverbar" ;
  oresolverbar_av_1_A = mkA "oresolverbar" ;
  oresonlig_av_1_A = mkA "oresonlig" ;
  oresorberbar_av_1_A = mkA "oresorberbar" ;
  orespekterbar_av_1_A = mkA "orespekterbar" ;
  orespirerbar_av_1_A = mkA "orespirerbar" ;
  orestaurerbar_av_1_A = mkA "orestaurerbar" ;
  orestituerbar_av_1_A = mkA "orestituerbar" ;
  oresumerbar_av_1_A = mkA "oresumerbar" ;
  oretablerbar_av_1_A = mkA "oretablerbar" ;
  oretarderbar_av_1_A = mkA "oretarderbar" ;
  oreturnerbar_av_1_A = mkA "oreturnerbar" ;
  oretuscherbar_av_1_A = mkA "oretuscherbar" ;
  orevalverbar_av_1_A = mkA "orevalverbar" ;
  oreveterbar_av_1_A = mkA "oreveterbar" ;
  oreviderbar_av_1_A = mkA "oreviderbar" ;
  orevolutionerbar_av_1_A = mkA "orevolutionerbar" ;
  orfisk_av_1_A = mkA "orfisk" ;
  organisationsmaessig_av_1_1_A = mkA "organisationsmässig" ;
  organisatorisk_av_1_A = mkA "organisatorisk" ;
  organiserbar_av_1_A = mkA "organiserbar" ;
  organisk_av_1_A = mkA "organisk" ;
  orgastisk_av_1_A = mkA "orgastisk" ;
  orgelmaessig_av_1_1_A = mkA "orgelmässig" ;
  orgiastisk_av_1_A = mkA "orgiastisk" ;
  orientalisk_av_1_A = mkA "orientalisk" ;
  orienterbar_av_1_A = mkA "orienterbar" ;
  originell_av_1_A = mkA "originell" ;
  oriktig_av_1_A = mkA "oriktig" ;
  orimlig_av_1_A = mkA "orimlig" ;
  oritualiserbar_av_1_A = mkA "oritualiserbar" ;
  orkesloes_av_1_1_A = mkA "orkeslös" ;
  orkestral_av_1_A = mkA "orkestral" ;
  orkestrerbar_av_1_A = mkA "orkestrerbar" ;
  orkloes_av_1_1_A = mkA "orklös" ;
  ornamental_av_1_A = mkA "ornamental" ;
  ornamenterbar_av_1_A = mkA "ornamenterbar" ;
  ornerbar_av_1_A = mkA "ornerbar" ;
  ornitologisk_av_1_A = mkA "ornitologisk" ;
  orobotiserbar_av_1_A = mkA "orobotiserbar" ;
  orockerbar_av_1_A = mkA "orockerbar" ;
  orogenetisk_av_1_A = mkA "orogenetisk" ;
  orolig_av_1_A = mkA "orolig" ;
  oromantiserbar_av_1_A = mkA "oromantiserbar" ;
  oroterbar_av_1_A = mkA "oroterbar" ;
  orsaklig_av_1_A = mkA "orsaklig" ;
  orsaksmaessig_av_1_1_A = mkA "orsaksmässig" ;
  ortlig_av_1_A = mkA "ortlig" ;
  ortodox_av_1_A = mkA "ortodox" ;
  ortogonal_av_1_A = mkA "ortogonal" ;
  ortokromatisk_av_1_A = mkA "ortokromatisk" ;
  orubblig_av_1_A = mkA "orubblig" ;
  orubricerbar_av_1_A = mkA "orubricerbar" ;
  oruinerbar_av_1_A = mkA "oruinerbar" ;
  orussificerbar_av_1_A = mkA "orussificerbar" ;
  orussifierbar_av_1_A = mkA "orussifierbar" ;
  orygglig_av_1_A = mkA "orygglig" ;
  orytmiserbar_av_1_A = mkA "orytmiserbar" ;
  orytmisk_av_1_A = mkA "orytmisk" ;
  oraeknelig_av_1_1_A = mkA "oräknelig" ;
  oraettfaerdig_av_1_1_A = mkA "orättfärdig" ;
  oraettmaetig_av_1_1_A = mkA "orättmätig" ;
  oraettraadig_av_1_1_A = mkA "orättrådig" ;
  oraettvis_av_1_1_A = mkA "orättvis" ;
  oroerbar_av_1_1_A = mkA "orörbar" ;
  oroerlig_av_1_1_A = mkA "orörlig" ;
  osaboterbar_av_1_A = mkA "osaboterbar" ;
  osabrerbar_av_1_A = mkA "osabrerbar" ;
  osakkunnig_av_1_A = mkA "osakkunnig" ;
  osaklig_av_1_A = mkA "osaklig" ;
  osalderbar_av_1_A = mkA "osalderbar" ;
  osalig_av_1_A = mkA "osalig" ;
  osaluterbar_av_1_A = mkA "osaluterbar" ;
  osamtaxerbar_av_1_A = mkA "osamtaxerbar" ;
  osanerbar_av_1_A = mkA "osanerbar" ;
  osanforiserbar_av_1_A = mkA "osanforiserbar" ;
  osanktifierbar_av_1_A = mkA "osanktifierbar" ;
  osanktionerbar_av_1_A = mkA "osanktionerbar" ;
  osannfaerdig_av_1_1_A = mkA "osannfärdig" ;
  osannolik_av_1_A = mkA "osannolik" ;
  osaponifierbar_av_1_A = mkA "osaponifierbar" ;
  osatinerbar_av_1_A = mkA "osatinerbar" ;
  osatisfierbar_av_1_A = mkA "osatisfierbar" ;
  osaturerbar_av_1_A = mkA "osaturerbar" ;
  osauterbar_av_1_A = mkA "osauterbar" ;
  osauverbar_av_1_A = mkA "osauverbar" ;
  oschablonerbar_av_1_A = mkA "oschablonerbar" ;
  oschabloniserbar_av_1_A = mkA "oschabloniserbar" ;
  oschamponerbar_av_1_A = mkA "oschamponerbar" ;
  oschatterbar_av_1_A = mkA "oschatterbar" ;
  oschematiserbar_av_1_A = mkA "oschematiserbar" ;
  osedimenterbar_av_1_A = mkA "osedimenterbar" ;
  osedlig_av_1_A = mkA "osedlig" ;
  osedvanlig_av_1_A = mkA "osedvanlig" ;
  osegmenterbar_av_1_A = mkA "osegmenterbar" ;
  osegregerbar_av_1_A = mkA "osegregerbar" ;
  osekonderbar_av_1_A = mkA "osekonderbar" ;
  osekulariserbar_av_1_A = mkA "osekulariserbar" ;
  osekunderbar_av_1_A = mkA "osekunderbar" ;
  osekvestrerbar_av_1_A = mkA "osekvestrerbar" ;
  oselekterbar_av_1_A = mkA "oselekterbar" ;
  osemaforerbar_av_1_A = mkA "osemaforerbar" ;
  oseminerbar_av_1_A = mkA "oseminerbar" ;
  osensibiliserbar_av_1_A = mkA "osensibiliserbar" ;
  osenterbar_av_1_A = mkA "osenterbar" ;
  osentimental_av_1_A = mkA "osentimental" ;
  oseparerbar_av_1_A = mkA "oseparerbar" ;
  oserioes_av_1_1_A = mkA "oseriös" ;
  oserverbar_av_1_A = mkA "oserverbar" ;
  osexualiserbar_av_1_A = mkA "osexualiserbar" ;
  oshamponerbar_av_1_A = mkA "oshamponerbar" ;
  osigillerbar_av_1_A = mkA "osigillerbar" ;
  osignalerbar_av_1_A = mkA "osignalerbar" ;
  osignerbar_av_1_A = mkA "osignerbar" ;
  osiktbar_av_1_A = mkA "osiktbar" ;
  osiktig_av_1_A = mkA "osiktig" ;
  osilhuetterbar_av_1_A = mkA "osilhuetterbar" ;
  osiluetterbar_av_1_A = mkA "osiluetterbar" ;
  osimplifierbar_av_1_A = mkA "osimplifierbar" ;
  osimulerbar_av_1_A = mkA "osimulerbar" ;
  osinlig_av_1_A = mkA "osinlig" ;
  osinnlig_av_1_A = mkA "osinnlig" ;
  osjaelvisk_av_1_1_A = mkA "osjälvisk" ;
  osjaelvstaendig_av_1_1_A = mkA "osjälvständig" ;
  oskadlig_av_1_A = mkA "oskadlig" ;
  oskalperbar_av_1_A = mkA "oskalperbar" ;
  oskandaliserbar_av_1_A = mkA "oskandaliserbar" ;
  oskanderbar_av_1_A = mkA "oskanderbar" ;
  oskaplig_av_1_A = mkA "oskaplig" ;
  oskariansk_av_1_A = mkA "oskariansk" ;
  oskarp_av_1_A = mkA "oskarp" ;
  oskattbar_av_1_A = mkA "oskattbar" ;
  oskicklig_av_1_A = mkA "oskicklig" ;
  oskiljaktig_av_1_A = mkA "oskiljaktig" ;
  oskisserbar_av_1_A = mkA "oskisserbar" ;
  oskrafferbar_av_1_A = mkA "oskrafferbar" ;
  oskuldsfull_av_1_A = mkA "oskuldsfull" ;
  oskulpterbar_av_1_A = mkA "oskulpterbar" ;
  oskulpturerbar_av_1_A = mkA "oskulpturerbar" ;
  oskyldig_av_1_A = mkA "oskyldig" ;
  oskaelig_av_1_1_A = mkA "oskälig" ;
  oskoen_av_1_1_A = mkA "oskön" ;
  oslagbar_av_1_A = mkA "oslagbar" ;
  oslaviserbar_av_1_A = mkA "oslaviserbar" ;
  oslaecklig_av_1_1_A = mkA "osläcklig" ;
  osmaklig_av_1_A = mkA "osmaklig" ;
  osmansk_av_1_A = mkA "osmansk" ;
  osmidbar_av_1_A = mkA "osmidbar" ;
  osmidig_av_1_A = mkA "osmidig" ;
  osmotisk_av_1_A = mkA "osmotisk" ;
  osmaeltbar_av_1_1_A = mkA "osmältbar" ;
  osnedrekryterbar_av_1_A = mkA "osnedrekryterbar" ;
  osnygg_av_1_A = mkA "osnygg" ;
  osocial_av_1_A = mkA "osocial" ;
  osocialiserbar_av_1_A = mkA "osocialiserbar" ;
  osolidarisk_av_1_A = mkA "osolidarisk" ;
  osolverbar_av_1_A = mkA "osolverbar" ;
  osonderbar_av_1_A = mkA "osonderbar" ;
  osordinerbar_av_1_A = mkA "osordinerbar" ;
  osorterbar_av_1_A = mkA "osorterbar" ;
  osoulagerbar_av_1_A = mkA "osoulagerbar" ;
  osovjetiserbar_av_1_A = mkA "osovjetiserbar" ;
  ospaljerbar_av_1_A = mkA "ospaljerbar" ;
  ospallerbar_av_1_A = mkA "ospallerbar" ;
  ospecialiserbar_av_1_A = mkA "ospecialiserbar" ;
  ospecificerbar_av_1_A = mkA "ospecificerbar" ;
  ospeciminerbar_av_1_A = mkA "ospeciminerbar" ;
  ospekulerbar_av_1_A = mkA "ospekulerbar" ;
  ospelbar_av_1_A = mkA "ospelbar" ;
  ospenderbar_av_1_A = mkA "ospenderbar" ;
  ospolierbar_av_1_A = mkA "ospolierbar" ;
  osportslig_av_1_A = mkA "osportslig" ;
  ostabiliserbar_av_1_A = mkA "ostabiliserbar" ;
  ostadig_av_1_A = mkA "ostadig" ;
  ostafferbar_av_1_A = mkA "ostafferbar" ;
  ostandardiserbar_av_1_A = mkA "ostandardiserbar" ;
  ostationerbar_av_1_A = mkA "ostationerbar" ;
  ostatuerbar_av_1_A = mkA "ostatuerbar" ;
  ostencilerbar_av_1_A = mkA "ostencilerbar" ;
  ostenograferbar_av_1_A = mkA "ostenograferbar" ;
  ostensiv_av_1_A = mkA "ostensiv" ;
  ostentativ_av_1_A = mkA "ostentativ" ;
  ostereotyperbar_av_1_A = mkA "ostereotyperbar" ;
  osteriliserbar_av_1_A = mkA "osteriliserbar" ;
  ostig_av_1_A = mkA "ostig" ;
  ostigmatiserbar_av_1_A = mkA "ostigmatiserbar" ;
  ostiliserbar_av_1_A = mkA "ostiliserbar" ;
  ostimulerbar_av_1_A = mkA "ostimulerbar" ;
  ostindisk_av_1_A = mkA "ostindisk" ;
  ostipendierbar_av_1_A = mkA "ostipendierbar" ;
  ostipulerbar_av_1_A = mkA "ostipulerbar" ;
  ostjakisk_av_1_A = mkA "ostjakisk" ;
  ostlig_av_1_A = mkA "ostlig" ;
  ostofferbar_av_1_A = mkA "ostofferbar" ;
  ostrafflig_av_1_A = mkA "ostrafflig" ;
  ostrangulerbar_av_1_A = mkA "ostrangulerbar" ;
  ostratifierbar_av_1_A = mkA "ostratifierbar" ;
  ostridig_av_1_A = mkA "ostridig" ;
  ostrukturerbar_av_1_A = mkA "ostrukturerbar" ;
  ostuderbar_av_1_A = mkA "ostuderbar" ;
  ostyrig_av_1_A = mkA "ostyrig" ;
  osublimerbar_av_1_A = mkA "osublimerbar" ;
  osubordinerbar_av_1_A = mkA "osubordinerbar" ;
  osubsidierbar_av_1_A = mkA "osubsidierbar" ;
  osubskriberbar_av_1_A = mkA "osubskriberbar" ;
  osubstantiverbar_av_1_A = mkA "osubstantiverbar" ;
  osubstituerbar_av_1_A = mkA "osubstituerbar" ;
  osubsumerbar_av_1_A = mkA "osubsumerbar" ;
  osubtraherbar_av_1_A = mkA "osubtraherbar" ;
  osubventionerbar_av_1_A = mkA "osubventionerbar" ;
  osuccederbar_av_1_A = mkA "osuccederbar" ;
  osuffigerbar_av_1_A = mkA "osuffigerbar" ;
  osufflerbar_av_1_A = mkA "osufflerbar" ;
  osuggererbar_av_1_A = mkA "osuggererbar" ;
  osummerbar_av_1_A = mkA "osummerbar" ;
  osupplerbar_av_1_A = mkA "osupplerbar" ;
  osupponerbar_av_1_A = mkA "osupponerbar" ;
  osurfbar_av_1_A = mkA "osurfbar" ;
  osuspenderbar_av_1_A = mkA "osuspenderbar" ;
  osvensk_av_1_A = mkA "osvensk" ;
  osviklig_av_1_A = mkA "osviklig" ;
  osymboliserbar_av_1_A = mkA "osymboliserbar" ;
  osymmetrisk_av_1_A = mkA "osymmetrisk" ;
  osympatisk_av_1_A = mkA "osympatisk" ;
  osynkoperbar_av_1_A = mkA "osynkoperbar" ;
  osynkroniserbar_av_1_A = mkA "osynkroniserbar" ;
  osynlig_av_1_A = mkA "osynlig" ;
  osyntetiserbar_av_1_A = mkA "osyntetiserbar" ;
  osystematiserbar_av_1_A = mkA "osystematiserbar" ;
  osystematisk_av_1_A = mkA "osystematisk" ;
  osaegbar_av_1_1_A = mkA "osägbar" ;
  osaeglig_av_1_1_A = mkA "osäglig" ;
  osaeljbar_av_1_1_A = mkA "osäljbar" ;
  osaell_av_1_1_A = mkA "osäll" ;
  osaellskaplig_av_1_1_A = mkA "osällskaplig" ;
  osaenkbar_av_1_1_A = mkA "osänkbar" ;
  osaarbar_av_1_1_A = mkA "osårbar" ;
  osaaterbar_av_1_1_A = mkA "osåterbar" ;
  osaaverbar_av_1_1_A = mkA "osåverbar" ;
  otabellerbar_av_1_A = mkA "otabellerbar" ;
  otabuerbar_av_1_A = mkA "otabuerbar" ;
  otadlig_av_1_A = mkA "otadlig" ;
  otalig_av_1_A = mkA "otalig" ;
  otamponerbar_av_1_A = mkA "otamponerbar" ;
  otangerbar_av_1_A = mkA "otangerbar" ;
  otapetserbar_av_1_A = mkA "otapetserbar" ;
  otarerbar_av_1_A = mkA "otarerbar" ;
  otarifferbar_av_1_A = mkA "otarifferbar" ;
  otatuerbar_av_1_A = mkA "otatuerbar" ;
  otaxerbar_av_1_A = mkA "otaxerbar" ;
  oteknifierbar_av_1_A = mkA "oteknifierbar" ;
  oteknisk_av_1_A = mkA "oteknisk" ;
  otelefonerbar_av_1_A = mkA "otelefonerbar" ;
  otelegraferbar_av_1_A = mkA "otelegraferbar" ;
  oteleviserbar_av_1_A = mkA "oteleviserbar" ;
  otemperbar_av_1_A = mkA "otemperbar" ;
  otempererbar_av_1_A = mkA "otempererbar" ;
  otenterbar_av_1_A = mkA "otenterbar" ;
  oterrasserbar_av_1_A = mkA "oterrasserbar" ;
  oterroriserbar_av_1_A = mkA "oterroriserbar" ;
  otesaurerbar_av_1_A = mkA "otesaurerbar" ;
  otestamenterbar_av_1_A = mkA "otestamenterbar" ;
  otidig_av_1_A = mkA "otidig" ;
  otidsenlig_av_1_A = mkA "otidsenlig" ;
  otillboerlig_av_1_1_A = mkA "otillbörlig" ;
  otillfoerlitlig_av_1_1_A = mkA "otillförlitlig" ;
  otillgaenglig_av_1_1_A = mkA "otillgänglig" ;
  otillraecklig_av_1_1_A = mkA "otillräcklig" ;
  otillraeknelig_av_1_1_A = mkA "otillräknelig" ;
  otillstaendig_av_1_1_A = mkA "otillständig" ;
  otillaemplig_av_1_1_A = mkA "otillämplig" ;
  otillaatlig_av_1_1_A = mkA "otillåtlig" ;
  otitrerbar_av_1_A = mkA "otitrerbar" ;
  otitulerbar_av_1_A = mkA "otitulerbar" ;
  otjusig_av_1_A = mkA "otjusig" ;
  otjaenlig_av_1_1_A = mkA "otjänlig" ;
  otolererbar_av_1_A = mkA "otolererbar" ;
  otorderbar_av_1_A = mkA "otorderbar" ;
  otorpederbar_av_1_A = mkA "otorpederbar" ;
  otorterbar_av_1_A = mkA "otorterbar" ;
  otoucherbar_av_1_A = mkA "otoucherbar" ;
  otouperbar_av_1_A = mkA "otouperbar" ;
  otraderbar_av_1_A = mkA "otraderbar" ;
  otrafikerbar_av_1_A = mkA "otrafikerbar" ;
  otrakasserbar_av_1_A = mkA "otrakasserbar" ;
  otrakterbar_av_1_A = mkA "otrakterbar" ;
  otrancherbar_av_1_A = mkA "otrancherbar" ;
  otransfererbar_av_1_A = mkA "otransfererbar" ;
  otransformerbar_av_1_A = mkA "otransformerbar" ;
  otransiterbar_av_1_A = mkA "otransiterbar" ;
  otranskriberbar_av_1_A = mkA "otranskriberbar" ;
  otranslittererbar_av_1_A = mkA "otranslittererbar" ;
  otransmitterbar_av_1_A = mkA "otransmitterbar" ;
  otransmuterbar_av_1_A = mkA "otransmuterbar" ;
  otransplanterbar_av_1_A = mkA "otransplanterbar" ;
  otransponerbar_av_1_A = mkA "otransponerbar" ;
  otransporterbar_av_1_A = mkA "otransporterbar" ;
  otransumerbar_av_1_A = mkA "otransumerbar" ;
  otrasserbar_av_1_A = mkA "otrasserbar" ;
  otravesterbar_av_1_A = mkA "otravesterbar" ;
  otrepanerbar_av_1_A = mkA "otrepanerbar" ;
  otrevlig_av_1_A = mkA "otrevlig" ;
  otriangulerbar_av_1_A = mkA "otriangulerbar" ;
  otrierbar_av_1_A = mkA "otrierbar" ;
  otrivialiserbar_av_1_A = mkA "otrivialiserbar" ;
  otrolig_av_1_A = mkA "otrolig" ;
  otryckbar_av_1_A = mkA "otryckbar" ;
  otryfferbar_av_1_A = mkA "otryfferbar" ;
  otrygg_av_1_A = mkA "otrygg" ;
  otroestlig_av_1_1_A = mkA "otröstlig" ;
  otroettlig_av_1_1_A = mkA "otröttlig" ;
  ottomansk_av_1_A = mkA "ottomansk" ;
  otuktig_av_1_A = mkA "otuktig" ;
  otuperbar_av_1_A = mkA "otuperbar" ;
  oturlig_av_1_A = mkA "oturlig" ;
  oturnerbar_av_1_A = mkA "oturnerbar" ;
  otuscherbar_av_1_A = mkA "otuscherbar" ;
  otvetydig_av_1_A = mkA "otvetydig" ;
  otvivelaktig_av_1_A = mkA "otvivelaktig" ;
  otydbar_av_1_A = mkA "otydbar" ;
  otydlig_av_1_A = mkA "otydlig" ;
  otymplig_av_1_A = mkA "otymplig" ;
  otypifierbar_av_1_A = mkA "otypifierbar" ;
  otypiserbar_av_1_A = mkA "otypiserbar" ;
  otypisk_av_1_A = mkA "otypisk" ;
  otyranniserbar_av_1_A = mkA "otyranniserbar" ;
  otaeck_av_1_1_A = mkA "otäck" ;
  otaemjbar_av_1_1_A = mkA "otämjbar" ;
  otaenjbar_av_1_1_A = mkA "otänjbar" ;
  otaenkbar_av_1_1_A = mkA "otänkbar" ;
  otaet_av_1_1_A = mkA "otät" ;
  otaalig_av_1_1_A = mkA "otålig" ;
  otoerstig_av_1_1_A = mkA "otörstig" ;
  oumbaerlig_av_1_1_A = mkA "oumbärlig" ;
  ounderbalanserbar_av_1_A = mkA "ounderbalanserbar" ;
  ounderdimensionerbar_av_1_A = mkA "ounderdimensionerbar" ;
  ounderexponerbar_av_1_A = mkA "ounderexponerbar" ;
  ounderminerbar_av_1_A = mkA "ounderminerbar" ;
  oundertaxerbar_av_1_A = mkA "oundertaxerbar" ;
  oundervaerderbar_av_1_1_A = mkA "oundervärderbar" ;
  oundgaenglig_av_1_1_A = mkA "oundgänglig" ;
  oundviklig_av_1_A = mkA "oundviklig" ;
  ounifierbar_av_1_A = mkA "ounifierbar" ;
  ouniformerbar_av_1_A = mkA "ouniformerbar" ;
  ouppdaterbar_av_1_A = mkA "ouppdaterbar" ;
  ouppfattbar_av_1_A = mkA "ouppfattbar" ;
  ouppgraderbar_av_1_A = mkA "ouppgraderbar" ;
  oupphinnelig_av_1_A = mkA "oupphinnelig" ;
  oupphoerlig_av_1_1_A = mkA "oupphörlig" ;
  ouppjusterbar_av_1_A = mkA "ouppjusterbar" ;
  oupploeslig_av_1_1_A = mkA "oupplöslig" ;
  ouppnaaelig_av_1_1_A = mkA "ouppnåelig" ;
  ouppreklamerbar_av_1_A = mkA "ouppreklamerbar" ;
  ouppskattbar_av_1_A = mkA "ouppskattbar" ;
  ouppsummerbar_av_1_A = mkA "ouppsummerbar" ;
  ouppsaegbar_av_1_1_A = mkA "ouppsägbar" ;
  ouppsaatlig_av_1_1_A = mkA "ouppsåtlig" ;
  oupptaxerbar_av_1_A = mkA "oupptaxerbar" ;
  ouppvaerderbar_av_1_1_A = mkA "ouppvärderbar" ;
  ourbaniserbar_av_1_A = mkA "ourbaniserbar" ;
  oursaektlig_av_1_1_A = mkA "oursäktlig" ;
  ousurperbar_av_1_A = mkA "ousurperbar" ;
  outackorderbar_av_1_A = mkA "outackorderbar" ;
  outannonserbar_av_1_A = mkA "outannonserbar" ;
  outarrenderbar_av_1_A = mkA "outarrenderbar" ;
  outbalanserbar_av_1_A = mkA "outbalanserbar" ;
  outbasunerbar_av_1_A = mkA "outbasunerbar" ;
  outbroderbar_av_1_A = mkA "outbroderbar" ;
  outdebiterbar_av_1_A = mkA "outdebiterbar" ;
  outexaminerbar_av_1_A = mkA "outexaminerbar" ;
  outexperimenterbar_av_1_A = mkA "outexperimenterbar" ;
  outfoerbar_av_1_1_A = mkA "outförbar" ;
  outgrundlig_av_1_A = mkA "outgrundlig" ;
  outhaerdlig_av_1_1_A = mkA "outhärdlig" ;
  outklarerbar_av_1_A = mkA "outklarerbar" ;
  outkommenderbar_av_1_A = mkA "outkommenderbar" ;
  outkonkurrerbar_av_1_A = mkA "outkonkurrerbar" ;
  outkristalliserbar_av_1_A = mkA "outkristalliserbar" ;
  outkvitterbar_av_1_A = mkA "outkvitterbar" ;
  outlokaliserbar_av_1_A = mkA "outlokaliserbar" ;
  outmanoevrerbar_av_1_1_A = mkA "outmanövrerbar" ;
  outminuterbar_av_1_A = mkA "outminuterbar" ;
  outplacerbar_av_1_A = mkA "outplacerbar" ;
  outplaanlig_av_1_1_A = mkA "outplånlig" ;
  outposterbar_av_1_A = mkA "outposterbar" ;
  outraderbar_av_1_A = mkA "outraderbar" ;
  outrangerbar_av_1_A = mkA "outrangerbar" ;
  outrannsaklig_av_1_A = mkA "outrannsaklig" ;
  outrotlig_av_1_A = mkA "outrotlig" ;
  outsinlig_av_1_A = mkA "outsinlig" ;
  outslitlig_av_1_A = mkA "outslitlig" ;
  outslaecklig_av_1_1_A = mkA "outsläcklig" ;
  outstofferbar_av_1_A = mkA "outstofferbar" ;
  outsaegbar_av_1_1_A = mkA "outsägbar" ;
  outsaeglig_av_1_1_A = mkA "outsäglig" ;
  outtalbar_av_1_A = mkA "outtalbar" ;
  outtaxerbar_av_1_A = mkA "outtaxerbar" ;
  outtroettlig_av_1_1_A = mkA "outtröttlig" ;
  outtoemlig_av_1_1_A = mkA "outtömlig" ;
  outvaerderbar_av_1_1_A = mkA "outvärderbar" ;
  ovaccinerbar_av_1_A = mkA "ovaccinerbar" ;
  ovadderbar_av_1_A = mkA "ovadderbar" ;
  ovaksinerbar_av_1_A = mkA "ovaksinerbar" ;
  oval_av_1_A = mkA "oval" ;
  ovaluterbar_av_1_A = mkA "ovaluterbar" ;
  ovalverbar_av_1_A = mkA "ovalverbar" ;
  ovan_av_1_A = mkA "ovan" ;
  ovandaliserbar_av_1_A = mkA "ovandaliserbar" ;
  ovanjordisk_av_1_A = mkA "ovanjordisk" ;
  ovanlig_av_1_A = mkA "ovanlig" ;
  ovansklig_av_1_A = mkA "ovansklig" ;
  ovarierbar_av_1_A = mkA "ovarierbar" ;
  ovederhaeftig_av_1_1_A = mkA "ovederhäftig" ;
  ovederlaegglig_av_1_1_A = mkA "ovederlägglig" ;
  ovedersaeglig_av_1_1_A = mkA "ovedersäglig" ;
  ovelouriserbar_av_1_A = mkA "ovelouriserbar" ;
  oventilerbar_av_1_A = mkA "oventilerbar" ;
  overbaliserbar_av_1_A = mkA "overbaliserbar" ;
  overifierbar_av_1_A = mkA "overifierbar" ;
  overklig_av_1_A = mkA "overklig" ;
  oversifierbar_av_1_A = mkA "oversifierbar" ;
  ovetbar_av_1_A = mkA "ovetbar" ;
  ovetenskaplig_av_1_A = mkA "ovetenskaplig" ;
  ovettig_av_1_A = mkA "ovettig" ;
  ovidimerbar_av_1_A = mkA "ovidimerbar" ;
  ovig_av_1_A = mkA "ovig" ;
  oviktig_av_1_A = mkA "oviktig" ;
  ovillig_av_1_A = mkA "ovillig" ;
  ovillkorlig_av_1_A = mkA "ovillkorlig" ;
  ovindicerbar_av_1_A = mkA "ovindicerbar" ;
  ovipar_av_1_A = mkA "ovipar" ;
  ovis_av_1_A = mkA "ovis" ;
  oviserbar_av_1_A = mkA "oviserbar" ;
  ovisiterbar_av_1_A = mkA "ovisiterbar" ;
  oviss_av_1_A = mkA "oviss" ;
  ovisualiserbar_av_1_A = mkA "ovisualiserbar" ;
  ovitaliserbar_av_1_A = mkA "ovitaliserbar" ;
  ovitaminerbar_av_1_A = mkA "ovitaminerbar" ;
  ovitaminiserbar_av_1_A = mkA "ovitaminiserbar" ;
  ovokaliserbar_av_1_A = mkA "ovokaliserbar" ;
  ovulgariserbar_av_1_A = mkA "ovulgariserbar" ;
  ovulkaniserbar_av_1_A = mkA "ovulkaniserbar" ;
  ovaeldig_av_1_1_A = mkA "oväldig" ;
  ovaenlig_av_1_1_A = mkA "ovänlig" ;
  ovaerderbar_av_1_1_A = mkA "ovärderbar" ;
  ovaerderlig_av_1_1_A = mkA "ovärderlig" ;
  ovaerdig_av_1_1_A = mkA "ovärdig" ;
  ovaerldslig_av_1_1_A = mkA "ovärldslig" ;
  ovaesentlig_av_1_1_A = mkA "oväsentlig" ;
  ovaalig_av_1_1_A = mkA "ovålig" ;
  oxiderbar_av_1_A = mkA "oxiderbar" ;
  oaendlig_av_1_1_A = mkA "oändlig" ;
  oaerlig_av_1_1_A = mkA "oärlig" ;
  oaetbar_av_1_1_A = mkA "oätbar" ;
  oaetlig_av_1_1_A = mkA "oätlig" ;
  oaaterinstallerbar_av_1_1_A = mkA "oåterinstallerbar" ;
  oaaterkallelig_av_1_1_A = mkA "oåterkallelig" ;
  oaatkomlig_av_1_1_A = mkA "oåtkomlig" ;
  ooeverbrygglig_av_1_1_A = mkA "oöverbrygglig" ;
  ooeverdimensionerbar_av_1_1_A = mkA "oöverdimensionerbar" ;
  ooeverdoserbar_av_1_1_A = mkA "oöverdoserbar" ;
  ooeverexponerbar_av_1_1_A = mkA "oöverexponerbar" ;
  ooeverkomlig_av_1_1_A = mkA "oöverkomlig" ;
  ooeverkompenserbar_av_1_1_A = mkA "oöverkompenserbar" ;
  ooeverskaadlig_av_1_1_A = mkA "oöverskådlig" ;
  ooeverstiglig_av_1_1_A = mkA "oöverstiglig" ;
  ooeversaettlig_av_1_1_A = mkA "oöversättlig" ;
  ooevertrasserbar_av_1_1_A = mkA "oövertrasserbar" ;
  ooevertraefflig_av_1_1_A = mkA "oöverträfflig" ;
  ooevervinnelig_av_1_1_A = mkA "oövervinnelig" ;
  ooevervinnerlig_av_1_1_A = mkA "oövervinnerlig" ;
  ooevervinnlig_av_1_1_A = mkA "oövervinnlig" ;
  ooevervaerderbar_av_1_1_A = mkA "oövervärderbar" ;
  pacificerbar_av_1_A = mkA "pacificerbar" ;
  pacifistisk_av_1_A = mkA "pacifistisk" ;
  paff_av_1_A = mkA "paff" ;
  paginerbar_av_1_A = mkA "paginerbar" ;
  pajig_av_1_A = mkA "pajig" ;
  paketerbar_av_1_A = mkA "paketerbar" ;
  pakistansk_av_1_A = mkA "pakistansk" ;
  palatal_av_1_A = mkA "palatal" ;
  palataliserbar_av_1_A = mkA "palataliserbar" ;
  palauisk_av_1_A = mkA "palauisk" ;
  paleoekologisk_av_1_A = mkA "paleoekologisk" ;
  paleolitisk_av_1_A = mkA "paleolitisk" ;
  paleontologisk_av_1_A = mkA "paleontologisk" ;
  palestinsk_av_1_A = mkA "palestinsk" ;
  paljetterbar_av_1_A = mkA "paljetterbar" ;
  palliativ_av_1_A = mkA "palliativ" ;
  palperbar_av_1_A = mkA "palperbar" ;
  paltig_av_1_A = mkA "paltig" ;
  pampig_av_1_A = mkA "pampig" ;
  panafrikansk_av_1_A = mkA "panafrikansk" ;
  panamansk_av_1_A = mkA "panamansk" ;
  panamerikansk_av_1_A = mkA "panamerikansk" ;
  panarabisk_av_1_A = mkA "panarabisk" ;
  panegyrisk_av_1_A = mkA "panegyrisk" ;
  panerbar_av_1_A = mkA "panerbar" ;
  panikmaessig_av_1_1_A = mkA "panikmässig" ;
  panisk_av_1_A = mkA "panisk" ;
  pank_av_1_A = mkA "pank" ;
  pankromatisk_av_1_A = mkA "pankromatisk" ;
  panorerbar_av_1_A = mkA "panorerbar" ;
  panteistisk_av_1_A = mkA "panteistisk" ;
  pantograferbar_av_1_A = mkA "pantograferbar" ;
  pantomimisk_av_1_A = mkA "pantomimisk" ;
  pappaledig_av_1_A = mkA "pappaledig" ;
  pappersloes_av_1_1_A = mkA "papperslös" ;
  pappig_av_1_A = mkA "pappig" ;
  papuansk_av_1_A = mkA "papuansk" ;
  parabolisk_av_1_A = mkA "parabolisk" ;
  paraderbar_av_1_A = mkA "paraderbar" ;
  paradisisk_av_1_A = mkA "paradisisk" ;
  paradmaessig_av_1_1_A = mkA "paradmässig" ;
  paradoxal_av_1_A = mkA "paradoxal" ;
  paraferbar_av_1_A = mkA "paraferbar" ;
  paraffinerbar_av_1_A = mkA "paraffinerbar" ;
  parafraserbar_av_1_A = mkA "parafraserbar" ;
  parafrastisk_av_1_A = mkA "parafrastisk" ;
  paraguayansk_av_1_A = mkA "paraguayansk" ;
  paraguaysk_av_1_A = mkA "paraguaysk" ;
  parallell_av_1_A = mkA "parallell" ;
  parallelliserbar_av_1_A = mkA "parallelliserbar" ;
  paralyserbar_av_1_A = mkA "paralyserbar" ;
  paralytisk_av_1_A = mkA "paralytisk" ;
  paramilitaer_av_1_1_A = mkA "paramilitär" ;
  parasitisk_av_1_A = mkA "parasitisk" ;
  parasitaer_av_1_1_A = mkA "parasitär" ;
  parataktisk_av_1_A = mkA "parataktisk" ;
  parbladig_av_1_A = mkA "parbladig" ;
  parentetisk_av_1_A = mkA "parentetisk" ;
  parerbar_av_1_A = mkA "parerbar" ;
  parflikig_av_1_A = mkA "parflikig" ;
  parfymerbar_av_1_A = mkA "parfymerbar" ;
  parig_av_1_A = mkA "parig" ;
  parisisk_av_1_A = mkA "parisisk" ;
  parkerbar_av_1_A = mkA "parkerbar" ;
  parketterbar_av_1_A = mkA "parketterbar" ;
  parlamentarisk_av_1_A = mkA "parlamentarisk" ;
  parodierbar_av_1_A = mkA "parodierbar" ;
  parodisk_av_1_A = mkA "parodisk" ;
  participiell_av_1_A = mkA "participiell" ;
  partiell_av_1_A = mkA "partiell" ;
  partikuljaer_av_1_1_A = mkA "partikuljär" ;
  partikulaer_av_1_1_A = mkA "partikulär" ;
  partiloes_av_1_1_A = mkA "partilös" ;
  partimaessig_av_1_1_A = mkA "partimässig" ;
  partipolitisk_av_1_A = mkA "partipolitisk" ;
  partisk_av_1_A = mkA "partisk" ;
  partitiv_av_1_A = mkA "partitiv" ;
  partaaig_av_1_1_A = mkA "partåig" ;
  passerbar_av_1_A = mkA "passerbar" ;
  passionsfri_av_1_A = mkA "passionsfri" ;
  passiv_av_1_A = mkA "passiv" ;
  passiverbar_av_1_A = mkA "passiverbar" ;
  passiviserbar_av_1_A = mkA "passiviserbar" ;
  passlig_av_1_A = mkA "passlig" ;
  pastoral_av_1_A = mkA "pastoral" ;
  pastos_av_1_A = mkA "pastos" ;
  pastoeriserbar_av_1_1_A = mkA "pastöriserbar" ;
  pastoes_av_1_1_A = mkA "pastös" ;
  patenterbar_av_1_A = mkA "patenterbar" ;
  patetisk_av_1_A = mkA "patetisk" ;
  patinerbar_av_1_A = mkA "patinerbar" ;
  patologisk_av_1_A = mkA "patologisk" ;
  patriarkal_av_1_A = mkA "patriarkal" ;
  patriarkalisk_av_1_A = mkA "patriarkalisk" ;
  patriotisk_av_1_A = mkA "patriotisk" ;
  patrullerbar_av_1_A = mkA "patrullerbar" ;
  pauperiserbar_av_1_A = mkA "pauperiserbar" ;
  pauserbar_av_1_A = mkA "pauserbar" ;
  pauskommaterbar_av_1_A = mkA "pauskommaterbar" ;
  pedagogisk_av_1_A = mkA "pedagogisk" ;
  pedantisk_av_1_A = mkA "pedantisk" ;
  pediatrisk_av_1_A = mkA "pediatrisk" ;
  pejorativ_av_1_A = mkA "pejorativ" ;
  pekoralistisk_av_1_A = mkA "pekoralistisk" ;
  pekuniaer_av_1_1_A = mkA "pekuniär" ;
  pelagisk_av_1_A = mkA "pelagisk" ;
  pelarformig_av_1_A = mkA "pelarformig" ;
  pelleterbar_av_1_A = mkA "pelleterbar" ;
  penetrerbar_av_1_A = mkA "penetrerbar" ;
  pengamaessig_av_1_1_A = mkA "pengamässig" ;
  penningmaessig_av_1_1_A = mkA "penningmässig" ;
  pensionerbar_av_1_A = mkA "pensionerbar" ;
  pensionsmaessig_av_1_1_A = mkA "pensionsmässig" ;
  perceptuell_av_1_A = mkA "perceptuell" ;
  percipierbar_av_1_A = mkA "percipierbar" ;
  peremtorisk_av_1_A = mkA "peremtorisk" ;
  perfektiv_av_1_A = mkA "perfektiv" ;
  perfektivisk_av_1_A = mkA "perfektivisk" ;
  perforerbar_av_1_A = mkA "perforerbar" ;
  perifrastisk_av_1_A = mkA "perifrastisk" ;
  perinatal_av_1_A = mkA "perinatal" ;
  periodiserbar_av_1_A = mkA "periodiserbar" ;
  periodisk_av_1_A = mkA "periodisk" ;
  periskopisk_av_1_A = mkA "periskopisk" ;
  peristaltisk_av_1_A = mkA "peristaltisk" ;
  perkutan_av_1_A = mkA "perkutan" ;
  permanentondulerbar_av_1_A = mkA "permanentondulerbar" ;
  permitterbar_av_1_A = mkA "permitterbar" ;
  permuterbar_av_1_A = mkA "permuterbar" ;
  pernicioes_av_1_1_A = mkA "perniciös" ;
  perpendikulaer_av_1_1_A = mkA "perpendikulär" ;
  perpetuell_av_1_A = mkA "perpetuell" ;
  perplex_av_1_A = mkA "perplex" ;
  persiflerbar_av_1_A = mkA "persiflerbar" ;
  persisk_av_1_A = mkA "persisk" ;
  personalmaessig_av_1_1_A = mkA "personalmässig" ;
  personell_av_1_A = mkA "personell" ;
  personhistorisk_av_1_A = mkA "personhistorisk" ;
  personifierbar_av_1_A = mkA "personifierbar" ;
  personlig_av_1_A = mkA "personlig" ;
  personlighetsmaessig_av_1_1_A = mkA "personlighetsmässig" ;
  personmaessig_av_1_1_A = mkA "personmässig" ;
  personpolitisk_av_1_A = mkA "personpolitisk" ;
  perspektivisk_av_1_A = mkA "perspektivisk" ;
  perspektivloes_av_1_1_A = mkA "perspektivlös" ;
  perspektivmaessig_av_1_1_A = mkA "perspektivmässig" ;
  persvaderbar_av_1_A = mkA "persvaderbar" ;
  peruansk_av_1_A = mkA "peruansk" ;
  pervers_av_1_A = mkA "pervers" ;
  perverterbar_av_1_A = mkA "perverterbar" ;
  pessimistisk_av_1_A = mkA "pessimistisk" ;
  petig_av_1_A = mkA "petig" ;
  petrifierbar_av_1_A = mkA "petrifierbar" ;
  petrokemisk_av_1_A = mkA "petrokemisk" ;
  pietetsfull_av_1_A = mkA "pietetsfull" ;
  pietetsloes_av_1_1_A = mkA "pietetslös" ;
  piffig_av_1_A = mkA "piffig" ;
  pigg_av_1_A = mkA "pigg" ;
  pikerbar_av_1_A = mkA "pikerbar" ;
  pillemarisk_av_1_A = mkA "pillemarisk" ;
  pillrig_av_1_A = mkA "pillrig" ;
  pilsk_av_1_A = mkA "pilsk" ;
  pilsnabb_av_1_A = mkA "pilsnabb" ;
  pincerbar_av_1_A = mkA "pincerbar" ;
  pingstvaenlig_av_1_1_A = mkA "pingstvänlig" ;
  pinknoedig_av_1_1_A = mkA "pinknödig" ;
  pinlig_av_1_A = mkA "pinlig" ;
  pinnig_av_1_A = mkA "pinnig" ;
  pionjaermaessig_av_1_1_A = mkA "pionjärmässig" ;
  pipig_av_1_A = mkA "pipig" ;
  pirrig_av_1_A = mkA "pirrig" ;
  pissig_av_1_A = mkA "pissig" ;
  pittoresk_av_1_A = mkA "pittoresk" ;
  pjoskig_av_1_A = mkA "pjoskig" ;
  pjunkig_av_1_A = mkA "pjunkig" ;
  pjaakig_av_1_1_A = mkA "pjåkig" ;
  placerbar_av_1_A = mkA "placerbar" ;
  pladdrig_av_1_A = mkA "pladdrig" ;
  plagierbar_av_1_A = mkA "plagierbar" ;
  plan_av_1_A = mkA "plan" ;
  planenlig_av_1_A = mkA "planenlig" ;
  planerbar_av_1_A = mkA "planerbar" ;
  planeringsmaessig_av_1_1_A = mkA "planeringsmässig" ;
  planetarisk_av_1_A = mkA "planetarisk" ;
  plankonkav_av_1_A = mkA "plankonkav" ;
  plankonvex_av_1_A = mkA "plankonvex" ;
  planloes_av_1_1_A = mkA "planlös" ;
  planmaessig_av_1_1_A = mkA "planmässig" ;
  planparallell_av_1_A = mkA "planparallell" ;
  planterbar_av_1_A = mkA "planterbar" ;
  plaskvaat_av_1_1_A = mkA "plaskvåt" ;
  plastisk_av_1_A = mkA "plastisk" ;
  platinerbar_av_1_A = mkA "platinerbar" ;
  platonisk_av_1_A = mkA "platonisk" ;
  platonsk_av_1_A = mkA "platonsk" ;
  platsmaessig_av_1_1_A = mkA "platsmässig" ;
  plattysk_av_1_A = mkA "plattysk" ;
  plebejisk_av_1_A = mkA "plebejisk" ;
  pleonastisk_av_1_A = mkA "pleonastisk" ;
  pliktig_av_1_A = mkA "pliktig" ;
  pliktmaessig_av_1_1_A = mkA "pliktmässig" ;
  pliktskyldig_av_1_A = mkA "pliktskyldig" ;
  plirig_av_1_A = mkA "plirig" ;
  plisserbar_av_1_A = mkA "plisserbar" ;
  plockig_av_1_A = mkA "plockig" ;
  plomberbar_av_1_A = mkA "plomberbar" ;
  plottrig_av_1_A = mkA "plottrig" ;
  plufsig_av_1_A = mkA "plufsig" ;
  plump_av_1_A = mkA "plump" ;
  plural_av_1_A = mkA "plural" ;
  pluralistisk_av_1_A = mkA "pluralistisk" ;
  plussig_av_1_A = mkA "plussig" ;
  plutonisk_av_1_A = mkA "plutonisk" ;
  pluttig_av_1_A = mkA "pluttig" ;
  pluvial_av_1_A = mkA "pluvial" ;
  plaeterbar_av_1_1_A = mkA "pläterbar" ;
  ploetslig_av_1_1_A = mkA "plötslig" ;
  pneumatisk_av_1_A = mkA "pneumatisk" ;
  pocherbar_av_1_A = mkA "pocherbar" ;
  poesiloes_av_1_1_A = mkA "poesilös" ;
  poetisk_av_1_A = mkA "poetisk" ;
  pointerbar_av_1_A = mkA "pointerbar" ;
  pojkaktig_av_1_A = mkA "pojkaktig" ;
  pojklagsmaessig_av_1_1_A = mkA "pojklagsmässig" ;
  polar_av_1_A = mkA "polar" ;
  polariserbar_av_1_A = mkA "polariserbar" ;
  polemisk_av_1_A = mkA "polemisk" ;
  polerbar_av_1_A = mkA "polerbar" ;
  poliklinisk_av_1_A = mkA "poliklinisk" ;
  polisiaer_av_1_1_A = mkA "polisiär" ;
  politiserbar_av_1_A = mkA "politiserbar" ;
  politisk_av_1_A = mkA "politisk" ;
  polletterbar_av_1_A = mkA "polletterbar" ;
  pollinerbar_av_1_A = mkA "pollinerbar" ;
  polsk_fransk_av_1_A = mkA "polsk-fransk" ;
  polsk_av_1_A = mkA "polsk" ;
  polyfon_av_1_A = mkA "polyfon" ;
  polygam_av_1_A = mkA "polygam" ;
  polykrom_av_1_A = mkA "polykrom" ;
  polymorf_av_1_A = mkA "polymorf" ;
  polynesisk_av_1_A = mkA "polynesisk" ;
  polyteknisk_av_1_A = mkA "polyteknisk" ;
  polaer_av_1_1_A = mkA "polär" ;
  pomaderbar_av_1_A = mkA "pomaderbar" ;
  pommersk_av_1_A = mkA "pommersk" ;
  pompoes_av_1_1_A = mkA "pompös" ;
  poppig_av_1_A = mkA "poppig" ;
  populariserbar_av_1_A = mkA "populariserbar" ;
  popularitetsmaessig_av_1_1_A = mkA "popularitetsmässig" ;
  populistisk_av_1_A = mkA "populistisk" ;
  populaer_av_1_1_A = mkA "populär" ;
  populaervetenskaplig_av_1_1_A = mkA "populärvetenskaplig" ;
  porig_av_1_A = mkA "porig" ;
  pornografisk_av_1_A = mkA "pornografisk" ;
  porrig_av_1_A = mkA "porrig" ;
  portativ_av_1_A = mkA "portativ" ;
  portionerbar_av_1_A = mkA "portionerbar" ;
  portraetterbar_av_1_1_A = mkA "porträtterbar" ;
  portraettlik_av_1_1_A = mkA "porträttlik" ;
  portugisisk_av_1_A = mkA "portugisisk" ;
  poroes_av_1_1_A = mkA "porös" ;
  positiv_av_1_A = mkA "positiv" ;
  positivistisk_av_1_A = mkA "positivistisk" ;
  possessiv_av_1_A = mkA "possessiv" ;
  postal_av_1_A = mkA "postal" ;
  postdaterbar_av_1_A = mkA "postdaterbar" ;
  posterbar_av_1_A = mkA "posterbar" ;
  postglacial_av_1_A = mkA "postglacial" ;
  postgymnasial_av_1_A = mkA "postgymnasial" ;
  postindustriell_av_1_A = mkA "postindustriell" ;
  postnatal_av_1_A = mkA "postnatal" ;
  postponerbar_av_1_A = mkA "postponerbar" ;
  postulerbar_av_1_A = mkA "postulerbar" ;
  potentiell_av_1_A = mkA "potentiell" ;
  poaengloes_av_1_1_A = mkA "poänglös" ;
  poaengmaessig_av_1_1_A = mkA "poängmässig" ;
  poaengterbar_av_1_1_A = mkA "poängterbar" ;
  pragmatisk_av_1_A = mkA "pragmatisk" ;
  praktfull_av_1_A = mkA "praktfull" ;
  praktiserbar_av_1_A = mkA "praktiserbar" ;
  praktisk_av_1_A = mkA "praktisk" ;
  pratig_av_1_A = mkA "pratig" ;
  pratsjuk_av_1_A = mkA "pratsjuk" ;
  precis_av_1_A = mkA "precis" ;
  preciserbar_av_1_A = mkA "preciserbar" ;
  precioes_av_1_1_A = mkA "preciös" ;
  predestinerbar_av_1_A = mkA "predestinerbar" ;
  predicerbar_av_1_A = mkA "predicerbar" ;
  predikantmaessig_av_1_1_A = mkA "predikantmässig" ;
  predikativ_av_1_A = mkA "predikativ" ;
  predikatlogisk_av_1_A = mkA "predikatlogisk" ;
  predisponerbar_av_1_A = mkA "predisponerbar" ;
  prefabricerbar_av_1_A = mkA "prefabricerbar" ;
  prefererbar_av_1_A = mkA "prefererbar" ;
  prefigerbar_av_1_A = mkA "prefigerbar" ;
  preglacial_av_1_A = mkA "preglacial" ;
  prehistorisk_av_1_A = mkA "prehistorisk" ;
  prekaer_av_1_1_A = mkA "prekär" ;
  preliminaer_av_1_1_A = mkA "preliminär" ;
  preludierbar_av_1_A = mkA "preludierbar" ;
  premiegill_av_1_A = mkA "premiegill" ;
  premierbar_av_1_A = mkA "premierbar" ;
  prenatal_av_1_A = mkA "prenatal" ;
  preparerbar_av_1_A = mkA "preparerbar" ;
  prepositionell_av_1_A = mkA "prepositionell" ;
  presenterbar_av_1_A = mkA "presenterbar" ;
  preserverbar_av_1_A = mkA "preserverbar" ;
  presidentmaessig_av_1_1_A = mkA "presidentmässig" ;
  preskriberbar_av_1_A = mkA "preskriberbar" ;
  prestandamaessig_av_1_1_A = mkA "prestandamässig" ;
  presterbar_av_1_A = mkA "presterbar" ;
  prestigemaessig_av_1_1_A = mkA "prestigemässig" ;
  presumerbar_av_1_A = mkA "presumerbar" ;
  presumtiv_av_1_A = mkA "presumtiv" ;
  pretentioes_av_1_1_A = mkA "pretentiös" ;
  pretioes_av_1_1_A = mkA "pretiös" ;
  preussisk_av_1_A = mkA "preussisk" ;
  preventiv_av_1_A = mkA "preventiv" ;
  prickig_av_1_A = mkA "prickig" ;
  prillig_av_1_A = mkA "prillig" ;
  primitiv_av_1_A = mkA "primitiv" ;
  primitivistisk_av_1_A = mkA "primitivistisk" ;
  primaer_av_1_1_A = mkA "primär" ;
  principiell_av_1_A = mkA "principiell" ;
  principloes_av_1_1_A = mkA "principlös" ;
  prioriterbar_av_1_A = mkA "prioriterbar" ;
  prioriteringsmaessig_av_1_1_A = mkA "prioriteringsmässig" ;
  prisbillig_av_1_A = mkA "prisbillig" ;
  prismatisk_av_1_A = mkA "prismatisk" ;
  prismaessig_av_1_1_A = mkA "prismässig" ;
  prisreglerbar_av_1_A = mkA "prisreglerbar" ;
  privatekonomisk_av_1_A = mkA "privatekonomisk" ;
  privatiserbar_av_1_A = mkA "privatiserbar" ;
  privilegierbar_av_1_A = mkA "privilegierbar" ;
  probabilistisk_av_1_A = mkA "probabilistisk" ;
  proberbar_av_1_A = mkA "proberbar" ;
  problematiserbar_av_1_A = mkA "problematiserbar" ;
  problematisk_av_1_A = mkA "problematisk" ;
  procentisk_av_1_A = mkA "procentisk" ;
  procentuell_av_1_A = mkA "procentuell" ;
  processuell_av_1_A = mkA "processuell" ;
  producerbar_av_1_A = mkA "producerbar" ;
  produktionsmaessig_av_1_1_A = mkA "produktionsmässig" ;
  produktiv_av_1_A = mkA "produktiv" ;
  produktmaessig_av_1_1_A = mkA "produktmässig" ;
  profan_av_1_A = mkA "profan" ;
  profanerbar_av_1_A = mkA "profanerbar" ;
  professionaliserbar_av_1_A = mkA "professionaliserbar" ;
  professionell_av_1_A = mkA "professionell" ;
  professorlig_av_1_A = mkA "professorlig" ;
  profetisk_av_1_A = mkA "profetisk" ;
  proffsig_av_1_A = mkA "proffsig" ;
  profilerbar_av_1_A = mkA "profilerbar" ;
  profylaktisk_av_1_A = mkA "profylaktisk" ;
  prognostiserbar_av_1_A = mkA "prognostiserbar" ;
  prognostisk_av_1_A = mkA "prognostisk" ;
  programenlig_av_1_A = mkA "programenlig" ;
  programledarmaessig_av_1_1_A = mkA "programledarmässig" ;
  programmatisk_av_1_A = mkA "programmatisk" ;
  programmerbar_av_1_A = mkA "programmerbar" ;
  programmaessig_av_1_1_A = mkA "programmässig" ;
  progressiv_av_1_A = mkA "progressiv" ;
  prohibitiv_av_1_A = mkA "prohibitiv" ;
  proisraelisk_av_1_A = mkA "proisraelisk" ;
  projekterbar_av_1_A = mkA "projekterbar" ;
  projektiv_av_1_A = mkA "projektiv" ;
  projicerbar_av_1_A = mkA "projicerbar" ;
  proklamerbar_av_1_A = mkA "proklamerbar" ;
  proklitisk_av_1_A = mkA "proklitisk" ;
  prokrustisk_av_1_A = mkA "prokrustisk" ;
  prokurdisk_av_1_A = mkA "prokurdisk" ;
  proletariserbar_av_1_A = mkA "proletariserbar" ;
  proletaer_av_1_1_A = mkA "proletär" ;
  prolongerbar_av_1_A = mkA "prolongerbar" ;
  promiskuoes_av_1_1_A = mkA "promiskuös" ;
  promoverbar_av_1_A = mkA "promoverbar" ;
  promulgerbar_av_1_A = mkA "promulgerbar" ;
  pronominal_av_1_A = mkA "pronominal" ;
  pronominell_av_1_A = mkA "pronominell" ;
  prononcerbar_av_1_A = mkA "prononcerbar" ;
  propagandamaessig_av_1_1_A = mkA "propagandamässig" ;
  propagandistisk_av_1_A = mkA "propagandistisk" ;
  propedeutisk_av_1_A = mkA "propedeutisk" ;
  proponerbar_av_1_A = mkA "proponerbar" ;
  proportionell_av_1_A = mkA "proportionell" ;
  proportionerbar_av_1_A = mkA "proportionerbar" ;
  proportionerlig_av_1_A = mkA "proportionerlig" ;
  proppfull_av_1_A = mkA "proppfull" ;
  prosaisk_av_1_A = mkA "prosaisk" ;
  proskriberbar_av_1_A = mkA "proskriberbar" ;
  prosodisk_av_1_A = mkA "prosodisk" ;
  prospekterbar_av_1_A = mkA "prospekterbar" ;
  protegerbar_av_1_A = mkA "protegerbar" ;
  proteinrik_av_1_A = mkA "proteinrik" ;
  proteisk_av_1_A = mkA "proteisk" ;
  protektionistisk_av_1_A = mkA "protektionistisk" ;
  protestantisk_av_1_A = mkA "protestantisk" ;
  protokollerbar_av_1_A = mkA "protokollerbar" ;
  protokollmaessig_av_1_1_A = mkA "protokollmässig" ;
  protokollaer_av_1_1_A = mkA "protokollär" ;
  provensalsk_av_1_A = mkA "provensalsk" ;
  provinsiell_av_1_A = mkA "provinsiell" ;
  provisorisk_av_1_A = mkA "provisorisk" ;
  provocerbar_av_1_A = mkA "provocerbar" ;
  provokativ_av_1_A = mkA "provokativ" ;
  provokatorisk_av_1_A = mkA "provokatorisk" ;
  proximal_av_1_A = mkA "proximal" ;
  prudentlig_av_1_A = mkA "prudentlig" ;
  pruttig_av_1_A = mkA "pruttig" ;
  prydlig_av_1_A = mkA "prydlig" ;
  pryltokig_av_1_A = mkA "pryltokig" ;
  praektig_av_1_1_A = mkA "präktig" ;
  praesterlig_av_1_1_A = mkA "prästerlig" ;
  praalfri_av_1_1_A = mkA "prålfri" ;
  praalig_av_1_1_A = mkA "prålig" ;
  psykedelisk_av_1_A = mkA "psykedelisk" ;
  psykiatrisk_av_1_A = mkA "psykiatrisk" ;
  psykisk_av_1_A = mkA "psykisk" ;
  psykoanalyserbar_av_1_A = mkA "psykoanalyserbar" ;
  psykoanalytisk_av_1_A = mkA "psykoanalytisk" ;
  psykologiserbar_av_1_A = mkA "psykologiserbar" ;
  psykologisk_av_1_A = mkA "psykologisk" ;
  psykoprofylaktisk_av_1_A = mkA "psykoprofylaktisk" ;
  psykosocial_av_1_A = mkA "psykosocial" ;
  psykosomatisk_av_1_A = mkA "psykosomatisk" ;
  psykotisk_av_1_A = mkA "psykotisk" ;
  pubertal_av_1_A = mkA "pubertal" ;
  publicerbar_av_1_A = mkA "publicerbar" ;
  publicistisk_av_1_A = mkA "publicistisk" ;
  publik_av_1_A = mkA "publik" ;
  publikmaessig_av_1_1_A = mkA "publikmässig" ;
  puckelryggig_av_1_A = mkA "puckelryggig" ;
  pucklig_av_1_A = mkA "pucklig" ;
  pudrig_av_1_A = mkA "pudrig" ;
  pueril_av_1_A = mkA "pueril" ;
  pulveriserbar_av_1_A = mkA "pulveriserbar" ;
  pulverlackerbar_av_1_A = mkA "pulverlackerbar" ;
  pulvriserbar_av_1_A = mkA "pulvriserbar" ;
  pundig_av_1_A = mkA "pundig" ;
  punisk_av_1_A = mkA "punisk" ;
  punkterbar_av_1_A = mkA "punkterbar" ;
  punktlig_av_1_A = mkA "punktlig" ;
  punktuell_av_1_A = mkA "punktuell" ;
  pur_av_1_A = mkA "pur" ;
  purgerbar_av_1_A = mkA "purgerbar" ;
  puritansk_av_1_A = mkA "puritansk" ;
  pussig_av_1_A = mkA "pussig" ;
  putig_av_1_A = mkA "putig" ;
  putslustig_av_1_A = mkA "putslustig" ;
  puttrig_av_1_A = mkA "puttrig" ;
  pyknisk_av_1_A = mkA "pyknisk" ;
  pyramidal_av_1_A = mkA "pyramidal" ;
  pyreneisk_av_1_A = mkA "pyreneisk" ;
  pyroteknisk_av_1_A = mkA "pyroteknisk" ;
  pysslig_av_1_A = mkA "pysslig" ;
  paaannonserbar_av_1_1_A = mkA "påannonserbar" ;
  paahittig_av_1_1_A = mkA "påhittig" ;
  paalitlig_av_1_1_A = mkA "pålitlig" ;
  paapasslig_av_1_1_A = mkA "påpasslig" ;
  paasig_av_1_1_A = mkA "påsig" ;
  paaskledig_av_1_1_A = mkA "påskledig" ;
  paastridig_av_1_1_A = mkA "påstridig" ;
  paastaaelig_av_1_1_A = mkA "påståelig" ;
  paatagbar_av_1_1_A = mkA "påtagbar" ;
  paataglig_av_1_1_A = mkA "påtaglig" ;
  paaverkbar_av_1_1_A = mkA "påverkbar" ;
  paavisbar_av_1_1_A = mkA "påvisbar" ;
  paavisk_av_1_1_A = mkA "påvisk" ;
  paavislig_av_1_1_A = mkA "påvislig" ;
  paavlig_av_1_1_A = mkA "påvlig" ;
  poebelaktig_av_1_1_A = mkA "pöbelaktig" ;
  poelsig_av_1_1_A = mkA "pölsig" ;
  poesig_av_1_1_A = mkA "pösig" ;
  qatarisk_av_1_A = mkA "qatarisk" ;
  rabatterbar_av_1_A = mkA "rabatterbar" ;
  rabulistisk_av_1_A = mkA "rabulistisk" ;
  racingmaessig_av_1_1_A = mkA "racingmässig" ;
  rackaraktig_av_1_A = mkA "rackaraktig" ;
  racklig_av_1_A = mkA "racklig" ;
  raderbar_av_1_A = mkA "raderbar" ;
  radial_av_1_A = mkA "radial" ;
  radiell_av_1_A = mkA "radiell" ;
  radierbar_av_1_A = mkA "radierbar" ;
  radikal_av_1_A = mkA "radikal" ;
  radikaliserbar_av_1_A = mkA "radikaliserbar" ;
  radioaktiv_av_1_A = mkA "radioaktiv" ;
  radioastronomisk_av_1_A = mkA "radioastronomisk" ;
  radiomaessig_av_1_1_A = mkA "radiomässig" ;
  radionavigerbar_av_1_A = mkA "radionavigerbar" ;
  raffig_av_1_A = mkA "raffig" ;
  raffinerbar_av_1_A = mkA "raffinerbar" ;
  rafflig_av_1_A = mkA "rafflig" ;
  raggig_av_1_A = mkA "raggig" ;
  rak_av_1_A = mkA "rak" ;
  rakitisk_av_1_A = mkA "rakitisk" ;
  raklinjig_av_1_A = mkA "raklinjig" ;
  raklaang_av_1_1_A = mkA "raklång" ;
  ramponerbar_av_1_A = mkA "ramponerbar" ;
  ramstark_av_1_A = mkA "ramstark" ;
  randig_av_1_A = mkA "randig" ;
  randomiserbar_av_1_A = mkA "randomiserbar" ;
  rangerbar_av_1_A = mkA "rangerbar" ;
  ranglig_av_1_A = mkA "ranglig" ;
  rangmaessig_av_1_1_A = mkA "rangmässig" ;
  rank_av_1_A = mkA "rank" ;
  rankig_av_1_A = mkA "rankig" ;
  ransonerbar_av_1_A = mkA "ransonerbar" ;
  rapp_av_1_A = mkA "rapp" ;
  rappellerbar_av_1_A = mkA "rappellerbar" ;
  rapporterbar_av_1_A = mkA "rapporterbar" ;
  rapsodisk_av_1_A = mkA "rapsodisk" ;
  rar_av_1_A = mkA "rar" ;
  rasdiskriminerbar_av_1_A = mkA "rasdiskriminerbar" ;
  raserbar_av_1_A = mkA "raserbar" ;
  rasistisk_av_1_A = mkA "rasistisk" ;
  rask_av_1_A = mkA "rask" ;
  rasmaessig_av_1_1_A = mkA "rasmässig" ;
  raspig_av_1_A = mkA "raspig" ;
  rastloes_av_1_1_A = mkA "rastlös" ;
  ratificerbar_av_1_A = mkA "ratificerbar" ;
  rationaliserbar_av_1_A = mkA "rationaliserbar" ;
  rationell_av_1_A = mkA "rationell" ;
  reaktionaer_av_1_1_A = mkA "reaktionär" ;
  reaktiv_av_1_A = mkA "reaktiv" ;
  reaktiverbar_av_1_A = mkA "reaktiverbar" ;
  real_av_1_A = mkA "real" ;
  realiserbar_av_1_A = mkA "realiserbar" ;
  realistisk_av_1_A = mkA "realistisk" ;
  reassurerbar_av_1_A = mkA "reassurerbar" ;
  rebellisk_av_1_A = mkA "rebellisk" ;
  recenserbar_av_1_A = mkA "recenserbar" ;
  receptiv_av_1_A = mkA "receptiv" ;
  recessiv_av_1_A = mkA "recessiv" ;
  recipierbar_av_1_A = mkA "recipierbar" ;
  reciprok_av_1_A = mkA "reciprok" ;
  reciterbar_av_1_A = mkA "reciterbar" ;
  redaktionell_av_1_A = mkA "redaktionell" ;
  redbar_av_1_A = mkA "redbar" ;
  redig_av_1_A = mkA "redig" ;
  redigerbar_av_1_A = mkA "redigerbar" ;
  redlig_av_1_A = mkA "redlig" ;
  redloes_av_1_1_A = mkA "redlös" ;
  redovisningsmaessig_av_1_1_A = mkA "redovisningsmässig" ;
  reducerbar_av_1_A = mkA "reducerbar" ;
  reell_av_1_A = mkA "reell" ;
  refererbar_av_1_A = mkA "refererbar" ;
  reflekterbar_av_1_A = mkA "reflekterbar" ;
  reflektionsloes_av_1_1_A = mkA "reflektionslös" ;
  reflexionsloes_av_1_1_A = mkA "reflexionslös" ;
  reflexiv_av_1_A = mkA "reflexiv" ;
  reflexmaessig_av_1_1_A = mkA "reflexmässig" ;
  reformerbar_av_1_A = mkA "reformerbar" ;
  reformvaenlig_av_1_1_A = mkA "reformvänlig" ;
  refuserbar_av_1_A = mkA "refuserbar" ;
  regal_av_1_A = mkA "regal" ;
  regalerbar_av_1_A = mkA "regalerbar" ;
  regelloes_av_1_1_A = mkA "regellös" ;
  regelmaessig_av_1_1_A = mkA "regelmässig" ;
  regelvidrig_av_1_A = mkA "regelvidrig" ;
  regenererbar_av_1_A = mkA "regenererbar" ;
  regerbar_av_1_A = mkA "regerbar" ;
  regeringsduglig_av_1_A = mkA "regeringsduglig" ;
  regeringsfientlig_av_1_A = mkA "regeringsfientlig" ;
  regeringskritisk_av_1_A = mkA "regeringskritisk" ;
  regerlig_av_1_A = mkA "regerlig" ;
  regimkritisk_av_1_A = mkA "regimkritisk" ;
  regimaessig_av_1_1_A = mkA "regimässig" ;
  regional_av_1_A = mkA "regional" ;
  regisserbar_av_1_A = mkA "regisserbar" ;
  registrerbar_av_1_A = mkA "registrerbar" ;
  reglementarisk_av_1_A = mkA "reglementarisk" ;
  reglementerbar_av_1_A = mkA "reglementerbar" ;
  reglementsenlig_av_1_A = mkA "reglementsenlig" ;
  reglementsvidrig_av_1_A = mkA "reglementsvidrig" ;
  reglerbar_av_1_A = mkA "reglerbar" ;
  regnfri_av_1_A = mkA "regnfri" ;
  regnig_av_1_A = mkA "regnig" ;
  regntung_av_1_A = mkA "regntung" ;
  regntaet_av_1_1_A = mkA "regntät" ;
  regnvaat_av_1_1_A = mkA "regnvåt" ;
  regressiv_av_1_A = mkA "regressiv" ;
  reguljaer_av_1_1_A = mkA "reguljär" ;
  regummerbar_av_1_A = mkA "regummerbar" ;
  rehabiliterbar_av_1_A = mkA "rehabiliterbar" ;
  reinkarnerbar_av_1_A = mkA "reinkarnerbar" ;
  rejael_av_1_1_A = mkA "rejäl" ;
  rekapitulerbar_av_1_A = mkA "rekapitulerbar" ;
  reklamerbar_av_1_A = mkA "reklamerbar" ;
  rekognoscerbar_av_1_A = mkA "rekognoscerbar" ;
  rekognoserbar_av_1_A = mkA "rekognoserbar" ;
  rekommenderbar_av_1_A = mkA "rekommenderbar" ;
  rekompenserbar_av_1_A = mkA "rekompenserbar" ;
  rekonstruerbar_av_1_A = mkA "rekonstruerbar" ;
  rekorddjup_av_1_A = mkA "rekorddjup" ;
  rekorderlig_av_1_A = mkA "rekorderlig" ;
  rekordmaessig_av_1_1_A = mkA "rekordmässig" ;
  rekordsnabb_av_1_A = mkA "rekordsnabb" ;
  rekreationsmaessig_av_1_1_A = mkA "rekreationsmässig" ;
  rekreativ_av_1_A = mkA "rekreativ" ;
  rekryterbar_av_1_A = mkA "rekryterbar" ;
  rektangulaer_av_1_1_A = mkA "rektangulär" ;
  rektificerbar_av_1_A = mkA "rektificerbar" ;
  rektifierbar_av_1_A = mkA "rektifierbar" ;
  rekvirerbar_av_1_A = mkA "rekvirerbar" ;
  relaterbar_av_1_A = mkA "relaterbar" ;
  relationsmaessig_av_1_1_A = mkA "relationsmässig" ;
  relativ_av_1_A = mkA "relativ" ;
  relativistisk_av_1_A = mkA "relativistisk" ;
  relegerbar_av_1_A = mkA "relegerbar" ;
  religionsfientlig_av_1_A = mkA "religionsfientlig" ;
  religionsloes_av_1_1_A = mkA "religionslös" ;
  religioes_av_1_1_A = mkA "religiös" ;
  remitterbar_av_1_A = mkA "remitterbar" ;
  remplacerbar_av_1_A = mkA "remplacerbar" ;
  ren_av_1_A = mkA "ren" ;
  renderbar_av_1_A = mkA "renderbar" ;
  renhaarig_av_1_1_A = mkA "renhårig" ;
  renlig_av_1_A = mkA "renlig" ;
  renlaerig_av_1_1_A = mkA "renlärig" ;
  renoverbar_av_1_A = mkA "renoverbar" ;
  renrasig_av_1_A = mkA "renrasig" ;
  reorganiserbar_av_1_A = mkA "reorganiserbar" ;
  reparerbar_av_1_A = mkA "reparerbar" ;
  repartiserbar_av_1_A = mkA "repartiserbar" ;
  repatrierbar_av_1_A = mkA "repatrierbar" ;
  repellerbar_av_1_A = mkA "repellerbar" ;
  repertoarmaessig_av_1_1_A = mkA "repertoarmässig" ;
  repeterbar_av_1_A = mkA "repeterbar" ;
  repig_av_1_A = mkA "repig" ;
  reportagemaessig_av_1_1_A = mkA "reportagemässig" ;
  representativ_av_1_A = mkA "representativ" ;
  representerbar_av_1_A = mkA "representerbar" ;
  repressiv_av_1_A = mkA "repressiv" ;
  repriserbar_av_1_A = mkA "repriserbar" ;
  reproducerbar_av_1_A = mkA "reproducerbar" ;
  republikansk_av_1_A = mkA "republikansk" ;
  repulsiv_av_1_A = mkA "repulsiv" ;
  reputerlig_av_1_A = mkA "reputerlig" ;
  reservationsloes_av_1_1_A = mkA "reservationslös" ;
  reserverbar_av_1_A = mkA "reserverbar" ;
  reslig_av_1_A = mkA "reslig" ;
  resolverbar_av_1_A = mkA "resolverbar" ;
  resonlig_av_1_A = mkA "resonlig" ;
  resorberbar_av_1_A = mkA "resorberbar" ;
  respekterbar_av_1_A = mkA "respekterbar" ;
  respektfull_av_1_A = mkA "respektfull" ;
  respektloes_av_1_1_A = mkA "respektlös" ;
  respiratorisk_av_1_A = mkA "respiratorisk" ;
  respirerbar_av_1_A = mkA "respirerbar" ;
  restaurerbar_av_1_A = mkA "restaurerbar" ;
  restituerbar_av_1_A = mkA "restituerbar" ;
  restloes_av_1_1_A = mkA "restlös" ;
  restriktiv_av_1_A = mkA "restriktiv" ;
  resultativ_av_1_A = mkA "resultativ" ;
  resultatloes_av_1_1_A = mkA "resultatlös" ;
  resultatmaessig_av_1_1_A = mkA "resultatmässig" ;
  resumerbar_av_1_A = mkA "resumerbar" ;
  resursmaessig_av_1_1_A = mkA "resursmässig" ;
  resvan_av_1_A = mkA "resvan" ;
  retablerbar_av_1_A = mkA "retablerbar" ;
  retarderbar_av_1_A = mkA "retarderbar" ;
  retfull_av_1_A = mkA "retfull" ;
  retlig_av_1_A = mkA "retlig" ;
  retorisk_av_1_A = mkA "retorisk" ;
  retroaktiv_av_1_A = mkA "retroaktiv" ;
  retrospektiv_av_1_A = mkA "retrospektiv" ;
  returnerbar_av_1_A = mkA "returnerbar" ;
  retuscherbar_av_1_A = mkA "retuscherbar" ;
  reumatisk_av_1_A = mkA "reumatisk" ;
  revalverbar_av_1_A = mkA "revalverbar" ;
  reveterbar_av_1_A = mkA "reveterbar" ;
  reviderbar_av_1_A = mkA "reviderbar" ;
  revolutionerbar_av_1_A = mkA "revolutionerbar" ;
  revolutionaer_av_1_1_A = mkA "revolutionär" ;
  rh_negativ_av_1_A = mkA "rh-negativ" ;
  rh_positiv_av_1_A = mkA "rh-positiv" ;
  rhensk_av_1_A = mkA "rhensk" ;
  rhodesisk_av_1_A = mkA "rhodesisk" ;
  rickig_av_1_A = mkA "rickig" ;
  ridderlig_av_1_A = mkA "ridderlig" ;
  ridkunnig_av_1_A = mkA "ridkunnig" ;
  rigoroes_av_1_1_A = mkA "rigorös" ;
  rik_av_1_A = mkA "rik" ;
  rikhaltig_av_1_A = mkA "rikhaltig" ;
  riklig_av_1_A = mkA "riklig" ;
  rikssvensk_av_1_A = mkA "rikssvensk" ;
  riksviktig_av_1_A = mkA "riksviktig" ;
  riktig_av_1_A = mkA "riktig" ;
  rimlig_av_1_A = mkA "rimlig" ;
  ringformig_av_1_A = mkA "ringformig" ;
  ringrostig_av_1_A = mkA "ringrostig" ;
  risig_av_1_A = mkA "risig" ;
  riskvillig_av_1_A = mkA "riskvillig" ;
  ritualiserbar_av_1_A = mkA "ritualiserbar" ;
  ritualmaessig_av_1_1_A = mkA "ritualmässig" ;
  rituell_av_1_A = mkA "rituell" ;
  rivig_av_1_A = mkA "rivig" ;
  robotiserbar_av_1_A = mkA "robotiserbar" ;
  rockerbar_av_1_A = mkA "rockerbar" ;
  rojalistisk_av_1_A = mkA "rojalistisk" ;
  rolig_av_1_A = mkA "rolig" ;
  roloes_av_1_1_A = mkA "rolös" ;
  romanesk_av_1_A = mkA "romanesk" ;
  romanistisk_av_1_A = mkA "romanistisk" ;
  romansk_av_1_A = mkA "romansk" ;
  romantiserbar_av_1_A = mkA "romantiserbar" ;
  romantisk_av_1_A = mkA "romantisk" ;
  rombisk_av_1_A = mkA "rombisk" ;
  romersk_katolsk_av_1_A = mkA "romersk-katolsk" ;
  romersk_av_1_A = mkA "romersk" ;
  rosig_av_1_A = mkA "rosig" ;
  rosslig_av_1_A = mkA "rosslig" ;
  rostig_av_1_A = mkA "rostig" ;
  rotloes_av_1_1_A = mkA "rotlös" ;
  rovgirig_av_1_A = mkA "rovgirig" ;
  rubricerbar_av_1_A = mkA "rubricerbar" ;
  rubrikmaessig_av_1_1_A = mkA "rubrikmässig" ;
  rucklig_av_1_A = mkA "rucklig" ;
  rudimentaer_av_1_1_A = mkA "rudimentär" ;
  ruffig_av_1_A = mkA "ruffig" ;
  rufsig_av_1_A = mkA "rufsig" ;
  ruggig_av_1_A = mkA "ruggig" ;
  ruinerbar_av_1_A = mkA "ruinerbar" ;
  rullbar_av_1_A = mkA "rullbar" ;
  rultig_av_1_A = mkA "rultig" ;
  rumslig_av_1_A = mkA "rumslig" ;
  rumaensk_fransk_av_1_1_A = mkA "rumänsk-fransk" ;
  rumaensk_av_1_1_A = mkA "rumänsk" ;
  rundkullig_av_1_A = mkA "rundkullig" ;
  rundlig_av_1_A = mkA "rundlig" ;
  rural_av_1_A = mkA "rural" ;
  ruschig_av_1_A = mkA "ruschig" ;
  rusig_av_1_A = mkA "rusig" ;
  ruskig_av_1_A = mkA "ruskig" ;
  russificerbar_av_1_A = mkA "russificerbar" ;
  russifierbar_av_1_A = mkA "russifierbar" ;
  rustik_av_1_A = mkA "rustik" ;
  rutig_av_1_A = mkA "rutig" ;
  rutinmaessig_av_1_1_A = mkA "rutinmässig" ;
  rwandisk_av_1_A = mkA "rwandisk" ;
  ryckig_av_1_A = mkA "ryckig" ;
  ryggmaergsmaessig_av_1_1_A = mkA "ryggmärgsmässig" ;
  ryggradsloes_av_1_1_A = mkA "ryggradslös" ;
  ryktbar_av_1_A = mkA "ryktbar" ;
  rymlig_av_1_A = mkA "rymlig" ;
  rynkig_av_1_A = mkA "rynkig" ;
  ryschig_av_1_A = mkA "ryschig" ;
  rysk_amerikansk_av_1_A = mkA "rysk-amerikansk" ;
  rysk_av_1_A = mkA "rysk" ;
  ryskvaenlig_av_1_1_A = mkA "ryskvänlig" ;
  ryslig_av_1_A = mkA "ryslig" ;
  rysslaendsk_av_1_1_A = mkA "ryssländsk" ;
  rytmiserbar_av_1_A = mkA "rytmiserbar" ;
  rytmisk_av_1_A = mkA "rytmisk" ;
  raeddningsloes_av_1_1_A = mkA "räddningslös" ;
  raelig_av_1_1_A = mkA "rälig" ;
  raenkfull_av_1_1_A = mkA "ränkfull" ;
  raetlinjig_av_1_1_A = mkA "rätlinjig" ;
  raettfaerdig_av_1_1_A = mkA "rättfärdig" ;
  raettmaetig_av_1_1_A = mkA "rättmätig" ;
  raettraadig_av_1_1_A = mkA "rättrådig" ;
  raettsenlig_av_1_1_A = mkA "rättsenlig" ;
  raettshaveristisk_av_1_1_A = mkA "rättshaveristisk" ;
  raettsinnig_av_1_1_A = mkA "rättsinnig" ;
  raettslig_av_1_1_A = mkA "rättslig" ;
  raettsloes_av_1_1_A = mkA "rättslös" ;
  raettsmedicinsk_av_1_1_A = mkA "rättsmedicinsk" ;
  raettspsykiatrisk_av_1_1_A = mkA "rättspsykiatrisk" ;
  raettsstridig_av_1_1_A = mkA "rättsstridig" ;
  raettsvidrig_av_1_1_A = mkA "rättsvidrig" ;
  raettvis_av_1_1_A = mkA "rättvis" ;
  raettvisemaessig_av_1_1_A = mkA "rättvisemässig" ;
  raetvinklig_av_1_1_A = mkA "rätvinklig" ;
  raaddig_av_1_1_A = mkA "råddig" ;
  raadig_av_1_1_A = mkA "rådig" ;
  raadlig_av_1_1_A = mkA "rådlig" ;
  raadloes_av_1_1_A = mkA "rådlös" ;
  raadsnar_av_1_1_A = mkA "rådsnar" ;
  raadvill_av_1_1_A = mkA "rådvill" ;
  raakall_av_1_1_A = mkA "råkall" ;
  raavarumaessig_av_1_1_A = mkA "råvarumässig" ;
  roedaktig_av_1_1_A = mkA "rödaktig" ;
  roedblommig_av_1_1_A = mkA "rödblommig" ;
  roedbrokig_av_1_1_A = mkA "rödbrokig" ;
  roedbrun_av_1_1_A = mkA "rödbrun" ;
  roedbrusig_av_1_1_A = mkA "rödbrusig" ;
  roedflammig_av_1_1_A = mkA "rödflammig" ;
  roedgroen_av_1_1_A = mkA "rödgrön" ;
  roedhaarig_av_1_1_A = mkA "rödhårig" ;
  roedmosig_av_1_1_A = mkA "rödmosig" ;
  roekig_av_1_1_A = mkA "rökig" ;
  roeksvag_av_1_1_A = mkA "röksvag" ;
  roentgenfotograferbar_av_1_1_A = mkA "röntgenfotograferbar" ;
  roerelsemaessig_av_1_1_A = mkA "rörelsemässig" ;
  roerig_av_1_1_A = mkA "rörig" ;
  roerlig_av_1_1_A = mkA "rörlig" ;
  roestmaessig_av_1_1_A = mkA "röstmässig" ;
  roeststark_av_1_1_A = mkA "röststark" ;
  saboterbar_av_1_A = mkA "saboterbar" ;
  sabrerbar_av_1_A = mkA "sabrerbar" ;
  sachsisk_av_1_A = mkA "sachsisk" ;
  sadelformig_av_1_A = mkA "sadelformig" ;
  sadistisk_av_1_A = mkA "sadistisk" ;
  sado_masochistisk_av_1_A = mkA "sado-masochistisk" ;
  saffransgul_av_1_A = mkA "saffransgul" ;
  saftfull_av_1_A = mkA "saftfull" ;
  saftig_av_1_A = mkA "saftig" ;
  saftloes_av_1_1_A = mkA "saftlös" ;
  sagolik_av_1_A = mkA "sagolik" ;
  sagomaessig_av_1_1_A = mkA "sagomässig" ;
  sakfoerstaandig_av_1_1_A = mkA "sakförståndig" ;
  sakkunnig_av_1_A = mkA "sakkunnig" ;
  saklig_av_1_A = mkA "saklig" ;
  sakloes_av_1_1_A = mkA "saklös" ;
  sakpolitisk_av_1_A = mkA "sakpolitisk" ;
  sakral_av_1_A = mkA "sakral" ;
  sakramental_av_1_A = mkA "sakramental" ;
  sakraettslig_av_1_1_A = mkA "sakrättslig" ;
  saktfaerdig_av_1_1_A = mkA "saktfärdig" ;
  saktmodig_av_1_A = mkA "saktmodig" ;
  salderbar_av_1_A = mkA "salderbar" ;
  salig_av_1_A = mkA "salig" ;
  salisk_av_1_A = mkA "salisk" ;
  salomonisk_av_1_A = mkA "salomonisk" ;
  salomonsk_av_1_A = mkA "salomonsk" ;
  salongsfaehig_av_1_1_A = mkA "salongsfähig" ;
  salongsmaessig_av_1_1_A = mkA "salongsmässig" ;
  salthaltig_av_1_A = mkA "salthaltig" ;
  saltig_av_1_A = mkA "saltig" ;
  saluterbar_av_1_A = mkA "saluterbar" ;
  salvadoransk_av_1_A = mkA "salvadoransk" ;
  salvelsefull_av_1_A = mkA "salvelsefull" ;
  samarbetsvillig_av_1_A = mkA "samarbetsvillig" ;
  sambladig_av_1_A = mkA "sambladig" ;
  samfundsmaessig_av_1_1_A = mkA "samfundsmässig" ;
  samfaellig_av_1_1_A = mkA "samfällig" ;
  samhaellelig_av_1_1_A = mkA "samhällelig" ;
  samhaellsekonomisk_av_1_1_A = mkA "samhällsekonomisk" ;
  samhaellsfarlig_av_1_1_A = mkA "samhällsfarlig" ;
  samhaellsfientlig_av_1_1_A = mkA "samhällsfientlig" ;
  samhaellskritisk_av_1_1_A = mkA "samhällskritisk" ;
  samhaellsmaessig_av_1_1_A = mkA "samhällsmässig" ;
  samhaellsnyttig_av_1_1_A = mkA "samhällsnyttig" ;
  samhaellssolidarisk_av_1_1_A = mkA "samhällssolidarisk" ;
  samhaellsvetenskaplig_av_1_1_A = mkA "samhällsvetenskaplig" ;
  samhoerig_av_1_1_A = mkA "samhörig" ;
  samisk_av_1_A = mkA "samisk" ;
  sammanhaallig_av_1_1_A = mkA "sammanhållig" ;
  sammetsmjuk_av_1_A = mkA "sammetsmjuk" ;
  samnordisk_av_1_A = mkA "samnordisk" ;
  samstaemmig_av_1_1_A = mkA "samstämmig" ;
  samtaxerbar_av_1_A = mkA "samtaxerbar" ;
  samtidig_av_1_A = mkA "samtidig" ;
  samvetsloes_av_1_1_A = mkA "samvetslös" ;
  sandbrun_av_1_A = mkA "sandbrun" ;
  sandig_av_1_A = mkA "sandig" ;
  sanerbar_av_1_A = mkA "sanerbar" ;
  sanforiserbar_av_1_A = mkA "sanforiserbar" ;
  sangvinisk_av_1_A = mkA "sangvinisk" ;
  sanitaer_av_1_1_A = mkA "sanitär" ;
  sank_av_1_A = mkA "sank" ;
  sanktifierbar_av_1_A = mkA "sanktifierbar" ;
  sanktionerbar_av_1_A = mkA "sanktionerbar" ;
  sanmarinesisk_av_1_A = mkA "sanmarinesisk" ;
  sanmarinsk_av_1_A = mkA "sanmarinsk" ;
  sannfaerdig_av_1_1_A = mkA "sannfärdig" ;
  sanningsenlig_av_1_A = mkA "sanningsenlig" ;
  sanningsloes_av_1_1_A = mkA "sanningslös" ;
  sannolik_av_1_A = mkA "sannolik" ;
  sannskyldig_av_1_A = mkA "sannskyldig" ;
  sansloes_av_1_1_A = mkA "sanslös" ;
  saotomeansk_av_1_A = mkA "saotomeansk" ;
  sapfisk_av_1_A = mkA "sapfisk" ;
  saponifierbar_av_1_A = mkA "saponifierbar" ;
  sardinisk_av_1_A = mkA "sardinisk" ;
  sardinsk_av_1_A = mkA "sardinsk" ;
  sardisk_av_1_A = mkA "sardisk" ;
  sardonisk_av_1_A = mkA "sardonisk" ;
  sarkastisk_av_1_A = mkA "sarkastisk" ;
  satanisk_av_1_A = mkA "satanisk" ;
  satinerbar_av_1_A = mkA "satinerbar" ;
  satirisk_av_1_A = mkA "satirisk" ;
  satisfierbar_av_1_A = mkA "satisfierbar" ;
  saturerbar_av_1_A = mkA "saturerbar" ;
  saturnalisk_av_1_A = mkA "saturnalisk" ;
  saturnisk_av_1_A = mkA "saturnisk" ;
  satyrisk_av_1_A = mkA "satyrisk" ;
  saudiarabisk_av_1_A = mkA "saudiarabisk" ;
  saudisk_av_1_A = mkA "saudisk" ;
  sauterbar_av_1_A = mkA "sauterbar" ;
  sauverbar_av_1_A = mkA "sauverbar" ;
  savig_av_1_A = mkA "savig" ;
  saxformig_av_1_A = mkA "saxformig" ;
  saxisk_av_1_A = mkA "saxisk" ;
  scenisk_av_1_A = mkA "scenisk" ;
  schablonerbar_av_1_A = mkA "schablonerbar" ;
  schabloniserbar_av_1_A = mkA "schabloniserbar" ;
  schablonmaessig_av_1_1_A = mkA "schablonmässig" ;
  schablontaxerbar_av_1_A = mkA "schablontaxerbar" ;
  schamponerbar_av_1_A = mkA "schamponerbar" ;
  schangtil_av_1_A = mkA "schangtil" ;
  schartauansk_av_1_A = mkA "schartauansk" ;
  schatterbar_av_1_A = mkA "schatterbar" ;
  schemamaessig_av_1_1_A = mkA "schemamässig" ;
  schematiserbar_av_1_A = mkA "schematiserbar" ;
  schematisk_av_1_A = mkA "schematisk" ;
  schismatisk_av_1_A = mkA "schismatisk" ;
  schizotym_av_1_A = mkA "schizotym" ;
  schizzig_av_1_A = mkA "schizzig" ;
  schvungfull_av_1_A = mkA "schvungfull" ;
  schvungig_av_1_A = mkA "schvungig" ;
  schweizisk_av_1_A = mkA "schweizisk" ;
  schwungfull_av_1_A = mkA "schwungfull" ;
  schwungig_av_1_A = mkA "schwungig" ;
  scoutmaessig_av_1_1_A = mkA "scoutmässig" ;
  sebar_av_1_A = mkA "sebar" ;
  sedativ_av_1_A = mkA "sedativ" ;
  sedesloes_av_1_1_A = mkA "sedeslös" ;
  sedig_av_1_A = mkA "sedig" ;
  sedimenterbar_av_1_A = mkA "sedimenterbar" ;
  sedimentaer_av_1_1_A = mkA "sedimentär" ;
  sedlig_av_1_A = mkA "sedlig" ;
  sedvanlig_av_1_A = mkA "sedvanlig" ;
  seg_av_1_A = mkA "seg" ;
  segelbar_av_1_A = mkA "segelbar" ;
  segerrik_av_1_A = mkA "segerrik" ;
  segerrusig_av_1_A = mkA "segerrusig" ;
  segersaell_av_1_1_A = mkA "segersäll" ;
  segerviss_av_1_A = mkA "segerviss" ;
  seglationsklar_av_1_A = mkA "seglationsklar" ;
  segmentell_av_1_A = mkA "segmentell" ;
  segmenterbar_av_1_A = mkA "segmenterbar" ;
  segregerbar_av_1_A = mkA "segregerbar" ;
  seismisk_av_1_A = mkA "seismisk" ;
  sekellaang_av_1_1_A = mkA "sekellång" ;
  sekonderbar_av_1_A = mkA "sekonderbar" ;
  sekretorisk_av_1_A = mkA "sekretorisk" ;
  sekteristisk_av_1_A = mkA "sekteristisk" ;
  sektoriell_av_1_A = mkA "sektoriell" ;
  sekulariserbar_av_1_A = mkA "sekulariserbar" ;
  sekulaer_av_1_1_A = mkA "sekulär" ;
  sekunderbar_av_1_A = mkA "sekunderbar" ;
  sekundaer_av_1_1_A = mkA "sekundär" ;
  sekvestrerbar_av_1_A = mkA "sekvestrerbar" ;
  selekterbar_av_1_A = mkA "selekterbar" ;
  selektiv_av_1_A = mkA "selektiv" ;
  semaforerbar_av_1_A = mkA "semaforerbar" ;
  semantisk_av_1_A = mkA "semantisk" ;
  seminerbar_av_1_A = mkA "seminerbar" ;
  semiotisk_av_1_A = mkA "semiotisk" ;
  semitisk_av_1_A = mkA "semitisk" ;
  semologisk_av_1_A = mkA "semologisk" ;
  sen_av_1_A = mkA "sen" ;
  senantik_av_1_A = mkA "senantik" ;
  senegalesisk_av_1_A = mkA "senegalesisk" ;
  senfaerdig_av_1_1_A = mkA "senfärdig" ;
  sengaangaraktig_av_1_1_A = mkA "sengångaraktig" ;
  senig_av_1_A = mkA "senig" ;
  senil_av_1_A = mkA "senil" ;
  senildement_av_1_A = mkA "senildement" ;
  senior_av_1_A = mkA "senior" ;
  senromersk_av_1_A = mkA "senromersk" ;
  sensationell_av_1_A = mkA "sensationell" ;
  sensibiliserbar_av_1_A = mkA "sensibiliserbar" ;
  sensitiv_av_1_A = mkA "sensitiv" ;
  sensomotorisk_av_1_A = mkA "sensomotorisk" ;
  sensorisk_av_1_A = mkA "sensorisk" ;
  sensuell_av_1_A = mkA "sensuell" ;
  sentensioes_av_1_1_A = mkA "sentensiös" ;
  sententioes_av_1_1_A = mkA "sententiös" ;
  senterbar_av_1_A = mkA "senterbar" ;
  sentimental_av_1_A = mkA "sentimental" ;
  separatistisk_av_1_A = mkA "separatistisk" ;
  separerbar_av_1_A = mkA "separerbar" ;
  septisk_av_1_A = mkA "septisk" ;
  serafisk_av_1_A = mkA "serafisk" ;
  serbisk_av_1_A = mkA "serbisk" ;
  serbokroatisk_av_1_A = mkA "serbokroatisk" ;
  seriell_av_1_A = mkA "seriell" ;
  seriemaessig_av_1_1_A = mkA "seriemässig" ;
  serioes_av_1_1_A = mkA "seriös" ;
  serverbar_av_1_A = mkA "serverbar" ;
  servicemaessig_av_1_1_A = mkA "servicemässig" ;
  servil_av_1_A = mkA "servil" ;
  seroes_av_1_1_A = mkA "serös" ;
  sexig_av_1_A = mkA "sexig" ;
  sexkantig_av_1_A = mkA "sexkantig" ;
  sexpipig_av_1_A = mkA "sexpipig" ;
  sexradig_av_1_A = mkA "sexradig" ;
  sexsiffrig_av_1_A = mkA "sexsiffrig" ;
  sexualiserbar_av_1_A = mkA "sexualiserbar" ;
  sexuell_av_1_A = mkA "sexuell" ;
  seychellisk_av_1_A = mkA "seychellisk" ;
  sfaerisk_av_1_1_A = mkA "sfärisk" ;
  shamponerbar_av_1_A = mkA "shamponerbar" ;
  shetlaendsk_av_1_1_A = mkA "shetländsk" ;
  showmaessig_av_1_1_A = mkA "showmässig" ;
  siamesisk_av_1_A = mkA "siamesisk" ;
  sibirisk_av_1_A = mkA "sibirisk" ;
  sibyllinsk_av_1_A = mkA "sibyllinsk" ;
  siciliansk_av_1_A = mkA "siciliansk" ;
  sidenvit_av_1_A = mkA "sidenvit" ;
  siderisk_av_1_A = mkA "siderisk" ;
  sidnumrerbar_av_1_A = mkA "sidnumrerbar" ;
  sierraleonsk_av_1_A = mkA "sierraleonsk" ;
  siffermaessig_av_1_1_A = mkA "siffermässig" ;
  sigillerbar_av_1_A = mkA "sigillerbar" ;
  signalerbar_av_1_A = mkA "signalerbar" ;
  signaturmaessig_av_1_1_A = mkA "signaturmässig" ;
  signerbar_av_1_A = mkA "signerbar" ;
  signifikativ_av_1_A = mkA "signifikativ" ;
  siktbar_av_1_A = mkA "siktbar" ;
  siktig_av_1_A = mkA "siktig" ;
  silhuetterbar_av_1_A = mkA "silhuetterbar" ;
  silkig_av_1_A = mkA "silkig" ;
  siluetterbar_av_1_A = mkA "siluetterbar" ;
  silverhaltig_av_1_A = mkA "silverhaltig" ;
  silverklar_av_1_A = mkA "silverklar" ;
  silvrig_av_1_A = mkA "silvrig" ;
  simkunnig_av_1_A = mkA "simkunnig" ;
  simmig_av_1_A = mkA "simmig" ;
  simplifierbar_av_1_A = mkA "simplifierbar" ;
  simulerbar_av_1_A = mkA "simulerbar" ;
  simultan_av_1_A = mkA "simultan" ;
  singalesisk_av_1_A = mkA "singalesisk" ;
  singular_av_1_A = mkA "singular" ;
  singuljaer_av_1_1_A = mkA "singuljär" ;
  singulaer_av_1_1_A = mkA "singulär" ;
  sinnebildlig_av_1_A = mkA "sinnebildlig" ;
  sinnessjuk_av_1_A = mkA "sinnessjuk" ;
  sinnessvag_av_1_A = mkA "sinnessvag" ;
  sinnlig_av_1_A = mkA "sinnlig" ;
  sinnrik_av_1_A = mkA "sinnrik" ;
  sipp_av_1_A = mkA "sipp" ;
  sirapssoet_av_1_1_A = mkA "sirapssöt" ;
  siratlig_av_1_A = mkA "siratlig" ;
  sirlig_av_1_A = mkA "sirlig" ;
  sittriktig_av_1_A = mkA "sittriktig" ;
  sittvaenlig_av_1_1_A = mkA "sittvänlig" ;
  sjabbig_av_1_A = mkA "sjabbig" ;
  sjangtil_av_1_A = mkA "sjangtil" ;
  sjaskig_av_1_A = mkA "sjaskig" ;
  sjavig_av_1_A = mkA "sjavig" ;
  sjudimensionell_av_1_A = mkA "sjudimensionell" ;
  sjuk_av_1_A = mkA "sjuk" ;
  sjukledig_av_1_A = mkA "sjukledig" ;
  sjuklig_av_1_A = mkA "sjuklig" ;
  sjukvaardsmaessig_av_1_1_A = mkA "sjukvårdsmässig" ;
  sjaelavaardsmaessig_av_1_1_A = mkA "själavårdsmässig" ;
  sjaelfull_av_1_1_A = mkA "själfull" ;
  sjaelisk_av_1_1_A = mkA "själisk" ;
  sjaelloes_av_1_1_A = mkA "själlös" ;
  sjaelslig_av_1_1_A = mkA "själslig" ;
  sjaelssjuk_av_1_1_A = mkA "själssjuk" ;
  sjaelvbiografisk_av_1_1_A = mkA "självbiografisk" ;
  sjaelvfinansierbar_av_1_1_A = mkA "självfinansierbar" ;
  sjaelvhaerlig_av_1_1_A = mkA "självhärlig" ;
  sjaelvironisk_av_1_1_A = mkA "självironisk" ;
  sjaelvisk_av_1_1_A = mkA "självisk" ;
  sjaelvklar_av_1_1_A = mkA "självklar" ;
  sjaelvkritisk_av_1_1_A = mkA "självkritisk" ;
  sjaelvmordsmaessig_av_1_1_A = mkA "självmordsmässig" ;
  sjaelvraettfaerdig_av_1_1_A = mkA "självrättfärdig" ;
  sjaelvraadig_av_1_1_A = mkA "självrådig" ;
  sjaelvstaendig_av_1_1_A = mkA "självständig" ;
  sjaelvsvaaldig_av_1_1_A = mkA "självsvåldig" ;
  sjaelvtillraecklig_av_1_1_A = mkA "självtillräcklig" ;
  sjaapig_av_1_1_A = mkA "sjåpig" ;
  sjoebloet_av_1_1_A = mkA "sjöblöt" ;
  sjoeduglig_av_1_1_A = mkA "sjöduglig" ;
  sjoemansmaessig_av_1_1_A = mkA "sjömansmässig" ;
  sjoesjuk_av_1_1_A = mkA "sjösjuk" ;
  sjoesaekerhetsmaessig_av_1_1_A = mkA "sjösäkerhetsmässig" ;
  sjoevaerdig_av_1_1_A = mkA "sjövärdig" ;
  skabbig_av_1_A = mkA "skabbig" ;
  skabroes_av_1_1_A = mkA "skabrös" ;
  skadereglerbar_av_1_A = mkA "skadereglerbar" ;
  skadesloes_av_1_1_A = mkA "skadeslös" ;
  skadlig_av_1_A = mkA "skadlig" ;
  skakig_av_1_A = mkA "skakig" ;
  skaktaalig_av_1_1_A = mkA "skaktålig" ;
  skaldisk_av_1_A = mkA "skaldisk" ;
  skalenlig_av_1_A = mkA "skalenlig" ;
  skalkaktig_av_1_A = mkA "skalkaktig" ;
  skallig_av_1_A = mkA "skallig" ;
  skalloes_av_1_1_A = mkA "skallös" ;
  skalperbar_av_1_A = mkA "skalperbar" ;
  skalaer_av_1_1_A = mkA "skalär" ;
  skamlig_av_1_A = mkA "skamlig" ;
  skamloes_av_1_1_A = mkA "skamlös" ;
  skandaliserbar_av_1_A = mkA "skandaliserbar" ;
  skandaloes_av_1_1_A = mkA "skandalös" ;
  skanderbar_av_1_A = mkA "skanderbar" ;
  skandinavisk_av_1_A = mkA "skandinavisk" ;
  skaplig_av_1_A = mkA "skaplig" ;
  skarp_av_1_A = mkA "skarp" ;
  skarpsinnig_av_1_A = mkA "skarpsinnig" ;
  skattemaessig_av_1_1_A = mkA "skattemässig" ;
  skatteplanerbar_av_1_A = mkA "skatteplanerbar" ;
  skattepliktig_av_1_A = mkA "skattepliktig" ;
  skattskyldig_av_1_A = mkA "skattskyldig" ;
  skenbar_av_1_A = mkA "skenbar" ;
  skenhelig_av_1_A = mkA "skenhelig" ;
  skeptisk_av_1_A = mkA "skeptisk" ;
  skev_av_1_A = mkA "skev" ;
  skicklig_av_1_A = mkA "skicklig" ;
  skiffrig_av_1_A = mkA "skiffrig" ;
  skiljaktig_av_1_A = mkA "skiljaktig" ;
  skiljbar_av_1_A = mkA "skiljbar" ;
  skinntorr_av_1_A = mkA "skinntorr" ;
  skir_av_1_A = mkA "skir" ;
  skisserbar_av_1_A = mkA "skisserbar" ;
  skitbesvaerlig_av_1_1_A = mkA "skitbesvärlig" ;
  skitdaalig_av_1_1_A = mkA "skitdålig" ;
  skitfoernaem_av_1_1_A = mkA "skitförnäm" ;
  skitig_av_1_A = mkA "skitig" ;
  skitnoedig_av_1_1_A = mkA "skitnödig" ;
  skitsnygg_av_1_A = mkA "skitsnygg" ;
  skittraakig_av_1_1_A = mkA "skittråkig" ;
  skitviktig_av_1_A = mkA "skitviktig" ;
  skivig_av_1_A = mkA "skivig" ;
  skjutfaerdig_av_1_1_A = mkA "skjutfärdig" ;
  skjutklar_av_1_A = mkA "skjutklar" ;
  sklerotisk_av_1_A = mkA "sklerotisk" ;
  skogfattig_av_1_A = mkA "skogfattig" ;
  skogig_av_1_A = mkA "skogig" ;
  skoglig_av_1_A = mkA "skoglig" ;
  skogloes_av_1_1_A = mkA "skoglös" ;
  skogrik_av_1_A = mkA "skogrik" ;
  skogsgenetisk_av_1_A = mkA "skogsgenetisk" ;
  skojfrisk_av_1_A = mkA "skojfrisk" ;
  skojig_av_1_A = mkA "skojig" ;
  skolastisk_av_1_A = mkA "skolastisk" ;
  skolboksmaessig_av_1_1_A = mkA "skolboksmässig" ;
  skolmaessig_av_1_1_A = mkA "skolmässig" ;
  skolmaestaraktig_av_1_1_A = mkA "skolmästaraktig" ;
  skolsjuk_av_1_A = mkA "skolsjuk" ;
  skoningsloes_av_1_1_A = mkA "skoningslös" ;
  skopofil_av_1_A = mkA "skopofil" ;
  skorvig_av_1_A = mkA "skorvig" ;
  skotsk_av_1_A = mkA "skotsk" ;
  skotskrutig_av_1_A = mkA "skotskrutig" ;
  skottfri_av_1_A = mkA "skottfri" ;
  skrabbig_av_1_A = mkA "skrabbig" ;
  skrafferbar_av_1_A = mkA "skrafferbar" ;
  skraj_av_1_A = mkA "skraj" ;
  skral_av_1_A = mkA "skral" ;
  skraltig_av_1_A = mkA "skraltig" ;
  skramlig_av_1_A = mkA "skramlig" ;
  skranglig_av_1_A = mkA "skranglig" ;
  skriftlig_av_1_A = mkA "skriftlig" ;
  skriftspraaklig_av_1_1_A = mkA "skriftspråklig" ;
  skrikig_av_1_A = mkA "skrikig" ;
  skrivkunnig_av_1_A = mkA "skrivkunnig" ;
  skrockfull_av_1_A = mkA "skrockfull" ;
  skrofuloes_av_1_1_A = mkA "skrofulös" ;
  skrovlig_av_1_A = mkA "skrovlig" ;
  skrupelloes_av_1_1_A = mkA "skrupellös" ;
  skrupuloes_av_1_1_A = mkA "skrupulös" ;
  skruttig_av_1_A = mkA "skruttig" ;
  skrynkelhaerdig_av_1_1_A = mkA "skrynkelhärdig" ;
  skrynklig_av_1_A = mkA "skrynklig" ;
  skraellig_av_1_1_A = mkA "skrällig" ;
  skraenig_av_1_1_A = mkA "skränig" ;
  skraepig_av_1_1_A = mkA "skräpig" ;
  skraevlig_av_1_1_A = mkA "skrävlig" ;
  skraamaessig_av_1_1_A = mkA "skråmässig" ;
  skroeplig_av_1_1_A = mkA "skröplig" ;
  skuggig_av_1_A = mkA "skuggig" ;
  skuldloes_av_1_1_A = mkA "skuldlös" ;
  skulpterbar_av_1_A = mkA "skulpterbar" ;
  skulptural_av_1_A = mkA "skulptural" ;
  skulpturerbar_av_1_A = mkA "skulpturerbar" ;
  skummig_av_1_A = mkA "skummig" ;
  skumpig_av_1_A = mkA "skumpig" ;
  skunkig_av_1_A = mkA "skunkig" ;
  skurkaktig_av_1_A = mkA "skurkaktig" ;
  skurril_av_1_A = mkA "skurril" ;
  skvalleraktig_av_1_A = mkA "skvalleraktig" ;
  skvallrig_av_1_A = mkA "skvallrig" ;
  skvalpig_av_1_A = mkA "skvalpig" ;
  skyddsimpregnerbar_av_1_A = mkA "skyddsimpregnerbar" ;
  skyddsloes_av_1_1_A = mkA "skyddslös" ;
  skygg_av_1_A = mkA "skygg" ;
  skyhoeg_av_1_1_A = mkA "skyhög" ;
  skyig_av_1_A = mkA "skyig" ;
  skyldig_av_1_A = mkA "skyldig" ;
  skymflig_av_1_A = mkA "skymflig" ;
  skaeckig_av_1_1_A = mkA "skäckig" ;
  skaeggig_av_1_1_A = mkA "skäggig" ;
  skaeggloes_av_1_1_A = mkA "skägglös" ;
  skaelig_av_1_1_A = mkA "skälig" ;
  skaell_av_1_1_A = mkA "skäll" ;
  skaellig_av_1_1_A = mkA "skällig" ;
  skaelmaktig_av_1_1_A = mkA "skälmaktig" ;
  skaelmsk_av_1_1_A = mkA "skälmsk" ;
  skaemmig_av_1_1_A = mkA "skämmig" ;
  skaendlig_av_1_1_A = mkA "skändlig" ;
  skaer_av_1_1_A = mkA "skär" ;
  skaevig_av_1_1_A = mkA "skävig" ;
  skaadespelarmaessig_av_1_1_A = mkA "skådespelarmässig" ;
  skaalformig_av_1_1_A = mkA "skålformig" ;
  skaalig_av_1_1_A = mkA "skålig" ;
  skaallhet_av_1_1_A = mkA "skållhet" ;
  skaansk_av_1_1_A = mkA "skånsk" ;
  skoen_av_1_1_A = mkA "skön" ;
  skoenjbar_av_1_1_A = mkA "skönjbar" ;
  skoenlitteraer_av_1_1_A = mkA "skönlitterär" ;
  skoenlockig_av_1_1_A = mkA "skönlockig" ;
  skoensmaessig_av_1_1_A = mkA "skönsmässig" ;
  skoenstaxerbar_av_1_1_A = mkA "skönstaxerbar" ;
  skoentaxerbar_av_1_1_A = mkA "sköntaxerbar" ;
  skoer_av_1_1_A = mkA "skör" ;
  slabb_av_1_A = mkA "slabb" ;
  slabbig_av_1_A = mkA "slabbig" ;
  slack_av_1_A = mkA "slack" ;
  sladdig_av_1_A = mkA "sladdig" ;
  sladdrig_av_1_A = mkA "sladdrig" ;
  slafsig_av_1_A = mkA "slafsig" ;
  slagfaerdig_av_1_1_A = mkA "slagfärdig" ;
  slaggig_av_1_A = mkA "slaggig" ;
  slagkraftig_av_1_A = mkA "slagkraftig" ;
  slagordsmaessig_av_1_1_A = mkA "slagordsmässig" ;
  slagtaalig_av_1_1_A = mkA "slagtålig" ;
  slak_av_1_A = mkA "slak" ;
  slammig_av_1_A = mkA "slammig" ;
  slampig_av_1_A = mkA "slampig" ;
  slamsig_av_1_A = mkA "slamsig" ;
  slangloes_av_1_1_A = mkA "slanglös" ;
  slank_av_1_A = mkA "slank" ;
  slankig_av_1_A = mkA "slankig" ;
  slapp_av_1_A = mkA "slapp" ;
  slarvig_av_1_A = mkA "slarvig" ;
  slaskig_av_1_A = mkA "slaskig" ;
  slattrig_av_1_A = mkA "slattrig" ;
  slaviserbar_av_1_A = mkA "slaviserbar" ;
  slavisk_av_1_A = mkA "slavisk" ;
  slavofil_av_1_A = mkA "slavofil" ;
  slemmig_av_1_A = mkA "slemmig" ;
  slentrianmaessig_av_1_1_A = mkA "slentrianmässig" ;
  slibbig_av_1_A = mkA "slibbig" ;
  sliddrig_av_1_A = mkA "sliddrig" ;
  slingrig_av_1_A = mkA "slingrig" ;
  slinkig_av_1_A = mkA "slinkig" ;
  slipprig_av_1_A = mkA "slipprig" ;
  slirig_av_1_A = mkA "slirig" ;
  sliskig_av_1_A = mkA "sliskig" ;
  slitig_av_1_A = mkA "slitig" ;
  slitstark_av_1_A = mkA "slitstark" ;
  slittaalig_av_1_1_A = mkA "slittålig" ;
  slokig_av_1_A = mkA "slokig" ;
  slovakisk_av_1_A = mkA "slovakisk" ;
  slovensk_av_1_A = mkA "slovensk" ;
  sluddrig_av_1_A = mkA "sluddrig" ;
  slug_av_1_A = mkA "slug" ;
  sluggermaessig_av_1_1_A = mkA "sluggermässig" ;
  slumpmaessig_av_1_1_A = mkA "slumpmässig" ;
  sluskig_av_1_A = mkA "sluskig" ;
  slutgiltig_av_1_A = mkA "slutgiltig" ;
  slutlig_av_1_A = mkA "slutlig" ;
  slynig_av_1_A = mkA "slynig" ;
  slaektmaessig_av_1_1_A = mkA "släktmässig" ;
  slaengig_av_1_1_A = mkA "slängig" ;
  slaepig_av_1_1_A = mkA "släpig" ;
  slaet_av_1_1_A = mkA "slät" ;
  slaethaarig_av_1_1_A = mkA "släthårig" ;
  sloejig_av_1_1_A = mkA "slöjig" ;
  sloesaktig_av_1_1_A = mkA "slösaktig" ;
  sloesig_av_1_1_A = mkA "slösig" ;
  smakfull_av_1_A = mkA "smakfull" ;
  smaklig_av_1_A = mkA "smaklig" ;
  smakloes_av_1_1_A = mkA "smaklös" ;
  smakmaessig_av_1_1_A = mkA "smakmässig" ;
  smakstark_av_1_A = mkA "smakstark" ;
  smal_av_1_A = mkA "smal" ;
  smalspaarig_av_1_1_A = mkA "smalspårig" ;
  smaragdgroen_av_1_1_A = mkA "smaragdgrön" ;
  smarrig_av_1_A = mkA "smarrig" ;
  smaskig_av_1_A = mkA "smaskig" ;
  smekfull_av_1_A = mkA "smekfull" ;
  smetig_av_1_A = mkA "smetig" ;
  smidbar_av_1_A = mkA "smidbar" ;
  smidig_av_1_A = mkA "smidig" ;
  smilig_av_1_A = mkA "smilig" ;
  smilsk_av_1_A = mkA "smilsk" ;
  smockfull_av_1_A = mkA "smockfull" ;
  smul_av_1_A = mkA "smul" ;
  smulig_av_1_A = mkA "smulig" ;
  smutsig_av_1_A = mkA "smutsig" ;
  smaeckfet_av_1_1_A = mkA "smäckfet" ;
  smaeckfull_av_1_1_A = mkA "smäckfull" ;
  smaeckig_av_1_1_A = mkA "smäckig" ;
  smaedlig_av_1_1_A = mkA "smädlig" ;
  smaellfet_av_1_1_A = mkA "smällfet" ;
  smaellkall_av_1_1_A = mkA "smällkall" ;
  smaaaktig_av_1_1_A = mkA "småaktig" ;
  smaabarnsaktig_av_1_1_A = mkA "småbarnsaktig" ;
  smaabladig_av_1_1_A = mkA "småbladig" ;
  smaablommig_av_1_1_A = mkA "småblommig" ;
  smaablaasig_av_1_1_A = mkA "småblåsig" ;
  smaaborgerlig_av_1_1_A = mkA "småborgerlig" ;
  smaaelak_av_1_1_A = mkA "småelak" ;
  smaagnabbig_av_1_1_A = mkA "smågnabbig" ;
  smaalaendsk_av_1_1_A = mkA "småländsk" ;
  smaapipig_av_1_1_A = mkA "småpipig" ;
  smaarolig_av_1_1_A = mkA "smårolig" ;
  smaarutig_av_1_1_A = mkA "smårutig" ;
  smaaskalig_av_1_1_A = mkA "småskalig" ;
  smaatrevlig_av_1_1_A = mkA "småtrevlig" ;
  smaattig_av_1_1_A = mkA "småttig" ;
  smaaviktig_av_1_1_A = mkA "småviktig" ;
  smoerig_av_1_1_A = mkA "smörig" ;
  smoerjig_av_1_1_A = mkA "smörjig" ;
  snabb_av_1_A = mkA "snabb" ;
  snabbloeslig_av_1_1_A = mkA "snabblöslig" ;
  snackesalig_av_1_A = mkA "snackesalig" ;
  snacksalig_av_1_A = mkA "snacksalig" ;
  snar_av_1_A = mkA "snar" ;
  snarfyndig_av_1_A = mkA "snarfyndig" ;
  snarfaerdig_av_1_1_A = mkA "snarfärdig" ;
  snarlig_av_1_A = mkA "snarlig" ;
  snarlik_av_1_A = mkA "snarlik" ;
  snaskig_av_1_A = mkA "snaskig" ;
  snedhoernig_av_1_1_A = mkA "snedhörnig" ;
  snedig_av_1_A = mkA "snedig" ;
  snedparkerbar_av_1_A = mkA "snedparkerbar" ;
  snedrekryterbar_av_1_A = mkA "snedrekryterbar" ;
  snedvinklig_av_1_A = mkA "snedvinklig" ;
  snibbig_av_1_A = mkA "snibbig" ;
  snillrik_av_1_A = mkA "snillrik" ;
  snipig_av_1_A = mkA "snipig" ;
  snirklig_av_1_A = mkA "snirklig" ;
  snitsig_av_1_A = mkA "snitsig" ;
  snobbig_av_1_A = mkA "snobbig" ;
  snobbistisk_av_1_A = mkA "snobbistisk" ;
  snofsig_av_1_A = mkA "snofsig" ;
  snorig_av_1_A = mkA "snorig" ;
  snorkig_av_1_A = mkA "snorkig" ;
  snubblig_av_1_A = mkA "snubblig" ;
  snudig_av_1_A = mkA "snudig" ;
  snurrig_av_1_A = mkA "snurrig" ;
  snusbrun_av_1_A = mkA "snusbrun" ;
  snusfoernuftig_av_1_1_A = mkA "snusförnuftig" ;
  snusig_av_1_A = mkA "snusig" ;
  snuskig_av_1_A = mkA "snuskig" ;
  snustorr_av_1_A = mkA "snustorr" ;
  snuvig_av_1_A = mkA "snuvig" ;
  snygg_av_1_A = mkA "snygg" ;
  snaell_av_1_1_A = mkA "snäll" ;
  snaerjig_av_1_1_A = mkA "snärjig" ;
  snaertig_av_1_1_A = mkA "snärtig" ;
  snaesig_av_1_1_A = mkA "snäsig" ;
  snaev_av_1_1_A = mkA "snäv" ;
  snaal_av_1_1_A = mkA "snål" ;
  snaarig_av_1_1_A = mkA "snårig" ;
  snoefattig_av_1_1_A = mkA "snöfattig" ;
  snoehal_av_1_1_A = mkA "snöhal" ;
  snoeig_av_1_1_A = mkA "snöig" ;
  snoeplig_av_1_1_A = mkA "snöplig" ;
  snoerik_av_1_1_A = mkA "snörik" ;
  snoerpig_av_1_1_A = mkA "snörpig" ;
  snoerraet_av_1_1_A = mkA "snörrät" ;
  snoervlig_av_1_1_A = mkA "snörvlig" ;
  snoevit_av_1_1_A = mkA "snövit" ;
  social_av_1_A = mkA "social" ;
  socialantropologisk_av_1_A = mkA "socialantropologisk" ;
  socialdemokratisk_av_1_A = mkA "socialdemokratisk" ;
  socialfascistisk_av_1_A = mkA "socialfascistisk" ;
  socialiserbar_av_1_A = mkA "socialiserbar" ;
  socialistisk_av_1_A = mkA "socialistisk" ;
  socialliberal_av_1_A = mkA "socialliberal" ;
  socialpolitisk_av_1_A = mkA "socialpolitisk" ;
  socioekonomisk_av_1_A = mkA "socioekonomisk" ;
  sociologisk_av_1_A = mkA "sociologisk" ;
  sockerhaltig_av_1_A = mkA "sockerhaltig" ;
  sockermaessig_av_1_1_A = mkA "sockermässig" ;
  sockerrik_av_1_A = mkA "sockerrik" ;
  sockersjuk_av_1_A = mkA "sockersjuk" ;
  sockersoet_av_1_1_A = mkA "sockersöt" ;
  sockrig_av_1_A = mkA "sockrig" ;
  sodahaltig_av_1_A = mkA "sodahaltig" ;
  sokratisk_av_1_A = mkA "sokratisk" ;
  solar_av_1_A = mkA "solar" ;
  solarisk_av_1_A = mkA "solarisk" ;
  soldatmaessig_av_1_1_A = mkA "soldatmässig" ;
  solfattig_av_1_A = mkA "solfattig" ;
  solgul_av_1_A = mkA "solgul" ;
  solidarisk_av_1_A = mkA "solidarisk" ;
  solig_av_1_A = mkA "solig" ;
  solistisk_av_1_A = mkA "solistisk" ;
  solitaer_av_1_1_A = mkA "solitär" ;
  solkig_av_1_A = mkA "solkig" ;
  solklar_av_1_A = mkA "solklar" ;
  solljus_av_1_A = mkA "solljus" ;
  solloes_av_1_1_A = mkA "sollös" ;
  solvarm_av_1_A = mkA "solvarm" ;
  solverbar_av_1_A = mkA "solverbar" ;
  solaer_av_1_1_A = mkA "solär" ;
  somalisk_av_1_A = mkA "somalisk" ;
  somatisk_av_1_A = mkA "somatisk" ;
  sommaraktig_av_1_A = mkA "sommaraktig" ;
  sommarlig_av_1_A = mkA "sommarlig" ;
  sommarsvettig_av_1_A = mkA "sommarsvettig" ;
  somnambul_av_1_A = mkA "somnambul" ;
  somnambulisk_av_1_A = mkA "somnambulisk" ;
  somrig_av_1_A = mkA "somrig" ;
  sonantisk_av_1_A = mkA "sonantisk" ;
  sonderbar_av_1_A = mkA "sonderbar" ;
  sonisk_av_1_A = mkA "sonisk" ;
  sonlig_av_1_A = mkA "sonlig" ;
  sonor_av_1_A = mkA "sonor" ;
  soppig_av_1_A = mkA "soppig" ;
  sordinerbar_av_1_A = mkA "sordinerbar" ;
  sorgfull_av_1_A = mkA "sorgfull" ;
  sorgfaellig_av_1_1_A = mkA "sorgfällig" ;
  sorglig_av_1_A = mkA "sorglig" ;
  sorglustig_av_1_A = mkA "sorglustig" ;
  sorgloes_av_1_1_A = mkA "sorglös" ;
  sorgmodig_av_1_A = mkA "sorgmodig" ;
  sorterbar_av_1_A = mkA "sorterbar" ;
  sotig_av_1_A = mkA "sotig" ;
  soulagerbar_av_1_A = mkA "soulagerbar" ;
  soundmaessig_av_1_1_A = mkA "soundmässig" ;
  sovjetiserbar_av_1_A = mkA "sovjetiserbar" ;
  sovjetisk_av_1_A = mkA "sovjetisk" ;
  sovjetrysk_av_1_A = mkA "sovjetrysk" ;
  spak_av_1_A = mkA "spak" ;
  spaljerbar_av_1_A = mkA "spaljerbar" ;
  spallerbar_av_1_A = mkA "spallerbar" ;
  spansk_av_1_A = mkA "spansk" ;
  spartansk_av_1_A = mkA "spartansk" ;
  spasmodisk_av_1_A = mkA "spasmodisk" ;
  spastisk_av_1_A = mkA "spastisk" ;
  spatial_av_1_A = mkA "spatial" ;
  spatioes_av_1_1_A = mkA "spatiös" ;
  spattig_av_1_A = mkA "spattig" ;
  specialiserbar_av_1_A = mkA "specialiserbar" ;
  speciell_av_1_A = mkA "speciell" ;
  specificerbar_av_1_A = mkA "specificerbar" ;
  specifik_av_1_A = mkA "specifik" ;
  speciminerbar_av_1_A = mkA "speciminerbar" ;
  spefull_av_1_A = mkA "spefull" ;
  spegelblank_av_1_A = mkA "spegelblank" ;
  spektakulaer_av_1_1_A = mkA "spektakulär" ;
  spektral_av_1_A = mkA "spektral" ;
  spekulativ_av_1_A = mkA "spekulativ" ;
  spekulerbar_av_1_A = mkA "spekulerbar" ;
  spelarmaessig_av_1_1_A = mkA "spelarmässig" ;
  spelbar_av_1_A = mkA "spelbar" ;
  spelmaessig_av_1_1_A = mkA "spelmässig" ;
  spenderbar_av_1_A = mkA "spenderbar" ;
  spenslig_av_1_A = mkA "spenslig" ;
  spetig_av_1_A = mkA "spetig" ;
  spetsfundig_av_1_A = mkA "spetsfundig" ;
  spetsig_av_1_A = mkA "spetsig" ;
  spetsvinklig_av_1_A = mkA "spetsvinklig" ;
  spetaelsk_av_1_1_A = mkA "spetälsk" ;
  spexig_av_1_A = mkA "spexig" ;
  spikrak_av_1_A = mkA "spikrak" ;
  spinal_av_1_A = mkA "spinal" ;
  spinkig_av_1_A = mkA "spinkig" ;
  spirituell_av_1_A = mkA "spirituell" ;
  spirituoes_av_1_1_A = mkA "spirituös" ;
  spolformig_av_1_A = mkA "spolformig" ;
  spolierbar_av_1_A = mkA "spolierbar" ;
  sponsormaessig_av_1_1_A = mkA "sponsormässig" ;
  spontan_av_1_A = mkA "spontan" ;
  sporadisk_av_1_A = mkA "sporadisk" ;
  sportig_av_1_A = mkA "sportig" ;
  sportslig_av_1_A = mkA "sportslig" ;
  sportsmannamaessig_av_1_1_A = mkA "sportsmannamässig" ;
  spotsk_av_1_A = mkA "spotsk" ;
  sprallig_av_1_A = mkA "sprallig" ;
  spretig_av_1_A = mkA "spretig" ;
  sprickfaerdig_av_1_1_A = mkA "sprickfärdig" ;
  sprickig_av_1_A = mkA "sprickig" ;
  sprithaltig_av_1_A = mkA "sprithaltig" ;
  sprutlackerbar_av_1_A = mkA "sprutlackerbar" ;
  spraecklig_av_1_1_A = mkA "spräcklig" ;
  spraengfull_av_1_1_A = mkA "sprängfull" ;
  spraettig_av_1_1_A = mkA "sprättig" ;
  spraakkunnig_av_1_1_A = mkA "språkkunnig" ;
  spraaklig_av_1_1_A = mkA "språklig" ;
  spraakmaessig_av_1_1_A = mkA "språkmässig" ;
  spraakriktig_av_1_1_A = mkA "språkriktig" ;
  spydig_av_1_A = mkA "spydig" ;
  spyfaerdig_av_1_1_A = mkA "spyfärdig" ;
  spaenningsmaessig_av_1_1_A = mkA "spänningsmässig" ;
  spaenstig_av_1_1_A = mkA "spänstig" ;
  spaarloes_av_1_1_A = mkA "spårlös" ;
  spoekaktig_av_1_1_A = mkA "spökaktig" ;
  spoeklik_av_1_1_A = mkA "spöklik" ;
  srilankesisk_av_1_A = mkA "srilankesisk" ;
  stabbig_av_1_A = mkA "stabbig" ;
  stabil_av_1_A = mkA "stabil" ;
  stabiliserbar_av_1_A = mkA "stabiliserbar" ;
  stadgemaessig_av_1_1_A = mkA "stadgemässig" ;
  stadig_av_1_A = mkA "stadig" ;
  stadsbildmaessig_av_1_1_A = mkA "stadsbildmässig" ;
  stadsbildsmaessig_av_1_1_A = mkA "stadsbildsmässig" ;
  stadsbyggnadsmaessig_av_1_1_A = mkA "stadsbyggnadsmässig" ;
  stadsmiljoemaessig_av_1_1_A = mkA "stadsmiljömässig" ;
  stadsmaessig_av_1_1_A = mkA "stadsmässig" ;
  stadsplanemaessig_av_1_1_A = mkA "stadsplanemässig" ;
  stadsplanerbar_av_1_A = mkA "stadsplanerbar" ;
  stafferbar_av_1_A = mkA "stafferbar" ;
  stalinistisk_av_1_A = mkA "stalinistisk" ;
  standardiserbar_av_1_A = mkA "standardiserbar" ;
  standardmaessig_av_1_1_A = mkA "standardmässig" ;
  standardspraaklig_av_1_1_A = mkA "standardspråklig" ;
  stark_av_1_A = mkA "stark" ;
  startsnabb_av_1_A = mkA "startsnabb" ;
  stationerbar_av_1_A = mkA "stationerbar" ;
  stationaer_av_1_1_A = mkA "stationär" ;
  statisk_av_1_A = mkA "statisk" ;
  statistikmaessig_av_1_1_A = mkA "statistikmässig" ;
  statistisk_av_1_A = mkA "statistisk" ;
  stativ_av_1_A = mkA "stativ" ;
  statlig_av_1_A = mkA "statlig" ;
  statsfinansiell_av_1_A = mkA "statsfinansiell" ;
  statskvinnamaessig_av_1_1_A = mkA "statskvinnamässig" ;
  statskvinnomaessig_av_1_1_A = mkA "statskvinnomässig" ;
  statsloes_av_1_1_A = mkA "statslös" ;
  statsmannamaessig_av_1_1_A = mkA "statsmannamässig" ;
  statuarisk_av_1_A = mkA "statuarisk" ;
  statuerbar_av_1_A = mkA "statuerbar" ;
  statusmaessig_av_1_1_A = mkA "statusmässig" ;
  stegloes_av_1_1_A = mkA "steglös" ;
  stekhet_av_1_A = mkA "stekhet" ;
  stel_av_1_A = mkA "stel" ;
  stellar_av_1_A = mkA "stellar" ;
  stellarisk_av_1_A = mkA "stellarisk" ;
  stencilerbar_av_1_A = mkA "stencilerbar" ;
  stendoev_av_1_1_A = mkA "stendöv" ;
  stenfri_av_1_A = mkA "stenfri" ;
  stenig_av_1_A = mkA "stenig" ;
  stenograferbar_av_1_A = mkA "stenograferbar" ;
  stenrik_av_1_A = mkA "stenrik" ;
  stenaaldersmaessig_av_1_1_A = mkA "stenåldersmässig" ;
  stereofonisk_av_1_A = mkA "stereofonisk" ;
  stereofotograferbar_av_1_A = mkA "stereofotograferbar" ;
  stereotyp_av_1_A = mkA "stereotyp" ;
  stereotyperbar_av_1_A = mkA "stereotyperbar" ;
  steril_av_1_A = mkA "steril" ;
  steriliserbar_av_1_A = mkA "steriliserbar" ;
  sterisk_av_1_A = mkA "sterisk" ;
  stickelhaarig_av_1_1_A = mkA "stickelhårig" ;
  stickig_av_1_A = mkA "stickig" ;
  stickprovsmaessig_av_1_1_A = mkA "stickprovsmässig" ;
  stigloes_av_1_1_A = mkA "stiglös" ;
  stigmatiserbar_av_1_A = mkA "stigmatiserbar" ;
  stikisk_av_1_A = mkA "stikisk" ;
  stilenlig_av_1_A = mkA "stilenlig" ;
  stilfull_av_1_A = mkA "stilfull" ;
  stilig_av_1_A = mkA "stilig" ;
  stiliserbar_av_1_A = mkA "stiliserbar" ;
  stilistisk_av_1_A = mkA "stilistisk" ;
  stilloes_av_1_1_A = mkA "stillös" ;
  stilmaessig_av_1_1_A = mkA "stilmässig" ;
  stilvidrig_av_1_A = mkA "stilvidrig" ;
  stimmig_av_1_A = mkA "stimmig" ;
  stimulerbar_av_1_A = mkA "stimulerbar" ;
  stingslig_av_1_A = mkA "stingslig" ;
  stipendierbar_av_1_A = mkA "stipendierbar" ;
  stipulerbar_av_1_A = mkA "stipulerbar" ;
  stirrig_av_1_A = mkA "stirrig" ;
  stjaelbar_av_1_1_A = mkA "stjälbar" ;
  stjaernformig_av_1_1_A = mkA "stjärnformig" ;
  stjaernklar_av_1_1_A = mkA "stjärnklar" ;
  stjaernlik_av_1_1_A = mkA "stjärnlik" ;
  stjaernljus_av_1_1_A = mkA "stjärnljus" ;
  stockholmsmaessig_av_1_1_A = mkA "stockholmsmässig" ;
  stockkonservativ_av_1_A = mkA "stockkonservativ" ;
  stofferbar_av_1_A = mkA "stofferbar" ;
  stoisk_av_1_A = mkA "stoisk" ;
  stojig_av_1_A = mkA "stojig" ;
  stokastisk_av_1_A = mkA "stokastisk" ;
  stollig_av_1_A = mkA "stollig" ;
  storbandsmaessig_av_1_1_A = mkA "storbandsmässig" ;
  storblommig_av_1_A = mkA "storblommig" ;
  storbritannisk_av_1_A = mkA "storbritannisk" ;
  storleksmaessig_av_1_1_A = mkA "storleksmässig" ;
  stormaktspolitisk_av_1_A = mkA "stormaktspolitisk" ;
  stormfri_av_1_A = mkA "stormfri" ;
  stormig_av_1_A = mkA "stormig" ;
  stormrik_av_1_A = mkA "stormrik" ;
  storordig_av_1_A = mkA "storordig" ;
  storpipig_av_1_A = mkA "storpipig" ;
  storpolitisk_av_1_A = mkA "storpolitisk" ;
  storrysk_av_1_A = mkA "storrysk" ;
  storskalig_av_1_A = mkA "storskalig" ;
  storstadsmaessig_av_1_1_A = mkA "storstadsmässig" ;
  storsvensk_av_1_A = mkA "storsvensk" ;
  storymaessig_av_1_1_A = mkA "storymässig" ;
  straffbar_av_1_A = mkA "straffbar" ;
  straffloes_av_1_1_A = mkA "strafflös" ;
  strak_av_1_A = mkA "strak" ;
  stram_av_1_A = mkA "stram" ;
  strangulerbar_av_1_A = mkA "strangulerbar" ;
  strategisk_av_1_A = mkA "strategisk" ;
  stratifierbar_av_1_A = mkA "stratifierbar" ;
  stressig_av_1_A = mkA "stressig" ;
  stresstaalig_av_1_1_A = mkA "stresstålig" ;
  stretig_av_1_A = mkA "stretig" ;
  stridbar_av_1_A = mkA "stridbar" ;
  stridig_av_1_A = mkA "stridig" ;
  stridsduglig_av_1_A = mkA "stridsduglig" ;
  stridsformerbar_av_1_A = mkA "stridsformerbar" ;
  stridsgrupperbar_av_1_A = mkA "stridsgrupperbar" ;
  stridsmaessig_av_1_1_A = mkA "stridsmässig" ;
  strimmig_av_1_A = mkA "strimmig" ;
  stripig_av_1_A = mkA "stripig" ;
  strofisk_av_1_A = mkA "strofisk" ;
  strong_av_1_A = mkA "strong" ;
  stroppig_av_1_A = mkA "stroppig" ;
  strukturell_av_1_A = mkA "strukturell" ;
  strukturerbar_av_1_A = mkA "strukturerbar" ;
  strukturrationaliserbar_av_1_A = mkA "strukturrationaliserbar" ;
  strulig_av_1_A = mkA "strulig" ;
  struntfin_av_1_A = mkA "struntfin" ;
  struntfoernaem_av_1_1_A = mkA "struntförnäm" ;
  struntviktig_av_1_A = mkA "struntviktig" ;
  struttig_av_1_A = mkA "struttig" ;
  stryktaeck_av_1_1_A = mkA "stryktäck" ;
  stryktaalig_av_1_1_A = mkA "stryktålig" ;
  straeng_av_1_1_A = mkA "sträng" ;
  straev_av_1_1_A = mkA "sträv" ;
  straevhaarig_av_1_1_A = mkA "strävhårig" ;
  straevig_av_1_1_A = mkA "strävig" ;
  straalfenig_av_1_1_A = mkA "strålfenig" ;
  straalkonserverbar_av_1_1_A = mkA "strålkonserverbar" ;
  stroem_av_1_1_A = mkA "ström" ;
  stubbig_av_1_A = mkA "stubbig" ;
  studentikos_av_1_A = mkA "studentikos" ;
  studerbar_av_1_A = mkA "studerbar" ;
  studiemaessig_av_1_1_A = mkA "studiemässig" ;
  studieorienterbar_av_1_A = mkA "studieorienterbar" ;
  studiomaessig_av_1_1_A = mkA "studiomässig" ;
  stumfilmsmaessig_av_1_1_A = mkA "stumfilmsmässig" ;
  stundlig_av_1_A = mkA "stundlig" ;
  stupfull_av_1_A = mkA "stupfull" ;
  sturig_av_1_A = mkA "sturig" ;
  stursk_av_1_A = mkA "stursk" ;
  stygg_av_1_A = mkA "stygg" ;
  styrbar_av_1_A = mkA "styrbar" ;
  styrselloes_av_1_1_A = mkA "styrsellös" ;
  styv_av_1_A = mkA "styv" ;
  styvmoderlig_av_1_A = mkA "styvmoderlig" ;
  staemningsfull_av_1_1_A = mkA "stämningsfull" ;
  staendig_av_1_1_A = mkA "ständig" ;
  staerkelserik_av_1_1_A = mkA "stärkelserik" ;
  staalvit_av_1_1_A = mkA "stålvit" ;
  staandaktig_av_1_1_A = mkA "ståndaktig" ;
  staandmaessig_av_1_1_A = mkA "ståndmässig" ;
  staandsmaessig_av_1_1_A = mkA "ståndsmässig" ;
  staatlig_av_1_1_A = mkA "ståtlig" ;
  stoeddig_av_1_1_A = mkA "stöddig" ;
  stoekig_av_1_1_A = mkA "stökig" ;
  stoerig_av_1_1_A = mkA "störig" ;
  stoertkaer_av_1_1_A = mkA "störtkär" ;
  stoettaalig_av_1_1_A = mkA "stöttålig" ;
  subalpin_av_1_A = mkA "subalpin" ;
  subantarktisk_av_1_A = mkA "subantarktisk" ;
  subarktisk_av_1_A = mkA "subarktisk" ;
  subbig_av_1_A = mkA "subbig" ;
  subjektiv_av_1_A = mkA "subjektiv" ;
  subkutan_av_1_A = mkA "subkutan" ;
  sublim_av_1_A = mkA "sublim" ;
  sublimerbar_av_1_A = mkA "sublimerbar" ;
  subliminal_av_1_A = mkA "subliminal" ;
  submarin_av_1_A = mkA "submarin" ;
  subordinerbar_av_1_A = mkA "subordinerbar" ;
  subsidierbar_av_1_A = mkA "subsidierbar" ;
  subsidiaer_av_1_1_A = mkA "subsidiär" ;
  subskriberbar_av_1_A = mkA "subskriberbar" ;
  substantiell_av_1_A = mkA "substantiell" ;
  substantiverbar_av_1_A = mkA "substantiverbar" ;
  substituerbar_av_1_A = mkA "substituerbar" ;
  subsumerbar_av_1_A = mkA "subsumerbar" ;
  subtil_av_1_A = mkA "subtil" ;
  subtraherbar_av_1_A = mkA "subtraherbar" ;
  subtropisk_av_1_A = mkA "subtropisk" ;
  subventionerbar_av_1_A = mkA "subventionerbar" ;
  subversiv_av_1_A = mkA "subversiv" ;
  succederbar_av_1_A = mkA "succederbar" ;
  successiv_av_1_A = mkA "successiv" ;
  sudanesisk_av_1_A = mkA "sudanesisk" ;
  suddig_av_1_A = mkA "suddig" ;
  suffigerbar_av_1_A = mkA "suffigerbar" ;
  sufflerbar_av_1_A = mkA "sufflerbar" ;
  suggererbar_av_1_A = mkA "suggererbar" ;
  suggestiv_av_1_A = mkA "suggestiv" ;
  suicidal_av_1_A = mkA "suicidal" ;
  sumerisk_av_1_A = mkA "sumerisk" ;
  summarisk_av_1_A = mkA "summarisk" ;
  summerbar_av_1_A = mkA "summerbar" ;
  sumpig_av_1_A = mkA "sumpig" ;
  sunkig_av_1_A = mkA "sunkig" ;
  superb_av_1_A = mkA "superb" ;
  superlativ_av_1_A = mkA "superlativ" ;
  supersnabb_av_1_A = mkA "supersnabb" ;
  supersonisk_av_1_A = mkA "supersonisk" ;
  superstark_av_1_A = mkA "superstark" ;
  supig_av_1_A = mkA "supig" ;
  supplementaer_av_1_1_A = mkA "supplementär" ;
  supplerbar_av_1_A = mkA "supplerbar" ;
  supponerbar_av_1_A = mkA "supponerbar" ;
  supradental_av_1_A = mkA "supradental" ;
  supramarin_av_1_A = mkA "supramarin" ;
  sur_av_1_A = mkA "sur" ;
  surfbar_av_1_A = mkA "surfbar" ;
  surinamesisk_av_1_A = mkA "surinamesisk" ;
  surrealistisk_av_1_A = mkA "surrealistisk" ;
  suspenderbar_av_1_A = mkA "suspenderbar" ;
  suspensiv_av_1_A = mkA "suspensiv" ;
  suveraen_av_1_1_A = mkA "suverän" ;
  svag_av_1_A = mkA "svag" ;
  svagtonig_av_1_A = mkA "svagtonig" ;
  svajig_av_1_A = mkA "svajig" ;
  sval_av_1_A = mkA "sval" ;
  svamlig_av_1_A = mkA "svamlig" ;
  svampig_av_1_A = mkA "svampig" ;
  svankig_av_1_A = mkA "svankig" ;
  svarsloes_av_1_1_A = mkA "svarslös" ;
  svartmuskig_av_1_A = mkA "svartmuskig" ;
  svartsjuk_av_1_A = mkA "svartsjuk" ;
  svartvit_av_1_A = mkA "svartvit" ;
  svekfri_av_1_A = mkA "svekfri" ;
  svekfull_av_1_A = mkA "svekfull" ;
  sveklig_av_1_A = mkA "sveklig" ;
  svekloes_av_1_1_A = mkA "sveklös" ;
  svensk_rysk_av_1_A = mkA "svensk-rysk" ;
  svensk_av_1_A = mkA "svensk" ;
  svettig_av_1_A = mkA "svettig" ;
  sviklig_av_1_A = mkA "sviklig" ;
  svimfaerdig_av_1_1_A = mkA "svimfärdig" ;
  svinaktig_av_1_A = mkA "svinaktig" ;
  svindyr_av_1_A = mkA "svindyr" ;
  svinkall_av_1_A = mkA "svinkall" ;
  svulstig_av_1_A = mkA "svulstig" ;
  svaeltmaessig_av_1_1_A = mkA "svältmässig" ;
  svaengbar_av_1_1_A = mkA "svängbar" ;
  svaengig_av_1_1_A = mkA "svängig" ;
  svaerdlik_av_1_1_A = mkA "svärdlik" ;
  svaerdsloes_av_1_1_A = mkA "svärdslös" ;
  svaermisk_av_1_1_A = mkA "svärmisk" ;
  svaar_av_1_1_A = mkA "svår" ;
  svaaravvislig_av_1_1_A = mkA "svåravvislig" ;
  svaarbegriplig_av_1_1_A = mkA "svårbegriplig" ;
  svaarfattlig_av_1_1_A = mkA "svårfattlig" ;
  svaarframkomlig_av_1_1_A = mkA "svårframkomlig" ;
  svaarfoerklarlig_av_1_1_A = mkA "svårförklarlig" ;
  svaarfoerstaaelig_av_1_1_A = mkA "svårförståelig" ;
  svaargenomtraenglig_av_1_1_A = mkA "svårgenomtränglig" ;
  svaarhanterlig_av_1_1_A = mkA "svårhanterlig" ;
  svaarintaglig_av_1_1_A = mkA "svårintaglig" ;
  svaarmodig_av_1_1_A = mkA "svårmodig" ;
  svaarpaavisbar_av_1_1_A = mkA "svårpåvisbar" ;
  svaartillgaenglig_av_1_1_A = mkA "svårtillgänglig" ;
  svaaroeverblickbar_av_1_1_A = mkA "svåröverblickbar" ;
  svaaroeverskaadlig_av_1_1_A = mkA "svåröverskådlig" ;
  swazilaendsk_av_1_1_A = mkA "swaziländsk" ;
  sybaritisk_av_1_A = mkA "sybaritisk" ;
  sydafrikansk_av_1_A = mkA "sydafrikansk" ;
  sydamerikansk_av_1_A = mkA "sydamerikansk" ;
  sydkoreansk_av_1_A = mkA "sydkoreansk" ;
  sydlig_av_1_A = mkA "sydlig" ;
  sydlaendsk_av_1_1_A = mkA "sydländsk" ;
  sydsvensk_av_1_A = mkA "sydsvensk" ;
  syfilitisk_av_1_A = mkA "syfilitisk" ;
  sylfidisk_av_1_A = mkA "sylfidisk" ;
  syllabisk_av_1_A = mkA "syllabisk" ;
  symbiotisk_av_1_A = mkA "symbiotisk" ;
  symboliserbar_av_1_A = mkA "symboliserbar" ;
  symbolisk_av_1_A = mkA "symbolisk" ;
  symbolmaessig_av_1_1_A = mkA "symbolmässig" ;
  symfonisk_av_1_A = mkA "symfonisk" ;
  symmetrisk_av_1_A = mkA "symmetrisk" ;
  sympatetisk_av_1_A = mkA "sympatetisk" ;
  sympatisk_av_1_A = mkA "sympatisk" ;
  symptomatisk_av_1_A = mkA "symptomatisk" ;
  symtomatisk_av_1_A = mkA "symtomatisk" ;
  synbar_av_1_A = mkA "synbar" ;
  synbarlig_av_1_A = mkA "synbarlig" ;
  syndfull_av_1_A = mkA "syndfull" ;
  syndig_av_1_A = mkA "syndig" ;
  synkoperbar_av_1_A = mkA "synkoperbar" ;
  synkopisk_av_1_A = mkA "synkopisk" ;
  synkron_av_1_A = mkA "synkron" ;
  synkroniserbar_av_1_A = mkA "synkroniserbar" ;
  synkronisk_av_1_A = mkA "synkronisk" ;
  synlig_av_1_A = mkA "synlig" ;
  synnerlig_av_1_A = mkA "synnerlig" ;
  synodal_av_1_A = mkA "synodal" ;
  synodisk_av_1_A = mkA "synodisk" ;
  synonym_av_1_A = mkA "synonym" ;
  synoptisk_av_1_A = mkA "synoptisk" ;
  synsk_av_1_A = mkA "synsk" ;
  syntaktisk_av_1_A = mkA "syntaktisk" ;
  syntetiserbar_av_1_A = mkA "syntetiserbar" ;
  syntetisk_av_1_A = mkA "syntetisk" ;
  syperb_av_1_A = mkA "syperb" ;
  syrefattig_av_1_A = mkA "syrefattig" ;
  syrerik_av_1_A = mkA "syrerik" ;
  syrisk_av_1_A = mkA "syrisk" ;
  syrlig_av_1_A = mkA "syrlig" ;
  syskonlig_av_1_A = mkA "syskonlig" ;
  sysselsaettningsmaessig_av_1_1_A = mkA "sysselsättningsmässig" ;
  syssloloes_av_1_1_A = mkA "sysslolös" ;
  systematiserbar_av_1_A = mkA "systematiserbar" ;
  systematisk_av_1_A = mkA "systematisk" ;
  systemmaessig_av_1_1_A = mkA "systemmässig" ;
  systerlig_av_1_A = mkA "systerlig" ;
  systolisk_av_1_A = mkA "systolisk" ;
  saeckig_av_1_1_A = mkA "säckig" ;
  saekerhetsmaessig_av_1_1_A = mkA "säkerhetsmässig" ;
  saeljbar_av_1_1_A = mkA "säljbar" ;
  saell_av_1_1_A = mkA "säll" ;
  saellskaplig_av_1_1_A = mkA "sällskaplig" ;
  saellskapssjuk_av_1_1_A = mkA "sällskapssjuk" ;
  saerklassig_av_1_1_A = mkA "särklassig" ;
  saesongmaessig_av_1_1_A = mkA "säsongmässig" ;
  saesongsmaessig_av_1_1_A = mkA "säsongsmässig" ;
  saevlig_av_1_1_A = mkA "sävlig" ;
  saadig_av_1_1_A = mkA "sådig" ;
  saangbar_av_1_1_A = mkA "sångbar" ;
  saanglig_av_1_1_A = mkA "sånglig" ;
  saangmaessig_av_1_1_A = mkA "sångmässig" ;
  saaphal_av_1_1_A = mkA "såphal" ;
  saarbar_av_1_1_A = mkA "sårbar" ;
  saarig_av_1_1_A = mkA "sårig" ;
  saasig_av_1_1_A = mkA "såsig" ;
  saaterbar_av_1_1_A = mkA "såterbar" ;
  saaverbar_av_1_1_A = mkA "såverbar" ;
  soedermanlaendsk_av_1_1_A = mkA "södermanländsk" ;
  soelig_av_1_1_A = mkA "sölig" ;
  soemngaangaraktig_av_1_1_A = mkA "sömngångaraktig" ;
  soemnig_av_1_1_A = mkA "sömnig" ;
  soemnloes_av_1_1_A = mkA "sömnlös" ;
  soemntung_av_1_1_A = mkA "sömntung" ;
  soendaglig_av_1_1_A = mkA "söndaglig" ;
  soendrig_av_1_1_A = mkA "söndrig" ;
  soerlaendsk_av_1_1_A = mkA "sörländsk" ;
  soermlaendsk_av_1_1_A = mkA "sörmländsk" ;
  soet_av_1_1_A = mkA "söt" ;
  soetaktig_av_1_1_A = mkA "sötaktig" ;
  soetsliskig_av_1_1_A = mkA "sötsliskig" ;
  soetsur_av_1_1_A = mkA "sötsur" ;
  tabellarisk_av_1_A = mkA "tabellarisk" ;
  tabellerbar_av_1_A = mkA "tabellerbar" ;
  tablaamaessig_av_1_1_A = mkA "tablåmässig" ;
  tabuerbar_av_1_A = mkA "tabuerbar" ;
  tacknaemlig_av_1_1_A = mkA "tacknämlig" ;
  tadzjikisk_av_1_A = mkA "tadzjikisk" ;
  tafflig_av_1_A = mkA "tafflig" ;
  tafsig_av_1_A = mkA "tafsig" ;
  taggfenig_av_1_A = mkA "taggfenig" ;
  taggig_av_1_A = mkA "taggig" ;
  taiwanesisk_av_1_A = mkA "taiwanesisk" ;
  taktfull_av_1_A = mkA "taktfull" ;
  taktil_av_1_A = mkA "taktil" ;
  taktisk_av_1_A = mkA "taktisk" ;
  taktloes_av_1_1_A = mkA "taktlös" ;
  taktmaessig_av_1_1_A = mkA "taktmässig" ;
  talangfull_av_1_A = mkA "talangfull" ;
  talangloes_av_1_1_A = mkA "talanglös" ;
  talfoer_av_1_1_A = mkA "talför" ;
  talgig_av_1_A = mkA "talgig" ;
  talkig_av_1_A = mkA "talkig" ;
  tallrik_av_1_A = mkA "tallrik" ;
  talloes_av_1_1_A = mkA "tallös" ;
  talrik_av_1_A = mkA "talrik" ;
  talspraaklig_av_1_1_A = mkA "talspråklig" ;
  talspraaksmaessig_av_1_1_A = mkA "talspråksmässig" ;
  tam_av_1_A = mkA "tam" ;
  tamponerbar_av_1_A = mkA "tamponerbar" ;
  tandlik_av_1_A = mkA "tandlik" ;
  tandloes_av_1_1_A = mkA "tandlös" ;
  tandvaenlig_av_1_1_A = mkA "tandvänlig" ;
  tangerbar_av_1_A = mkA "tangerbar" ;
  tanig_av_1_A = mkA "tanig" ;
  tankemaessig_av_1_1_A = mkA "tankemässig" ;
  tankfull_av_1_A = mkA "tankfull" ;
  tankloes_av_1_1_A = mkA "tanklös" ;
  tantaktig_av_1_A = mkA "tantaktig" ;
  tantig_av_1_A = mkA "tantig" ;
  tanzanisk_av_1_A = mkA "tanzanisk" ;
  tapetserbar_av_1_A = mkA "tapetserbar" ;
  tarerbar_av_1_A = mkA "tarerbar" ;
  tarifferbar_av_1_A = mkA "tarifferbar" ;
  tarvlig_av_1_A = mkA "tarvlig" ;
  taskig_av_1_A = mkA "taskig" ;
  tatuerbar_av_1_A = mkA "tatuerbar" ;
  tautologisk_av_1_A = mkA "tautologisk" ;
  taxerbar_av_1_A = mkA "taxerbar" ;
  taxeringsmaessig_av_1_1_A = mkA "taxeringsmässig" ;
  tchadisk_av_1_A = mkA "tchadisk" ;
  teatermaessig_av_1_1_A = mkA "teatermässig" ;
  teatral_av_1_A = mkA "teatral" ;
  teatralisk_av_1_A = mkA "teatralisk" ;
  teknifierbar_av_1_A = mkA "teknifierbar" ;
  teknisk_av_1_A = mkA "teknisk" ;
  teknologisk_av_1_A = mkA "teknologisk" ;
  telefonerbar_av_1_A = mkA "telefonerbar" ;
  telegraferbar_av_1_A = mkA "telegraferbar" ;
  telegrafisk_av_1_A = mkA "telegrafisk" ;
  teleologisk_av_1_A = mkA "teleologisk" ;
  telepatisk_av_1_A = mkA "telepatisk" ;
  teleskopisk_av_1_A = mkA "teleskopisk" ;
  teleteknisk_av_1_A = mkA "teleteknisk" ;
  televiserbar_av_1_A = mkA "televiserbar" ;
  tellurisk_av_1_A = mkA "tellurisk" ;
  tematisk_av_1_A = mkA "tematisk" ;
  temperamentfull_av_1_A = mkA "temperamentfull" ;
  temperamentsfull_av_1_A = mkA "temperamentsfull" ;
  temperaturbestaendig_av_1_1_A = mkA "temperaturbeständig" ;
  temperaturkaenslig_av_1_1_A = mkA "temperaturkänslig" ;
  temperbar_av_1_A = mkA "temperbar" ;
  tempererbar_av_1_A = mkA "tempererbar" ;
  tempomaessig_av_1_1_A = mkA "tempomässig" ;
  temporaer_av_1_1_A = mkA "temporär" ;
  tendensloes_av_1_1_A = mkA "tendenslös" ;
  tendentioes_av_1_1_A = mkA "tendentiös" ;
  tentativ_av_1_A = mkA "tentativ" ;
  tenterbar_av_1_A = mkA "tenterbar" ;
  teocentrisk_av_1_A = mkA "teocentrisk" ;
  teokratisk_av_1_A = mkA "teokratisk" ;
  teologisk_av_1_A = mkA "teologisk" ;
  teoretisk_av_1_A = mkA "teoretisk" ;
  teosofisk_av_1_A = mkA "teosofisk" ;
  terapeutisk_av_1_A = mkA "terapeutisk" ;
  terminal_av_1_A = mkA "terminal" ;
  terminlig_av_1_A = mkA "terminlig" ;
  terminologisk_av_1_A = mkA "terminologisk" ;
  termisk_av_1_A = mkA "termisk" ;
  termitbestaendig_av_1_1_A = mkA "termitbeständig" ;
  termodynamisk_av_1_A = mkA "termodynamisk" ;
  termofil_av_1_A = mkA "termofil" ;
  termonukleaer_av_1_1_A = mkA "termonukleär" ;
  terrasserbar_av_1_A = mkA "terrasserbar" ;
  territoriell_av_1_A = mkA "territoriell" ;
  terroriserbar_av_1_A = mkA "terroriserbar" ;
  tertiaer_av_1_1_A = mkA "tertiär" ;
  tesaurerbar_av_1_A = mkA "tesaurerbar" ;
  testamentarisk_av_1_A = mkA "testamentarisk" ;
  testamenterbar_av_1_A = mkA "testamenterbar" ;
  testig_av_1_A = mkA "testig" ;
  tetig_av_1_A = mkA "tetig" ;
  textil_av_1_A = mkA "textil" ;
  textkritisk_av_1_A = mkA "textkritisk" ;
  textmaessig_av_1_1_A = mkA "textmässig" ;
  thailaendsk_av_1_1_A = mkA "thailändsk" ;
  tibetansk_av_1_A = mkA "tibetansk" ;
  tidig_av_1_A = mkA "tidig" ;
  tidlig_av_1_A = mkA "tidlig" ;
  tidloes_av_1_1_A = mkA "tidlös" ;
  tidsenlig_av_1_A = mkA "tidsenlig" ;
  tidslig_av_1_A = mkA "tidslig" ;
  tidsmaessig_av_1_1_A = mkA "tidsmässig" ;
  tidstypisk_av_1_A = mkA "tidstypisk" ;
  tidtabellsmaessig_av_1_1_A = mkA "tidtabellsmässig" ;
  tigerrandig_av_1_A = mkA "tigerrandig" ;
  tigerstrimmig_av_1_A = mkA "tigerstrimmig" ;
  tillboerlig_av_1_1_A = mkA "tillbörlig" ;
  tillfaellig_av_1_1_A = mkA "tillfällig" ;
  tillfoerlitlig_av_1_1_A = mkA "tillförlitlig" ;
  tillgaenglig_av_1_1_A = mkA "tillgänglig" ;
  tillhoerig_av_1_1_A = mkA "tillhörig" ;
  tillitsfull_av_1_A = mkA "tillitsfull" ;
  tillraecklig_av_1_1_A = mkA "tillräcklig" ;
  tillraeknelig_av_1_1_A = mkA "tillräknelig" ;
  tillraadlig_av_1_1_A = mkA "tillrådlig" ;
  tillstaendig_av_1_1_A = mkA "tillständig" ;
  tillaemplig_av_1_1_A = mkA "tillämplig" ;
  tillaatlig_av_1_1_A = mkA "tillåtlig" ;
  timlig_av_1_A = mkA "timlig" ;
  timslaang_av_1_1_A = mkA "timslång" ;
  tiofaldig_av_1_A = mkA "tiofaldig" ;
  titanisk_av_1_A = mkA "titanisk" ;
  titelsjuk_av_1_A = mkA "titelsjuk" ;
  titrerbar_av_1_A = mkA "titrerbar" ;
  tittarmaessig_av_1_1_A = mkA "tittarmässig" ;
  titulerbar_av_1_A = mkA "titulerbar" ;
  tixotrop_av_1_A = mkA "tixotrop" ;
  tjafsig_av_1_A = mkA "tjafsig" ;
  tjatig_av_1_A = mkA "tjatig" ;
  tjeckisk_av_1_A = mkA "tjeckisk" ;
  tjeckoslovakisk_av_1_A = mkA "tjeckoslovakisk" ;
  tjetjensk_av_1_A = mkA "tjetjensk" ;
  tjock_av_1_A = mkA "tjock" ;
  tjockskallig_av_1_A = mkA "tjockskallig" ;
  tjugoplanig_av_1_A = mkA "tjugoplanig" ;
  tjurig_av_1_A = mkA "tjurig" ;
  tjurskallig_av_1_A = mkA "tjurskallig" ;
  tjusig_av_1_A = mkA "tjusig" ;
  tjuvaktig_av_1_A = mkA "tjuvaktig" ;
  tjuvtjock_av_1_A = mkA "tjuvtjock" ;
  tjyvaktig_av_1_A = mkA "tjyvaktig" ;
  tjyvtjock_av_1_A = mkA "tjyvtjock" ;
  tjaenlig_av_1_1_A = mkA "tjänlig" ;
  tjaenstaktig_av_1_1_A = mkA "tjänstaktig" ;
  tjaenstbar_av_1_1_A = mkA "tjänstbar" ;
  tjaenstemannamaessig_av_1_1_A = mkA "tjänstemannamässig" ;
  tjaenstfri_av_1_1_A = mkA "tjänstfri" ;
  tjaenstledig_av_1_1_A = mkA "tjänstledig" ;
  tjaenstvillig_av_1_1_A = mkA "tjänstvillig" ;
  tofsig_av_1_A = mkA "tofsig" ;
  togolesisk_av_1_A = mkA "togolesisk" ;
  tokig_av_1_A = mkA "tokig" ;
  tokrolig_av_1_A = mkA "tokrolig" ;
  tolererbar_av_1_A = mkA "tolererbar" ;
  tolkningsmaessig_av_1_1_A = mkA "tolkningsmässig" ;
  tonal_av_1_A = mkA "tonal" ;
  tondoev_av_1_1_A = mkA "tondöv" ;
  tongansk_av_1_A = mkA "tongansk" ;
  tonisk_av_1_A = mkA "tonisk" ;
  tonloes_av_1_1_A = mkA "tonlös" ;
  topografisk_av_1_A = mkA "topografisk" ;
  topologisk_av_1_A = mkA "topologisk" ;
  toppformig_av_1_A = mkA "toppformig" ;
  toppig_av_1_A = mkA "toppig" ;
  toppmodern_av_1_A = mkA "toppmodern" ;
  torderbar_av_1_A = mkA "torderbar" ;
  torftig_av_1_A = mkA "torftig" ;
  torpederbar_av_1_A = mkA "torpederbar" ;
  torr_av_1_A = mkA "torr" ;
  torrdestillerbar_av_1_A = mkA "torrdestillerbar" ;
  torrolig_av_1_A = mkA "torrolig" ;
  torrschamponerbar_av_1_A = mkA "torrschamponerbar" ;
  torterbar_av_1_A = mkA "torterbar" ;
  torvaktig_av_1_A = mkA "torvaktig" ;
  tosig_av_1_A = mkA "tosig" ;
  toskansk_av_1_A = mkA "toskansk" ;
  tossig_av_1_A = mkA "tossig" ;
  total_av_1_A = mkA "total" ;
  totalfinansierbar_av_1_A = mkA "totalfinansierbar" ;
  totalitaer_av_1_1_A = mkA "totalitär" ;
  toucherbar_av_1_A = mkA "toucherbar" ;
  touperbar_av_1_A = mkA "touperbar" ;
  tovig_av_1_A = mkA "tovig" ;
  toxikologisk_av_1_A = mkA "toxikologisk" ;
  toxisk_av_1_A = mkA "toxisk" ;
  traderbar_av_1_A = mkA "traderbar" ;
  tradig_av_1_A = mkA "tradig" ;
  traditionell_av_1_A = mkA "traditionell" ;
  traditionsenlig_av_1_A = mkA "traditionsenlig" ;
  traditionsrik_av_1_A = mkA "traditionsrik" ;
  trafikerbar_av_1_A = mkA "trafikerbar" ;
  trafikfarlig_av_1_A = mkA "trafikfarlig" ;
  trafikmaessig_av_1_1_A = mkA "trafikmässig" ;
  trafikreglerbar_av_1_A = mkA "trafikreglerbar" ;
  trafiksaekerhetsmaessig_av_1_1_A = mkA "trafiksäkerhetsmässig" ;
  tragglig_av_1_A = mkA "tragglig" ;
  tragikomisk_av_1_A = mkA "tragikomisk" ;
  tragisk_av_1_A = mkA "tragisk" ;
  trakasserbar_av_1_A = mkA "trakasserbar" ;
  trakterbar_av_1_A = mkA "trakterbar" ;
  tramsig_av_1_A = mkA "tramsig" ;
  trancherbar_av_1_A = mkA "trancherbar" ;
  trankil_av_1_A = mkA "trankil" ;
  transalpin_av_1_A = mkA "transalpin" ;
  transalpinsk_av_1_A = mkA "transalpinsk" ;
  transatlantisk_av_1_A = mkA "transatlantisk" ;
  transcendental_av_1_A = mkA "transcendental" ;
  transfererbar_av_1_A = mkA "transfererbar" ;
  transformerbar_av_1_A = mkA "transformerbar" ;
  transiterbar_av_1_A = mkA "transiterbar" ;
  transitiv_av_1_A = mkA "transitiv" ;
  transitorisk_av_1_A = mkA "transitorisk" ;
  transkontinental_av_1_A = mkA "transkontinental" ;
  transkriberbar_av_1_A = mkA "transkriberbar" ;
  translittererbar_av_1_A = mkA "translittererbar" ;
  transmitterbar_av_1_A = mkA "transmitterbar" ;
  transmuterbar_av_1_A = mkA "transmuterbar" ;
  transocean_av_1_A = mkA "transocean" ;
  transoceansk_av_1_A = mkA "transoceansk" ;
  transplanterbar_av_1_A = mkA "transplanterbar" ;
  transponerbar_av_1_A = mkA "transponerbar" ;
  transporterbar_av_1_A = mkA "transporterbar" ;
  transportmaessig_av_1_1_A = mkA "transportmässig" ;
  transsexuell_av_1_A = mkA "transsexuell" ;
  transsibirisk_av_1_A = mkA "transsibirisk" ;
  transumerbar_av_1_A = mkA "transumerbar" ;
  transversal_av_1_A = mkA "transversal" ;
  transversell_av_1_A = mkA "transversell" ;
  trappklok_av_1_A = mkA "trappklok" ;
  trasig_av_1_A = mkA "trasig" ;
  trasserbar_av_1_A = mkA "trasserbar" ;
  trasslig_av_1_A = mkA "trasslig" ;
  trattformig_av_1_A = mkA "trattformig" ;
  traumatisk_av_1_A = mkA "traumatisk" ;
  travesterbar_av_1_A = mkA "travesterbar" ;
  tredimensionell_av_1_A = mkA "tredimensionell" ;
  tredsk_av_1_A = mkA "tredsk" ;
  treenig_av_1_A = mkA "treenig" ;
  trefaldig_av_1_A = mkA "trefaldig" ;
  trefasig_av_1_A = mkA "trefasig" ;
  trefilig_av_1_A = mkA "trefilig" ;
  trekantig_av_1_A = mkA "trekantig" ;
  trekvartslaang_av_1_1_A = mkA "trekvartslång" ;
  trendig_av_1_A = mkA "trendig" ;
  trendkaenslig_av_1_1_A = mkA "trendkänslig" ;
  trendmaessig_av_1_1_A = mkA "trendmässig" ;
  trendriktig_av_1_A = mkA "trendriktig" ;
  trepanerbar_av_1_A = mkA "trepanerbar" ;
  treradig_av_1_A = mkA "treradig" ;
  tresiffrig_av_1_A = mkA "tresiffrig" ;
  trestavig_av_1_A = mkA "trestavig" ;
  trestjaernig_av_1_1_A = mkA "trestjärnig" ;
  trevinklig_av_1_A = mkA "trevinklig" ;
  trevlig_av_1_A = mkA "trevlig" ;
  triangulerbar_av_1_A = mkA "triangulerbar" ;
  triangulaer_av_1_1_A = mkA "triangulär" ;
  tribadisk_av_1_A = mkA "tribadisk" ;
  trierbar_av_1_A = mkA "trierbar" ;
  trigonometrisk_av_1_A = mkA "trigonometrisk" ;
  trikinoes_av_1_1_A = mkA "trikinös" ;
  trilateral_av_1_A = mkA "trilateral" ;
  trilsk_av_1_A = mkA "trilsk" ;
  trindbladig_av_1_A = mkA "trindbladig" ;
  trinidadisk_av_1_A = mkA "trinidadisk" ;
  triumfatorisk_av_1_A = mkA "triumfatorisk" ;
  trivial_av_1_A = mkA "trivial" ;
  trivialiserbar_av_1_A = mkA "trivialiserbar" ;
  trixig_av_1_A = mkA "trixig" ;
  trojansk_av_1_A = mkA "trojansk" ;
  trokaisk_av_1_A = mkA "trokaisk" ;
  trok_eisk_av_1_1_A = mkA "trokéisk" ;
  trolig_av_1_A = mkA "trolig" ;
  trollkunnig_av_1_A = mkA "trollkunnig" ;
  trolsk_av_1_A = mkA "trolsk" ;
  troloes_av_1_1_A = mkA "trolös" ;
  tropisk_av_1_A = mkA "tropisk" ;
  troskyldig_av_1_A = mkA "troskyldig" ;
  trosmaessig_av_1_1_A = mkA "trosmässig" ;
  trosviss_av_1_A = mkA "trosviss" ;
  trotsig_av_1_A = mkA "trotsig" ;
  trovaerdig_av_1_1_A = mkA "trovärdig" ;
  trubbig_av_1_A = mkA "trubbig" ;
  trubbnosig_av_1_A = mkA "trubbnosig" ;
  trubbvinklig_av_1_A = mkA "trubbvinklig" ;
  truistisk_av_1_A = mkA "truistisk" ;
  trulig_av_1_A = mkA "trulig" ;
  trulsig_av_1_A = mkA "trulsig" ;
  tryckbar_av_1_A = mkA "tryckbar" ;
  tryckimpregnerbar_av_1_A = mkA "tryckimpregnerbar" ;
  tryckkaenslig_av_1_1_A = mkA "tryckkänslig" ;
  tryckstark_av_1_A = mkA "tryckstark" ;
  trycksvag_av_1_A = mkA "trycksvag" ;
  tryfferbar_av_1_A = mkA "tryfferbar" ;
  trygg_av_1_A = mkA "trygg" ;
  traeaktig_av_1_1_A = mkA "träaktig" ;
  traedloes_av_1_1_A = mkA "trädlös" ;
  traeig_av_1_1_A = mkA "träig" ;
  traelig_av_1_1_A = mkA "trälig" ;
  traeningsmaessig_av_1_1_A = mkA "träningsmässig" ;
  traeskallig_av_1_1_A = mkA "träskallig" ;
  traeteknisk_av_1_1_A = mkA "träteknisk" ;
  traetgirig_av_1_1_A = mkA "trätgirig" ;
  traevit_av_1_1_A = mkA "trävit" ;
  traadig_av_1_1_A = mkA "trådig" ;
  traadloes_av_1_1_A = mkA "trådlös" ;
  traadraet_av_1_1_A = mkA "trådrät" ;
  traadsmal_av_1_1_A = mkA "trådsmal" ;
  traakig_av_1_1_A = mkA "tråkig" ;
  traanadsfull_av_1_1_A = mkA "trånadsfull" ;
  traansjuk_av_1_1_A = mkA "trånsjuk" ;
  troeg_av_1_1_A = mkA "trög" ;
  troeghetsnavigerbar_av_1_1_A = mkA "tröghetsnavigerbar" ;
  troegroerlig_av_1_1_A = mkA "trögrörlig" ;
  troestelig_av_1_1_A = mkA "tröstelig" ;
  troesterik_av_1_1_A = mkA "trösterik" ;
  troestlig_av_1_1_A = mkA "tröstlig" ;
  troestloes_av_1_1_A = mkA "tröstlös" ;
  troestrik_av_1_1_A = mkA "tröstrik" ;
  tuberkuloes_av_1_1_A = mkA "tuberkulös" ;
  tuff_av_1_A = mkA "tuff" ;
  tufsig_av_1_A = mkA "tufsig" ;
  tuktig_av_1_A = mkA "tuktig" ;
  tuktloes_av_1_1_A = mkA "tuktlös" ;
  tullmaessig_av_1_1_A = mkA "tullmässig" ;
  tullpliktig_av_1_A = mkA "tullpliktig" ;
  tumstjock_av_1_A = mkA "tumstjock" ;
  tumultuarisk_av_1_A = mkA "tumultuarisk" ;
  tunisisk_av_1_A = mkA "tunisisk" ;
  tunnbladig_av_1_A = mkA "tunnbladig" ;
  tunnhaarig_av_1_1_A = mkA "tunnhårig" ;
  tuperbar_av_1_A = mkA "tuperbar" ;
  turistisk_av_1_A = mkA "turistisk" ;
  turistmaessig_av_1_1_A = mkA "turistmässig" ;
  turisttaet_av_1_1_A = mkA "turisttät" ;
  turkisk_av_1_A = mkA "turkisk" ;
  turkos_av_1_A = mkA "turkos" ;
  turlig_av_1_A = mkA "turlig" ;
  turnerbar_av_1_A = mkA "turnerbar" ;
  tuscherbar_av_1_A = mkA "tuscherbar" ;
  tuvaluansk_av_1_A = mkA "tuvaluansk" ;
  tuvig_av_1_A = mkA "tuvig" ;
  tvekloes_av_1_1_A = mkA "tveklös" ;
  tvetydig_av_1_A = mkA "tvetydig" ;
  tvinsjuk_av_1_A = mkA "tvinsjuk" ;
  tvistig_av_1_A = mkA "tvistig" ;
  tvistlig_av_1_A = mkA "tvistlig" ;
  tvivelaktig_av_1_A = mkA "tvivelaktig" ;
  tvivelsjuk_av_1_A = mkA "tvivelsjuk" ;
  tvaer_av_1_1_A = mkA "tvär" ;
  tvaerarg_av_1_1_A = mkA "tvärarg" ;
  tvaerfacklig_av_1_1_A = mkA "tvärfacklig" ;
  tvaerfakultaer_av_1_1_A = mkA "tvärfakultär" ;
  tvaerkulturell_av_1_1_A = mkA "tvärkulturell" ;
  tvaerpolitisk_av_1_1_A = mkA "tvärpolitisk" ;
  tvaerrandig_av_1_1_A = mkA "tvärrandig" ;
  tvaervetenskaplig_av_1_1_A = mkA "tvärvetenskaplig" ;
  tvaettbar_av_1_1_A = mkA "tvättbar" ;
  tvaacylindrig_av_1_1_A = mkA "tvåcylindrig" ;
  tvaadimensionell_av_1_1_A = mkA "tvådimensionell" ;
  tvaaformig_av_1_1_A = mkA "tvåformig" ;
  tvaahjaertbladig_av_1_1_A = mkA "tvåhjärtbladig" ;
  tvaahaendig_av_1_1_A = mkA "tvåhändig" ;
  tvaalig_av_1_1_A = mkA "tvålig" ;
  tvaaloperamaessig_av_1_1_A = mkA "tvåloperamässig" ;
  tvaalaeppig_av_1_1_A = mkA "tvåläppig" ;
  tvaangfri_av_1_1_A = mkA "tvångfri" ;
  tvaangskommenderbar_av_1_1_A = mkA "tvångskommenderbar" ;
  tvaangsmaessig_av_1_1_A = mkA "tvångsmässig" ;
  tvaangsrekryterbar_av_1_1_A = mkA "tvångsrekryterbar" ;
  tvaangstatuerbar_av_1_1_A = mkA "tvångstatuerbar" ;
  tvaasiffrig_av_1_1_A = mkA "tvåsiffrig" ;
  tvaaspraakig_av_1_1_A = mkA "tvåspråkig" ;
  tvaastavig_av_1_1_A = mkA "tvåstavig" ;
  tydbar_av_1_A = mkA "tydbar" ;
  tydlig_av_1_A = mkA "tydlig" ;
  tygelloes_av_1_1_A = mkA "tygellös" ;
  tyngdloes_av_1_1_A = mkA "tyngdlös" ;
  typifierbar_av_1_A = mkA "typifierbar" ;
  typiserbar_av_1_A = mkA "typiserbar" ;
  typisk_av_1_A = mkA "typisk" ;
  tyranniserbar_av_1_A = mkA "tyranniserbar" ;
  tyrannisk_av_1_A = mkA "tyrannisk" ;
  tyrolsk_av_1_A = mkA "tyrolsk" ;
  tysk_av_1_A = mkA "tysk" ;
  taeck_av_1_1_A = mkA "täck" ;
  taeckelig_av_1_1_A = mkA "täckelig" ;
  taemlig_av_1_1_A = mkA "tämlig" ;
  taenjbar_av_1_1_A = mkA "tänjbar" ;
  taenkbar_av_1_1_A = mkA "tänkbar" ;
  taet_av_1_1_A = mkA "tät" ;
  taevlingsmaessig_av_1_1_A = mkA "tävlingsmässig" ;
  taalig_av_1_1_A = mkA "tålig" ;
  taalmodig_av_1_1_A = mkA "tålmodig" ;
  taarfull_av_1_1_A = mkA "tårfull" ;
  taarloes_av_1_1_A = mkA "tårlös" ;
  toecknig_av_1_1_A = mkA "töcknig" ;
  toeig_av_1_1_A = mkA "töig" ;
  toejbar_av_1_1_A = mkA "töjbar" ;
  toelpaktig_av_1_1_A = mkA "tölpaktig" ;
  toelpig_av_1_1_A = mkA "tölpig" ;
  toentig_av_1_1_A = mkA "töntig" ;
  toernig_av_1_1_A = mkA "törnig" ;
  toerstig_av_1_1_A = mkA "törstig" ;
  uddataaig_av_1_1_A = mkA "uddatåig" ;
  uddig_av_1_A = mkA "uddig" ;
  usel_av_1_A = mkA "usel" "uselt" "usla" "usla" "uslare" "uslast" "uslaste" ;
  aedel_av_1_1_A = mkA "ädel" "ädelt" "ädla" "ädla" "ädlare" "ädlast" "ädlaste" ;
  abrupt_av_1_A = mkA "abrupt" "abrupt" ;
  absolut_av_1_A = mkA "absolut" "absolut" ;
  abstrakt_av_1_A = mkA "abstrakt" "abstrakt" ;
  abundant_av_1_A = mkA "abundant" "abundant" ;
  ackurat_av_1_A = mkA "ackurat" "ackurat" ;
  adekvat_av_1_A = mkA "adekvat" "adekvat" ;
  akut_av_1_A = mkA "akut" "akut" ;
  alert_av_1_A = mkA "alert" "alert" ;
  allbekant_av_1_A = mkA "allbekant" "allbekant" ;
  allergen_av_1_A = mkA "allergen" "allergent" ;
  allmogeblaa_av_1_1_A = mkA "allmogeblå" "allmogeblått" ;
  ambivalent_av_1_A = mkA "ambivalent" "ambivalent" ;
  andtaeppt_av_1_1_A = mkA "andtäppt" "andtäppt" ;
  antibiotikaresistent_av_1_A = mkA "antibiotikaresistent" "antibiotikaresistent" ;
  apart_av_1_A = mkA "apart" "apart" ;
  apelgraa_av_1_1_A = mkA "apelgrå" "apelgrått" ;
  arbetsofoermoegen_av_1_1_A = mkA "arbetsoförmögen" "arbetsoförmöget" ;
  argsint_av_1_A = mkA "argsint" "argsint" ;
  arrogant_av_1_A = mkA "arrogant" "arrogant" ;
  askgraa_av_1_1_A = mkA "askgrå" "askgrått" ;
  atomdriven_av_1_A = mkA "atomdriven" "atomdrivet" ;
  avbiten_av_1_A = mkA "avbiten" "avbitet" ;
  avsutten_av_1_A = mkA "avsutten" "avsuttet" ;
  azurblaa_av_1_1_A = mkA "azurblå" "azurblått" ;
  ballongburen_av_1_A = mkA "ballongburen" "ballongburet" ;
  barbent_av_1_A = mkA "barbent" "barbent" ;
  bastant_av_1_A = mkA "bastant" "bastant" ;
  batteridriven_av_1_A = mkA "batteridriven" "batteridrivet" ;
  becksvart_av_1_A = mkA "becksvart" "becksvart" ;
  beige_av_1_A = mkA "beige" "beiget" ;
  bekant_av_1_A = mkA "bekant" "bekant" ;
  belaest_av_1_1_A = mkA "beläst" "beläst" ;
  bemaerkt_av_1_1_A = mkA "bemärkt" "bemärkt" ;
  bensindriven_av_1_A = mkA "bensindriven" "bensindrivet" ;
  berest_av_1_A = mkA "berest" "berest" ;
  bergfast_av_1_A = mkA "bergfast" "bergfast" ;
  beskaenkt_av_1_1_A = mkA "beskänkt" "beskänkt" ;
  bestoert_av_1_1_A = mkA "bestört" "bestört" ;
  betjaent_av_1_1_A = mkA "betjänt" "betjänt" ;
  betryckt_av_1_A = mkA "betryckt" "betryckt" ;
  betaenkt_av_1_1_A = mkA "betänkt" "betänkt" ;
  bevaext_av_1_1_A = mkA "beväxt" "beväxt" ;
  biogasdriven_av_1_A = mkA "biogasdriven" "biogasdrivet" ;
  biogen_av_1_A = mkA "biogen" "biogent" ;
  bittersalt_av_1_A = mkA "bittersalt" "bittersalt" ;
  bjaert_av_1_1_A = mkA "bjärt" "bjärt" ;
  blamant_av_1_A = mkA "blamant" "blamant" ;
  blodstaenkt_av_1_1_A = mkA "blodstänkt" "blodstänkt" ;
  blyertsgraa_av_1_1_A = mkA "blyertsgrå" "blyertsgrått" ;
  blygraa_av_1_1_A = mkA "blygrå" "blygrått" ;
  blaa_av_1_1_A = mkA "blå" "blått" ;
  blaagraa_av_1_1_A = mkA "blågrå" "blågrått" ;
  blaaslagen_av_1_1_A = mkA "blåslagen" "blåslaget" ;
  blaast_av_1_1_A = mkA "blåst" "blåst" ;
  blaasvart_av_1_1_A = mkA "blåsvart" "blåsvart" ;
  bloetsvart_av_1_1_A = mkA "blötsvart" "blötsvart" ;
  bockbent_av_1_A = mkA "bockbent" "bockbent" ;
  bofast_av_1_A = mkA "bofast" "bofast" ;
  boghalt_av_1_A = mkA "boghalt" "boghalt" ;
  boksynt_av_1_A = mkA "boksynt" "boksynt" ;
  bombfast_av_1_A = mkA "bombfast" "bombfast" ;
  bortblaast_av_1_1_A = mkA "bortblåst" "bortblåst" ;
  bortflugen_av_1_A = mkA "bortflugen" "bortfluget" ;
  bortrest_av_1_A = mkA "bortrest" "bortrest" ;
  bortryckt_av_1_A = mkA "bortryckt" "bortryckt" ;
  bortskjuten_av_1_A = mkA "bortskjuten" "bortskjutet" ;
  bottenfast_av_1_A = mkA "bottenfast" "bottenfast" ;
  brant_av_1_A = mkA "brant" "brant" ;
  bredbent_av_1_A = mkA "bredbent" "bredbent" ;
  bredmynt_av_1_A = mkA "bredmynt" "bredmynt" ;
  briljant_av_1_A = mkA "briljant" "briljant" ;
  brisant_av_1_A = mkA "brisant" "brisant" ;
  brunsvart_av_1_A = mkA "brunsvart" "brunsvart" ;
  braeckt_av_1_1_A = mkA "bräckt" "bräckt" ;
  braenslecellsdriven_av_1_1_A = mkA "bränslecellsdriven" "bränslecellsdrivet" ;
  buskbevuxen_av_1_A = mkA "buskbevuxen" "buskbevuxet" ;
  boerdsstolt_av_1_1_A = mkA "bördsstolt" "bördsstolt" ;
  camp_av_1_A = mkA "camp" "camp" ;
  cancerogen_av_1_A = mkA "cancerogen" "cancerogent" ;
  carcinogen_av_1_A = mkA "carcinogen" "carcinogent" ;
  celest_av_1_A = mkA "celest" "celest" ;
  charmant_av_1_A = mkA "charmant" "charmant" ;
  clairvoyant_av_1_A = mkA "clairvoyant" "clairvoyant" ;
  cyanblaa_av_1_1_A = mkA "cyanblå" "cyanblått" ;
  dansant_av_1_A = mkA "dansant" "dansant" ;
  darrhaent_av_1_1_A = mkA "darrhänt" "darrhänt" ;
  defekt_av_1_A = mkA "defekt" "defekt" ;
  definit_av_1_A = mkA "definit" "definit" ;
  dekadent_av_1_A = mkA "dekadent" "dekadent" ;
  delikat_av_1_A = mkA "delikat" "delikat" ;
  deltidssjukskriven_av_1_A = mkA "deltidssjukskriven" "deltidssjukskrivet" ;
  desperat_av_1_A = mkA "desperat" "desperat" ;
  devot_av_1_A = mkA "devot" "devot" ;
  dieseldriven_av_1_A = mkA "dieseldriven" "dieseldrivet" ;
  different_av_1_A = mkA "different" "different" ;
  dimblaa_av_1_1_A = mkA "dimblå" "dimblått" ;
  direkt_av_1_A = mkA "direkt" "direkt" ;
  disjunkt_av_1_A = mkA "disjunkt" "disjunkt" ;
  diskordant_av_1_A = mkA "diskordant" "diskordant" ;
  diskret_av_1_A = mkA "diskret" "diskret" ;
  disparat_av_1_A = mkA "disparat" "disparat" ;
  dissonant_av_1_A = mkA "dissonant" "dissonant" ;
  distinkt_av_1_A = mkA "distinkt" "distinkt" ;
  ditflugen_av_1_A = mkA "ditflugen" "ditfluget" ;
  divergent_av_1_A = mkA "divergent" "divergent" ;
  djupblaa_av_1_1_A = mkA "djupblå" "djupblått" ;
  djuptaenkt_av_1_1_A = mkA "djuptänkt" "djuptänkt" ;
  dominant_av_1_A = mkA "dominant" "dominant" ;
  druvblaa_av_1_1_A = mkA "druvblå" "druvblått" ;
  dunkelblaa_av_1_1_A = mkA "dunkelblå" "dunkelblått" ;
  durabel_av_1_A = mkA "durabel" "durabelt" ;
  duvblaa_av_1_1_A = mkA "duvblå" "duvblått" ;
  dyrkoept_av_1_1_A = mkA "dyrköpt" "dyrköpt" ;
  daest_av_1_1_A = mkA "däst" "däst" ;
  doedsfoerskraeckt_av_1_1_A = mkA "dödsförskräckt" "dödsförskräckt" ;
  doedsmaerkt_av_1_1_A = mkA "dödsmärkt" "dödsmärkt" ;
  doedstyst_av_1_1_A = mkA "dödstyst" "dödstyst" ;
  doefoerskraeckt_av_1_1_A = mkA "döförskräckt" "döförskräckt" ;
  doetyst_av_1_1_A = mkA "dötyst" "dötyst" ;
  eftersoekt_av_1_1_A = mkA "eftersökt" "eftersökt" ;
  eklatant_av_1_A = mkA "eklatant" "eklatant" ;
  ekvidistant_av_1_A = mkA "ekvidistant" "ekvidistant" ;
  ekvivalent_av_1_A = mkA "ekvivalent" "ekvivalent" ;
  eldfast_av_1_A = mkA "eldfast" "eldfast" ;
  eldriven_av_1_A = mkA "eldriven" "eldrivet" ;
  elegant_av_1_A = mkA "elegant" "elegant" ;
  elmotordriven_av_1_A = mkA "elmotordriven" "elmotordrivet" ;
  elokvent_av_1_A = mkA "elokvent" "elokvent" ;
  eminent_av_1_A = mkA "eminent" "eminent" ;
  enbent_av_1_A = mkA "enbent" "enbent" ;
  endogen_av_1_A = mkA "endogen" "endogent" ;
  enkelknaeppt_av_1_1_A = mkA "enkelknäppt" "enkelknäppt" ;
  enrisroekt_av_1_1_A = mkA "enrisrökt" "enrisrökt" ;
  erogen_av_1_A = mkA "erogen" "erogent" ;
  erotogen_av_1_A = mkA "erotogen" "erotogent" ;
  etanoldriven_av_1_A = mkA "etanoldriven" "etanoldrivet" ;
  evident_av_1_A = mkA "evident" "evident" ;
  exakt_av_1_A = mkA "exakt" "exakt" ;
  excellent_av_1_A = mkA "excellent" "excellent" ;
  exogen_av_1_A = mkA "exogen" "exogent" ;
  expedit_av_1_A = mkA "expedit" "expedit" ;
  explicit_av_1_A = mkA "explicit" "explicit" ;
  extrakontant_av_1_A = mkA "extrakontant" "extrakontant" ;
  extravagant_av_1_A = mkA "extravagant" "extravagant" ;
  extrovert_av_1_A = mkA "extrovert" "extrovert" ;
  fast_av_1_A = mkA "fast" "fast" ;
  fastlaast_av_1_1_A = mkA "fastlåst" "fastlåst" ;
  femdubbel_av_1_A = mkA "femdubben" "femdubbet" ;
  filttaeckt_av_1_1_A = mkA "filttäckt" "filttäckt" ;
  finhyllt_av_1_A = mkA "finhyllt" "finhyllt" ;
  finit_av_1_A = mkA "finit" "finit" ;
  finstilt_av_1_A = mkA "finstilt" "finstilt" ;
  flagrant_av_1_A = mkA "flagrant" "flagrant" ;
  flyhaent_av_1_1_A = mkA "flyhänt" "flyhänt" ;
  fosforescent_av_1_A = mkA "fosforescent" "fosforescent" ;
  framhjulsdriven_av_1_A = mkA "framhjulsdriven" "framhjulsdrivet" ;
  framsynt_av_1_A = mkA "framsynt" "framsynt" ;
  frappant_av_1_A = mkA "frappant" "frappant" ;
  frekvent_av_1_A = mkA "frekvent" "frekvent" ;
  fromsint_av_1_A = mkA "fromsint" "fromsint" ;
  fryst_av_1_A = mkA "fryst" "fryst" ;
  fraelst_av_1_1_A = mkA "frälst" "frälst" ;
  fraanaakt_av_1_1_A = mkA "frånåkt" "frånåkt" ;
  fullvaext_av_1_1_A = mkA "fullväxt" "fullväxt" ;
  fyrbent_av_1_A = mkA "fyrbent" "fyrbent" ;
  fyrhjulsdriven_av_1_A = mkA "fyrhjulsdriven" "fyrhjulsdrivet" ;
  fyrkluven_av_1_A = mkA "fyrkluven" "fyrkluvet" ;
  faeltgraa_av_1_1_A = mkA "fältgrå" "fältgrått" ;
  faest_av_1_1_A = mkA "fäst" "fäst" ;
  faamaelt_av_1_1_A = mkA "fåmält" "fåmält" ;
  foeranlaaten_av_1_1_A = mkA "föranlåten" "föranlåtet" ;
  foerkrympt_av_1_1_A = mkA "förkrympt" "förkrympt" ;
  foerlaest_av_1_1_A = mkA "förläst" "förläst" ;
  foerment_av_1_1_A = mkA "förment" "förment" ;
  foermoegen_av_2_1_A = mkA "förmögen" "förmöget" ;
  foerryckt_av_1_1_A = mkA "förryckt" "förryckt" ;
  foersanthaallen_av_1_1_A = mkA "försanthållen" "försanthållet" ;
  foerskraeckt_av_1_1_A = mkA "förskräckt" "förskräckt" ;
  foersynt_av_1_1_A = mkA "försynt" "försynt" ;
  foertent_av_1_1_A = mkA "förtent" "förtent" ;
  foertjust_av_1_1_A = mkA "förtjust" "förtjust" ;
  foertjaent_av_1_1_A = mkA "förtjänt" "förtjänt" ;
  foertaeckt_av_1_1_A = mkA "förtäckt" "förtäckt" ;
  foerunt_av_1_1_A = mkA "förunt" "förunt" ;
  foervaext_av_1_1_A = mkA "förväxt" "förväxt" ;
  gagatsvart_av_1_A = mkA "gagatsvart" "gagatsvart" ;
  galant_av_1_A = mkA "galant" "galant" ;
  gasdriven_av_1_A = mkA "gasdriven" "gasdrivet" ;
  gemen_av_1_A = mkA "gemen" "gement" ;
  genant_av_1_A = mkA "genant" "genant" ;
  genomstucken_av_1_A = mkA "genomstucken" "genomstucket" ;
  genomtryckt_av_1_A = mkA "genomtryckt" "genomtryckt" ;
  genomtaenkt_av_1_1_A = mkA "genomtänkt" "genomtänkt" ;
  gift_av_1_A = mkA "gift" "gift" ;
  girvaext_av_1_1_A = mkA "girväxt" "girväxt" ;
  gladlynt_av_1_A = mkA "gladlynt" "gladlynt" ;
  glasfiberfoerstaerkt_av_1_1_A = mkA "glasfiberförstärkt" "glasfiberförstärkt" ;
  glutenintolerant_av_1_A = mkA "glutenintolerant" "glutenintolerant" ;
  godlynt_av_1_A = mkA "godlynt" "godlynt" ;
  godsint_av_1_A = mkA "godsint" "godsint" ;
  golvfast_av_1_A = mkA "golvfast" "golvfast" ;
  grafitgraa_av_1_1_A = mkA "grafitgrå" "grafitgrått" ;
  grannsynt_av_1_A = mkA "grannsynt" "grannsynt" ;
  granntyckt_av_1_A = mkA "granntyckt" "granntyckt" ;
  graesbetaeckt_av_1_1_A = mkA "gräsbetäckt" "gräsbetäckt" ;
  graesbevuxen_av_1_1_A = mkA "gräsbevuxen" "gräsbevuxet" ;
  graa_av_1_1_A = mkA "grå" "grått" ;
  graablaa_av_1_1_A = mkA "gråblå" "gråblått" ;
  graasvart_av_1_1_A = mkA "gråsvart" "gråsvart" ;
  gudagiven_av_1_A = mkA "gudagiven" "gudagivet" ;
  gulgraa_av_1_1_A = mkA "gulgrå" "gulgrått" ;
  hallucinogen_av_1_A = mkA "hallucinogen" "hallucinogent" ;
  halt_av_1_A = mkA "halt" "halt" ;
  halvgalen_av_1_A = mkA "halvgalen" "halvgalet" ;
  halvrutten_av_1_A = mkA "halvrutten" "halvruttet" ;
  halvsmaelt_av_1_1_A = mkA "halvsmält" "halvsmält" ;
  halvtrist_av_1_A = mkA "halvtrist" "halvtrist" ;
  handfast_av_1_A = mkA "handfast" "handfast" ;
  handhaallen_av_1_1_A = mkA "handhållen" "handhållet" ;
  handknyten_av_1_A = mkA "handknyten" "handknytet" ;
  harmynt_av_1_A = mkA "harmynt" "harmynt" ;
  havsblaa_av_1_1_A = mkA "havsblå" "havsblått" ;
  helblaa_av_1_1_A = mkA "helblå" "helblått" ;
  helgjuten_av_2_A = mkA "helgjuten" "helgjutet" ;
  helikopterburen_av_1_A = mkA "helikopterburen" "helikopterburet" ;
  helstekt_av_1_A = mkA "helstekt" "helstekt" ;
  helsvart_av_1_A = mkA "helsvart" "helsvart" ;
  hembakt_av_1_A = mkA "hembakt" "hembakt" ;
  hemburen_av_1_A = mkA "hemburen" "hemburet" ;
  hemflugen_av_1_A = mkA "hemflugen" "hemfluget" ;
  heterogen_av_1_A = mkA "heterogen" "heterogent" ;
  heterozygot_av_1_A = mkA "heterozygot" "heterozygot" ;
  himmelsblaa_av_1_1_A = mkA "himmelsblå" "himmelsblått" ;
  hitflugen_av_1_A = mkA "hitflugen" "hitfluget" ;
  hjulbent_av_1_A = mkA "hjulbent" "hjulbent" ;
  homogen_av_1_A = mkA "homogen" "homogent" ;
  homozygot_av_1_A = mkA "homozygot" "homozygot" ;
  honungslen_av_1_A = mkA "honungslen" "honungslent" ;
  hophaallen_av_1_1_A = mkA "hophållen" "hophållet" ;
  hopknaeppt_av_1_1_A = mkA "hopknäppt" "hopknäppt" ;
  hopsnoerpt_av_1_1_A = mkA "hopsnörpt" "hopsnörpt" ;
  hopvaext_av_1_1_A = mkA "hopväxt" "hopväxt" ;
  hyperelegant_av_1_A = mkA "hyperelegant" "hyperelegant" ;
  hyperkorrekt_av_1_A = mkA "hyperkorrekt" "hyperkorrekt" ;
  haenryckt_av_1_1_A = mkA "hänryckt" "hänryckt" ;
  haallfast_av_1_1_A = mkA "hållfast" "hållfast" ;
  haardhaent_av_1_1_A = mkA "hårdhänt" "hårdhänt" ;
  haardkokt_av_1_1_A = mkA "hårdkokt" "hårdkokt" ;
  haardsmaelt_av_1_1_A = mkA "hårdsmält" "hårdsmält" ;
  hoegblaa_av_1_1_A = mkA "högblå" "högblått" ;
  hoegerhaent_av_1_1_A = mkA "högerhänt" "högerhänt" ;
  hoegfrekvent_av_1_1_A = mkA "högfrekvent" "högfrekvent" ;
  hoegintressant_av_1_1_A = mkA "högintressant" "högintressant" ;
  hoeglaent_av_1_1_A = mkA "höglänt" "höglänt" ;
  hoegrest_av_1_1_A = mkA "högrest" "högrest" ;
  hoegsint_av_1_1_A = mkA "högsint" "högsint" ;
  hoegvaext_av_1_1_A = mkA "högväxt" "högväxt" ;
  ifattsprungen_av_1_A = mkA "ifattsprungen" "ifattsprunget" ;
  ifraansprungen_av_1_1_A = mkA "ifrånsprungen" "ifrånsprunget" ;
  igenvaext_av_1_1_A = mkA "igenväxt" "igenväxt" ;
  ignorant_av_1_A = mkA "ignorant" "ignorant" ;
  ihjaelskjuten_av_1_1_A = mkA "ihjälskjuten" "ihjälskjutet" ;
  ihjaelslagen_av_1_1_A = mkA "ihjälslagen" "ihjälslaget" ;
  ilandfluten_av_1_A = mkA "ilandfluten" "ilandflutet" ;
  illitterat_av_1_A = mkA "illitterat" "illitterat" ;
  immanent_av_1_A = mkA "immanent" "immanent" ;
  impertinent_av_1_A = mkA "impertinent" "impertinent" ;
  implicit_av_1_A = mkA "implicit" "implicit" ;
  imposant_av_1_A = mkA "imposant" "imposant" ;
  impotent_av_1_A = mkA "impotent" "impotent" ;
  inadekvat_av_1_A = mkA "inadekvat" "inadekvat" ;
  indefinit_av_1_A = mkA "indefinit" "indefinit" ;
  indelt_av_1_A = mkA "indelt" "indelt" ;
  indifferent_av_1_A = mkA "indifferent" "indifferent" ;
  indirekt_av_1_A = mkA "indirekt" "indirekt" ;
  indiskret_av_1_A = mkA "indiskret" "indiskret" ;
  indolent_av_1_A = mkA "indolent" "indolent" ;
  inexakt_av_1_A = mkA "inexakt" "inexakt" ;
  infinit_av_1_A = mkA "infinit" "infinit" ;
  ingift_av_1_A = mkA "ingift" "ingift" ;
  inherent_av_1_A = mkA "inherent" "inherent" ;
  inkompetent_av_1_A = mkA "inkompetent" "inkompetent" ;
  inkongruent_av_1_A = mkA "inkongruent" "inkongruent" ;
  inkonsekvent_av_1_A = mkA "inkonsekvent" "inkonsekvent" ;
  inkonstant_av_1_A = mkA "inkonstant" "inkonstant" ;
  inkontinent_av_1_A = mkA "inkontinent" "inkontinent" ;
  inkorrekt_av_1_A = mkA "inkorrekt" "inkorrekt" ;
  inkroekt_av_1_1_A = mkA "inkrökt" "inkrökt" ;
  inkurabel_av_1_A = mkA "inkuraben" "inkurabet" ;
  inkurant_av_1_A = mkA "inkurant" "inkurant" ;
  inlaest_av_1_1_A = mkA "inläst" "inläst" ;
  insinuant_av_1_A = mkA "insinuant" "insinuant" ;
  inskraenkt_av_1_1_A = mkA "inskränkt" "inskränkt" ;
  insolvent_av_1_A = mkA "insolvent" "insolvent" ;
  insutten_av_1_A = mkA "insutten" "insuttet" ;
  intakt_av_1_A = mkA "intakt" "intakt" ;
  intelligent_av_1_A = mkA "intelligent" "intelligent" ;
  intermittent_av_1_A = mkA "intermittent" "intermittent" ;
  intolerant_av_1_A = mkA "intolerant" "intolerant" ;
  intransigent_av_1_A = mkA "intransigent" "intransigent" ;
  intressant_av_1_A = mkA "intressant" "intressant" ;
  intrigant_av_1_A = mkA "intrigant" "intrigant" ;
  intrikat_av_1_A = mkA "intrikat" "intrikat" ;
  introvert_av_1_A = mkA "introvert" "introvert" ;
  intryckt_av_1_A = mkA "intryckt" "intryckt" ;
  invariant_av_1_A = mkA "invariant" "invariant" ;
  invikt_av_1_A = mkA "invikt" "invikt" ;
  irrelevant_av_1_A = mkA "irrelevant" "irrelevant" ;
  isblaa_av_1_1_A = mkA "isblå" "isblått" ;
  istaeckt_av_1_1_A = mkA "istäckt" "istäckt" ;
  jordfast_av_1_A = mkA "jordfast" "jordfast" ;
  just_av_1_A = mkA "just" "just" ;
  jaemspelt_av_1_1_A = mkA "jämspelt" "jämspelt" ;
  jaetteschyst_av_1_1_A = mkA "jätteschyst" "jätteschyst" ;
  kamouflagegraa_av_1_1_A = mkA "kamouflagegrå" "kamouflagegrått" ;
  karaktaersfast_av_1_1_A = mkA "karaktärsfast" "karaktärsfast" ;
  karaktaersloes_av_1_1_A = mkA "karaktärslös" "karaktärslöt" ;
  kavat_av_1_A = mkA "kavat" "kavat" ;
  klarblaa_av_1_1_A = mkA "klarblå" "klarblått" ;
  klarsynt_av_1_A = mkA "klarsynt" "klarsynt" ;
  klartaenkt_av_1_1_A = mkA "klartänkt" "klartänkt" ;
  klimatsmart_av_1_A = mkA "klimatsmart" "klimatsmart" ;
  klaervoajant_av_1_1_A = mkA "klärvoajant" "klärvoajant" ;
  knaeckt_av_1_1_A = mkA "knäckt" "knäckt" ;
  knaekort_av_1_1_A = mkA "knäkort" "knäkort" ;
  knaepptyst_av_1_1_A = mkA "knäpptyst" "knäpptyst" ;
  kobent_av_1_A = mkA "kobent" "kobent" ;
  koftgraa_av_1_1_A = mkA "koftgrå" "koftgrått" ;
  koherent_av_1_A = mkA "koherent" "koherent" ;
  koksgraa_av_1_1_A = mkA "koksgrå" "koksgrått" ;
  kokt_av_1_A = mkA "kokt" "kokt" ;
  kolsvart_av_1_A = mkA "kolsvart" "kolsvart" ;
  kompakt_av_1_A = mkA "kompakt" "kompakt" ;
  kompetent_av_1_A = mkA "kompetent" "kompetent" ;
  konciliant_av_1_A = mkA "konciliant" "konciliant" ;
  kongruent_av_1_A = mkA "kongruent" "kongruent" ;
  konkret_av_1_A = mkA "konkret" "konkret" ;
  konsekvent_av_1_A = mkA "konsekvent" "konsekvent" ;
  konsiliant_av_1_A = mkA "konsiliant" "konsiliant" ;
  konsonant_av_1_A = mkA "konsonant" "konsonant" ;
  konstant_av_1_A = mkA "konstant" "konstant" ;
  kontant_av_1_A = mkA "kontant" "kontant" ;
  konvalescent_av_1_A = mkA "konvalescent" "konvalescent" ;
  konvergent_av_1_A = mkA "konvergent" "konvergent" ;
  kopplerimisstaenkt_av_1_1_A = mkA "kopplerimisstänkt" "kopplerimisstänkt" ;
  kornblaa_av_1_1_A = mkA "kornblå" "kornblått" ;
  korpsvart_av_1_A = mkA "korpsvart" "korpsvart" ;
  korpulent_av_1_A = mkA "korpulent" "korpulent" ;
  korrekt_av_1_A = mkA "korrekt" "korrekt" ;
  korrupt_av_1_A = mkA "korrupt" "korrupt" ;
  kort_av_1_A = mkA "kort" "kort" ;
  kortbent_av_1_A = mkA "kortbent" "kortbent" ;
  kortklippt_av_1_A = mkA "kortklippt" "kortklippt" ;
  kortkort_av_1_A = mkA "kortkort" "kortkort" ;
  kortsynt_av_1_A = mkA "kortsynt" "kortsynt" ;
  korttaenkt_av_1_1_A = mkA "korttänkt" "korttänkt" ;
  kortvaext_av_1_1_A = mkA "kortväxt" "kortväxt" ;
  kovalent_av_1_A = mkA "kovalent" "kovalent" ;
  kovert_av_1_A = mkA "kovert" "kovert" ;
  kringsynt_av_1_A = mkA "kringsynt" "kringsynt" ;
  krisgraa_av_1_1_A = mkA "krisgrå" "krisgrått" ;
  kroknaest_av_1_1_A = mkA "kroknäst" "kroknäst" ;
  kroekt_av_1_1_A = mkA "krökt" "krökt" ;
  kullfallen_av_1_A = mkA "kullfallen" "kullfallet" ;
  kuloert_av_1_1_A = mkA "kulört" "kulört" ;
  kungsblaa_av_1_1_A = mkA "kungsblå" "kungsblått" ;
  kurant_av_1_A = mkA "kurant" "kurant" ;
  kvicktaenkt_av_1_1_A = mkA "kvicktänkt" "kvicktänkt" ;
  kvinnoburen_av_1_A = mkA "kvinnoburen" "kvinnoburet" ;
  laktosintolerant_av_1_A = mkA "laktosintolerant" "laktosintolerant" ;
  landdriven_av_1_A = mkA "landdriven" "landdrivet" ;
  landfast_av_1_A = mkA "landfast" "landfast" ;
  latent_av_1_A = mkA "latent" "latent" ;
  lavendelblaa_av_1_1_A = mkA "lavendelblå" "lavendelblått" ;
  likbent_av_1_A = mkA "likbent" "likbent" ;
  litterat_av_1_A = mkA "litterat" "litterat" ;
  ljusblaa_av_1_1_A = mkA "ljusblå" "ljusblått" ;
  ljusgraa_av_1_1_A = mkA "ljusgrå" "ljusgrått" ;
  ljushyllt_av_1_A = mkA "ljushyllt" "ljushyllt" ;
  lossliten_av_1_A = mkA "lossliten" "losslitet" ;
  laederinbunden_av_1_1_A = mkA "läderinbunden" "läderinbundet" ;
  laettfoertjaent_av_1_1_A = mkA "lättförtjänt" "lättförtjänt" ;
  laettkokt_av_1_1_A = mkA "lättkokt" "lättkokt" ;
  laettkoept_av_1_1_A = mkA "lättköpt" "lättköpt" ;
  laettlaest_av_1_1_A = mkA "lättläst" "lättläst" ;
  laettloest_av_1_1_A = mkA "lättlöst" "lättlöst" ;
  laettroekt_av_1_1_A = mkA "lättrökt" "lättrökt" ;
  laettsjungen_av_1_1_A = mkA "lättsjungen" "lättsjunget" ;
  laettsmaelt_av_1_1_A = mkA "lättsmält" "lättsmält" ;
  laettstekt_av_1_1_A = mkA "lättstekt" "lättstekt" ;
  laettstruken_av_1_1_A = mkA "lättstruken" "lättstruket" ;
  laettvikt_av_1_1_A = mkA "lättvikt" "lättvikt" ;
  laagfrekvent_av_1_1_A = mkA "lågfrekvent" "lågfrekvent" ;
  laaghalt_av_1_1_A = mkA "låghalt" "låghalt" ;
  laaglaent_av_1_1_A = mkA "låglänt" "låglänt" ;
  laagsint_av_1_1_A = mkA "lågsint" "lågsint" ;
  laagvaext_av_1_1_A = mkA "lågväxt" "lågväxt" ;
  laangbent_av_1_1_A = mkA "långbent" "långbent" ;
  laangnaest_av_1_1_A = mkA "långnäst" "långnäst" ;
  laangsint_av_1_1_A = mkA "långsint" "långsint" ;
  laangstraeckt_av_1_1_A = mkA "långsträckt" "långsträckt" ;
  laangsynt_av_1_1_A = mkA "långsynt" "långsynt" ;
  laangsoekt_av_1_1_A = mkA "långsökt" "långsökt" ;
  laangtidssjukskriven_av_1_1_A = mkA "långtidssjukskriven" "långtidssjukskrivet" ;
  laant_av_1_1_A = mkA "lånt" "lånt" ;
  loesbruten_av_1_1_A = mkA "lösbruten" "lösbrutet" ;
  loeskokt_av_1_1_A = mkA "löskokt" "löskokt" ;
  loesmynt_av_1_1_A = mkA "lösmynt" "lösmynt" ;
  loesryckt_av_1_1_A = mkA "lösryckt" "lösryckt" ;
  loesslaeppt_av_1_1_A = mkA "lössläppt" "lössläppt" ;
  manifest_av_1_A = mkA "manifest" "manifest" ;
  marinblaa_av_1_1_A = mkA "marinblå" "marinblått" ;
  markant_av_1_A = mkA "markant" "markant" ;
  marknadsbaserad_av_1_A = mkA "marknadsbaserad" "marknadsbaseradt" ;
  mattsvart_av_1_A = mkA "mattsvart" "mattsvart" ;
  mellanblaa_av_1_1_A = mkA "mellanblå" "mellanblått" ;
  midnattsblaa_av_1_1_A = mkA "midnattsblå" "midnattsblått" ;
  mildsint_av_1_A = mkA "mildsint" "mildsint" ;
  militant_av_1_A = mkA "militant" "militant" ;
  mintblaa_av_1_1_A = mkA "mintblå" "mintblått" ;
  minutkort_av_1_A = mkA "minutkort" "minutkort" ;
  misslynt_av_1_A = mkA "misslynt" "misslynt" ;
  misstaenkt_av_1_1_A = mkA "misstänkt" "misstänkt" ;
  mjoelksvullen_av_1_1_A = mkA "mjölksvullen" "mjölksvullet" ;
  moderat_av_1_A = mkA "moderat" "moderat" ;
  modest_av_1_A = mkA "modest" "modest" ;
  moltyst_av_1_A = mkA "moltyst" "moltyst" ;
  mordmisstaenkt_av_1_1_A = mkA "mordmisstänkt" "mordmisstänkt" ;
  motordriven_av_1_A = mkA "motordriven" "motordrivet" ;
  multiresistent_av_1_A = mkA "multiresistent" "multiresistent" ;
  muromsluten_av_1_A = mkA "muromsluten" "muromslutet" ;
  musgraa_av_1_1_A = mkA "musgrå" "musgrått" ;
  mutmisstaenkt_av_1_1_A = mkA "mutmisstänkt" "mutmisstänkt" ;
  maanbelyst_av_1_1_A = mkA "månbelyst" "månbelyst" ;
  maangalen_av_1_1_A = mkA "mångalen" "mångalet" ;
  moerkblaa_av_1_1_A = mkA "mörkblå" "mörkblått" ;
  nattblaa_av_1_1_A = mkA "nattblå" "nattblått" ;
  nattsvart_av_1_A = mkA "nattsvart" "nattsvart" ;
  naturgiven_av_1_A = mkA "naturgiven" "naturgivet" ;
  nedrest_av_1_A = mkA "nedrest" "nedrest" ;
  nedtryckt_av_1_A = mkA "nedtryckt" "nedtryckt" ;
  nertryckt_av_1_A = mkA "nertryckt" "nertryckt" ;
  niodubbel_av_1_A = mkA "niodubben" "niodubbet" ;
  njugghaent_av_1_1_A = mkA "njugghänt" "njugghänt" ;
  nonchalant_av_1_A = mkA "nonchalant" "nonchalant" ;
  notfast_av_1_A = mkA "notfast" "notfast" ;
  nyavgaangen_av_1_1_A = mkA "nyavgången" "nyavgånget" ;
  nygift_av_1_A = mkA "nygift" "nygift" ;
  nyinkoept_av_1_1_A = mkA "nyinköpt" "nyinköpt" ;
  nyklippt_av_1_A = mkA "nyklippt" "nyklippt" ;
  nyskriven_av_1_A = mkA "nyskriven" "nyskrivet" ;
  nytagen_av_1_A = mkA "nytagen" "nytaget" ;
  nyupptaeckt_av_1_1_A = mkA "nyupptäckt" "nyupptäckt" ;
  naersynt_av_1_1_A = mkA "närsynt" "närsynt" ;
  oanloept_av_1_1_A = mkA "oanlöpt" "oanlöpt" ;
  oanmaerkt_av_1_1_A = mkA "oanmärkt" "oanmärkt" ;
  oansoekt_av_1_1_A = mkA "oansökt" "oansökt" ;
  oavblaast_av_1_1_A = mkA "oavblåst" "oavblåst" ;
  oavhjaelpt_av_1_1_A = mkA "oavhjälpt" "oavhjälpt" ;
  oavhyst_av_1_A = mkA "oavhyst" "oavhyst" ;
  oavlyst_av_1_A = mkA "oavlyst" "oavlyst" ;
  oavloept_av_1_1_A = mkA "oavlöpt" "oavlöpt" ;
  oavloest_av_1_1_A = mkA "oavlöst" "oavlöst" ;
  oavrest_av_1_A = mkA "oavrest" "oavrest" ;
  oavskraeckt_av_1_1_A = mkA "oavskräckt" "oavskräckt" ;
  oavstyrkt_av_1_A = mkA "oavstyrkt" "oavstyrkt" ;
  oavsoekt_av_1_1_A = mkA "oavsökt" "oavsökt" ;
  oavtaeckt_av_1_1_A = mkA "oavtäckt" "oavtäckt" ;
  obannlyst_av_1_A = mkA "obannlyst" "obannlyst" ;
  obeglaenst_av_1_1_A = mkA "obeglänst" "obeglänst" ;
  obekant_av_1_A = mkA "obekant" "obekant" ;
  obekroent_av_1_1_A = mkA "obekrönt" "obekrönt" ;
  obelyst_av_1_A = mkA "obelyst" "obelyst" ;
  obemaerkt_av_1_1_A = mkA "obemärkt" "obemärkt" ;
  obestyrkt_av_1_A = mkA "obestyrkt" "obestyrkt" ;
  obestaenkt_av_1_1_A = mkA "obestänkt" "obestänkt" ;
  obesoekt_av_1_1_A = mkA "obesökt" "obesökt" ;
  obetryckt_av_1_A = mkA "obetryckt" "obetryckt" ;
  obetaeckt_av_1_1_A = mkA "obetäckt" "obetäckt" ;
  obetaenkt_av_1_1_A = mkA "obetänkt" "obetänkt" ;
  obistraeckt_av_1_1_A = mkA "obisträckt" "obisträckt" ;
  oblekt_av_1_A = mkA "oblekt" "oblekt" ;
  obligat_av_1_A = mkA "obligat" "obligat" ;
  oblaast_av_1_1_A = mkA "oblåst" "oblåst" ;
  obrynt_av_1_A = mkA "obrynt" "obrynt" ;
  obraeckt_av_1_1_A = mkA "obräckt" "obräckt" ;
  observant_av_1_A = mkA "observant" "observant" ;
  obskurant_av_1_A = mkA "obskurant" "obskurant" ;
  obsolet_av_1_A = mkA "obsolet" "obsolet" ;
  obstinat_av_1_A = mkA "obstinat" "obstinat" ;
  ockult_av_1_A = mkA "ockult" "ockult" ;
  odriven_av_1_A = mkA "odriven" "odrivet" ;
  odraenkt_av_1_1_A = mkA "odränkt" "odränkt" ;
  odraept_av_1_1_A = mkA "odräpt" "odräpt" ;
  odaenkt_av_1_1_A = mkA "odänkt" "odänkt" ;
  odoept_av_1_1_A = mkA "odöpt" "odöpt" ;
  oefterlyst_av_1_A = mkA "oefterlyst" "oefterlyst" ;
  oefterskaenkt_av_1_1_A = mkA "oefterskänkt" "oefterskänkt" ;
  oeftersoekt_av_1_1_A = mkA "oeftersökt" "oeftersökt" ;
  oflaekt_av_1_1_A = mkA "ofläkt" "ofläkt" ;
  ofrimaerkt_av_1_1_A = mkA "ofrimärkt" "ofrimärkt" ;
  ofraelst_av_1_1_A = mkA "ofrälst" "ofrälst" ;
  ofraest_av_1_1_A = mkA "ofräst" "ofräst" ;
  ofoerkrympt_av_1_1_A = mkA "oförkrympt" "oförkrympt" ;
  ofoerlikt_av_1_1_A = mkA "oförlikt" "oförlikt" ;
  ofoerlist_av_1_1_A = mkA "oförlist" "oförlist" ;
  ofoerloest_av_1_1_A = mkA "oförlöst" "oförlöst" ;
  ofoermaerkt_av_1_1_A = mkA "oförmärkt" "oförmärkt" ;
  ofoerryckt_av_1_1_A = mkA "oförryckt" "oförryckt" ;
  ofoerskraeckt_av_1_1_A = mkA "oförskräckt" "oförskräckt" ;
  ofoerstraeckt_av_1_1_A = mkA "oförsträckt" "oförsträckt" ;
  ofoerstaerkt_av_1_1_A = mkA "oförstärkt" "oförstärkt" ;
  ofoersynt_av_1_1_A = mkA "oförsynt" "oförsynt" ;
  ofoersaenkt_av_1_1_A = mkA "oförsänkt" "oförsänkt" ;
  ofoertjust_av_1_1_A = mkA "oförtjust" "oförtjust" ;
  ofoertjaent_av_1_1_A = mkA "oförtjänt" "oförtjänt" ;
  ofoertryckt_av_1_1_A = mkA "oförtryckt" "oförtryckt" ;
  ofoertyckt_av_1_1_A = mkA "oförtyckt" "oförtyckt" ;
  ofoertaeckt_av_1_1_A = mkA "oförtäckt" "oförtäckt" ;
  ofoertaenkt_av_1_1_A = mkA "oförtänkt" "oförtänkt" ;
  ofoest_av_1_1_A = mkA "oföst" "oföst" ;
  ogenomlyst_av_1_A = mkA "ogenomlyst" "ogenomlyst" ;
  ogenomsoekt_av_1_1_A = mkA "ogenomsökt" "ogenomsökt" ;
  ogenomtaenkt_av_1_1_A = mkA "ogenomtänkt" "ogenomtänkt" ;
  ogift_av_1_A = mkA "ogift" "ogift" ;
  ogulden_av_1_A = mkA "ogulden" "oguldet" ;
  ohemsoekt_av_1_1_A = mkA "ohemsökt" "ohemsökt" ;
  ohjaelpt_av_1_1_A = mkA "ohjälpt" "ohjälpt" ;
  ohyst_av_1_A = mkA "ohyst" "ohyst" ;
  ohaenryckt_av_1_1_A = mkA "ohänryckt" "ohänryckt" ;
  oindraenkt_av_1_1_A = mkA "oindränkt" "oindränkt" ;
  oinhyst_av_1_A = mkA "oinhyst" "oinhyst" ;
  oinkoept_av_1_1_A = mkA "oinköpt" "oinköpt" ;
  oinloept_av_1_1_A = mkA "oinlöpt" "oinlöpt" ;
  oinloest_av_1_1_A = mkA "oinlöst" "oinlöst" ;
  oinskraenkt_av_1_1_A = mkA "oinskränkt" "oinskränkt" ;
  oinskaerpt_av_1_1_A = mkA "oinskärpt" "oinskärpt" ;
  oinsvept_av_1_A = mkA "oinsvept" "oinsvept" ;
  ointelligent_av_1_A = mkA "ointelligent" "ointelligent" ;
  ointressant_av_1_A = mkA "ointressant" "ointressant" ;
  ojust_av_1_A = mkA "ojust" "ojust" ;
  ojaest_av_1_1_A = mkA "ojäst" "ojäst" ;
  oklippt_av_1_A = mkA "oklippt" "oklippt" ;
  oklaeckt_av_1_1_A = mkA "okläckt" "okläckt" ;
  okloest_av_1_1_A = mkA "oklöst" "oklöst" ;
  oknyckt_av_1_A = mkA "oknyckt" "oknyckt" ;
  oknaeckt_av_1_1_A = mkA "oknäckt" "oknäckt" ;
  oknaeppt_av_1_1_A = mkA "oknäppt" "oknäppt" ;
  okokt_av_1_A = mkA "okokt" "okokt" ;
  okontant_av_1_A = mkA "okontant" "okontant" ;
  okrympt_av_1_A = mkA "okrympt" "okrympt" ;
  okraenkt_av_1_1_A = mkA "okränkt" "okränkt" ;
  okroekt_av_1_1_A = mkA "okrökt" "okrökt" ;
  okroent_av_1_1_A = mkA "okrönt" "okrönt" ;
  okvaest_av_1_1_A = mkA "okväst" "okväst" ;
  okysst_av_1_A = mkA "okysst" "okysst" ;
  okoept_av_1_1_A = mkA "oköpt" "oköpt" ;
  olyst_av_1_A = mkA "olyst" "olyst" ;
  olaeckt_av_1_1_A = mkA "oläckt" "oläckt" ;
  olaekt_av_1_1_A = mkA "oläkt" "oläkt" ;
  olaest_av_1_1_A = mkA "oläst" "oläst" ;
  olaast_av_1_1_A = mkA "olåst" "olåst" ;
  oloent_av_1_1_A = mkA "olönt" "olönt" ;
  oloest_av_1_1_A = mkA "olöst" "olöst" ;
  omfluten_av_1_A = mkA "omfluten" "omflutet" ;
  omgift_av_1_A = mkA "omgift" "omgift" ;
  omkulldragen_av_1_A = mkA "omkulldragen" "omkulldraget" ;
  omkullfallen_av_1_A = mkA "omkullfallen" "omkullfallet" ;
  omotlaest_av_1_1_A = mkA "omotläst" "omotläst" ;
  omtyckt_av_1_A = mkA "omtyckt" "omtyckt" ;
  omaerkt_av_1_1_A = mkA "omärkt" "omärkt" ;
  ondsint_av_1_A = mkA "ondsint" "ondsint" ;
  onedblaast_av_1_1_A = mkA "onedblåst" "onedblåst" ;
  onedsaenkt_av_1_1_A = mkA "onedsänkt" "onedsänkt" ;
  onerblaast_av_1_1_A = mkA "onerblåst" "onerblåst" ;
  onersaenkt_av_1_1_A = mkA "onersänkt" "onersänkt" ;
  onaepst_av_1_1_A = mkA "onäpst" "onäpst" ;
  oomstoept_av_1_1_A = mkA "oomstöpt" "oomstöpt" ;
  oomsvept_av_1_A = mkA "oomsvept" "oomsvept" ;
  oppklippt_av_1_A = mkA "oppklippt" "oppklippt" ;
  oppknaeppt_av_1_1_A = mkA "oppknäppt" "oppknäppt" ;
  oppsutten_av_1_A = mkA "oppsutten" "oppsuttet" ;
  oppvikt_av_1_A = mkA "oppvikt" "oppvikt" ;
  oppaakt_av_1_1_A = mkA "oppåkt" "oppåkt" ;
  opulent_av_1_A = mkA "opulent" "opulent" ;
  orest_av_1_A = mkA "orest" "orest" ;
  oraeckt_av_1_1_A = mkA "oräckt" "oräckt" ;
  oroekt_av_1_1_A = mkA "orökt" "orökt" ;
  oroent_av_1_1_A = mkA "orönt" "orönt" ;
  osammanloept_av_1_1_A = mkA "osammanlöpt" "osammanlöpt" ;
  osammantryckt_av_1_A = mkA "osammantryckt" "osammantryckt" ;
  osammanvaext_av_1_1_A = mkA "osammanväxt" "osammanväxt" ;
  oslaeckt_av_1_1_A = mkA "osläckt" "osläckt" ;
  osmaelt_av_1_1_A = mkA "osmält" "osmält" ;
  ostyrkt_av_1_A = mkA "ostyrkt" "ostyrkt" ;
  ostaerkt_av_1_1_A = mkA "ostärkt" "ostärkt" ;
  osoekt_av_1_1_A = mkA "osökt" "osökt" ;
  otryckt_av_1_A = mkA "otryckt" "otryckt" ;
  oupplyst_av_1_A = mkA "oupplyst" "oupplyst" ;
  oupptaeckt_av_1_1_A = mkA "oupptäckt" "oupptäckt" ;
  outvaext_av_1_1_A = mkA "outväxt" "outväxt" ;
  ooevertaenkt_av_1_1_A = mkA "oövertänkt" "oövertänkt" ;
  parant_av_1_A = mkA "parant" "parant" ;
  parat_av_1_A = mkA "parat" "parat" ;
  partiobunden_av_1_A = mkA "partiobunden" "partiobundet" ;
  perfekt_av_1_A = mkA "perfekt" "perfekt" ;
  permanent_av_1_A = mkA "permanent" "permanent" ;
  pikant_av_1_A = mkA "pikant" "pikant" ;
  plattnaest_av_1_1_A = mkA "plattnäst" "plattnäst" ;
  pluripotent_av_1_A = mkA "pluripotent" "pluripotent" ;
  potent_av_1_A = mkA "potent" "potent" ;
  pregnant_av_1_A = mkA "pregnant" "pregnant" ;
  present_av_1_A = mkA "present" "present" ;
  principfast_av_1_A = mkA "principfast" "principfast" ;
  privat_av_1_A = mkA "privat" "privat" ;
  probat_av_1_A = mkA "probat" "probat" ;
  prognat_av_1_A = mkA "prognat" "prognat" ;
  prominent_av_1_A = mkA "prominent" "prominent" ;
  paerlgraa_av_1_1_A = mkA "pärlgrå" "pärlgrått" ;
  paerlsvart_av_1_1_A = mkA "pärlsvart" "pärlsvart" ;
  paalaest_av_1_1_A = mkA "påläst" "påläst" ;
  paataenkt_av_1_1_A = mkA "påtänkt" "påtänkt" ;
  rabiat_av_1_A = mkA "rabiat" "rabiat" ;
  radiofrekvent_av_1_A = mkA "radiofrekvent" "radiofrekvent" ;
  raljant_av_1_A = mkA "raljant" "raljant" ;
  ramsvart_av_1_A = mkA "ramsvart" "ramsvart" ;
  recent_av_1_A = mkA "recent" "recent" ;
  redundant_av_1_A = mkA "redundant" "redundant" ;
  reformert_av_1_A = mkA "reformert" "reformert" ;
  regeringstrogen_av_1_A = mkA "regeringstrogen" "regeringstroget" ;
  regngraa_av_1_1_A = mkA "regngrå" "regngrått" ;
  relevant_av_1_A = mkA "relevant" "relevant" ;
  remittent_av_1_A = mkA "remittent" "remittent" ;
  resistent_av_1_A = mkA "resistent" "resistent" ;
  resolut_av_1_A = mkA "resolut" "resolut" ;
  riksbekant_av_1_A = mkA "riksbekant" "riksbekant" ;
  robust_av_1_A = mkA "robust" "robust" ;
  rotfast_av_1_A = mkA "rotfast" "rotfast" ;
  rullstolsburen_av_1_A = mkA "rullstolsburen" "rullstolsburet" ;
  rundhyllt_av_1_A = mkA "rundhyllt" "rundhyllt" ;
  rundhaent_av_1_1_A = mkA "rundhänt" "rundhänt" ;
  roedblaa_av_1_1_A = mkA "rödblå" "rödblått" ;
  roednaest_av_1_1_A = mkA "rödnäst" "rödnäst" ;
  roekblaa_av_1_1_A = mkA "rökblå" "rökblått" ;
  roekgraa_av_1_1_A = mkA "rökgrå" "rökgrått" ;
  roekt_av_1_1_A = mkA "rökt" "rökt" ;
  sabelbent_av_1_A = mkA "sabelbent" "sabelbent" ;
  sakrosankt_av_1_A = mkA "sakrosankt" "sakrosankt" ;
  sakrosant_av_1_A = mkA "sakrosant" "sakrosant" ;
  salt_av_1_A = mkA "salt" "salt" ;
  saltstaenkt_av_1_1_A = mkA "saltstänkt" "saltstänkt" ;
  sammanbragt_av_1_A = mkA "sammanbragt" "sammanbragt" ;
  sammansvuren_av_1_A = mkA "sammansvuren" "sammansvuret" ;
  samspelt_av_1_A = mkA "samspelt" "samspelt" ;
  sankt_av_1_A = mkA "sankt" "sankt" ;
  schysst_av_1_A = mkA "schysst" "schysst" ;
  schyst_av_1_A = mkA "schyst" "schyst" ;
  segerkroent_av_1_1_A = mkA "segerkrönt" "segerkrönt" ;
  sekret_av_1_A = mkA "sekret" "sekret" ;
  separat_av_1_A = mkA "separat" "separat" ;
  sexdubbel_av_1_A = mkA "sexdubben" "sexdubbet" ;
  sidlaent_av_1_1_A = mkA "sidlänt" "sidlänt" ;
  signifikant_av_1_A = mkA "signifikant" "signifikant" ;
  silvergraa_av_1_1_A = mkA "silvergrå" "silvergrått" ;
  sjudubbel_av_1_A = mkA "sjudubben" "sjudubbet" ;
  sjyst_av_1_A = mkA "sjyst" "sjyst" ;
  sjaelvfoersjunken_av_1_1_A = mkA "självförsjunken" "självförsjunket" ;
  sjoedraenkt_av_1_1_A = mkA "sjödränkt" "sjödränkt" ;
  skarpsynt_av_1_A = mkA "skarpsynt" "skarpsynt" ;
  skiffergraa_av_1_1_A = mkA "skiffergrå" "skiffergrått" ;
  skaerpt_av_1_1_A = mkA "skärpt" "skärpt" ;
  slapphaent_av_1_1_A = mkA "slapphänt" "slapphänt" ;
  slavdriven_av_1_A = mkA "slavdriven" "slavdrivet" ;
  slaepphaent_av_1_1_A = mkA "släpphänt" "släpphänt" ;
  sloesint_av_1_1_A = mkA "slösint" "slösint" ;
  smart_av_1_A = mkA "smart" "smart" ;
  smutsgraa_av_1_1_A = mkA "smutsgrå" "smutsgrått" ;
  smaert_av_1_1_A = mkA "smärt" "smärt" ;
  smaasint_av_1_1_A = mkA "småsint" "småsint" ;
  smaavaext_av_1_1_A = mkA "småväxt" "småväxt" ;
  snabbtaenkt_av_1_1_A = mkA "snabbtänkt" "snabbtänkt" ;
  snartaenkt_av_1_1_A = mkA "snartänkt" "snartänkt" ;
  snoetaeckt_av_1_1_A = mkA "snötäckt" "snötäckt" ;
  solbelyst_av_1_A = mkA "solbelyst" "solbelyst" ;
  solblekt_av_1_A = mkA "solblekt" "solblekt" ;
  solcellsdriven_av_1_A = mkA "solcellsdriven" "solcellsdrivet" ;
  solkraftsdriven_av_1_A = mkA "solkraftsdriven" "solkraftsdrivet" ;
  solstekt_av_1_A = mkA "solstekt" "solstekt" ;
  solvent_av_1_A = mkA "solvent" "solvent" ;
  sotsvart_av_1_A = mkA "sotsvart" "sotsvart" ;
  spaedvuxen_av_1_1_A = mkA "spädvuxen" "spädvuxet" ;
  spaarbunden_av_1_1_A = mkA "spårbunden" "spårbundet" ;
  stelbent_av_1_A = mkA "stelbent" "stelbent" ;
  stenbunden_av_1_A = mkA "stenbunden" "stenbundet" ;
  stentrist_av_1_A = mkA "stentrist" "stentrist" ;
  stolt_av_1_A = mkA "stolt" "stolt" ;
  stormfoertjust_av_1_1_A = mkA "stormförtjust" "stormförtjust" ;
  storsint_av_1_A = mkA "storsint" "storsint" ;
  storstilt_av_1_A = mkA "storstilt" "storstilt" ;
  storvaext_av_1_1_A = mkA "storväxt" "storväxt" ;
  strakbent_av_1_A = mkA "strakbent" "strakbent" ;
  strikt_av_1_A = mkA "strikt" "strikt" ;
  stringent_av_1_A = mkA "stringent" "stringent" ;
  styvsint_av_1_A = mkA "styvsint" "styvsint" ;
  staalblaa_av_1_1_A = mkA "stålblå" "stålblått" ;
  staalgraa_av_1_1_A = mkA "stålgrå" "stålgrått" ;
  suckulent_av_1_A = mkA "suckulent" "suckulent" ;
  suspekt_av_1_A = mkA "suspekt" "suspekt" ;
  svagsint_av_1_A = mkA "svagsint" "svagsint" ;
  svagsynt_av_1_A = mkA "svagsynt" "svagsynt" ;
  svart_av_1_A = mkA "svart" "svart" ;
  svaarlaest_av_1_1_A = mkA "svårläst" "svårläst" ;
  svaarloest_av_1_1_A = mkA "svårlöst" "svårlöst" ;
  svaarsmaelt_av_1_1_A = mkA "svårsmält" "svårsmält" ;
  svaarupptaeckt_av_1_1_A = mkA "svårupptäckt" "svårupptäckt" ;
  syrafast_av_1_A = mkA "syrafast" "syrafast" ;
  saellsynt_av_1_1_A = mkA "sällsynt" "sällsynt" ;
  soekt_av_1_1_A = mkA "sökt" "sökt" ;
  soenderskjuten_av_1_1_A = mkA "sönderskjuten" "sönderskjutet" ;
  soendersutten_av_1_1_A = mkA "söndersutten" "söndersuttet" ;
  tajt_av_1_A = mkA "tajt" "tajt" ;
  taktfast_av_1_A = mkA "taktfast" "taktfast" ;
  terrormisstaenkt_av_1_1_A = mkA "terrormisstänkt" "terrormisstänkt" ;
  tight_av_1_A = mkA "tight" "tight" ;
  tillbakahaallen_av_1_1_A = mkA "tillbakahållen" "tillbakahållet" ;
  tillbakaslagen_av_1_A = mkA "tillbakaslagen" "tillbakaslaget" ;
  tillklippt_av_1_A = mkA "tillklippt" "tillklippt" ;
  tillknaeppt_av_1_1_A = mkA "tillknäppt" "tillknäppt" ;
  tillrest_av_1_A = mkA "tillrest" "tillrest" ;
  tilltaenkt_av_1_1_A = mkA "tilltänkt" "tilltänkt" ;
  tolerant_av_1_A = mkA "tolerant" "tolerant" ;
  tomhaent_av_1_1_A = mkA "tomhänt" "tomhänt" ;
  tortyrmisstaenkt_av_1_1_A = mkA "tortyrmisstänkt" "tortyrmisstänkt" ;
  transcendent_av_1_A = mkA "transcendent" "transcendent" ;
  transparent_av_1_A = mkA "transparent" "transparent" ;
  traselegant_av_1_A = mkA "traselegant" "traselegant" ;
  trebent_av_1_A = mkA "trebent" "trebent" ;
  trist_av_1_A = mkA "trist" "trist" ;
  trofast_av_1_A = mkA "trofast" "trofast" ;
  trosfast_av_1_A = mkA "trosfast" "trosfast" ;
  trubbnaest_av_1_1_A = mkA "trubbnäst" "trubbnäst" ;
  tryckluftsdriven_av_1_A = mkA "tryckluftsdriven" "tryckluftsdrivet" ;
  tryckt_av_1_A = mkA "tryckt" "tryckt" ;
  traangsint_av_1_1_A = mkA "trångsint" "trångsint" ;
  traangsynt_av_1_1_A = mkA "trångsynt" "trångsynt" ;
  troeglaest_av_1_1_A = mkA "trögläst" "trögläst" ;
  troegtaenkt_av_1_1_A = mkA "trögtänkt" "trögtänkt" ;
  tunglaest_av_1_1_A = mkA "tungläst" "tungläst" ;
  tungsint_av_1_A = mkA "tungsint" "tungsint" ;
  turbulent_av_1_A = mkA "turbulent" "turbulent" ;
  turkosblaa_av_1_1_A = mkA "turkosblå" "turkosblått" ;
  tvaerbrant_av_1_1_A = mkA "tvärbrant" "tvärbrant" ;
  tvaersvart_av_1_1_A = mkA "tvärsvart" "tvärsvart" ;
  tvaabent_av_1_1_A = mkA "tvåbent" "tvåbent" ;
  tvaahaent_av_1_1_A = mkA "tvåhänt" "tvåhänt" ;
  tvaangsgift_av_1_1_A = mkA "tvångsgift" "tvångsgift" ;
  tvaangsintagen_av_1_1_A = mkA "tvångsintagen" "tvångsintaget" ;
  tyst_av_1_A = mkA "tyst" "tyst" ;
  taeckt_av_1_1_A = mkA "täckt" "täckt" ;
  taeppt_av_1_1_A = mkA "täppt" "täppt" ;
  taettklippt_av_1_1_A = mkA "tättklippt" "tättklippt" ;
  taardraenkt_av_1_1_A = mkA "tårdränkt" "tårdränkt" ;
  toernekroent_av_1_1_A = mkA "törnekrönt" "törnekrönt" ;
  ugnseldfast_av_1_A = mkA "ugnseldfast" "ugnseldfast" ;
  ugnsfast_av_1_A = mkA "ugnsfast" "ugnsfast" ;
  ultimat_av_1_A = mkA "ultimat" "ultimat" ;
  uppblaast_av_1_1_A = mkA "uppblåst" "uppblåst" ;
  uppbragt_av_1_A = mkA "uppbragt" "uppbragt" ;
  uppdriven_av_1_A = mkA "uppdriven" "uppdrivet" ;
  uppklippt_av_1_A = mkA "uppklippt" "uppklippt" ;
  uppknaeppt_av_1_1_A = mkA "uppknäppt" "uppknäppt" ;
  upplyst_av_1_A = mkA "upplyst" "upplyst" ;
  uppnaest_av_1_1_A = mkA "uppnäst" "uppnäst" ;
  uppslagen_av_1_A = mkA "uppslagen" "uppslaget" ;
  uppspelt_av_1_A = mkA "uppspelt" "uppspelt" ;
  uppstraeckt_av_1_1_A = mkA "uppsträckt" "uppsträckt" ;
  uppsutten_av_1_A = mkA "uppsutten" "uppsuttet" ;
  uppvikt_av_1_A = mkA "uppvikt" "uppvikt" ;
  uppaakt_av_1_1_A = mkA "uppåkt" "uppåkt" ;
  urblekt_av_1_A = mkA "urblekt" "urblekt" ;
  urblaast_av_1_1_A = mkA "urblåst" "urblåst" ;
  urgroept_av_1_1_A = mkA "urgröpt" "urgröpt" ;
  urkokt_av_1_A = mkA "urkokt" "urkokt" ;
  ursupen_av_1_A = mkA "ursupen" "ursupet" ;
  urtrist_av_1_A = mkA "urtrist" "urtrist" ;
  urvaext_av_1_1_A = mkA "urväxt" "urväxt" ;
  utfryst_av_1_A = mkA "utfryst" "utfryst" ;
  utmaerkt_av_1_1_A = mkA "utmärkt" "utmärkt" ;
  utskuren_av_1_A = mkA "utskuren" "utskuret" ;
  utstaanden_av_1_1_A = mkA "utstånden" "utståndet" ;
  utsoekt_av_1_1_A = mkA "utsökt" "utsökt" ;
  uttjaent_av_1_1_A = mkA "uttjänt" "uttjänt" ;
  uttaenkt_av_1_1_A = mkA "uttänkt" "uttänkt" ;
  vakant_av_1_A = mkA "vakant" "vakant" ;
  valhaent_av_1_1_A = mkA "valhänt" "valhänt" ;
  valnoetsgraa_av_1_1_A = mkA "valnötsgrå" "valnötsgrått" ;
  vanskapt_av_1_A = mkA "vanskapt" "vanskapt" ;
  vareviga_av_1_A = mkA "varevig" "varteviga" ;
  varmbraeckt_av_1_1_A = mkA "varmbräckt" "varmbräckt" ;
  vassnaest_av_1_1_A = mkA "vassnäst" "vassnäst" ;
  vattblaa_av_1_1_A = mkA "vattblå" "vattblått" ;
  vattenblaa_av_1_1_A = mkA "vattenblå" "vattenblått" ;
  vattendriven_av_1_A = mkA "vattendriven" "vattendrivet" ;
  vattenfast_av_1_A = mkA "vattenfast" "vattenfast" ;
  vattenomfluten_av_1_A = mkA "vattenomfluten" "vattenomflutet" ;
  vidstraeckt_av_1_1_A = mkA "vidsträckt" "vidsträckt" ;
  vidsynt_av_1_A = mkA "vidsynt" "vidsynt" ;
  vildsint_av_1_A = mkA "vildsint" "vildsint" ;
  vinddriven_av_2_A = mkA "vinddriven" "vinddrivet" ;
  vinterblaa_av_1_1_A = mkA "vinterblå" "vinterblått" ;
  violblaa_av_1_1_A = mkA "violblå" "violblått" ;
  virulent_av_1_A = mkA "virulent" "virulent" ;
  vitblaa_av_1_1_A = mkA "vitblå" "vitblått" ;
  vitgraa_av_1_1_A = mkA "vitgrå" "vitgrått" ;
  vithyllt_av_1_A = mkA "vithyllt" "vithyllt" ;
  vittbekant_av_1_A = mkA "vittbekant" "vittbekant" ;
  vittberest_av_1_A = mkA "vittberest" "vittberest" ;
  vaeggfast_av_1_1_A = mkA "väggfast" "väggfast" ;
  vaelbekant_av_1_1_A = mkA "välbekant" "välbekant" ;
  vaelbesoekt_av_1_1_A = mkA "välbesökt" "välbesökt" ;
  vaelbetaenkt_av_1_1_A = mkA "välbetänkt" "välbetänkt" ;
  vaelfoertjaent_av_1_1_A = mkA "välförtjänt" "välförtjänt" ;
  vaelment_av_1_1_A = mkA "välment" "välment" ;
  vaelskapt_av_1_1_A = mkA "välskapt" "välskapt" ;
  vaelstekt_av_1_1_A = mkA "välstekt" "välstekt" ;
  vaelvaext_av_1_1_A = mkA "välväxt" "välväxt" ;
  vaenfast_av_1_1_A = mkA "vänfast" "vänfast" ;
  vaensterhaent_av_1_1_A = mkA "vänsterhänt" "vänsterhänt" ;
  vaerdefast_av_1_1_A = mkA "värdefast" "värdefast" ;
  vaerldsbekant_av_1_1_A = mkA "världsbekant" "världsbekant" ;
  vaerldsbaest_av_1_1_A = mkA "världsbäst" "världsbäst" ;
  vaetgasdriven_av_1_1_A = mkA "vätgasdriven" "vätgasdrivet" ;
  vaaldtaektsmisstaenkt_av_1_1_A = mkA "våldtäktsmisstänkt" "våldtäktsmisstänkt" ;
  aangdriven_av_1_1_A = mkA "ångdriven" "ångdrivet" ;
  aangerkoept_av_1_1_A = mkA "ångerköpt" "ångerköpt" ;
  aangestriden_av_1_1_A = mkA "ångestriden" "ångestridet" ;
  aarbraeckt_av_1_1_A = mkA "årbräckt" "årbräckt" ;
  aattadubbel_av_1_1_A = mkA "åttadubben" "åttadubbet" ;
  oemsint_av_1_1_A = mkA "ömsint" "ömsint" ;
  oeverfoertjust_av_1_1_A = mkA "överförtjust" "överförtjust" ;
  oeversynt_av_1_1_A = mkA "översynt" "översynt" ;
  oevertaenkt_av_1_1_A = mkA "övertänkt" "övertänkt" ;
  EU_skeptisk_av_1_A = mkA "EU-skeptisk" ;
  Natoledd_av_1_A = mkA "Natoledd" ;
  _95_oktanig_av_1_A = mkA "95-oktanig" ;
  abbotlig_av_1_A = mkA "abbotlig" ;
  abbrevierbar_av_1_A = mkA "abbrevierbar" ;
  abderitisk_av_1_A = mkA "abderitisk" ;
  abdikerbar_av_1_A = mkA "abdikerbar" ;
  abessinsk_av_1_A = mkA "abessinsk" ;
  abnorm_av_1_A = mkA "abnorm" ;
  abolitionistisk_av_1_A = mkA "abolitionistisk" ;
  abominabel_av_1_A = mkA "abominabel" ;
  abonnerbar_av_1_A = mkA "abonnerbar" ;
  aborterbar_av_1_A = mkA "aborterbar" ;
  abortiv_av_1_A = mkA "abortiv" ;
  abraderbar_av_1_A = mkA "abraderbar" ;
  absolutistisk_av_1_A = mkA "absolutistisk" ;
  absolverbar_av_1_A = mkA "absolverbar" ;
  absorberbar_av_1_A = mkA "absorberbar" ;
  abstraherbar_av_1_A = mkA "abstraherbar" ;
  abstrus_av_1_A = mkA "abstrus" ;
  absurdistisk_av_1_A = mkA "absurdistisk" ;
  abyssal_av_1_A = mkA "abyssal" ;
  accederbar_av_1_A = mkA "accederbar" ;
  accelererbar_av_1_A = mkA "accelererbar" ;
  accentuerbar_av_1_A = mkA "accentuerbar" ;
  acceptabel_av_1_A = mkA "acceptabel" ;
  accepterbar_av_1_A = mkA "accepterbar" ;
  accessorisk_av_1_A = mkA "accessorisk" ;
  accidentell_av_1_A = mkA "accidentell" ;
  accisfri_av_1_A = mkA "accisfri" ;
  acklimatiserbar_av_1_A = mkA "acklimatiserbar" ;
  ackommoderbar_av_1_A = mkA "ackommoderbar" ;
  ackompanjerbar_av_1_A = mkA "ackompanjerbar" ;
  ackorderbar_av_1_A = mkA "ackorderbar" ;
  ackrediterbar_av_1_A = mkA "ackrediterbar" ;
  ackumulerbar_av_1_A = mkA "ackumulerbar" ;
  ackusativ_av_1_A = mkA "ackusativ" ;
  ackusatorisk_av_1_A = mkA "ackusatorisk" ;
  ackvirerbar_av_1_A = mkA "ackvirerbar" ;
  adapterbar_av_1_A = mkA "adapterbar" ;
  adaptiv_av_1_A = mkA "adaptiv" ;
  adderbar_av_1_A = mkA "adderbar" ;
  additiv_av_1_A = mkA "additiv" ;
  adhesiv_av_1_A = mkA "adhesiv" ;
  adiabatisk_av_1_A = mkA "adiabatisk" ;
  adiaforistisk_av_1_A = mkA "adiaforistisk" ;
  adjektivisk_av_1_A = mkA "adjektivisk" ;
  adjektivistisk_av_1_A = mkA "adjektivistisk" ;
  adjungerbar_av_1_A = mkA "adjungerbar" ;
  adlig_av_1_A = mkA "adlig" ;
  administrativ_av_1_A = mkA "administrativ" ;
  administrerbar_av_1_A = mkA "administrerbar" ;
  adopterbar_av_1_A = mkA "adopterbar" ;
  adoptiv_av_1_A = mkA "adoptiv" ;
  adresserbar_av_1_A = mkA "adresserbar" ;
  adsorberbar_av_1_A = mkA "adsorberbar" ;
  aducerbar_av_1_A = mkA "aducerbar" ;
  adventistisk_av_1_A = mkA "adventistisk" ;
  adventiv_av_1_A = mkA "adventiv" ;
  adverbiell_av_1_A = mkA "adverbiell" ;
  adversativ_av_1_A = mkA "adversativ" ;
  advocerbar_av_1_A = mkA "advocerbar" ;
  advokatorisk_av_1_A = mkA "advokatorisk" ;
  aerob_av_1_A = mkA "aerob" ;
  aerobisk_av_1_A = mkA "aerobisk" ;
  aerodynamisk_av_1_A = mkA "aerodynamisk" ;
  afasisk_av_1_A = mkA "afasisk" ;
  afatisk_av_1_A = mkA "afatisk" ;
  affektfri_av_1_A = mkA "affektfri" ;
  affektiv_av_1_A = mkA "affektiv" ;
  afficierbar_av_1_A = mkA "afficierbar" ;
  affin_av_1_A = mkA "affin" ;
  affinerbar_av_1_A = mkA "affinerbar" ;
  affirmativ_av_1_A = mkA "affirmativ" ;
  affischerbar_av_1_A = mkA "affischerbar" ;
  affischmaessig_av_1_1_A = mkA "affischmässig" ;
  affaersmannamaessig_av_1_1_A = mkA "affärsmannamässig" ;
  affaersmaessig_av_1_1_A = mkA "affärsmässig" ;
  afghansk_av_1_A = mkA "afghansk" ;
  aforistisk_av_1_A = mkA "aforistisk" ;
  afrikaniserbar_av_1_A = mkA "afrikaniserbar" ;
  afrikansk_av_1_A = mkA "afrikansk" ;
  afro_asiatisk_av_1_A = mkA "afro-asiatisk" ;
  afroasiatisk_av_1_A = mkA "afroasiatisk" ;
  agerbar_av_1_A = mkA "agerbar" ;
  aggfri_av_1_A = mkA "aggfri" ;
  agglomererbar_av_1_A = mkA "agglomererbar" ;
  agglutinerbar_av_1_A = mkA "agglutinerbar" ;
  aggressiv_av_1_A = mkA "aggressiv" ;
  agitatorisk_av_1_A = mkA "agitatorisk" ;
  agiterbar_av_1_A = mkA "agiterbar" ;
  agnatisk_av_1_A = mkA "agnatisk" ;
  agnblommig_av_1_A = mkA "agnblommig" ;
  agnostisk_av_1_A = mkA "agnostisk" ;
  agonistisk_av_1_A = mkA "agonistisk" ;
  agrar_av_1_A = mkA "agrar" ;
  agrarkommunistisk_av_1_A = mkA "agrarkommunistisk" ;
  agreabel_av_1_A = mkA "agreabel" ;
  agrikulturell_av_1_A = mkA "agrikulturell" ;
  agronomisk_av_1_A = mkA "agronomisk" ;
  aidssjuk_av_1_A = mkA "aidssjuk" ;
  ajournerbar_av_1_A = mkA "ajournerbar" ;
  akademisk_av_1_A = mkA "akademisk" ;
  akatalektisk_av_1_A = mkA "akatalektisk" ;
  akrobatisk_av_1_A = mkA "akrobatisk" ;
  akromatisk_av_1_A = mkA "akromatisk" ;
  akterlig_av_1_A = mkA "akterlig" ;
  aktionistisk_av_1_A = mkA "aktionistisk" ;
  aktiv_av_1_A = mkA "aktiv" ;
  aktiverbar_av_1_A = mkA "aktiverbar" ;
  aktivistisk_av_1_A = mkA "aktivistisk" ;
  aktningsfull_av_1_A = mkA "aktningsfull" ;
  aktualiserbar_av_1_A = mkA "aktualiserbar" ;
  aktualistisk_av_1_A = mkA "aktualistisk" ;
  aktuell_av_1_A = mkA "aktuell" ;
  akustisk_av_1_A = mkA "akustisk" ;
  akvaristisk_av_1_A = mkA "akvaristisk" ;
  akvatisk_av_1_A = mkA "akvatisk" ;
  alarmerbar_av_1_A = mkA "alarmerbar" ;
  alarmistisk_av_1_A = mkA "alarmistisk" ;
  albansk_av_1_A = mkA "albansk" ;
  albinistisk_av_1_A = mkA "albinistisk" ;
  alexandrinsk_av_1_A = mkA "alexandrinsk" ;
  alfabetiserbar_av_1_A = mkA "alfabetiserbar" ;
  alfabetisk_av_1_A = mkA "alfabetisk" ;
  alfanumerisk_av_1_A = mkA "alfanumerisk" ;
  algebraisk_av_1_A = mkA "algebraisk" ;
  algerisk_av_1_A = mkA "algerisk" ;
  alibistisk_av_1_A = mkA "alibistisk" ;
  alienerbar_av_1_A = mkA "alienerbar" ;
  alifatisk_av_1_A = mkA "alifatisk" ;
  alimentaer_av_1_1_A = mkA "alimentär" ;
  alkaisk_av_1_A = mkA "alkaisk" ;
  alkalisk_av_1_A = mkA "alkalisk" ;
  alkemisk_av_1_A = mkA "alkemisk" ;
  alkemistisk_av_1_A = mkA "alkemistisk" ;
  alkoholhaltig_av_1_A = mkA "alkoholhaltig" ;
  alkoholisk_av_1_A = mkA "alkoholisk" ;
  alkoholistisk_av_1_A = mkA "alkoholistisk" ;
  alkoholpolitisk_av_1_A = mkA "alkoholpolitisk" ;
  alkoholsvag_av_1_A = mkA "alkoholsvag" ;
  alldaglig_av_1_A = mkA "alldaglig" ;
  allegoriserbar_av_1_A = mkA "allegoriserbar" ;
  allegorisk_av_1_A = mkA "allegorisk" ;
  allergisk_av_1_A = mkA "allergisk" ;
  allierbar_av_1_A = mkA "allierbar" ;
  allittererbar_av_1_A = mkA "allittererbar" ;
  allmaenfarlig_av_1_1_A = mkA "allmänfarlig" ;
  allmaengiltig_av_1_1_A = mkA "allmängiltig" ;
  allmaenhumanistisk_av_1_1_A = mkA "allmänhumanistisk" ;
  allmaenmodernistisk_av_1_1_A = mkA "allmänmodernistisk" ;
  allmaenmaensklig_av_1_1_A = mkA "allmänmänsklig" ;
  allmaennelig_av_1_1_A = mkA "allmännelig" ;
  allmaennyttig_av_1_1_A = mkA "allmännyttig" ;
  allmaenpolitisk_av_1_1_A = mkA "allmänpolitisk" ;
  allmaenpreventiv_av_1_1_A = mkA "allmänpreventiv" ;
  allnationell_av_1_A = mkA "allnationell" ;
  allodial_av_1_A = mkA "allodial" ;
  allokerbar_av_1_A = mkA "allokerbar" ;
  allokton_av_1_A = mkA "allokton" ;
  allomorf_av_1_A = mkA "allomorf" ;
  allsidig_av_1_A = mkA "allsidig" ;
  allsmaektig_av_1_1_A = mkA "allsmäktig" ;
  allsvensk_av_1_A = mkA "allsvensk" ;
  allsvaaldig_av_1_1_A = mkA "allsvåldig" ;
  alluderbar_av_1_A = mkA "alluderbar" ;
  alluvial_av_1_A = mkA "alluvial" ;
  allvarlig_av_1_A = mkA "allvarlig" ;
  allvis_av_1_A = mkA "allvis" ;
  alpin_av_1_A = mkA "alpin" ;
  alpinsk_av_1_A = mkA "alpinsk" ;
  alternativ_av_1_A = mkA "alternativ" ;
  alternerbar_av_1_A = mkA "alternerbar" ;
  altruistisk_av_1_A = mkA "altruistisk" ;
  aluminerbar_av_1_A = mkA "aluminerbar" ;
  alveolar_av_1_A = mkA "alveolar" ;
  amalgamerbar_av_1_A = mkA "amalgamerbar" ;
  amatoeristisk_av_1_1_A = mkA "amatöristisk" ;
  amatoermaessig_av_1_1_A = mkA "amatörmässig" ;
  ambassadoersmaessig_av_1_1_A = mkA "ambassadörsmässig" ;
  ambidexter_av_1_A = mkA "ambidexter" ;
  ambitioes_av_1_1_A = mkA "ambitiös" ;
  ambrosisk_av_1_A = mkA "ambrosisk" ;
  ambulatorisk_av_1_A = mkA "ambulatorisk" ;
  ambulerbar_av_1_A = mkA "ambulerbar" ;
  amerikaniserbar_av_1_A = mkA "amerikaniserbar" ;
  amerikansk_av_1_A = mkA "amerikansk" ;
  amfibisk_av_1_A = mkA "amfibisk" ;
  amfiteatralisk_av_1_A = mkA "amfiteatralisk" ;
  amoralisk_av_1_A = mkA "amoralisk" ;
  amorf_av_1_A = mkA "amorf" ;
  amorterbar_av_1_A = mkA "amorterbar" ;
  amoroes_av_1_1_A = mkA "amorös" ;
  ampel_av_1_A = mkA "ampel" ;
  amper_av_1_A = mkA "amper" ;
  amplifierbar_av_1_A = mkA "amplifierbar" ;
  amplitudmodulerbar_av_1_A = mkA "amplitudmodulerbar" ;
  amputerbar_av_1_A = mkA "amputerbar" ;
  anabaptistisk_av_1_A = mkA "anabaptistisk" ;
  anabatisk_av_1_A = mkA "anabatisk" ;
  anabol_av_1_A = mkA "anabol" ;
  anadrom_av_1_A = mkA "anadrom" ;
  anaerob_av_1_A = mkA "anaerob" ;
  anaforisk_av_1_A = mkA "anaforisk" ;
  anakreontisk_av_1_A = mkA "anakreontisk" ;
  anakronistisk_av_1_A = mkA "anakronistisk" ;
  anal_av_1_A = mkA "anal" ;
  analfabetisk_av_1_A = mkA "analfabetisk" ;
  analog_av_1_A = mkA "analog" ;
  analogisk_av_1_A = mkA "analogisk" ;
  analyserbar_av_1_A = mkA "analyserbar" ;
  analytisk_av_1_A = mkA "analytisk" ;
  anarkisk_av_1_A = mkA "anarkisk" ;
  anarkistisk_av_1_A = mkA "anarkistisk" ;
  anarkokapitalistisk_av_1_A = mkA "anarkokapitalistisk" ;
  anarkokommunistisk_av_1_A = mkA "anarkokommunistisk" ;
  anarkoprimitivistisk_av_1_A = mkA "anarkoprimitivistisk" ;
  anarkosyndikalistisk_av_1_A = mkA "anarkosyndikalistisk" ;
  anastatisk_av_1_A = mkA "anastatisk" ;
  anastigmatisk_av_1_A = mkA "anastigmatisk" ;
  anatomisk_av_1_A = mkA "anatomisk" ;
  andaktsfull_av_1_A = mkA "andaktsfull" ;
  andefattig_av_1_A = mkA "andefattig" ;
  andeloes_av_1_1_A = mkA "andelös" ;
  andfaadd_av_1_1_A = mkA "andfådd" ;
  andlig_av_1_A = mkA "andlig" ;
  andloes_av_1_1_A = mkA "andlös" ;
  andorransk_av_1_A = mkA "andorransk" ;
  androgyn_av_1_A = mkA "androgyn" ;
  andryg_av_1_A = mkA "andryg" ;
  andaektig_av_1_1_A = mkA "andäktig" ;
  anekdotisk_av_1_A = mkA "anekdotisk" ;
  anemisk_av_1_A = mkA "anemisk" ;
  anestetisk_av_1_A = mkA "anestetisk" ;
  anfallsmaessig_av_1_1_A = mkA "anfallsmässig" ;
  angelsachsisk_av_1_A = mkA "angelsachsisk" ;
  angelsaxisk_av_1_A = mkA "angelsaxisk" ;
  angenaem_av_1_1_A = mkA "angenäm" ;
  anglicistisk_av_1_A = mkA "anglicistisk" ;
  anglikansk_av_1_A = mkA "anglikansk" ;
  angliserbar_av_1_A = mkA "angliserbar" ;
  anglosachsisk_av_1_A = mkA "anglosachsisk" ;
  anglosaxisk_av_1_A = mkA "anglosaxisk" ;
  angolansk_av_1_A = mkA "angolansk" ;
  anhaengig_av_1_1_A = mkA "anhängig" ;
  anhoerig_av_1_1_A = mkA "anhörig" ;
  animal_av_1_A = mkA "animal" ;
  animalisk_av_1_A = mkA "animalisk" ;
  animerbar_av_1_A = mkA "animerbar" ;
  animistisk_av_1_A = mkA "animistisk" ;
  aningsfull_av_1_A = mkA "aningsfull" ;
  aningsloes_av_1_1_A = mkA "aningslös" ;
  ankellaang_av_1_1_A = mkA "ankellång" ;
  ankistisk_av_1_A = mkA "ankistisk" ;
  anmaelningspliktig_av_1_1_A = mkA "anmälningspliktig" ;
  anmaelningsskyldig_av_1_1_A = mkA "anmälningsskyldig" ;
  annekterbar_av_1_A = mkA "annekterbar" ;
  annihilerbar_av_1_A = mkA "annihilerbar" ;
  annonserbar_av_1_A = mkA "annonserbar" ;
  annoterbar_av_1_A = mkA "annoterbar" ;
  annuell_av_1_A = mkA "annuell" ;
  annullerbar_av_1_A = mkA "annullerbar" ;
  anodiserbar_av_1_A = mkA "anodiserbar" ;
  anomal_av_1_A = mkA "anomal" ;
  anomalisk_av_1_A = mkA "anomalisk" ;
  anomalistisk_av_1_A = mkA "anomalistisk" ;
  anonym_av_1_A = mkA "anonym" ;
  anonymiserbar_av_1_A = mkA "anonymiserbar" ;
  anorektisk_av_1_A = mkA "anorektisk" ;
  anormal_av_1_A = mkA "anormal" ;
  anpassbar_av_1_A = mkA "anpassbar" ;
  anpasslig_av_1_A = mkA "anpasslig" ;
  anrik_av_1_A = mkA "anrik" ;
  ansedd_av_1_A = mkA "ansedd" ;
  ansenlig_av_1_A = mkA "ansenlig" ;
  anskraemlig_av_1_1_A = mkA "anskrämlig" ;
  anslagsmaessig_av_1_1_A = mkA "anslagsmässig" ;
  anspraakloes_av_1_1_A = mkA "anspråklös" ;
  anspraaksfull_av_1_1_A = mkA "anspråksfull" ;
  anspraaksloes_av_1_1_A = mkA "anspråkslös" ;
  anstaendig_av_1_1_A = mkA "anständig" ;
  anstoetlig_av_1_1_A = mkA "anstötlig" ;
  ansvarig_av_1_A = mkA "ansvarig" ;
  ansvarsfri_av_1_A = mkA "ansvarsfri" ;
  ansvarsfull_av_1_A = mkA "ansvarsfull" ;
  ansvarsloes_av_1_1_A = mkA "ansvarslös" ;
  antaglig_av_1_A = mkA "antaglig" ;
  antagonistisk_av_1_A = mkA "antagonistisk" ;
  antalsmaessig_av_1_1_A = mkA "antalsmässig" ;
  antarktisk_av_1_A = mkA "antarktisk" ;
  antecipativ_av_1_A = mkA "antecipativ" ;
  anteciperbar_av_1_A = mkA "anteciperbar" ;
  antedaterbar_av_1_A = mkA "antedaterbar" ;
  antediluviansk_av_1_A = mkA "antediluviansk" ;
  antibiotisk_av_1_A = mkA "antibiotisk" ;
  antichambrerbar_av_1_A = mkA "antichambrerbar" ;
  antidemokratisk_av_1_A = mkA "antidemokratisk" ;
  antidepressiv_av_1_A = mkA "antidepressiv" ;
  antielitistisk_av_1_A = mkA "antielitistisk" ;
  antiexpressionistisk_av_1_A = mkA "antiexpressionistisk" ;
  antifundamentalistisk_av_1_A = mkA "antifundamentalistisk" ;
  antiguansk_av_1_A = mkA "antiguansk" ;
  antihumanistisk_av_1_A = mkA "antihumanistisk" ;
  antiidealistisk_av_1_A = mkA "antiidealistisk" ;
  antiimperialistisk_av_1_A = mkA "antiimperialistisk" ;
  antiindividualistisk_av_1_A = mkA "antiindividualistisk" ;
  antiintellektualistisk_av_1_A = mkA "antiintellektualistisk" ;
  antiintellektuell_av_1_A = mkA "antiintellektuell" ;
  antiislamistisk_av_1_A = mkA "antiislamistisk" ;
  antik_av_1_A = mkA "antik" ;
  antikiserbar_av_1_A = mkA "antikiserbar" ;
  antiklerikal_av_1_A = mkA "antiklerikal" ;
  antikommunistisk_av_1_A = mkA "antikommunistisk" ;
  antikonceptionell_av_1_A = mkA "antikonceptionell" ;
  antikristlig_av_1_A = mkA "antikristlig" ;
  antikvarisk_av_1_A = mkA "antikvarisk" ;
  antimilitaristisk_av_1_A = mkA "antimilitaristisk" ;
  antipatisk_av_1_A = mkA "antipatisk" ;
  antipolitisk_av_1_A = mkA "antipolitisk" ;
  antireligioes_av_1_1_A = mkA "antireligiös" ;
  antirojalistisk_av_1_A = mkA "antirojalistisk" ;
  antisemitisk_av_1_A = mkA "antisemitisk" ;
  antiseptisk_av_1_A = mkA "antiseptisk" ;
  antisionistisk_av_1_A = mkA "antisionistisk" ;
  antistatisk_av_1_A = mkA "antistatisk" ;
  antitetisk_av_1_A = mkA "antitetisk" ;
  antonym_av_1_A = mkA "antonym" ;
  antropisk_av_1_A = mkA "antropisk" ;
  antropocentrisk_av_1_A = mkA "antropocentrisk" ;
  antropologisk_av_1_A = mkA "antropologisk" ;
  antropomorf_av_1_A = mkA "antropomorf" ;
  antropomorfisk_av_1_A = mkA "antropomorfisk" ;
  antropomorfistisk_av_1_A = mkA "antropomorfistisk" ;
  antroposofisk_av_1_A = mkA "antroposofisk" ;
  antraeffbar_av_1_1_A = mkA "anträffbar" ;
  anvaendarvaenlig_av_1_1_A = mkA "användarvänlig" ;
  anvaendbar_av_1_1_A = mkA "användbar" ;
  apatisk_av_1_A = mkA "apatisk" ;
  aplik_av_1_A = mkA "aplik" ;
  apodiktisk_av_1_A = mkA "apodiktisk" ;
  apokalyptisk_av_1_A = mkA "apokalyptisk" ;
  apokryfisk_av_1_A = mkA "apokryfisk" ;
  apolitisk_av_1_A = mkA "apolitisk" ;
  apollinisk_av_1_A = mkA "apollinisk" ;
  apollinsk_av_1_A = mkA "apollinsk" ;
  apologetisk_av_1_A = mkA "apologetisk" ;
  apoplektisk_av_1_A = mkA "apoplektisk" ;
  aposteriorisk_av_1_A = mkA "aposteriorisk" ;
  apostolisk_av_1_A = mkA "apostolisk" ;
  apostroferbar_av_1_A = mkA "apostroferbar" ;
  appellerbar_av_1_A = mkA "appellerbar" ;
  applicerbar_av_1_A = mkA "applicerbar" ;
  applikatorisk_av_1_A = mkA "applikatorisk" ;
  applaaderbar_av_1_1_A = mkA "applåderbar" ;
  apporterbar_av_1_A = mkA "apporterbar" ;
  apprecierbar_av_1_A = mkA "apprecierbar" ;
  appreterbar_av_1_A = mkA "appreterbar" ;
  approbabel_av_1_A = mkA "approbabel" ;
  approcherbar_av_1_A = mkA "approcherbar" ;
  approximativ_av_1_A = mkA "approximativ" ;
  approximerbar_av_1_A = mkA "approximerbar" ;
  aprak_av_1_A = mkA "aprak" ;
  apriorisk_av_1_A = mkA "apriorisk" ;
  apterbar_av_1_A = mkA "apterbar" ;
  aptitlig_av_1_A = mkA "aptitlig" ;
  arabisk_av_1_A = mkA "arabisk" ;
  arbetsduglig_av_1_A = mkA "arbetsduglig" ;
  arbetsfoer_av_1_1_A = mkA "arbetsför" ;
  arbetsintensiv_av_1_A = mkA "arbetsintensiv" ;
  arbetsloes_av_1_1_A = mkA "arbetslös" ;
  arbetsmarknadsmaessig_av_1_1_A = mkA "arbetsmarknadsmässig" ;
  arbetsmarknadspolitisk_av_1_A = mkA "arbetsmarknadspolitisk" ;
  arbetsmiljoemaessig_av_1_1_A = mkA "arbetsmiljömässig" ;
  arbetsmaessig_av_1_1_A = mkA "arbetsmässig" ;
  arbetsraettslig_av_1_1_A = mkA "arbetsrättslig" ;
  arbetsskygg_av_1_A = mkA "arbetsskygg" ;
  arbetsvillig_av_1_A = mkA "arbetsvillig" ;
  arbitraer_av_1_1_A = mkA "arbiträr" ;
  arealmaessig_av_1_1_A = mkA "arealmässig" ;
  arg_av_1_A = mkA "arg" ;
  argentinsk_av_1_A = mkA "argentinsk" ;
  argumentativ_av_1_A = mkA "argumentativ" ;
  argumenterbar_av_1_A = mkA "argumenterbar" ;
  argumentrik_av_1_A = mkA "argumentrik" ;
  ariansk_av_1_A = mkA "ariansk" ;
  arisk_av_1_A = mkA "arisk" ;
  aristokratisk_av_1_A = mkA "aristokratisk" ;
  aritmetisk_av_1_A = mkA "aritmetisk" ;
  arkadisk_av_1_A = mkA "arkadisk" ;
  arkaiserbar_av_1_A = mkA "arkaiserbar" ;
  arkaisk_av_1_A = mkA "arkaisk" ;
  arkaistisk_av_1_A = mkA "arkaistisk" ;
  arkebuserbar_av_1_A = mkA "arkebuserbar" ;
  arkeologisk_av_1_A = mkA "arkeologisk" ;
  arketypisk_av_1_A = mkA "arketypisk" ;
  arkitektonisk_av_1_A = mkA "arkitektonisk" ;
  arkitekturpolitisk_av_1_A = mkA "arkitekturpolitisk" ;
  arkivalisk_av_1_A = mkA "arkivalisk" ;
  arkiverbar_av_1_A = mkA "arkiverbar" ;
  arktisk_av_1_A = mkA "arktisk" ;
  arm_av_1_A = mkA "arm" ;
  armenisk_av_1_A = mkA "armenisk" ;
  armerbar_av_1_A = mkA "armerbar" ;
  aromatisk_av_1_A = mkA "aromatisk" ;
  arrangemangsmaessig_av_1_1_A = mkA "arrangemangsmässig" ;
  arrangerbar_av_1_A = mkA "arrangerbar" ;
  arrangoersmaessig_av_1_1_A = mkA "arrangörsmässig" ;
  arrenderbar_av_1_A = mkA "arrenderbar" ;
  arresterbar_av_1_A = mkA "arresterbar" ;
  arronderbar_av_1_A = mkA "arronderbar" ;
  arsenikfri_av_1_A = mkA "arsenikfri" ;
  arsenikhaltig_av_1_A = mkA "arsenikhaltig" ;
  arteriell_av_1_A = mkA "arteriell" ;
  artesisk_av_1_A = mkA "artesisk" ;
  artificiell_av_1_A = mkA "artificiell" ;
  artig_av_1_A = mkA "artig" ;
  artikulerbar_av_1_A = mkA "artikulerbar" ;
  artistisk_av_1_A = mkA "artistisk" ;
  artonaarig_av_1_1_A = mkA "artonårig" ;
  artrik_av_1_A = mkA "artrik" ;
  arvloes_av_1_1_A = mkA "arvlös" ;
  arvoderbar_av_1_A = mkA "arvoderbar" ;
  arvsmaessig_av_1_1_A = mkA "arvsmässig" ;
  asenkel_av_1_A = mkA "asenkel" ;
  aseptisk_av_1_A = mkA "aseptisk" ;
  asexuell_av_1_A = mkA "asexuell" ;
  asfalterbar_av_1_A = mkA "asfalterbar" ;
  asfull_av_1_A = mkA "asfull" ;
  asiatisk_av_1_A = mkA "asiatisk" ;
  asketisk_av_1_A = mkA "asketisk" ;
  asocial_av_1_A = mkA "asocial" ;
  aspirerbar_av_1_A = mkA "aspirerbar" ;
  assignerbar_av_1_A = mkA "assignerbar" ;
  assimilerbar_av_1_A = mkA "assimilerbar" ;
  assisterbar_av_1_A = mkA "assisterbar" ;
  associationsrik_av_1_A = mkA "associationsrik" ;
  associativ_av_1_A = mkA "associativ" ;
  associerbar_av_1_A = mkA "associerbar" ;
  assurerbar_av_1_A = mkA "assurerbar" ;
  assyrisk_av_1_A = mkA "assyrisk" ;
  astenisk_av_1_A = mkA "astenisk" ;
  astigmatisk_av_1_A = mkA "astigmatisk" ;
  astmatisk_av_1_A = mkA "astmatisk" ;
  astral_av_1_A = mkA "astral" ;
  astrologisk_av_1_A = mkA "astrologisk" ;
  astronomisk_av_1_A = mkA "astronomisk" ;
  asymmetrisk_av_1_A = mkA "asymmetrisk" ;
  asyndetisk_av_1_A = mkA "asyndetisk" ;
  asynkron_av_1_A = mkA "asynkron" ;
  ataktisk_av_1_A = mkA "ataktisk" ;
  atavistisk_av_1_A = mkA "atavistisk" ;
  ateistisk_av_1_A = mkA "ateistisk" ;
  atlantisk_av_1_A = mkA "atlantisk" ;
  atletisk_av_1_A = mkA "atletisk" ;
  atmosfaerisk_av_1_1_A = mkA "atmosfärisk" ;
  atomistisk_av_1_A = mkA "atomistisk" ;
  atomaer_av_1_1_A = mkA "atomär" ;
  atonal_av_1_A = mkA "atonal" ;
  atrofierbar_av_1_A = mkA "atrofierbar" ;
  atrofisk_av_1_A = mkA "atrofisk" ;
  attackerbar_av_1_A = mkA "attackerbar" ;
  attesterbar_av_1_A = mkA "attesterbar" ;
  attisk_av_1_A = mkA "attisk" ;
  attitydmaessig_av_1_1_A = mkA "attitydmässig" ;
  attraherbar_av_1_A = mkA "attraherbar" ;
  attraktiv_av_1_A = mkA "attraktiv" ;
  attrapperbar_av_1_A = mkA "attrapperbar" ;
  attribuerbar_av_1_A = mkA "attribuerbar" ;
  attributiv_av_1_A = mkA "attributiv" ;
  atypisk_av_1_A = mkA "atypisk" ;
  audiovisuell_av_1_A = mkA "audiovisuell" ;
  auditiv_av_1_A = mkA "auditiv" ;
  audivisuell_av_1_A = mkA "audivisuell" ;
  auktionerbar_av_1_A = mkA "auktionerbar" ;
  auktoriserbar_av_1_A = mkA "auktoriserbar" ;
  auktoritativ_av_1_A = mkA "auktoritativ" ;
  auktoritaer_av_1_1_A = mkA "auktoritär" ;
  auskulterbar_av_1_A = mkA "auskulterbar" ;
  australiensisk_av_1_A = mkA "australiensisk" ;
  australisk_av_1_A = mkA "australisk" ;
  autenticerbar_av_1_A = mkA "autenticerbar" ;
  autentifierbar_av_1_A = mkA "autentifierbar" ;
  autentiserbar_av_1_A = mkA "autentiserbar" ;
  autentisk_av_1_A = mkA "autentisk" ;
  autistisk_av_1_A = mkA "autistisk" ;
  autokton_av_1_A = mkA "autokton" ;
  automagisk_av_1_A = mkA "automagisk" ;
  automatiserbar_av_1_A = mkA "automatiserbar" ;
  automatisk_av_1_A = mkA "automatisk" ;
  autonom_av_1_A = mkA "autonom" ;
  avancerbar_av_1_A = mkA "avancerbar" ;
  avannonserbar_av_1_A = mkA "avannonserbar" ;
  avantgardistisk_av_1_A = mkA "avantgardistisk" ;
  avdragsgill_av_1_A = mkA "avdragsgill" ;
  avdragsglad_av_1_A = mkA "avdragsglad" ;
  avdramatiserbar_av_1_A = mkA "avdramatiserbar" ;
  avdoed_av_1_1_A = mkA "avdöd" ;
  avfaellig_av_1_1_A = mkA "avfällig" ;
  avgrundsdjup_av_1_A = mkA "avgrundsdjup" ;
  avhaengig_av_1_1_A = mkA "avhängig" ;
  aviatisk_av_1_A = mkA "aviatisk" ;
  avig_av_1_A = mkA "avig" ;
  aviserbar_av_1_A = mkA "aviserbar" ;
  avkoloniserbar_av_1_A = mkA "avkoloniserbar" ;
  avkriminaliserbar_av_1_A = mkA "avkriminaliserbar" ;
  avlaesbar_av_1_1_A = mkA "avläsbar" ;
  avlaang_av_1_1_A = mkA "avlång" ;
  avmagnetiserbar_av_1_A = mkA "avmagnetiserbar" ;
  avmystifierbar_av_1_A = mkA "avmystifierbar" ;
  avmaett_av_1_1_A = mkA "avmätt" ;
  avnazifierbar_av_1_A = mkA "avnazifierbar" ;
  avog_av_1_A = mkA "avog" ;
  avpatrullerbar_av_1_A = mkA "avpatrullerbar" ;
  avpolitiserbar_av_1_A = mkA "avpolitiserbar" ;
  avpolletterbar_av_1_A = mkA "avpolletterbar" ;
  avportraetterbar_av_1_1_A = mkA "avporträtterbar" ;
  avreagerbar_av_1_A = mkA "avreagerbar" ;
  avregistrerbar_av_1_A = mkA "avregistrerbar" ;
  avreglerbar_av_1_A = mkA "avreglerbar" ;
  avromantiserbar_av_1_A = mkA "avromantiserbar" ;
  avsiktlig_av_1_A = mkA "avsiktlig" ;
  avsiktsloes_av_1_1_A = mkA "avsiktslös" ;
  avsocialiserbar_av_1_A = mkA "avsocialiserbar" ;
  avstaliniserbar_av_1_A = mkA "avstaliniserbar" ;
  avsaettlig_av_1_1_A = mkA "avsättlig" ;
  avtagbar_av_1_A = mkA "avtagbar" ;
  avtalsenlig_av_1_A = mkA "avtalsenlig" ;
  avtalsmaessig_av_1_1_A = mkA "avtalsmässig" ;
  avtalsstridig_av_1_A = mkA "avtalsstridig" ;
  avundsfri_av_1_A = mkA "avundsfri" ;
  avundsfull_av_1_A = mkA "avundsfull" ;
  avundsjuk_av_1_A = mkA "avundsjuk" ;
  avytterlig_av_1_A = mkA "avytterlig" ;
  axblommig_av_1_A = mkA "axblommig" ;
  axelbred_av_1_A = mkA "axelbred" ;
  axellaang_av_1_1_A = mkA "axellång" ;
  axial_av_1_A = mkA "axial" ;
  axiomatiserbar_av_1_A = mkA "axiomatiserbar" ;
  axiomatisk_av_1_A = mkA "axiomatisk" ;
  azerbajdzjansk_av_1_A = mkA "azerbajdzjansk" ;
  aztekisk_av_1_A = mkA "aztekisk" ;
  babylonisk_av_1_A = mkA "babylonisk" ;
  bacillfri_av_1_A = mkA "bacillfri" ;
  backig_av_1_A = mkA "backig" ;
  badensisk_av_1_A = mkA "badensisk" ;
  bagatelliserbar_av_1_A = mkA "bagatelliserbar" ;
  bahamansk_av_1_A = mkA "bahamansk" ;
  bahrainsk_av_1_A = mkA "bahrainsk" ;
  bajersk_av_1_A = mkA "bajersk" ;
  bajonettfoersedd_av_1_1_A = mkA "bajonettförsedd" ;
  bajsbrun_av_1_A = mkA "bajsbrun" ;
  bajsig_av_1_A = mkA "bajsig" ;
  bajsnoedig_av_1_1_A = mkA "bajsnödig" ;
  bakfull_av_1_A = mkA "bakfull" ;
  bakhal_av_1_A = mkA "bakhal" ;
  bakslug_av_1_A = mkA "bakslug" ;
  bakteriefri_av_1_A = mkA "bakteriefri" ;
  bakteriologisk_av_1_A = mkA "bakteriologisk" ;
  baktung_av_1_A = mkA "baktung" ;
  balanserbar_av_1_A = mkA "balanserbar" ;
  ball_av_1_A = mkA "ball" ;
  balloterbar_av_1_A = mkA "balloterbar" ;
  balsamerbar_av_1_A = mkA "balsamerbar" ;
  balsamisk_av_1_A = mkA "balsamisk" ;
  baltisk_av_1_A = mkA "baltisk" ;
  banal_av_1_A = mkA "banal" ;
  banaliserbar_av_1_A = mkA "banaliserbar" ;
  bang_av_1_A = mkA "bang" ;
  bangladeshisk_av_1_A = mkA "bangladeshisk" ;
  bankmaessig_av_1_1_A = mkA "bankmässig" ;
  bankrutt_av_1_A = mkA "bankrutt" ;
  bankrutterbar_av_1_A = mkA "bankrutterbar" ;
  bankruttmaessig_av_1_1_A = mkA "bankruttmässig" ;
  baptistisk_av_1_A = mkA "baptistisk" ;
  bar_av_1_A = mkA "bar" ;
  barbadisk_av_1_A = mkA "barbadisk" ;
  barbarisk_av_1_A = mkA "barbarisk" ;
  barmhaertig_av_1_1_A = mkA "barmhärtig" ;
  barnfoedd_av_1_1_A = mkA "barnfödd" ;
  barnkaer_av_1_1_A = mkA "barnkär" ;
  barnledig_av_1_A = mkA "barnledig" ;
  barnloes_av_1_1_A = mkA "barnlös" ;
  barnslig_av_1_A = mkA "barnslig" ;
  barnsaeker_av_1_1_A = mkA "barnsäker" ;
  barock_av_1_A = mkA "barock" ;
  barockmaessig_av_1_1_A = mkA "barockmässig" ;
  barometrisk_av_1_A = mkA "barometrisk" ;
  barrikaderbar_av_1_A = mkA "barrikaderbar" ;
  barsk_av_1_A = mkA "barsk" ;
  basal_av_1_A = mkA "basal" ;
  baserbar_av_1_A = mkA "baserbar" ;
  basisk_av_1_A = mkA "basisk" ;
  baskisk_av_1_A = mkA "baskisk" ;
  beatifierbar_av_1_A = mkA "beatifierbar" ;
  bebodd_av_1_A = mkA "bebodd" ;
  beboelig_av_1_A = mkA "beboelig" ;
  bebolig_av_1_A = mkA "bebolig" ;
  beckig_av_1_A = mkA "beckig" ;
  beckmoerk_av_1_1_A = mkA "beckmörk" ;
  bedraeglig_av_1_1_A = mkA "bedräglig" ;
  bedroevlig_av_1_1_A = mkA "bedrövlig" ;
  befattningsmaessig_av_1_1_A = mkA "befattningsmässig" ;
  befintlig_av_1_A = mkA "befintlig" ;
  befolkningsmaessig_av_1_1_A = mkA "befolkningsmässig" ;
  befolkningspolitisk_av_1_A = mkA "befolkningspolitisk" ;
  begreppsanalytisk_av_1_A = mkA "begreppsanalytisk" ;
  begreppslig_av_1_A = mkA "begreppslig" ;
  begreppsmaessig_av_1_1_A = mkA "begreppsmässig" ;
  begriplig_av_1_A = mkA "begriplig" ;
  begaerlig_av_1_1_A = mkA "begärlig" ;
  begaavningsmaessig_av_1_1_A = mkA "begåvningsmässig" ;
  behagfull_av_1_A = mkA "behagfull" ;
  behaglig_av_1_A = mkA "behaglig" ;
  behagsjuk_av_1_A = mkA "behagsjuk" ;
  behandlingsbar_av_1_A = mkA "behandlingsbar" ;
  behandlingsmaessig_av_1_1_A = mkA "behandlingsmässig" ;
  behavioristisk_av_1_A = mkA "behavioristisk" ;
  behjaelplig_av_1_1_A = mkA "behjälplig" ;
  behovloes_av_1_1_A = mkA "behovlös" ;
  behaendig_av_1_1_A = mkA "behändig" ;
  behoerig_av_1_1_A = mkA "behörig" ;
  behoevlig_av_1_1_A = mkA "behövlig" ;
  beklaglig_av_1_A = mkA "beklaglig" ;
  bekvaem_av_1_1_A = mkA "bekväm" ;
  bekymmersfull_av_1_A = mkA "bekymmersfull" ;
  bekymmersloes_av_1_1_A = mkA "bekymmerslös" ;
  belgisk_av_1_A = mkA "belgisk" ;
  belizisk_av_1_A = mkA "belizisk" ;
  belletristisk_av_1_A = mkA "belletristisk" ;
  benefik_av_1_A = mkA "benefik" ;
  bengalisk_av_1_A = mkA "bengalisk" ;
  benig_av_1_A = mkA "benig" ;
  benign_av_1_A = mkA "benign" ;
  beninsk_av_1_A = mkA "beninsk" ;
  bensinsnaal_av_1_1_A = mkA "bensinsnål" ;
  benskoer_av_1_1_A = mkA "benskör" ;
  benvit_av_1_A = mkA "benvit" ;
  beredd_av_1_A = mkA "beredd" ;
  beredskapsmaessig_av_1_1_A = mkA "beredskapsmässig" ;
  beredvillig_av_1_A = mkA "beredvillig" ;
  bergfin_av_1_A = mkA "bergfin" ;
  bergig_av_1_A = mkA "bergig" ;
  bergsaeker_av_1_1_A = mkA "bergsäker" ;
  beryllgroen_av_1_1_A = mkA "beryllgrön" ;
  beraeknelig_av_1_1_A = mkA "beräknelig" ;
  beraekningsmaessig_av_1_1_A = mkA "beräkningsmässig" ;
  beraettarmaessig_av_1_1_A = mkA "berättarmässig" ;
  beroemlig_av_1_1_A = mkA "berömlig" ;
  besatt_av_1_A = mkA "besatt" ;
  besinningsfull_av_1_A = mkA "besinningsfull" ;
  besinningsloes_av_1_1_A = mkA "besinningslös" ;
  besk_av_1_A = mkA "besk" ;
  beskattningsbar_av_1_A = mkA "beskattningsbar" ;
  beskedlig_av_1_A = mkA "beskedlig" ;
  beskrivbar_av_1_A = mkA "beskrivbar" ;
  beskaeftig_av_1_1_A = mkA "beskäftig" ;
  beslutenlig_av_1_A = mkA "beslutenlig" ;
  beslutfoer_av_1_1_A = mkA "beslutför" ;
  beslutmaessig_av_1_1_A = mkA "beslutmässig" ;
  beslutsenlig_av_1_A = mkA "beslutsenlig" ;
  beslutsfoer_av_1_1_A = mkA "beslutsför" ;
  beslutskapabel_av_1_A = mkA "beslutskapabel" ;
  beslutsmaessig_av_1_1_A = mkA "beslutsmässig" ;
  bestialisk_av_1_A = mkA "bestialisk" ;
  besticklig_av_1_A = mkA "besticklig" ;
  bestaembar_av_1_1_A = mkA "bestämbar" ;
  bestaendig_av_1_1_A = mkA "beständig" ;
  bestaandsmaessig_av_1_1_A = mkA "beståndsmässig" ;
  besvaerlig_av_1_1_A = mkA "besvärlig" ;
  besynnerlig_av_1_A = mkA "besynnerlig" ;
  betalbar_av_1_A = mkA "betalbar" ;
  betalningsgill_av_1_A = mkA "betalningsgill" ;
  betalningsskyldig_av_1_A = mkA "betalningsskyldig" ;
  beteendemaessig_av_1_1_A = mkA "beteendemässig" ;
  betongerbar_av_1_A = mkA "betongerbar" ;
  betrodd_av_1_A = mkA "betrodd" ;
  betydelsefattig_av_1_A = mkA "betydelsefattig" ;
  betydelsefull_av_1_A = mkA "betydelsefull" ;
  betydelseloes_av_1_1_A = mkA "betydelselös" ;
  betydelsemaessig_av_1_1_A = mkA "betydelsemässig" ;
  betydlig_av_1_A = mkA "betydlig" ;
  betaenklig_av_1_1_A = mkA "betänklig" ;
  bevisbar_av_1_A = mkA "bevisbar" ;
  beviskraftig_av_1_A = mkA "beviskraftig" ;
  bevislig_av_1_A = mkA "bevislig" ;
  bevismaessig_av_1_1_A = mkA "bevismässig" ;
  bevisskyldig_av_1_A = mkA "bevisskyldig" ;
  bhutanesisk_av_1_A = mkA "bhutanesisk" ;
  bibelkunnig_av_1_A = mkA "bibelkunnig" ;
  biblicistisk_av_1_A = mkA "biblicistisk" ;
  bibliografisk_av_1_A = mkA "bibliografisk" ;
  biblisk_av_1_A = mkA "biblisk" ;
  biffig_av_1_A = mkA "biffig" ;
  bifilar_av_1_A = mkA "bifilar" ;
  bifilaer_av_1_1_A = mkA "bifilär" ;
  bigott_av_1_A = mkA "bigott" ;
  bikonkav_av_1_A = mkA "bikonkav" ;
  bikonvex_av_1_A = mkA "bikonvex" ;
  bikvadratisk_av_1_A = mkA "bikvadratisk" ;
  bilabial_av_1_A = mkA "bilabial" ;
  bilateral_av_1_A = mkA "bilateral" ;
  bildbar_av_1_A = mkA "bildbar" ;
  bildlig_av_1_A = mkA "bildlig" ;
  bildlik_av_1_A = mkA "bildlik" ;
  bildmaessig_av_1_1_A = mkA "bildmässig" ;
  bildningsmaessig_av_1_1_A = mkA "bildningsmässig" ;
  bildrik_av_1_A = mkA "bildrik" ;
  bildskoen_av_1_1_A = mkA "bildskön" ;
  bilingual_av_1_A = mkA "bilingual" ;
  bilistisk_av_1_A = mkA "bilistisk" ;
  billig_av_1_A = mkA "billig" ;
  bilsjuk_av_1_A = mkA "bilsjuk" ;
  biltog_av_1_A = mkA "biltog" ;
  binokulaer_av_1_1_A = mkA "binokulär" ;
  binaer_av_1_1_A = mkA "binär" ;
  biodynamisk_av_1_A = mkA "biodynamisk" ;
  biofysisk_av_1_A = mkA "biofysisk" ;
  biogenetisk_av_1_A = mkA "biogenetisk" ;
  biograferbar_av_1_A = mkA "biograferbar" ;
  biografisk_av_1_A = mkA "biografisk" ;
  biografmaessig_av_1_1_A = mkA "biografmässig" ;
  biokemisk_av_1_A = mkA "biokemisk" ;
  biologisk_av_1_A = mkA "biologisk" ;
  bioteknisk_av_1_A = mkA "bioteknisk" ;
  biotisk_av_1_A = mkA "biotisk" ;
  bipolaer_av_1_1_A = mkA "bipolär" ;
  bisarr_av_1_A = mkA "bisarr" ;
  bisexuell_av_1_A = mkA "bisexuell" ;
  biskoplig_av_1_A = mkA "biskoplig" ;
  bissauguineansk_av_1_A = mkA "bissauguineansk" ;
  bisserbar_av_1_A = mkA "bisserbar" ;
  bister_av_1_A = mkA "bister" ;
  bistaandspolitisk_av_1_1_A = mkA "biståndspolitisk" ;
  bitsk_av_1_A = mkA "bitsk" ;
  bitter_av_1_A = mkA "bitter" ;
  bitterkall_av_1_A = mkA "bitterkall" ;
  bitterljuv_av_1_A = mkA "bitterljuv" ;
  bittersoet_av_1_1_A = mkA "bittersöt" ;
  bituminoes_av_1_1_A = mkA "bituminös" ;
  bivackerbar_av_1_A = mkA "bivackerbar" ;
  bjaebbig_av_1_1_A = mkA "bjäbbig" ;
  bjaertgroen_av_1_1_A = mkA "bjärtgrön" ;
  black_av_1_A = mkA "black" ;
  blackig_av_1_A = mkA "blackig" ;
  bladig_av_1_A = mkA "bladig" ;
  blancherbar_av_1_A = mkA "blancherbar" ;
  blank_av_1_A = mkA "blank" ;
  blankpolerbar_av_1_A = mkA "blankpolerbar" ;
  blasfemisk_av_1_A = mkA "blasfemisk" ;
  blaskig_av_1_A = mkA "blaskig" ;
  blazerklaedd_av_1_1_A = mkA "blazerklädd" ;
  blek_av_1_A = mkA "blek" ;
  blekfet_av_1_A = mkA "blekfet" ;
  blekgul_av_1_A = mkA "blekgul" ;
  blekingsk_av_1_A = mkA "blekingsk" ;
  blekroed_av_1_1_A = mkA "blekröd" ;
  bleksiktig_av_1_A = mkA "bleksiktig" ;
  blesserbar_av_1_A = mkA "blesserbar" ;
  blid_av_1_A = mkA "blid" ;
  blinderbar_av_1_A = mkA "blinderbar" ;
  blixtfotograferbar_av_1_A = mkA "blixtfotograferbar" ;
  blixtsnabb_av_1_A = mkA "blixtsnabb" ;
  blockerbar_av_1_A = mkA "blockerbar" ;
  blockig_av_1_A = mkA "blockig" ;
  blockpolitisk_av_1_A = mkA "blockpolitisk" ;
  blodfattig_av_1_A = mkA "blodfattig" ;
  blodfull_av_1_A = mkA "blodfull" ;
  blodig_av_1_A = mkA "blodig" ;
  blodloes_av_1_1_A = mkA "blodlös" ;
  blodroed_av_1_1_A = mkA "blodröd" ;
  blodtoerstig_av_1_1_A = mkA "blodtörstig" ;
  blomklaedd_av_1_1_A = mkA "blomklädd" ;
  blommig_av_1_A = mkA "blommig" ;
  blommograferbar_av_1_A = mkA "blommograferbar" ;
  blomsterklaedd_av_1_1_A = mkA "blomsterklädd" ;
  blonderbar_av_1_A = mkA "blonderbar" ;
  blott_av_1_A = mkA "blott" ;
  blyg_av_1_A = mkA "blyg" ;
  blyhaltig_av_1_A = mkA "blyhaltig" ;
  blytung_av_1_A = mkA "blytung" ;
  blaendvit_av_1_1_A = mkA "bländvit" ;
  blaaaktig_av_1_1_A = mkA "blåaktig" ;
  blaablodig_av_1_1_A = mkA "blåblodig" ;
  blaagroen_av_1_1_A = mkA "blågrön" ;
  blaagul_av_1_1_A = mkA "blågul" ;
  blaakopierbar_av_1_1_A = mkA "blåkopierbar" ;
  blaaprickig_av_1_1_A = mkA "blåprickig" ;
  blaarandig_av_1_1_A = mkA "blårandig" ;
  blaarutig_av_1_1_A = mkA "blårutig" ;
  blaaroed_av_1_1_A = mkA "blåröd" ;
  blaasig_av_1_1_A = mkA "blåsig" ;
  blaasur_av_1_1_A = mkA "blåsur" ;
  blaavarm_av_1_1_A = mkA "blåvarm" ;
  blaaviolett_av_1_1_A = mkA "blåviolett" ;
  blaavit_av_1_1_A = mkA "blåvit" ;
  bloedig_av_1_1_A = mkA "blödig" ;
  bloet_av_1_1_A = mkA "blöt" ;
  boaserbar_av_1_A = mkA "boaserbar" ;
  bofaellig_av_1_1_A = mkA "bofällig" ;
  bogserbar_av_1_A = mkA "bogserbar" ;
  bohemisk_av_1_A = mkA "bohemisk" ;
  bohuslaensk_av_1_1_A = mkA "bohuslänsk" ;
  bokfoeringsmaessig_av_1_1_A = mkA "bokföringsmässig" ;
  bokfoeringsskyldig_av_1_1_A = mkA "bokföringsskyldig" ;
  boklig_av_1_A = mkA "boklig" ;
  bokstaverbar_av_1_A = mkA "bokstaverbar" ;
  bokstavlig_av_1_A = mkA "bokstavlig" ;
  boliviansk_av_1_A = mkA "boliviansk" ;
  bolsjevikisk_av_1_A = mkA "bolsjevikisk" ;
  bolsjevistisk_av_1_A = mkA "bolsjevistisk" ;
  bombarderbar_av_1_A = mkA "bombarderbar" ;
  bombastisk_av_1_A = mkA "bombastisk" ;
  bombfri_av_1_A = mkA "bombfri" ;
  bombsaeker_av_1_1_A = mkA "bombsäker" ;
  bonddryg_av_1_A = mkA "bonddryg" ;
  bondsk_av_1_A = mkA "bondsk" ;
  bondslug_av_1_A = mkA "bondslug" ;
  boniterbar_av_1_A = mkA "boniterbar" ;
  boreal_av_1_A = mkA "boreal" ;
  borgerlig_av_1_A = mkA "borgerlig" ;
  borstig_av_1_A = mkA "borstig" ;
  borstloes_av_1_1_A = mkA "borstlös" ;
  bortresonerbar_av_1_A = mkA "bortresonerbar" ;
  bosatt_av_1_A = mkA "bosatt" ;
  bosnienserbisk_av_1_A = mkA "bosnienserbisk" ;
  bosnisk_av_1_A = mkA "bosnisk" ;
  bossig_av_1_A = mkA "bossig" ;
  bostadsloes_av_1_1_A = mkA "bostadslös" ;
  bostadsmaessig_av_1_1_A = mkA "bostadsmässig" ;
  bostadspolitisk_av_1_A = mkA "bostadspolitisk" ;
  botanisk_av_1_A = mkA "botanisk" ;
  botfaerdig_av_1_1_A = mkA "botfärdig" ;
  botlig_av_1_A = mkA "botlig" ;
  botswansk_av_1_A = mkA "botswansk" ;
  bottendaalig_av_1_1_A = mkA "bottendålig" ;
  bottenhederlig_av_1_A = mkA "bottenhederlig" ;
  bottenloes_av_1_1_A = mkA "bottenlös" ;
  bottnisk_av_1_A = mkA "bottnisk" ;
  bovaktig_av_1_A = mkA "bovaktig" ;
  brackig_av_1_A = mkA "brackig" ;
  bragdmaessig_av_1_1_A = mkA "bragdmässig" ;
  brakycefal_av_1_A = mkA "brakycefal" ;
  bramansk_av_1_A = mkA "bramansk" ;
  brandfarlig_av_1_A = mkA "brandfarlig" ;
  brandfri_av_1_A = mkA "brandfri" ;
  brandgul_av_1_A = mkA "brandgul" ;
  brandhaerdig_av_1_1_A = mkA "brandhärdig" ;
  brandsaeker_av_1_1_A = mkA "brandsäker" ;
  branschmaessig_av_1_1_A = mkA "branschmässig" ;
  brasiliansk_av_1_A = mkA "brasiliansk" ;
  bred_av_1_A = mkA "bred" ;
  bredbar_av_1_A = mkA "bredbar" ;
  bredbladig_av_1_A = mkA "bredbladig" ;
  bredbraettig_av_1_1_A = mkA "bredbrättig" ;
  breddmaessig_av_1_1_A = mkA "breddmässig" ;
  bredrandig_av_1_A = mkA "bredrandig" ;
  bredskyggig_av_1_A = mkA "bredskyggig" ;
  bredspaarig_av_1_1_A = mkA "bredspårig" ;
  bretagnisk_av_1_A = mkA "bretagnisk" ;
  bretonsk_av_1_A = mkA "bretonsk" ;
  briketterbar_av_1_A = mkA "briketterbar" ;
  briserbar_av_1_A = mkA "briserbar" ;
  bristfaellig_av_1_1_A = mkA "bristfällig" ;
  britannisk_av_1_A = mkA "britannisk" ;
  brittisk_av_1_A = mkA "brittisk" ;
  broderbar_av_1_A = mkA "broderbar" ;
  broderlig_av_1_A = mkA "broderlig" ;
  brokbladig_av_1_A = mkA "brokbladig" ;
  brokblommig_av_1_A = mkA "brokblommig" ;
  brokig_av_1_A = mkA "brokig" ;
  bromerbar_av_1_A = mkA "bromerbar" ;
  bronserbar_av_1_A = mkA "bronserbar" ;
  broscherbar_av_1_A = mkA "broscherbar" ;
  brottslig_av_1_A = mkA "brottslig" ;
  brukbar_av_1_A = mkA "brukbar" ;
  bruklig_av_1_A = mkA "bruklig" ;
  brun_av_1_A = mkA "brun" ;
  brunaktig_av_1_A = mkA "brunaktig" ;
  bruneisk_av_1_A = mkA "bruneisk" ;
  brunerbar_av_1_A = mkA "brunerbar" ;
  brunett_av_1_A = mkA "brunett" ;
  brungul_av_1_A = mkA "brungul" ;
  brunhaarig_av_1_1_A = mkA "brunhårig" ;
  brunmurrig_av_1_A = mkA "brunmurrig" ;
  brunnskall_av_1_A = mkA "brunnskall" ;
  brunrutig_av_1_A = mkA "brunrutig" ;
  brunroed_av_1_1_A = mkA "brunröd" ;
  brunsmutsig_av_1_A = mkA "brunsmutsig" ;
  brunstig_av_1_A = mkA "brunstig" ;
  brutal_av_1_A = mkA "brutal" ;
  brutaliserbar_av_1_A = mkA "brutaliserbar" ;
  brydd_av_1_A = mkA "brydd" ;
  brysk_av_1_A = mkA "brysk" ;
  braecklig_av_1_1_A = mkA "bräcklig" ;
  braeddfull_av_1_1_A = mkA "bräddfull" ;
  braennbar_av_1_1_A = mkA "brännbar" ;
  braennhet_av_1_1_A = mkA "brännhet" ;
  braennlackerbar_av_1_1_A = mkA "brännlackerbar" ;
  braenslesnaal_av_1_1_A = mkA "bränslesnål" ;
  braeserbar_av_1_1_A = mkA "bräserbar" ;
  braad_av_1_1_A = mkA "bråd" ;
  braaddjup_av_1_1_A = mkA "bråddjup" ;
  braakig_av_1_1_A = mkA "bråkig" ;
  broedloes_av_1_1_A = mkA "brödlös" ;
  broestsjuk_av_1_1_A = mkA "bröstsjuk" ;
  bubblig_av_1_A = mkA "bubblig" ;
  bucklig_av_1_A = mkA "bucklig" ;
  buddhistisk_av_1_A = mkA "buddhistisk" ;
  buddistisk_av_1_A = mkA "buddistisk" ;
  budgeterbar_av_1_A = mkA "budgeterbar" ;
  budgetmaessig_av_1_1_A = mkA "budgetmässig" ;
  budgetpolitisk_av_1_A = mkA "budgetpolitisk" ;
  budgetaer_av_1_1_A = mkA "budgetär" ;
  budoarmaessig_av_1_1_A = mkA "budoarmässig" ;
  buffelaktig_av_1_A = mkA "buffelaktig" ;
  bufflig_av_1_A = mkA "bufflig" ;
  bukformig_av_1_A = mkA "bukformig" ;
  bukig_av_1_A = mkA "bukig" ;
  bukolisk_av_1_A = mkA "bukolisk" ;
  buktig_av_1_A = mkA "buktig" ;
  bulgarisk_av_1_A = mkA "bulgarisk" ;
  bullerutsatt_av_1_A = mkA "bullerutsatt" ;
  bullig_av_1_A = mkA "bullig" ;
  bullrig_av_1_A = mkA "bullrig" ;
  bulsig_av_1_A = mkA "bulsig" ;
  burdus_av_1_A = mkA "burdus" ;
  burkinsk_av_1_A = mkA "burkinsk" ;
  burlesk_av_1_A = mkA "burlesk" ;
  burmansk_av_1_A = mkA "burmansk" ;
  burmesisk_av_1_A = mkA "burmesisk" ;
  burrig_av_1_A = mkA "burrig" ;
  burschikos_av_1_A = mkA "burschikos" ;
  burundisk_av_1_A = mkA "burundisk" ;
  busenkel_av_1_A = mkA "busenkel" ;
  busig_av_1_A = mkA "busig" ;
  buskablyg_av_1_A = mkA "buskablyg" ;
  buskig_av_1_A = mkA "buskig" ;
  bussig_av_1_A = mkA "bussig" ;
  buteljerbar_av_1_A = mkA "buteljerbar" ;
  buteljgroen_av_1_1_A = mkA "buteljgrön" ;
  butter_av_1_A = mkA "butter" ;
  byggnadsmaessig_av_1_1_A = mkA "byggnadsmässig" ;
  byig_av_1_A = mkA "byig" ;
  bylsig_av_1_A = mkA "bylsig" ;
  byraakratiserbar_av_1_1_A = mkA "byråkratiserbar" ;
  byraakratisk_av_1_1_A = mkA "byråkratisk" ;
  bysantinsk_av_1_A = mkA "bysantinsk" ;
  byxloes_av_1_1_A = mkA "byxlös" ;
  baeng_av_1_1_A = mkA "bäng" ;
  baerbar_av_1_1_A = mkA "bärbar" ;
  baerig_av_1_1_A = mkA "bärig" ;
  baerkraftig_av_1_1_A = mkA "bärkraftig" ;
  baagformig_av_1_1_A = mkA "bågformig" ;
  baagig_av_1_1_A = mkA "bågig" ;
  baangstyrig_av_1_1_A = mkA "bångstyrig" ;
  baatformig_av_1_1_A = mkA "båtformig" ;
  boehmisk_av_1_1_A = mkA "böhmisk" ;
  boejbar_av_1_1_A = mkA "böjbar" ;
  boejlig_av_1_1_A = mkA "böjlig" ;
  boekig_av_1_1_A = mkA "bökig" ;
  boenformig_av_1_1_A = mkA "bönformig" ;
  boenlig_av_1_1_A = mkA "bönlig" ;
  boerdig_av_1_1_A = mkA "bördig" ;
  boerdig_av_2_1_A = mkA "bördig" ;
  boersmaessig_av_1_1_A = mkA "börsmässig" ;
  boersnoterbar_av_1_1_A = mkA "börsnoterbar" ;
  camouflerbar_av_1_A = mkA "camouflerbar" ;
  cartesiansk_av_1_A = mkA "cartesiansk" ;
  cederbar_av_1_A = mkA "cederbar" ;
  celeber_av_1_A = mkA "celeber" ;
  celebrerbar_av_1_A = mkA "celebrerbar" ;
  cellulaer_av_1_1_A = mkA "cellulär" ;
  cementerbar_av_1_A = mkA "cementerbar" ;
  censurerbar_av_1_A = mkA "censurerbar" ;
  centimeterlaang_av_1_1_A = mkA "centimeterlång" ;
  centimetertjock_av_1_A = mkA "centimetertjock" ;
  central_av_1_A = mkA "central" ;
  centralafrikansk_av_1_A = mkA "centralafrikansk" ;
  centralamerikansk_av_1_A = mkA "centralamerikansk" ;
  centraleuropeisk_av_1_A = mkA "centraleuropeisk" ;
  centraliserbar_av_1_A = mkA "centraliserbar" ;
  centralistisk_av_1_A = mkA "centralistisk" ;
  centrallyrisk_av_1_A = mkA "centrallyrisk" ;
  centrerbar_av_1_A = mkA "centrerbar" ;
  centrifugal_av_1_A = mkA "centrifugal" ;
  centrifugerbar_av_1_A = mkA "centrifugerbar" ;
  centripetal_av_1_A = mkA "centripetal" ;
  centrisk_av_1_A = mkA "centrisk" ;
  cerebral_av_1_A = mkA "cerebral" ;
  cerebrospinal_av_1_A = mkA "cerebrospinal" ;
  ceremoniell_av_1_A = mkA "ceremoniell" ;
  ceremonioes_av_1_1_A = mkA "ceremoniös" ;
  cernerbar_av_1_A = mkA "cernerbar" ;
  cesarisk_av_1_A = mkA "cesarisk" ;
  chansloes_av_1_1_A = mkA "chanslös" ;
  chansmaessig_av_1_1_A = mkA "chansmässig" ;
  chargerbar_av_1_A = mkA "chargerbar" ;
  charlatanmaessig_av_1_1_A = mkA "charlatanmässig" ;
  charmerbar_av_1_A = mkA "charmerbar" ;
  charmfull_av_1_A = mkA "charmfull" ;
  charmig_av_1_A = mkA "charmig" ;
  charmloes_av_1_1_A = mkA "charmlös" ;
  chassidistisk_av_1_A = mkA "chassidistisk" ;
  chauvinistisk_av_1_A = mkA "chauvinistisk" ;
  chevaleresk_av_1_A = mkA "chevaleresk" ;
  chevroterbar_av_1_A = mkA "chevroterbar" ;
  chic_av_1_A = mkA "chic" ;
  chiffrerbar_av_1_A = mkA "chiffrerbar" ;
  chikanerbar_av_1_A = mkA "chikanerbar" ;
  chilensk_av_1_A = mkA "chilensk" ;
  chockerbar_av_1_A = mkA "chockerbar" ;
  chokladbrun_av_1_A = mkA "chokladbrun" ;
  chosig_av_1_A = mkA "chosig" ;
  cinnoberroed_av_1_1_A = mkA "cinnoberröd" ;
  cirkulerbar_av_1_A = mkA "cirkulerbar" ;
  cirkulaer_av_1_1_A = mkA "cirkulär" ;
  cirkumpolar_av_1_A = mkA "cirkumpolar" ;
  cirkumpolaer_av_1_1_A = mkA "cirkumpolär" ;
  cirkusmaessig_av_1_1_A = mkA "cirkusmässig" ;
  cisalpinsk_av_1_A = mkA "cisalpinsk" ;
  ciselerbar_av_1_A = mkA "ciselerbar" ;
  citerbar_av_1_A = mkA "citerbar" ;
  citrongul_av_1_A = mkA "citrongul" ;
  civil_av_1_A = mkA "civil" ;
  civilisatorisk_av_1_A = mkA "civilisatorisk" ;
  civiliserbar_av_1_A = mkA "civiliserbar" ;
  civilklaedd_av_1_1_A = mkA "civilklädd" ;
  civilmilitaer_av_1_1_A = mkA "civilmilitär" ;
  civilraettslig_av_1_1_A = mkA "civilrättslig" ;
  colombiansk_av_1_A = mkA "colombiansk" ;
  comorisk_av_1_A = mkA "comorisk" ;
  cool_av_1_A = mkA "cool" ;
  cortical_av_1_A = mkA "cortical" ;
  costaricansk_av_1_A = mkA "costaricansk" ;
  cubansk_av_1_A = mkA "cubansk" ;
  curaterbar_av_1_A = mkA "curaterbar" ;
  curerbar_av_1_A = mkA "curerbar" ;
  cybernetisk_av_1_A = mkA "cybernetisk" ;
  cyklisk_av_1_A = mkA "cyklisk" ;
  cyklotym_av_1_A = mkA "cyklotym" ;
  cylindrisk_av_1_A = mkA "cylindrisk" ;
  cynisk_av_1_A = mkA "cynisk" ;
  cypriotisk_av_1_A = mkA "cypriotisk" ;
  cytologisk_av_1_A = mkA "cytologisk" ;
  dadaistisk_av_1_A = mkA "dadaistisk" ;
  dagaktiv_av_1_A = mkA "dagaktiv" ;
  daggfrisk_av_1_A = mkA "daggfrisk" ;
  daggig_av_1_A = mkA "daggig" ;
  daggvaat_av_1_1_A = mkA "daggvåt" ;
  daglig_av_1_A = mkA "daglig" ;
  dagsaktuell_av_1_A = mkA "dagsaktuell" ;
  dagslaang_av_1_1_A = mkA "dagslång" ;
  dagspolitisk_av_1_A = mkA "dagspolitisk" ;
  daktylisk_av_1_A = mkA "daktylisk" ;
  dalamaessig_av_1_1_A = mkA "dalamässig" ;
  dalsk_av_1_A = mkA "dalsk" ;
  dalslaendsk_av_1_1_A = mkA "dalsländsk" ;
  damig_av_1_A = mkA "damig" ;
  dammfri_av_1_A = mkA "dammfri" ;
  dammig_av_1_A = mkA "dammig" ;
  dansk_av_1_A = mkA "dansk" ;
  dansmaessig_av_1_1_A = mkA "dansmässig" ;
  darrig_av_1_A = mkA "darrig" ;
  darwinistisk_av_1_A = mkA "darwinistisk" ;
  daskig_av_1_A = mkA "daskig" ;
  dassig_av_1_A = mkA "dassig" ;
  datamaskinell_av_1_A = mkA "datamaskinell" ;
  datapolitisk_av_1_A = mkA "datapolitisk" ;
  daterbar_av_1_A = mkA "daterbar" ;
  datoriserbar_av_1_A = mkA "datoriserbar" ;
  datumparkerbar_av_1_A = mkA "datumparkerbar" ;
  debarkerbar_av_1_A = mkA "debarkerbar" ;
  debatterbar_av_1_A = mkA "debatterbar" ;
  debattmaessig_av_1_1_A = mkA "debattmässig" ;
  debil_av_1_A = mkA "debil" ;
  debiterbar_av_1_A = mkA "debiterbar" ;
  decentraliserbar_av_1_A = mkA "decentraliserbar" ;
  dechiffrerbar_av_1_A = mkA "dechiffrerbar" ;
  decimerbar_av_1_A = mkA "decimerbar" ;
  decimeterlaang_av_1_1_A = mkA "decimeterlång" ;
  dedicerbar_av_1_A = mkA "dedicerbar" ;
  dedikerbar_av_1_A = mkA "dedikerbar" ;
  deducerbar_av_1_A = mkA "deducerbar" ;
  deduktiv_av_1_A = mkA "deduktiv" ;
  defaitistisk_av_1_A = mkA "defaitistisk" ;
  defensiv_av_1_A = mkA "defensiv" ;
  defilerbar_av_1_A = mkA "defilerbar" ;
  definierbar_av_1_A = mkA "definierbar" ;
  definitionsmaessig_av_1_1_A = mkA "definitionsmässig" ;
  definitiv_av_1_A = mkA "definitiv" ;
  deflorerbar_av_1_A = mkA "deflorerbar" ;
  deformerbar_av_1_A = mkA "deformerbar" ;
  degenerativ_av_1_A = mkA "degenerativ" ;
  degenererbar_av_1_A = mkA "degenererbar" ;
  degig_av_1_A = mkA "degig" ;
  degraderbar_av_1_A = mkA "degraderbar" ;
  deiktisk_av_1_A = mkA "deiktisk" ;
  deistisk_av_1_A = mkA "deistisk" ;
  dejlig_av_1_A = mkA "dejlig" ;
  dekadisk_av_1_A = mkA "dekadisk" ;
  dekanterbar_av_1_A = mkA "dekanterbar" ;
  dekapiterbar_av_1_A = mkA "dekapiterbar" ;
  deklamatorisk_av_1_A = mkA "deklamatorisk" ;
  deklamerbar_av_1_A = mkA "deklamerbar" ;
  deklarerbar_av_1_A = mkA "deklarerbar" ;
  deklasserbar_av_1_A = mkA "deklasserbar" ;
  deklinerbar_av_1_A = mkA "deklinerbar" ;
  dekorativ_av_1_A = mkA "dekorativ" ;
  dekorerbar_av_1_A = mkA "dekorerbar" ;
  dekouragerbar_av_1_A = mkA "dekouragerbar" ;
  dekreterbar_av_1_A = mkA "dekreterbar" ;
  delaktig_av_1_A = mkA "delaktig" ;
  delbar_av_1_A = mkA "delbar" ;
  delegerbar_av_1_A = mkA "delegerbar" ;
  delicioes_av_1_1_A = mkA "deliciös" ;
  deltidssjuk_av_1_A = mkA "deltidssjuk" ;
  delvis_av_1_A = mkA "delvis" ;
  demagogisk_av_1_A = mkA "demagogisk" ;
  demaskerbar_av_1_A = mkA "demaskerbar" ;
  dement_av_1_A = mkA "dement" ;
  dementerbar_av_1_A = mkA "dementerbar" ;
  demilitariserbar_av_1_A = mkA "demilitariserbar" ;
  demobiliserbar_av_1_A = mkA "demobiliserbar" ;
  demografisk_av_1_A = mkA "demografisk" ;
  demokratiserbar_av_1_A = mkA "demokratiserbar" ;
  demokratisk_av_1_A = mkA "demokratisk" ;
  demolerbar_av_1_A = mkA "demolerbar" ;
  demoniserbar_av_1_A = mkA "demoniserbar" ;
  demonisk_av_1_A = mkA "demonisk" ;
  demonologisk_av_1_A = mkA "demonologisk" ;
  demonstrativ_av_1_A = mkA "demonstrativ" ;
  demonstrerbar_av_1_A = mkA "demonstrerbar" ;
  demonterbar_av_1_A = mkA "demonterbar" ;
  demoraliserbar_av_1_A = mkA "demoraliserbar" ;
  denaturaliserbar_av_1_A = mkA "denaturaliserbar" ;
  denaturerbar_av_1_A = mkA "denaturerbar" ;
  denotativ_av_1_A = mkA "denotativ" ;
  denoterbar_av_1_A = mkA "denoterbar" ;
  dental_av_1_A = mkA "dental" ;
  denuderbar_av_1_A = mkA "denuderbar" ;
  deodoriserbar_av_1_A = mkA "deodoriserbar" ;
  departemental_av_1_A = mkA "departemental" ;
  depatrierbar_av_1_A = mkA "depatrierbar" ;
  depenserbar_av_1_A = mkA "depenserbar" ;
  deplacerbar_av_1_A = mkA "deplacerbar" ;
  deponentiell_av_1_A = mkA "deponentiell" ;
  deponerbar_av_1_A = mkA "deponerbar" ;
  deporterbar_av_1_A = mkA "deporterbar" ;
  deppig_av_1_A = mkA "deppig" ;
  deprecierbar_av_1_A = mkA "deprecierbar" ;
  depressiv_av_1_A = mkA "depressiv" ;
  derangerbar_av_1_A = mkA "derangerbar" ;
  deriverbar_av_1_A = mkA "deriverbar" ;
  dermatologisk_av_1_A = mkA "dermatologisk" ;
  desarmerbar_av_1_A = mkA "desarmerbar" ;
  desavouerbar_av_1_A = mkA "desavouerbar" ;
  desensibiliserbar_av_1_A = mkA "desensibiliserbar" ;
  designerbar_av_1_A = mkA "designerbar" ;
  designmaessig_av_1_1_A = mkA "designmässig" ;
  desinfekterbar_av_1_A = mkA "desinfekterbar" ;
  desinficerbar_av_1_A = mkA "desinficerbar" ;
  desinformerbar_av_1_A = mkA "desinformerbar" ;
  deskriptiv_av_1_A = mkA "deskriptiv" ;
  desorganiserbar_av_1_A = mkA "desorganiserbar" ;
  despotisk_av_1_A = mkA "despotisk" ;
  destabiliserbar_av_1_A = mkA "destabiliserbar" ;
  destillerbar_av_1_A = mkA "destillerbar" ;
  destinerbar_av_1_A = mkA "destinerbar" ;
  destruerbar_av_1_A = mkA "destruerbar" ;
  destruktiv_av_1_A = mkA "destruktiv" ;
  detacherbar_av_1_A = mkA "detacherbar" ;
  detaljrik_av_1_A = mkA "detaljrik" ;
  detekterbar_av_1_A = mkA "detekterbar" ;
  detektiv_av_1_A = mkA "detektiv" ;
  determinativ_av_1_A = mkA "determinativ" ;
  determinerbar_av_1_A = mkA "determinerbar" ;
  deterministisk_av_1_A = mkA "deterministisk" ;
  detonerbar_av_1_A = mkA "detonerbar" ;
  detroniserbar_av_1_A = mkA "detroniserbar" ;
  devalverbar_av_1_A = mkA "devalverbar" ;
  diabolisk_av_1_A = mkA "diabolisk" ;
  diagnosticerbar_av_1_A = mkA "diagnosticerbar" ;
  diagnostiserbar_av_1_A = mkA "diagnostiserbar" ;
  diagnostisk_av_1_A = mkA "diagnostisk" ;
  diagonal_av_1_A = mkA "diagonal" ;
  diakritisk_av_1_A = mkA "diakritisk" ;
  diakron_av_1_A = mkA "diakron" ;
  diakronisk_av_1_A = mkA "diakronisk" ;
  dialektal_av_1_A = mkA "dialektal" ;
  dialektgeografisk_av_1_A = mkA "dialektgeografisk" ;
  dialektisk_av_1_A = mkA "dialektisk" ;
  dialektologisk_av_1_A = mkA "dialektologisk" ;
  dialogisk_av_1_A = mkA "dialogisk" ;
  dialyserbar_av_1_A = mkA "dialyserbar" ;
  dialytisk_av_1_A = mkA "dialytisk" ;
  diamantprydd_av_1_A = mkA "diamantprydd" ;
  diametral_av_1_A = mkA "diametral" ;
  diastolisk_av_1_A = mkA "diastolisk" ;
  diatonisk_av_1_A = mkA "diatonisk" ;
  didaktisk_av_1_A = mkA "didaktisk" ;
  dietetisk_av_1_A = mkA "dietetisk" ;
  dietisk_av_1_A = mkA "dietisk" ;
  differentiell_av_1_A = mkA "differentiell" ;
  differentierbar_av_1_A = mkA "differentierbar" ;
  diffunderbar_av_1_A = mkA "diffunderbar" ;
  diffus_av_1_A = mkA "diffus" ;
  diftongerbar_av_1_A = mkA "diftongerbar" ;
  diger_av_1_A = mkA "diger" ;
  digererbar_av_1_A = mkA "digererbar" ;
  digital_av_1_A = mkA "digital" ;
  diklin_av_1_A = mkA "diklin" ;
  dikotyledon_av_1_A = mkA "dikotyledon" ;
  diktatorisk_av_1_A = mkA "diktatorisk" ;
  dikterbar_av_1_A = mkA "dikterbar" ;
  diktmaessig_av_1_1_A = mkA "diktmässig" ;
  dilettantisk_av_1_A = mkA "dilettantisk" ;
  dilettantmaessig_av_1_1_A = mkA "dilettantmässig" ;
  dimensionerbar_av_1_A = mkA "dimensionerbar" ;
  dimensionsloes_av_1_1_A = mkA "dimensionslös" ;
  diminutiv_av_1_A = mkA "diminutiv" ;
  dimmig_av_1_A = mkA "dimmig" ;
  dimorf_av_1_A = mkA "dimorf" ;
  dionysisk_av_1_A = mkA "dionysisk" ;
  dioptrisk_av_1_A = mkA "dioptrisk" ;
  diplomatarisk_av_1_A = mkA "diplomatarisk" ;
  diplomatisk_av_1_A = mkA "diplomatisk" ;
  diplomatisk_av_2_A = mkA "diplomatisk" ;
  diplomerbar_av_1_A = mkA "diplomerbar" ;
  dirigerbar_av_1_A = mkA "dirigerbar" ;
  disambiguerbar_av_1_A = mkA "disambiguerbar" ;
  disciplinerbar_av_1_A = mkA "disciplinerbar" ;
  disciplinaer_av_1_1_A = mkA "disciplinär" ;
  disharmonierbar_av_1_A = mkA "disharmonierbar" ;
  disharmonisk_av_1_A = mkA "disharmonisk" ;
  disig_av_1_A = mkA "disig" ;
  disjunktiv_av_1_A = mkA "disjunktiv" ;
  diskonterbar_av_1_A = mkA "diskonterbar" ;
  diskontinuerlig_av_1_A = mkA "diskontinuerlig" ;
  diskrediterbar_av_1_A = mkA "diskrediterbar" ;
  diskriminerbar_av_1_A = mkA "diskriminerbar" ;
  diskursiv_av_1_A = mkA "diskursiv" ;
  diskutabel_av_1_A = mkA "diskutabel" ;
  diskuterbar_av_1_A = mkA "diskuterbar" ;
  diskvalificerbar_av_1_A = mkA "diskvalificerbar" ;
  dispascherbar_av_1_A = mkA "dispascherbar" ;
  dispenserbar_av_1_A = mkA "dispenserbar" ;
  dispergerbar_av_1_A = mkA "dispergerbar" ;
  dispers_av_1_A = mkA "dispers" ;
  disponerbar_av_1_A = mkA "disponerbar" ;
  disponibel_av_1_A = mkA "disponibel" ;
  dispositiv_av_1_A = mkA "dispositiv" ;
  disproportionerlig_av_1_A = mkA "disproportionerlig" ;
  disputerbar_av_1_A = mkA "disputerbar" ;
  dissekerbar_av_1_A = mkA "dissekerbar" ;
  dissimilerbar_av_1_A = mkA "dissimilerbar" ;
  dissocierbar_av_1_A = mkA "dissocierbar" ;
  distanserbar_av_1_A = mkA "distanserbar" ;
  distraherbar_av_1_A = mkA "distraherbar" ;
  distribuerbar_av_1_A = mkA "distribuerbar" ;
  distributiv_av_1_A = mkA "distributiv" ;
  dityrambisk_av_1_A = mkA "dityrambisk" ;
  divergerbar_av_1_A = mkA "divergerbar" ;
  diversifierbar_av_1_A = mkA "diversifierbar" ;
  dividerbar_av_1_A = mkA "dividerbar" ;
  divig_av_1_A = mkA "divig" ;
  divinatorisk_av_1_A = mkA "divinatorisk" ;
  djiboutisk_av_1_A = mkA "djiboutisk" ;
  djup_av_1_A = mkA "djup" ;
  djupgroen_av_1_1_A = mkA "djupgrön" ;
  djuproed_av_1_1_A = mkA "djupröd" ;
  djupsinnig_av_1_A = mkA "djupsinnig" ;
  djurisk_av_1_A = mkA "djurisk" ;
  djurskyddsmaessig_av_1_1_A = mkA "djurskyddsmässig" ;
  djurvaenlig_av_1_1_A = mkA "djurvänlig" ;
  djaeklig_av_1_1_A = mkA "djäklig" ;
  djaerv_av_1_1_A = mkA "djärv" ;
  djaevelsk_av_1_1_A = mkA "djävelsk" ;
  djaevlig_av_1_1_A = mkA "djävlig" ;
  djaevulsk_av_1_1_A = mkA "djävulsk" ;
  djaevulusisk_av_1_1_A = mkA "djävulusisk" ;
  docerbar_av_1_A = mkA "docerbar" ;
  dockaktig_av_1_A = mkA "dockaktig" ;
  docksoet_av_1_1_A = mkA "docksöt" ;
  doftloes_av_1_1_A = mkA "doftlös" ;
  doftmarkerbar_av_1_A = mkA "doftmarkerbar" ;
  doftsvag_av_1_A = mkA "doftsvag" ;
  dogmatiserbar_av_1_A = mkA "dogmatiserbar" ;
  dogmatisk_av_1_A = mkA "dogmatisk" ;
  doktrinaer_av_1_1_A = mkA "doktrinär" ;
  dokumentarisk_av_1_A = mkA "dokumentarisk" ;
  dokumenterbar_av_1_A = mkA "dokumenterbar" ;
  dokumentaer_av_1_1_A = mkA "dokumentär" ;
  dolikocefal_av_1_A = mkA "dolikocefal" ;
  dolsk_av_1_A = mkA "dolsk" ;
  domesticerbar_av_1_A = mkA "domesticerbar" ;
  domfoer_av_1_1_A = mkA "domför" ;
  domicilierbar_av_1_A = mkA "domicilierbar" ;
  dominerbar_av_1_A = mkA "dominerbar" ;
  dominikansk_av_1_A = mkA "dominikansk" ;
  dominikisk_av_1_A = mkA "dominikisk" ;
  dompterbar_av_1_A = mkA "dompterbar" ;
  domstolsmaessig_av_1_1_A = mkA "domstolsmässig" ;
  donerbar_av_1_A = mkA "donerbar" ;
  dopaminkaenslig_av_1_1_A = mkA "dopaminkänslig" ;
  dorisk_av_1_A = mkA "dorisk" ;
  dorsal_av_1_A = mkA "dorsal" ;
  dorsk_av_1_A = mkA "dorsk" ;
  doserbar_av_1_A = mkA "doserbar" ;
  dosserbar_av_1_A = mkA "dosserbar" ;
  doterbar_av_1_A = mkA "doterbar" ;
  dotterlig_av_1_A = mkA "dotterlig" ;
  dov_av_1_A = mkA "dov" ;
  dragerbar_av_1_A = mkA "dragerbar" ;
  dragig_av_1_A = mkA "dragig" ;
  drakonisk_av_1_A = mkA "drakonisk" ;
  dramatiserbar_av_1_A = mkA "dramatiserbar" ;
  dramatisk_av_1_A = mkA "dramatisk" ;
  dramaturgisk_av_1_A = mkA "dramaturgisk" ;
  draperbar_av_1_A = mkA "draperbar" ;
  drastisk_av_1_A = mkA "drastisk" ;
  dresserbar_av_1_A = mkA "dresserbar" ;
  drickbar_av_1_A = mkA "drickbar" ;
  driftig_av_1_A = mkA "driftig" ;
  driftmaessig_av_1_1_A = mkA "driftmässig" ;
  driftsmaessig_av_1_1_A = mkA "driftsmässig" ;
  driftsaeker_av_1_1_A = mkA "driftsäker" ;
  driftsaekerhetsmaessig_av_1_1_A = mkA "driftsäkerhetsmässig" ;
  dristig_av_1_A = mkA "dristig" ;
  drottninglik_av_1_A = mkA "drottninglik" ;
  drulig_av_1_A = mkA "drulig" ;
  drullig_av_1_A = mkA "drullig" ;
  drumlig_av_1_A = mkA "drumlig" ;
  drummelaktig_av_1_A = mkA "drummelaktig" ;
  dryg_av_1_A = mkA "dryg" ;
  draeglig_av_1_1_A = mkA "dräglig" ;
  draektig_av_1_1_A = mkA "dräktig" ;
  draenerbar_av_1_1_A = mkA "dränerbar" ;
  draenkbar_av_1_1_A = mkA "dränkbar" ;
  draaplig_av_1_1_A = mkA "dråplig" ;
  droemlik_av_1_1_A = mkA "drömlik" ;
  droemsk_av_1_1_A = mkA "drömsk" ;
  dualistisk_av_1_A = mkA "dualistisk" ;
  dubbel_av_1_A = mkA "dubbel" ;
  dubbelexponerbar_av_1_A = mkA "dubbelexponerbar" ;
  dubbelpipig_av_1_A = mkA "dubbelpipig" ;
  dubbelsidig_av_1_A = mkA "dubbelsidig" ;
  dubbelspaarig_av_1_1_A = mkA "dubbelspårig" ;
  dubbeltraadig_av_1_1_A = mkA "dubbeltrådig" ;
  dubbeltydig_av_1_A = mkA "dubbeltydig" ;
  dubblerbar_av_1_A = mkA "dubblerbar" ;
  dubioes_av_1_1_A = mkA "dubiös" ;
  duglig_av_1_A = mkA "duglig" ;
  duktig_av_1_A = mkA "duktig" ;
  dumdristig_av_1_A = mkA "dumdristig" ;
  dumdryg_av_1_A = mkA "dumdryg" ;
  dunig_av_1_A = mkA "dunig" ;
  dunkel_av_1_A = mkA "dunkel" ;
  dunlaett_av_1_1_A = mkA "dunlätt" ;
  dunstig_av_1_A = mkA "dunstig" ;
  duperbar_av_1_A = mkA "duperbar" ;
  duplicerbar_av_1_A = mkA "duplicerbar" ;
  durativ_av_1_A = mkA "durativ" ;
  dvaergaktig_av_1_1_A = mkA "dvärgaktig" ;
  dybloet_av_1_1_A = mkA "dyblöt" ;
  dygdig_av_1_A = mkA "dygdig" ;
  dygnsvis_av_1_A = mkA "dygnsvis" ;
  dyig_av_1_A = mkA "dyig" ;
  dynamisk_av_1_A = mkA "dynamisk" ;
  dynamistisk_av_1_A = mkA "dynamistisk" ;
  dynastisk_av_1_A = mkA "dynastisk" ;
  dyngrak_av_1_A = mkA "dyngrak" ;
  dyngsur_av_1_A = mkA "dyngsur" ;
  dyr_av_1_A = mkA "dyr" ;
  dyrbar_av_1_A = mkA "dyrbar" ;
  dysfunktionell_av_1_A = mkA "dysfunktionell" ;
  dyslektisk_av_1_A = mkA "dyslektisk" ;
  dyster_av_1_A = mkA "dyster" ;
  dystopisk_av_1_A = mkA "dystopisk" ;
  dystrof_av_1_A = mkA "dystrof" ;
  dyvaat_av_1_1_A = mkA "dyvåt" ;
  daadloes_av_1_1_A = mkA "dådlös" ;
  daaraktig_av_1_1_A = mkA "dåraktig" ;
  daarhusmaessig_av_1_1_A = mkA "dårhusmässig" ;
  daasig_av_1_1_A = mkA "dåsig" ;
  doeblek_av_1_1_A = mkA "döblek" ;
  doed_av_1_1_A = mkA "död" ;
  doedfull_av_1_1_A = mkA "dödfull" ;
  doedfoedd_av_1_1_A = mkA "dödfödd" ;
  doedlig_av_1_1_A = mkA "dödlig" ;
  doedsblek_av_1_1_A = mkA "dödsblek" ;
  doedssjuk_av_1_1_A = mkA "dödssjuk" ;
  doedstraakig_av_1_1_A = mkA "dödstråkig" ;
  doedstroett_av_1_1_A = mkA "dödstrött" ;
  doefull_av_1_1_A = mkA "döfull" ;
  doesjuk_av_1_1_A = mkA "dösjuk" ;
  doeskraj_av_1_1_A = mkA "döskraj" ;
  doetraakig_av_1_1_A = mkA "dötråkig" ;
  doetroett_av_1_1_A = mkA "dötrött" ;
  doev_av_1_1_A = mkA "döv" ;
  ecklesiastik_av_1_A = mkA "ecklesiastik" ;
  ecklesiastisk_av_1_A = mkA "ecklesiastisk" ;
  ecuadoriansk_av_1_A = mkA "ecuadoriansk" ;
  ederbar_av_1_A = mkA "ederbar" ;
  edlig_av_1_A = mkA "edlig" ;
  efemaer_av_1_1_A = mkA "efemär" ;
  effacerbar_av_1_A = mkA "effacerbar" ;
  effektfull_av_1_A = mkA "effektfull" ;
  effektiv_av_1_A = mkA "effektiv" ;
  effektiverbar_av_1_A = mkA "effektiverbar" ;
  effektiviserbar_av_1_A = mkA "effektiviserbar" ;
  effektivitetsmaessig_av_1_1_A = mkA "effektivitetsmässig" ;
  effektloes_av_1_1_A = mkA "effektlös" ;
  effektmaessig_av_1_1_A = mkA "effektmässig" ;
  effektuerbar_av_1_A = mkA "effektuerbar" ;
  efterdaterbar_av_1_A = mkA "efterdaterbar" ;
  efterdebiterbar_av_1_A = mkA "efterdebiterbar" ;
  efterdoemlig_av_1_1_A = mkA "efterdömlig" ;
  eftergivlig_av_1_A = mkA "eftergivlig" ;
  eftergymnasial_av_1_A = mkA "eftergymnasial" ;
  efterklok_av_1_A = mkA "efterklok" ;
  efterrationaliserbar_av_1_A = mkA "efterrationaliserbar" ;
  eftersynkroniserbar_av_1_A = mkA "eftersynkroniserbar" ;
  eftertaxerbar_av_1_A = mkA "eftertaxerbar" ;
  eftertrycklig_av_1_A = mkA "eftertrycklig" ;
  eftervis_av_1_A = mkA "eftervis" ;
  egal_av_1_A = mkA "egal" ;
  egaliserbar_av_1_A = mkA "egaliserbar" ;
  egalitaer_av_1_1_A = mkA "egalitär" ;
  egeisk_av_1_A = mkA "egeisk" ;
  egendomlig_av_1_A = mkA "egendomlig" ;
  egendomsloes_av_1_1_A = mkA "egendomslös" ;
  egenhaendig_av_1_1_A = mkA "egenhändig" ;
  egenkaer_av_1_1_A = mkA "egenkär" ;
  egenmaektig_av_1_1_A = mkA "egenmäktig" ;
  egennyttig_av_1_A = mkA "egennyttig" ;
  egenraettfaerdig_av_1_1_A = mkA "egenrättfärdig" ;
  egenraadig_av_1_1_A = mkA "egenrådig" ;
  egensinnig_av_1_A = mkA "egensinnig" ;
  egentlig_av_1_A = mkA "egentlig" ;
  egenvarm_av_1_A = mkA "egenvarm" ;
  eggvass_av_1_A = mkA "eggvass" ;
  egocentrisk_av_1_A = mkA "egocentrisk" ;
  egoistisk_av_1_A = mkA "egoistisk" ;
  egyptisk_av_1_A = mkA "egyptisk" ;
  eidetisk_av_1_A = mkA "eidetisk" ;
  einsteinsk_av_1_A = mkA "einsteinsk" ;
  ekiperbar_av_1_A = mkA "ekiperbar" ;
  ekivok_av_1_A = mkA "ekivok" ;
  eklaterbar_av_1_A = mkA "eklaterbar" ;
  eklatt_av_1_A = mkA "eklatt" ;
  eklektisk_av_1_A = mkA "eklektisk" ;
  eklaererbar_av_1_1_A = mkA "eklärerbar" ;
  ekofascistisk_av_1_A = mkA "ekofascistisk" ;
  ekologisk_av_1_A = mkA "ekologisk" ;
  ekonomiserbar_av_1_A = mkA "ekonomiserbar" ;
  ekonomisk_politisk_av_1_A = mkA "ekonomisk-politisk" ;
  ekonomisk_av_1_A = mkA "ekonomisk" ;
  ekonomiskpolitisk_av_1_A = mkA "ekonomiskpolitisk" ;
  ekonomiskt_politisk_av_1_A = mkA "ekonomiskt-politisk" ;
  ekonomisktpolitisk_av_1_A = mkA "ekonomisktpolitisk" ;
  ekorroed_av_1_1_A = mkA "ekorröd" ;
  ekumenisk_av_1_A = mkA "ekumenisk" ;
  ekvatorial_av_1_A = mkA "ekvatorial" ;
  ekvatorialguineansk_av_1_A = mkA "ekvatorialguineansk" ;
  ekvatoriell_av_1_A = mkA "ekvatoriell" ;
  ekvilibristisk_av_1_A = mkA "ekvilibristisk" ;
  elaborerbar_av_1_A = mkA "elaborerbar" ;
  elak_av_1_A = mkA "elak" ;
  elastiserbar_av_1_A = mkA "elastiserbar" ;
  elastisk_av_1_A = mkA "elastisk" ;
  eldfarlig_av_1_A = mkA "eldfarlig" ;
  eldgaffelsrak_av_1_A = mkA "eldgaffelsrak" ;
  eldhaerdig_av_1_1_A = mkA "eldhärdig" ;
  eldig_av_1_A = mkA "eldig" ;
  eldroed_av_1_1_A = mkA "eldröd" ;
  eldsaeker_av_1_1_A = mkA "eldsäker" ;
  elegisk_av_1_A = mkA "elegisk" ;
  elektrificerbar_av_1_A = mkA "elektrificerbar" ;
  elektrifierbar_av_1_A = mkA "elektrifierbar" ;
  elektriserbar_av_1_A = mkA "elektriserbar" ;
  elektrisk_av_1_A = mkA "elektrisk" ;
  elektrokemisk_av_1_A = mkA "elektrokemisk" ;
  elektrolytisk_av_1_A = mkA "elektrolytisk" ;
  elektromagnetisk_av_1_A = mkA "elektromagnetisk" ;
  elektromekanisk_av_1_A = mkA "elektromekanisk" ;
  elektromotorisk_av_1_A = mkA "elektromotorisk" ;
  elektronisk_av_1_A = mkA "elektronisk" ;
  elektrostatisk_av_1_A = mkA "elektrostatisk" ;
  elektrosvag_av_1_A = mkA "elektrosvag" ;
  elektroteknisk_av_1_A = mkA "elektroteknisk" ;
  elementaer_av_1_1_A = mkA "elementär" ;
  elfenbensvit_av_1_A = mkA "elfenbensvit" ;
  eliderbar_av_1_A = mkA "eliderbar" ;
  eliminerbar_av_1_A = mkA "eliminerbar" ;
  elitisk_av_1_A = mkA "elitisk" ;
  elitistisk_av_1_A = mkA "elitistisk" ;
  elitmaessig_av_1_1_A = mkA "elitmässig" ;
  elitseriemaessig_av_1_1_A = mkA "elitseriemässig" ;
  elliptisk_av_1_A = mkA "elliptisk" ;
  eloxerbar_av_1_A = mkA "eloxerbar" ;
  eluderbar_av_1_A = mkA "eluderbar" ;
  eluerbar_av_1_A = mkA "eluerbar" ;
  eluvial_av_1_A = mkA "eluvial" ;
  elvadimensionell_av_1_A = mkA "elvadimensionell" ;
  elvaaarig_av_1_1_A = mkA "elvaårig" ;
  elyseisk_av_1_A = mkA "elyseisk" ;
  elaendig_av_1_1_A = mkA "eländig" ;
  emaljerbar_av_1_A = mkA "emaljerbar" ;
  emanciperbar_av_1_A = mkA "emanciperbar" ;
  emballerbar_av_1_A = mkA "emballerbar" ;
  embarkerbar_av_1_A = mkA "embarkerbar" ;
  embellerbar_av_1_A = mkA "embellerbar" ;
  emblematisk_av_1_A = mkA "emblematisk" ;
  embryonal_av_1_A = mkA "embryonal" ;
  embryonisk_av_1_A = mkA "embryonisk" ;
  emenderbar_av_1_A = mkA "emenderbar" ;
  emfatisk_av_1_A = mkA "emfatisk" ;
  emigrerbar_av_1_A = mkA "emigrerbar" ;
  emiratisk_av_1_A = mkA "emiratisk" ;
  emitterbar_av_1_A = mkA "emitterbar" ;
  emotionell_av_1_A = mkA "emotionell" ;
  emotiv_av_1_A = mkA "emotiv" ;
  empatisk_av_1_A = mkA "empatisk" ;
  empirisk_av_1_A = mkA "empirisk" ;
  empiristisk_av_1_A = mkA "empiristisk" ;
  emulgerbar_av_1_A = mkA "emulgerbar" ;
  enarmig_av_1_A = mkA "enarmig" ;
  enaxlig_av_1_A = mkA "enaxlig" ;
  enbasisk_av_1_A = mkA "enbasisk" ;
  encellig_av_1_A = mkA "encellig" ;
  encyklopedisk_av_1_A = mkA "encyklopedisk" ;
  endemisk_av_1_A = mkA "endemisk" ;
  endimensionell_av_1_A = mkA "endimensionell" ;
  endokrin_av_1_A = mkA "endokrin" ;
  endosserbar_av_1_A = mkA "endosserbar" ;
  endotermisk_av_1_A = mkA "endotermisk" ;
  endraektig_av_1_1_A = mkA "endräktig" ;
  energiloes_av_1_1_A = mkA "energilös" ;
  energimaessig_av_1_1_A = mkA "energimässig" ;
  energipolitisk_av_1_A = mkA "energipolitisk" ;
  energirik_av_1_A = mkA "energirik" ;
  energisk_av_1_A = mkA "energisk" ;
  energisnaal_av_1_1_A = mkA "energisnål" ;
  enerverbar_av_1_A = mkA "enerverbar" ;
  enfaldig_av_1_A = mkA "enfaldig" ;
  enfasig_av_1_A = mkA "enfasig" ;
  enformig_av_1_A = mkA "enformig" ;
  enfoedd_av_1_1_A = mkA "enfödd" ;
  engagerbar_av_1_A = mkA "engagerbar" ;
  engelsk_av_1_A = mkA "engelsk" ;
  engelskspraakig_av_1_1_A = mkA "engelskspråkig" ;
  engelskspaakig_av_1_1_A = mkA "engelskspåkig" ;
  enharmonisk_av_1_A = mkA "enharmonisk" ;
  enhetlig_av_1_A = mkA "enhetlig" ;
  enhjulig_av_1_A = mkA "enhjulig" ;
  enhjaertbladig_av_1_1_A = mkA "enhjärtbladig" ;
  enhaellig_av_1_1_A = mkA "enhällig" ;
  enig_av_1_A = mkA "enig" ;
  enigmatisk_av_1_A = mkA "enigmatisk" ;
  enkel_av_1_A = mkA "enkel" ;
  enkelnervig_av_1_A = mkA "enkelnervig" ;
  enkelpipig_av_1_A = mkA "enkelpipig" ;
  enkelspaarig_av_1_1_A = mkA "enkelspårig" ;
  enklitisk_av_1_A = mkA "enklitisk" ;
  enleverbar_av_1_A = mkA "enleverbar" ;
  enorm_av_1_A = mkA "enorm" ;
  enpolig_av_1_A = mkA "enpolig" ;
  enpucklig_av_1_A = mkA "enpucklig" ;
  enrollerbar_av_1_A = mkA "enrollerbar" ;
  enraadig_av_1_1_A = mkA "enrådig" ;
  ensidig_av_1_A = mkA "ensidig" ;
  ensilerbar_av_1_A = mkA "ensilerbar" ;
  enslig_av_1_A = mkA "enslig" ;
  enspraakig_av_1_1_A = mkA "enspråkig" ;
  enstavig_av_1_A = mkA "enstavig" ;
  enstjaernig_av_1_1_A = mkA "enstjärnig" ;
  enstaemmig_av_1_1_A = mkA "enstämmig" ;
  enstaendig_av_1_1_A = mkA "enständig" ;
  enstoerig_av_1_1_A = mkA "enstörig" ;
  entomologisk_av_1_A = mkA "entomologisk" ;
  entonig_av_1_A = mkA "entonig" ;
  entusiasmerbar_av_1_A = mkA "entusiasmerbar" ;
  entusiastisk_av_1_A = mkA "entusiastisk" ;
  entydig_av_1_A = mkA "entydig" ;
  envis_av_1_A = mkA "envis" ;
  envaeldig_av_1_1_A = mkA "enväldig" ;
  eolisk_av_1_A = mkA "eolisk" ;
  epidemiologisk_av_1_A = mkA "epidemiologisk" ;
  epidemisk_av_1_A = mkA "epidemisk" ;
  epigrammatisk_av_1_A = mkA "epigrammatisk" ;
  epikureisk_av_1_A = mkA "epikureisk" ;
  epilerbar_av_1_A = mkA "epilerbar" ;
  episk_av_1_A = mkA "episk" ;
  episkopal_av_1_A = mkA "episkopal" ;
  episodisk_av_1_A = mkA "episodisk" ;
  epistolaer_av_1_1_A = mkA "epistolär" ;
  epizoisk_av_1_A = mkA "epizoisk" ;
  erbarmlig_av_1_A = mkA "erbarmlig" ;
  eremitisk_av_1_A = mkA "eremitisk" ;
  erfarenhetsmaessig_av_1_1_A = mkA "erfarenhetsmässig" ;
  erforderlig_av_1_A = mkA "erforderlig" ;
  ergativ_av_1_A = mkA "ergativ" ;
  ergonometrisk_av_1_A = mkA "ergonometrisk" ;
  ergonomisk_av_1_A = mkA "ergonomisk" ;
  erigerbar_av_1_A = mkA "erigerbar" ;
  eritreansk_av_1_A = mkA "eritreansk" ;
  eroderbar_av_1_A = mkA "eroderbar" ;
  erotisk_av_1_A = mkA "erotisk" ;
  erotoman_av_1_A = mkA "erotoman" ;
  erratisk_av_1_A = mkA "erratisk" ;
  ersaettlig_av_1_1_A = mkA "ersättlig" ;
  eruptiv_av_1_A = mkA "eruptiv" ;
  eskalerbar_av_1_A = mkA "eskalerbar" ;
  eskapistisk_av_1_A = mkA "eskapistisk" ;
  eskatologisk_av_1_A = mkA "eskatologisk" ;
  eskorterbar_av_1_A = mkA "eskorterbar" ;
  esoterisk_av_1_A = mkA "esoterisk" ;
  essayistisk_av_1_A = mkA "essayistisk" ;
  essentiell_av_1_A = mkA "essentiell" ;
  essaeistisk_av_1_1_A = mkA "essäistisk" ;
  esteticerbar_av_1_A = mkA "esteticerbar" ;
  estetiserbar_av_1_A = mkA "estetiserbar" ;
  estetisk_av_1_A = mkA "estetisk" ;
  estimerbar_av_1_A = mkA "estimerbar" ;
  estlaendsk_av_1_1_A = mkA "estländsk" ;
  estnisk_av_1_A = mkA "estnisk" ;
  etablerbar_av_1_A = mkA "etablerbar" ;
  eteriserbar_av_1_A = mkA "eteriserbar" ;
  eterisk_av_1_A = mkA "eterisk" ;
  etiketterbar_av_1_A = mkA "etiketterbar" ;
  etikettsmaessig_av_1_1_A = mkA "etikettsmässig" ;
  etiologisk_av_1_A = mkA "etiologisk" ;
  etiopisk_av_1_A = mkA "etiopisk" ;
  etisk_av_1_A = mkA "etisk" ;
  etnisk_av_1_A = mkA "etnisk" ;
  etnocentrisk_av_1_A = mkA "etnocentrisk" ;
  etnografisk_av_1_A = mkA "etnografisk" ;
  etnologisk_av_1_A = mkA "etnologisk" ;
  etologisk_av_1_A = mkA "etologisk" ;
  etruskisk_av_1_A = mkA "etruskisk" ;
  ettrig_av_1_A = mkA "ettrig" ;
  ettaarig_av_1_1_A = mkA "ettårig" ;
  etymologiserbar_av_1_A = mkA "etymologiserbar" ;
  etymologisk_av_1_A = mkA "etymologisk" ;
  eufemistisk_av_1_A = mkA "eufemistisk" ;
  euforisk_av_1_A = mkA "euforisk" ;
  euklidisk_av_1_A = mkA "euklidisk" ;
  eurasisk_av_1_A = mkA "eurasisk" ;
  eurokommunistisk_av_1_A = mkA "eurokommunistisk" ;
  europeiserbar_av_1_A = mkA "europeiserbar" ;
  europeisk_av_1_A = mkA "europeisk" ;
  eutrof_av_1_A = mkA "eutrof" ;
  evakuerbar_av_1_A = mkA "evakuerbar" ;
  evaluerbar_av_1_A = mkA "evaluerbar" ;
  evalverbar_av_1_A = mkA "evalverbar" ;
  evangelisk_av_1_A = mkA "evangelisk" ;
  evaporerbar_av_1_A = mkA "evaporerbar" ;
  eventuell_av_1_A = mkA "eventuell" ;
  evig_av_1_A = mkA "evig" ;
  evinnerlig_av_1_A = mkA "evinnerlig" ;
  evolutionistisk_av_1_A = mkA "evolutionistisk" ;
  evolutionsmaessig_av_1_1_A = mkA "evolutionsmässig" ;
  evolutionaer_av_1_1_A = mkA "evolutionär" ;
  evaerdlig_av_1_1_A = mkA "evärdlig" ;
  examinerbar_av_1_A = mkA "examinerbar" ;
  excentrisk_av_1_A = mkA "excentrisk" ;
  exceptionell_av_1_A = mkA "exceptionell" ;
  excerperbar_av_1_A = mkA "excerperbar" ;
  exciterbar_av_1_A = mkA "exciterbar" ;
  exegetisk_av_1_A = mkA "exegetisk" ;
  exekutiv_av_1_A = mkA "exekutiv" ;
  exekutorisk_av_1_A = mkA "exekutorisk" ;
  exekverbar_av_1_A = mkA "exekverbar" ;
  exempelloes_av_1_1_A = mkA "exempellös" ;
  exemplarisk_av_1_A = mkA "exemplarisk" ;
  exemplifierbar_av_1_A = mkA "exemplifierbar" ;
  exercerbar_av_1_A = mkA "exercerbar" ;
  exhibitionistisk_av_1_A = mkA "exhibitionistisk" ;
  exigibel_av_1_A = mkA "exigibel" ;
  existentialistisk_av_1_A = mkA "existentialistisk" ;
  existentiell_av_1_A = mkA "existentiell" ;
  exklamatorisk_av_1_A = mkA "exklamatorisk" ;
  exkluderbar_av_1_A = mkA "exkluderbar" ;
  exklusiv_av_1_A = mkA "exklusiv" ;
  exkommunicerbar_av_1_A = mkA "exkommunicerbar" ;
  exkremental_av_1_A = mkA "exkremental" ;
  exorcistisk_av_1_A = mkA "exorcistisk" ;
  exoterisk_av_1_A = mkA "exoterisk" ;
  exotermisk_av_1_A = mkA "exotermisk" ;
  exotisk_av_1_A = mkA "exotisk" ;
  exotistisk_av_1_A = mkA "exotistisk" ;
  expanderbar_av_1_A = mkA "expanderbar" ;
  expansibel_av_1_A = mkA "expansibel" ;
  expansionistisk_av_1_A = mkA "expansionistisk" ;
  expansiv_av_1_A = mkA "expansiv" ;
  expatrierbar_av_1_A = mkA "expatrierbar" ;
  expedierbar_av_1_A = mkA "expedierbar" ;
  expektorerbar_av_1_A = mkA "expektorerbar" ;
  experimentell_av_1_A = mkA "experimentell" ;
  explanativ_av_1_A = mkA "explanativ" ;
  explicerbar_av_1_A = mkA "explicerbar" ;
  exploaterbar_av_1_A = mkA "exploaterbar" ;
  exploderbar_av_1_A = mkA "exploderbar" ;
  explosiv_av_1_A = mkA "explosiv" ;
  exponentiell_av_1_A = mkA "exponentiell" ;
  exponerbar_av_1_A = mkA "exponerbar" ;
  exporterbar_av_1_A = mkA "exporterbar" ;
  expressionistisk_av_1_A = mkA "expressionistisk" ;
  expressiv_av_1_A = mkA "expressiv" ;
  exproprierbar_av_1_A = mkA "exproprierbar" ;
  exstirperbar_av_1_A = mkA "exstirperbar" ;
  extatisk_av_1_A = mkA "extatisk" ;
  extemporerbar_av_1_A = mkA "extemporerbar" ;
  extensiv_av_1_A = mkA "extensiv" ;
  exterioer_av_1_1_A = mkA "exteriör" ;
  extern_av_1_A = mkA "extern" ;
  exterritoriell_av_1_A = mkA "exterritoriell" ;
  extraherbar_av_1_A = mkA "extraherbar" ;
  extrajudiciell_av_1_A = mkA "extrajudiciell" ;
  extramural_av_1_A = mkA "extramural" ;
  extraordinaer_av_1_1_A = mkA "extraordinär" ;
  extrapolerbar_av_1_A = mkA "extrapolerbar" ;
  extrauterin_av_1_A = mkA "extrauterin" ;
  extrem_av_1_A = mkA "extrem" ;
  extremistisk_av_1_A = mkA "extremistisk" ;
  extrinsisk_av_1_A = mkA "extrinsisk" ;
  fabelaktig_av_1_A = mkA "fabelaktig" ;
  fabricerbar_av_1_A = mkA "fabricerbar" ;
  fabriksmaessig_av_1_1_A = mkA "fabriksmässig" ;
  fabulerbar_av_1_A = mkA "fabulerbar" ;
  fabuloes_av_1_1_A = mkA "fabulös" ;
  facetterbar_av_1_A = mkA "facetterbar" ;
  facil_av_1_A = mkA "facil" ;
  fackfoereningsfientlig_av_1_1_A = mkA "fackföreningsfientlig" ;
  fackkunnig_av_1_A = mkA "fackkunnig" ;
  facklig_politisk_av_1_A = mkA "facklig-politisk" ;
  facklig_av_1_A = mkA "facklig" ;
  fackligpolitisk_av_1_A = mkA "fackligpolitisk" ;
  fackligt_politisk_av_1_A = mkA "fackligt-politisk" ;
  fackligtpolitisk_av_1_A = mkA "fackligtpolitisk" ;
  fackmannamaessig_av_1_1_A = mkA "fackmannamässig" ;
  fackmaessig_av_1_1_A = mkA "fackmässig" ;
  faderlig_av_1_A = mkA "faderlig" ;
  faderloes_av_1_1_A = mkA "faderlös" ;
  fager_av_1_A = mkA "fager" ;
  faktamaessig_av_1_1_A = mkA "faktamässig" ;
  faktisk_av_1_A = mkA "faktisk" ;
  fakturerbar_av_1_A = mkA "fakturerbar" ;
  fakultativ_av_1_A = mkA "fakultativ" ;
  fal_av_1_A = mkA "fal" ;
  fallfaerdig_av_1_1_A = mkA "fallfärdig" ;
  falsifierbar_av_1_A = mkA "falsifierbar" ;
  falsk_av_1_A = mkA "falsk" ;
  faluroed_av_1_1_A = mkA "faluröd" ;
  familjemaessig_av_1_1_A = mkA "familjemässig" ;
  familjepolitisk_av_1_A = mkA "familjepolitisk" ;
  familjaer_av_1_1_A = mkA "familjär" ;
  famoes_av_1_1_A = mkA "famös" ;
  fanatisk_av_1_A = mkA "fanatisk" ;
  fanerogam_av_1_A = mkA "fanerogam" ;
  fantasifull_av_1_A = mkA "fantasifull" ;
  fantasiloes_av_1_1_A = mkA "fantasilös" ;
  fantasirik_av_1_A = mkA "fantasirik" ;
  fantastisk_av_1_A = mkA "fantastisk" ;
  fantiserbar_av_1_A = mkA "fantiserbar" ;
  fantomsnygg_av_1_A = mkA "fantomsnygg" ;
  faraonisk_av_1_A = mkA "faraonisk" ;
  farbar_av_1_A = mkA "farbar" ;
  farbroderlig_av_1_A = mkA "farbroderlig" ;
  fariseisk_av_1_A = mkA "fariseisk" ;
  farlig_av_1_A = mkA "farlig" ;
  farmaceutisk_av_1_A = mkA "farmaceutisk" ;
  farmacevtisk_av_1_A = mkA "farmacevtisk" ;
  farmakologisk_av_1_A = mkA "farmakologisk" ;
  faryngal_av_1_A = mkA "faryngal" ;
  fasansfull_av_1_A = mkA "fasansfull" ;
  fascinerbar_av_1_A = mkA "fascinerbar" ;
  fascistisk_av_1_A = mkA "fascistisk" ;
  fasetterbar_av_1_A = mkA "fasetterbar" ;
  fashionabel_av_1_A = mkA "fashionabel" ;
  faslig_av_1_A = mkA "faslig" ;
  fasonerbar_av_1_A = mkA "fasonerbar" ;
  fasonlig_av_1_A = mkA "fasonlig" ;
  fastighetstaxerbar_av_1_A = mkA "fastighetstaxerbar" ;
  fatal_av_1_A = mkA "fatal" ;
  fatalistisk_av_1_A = mkA "fatalistisk" ;
  fattbar_av_1_A = mkA "fattbar" ;
  fattig_av_1_A = mkA "fattig" ;
  fattlig_av_1_A = mkA "fattlig" ;
  faunistisk_av_1_A = mkA "faunistisk" ;
  favoriserbar_av_1_A = mkA "favoriserbar" ;
  feberhet_av_1_A = mkA "feberhet" ;
  febersjuk_av_1_A = mkA "febersjuk" ;
  febrig_av_1_A = mkA "febrig" ;
  febril_av_1_A = mkA "febril" ;
  federal_av_1_A = mkA "federal" ;
  federalistisk_av_1_A = mkA "federalistisk" ;
  federativ_av_1_A = mkA "federativ" ;
  feg_av_1_A = mkA "feg" ;
  fekal_av_1_A = mkA "fekal" ;
  felaktig_av_1_A = mkA "felaktig" ;
  felparkerbar_av_1_A = mkA "felparkerbar" ;
  femfaldig_av_1_A = mkA "femfaldig" ;
  femflikig_av_1_A = mkA "femflikig" ;
  femgradig_av_1_A = mkA "femgradig" ;
  feminin_av_1_A = mkA "feminin" ;
  feministisk_av_1_A = mkA "feministisk" ;
  femstaemmig_av_1_1_A = mkA "femstämmig" ;
  femtonaarig_av_1_1_A = mkA "femtonårig" ;
  femuddig_av_1_A = mkA "femuddig" ;
  femaarig_av_1_1_A = mkA "femårig" ;
  fenicisk_av_1_A = mkA "fenicisk" ;
  fenolisk_av_1_A = mkA "fenolisk" ;
  fenomenal_av_1_A = mkA "fenomenal" ;
  fenomenologisk_av_1_A = mkA "fenomenologisk" ;
  feodal_av_1_A = mkA "feodal" ;
  feodalistisk_av_1_A = mkA "feodalistisk" ;
  ferm_av_1_A = mkA "ferm" ;
  fermenterbar_av_1_A = mkA "fermenterbar" ;
  fertil_av_1_A = mkA "fertil" ;
  festlig_av_1_A = mkA "festlig" ;
  fet_av_1_A = mkA "fet" ;
  feterbar_av_1_A = mkA "feterbar" ;
  fetischistisk_av_1_A = mkA "fetischistisk" ;
  fetthaltig_av_1_A = mkA "fetthaltig" ;
  fettloeslig_av_1_1_A = mkA "fettlöslig" ;
  fettrik_av_1_A = mkA "fettrik" ;
  fiberrik_av_1_A = mkA "fiberrik" ;
  fibrig_av_1_A = mkA "fibrig" ;
  fickparkerbar_av_1_A = mkA "fickparkerbar" ;
  fientlig_av_1_A = mkA "fientlig" ;
  fiffig_av_1_A = mkA "fiffig" ;
  figurativ_av_1_A = mkA "figurativ" ;
  figurlig_av_1_A = mkA "figurlig" ;
  figursydd_av_1_A = mkA "figursydd" ;
  fijiansk_av_1_A = mkA "fijiansk" ;
  fiktiv_av_1_A = mkA "fiktiv" ;
  filantropisk_av_1_A = mkA "filantropisk" ;
  filerbar_av_1_A = mkA "filerbar" ;
  filharmonisk_av_1_A = mkA "filharmonisk" ;
  filippinsk_av_1_A = mkA "filippinsk" ;
  filistroes_av_1_1_A = mkA "filiströs" ;
  filmatiserbar_av_1_A = mkA "filmatiserbar" ;
  filmatisk_av_1_A = mkA "filmatisk" ;
  filmisk_av_1_A = mkA "filmisk" ;
  filmmaessig_av_1_1_A = mkA "filmmässig" ;
  filologisk_av_1_A = mkA "filologisk" ;
  filosofisk_av_1_A = mkA "filosofisk" ;
  filtrerbar_av_1_A = mkA "filtrerbar" ;
  fin_av_1_A = mkA "fin" ;
  final_av_1_A = mkA "final" ;
  finalklar_av_1_A = mkA "finalklar" ;
  finansiell_av_1_A = mkA "finansiell" ;
  finansierbar_av_1_A = mkA "finansierbar" ;
  finanspolitisk_av_1_A = mkA "finanspolitisk" ;
  finfin_av_1_A = mkA "finfin" ;
  fingerbar_av_1_A = mkA "fingerbar" ;
  fingerbred_av_1_A = mkA "fingerbred" ;
  fingerfaerdig_av_1_1_A = mkA "fingerfärdig" ;
  finjusterbar_av_1_A = mkA "finjusterbar" ;
  finkalibrig_av_1_A = mkA "finkalibrig" ;
  finklaedd_av_1_1_A = mkA "finklädd" ;
  finkornig_av_1_A = mkA "finkornig" ;
  finkaenslig_av_1_1_A = mkA "finkänslig" ;
  finlandiserbar_av_1_A = mkA "finlandiserbar" ;
  finlandssvensk_av_1_A = mkA "finlandssvensk" ;
  finlaendsk_av_1_1_A = mkA "finländsk" ;
  finmaskig_av_1_A = mkA "finmaskig" ;
  finmekanisk_av_1_A = mkA "finmekanisk" ;
  finnig_av_1_A = mkA "finnig" ;
  finsk_ugrisk_av_1_A = mkA "finsk-ugrisk" ;
  finsk_av_1_A = mkA "finsk" ;
  finskspraakig_av_1_1_A = mkA "finskspråkig" ;
  fintlig_av_1_A = mkA "fintlig" ;
  finurlig_av_1_A = mkA "finurlig" ;
  fipplig_av_1_A = mkA "fipplig" ;
  fisfoernaem_av_1_1_A = mkA "fisförnäm" ;
  fisig_av_1_A = mkA "fisig" ;
  fiskal_av_1_A = mkA "fiskal" ;
  fiskalisk_av_1_A = mkA "fiskalisk" ;
  fiskeansvarig_av_1_A = mkA "fiskeansvarig" ;
  fisklik_av_1_A = mkA "fisklik" ;
  fiskrik_av_1_A = mkA "fiskrik" ;
  fissil_av_1_A = mkA "fissil" ;
  fistuloes_av_1_1_A = mkA "fistulös" ;
  fix_av_1_A = mkA "fix" ;
  fixerbar_av_1_A = mkA "fixerbar" ;
  fjantig_av_1_A = mkA "fjantig" ;
  fjollig_av_1_A = mkA "fjollig" ;
  fjompig_av_1_A = mkA "fjompig" ;
  fjortonaarig_av_1_1_A = mkA "fjortonårig" ;
  fjunig_av_1_A = mkA "fjunig" ;
  fjuttig_av_1_A = mkA "fjuttig" ;
  fjaederklaedd_av_1_1_A = mkA "fjäderklädd" ;
  fjaederlaett_av_1_1_A = mkA "fjäderlätt" ;
  fjaellig_av_1_1_A = mkA "fjällig" ;
  fjaellik_av_1_1_A = mkA "fjällik" ;
  fjaer_av_1_1_A = mkA "fjär" ;
  fjaerrblockerbar_av_1_1_A = mkA "fjärrblockerbar" ;
  fjaeskig_av_1_1_A = mkA "fjäskig" ;
  flabbig_av_1_A = mkA "flabbig" ;
  flack_av_1_A = mkA "flack" ;
  fladdrig_av_1_A = mkA "fladdrig" ;
  flagig_av_1_A = mkA "flagig" ;
  flamberbar_av_1_A = mkA "flamberbar" ;
  flamlaendsk_av_1_1_A = mkA "flamländsk" ;
  flammig_av_1_A = mkA "flammig" ;
  flamsig_av_1_A = mkA "flamsig" ;
  flamsk_av_1_A = mkA "flamsk" ;
  flandrisk_av_1_A = mkA "flandrisk" ;
  flankerbar_av_1_A = mkA "flankerbar" ;
  flatterbar_av_1_A = mkA "flatterbar" ;
  flaxig_av_1_A = mkA "flaxig" ;
  flegmatisk_av_1_A = mkA "flegmatisk" ;
  flekterbar_av_1_A = mkA "flekterbar" ;
  flercellig_av_1_A = mkA "flercellig" ;
  flerdubbel_av_1_A = mkA "flerdubbel" ;
  flerfaldig_av_1_A = mkA "flerfaldig" ;
  flerspraakig_av_1_1_A = mkA "flerspråkig" ;
  flerstammig_av_1_A = mkA "flerstammig" ;
  flerstaemmig_av_1_1_A = mkA "flerstämmig" ;
  flertydig_av_1_A = mkA "flertydig" ;
  fleraarig_av_1_1_A = mkA "flerårig" ;
  flexibel_av_1_A = mkA "flexibel" ;
  flickaktig_av_1_A = mkA "flickaktig" ;
  flikig_av_1_A = mkA "flikig" ;
  flimrig_av_1_A = mkA "flimrig" ;
  flink_av_1_A = mkA "flink" ;
  flintskallig_av_1_A = mkA "flintskallig" ;
  flirtig_av_1_A = mkA "flirtig" ;
  flisig_av_1_A = mkA "flisig" ;
  flitig_av_1_A = mkA "flitig" ;
  flockblommig_av_1_A = mkA "flockblommig" ;
  flockig_av_1_A = mkA "flockig" ;
  florentinsk_av_1_A = mkA "florentinsk" ;
  floristisk_av_1_A = mkA "floristisk" ;
  floskuloes_av_1_1_A = mkA "floskulös" ;
  flott_av_1_A = mkA "flott" ;
  flottig_av_1_A = mkA "flottig" ;
  fluffig_av_1_A = mkA "fluffig" ;
  fluidiserbar_av_1_A = mkA "fluidiserbar" ;
  flummig_av_1_A = mkA "flummig" ;
  fluorerbar_av_1_A = mkA "fluorerbar" ;
  fluorhaltig_av_1_A = mkA "fluorhaltig" ;
  fluoriderbar_av_1_A = mkA "fluoriderbar" ;
  fluvial_av_1_A = mkA "fluvial" ;
  flygfaerdig_av_1_1_A = mkA "flygfärdig" ;
  flygg_av_1_A = mkA "flygg" ;
  flyktig_av_1_A = mkA "flyktig" ;
  flyttbar_av_1_A = mkA "flyttbar" ;
  flyttraett_av_1_1_A = mkA "flytträtt" ;
  flaeckig_av_1_1_A = mkA "fläckig" ;
  flaeckloes_av_1_1_A = mkA "fläcklös" ;
  flaeng_av_1_1_A = mkA "fläng" ;
  flaengig_av_1_1_A = mkA "flängig" ;
  flaerdfull_av_1_1_A = mkA "flärdfull" ;
  flaerdloes_av_1_1_A = mkA "flärdlös" ;
  flaeskig_av_1_1_A = mkA "fläskig" ;
  flaadig_av_1_1_A = mkA "flådig" ;
  flaasig_av_1_1_A = mkA "flåsig" ;
  floertig_av_1_1_A = mkA "flörtig" ;
  fnasig_av_1_A = mkA "fnasig" ;
  fnissig_av_1_A = mkA "fnissig" ;
  fnittrig_av_1_A = mkA "fnittrig" ;
  fnoskig_av_1_A = mkA "fnoskig" ;
  foglig_av_1_A = mkA "foglig" ;
  fokal_av_1_A = mkA "fokal" ;
  fokuserbar_av_1_A = mkA "fokuserbar" ;
  folierbar_av_1_A = mkA "folierbar" ;
  folkdemokratisk_av_1_A = mkA "folkdemokratisk" ;
  folketymologisk_av_1_A = mkA "folketymologisk" ;
  folkhemsk_av_1_A = mkA "folkhemsk" ;
  folkkaer_av_1_1_A = mkA "folkkär" ;
  folklig_av_1_A = mkA "folklig" ;
  folkloristisk_av_1_A = mkA "folkloristisk" ;
  folkrik_av_1_A = mkA "folkrik" ;
  folkraettslig_av_1_1_A = mkA "folkrättslig" ;
  folkskygg_av_1_A = mkA "folkskygg" ;
  folktaet_av_1_1_A = mkA "folktät" ;
  fonderbar_av_1_A = mkA "fonderbar" ;
  fonematisk_av_1_A = mkA "fonematisk" ;
  fonetisk_av_1_A = mkA "fonetisk" ;
  foniatrisk_av_1_A = mkA "foniatrisk" ;
  fonologisk_av_1_A = mkA "fonologisk" ;
  forcerbar_av_1_A = mkA "forcerbar" ;
  fordringsfull_av_1_A = mkA "fordringsfull" ;
  fordringsloes_av_1_1_A = mkA "fordringslös" ;
  forensisk_av_1_A = mkA "forensisk" ;
  formaliserbar_av_1_A = mkA "formaliserbar" ;
  formalistisk_av_1_A = mkA "formalistisk" ;
  formbar_av_1_A = mkA "formbar" ;
  formell_av_1_A = mkA "formell" ;
  formerbar_av_1_A = mkA "formerbar" ;
  formidabel_av_1_A = mkA "formidabel" ;
  formlig_av_1_A = mkA "formlig" ;
  formloes_av_1_1_A = mkA "formlös" ;
  formmaessig_av_1_1_A = mkA "formmässig" ;
  formrik_av_1_A = mkA "formrik" ;
  formskoen_av_1_1_A = mkA "formskön" ;
  formstark_av_1_A = mkA "formstark" ;
  formulerbar_av_1_A = mkA "formulerbar" ;
  forn_av_1_A = mkA "forn" ;
  fornegyptisk_av_1_A = mkA "fornegyptisk" ;
  forngrekisk_av_1_A = mkA "forngrekisk" ;
  fornislaendsk_av_1_1_A = mkA "fornisländsk" ;
  fornitaliensk_av_1_A = mkA "fornitaliensk" ;
  fornkeltisk_av_1_A = mkA "fornkeltisk" ;
  fornnordisk_av_1_A = mkA "fornnordisk" ;
  fornromersk_av_1_A = mkA "fornromersk" ;
  fornsvensk_av_1_A = mkA "fornsvensk" ;
  forskarmaessig_av_1_1_A = mkA "forskarmässig" ;
  forskningsmaessig_av_1_1_A = mkA "forskningsmässig" ;
  forskningspolitisk_av_1_A = mkA "forskningspolitisk" ;
  fortfaerdig_av_1_1_A = mkA "fortfärdig" ;
  fortplantningsmaessig_av_1_1_A = mkA "fortplantningsmässig" ;
  fosfaterbar_av_1_A = mkA "fosfaterbar" ;
  fossil_av_1_A = mkA "fossil" ;
  fossiliserbar_av_1_A = mkA "fossiliserbar" ;
  fosterlaendsk_av_1_1_A = mkA "fosterländsk" ;
  fotbollsmaessig_av_1_1_A = mkA "fotbollsmässig" ;
  fotoelektrisk_av_1_A = mkA "fotoelektrisk" ;
  fotogenisk_av_1_A = mkA "fotogenisk" ;
  fotograferbar_av_1_A = mkA "fotograferbar" ;
  fotografisk_av_1_A = mkA "fotografisk" ;
  fotogrammetrisk_av_1_A = mkA "fotogrammetrisk" ;
  fotokemisk_av_1_A = mkA "fotokemisk" ;
  fotokopierbar_av_1_A = mkA "fotokopierbar" ;
  fotostatkopierbar_av_1_A = mkA "fotostatkopierbar" ;
  fotriktig_av_1_A = mkA "fotriktig" ;
  fotraet_av_1_1_A = mkA "foträt" ;
  fotsid_av_1_A = mkA "fotsid" ;
  fotvaenlig_av_1_1_A = mkA "fotvänlig" ;
  fradgig_av_1_A = mkA "fradgig" ;
  fragil_av_1_A = mkA "fragil" ;
  fragmentarisk_av_1_A = mkA "fragmentarisk" ;
  fragmenterbar_av_1_A = mkA "fragmenterbar" ;
  fraktal_av_1_A = mkA "fraktal" ;
  fraktfri_av_1_A = mkA "fraktfri" ;
  fraktionerbar_av_1_A = mkA "fraktionerbar" ;
  framfusig_av_1_A = mkA "framfusig" ;
  framgaangsrik_av_1_1_A = mkA "framgångsrik" ;
  framkomlig_av_1_A = mkA "framkomlig" ;
  framstegsvaenlig_av_1_1_A = mkA "framstegsvänlig" ;
  framtung_av_1_A = mkA "framtung" ;
  frank_av_1_A = mkA "frank" ;
  frankerbar_av_1_A = mkA "frankerbar" ;
  fransig_av_1_A = mkA "fransig" ;
  fransk_av_1_A = mkA "fransk" ;
  franskfoedd_av_1_1_A = mkA "franskfödd" ;
  franskklassicistisk_av_1_A = mkA "franskklassicistisk" ;
  franskklassisk_av_1_A = mkA "franskklassisk" ;
  franskspraakig_av_1_1_A = mkA "franskspråkig" ;
  fraseologisk_av_1_A = mkA "fraseologisk" ;
  fraserbar_av_1_A = mkA "fraserbar" ;
  frasig_av_1_A = mkA "frasig" ;
  frasliberal_av_1_A = mkA "frasliberal" ;
  frasradikal_av_1_A = mkA "frasradikal" ;
  fredlig_av_1_A = mkA "fredlig" ;
  fredloes_av_1_1_A = mkA "fredlös" ;
  fredsvaenlig_av_1_1_A = mkA "fredsvänlig" ;
  frejdig_av_1_A = mkA "frejdig" ;
  frekvensmodulerbar_av_1_A = mkA "frekvensmodulerbar" ;
  frekventerbar_av_1_A = mkA "frekventerbar" ;
  frenetisk_av_1_A = mkA "frenetisk" ;
  frenologisk_av_1_A = mkA "frenologisk" ;
  fribladig_av_1_A = mkA "fribladig" ;
  fridfull_av_1_A = mkA "fridfull" ;
  fridloes_av_1_1_A = mkA "fridlös" ;
  frifraesig_av_1_1_A = mkA "frifräsig" ;
  friherrlig_av_1_A = mkA "friherrlig" ;
  frihetlig_av_1_A = mkA "frihetlig" ;
  frikativ_av_1_A = mkA "frikativ" ;
  frikostig_av_1_A = mkA "frikostig" ;
  frikyrklig_av_1_A = mkA "frikyrklig" ;
  frimodig_av_1_A = mkA "frimodig" ;
  frireligioes_av_1_1_A = mkA "frireligiös" ;
  friserbar_av_1_A = mkA "friserbar" ;
  frisisk_av_1_A = mkA "frisisk" ;
  frisk_av_1_A = mkA "frisk" ;
  frispraakig_av_1_1_A = mkA "frispråkig" ;
  friterbar_av_1_A = mkA "friterbar" ;
  fritidspolitisk_av_1_A = mkA "fritidspolitisk" ;
  frivillig_av_1_A = mkA "frivillig" ;
  frivol_av_1_A = mkA "frivol" ;
  frodig_av_1_A = mkA "frodig" ;
  fronderbar_av_1_A = mkA "fronderbar" ;
  frontal_av_1_A = mkA "frontal" ;
  frosthaerdig_av_1_1_A = mkA "frosthärdig" ;
  frostig_av_1_A = mkA "frostig" ;
  frostkaenslig_av_1_1_A = mkA "frostkänslig" ;
  frosttaalig_av_1_1_A = mkA "frosttålig" ;
  frotterbar_av_1_A = mkA "frotterbar" ;
  frugal_av_1_A = mkA "frugal" ;
  fruktbar_av_1_A = mkA "fruktbar" ;
  fruktig_av_1_A = mkA "fruktig" ;
  fruktloes_av_1_1_A = mkA "fruktlös" ;
  frustrerbar_av_1_A = mkA "frustrerbar" ;
  fryntlig_av_1_A = mkA "fryntlig" ;
  frystaalig_av_1_1_A = mkA "frystålig" ;
  fraeck_av_1_1_A = mkA "fräck" ;
  fraeknig_av_1_1_A = mkA "fräknig" ;
  fraemlingsfientlig_av_1_1_A = mkA "främlingsfientlig" ;
  fraen_av_1_1_A = mkA "frän" ;
  fraesch_av_1_1_A = mkA "fräsch" ;
  fraesig_av_1_1_A = mkA "fräsig" ;
  fraagvis_av_1_1_A = mkA "frågvis" ;
  froejdefull_av_1_1_A = mkA "fröjdefull" ;
  fuktfri_av_1_A = mkA "fuktfri" ;
  fukthal_av_1_A = mkA "fukthal" ;
  fuktig_av_1_A = mkA "fuktig" ;
  ful_av_1_A = mkA "ful" ;
  full_av_1_A = mkA "full" ;
  fullfaerdig_av_1_1_A = mkA "fullfärdig" ;
  fullgod_av_1_A = mkA "fullgod" ;
  fullkomlig_av_1_A = mkA "fullkomlig" ;
  fullsatt_av_1_A = mkA "fullsatt" ;
  fullskalig_av_1_A = mkA "fullskalig" ;
  fullstor_av_1_A = mkA "fullstor" ;
  fullstaemmig_av_1_1_A = mkA "fullstämmig" ;
  fullstaendig_av_1_1_A = mkA "fullständig" ;
  fulltalig_av_1_A = mkA "fulltalig" ;
  fulltonig_av_1_A = mkA "fulltonig" ;
  fullvaerdig_av_1_1_A = mkA "fullvärdig" ;
  fulloedig_av_1_1_A = mkA "fullödig" ;
  fulsnygg_av_1_A = mkA "fulsnygg" ;
  fumlig_av_1_A = mkA "fumlig" ;
  fundamental_av_1_A = mkA "fundamental" ;
  fundamentalistisk_av_1_A = mkA "fundamentalistisk" ;
  funktionalistisk_av_1_A = mkA "funktionalistisk" ;
  funktionell_av_1_A = mkA "funktionell" ;
  funktionsduglig_av_1_A = mkA "funktionsduglig" ;
  funktionsmaessig_av_1_1_A = mkA "funktionsmässig" ;
  funktionsoduglig_av_1_A = mkA "funktionsoduglig" ;
  furnerbar_av_1_A = mkA "furnerbar" ;
  furstlig_av_1_A = mkA "furstlig" ;
  fusionerbar_av_1_A = mkA "fusionerbar" ;
  futil_av_1_A = mkA "futil" ;
  futtig_av_1_A = mkA "futtig" ;
  futural_av_1_A = mkA "futural" ;
  futuristisk_av_1_A = mkA "futuristisk" ;
  futurologisk_av_1_A = mkA "futurologisk" ;
  fyllig_av_1_A = mkA "fyllig" ;
  fylogenetisk_av_1_A = mkA "fylogenetisk" ;
  fyndig_av_1_A = mkA "fyndig" ;
  fyraaarig_av_1_1_A = mkA "fyraårig" ;
  fyrcylindrig_av_1_A = mkA "fyrcylindrig" ;
  fyrdubbel_av_1_A = mkA "fyrdubbel" ;
  fyrfaldig_av_1_A = mkA "fyrfaldig" ;
  fyrfilig_av_1_A = mkA "fyrfilig" ;
  fyrgradig_av_1_A = mkA "fyrgradig" ;
  fyrhjulig_av_1_A = mkA "fyrhjulig" ;
  fyrhaendig_av_1_1_A = mkA "fyrhändig" ;
  fyrkantig_av_1_A = mkA "fyrkantig" ;
  fyrkantig_av_2_A = mkA "fyrkantig" ;
  fyrmotorig_av_1_A = mkA "fyrmotorig" ;
  fyrsiffrig_av_1_A = mkA "fyrsiffrig" ;
  fyrsitsig_av_1_A = mkA "fyrsitsig" ;
  fyrstjaernig_av_1_1_A = mkA "fyrstjärnig" ;
  fyrtalig_av_1_A = mkA "fyrtalig" ;
  fyrtiotalistisk_av_1_A = mkA "fyrtiotalistisk" ;
  fyrvaeldig_av_1_1_A = mkA "fyrväldig" ;
  fysikalisk_av_1_A = mkA "fysikalisk" ;
  fysiljerbar_av_1_A = mkA "fysiljerbar" ;
  fysiokratisk_av_1_A = mkA "fysiokratisk" ;
  fysiologisk_av_1_A = mkA "fysiologisk" ;
  fysisk_av_1_A = mkA "fysisk" ;
  faeaktig_av_1_1_A = mkA "fäaktig" ;
  faellbar_av_1_1_A = mkA "fällbar" ;
  faeltmaessig_av_1_1_A = mkA "fältmässig" ;
  faerdig_av_1_1_A = mkA "färdig" ;
  faergbestaendig_av_1_1_A = mkA "färgbeständig" ;
  faergglad_av_1_1_A = mkA "färgglad" ;
  faergkaenslig_av_1_1_A = mkA "färgkänslig" ;
  faergloes_av_1_1_A = mkA "färglös" ;
  faergmaessig_av_1_1_A = mkA "färgmässig" ;
  faergrik_av_1_1_A = mkA "färgrik" ;
  faergstark_av_1_1_A = mkA "färgstark" ;
  faerm_av_1_1_A = mkA "färm" ;
  faerserbar_av_1_1_A = mkA "färserbar" ;
  faersk_av_1_1_A = mkA "färsk" ;
  faeroeisk_av_1_1_A = mkA "färöisk" ;
  faafaeng_av_1_1_A = mkA "fåfäng" ;
  faafaenglig_av_1_1_A = mkA "fåfänglig" ;
  faagelkunnig_av_1_1_A = mkA "fågelkunnig" ;
  faakunnig_av_1_1_A = mkA "fåkunnig" ;
  faanig_av_1_1_A = mkA "fånig" ;
  faaordig_av_1_1_A = mkA "fåordig" ;
  faaraktig_av_1_1_A = mkA "fåraktig" ;
  faatalig_av_1_1_A = mkA "fåtalig" ;
  faavitsk_av_1_1_A = mkA "fåvitsk" ;
  foedd_av_1_1_A = mkA "född" ;
  foeljdenlig_av_1_1_A = mkA "följdenlig" ;
  foeljdriktig_av_1_1_A = mkA "följdriktig" ;
  foeljetongsmaessig_av_1_1_A = mkA "följetongsmässig" ;
  foeraktfull_av_1_1_A = mkA "föraktfull" ;
  foeraktlig_av_1_1_A = mkA "föraktlig" ;
  foerannonserbar_av_1_1_A = mkA "förannonserbar" ;
  foerarglig_av_1_1_A = mkA "förarglig" ;
  foerarloes_av_1_1_A = mkA "förarlös" ;
  foerbehaallsloes_av_1_1_A = mkA "förbehållslös" ;
  foerberedd_av_1_1_A = mkA "förberedd" ;
  foerbindlig_av_1_1_A = mkA "förbindlig" ;
  foerbaetterlig_av_1_1_A = mkA "förbätterlig" ;
  foercolumbiansk_av_1_1_A = mkA "förcolumbiansk" ;
  foercolumbisk_av_1_1_A = mkA "förcolumbisk" ;
  foerdelaktig_av_1_1_A = mkA "fördelaktig" ;
  foerdelningsmaessig_av_1_1_A = mkA "fördelningsmässig" ;
  foerdelningspolitisk_av_1_1_A = mkA "fördelningspolitisk" ;
  foerdomsfull_av_1_1_A = mkA "fördomsfull" ;
  foerdragsmaessig_av_1_1_A = mkA "fördragsmässig" ;
  foerdaervlig_av_1_1_A = mkA "fördärvlig" ;
  foerdoemlig_av_1_1_A = mkA "fördömlig" ;
  foerebildlig_av_1_1_A = mkA "förebildlig" ;
  foeredoemlig_av_1_1_A = mkA "föredömlig" ;
  foerefintlig_av_1_1_A = mkA "förefintlig" ;
  foereningsmaessig_av_1_1_A = mkA "föreningsmässig" ;
  foerenlig_av_1_1_A = mkA "förenlig" ;
  foeretagsekonomisk_av_1_1_A = mkA "företagsekonomisk" ;
  foeretagsmaessig_av_1_1_A = mkA "företagsmässig" ;
  foeretagstaet_av_1_1_A = mkA "företagstät" ;
  foerfattningsmaessig_av_1_1_A = mkA "författningsmässig" ;
  foerfattningsstridig_av_1_1_A = mkA "författningsstridig" ;
  foerfaerlig_av_1_1_A = mkA "förfärlig" ;
  foerfoerisk_av_1_1_A = mkA "förförisk" ;
  foergriplig_av_1_1_A = mkA "förgriplig" ;
  foergaenglig_av_1_1_A = mkA "förgänglig" ;
  foerhandlingsbar_av_1_1_A = mkA "förhandlingsbar" ;
  foerhandlingsmaessig_av_1_1_A = mkA "förhandlingsmässig" ;
  foerhatlig_av_1_1_A = mkA "förhatlig" ;
  foerhistorisk_av_1_1_A = mkA "förhistorisk" ;
  foerhoppningsfull_av_1_1_A = mkA "förhoppningsfull" ;
  foerkastlig_av_1_1_A = mkA "förkastlig" ;
  foerklarlig_av_1_1_A = mkA "förklarlig" ;
  foerklaedd_av_1_1_A = mkA "förklädd" ;
  foerlagsmaessig_av_1_1_A = mkA "förlagsmässig" ;
  foerlig_av_1_1_A = mkA "förlig" ;
  foerlustig_av_1_1_A = mkA "förlustig" ;
  foerlustrik_av_1_1_A = mkA "förlustrik" ;
  foerlaatlig_av_1_1_A = mkA "förlåtlig" ;
  foermodern_av_1_1_A = mkA "förmodern" ;
  foermyndaraktig_av_1_1_A = mkA "förmyndaraktig" ;
  foermaanlig_av_1_1_A = mkA "förmånlig" ;
  foernimbar_av_1_1_A = mkA "förnimbar" ;
  foernuftig_av_1_1_A = mkA "förnuftig" ;
  foernuftsloes_av_1_1_A = mkA "förnuftslös" ;
  foernuftsmaessig_av_1_1_A = mkA "förnuftsmässig" ;
  foernuftsstridig_av_1_1_A = mkA "förnuftsstridig" ;
  foernuftsvidrig_av_1_1_A = mkA "förnuftsvidrig" ;
  foernumstig_av_1_1_A = mkA "förnumstig" ;
  foernybar_av_1_1_A = mkA "förnybar" ;
  foernyelsebar_av_1_1_A = mkA "förnyelsebar" ;
  foernaemlig_av_1_1_A = mkA "förnämlig" ;
  foerromantisk_av_1_1_A = mkA "förromantisk" ;
  foerromersk_av_1_1_A = mkA "förromersk" ;
  foerraedisk_av_1_1_A = mkA "förrädisk" ;
  foersakelsefull_av_1_1_A = mkA "försakelsefull" ;
  foersiktig_av_1_1_A = mkA "försiktig" ;
  foerskotterbar_av_1_1_A = mkA "förskotterbar" ;
  foerskraecklig_av_1_1_A = mkA "förskräcklig" ;
  foersmaedlig_av_1_1_A = mkA "försmädlig" ;
  foersonlig_av_1_1_A = mkA "försonlig" ;
  foerstfoedd_av_1_1_A = mkA "förstfödd" ;
  foerstklassig_av_1_1_A = mkA "förstklassig" ;
  foerstroedd_av_1_1_A = mkA "förströdd" ;
  foerstaaelig_av_1_1_A = mkA "förståelig" ;
  foerstaandig_av_1_1_A = mkA "förståndig" ;
  foerstaandsmaessig_av_1_1_A = mkA "förståndsmässig" ;
  foersumbar_av_1_1_A = mkA "försumbar" ;
  foersumlig_av_1_1_A = mkA "försumlig" ;
  foersvarbar_av_1_1_A = mkA "försvarbar" ;
  foersvarlig_av_1_1_A = mkA "försvarlig" ;
  foersvarsloes_av_1_1_A = mkA "försvarslös" ;
  foersvarsmaessig_av_1_1_A = mkA "försvarsmässig" ;
  foersvarspolitisk_av_1_1_A = mkA "försvarspolitisk" ;
  foersaekringsmaessig_av_1_1_A = mkA "försäkringsmässig" ;
  foersaeljningsmaessig_av_1_1_A = mkA "försäljningsmässig" ;
  foersaatlig_av_1_1_A = mkA "försåtlig" ;
  foersoerjningsmaessig_av_1_1_A = mkA "försörjningsmässig" ;
  foersoerjningspolitisk_av_1_1_A = mkA "försörjningspolitisk" ;
  foerteknisk_av_1_1_A = mkA "förteknisk" ;
  foertidspensionerbar_av_1_1_A = mkA "förtidspensionerbar" ;
  foertjaenstfull_av_1_1_A = mkA "förtjänstfull" ;
  foertretlig_av_1_1_A = mkA "förtretlig" ;
  foertroendefull_av_1_1_A = mkA "förtroendefull" ;
  foertroendemaessig_av_1_1_A = mkA "förtroendemässig" ;
  foertrolig_av_1_1_A = mkA "förtrolig" ;
  foertraefflig_av_1_1_A = mkA "förträfflig" ;
  foertroestansfull_av_1_1_A = mkA "förtröstansfull" ;
  foerunderlig_av_1_1_A = mkA "förunderlig" ;
  foerutsaegbar_av_1_1_A = mkA "förutsägbar" ;
  foerutsaettningsloes_av_1_1_A = mkA "förutsättningslös" ;
  foervaltningsmaessig_av_1_1_A = mkA "förvaltningsmässig" ;
  foervaentansfull_av_1_1_A = mkA "förväntansfull" ;
  foervaentningsfull_av_1_1_A = mkA "förväntningsfull" ;
  foervaervsmaessig_av_1_1_A = mkA "förvärvsmässig" ;
  foeraektenskaplig_av_1_1_A = mkA "föräktenskaplig" ;
  foeraeldraledig_av_1_1_A = mkA "föräldraledig" ;
  foeraeldraloes_av_1_1_A = mkA "föräldralös" ;
  foeraenderlig_av_1_1_A = mkA "föränderlig" ;
  gabonesisk_av_1_A = mkA "gabonesisk" ;
  gaddloes_av_1_1_A = mkA "gaddlös" ;
  gaelisk_av_1_A = mkA "gaelisk" ;
  gaggig_av_1_A = mkA "gaggig" ;
  gagnelig_av_1_A = mkA "gagnelig" ;
  gagnerik_av_1_A = mkA "gagnerik" ;
  gagnloes_av_1_1_A = mkA "gagnlös" ;
  gagnrik_av_1_A = mkA "gagnrik" ;
  galaktisk_av_1_A = mkA "galaktisk" ;
  galicisk_av_1_A = mkA "galicisk" ;
  gallerfoersedd_av_1_1_A = mkA "gallerförsedd" ;
  galliserbar_av_1_A = mkA "galliserbar" ;
  gallisk_av_1_A = mkA "gallisk" ;
  gallsjuk_av_1_A = mkA "gallsjuk" ;
  galoscherbar_av_1_A = mkA "galoscherbar" ;
  galvaniserbar_av_1_A = mkA "galvaniserbar" ;
  galvanisk_av_1_A = mkA "galvanisk" ;
  gambisk_av_1_A = mkA "gambisk" ;
  gammalkyrklig_av_1_A = mkA "gammalkyrklig" ;
  gammalmodig_av_1_A = mkA "gammalmodig" ;
  gammaltestamentlig_av_1_A = mkA "gammaltestamentlig" ;
  gangrenoes_av_1_1_A = mkA "gangrenös" ;
  gapig_av_1_A = mkA "gapig" ;
  garagerbar_av_1_A = mkA "garagerbar" ;
  garanterbar_av_1_A = mkA "garanterbar" ;
  garderbar_av_1_A = mkA "garderbar" ;
  garderobsmaessig_av_1_1_A = mkA "garderobsmässig" ;
  garnerbar_av_1_A = mkA "garnerbar" ;
  garnisonerbar_av_1_A = mkA "garnisonerbar" ;
  garrotterbar_av_1_A = mkA "garrotterbar" ;
  gasformig_av_1_A = mkA "gasformig" ;
  gasrik_av_1_A = mkA "gasrik" ;
  gassig_av_1_A = mkA "gassig" ;
  gastrisk_av_1_A = mkA "gastrisk" ;
  gastronomisk_av_1_A = mkA "gastronomisk" ;
  gastroskoperbar_av_1_A = mkA "gastroskoperbar" ;
  gauffrerbar_av_1_A = mkA "gauffrerbar" ;
  gaullistisk_av_1_A = mkA "gaullistisk" ;
  gay_av_1_A = mkA "gay" ;
  geggig_av_1_A = mkA "geggig" ;
  gelatinerbar_av_1_A = mkA "gelatinerbar" ;
  gelatinoes_av_1_1_A = mkA "gelatinös" ;
  geleig_av_1_A = mkA "geleig" ;
  geminerbar_av_1_A = mkA "geminerbar" ;
  gemytlig_av_1_A = mkA "gemytlig" ;
  gen_av_1_A = mkA "gen" ;
  genealogisk_av_1_A = mkA "genealogisk" ;
  generaliserbar_av_1_A = mkA "generaliserbar" ;
  generalplanemaessig_av_1_1_A = mkA "generalplanemässig" ;
  generationsmaessig_av_1_1_A = mkA "generationsmässig" ;
  generativ_av_1_A = mkA "generativ" ;
  generbar_av_1_A = mkA "generbar" ;
  generell_av_1_A = mkA "generell" ;
  genererbar_av_1_A = mkA "genererbar" ;
  generisk_av_1_A = mkA "generisk" ;
  generoes_av_1_1_A = mkA "generös" ;
  genetisk_av_1_A = mkA "genetisk" ;
  gengaangarlik_av_1_1_A = mkA "gengångarlik" ;
  genial_av_1_A = mkA "genial" ;
  genialisk_av_1_A = mkA "genialisk" ;
  genmanipulerbar_av_1_A = mkA "genmanipulerbar" ;
  genombloet_av_1_1_A = mkA "genomblöt" ;
  genomfoerbar_av_1_1_A = mkA "genomförbar" ;
  genomgod_av_1_A = mkA "genomgod" ;
  genomskinlig_av_1_A = mkA "genomskinlig" ;
  genomslaepplig_av_1_1_A = mkA "genomsläpplig" ;
  genomsnittlig_av_1_A = mkA "genomsnittlig" ;
  genomsnaell_av_1_1_A = mkA "genomsnäll" ;
  genomsur_av_1_A = mkA "genomsur" ;
  genomsvettig_av_1_A = mkA "genomsvettig" ;
  genomtraenglig_av_1_1_A = mkA "genomtränglig" ;
  genomusel_av_1_A = mkA "genomusel" ;
  genomvarm_av_1_A = mkA "genomvarm" ;
  genomvaat_av_1_1_A = mkA "genomvåt" ;
  genremaessig_av_1_1_A = mkA "genremässig" ;
  genstridig_av_1_A = mkA "genstridig" ;
  genstraevig_av_1_1_A = mkA "gensträvig" ;
  genstoertig_av_1_1_A = mkA "genstörtig" ;
  gentil_av_1_A = mkA "gentil" ;
  gentlemannamaessig_av_1_1_A = mkA "gentlemannamässig" ;
  genuin_av_1_A = mkA "genuin" ;
  genusmaessig_av_1_1_A = mkA "genusmässig" ;
  geocentrisk_av_1_A = mkA "geocentrisk" ;
  geodetisk_av_1_A = mkA "geodetisk" ;
  geografisk_av_1_A = mkA "geografisk" ;
  geokemisk_av_1_A = mkA "geokemisk" ;
  geokronologisk_av_1_A = mkA "geokronologisk" ;
  geologisk_av_1_A = mkA "geologisk" ;
  geometriserbar_av_1_A = mkA "geometriserbar" ;
  geometrisk_av_1_A = mkA "geometrisk" ;
  geomorfologisk_av_1_A = mkA "geomorfologisk" ;
  geopolitisk_av_1_A = mkA "geopolitisk" ;
  georgiansk_av_1_A = mkA "georgiansk" ;
  georgisk_av_1_A = mkA "georgisk" ;
  geostationaer_av_1_1_A = mkA "geostationär" ;
  geotermisk_av_1_A = mkA "geotermisk" ;
  geovetenskaplig_av_1_A = mkA "geovetenskaplig" ;
  geriatrisk_av_1_A = mkA "geriatrisk" ;
  germaniserbar_av_1_A = mkA "germaniserbar" ;
  germanistisk_av_1_A = mkA "germanistisk" ;
  germansk_av_1_A = mkA "germansk" ;
  gerontologisk_av_1_A = mkA "gerontologisk" ;
  gestaltloes_av_1_1_A = mkA "gestaltlös" ;
  gestaltningsmaessig_av_1_1_A = mkA "gestaltningsmässig" ;
  ghanansk_av_1_A = mkA "ghanansk" ;
  ghanesisk_av_1_A = mkA "ghanesisk" ;
  giftgroen_av_1_1_A = mkA "giftgrön" ;
  giftig_av_1_A = mkA "giftig" ;
  gigantisk_av_1_A = mkA "gigantisk" ;
  giljotinerbar_av_1_A = mkA "giljotinerbar" ;
  gill_av_1_A = mkA "gill" ;
  giltig_av_1_A = mkA "giltig" ;
  gin_av_1_A = mkA "gin" ;
  girerbar_av_1_A = mkA "girerbar" ;
  girig_av_1_A = mkA "girig" ;
  gjutbar_av_1_A = mkA "gjutbar" ;
  glacial_av_1_A = mkA "glacial" ;
  glacifluvial_av_1_A = mkA "glacifluvial" ;
  glaciologisk_av_1_A = mkA "glaciologisk" ;
  glad_av_1_A = mkA "glad" ;
  gladelig_av_1_A = mkA "gladelig" ;
  gladlig_av_1_A = mkA "gladlig" ;
  glagolitisk_av_1_A = mkA "glagolitisk" ;
  glammig_av_1_A = mkA "glammig" ;
  glamoriserbar_av_1_A = mkA "glamoriserbar" ;
  glamoroes_av_1_1_A = mkA "glamorös" ;
  glamouriserbar_av_1_A = mkA "glamouriserbar" ;
  glamouroes_av_1_1_A = mkA "glamourös" ;
  glanduloes_av_1_1_A = mkA "glandulös" ;
  glansfull_av_1_A = mkA "glansfull" ;
  glansig_av_1_A = mkA "glansig" ;
  glansk_av_1_A = mkA "glansk" ;
  glansloes_av_1_1_A = mkA "glanslös" ;
  glapp_av_1_A = mkA "glapp" ;
  glaserbar_av_1_A = mkA "glaserbar" ;
  glashal_av_1_A = mkA "glashal" ;
  glasig_av_1_A = mkA "glasig" ;
  glasiologisk_av_1_A = mkA "glasiologisk" ;
  glasklar_av_1_A = mkA "glasklar" ;
  glassig_av_1_A = mkA "glassig" ;
  glatt_av_1_A = mkA "glatt" ;
  gles_av_1_A = mkA "gles" ;
  glitterfin_av_1_A = mkA "glitterfin" ;
  glitterglad_av_1_A = mkA "glitterglad" ;
  glitterprydd_av_1_A = mkA "glitterprydd" ;
  glittrig_av_1_A = mkA "glittrig" ;
  global_av_1_A = mkA "global" ;
  glorifierbar_av_1_A = mkA "glorifierbar" ;
  glorioes_av_1_1_A = mkA "gloriös" ;
  glosig_av_1_A = mkA "glosig" ;
  glupsk_av_1_A = mkA "glupsk" ;
  glutinoes_av_1_1_A = mkA "glutinös" ;
  glyttig_av_1_A = mkA "glyttig" ;
  glaedjefull_av_1_1_A = mkA "glädjefull" ;
  glaedjeloes_av_1_1_A = mkA "glädjelös" ;
  glaedjerusig_av_1_1_A = mkA "glädjerusig" ;
  glaettig_av_1_1_A = mkA "glättig" ;
  glaamig_av_1_1_A = mkA "glåmig" ;
  gloedhet_av_1_1_A = mkA "glödhet" ;
  gloedmjuk_av_1_1_A = mkA "glödmjuk" ;
  gloedvarm_av_1_1_A = mkA "glödvarm" ;
  gloemsk_av_1_1_A = mkA "glömsk" ;
  gnatig_av_1_A = mkA "gnatig" ;
  gnetig_av_1_A = mkA "gnetig" ;
  gnidig_av_1_A = mkA "gnidig" ;
  gnistrig_av_1_A = mkA "gnistrig" ;
  gnaellig_av_1_1_A = mkA "gnällig" ;
  gobelaengklaedd_av_1_1_A = mkA "gobelängklädd" ;
  godhetsfull_av_1_A = mkA "godhetsfull" ;
  godhaellig_av_1_1_A = mkA "godhällig" ;
  godmodig_av_1_A = mkA "godmodig" ;
  godtagbar_av_1_A = mkA "godtagbar" ;
  godtycklig_av_1_A = mkA "godtycklig" ;
  godvillig_av_1_A = mkA "godvillig" ;
  goffrerbar_av_1_A = mkA "goffrerbar" ;
  golfmaessig_av_1_1_A = mkA "golfmässig" ;
  golvkall_av_1_A = mkA "golvkall" ;
  googlingsbar_av_1_A = mkA "googlingsbar" ;
  gosig_av_1_A = mkA "gosig" ;
  gotisk_av_1_A = mkA "gotisk" ;
  gotlaendsk_av_1_1_A = mkA "gotländsk" ;
  gotsk_av_1_A = mkA "gotsk" ;
  gouterbar_av_1_A = mkA "gouterbar" ;
  gracil_av_1_A = mkA "gracil" ;
  gracioes_av_1_1_A = mkA "graciös" ;
  graderbar_av_1_A = mkA "graderbar" ;
  graduell_av_1_A = mkA "graduell" ;
  graduerbar_av_1_A = mkA "graduerbar" ;
  gradvis_av_1_A = mkA "gradvis" ;
  grafematisk_av_1_A = mkA "grafematisk" ;
  grafisk_av_1_A = mkA "grafisk" ;
  grafiterbar_av_1_A = mkA "grafiterbar" ;
  grafonomisk_av_1_A = mkA "grafonomisk" ;
  grammatikalisk_av_1_A = mkA "grammatikalisk" ;
  grammatisk_av_1_A = mkA "grammatisk" ;
  grandios_av_1_A = mkA "grandios" ;
  granulerbar_av_1_A = mkA "granulerbar" ;
  gratinerbar_av_1_A = mkA "gratinerbar" ;
  gratis_av_1_A = mkA "gratis" ;
  gratulerbar_av_1_A = mkA "gratulerbar" ;
  grav_av_1_A = mkA "grav" ;
  gravallvarlig_av_1_A = mkA "gravallvarlig" ;
  graverbar_av_1_A = mkA "graverbar" ;
  gravitetisk_av_1_A = mkA "gravitetisk" ;
  gravlik_av_1_A = mkA "gravlik" ;
  gredelin_av_1_A = mkA "gredelin" ;
  gregoriansk_av_1_A = mkA "gregoriansk" ;
  grekisk_katolsk_av_1_A = mkA "grekisk-katolsk" ;
  grekisk_ortodox_av_1_A = mkA "grekisk-ortodox" ;
  grekisk_romersk_av_1_A = mkA "grekisk-romersk" ;
  grekisk_av_1_A = mkA "grekisk" ;
  grenadisk_av_1_A = mkA "grenadisk" ;
  grenig_av_1_A = mkA "grenig" ;
  greppbar_av_1_A = mkA "greppbar" ;
  greppbar_av_2_A = mkA "greppbar" ;
  greppriktig_av_1_A = mkA "greppriktig" ;
  greppvaenlig_av_1_1_A = mkA "greppvänlig" ;
  grevlig_av_1_A = mkA "grevlig" ;
  griljerbar_av_1_A = mkA "griljerbar" ;
  grimerbar_av_1_A = mkA "grimerbar" ;
  grinig_av_1_A = mkA "grinig" ;
  gripbar_av_1_A = mkA "gripbar" ;
  grisig_av_1_A = mkA "grisig" ;
  grisskaer_av_1_1_A = mkA "grisskär" ;
  gropig_av_1_A = mkA "gropig" ;
  grotesk_av_1_A = mkA "grotesk" ;
  grovkalibrig_av_1_A = mkA "grovkalibrig" ;
  grovkornig_av_1_A = mkA "grovkornig" ;
  grovplanerbar_av_1_A = mkA "grovplanerbar" ;
  grovsorterbar_av_1_A = mkA "grovsorterbar" ;
  grumlig_av_1_A = mkA "grumlig" ;
  grumsig_av_1_A = mkA "grumsig" ;
  grunderbar_av_1_A = mkA "grunderbar" ;
  grundfalsk_av_1_A = mkA "grundfalsk" ;
  grundlagsmaessig_av_1_1_A = mkA "grundlagsmässig" ;
  grundlig_av_1_A = mkA "grundlig" ;
  grundloes_av_1_1_A = mkA "grundlös" ;
  gruppdynamisk_av_1_A = mkA "gruppdynamisk" ;
  grupperbar_av_1_A = mkA "grupperbar" ;
  grusig_av_1_A = mkA "grusig" ;
  gruvlig_av_1_A = mkA "gruvlig" ;
  grynig_av_1_A = mkA "grynig" ;
  grynpipig_av_1_A = mkA "grynpipig" ;
  graeddgul_av_1_1_A = mkA "gräddgul" ;
  graeddig_av_1_1_A = mkA "gräddig" ;
  graeddvit_av_1_1_A = mkA "gräddvit" ;
  graelaktig_av_1_1_A = mkA "grälaktig" ;
  graelig_av_1_1_A = mkA "grälig" ;
  graell_av_1_1_A = mkA "gräll" ;
  graelsjuk_av_1_1_A = mkA "grälsjuk" ;
  graensloes_av_1_1_A = mkA "gränslös" ;
  graesgroen_av_1_1_A = mkA "gräsgrön" ;
  graeslig_av_1_1_A = mkA "gräslig" ;
  graaaktig_av_1_1_A = mkA "gråaktig" ;
  graablek_av_1_1_A = mkA "gråblek" ;
  graabrun_av_1_1_A = mkA "gråbrun" ;
  graadaskig_av_1_1_A = mkA "grådaskig" ;
  graaflaeckig_av_1_1_A = mkA "gråfläckig" ;
  graagroen_av_1_1_A = mkA "grågrön" ;
  graagul_av_1_1_A = mkA "grågul" ;
  graahaarig_av_1_1_A = mkA "gråhårig" ;
  graakall_av_1_1_A = mkA "gråkall" ;
  graamurrig_av_1_1_A = mkA "gråmurrig" ;
  graaregnig_av_1_1_A = mkA "gråregnig" ;
  graaskimlig_av_1_1_A = mkA "gråskimlig" ;
  graaskaeckig_av_1_1_A = mkA "gråskäckig" ;
  graastrimmig_av_1_1_A = mkA "gråstrimmig" ;
  graatfaerdig_av_1_1_A = mkA "gråtfärdig" ;
  graavit_av_1_1_A = mkA "gråvit" ;
  groen_av_1_1_A = mkA "grön" ;
  groenaktig_av_1_1_A = mkA "grönaktig" ;
  groenblek_av_1_1_A = mkA "grönblek" ;
  groengul_av_1_1_A = mkA "gröngul" ;
  groenkoepingsmaessig_av_1_1_A = mkA "grönköpingsmässig" ;
  groenlaendsk_av_1_1_A = mkA "grönländsk" ;
  groenmoerk_av_1_1_A = mkA "grönmörk" ;
  groenaadrig_av_1_1_A = mkA "grönådrig" ;
  groetig_av_1_1_A = mkA "grötig" ;
  groetmyndig_av_1_1_A = mkA "grötmyndig" ;
  guatemalansk_av_1_A = mkA "guatemalansk" ;
  guatemaltekisk_av_1_A = mkA "guatemaltekisk" ;
  guayansk_av_1_A = mkA "guayansk" ;
  gubbig_av_1_A = mkA "gubbig" ;
  gubbsjuk_av_1_A = mkA "gubbsjuk" ;
  gudaktig_av_1_A = mkA "gudaktig" ;
  gudelig_av_1_A = mkA "gudelig" ;
  gudfruktig_av_1_A = mkA "gudfruktig" ;
  gudlig_av_1_A = mkA "gudlig" ;
  gudloes_av_1_1_A = mkA "gudlös" ;
  gudomlig_av_1_A = mkA "gudomlig" ;
  gudsnaadelig_av_1_1_A = mkA "gudsnådelig" ;
  gudsnaadlig_av_1_1_A = mkA "gudsnådlig" ;
  gudstjaenstlig_av_1_1_A = mkA "gudstjänstlig" ;
  guineansk_av_1_A = mkA "guineansk" ;
  gul_av_1_A = mkA "gul" ;
  gulaktig_av_1_A = mkA "gulaktig" ;
  gulblek_av_1_A = mkA "gulblek" ;
  gulblommig_av_1_A = mkA "gulblommig" ;
  gulbrun_av_1_A = mkA "gulbrun" ;
  guldbesatt_av_1_A = mkA "guldbesatt" ;
  guldgul_av_1_A = mkA "guldgul" ;
  guldsmidd_av_1_A = mkA "guldsmidd" ;
  gulgroen_av_1_1_A = mkA "gulgrön" ;
  gullig_av_1_A = mkA "gullig" ;
  gulrutig_av_1_A = mkA "gulrutig" ;
  gulroed_av_1_1_A = mkA "gulröd" ;
  gulsiktig_av_1_A = mkA "gulsiktig" ;
  gulvit_av_1_A = mkA "gulvit" ;
  gummerbar_av_1_A = mkA "gummerbar" ;
  gummibeklaedd_av_1_1_A = mkA "gummibeklädd" ;
  gummoes_av_1_1_A = mkA "gummös" ;
  gungig_av_1_A = mkA "gungig" ;
  gunstig_av_1_A = mkA "gunstig" ;
  guppig_av_1_A = mkA "guppig" ;
  gustaviansk_av_1_A = mkA "gustaviansk" ;
  guterbar_av_1_A = mkA "guterbar" ;
  gutnisk_av_1_A = mkA "gutnisk" ;
  guttural_av_1_A = mkA "guttural" ;
  guyanansk_av_1_A = mkA "guyanansk" ;
  gyllenbrun_av_1_A = mkA "gyllenbrun" ;
  gymnasial_av_1_A = mkA "gymnasial" ;
  gymnastiserbar_av_1_A = mkA "gymnastiserbar" ;
  gymnastisk_av_1_A = mkA "gymnastisk" ;
  gymnisk_av_1_A = mkA "gymnisk" ;
  gynekologisk_av_1_A = mkA "gynekologisk" ;
  gyttjig_av_1_A = mkA "gyttjig" ;
  gyttrig_av_1_A = mkA "gyttrig" ;
  gaeldfri_av_1_1_A = mkA "gäldfri" ;
  gaelisk_av_1_1_A = mkA "gälisk" ;
  gaell_av_1_1_A = mkA "gäll" ;
  gaenglig_av_1_1_A = mkA "gänglig" ;
  gaespig_av_1_1_A = mkA "gäspig" ;
  gaestriklaendsk_av_1_1_A = mkA "gästrikländsk" ;
  gaestrisk_av_1_1_A = mkA "gästrisk" ;
  gaestvaenlig_av_1_1_A = mkA "gästvänlig" ;
  gaangbar_av_1_1_A = mkA "gångbar" ;
  gaangjaernsfoersedd_av_1_1_A = mkA "gångjärnsförsedd" ;
  gaapaaig_av_1_1_A = mkA "gåpåig" ;
  gaatfull_av_1_1_A = mkA "gåtfull" ;
  goemfroeig_av_1_1_A = mkA "gömfröig" ;
  goerlig_av_1_1_A = mkA "görlig" ;
  goeteborgsk_av_1_1_A = mkA "göteborgsk" ;
  goeticistisk_av_1_1_A = mkA "göticistisk" ;
  goetisk_av_1_1_A = mkA "götisk" ;
  habil_av_1_A = mkA "habil" ;
  habituell_av_1_A = mkA "habituell" ;
  habsburgsk_av_1_A = mkA "habsburgsk" ;
  hackig_av_1_A = mkA "hackig" ;
  hafsig_av_1_A = mkA "hafsig" ;
  hagiografisk_av_1_A = mkA "hagiografisk" ;
  haitisk_av_1_A = mkA "haitisk" ;
  hal_av_1_A = mkA "hal" ;
  halkig_av_1_A = mkA "halkig" ;
  hallucinatorisk_av_1_A = mkA "hallucinatorisk" ;
  hallucinerbar_av_1_A = mkA "hallucinerbar" ;
  hallaendsk_av_1_1_A = mkA "halländsk" ;
  halmgul_av_1_A = mkA "halmgul" ;
  halsstarrig_av_1_A = mkA "halsstarrig" ;
  haltloes_av_1_1_A = mkA "haltlös" ;
  halv_av_1_A = mkA "halv" ;
  halvautomatisk_av_1_A = mkA "halvautomatisk" ;
  halvblank_av_1_A = mkA "halvblank" ;
  halvdaglig_av_1_A = mkA "halvdaglig" ;
  halvdan_av_1_A = mkA "halvdan" ;
  halvdunkel_av_1_A = mkA "halvdunkel" ;
  halvdoed_av_1_1_A = mkA "halvdöd" ;
  halverbar_av_1_A = mkA "halverbar" ;
  halvfet_av_1_A = mkA "halvfet" ;
  halvfransk_av_1_A = mkA "halvfransk" ;
  halvfull_av_1_A = mkA "halvfull" ;
  halvfaerdig_av_1_1_A = mkA "halvfärdig" ;
  halvgenomskinlig_av_1_A = mkA "halvgenomskinlig" ;
  halvhoeg_av_1_1_A = mkA "halvhög" ;
  halvklar_av_1_A = mkA "halvklar" ;
  halvklotformig_av_1_A = mkA "halvklotformig" ;
  halvmetallisk_av_1_A = mkA "halvmetallisk" ;
  halvmeterbred_av_1_A = mkA "halvmeterbred" ;
  halvmodern_av_1_A = mkA "halvmodern" ;
  halvmaanformig_av_1_1_A = mkA "halvmånformig" ;
  halvmoerk_av_1_1_A = mkA "halvmörk" ;
  halvofficiell_av_1_A = mkA "halvofficiell" ;
  halvspraakig_av_1_1_A = mkA "halvspråkig" ;
  halvstatlig_av_1_A = mkA "halvstatlig" ;
  halvstor_av_1_A = mkA "halvstor" ;
  halvsur_av_1_A = mkA "halvsur" ;
  halvsvensk_av_1_A = mkA "halvsvensk" ;
  halvtokig_av_1_A = mkA "halvtokig" ;
  halvtorr_av_1_A = mkA "halvtorr" ;
  halvaarsvis_av_1_1_A = mkA "halvårsvis" ;
  hamitisk_av_1_A = mkA "hamitisk" ;
  handboksmaessig_av_1_1_A = mkA "handboksmässig" ;
  handbollsmaessig_av_1_1_A = mkA "handbollsmässig" ;
  handelsmaessig_av_1_1_A = mkA "handelsmässig" ;
  handelspolitisk_av_1_A = mkA "handelspolitisk" ;
  handflikig_av_1_A = mkA "handflikig" ;
  handgriplig_av_1_A = mkA "handgriplig" ;
  handikappolitisk_av_1_A = mkA "handikappolitisk" ;
  handlingskraftig_av_1_A = mkA "handlingskraftig" ;
  handlingsmaessig_av_1_1_A = mkA "handlingsmässig" ;
  handsbred_av_1_A = mkA "handsbred" ;
  handskbeklaedd_av_1_1_A = mkA "handskbeklädd" ;
  handsydd_av_1_A = mkA "handsydd" ;
  hanglig_av_1_A = mkA "hanglig" ;
  hanlig_av_1_A = mkA "hanlig" ;
  hanterbar_av_1_A = mkA "hanterbar" ;
  hanterlig_av_1_A = mkA "hanterlig" ;
  hantverksmaessig_av_1_1_A = mkA "hantverksmässig" ;
  harangerbar_av_1_A = mkA "harangerbar" ;
  harig_av_1_A = mkA "harig" ;
  harmfull_av_1_A = mkA "harmfull" ;
  harmlig_av_1_A = mkA "harmlig" ;
  harmloes_av_1_1_A = mkA "harmlös" ;
  harmoniserbar_av_1_A = mkA "harmoniserbar" ;
  harmonisk_av_1_A = mkA "harmonisk" ;
  harpunerbar_av_1_A = mkA "harpunerbar" ;
  hasarderbar_av_1_A = mkA "hasarderbar" ;
  haschhoeg_av_1_1_A = mkA "haschhög" ;
  hastig_av_1_A = mkA "hastig" ;
  hatfull_av_1_A = mkA "hatfull" ;
  hatisk_av_1_A = mkA "hatisk" ;
  hattig_av_1_A = mkA "hattig" ;
  havererbar_av_1_A = mkA "havererbar" ;
  hawaiiansk_av_1_A = mkA "hawaiiansk" ;
  hawaiisk_av_1_A = mkA "hawaiisk" ;
  hebreisk_av_1_A = mkA "hebreisk" ;
  hederlig_av_1_A = mkA "hederlig" ;
  hednisk_av_1_A = mkA "hednisk" ;
  hedonistisk_av_1_A = mkA "hedonistisk" ;
  hejdloes_av_1_1_A = mkA "hejdlös" ;
  hejig_av_1_A = mkA "hejig" ;
  hektisk_av_1_A = mkA "hektisk" ;
  hektograferbar_av_1_A = mkA "hektograferbar" ;
  hel_av_1_A = mkA "hel" ;
  helautomatisk_av_1_A = mkA "helautomatisk" ;
  heldaglig_av_1_A = mkA "heldaglig" ;
  helfet_av_1_A = mkA "helfet" ;
  helfransk_av_1_A = mkA "helfransk" ;
  helgarderbar_av_1_A = mkA "helgarderbar" ;
  helig_av_1_A = mkA "helig" ;
  helinackorderbar_av_1_A = mkA "helinackorderbar" ;
  heliocentrisk_av_1_A = mkA "heliocentrisk" ;
  heliofob_av_1_A = mkA "heliofob" ;
  hellenistisk_av_1_A = mkA "hellenistisk" ;
  hellensk_av_1_A = mkA "hellensk" ;
  helnykter_av_1_A = mkA "helnykter" ;
  helroed_av_1_1_A = mkA "helröd" ;
  helstatlig_av_1_A = mkA "helstatlig" ;
  helvetisk_av_1_A = mkA "helvetisk" ;
  helvit_av_1_A = mkA "helvit" ;
  hemhoerig_av_1_1_A = mkA "hemhörig" ;
  hemkaer_av_1_1_A = mkA "hemkär" ;
  hemlig_av_1_A = mkA "hemlig" ;
  hemlighetsfull_av_1_A = mkA "hemlighetsfull" ;
  hemloes_av_1_1_A = mkA "hemlös" ;
  hemmahoerig_av_1_1_A = mkA "hemmahörig" ;
  hemmastadd_av_1_A = mkA "hemmastadd" ;
  hemsk_av_1_A = mkA "hemsk" ;
  hemtam_av_1_A = mkA "hemtam" ;
  hemtrevlig_av_1_A = mkA "hemtrevlig" ;
  heraldisk_av_1_A = mkA "heraldisk" ;
  hereditaer_av_1_1_A = mkA "hereditär" ;
  heretisk_av_1_A = mkA "heretisk" ;
  herkulisk_av_1_A = mkA "herkulisk" ;
  hermeneutisk_av_1_A = mkA "hermeneutisk" ;
  hermetisk_av_1_A = mkA "hermetisk" ;
  heroiserbar_av_1_A = mkA "heroiserbar" ;
  heroisk_av_1_A = mkA "heroisk" ;
  herostratisk_av_1_A = mkA "herostratisk" ;
  herreloes_av_1_1_A = mkA "herrelös" ;
  herrnhutistisk_av_1_A = mkA "herrnhutistisk" ;
  hertiglig_av_1_A = mkA "hertiglig" ;
  hes_av_1_A = mkA "hes" ;
  het_av_1_A = mkA "het" ;
  heterodox_av_1_A = mkA "heterodox" ;
  heteroklitisk_av_1_A = mkA "heteroklitisk" ;
  heteronormativ_av_1_A = mkA "heteronormativ" ;
  heterosexuell_av_1_A = mkA "heterosexuell" ;
  heterotematisk_av_1_A = mkA "heterotematisk" ;
  hetsig_av_1_A = mkA "hetsig" ;
  hetspolitisk_av_1_A = mkA "hetspolitisk" ;
  hettitisk_av_1_A = mkA "hettitisk" ;
  heuristisk_av_1_A = mkA "heuristisk" ;
  hierarkisk_av_1_A = mkA "hierarkisk" ;
  hieratisk_av_1_A = mkA "hieratisk" ;
  himmelsk_av_1_A = mkA "himmelsk" ;
  himmelsvid_av_1_A = mkA "himmelsvid" ;
  hinderlig_av_1_A = mkA "hinderlig" ;
  hinderloes_av_1_1_A = mkA "hinderlös" ;
  hindersloes_av_1_1_A = mkA "hinderslös" ;
  hinduisk_av_1_A = mkA "hinduisk" ;
  hinduistisk_av_1_A = mkA "hinduistisk" ;
  hipp_av_1_A = mkA "hipp" ;
  hippologisk_av_1_A = mkA "hippologisk" ;
  hiskelig_av_1_A = mkA "hiskelig" ;
  hisklig_av_1_A = mkA "hisklig" ;
  hispig_av_1_A = mkA "hispig" ;
  historicistisk_av_1_A = mkA "historicistisk" ;
  historieloes_av_1_1_A = mkA "historielös" ;
  historierbar_av_1_A = mkA "historierbar" ;
  historiserbar_av_1_A = mkA "historiserbar" ;
  historisk_av_1_A = mkA "historisk" ;
  hitmaessig_av_1_1_A = mkA "hitmässig" ;
  hivpositiv_av_1_A = mkA "hivpositiv" ;
  hjaelplig_av_1_1_A = mkA "hjälplig" ;
  hjaelploes_av_1_1_A = mkA "hjälplös" ;
  hjaeltemodig_av_1_1_A = mkA "hjältemodig" ;
  hjaerndoed_av_1_1_A = mkA "hjärndöd" ;
  hjaertegod_av_1_1_A = mkA "hjärtegod" ;
  hjaertevarm_av_1_1_A = mkA "hjärtevarm" ;
  hjaertformig_av_1_1_A = mkA "hjärtformig" ;
  hjaertinnerlig_av_1_1_A = mkA "hjärtinnerlig" ;
  hjaertlig_av_1_1_A = mkA "hjärtlig" ;
  hjaertloes_av_1_1_A = mkA "hjärtlös" ;
  hjaertsjuk_av_1_1_A = mkA "hjärtsjuk" ;
  hjaertaengslig_av_1_1_A = mkA "hjärtängslig" ;
  hobbymaessig_av_1_1_A = mkA "hobbymässig" ;
  hockeymaessig_av_1_1_A = mkA "hockeymässig" ;
  holistisk_av_1_A = mkA "holistisk" ;
  hollaendsk_av_1_1_A = mkA "holländsk" ;
  holograferbar_av_1_A = mkA "holograferbar" ;
  homeopatisk_av_1_A = mkA "homeopatisk" ;
  homerisk_av_1_A = mkA "homerisk" ;
  homiletisk_av_1_A = mkA "homiletisk" ;
  homofon_av_1_A = mkA "homofon" ;
  homogeniserbar_av_1_A = mkA "homogeniserbar" ;
  homograf_av_1_A = mkA "homograf" ;
  homolog_av_1_A = mkA "homolog" ;
  homonym_av_1_A = mkA "homonym" ;
  homosexuell_av_1_A = mkA "homosexuell" ;
  honduransk_av_1_A = mkA "honduransk" ;
  honlig_av_1_A = mkA "honlig" ;
  honnett_av_1_A = mkA "honnett" ;
  honorerbar_av_1_A = mkA "honorerbar" ;
  honoraer_av_1_1_A = mkA "honorär" ;
  honungsgul_av_1_A = mkA "honungsgul" ;
  hopfaellbar_av_1_1_A = mkA "hopfällbar" ;
  hoppfull_av_1_A = mkA "hoppfull" ;
  hoppig_av_1_A = mkA "hoppig" ;
  hopploes_av_1_1_A = mkA "hopplös" ;
  hopskjutbar_av_1_A = mkA "hopskjutbar" ;
  hopsnodd_av_1_A = mkA "hopsnodd" ;
  hoptryckbar_av_1_A = mkA "hoptryckbar" ;
  horisontal_av_1_A = mkA "horisontal" ;
  horisontell_av_1_A = mkA "horisontell" ;
  hormonell_av_1_A = mkA "hormonell" ;
  hornloes_av_1_1_A = mkA "hornlös" ;
  horribel_av_1_A = mkA "horribel" ;
  hospitaliserbar_av_1_A = mkA "hospitaliserbar" ;
  hostig_av_1_A = mkA "hostig" ;
  hotfull_av_1_A = mkA "hotfull" ;
  hottentotsk_av_1_A = mkA "hottentotsk" ;
  hovmannamaessig_av_1_1_A = mkA "hovmannamässig" ;
  hudloes_av_1_1_A = mkA "hudlös" ;
  hudvaenlig_av_1_1_A = mkA "hudvänlig" ;
  hullingfoersedd_av_1_1_A = mkA "hullingförsedd" ;
  human_av_1_A = mkA "human" ;
  humanekologisk_av_1_A = mkA "humanekologisk" ;
  humaniserbar_av_1_A = mkA "humaniserbar" ;
  humanistisk_av_1_A = mkA "humanistisk" ;
  humanitaer_av_1_1_A = mkA "humanitär" ;
  humoristisk_av_1_A = mkA "humoristisk" ;
  humushaltig_av_1_A = mkA "humushaltig" ;
  humoermaessig_av_1_1_A = mkA "humörmässig" ;
  hundraprocentig_av_1_A = mkA "hundraprocentig" ;
  hundraaarig_av_1_1_A = mkA "hundraårig" ;
  hundsfotterbar_av_1_A = mkA "hundsfotterbar" ;
  hungrig_av_1_A = mkA "hungrig" ;
  hurtfrisk_av_1_A = mkA "hurtfrisk" ;
  hurtig_av_1_A = mkA "hurtig" ;
  huserbar_av_1_A = mkA "huserbar" ;
  huslig_av_1_A = mkA "huslig" ;
  husvill_av_1_A = mkA "husvill" ;
  hutloes_av_1_1_A = mkA "hutlös" ;
  huvudansvarig_av_1_A = mkA "huvudansvarig" ;
  huvudloes_av_1_1_A = mkA "huvudlös" ;
  huvudsaklig_av_1_A = mkA "huvudsaklig" ;
  hybridiserbar_av_1_A = mkA "hybridiserbar" ;
  hydraulisk_av_1_A = mkA "hydraulisk" ;
  hydrerbar_av_1_A = mkA "hydrerbar" ;
  hydrodynamisk_av_1_A = mkA "hydrodynamisk" ;
  hydrofob_av_1_A = mkA "hydrofob" ;
  hydrologisk_av_1_A = mkA "hydrologisk" ;
  hydrostatisk_av_1_A = mkA "hydrostatisk" ;
  hygglig_av_1_A = mkA "hygglig" ;
  hygienisk_av_1_A = mkA "hygienisk" ;
  hygroskopisk_av_1_A = mkA "hygroskopisk" ;
  hyperaktiv_av_1_A = mkA "hyperaktiv" ;
  hyperbolisk_av_1_A = mkA "hyperbolisk" ;
  hyperkatalektisk_av_1_A = mkA "hyperkatalektisk" ;
  hyperkaenslig_av_1_1_A = mkA "hyperkänslig" ;
  hypermodern_av_1_A = mkA "hypermodern" ;
  hypnotiserbar_av_1_A = mkA "hypnotiserbar" ;
  hypnotisk_av_1_A = mkA "hypnotisk" ;
  hypokondrisk_av_1_A = mkA "hypokondrisk" ;
  hypokritisk_av_1_A = mkA "hypokritisk" ;
  hypomanisk_av_1_A = mkA "hypomanisk" ;
  hypotaktisk_av_1_A = mkA "hypotaktisk" ;
  hypotetisk_av_1_A = mkA "hypotetisk" ;
  hypotiserbar_av_1_A = mkA "hypotiserbar" ;
  hysbar_av_1_A = mkA "hysbar" ;
  hysterisk_av_1_A = mkA "hysterisk" ;
  haedisk_av_1_1_A = mkA "hädisk" ;
  haeftig_av_1_1_A = mkA "häftig" ;
  haelsingsk_av_1_1_A = mkA "hälsingsk" ;
  haelsofarlig_av_1_1_A = mkA "hälsofarlig" ;
  haelsomaessig_av_1_1_A = mkA "hälsomässig" ;
  haelsopolitisk_av_1_1_A = mkA "hälsopolitisk" ;
  haelsovaadlig_av_1_1_A = mkA "hälsovådlig" ;
  haemndgirig_av_1_1_A = mkA "hämndgirig" ;
  haemningsloes_av_1_1_A = mkA "hämningslös" ;
  haendelsefattig_av_1_1_A = mkA "händelsefattig" ;
  haendelseloes_av_1_1_A = mkA "händelselös" ;
  haendelserik_av_1_1_A = mkA "händelserik" ;
  haendig_av_1_1_A = mkA "händig" ;
  haengfaerdig_av_1_1_A = mkA "hängfärdig" ;
  haengig_av_1_1_A = mkA "hängig" ;
  haengsjuk_av_1_1_A = mkA "hängsjuk" ;
  haensynsfull_av_1_1_A = mkA "hänsynsfull" ;
  haensynsloes_av_1_1_A = mkA "hänsynslös" ;
  haerbaergerbar_av_1_1_A = mkA "härbärgerbar" ;
  haerdig_av_1_1_A = mkA "härdig" ;
  haerjedalsk_av_1_1_A = mkA "härjedalsk" ;
  haerlig_av_1_1_A = mkA "härlig" ;
  haetsk_av_1_1_A = mkA "hätsk" ;
  haagloes_av_1_1_A = mkA "håglös" ;
  haalig_av_1_1_A = mkA "hålig" ;
  haallbar_av_1_1_A = mkA "hållbar" ;
  haallningsloes_av_1_1_A = mkA "hållningslös" ;
  haanfull_av_1_1_A = mkA "hånfull" ;
  haardfoer_av_1_1_A = mkA "hårdför" ;
  haardvarumaessig_av_1_1_A = mkA "hårdvarumässig" ;
  haarfin_av_1_1_A = mkA "hårfin" ;
  haarig_av_1_1_A = mkA "hårig" ;
  haarloes_av_1_1_A = mkA "hårlös" ;
  hoegaktiv_av_1_1_A = mkA "högaktiv" ;
  hoegaktningsfull_av_1_1_A = mkA "högaktningsfull" ;
  hoegaktuell_av_1_1_A = mkA "högaktuell" ;
  hoegborgerlig_av_1_1_A = mkA "högborgerlig" ;
  hoegeffektiv_av_1_1_A = mkA "högeffektiv" ;
  hoegerextrem_av_1_1_A = mkA "högerextrem" ;
  hoegerextremistisk_av_1_1_A = mkA "högerextremistisk" ;
  hoegernationalistisk_av_1_1_A = mkA "högernationalistisk" ;
  hoegerpolitisk_av_1_1_A = mkA "högerpolitisk" ;
  hoegerpopulistisk_av_1_1_A = mkA "högerpopulistisk" ;
  hoegexplosiv_av_1_1_A = mkA "högexplosiv" ;
  hoegfaerdig_av_1_1_A = mkA "högfärdig" ;
  hoegfoernaem_av_1_1_A = mkA "högförnäm" ;
  hoeggradig_av_1_1_A = mkA "höggradig" ;
  hoegklassig_av_1_1_A = mkA "högklassig" ;
  hoegkyrklig_av_1_1_A = mkA "högkyrklig" ;
  hoegljudd_av_1_1_A = mkA "högljudd" ;
  hoegmodig_av_1_1_A = mkA "högmodig" ;
  hoegmolekylaer_av_1_1_A = mkA "högmolekylär" ;
  hoegoktanig_av_1_1_A = mkA "högoktanig" ;
  hoegpatriotisk_av_1_1_A = mkA "högpatriotisk" ;
  hoegrestaandsmaessig_av_1_1_A = mkA "högreståndsmässig" ;
  hoegromantisk_av_1_1_A = mkA "högromantisk" ;
  hoegroed_av_1_1_A = mkA "högröd" ;
  hoegskolemaessig_av_1_1_A = mkA "högskolemässig" ;
  hoegteknologisk_av_1_1_A = mkA "högteknologisk" ;
  hoegtidlig_av_1_1_A = mkA "högtidlig" ;
  hoegtysk_av_1_1_A = mkA "högtysk" ;
  hoegvaerdig_av_1_1_A = mkA "högvärdig" ;
  hoegvoerdig_av_1_1_A = mkA "högvördig" ;
  hoegoensklig_av_1_1_A = mkA "högönsklig" ;
  hoejdmaessig_av_1_1_A = mkA "höjdmässig" ;
  hoensig_av_1_1_A = mkA "hönsig" ;
  hoerbar_av_1_1_A = mkA "hörbar" ;
  hoestlig_av_1_1_A = mkA "höstlig" ;
  hoestloevsgul_av_1_1_A = mkA "höstlövsgul" ;
  hoeststormig_av_1_1_A = mkA "höststormig" ;
  hoevisk_av_1_1_A = mkA "hövisk" ;
  hoevlig_av_1_1_A = mkA "hövlig" ;
  iberisk_av_1_A = mkA "iberisk" ;
  ibero_amerikansk_av_1_A = mkA "ibero-amerikansk" ;
  icke_darwinistisk_av_1_A = mkA "icke-darwinistisk" ;
  icke_euklidisk_av_1_A = mkA "icke-euklidisk" ;
  icke_individuell_av_1_A = mkA "icke-individuell" ;
  icke_linjaer_av_1_1_A = mkA "icke-linjär" ;
  icke_periodisk_av_1_A = mkA "icke-periodisk" ;
  icke_politisk_av_1_A = mkA "icke-politisk" ;
  icke_religioes_av_1_1_A = mkA "icke-religiös" ;
  icke_symmetrisk_av_1_A = mkA "icke-symmetrisk" ;
  icke_verbal_av_1_A = mkA "icke-verbal" ;
  ickemuslimsk_av_1_A = mkA "ickemuslimsk" ;
  ickepolitisk_av_1_A = mkA "ickepolitisk" ;
  ickeverbal_av_1_A = mkA "ickeverbal" ;
  ideal_av_1_A = mkA "ideal" ;
  idealiserbar_av_1_A = mkA "idealiserbar" ;
  idealisk_av_1_A = mkA "idealisk" ;
  idealistisk_av_1_A = mkA "idealistisk" ;
  ideell_av_1_A = mkA "ideell" ;
  idelig_av_1_A = mkA "idelig" ;
  identifierbar_av_1_A = mkA "identifierbar" ;
  identisk_av_1_A = mkA "identisk" ;
  identitetsmaessig_av_1_1_A = mkA "identitetsmässig" ;
  ideografisk_av_1_A = mkA "ideografisk" ;
  ideologisk_av_1_A = mkA "ideologisk" ;
  idiomatisk_av_1_A = mkA "idiomatisk" ;
  idiopatisk_av_1_A = mkA "idiopatisk" ;
  idiotisk_av_1_A = mkA "idiotisk" ;
  idiotsaeker_av_1_1_A = mkA "idiotsäker" ;
  idog_av_1_A = mkA "idog" ;
  idrottslig_av_1_A = mkA "idrottslig" ;
  idrottsmaessig_av_1_1_A = mkA "idrottsmässig" ;
  idyllisk_av_1_A = mkA "idyllisk" ;
  id_efattig_av_1_1_A = mkA "idéfattig" ;
  id_ehistorisk_av_1_1_A = mkA "idéhistorisk" ;
  id_emaessig_av_1_1_A = mkA "idémässig" ;
  id_erik_av_1_1_A = mkA "idérik" ;
  igengrodd_av_1_A = mkA "igengrodd" ;
  igenkaennlig_av_1_1_A = mkA "igenkännlig" ;
  ignorerbar_av_1_A = mkA "ignorerbar" ;
  ihopfaellbar_av_1_1_A = mkA "ihopfällbar" ;
  ihaerdig_av_1_1_A = mkA "ihärdig" ;
  ihaalig_av_1_1_A = mkA "ihålig" ;
  ihaallig_av_1_1_A = mkA "ihållig" ;
  ikonisk_av_1_A = mkA "ikonisk" ;
  iktyologisk_av_1_A = mkA "iktyologisk" ;
  ilig_av_1_A = mkA "ilig" ;
  illegal_av_1_A = mkA "illegal" ;
  illegitim_av_1_A = mkA "illegitim" ;
  illfundig_av_1_A = mkA "illfundig" ;
  illistig_av_1_A = mkA "illistig" ;
  illmarig_av_1_A = mkA "illmarig" ;
  illojal_av_1_A = mkA "illojal" ;
  illparig_av_1_A = mkA "illparig" ;
  illroed_av_1_1_A = mkA "illröd" ;
  illslug_av_1_A = mkA "illslug" ;
  illuminerbar_av_1_A = mkA "illuminerbar" ;
  illusionsloes_av_1_1_A = mkA "illusionslös" ;
  illusorisk_av_1_A = mkA "illusorisk" ;
  illuster_av_1_A = mkA "illuster" ;
  illustrativ_av_1_A = mkA "illustrativ" ;
  illustrerbar_av_1_A = mkA "illustrerbar" ;
  illvillig_av_1_A = mkA "illvillig" ;
  illyrisk_av_1_A = mkA "illyrisk" ;
  ilsk_av_1_A = mkA "ilsk" ;
  imagemaessig_av_1_1_A = mkA "imagemässig" ;
  imaginaer_av_1_1_A = mkA "imaginär" ;
  imbecill_av_1_A = mkA "imbecill" ;
  imitativ_av_1_A = mkA "imitativ" ;
  imiterbar_av_1_A = mkA "imiterbar" ;
  immateriell_av_1_A = mkA "immateriell" ;
  immatrikulerbar_av_1_A = mkA "immatrikulerbar" ;
  immig_av_1_A = mkA "immig" ;
  immigrerbar_av_1_A = mkA "immigrerbar" ;
  immobil_av_1_A = mkA "immobil" ;
  immun_av_1_A = mkA "immun" ;
  immuniserbar_av_1_A = mkA "immuniserbar" ;
  immunologisk_av_1_A = mkA "immunologisk" ;
  imperativisk_av_1_A = mkA "imperativisk" ;
  imperatorisk_av_1_A = mkA "imperatorisk" ;
  imperialistisk_av_1_A = mkA "imperialistisk" ;
  implanterbar_av_1_A = mkA "implanterbar" ;
  implicerbar_av_1_A = mkA "implicerbar" ;
  imploderbar_av_1_A = mkA "imploderbar" ;
  imponerbar_av_1_A = mkA "imponerbar" ;
  impopulaer_av_1_1_A = mkA "impopulär" ;
  importerbar_av_1_A = mkA "importerbar" ;
  impregnerbar_av_1_A = mkA "impregnerbar" ;
  impressionistisk_av_1_A = mkA "impressionistisk" ;
  improduktiv_av_1_A = mkA "improduktiv" ;
  improvisatorisk_av_1_A = mkA "improvisatorisk" ;
  improviserbar_av_1_A = mkA "improviserbar" ;
  impulsiv_av_1_A = mkA "impulsiv" ;
  inackorderbar_av_1_A = mkA "inackorderbar" ;
  inaktiv_av_1_A = mkA "inaktiv" ;
  inaktuell_av_1_A = mkA "inaktuell" ;
  inaugurerbar_av_1_A = mkA "inaugurerbar" ;
  inbillningssjuk_av_1_A = mkA "inbillningssjuk" ;
  inbilsk_av_1_A = mkA "inbilsk" ;
  incestuoes_av_1_1_A = mkA "incestuös" ;
  indexerbar_av_1_A = mkA "indexerbar" ;
  indexreglerbar_av_1_A = mkA "indexreglerbar" ;
  indiansk_av_1_A = mkA "indiansk" ;
  indicerbar_av_1_A = mkA "indicerbar" ;
  indikativ_av_1_A = mkA "indikativ" ;
  indikerbar_av_1_A = mkA "indikerbar" ;
  indisk_av_1_A = mkA "indisk" ;
  indisponibel_av_1_A = mkA "indisponibel" ;
  individualiserbar_av_1_A = mkA "individualiserbar" ;
  individualistisk_av_1_A = mkA "individualistisk" ;
  individuell_av_1_A = mkA "individuell" ;
  indoeuropeisk_av_1_A = mkA "indoeuropeisk" ;
  indokinesisk_av_1_A = mkA "indokinesisk" ;
  indoktrinerbar_av_1_A = mkA "indoktrinerbar" ;
  indonesisk_av_1_A = mkA "indonesisk" ;
  indraektig_av_1_1_A = mkA "indräktig" ;
  inducerbar_av_1_A = mkA "inducerbar" ;
  induktiv_av_1_A = mkA "induktiv" ;
  industrialiserbar_av_1_A = mkA "industrialiserbar" ;
  industrialistisk_av_1_A = mkA "industrialistisk" ;
  industriell_av_1_A = mkA "industriell" ;
  industrimaessig_av_1_1_A = mkA "industrimässig" ;
  industripolitisk_av_1_A = mkA "industripolitisk" ;
  ineffektiv_av_1_A = mkA "ineffektiv" ;
  infallsrik_av_1_A = mkA "infallsrik" ;
  infam_av_1_A = mkA "infam" ;
  infantil_av_1_A = mkA "infantil" ;
  infantiliserbar_av_1_A = mkA "infantiliserbar" ;
  infekterbar_av_1_A = mkA "infekterbar" ;
  infektioes_av_1_1_A = mkA "infektiös" ;
  infernalisk_av_1_A = mkA "infernalisk" ;
  infertil_av_1_A = mkA "infertil" ;
  infiltrerbar_av_1_A = mkA "infiltrerbar" ;
  inflammatorisk_av_1_A = mkA "inflammatorisk" ;
  inflammerbar_av_1_A = mkA "inflammerbar" ;
  inflationistisk_av_1_A = mkA "inflationistisk" ;
  inflatorisk_av_1_A = mkA "inflatorisk" ;
  influerbar_av_1_A = mkA "influerbar" ;
  inflytelserik_av_1_A = mkA "inflytelserik" ;
  informationsansvarig_av_1_A = mkA "informationsansvarig" ;
  informationsmaessig_av_1_1_A = mkA "informationsmässig" ;
  informationsrik_av_1_A = mkA "informationsrik" ;
  informationsteknologisk_av_1_A = mkA "informationsteknologisk" ;
  informativ_av_1_A = mkA "informativ" ;
  informell_av_1_A = mkA "informell" ;
  informerbar_av_1_A = mkA "informerbar" ;
  infraroed_av_1_1_A = mkA "infraröd" ;
  infrastrukturell_av_1_A = mkA "infrastrukturell" ;
  infoedd_av_1_1_A = mkA "infödd" ;
  infoerstaadd_av_1_1_A = mkA "införstådd" ;
  ingenjoersmaessig_av_1_1_A = mkA "ingenjörsmässig" ;
  ingraverbar_av_1_A = mkA "ingraverbar" ;
  ingrodd_av_1_A = mkA "ingrodd" ;
  inhalerbar_av_1_A = mkA "inhalerbar" ;
  inhemsk_av_1_A = mkA "inhemsk" ;
  inhiberbar_av_1_A = mkA "inhiberbar" ;
  inhibiterbar_av_1_A = mkA "inhibiterbar" ;
  inhuman_av_1_A = mkA "inhuman" ;
  initial_av_1_A = mkA "initial" ;
  initiativrik_av_1_A = mkA "initiativrik" ;
  initierbar_av_1_A = mkA "initierbar" ;
  injekterbar_av_1_A = mkA "injekterbar" ;
  injicerbar_av_1_A = mkA "injicerbar" ;
  inkapabel_av_1_A = mkA "inkapabel" ;
  inkarnerbar_av_1_A = mkA "inkarnerbar" ;
  inkasserbar_av_1_A = mkA "inkasserbar" ;
  inkiett_av_1_A = mkA "inkiett" ;
  inklarerbar_av_1_A = mkA "inklarerbar" ;
  inkluderbar_av_1_A = mkA "inkluderbar" ;
  inkoativ_av_1_A = mkA "inkoativ" ;
  inkommensurabel_av_1_A = mkA "inkommensurabel" ;
  inkompatibel_av_1_A = mkA "inkompatibel" ;
  inkomstmaessig_av_1_1_A = mkA "inkomstmässig" ;
  inkomstsvag_av_1_A = mkA "inkomstsvag" ;
  inkomsttaxerbar_av_1_A = mkA "inkomsttaxerbar" ;
  inkorporerbar_av_1_A = mkA "inkorporerbar" ;
  inkvarterbar_av_1_A = mkA "inkvarterbar" ;
  inkvisitorisk_av_1_A = mkA "inkvisitorisk" ;
  inlaendsk_av_1_1_A = mkA "inländsk" ;
  inlaerningsmaessig_av_1_1_A = mkA "inlärningsmässig" ;
  innehaallslig_av_1_1_A = mkA "innehållslig" ;
  innehaallsloes_av_1_1_A = mkA "innehållslös" ;
  innehaallsmaessig_av_1_1_A = mkA "innehållsmässig" ;
  innehaallsrik_av_1_1_A = mkA "innehållsrik" ;
  innerlig_av_1_A = mkA "innerlig" ;
  innerstadsmaessig_av_1_1_A = mkA "innerstadsmässig" ;
  innerverbar_av_1_A = mkA "innerverbar" ;
  innovativ_av_1_A = mkA "innovativ" ;
  inofficiell_av_1_A = mkA "inofficiell" ;
  inokulerbar_av_1_A = mkA "inokulerbar" ;
  inomkatolsk_av_1_A = mkA "inomkatolsk" ;
  inomvetenskaplig_av_1_A = mkA "inomvetenskaplig" ;
  inopportun_av_1_A = mkA "inopportun" ;
  inplanterbar_av_1_A = mkA "inplanterbar" ;
  inrangerbar_av_1_A = mkA "inrangerbar" ;
  inrapporterbar_av_1_A = mkA "inrapporterbar" ;
  inredningsmaessig_av_1_1_A = mkA "inredningsmässig" ;
  inregistrerbar_av_1_A = mkA "inregistrerbar" ;
  inremedicinsk_av_1_A = mkA "inremedicinsk" ;
  inresekretorisk_av_1_A = mkA "inresekretorisk" ;
  inrikespolitisk_av_1_A = mkA "inrikespolitisk" ;
  insatt_av_1_A = mkA "insatt" ;
  inscenerbar_av_1_A = mkA "inscenerbar" ;
  insektskunnig_av_1_A = mkA "insektskunnig" ;
  inseminerbar_av_1_A = mkA "inseminerbar" ;
  insiktsfull_av_1_A = mkA "insiktsfull" ;
  insinuerbar_av_1_A = mkA "insinuerbar" ;
  insnodd_av_1_A = mkA "insnodd" ;
  inspekterbar_av_1_A = mkA "inspekterbar" ;
  inspirationsmaessig_av_1_1_A = mkA "inspirationsmässig" ;
  inspirerbar_av_1_A = mkA "inspirerbar" ;
  instabil_av_1_A = mkA "instabil" ;
  installerbar_av_1_A = mkA "installerbar" ;
  instinktiv_av_1_A = mkA "instinktiv" ;
  instinktmaessig_av_1_1_A = mkA "instinktmässig" ;
  institutionaliserbar_av_1_A = mkA "institutionaliserbar" ;
  institutionell_av_1_A = mkA "institutionell" ;
  instruerbar_av_1_A = mkA "instruerbar" ;
  instruktiv_av_1_A = mkA "instruktiv" ;
  instrumental_av_1_A = mkA "instrumental" ;
  instrumentell_av_1_A = mkA "instrumentell" ;
  instrumenterbar_av_1_A = mkA "instrumenterbar" ;
  instuderbar_av_1_A = mkA "instuderbar" ;
  instaellbar_av_1_1_A = mkA "inställbar" ;
  instaellningsbar_av_1_1_A = mkA "inställningsbar" ;
  insulaer_av_1_1_A = mkA "insulär" ;
  insydd_av_1_A = mkA "insydd" ;
  integrationspolitisk_av_1_A = mkA "integrationspolitisk" ;
  integrerbar_av_1_A = mkA "integrerbar" ;
  integritetsmaessig_av_1_1_A = mkA "integritetsmässig" ;
  intellektualiserbar_av_1_A = mkA "intellektualiserbar" ;
  intellektualistisk_av_1_A = mkA "intellektualistisk" ;
  intellektuell_av_1_A = mkA "intellektuell" ;
  intelligensmaessig_av_1_1_A = mkA "intelligensmässig" ;
  intensifierbar_av_1_A = mkA "intensifierbar" ;
  intensiv_av_1_A = mkA "intensiv" ;
  intensiverbar_av_1_A = mkA "intensiverbar" ;
  interaktiv_av_1_A = mkA "interaktiv" ;
  interdental_av_1_A = mkA "interdental" ;
  interetnisk_av_1_A = mkA "interetnisk" ;
  interfolierbar_av_1_A = mkA "interfolierbar" ;
  interglacial_av_1_A = mkA "interglacial" ;
  interimistisk_av_1_A = mkA "interimistisk" ;
  interkontinental_av_1_A = mkA "interkontinental" ;
  intern_av_1_A = mkA "intern" ;
  internaliserbar_av_1_A = mkA "internaliserbar" ;
  internationaliserbar_av_1_A = mkA "internationaliserbar" ;
  internationalistisk_av_1_A = mkA "internationalistisk" ;
  internationell_av_1_A = mkA "internationell" ;
  internerbar_av_1_A = mkA "internerbar" ;
  internordisk_av_1_A = mkA "internordisk" ;
  interorganisatorisk_av_1_A = mkA "interorganisatorisk" ;
  interpellerbar_av_1_A = mkA "interpellerbar" ;
  interplanetarisk_av_1_A = mkA "interplanetarisk" ;
  interpolerbar_av_1_A = mkA "interpolerbar" ;
  interpreterbar_av_1_A = mkA "interpreterbar" ;
  interpunkterbar_av_1_A = mkA "interpunkterbar" ;
  interrogativ_av_1_A = mkA "interrogativ" ;
  interstellaer_av_1_1_A = mkA "interstellär" ;
  interurban_av_1_A = mkA "interurban" ;
  intervenerbar_av_1_A = mkA "intervenerbar" ;
  intervokalisk_av_1_A = mkA "intervokalisk" ;
  intig_av_1_A = mkA "intig" ;
  intim_av_1_A = mkA "intim" ;
  intolerabel_av_1_A = mkA "intolerabel" ;
  intrinsisk_av_1_A = mkA "intrinsisk" ;
  invandrarpolitisk_av_1_A = mkA "invandrarpolitisk" ;
  invandringspolitisk_av_1_A = mkA "invandringspolitisk" ;
  invariabel_av_1_A = mkA "invariabel" ;
  irreligioes_av_1_1_A = mkA "irreligiös" ;
  irreparabel_av_1_A = mkA "irreparabel" ;
  irreversibel_av_1_A = mkA "irreversibel" ;
  irritabel_av_1_A = mkA "irritabel" ;
  jainistisk_av_1_A = mkA "jainistisk" ;
  jansenistisk_av_1_A = mkA "jansenistisk" ;
  jordbrukspolitisk_av_1_A = mkA "jordbrukspolitisk" ;
  jordbaevningssaeker_av_1_1_A = mkA "jordbävningssäker" ;
  justerbar_av_1_A = mkA "justerbar" ;
  jaemgod_av_1_1_A = mkA "jämgod" ;
  jaemngod_av_1_1_A = mkA "jämngod" ;
  jaemnaarig_av_1_1_A = mkA "jämnårig" ;
  jaemstor_av_1_1_A = mkA "jämstor" ;
  jaemstaelldhetspolitisk_av_1_1_A = mkA "jämställdhetspolitisk" ;
  jaettefin_av_1_1_A = mkA "jättefin" ;
  jaetteglad_av_1_1_A = mkA "jätteglad" ;
  jaettelarvig_av_1_1_A = mkA "jättelarvig" ;
  jaettelaang_av_1_1_A = mkA "jättelång" ;
  jaetterolig_av_1_1_A = mkA "jätterolig" ;
  jaettestor_av_1_1_A = mkA "jättestor" ;
  jaettesvaar_av_1_1_A = mkA "jättesvår" ;
  jaetteviktig_av_1_1_A = mkA "jätteviktig" ;
  kabbalistisk_av_1_A = mkA "kabbalistisk" ;
  kamprydd_av_1_A = mkA "kamprydd" ;
  kaninstor_av_1_A = mkA "kaninstor" ;
  kannibalistisk_av_1_A = mkA "kannibalistisk" ;
  kantabel_av_1_A = mkA "kantabel" ;
  kantstoett_av_1_1_A = mkA "kantstött" ;
  kapabel_av_1_A = mkA "kapabel" ;
  karateteknisk_av_1_A = mkA "karateteknisk" ;
  karolingisk_av_1_A = mkA "karolingisk" ;
  karriaeristisk_av_1_1_A = mkA "karriäristisk" ;
  kassabel_av_1_A = mkA "kassabel" ;
  kastanjbrun_av_1_A = mkA "kastanjbrun" ;
  kastanjebrun_av_1_A = mkA "kastanjebrun" ;
  katadrom_av_1_A = mkA "katadrom" ;
  katedersocialistisk_av_1_A = mkA "katedersocialistisk" ;
  kejsarlik_av_1_A = mkA "kejsarlik" ;
  keramisk_av_1_A = mkA "keramisk" ;
  kilometerhoeg_av_1_1_A = mkA "kilometerhög" ;
  kilometerlaang_av_1_1_A = mkA "kilometerlång" ;
  kippskodd_av_1_A = mkA "kippskodd" ;
  kjolloes_av_1_1_A = mkA "kjollös" ;
  klarroed_av_1_1_A = mkA "klarröd" ;
  klassicistisk_av_1_A = mkA "klassicistisk" ;
  klerikofascistisk_av_1_A = mkA "klerikofascistisk" ;
  klotformig_av_1_A = mkA "klotformig" ;
  klotsporig_av_1_A = mkA "klotsporig" ;
  klaedd_av_1_1_A = mkA "klädd" ;
  klaemkaeck_av_1_1_A = mkA "klämkäck" ;
  kloevertroett_av_1_1_A = mkA "klövertrött" ;
  knallroed_av_1_1_A = mkA "knallröd" ;
  knaper_av_1_A = mkA "knaper" ;
  knaadbar_av_1_1_A = mkA "knådbar" ;
  kokett_av_1_A = mkA "kokett" ;
  kollektivistisk_av_1_A = mkA "kollektivistisk" ;
  kolonialistisk_av_1_A = mkA "kolonialistisk" ;
  koloristisk_av_1_A = mkA "koloristisk" ;
  komfortabel_av_1_A = mkA "komfortabel" ;
  kommensurabel_av_1_A = mkA "kommensurabel" ;
  kommunalekonomisk_av_1_A = mkA "kommunalekonomisk" ;
  kommunikationscentral_av_1_A = mkA "kommunikationscentral" ;
  komparabel_av_1_A = mkA "komparabel" ;
  kompatibel_av_1_A = mkA "kompatibel" ;
  komplett_av_1_A = mkA "komplett" ;
  konformistisk_av_1_A = mkA "konformistisk" ;
  konfrontativ_av_1_A = mkA "konfrontativ" ;
  konfrontatorisk_av_1_A = mkA "konfrontatorisk" ;
  konfucianistisk_av_1_A = mkA "konfucianistisk" ;
  konjunkturpolitisk_av_1_A = mkA "konjunkturpolitisk" ;
  konkretistisk_av_1_A = mkA "konkretistisk" ;
  konkurrensutsatt_av_1_A = mkA "konkurrensutsatt" ;
  konspirationsteoretisk_av_1_A = mkA "konspirationsteoretisk" ;
  konstindustriell_av_1_A = mkA "konstindustriell" ;
  konstteoretisk_av_1_A = mkA "konstteoretisk" ;
  konsumentpolitisk_av_1_A = mkA "konsumentpolitisk" ;
  konversabel_av_1_A = mkA "konversabel" ;
  konvertibel_av_1_A = mkA "konvertibel" ;
  kopparroed_av_1_1_A = mkA "kopparröd" ;
  korallroed_av_1_1_A = mkA "korallröd" ;
  korgvis_av_1_A = mkA "korgvis" ;
  korporatistisk_av_1_A = mkA "korporatistisk" ;
  korporativistisk_av_1_A = mkA "korporativistisk" ;
  korsvis_av_1_A = mkA "korsvis" ;
  kostymklaedd_av_1_1_A = mkA "kostymklädd" ;
  kreationistisk_av_1_A = mkA "kreationistisk" ;
  krigstroett_av_1_1_A = mkA "krigstrött" ;
  kriminalpolitisk_av_1_A = mkA "kriminalpolitisk" ;
  kriminalteknisk_av_1_A = mkA "kriminalteknisk" ;
  kristdemokratisk_av_1_A = mkA "kristdemokratisk" ;
  kristologisk_av_1_A = mkA "kristologisk" ;
  kromatisk_av_1_A = mkA "kromatisk" ;
  kryptografisk_av_1_A = mkA "kryptografisk" ;
  kubisk_av_1_A = mkA "kubisk" ;
  kulturpolitisk_av_1_A = mkA "kulturpolitisk" ;
  kunskapsteoretisk_av_1_A = mkA "kunskapsteoretisk" ;
  kupolfoersedd_av_1_1_A = mkA "kupolförsedd" ;
  kvadratisk_av_1_A = mkA "kvadratisk" ;
  kvartalsvis_av_1_A = mkA "kvartalsvis" ;
  kvartsekellaang_av_1_1_A = mkA "kvartsekellång" ;
  kvasiintellektuell_av_1_A = mkA "kvasiintellektuell" ;
  kvietistisk_av_1_A = mkA "kvietistisk" ;
  kvinnopolitisk_av_1_A = mkA "kvinnopolitisk" ;
  kynokephal_av_1_A = mkA "kynokephal" ;
  kyssaeker_av_1_1_A = mkA "kyssäker" ;
  kaellkritisk_av_1_1_A = mkA "källkritisk" ;
  kaerleksberedd_av_1_1_A = mkA "kärleksberedd" ;
  kaernteknisk_av_1_1_A = mkA "kärnteknisk" ;
  koensneutral_av_1_1_A = mkA "könsneutral" ;
  koepkraftstark_av_1_1_A = mkA "köpkraftstark" ;
  koersbaersroed_av_1_1_A = mkA "körsbärsröd" ;
  laber_av_1_A = mkA "laber" ;
  lamaistisk_av_1_A = mkA "lamaistisk" ;
  landsgagnelig_av_1_A = mkA "landsgagnelig" ;
  laparoskopisk_av_1_A = mkA "laparoskopisk" ;
  led_av_1_A = mkA "led" ;
  lemmalytt_av_1_A = mkA "lemmalytt" ;
  levnadsglad_av_1_A = mkA "levnadsglad" ;
  levnadstroett_av_1_1_A = mkA "levnadstrött" ;
  liberalistisk_av_1_A = mkA "liberalistisk" ;
  likoeverstroedd_av_1_1_A = mkA "liköverströdd" ;
  lingonroed_av_1_1_A = mkA "lingonröd" ;
  litteraturvetenskaplig_av_1_A = mkA "litteraturvetenskaplig" ;
  ljuslaett_av_1_1_A = mkA "ljuslätt" ;
  ljusroed_av_1_1_A = mkA "ljusröd" ;
  lokaliseringspolitisk_av_1_A = mkA "lokaliseringspolitisk" ;
  lokalpatriotisk_av_1_A = mkA "lokalpatriotisk" ;
  lokalpolitisk_av_1_A = mkA "lokalpolitisk" ;
  lucker_av_1_A = mkA "lucker" ;
  luguber_av_1_A = mkA "luguber" ;
  lytt_av_1_A = mkA "lytt" ;
  laecker_av_1_1_A = mkA "läcker" ;
  laerarledd_av_1_1_A = mkA "lärarledd" ;
  laett_av_1_1_A = mkA "lätt" ;
  laettklaedd_av_1_1_A = mkA "lättklädd" ;
  laettledd_av_1_1_A = mkA "lättledd" ;
  laettskoett_av_1_1_A = mkA "lättskött" ;
  laettstoett_av_1_1_A = mkA "lättstött" ;
  laagintensiv_av_1_1_A = mkA "lågintensiv" ;
  laagsaesongssoemnig_av_1_1_A = mkA "lågsäsongssömnig" ;
  laangperiodisk_av_1_1_A = mkA "långperiodisk" ;
  laangtidsarbetsloes_av_1_1_A = mkA "långtidsarbetslös" ;
  laarhoeg_av_1_1_A = mkA "lårhög" ;
  loenepolitisk_av_1_1_A = mkA "lönepolitisk" ;
  loes_av_2_1_A = mkA "lös" ;
  loevklaedd_av_1_1_A = mkA "lövklädd" ;
  mager_av_1_A = mkA "mager" ;
  makaber_av_1_A = mkA "makaber" ;
  maktpolitisk_av_1_A = mkA "maktpolitisk" ;
  mangogul_av_1_A = mkA "mangogul" ;
  manieristisk_av_1_A = mkA "manieristisk" ;
  manikeistisk_av_1_A = mkA "manikeistisk" ;
  manschauvinistisk_av_1_A = mkA "manschauvinistisk" ;
  manshoeg_av_1_1_A = mkA "manshög" ;
  mantelklaedd_av_1_1_A = mkA "mantelklädd" ;
  maoistisk_av_1_A = mkA "maoistisk" ;
  marinarkeologisk_av_1_A = mkA "marinarkeologisk" ;
  maskinteknisk_av_1_A = mkA "maskinteknisk" ;
  masochistisk_av_1_A = mkA "masochistisk" ;
  matt_av_1_A = mkA "matt" ;
  medelgod_av_1_A = mkA "medelgod" ;
  medelgrov_av_1_A = mkA "medelgrov" ;
  medelhoeg_av_1_1_A = mkA "medelhög" ;
  medelstor_av_1_A = mkA "medelstor" ;
  medelsvaar_av_1_1_A = mkA "medelsvår" ;
  medfoedd_av_1_1_A = mkA "medfödd" ;
  mediapolitisk_av_1_A = mkA "mediapolitisk" ;
  medicinhistorisk_av_1_A = mkA "medicinhistorisk" ;
  mediepolitisk_av_1_A = mkA "mediepolitisk" ;
  medioker_av_1_A = mkA "medioker" ;
  mellanmaensklig_av_1_1_A = mkA "mellanmänsklig" ;
  mellanstor_av_1_A = mkA "mellanstor" ;
  mentalistisk_av_1_A = mkA "mentalistisk" ;
  merkantilistisk_av_1_A = mkA "merkantilistisk" ;
  mesolitisk_av_1_A = mkA "mesolitisk" ;
  metallklaedd_av_1_1_A = mkA "metallklädd" ;
  meterlaang_av_1_1_A = mkA "meterlång" ;
  metodistisk_av_1_A = mkA "metodistisk" ;
  militaerdiplomatisk_av_1_1_A = mkA "militärdiplomatisk" ;
  miljoepolitisk_av_1_1_A = mkA "miljöpolitisk" ;
  millimeterlaang_av_1_1_A = mkA "millimeterlång" ;
  milslaang_av_1_1_A = mkA "milslång" ;
  milsvid_av_1_A = mkA "milsvid" ;
  minnesgod_av_1_A = mkA "minnesgod" ;
  miserabel_av_1_A = mkA "miserabel" ;
  mnemonisk_av_1_A = mkA "mnemonisk" ;
  moderloes_av_1_1_A = mkA "moderlös" ;
  monistisk_av_1_A = mkA "monistisk" ;
  monopolistisk_av_1_A = mkA "monopolistisk" ;
  monoteistisk_av_1_A = mkA "monoteistisk" ;
  moralistisk_av_1_A = mkA "moralistisk" ;
  morgonfryntlig_av_1_A = mkA "morgonfryntlig" ;
  morgontroett_av_1_1_A = mkA "morgontrött" ;
  mossklaedd_av_1_1_A = mkA "mossklädd" ;
  motsatt_av_1_A = mkA "motsatt" ;
  multipel_av_1_A = mkA "multipel" ;
  multisjuk_av_1_A = mkA "multisjuk" ;
  munter_av_1_A = mkA "munter" ;
  mustaschprydd_av_1_A = mkA "mustaschprydd" ;
  mysticistisk_av_1_A = mkA "mysticistisk" ;
  maett_av_1_1_A = mkA "mätt" ;
  maanadslaang_av_1_1_A = mkA "månadslång" ;
  maanadsvis_av_1_1_A = mkA "månadsvis" ;
  maanformig_av_1_1_A = mkA "månformig" ;
  maangdubbel_av_1_1_A = mkA "mångdubbel" ;
  maangtusenaarig_av_1_1_A = mkA "mångtusenårig" ;
  maangaarig_av_1_1_A = mkA "mångårig" ;
  maattsydd_av_1_1_A = mkA "måttsydd" ;
  moerkklaedd_av_1_1_A = mkA "mörkklädd" ;
  moerkroed_av_1_1_A = mkA "mörkröd" ;
  narcissistisk_av_1_A = mkA "narcissistisk" ;
  nedbrytbar_av_1_A = mkA "nedbrytbar" ;
  nedsatt_av_1_A = mkA "nedsatt" ;
  negativistisk_av_1_A = mkA "negativistisk" ;
  negligeabel_av_1_A = mkA "negligeabel" ;
  negligibel_av_1_A = mkA "negligibel" ;
  nekrofil_av_1_A = mkA "nekrofil" ;
  neoimpressionistisk_av_1_A = mkA "neoimpressionistisk" ;
  neoklassicistisk_av_1_A = mkA "neoklassicistisk" ;
  nersatt_av_1_A = mkA "nersatt" ;
  niofaldig_av_1_A = mkA "niofaldig" ;
  nioaarig_av_1_1_A = mkA "nioårig" ;
  nittiotalistisk_av_1_A = mkA "nittiotalistisk" ;
  nittonaarig_av_1_1_A = mkA "nittonårig" ;
  nobel_av_1_A = mkA "nobel" ;
  nolldimensionell_av_1_A = mkA "nolldimensionell" ;
  nonkonformistisk_av_1_A = mkA "nonkonformistisk" ;
  nordistisk_av_1_A = mkA "nordistisk" ;
  normalblyg_av_1_A = mkA "normalblyg" ;
  normalstor_av_1_A = mkA "normalstor" ;
  notabel_av_1_A = mkA "notabel" ;
  notsaeker_av_1_1_A = mkA "notsäker" ;
  nyandlig_av_1_A = mkA "nyandlig" ;
  nyenkel_av_1_A = mkA "nyenkel" ;
  nyfascistisk_av_1_A = mkA "nyfascistisk" ;
  nyfoedd_av_1_1_A = mkA "nyfödd" ;
  nyinredd_av_1_A = mkA "nyinredd" ;
  nykolonialistisk_av_1_A = mkA "nykolonialistisk" ;
  nykter_av_1_A = mkA "nykter" ;
  nykteristisk_av_1_A = mkA "nykteristisk" ;
  nyliberalistisk_av_1_A = mkA "nyliberalistisk" ;
  nynazistisk_av_1_A = mkA "nynazistisk" ;
  nyplatonistisk_av_1_A = mkA "nyplatonistisk" ;
  nyrealistisk_av_1_A = mkA "nyrealistisk" ;
  nyromantisk_av_1_A = mkA "nyromantisk" ;
  nysaadd_av_1_1_A = mkA "nysådd" ;
  nyter_av_1_A = mkA "nyter" ;
  naeringslivspolitisk_av_1_1_A = mkA "näringslivspolitisk" ;
  naeringspolitisk_av_1_1_A = mkA "näringspolitisk" ;
  naett_av_1_1_A = mkA "nätt" ;
  noedbedd_av_1_1_A = mkA "nödbedd" ;
  noedd_av_1_1_A = mkA "nödd" ;
  oacceptabel_av_1_A = mkA "oacceptabel" ;
  oanfraett_av_1_1_A = mkA "oanfrätt" ;
  oavmaett_av_1_1_A = mkA "oavmätt" ;
  oavsedd_av_1_A = mkA "oavsedd" ;
  oavstoett_av_1_1_A = mkA "oavstött" ;
  obebodd_av_1_A = mkA "obebodd" ;
  obedd_av_1_A = mkA "obedd" ;
  obemoett_av_1_1_A = mkA "obemött" ;
  oberedd_av_1_A = mkA "oberedd" ;
  obesatt_av_1_A = mkA "obesatt" ;
  obesedd_av_1_A = mkA "obesedd" ;
  obestridd_av_1_A = mkA "obestridd" ;
  objektivistisk_av_1_A = mkA "objektivistisk" ;
  oblid_av_1_A = mkA "oblid" ;
  obloett_av_1_1_A = mkA "oblött" ;
  obskurantistisk_av_1_A = mkA "obskurantistisk" ;
  obytt_av_1_A = mkA "obytt" ;
  ockultistisk_av_1_A = mkA "ockultistisk" ;
  odiskutabel_av_1_A = mkA "odiskutabel" ;
  odisputabel_av_1_A = mkA "odisputabel" ;
  offentligraettslig_av_1_1_A = mkA "offentligrättslig" ;
  ofraett_av_1_1_A = mkA "ofrätt" ;
  ofoedd_av_1_1_A = mkA "ofödd" ;
  ofoerberedd_av_1_1_A = mkA "oförberedd" ;
  ofoerbytt_av_1_1_A = mkA "oförbytt" ;
  ofoergaenglig_av_1_1_A = mkA "oförgänglig" ;
  ofoernoett_av_1_1_A = mkA "oförnött" ;
  ofoerutsedd_av_1_1_A = mkA "oförutsedd" ;
  ofoerutspaadd_av_1_1_A = mkA "oförutspådd" ;
  oinredd_av_1_A = mkA "oinredd" ;
  oklaedd_av_1_1_A = mkA "oklädd" ;
  olycksdiger_av_1_A = mkA "olycksdiger" ;
  ombytt_av_1_A = mkA "ombytt" ;
  omljudd_av_1_A = mkA "omljudd" ;
  omstridd_av_1_A = mkA "omstridd" ;
  omstaellningsbar_av_1_1_A = mkA "omställningsbar" ;
  omaett_av_1_1_A = mkA "omätt" ;
  omoett_av_1_1_A = mkA "omött" ;
  onykter_av_1_A = mkA "onykter" ;
  onoett_av_1_1_A = mkA "onött" ;
  oombedd_av_1_A = mkA "oombedd" ;
  oomljudd_av_1_A = mkA "oomljudd" ;
  oomskoett_av_1_1_A = mkA "oomskött" ;
  oomstridd_av_1_A = mkA "oomstridd" ;
  opatriotisk_av_1_A = mkA "opatriotisk" ;
  operabel_av_1_A = mkA "operabel" ;
  operationalistisk_av_1_A = mkA "operationalistisk" ;
  oppklaedd_av_1_1_A = mkA "oppklädd" ;
  oppraett_av_1_1_A = mkA "opprätt" ;
  orangegul_av_1_A = mkA "orangegul" ;
  ordraett_av_1_1_A = mkA "ordrätt" ;
  orfistisk_av_1_A = mkA "orfistisk" ;
  orientalistisk_av_1_A = mkA "orientalistisk" ;
  ortopedisk_av_1_A = mkA "ortopedisk" ;
  oraett_av_1_1_A = mkA "orätt" ;
  osammanstoett_av_1_1_A = mkA "osammanstött" ;
  osedd_av_1_A = mkA "osedd" ;
  oskadd_av_1_A = mkA "oskadd" ;
  osaeker_av_1_1_A = mkA "osäker" ;
  ouppraeknelig_av_1_1_A = mkA "ouppräknelig" ;
  outspaedd_av_1_1_A = mkA "outspädd" ;
  oxblodsroed_av_1_1_A = mkA "oxblodsröd" ;
  ooeverbryggbar_av_1_1_A = mkA "oöverbryggbar" ;
  paljettbestroedd_av_1_1_A = mkA "paljettbeströdd" ;
  pandemisk_av_1_A = mkA "pandemisk" ;
  papistisk_av_1_A = mkA "papistisk" ;
  parallellistisk_av_1_A = mkA "parallellistisk" ;
  parlamentaristisk_av_1_A = mkA "parlamentaristisk" ;
  partikularistisk_av_1_A = mkA "partikularistisk" ;
  passabel_av_1_A = mkA "passabel" ;
  patriotistisk_av_1_A = mkA "patriotistisk" ;
  pedofil_av_1_A = mkA "pedofil" ;
  penibel_av_1_A = mkA "penibel" ;
  pennalistisk_av_1_A = mkA "pennalistisk" ;
  penningpolitisk_av_1_A = mkA "penningpolitisk" ;
  pepitarutig_av_1_A = mkA "pepitarutig" ;
  perfektionistisk_av_1_A = mkA "perfektionistisk" ;
  permeabel_av_1_A = mkA "permeabel" ;
  personalistisk_av_1_A = mkA "personalistisk" ;
  personalpolitisk_av_1_A = mkA "personalpolitisk" ;
  petsaeker_av_1_1_A = mkA "petsäker" ;
  pietistisk_av_1_A = mkA "pietistisk" ;
  piezoelektrisk_av_1_A = mkA "piezoelektrisk" ;
  pimpinett_av_1_A = mkA "pimpinett" ;
  pionroed_av_1_1_A = mkA "pionröd" ;
  platt_av_1_A = mkA "platt" ;
  plausibel_av_1_A = mkA "plausibel" ;
  plyschklaedd_av_1_1_A = mkA "plyschklädd" ;
  pointillistisk_av_1_A = mkA "pointillistisk" ;
  polyglott_av_1_A = mkA "polyglott" ;
  polyteistisk_av_1_A = mkA "polyteistisk" ;
  ponderabel_av_1_A = mkA "ponderabel" ;
  populaerkulturell_av_1_1_A = mkA "populärkulturell" ;
  portabel_av_1_A = mkA "portabel" ;
  postmodern_av_1_A = mkA "postmodern" ;
  postmodernistisk_av_1_A = mkA "postmodernistisk" ;
  postoperativ_av_1_A = mkA "postoperativ" ;
  posttraumatisk_av_1_A = mkA "posttraumatisk" ;
  postum_av_1_A = mkA "postum" ;
  praktikabel_av_1_A = mkA "praktikabel" ;
  pratglad_av_1_A = mkA "pratglad" ;
  premenstruell_av_1_A = mkA "premenstruell" ;
  presentabel_av_1_A = mkA "presentabel" ;
  pressansvarig_av_1_A = mkA "pressansvarig" ;
  pressetisk_av_1_A = mkA "pressetisk" ;
  pricksaeker_av_1_1_A = mkA "pricksäker" ;
  privatraettslig_av_1_1_A = mkA "privaträttslig" ;
  proamerikansk_av_1_A = mkA "proamerikansk" ;
  probabel_av_1_A = mkA "probabel" ;
  propalestinsk_av_1_A = mkA "propalestinsk" ;
  proper_av_1_A = mkA "proper" ;
  proppmaett_av_1_1_A = mkA "proppmätt" ;
  prospektiv_av_1_A = mkA "prospektiv" ;
  provinsialistisk_av_1_A = mkA "provinsialistisk" ;
  pryd_av_1_A = mkA "pryd" ;
  psykotropisk_av_1_A = mkA "psykotropisk" ;
  ptolemeisk_av_1_A = mkA "ptolemeisk" ;
  puertoricansk_av_1_A = mkA "puertoricansk" ;
  pugilistisk_av_1_A = mkA "pugilistisk" ;
  puristisk_av_1_A = mkA "puristisk" ;
  puritanistisk_av_1_A = mkA "puritanistisk" ;
  purpurroed_av_1_1_A = mkA "purpurröd" ;
  putt_av_1_A = mkA "putt" ;
  pyrofil_av_1_A = mkA "pyrofil" ;
  pyrofor_av_1_A = mkA "pyrofor" ;
  pyroklastisk_av_1_A = mkA "pyroklastisk" ;
  paelsteknisk_av_1_1_A = mkA "pälsteknisk" ;
  paaklaedd_av_1_1_A = mkA "påklädd" ;
  paaver_av_1_1_A = mkA "påver" ;
  randsydd_av_1_A = mkA "randsydd" ;
  rationalistisk_av_1_A = mkA "rationalistisk" ;
  rattfull_av_1_A = mkA "rattfull" ;
  realpolitisk_av_1_A = mkA "realpolitisk" ;
  reformistisk_av_1_A = mkA "reformistisk" ;
  regelraett_av_1_1_A = mkA "regelrätt" ;
  regionalistisk_av_1_A = mkA "regionalistisk" ;
  regionalpolitisk_av_1_A = mkA "regionalpolitisk" ;
  regionpolitisk_av_1_A = mkA "regionpolitisk" ;
  regionspolitisk_av_1_A = mkA "regionspolitisk" ;
  rekommendabel_av_1_A = mkA "rekommendabel" ;
  rekordklantig_av_1_A = mkA "rekordklantig" ;
  rekordlaag_av_1_1_A = mkA "rekordlåg" ;
  rekordlaang_av_1_1_A = mkA "rekordlång" ;
  rekordstor_av_1_A = mkA "rekordstor" ;
  rekreationspolitisk_av_1_A = mkA "rekreationspolitisk" ;
  rektal_av_1_A = mkA "rektal" ;
  reliabel_av_1_A = mkA "reliabel" ;
  remarkabel_av_1_A = mkA "remarkabel" ;
  rensbar_av_1_A = mkA "rensbar" ;
  reparabel_av_1_A = mkA "reparabel" ;
  reproduktiv_av_1_A = mkA "reproduktiv" ;
  resonabel_av_1_A = mkA "resonabel" ;
  respektabel_av_1_A = mkA "respektabel" ;
  retrofuturistisk_av_1_A = mkA "retrofuturistisk" ;
  revanschistisk_av_1_A = mkA "revanschistisk" ;
  reversibel_av_1_A = mkA "reversibel" ;
  revisionistisk_av_1_A = mkA "revisionistisk" ;
  rikspolitisk_av_1_A = mkA "rikspolitisk" ;
  ringprydd_av_1_A = mkA "ringprydd" ;
  riskabel_av_1_A = mkA "riskabel" ;
  ritualistisk_av_1_A = mkA "ritualistisk" ;
  roderloes_av_1_1_A = mkA "roderlös" ;
  rosenaktig_av_1_A = mkA "rosenaktig" ;
  rosenroed_av_1_1_A = mkA "rosenröd" ;
  rosettprydd_av_1_A = mkA "rosettprydd" ;
  rostroed_av_1_1_A = mkA "roströd" ;
  roterbar_av_1_A = mkA "roterbar" ;
  rubinroed_av_1_1_A = mkA "rubinröd" ;
  rundnaett_av_1_1_A = mkA "rundnätt" ;
  rymningssaeker_av_1_1_A = mkA "rymningssäker" ;
  ryskspraakig_av_1_1_A = mkA "ryskspråkig" ;
  raentabel_av_1_1_A = mkA "räntabel" ;
  raett_av_1_1_A = mkA "rätt" ;
  raettspolitisk_av_1_1_A = mkA "rättspolitisk" ;
  roed_av_1_1_A = mkA "röd" "rött" ;
  roedgul_av_1_1_A = mkA "rödgul" ;
  roedlaett_av_1_1_A = mkA "rödlätt" ;
  roedprickig_av_1_1_A = mkA "rödprickig" ;
  roedrandig_av_1_1_A = mkA "rödrandig" ;
  samhaellspolitisk_av_1_1_A = mkA "samhällspolitisk" ;
  sammansatt_av_1_A = mkA "sammansatt" ;
  sannspaadd_av_1_1_A = mkA "sannspådd" ;
  satanistisk_av_1_A = mkA "satanistisk" ;
  satt_av_1_A = mkA "satt" ;
  schamanistisk_av_1_A = mkA "schamanistisk" ;
  scharlakansroed_av_1_1_A = mkA "scharlakansröd" ;
  segelduksklaedd_av_1_1_A = mkA "segelduksklädd" ;
  sekelskiftesintellektuell_av_1_A = mkA "sekelskiftesintellektuell" ;
  sekretesslovlig_av_1_A = mkA "sekretesslovlig" ;
  sekventiell_av_1_A = mkA "sekventiell" ;
  semiautomatisk_av_1_A = mkA "semiautomatisk" ;
  semipermeabel_av_1_A = mkA "semipermeabel" ;
  senapsgul_av_1_A = mkA "senapsgul" ;
  senfoedd_av_1_1_A = mkA "senfödd" ;
  senneolitisk_av_1_A = mkA "senneolitisk" ;
  sensibel_av_1_A = mkA "sensibel" ;
  sensualistisk_av_1_A = mkA "sensualistisk" ;
  separabel_av_1_A = mkA "separabel" ;
  sexfaldig_av_1_A = mkA "sexfaldig" ;
  sexistisk_av_1_A = mkA "sexistisk" ;
  sextonaarig_av_1_1_A = mkA "sextonårig" ;
  sexaarig_av_1_1_A = mkA "sexårig" ;
  shiamuslimsk_av_1_A = mkA "shiamuslimsk" ;
  shiitisk_av_1_A = mkA "shiitisk" ;
  shintoistisk_av_1_A = mkA "shintoistisk" ;
  sid_av_1_A = mkA "sid" ;
  simpel_av_1_A = mkA "simpel" ;
  sinister_av_1_A = mkA "sinister" ;
  sionistisk_av_1_A = mkA "sionistisk" ;
  sjangdobel_av_1_A = mkA "sjangdobel" ;
  sjufaldig_av_1_A = mkA "sjufaldig" ;
  sjukvaardspolitisk_av_1_1_A = mkA "sjukvårdspolitisk" ;
  sjuttonaarig_av_1_1_A = mkA "sjuttonårig" ;
  sjuaarig_av_1_1_A = mkA "sjuårig" ;
  sjaelaglad_av_1_1_A = mkA "själaglad" ;
  sjaelsstark_av_1_1_A = mkA "själsstark" ;
  sjaelvgod_av_1_1_A = mkA "självgod" ;
  sjaelvsaeker_av_1_1_A = mkA "självsäker" ;
  sjoefartspolitisk_av_1_1_A = mkA "sjöfartspolitisk" ;
  sjoehistorisk_av_1_1_A = mkA "sjöhistorisk" ;
  sjoesaeker_av_1_1_A = mkA "sjösäker" ;
  skadeglad_av_1_A = mkA "skadeglad" ;
  skadestaandsraettslig_av_1_1_A = mkA "skadeståndsrättslig" ;
  skadestaandsskyldig_av_1_1_A = mkA "skadeståndsskyldig" ;
  skandinavistisk_av_1_A = mkA "skandinavistisk" ;
  skarp_av_2_A = mkA "skarp" ;
  skatteallergisk_av_1_A = mkA "skatteallergisk" ;
  skattepolitisk_av_1_A = mkA "skattepolitisk" ;
  skendoed_av_1_1_A = mkA "skendöd" ;
  skickelsediger_av_1_A = mkA "skickelsediger" ;
  skinnflaadd_av_1_1_A = mkA "skinnflådd" ;
  skinnklaedd_av_1_1_A = mkA "skinnklädd" ;
  skitkass_av_1_A = mkA "skitkass" ;
  skittoentig_av_1_1_A = mkA "skittöntig" ;
  skjutbar_av_1_A = mkA "skjutbar" ;
  skjutglad_av_1_A = mkA "skjutglad" ;
  skogklaedd_av_1_1_A = mkA "skogklädd" ;
  skoklaedd_av_1_1_A = mkA "skoklädd" ;
  skolpolitisk_av_1_A = mkA "skolpolitisk" ;
  skoltroett_av_1_1_A = mkA "skoltrött" ;
  skottsaeker_av_1_1_A = mkA "skottsäker" ;
  skrivbar_av_1_A = mkA "skrivbar" ;
  skrivberedd_av_1_A = mkA "skrivberedd" ;
  skruvbar_av_1_A = mkA "skruvbar" ;
  skuggloes_av_1_1_A = mkA "skugglös" ;
  skuldsatt_av_1_A = mkA "skuldsatt" ;
  skaeftig_av_1_1_A = mkA "skäftig" ;
  slottslik_av_1_A = mkA "slottslik" ;
  smittbar_av_1_A = mkA "smittbar" ;
  smaecker_av_1_1_A = mkA "smäcker" ;
  smaahet_av_1_1_A = mkA "småhet" ;
  smaakornig_av_1_1_A = mkA "småkornig" ;
  smaarufsig_av_1_1_A = mkA "smårufsig" ;
  smaasur_av_1_1_A = mkA "småsur" ;
  snarfager_av_1_A = mkA "snarfager" ;
  snarvacker_av_1_A = mkA "snarvacker" ;
  sned_av_1_A = mkA "sned" ;
  snurrbar_av_1_A = mkA "snurrbar" ;
  snutfager_av_1_A = mkA "snutfager" ;
  snoeklaedd_av_1_1_A = mkA "snöklädd" ;
  sober_av_1_A = mkA "sober" ;
  socialrealistisk_av_1_A = mkA "socialrealistisk" ;
  sofistisk_av_1_A = mkA "sofistisk" ;
  solid_av_1_A = mkA "solid" ;
  solipsistisk_av_1_A = mkA "solipsistisk" ;
  sommarlovsledig_av_1_A = mkA "sommarlovsledig" ;
  sorgklaedd_av_1_1_A = mkA "sorgklädd" ;
  sotdoed_av_1_1_A = mkA "sotdöd" ;
  sovjetunderstoedd_av_1_1_A = mkA "sovjetunderstödd" ;
  spanskspraakig_av_1_1_A = mkA "spanskspråkig" ;
  spektroskopisk_av_1_A = mkA "spektroskopisk" ;
  spiksaeker_av_1_1_A = mkA "spiksäker" ;
  spindellik_av_1_A = mkA "spindellik" ;
  spindelvaevsaktig_av_1_1_A = mkA "spindelvävsaktig" ;
  spiritistisk_av_1_A = mkA "spiritistisk" ;
  spiritualistisk_av_1_A = mkA "spiritualistisk" ;
  spontanistisk_av_1_A = mkA "spontanistisk" ;
  spridd_av_1_A = mkA "spridd" ;
  sproed_av_1_1_A = mkA "spröd" ;
  spaed_av_1_1_A = mkA "späd" ;
  spaanklaedd_av_1_1_A = mkA "spånklädd" ;
  spaarfoersedd_av_1_1_A = mkA "spårförsedd" ;
  startberedd_av_1_A = mkA "startberedd" ;
  statsraettslig_av_1_1_A = mkA "statsrättslig" ;
  stavformig_av_1_A = mkA "stavformig" ;
  stegvis_av_1_A = mkA "stegvis" ;
  stendoed_av_1_1_A = mkA "stendöd" ;
  stensatt_av_1_A = mkA "stensatt" ;
  stentuff_av_1_A = mkA "stentuff" ;
  stjaernbestroedd_av_1_1_A = mkA "stjärnbeströdd" ;
  stoicistisk_av_1_A = mkA "stoicistisk" ;
  stormsaeker_av_1_1_A = mkA "stormsäker" ;
  storrutig_av_1_A = mkA "storrutig" ;
  straffraettslig_av_1_1_A = mkA "straffrättslig" ;
  strid_av_1_A = mkA "strid" ;
  strukturalistisk_av_1_A = mkA "strukturalistisk" ;
  strumpklaedd_av_1_1_A = mkA "strumpklädd" ;
  strutfoersedd_av_1_1_A = mkA "strutförsedd" ;
  straalningssaeker_av_1_1_A = mkA "strålningssäker" ;
  stroemloes_av_1_1_A = mkA "strömlös" ;
  studieovan_av_1_A = mkA "studieovan" ;
  studiesocial_av_1_A = mkA "studiesocial" ;
  stundvis_av_1_A = mkA "stundvis" ;
  staellbar_av_1_1_A = mkA "ställbar" ;
  stoeldsaeker_av_1_1_A = mkA "stöldsäker" ;
  stoett_av_1_1_A = mkA "stött" ;
  stoetvis_av_1_1_A = mkA "stötvis" ;
  subjektivistisk_av_1_A = mkA "subjektivistisk" ;
  suggestibel_av_1_A = mkA "suggestibel" ;
  suicidpreventiv_av_1_A = mkA "suicidpreventiv" ;
  sunnimuslimsk_av_1_A = mkA "sunnimuslimsk" ;
  sunnitisk_av_1_A = mkA "sunnitisk" ;
  superelastisk_av_1_A = mkA "superelastisk" ;
  superglad_av_1_A = mkA "superglad" ;
  superlaett_av_1_1_A = mkA "superlätt" ;
  superlaag_av_1_1_A = mkA "superlåg" ;
  supermassiv_av_1_A = mkA "supermassiv" ;
  supersmaskig_av_1_A = mkA "supersmaskig" ;
  superviktig_av_1_A = mkA "superviktig" ;
  supranaturalistisk_av_1_A = mkA "supranaturalistisk" ;
  suprematistisk_av_1_A = mkA "suprematistisk" ;
  svackig_av_1_A = mkA "svackig" ;
  svartklaedd_av_1_1_A = mkA "svartklädd" ;
  svavelgul_av_1_A = mkA "svavelgul" ;
  svensk_engelsk_av_1_A = mkA "svensk-engelsk" ;
  svensk_tysk_av_1_A = mkA "svensk-tysk" ;
  svenskfoedd_av_1_1_A = mkA "svenskfödd" ;
  svenskledd_av_1_A = mkA "svenskledd" ;
  svenskspraakig_av_1_1_A = mkA "svenskspråkig" ;
  svenskstoedd_av_1_1_A = mkA "svenskstödd" ;
  svett_av_1_A = mkA "svett" ;
  svettfuktig_av_1_A = mkA "svettfuktig" ;
  svaeltfoedd_av_1_1_A = mkA "svältfödd" ;
  svaardefinierbar_av_1_1_A = mkA "svårdefinierbar" ;
  svaarfoerenlig_av_1_1_A = mkA "svårförenlig" ;
  svaartydd_av_1_1_A = mkA "svårtydd" ;
  syllogistisk_av_1_A = mkA "syllogistisk" ;
  sylvass_av_1_A = mkA "sylvass" ;
  symbolistisk_av_1_A = mkA "symbolistisk" ;
  syndikalistisk_av_1_A = mkA "syndikalistisk" ;
  synergistisk_av_1_A = mkA "synergistisk" ;
  synkretistisk_av_1_A = mkA "synkretistisk" ;
  sysselsatt_av_1_A = mkA "sysselsatt" ;
  sysselsaettningspolitisk_av_1_1_A = mkA "sysselsättningspolitisk" ;
  saeker_av_1_1_A = mkA "säker" ;
  saekerhetspolitisk_av_1_1_A = mkA "säkerhetspolitisk" ;
  soekbar_av_1_1_A = mkA "sökbar" ;
  tafatt_av_1_A = mkA "tafatt" ;
  taggfoersedd_av_1_1_A = mkA "taggförsedd" ;
  tamilsk_av_1_A = mkA "tamilsk" ;
  tankediger_av_1_A = mkA "tankediger" ;
  tankspridd_av_1_A = mkA "tankspridd" ;
  taoistisk_av_1_A = mkA "taoistisk" ;
  tapper_av_1_A = mkA "tapper" ;
  taxonomisk_av_1_A = mkA "taxonomisk" ;
  tegelroed_av_1_1_A = mkA "tegelröd" ;
  teistisk_av_1_A = mkA "teistisk" ;
  temporal_av_1_A = mkA "temporal" ;
  terrester_av_1_A = mkA "terrester" ;
  terroristisk_av_1_A = mkA "terroristisk" ;
  testabel_av_1_A = mkA "testabel" ;
  teutonisk_av_1_A = mkA "teutonisk" ;
  tidigneolitisk_av_1_A = mkA "tidigneolitisk" ;
  tidsasymmetrisk_av_1_A = mkA "tidsasymmetrisk" ;
  tidssymmetrisk_av_1_A = mkA "tidssymmetrisk" ;
  tillbakasatt_av_1_A = mkA "tillbakasatt" ;
  tillvaextstark_av_1_1_A = mkA "tillväxtstark" ;
  timvis_av_1_A = mkA "timvis" ;
  tiodubbel_av_1_A = mkA "tiodubbel" ;
  tiogradig_av_1_A = mkA "tiogradig" ;
  tioaarig_av_1_1_A = mkA "tioårig" ;
  tjugoettaarig_av_1_1_A = mkA "tjugoettårig" ;
  tjugofaldig_av_1_A = mkA "tjugofaldig" ;
  tjugofemaarig_av_1_1_A = mkA "tjugofemårig" ;
  tjugofyraaarig_av_1_1_A = mkA "tjugofyraårig" ;
  tjugotreaarig_av_1_1_A = mkA "tjugotreårig" ;
  tjugotvaaaarig_av_1_1_A = mkA "tjugotvåårig" ;
  tjugoaarig_av_1_1_A = mkA "tjugoårig" ;
  tjugufemaarig_av_1_1_A = mkA "tjugufemårig" ;
  tjuguaarig_av_1_1_A = mkA "tjuguårig" ;
  tolerabel_av_1_A = mkA "tolerabel" ;
  tolvfaldig_av_1_A = mkA "tolvfaldig" ;
  tolvaarig_av_1_1_A = mkA "tolvårig" ;
  tonsaeker_av_1_1_A = mkA "tonsäker" ;
  tonaarig_av_1_1_A = mkA "tonårig" ;
  torrskodd_av_1_A = mkA "torrskodd" ;
  totalitaristisk_av_1_A = mkA "totalitaristisk" ;
  totemistisk_av_1_A = mkA "totemistisk" ;
  traditionalistisk_av_1_A = mkA "traditionalistisk" ;
  trafikabel_av_1_A = mkA "trafikabel" ;
  trafikpolitisk_av_1_A = mkA "trafikpolitisk" ;
  trafiksaeker_av_1_1_A = mkA "trafiksäker" ;
  transnationell_av_1_A = mkA "transnationell" ;
  transportabel_av_1_A = mkA "transportabel" ;
  transsylvansk_av_1_A = mkA "transsylvansk" ;
  tredubbel_av_1_A = mkA "tredubbel" ;
  trenchcoatklaedd_av_1_1_A = mkA "trenchcoatklädd" ;
  trettioaarig_av_1_1_A = mkA "trettioårig" ;
  trettiaarig_av_1_1_A = mkA "trettiårig" ;
  trettonaarig_av_1_1_A = mkA "trettonårig" ;
  treaarig_av_1_1_A = mkA "treårig" ;
  tribalistisk_av_1_A = mkA "tribalistisk" ;
  trippel_av_1_A = mkA "trippel" ;
  tropistisk_av_1_A = mkA "tropistisk" ;
  trotskistisk_av_1_A = mkA "trotskistisk" ;
  trycksaeker_av_1_1_A = mkA "trycksäker" ;
  traeffsaeker_av_1_1_A = mkA "träffsäker" ;
  traadformig_av_1_1_A = mkA "trådformig" ;
  traangbodd_av_1_1_A = mkA "trångbodd" ;
  troegbedd_av_1_1_A = mkA "trögbedd" ;
  troett_av_1_1_A = mkA "trött" ;
  tungrodd_av_1_A = mkA "tungrodd" ;
  tunnklaedd_av_1_1_A = mkA "tunnklädd" ;
  tunnsaadd_av_1_1_A = mkA "tunnsådd" ;
  turbanklaedd_av_1_1_A = mkA "turbanklädd" ;
  turvis_av_1_A = mkA "turvis" ;
  tusenaarig_av_1_1_A = mkA "tusenårig" ;
  tvillinglik_av_1_A = mkA "tvillinglik" ;
  tvaermaett_av_1_1_A = mkA "tvärmätt" ;
  tvaersaeker_av_1_1_A = mkA "tvärsäker" ;
  tvaafaldig_av_1_1_A = mkA "tvåfaldig" ;
  tvaahjulig_av_1_1_A = mkA "tvåhjulig" ;
  tvaalfager_av_1_1_A = mkA "tvålfager" ;
  tvaastjaernig_av_1_1_A = mkA "tvåstjärnig" ;
  tvaaaarig_av_1_1_A = mkA "tvåårig" ;
  typografisk_av_1_A = mkA "typografisk" ;
  typologisk_av_1_A = mkA "typologisk" ;
  tysk_romersk_av_1_A = mkA "tysk-romersk" ;
  tysk_schweizisk_av_1_A = mkA "tysk-schweizisk" ;
  tysk_svensk_av_1_A = mkA "tysk-svensk" ;
  tyskspraakig_av_1_1_A = mkA "tyskspråkig" ;
  toernbestroedd_av_1_1_A = mkA "törnbeströdd" ;
  ultraroed_av_1_1_A = mkA "ultraröd" ;
  ultraviolett_av_1_A = mkA "ultraviolett" ;
  underfoerstaadd_av_1_1_A = mkA "underförstådd" ;
  undersysselsatt_av_1_A = mkA "undersysselsatt" ;
  underaarig_av_1_1_A = mkA "underårig" ;
  ungdomspolitisk_av_1_A = mkA "ungdomspolitisk" ;
  ungsocialistisk_av_1_A = mkA "ungsocialistisk" ;
  uniformsklaedd_av_1_1_A = mkA "uniformsklädd" ;
  unitariansk_av_1_A = mkA "unitariansk" ;
  unitaristisk_av_1_A = mkA "unitaristisk" ;
  uppbloett_av_1_1_A = mkA "uppblött" ;
  uppdragsarkeologisk_av_1_A = mkA "uppdragsarkeologisk" ;
  uppklaedd_av_1_1_A = mkA "uppklädd" ;
  uppraett_av_1_1_A = mkA "upprätt" ;
  uppsatt_av_1_A = mkA "uppsatt" ;
  urusel_av_1_A = mkA "urusel" ;
  utbildningspolitisk_av_1_A = mkA "utbildningspolitisk" ;
  utbredd_av_1_A = mkA "utbredd" ;
  utdoed_av_1_1_A = mkA "utdöd" ;
  utklaedd_av_1_1_A = mkA "utklädd" ;
  utled_av_1_A = mkA "utled" ;
  utnoett_av_1_1_A = mkA "utnött" ;
  utomkroppslig_av_1_A = mkA "utomkroppslig" ;
  utommaensklig_av_1_1_A = mkA "utommänsklig" ;
  utredningsteknisk_av_1_A = mkA "utredningsteknisk" ;
  utsatt_av_1_A = mkA "utsatt" ;
  utspridd_av_1_A = mkA "utspridd" ;
  utspaedd_av_1_1_A = mkA "utspädd" ;
  utstoett_av_1_1_A = mkA "utstött" ;
  uttagbar_av_1_A = mkA "uttagbar" ;
  uttryckbar_av_1_A = mkA "uttryckbar" ;
  vacker_av_1_A = mkA "vacker" ;
  valutapolitisk_av_1_A = mkA "valutapolitisk" ;
  variabel_av_1_A = mkA "variabel" ;
  veckolaang_av_1_1_A = mkA "veckolång" ;
  veckovis_av_1_A = mkA "veckovis" ;
  venerabel_av_1_A = mkA "venerabel" ;
  veristisk_av_1_A = mkA "veristisk" ;
  veritabel_av_1_A = mkA "veritabel" ;
  vid_av_1_A = mkA "vid" ;
  vimpelprydd_av_1_A = mkA "vimpelprydd" ;
  vinroed_av_1_1_A = mkA "vinröd" ;
  violett_av_1_A = mkA "violett" ;
  visibel_av_1_A = mkA "visibel" ;
  vitalistisk_av_1_A = mkA "vitalistisk" ;
  vitklaedd_av_1_1_A = mkA "vitklädd" ;
  vitskaeggig_av_1_1_A = mkA "vitskäggig" ;
  vitter_av_1_A = mkA "vitter" ;
  voluntaristisk_av_1_A = mkA "voluntaristisk" ;
  vraalflott_av_1_1_A = mkA "vrålflott" ;
  vaelbesatt_av_1_1_A = mkA "välbesatt" ;
  vaelfaerdspolitisk_av_1_1_A = mkA "välfärdspolitisk" ;
  vaelfoedd_av_1_1_A = mkA "välfödd" ;
  vaelfoersedd_av_1_1_A = mkA "välförsedd" ;
  vaelfoerstaadd_av_1_1_A = mkA "välförstådd" ;
  vaelgoedd_av_1_1_A = mkA "välgödd" ;
  vaelklaedd_av_1_1_A = mkA "välklädd" ;
  vaelsedd_av_1_1_A = mkA "välsedd" ;
  vaelskoett_av_1_1_A = mkA "välskött" ;
  vaendsydd_av_1_1_A = mkA "vändsydd" ;
  vaensterintellektuell_av_1_1_A = mkA "vänsterintellektuell" ;
  vaensteroppositionell_av_1_1_A = mkA "vänsteroppositionell" ;
  vaensterpolitisk_av_1_1_A = mkA "vänsterpolitisk" ;
  vaenstersocialistisk_av_1_1_A = mkA "vänstersocialistisk" ;
  vaerdenihilistisk_av_1_1_A = mkA "värdenihilistisk" ;
  vaerdesaeker_av_1_1_A = mkA "värdesäker" ;
  vaerldspolitisk_av_1_1_A = mkA "världspolitisk" ;
  vaaldsutsatt_av_1_1_A = mkA "våldsutsatt" ;
  vaarfin_av_1_1_A = mkA "vårfin" ;
  vaarfraesch_av_1_1_A = mkA "vårfräsch" ;
  vaartroett_av_1_1_A = mkA "vårtrött" ;
  vaatblank_av_1_1_A = mkA "våtblank" ;
  vaatstrimmig_av_1_1_A = mkA "våtstrimmig" ;
  wienklassicistisk_av_1_A = mkA "wienklassicistisk" ;
  yster_av_1_A = mkA "yster" ;
  aemabel_av_1_1_A = mkA "ämabel" ;
  aarslaang_av_1_1_A = mkA "årslång" ;
  aarsvis_av_1_1_A = mkA "årsvis" ;
  aaskdiger_av_1_1_A = mkA "åskdiger" ;
  aasklik_av_1_1_A = mkA "åsklik" ;
  aatalbar_av_1_1_A = mkA "åtalbar" ;
  aaterfoerslutningsbar_av_1_1_A = mkA "återförslutningsbar" ;
  aattafaldig_av_1_1_A = mkA "åttafaldig" ;
  aattaaarig_av_1_1_A = mkA "åttaårig" ;
  aattioprocentig_av_1_1_A = mkA "åttioprocentig" ;
  aattiotalistisk_av_1_1_A = mkA "åttiotalistisk" ;
  aattkantig_av_1_1_A = mkA "åttkantig" ;
  oedesdiger_av_1_1_A = mkA "ödesdiger" ;
  oeverfoerbar_av_1_1_A = mkA "överförbar" ;
  oevergaangsvis_av_1_1_A = mkA "övergångsvis" ;
  oevermaett_av_1_1_A = mkA "övermätt" ;
  oeveroptimistisk_av_1_1_A = mkA "överoptimistisk" ;
  oeverskoeljningssaeker_av_1_1_A = mkA "översköljningssäker" ;
  oeverstroedd_av_1_1_A = mkA "överströdd" ;
  Celsius_ab_1_Adv = mkAdv "Celsius" ;
  absolut_ab_1_Adv = mkAdv "absolut" ;
  ackurat_ab_1_Adv = mkAdv "ackurat" ;
  adagio_ab_1_Adv = mkAdv "adagio" ;
  akter_ab_1_Adv = mkAdv "akter" ;
  akterst_ab_1_Adv = mkAdv "akterst" ;
  akterut_ab_1_Adv = mkAdv "akterut" ;
  akteroever_ab_1_1_Adv = mkAdv "akteröver" ;
  akut_ab_1_Adv = mkAdv "akut" ;
  aldrig_ab_1_Adv = mkAdv "aldrig" ;
  alfresko_ab_1_Adv = mkAdv "alfresko" ;
  alias_ab_1_Adv = mkAdv "alias" ;
  allaredan_ab_1_Adv = mkAdv "allaredan" ;
  alldeles_ab_1_Adv = mkAdv "alldeles" ;
  allegretto_ab_1_Adv = mkAdv "allegretto" ;
  allegro_ab_1_Adv = mkAdv "allegro" ;
  allenast_ab_1_Adv = mkAdv "allenast" ;
  allestaedes_ab_1_1_Adv = mkAdv "allestädes" ;
  allra_ab_1_Adv = mkAdv "allra" ;
  alls_ab_1_Adv = mkAdv "alls" ;
  allt_ab_1_Adv = mkAdv "allt" ;
  alltemellan_ab_1_Adv = mkAdv "alltemellan" ;
  alltemellanaat_ab_1_1_Adv = mkAdv "alltemellanåt" ;
  alltfort_ab_1_Adv = mkAdv "alltfort" ;
  alltfoer_ab_1_1_Adv = mkAdv "alltför" ;
  alltid_ab_1_Adv = mkAdv "alltid" ;
  alltigenom_ab_1_Adv = mkAdv "alltigenom" ;
  alltjaemt_ab_1_1_Adv = mkAdv "alltjämt" ;
  alltmer_ab_1_Adv = mkAdv "alltmer" ;
  alltmera_ab_1_Adv = mkAdv "alltmera" ;
  alltnog_ab_1_Adv = mkAdv "alltnog" ;
  alltsomoftast_ab_1_Adv = mkAdv "alltsomoftast" ;
  alltsaa_ab_1_1_Adv = mkAdv "alltså" ;
  allvarligen_ab_1_Adv = mkAdv "allvarligen" ;
  alpari_ab_1_Adv = mkAdv "alpari" ;
  alternativt_ab_1_Adv = mkAdv "alternativt" ;
  amok_ab_1_Adv = mkAdv "amok" ;
  an_ab_1_Adv = mkAdv "an" ;
  andante_ab_1_Adv = mkAdv "andante" ;
  andligen_ab_1_Adv = mkAdv "andligen" ;
  aningen_ab_1_Adv = mkAdv "aningen" ;
  aningens_ab_1_Adv = mkAdv "aningens" ;
  annanstans_ab_1_Adv = mkAdv "annanstans" ;
  annars_ab_1_Adv = mkAdv "annars" ;
  annorledes_ab_1_Adv = mkAdv "annorledes" ;
  annorlunda_ab_1_Adv = mkAdv "annorlunda" ;
  annorstaedes_ab_1_1_Adv = mkAdv "annorstädes" ;
  anstaendigtvis_ab_1_1_Adv = mkAdv "anständigtvis" ;
  antagligen_ab_1_Adv = mkAdv "antagligen" ;
  antingen_ab_1_Adv = mkAdv "antingen" ;
  antydningsvis_ab_1_Adv = mkAdv "antydningsvis" ;
  apropaa_ab_1_1_Adv = mkAdv "apropå" ;
  arla_ab_1_Adv = mkAdv "arla" ;
  av_ab_1_Adv = mkAdv "av" ;
  avista_ab_1_Adv = mkAdv "avista" ;
  avsides_ab_1_Adv = mkAdv "avsides" ;
  avsiktligen_ab_1_Adv = mkAdv "avsiktligen" ;
  avslutningsvis_ab_1_Adv = mkAdv "avslutningsvis" ;
  ba_ab_1_Adv = mkAdv "ba" ;
  babord_ab_1_Adv = mkAdv "babord" ;
  bak_ab_1_Adv = mkAdv "bak" ;
  bakefter_ab_1_Adv = mkAdv "bakefter" ;
  bakerst_ab_1_Adv = mkAdv "bakerst" ;
  bakfram_ab_1_Adv = mkAdv "bakfram" ;
  baki_ab_1_Adv = mkAdv "baki" ;
  bakifraan_ab_1_1_Adv = mkAdv "bakifrån" ;
  baklaenges_ab_1_1_Adv = mkAdv "baklänges" ;
  bakom_ab_1_Adv = mkAdv "bakom" ;
  bakpaa_ab_1_1_Adv = mkAdv "bakpå" ;
  baktill_ab_1_Adv = mkAdv "baktill" ;
  bakut_ab_1_Adv = mkAdv "bakut" ;
  bakvid_ab_1_Adv = mkAdv "bakvid" ;
  bakaat_ab_1_1_Adv = mkAdv "bakåt" ;
  bakoever_ab_1_1_Adv = mkAdv "baköver" ;
  bara_ab_1_Adv = mkAdv "bara" ;
  behoerigen_ab_1_1_Adv = mkAdv "behörigen" ;
  beklagligen_ab_1_Adv = mkAdv "beklagligen" ;
  beklagligtvis_ab_1_Adv = mkAdv "beklagligtvis" ;
  bevisligen_ab_1_Adv = mkAdv "bevisligen" ;
  bidevind_ab_1_Adv = mkAdv "bidevind" ;
  bitterligen_ab_1_Adv = mkAdv "bitterligen" ;
  bittida_ab_1_Adv = mkAdv "bittida" ;
  bitvis_ab_1_Adv = mkAdv "bitvis" ;
  blott_ab_1_Adv = mkAdv "blott" ;
  bokstavligen_ab_1_Adv = mkAdv "bokstavligen" ;
  bordvarts_ab_1_Adv = mkAdv "bordvarts" ;
  bort_ab_1_Adv = mkAdv "bort" ;
  borta_ab_1_Adv = mkAdv "borta" ;
  bortanfoer_ab_1_1_Adv = mkAdv "bortanför" ;
  bortemot_ab_1_Adv = mkAdv "bortemot" ;
  borterst_ab_1_Adv = mkAdv "borterst" ;
  bortifraan_ab_1_1_Adv = mkAdv "bortifrån" ;
  bortigenom_ab_1_Adv = mkAdv "bortigenom" ;
  bortom_ab_1_Adv = mkAdv "bortom" ;
  bortaat_ab_1_1_Adv = mkAdv "bortåt" ;
  bortoever_ab_1_1_Adv = mkAdv "bortöver" ;
  bra_ab_1_Adv = mkAdv "bra" ;
  bredvid_ab_1_Adv = mkAdv "bredvid" ;
  brevledes_ab_1_Adv = mkAdv "brevledes" ;
  brutto_ab_1_Adv = mkAdv "brutto" ;
  braadis_ab_1_1_Adv = mkAdv "brådis" ;
  broestgaenges_ab_1_1_Adv = mkAdv "bröstgänges" ;
  bums_ab_1_Adv = mkAdv "bums" ;
  baade_ab_1_1_Adv = mkAdv "både" ;
  cash_ab_1_Adv = mkAdv "cash" ;
  cif_ab_1_Adv = mkAdv "cif" ;
  comme_il_faut_ab_1_Adv = mkAdv "comme-il-faut" ;
  crescendo_ab_1_Adv = mkAdv "crescendo" ;
  dagligdags_ab_1_Adv = mkAdv "dagligdags" ;
  dagligen_ab_1_Adv = mkAdv "dagligen" ;
  dags_ab_1_Adv = mkAdv "dags" ;
  dels_ab_1_Adv = mkAdv "dels" ;
  delvis_ab_1_Adv = mkAdv "delvis" ;
  dennes_ab_1_Adv = mkAdv "dennes" ;
  dessbaettre_ab_1_1_Adv = mkAdv "dessbättre" ;
  dessemellan_ab_1_Adv = mkAdv "dessemellan" ;
  dessfoerinnan_ab_1_1_Adv = mkAdv "dessförinnan" ;
  dessfoerutan_ab_1_1_Adv = mkAdv "dessförutan" ;
  desslikes_ab_1_Adv = mkAdv "desslikes" ;
  dessutom_ab_1_Adv = mkAdv "dessutom" ;
  dessvaerre_ab_1_1_Adv = mkAdv "dessvärre" ;
  desto_ab_1_Adv = mkAdv "desto" ;
  deuce_ab_1_Adv = mkAdv "deuce" ;
  dikt_ab_1_Adv = mkAdv "dikt" ;
  diminuendo_ab_1_Adv = mkAdv "diminuendo" ;
  direkt_ab_1_Adv = mkAdv "direkt" ;
  dit_ab_1_Adv = mkAdv "dit" ;
  dithaen_ab_1_1_Adv = mkAdv "dithän" ;
  ditin_ab_1_Adv = mkAdv "ditin" ;
  ditintills_ab_1_Adv = mkAdv "ditintills" ;
  dittills_ab_1_Adv = mkAdv "dittills" ;
  ditut_ab_1_Adv = mkAdv "ditut" ;
  ditaat_ab_1_1_Adv = mkAdv "ditåt" ;
  djaevligt_ab_1_1_Adv = mkAdv "djävligt" ;
  dock_ab_1_Adv = mkAdv "dock" ;
  droppstilla_ab_1_Adv = mkAdv "droppstilla" ;
  droppvis_ab_1_Adv = mkAdv "droppvis" ;
  dussinvis_ab_1_Adv = mkAdv "dussinvis" ;
  dygnsvis_ab_1_Adv = mkAdv "dygnsvis" ;
  dymedels_ab_1_Adv = mkAdv "dymedels" ;
  dymedelst_ab_1_Adv = mkAdv "dymedelst" ;
  daedan_ab_1_1_Adv = mkAdv "dädan" ;
  daen_ab_1_1_Adv = mkAdv "dän" ;
  daer_ab_1_1_Adv = mkAdv "där" ;
  daerav_ab_1_1_Adv = mkAdv "därav" ;
  daerbakom_ab_1_1_Adv = mkAdv "därbakom" ;
  daerborta_ab_1_1_Adv = mkAdv "därborta" ;
  daerbortom_ab_1_1_Adv = mkAdv "därbortom" ;
  daerefter_ab_1_1_Adv = mkAdv "därefter" ;
  daeremellan_ab_1_1_Adv = mkAdv "däremellan" ;
  daeremot_ab_1_1_Adv = mkAdv "däremot" ;
  daerframme_ab_1_1_Adv = mkAdv "därframme" ;
  daerfoer_ab_1_1_Adv = mkAdv "därför" ;
  daerfoere_ab_1_1_Adv = mkAdv "därföre" ;
  daerfoerinnan_ab_1_1_Adv = mkAdv "därförinnan" ;
  daerfoerutan_ab_1_1_Adv = mkAdv "därförutan" ;
  daerhemma_ab_1_1_Adv = mkAdv "därhemma" ;
  daerhaen_ab_1_1_Adv = mkAdv "därhän" ;
  daeri_ab_1_1_Adv = mkAdv "däri" ;
  daeribland_ab_1_1_Adv = mkAdv "däribland" ;
  daerifraan_ab_1_1_Adv = mkAdv "därifrån" ;
  daerigenom_ab_1_1_Adv = mkAdv "därigenom" ;
  daerinifraan_ab_1_1_Adv = mkAdv "därinifrån" ;
  daerinne_ab_1_1_Adv = mkAdv "därinne" ;
  daerjaemte_ab_1_1_Adv = mkAdv "därjämte" ;
  daermed_ab_1_1_Adv = mkAdv "därmed" ;
  daernedanfoer_ab_1_1_Adv = mkAdv "därnedanför" ;
  daernere_ab_1_1_Adv = mkAdv "därnere" ;
  daernaest_ab_1_1_Adv = mkAdv "därnäst" ;
  daerom_ab_1_1_Adv = mkAdv "därom" ;
  daeromkring_ab_1_1_Adv = mkAdv "däromkring" ;
  daeroppe_ab_1_1_Adv = mkAdv "däroppe" ;
  daerovanfoer_ab_1_1_Adv = mkAdv "därovanför" ;
  daerpaa_ab_1_1_Adv = mkAdv "därpå" ;
  daerstaedes_ab_1_1_Adv = mkAdv "därstädes" ;
  daertill_ab_1_1_Adv = mkAdv "därtill" ;
  daerunder_ab_1_1_Adv = mkAdv "därunder" ;
  daeruppe_ab_1_1_Adv = mkAdv "däruppe" ;
  daeruppifraan_ab_1_1_Adv = mkAdv "däruppifrån" ;
  daerur_ab_1_1_Adv = mkAdv "därur" ;
  daerutanfoer_ab_1_1_Adv = mkAdv "därutanför" ;
  daerutav_ab_1_1_Adv = mkAdv "därutav" ;
  daerute_ab_1_1_Adv = mkAdv "därute" ;
  daerutinnan_ab_1_1_Adv = mkAdv "därutinnan" ;
  daerutur_ab_1_1_Adv = mkAdv "därutur" ;
  daerutoever_ab_1_1_Adv = mkAdv "därutöver" ;
  daervid_ab_1_1_Adv = mkAdv "därvid" ;
  daervidlag_ab_1_1_Adv = mkAdv "därvidlag" ;
  daeraat_ab_1_1_Adv = mkAdv "däråt" ;
  daeroever_ab_1_1_Adv = mkAdv "däröver" ;
  daa_ab_1_1_Adv = mkAdv "då" ;
  daa_ab_2_1_Adv = mkAdv "då" ;
  daafoertiden_ab_1_1_Adv = mkAdv "dåförtiden" ;
  daamera_ab_1_1_Adv = mkAdv "dåmera" ;
  edligen_ab_1_Adv = mkAdv "edligen" ;
  efter_ab_1_Adv = mkAdv "efter" ;
  efterhand_ab_1_Adv = mkAdv "efterhand" ;
  efterst_ab_1_Adv = mkAdv "efterst" ;
  eftertryckligen_ab_1_Adv = mkAdv "eftertryckligen" ;
  efteraat_ab_1_1_Adv = mkAdv "efteråt" ;
  egentligen_ab_1_Adv = mkAdv "egentligen" ;
  ej_ab_1_Adv = mkAdv "ej" ;
  eljes_ab_1_Adv = mkAdv "eljes" ;
  eljest_ab_1_Adv = mkAdv "eljest" ;
  ellande_ab_1_Adv = mkAdv "ellande" ;
  emellan_ab_1_Adv = mkAdv "emellan" ;
  emellanaat_ab_1_1_Adv = mkAdv "emellanåt" ;
  emellertid_ab_1_Adv = mkAdv "emellertid" ;
  emot_ab_1_Adv = mkAdv "emot" ;
  en_ab_1_Adv = mkAdv "en" ;
  enbart_ab_1_Adv = mkAdv "enbart" ;
  enda_av_1_A = mkA "enda" ;
  endast_ab_1_Adv = mkAdv "endast" ;
  endels_ab_1_Adv = mkAdv "endels" ;
  endera_ab_1_Adv = mkAdv "endera" ;
  enfaldeligen_ab_1_Adv = mkAdv "enfaldeligen" ;
  engaang_ab_1_1_Adv = mkAdv "engång" ;
  enkannerligen_ab_1_Adv = mkAdv "enkannerligen" ;
  enkom_ab_1_Adv = mkAdv "enkom" ;
  ens_ab_1_Adv = mkAdv "ens" ;
  erbarmligen_ab_1_Adv = mkAdv "erbarmligen" ;
  ergo_ab_1_Adv = mkAdv "ergo" ;
  esomoftast_ab_1_Adv = mkAdv "esomoftast" ;
  etappvis_ab_1_Adv = mkAdv "etappvis" ;
  etcetera_ab_1_Adv = mkAdv "etcetera" ;
  evar_ab_1_Adv = mkAdv "evar" ;
  evart_ab_1_Adv = mkAdv "evart" ;
  evinnerligen_ab_1_Adv = mkAdv "evinnerligen" ;
  exempelvis_ab_1_Adv = mkAdv "exempelvis" ;
  express_ab_1_Adv = mkAdv "express" ;
  extempore_ab_1_Adv = mkAdv "extempore" ;
  extra_ab_1_Adv = mkAdv "extra" ;
  falskeligen_ab_1_Adv = mkAdv "falskeligen" ;
  fast_ab_1_Adv = mkAdv "fast" ;
  fastmer_ab_1_Adv = mkAdv "fastmer" ;
  fastmera_ab_1_Adv = mkAdv "fastmera" ;
  fett_ab_1_Adv = mkAdv "fett" ;
  fikadags_ab_1_Adv = mkAdv "fikadags" ;
  fjaerran_ab_1_1_Adv = mkAdv "fjärran" ;
  flerstaedes_ab_1_1_Adv = mkAdv "flerstädes" ;
  flott_ab_1_Adv = mkAdv "flott" ;
  flygledes_ab_1_Adv = mkAdv "flygledes" ;
  flaeckvis_ab_1_1_Adv = mkAdv "fläckvis" ;
  fob_ab_1_Adv = mkAdv "fob" ;
  fordom_ab_1_Adv = mkAdv "fordom" ;
  fordomdags_ab_1_Adv = mkAdv "fordomdags" ;
  formaliter_ab_1_Adv = mkAdv "formaliter" ;
  formligen_ab_1_Adv = mkAdv "formligen" ;
  fort_ab_1_Adv = mkAdv "fort" ;
  forte_ab_1_Adv = mkAdv "forte" ;
  fortfarande_ab_1_Adv = mkAdv "fortfarande" ;
  fortissimo_ab_1_Adv = mkAdv "fortissimo" ;
  fortsaettningsvis_ab_1_1_Adv = mkAdv "fortsättningsvis" ;
  fram_ab_1_Adv = mkAdv "fram" ;
  framdeles_ab_1_Adv = mkAdv "framdeles" ;
  framfoer_ab_1_1_Adv = mkAdv "framför" ;
  framfoerallt_ab_1_1_Adv = mkAdv "framförallt" ;
  framgent_ab_1_Adv = mkAdv "framgent" ;
  framifraan_ab_1_1_Adv = mkAdv "framifrån" ;
  framlaenges_ab_1_1_Adv = mkAdv "framlänges" ;
  framme_ab_1_Adv = mkAdv "framme" ;
  frampaa_ab_1_1_Adv = mkAdv "frampå" ;
  framstupa_ab_1_Adv = mkAdv "framstupa" ;
  framtill_ab_1_Adv = mkAdv "framtill" ;
  framaat_ab_1_1_Adv = mkAdv "framåt" ;
  framoever_ab_1_1_Adv = mkAdv "framöver" ;
  franko_ab_1_Adv = mkAdv "franko" ;
  fruktansvaert_ab_1_1_Adv = mkAdv "fruktansvärt" ;
  fraemst_ab_1_1_Adv = mkAdv "främst" ;
  fraan_ab_1_1_Adv = mkAdv "från" ;
  fullkomligen_ab_1_Adv = mkAdv "fullkomligen" ;
  furioso_ab_1_Adv = mkAdv "furioso" ;
  fyrfalt_ab_1_Adv = mkAdv "fyrfalt" ;
  foega_ab_1_1_Adv = mkAdv "föga" ;
  foeljaktligen_ab_1_1_Adv = mkAdv "följaktligen" ;
  foer_ab_1_1_Adv = mkAdv "för" ;
  foer_ab_2_1_Adv = mkAdv "för" ;
  foerbi_ab_1_1_Adv = mkAdv "förbi" ;
  foerbaalt_ab_1_1_Adv = mkAdv "förbålt" ;
  foerdenskull_ab_1_1_Adv = mkAdv "fördenskull" ;
  foerdevind_ab_1_1_Adv = mkAdv "fördevind" ;
  foere_ab_1_1_Adv = mkAdv "före" ;
  foeretraedesvis_ab_1_1_Adv = mkAdv "företrädesvis" ;
  foerfaerligt_ab_1_1_Adv = mkAdv "förfärligt" ;
  foergaeves_ab_1_1_Adv = mkAdv "förgäves" ;
  foerhoppningsvis_ab_1_1_Adv = mkAdv "förhoppningsvis" ;
  foerhaallandevis_ab_1_1_Adv = mkAdv "förhållandevis" ;
  foermodligen_ab_1_1_Adv = mkAdv "förmodligen" ;
  foernaemligast_ab_1_1_Adv = mkAdv "förnämligast" ;
  foernaemligen_ab_1_1_Adv = mkAdv "förnämligen" ;
  foernaer_ab_1_1_Adv = mkAdv "förnär" ;
  foerr_ab_1_1_Adv = mkAdv "förr" ;
  foerra_av_1_1_A = mkA "förra" ;
  foerresten_ab_1_1_Adv = mkAdv "förresten" ;
  foersent_ab_1_1_Adv = mkAdv "försent" ;
  foersiktighetsvis_ab_1_1_Adv = mkAdv "försiktighetsvis" ;
  foersiktigtvis_ab_1_1_Adv = mkAdv "försiktigtvis" ;
  foerslagsvis_ab_1_1_Adv = mkAdv "förslagsvis" ;
  foerst_ab_1_1_Adv = mkAdv "först" ;
  foerstaas_ab_1_1_Adv = mkAdv "förstås" ;
  foersoeksvis_ab_1_1_Adv = mkAdv "försöksvis" ;
  foerty_ab_1_1_Adv = mkAdv "förty" ;
  foerut_ab_1_1_Adv = mkAdv "förut" ;
  foerut_2_ab_1_1_Adv = mkAdv "förut" ;
  foervisso_ab_1_1_Adv = mkAdv "förvisso" ;
  foeroever_ab_1_1_Adv = mkAdv "föröver" ;
  foeroevrigt_ab_1_1_Adv = mkAdv "förövrigt" ;
  galant_ab_1_Adv = mkAdv "galant" ;
  ganska_ab_1_Adv = mkAdv "ganska" ;
  gemenligen_ab_1_Adv = mkAdv "gemenligen" ;
  genast_ab_1_Adv = mkAdv "genast" ;
  genom_ab_1_Adv = mkAdv "genom" ;
  genomgaaende_ab_1_1_Adv = mkAdv "genomgående" ;
  geschvint_ab_1_Adv = mkAdv "geschvint" ;
  geschwint_ab_1_Adv = mkAdv "geschwint" ;
  gesvint_ab_1_Adv = mkAdv "gesvint" ;
  gissningsvis_ab_1_Adv = mkAdv "gissningsvis" ;
  givetvis_ab_1_Adv = mkAdv "givetvis" ;
  gladeligen_ab_1_Adv = mkAdv "gladeligen" ;
  gladligen_ab_1_Adv = mkAdv "gladligen" ;
  glimtvis_ab_1_Adv = mkAdv "glimtvis" ;
  gradvis_ab_1_Adv = mkAdv "gradvis" ;
  granneligen_ab_1_Adv = mkAdv "granneligen" ;
  gratis_ab_1_Adv = mkAdv "gratis" ;
  grave_ab_1_Adv = mkAdv "grave" ;
  grensle_ab_1_Adv = mkAdv "grensle" ;
  grundligen_ab_1_Adv = mkAdv "grundligen" ;
  grymt_ab_1_Adv = mkAdv "grymt" ;
  graensle_ab_1_1_Adv = mkAdv "gränsle" ;
  gudilov_ab_1_Adv = mkAdv "gudilov" ;
  gudinog_ab_1_Adv = mkAdv "gudinog" ;
  gudskelov_ab_1_Adv = mkAdv "gudskelov" ;
  gaerna_ab_1_1_Adv = mkAdv "gärna" ;
  halvvaegs_ab_1_1_Adv = mkAdv "halvvägs" ;
  halvaarsvis_ab_1_1_Adv = mkAdv "halvårsvis" ;
  handgripligen_ab_1_Adv = mkAdv "handgripligen" ;
  handloest_ab_1_1_Adv = mkAdv "handlöst" ;
  heller_ab_1_Adv = mkAdv "heller" ;
  hem_ab_1_Adv = mkAdv "hem" ;
  hemifraan_ab_1_1_Adv = mkAdv "hemifrån" ;
  hemligen_ab_1_Adv = mkAdv "hemligen" ;
  hemma_ab_1_Adv = mkAdv "hemma" ;
  hemmavid_ab_1_Adv = mkAdv "hemmavid" ;
  hemskt_ab_1_Adv = mkAdv "hemskt" ;
  hemaat_ab_1_1_Adv = mkAdv "hemåt" ;
  himla_ab_1_Adv = mkAdv "himla" ;
  hinkvis_ab_1_Adv = mkAdv "hinkvis" ;
  hit_ab_1_Adv = mkAdv "hit" ;
  hiterst_ab_1_Adv = mkAdv "hiterst" ;
  hitintills_ab_1_Adv = mkAdv "hitintills" ;
  hittilldags_ab_1_Adv = mkAdv "hittilldags" ;
  hittills_ab_1_Adv = mkAdv "hittills" ;
  hitaat_ab_1_1_Adv = mkAdv "hitåt" ;
  hjaertans_ab_1_1_Adv = mkAdv "hjärtans" ;
  hjaertligen_ab_1_1_Adv = mkAdv "hjärtligen" ;
  hoppeligen_ab_1_Adv = mkAdv "hoppeligen" ;
  hundrafalt_ab_1_Adv = mkAdv "hundrafalt" ;
  hur_ab_1_Adv = mkAdv "hur" ;
  hursomhaver_ab_1_Adv = mkAdv "hursomhaver" ;
  hursomhelst_ab_1_Adv = mkAdv "hursomhelst" ;
  huru_ab_1_Adv = mkAdv "huru" ;
  huruledes_ab_1_Adv = mkAdv "huruledes" ;
  huvudsakligen_ab_1_Adv = mkAdv "huvudsakligen" ;
  huvudstupa_ab_1_Adv = mkAdv "huvudstupa" ;
  haedan_ab_1_1_Adv = mkAdv "hädan" ;
  haedanefter_ab_1_1_Adv = mkAdv "hädanefter" ;
  haen_ab_1_1_Adv = mkAdv "hän" ;
  haendelsevis_ab_1_1_Adv = mkAdv "händelsevis" ;
  haer_ab_1_1_Adv = mkAdv "här" ;
  haerav_ab_1_1_Adv = mkAdv "härav" ;
  haerefter_ab_1_1_Adv = mkAdv "härefter" ;
  haeremot_ab_1_1_Adv = mkAdv "häremot" ;
  haerfoer_ab_1_1_Adv = mkAdv "härför" ;
  haerfoerleden_ab_1_1_Adv = mkAdv "härförleden" ;
  haerhemma_ab_1_1_Adv = mkAdv "härhemma" ;
  haeri_ab_1_1_Adv = mkAdv "häri" ;
  haerifraan_ab_1_1_Adv = mkAdv "härifrån" ;
  haerigenom_ab_1_1_Adv = mkAdv "härigenom" ;
  haerinne_ab_1_1_Adv = mkAdv "härinne" ;
  haerintill_ab_1_1_Adv = mkAdv "härintill" ;
  haerjaemte_ab_1_1_Adv = mkAdv "härjämte" ;
  haermed_ab_1_1_Adv = mkAdv "härmed" ;
  haernere_ab_1_1_Adv = mkAdv "härnere" ;
  haernaest_ab_1_1_Adv = mkAdv "härnäst" ;
  haerom_ab_1_1_Adv = mkAdv "härom" ;
  haeromdagen_ab_1_1_Adv = mkAdv "häromdagen" ;
  haeromdan_ab_1_1_Adv = mkAdv "häromdan" ;
  haeromkring_ab_1_1_Adv = mkAdv "häromkring" ;
  haeromkvaellen_ab_1_1_Adv = mkAdv "häromkvällen" ;
  haerommaanaden_ab_1_1_Adv = mkAdv "härommånaden" ;
  haeromnatten_ab_1_1_Adv = mkAdv "häromnatten" ;
  haeromsistens_ab_1_1_Adv = mkAdv "häromsistens" ;
  haeromveckan_ab_1_1_Adv = mkAdv "häromveckan" ;
  haeromaaret_ab_1_1_Adv = mkAdv "häromåret" ;
  haerpaa_ab_1_1_Adv = mkAdv "härpå" ;
  haerstaedes_ab_1_1_Adv = mkAdv "härstädes" ;
  haertill_ab_1_1_Adv = mkAdv "härtill" ;
  haeruppe_ab_1_1_Adv = mkAdv "häruppe" ;
  haerute_ab_1_1_Adv = mkAdv "härute" ;
  haerutinnan_ab_1_1_Adv = mkAdv "härutinnan" ;
  haerutoever_ab_1_1_Adv = mkAdv "härutöver" ;
  haervid_ab_1_1_Adv = mkAdv "härvid" ;
  haervidlag_ab_1_1_Adv = mkAdv "härvidlag" ;
  haeraat_ab_1_1_Adv = mkAdv "häråt" ;
  hoegeligen_ab_1_1_Adv = mkAdv "högeligen" ;
  hoegst_ab_1_1_Adv = mkAdv "högst" ;
  hoegtidligen_ab_1_1_Adv = mkAdv "högtidligen" ;
  hoerbarligen_ab_1_1_Adv = mkAdv "hörbarligen" ;
  i_ab_1_Adv = mkAdv "i" ;
  ibidem_ab_1_Adv = mkAdv "ibidem" ;
  ibland_ab_1_Adv = mkAdv "ibland" ;
  icke_ab_1_Adv = mkAdv "icke" ;
  idag_ab_1_Adv = mkAdv "idag" ;
  idel_ab_1_Adv = mkAdv "idel" ;
  ideligen_ab_1_Adv = mkAdv "ideligen" ;
  ifatt_ab_1_Adv = mkAdv "ifatt" ;
  ifjol_ab_1_Adv = mkAdv "ifjol" ;
  ifred_ab_1_Adv = mkAdv "ifred" ;
  ifraaga_ab_1_1_Adv = mkAdv "ifråga" ;
  ifraan_ab_1_1_Adv = mkAdv "ifrån" ;
  igen_ab_1_Adv = mkAdv "igen" ;
  igen_ab_2_Adv = mkAdv "igen" ;
  igenom_ab_1_Adv = mkAdv "igenom" ;
  igaang_ab_1_1_Adv = mkAdv "igång" ;
  igaar_ab_1_1_Adv = mkAdv "igår" ;
  ihjael_ab_1_1_Adv = mkAdv "ihjäl" ;
  ihop_ab_1_Adv = mkAdv "ihop" ;
  ikapp_ab_1_Adv = mkAdv "ikapp" ;
  ikraft_ab_1_Adv = mkAdv "ikraft" ;
  ikull_ab_1_Adv = mkAdv "ikull" ;
  ikvaell_ab_1_1_Adv = mkAdv "ikväll" ;
  iland_ab_1_Adv = mkAdv "iland" ;
  illa_ab_1_Adv = mkAdv "illa" ;
  illande_ab_1_Adv = mkAdv "illande" ;
  imorgon_ab_1_Adv = mkAdv "imorgon" ;
  imorse_ab_1_Adv = mkAdv "imorse" ;
  in_ab_1_Adv = mkAdv "in" ;
  inalles_ab_1_Adv = mkAdv "inalles" ;
  ingalunda_ab_1_Adv = mkAdv "ingalunda" ;
  ingenstans_ab_1_Adv = mkAdv "ingenstans" ;
  ingenstaedes_ab_1_1_Adv = mkAdv "ingenstädes" ;
  ingenvart_ab_1_Adv = mkAdv "ingenvart" ;
  inifraan_ab_1_1_Adv = mkAdv "inifrån" ;
  inkognito_ab_1_Adv = mkAdv "inkognito" ;
  inledningsvis_ab_1_Adv = mkAdv "inledningsvis" ;
  innan_ab_1_Adv = mkAdv "innan" ;
  innanfoer_ab_1_1_Adv = mkAdv "innanför" ;
  innantill_ab_1_Adv = mkAdv "innantill" ;
  inne_ab_1_Adv = mkAdv "inne" ;
  innerligen_ab_1_Adv = mkAdv "innerligen" ;
  innerst_ab_1_Adv = mkAdv "innerst" ;
  inombords_ab_1_Adv = mkAdv "inombords" ;
  inomhus_ab_1_Adv = mkAdv "inomhus" ;
  inomlands_ab_1_Adv = mkAdv "inomlands" ;
  inomskaers_ab_1_1_Adv = mkAdv "inomskärs" ;
  inrikes_ab_1_Adv = mkAdv "inrikes" ;
  inte_ab_1_Adv = mkAdv "inte" ;
  intill_ab_1_Adv = mkAdv "intill" ;
  inuti_ab_1_Adv = mkAdv "inuti" ;
  invaertes_ab_1_1_Adv = mkAdv "invärtes" ;
  inaat_ab_1_1_Adv = mkAdv "inåt" ;
  istaellet_ab_1_1_Adv = mkAdv "istället" ;
  isaender_ab_1_1_Adv = mkAdv "isänder" ;
  isaer_ab_1_1_Adv = mkAdv "isär" ;
  itu_ab_1_Adv = mkAdv "itu" ;
  ity_ab_1_Adv = mkAdv "ity" ;
  ivaeg_ab_1_1_Adv = mkAdv "iväg" ;
  ju_ab_1_Adv = mkAdv "ju" ;
  just_ab_1_Adv = mkAdv "just" ;
  jaemfota_ab_1_1_Adv = mkAdv "jämfota" ;
  jaemfoerelsevis_ab_1_1_Adv = mkAdv "jämförelsevis" ;
  jaems_ab_1_1_Adv = mkAdv "jäms" ;
  jaemsides_ab_1_1_Adv = mkAdv "jämsides" ;
  jaemt_ab_1_1_Adv = mkAdv "jämt" ;
  jaemvael_ab_1_1_Adv = mkAdv "jämväl" ;
  jaette_ab_1_1_Adv = mkAdv "jätte" ;
  jaettelaenge_ab_1_1_Adv = mkAdv "jättelänge" ;
  jaettemycket_ab_1_1_Adv = mkAdv "jättemycket" ;
  jaetteofta_ab_1_1_Adv = mkAdv "jätteofta" ;
  jaettesaellan_ab_1_1_Adv = mkAdv "jättesällan" ;
  jaevligt_ab_1_1_Adv = mkAdv "jävligt" ;
  kaffedags_ab_1_Adv = mkAdv "kaffedags" ;
  kajfritt_ab_1_Adv = mkAdv "kajfritt" ;
  kanhaenda_ab_1_1_Adv = mkAdv "kanhända" ;
  kanonbra_ab_1_Adv = mkAdv "kanonbra" ;
  kanske_ab_1_Adv = mkAdv "kanske" ;
  kantaenka_ab_1_1_Adv = mkAdv "kantänka" ;
  kapitelvis_ab_1_Adv = mkAdv "kapitelvis" ;
  kav_ab_1_Adv = mkAdv "kav" ;
  klarligen_ab_1_Adv = mkAdv "klarligen" ;
  klockrent_ab_1_Adv = mkAdv "klockrent" ;
  kloss_ab_1_Adv = mkAdv "kloss" ;
  klumpvis_ab_1_Adv = mkAdv "klumpvis" ;
  knappast_ab_1_Adv = mkAdv "knappast" ;
  knappt_ab_1_Adv = mkAdv "knappt" ;
  korgvis_ab_1_Adv = mkAdv "korgvis" ;
  korsvis_ab_1_Adv = mkAdv "korsvis" ;
  kort_ab_1_Adv = mkAdv "kort" ;
  korteligen_ab_1_Adv = mkAdv "korteligen" ;
  kranbalksvis_ab_1_Adv = mkAdv "kranbalksvis" ;
  kring_ab_1_Adv = mkAdv "kring" ;
  kroppsligen_ab_1_Adv = mkAdv "kroppsligen" ;
  kraesligen_ab_1_1_Adv = mkAdv "kräsligen" ;
  kull_ab_1_Adv = mkAdv "kull" ;
  kundnaera_ab_1_1_Adv = mkAdv "kundnära" ;
  kustnaera_ab_1_1_Adv = mkAdv "kustnära" ;
  kvar_ab_1_Adv = mkAdv "kvar" ;
  kvartalsvis_ab_1_Adv = mkAdv "kvartalsvis" ;
  kaeppraett_ab_1_1_Adv = mkAdv "käpprätt" ;
  kaerligen_ab_1_1_Adv = mkAdv "kärligen" ;
  lagligen_ab_1_Adv = mkAdv "lagligen" ;
  lagom_ab_1_Adv = mkAdv "lagom" ;
  landledes_ab_1_Adv = mkAdv "landledes" ;
  largetto_ab_1_Adv = mkAdv "largetto" ;
  largo_ab_1_Adv = mkAdv "largo" ;
  legaliter_ab_1_Adv = mkAdv "legaliter" ;
  legato_ab_1_Adv = mkAdv "legato" ;
  lekamligen_ab_1_Adv = mkAdv "lekamligen" ;
  liggdags_ab_1_Adv = mkAdv "liggdags" ;
  lika_ab_1_Adv = mkAdv "lika" ;
  likafullt_ab_1_Adv = mkAdv "likafullt" ;
  likaledes_ab_1_Adv = mkAdv "likaledes" ;
  likasom_ab_1_Adv = mkAdv "likasom" ;
  likasaa_ab_1_1_Adv = mkAdv "likaså" ;
  likasaavael_ab_1_1_Adv = mkAdv "likasåväl" ;
  likavael_ab_1_1_Adv = mkAdv "likaväl" ;
  likmaetigt_ab_1_1_Adv = mkAdv "likmätigt" ;
  liksom_ab_1_Adv = mkAdv "liksom" ;
  likvisst_ab_1_Adv = mkAdv "likvisst" ;
  likvael_ab_1_1_Adv = mkAdv "likväl" ;
  lite_ab_1_Adv = mkAdv "lite" ;
  litervis_ab_1_Adv = mkAdv "litervis" ;
  litet_ab_1_Adv = mkAdv "litet" ;
  loco_ab_1_Adv = mkAdv "loco" ;
  loko_ab_1_Adv = mkAdv "loko" ;
  loss_ab_1_Adv = mkAdv "loss" ;
  luftledes_ab_1_Adv = mkAdv "luftledes" ;
  lyckligen_ab_1_Adv = mkAdv "lyckligen" ;
  lyckligtvis_ab_1_Adv = mkAdv "lyckligtvis" ;
  laeggdags_ab_1_1_Adv = mkAdv "läggdags" ;
  laempligen_ab_1_1_Adv = mkAdv "lämpligen" ;
  laenge_ab_1_1_Adv = mkAdv "länge" ;
  laengesedan_ab_1_1_Adv = mkAdv "längesedan" ;
  laengesen_ab_1_1_Adv = mkAdv "längesen" ;
  laengs_ab_1_1_Adv = mkAdv "längs" ;
  laengst_ab_1_1_Adv = mkAdv "längst" ;
  laensvis_ab_1_1_Adv = mkAdv "länsvis" ;
  laetteligen_ab_1_1_Adv = mkAdv "lätteligen" ;
  laangsides_ab_1_1_Adv = mkAdv "långsides" ;
  laangskepps_ab_1_1_Adv = mkAdv "långskepps" ;
  laangt_ab_1_1_Adv = mkAdv "långt" ;
  laangtbortifraan_ab_1_1_Adv = mkAdv "långtbortifrån" ;
  laangtifraan_ab_1_1_Adv = mkAdv "långtifrån" ;
  loennligen_ab_1_1_Adv = mkAdv "lönnligen" ;
  malapropaa_ab_1_1_Adv = mkAdv "malapropå" ;
  massvis_ab_1_Adv = mkAdv "massvis" ;
  mastfritt_ab_1_Adv = mkAdv "mastfritt" ;
  med_ab_1_Adv = mkAdv "med" ;
  med_ab_2_Adv = mkAdv "med" ;
  meddetsamma_ab_1_Adv = mkAdv "meddetsamma" ;
  medhaars_ab_1_1_Adv = mkAdv "medhårs" ;
  medsamma_ab_1_Adv = mkAdv "medsamma" ;
  medsols_ab_1_Adv = mkAdv "medsols" ;
  medstroems_ab_1_1_Adv = mkAdv "medströms" ;
  medurs_ab_1_Adv = mkAdv "medurs" ;
  mellerst_ab_1_Adv = mkAdv "mellerst" ;
  mer_ab_1_Adv = mkAdv "mer" ;
  mera_ab_1_Adv = mkAdv "mera" ;
  merendels_ab_1_Adv = mkAdv "merendels" ;
  mestadels_ab_1_Adv = mkAdv "mestadels" ;
  metervis_ab_1_Adv = mkAdv "metervis" ;
  mezzoforte_ab_1_Adv = mkAdv "mezzoforte" ;
  midskepps_ab_1_Adv = mkAdv "midskepps" ;
  midvattens_ab_1_Adv = mkAdv "midvattens" ;
  miltals_ab_1_Adv = mkAdv "miltals" ;
  minsann_ab_1_Adv = mkAdv "minsann" ;
  minst_ab_1_Adv = mkAdv "minst" ;
  miste_ab_1_Adv = mkAdv "miste" ;
  mitt_ab_1_Adv = mkAdv "mitt" ;
  mittemellan_ab_1_Adv = mkAdv "mittemellan" ;
  mittemot_ab_1_Adv = mkAdv "mittemot" ;
  mitterst_ab_1_Adv = mkAdv "mitterst" ;
  mittsunds_ab_1_Adv = mkAdv "mittsunds" ;
  mol_ab_1_Adv = mkAdv "mol" ;
  mot_ab_1_Adv = mkAdv "mot" ;
  mothaars_ab_1_1_Adv = mkAdv "mothårs" ;
  motsols_ab_1_Adv = mkAdv "motsols" ;
  motstroems_ab_1_1_Adv = mkAdv "motströms" ;
  moturs_ab_1_Adv = mkAdv "moturs" ;
  muntligen_ab_1_Adv = mkAdv "muntligen" ;
  mycket_ab_1_Adv = mkAdv "mycket" ;
  maekta_ab_1_1_Adv = mkAdv "mäkta" ;
  maengdvis_ab_1_1_Adv = mkAdv "mängdvis" ;
  maahaenda_ab_1_1_Adv = mkAdv "måhända" ;
  maanadsvis_ab_1_1_Adv = mkAdv "månadsvis" ;
  maanatligen_ab_1_1_Adv = mkAdv "månatligen" ;
  maangenstaedes_ab_1_1_Adv = mkAdv "mångenstädes" ;
  maangfalt_ab_1_1_Adv = mkAdv "mångfalt" ;
  maanne_ab_1_1_Adv = mkAdv "månne" ;
  maanntro_ab_1_1_Adv = mkAdv "månntro" ;
  maatro_ab_1_1_Adv = mkAdv "måtro" ;
  moejligen_ab_1_1_Adv = mkAdv "möjligen" ;
  moejligtvis_ab_1_1_Adv = mkAdv "möjligtvis" ;
  naggande_ab_1_Adv = mkAdv "naggande" ;
  namneligen_ab_1_Adv = mkAdv "namneligen" ;
  nationsvis_ab_1_Adv = mkAdv "nationsvis" ;
  nattetid_ab_1_Adv = mkAdv "nattetid" ;
  naturligen_ab_1_Adv = mkAdv "naturligen" ;
  naturligtvis_ab_1_Adv = mkAdv "naturligtvis" ;
  ned_ab_1_Adv = mkAdv "ned" ;
  nedan_ab_1_Adv = mkAdv "nedan" ;
  nedanfoer_ab_1_1_Adv = mkAdv "nedanför" ;
  neder_ab_1_Adv = mkAdv "neder" ;
  nederst_ab_1_Adv = mkAdv "nederst" ;
  nedfoer_ab_1_1_Adv = mkAdv "nedför" ;
  nedifraan_ab_1_1_Adv = mkAdv "nedifrån" ;
  nedom_ab_1_Adv = mkAdv "nedom" ;
  nedstroems_ab_1_1_Adv = mkAdv "nedströms" ;
  nedtill_ab_1_Adv = mkAdv "nedtill" ;
  nedaat_ab_1_1_Adv = mkAdv "nedåt" ;
  ner_ab_1_Adv = mkAdv "ner" ;
  nere_ab_1_Adv = mkAdv "nere" ;
  nerfoer_ab_1_1_Adv = mkAdv "nerför" ;
  nerifraan_ab_1_1_Adv = mkAdv "nerifrån" ;
  nerom_ab_1_Adv = mkAdv "nerom" ;
  nerstroems_ab_1_1_Adv = mkAdv "nerströms" ;
  nertill_ab_1_Adv = mkAdv "nertill" ;
  neraat_ab_1_1_Adv = mkAdv "neråt" ;
  nesligen_ab_1_Adv = mkAdv "nesligen" ;
  netto_ab_1_Adv = mkAdv "netto" ;
  nog_ab_1_Adv = mkAdv "nog" ;
  noga_ab_1_Adv = mkAdv "noga" ;
  nogav_ab_1_Adv = mkAdv "nogav" ;
  nogsamt_ab_1_Adv = mkAdv "nogsamt" ;
  nonstop_ab_1_Adv = mkAdv "nonstop" ;
  nordan_ab_1_Adv = mkAdv "nordan" ;
  nordnordost_ab_1_Adv = mkAdv "nordnordost" ;
  nordnordvaest_ab_1_1_Adv = mkAdv "nordnordväst" ;
  nordost_ab_1_Adv = mkAdv "nordost" ;
  nordpaa_ab_1_1_Adv = mkAdv "nordpå" ;
  nordvart_ab_1_Adv = mkAdv "nordvart" ;
  nordvaest_ab_1_1_Adv = mkAdv "nordväst" ;
  nordoest_ab_1_1_Adv = mkAdv "nordöst" ;
  normaliter_ab_1_Adv = mkAdv "normaliter" ;
  norr_ab_1_Adv = mkAdv "norr" ;
  norrifraan_ab_1_1_Adv = mkAdv "norrifrån" ;
  norrpaa_ab_1_1_Adv = mkAdv "norrpå" ;
  norrut_ab_1_Adv = mkAdv "norrut" ;
  norroever_ab_1_1_Adv = mkAdv "norröver" ;
  nu_ab_1_Adv = mkAdv "nu" ;
  nufoertiden_ab_1_1_Adv = mkAdv "nuförtiden" ;
  numer_ab_1_Adv = mkAdv "numer" ;
  numera_ab_1_Adv = mkAdv "numera" ;
  nutilldags_ab_1_Adv = mkAdv "nutilldags" ;
  nyligen_ab_1_Adv = mkAdv "nyligen" ;
  nyss_ab_1_Adv = mkAdv "nyss" ;
  nyssbemaelda_av_1_1_A = mkA "nyssbemälda" ;
  nyssbemaelta_av_1_1_A = mkA "nyssbemälta" ;
  nyssberoerda_av_1_1_A = mkA "nyssberörda" ;
  nyssnaemnda_av_1_1_A = mkA "nyssnämnda" ;
  naemligen_ab_1_1_Adv = mkAdv "nämligen" ;
  naeppeligen_ab_1_1_Adv = mkAdv "näppeligen" ;
  naer_ab_1_1_Adv = mkAdv "när" ;
  naera_ab_1_1_Adv = mkAdv "nära" ;
  naerapaa_ab_1_1_Adv = mkAdv "närapå" ;
  naest_ab_1_1_Adv = mkAdv "näst" ;
  naesta_av_1_1_A = mkA "nästa" ;
  naestan_ab_1_1_Adv = mkAdv "nästan" ;
  naestans_ab_1_1_Adv = mkAdv "nästans" ;
  naestgaards_ab_1_1_Adv = mkAdv "nästgårds" ;
  naestintill_ab_1_1_Adv = mkAdv "nästintill" ;
  naett_ab_1_1_Adv = mkAdv "nätt" ;
  naettopp_ab_1_1_Adv = mkAdv "nättopp" ;
  naettupp_ab_1_1_Adv = mkAdv "nättupp" ;
  naadeligen_ab_1_1_Adv = mkAdv "nådeligen" ;
  naagongaang_ab_1_1_Adv = mkAdv "någongång" ;
  naagonsin_ab_1_1_Adv = mkAdv "någonsin" ;
  naagonstans_ab_1_1_Adv = mkAdv "någonstans" ;
  naagonstaedes_ab_1_1_Adv = mkAdv "någonstädes" ;
  naagonvart_ab_1_1_Adv = mkAdv "någonvart" ;
  naagorlunda_ab_1_1_Adv = mkAdv "någorlunda" ;
  naagotsaanaer_ab_1_1_Adv = mkAdv "någotsånär" ;
  naangaang_ab_1_1_Adv = mkAdv "nångång" ;
  naansin_ab_1_1_Adv = mkAdv "nånsin" ;
  naanstans_ab_1_1_Adv = mkAdv "nånstans" ;
  naanvart_ab_1_1_Adv = mkAdv "nånvart" ;
  naatsaanaer_ab_1_1_Adv = mkAdv "nåtsånär" ;
  noedvaendigtvis_ab_1_1_Adv = mkAdv "nödvändigtvis" ;
  oavlaatligen_ab_1_1_Adv = mkAdv "oavlåtligen" ;
  oavsiktligen_ab_1_Adv = mkAdv "oavsiktligen" ;
  oavvaent_ab_1_1_Adv = mkAdv "oavvänt" ;
  obehindrat_ab_1_Adv = mkAdv "obehindrat" ;
  obehoerigen_ab_1_1_Adv = mkAdv "obehörigen" ;
  obestridligen_ab_1_Adv = mkAdv "obestridligen" ;
  oboenhoerligen_ab_1_1_Adv = mkAdv "obönhörligen" ;
  ock_ab_1_Adv = mkAdv "ock" ;
  ocksaa_ab_1_1_Adv = mkAdv "också" ;
  offentligen_ab_1_Adv = mkAdv "offentligen" ;
  offside_ab_1_Adv = mkAdv "offside" ;
  ofraankomligen_ab_1_1_Adv = mkAdv "ofrånkomligen" ;
  ofta_ab_1_Adv = mkAdv "ofta" ;
  ofoerdroejligen_ab_1_1_Adv = mkAdv "ofördröjligen" ;
  ofoerhappandes_ab_1_1_Adv = mkAdv "oförhappandes" ;
  ofoervarandes_ab_1_1_Adv = mkAdv "oförvarandes" ;
  ogaerna_ab_1_1_Adv = mkAdv "ogärna" ;
  olika_ab_1_Adv = mkAdv "olika" ;
  olovandes_ab_1_Adv = mkAdv "olovandes" ;
  olovligen_ab_1_Adv = mkAdv "olovligen" ;
  olyckligtvis_ab_1_Adv = mkAdv "olyckligtvis" ;
  om_ab_1_Adv = mkAdv "om" ;
  ombord_ab_1_Adv = mkAdv "ombord" ;
  omedelbums_ab_1_Adv = mkAdv "omedelbums" ;
  omgaaende_ab_1_1_Adv = mkAdv "omgående" ;
  omigen_ab_1_Adv = mkAdv "omigen" ;
  omintet_ab_1_Adv = mkAdv "omintet" ;
  omkring_ab_1_Adv = mkAdv "omkring" ;
  omkull_ab_1_Adv = mkAdv "omkull" ;
  omlott_ab_1_Adv = mkAdv "omlott" ;
  omsider_ab_1_Adv = mkAdv "omsider" ;
  omstyr_ab_1_Adv = mkAdv "omstyr" ;
  omsaender_ab_1_1_Adv = mkAdv "omsänder" ;
  omoejligen_ab_1_1_Adv = mkAdv "omöjligen" ;
  on_line_ab_1_Adv = mkAdv "on-line" ;
  onekligen_ab_1_Adv = mkAdv "onekligen" ;
  online_ab_1_Adv = mkAdv "online" ;
  onoedigtvis_ab_1_1_Adv = mkAdv "onödigtvis" ;
  opp_ab_1_Adv = mkAdv "opp" ;
  oppe_ab_1_Adv = mkAdv "oppe" ;
  oppemot_ab_1_Adv = mkAdv "oppemot" ;
  oppfoer_ab_1_1_Adv = mkAdv "oppför" ;
  oppifraan_ab_1_1_Adv = mkAdv "oppifrån" ;
  oppochned_ab_1_Adv = mkAdv "oppochned" ;
  oppochner_ab_1_Adv = mkAdv "oppochner" ;
  oppstroems_ab_1_1_Adv = mkAdv "oppströms" ;
  oppaaned_ab_1_1_Adv = mkAdv "oppåned" ;
  oppaaner_ab_1_1_Adv = mkAdv "oppåner" ;
  oppaat_ab_1_1_Adv = mkAdv "oppåt" ;
  ost_ab_1_Adv = mkAdv "ost" ;
  ostanfraan_ab_1_1_Adv = mkAdv "ostanfrån" ;
  ostanifraan_ab_1_1_Adv = mkAdv "ostanifrån" ;
  ostnordost_ab_1_Adv = mkAdv "ostnordost" ;
  ostsydost_ab_1_Adv = mkAdv "ostsydost" ;
  ostvart_ab_1_Adv = mkAdv "ostvart" ;
  osoekt_ab_1_1_Adv = mkAdv "osökt" ;
  otillboerligen_ab_1_1_Adv = mkAdv "otillbörligen" ;
  otroligt_ab_1_Adv = mkAdv "otroligt" ;
  oundgaengligen_ab_1_1_Adv = mkAdv "oundgängligen" ;
  oundvikligen_ab_1_Adv = mkAdv "oundvikligen" ;
  oupphoerligen_ab_1_1_Adv = mkAdv "oupphörligen" ;
  oupploesligen_ab_1_1_Adv = mkAdv "oupplösligen" ;
  ovan_ab_1_Adv = mkAdv "ovan" ;
  ovanbemaelda_av_1_1_A = mkA "ovanbemälda" ;
  ovanbemaelta_av_1_1_A = mkA "ovanbemälta" ;
  ovanbords_ab_1_Adv = mkAdv "ovanbords" ;
  ovanfoer_ab_1_1_Adv = mkAdv "ovanför" ;
  ovanifraan_ab_1_1_Adv = mkAdv "ovanifrån" ;
  ovanpaa_ab_1_1_Adv = mkAdv "ovanpå" ;
  ovantill_ab_1_Adv = mkAdv "ovantill" ;
  ovedersaegligen_ab_1_1_Adv = mkAdv "ovedersägligen" ;
  ovillkorligen_ab_1_Adv = mkAdv "ovillkorligen" ;
  oaaterkalleligen_ab_1_1_Adv = mkAdv "oåterkalleligen" ;
  parlando_ab_1_Adv = mkAdv "parlando" ;
  partout_ab_1_Adv = mkAdv "partout" ;
  parvis_ab_1_Adv = mkAdv "parvis" ;
  periodvis_ab_1_Adv = mkAdv "periodvis" ;
  personligen_ab_1_Adv = mkAdv "personligen" ;
  pianissimo_ab_1_Adv = mkAdv "pianissimo" ;
  piano_ab_1_Adv = mkAdv "piano" ;
  pin_ab_1_Adv = mkAdv "pin" ;
  pizzicato_ab_1_Adv = mkAdv "pizzicato" ;
  pladask_ab_1_Adv = mkAdv "pladask" ;
  platt_ab_1_Adv = mkAdv "platt" ;
  ploetsligen_ab_1_1_Adv = mkAdv "plötsligen" ;
  precis_ab_1_Adv = mkAdv "precis" ;
  presto_ab_1_Adv = mkAdv "presto" ;
  prick_ab_1_Adv = mkAdv "prick" ;
  privatim_ab_1_Adv = mkAdv "privatim" ;
  prompt_ab_1_Adv = mkAdv "prompt" ;
  punktvis_ab_1_Adv = mkAdv "punktvis" ;
  pyrt_ab_1_Adv = mkAdv "pyrt" ;
  paa_ab_1_1_Adv = mkAdv "på" ;
  realiter_ab_1_Adv = mkAdv "realiter" ;
  redan_ab_1_Adv = mkAdv "redan" ;
  redligen_ab_1_Adv = mkAdv "redligen" ;
  relativt_ab_1_Adv = mkAdv "relativt" ;
  ren_ab_1_Adv = mkAdv "ren" ;
  rentav_ab_1_Adv = mkAdv "rentav" ;
  rentut_ab_1_Adv = mkAdv "rentut" ;
  rentutav_ab_1_Adv = mkAdv "rentutav" ;
  reverenter_ab_1_Adv = mkAdv "reverenter" ;
  rikligen_ab_1_Adv = mkAdv "rikligen" ;
  rimligen_ab_1_Adv = mkAdv "rimligen" ;
  rimligtvis_ab_1_Adv = mkAdv "rimligtvis" ;
  ritardando_ab_1_Adv = mkAdv "ritardando" ;
  runt_ab_1_Adv = mkAdv "runt" ;
  runtikring_ab_1_Adv = mkAdv "runtikring" ;
  runtom_ab_1_Adv = mkAdv "runtom" ;
  runtomkring_ab_1_Adv = mkAdv "runtomkring" ;
  ryckvis_ab_1_Adv = mkAdv "ryckvis" ;
  rykande_ab_1_Adv = mkAdv "rykande" ;
  raett_ab_1_1_Adv = mkAdv "rätt" ;
  raetteligen_ab_1_1_Adv = mkAdv "rätteligen" ;
  sakloest_ab_1_1_Adv = mkAdv "saklöst" ;
  sakta_ab_1_Adv = mkAdv "sakta" ;
  sakteliga_ab_1_Adv = mkAdv "sakteliga" ;
  sakteligen_ab_1_Adv = mkAdv "sakteligen" ;
  saligen_ab_1_Adv = mkAdv "saligen" ;
  sammaledes_ab_1_Adv = mkAdv "sammaledes" ;
  sammalunda_ab_1_Adv = mkAdv "sammalunda" ;
  samman_ab_1_Adv = mkAdv "samman" ;
  sammanfattningsvis_ab_1_Adv = mkAdv "sammanfattningsvis" ;
  sammastaedes_ab_1_1_Adv = mkAdv "sammastädes" ;
  sannerligen_ab_1_Adv = mkAdv "sannerligen" ;
  scherzando_ab_1_Adv = mkAdv "scherzando" ;
  sedan_ab_1_Adv = mkAdv "sedan" ;
  sedermera_ab_1_Adv = mkAdv "sedermera" ;
  sen_ab_1_Adv = mkAdv "sen" ;
  senare_ab_1_Adv = mkAdv "senare" ;
  senast_ab_1_Adv = mkAdv "senast" ;
  separatim_ab_1_Adv = mkAdv "separatim" ;
  sforzando_ab_1_Adv = mkAdv "sforzando" ;
  sic_ab_1_Adv = mkAdv "sic" ;
  sidledes_ab_1_Adv = mkAdv "sidledes" ;
  sidlaenges_ab_1_1_Adv = mkAdv "sidlänges" ;
  sinsemellan_ab_1_Adv = mkAdv "sinsemellan" ;
  sist_ab_1_Adv = mkAdv "sist" ;
  sista_av_1_A = mkA "sista" ;
  sistbemaelda_av_1_1_A = mkA "sistbemälda" ;
  sistbemaelta_av_1_1_A = mkA "sistbemälta" ;
  sistens_ab_1_Adv = mkAdv "sistens" ;
  sistnaemnda_av_1_1_A = mkA "sistnämnda" ;
  sisaadaer_ab_1_1_Adv = mkAdv "sisådär" ;
  sjuckert_ab_1_Adv = mkAdv "sjuckert" ;
  sjuhelvetes_ab_1_Adv = mkAdv "sjuhelvetes" ;
  sjukt_ab_1_Adv = mkAdv "sjukt" ;
  sjusaerdeles_ab_1_1_Adv = mkAdv "sjusärdeles" ;
  sjaelsligen_ab_1_1_Adv = mkAdv "själsligen" ;
  sjaelvfallet_ab_1_1_Adv = mkAdv "självfallet" ;
  sjaelvmant_ab_1_1_Adv = mkAdv "självmant" ;
  sjoeledes_ab_1_1_Adv = mkAdv "sjöledes" ;
  skaffoettes_ab_1_1_Adv = mkAdv "skafföttes" ;
  skafoettes_ab_1_1_Adv = mkAdv "skaföttes" ;
  skamligen_ab_1_Adv = mkAdv "skamligen" ;
  skarpt_ab_1_Adv = mkAdv "skarpt" ;
  skavfoetters_ab_1_1_Adv = mkAdv "skavfötters" ;
  skedvis_ab_1_Adv = mkAdv "skedvis" ;
  skenbarligen_ab_1_Adv = mkAdv "skenbarligen" ;
  skriftligen_ab_1_Adv = mkAdv "skriftligen" ;
  skvatt_ab_1_Adv = mkAdv "skvatt" ;
  skymfligen_ab_1_Adv = mkAdv "skymfligen" ;
  skaeligen_ab_1_1_Adv = mkAdv "skäligen" ;
  skaendligen_ab_1_1_Adv = mkAdv "skändligen" ;
  slumpvis_ab_1_Adv = mkAdv "slumpvis" ;
  slutligen_ab_1_Adv = mkAdv "slutligen" ;
  smaaningom_ab_1_1_Adv = mkAdv "småningom" ;
  snarare_ab_1_Adv = mkAdv "snarare" ;
  snarast_ab_1_Adv = mkAdv "snarast" ;
  snarliga_ab_1_Adv = mkAdv "snarliga" ;
  snarligen_ab_1_Adv = mkAdv "snarligen" ;
  snart_ab_1_Adv = mkAdv "snart" ;
  solbrilledags_ab_1_Adv = mkAdv "solbrilledags" ;
  solraett_ab_1_1_Adv = mkAdv "solrätt" ;
  som_ab_1_Adv = mkAdv "som" ;
  sommartid_ab_1_Adv = mkAdv "sommartid" ;
  spik_ab_1_Adv = mkAdv "spik" ;
  splitt_ab_1_Adv = mkAdv "splitt" ;
  splitter_ab_1_Adv = mkAdv "splitter" ;
  spritt_ab_1_Adv = mkAdv "spritt" ;
  spraangvis_ab_1_1_Adv = mkAdv "språngvis" ;
  sta_ab_1_Adv = mkAdv "sta" ;
  stackato_ab_1_Adv = mkAdv "stackato" ;
  stegvis_ab_1_Adv = mkAdv "stegvis" ;
  still_ab_1_Adv = mkAdv "still" ;
  stilla_ab_1_Adv = mkAdv "stilla" ;
  stint_ab_1_Adv = mkAdv "stint" ;
  storliga_ab_1_Adv = mkAdv "storliga" ;
  storligen_ab_1_Adv = mkAdv "storligen" ;
  strax_ab_1_Adv = mkAdv "strax" ;
  straengeligen_ab_1_1_Adv = mkAdv "strängeligen" ;
  stundligen_ab_1_Adv = mkAdv "stundligen" ;
  stundom_ab_1_Adv = mkAdv "stundom" ;
  stundtals_ab_1_Adv = mkAdv "stundtals" ;
  stundvis_ab_1_Adv = mkAdv "stundvis" ;
  styckevis_ab_1_Adv = mkAdv "styckevis" ;
  styckvis_ab_1_Adv = mkAdv "styckvis" ;
  styrbord_ab_1_Adv = mkAdv "styrbord" ;
  staedse_ab_1_1_Adv = mkAdv "städse" ;
  stoert_ab_1_1_Adv = mkAdv "stört" ;
  stoetvis_ab_1_1_Adv = mkAdv "stötvis" ;
  svaara_ab_1_1_Adv = mkAdv "svåra" ;
  svaarligen_ab_1_1_Adv = mkAdv "svårligen" ;
  syd_ab_1_Adv = mkAdv "syd" ;
  sydost_ab_1_Adv = mkAdv "sydost" ;
  sydvart_ab_1_Adv = mkAdv "sydvart" ;
  sydvaest_ab_1_1_Adv = mkAdv "sydväst" ;
  sydoest_ab_1_1_Adv = mkAdv "sydöst" ;
  synbarligen_ab_1_Adv = mkAdv "synbarligen" ;
  synd_ab_1_Adv = mkAdv "synd" ;
  synnerligen_ab_1_Adv = mkAdv "synnerligen" ;
  saekerligen_ab_1_1_Adv = mkAdv "säkerligen" ;
  saellan_ab_1_1_Adv = mkAdv "sällan" ;
  saengdags_ab_1_1_Adv = mkAdv "sängdags" ;
  saerdeles_ab_1_1_Adv = mkAdv "särdeles" ;
  saerla_ab_1_1_Adv = mkAdv "särla" ;
  saerskilt_ab_1_1_Adv = mkAdv "särskilt" ;
  saesongsvis_ab_1_1_Adv = mkAdv "säsongsvis" ;
  saa_ab_1_1_Adv = mkAdv "så" ;
  saadaer_ab_1_1_Adv = mkAdv "sådär" ;
  saahaer_ab_1_1_Adv = mkAdv "såhär" ;
  saaklart_ab_1_1_Adv = mkAdv "såklart" ;
  saaledes_ab_1_1_Adv = mkAdv "således" ;
  saalunda_ab_1_1_Adv = mkAdv "sålunda" ;
  saanaer_ab_1_1_Adv = mkAdv "sånär" ;
  saapass_ab_1_1_Adv = mkAdv "såpass" ;
  saatillvida_ab_1_1_Adv = mkAdv "såtillvida" ;
  saavitt_ab_1_1_Adv = mkAdv "såvitt" ;
  saavael_ab_1_1_Adv = mkAdv "såväl" ;
  soeder_ab_1_1_Adv = mkAdv "söder" ;
  soederifraan_ab_1_1_Adv = mkAdv "söderifrån" ;
  soederut_ab_1_1_Adv = mkAdv "söderut" ;
  soederoever_ab_1_1_Adv = mkAdv "söderöver" ;
  soender_ab_1_1_Adv = mkAdv "sönder" ;
  tedags_ab_1_Adv = mkAdv "tedags" ;
  telefonledes_ab_1_Adv = mkAdv "telefonledes" ;
  tidigare_ab_1_Adv = mkAdv "tidigare" ;
  tidigast_ab_1_Adv = mkAdv "tidigast" ;
  tidtals_ab_1_Adv = mkAdv "tidtals" ;
  tidvis_ab_1_Adv = mkAdv "tidvis" ;
  till_ab_1_Adv = mkAdv "till" ;
  tillbaka_ab_1_Adv = mkAdv "tillbaka" ;
  tillbaks_ab_1_Adv = mkAdv "tillbaks" ;
  tillbuds_ab_1_Adv = mkAdv "tillbuds" ;
  tillboerligen_ab_1_1_Adv = mkAdv "tillbörligen" ;
  tilldels_ab_1_Adv = mkAdv "tilldels" ;
  tillfinnandes_ab_1_Adv = mkAdv "tillfinnandes" ;
  tillfullo_ab_1_Adv = mkAdv "tillfullo" ;
  tillfyllest_ab_1_Adv = mkAdv "tillfyllest" ;
  tillfaelligtvis_ab_1_1_Adv = mkAdv "tillfälligtvis" ;
  tillfoerne_ab_1_1_Adv = mkAdv "tillförne" ;
  tillgodo_ab_1_Adv = mkAdv "tillgodo" ;
  tillhanda_ab_1_Adv = mkAdv "tillhanda" ;
  tillhands_ab_1_Adv = mkAdv "tillhands" ;
  tillhopa_ab_1_Adv = mkAdv "tillhopa" ;
  tillika_ab_1_Adv = mkAdv "tillika" ;
  tillmoetes_ab_1_1_Adv = mkAdv "tillmötes" ;
  tillnaermelsevis_ab_1_1_Adv = mkAdv "tillnärmelsevis" ;
  tillpass_ab_1_Adv = mkAdv "tillpass" ;
  tillreds_ab_1_Adv = mkAdv "tillreds" ;
  tillraetta_ab_1_1_Adv = mkAdv "tillrätta" ;
  tillsamman_ab_1_Adv = mkAdv "tillsamman" ;
  tillsammans_ab_1_Adv = mkAdv "tillsammans" ;
  tillspillo_ab_1_Adv = mkAdv "tillspillo" ;
  tillstaedes_ab_1_1_Adv = mkAdv "tillstädes" ;
  tillsvidare_ab_1_Adv = mkAdv "tillsvidare" ;
  tillsynes_ab_1_Adv = mkAdv "tillsynes" ;
  tillviljes_ab_1_Adv = mkAdv "tillviljes" ;
  tillaenda_ab_1_1_Adv = mkAdv "tillända" ;
  tillaeventyrs_ab_1_1_Adv = mkAdv "tilläventyrs" ;
  timtals_ab_1_Adv = mkAdv "timtals" ;
  timvis_ab_1_Adv = mkAdv "timvis" ;
  tiofalt_ab_1_Adv = mkAdv "tiofalt" ;
  tjaenste_ab_1_1_Adv = mkAdv "tjänste" ;
  tonvis_ab_1_Adv = mkAdv "tonvis" ;
  totaliter_ab_1_Adv = mkAdv "totaliter" ;
  trefalt_ab_1_Adv = mkAdv "trefalt" ;
  troligen_ab_1_Adv = mkAdv "troligen" ;
  troligtvis_ab_1_Adv = mkAdv "troligtvis" ;
  turvis_ab_1_Adv = mkAdv "turvis" ;
  tusenfalt_ab_1_Adv = mkAdv "tusenfalt" ;
  tvivelsutan_ab_1_Adv = mkAdv "tvivelsutan" ;
  tvaers_ab_1_1_Adv = mkAdv "tvärs" ;
  tvaersemot_ab_1_1_Adv = mkAdv "tvärsemot" ;
  tvaersigenom_ab_1_1_Adv = mkAdv "tvärsigenom" ;
  tvaerskepps_ab_1_1_Adv = mkAdv "tvärskepps" ;
  tvaersom_ab_1_1_Adv = mkAdv "tvärsom" ;
  tvaersoever_ab_1_1_Adv = mkAdv "tvärsöver" ;
  tvaertemot_ab_1_1_Adv = mkAdv "tvärtemot" ;
  tvaertom_ab_1_1_Adv = mkAdv "tvärtom" ;
  tvaangsvis_ab_1_1_Adv = mkAdv "tvångsvis" ;
  tydligen_ab_1_Adv = mkAdv "tydligen" ;
  tydligtvis_ab_1_Adv = mkAdv "tydligtvis" ;
  typ_ab_1_Adv = mkAdv "typ" ;
  tyvaerr_ab_1_1_Adv = mkAdv "tyvärr" ;
  taemligen_ab_1_1_Adv = mkAdv "tämligen" ;
  toerhaenda_ab_1_1_Adv = mkAdv "törhända" ;
  ultimo_ab_1_Adv = mkAdv "ultimo" ;
  undan_ab_1_Adv = mkAdv "undan" ;
  undantagsvis_ab_1_Adv = mkAdv "undantagsvis" ;
  under_ab_1_Adv = mkAdv "under" ;
  underdaanigst_ab_1_1_Adv = mkAdv "underdånigst" ;
  underifraan_ab_1_1_Adv = mkAdv "underifrån" ;
  underst_ab_1_Adv = mkAdv "underst" ;
  understundom_ab_1_Adv = mkAdv "understundom" ;
  undertill_ab_1_Adv = mkAdv "undertill" ;
  undervaegs_ab_1_1_Adv = mkAdv "undervägs" ;
  ungefaer_ab_1_1_Adv = mkAdv "ungefär" ;
  ungefaerligen_ab_1_1_Adv = mkAdv "ungefärligen" ;
  upp_ab_1_Adv = mkAdv "upp" ;
  uppe_ab_1_Adv = mkAdv "uppe" ;
  uppemot_ab_1_Adv = mkAdv "uppemot" ;
  uppenbarligen_ab_1_Adv = mkAdv "uppenbarligen" ;
  uppepaa_ab_1_1_Adv = mkAdv "uppepå" ;
  uppfoer_ab_1_1_Adv = mkAdv "uppför" ;
  uppifraan_ab_1_1_Adv = mkAdv "uppifrån" ;
  upplysningsvis_ab_1_Adv = mkAdv "upplysningsvis" ;
  uppochned_ab_1_Adv = mkAdv "uppochned" ;
  uppochner_ab_1_Adv = mkAdv "uppochner" ;
  uppskattningsvis_ab_1_Adv = mkAdv "uppskattningsvis" ;
  uppstroems_ab_1_1_Adv = mkAdv "uppströms" ;
  uppsaatligen_ab_1_1_Adv = mkAdv "uppsåtligen" ;
  upptill_ab_1_Adv = mkAdv "upptill" ;
  uppaaned_ab_1_1_Adv = mkAdv "uppåned" ;
  uppaaner_ab_1_1_Adv = mkAdv "uppåner" ;
  uppaat_ab_1_1_Adv = mkAdv "uppåt" ;
  ur_ab_1_Adv = mkAdv "ur" ;
  urbota_ab_1_Adv = mkAdv "urbota" ;
  ursprungligen_ab_1_Adv = mkAdv "ursprungligen" ;
  ut_ab_1_Adv = mkAdv "ut" ;
  utanfoer_ab_1_1_Adv = mkAdv "utanför" ;
  utanpaa_ab_1_1_Adv = mkAdv "utanpå" ;
  utantill_ab_1_Adv = mkAdv "utantill" ;
  utav_ab_1_Adv = mkAdv "utav" ;
  ute_ab_1_Adv = mkAdv "ute" ;
  uteslutande_ab_1_Adv = mkAdv "uteslutande" ;
  utfoer_ab_1_1_Adv = mkAdv "utför" ;
  utifraan_ab_1_1_Adv = mkAdv "utifrån" ;
  utombords_ab_1_Adv = mkAdv "utombords" ;
  utombys_ab_1_Adv = mkAdv "utombys" ;
  utomhus_ab_1_Adv = mkAdv "utomhus" ;
  utomlands_ab_1_Adv = mkAdv "utomlands" ;
  utomskaers_ab_1_1_Adv = mkAdv "utomskärs" ;
  utrikes_ab_1_Adv = mkAdv "utrikes" ;
  utsocknes_ab_1_Adv = mkAdv "utsocknes" ;
  uttryckligen_ab_1_Adv = mkAdv "uttryckligen" ;
  utvaertes_ab_1_1_Adv = mkAdv "utvärtes" ;
  utaat_ab_1_1_Adv = mkAdv "utåt" ;
  vackert_ab_1_Adv = mkAdv "vackert" ;
  vad_ab_1_Adv = mkAdv "vad" ;
  vadan_ab_1_Adv = mkAdv "vadan" ;
  vadfalls_ab_1_Adv = mkAdv "vadfalls" ;
  vadaa_ab_1_1_Adv = mkAdv "vadå" ;
  vafalls_ab_1_Adv = mkAdv "vafalls" ;
  vajert_ab_1_Adv = mkAdv "vajert" ;
  vanligen_ab_1_Adv = mkAdv "vanligen" ;
  vanligtvis_ab_1_Adv = mkAdv "vanligtvis" ;
  vansinnigt_ab_1_Adv = mkAdv "vansinnigt" ;
  var_ab_1_Adv = mkAdv "var" ;
  varav_ab_1_Adv = mkAdv "varav" ;
  vardagsnaera_ab_1_1_Adv = mkAdv "vardagsnära" ;
  varefter_ab_1_Adv = mkAdv "varefter" ;
  varemot_ab_1_Adv = mkAdv "varemot" ;
  varest_ab_1_Adv = mkAdv "varest" ;
  varfoer_ab_1_1_Adv = mkAdv "varför" ;
  varfoere_ab_1_1_Adv = mkAdv "varföre" ;
  varhelst_ab_1_Adv = mkAdv "varhelst" ;
  vari_ab_1_Adv = mkAdv "vari" ;
  varibland_ab_1_Adv = mkAdv "varibland" ;
  varifraan_ab_1_1_Adv = mkAdv "varifrån" ;
  varigenom_ab_1_Adv = mkAdv "varigenom" ;
  varjaemte_ab_1_1_Adv = mkAdv "varjämte" ;
  varken_ab_1_Adv = mkAdv "varken" ;
  varliga_ab_1_Adv = mkAdv "varliga" ;
  varligen_ab_1_Adv = mkAdv "varligen" ;
  varmed_ab_1_Adv = mkAdv "varmed" ;
  varom_ab_1_Adv = mkAdv "varom" ;
  varpaa_ab_1_1_Adv = mkAdv "varpå" ;
  varsomhelst_ab_1_Adv = mkAdv "varsomhelst" ;
  vart_ab_1_Adv = mkAdv "vart" ;
  vartefter_ab_1_Adv = mkAdv "vartefter" ;
  varthelst_ab_1_Adv = mkAdv "varthelst" ;
  varthaen_ab_1_1_Adv = mkAdv "varthän" ;
  vartill_ab_1_Adv = mkAdv "vartill" ;
  vartsomhelst_ab_1_Adv = mkAdv "vartsomhelst" ;
  vartaat_ab_1_1_Adv = mkAdv "vartåt" ;
  varunder_ab_1_Adv = mkAdv "varunder" ;
  varur_ab_1_Adv = mkAdv "varur" ;
  varuti_ab_1_Adv = mkAdv "varuti" ;
  varutinnan_ab_1_Adv = mkAdv "varutinnan" ;
  varvid_ab_1_Adv = mkAdv "varvid" ;
  varvidlag_ab_1_Adv = mkAdv "varvidlag" ;
  varoever_ab_1_1_Adv = mkAdv "varöver" ;
  veckovis_ab_1_Adv = mkAdv "veckovis" ;
  vederboerligen_ab_1_1_Adv = mkAdv "vederbörligen" ;
  verbaliter_ab_1_Adv = mkAdv "verbaliter" ;
  verkligen_ab_1_Adv = mkAdv "verkligen" ;
  veterligen_ab_1_Adv = mkAdv "veterligen" ;
  veterligt_ab_1_Adv = mkAdv "veterligt" ;
  vi_ab_1_Adv = mkAdv "vi" ;
  vid_ab_1_Adv = mkAdv "vid" ;
  vida_ab_1_Adv = mkAdv "vida" ;
  vidare_ab_1_Adv = mkAdv "vidare" ;
  vidi_ab_1_Adv = mkAdv "vidi" ;
  vill_ab_1_Adv = mkAdv "vill" ;
  vilse_ab_1_Adv = mkAdv "vilse" ;
  vindraett_ab_1_1_Adv = mkAdv "vindrätt" ;
  vintertid_ab_1_Adv = mkAdv "vintertid" ;
  vips_ab_1_Adv = mkAdv "vips" ;
  visligen_ab_1_Adv = mkAdv "visligen" ;
  visserligen_ab_1_Adv = mkAdv "visserligen" ;
  visst_ab_1_Adv = mkAdv "visst" ;
  vivace_ab_1_Adv = mkAdv "vivace" ;
  vaeck_ab_1_1_Adv = mkAdv "väck" ;
  vael_ab_1_1_Adv = mkAdv "väl" ;
  vael_2_ab_1_1_Adv = mkAdv "väl" ;
  vaelan_ab_1_1_Adv = mkAdv "välan" ;
  vaeldans_ab_1_1_Adv = mkAdv "väldans" ;
  vaeldeliga_ab_1_1_Adv = mkAdv "väldeliga" ;
  vaeldeligen_ab_1_1_Adv = mkAdv "väldeligen" ;
  vaenligen_ab_1_1_Adv = mkAdv "vänligen" ;
  vaenskapligen_ab_1_1_Adv = mkAdv "vänskapligen" ;
  vaesentligen_ab_1_1_Adv = mkAdv "väsentligen" ;
  vaest_ab_1_1_Adv = mkAdv "väst" ;
  vaestan_ab_1_1_Adv = mkAdv "västan" ;
  vaestanhavs_ab_1_1_Adv = mkAdv "västanhavs" ;
  vaester_ab_1_1_Adv = mkAdv "väster" ;
  vaesterut_ab_1_1_Adv = mkAdv "västerut" ;
  vaestpaa_ab_1_1_Adv = mkAdv "västpå" ;
  vaestvart_ab_1_1_Adv = mkAdv "västvart" ;
  vaestoever_ab_1_1_Adv = mkAdv "västöver" ;
  vaexelvis_ab_1_1_Adv = mkAdv "växelvis" ;
  vaadligen_ab_1_1_Adv = mkAdv "vådligen" ;
  voerdsamligen_ab_1_1_Adv = mkAdv "vördsamligen" ;
  ytledes_ab_1_Adv = mkAdv "ytledes" ;
  ytterst_ab_1_Adv = mkAdv "ytterst" ;
  aen_ab_1_1_Adv = mkAdv "än" ;
  aenda_ab_1_1_Adv = mkAdv "ända" ;
  aendock_ab_1_1_Adv = mkAdv "ändock" ;
  aendaa_ab_1_1_Adv = mkAdv "ändå" ;
  aennu_ab_1_1_Adv = mkAdv "ännu" ;
  aentligen_ab_1_1_Adv = mkAdv "äntligen" ;
  aerligen_ab_1_1_Adv = mkAdv "ärligen" ;
  aeven_ab_1_1_Adv = mkAdv "även" ;
  aevenledes_ab_1_1_Adv = mkAdv "ävenledes" ;
  aevensaa_ab_1_1_Adv = mkAdv "ävenså" ;
  aanyo_ab_1_1_Adv = mkAdv "ånyo" ;
  aaretom_ab_1_1_Adv = mkAdv "åretom" ;
  aaretrunt_ab_1_1_Adv = mkAdv "åretrunt" ;
  aarligen_ab_1_1_Adv = mkAdv "årligen" ;
  aarsvis_ab_1_1_Adv = mkAdv "årsvis" ;
  aasido_ab_1_1_Adv = mkAdv "åsido" ;
  aastad_ab_1_1_Adv = mkAdv "åstad" ;
  aat_ab_1_1_Adv = mkAdv "åt" ;
  aater_ab_1_1_Adv = mkAdv "åter" ;
  aaterigen_ab_1_1_Adv = mkAdv "återigen" ;
  aatminstone_ab_1_1_Adv = mkAdv "åtminstone" ;
  aatskils_ab_1_1_Adv = mkAdv "åtskils" ;
  oegonaboej_ab_1_1_Adv = mkAdv "ögonaböj" ;
  oegonakroek_ab_1_1_Adv = mkAdv "ögonakrök" ;
  oegonblickligen_ab_1_1_Adv = mkAdv "ögonblickligen" ;
  oegonskenligen_ab_1_1_Adv = mkAdv "ögonskenligen" ;
  oemkligen_ab_1_1_Adv = mkAdv "ömkligen" ;
  oemsevis_ab_1_1_Adv = mkAdv "ömsevis" ;
  oemsom_ab_1_1_Adv = mkAdv "ömsom" ;
  oest_ab_1_1_Adv = mkAdv "öst" ;
  oestan_ab_1_1_Adv = mkAdv "östan" ;
  oester_ab_1_1_Adv = mkAdv "öster" ;
  oesterifraan_ab_1_1_Adv = mkAdv "österifrån" ;
  oesterut_ab_1_1_Adv = mkAdv "österut" ;
  oestpaa_ab_1_1_Adv = mkAdv "östpå" ;
  oestvart_ab_1_1_Adv = mkAdv "östvart" ;
  oestoever_ab_1_1_Adv = mkAdv "östöver" ;
  oever_ab_1_1_Adv = mkAdv "över" ;
  oeverallt_ab_1_1_Adv = mkAdv "överallt" ;
  oeveralltifraan_ab_1_1_Adv = mkAdv "överalltifrån" ;
  oeverbord_ab_1_1_Adv = mkAdv "överbord" ;
  oevergaangsvis_ab_1_1_Adv = mkAdv "övergångsvis" ;
  oeverhuvud_ab_1_1_Adv = mkAdv "överhuvud" ;
  oeverhuvudtaget_ab_1_1_Adv = mkAdv "överhuvudtaget" ;
  oeverhoevan_ab_1_1_Adv = mkAdv "överhövan" ;
  oeverlag_ab_1_1_Adv = mkAdv "överlag" ;
  oeverljutt_ab_1_1_Adv = mkAdv "överljutt" ;
  oevermaattan_ab_1_1_Adv = mkAdv "övermåttan" ;
  oevernog_ab_1_1_Adv = mkAdv "övernog" ;
  oeverst_ab_1_1_Adv = mkAdv "överst" ;
  oeveraenda_ab_1_1_Adv = mkAdv "överända" ;
  oevertygad_av_1_1_A = compoundA (regA "övertygad") ;
  oeversaallad_av_1_1_A = compoundA (regA "översållad") ;
  oeverstoekad_av_1_1_A = compoundA (regA "överstökad") ;
  oeverspelad_av_1_1_A = compoundA (regA "överspelad") ;
  oeversnoead_av_1_1_A = compoundA (regA "översnöad") ;
  oeverriggad_av_1_1_A = compoundA (regA "överriggad") ;
  oeverrepresenterad_av_1_1_A = compoundA (regA "överrepresenterad") ;
  oeverreklamerad_av_1_1_A = compoundA (regA "överreklamerad") ;
  oeverraskad_av_1_1_A = compoundA (regA "överraskad") ;
  oeverordnad_av_1_1_A = compoundA (regA "överordnad") ;
  oeverlastad_av_1_1_A = compoundA (regA "överlastad") ;
  oeverkvalificerad_av_1_1_A = compoundA (regA "överkvalificerad") ;
  oeverilad_av_1_1_A = compoundA (regA "överilad") ;
  oeverhopad_av_1_1_A = compoundA (regA "överhopad") ;
  oeverfoerfriskad_av_1_1_A = compoundA (regA "överförfriskad") ;
  oeverbelastad_av_1_1_A = compoundA (regA "överbelastad") ;
  oeverbegaavad_av_1_1_A = compoundA (regA "överbegåvad") ;
  oeverbefolkad_av_1_1_A = compoundA (regA "överbefolkad") ;
  oeverbalanserad_av_1_1_A = compoundA (regA "överbalanserad") ;
  oemhudad_av_1_1_A = compoundA (regA "ömhudad") ;
  oemhjaertad_av_1_1_A = compoundA (regA "ömhjärtad") ;
  oemfotad_av_1_1_A = compoundA (regA "ömfotad") ;
  oedesmaettad_av_1_1_A = compoundA (regA "ödesmättad") ;
  aatalad_av_1_1_A = compoundA (regA "åtalad") ;
  aarsgammal_av_1_1_A = compoundA (regA "årsgammal") ;
  aangestladdad_av_1_1_A = compoundA (regA "ångestladdad") ;
  aaldrad_av_1_1_A = compoundA (regA "åldrad") ;
  aaldersfoeraendrad_av_1_1_A = compoundA (regA "åldersförändrad") ;
  aaldersblandad_av_1_1_A = compoundA (regA "åldersblandad") ;
  aaderfoerkalkad_av_1_1_A = compoundA (regA "åderförkalkad") ;
  aerad_av_1_1_A = compoundA (regA "ärad") ;
  aeppelkindad_av_1_1_A = compoundA (regA "äppelkindad") ;
  aelskad_av_1_1_A = compoundA (regA "älskad") ;
  aeggskalsfaergad_av_1_1_A = compoundA (regA "äggskalsfärgad") ;
  aeggfaergad_av_1_1_A = compoundA (regA "äggfärgad") ;
  yrkesutbildad_av_1_A = compoundA (regA "yrkesutbildad") ;
  yrkesinriktad_av_1_A = compoundA (regA "yrkesinriktad") ;
  vaardskadad_av_1_1_A = compoundA (regA "vårdskadad") ;
  vaardad_av_1_1_A = compoundA (regA "vårdad") ;
  vaaldsplaagad_av_1_1_A = compoundA (regA "våldsplågad") ;
  vaagformad_av_1_1_A = compoundA (regA "vågformad") ;
  vaagad_av_1_1_A = compoundA (regA "vågad") ;
  vaaffelmoenstrad_av_1_1_A = compoundA (regA "våffelmönstrad") ;
  vaerdeladdad_av_1_1_A = compoundA (regA "värdeladdad") ;
  vaepnad_av_1_1_A = compoundA (regA "väpnad") ;
  vaelvaardad_av_1_1_A = compoundA (regA "välvårdad") ;
  vaelventilerad_av_1_1_A = compoundA (regA "välventilerad") ;
  vaelutvecklad_av_1_1_A = compoundA (regA "välutvecklad") ;
  vaelutrustad_av_1_1_A = compoundA (regA "välutrustad") ;
  vaelutbildad_av_1_1_A = compoundA (regA "välutbildad") ;
  vaeluppfostrad_av_1_1_A = compoundA (regA "väluppfostrad") ;
  vaeluniformerad_av_1_1_A = compoundA (regA "väluniformerad") ;
  vaelunderraettad_av_1_1_A = compoundA (regA "välunderrättad") ;
  vaelturnerad_av_1_1_A = compoundA (regA "välturnerad") ;
  vaeltuktad_av_1_1_A = compoundA (regA "vältuktad") ;
  vaeltraenad_av_1_1_A = compoundA (regA "vältränad") ;
  vaeltrimmad_av_1_1_A = compoundA (regA "vältrimmad") ;
  vaelsvarvad_av_1_1_A = compoundA (regA "välsvarvad") ;
  vaelstaedad_av_1_1_A = compoundA (regA "välstädad") ;
  vaelspaeckad_av_1_1_A = compoundA (regA "välspäckad") ;
  vaelspelad_av_1_1_A = compoundA (regA "välspelad") ;
  vaelsorterad_av_1_1_A = compoundA (regA "välsorterad") ;
  vaelskraeddad_av_1_1_A = compoundA (regA "välskräddad") ;
  vaelskapad_av_1_1_A = compoundA (regA "välskapad") ;
  vaelsituerad_av_1_1_A = compoundA (regA "välsituerad") ;
  vaelsinnad_av_1_1_A = compoundA (regA "välsinnad") ;
  vaelsignad_av_1_1_A = compoundA (regA "välsignad") ;
  vaelrustad_av_1_1_A = compoundA (regA "välrustad") ;
  vaelriktad_av_1_1_A = compoundA (regA "välriktad") ;
  vaelrenommerad_av_1_1_A = compoundA (regA "välrenommerad") ;
  vaelpressad_av_1_1_A = compoundA (regA "välpressad") ;
  vaelplaegad_av_1_1_A = compoundA (regA "välplägad") ;
  vaelorganiserad_av_1_1_A = compoundA (regA "välorganiserad") ;
  vaelordnad_av_1_1_A = compoundA (regA "välordnad") ;
  vaelondulerad_av_1_1_A = compoundA (regA "välondulerad") ;
  vaelmeriterad_av_1_1_A = compoundA (regA "välmeriterad") ;
  vaelmatad_av_1_1_A = compoundA (regA "välmatad") ;
  vaellyckad_av_1_1_A = compoundA (regA "vällyckad") ;
  vaellagrad_av_1_1_A = compoundA (regA "vällagrad") ;
  vaellagad_av_1_1_A = compoundA (regA "vällagad") ;
  vaelkryddad_av_1_1_A = compoundA (regA "välkryddad") ;
  vaelkammad_av_1_1_A = compoundA (regA "välkammad") ;
  vaelisolerad_av_1_1_A = compoundA (regA "välisolerad") ;
  vaelinformerad_av_1_1_A = compoundA (regA "välinformerad") ;
  vaelgrundad_av_1_1_A = compoundA (regA "välgrundad") ;
  vaelfoerraettad_av_1_1_A = compoundA (regA "välförrättad") ;
  vaelfriserad_av_1_1_A = compoundA (regA "välfriserad") ;
  vaelformad_av_1_1_A = compoundA (regA "välformad") ;
  vaeldaterad_av_1_1_A = compoundA (regA "väldaterad") ;
  vaelbaergad_av_1_1_A = compoundA (regA "välbärgad") ;
  vaelborstad_av_1_1_A = compoundA (regA "välborstad") ;
  vaelbildad_av_1_1_A = compoundA (regA "välbildad") ;
  vaelbevarad_av_1_1_A = compoundA (regA "välbevarad") ;
  vaelberaeknad_av_1_1_A = compoundA (regA "välberäknad") ;
  vaelbeproevad_av_1_1_A = compoundA (regA "välbeprövad") ;
  vaelbemedlad_av_1_1_A = compoundA (regA "välbemedlad") ;
  vaelbefogad_av_1_1_A = compoundA (regA "välbefogad") ;
  vaelbalanserad_av_1_1_A = compoundA (regA "välbalanserad") ;
  vaelavloenad_av_1_1_A = compoundA (regA "välavlönad") ;
  vaelartad_av_1_1_A = compoundA (regA "välartad") ;
  vaelansad_av_1_1_A = compoundA (regA "välansad") ;
  vaelanpassad_av_1_1_A = compoundA (regA "välanpassad") ;
  vaelaktad_av_1_1_A = compoundA (regA "välaktad") ;
  vrickad_av_1_A = compoundA (regA "vrickad") ;
  vredgad_av_1_A = compoundA (regA "vredgad") ;
  vittfoergrenad_av_1_1_A = compoundA (regA "vittförgrenad") ;
  vitslammad_av_1_A = compoundA (regA "vitslammad") ;
  vitputsad_av_1_A = compoundA (regA "vitputsad") ;
  vitnosad_av_1_A = compoundA (regA "vitnosad") ;
  vitmaalad_av_1_1_A = compoundA (regA "vitmålad") ;
  vitkindad_av_1_A = compoundA (regA "vitkindad") ;
  vitaminberikad_av_1_A = compoundA (regA "vitaminberikad") ;
  vinkelformad_av_1_A = compoundA (regA "vinkelformad") ;
  vingad_av_1_A = compoundA (regA "vingad") ;
  vinfaergad_av_1_1_A = compoundA (regA "vinfärgad") ;
  vindsopad_av_1_A = compoundA (regA "vindsopad") ;
  vindskyddad_av_1_A = compoundA (regA "vindskyddad") ;
  vindpinad_av_1_A = compoundA (regA "vindpinad") ;
  vimplad_av_1_A = compoundA (regA "vimplad") ;
  vidbraettad_av_1_1_A = compoundA (regA "vidbrättad") ;
  vertikalaxlad_av_1_A = compoundA (regA "vertikalaxlad") ;
  vertebrerad_av_1_A = compoundA (regA "vertebrerad") ;
  verserad_av_1_A = compoundA (regA "verserad") ;
  verklighetsbetonad_av_1_A = compoundA (regA "verklighetsbetonad") ;
  verklighetsbaserad_av_1_A = compoundA (regA "verklighetsbaserad") ;
  vedeldad_av_1_A = compoundA (regA "vedeldad") ;
  vedartad_av_1_A = compoundA (regA "vedartad") ;
  veckogammal_av_1_A = compoundA (regA "veckogammal") ;
  vaxartad_av_1_A = compoundA (regA "vaxartad") ;
  vattrad_av_1_A = compoundA (regA "vattrad") ;
  vattenbaserad_av_1_A = compoundA (regA "vattenbaserad") ;
  varmhjaertad_av_1_1_A = compoundA (regA "varmhjärtad") ;
  varmfoertennad_av_1_1_A = compoundA (regA "varmförtennad") ;
  vanskapad_av_1_A = compoundA (regA "vanskapad") ;
  vanryktad_av_1_A = compoundA (regA "vanryktad") ;
  vanlottad_av_1_A = compoundA (regA "vanlottad") ;
  vanartad_av_1_A = compoundA (regA "vanartad") ;
  valnoetsbetsad_av_1_1_A = compoundA (regA "valnötsbetsad") ;
  valmad_av_1_A = compoundA (regA "valmad") ;
  utaatriktad_av_1_1_A = compoundA (regA "utåtriktad") ;
  utvilad_av_1_A = compoundA (regA "utvilad") ;
  utvecklingshaemmad_av_1_1_A = compoundA (regA "utvecklingshämmad") ;
  utvecklad_av_1_A = compoundA (regA "utvecklad") ;
  utvakad_av_1_A = compoundA (regA "utvakad") ;
  uttunnad_av_1_A = compoundA (regA "uttunnad") ;
  uttroettad_av_1_1_A = compoundA (regA "uttröttad") ;
  uttraakad_av_1_1_A = compoundA (regA "uttråkad") ;
  uttjaenad_av_1_1_A = compoundA (regA "uttjänad") ;
  uttjatad_av_1_A = compoundA (regA "uttjatad") ;
  uttittad_av_1_A = compoundA (regA "uttittad") ;
  uttalad_av_1_A = compoundA (regA "uttalad") ;
  utsuddad_av_1_A = compoundA (regA "utsuddad") ;
  utstuderad_av_1_A = compoundA (regA "utstuderad") ;
  utstofferad_av_1_A = compoundA (regA "utstofferad") ;
  utspoekad_av_1_1_A = compoundA (regA "utspökad") ;
  utspekulerad_av_1_A = compoundA (regA "utspekulerad") ;
  utsparkad_av_1_A = compoundA (regA "utsparkad") ;
  utsmyckad_av_1_A = compoundA (regA "utsmyckad") ;
  utslaepad_av_1_1_A = compoundA (regA "utsläpad") ;
  utslocknad_av_1_A = compoundA (regA "utslocknad") ;
  utsjasad_av_1_A = compoundA (regA "utsjasad") ;
  utseendefixerad_av_1_A = compoundA (regA "utseendefixerad") ;
  utschasad_av_1_A = compoundA (regA "utschasad") ;
  utraeknad_av_1_1_A = compoundA (regA "uträknad") ;
  utrullad_av_1_A = compoundA (regA "utrullad") ;
  utrotningshotad_av_1_A = compoundA (regA "utrotningshotad") ;
  utriggad_av_1_A = compoundA (regA "utriggad") ;
  utrerad_av_1_A = compoundA (regA "utrerad") ;
  utpyntad_av_1_A = compoundA (regA "utpyntad") ;
  utpumpad_av_1_A = compoundA (regA "utpumpad") ;
  utpraeglad_av_1_1_A = compoundA (regA "utpräglad") ;
  utposterad_av_1_A = compoundA (regA "utposterad") ;
  utpinad_av_1_A = compoundA (regA "utpinad") ;
  utmaerglad_av_1_1_A = compoundA (regA "utmärglad") ;
  utmattad_av_1_A = compoundA (regA "utmattad") ;
  utlevad_av_1_A = compoundA (regA "utlevad") ;
  utkorad_av_1_A = compoundA (regA "utkorad") ;
  uthungrad_av_1_A = compoundA (regA "uthungrad") ;
  utgammal_av_1_A = compoundA (regA "utgammal") ;
  utfestad_av_1_A = compoundA (regA "utfestad") ;
  utbuktad_av_1_A = compoundA (regA "utbuktad") ;
  utbuad_av_1_A = compoundA (regA "utbuad") ;
  utblottad_av_1_A = compoundA (regA "utblottad") ;
  utblommad_av_1_A = compoundA (regA "utblommad") ;
  utarmad_av_1_A = compoundA (regA "utarmad") ;
  utarbetad_av_1_A = compoundA (regA "utarbetad") ;
  utagerad_av_1_A = compoundA (regA "utagerad") ;
  urvattnad_av_1_A = compoundA (regA "urvattnad") ;
  urtvaettad_av_1_1_A = compoundA (regA "urtvättad") ;
  urspaarad_av_1_1_A = compoundA (regA "urspårad") ;
  urskaalad_av_1_1_A = compoundA (regA "urskålad") ;
  urringad_av_1_A = compoundA (regA "urringad") ;
  urnformad_av_1_A = compoundA (regA "urnformad") ;
  urlakad_av_1_A = compoundA (regA "urlakad") ;
  urkramad_av_1_A = compoundA (regA "urkramad") ;
  urkopplad_av_1_A = compoundA (regA "urkopplad") ;
  urbenad_av_1_A = compoundA (regA "urbenad") ;
  uppaatriktad_av_1_1_A = compoundA (regA "uppåtriktad") ;
  uppaatkammad_av_1_1_A = compoundA (regA "uppåtkammad") ;
  uppvilad_av_1_A = compoundA (regA "uppvilad") ;
  upptrampad_av_1_A = compoundA (regA "upptrampad") ;
  uppstyltad_av_1_A = compoundA (regA "uppstyltad") ;
  uppstoppad_av_1_A = compoundA (regA "uppstoppad") ;
  uppstaplad_av_1_A = compoundA (regA "uppstaplad") ;
  uppspaerrad_av_1_1_A = compoundA (regA "uppspärrad") ;
  uppspetad_av_1_A = compoundA (regA "uppspetad") ;
  uppslitsad_av_1_A = compoundA (regA "uppslitsad") ;
  uppslammad_av_1_A = compoundA (regA "uppslammad") ;
  uppslaktad_av_1_A = compoundA (regA "uppslaktad") ;
  uppskoertad_av_1_1_A = compoundA (regA "uppskörtad") ;
  uppskaerrad_av_1_1_A = compoundA (regA "uppskärrad") ;
  uppskruvad_av_1_A = compoundA (regA "uppskruvad") ;
  uppskojad_av_1_A = compoundA (regA "uppskojad") ;
  uppskakad_av_1_A = compoundA (regA "uppskakad") ;
  uppretad_av_1_A = compoundA (regA "uppretad") ;
  upprepad_av_1_A = compoundA (regA "upprepad") ;
  uppmaalad_av_1_1_A = compoundA (regA "uppmålad") ;
  uppmaerksammad_av_1_1_A = compoundA (regA "uppmärksammad") ;
  uppluckrad_av_1_A = compoundA (regA "uppluckrad") ;
  upplandad_av_1_A = compoundA (regA "upplandad") ;
  uppladdad_av_1_A = compoundA (regA "uppladdad") ;
  uppkavlad_av_1_A = compoundA (regA "uppkavlad") ;
  uppkammad_av_1_A = compoundA (regA "uppkammad") ;
  uppjagad_av_1_A = compoundA (regA "uppjagad") ;
  uppiskad_av_1_A = compoundA (regA "uppiskad") ;
  upphetsad_av_1_A = compoundA (regA "upphetsad") ;
  uppgummad_av_1_A = compoundA (regA "uppgummad") ;
  uppeldad_av_1_A = compoundA (regA "uppeldad") ;
  uppdiktad_av_1_A = compoundA (regA "uppdiktad") ;
  uppblandad_av_1_A = compoundA (regA "uppblandad") ;
  uniformerad_av_1_A = compoundA (regA "uniformerad") ;
  underutvecklad_av_1_A = compoundA (regA "underutvecklad") ;
  undertecknad_av_1_A = compoundA (regA "undertecknad") ;
  understimulerad_av_1_A = compoundA (regA "understimulerad") ;
  underrepresenterad_av_1_A = compoundA (regA "underrepresenterad") ;
  underordnad_av_1_A = compoundA (regA "underordnad") ;
  underinformerad_av_1_A = compoundA (regA "underinformerad") ;
  underfinansierad_av_1_A = compoundA (regA "underfinansierad") ;
  underbemannad_av_1_A = compoundA (regA "underbemannad") ;
  underbefolkad_av_1_A = compoundA (regA "underbefolkad") ;
  undanstoekad_av_1_1_A = compoundA (regA "undanstökad") ;
  undanstoppad_av_1_A = compoundA (regA "undanstoppad") ;
  ugnstillagad_av_1_A = compoundA (regA "ugnstillagad") ;
  ugnslagad_av_1_A = compoundA (regA "ugnslagad") ;
  u_formad_av_1_A = compoundA (regA "u-formad") ;
  taettbefolkad_av_1_1_A = compoundA (regA "tättbefolkad") ;
  taetplacerad_av_1_1_A = compoundA (regA "tätplacerad") ;
  tvaatungad_av_1_1_A = compoundA (regA "tvåtungad") ;
  tvaangsvaervad_av_1_1_A = compoundA (regA "tvångsvärvad") ;
  tvaamastad_av_1_1_A = compoundA (regA "tvåmastad") ;
  tvaakoenad_av_1_1_A = compoundA (regA "tvåkönad") ;
  tvaafaergad_av_1_1_A = compoundA (regA "tvåfärgad") ;
  tvaadelad_av_1_1_A = compoundA (regA "tvådelad") ;
  tvaerfoerbannad_av_1_1_A = compoundA (regA "tvärförbannad") ;
  tvehoevdad_av_1_1_A = compoundA (regA "tvehövdad") ;
  tveeggad_av_1_A = compoundA (regA "tveeggad") ;
  tuvad_av_1_A = compoundA (regA "tuvad") ;
  tusenhoevdad_av_1_1_A = compoundA (regA "tusenhövdad") ;
  turkosfaergad_av_1_1_A = compoundA (regA "turkosfärgad") ;
  tunnhudad_av_1_A = compoundA (regA "tunnhudad") ;
  tunggumpad_av_1_A = compoundA (regA "tunggumpad") ;
  tungfotad_av_1_A = compoundA (regA "tungfotad") ;
  tungarbetad_av_1_A = compoundA (regA "tungarbetad") ;
  tumultartad_av_1_A = compoundA (regA "tumultartad") ;
  tuftad_av_1_A = compoundA (regA "tuftad") ;
  troegfattad_av_1_1_A = compoundA (regA "trögfattad") ;
  traangbroestad_av_1_1_A = compoundA (regA "trångbröstad") ;
  traeffad_av_1_1_A = compoundA (regA "träffad") ;
  trolovad_av_1_A = compoundA (regA "trolovad") ;
  trohjaertad_av_1_1_A = compoundA (regA "trohjärtad") ;
  tretungad_av_1_A = compoundA (regA "tretungad") ;
  tremastad_av_1_A = compoundA (regA "tremastad") ;
  treledad_av_1_A = compoundA (regA "treledad") ;
  trehoevdad_av_1_1_A = compoundA (regA "trehövdad") ;
  tredelad_av_1_A = compoundA (regA "tredelad") ;
  trappstegsformad_av_1_A = compoundA (regA "trappstegsformad") ;
  trakterad_av_1_A = compoundA (regA "trakterad") ;
  trafikseparerad_av_1_A = compoundA (regA "trafikseparerad") ;
  trafikdoedad_av_1_1_A = compoundA (regA "trafikdödad") ;
  torrladdad_av_1_A = compoundA (regA "torrladdad") ;
  toppmatad_av_1_A = compoundA (regA "toppmatad") ;
  togolesiskflaggad_av_1_A = compoundA (regA "togolesiskflaggad") ;
  tjockmagad_av_1_A = compoundA (regA "tjockmagad") ;
  tjockhudad_av_1_A = compoundA (regA "tjockhudad") ;
  tillyxad_av_1_A = compoundA (regA "tillyxad") ;
  tillvaextorienterad_av_1_1_A = compoundA (regA "tillväxtorienterad") ;
  tilltufsad_av_1_A = compoundA (regA "tilltufsad") ;
  tilltrasslad_av_1_A = compoundA (regA "tilltrasslad") ;
  tillstukad_av_1_A = compoundA (regA "tillstukad") ;
  tillspetsad_av_1_A = compoundA (regA "tillspetsad") ;
  tillskrynklad_av_1_A = compoundA (regA "tillskrynklad") ;
  tillrynkad_av_1_A = compoundA (regA "tillrynkad") ;
  tillrufsad_av_1_A = compoundA (regA "tillrufsad") ;
  tillproppad_av_1_A = compoundA (regA "tillproppad") ;
  tillplattad_av_1_A = compoundA (regA "tillplattad") ;
  tillkaempad_av_1_1_A = compoundA (regA "tillkämpad") ;
  tillkraanglad_av_1_1_A = compoundA (regA "tillkrånglad") ;
  tillkorkad_av_1_A = compoundA (regA "tillkorkad") ;
  tillknycklad_av_1_A = compoundA (regA "tillknycklad") ;
  tillfoerordnad_av_1_1_A = compoundA (regA "tillförordnad") ;
  tillbucklad_av_1_A = compoundA (regA "tillbucklad") ;
  tillbakalutad_av_1_A = compoundA (regA "tillbakalutad") ;
  tigrerad_av_1_A = compoundA (regA "tigrerad") ;
  tidsbegraensad_av_1_1_A = compoundA (regA "tidsbegränsad") ;
  testosteronpumpad_av_1_A = compoundA (regA "testosteronpumpad") ;
  tempererad_av_1_A = compoundA (regA "tempererad") ;
  teknikanpassad_av_1_A = compoundA (regA "teknikanpassad") ;
  tegelmurad_av_1_A = compoundA (regA "tegelmurad") ;
  tegelfaergad_av_1_1_A = compoundA (regA "tegelfärgad") ;
  tecknad_av_1_A = compoundA (regA "tecknad") ;
  teaterintresserad_av_1_A = compoundA (regA "teaterintresserad") ;
  tandad_av_1_A = compoundA (regA "tandad") ;
  tallriksformad_av_1_A = compoundA (regA "tallriksformad") ;
  taggad_av_1_A = compoundA (regA "taggad") ;
  soenderaelskad_av_1_1_A = compoundA (regA "sönderälskad") ;
  soendertrasad_av_1_1_A = compoundA (regA "söndertrasad") ;
  soenderspekulerad_av_1_1_A = compoundA (regA "sönderspekulerad") ;
  soenderrostad_av_1_1_A = compoundA (regA "sönderrostad") ;
  soenderplockad_av_1_1_A = compoundA (regA "sönderplockad") ;
  saagtandad_av_1_1_A = compoundA (regA "sågtandad") ;
  saerpraeglad_av_1_1_A = compoundA (regA "särpräglad") ;
  saegenomsusad_av_1_1_A = compoundA (regA "sägenomsusad") ;
  syrad_av_1_A = compoundA (regA "syrad") ;
  synskadad_av_1_A = compoundA (regA "synskadad") ;
  synkoperad_av_1_A = compoundA (regA "synkoperad") ;
  svaaroevertraeffad_av_1_1_A = compoundA (regA "svåröverträffad") ;
  svaaruttalad_av_1_1_A = compoundA (regA "svåruttalad") ;
  svaarutrotad_av_1_1_A = compoundA (regA "svårutrotad") ;
  svaartolkad_av_1_1_A = compoundA (regA "svårtolkad") ;
  svaarstartad_av_1_1_A = compoundA (regA "svårstartad") ;
  svaarpratad_av_1_1_A = compoundA (regA "svårpratad") ;
  svaarobserverad_av_1_1_A = compoundA (regA "svårobserverad") ;
  svaarfoersvarad_av_1_1_A = compoundA (regA "svårförsvarad") ;
  svaarformulerad_av_1_1_A = compoundA (regA "svårformulerad") ;
  svaarfloertad_av_1_1_A = compoundA (regA "svårflörtad") ;
  svaarflirtad_av_1_1_A = compoundA (regA "svårflirtad") ;
  svaardiagnosticerad_av_1_1_A = compoundA (regA "svårdiagnosticerad") ;
  svaarbotad_av_1_1_A = compoundA (regA "svårbotad") ;
  svaarbemaestrad_av_1_1_A = compoundA (regA "svårbemästrad") ;
  svaarartad_av_1_1_A = compoundA (regA "svårartad") ;
  svaeltdrabbad_av_1_1_A = compoundA (regA "svältdrabbad") ;
  svunnen_av_1_A = compoundA (regA "svunnen") ;
  svensktillverkad_av_1_A = compoundA (regA "svensktillverkad") ;
  svenskregistrerad_av_1_A = compoundA (regA "svenskregistrerad") ;
  svartoxiderad_av_1_A = compoundA (regA "svartoxiderad") ;
  svartnaglad_av_1_A = compoundA (regA "svartnaglad") ;
  svartmaalad_av_1_1_A = compoundA (regA "svartmålad") ;
  svartmunnad_av_1_A = compoundA (regA "svartmunnad") ;
  svartlackerad_av_1_A = compoundA (regA "svartlackerad") ;
  svagartikulerad_av_1_A = compoundA (regA "svagartikulerad") ;
  stoertfoerbannad_av_1_1_A = compoundA (regA "störtförbannad") ;
  staalhaettad_av_1_1_A = compoundA (regA "stålhättad") ;
  staalbaagad_av_1_1_A = compoundA (regA "stålbågad") ;
  staalartad_av_1_1_A = compoundA (regA "stålartad") ;
  staedad_av_1_1_A = compoundA (regA "städad") ;
  styvnackad_av_1_A = compoundA (regA "styvnackad") ;
  studerad_av_1_A = compoundA (regA "studerad") ;
  stroemlinjeformad_av_1_1_A = compoundA (regA "strömlinjeformad") ;
  straalorsakad_av_1_1_A = compoundA (regA "strålorsakad") ;
  strumaartad_av_1_A = compoundA (regA "strumaartad") ;
  strimmad_av_1_A = compoundA (regA "strimmad") ;
  stridsutrustad_av_1_A = compoundA (regA "stridsutrustad") ;
  stridsmunderad_av_1_A = compoundA (regA "stridsmunderad") ;
  streckprickad_av_1_A = compoundA (regA "streckprickad") ;
  storstilad_av_1_A = compoundA (regA "storstilad") ;
  stormunnad_av_1_A = compoundA (regA "stormunnad") ;
  storkukad_av_1_A = compoundA (regA "storkukad") ;
  storbystad_av_1_A = compoundA (regA "storbystad") ;
  storbraettad_av_1_1_A = compoundA (regA "storbrättad") ;
  storartad_av_1_A = compoundA (regA "storartad") ;
  stjaernspaeckad_av_1_1_A = compoundA (regA "stjärnspäckad") ;
  stadgad_av_1_A = compoundA (regA "stadgad") ;
  sproejsad_av_1_1_A = compoundA (regA "spröjsad") ;
  spraakbaserad_av_1_1_A = compoundA (regA "språkbaserad") ;
  spritbegaavad_av_1_1_A = compoundA (regA "spritbegåvad") ;
  sportintresserad_av_1_A = compoundA (regA "sportintresserad") ;
  spolformad_av_1_A = compoundA (regA "spolformad") ;
  splittrad_av_1_A = compoundA (regA "splittrad") ;
  spiralgalaxformad_av_1_A = compoundA (regA "spiralgalaxformad") ;
  spiralformad_av_1_A = compoundA (regA "spiralformad") ;
  spindelvaevsmoenstrad_av_1_1_A = compoundA (regA "spindelvävsmönstrad") ;
  spikad_av_1_A = compoundA (regA "spikad") ;
  specialkomponerad_av_1_A = compoundA (regA "specialkomponerad") ;
  specialintresserad_av_1_A = compoundA (regA "specialintresserad") ;
  specialdestinerad_av_1_A = compoundA (regA "specialdestinerad") ;
  sparsmakad_av_1_A = compoundA (regA "sparsmakad") ;
  sorgkantad_av_1_A = compoundA (regA "sorgkantad") ;
  sorgbetonad_av_1_A = compoundA (regA "sorgbetonad") ;
  sommarvindsomfladdrad_av_1_A = compoundA (regA "sommarvindsomfladdrad") ;
  soignerad_av_1_A = compoundA (regA "soignerad") ;
  sofistikerad_av_1_A = compoundA (regA "sofistikerad") ;
  snoeblandad_av_1_1_A = compoundA (regA "snöblandad") ;
  snubbelfotad_av_1_A = compoundA (regA "snubbelfotad") ;
  snedtrampad_av_1_A = compoundA (regA "snedtrampad") ;
  snabblagad_av_1_A = compoundA (regA "snabblagad") ;
  snabbfotad_av_1_A = compoundA (regA "snabbfotad") ;
  smaamoenstrad_av_1_1_A = compoundA (regA "småmönstrad") ;
  smockad_av_1_A = compoundA (regA "smockad") ;
  smickrad_av_1_A = compoundA (regA "smickrad") ;
  smaragdfaergad_av_1_1_A = compoundA (regA "smaragdfärgad") ;
  slaettoppad_av_1_1_A = compoundA (regA "slättoppad") ;
  slaetstickad_av_1_1_A = compoundA (regA "slätstickad") ;
  slaetriggad_av_1_1_A = compoundA (regA "slätriggad") ;
  slaetrakad_av_1_1_A = compoundA (regA "slätrakad") ;
  slaetkammad_av_1_1_A = compoundA (regA "slätkammad") ;
  slumpartad_av_1_A = compoundA (regA "slumpartad") ;
  slottstappad_av_1_A = compoundA (regA "slottstappad") ;
  slokoerad_av_1_1_A = compoundA (regA "slokörad") ;
  slipad_av_1_A = compoundA (regA "slipad") ;
  slimmad_av_1_A = compoundA (regA "slimmad") ;
  skumpiskad_av_1_A = compoundA (regA "skumpiskad") ;
  skuldbelastad_av_1_A = compoundA (regA "skuldbelastad") ;
  skruvad_av_1_A = compoundA (regA "skruvad") ;
  skildkoenad_av_1_1_A = compoundA (regA "skildkönad") ;
  skiktad_av_1_A = compoundA (regA "skiktad") ;
  skickad_av_1_A = compoundA (regA "skickad") ;
  skattefinansierad_av_1_A = compoundA (regA "skattefinansierad") ;
  skarpslipad_av_1_A = compoundA (regA "skarpslipad") ;
  skarpladdad_av_1_A = compoundA (regA "skarpladdad") ;
  skandalomsusad_av_1_A = compoundA (regA "skandalomsusad") ;
  skandalartad_av_1_A = compoundA (regA "skandalartad") ;
  skakad_av_1_A = compoundA (regA "skakad") ;
  sjaelvpaahittad_av_1_1_A = compoundA (regA "självpåhittad") ;
  sjaelvfoervaallad_av_1_1_A = compoundA (regA "självförvållad") ;
  sjaelvdistanserad_av_1_1_A = compoundA (regA "självdistanserad") ;
  sjaelvcentrerad_av_1_1_A = compoundA (regA "självcentrerad") ;
  sjaelsbeslaektad_av_1_1_A = compoundA (regA "själsbesläktad") ;
  sjukdomsklassad_av_1_A = compoundA (regA "sjukdomsklassad") ;
  sjuarmad_av_1_A = compoundA (regA "sjuarmad") ;
  situerad_av_1_A = compoundA (regA "situerad") ;
  sinnesrubbad_av_1_A = compoundA (regA "sinnesrubbad") ;
  sinnesfoervirrad_av_1_1_A = compoundA (regA "sinnesförvirrad") ;
  sinnad_av_1_A = compoundA (regA "sinnad") ;
  silvrad_av_1_A = compoundA (regA "silvrad") ;
  silverstickad_av_1_A = compoundA (regA "silverstickad") ;
  silverfaergad_av_1_1_A = compoundA (regA "silverfärgad") ;
  silkestickad_av_1_A = compoundA (regA "silkestickad") ;
  silkesstickad_av_1_A = compoundA (regA "silkesstickad") ;
  signalreglerad_av_1_A = compoundA (regA "signalreglerad") ;
  sidoordnad_av_1_A = compoundA (regA "sidoordnad") ;
  sexfixerad_av_1_A = compoundA (regA "sexfixerad") ;
  sepiafaergad_av_1_1_A = compoundA (regA "sepiafärgad") ;
  sensationsbetonad_av_1_A = compoundA (regA "sensationsbetonad") ;
  senfaangad_av_1_1_A = compoundA (regA "senfångad") ;
  sekelgammal_av_1_A = compoundA (regA "sekelgammal") ;
  seglivad_av_1_A = compoundA (regA "seglivad") ;
  sansad_av_1_A = compoundA (regA "sansad") ;
  sandfaergad_av_1_1_A = compoundA (regA "sandfärgad") ;
  sandblandad_av_1_A = compoundA (regA "sandblandad") ;
  sammanslingrad_av_1_A = compoundA (regA "sammanslingrad") ;
  sammangyttrad_av_1_A = compoundA (regA "sammangyttrad") ;
  samlad_av_1_A = compoundA (regA "samlad") ;
  samkoenad_av_1_1_A = compoundA (regA "samkönad") ;
  samhaellsintresserad_av_1_1_A = compoundA (regA "samhällsintresserad") ;
  salongsberusad_av_1_A = compoundA (regA "salongsberusad") ;
  salmonellainfekterad_av_1_A = compoundA (regA "salmonellainfekterad") ;
  sakramentskad_av_1_A = compoundA (regA "sakramentskad") ;
  saffransfaergad_av_1_1_A = compoundA (regA "saffransfärgad") ;
  sadelformad_av_1_A = compoundA (regA "sadelformad") ;
  sabeltandad_av_1_A = compoundA (regA "sabeltandad") ;
  sabelformad_av_1_A = compoundA (regA "sabelformad") ;
  s_formad_av_1_A = compoundA (regA "s-formad") ;
  roestberaettigad_av_1_1_A = compoundA (regA "röstberättigad") ;
  roerelsehindrad_av_1_1_A = compoundA (regA "rörelsehindrad") ;
  roeksvaertad_av_1_1_A = compoundA (regA "röksvärtad") ;
  roekskadad_av_1_1_A = compoundA (regA "rökskadad") ;
  roekfaergad_av_1_1_A = compoundA (regA "rökfärgad") ;
  roedmaalad_av_1_1_A = compoundA (regA "rödmålad") ;
  roedkindad_av_1_1_A = compoundA (regA "rödkindad") ;
  roedkantad_av_1_1_A = compoundA (regA "rödkantad") ;
  raatacklad_av_1_1_A = compoundA (regA "råtacklad") ;
  raabarkad_av_1_1_A = compoundA (regA "råbarkad") ;
  raettsinnad_av_1_1_A = compoundA (regA "rättsinnad") ;
  raetstickad_av_1_1_A = compoundA (regA "rätstickad") ;
  raefflad_av_1_1_A = compoundA (regA "räfflad") ;
  raeddhaagad_av_1_1_A = compoundA (regA "räddhågad") ;
  ryggmaergsskadad_av_1_1_A = compoundA (regA "ryggmärgsskadad") ;
  rutinerad_av_1_A = compoundA (regA "rutinerad") ;
  rutad_av_1_A = compoundA (regA "rutad") ;
  rustad_av_1_A = compoundA (regA "rustad") ;
  ruppad_av_1_A = compoundA (regA "ruppad") ;
  rundstickad_av_1_A = compoundA (regA "rundstickad") ;
  rundslipad_av_1_A = compoundA (regA "rundslipad") ;
  rundhoevdad_av_1_1_A = compoundA (regA "rundhövdad") ;
  rundbottnad_av_1_A = compoundA (regA "rundbottnad") ;
  rundad_av_1_A = compoundA (regA "rundad") ;
  ruggad_av_1_A = compoundA (regA "ruggad") ;
  ruffad_av_1_A = compoundA (regA "ruffad") ;
  rubbad_av_1_A = compoundA (regA "rubbad") ;
  rotad_av_1_A = compoundA (regA "rotad") ;
  rostskyddsfaergad_av_1_1_A = compoundA (regA "rostskyddsfärgad") ;
  rostflaeckad_av_1_1_A = compoundA (regA "rostfläckad") ;
  rosenkindad_av_1_A = compoundA (regA "rosenkindad") ;
  rosafaergad_av_1_1_A = compoundA (regA "rosafärgad") ;
  rokokopyntad_av_1_A = compoundA (regA "rokokopyntad") ;
  road_av_1_A = compoundA (regA "road") ;
  rivningshotad_av_1_A = compoundA (regA "rivningshotad") ;
  ringfoerlovad_av_1_1_A = compoundA (regA "ringförlovad") ;
  ringformad_av_1_A = compoundA (regA "ringformad") ;
  ribbstickad_av_1_A = compoundA (regA "ribbstickad") ;
  ribbad_av_1_A = compoundA (regA "ribbad") ;
  retarderad_av_1_A = compoundA (regA "retarderad") ;
  resursorienterad_av_1_A = compoundA (regA "resursorienterad") ;
  resultatinriktad_av_1_A = compoundA (regA "resultatinriktad") ;
  resignerad_av_1_A = compoundA (regA "resignerad") ;
  reserverad_av_1_A = compoundA (regA "reserverad") ;
  renspolad_av_1_A = compoundA (regA "renspolad") ;
  rensopad_av_1_A = compoundA (regA "rensopad") ;
  renommerad_av_1_A = compoundA (regA "renommerad") ;
  renhjaertad_av_1_1_A = compoundA (regA "renhjärtad") ;
  reliefartad_av_1_A = compoundA (regA "reliefartad") ;
  rekordartad_av_1_A = compoundA (regA "rekordartad") ;
  reforminriktad_av_1_A = compoundA (regA "reforminriktad") ;
  reflekterad_av_1_A = compoundA (regA "reflekterad") ;
  rassegregerad_av_1_A = compoundA (regA "rassegregerad") ;
  rangerad_av_1_A = compoundA (regA "rangerad") ;
  randomiserad_av_1_A = compoundA (regA "randomiserad") ;
  rakryggad_av_1_A = compoundA (regA "rakryggad") ;
  raffinerad_av_1_A = compoundA (regA "raffinerad") ;
  paaverkad_av_1_1_A = compoundA (regA "påverkad") ;
  paaselad_av_1_1_A = compoundA (regA "påselad") ;
  paapaelsad_av_1_1_A = compoundA (regA "påpälsad") ;
  paapassad_av_1_1_A = compoundA (regA "påpassad") ;
  paakostad_av_1_1_A = compoundA (regA "påkostad") ;
  paahittad_av_1_1_A = compoundA (regA "påhittad") ;
  paerlspontad_av_1_1_A = compoundA (regA "pärlspontad") ;
  puckad_av_1_A = compoundA (regA "puckad") ;
  prunefaergad_av_1_1_A = compoundA (regA "prunefärgad") ;
  prostituerad_av_1_A = compoundA (regA "prostituerad") ;
  prononcerad_av_1_A = compoundA (regA "prononcerad") ;
  profilerad_av_1_A = compoundA (regA "profilerad") ;
  processinriktad_av_1_A = compoundA (regA "processinriktad") ;
  problemorienterad_av_1_A = compoundA (regA "problemorienterad") ;
  privilegierad_av_1_A = compoundA (regA "privilegierad") ;
  prismaformad_av_1_A = compoundA (regA "prismaformad") ;
  prestationsinriktad_av_1_A = compoundA (regA "prestationsinriktad") ;
  polyklorerad_av_1_A = compoundA (regA "polyklorerad") ;
  polyesterbaserad_av_1_A = compoundA (regA "polyesterbaserad") ;
  polerad_av_1_A = compoundA (regA "polerad") ;
  plymascherad_av_1_A = compoundA (regA "plymascherad") ;
  plattnaglad_av_1_A = compoundA (regA "plattnaglad") ;
  plattfotad_av_1_A = compoundA (regA "plattfotad") ;
  pistolformad_av_1_A = compoundA (regA "pistolformad") ;
  pistolbevaepnad_av_1_1_A = compoundA (regA "pistolbeväpnad") ;
  pisksnaertskadad_av_1_1_A = compoundA (regA "pisksnärtskadad") ;
  piskad_av_1_A = compoundA (regA "piskad") ;
  pigmenterad_av_1_A = compoundA (regA "pigmenterad") ;
  petroleumbaserad_av_1_A = compoundA (regA "petroleumbaserad") ;
  personfixerad_av_1_A = compoundA (regA "personfixerad") ;
  persikofaergad_av_1_1_A = compoundA (regA "persikofärgad") ;
  pepprad_av_1_A = compoundA (regA "pepprad") ;
  pedalmanoevrerad_av_1_1_A = compoundA (regA "pedalmanövrerad") ;
  patentstickad_av_1_A = compoundA (regA "patentstickad") ;
  patenterad_av_1_A = compoundA (regA "patenterad") ;
  pastellfaergad_av_1_1_A = compoundA (regA "pastellfärgad") ;
  passionerad_av_1_A = compoundA (regA "passionerad") ;
  passerad_av_1_A = compoundA (regA "passerad") ;
  parrimmad_av_1_A = compoundA (regA "parrimmad") ;
  pantad_av_1_A = compoundA (regA "pantad") ;
  panikartad_av_1_A = compoundA (regA "panikartad") ;
  packad_av_1_A = compoundA (regA "packad") ;
  ooevertraeffad_av_1_1_A = compoundA (regA "oöverträffad") ;
  ooenskad_av_1_1_A = compoundA (regA "oönskad") ;
  oaelskad_av_1_1_A = compoundA (regA "oälskad") ;
  ovaardad_av_1_1_A = compoundA (regA "ovårdad") ;
  ovaerderad_av_1_1_A = compoundA (regA "ovärderad") ;
  ovaepnad_av_1_1_A = compoundA (regA "oväpnad") ;
  ovaentad_av_1_1_A = compoundA (regA "oväntad") ;
  ovulkaniserad_av_1_A = compoundA (regA "ovulkaniserad") ;
  ovulgariserad_av_1_A = compoundA (regA "ovulgariserad") ;
  ovokaliserad_av_1_A = compoundA (regA "ovokaliserad") ;
  ovitaminiserad_av_1_A = compoundA (regA "ovitaminiserad") ;
  ovitaminerad_av_1_A = compoundA (regA "ovitaminerad") ;
  ovitaliserad_av_1_A = compoundA (regA "ovitaliserad") ;
  ovisualiserad_av_1_A = compoundA (regA "ovisualiserad") ;
  ovisiterad_av_1_A = compoundA (regA "ovisiterad") ;
  oviserad_av_1_A = compoundA (regA "oviserad") ;
  ovindicerad_av_1_A = compoundA (regA "ovindicerad") ;
  ovidimerad_av_1_A = compoundA (regA "ovidimerad") ;
  oversifierad_av_1_A = compoundA (regA "oversifierad") ;
  overifierad_av_1_A = compoundA (regA "overifierad") ;
  overbaliserad_av_1_A = compoundA (regA "overbaliserad") ;
  oventilerad_av_1_A = compoundA (regA "oventilerad") ;
  ovelouriserad_av_1_A = compoundA (regA "ovelouriserad") ;
  ovarierad_av_1_A = compoundA (regA "ovarierad") ;
  ovandaliserad_av_1_A = compoundA (regA "ovandaliserad") ;
  ovalverad_av_1_A = compoundA (regA "ovalverad") ;
  ovaluterad_av_1_A = compoundA (regA "ovaluterad") ;
  ovaksinerad_av_1_A = compoundA (regA "ovaksinerad") ;
  ovaggad_av_1_A = compoundA (regA "ovaggad") ;
  ovadderad_av_1_A = compoundA (regA "ovadderad") ;
  ovaccinerad_av_1_A = compoundA (regA "ovaccinerad") ;
  outvaerderad_av_1_1_A = compoundA (regA "outvärderad") ;
  outvecklad_av_1_A = compoundA (regA "outvecklad") ;
  outtaxerad_av_1_A = compoundA (regA "outtaxerad") ;
  outtalad_av_1_A = compoundA (regA "outtalad") ;
  outstofferad_av_1_A = compoundA (regA "outstofferad") ;
  outrangerad_av_1_A = compoundA (regA "outrangerad") ;
  outraderad_av_1_A = compoundA (regA "outraderad") ;
  outposterad_av_1_A = compoundA (regA "outposterad") ;
  outplacerad_av_1_A = compoundA (regA "outplacerad") ;
  outnyttjad_av_1_A = compoundA (regA "outnyttjad") ;
  outminuterad_av_1_A = compoundA (regA "outminuterad") ;
  outmanoevrerad_av_1_1_A = compoundA (regA "outmanövrerad") ;
  outlokaliserad_av_1_A = compoundA (regA "outlokaliserad") ;
  outkvitterad_av_1_A = compoundA (regA "outkvitterad") ;
  outkristalliserad_av_1_A = compoundA (regA "outkristalliserad") ;
  outkonkurrerad_av_1_A = compoundA (regA "outkonkurrerad") ;
  outkommenderad_av_1_A = compoundA (regA "outkommenderad") ;
  outklarerad_av_1_A = compoundA (regA "outklarerad") ;
  outforskad_av_1_A = compoundA (regA "outforskad") ;
  outexperimenterad_av_1_A = compoundA (regA "outexperimenterad") ;
  outexaminerad_av_1_A = compoundA (regA "outexaminerad") ;
  outdebiterad_av_1_A = compoundA (regA "outdebiterad") ;
  outbroderad_av_1_A = compoundA (regA "outbroderad") ;
  outbildad_av_1_A = compoundA (regA "outbildad") ;
  outbasunerad_av_1_A = compoundA (regA "outbasunerad") ;
  outbalanserad_av_1_A = compoundA (regA "outbalanserad") ;
  outarrenderad_av_1_A = compoundA (regA "outarrenderad") ;
  outannonserad_av_1_A = compoundA (regA "outannonserad") ;
  outackorderad_av_1_A = compoundA (regA "outackorderad") ;
  ousurperad_av_1_A = compoundA (regA "ousurperad") ;
  ourbaniserad_av_1_A = compoundA (regA "ourbaniserad") ;
  ouppoevad_av_1_1_A = compoundA (regA "ouppövad") ;
  ouppvaerderad_av_1_1_A = compoundA (regA "ouppvärderad") ;
  oupptaxerad_av_1_A = compoundA (regA "oupptaxerad") ;
  ouppsummerad_av_1_A = compoundA (regA "ouppsummerad") ;
  ouppreklamerad_av_1_A = compoundA (regA "ouppreklamerad") ;
  ouppklarad_av_1_A = compoundA (regA "ouppklarad") ;
  ouppjusterad_av_1_A = compoundA (regA "ouppjusterad") ;
  ouppgraderad_av_1_A = compoundA (regA "ouppgraderad") ;
  ouppfostrad_av_1_A = compoundA (regA "ouppfostrad") ;
  ouppdaterad_av_1_A = compoundA (regA "ouppdaterad") ;
  ouppackad_av_1_A = compoundA (regA "ouppackad") ;
  ouniformerad_av_1_A = compoundA (regA "ouniformerad") ;
  ounifierad_av_1_A = compoundA (regA "ounifierad") ;
  otyranniserad_av_1_A = compoundA (regA "otyranniserad") ;
  otypiserad_av_1_A = compoundA (regA "otypiserad") ;
  otypifierad_av_1_A = compoundA (regA "otypifierad") ;
  otyglad_av_1_A = compoundA (regA "otyglad") ;
  otvaettad_av_1_1_A = compoundA (regA "otvättad") ;
  otuscherad_av_1_A = compoundA (regA "otuscherad") ;
  oturnerad_av_1_A = compoundA (regA "oturnerad") ;
  otuperad_av_1_A = compoundA (regA "otuperad") ;
  otuktad_av_1_A = compoundA (regA "otuktad") ;
  otraenad_av_1_1_A = compoundA (regA "otränad") ;
  otryfferad_av_1_A = compoundA (regA "otryfferad") ;
  otrivialiserad_av_1_A = compoundA (regA "otrivialiserad") ;
  otrierad_av_1_A = compoundA (regA "otrierad") ;
  otriangulerad_av_1_A = compoundA (regA "otriangulerad") ;
  otrepanerad_av_1_A = compoundA (regA "otrepanerad") ;
  otravesterad_av_1_A = compoundA (regA "otravesterad") ;
  otrasserad_av_1_A = compoundA (regA "otrasserad") ;
  otransumerad_av_1_A = compoundA (regA "otransumerad") ;
  otransporterad_av_1_A = compoundA (regA "otransporterad") ;
  otransponerad_av_1_A = compoundA (regA "otransponerad") ;
  otransplanterad_av_1_A = compoundA (regA "otransplanterad") ;
  otransmuterad_av_1_A = compoundA (regA "otransmuterad") ;
  otransmitterad_av_1_A = compoundA (regA "otransmitterad") ;
  otranslittererad_av_1_A = compoundA (regA "otranslittererad") ;
  otranskriberad_av_1_A = compoundA (regA "otranskriberad") ;
  otransiterad_av_1_A = compoundA (regA "otransiterad") ;
  otransformerad_av_1_A = compoundA (regA "otransformerad") ;
  otransfererad_av_1_A = compoundA (regA "otransfererad") ;
  otrancherad_av_1_A = compoundA (regA "otrancherad") ;
  otrakterad_av_1_A = compoundA (regA "otrakterad") ;
  otrakasserad_av_1_A = compoundA (regA "otrakasserad") ;
  otrafikerad_av_1_A = compoundA (regA "otrafikerad") ;
  otraderad_av_1_A = compoundA (regA "otraderad") ;
  otouperad_av_1_A = compoundA (regA "otouperad") ;
  otoucherad_av_1_A = compoundA (regA "otoucherad") ;
  otorterad_av_1_A = compoundA (regA "otorterad") ;
  otorpederad_av_1_A = compoundA (regA "otorpederad") ;
  otorderad_av_1_A = compoundA (regA "otorderad") ;
  otolererad_av_1_A = compoundA (regA "otolererad") ;
  otitulerad_av_1_A = compoundA (regA "otitulerad") ;
  otitrerad_av_1_A = compoundA (regA "otitrerad") ;
  otippad_av_1_A = compoundA (regA "otippad") ;
  otestamenterad_av_1_A = compoundA (regA "otestamenterad") ;
  otesaurerad_av_1_A = compoundA (regA "otesaurerad") ;
  oterroriserad_av_1_A = compoundA (regA "oterroriserad") ;
  oterrasserad_av_1_A = compoundA (regA "oterrasserad") ;
  otenterad_av_1_A = compoundA (regA "otenterad") ;
  otempererad_av_1_A = compoundA (regA "otempererad") ;
  otemperad_av_1_A = compoundA (regA "otemperad") ;
  oteleviserad_av_1_A = compoundA (regA "oteleviserad") ;
  otelegraferad_av_1_A = compoundA (regA "otelegraferad") ;
  otelefonerad_av_1_A = compoundA (regA "otelefonerad") ;
  oteknifierad_av_1_A = compoundA (regA "oteknifierad") ;
  otaxerad_av_1_A = compoundA (regA "otaxerad") ;
  otatuerad_av_1_A = compoundA (regA "otatuerad") ;
  otarifferad_av_1_A = compoundA (regA "otarifferad") ;
  otarerad_av_1_A = compoundA (regA "otarerad") ;
  otapetserad_av_1_A = compoundA (regA "otapetserad") ;
  otangerad_av_1_A = compoundA (regA "otangerad") ;
  otandad_av_1_A = compoundA (regA "otandad") ;
  otamponerad_av_1_A = compoundA (regA "otamponerad") ;
  otabuerad_av_1_A = compoundA (regA "otabuerad") ;
  otabellerad_av_1_A = compoundA (regA "otabellerad") ;
  osoetad_av_1_1_A = compoundA (regA "osötad") ;
  osaaverad_av_1_1_A = compoundA (regA "osåverad") ;
  osaaterad_av_1_1_A = compoundA (regA "osåterad") ;
  osystematiserad_av_1_A = compoundA (regA "osystematiserad") ;
  osyrad_av_1_A = compoundA (regA "osyrad") ;
  osyntetiserad_av_1_A = compoundA (regA "osyntetiserad") ;
  osynkroniserad_av_1_A = compoundA (regA "osynkroniserad") ;
  osynkoperad_av_1_A = compoundA (regA "osynkoperad") ;
  osymboliserad_av_1_A = compoundA (regA "osymboliserad") ;
  osuspenderad_av_1_A = compoundA (regA "osuspenderad") ;
  osupponerad_av_1_A = compoundA (regA "osupponerad") ;
  osupplerad_av_1_A = compoundA (regA "osupplerad") ;
  osummerad_av_1_A = compoundA (regA "osummerad") ;
  osuggererad_av_1_A = compoundA (regA "osuggererad") ;
  osufflerad_av_1_A = compoundA (regA "osufflerad") ;
  osuffigerad_av_1_A = compoundA (regA "osuffigerad") ;
  osuccederad_av_1_A = compoundA (regA "osuccederad") ;
  osubventionerad_av_1_A = compoundA (regA "osubventionerad") ;
  osubtraherad_av_1_A = compoundA (regA "osubtraherad") ;
  osubsumerad_av_1_A = compoundA (regA "osubsumerad") ;
  osubstituerad_av_1_A = compoundA (regA "osubstituerad") ;
  osubstantiverad_av_1_A = compoundA (regA "osubstantiverad") ;
  osubskriberad_av_1_A = compoundA (regA "osubskriberad") ;
  osubsidierad_av_1_A = compoundA (regA "osubsidierad") ;
  osubordinerad_av_1_A = compoundA (regA "osubordinerad") ;
  osublimerad_av_1_A = compoundA (regA "osublimerad") ;
  ostaemplad_av_1_1_A = compoundA (regA "ostämplad") ;
  ostaedad_av_1_1_A = compoundA (regA "ostädad") ;
  ostyckad_av_1_A = compoundA (regA "ostyckad") ;
  ostuderad_av_1_A = compoundA (regA "ostuderad") ;
  ostrukturerad_av_1_A = compoundA (regA "ostrukturerad") ;
  ostratifierad_av_1_A = compoundA (regA "ostratifierad") ;
  ostrangulerad_av_1_A = compoundA (regA "ostrangulerad") ;
  ostraffad_av_1_A = compoundA (regA "ostraffad") ;
  ostofferad_av_1_A = compoundA (regA "ostofferad") ;
  ostipulerad_av_1_A = compoundA (regA "ostipulerad") ;
  ostipendierad_av_1_A = compoundA (regA "ostipendierad") ;
  ostimulerad_av_1_A = compoundA (regA "ostimulerad") ;
  ostiliserad_av_1_A = compoundA (regA "ostiliserad") ;
  ostigmatiserad_av_1_A = compoundA (regA "ostigmatiserad") ;
  osteriliserad_av_1_A = compoundA (regA "osteriliserad") ;
  ostereotyperad_av_1_A = compoundA (regA "ostereotyperad") ;
  ostenograferad_av_1_A = compoundA (regA "ostenograferad") ;
  ostencilerad_av_1_A = compoundA (regA "ostencilerad") ;
  ostatuerad_av_1_A = compoundA (regA "ostatuerad") ;
  ostationerad_av_1_A = compoundA (regA "ostationerad") ;
  ostandardiserad_av_1_A = compoundA (regA "ostandardiserad") ;
  ostagnerad_av_1_A = compoundA (regA "ostagnerad") ;
  ostafferad_av_1_A = compoundA (regA "ostafferad") ;
  ostabiliserad_av_1_A = compoundA (regA "ostabiliserad") ;
  ospaerrad_av_1_1_A = compoundA (regA "ospärrad") ;
  ospolierad_av_1_A = compoundA (regA "ospolierad") ;
  ospenderad_av_1_A = compoundA (regA "ospenderad") ;
  ospekulerad_av_1_A = compoundA (regA "ospekulerad") ;
  ospeciminerad_av_1_A = compoundA (regA "ospeciminerad") ;
  ospecificerad_av_1_A = compoundA (regA "ospecificerad") ;
  ospecialiserad_av_1_A = compoundA (regA "ospecialiserad") ;
  osparad_av_1_A = compoundA (regA "osparad") ;
  ospallerad_av_1_A = compoundA (regA "ospallerad") ;
  ospaljerad_av_1_A = compoundA (regA "ospaljerad") ;
  osovjetiserad_av_1_A = compoundA (regA "osovjetiserad") ;
  osoulagerad_av_1_A = compoundA (regA "osoulagerad") ;
  osorterad_av_1_A = compoundA (regA "osorterad") ;
  osordinerad_av_1_A = compoundA (regA "osordinerad") ;
  osonderad_av_1_A = compoundA (regA "osonderad") ;
  osolverad_av_1_A = compoundA (regA "osolverad") ;
  osocialiserad_av_1_A = compoundA (regA "osocialiserad") ;
  osminkad_av_1_A = compoundA (regA "osminkad") ;
  oslipad_av_1_A = compoundA (regA "oslipad") ;
  oslaviserad_av_1_A = compoundA (regA "oslaviserad") ;
  oslaktad_av_1_A = compoundA (regA "oslaktad") ;
  oskyddad_av_1_A = compoundA (regA "oskyddad") ;
  oskulpturerad_av_1_A = compoundA (regA "oskulpturerad") ;
  oskulpterad_av_1_A = compoundA (regA "oskulpterad") ;
  oskrymtad_av_1_A = compoundA (regA "oskrymtad") ;
  oskrudad_av_1_A = compoundA (regA "oskrudad") ;
  oskrubbad_av_1_A = compoundA (regA "oskrubbad") ;
  oskrotad_av_1_A = compoundA (regA "oskrotad") ;
  oskrapad_av_1_A = compoundA (regA "oskrapad") ;
  oskramlad_av_1_A = compoundA (regA "oskramlad") ;
  oskrafferad_av_1_A = compoundA (regA "oskrafferad") ;
  oskovlad_av_1_A = compoundA (regA "oskovlad") ;
  oskottad_av_1_A = compoundA (regA "oskottad") ;
  oskotad_av_1_A = compoundA (regA "oskotad") ;
  oskopad_av_1_A = compoundA (regA "oskopad") ;
  oskonad_av_1_A = compoundA (regA "oskonad") ;
  oskolad_av_1_A = compoundA (regA "oskolad") ;
  oskojad_av_1_A = compoundA (regA "oskojad") ;
  oskjuvad_av_1_A = compoundA (regA "oskjuvad") ;
  oskjutsad_av_1_A = compoundA (regA "oskjutsad") ;
  oskivad_av_1_A = compoundA (regA "oskivad") ;
  oskisserad_av_1_A = compoundA (regA "oskisserad") ;
  oskissad_av_1_A = compoundA (regA "oskissad") ;
  oskirad_av_1_A = compoundA (regA "oskirad") ;
  oskippad_av_1_A = compoundA (regA "oskippad") ;
  oskipad_av_1_A = compoundA (regA "oskipad") ;
  oskinnad_av_1_A = compoundA (regA "oskinnad") ;
  oskingrad_av_1_A = compoundA (regA "oskingrad") ;
  oskildrad_av_1_A = compoundA (regA "oskildrad") ;
  oskiktad_av_1_A = compoundA (regA "oskiktad") ;
  oskiftad_av_1_A = compoundA (regA "oskiftad") ;
  oskevrad_av_1_A = compoundA (regA "oskevrad") ;
  oskevad_av_1_A = compoundA (regA "oskevad") ;
  oskeppad_av_1_A = compoundA (regA "oskeppad") ;
  oskenad_av_1_A = compoundA (regA "oskenad") ;
  oskedad_av_1_A = compoundA (regA "oskedad") ;
  oskattad_av_1_A = compoundA (regA "oskattad") ;
  oskarvad_av_1_A = compoundA (regA "oskarvad") ;
  oskapad_av_1_A = compoundA (regA "oskapad") ;
  oskannad_av_1_A = compoundA (regA "oskannad") ;
  oskanderad_av_1_A = compoundA (regA "oskanderad") ;
  oskandaliserad_av_1_A = compoundA (regA "oskandaliserad") ;
  oskalperad_av_1_A = compoundA (regA "oskalperad") ;
  oskallad_av_1_A = compoundA (regA "oskallad") ;
  oskalkad_av_1_A = compoundA (regA "oskalkad") ;
  oskaldad_av_1_A = compoundA (regA "oskaldad") ;
  oskalad_av_1_A = compoundA (regA "oskalad") ;
  oskakad_av_1_A = compoundA (regA "oskakad") ;
  oskaftad_av_1_A = compoundA (regA "oskaftad") ;
  oskaffad_av_1_A = compoundA (regA "oskaffad") ;
  oskadad_av_1_A = compoundA (regA "oskadad") ;
  osjasad_av_1_A = compoundA (regA "osjasad") ;
  osjappad_av_1_A = compoundA (regA "osjappad") ;
  osjanghajad_av_1_A = compoundA (regA "osjanghajad") ;
  osirad_av_1_A = compoundA (regA "osirad") ;
  osintrad_av_1_A = compoundA (regA "osintrad") ;
  osinkad_av_1_A = compoundA (regA "osinkad") ;
  osimulerad_av_1_A = compoundA (regA "osimulerad") ;
  osimsad_av_1_A = compoundA (regA "osimsad") ;
  osimplifierad_av_1_A = compoundA (regA "osimplifierad") ;
  osilvrad_av_1_A = compoundA (regA "osilvrad") ;
  osiluetterad_av_1_A = compoundA (regA "osiluetterad") ;
  osilhuetterad_av_1_A = compoundA (regA "osilhuetterad") ;
  osilad_av_1_A = compoundA (regA "osilad") ;
  osiktad_av_1_A = compoundA (regA "osiktad") ;
  osignerad_av_1_A = compoundA (regA "osignerad") ;
  osignalerad_av_1_A = compoundA (regA "osignalerad") ;
  osignad_av_1_A = compoundA (regA "osignad") ;
  osigillerad_av_1_A = compoundA (regA "osigillerad") ;
  osicksackad_av_1_A = compoundA (regA "osicksackad") ;
  osicklad_av_1_A = compoundA (regA "osicklad") ;
  osickad_av_1_A = compoundA (regA "osickad") ;
  oshuntad_av_1_A = compoundA (regA "oshuntad") ;
  oshortad_av_1_A = compoundA (regA "oshortad") ;
  oshinglad_av_1_A = compoundA (regA "oshinglad") ;
  oshanghajad_av_1_A = compoundA (regA "oshanghajad") ;
  oshamponerad_av_1_A = compoundA (regA "oshamponerad") ;
  osexualiserad_av_1_A = compoundA (regA "osexualiserad") ;
  oserverad_av_1_A = compoundA (regA "oserverad") ;
  oservad_av_1_A = compoundA (regA "oservad") ;
  oseparerad_av_1_A = compoundA (regA "oseparerad") ;
  osenterad_av_1_A = compoundA (regA "osenterad") ;
  osensibiliserad_av_1_A = compoundA (regA "osensibiliserad") ;
  oseminerad_av_1_A = compoundA (regA "oseminerad") ;
  osemaforerad_av_1_A = compoundA (regA "osemaforerad") ;
  oselekterad_av_1_A = compoundA (regA "oselekterad") ;
  oselad_av_1_A = compoundA (regA "oselad") ;
  osekvestrerad_av_1_A = compoundA (regA "osekvestrerad") ;
  osekunderad_av_1_A = compoundA (regA "osekunderad") ;
  osekulariserad_av_1_A = compoundA (regA "osekulariserad") ;
  osekonderad_av_1_A = compoundA (regA "osekonderad") ;
  osejsad_av_1_A = compoundA (regA "osejsad") ;
  osegregerad_av_1_A = compoundA (regA "osegregerad") ;
  osegrad_av_1_A = compoundA (regA "osegrad") ;
  osegmenterad_av_1_A = compoundA (regA "osegmenterad") ;
  oseglad_av_1_A = compoundA (regA "oseglad") ;
  oseedad_av_1_A = compoundA (regA "oseedad") ;
  osedimenterad_av_1_A = compoundA (regA "osedimenterad") ;
  oschveifad_av_1_A = compoundA (regA "oschveifad") ;
  oschematiserad_av_1_A = compoundA (regA "oschematiserad") ;
  oschatterad_av_1_A = compoundA (regA "oschatterad") ;
  oschasad_av_1_A = compoundA (regA "oschasad") ;
  oschappad_av_1_A = compoundA (regA "oschappad") ;
  oschanghajad_av_1_A = compoundA (regA "oschanghajad") ;
  oschamponerad_av_1_A = compoundA (regA "oschamponerad") ;
  oschaktad_av_1_A = compoundA (regA "oschaktad") ;
  oschacklad_av_1_A = compoundA (regA "oschacklad") ;
  oschackad_av_1_A = compoundA (regA "oschackad") ;
  oschabloniserad_av_1_A = compoundA (regA "oschabloniserad") ;
  oschablonerad_av_1_A = compoundA (regA "oschablonerad") ;
  oscannad_av_1_A = compoundA (regA "oscannad") ;
  osaxad_av_1_A = compoundA (regA "osaxad") ;
  osauverad_av_1_A = compoundA (regA "osauverad") ;
  osauterad_av_1_A = compoundA (regA "osauterad") ;
  osaturerad_av_1_A = compoundA (regA "osaturerad") ;
  osatsad_av_1_A = compoundA (regA "osatsad") ;
  osatisfierad_av_1_A = compoundA (regA "osatisfierad") ;
  osatinerad_av_1_A = compoundA (regA "osatinerad") ;
  osargad_av_1_A = compoundA (regA "osargad") ;
  osaponifierad_av_1_A = compoundA (regA "osaponifierad") ;
  osannad_av_1_A = compoundA (regA "osannad") ;
  osanktionerad_av_1_A = compoundA (regA "osanktionerad") ;
  osanktifierad_av_1_A = compoundA (regA "osanktifierad") ;
  osanforiserad_av_1_A = compoundA (regA "osanforiserad") ;
  osanerad_av_1_A = compoundA (regA "osanerad") ;
  osandad_av_1_A = compoundA (regA "osandad") ;
  osamtaxerad_av_1_A = compoundA (regA "osamtaxerad") ;
  osamsad_av_1_A = compoundA (regA "osamsad") ;
  osamplad_av_1_A = compoundA (regA "osamplad") ;
  osamordnad_av_1_A = compoundA (regA "osamordnad") ;
  osammantraeffad_av_1_1_A = compoundA (regA "osammanträffad") ;
  osammansvetsad_av_1_A = compoundA (regA "osammansvetsad") ;
  osammanstraalad_av_1_1_A = compoundA (regA "osammanstrålad") ;
  osammanraeknad_av_1_1_A = compoundA (regA "osammanräknad") ;
  osammanpressad_av_1_A = compoundA (regA "osammanpressad") ;
  osammanpackad_av_1_A = compoundA (regA "osammanpackad") ;
  osammanlaenkad_av_1_1_A = compoundA (regA "osammanlänkad") ;
  osammankopplad_av_1_A = compoundA (regA "osammankopplad") ;
  osammankallad_av_1_A = compoundA (regA "osammankallad") ;
  osammanjaemkad_av_1_1_A = compoundA (regA "osammanjämkad") ;
  osammanhopad_av_1_A = compoundA (regA "osammanhopad") ;
  osammanfogad_av_1_A = compoundA (regA "osammanfogad") ;
  osammanflaetad_av_1_1_A = compoundA (regA "osammanflätad") ;
  osammanfattad_av_1_A = compoundA (regA "osammanfattad") ;
  osammanblandad_av_1_A = compoundA (regA "osammanblandad") ;
  osamlad_av_1_A = compoundA (regA "osamlad") ;
  osamkad_av_1_A = compoundA (regA "osamkad") ;
  osambeskattad_av_1_A = compoundA (regA "osambeskattad") ;
  osaluterad_av_1_A = compoundA (regA "osaluterad") ;
  osaltad_av_1_A = compoundA (regA "osaltad") ;
  osalderad_av_1_A = compoundA (regA "osalderad") ;
  osalad_av_1_A = compoundA (regA "osalad") ;
  osaktad_av_1_A = compoundA (regA "osaktad") ;
  osaknad_av_1_A = compoundA (regA "osaknad") ;
  osakad_av_1_A = compoundA (regA "osakad") ;
  osaftad_av_1_A = compoundA (regA "osaftad") ;
  osadlad_av_1_A = compoundA (regA "osadlad") ;
  osabrerad_av_1_A = compoundA (regA "osabrerad") ;
  osaboterad_av_1_A = compoundA (regA "osaboterad") ;
  osabbad_av_1_A = compoundA (regA "osabbad") ;
  oroevad_av_1_1_A = compoundA (regA "orövad") ;
  oroesad_av_1_1_A = compoundA (regA "orösad") ;
  oroentgad_av_1_1_A = compoundA (regA "oröntgad") ;
  oraanad_av_1_1_A = compoundA (regA "orånad") ;
  oraamad_av_1_1_A = compoundA (regA "oråmad") ;
  oraakad_av_1_1_A = compoundA (regA "oråkad") ;
  oraagad_av_1_1_A = compoundA (regA "orågad") ;
  oraettfaerdigad_av_1_1_A = compoundA (regA "orättfärdigad") ;
  oraettad_av_1_1_A = compoundA (regA "orättad") ;
  oraetad_av_1_1_A = compoundA (regA "orätad") ;
  oraemnad_av_1_1_A = compoundA (regA "orämnad") ;
  oraeknad_av_1_1_A = compoundA (regA "oräknad") ;
  oraefsad_av_1_1_A = compoundA (regA "oräfsad") ;
  oraefflad_av_1_1_A = compoundA (regA "oräfflad") ;
  oraeddad_av_1_1_A = compoundA (regA "oräddad") ;
  orytmiserad_av_1_A = compoundA (regA "orytmiserad") ;
  orynkad_av_1_A = compoundA (regA "orynkad") ;
  oryktad_av_1_A = compoundA (regA "oryktad") ;
  oruvad_av_1_A = compoundA (regA "oruvad") ;
  orutinerad_av_1_A = compoundA (regA "orutinerad") ;
  orustad_av_1_A = compoundA (regA "orustad") ;
  orussifierad_av_1_A = compoundA (regA "orussifierad") ;
  orussificerad_av_1_A = compoundA (regA "orussificerad") ;
  oruskad_av_1_A = compoundA (regA "oruskad") ;
  orusad_av_1_A = compoundA (regA "orusad") ;
  orunkad_av_1_A = compoundA (regA "orunkad") ;
  orundad_av_1_A = compoundA (regA "orundad") ;
  orullad_av_1_A = compoundA (regA "orullad") ;
  oruinerad_av_1_A = compoundA (regA "oruinerad") ;
  oruggad_av_1_A = compoundA (regA "oruggad") ;
  oruckad_av_1_A = compoundA (regA "oruckad") ;
  orubricerad_av_1_A = compoundA (regA "orubricerad") ;
  orubbad_av_1_A = compoundA (regA "orubbad") ;
  oroterad_av_1_A = compoundA (regA "oroterad") ;
  orostad_av_1_A = compoundA (regA "orostad") ;
  orosad_av_1_A = compoundA (regA "orosad") ;
  oromantiserad_av_1_A = compoundA (regA "oromantiserad") ;
  orollad_av_1_A = compoundA (regA "orollad") ;
  oroffad_av_1_A = compoundA (regA "oroffad") ;
  orockerad_av_1_A = compoundA (regA "orockerad") ;
  orobotiserad_av_1_A = compoundA (regA "orobotiserad") ;
  oritualiserad_av_1_A = compoundA (regA "oritualiserad") ;
  oritsad_av_1_A = compoundA (regA "oritsad") ;
  oritad_av_1_A = compoundA (regA "oritad") ;
  oristad_av_1_A = compoundA (regA "oristad") ;
  orisslad_av_1_A = compoundA (regA "orisslad") ;
  orispad_av_1_A = compoundA (regA "orispad") ;
  orisad_av_1_A = compoundA (regA "orisad") ;
  oringad_av_1_A = compoundA (regA "oringad") ;
  orimmad_av_1_A = compoundA (regA "orimmad") ;
  oriktad_av_1_A = compoundA (regA "oriktad") ;
  orikoschetterad_av_1_A = compoundA (regA "orikoschetterad") ;
  origlad_av_1_A = compoundA (regA "origlad") ;
  origgad_av_1_A = compoundA (regA "origgad") ;
  oriad_av_1_A = compoundA (regA "oriad") ;
  organiserad_av_1_A = compoundA (regA "organiserad") ;
  orevolutionerad_av_1_A = compoundA (regA "orevolutionerad") ;
  oreviderad_av_1_A = compoundA (regA "oreviderad") ;
  oreveterad_av_1_A = compoundA (regA "oreveterad") ;
  orevalverad_av_1_A = compoundA (regA "orevalverad") ;
  orevad_av_1_A = compoundA (regA "orevad") ;
  oretuscherad_av_1_A = compoundA (regA "oretuscherad") ;
  oreturnerad_av_1_A = compoundA (regA "oreturnerad") ;
  oretarderad_av_1_A = compoundA (regA "oretarderad") ;
  oretad_av_1_A = compoundA (regA "oretad") ;
  oretablerad_av_1_A = compoundA (regA "oretablerad") ;
  oresumerad_av_1_A = compoundA (regA "oresumerad") ;
  orestituerad_av_1_A = compoundA (regA "orestituerad") ;
  orestaurerad_av_1_A = compoundA (regA "orestaurerad") ;
  orespirerad_av_1_A = compoundA (regA "orespirerad") ;
  orespekterad_av_1_A = compoundA (regA "orespekterad") ;
  oresorberad_av_1_A = compoundA (regA "oresorberad") ;
  oresolverad_av_1_A = compoundA (regA "oresolverad") ;
  oreserverad_av_1_A = compoundA (regA "oreserverad") ;
  oreproducerad_av_1_A = compoundA (regA "oreproducerad") ;
  orepriserad_av_1_A = compoundA (regA "orepriserad") ;
  orepresenterad_av_1_A = compoundA (regA "orepresenterad") ;
  orepeterad_av_1_A = compoundA (regA "orepeterad") ;
  orepellerad_av_1_A = compoundA (regA "orepellerad") ;
  orepatrierad_av_1_A = compoundA (regA "orepatrierad") ;
  orepartiserad_av_1_A = compoundA (regA "orepartiserad") ;
  oreparerad_av_1_A = compoundA (regA "oreparerad") ;
  orepad_av_1_A = compoundA (regA "orepad") ;
  oreorganiserad_av_1_A = compoundA (regA "oreorganiserad") ;
  orensad_av_1_A = compoundA (regA "orensad") ;
  orenoverad_av_1_A = compoundA (regA "orenoverad") ;
  orenderad_av_1_A = compoundA (regA "orenderad") ;
  orenad_av_1_A = compoundA (regA "orenad") ;
  oremplacerad_av_1_A = compoundA (regA "oremplacerad") ;
  oremmad_av_1_A = compoundA (regA "oremmad") ;
  oremitterad_av_1_A = compoundA (regA "oremitterad") ;
  orelaead_av_1_1_A = compoundA (regA "oreläad") ;
  orelegerad_av_1_A = compoundA (regA "orelegerad") ;
  orelaterad_av_1_A = compoundA (regA "orelaterad") ;
  orekvirerad_av_1_A = compoundA (regA "orekvirerad") ;
  orektifierad_av_1_A = compoundA (regA "orektifierad") ;
  orektificerad_av_1_A = compoundA (regA "orektificerad") ;
  orekryterad_av_1_A = compoundA (regA "orekryterad") ;
  orekonstruerad_av_1_A = compoundA (regA "orekonstruerad") ;
  orekompenserad_av_1_A = compoundA (regA "orekompenserad") ;
  orekommenderad_av_1_A = compoundA (regA "orekommenderad") ;
  orekognoserad_av_1_A = compoundA (regA "orekognoserad") ;
  orekognoscerad_av_1_A = compoundA (regA "orekognoscerad") ;
  oreklamerad_av_1_A = compoundA (regA "oreklamerad") ;
  orekapitulerad_av_1_A = compoundA (regA "orekapitulerad") ;
  orekad_av_1_A = compoundA (regA "orekad") ;
  oreinkarnerad_av_1_A = compoundA (regA "oreinkarnerad") ;
  orehabiliterad_av_1_A = compoundA (regA "orehabiliterad") ;
  oregummerad_av_1_A = compoundA (regA "oregummerad") ;
  oreglerad_av_1_A = compoundA (regA "oreglerad") ;
  oreglementerad_av_1_A = compoundA (regA "oreglementerad") ;
  oreglad_av_1_A = compoundA (regA "oreglad") ;
  oregistrerad_av_1_A = compoundA (regA "oregistrerad") ;
  oregisserad_av_1_A = compoundA (regA "oregisserad") ;
  oregerad_av_1_A = compoundA (regA "oregerad") ;
  oregenererad_av_1_A = compoundA (regA "oregenererad") ;
  oregalerad_av_1_A = compoundA (regA "oregalerad") ;
  orefuserad_av_1_A = compoundA (regA "orefuserad") ;
  oreformerad_av_1_A = compoundA (regA "oreformerad") ;
  oreflekterad_av_1_A = compoundA (regA "oreflekterad") ;
  orefererad_av_1_A = compoundA (regA "orefererad") ;
  oreducerad_av_1_A = compoundA (regA "oreducerad") ;
  oredubblad_av_1_A = compoundA (regA "oredubblad") ;
  oredovisad_av_1_A = compoundA (regA "oredovisad") ;
  oredigerad_av_1_A = compoundA (regA "oredigerad") ;
  oreciterad_av_1_A = compoundA (regA "oreciterad") ;
  orecipierad_av_1_A = compoundA (regA "orecipierad") ;
  orecenserad_av_1_A = compoundA (regA "orecenserad") ;
  oreassurerad_av_1_A = compoundA (regA "oreassurerad") ;
  orealiserad_av_1_A = compoundA (regA "orealiserad") ;
  oreaktiverad_av_1_A = compoundA (regA "oreaktiverad") ;
  orattad_av_1_A = compoundA (regA "orattad") ;
  orationaliserad_av_1_A = compoundA (regA "orationaliserad") ;
  oratificerad_av_1_A = compoundA (regA "oratificerad") ;
  oratad_av_1_A = compoundA (regA "oratad") ;
  orastad_av_1_A = compoundA (regA "orastad") ;
  oraspad_av_1_A = compoundA (regA "oraspad") ;
  oraserad_av_1_A = compoundA (regA "oraserad") ;
  orapporterad_av_1_A = compoundA (regA "orapporterad") ;
  orappellerad_av_1_A = compoundA (regA "orappellerad") ;
  orappad_av_1_A = compoundA (regA "orappad") ;
  oransonerad_av_1_A = compoundA (regA "oransonerad") ;
  orannsakad_av_1_A = compoundA (regA "orannsakad") ;
  orankad_av_1_A = compoundA (regA "orankad") ;
  orangerad_av_1_A = compoundA (regA "orangerad") ;
  orangemaalad_av_1_1_A = compoundA (regA "orangemålad") ;
  orangefaergad_av_1_1_A = compoundA (regA "orangefärgad") ;
  orandomiserad_av_1_A = compoundA (regA "orandomiserad") ;
  orandad_av_1_A = compoundA (regA "orandad") ;
  oramsad_av_1_A = compoundA (regA "oramsad") ;
  oramponerad_av_1_A = compoundA (regA "oramponerad") ;
  orammad_av_1_A = compoundA (regA "orammad") ;
  oramad_av_1_A = compoundA (regA "oramad") ;
  orakad_av_1_A = compoundA (regA "orakad") ;
  oraggad_av_1_A = compoundA (regA "oraggad") ;
  oraffinerad_av_1_A = compoundA (regA "oraffinerad") ;
  oradikaliserad_av_1_A = compoundA (regA "oradikaliserad") ;
  oradierad_av_1_A = compoundA (regA "oradierad") ;
  oraderad_av_1_A = compoundA (regA "oraderad") ;
  orackad_av_1_A = compoundA (regA "orackad") ;
  orabblad_av_1_A = compoundA (regA "orabblad") ;
  orabatterad_av_1_A = compoundA (regA "orabatterad") ;
  oquiltad_av_1_A = compoundA (regA "oquiltad") ;
  opaayrkad_av_1_1_A = compoundA (regA "opåyrkad") ;
  opaavisad_av_1_1_A = compoundA (regA "opåvisad") ;
  opaaverkad_av_1_1_A = compoundA (regA "opåverkad") ;
  opaatraeffad_av_1_1_A = compoundA (regA "opåträffad") ;
  opaatalad_av_1_1_A = compoundA (regA "opåtalad") ;
  opaaskyndad_av_1_1_A = compoundA (regA "opåskyndad") ;
  opaaraeknad_av_1_1_A = compoundA (regA "opåräknad") ;
  opaaropad_av_1_1_A = compoundA (regA "opåropad") ;
  opaapekad_av_1_1_A = compoundA (regA "opåpekad") ;
  opaalad_av_1_1_A = compoundA (regA "opålad") ;
  opaakallad_av_1_1_A = compoundA (regA "opåkallad") ;
  opaafordrad_av_1_1_A = compoundA (regA "opåfordrad") ;
  opaadyvlad_av_1_1_A = compoundA (regA "opådyvlad") ;
  opaaboerjad_av_1_1_A = compoundA (regA "opåbörjad") ;
  opaaboerdad_av_1_1_A = compoundA (regA "opåbördad") ;
  opaaad_av_1_1_A = compoundA (regA "opåad") ;
  opaelad_av_1_1_A = compoundA (regA "opälad") ;
  opytsad_av_1_A = compoundA (regA "opytsad") ;
  opyntad_av_1_A = compoundA (regA "opyntad") ;
  oputtad_av_1_A = compoundA (regA "oputtad") ;
  oputsad_av_1_A = compoundA (regA "oputsad") ;
  opussad_av_1_A = compoundA (regA "opussad") ;
  opushad_av_1_A = compoundA (regA "opushad") ;
  opurrad_av_1_A = compoundA (regA "opurrad") ;
  opurprad_av_1_A = compoundA (regA "opurprad") ;
  opurgerad_av_1_A = compoundA (regA "opurgerad") ;
  opunsad_av_1_A = compoundA (regA "opunsad") ;
  opunkterad_av_1_A = compoundA (regA "opunkterad") ;
  opunktad_av_1_A = compoundA (regA "opunktad") ;
  opumpad_av_1_A = compoundA (regA "opumpad") ;
  opulvriserad_av_1_A = compoundA (regA "opulvriserad") ;
  opulveriserad_av_1_A = compoundA (regA "opulveriserad") ;
  opuffad_av_1_A = compoundA (regA "opuffad") ;
  opudrad_av_1_A = compoundA (regA "opudrad") ;
  opuddlad_av_1_A = compoundA (regA "opuddlad") ;
  opublicerad_av_1_A = compoundA (regA "opublicerad") ;
  opsykologiserad_av_1_A = compoundA (regA "opsykologiserad") ;
  opsykad_av_1_A = compoundA (regA "opsykad") ;
  oproevad_av_1_1_A = compoundA (regA "oprövad") ;
  oproejsad_av_1_1_A = compoundA (regA "opröjsad") ;
  opraamad_av_1_1_A = compoundA (regA "opråmad") ;
  opraentad_av_1_1_A = compoundA (regA "opräntad") ;
  opraeglad_av_1_1_A = compoundA (regA "opräglad") ;
  opryglad_av_1_A = compoundA (regA "opryglad") ;
  oprutad_av_1_A = compoundA (regA "oprutad") ;
  oprovocerad_av_1_A = compoundA (regA "oprovocerad") ;
  oprovad_av_1_A = compoundA (regA "oprovad") ;
  oprotokollerad_av_1_A = compoundA (regA "oprotokollerad") ;
  oprotesterad_av_1_A = compoundA (regA "oprotesterad") ;
  oprotegerad_av_1_A = compoundA (regA "oprotegerad") ;
  oprospekterad_av_1_A = compoundA (regA "oprospekterad") ;
  oproskriberad_av_1_A = compoundA (regA "oproskriberad") ;
  oproppad_av_1_A = compoundA (regA "oproppad") ;
  oproportionerad_av_1_A = compoundA (regA "oproportionerad") ;
  oproponerad_av_1_A = compoundA (regA "oproponerad") ;
  oprononcerad_av_1_A = compoundA (regA "oprononcerad") ;
  opromulgerad_av_1_A = compoundA (regA "opromulgerad") ;
  opromoverad_av_1_A = compoundA (regA "opromoverad") ;
  oprolongerad_av_1_A = compoundA (regA "oprolongerad") ;
  oproletariserad_av_1_A = compoundA (regA "oproletariserad") ;
  oproklamerad_av_1_A = compoundA (regA "oproklamerad") ;
  oprojicerad_av_1_A = compoundA (regA "oprojicerad") ;
  oprojekterad_av_1_A = compoundA (regA "oprojekterad") ;
  oprogrammerad_av_1_A = compoundA (regA "oprogrammerad") ;
  oprognostiserad_av_1_A = compoundA (regA "oprognostiserad") ;
  oprofilerad_av_1_A = compoundA (regA "oprofilerad") ;
  oprofessionaliserad_av_1_A = compoundA (regA "oprofessionaliserad") ;
  oprofanerad_av_1_A = compoundA (regA "oprofanerad") ;
  oproducerad_av_1_A = compoundA (regA "oproducerad") ;
  oprocessad_av_1_A = compoundA (regA "oprocessad") ;
  oproblematiserad_av_1_A = compoundA (regA "oproblematiserad") ;
  oproberad_av_1_A = compoundA (regA "oproberad") ;
  oprivilegierad_av_1_A = compoundA (regA "oprivilegierad") ;
  oprivatiserad_av_1_A = compoundA (regA "oprivatiserad") ;
  oprisad_av_1_A = compoundA (regA "oprisad") ;
  oprioriterad_av_1_A = compoundA (regA "oprioriterad") ;
  oprickad_av_1_A = compoundA (regA "oprickad") ;
  opresumerad_av_1_A = compoundA (regA "opresumerad") ;
  opresterad_av_1_A = compoundA (regA "opresterad") ;
  opressad_av_1_A = compoundA (regA "opressad") ;
  opreskriberad_av_1_A = compoundA (regA "opreskriberad") ;
  opreserverad_av_1_A = compoundA (regA "opreserverad") ;
  opresenterad_av_1_A = compoundA (regA "opresenterad") ;
  opresentad_av_1_A = compoundA (regA "opresentad") ;
  opreparerad_av_1_A = compoundA (regA "opreparerad") ;
  opremierad_av_1_A = compoundA (regA "opremierad") ;
  opreludierad_av_1_A = compoundA (regA "opreludierad") ;
  oprejad_av_1_A = compoundA (regA "oprejad") ;
  oprefigerad_av_1_A = compoundA (regA "oprefigerad") ;
  oprefererad_av_1_A = compoundA (regA "oprefererad") ;
  oprefabricerad_av_1_A = compoundA (regA "oprefabricerad") ;
  opredisponerad_av_1_A = compoundA (regA "opredisponerad") ;
  opredicerad_av_1_A = compoundA (regA "opredicerad") ;
  opredestinerad_av_1_A = compoundA (regA "opredestinerad") ;
  opreciserad_av_1_A = compoundA (regA "opreciserad") ;
  opraktiserad_av_1_A = compoundA (regA "opraktiserad") ;
  oppaatriktad_av_1_1_A = compoundA (regA "oppåtriktad") ;
  oppaatkammad_av_1_1_A = compoundA (regA "oppåtkammad") ;
  oppvilad_av_1_A = compoundA (regA "oppvilad") ;
  oppspaerrad_av_1_1_A = compoundA (regA "oppspärrad") ;
  oppskojad_av_1_A = compoundA (regA "oppskojad") ;
  oppretad_av_1_A = compoundA (regA "oppretad") ;
  oppladdad_av_1_A = compoundA (regA "oppladdad") ;
  oppkavlad_av_1_A = compoundA (regA "oppkavlad") ;
  oppkammad_av_1_A = compoundA (regA "oppkammad") ;
  oppjagad_av_1_A = compoundA (regA "oppjagad") ;
  opphetsad_av_1_A = compoundA (regA "opphetsad") ;
  oppeldad_av_1_A = compoundA (regA "oppeldad") ;
  oppdiktad_av_1_A = compoundA (regA "oppdiktad") ;
  oppblandad_av_1_A = compoundA (regA "oppblandad") ;
  opoaengterad_av_1_1_A = compoundA (regA "opoängterad") ;
  opostulerad_av_1_A = compoundA (regA "opostulerad") ;
  opostponerad_av_1_A = compoundA (regA "opostponerad") ;
  oposterad_av_1_A = compoundA (regA "oposterad") ;
  opostdaterad_av_1_A = compoundA (regA "opostdaterad") ;
  opostad_av_1_A = compoundA (regA "opostad") ;
  oportraetterad_av_1_1_A = compoundA (regA "oporträtterad") ;
  oportionerad_av_1_A = compoundA (regA "oportionerad") ;
  oportad_av_1_A = compoundA (regA "oportad") ;
  opopulariserad_av_1_A = compoundA (regA "opopulariserad") ;
  opoppad_av_1_A = compoundA (regA "opoppad") ;
  opomaderad_av_1_A = compoundA (regA "opomaderad") ;
  opolstrad_av_1_A = compoundA (regA "opolstrad") ;
  opollinerad_av_1_A = compoundA (regA "opollinerad") ;
  opolletterad_av_1_A = compoundA (regA "opolletterad") ;
  opolitiserad_av_1_A = compoundA (regA "opolitiserad") ;
  opolerad_av_1_A = compoundA (regA "opolerad") ;
  opolariserad_av_1_A = compoundA (regA "opolariserad") ;
  opointerad_av_1_A = compoundA (regA "opointerad") ;
  opocherad_av_1_A = compoundA (regA "opocherad") ;
  oplaatad_av_1_1_A = compoundA (regA "oplåtad") ;
  oplaastrad_av_1_1_A = compoundA (regA "oplåstrad") ;
  oplaeterad_av_1_1_A = compoundA (regA "opläterad") ;
  oplysad_av_1_A = compoundA (regA "oplysad") ;
  oplundrad_av_1_A = compoundA (regA "oplundrad") ;
  opluggad_av_1_A = compoundA (regA "opluggad") ;
  oplottad_av_1_A = compoundA (regA "oplottad") ;
  oplomberad_av_1_A = compoundA (regA "oplomberad") ;
  oplogad_av_1_A = compoundA (regA "oplogad") ;
  oplockad_av_1_A = compoundA (regA "oplockad") ;
  oplisserad_av_1_A = compoundA (regA "oplisserad") ;
  opliggad_av_1_A = compoundA (regA "opliggad") ;
  oplatinerad_av_1_A = compoundA (regA "oplatinerad") ;
  oplastad_av_1_A = compoundA (regA "oplastad") ;
  oplanterad_av_1_A = compoundA (regA "oplanterad") ;
  oplantad_av_1_A = compoundA (regA "oplantad") ;
  oplankad_av_1_A = compoundA (regA "oplankad") ;
  oplanerad_av_1_A = compoundA (regA "oplanerad") ;
  oplanad_av_1_A = compoundA (regA "oplanad") ;
  oplagierad_av_1_A = compoundA (regA "oplagierad") ;
  oplacerad_av_1_A = compoundA (regA "oplacerad") ;
  opiskad_av_1_A = compoundA (regA "opiskad") ;
  opirkad_av_1_A = compoundA (regA "opirkad") ;
  opippad_av_1_A = compoundA (regA "opippad") ;
  opinnad_av_1_A = compoundA (regA "opinnad") ;
  opincerad_av_1_A = compoundA (regA "opincerad") ;
  opinad_av_1_A = compoundA (regA "opinad") ;
  opimplad_av_1_A = compoundA (regA "opimplad") ;
  opimpad_av_1_A = compoundA (regA "opimpad") ;
  opilkad_av_1_A = compoundA (regA "opilkad") ;
  opikerad_av_1_A = compoundA (regA "opikerad") ;
  opikad_av_1_A = compoundA (regA "opikad") ;
  opickad_av_1_A = compoundA (regA "opickad") ;
  opetrifierad_av_1_A = compoundA (regA "opetrifierad") ;
  opetad_av_1_A = compoundA (regA "opetad") ;
  operverterad_av_1_A = compoundA (regA "operverterad") ;
  opersvaderad_av_1_A = compoundA (regA "opersvaderad") ;
  opersonifierad_av_1_A = compoundA (regA "opersonifierad") ;
  opersiflerad_av_1_A = compoundA (regA "opersiflerad") ;
  opermuterad_av_1_A = compoundA (regA "opermuterad") ;
  opermitterad_av_1_A = compoundA (regA "opermitterad") ;
  opermanentad_av_1_A = compoundA (regA "opermanentad") ;
  operiodiserad_av_1_A = compoundA (regA "operiodiserad") ;
  operforerad_av_1_A = compoundA (regA "operforerad") ;
  opercipierad_av_1_A = compoundA (regA "opercipierad") ;
  opepprad_av_1_A = compoundA (regA "opepprad") ;
  opeppad_av_1_A = compoundA (regA "opeppad") ;
  openslad_av_1_A = compoundA (regA "openslad") ;
  opensionerad_av_1_A = compoundA (regA "opensionerad") ;
  openetrerad_av_1_A = compoundA (regA "openetrerad") ;
  opelleterad_av_1_A = compoundA (regA "opelleterad") ;
  opejlad_av_1_A = compoundA (regA "opejlad") ;
  opaxad_av_1_A = compoundA (regA "opaxad") ;
  opauserad_av_1_A = compoundA (regA "opauserad") ;
  opausad_av_1_A = compoundA (regA "opausad") ;
  opauperiserad_av_1_A = compoundA (regA "opauperiserad") ;
  opatrullerad_av_1_A = compoundA (regA "opatrullerad") ;
  opatinerad_av_1_A = compoundA (regA "opatinerad") ;
  opatenterad_av_1_A = compoundA (regA "opatenterad") ;
  opastoeriserad_av_1_1_A = compoundA (regA "opastöriserad") ;
  opassiviserad_av_1_A = compoundA (regA "opassiviserad") ;
  opassiverad_av_1_A = compoundA (regA "opassiverad") ;
  opasserad_av_1_A = compoundA (regA "opasserad") ;
  opassad_av_1_A = compoundA (regA "opassad") ;
  oparodierad_av_1_A = compoundA (regA "oparodierad") ;
  oparketterad_av_1_A = compoundA (regA "oparketterad") ;
  oparkerad_av_1_A = compoundA (regA "oparkerad") ;
  oparfymerad_av_1_A = compoundA (regA "oparfymerad") ;
  oparerad_av_1_A = compoundA (regA "oparerad") ;
  oparalyserad_av_1_A = compoundA (regA "oparalyserad") ;
  oparallelliserad_av_1_A = compoundA (regA "oparallelliserad") ;
  oparafraserad_av_1_A = compoundA (regA "oparafraserad") ;
  oparaffinerad_av_1_A = compoundA (regA "oparaffinerad") ;
  oparaferad_av_1_A = compoundA (regA "oparaferad") ;
  oparaderad_av_1_A = compoundA (regA "oparaderad") ;
  oparad_av_1_A = compoundA (regA "oparad") ;
  opantograferad_av_1_A = compoundA (regA "opantograferad") ;
  opantad_av_1_A = compoundA (regA "opantad") ;
  opansrad_av_1_A = compoundA (regA "opansrad") ;
  opanorerad_av_1_A = compoundA (regA "opanorerad") ;
  opangad_av_1_A = compoundA (regA "opangad") ;
  opanerad_av_1_A = compoundA (regA "opanerad") ;
  opanelad_av_1_A = compoundA (regA "opanelad") ;
  opalperad_av_1_A = compoundA (regA "opalperad") ;
  opalmad_av_1_A = compoundA (regA "opalmad") ;
  opallad_av_1_A = compoundA (regA "opallad") ;
  opaljetterad_av_1_A = compoundA (regA "opaljetterad") ;
  opalfaergad_av_1_1_A = compoundA (regA "opalfärgad") ;
  opalataliserad_av_1_A = compoundA (regA "opalataliserad") ;
  opaketerad_av_1_A = compoundA (regA "opaketerad") ;
  opajad_av_1_A = compoundA (regA "opajad") ;
  opaginerad_av_1_A = compoundA (regA "opaginerad") ;
  opackad_av_1_A = compoundA (regA "opackad") ;
  opacificerad_av_1_A = compoundA (regA "opacificerad") ;
  ooxiderad_av_1_A = compoundA (regA "ooxiderad") ;
  ooutad_av_1_A = compoundA (regA "ooutad") ;
  oorsakad_av_1_A = compoundA (regA "oorsakad") ;
  oornerad_av_1_A = compoundA (regA "oornerad") ;
  oornamenterad_av_1_A = compoundA (regA "oornamenterad") ;
  oorkestrerad_av_1_A = compoundA (regA "oorkestrerad") ;
  oorienterad_av_1_A = compoundA (regA "oorienterad") ;
  oorganiserad_av_1_A = compoundA (regA "oorganiserad") ;
  oordnad_av_1_A = compoundA (regA "oordnad") ;
  oordinerad_av_1_A = compoundA (regA "oordinerad") ;
  ooptimerad_av_1_A = compoundA (regA "ooptimerad") ;
  ooppvaerderad_av_1_1_A = compoundA (regA "ooppvärderad") ;
  ooppsummerad_av_1_A = compoundA (regA "ooppsummerad") ;
  oopponerad_av_1_A = compoundA (regA "oopponerad") ;
  ooppjusterad_av_1_A = compoundA (regA "ooppjusterad") ;
  oopererad_av_1_A = compoundA (regA "oopererad") ;
  ooperationaliserad_av_1_A = compoundA (regA "ooperationaliserad") ;
  oondulerad_av_1_A = compoundA (regA "oondulerad") ;
  oomaendrad_av_1_1_A = compoundA (regA "oomändrad") ;
  oomvaerderad_av_1_1_A = compoundA (regA "oomvärderad") ;
  oomvittnad_av_1_A = compoundA (regA "oomvittnad") ;
  oomvandlad_av_1_A = compoundA (regA "oomvandlad") ;
  oomtvistad_av_1_A = compoundA (regA "oomtvistad") ;
  oomtolkad_av_1_A = compoundA (regA "oomtolkad") ;
  oomtalad_av_1_A = compoundA (regA "oomtalad") ;
  oomsvaermad_av_1_1_A = compoundA (regA "oomsvärmad") ;
  oomstoertad_av_1_1_A = compoundA (regA "oomstörtad") ;
  oomstraalad_av_1_1_A = compoundA (regA "oomstrålad") ;
  oomstrukturerad_av_1_A = compoundA (regA "oomstrukturerad") ;
  oomslingrad_av_1_A = compoundA (regA "oomslingrad") ;
  oomskulpturerad_av_1_A = compoundA (regA "oomskulpturerad") ;
  oomskolad_av_1_A = compoundA (regA "oomskolad") ;
  oomskapad_av_1_A = compoundA (regA "oomskapad") ;
  oomraeknad_av_1_1_A = compoundA (regA "oomräknad") ;
  oomringad_av_1_A = compoundA (regA "oomringad") ;
  oomramad_av_1_A = compoundA (regA "oomramad") ;
  oomproevad_av_1_1_A = compoundA (regA "oomprövad") ;
  oomplaastrad_av_1_1_A = compoundA (regA "oomplåstrad") ;
  oomplacerad_av_1_A = compoundA (regA "oomplacerad") ;
  oomorganiserad_av_1_A = compoundA (regA "oomorganiserad") ;
  oommoeblerad_av_1_1_A = compoundA (regA "oommöblerad") ;
  oomkretsad_av_1_A = compoundA (regA "oomkretsad") ;
  oomkransad_av_1_A = compoundA (regA "oomkransad") ;
  oomkastad_av_1_A = compoundA (regA "oomkastad") ;
  oomhaektad_av_1_1_A = compoundA (regA "oomhäktad") ;
  oomhaegnad_av_1_1_A = compoundA (regA "oomhägnad") ;
  oomhuldad_av_1_A = compoundA (regA "oomhuldad") ;
  oomgaerdad_av_1_1_A = compoundA (regA "oomgärdad") ;
  oomgrupperad_av_1_A = compoundA (regA "oomgrupperad") ;
  oomgestaltad_av_1_A = compoundA (regA "oomgestaltad") ;
  oomfoerhandlad_av_1_1_A = compoundA (regA "oomförhandlad") ;
  oomfoerdelad_av_1_1_A = compoundA (regA "oomfördelad") ;
  oomformad_av_1_A = compoundA (regA "oomformad") ;
  oomflyttad_av_1_A = compoundA (regA "oomflyttad") ;
  oomfattad_av_1_A = compoundA (regA "oomfattad") ;
  oomfamnad_av_1_A = compoundA (regA "oomfamnad") ;
  oomdirigerad_av_1_A = compoundA (regA "oomdirigerad") ;
  oomdanad_av_1_A = compoundA (regA "oomdanad") ;
  oombildad_av_1_A = compoundA (regA "oombildad") ;
  oomarbetad_av_1_A = compoundA (regA "oomarbetad") ;
  oollad_av_1_A = compoundA (regA "oollad") ;
  ooljad_av_1_A = compoundA (regA "ooljad") ;
  oolad_av_1_A = compoundA (regA "oolad") ;
  ookulerad_av_1_A = compoundA (regA "ookulerad") ;
  ooktrojerad_av_1_A = compoundA (regA "ooktrojerad") ;
  ookad_av_1_A = compoundA (regA "ookad") ;
  ooffrad_av_1_A = compoundA (regA "ooffrad") ;
  ooffererad_av_1_A = compoundA (regA "ooffererad") ;
  oodlad_av_1_A = compoundA (regA "oodlad") ;
  oockuperad_av_1_A = compoundA (regA "oockuperad") ;
  ooccidentaliserad_av_1_A = compoundA (regA "ooccidentaliserad") ;
  oobserverad_av_1_A = compoundA (regA "oobserverad") ;
  oobligerad_av_1_A = compoundA (regA "oobligerad") ;
  oobjektiverad_av_1_A = compoundA (regA "oobjektiverad") ;
  oobducerad_av_1_A = compoundA (regA "oobducerad") ;
  onoedgad_av_1_1_A = compoundA (regA "onödgad") ;
  onaatlad_av_1_1_A = compoundA (regA "onåtlad") ;
  onaatad_av_1_1_A = compoundA (regA "onåtad") ;
  onaalad_av_1_1_A = compoundA (regA "onålad") ;
  onaadad_av_1_1_A = compoundA (regA "onådad") ;
  onaetad_av_1_1_A = compoundA (regA "onätad") ;
  onaermad_av_1_1_A = compoundA (regA "onärmad") ;
  onyttjad_av_1_A = compoundA (regA "onyttjad") ;
  onystad_av_1_A = compoundA (regA "onystad") ;
  onynnad_av_1_A = compoundA (regA "onynnad") ;
  onyanserad_av_1_A = compoundA (regA "onyanserad") ;
  onumrerad_av_1_A = compoundA (regA "onumrerad") ;
  onuddad_av_1_A = compoundA (regA "onuddad") ;
  onubbad_av_1_A = compoundA (regA "onubbad") ;
  onotiserad_av_1_A = compoundA (regA "onotiserad") ;
  onotifierad_av_1_A = compoundA (regA "onotifierad") ;
  onotificerad_av_1_A = compoundA (regA "onotificerad") ;
  onoterad_av_1_A = compoundA (regA "onoterad") ;
  onotad_av_1_A = compoundA (regA "onotad") ;
  onorpad_av_1_A = compoundA (regA "onorpad") ;
  onormerad_av_1_A = compoundA (regA "onormerad") ;
  onormaliserad_av_1_A = compoundA (regA "onormaliserad") ;
  onoppad_av_1_A = compoundA (regA "onoppad") ;
  ononchalerad_av_1_A = compoundA (regA "ononchalerad") ;
  onominerad_av_1_A = compoundA (regA "onominerad") ;
  onollad_av_1_A = compoundA (regA "onollad") ;
  onockad_av_1_A = compoundA (regA "onockad") ;
  onobiliserad_av_1_A = compoundA (regA "onobiliserad") ;
  onobbad_av_1_A = compoundA (regA "onobbad") ;
  onivellerad_av_1_A = compoundA (regA "onivellerad") ;
  onitrerad_av_1_A = compoundA (regA "onitrerad") ;
  onitad_av_1_A = compoundA (regA "onitad") ;
  oniellerad_av_1_A = compoundA (regA "oniellerad") ;
  onickad_av_1_A = compoundA (regA "onickad") ;
  oniad_av_1_A = compoundA (regA "oniad") ;
  oneutraliserad_av_1_A = compoundA (regA "oneutraliserad") ;
  onervaerderad_av_1_1_A = compoundA (regA "onervärderad") ;
  onertransponerad_av_1_A = compoundA (regA "onertransponerad") ;
  onertransformerad_av_1_A = compoundA (regA "onertransformerad") ;
  onertecknad_av_1_A = compoundA (regA "onertecknad") ;
  onerrustad_av_1_A = compoundA (regA "onerrustad") ;
  onerklassad_av_1_A = compoundA (regA "onerklassad") ;
  onerkavlad_av_1_A = compoundA (regA "onerkavlad") ;
  onerkastad_av_1_A = compoundA (regA "onerkastad") ;
  onerkallad_av_1_A = compoundA (regA "onerkallad") ;
  onerisad_av_1_A = compoundA (regA "onerisad") ;
  onerarbetad_av_1_A = compoundA (regA "onerarbetad") ;
  onekad_av_1_A = compoundA (regA "onekad") ;
  onegotierad_av_1_A = compoundA (regA "onegotierad") ;
  onegocierad_av_1_A = compoundA (regA "onegocierad") ;
  onegligerad_av_1_A = compoundA (regA "onegligerad") ;
  onegerad_av_1_A = compoundA (regA "onegerad") ;
  onedvaerderad_av_1_1_A = compoundA (regA "onedvärderad") ;
  onedtransponerad_av_1_A = compoundA (regA "onedtransponerad") ;
  onedtransformerad_av_1_A = compoundA (regA "onedtransformerad") ;
  onedtecknad_av_1_A = compoundA (regA "onedtecknad") ;
  onedrustad_av_1_A = compoundA (regA "onedrustad") ;
  onedklassad_av_1_A = compoundA (regA "onedklassad") ;
  onedkavlad_av_1_A = compoundA (regA "onedkavlad") ;
  onedkastad_av_1_A = compoundA (regA "onedkastad") ;
  onedkallad_av_1_A = compoundA (regA "onedkallad") ;
  onedisad_av_1_A = compoundA (regA "onedisad") ;
  onedarbetad_av_1_A = compoundA (regA "onedarbetad") ;
  onavlad_av_1_A = compoundA (regA "onavlad") ;
  onavigerad_av_1_A = compoundA (regA "onavigerad") ;
  onaturaliserad_av_1_A = compoundA (regA "onaturaliserad") ;
  onattad_av_1_A = compoundA (regA "onattad") ;
  onationaliserad_av_1_A = compoundA (regA "onationaliserad") ;
  onasaliserad_av_1_A = compoundA (regA "onasaliserad") ;
  onasalerad_av_1_A = compoundA (regA "onasalerad") ;
  onasad_av_1_A = compoundA (regA "onasad") ;
  onarvad_av_1_A = compoundA (regA "onarvad") ;
  onarrad_av_1_A = compoundA (regA "onarrad") ;
  onarad_av_1_A = compoundA (regA "onarad") ;
  onappad_av_1_A = compoundA (regA "onappad") ;
  onamnad_av_1_A = compoundA (regA "onamnad") ;
  onallad_av_1_A = compoundA (regA "onallad") ;
  onajad_av_1_A = compoundA (regA "onajad") ;
  onaglad_av_1_A = compoundA (regA "onaglad") ;
  onaggad_av_1_A = compoundA (regA "onaggad") ;
  onafsad_av_1_A = compoundA (regA "onafsad") ;
  onackad_av_1_A = compoundA (regA "onackad") ;
  omoerkad_av_1_1_A = compoundA (regA "omörkad") ;
  omoerdad_av_1_1_A = compoundA (regA "omördad") ;
  omoerad_av_1_1_A = compoundA (regA "omörad") ;
  omoenstrad_av_1_1_A = compoundA (regA "omönstrad") ;
  omoeblerad_av_1_1_A = compoundA (regA "omöblerad") ;
  omaattad_av_1_1_A = compoundA (regA "omåttad") ;
  omaanglad_av_1_1_A = compoundA (regA "omånglad") ;
  omaalad_av_1_1_A = compoundA (regA "omålad") ;
  omaettad_av_1_1_A = compoundA (regA "omättad") ;
  omaestrad_av_1_1_A = compoundA (regA "omästrad") ;
  omaeskad_av_1_1_A = compoundA (regA "omäskad") ;
  omaerglad_av_1_1_A = compoundA (regA "omärglad") ;
  omaeltad_av_1_1_A = compoundA (regA "omältad") ;
  omaeklad_av_1_1_A = compoundA (regA "omäklad") ;
  omystifierad_av_1_A = compoundA (regA "omystifierad") ;
  omyntad_av_1_A = compoundA (regA "omyntad") ;
  omyllad_av_1_A = compoundA (regA "omyllad") ;
  omuterad_av_1_A = compoundA (regA "omuterad") ;
  omutad_av_1_A = compoundA (regA "omutad") ;
  omurad_av_1_A = compoundA (regA "omurad") ;
  omumifierad_av_1_A = compoundA (regA "omumifierad") ;
  omultiplicerad_av_1_A = compoundA (regA "omultiplicerad") ;
  omuljerad_av_1_A = compoundA (regA "omuljerad") ;
  omuddrad_av_1_A = compoundA (regA "omuddrad") ;
  omtoecknad_av_1_1_A = compoundA (regA "omtöcknad") ;
  omtvistad_av_1_A = compoundA (regA "omtvistad") ;
  omtumlad_av_1_A = compoundA (regA "omtumlad") ;
  omtuggad_av_1_A = compoundA (regA "omtuggad") ;
  omtalad_av_1_A = compoundA (regA "omtalad") ;
  omsusad_av_1_A = compoundA (regA "omsusad") ;
  omskakad_av_1_A = compoundA (regA "omskakad") ;
  omotverkad_av_1_A = compoundA (regA "omotverkad") ;
  omotoriserad_av_1_A = compoundA (regA "omotoriserad") ;
  omotiverad_av_1_A = compoundA (regA "omotiverad") ;
  omotbevisad_av_1_A = compoundA (regA "omotbevisad") ;
  omotarbetad_av_1_A = compoundA (regA "omotarbetad") ;
  omotad_av_1_A = compoundA (regA "omotad") ;
  omosad_av_1_A = compoundA (regA "omosad") ;
  omortifierad_av_1_A = compoundA (regA "omortifierad") ;
  omortificerad_av_1_A = compoundA (regA "omortificerad") ;
  omorserad_av_1_A = compoundA (regA "omorserad") ;
  omornad_av_1_A = compoundA (regA "omornad") ;
  omorgnad_av_1_A = compoundA (regA "omorgnad") ;
  omoppad_av_1_A = compoundA (regA "omoppad") ;
  omonterad_av_1_A = compoundA (regA "omonterad") ;
  omonopoliserad_av_1_A = compoundA (regA "omonopoliserad") ;
  omonoftongerad_av_1_A = compoundA (regA "omonoftongerad") ;
  omodaerniserad_av_1_1_A = compoundA (regA "omodärniserad") ;
  omodulerad_av_1_A = compoundA (regA "omodulerad") ;
  omodifierad_av_1_A = compoundA (regA "omodifierad") ;
  omoderniserad_av_1_A = compoundA (regA "omoderniserad") ;
  omodererad_av_1_A = compoundA (regA "omodererad") ;
  omodellerad_av_1_A = compoundA (regA "omodellerad") ;
  omockad_av_1_A = compoundA (regA "omockad") ;
  omobiliserad_av_1_A = compoundA (regA "omobiliserad") ;
  omobbad_av_1_A = compoundA (regA "omobbad") ;
  omkullknuffad_av_1_A = compoundA (regA "omkullknuffad") ;
  omjoelkad_av_1_1_A = compoundA (regA "omjölkad") ;
  omjoelad_av_1_1_A = compoundA (regA "omjölad") ;
  omjukad_av_1_A = compoundA (regA "omjukad") ;
  omixad_av_1_A = compoundA (regA "omixad") ;
  omisskrediterad_av_1_A = compoundA (regA "omisskrediterad") ;
  omissiverad_av_1_A = compoundA (regA "omissiverad") ;
  omissad_av_1_A = compoundA (regA "omissad") ;
  ominskad_av_1_A = compoundA (regA "ominskad") ;
  ominimerad_av_1_A = compoundA (regA "ominimerad") ;
  ominiatyriserad_av_1_A = compoundA (regA "ominiatyriserad") ;
  omineraliserad_av_1_A = compoundA (regA "omineraliserad") ;
  ominerad_av_1_A = compoundA (regA "ominerad") ;
  omimad_av_1_A = compoundA (regA "omimad") ;
  omilitariserad_av_1_A = compoundA (regA "omilitariserad") ;
  omildrad_av_1_A = compoundA (regA "omildrad") ;
  omikroskoperad_av_1_A = compoundA (regA "omikroskoperad") ;
  omikrad_av_1_A = compoundA (regA "omikrad") ;
  omicrad_av_1_A = compoundA (regA "omicrad") ;
  omfladdrad_av_1_A = compoundA (regA "omfladdrad") ;
  ometalliserad_av_1_A = compoundA (regA "ometalliserad") ;
  omessad_av_1_A = compoundA (regA "omessad") ;
  omeriterad_av_1_A = compoundA (regA "omeriterad") ;
  omerceriserad_av_1_A = compoundA (regA "omerceriserad") ;
  omemorerad_av_1_A = compoundA (regA "omemorerad") ;
  omekaniserad_av_1_A = compoundA (regA "omekaniserad") ;
  omejslad_av_1_A = compoundA (regA "omejslad") ;
  omejlad_av_1_A = compoundA (regA "omejlad") ;
  omejad_av_1_A = compoundA (regA "omejad") ;
  omedicinerad_av_1_A = compoundA (regA "omedicinerad") ;
  omedaljerad_av_1_A = compoundA (regA "omedaljerad") ;
  omdiskuterad_av_1_A = compoundA (regA "omdiskuterad") ;
  omdebatterad_av_1_A = compoundA (regA "omdebatterad") ;
  ombonad_av_1_A = compoundA (regA "ombonad") ;
  omaximerad_av_1_A = compoundA (regA "omaximerad") ;
  omaxad_av_1_A = compoundA (regA "omaxad") ;
  omatterad_av_1_A = compoundA (regA "omatterad") ;
  omattad_av_1_A = compoundA (regA "omattad") ;
  omaterialiserad_av_1_A = compoundA (regA "omaterialiserad") ;
  omatelasserad_av_1_A = compoundA (regA "omatelasserad") ;
  omatchad_av_1_A = compoundA (regA "omatchad") ;
  omatad_av_1_A = compoundA (regA "omatad") ;
  omastad_av_1_A = compoundA (regA "omastad") ;
  omasserad_av_1_A = compoundA (regA "omasserad") ;
  omassakrerad_av_1_A = compoundA (regA "omassakrerad") ;
  omaskuliniserad_av_1_A = compoundA (regA "omaskuliniserad") ;
  omaskerad_av_1_A = compoundA (regA "omaskerad") ;
  omaskad_av_1_A = compoundA (regA "omaskad") ;
  omasad_av_1_A = compoundA (regA "omasad") ;
  omarterad_av_1_A = compoundA (regA "omarterad") ;
  omarmorerad_av_1_A = compoundA (regA "omarmorerad") ;
  omarkerad_av_1_A = compoundA (regA "omarkerad") ;
  omarinerad_av_1_A = compoundA (regA "omarinerad") ;
  omarginaliserad_av_1_A = compoundA (regA "omarginaliserad") ;
  omanoevrerad_av_1_1_A = compoundA (regA "omanövrerad") ;
  omantlad_av_1_A = compoundA (regA "omantlad") ;
  omanipulerad_av_1_A = compoundA (regA "omanipulerad") ;
  omanikyrerad_av_1_A = compoundA (regA "omanikyrerad") ;
  omanikurerad_av_1_A = compoundA (regA "omanikurerad") ;
  omanifesterad_av_1_A = compoundA (regA "omanifesterad") ;
  omanglad_av_1_A = compoundA (regA "omanglad") ;
  omanad_av_1_A = compoundA (regA "omanad") ;
  omaltraeterad_av_1_1_A = compoundA (regA "omalträterad") ;
  omalmad_av_1_A = compoundA (regA "omalmad") ;
  omalfoberad_av_1_A = compoundA (regA "omalfoberad") ;
  omakulerad_av_1_A = compoundA (regA "omakulerad") ;
  omakad_av_1_A = compoundA (regA "omakad") ;
  omajad_av_1_A = compoundA (regA "omajad") ;
  omailad_av_1_A = compoundA (regA "omailad") ;
  omagnetiserad_av_1_A = compoundA (regA "omagnetiserad") ;
  omagasinerad_av_1_A = compoundA (regA "omagasinerad") ;
  omadrasserad_av_1_A = compoundA (regA "omadrasserad") ;
  oloevad_av_1_1_A = compoundA (regA "olövad") ;
  oloenad_av_1_1_A = compoundA (regA "olönad") ;
  oloegad_av_1_1_A = compoundA (regA "olögad") ;
  olaatsad_av_1_1_A = compoundA (regA "olåtsad") ;
  olaassad_av_1_1_A = compoundA (regA "olåssad") ;
  olaanad_av_1_1_A = compoundA (regA "olånad") ;
  olaettrad_av_1_1_A = compoundA (regA "olättrad") ;
  olaettad_av_1_1_A = compoundA (regA "olättad") ;
  olaeskad_av_1_1_A = compoundA (regA "oläskad") ;
  olaensad_av_1_1_A = compoundA (regA "olänsad") ;
  olaenkad_av_1_1_A = compoundA (regA "olänkad") ;
  olaempad_av_1_1_A = compoundA (regA "olämpad") ;
  olaemnad_av_1_1_A = compoundA (regA "olämnad") ;
  olaektrad_av_1_1_A = compoundA (regA "oläktrad") ;
  olaegrad_av_1_1_A = compoundA (regA "olägrad") ;
  olaederad_av_1_1_A = compoundA (regA "oläderad") ;
  olyxrenoverad_av_1_A = compoundA (regA "olyxrenoverad") ;
  olyrad_av_1_A = compoundA (regA "olyrad") ;
  olynchad_av_1_A = compoundA (regA "olynchad") ;
  olyktad_av_1_A = compoundA (regA "olyktad") ;
  olycksdrabbad_av_1_A = compoundA (regA "olycksdrabbad") ;
  oluttrad_av_1_A = compoundA (regA "oluttrad") ;
  oluteiniserad_av_1_A = compoundA (regA "oluteiniserad") ;
  olutad_av_1_A = compoundA (regA "olutad") ;
  olurad_av_1_A = compoundA (regA "olurad") ;
  olunnad_av_1_A = compoundA (regA "olunnad") ;
  oluktad_av_1_A = compoundA (regA "oluktad") ;
  olugnad_av_1_A = compoundA (regA "olugnad") ;
  oluggad_av_1_A = compoundA (regA "oluggad") ;
  oluftad_av_1_A = compoundA (regA "oluftad") ;
  oluckrad_av_1_A = compoundA (regA "oluckrad") ;
  olovad_av_1_A = compoundA (regA "olovad") ;
  olottad_av_1_A = compoundA (regA "olottad") ;
  olotsad_av_1_A = compoundA (regA "olotsad") ;
  olossad_av_1_A = compoundA (regA "olossad") ;
  oloppad_av_1_A = compoundA (regA "oloppad") ;
  olokaliserad_av_1_A = compoundA (regA "olokaliserad") ;
  ologgad_av_1_A = compoundA (regA "ologgad") ;
  ologerad_av_1_A = compoundA (regA "ologerad") ;
  olodad_av_1_A = compoundA (regA "olodad") ;
  olockoutad_av_1_A = compoundA (regA "olockoutad") ;
  olockad_av_1_A = compoundA (regA "olockad") ;
  olobbad_av_1_A = compoundA (regA "olobbad") ;
  oljustrad_av_1_A = compoundA (regA "oljustrad") ;
  oljudad_av_1_A = compoundA (regA "oljudad") ;
  oljeskadad_av_1_A = compoundA (regA "oljeskadad") ;
  oljeblandad_av_1_A = compoundA (regA "oljeblandad") ;
  oljebaserad_av_1_A = compoundA (regA "oljebaserad") ;
  olivfaergad_av_1_1_A = compoundA (regA "olivfärgad") ;
  olivad_av_1_A = compoundA (regA "olivad") ;
  olitsad_av_1_A = compoundA (regA "olitsad") ;
  olitograferad_av_1_A = compoundA (regA "olitograferad") ;
  olistad_av_1_A = compoundA (regA "olistad") ;
  olisserad_av_1_A = compoundA (regA "olisserad") ;
  olirad_av_1_A = compoundA (regA "olirad") ;
  olinjerad_av_1_A = compoundA (regA "olinjerad") ;
  olindrad_av_1_A = compoundA (regA "olindrad") ;
  olindad_av_1_A = compoundA (regA "olindad") ;
  olimmad_av_1_A = compoundA (regA "olimmad") ;
  olikviderad_av_1_A = compoundA (regA "olikviderad") ;
  olikfaergad_av_1_1_A = compoundA (regA "olikfärgad") ;
  olikartad_av_1_A = compoundA (regA "olikartad") ;
  olikad_av_1_A = compoundA (regA "olikad") ;
  olierad_av_1_A = compoundA (regA "olierad") ;
  olicentierad_av_1_A = compoundA (regA "olicentierad") ;
  olicensierad_av_1_A = compoundA (regA "olicensierad") ;
  olicenserad_av_1_A = compoundA (regA "olicenserad") ;
  oliberaliserad_av_1_A = compoundA (regA "oliberaliserad") ;
  olevererad_av_1_A = compoundA (regA "olevererad") ;
  olettrad_av_1_A = compoundA (regA "olettrad") ;
  oletad_av_1_A = compoundA (regA "oletad") ;
  olenad_av_1_A = compoundA (regA "olenad") ;
  olemlaestad_av_1_1_A = compoundA (regA "olemlästad") ;
  olejdrad_av_1_A = compoundA (regA "olejdrad") ;
  olegitimerad_av_1_A = compoundA (regA "olegitimerad") ;
  olegerad_av_1_A = compoundA (regA "olegerad") ;
  olegaliserad_av_1_A = compoundA (regA "olegaliserad") ;
  oledsagad_av_1_A = compoundA (regA "oledsagad") ;
  oledad_av_1_A = compoundA (regA "oledad") ;
  oleasad_av_1_A = compoundA (regA "oleasad") ;
  olaxad_av_1_A = compoundA (regA "olaxad") ;
  olaverad_av_1_A = compoundA (regA "olaverad") ;
  olatiniserad_av_1_A = compoundA (regA "olatiniserad") ;
  olastad_av_1_A = compoundA (regA "olastad") ;
  olaskad_av_1_A = compoundA (regA "olaskad") ;
  olaserad_av_1_A = compoundA (regA "olaserad") ;
  olarmad_av_1_A = compoundA (regA "olarmad") ;
  olappad_av_1_A = compoundA (regA "olappad") ;
  olapiserad_av_1_A = compoundA (regA "olapiserad") ;
  olapad_av_1_A = compoundA (regA "olapad") ;
  olanserad_av_1_A = compoundA (regA "olanserad") ;
  olangetterad_av_1_A = compoundA (regA "olangetterad") ;
  olangad_av_1_A = compoundA (regA "olangad") ;
  olandad_av_1_A = compoundA (regA "olandad") ;
  olaminerad_av_1_A = compoundA (regA "olaminerad") ;
  olamenterad_av_1_A = compoundA (regA "olamenterad") ;
  olagrad_av_1_A = compoundA (regA "olagrad") ;
  olaggad_av_1_A = compoundA (regA "olaggad") ;
  olagad_av_1_A = compoundA (regA "olagad") ;
  oladdad_av_1_A = compoundA (regA "oladdad") ;
  olackerad_av_1_A = compoundA (regA "olackerad") ;
  olackad_av_1_A = compoundA (regA "olackad") ;
  olabialiserad_av_1_A = compoundA (regA "olabialiserad") ;
  okoernad_av_1_1_A = compoundA (regA "okörnad") ;
  okoenad_av_1_1_A = compoundA (regA "okönad") ;
  okaarad_av_1_1_A = compoundA (regA "okårad") ;
  okaankad_av_1_1_A = compoundA (regA "okånkad") ;
  okaernad_av_1_1_A = compoundA (regA "okärnad") ;
  okaerad_av_1_1_A = compoundA (regA "okärad") ;
  okaelad_av_1_1_A = compoundA (regA "okälad") ;
  okaekad_av_1_1_A = compoundA (regA "okäkad") ;
  okyprad_av_1_A = compoundA (regA "okyprad") ;
  okvoterad_av_1_A = compoundA (regA "okvoterad") ;
  okvitterad_av_1_A = compoundA (regA "okvitterad") ;
  okvittad_av_1_A = compoundA (regA "okvittad") ;
  okvistad_av_1_A = compoundA (regA "okvistad") ;
  okviltad_av_1_A = compoundA (regA "okviltad") ;
  okvarstannad_av_1_A = compoundA (regA "okvarstannad") ;
  okvarlaemnad_av_1_1_A = compoundA (regA "okvarlämnad") ;
  okvantifierad_av_1_A = compoundA (regA "okvantifierad") ;
  okvalificerad_av_1_A = compoundA (regA "okvalificerad") ;
  okvadrerad_av_1_A = compoundA (regA "okvadrerad") ;
  okvaddad_av_1_A = compoundA (regA "okvaddad") ;
  okuverterad_av_1_A = compoundA (regA "okuverterad") ;
  okuvad_av_1_A = compoundA (regA "okuvad") ;
  okuschad_av_1_A = compoundA (regA "okuschad") ;
  okurtiserad_av_1_A = compoundA (regA "okurtiserad") ;
  okursiverad_av_1_A = compoundA (regA "okursiverad") ;
  okursad_av_1_A = compoundA (regA "okursad") ;
  okurerad_av_1_A = compoundA (regA "okurerad") ;
  okuraterad_av_1_A = compoundA (regA "okuraterad") ;
  okurad_av_1_A = compoundA (regA "okurad") ;
  okuperad_av_1_A = compoundA (regA "okuperad") ;
  okupad_av_1_A = compoundA (regA "okupad") ;
  okumulerad_av_1_A = compoundA (regA "okumulerad") ;
  okultiverad_av_1_A = compoundA (regA "okultiverad") ;
  okullpratad_av_1_A = compoundA (regA "okullpratad") ;
  okullkastad_av_1_A = compoundA (regA "okullkastad") ;
  okullad_av_1_A = compoundA (regA "okullad") ;
  okujonerad_av_1_A = compoundA (regA "okujonerad") ;
  okuggad_av_1_A = compoundA (regA "okuggad") ;
  okuberad_av_1_A = compoundA (regA "okuberad") ;
  okraeppad_av_1_1_A = compoundA (regA "okräppad") ;
  okryssad_av_1_A = compoundA (regA "okryssad") ;
  okrypterad_av_1_A = compoundA (regA "okrypterad") ;
  okryddad_av_1_A = compoundA (regA "okryddad") ;
  okrusad_av_1_A = compoundA (regA "okrusad") ;
  okrullad_av_1_A = compoundA (regA "okrullad") ;
  okrossad_av_1_A = compoundA (regA "okrossad") ;
  okromad_av_1_A = compoundA (regA "okromad") ;
  okroknad_av_1_A = compoundA (regA "okroknad") ;
  okrokad_av_1_A = compoundA (regA "okrokad") ;
  okrockad_av_1_A = compoundA (regA "okrockad") ;
  okritiserad_av_1_A = compoundA (regA "okritiserad") ;
  okritad_av_1_A = compoundA (regA "okritad") ;
  okristnad_av_1_A = compoundA (regA "okristnad") ;
  okristalliserad_av_1_A = compoundA (regA "okristalliserad") ;
  okringskansad_av_1_A = compoundA (regA "okringskansad") ;
  okringgaerdad_av_1_1_A = compoundA (regA "okringgärdad") ;
  okriminaliserad_av_1_A = compoundA (regA "okriminaliserad") ;
  okreverad_av_1_A = compoundA (regA "okreverad") ;
  okretad_av_1_A = compoundA (regA "okretad") ;
  okreperad_av_1_A = compoundA (regA "okreperad") ;
  okremerad_av_1_A = compoundA (regA "okremerad") ;
  okreerad_av_1_A = compoundA (regA "okreerad") ;
  okrediterad_av_1_A = compoundA (regA "okrediterad") ;
  okredensad_av_1_A = compoundA (regA "okredensad") ;
  okrattad_av_1_A = compoundA (regA "okrattad") ;
  okratsad_av_1_A = compoundA (regA "okratsad") ;
  okraschad_av_1_A = compoundA (regA "okraschad") ;
  okransad_av_1_A = compoundA (regA "okransad") ;
  okramad_av_1_A = compoundA (regA "okramad") ;
  okrafsad_av_1_A = compoundA (regA "okrafsad") ;
  okrackelerad_av_1_A = compoundA (regA "okrackelerad") ;
  okrackad_av_1_A = compoundA (regA "okrackad") ;
  okostymerad_av_1_A = compoundA (regA "okostymerad") ;
  okortad_av_1_A = compoundA (regA "okortad") ;
  okorsetterad_av_1_A = compoundA (regA "okorsetterad") ;
  okorsad_av_1_A = compoundA (regA "okorsad") ;
  okorrumperad_av_1_A = compoundA (regA "okorrumperad") ;
  okorrugerad_av_1_A = compoundA (regA "okorrugerad") ;
  okorroderad_av_1_A = compoundA (regA "okorroderad") ;
  okorrigerad_av_1_A = compoundA (regA "okorrigerad") ;
  okorrelerad_av_1_A = compoundA (regA "okorrelerad") ;
  okorpad_av_1_A = compoundA (regA "okorpad") ;
  okorkad_av_1_A = compoundA (regA "okorkad") ;
  okorad_av_1_A = compoundA (regA "okorad") ;
  okopplad_av_1_A = compoundA (regA "okopplad") ;
  okoppad_av_1_A = compoundA (regA "okoppad") ;
  okopierad_av_1_A = compoundA (regA "okopierad") ;
  okoordinerad_av_1_A = compoundA (regA "okoordinerad") ;
  okonvojerad_av_1_A = compoundA (regA "okonvojerad") ;
  okonverterad_av_1_A = compoundA (regA "okonverterad") ;
  okonverserad_av_1_A = compoundA (regA "okonverserad") ;
  okonvergerad_av_1_A = compoundA (regA "okonvergerad") ;
  okonturerad_av_1_A = compoundA (regA "okonturerad") ;
  okontrollerad_av_1_A = compoundA (regA "okontrollerad") ;
  okontribuerad_av_1_A = compoundA (regA "okontribuerad") ;
  okontrasterad_av_1_A = compoundA (regA "okontrasterad") ;
  okontrasignerad_av_1_A = compoundA (regA "okontrasignerad") ;
  okontramanderad_av_1_A = compoundA (regA "okontramanderad") ;
  okontrakterad_av_1_A = compoundA (regA "okontrakterad") ;
  okontraherad_av_1_A = compoundA (regA "okontraherad") ;
  okontoriserad_av_1_A = compoundA (regA "okontoriserad") ;
  okontingenterad_av_1_A = compoundA (regA "okontingenterad") ;
  okonterad_av_1_A = compoundA (regA "okonterad") ;
  okontaminerad_av_1_A = compoundA (regA "okontaminerad") ;
  okontaktad_av_1_A = compoundA (regA "okontaktad") ;
  okonsumerad_av_1_A = compoundA (regA "okonsumerad") ;
  okonsulterad_av_1_A = compoundA (regA "okonsulterad") ;
  okonstruerad_av_1_A = compoundA (regA "okonstruerad") ;
  okonstlad_av_1_A = compoundA (regA "okonstlad") ;
  okonstituerad_av_1_A = compoundA (regA "okonstituerad") ;
  okonsternerad_av_1_A = compoundA (regA "okonsternerad") ;
  okonstbevattnad_av_1_A = compoundA (regA "okonstbevattnad") ;
  okonstbefruktad_av_1_A = compoundA (regA "okonstbefruktad") ;
  okonstaterad_av_1_A = compoundA (regA "okonstaterad") ;
  okonsoliderad_av_1_A = compoundA (regA "okonsoliderad") ;
  okonsignerad_av_1_A = compoundA (regA "okonsignerad") ;
  okonserverad_av_1_A = compoundA (regA "okonserverad") ;
  okonkretiserad_av_1_A = compoundA (regA "okonkretiserad") ;
  okonkluderad_av_1_A = compoundA (regA "okonkluderad") ;
  okonjugerad_av_1_A = compoundA (regA "okonjugerad") ;
  okongruerad_av_1_A = compoundA (regA "okongruerad") ;
  okonfunderad_av_1_A = compoundA (regA "okonfunderad") ;
  okonfronterad_av_1_A = compoundA (regA "okonfronterad") ;
  okonfiskerad_av_1_A = compoundA (regA "okonfiskerad") ;
  okonfirmerad_av_1_A = compoundA (regA "okonfirmerad") ;
  okondolerad_av_1_A = compoundA (regA "okondolerad") ;
  okonditionerad_av_1_A = compoundA (regA "okonditionerad") ;
  okondenserad_av_1_A = compoundA (regA "okondenserad") ;
  okondemnerad_av_1_A = compoundA (regA "okondemnerad") ;
  okoncipierad_av_1_A = compoundA (regA "okoncipierad") ;
  okoncessionerad_av_1_A = compoundA (regA "okoncessionerad") ;
  okoncentrerad_av_1_A = compoundA (regA "okoncentrerad") ;
  okomprometterad_av_1_A = compoundA (regA "okomprometterad") ;
  okomprimerad_av_1_A = compoundA (regA "okomprimerad") ;
  okomposterad_av_1_A = compoundA (regA "okomposterad") ;
  okomponerad_av_1_A = compoundA (regA "okomponerad") ;
  okomplimenterad_av_1_A = compoundA (regA "okomplimenterad") ;
  okomplicerad_av_1_A = compoundA (regA "okomplicerad") ;
  okompletterad_av_1_A = compoundA (regA "okompletterad") ;
  okompilerad_av_1_A = compoundA (regA "okompilerad") ;
  okompenserad_av_1_A = compoundA (regA "okompenserad") ;
  okomparerad_av_1_A = compoundA (regA "okomparerad") ;
  okompad_av_1_A = compoundA (regA "okompad") ;
  okommuterad_av_1_A = compoundA (regA "okommuterad") ;
  okommunicerad_av_1_A = compoundA (regA "okommunicerad") ;
  okommunaliserad_av_1_A = compoundA (regA "okommunaliserad") ;
  okommersialiserad_av_1_A = compoundA (regA "okommersialiserad") ;
  okommersad_av_1_A = compoundA (regA "okommersad") ;
  okommenterad_av_1_A = compoundA (regA "okommenterad") ;
  okommenderad_av_1_A = compoundA (regA "okommenderad") ;
  okommaterad_av_1_A = compoundA (regA "okommaterad") ;
  nypaakommen_av_1_1_A = compoundA (regA "nypåkommen") ;
  nygammal_av_1_A = compoundA (regA "nygammal") ;
  nattgammal_av_1_A = compoundA (regA "nattgammal") ;
  lillgammal_av_1_A = compoundA (regA "lillgammal") ;
  lastgammal_av_1_A = compoundA (regA "lastgammal") ;
  lagakraftvunnen_av_1_A = compoundA (regA "lagakraftvunnen") ;
  kvartssekelgammal_av_1_A = compoundA (regA "kvartssekelgammal") ;
  jaemngammal_av_1_1_A = compoundA (regA "jämngammal") ;
  jaemgammal_av_1_1_A = compoundA (regA "jämgammal") ;
  hemkommen_av_1_A = compoundA (regA "hemkommen") ;
  halvgammal_av_1_A = compoundA (regA "halvgammal") ;
  fesljummen_av_1_A = compoundA (regA "fesljummen") ;
  dygnsgammal_av_1_A = compoundA (regA "dygnsgammal") ;
  ditkommen_av_1_A = compoundA (regA "ditkommen") ;
  vaenster_av_1_1_A = compoundA (regA "vänster") ;
  okombinerad_av_1_A = compoundA (regA "okombinerad") ;
  okolporterad_av_1_A = compoundA (regA "okolporterad") ;
  okolorerad_av_1_A = compoundA (regA "okolorerad") ;
  okoloniserad_av_1_A = compoundA (regA "okoloniserad") ;
  okollektiviserad_av_1_A = compoundA (regA "okollektiviserad") ;
  okollationerad_av_1_A = compoundA (regA "okollationerad") ;
  okollapsad_av_1_A = compoundA (regA "okollapsad") ;
  okollad_av_1_A = compoundA (regA "okollad") ;
  okolkad_av_1_A = compoundA (regA "okolkad") ;
  okolad_av_1_A = compoundA (regA "okolad") ;
  okojsad_av_1_A = compoundA (regA "okojsad") ;
  okojad_av_1_A = compoundA (regA "okojad") ;
  okodifierad_av_1_A = compoundA (regA "okodifierad") ;
  okodad_av_1_A = compoundA (regA "okodad") ;
  okoagulerad_av_1_A = compoundA (regA "okoagulerad") ;
  okoafferad_av_1_A = compoundA (regA "okoafferad") ;
  oknoelad_av_1_1_A = compoundA (regA "oknölad") ;
  oknaadad_av_1_1_A = compoundA (regA "oknådad") ;
  oknaead_av_1_1_A = compoundA (regA "oknäad") ;
  oknypplad_av_1_A = compoundA (regA "oknypplad") ;
  oknycklad_av_1_A = compoundA (regA "oknycklad") ;
  oknullad_av_1_A = compoundA (regA "oknullad") ;
  oknuffad_av_1_A = compoundA (regA "oknuffad") ;
  oknorvad_av_1_A = compoundA (regA "oknorvad") ;
  oknopad_av_1_A = compoundA (regA "oknopad") ;
  oknollrad_av_1_A = compoundA (regA "oknollrad") ;
  oknockad_av_1_A = compoundA (regA "oknockad") ;
  oknivad_av_1_A = compoundA (regA "oknivad") ;
  oknipsad_av_1_A = compoundA (regA "oknipsad") ;
  oknatad_av_1_A = compoundA (regA "oknatad") ;
  oknarkad_av_1_A = compoundA (regA "oknarkad") ;
  oknaprad_av_1_A = compoundA (regA "oknaprad") ;
  oknackad_av_1_A = compoundA (regA "oknackad") ;
  okloevjad_av_1_1_A = compoundA (regA "oklövjad") ;
  oklaettrad_av_1_1_A = compoundA (regA "oklättrad") ;
  oklyftad_av_1_A = compoundA (regA "oklyftad") ;
  okluddad_av_1_A = compoundA (regA "okluddad") ;
  oklubbad_av_1_A = compoundA (regA "oklubbad") ;
  oklottrad_av_1_A = compoundA (regA "oklottrad") ;
  oklorerad_av_1_A = compoundA (regA "oklorerad") ;
  oklonad_av_1_A = compoundA (regA "oklonad") ;
  oklockad_av_1_A = compoundA (regA "oklockad") ;
  oklistrad_av_1_A = compoundA (regA "oklistrad") ;
  oklirad_av_1_A = compoundA (regA "oklirad") ;
  okliad_av_1_A = compoundA (regA "okliad") ;
  okletad_av_1_A = compoundA (regA "okletad") ;
  oklenad_av_1_A = compoundA (regA "oklenad") ;
  oklatschad_av_1_A = compoundA (regA "oklatschad") ;
  oklassificerad_av_1_A = compoundA (regA "oklassificerad") ;
  oklassad_av_1_A = compoundA (regA "oklassad") ;
  oklarerad_av_1_A = compoundA (regA "oklarerad") ;
  oklarad_av_1_A = compoundA (regA "oklarad") ;
  oklappad_av_1_A = compoundA (regA "oklappad") ;
  oklandrad_av_1_A = compoundA (regA "oklandrad") ;
  oklamrad_av_1_A = compoundA (regA "oklamrad") ;
  oklampad_av_1_A = compoundA (regA "oklampad") ;
  oklackad_av_1_A = compoundA (regA "oklackad") ;
  okittlad_av_1_A = compoundA (regA "okittlad") ;
  okittad_av_1_A = compoundA (regA "okittad") ;
  okissad_av_1_A = compoundA (regA "okissad") ;
  okirrad_av_1_A = compoundA (regA "okirrad") ;
  okillad_av_1_A = compoundA (regA "okillad") ;
  okilad_av_1_A = compoundA (regA "okilad") ;
  okikad_av_1_A = compoundA (regA "okikad") ;
  okidnappad_av_1_A = compoundA (regA "okidnappad") ;
  okickad_av_1_A = compoundA (regA "okickad") ;
  okedjad_av_1_A = compoundA (regA "okedjad") ;
  okavlad_av_1_A = compoundA (regA "okavlad") ;
  okauteriserad_av_1_A = compoundA (regA "okauteriserad") ;
  okattad_av_1_A = compoundA (regA "okattad") ;
  okatetriserad_av_1_A = compoundA (regA "okatetriserad") ;
  okateteriserad_av_1_A = compoundA (regA "okateteriserad") ;
  okategoriserad_av_1_A = compoundA (regA "okategoriserad") ;
  okatalyserad_av_1_A = compoundA (regA "okatalyserad") ;
  okatalogiserad_av_1_A = compoundA (regA "okatalogiserad") ;
  okastrerad_av_1_A = compoundA (regA "okastrerad") ;
  okastad_av_1_A = compoundA (regA "okastad") ;
  okasserad_av_1_A = compoundA (regA "okasserad") ;
  okarvad_av_1_A = compoundA (regA "okarvad") ;
  okartonnerad_av_1_A = compoundA (regA "okartonnerad") ;
  okarterad_av_1_A = compoundA (regA "okarterad") ;
  okarikerad_av_1_A = compoundA (regA "okarikerad") ;
  okardad_av_1_A = compoundA (regA "okardad") ;
  okarboniserad_av_1_A = compoundA (regA "okarboniserad") ;
  okarambolerad_av_1_A = compoundA (regA "okarambolerad") ;
  okaraktaeriserad_av_1_1_A = compoundA (regA "okaraktäriserad") ;
  okarakteriserad_av_1_A = compoundA (regA "okarakteriserad") ;
  okarad_av_1_A = compoundA (regA "okarad") ;
  okapslad_av_1_A = compoundA (regA "okapslad") ;
  okapsejsad_av_1_A = compoundA (regA "okapsejsad") ;
  okapitaliserad_av_1_A = compoundA (regA "okapitaliserad") ;
  okapad_av_1_A = compoundA (regA "okapad") ;
  okantrad_av_1_A = compoundA (regA "okantrad") ;
  okantad_av_1_A = compoundA (regA "okantad") ;
  okanoniserad_av_1_A = compoundA (regA "okanoniserad") ;
  okannelerad_av_1_A = compoundA (regA "okannelerad") ;
  okanderad_av_1_A = compoundA (regA "okanderad") ;
  okanaliserad_av_1_A = compoundA (regA "okanaliserad") ;
  okamouflerad_av_1_A = compoundA (regA "okamouflerad") ;
  okammad_av_1_A = compoundA (regA "okammad") ;
  okalmerad_av_1_A = compoundA (regA "okalmerad") ;
  okallnad_av_1_A = compoundA (regA "okallnad") ;
  okallad_av_1_A = compoundA (regA "okallad") ;
  okalkylerad_av_1_A = compoundA (regA "okalkylerad") ;
  okalkerad_av_1_A = compoundA (regA "okalkerad") ;
  okalkad_av_1_A = compoundA (regA "okalkad") ;
  okalibrerad_av_1_A = compoundA (regA "okalibrerad") ;
  okalfatrad_av_1_A = compoundA (regA "okalfatrad") ;
  okalcinerad_av_1_A = compoundA (regA "okalcinerad") ;
  okalandrerad_av_1_A = compoundA (regA "okalandrerad") ;
  okaklad_av_1_A = compoundA (regA "okaklad") ;
  okablad_av_1_A = compoundA (regA "okablad") ;
  ojaevad_av_1_1_A = compoundA (regA "ojävad") ;
  ojaemnad_av_1_1_A = compoundA (regA "ojämnad") ;
  ojaemkad_av_1_1_A = compoundA (regA "ojämkad") ;
  ojaektad_av_1_1_A = compoundA (regA "ojäktad") ;
  ojusterad_av_1_A = compoundA (regA "ojusterad") ;
  ojordad_av_1_A = compoundA (regA "ojordad") ;
  ojoniserad_av_1_A = compoundA (regA "ojoniserad") ;
  ojonglerad_av_1_A = compoundA (regA "ojonglerad") ;
  ojollrad_av_1_A = compoundA (regA "ojollrad") ;
  ojojkad_av_1_A = compoundA (regA "ojojkad") ;
  ojoggad_av_1_A = compoundA (regA "ojoggad") ;
  ojoderad_av_1_A = compoundA (regA "ojoderad") ;
  ojoddlad_av_1_A = compoundA (regA "ojoddlad") ;
  ojazzifierad_av_1_A = compoundA (regA "ojazzifierad") ;
  ojakad_av_1_A = compoundA (regA "ojakad") ;
  ojagad_av_1_A = compoundA (regA "ojagad") ;
  ojabbad_av_1_A = compoundA (regA "ojabbad") ;
  oitutad_av_1_A = compoundA (regA "oitutad") ;
  oitererad_av_1_A = compoundA (regA "oitererad") ;
  oisolerad_av_1_A = compoundA (regA "oisolerad") ;
  oislamiserad_av_1_A = compoundA (regA "oislamiserad") ;
  oirriterad_av_1_A = compoundA (regA "oirriterad") ;
  oinoevad_av_1_1_A = compoundA (regA "oinövad") ;
  oinympad_av_1_A = compoundA (regA "oinympad") ;
  oinvaentad_av_1_1_A = compoundA (regA "oinväntad") ;
  oinvolverad_av_1_A = compoundA (regA "oinvolverad") ;
  oinviterad_av_1_A = compoundA (regA "oinviterad") ;
  oinvesterad_av_1_A = compoundA (regA "oinvesterad") ;
  oinverterad_av_1_A = compoundA (regA "oinverterad") ;
  oinventerad_av_1_A = compoundA (regA "oinventerad") ;
  oinvecklad_av_1_A = compoundA (regA "oinvecklad") ;
  oinvandrad_av_1_A = compoundA (regA "oinvandrad") ;
  oinvalidiserad_av_1_A = compoundA (regA "oinvalidiserad") ;
  oinvaggad_av_1_A = compoundA (regA "oinvaggad") ;
  oinvaderad_av_1_A = compoundA (regA "oinvaderad") ;
  ointaagad_av_1_1_A = compoundA (regA "ointågad") ;
  ointygad_av_1_A = compoundA (regA "ointygad") ;
  ointraeffad_av_1_1_A = compoundA (regA "ointräffad") ;
  ointrumfad_av_1_A = compoundA (regA "ointrumfad") ;
  ointroducerad_av_1_A = compoundA (regA "ointroducerad") ;
  ointresserad_av_1_A = compoundA (regA "ointresserad") ;
  ointonerad_av_1_A = compoundA (regA "ointonerad") ;
  ointolkad_av_1_A = compoundA (regA "ointolkad") ;
  ointervjuad_av_1_A = compoundA (regA "ointervjuad") ;
  ointervenerad_av_1_A = compoundA (regA "ointervenerad") ;
  ointerpunkterad_av_1_A = compoundA (regA "ointerpunkterad") ;
  ointerpreterad_av_1_A = compoundA (regA "ointerpreterad") ;
  ointerpolerad_av_1_A = compoundA (regA "ointerpolerad") ;
  ointerpellerad_av_1_A = compoundA (regA "ointerpellerad") ;
  ointernerad_av_1_A = compoundA (regA "ointernerad") ;
  ointernationaliserad_av_1_A = compoundA (regA "ointernationaliserad") ;
  ointernaliserad_av_1_A = compoundA (regA "ointernaliserad") ;
  ointerfolierad_av_1_A = compoundA (regA "ointerfolierad") ;
  ointensiverad_av_1_A = compoundA (regA "ointensiverad") ;
  ointensifierad_av_1_A = compoundA (regA "ointensifierad") ;
  ointellektualiserad_av_1_A = compoundA (regA "ointellektualiserad") ;
  ointegrerad_av_1_A = compoundA (regA "ointegrerad") ;
  ointecknad_av_1_A = compoundA (regA "ointecknad") ;
  oinsoendrad_av_1_1_A = compoundA (regA "oinsöndrad") ;
  oinstuderad_av_1_A = compoundA (regA "oinstuderad") ;
  oinstraalad_av_1_1_A = compoundA (regA "oinstrålad") ;
  oinstrumenterad_av_1_A = compoundA (regA "oinstrumenterad") ;
  oinstruerad_av_1_A = compoundA (regA "oinstruerad") ;
  oinstitutionaliserad_av_1_A = compoundA (regA "oinstitutionaliserad") ;
  oinstiftad_av_1_A = compoundA (regA "oinstiftad") ;
  oinstallerad_av_1_A = compoundA (regA "oinstallerad") ;
  oinspirerad_av_1_A = compoundA (regA "oinspirerad") ;
  oinspekterad_av_1_A = compoundA (regA "oinspekterad") ;
  oinsomnad_av_1_A = compoundA (regA "oinsomnad") ;
  oinskolad_av_1_A = compoundA (regA "oinskolad") ;
  oinskeppad_av_1_A = compoundA (regA "oinskeppad") ;
  oinskaffad_av_1_A = compoundA (regA "oinskaffad") ;
  oinsjuknad_av_1_A = compoundA (regA "oinsjuknad") ;
  oinsisterad_av_1_A = compoundA (regA "oinsisterad") ;
  oinsinuerad_av_1_A = compoundA (regA "oinsinuerad") ;
  oinseminerad_av_1_A = compoundA (regA "oinseminerad") ;
  oinseglad_av_1_A = compoundA (regA "oinseglad") ;
  oinscenerad_av_1_A = compoundA (regA "oinscenerad") ;
  oinsamlad_av_1_A = compoundA (regA "oinsamlad") ;
  oinraettad_av_1_1_A = compoundA (regA "oinrättad") ;
  oinraeknad_av_1_1_A = compoundA (regA "oinräknad") ;
  oinropad_av_1_A = compoundA (regA "oinropad") ;
  oinristad_av_1_A = compoundA (regA "oinristad") ;
  oinringad_av_1_A = compoundA (regA "oinringad") ;
  oinriktad_av_1_A = compoundA (regA "oinriktad") ;
  oinregistrerad_av_1_A = compoundA (regA "oinregistrerad") ;
  oinrapporterad_av_1_A = compoundA (regA "oinrapporterad") ;
  oinrangerad_av_1_A = compoundA (regA "oinrangerad") ;
  oinramad_av_1_A = compoundA (regA "oinramad") ;
  oinpraentad_av_1_1_A = compoundA (regA "oinpräntad") ;
  oinpraeglad_av_1_1_A = compoundA (regA "oinpräglad") ;
  oinprickad_av_1_A = compoundA (regA "oinprickad") ;
  oinpressad_av_1_A = compoundA (regA "oinpressad") ;
  oinplanterad_av_1_A = compoundA (regA "oinplanterad") ;
  oinplantad_av_1_A = compoundA (regA "oinplantad") ;
  oinpassad_av_1_A = compoundA (regA "oinpassad") ;
  oinordnad_av_1_A = compoundA (regA "oinordnad") ;
  oinoljad_av_1_A = compoundA (regA "oinoljad") ;
  oinokulerad_av_1_A = compoundA (regA "oinokulerad") ;
  oinnerverad_av_1_A = compoundA (regA "oinnerverad") ;
  oinnefattad_av_1_A = compoundA (regA "oinnefattad") ;
  oinmoenstrad_av_1_1_A = compoundA (regA "oinmönstrad") ;
  oinmundigad_av_1_A = compoundA (regA "oinmundigad") ;
  oinmatad_av_1_A = compoundA (regA "oinmatad") ;
  oinlaanad_av_1_1_A = compoundA (regA "oinlånad") ;
  oinlaemnad_av_1_1_A = compoundA (regA "oinlämnad") ;
  oinlemmad_av_1_A = compoundA (regA "oinlemmad") ;
  oinkvarterad_av_1_A = compoundA (regA "oinkvarterad") ;
  oinkorporerad_av_1_A = compoundA (regA "oinkorporerad") ;
  oinkopplad_av_1_A = compoundA (regA "oinkopplad") ;
  oinkluderad_av_1_A = compoundA (regA "oinkluderad") ;
  oinklarerad_av_1_A = compoundA (regA "oinklarerad") ;
  oinkasserad_av_1_A = compoundA (regA "oinkasserad") ;
  oinkarnerad_av_1_A = compoundA (regA "oinkarnerad") ;
  oinkapslad_av_1_A = compoundA (regA "oinkapslad") ;
  oinkallad_av_1_A = compoundA (regA "oinkallad") ;
  oinjicerad_av_1_A = compoundA (regA "oinjicerad") ;
  oinjekterad_av_1_A = compoundA (regA "oinjekterad") ;
  oinjagad_av_1_A = compoundA (regA "oinjagad") ;
  oinitierad_av_1_A = compoundA (regA "oinitierad") ;
  oinhoestad_av_1_1_A = compoundA (regA "oinhöstad") ;
  oinhaemtad_av_1_1_A = compoundA (regA "oinhämtad") ;
  oinhaegnad_av_1_1_A = compoundA (regA "oinhägnad") ;
  oinhibiterad_av_1_A = compoundA (regA "oinhibiterad") ;
  oinhiberad_av_1_A = compoundA (regA "oinhiberad") ;
  oinhandlad_av_1_A = compoundA (regA "oinhandlad") ;
  oinhalerad_av_1_A = compoundA (regA "oinhalerad") ;
  oingraverad_av_1_A = compoundA (regA "oingraverad") ;
  oinfoerskaffad_av_1_1_A = compoundA (regA "oinförskaffad") ;
  oinfoerlivad_av_1_1_A = compoundA (regA "oinförlivad") ;
  oinfaangad_av_1_1_A = compoundA (regA "oinfångad") ;
  oinfriad_av_1_A = compoundA (regA "oinfriad") ;
  oinformerad_av_1_A = compoundA (regA "oinformerad") ;
  oinfordrad_av_1_A = compoundA (regA "oinfordrad") ;
  oinfogad_av_1_A = compoundA (regA "oinfogad") ;
  oinfodrad_av_1_A = compoundA (regA "oinfodrad") ;
  oinflaetad_av_1_1_A = compoundA (regA "oinflätad") ;
  oinflyttad_av_1_A = compoundA (regA "oinflyttad") ;
  oinfluerad_av_1_A = compoundA (regA "oinfluerad") ;
  oinflammerad_av_1_A = compoundA (regA "oinflammerad") ;
  oinfiltrerad_av_1_A = compoundA (regA "oinfiltrerad") ;
  oinfettad_av_1_A = compoundA (regA "oinfettad") ;
  oinfekterad_av_1_A = compoundA (regA "oinfekterad") ;
  oinfattad_av_1_A = compoundA (regA "oinfattad") ;
  oindustrialiserad_av_1_A = compoundA (regA "oindustrialiserad") ;
  oindunstad_av_1_A = compoundA (regA "oindunstad") ;
  oinducerad_av_1_A = compoundA (regA "oinducerad") ;
  oindoktrinerad_av_1_A = compoundA (regA "oindoktrinerad") ;
  oindividualiserad_av_1_A = compoundA (regA "oindividualiserad") ;
  oindikerad_av_1_A = compoundA (regA "oindikerad") ;
  oindicerad_av_1_A = compoundA (regA "oindicerad") ;
  oindexerad_av_1_A = compoundA (regA "oindexerad") ;
  oindelad_av_1_A = compoundA (regA "oindelad") ;
  oinblandad_av_1_A = compoundA (regA "oinblandad") ;
  oinbillad_av_1_A = compoundA (regA "oinbillad") ;
  oinbesparad_av_1_A = compoundA (regA "oinbesparad") ;
  oinberaeknad_av_1_1_A = compoundA (regA "oinberäknad") ;
  oinbakad_av_1_A = compoundA (regA "oinbakad") ;
  oinaugurerad_av_1_A = compoundA (regA "oinaugurerad") ;
  oinarbetad_av_1_A = compoundA (regA "oinarbetad") ;
  oinackorderad_av_1_A = compoundA (regA "oinackorderad") ;
  oimproviserad_av_1_A = compoundA (regA "oimproviserad") ;
  oimpregnerad_av_1_A = compoundA (regA "oimpregnerad") ;
  oimporterad_av_1_A = compoundA (regA "oimporterad") ;
  oimponerad_av_1_A = compoundA (regA "oimponerad") ;
  oimploderad_av_1_A = compoundA (regA "oimploderad") ;
  oimplicerad_av_1_A = compoundA (regA "oimplicerad") ;
  oimplanterad_av_1_A = compoundA (regA "oimplanterad") ;
  oimpad_av_1_A = compoundA (regA "oimpad") ;
  oimmuniserad_av_1_A = compoundA (regA "oimmuniserad") ;
  oimmigrerad_av_1_A = compoundA (regA "oimmigrerad") ;
  oimmatrikulerad_av_1_A = compoundA (regA "oimmatrikulerad") ;
  oimiterad_av_1_A = compoundA (regA "oimiterad") ;
  oillustrerad_av_1_A = compoundA (regA "oillustrerad") ;
  oilluminerad_av_1_A = compoundA (regA "oilluminerad") ;
  oignorerad_av_1_A = compoundA (regA "oignorerad") ;
  oidkad_av_1_A = compoundA (regA "oidkad") ;
  oidisslad_av_1_A = compoundA (regA "oidisslad") ;
  oidentifierad_av_1_A = compoundA (regA "oidentifierad") ;
  oidealiserad_av_1_A = compoundA (regA "oidealiserad") ;
  ohoersammad_av_1_1_A = compoundA (regA "ohörsammad") ;
  ohoegaktad_av_1_1_A = compoundA (regA "ohögaktad") ;
  ohaavad_av_1_1_A = compoundA (regA "ohåvad") ;
  ohaardnad_av_1_1_A = compoundA (regA "ohårdnad") ;
  ohaanad_av_1_1_A = compoundA (regA "ohånad") ;
  ohaalad_av_1_1_A = compoundA (regA "ohålad") ;
  ohaagad_av_1_1_A = compoundA (regA "ohågad") ;
  ohaevdad_av_1_1_A = compoundA (regA "ohävdad") ;
  ohaessjad_av_1_1_A = compoundA (regA "ohässjad") ;
  ohaersknad_av_1_1_A = compoundA (regA "ohärsknad") ;
  ohaermad_av_1_1_A = compoundA (regA "ohärmad") ;
  ohaerjad_av_1_1_A = compoundA (regA "ohärjad") ;
  ohaerdad_av_1_1_A = compoundA (regA "ohärdad") ;
  ohaerbaergerad_av_1_1_A = compoundA (regA "ohärbärgerad") ;
  ohaenvisad_av_1_1_A = compoundA (regA "ohänvisad") ;
  ohaemtad_av_1_1_A = compoundA (regA "ohämtad") ;
  ohaemnad_av_1_1_A = compoundA (regA "ohämnad") ;
  ohaemmad_av_1_1_A = compoundA (regA "ohämmad") ;
  ohaelsad_av_1_1_A = compoundA (regA "ohälsad") ;
  ohaektad_av_1_1_A = compoundA (regA "ohäktad") ;
  ohaegnad_av_1_1_A = compoundA (regA "ohägnad") ;
  ohaeftad_av_1_1_A = compoundA (regA "ohäftad") ;
  ohaedankallad_av_1_1_A = compoundA (regA "ohädankallad") ;
  ohaecklad_av_1_1_A = compoundA (regA "ohäcklad") ;
  ohyvlad_av_1_A = compoundA (regA "ohyvlad") ;
  ohyvad_av_1_A = compoundA (regA "ohyvad") ;
  ohystad_av_1_A = compoundA (regA "ohystad") ;
  ohyssjad_av_1_A = compoundA (regA "ohyssjad") ;
  ohypotiserad_av_1_A = compoundA (regA "ohypotiserad") ;
  ohypnotiserad_av_1_A = compoundA (regA "ohypnotiserad") ;
  ohyllad_av_1_A = compoundA (regA "ohyllad") ;
  ohyfsad_av_1_A = compoundA (regA "ohyfsad") ;
  ohydrerad_av_1_A = compoundA (regA "ohydrerad") ;
  ohycklad_av_1_A = compoundA (regA "ohycklad") ;
  ohybridiserad_av_1_A = compoundA (regA "ohybridiserad") ;
  ohuserad_av_1_A = compoundA (regA "ohuserad") ;
  ohunsad_av_1_A = compoundA (regA "ohunsad") ;
  ohundsfotterad_av_1_A = compoundA (regA "ohundsfotterad") ;
  ohundsad_av_1_A = compoundA (regA "ohundsad") ;
  ohumaniserad_av_1_A = compoundA (regA "ohumaniserad") ;
  ohugnad_av_1_A = compoundA (regA "ohugnad") ;
  ohottad_av_1_A = compoundA (regA "ohottad") ;
  ohotad_av_1_A = compoundA (regA "ohotad") ;
  ohostad_av_1_A = compoundA (regA "ohostad") ;
  ohospitaliserad_av_1_A = compoundA (regA "ohospitaliserad") ;
  ohoppad_av_1_A = compoundA (regA "ohoppad") ;
  ohoplappad_av_1_A = compoundA (regA "ohoplappad") ;
  ohopfogad_av_1_A = compoundA (regA "ohopfogad") ;
  ohopdiktad_av_1_A = compoundA (regA "ohopdiktad") ;
  ohopad_av_1_A = compoundA (regA "ohopad") ;
  ohonorerad_av_1_A = compoundA (regA "ohonorerad") ;
  ohomogeniserad_av_1_A = compoundA (regA "ohomogeniserad") ;
  oholograferad_av_1_A = compoundA (regA "oholograferad") ;
  ohivad_av_1_A = compoundA (regA "ohivad") ;
  ohittad_av_1_A = compoundA (regA "ohittad") ;
  ohistoriserad_av_1_A = compoundA (regA "ohistoriserad") ;
  ohistorierad_av_1_A = compoundA (regA "ohistorierad") ;
  ohissad_av_1_A = compoundA (regA "ohissad") ;
  ohinkad_av_1_A = compoundA (regA "ohinkad") ;
  ohindrad_av_1_A = compoundA (regA "ohindrad") ;
  ohetsad_av_1_A = compoundA (regA "ohetsad") ;
  oheroiserad_av_1_A = compoundA (regA "oheroiserad") ;
  ohenad_av_1_A = compoundA (regA "ohenad") ;
  ohelgad_av_1_A = compoundA (regA "ohelgad") ;
  ohelad_av_1_A = compoundA (regA "ohelad") ;
  ohejdad_av_1_A = compoundA (regA "ohejdad") ;
  ohejad_av_1_A = compoundA (regA "ohejad") ;
  ohedrad_av_1_A = compoundA (regA "ohedrad") ;
  ohavererad_av_1_A = compoundA (regA "ohavererad") ;
  ohaussad_av_1_A = compoundA (regA "ohaussad") ;
  ohatad_av_1_A = compoundA (regA "ohatad") ;
  ohasplad_av_1_A = compoundA (regA "ohasplad") ;
  ohaspad_av_1_A = compoundA (regA "ohaspad") ;
  ohasarderad_av_1_A = compoundA (regA "ohasarderad") ;
  ohasad_av_1_A = compoundA (regA "ohasad") ;
  oharvad_av_1_A = compoundA (regA "oharvad") ;
  ohartsad_av_1_A = compoundA (regA "ohartsad") ;
  oharpunerad_av_1_A = compoundA (regA "oharpunerad") ;
  oharmoniserad_av_1_A = compoundA (regA "oharmoniserad") ;
  oharmad_av_1_A = compoundA (regA "oharmad") ;
  oharangerad_av_1_A = compoundA (regA "oharangerad") ;
  ohanterad_av_1_A = compoundA (regA "ohanterad") ;
  ohandlad_av_1_A = compoundA (regA "ohandlad") ;
  ohandikappad_av_1_A = compoundA (regA "ohandikappad") ;
  ohamstrad_av_1_A = compoundA (regA "ohamstrad") ;
  ohamrad_av_1_A = compoundA (regA "ohamrad") ;
  ohamlad_av_1_A = compoundA (regA "ohamlad") ;
  ohalverad_av_1_A = compoundA (regA "ohalverad") ;
  ohalstrad_av_1_A = compoundA (regA "ohalstrad") ;
  ohalsad_av_1_A = compoundA (regA "ohalsad") ;
  ohallucinerad_av_1_A = compoundA (regA "ohallucinerad") ;
  ohalad_av_1_A = compoundA (regA "ohalad") ;
  ohakad_av_1_A = compoundA (regA "ohakad") ;
  ohajad_av_1_A = compoundA (regA "ohajad") ;
  ohaffad_av_1_A = compoundA (regA "ohaffad") ;
  ohackad_av_1_A = compoundA (regA "ohackad") ;
  ogoerdlad_av_1_1_A = compoundA (regA "ogördlad") ;
  ogoekad_av_1_1_A = compoundA (regA "ogökad") ;
  ogoedslad_av_1_1_A = compoundA (regA "ogödslad") ;
  ogaangrad_av_1_1_A = compoundA (regA "ogångrad") ;
  ogaestad_av_1_1_A = compoundA (regA "ogästad") ;
  ogaerdslad_av_1_1_A = compoundA (regA "ogärdslad") ;
  ogaerdad_av_1_1_A = compoundA (regA "ogärdad") ;
  ogaengad_av_1_1_A = compoundA (regA "ogängad") ;
  ogaelad_av_1_1_A = compoundA (regA "ogälad") ;
  ogaeckad_av_1_1_A = compoundA (regA "ogäckad") ;
  ogynnad_av_1_A = compoundA (regA "ogynnad") ;
  ogymnastiserad_av_1_A = compoundA (regA "ogymnastiserad") ;
  oguterad_av_1_A = compoundA (regA "oguterad") ;
  oguskad_av_1_A = compoundA (regA "oguskad") ;
  ogurglad_av_1_A = compoundA (regA "ogurglad") ;
  ogungad_av_1_A = compoundA (regA "ogungad") ;
  ogummerad_av_1_A = compoundA (regA "ogummerad") ;
  ogulnad_av_1_A = compoundA (regA "ogulnad") ;
  oguidad_av_1_A = compoundA (regA "oguidad") ;
  ogroepad_av_1_1_A = compoundA (regA "ogröpad") ;
  ograanad_av_1_1_A = compoundA (regA "ogrånad") ;
  ograesbekaempad_av_1_1_A = compoundA (regA "ogräsbekämpad") ;
  ograenslad_av_1_1_A = compoundA (regA "ogränslad") ;
  ograeftad_av_1_1_A = compoundA (regA "ogräftad") ;
  ograeddad_av_1_1_A = compoundA (regA "ogräddad") ;
  ogrusad_av_1_A = compoundA (regA "ogrusad") ;
  ogrupperad_av_1_A = compoundA (regA "ogrupperad") ;
  ogrunderad_av_1_A = compoundA (regA "ogrunderad") ;
  ogrundad_av_1_A = compoundA (regA "ogrundad") ;
  ogrumsad_av_1_A = compoundA (regA "ogrumsad") ;
  ogrumlad_av_1_A = compoundA (regA "ogrumlad") ;
  ogroddad_av_1_A = compoundA (regA "ogroddad") ;
  ogrimerad_av_1_A = compoundA (regA "ogrimerad") ;
  ogrillad_av_1_A = compoundA (regA "ogrillad") ;
  ogriljerad_av_1_A = compoundA (regA "ogriljerad") ;
  ogreppad_av_1_A = compoundA (regA "ogreppad") ;
  ogrenslad_av_1_A = compoundA (regA "ogrenslad") ;
  ogrenad_av_1_A = compoundA (regA "ogrenad") ;
  ogrejad_av_1_A = compoundA (regA "ogrejad") ;
  ograverad_av_1_A = compoundA (regA "ograverad") ;
  ogravad_av_1_A = compoundA (regA "ogravad") ;
  ogratulerad_av_1_A = compoundA (regA "ogratulerad") ;
  ograttad_av_1_A = compoundA (regA "ograttad") ;
  ogratinerad_av_1_A = compoundA (regA "ogratinerad") ;
  ogranulerad_av_1_A = compoundA (regA "ogranulerad") ;
  ogranskad_av_1_A = compoundA (regA "ogranskad") ;
  ografiterad_av_1_A = compoundA (regA "ografiterad") ;
  ograduerad_av_1_A = compoundA (regA "ograduerad") ;
  ograderad_av_1_A = compoundA (regA "ograderad") ;
  ogradad_av_1_A = compoundA (regA "ogradad") ;
  ograbbad_av_1_A = compoundA (regA "ograbbad") ;
  ogouterad_av_1_A = compoundA (regA "ogouterad") ;
  ogooglad_av_1_A = compoundA (regA "ogooglad") ;
  ogolvad_av_1_A = compoundA (regA "ogolvad") ;
  ogoffrerad_av_1_A = compoundA (regA "ogoffrerad") ;
  ognuggad_av_1_A = compoundA (regA "ognuggad") ;
  ognolad_av_1_A = compoundA (regA "ognolad") ;
  ognistad_av_1_A = compoundA (regA "ognistad") ;
  ogloedgad_av_1_1_A = compoundA (regA "oglödgad") ;
  oglaettad_av_1_1_A = compoundA (regA "oglättad") ;
  oglaentad_av_1_1_A = compoundA (regA "ogläntad") ;
  oglorifierad_av_1_A = compoundA (regA "oglorifierad") ;
  oglesnad_av_1_A = compoundA (regA "oglesnad") ;
  oglesad_av_1_A = compoundA (regA "oglesad") ;
  oglattad_av_1_A = compoundA (regA "oglattad") ;
  oglaserad_av_1_A = compoundA (regA "oglaserad") ;
  oglasad_av_1_A = compoundA (regA "oglasad") ;
  oglanskad_av_1_A = compoundA (regA "oglanskad") ;
  oglansad_av_1_A = compoundA (regA "oglansad") ;
  oglamouriserad_av_1_A = compoundA (regA "oglamouriserad") ;
  oglamoriserad_av_1_A = compoundA (regA "oglamoriserad") ;
  ogjordad_av_1_A = compoundA (regA "ogjordad") ;
  ogistad_av_1_A = compoundA (regA "ogistad") ;
  ogisslad_av_1_A = compoundA (regA "ogisslad") ;
  ogissad_av_1_A = compoundA (regA "ogissad") ;
  ogirerad_av_1_A = compoundA (regA "ogirerad") ;
  ogipsad_av_1_A = compoundA (regA "ogipsad") ;
  ogiltigfoerklarad_av_1_1_A = compoundA (regA "ogiltigförklarad") ;
  ogillrad_av_1_A = compoundA (regA "ogillrad") ;
  ogillad_av_1_A = compoundA (regA "ogillad") ;
  ogiljotinerad_av_1_A = compoundA (regA "ogiljotinerad") ;
  ogigad_av_1_A = compoundA (regA "ogigad") ;
  ogestaltad_av_1_A = compoundA (regA "ogestaltad") ;
  ogermaniserad_av_1_A = compoundA (regA "ogermaniserad") ;
  ogeotaggad_av_1_A = compoundA (regA "ogeotaggad") ;
  ogeometriserad_av_1_A = compoundA (regA "ogeometriserad") ;
  ogenomsyrad_av_1_A = compoundA (regA "ogenomsyrad") ;
  ogenomstroemmad_av_1_1_A = compoundA (regA "ogenomströmmad") ;
  ogenomskaadad_av_1_1_A = compoundA (regA "ogenomskådad") ;
  ogenomsipprad_av_1_A = compoundA (regA "ogenomsipprad") ;
  ogenomkorsad_av_1_A = compoundA (regA "ogenomkorsad") ;
  ogenomborrad_av_1_A = compoundA (regA "ogenomborrad") ;
  ogenomarbetad_av_1_A = compoundA (regA "ogenomarbetad") ;
  ogengaeldad_av_1_1_A = compoundA (regA "ogengäldad") ;
  ogenererad_av_1_A = compoundA (regA "ogenererad") ;
  ogeneraliserad_av_1_A = compoundA (regA "ogeneraliserad") ;
  ogenerad_av_1_A = compoundA (regA "ogenerad") ;
  ogeminerad_av_1_A = compoundA (regA "ogeminerad") ;
  ogelead_av_1_A = compoundA (regA "ogelead") ;
  ogelatinerad_av_1_A = compoundA (regA "ogelatinerad") ;
  ogauffrerad_av_1_A = compoundA (regA "ogauffrerad") ;
  ogastroskoperad_av_1_A = compoundA (regA "ogastroskoperad") ;
  ogasad_av_1_A = compoundA (regA "ogasad") ;
  ogarvad_av_1_A = compoundA (regA "ogarvad") ;
  ogarrotterad_av_1_A = compoundA (regA "ogarrotterad") ;
  ogarnisonerad_av_1_A = compoundA (regA "ogarnisonerad") ;
  ogarnerad_av_1_A = compoundA (regA "ogarnerad") ;
  ogarderad_av_1_A = compoundA (regA "ogarderad") ;
  ogaranterad_av_1_A = compoundA (regA "ogaranterad") ;
  ogaragerad_av_1_A = compoundA (regA "ogaragerad") ;
  ogarad_av_1_A = compoundA (regA "ogarad") ;
  oganad_av_1_A = compoundA (regA "oganad") ;
  ogalvaniserad_av_1_A = compoundA (regA "ogalvaniserad") ;
  ogalvad_av_1_A = compoundA (regA "ogalvad") ;
  ogaloscherad_av_1_A = compoundA (regA "ogaloscherad") ;
  ogallrad_av_1_A = compoundA (regA "ogallrad") ;
  ogalliserad_av_1_A = compoundA (regA "ogalliserad") ;
  ogagnad_av_1_A = compoundA (regA "ogagnad") ;
  ofoeroevad_av_1_1_A = compoundA (regA "oförövad") ;
  ofoeroekad_av_1_1_A = compoundA (regA "oförökad") ;
  ofoeroedmjukad_av_1_1_A = compoundA (regA "oförödmjukad") ;
  ofoeraangad_av_1_1_A = compoundA (regA "oförångad") ;
  ofoeraerad_av_1_1_A = compoundA (regA "oförärad") ;
  ofoeraendrad_av_1_1_A = compoundA (regA "oförändrad") ;
  ofoeraedlad_av_1_1_A = compoundA (regA "oförädlad") ;
  ofoerzinkad_av_1_1_A = compoundA (regA "oförzinkad") ;
  ofoeryngrad_av_1_1_A = compoundA (regA "oföryngrad") ;
  ofoervaanad_av_1_1_A = compoundA (regA "oförvånad") ;
  ofoervaallad_av_1_1_A = compoundA (regA "oförvållad") ;
  ofoervaexlad_av_1_1_A = compoundA (regA "oförväxlad") ;
  ofoervaervad_av_1_1_A = compoundA (regA "oförvärvad") ;
  ofoervaerrad_av_1_1_A = compoundA (regA "oförvärrad") ;
  ofoervaerldsligad_av_1_1_A = compoundA (regA "oförvärldsligad") ;
  ofoervaentad_av_1_1_A = compoundA (regA "oförväntad") ;
  ofoervaegrad_av_1_1_A = compoundA (regA "oförvägrad") ;
  ofoervittrad_av_1_1_A = compoundA (regA "oförvittrad") ;
  ofoervissnad_av_1_1_A = compoundA (regA "oförvissnad") ;
  ofoervissad_av_1_1_A = compoundA (regA "oförvissad") ;
  ofoervisad_av_1_1_A = compoundA (regA "oförvisad") ;
  ofoervirrad_av_1_1_A = compoundA (regA "oförvirrad") ;
  ofoervillad_av_1_1_A = compoundA (regA "oförvillad") ;
  ofoerverkligad_av_1_1_A = compoundA (regA "oförverkligad") ;
  ofoerverkad_av_1_1_A = compoundA (regA "oförverkad") ;
  ofoervekligad_av_1_1_A = compoundA (regA "oförvekligad") ;
  ofoervedad_av_1_1_A = compoundA (regA "oförvedad") ;
  ofoervarnad_av_1_1_A = compoundA (regA "oförvarnad") ;
  ofoervarad_av_1_1_A = compoundA (regA "oförvarad") ;
  ofoervanskad_av_1_1_A = compoundA (regA "oförvanskad") ;
  ofoervandlad_av_1_1_A = compoundA (regA "oförvandlad") ;
  ofoervaltad_av_1_1_A = compoundA (regA "oförvaltad") ;
  ofoerutskickad_av_1_1_A = compoundA (regA "oförutskickad") ;
  ofoerunnad_av_1_1_A = compoundA (regA "oförunnad") ;
  ofoerundrad_av_1_1_A = compoundA (regA "oförundrad") ;
  ofoertoevad_av_1_1_A = compoundA (regA "oförtövad") ;
  ofoertaetad_av_1_1_A = compoundA (regA "oförtätad") ;
  ofoertyskad_av_1_1_A = compoundA (regA "oförtyskad") ;
  ofoertydligad_av_1_1_A = compoundA (regA "oförtydligad") ;
  ofoertvaalad_av_1_1_A = compoundA (regA "oförtvålad") ;
  ofoertvivlad_av_1_1_A = compoundA (regA "oförtvivlad") ;
  ofoertvinad_av_1_1_A = compoundA (regA "oförtvinad") ;
  ofoertunnad_av_1_1_A = compoundA (regA "oförtunnad") ;
  ofoertullad_av_1_1_A = compoundA (regA "oförtullad") ;
  ofoertroestad_av_1_1_A = compoundA (regA "oförtröstad") ;
  ofoertrustad_av_1_1_A = compoundA (regA "oförtrustad") ;
  ofoertrollad_av_1_1_A = compoundA (regA "oförtrollad") ;
  ofoertretad_av_1_1_A = compoundA (regA "oförtretad") ;
  ofoertrampad_av_1_1_A = compoundA (regA "oförtrampad") ;
  ofoertorkad_av_1_1_A = compoundA (regA "oförtorkad") ;
  ofoertjaenad_av_1_1_A = compoundA (regA "oförtjänad") ;
  ofoertjockad_av_1_1_A = compoundA (regA "oförtjockad") ;
  ofoertennad_av_1_1_A = compoundA (regA "oförtennad") ;
  ofoertecknad_av_1_1_A = compoundA (regA "oförtecknad") ;
  ofoertalad_av_1_1_A = compoundA (regA "oförtalad") ;
  ofoersaemrad_av_1_1_A = compoundA (regA "oförsämrad") ;
  ofoersaekrad_av_1_1_A = compoundA (regA "oförsäkrad") ;
  ofoersvaarad_av_1_1_A = compoundA (regA "oförsvårad") ;
  ofoersvenskad_av_1_1_A = compoundA (regA "oförsvenskad") ;
  ofoersvarad_av_1_1_A = compoundA (regA "oförsvarad") ;
  ofoersvagad_av_1_1_A = compoundA (regA "oförsvagad") ;
  ofoersurad_av_1_1_A = compoundA (regA "oförsurad") ;
  ofoersummad_av_1_1_A = compoundA (regA "oförsummad") ;
  ofoerstaendigad_av_1_1_A = compoundA (regA "oförständigad") ;
  ofoerstummad_av_1_1_A = compoundA (regA "oförstummad") ;
  ofoerstraevad_av_1_1_A = compoundA (regA "oförsträvad") ;
  ofoerstorad_av_1_1_A = compoundA (regA "oförstorad") ;
  ofoerstoppad_av_1_1_A = compoundA (regA "oförstoppad") ;
  ofoerstockad_av_1_1_A = compoundA (regA "oförstockad") ;
  ofoerstenad_av_1_1_A = compoundA (regA "oförstenad") ;
  ofoerstelnad_av_1_1_A = compoundA (regA "oförstelnad") ;
  ofoerstatligad_av_1_1_A = compoundA (regA "oförstatligad") ;
  ofoersonad_av_1_1_A = compoundA (regA "oförsonad") ;
  ofoersoffad_av_1_1_A = compoundA (regA "oförsoffad") ;
  ofoersnillad_av_1_1_A = compoundA (regA "oförsnillad") ;
  ofoersloesad_av_1_1_A = compoundA (regA "oförslösad") ;
  ofoersloead_av_1_1_A = compoundA (regA "oförslöad") ;
  ofoerslavad_av_1_1_A = compoundA (regA "oförslavad") ;
  ofoerslappad_av_1_1_A = compoundA (regA "oförslappad") ;
  ofoerskoenad_av_1_1_A = compoundA (regA "oförskönad") ;
  ofoerskotterad_av_1_1_A = compoundA (regA "oförskotterad") ;
  ofoerskonad_av_1_1_A = compoundA (regA "oförskonad") ;
  ofoerskingrad_av_1_1_A = compoundA (regA "oförskingrad") ;
  ofoerskansad_av_1_1_A = compoundA (regA "oförskansad") ;
  ofoerskaffad_av_1_1_A = compoundA (regA "oförskaffad") ;
  ofoersinkad_av_1_1_A = compoundA (regA "oförsinkad") ;
  ofoersilvrad_av_1_1_A = compoundA (regA "oförsilvrad") ;
  ofoersenad_av_1_1_A = compoundA (regA "oförsenad") ;
  ofoerseglad_av_1_1_A = compoundA (regA "oförseglad") ;
  ofoersamlad_av_1_1_A = compoundA (regA "oförsamlad") ;
  ofoersakad_av_1_1_A = compoundA (regA "oförsakad") ;
  ofoerraaad_av_1_1_A = compoundA (regA "oförråad") ;
  ofoerraettad_av_1_1_A = compoundA (regA "oförrättad") ;
  ofoerraentad_av_1_1_A = compoundA (regA "oförräntad") ;
  ofoerryskad_av_1_1_A = compoundA (regA "oförryskad") ;
  ofoerruttnad_av_1_1_A = compoundA (regA "oförruttnad") ;
  ofoerringad_av_1_1_A = compoundA (regA "oförringad") ;
  ofoerprickad_av_1_1_A = compoundA (regA "oförprickad") ;
  ofoerplaegad_av_1_1_A = compoundA (regA "oförplägad") ;
  ofoerpliktigad_av_1_1_A = compoundA (regA "oförpliktigad") ;
  ofoerpliktad_av_1_1_A = compoundA (regA "oförpliktad") ;
  ofoerpestad_av_1_1_A = compoundA (regA "oförpestad") ;
  ofoerpassad_av_1_1_A = compoundA (regA "oförpassad") ;
  ofoerpantad_av_1_1_A = compoundA (regA "oförpantad") ;
  ofoerpaktad_av_1_1_A = compoundA (regA "oförpaktad") ;
  ofoerpackad_av_1_1_A = compoundA (regA "oförpackad") ;
  ofoeroraettad_av_1_1_A = compoundA (regA "oförorättad") ;
  ofoerorsakad_av_1_1_A = compoundA (regA "oförorsakad") ;
  ofoerorenad_av_1_1_A = compoundA (regA "oförorenad") ;
  ofoerordnad_av_1_1_A = compoundA (regA "oförordnad") ;
  ofoerordad_av_1_1_A = compoundA (regA "oförordad") ;
  ofoerolaempad_av_1_1_A = compoundA (regA "oförolämpad") ;
  ofoernaermad_av_1_1_A = compoundA (regA "oförnärmad") ;
  ofoernyad_av_1_1_A = compoundA (regA "oförnyad") ;
  ofoernicklad_av_1_1_A = compoundA (regA "oförnicklad") ;
  ofoernekad_av_1_1_A = compoundA (regA "oförnekad") ;
  ofoernedrad_av_1_1_A = compoundA (regA "oförnedrad") ;
  ofoermoerkad_av_1_1_A = compoundA (regA "oförmörkad") ;
  ofoermaenskligad_av_1_1_A = compoundA (regA "oförmänskligad") ;
  ofoermultnad_av_1_1_A = compoundA (regA "oförmultnad") ;
  ofoermodad_av_1_1_A = compoundA (regA "oförmodad") ;
  ofoerminskad_av_1_1_A = compoundA (regA "oförminskad") ;
  ofoermildrad_av_1_1_A = compoundA (regA "oförmildrad") ;
  ofoermenad_av_1_1_A = compoundA (regA "oförmenad") ;
  ofoermedlad_av_1_1_A = compoundA (regA "oförmedlad") ;
  ofoermanad_av_1_1_A = compoundA (regA "oförmanad") ;
  ofoerloejligad_av_1_1_A = compoundA (regA "oförlöjligad") ;
  ofoerlaenad_av_1_1_A = compoundA (regA "oförlänad") ;
  ofoerlustad_av_1_1_A = compoundA (regA "oförlustad") ;
  ofoerlossad_av_1_1_A = compoundA (regA "oförlossad") ;
  ofoerlorad_av_1_1_A = compoundA (regA "oförlorad") ;
  ofoerljuvad_av_1_1_A = compoundA (regA "oförljuvad") ;
  ofoerlamad_av_1_1_A = compoundA (regA "oförlamad") ;
  ofoerkunnad_av_1_1_A = compoundA (regA "oförkunnad") ;
  ofoerkrossad_av_1_1_A = compoundA (regA "oförkrossad") ;
  ofoerkroppsligad_av_1_1_A = compoundA (regA "oförkroppsligad") ;
  ofoerkromad_av_1_1_A = compoundA (regA "oförkromad") ;
  ofoerkovrad_av_1_1_A = compoundA (regA "oförkovrad") ;
  ofoerkortad_av_1_1_A = compoundA (regA "oförkortad") ;
  ofoerkolnad_av_1_1_A = compoundA (regA "oförkolnad") ;
  ofoerknippad_av_1_1_A = compoundA (regA "oförknippad") ;
  ofoerklistrad_av_1_1_A = compoundA (regA "oförklistrad") ;
  ofoerklingad_av_1_1_A = compoundA (regA "oförklingad") ;
  ofoerklarad_av_1_1_A = compoundA (regA "oförklarad") ;
  ofoerkastad_av_1_1_A = compoundA (regA "oförkastad") ;
  ofoerjagad_av_1_1_A = compoundA (regA "oförjagad") ;
  ofoerintad_av_1_1_A = compoundA (regA "oförintad") ;
  ofoerhaanad_av_1_1_A = compoundA (regA "oförhånad") ;
  ofoerhaexad_av_1_1_A = compoundA (regA "oförhäxad") ;
  ofoerhaerligad_av_1_1_A = compoundA (regA "oförhärligad") ;
  ofoerhaerjad_av_1_1_A = compoundA (regA "oförhärjad") ;
  ofoerhaerdad_av_1_1_A = compoundA (regA "oförhärdad") ;
  ofoerhindrad_av_1_1_A = compoundA (regA "oförhindrad") ;
  ofoerhandlad_av_1_1_A = compoundA (regA "oförhandlad") ;
  ofoerhalad_av_1_1_A = compoundA (regA "oförhalad") ;
  ofoergrymmad_av_1_1_A = compoundA (regA "oförgrymmad") ;
  ofoergrovad_av_1_1_A = compoundA (regA "oförgrovad") ;
  ofoergiftad_av_1_1_A = compoundA (regA "oförgiftad") ;
  ofoergasad_av_1_1_A = compoundA (regA "oförgasad") ;
  ofoerfoerdelad_av_1_1_A = compoundA (regA "oförfördelad") ;
  ofoerfaangad_av_1_1_A = compoundA (regA "oförfångad") ;
  ofoerfaerdigad_av_1_1_A = compoundA (regA "oförfärdigad") ;
  ofoerfaerad_av_1_1_A = compoundA (regA "oförfärad") ;
  ofoerfaektad_av_1_1_A = compoundA (regA "oförfäktad") ;
  ofoerfaead_av_1_1_A = compoundA (regA "oförfäad") ;
  ofoerfuskad_av_1_1_A = compoundA (regA "oförfuskad") ;
  ofoerfranskad_av_1_1_A = compoundA (regA "oförfranskad") ;
  ofoerflyttad_av_1_1_A = compoundA (regA "oförflyttad") ;
  ofoerflackad_av_1_1_A = compoundA (regA "oförflackad") ;
  ofoerfinad_av_1_1_A = compoundA (regA "oförfinad") ;
  ofoerfelad_av_1_1_A = compoundA (regA "oförfelad") ;
  ofoerfattad_av_1_1_A = compoundA (regA "oförfattad") ;
  ofoerfalskad_av_1_1_A = compoundA (regA "oförfalskad") ;
  ofoerevitad_av_1_1_A = compoundA (regA "oförevitad") ;
  ofoerevisad_av_1_1_A = compoundA (regA "oförevisad") ;
  ofoerevigad_av_1_1_A = compoundA (regA "oförevigad") ;
  ofoerestavad_av_1_1_A = compoundA (regA "oförestavad") ;
  ofoerespraakad_av_1_1_A = compoundA (regA "oförespråkad") ;
  ofoerespeglad_av_1_1_A = compoundA (regA "oförespeglad") ;
  ofoerenklad_av_1_1_A = compoundA (regA "oförenklad") ;
  ofoerebaadad_av_1_1_A = compoundA (regA "oförebådad") ;
  ofoerdaervad_av_1_1_A = compoundA (regA "ofördärvad") ;
  ofoerdystrad_av_1_1_A = compoundA (regA "ofördystrad") ;
  ofoerdyrad_av_1_1_A = compoundA (regA "ofördyrad") ;
  ofoerdunstad_av_1_1_A = compoundA (regA "ofördunstad") ;
  ofoerdunklad_av_1_1_A = compoundA (regA "ofördunklad") ;
  ofoerdummad_av_1_1_A = compoundA (regA "ofördummad") ;
  ofoerdubblad_av_1_1_A = compoundA (regA "ofördubblad") ;
  ofoerdjupad_av_1_1_A = compoundA (regA "ofördjupad") ;
  ofoerdelad_av_1_1_A = compoundA (regA "ofördelad") ;
  ofoerbaettrad_av_1_1_A = compoundA (regA "oförbättrad") ;
  ofoerbuskad_av_1_1_A = compoundA (regA "oförbuskad") ;
  ofoerbroedrad_av_1_1_A = compoundA (regA "oförbrödrad") ;
  ofoerbryllad_av_1_1_A = compoundA (regA "oförbryllad") ;
  ofoerbrukad_av_1_1_A = compoundA (regA "oförbrukad") ;
  ofoerborgerligad_av_1_1_A = compoundA (regA "oförborgerligad") ;
  ofoerborgad_av_1_1_A = compoundA (regA "oförborgad") ;
  ofoerbluffad_av_1_1_A = compoundA (regA "oförbluffad") ;
  ofoerblommerad_av_1_1_A = compoundA (regA "oförblommerad") ;
  ofoerblindad_av_1_1_A = compoundA (regA "oförblindad") ;
  ofoerbleknad_av_1_1_A = compoundA (regA "oförbleknad") ;
  ofoerblandad_av_1_1_A = compoundA (regA "oförblandad") ;
  ofoerbittrad_av_1_1_A = compoundA (regA "oförbittrad") ;
  ofoerbilligad_av_1_1_A = compoundA (regA "oförbilligad") ;
  ofoerbidad_av_1_1_A = compoundA (regA "oförbidad") ;
  ofoerbannad_av_1_1_A = compoundA (regA "oförbannad") ;
  ofoerargad_av_1_1_A = compoundA (regA "oförargad") ;
  ofoeranstaltad_av_1_1_A = compoundA (regA "oföranstaltad") ;
  ofoerannonserad_av_1_1_A = compoundA (regA "oförannonserad") ;
  ofoerankrad_av_1_1_A = compoundA (regA "oförankrad") ;
  ofoerandligad_av_1_1_A = compoundA (regA "oförandligad") ;
  ofoerallmaenligad_av_1_1_A = compoundA (regA "oförallmänligad") ;
  ofoeraktad_av_1_1_A = compoundA (regA "oföraktad") ;
  ofoenad_av_1_1_A = compoundA (regA "ofönad") ;
  ofaarad_av_1_1_A = compoundA (regA "ofårad") ;
  ofaangad_av_1_1_A = compoundA (regA "ofångad") ;
  ofaallad_av_1_1_A = compoundA (regA "ofållad") ;
  ofaerskad_av_1_1_A = compoundA (regA "ofärskad") ;
  ofaerserad_av_1_1_A = compoundA (regA "ofärserad") ;
  ofaerjad_av_1_1_A = compoundA (regA "ofärjad") ;
  ofaergad_av_1_1_A = compoundA (regA "ofärgad") ;
  ofaengslad_av_1_1_A = compoundA (regA "ofängslad") ;
  ofaegnad_av_1_1_A = compoundA (regA "ofägnad") ;
  ofysiljerad_av_1_A = compoundA (regA "ofysiljerad") ;
  ofyndad_av_1_A = compoundA (regA "ofyndad") ;
  ofylkad_av_1_A = compoundA (regA "ofylkad") ;
  ofusionerad_av_1_A = compoundA (regA "ofusionerad") ;
  ofurnerad_av_1_A = compoundA (regA "ofurnerad") ;
  ofullaendad_av_1_1_A = compoundA (regA "ofulländad") ;
  ofullstaendigad_av_1_1_A = compoundA (regA "ofullständigad") ;
  ofullkomnad_av_1_A = compoundA (regA "ofullkomnad") ;
  ofullbordad_av_1_A = compoundA (regA "ofullbordad") ;
  ofuktad_av_1_A = compoundA (regA "ofuktad") ;
  ofraagad_av_1_1_A = compoundA (regA "ofrågad") ;
  ofraemjad_av_1_1_A = compoundA (regA "ofrämjad") ;
  ofrustrerad_av_1_A = compoundA (regA "ofrustrerad") ;
  ofruktad_av_1_A = compoundA (regA "ofruktad") ;
  ofrotterad_av_1_A = compoundA (regA "ofrotterad") ;
  ofrontad_av_1_A = compoundA (regA "ofrontad") ;
  ofronderad_av_1_A = compoundA (regA "ofronderad") ;
  ofriterad_av_1_A = compoundA (regA "ofriterad") ;
  ofriserad_av_1_A = compoundA (regA "ofriserad") ;
  ofriad_av_1_A = compoundA (regA "ofriad") ;
  ofrestad_av_1_A = compoundA (regA "ofrestad") ;
  ofrekventerad_av_1_A = compoundA (regA "ofrekventerad") ;
  ofredad_av_1_A = compoundA (regA "ofredad") ;
  ofraserad_av_1_A = compoundA (regA "ofraserad") ;
  ofrapperad_av_1_A = compoundA (regA "ofrapperad") ;
  ofransad_av_1_A = compoundA (regA "ofransad") ;
  ofrankerad_av_1_A = compoundA (regA "ofrankerad") ;
  oframvisad_av_1_A = compoundA (regA "oframvisad") ;
  oframskymtad_av_1_A = compoundA (regA "oframskymtad") ;
  oframpressad_av_1_A = compoundA (regA "oframpressad") ;
  oframmanad_av_1_A = compoundA (regA "oframmanad") ;
  oframkastad_av_1_A = compoundA (regA "oframkastad") ;
  oframkallad_av_1_A = compoundA (regA "oframkallad") ;
  oframflyttad_av_1_A = compoundA (regA "oframflyttad") ;
  ofraktionerad_av_1_A = compoundA (regA "ofraktionerad") ;
  ofraktad_av_1_A = compoundA (regA "ofraktad") ;
  ofragmenterad_av_1_A = compoundA (regA "ofragmenterad") ;
  ofotokopierad_av_1_A = compoundA (regA "ofotokopierad") ;
  ofotograferad_av_1_A = compoundA (regA "ofotograferad") ;
  ofotad_av_1_A = compoundA (regA "ofotad") ;
  ofostrad_av_1_A = compoundA (regA "ofostrad") ;
  ofossiliserad_av_1_A = compoundA (regA "ofossiliserad") ;
  ofosfaterad_av_1_A = compoundA (regA "ofosfaterad") ;
  oforslad_av_1_A = compoundA (regA "oforslad") ;
  oformulerad_av_1_A = compoundA (regA "oformulerad") ;
  oformerad_av_1_A = compoundA (regA "oformerad") ;
  oformaliserad_av_1_A = compoundA (regA "oformaliserad") ;
  oformad_av_1_A = compoundA (regA "oformad") ;
  oforecheckad_av_1_A = compoundA (regA "oforecheckad") ;
  oforcerad_av_1_A = compoundA (regA "oforcerad") ;
  ofonderad_av_1_A = compoundA (regA "ofonderad") ;
  ofolierad_av_1_A = compoundA (regA "ofolierad") ;
  ofokuserad_av_1_A = compoundA (regA "ofokuserad") ;
  ofogad_av_1_A = compoundA (regA "ofogad") ;
  ofodrad_av_1_A = compoundA (regA "ofodrad") ;
  ofockad_av_1_A = compoundA (regA "ofockad") ;
  ofloejtad_av_1_1_A = compoundA (regA "oflöjtad") ;
  ofloejlad_av_1_1_A = compoundA (regA "oflöjlad") ;
  oflaetad_av_1_1_A = compoundA (regA "oflätad") ;
  oflaensad_av_1_1_A = compoundA (regA "oflänsad") ;
  oflaeckad_av_1_1_A = compoundA (regA "ofläckad") ;
  oflyttad_av_1_A = compoundA (regA "oflyttad") ;
  oflyktad_av_1_A = compoundA (regA "oflyktad") ;
  ofluoriderad_av_1_A = compoundA (regA "ofluoriderad") ;
  ofluorerad_av_1_A = compoundA (regA "ofluorerad") ;
  ofluidiserad_av_1_A = compoundA (regA "ofluidiserad") ;
  oflottad_av_1_A = compoundA (regA "oflottad") ;
  oflekterad_av_1_A = compoundA (regA "oflekterad") ;
  oflatterad_av_1_A = compoundA (regA "oflatterad") ;
  oflankerad_av_1_A = compoundA (regA "oflankerad") ;
  oflamberad_av_1_A = compoundA (regA "oflamberad") ;
  oflagnad_av_1_A = compoundA (regA "oflagnad") ;
  oflaggad_av_1_A = compoundA (regA "oflaggad") ;
  ofjaettrad_av_1_1_A = compoundA (regA "ofjättrad") ;
  ofjaermad_av_1_1_A = compoundA (regA "ofjärmad") ;
  ofjaellad_av_1_1_A = compoundA (regA "ofjällad") ;
  ofixerad_av_1_A = compoundA (regA "ofixerad") ;
  ofixad_av_1_A = compoundA (regA "ofixad") ;
  ofiskad_av_1_A = compoundA (regA "ofiskad") ;
  ofirad_av_1_A = compoundA (regA "ofirad") ;
  ofintad_av_1_A = compoundA (regA "ofintad") ;
  ofinlandiserad_av_1_A = compoundA (regA "ofinlandiserad") ;
  ofinkad_av_1_A = compoundA (regA "ofinkad") ;
  ofingerad_av_1_A = compoundA (regA "ofingerad") ;
  ofinansierad_av_1_A = compoundA (regA "ofinansierad") ;
  ofimpad_av_1_A = compoundA (regA "ofimpad") ;
  ofiltrerad_av_1_A = compoundA (regA "ofiltrerad") ;
  ofiltad_av_1_A = compoundA (regA "ofiltad") ;
  ofilmatiserad_av_1_A = compoundA (regA "ofilmatiserad") ;
  ofilmad_av_1_A = compoundA (regA "ofilmad") ;
  ofilerad_av_1_A = compoundA (regA "ofilerad") ;
  ofilead_av_1_A = compoundA (regA "ofilead") ;
  ofilad_av_1_A = compoundA (regA "ofilad") ;
  ofeterad_av_1_A = compoundA (regA "ofeterad") ;
  ofernissad_av_1_A = compoundA (regA "ofernissad") ;
  ofermenterad_av_1_A = compoundA (regA "ofermenterad") ;
  ofejkad_av_1_A = compoundA (regA "ofejkad") ;
  ofejad_av_1_A = compoundA (regA "ofejad") ;
  ofaxad_av_1_A = compoundA (regA "ofaxad") ;
  ofavoriserad_av_1_A = compoundA (regA "ofavoriserad") ;
  ofasonerad_av_1_A = compoundA (regA "ofasonerad") ;
  ofasetterad_av_1_A = compoundA (regA "ofasetterad") ;
  ofascinerad_av_1_A = compoundA (regA "ofascinerad") ;
  ofasad_av_1_A = compoundA (regA "ofasad") ;
  ofantiserad_av_1_A = compoundA (regA "ofantiserad") ;
  ofamnad_av_1_A = compoundA (regA "ofamnad") ;
  ofalsifierad_av_1_A = compoundA (regA "ofalsifierad") ;
  ofalsad_av_1_A = compoundA (regA "ofalsad") ;
  ofalnad_av_1_A = compoundA (regA "ofalnad") ;
  ofakturerad_av_1_A = compoundA (regA "ofakturerad") ;
  ofacetterad_av_1_A = compoundA (regA "ofacetterad") ;
  ofabulerad_av_1_A = compoundA (regA "ofabulerad") ;
  ofabricerad_av_1_A = compoundA (regA "ofabricerad") ;
  oextrapolerad_av_1_A = compoundA (regA "oextrapolerad") ;
  oextraherad_av_1_A = compoundA (regA "oextraherad") ;
  oextemporerad_av_1_A = compoundA (regA "oextemporerad") ;
  oexstirperad_av_1_A = compoundA (regA "oexstirperad") ;
  oexproprierad_av_1_A = compoundA (regA "oexproprierad") ;
  oexporterad_av_1_A = compoundA (regA "oexporterad") ;
  oexponerad_av_1_A = compoundA (regA "oexponerad") ;
  oexploderad_av_1_A = compoundA (regA "oexploderad") ;
  oexploaterad_av_1_A = compoundA (regA "oexploaterad") ;
  oexplicerad_av_1_A = compoundA (regA "oexplicerad") ;
  oexpektorerad_av_1_A = compoundA (regA "oexpektorerad") ;
  oexpedierad_av_1_A = compoundA (regA "oexpedierad") ;
  oexpatrierad_av_1_A = compoundA (regA "oexpatrierad") ;
  oexpanderad_av_1_A = compoundA (regA "oexpanderad") ;
  oexkommunicerad_av_1_A = compoundA (regA "oexkommunicerad") ;
  oexkluderad_av_1_A = compoundA (regA "oexkluderad") ;
  oexercerad_av_1_A = compoundA (regA "oexercerad") ;
  oexemplifierad_av_1_A = compoundA (regA "oexemplifierad") ;
  oexekverad_av_1_A = compoundA (regA "oexekverad") ;
  oexciterad_av_1_A = compoundA (regA "oexciterad") ;
  oexcerperad_av_1_A = compoundA (regA "oexcerperad") ;
  oexaminerad_av_1_A = compoundA (regA "oexaminerad") ;
  oevaporerad_av_1_A = compoundA (regA "oevaporerad") ;
  oevalverad_av_1_A = compoundA (regA "oevalverad") ;
  oevaluerad_av_1_A = compoundA (regA "oevaluerad") ;
  oevakuerad_av_1_A = compoundA (regA "oevakuerad") ;
  oeuropeiserad_av_1_A = compoundA (regA "oeuropeiserad") ;
  oetymologiserad_av_1_A = compoundA (regA "oetymologiserad") ;
  oetsad_av_1_A = compoundA (regA "oetsad") ;
  oetiketterad_av_1_A = compoundA (regA "oetiketterad") ;
  oeteriserad_av_1_A = compoundA (regA "oeteriserad") ;
  oetablerad_av_1_A = compoundA (regA "oetablerad") ;
  oestimerad_av_1_A = compoundA (regA "oestimerad") ;
  oestetiserad_av_1_A = compoundA (regA "oestetiserad") ;
  oesteticerad_av_1_A = compoundA (regA "oesteticerad") ;
  oeskorterad_av_1_A = compoundA (regA "oeskorterad") ;
  oeskalerad_av_1_A = compoundA (regA "oeskalerad") ;
  oeroevrad_av_1_1_A = compoundA (regA "oerövrad") ;
  oertappad_av_1_A = compoundA (regA "oertappad") ;
  oeroderad_av_1_A = compoundA (regA "oeroderad") ;
  oerigerad_av_1_A = compoundA (regA "oerigerad") ;
  oerfordrad_av_1_A = compoundA (regA "oerfordrad") ;
  oepilerad_av_1_A = compoundA (regA "oepilerad") ;
  oentusiasmerad_av_1_A = compoundA (regA "oentusiasmerad") ;
  oentledigad_av_1_A = compoundA (regA "oentledigad") ;
  oensilerad_av_1_A = compoundA (regA "oensilerad") ;
  oensad_av_1_A = compoundA (regA "oensad") ;
  oenrollerad_av_1_A = compoundA (regA "oenrollerad") ;
  oenleverad_av_1_A = compoundA (regA "oenleverad") ;
  oenklad_av_1_A = compoundA (regA "oenklad") ;
  oengagerad_av_1_A = compoundA (regA "oengagerad") ;
  oenerverad_av_1_A = compoundA (regA "oenerverad") ;
  oendosserad_av_1_A = compoundA (regA "oendosserad") ;
  oenad_av_1_A = compoundA (regA "oenad") ;
  oemulgerad_av_1_A = compoundA (regA "oemulgerad") ;
  oemitterad_av_1_A = compoundA (regA "oemitterad") ;
  oemigrerad_av_1_A = compoundA (regA "oemigrerad") ;
  oemenderad_av_1_A = compoundA (regA "oemenderad") ;
  oembellerad_av_1_A = compoundA (regA "oembellerad") ;
  oembarkerad_av_1_A = compoundA (regA "oembarkerad") ;
  oemballerad_av_1_A = compoundA (regA "oemballerad") ;
  oemanciperad_av_1_A = compoundA (regA "oemanciperad") ;
  oemaljerad_av_1_A = compoundA (regA "oemaljerad") ;
  oeluerad_av_1_A = compoundA (regA "oeluerad") ;
  oeluderad_av_1_A = compoundA (regA "oeluderad") ;
  oeloxerad_av_1_A = compoundA (regA "oeloxerad") ;
  oeliminerad_av_1_A = compoundA (regA "oeliminerad") ;
  oeliderad_av_1_A = compoundA (regA "oeliderad") ;
  oelektriserad_av_1_A = compoundA (regA "oelektriserad") ;
  oelektrifierad_av_1_A = compoundA (regA "oelektrifierad") ;
  oelektrificerad_av_1_A = compoundA (regA "oelektrificerad") ;
  oeldad_av_1_A = compoundA (regA "oeldad") ;
  oelastiserad_av_1_A = compoundA (regA "oelastiserad") ;
  oelaborerad_av_1_A = compoundA (regA "oelaborerad") ;
  oekonomiserad_av_1_A = compoundA (regA "oekonomiserad") ;
  oeklaererad_av_1_1_A = compoundA (regA "oeklärerad") ;
  oeklaterad_av_1_A = compoundA (regA "oeklaterad") ;
  oekiperad_av_1_A = compoundA (regA "oekiperad") ;
  oekad_av_1_A = compoundA (regA "oekad") ;
  oeggad_av_1_A = compoundA (regA "oeggad") ;
  oegaliserad_av_1_A = compoundA (regA "oegaliserad") ;
  oeftertraktad_av_1_A = compoundA (regA "oeftertraktad") ;
  oeftertaxerad_av_1_A = compoundA (regA "oeftertaxerad") ;
  oeftersynkroniserad_av_1_A = compoundA (regA "oeftersynkroniserad") ;
  oefterstraevad_av_1_1_A = compoundA (regA "oeftersträvad") ;
  oefterstavad_av_1_A = compoundA (regA "oefterstavad") ;
  oefterrationaliserad_av_1_A = compoundA (regA "oefterrationaliserad") ;
  oeftermognad_av_1_A = compoundA (regA "oeftermognad") ;
  oefterlaemnad_av_1_1_A = compoundA (regA "oefterlämnad") ;
  oefterliknad_av_1_A = compoundA (regA "oefterliknad") ;
  oefterhaermad_av_1_1_A = compoundA (regA "oefterhärmad") ;
  oefterfraagad_av_1_1_A = compoundA (regA "oefterfrågad") ;
  oefterforskad_av_1_A = compoundA (regA "oefterforskad") ;
  oefterdebiterad_av_1_A = compoundA (regA "oefterdebiterad") ;
  oefterdaterad_av_1_A = compoundA (regA "oefterdaterad") ;
  oefterbildad_av_1_A = compoundA (regA "oefterbildad") ;
  oefterbehandlad_av_1_A = compoundA (regA "oefterbehandlad") ;
  oefterapad_av_1_A = compoundA (regA "oefterapad") ;
  oeffektuerad_av_1_A = compoundA (regA "oeffektuerad") ;
  oeffektiviserad_av_1_A = compoundA (regA "oeffektiviserad") ;
  oeffektiverad_av_1_A = compoundA (regA "oeffektiverad") ;
  oeffacerad_av_1_A = compoundA (regA "oeffacerad") ;
  oederad_av_1_A = compoundA (regA "oederad") ;
  odoevad_av_1_1_A = compoundA (regA "odövad") ;
  odoerjad_av_1_1_A = compoundA (regA "odörjad") ;
  odoedad_av_1_1_A = compoundA (regA "odödad") ;
  odaarad_av_1_1_A = compoundA (regA "odårad") ;
  odaanad_av_1_1_A = compoundA (regA "odånad") ;
  odaevnad_av_1_1_A = compoundA (regA "odävnad") ;
  odaempad_av_1_1_A = compoundA (regA "odämpad") ;
  odaeggad_av_1_1_A = compoundA (regA "odäggad") ;
  odaeckad_av_1_1_A = compoundA (regA "odäckad") ;
  odyrkad_av_1_A = compoundA (regA "odyrkad") ;
  oduschad_av_1_A = compoundA (regA "oduschad") ;
  oduplicerad_av_1_A = compoundA (regA "oduplicerad") ;
  oduperad_av_1_A = compoundA (regA "oduperad") ;
  odunstad_av_1_A = compoundA (regA "odunstad") ;
  odunkad_av_1_A = compoundA (regA "odunkad") ;
  odumpad_av_1_A = compoundA (regA "odumpad") ;
  odukad_av_1_A = compoundA (regA "odukad") ;
  odubblerad_av_1_A = compoundA (regA "odubblerad") ;
  odubblad_av_1_A = compoundA (regA "odubblad") ;
  odubbad_av_1_A = compoundA (regA "odubbad") ;
  oduad_av_1_A = compoundA (regA "oduad") ;
  odraenerad_av_1_1_A = compoundA (regA "odränerad") ;
  odryftad_av_1_A = compoundA (regA "odryftad") ;
  odrunknad_av_1_A = compoundA (regA "odrunknad") ;
  odroppad_av_1_A = compoundA (regA "odroppad") ;
  odrogad_av_1_A = compoundA (regA "odrogad") ;
  odrillad_av_1_A = compoundA (regA "odrillad") ;
  odribblad_av_1_A = compoundA (regA "odribblad") ;
  odrevad_av_1_A = compoundA (regA "odrevad") ;
  odresserad_av_1_A = compoundA (regA "odresserad") ;
  odrejad_av_1_A = compoundA (regA "odrejad") ;
  odrattad_av_1_A = compoundA (regA "odrattad") ;
  odraperad_av_1_A = compoundA (regA "odraperad") ;
  odramatiserad_av_1_A = compoundA (regA "odramatiserad") ;
  odraggad_av_1_A = compoundA (regA "odraggad") ;
  odragerad_av_1_A = compoundA (regA "odragerad") ;
  odrabbad_av_1_A = compoundA (regA "odrabbad") ;
  odoterad_av_1_A = compoundA (regA "odoterad") ;
  odosserad_av_1_A = compoundA (regA "odosserad") ;
  odoserad_av_1_A = compoundA (regA "odoserad") ;
  odoppad_av_1_A = compoundA (regA "odoppad") ;
  odopad_av_1_A = compoundA (regA "odopad") ;
  odonkad_av_1_A = compoundA (regA "odonkad") ;
  odonerad_av_1_A = compoundA (regA "odonerad") ;
  odompterad_av_1_A = compoundA (regA "odompterad") ;
  odomnad_av_1_A = compoundA (regA "odomnad") ;
  odominerad_av_1_A = compoundA (regA "odominerad") ;
  odomicilierad_av_1_A = compoundA (regA "odomicilierad") ;
  odomesticerad_av_1_A = compoundA (regA "odomesticerad") ;
  odokumenterad_av_1_A = compoundA (regA "odokumenterad") ;
  odoktorerad_av_1_A = compoundA (regA "odoktorerad") ;
  odogmatiserad_av_1_A = compoundA (regA "odogmatiserad") ;
  odockad_av_1_A = compoundA (regA "odockad") ;
  odocerad_av_1_A = compoundA (regA "odocerad") ;
  odividerad_av_1_A = compoundA (regA "odividerad") ;
  odiversifierad_av_1_A = compoundA (regA "odiversifierad") ;
  odivergerad_av_1_A = compoundA (regA "odivergerad") ;
  odistribuerad_av_1_A = compoundA (regA "odistribuerad") ;
  odistraherad_av_1_A = compoundA (regA "odistraherad") ;
  odistanserad_av_1_A = compoundA (regA "odistanserad") ;
  odissocierad_av_1_A = compoundA (regA "odissocierad") ;
  odissimilerad_av_1_A = compoundA (regA "odissimilerad") ;
  odissekerad_av_1_A = compoundA (regA "odissekerad") ;
  odissad_av_1_A = compoundA (regA "odissad") ;
  odisputerad_av_1_A = compoundA (regA "odisputerad") ;
  odisponerad_av_1_A = compoundA (regA "odisponerad") ;
  odispergerad_av_1_A = compoundA (regA "odispergerad") ;
  odispenserad_av_1_A = compoundA (regA "odispenserad") ;
  odispascherad_av_1_A = compoundA (regA "odispascherad") ;
  odiskvalificerad_av_1_A = compoundA (regA "odiskvalificerad") ;
  odiskuterad_av_1_A = compoundA (regA "odiskuterad") ;
  odiskriminerad_av_1_A = compoundA (regA "odiskriminerad") ;
  odiskrediterad_av_1_A = compoundA (regA "odiskrediterad") ;
  odiskonterad_av_1_A = compoundA (regA "odiskonterad") ;
  odiskad_av_1_A = compoundA (regA "odiskad") ;
  odisharmonierad_av_1_A = compoundA (regA "odisharmonierad") ;
  odisciplinerad_av_1_A = compoundA (regA "odisciplinerad") ;
  odisambiguerad_av_1_A = compoundA (regA "odisambiguerad") ;
  odirigerad_av_1_A = compoundA (regA "odirigerad") ;
  odippad_av_1_A = compoundA (regA "odippad") ;
  odiplomerad_av_1_A = compoundA (regA "odiplomerad") ;
  odimensionerad_av_1_A = compoundA (regA "odimensionerad") ;
  odikterad_av_1_A = compoundA (regA "odikterad") ;
  odiktad_av_1_A = compoundA (regA "odiktad") ;
  odikad_av_1_A = compoundA (regA "odikad") ;
  odiggad_av_1_A = compoundA (regA "odiggad") ;
  odigererad_av_1_A = compoundA (regA "odigererad") ;
  odiftongerad_av_1_A = compoundA (regA "odiftongerad") ;
  odiffunderad_av_1_A = compoundA (regA "odiffunderad") ;
  odifferentierad_av_1_A = compoundA (regA "odifferentierad") ;
  odibblad_av_1_A = compoundA (regA "odibblad") ;
  odialyserad_av_1_A = compoundA (regA "odialyserad") ;
  odiagnostiserad_av_1_A = compoundA (regA "odiagnostiserad") ;
  odiagnosticerad_av_1_A = compoundA (regA "odiagnosticerad") ;
  odiad_av_1_A = compoundA (regA "odiad") ;
  odevalverad_av_1_A = compoundA (regA "odevalverad") ;
  odetroniserad_av_1_A = compoundA (regA "odetroniserad") ;
  odetonerad_av_1_A = compoundA (regA "odetonerad") ;
  odeterminerad_av_1_A = compoundA (regA "odeterminerad") ;
  odetekterad_av_1_A = compoundA (regA "odetekterad") ;
  odetaljerad_av_1_A = compoundA (regA "odetaljerad") ;
  odetacherad_av_1_A = compoundA (regA "odetacherad") ;
  odestruerad_av_1_A = compoundA (regA "odestruerad") ;
  odestinerad_av_1_A = compoundA (regA "odestinerad") ;
  odestillerad_av_1_A = compoundA (regA "odestillerad") ;
  odestabiliserad_av_1_A = compoundA (regA "odestabiliserad") ;
  odesorganiserad_av_1_A = compoundA (regA "odesorganiserad") ;
  odesinformerad_av_1_A = compoundA (regA "odesinformerad") ;
  odesinficerad_av_1_A = compoundA (regA "odesinficerad") ;
  odesinfekterad_av_1_A = compoundA (regA "odesinfekterad") ;
  odesignerad_av_1_A = compoundA (regA "odesignerad") ;
  odesignad_av_1_A = compoundA (regA "odesignad") ;
  odesensibiliserad_av_1_A = compoundA (regA "odesensibiliserad") ;
  odesavouerad_av_1_A = compoundA (regA "odesavouerad") ;
  odesarmerad_av_1_A = compoundA (regA "odesarmerad") ;
  oderiverad_av_1_A = compoundA (regA "oderiverad") ;
  oderangerad_av_1_A = compoundA (regA "oderangerad") ;
  odeprecierad_av_1_A = compoundA (regA "odeprecierad") ;
  odeporterad_av_1_A = compoundA (regA "odeporterad") ;
  odeponerad_av_1_A = compoundA (regA "odeponerad") ;
  odeplacerad_av_1_A = compoundA (regA "odeplacerad") ;
  odepenserad_av_1_A = compoundA (regA "odepenserad") ;
  odepatrierad_av_1_A = compoundA (regA "odepatrierad") ;
  odeodoriserad_av_1_A = compoundA (regA "odeodoriserad") ;
  odenuderad_av_1_A = compoundA (regA "odenuderad") ;
  odenoterad_av_1_A = compoundA (regA "odenoterad") ;
  odenaturerad_av_1_A = compoundA (regA "odenaturerad") ;
  odenaturaliserad_av_1_A = compoundA (regA "odenaturaliserad") ;
  odemoraliserad_av_1_A = compoundA (regA "odemoraliserad") ;
  odemonterad_av_1_A = compoundA (regA "odemonterad") ;
  odemonstrerad_av_1_A = compoundA (regA "odemonstrerad") ;
  odemolerad_av_1_A = compoundA (regA "odemolerad") ;
  odemokratiserad_av_1_A = compoundA (regA "odemokratiserad") ;
  odemobiliserad_av_1_A = compoundA (regA "odemobiliserad") ;
  odemissionerad_av_1_A = compoundA (regA "odemissionerad") ;
  odemilitariserad_av_1_A = compoundA (regA "odemilitariserad") ;
  odementerad_av_1_A = compoundA (regA "odementerad") ;
  odemaskerad_av_1_A = compoundA (regA "odemaskerad") ;
  odemad_av_1_A = compoundA (regA "odemad") ;
  odelegerad_av_1_A = compoundA (regA "odelegerad") ;
  odelad_av_1_A = compoundA (regA "odelad") ;
  odekreterad_av_1_A = compoundA (regA "odekreterad") ;
  odekouragerad_av_1_A = compoundA (regA "odekouragerad") ;
  odekorerad_av_1_A = compoundA (regA "odekorerad") ;
  odeklinerad_av_1_A = compoundA (regA "odeklinerad") ;
  odeklasserad_av_1_A = compoundA (regA "odeklasserad") ;
  odeklarerad_av_1_A = compoundA (regA "odeklarerad") ;
  odeklamerad_av_1_A = compoundA (regA "odeklamerad") ;
  odekapiterad_av_1_A = compoundA (regA "odekapiterad") ;
  odekanterad_av_1_A = compoundA (regA "odekanterad") ;
  odejtad_av_1_A = compoundA (regA "odejtad") ;
  odegraderad_av_1_A = compoundA (regA "odegraderad") ;
  odegenererad_av_1_A = compoundA (regA "odegenererad") ;
  odeformerad_av_1_A = compoundA (regA "odeformerad") ;
  odeflorerad_av_1_A = compoundA (regA "odeflorerad") ;
  odefinierad_av_1_A = compoundA (regA "odefinierad") ;
  odefilerad_av_1_A = compoundA (regA "odefilerad") ;
  odeducerad_av_1_A = compoundA (regA "odeducerad") ;
  odedikerad_av_1_A = compoundA (regA "odedikerad") ;
  odedicerad_av_1_A = compoundA (regA "odedicerad") ;
  odecimerad_av_1_A = compoundA (regA "odecimerad") ;
  odeciderad_av_1_A = compoundA (regA "odeciderad") ;
  odechiffrerad_av_1_A = compoundA (regA "odechiffrerad") ;
  odecentraliserad_av_1_A = compoundA (regA "odecentraliserad") ;
  odebiterad_av_1_A = compoundA (regA "odebiterad") ;
  odebatterad_av_1_A = compoundA (regA "odebatterad") ;
  odebarkerad_av_1_A = compoundA (regA "odebarkerad") ;
  odatoriserad_av_1_A = compoundA (regA "odatoriserad") ;
  odaterad_av_1_A = compoundA (regA "odaterad") ;
  odaskad_av_1_A = compoundA (regA "odaskad") ;
  odanad_av_1_A = compoundA (regA "odanad") ;
  odampad_av_1_A = compoundA (regA "odampad") ;
  odammad_av_1_A = compoundA (regA "odammad") ;
  odaddad_av_1_A = compoundA (regA "odaddad") ;
  ocyklad_av_1_A = compoundA (regA "ocyklad") ;
  ocurerad_av_1_A = compoundA (regA "ocurerad") ;
  ocuraterad_av_1_A = compoundA (regA "ocuraterad") ;
  oclearad_av_1_A = compoundA (regA "oclearad") ;
  ociviliserad_av_1_A = compoundA (regA "ociviliserad") ;
  ociterad_av_1_A = compoundA (regA "ociterad") ;
  ociselerad_av_1_A = compoundA (regA "ociselerad") ;
  ocirkulerad_av_1_A = compoundA (regA "ocirkulerad") ;
  ochokad_av_1_A = compoundA (regA "ochokad") ;
  ochockerad_av_1_A = compoundA (regA "ochockerad") ;
  ochockad_av_1_A = compoundA (regA "ochockad") ;
  ochikanerad_av_1_A = compoundA (regA "ochikanerad") ;
  ochiffrerad_av_1_A = compoundA (regA "ochiffrerad") ;
  ochevroterad_av_1_A = compoundA (regA "ochevroterad") ;
  ocheckad_av_1_A = compoundA (regA "ocheckad") ;
  ochartrad_av_1_A = compoundA (regA "ochartrad") ;
  ocharmerad_av_1_A = compoundA (regA "ocharmerad") ;
  ocharmad_av_1_A = compoundA (regA "ocharmad") ;
  ochargerad_av_1_A = compoundA (regA "ochargerad") ;
  ocernerad_av_1_A = compoundA (regA "ocernerad") ;
  ocentrifugerad_av_1_A = compoundA (regA "ocentrifugerad") ;
  ocentrerad_av_1_A = compoundA (regA "ocentrerad") ;
  ocentraliserad_av_1_A = compoundA (regA "ocentraliserad") ;
  ocentrad_av_1_A = compoundA (regA "ocentrad") ;
  ocensurerad_av_1_A = compoundA (regA "ocensurerad") ;
  ocementerad_av_1_A = compoundA (regA "ocementerad") ;
  ocementad_av_1_A = compoundA (regA "ocementad") ;
  ocelebrerad_av_1_A = compoundA (regA "ocelebrerad") ;
  ocederad_av_1_A = compoundA (regA "ocederad") ;
  ocaterad_av_1_A = compoundA (regA "ocaterad") ;
  ocamouflerad_av_1_A = compoundA (regA "ocamouflerad") ;
  oboetad_av_1_1_A = compoundA (regA "obötad") ;
  oboerjad_av_1_1_A = compoundA (regA "obörjad") ;
  obaagnad_av_1_1_A = compoundA (regA "obågnad") ;
  obaettrad_av_1_1_A = compoundA (regA "obättrad") ;
  obaergad_av_1_1_A = compoundA (regA "obärgad") ;
  obaenslad_av_1_1_A = compoundA (regA "obänslad") ;
  obaendslad_av_1_1_A = compoundA (regA "obändslad") ;
  obaelgad_av_1_1_A = compoundA (regA "obälgad") ;
  obaeddad_av_1_1_A = compoundA (regA "obäddad") ;
  obyraakratiserad_av_1_1_A = compoundA (regA "obyråkratiserad") ;
  obuteljerad_av_1_A = compoundA (regA "obuteljerad") ;
  obussad_av_1_A = compoundA (regA "obussad") ;
  obuskad_av_1_A = compoundA (regA "obuskad") ;
  oburkad_av_1_A = compoundA (regA "oburkad") ;
  obuntad_av_1_A = compoundA (regA "obuntad") ;
  obunkrad_av_1_A = compoundA (regA "obunkrad") ;
  obultad_av_1_A = compoundA (regA "obultad") ;
  obuffrad_av_1_A = compoundA (regA "obuffrad") ;
  obuffad_av_1_A = compoundA (regA "obuffad") ;
  obudgeterad_av_1_A = compoundA (regA "obudgeterad") ;
  obudad_av_1_A = compoundA (regA "obudad") ;
  obubbad_av_1_A = compoundA (regA "obubbad") ;
  obroedad_av_1_1_A = compoundA (regA "obrödad") ;
  obroead_av_1_1_A = compoundA (regA "obröad") ;
  obraakad_av_1_1_A = compoundA (regA "obråkad") ;
  obraeserad_av_1_1_A = compoundA (regA "obräserad") ;
  obraemad_av_1_1_A = compoundA (regA "obrämad") ;
  obraeddad_av_1_1_A = compoundA (regA "obräddad") ;
  obraedad_av_1_1_A = compoundA (regA "obrädad") ;
  obrutaliserad_av_1_A = compoundA (regA "obrutaliserad") ;
  obrunfaergad_av_1_1_A = compoundA (regA "obrunfärgad") ;
  obrunerad_av_1_A = compoundA (regA "obrunerad") ;
  obrukad_av_1_A = compoundA (regA "obrukad") ;
  obrucklad_av_1_A = compoundA (regA "obrucklad") ;
  obrotschad_av_1_A = compoundA (regA "obrotschad") ;
  obrosslad_av_1_A = compoundA (regA "obrosslad") ;
  obroscherad_av_1_A = compoundA (regA "obroscherad") ;
  obronserad_av_1_A = compoundA (regA "obronserad") ;
  obromsad_av_1_A = compoundA (regA "obromsad") ;
  obromerad_av_1_A = compoundA (regA "obromerad") ;
  obroderad_av_1_A = compoundA (regA "obroderad") ;
  obroddad_av_1_A = compoundA (regA "obroddad") ;
  obroad_av_1_A = compoundA (regA "obroad") ;
  obriserad_av_1_A = compoundA (regA "obriserad") ;
  obriketterad_av_1_A = compoundA (regA "obriketterad") ;
  obriefad_av_1_A = compoundA (regA "obriefad") ;
  obreddad_av_1_A = compoundA (regA "obreddad") ;
  obrassad_av_1_A = compoundA (regA "obrassad") ;
  oboxad_av_1_A = compoundA (regA "oboxad") ;
  obotad_av_1_A = compoundA (regA "obotad") ;
  oborstad_av_1_A = compoundA (regA "oborstad") ;
  oborrad_av_1_A = compoundA (regA "oborrad") ;
  oborgad_av_1_A = compoundA (regA "oborgad") ;
  obordad_av_1_A = compoundA (regA "obordad") ;
  obootad_av_1_A = compoundA (regA "obootad") ;
  oboniterad_av_1_A = compoundA (regA "oboniterad") ;
  obongad_av_1_A = compoundA (regA "obongad") ;
  obonad_av_1_A = compoundA (regA "obonad") ;
  obommad_av_1_A = compoundA (regA "obommad") ;
  obombarderad_av_1_A = compoundA (regA "obombarderad") ;
  obombad_av_1_A = compoundA (regA "obombad") ;
  obollad_av_1_A = compoundA (regA "obollad") ;
  obokstaverad_av_1_A = compoundA (regA "obokstaverad") ;
  obokad_av_1_A = compoundA (regA "obokad") ;
  obojkottad_av_1_A = compoundA (regA "obojkottad") ;
  obogserad_av_1_A = compoundA (regA "obogserad") ;
  obockad_av_1_A = compoundA (regA "obockad") ;
  obobbad_av_1_A = compoundA (regA "obobbad") ;
  oboaserad_av_1_A = compoundA (regA "oboaserad") ;
  oblaestrad_av_1_1_A = compoundA (regA "oblästrad") ;
  oblaestad_av_1_1_A = compoundA (regA "oblästad") ;
  oblaendad_av_1_1_A = compoundA (regA "obländad") ;
  oblaeddrad_av_1_1_A = compoundA (regA "obläddrad") ;
  oblaedad_av_1_1_A = compoundA (regA "oblädad") ;
  oblaeckad_av_1_1_A = compoundA (regA "obläckad") ;
  oblyad_av_1_A = compoundA (regA "oblyad") ;
  obluffad_av_1_A = compoundA (regA "obluffad") ;
  oblottad_av_1_A = compoundA (regA "oblottad") ;
  oblonderad_av_1_A = compoundA (regA "oblonderad") ;
  oblommograferad_av_1_A = compoundA (regA "oblommograferad") ;
  obloggad_av_1_A = compoundA (regA "obloggad") ;
  oblodad_av_1_A = compoundA (regA "oblodad") ;
  oblockerad_av_1_A = compoundA (regA "oblockerad") ;
  oblockad_av_1_A = compoundA (regA "oblockad") ;
  oblinderad_av_1_A = compoundA (regA "oblinderad") ;
  oblidkad_av_1_A = compoundA (regA "oblidkad") ;
  oblesserad_av_1_A = compoundA (regA "oblesserad") ;
  obleknad_av_1_A = compoundA (regA "obleknad") ;
  oblankad_av_1_A = compoundA (regA "oblankad") ;
  oblandad_av_1_A = compoundA (regA "oblandad") ;
  oblancherad_av_1_A = compoundA (regA "oblancherad") ;
  obladad_av_1_A = compoundA (regA "obladad") ;
  objoernad_av_1_1_A = compoundA (regA "objörnad") ;
  objussad_av_1_A = compoundA (regA "objussad") ;
  obivackerad_av_1_A = compoundA (regA "obivackerad") ;
  obitad_av_1_A = compoundA (regA "obitad") ;
  obisserad_av_1_A = compoundA (regA "obisserad") ;
  obiograferad_av_1_A = compoundA (regA "obiograferad") ;
  obildad_av_1_A = compoundA (regA "obildad") ;
  obilad_av_1_A = compoundA (regA "obilad") ;
  obiktad_av_1_A = compoundA (regA "obiktad") ;
  obifogad_av_1_A = compoundA (regA "obifogad") ;
  obidad_av_1_A = compoundA (regA "obidad") ;
  obevaerdigad_av_1_1_A = compoundA (regA "obevärdigad") ;
  obevaerad_av_1_1_A = compoundA (regA "obevärad") ;
  obevaepnad_av_1_1_A = compoundA (regA "obeväpnad") ;
  obevittnad_av_1_A = compoundA (regA "obevittnad") ;
  obevistad_av_1_A = compoundA (regA "obevistad") ;
  obevisad_av_1_A = compoundA (regA "obevisad") ;
  obeviljad_av_1_A = compoundA (regA "obeviljad") ;
  obevattnad_av_1_A = compoundA (regA "obevattnad") ;
  obevarad_av_1_A = compoundA (regA "obevarad") ;
  obevandrad_av_1_A = compoundA (regA "obevandrad") ;
  obevakad_av_1_A = compoundA (regA "obevakad") ;
  obeundrad_av_1_A = compoundA (regA "obeundrad") ;
  obetygad_av_1_A = compoundA (regA "obetygad") ;
  obetvivlad_av_1_A = compoundA (regA "obetvivlad") ;
  obetungad_av_1_A = compoundA (regA "obetungad") ;
  obetslad_av_1_A = compoundA (regA "obetslad") ;
  obetsad_av_1_A = compoundA (regA "obetsad") ;
  obetraeffad_av_1_1_A = compoundA (regA "obeträffad") ;
  obetryggad_av_1_A = compoundA (regA "obetryggad") ;
  obetraktad_av_1_A = compoundA (regA "obetraktad") ;
  obetongerad_av_1_A = compoundA (regA "obetongerad") ;
  obetonad_av_1_A = compoundA (regA "obetonad") ;
  obetjaenad_av_1_1_A = compoundA (regA "obetjänad") ;
  obetittad_av_1_A = compoundA (regA "obetittad") ;
  obetitlad_av_1_A = compoundA (regA "obetitlad") ;
  obetingad_av_1_A = compoundA (regA "obetingad") ;
  obetecknad_av_1_A = compoundA (regA "obetecknad") ;
  obetad_av_1_A = compoundA (regA "obetad") ;
  obesvaerad_av_1_1_A = compoundA (regA "obesvärad") ;
  obesvarad_av_1_A = compoundA (regA "obesvarad") ;
  obesudlad_av_1_A = compoundA (regA "obesudlad") ;
  obestyckad_av_1_A = compoundA (regA "obestyckad") ;
  obestraalad_av_1_1_A = compoundA (regA "obestrålad") ;
  obestraffad_av_1_A = compoundA (regA "obestraffad") ;
  obestormad_av_1_A = compoundA (regA "obestormad") ;
  obesprutad_av_1_A = compoundA (regA "obesprutad") ;
  obespottad_av_1_A = compoundA (regA "obespottad") ;
  obespolad_av_1_A = compoundA (regA "obespolad") ;
  obespisad_av_1_A = compoundA (regA "obespisad") ;
  obespejad_av_1_A = compoundA (regA "obespejad") ;
  obesoldad_av_1_A = compoundA (regA "obesoldad") ;
  obesockrad_av_1_A = compoundA (regA "obesockrad") ;
  obesmittad_av_1_A = compoundA (regA "obesmittad") ;
  obesloejad_av_1_1_A = compoundA (regA "obeslöjad") ;
  obeslaektad_av_1_1_A = compoundA (regA "obesläktad") ;
  obeskaadad_av_1_1_A = compoundA (regA "obeskådad") ;
  obeskaermad_av_1_1_A = compoundA (regA "obeskärmad") ;
  obeskyddad_av_1_A = compoundA (regA "obeskyddad") ;
  obeskuggad_av_1_A = compoundA (regA "obeskuggad") ;
  obeskickad_av_1_A = compoundA (regA "obeskickad") ;
  obeskattad_av_1_A = compoundA (regA "obeskattad") ;
  obesjaelad_av_1_1_A = compoundA (regA "obesjälad") ;
  obesinnad_av_1_A = compoundA (regA "obesinnad") ;
  obesiktigad_av_1_A = compoundA (regA "obesiktigad") ;
  obesegrad_av_1_A = compoundA (regA "obesegrad") ;
  obeseglad_av_1_A = compoundA (regA "obeseglad") ;
  obesannad_av_1_A = compoundA (regA "obesannad") ;
  oberoevad_av_1_1_A = compoundA (regA "oberövad") ;
  oberaettigad_av_1_1_A = compoundA (regA "oberättigad") ;
  oberaettad_av_1_1_A = compoundA (regA "oberättad") ;
  oberaeknad_av_1_1_A = compoundA (regA "oberäknad") ;
  oberusad_av_1_A = compoundA (regA "oberusad") ;
  oberiktigad_av_1_A = compoundA (regA "oberiktigad") ;
  oberikad_av_1_A = compoundA (regA "oberikad") ;
  obepudrad_av_1_A = compoundA (regA "obepudrad") ;
  obeproevad_av_1_1_A = compoundA (regA "obeprövad") ;
  obeprisad_av_1_A = compoundA (regA "obeprisad") ;
  obepansrad_av_1_A = compoundA (regA "obepansrad") ;
  obeordrad_av_1_A = compoundA (regA "obeordrad") ;
  obenaadad_av_1_1_A = compoundA (regA "obenådad") ;
  obenad_av_1_A = compoundA (regA "obenad") ;
  obemaestrad_av_1_1_A = compoundA (regA "obemästrad") ;
  obemyndigad_av_1_A = compoundA (regA "obemyndigad") ;
  obemedlad_av_1_A = compoundA (regA "obemedlad") ;
  obemantlad_av_1_A = compoundA (regA "obemantlad") ;
  obemannad_av_1_A = compoundA (regA "obemannad") ;
  obeloenad_av_1_1_A = compoundA (regA "obelönad") ;
  obelaanad_av_1_1_A = compoundA (regA "obelånad") ;
  obelaegrad_av_1_1_A = compoundA (regA "obelägrad") ;
  obeledsagad_av_1_A = compoundA (regA "obeledsagad") ;
  obelastad_av_1_A = compoundA (regA "obelastad") ;
  obelamrad_av_1_A = compoundA (regA "obelamrad") ;
  obekaempad_av_1_1_A = compoundA (regA "obekämpad") ;
  obekymrad_av_1_A = compoundA (regA "obekymrad") ;
  obekraeftad_av_1_1_A = compoundA (regA "obekräftad") ;
  obekrigad_av_1_A = compoundA (regA "obekrigad") ;
  obekransad_av_1_A = compoundA (regA "obekransad") ;
  obekostad_av_1_A = compoundA (regA "obekostad") ;
  obeklagad_av_1_A = compoundA (regA "obeklagad") ;
  obekikad_av_1_A = compoundA (regA "obekikad") ;
  obekajad_av_1_A = compoundA (regA "obekajad") ;
  obejublad_av_1_A = compoundA (regA "obejublad") ;
  obejakad_av_1_A = compoundA (regA "obejakad") ;
  obeivrad_av_1_A = compoundA (regA "obeivrad") ;
  obehaerskad_av_1_1_A = compoundA (regA "obehärskad") ;
  obehindrad_av_1_A = compoundA (regA "obehindrad") ;
  obehandlad_av_1_A = compoundA (regA "obehandlad") ;
  obegaavad_av_1_1_A = compoundA (regA "obegåvad") ;
  obegraensad_av_1_1_A = compoundA (regA "obegränsad") ;
  obegrundad_av_1_A = compoundA (regA "obegrundad") ;
  obegapad_av_1_A = compoundA (regA "obegapad") ;
  obegagnad_av_1_A = compoundA (regA "obegagnad") ;
  obegabbad_av_1_A = compoundA (regA "obegabbad") ;
  obefullmaektigad_av_1_1_A = compoundA (regA "obefullmäktigad") ;
  obefraemjad_av_1_1_A = compoundA (regA "obefrämjad") ;
  obefryndad_av_1_A = compoundA (regA "obefryndad") ;
  obefruktad_av_1_A = compoundA (regA "obefruktad") ;
  obefriad_av_1_A = compoundA (regA "obefriad") ;
  obefraktad_av_1_A = compoundA (regA "obefraktad") ;
  obefordrad_av_1_A = compoundA (regA "obefordrad") ;
  obefolkad_av_1_A = compoundA (regA "obefolkad") ;
  obefogad_av_1_A = compoundA (regA "obefogad") ;
  obeflaeckad_av_1_1_A = compoundA (regA "obefläckad") ;
  obefarad_av_1_A = compoundA (regA "obefarad") ;
  obeedigad_av_1_A = compoundA (regA "obeedigad") ;
  obedoevad_av_1_1_A = compoundA (regA "obedövad") ;
  obedaarad_av_1_1_A = compoundA (regA "obedårad") ;
  obedyrad_av_1_A = compoundA (regA "obedyrad") ;
  obedroevad_av_1_1_A = compoundA (regA "obedrövad") ;
  obedarrad_av_1_A = compoundA (regA "obedarrad") ;
  obeckad_av_1_A = compoundA (regA "obeckad") ;
  obebaadad_av_1_1_A = compoundA (regA "obebådad") ;
  obearbetad_av_1_A = compoundA (regA "obearbetad") ;
  obeaktad_av_1_A = compoundA (regA "obeaktad") ;
  obaxad_av_1_A = compoundA (regA "obaxad") ;
  obastad_av_1_A = compoundA (regA "obastad") ;
  obaserad_av_1_A = compoundA (regA "obaserad") ;
  obarrikaderad_av_1_A = compoundA (regA "obarrikaderad") ;
  obarrad_av_1_A = compoundA (regA "obarrad") ;
  obarlastad_av_1_A = compoundA (regA "obarlastad") ;
  obarkad_av_1_A = compoundA (regA "obarkad") ;
  obantad_av_1_A = compoundA (regA "obantad") ;
  obannad_av_1_A = compoundA (regA "obannad") ;
  obankrutterad_av_1_A = compoundA (regA "obankrutterad") ;
  obankad_av_1_A = compoundA (regA "obankad") ;
  obandad_av_1_A = compoundA (regA "obandad") ;
  obanaliserad_av_1_A = compoundA (regA "obanaliserad") ;
  obanad_av_1_A = compoundA (regA "obanad") ;
  obalsamerad_av_1_A = compoundA (regA "obalsamerad") ;
  oballoterad_av_1_A = compoundA (regA "oballoterad") ;
  obalanserad_av_1_A = compoundA (regA "obalanserad") ;
  obalad_av_1_A = compoundA (regA "obalad") ;
  obaktalad_av_1_A = compoundA (regA "obaktalad") ;
  obakdantad_av_1_A = compoundA (regA "obakdantad") ;
  obakad_av_1_A = compoundA (regA "obakad") ;
  obajsad_av_1_A = compoundA (regA "obajsad") ;
  obaissad_av_1_A = compoundA (regA "obaissad") ;
  obagatelliserad_av_1_A = compoundA (regA "obagatelliserad") ;
  obaddad_av_1_A = compoundA (regA "obaddad") ;
  obadad_av_1_A = compoundA (regA "obadad") ;
  obackuppad_av_1_A = compoundA (regA "obackuppad") ;
  obackupad_av_1_A = compoundA (regA "obackupad") ;
  obackad_av_1_A = compoundA (regA "obackad") ;
  oaxlad_av_1_A = compoundA (regA "oaxlad") ;
  oaxiomatiserad_av_1_A = compoundA (regA "oaxiomatiserad") ;
  oavyttrad_av_1_A = compoundA (regA "oavyttrad") ;
  oavvaepnad_av_1_1_A = compoundA (regA "oavväpnad") ;
  oavvittrad_av_1_A = compoundA (regA "oavvittrad") ;
  oavvitad_av_1_A = compoundA (regA "oavvitad") ;
  oavvisad_av_1_A = compoundA (regA "oavvisad") ;
  oavverkad_av_1_A = compoundA (regA "oavverkad") ;
  oavvecklad_av_1_A = compoundA (regA "oavvecklad") ;
  oavvattnad_av_1_A = compoundA (regA "oavvattnad") ;
  oavvaktad_av_1_A = compoundA (regA "oavvaktad") ;
  oavtaagad_av_1_1_A = compoundA (regA "oavtågad") ;
  oavtunnad_av_1_A = compoundA (regA "oavtunnad") ;
  oavtrubbad_av_1_A = compoundA (regA "oavtrubbad") ;
  oavtrappad_av_1_A = compoundA (regA "oavtrappad") ;
  oavtonad_av_1_A = compoundA (regA "oavtonad") ;
  oavtjaenad_av_1_1_A = compoundA (regA "oavtjänad") ;
  oavtecknad_av_1_A = compoundA (regA "oavtecknad") ;
  oavtappad_av_1_A = compoundA (regA "oavtappad") ;
  oavtalad_av_1_A = compoundA (regA "oavtalad") ;
  oavtackad_av_1_A = compoundA (regA "oavtackad") ;
  oavsoendrad_av_1_1_A = compoundA (regA "oavsöndrad") ;
  oavsynad_av_1_A = compoundA (regA "oavsynad") ;
  oavsvavlad_av_1_A = compoundA (regA "oavsvavlad") ;
  oavsvalnad_av_1_A = compoundA (regA "oavsvalnad") ;
  oavstyckad_av_1_A = compoundA (regA "oavstyckad") ;
  oavstressad_av_1_A = compoundA (regA "oavstressad") ;
  oavstavad_av_1_A = compoundA (regA "oavstavad") ;
  oavstannad_av_1_A = compoundA (regA "oavstannad") ;
  oavstaliniserad_av_1_A = compoundA (regA "oavstaliniserad") ;
  oavspaerrad_av_1_1_A = compoundA (regA "oavspärrad") ;
  oavspisad_av_1_A = compoundA (regA "oavspisad") ;
  oavspelad_av_1_A = compoundA (regA "oavspelad") ;
  oavspeglad_av_1_A = compoundA (regA "oavspeglad") ;
  oavsomnad_av_1_A = compoundA (regA "oavsomnad") ;
  oavsocialiserad_av_1_A = compoundA (regA "oavsocialiserad") ;
  oavsmalnad_av_1_A = compoundA (regA "oavsmalnad") ;
  oavsmakad_av_1_A = compoundA (regA "oavsmakad") ;
  oavsloejad_av_1_1_A = compoundA (regA "oavslöjad") ;
  oavslutad_av_1_A = compoundA (regA "oavslutad") ;
  oavslipad_av_1_A = compoundA (regA "oavslipad") ;
  oavskaermad_av_1_1_A = compoundA (regA "oavskärmad") ;
  oavskedad_av_1_A = compoundA (regA "oavskedad") ;
  oavskaffad_av_1_A = compoundA (regA "oavskaffad") ;
  oavseglad_av_1_A = compoundA (regA "oavseglad") ;
  oavsaltad_av_1_A = compoundA (regA "oavsaltad") ;
  oavraettad_av_1_1_A = compoundA (regA "oavrättad") ;
  oavraeknad_av_1_1_A = compoundA (regA "oavräknad") ;
  oavrustad_av_1_A = compoundA (regA "oavrustad") ;
  oavrundad_av_1_A = compoundA (regA "oavrundad") ;
  oavromantiserad_av_1_A = compoundA (regA "oavromantiserad") ;
  oavreglerad_av_1_A = compoundA (regA "oavreglerad") ;
  oavregistrerad_av_1_A = compoundA (regA "oavregistrerad") ;
  oavreagerad_av_1_A = compoundA (regA "oavreagerad") ;
  oavpressad_av_1_A = compoundA (regA "oavpressad") ;
  oavportraetterad_av_1_1_A = compoundA (regA "oavporträtterad") ;
  oavpolletterad_av_1_A = compoundA (regA "oavpolletterad") ;
  oavpolitiserad_av_1_A = compoundA (regA "oavpolitiserad") ;
  oavplanad_av_1_A = compoundA (regA "oavplanad") ;
  oavpatrullerad_av_1_A = compoundA (regA "oavpatrullerad") ;
  oavpassad_av_1_A = compoundA (regA "oavpassad") ;
  oavnazifierad_av_1_A = compoundA (regA "oavnazifierad") ;
  oavnavlad_av_1_A = compoundA (regA "oavnavlad") ;
  oavmattad_av_1_A = compoundA (regA "oavmattad") ;
  oavmastad_av_1_A = compoundA (regA "oavmastad") ;
  oavmaskad_av_1_A = compoundA (regA "oavmaskad") ;
  oavmagnetiserad_av_1_A = compoundA (regA "oavmagnetiserad") ;
  oavloevad_av_1_1_A = compoundA (regA "oavlövad") ;
  oavloenad_av_1_1_A = compoundA (regA "oavlönad") ;
  oavlaenkad_av_1_1_A = compoundA (regA "oavlänkad") ;
  oavlaemnad_av_1_1_A = compoundA (regA "oavlämnad") ;
  oavlaegsnad_av_1_1_A = compoundA (regA "oavlägsnad") ;
  oavlyssnad_av_1_A = compoundA (regA "oavlyssnad") ;
  oavlusad_av_1_A = compoundA (regA "oavlusad") ;
  oavlossad_av_1_A = compoundA (regA "oavlossad") ;
  oavlockad_av_1_A = compoundA (regA "oavlockad") ;
  oavlivad_av_1_A = compoundA (regA "oavlivad") ;
  oavlastad_av_1_A = compoundA (regA "oavlastad") ;
  oavlagrad_av_1_A = compoundA (regA "oavlagrad") ;
  oavlad_av_1_A = compoundA (regA "oavlad") ;
  oavkoenad_av_1_1_A = compoundA (regA "oavkönad") ;
  oavkunnad_av_1_A = compoundA (regA "oavkunnad") ;
  oavkristnad_av_1_A = compoundA (regA "oavkristnad") ;
  oavkriminaliserad_av_1_A = compoundA (regA "oavkriminaliserad") ;
  oavkortad_av_1_A = compoundA (regA "oavkortad") ;
  oavkopplad_av_1_A = compoundA (regA "oavkopplad") ;
  oavkoloniserad_av_1_A = compoundA (regA "oavkoloniserad") ;
  oavknoppad_av_1_A = compoundA (regA "oavknoppad") ;
  oavklingad_av_1_A = compoundA (regA "oavklingad") ;
  oavklarad_av_1_A = compoundA (regA "oavklarad") ;
  oavkalkad_av_1_A = compoundA (regA "oavkalkad") ;
  oavjaemnad_av_1_1_A = compoundA (regA "oavjämnad") ;
  oavjagad_av_1_A = compoundA (regA "oavjagad") ;
  oaviserad_av_1_A = compoundA (regA "oaviserad") ;
  oavisad_av_1_A = compoundA (regA "oavisad") ;
  oavhoestad_av_1_1_A = compoundA (regA "oavhöstad") ;
  oavhaerdad_av_1_1_A = compoundA (regA "oavhärdad") ;
  oavhaemtad_av_1_1_A = compoundA (regA "oavhämtad") ;
  oavhandlad_av_1_A = compoundA (regA "oavhandlad") ;
  oavgaerdad_av_1_1_A = compoundA (regA "oavgärdad") ;
  oavgudad_av_1_A = compoundA (regA "oavgudad") ;
  oavgraensad_av_1_1_A = compoundA (regA "oavgränsad") ;
  oavgiftad_av_1_A = compoundA (regA "oavgiftad") ;
  oavfaerdad_av_1_1_A = compoundA (regA "oavfärdad") ;
  oavfyrad_av_1_A = compoundA (regA "oavfyrad") ;
  oavfuktad_av_1_A = compoundA (regA "oavfuktad") ;
  oavfordrad_av_1_A = compoundA (regA "oavfordrad") ;
  oavfolkad_av_1_A = compoundA (regA "oavfolkad") ;
  oavflyttad_av_1_A = compoundA (regA "oavflyttad") ;
  oavfettad_av_1_A = compoundA (regA "oavfettad") ;
  oavfattad_av_1_A = compoundA (regA "oavfattad") ;
  oavdunstad_av_1_A = compoundA (regA "oavdunstad") ;
  oavdramatiserad_av_1_A = compoundA (regA "oavdramatiserad") ;
  oavdelad_av_1_A = compoundA (regA "oavdelad") ;
  oavboerdad_av_1_1_A = compoundA (regA "oavbördad") ;
  oavbildad_av_1_A = compoundA (regA "oavbildad") ;
  oavbetalad_av_1_A = compoundA (regA "oavbetalad") ;
  oavbetad_av_1_A = compoundA (regA "oavbetad") ;
  oavbalkad_av_1_A = compoundA (regA "oavbalkad") ;
  oavannonserad_av_1_A = compoundA (regA "oavannonserad") ;
  oavancerad_av_1_A = compoundA (regA "oavancerad") ;
  oavad_av_1_A = compoundA (regA "oavad") ;
  oautomatiserad_av_1_A = compoundA (regA "oautomatiserad") ;
  oautentiserad_av_1_A = compoundA (regA "oautentiserad") ;
  oautentifierad_av_1_A = compoundA (regA "oautentifierad") ;
  oautenticerad_av_1_A = compoundA (regA "oautenticerad") ;
  oauskulterad_av_1_A = compoundA (regA "oauskulterad") ;
  oauktoriserad_av_1_A = compoundA (regA "oauktoriserad") ;
  oauktionerad_av_1_A = compoundA (regA "oauktionerad") ;
  oattribuerad_av_1_A = compoundA (regA "oattribuerad") ;
  oattrapperad_av_1_A = compoundA (regA "oattrapperad") ;
  oattraherad_av_1_A = compoundA (regA "oattraherad") ;
  oattesterad_av_1_A = compoundA (regA "oattesterad") ;
  oattackerad_av_1_A = compoundA (regA "oattackerad") ;
  oatrofierad_av_1_A = compoundA (regA "oatrofierad") ;
  oassurerad_av_1_A = compoundA (regA "oassurerad") ;
  oassocierad_av_1_A = compoundA (regA "oassocierad") ;
  oassisterad_av_1_A = compoundA (regA "oassisterad") ;
  oassimilerad_av_1_A = compoundA (regA "oassimilerad") ;
  oassignerad_av_1_A = compoundA (regA "oassignerad") ;
  oaspirerad_av_1_A = compoundA (regA "oaspirerad") ;
  oaskad_av_1_A = compoundA (regA "oaskad") ;
  oasfalterad_av_1_A = compoundA (regA "oasfalterad") ;
  oarvoderad_av_1_A = compoundA (regA "oarvoderad") ;
  oartikulerad_av_1_A = compoundA (regA "oartikulerad") ;
  oarronderad_av_1_A = compoundA (regA "oarronderad") ;
  oarresterad_av_1_A = compoundA (regA "oarresterad") ;
  oarrenderad_av_1_A = compoundA (regA "oarrenderad") ;
  oarrangerad_av_1_A = compoundA (regA "oarrangerad") ;
  oarmerad_av_1_A = compoundA (regA "oarmerad") ;
  oarkiverad_av_1_A = compoundA (regA "oarkiverad") ;
  oarkebuserad_av_1_A = compoundA (regA "oarkebuserad") ;
  oarkaiserad_av_1_A = compoundA (regA "oarkaiserad") ;
  oargumenterad_av_1_A = compoundA (regA "oargumenterad") ;
  oarbetad_av_1_A = compoundA (regA "oarbetad") ;
  oapterad_av_1_A = compoundA (regA "oapterad") ;
  oapproximerad_av_1_A = compoundA (regA "oapproximerad") ;
  oapprocherad_av_1_A = compoundA (regA "oapprocherad") ;
  oappreterad_av_1_A = compoundA (regA "oappreterad") ;
  oapprecierad_av_1_A = compoundA (regA "oapprecierad") ;
  oapporterad_av_1_A = compoundA (regA "oapporterad") ;
  oapplaaderad_av_1_1_A = compoundA (regA "oapplåderad") ;
  oapplicerad_av_1_A = compoundA (regA "oapplicerad") ;
  oappellerad_av_1_A = compoundA (regA "oappellerad") ;
  oapostroferad_av_1_A = compoundA (regA "oapostroferad") ;
  oanvisad_av_1_A = compoundA (regA "oanvisad") ;
  oantaagad_av_1_1_A = compoundA (regA "oantågad") ;
  oantvardad_av_1_A = compoundA (regA "oantvardad") ;
  oantraeffad_av_1_1_A = compoundA (regA "oanträffad") ;
  oantikiserad_av_1_A = compoundA (regA "oantikiserad") ;
  oantichambrerad_av_1_A = compoundA (regA "oantichambrerad") ;
  oantedaterad_av_1_A = compoundA (regA "oantedaterad") ;
  oantecknad_av_1_A = compoundA (regA "oantecknad") ;
  oanteciperad_av_1_A = compoundA (regA "oanteciperad") ;
  oantastad_av_1_A = compoundA (regA "oantastad") ;
  oanstormad_av_1_A = compoundA (regA "oanstormad") ;
  oanstiftad_av_1_A = compoundA (regA "oanstiftad") ;
  oanspelad_av_1_A = compoundA (regA "oanspelad") ;
  oanskaffad_av_1_A = compoundA (regA "oanskaffad") ;
  oansamlad_av_1_A = compoundA (regA "oansamlad") ;
  oansad_av_1_A = compoundA (regA "oansad") ;
  oanraettad_av_1_1_A = compoundA (regA "oanrättad") ;
  oanropad_av_1_A = compoundA (regA "oanropad") ;
  oanrikad_av_1_A = compoundA (regA "oanrikad") ;
  oanpassad_av_1_A = compoundA (regA "oanpassad") ;
  oanordnad_av_1_A = compoundA (regA "oanordnad") ;
  oanonymiserad_av_1_A = compoundA (regA "oanonymiserad") ;
  oanodiserad_av_1_A = compoundA (regA "oanodiserad") ;
  oannullerad_av_1_A = compoundA (regA "oannullerad") ;
  oannoterad_av_1_A = compoundA (regA "oannoterad") ;
  oannonserad_av_1_A = compoundA (regA "oannonserad") ;
  oannihilerad_av_1_A = compoundA (regA "oannihilerad") ;
  oannekterad_av_1_A = compoundA (regA "oannekterad") ;
  oanmodad_av_1_A = compoundA (regA "oanmodad") ;
  oanmanad_av_1_A = compoundA (regA "oanmanad") ;
  oanlitad_av_1_A = compoundA (regA "oanlitad") ;
  oankrad_av_1_A = compoundA (regA "oankrad") ;
  oanklagad_av_1_A = compoundA (regA "oanklagad") ;
  oanimerad_av_1_A = compoundA (regA "oanimerad") ;
  oanhopad_av_1_A = compoundA (regA "oanhopad") ;
  oangliserad_av_1_A = compoundA (regA "oangliserad") ;
  oanglad_av_1_A = compoundA (regA "oanglad") ;
  oanfaektad_av_1_1_A = compoundA (regA "oanfäktad") ;
  oanammad_av_1_A = compoundA (regA "oanammad") ;
  oanalyserad_av_1_A = compoundA (regA "oanalyserad") ;
  oanad_av_1_A = compoundA (regA "oanad") ;
  oamputerad_av_1_A = compoundA (regA "oamputerad") ;
  oamplifierad_av_1_A = compoundA (regA "oamplifierad") ;
  oamorterad_av_1_A = compoundA (regA "oamorterad") ;
  oammad_av_1_A = compoundA (regA "oammad") ;
  oamerikaniserad_av_1_A = compoundA (regA "oamerikaniserad") ;
  oambulerad_av_1_A = compoundA (regA "oambulerad") ;
  oamalgamerad_av_1_A = compoundA (regA "oamalgamerad") ;
  oaluminerad_av_1_A = compoundA (regA "oaluminerad") ;
  oalternerad_av_1_A = compoundA (regA "oalternerad") ;
  oalstrad_av_1_A = compoundA (regA "oalstrad") ;
  oalluderad_av_1_A = compoundA (regA "oalluderad") ;
  oallokerad_av_1_A = compoundA (regA "oallokerad") ;
  oallmaenbildad_av_1_1_A = compoundA (regA "oallmänbildad") ;
  oallittererad_av_1_A = compoundA (regA "oallittererad") ;
  oallierad_av_1_A = compoundA (regA "oallierad") ;
  oallegoriserad_av_1_A = compoundA (regA "oallegoriserad") ;
  oalienerad_av_1_A = compoundA (regA "oalienerad") ;
  oalfabetiserad_av_1_A = compoundA (regA "oalfabetiserad") ;
  oalarmerad_av_1_A = compoundA (regA "oalarmerad") ;
  oaktualiserad_av_1_A = compoundA (regA "oaktualiserad") ;
  oaktiverad_av_1_A = compoundA (regA "oaktiverad") ;
  oaktad_av_1_A = compoundA (regA "oaktad") ;
  oajournerad_av_1_A = compoundA (regA "oajournerad") ;
  oagnad_av_1_A = compoundA (regA "oagnad") ;
  oagiterad_av_1_A = compoundA (regA "oagiterad") ;
  oagglutinerad_av_1_A = compoundA (regA "oagglutinerad") ;
  oagglomererad_av_1_A = compoundA (regA "oagglomererad") ;
  oagerad_av_1_A = compoundA (regA "oagerad") ;
  oagad_av_1_A = compoundA (regA "oagad") ;
  oafrikaniserad_av_1_A = compoundA (regA "oafrikaniserad") ;
  oaffischerad_av_1_A = compoundA (regA "oaffischerad") ;
  oaffinerad_av_1_A = compoundA (regA "oaffinerad") ;
  oafficierad_av_1_A = compoundA (regA "oafficierad") ;
  oadvocerad_av_1_A = compoundA (regA "oadvocerad") ;
  oaducerad_av_1_A = compoundA (regA "oaducerad") ;
  oadsorberad_av_1_A = compoundA (regA "oadsorberad") ;
  oadresserad_av_1_A = compoundA (regA "oadresserad") ;
  oadopterad_av_1_A = compoundA (regA "oadopterad") ;
  oadministrerad_av_1_A = compoundA (regA "oadministrerad") ;
  oadlad_av_1_A = compoundA (regA "oadlad") ;
  oadjungerad_av_1_A = compoundA (regA "oadjungerad") ;
  oadderad_av_1_A = compoundA (regA "oadderad") ;
  oadapterad_av_1_A = compoundA (regA "oadapterad") ;
  oackvirerad_av_1_A = compoundA (regA "oackvirerad") ;
  oackumulerad_av_1_A = compoundA (regA "oackumulerad") ;
  oackrediterad_av_1_A = compoundA (regA "oackrediterad") ;
  oackorderad_av_1_A = compoundA (regA "oackorderad") ;
  oackompanjerad_av_1_A = compoundA (regA "oackompanjerad") ;
  oackommoderad_av_1_A = compoundA (regA "oackommoderad") ;
  oacklimatiserad_av_1_A = compoundA (regA "oacklimatiserad") ;
  oaccepterad_av_1_A = compoundA (regA "oaccepterad") ;
  oaccentuerad_av_1_A = compoundA (regA "oaccentuerad") ;
  oaccelererad_av_1_A = compoundA (regA "oaccelererad") ;
  oaccederad_av_1_A = compoundA (regA "oaccederad") ;
  oabstraherad_av_1_A = compoundA (regA "oabstraherad") ;
  oabsorberad_av_1_A = compoundA (regA "oabsorberad") ;
  oabsolverad_av_1_A = compoundA (regA "oabsolverad") ;
  oabraderad_av_1_A = compoundA (regA "oabraderad") ;
  oaborterad_av_1_A = compoundA (regA "oaborterad") ;
  oabonnerad_av_1_A = compoundA (regA "oabonnerad") ;
  oabdikerad_av_1_A = compoundA (regA "oabdikerad") ;
  oabbrevierad_av_1_A = compoundA (regA "oabbrevierad") ;
  noedsakad_av_1_1_A = compoundA (regA "nödsakad") ;
  naerbeslaektad_av_1_1_A = compoundA (regA "närbesläktad") ;
  nyoeppnad_av_1_1_A = compoundA (regA "nyöppnad") ;
  nyvaessad_av_1_1_A = compoundA (regA "nyvässad") ;
  nyutexaminerad_av_1_A = compoundA (regA "nyutexaminerad") ;
  nytvaettad_av_1_1_A = compoundA (regA "nytvättad") ;
  nytumlad_av_1_A = compoundA (regA "nytumlad") ;
  nyttobetonad_av_1_A = compoundA (regA "nyttobetonad") ;
  nystaedad_av_1_1_A = compoundA (regA "nystädad") ;
  nystartad_av_1_A = compoundA (regA "nystartad") ;
  nyslipad_av_1_A = compoundA (regA "nyslipad") ;
  nyrenoverad_av_1_A = compoundA (regA "nyrenoverad") ;
  nypressad_av_1_A = compoundA (regA "nypressad") ;
  nypolerad_av_1_A = compoundA (regA "nypolerad") ;
  nymornad_av_1_A = compoundA (regA "nymornad") ;
  nymorgnad_av_1_A = compoundA (regA "nymorgnad") ;
  nymobiliserad_av_1_A = compoundA (regA "nymobiliserad") ;
  nyloevad_av_1_1_A = compoundA (regA "nylövad") ;
  nylagad_av_1_A = compoundA (regA "nylagad") ;
  nyinskaffad_av_1_A = compoundA (regA "nyinskaffad") ;
  nyinraettad_av_1_1_A = compoundA (regA "nyinrättad") ;
  nyinflyttad_av_1_A = compoundA (regA "nyinflyttad") ;
  nygraeddad_av_1_1_A = compoundA (regA "nygräddad") ;
  nygrundad_av_1_A = compoundA (regA "nygrundad") ;
  nyfoervaervad_av_1_1_A = compoundA (regA "nyförvärvad") ;
  nyfriserad_av_1_A = compoundA (regA "nyfriserad") ;
  nyexaminerad_av_1_A = compoundA (regA "nyexaminerad") ;
  nyduschad_av_1_A = compoundA (regA "nyduschad") ;
  nybildad_av_1_A = compoundA (regA "nybildad") ;
  nybakad_av_1_A = compoundA (regA "nybakad") ;
  nyanserad_av_1_A = compoundA (regA "nyanserad") ;
  nyagnad_av_1_A = compoundA (regA "nyagnad") ;
  nutidsorienterad_av_1_A = compoundA (regA "nutidsorienterad") ;
  nutidsfixerad_av_1_A = compoundA (regA "nutidsfixerad") ;
  norsktillverkad_av_1_A = compoundA (regA "norsktillverkad") ;
  normalbegaavad_av_1_1_A = compoundA (regA "normalbegåvad") ;
  nograeknad_av_1_1_A = compoundA (regA "nogräknad") ;
  nischad_av_1_A = compoundA (regA "nischad") ;
  nervevad_av_1_A = compoundA (regA "nervevad") ;
  nertrampad_av_1_A = compoundA (regA "nertrampad") ;
  nersoelad_av_1_1_A = compoundA (regA "nersölad") ;
  nerputtad_av_1_A = compoundA (regA "nerputtad") ;
  nerplitad_av_1_A = compoundA (regA "nerplitad") ;
  nerpetad_av_1_A = compoundA (regA "nerpetad") ;
  nerlaeggningshotad_av_1_1_A = compoundA (regA "nerläggningshotad") ;
  nerlusad_av_1_A = compoundA (regA "nerlusad") ;
  nerlegad_av_1_A = compoundA (regA "nerlegad") ;
  nerknarkad_av_1_A = compoundA (regA "nerknarkad") ;
  nerkippad_av_1_A = compoundA (regA "nerkippad") ;
  nerkilad_av_1_A = compoundA (regA "nerkilad") ;
  nerhukad_av_1_A = compoundA (regA "nerhukad") ;
  nergrisad_av_1_A = compoundA (regA "nergrisad") ;
  nerdekad_av_1_A = compoundA (regA "nerdekad") ;
  nerbusad_av_1_A = compoundA (regA "nerbusad") ;
  nerborrad_av_1_A = compoundA (regA "nerborrad") ;
  nerblodad_av_1_A = compoundA (regA "nerblodad") ;
  nerbantad_av_1_A = compoundA (regA "nerbantad") ;
  nedtvingad_av_1_A = compoundA (regA "nedtvingad") ;
  nedtrampad_av_1_A = compoundA (regA "nedtrampad") ;
  nedsoelad_av_1_1_A = compoundA (regA "nedsölad") ;
  nedsolkad_av_1_A = compoundA (regA "nedsolkad") ;
  nedlaeggningshotad_av_1_1_A = compoundA (regA "nedläggningshotad") ;
  nedlusad_av_1_A = compoundA (regA "nedlusad") ;
  nedlegad_av_1_A = compoundA (regA "nedlegad") ;
  nedknarkad_av_1_A = compoundA (regA "nedknarkad") ;
  nedkletad_av_1_A = compoundA (regA "nedkletad") ;
  nedkippad_av_1_A = compoundA (regA "nedkippad") ;
  nedhukad_av_1_A = compoundA (regA "nedhukad") ;
  nedgrisad_av_1_A = compoundA (regA "nedgrisad") ;
  neddekad_av_1_A = compoundA (regA "neddekad") ;
  nedbaeddad_av_1_1_A = compoundA (regA "nedbäddad") ;
  nedbusad_av_1_A = compoundA (regA "nedbusad") ;
  nedborrad_av_1_A = compoundA (regA "nedborrad") ;
  nedblodad_av_1_A = compoundA (regA "nedblodad") ;
  nedbantad_av_1_A = compoundA (regA "nedbantad") ;
  naturskyddad_av_1_A = compoundA (regA "naturskyddad") ;
  naturfaergad_av_1_1_A = compoundA (regA "naturfärgad") ;
  naturbehandlad_av_1_A = compoundA (regA "naturbehandlad") ;
  naturbegaavad_av_1_1_A = compoundA (regA "naturbegåvad") ;
  narkotikapaaverkad_av_1_1_A = compoundA (regA "narkotikapåverkad") ;
  narkotikaklassad_av_1_A = compoundA (regA "narkotikaklassad") ;
  namnskyddad_av_1_A = compoundA (regA "namnskyddad") ;
  nakenkindad_av_1_A = compoundA (regA "nakenkindad") ;
  naggsaagad_av_1_1_A = compoundA (regA "naggsågad") ;
  nabbad_av_1_A = compoundA (regA "nabbad") ;
  moerkrostad_av_1_1_A = compoundA (regA "mörkrostad") ;
  moerkhyad_av_1_1_A = compoundA (regA "mörkhyad") ;
  moensterstickad_av_1_1_A = compoundA (regA "mönsterstickad") ;
  maanghoevdad_av_1_1_A = compoundA (regA "månghövdad") ;
  maanggestaltad_av_1_1_A = compoundA (regA "månggestaltad") ;
  maangfaergad_av_1_1_A = compoundA (regA "mångfärgad") ;
  maangfasetterad_av_1_1_A = compoundA (regA "mångfasetterad") ;
  maangfacetterad_av_1_1_A = compoundA (regA "mångfacetterad") ;
  maangbeproevad_av_1_1_A = compoundA (regA "mångbeprövad") ;
  maangarmad_av_1_1_A = compoundA (regA "mångarmad") ;
  maalrelaterad_av_1_1_A = compoundA (regA "målrelaterad") ;
  maalinriktad_av_1_1_A = compoundA (regA "målinriktad") ;
  maettad_av_1_1_A = compoundA (regA "mättad") ;
  maenniskogestaltad_av_1_1_A = compoundA (regA "människogestaltad") ;
  maenniskocentrerad_av_1_1_A = compoundA (regA "människocentrerad") ;
  mutanklagad_av_1_A = compoundA (regA "mutanklagad") ;
  muromgaerdad_av_1_1_A = compoundA (regA "muromgärdad") ;
  murkelkindad_av_1_A = compoundA (regA "murkelkindad") ;
  multihandikappad_av_1_A = compoundA (regA "multihandikappad") ;
  motriktad_av_1_A = compoundA (regA "motriktad") ;
  motiverad_av_1_A = compoundA (regA "motiverad") ;
  mosaikinramad_av_1_A = compoundA (regA "mosaikinramad") ;
  mosaikartad_av_1_A = compoundA (regA "mosaikartad") ;
  mockasinformad_av_1_A = compoundA (regA "mockasinformad") ;
  mjukryggad_av_1_A = compoundA (regA "mjukryggad") ;
  mittenorienterad_av_1_A = compoundA (regA "mittenorienterad") ;
  missriktad_av_1_A = compoundA (regA "missriktad") ;
  misslyckad_av_1_A = compoundA (regA "misslyckad") ;
  missbildad_av_1_A = compoundA (regA "missbildad") ;
  missanpassad_av_1_A = compoundA (regA "missanpassad") ;
  mirakelraeddad_av_1_1_A = compoundA (regA "mirakelräddad") ;
  miljoeskadad_av_1_1_A = compoundA (regA "miljöskadad") ;
  miljoeanpassad_av_1_1_A = compoundA (regA "miljöanpassad") ;
  meteorartad_av_1_A = compoundA (regA "meteorartad") ;
  meriterad_av_1_A = compoundA (regA "meriterad") ;
  melerad_av_1_A = compoundA (regA "melerad") ;
  medaatalad_av_1_1_A = compoundA (regA "medåtalad") ;
  medborgarinitierad_av_1_A = compoundA (regA "medborgarinitierad") ;
  mattslipad_av_1_A = compoundA (regA "mattslipad") ;
  matfoergiftad_av_1_1_A = compoundA (regA "matförgiftad") ;
  mastad_av_1_A = compoundA (regA "mastad") ;
  markerad_av_1_A = compoundA (regA "markerad") ;
  marginaliserad_av_1_A = compoundA (regA "marginaliserad") ;
  mansdominerad_av_1_A = compoundA (regA "mansdominerad") ;
  maniererad_av_1_A = compoundA (regA "maniererad") ;
  mandelformad_av_1_A = compoundA (regA "mandelformad") ;
  malvafaergad_av_1_1_A = compoundA (regA "malvafärgad") ;
  malplacerad_av_1_A = compoundA (regA "malplacerad") ;
  majsoelsberusad_av_1_1_A = compoundA (regA "majsölsberusad") ;
  mahognyfanerad_av_1_A = compoundA (regA "mahognyfanerad") ;
  magentafaergad_av_1_1_A = compoundA (regA "magentafärgad") ;
  loesningsmedelsbaserad_av_1_1_A = compoundA (regA "lösningsmedelsbaserad") ;
  laangoerad_av_1_1_A = compoundA (regA "långörad") ;
  laangaermad_av_1_1_A = compoundA (regA "långärmad") ;
  laangtandad_av_1_1_A = compoundA (regA "långtandad") ;
  laangsvansad_av_1_1_A = compoundA (regA "långsvansad") ;
  laangskaftad_av_1_1_A = compoundA (regA "långskaftad") ;
  laanglivad_av_1_1_A = compoundA (regA "långlivad") ;
  laangfingrad_av_1_1_A = compoundA (regA "långfingrad") ;
  laagutbildad_av_1_1_A = compoundA (regA "lågutbildad") ;
  laagsinnad_av_1_1_A = compoundA (regA "lågsinnad") ;
  laagklackad_av_1_1_A = compoundA (regA "lågklackad") ;
  laagkastad_av_1_1_A = compoundA (regA "lågkastad") ;
  laagavloenad_av_1_1_A = compoundA (regA "lågavlönad") ;
  laaganrikad_av_1_1_A = compoundA (regA "låganrikad") ;
  laettuttalad_av_1_1_A = compoundA (regA "lättuttalad") ;
  laettsmickrad_av_1_1_A = compoundA (regA "lättsmickrad") ;
  laettsaltad_av_1_1_A = compoundA (regA "lättsaltad") ;
  laettrullad_av_1_1_A = compoundA (regA "lättrullad") ;
  laettroad_av_1_1_A = compoundA (regA "lättroad") ;
  laettrimmad_av_1_1_A = compoundA (regA "lättrimmad") ;
  laettretad_av_1_1_A = compoundA (regA "lättretad") ;
  laettpratad_av_1_1_A = compoundA (regA "lättpratad") ;
  laettodlad_av_1_1_A = compoundA (regA "lättodlad") ;
  laettnarrad_av_1_1_A = compoundA (regA "lättnarrad") ;
  laettmanoevrerad_av_1_1_A = compoundA (regA "lättmanövrerad") ;
  laettlurad_av_1_1_A = compoundA (regA "lättlurad") ;
  laettfoersvarad_av_1_1_A = compoundA (regA "lättförsvarad") ;
  laettfaangad_av_1_1_A = compoundA (regA "lättfångad") ;
  laettfotad_av_1_1_A = compoundA (regA "lättfotad") ;
  laettfixad_av_1_1_A = compoundA (regA "lättfixad") ;
  laettbrukad_av_1_1_A = compoundA (regA "lättbrukad") ;
  laettbevaepnad_av_1_1_A = compoundA (regA "lättbeväpnad") ;
  laettarbetad_av_1_1_A = compoundA (regA "lättarbetad") ;
  laettad_av_1_1_A = compoundA (regA "lättad") ;
  laesbegaavad_av_1_1_A = compoundA (regA "läsbegåvad") ;
  laempad_av_1_1_A = compoundA (regA "lämpad") ;
  laederartad_av_1_1_A = compoundA (regA "läderartad") ;
  lyxprostituerad_av_1_A = compoundA (regA "lyxprostituerad") ;
  lyrformad_av_1_A = compoundA (regA "lyrformad") ;
  lyckad_av_1_A = compoundA (regA "lyckad") ;
  luttrad_av_1_A = compoundA (regA "luttrad") ;
  lustbetonad_av_1_A = compoundA (regA "lustbetonad") ;
  luftkonditionerad_av_1_A = compoundA (regA "luftkonditionerad") ;
  lottad_av_1_A = compoundA (regA "lottad") ;
  ljushyad_av_1_A = compoundA (regA "ljushyad") ;
  ljusflaeckad_av_1_1_A = compoundA (regA "ljusfläckad") ;
  livad_av_1_A = compoundA (regA "livad") ;
  linoljebaserad_av_1_A = compoundA (regA "linoljebaserad") ;
  linfaergad_av_1_1_A = compoundA (regA "linfärgad") ;
  limiterad_av_1_A = compoundA (regA "limiterad") ;
  likriktad_av_1_A = compoundA (regA "likriktad") ;
  likasinnad_av_1_A = compoundA (regA "likasinnad") ;
  likartad_av_1_A = compoundA (regA "likartad") ;
  likaberaettigad_av_1_1_A = compoundA (regA "likaberättigad") ;
  leopardmoenstrad_av_1_1_A = compoundA (regA "leopardmönstrad") ;
  legendomsusad_av_1_A = compoundA (regA "legendomsusad") ;
  ledad_av_1_A = compoundA (regA "ledad") ;
  laxfaergad_av_1_1_A = compoundA (regA "laxfärgad") ;
  lavinartad_av_1_A = compoundA (regA "lavinartad") ;
  lavendelfaergad_av_1_1_A = compoundA (regA "lavendelfärgad") ;
  lasad_av_1_A = compoundA (regA "lasad") ;
  lagstadgad_av_1_A = compoundA (regA "lagstadgad") ;
  laddad_av_1_A = compoundA (regA "laddad") ;
  labialiserad_av_1_A = compoundA (regA "labialiserad") ;
  koettfaergad_av_1_1_A = compoundA (regA "köttfärgad") ;
  koersbaersfaergad_av_1_1_A = compoundA (regA "körsbärsfärgad") ;
  koersbaersfanerad_av_1_1_A = compoundA (regA "körsbärsfanerad") ;
  koeldskadad_av_1_1_A = compoundA (regA "köldskadad") ;
  koelad_av_1_1_A = compoundA (regA "kölad") ;
  kaernvapenbestyckad_av_1_1_A = compoundA (regA "kärnvapenbestyckad") ;
  kaensloladdad_av_1_1_A = compoundA (regA "känsloladdad") ;
  kvinnodominerad_av_1_A = compoundA (regA "kvinnodominerad") ;
  kvickfotad_av_1_A = compoundA (regA "kvickfotad") ;
  kvarvarad_av_1_A = compoundA (regA "kvarvarad") ;
  kvalificerad_av_1_A = compoundA (regA "kvalificerad") ;
  kuppartad_av_1_A = compoundA (regA "kuppartad") ;
  kuperad_av_1_A = compoundA (regA "kuperad") ;
  kunskapsbaserad_av_1_A = compoundA (regA "kunskapsbaserad") ;
  kundcentrerad_av_1_A = compoundA (regA "kundcentrerad") ;
  kulturintresserad_av_1_A = compoundA (regA "kulturintresserad") ;
  kultiverad_av_1_A = compoundA (regA "kultiverad") ;
  kultfoerklarad_av_1_1_A = compoundA (regA "kultförklarad") ;
  kullagrad_av_1_A = compoundA (regA "kullagrad") ;
  kraesmagad_av_1_1_A = compoundA (regA "kräsmagad") ;
  kraemfaergad_av_1_1_A = compoundA (regA "krämfärgad") ;
  krystad_av_1_A = compoundA (regA "krystad") ;
  krympbehandlad_av_1_A = compoundA (regA "krympbehandlad") ;
  krutsvaertad_av_1_1_A = compoundA (regA "krutsvärtad") ;
  kroppsfixerad_av_1_A = compoundA (regA "kroppsfixerad") ;
  krokanutsirad_av_1_A = compoundA (regA "krokanutsirad") ;
  krockskadad_av_1_A = compoundA (regA "krockskadad") ;
  krisdrabbad_av_1_A = compoundA (regA "krisdrabbad") ;
  krisartad_av_1_A = compoundA (regA "krisartad") ;
  krigsinkallad_av_1_A = compoundA (regA "krigsinkallad") ;
  krigshaerjad_av_1_1_A = compoundA (regA "krigshärjad") ;
  krenelerad_av_1_A = compoundA (regA "krenelerad") ;
  kortaermad_av_1_1_A = compoundA (regA "kortärmad") ;
  kortsnaggad_av_1_A = compoundA (regA "kortsnaggad") ;
  kortlivad_av_1_A = compoundA (regA "kortlivad") ;
  kortfattad_av_1_A = compoundA (regA "kortfattad") ;
  korruptionsanklagad_av_1_A = compoundA (regA "korruptionsanklagad") ;
  korkad_av_1_A = compoundA (regA "korkad") ;
  koppleriaatalad_av_1_1_A = compoundA (regA "koppleriåtalad") ;
  kopplerianklagad_av_1_A = compoundA (regA "kopplerianklagad") ;
  kopparfaergad_av_1_1_A = compoundA (regA "kopparfärgad") ;
  kontrollgenomsyrad_av_1_A = compoundA (regA "kontrollgenomsyrad") ;
  konstruerad_av_1_A = compoundA (regA "konstruerad") ;
  konstlad_av_1_A = compoundA (regA "konstlad") ;
  konformad_av_1_A = compoundA (regA "konformad") ;
  konfliktdrabbad_av_1_A = compoundA (regA "konfliktdrabbad") ;
  konfedererad_av_1_A = compoundA (regA "konfedererad") ;
  konditionerad_av_1_A = compoundA (regA "konditionerad") ;
  komplicerad_av_1_A = compoundA (regA "komplicerad") ;
  kommitterad_av_1_A = compoundA (regA "kommitterad") ;
  kolsyrad_av_1_A = compoundA (regA "kolsyrad") ;
  kolonnomgaerdad_av_1_1_A = compoundA (regA "kolonnomgärdad") ;
  knaeskadad_av_1_1_A = compoundA (regA "knäskadad") ;
  knivbevaepnad_av_1_1_A = compoundA (regA "knivbeväpnad") ;
  kloevad_av_1_1_A = compoundA (regA "klövad") ;
  klockformad_av_1_A = compoundA (regA "klockformad") ;
  klockad_av_1_A = compoundA (regA "klockad") ;
  klimatreglerad_av_1_A = compoundA (regA "klimatreglerad") ;
  khakifaergad_av_1_1_A = compoundA (regA "khakifärgad") ;
  kedjeformad_av_1_A = compoundA (regA "kedjeformad") ;
  katastrofdrabbad_av_1_A = compoundA (regA "katastrofdrabbad") ;
  karaterad_av_1_A = compoundA (regA "karaterad") ;
  karamellfaergad_av_1_1_A = compoundA (regA "karamellfärgad") ;
  kaosartad_av_1_A = compoundA (regA "kaosartad") ;
  kampintresserad_av_1_A = compoundA (regA "kampintresserad") ;
  kamouflagefaergad_av_1_1_A = compoundA (regA "kamouflagefärgad") ;
  kamelhaarsfaergad_av_1_1_A = compoundA (regA "kamelhårsfärgad") ;
  kalspolad_av_1_A = compoundA (regA "kalspolad") ;
  kallhamrad_av_1_A = compoundA (regA "kallhamrad") ;
  kalkad_av_1_A = compoundA (regA "kalkad") ;
  kakifaergad_av_1_1_A = compoundA (regA "kakifärgad") ;
  kafkaartad_av_1_A = compoundA (regA "kafkaartad") ;
  jaemstaelldhetsintegrerad_av_1_1_A = compoundA (regA "jämställdhetsintegrerad") ;
  jaemnslipad_av_1_1_A = compoundA (regA "jämnslipad") ;
  jaektad_av_1_1_A = compoundA (regA "jäktad") ;
  jordfaergad_av_1_1_A = compoundA (regA "jordfärgad") ;
  jordbaevningsdrabbad_av_1_1_A = compoundA (regA "jordbävningsdrabbad") ;
  jobbrelaterad_av_1_A = compoundA (regA "jobbrelaterad") ;
  jetlaggad_av_1_A = compoundA (regA "jetlaggad") ;
  jazzintresserad_av_1_A = compoundA (regA "jazzintresserad") ;
  ivaegslaepad_av_1_1_A = compoundA (regA "ivägsläpad") ;
  itudelad_av_1_A = compoundA (regA "itudelad") ;
  isolerad_av_1_A = compoundA (regA "isolerad") ;
  isdrabbad_av_1_A = compoundA (regA "isdrabbad") ;
  isblandad_av_1_A = compoundA (regA "isblandad") ;
  invecklad_av_1_A = compoundA (regA "invecklad") ;
  intraenad_av_1_1_A = compoundA (regA "intränad") ;
  intresserad_av_1_A = compoundA (regA "intresserad") ;
  internetrelaterad_av_1_A = compoundA (regA "internetrelaterad") ;
  insyltad_av_1_A = compoundA (regA "insyltad") ;
  institutionsskadad_av_1_A = compoundA (regA "institutionsskadad") ;
  inspirerad_av_1_A = compoundA (regA "inspirerad") ;
  insnoead_av_1_1_A = compoundA (regA "insnöad") ;
  insmugglad_av_1_A = compoundA (regA "insmugglad") ;
  inslaepad_av_1_1_A = compoundA (regA "insläpad") ;
  inslussad_av_1_A = compoundA (regA "inslussad") ;
  inraekna_av_1_1_A = compoundA (regA "inräkna") ;
  inrutad_av_1_A = compoundA (regA "inrutad") ;
  inrotad_av_1_A = compoundA (regA "inrotad") ;
  inriggad_av_1_A = compoundA (regA "inriggad") ;
  inredningsintresserad_av_1_A = compoundA (regA "inredningsintresserad") ;
  inplastad_av_1_A = compoundA (regA "inplastad") ;
  inpiskad_av_1_A = compoundA (regA "inpiskad") ;
  inpetad_av_1_A = compoundA (regA "inpetad") ;
  innehaallsrelaterad_av_1_1_A = compoundA (regA "innehållsrelaterad") ;
  inmaalad_av_1_1_A = compoundA (regA "inmålad") ;
  inkilad_av_1_A = compoundA (regA "inkilad") ;
  inkalla_av_1_A = compoundA (regA "inkalla") ;
  initierad_av_1_A = compoundA (regA "initierad") ;
  inglasad_av_1_A = compoundA (regA "inglasad") ;
  inflammerad_av_1_A = compoundA (regA "inflammerad") ;
  individrelaterad_av_1_A = compoundA (regA "individrelaterad") ;
  individcentrerad_av_1_A = compoundA (regA "individcentrerad") ;
  indisponerad_av_1_A = compoundA (regA "indisponerad") ;
  indignerad_av_1_A = compoundA (regA "indignerad") ;
  inbaeddad_av_1_1_A = compoundA (regA "inbäddad") ;
  inblandad_av_1_A = compoundA (regA "inblandad") ;
  inbakad_av_1_A = compoundA (regA "inbakad") ;
  inaskad_av_1_A = compoundA (regA "inaskad") ;
  illasinnad_av_1_A = compoundA (regA "illasinnad") ;
  ihopklistrad_av_1_A = compoundA (regA "ihopklistrad") ;
  igensnoead_av_1_1_A = compoundA (regA "igensnöad") ;
  igenmurad_av_1_A = compoundA (regA "igenmurad") ;
  igenkorkad_av_1_A = compoundA (regA "igenkorkad") ;
  igenbommad_av_1_A = compoundA (regA "igenbommad") ;
  hoerselskadad_av_1_1_A = compoundA (regA "hörselskadad") ;
  hoegaettad_av_1_1_A = compoundA (regA "högättad") ;
  hoegutbildad_av_1_1_A = compoundA (regA "högutbildad") ;
  hoegspecialiserad_av_1_1_A = compoundA (regA "högspecialiserad") ;
  hoegskaftad_av_1_1_A = compoundA (regA "högskaftad") ;
  hoegsinnad_av_1_1_A = compoundA (regA "högsinnad") ;
  hoegroestad_av_1_1_A = compoundA (regA "högröstad") ;
  hoegklackad_av_1_1_A = compoundA (regA "högklackad") ;
  hoeghalsad_av_1_1_A = compoundA (regA "höghalsad") ;
  hoegergaengad_av_1_1_A = compoundA (regA "högergängad") ;
  hoeger_av_1_1_A = compoundA (regA "höger") ;
  hoegavloenad_av_1_1_A = compoundA (regA "högavlönad") ;
  haardtvinnad_av_1_1_A = compoundA (regA "hårdtvinnad") ;
  haardnackad_av_1_1_A = compoundA (regA "hårdnackad") ;
  haardhudad_av_1_1_A = compoundA (regA "hårdhudad") ;
  haardhjaertad_av_1_1_A = compoundA (regA "hårdhjärtad") ;
  haardfloertad_av_1_1_A = compoundA (regA "hårdflörtad") ;
  haardflirtad_av_1_1_A = compoundA (regA "hårdflirtad") ;
  haardfjaellad_av_1_1_A = compoundA (regA "hårdfjällad") ;
  haardbevakad_av_1_1_A = compoundA (regA "hårdbevakad") ;
  haalkindad_av_1_1_A = compoundA (regA "hålkindad") ;
  haagad_av_1_1_A = compoundA (regA "hågad") ;
  haertappad_av_1_1_A = compoundA (regA "härtappad") ;
  haerjad_av_1_1_A = compoundA (regA "härjad") ;
  haemmad_av_1_1_A = compoundA (regA "hämmad") ;
  haeftad_av_1_1_A = compoundA (regA "häftad") ;
  hyveltandad_av_1_A = compoundA (regA "hyveltandad") ;
  hylsformad_av_1_A = compoundA (regA "hylsformad") ;
  hyllformad_av_1_A = compoundA (regA "hyllformad") ;
  hyfsad_av_1_A = compoundA (regA "hyfsad") ;
  hydratiserad_av_1_A = compoundA (regA "hydratiserad") ;
  hundhoevdad_av_1_1_A = compoundA (regA "hundhövdad") ;
  hugad_av_1_A = compoundA (regA "hugad") ;
  hudfaergad_av_1_1_A = compoundA (regA "hudfärgad") ;
  hornbaagad_av_1_1_A = compoundA (regA "hornbågad") ;
  horisontalaxlad_av_1_A = compoundA (regA "horisontalaxlad") ;
  hoptvinnad_av_1_A = compoundA (regA "hoptvinnad") ;
  hoptrasslad_av_1_A = compoundA (regA "hoptrasslad") ;
  hopsvetsad_av_1_A = compoundA (regA "hopsvetsad") ;
  hopskrynklad_av_1_A = compoundA (regA "hopskrynklad") ;
  hoprullad_av_1_A = compoundA (regA "hoprullad") ;
  hoprasad_av_1_A = compoundA (regA "hoprasad") ;
  hopkurad_av_1_A = compoundA (regA "hopkurad") ;
  hopknoelad_av_1_1_A = compoundA (regA "hopknölad") ;
  hopknaapad_av_1_1_A = compoundA (regA "hopknåpad") ;
  hopgyttrad_av_1_A = compoundA (regA "hopgyttrad") ;
  honungsfaergad_av_1_1_A = compoundA (regA "honungsfärgad") ;
  honungsbakad_av_1_A = compoundA (regA "honungsbakad") ;
  hjaertformad_av_1_1_A = compoundA (regA "hjärtformad") ;
  hjaernskadad_av_1_1_A = compoundA (regA "hjärnskadad") ;
  hjaernintresserad_av_1_1_A = compoundA (regA "hjärnintresserad") ;
  hippieartad_av_1_A = compoundA (regA "hippieartad") ;
  hetlevrad_av_1_A = compoundA (regA "hetlevrad") ;
  hemstickad_av_1_A = compoundA (regA "hemstickad") ;
  hemsnickrad_av_1_A = compoundA (regA "hemsnickrad") ;
  hemskickad_av_1_A = compoundA (regA "hemskickad") ;
  hemlagad_av_1_A = compoundA (regA "hemlagad") ;
  hemkaernad_av_1_1_A = compoundA (regA "hemkärnad") ;
  hemkryddad_av_1_A = compoundA (regA "hemkryddad") ;
  hemfraktad_av_1_A = compoundA (regA "hemfraktad") ;
  hembakad_av_1_A = compoundA (regA "hembakad") ;
  helsvetsad_av_1_A = compoundA (regA "helsvetsad") ;
  helskinnad_av_1_A = compoundA (regA "helskinnad") ;
  helkaklad_av_1_A = compoundA (regA "helkaklad") ;
  helhjaertad_av_1_1_A = compoundA (regA "helhjärtad") ;
  helfoerlamad_av_1_1_A = compoundA (regA "helförlamad") ;
  heldaeckad_av_1_1_A = compoundA (regA "heldäckad") ;
  hedersrelaterad_av_1_A = compoundA (regA "hedersrelaterad") ;
  harhjaertad_av_1_1_A = compoundA (regA "harhjärtad") ;
  hankoenad_av_1_1_A = compoundA (regA "hankönad") ;
  handlingsfoerlamad_av_1_1_A = compoundA (regA "handlingsförlamad") ;
  handknackad_av_1_A = compoundA (regA "handknackad") ;
  handikappad_av_1_A = compoundA (regA "handikappad") ;
  halvskyddad_av_1_A = compoundA (regA "halvskyddad") ;
  halvmaanformad_av_1_1_A = compoundA (regA "halvmånformad") ;
  halvhyvlad_av_1_A = compoundA (regA "halvhyvlad") ;
  halvhjaertad_av_1_1_A = compoundA (regA "halvhjärtad") ;
  halverigerad_av_1_A = compoundA (regA "halverigerad") ;
  halvdaeckad_av_1_1_A = compoundA (regA "halvdäckad") ;
  halvcirkelformad_av_1_A = compoundA (regA "halvcirkelformad") ;
  halvbildad_av_1_A = compoundA (regA "halvbildad") ;
  halvberusad_av_1_A = compoundA (regA "halvberusad") ;
  halmstoppad_av_1_A = compoundA (regA "halmstoppad") ;
  goeteborgsbaserad_av_1_1_A = compoundA (regA "göteborgsbaserad") ;
  gaengad_av_1_1_A = compoundA (regA "gängad") ;
  gymnastiserad_av_1_A = compoundA (regA "gymnastiserad") ;
  gummiraefflad_av_1_1_A = compoundA (regA "gummiräfflad") ;
  gulmaalad_av_1_1_A = compoundA (regA "gulmålad") ;
  gulfaergad_av_1_1_A = compoundA (regA "gulfärgad") ;
  guldstickad_av_1_A = compoundA (regA "guldstickad") ;
  guldkantad_av_1_A = compoundA (regA "guldkantad") ;
  guldbaagad_av_1_1_A = compoundA (regA "guldbågad") ;
  gudabenaadad_av_1_1_A = compoundA (regA "gudabenådad") ;
  groenmaalad_av_1_1_A = compoundA (regA "grönmålad") ;
  graamaalad_av_1_1_A = compoundA (regA "gråmålad") ;
  graesad_av_1_1_A = compoundA (regA "gräsad") ;
  graeddfaergad_av_1_1_A = compoundA (regA "gräddfärgad") ;
  grundmurad_av_1_A = compoundA (regA "grundmurad") ;
  grundlagsskyddad_av_1_A = compoundA (regA "grundlagsskyddad") ;
  grundad_av_1_A = compoundA (regA "grundad") ;
  grovyxad_av_1_A = compoundA (regA "grovyxad") ;
  grovhyad_av_1_A = compoundA (regA "grovhyad") ;
  grenad_av_1_A = compoundA (regA "grenad") ;
  godhjaertad_av_1_1_A = compoundA (regA "godhjärtad") ;
  godartad_av_1_A = compoundA (regA "godartad") ;
  glaettad_av_1_1_A = compoundA (regA "glättad") ;
  glasartad_av_1_A = compoundA (regA "glasartad") ;
  genomrostad_av_1_A = compoundA (regA "genomrostad") ;
  genomorganiserad_av_1_A = compoundA (regA "genomorganiserad") ;
  genomkomponerad_av_1_A = compoundA (regA "genomkomponerad") ;
  genmodifierad_av_1_A = compoundA (regA "genmodifierad") ;
  genfoeraendrad_av_1_1_A = compoundA (regA "genförändrad") ;
  generad_av_1_A = compoundA (regA "generad") ;
  gel_eartad_av_1_1_A = compoundA (regA "geléartad") ;
  gatuprostituerad_av_1_A = compoundA (regA "gatuprostituerad") ;
  garvad_av_1_A = compoundA (regA "garvad") ;
  galonerad_av_1_A = compoundA (regA "galonerad") ;
  foeraaldrad_av_1_1_A = compoundA (regA "föråldrad") ;
  foeraelskad_av_1_1_A = compoundA (regA "förälskad") ;
  foervaanad_av_1_1_A = compoundA (regA "förvånad") ;
  foervirrad_av_1_1_A = compoundA (regA "förvirrad") ;
  foerutfattad_av_1_1_A = compoundA (regA "förutfattad") ;
  foertoernad_av_1_1_A = compoundA (regA "förtörnad") ;
  foertvivlad_av_1_1_A = compoundA (regA "förtvivlad") ;
  foertjocknad_av_1_1_A = compoundA (regA "förtjocknad") ;
  foertappad_av_1_1_A = compoundA (regA "förtappad") ;
  foerstaandshandikappad_av_1_1_A = compoundA (regA "förståndshandikappad") ;
  foerstockad_av_1_1_A = compoundA (regA "förstockad") ;
  foersenad_av_1_1_A = compoundA (regA "försenad") ;
  foerpliktigad_av_1_1_A = compoundA (regA "förpliktigad") ;
  foerpliktad_av_1_1_A = compoundA (regA "förpliktad") ;
  foeroraettad_av_1_1_A = compoundA (regA "förorättad") ;
  foerolyckad_av_1_1_A = compoundA (regA "förolyckad") ;
  foernaermad_av_1_1_A = compoundA (regA "förnärmad") ;
  foerlovad_av_1_1_A = compoundA (regA "förlovad") ;
  foerlorad_av_1_1_A = compoundA (regA "förlorad") ;
  foerlegad_av_1_1_A = compoundA (regA "förlegad") ;
  foerkaettrad_av_1_1_A = compoundA (regA "förkättrad") ;
  foerkrossad_av_1_1_A = compoundA (regA "förkrossad") ;
  foerkonstlad_av_1_1_A = compoundA (regA "förkonstlad") ;
  foerklarad_av_1_1_A = compoundA (regA "förklarad") ;
  foerhastad_av_1_1_A = compoundA (regA "förhastad") ;
  foergrymmad_av_1_1_A = compoundA (regA "förgrymmad") ;
  foergrenad_av_1_1_A = compoundA (regA "förgrenad") ;
  foerfinad_av_1_1_A = compoundA (regA "förfinad") ;
  foerbommad_av_1_1_A = compoundA (regA "förbommad") ;
  foerbluffad_av_1_1_A = compoundA (regA "förbluffad") ;
  foerblommerad_av_1_1_A = compoundA (regA "förblommerad") ;
  foerbittrad_av_1_1_A = compoundA (regA "förbittrad") ;
  foerbenad_av_1_1_A = compoundA (regA "förbenad") ;
  foerbaskad_av_1_1_A = compoundA (regA "förbaskad") ;
  foerbannad_av_1_1_A = compoundA (regA "förbannad") ;
  foerargad_av_1_1_A = compoundA (regA "förargad") ;
  foerandligad_av_1_1_A = compoundA (regA "förandligad") ;
  faestad_av_1_1_A = compoundA (regA "fästad") ;
  faerskpressad_av_1_1_A = compoundA (regA "färskpressad") ;
  faergdelad_av_1_1_A = compoundA (regA "färgdelad") ;
  faergad_av_1_1_A = compoundA (regA "färgad") ;
  faerdigutvecklad_av_1_1_A = compoundA (regA "färdigutvecklad") ;
  faerdigutbildad_av_1_1_A = compoundA (regA "färdigutbildad") ;
  faerdigskulpterad_av_1_1_A = compoundA (regA "färdigskulpterad") ;
  faerdiglagad_av_1_1_A = compoundA (regA "färdiglagad") ;
  faerdigkaempad_av_1_1_A = compoundA (regA "färdigkämpad") ;
  faerdigbildad_av_1_1_A = compoundA (regA "färdigbildad") ;
  fyrvaexlad_av_1_1_A = compoundA (regA "fyrväxlad") ;
  fyrskaftad_av_1_A = compoundA (regA "fyrskaftad") ;
  fyrfaergad_av_1_1_A = compoundA (regA "fyrfärgad") ;
  fyrfotad_av_1_A = compoundA (regA "fyrfotad") ;
  funtad_av_1_A = compoundA (regA "funtad") ;
  funktionshindrad_av_1_A = compoundA (regA "funktionshindrad") ;
  fullaendad_av_1_1_A = compoundA (regA "fulländad") ;
  fullvaepnad_av_1_1_A = compoundA (regA "fullväpnad") ;
  fulltraenad_av_1_1_A = compoundA (regA "fulltränad") ;
  fulltecknad_av_1_A = compoundA (regA "fulltecknad") ;
  fullstaplad_av_1_A = compoundA (regA "fullstaplad") ;
  fullspaeckad_av_1_1_A = compoundA (regA "fullspäckad") ;
  fullspikad_av_1_A = compoundA (regA "fullspikad") ;
  fullriggad_av_1_A = compoundA (regA "fullriggad") ;
  fullproppad_av_1_A = compoundA (regA "fullproppad") ;
  fullmatad_av_1_A = compoundA (regA "fullmatad") ;
  fullklottrad_av_1_A = compoundA (regA "fullklottrad") ;
  fullklistrad_av_1_A = compoundA (regA "fullklistrad") ;
  fullfjaedrad_av_1_1_A = compoundA (regA "fullfjädrad") ;
  fullbokad_av_1_A = compoundA (regA "fullbokad") ;
  fullastad_av_1_A = compoundA (regA "fullastad") ;
  fugerad_av_1_A = compoundA (regA "fugerad") ;
  frustrerad_av_1_A = compoundA (regA "frustrerad") ;
  frontmatad_av_1_A = compoundA (regA "frontmatad") ;
  frisinnad_av_1_A = compoundA (regA "frisinnad") ;
  frestad_av_1_A = compoundA (regA "frestad") ;
  frejdad_av_1_A = compoundA (regA "frejdad") ;
  fransad_av_1_A = compoundA (regA "fransad") ;
  framaatriktad_av_1_1_A = compoundA (regA "framåtriktad") ;
  framaatlutad_av_1_1_A = compoundA (regA "framåtlutad") ;
  framtidsorienterad_av_1_A = compoundA (regA "framtidsorienterad") ;
  framtidsinriktad_av_1_A = compoundA (regA "framtidsinriktad") ;
  framorkestrerad_av_1_A = compoundA (regA "framorkestrerad") ;
  framimproviserad_av_1_A = compoundA (regA "framimproviserad") ;
  fotbollsdominerad_av_1_A = compoundA (regA "fotbollsdominerad") ;
  fosterlandssinnad_av_1_A = compoundA (regA "fosterlandssinnad") ;
  formfullaendad_av_1_1_A = compoundA (regA "formfulländad") ;
  forcerad_av_1_A = compoundA (regA "forcerad") ;
  folkmordsaatalad_av_1_1_A = compoundA (regA "folkmordsåtalad") ;
  flytungad_av_1_A = compoundA (regA "flytungad") ;
  flyfotad_av_1_A = compoundA (regA "flyfotad") ;
  flossad_av_1_A = compoundA (regA "flossad") ;
  fleromaettad_av_1_1_A = compoundA (regA "fleromättad") ;
  flerhandikappad_av_1_A = compoundA (regA "flerhandikappad") ;
  flerfaergad_av_1_1_A = compoundA (regA "flerfärgad") ;
  flatbottnad_av_1_A = compoundA (regA "flatbottnad") ;
  fjaederformad_av_1_1_A = compoundA (regA "fjäderformad") ;
  fixerad_av_1_A = compoundA (regA "fixerad") ;
  finspaentad_av_1_1_A = compoundA (regA "finspäntad") ;
  finlemmad_av_1_A = compoundA (regA "finlemmad") ;
  finhackad_av_1_A = compoundA (regA "finhackad") ;
  fingraderad_av_1_A = compoundA (regA "fingraderad") ;
  fingrad_av_1_A = compoundA (regA "fingrad") ;
  fingerad_av_1_A = compoundA (regA "fingerad") ;
  filmintresserad_av_1_A = compoundA (regA "filmintresserad") ;
  fiaskoartad_av_1_A = compoundA (regA "fiaskoartad") ;
  feminiserad_av_1_A = compoundA (regA "feminiserad") ;
  femarmad_av_1_A = compoundA (regA "femarmad") ;
  felunderraettad_av_1_1_A = compoundA (regA "felunderrättad") ;
  felstavad_av_1_A = compoundA (regA "felstavad") ;
  felplacerad_av_1_A = compoundA (regA "felplacerad") ;
  felkonstruerad_av_1_A = compoundA (regA "felkonstruerad") ;
  federerad_av_1_A = compoundA (regA "federerad") ;
  favorittippad_av_1_A = compoundA (regA "favorittippad") ;
  fattad_av_1_A = compoundA (regA "fattad") ;
  fasttejpad_av_1_A = compoundA (regA "fasttejpad") ;
  fastnaglad_av_1_A = compoundA (regA "fastnaglad") ;
  fasetterad_av_1_A = compoundA (regA "fasetterad") ;
  fascinerad_av_1_A = compoundA (regA "fascinerad") ;
  fartygsanpassad_av_1_A = compoundA (regA "fartygsanpassad") ;
  farsartad_av_1_A = compoundA (regA "farsartad") ;
  facetterad_av_1_A = compoundA (regA "facetterad") ;
  extrainkallad_av_1_A = compoundA (regA "extrainkallad") ;
  explosionsartad_av_1_A = compoundA (regA "explosionsartad") ;
  exhalterad_av_1_A = compoundA (regA "exhalterad") ;
  exalterad_av_1_A = compoundA (regA "exalterad") ;
  etablerad_av_1_A = compoundA (regA "etablerad") ;
  erfarenhetsgrundad_av_1_A = compoundA (regA "erfarenhetsgrundad") ;
  erfarenhetsbaserad_av_1_A = compoundA (regA "erfarenhetsbaserad") ;
  enstegstaetad_av_1_1_A = compoundA (regA "enstegstätad") ;
  ensartad_av_1_A = compoundA (regA "ensartad") ;
  enkelstraengad_av_1_1_A = compoundA (regA "enkelsträngad") ;
  enkelriktad_av_1_A = compoundA (regA "enkelriktad") ;
  enkelrenad_av_1_A = compoundA (regA "enkelrenad") ;
  engagerad_av_1_A = compoundA (regA "engagerad") ;
  enfaergad_av_1_1_A = compoundA (regA "enfärgad") ;
  enfotad_av_1_A = compoundA (regA "enfotad") ;
  enaxlad_av_1_A = compoundA (regA "enaxlad") ;
  enarmad_av_1_A = compoundA (regA "enarmad") ;
  empatibefriad_av_1_A = compoundA (regA "empatibefriad") ;
  elmanoevrerad_av_1_1_A = compoundA (regA "elmanövrerad") ;
  elfoerzinkad_av_1_1_A = compoundA (regA "elförzinkad") ;
  elfenbensfaergad_av_1_1_A = compoundA (regA "elfenbensfärgad") ;
  elektricitetsorsakad_av_1_A = compoundA (regA "elektricitetsorsakad") ;
  elakartad_av_1_A = compoundA (regA "elakartad") ;
  ekoodlad_av_1_A = compoundA (regA "ekoodlad") ;
  egotrippad_av_1_A = compoundA (regA "egotrippad") ;
  egentillverkad_av_1_A = compoundA (regA "egentillverkad") ;
  egenodlad_av_1_A = compoundA (regA "egenodlad") ;
  egenkonstruerad_av_1_A = compoundA (regA "egenkonstruerad") ;
  egenartad_av_1_A = compoundA (regA "egenartad") ;
  efterspanad_av_1_A = compoundA (regA "efterspanad") ;
  eftersaknad_av_1_A = compoundA (regA "eftersaknad") ;
  efterlaengtad_av_1_1_A = compoundA (regA "efterlängtad") ;
  efterfraagad_av_1_1_A = compoundA (regA "efterfrågad") ;
  effeminerad_av_1_A = compoundA (regA "effeminerad") ;
  echaufferad_av_1_A = compoundA (regA "echaufferad") ;
  doefoerbannad_av_1_1_A = compoundA (regA "döförbannad") ;
  doedsfoerbannad_av_1_1_A = compoundA (regA "dödsförbannad") ;
  doedbakad_av_1_1_A = compoundA (regA "dödbakad") ;
  daempad_av_1_1_A = compoundA (regA "dämpad") ;
  daeckad_av_1_1_A = compoundA (regA "däckad") ;
  dubbelstraengad_av_1_1_A = compoundA (regA "dubbelsträngad") ;
  dubbelbottnad_av_1_A = compoundA (regA "dubbelbottnad") ;
  drogpaaverkad_av_1_1_A = compoundA (regA "drogpåverkad") ;
  djurhoevdad_av_1_1_A = compoundA (regA "djurhövdad") ;
  djuprotad_av_1_A = compoundA (regA "djuprotad") ;
  djupborrad_av_1_A = compoundA (regA "djupborrad") ;
  distraherad_av_1_A = compoundA (regA "distraherad") ;
  distingerad_av_1_A = compoundA (regA "distingerad") ;
  disponerad_av_1_A = compoundA (regA "disponerad") ;
  disciplinerad_av_1_A = compoundA (regA "disciplinerad") ;
  detaljfixerad_av_1_A = compoundA (regA "detaljfixerad") ;
  detaljerad_av_1_A = compoundA (regA "detaljerad") ;
  desorienterad_av_1_A = compoundA (regA "desorienterad") ;
  desintresserad_av_1_A = compoundA (regA "desintresserad") ;
  desillusionerad_av_1_A = compoundA (regA "desillusionerad") ;
  deprimerad_av_1_A = compoundA (regA "deprimerad") ;
  depraverad_av_1_A = compoundA (regA "depraverad") ;
  deppad_av_1_A = compoundA (regA "deppad") ;
  denukleariserad_av_1_A = compoundA (regA "denukleariserad") ;
  demensrelaterad_av_1_A = compoundA (regA "demensrelaterad") ;
  deltaformad_av_1_A = compoundA (regA "deltaformad") ;
  delad_av_1_A = compoundA (regA "delad") ;
  delabialiserad_av_1_A = compoundA (regA "delabialiserad") ;
  dekolleterad_av_1_A = compoundA (regA "dekolleterad") ;
  deciderad_av_1_A = compoundA (regA "deciderad") ;
  datorrelaterad_av_1_A = compoundA (regA "datorrelaterad") ;
  cylinderformad_av_1_A = compoundA (regA "cylinderformad") ;
  cp_skadad_av_1_A = compoundA (regA "cp-skadad") ;
  civiliserad_av_1_A = compoundA (regA "civiliserad") ;
  citronmarinerad_av_1_A = compoundA (regA "citronmarinerad") ;
  chockartad_av_1_A = compoundA (regA "chockartad") ;
  chausserad_av_1_A = compoundA (regA "chausserad") ;
  chansartad_av_1_A = compoundA (regA "chansartad") ;
  cerisefaergad_av_1_1_A = compoundA (regA "cerisefärgad") ;
  centraldirigerad_av_1_A = compoundA (regA "centraldirigerad") ;
  baagformad_av_1_1_A = compoundA (regA "bågformad") ;
  baelgformad_av_1_1_A = compoundA (regA "bälgformad") ;
  buskartad_av_1_A = compoundA (regA "buskartad") ;
  braadstoertad_av_1_1_A = compoundA (regA "brådstörtad") ;
  braennskadad_av_1_1_A = compoundA (regA "brännskadad") ;
  brunmaalad_av_1_1_A = compoundA (regA "brunmålad") ;
  brunlackerad_av_1_A = compoundA (regA "brunlackerad") ;
  brunfaergad_av_1_1_A = compoundA (regA "brunfärgad") ;
  broscherad_av_1_A = compoundA (regA "broscherad") ;
  bronsinfattad_av_1_A = compoundA (regA "bronsinfattad") ;
  bronsfaergad_av_1_1_A = compoundA (regA "bronsfärgad") ;
  briljanterad_av_1_A = compoundA (regA "briljanterad") ;
  bredkaeftad_av_1_1_A = compoundA (regA "bredkäftad") ;
  bredbraettad_av_1_1_A = compoundA (regA "bredbrättad") ;
  bredaxlad_av_1_A = compoundA (regA "bredaxlad") ;
  brandskadad_av_1_A = compoundA (regA "brandskadad") ;
  boxningstraenad_av_1_1_A = compoundA (regA "boxningstränad") ;
  borttappad_av_1_A = compoundA (regA "borttappad") ;
  bortkastad_av_1_A = compoundA (regA "bortkastad") ;
  bornerad_av_1_A = compoundA (regA "bornerad") ;
  bombad_av_1_A = compoundA (regA "bombad") ;
  blaamaalad_av_1_1_A = compoundA (regA "blåmålad") ;
  blyfoergiftad_av_1_1_A = compoundA (regA "blyförgiftad") ;
  blommerad_av_1_A = compoundA (regA "blommerad") ;
  blodbeflaeckad_av_1_1_A = compoundA (regA "blodbefläckad") ;
  blixtinkallad_av_1_A = compoundA (regA "blixtinkallad") ;
  blekglaserad_av_1_A = compoundA (regA "blekglaserad") ;
  blaserad_av_1_A = compoundA (regA "blaserad") ;
  blankputsad_av_1_A = compoundA (regA "blankputsad") ;
  blankgalvad_av_1_A = compoundA (regA "blankgalvad") ;
  blandad_av_1_A = compoundA (regA "blandad") ;
  bildad_av_1_A = compoundA (regA "bildad") ;
  bevaepna_av_1_1_A = compoundA (regA "beväpna") ;
  bevingad_av_1_A = compoundA (regA "bevingad") ;
  bevandrad_av_1_A = compoundA (regA "bevandrad") ;
  betuttad_av_1_A = compoundA (regA "betuttad") ;
  betonad_av_1_A = compoundA (regA "betonad") ;
  betingad_av_1_A = compoundA (regA "betingad") ;
  besvaagrad_av_1_1_A = compoundA (regA "besvågrad") ;
  besvaerad_av_1_1_A = compoundA (regA "besvärad") ;
  besloejad_av_1_1_A = compoundA (regA "beslöjad") ;
  beslaektad_av_1_1_A = compoundA (regA "besläktad") ;
  beskaffad_av_1_A = compoundA (regA "beskaffad") ;
  besinnad_av_1_A = compoundA (regA "besinnad") ;
  besiffrad_av_1_A = compoundA (regA "besiffrad") ;
  beraettigad_av_1_1_A = compoundA (regA "berättigad") ;
  beryktad_av_1_A = compoundA (regA "beryktad") ;
  berusad_av_1_A = compoundA (regA "berusad") ;
  beramad_av_1_A = compoundA (regA "beramad") ;
  beproevad_av_1_1_A = compoundA (regA "beprövad") ;
  benfaergad_av_1_1_A = compoundA (regA "benfärgad") ;
  bemedlad_av_1_A = compoundA (regA "bemedlad") ;
  bemannad_av_1_A = compoundA (regA "bemannad") ;
  belevad_av_1_A = compoundA (regA "belevad") ;
  bekyttad_av_1_A = compoundA (regA "bekyttad") ;
  bekymrad_av_1_A = compoundA (regA "bekymrad") ;
  behaarad_av_1_1_A = compoundA (regA "behårad") ;
  behaerskad_av_1_1_A = compoundA (regA "behärskad") ;
  behaeftad_av_1_1_A = compoundA (regA "behäftad") ;
  behovsproevad_av_1_1_A = compoundA (regA "behovsprövad") ;
  behornad_av_1_A = compoundA (regA "behornad") ;
  behjaertad_av_1_1_A = compoundA (regA "behjärtad") ;
  behandskad_av_1_A = compoundA (regA "behandskad") ;
  begaavad_av_1_1_A = compoundA (regA "begåvad") ;
  begraensad_av_1_1_A = compoundA (regA "begränsad") ;
  begeistrad_av_1_A = compoundA (regA "begeistrad") ;
  begagnad_av_1_A = compoundA (regA "begagnad") ;
  befryndad_av_1_A = compoundA (regA "befryndad") ;
  befogad_av_1_A = compoundA (regA "befogad") ;
  befjaedrad_av_1_1_A = compoundA (regA "befjädrad") ;
  bedroevad_av_1_1_A = compoundA (regA "bedrövad") ;
  bedagad_av_1_A = compoundA (regA "bedagad") ;
  barskrapad_av_1_A = compoundA (regA "barskrapad") ;
  barnporranklagad_av_1_A = compoundA (regA "barnporranklagad") ;
  barhuvad_av_1_A = compoundA (regA "barhuvad") ;
  barfotad_av_1_A = compoundA (regA "barfotad") ;
  barbroestad_av_1_1_A = compoundA (regA "barbröstad") ;
  bararmad_av_1_A = compoundA (regA "bararmad") ;
  balkaniserad_av_1_A = compoundA (regA "balkaniserad") ;
  balanserad_av_1_A = compoundA (regA "balanserad") ;
  bakaatriktad_av_1_1_A = compoundA (regA "bakåtriktad") ;
  bakaatlutad_av_1_1_A = compoundA (regA "bakåtlutad") ;
  bakaatkammad_av_1_1_A = compoundA (regA "bakåtkammad") ;
  bakteriesmittad_av_1_A = compoundA (regA "bakteriesmittad") ;
  bagatellartad_av_1_A = compoundA (regA "bagatellartad") ;
  avvarad_av_1_A = compoundA (regA "avvarad") ;
  avtacklad_av_1_A = compoundA (regA "avtacklad") ;
  avstressad_av_1_A = compoundA (regA "avstressad") ;
  avsnoppad_av_1_A = compoundA (regA "avsnoppad") ;
  avslappnad_av_1_A = compoundA (regA "avslappnad") ;
  avrakad_av_1_A = compoundA (regA "avrakad") ;
  avmagrad_av_1_A = compoundA (regA "avmagrad") ;
  avhoppad_av_1_A = compoundA (regA "avhoppad") ;
  avflagnad_av_1_A = compoundA (regA "avflagnad") ;
  avdankad_av_1_A = compoundA (regA "avdankad") ;
  avancerad_av_1_A = compoundA (regA "avancerad") ;
  augustnominerad_av_1_A = compoundA (regA "augustnominerad") ;
  aspackad_av_1_A = compoundA (regA "aspackad") ;
  asfoerbannad_av_1_1_A = compoundA (regA "asförbannad") ;
  asberusad_av_1_A = compoundA (regA "asberusad") ;
  arvsberaettigad_av_1_1_A = compoundA (regA "arvsberättigad") ;
  arriverad_av_1_A = compoundA (regA "arriverad") ;
  arbetshandikappad_av_1_A = compoundA (regA "arbetshandikappad") ;
  apelkastad_av_1_A = compoundA (regA "apelkastad") ;
  antimoegelbehandlad_av_1_1_A = compoundA (regA "antimögelbehandlad") ;
  antikverad_av_1_A = compoundA (regA "antikverad") ;
  animerad_av_1_A = compoundA (regA "animerad") ;
  anfaektad_av_1_1_A = compoundA (regA "anfäktad") ;
  amerikansktillverkad_av_1_A = compoundA (regA "amerikansktillverkad") ;
  altererad_av_1_A = compoundA (regA "altererad") ;
  aloebaserad_av_1_A = compoundA (regA "aloebaserad") ;
  allmaenbildad_av_1_1_A = compoundA (regA "allmänbildad") ;
  allierad_av_1_A = compoundA (regA "allierad") ;
  alkoholrelaterad_av_1_A = compoundA (regA "alkoholrelaterad") ;
  alkoholpaaverkad_av_1_1_A = compoundA (regA "alkoholpåverkad") ;
  alkoholiserad_av_1_A = compoundA (regA "alkoholiserad") ;
  akterseglad_av_1_A = compoundA (regA "akterseglad") ;
  affekterad_av_1_A = compoundA (regA "affekterad") ;
  _7_armad_av_1_A = compoundA (regA "7-armad") ;
  _5_armad_av_1_A = compoundA (regA "5-armad") ;
  Marseillebaserad_av_1_A = compoundA (regA "Marseillebaserad") ;
  Kafkaartad_av_1_A = compoundA (regA "Kafkaartad") ;
  Cp_skadad_av_1_A = compoundA (regA "Cp-skadad") ;
  Chicagobaserad_av_1_A = compoundA (regA "Chicagobaserad") ;
  Chicago_baserad_av_1_A = compoundA (regA "Chicago-baserad") ;
  CP_skadad_av_1_A = compoundA (regA "CP-skadad") ;
}
