--# -path=.:abstract:alltenses/

-- This dictionary is derived from SALDO, see:
--
--   Borin, Lars, Markus Forsberg and Lennart Lönngren 2008.
--   The hunting of the BLARK - SALDO, a freely available lexical database for
--   Swedish language technology. Resourceful language technology.
--   Festschrift in honor of Anna Sågvall Hein, ed. by Joakim Nivre,
--   Mats Dahllöf and Bea¡ta Megyesi.
--   Acta Universitatis Upsaliensis: Studia Linguistica Upsaliensia 7. 21-32.
--   <http://spraakbanken.gu.se/personal/lars/pblctns/ash-fs-080605.pdf>
--
-- Imported to GF by Malin Ahlberg
--
-- This resource is distributed under the free software license LGPL 3.0 or
-- Creative Commons Attribution-Share Alike 2.5 Generic.

abstract OldDictSweAbs = Cat ** {

fun
  vaexa_oever_vbm_1_1_V2 : V2 ;
  vaexa_ur_vbm_1_1_V2 : V2 ;
  vaexa_ifraan_vbm_1_1_V2 : V2 ;
  vaexa_i_vbm_1_1_V2 : V2 ;
  vaexa_fraan_vbm_1_1_V2 : V2 ;
  vaexa_vb_1_1_V : V ;
  varda_vb_1_V : V ;
  utloepa_vb_1_1_V : V ;
  uppvaexa_vb_1_1_V : V ;
  traeda_vb_2_1_V : V ;
  tillvaexa_vb_1_1_V : V ;
  ta_ut_vbm_1_V2 : V2 ;
  ta_ur_vbm_1_V2 : V2 ;
  ta_in_vbm_1_V2 : V2 ;
  ta_av_vbm_1_V2 : V2 ;
  svaelta_vb_2_1_V : V ;
  spae_ut_vbm_1_1_V2 : V2 ;
  spae_paa_vbm_1_1_V2 : V2 ;
  snusmala_vb_1_V : V ;
  skvaetta_vb_1_1_V : V ;
  oppvaexa_vb_1_1_V : V ;
  nypa_till_vbm_1_V2 : V2 ;
  nypa_av_vbm_1_V2 : V2 ;
  nypa_vb_1_V : V ;
  klae_ut_vbm_1_1_V2 : V2 ;
  klae_paa_vbm_1_1_V2 : V2 ;
  klae_om_vbm_1_1_V2 : V2 ;
  klae_av_vbm_1_1_V2 : V2 ;
  gaa_aat_vbm_1_1_V2 : V2 ;
  gaa_ut_vbm_1_1_V2 : V2 ;
  gaa_paa_vbm_2_1_V2 : V2 ;
  gaa_in_vbm_1_1_V2 : V2 ;
  gaa_igenom_vbm_1_1_V2 : V2 ;
  framvaexa_vb_1_1_V : V ;
  dra_oever_vbm_1_1_V2 : V2 ;
  dra_aat_vbm_1_1_V2 : V2 ;
  dra_ut_vbm_1_V2 : V2 ;
  dra_in_vbm_1_V2 : V2 ;
  dra_ifraan_vbm_1_1_V2 : V2 ;
  dra_av_vbm_1_V2 : V2 ;
  ansluta_sig_vbm_1_VR : V ;
  avhaalla_sig_vbm_1_1_VR : V ;
  avsvaerja_vb_1_1_V : V ;
  avsaega_sig_vbm_1_1_VR : V ;
  avvika_vb_1_V : V ;
  befinna_sig_vbm_1_VR : V ;
  bege_sig_vbm_1_VR : V ;
  beloepa_sig_vbm_1_1_VR : V ;
  bestrida_vb_1_V : V ;
  besvaerja_vb_1_1_V : V ;
  bete_sig_vbm_1_VR : V ;
  bli_av_vbm_1_V2 : V2 ;
  bli_efter_vbm_1_V2 : V2 ;
  bli_med_vbm_1_V2 : V2 ;
  bli_till_vbm_1_V2 : V2 ;
  bli_utan_vbm_1_V2 : V2 ;
  bli_oever_vbm_1_1_V2 : V2 ;
  bosaetta_sig_vbm_1_1_VR : V ;
  bre_vb_1_V : V ;
  baera_sig_vbm_1_1_VR : V ;
  drypa_vb_1_V : V ;
  duga_vb_1_V : V ;
  doe_ut_vbm_1_1_V2 : V2 ;
  finna_sig_vbm_1_VR : V ;
  frambesvaerja_vb_1_1_V : V ;
  fraansaega_sig_vbm_1_1_VR : V ;
  faesta_sig_vbm_1_1_VR : V ;
  faa_till_vbm_1_1_V2 : V2 ;
  foerbinda_sig_vbm_1_1_VR : V ;
  foerbryta_sig_vbm_1_1_VR : V ;
  foeresaetta_sig_vbm_1_1_VR : V ;
  foergripa_sig_vbm_1_1_VR : V ;
  foergaa_sig_vbm_1_1_VR : V ;
  foerhaalla_sig_vbm_1_1_VR : V ;
  foerlyfta_sig_vbm_1_1_VR : V ;
  foerse_vb_1_1_V : V ;
  foerskriva_sig_vbm_1_1_VR : V ;
  foersova_sig_vbm_1_1_VR : V ;
  foersvaerja_vb_1_1_V : V ;
  foersvaerja_sig_vbm_1_1_VR : V ;
  foersaega_sig_vbm_1_1_VR : V ;
  foertaelja_vb_1_1_V : V ;
  ge_sig_vbm_1_VR : V ;
  gifta_sig_vbm_1_VR : V ;
  gaa_an_vbm_1_1_V2 : V2 ;
  gaa_efter_vbm_1_1_V2 : V2 ;
  gaa_foere_vbm_1_1_V2 : V2 ;
  gaa_igenom_vbm_2_1_V2 : V2 ;
  gaa_in_vbm_2_1_V2 : V2 ;
  gaa_med_vbm_1_1_V2 : V2 ;
  gaa_paa_vbm_1_1_V2 : V2 ;
  gaa_till_vbm_1_1_V2 : V2 ;
  gaa_under_vbm_1_1_V2 : V2 ;
  gaa_oever_vbm_1_1_V2 : V2 ;
  goera_sig_vbm_1_1_VR : V ;
  heta_vb_1_V : V ;
  hopvika_vb_1_V : V ;
  haenge_sig_vbm_1_1_VR : V ;
  haalla_sig_vbm_1_1_VR : V ;
  hoeja_sig_vbm_1_1_VR : V ;
  ifoera_sig_vbm_1_1_VR : V ;
  infinna_sig_vbm_1_VR : V ;
  inlaata_sig_vbm_1_1_VR : V ;
  klyva_vb_1_V : V ;
  komma_an_vbm_1_V2 : V2 ;
  komma_foer_vbm_1_1_V2 : V2 ;
  komma_ifraan_vbm_1_1_V2 : V2 ;
  komma_sig_vbm_1_VR : V ;
  komma_till_vbm_2_V2 : V2 ;
  komma_vid_vbm_1_V2 : V2 ;
  kvida_vb_1_V : V ;
  kvaeda_vb_1_1_V : V ;
  kaenna_sig_vbm_1_1_VR : V ;
  livnaera_sig_vbm_1_1_VR : V ;
  lyda_vb_1_V : V ;
  lyfta_sig_vbm_1_VR : V ;
  laegga_sig_vbm_1_1_VR : V ;
  laera_sig_vbm_1_1_VR : V ;
  missminna_sig_vbm_1_VR : V ;
  motsaetta_sig_vbm_1_1_VR : V ;
  nedlaata_sig_vbm_1_1_VR : V ;
  nerlaata_sig_vbm_1_1_VR : V ;
  noeja_sig_vbm_1_1_VR : V ;
  ondgoera_sig_vbm_1_1_VR : V ;
  reda_sig_vbm_1_VR : V ;
  roera_sig_vbm_1_1_VR : V ;
  sammansvaerja_sig_vbm_1_1_VR : V ;
  se_efter_vbm_1_V2 : V2 ;
  se_om_vbm_1_V2 : V2 ;
  se_till_vbm_1_V2 : V2 ;
  se_ut_vbm_1_V2 : V2 ;
  skaelva_vb_1_1_V : V ;
  skaera_sig_vbm_1_1_VR : V ;
  slita_sig_vbm_1_VR : V ;
  sluta_sig_vbm_1_VR : V ;
  slaa_an_vbm_1_1_V2 : V2 ;
  slaa_an_vbm_2_1_V2 : V2 ;
  slaa_av_vbm_1_1_V2 : V2 ;
  slaa_fraan_vbm_1_1_V2 : V2 ;
  slaa_ifraan_vbm_1_1_V2 : V2 ;
  slaa_igenom_vbm_1_1_V2 : V2 ;
  slaa_in_vbm_1_1_V2 : V2 ;
  slaa_in_vbm_2_1_V2 : V2 ;
  slaa_om_vbm_1_1_V2 : V2 ;
  slaa_paa_vbm_1_1_V2 : V2 ;
  slaa_runt_vbm_1_1_V2 : V2 ;
  slaa_sig_vbm_1_1_VR : V ;
  slaa_till_vbm_1_1_V2 : V2 ;
  slaa_ut_vbm_1_1_V2 : V2 ;
  slaa_oever_vbm_1_1_V2 : V2 ;
  smaella_vb_2_1_V : V ;
  smaella_av_vbm_1_1_V2 : V2 ;
  smaelta_vb_1_1_V : V ;
  snyta_sig_vbm_1_VR : V ;
  sova_ut_vbm_2_V2 : V2 ;
  sova_oever_vbm_1_1_V2 : V2 ;
  sprida_vb_1_V : V ;
  sprida_sig_vbm_1_VR : V ;
  sprida_ut_vbm_1_V2 : V2 ;
  spaenna_sig_vbm_1_1_VR : V ;
  strida_vb_1_V : V ;
  staa_paa_vbm_1_1_V2 : V2 ;
  staa_sig_vbm_1_1_VR : V ;
  staa_till_vbm_1_1_V2 : V2 ;
  staa_ut_vbm_1_1_V2 : V2 ;
  staa_ut_vbm_2_1_V2 : V2 ;
  staa_oever_vbm_1_1_V2 : V2 ;
  staalsaetta_sig_vbm_1_1_VR : V ;
  saega_sig_vbm_1_1_VR : V ;
  saelja_sig_vbm_1_1_VR : V ;
  saetta_sig_vbm_1_1_VR : V ;
  te_sig_vbm_1_VR : V ;
  tillgodogoera_sig_vbm_1_1_VR : V ;
  tillvinna_sig_vbm_1_VR : V ;
  taelja_vb_2_1_V : V ;
  undanbe_sig_vbm_1_VR : V ;
  underlaegga_sig_vbm_1_1_VR : V ;
  understaa_sig_vbm_1_1_VR : V ;
  uppehaalla_sig_vbm_1_1_VR : V ;
  uppfoera_sig_vbm_1_1_VR : V ;
  utbe_sig_vbm_1_VR : V ;
  utbre_vb_1_V : V ;
  utfaesta_sig_vbm_1_1_VR : V ;
  utge_sig_vbm_1_VR : V ;
  utgjuta_sig_vbm_1_VR : V ;
  utlaata_sig_vbm_1_1_VR : V ;
  utspinna_sig_vbm_1_VR : V ;
  utsprida_vb_1_V : V ;
  vika_vb_1_V : V ;
  vinnlaegga_sig_vbm_1_1_VR : V ;
  vrida_sig_vbm_1_VR : V ;
  vaenja_sig_vbm_1_1_VR : V ;
  vaaldfoera_sig_vbm_1_1_VR : V ;
  aatlyda_vb_1_1_V : V ;
  aatnoeja_sig_vbm_1_1_VR : V ;
  agera_ut_vbm_1_V2 : V2 ;
  akta_sig_vbm_1_VR : V ;
  anbringa_vb_1_V : V ;
  anmaela_sig_vbm_1_1_VR : V ;
  anpassa_sig_vbm_1_VR : V ;
  anstraenga_sig_vbm_1_1_VR : V ;
  apa_efter_vbm_1_V2 : V2 ;
  apa_runt_vbm_1_V2 : V2 ;
  apa_sig_vbm_1_VR : V ;
  armbaaga_sig_vbm_1_1_VR : V ;
  arta_sig_vbm_1_VR : V ;
  avboerda_sig_vbm_1_1_VR : V ;
  avklae_vb_1_1_V : V ;
  avkoena_sig_vbm_1_1_VR : V ;
  avlaegsna_sig_vbm_1_1_VR : V ;
  avreagera_sig_vbm_1_VR : V ;
  avteckna_sig_vbm_1_VR : V ;
  avtvinga_vb_1_V : V ;
  avtvaa_vb_1_1_V : V ;
  avvara_vb_1_V : V ;
  backa_ur_vbm_1_V2 : V2 ;
  barka_av_vbm_1_V2 : V2 ;
  beblanda_sig_vbm_1_VR : V ;
  becka_sig_vbm_1_VR : V ;
  befatta_sig_vbm_1_VR : V ;
  beflita_sig_vbm_1_VR : V ;
  begrava_vb_1_V : V ;
  behaerska_sig_vbm_1_1_VR : V ;
  beklaga_sig_vbm_1_VR : V ;
  beklae_vb_1_1_V : V ;
  bekvaema_sig_vbm_1_1_VR : V ;
  bekymra_sig_vbm_1_VR : V ;
  bemaektiga_sig_vbm_1_1_VR : V ;
  bemoeda_sig_vbm_1_1_VR : V ;
  bero_paa_vbm_1_1_V2 : V2 ;
  berusa_sig_vbm_1_VR : V ;
  besinna_sig_vbm_1_VR : V ;
  beskaerma_sig_vbm_1_1_VR : V ;
  besluta_vb_1_V : V ;
  bespetsa_sig_vbm_1_VR : V ;
  bestaemma_sig_vbm_1_1_VR : V ;
  besvaera_sig_vbm_1_1_VR : V ;
  betacka_sig_vbm_1_VR : V ;
  betala_vb_1_V : V ;
  betala_sig_vbm_1_VR : V ;
  betvinga_vb_1_V : V ;
  betaenka_sig_vbm_1_1_VR : V ;
  beveka_vb_1_V : V ;
  bibringa_vb_1_V : V ;
  bikta_sig_vbm_1_VR : V ;
  bistra_till_vbm_1_V2 : V2 ;
  blamera_sig_vbm_1_VR : V ;
  blomma_ut_vbm_1_V2 : V2 ;
  blotta_sig_vbm_1_VR : V ;
  blusa_sig_vbm_1_VR : V ;
  blaasa_av_vbm_1_1_V2 : V2 ;
  bo_oever_vbm_1_1_V2 : V2 ;
  bocka_sig_vbm_1_VR : V ;
  bringa_vb_1_V : V ;
  bry_sig_vbm_1_VR : V ;
  braedbeklae_vb_1_1_V : V ;
  broesta_sig_vbm_1_1_VR : V ;
  buga_sig_vbm_1_VR : V ;
  baenka_sig_vbm_1_1_VR : V ;
  baerga_sig_vbm_1_1_VR : V ;
  baettra_sig_vbm_1_1_VR : V ;
  boerja_om_vbm_1_1_V2 : V2 ;
  chosa_sig_vbm_1_VR : V ;
  dabba_sig_vbm_1_VR : V ;
  dela_sig_vbm_1_VR : V ;
  dra_sig_vbm_1_VR : V ;
  drista_sig_vbm_1_VR : V ;
  droga_sig_vbm_1_VR : V ;
  droesa_vb_1_1_V : V ;
  dumma_sig_vbm_1_VR : V ;
  dyka_vb_1_V : V ;
  dystra_till_vbm_1_V2 : V2 ;
  doema_ut_vbm_1_1_V2 : V2 ;
  fega_sig_vbm_1_VR : V ;
  fega_ur_vbm_1_V2 : V2 ;
  fjompa_sig_vbm_1_VR : V ;
  fjaedra_sig_vbm_1_1_VR : V ;
  flisa_sig_vbm_1_VR : V ;
  flocka_sig_vbm_1_VR : V ;
  flottyrkoka_vb_1_V : V ;
  flytta_sig_vbm_1_VR : V ;
  flaeka_sig_vbm_1_1_VR : V ;
  floeda_till_vbm_1_1_V2 : V2 ;
  floeda_ut_vbm_1_1_V2 : V2 ;
  foga_sig_vbm_1_VR : V ;
  forta_sig_vbm_1_VR : V ;
  fortbilda_sig_vbm_1_VR : V ;
  fortplanta_sig_vbm_1_VR : V ;
  fortvara_vb_1_V : V ;
  frambringa_vb_1_V : V ;
  framtvinga_vb_1_V : V ;
  friska_i_vbm_1_V2 : V2 ;
  frottera_sig_vbm_1_VR : V ;
  fraaga_sig_vbm_1_1_VR : V ;
  froejda_sig_vbm_1_1_VR : V ;
  fylka_sig_vbm_1_VR : V ;
  fyra_av_vbm_1_V2 : V2 ;
  faana_sig_vbm_1_1_VR : V ;
  foerbarma_sig_vbm_1_1_VR : V ;
  foerbena_sig_vbm_1_1_VR : V ;
  foerdjupa_sig_vbm_1_1_VR : V ;
  foerestaella_sig_vbm_1_1_VR : V ;
  foerfasa_sig_vbm_1_1_VR : V ;
  foerflytta_sig_vbm_1_1_VR : V ;
  foerfoga_sig_vbm_1_1_VR : V ;
  foerfriska_sig_vbm_1_1_VR : V ;
  foerfraaga_sig_vbm_1_1_VR : V ;
  foergapa_sig_vbm_1_1_VR : V ;
  foergrena_sig_vbm_1_1_VR : V ;
  foerhasta_sig_vbm_1_1_VR : V ;
  foerhaerda_sig_vbm_1_1_VR : V ;
  foerhaeva_sig_vbm_1_1_VR : V ;
  foerirra_sig_vbm_1_1_VR : V ;
  foerivra_sig_vbm_1_1_VR : V ;
  foerkasta_sig_vbm_1_1_VR : V ;
  foerklistra_sig_vbm_1_1_VR : V ;
  foerkovra_sig_vbm_1_1_VR : V ;
  foerkyla_sig_vbm_1_1_VR : V ;
  foerkoepa_sig_vbm_1_1_VR : V ;
  foerlika_sig_vbm_1_1_VR : V ;
  foerlita_sig_vbm_1_1_VR : V ;
  foerlora_sig_vbm_1_1_VR : V ;
  foerlova_sig_vbm_1_1_VR : V ;
  foerlusta_sig_vbm_1_1_VR : V ;
  foerlaesa_sig_vbm_1_1_VR : V ;
  foerloepa_vb_1_1_V : V ;
  foerloepa_sig_vbm_1_1_VR : V ;
  foermena_vb_2_1_V : V ;
  foermaela_vb_2_1_V : V ;
  foermaela_sig_vbm_1_1_VR : V ;
  foermaa_sig_vbm_1_1_VR : V ;
  foerneka_sig_vbm_1_1_VR : V ;
  foerskansa_sig_vbm_1_1_VR : V ;
  foerstaella_sig_vbm_1_1_VR : V ;
  foersynda_sig_vbm_1_1_VR : V ;
  foersaekra_sig_vbm_1_1_VR : V ;
  foervaenta_sig_vbm_1_1_VR : V ;
  foeraelska_sig_vbm_1_1_VR : V ;
  foeroeka_sig_vbm_1_1_VR : V ;
  gloedbaka_vb_1_1_V : V ;
  gona_sig_vbm_1_VR : V ;
  gosa_sig_vbm_1_VR : V ;
  gotta_sig_vbm_1_VR : V ;
  grena_sig_vbm_1_VR : V ;
  graema_sig_vbm_1_1_VR : V ;
  gaelda_vb_1_1_V : V ;
  gaella_vb_2_1_V : V ;
  gaenga_sig_vbm_1_1_VR : V ;
  habilitera_sig_vbm_1_VR : V ;
  haja_till_vbm_1_V2 : V2 ;
  hanka_sig_vbm_1_VR : V ;
  himla_sig_vbm_1_VR : V ;
  hopbringa_vb_1_V : V ;
  hovera_sig_vbm_1_VR : V ;
  huka_sig_vbm_1_VR : V ;
  haemna_sig_vbm_1_1_VR : V ;
  haemta_sig_vbm_1_1_VR : V ;
  haenga_sig_vbm_1_1_VR : V ;
  haenvaenda_sig_vbm_1_1_VR : V ;
  haerskna_till_vbm_1_1_V2 : V2 ;
  haevda_sig_vbm_1_1_VR : V ;
  iklae_vb_1_1_V : V ;
  ila_igenom_vbm_1_V2 : V2 ;
  inbetala_vb_1_V : V ;
  inbilla_sig_vbm_1_VR : V ;
  inbringa_vb_1_V : V ;
  inkoka_vb_1_V : V ;
  inrikta_sig_vbm_1_VR : V ;
  instaella_sig_vbm_1_1_VR : V ;
  intala_sig_vbm_1_VR : V ;
  intressera_sig_vbm_1_VR : V ;
  irritera_sig_vbm_1_VR : V ;
  jaemra_sig_vbm_1_1_VR : V ;
  joensa_sig_vbm_1_1_VR : V ;
  kasta_sig_vbm_1_VR : V ;
  kila_in_vbm_2_V2 : V2 ;
  klanta_sig_vbm_1_VR : V ;
  klara_sig_vbm_1_VR : V ;
  klinga_vb_1_V : V ;
  klippa_sig_vbm_1_VR : V ;
  klumpa_sig_vbm_1_VR : V ;
  klyfta_sig_vbm_1_VR : V ;
  klae_vb_1_1_V : V ;
  knottra_sig_vbm_1_VR : V ;
  knulla_runt_vbm_1_V2 : V2 ;
  knoela_sig_vbm_1_1_VR : V ;
  koda_av_vbm_1_V2 : V2 ;
  koka_vb_1_V : V ;
  koka_in_vbm_1_V2 : V2 ;
  koka_oever_vbm_1_1_V2 : V2 ;
  koncentrera_sig_vbm_1_VR : V ;
  konformera_sig_vbm_1_VR : V ;
  koppla_av_vbm_1_V2 : V2 ;
  korsa_sig_vbm_1_VR : V ;
  korva_sig_vbm_1_VR : V ;
  kosta_paa_vbm_1_1_V2 : V2 ;
  krumma_sig_vbm_1_VR : V ;
  kraama_sig_vbm_1_1_VR : V ;
  kraangla_in_vbm_1_1_V2 : V2 ;
  kuska_runt_vbm_1_V2 : V2 ;
  kvarvara_vb_1_V : V ;
  lagra_sig_vbm_1_VR : V ;
  laka_ur_vbm_1_V2 : V2 ;
  larva_sig_vbm_1_VR : V ;
  lassa_av_vbm_1_V2 : V2 ;
  lassa_paa_vbm_1_1_V2 : V2 ;
  lata_sig_vbm_1_VR : V ;
  legitimera_sig_vbm_1_VR : V ;
  levra_sig_vbm_1_VR : V ;
  lokalisera_sig_vbm_1_VR : V ;
  lugga_sig_vbm_1_VR : V ;
  lugna_sig_vbm_1_VR : V ;
  lura_till_vbm_1_V2 : V2 ;
  laegra_sig_vbm_1_1_VR : V ;
  laemna_av_vbm_1_1_V2 : V2 ;
  laemna_in_vbm_1_1_V2 : V2 ;
  laemna_oever_vbm_1_1_V2 : V2 ;
  laempa_sig_vbm_1_1_VR : V ;
  laesa_av_vbm_1_1_V2 : V2 ;
  laesa_in_vbm_1_1_V2 : V2 ;
  laesa_paa_vbm_1_1_V2 : V2 ;
  laesa_ut_vbm_1_1_V2 : V2 ;
  laasa_in_vbm_1_1_V2 : V2 ;
  loeda_vb_1_1_V : V ;
  loejla_sig_vbm_1_1_VR : V ;
  loena_sig_vbm_1_1_VR : V ;
  loepa_vb_1_1_V : V ;
  loesa_ut_vbm_1_1_V2 : V2 ;
  mala_vb_1_V : V ;
  malla_sig_vbm_1_VR : V ;
  marschera_an_vbm_1_V2 : V2 ;
  marschera_av_vbm_1_V2 : V2 ;
  marschera_in_vbm_1_V2 : V2 ;
  marschera_ut_vbm_1_V2 : V2 ;
  masa_sig_vbm_1_VR : V ;
  medbringa_vb_1_V : V ;
  mena_vb_1_V : V ;
  missklae_vb_1_1_V : V ;
  misskunda_sig_vbm_1_VR : V ;
  missraekna_sig_vbm_1_1_VR : V ;
  mjoela_sig_vbm_1_1_VR : V ;
  mopsa_sig_vbm_1_VR : V ;
  morgna_sig_vbm_1_VR : V ;
  morna_sig_vbm_1_VR : V ;
  morska_sig_vbm_1_VR : V ;
  morskna_till_vbm_1_V2 : V2 ;
  muppa_sig_vbm_1_VR : V ;
  moeda_sig_vbm_1_1_VR : V ;
  nalka_sig_vbm_1_VR : V ;
  nedbringa_vb_1_V : V ;
  nerbringa_vb_1_V : V ;
  noppa_sig_vbm_1_VR : V ;
  noppra_sig_vbm_1_VR : V ;
  nosa_sig_vbm_1_VR : V ;
  nysa_vb_1_V : V ;
  naerma_sig_vbm_1_1_VR : V ;
  naervara_vb_1_1_V : V ;
  naesta_vb_1_1_V : V ;
  omaka_sig_vbm_1_VR : V ;
  omfoermaela_vb_1_1_V : V ;
  omklae_vb_1_1_V : V ;
  opphaeva_vb_2_1_V : V ;
  orientera_sig_vbm_1_VR : V ;
  orka_med_vbm_1_V2 : V2 ;
  oroa_sig_vbm_1_VR : V ;
  osta_sig_vbm_1_VR : V ;
  pallra_sig_vbm_1_VR : V ;
  para_sig_vbm_1_VR : V ;
  passa_paa_vbm_1_1_V2 : V2 ;
  passa_sig_vbm_1_VR : V ;
  prova_paa_vbm_1_1_V2 : V2 ;
  praangla_ut_vbm_1_1_V2 : V2 ;
  proeva_paa_vbm_1_1_V2 : V2 ;
  paelsa_paa_vbm_1_1_V2 : V2 ;
  paaspae_vb_1_1_V : V ;
  paatvinga_vb_1_1_V : V ;
  raka_sig_vbm_1_VR : V ;
  rappa_paa_vbm_1_1_V2 : V2 ;
  raska_paa_vbm_1_1_V2 : V2 ;
  rekreera_sig_vbm_1_VR : V ;
  repa_sig_vbm_1_VR : V ;
  reservera_sig_vbm_1_VR : V ;
  reta_sig_vbm_1_VR : V ;
  revanschera_sig_vbm_1_VR : V ;
  rikta_in_vbm_1_V2 : V2 ;
  roa_sig_vbm_1_VR : V ;
  ropa_till_vbm_1_V2 : V2 ;
  rota_sig_vbm_1_VR : V ;
  rusa_in_vbm_1_V2 : V2 ;
  rusa_ut_vbm_1_V2 : V2 ;
  ryka_vb_1_V : V ;
  raekna_med_vbm_1_1_V2 : V2 ;
  raenta_sig_vbm_1_1_VR : V ;
  raetta_sig_vbm_1_1_VR : V ;
  raa_vb_1_1_V : V ;
  raa_foer_vbm_1_1_V2 : V2 ;
  raa_om_vbm_1_1_V2 : V2 ;
  sacka_efter_vbm_1_V2 : V2 ;
  safta_i_vbm_1_V2 : V2 ;
  safta_paa_vbm_1_1_V2 : V2 ;
  safta_sig_vbm_1_VR : V ;
  safta_till_vbm_1_V2 : V2 ;
  sakta_av_vbm_1_V2 : V2 ;
  sakta_sig_vbm_1_VR : V ;
  samla_sig_vbm_1_VR : V ;
  sammangadda_sig_vbm_1_VR : V ;
  sansa_sig_vbm_1_VR : V ;
  sega_sig_vbm_1_VR : V ;
  simma_vb_1_V : V ;
  sippra_ut_vbm_1_V2 : V2 ;
  sjaelvsaa_sig_vbm_1_1_VR : V ;
  sjaapa_sig_vbm_1_1_VR : V ;
  skaffa_sig_vbm_1_VR : V ;
  skiffra_sig_vbm_1_VR : V ;
  skikta_sig_vbm_1_VR : V ;
  skilja_av_vbm_1_V2 : V2 ;
  skilja_sig_vbm_1_VR : V ;
  skilja_aat_vbm_1_1_V2 : V2 ;
  skimra_igenom_vbm_1_V2 : V2 ;
  skinna_sig_vbm_1_VR : V ;
  sko_sig_vbm_1_VR : V ;
  skocka_sig_vbm_1_VR : V ;
  skrifta_sig_vbm_1_VR : V ;
  skrota_sig_vbm_1_VR : V ;
  skruva_sig_vbm_1_VR : V ;
  skumma_av_vbm_1_V2 : V2 ;
  skaemma_ut_vbm_1_1_V2 : V2 ;
  skaerpa_sig_vbm_1_1_VR : V ;
  skoeta_sig_vbm_1_1_VR : V ;
  slappna_av_vbm_1_V2 : V2 ;
  sluka_vb_1_V : V ;
  slumpa_sig_vbm_1_VR : V ;
  slumra_in_vbm_1_V2 : V2 ;
  slumra_till_vbm_1_V2 : V2 ;
  slaenga_sig_vbm_1_1_VR : V ;
  slaenga_ut_vbm_1_1_V2 : V2 ;
  slaepa_efter_vbm_1_1_V2 : V2 ;
  slaeppa_sig_vbm_1_1_VR : V ;
  smula_sig_vbm_1_VR : V ;
  smussla_in_vbm_1_V2 : V2 ;
  snabba_paa_vbm_1_1_V2 : V2 ;
  snabba_sig_vbm_1_VR : V ;
  snoppa_av_vbm_1_V2 : V2 ;
  snaesa_av_vbm_1_1_V2 : V2 ;
  solidarisera_sig_vbm_1_VR : V ;
  sopa_till_vbm_1_V2 : V2 ;
  spela_vb_1_V : V ;
  spela_in_vbm_1_V2 : V2 ;
  spae_vb_1_1_V : V ;
  staka_sig_vbm_1_VR : V ;
  stocka_sig_vbm_1_VR : V ;
  straffa_sig_vbm_1_VR : V ;
  strypa_vb_1_V : V ;
  straecka_sig_vbm_1_1_VR : V ;
  stroemma_in_vbm_1_1_V2 : V2 ;
  stroemma_oever_vbm_1_1_V2 : V2 ;
  stupa_vb_1_V : V ;
  stygga_sig_vbm_1_VR : V ;
  staella_sig_vbm_1_1_VR : V ;
  stoeka_om_vbm_1_1_V2 : V2 ;
  stoeta_sig_vbm_1_1_VR : V ;
  svinga_sig_vbm_1_VR : V ;
  svaenga_sig_vbm_1_1_VR : V ;
  sy_in_vbm_1_V2 : V2 ;
  saella_sig_vbm_1_1_VR : V ;
  saenda_efter_vbm_1_1_V2 : V2 ;
  soeka_sig_vbm_1_1_VR : V ;
  tala_vb_1_V : V ;
  tala_om_vbm_1_V2 : V2 ;
  tillbringa_vb_1_V : V ;
  tillhandla_sig_vbm_1_VR : V ;
  tillkaempa_sig_vbm_1_1_VR : V ;
  tillskansa_sig_vbm_1_VR : V ;
  tilltvinga_sig_vbm_1_VR : V ;
  tillvaegabringa_vb_1_1_V : V ;
  tillvaella_sig_vbm_1_1_VR : V ;
  tillaegna_sig_vbm_1_1_VR : V ;
  tingsmeritera_sig_vbm_1_VR : V ;
  tjusa_vb_1_V : V ;
  tjaena_av_vbm_1_1_V2 : V2 ;
  tjaena_ut_vbm_1_1_V2 : V2 ;
  toka_sig_vbm_1_VR : V ;
  torrkoka_vb_1_V : V ;
  tova_sig_vbm_1_VR : V ;
  trilskna_till_vbm_1_V2 : V2 ;
  trubba_av_vbm_1_V2 : V2 ;
  trumpna_till_vbm_1_V2 : V2 ;
  trae_vb_1_1_V : V ;
  traenga_sig_vbm_1_1_VR : V ;
  troetta_ut_vbm_1_1_V2 : V2 ;
  tuva_sig_vbm_1_VR : V ;
  tvinga_vb_1_V : V ;
  tvaa_vb_1_1_V : V ;
  ty_sig_vbm_1_VR : V ;
  taenda_paa_vbm_1_1_V2 : V2 ;
  taenka_sig_vbm_1_1_VR : V ;
  taara_sig_vbm_1_1_VR : V ;
  ugnskoka_vb_1_V : V ;
  undanhaalla_sig_vbm_1_1_VR : V ;
  underbetala_vb_1_V : V ;
  underkasta_sig_vbm_1_VR : V ;
  undfalla_sig_vbm_1_VR : V ;
  undvara_vb_1_V : V ;
  upphaeva_vb_2_1_V : V ;
  uppoffra_sig_vbm_1_VR : V ;
  ursaekta_sig_vbm_1_1_VR : V ;
  utbetala_vb_1_V : V ;
  utbringa_vb_1_V : V ;
  utmaerka_sig_vbm_1_1_VR : V ;
  utspela_sig_vbm_1_VR : V ;
  uttala_sig_vbm_1_VR : V ;
  utveckla_sig_vbm_1_VR : V ;
  valsa_ut_vbm_1_V2 : V2 ;
  vara_sig_vbm_1_VR : V ;
  varkunna_sig_vbm_1_VR : V ;
  vassla_sig_vbm_1_VR : V ;
  vikta_sig_vbm_1_VR : V ;
  vila_ut_vbm_1_V2 : V2 ;
  vinda_av_vbm_1_V2 : V2 ;
  vira_in_vbm_1_V2 : V2 ;
  vira_om_vbm_1_V2 : V2 ;
  visa_in_vbm_1_V2 : V2 ;
  visa_sig_vbm_1_VR : V ;
  voja_sig_vbm_1_VR : V ;
  votera_ut_vbm_1_V2 : V2 ;
  vraeka_sig_vbm_1_1_VR : V ;
  vaeltra_av_vbm_1_1_V2 : V2 ;
  vaeltra_sig_vbm_1_1_VR : V ;
  vaelva_sig_vbm_1_1_VR : V ;
  vaenda_sig_vbm_1_1_VR : V ;
  vaenta_sig_vbm_1_1_VR : V ;
  vaenta_ut_vbm_1_1_V2 : V2 ;
  vaerma_paa_vbm_1_1_V2 : V2 ;
  vaetska_sig_vbm_1_1_VR : V ;
  vaexla_av_vbm_1_1_V2 : V2 ;
  vaexla_in_vbm_1_1_V2 : V2 ;
  vaaga_sig_vbm_1_1_VR : V ;
  ysta_sig_vbm_1_VR : V ;
  yttra_sig_vbm_1_VR : V ;
  yva_sig_vbm_1_VR : V ;
  yxa_till_vbm_1_V2 : V2 ;
  aegna_sig_vbm_1_1_VR : V ;
  aendra_sig_vbm_1_1_VR : V ;
  aengsla_sig_vbm_1_1_VR : V ;
  aerra_sig_vbm_1_1_VR : V ;
  aaberopa_sig_vbm_1_1_VR : V ;
  aabaeka_sig_vbm_1_1_VR : V ;
  aama_sig_vbm_1_1_VR : V ;
  aangkoka_vb_1_1_V : V ;
  aangra_sig_vbm_1_1_VR : V ;
  aaterbetala_vb_1_1_V : V ;
  aaterhaemta_sig_vbm_1_1_VR : V ;
  aavaegabringa_vb_1_1_V : V ;
  oedmjuka_sig_vbm_1_1_VR : V ;
  oegna_igenom_vbm_1_1_V2 : V2 ;
  oeka_paa_vbm_1_1_V2 : V2 ;
  oeka_till_vbm_1_1_V2 : V2 ;
  oemka_sig_vbm_1_1_VR : V ;
  oeverbringa_vb_1_1_V : V ;
  oeverila_sig_vbm_1_1_VR : V ;
  oevervara_vb_1_1_V : V ;
  oeverta_vb_1_1_V : V ;
  oeversaetta_vb_1_1_V : V ;
  oeverge_vb_1_1_V : V ;
  oeverdra_vb_1_1_V : V ;
  aatgaa_vb_1_1_V : V ;
  aateruppta_vb_1_1_V : V ;
  aateruppstaa_vb_1_1_V : V ;
  aaterta_vb_1_1_V : V ;
  aaterinsaetta_vb_1_1_V : V ;
  aatergaa_vb_1_1_V : V ;
  aaterge_vb_1_1_V : V ;
  aasaetta_vb_1_1_V : V ;
  aasidosaetta_vb_1_1_V : V ;
  aadra_vb_1_1_V : V ;
  vaaldta_vb_1_1_V : V ;
  vaerdesaetta_vb_1_1_V : V ;
  vaelta_vb_1_1_V : V ;
  vidta_vb_1_V : V ;
  vakantsaetta_vb_1_1_V : V ;
  vakanssaetta_vb_1_1_V : V ;
  utsaetta_vb_1_1_V : V ;
  utstaa_vb_1_1_V : V ;
  utroena_vb_1_1_V : V ;
  utgaa_vb_1_1_V : V ;
  utge_vb_1_V : V ;
  utfaesta_vb_1_1_V : V ;
  utdra_vb_1_V : V ;
  uppta_vb_1_V : V ;
  uppsaetta_vb_1_1_V : V ;
  uppstaa_vb_1_1_V : V ;
  uppgaa_vb_1_1_V : V ;
  uppge_vb_1_V : V ;
  uppdra_vb_1_V : V ;
  undsaetta_vb_1_1_V : V ;
  undergaa_vb_1_1_V : V ;
  undanta_vb_1_V : V ;
  taala_vb_1_1_V : V ;
  tonsaetta_vb_1_1_V : V ;
  tillvarata_vb_1_V : V ;
  tillta_vb_1_V : V ;
  tillsaetta_vb_1_1_V : V ;
  tillstaedja_vb_1_1_V : V ;
  tillspilloge_vb_1_V : V ;
  tillkaennage_vb_1_1_V : V ;
  tillge_vb_1_V : V ;
  tillfaangata_vb_1_1_V : V ;
  tidfaesta_vb_1_1_V : V ;
  ta_vb_1_V : V ;
  saetta_vb_1_1_V : V ;
  sysselsaetta_vb_1_1_V : V ;
  syrsaetta_vb_1_1_V : V ;
  staedja_vb_1_1_V : V ;
  strandsaetta_vb_1_1_V : V ;
  stjaela_vb_1_1_V : V ;
  stadfaesta_vb_1_1_V : V ;
  spraetta_vb_1_1_V : V ;
  smaetta_vb_1_1_V : V ;
  smaelta_vb_2_1_V : V ;
  smaksaetta_vb_1_1_V : V ;
  skvaetta_vb_2_1_V : V ;
  skuldsaetta_vb_1_1_V : V ;
  sjoesaetta_vb_1_1_V : V ;
  segdra_vb_1_V : V ;
  sammansaetta_vb_1_1_V : V ;
  sammansmaelta_vb_1_1_V : V ;
  sammangaa_vb_1_1_V : V ;
  sammandra_vb_1_V : V ;
  samgaa_vb_1_1_V : V ;
  roena_vb_1_1_V : V ;
  rollbesaetta_vb_1_1_V : V ;
  rista_vb_2_V : V ;
  paata_vb_1_1_V : V ;
  prissaetta_vb_1_1_V : V ;
  prisge_vb_1_V : V ;
  pantsaetta_vb_1_1_V : V ;
  ordinariesaetta_vb_1_1_V : V ;
  oppta_vb_1_V : V ;
  oppsaetta_vb_1_1_V : V ;
  oppge_vb_1_V : V ;
  omta_vb_1_V : V ;
  omsaetta_vb_1_1_V : V ;
  omhaenderta_vb_1_1_V : V ;
  omge_vb_1_V : V ;
  nersaetta_vb_1_1_V : V ;
  nedsaetta_vb_1_1_V : V ;
  namnge_vb_1_V : V ;
  namnfaesta_vb_1_1_V : V ;
  motta_vb_1_V : V ;
  mista_vb_1_V : V ;
  missta_vb_1_V : V ;
  medta_vb_1_V : V ;
  medge_vb_1_V : V ;
  lyfta_vb_1_V : V ;
  luftlandsaetta_vb_1_1_V : V ;
  ljudsaetta_vb_1_1_V : V ;
  landsaetta_vb_1_1_V : V ;
  lagfaesta_vb_1_1_V : V ;
  lagerkroena_vb_1_1_V : V ;
  kroena_vb_1_1_V : V ;
  kringgaa_vb_1_1_V : V ;
  korsfaesta_vb_1_1_V : V ;
  knaesaetta_vb_1_1_V : V ;
  kalldra_vb_1_V : V ;
  jordfaesta_vb_1_1_V : V ;
  istaandsaetta_vb_1_1_V : V ;
  iscensaetta_vb_1_1_V : V ;
  inta_vb_1_V : V ;
  insaetta_vb_1_1_V : V ;
  insmaelta_vb_1_1_V : V ;
  ingaa_vb_2_1_V : V ;
  inge_vb_1_V : V ;
  indra_vb_1_V : V ;
  ilandsaetta_vb_1_1_V : V ;
  igaangsaetta_vb_1_1_V : V ;
  igensaetta_vb_1_1_V : V ;
  ifraagasaetta_vb_1_1_V : V ;
  iaktta_vb_1_V : V ;
  hoetta_vb_1_1_V : V ;
  haardra_vb_1_1_V : V ;
  haarddra_vb_1_1_V : V ;
  hytta_vb_1_V : V ;
  hugfaesta_vb_1_1_V : V ;
  gaa_vb_1_1_V : V ;
  gravsaetta_vb_1_1_V : V ;
  godta_vb_1_V : V ;
  genta_vb_1_V : V ;
  genomgaa_vb_1_1_V : V ;
  ge_vb_1_V : V ;
  foerutsaetta_vb_1_1_V : V ;
  foerta_vb_1_1_V : V ;
  foersaetta_vb_1_1_V : V ;
  foersiggaa_vb_1_1_V : V ;
  foergaa_vb_1_1_V : V ;
  foereta_vb_1_1_V : V ;
  foeregaa_vb_1_1_V : V ;
  foerege_vb_1_1_V : V ;
  foeredra_vb_1_1_V : V ;
  foerdra_vb_1_1_V : V ;
  foerbigaa_vb_1_1_V : V ;
  faesta_vb_1_1_V : V ;
  fraanta_vb_1_1_V : V ;
  frita_vb_1_V : V ;
  frisaetta_vb_1_1_V : V ;
  frige_vb_1_V : V ;
  framgaa_vb_1_1_V : V ;
  fortsaetta_vb_1_1_V : V ;
  formge_vb_1_V : V ;
  fastta_vb_1_V : V ;
  fastsaetta_vb_1_1_V : V ;
  ersaetta_vb_1_1_V : V ;
  emotta_vb_1_V : V ;
  emotstaa_vb_1_1_V : V ;
  eftersaetta_vb_1_1_V : V ;
  efterge_vb_1_V : V ;
  edfaesta_vb_1_1_V : V ;
  dra_vb_1_V : V ;
  delta_vb_1_V : V ;
  delge_vb_1_V : V ;
  bysaetta_vb_1_1_V : V ;
  bryna_vb_1_V : V ;
  bortta_vb_1_V : V ;
  bisaetta_vb_1_1_V : V ;
  bidra_vb_1_V : V ;
  betygsaetta_vb_1_1_V : V ;
  betygssaetta_vb_1_1_V : V ;
  beta_vb_2_V : V ;
  besaetta_vb_1_1_V : V ;
  bestjaela_vb_1_1_V : V ;
  beslagta_vb_1_V : V ;
  bekroena_vb_1_1_V : V ;
  begaa_vb_1_1_V : V ;
  befaesta_vb_1_1_V : V ;
  bedra_vb_1_V : V ;
  avta_vb_1_V : V ;
  avsaetta_vb_1_1_V : V ;
  avgaa_vb_1_1_V : V ;
  avge_vb_1_V : V ;
  avdagata_vb_1_V : V ;
  anta_vb_1_V : V ;
  ansaetta_vb_1_1_V : V ;
  ange_vb_1_V : V ;
  andra_vb_1_V : V ;
  anfalla_vb_1_V : V ;
  anfoera_vb_1_1_V : V ;
  angripa_vb_1_V : V ;
  angaa_vb_1_1_V : V ;
  angoera_vb_1_1_V : V ;
  anhaalla_vb_1_1_V : V ;
  anknyta_vb_1_V : V ;
  anligga_vb_1_V : V ;
  anlaegga_vb_1_1_V : V ;
  anse_vb_1_V : V ;
  ansluta_vb_1_V : V ;
  anslaa_vb_1_1_V : V ;
  anstryka_vb_1_V : V ;
  anstaa_vb_1_1_V : V ;
  antraeda_vb_1_1_V : V ;
  antyda_vb_1_V : V ;
  avbinda_vb_1_V : V ;
  avbryta_vb_1_V : V ;
  avboeja_vb_1_1_V : V ;
  avboeja_vb_2_1_V : V ;
  avdriva_vb_1_V : V ;
  avfalla_vb_1_V : V ;
  avfoera_vb_1_1_V : V ;
  avgiftsbelaegga_vb_1_1_V : V ;
  avgoera_vb_1_1_V : V ;
  avhaalla_vb_1_1_V : V ;
  avhoera_vb_1_1_V : V ;
  avkaenna_vb_1_1_V : V ;
  avleda_vb_1_V : V ;
  avlida_vb_1_V : V ;
  avlaegga_vb_1_1_V : V ;
  avlaata_vb_1_1_V : V ;
  avnjuta_vb_1_V : V ;
  avreda_vb_1_V : V ;
  avrinna_vb_1_V : V ;
  avraada_vb_1_1_V : V ;
  avse_vb_1_V : V ;
  avsjunga_vb_1_V : V ;
  avskilja_vb_1_V : V ;
  avskjuta_vb_1_V : V ;
  avskriva_vb_1_V : V ;
  avskraeda_vb_1_1_V : V ;
  avskaera_vb_1_1_V : V ;
  avslita_vb_1_V : V ;
  avslaa_vb_1_1_V : V ;
  avsnoera_vb_1_1_V : V ;
  avstyra_vb_1_V : V ;
  avstaa_vb_1_1_V : V ;
  avstoera_vb_1_1_V : V ;
  avsaega_vb_1_1_V : V ;
  avtraeda_vb_1_1_V : V ;
  avvinna_vb_1_V : V ;
  avvaenja_vb_1_1_V : V ;
  avvaerja_vb_1_1_V : V ;
  avaeta_vb_1_1_V : V ;
  bakbinda_vb_1_V : V ;
  be_vb_1_V : V ;
  bedriva_vb_1_V : V ;
  befara_vb_2_V : V ;
  begjuta_vb_1_V : V ;
  begripa_vb_1_V : V ;
  begraata_vb_1_1_V : V ;
  begynna_vb_1_V : V ;
  begaera_vb_1_1_V : V ;
  behaalla_vb_1_1_V : V ;
  bekantgoera_vb_1_1_V : V ;
  beknipa_vb_1_V : V ;
  bekomma_vb_1_V : V ;
  bekaenna_vb_1_1_V : V ;
  bele_vb_1_V : V ;
  beljuga_vb_1_V : V ;
  belaegga_vb_1_1_V : V ;
  bepryda_vb_1_V : V ;
  bereda_vb_1_V : V ;
  beroera_vb_1_1_V : V ;
  bese_vb_1_V : V ;
  besitta_vb_1_V : V ;
  besjunga_vb_1_V : V ;
  beskjuta_vb_1_V : V ;
  beskriva_vb_1_V : V ;
  beskaera_vb_1_1_V : V ;
  beskaera_vb_2_1_V : V ;
  beslaglaegga_vb_1_1_V : V ;
  beslaa_vb_1_1_V : V ;
  besmoerja_vb_1_1_V : V ;
  besticka_vb_1_V : V ;
  bestiga_vb_1_V : V ;
  bestryka_vb_1_V : V ;
  bestyra_vb_1_V : V ;
  bestaa_vb_1_1_V : V ;
  bestaa_vb_2_1_V : V ;
  besoerja_vb_1_1_V : V ;
  betraeda_vb_1_1_V : V ;
  betyda_vb_1_V : V ;
  bibehaalla_vb_1_1_V : V ;
  bifalla_vb_1_V : V ;
  bilaegga_vb_1_1_V : V ;
  binda_vb_1_V : V ;
  bispringa_vb_1_V : V ;
  bistaa_vb_1_1_V : V ;
  bita_vb_1_V : V ;
  bitraeda_vb_1_1_V : V ;
  bjuda_vb_1_V : V ;
  bli_vb_1_V : V ;
  blottlaegga_vb_1_1_V : V ;
  blaakoera_vb_1_1_V : V ;
  blaaljuga_vb_1_1_V : V ;
  bloeda_vb_1_1_V : V ;
  bloetlaegga_vb_1_1_V : V ;
  bokfoera_vb_1_1_V : V ;
  bordlaegga_vb_1_1_V : V ;
  bortdriva_vb_1_V : V ;
  bortfalla_vb_1_V : V ;
  bortfoera_vb_1_1_V : V ;
  bortgaa_vb_1_1_V : V ;
  bortrinna_vb_1_V : V ;
  bortse_vb_1_V : V ;
  bortskraemma_vb_1_1_V : V ;
  bortsluta_vb_1_V : V ;
  brinna_vb_1_V : V ;
  brinna_vb_2_V : V ;
  brista_vb_1_V : V ;
  brista_vb_2_V : V ;
  brolaegga_vb_1_1_V : V ;
  brukslaa_vb_1_1_V : V ;
  bryta_vb_1_V : V ;
  braedbeslaa_vb_1_1_V : V ;
  braedslaa_vb_1_1_V : V ;
  braenna_vb_1_1_V : V ;
  baera_vb_1_1_V : V ;
  boeja_vb_1_1_V : V ;
  boenfalla_vb_1_1_V : V ;
  boenhoera_vb_1_1_V : V ;
  boera_vb_1_1_V : V ;
  dammsuga_vb_1_V : V ;
  diariefoera_vb_1_1_V : V ;
  dimpa_vb_1_V : V ;
  dricka_vb_1_V : V ;
  driva_vb_1_V : V ;
  droeja_vb_1_1_V : V ;
  doe_vb_1_1_V : V ;
  doelja_vb_1_1_V : V ;
  efterfoelja_vb_1_1_V : V ;
  eftergoera_vb_1_1_V : V ;
  efterhaalla_vb_1_1_V : V ;
  efterhoera_vb_1_1_V : V ;
  efterlaata_vb_1_1_V : V ;
  efterse_vb_1_V : V ;
  eftersaega_vb_1_1_V : V ;
  eftertraeda_vb_1_1_V : V ;
  emotse_vb_1_V : V ;
  enkelskriva_vb_1_V : V ;
  erbjuda_vb_1_V : V ;
  erfara_vb_1_V : V ;
  erhaalla_vb_1_1_V : V ;
  erkaenna_vb_1_1_V : V ;
  erlaegga_vb_1_1_V : V ;
  falla_vb_1_V : V ;
  fara_vb_1_V : V ;
  fastgoera_vb_1_1_V : V ;
  fasthaalla_vb_1_1_V : V ;
  fastlaegga_vb_1_1_V : V ;
  fastslaa_vb_1_1_V : V ;
  finbraenna_vb_1_1_V : V ;
  finna_vb_1_V : V ;
  flyga_vb_1_V : V ;
  flyta_vb_1_V : V ;
  fogstryka_vb_1_V : V ;
  formgjuta_vb_1_V : V ;
  fortbestaa_vb_1_1_V : V ;
  fortfara_vb_1_V : V ;
  fortgaa_vb_1_1_V : V ;
  fortskrida_vb_1_V : V ;
  frambryta_vb_1_V : V ;
  frambaera_vb_1_1_V : V ;
  framdriva_vb_1_V : V ;
  framfara_vb_1_V : V ;
  framfoeda_vb_1_1_V : V ;
  framfoera_vb_1_1_V : V ;
  framhaalla_vb_1_1_V : V ;
  framlida_vb_1_V : V ;
  framlaegga_vb_1_1_V : V ;
  framskina_vb_1_V : V ;
  framskjuta_vb_1_V : V ;
  framskrida_vb_1_V : V ;
  framstaa_vb_1_1_V : V ;
  framsaega_vb_1_1_V : V ;
  framtraeda_vb_1_1_V : V ;
  frigoera_vb_1_1_V : V ;
  frikaenna_vb_1_1_V : V ;
  frilaegga_vb_1_1_V : V ;
  friskskriva_vb_1_V : V ;
  fryna_vb_1_V : V ;
  fraangaa_vb_1_1_V : V ;
  fraankaenna_vb_1_1_V : V ;
  fraanse_vb_1_1_V : V ;
  fraanskilja_vb_1_1_V : V ;
  fraantraeda_vb_1_1_V : V ;
  fullfoelja_vb_1_1_V : V ;
  fullgoera_vb_1_1_V : V ;
  faerglaegga_vb_1_1_V : V ;
  faa_vb_1_1_V : V ;
  foeda_vb_1_1_V : V ;
  foelja_vb_1_1_V : V ;
  foera_vb_1_1_V : V ;
  foeranleda_vb_1_1_V : V ;
  foeranlaata_vb_1_1_V : V ;
  foerbehaalla_vb_1_1_V : V ;
  foerbereda_vb_1_1_V : V ;
  foerbinda_vb_1_1_V : V ;
  foerbise_vb_1_1_V : V ;
  foerbjuda_vb_1_1_V : V ;
  foerbli_vb_1_1_V : V ;
  foerbloeda_vb_1_1_V : V ;
  foerbrinna_vb_1_1_V : V ;
  foerbraenna_vb_1_1_V : V ;
  foerdriva_vb_1_1_V : V ;
  foerdroeja_vb_1_1_V : V ;
  foerdoelja_vb_1_1_V : V ;
  foerebaera_vb_1_1_V : V ;
  foerefalla_vb_1_1_V : V ;
  foeregripa_vb_1_1_V : V ;
  foerehaalla_vb_1_1_V : V ;
  foereligga_vb_1_1_V : V ;
  foerelaegga_vb_1_1_V : V ;
  foereskriva_vb_1_1_V : V ;
  foereslaa_vb_1_1_V : V ;
  foerestaa_vb_1_1_V : V ;
  foerete_vb_1_1_V : V ;
  foeretraeda_vb_1_1_V : V ;
  foerfalla_vb_1_1_V : V ;
  foerfara_vb_1_1_V : V ;
  foerflyta_vb_1_1_V : V ;
  foerfoelja_vb_1_1_V : V ;
  foerfoera_vb_1_1_V : V ;
  foergaeta_vb_1_1_V : V ;
  foergoera_vb_1_1_V : V ;
  foerhyda_vb_1_1_V : V ;
  foerhyra_vb_1_1_V : V ;
  foerhaalla_vb_1_1_V : V ;
  foerhoeja_vb_1_1_V : V ;
  foerhoera_vb_1_1_V : V ;
  foerleda_vb_1_1_V : V ;
  foerlida_vb_1_1_V : V ;
  foerlaegga_vb_1_1_V : V ;
  foerlaata_vb_1_1_V : V ;
  foernoeja_vb_1_1_V : V ;
  foerrinna_vb_1_1_V : V ;
  foerraada_vb_1_1_V : V ;
  foersitta_vb_1_1_V : V ;
  foersjunka_vb_1_1_V : V ;
  foerskjuta_vb_1_1_V : V ;
  foerskriva_vb_1_1_V : V ;
  foerskaera_vb_1_1_V : V ;
  foerslita_vb_1_1_V : V ;
  foersluta_vb_1_1_V : V ;
  foerslaa_vb_1_1_V : V ;
  foerspoerja_vb_1_1_V : V ;
  foerstaa_vb_1_1_V : V ;
  foerstoera_vb_1_1_V : V ;
  foersvinna_vb_1_1_V : V ;
  foersaelja_vb_1_1_V : V ;
  foersoerja_vb_1_1_V : V ;
  foertiga_vb_1_1_V : V ;
  foertryta_vb_1_1_V : V ;
  foertaera_vb_1_1_V : V ;
  foertoeja_vb_1_1_V : V ;
  foerutse_vb_1_1_V : V ;
  foerutsaega_vb_1_1_V : V ;
  foervrida_vb_1_1_V : V ;
  foeryngringsbeskaera_vb_1_1_V : V ;
  foeroeda_vb_1_1_V : V ;
  gallskrika_vb_1_V : V ;
  galltjuta_vb_1_V : V ;
  gendriva_vb_1_V : V ;
  genljuda_vb_1_V : V ;
  genombryta_vb_1_V : V ;
  genomdriva_vb_1_V : V ;
  genomfara_vb_1_V : V ;
  genomfoera_vb_1_1_V : V ;
  genomlida_vb_1_V : V ;
  genomskoelja_vb_1_1_V : V ;
  genskjuta_vb_1_V : V ;
  gitta_vb_1_V : V ;
  gjuta_vb_1_V : V ;
  glida_vb_1_V : V ;
  gloeda_vb_1_1_V : V ;
  gnida_vb_1_V : V ;
  godkaenna_vb_1_1_V : V ;
  gottgoera_vb_1_1_V : V ;
  gottskriva_vb_1_V : V ;
  granatbeskjuta_vb_1_V : V ;
  gravlaegga_vb_1_1_V : V ;
  gripa_vb_1_V : V ;
  grundlaegga_vb_1_1_V : V ;
  graata_vb_1_1_V : V ;
  gudomliggoera_vb_1_1_V : V ;
  goeda_vb_1_1_V : V ;
  goera_vb_1_1_V : V ;
  halshugga_vb_1_V : V ;
  halvsova_vb_1_V : V ;
  halvspringa_vb_1_V : V ;
  handleda_vb_1_V : V ;
  handlaegga_vb_1_1_V : V ;
  hembjuda_vb_1_V : V ;
  hembaera_vb_1_1_V : V ;
  hemfalla_vb_1_V : V ;
  hemfoera_vb_1_1_V : V ;
  hemlighaalla_vb_1_1_V : V ;
  hinna_vb_1_V : V ;
  hopknyta_vb_1_V : V ;
  hopskjuta_vb_1_V : V ;
  hovniga_vb_1_V : V ;
  hugga_vb_1_V : V ;
  hugga_vb_2_V : V ;
  hyra_vb_1_V : V ;
  haenfoera_vb_1_1_V : V ;
  haenskjuta_vb_1_1_V : V ;
  haentyda_vb_1_1_V : V ;
  haerflyta_vb_1_1_V : V ;
  haerleda_vb_1_1_V : V ;
  haalla_vb_1_1_V : V ;
  haalslaa_vb_1_1_V : V ;
  haanle_vb_1_1_V : V ;
  haardloeda_vb_1_1_V : V ;
  hoegtidlighaalla_vb_1_1_V : V ;
  hoeja_vb_1_1_V : V ;
  hoelja_vb_1_1_V : V ;
  hoera_vb_1_1_V : V ;
  hoeta_vb_1_1_V : V ;
  igenkaenna_vb_1_1_V : V ;
  illtjuta_vb_1_V : V ;
  inbegripa_vb_1_V : V ;
  inbjuda_vb_1_V : V ;
  indriva_vb_1_V : V ;
  infalla_vb_1_V : V ;
  inflyta_vb_1_V : V ;
  infoera_vb_1_1_V : V ;
  ingjuta_vb_1_V : V ;
  ingripa_vb_1_V : V ;
  ingaa_vb_1_1_V : V ;
  inleda_vb_1_V : V ;
  inlaegga_vb_1_1_V : V ;
  inlaera_vb_1_1_V : V ;
  innebaera_vb_1_1_V : V ;
  innehaalla_vb_1_1_V : V ;
  innesluta_vb_1_V : V ;
  inreda_vb_1_V : V ;
  inse_vb_1_V : V ;
  inskjuta_vb_1_V : V ;
  inskrida_vb_1_V : V ;
  inskriva_vb_1_V : V ;
  insmyga_vb_1_V : V ;
  insuga_vb_1_V : V ;
  insupa_vb_1_V : V ;
  intraeda_vb_1_1_V : V ;
  invaelja_vb_1_1_V : V ;
  jordslaa_vb_1_1_V : V ;
  jaemfoera_vb_1_1_V : V ;
  kalhugga_vb_1_V : V ;
  kalkslaa_vb_1_1_V : V ;
  kallroera_vb_1_1_V : V ;
  kallsmida_vb_1_V : V ;
  kalaeta_vb_1_1_V : V ;
  kanthugga_vb_1_V : V ;
  kartlaegga_vb_1_1_V : V ;
  klargoera_vb_1_1_V : V ;
  klarlaegga_vb_1_1_V : V ;
  klavbinda_vb_1_V : V ;
  kliva_vb_1_V : V ;
  knipa_vb_1_V : V ;
  knivhugga_vb_1_V : V ;
  knivskaera_vb_1_1_V : V ;
  knyta_vb_1_V : V ;
  knaeboeja_vb_1_1_V : V ;
  knaefalla_vb_1_1_V : V ;
  korsfoerhoera_vb_1_1_V : V ;
  korslaegga_vb_1_1_V : V ;
  kortsluta_vb_1_V : V ;
  kringraenna_vb_1_1_V : V ;
  kringskaera_vb_1_1_V : V ;
  krypa_vb_1_V : V ;
  krypkoera_vb_1_1_V : V ;
  kungoera_vb_1_1_V : V ;
  kvarbli_vb_1_V : V ;
  kvardroeja_vb_1_1_V : V ;
  kvarhaalla_vb_1_1_V : V ;
  kvarstaa_vb_1_1_V : V ;
  kvaelja_vb_1_1_V : V ;
  kyrkbokfoera_vb_1_1_V : V ;
  kyrkobokfoera_vb_1_1_V : V ;
  kyrkskriva_vb_1_V : V ;
  kaenna_vb_1_1_V : V ;
  kaenna_vb_2_1_V : V ;
  koepslaa_vb_1_1_V : V ;
  koera_vb_1_1_V : V ;
  lagerfoera_vb_1_1_V : V ;
  lagfara_vb_1_V : V ;
  lagfoera_vb_1_1_V : V ;
  lamslaa_vb_1_1_V : V ;
  landstiga_vb_1_V : V ;
  le_vb_1_V : V ;
  leda_vb_1_V : V ;
  leja_vb_1_V : V ;
  levandegoera_vb_1_1_V : V ;
  licensbelaegga_vb_1_1_V : V ;
  lida_vb_1_V : V ;
  ligga_vb_1_V : V ;
  livnaera_vb_1_1_V : V ;
  ljuda_vb_1_V : V ;
  ljuga_vb_1_V : V ;
  lovsjunga_vb_1_V : V ;
  lyckliggoera_vb_1_1_V : V ;
  laegga_vb_1_1_V : V ;
  laera_vb_1_1_V : V ;
  laagflyga_vb_1_1_V : V ;
  laata_vb_1_1_V : V ;
  loesgoera_vb_1_1_V : V ;
  marknadsfoera_vb_1_1_V : V ;
  medfoelja_vb_1_1_V : V ;
  medfoera_vb_1_1_V : V ;
  medvetandegoera_vb_1_1_V : V ;
  minna_vb_1_V : V ;
  missfoerstaa_vb_1_1_V : V ;
  misskaenna_vb_1_1_V : V ;
  missleda_vb_1_V : V ;
  misspryda_vb_1_V : V ;
  misstyda_vb_1_V : V ;
  misstaenkliggoera_vb_1_1_V : V ;
  mjukgoera_vb_1_1_V : V ;
  moltiga_vb_1_V : V ;
  motse_vb_1_V : V ;
  motstaa_vb_1_1_V : V ;
  motsaega_vb_1_1_V : V ;
  maerkvaerdiggoera_vb_1_1_V : V ;
  moejliggoera_vb_1_1_V : V ;
  moerklaegga_vb_1_1_V : V ;
  nagelfara_vb_1_V : V ;
  nedbryta_vb_1_V : V ;
  nedgoera_vb_1_1_V : V ;
  nedlaegga_vb_1_1_V : V ;
  nedskriva_vb_1_V : V ;
  nedslaa_vb_1_1_V : V ;
  nedstiga_vb_1_V : V ;
  nerbryta_vb_1_V : V ;
  nergoera_vb_1_1_V : V ;
  nerlaegga_vb_1_1_V : V ;
  nerskriva_vb_1_V : V ;
  nerslaa_vb_1_1_V : V ;
  nerstiga_vb_1_V : V ;
  niga_vb_1_V : V ;
  njuta_vb_1_V : V ;
  nyanlaegga_vb_1_1_V : V ;
  nyttiggoera_vb_1_1_V : V ;
  naera_vb_1_1_V : V ;
  naersluta_vb_1_1_V : V ;
  offentliggoera_vb_1_1_V : V ;
  ombe_vb_1_V : V ;
  ombestyra_vb_1_V : V ;
  ombesoerja_vb_1_1_V : V ;
  ombryta_vb_1_V : V ;
  omfoera_vb_1_1_V : V ;
  omhoelja_vb_1_1_V : V ;
  omintetgoera_vb_1_1_V : V ;
  omkoera_vb_1_1_V : V ;
  omse_vb_1_V : V ;
  omskriva_vb_1_V : V ;
  omskaera_vb_1_1_V : V ;
  omsluta_vb_1_V : V ;
  omspinna_vb_1_V : V ;
  omspaenna_vb_1_1_V : V ;
  omvaelja_vb_1_1_V : V ;
  omoejliggoera_vb_1_1_V : V ;
  oppbaera_vb_1_1_V : V ;
  oppdriva_vb_1_V : V ;
  oppfinna_vb_1_V : V ;
  oppfoeda_vb_1_1_V : V ;
  opphoeja_vb_1_1_V : V ;
  opphoera_vb_1_1_V : V ;
  opplaegga_vb_1_1_V : V ;
  oppskjuta_vb_1_V : V ;
  oppsuga_vb_1_V : V ;
  oppaeta_vb_1_1_V : V ;
  oskadliggoera_vb_1_1_V : V ;
  osynliggoera_vb_1_1_V : V ;
  pantfoerskriva_vb_1_1_V : V ;
  pipa_vb_1_V : V ;
  planlaegga_vb_1_1_V : V ;
  ploeja_vb_1_1_V : V ;
  portfoerbjuda_vb_1_1_V : V ;
  premiaerkoera_vb_1_1_V : V ;
  presslaegga_vb_1_1_V : V ;
  promenadkoera_vb_1_1_V : V ;
  provkoera_vb_1_1_V : V ;
  provskjuta_vb_1_V : V ;
  pryda_vb_1_V : V ;
  pungslaa_vb_1_1_V : V ;
  pyra_vb_1_V : V ;
  paabjuda_vb_1_1_V : V ;
  paafoera_vb_1_1_V : V ;
  paagaa_vb_1_1_V : V ;
  paalaegga_vb_1_1_V : V ;
  paaloeda_vb_1_1_V : V ;
  paaminna_vb_1_1_V : V ;
  paanyttfoeda_vb_1_1_V : V ;
  paaskina_vb_1_1_V : V ;
  paastaa_vb_1_1_V : V ;
  reda_vb_1_V : V ;
  redogoera_vb_1_1_V : V ;
  rengoera_vb_1_1_V : V ;
  renskriva_vb_1_V : V ;
  rida_vb_1_V : V ;
  rinna_vb_1_V : V ;
  riva_vb_1_V : V ;
  rumphugga_vb_1_V : V ;
  rundsmoerja_vb_1_1_V : V ;
  ryta_vb_1_V : V ;
  raenna_vb_1_1_V : V ;
  raettfaerdiggoera_vb_1_1_V : V ;
  raada_vb_1_1_V : V ;
  raadfoera_vb_1_1_V : V ;
  raadgoera_vb_1_1_V : V ;
  raadlaegga_vb_1_1_V : V ;
  raadslaa_vb_1_1_V : V ;
  raariva_vb_1_1_V : V ;
  roeja_vb_1_1_V : V ;
  roeja_vb_2_1_V : V ;
  roera_vb_1_1_V : V ;
  salubjuda_vb_1_V : V ;
  salufoera_vb_1_1_V : V ;
  samkoera_vb_1_1_V : V ;
  sammanbinda_vb_1_V : V ;
  sammanfalla_vb_1_V : V ;
  sammanfoera_vb_1_1_V : V ;
  sammanhaalla_vb_1_1_V : V ;
  sammanlaegga_vb_1_1_V : V ;
  sammanskjuta_vb_1_V : V ;
  sammanskriva_vb_1_V : V ;
  sammanslaa_vb_1_1_V : V ;
  sammantraeda_vb_1_1_V : V ;
  samraada_vb_1_1_V : V ;
  se_vb_1_V : V ;
  segelflyga_vb_1_V : V ;
  sekretessbelaegga_vb_1_1_V : V ;
  senarelaegga_vb_1_1_V : V ;
  sitta_vb_1_V : V ;
  sjuda_vb_1_V : V ;
  sjukskriva_vb_1_V : V ;
  sjunga_vb_1_V : V ;
  sjunka_vb_1_V : V ;
  sjaelvdoe_vb_1_1_V : V ;
  skadskjuta_vb_1_V : V ;
  skambelaegga_vb_1_1_V : V ;
  skattlaegga_vb_1_1_V : V ;
  skattskriva_vb_1_V : V ;
  ske_vb_1_V : V ;
  skilja_vb_1_V : V ;
  skina_vb_1_V : V ;
  skita_vb_1_V : V ;
  skjuta_vb_1_V : V ;
  skrida_vb_1_V : V ;
  skrika_vb_1_V : V ;
  skrinlaegga_vb_1_1_V : V ;
  skriva_vb_1_V : V ;
  skryta_vb_1_V : V ;
  skraeda_vb_1_1_V : V ;
  skuldbelaegga_vb_1_1_V : V ;
  skaera_vb_1_1_V : V ;
  skaapsupa_vb_1_1_V : V ;
  skoelja_vb_1_1_V : V ;
  skoenja_vb_1_1_V : V ;
  slinka_vb_1_V : V ;
  slinta_vb_1_V : V ;
  slippa_vb_1_V : V ;
  slita_vb_1_V : V ;
  sluta_vb_3_V : V ;
  slutfoera_vb_1_1_V : V ;
  slaa_vb_1_1_V : V ;
  smida_vb_1_V : V ;
  smita_vb_1_V : V ;
  smyga_vb_1_V : V ;
  smygsupa_vb_1_V : V ;
  smygaeta_vb_1_1_V : V ;
  smaale_vb_1_1_V : V ;
  smaasjunga_vb_1_1_V : V ;
  smaasova_vb_1_1_V : V ;
  smaaspringa_vb_1_1_V : V ;
  smaasvaera_vb_1_1_V : V ;
  smoerja_vb_1_1_V : V ;
  snabbutreda_vb_1_V : V ;
  snedvrida_vb_1_V : V ;
  snyta_vb_1_V : V ;
  snaerja_vb_1_1_V : V ;
  snoera_vb_1_1_V : V ;
  sova_vb_1_V : V ;
  spinna_vb_1_V : V ;
  spricka_vb_1_V : V ;
  springa_vb_1_V : V ;
  spritta_vb_1_V : V ;
  spaenna_vb_1_1_V : V ;
  spoerja_vb_1_1_V : V ;
  sticka_vb_1_V : V ;
  sticka_vb_3_V : V ;
  stiga_vb_1_V : V ;
  stinka_vb_1_V : V ;
  storgraata_vb_1_1_V : V ;
  stryka_vb_1_V : V ;
  stryka_vb_2_V : V ;
  styra_vb_1_V : V ;
  staa_vb_1_1_V : V ;
  stoedja_vb_1_1_V : V ;
  stoera_vb_1_1_V : V ;
  stoertbloeda_vb_1_1_V : V ;
  suga_vb_1_V : V ;
  suga_vb_2_V : V ;
  supa_vb_1_V : V ;
  sveda_vb_1_V : V ;
  svida_vb_1_V : V ;
  svika_vb_1_V : V ;
  svinna_vb_1_V : V ;
  svaelja_vb_1_1_V : V ;
  svaelta_vb_1_1_V : V ;
  svaera_vb_1_1_V : V ;
  synliggoera_vb_1_1_V : V ;
  saega_vb_1_1_V : V ;
  saelja_vb_1_1_V : V ;
  saellskapsgraata_vb_1_1_V : V ;
  saellskapsaeta_vb_1_1_V : V ;
  saerskilja_vb_1_1_V : V ;
  soendagskoera_vb_1_1_V : V ;
  soenderfalla_vb_1_1_V : V ;
  soenderriva_vb_1_1_V : V ;
  soerja_vb_1_1_V : V ;
  tabubelaegga_vb_1_1_V : V ;
  testflyga_vb_1_V : V ;
  testkoera_vb_1_1_V : V ;
  tidigarelaegga_vb_1_1_V : V ;
  tiga_vb_1_V : V ;
  tillbe_vb_1_V : V ;
  tillerkaenna_vb_1_1_V : V ;
  tillfalla_vb_1_V : V ;
  tillfoera_vb_1_1_V : V ;
  tillgodose_vb_1_V : V ;
  tillgripa_vb_1_V : V ;
  tillgaa_vb_1_1_V : V ;
  tillhandahaalla_vb_1_1_V : V ;
  tillhaalla_vb_1_1_V : V ;
  tillhoera_vb_1_1_V : V ;
  tillintetgoera_vb_1_1_V : V ;
  tillmoetesgaa_vb_1_1_V : V ;
  tillreda_vb_1_V : V ;
  tillryggalaegga_vb_1_1_V : V ;
  tillraettalaegga_vb_1_1_V : V ;
  tillraada_vb_1_1_V : V ;
  tillse_vb_1_V : V ;
  tillskjuta_vb_1_V : V ;
  tillskriva_vb_1_V : V ;
  tillskaera_vb_1_1_V : V ;
  tillsluta_vb_1_V : V ;
  tillstaa_vb_1_1_V : V ;
  tillsaega_vb_1_1_V : V ;
  tilltraeda_vb_1_1_V : V ;
  tillvaenja_vb_1_1_V : V ;
  tillaegga_vb_1_1_V : V ;
  tillaata_vb_1_1_V : V ;
  tjuta_vb_1_V : V ;
  tjuvhaalla_vb_1_1_V : V ;
  tjyvhaalla_vb_1_1_V : V ;
  tjaenstgoera_vb_1_1_V : V ;
  topphugga_vb_1_V : V ;
  topprida_vb_1_V : V ;
  torgfoera_vb_1_1_V : V ;
  torrlaegga_vb_1_1_V : V ;
  totalfoerbjuda_vb_1_1_V : V ;
  totalfoerstoera_vb_1_1_V : V ;
  trafikleda_vb_1_V : V ;
  trakthugga_vb_1_V : V ;
  trollbinda_vb_1_V : V ;
  tryta_vb_1_V : V ;
  traeda_vb_1_1_V : V ;
  traelbinda_vb_1_1_V : V ;
  tyda_vb_1_V : V ;
  tydliggoera_vb_1_1_V : V ;
  taelja_vb_1_1_V : V ;
  taemja_vb_1_1_V : V ;
  taenja_vb_1_1_V : V ;
  taera_vb_1_1_V : V ;
  toeja_vb_1_1_V : V ;
  umbaera_vb_1_1_V : V ;
  undanhaalla_vb_1_1_V : V ;
  undanroeja_vb_1_1_V : V ;
  undansticka_vb_1_V : V ;
  underbinda_vb_1_V : V ;
  underbjuda_vb_1_V : V ;
  underdriva_vb_1_V : V ;
  underfoerstaa_vb_1_1_V : V ;
  underhaalla_vb_1_1_V : V ;
  underkaenna_vb_1_1_V : V ;
  underlaata_vb_1_1_V : V ;
  underskrida_vb_1_V : V ;
  underslaa_vb_1_1_V : V ;
  understicka_vb_1_V : V ;
  understiga_vb_1_V : V ;
  understryka_vb_1_V : V ;
  understoedja_vb_1_1_V : V ;
  undersaelja_vb_1_1_V : V ;
  undfalla_vb_1_V : V ;
  undfaa_vb_1_1_V : V ;
  undgaa_vb_1_1_V : V ;
  undkomma_vb_1_V : V ;
  undslippa_vb_1_V : V ;
  undvika_vb_1_V : V ;
  uppbjuda_vb_1_V : V ;
  uppbaera_vb_1_1_V : V ;
  uppdriva_vb_1_V : V ;
  uppehaalla_vb_1_1_V : V ;
  uppfinna_vb_1_V : V ;
  uppfoeda_vb_1_1_V : V ;
  uppfoera_vb_1_1_V : V ;
  upphoeja_vb_1_1_V : V ;
  upphoera_vb_1_1_V : V ;
  upplaegga_vb_1_1_V : V ;
  upplaata_vb_1_1_V : V ;
  uppriva_vb_1_V : V ;
  uppraenna_vb_1_1_V : V ;
  uppraetthaalla_vb_1_1_V : V ;
  upproera_vb_1_1_V : V ;
  uppskjuta_vb_1_V : V ;
  uppspricka_vb_1_V : V ;
  uppstiga_vb_1_V : V ;
  uppsuga_vb_1_V : V ;
  upptraeda_vb_1_1_V : V ;
  uppaeta_vb_1_1_V : V ;
  uraktlaata_vb_1_1_V : V ;
  urskilja_vb_1_V : V ;
  urskoenja_vb_1_1_V : V ;
  uruppfoera_vb_1_1_V : V ;
  utbjuda_vb_1_V : V ;
  utbrista_vb_1_V : V ;
  utbryta_vb_1_V : V ;
  utdriva_vb_1_V : V ;
  utebli_vb_1_V : V ;
  utesluta_vb_1_V : V ;
  utfalla_vb_1_V : V ;
  utfaa_vb_1_1_V : V ;
  utfoera_vb_1_1_V : V ;
  utfoersaelja_vb_1_1_V : V ;
  utgjuta_vb_1_V : V ;
  utgoera_vb_1_1_V : V ;
  uthyra_vb_1_V : V ;
  utklyva_vb_1_V : V ;
  utlaegga_vb_1_1_V : V ;
  utreda_vb_1_V : V ;
  utse_vb_1_V : V ;
  utskilja_vb_1_V : V ;
  utskriva_vb_1_V : V ;
  utsuga_vb_1_V : V ;
  utsaega_vb_1_1_V : V ;
  uttraeda_vb_1_1_V : V ;
  uttyda_vb_1_V : V ;
  uttaenja_vb_1_1_V : V ;
  utvinna_vb_1_V : V ;
  utvaelja_vb_1_1_V : V ;
  vanpryda_vb_1_V : V ;
  vanstyra_vb_1_V : V ;
  varmkoera_vb_1_1_V : V ;
  varsebli_vb_1_V : V ;
  vassgoera_vb_1_1_V : V ;
  vederlaegga_vb_1_1_V : V ;
  verkliggoera_vb_1_1_V : V ;
  vetta_vb_1_V : V ;
  vidbraenna_vb_1_1_V : V ;
  vidgaa_vb_1_1_V : V ;
  vidhaalla_vb_1_1_V : V ;
  vidkomma_vb_1_V : V ;
  vidlaada_vb_1_1_V : V ;
  vidmakthaalla_vb_1_1_V : V ;
  vidroera_vb_1_1_V : V ;
  villfara_vb_1_V : V ;
  vilsefoera_vb_1_1_V : V ;
  vilseleda_vb_1_V : V ;
  vina_vb_1_V : V ;
  vinna_vb_1_V : V ;
  vintervaeghaalla_vb_1_1_V : V ;
  vrida_vb_1_V : V ;
  vaegleda_vb_1_1_V : V ;
  vaeja_vb_1_1_V : V ;
  vaelja_vb_1_1_V : V ;
  vaemja_vb_1_1_V : V ;
  vaenja_vb_1_1_V : V ;
  vaerja_vb_1_1_V : V ;
  vaagfoera_vb_1_1_V : V ;
  vaaldfoera_vb_1_1_V : V ;
  yra_vb_2_V : V ;
  aeta_vb_1_1_V : V ;
  aadagalaegga_vb_1_1_V : V ;
  aaderlaata_vb_1_1_V : V ;
  aahoera_vb_1_1_V : V ;
  aaligga_vb_1_1_V : V ;
  aalaegga_vb_1_1_V : V ;
  aase_vb_1_1_V : V ;
  aaskaadliggoera_vb_1_1_V : V ;
  aaterfalla_vb_1_1_V : V ;
  aaterfinna_vb_1_1_V : V ;
  aaterfaa_vb_1_1_V : V ;
  aaterfoera_vb_1_1_V : V ;
  aaterfoersluta_vb_1_1_V : V ;
  aaterfoersaelja_vb_1_1_V : V ;
  aaterhaalla_vb_1_1_V : V ;
  aaterinfoera_vb_1_1_V : V ;
  aaterknyta_vb_1_1_V : V ;
  aaterse_vb_1_1_V : V ;
  aaterstaa_vb_1_1_V : V ;
  aatersaelja_vb_1_1_V : V ;
  aatervinna_vb_1_1_V : V ;
  aatervaelja_vb_1_1_V : V ;
  aatfoelja_vb_1_1_V : V ;
  aatnjuta_vb_1_1_V : V ;
  aatskilja_vb_1_1_V : V ;
  oeda_vb_1_1_V : V ;
  oedelaegga_vb_1_1_V : V ;
  oeverbelaegga_vb_1_1_V : V ;
  oeverbjuda_vb_1_1_V : V ;
  oeverdriva_vb_1_1_V : V ;
  oeverfalla_vb_1_1_V : V ;
  oeverflyga_vb_1_1_V : V ;
  oeverfoera_vb_1_1_V : V ;
  oevergaa_vb_1_1_V : V ;
  oevergoeda_vb_1_1_V : V ;
  oeverhoelja_vb_1_1_V : V ;
  oeverlaegga_vb_1_1_V : V ;
  oeverlaata_vb_1_1_V : V ;
  oeverse_vb_1_1_V : V ;
  oeverskrida_vb_1_1_V : V ;
  oeverskoelja_vb_1_1_V : V ;
  oeverstiga_vb_1_1_V : V ;
  oevertraeda_vb_1_1_V : V ;
  oevervinna_vb_1_1_V : V ;
  oevningskoera_vb_1_1_V : V ;
  foerevara_vb_1_1_V : V ;
  K_maerka_vb_1_1_V : V ;
  KU_anmaela_vb_1_1_V : V ;
  accelerera_vb_1_V : V ;
  agera_vb_1_V : V ;
  akta_vb_1_V : V ;
  alstra_vb_1_V : V ;
  anbefalla_vb_1_V : V ;
  anbelanga_vb_1_V : V ;
  anfraeta_vb_1_1_V : V ;
  anfoertro_vb_1_1_V : V ;
  angla_vb_1_V : V ;
  angraensa_vb_1_1_V : V ;
  anlaenda_vb_1_1_V : V ;
  anloepa_vb_1_1_V : V ;
  anmaela_vb_1_1_V : V ;
  anmaerka_vb_1_1_V : V ;
  anstraenga_vb_1_1_V : V ;
  anstaella_vb_1_1_V : V ;
  ansvara_vb_1_V : V ;
  ansvaella_vb_1_1_V : V ;
  ansoeka_vb_1_1_V : V ;
  antaenda_vb_1_1_V : V ;
  anvaenda_vb_1_1_V : V ;
  arbeta_av_vbm_1_V2 : V2 ;
  artbestaemma_vb_1_1_V : V ;
  asa_vb_1_V : V ;
  asgarva_vb_1_V : V ;
  avbestaella_vb_1_1_V : V ;
  avblaasa_vb_1_1_V : V ;
  avdaemma_vb_1_1_V : V ;
  avdoema_vb_1_1_V : V ;
  avhjaelpa_vb_1_1_V : V ;
  avhysa_vb_1_V : V ;
  avhaenda_vb_1_1_V : V ;
  avhaenga_vb_1_1_V : V ;
  avkasta_vb_1_V : V ;
  avklara_vb_1_V : V ;
  avkraeva_vb_1_1_V : V ;
  avkyla_vb_1_V : V ;
  avlysa_vb_1_V : V ;
  avlaesa_vb_1_1_V : V ;
  avloepa_vb_1_1_V : V ;
  avloesa_vb_1_1_V : V ;
  avmaeta_vb_1_1_V : V ;
  avmoenstra_vb_1_1_V : V ;
  avresa_vb_1_V : V ;
  avskava_vb_1_V : V ;
  avskraecka_vb_1_1_V : V ;
  avsky_vb_1_V : V ;
  avstyrka_vb_1_V : V ;
  avstaella_vb_1_1_V : V ;
  avstaemma_vb_1_1_V : V ;
  avstaenga_vb_1_1_V : V ;
  avstoeta_vb_1_1_V : V ;
  avsvimma_vb_1_V : V ;
  avsaenda_vb_1_1_V : V ;
  avsoeka_vb_1_1_V : V ;
  avtorka_vb_1_V : V ;
  avtaecka_vb_1_1_V : V ;
  avvaega_vb_1_1_V : V ;
  avvaenda_vb_1_1_V : V ;
  babbla_vb_1_V : V ;
  balansera_vb_1_V : V ;
  bannlysa_vb_1_V : V ;
  banta_vb_1_V : V ;
  barka_vb_2_V : V ;
  basa_vb_1_V : V ;
  basuna_ut_vbm_1_V2 : V2 ;
  basunera_ut_vbm_1_V2 : V2 ;
  baxna_vb_1_V : V ;
  bebo_vb_1_V : V ;
  bebygga_vb_1_V : V ;
  bedoema_vb_1_1_V : V ;
  befalla_vb_1_V : V ;
  beglaensa_vb_1_1_V : V ;
  behaga_vb_1_V : V ;
  behaenga_vb_1_1_V : V ;
  behoeva_vb_1_1_V : V ;
  belanga_vb_1_V : V ;
  belysa_vb_1_V : V ;
  bemaenga_vb_1_1_V : V ;
  bemaerka_vb_1_1_V : V ;
  bemoeta_vb_1_1_V : V ;
  benaemna_vb_1_1_V : V ;
  bero_vb_1_V : V ;
  beroemma_vb_1_1_V : V ;
  beskylla_vb_1_V : V ;
  bespara_vb_1_V : V ;
  besserwissra_vb_1_V : V ;
  bestroe_vb_1_1_V : V ;
  bestyrka_vb_1_V : V ;
  bestaella_vb_1_1_V : V ;
  bestaella_vb_2_1_V : V ;
  bestaemma_vb_1_1_V : V ;
  bestaenka_vb_1_1_V : V ;
  besaa_vb_1_1_V : V ;
  besoeka_vb_1_1_V : V ;
  beta_av_vbm_1_V2 : V2 ;
  betro_vb_1_V : V ;
  betrycka_vb_1_V : V ;
  betsla_av_vbm_1_V2 : V2 ;
  bettla_vb_1_V : V ;
  betaecka_vb_1_1_V : V ;
  betaenka_vb_1_1_V : V ;
  bevare_vb_1_V : V ;
  bila_vb_2_V : V ;
  bila_av_vbm_1_V2 : V2 ;
  bistraecka_vb_1_1_V : V ;
  bjaebba_vb_1_1_V : V ;
  bladdra_vb_1_V : V ;
  blaja_vb_1_V : V ;
  blanda_i_vbm_1_V2 : V2 ;
  blanda_in_vbm_1_V2 : V2 ;
  blanda_om_vbm_1_V2 : V2 ;
  blanda_ut_vbm_1_V2 : V2 ;
  blarra_vb_1_V : V ;
  blaska_vb_1_V : V ;
  blasta_av_vbm_1_V2 : V2 ;
  bleka_vb_1_V : V ;
  blicka_vb_1_V : V ;
  bliga_vb_1_V : V ;
  blinka_vb_1_V : V ;
  blippa_vb_1_V : V ;
  blixtra_vb_1_V : V ;
  blomma_vb_1_V : V ;
  blomstra_vb_1_V : V ;
  blossa_vb_1_V : V ;
  blota_vb_1_V : V ;
  bluddra_vb_1_V : V ;
  blunda_vb_1_V : V ;
  blaeddra_vb_1_1_V : V ;
  blaeddra_igenom_vbm_1_1_V2 : V2 ;
  blaenda_av_vbm_1_1_V2 : V2 ;
  blaenga_vb_1_1_V : V ;
  blaenka_vb_1_1_V : V ;
  blaestra_vb_1_1_V : V ;
  blaana_vb_1_1_V : V ;
  blaaneka_vb_1_1_V : V ;
  blaasa_vb_1_1_V : V ;
  blaasa_vb_2_1_V : V ;
  bloeta_vb_1_1_V : V ;
  bloetna_vb_1_1_V : V ;
  bo_vb_1_V : V ;
  bocka_foer_vbm_1_1_V2 : V2 ;
  bogsera_in_vbm_1_V2 : V2 ;
  bokna_vb_1_V : V ;
  bola_vb_1_V : V ;
  bolma_vb_1_V : V ;
  bomma_vb_2_V : V ;
  bomma_foer_vbm_1_1_V2 : V2 ;
  bomma_till_vbm_1_V2 : V2 ;
  booma_vb_1_V : V ;
  bornera_vb_1_V : V ;
  borsta_av_vbm_1_V2 : V2 ;
  bortarbeta_vb_1_V : V ;
  bortdomna_vb_1_V : V ;
  bortforsla_vb_1_V : V ;
  bortfoerklara_vb_1_1_V : V ;
  bortlova_vb_1_V : V ;
  bortmota_vb_1_V : V ;
  bortoperera_vb_1_V : V ;
  bortrationalisera_vb_1_V : V ;
  bortraekna_vb_1_1_V : V ;
  bortraenga_vb_1_1_V : V ;
  bortslumpa_vb_1_V : V ;
  borttappa_vb_1_V : V ;
  borttorka_vb_1_V : V ;
  bortvraeka_vb_1_1_V : V ;
  botanisera_vb_1_V : V ;
  bottenfrysa_vb_1_V : V ;
  bottna_vb_1_V : V ;
  bowla_vb_1_V : V ;
  braka_vb_1_V : V ;
  braska_vb_1_V : V ;
  bravera_vb_1_V : V ;
  bredsaa_vb_1_1_V : V ;
  briljera_vb_1_V : V ;
  bronsfoergylla_vb_1_1_V : V ;
  brossla_vb_1_V : V ;
  brottsutreda_vb_1_V : V ;
  bruckla_vb_1_V : V ;
  brumma_vb_1_V : V ;
  brusa_vb_1_V : V ;
  bry_vb_1_V : V ;
  brygga_vb_1_V : V ;
  brygga_oever_vbm_1_1_V2 : V2 ;
  braecka_vb_1_1_V : V ;
  braeka_vb_1_1_V : V ;
  braennmaerka_vb_1_1_V : V ;
  braadska_vb_1_1_V : V ;
  braaka_vb_1_1_V : V ;
  broela_vb_1_1_V : V ;
  broesta_av_vbm_1_1_V2 : V2 ;
  bua_vb_1_V : V ;
  bubbla_vb_1_V : V ;
  buffra_vb_1_V : V ;
  buga_vb_1_V : V ;
  bugga_vb_1_V : V ;
  bukta_vb_1_V : V ;
  buktala_vb_1_V : V ;
  bullra_vb_1_V : V ;
  bulna_vb_1_V : V ;
  bunkra_vb_1_V : V ;
  bura_in_vbm_1_V2 : V2 ;
  busa_vb_1_V : V ;
  buska_vb_2_V : V ;
  busringa_vb_1_V : V ;
  busvissla_vb_1_V : V ;
  bygga_vb_1_V : V ;
  byka_vb_1_V : V ;
  byta_vb_1_V : V ;
  baedda_in_vbm_1_1_V2 : V2 ;
  baedda_om_vbm_1_1_V2 : V2 ;
  baenda_vb_1_1_V : V ;
  baendsla_vb_1_1_V : V ;
  baensla_vb_1_1_V : V ;
  baersa_vb_1_1_V : V ;
  baeva_vb_1_1_V : V ;
  baada_vb_1_1_V : V ;
  baaga_vb_1_1_V : V ;
  baata_vb_1_1_V : V ;
  boeka_vb_1_1_V : V ;
  boela_vb_1_1_V : V ;
  boelja_vb_1_1_V : V ;
  boena_vb_1_1_V : V ;
  boesta_vb_1_1_V : V ;
  boetfaella_vb_1_1_V : V ;
  campa_vb_1_V : V ;
  changera_vb_1_V : V ;
  changsera_vb_1_V : V ;
  chansa_vb_1_V : V ;
  chansera_vb_1_V : V ;
  chatta_vb_1_V : V ;
  chefa_vb_1_V : V ;
  chilla_vb_1_V : V ;
  chimpa_vb_1_V : V ;
  cirkla_vb_1_V : V ;
  crawla_vb_1_V : V ;
  curla_vb_1_V : V ;
  dagdroemma_vb_1_1_V : V ;
  dagga_vb_1_V : V ;
  dagtinga_vb_1_V : V ;
  dala_vb_1_V : V ;
  dallra_vb_1_V : V ;
  dalta_vb_1_V : V ;
  damma_vb_1_V : V ;
  damma_av_vbm_1_V2 : V2 ;
  damma_till_vbm_1_V2 : V2 ;
  dampa_vb_2_V : V ;
  dangla_vb_1_V : V ;
  dansa_vb_1_V : V ;
  darra_vb_1_V : V ;
  dassa_vb_1_V : V ;
  datta_vb_1_V : V ;
  datummaerka_vb_1_1_V : V ;
  debutera_vb_1_V : V ;
  dega_vb_1_V : V ;
  dejsa_vb_1_V : V ;
  dela_ut_vbm_1_V2 : V2 ;
  deltidsarbeta_vb_1_V : V ;
  demonstrera_vb_2_V : V ;
  deppa_vb_1_V : V ;
  desertera_vb_1_V : V ;
  deviera_vb_1_V : V ;
  diagonala_vb_1_V : V ;
  dibbla_vb_1_V : V ;
  digna_vb_1_V : V ;
  dika_av_vbm_1_V2 : V2 ;
  dila_vb_1_V : V ;
  dilla_vb_1_V : V ;
  dinera_vb_1_V : V ;
  dingla_vb_1_V : V ;
  dippa_vb_2_V : V ;
  direktsaenda_vb_1_1_V : V ;
  dirka_vb_1_V : V ;
  dirra_vb_1_V : V ;
  diska_av_vbm_1_V2 : V2 ;
  dissonera_vb_1_V : V ;
  djupfrysa_vb_1_V : V ;
  djupna_vb_1_V : V ;
  doa_vb_1_V : V ;
  dobbla_vb_1_V : V ;
  docera_vb_1_V : V ;
  dofta_vb_1_V : V ;
  domdera_vb_1_V : V ;
  domfaella_vb_1_1_V : V ;
  domna_av_vbm_1_V2 : V2 ;
  dona_vb_1_V : V ;
  donka_vb_2_V : V ;
  dravla_vb_1_V : V ;
  dregla_vb_1_V : V ;
  drejvaenda_vb_1_1_V : V ;
  dribbla_vb_1_V : V ;
  droppa_vb_1_V : V ;
  drulla_vb_1_V : V ;
  drumla_vb_1_V : V ;
  dryga_ut_vbm_1_V2 : V2 ;
  draegla_vb_1_1_V : V ;
  draella_vb_1_1_V : V ;
  draemma_vb_1_1_V : V ;
  draenka_vb_1_1_V : V ;
  draepa_vb_1_1_V : V ;
  draasa_vb_1_1_V : V ;
  droemma_vb_1_1_V : V ;
  droena_vb_1_1_V : V ;
  ducka_vb_1_V : V ;
  duellera_vb_1_V : V ;
  dugga_vb_1_V : V ;
  duggregna_vb_1_V : V ;
  duka_av_vbm_1_V2 : V2 ;
  duna_vb_1_V : V ;
  dundra_vb_1_V : V ;
  dunsa_vb_1_V : V ;
  dunsta_vb_1_V : V ;
  durka_vb_1_V : V ;
  duska_vb_1_V : V ;
  duva_vb_1_V : V ;
  duvna_vb_1_V : V ;
  dyvla_paa_vbm_1_1_V2 : V2 ;
  daemma_vb_1_1_V : V ;
  daenga_vb_1_1_V : V ;
  daenka_vb_1_1_V : V ;
  daana_vb_1_1_V : V ;
  daasa_vb_1_1_V : V ;
  doema_vb_1_1_V : V ;
  doena_vb_1_1_V : V ;
  doepa_vb_1_1_V : V ;
  ebba_vb_1_V : V ;
  efteranmaela_vb_1_1_V : V ;
  efterleva_vb_1_V : V ;
  efterlysa_vb_1_V : V ;
  eftersinna_vb_1_V : V ;
  efterskaenka_vb_1_1_V : V ;
  eftersaenda_vb_1_1_V : V ;
  eftersoeka_vb_1_1_V : V ;
  eftertraa_vb_1_1_V : V ;
  egensvaenga_vb_1_1_V : V ;
  ejakulera_vb_1_V : V ;
  eka_vb_1_V : V ;
  eldvakta_vb_1_V : V ;
  emanera_vb_1_V : V ;
  enkla_vb_1_V : V ;
  erinra_vb_1_V : V ;
  ernaa_vb_1_1_V : V ;
  evangelisera_vb_1_V : V ;
  excellera_vb_1_V : V ;
  existera_vb_1_V : V ;
  experimentera_vb_1_V : V ;
  extraknaecka_vb_1_1_V : V ;
  extremkyla_vb_1_V : V ;
  fabla_vb_1_V : V ;
  falka_vb_1_V : V ;
  fallera_vb_1_V : V ;
  falsa_av_vbm_1_V2 : V2 ;
  famla_vb_1_V : V ;
  fasa_vb_2_V : V ;
  fasa_av_vbm_1_V2 : V2 ;
  fasa_ut_vbm_1_V2 : V2 ;
  fasta_vb_1_V : V ;
  fastna_vb_1_V : V ;
  faststaella_vb_1_1_V : V ;
  fatta_vb_2_V : V ;
  feja_av_vbm_1_V2 : V2 ;
  fela_vb_1_V : V ;
  felbedoema_vb_1_1_V : V ;
  festa_vb_1_V : V ;
  fetma_vb_1_V : V ;
  fetna_vb_1_V : V ;
  fiffla_vb_1_V : V ;
  figurera_vb_1_V : V ;
  fika_vb_1_V : V ;
  fila_av_vbm_1_V2 : V2 ;
  filosofera_vb_1_V : V ;
  filtrera_av_vbm_1_V2 : V2 ;
  fingra_vb_1_V : V ;
  fininstaella_vb_1_1_V : V ;
  fippla_vb_1_V : V ;
  fjanta_vb_1_V : V ;
  fjaedra_vb_1_1_V : V ;
  fjaella_av_vbm_1_1_V2 : V2 ;
  fjaellvandra_vb_1_1_V : V ;
  fjaerta_vb_1_1_V : V ;
  fjaeska_vb_1_1_V : V ;
  fjaettra_vb_1_1_V : V ;
  fjoela_vb_1_1_V : V ;
  flabba_vb_1_V : V ;
  flacka_vb_1_V : V ;
  fladdra_vb_1_V : V ;
  flaga_vb_1_V : V ;
  flamma_vb_1_V : V ;
  flamsa_vb_1_V : V ;
  flanera_vb_1_V : V ;
  flatskratta_vb_1_V : V ;
  flaxa_vb_1_V : V ;
  flexa_vb_1_V : V ;
  flexa_in_vbm_1_V2 : V2 ;
  flexa_ut_vbm_1_V2 : V2 ;
  flicka_in_vbm_1_V2 : V2 ;
  flika_in_vbm_1_V2 : V2 ;
  flimra_vb_1_V : V ;
  flina_vb_1_V : V ;
  flirta_vb_1_V : V ;
  florera_vb_1_V : V ;
  flukta_vb_1_V : V ;
  fluktuera_vb_1_V : V ;
  flumma_vb_1_V : V ;
  fluorescera_vb_1_V : V ;
  fly_vb_1_V : V ;
  flytta_ut_vbm_1_V2 : V2 ;
  flaeka_vb_1_1_V : V ;
  flaekta_vb_1_1_V : V ;
  flaemta_vb_1_1_V : V ;
  flaenga_vb_1_1_V : V ;
  flaenga_vb_2_1_V : V ;
  flaeska_paa_vbm_1_1_V2 : V2 ;
  flaeska_till_vbm_1_1_V2 : V2 ;
  flaa_vb_1_1_V : V ;
  flaasa_vb_1_1_V : V ;
  floeda_vb_1_1_V : V ;
  floejla_vb_1_1_V : V ;
  floerta_vb_1_1_V : V ;
  fnaska_vb_1_V : V ;
  fnatta_vb_1_V : V ;
  fnissa_vb_1_V : V ;
  fnittra_vb_1_V : V ;
  fodra_vb_1_V : V ;
  folkomroesta_vb_1_1_V : V ;
  fordra_vb_1_V : V ;
  forma_till_vbm_1_V2 : V2 ;
  forsa_vb_1_V : V ;
  forska_vb_1_V : V ;
  forska_igenom_vbm_1_V2 : V2 ;
  forsla_av_vbm_1_V2 : V2 ;
  forsla_in_vbm_1_V2 : V2 ;
  fortleva_vb_1_V : V ;
  fortloepa_vb_1_1_V : V ;
  fosforescera_vb_1_V : V ;
  fostra_vb_1_V : V ;
  fotvandra_vb_1_V : V ;
  fradga_vb_1_V : V ;
  framavla_vb_1_V : V ;
  framhaerda_vb_1_1_V : V ;
  framhaeva_vb_1_1_V : V ;
  framleva_vb_1_V : V ;
  framstaella_vb_1_1_V : V ;
  framtona_vb_1_V : V ;
  framtraenga_vb_1_1_V : V ;
  frasa_vb_1_V : V ;
  fraternisera_vb_1_V : V ;
  freaka_ut_vbm_1_V2 : V2 ;
  fridlysa_vb_1_V : V ;
  frika_ut_vbm_1_V2 : V2 ;
  frikoepa_vb_1_1_V : V ;
  frilansa_vb_1_V : V ;
  frimaerka_vb_1_1_V : V ;
  friska_vb_1_V : V ;
  friskanmaela_vb_1_1_V : V ;
  friskna_till_vbm_1_V2 : V2 ;
  frisksporta_vb_1_V : V ;
  frislaeppa_vb_1_1_V : V ;
  fristaella_vb_1_1_V : V ;
  fromla_vb_1_V : V ;
  frossa_vb_1_V : V ;
  frosta_av_vbm_1_V2 : V2 ;
  frosta_ur_vbm_1_V2 : V2 ;
  frukostera_vb_1_V : V ;
  frusa_vb_1_V : V ;
  frusta_vb_1_V : V ;
  fraelsa_vb_1_1_V : V ;
  fraesa_vb_1_1_V : V ;
  fraesa_vb_2_1_V : V ;
  fraeta_vb_1_1_V : V ;
  fraaga_ut_vbm_1_1_V2 : V2 ;
  fraandoema_vb_1_1_V : V ;
  froea_vb_1_1_V : V ;
  froejda_vb_1_1_V : V ;
  fullproppa_vb_1_V : V ;
  fumla_vb_1_V : V ;
  fundera_vb_1_V : V ;
  fundera_ut_vbm_1_V2 : V2 ;
  fungera_vb_1_V : V ;
  funka_vb_1_V : V ;
  funktionera_vb_1_V : V ;
  fuska_vb_1_V : V ;
  futta_vb_1_V : V ;
  fylla_vb_1_V : V ;
  fyllna_vb_1_V : V ;
  faekta_vb_1_1_V : V ;
  faella_vb_1_1_V : V ;
  faerdigjaesa_vb_1_1_V : V ;
  faerdigstaella_vb_1_1_V : V ;
  faanskratta_vb_1_1_V : V ;
  foela_vb_1_1_V : V ;
  foeranmaela_vb_1_1_V : V ;
  foerbygga_vb_1_1_V : V ;
  foerbyta_vb_1_1_V : V ;
  foerdaemma_vb_1_1_V : V ;
  foerdoema_vb_1_1_V : V ;
  foerebraa_vb_1_1_V : V ;
  foerebygga_vb_1_1_V : V ;
  foerelaesa_vb_1_1_V : V ;
  foerena_vb_1_1_V : V ;
  foerespaa_vb_1_1_V : V ;
  foerestaella_vb_1_1_V : V ;
  foeresvaeva_vb_1_1_V : V ;
  foerfoga_vb_1_1_V : V ;
  foergloemma_vb_1_1_V : V ;
  foergylla_vb_1_1_V : V ;
  foerhaerska_vb_1_1_V : V ;
  foerkrympa_vb_1_1_V : V ;
  foerkvaeva_vb_1_1_V : V ;
  foerlika_vb_1_1_V : V ;
  foerlisa_vb_1_1_V : V ;
  foerlaenga_vb_1_1_V : V ;
  foerloesa_vb_1_1_V : V ;
  foermaela_vb_1_1_V : V ;
  foermaerka_vb_1_1_V : V ;
  foermaa_vb_1_1_V : V ;
  foernoeta_vb_1_1_V : V ;
  foerortsbo_vb_1_1_V : V ;
  foerpassa_in_vbm_1_1_V2 : V2 ;
  foerrycka_vb_1_1_V : V ;
  foerskraecka_vb_1_1_V : V ;
  foerskylla_vb_1_1_V : V ;
  foersmaekta_vb_1_1_V : V ;
  foersmaa_vb_1_1_V : V ;
  foerspilla_vb_1_1_V : V ;
  foerstraecka_vb_1_1_V : V ;
  foerstroe_vb_1_1_V : V ;
  foerstaella_vb_1_1_V : V ;
  foerstaemma_vb_1_1_V : V ;
  foerstaerka_vb_1_1_V : V ;
  foersaenda_vb_1_1_V : V ;
  foersaenka_vb_1_1_V : V ;
  foersoeka_vb_1_1_V : V ;
  foertjusa_vb_1_1_V : V ;
  foertona_vb_1_1_V : V ;
  foertro_vb_1_1_V : V ;
  foertrycka_vb_1_1_V : V ;
  foertraenga_vb_1_1_V : V ;
  foertycka_vb_1_1_V : V ;
  foertaenka_vb_1_1_V : V ;
  foerundersoeka_vb_1_1_V : V ;
  foerutbestaemma_vb_1_1_V : V ;
  foerutspaa_vb_1_1_V : V ;
  foervraenga_vb_1_1_V : V ;
  foervaella_vb_1_1_V : V ;
  foervaenda_vb_1_1_V : V ;
  foervaervsarbeta_vb_1_1_V : V ;
  foesa_vb_1_1_V : V ;
  gaffla_vb_1_V : V ;
  gagga_vb_1_V : V ;
  gallra_ut_vbm_1_V2 : V2 ;
  galoppera_vb_1_V : V ;
  gama_vb_1_V : V ;
  gana_vb_2_V : V ;
  gapa_vb_1_V : V ;
  gapflabba_vb_1_V : V ;
  gapskratta_vb_1_V : V ;
  gasa_vb_1_V : V ;
  gassa_vb_1_V : V ;
  gasta_vb_1_V : V ;
  gastera_vb_1_V : V ;
  gegga_vb_1_V : V ;
  gena_vb_1_V : V ;
  genmaela_vb_1_1_V : V ;
  genomleva_vb_1_V : V ;
  genomlysa_vb_1_V : V ;
  genomsoeka_vb_1_1_V : V ;
  genomtraenga_vb_1_1_V : V ;
  genomtaenka_vb_1_1_V : V ;
  gestikulera_vb_1_V : V ;
  gigga_vb_1_V : V ;
  gilja_vb_1_V : V ;
  gina_vb_1_V : V ;
  gipa_vb_1_V : V ;
  gippa_vb_1_V : V ;
  gira_vb_1_V : V ;
  gissla_vb_1_V : V ;
  gistna_vb_1_V : V ;
  glamma_vb_1_V : V ;
  glana_vb_1_V : V ;
  glappa_vb_1_V : V ;
  glassa_vb_1_V : V ;
  glesbygdsbo_vb_1_V : V ;
  glimma_vb_1_V : V ;
  glimra_vb_1_V : V ;
  glimta_vb_1_V : V ;
  glindra_vb_1_V : V ;
  glipa_vb_1_V : V ;
  glisa_vb_1_V : V ;
  glittra_vb_1_V : V ;
  glo_vb_1_V : V ;
  glunka_vb_1_V : V ;
  glutta_vb_1_V : V ;
  glaefsa_vb_1_1_V : V ;
  glaensa_vb_1_1_V : V ;
  gloedsteka_vb_1_1_V : V ;
  gloedtaenda_vb_1_1_V : V ;
  gloegga_vb_1_1_V : V ;
  gloemma_vb_1_1_V : V ;
  gloeta_vb_1_1_V : V ;
  gnaga_vb_1_V : V ;
  gnata_vb_1_V : V ;
  gnava_vb_1_V : V ;
  gneta_vb_1_V : V ;
  gnissla_vb_1_V : V ;
  gnistra_vb_1_V : V ;
  gno_vb_1_V : V ;
  gnugga_av_vbm_1_V2 : V2 ;
  gnussa_vb_1_V : V ;
  gny_vb_1_V : V ;
  gnaegga_vb_1_1_V : V ;
  gnaella_vb_1_1_V : V ;
  gnoela_vb_1_1_V : V ;
  gola_vb_1_V : V ;
  golfa_vb_1_V : V ;
  gorma_vb_1_V : V ;
  gosa_vb_1_V : V ;
  grassera_vb_1_V : V ;
  gravitera_vb_1_V : V ;
  grensla_vb_1_V : V ;
  grimasera_vb_1_V : V ;
  grina_vb_1_V : V ;
  grisa_vb_1_V : V ;
  gro_vb_1_V : V ;
  grogga_vb_1_V : V ;
  grovna_vb_1_V : V ;
  grubbla_vb_1_V : V ;
  gruffa_vb_1_V : V ;
  grumla_vb_1_V : V ;
  grunda_vb_2_V : V ;
  grundstoeta_vb_1_1_V : V ;
  grunna_vb_1_V : V ;
  gruppsaa_vb_1_1_V : V ;
  gry_vb_1_V : V ;
  grymta_vb_1_V : V ;
  gryna_vb_1_V : V ;
  graela_vb_1_1_V : V ;
  graema_vb_1_1_V : V ;
  graensa_vb_1_1_V : V ;
  graensla_vb_1_1_V : V ;
  graesa_vb_1_1_V : V ;
  graeva_vb_1_1_V : V ;
  graeva_vb_2_1_V : V ;
  groengoedsla_vb_1_1_V : V ;
  groenska_vb_1_1_V : V ;
  groeta_vb_1_1_V : V ;
  gulla_vb_1_V : V ;
  gumpa_vb_1_V : V ;
  gunga_vb_1_V : V ;
  guppa_vb_1_V : V ;
  gurgla_vb_1_V : V ;
  gurgla_vb_2_V : V ;
  gyckla_vb_1_V : V ;
  gympa_vb_1_V : V ;
  gyttra_vb_1_V : V ;
  gaella_vb_1_1_V : V ;
  gaerdsla_vb_1_1_V : V ;
  gaespa_vb_1_1_V : V ;
  gaanga_vb_1_1_V : V ;
  goedsla_vb_1_1_V : V ;
  goemma_vb_1_1_V : V ;
  goerdla_vb_1_1_V : V ;
  hacka_av_vbm_1_V2 : V2 ;
  hafsa_vb_1_V : V ;
  hagla_vb_1_V : V ;
  hajka_vb_1_V : V ;
  haka_av_vbm_1_V2 : V2 ;
  haka_paa_vbm_1_1_V2 : V2 ;
  hala_ut_vbm_1_V2 : V2 ;
  halka_vb_1_V : V ;
  hallaaa_vb_1_1_V : V ;
  halstra_vb_1_V : V ;
  halta_vb_1_V : V ;
  halvnaecka_vb_1_1_V : V ;
  hamla_vb_1_V : V ;
  hamstra_vb_1_V : V ;
  handla_vb_1_V : V ;
  hanka_vb_1_V : V ;
  harkla_vb_1_V : V ;
  harmoniera_vb_1_V : V ;
  harskla_vb_1_V : V ;
  hasa_vb_1_V : V ;
  haspla_av_vbm_1_V2 : V2 ;
  hasta_vb_1_V : V ;
  hatta_vb_1_V : V ;
  hemstaella_vb_1_1_V : V ;
  hemsoeka_vb_1_1_V : V ;
  hesitera_vb_1_V : V ;
  hetta_vb_1_V : V ;
  hibernera_vb_1_V : V ;
  hicka_vb_1_V : V ;
  himla_vb_1_V : V ;
  hindra_vb_1_V : V ;
  hisna_vb_1_V : V ;
  hissna_vb_1_V : V ;
  hitta_paa_vbm_1_1_V2 : V2 ;
  hjula_vb_1_V : V ;
  hjaelpa_vb_1_1_V : V ;
  hjaelpe_vb_1_1_V : V ;
  hoa_vb_1_V : V ;
  hoja_vb_1_V : V ;
  hojta_vb_1_V : V ;
  hopknyckla_vb_1_V : V ;
  hopkoppla_vb_1_V : V ;
  hoppa_av_vbm_1_V2 : V2 ;
  hoppa_oever_vbm_1_1_V2 : V2 ;
  hora_vb_1_V : V ;
  hosta_vb_1_V : V ;
  hovra_vb_1_V : V ;
  hudflaenga_vb_1_1_V : V ;
  hulka_vb_1_V : V ;
  humma_vb_1_V : V ;
  hungerstrejka_vb_1_V : V ;
  hungra_vb_1_V : V ;
  hurra_vb_1_V : V ;
  husera_vb_1_V : V ;
  hushaalla_vb_1_1_V : V ;
  huta_vb_1_V : V ;
  huttla_vb_1_V : V ;
  huttra_vb_1_V : V ;
  hyckla_vb_1_V : V ;
  hyfsa_till_vbm_1_V2 : V2 ;
  hyla_vb_1_V : V ;
  hymla_vb_1_V : V ;
  hysa_vb_1_V : V ;
  hyvla_vb_1_V : V ;
  hyvla_av_vbm_1_V2 : V2 ;
  haecka_vb_1_1_V : V ;
  haeckla_vb_1_1_V : V ;
  haefta_in_vbm_1_1_V2 : V2 ;
  haefta_vid_vbm_1_1_V2 : V2 ;
  haegna_in_vbm_1_1_V2 : V2 ;
  haegra_vb_1_1_V : V ;
  haekta_av_vbm_1_1_V2 : V2 ;
  haella_vb_1_1_V : V ;
  haellregna_vb_1_1_V : V ;
  haelsa_paa_vbm_1_1_V2 : V2 ;
  haemma_vb_1_1_V : V ;
  haenda_vb_1_1_V : V ;
  haenga_vb_1_1_V : V ;
  haenga_vb_2_1_V : V ;
  haenrycka_vb_1_1_V : V ;
  haensyfta_vb_1_1_V : V ;
  haepna_vb_1_1_V : V ;
  haerda_ut_vbm_1_1_V2 : V2 ;
  haerska_vb_1_1_V : V ;
  haerstamma_vb_1_1_V : V ;
  haeva_vb_1_1_V : V ;
  haanflina_vb_1_1_V : V ;
  haangla_vb_1_1_V : V ;
  haanskratta_vb_1_1_V : V ;
  haardna_till_vbm_1_1_V2 : V2 ;
  haava_in_vbm_1_1_V2 : V2 ;
  hoefta_till_vbm_1_1_V2 : V2 ;
  hoesta_vb_1_1_V : V ;
  hoesta_in_vbm_1_1_V2 : V2 ;
  idissla_vb_1_V : V ;
  idrotta_vb_1_V : V ;
  ila_vb_1_V : V ;
  illudera_vb_1_V : V ;
  illvraala_vb_1_1_V : V ;
  ilskna_till_vbm_1_V2 : V2 ;
  imma_vb_1_V : V ;
  inblanda_vb_1_V : V ;
  inbygga_vb_1_V : V ;
  indraenka_vb_1_1_V : V ;
  inhysa_vb_1_V : V ;
  inhoesta_vb_1_1_V : V ;
  inkraekta_vb_1_1_V : V ;
  inkraeva_vb_1_1_V : V ;
  inkoepa_vb_1_1_V : V ;
  inloepa_vb_1_1_V : V ;
  inloesa_vb_1_1_V : V ;
  inmaenga_vb_1_1_V : V ;
  innestaenga_vb_1_1_V : V ;
  inoperera_vb_1_V : V ;
  inprogrammera_vb_1_V : V ;
  inrymma_vb_1_V : V ;
  inskraenka_vb_1_1_V : V ;
  inskaerpa_vb_1_1_V : V ;
  inspaerra_vb_1_1_V : V ;
  instunda_vb_1_V : V ;
  instaella_vb_1_1_V : V ;
  instaemma_vb_1_1_V : V ;
  instaemma_vb_2_1_V : V ;
  instaenga_vb_1_1_V : V ;
  insvepa_vb_1_V : V ;
  insaenda_vb_1_1_V : V ;
  intala_vb_1_V : V ;
  interagera_vb_1_V : V ;
  interferera_vb_1_V : V ;
  intrigera_vb_1_V : V ;
  intraenga_vb_1_1_V : V ;
  inverka_vb_1_V : V ;
  inviga_vb_1_V : V ;
  invintra_vb_1_V : V ;
  invaenda_vb_1_1_V : V ;
  invaeva_vb_1_1_V : V ;
  iordningstaella_vb_1_1_V : V ;
  irisera_vb_1_V : V ;
  ironisera_vb_1_V : V ;
  irra_vb_1_V : V ;
  isa_vb_1_V : V ;
  ivra_vb_1_V : V ;
  jaga_ut_vbm_1_V2 : V2 ;
  jama_vb_1_V : V ;
  jamma_vb_1_V : V ;
  jamsa_vb_1_V : V ;
  jassa_vb_1_V : V ;
  jazza_vb_1_V : V ;
  jiddra_vb_1_V : V ;
  jobba_vb_1_V : V ;
  joddla_vb_1_V : V ;
  jollra_vb_1_V : V ;
  jolta_vb_1_V : V ;
  joxa_vb_1_V : V ;
  jubilera_vb_1_V : V ;
  jubla_vb_1_V : V ;
  jucka_vb_1_V : V ;
  jula_vb_1_V : V ;
  jumpa_vb_1_V : V ;
  jympa_vb_1_V : V ;
  jaemna_till_vbm_1_1_V2 : V2 ;
  jaemna_ut_vbm_1_1_V2 : V2 ;
  jaemstaella_vb_1_1_V : V ;
  jaernsko_vb_1_1_V : V ;
  jaesa_vb_1_1_V : V ;
  k_maerka_vb_1_1_V : V ;
  kabla_vb_1_V : V ;
  kacka_vb_1_V : V ;
  kackla_vb_1_V : V ;
  kajka_vb_1_V : V ;
  kalasa_vb_1_V : V ;
  kalla_ut_vbm_1_V2 : V2 ;
  kallgrina_vb_1_V : V ;
  kallmangla_vb_1_V : V ;
  kallprata_vb_1_V : V ;
  kallroeka_vb_1_1_V : V ;
  kalna_vb_1_V : V ;
  kalva_vb_1_V : V ;
  kamma_in_vbm_1_V2 : V2 ;
  kampa_vb_1_V : V ;
  kampera_vb_1_V : V ;
  kana_vb_1_V : V ;
  kandidera_vb_1_V : V ;
  kanota_vb_1_V : V ;
  kanta_av_vbm_1_V2 : V2 ;
  kantklippa_vb_1_V : V ;
  kapa_av_vbm_1_V2 : V2 ;
  kapitulera_vb_1_V : V ;
  kapprusta_vb_1_V : V ;
  kappsegla_vb_1_V : V ;
  kapsla_vb_1_V : V ;
  kasa_vb_1_V : V ;
  kassera_in_vbm_1_V2 : V2 ;
  kasta_in_vbm_1_V2 : V2 ;
  kasta_om_vbm_1_V2 : V2 ;
  kasta_ut_vbm_1_V2 : V2 ;
  kava_vb_1_V : V ;
  kavla_vb_1_V : V ;
  kavla_ut_vbm_1_V2 : V2 ;
  kedjeroeka_vb_1_1_V : V ;
  kela_vb_1_V : V ;
  kesa_vb_1_V : V ;
  kikna_vb_1_V : V ;
  kila_vb_2_V : V ;
  kila_in_vbm_1_V2 : V2 ;
  kimma_vb_1_V : V ;
  kinesa_vb_1_V : V ;
  kinka_vb_1_V : V ;
  kippa_vb_1_V : V ;
  kisa_vb_1_V : V ;
  kittla_vb_1_V : V ;
  klabba_vb_1_V : V ;
  kladda_vb_1_V : V ;
  klaffa_vb_1_V : V ;
  klafsa_vb_1_V : V ;
  klampa_vb_1_V : V ;
  klandra_vb_1_V : V ;
  klanka_vb_1_V : V ;
  klanta_till_vbm_1_V2 : V2 ;
  klappa_vb_2_V : V ;
  klappra_vb_1_V : V ;
  klara_vb_1_V : V ;
  klara_av_vbm_1_V2 : V2 ;
  klarna_vb_1_V : V ;
  klema_vb_1_V : V ;
  klia_vb_1_V : V ;
  klibba_vb_1_V : V ;
  klicka_vb_1_V : V ;
  klimpa_vb_1_V : V ;
  klinka_vb_1_V : V ;
  klippa_vb_1_V : V ;
  klirra_vb_1_V : V ;
  klistra_vb_1_V : V ;
  klistra_paa_vbm_1_1_V2 : V2 ;
  klottra_vb_1_V : V ;
  klucka_vb_1_V : V ;
  klunka_vb_1_V : V ;
  klura_ut_vbm_1_V2 : V2 ;
  kluta_ut_vbm_1_V2 : V2 ;
  klaecka_vb_1_1_V : V ;
  klaemma_vb_1_1_V : V ;
  klaemta_vb_1_1_V : V ;
  klaenga_vb_1_1_V : V ;
  klaenga_vb_2_1_V : V ;
  klaettra_vb_1_1_V : V ;
  klaa_vb_1_1_V : V ;
  klaapa_vb_1_1_V : V ;
  kloesa_vb_1_1_V : V ;
  knacka_av_vbm_1_V2 : V2 ;
  knaggla_vb_1_V : V ;
  knaka_vb_1_V : V ;
  knalla_vb_1_V : V ;
  knappa_in_vbm_1_V2 : V2 ;
  knapra_vb_1_V : V ;
  knarra_vb_1_V : V ;
  knastra_vb_1_V : V ;
  knattra_vb_1_V : V ;
  knega_vb_1_V : V ;
  knirka_vb_1_V : V ;
  knirra_vb_1_V : V ;
  knistra_vb_1_V : V ;
  knittra_vb_1_V : V ;
  knixa_vb_1_V : V ;
  knoga_vb_1_V : V ;
  knollra_vb_1_V : V ;
  knoppa_av_vbm_1_V2 : V2 ;
  knorra_vb_1_V : V ;
  knorra_vb_2_V : V ;
  knota_vb_1_V : V ;
  knottra_vb_1_V : V ;
  knuffa_ut_vbm_1_V2 : V2 ;
  knussla_vb_1_V : V ;
  knycka_vb_1_V : V ;
  knyckla_vb_1_V : V ;
  knyckla_till_vbm_1_V2 : V2 ;
  knyppla_vb_1_V : V ;
  knysta_vb_1_V : V ;
  knaea_vb_1_1_V : V ;
  knaecka_vb_1_1_V : V ;
  knaeppa_vb_1_1_V : V ;
  knaeppa_vb_2_1_V : V ;
  knaada_in_vbm_1_1_V2 : V2 ;
  knaapa_vb_1_1_V : V ;
  knoeka_vb_1_1_V : V ;
  kodvaexla_vb_1_1_V : V ;
  kohandla_vb_1_V : V ;
  koka_vb_2_V : V ;
  kokettera_vb_1_V : V ;
  koksa_vb_1_V : V ;
  kollabera_vb_1_V : V ;
  kollaborera_vb_1_V : V ;
  kollidera_vb_1_V : V ;
  kommunicera_vb_2_V : V ;
  kompromissa_vb_1_V : V ;
  konferera_vb_1_V : V ;
  kongressa_vb_1_V : V ;
  konka_vb_1_V : V ;
  konkurrera_vb_1_V : V ;
  konsertera_vb_1_V : V ;
  konspirera_vb_1_V : V ;
  konstra_vb_1_V : V ;
  kontra_vb_1_V : V ;
  kontrollvaega_vb_1_1_V : V ;
  kontrollaesa_vb_1_1_V : V ;
  konvalescera_vb_1_V : V ;
  konvertera_vb_1_V : V ;
  kooperera_vb_1_V : V ;
  koppla_vb_1_V : V ;
  koppla_ifraan_vbm_1_1_V2 : V2 ;
  koppla_paa_vbm_1_1_V2 : V2 ;
  koppla_ur_vbm_1_V2 : V2 ;
  kopulera_vb_1_V : V ;
  korka_till_vbm_1_V2 : V2 ;
  korrekturlaesa_vb_1_1_V : V ;
  korrespondera_vb_1_V : V ;
  korsa_oever_vbm_1_1_V2 : V2 ;
  kortklippa_vb_1_V : V ;
  kosta_vb_1_V : V ;
  kovaenda_vb_1_1_V : V ;
  koxa_vb_1_V : V ;
  krama_ur_vbm_1_V2 : V2 ;
  krama_ut_vbm_1_V2 : V2 ;
  krasa_vb_1_V : V ;
  kratsa_ut_vbm_1_V2 : V2 ;
  kratta_av_vbm_1_V2 : V2 ;
  kravla_vb_1_V : V ;
  kraxa_vb_1_V : V ;
  kretsa_vb_1_V : V ;
  kriga_vb_1_V : V ;
  kringstroe_vb_1_1_V : V ;
  krisa_vb_1_V : V ;
  kroka_av_vbm_1_V2 : V2 ;
  krokna_vb_1_V : V ;
  kroppsarbeta_vb_1_V : V ;
  krubba_vb_1_V : V ;
  krumbukta_vb_1_V : V ;
  krylla_vb_1_V : V ;
  krympa_vb_1_V : V ;
  kryssa_vb_2_V : V ;
  kryssa_foer_vbm_1_1_V2 : V2 ;
  kryssa_oever_vbm_1_1_V2 : V2 ;
  krysta_vb_1_V : V ;
  kraela_vb_1_1_V : V ;
  kraemta_vb_1_1_V : V ;
  kraenga_vb_1_1_V : V ;
  kraenga_vb_2_1_V : V ;
  kraenka_vb_1_1_V : V ;
  kraeva_vb_1_1_V : V ;
  kraama_vb_1_1_V : V ;
  kraangla_vb_1_1_V : V ;
  kraangla_till_vbm_1_1_V2 : V2 ;
  kroeka_vb_1_1_V : V ;
  kroeka_vb_2_1_V : V ;
  kuckilura_vb_1_V : V ;
  kuckla_vb_1_V : V ;
  kullbyttera_vb_1_V : V ;
  kullra_vb_1_V : V ;
  kulminera_vb_1_V : V ;
  kulna_vb_1_V : V ;
  kulturminnesmaerka_vb_1_1_V : V ;
  kunskapa_vb_1_V : V ;
  kuppa_vb_1_V : V ;
  kurra_vb_1_V : V ;
  kursera_vb_1_V : V ;
  kuska_vb_1_V : V ;
  kuta_vb_1_V : V ;
  kuttra_vb_1_V : V ;
  kvacka_vb_1_V : V ;
  kvala_vb_1_V : V ;
  kvarta_vb_1_V : V ;
  kverulera_vb_1_V : V ;
  kvicka_vb_1_V : V ;
  kvickna_till_vbm_1_V2 : V2 ;
  kvillra_vb_1_V : V ;
  kvintilera_vb_1_V : V ;
  kvirra_vb_1_V : V ;
  kvista_av_vbm_1_V2 : V2 ;
  kvista_oever_vbm_1_1_V2 : V2 ;
  kvitta_vb_2_V : V ;
  kvitta_ut_vbm_1_V2 : V2 ;
  kvittra_vb_1_V : V ;
  kvaeka_vb_1_1_V : V ;
  kvaella_vb_1_1_V : V ;
  kvaesa_vb_1_1_V : V ;
  kvaeva_vb_1_1_V : V ;
  kyffa_vb_1_V : V ;
  kyla_vb_1_V : V ;
  kylna_vb_1_V : V ;
  kyssa_vb_1_V : V ;
  kaebbla_vb_1_1_V : V ;
  kaefta_vb_1_1_V : V ;
  kaelta_vb_1_1_V : V ;
  kaempa_vb_1_1_V : V ;
  kaera_vb_2_1_V : V ;
  kaerna_ur_vbm_1_1_V2 : V2 ;
  kaerva_vb_1_1_V : V ;
  kaexa_vb_1_1_V : V ;
  kaara_vb_2_1_V : V ;
  kaasera_vb_1_1_V : V ;
  koea_vb_1_1_V : V ;
  koelhala_vb_1_1_V : V ;
  koepa_vb_1_1_V : V ;
  koeva_vb_1_1_V : V ;
  laborera_vb_1_V : V ;
  lackera_oever_vbm_1_1_V2 : V2 ;
  ladda_om_vbm_1_V2 : V2 ;
  ladda_ur_vbm_1_V2 : V2 ;
  lafsa_vb_1_V : V ;
  lagstadga_vb_1_V : V ;
  lagsoeka_vb_1_1_V : V ;
  lalla_vb_1_V : V ;
  lamma_vb_1_V : V ;
  landsbo_vb_1_V : V ;
  lantbo_vb_1_V : V ;
  lappa_till_vbm_1_V2 : V2 ;
  larma_vb_1_V : V ;
  larva_vb_1_V : V ;
  lasa_in_vbm_1_V2 : V2 ;
  lassa_vb_1_V : V ;
  lasta_in_vbm_1_V2 : V2 ;
  lasta_om_vbm_1_V2 : V2 ;
  lasta_paa_vbm_1_1_V2 : V2 ;
  lasta_ur_vbm_1_V2 : V2 ;
  lattja_vb_1_V : V ;
  laxera_vb_1_V : V ;
  ledsna_vb_1_V : V ;
  leka_vb_1_V : V ;
  lessna_vb_1_V : V ;
  leta_igenom_vbm_1_V2 : V2 ;
  leta_ut_vbm_1_V2 : V2 ;
  lettra_vb_1_V : V ;
  leva_vb_1_V : V ;
  lifta_vb_1_V : V ;
  likna_vb_1_V : V ;
  likstaella_vb_1_1_V : V ;
  limma_paa_vbm_1_1_V2 : V2 ;
  linda_av_vbm_1_V2 : V2 ;
  linda_in_vbm_1_V2 : V2 ;
  linda_om_vbm_1_V2 : V2 ;
  linka_vb_1_V : V ;
  lipa_vb_1_V : V ;
  lirka_vb_1_V : V ;
  lisma_vb_1_V : V ;
  lista_ut_vbm_1_V2 : V2 ;
  lita_vb_1_V : V ;
  ljumma_vb_1_V : V ;
  ljunga_vb_1_V : V ;
  ljusna_vb_1_V : V ;
  ljustra_vb_1_V : V ;
  lobba_vb_2_V : V ;
  locka_in_vbm_1_V2 : V2 ;
  loda_vb_2_V : V ;
  logga_in_vbm_1_V2 : V2 ;
  logga_ut_vbm_1_V2 : V2 ;
  loma_vb_1_V : V ;
  lomma_vb_1_V : V ;
  loska_vb_1_V : V ;
  lossna_vb_1_V : V ;
  lotsa_in_vbm_1_V2 : V2 ;
  lova_vb_2_V : V ;
  lubba_vb_1_V : V ;
  luckra_vb_1_V : V ;
  ludda_vb_1_V : V ;
  luffa_vb_1_V : V ;
  lufsa_vb_1_V : V ;
  lukta_vb_1_V : V ;
  lulla_vb_1_V : V ;
  lumpa_vb_1_V : V ;
  luncha_vb_1_V : V ;
  lunka_vb_1_V : V ;
  lunta_vb_1_V : V ;
  lura_vb_2_V : V ;
  lura_av_vbm_1_V2 : V2 ;
  lusa_vb_1_V : V ;
  luska_vb_1_V : V ;
  luslaesa_vb_1_1_V : V ;
  lussa_vb_1_V : V ;
  luta_vb_2_V : V ;
  luta_av_vbm_1_V2 : V2 ;
  luttra_vb_1_V : V ;
  lysa_vb_1_V : V ;
  lysa_vb_2_V : V ;
  lyssna_vb_1_V : V ;
  lystra_vb_1_V : V ;
  lyxa_vb_1_V : V ;
  laea_vb_1_1_V : V ;
  laecka_vb_1_1_V : V ;
  laeka_vb_1_1_V : V ;
  laekarundersoeka_vb_1_1_V : V ;
  laenda_vb_1_1_V : V ;
  laenga_vb_1_1_V : V ;
  laengta_vb_1_1_V : V ;
  laeppja_vb_1_1_V : V ;
  laesa_vb_1_1_V : V ;
  laespa_vb_1_1_V : V ;
  laesta_ut_vbm_1_1_V2 : V2 ;
  laetta_vb_2_1_V : V ;
  laettna_vb_1_1_V : V ;
  laettra_vb_1_1_V : V ;
  laaga_vb_1_1_V : V ;
  laana_ut_vbm_1_1_V2 : V2 ;
  laasa_vb_1_1_V : V ;
  loeddra_vb_1_1_V : V ;
  loemskna_vb_1_1_V : V ;
  loepa_vb_2_1_V : V ;
  loepna_vb_1_1_V : V ;
  loesa_vb_1_1_V : V ;
  mackla_vb_1_V : V ;
  magra_vb_1_V : V ;
  majoritetsaega_vb_1_1_V : V ;
  mangla_vb_1_V : V ;
  mankera_vb_1_V : V ;
  mantla_vb_1_V : V ;
  marodera_vb_1_V : V ;
  marschera_vb_1_V : V ;
  maska_vb_1_V : V ;
  masturbera_vb_1_V : V ;
  matvaegra_vb_1_1_V : V ;
  mecka_vb_1_V : V ;
  meckla_vb_1_V : V ;
  medarbeta_vb_1_V : V ;
  meddela_vb_1_V : V ;
  meditera_vb_1_V : V ;
  medla_vb_1_V : V ;
  medverka_vb_1_V : V ;
  meja_av_vbm_1_V2 : V2 ;
  mejsla_av_vbm_1_V2 : V2 ;
  meka_vb_1_V : V ;
  menstruera_vb_1_V : V ;
  meta_vb_1_V : V ;
  miljoemaerka_vb_1_1_V : V ;
  mingla_vb_1_V : V ;
  missbedoema_vb_1_1_V : V ;
  misshaga_vb_1_V : V ;
  misshushaalla_vb_1_1_V : V ;
  missionera_vb_1_V : V ;
  misskoeta_vb_1_1_V : V ;
  misstro_vb_1_V : V ;
  misstroesta_vb_1_1_V : V ;
  misstycka_vb_1_V : V ;
  misstaenka_vb_1_1_V : V ;
  missvisa_vb_1_V : V ;
  mixtra_vb_1_V : V ;
  mjaua_vb_1_V : V ;
  mjukna_vb_1_V : V ;
  mogna_vb_1_V : V ;
  mojna_vb_1_V : V ;
  mola_vb_1_V : V ;
  momsredovisa_vb_1_V : V ;
  mopeda_vb_1_V : V ;
  moralisera_vb_1_V : V ;
  morla_vb_1_V : V ;
  morra_vb_1_V : V ;
  morsa_vb_1_V : V ;
  mota_ut_vbm_1_V2 : V2 ;
  motionera_vb_1_V : V ;
  motlaesa_vb_1_1_V : V ;
  motsvara_vb_1_V : V ;
  motvaega_vb_1_1_V : V ;
  moussera_vb_1_V : V ;
  mucka_vb_1_V : V ;
  muddra_vb_1_V : V ;
  mullra_vb_1_V : V ;
  mulna_vb_1_V : V ;
  multna_vb_1_V : V ;
  mumla_vb_1_V : V ;
  mumsa_vb_1_V : V ;
  mura_in_vbm_1_V2 : V2 ;
  mura_paa_vbm_1_1_V2 : V2 ;
  mura_till_vbm_1_V2 : V2 ;
  murkna_vb_1_V : V ;
  murra_vb_1_V : V ;
  musicera_vb_1_V : V ;
  mussera_vb_1_V : V ;
  muta_in_vbm_1_V2 : V2 ;
  muttra_vb_1_V : V ;
  mygla_vb_1_V : V ;
  myllra_vb_1_V : V ;
  mynna_vb_1_V : V ;
  mysa_vb_1_V : V ;
  maekla_vb_1_1_V : V ;
  maekta_vb_1_1_V : V ;
  maela_vb_1_1_V : V ;
  maenga_vb_1_1_V : V ;
  maergla_vb_1_1_V : V ;
  maerka_vb_1_1_V : V ;
  maessa_vb_1_1_V : V ;
  maeta_vb_1_1_V : V ;
  maa_vb_1_1_V : V ;
  maala_av_vbm_1_1_V2 : V2 ;
  maala_om_vbm_1_1_V2 : V2 ;
  maala_oever_vbm_1_1_V2 : V2 ;
  maana_vb_1_1_V : V ;
  maangla_vb_1_1_V : V ;
  moegla_vb_1_1_V : V ;
  moenstra_av_vbm_1_1_V2 : V2 ;
  moenstra_paa_vbm_1_1_V2 : V2 ;
  moerkna_vb_1_1_V : V ;
  moeta_vb_1_1_V : V ;
  nagga_vb_2_V : V ;
  nagla_foer_vbm_1_1_V2 : V2 ;
  nappa_vb_1_V : V ;
  nara_vb_2_V : V ;
  naturvandra_vb_1_V : V ;
  nedblaasa_vb_1_1_V : V ;
  nedgraeva_vb_1_1_V : V ;
  nedsaenka_vb_1_1_V : V ;
  nerblaasa_vb_1_1_V : V ;
  nersaenka_vb_1_1_V : V ;
  nicka_vb_1_V : V ;
  nitaelska_vb_1_1_V : V ;
  noja_vb_1_V : V ;
  nojsa_vb_1_V : V ;
  nollstaella_vb_1_1_V : V ;
  nolltaxera_vb_1_V : V ;
  nomadisera_vb_1_V : V ;
  nosa_vb_1_V : V ;
  nyanstaella_vb_1_1_V : V ;
  nyktra_till_vbm_1_V2 : V2 ;
  nysta_av_vbm_1_V2 : V2 ;
  nytta_vb_1_V : V ;
  naecka_vb_1_1_V : V ;
  naemna_vb_1_1_V : V ;
  naepsa_vb_1_1_V : V ;
  naethandla_vb_1_1_V : V ;
  naetkommunicera_vb_1_1_V : V ;
  naa_vb_1_1_V : V ;
  naatla_vb_1_1_V : V ;
  noedsignalera_vb_1_1_V : V ;
  noeta_vb_1_1_V : V ;
  obstruera_vb_1_V : V ;
  ockra_vb_1_V : V ;
  officiera_vb_1_V : V ;
  offra_vb_1_V : V ;
  oja_vb_1_V : V ;
  oktavera_vb_1_V : V ;
  okynnesstrejka_vb_1_V : V ;
  ombetro_vb_1_V : V ;
  omnaemna_vb_1_1_V : V ;
  omskoeta_vb_1_1_V : V ;
  omstaella_vb_1_1_V : V ;
  omstoepa_vb_1_1_V : V ;
  omsvepa_vb_1_V : V ;
  omvaelva_vb_1_1_V : V ;
  omvaenda_vb_1_1_V : V ;
  omvaerva_vb_1_1_V : V ;
  omvaexla_vb_1_1_V : V ;
  onanera_vb_1_V : V ;
  onanisera_vb_1_V : V ;
  opinera_vb_1_V : V ;
  oppfylla_vb_1_V : V ;
  opphaeva_vb_1_1_V : V ;
  opplaesa_vb_1_1_V : V ;
  oppstaella_vb_1_1_V : V ;
  oppsoeka_vb_1_1_V : V ;
  oppvaega_vb_1_1_V : V ;
  optera_vb_1_V : V ;
  orda_vb_1_V : V ;
  ordna_om_vbm_1_V2 : V2 ;
  orera_vb_1_V : V ;
  orientera_vb_1_V : V ;
  orka_vb_1_V : V ;
  orma_vb_1_V : V ;
  osa_vb_1_V : V ;
  oscillera_vb_1_V : V ;
  packa_av_vbm_1_V2 : V2 ;
  packa_in_vbm_1_V2 : V2 ;
  packa_om_vbm_1_V2 : V2 ;
  packa_till_vbm_1_V2 : V2 ;
  packa_ur_vbm_1_V2 : V2 ;
  paddla_vb_1_V : V ;
  palla_vb_2_V : V ;
  palta_paa_vbm_1_1_V2 : V2 ;
  panga_vb_1_V : V ;
  parasitera_vb_1_V : V ;
  parentera_vb_1_V : V ;
  parlamentera_vb_1_V : V ;
  parlera_vb_1_V : V ;
  parta_vb_1_V : V ;
  partaja_vb_1_V : V ;
  passa_vb_1_V : V ;
  peaka_vb_1_V : V ;
  peka_vb_1_V : V ;
  peka_ut_vbm_1_V2 : V2 ;
  pendla_vb_1_V : V ;
  pensla_vb_1_V : V ;
  perennera_vb_1_V : V ;
  personroesta_vb_1_1_V : V ;
  peta_vb_1_V : V ;
  piffa_till_vbm_1_V2 : V2 ;
  piggna_till_vbm_1_V2 : V2 ;
  pila_vb_1_V : V ;
  pilla_vb_1_V : V ;
  pillra_vb_1_V : V ;
  pimpla_vb_1_V : V ;
  pingla_vb_1_V : V ;
  pinka_vb_1_V : V ;
  pinna_vb_2_V : V ;
  pirra_vb_1_V : V ;
  piruettera_vb_1_V : V ;
  pissa_vb_1_V : V ;
  pivotera_vb_1_V : V ;
  pjollra_vb_1_V : V ;
  pjoska_vb_1_V : V ;
  pjunka_vb_1_V : V ;
  pladdra_vb_1_V : V ;
  plana_vb_2_V : V ;
  planka_vb_1_V : V ;
  plantera_om_vbm_1_V2 : V2 ;
  plaska_vb_1_V : V ;
  platsa_vb_1_V : V ;
  platta_till_vbm_1_V2 : V2 ;
  platta_ut_vbm_1_V2 : V2 ;
  plikta_vb_1_V : V ;
  pliktfaella_vb_1_1_V : V ;
  plira_vb_1_V : V ;
  plita_vb_1_V : V ;
  plocka_av_vbm_1_V2 : V2 ;
  plocka_ur_vbm_1_V2 : V2 ;
  plocka_ut_vbm_1_V2 : V2 ;
  plottra_vb_1_V : V ;
  plugga_vb_2_V : V ;
  plugga_in_vbm_1_V2 : V2 ;
  plumpa_vb_1_V : V ;
  plumsa_vb_1_V : V ;
  plundra_vb_1_V : V ;
  plurra_vb_1_V : V ;
  plussa_vb_1_V : V ;
  pluta_vb_1_V : V ;
  plaedera_vb_1_1_V : V ;
  plaega_vb_1_1_V : V ;
  pocka_vb_1_V : V ;
  pokulera_vb_1_V : V ;
  pola_vb_1_V : V ;
  polemisera_vb_1_V : V ;
  polera_av_vbm_1_V2 : V2 ;
  polera_om_vbm_1_V2 : V2 ;
  polisanmaela_vb_1_1_V : V ;
  polstra_vb_1_V : V ;
  ponera_vb_1_V : V ;
  porla_vb_1_V : V ;
  porrsurfa_vb_1_V : V ;
  portionera_ut_vbm_1_V2 : V2 ;
  posera_vb_1_V : V ;
  pracka_paa_vbm_1_1_V2 : V2 ;
  praoa_vb_1_V : V ;
  prassla_vb_1_V : V ;
  prata_vb_1_V : V ;
  predominera_vb_1_V : V ;
  prenumerera_vb_1_V : V ;
  presidera_vb_1_V : V ;
  prestavera_vb_1_V : V ;
  pretendera_vb_1_V : V ;
  pricka_av_vbm_1_V2 : V2 ;
  prisbeloena_vb_1_1_V : V ;
  prismaerka_vb_1_1_V : V ;
  procenta_vb_1_V : V ;
  processa_vb_1_V : V ;
  profetera_vb_1_V : V ;
  profitera_vb_1_V : V ;
  programmera_in_vbm_1_V2 : V2 ;
  promenera_vb_1_V : V ;
  propagera_vb_1_V : V ;
  proppa_in_vbm_1_V2 : V2 ;
  proppa_till_vbm_1_V2 : V2 ;
  propsa_vb_1_V : V ;
  prostituera_vb_1_V : V ;
  protestera_vb_1_V : V ;
  protestklicka_vb_1_V : V ;
  protestroesta_vb_1_1_V : V ;
  proviantera_vb_1_V : V ;
  prunka_vb_1_V : V ;
  prusta_vb_1_V : V ;
  prutta_vb_1_V : V ;
  prya_vb_1_V : V ;
  prygla_vb_1_V : V ;
  praenta_i_vbm_1_1_V2 : V2 ;
  praestviga_vb_1_1_V : V ;
  praala_vb_1_1_V : V ;
  praangla_vb_1_1_V : V ;
  puckla_paa_vbm_1_1_V2 : V2 ;
  puddla_vb_1_V : V ;
  pudla_vb_1_V : V ;
  puffa_vb_1_V : V ;
  pula_vb_1_V : V ;
  pulla_vb_1_V : V ;
  pulsa_vb_1_V : V ;
  pulsera_vb_1_V : V ;
  pumpa_in_vbm_1_V2 : V2 ;
  punga_ut_vbm_1_V2 : V2 ;
  purkna_vb_1_V : V ;
  pussla_vb_1_V : V ;
  pusta_vb_1_V : V ;
  puta_vb_1_V : V ;
  putsa_av_vbm_1_V2 : V2 ;
  puttra_vb_1_V : V ;
  pynta_till_vbm_1_V2 : V2 ;
  pysa_vb_1_V : V ;
  pyssla_vb_1_V : V ;
  paerla_vb_1_1_V : V ;
  paata_vb_2_1_V : V ;
  paavila_vb_1_1_V : V ;
  poela_vb_1_1_V : V ;
  poesa_vb_1_1_V : V ;
  quiza_vb_1_V : V ;
  quizza_vb_1_V : V ;
  rabbla_vb_1_V : V ;
  radionavigera_vb_1_V : V ;
  rafistulera_vb_1_V : V ;
  rafsa_vb_1_V : V ;
  raggla_vb_1_V : V ;
  ragla_vb_1_V : V ;
  raka_av_vbm_1_V2 : V2 ;
  rakna_vb_1_V : V ;
  raljera_vb_1_V : V ;
  ramla_vb_1_V : V ;
  rangla_vb_1_V : V ;
  ranta_vb_1_V : V ;
  rapa_vb_1_V : V ;
  rasa_vb_1_V : V ;
  rassla_vb_1_V : V ;
  rasta_vb_1_V : V ;
  ratscha_vb_1_V : V ;
  reagera_vb_1_V : V ;
  rebellera_vb_1_V : V ;
  recidivera_vb_1_V : V ;
  redigera_om_vbm_1_V2 : V2 ;
  regla_vb_1_V : V ;
  regla_foer_vbm_1_1_V2 : V2 ;
  regla_till_vbm_1_V2 : V2 ;
  regna_vb_1_V : V ;
  rekylera_vb_1_V : V ;
  relaxa_vb_1_V : V ;
  remma_vb_2_V : V ;
  remontera_vb_1_V : V ;
  rensa_av_vbm_1_V2 : V2 ;
  rensa_ut_vbm_1_V2 : V2 ;
  rentvaa_vb_1_1_V : V ;
  repliera_vb_1_V : V ;
  replikera_vb_1_V : V ;
  resa_vb_1_V : V ;
  resa_vb_2_V : V ;
  residera_vb_1_V : V ;
  resignera_vb_1_V : V ;
  resonera_vb_1_V : V ;
  restera_vb_1_V : V ;
  resultera_vb_1_V : V ;
  retirera_vb_1_V : V ;
  revoltera_vb_1_V : V ;
  ricka_vb_1_V : V ;
  rigla_vb_1_V : V ;
  rigla_foer_vbm_1_1_V2 : V2 ;
  rigla_till_vbm_1_V2 : V2 ;
  rikta_till_vbm_1_V2 : V2 ;
  ringa_vb_1_V : V ;
  ringla_vb_1_V : V ;
  ringmaerka_vb_1_1_V : V ;
  ripostera_vb_1_V : V ;
  riskera_vb_1_V : V ;
  rissla_vb_1_V : V ;
  rissla_vb_2_V : V ;
  rita_av_vbm_1_V2 : V2 ;
  rita_in_vbm_1_V2 : V2 ;
  rita_ut_vbm_1_V2 : V2 ;
  ritscha_vb_1_V : V ;
  rivalisera_vb_1_V : V ;
  ro_vb_1_V : V ;
  rocka_vb_1_V : V ;
  rodna_vb_1_V : V ;
  ropa_vb_1_V : V ;
  rossla_vb_1_V : V ;
  rosta_vb_1_V : V ;
  rota_vb_1_V : V ;
  rotfylla_vb_1_V : V ;
  ruckla_vb_1_V : V ;
  ruffla_vb_1_V : V ;
  rufsa_vb_1_V : V ;
  rugga_vb_1_V : V ;
  rulla_vb_2_V : V ;
  rulla_av_vbm_1_V2 : V2 ;
  rulla_ut_vbm_1_V2 : V2 ;
  rulta_vb_1_V : V ;
  rumla_vb_1_V : V ;
  rumstera_vb_1_V : V ;
  runda_till_vbm_1_V2 : V2 ;
  runga_vb_1_V : V ;
  rusa_vb_1_V : V ;
  ruska_vb_2_V : V ;
  rutscha_vb_1_V : V ;
  ruttna_vb_1_V : V ;
  ruva_vb_2_V : V ;
  rya_vb_1_V : V ;
  rycka_vb_1_V : V ;
  rygga_vb_1_V : V ;
  ryggsaecksluffa_vb_1_1_V : V ;
  rymma_vb_1_V : V ;
  rymma_vb_2_V : V ;
  ryttla_vb_1_V : V ;
  raecka_vb_1_1_V : V ;
  raecka_vb_2_1_V : V ;
  raeffla_vb_1_1_V : V ;
  raekna_efter_vbm_1_1_V2 : V2 ;
  raekna_igenom_vbm_1_1_V2 : V2 ;
  raekna_ut_vbm_1_1_V2 : V2 ;
  raekna_oever_vbm_1_1_V2 : V2 ;
  raeta_ut_vbm_1_1_V2 : V2 ;
  raetta_till_vbm_1_1_V2 : V2 ;
  raa_vb_2_1_V : V ;
  raama_vb_1_1_V : V ;
  raaskaella_vb_1_1_V : V ;
  raasteka_vb_1_1_V : V ;
  roeka_vb_1_1_V : V ;
  roesta_vb_1_1_V : V ;
  roesta_ut_vbm_1_1_V2 : V2 ;
  roestmaximera_vb_1_1_V : V ;
  roestskolka_vb_1_1_V : V ;
  sacka_vb_1_V : V ;
  sadla_vb_1_V : V ;
  sadla_av_vbm_1_V2 : V2 ;
  sadla_om_vbm_1_V2 : V2 ;
  sadla_paa_vbm_1_1_V2 : V2 ;
  sagga_vb_1_V : V ;
  sagla_vb_1_V : V ;
  sakfaella_vb_1_1_V : V ;
  sakna_vb_2_V : V ;
  salivera_vb_1_V : V ;
  salta_in_vbm_1_V2 : V2 ;
  samarbeta_vb_1_V : V ;
  sambo_vb_1_V : V ;
  samhaellsplanera_vb_1_1_V : V ;
  samklinga_vb_1_V : V ;
  samla_vb_1_V : V ;
  sammanbo_vb_1_V : V ;
  sammanhaenga_vb_1_1_V : V ;
  sammankoppla_vb_1_V : V ;
  sammanleva_vb_1_V : V ;
  sammanloepa_vb_1_1_V : V ;
  sammanringa_vb_1_V : V ;
  sammanstaella_vb_1_1_V : V ;
  sammanstoeta_vb_1_1_V : V ;
  sammantrycka_vb_1_V : V ;
  sammanvaega_vb_1_1_V : V ;
  sammanvaeva_vb_1_1_V : V ;
  sammanvaexa_vb_1_1_V : V ;
  sampla_vb_1_V : V ;
  samspela_vb_1_V : V ;
  samspraaka_vb_1_1_V : V ;
  samtala_vb_1_V : V ;
  samtycka_vb_1_V : V ;
  samverka_vb_1_V : V ;
  samaaka_vb_1_1_V : V ;
  satirisera_vb_1_V : V ;
  sava_vb_1_V : V ;
  schabbla_vb_1_V : V ;
  schackla_vb_1_V : V ;
  schackra_vb_1_V : V ;
  schasa_ut_vbm_1_V2 : V2 ;
  schavottera_vb_1_V : V ;
  sega_vb_1_V : V ;
  segla_vb_1_V : V ;
  segla_om_vbm_1_V2 : V2 ;
  segla_paa_vbm_1_1_V2 : V2 ;
  segla_ut_vbm_1_V2 : V2 ;
  segla_oever_vbm_1_1_V2 : V2 ;
  segna_vb_1_V : V ;
  segra_vb_1_V : V ;
  sejda_vb_1_V : V ;
  sela_av_vbm_1_V2 : V2 ;
  sela_paa_vbm_1_1_V2 : V2 ;
  semesterresa_vb_1_V : V ;
  semestra_vb_1_V : V ;
  sexchatta_vb_1_V : V ;
  sexvaegra_vb_1_1_V : V ;
  shaka_vb_1_V : V ;
  shingla_vb_1_V : V ;
  shoppa_vb_1_V : V ;
  showa_vb_1_V : V ;
  sia_vb_1_V : V ;
  sicksacka_vb_1_V : V ;
  signalera_vb_1_V : V ;
  sikta_vb_1_V : V ;
  sila_vb_2_V : V ;
  sila_av_vbm_1_V2 : V2 ;
  sila_ifraan_vbm_1_1_V2 : V2 ;
  sina_vb_1_V : V ;
  sina_ut_vbm_1_V2 : V2 ;
  singla_vb_1_V : V ;
  sintra_vb_1_V : V ;
  sippra_vb_1_V : V ;
  sirpa_vb_1_V : V ;
  sirra_vb_1_V : V ;
  sisa_vb_1_V : V ;
  sittstrejka_vb_1_V : V ;
  sittupa_vb_1_V : V ;
  sittuppa_vb_1_V : V ;
  situpa_vb_1_V : V ;
  situppa_vb_1_V : V ;
  sjabbla_vb_1_V : V ;
  sjangsera_vb_1_V : V ;
  sjaska_vb_1_V : V ;
  sjava_vb_1_V : V ;
  sjukanmaela_vb_1_1_V : V ;
  sjukna_vb_1_V : V ;
  sjaelvantaenda_vb_1_1_V : V ;
  sjaelvlaeka_vb_1_1_V : V ;
  sjaelvtaenda_vb_1_1_V : V ;
  sjaaa_vb_1_1_V : V ;
  skaka_av_vbm_1_V2 : V2 ;
  skaka_om_vbm_1_V2 : V2 ;
  skala_vb_2_V : V ;
  skala_av_vbm_1_V2 : V2 ;
  skalla_vb_1_V : V ;
  skallra_vb_1_V : V ;
  skapa_vb_1_V : V ;
  skarva_vb_2_V : V ;
  skarva_till_vbm_1_V2 : V2 ;
  skata_vb_1_V : V ;
  skatta_vb_1_V : V ;
  skattefiffla_vb_1_V : V ;
  skava_vb_1_V : V ;
  skejta_vb_1_V : V ;
  skela_vb_1_V : V ;
  skeva_vb_1_V : V ;
  skicka_vb_1_V : V ;
  skicka_efter_vbm_1_V2 : V2 ;
  skicka_in_vbm_1_V2 : V2 ;
  skicka_med_vbm_1_V2 : V2 ;
  skicka_ut_vbm_1_V2 : V2 ;
  skicka_oever_vbm_1_1_V2 : V2 ;
  skida_vb_1_V : V ;
  skidra_vb_1_V : V ;
  skifta_vb_2_V : V ;
  skifta_ut_vbm_1_V2 : V2 ;
  skimra_vb_1_V : V ;
  sko_vb_1_V : V ;
  skoja_vb_1_V : V ;
  skolka_vb_1_V : V ;
  skorra_vb_1_V : V ;
  skotta_av_vbm_1_V2 : V2 ;
  skovla_vb_1_V : V ;
  skralna_vb_1_V : V ;
  skralta_vb_1_V : V ;
  skramla_vb_1_V : V ;
  skramla_vb_2_V : V ;
  skrapa_av_vbm_1_V2 : V2 ;
  skrapa_ut_vbm_1_V2 : V2 ;
  skratta_vb_1_V : V ;
  skratta_ut_vbm_1_V2 : V2 ;
  skreva_vb_1_V : V ;
  skria_vb_1_V : V ;
  skrinna_vb_1_V : V ;
  skritta_vb_1_V : V ;
  skrocka_vb_1_V : V ;
  skrodera_vb_1_V : V ;
  skrota_vb_2_V : V ;
  skrubba_av_vbm_1_V2 : V2 ;
  skrumpna_vb_1_V : V ;
  skruva_av_vbm_1_V2 : V2 ;
  skruva_foer_vbm_1_1_V2 : V2 ;
  skruva_ifraan_vbm_1_1_V2 : V2 ;
  skruva_in_vbm_1_V2 : V2 ;
  skruva_paa_vbm_1_1_V2 : V2 ;
  skruva_till_vbm_1_V2 : V2 ;
  skrymma_vb_1_V : V ;
  skrynkla_vb_1_V : V ;
  skrynkla_till_vbm_1_V2 : V2 ;
  skraeddarsy_vb_1_1_V : V ;
  skraella_vb_1_1_V : V ;
  skraemma_vb_1_1_V : V ;
  skraenka_vb_1_1_V : V ;
  skraeppa_vb_1_1_V : V ;
  skraevla_vb_1_1_V : V ;
  skudda_av_vbm_1_V2 : V2 ;
  skuffa_ut_vbm_1_V2 : V2 ;
  skuggboxa_vb_1_V : V ;
  skumma_vb_1_V : V ;
  skura_av_vbm_1_V2 : V2 ;
  skvallra_vb_1_V : V ;
  skvalpa_om_vbm_1_V2 : V2 ;
  skvalpa_ut_vbm_1_V2 : V2 ;
  sky_vb_1_V : V ;
  skyffla_vb_1_V : V ;
  skyffla_av_vbm_1_V2 : V2 ;
  skyla_vb_1_V : V ;
  skyldra_vb_1_V : V ;
  skylla_vb_1_V : V ;
  skymla_vb_1_V : V ;
  skymma_vb_1_V : V ;
  skaella_vb_1_1_V : V ;
  skaemma_vb_1_1_V : V ;
  skaenka_vb_1_1_V : V ;
  skaenkla_vb_1_1_V : V ;
  skaerma_av_vbm_1_1_V2 : V2 ;
  skaerpa_vb_1_1_V : V ;
  skaangra_vb_1_1_V : V ;
  skaapa_ut_vbm_1_1_V2 : V2 ;
  skoena_vb_1_1_V : V ;
  skoeta_vb_1_1_V : V ;
  skoevla_vb_1_1_V : V ;
  slabbra_vb_1_V : V ;
  sladdra_vb_1_V : V ;
  slakta_ut_vbm_1_V2 : V2 ;
  slamma_vb_1_V : V ;
  slamra_vb_1_V : V ;
  slappzappa_vb_1_V : V ;
  slicka_av_vbm_1_V2 : V2 ;
  slingra_vb_1_V : V ;
  slitsa_vb_1_V : V ;
  sloka_vb_1_V : V ;
  slopa_vb_1_V : V ;
  slubba_vb_1_V : V ;
  sluddra_vb_1_V : V ;
  slugga_vb_1_V : V ;
  slumpa_vb_1_V : V ;
  slumra_vb_1_V : V ;
  slunga_vb_1_V : V ;
  slunga_in_vbm_1_V2 : V2 ;
  slurfa_vb_1_V : V ;
  slurpa_vb_1_V : V ;
  slussa_vb_1_V : V ;
  slussa_ut_vbm_1_V2 : V2 ;
  sluta_vb_1_V : V ;
  slutplaedera_vb_1_1_V : V ;
  slutta_vb_1_V : V ;
  slaecka_vb_1_1_V : V ;
  slaegga_vb_1_1_V : V ;
  slaenga_vb_1_1_V : V ;
  slaentra_vb_1_1_V : V ;
  slaepa_vb_1_1_V : V ;
  slaepa_in_vbm_1_1_V2 : V2 ;
  slaepa_ut_vbm_1_1_V2 : V2 ;
  slaeppa_vb_1_1_V : V ;
  slaeta_vb_1_1_V : V ;
  slaeta_av_vbm_1_1_V2 : V2 ;
  slaeta_till_vbm_1_1_V2 : V2 ;
  slaeta_oever_vbm_1_1_V2 : V2 ;
  slaetraka_vb_1_1_V : V ;
  slaetslipa_vb_1_1_V : V ;
  slaatta_vb_1_1_V : V ;
  sloea_vb_1_1_V : V ;
  sloejda_vb_1_1_V : V ;
  sloera_vb_1_1_V : V ;
  sloesa_vb_1_1_V : V ;
  sloesurfa_vb_1_1_V : V ;
  sloetitta_vb_1_1_V : V ;
  smacka_vb_1_V : V ;
  smaka_vb_1_V : V ;
  smaka_vb_2_V : V ;
  smalfilma_vb_1_V : V ;
  smalna_vb_1_V : V ;
  smarra_vb_1_V : V ;
  smasha_vb_1_V : V ;
  smaska_vb_1_V : V ;
  smattra_vb_1_V : V ;
  smeka_vb_1_V : V ;
  smeta_vb_1_V : V ;
  smeta_paa_vbm_1_1_V2 : V2 ;
  smeta_oever_vbm_1_1_V2 : V2 ;
  smickra_vb_1_V : V ;
  smila_vb_1_V : V ;
  sminka_vb_1_V : V ;
  smiska_vb_1_V : V ;
  smitta_vb_1_V : V ;
  smittspaara_vb_1_1_V : V ;
  smocka_vb_1_V : V ;
  smocka_till_vbm_1_V2 : V2 ;
  smsa_vb_1_V : V ;
  smuggla_vb_1_V : V ;
  smuggla_in_vbm_1_V2 : V2 ;
  smula_vb_1_V : V ;
  smulta_vb_1_V : V ;
  smussla_vb_1_V : V ;
  smutsa_vb_1_V : V ;
  smutskasta_vb_1_V : V ;
  smutta_vb_1_V : V ;
  smycka_vb_1_V : V ;
  smygjaga_vb_1_V : V ;
  smyglyssna_vb_1_V : V ;
  smygroeka_vb_1_1_V : V ;
  smygtitta_vb_1_V : V ;
  smaecka_vb_1_1_V : V ;
  smaekta_vb_1_1_V : V ;
  smaella_vb_1_1_V : V ;
  smaergla_vb_1_1_V : V ;
  smaerta_vb_1_1_V : V ;
  smaaflina_vb_1_1_V : V ;
  smaagraela_vb_1_1_V : V ;
  smaaprata_vb_1_1_V : V ;
  smaaputtra_vb_1_1_V : V ;
  smaaskratta_vb_1_1_V : V ;
  smaastadsbo_vb_1_1_V : V ;
  smoera_vb_1_1_V : V ;
  smoerfraesa_vb_1_1_V : V ;
  snabbteckna_vb_1_V : V ;
  snabbtoersta_vb_1_1_V : V ;
  snacka_vb_1_V : V ;
  snagga_vb_1_V : V ;
  snappa_vb_1_V : V ;
  snapsa_vb_1_V : V ;
  snara_vb_1_V : V ;
  snarka_vb_1_V : V ;
  snarpa_vb_1_V : V ;
  snarra_vb_1_V : V ;
  snaska_vb_1_V : V ;
  snatta_vb_1_V : V ;
  snattra_vb_1_V : V ;
  snava_vb_1_V : V ;
  snedda_vb_1_V : V ;
  snedstaella_vb_1_1_V : V ;
  snegla_vb_1_V : V ;
  snida_vb_1_V : V ;
  sniffa_vb_1_V : V ;
  snirkla_vb_1_V : V ;
  snitsa_vb_1_V : V ;
  snitsla_vb_1_V : V ;
  snitta_vb_1_V : V ;
  sno_vb_1_V : V ;
  snobba_vb_1_V : V ;
  snofsa_till_vbm_1_V2 : V2 ;
  snoka_vb_1_V : V ;
  snoka_igenom_vbm_1_V2 : V2 ;
  snoppa_vb_1_V : V ;
  snora_vb_1_V : V ;
  snubba_vb_1_V : V ;
  snubbla_vb_1_V : V ;
  snudda_vb_1_V : V ;
  snurra_vb_1_V : V ;
  snusa_vb_1_V : V ;
  snuska_vb_1_V : V ;
  snuva_vb_1_V : V ;
  snyfta_vb_1_V : V ;
  snygga_till_vbm_1_V2 : V2 ;
  snylta_vb_1_V : V ;
  snaeppa_vb_1_1_V : V ;
  snaerpa_vb_1_1_V : V ;
  snaerta_vb_1_1_V : V ;
  snaesa_vb_1_1_V : V ;
  snaeva_vb_1_1_V : V ;
  snaala_vb_1_1_V : V ;
  snaala_in_vbm_1_1_V2 : V2 ;
  snoea_vb_1_1_V : V ;
  snoea_in_vbm_1_1_V2 : V2 ;
  snoepa_vb_1_1_V : V ;
  snoeploga_vb_1_1_V : V ;
  snoerpa_vb_1_1_V : V ;
  snoervla_vb_1_1_V : V ;
  sockersalta_vb_1_V : V ;
  sockra_oever_vbm_1_1_V2 : V2 ;
  soffsurfa_vb_1_V : V ;
  softa_vb_1_V : V ;
  sol_och_vaara_vb_1_1_V : V ;
  sola_vb_1_V : V ;
  solbada_vb_1_V : V ;
  solka_vb_1_V : V ;
  solochvaara_vb_1_1_V : V ;
  soltorka_vb_1_V : V ;
  solva_vb_1_V : V ;
  somna_vb_1_V : V ;
  sopa_vb_1_V : V ;
  sopa_av_vbm_1_V2 : V2 ;
  sopa_ut_vbm_1_V2 : V2 ;
  sota_vb_1_V : V ;
  sota_vb_2_V : V ;
  spackla_vb_1_V : V ;
  spadvaenda_vb_1_1_V : V ;
  spaka_vb_1_V : V ;
  spakna_vb_1_V : V ;
  spalta_vb_1_V : V ;
  spana_vb_1_V : V ;
  spana_efter_vbm_1_V2 : V2 ;
  spankulera_vb_1_V : V ;
  spara_vb_1_V : V ;
  spara_vb_2_V : V ;
  spara_in_vbm_1_V2 : V2 ;
  sparka_vb_1_V : V ;
  sparka_av_vbm_1_V2 : V2 ;
  sparka_ut_vbm_1_V2 : V2 ;
  sparra_vb_1_V : V ;
  spatsera_vb_1_V : V ;
  specialbestaella_vb_1_1_V : V ;
  speja_vb_1_V : V ;
  speja_ut_vbm_1_V2 : V2 ;
  spela_vb_2_V : V ;
  spendera_vb_1_V : V ;
  speta_vb_1_V : V ;
  spetsa_vb_1_V : V ;
  spetta_vb_1_V : V ;
  spexa_vb_1_V : V ;
  spika_foer_vbm_1_1_V2 : V2 ;
  spika_paa_vbm_1_1_V2 : V2 ;
  spika_till_vbm_1_V2 : V2 ;
  spila_vb_1_V : V ;
  spilla_vb_1_V : V ;
  spionera_vb_1_V : V ;
  spira_vb_1_V : V ;
  spisa_vb_1_V : V ;
  spjaela_vb_1_1_V : V ;
  spjaelka_vb_1_1_V : V ;
  spjaerna_vb_1_1_V : V ;
  splinta_vb_1_V : V ;
  splissa_vb_1_V : V ;
  splitsa_vb_1_V : V ;
  splittra_vb_1_V : V ;
  spola_vb_1_V : V ;
  spola_av_vbm_1_V2 : V2 ;
  spola_oever_vbm_1_1_V2 : V2 ;
  sponta_vb_1_V : V ;
  sporra_vb_1_V : V ;
  sporta_vb_1_V : V ;
  spotta_vb_1_V : V ;
  spraka_vb_1_V : V ;
  spralla_vb_1_V : V ;
  sprattla_vb_1_V : V ;
  spraya_vb_1_V : V ;
  spreja_vb_1_V : V ;
  spreta_vb_1_V : V ;
  sprinta_vb_1_V : V ;
  sprita_vb_1_V : V ;
  sprita_vb_2_V : V ;
  spritsa_vb_1_V : V ;
  sprudla_vb_1_V : V ;
  spruta_vb_1_V : V ;
  spruta_in_vbm_1_V2 : V2 ;
  sprutmaala_vb_1_1_V : V ;
  spraecka_vb_1_1_V : V ;
  spraenga_vb_1_1_V : V ;
  spraenga_vb_2_1_V : V ;
  spraetta_vb_2_1_V : V ;
  spraaka_vb_1_1_V : V ;
  sproeta_vb_1_1_V : V ;
  spurta_vb_1_V : V ;
  spy_vb_1_V : V ;
  spaecka_vb_1_1_V : V ;
  spaeka_vb_1_1_V : V ;
  spaensta_vb_1_1_V : V ;
  spaenta_vb_1_1_V : V ;
  spaerra_vb_1_1_V : V ;
  spaerra_in_vbm_1_1_V2 : V2 ;
  spaerra_till_vbm_1_1_V2 : V2 ;
  spaerra_ut_vbm_1_1_V2 : V2 ;
  spaa_vb_1_1_V : V ;
  spaana_vb_1_1_V : V ;
  spaanga_vb_1_1_V : V ;
  spaanta_vb_1_1_V : V ;
  spaara_vb_1_1_V : V ;
  spaara_ur_vbm_1_1_V2 : V2 ;
  spoea_vb_1_1_V : V ;
  spoeka_vb_1_1_V : V ;
  spoeka_ut_vbm_1_1_V2 : V2 ;
  stacka_vb_1_V : V ;
  stadvaenda_vb_1_1_V : V ;
  staga_vb_1_V : V ;
  stagvaenda_vb_1_1_V : V ;
  staka_vb_1_V : V ;
  staka_ut_vbm_1_V2 : V2 ;
  stalla_vb_1_V : V ;
  stamma_vb_2_V : V ;
  stampa_vb_1_V : V ;
  stampa_vb_2_V : V ;
  stanna_vb_1_V : V ;
  stansa_vb_1_V : V ;
  stansa_ut_vbm_1_V2 : V2 ;
  stapla_vb_1_V : V ;
  stappla_vb_1_V : V ;
  starrbliga_vb_1_V : V ;
  starta_vb_1_V : V ;
  starta_om_vbm_1_V2 : V2 ;
  stassa_vb_1_V : V ;
  statera_vb_1_V : V ;
  statuera_vb_1_V : V ;
  stava_vb_1_V : V ;
  stega_vb_1_V : V ;
  stegla_vb_1_V : V ;
  steka_vb_1_V : V ;
  stena_vb_1_V : V ;
  steppa_vb_1_V : V ;
  sticka_vb_2_V : V ;
  stifta_vb_1_V : V ;
  stila_vb_1_V : V ;
  stilla_vb_1_V : V ;
  stillna_vb_1_V : V ;
  stimma_vb_1_V : V ;
  stirra_vb_1_V : V ;
  stjaelpa_vb_1_1_V : V ;
  stocka_vb_1_V : V ;
  stoja_vb_1_V : V ;
  stolpa_vb_1_V : V ;
  stoltsera_vb_1_V : V ;
  stoppa_vb_1_V : V ;
  stoppa_in_vbm_1_V2 : V2 ;
  stoppa_om_vbm_1_V2 : V2 ;
  stoppa_till_vbm_1_V2 : V2 ;
  storhandla_vb_1_V : V ;
  storkna_vb_1_V : V ;
  storma_vb_1_V : V ;
  stormgraela_vb_1_1_V : V ;
  stormskaella_vb_1_1_V : V ;
  storsatsa_vb_1_V : V ;
  storskratta_vb_1_V : V ;
  straffa_vb_1_V : V ;
  straffbeskatta_vb_1_V : V ;
  strama_vb_1_V : V ;
  stranda_vb_1_V : V ;
  streaka_vb_1_V : V ;
  strecka_vb_1_V : V ;
  strejka_vb_1_V : V ;
  stressa_vb_1_V : V ;
  streta_vb_1_V : V ;
  stretcha_vb_1_V : V ;
  strigla_vb_1_V : V ;
  strila_vb_1_V : V ;
  strimla_vb_1_V : V ;
  stripa_vb_1_V : V ;
  strippa_vb_1_V : V ;
  strosa_vb_1_V : V ;
  strula_vb_1_V : V ;
  strunta_vb_1_V : V ;
  strutta_vb_1_V : V ;
  straecka_vb_1_1_V : V ;
  straecklaesa_vb_1_1_V : V ;
  straenga_vb_1_1_V : V ;
  straeva_vb_1_1_V : V ;
  straala_vb_1_1_V : V ;
  stroe_vb_1_1_V : V ;
  stroemma_vb_1_1_V : V ;
  stroeppla_vb_1_1_V : V ;
  stroeva_vb_1_1_V : V ;
  stroeva_igenom_vbm_1_1_V2 : V2 ;
  stubba_vb_1_V : V ;
  studsa_vb_1_V : V ;
  stuka_vb_1_V : V ;
  stuka_till_vbm_1_V2 : V2 ;
  stulta_vb_1_V : V ;
  stunda_vb_1_V : V ;
  stura_vb_1_V : V ;
  stuva_vb_1_V : V ;
  stuva_in_vbm_1_V2 : V2 ;
  stuva_om_vbm_1_V2 : V2 ;
  stycka_vb_1_V : V ;
  stylta_vb_1_V : V ;
  stympa_vb_1_V : V ;
  styrka_vb_1_V : V ;
  styva_vb_1_V : V ;
  styvna_vb_1_V : V ;
  staecka_vb_1_1_V : V ;
  staeda_vb_1_1_V : V ;
  staedsla_vb_1_1_V : V ;
  staella_vb_1_1_V : V ;
  staemma_vb_1_1_V : V ;
  staempla_in_vbm_1_1_V2 : V2 ;
  staempla_ut_vbm_1_1_V2 : V2 ;
  staenga_vb_1_1_V : V ;
  staenka_vb_1_1_V : V ;
  staerka_vb_1_1_V : V ;
  staeva_vb_1_1_V : V ;
  staevja_vb_1_1_V : V ;
  staanda_vb_1_1_V : V ;
  staanga_vb_1_1_V : V ;
  staanka_vb_1_1_V : V ;
  staata_vb_1_1_V : V ;
  stoedkoepa_vb_1_1_V : V ;
  stoedroesta_vb_1_1_V : V ;
  stoeka_vb_1_1_V : V ;
  stoeka_till_vbm_1_1_V2 : V2 ;
  stoeka_oever_vbm_1_1_V2 : V2 ;
  stoena_vb_1_1_V : V ;
  stoepa_vb_1_1_V : V ;
  stoeppla_vb_1_1_V : V ;
  stoera_vb_2_1_V : V ;
  stoerta_vb_1_1_V : V ;
  stoerta_in_vbm_1_1_V2 : V2 ;
  stoertregna_vb_1_1_V : V ;
  stoeta_vb_1_1_V : V ;
  stoetta_vb_1_1_V : V ;
  sucka_vb_1_V : V ;
  sudda_vb_1_V : V ;
  sudda_ut_vbm_1_V2 : V2 ;
  sudda_oever_vbm_1_1_V2 : V2 ;
  suga_av_vbm_1_V2 : V2 ;
  sukta_vb_1_V : V ;
  sula_vb_1_V : V ;
  summa_vb_1_V : V ;
  sumpa_vb_1_V : V ;
  supera_vb_1_V : V ;
  suppurera_vb_1_V : V ;
  sura_vb_1_V : V ;
  surfa_vb_1_V : V ;
  surna_vb_1_V : V ;
  surra_vb_1_V : V ;
  surra_vb_2_V : V ;
  susa_vb_1_V : V ;
  sussa_vb_1_V : V ;
  svabba_vb_1_V : V ;
  svacka_vb_1_V : V ;
  svaja_vb_1_V : V ;
  svalka_vb_1_V : V ;
  svalla_vb_1_V : V ;
  svalla_oever_vbm_1_1_V2 : V2 ;
  svamla_vb_1_V : V ;
  svanka_vb_1_V : V ;
  svansa_vb_1_V : V ;
  svartlista_vb_1_V : V ;
  svarva_vb_1_V : V ;
  svarva_till_vbm_1_V2 : V2 ;
  svassa_vb_1_V : V ;
  svavla_vb_1_V : V ;
  svedja_vb_1_V : V ;
  svedja_av_vbm_1_V2 : V2 ;
  svepa_vb_1_V : V ;
  svetsa_vb_1_V : V ;
  svetta_vb_1_V : V ;
  svikta_vb_1_V : V ;
  svimma_vb_1_V : V ;
  svimma_av_vbm_1_V2 : V2 ;
  svindla_vb_1_V : V ;
  svindla_vb_2_V : V ;
  svinga_vb_1_V : V ;
  svinga_vb_2_V : V ;
  svira_vb_1_V : V ;
  svirra_vb_1_V : V ;
  svischa_vb_1_V : V ;
  svullna_vb_1_V : V ;
  svaella_vb_1_1_V : V ;
  svaemma_oever_vbm_1_1_V2 : V2 ;
  svaenga_vb_1_1_V : V ;
  svaenga_vb_2_1_V : V ;
  svaerma_vb_1_1_V : V ;
  svaerta_vb_1_1_V : V ;
  svaeva_vb_1_1_V : V ;
  svaeva_ut_vbm_1_1_V2 : V2 ;
  swinga_vb_1_V : V ;
  sy_vb_1_V : V ;
  syfta_vb_1_V : V ;
  sylta_vb_1_V : V ;
  sylta_in_vbm_1_V2 : V2 ;
  sympatisera_vb_1_V : V ;
  syna_vb_1_V : V ;
  synda_vb_1_V : V ;
  synka_vb_1_V : V ;
  syra_vb_1_V : V ;
  syssla_vb_1_V : V ;
  systemera_vb_1_V : V ;
  saecka_vb_1_1_V : V ;
  saekerstaella_vb_1_1_V : V ;
  saellskapa_vb_1_1_V : V ;
  saemska_vb_1_1_V : V ;
  saemskgarva_vb_1_1_V : V ;
  saenda_vb_1_1_V : V ;
  saengroeka_vb_1_1_V : V ;
  saenka_vb_1_1_V : V ;
  saera_vb_1_1_V : V ;
  saerbeskatta_vb_1_1_V : V ;
  saa_vb_1_1_V : V ;
  saaga_vb_1_1_V : V ;
  saaga_av_vbm_1_1_V2 : V2 ;
  saaga_ur_vbm_1_1_V2 : V2 ;
  saaga_ut_vbm_1_1_V2 : V2 ;
  saalla_vb_1_1_V : V ;
  saapa_vb_1_1_V : V ;
  saara_vb_1_1_V : V ;
  saasa_vb_1_1_V : V ;
  saata_vb_1_1_V : V ;
  soeka_vb_1_1_V : V ;
  soela_vb_1_1_V : V ;
  soenderdela_vb_1_1_V : V ;
  soenderhacka_vb_1_1_V : V ;
  soenderspraenga_vb_1_1_V : V ;
  soerpla_vb_1_1_V : V ;
  soeta_vb_1_1_V : V ;
  soeva_vb_1_1_V : V ;
  tabulera_vb_1_V : V ;
  tacka_vb_1_V : V ;
  tackla_vb_1_V : V ;
  tackla_av_vbm_1_V2 : V2 ;
  tadla_vb_1_V : V ;
  taffla_vb_1_V : V ;
  tafsa_vb_1_V : V ;
  tagga_vb_1_V : V ;
  tagla_vb_1_V : V ;
  taja_vb_1_V : V ;
  tajma_vb_1_V : V ;
  taktera_vb_1_V : V ;
  taktikroesta_vb_1_1_V : V ;
  talga_vb_1_V : V ;
  talka_vb_1_V : V ;
  talla_vb_1_V : V ;
  tanda_vb_1_V : V ;
  tanka_vb_1_V : V ;
  tappa_vb_1_V : V ;
  tarva_vb_1_V : V ;
  tassa_vb_1_V : V ;
  tassla_vb_1_V : V ;
  taxa_vb_1_V : V ;
  tejpa_vb_1_V : V ;
  teka_vb_1_V : V ;
  tempa_vb_1_V : V ;
  tendera_vb_1_V : V ;
  tenta_vb_1_V : V ;
  tentamenslaesa_vb_1_1_V : V ;
  teoretisera_vb_1_V : V ;
  testa_vb_1_V : V ;
  texta_vb_1_V : V ;
  ticka_vb_1_V : V ;
  tidsbegraensa_vb_1_1_V : V ;
  tidsbestaemma_vb_1_1_V : V ;
  tigga_vb_1_V : V ;
  tillaga_vb_1_V : V ;
  tillbakavisa_vb_1_V : V ;
  tillblanda_vb_1_V : V ;
  tilldela_vb_1_V : V ;
  tilldoema_vb_1_1_V : V ;
  tillfoga_vb_1_V : V ;
  tillfredsstaella_vb_1_1_V : V ;
  tillfriskna_vb_1_V : V ;
  tillfrysa_vb_1_V : V ;
  tillfraaga_vb_1_1_V : V ;
  tillgodoraekna_vb_1_1_V : V ;
  tillkalla_vb_1_V : V ;
  tillmaeta_vb_1_1_V : V ;
  tillpassa_vb_1_V : V ;
  tillplatta_vb_1_V : V ;
  tillra_vb_1_V : V ;
  tillraekna_vb_1_1_V : V ;
  tillraettavisa_vb_1_1_V : V ;
  tillskapa_vb_1_V : V ;
  tillskynda_vb_1_V : V ;
  tillspetsa_vb_1_V : V ;
  tillstunda_vb_1_V : V ;
  tillstyrka_vb_1_V : V ;
  tillstaella_vb_1_1_V : V ;
  tillstoeta_vb_1_1_V : V ;
  tilltala_vb_1_V : V ;
  tilltro_vb_1_V : V ;
  tilltyga_vb_1_V : V ;
  tilltaeppa_vb_1_1_V : V ;
  tillverka_vb_1_V : V ;
  tillvita_vb_1_V : V ;
  tillyxa_vb_1_V : V ;
  tillaegna_vb_1_1_V : V ;
  tillaemna_vb_1_1_V : V ;
  tillaempa_vb_1_1_V : V ;
  tilloenska_vb_1_1_V : V ;
  tima_vb_1_V : V ;
  tina_vb_1_V : V ;
  tindra_vb_1_V : V ;
  tinga_vb_1_V : V ;
  tiofaldiga_vb_1_V : V ;
  tippa_vb_1_V : V ;
  tipsa_vb_1_V : V ;
  tira_vb_1_V : V ;
  tissla_vb_1_V : V ;
  titta_vb_1_V : V ;
  titta_in_vbm_1_V2 : V2 ;
  titta_paa_vbm_1_1_V2 : V2 ;
  titta_till_vbm_1_V2 : V2 ;
  tjacka_vb_1_V : V ;
  tjafsa_vb_1_V : V ;
  tjalla_vb_1_V : V ;
  tjata_vb_1_V : V ;
  tjattra_vb_1_V : V ;
  tjilla_vb_1_V : V ;
  tjimma_vb_1_V : V ;
  tjinga_vb_1_V : V ;
  tjoa_vb_1_V : V ;
  tjockna_vb_1_V : V ;
  tjorva_vb_1_V : V ;
  tjura_vb_1_V : V ;
  tjuva_vb_1_V : V ;
  tjuvkika_vb_1_V : V ;
  tjuvmjoelka_vb_1_1_V : V ;
  tjuvroeka_vb_1_1_V : V ;
  tjuvstarta_vb_1_V : V ;
  tjuvtitta_vb_1_V : V ;
  tjuvtraena_vb_1_1_V : V ;
  tjyva_vb_1_V : V ;
  tjyvkika_vb_1_V : V ;
  tjyvmjoelka_vb_1_1_V : V ;
  tjyvroeka_vb_1_1_V : V ;
  tjyvstarta_vb_1_V : V ;
  tjyvtitta_vb_1_V : V ;
  tjaela_vb_1_1_V : V ;
  tjaena_vb_1_1_V : V ;
  tjaera_vb_1_1_V : V ;
  tocka_vb_1_V : V ;
  toffla_vb_1_V : V ;
  tolka_vb_1_V : V ;
  tomta_vb_1_V : V ;
  tona_vb_1_V : V ;
  toppa_vb_1_V : V ;
  torde_vb_1_V : V ;
  torka_vb_1_V : V ;
  torka_av_vbm_1_V2 : V2 ;
  torka_in_vbm_1_V2 : V2 ;
  torka_ut_vbm_1_V2 : V2 ;
  torna_vb_1_V : V ;
  tornera_vb_1_V : V ;
  torrhosta_vb_1_V : V ;
  torrslipa_vb_1_V : V ;
  torroeka_vb_1_1_V : V ;
  torska_vb_1_V : V ;
  torva_vb_1_V : V ;
  torvtaecka_vb_1_1_V : V ;
  totalkvadda_vb_1_V : V ;
  toucha_vb_1_V : V ;
  tova_vb_1_V : V ;
  traggla_vb_1_V : V ;
  traja_vb_1_V : V ;
  trakta_vb_1_V : V ;
  tralla_vb_1_V : V ;
  trampa_vb_1_V : V ;
  trampa_till_vbm_1_V2 : V2 ;
  trampa_ut_vbm_1_V2 : V2 ;
  tramsa_vb_1_V : V ;
  tranchera_vb_1_V : V ;
  transpirera_vb_1_V : V ;
  trasa_vb_1_V : V ;
  traska_vb_1_V : V ;
  trassla_vb_1_V : V ;
  trassla_in_vbm_1_V2 : V2 ;
  trassla_till_vbm_1_V2 : V2 ;
  tratta_vb_1_V : V ;
  trava_vb_1_V : V ;
  tremulera_vb_1_V : V ;
  treva_vb_1_V : V ;
  trilla_vb_1_V : V ;
  trimma_vb_1_V : V ;
  trippa_vb_1_V : V ;
  triumfera_vb_1_V : V ;
  tro_vb_1_V : V ;
  trolla_vb_1_V : V ;
  trolova_vb_1_V : V ;
  trona_vb_1_V : V ;
  troppa_vb_1_V : V ;
  troppa_av_vbm_1_V2 : V2 ;
  trotsa_vb_1_V : V ;
  truga_vb_1_V : V ;
  truga_paa_vbm_1_1_V2 : V2 ;
  trula_vb_1_V : V ;
  trumfa_vb_1_V : V ;
  trumfa_i_vbm_1_V2 : V2 ;
  trumfa_igenom_vbm_1_V2 : V2 ;
  trumla_vb_1_V : V ;
  trumma_in_vbm_1_V2 : V2 ;
  trumpeta_vb_1_V : V ;
  trumpeta_ut_vbm_1_V2 : V2 ;
  truta_vb_1_V : V ;
  trycka_vb_1_V : V ;
  trygga_vb_1_V : V ;
  tryna_vb_1_V : V ;
  traecka_vb_1_1_V : V ;
  traeffa_vb_1_1_V : V ;
  traeffa_paa_vbm_1_1_V2 : V2 ;
  traela_vb_1_1_V : V ;
  traena_vb_1_1_V : V ;
  traenga_vb_1_1_V : V ;
  traengta_vb_1_1_V : V ;
  traensa_vb_1_1_V : V ;
  traeta_vb_1_1_V : V ;
  traa_vb_1_1_V : V ;
  traackla_vb_1_1_V : V ;
  traackla_till_vbm_1_1_V2 : V2 ;
  traaka_vb_1_1_V : V ;
  traaka_ut_vbm_1_1_V2 : V2 ;
  traala_vb_1_1_V : V ;
  traana_vb_1_1_V : V ;
  troeska_vb_1_1_V : V ;
  troesta_vb_1_1_V : V ;
  troetta_vb_1_1_V : V ;
  tubba_vb_1_V : V ;
  tudela_vb_1_V : V ;
  tuffa_vb_1_V : V ;
  tufsa_vb_1_V : V ;
  tufsa_till_vbm_1_V2 : V2 ;
  tugga_vb_1_V : V ;
  tugga_om_vbm_1_V2 : V2 ;
  tukta_vb_1_V : V ;
  tulla_vb_1_V : V ;
  tullbesiktiga_vb_1_V : V ;
  tulta_vb_1_V : V ;
  tumla_vb_1_V : V ;
  tumma_vb_2_V : V ;
  tunna_vb_1_V : V ;
  tuppa_av_vbm_1_V2 : V2 ;
  turista_vb_1_V : V ;
  turnera_vb_1_V : V ;
  tuscha_vb_1_V : V ;
  tussa_vb_1_V : V ;
  tuta_vb_1_V : V ;
  tuta_i_vbm_1_V2 : V2 ;
  tutta_paa_vbm_1_1_V2 : V2 ;
  tveka_vb_1_V : V ;
  tvina_vb_1_V : V ;
  tvinna_vb_1_V : V ;
  tvaera_vb_1_1_V : V ;
  tvaerbromsa_vb_1_1_V : V ;
  tvaernita_vb_1_1_V : V ;
  tvaersa_vb_1_1_V : V ;
  tvaerstanna_vb_1_1_V : V ;
  tvaervaenda_vb_1_1_V : V ;
  tvaetta_vb_1_1_V : V ;
  tvaetta_av_vbm_1_1_V2 : V2 ;
  tvaala_in_vbm_1_1_V2 : V2 ;
  tvaala_till_vbm_1_1_V2 : V2 ;
  tvaangsinloesa_vb_1_1_V : V ;
  twista_vb_1_V : V ;
  tya_vb_1_V : V ;
  tycka_vb_1_V : V ;
  tygla_vb_1_V : V ;
  tyna_vb_1_V : V ;
  tyna_av_vbm_1_V2 : V2 ;
  tynga_vb_1_V : V ;
  tysta_vb_1_V : V ;
  tystna_vb_1_V : V ;
  taecka_vb_1_1_V : V ;
  taelta_vb_1_1_V : V ;
  taenda_vb_1_1_V : V ;
  taenka_vb_1_1_V : V ;
  taerna_vb_1_1_V : V ;
  taeta_vb_1_1_V : V ;
  taetna_vb_1_1_V : V ;
  taaa_vb_1_1_V : V ;
  taaga_vb_1_1_V : V ;
  taaga_igenom_vbm_1_1_V2 : V2 ;
  taaga_ut_vbm_1_1_V2 : V2 ;
  taagluffa_vb_1_1_V : V ;
  taarta_vb_1_1_V : V ;
  toea_vb_1_1_V : V ;
  toelta_vb_1_1_V : V ;
  toemma_vb_1_1_V : V ;
  toenta_vb_1_1_V : V ;
  toerna_vb_1_1_V : V ;
  toerna_in_vbm_1_1_V2 : V2 ;
  toersta_vb_1_1_V : V ;
  toeva_vb_1_1_V : V ;
  uggla_vb_1_V : V ;
  ugnsbaka_vb_1_V : V ;
  ugnsgraedda_vb_1_1_V : V ;
  ugnssteka_vb_1_V : V ;
  ugnstorka_vb_1_V : V ;
  ulka_vb_1_V : V ;
  ulma_vb_1_V : V ;
  umeaabo_vb_1_1_V : V ;
  umgaella_vb_1_1_V : V ;
  undangoemma_vb_1_1_V : V ;
  undanskaffa_vb_1_V : V ;
  undanskifta_vb_1_V : V ;
  undanskuffa_vb_1_V : V ;
  undanskymma_vb_1_V : V ;
  undansnilla_vb_1_V : V ;
  undantraenga_vb_1_1_V : V ;
  underanvaenda_vb_1_1_V : V ;
  underblaasa_vb_1_1_V : V ;
  underbygga_vb_1_V : V ;
  undergraeva_vb_1_1_V : V ;
  underkasta_vb_1_V : V ;
  underkuva_vb_1_V : V ;
  underkvista_vb_1_V : V ;
  underkyla_vb_1_V : V ;
  underlappa_vb_1_V : V ;
  underordna_vb_1_V : V ;
  underraetta_vb_1_1_V : V ;
  underskatta_vb_1_V : V ;
  understrecka_vb_1_V : V ;
  understaella_vb_1_1_V : V ;
  undersoeka_vb_1_1_V : V ;
  undertrycka_vb_1_V : V ;
  undervisa_vb_1_V : V ;
  undfly_vb_1_V : V ;
  undfaegna_vb_1_1_V : V ;
  undskylla_vb_1_V : V ;
  undulera_vb_1_V : V ;
  unkna_vb_1_V : V ;
  unna_vb_1_V : V ;
  upparbeta_vb_1_V : V ;
  uppassa_vb_1_V : V ;
  uppblanda_vb_1_V : V ;
  uppbringa_vb_1_V : V ;
  uppbygga_vb_1_V : V ;
  uppbaada_vb_1_1_V : V ;
  uppdaga_vb_1_V : V ;
  uppdela_vb_1_V : V ;
  uppegga_vb_1_V : V ;
  uppenbara_vb_1_V : V ;
  uppfatta_vb_1_V : V ;
  uppfriska_vb_1_V : V ;
  uppfylla_vb_1_V : V ;
  uppfaanga_vb_1_1_V : V ;
  uppfoerstora_vb_1_1_V : V ;
  upphaussa_vb_1_V : V ;
  upphetsa_vb_1_V : V ;
  upphetta_vb_1_V : V ;
  upphitta_vb_1_V : V ;
  upphaemta_vb_1_1_V : V ;
  upphaeva_vb_1_1_V : V ;
  uppjazza_vb_1_V : V ;
  uppkalla_vb_1_V : V ;
  uppklara_vb_1_V : V ;
  uppkvista_vb_1_V : V ;
  upplappa_vb_1_V : V ;
  uppleva_vb_1_V : V ;
  uppliva_vb_1_V : V ;
  upplysa_vb_1_V : V ;
  upplaesa_vb_1_1_V : V ;
  upploesa_vb_1_1_V : V ;
  uppmana_vb_1_V : V ;
  uppmjuka_vb_1_V : V ;
  uppmaeta_vb_1_1_V : V ;
  uppnaa_vb_1_1_V : V ;
  uppnaala_vb_1_1_V : V ;
  upprada_vb_1_V : V ;
  upprensa_vb_1_V : V ;
  upprepa_vb_1_V : V ;
  uppresa_vb_1_V : V ;
  upprusta_vb_1_V : V ;
  upprymma_vb_1_V : V ;
  uppraetta_vb_1_1_V : V ;
  uppskatta_vb_1_V : V ;
  uppsluka_vb_1_V : V ;
  uppsnabba_vb_1_V : V ;
  uppsnappa_vb_1_V : V ;
  uppspjaelka_vb_1_1_V : V ;
  uppspaara_vb_1_1_V : V ;
  uppstrama_vb_1_V : V ;
  uppstaella_vb_1_1_V : V ;
  uppstaemma_vb_1_1_V : V ;
  uppsoeka_vb_1_1_V : V ;
  uppteckna_vb_1_V : V ;
  upptorna_vb_1_V : V ;
  upptrampa_vb_1_V : V ;
  upptrappa_vb_1_V : V ;
  upptrissa_vb_1_V : V ;
  upptaecka_vb_1_1_V : V ;
  upptaenda_vb_1_1_V : V ;
  uppvakta_vb_1_V : V ;
  uppvaecka_vb_1_1_V : V ;
  uppvaega_vb_1_1_V : V ;
  uppvaerma_vb_1_1_V : V ;
  uppoeva_vb_1_1_V : V ;
  urarta_vb_1_V : V ;
  urgera_vb_1_V : V ;
  urinera_vb_1_V : V ;
  urkalka_vb_1_V : V ;
  urlaka_vb_1_V : V ;
  ursaka_vb_1_V : V ;
  urskulda_vb_1_V : V ;
  ursprungsmaerka_vb_1_1_V : V ;
  ursaekta_vb_1_1_V : V ;
  utanordna_vb_1_V : V ;
  utarbeta_vb_1_V : V ;
  utarma_vb_1_V : V ;
  utbilda_vb_1_V : V ;
  utbua_vb_1_V : V ;
  utbygga_vb_1_V : V ;
  utbyta_vb_1_V : V ;
  utdela_vb_1_V : V ;
  utdika_vb_1_V : V ;
  utdunsta_vb_1_V : V ;
  utdoema_vb_1_1_V : V ;
  utelaemna_vb_1_1_V : V ;
  utelaasa_vb_1_1_V : V ;
  utestaenga_vb_1_1_V : V ;
  utfiska_vb_1_V : V ;
  utflagga_vb_1_V : V ;
  utforma_vb_1_V : V ;
  utforska_vb_1_V : V ;
  utfrakta_vb_1_V : V ;
  utfraaga_vb_1_1_V : V ;
  utfylla_vb_1_V : V ;
  utfaella_vb_1_1_V : V ;
  utfaerda_vb_1_1_V : V ;
  utglesa_vb_1_V : V ;
  utgrunda_vb_1_V : V ;
  utgraeva_vb_1_1_V : V ;
  uthaerda_vb_1_1_V : V ;
  utjaemna_vb_1_1_V : V ;
  utkasta_vb_1_V : V ;
  utklara_vb_1_V : V ;
  utklassa_vb_1_V : V ;
  utkora_vb_1_V : V ;
  utkraeva_vb_1_1_V : V ;
  utkyla_vb_1_V : V ;
  utkaempa_vb_1_1_V : V ;
  utlotta_vb_1_V : V ;
  utlova_vb_1_V : V ;
  utlysa_vb_1_V : V ;
  utlaesa_vb_1_1_V : V ;
  utlaana_vb_1_1_V : V ;
  utloesa_vb_1_1_V : V ;
  utmana_vb_1_V : V ;
  utmatta_vb_1_V : V ;
  utmynna_vb_1_V : V ;
  utmaerka_vb_1_1_V : V ;
  utmaeta_vb_1_1_V : V ;
  utmaala_vb_1_1_V : V ;
  utnyttja_vb_1_V : V ;
  utnaemna_vb_1_1_V : V ;
  utpeka_vb_1_V : V ;
  utplaana_vb_1_1_V : V ;
  utpressa_vb_1_V : V ;
  utpricka_vb_1_V : V ;
  utprova_vb_1_V : V ;
  utproeva_vb_1_1_V : V ;
  utrensa_vb_1_V : V ;
  utropa_vb_1_V : V ;
  utrota_vb_1_V : V ;
  utrusta_vb_1_V : V ;
  utrymma_vb_1_V : V ;
  utraetta_vb_1_1_V : V ;
  utsira_vb_1_V : V ;
  utskeppa_vb_1_V : V ;
  utskaenka_vb_1_1_V : V ;
  utslunga_vb_1_V : V ;
  utslussa_vb_1_V : V ;
  utslaecka_vb_1_1_V : V ;
  utslaeta_vb_1_1_V : V ;
  utsmycka_vb_1_V : V ;
  utspana_vb_1_V : V ;
  utspisa_vb_1_V : V ;
  utspy_vb_1_V : V ;
  utspaerra_vb_1_1_V : V ;
  utstaka_vb_1_V : V ;
  utstraecka_vb_1_1_V : V ;
  utstraala_vb_1_1_V : V ;
  utstaella_vb_1_1_V : V ;
  utstoeta_vb_1_1_V : V ;
  utsyna_vb_1_V : V ;
  utsaenda_vb_1_1_V : V ;
  utsoeka_vb_1_1_V : V ;
  uttala_vb_1_V : V ;
  uttolka_vb_1_V : V ;
  uttrycka_vb_1_V : V ;
  uttroetta_vb_1_1_V : V ;
  uttunna_vb_1_V : V ;
  uttoemma_vb_1_1_V : V ;
  utverka_vb_1_V : V ;
  utvidga_vb_1_V : V ;
  utvisa_vb_1_V : V ;
  utoeka_vb_1_1_V : V ;
  utoeva_vb_1_1_V : V ;
  vabba_vb_1_V : V ;
  vackla_vb_1_V : V ;
  vada_vb_1_V : V ;
  vada_igenom_vbm_1_V2 : V2 ;
  vagabondera_vb_1_V : V ;
  vagga_vb_1_V : V ;
  vaja_vb_1_V : V ;
  vaka_vb_1_V : V ;
  vakta_vb_1_V : V ;
  valacka_vb_1_V : V ;
  valfuska_vb_1_V : V ;
  valka_vb_1_V : V ;
  valkgarva_vb_1_V : V ;
  valla_vb_1_V : V ;
  valla_in_vbm_1_V2 : V2 ;
  vallfaerda_vb_1_1_V : V ;
  valna_vb_1_V : V ;
  valpa_vb_1_V : V ;
  valsa_vb_1_V : V ;
  valsa_ut_vbm_2_V2 : V2 ;
  vampa_vb_1_V : V ;
  vandra_igenom_vbm_1_V2 : V2 ;
  vanka_vb_1_V : V ;
  vanna_vb_1_V : V ;
  vanskoeta_vb_1_1_V : V ;
  vanstaella_vb_1_1_V : V ;
  vantolka_vb_1_V : V ;
  vanvaarda_vb_1_1_V : V ;
  vanvoerda_vb_1_1_V : V ;
  vanaera_vb_1_1_V : V ;
  vapenvaegra_vb_1_1_V : V ;
  vara_vb_2_V : V ;
  varga_vb_1_V : V ;
  varmbona_vb_1_V : V ;
  varmroeka_vb_1_1_V : V ;
  varna_vb_1_V : V ;
  varpa_vb_1_V : V ;
  varsko_vb_1_V : V ;
  varsla_vb_1_V : V ;
  varsna_vb_1_V : V ;
  varva_vb_1_V : V ;
  vaska_vb_1_V : V ;
  vaska_ut_vbm_1_V2 : V2 ;
  vattna_vb_1_V : V ;
  vattna_ur_vbm_1_V2 : V2 ;
  vaxa_vb_1_V : V ;
  vecka_vb_1_V : V ;
  veckohandla_vb_1_V : V ;
  veckopendla_vb_1_V : V ;
  vederfaas_vb_1_1_V : V ;
  vedergaella_vb_1_1_V : V ;
  vederkvicka_vb_1_V : V ;
  vedervaaga_vb_1_1_V : V ;
  vegetera_vb_1_V : V ;
  veklaga_vb_1_V : V ;
  vekna_vb_1_V : V ;
  vela_vb_1_V : V ;
  verka_vb_1_V : V ;
  verkstaella_vb_1_1_V : V ;
  vetenskapa_vb_1_V : V ;
  veva_vb_1_V : V ;
  vibrera_vb_1_V : V ;
  vicka_vb_1_V : V ;
  vidga_vb_1_V : V ;
  vidhaefta_vb_1_1_V : V ;
  vidhaenga_vb_1_1_V : V ;
  vidtala_vb_1_V : V ;
  vifta_vb_1_V : V ;
  viga_vb_1_V : V ;
  vigga_vb_1_V : V ;
  vigilera_vb_1_V : V ;
  vikariera_vb_1_V : V ;
  vila_vb_1_V : V ;
  villkora_vb_1_V : V ;
  vimla_vb_1_V : V ;
  vimsa_vb_1_V : V ;
  vina_vb_2_V : V ;
  vinda_vb_1_V : V ;
  vindla_vb_1_V : V ;
  vindsurfa_vb_1_V : V ;
  vingklippa_vb_1_V : V ;
  vingla_vb_1_V : V ;
  vinka_vb_1_V : V ;
  vinkla_vb_1_V : V ;
  vinscha_vb_1_V : V ;
  vinstvarna_vb_1_V : V ;
  vinterbona_vb_1_V : V ;
  vippa_vb_1_V : V ;
  vira_vb_1_V : V ;
  virka_vb_1_V : V ;
  virra_vb_1_V : V ;
  virvla_vb_1_V : V ;
  visa_vb_1_V : V ;
  viska_vb_1_V : V ;
  vispa_vb_1_V : V ;
  vissla_vb_1_V : V ;
  vissna_vb_1_V : V ;
  vitgloedga_vb_1_1_V : V ;
  vitkalka_vb_1_V : V ;
  vitmena_vb_1_V : V ;
  vitsa_vb_1_V : V ;
  vitsorda_vb_1_V : V ;
  vitta_vb_1_V : V ;
  vittja_vb_1_V : V ;
  volma_vb_1_V : V ;
  volontera_vb_1_V : V ;
  voltigera_vb_1_V : V ;
  vomera_vb_1_V : V ;
  votera_vb_1_V : V ;
  vraka_vb_1_V : V ;
  vricka_vb_1_V : V ;
  vraeka_vb_1_1_V : V ;
  vraenga_vb_1_1_V : V ;
  vraala_vb_1_1_V : V ;
  vraalplugga_vb_1_1_V : V ;
  vroevla_vb_1_1_V : V ;
  vula_vb_1_V : V ;
  vulka_vb_1_V : V ;
  vurma_vb_1_V : V ;
  vurpa_vb_1_V : V ;
  vyssa_vb_1_V : V ;
  vyssja_vb_1_V : V ;
  vaecka_vb_1_1_V : V ;
  vaega_vb_1_1_V : V ;
  vaega_vb_2_1_V : V ;
  vaega_vb_3_13_V : V ;
  vaelfaegna_vb_1_1_V : V ;
  vaella_vb_1_1_V : V ;
  vaelsigna_vb_1_1_V : V ;
  vaelsigne_vb_1_1_V : V ;
  vaelta_vb_2_1_V : V ;
  vaelva_vb_1_1_V : V ;
  vaenda_vb_1_1_V : V ;
  vaenda_vb_2_1_V : V ;
  vaendsteka_vb_1_1_V : V ;
  vaensterknaecka_vb_1_1_V : V ;
  vaensterprassla_vb_1_1_V : V ;
  vaenta_vb_1_1_V : V ;
  vaepna_vb_1_1_V : V ;
  vaerka_vb_1_1_V : V ;
  vaerma_vb_1_1_V : V ;
  vaerna_vb_1_1_V : V ;
  vaerpa_vb_1_1_V : V ;
  vaerva_vb_1_1_V : V ;
  vaesa_vb_1_1_V : V ;
  vaessa_vb_1_1_V : V ;
  vaeta_vb_1_1_V : V ;
  vaetska_vb_1_1_V : V ;
  vaeva_vb_1_1_V : V ;
  vaexelverka_vb_1_1_V : V ;
  vaexla_vb_1_1_V : V ;
  vaaga_vb_1_1_V : V ;
  vaaldgaesta_vb_1_1_V : V ;
  vaalla_vb_1_1_V : V ;
  vaalma_vb_1_1_V : V ;
  vaanna_vb_1_1_V : V ;
  vaara_vb_1_1_V : V ;
  vaarda_vb_1_1_V : V ;
  vaardsloesa_vb_1_1_V : V ;
  vaatkola_vb_1_1_V : V ;
  vaatpressa_vb_1_1_V : V ;
  voerda_vb_1_1_V : V ;
  x_a_vb_1_V : V ;
  xa_vb_1_V : V ;
  yla_vb_1_V : V ;
  ympa_vb_1_V : V ;
  yngla_vb_1_V : V ;
  ynka_vb_1_V : V ;
  yoga_vb_1_V : V ;
  yppa_vb_1_V : V ;
  yra_vb_1_V : V ;
  yrka_vb_1_V : V ;
  yrkesarbeta_vb_1_V : V ;
  ysta_vb_1_V : V ;
  zappa_vb_1_V : V ;
  zooma_vb_1_V : V ;
  aeckla_vb_1_1_V : V ;
  aega_vb_1_1_V : V ;
  aega_vb_2_1_V : V ;
  aegna_vb_1_1_V : V ;
  aekta_vb_1_1_V : V ;
  aelga_vb_1_1_V : V ;
  aelska_vb_2_1_V : V ;
  aelta_vb_1_1_V : V ;
  aemna_vb_1_1_V : V ;
  aendvaenda_vb_1_1_V : V ;
  aengsla_vb_1_1_V : V ;
  aentra_vb_1_1_V : V ;
  aera_vb_1_1_V : V ;
  aerekraenka_vb_1_1_V : V ;
  aerga_vb_1_1_V : V ;
  aerja_vb_1_1_V : V ;
  aerna_vb_1_1_V : V ;
  aerva_vb_1_1_V : V ;
  aeska_vb_1_1_V : V ;
  aeventyra_vb_1_1_V : V ;
  aaberopa_vb_1_1_V : V ;
  aadoema_vb_1_1_V : V ;
  aaka_vb_1_1_V : V ;
  aakalla_vb_1_1_V : V ;
  aaklaga_vb_1_1_V : V ;
  aala_vb_1_1_V : V ;
  aaldersbestaemma_vb_1_1_V : V ;
  aanga_vb_1_1_V : V ;
  aangfoervaella_vb_1_1_V : V ;
  aangra_vb_1_1_V : V ;
  aasamka_vb_1_1_V : V ;
  aaska_vb_1_1_V : V ;
  aaskaada_vb_1_1_V : V ;
  aastunda_vb_1_1_V : V ;
  aasyfta_vb_1_1_V : V ;
  aatala_vb_1_1_V : V ;
  aateranlaenda_vb_1_1_V : V ;
  aateranskaffa_vb_1_1_V : V ;
  aateranvaenda_vb_1_1_V : V ;
  aaterberaetta_vb_1_1_V : V ;
  aaterbesoeka_vb_1_1_V : V ;
  aaterflytta_vb_1_1_V : V ;
  aaterfoerena_vb_1_1_V : V ;
  aatergaelda_vb_1_1_V : V ;
  aaterhaemta_vb_1_1_V : V ;
  aaterkalla_vb_1_1_V : V ;
  aaterkasta_vb_1_1_V : V ;
  aaterklinga_vb_1_1_V : V ;
  aaterkraeva_vb_1_1_V : V ;
  aaterloesa_vb_1_1_V : V ;
  aaterropa_vb_1_1_V : V ;
  aaterskalla_vb_1_1_V : V ;
  aaterskapa_vb_1_1_V : V ;
  aaterstudsa_vb_1_1_V : V ;
  aaterstaella_vb_1_1_V : V ;
  aatersaenda_vb_1_1_V : V ;
  aatertaaga_vb_1_1_V : V ;
  aateruppbygga_vb_1_1_V : V ;
  aateruppleva_vb_1_1_V : V ;
  aateruppliva_vb_1_1_V : V ;
  aateruppraetta_vb_1_1_V : V ;
  aateruppvaecka_vb_1_1_V : V ;
  aaterutstraala_vb_1_1_V : V ;
  aaterutsaenda_vb_1_1_V : V ;
  aaterverka_vb_1_1_V : V ;
  aatervaenda_vb_1_1_V : V ;
  aatgaerda_vb_1_1_V : V ;
  aatraa_vb_1_1_V : V ;
  aatstrama_vb_1_1_V : V ;
  aavila_vb_1_1_V : V ;
  oebo_vb_1_1_V : V ;
  oedmjuka_vb_1_1_V : V ;
  oegna_vb_1_1_V : V ;
  oeka_vb_1_1_V : V ;
  oeka_vb_2_1_V : V ;
  oela_vb_1_1_V : V ;
  oemka_vb_1_1_V : V ;
  oemma_vb_1_1_V : V ;
  oemsa_vb_1_1_V : V ;
  oenska_vb_1_1_V : V ;
  oerfila_vb_1_1_V : V ;
  oerla_vb_1_1_V : V ;
  oeronmaerka_vb_1_1_V : V ;
  oesa_vb_1_1_V : V ;
  oesregna_vb_1_1_V : V ;
  oeva_vb_1_1_V : V ;
  oeveranstraenga_vb_1_1_V : V ;
  oeverantvarda_vb_1_1_V : V ;
  oeveranvaenda_vb_1_1_V : V ;
  oeverarbeta_vb_1_1_V : V ;
  oeverbefolka_vb_1_1_V : V ;
  oeverbeskydda_vb_1_1_V : V ;
  oeverbetona_vb_1_1_V : V ;
  oeverbevisa_vb_1_1_V : V ;
  oeverblicka_vb_1_1_V : V ;
  oeverboka_vb_1_1_V : V ;
  oeverbrygga_vb_1_1_V : V ;
  oeverensstaemma_vb_1_1_V : V ;
  oeverflytta_vb_1_1_V : V ;
  oeverfloeda_vb_1_1_V : V ;
  oeverglaensa_vb_1_1_V : V ;
  oeverhetta_vb_1_1_V : V ;
  oeverhopa_vb_1_1_V : V ;
  oeverhoppa_vb_1_1_V : V ;
  oeverklaga_vb_1_1_V : V ;
  oeverlappa_vb_1_1_V : V ;
  oeverlasta_vb_1_1_V : V ;
  oeverleva_vb_1_1_V : V ;
  oeverlista_vb_1_1_V : V ;
  oevermanna_vb_1_1_V : V ;
  oevernatta_vb_1_1_V : V ;
  oeverproeva_vb_1_1_V : V ;
  oeverraecka_vb_1_1_V : V ;
  oeverroesta_vb_1_1_V : V ;
  oeverskatta_vb_1_1_V : V ;
  oeverskugga_vb_1_1_V : V ;
  oeverskygga_vb_1_1_V : V ;
  oeverskyla_vb_1_1_V : V ;
  oeverskaada_vb_1_1_V : V ;
  oeversaenda_vb_1_1_V : V ;
  oevertala_vb_1_1_V : V ;
  oeverteckna_vb_1_1_V : V ;
  oevertrumfa_vb_1_1_V : V ;
  oevertraeffa_vb_1_1_V : V ;
  oevertyga_vb_1_1_V : V ;
  oevervaka_vb_1_1_V : V ;
  oevervaega_vb_1_1_V : V ;
  oevervaega_vb_2_1_V : V ;
  oevervaeldiga_vb_1_1_V : V ;
  oeveroesa_vb_1_1_V : V ;
  DNA_testa_vb_1_V : V ;
  GPS_a_vb_1_V : V ;
  GPSa_vb_1_V : V ;
  GPSa_vb_2_V : V ;
  OCR_a_vb_1_V : V ;
  OCRa_vb_1_V : V ;
  abbreviera_vb_1_V : V ;
  abdikera_vb_1_V : V ;
  abonnera_vb_1_V : V ;
  abortera_vb_1_V : V ;
  abradera_vb_1_V : V ;
  absolvera_vb_1_V : V ;
  absorbera_vb_1_V : V ;
  absorbera_vb_2_V : V ;
  abstrahera_vb_1_V : V ;
  accedera_vb_1_V : V ;
  accelerera_vb_2_V : V ;
  accentuera_vb_1_V : V ;
  acceptera_vb_1_V : V ;
  accessa_vb_1_V : V ;
  acklimatisera_vb_1_V : V ;
  ackommodera_vb_1_V : V ;
  ackompanjera_vb_1_V : V ;
  ackordera_vb_1_V : V ;
  ackreditera_vb_1_V : V ;
  ackumulera_vb_1_V : V ;
  ackvirera_vb_1_V : V ;
  adaptera_vb_1_V : V ;
  addera_vb_1_V : V ;
  adjungera_vb_1_V : V ;
  adla_vb_1_V : V ;
  administrera_vb_1_V : V ;
  adoptera_vb_1_V : V ;
  adressera_vb_1_V : V ;
  adsorbera_vb_1_V : V ;
  aducera_vb_1_V : V ;
  advocera_vb_1_V : V ;
  afficiera_vb_1_V : V ;
  affinera_vb_1_V : V ;
  affischera_vb_1_V : V ;
  afrikanisera_vb_1_V : V ;
  aga_vb_1_V : V ;
  agera_vb_2_V : V ;
  agglomerera_vb_1_V : V ;
  agglutinera_vb_1_V : V ;
  aggravera_vb_1_V : V ;
  agitera_vb_1_V : V ;
  agna_vb_1_V : V ;
  ajournera_vb_1_V : V ;
  akta_vb_2_V : V ;
  aktivera_vb_1_V : V ;
  aktualisera_vb_1_V : V ;
  alarmera_vb_1_V : V ;
  alfabetisera_vb_1_V : V ;
  alienera_vb_1_V : V ;
  allegorisera_vb_1_V : V ;
  alliera_vb_1_V : V ;
  allitterera_vb_1_V : V ;
  allmaenbilda_vb_1_1_V : V ;
  allokera_vb_1_V : V ;
  alludera_vb_1_V : V ;
  alternera_vb_1_V : V ;
  aluminera_vb_1_V : V ;
  alvluckra_vb_1_V : V ;
  amalgamera_vb_1_V : V ;
  ambulera_vb_1_V : V ;
  amerikanisera_vb_1_V : V ;
  amma_vb_1_V : V ;
  amortera_vb_1_V : V ;
  amplifiera_vb_1_V : V ;
  amplitudmodulera_vb_1_V : V ;
  amputera_vb_1_V : V ;
  ana_vb_1_V : V ;
  analysera_vb_1_V : V ;
  anamma_vb_1_V : V ;
  anfaekta_vb_1_1_V : V ;
  anglisera_vb_1_V : V ;
  anhopa_vb_1_V : V ;
  animera_vb_1_V : V ;
  anklaga_vb_1_V : V ;
  ankra_vb_1_V : V ;
  anlita_vb_1_V : V ;
  anmana_vb_1_V : V ;
  anmoda_vb_1_V : V ;
  annektera_vb_1_V : V ;
  annihilera_vb_1_V : V ;
  annonsera_vb_1_V : V ;
  annotera_vb_1_V : V ;
  annullera_vb_1_V : V ;
  anodisera_vb_1_V : V ;
  anonymisera_vb_1_V : V ;
  anordna_vb_1_V : V ;
  anpassa_vb_1_V : V ;
  anrika_vb_1_V : V ;
  anropa_vb_1_V : V ;
  anraetta_vb_1_1_V : V ;
  ansa_vb_1_V : V ;
  ansamla_vb_1_V : V ;
  anskaffa_vb_1_V : V ;
  anspela_vb_1_V : V ;
  anstifta_vb_1_V : V ;
  anstorma_vb_1_V : V ;
  antasta_vb_1_V : V ;
  antecipera_vb_1_V : V ;
  anteckna_vb_1_V : V ;
  antedatera_vb_1_V : V ;
  antichambrera_vb_1_V : V ;
  antikbehandla_vb_1_V : V ;
  antikfynda_vb_1_V : V ;
  antikisera_vb_1_V : V ;
  antireflexbehandla_vb_1_V : V ;
  antraeffa_vb_1_1_V : V ;
  antvarda_vb_1_V : V ;
  antaaga_vb_1_1_V : V ;
  anvisa_vb_1_V : V ;
  apostrofera_vb_1_V : V ;
  appellera_vb_1_V : V ;
  applicera_vb_1_V : V ;
  applaadera_vb_1_1_V : V ;
  apportera_vb_1_V : V ;
  appreciera_vb_1_V : V ;
  appretera_vb_1_V : V ;
  approchera_vb_1_V : V ;
  approximera_vb_1_V : V ;
  aptera_vb_1_V : V ;
  arbeta_vb_1_V : V ;
  arbetspendla_vb_1_V : V ;
  arborra_vb_1_V : V ;
  argumentera_vb_1_V : V ;
  arkaisera_vb_1_V : V ;
  arkebusera_vb_1_V : V ;
  arkivera_vb_1_V : V ;
  armera_vb_1_V : V ;
  arra_vb_1_V : V ;
  arrangera_vb_1_V : V ;
  arrendera_vb_1_V : V ;
  arrestera_vb_1_V : V ;
  arrondera_vb_1_V : V ;
  artikulera_vb_1_V : V ;
  arvodera_vb_1_V : V ;
  asfaltera_vb_1_V : V ;
  aska_vb_1_V : V ;
  aspirera_vb_1_V : V ;
  assignera_vb_1_V : V ;
  assimilera_vb_1_V : V ;
  assistera_vb_1_V : V ;
  associera_vb_1_V : V ;
  assurera_vb_1_V : V ;
  atombomba_vb_1_V : V ;
  atrofiera_vb_1_V : V ;
  attackera_vb_1_V : V ;
  attestera_vb_1_V : V ;
  attrahera_vb_1_V : V ;
  attrappera_vb_1_V : V ;
  attribuera_vb_1_V : V ;
  auktionera_vb_1_V : V ;
  auktorisera_vb_1_V : V ;
  auskultera_vb_1_V : V ;
  autenticera_vb_1_V : V ;
  autentifiera_vb_1_V : V ;
  autentisera_vb_1_V : V ;
  automatisera_vb_1_V : V ;
  ava_vb_1_V : V ;
  avancera_vb_1_V : V ;
  avannonsera_vb_1_V : V ;
  avbalka_vb_1_V : V ;
  avbarka_vb_1_V : V ;
  avbeta_vb_1_V : V ;
  avbetala_vb_1_V : V ;
  avbilda_vb_1_V : V ;
  avboka_vb_1_V : V ;
  avboerda_vb_1_1_V : V ;
  avdela_vb_1_V : V ;
  avdramatisera_vb_1_V : V ;
  avdunsta_vb_1_V : V ;
  avfatta_vb_1_V : V ;
  avfetta_vb_1_V : V ;
  avflytta_vb_1_V : V ;
  avfolka_vb_1_V : V ;
  avfordra_vb_1_V : V ;
  avfrosta_vb_1_V : V ;
  avfukta_vb_1_V : V ;
  avfyra_vb_1_V : V ;
  avfaerda_vb_1_1_V : V ;
  avgifta_vb_1_V : V ;
  avgraensa_vb_1_1_V : V ;
  avguda_vb_1_V : V ;
  avgaerda_vb_1_1_V : V ;
  avhandla_vb_1_V : V ;
  avhumanisera_vb_1_V : V ;
  avhaemta_vb_1_1_V : V ;
  avhaerda_vb_1_1_V : V ;
  avhoesta_vb_1_1_V : V ;
  avisa_vb_1_V : V ;
  avisera_vb_1_V : V ;
  avjaga_vb_1_V : V ;
  avjaemna_vb_1_1_V : V ;
  avkalka_vb_1_V : V ;
  avklara_vb_2_V : V ;
  avklinga_vb_1_V : V ;
  avknoppa_vb_1_V : V ;
  avkoda_vb_1_V : V ;
  avkolonisera_vb_1_V : V ;
  avkoppla_vb_1_V : V ;
  avkorta_vb_1_V : V ;
  avkriminalisera_vb_1_V : V ;
  avkristna_vb_1_V : V ;
  avkunna_vb_1_V : V ;
  avkoena_vb_1_1_V : V ;
  avla_vb_1_V : V ;
  avlagra_vb_1_V : V ;
  avlasta_vb_1_V : V ;
  avleverera_vb_1_V : V ;
  avliva_vb_1_V : V ;
  avlocka_vb_1_V : V ;
  avlossa_vb_1_V : V ;
  avlusa_vb_1_V : V ;
  avluta_vb_1_V : V ;
  avlyssna_vb_1_V : V ;
  avlaegsna_vb_1_1_V : V ;
  avlaemna_vb_1_1_V : V ;
  avlaenka_vb_1_1_V : V ;
  avloena_vb_1_1_V : V ;
  avloeva_vb_1_1_V : V ;
  avmagnetisera_vb_1_V : V ;
  avmaska_vb_1_V : V ;
  avmasta_vb_1_V : V ;
  avmatta_vb_1_V : V ;
  avmystifiera_vb_1_V : V ;
  avnavla_vb_1_V : V ;
  avnazifiera_vb_1_V : V ;
  avpassa_vb_1_V : V ;
  avpatrullera_vb_1_V : V ;
  avpersonifiera_vb_1_V : V ;
  avplana_vb_1_V : V ;
  avpolitisera_vb_1_V : V ;
  avpollettera_vb_1_V : V ;
  avportraettera_vb_1_1_V : V ;
  avpressa_vb_1_V : V ;
  avradikalisera_vb_1_V : V ;
  avreagera_vb_1_V : V ;
  avregistrera_vb_1_V : V ;
  avreglera_vb_1_V : V ;
  avromantisera_vb_1_V : V ;
  avrunda_vb_1_V : V ;
  avrusta_vb_1_V : V ;
  avraekna_vb_1_1_V : V ;
  avraetta_vb_1_1_V : V ;
  avsalta_vb_1_V : V ;
  avsegla_vb_1_V : V ;
  avskaffa_vb_1_V : V ;
  avskeda_vb_1_V : V ;
  avskaerma_vb_1_1_V : V ;
  avslipa_vb_1_V : V ;
  avsluta_vb_1_V : V ;
  avsloeja_vb_1_1_V : V ;
  avsmaka_vb_1_V : V ;
  avsmalna_vb_1_V : V ;
  avsnoppa_vb_1_V : V ;
  avsocialisera_vb_1_V : V ;
  avsomna_vb_1_V : V ;
  avspegla_vb_1_V : V ;
  avspela_vb_1_V : V ;
  avspisa_vb_1_V : V ;
  avspaerra_vb_1_1_V : V ;
  avstalinisera_vb_1_V : V ;
  avstanna_vb_1_V : V ;
  avstava_vb_1_V : V ;
  avstressa_vb_1_V : V ;
  avstycka_vb_1_V : V ;
  avsvalna_vb_1_V : V ;
  avsvavla_vb_1_V : V ;
  avsyna_vb_1_V : V ;
  avsaaga_vb_1_1_V : V ;
  avsoendra_vb_1_1_V : V ;
  avtacka_vb_1_V : V ;
  avtala_vb_1_V : V ;
  avtappa_vb_1_V : V ;
  avteckna_vb_1_V : V ;
  avtjaena_vb_1_1_V : V ;
  avtona_vb_1_V : V ;
  avtrappa_vb_1_V : V ;
  avtrubba_vb_1_V : V ;
  avtunna_vb_1_V : V ;
  avtaaga_vb_1_1_V : V ;
  avvakta_vb_1_V : V ;
  avvattna_vb_1_V : V ;
  avveckla_vb_1_V : V ;
  avverka_vb_1_V : V ;
  avvisa_vb_1_V : V ;
  avvita_vb_1_V : V ;
  avvittra_vb_1_V : V ;
  avvaepna_vb_1_1_V : V ;
  avyttra_vb_1_V : V ;
  axa_vb_1_V : V ;
  axiomatisera_vb_1_V : V ;
  axla_vb_1_V : V ;
  backa_vb_1_V : V ;
  backupa_vb_1_V : V ;
  backuppa_vb_1_V : V ;
  bada_vb_1_V : V ;
  badda_vb_1_V : V ;
  bagatellisera_vb_1_V : V ;
  baggboela_vb_1_1_V : V ;
  baissa_vb_1_V : V ;
  bajsa_vb_1_V : V ;
  baka_vb_1_V : V ;
  bakdanta_vb_1_V : V ;
  baktala_vb_1_V : V ;
  bala_vb_1_V : V ;
  balansera_vb_2_V : V ;
  ballotera_vb_1_V : V ;
  balsamera_vb_1_V : V ;
  banalisera_vb_1_V : V ;
  banda_vb_1_V : V ;
  banka_vb_1_V : V ;
  bankruttera_vb_1_V : V ;
  banna_vb_1_V : V ;
  banta_vb_2_V : V ;
  barka_vb_1_V : V ;
  barkympa_vb_1_V : V ;
  barlasta_vb_1_V : V ;
  barra_vb_1_V : V ;
  barrikadera_vb_1_V : V ;
  basera_vb_1_V : V ;
  basta_vb_1_V : V ;
  baxa_vb_1_V : V ;
  beakta_vb_1_V : V ;
  bearbeta_vb_1_V : V ;
  beatifiera_vb_1_V : V ;
  bebaada_vb_1_1_V : V ;
  becka_vb_1_V : V ;
  bedarra_vb_1_V : V ;
  bedroeva_vb_1_1_V : V ;
  bedyra_vb_1_V : V ;
  bedaara_vb_1_1_V : V ;
  bedoeva_vb_1_1_V : V ;
  beediga_vb_1_V : V ;
  befara_vb_1_V : V ;
  beflaecka_vb_1_1_V : V ;
  befolka_vb_1_V : V ;
  befordra_vb_1_V : V ;
  befrakta_vb_1_V : V ;
  befria_vb_1_V : V ;
  befrukta_vb_1_V : V ;
  befrynda_vb_1_V : V ;
  befraemja_vb_1_1_V : V ;
  befullmaektiga_vb_1_1_V : V ;
  begabba_vb_1_V : V ;
  begagna_vb_1_V : V ;
  begapa_vb_1_V : V ;
  begrunda_vb_1_V : V ;
  begraensa_vb_1_1_V : V ;
  begaava_vb_1_1_V : V ;
  behandla_vb_1_V : V ;
  behaerska_vb_1_1_V : V ;
  beivra_vb_1_V : V ;
  bejaka_vb_1_V : V ;
  bejubla_vb_1_V : V ;
  bekaja_vb_1_V : V ;
  bekika_vb_1_V : V ;
  beklaga_vb_1_V : V ;
  bekosta_vb_1_V : V ;
  bekransa_vb_1_V : V ;
  bekriga_vb_1_V : V ;
  bekraefta_vb_1_1_V : V ;
  bekymra_vb_1_V : V ;
  bekaempa_vb_1_1_V : V ;
  belamra_vb_1_V : V ;
  belasta_vb_1_V : V ;
  beledsaga_vb_1_V : V ;
  belaegra_vb_1_1_V : V ;
  belaana_vb_1_1_V : V ;
  beloena_vb_1_1_V : V ;
  bemanna_vb_1_V : V ;
  bemantla_vb_1_V : V ;
  bemedla_vb_1_V : V ;
  bemyndiga_vb_1_V : V ;
  bemaestra_vb_1_1_V : V ;
  bena_vb_1_V : V ;
  benaada_vb_1_1_V : V ;
  beordra_vb_1_V : V ;
  bepansra_vb_1_V : V ;
  beprisa_vb_1_V : V ;
  bepudra_vb_1_V : V ;
  berika_vb_1_V : V ;
  beriktiga_vb_1_V : V ;
  berusa_vb_1_V : V ;
  beraekna_vb_1_1_V : V ;
  beraetta_vb_1_1_V : V ;
  beraettiga_vb_1_1_V : V ;
  beroeva_vb_1_1_V : V ;
  besanna_vb_1_V : V ;
  besegla_vb_1_V : V ;
  besegra_vb_1_V : V ;
  besiktiga_vb_1_V : V ;
  besinna_vb_1_V : V ;
  besjaela_vb_1_1_V : V ;
  beskatta_vb_1_V : V ;
  beskicka_vb_1_V : V ;
  beskugga_vb_1_V : V ;
  beskydda_vb_1_V : V ;
  beskaerma_vb_1_1_V : V ;
  beskaada_vb_1_1_V : V ;
  besloeja_vb_1_1_V : V ;
  besmitta_vb_1_V : V ;
  besockra_vb_1_V : V ;
  besolda_vb_1_V : V ;
  bespeja_vb_1_V : V ;
  bespisa_vb_1_V : V ;
  bespola_vb_1_V : V ;
  bespotta_vb_1_V : V ;
  bespruta_vb_1_V : V ;
  bestorma_vb_1_V : V ;
  bestraffa_vb_1_V : V ;
  bestraala_vb_1_1_V : V ;
  bestycka_vb_1_V : V ;
  besudla_vb_1_V : V ;
  besvara_vb_1_V : V ;
  besvaera_vb_1_1_V : V ;
  beta_vb_1_V : V ;
  betalningssaekra_vb_1_1_V : V ;
  beteckna_vb_1_V : V ;
  betinga_vb_1_V : V ;
  betitla_vb_1_V : V ;
  betitta_vb_1_V : V ;
  betjaena_vb_1_1_V : V ;
  betona_vb_1_V : V ;
  betongera_vb_1_V : V ;
  betrakta_vb_1_V : V ;
  betrygga_vb_1_V : V ;
  betraeffa_vb_1_1_V : V ;
  betsa_vb_1_V : V ;
  betsla_vb_1_V : V ;
  betunga_vb_1_V : V ;
  betvivla_vb_1_V : V ;
  betyga_vb_1_V : V ;
  beundra_vb_1_V : V ;
  bevaka_vb_1_V : V ;
  bevara_vb_1_V : V ;
  bevattna_vb_1_V : V ;
  bevilja_vb_1_V : V ;
  bevisa_vb_1_V : V ;
  bevista_vb_1_V : V ;
  bevittna_vb_1_V : V ;
  bevaepna_vb_1_1_V : V ;
  bevaera_vb_1_1_V : V ;
  bevaerdiga_vb_1_1_V : V ;
  bida_vb_1_V : V ;
  bifoga_vb_1_V : V ;
  bikta_vb_1_V : V ;
  bila_vb_1_V : V ;
  bilda_vb_1_V : V ;
  biografera_vb_1_V : V ;
  bissera_vb_1_V : V ;
  bita_vb_2_V : V ;
  bivackera_vb_1_V : V ;
  bjussa_vb_1_V : V ;
  bjoerna_vb_1_1_V : V ;
  blada_vb_1_V : V ;
  blanchera_vb_1_V : V ;
  blanda_vb_1_V : V ;
  blanka_vb_1_V : V ;
  blankpolera_vb_1_V : V ;
  blekna_vb_1_V : V ;
  blessera_vb_1_V : V ;
  blidka_vb_1_V : V ;
  blindera_vb_1_V : V ;
  blindpressa_vb_1_V : V ;
  blinga_vb_1_V : V ;
  blixtfotografera_vb_1_V : V ;
  blixtinkalla_vb_1_V : V ;
  blocka_vb_1_V : V ;
  blockera_vb_1_V : V ;
  bloda_vb_1_V : V ;
  blogga_vb_1_V : V ;
  blommografera_vb_1_V : V ;
  blomstersmycka_vb_1_V : V ;
  blondera_vb_1_V : V ;
  blotta_vb_1_V : V ;
  bluffa_vb_1_V : V ;
  blya_vb_1_V : V ;
  blaecka_vb_1_1_V : V ;
  blaeda_vb_1_1_V : V ;
  blaenda_vb_1_1_V : V ;
  blaesta_vb_1_1_V : V ;
  blaakopiera_vb_1_1_V : V ;
  boasera_vb_1_V : V ;
  bobba_vb_1_V : V ;
  bocka_vb_1_V : V ;
  bogsera_vb_1_V : V ;
  bojkotta_vb_1_V : V ;
  boka_vb_1_V : V ;
  bokstavera_vb_1_V : V ;
  bolla_vb_1_V : V ;
  bomba_vb_1_V : V ;
  bombardera_vb_1_V : V ;
  bomma_vb_1_V : V ;
  bona_vb_1_V : V ;
  bondneka_vb_1_V : V ;
  bonga_vb_1_V : V ;
  bonitera_vb_1_V : V ;
  boota_vb_1_V : V ;
  borda_vb_1_V : V ;
  borga_vb_1_V : V ;
  borra_vb_1_V : V ;
  borsta_vb_1_V : V ;
  bortmontera_vb_1_V : V ;
  bortresonera_vb_1_V : V ;
  bortroeva_vb_1_1_V : V ;
  bortskaffa_vb_1_V : V ;
  bota_vb_1_V : V ;
  bottenreva_vb_1_V : V ;
  bottenskrapa_vb_1_V : V ;
  boxa_vb_1_V : V ;
  brandhaerja_vb_1_1_V : V ;
  brandskatta_vb_1_V : V ;
  brassa_vb_1_V : V ;
  bredda_vb_1_V : V ;
  bremsa_vb_1_V : V ;
  brevvaexla_vb_1_1_V : V ;
  briefa_vb_1_V : V ;
  brikettera_vb_1_V : V ;
  brisera_vb_1_V : V ;
  broa_vb_1_V : V ;
  brodda_vb_1_V : V ;
  brodera_vb_1_V : V ;
  bromera_vb_1_V : V ;
  bromsa_vb_1_V : V ;
  bronsera_vb_1_V : V ;
  broschera_vb_1_V : V ;
  brotscha_vb_1_V : V ;
  bruka_vb_1_V : V ;
  brunera_vb_1_V : V ;
  brunfaerga_vb_1_1_V : V ;
  brutalisera_vb_1_V : V ;
  braeda_vb_1_1_V : V ;
  braedda_vb_1_1_V : V ;
  braedfodra_vb_1_1_V : V ;
  braedsegla_vb_1_1_V : V ;
  braema_vb_1_1_V : V ;
  braennlackera_vb_1_1_V : V ;
  braennskada_vb_1_1_V : V ;
  braesera_vb_1_1_V : V ;
  braaka_vb_2_1_V : V ;
  broea_vb_1_1_V : V ;
  broeda_vb_1_1_V : V ;
  bubba_vb_1_V : V ;
  buda_vb_1_V : V ;
  budgetera_vb_1_V : V ;
  buffa_vb_1_V : V ;
  buklanda_vb_1_V : V ;
  bulta_vb_1_V : V ;
  bunta_vb_1_V : V ;
  burka_vb_1_V : V ;
  buska_vb_1_V : V ;
  bussa_vb_1_V : V ;
  buteljera_vb_1_V : V ;
  byraakratisera_vb_1_1_V : V ;
  baedda_vb_1_1_V : V ;
  baelga_vb_1_1_V : V ;
  baerga_vb_1_1_V : V ;
  baettra_vb_1_1_V : V ;
  baagna_vb_1_1_V : V ;
  boerja_vb_1_1_V : V ;
  boersnotera_vb_1_1_V : V ;
  boeta_vb_1_1_V : V ;
  camouflera_vb_1_V : V ;
  catera_vb_1_V : V ;
  cedera_vb_1_V : V ;
  celebrera_vb_1_V : V ;
  cementa_vb_1_V : V ;
  cementera_vb_1_V : V ;
  censurera_vb_1_V : V ;
  centra_vb_1_V : V ;
  centralisera_vb_1_V : V ;
  centrera_vb_1_V : V ;
  centrifugera_vb_1_V : V ;
  cernera_vb_1_V : V ;
  certifiera_vb_1_V : V ;
  chargera_vb_1_V : V ;
  charma_vb_1_V : V ;
  charmera_vb_1_V : V ;
  chartra_vb_1_V : V ;
  checka_vb_1_V : V ;
  chevrotera_vb_1_V : V ;
  chiffrera_vb_1_V : V ;
  chikanera_vb_1_V : V ;
  chocka_vb_1_V : V ;
  chockbehandla_vb_1_V : V ;
  chockera_vb_1_V : V ;
  choka_vb_1_V : V ;
  cirkulera_vb_1_V : V ;
  ciselera_vb_1_V : V ;
  citera_vb_1_V : V ;
  civilisera_vb_1_V : V ;
  cleara_vb_1_V : V ;
  covra_vb_1_V : V ;
  curatera_vb_1_V : V ;
  curera_vb_1_V : V ;
  curla_vb_2_V : V ;
  cykla_vb_1_V : V ;
  dadda_vb_1_V : V ;
  dagteckna_vb_1_V : V ;
  damma_vb_2_V : V ;
  dammtorka_vb_1_V : V ;
  dampa_vb_1_V : V ;
  dana_vb_1_V : V ;
  daska_vb_1_V : V ;
  databehandla_vb_1_V : V ;
  datera_vb_1_V : V ;
  datorisera_vb_1_V : V ;
  datorsimulera_vb_1_V : V ;
  datumparkera_vb_1_V : V ;
  debarkera_vb_1_V : V ;
  debattera_vb_1_V : V ;
  debitera_vb_1_V : V ;
  decentralisera_vb_1_V : V ;
  dechiffrera_vb_1_V : V ;
  decimera_vb_1_V : V ;
  dedicera_vb_1_V : V ;
  dedikera_vb_1_V : V ;
  deducera_vb_1_V : V ;
  defilera_vb_1_V : V ;
  definiera_vb_1_V : V ;
  deflorera_vb_1_V : V ;
  deformera_vb_1_V : V ;
  degenerera_vb_1_V : V ;
  degradera_vb_1_V : V ;
  dejta_vb_1_V : V ;
  dekantera_vb_1_V : V ;
  dekapitera_vb_1_V : V ;
  deklamera_vb_1_V : V ;
  deklarera_vb_1_V : V ;
  deklassera_vb_1_V : V ;
  deklinera_vb_1_V : V ;
  dekorera_vb_1_V : V ;
  dekouragera_vb_1_V : V ;
  dekretera_vb_1_V : V ;
  dela_vb_1_V : V ;
  delegera_vb_1_V : V ;
  dema_vb_1_V : V ;
  demaskera_vb_1_V : V ;
  dementera_vb_1_V : V ;
  demilitarisera_vb_1_V : V ;
  demissionera_vb_1_V : V ;
  demobilisera_vb_1_V : V ;
  demokratisera_vb_1_V : V ;
  demolera_vb_1_V : V ;
  demonisera_vb_1_V : V ;
  demonstrera_vb_1_V : V ;
  demontera_vb_1_V : V ;
  demoralisera_vb_1_V : V ;
  denaturalisera_vb_1_V : V ;
  denaturera_vb_1_V : V ;
  denotera_vb_1_V : V ;
  denudera_vb_1_V : V ;
  deodorisera_vb_1_V : V ;
  depatriera_vb_1_V : V ;
  depensera_vb_1_V : V ;
  deplacera_vb_1_V : V ;
  deponera_vb_1_V : V ;
  deportera_vb_1_V : V ;
  depreciera_vb_1_V : V ;
  derangera_vb_1_V : V ;
  derivera_vb_1_V : V ;
  desarmera_vb_1_V : V ;
  desavouera_vb_1_V : V ;
  desensibilisera_vb_1_V : V ;
  designa_vb_1_V : V ;
  designera_vb_1_V : V ;
  desinfektera_vb_1_V : V ;
  desinficera_vb_1_V : V ;
  desinformera_vb_1_V : V ;
  desorganisera_vb_1_V : V ;
  destabilisera_vb_1_V : V ;
  destillera_vb_1_V : V ;
  destinera_vb_1_V : V ;
  destruera_vb_1_V : V ;
  detachera_vb_1_V : V ;
  detaljgranska_vb_1_V : V ;
  detektera_vb_1_V : V ;
  determinera_vb_1_V : V ;
  detonera_vb_1_V : V ;
  detronisera_vb_1_V : V ;
  devalvera_vb_1_V : V ;
  dia_vb_1_V : V ;
  diagnosticera_vb_1_V : V ;
  diagnostisera_vb_1_V : V ;
  dialysera_vb_1_V : V ;
  differentiera_vb_1_V : V ;
  diffundera_vb_1_V : V ;
  diftongera_vb_1_V : V ;
  digerera_vb_1_V : V ;
  digga_vb_1_V : V ;
  dika_vb_1_V : V ;
  dikta_vb_1_V : V ;
  diktera_vb_1_V : V ;
  dimensionera_vb_1_V : V ;
  diplomera_vb_1_V : V ;
  dippa_vb_1_V : V ;
  dirigera_vb_1_V : V ;
  disambiguera_vb_1_V : V ;
  disciplinera_vb_1_V : V ;
  disharmoniera_vb_1_V : V ;
  diska_vb_1_V : V ;
  diska_vb_2_V : V ;
  diskontera_vb_1_V : V ;
  diskreditera_vb_1_V : V ;
  diskriminera_vb_1_V : V ;
  diskutera_vb_1_V : V ;
  diskvalificera_vb_1_V : V ;
  dispaschera_vb_1_V : V ;
  dispensera_vb_1_V : V ;
  dispergera_vb_1_V : V ;
  disponera_vb_1_V : V ;
  disputera_vb_1_V : V ;
  dissa_vb_1_V : V ;
  dissekera_vb_1_V : V ;
  dissimilera_vb_1_V : V ;
  dissociera_vb_1_V : V ;
  distansera_vb_1_V : V ;
  distrahera_vb_1_V : V ;
  distribuera_vb_1_V : V ;
  divergera_vb_1_V : V ;
  diversifiera_vb_1_V : V ;
  dividera_vb_1_V : V ;
  djuploda_vb_1_V : V ;
  dna_testa_vb_1_V : V ;
  docera_vb_2_V : V ;
  docka_vb_1_V : V ;
  dofta_vb_2_V : V ;
  doftmarkera_vb_1_V : V ;
  dogmatisera_vb_1_V : V ;
  doktorera_vb_1_V : V ;
  dokumentera_vb_1_V : V ;
  domesticera_vb_1_V : V ;
  domiciliera_vb_1_V : V ;
  dominera_vb_1_V : V ;
  domna_vb_1_V : V ;
  domptera_vb_1_V : V ;
  donera_vb_1_V : V ;
  donka_vb_1_V : V ;
  dopa_vb_1_V : V ;
  doppa_vb_1_V : V ;
  dosera_vb_1_V : V ;
  dossera_vb_1_V : V ;
  dotera_vb_1_V : V ;
  drabba_vb_1_V : V ;
  dragera_vb_1_V : V ;
  dragga_vb_1_V : V ;
  dramatisera_vb_1_V : V ;
  drapera_vb_1_V : V ;
  dratta_vb_1_V : V ;
  dreja_vb_1_V : V ;
  dressera_vb_1_V : V ;
  dreva_vb_1_V : V ;
  drifta_vb_1_V : V ;
  drilla_vb_1_V : V ;
  droga_vb_1_V : V ;
  droppa_vb_2_V : V ;
  drunkna_vb_1_V : V ;
  dryfta_vb_1_V : V ;
  draenera_vb_1_1_V : V ;
  dua_vb_1_V : V ;
  dubba_vb_1_V : V ;
  dubbelbeskatta_vb_1_V : V ;
  dubbelexponera_vb_1_V : V ;
  dubbla_vb_1_V : V ;
  dubblera_vb_1_V : V ;
  duka_vb_1_V : V ;
  dumpa_vb_1_V : V ;
  dunka_vb_1_V : V ;
  dunsta_vb_2_V : V ;
  dupera_vb_1_V : V ;
  duplicera_vb_1_V : V ;
  duscha_vb_1_V : V ;
  dyrka_vb_1_V : V ;
  daecka_vb_1_1_V : V ;
  daegga_vb_1_1_V : V ;
  daempa_vb_1_1_V : V ;
  daevna_vb_1_1_V : V ;
  daana_vb_2_1_V : V ;
  daara_vb_1_1_V : V ;
  doeda_vb_1_1_V : V ;
  doedfoerklara_vb_1_1_V : V ;
  doerja_vb_1_1_V : V ;
  doeva_vb_1_1_V : V ;
  e_maila_vb_1_V : V ;
  e_posta_vb_1_V : V ;
  edera_vb_1_V : V ;
  effacera_vb_1_V : V ;
  effektivera_vb_1_V : V ;
  effektivisera_vb_1_V : V ;
  effektuera_vb_1_V : V ;
  efterapa_vb_1_V : V ;
  efterbehandla_vb_1_V : V ;
  efterbilda_vb_1_V : V ;
  efterdatera_vb_1_V : V ;
  efterdebitera_vb_1_V : V ;
  efterforska_vb_1_V : V ;
  efterfraaga_vb_1_1_V : V ;
  efterhaerma_vb_1_1_V : V ;
  efterlikna_vb_1_V : V ;
  efterlaemna_vb_1_1_V : V ;
  eftermogna_vb_1_V : V ;
  efterrationalisera_vb_1_V : V ;
  efterstava_vb_1_V : V ;
  efterstraeva_vb_1_1_V : V ;
  eftersynkronisera_vb_1_V : V ;
  eftertaxera_vb_1_V : V ;
  eftertrakta_vb_1_V : V ;
  egalisera_vb_1_V : V ;
  egga_vb_1_V : V ;
  egoboosta_vb_1_V : V ;
  eka_vb_2_V : V ;
  ekfatslagra_vb_1_V : V ;
  ekipera_vb_1_V : V ;
  eklatera_vb_1_V : V ;
  eklaerera_vb_1_1_V : V ;
  ekoloda_vb_1_V : V ;
  ekonomisera_vb_1_V : V ;
  elaborera_vb_1_V : V ;
  elastisera_vb_1_V : V ;
  elda_vb_1_V : V ;
  eldhaerja_vb_1_1_V : V ;
  eldsaekra_vb_1_1_V : V ;
  elektrificera_vb_1_V : V ;
  elektrifiera_vb_1_V : V ;
  elektrisera_vb_1_V : V ;
  elidera_vb_1_V : V ;
  eliminera_vb_1_V : V ;
  eloxera_vb_1_V : V ;
  eludera_vb_1_V : V ;
  eluera_vb_1_V : V ;
  emaljera_vb_1_V : V ;
  emancipera_vb_1_V : V ;
  emballera_vb_1_V : V ;
  embarkera_vb_1_V : V ;
  embellera_vb_1_V : V ;
  emendera_vb_1_V : V ;
  emigrera_vb_1_V : V ;
  emittera_vb_1_V : V ;
  emotionalisera_vb_1_V : V ;
  emulgera_vb_1_V : V ;
  ena_vb_1_V : V ;
  endossera_vb_1_V : V ;
  enervera_vb_1_V : V ;
  engagera_vb_1_V : V ;
  enkelrikta_vb_1_V : V ;
  enkelteckna_vb_1_V : V ;
  enlevera_vb_1_V : V ;
  enrollera_vb_1_V : V ;
  ensa_vb_1_V : V ;
  ensilera_vb_1_V : V ;
  entlediga_vb_1_V : V ;
  entusiasmera_vb_1_V : V ;
  epilera_vb_1_V : V ;
  eposta_vb_1_V : V ;
  erfordra_vb_1_V : V ;
  erigera_vb_1_V : V ;
  erodera_vb_1_V : V ;
  erotisera_vb_1_V : V ;
  ertappa_vb_1_V : V ;
  eroevra_vb_1_1_V : V ;
  eskalera_vb_1_V : V ;
  eskortera_vb_1_V : V ;
  esteticera_vb_1_V : V ;
  estetisera_vb_1_V : V ;
  estimera_vb_1_V : V ;
  etablera_vb_1_V : V ;
  eterisera_vb_1_V : V ;
  etikettera_vb_1_V : V ;
  etsa_vb_1_V : V ;
  etymologisera_vb_1_V : V ;
  europeisera_vb_1_V : V ;
  evakuera_vb_1_V : V ;
  evaluera_vb_1_V : V ;
  evalvera_vb_1_V : V ;
  evaporera_vb_1_V : V ;
  examinera_vb_1_V : V ;
  excerpera_vb_1_V : V ;
  excitera_vb_1_V : V ;
  exekvera_vb_1_V : V ;
  exemplifiera_vb_1_V : V ;
  exercera_vb_1_V : V ;
  exkludera_vb_1_V : V ;
  exkommunicera_vb_1_V : V ;
  expandera_vb_1_V : V ;
  expatriera_vb_1_V : V ;
  expediera_vb_1_V : V ;
  expektorera_vb_1_V : V ;
  explicera_vb_1_V : V ;
  exploatera_vb_1_V : V ;
  explodera_vb_1_V : V ;
  exponera_vb_1_V : V ;
  exportera_vb_1_V : V ;
  expropriera_vb_1_V : V ;
  exstirpera_vb_1_V : V ;
  extemporera_vb_1_V : V ;
  extrahera_vb_1_V : V ;
  extrapolera_vb_1_V : V ;
  fabricera_vb_1_V : V ;
  fabulera_vb_1_V : V ;
  facebooka_vb_1_V : V ;
  facettera_vb_1_V : V ;
  fakturera_vb_1_V : V ;
  falna_vb_1_V : V ;
  falsa_vb_1_V : V ;
  falsifiera_vb_1_V : V ;
  falskskylta_vb_1_V : V ;
  famna_vb_1_V : V ;
  fantisera_vb_1_V : V ;
  fasa_vb_1_V : V ;
  fascinera_vb_1_V : V ;
  fasettera_vb_1_V : V ;
  fasonera_vb_1_V : V ;
  fastighetstaxera_vb_1_V : V ;
  fastkedja_vb_1_V : V ;
  fastklistra_vb_1_V : V ;
  fatta_vb_1_V : V ;
  favorisera_vb_1_V : V ;
  faxa_vb_1_V : V ;
  feja_vb_1_V : V ;
  fejka_vb_1_V : V ;
  felnavigera_vb_1_V : V ;
  felparkera_vb_1_V : V ;
  feltolka_vb_1_V : V ;
  femdubbla_vb_1_V : V ;
  femfaldiga_vb_1_V : V ;
  fermentera_vb_1_V : V ;
  fernissa_vb_1_V : V ;
  fetera_vb_1_V : V ;
  fickparkera_vb_1_V : V ;
  fila_vb_1_V : V ;
  filea_vb_1_V : V ;
  filera_vb_1_V : V ;
  filma_vb_1_V : V ;
  filmatisera_vb_1_V : V ;
  filta_vb_1_V : V ;
  filtrera_vb_1_V : V ;
  fimpa_vb_1_V : V ;
  finansiera_vb_1_V : V ;
  finfoerdela_vb_1_1_V : V ;
  fingera_vb_1_V : V ;
  fingranska_vb_1_V : V ;
  finhacka_vb_1_V : V ;
  finjustera_vb_1_V : V ;
  finka_vb_1_V : V ;
  finkamma_vb_1_V : V ;
  finlandisera_vb_1_V : V ;
  finputsa_vb_1_V : V ;
  finslipa_vb_1_V : V ;
  finta_vb_1_V : V ;
  fira_vb_1_V : V ;
  fiska_vb_1_V : V ;
  fixa_vb_1_V : V ;
  fixera_vb_1_V : V ;
  fjaella_vb_1_1_V : V ;
  fjaerma_vb_1_1_V : V ;
  fjaerrblockera_vb_1_1_V : V ;
  flagga_vb_1_V : V ;
  flagna_vb_1_V : V ;
  flambera_vb_1_V : V ;
  flankera_vb_1_V : V ;
  flattera_vb_1_V : V ;
  flektera_vb_1_V : V ;
  flerdubbla_vb_1_V : V ;
  flerfaldiga_vb_1_V : V ;
  flotta_vb_1_V : V ;
  fluidisera_vb_1_V : V ;
  fluorera_vb_1_V : V ;
  fluoridera_vb_1_V : V ;
  flygbomba_vb_1_V : V ;
  flykta_vb_1_V : V ;
  flytta_vb_1_V : V ;
  flaecka_vb_1_1_V : V ;
  flaensa_vb_1_1_V : V ;
  flaeta_vb_1_1_V : V ;
  flaahacka_vb_1_1_V : V ;
  floejta_vb_1_1_V : V ;
  focka_vb_1_V : V ;
  foga_vb_1_V : V ;
  fokusera_vb_1_V : V ;
  foliera_vb_1_V : V ;
  fondera_vb_1_V : V ;
  forcera_vb_1_V : V ;
  forechecka_vb_1_V : V ;
  forma_vb_1_V : V ;
  formalisera_vb_1_V : V ;
  formera_vb_1_V : V ;
  formpressa_vb_1_V : V ;
  formulera_vb_1_V : V ;
  forsla_vb_1_V : V ;
  fosfatera_vb_1_V : V ;
  fossilisera_vb_1_V : V ;
  fota_vb_1_V : V ;
  fotografera_vb_1_V : V ;
  fotokopiera_vb_1_V : V ;
  fotostatkopiera_vb_1_V : V ;
  fragmentera_vb_1_V : V ;
  frakta_vb_1_V : V ;
  fraktionera_vb_1_V : V ;
  framflytta_vb_1_V : V ;
  framkalla_vb_1_V : V ;
  framkasta_vb_1_V : V ;
  frammana_vb_1_V : V ;
  frammata_vb_1_V : V ;
  frampressa_vb_1_V : V ;
  framskymta_vb_1_V : V ;
  framvisa_vb_1_V : V ;
  frankera_vb_1_V : V ;
  fransa_vb_1_V : V ;
  frappera_vb_1_V : V ;
  frasera_vb_1_V : V ;
  freda_vb_1_V : V ;
  frekvensmodulera_vb_1_V : V ;
  frekventera_vb_1_V : V ;
  fresta_vb_1_V : V ;
  fria_vb_1_V : V ;
  frihetsberoeva_vb_1_1_V : V ;
  frikalla_vb_1_V : V ;
  frikoppla_vb_1_V : V ;
  frilista_vb_1_V : V ;
  frisera_vb_1_V : V ;
  frisera_vb_2_V : V ;
  friskfoerklara_vb_1_1_V : V ;
  frispela_vb_1_V : V ;
  fritera_vb_1_V : V ;
  frondera_vb_1_V : V ;
  fronta_vb_1_V : V ;
  frottera_vb_1_V : V ;
  frukta_vb_1_V : V ;
  frustrera_vb_1_V : V ;
  frystesta_vb_1_V : V ;
  frystorka_vb_1_V : V ;
  fraemja_vb_1_1_V : V ;
  fraaga_vb_1_1_V : V ;
  fraanraekna_vb_1_1_V : V ;
  fraanspela_vb_1_1_V : V ;
  fukta_vb_1_V : V ;
  fullborda_vb_1_V : V ;
  fullkomna_vb_1_V : V ;
  fullstaendiga_vb_1_1_V : V ;
  fullaenda_vb_1_1_V : V ;
  fulvinkla_vb_1_V : V ;
  furnera_vb_1_V : V ;
  fusionera_vb_1_V : V ;
  fylka_vb_1_V : V ;
  fynda_vb_1_V : V ;
  fyrdela_vb_1_V : V ;
  fyrdubbla_vb_1_V : V ;
  fyrfaldiga_vb_1_V : V ;
  fysiljera_vb_1_V : V ;
  faegna_vb_1_1_V : V ;
  faengsla_vb_1_1_V : V ;
  faerga_vb_1_1_V : V ;
  faerja_vb_1_1_V : V ;
  faersera_vb_1_1_V : V ;
  faerska_vb_1_1_V : V ;
  faalla_vb_1_1_V : V ;
  faanga_vb_1_1_V : V ;
  faara_vb_1_1_V : V ;
  foena_vb_1_1_V : V ;
  foerakta_vb_1_1_V : V ;
  foerallmaenliga_vb_1_1_V : V ;
  foerandliga_vb_1_1_V : V ;
  foerankra_vb_1_1_V : V ;
  foerannonsera_vb_1_1_V : V ;
  foeranstalta_vb_1_1_V : V ;
  foerarbeta_vb_1_1_V : V ;
  foerarga_vb_1_1_V : V ;
  foerbanna_vb_1_1_V : V ;
  foerbida_vb_1_1_V : V ;
  foerbilliga_vb_1_1_V : V ;
  foerbittra_vb_1_1_V : V ;
  foerblanda_vb_1_1_V : V ;
  foerblekna_vb_1_1_V : V ;
  foerblinda_vb_1_1_V : V ;
  foerbluffa_vb_1_1_V : V ;
  foerborga_vb_1_1_V : V ;
  foerborgerliga_vb_1_1_V : V ;
  foerbruka_vb_1_1_V : V ;
  foerbrylla_vb_1_1_V : V ;
  foerbroedra_vb_1_1_V : V ;
  foerbuska_vb_1_1_V : V ;
  foerbaettra_vb_1_1_V : V ;
  foerdela_vb_1_1_V : V ;
  foerdjupa_vb_1_1_V : V ;
  foerdubbla_vb_1_1_V : V ;
  foerdumma_vb_1_1_V : V ;
  foerdunkla_vb_1_1_V : V ;
  foerdunsta_vb_1_1_V : V ;
  foerdyra_vb_1_1_V : V ;
  foerdystra_vb_1_1_V : V ;
  foerdaerva_vb_1_1_V : V ;
  foerebaada_vb_1_1_V : V ;
  foerenkla_vb_1_1_V : V ;
  foerespegla_vb_1_1_V : V ;
  foerespraaka_vb_1_1_V : V ;
  foerestava_vb_1_1_V : V ;
  foereviga_vb_1_1_V : V ;
  foerevisa_vb_1_1_V : V ;
  foerevita_vb_1_1_V : V ;
  foerfalska_vb_1_1_V : V ;
  foerfatta_vb_1_1_V : V ;
  foerfela_vb_1_1_V : V ;
  foerfina_vb_1_1_V : V ;
  foerflacka_vb_1_1_V : V ;
  foerflytta_vb_1_1_V : V ;
  foerfranska_vb_1_1_V : V ;
  foerfraemliga_vb_1_1_V : V ;
  foerfuska_vb_1_1_V : V ;
  foerfaea_vb_1_1_V : V ;
  foerfaekta_vb_1_1_V : V ;
  foerfaera_vb_1_1_V : V ;
  foerfaerdiga_vb_1_1_V : V ;
  foerfaanga_vb_1_1_V : V ;
  foerfoerdela_vb_1_1_V : V ;
  foergasa_vb_1_1_V : V ;
  foergifta_vb_1_1_V : V ;
  foergrova_vb_1_1_V : V ;
  foergrymma_vb_1_1_V : V ;
  foerhala_vb_1_1_V : V ;
  foerhandla_vb_1_1_V : V ;
  foerhindra_vb_1_1_V : V ;
  foerhaerda_vb_1_1_V : V ;
  foerhaerja_vb_1_1_V : V ;
  foerhaerliga_vb_1_1_V : V ;
  foerhaexa_vb_1_1_V : V ;
  foerhaana_vb_1_1_V : V ;
  foerinta_vb_1_1_V : V ;
  foerjaga_vb_1_1_V : V ;
  foerkasta_vb_1_1_V : V ;
  foerklara_vb_1_1_V : V ;
  foerklinga_vb_1_1_V : V ;
  foerklistra_1_vb_1_1_V : V ;
  foerknippa_vb_1_1_V : V ;
  foerkolna_vb_1_1_V : V ;
  foerkorta_vb_1_1_V : V ;
  foerkovra_vb_1_1_V : V ;
  foerkroma_vb_1_1_V : V ;
  foerkroppsliga_vb_1_1_V : V ;
  foerkrossa_vb_1_1_V : V ;
  foerkraama_vb_1_1_V : V ;
  foerkunna_vb_1_1_V : V ;
  foerlama_vb_1_1_V : V ;
  foerljuva_vb_1_1_V : V ;
  foerlora_vb_1_1_V : V ;
  foerlossa_vb_1_1_V : V ;
  foerlusta_vb_1_1_V : V ;
  foerlaena_vb_1_1_V : V ;
  foerloejliga_vb_1_1_V : V ;
  foermana_vb_1_1_V : V ;
  foermedla_vb_1_1_V : V ;
  foermena_vb_1_1_V : V ;
  foermildra_vb_1_1_V : V ;
  foerminska_vb_1_1_V : V ;
  foermoda_vb_1_1_V : V ;
  foermultna_vb_1_1_V : V ;
  foermaenskliga_vb_1_1_V : V ;
  foermoerka_vb_1_1_V : V ;
  foernagla_vb_1_1_V : V ;
  foernedra_vb_1_1_V : V ;
  foerneka_vb_1_1_V : V ;
  foernickla_vb_1_1_V : V ;
  foernya_vb_1_1_V : V ;
  foernaerma_vb_1_1_V : V ;
  foerolaempa_vb_1_1_V : V ;
  foerorda_vb_1_1_V : V ;
  foerordna_vb_1_1_V : V ;
  foerorena_vb_1_1_V : V ;
  foerorsaka_vb_1_1_V : V ;
  foeroraetta_vb_1_1_V : V ;
  foerpacka_vb_1_1_V : V ;
  foerpakta_vb_1_1_V : V ;
  foerpanta_vb_1_1_V : V ;
  foerpassa_vb_1_1_V : V ;
  foerpesta_vb_1_1_V : V ;
  foerplikta_vb_1_1_V : V ;
  foerpliktiga_vb_1_1_V : V ;
  foerplaega_vb_1_1_V : V ;
  foerpricka_vb_1_1_V : V ;
  foerringa_vb_1_1_V : V ;
  foerruttna_vb_1_1_V : V ;
  foerryska_vb_1_1_V : V ;
  foerraenta_vb_1_1_V : V ;
  foerraetta_vb_1_1_V : V ;
  foerraaa_vb_1_1_V : V ;
  foersaka_vb_1_1_V : V ;
  foersamla_vb_1_1_V : V ;
  foersegla_vb_1_1_V : V ;
  foersena_vb_1_1_V : V ;
  foersilvra_vb_1_1_V : V ;
  foersinka_vb_1_1_V : V ;
  foerskaffa_vb_1_1_V : V ;
  foerskansa_vb_1_1_V : V ;
  foerskingra_vb_1_1_V : V ;
  foerskona_vb_1_1_V : V ;
  foerskottera_vb_1_1_V : V ;
  foerskoena_vb_1_1_V : V ;
  foerslappa_vb_1_1_V : V ;
  foerslava_vb_1_1_V : V ;
  foersloea_vb_1_1_V : V ;
  foersloesa_vb_1_1_V : V ;
  foersnilla_vb_1_1_V : V ;
  foersoffa_vb_1_1_V : V ;
  foersona_vb_1_1_V : V ;
  foerstatliga_vb_1_1_V : V ;
  foerstelna_vb_1_1_V : V ;
  foerstena_vb_1_1_V : V ;
  foerstocka_vb_1_1_V : V ;
  foerstoppa_vb_1_1_V : V ;
  foerstora_vb_1_1_V : V ;
  foerstraeva_vb_1_1_V : V ;
  foerstumma_vb_1_1_V : V ;
  foerstaendiga_vb_1_1_V : V ;
  foersumma_vb_1_1_V : V ;
  foersura_vb_1_1_V : V ;
  foersvaga_vb_1_1_V : V ;
  foersvara_vb_1_1_V : V ;
  foersvenska_vb_1_1_V : V ;
  foersvaara_vb_1_1_V : V ;
  foersaekra_vb_1_1_V : V ;
  foersaemra_vb_1_1_V : V ;
  foertala_vb_1_1_V : V ;
  foerteckna_vb_1_1_V : V ;
  foertenna_vb_1_1_V : V ;
  foertidspensionera_vb_1_1_V : V ;
  foertjocka_vb_1_1_V : V ;
  foertjaena_vb_1_1_V : V ;
  foertorka_vb_1_1_V : V ;
  foertrampa_vb_1_1_V : V ;
  foertreta_vb_1_1_V : V ;
  foertrolla_vb_1_1_V : V ;
  foertrusta_vb_1_1_V : V ;
  foertroesta_vb_1_1_V : V ;
  foertulla_vb_1_1_V : V ;
  foertunna_vb_1_1_V : V ;
  foertvina_vb_1_1_V : V ;
  foertvivla_vb_1_1_V : V ;
  foertvaala_vb_1_1_V : V ;
  foertydliga_vb_1_1_V : V ;
  foertyska_vb_1_1_V : V ;
  foertaeta_vb_1_1_V : V ;
  foerundra_vb_1_1_V : V ;
  foerunna_vb_1_1_V : V ;
  foerutskicka_vb_1_1_V : V ;
  foervalta_vb_1_1_V : V ;
  foervandla_vb_1_1_V : V ;
  foervanska_vb_1_1_V : V ;
  foervara_vb_1_1_V : V ;
  foervarna_vb_1_1_V : V ;
  foerveda_vb_1_1_V : V ;
  foervekliga_vb_1_1_V : V ;
  foerverka_vb_1_1_V : V ;
  foerverkliga_vb_1_1_V : V ;
  foervilla_vb_1_1_V : V ;
  foervirra_vb_1_1_V : V ;
  foervisa_vb_1_1_V : V ;
  foervissa_vb_1_1_V : V ;
  foervissna_vb_1_1_V : V ;
  foervittra_vb_1_1_V : V ;
  foervaegra_vb_1_1_V : V ;
  foervaenta_vb_1_1_V : V ;
  foervaerldsliga_vb_1_1_V : V ;
  foervaerra_vb_1_1_V : V ;
  foervaerva_vb_1_1_V : V ;
  foervaexla_vb_1_1_V : V ;
  foervaalla_vb_1_1_V : V ;
  foervaana_vb_1_1_V : V ;
  foeryngra_vb_1_1_V : V ;
  foerzinka_vb_1_1_V : V ;
  foeraedla_vb_1_1_V : V ;
  foeraendra_vb_1_1_V : V ;
  foeraera_vb_1_1_V : V ;
  foeraanga_vb_1_1_V : V ;
  foeroedmjuka_vb_1_1_V : V ;
  foeroeka_vb_1_1_V : V ;
  foeroeva_vb_1_1_V : V ;
  gagna_vb_1_V : V ;
  gallisera_vb_1_V : V ;
  gallra_vb_1_V : V ;
  galoschera_vb_1_V : V ;
  galva_vb_1_V : V ;
  galvanisera_vb_1_V : V ;
  gana_vb_1_V : V ;
  gara_vb_1_V : V ;
  garagera_vb_1_V : V ;
  garantera_vb_1_V : V ;
  gardera_vb_1_V : V ;
  garnera_vb_1_V : V ;
  garnisonera_vb_1_V : V ;
  garrottera_vb_1_V : V ;
  garva_vb_1_V : V ;
  gasa_vb_2_V : V ;
  gastkrama_vb_1_V : V ;
  gastroskopera_vb_1_V : V ;
  gauffrera_vb_1_V : V ;
  gelatinera_vb_1_V : V ;
  gelea_vb_1_V : V ;
  geminera_vb_1_V : V ;
  genera_vb_1_V : V ;
  generalisera_vb_1_V : V ;
  generera_vb_1_V : V ;
  gengaelda_vb_1_1_V : V ;
  genmanipulera_vb_1_V : V ;
  genomarbeta_vb_1_V : V ;
  genomborra_vb_1_V : V ;
  genomgraedda_vb_1_1_V : V ;
  genomkorsa_vb_1_V : V ;
  genomsippra_vb_1_V : V ;
  genomskaada_vb_1_1_V : V ;
  genomstroemma_vb_1_1_V : V ;
  genomsyra_vb_1_V : V ;
  geometrisera_vb_1_V : V ;
  geotagga_vb_1_V : V ;
  germanisera_vb_1_V : V ;
  gestalta_vb_1_V : V ;
  giga_vb_1_V : V ;
  giljotinera_vb_1_V : V ;
  gilla_vb_1_V : V ;
  gillra_vb_1_V : V ;
  gipsa_vb_1_V : V ;
  girera_vb_1_V : V ;
  gissa_vb_1_V : V ;
  gista_vb_1_V : V ;
  gjorda_vb_1_V : V ;
  glamorisera_vb_1_V : V ;
  glamourisera_vb_1_V : V ;
  glansa_vb_1_V : V ;
  glanska_vb_1_V : V ;
  glasa_vb_1_V : V ;
  glasera_vb_1_V : V ;
  glatta_vb_1_V : V ;
  glesa_vb_1_V : V ;
  glesna_vb_1_V : V ;
  glorifiera_vb_1_V : V ;
  glaenta_vb_1_1_V : V ;
  glaetta_vb_1_1_V : V ;
  gloedga_vb_1_1_V : V ;
  gloedrita_vb_1_1_V : V ;
  gnista_vb_1_V : V ;
  gnola_vb_1_V : V ;
  gnugga_vb_1_V : V ;
  goffrera_vb_1_V : V ;
  golva_vb_1_V : V ;
  googla_vb_1_V : V ;
  goutera_vb_1_V : V ;
  gps_a_vb_1_V : V ;
  gpsa_vb_1_V : V ;
  gpsa_vb_2_V : V ;
  grabba_vb_1_V : V ;
  grada_vb_1_V : V ;
  gradera_vb_1_V : V ;
  graduera_vb_1_V : V ;
  grafitera_vb_1_V : V ;
  granska_vb_1_V : V ;
  granulera_vb_1_V : V ;
  gratinera_vb_1_V : V ;
  gratta_vb_1_V : V ;
  gratulera_vb_1_V : V ;
  grava_vb_1_V : V ;
  gravera_vb_1_V : V ;
  greja_vb_1_V : V ;
  greppa_vb_1_V : V ;
  griljera_vb_1_V : V ;
  grilla_vb_1_V : V ;
  grimera_vb_1_V : V ;
  grodda_vb_1_V : V ;
  grovplanera_vb_1_V : V ;
  grovsortera_vb_1_V : V ;
  grumsa_vb_1_V : V ;
  grunda_vb_1_V : V ;
  grundbehandla_vb_1_V : V ;
  grundera_vb_1_V : V ;
  grundlura_vb_1_V : V ;
  grundmaala_vb_1_1_V : V ;
  gruppera_vb_1_V : V ;
  grusa_vb_1_V : V ;
  graedda_vb_1_1_V : V ;
  graefta_vb_1_1_V : V ;
  graana_vb_1_1_V : V ;
  groepa_vb_1_1_V : V ;
  guida_vb_1_V : V ;
  gulfaerga_vb_1_1_V : V ;
  gulna_vb_1_V : V ;
  gummera_vb_1_V : V ;
  gunga_vb_2_V : V ;
  guska_vb_1_V : V ;
  gutera_vb_1_V : V ;
  gymnastisera_vb_1_V : V ;
  gynna_vb_1_V : V ;
  gaecka_vb_1_1_V : V ;
  gaela_vb_1_1_V : V ;
  gaenga_vb_1_1_V : V ;
  gaerda_vb_1_1_V : V ;
  gaesta_vb_1_1_V : V ;
  gaestspela_vb_1_1_V : V ;
  gaangra_vb_1_1_V : V ;
  goeka_vb_1_1_V : V ;
  hacka_vb_1_V : V ;
  haffa_vb_1_V : V ;
  haja_vb_1_V : V ;
  haka_vb_1_V : V ;
  hala_vb_1_V : V ;
  hallstaempla_vb_1_1_V : V ;
  hallucinera_vb_1_V : V ;
  halsa_vb_1_V : V ;
  halvera_vb_1_V : V ;
  halvsula_vb_1_V : V ;
  halvviska_vb_1_V : V ;
  hamna_vb_1_V : V ;
  hamra_vb_1_V : V ;
  handarbeta_vb_1_V : V ;
  handboja_vb_1_V : V ;
  handikappa_vb_1_V : V ;
  handla_vb_2_V : V ;
  handplocka_vb_1_V : V ;
  hantera_vb_1_V : V ;
  harangera_vb_1_V : V ;
  harma_vb_1_V : V ;
  harmonisera_vb_1_V : V ;
  harpunera_vb_1_V : V ;
  hartsa_vb_1_V : V ;
  harva_vb_1_V : V ;
  hasa_vb_2_V : V ;
  hasardera_vb_1_V : V ;
  haspa_vb_1_V : V ;
  haspla_vb_1_V : V ;
  hata_vb_1_V : V ;
  haussa_vb_1_V : V ;
  haverera_vb_1_V : V ;
  hedra_vb_1_V : V ;
  heja_vb_1_V : V ;
  hejda_vb_1_V : V ;
  hektografera_vb_1_V : V ;
  hela_vb_1_V : V ;
  helfoersaekra_vb_1_1_V : V ;
  helga_vb_1_V : V ;
  helgardera_vb_1_V : V ;
  helgonfoerklara_vb_1_1_V : V ;
  helinackordera_vb_1_V : V ;
  hemfoerlova_vb_1_1_V : V ;
  hemkalla_vb_1_V : V ;
  hemligstaempla_vb_1_1_V : V ;
  hena_vb_1_V : V ;
  heroisera_vb_1_V : V ;
  hetsa_vb_1_V : V ;
  hinka_vb_1_V : V ;
  hissa_vb_1_V : V ;
  historiera_vb_1_V : V ;
  historisera_vb_1_V : V ;
  hitta_vb_1_V : V ;
  hiva_vb_1_V : V ;
  hjaerntvaetta_vb_1_1_V : V ;
  holografera_vb_1_V : V ;
  homogenisera_vb_1_V : V ;
  honorera_vb_1_V : V ;
  hopa_vb_1_V : V ;
  hopbunta_vb_1_V : V ;
  hopdikta_vb_1_V : V ;
  hopfoga_vb_1_V : V ;
  hoplappa_vb_1_V : V ;
  hoppa_vb_1_V : V ;
  hoppacka_vb_1_V : V ;
  hoprafsa_vb_1_V : V ;
  hospitalisera_vb_1_V : V ;
  hosta_vb_2_V : V ;
  hota_vb_1_V : V ;
  hotta_vb_1_V : V ;
  hugna_vb_1_V : V ;
  hugsvala_vb_1_V : V ;
  humanisera_vb_1_V : V ;
  hundsa_vb_1_V : V ;
  hundsfottera_vb_1_V : V ;
  hunsa_vb_1_V : V ;
  husera_vb_2_V : V ;
  hybridisera_vb_1_V : V ;
  hydrera_vb_1_V : V ;
  hyfsa_vb_1_V : V ;
  hylla_vb_1_V : V ;
  hypnotisera_vb_1_V : V ;
  hypotisera_vb_1_V : V ;
  hyresreglera_vb_1_V : V ;
  hyssja_vb_1_V : V ;
  hysta_vb_1_V : V ;
  hyva_vb_1_V : V ;
  haeda_vb_1_1_V : V ;
  haedankalla_vb_1_1_V : V ;
  haefta_vb_1_1_V : V ;
  haegna_vb_1_1_V : V ;
  haekta_vb_1_1_V : V ;
  haelsa_vb_1_1_V : V ;
  haemna_vb_1_1_V : V ;
  haemta_vb_1_1_V : V ;
  haenvisa_vb_1_1_V : V ;
  haerbaergera_vb_1_1_V : V ;
  haerda_vb_1_1_V : V ;
  haerja_vb_1_1_V : V ;
  haerma_vb_1_1_V : V ;
  haerskna_vb_1_1_V : V ;
  haessja_vb_1_1_V : V ;
  haevda_vb_1_1_V : V ;
  haala_vb_1_1_V : V ;
  haana_vb_1_1_V : V ;
  haardgranska_vb_1_1_V : V ;
  haardna_vb_1_1_V : V ;
  haardtraena_vb_1_1_V : V ;
  haava_vb_1_1_V : V ;
  hoegakta_vb_1_1_V : V ;
  hoegprioritera_vb_1_1_V : V ;
  hoersamma_vb_1_1_V : V ;
  idealisera_vb_1_V : V ;
  identifiera_vb_1_V : V ;
  idiotfoerklara_vb_1_1_V : V ;
  idka_vb_1_V : V ;
  ignorera_vb_1_V : V ;
  illuminera_vb_1_V : V ;
  illustrera_vb_1_V : V ;
  imitera_vb_1_V : V ;
  immatrikulera_vb_1_V : V ;
  immigrera_vb_1_V : V ;
  immunisera_vb_1_V : V ;
  impa_vb_1_V : V ;
  implantera_vb_1_V : V ;
  implicera_vb_1_V : V ;
  implodera_vb_1_V : V ;
  imponera_vb_1_V : V ;
  importera_vb_1_V : V ;
  impregnera_vb_1_V : V ;
  improvisera_vb_1_V : V ;
  inackordera_vb_1_V : V ;
  inarbeta_vb_1_V : V ;
  inaugurera_vb_1_V : V ;
  inbaka_vb_1_V : V ;
  inberaekna_vb_1_1_V : V ;
  inbespara_vb_1_V : V ;
  inbilla_vb_1_V : V ;
  indela_vb_1_V : V ;
  indexera_vb_1_V : V ;
  indexreglera_vb_1_V : V ;
  indicera_vb_1_V : V ;
  indikera_vb_1_V : V ;
  individualisera_vb_1_V : V ;
  indoktrinera_vb_1_V : V ;
  inducera_vb_1_V : V ;
  indunsta_vb_1_V : V ;
  industrialisera_vb_1_V : V ;
  infantilisera_vb_1_V : V ;
  infatta_vb_1_V : V ;
  infektera_vb_1_V : V ;
  infetta_vb_1_V : V ;
  infiltrera_vb_1_V : V ;
  inflammera_vb_1_V : V ;
  inflicka_vb_1_V : V ;
  inflika_vb_1_V : V ;
  influera_vb_1_V : V ;
  inflytta_vb_1_V : V ;
  inflaeta_vb_1_1_V : V ;
  infodra_vb_1_V : V ;
  infoga_vb_1_V : V ;
  infordra_vb_1_V : V ;
  informera_vb_1_V : V ;
  infria_vb_1_V : V ;
  infaanga_vb_1_1_V : V ;
  infoerliva_vb_1_1_V : V ;
  infoerskaffa_vb_1_1_V : V ;
  ingravera_vb_1_V : V ;
  ingaerda_vb_1_1_V : V ;
  inhalera_vb_1_V : V ;
  inhandla_vb_1_V : V ;
  inhibera_vb_1_V : V ;
  inhibitera_vb_1_V : V ;
  inhaegna_vb_1_1_V : V ;
  inhaemta_vb_1_1_V : V ;
  initiera_vb_1_V : V ;
  injaga_vb_1_V : V ;
  injektera_vb_1_V : V ;
  injicera_vb_1_V : V ;
  inkalla_vb_1_V : V ;
  inkapsla_vb_1_V : V ;
  inkarnera_vb_1_V : V ;
  inkassera_vb_1_V : V ;
  inklarera_vb_1_V : V ;
  inkludera_vb_1_V : V ;
  inkompetensfoerklara_vb_1_1_V : V ;
  inkomsttaxera_vb_1_V : V ;
  inkoppla_vb_1_V : V ;
  inkorporera_vb_1_V : V ;
  inkvartera_vb_1_V : V ;
  inlemma_vb_1_V : V ;
  inleverera_vb_1_V : V ;
  inlinda_vb_1_V : V ;
  inlaemna_vb_1_1_V : V ;
  inlaana_vb_1_1_V : V ;
  inmata_vb_1_V : V ;
  inmundiga_vb_1_V : V ;
  inmuta_vb_1_V : V ;
  inmoenstra_vb_1_1_V : V ;
  innefatta_vb_1_V : V ;
  innervera_vb_1_V : V ;
  inokulera_vb_1_V : V ;
  inolja_vb_1_V : V ;
  inordna_vb_1_V : V ;
  inpassa_vb_1_V : V ;
  inplanta_vb_1_V : V ;
  inplantera_vb_1_V : V ;
  inpressa_vb_1_V : V ;
  inpricka_vb_1_V : V ;
  inpraegla_vb_1_1_V : V ;
  inpraenta_vb_1_1_V : V ;
  inrama_vb_1_V : V ;
  inrangera_vb_1_V : V ;
  inrapportera_vb_1_V : V ;
  inregistrera_vb_1_V : V ;
  inrikta_vb_1_V : V ;
  inringa_vb_1_V : V ;
  inrista_vb_1_V : V ;
  inropa_vb_1_V : V ;
  inraekna_vb_1_1_V : V ;
  inraetta_vb_1_1_V : V ;
  insamla_vb_1_V : V ;
  inscenera_vb_1_V : V ;
  insegla_vb_1_V : V ;
  inseminera_vb_1_V : V ;
  insinuera_vb_1_V : V ;
  insistera_vb_1_V : V ;
  insjukna_vb_1_V : V ;
  inskaffa_vb_1_V : V ;
  inskeppa_vb_1_V : V ;
  inskola_vb_1_V : V ;
  insomna_vb_1_V : V ;
  inspektera_vb_1_V : V ;
  inspela_vb_1_V : V ;
  inspirera_vb_1_V : V ;
  installera_vb_1_V : V ;
  instifta_vb_1_V : V ;
  institutionalisera_vb_1_V : V ;
  instruera_vb_1_V : V ;
  instrumentera_vb_1_V : V ;
  instraala_vb_1_1_V : V ;
  instudera_vb_1_V : V ;
  insoendra_vb_1_1_V : V ;
  inteckna_vb_1_V : V ;
  integrera_vb_1_V : V ;
  intellektualisera_vb_1_V : V ;
  intensifiera_vb_1_V : V ;
  intensivera_vb_1_V : V ;
  interfoliera_vb_1_V : V ;
  internalisera_vb_1_V : V ;
  internationalisera_vb_1_V : V ;
  internera_vb_1_V : V ;
  interpellera_vb_1_V : V ;
  interpolera_vb_1_V : V ;
  interpretera_vb_1_V : V ;
  interpunktera_vb_1_V : V ;
  intervenera_vb_1_V : V ;
  intervjua_vb_1_V : V ;
  intimisera_vb_1_V : V ;
  intolka_vb_1_V : V ;
  intonera_vb_1_V : V ;
  intressera_vb_1_V : V ;
  introducera_vb_1_V : V ;
  intrumfa_vb_1_V : V ;
  intraeffa_vb_1_1_V : V ;
  intyga_vb_1_V : V ;
  intaaga_vb_1_1_V : V ;
  invadera_vb_1_V : V ;
  invagga_vb_1_V : V ;
  invalidisera_vb_1_V : V ;
  invandra_vb_1_V : V ;
  inveckla_vb_1_V : V ;
  inventera_vb_1_V : V ;
  invertera_vb_1_V : V ;
  investera_vb_1_V : V ;
  invitera_vb_1_V : V ;
  involvera_vb_1_V : V ;
  invaenta_vb_1_1_V : V ;
  inympa_vb_1_V : V ;
  inoeva_vb_1_1_V : V ;
  irritera_vb_1_V : V ;
  islamisera_vb_1_V : V ;
  isolera_vb_1_V : V ;
  iterera_vb_1_V : V ;
  ituta_vb_1_V : V ;
  ivaegskicka_vb_1_1_V : V ;
  jabba_vb_1_V : V ;
  jaga_vb_1_V : V ;
  jaka_vb_1_V : V ;
  jazzifiera_vb_1_V : V ;
  jodera_vb_1_V : V ;
  jogga_vb_1_V : V ;
  jojka_vb_1_V : V ;
  jonglera_vb_1_V : V ;
  jonisera_vb_1_V : V ;
  jorda_vb_1_V : V ;
  justera_vb_1_V : V ;
  jaekta_vb_1_1_V : V ;
  jaemka_vb_1_1_V : V ;
  jaemna_vb_1_1_V : V ;
  jaeva_vb_1_1_V : V ;
  kakla_vb_1_V : V ;
  kalandrera_vb_1_V : V ;
  kalavverka_vb_1_V : V ;
  kalcinera_vb_1_V : V ;
  kalfatra_vb_1_V : V ;
  kalibrera_vb_1_V : V ;
  kalka_vb_1_V : V ;
  kalkera_vb_1_V : V ;
  kalkylera_vb_1_V : V ;
  kalla_vb_1_V : V ;
  kallarbeta_vb_1_V : V ;
  kallbearbeta_vb_1_V : V ;
  kallbocka_vb_1_V : V ;
  kallhamra_vb_1_V : V ;
  kallna_vb_1_V : V ;
  kallpressa_vb_1_V : V ;
  kallvalsa_vb_1_V : V ;
  kalmera_vb_1_V : V ;
  kameraoevervaka_vb_1_1_V : V ;
  kamma_vb_1_V : V ;
  kamouflera_vb_1_V : V ;
  kanalisera_vb_1_V : V ;
  kandera_vb_1_V : V ;
  kannelera_vb_1_V : V ;
  kanonisera_vb_1_V : V ;
  kanta_vb_1_V : V ;
  kantra_vb_1_V : V ;
  kapa_vb_1_V : V ;
  kapitalisera_vb_1_V : V ;
  kapsejsa_vb_1_V : V ;
  kara_vb_1_V : V ;
  karakterisera_vb_1_V : V ;
  karaktaerisera_vb_1_1_V : V ;
  karambolera_vb_1_V : V ;
  karbonisera_vb_1_V : V ;
  karda_vb_1_V : V ;
  karikera_vb_1_V : V ;
  kartera_vb_1_V : V ;
  kartonnera_vb_1_V : V ;
  karva_vb_1_V : V ;
  kaskadkoppla_vb_1_V : V ;
  kassera_vb_1_V : V ;
  kasta_vb_1_V : V ;
  kastrera_vb_1_V : V ;
  katalogisera_vb_1_V : V ;
  katalysera_vb_1_V : V ;
  kategorisera_vb_1_V : V ;
  kateterisera_vb_1_V : V ;
  katetrisera_vb_1_V : V ;
  katta_vb_1_V : V ;
  kauterisera_vb_1_V : V ;
  kedja_vb_1_V : V ;
  kicka_vb_1_V : V ;
  kidnappa_vb_1_V : V ;
  kika_vb_1_V : V ;
  kila_vb_1_V : V ;
  killa_vb_1_V : V ;
  kindpussa_vb_1_V : V ;
  kirra_vb_1_V : V ;
  kissa_vb_1_V : V ;
  kitta_vb_1_V : V ;
  klacka_vb_1_V : V ;
  klaga_vb_1_V : V ;
  klampa_vb_2_V : V ;
  klamra_vb_1_V : V ;
  klappa_vb_1_V : V ;
  klara_vb_2_V : V ;
  klarera_vb_1_V : V ;
  klassa_vb_1_V : V ;
  klassificera_vb_1_V : V ;
  klatscha_vb_1_V : V ;
  klena_vb_1_V : V ;
  kleta_vb_1_V : V ;
  klia_vb_2_V : V ;
  klicka_vb_2_V : V ;
  klira_vb_1_V : V ;
  klocka_vb_1_V : V ;
  klona_vb_1_V : V ;
  klorera_vb_1_V : V ;
  klubba_vb_1_V : V ;
  kludda_vb_1_V : V ;
  klyfta_vb_1_V : V ;
  kloevja_vb_1_1_V : V ;
  knacka_vb_1_V : V ;
  knarka_vb_1_V : V ;
  knata_vb_1_V : V ;
  knipsa_vb_1_V : V ;
  kniva_vb_1_V : V ;
  knivdoeda_vb_1_1_V : V ;
  knivmoerda_vb_1_1_V : V ;
  knocka_vb_1_V : V ;
  knopa_vb_1_V : V ;
  knorva_vb_1_V : V ;
  knuffa_vb_1_V : V ;
  knulla_vb_1_V : V ;
  knuttimra_vb_1_V : V ;
  knaea_vb_2_1_V : V ;
  knaada_vb_1_1_V : V ;
  knoela_vb_1_1_V : V ;
  koaffera_vb_1_V : V ;
  koagulera_vb_1_V : V ;
  koda_vb_1_V : V ;
  kodifiera_vb_1_V : V ;
  koja_vb_1_V : V ;
  kojsa_vb_1_V : V ;
  kola_vb_1_V : V ;
  kola_2_vb_1_V : V ;
  kolka_vb_1_V : V ;
  kolla_vb_1_V : V ;
  kollapsa_vb_1_V : V ;
  kollationera_vb_1_V : V ;
  kollektivisera_vb_1_V : V ;
  kolonisera_vb_1_V : V ;
  kolorera_vb_1_V : V ;
  kolportera_vb_1_V : V ;
  kombinera_vb_1_V : V ;
  kommatera_vb_1_V : V ;
  kommendera_vb_1_V : V ;
  kommentera_vb_1_V : V ;
  kommersa_vb_1_V : V ;
  kommersialisera_vb_1_V : V ;
  kommunalisera_vb_1_V : V ;
  kommunicera_vb_1_V : V ;
  kommutera_vb_1_V : V ;
  kompa_vb_1_V : V ;
  komparera_vb_1_V : V ;
  kompensera_vb_1_V : V ;
  kompetensfoerklara_vb_1_1_V : V ;
  kompilera_vb_1_V : V ;
  komplettera_vb_1_V : V ;
  komplicera_vb_1_V : V ;
  komplimentera_vb_1_V : V ;
  komponera_vb_1_V : V ;
  kompostera_vb_1_V : V ;
  komprimera_vb_1_V : V ;
  kompromettera_vb_1_V : V ;
  koncentrera_vb_1_V : V ;
  koncessionera_vb_1_V : V ;
  koncipiera_vb_1_V : V ;
  kondemnera_vb_1_V : V ;
  kondensera_vb_1_V : V ;
  konditionera_vb_1_V : V ;
  kondolera_vb_1_V : V ;
  konfirmera_vb_1_V : V ;
  konfiskera_vb_1_V : V ;
  konformera_vb_1_V : V ;
  konfrontera_vb_1_V : V ;
  konfundera_vb_1_V : V ;
  kongruera_vb_1_V : V ;
  konjugera_vb_1_V : V ;
  konkludera_vb_1_V : V ;
  konkretisera_vb_1_V : V ;
  konservera_vb_1_V : V ;
  konsignera_vb_1_V : V ;
  konsolidera_vb_1_V : V ;
  konstatera_vb_1_V : V ;
  konstbefrukta_vb_1_V : V ;
  konstbevattna_vb_1_V : V ;
  konsternera_vb_1_V : V ;
  konstituera_vb_1_V : V ;
  konstruera_vb_1_V : V ;
  konststoppa_vb_1_V : V ;
  konsultera_vb_1_V : V ;
  konsumera_vb_1_V : V ;
  kontakta_vb_1_V : V ;
  kontaminera_vb_1_V : V ;
  kontera_vb_1_V : V ;
  kontingentera_vb_1_V : V ;
  kontorisera_vb_1_V : V ;
  kontrahera_vb_1_V : V ;
  kontraktera_vb_1_V : V ;
  kontramandera_vb_1_V : V ;
  kontrasignera_vb_1_V : V ;
  kontrastera_vb_1_V : V ;
  kontribuera_vb_1_V : V ;
  kontrollera_vb_1_V : V ;
  kontrollstaempla_vb_1_1_V : V ;
  konturera_vb_1_V : V ;
  konvergera_vb_1_V : V ;
  konversera_vb_1_V : V ;
  konvertera_vb_2_V : V ;
  konvojera_vb_1_V : V ;
  koordinera_vb_1_V : V ;
  kopiera_vb_1_V : V ;
  koppa_vb_1_V : V ;
  kora_vb_1_V : V ;
  korka_vb_1_V : V ;
  korpa_vb_1_V : V ;
  korrelera_vb_1_V : V ;
  korrigera_vb_1_V : V ;
  korrodera_vb_1_V : V ;
  korrugera_vb_1_V : V ;
  korrumpera_vb_1_V : V ;
  korsa_vb_1_V : V ;
  korsbefrukta_vb_1_V : V ;
  korsettera_vb_1_V : V ;
  korsvaedra_vb_1_1_V : V ;
  korta_vb_1_V : V ;
  kortpassa_vb_1_V : V ;
  kostymera_vb_1_V : V ;
  kracka_vb_1_V : V ;
  krackelera_vb_1_V : V ;
  krafsa_vb_1_V : V ;
  kraftsamla_vb_1_V : V ;
  krama_vb_1_V : V ;
  kransa_vb_1_V : V ;
  krascha_vb_1_V : V ;
  kraschlanda_vb_1_V : V ;
  kratsa_vb_1_V : V ;
  kratta_vb_1_V : V ;
  kredensa_vb_1_V : V ;
  kreditera_vb_1_V : V ;
  kreera_vb_1_V : V ;
  kremera_vb_1_V : V ;
  kreolisera_vb_1_V : V ;
  krepera_vb_1_V : V ;
  kreta_vb_1_V : V ;
  krevera_vb_1_V : V ;
  krigsplacera_vb_1_V : V ;
  kriminalisera_vb_1_V : V ;
  kringgaerda_vb_1_1_V : V ;
  kringskansa_vb_1_V : V ;
  kristallisera_vb_1_V : V ;
  kristna_vb_1_V : V ;
  krita_vb_1_V : V ;
  kritisera_vb_1_V : V ;
  krocka_vb_1_V : V ;
  kroka_vb_1_V : V ;
  kroma_vb_1_V : V ;
  kromgarva_vb_1_V : V ;
  kroppsvisitera_vb_1_V : V ;
  krossa_vb_1_V : V ;
  krulla_vb_1_V : V ;
  krusa_vb_1_V : V ;
  krydda_vb_1_V : V ;
  kryptera_vb_1_V : V ;
  kryssa_vb_1_V : V ;
  kraeppa_vb_1_1_V : V ;
  kraama_vb_2_1_V : V ;
  kubera_vb_1_V : V ;
  kugga_vb_1_V : V ;
  kujonera_vb_1_V : V ;
  kulla_vb_1_V : V ;
  kullkasta_vb_1_V : V ;
  kullprata_vb_1_V : V ;
  kultivera_vb_1_V : V ;
  kumulera_vb_1_V : V ;
  kupa_vb_1_V : V ;
  kupera_vb_1_V : V ;
  kura_vb_1_V : V ;
  kuratera_vb_1_V : V ;
  kurera_vb_1_V : V ;
  kursa_vb_1_V : V ;
  kursivera_vb_1_V : V ;
  kurtisera_vb_1_V : V ;
  kuscha_vb_1_V : V ;
  kuva_vb_1_V : V ;
  kuvertera_vb_1_V : V ;
  kvadda_vb_1_V : V ;
  kvadrera_vb_1_V : V ;
  kvalificera_vb_1_V : V ;
  kvalitetsgranska_vb_1_V : V ;
  kvalitetssaekra_vb_1_1_V : V ;
  kvantifiera_vb_1_V : V ;
  kvarlaemna_vb_1_1_V : V ;
  kvarstanna_vb_1_V : V ;
  kvicksilverbeta_vb_1_V : V ;
  kvilta_vb_1_V : V ;
  kvista_vb_1_V : V ;
  kvitta_vb_1_V : V ;
  kvittera_vb_1_V : V ;
  kvotera_vb_1_V : V ;
  kyllagra_vb_1_V : V ;
  kypra_vb_1_V : V ;
  kaeka_vb_1_1_V : V ;
  kaela_vb_1_1_V : V ;
  kaellsortera_vb_1_1_V : V ;
  kaenneteckna_vb_1_1_V : V ;
  kaera_vb_1_1_V : V ;
  kaerna_vb_1_1_V : V ;
  kaanka_vb_1_1_V : V ;
  kaara_vb_1_1_V : V ;
  koelhala_vb_2_1_V : V ;
  koena_vb_1_1_V : V ;
  koensdiskriminera_vb_1_1_V : V ;
  koenskvotera_vb_1_1_V : V ;
  koerna_vb_1_1_V : V ;
  labialisera_vb_1_V : V ;
  lacka_vb_1_V : V ;
  lackera_vb_1_V : V ;
  ladda_vb_1_V : V ;
  laga_vb_1_V : V ;
  lagerkransa_vb_1_V : V ;
  lagga_vb_1_V : V ;
  lagra_vb_1_V : V ;
  lagstifta_vb_1_V : V ;
  lamentera_vb_1_V : V ;
  laminera_vb_1_V : V ;
  landa_vb_1_V : V ;
  landa_vb_2_V : V ;
  landsfoervisa_vb_1_1_V : V ;
  langa_vb_1_V : V ;
  langettera_vb_1_V : V ;
  lansera_vb_1_V : V ;
  lapa_vb_1_V : V ;
  lapisera_vb_1_V : V ;
  lappa_vb_1_V : V ;
  larma_vb_2_V : V ;
  lasera_vb_1_V : V ;
  laska_vb_1_V : V ;
  lasta_vb_1_V : V ;
  latinisera_vb_1_V : V ;
  lavera_vb_1_V : V ;
  laxa_vb_1_V : V ;
  leasa_vb_1_V : V ;
  leda_vb_2_V : V ;
  ledigfoerklara_vb_1_1_V : V ;
  ledsaga_vb_1_V : V ;
  legalisera_vb_1_V : V ;
  legera_vb_1_V : V ;
  legitimera_vb_1_V : V ;
  lejdra_vb_1_V : V ;
  lemlaesta_vb_1_1_V : V ;
  lena_vb_1_V : V ;
  leta_vb_1_V : V ;
  leverera_vb_1_V : V ;
  liberalisera_vb_1_V : V ;
  licensera_vb_1_V : V ;
  licensiera_vb_1_V : V ;
  licentiera_vb_1_V : V ;
  liera_vb_1_V : V ;
  lika_vb_1_V : V ;
  likrikta_vb_1_V : V ;
  likvidera_vb_1_V : V ;
  limma_vb_1_V : V ;
  linda_vb_1_V : V ;
  lindra_vb_1_V : V ;
  linjera_vb_1_V : V ;
  lira_vb_1_V : V ;
  lissera_vb_1_V : V ;
  lista_vb_1_V : V ;
  litografera_vb_1_V : V ;
  litsa_vb_1_V : V ;
  liva_vb_1_V : V ;
  livfoersaekra_vb_1_1_V : V ;
  ljuda_vb_2_V : V ;
  ljudisolera_vb_1_V : V ;
  ljuskopiera_vb_1_V : V ;
  lobba_vb_1_V : V ;
  locka_vb_1_V : V ;
  lockouta_vb_1_V : V ;
  loda_vb_1_V : V ;
  logera_vb_1_V : V ;
  logga_vb_1_V : V ;
  lokalbedoeva_vb_1_1_V : V ;
  lokalisera_vb_1_V : V ;
  loppa_vb_1_V : V ;
  lossa_vb_1_V : V ;
  lotsa_vb_1_V : V ;
  lotta_vb_1_V : V ;
  lova_vb_1_V : V ;
  lovorda_vb_1_V : V ;
  lovprisa_vb_1_V : V ;
  luffa_vb_2_V : V ;
  lufta_vb_1_V : V ;
  lufttorka_vb_1_V : V ;
  lugga_vb_1_V : V ;
  lugna_vb_1_V : V ;
  lukta_vb_2_V : V ;
  lulla_vb_2_V : V ;
  lunna_vb_1_V : V ;
  lura_vb_1_V : V ;
  lurpassa_vb_1_V : V ;
  luta_vb_1_V : V ;
  luteinisera_vb_1_V : V ;
  lyckoenska_vb_1_1_V : V ;
  lykta_vb_1_V : V ;
  lyncha_vb_1_V : V ;
  lyra_vb_1_V : V ;
  lyster_vb_1_V : V ;
  lyxkonsumera_vb_1_V : V ;
  lyxrenovera_vb_1_V : V ;
  laedera_vb_1_1_V : V ;
  laegra_vb_1_1_V : V ;
  laektra_vb_1_1_V : V ;
  laemna_vb_1_1_V : V ;
  laempa_vb_1_1_V : V ;
  laenka_vb_1_1_V : V ;
  laensa_vb_1_1_V : V ;
  laenspumpa_vb_1_1_V : V ;
  laer_vb_1_1_V : V ;
  laeska_vb_1_1_V : V ;
  laetta_vb_1_1_V : V ;
  laagprioritera_vb_1_1_V : V ;
  laana_vb_1_1_V : V ;
  laangtidsparkera_vb_1_1_V : V ;
  laanspara_vb_1_1_V : V ;
  laassa_vb_1_1_V : V ;
  laatsa_vb_1_1_V : V ;
  loega_vb_1_1_V : V ;
  loena_vb_1_1_V : V ;
  loennmoerda_vb_1_1_V : V ;
  loenspara_vb_1_1_V : V ;
  loeva_vb_1_1_V : V ;
  madrassera_vb_1_V : V ;
  magasinera_vb_1_V : V ;
  magnetisera_vb_1_V : V ;
  magpumpa_vb_1_V : V ;
  maila_vb_1_V : V ;
  maja_vb_1_V : V ;
  maka_vb_1_V : V ;
  makulera_vb_1_V : V ;
  malfobera_vb_1_V : V ;
  malma_vb_1_V : V ;
  maltraetera_vb_1_1_V : V ;
  mana_vb_1_V : V ;
  manifestera_vb_1_V : V ;
  manikurera_vb_1_V : V ;
  manikyrera_vb_1_V : V ;
  manipulera_vb_1_V : V ;
  manoevrera_vb_1_1_V : V ;
  marginalisera_vb_1_V : V ;
  marinera_vb_1_V : V ;
  markera_vb_1_V : V ;
  marknadsanpassa_vb_1_V : V ;
  marknadsvaerdera_vb_1_1_V : V ;
  marmorera_vb_1_V : V ;
  martera_vb_1_V : V ;
  masa_vb_1_V : V ;
  maska_vb_2_V : V ;
  maskera_vb_1_V : V ;
  maskulinisera_vb_1_V : V ;
  massakrera_vb_1_V : V ;
  massavskeda_vb_1_V : V ;
  massera_vb_1_V : V ;
  mata_vb_1_V : V ;
  matcha_vb_1_V : V ;
  matelassera_vb_1_V : V ;
  materialisera_vb_1_V : V ;
  matta_vb_1_V : V ;
  mattera_vb_1_V : V ;
  maxa_vb_1_V : V ;
  maximera_vb_1_V : V ;
  medaljera_vb_1_V : V ;
  medicinera_vb_1_V : V ;
  meja_vb_1_V : V ;
  mejla_vb_1_V : V ;
  mejlbomba_vb_1_V : V ;
  mejsla_vb_1_V : V ;
  mekanisera_vb_1_V : V ;
  mellanlanda_vb_1_V : V ;
  memorera_vb_1_V : V ;
  mensa_vb_1_V : V ;
  mercerisera_vb_1_V : V ;
  meritera_vb_1_V : V ;
  messa_vb_1_V : V ;
  metallisera_vb_1_V : V ;
  micra_vb_1_V : V ;
  mikra_vb_1_V : V ;
  mikrofilma_vb_1_V : V ;
  mikrofotografera_vb_1_V : V ;
  mikroskopera_vb_1_V : V ;
  mildra_vb_1_V : V ;
  militarisera_vb_1_V : V ;
  miljoecertifiera_vb_1_1_V : V ;
  miljoefoerstoera_vb_1_1_V : V ;
  mima_vb_1_V : V ;
  minera_vb_1_V : V ;
  mineralisera_vb_1_V : V ;
  miniatyrisera_vb_1_V : V ;
  minimera_vb_1_V : V ;
  minska_vb_1_V : V ;
  missa_vb_1_V : V ;
  missakta_vb_1_V : V ;
  missbruka_vb_1_V : V ;
  missfirma_vb_1_V : V ;
  missfaerga_vb_1_1_V : V ;
  missgynna_vb_1_V : V ;
  misshandla_vb_1_V : V ;
  missivera_vb_1_V : V ;
  misskreditera_vb_1_V : V ;
  misstolka_vb_1_V : V ;
  missunna_vb_1_V : V ;
  missuppfatta_vb_1_V : V ;
  mixa_vb_1_V : V ;
  mjuka_vb_1_V : V ;
  mjuklanda_vb_1_V : V ;
  mjoela_vb_1_1_V : V ;
  mjoelka_vb_1_1_V : V ;
  mobba_vb_1_V : V ;
  mobilisera_vb_1_V : V ;
  mocka_vb_1_V : V ;
  modellera_vb_1_V : V ;
  moderera_vb_1_V : V ;
  modernisera_vb_1_V : V ;
  modifiera_vb_1_V : V ;
  modulera_vb_1_V : V ;
  modaernisera_vb_1_1_V : V ;
  monoftongera_vb_1_V : V ;
  monopolisera_vb_1_V : V ;
  montera_vb_1_V : V ;
  moppa_vb_1_V : V ;
  mordhota_vb_1_V : V ;
  morsera_vb_1_V : V ;
  mortificera_vb_1_V : V ;
  mortifiera_vb_1_V : V ;
  mosa_vb_1_V : V ;
  mota_vb_1_V : V ;
  motarbeta_vb_1_V : V ;
  motbevisa_vb_1_V : V ;
  motivera_vb_1_V : V ;
  motorisera_vb_1_V : V ;
  motverka_vb_1_V : V ;
  mula_vb_1_V : V ;
  muljera_vb_1_V : V ;
  multiplicera_vb_1_V : V ;
  mumifiera_vb_1_V : V ;
  mura_vb_1_V : V ;
  muta_vb_1_V : V ;
  mutera_vb_1_V : V ;
  mylla_vb_1_V : V ;
  mynta_vb_1_V : V ;
  mystifiera_vb_1_V : V ;
  mytifiera_vb_1_V : V ;
  maekla_vb_2_1_V : V ;
  maelta_vb_1_1_V : V ;
  maeska_vb_1_1_V : V ;
  maestra_vb_1_1_V : V ;
  maetta_vb_1_1_V : V ;
  maala_vb_1_1_V : V ;
  maangdubbla_vb_1_1_V : V ;
  maangfaldiga_vb_1_1_V : V ;
  maatta_vb_1_1_V : V ;
  moeblera_vb_1_1_V : V ;
  moenstra_vb_1_1_V : V ;
  moera_vb_1_1_V : V ;
  moerbulta_vb_1_1_V : V ;
  moerda_vb_1_1_V : V ;
  moerka_vb_1_1_V : V ;
  nacka_vb_1_V : V ;
  nafsa_vb_1_V : V ;
  nagga_vb_1_V : V ;
  nagla_vb_1_V : V ;
  naja_vb_1_V : V ;
  nalla_vb_1_V : V ;
  namna_vb_1_V : V ;
  nappa_vb_2_V : V ;
  nara_vb_1_V : V ;
  narra_vb_1_V : V ;
  narva_vb_1_V : V ;
  nasa_vb_1_V : V ;
  nasalera_vb_1_V : V ;
  nasalisera_vb_1_V : V ;
  nationalisera_vb_1_V : V ;
  natta_vb_1_V : V ;
  naturalisera_vb_1_V : V ;
  navigera_vb_1_V : V ;
  navla_vb_1_V : V ;
  nedarbeta_vb_1_V : V ;
  nedisa_vb_1_V : V ;
  nedkalla_vb_1_V : V ;
  nedkasta_vb_1_V : V ;
  nedkavla_vb_1_V : V ;
  nedklassa_vb_1_V : V ;
  nedrusta_vb_1_V : V ;
  nedsalta_vb_1_V : V ;
  nedteckna_vb_1_V : V ;
  nedtransformera_vb_1_V : V ;
  nedtransponera_vb_1_V : V ;
  nedtrappa_vb_1_V : V ;
  nedtysta_vb_1_V : V ;
  nedvaerdera_vb_1_1_V : V ;
  negera_vb_1_V : V ;
  negligera_vb_1_V : V ;
  negociera_vb_1_V : V ;
  negotiera_vb_1_V : V ;
  neka_vb_1_V : V ;
  nerarbeta_vb_1_V : V ;
  nerisa_vb_1_V : V ;
  nerkalla_vb_1_V : V ;
  nerkasta_vb_1_V : V ;
  nerkavla_vb_1_V : V ;
  nerklassa_vb_1_V : V ;
  nerrusta_vb_1_V : V ;
  nersalta_vb_1_V : V ;
  nerteckna_vb_1_V : V ;
  nertransformera_vb_1_V : V ;
  nertransponera_vb_1_V : V ;
  nertrappa_vb_1_V : V ;
  nertysta_vb_1_V : V ;
  nervaerdera_vb_1_1_V : V ;
  neurotisera_vb_1_V : V ;
  neutralisera_vb_1_V : V ;
  nia_vb_1_V : V ;
  nicka_vb_2_V : V ;
  niellera_vb_1_V : V ;
  nita_vb_1_V : V ;
  nita_vb_2_V : V ;
  nitrera_vb_1_V : V ;
  nivellera_vb_1_V : V ;
  nivaagruppera_vb_1_1_V : V ;
  nobba_vb_1_V : V ;
  nobilisera_vb_1_V : V ;
  nocka_vb_1_V : V ;
  nolla_vb_1_V : V ;
  nominera_vb_1_V : V ;
  nonchalera_vb_1_V : V ;
  noppa_vb_1_V : V ;
  noppra_vb_1_V : V ;
  normalisera_vb_1_V : V ;
  normera_vb_1_V : V ;
  norpa_vb_1_V : V ;
  nota_vb_1_V : V ;
  notera_vb_1_V : V ;
  notificera_vb_1_V : V ;
  notifiera_vb_1_V : V ;
  notisera_vb_1_V : V ;
  nubba_vb_1_V : V ;
  nudda_vb_1_V : V ;
  numrera_vb_1_V : V ;
  nuppa_vb_1_V : V ;
  nyansera_vb_1_V : V ;
  nyanskaffa_vb_1_V : V ;
  nydana_vb_1_V : V ;
  nyemittera_vb_1_V : V ;
  nyetablera_vb_1_V : V ;
  nyinvestera_vb_1_V : V ;
  nynna_vb_1_V : V ;
  nyplantera_vb_1_V : V ;
  nyskapa_vb_1_V : V ;
  nysta_vb_1_V : V ;
  nyteckna_vb_1_V : V ;
  nyttja_vb_1_V : V ;
  naerma_vb_1_1_V : V ;
  naerstudera_vb_1_1_V : V ;
  naeta_vb_1_1_V : V ;
  naada_vb_1_1_V : V ;
  naade_vb_1_1_V : V ;
  naala_vb_1_1_V : V ;
  naata_vb_1_1_V : V ;
  noedbromsa_vb_1_1_V : V ;
  noedga_vb_1_1_V : V ;
  noedlanda_vb_1_1_V : V ;
  noedsaka_vb_1_1_V : V ;
  noedstoppa_vb_1_1_V : V ;
  noedoeppna_vb_1_1_V : V ;
  obducera_vb_1_V : V ;
  objektivera_vb_1_V : V ;
  obligera_vb_1_V : V ;
  observera_vb_1_V : V ;
  occidentalisera_vb_1_V : V ;
  ockupera_vb_1_V : V ;
  odla_vb_1_V : V ;
  offerera_vb_1_V : V ;
  ofreda_vb_1_V : V ;
  ogilla_vb_1_V : V ;
  oka_vb_1_V : V ;
  oktrojera_vb_1_V : V ;
  okulera_vb_1_V : V ;
  okvaeda_vb_1_1_V : V ;
  ola_vb_1_V : V ;
  olagligfoerklara_vb_1_1_V : V ;
  olja_vb_1_V : V ;
  olla_vb_1_V : V ;
  omarbeta_vb_1_V : V ;
  ombilda_vb_1_V : V ;
  omdana_vb_1_V : V ;
  omdirigera_vb_1_V : V ;
  omfamna_vb_1_V : V ;
  omfatta_vb_1_V : V ;
  omflytta_vb_1_V : V ;
  omforma_vb_1_V : V ;
  omfoerdela_vb_1_1_V : V ;
  omfoerhandla_vb_1_1_V : V ;
  omgestalta_vb_1_V : V ;
  omgruppera_vb_1_V : V ;
  omgaerda_vb_1_1_V : V ;
  omhulda_vb_1_V : V ;
  omhaegna_vb_1_1_V : V ;
  omhaekta_vb_1_1_V : V ;
  omkasta_vb_1_V : V ;
  omkostymera_vb_1_V : V ;
  omkransa_vb_1_V : V ;
  omkretsa_vb_1_V : V ;
  ommoeblera_vb_1_1_V : V ;
  omorganisera_vb_1_V : V ;
  omplacera_vb_1_V : V ;
  omplaastra_vb_1_1_V : V ;
  omproeva_vb_1_1_V : V ;
  omrama_vb_1_V : V ;
  omringa_vb_1_V : V ;
  omraekna_vb_1_1_V : V ;
  omskapa_vb_1_V : V ;
  omskola_vb_1_V : V ;
  omskulpturera_vb_1_V : V ;
  omslingra_vb_1_V : V ;
  omstrukturera_vb_1_V : V ;
  omstraala_vb_1_1_V : V ;
  omstoerta_vb_1_1_V : V ;
  omsvaerma_vb_1_1_V : V ;
  omtala_vb_1_V : V ;
  omtolka_vb_1_V : V ;
  omvandla_vb_1_V : V ;
  omvittna_vb_1_V : V ;
  omvaerdera_vb_1_1_V : V ;
  omyndigfoerklara_vb_1_1_V : V ;
  omaendra_vb_1_1_V : V ;
  ondulera_vb_1_V : V ;
  operationalisera_vb_1_V : V ;
  operera_vb_1_V : V ;
  oppamma_vb_1_V : V ;
  opparbeta_vb_1_V : V ;
  oppassa_vb_1_V : V ;
  oppblanda_vb_1_V : V ;
  oppbringa_vb_1_V : V ;
  oppdaga_vb_1_V : V ;
  oppdatera_vb_1_V : V ;
  oppdela_vb_1_V : V ;
  oppegga_vb_1_V : V ;
  oppfatta_vb_1_V : V ;
  oppfostra_vb_1_V : V ;
  oppfriska_vb_1_V : V ;
  oppfaanga_vb_1_1_V : V ;
  opphetsa_vb_1_V : V ;
  opphetta_vb_1_V : V ;
  opphitta_vb_1_V : V ;
  opphaemta_vb_1_1_V : V ;
  oppjustera_vb_1_V : V ;
  oppkalla_vb_1_V : V ;
  oppklara_vb_1_V : V ;
  oppliva_vb_1_V : V ;
  oppmuntra_vb_1_V : V ;
  opponera_vb_1_V : V ;
  opprada_vb_1_V : V ;
  opprensa_vb_1_V : V ;
  oppraekna_vb_1_1_V : V ;
  oppsamla_vb_1_V : V ;
  oppsnabba_vb_1_V : V ;
  oppsummera_vb_1_V : V ;
  opptorna_vb_1_V : V ;
  opptrappa_vb_1_V : V ;
  opptrissa_vb_1_V : V ;
  oppvakta_vb_1_V : V ;
  oppvisa_vb_1_V : V ;
  oppvaerdera_vb_1_1_V : V ;
  oppoeva_vb_1_1_V : V ;
  optimera_vb_1_V : V ;
  ordinera_vb_1_V : V ;
  ordna_vb_1_V : V ;
  oreda_vb_1_V : V ;
  orena_vb_1_V : V ;
  organisera_vb_1_V : V ;
  orientera_vb_2_V : V ;
  orkestrera_vb_1_V : V ;
  ornamentera_vb_1_V : V ;
  ornera_vb_1_V : V ;
  oroa_vb_1_V : V ;
  orsaka_vb_1_V : V ;
  oskaera_vb_1_1_V : V ;
  osnygga_vb_1_V : V ;
  osaekra_vb_1_1_V : V ;
  outa_vb_1_V : V ;
  oxidera_vb_1_V : V ;
  pacificera_vb_1_V : V ;
  packa_vb_1_V : V ;
  paginera_vb_1_V : V ;
  paja_vb_1_V : V ;
  paketera_vb_1_V : V ;
  palatalisera_vb_1_V : V ;
  paljettera_vb_1_V : V ;
  palla_vb_1_V : V ;
  palma_vb_1_V : V ;
  palpera_vb_1_V : V ;
  panela_vb_1_V : V ;
  panera_vb_1_V : V ;
  panga_vb_2_V : V ;
  panikbromsa_vb_1_V : V ;
  panorera_vb_1_V : V ;
  pansra_vb_1_V : V ;
  panta_vb_1_V : V ;
  pantografera_vb_1_V : V ;
  para_vb_1_V : V ;
  paradera_vb_1_V : V ;
  parafera_vb_1_V : V ;
  paraffinera_vb_1_V : V ;
  parafrasera_vb_1_V : V ;
  parallellisera_vb_1_V : V ;
  parallellkoppla_vb_1_V : V ;
  paralysera_vb_1_V : V ;
  parera_vb_1_V : V ;
  parfymera_vb_1_V : V ;
  parkera_vb_1_V : V ;
  parkettera_vb_1_V : V ;
  parodiera_vb_1_V : V ;
  parsa_vb_1_V : V ;
  passa_vb_2_V : V ;
  passera_vb_1_V : V ;
  passivera_vb_1_V : V ;
  passivisera_vb_1_V : V ;
  pastoerisera_vb_1_1_V : V ;
  patentera_vb_1_V : V ;
  patinera_vb_1_V : V ;
  patrullera_vb_1_V : V ;
  pauperisera_vb_1_V : V ;
  pausa_vb_1_V : V ;
  pausera_vb_1_V : V ;
  pauskommatera_vb_1_V : V ;
  paxa_vb_1_V : V ;
  pejla_vb_1_V : V ;
  pelletera_vb_1_V : V ;
  penetrera_vb_1_V : V ;
  pensionera_vb_1_V : V ;
  peppa_vb_1_V : V ;
  pepparspreja_vb_1_V : V ;
  peppra_vb_1_V : V ;
  percipiera_vb_1_V : V ;
  perforera_vb_1_V : V ;
  periodisera_vb_1_V : V ;
  permanenta_vb_1_V : V ;
  permanentondulera_vb_1_V : V ;
  permittera_vb_1_V : V ;
  permutera_vb_1_V : V ;
  persiflera_vb_1_V : V ;
  personifiera_vb_1_V : V ;
  personkryssa_vb_1_V : V ;
  persvadera_vb_1_V : V ;
  pervertera_vb_1_V : V ;
  peta_vb_2_V : V ;
  petrifiera_vb_1_V : V ;
  picka_vb_1_V : V ;
  pierca_vb_1_V : V ;
  pika_vb_1_V : V ;
  pikera_vb_1_V : V ;
  pilka_vb_1_V : V ;
  pimpa_vb_1_V : V ;
  pina_vb_1_V : V ;
  pincera_vb_1_V : V ;
  pinna_vb_1_V : V ;
  pippa_vb_1_V : V ;
  pirka_vb_1_V : V ;
  piska_vb_1_V : V ;
  pistolhota_vb_1_V : V ;
  placera_vb_1_V : V ;
  plagiera_vb_1_V : V ;
  plana_vb_1_V : V ;
  planera_vb_1_V : V ;
  planka_vb_2_V : V ;
  planta_vb_1_V : V ;
  plantera_vb_1_V : V ;
  plasta_vb_1_V : V ;
  platinera_vb_1_V : V ;
  pligga_vb_1_V : V ;
  plissera_vb_1_V : V ;
  plocka_vb_1_V : V ;
  ploga_vb_1_V : V ;
  plombera_vb_1_V : V ;
  plotta_vb_1_V : V ;
  plugga_vb_1_V : V ;
  plysa_vb_1_V : V ;
  plaetera_vb_1_1_V : V ;
  plaaga_vb_1_1_V : V ;
  plaastra_vb_1_1_V : V ;
  plaata_vb_1_1_V : V ;
  pochera_vb_1_V : V ;
  pointera_vb_1_V : V ;
  polarisera_vb_1_V : V ;
  polera_vb_1_V : V ;
  polisbevaka_vb_1_V : V ;
  politisera_vb_1_V : V ;
  pollettera_vb_1_V : V ;
  pollinera_vb_1_V : V ;
  pomadera_vb_1_V : V ;
  poppa_vb_1_V : V ;
  popularisera_vb_1_V : V ;
  porta_vb_1_V : V ;
  portionera_vb_1_V : V ;
  portraettera_vb_1_1_V : V ;
  posta_vb_1_V : V ;
  postdatera_vb_1_V : V ;
  postera_vb_1_V : V ;
  postponera_vb_1_V : V ;
  postroesta_vb_1_1_V : V ;
  poststaempla_vb_1_1_V : V ;
  postulera_vb_1_V : V ;
  poaengtera_vb_1_1_V : V ;
  praktisera_vb_1_V : V ;
  precisera_vb_1_V : V ;
  predestinera_vb_1_V : V ;
  predicera_vb_1_V : V ;
  predika_vb_1_V : V ;
  predisponera_vb_1_V : V ;
  prefabricera_vb_1_V : V ;
  preferera_vb_1_V : V ;
  prefigera_vb_1_V : V ;
  preja_vb_1_V : V ;
  preludiera_vb_1_V : V ;
  premiera_vb_1_V : V ;
  premiaervisa_vb_1_1_V : V ;
  preparera_vb_1_V : V ;
  presenta_vb_1_V : V ;
  presentera_vb_1_V : V ;
  preservera_vb_1_V : V ;
  preskribera_vb_1_V : V ;
  pressa_vb_1_V : V ;
  prestera_vb_1_V : V ;
  presumera_vb_1_V : V ;
  pricka_vb_1_V : V ;
  prioritera_vb_1_V : V ;
  prisa_vb_1_V : V ;
  prisreglera_vb_1_V : V ;
  privatisera_vb_1_V : V ;
  privilegiera_vb_1_V : V ;
  probera_vb_1_V : V ;
  problematisera_vb_1_V : V ;
  processa_vb_2_V : V ;
  producera_vb_1_V : V ;
  profanera_vb_1_V : V ;
  professionalisera_vb_1_V : V ;
  profilera_vb_1_V : V ;
  prognostisera_vb_1_V : V ;
  programmera_vb_1_V : V ;
  projektera_vb_1_V : V ;
  projicera_vb_1_V : V ;
  proklamera_vb_1_V : V ;
  proletarisera_vb_1_V : V ;
  prolongera_vb_1_V : V ;
  promovera_vb_1_V : V ;
  promulgera_vb_1_V : V ;
  prononcera_vb_1_V : V ;
  proponera_vb_1_V : V ;
  proportionera_vb_1_V : V ;
  proppa_vb_1_V : V ;
  proskribera_vb_1_V : V ;
  prospektera_vb_1_V : V ;
  protegera_vb_1_V : V ;
  protokollera_vb_1_V : V ;
  prova_vb_1_V : V ;
  provocera_vb_1_V : V ;
  provroersbefrukta_vb_1_1_V : V ;
  pruta_vb_1_V : V ;
  praegla_vb_1_1_V : V ;
  praenta_vb_1_1_V : V ;
  praama_vb_1_1_V : V ;
  proejsa_vb_1_1_V : V ;
  proeva_vb_1_1_V : V ;
  psyka_vb_1_V : V ;
  psykoanalysera_vb_1_V : V ;
  psykologisera_vb_1_V : V ;
  publicera_vb_1_V : V ;
  pudra_vb_1_V : V ;
  puffa_vb_2_V : V ;
  pulverisera_vb_1_V : V ;
  pulverlackera_vb_1_V : V ;
  pulvrisera_vb_1_V : V ;
  pumpa_vb_1_V : V ;
  punkta_vb_1_V : V ;
  punktbevaka_vb_1_V : V ;
  punktera_vb_1_V : V ;
  punktmarkera_vb_1_V : V ;
  punktsvetsa_vb_1_V : V ;
  punsa_vb_1_V : V ;
  purgera_vb_1_V : V ;
  purpra_vb_1_V : V ;
  purpurfaerga_vb_1_1_V : V ;
  purra_vb_1_V : V ;
  pusha_vb_1_V : V ;
  pussa_vb_1_V : V ;
  putsa_vb_1_V : V ;
  putta_vb_1_V : V ;
  pynta_vb_1_V : V ;
  pytsa_vb_1_V : V ;
  paela_vb_1_1_V : V ;
  paaa_vb_1_1_V : V ;
  paaannonsera_vb_1_1_V : V ;
  paaboerda_vb_1_1_V : V ;
  paaboerja_vb_1_1_V : V ;
  paadyvla_vb_1_1_V : V ;
  paafordra_vb_1_1_V : V ;
  paakalla_vb_1_1_V : V ;
  paala_vb_1_1_V : V ;
  paapeka_vb_1_1_V : V ;
  paaropa_vb_1_1_V : V ;
  paaraekna_vb_1_1_V : V ;
  paaskynda_vb_1_1_V : V ;
  paatala_vb_1_1_V : V ;
  paatraeffa_vb_1_1_V : V ;
  paaverka_vb_1_1_V : V ;
  paavisa_vb_1_1_V : V ;
  paayrka_vb_1_1_V : V ;
  quilta_vb_1_V : V ;
  rabattera_vb_1_V : V ;
  racka_vb_1_V : V ;
  radera_vb_1_V : V ;
  radiera_vb_1_V : V ;
  radikalisera_vb_1_V : V ;
  raffinera_vb_1_V : V ;
  ragga_vb_1_V : V ;
  raka_vb_1_V : V ;
  rama_vb_1_V : V ;
  ramma_vb_1_V : V ;
  ramponera_vb_1_V : V ;
  ramsa_vb_1_V : V ;
  randa_vb_1_V : V ;
  randomisera_vb_1_V : V ;
  rangera_vb_1_V : V ;
  rangordna_vb_1_V : V ;
  ranka_vb_1_V : V ;
  rannsaka_vb_1_V : V ;
  ransonera_vb_1_V : V ;
  rappa_vb_1_V : V ;
  rappellera_vb_1_V : V ;
  rapportera_vb_1_V : V ;
  rasdiskriminera_vb_1_V : V ;
  rasera_vb_1_V : V ;
  raspa_vb_1_V : V ;
  rasta_vb_2_V : V ;
  rata_vb_1_V : V ;
  ratificera_vb_1_V : V ;
  rationalisera_vb_1_V : V ;
  ratta_vb_1_V : V ;
  rea_vb_1_V : V ;
  reaktivera_vb_1_V : V ;
  realisera_vb_1_V : V ;
  reassurera_vb_1_V : V ;
  recensera_vb_1_V : V ;
  recipiera_vb_1_V : V ;
  recitera_vb_1_V : V ;
  redigera_vb_1_V : V ;
  redovisa_vb_1_V : V ;
  redubbla_vb_1_V : V ;
  reducera_vb_1_V : V ;
  referera_vb_1_V : V ;
  reflektera_vb_1_V : V ;
  reformera_vb_1_V : V ;
  refusera_vb_1_V : V ;
  regalera_vb_1_V : V ;
  regenerera_vb_1_V : V ;
  regera_vb_1_V : V ;
  regissera_vb_1_V : V ;
  registrera_vb_1_V : V ;
  reglementera_vb_1_V : V ;
  reglera_vb_1_V : V ;
  reglera_vb_2_V : V ;
  regummera_vb_1_V : V ;
  rehabilitera_vb_1_V : V ;
  reinkarnera_vb_1_V : V ;
  reka_vb_1_V : V ;
  rekapitulera_vb_1_V : V ;
  reklamera_vb_1_V : V ;
  rekognoscera_vb_1_V : V ;
  rekognosera_vb_1_V : V ;
  rekommendera_vb_1_V : V ;
  rekompensera_vb_1_V : V ;
  rekonstruera_vb_1_V : V ;
  rekrytera_vb_1_V : V ;
  rektificera_vb_1_V : V ;
  rektifiera_vb_1_V : V ;
  rekvirera_vb_1_V : V ;
  relatera_vb_1_V : V ;
  relegera_vb_1_V : V ;
  relaea_vb_1_1_V : V ;
  remissbehandla_vb_1_V : V ;
  remittera_vb_1_V : V ;
  remma_vb_1_V : V ;
  remplacera_vb_1_V : V ;
  rena_vb_1_V : V ;
  rendera_vb_1_V : V ;
  renodla_vb_1_V : V ;
  renovera_vb_1_V : V ;
  renraka_vb_1_V : V ;
  rensa_vb_1_V : V ;
  reorganisera_vb_1_V : V ;
  repa_vb_1_V : V ;
  reparera_vb_1_V : V ;
  repartisera_vb_1_V : V ;
  repatriera_vb_1_V : V ;
  repellera_vb_1_V : V ;
  repetera_vb_1_V : V ;
  representera_vb_1_V : V ;
  reprisera_vb_1_V : V ;
  reproducera_vb_1_V : V ;
  reservera_vb_1_V : V ;
  resolvera_vb_1_V : V ;
  resorbera_vb_1_V : V ;
  respektera_vb_1_V : V ;
  respirera_vb_1_V : V ;
  restaurera_vb_1_V : V ;
  restituera_vb_1_V : V ;
  resumera_vb_1_V : V ;
  reta_vb_1_V : V ;
  retablera_vb_1_V : V ;
  retardera_vb_1_V : V ;
  returnera_vb_1_V : V ;
  retuschera_vb_1_V : V ;
  reva_vb_1_V : V ;
  revalvera_vb_1_V : V ;
  revetera_vb_1_V : V ;
  revidera_vb_1_V : V ;
  revolutionera_vb_1_V : V ;
  ria_vb_1_V : V ;
  rigga_vb_1_V : V ;
  rikoschettera_vb_1_V : V ;
  rikta_vb_1_V : V ;
  rimma_vb_1_V : V ;
  rimsalta_vb_1_V : V ;
  ringa_vb_2_V : V ;
  ringakta_vb_1_V : V ;
  ringbarka_vb_1_V : V ;
  risa_vb_1_V : V ;
  rispa_vb_1_V : V ;
  rista_vb_1_V : V ;
  rita_vb_1_V : V ;
  ritsa_vb_1_V : V ;
  ritualisera_vb_1_V : V ;
  rivstarta_vb_1_V : V ;
  roa_vb_1_V : V ;
  robotisera_vb_1_V : V ;
  rockera_vb_1_V : V ;
  roffa_vb_1_V : V ;
  rolla_vb_1_V : V ;
  romantisera_vb_1_V : V ;
  rosa_vb_1_V : V ;
  rosta_vb_2_V : V ;
  rostbehandla_vb_1_V : V ;
  rostskydda_vb_1_V : V ;
  rotera_vb_1_V : V ;
  rubba_vb_1_V : V ;
  rubricera_vb_1_V : V ;
  rucka_vb_1_V : V ;
  rugga_vb_2_V : V ;
  ruinera_vb_1_V : V ;
  rulla_vb_1_V : V ;
  runda_vb_1_V : V ;
  rundsticka_vb_1_V : V ;
  runka_vb_1_V : V ;
  rusa_vb_2_V : V ;
  ruska_vb_1_V : V ;
  russificera_vb_1_V : V ;
  russifiera_vb_1_V : V ;
  rusta_vb_1_V : V ;
  ruva_vb_1_V : V ;
  rykta_vb_1_V : V ;
  rynka_vb_1_V : V ;
  rytmisera_vb_1_V : V ;
  raedda_vb_1_1_V : V ;
  raefsa_vb_1_1_V : V ;
  raekna_vb_1_1_V : V ;
  raemna_vb_1_1_V : V ;
  raeta_vb_1_1_V : V ;
  raetta_vb_1_1_V : V ;
  raettfaerdiga_vb_1_1_V : V ;
  raadbraaka_vb_1_1_V : V ;
  raadfraaga_vb_1_1_V : V ;
  raadplaega_vb_1_1_V : V ;
  raaga_vb_1_1_V : V ;
  raaka_vb_1_1_V : V ;
  raana_vb_1_1_V : V ;
  raaplugga_vb_1_1_V : V ;
  raaskala_vb_1_1_V : V ;
  roedgloedga_vb_1_1_V : V ;
  roedlista_vb_1_1_V : V ;
  roentga_vb_1_1_V : V ;
  roentgenfotografera_vb_1_1_V : V ;
  roesa_vb_1_1_V : V ;
  roeta_vb_1_1_V : V ;
  roeva_vb_1_1_V : V ;
  roevknulla_vb_1_1_V : V ;
  sabba_vb_1_V : V ;
  sabotera_vb_1_V : V ;
  sabrera_vb_1_V : V ;
  safta_vb_1_V : V ;
  saka_vb_1_V : V ;
  sakerfoerklara_vb_1_1_V : V ;
  sakna_vb_1_V : V ;
  sakta_vb_1_V : V ;
  sala_vb_1_V : V ;
  saldera_vb_1_V : V ;
  saligfoerklara_vb_1_1_V : V ;
  salta_vb_1_V : V ;
  salutera_vb_1_V : V ;
  sambeskatta_vb_1_V : V ;
  samka_vb_1_V : V ;
  samla_vb_2_V : V ;
  sammanavla_vb_1_V : V ;
  sammanblanda_vb_1_V : V ;
  sammandrabba_vb_1_V : V ;
  sammanfatta_vb_1_V : V ;
  sammanflaeta_vb_1_1_V : V ;
  sammanfoga_vb_1_V : V ;
  sammanhopa_vb_1_V : V ;
  sammanjaemka_vb_1_1_V : V ;
  sammankalla_vb_1_V : V ;
  sammanlaenka_vb_1_1_V : V ;
  sammanpacka_vb_1_V : V ;
  sammanpressa_vb_1_V : V ;
  sammanraekna_vb_1_1_V : V ;
  sammanstraala_vb_1_1_V : V ;
  sammansvetsa_vb_1_V : V ;
  sammantraeffa_vb_1_1_V : V ;
  samordna_vb_1_V : V ;
  samsa_vb_1_V : V ;
  samtaxera_vb_1_V : V ;
  sanda_vb_1_V : V ;
  sandblaestra_vb_1_1_V : V ;
  sandpappra_vb_1_V : V ;
  sanera_vb_1_V : V ;
  sanforisera_vb_1_V : V ;
  sanktifiera_vb_1_V : V ;
  sanktionera_vb_1_V : V ;
  sanna_vb_1_V : V ;
  sannolikhetsberaekna_vb_1_1_V : V ;
  saponifiera_vb_1_V : V ;
  sarga_vb_1_V : V ;
  satinera_vb_1_V : V ;
  satisfiera_vb_1_V : V ;
  satsa_vb_1_V : V ;
  saturera_vb_1_V : V ;
  sautera_vb_1_V : V ;
  sauvera_vb_1_V : V ;
  saxa_vb_1_V : V ;
  scanna_vb_1_V : V ;
  schablonera_vb_1_V : V ;
  schablonisera_vb_1_V : V ;
  schablontaxera_vb_1_V : V ;
  schacka_vb_1_V : V ;
  schakta_vb_1_V : V ;
  schamponera_vb_1_V : V ;
  schanghaja_vb_1_V : V ;
  schappa_vb_1_V : V ;
  schasa_vb_1_V : V ;
  schattera_vb_1_V : V ;
  schematisera_vb_1_V : V ;
  schveifa_vb_1_V : V ;
  sedimentera_vb_1_V : V ;
  seeda_vb_1_V : V ;
  seghaerda_vb_1_1_V : V ;
  segmentera_vb_1_V : V ;
  segra_vb_2_V : V ;
  segregera_vb_1_V : V ;
  sejsa_vb_1_V : V ;
  sekondera_vb_1_V : V ;
  sekularisera_vb_1_V : V ;
  sekundera_vb_1_V : V ;
  sekvensera_vb_1_V : V ;
  sekvestrera_vb_1_V : V ;
  sela_vb_1_V : V ;
  selektera_vb_1_V : V ;
  semaforera_vb_1_V : V ;
  seminera_vb_1_V : V ;
  sensibilisera_vb_1_V : V ;
  sentera_vb_1_V : V ;
  separera_vb_1_V : V ;
  seponera_vb_1_V : V ;
  seriekoppla_vb_1_V : V ;
  serietillverka_vb_1_V : V ;
  serva_vb_1_V : V ;
  servera_vb_1_V : V ;
  sexdubbla_vb_1_V : V ;
  sexfaldiga_vb_1_V : V ;
  sexualisera_vb_1_V : V ;
  sexutnyttja_vb_1_V : V ;
  shamponera_vb_1_V : V ;
  shanghaja_vb_1_V : V ;
  shorta_vb_1_V : V ;
  shunta_vb_1_V : V ;
  sicka_vb_1_V : V ;
  sickla_vb_1_V : V ;
  sicksacka_vb_2_V : V ;
  sidnumrera_vb_1_V : V ;
  sidsteppa_vb_1_V : V ;
  sigillera_vb_1_V : V ;
  signa_vb_1_V : V ;
  signalera_vb_2_V : V ;
  signera_vb_1_V : V ;
  sikta_vb_2_V : V ;
  sila_vb_1_V : V ;
  silhuettera_vb_1_V : V ;
  siluettera_vb_1_V : V ;
  silverinfatta_vb_1_V : V ;
  silvra_vb_1_V : V ;
  simplifiera_vb_1_V : V ;
  simsa_vb_1_V : V ;
  simulera_vb_1_V : V ;
  simultantolka_vb_1_V : V ;
  sinka_vb_1_V : V ;
  sira_vb_1_V : V ;
  sjanghaja_vb_1_V : V ;
  sjappa_vb_1_V : V ;
  sjasa_vb_1_V : V ;
  sjufaldiga_vb_1_V : V ;
  sjaelvfinansiera_vb_1_1_V : V ;
  skada_vb_1_V : V ;
  skadereglera_vb_1_V : V ;
  skaffa_vb_1_V : V ;
  skafta_vb_1_V : V ;
  skaka_vb_1_V : V ;
  skala_vb_1_V : V ;
  skalda_vb_1_V : V ;
  skalka_vb_1_V : V ;
  skalla_vb_2_V : V ;
  skalpera_vb_1_V : V ;
  skamfila_vb_1_V : V ;
  skandalisera_vb_1_V : V ;
  skandera_vb_1_V : V ;
  skanna_vb_1_V : V ;
  skarva_vb_1_V : V ;
  skatta_vb_2_V : V ;
  skatteplanera_vb_1_V : V ;
  skeda_vb_1_V : V ;
  skena_vb_1_V : V ;
  skenplocka_vb_1_V : V ;
  skeppa_vb_1_V : V ;
  skeva_vb_2_V : V ;
  skevra_vb_1_V : V ;
  skifta_vb_1_V : V ;
  skikta_vb_1_V : V ;
  skildra_vb_1_V : V ;
  skingra_vb_1_V : V ;
  skinna_vb_1_V : V ;
  skipa_vb_1_V : V ;
  skippa_vb_1_V : V ;
  skira_vb_1_V : V ;
  skissa_vb_1_V : V ;
  skissera_vb_1_V : V ;
  skiva_vb_1_V : V ;
  skjutsa_vb_1_V : V ;
  skjuva_vb_1_V : V ;
  skoja_vb_2_V : V ;
  skola_vb_1_V : V ;
  skona_vb_1_V : V ;
  skopa_vb_1_V : V ;
  skota_vb_1_V : V ;
  skotta_vb_1_V : V ;
  skottskada_vb_1_V : V ;
  skraffera_vb_1_V : V ;
  skrapa_vb_1_V : V ;
  skrota_vb_1_V : V ;
  skrubba_vb_1_V : V ;
  skruda_vb_1_V : V ;
  skruva_vb_1_V : V ;
  skrymta_vb_1_V : V ;
  skraedda_vb_1_1_V : V ;
  skraena_vb_1_1_V : V ;
  skraepa_vb_1_1_V : V ;
  skraala_vb_1_1_V : V ;
  skraama_vb_1_1_V : V ;
  skubba_vb_1_V : V ;
  skudda_vb_1_V : V ;
  skuffa_vb_1_V : V ;
  skugga_vb_1_V : V ;
  skulptera_vb_1_V : V ;
  skulpturera_vb_1_V : V ;
  skumma_vb_2_V : V ;
  skumpa_vb_1_V : V ;
  skumtvaetta_vb_1_1_V : V ;
  skura_vb_1_V : V ;
  skutta_vb_1_V : V ;
  skvala_vb_1_V : V ;
  skvalpa_vb_1_V : V ;
  skvalta_vb_1_V : V ;
  skvimpa_vb_1_V : V ;
  skvisa_vb_1_V : V ;
  skya_vb_1_V : V ;
  skydda_vb_1_V : V ;
  skyddsimpregnera_vb_1_V : V ;
  skyddsympa_vb_1_V : V ;
  skygga_vb_1_V : V ;
  skyla_vb_2_V : V ;
  skylta_vb_1_V : V ;
  skymfa_vb_1_V : V ;
  skymta_vb_1_V : V ;
  skynda_vb_1_V : V ;
  skaefta_vb_1_1_V : V ;
  skaegga_vb_1_1_V : V ;
  skaekta_vb_1_1_V : V ;
  skaemta_vb_1_1_V : V ;
  skaenda_vb_1_1_V : V ;
  skaera_vb_2_1_V : V ;
  skaermbilda_vb_1_1_V : V ;
  skaerra_vb_1_1_V : V ;
  skaerskaada_vb_1_1_V : V ;
  skaerva_vb_1_1_V : V ;
  skaada_vb_1_1_V : V ;
  skaala_vb_1_1_V : V ;
  skaalla_vb_1_1_V : V ;
  skaara_vb_1_1_V : V ;
  skoelpa_vb_1_1_V : V ;
  skoenmaala_vb_1_1_V : V ;
  skoenstaxera_vb_1_1_V : V ;
  skoentaxera_vb_1_1_V : V ;
  skoera_vb_1_1_V : V ;
  skoerda_vb_1_1_V : V ;
  skoerna_vb_1_1_V : V ;
  slabba_vb_1_V : V ;
  slacka_vb_1_V : V ;
  sladda_vb_1_V : V ;
  slafa_vb_1_V : V ;
  slafsa_vb_1_V : V ;
  slagga_vb_1_V : V ;
  slaka_vb_1_V : V ;
  slakna_vb_1_V : V ;
  slakta_vb_1_V : V ;
  slamma_vb_2_V : V ;
  slamsa_vb_1_V : V ;
  slanga_vb_1_V : V ;
  slanka_vb_1_V : V ;
  slankna_vb_1_V : V ;
  slanta_vb_1_V : V ;
  slappa_vb_1_V : V ;
  slappna_vb_1_V : V ;
  slarva_vb_1_V : V ;
  slasa_vb_1_V : V ;
  slaska_vb_1_V : V ;
  slava_vb_1_V : V ;
  slavisera_vb_1_V : V ;
  slentrianmoerka_vb_1_1_V : V ;
  sleva_vb_1_V : V ;
  slicka_vb_1_V : V ;
  slikta_vb_1_V : V ;
  slipa_vb_1_V : V ;
  slira_vb_1_V : V ;
  slockna_vb_1_V : V ;
  slutbehandla_vb_1_V : V ;
  slutfoervara_vb_1_1_V : V ;
  smygfilma_vb_1_V : V ;
  smygislamisera_vb_1_V : V ;
  smaeda_vb_1_1_V : V ;
  snabbgranska_vb_1_V : V ;
  snabbspola_vb_1_V : V ;
  snedparkera_vb_1_V : V ;
  snedrekrytera_vb_1_V : V ;
  snickra_vb_1_V : V ;
  snorkla_vb_1_V : V ;
  snorta_vb_1_V : V ;
  snoemula_vb_1_1_V : V ;
  socialisera_vb_1_V : V ;
  sockra_vb_1_V : V ;
  solvera_vb_1_V : V ;
  sona_vb_1_V : V ;
  sondera_vb_1_V : V ;
  sondmata_vb_1_V : V ;
  sopsortera_vb_1_V : V ;
  sordinera_vb_1_V : V ;
  sorla_vb_1_V : V ;
  sortera_vb_1_V : V ;
  soulagera_vb_1_V : V ;
  sovjetisera_vb_1_V : V ;
  sovra_vb_1_V : V ;
  spaljera_vb_1_V : V ;
  spallera_vb_1_V : V ;
  specialisera_vb_1_V : V ;
  specificera_vb_1_V : V ;
  speciminera_vb_1_V : V ;
  spegla_vb_1_V : V ;
  spekulera_vb_1_V : V ;
  spika_vb_1_V : V ;
  spoliera_vb_1_V : V ;
  sponsra_vb_1_V : V ;
  sprutlackera_vb_1_V : V ;
  stabilisera_vb_1_V : V ;
  stadga_vb_1_V : V ;
  stadsplanera_vb_1_V : V ;
  staffera_vb_1_V : V ;
  stagnera_vb_1_V : V ;
  stajla_vb_1_V : V ;
  stalka_vb_1_V : V ;
  stamma_vb_1_V : V ;
  standardisera_vb_1_V : V ;
  stationera_vb_1_V : V ;
  statuera_vb_2_V : V ;
  stegra_vb_1_V : V ;
  stelna_vb_1_V : V ;
  stencilera_vb_1_V : V ;
  stenografera_vb_1_V : V ;
  stereofotografera_vb_1_V : V ;
  stereotypera_vb_1_V : V ;
  sterilisera_vb_1_V : V ;
  stigmatisera_vb_1_V : V ;
  stilisera_vb_1_V : V ;
  stimulera_vb_1_V : V ;
  stipendiera_vb_1_V : V ;
  stipulera_vb_1_V : V ;
  stoffera_vb_1_V : V ;
  stormsaekra_vb_1_1_V : V ;
  strangulera_vb_1_V : V ;
  stratifiera_vb_1_V : V ;
  stridsformera_vb_1_V : V ;
  stridsgruppera_vb_1_V : V ;
  strukturera_vb_1_V : V ;
  strukturrationalisera_vb_1_V : V ;
  straalkonservera_vb_1_1_V : V ;
  studera_vb_1_V : V ;
  studieorientera_vb_1_V : V ;
  styla_vb_1_V : V ;
  staempla_vb_1_1_V : V ;
  staengsla_vb_1_1_V : V ;
  stoevla_vb_1_1_V : V ;
  sublimera_vb_1_V : V ;
  subordinera_vb_1_V : V ;
  subsidiera_vb_1_V : V ;
  subskribera_vb_1_V : V ;
  substantivera_vb_1_V : V ;
  substituera_vb_1_V : V ;
  subsumera_vb_1_V : V ;
  subtrahera_vb_1_V : V ;
  subventionera_vb_1_V : V ;
  succedera_vb_1_V : V ;
  suffigera_vb_1_V : V ;
  sufflera_vb_1_V : V ;
  suggerera_vb_1_V : V ;
  summera_vb_1_V : V ;
  supplera_vb_1_V : V ;
  supponera_vb_1_V : V ;
  suspendera_vb_1_V : V ;
  svalna_vb_1_V : V ;
  svara_vb_1_V : V ;
  svartmaala_vb_1_1_V : V ;
  svartna_vb_1_V : V ;
  symbolisera_vb_1_V : V ;
  synkopera_vb_1_V : V ;
  synkronisera_vb_1_V : V ;
  syntetisera_vb_1_V : V ;
  systematisera_vb_1_V : V ;
  saekra_vb_1_1_V : V ;
  saerbehandla_vb_1_1_V : V ;
  saaga_vb_2_1_V : V ;
  saatera_vb_1_1_V : V ;
  saavera_vb_1_1_V : V ;
  soemma_vb_1_1_V : V ;
  soendra_vb_1_1_V : V ;
  tabellera_vb_1_V : V ;
  tabuera_vb_1_V : V ;
  tamponera_vb_1_V : V ;
  tandtraada_vb_1_1_V : V ;
  tangera_vb_1_V : V ;
  tapetsera_vb_1_V : V ;
  tarera_vb_1_V : V ;
  tariffera_vb_1_V : V ;
  tatuera_vb_1_V : V ;
  taxera_vb_1_V : V ;
  teckna_vb_1_V : V ;
  teknifiera_vb_1_V : V ;
  telefonera_vb_1_V : V ;
  telegrafera_vb_1_V : V ;
  televisera_vb_1_V : V ;
  tempera_vb_1_V : V ;
  temperera_vb_1_V : V ;
  tentera_vb_1_V : V ;
  terrassera_vb_1_V : V ;
  terrorisera_vb_1_V : V ;
  tesaurera_vb_1_V : V ;
  testamentera_vb_1_V : V ;
  tidsberaekna_vb_1_1_V : V ;
  tillfoerordna_vb_1_1_V : V ;
  tillfoersaekra_vb_1_1_V : V ;
  tillkoppla_vb_1_V : V ;
  tillstroemma_vb_1_1_V : V ;
  tilta_vb_1_V : V ;
  timra_vb_1_V : V ;
  tiodubbla_vb_1_V : V ;
  titrera_vb_1_V : V ;
  titulera_vb_1_V : V ;
  tjonga_vb_1_V : V ;
  tjudra_vb_1_V : V ;
  tjugofaldiga_vb_1_V : V ;
  tjuvfiska_vb_1_V : V ;
  tjuvjaga_vb_1_V : V ;
  tjuvkoppla_vb_1_V : V ;
  tjuvlyssna_vb_1_V : V ;
  tjyvfiska_vb_1_V : V ;
  tjyvjaga_vb_1_V : V ;
  tjyvkoppla_vb_1_V : V ;
  tjyvlyssna_vb_1_V : V ;
  tolerera_vb_1_V : V ;
  tolvfaldiga_vb_1_V : V ;
  topsa_vb_1_V : V ;
  tordera_vb_1_V : V ;
  torktumla_vb_1_V : V ;
  torpedera_vb_1_V : V ;
  torrdestillera_vb_1_V : V ;
  torrschamponera_vb_1_V : V ;
  tortera_vb_1_V : V ;
  totalfinansiera_vb_1_V : V ;
  totalfoerlama_vb_1_1_V : V ;
  totalhaverera_vb_1_V : V ;
  totalsabba_vb_1_V : V ;
  totalvaegra_vb_1_1_V : V ;
  touchera_vb_1_V : V ;
  toupera_vb_1_V : V ;
  tracka_vb_1_V : V ;
  tradera_vb_1_V : V ;
  trafikera_vb_1_V : V ;
  trafikreglera_vb_1_V : V ;
  trakassera_vb_1_V : V ;
  traktera_vb_1_V : V ;
  transferera_vb_1_V : V ;
  transformera_vb_1_V : V ;
  transitera_vb_1_V : V ;
  transkribera_vb_1_V : V ;
  translitterera_vb_1_V : V ;
  transmittera_vb_1_V : V ;
  transmutera_vb_1_V : V ;
  transplantera_vb_1_V : V ;
  transponera_vb_1_V : V ;
  transportera_vb_1_V : V ;
  transumera_vb_1_V : V ;
  trasha_vb_1_V : V ;
  trassera_vb_1_V : V ;
  travestera_vb_1_V : V ;
  tredubbla_vb_1_V : V ;
  trefaldiga_vb_1_V : V ;
  trepanera_vb_1_V : V ;
  triangulera_vb_1_V : V ;
  tricksa_vb_1_V : V ;
  triera_vb_1_V : V ;
  trigga_vb_1_V : V ;
  trippla_vb_1_V : V ;
  trivialisera_vb_1_V : V ;
  trixa_vb_1_V : V ;
  trumma_vb_1_V : V ;
  tryckimpregnera_vb_1_V : V ;
  tryffera_vb_1_V : V ;
  traea_vb_1_1_V : V ;
  troeghetsnavigera_vb_1_1_V : V ;
  troettna_vb_1_1_V : V ;
  tumma_vb_1_V : V ;
  tupera_vb_1_V : V ;
  turnera_vb_2_V : V ;
  tuschera_vb_1_V : V ;
  tvaga_vb_1_V : V ;
  tvista_vb_1_V : V ;
  tvivla_vb_1_V : V ;
  tvaangskommendera_vb_1_1_V : V ;
  tvaangsrekrytera_vb_1_1_V : V ;
  tvaangstatuera_vb_1_1_V : V ;
  twittra_vb_1_V : V ;
  typifiera_vb_1_V : V ;
  typisera_vb_1_V : V ;
  tyrannisera_vb_1_V : V ;
  taeckdika_vb_1_1_V : V ;
  taevla_vb_1_1_V : V ;
  taevlingssegla_vb_1_1_V : V ;
  taagpendla_vb_1_1_V : V ;
  ultrarapidfotografera_vb_1_V : V ;
  underbalansera_vb_1_V : V ;
  underdimensionera_vb_1_V : V ;
  underexponera_vb_1_V : V ;
  underfoersaekra_vb_1_1_V : V ;
  underhandla_vb_1_V : V ;
  underlaetta_vb_1_1_V : V ;
  underminera_vb_1_V : V ;
  underredsbehandla_vb_1_V : V ;
  undertaxera_vb_1_V : V ;
  underteckna_vb_1_V : V ;
  undervaerdera_vb_1_1_V : V ;
  undra_vb_1_V : V ;
  unifiera_vb_1_V : V ;
  uniformera_vb_1_V : V ;
  uppamma_vb_1_V : V ;
  uppdatera_vb_1_V : V ;
  uppfodra_vb_1_V : V ;
  uppfordra_vb_1_V : V ;
  uppfostra_vb_1_V : V ;
  uppgradera_vb_1_V : V ;
  upphandla_vb_1_V : V ;
  uppjustera_vb_1_V : V ;
  upplagra_vb_1_V : V ;
  uppmuddra_vb_1_V : V ;
  uppmuntra_vb_1_V : V ;
  uppmaerksamma_vb_1_1_V : V ;
  uppodla_vb_1_V : V ;
  uppoffra_vb_1_V : V ;
  uppreklamera_vb_1_V : V ;
  uppraekna_vb_1_1_V : V ;
  uppsamla_vb_1_V : V ;
  uppslamma_vb_1_V : V ;
  uppsummera_vb_1_V : V ;
  upptaxera_vb_1_V : V ;
  uppvigla_vb_1_V : V ;
  uppvisa_vb_1_V : V ;
  uppvaerdera_vb_1_1_V : V ;
  urbanisera_vb_1_V : V ;
  urholka_vb_1_V : V ;
  usurpera_vb_1_V : V ;
  utackordera_vb_1_V : V ;
  utannonsera_vb_1_V : V ;
  utarrendera_vb_1_V : V ;
  utbalansera_vb_1_V : V ;
  utbasunera_vb_1_V : V ;
  utblotta_vb_1_V : V ;
  utbomba_vb_1_V : V ;
  utbrodera_vb_1_V : V ;
  utdebitera_vb_1_V : V ;
  utexaminera_vb_1_V : V ;
  utexperimentera_vb_1_V : V ;
  utfodra_vb_1_V : V ;
  utfordra_vb_1_V : V ;
  utfoersaekra_vb_1_1_V : V ;
  uthamra_vb_1_V : V ;
  utkamma_vb_1_V : V ;
  utklarera_vb_1_V : V ;
  utkommendera_vb_1_V : V ;
  utkonkurrera_vb_1_V : V ;
  utkristallisera_vb_1_V : V ;
  utkvittera_vb_1_V : V ;
  utlokalisera_vb_1_V : V ;
  utlaemna_vb_1_1_V : V ;
  utmanoevrera_vb_1_1_V : V ;
  utmejsla_vb_1_V : V ;
  utminutera_vb_1_V : V ;
  utmoenstra_vb_1_1_V : V ;
  utplacera_vb_1_V : V ;
  utplundra_vb_1_V : V ;
  utpostera_vb_1_V : V ;
  utradera_vb_1_V : V ;
  utrangera_vb_1_V : V ;
  utslockna_vb_1_V : V ;
  utstoffera_vb_1_V : V ;
  utsoendra_vb_1_1_V : V ;
  uttaxera_vb_1_V : V ;
  utvandra_vb_1_V : V ;
  utveckla_vb_1_V : V ;
  utvaerdera_vb_1_1_V : V ;
  utvaexla_vb_1_1_V : V ;
  vaccinera_vb_1_V : V ;
  vaddera_vb_1_V : V ;
  vakna_vb_1_V : V ;
  vaksinera_vb_1_V : V ;
  valutera_vb_1_V : V ;
  valvera_vb_1_V : V ;
  vandalisera_vb_1_V : V ;
  vandra_vb_1_V : V ;
  vanhedra_vb_1_V : V ;
  vanhelga_vb_1_V : V ;
  variera_vb_1_V : V ;
  varudeklarera_vb_1_V : V ;
  vattenkamma_vb_1_V : V ;
  vattra_vb_1_V : V ;
  veckla_vb_1_V : V ;
  velourisera_vb_1_V : V ;
  ventilera_vb_1_V : V ;
  verbalisera_vb_1_V : V ;
  verifiera_vb_1_V : V ;
  verklighetsfoerankra_vb_1_1_V : V ;
  versifiera_vb_1_V : V ;
  vevla_vb_1_V : V ;
  vidarebefordra_vb_1_V : V ;
  vidarerapportera_vb_1_V : V ;
  vidareutbilda_vb_1_V : V ;
  vidareutveckla_vb_1_V : V ;
  vidfoga_vb_1_V : V ;
  vidimera_vb_1_V : V ;
  vikta_vb_1_V : V ;
  vindicera_vb_1_V : V ;
  vindpollinera_vb_1_V : V ;
  vinstmaximera_vb_1_V : V ;
  vinterbada_vb_1_V : V ;
  vintercykla_vb_1_V : V ;
  visera_vb_1_V : V ;
  visitera_vb_1_V : V ;
  visualisera_vb_1_V : V ;
  vitalisera_vb_1_V : V ;
  vitaminera_vb_1_V : V ;
  vitaminisera_vb_1_V : V ;
  vitlimma_vb_1_V : V ;
  vitna_vb_1_V : V ;
  vitra_vb_1_V : V ;
  vittna_vb_1_V : V ;
  vittra_vb_1_V : V ;
  vokalisera_vb_1_V : V ;
  volta_vb_1_V : V ;
  vulgarisera_vb_1_V : V ;
  vulkanisera_vb_1_V : V ;
  vaedja_vb_1_1_V : V ;
  vaedra_vb_1_1_V : V ;
  vaeggmontera_vb_1_1_V : V ;
  vaegra_vb_1_1_V : V ;
  vaelkomna_vb_1_1_V : V ;
  vaeltra_vb_1_1_V : V ;
  vaenstra_vb_1_1_V : V ;
  vaerdera_vb_1_1_V : V ;
  vaerdesaekra_vb_1_1_V : V ;
  vaermebehandla_vb_1_1_V : V ;
  vaermefotografera_vb_1_1_V : V ;
  vaermeisolera_vb_1_1_V : V ;
  vaermesterilisera_vb_1_1_V : V ;
  vaadaskjuta_vb_1_1_V : V ;
  vaarstaeda_vb_1_1_V : V ;
  wallraffa_vb_1_V : V ;
  ytbehandla_vb_1_V : V ;
  yttra_vb_1_V : V ;
  aelska_vb_1_1_V : V ;
  aemnesintegrera_vb_1_1_V : V ;
  aenda_vb_1_1_V : V ;
  aendra_vb_1_1_V : V ;
  aadra_vb_2_1_V : V ;
  aaldersdiskriminera_vb_1_1_V : V ;
  aasiktsregistrera_vb_1_1_V : V ;
  aateranpassa_vb_1_1_V : V ;
  aaterbilda_vb_1_1_V : V ;
  aaterboerda_vb_1_1_V : V ;
  aatereroevra_vb_1_1_V : V ;
  aaterfoersaekra_vb_1_1_V : V ;
  aaterinstallera_vb_1_1_V : V ;
  aaterinvestera_vb_1_1_V : V ;
  aaterkoppla_vb_1_1_V : V ;
  aaterlaemna_vb_1_1_V : V ;
  aaterplantera_vb_1_1_V : V ;
  aaterspegla_vb_1_1_V : V ;
  aatra_vb_1_1_V : V ;
  oedsla_vb_1_1_V : V ;
  oegonflirta_vb_1_1_V : V ;
  oegonfloerta_vb_1_1_V : V ;
  oeppna_vb_1_1_V : V ;
  oeverbelasta_vb_1_1_V : V ;
  oeverdebitera_vb_1_1_V : V ;
  oeverdimensionera_vb_1_1_V : V ;
  oeverdosera_vb_1_1_V : V ;
  oeverexponera_vb_1_1_V : V ;
  oeverflygla_vb_1_1_V : V ;
  oeverkompensera_vb_1_1_V : V ;
  oeverlagra_vb_1_1_V : V ;
  oeverlaemna_vb_1_1_V : V ;
  oeverordna_vb_1_1_V : V ;
  oeverraska_vb_1_1_V : V ;
  oeverrenovera_vb_1_1_V : V ;
  oeverrumpla_vb_1_1_V : V ;
  oeverstegra_vb_1_1_V : V ;
  oeversvaemma_vb_1_1_V : V ;
  oevertrassera_vb_1_1_V : V ;
  oeverutnyttja_vb_1_1_V : V ;
  oevervintra_vb_1_1_V : V ;
  oevervaeltra_vb_1_1_V : V ;
  oevervaerdera_vb_1_1_V : V ;
  oevernattningsrum_nn_1_1_N : N ;
  oeverman_nn_1_1_N : N ;
  oeverhuvud_nn_1_1_N : N ;
  oeverfallsvaaldtaektsman_nn_1_1_N : N ;
  oerlogsman_nn_1_1_N : N ;
  oera_nn_1_1_N : N ;
  oega_nn_1_1_N : N ;
  oedesdrama_nn_1_1_N : N ;
  aavatten_nn_1_1_N : N ;
  aaterstaellningstecken_nn_1_1_N : N ;
  aasneoera_nn_1_1_N : N ;
  aangstroem_nn_1_1_N : N ;
  aalderstecken_nn_1_1_N : N ;
  aalderman_nn_1_1_N : N ;
  aalderdomshem_nn_1_1_N : N ;
  aettefader_nn_1_1_N : N ;
  aeretecken_nn_1_1_N : N ;
  aenkeman_nn_1_1_N : N ;
  aendrim_nn_1_1_N : N ;
  aembetsrum_nn_1_1_N : N ;
  aembetsman_nn_1_1_N : N ;
  aembetsexamen_nn_1_1_N : N ;
  aembetsbroder_nn_1_1_N : N ;
  aelvvatten_nn_1_1_N : N ;
  aegotecken_nn_1_1_N : N ;
  zaeta_nn_1_1_N : N ;
  zombie_nn_1_N : N ;
  zloty_nn_1_N : N ;
  zimbabwier_nn_1_N : N ;
  zeta_nn_1_N : N ;
  zambier_nn_1_N : N ;
  zairier_nn_1_N : N ;
  yxhuvud_nn_1_N : N ;
  yxhammare_nn_1_N : N ;
  ytvatten_nn_1_N : N ;
  ytteroera_nn_1_1_N : N ;
  yrkespolitiker_nn_1_N : N ;
  yrkesman_nn_1_N : N ;
  yrkesfysiker_nn_1_N : N ;
  yen_nn_1_N : N ;
  yard_nn_1_N : N ;
  yankee_nn_1_N : N ;
  wobbler_nn_1_N : N ;
  wiki_nn_1_N : N ;
  whig_nn_1_N : N ;
  western_nn_1_N : N ;
  weekend_nn_1_N : N ;
  watussi_nn_1_N : N ;
  watusi_nn_1_N : N ;
  watt_nn_1_N : N ;
  walkie_talkie_nn_1_N : N ;
  wafer_nn_1_N : N ;
  vaatrum_nn_1_1_N : N ;
  vaartecken_nn_1_1_N : N ;
  vaardtecken_nn_1_1_N : N ;
  vaardhem_nn_1_1_N : N ;
  vaaldtaektsman_nn_1_1_N : N ;
  vaaldsman_nn_1_1_N : N ;
  vaextlim_nn_1_1_N : N ;
  vaetevapen_nn_1_1_N : N ;
  vaerldsman_nn_1_1_N : N ;
  vaerdighetstecken_nn_1_1_N : N ;
  vaerderingsman_nn_1_1_N : N ;
  vaentrum_nn_1_1_N : N ;
  vaensteroera_nn_1_1_N : N ;
  vaensteroega_nn_1_1_N : N ;
  vaensterpolitiker_nn_1_1_N : N ;
  vaeglus_nn_1_1_N : N ;
  vaegglus_nn_1_1_N : N ;
  vaegfarande_nn_1_1_N : N ;
  vaeckelseman_nn_1_1_N : N ;
  vuxenstuderande_nn_1_N : N ;
  voucher_nn_1_N : N ;
  volymprocent_nn_1_N : N ;
  volt_nn_1_N : N ;
  vokalrim_nn_1_N : N ;
  vobbler_nn_1_N : N ;
  visman_nn_1_N : N ;
  viprum_nn_1_N : N ;
  vinlus_nn_1_N : N ;
  vingoera_nn_1_1_N : N ;
  vingaardsman_nn_1_1_N : N ;
  vingman_nn_1_N : N ;
  vindoega_nn_1_1_N : N ;
  vindskammare_nn_1_N : N ;
  vilrum_nn_1_N : N ;
  vilorum_nn_1_N : N ;
  vilohem_nn_1_N : N ;
  vildman_nn_1_N : N ;
  vildgaas_nn_1_1_N : N ;
  viktprocent_nn_1_N : N ;
  vigselrum_nn_1_N : N ;
  viderboende_nn_1_N : N ;
  vichyvatten_nn_1_N : N ;
  vetenskapsman_nn_1_N : N ;
  verst_nn_1_N : N ;
  verktum_nn_1_N : N ;
  vender_nn_1_N : N ;
  vederdeloman_nn_1_N : N ;
  vattenledningsvatten_nn_1_N : N ;
  vatten_nn_1_N : N ;
  varufakta_nn_1_N : N ;
  varningstecken_nn_1_N : N ;
  varmvatten_nn_1_N : N ;
  varia_nn_1_N : N ;
  vardagsrum_nn_1_N : N ;
  vapenbroder_nn_1_N : N ;
  vapen_nn_1_N : N ;
  vanuatuer_nn_1_N : N ;
  vandringsman_nn_1_N : N ;
  vandrarhem_nn_1_N : N ;
  valslogan_nn_1_N : N ;
  valman_nn_1_N : N ;
  vakuumkammare_nn_1_N : N ;
  vaktman_nn_1_N : N ;
  vakthavande_nn_1_N : N ;
  vacuumkammare_nn_1_N : N ;
  uttalstecken_nn_1_N : N ;
  utskottsordfoerande_nn_1_1_N : N ;
  utropstecken_nn_1_N : N ;
  utredningsman_nn_1_N : N ;
  uthyrningsrum_nn_1_N : N ;
  utfallsrum_nn_1_N : N ;
  uterum_nn_1_N : N ;
  utelaemningstecken_nn_1_1_N : N ;
  urhem_nn_1_N : N ;
  urfader_nn_1_N : N ;
  upptaecktsresande_nn_1_1_N : N ;
  upptagningshem_nn_1_N : N ;
  uppsyningsman_nn_1_N : N ;
  upprorsman_nn_1_N : N ;
  uppklarningsprocent_nn_1_N : N ;
  upphovsman_nn_1_N : N ;
  uppfostringshem_nn_1_N : N ;
  uppercut_nn_1_N : N ;
  uppboerdsman_nn_1_1_N : N ;
  universitetsstuderande_nn_1_N : N ;
  uniformstecken_nn_1_N : N ;
  ungdomshem_nn_1_N : N ;
  undersoekningsrum_nn_1_1_N : N ;
  underraettelseofficer_nn_1_1_N : N ;
  underofficer_nn_1_N : N ;
  underhavande_nn_1_N : N ;
  undergaangstecken_nn_1_1_N : N ;
  undergaangsscenario_nn_1_1_N : N ;
  ultra_nn_1_N : N ;
  ullus_nn_1_N : N ;
  ugandier_nn_1_N : N ;
  uddrim_nn_1_N : N ;
  toecken_nn_1_1_N : N ;
  tvaettvatten_nn_1_1_N : N ;
  tunisier_nn_1_N : N ;
  tuner_nn_1_N : N ;
  tum_nn_1_N : N ;
  tulltjaensteman_nn_1_1_N : N ;
  tullkammare_nn_1_N : N ;
  tsunami_nn_1_N : N ;
  troetthetstecken_nn_1_1_N : N ;
  traetobroder_nn_1_1_N : N ;
  tryckkammare_nn_1_N : N ;
  trumpetsolo_nn_1_N : N ;
  troman_nn_1_N : N ;
  trio_nn_1_N : N ;
  trinidadier_nn_1_N : N ;
  trimmer_nn_1_N : N ;
  trimhuvud_nn_1_N : N ;
  triangeldrama_nn_1_N : N ;
  trauma_nn_1_N : N ;
  trapper_nn_1_N : N ;
  trainee_nn_1_N : N ;
  tragiker_nn_1_N : N ;
  tory_nn_1_N : N ;
  tortyrkammare_nn_1_N : N ;
  torso_nn_1_N : N ;
  torskoega_nn_1_1_N : N ;
  tornado_nn_1_N : N ;
  torkrum_nn_1_N : N ;
  toppolitiker_nn_1_N : N ;
  toppman_nn_1_N : N ;
  toppduo_nn_1_N : N ;
  tonkilometer_nn_1_N : N ;
  tomrum_nn_1_N : N ;
  tolvman_nn_1_N : N ;
  tofsoera_nn_1_1_N : N ;
  tjaenstevapen_nn_1_1_N : N ;
  tjaensterum_nn_1_1_N : N ;
  tjaensteman_nn_1_1_N : N ;
  tjurhuvud_nn_1_N : N ;
  timmerman_nn_1_N : N ;
  tillvaextfanatiker_nn_1_1_N : N ;
  tillsynsman_nn_1_N : N ;
  tillsyningsman_nn_1_N : N ;
  tidvatten_nn_1_N : N ;
  tidsstudieman_nn_1_N : N ;
  tidningsman_nn_1_N : N ;
  tic_nn_1_N : N ;
  thaeta_nn_1_1_N : N ;
  theta_nn_1_N : N ;
  teve_nn_2_N : N ;
  tesla_nn_1_N : N ;
  territorialvatten_nn_1_N : N ;
  terrier_nn_1_N : N ;
  terminalrum_nn_1_N : N ;
  terawatt_nn_1_N : N ;
  teraelektronvolt_nn_1_N : N ;
  terabyte_nn_1_N : N ;
  teoretiker_nn_1_N : N ;
  tentamen_nn_1_N : N ;
  tempo_nn_1_N : N ;
  tema_nn_1_N : N ;
  teleskopoega_nn_1_1_N : N ;
  teledata_nn_1_N : N ;
  tekniker_nn_1_N : N ;
  tecken_nn_1_N : N ;
  teach_in_nn_1_N : N ;
  tchadier_nn_1_N : N ;
  taxi_nn_1_N : N ;
  taxeringsman_nn_1_N : N ;
  tanzanier_nn_1_N : N ;
  tantslem_nn_1_N : N ;
  tandtekniker_nn_1_N : N ;
  talman_nn_1_N : N ;
  talesman_nn_1_N : N ;
  taktiker_nn_1_N : N ;
  takeaway_nn_1_N : N ;
  take_away_nn_1_N : N ;
  taco_nn_1_N : N ;
  tabellhuvud_nn_1_N : N ;
  soetvatten_nn_1_1_N : N ;
  soem_nn_2_1_N : N ;
  soekande_nn_1_1_N : N ;
  saapvatten_nn_1_1_N : N ;
  saaningsman_nn_1_1_N : N ;
  saangtema_nn_1_1_N : N ;
  saenkningstecken_nn_1_1_N : N ;
  saengkammare_nn_1_1_N : N ;
  saellskapsrum_nn_1_1_N : N ;
  saellskapsbroder_nn_1_1_N : N ;
  saekerhetsman_nn_1_1_N : N ;
  saedgaas_nn_1_1_N : N ;
  systemman_nn_1_N : N ;
  syssloman_nn_1_N : N ;
  syrier_nn_1_N : N ;
  synoptiker_nn_1_N : N ;
  symfoniker_nn_1_N : N ;
  sweatshirt_nn_1_N : N ;
  svaerfar_nn_1_1_N : N ;
  svephammare_nn_1_N : N ;
  svartsjukedrama_nn_1_N : N ;
  svartbroder_nn_1_N : N ;
  svarande_nn_1_N : N ;
  svaghetstecken_nn_1_N : N ;
  sundhetstecken_nn_1_N : N ;
  sumerer_nn_1_N : N ;
  sudoku_nn_1_N : N ;
  stoel_nn_1_1_N : N ;
  staauppkomiker_nn_1_1_N : N ;
  staangjaernshammare_nn_1_1_N : N ;
  staanghammare_nn_1_1_N : N ;
  staalman_nn_1_1_N : N ;
  staendchen_nn_1_1_N : N ;
  styvfar_nn_1_N : N ;
  styver_nn_1_N : N ;
  styrtecken_nn_1_N : N ;
  styrman_nn_1_N : N ;
  styresman_nn_1_N : N ;
  styrelserum_nn_1_N : N ;
  styrelseordfoerande_nn_1_1_N : N ;
  styck_nn_1_N : N ;
  stuntman_nn_1_N : N ;
  studiosus_nn_1_N : N ;
  studiomusiker_nn_1_N : N ;
  studioman_nn_1_N : N ;
  studerkammare_nn_1_N : N ;
  studerande_nn_1_N : N ;
  studentrum_nn_1_N : N ;
  studenthem_nn_1_N : N ;
  studentexamen_nn_1_N : N ;
  strykrum_nn_1_N : N ;
  struphuvud_nn_1_N : N ;
  stroke_nn_2_N : N ;
  stridsman_nn_1_N : N ;
  streamer_nn_1_N : N ;
  stratum_nn_1_N : N ;
  storman_nn_1_N : N ;
  stopper_nn_1_N : N ;
  stoiker_nn_1_N : N ;
  stimulantia_nn_1_N : N ;
  stilistiker_nn_1_N : N ;
  stigman_nn_1_N : N ;
  stigma_nn_1_N : N ;
  stickvapen_nn_1_N : N ;
  stavrim_nn_1_N : N ;
  statsoeverhuvud_nn_1_1_N : N ;
  statstjaensteman_nn_1_1_N : N ;
  statsman_nn_1_N : N ;
  statistiker_nn_1_N : N ;
  starter_nn_1_N : N ;
  stamfar_nn_1_N : N ;
  stallbroder_nn_1_N : N ;
  staffli_nn_1_N : N ;
  stadsfullmaektig_nn_1_1_N : N ;
  stabsofficer_nn_1_N : N ;
  spaaman_nn_1_1_N : N ;
  spaenn_nn_1_1_N : N ;
  spraaktecken_nn_1_1_N : N ;
  sprinter_nn_1_N : N ;
  sprinkler_nn_1_N : N ;
  springvatten_nn_1_N : N ;
  spotlight_nn_1_N : N ;
  sportsman_nn_1_N : N ;
  spoiler_nn_1_N : N ;
  spiskammare_nn_1_N : N ;
  spillvatten_nn_1_N : N ;
  spikhuvud_nn_1_N : N ;
  spetsbergsgaas_nn_1_1_N : N ;
  spelman_nn_1_N : N ;
  speleman_nn_1_N : N ;
  speldrama_nn_1_N : N ;
  speaker_nn_1_N : N ;
  spastiker_nn_1_N : N ;
  sparringpartner_nn_1_N : N ;
  spaniel_nn_1_N : N ;
  spader_nn_1_N : N ;
  sovrum_nn_1_N : N ;
  sommarhem_nn_1_N : N ;
  somatiker_nn_1_N : N ;
  somalier_nn_1_N : N ;
  soloega_nn_1_1_N : N ;
  solo_nn_1_N : N ;
  soldathem_nn_1_N : N ;
  sodavatten_nn_1_N : N ;
  snaellhetsguru_nn_1_1_N : N ;
  snowboard_nn_1_N : N ;
  smaeltvatten_nn_1_1_N : N ;
  smaellglim_nn_1_1_N : N ;
  smutsvatten_nn_1_N : N ;
  smiley_nn_1_N : N ;
  smartphone_nn_1_N : N ;
  slaektvapen_nn_1_1_N : N ;
  slaegghammare_nn_1_1_N : N ;
  slusshuvud_nn_1_N : N ;
  slughuvud_nn_1_N : N ;
  slogan_nn_1_N : N ;
  slaskvatten_nn_1_N : N ;
  slagvapen_nn_1_N : N ;
  skoeldlus_nn_1_1_N : N ;
  skyeterrier_nn_1_N : N ;
  skraepkammare_nn_1_1_N : N ;
  skruvhuvud_nn_1_N : N ;
  skrivtecken_nn_1_N : N ;
  skottdrama_nn_1_N : N ;
  skolastiker_nn_1_N : N ;
  skogsraa_nn_1_1_N : N ;
  skogsmus_nn_1_N : N ;
  skogsgenetiker_nn_1_N : N ;
  skjutvapen_nn_1_N : N ;
  skinhead_nn_1_N : N ;
  skiljetecken_nn_1_N : N ;
  skiljeman_nn_1_N : N ;
  skeptiker_nn_1_N : N ;
  skepparexamen_nn_1_N : N ;
  skattkammare_nn_1_N : N ;
  skateboard_nn_1_N : N ;
  sjoevatten_nn_1_1_N : N ;
  sjoeraa_nn_1_1_N : N ;
  sjoeofficer_nn_1_1_N : N ;
  sjoemil_nn_1_1_N : N ;
  sjoeman_nn_1_1_N : N ;
  sjukskoeterskeexamen_nn_1_1_N : N ;
  sitkom_nn_1_N : N ;
  sitcom_nn_1_N : N ;
  silo_nn_1_N : N ;
  sigma_nn_1_N : N ;
  sievert_nn_1_N : N ;
  sierraleonier_nn_1_N : N ;
  siemens_nn_1_N : N ;
  sidovapen_nn_1_N : N ;
  sidotema_nn_1_N : N ;
  sibirier_nn_1_N : N ;
  shilling_nn_1_N : N ;
  shanty_nn_1_N : N ;
  seychellier_nn_1_N : N ;
  sexualia_nn_1_N : N ;
  sexpartner_nn_1_N : N ;
  serviceman_nn_1_N : N ;
  serievaaldtaektsman_nn_1_1_N : N ;
  sepoy_nn_1_N : N ;
  sekundmeter_nn_1_N : N ;
  segertecken_nn_1_N : N ;
  script_girl_nn_1_N : N ;
  scratchman_nn_1_N : N ;
  scone_nn_1_N : N ;
  scirocco_nn_1_N : N ;
  schweizerfranc_nn_1_N : N ;
  schismatiker_nn_1_N : N ;
  scenario_nn_1_N : N ;
  saudier_nn_1_N : N ;
  satyrdrama_nn_1_N : N ;
  satsuma_nn_1_N : N ;
  satiriker_nn_1_N : N ;
  sari_nn_1_N : N ;
  sanmarinier_nn_1_N : N ;
  sanitetstekniker_nn_1_N : N ;
  sangviniker_nn_1_N : N ;
  sang_nn_1_N : N ;
  sandwichman_nn_1_N : N ;
  samlagspartner_nn_1_N : N ;
  samhaellskritiker_nn_1_1_N : N ;
  sambo_nn_2_N : N ;
  sambandsofficer_nn_1_N : N ;
  samarbetspartner_nn_1_N : N ;
  samarbetsman_nn_1_N : N ;
  saltvatten_nn_1_N : N ;
  salomonier_nn_1_N : N ;
  salladshuvud_nn_1_N : N ;
  sakaegande_nn_1_1_N : N ;
  sagesman_nn_1_N : N ;
  safari_nn_1_N : N ;
  roetkammare_nn_1_1_N : N ;
  roe_nn_1_1_N : N ;
  raadman_nn_1_1_N : N ;
  raadkammare_nn_1_1_N : N ;
  raa_nn_3_13_N : N ;
  raa_nn_2_1_N : N ;
  raettspsykiatriker_nn_1_1_N : N ;
  rymdvapen_nn_1_N : N ;
  rwandier_nn_1_N : N ;
  ruter_nn_1_N : N ;
  rustkammare_nn_1_N : N ;
  rubel_nn_1_N : N ;
  royalty_nn_1_N : N ;
  rottweiler_nn_1_N : N ;
  rottecken_nn_1_N : N ;
  rorsman_nn_1_N : N ;
  rookie_nn_1_N : N ;
  romkom_nn_1_N : N ;
  romcom_nn_1_N : N ;
  romantiker_nn_1_N : N ;
  rododendron_nn_1_N : N ;
  robotvapen_nn_1_N : N ;
  roadie_nn_1_N : N ;
  ro_nn_2_N : N ;
  riksvapen_nn_1_N : N ;
  riksdaler_nn_1_N : N ;
  riksdagsman_nn_1_N : N ;
  rikeman_nn_1_N : N ;
  riddersman_nn_1_N : N ;
  rhododendron_nn_1_N : N ;
  rhodesier_nn_1_N : N ;
  reumatiker_nn_1_N : N ;
  retoriker_nn_1_N : N ;
  residuum_nn_1_N : N ;
  reservofficer_nn_1_N : N ;
  researcher_nn_1_N : N ;
  resande_nn_1_N : N ;
  repristecken_nn_1_N : N ;
  renlevnadsman_nn_1_N : N ;
  remedium_nn_1_N : N ;
  rem_nn_2_N : N ;
  religionskritiker_nn_1_N : N ;
  regnvatten_nn_1_N : N ;
  regimkritiker_nn_1_N : N ;
  regeringstalesman_nn_1_N : N ;
  regementsofficer_nn_1_N : N ;
  realia_nn_1_N : N ;
  realexamen_nn_1_N : N ;
  rastafari_nn_1_N : N ;
  rapsfroe_nn_1_1_N : N ;
  ranger_nn_1_N : N ;
  rand_nn_2_N : N ;
  rakvatten_nn_1_N : N ;
  raketvapen_nn_1_N : N ;
  radioman_nn_1_N : N ;
  rad_nn_2_N : N ;
  qatarier_nn_1_N : N ;
  paafaageloega_nn_1_1_N : N ;
  paafaagelsoega_nn_1_1_N : N ;
  pykniker_nn_1_N : N ;
  putto_nn_1_N : N ;
  pundhuvud_nn_1_N : N ;
  psykofarmaka_nn_1_N : N ;
  psykoanalytiker_nn_1_N : N ;
  psykiatriker_nn_1_N : N ;
  psoriatiker_nn_1_N : N ;
  praestman_nn_1_1_N : N ;
  prydnadsvapen_nn_1_N : N ;
  prutgaas_nn_1_1_N : N ;
  provie_nn_1_N : N ;
  promille_nn_1_N : N ;
  procent_nn_1_N : N ;
  privatpraktiker_nn_1_N : N ;
  privatman_nn_1_N : N ;
  pretiosa_nn_1_N : N ;
  prestanda_nn_1_N : N ;
  presstalesman_nn_1_N : N ;
  preses_nn_1_N : N ;
  preciosa_nn_1_N : N ;
  praktiker_nn_1_N : N ;
  pragmatiker_nn_1_N : N ;
  posttjaensteman_nn_1_1_N : N ;
  porter_nn_1_N : N ;
  poncho_nn_1_N : N ;
  polynesier_nn_1_N : N ;
  politiker_nn_1_N : N ;
  polistjaensteman_nn_1_1_N : N ;
  polisman_nn_1_N : N ;
  polemiker_nn_1_N : N ;
  plustecken_nn_1_N : N ;
  platt_teve_nn_1_N : N ;
  platoniker_nn_1_N : N ;
  plasmateve_nn_1_N : N ;
  plasma_teve_nn_1_N : N ;
  plankter_nn_1_N : N ;
  pirhuvud_nn_1_N : N ;
  piphuvud_nn_1_N : N ;
  pipeline_nn_1_N : N ;
  pilsner_nn_1_N : N ;
  pfennig_nn_1_N : N ;
  petabyte_nn_1_N : N ;
  peso_nn_1_N : N ;
  peseta_nn_1_N : N ;
  personkilometer_nn_1_N : N ;
  personalia_nn_1_N : N ;
  perser_nn_1_N : N ;
  pensionspoaeng_nn_1_1_N : N ;
  penny_nn_1_N : N ;
  penni_nn_1_N : N ;
  pediatriker_nn_1_N : N ;
  paustecken_nn_1_N : N ;
  patricier_nn_1_N : N ;
  passiva_nn_1_N : N ;
  pascal_nn_1_N : N ;
  partner_nn_1_N : N ;
  partiordfoerande_nn_1_1_N : N ;
  partiman_nn_1_N : N ;
  partikelfysiker_nn_1_N : N ;
  parodiker_nn_1_N : N ;
  parlamentariker_nn_1_N : N ;
  parentestecken_nn_1_N : N ;
  paranoiker_nn_1_N : N ;
  paralytiker_nn_1_N : N ;
  paragraftecken_nn_1_N : N ;
  papua_nn_1_N : N ;
  paper_nn_1_N : N ;
  pansarvaernsvapen_nn_1_1_N : N ;
  panorama_nn_1_N : N ;
  pannkaksteoretiker_nn_1_N : N ;
  palestinier_nn_1_N : N ;
  palauer_nn_1_N : N ;
  oxoega_nn_1_1_N : N ;
  oxhuvud_nn_1_N : N ;
  outsider_nn_1_N : N ;
  otrohetsdrama_nn_1_N : N ;
  ordningsman_nn_1_N : N ;
  ordfoerande_nn_1_1_N : N ;
  ordal_nn_1_N : N ;
  optiker_nn_1_N : N ;
  opinionsanalytiker_nn_1_N : N ;
  omvaendningstecken_nn_1_1_N : N ;
  omega_nn_1_N : N ;
  ombudsman_nn_1_N : N ;
  omanier_nn_1_N : N ;
  olympier_nn_1_N : N ;
  olycksbroder_nn_1_N : N ;
  oldtimer_nn_1_N : N ;
  ohm_nn_1_N : N ;
  ogaerningsman_nn_1_1_N : N ;
  officer_nn_1_N : N ;
  odalman_nn_1_N : N ;
  naalsoega_nn_1_1_N : N ;
  naalshuvud_nn_1_1_N : N ;
  naetguru_nn_1_1_N : N ;
  naeringsfrihetsombudsman_nn_1_1_N : N ;
  naemndeman_nn_1_1_N : N ;
  naebbmus_nn_1_1_N : N ;
  nyklassiker_nn_1_N : N ;
  nyckelman_nn_1_N : N ;
  nyanseringstecken_nn_1_N : N ;
  numismatiker_nn_1_N : N ;
  nubier_nn_1_N : N ;
  nottecken_nn_1_N : N ;
  notskriftstecken_nn_1_N : N ;
  nostalgiker_nn_1_N : N ;
  norrman_nn_1_N : N ;
  nordman_nn_1_N : N ;
  niuer_nn_1_N : N ;
  nithuvud_nn_1_N : N ;
  nissoega_nn_1_1_N : N ;
  nigerer_nn_1_N : N ;
  newton_nn_1_N : N ;
  neutrino_nn_1_N : N ;
  neurotiker_nn_1_N : N ;
  neuroleptika_nn_1_N : N ;
  nejonoega_nn_1_1_N : N ;
  nazistofficer_nn_1_N : N ;
  nautiker_nn_1_N : N ;
  nauruer_nn_1_N : N ;
  naturvetenskapsman_nn_1_N : N ;
  nattglim_nn_1_N : N ;
  narkotikum_nn_1_N : N ;
  namibier_nn_1_N : N ;
  moetesordfoerande_nn_1_1_N : N ;
  moessoera_nn_1_1_N : N ;
  moerkman_nn_1_1_N : N ;
  moerkerman_nn_1_1_N : N ;
  maalsaegande_nn_1_1_N : N ;
  maalsman_nn_1_1_N : N ;
  maetdata_nn_1_1_N : N ;
  maesterman_nn_1_1_N : N ;
  maerkhammare_nn_1_1_N : N ;
  maerkesman_nn_1_1_N : N ;
  mystiker_nn_1_N : N ;
  mynttecken_nn_1_N : N ;
  musoera_nn_1_1_N : N ;
  musiktecken_nn_1_N : N ;
  musiker_nn_1_N : N ;
  musikdrama_nn_1_N : N ;
  mus_nn_1_N : N ;
  munvatten_nn_1_N : N ;
  multiplikationstecken_nn_1_N : N ;
  multimedium_nn_1_N : N ;
  muffins_nn_1_N : N ;
  mocambikier_nn_1_1_N : N ;
  motti_nn_1_N : N ;
  motstaandsman_nn_1_1_N : N ;
  motorman_nn_1_N : N ;
  morfar_nn_1_N : N ;
  mordvapen_nn_1_N : N ;
  moldavier_nn_1_N : N ;
  mogenhetsexamen_nn_1_N : N ;
  moderatpolitiker_nn_1_N : N ;
  mocambikier_nn_1_N : N ;
  mjukdata_nn_1_N : N ;
  missgaerningsman_nn_1_1_N : N ;
  minustecken_nn_1_N : N ;
  mineralvatten_nn_1_N : N ;
  mineral_nn_1_N : N ;
  mimiker_nn_1_N : N ;
  milliwatt_nn_1_N : N ;
  millisievert_nn_1_N : N ;
  milliliter_nn_1_N : N ;
  millibar_nn_1_N : N ;
  militaerhistoriker_nn_1_1_N : N ;
  militieombudsman_nn_1_N : N ;
  mil_nn_1_N : N ;
  mikrosievert_nn_1_N : N ;
  mikronesier_nn_1_N : N ;
  metodiker_nn_1_N : N ;
  metafysiker_nn_1_N : N ;
  metadata_nn_1_N : N ;
  memorandum_nn_1_N : N ;
  mellanoera_nn_1_1_N : N ;
  melankoliker_nn_1_N : N ;
  melanesier_nn_1_N : N ;
  mekanikus_nn_1_N : N ;
  mekaniker_nn_1_N : N ;
  megawatt_nn_1_N : N ;
  meganewton_nn_1_N : N ;
  megajoule_nn_1_N : N ;
  megabyte_nn_1_N : N ;
  medsoekande_nn_1_1_N : N ;
  medloeftesman_nn_1_1_N : N ;
  medium_nn_1_N : N ;
  medikus_nn_1_N : N ;
  medicinman_nn_1_N : N ;
  medbroder_nn_1_N : N ;
  mauser_nn_1_N : N ;
  mauritier_nn_1_N : N ;
  mauretanier_nn_1_N : N ;
  matematiker_nn_1_N : N ;
  massmedium_nn_1_N : N ;
  martini_nn_1_N : N ;
  markomanner_nn_1_N : N ;
  mark_nn_2_N : N ;
  mardroemscenario_nn_1_1_N : N ;
  maorier_nn_1_N : N ;
  maniker_nn_1_N : N ;
  manager_nn_1_N : N ;
  man_nn_1_N : N ;
  malier_nn_1_N : N ;
  maldivier_nn_1_N : N ;
  maldiver_nn_1_N : N ;
  malaysier_nn_1_N : N ;
  malawier_nn_1_N : N ;
  makedonier_nn_1_N : N ;
  mahognyfaner_nn_1_N : N ;
  magnecyl_nn_1_N : N ;
  magmakammare_nn_1_N : N ;
  magiker_nn_1_N : N ;
  magier_nn_1_N : N ;
  mager_nn_1_N : N ;
  mach_nn_1_N : N ;
  loepmeter_nn_1_1_N : N ;
  loeftesman_nn_1_1_N : N ;
  laangeman_nn_1_1_N : N ;
  laagvatten_nn_1_1_N : N ;
  laeskeblask_nn_2_1_N : N ;
  laesk_nn_1_1_N : N ;
  laeshuvud_nn_1_1_N : N ;
  laesdrama_nn_1_1_N : N ;
  laerofader_nn_1_1_N : N ;
  laensvakthavande_nn_1_1_N : N ;
  laensman_nn_1_1_N : N ;
  laengdtecken_nn_1_1_N : N ;
  laengdmeter_nn_1_1_N : N ;
  lyriker_nn_1_N : N ;
  lyckokloever_nn_1_1_N : N ;
  lux_nn_1_N : N ;
  lus_nn_1_N : N ;
  lumen_nn_1_N : N ;
  luktvatten_nn_1_N : N ;
  lugnvatten_nn_1_N : N ;
  luftvapen_nn_1_N : N ;
  loser_nn_1_N : N ;
  lokalpolitiker_nn_1_N : N ;
  logiker_nn_1_N : N ;
  logi_nn_1_N : N ;
  ljushuvud_nn_1_N : N ;
  ljudtekniker_nn_1_N : N ;
  livstecken_nn_1_N : N ;
  livrustkammare_nn_1_N : N ;
  livmedikus_nn_1_N : N ;
  litteraturkritiker_nn_1_N : N ;
  litauer_nn_1_N : N ;
  lire_nn_1_N : N ;
  linslus_nn_1_N : N ;
  linjeman_nn_1_N : N ;
  lim_nn_1_N : N ;
  likhetstecken_nn_1_N : N ;
  licentiatexamen_nn_1_N : N ;
  libyer_nn_1_N : N ;
  liberier_nn_1_N : N ;
  leva_nn_1_N : N ;
  lesothier_nn_1_N : N ;
  lekmannabroder_nn_1_N : N ;
  lekman_nn_1_N : N ;
  ledhuvud_nn_1_N : N ;
  lebeman_nn_1_N : N ;
  lcd_teve_nn_2_N : N ;
  laotier_nn_1_N : N ;
  lantman_nn_1_N : N ;
  landstingsman_nn_1_N : N ;
  landsman_nn_1_N : N ;
  landskapsvapen_nn_1_N : N ;
  landsfader_nn_1_N : N ;
  landmil_nn_1_N : N ;
  lambda_nn_1_N : N ;
  lagman_nn_1_N : N ;
  lady_nn_1_N : N ;
  lackskoeldlus_nn_1_1_N : N ;
  koersbaersfaner_nn_1_1_N : N ;
  koerkortssoekande_nn_1_1_N : N ;
  koepman_nn_1_1_N : N ;
  kaarordfoerande_nn_1_1_N : N ;
  kaalhuvud_nn_1_1_N : N ;
  kaernvapen_nn_1_1_N : N ;
  kaerande_nn_1_1_N : N ;
  kaennetecken_nn_1_1_N : N ;
  kaenguru_nn_1_1_N : N ;
  kaellvatten_nn_1_1_N : N ;
  kyrkomusiker_nn_1_N : N ;
  kyrkoman_nn_1_N : N ;
  kyrkofullmaektig_nn_1_1_N : N ;
  kyrkofader_nn_1_N : N ;
  kyrkobroder_nn_1_N : N ;
  kyniker_nn_1_N : N ;
  kymrer_nn_1_N : N ;
  kvitten_nn_1_N : N ;
  kvickhuvud_nn_1_N : N ;
  kuwaitier_nn_1_N : N ;
  kuriosum_nn_1_N : N ;
  kurder_nn_1_N : N ;
  kukhuvud_nn_1_N : N ;
  kubik_nn_1_N : N ;
  kroniker_nn_1_N : N ;
  kritiker_nn_1_N : N ;
  krigsman_nn_1_N : N ;
  kreter_nn_1_N : N ;
  kranvatten_nn_1_N : N ;
  kooega_nn_1_1_N : N ;
  korstecken_nn_1_N : N ;
  korrekturtecken_nn_1_N : N ;
  korinter_nn_1_N : N ;
  kopter_nn_1_N : N ;
  kopek_nn_1_N : N ;
  kontaktman_nn_1_N : N ;
  konsumentombudsman_nn_1_N : N ;
  konstruktionslim_nn_1_N : N ;
  konstkritiker_nn_1_N : N ;
  konspirationsteoretiker_nn_1_N : N ;
  kongressman_nn_1_N : N ;
  konfliktmineral_nn_1_N : N ;
  kompositum_nn_1_N : N ;
  kompaniofficer_nn_1_N : N ;
  komorier_nn_1_N : N ;
  kommunpolitiker_nn_1_N : N ;
  kommunfullmaektig_nn_1_1_N : N ;
  kommunalpolitiker_nn_1_N : N ;
  kommunalordfoerande_nn_1_1_N : N ;
  kommunalnaemndsordfoerande_nn_1_1_N : N ;
  kommunalman_nn_1_N : N ;
  kommunalfullmaektig_nn_1_1_N : N ;
  kommatecken_nn_1_N : N ;
  komiker_nn_1_N : N ;
  kolli_nn_1_N : N ;
  koleriker_nn_1_N : N ;
  knop_nn_2_N : N ;
  knivman_nn_1_N : N ;
  knappnaalshuvud_nn_1_1_N : N ;
  kloever_nn_1_1_N : N ;
  klaedlus_nn_1_1_N : N ;
  klaedkammare_nn_1_1_N : N ;
  klustervapen_nn_1_N : N ;
  klosterbroder_nn_1_N : N ;
  klokhuvud_nn_1_N : N ;
  klipphuvud_nn_1_N : N ;
  klinker_nn_1_N : N ;
  kliniker_nn_1_N : N ;
  klimatskeptiker_nn_1_N : N ;
  klimatkammare_nn_1_N : N ;
  klimatfoeraendringsskeptiker_nn_1_1_N : N ;
  klassiker_nn_1_N : N ;
  klartecken_nn_1_N : N ;
  klammer_nn_1_N : N ;
  klagande_nn_1_N : N ;
  kiropraktiker_nn_1_N : N ;
  kiribatier_nn_1_N : N ;
  kirgisier_nn_1_N : N ;
  kimono_nn_1_N : N ;
  kilowatt_nn_1_N : N ;
  kilopondmeter_nn_1_N : N ;
  kilobyte_nn_1_N : N ;
  kilo_nn_1_N : N ;
  keramiker_nn_1_N : N ;
  kelvin_nn_1_N : N ;
  kavalleriofficer_nn_1_N : N ;
  kaukasier_nn_1_N : N ;
  kattoega_nn_1_1_N : N ;
  kastvapen_nn_1_N : N ;
  karttecken_nn_1_N : N ;
  karaktaersdrama_nn_1_1_N : N ;
  karaktaeristika_nn_2_1_N : N ;
  karakteristika_nn_2_N : N ;
  kapverdier_nn_1_N : N ;
  kappa_nn_2_N : N ;
  kapardrama_nn_1_N : N ;
  kansliexamen_nn_1_N : N ;
  kandidatexamen_nn_1_N : N ;
  kanadagaas_nn_1_1_N : N ;
  kammarmusiker_nn_1_N : N ;
  kammare_nn_1_N : N ;
  kameraman_nn_1_N : N ;
  kallvatten_nn_1_N : N ;
  jaertecken_nn_1_1_N : N ;
  jaernvaegstjaensteman_nn_1_1_N : N ;
  jaernvapen_nn_1_1_N : N ;
  justitieombudsman_nn_1_N : N ;
  justeringsman_nn_1_N : N ;
  jungman_nn_1_N : N ;
  jungfrukammare_nn_1_N : N ;
  jourhavande_nn_1_N : N ;
  joule_nn_1_N : N ;
  jota_nn_1_N : N ;
  jordanier_nn_1_N : N ;
  jonier_nn_1_N : N ;
  joner_nn_1_N : N ;
  jobbsoekande_nn_1_1_N : N ;
  jazzmusiker_nn_1_N : N ;
  jaktvapen_nn_1_N : N ;
  jacuzzi_nn_1_N : N ;
  ja_nn_1_N : N ;
  italiker_nn_1_N : N ;
  italer_nn_1_N : N ;
  ironiker_nn_1_N : N ;
  irer_nn_1_N : N ;
  iranier_nn_1_N : N ;
  irakier_nn_1_N : N ;
  iota_nn_1_N : N ;
  invandrarpolitiker_nn_1_N : N ;
  inneroera_nn_1_1_N : N ;
  indier_nn_1_N : N ;
  illgaerningsman_nn_1_1_N : N ;
  iktus_nn_1_N : N ;
  igenkaenningstecken_nn_1_1_N : N ;
  id_edrama_nn_1_1_N : N ;
  idylliker_nn_1_N : N ;
  idrottsman_nn_1_N : N ;
  identitetssoekande_nn_1_1_N : N ;
  hoevitsman_nn_1_1_N : N ;
  hoegvatten_nn_1_1_N : N ;
  hoegvallskloever_nn_1_1_N : N ;
  hoegskoleexamen_nn_1_1_N : N ;
  hoegeroera_nn_1_1_N : N ;
  hoegeroega_nn_1_1_N : N ;
  hoegerpolitiker_nn_1_1_N : N ;
  hoegerman_nn_1_1_N : N ;
  hoegbaatsman_nn_1_1_N : N ;
  haarvatten_nn_1_1_N : N ;
  haarddata_nn_1_1_N : N ;
  haestskosoem_nn_1_1_N : N ;
  haesthuvud_nn_1_1_N : N ;
  haerad_nn_1_1_N : N ;
  haensyn_nn_1_1_N : N ;
  haelsovatten_nn_1_1_N : N ;
  haelsotecken_nn_1_1_N : N ;
  haeftklammer_nn_1_1_N : N ;
  hysteriker_nn_1_N : N ;
  hypokondriker_nn_1_N : N ;
  huvudtema_nn_1_N : N ;
  huvudman_nn_1_N : N ;
  huvud_nn_1_N : N ;
  husfar_nn_1_N : N ;
  hurra_nn_1_N : N ;
  hunner_nn_1_N : N ;
  hundoera_nn_1_1_N : N ;
  hundhuvud_nn_1_N : N ;
  humusvatten_nn_1_N : N ;
  humorduo_nn_1_N : N ;
  humaniora_nn_1_N : N ;
  huggvapen_nn_1_N : N ;
  hryvnja_nn_1_N : N ;
  hovraettsexamen_nn_1_1_N : N ;
  hovman_nn_1_N : N ;
  hjaertkammare_nn_1_1_N : N ;
  hjaerter_nn_1_1_N : N ;
  hjuldolly_nn_1_N : N ;
  hit_nn_1_N : N ;
  historiker_nn_1_N : N ;
  hirdman_nn_1_N : N ;
  hippie_nn_1_N : N ;
  hetvatten_nn_1_N : N ;
  hertz_nn_1_N : N ;
  herreman_nn_1_N : N ;
  hermeneutiker_nn_1_N : N ;
  heretiker_nn_1_N : N ;
  heraldiker_nn_1_N : N ;
  henry_nn_1_N : N ;
  hemulsman_nn_1_N : N ;
  hemmaman_nn_1_N : N ;
  hektoliter_nn_1_N : N ;
  hekto_nn_1_N : N ;
  hederstecken_nn_1_N : N ;
  hedersordfoerande_nn_1_1_N : N ;
  hedersman_nn_1_N : N ;
  he_man_nn_1_N : N ;
  havsvatten_nn_1_N : N ;
  hasselmus_nn_1_N : N ;
  handvapen_nn_1_N : N ;
  handout_nn_1_N : N ;
  handlande_nn_1_N : N ;
  handkammare_nn_1_N : N ;
  handelsresande_nn_1_N : N ;
  handelsman_nn_1_N : N ;
  handelskammare_nn_1_N : N ;
  handeldvapen_nn_1_N : N ;
  hammerless_nn_1_N : N ;
  hammare_nn_1_N : N ;
  halvtum_nn_1_N : N ;
  halvmil_nn_1_N : N ;
  halvliter_nn_1_N : N ;
  hallaaman_nn_1_1_N : N ;
  haitier_nn_1_N : N ;
  hacker_nn_1_N : N ;
  gaas_nn_1_1_N : N ;
  gaardfarihandlande_nn_1_1_N : N ;
  gaerningsman_nn_1_1_N : N ;
  gyllen_nn_3_N : N ;
  gyllen_nn_2_N : N ;
  guru_nn_1_N : N ;
  gulden_nn_1_N : N ;
  guinea_nn_1_N : N ;
  gudsman_nn_1_N : N ;
  gudfar_nn_1_N : N ;
  groensaksfroe_nn_1_1_N : N ;
  graahaarsman_nn_1_1_N : N ;
  graagaas_nn_1_1_N : N ;
  graagyllen_nn_1_1_N : N ;
  graabroder_nn_1_1_N : N ;
  graestrimmer_nn_1_1_N : N ;
  gruvraa_nn_1_1_N : N ;
  gruvdrama_nn_1_N : N ;
  grundvatten_nn_1_N : N ;
  grundarduo_nn_1_N : N ;
  groupie_nn_1_N : N ;
  groschen_nn_1_N : N ;
  grodman_nn_1_N : N ;
  grisoega_nn_1_1_N : N ;
  gringo_nn_1_N : N ;
  greyhound_nn_1_N : N ;
  grenadier_nn_1_N : N ;
  gray_nn_1_N : N ;
  gravkammare_nn_1_N : N ;
  graviditetskilo_nn_1_N : N ;
  gravgaas_nn_1_1_N : N ;
  gravensteiner_nn_1_N : N ;
  granulum_nn_1_N : N ;
  granskningsman_nn_1_N : N ;
  granbarrlus_nn_1_N : N ;
  grammatiker_nn_1_N : N ;
  grafiker_nn_1_N : N ;
  gradtecken_nn_1_N : N ;
  gospel_nn_1_N : N ;
  gold_digger_nn_1_N : N ;
  go_cart_nn_1_N : N ;
  gnostiker_nn_1_N : N ;
  gnomiker_nn_1_N : N ;
  gnistkammare_nn_1_N : N ;
  glim_nn_1_N : N ;
  glasoega_nn_1_1_N : N ;
  gisslandrama_nn_1_N : N ;
  gillesbroder_nn_1_N : N ;
  gigolo_nn_1_N : N ;
  gigawatt_nn_1_N : N ;
  gigabyte_nn_1_N : N ;
  giftoman_nn_1_N : N ;
  ghost_writer_nn_1_N : N ;
  gevaldiger_nn_1_N : N ;
  georgier_nn_1_N : N ;
  geometriker_nn_1_N : N ;
  geodata_nn_1_N : N ;
  gentleman_nn_1_N : N ;
  genkaerande_nn_1_1_N : N ;
  genetiker_nn_1_N : N ;
  gauss_nn_1_N : N ;
  gauge_nn_1_N : N ;
  gaucho_nn_1_N : N ;
  gaskammare_nn_1_N : N ;
  gartner_nn_1_N : N ;
  gamma_nn_1_N : N ;
  gambier_nn_1_N : N ;
  gallon_nn_1_N : N ;
  gallier_nn_1_N : N ;
  galler_nn_2_N : N ;
  gage_nn_1_N : N ;
  foertroendeman_nn_1_1_N : N ;
  foertjaensttecken_nn_1_1_N : N ;
  foertecken_nn_1_1_N : N ;
  foersvarsvapen_nn_1_1_N : N ;
  foerstoerelsevapen_nn_1_1_N : N ;
  foerman_nn_1_1_N : N ;
  foerlikningsman_nn_1_1_N : N ;
  foerlagsman_nn_1_1_N : N ;
  foerfader_nn_1_1_N : N ;
  foeregaangsman_nn_1_1_N : N ;
  foeredragande_nn_1_1_N : N ;
  foerbindelseofficer_nn_1_1_N : N ;
  faangesman_nn_1_1_N : N ;
  faestman_nn_1_1_N : N ;
  faerskvatten_nn_1_1_N : N ;
  faergteve_nn_1_1_N : N ;
  faelttecken_nn_1_1_N : N ;
  fysiker_nn_1_N : N ;
  fullmaektig_nn_1_1_N : N ;
  fukttekniker_nn_1_N : N ;
  froe_nn_1_1_N : N ;
  fraagetecken_nn_1_1_N : N ;
  fraelseman_nn_1_1_N : N ;
  fritidspolitiker_nn_1_N : N ;
  frisbee_nn_1_N : N ;
  freestyle_nn_1_N : N ;
  free_style_nn_1_N : N ;
  fransman_nn_1_N : N ;
  frankotecken_nn_1_N : N ;
  franc_nn_1_N : N ;
  framtidsman_nn_1_N : N ;
  foxterrier_nn_1_N : N ;
  fotino_nn_1_N : N ;
  fot_nn_2_N : N ;
  fostervatten_nn_1_N : N ;
  fosterfar_nn_1_N : N ;
  forskningsresande_nn_1_N : N ;
  forshuvud_nn_1_N : N ;
  fornegyptier_nn_1_N : N ;
  formalia_nn_1_N : N ;
  foniatriker_nn_1_N : N ;
  fonetiker_nn_1_N : N ;
  folkmusiker_nn_1_N : N ;
  flaedermus_nn_1_1_N : N ;
  flygvapen_nn_1_N : N ;
  flygdrama_nn_1_N : N ;
  fluidum_nn_1_N : N ;
  flottstyrman_nn_1_N : N ;
  flodvatten_nn_1_N : N ;
  flickboksklassiker_nn_1_N : N ;
  flegmatiker_nn_1_N : N ;
  flatlus_nn_1_N : N ;
  flaggman_nn_1_N : N ;
  fladdermus_nn_1_N : N ;
  fjaerdingsvaeg_nn_1_1_N : N ;
  fjaerdingsman_nn_1_1_N : N ;
  fittsafari_nn_1_N : N ;
  fiskoega_nn_1_1_N : N ;
  fiskevatten_nn_1_N : N ;
  finmekaniker_nn_1_N : N ;
  finansman_nn_1_N : N ;
  filharmoniker_nn_1_N : N ;
  fighter_nn_1_N : N ;
  fettprocent_nn_1_N : N ;
  fenicier_nn_1_N : N ;
  felprocent_nn_1_N : N ;
  fasettoega_nn_1_1_N : N ;
  farvatten_nn_1_N : N ;
  farmaka_nn_1_N : N ;
  farfarsfar_nn_1_N : N ;
  farfar_nn_1_N : N ;
  farad_nn_1_N : N ;
  far_nn_1_N : N ;
  fanatiker_nn_1_N : N ;
  fan_nn_2_N : N ;
  familjedrama_nn_1_N : N ;
  fallhammare_nn_1_N : N ;
  falkoega_nn_1_1_N : N ;
  fajter_nn_1_N : N ;
  fader_nn_1_N : N ;
  fackman_nn_1_N : N ;
  facettoega_nn_1_1_N : N ;
  eyeliner_nn_1_N : N ;
  eye_liner_nn_1_N : N ;
  experimentalfysiker_nn_1_N : N ;
  excentriker_nn_1_N : N ;
  examen_nn_1_N : N ;
  exabyte_nn_1_N : N ;
  evergreen_nn_1_N : N ;
  eurodollar_nn_1_N : N ;
  euro_nn_1_N : N ;
  eurasier_nn_1_N : N ;
  etui_nn_1_N : N ;
  etrusker_nn_1_N : N ;
  etiopier_nn_1_N : N ;
  etiker_nn_1_N : N ;
  etermedium_nn_1_N : N ;
  eta_nn_1_N : N ;
  estetiker_nn_1_N : N ;
  eselhuvud_nn_1_N : N ;
  escudo_nn_1_N : N ;
  errata_nn_1_N : N ;
  erotiker_nn_1_N : N ;
  epoxylim_nn_1_N : N ;
  epileptiker_nn_1_N : N ;
  epiker_nn_1_N : N ;
  eolier_nn_1_N : N ;
  eoler_nn_1_N : N ;
  entertainer_nn_1_N : N ;
  engelsman_nn_1_N : N ;
  empiriker_nn_1_N : N ;
  emiratier_nn_1_N : N ;
  emeritus_nn_1_N : N ;
  emaljoega_nn_1_1_N : N ;
  elitidrottsman_nn_1_N : N ;
  elementa_nn_1_N : N ;
  elektrotekniker_nn_1_N : N ;
  elektronvolt_nn_1_N : N ;
  elektriker_nn_1_N : N ;
  elefantnaebbmus_nn_1_1_N : N ;
  eldvapen_nn_1_N : N ;
  eldhandvapen_nn_1_N : N ;
  ekonomexamen_nn_1_N : N ;
  eklektiker_nn_1_N : N ;
  egyptier_nn_1_N : N ;
  egypter_nn_1_N : N ;
  egocentriker_nn_1_N : N ;
  efterkommande_nn_1_N : N ;
  efterbraennkammare_nn_1_1_N : N ;
  daadrafroe_nn_1_1_N : N ;
  dyslektiker_nn_1_N : N ;
  dvd_rom_nn_1_N : N ;
  duo_nn_1_N : N ;
  dumhuvud_nn_1_N : N ;
  draetselkammare_nn_1_1_N : N ;
  dryckesbroder_nn_1_N : N ;
  dricksvatten_nn_1_N : N ;
  dribbler_nn_1_N : N ;
  dramatiker_nn_1_N : N ;
  drama_nn_1_N : N ;
  dorer_nn_1_N : N ;
  dominiker_nn_1_N : N ;
  domedagsvapen_nn_1_N : N ;
  dollar_nn_1_N : N ;
  doktorsexamen_nn_1_N : N ;
  dogmatiker_nn_1_N : N ;
  djurhuvud_nn_1_N : N ;
  djupvatten_nn_1_N : N ;
  djuphavsvatten_nn_1_N : N ;
  djiboutier_nn_1_N : N ;
  distriktsordfoerande_nn_1_1_N : N ;
  dissenter_nn_1_N : N ;
  diskvatten_nn_1_N : N ;
  diorama_nn_1_N : N ;
  dimkammare_nn_1_N : N ;
  diktamen_nn_1_N : N ;
  digitalteve_nn_1_N : N ;
  digital_teve_nn_1_N : N ;
  didaktiker_nn_1_N : N ;
  dialektiker_nn_1_N : N ;
  diagnostiker_nn_1_N : N ;
  diabetiker_nn_1_N : N ;
  desperado_nn_1_N : N ;
  designer_nn_1_N : N ;
  deputerad_nn_1_N : N ;
  depositum_nn_1_N : N ;
  denier_nn_1_N : N ;
  demo_nn_1_N : N ;
  delta_nn_2_N : N ;
  delgivningsman_nn_1_N : N ;
  dego_nn_1_N : N ;
  decimaltecken_nn_1_N : N ;
  deciliter_nn_1_N : N ;
  decibel_nn_1_N : N ;
  data_nn_1_N : N ;
  danneman_nn_1_N : N ;
  dalmatiner_nn_1_N : N ;
  daler_nn_1_N : N ;
  dagvatten_nn_1_N : N ;
  dagofficer_nn_1_N : N ;
  dago_nn_1_N : N ;
  daghavande_nn_1_N : N ;
  cyniker_nn_1_N : N ;
  cyklopoega_nn_1_1_N : N ;
  cyklamen_nn_1_N : N ;
  curie_nn_1_N : N ;
  creepe_nn_1_1_N : N ;
  cre_pe_nn_1_1_N : N ;
  crepe_nn_1_N : N ;
  cowboy_nn_1_N : N ;
  cover_nn_1_N : N ;
  coulomb_nn_1_N : N ;
  copywriter_nn_1_N : N ;
  copycat_nn_1_N : N ;
  copy_cat_nn_1_N : N ;
  comorier_nn_1_N : N ;
  commando_nn_1_N : N ;
  collie_nn_1_N : N ;
  cockerspaniel_nn_1_N : N ;
  citronlaesk_nn_1_1_N : N ;
  citationstecken_nn_1_N : N ;
  cigarettetui_nn_1_N : N ;
  chefstjaensteman_nn_1_1_N : N ;
  champion_nn_1_N : N ;
  centralstimulantia_nn_1_N : N ;
  centner_nn_1_N : N ;
  centilong_nn_1_N : N ;
  centiliter_nn_1_N : N ;
  cent_nn_1_N : N ;
  cd_rom_nn_1_N : N ;
  caterpillar_nn_1_N : N ;
  cashew_nn_1_N : N ;
  cardigan_nn_1_N : N ;
  cappuccino_nn_1_N : N ;
  candela_nn_1_N : N ;
  callgirl_nn_1_N : N ;
  caddie_nn_1_N : N ;
  boersanalytiker_nn_1_1_N : N ;
  boeneman_nn_1_1_N : N ;
  baatsman_nn_1_1_N : N ;
  baesteman_nn_1_1_N : N ;
  baeckvatten_nn_1_1_N : N ;
  byte_nn_2_N : N ;
  butler_nn_1_N : N ;
  bushman_nn_1_N : N ;
  burundier_nn_1_N : N ;
  burkinier_nn_1_N : N ;
  burgunder_nn_1_N : N ;
  bulthuvud_nn_1_N : N ;
  bubbelkammare_nn_1_N : N ;
  braeckvatten_nn_1_1_N : N ;
  braeckhammare_nn_1_1_N : N ;
  brytvapen_nn_1_N : N ;
  brushuvud_nn_1_N : N ;
  brunnsvatten_nn_1_N : N ;
  bruneier_nn_1_N : N ;
  brottsplatstekniker_nn_1_N : N ;
  brohuvud_nn_1_N : N ;
  broder_nn_1_N : N ;
  brevhuvud_nn_1_N : N ;
  brasilier_nn_1_N : N ;
  brandman_nn_1_N : N ;
  bouzouki_nn_1_N : N ;
  boutredningsman_nn_1_N : N ;
  bottenvatten_nn_1_N : N ;
  botswanier_nn_1_N : N ;
  botaniker_nn_1_N : N ;
  bostadssoekande_nn_1_1_N : N ;
  bosnier_nn_1_N : N ;
  borrhammare_nn_1_N : N ;
  borgensman_nn_1_N : N ;
  bordsvatten_nn_1_N : N ;
  bookmaker_nn_1_N : N ;
  bondkomiker_nn_1_N : N ;
  bolagsman_nn_1_N : N ;
  bokstavstecken_nn_1_N : N ;
  boer_nn_1_N : N ;
  boende_nn_2_N : N ;
  blaesgaas_nn_1_1_N : N ;
  blomkaalsoera_nn_1_1_N : N ;
  blomkaalshuvud_nn_1_1_N : N ;
  blomhuvud_nn_1_N : N ;
  blodsdrama_nn_1_N : N ;
  blankvatten_nn_1_N : N ;
  blandvatten_nn_1_N : N ;
  bladlus_nn_1_N : N ;
  bjaelkhuvud_nn_1_1_N : N ;
  bitecken_nn_1_N : N ;
  birdie_nn_1_N : N ;
  bilmekaniker_nn_1_N : N ;
  bilhammare_nn_1_N : N ;
  biktfar_nn_1_N : N ;
  bikini_nn_1_N : N ;
  beta_nn_2_N : N ;
  besoekande_nn_1_1_N : N ;
  besaettningsman_nn_1_1_N : N ;
  besiktningsman_nn_1_N : N ;
  bergsman_nn_1_N : N ;
  berber_nn_1_N : N ;
  beninier_nn_1_N : N ;
  belizier_nn_1_N : N ;
  belgier_nn_1_N : N ;
  befaelstecken_nn_1_1_N : N ;
  befallningsman_nn_1_N : N ;
  befallningshavande_nn_1_N : N ;
  becquerel_nn_1_N : N ;
  baud_nn_1_N : N ;
  barnkammare_nn_1_N : N ;
  barnhuvud_nn_1_N : N ;
  barnavaardsman_nn_1_1_N : N ;
  barnafar_nn_1_N : N ;
  barbadier_nn_1_N : N ;
  bar_nn_2_N : N ;
  banktjaensteman_nn_1_1_N : N ;
  bankofullmaektig_nn_1_1_N : N ;
  bankman_nn_1_N : N ;
  bangladeshier_nn_1_N : N ;
  baneman_nn_1_N : N ;
  baldersbraa_nn_1_1_N : N ;
  bakvatten_nn_1_N : N ;
  bakhuvud_nn_1_N : N ;
  bagel_nn_1_N : N ;
  badvatten_nn_1_N : N ;
  backpacker_nn_1_N : N ;
  babylonier_nn_1_N : N ;
  baby_nn_1_N : N ;
  avvikelseprocent_nn_1_N : N ;
  avundsman_nn_1_N : N ;
  avloppsvatten_nn_1_N : N ;
  aviatiker_nn_1_N : N ;
  avfallsvatten_nn_1_N : N ;
  automatvapen_nn_1_N : N ;
  australier_nn_1_N : N ;
  auktionskammare_nn_1_N : N ;
  attentatsman_nn_1_N : N ;
  atomvapen_nn_1_N : N ;
  ataraktika_nn_1_N : N ;
  asylsoekande_nn_1_1_N : N ;
  astrofysiker_nn_1_N : N ;
  astmatiker_nn_1_N : N ;
  astigmatiker_nn_1_N : N ;
  asteniker_nn_1_N : N ;
  assyrier_nn_1_N : N ;
  artillerivapen_nn_1_N : N ;
  armenier_nn_1_N : N ;
  arier_nn_1_N : N ;
  argusoega_nn_1_1_N : N ;
  ardenner_nn_1_N : N ;
  arbetssoekande_nn_1_1_N : N ;
  arbetsstudieman_nn_1_N : N ;
  apropaa_nn_1_1_N : N ;
  antiseptika_nn_1_N : N ;
  antibiotikum_nn_1_N : N ;
  antecedentia_nn_1_N : N ;
  anorektiker_nn_1_N : N ;
  anfoeringstecken_nn_1_1_N : N ;
  anfallsvapen_nn_1_N : N ;
  anfader_nn_1_N : N ;
  anestetika_nn_1_N : N ;
  anatema_nn_1_N : N ;
  analytiker_nn_1_N : N ;
  analgetika_nn_1_N : N ;
  amtman_nn_1_N : N ;
  ampere_nn_1_N : N ;
  ambulansman_nn_1_N : N ;
  allmaenpraktiker_nn_1_1_N : N ;
  allergiker_nn_1_N : N ;
  algerier_nn_1_N : N ;
  alfa_nn_1_N : N ;
  albyl_nn_1_N : N ;
  albino_nn_1_N : N ;
  albigenser_nn_1_N : N ;
  akutvaardsdata_nn_1_1_N : N ;
  akustiker_nn_1_N : N ;
  aktiva_nn_1_N : N ;
  akademiker_nn_1_N : N ;
  airdaleterrier_nn_1_N : N ;
  agnostiker_nn_1_N : N ;
  afrodisiakum_nn_1_N : N ;
  aforistiker_nn_1_N : N ;
  affaersman_nn_1_1_N : N ;
  afatiker_nn_1_N : N ;
  adiafora_nn_1_N : N ;
  adelsman_nn_1_N : N ;
  additionstecken_nn_1_N : N ;
  addenda_nn_1_N : N ;
  ackordion_nn_1_N : N ;
  accenttecken_nn_1_N : N ;
  aboriginer_nn_1_N : N ;
  abiturientexamen_nn_1_N : N ;
  abessinier_nn_1_N : N ;
  abdomen_nn_1_N : N ;
  Shakespearedrama_nn_1_N : N ;
  PR_man_nn_1_N : N ;
  Metallordfoerande_nn_1_1_N : N ;
  LO_ordfoerande_nn_1_1_N : N ;
  LCD_teve_nn_2_N : N ;
  Europaraadsparlamentariker_nn_1_1_N : N ;
  EU_parlamentariker_nn_1_N : N ;
  alkoholpolicy_nn_1_N : N ;
  alltiallo_nn_1_N : N ;
  assist_nn_1_N : N ;
  backup_nn_1_N : N ;
  backupp_nn_1_N : N ;
  bekant_nn_1_N : N ;
  bolero_nn_1_N : N ;
  bror_nn_1_N : N ;
  bungalow_nn_1_N : N ;
  cello_nn_1_N : N ;
  cembalo_nn_1_N : N ;
  cornichon_nn_1_N : N ;
  dandy_nn_1_N : N ;
  distansminut_nn_1_N : N ;
  drogpolicy_nn_1_N : N ;
  dubror_nn_1_N : N ;
  dummy_nn_1_N : N ;
  dus_nn_1_N : N ;
  etage_nn_1_N : N ;
  fandango_nn_1_N : N ;
  farbror_nn_1_N : N ;
  flamenco_nn_1_N : N ;
  fosterbror_nn_1_N : N ;
  foul_nn_1_N : N ;
  foergaetmigej_nn_1_1_N : N ;
  glasiglo_nn_1_N : N ;
  gravamen_nn_1_N : N ;
  grej_nn_1_N : N ;
  guppy_nn_1_N : N ;
  halo_nn_1_N : N ;
  halvbror_nn_1_N : N ;
  hambo_nn_1_N : N ;
  helbror_nn_1_N : N ;
  herrbekant_nn_1_N : N ;
  hobby_nn_1_N : N ;
  iglo_nn_1_N : N ;
  igloo_nn_1_N : N ;
  kaffe_nn_2_N : N ;
  kanon_nn_1_N : N ;
  korso_nn_1_N : N ;
  kaernvapenparaply_nn_1_1_N : N ;
  lasso_nn_1_N : N ;
  libero_nn_1_N : N ;
  libretto_nn_1_N : N ;
  litteraturkanon_nn_1_N : N ;
  mango_nn_1_N : N ;
  mellanbror_nn_1_N : N ;
  mikrofiche_nn_1_N : N ;
  mikron_nn_1_N : N ;
  minut_nn_1_N : N ;
  molo_nn_1_N : N ;
  morbror_nn_1_N : N ;
  mungo_nn_1_N : N ;
  navaho_nn_1_N : N ;
  navajo_nn_1_N : N ;
  paraply_nn_1_N : N ;
  personal_nn_2_N : N ;
  policy_nn_1_N : N ;
  ponny_nn_1_N : N ;
  promovend_nn_1_N : N ;
  shetlandsponny_nn_1_N : N ;
  slutminut_nn_1_N : N ;
  sombrero_nn_1_N : N ;
  spin_off_nn_1_N : N ;
  tango_nn_1_N : N ;
  te_nn_2_N : N ;
  the_nn_2_N : N ;
  torero_nn_1_N : N ;
  triage_nn_1_N : N ;
  tvillingbror_nn_1_N : N ;
  vad_nn_2_N : N ;
  oeverpris_nn_1_1_N : N ;
  oeverkast_nn_1_1_N : N ;
  oevergaangsproblem_nn_1_1_N : N ;
  oeverfaangsglas_nn_1_1_N : N ;
  oerclips_nn_1_1_N : N ;
  oelglas_nn_1_1_N : N ;
  oel_nn_2_1_N : N ;
  oel_nn_1_1_N : N ;
  oegonkast_nn_1_1_N : N ;
  oedem_nn_1_1_N : N ;
  aarder_nn_1_1_N : N ;
  aanglokomotiv_nn_1_1_N : N ;
  aangestsymtom_nn_1_1_N : N ;
  aangestsymptom_nn_1_1_N : N ;
  aalyngel_nn_1_1_N : N ;
  aettled_nn_1_1_N : N ;
  aess_nn_1_1_N : N ;
  aeppletraed_nn_1_1_N : N ;
  aeppeltraed_nn_1_1_N : N ;
  aeggviteprov_nn_1_1_N : N ;
  aegardirektiv_nn_1_1_N : N ;
  aedelloevtraed_nn_1_1_N : N ;
  aeckel_nn_1_1_N : N ;
  zoomobjektiv_nn_1_N : N ;
  ziqqurat_nn_1_N : N ;
  zikkurat_nn_1_N : N ;
  ziggurat_nn_1_N : N ;
  ypsilon_nn_1_N : N ;
  yogapass_nn_1_N : N ;
  ynnestbevis_nn_1_N : N ;
  yngel_nn_1_N : N ;
  ylletyg_nn_1_N : N ;
  yalelaas_nn_1_1_N : N ;
  xi_nn_1_N : N ;
  webbtest_nn_1_N : N ;
  vaardtraed_nn_1_1_N : N ;
  vaexthus_nn_1_1_N : N ;
  vaexthormon_nn_1_1_N : N ;
  vaevnadsprov_nn_1_1_N : N ;
  vaetteljus_nn_1_1_N : N ;
  vaermeljus_nn_1_1_N : N ;
  vaermeledningssystem_nn_1_1_N : N ;
  vaermekrus_nn_1_1_N : N ;
  vaerdshus_nn_1_1_N : N ;
  vaensterkryss_nn_1_1_N : N ;
  vaenskapspris_nn_1_1_N : N ;
  vaenpris_nn_1_1_N : N ;
  vaendkors_nn_1_1_N : N ;
  vaelfaerdssystem_nn_1_1_N : N ;
  vaegkors_nn_1_1_N : N ;
  vaedersegel_nn_1_1_N : N ;
  vaederkaos_nn_1_1_N : N ;
  vaeder_nn_1_1_N : N ;
  vrakpris_nn_1_N : N ;
  vov_nn_1_N : N ;
  votum_nn_1_N : N ;
  votivljus_nn_1_N : N ;
  vomitiv_nn_1_N : N ;
  vodkaglas_nn_1_N : N ;
  vittnesbaas_nn_1_1_N : N ;
  visum_nn_1_N : N ;
  visthus_nn_1_N : N ;
  visarkiv_nn_1_N : N ;
  vis_nn_1_N : N ;
  virus_nn_1_N : N ;
  virkgarn_nn_1_N : N ;
  vintermys_nn_1_N : N ;
  vinstras_nn_1_N : N ;
  vinkelhus_nn_1_N : N ;
  vinglas_nn_1_N : N ;
  vindkast_nn_1_N : N ;
  vin_nn_3_N : N ;
  viltstaengsel_nn_1_1_N : N ;
  villapris_nn_1_N : N ;
  vildgraes_nn_1_1_N : N ;
  viktsystem_nn_1_N : N ;
  vigselritual_nn_1_N : N ;
  vigselbevis_nn_1_N : N ;
  vidvinkelobjektiv_nn_1_N : N ;
  vidunder_nn_1_N : N ;
  victoriakors_nn_1_N : N ;
  viby_i_nn_1_N : N ;
  vevhus_nn_1_N : N ;
  verkstadshus_nn_1_N : N ;
  verbalsubstantiv_nn_1_N : N ;
  verbalabstrakt_nn_1_N : N ;
  ventilhus_nn_1_N : N ;
  ventilationssystem_nn_1_N : N ;
  vaxljus_nn_1_N : N ;
  vattupass_nn_1_N : N ;
  vattenvaermesystem_nn_1_1_N : N ;
  vattenprov_nn_1_N : N ;
  vattenpass_nn_1_N : N ;
  vattenlaas_nn_1_1_N : N ;
  vattenkrus_nn_1_N : N ;
  vattenglas_nn_1_N : N ;
  varuprov_nn_1_N : N ;
  varupris_nn_1_N : N ;
  varuhus_nn_1_N : N ;
  varsel_nn_1_N : N ;
  varningsljus_nn_1_N : N ;
  varmvattensystem_nn_1_N : N ;
  varmvattenssystem_nn_1_N : N ;
  varmluftssystem_nn_1_N : N ;
  varghagel_nn_1_N : N ;
  vardagsritual_nn_1_N : N ;
  vapensystem_nn_1_N : N ;
  vapenhus_nn_1_N : N ;
  vant_nn_1_N : N ;
  vandringspris_nn_1_N : N ;
  vanadinstaal_nn_1_1_N : N ;
  valnoetstraed_nn_1_1_N : N ;
  valmanifest_nn_1_N : N ;
  vallokomotiv_nn_1_N : N ;
  valkaos_nn_1_N : N ;
  vakuum_nn_1_N : N ;
  vagnslider_nn_1_N : N ;
  vacuum_nn_1_N : N ;
  vaccin_nn_1_N : N ;
  utvaerdshus_nn_1_1_N : N ;
  utvisningsbaas_nn_1_1_N : N ;
  utvecklingstraed_nn_1_1_N : N ;
  utseendekomplex_nn_1_N : N ;
  utkast_nn_1_N : N ;
  utifraanperspektiv_nn_1_1_N : N ;
  uthus_nn_1_N : N ;
  utgivningsbevis_nn_1_N : N ;
  utfallsprov_nn_1_N : N ;
  utedass_nn_1_N : N ;
  utbredningscentrum_nn_1_N : N ;
  utbildningssystem_nn_1_N : N ;
  ursprungsbevis_nn_1_N : N ;
  urinprov_nn_1_N : N ;
  uranglas_nn_1_N : N ;
  uppkast_nn_1_N : N ;
  uns_nn_1_N : N ;
  universum_nn_1_N : N ;
  universitetssjukhus_nn_1_N : N ;
  unikum_nn_1_N : N ;
  undervisningssjukhus_nn_1_N : N ;
  understatement_nn_1_N : N ;
  undersegel_nn_1_N : N ;
  underpris_nn_1_N : N ;
  underifraanperspektiv_nn_1_1_N : N ;
  underhaallsproblem_nn_1_1_N : N ;
  underhus_nn_1_N : N ;
  under_nn_1_N : N ;
  ultimatum_nn_1_N : N ;
  ugnstegel_nn_1_N : N ;
  taartkalas_nn_1_1_N : N ;
  taevlingspris_nn_1_1_N : N ;
  taerningskast_nn_1_1_N : N ;
  taendsticksproblem_nn_1_1_N : N ;
  taendningslaas_nn_1_1_N : N ;
  taeckglas_nn_1_1_N : N ;
  typexempel_nn_1_N : N ;
  tygprov_nn_1_N : N ;
  tyghus_nn_1_N : N ;
  tyg_nn_1_N : N ;
  tvaakammarsystem_nn_1_1_N : N ;
  tvaafamiljshus_nn_1_1_N : N ;
  tvivel_nn_1_N : N ;
  tvillingsyskon_nn_1_N : N ;
  tulpantraed_nn_1_1_N : N ;
  tullpass_nn_1_N : N ;
  tukthus_nn_1_N : N ;
  tsunamivarningssystem_nn_1_N : N ;
  troestpris_nn_1_1_N : N ;
  traadkors_nn_1_1_N : N ;
  traesk_nn_1_1_N : N ;
  traekors_nn_1_1_N : N ;
  traed_nn_1_1_N : N ;
  trubbel_nn_1_N : N ;
  tricks_nn_1_N : N ;
  trevaaningshus_nn_1_1_N : N ;
  trepass_nn_1_N : N ;
  treledarsystem_nn_1_N : N ;
  tredagarspass_nn_1_N : N ;
  travtips_nn_1_N : N ;
  trapphus_nn_1_N : N ;
  transumt_nn_1_N : N ;
  transportsystem_nn_1_N : N ;
  trafikljus_nn_1_N : N ;
  trafikkaos_nn_1_N : N ;
  totalkaos_nn_1_N : N ;
  torrdass_nn_1_N : N ;
  toppsegel_nn_1_N : N ;
  tonsystem_nn_1_N : N ;
  tonem_nn_1_N : N ;
  tomtebloss_nn_1_N : N ;
  tomglas_nn_1_N : N ;
  tjaerbloss_nn_1_1_N : N ;
  tips_nn_1_N : N ;
  tingshus_nn_1_N : N ;
  timmerhus_nn_1_N : N ;
  timglas_nn_1_N : N ;
  tillvaexthormon_nn_1_1_N : N ;
  tillstaandsbevis_nn_1_1_N : N ;
  tidsperspektiv_nn_1_N : N ;
  tidskriftsindex_nn_1_N : N ;
  tidsintervall_nn_1_N : N ;
  tidsadverbial_nn_1_N : N ;
  textarkiv_nn_1_N : N ;
  tetrakord_nn_1_N : N ;
  test_nn_1_N : N ;
  teorem_nn_1_N : N ;
  tempel_nn_1_N : N ;
  telex_nn_2_N : N ;
  teleobjektiv_nn_1_N : N ;
  tehus_nn_1_N : N ;
  teglas_nn_1_N : N ;
  tegel_nn_1_N : N ;
  tefralager_nn_1_N : N ;
  tedeum_nn_1_N : N ;
  teckningsbevis_nn_1_N : N ;
  teckensystem_nn_1_N : N ;
  teaktraed_nn_1_1_N : N ;
  taxeringsbevis_nn_1_N : N ;
  tau_nn_1_N : N ;
  tarmsystem_nn_1_N : N ;
  tarmkaex_nn_1_1_N : N ;
  tantiem_nn_1_N : N ;
  tankesystem_nn_1_N : N ;
  tankeexperiment_nn_1_N : N ;
  tandborstglas_nn_1_N : N ;
  talsystem_nn_1_N : N ;
  talgljus_nn_1_N : N ;
  talcentrum_nn_1_N : N ;
  taktegel_nn_1_N : N ;
  takroest_nn_1_1_N : N ;
  takras_nn_1_N : N ;
  taggtraadsstaengsel_nn_1_1_N : N ;
  tagel_nn_1_N : N ;
  tackoffer_nn_1_N : N ;
  tackel_nn_1_N : N ;
  tack_nn_1_N : N ;
  tabernakel_nn_1_N : N ;
  soemnproblem_nn_1_1_N : N ;
  soemmersketips_nn_1_1_N : N ;
  soekarljus_nn_1_1_N : N ;
  saettsadverbial_nn_1_1_N : N ;
  saekerhetssystem_nn_1_1_N : N ;
  saekerhetsproblem_nn_1_1_N : N ;
  saekerhetsglas_nn_1_1_N : N ;
  system_nn_1_N : N ;
  syskon_nn_1_N : N ;
  syntagm_nn_1_N : N ;
  synset_nn_1_N : N ;
  synonymlexikon_nn_1_N : N ;
  symtom_nn_1_N : N ;
  symptom_nn_1_N : N ;
  svaengningsproblem_nn_1_1_N : N ;
  svinstall_nn_1_N : N ;
  svinhus_nn_1_N : N ;
  svindelperspektiv_nn_1_N : N ;
  svinborst_nn_1_N : N ;
  svidknott_nn_1_N : N ;
  suterraenghus_nn_1_1_N : N ;
  surfproffs_nn_1_N : N ;
  supervirus_nn_1_N : N ;
  sulfit_nn_1_N : N ;
  sulfat_nn_1_N : N ;
  suffix_nn_1_N : N ;
  substantiv_nn_1_N : N ;
  staand_nn_2_1_N : N ;
  staerbhus_nn_1_1_N : N ;
  staengsel_nn_1_1_N : N ;
  staedsel_nn_1_1_N : N ;
  styvsyskon_nn_1_N : N ;
  styrsystem_nn_1_N : N ;
  styrkepass_nn_1_N : N ;
  styrcentrum_nn_1_N : N ;
  studioalbum_nn_1_N : N ;
  straalningsspektrum_nn_1_1_N : N ;
  straalningskvantum_nn_1_1_N : N ;
  straalkastarljus_nn_1_1_N : N ;
  stresshormon_nn_1_N : N ;
  strejkvarsel_nn_1_N : N ;
  straffkast_nn_1_N : N ;
  storsyskon_nn_1_N : N ;
  storsegel_nn_1_N : N ;
  stormcentrum_nn_1_N : N ;
  storkors_nn_1_N : N ;
  storfamiljshus_nn_1_N : N ;
  storasyskon_nn_1_N : N ;
  stoppris_nn_1_N : N ;
  stoppljus_nn_1_N : N ;
  stoff_nn_1_N : N ;
  stjaernsystem_nn_1_1_N : N ;
  stjaernljus_nn_1_1_N : N ;
  stjaernhus_nn_1_1_N : N ;
  stimulus_nn_1_N : N ;
  stiglaeder_nn_1_1_N : N ;
  sterbhus_nn_1_N : N ;
  stenroes_nn_1_1_N : N ;
  stenkummel_nn_1_N : N ;
  stenkast_nn_1_N : N ;
  stekhus_nn_1_N : N ;
  stegel_nn_1_N : N ;
  stearinljus_nn_1_N : N ;
  stativ_nn_1_N : N ;
  stationshus_nn_1_N : N ;
  startsystem_nn_1_N : N ;
  startproblem_nn_1_N : N ;
  startpris_nn_1_N : N ;
  starkoel_nn_1_1_N : N ;
  stamtraed_nn_1_1_N : N ;
  stamlokus_nn_1_N : N ;
  stalltips_nn_1_N : N ;
  stall_nn_1_N : N ;
  stagsegel_nn_1_N : N ;
  stadsljus_nn_1_N : N ;
  stadshus_nn_1_N : N ;
  stadsarkiv_nn_1_N : N ;
  stabiliseringsproblem_nn_1_N : N ;
  spaarljus_nn_1_1_N : N ;
  spraangsegel_nn_1_1_N : N ;
  spraakcentrum_nn_1_1_N : N ;
  sprinklersystem_nn_1_N : N ;
  splitter_nn_1_N : N ;
  spinnhus_nn_1_N : N ;
  spinn_nn_1_N : N ;
  spin_nn_1_N : N ;
  spex_nn_1_N : N ;
  spetsglas_nn_1_N : N ;
  spelproblem_nn_1_N : N ;
  spektrum_nn_1_N : N ;
  spektakel_nn_1_N : N ;
  spegeltest_nn_1_N : N ;
  spegelglas_nn_1_N : N ;
  specimen_nn_1_N : N ;
  specialproblem_nn_1_N : N ;
  spamm_nn_1_N : N ;
  spam_nn_1_N : N ;
  souterraenghus_nn_1_1_N : N ;
  souterrainhus_nn_1_N : N ;
  sorkvirus_nn_1_N : N ;
  sopnedkast_nn_1_N : N ;
  sommarparadis_nn_1_N : N ;
  sommarhus_nn_1_N : N ;
  solsystem_nn_1_N : N ;
  solljus_nn_1_N : N ;
  soleksem_nn_1_N : N ;
  sodaglas_nn_1_N : N ;
  societetshus_nn_1_N : N ;
  snoekaos_nn_1_1_N : N ;
  snoehagel_nn_1_1_N : N ;
  snaepplaas_nn_1_1_N : N ;
  snaeckhus_nn_1_1_N : N ;
  snigelhus_nn_1_N : N ;
  snedsegel_nn_1_N : N ;
  snapshot_nn_1_N : N ;
  snacks_nn_1_N : N ;
  smoergaasmargarin_nn_1_1_N : N ;
  smaasyskon_nn_1_1_N : N ;
  smaahus_nn_1_1_N : N ;
  smaaax_nn_1_1_N : N ;
  smaecklaas_nn_1_1_N : N ;
  smakprov_nn_1_N : N ;
  smakproblem_nn_1_N : N ;
  smajl_nn_1_N : N ;
  slaekttraed_nn_1_1_N : N ;
  slaektskapstraed_nn_1_1_N : N ;
  slaektkalas_nn_1_1_N : N ;
  slipprov_nn_1_N : N ;
  slavhus_nn_1_N : N ;
  slaktoffer_nn_1_N : N ;
  slakthus_nn_1_N : N ;
  skoenhetspris_nn_1_1_N : N ;
  skoeldkoertelhormon_nn_1_1_N : N ;
  skaalkors_nn_1_1_N : N ;
  skumrask_nn_2_N : N ;
  skuldderivat_nn_1_N : N ;
  skraeckexempel_nn_1_1_N : N ;
  skriptum_nn_1_N : N ;
  skriftsystem_nn_1_N : N ;
  skolsystem_nn_1_N : N ;
  skolljus_nn_1_N : N ;
  skolhus_nn_1_N : N ;
  skolexempel_nn_1_N : N ;
  skogstraed_nn_1_1_N : N ;
  skogshoens_nn_1_1_N : N ;
  skjortbroest_nn_1_1_N : N ;
  skivhus_nn_1_N : N ;
  skivalbum_nn_1_N : N ;
  skeppsljus_nn_1_N : N ;
  skatteutjaemningssystem_nn_1_1_N : N ;
  skattesystem_nn_1_N : N ;
  skatteparadis_nn_1_N : N ;
  skalhus_nn_1_N : N ;
  sjoemanshus_nn_1_1_N : N ;
  sjaelvaeckel_nn_1_1_N : N ;
  sjutillhaallarlaas_nn_1_1_N : N ;
  sjukhus_nn_1_N : N ;
  sjukdomssymtom_nn_1_N : N ;
  sjukdomssymptom_nn_1_N : N ;
  sjabbel_nn_1_N : N ;
  sinnessjukhus_nn_1_N : N ;
  sinder_nn_1_N : N ;
  simplex_nn_1_N : N ;
  silver_nn_1_N : N ;
  silkegarn_nn_1_N : N ;
  silikonbroest_nn_1_1_N : N ;
  silikon_nn_1_N : N ;
  silikat_nn_1_N : N ;
  signum_nn_1_N : N ;
  signalbloss_nn_1_N : N ;
  sifferpussel_nn_1_N : N ;
  sidoroder_nn_1_N : N ;
  sidentyg_nn_1_N : N ;
  sickativ_nn_1_N : N ;
  shoppingcentrum_nn_1_N : N ;
  shellack_nn_1_N : N ;
  servicehus_nn_1_N : N ;
  serveuppkast_nn_1_N : N ;
  servess_nn_1_N : N ;
  serveess_nn_1_N : N ;
  serum_nn_1_N : N ;
  senapsglas_nn_1_N : N ;
  semem_nn_1_N : N ;
  seltersglas_nn_1_N : N ;
  sekelskiftshus_nn_1_N : N ;
  sekel_nn_1_N : N ;
  segersmajl_nn_1_N : N ;
  segerrus_nn_1_N : N ;
  segel_nn_1_N : N ;
  sedimentprov_nn_1_N : N ;
  schibbolet_nn_1_N : N ;
  schackproblem_nn_1_N : N ;
  schabbel_nn_1_N : N ;
  scepter_nn_1_N : N ;
  satskompletteringstest_nn_1_N : N ;
  satsadverbial_nn_1_N : N ;
  sannolikhetsbevis_nn_1_N : N ;
  sandstenshus_nn_1_N : N ;
  sandeltraed_nn_1_1_N : N ;
  samsyskon_nn_1_N : N ;
  sampel_nn_1_N : N ;
  sammansaettningsled_nn_1_1_N : N ;
  samhaellssystem_nn_1_1_N : N ;
  samhaellsproblem_nn_1_1_N : N ;
  salupris_nn_1_N : N ;
  salivprov_nn_1_N : N ;
  salighetsrus_nn_1_N : N ;
  sagostoff_nn_1_N : N ;
  saftkalas_nn_1_N : N ;
  roevmoegel_nn_1_1_N : N ;
  roevarpris_nn_1_1_N : N ;
  roestkaos_nn_1_1_N : N ;
  roest_nn_2_1_N : N ;
  roes_nn_1_1_N : N ;
  roerelsekapital_nn_1_1_N : N ;
  roerelsecentrum_nn_1_1_N : N ;
  raasegel_nn_1_1_N : N ;
  raamaterial_nn_1_1_N : N ;
  raadhus_nn_1_1_N : N ;
  raettviseperspektiv_nn_1_1_N : N ;
  raettssystem_nn_1_1_N : N ;
  raekneexempel_nn_1_1_N : N ;
  rymdepos_nn_1_N : N ;
  russ_nn_1_N : N ;
  rus_nn_1_N : N ;
  runk_nn_1_N : N ;
  rumsadverbial_nn_1_N : N ;
  ruckel_nn_1_N : N ;
  rotsystem_nn_1_N : N ;
  rotmorfem_nn_1_N : N ;
  ros_evinsmingel_nn_1_1_N : N ;
  rorschachtest_nn_1_N : N ;
  romanutkast_nn_1_N : N ;
  ro_nn_3_N : N ;
  rivningshus_nn_1_N : N ;
  ritual_nn_1_N : N ;
  rissel_nn_1_N : N ;
  ris_nn_1_N : N ;
  ringbrosk_nn_1_N : N ;
  rimlexikon_nn_1_N : N ;
  riktpris_nn_1_N : N ;
  riksroes_nn_1_1_N : N ;
  riksdagshus_nn_1_N : N ;
  riksarkiv_nn_1_N : N ;
  riks_nn_1_N : N ;
  ridhus_nn_1_N : N ;
  riddarhus_nn_1_N : N ;
  rho_nn_1_N : N ;
  returglas_nn_1_N : N ;
  respass_nn_1_N : N ;
  reskaos_nn_1_N : N ;
  residens_nn_1_N : N ;
  resekreditiv_nn_1_N : N ;
  renaessanspalats_nn_1_1_N : N ;
  relativpronomen_nn_1_N : N ;
  rekvisit_nn_1_N : N ;
  rekviem_nn_1_N : N ;
  registratur_nn_1_N : N ;
  regionsjukhus_nn_1_N : N ;
  regeringspussel_nn_1_N : N ;
  regeringsdirektiv_nn_1_N : N ;
  regelsystem_nn_1_N : N ;
  regelkraangel_nn_1_1_N : N ;
  referenssystem_nn_1_N : N ;
  referendum_nn_1_N : N ;
  recitativ_nn_1_N : N ;
  recidiv_nn_1_N : N ;
  reapris_nn_1_N : N ;
  realindex_nn_1_N : N ;
  reagens_nn_1_N : N ;
  rattlaas_nn_1_1_N : N ;
  ras_nn_2_N : N ;
  raptus_nn_1_N : N ;
  rapphoens_nn_1_1_N : N ;
  rampris_nn_1_N : N ;
  radonhus_nn_1_N : N ;
  radionavigeringssystem_nn_1_N : N ;
  radiohus_nn_1_N : N ;
  radhus_nn_1_N : N ;
  poes_nn_1_1_N : N ;
  paavaextproblem_nn_1_1_N : N ;
  paaskoel_nn_1_1_N : N ;
  puts_nn_2_N : N ;
  pusskalas_nn_1_N : N ;
  pussel_nn_1_N : N ;
  purgativ_nn_1_N : N ;
  punkthus_nn_1_N : N ;
  pund_nn_1_N : N ;
  psi_nn_1_N : N ;
  pseudoproblem_nn_1_N : N ;
  praestcelibat_nn_1_1_N : N ;
  provglas_nn_1_N : N ;
  prov_nn_2_N : N ;
  pronomen_nn_1_N : N ;
  proffs_nn_1_N : N ;
  problemkomplex_nn_1_N : N ;
  problem_nn_1_N : N ;
  privatkapital_nn_1_N : N ;
  privatiseringsspektakel_nn_1_N : N ;
  prisras_nn_1_N : N ;
  pris_nn_1_N : N ;
  preservativ_nn_1_N : N ;
  prerogativ_nn_1_N : N ;
  prepositionskasus_nn_1_N : N ;
  preparat_nn_1_N : N ;
  premiaertest_nn_1_1_N : N ;
  prefix_nn_1_N : N ;
  predikativ_nn_1_N : N ;
  predikatadverbial_nn_1_N : N ;
  predikament_nn_1_N : N ;
  praktexempel_nn_1_N : N ;
  poaengtips_nn_1_1_N : N ;
  poaeng_nn_1_1_N : N ;
  potatischips_nn_1_N : N ;
  postskriptum_nn_1_N : N ;
  positiv_nn_1_N : N ;
  positionsljus_nn_1_N : N ;
  popcorn_nn_1_N : N ;
  polynom_nn_1_N : N ;
  polishus_nn_1_N : N ;
  polhemslaas_nn_1_1_N : N ;
  poem_nn_1_N : N ;
  plaaster_nn_1_1_N : N ;
  plaagoris_nn_1_1_N : N ;
  plus_nn_1_N : N ;
  pliktcelibat_nn_1_N : N ;
  plenum_nn_1_N : N ;
  plektrum_nn_1_N : N ;
  plektron_nn_1_N : N ;
  plattlaeggningsproblem_nn_1_1_N : N ;
  plastiktraesk_nn_1_1_N : N ;
  plastglas_nn_1_N : N ;
  planetsystem_nn_1_N : N ;
  pidgin_nn_1_N : N ;
  pi_nn_1_N : N ;
  phi_nn_1_N : N ;
  perspektiv_nn_1_N : N ;
  personlighetstest_nn_1_N : N ;
  personbevis_nn_1_N : N ;
  pergament_nn_1_N : N ;
  perfektiv_nn_1_N : N ;
  peptid_nn_1_N : N ;
  pepparkakshus_nn_1_N : N ;
  pensum_nn_1_N : N ;
  pensionssystem_nn_1_N : N ;
  penningsystem_nn_1_N : N ;
  pendelkaos_nn_1_N : N ;
  pektin_nn_1_N : N ;
  pekfingertest_nn_1_N : N ;
  pejorativ_nn_1_N : N ;
  patronymikon_nn_1_N : N ;
  patentlaas_nn_1_1_N : N ;
  passionsepos_nn_1_N : N ;
  pass_nn_1_N : N ;
  partylejon_nn_1_N : N ;
  partipris_nn_1_N : N ;
  parkeringsljus_nn_1_N : N ;
  parkeringshus_nn_1_N : N ;
  parhus_nn_1_N : N ;
  parasoll_nn_1_N : N ;
  paradis_nn_1_N : N ;
  paradigm_nn_1_N : N ;
  paradexempel_nn_1_N : N ;
  pansarglas_nn_1_N : N ;
  palmhus_nn_1_N : N ;
  palindrom_nn_1_N : N ;
  palats_nn_1_N : N ;
  paktum_nn_1_N : N ;
  paketpris_nn_1_N : N ;
  packhus_nn_1_N : N ;
  ovaederscentrum_nn_1_1_N : N ;
  otrohetstrassel_nn_1_N : N ;
  oskuldsbevis_nn_1_N : N ;
  os_nn_2_N : N ;
  ort_nn_3_N : N ;
  orsakskomplex_nn_1_N : N ;
  orsaksadverbial_nn_1_N : N ;
  oroscentrum_nn_1_N : N ;
  ormyngel_nn_1_N : N ;
  original_nn_1_N : N ;
  ordenskapitel_nn_1_N : N ;
  orakel_nn_1_N : N ;
  opus_nn_1_N : N ;
  optimum_nn_1_N : N ;
  oppkast_nn_1_N : N ;
  opiat_nn_1_N : N ;
  operativsystem_nn_1_N : N ;
  operahus_nn_1_N : N ;
  onus_nn_1_N : N ;
  ont_nn_2_N : N ;
  omkast_nn_1_N : N ;
  omikron_nn_1_N : N ;
  omen_nn_1_N : N ;
  ollontraed_nn_1_1_N : N ;
  oljepris_nn_1_N : N ;
  oljelaas_nn_1_1_N : N ;
  olivtraed_nn_1_1_N : N ;
  oktan_nn_1_N : N ;
  offer_nn_1_N : N ;
  odds_nn_1_N : N ;
  observandum_nn_1_N : N ;
  objektiv_nn_1_N : N ;
  objektglas_nn_1_N : N ;
  o_nn_1_N : N ;
  noejespalats_nn_1_1_N : N ;
  naadebevis_nn_1_1_N : N ;
  naetverksperspektiv_nn_1_1_N : N ;
  naest_nn_1_1_N : N ;
  naesbrosk_nn_1_1_N : N ;
  naes_nn_1_1_N : N ;
  nyhetstest_nn_1_N : N ;
  nyckelax_nn_1_N : N ;
  ny_nn_1_N : N ;
  nutidstest_nn_1_N : N ;
  nuklein_nn_1_N : N ;
  normsystem_nn_1_N : N ;
  normalobjektiv_nn_1_N : N ;
  nomen_nn_1_N : N ;
  nomadsystem_nn_1_N : N ;
  nollsuffix_nn_1_N : N ;
  nollmorfem_nn_1_N : N ;
  nollalternativ_nn_1_N : N ;
  nobelpris_nn_1_N : N ;
  nitrit_nn_1_N : N ;
  nitrat_nn_1_N : N ;
  niotillhaallarlaas_nn_1_1_N : N ;
  newyorkoriginal_nn_1_N : N ;
  neutrum_nn_1_N : N ;
  neuron_nn_1_N : N ;
  neurom_nn_1_N : N ;
  nettopris_nn_1_N : N ;
  nervsystem_nn_1_N : N ;
  nersaettningsbevis_nn_1_1_N : N ;
  neonljus_nn_1_N : N ;
  nej_nn_1_N : N ;
  negativ_nn_1_N : N ;
  nedsaettningsbevis_nn_1_1_N : N ;
  navigeringssystem_nn_1_N : N ;
  nattljus_nn_1_N : N ;
  nattis_nn_2_N : N ;
  natriumsulfat_nn_1_N : N ;
  natriumnitrat_nn_1_N : N ;
  nationalitetsbevis_nn_1_N : N ;
  namnchiffer_nn_1_N : N ;
  nakterhus_nn_1_N : N ;
  nafs_nn_1_N : N ;
  moerker_nn_1_1_N : N ;
  moenstringsbevis_nn_1_1_N : N ;
  moenstergarn_nn_1_1_N : N ;
  moeblemang_nn_1_1_N : N ;
  moebelvaruhus_nn_1_1_N : N ;
  moebeltyg_nn_1_1_N : N ;
  maattsystem_nn_1_1_N : N ;
  maetglas_nn_1_1_N : N ;
  maetarhus_nn_1_1_N : N ;
  maessoffer_nn_1_1_N : N ;
  maerssegel_nn_1_1_N : N ;
  maerkgarn_nn_1_1_N : N ;
  maenniskooffer_nn_1_1_N : N ;
  maenniskobroest_nn_1_1_N : N ;
  mys_nn_1_N : N ;
  myntsystem_nn_1_N : N ;
  myntinkast_nn_1_N : N ;
  my_nn_1_N : N ;
  mutsystem_nn_1_N : N ;
  muskottraed_nn_1_1_N : N ;
  muskedunder_nn_1_N : N ;
  musikalbum_nn_1_N : N ;
  munlaeder_nn_1_1_N : N ;
  mullbaerstraed_nn_1_1_N : N ;
  mullbaersfikontraed_nn_1_1_N : N ;
  mottagningsbevis_nn_1_N : N ;
  mott_nn_1_N : N ;
  motorstativ_nn_1_N : N ;
  motiv_nn_1_N : N ;
  motbevis_nn_1_N : N ;
  morgonritual_nn_1_N : N ;
  morgonbloss_nn_1_N : N ;
  morfinpreparat_nn_1_N : N ;
  morfem_nn_1_N : N ;
  mordoffer_nn_1_N : N ;
  moras_nn_1_N : N ;
  monokord_nn_1_N : N ;
  modus_nn_1_N : N ;
  modulsystem_nn_1_N : N ;
  mods_nn_1_N : N ;
  modem_nn_1_N : N ;
  modehus_nn_1_N : N ;
  mobilvirus_nn_1_N : N ;
  mobilmodem_nn_1_N : N ;
  misstroendevotum_nn_1_N : N ;
  missiv_nn_1_N : N ;
  missionshus_nn_1_N : N ;
  mirakel_nn_1_N : N ;
  minus_nn_1_N : N ;
  minnesalbum_nn_1_N : N ;
  minimum_nn_1_N : N ;
  minimipris_nn_1_N : N ;
  minimikapital_nn_1_N : N ;
  mingel_nn_1_N : N ;
  mineralprov_nn_1_N : N ;
  mindervaerdeskomplex_nn_1_1_N : N ;
  miljoeproblem_nn_1_1_N : N ;
  mikrooel_nn_2_1_N : N ;
  mikrooel_nn_1_1_N : N ;
  mikrokosmos_nn_1_N : N ;
  mikroklimat_nn_1_N : N ;
  mexitegel_nn_1_N : N ;
  metersystem_nn_1_N : N ;
  metacentrum_nn_1_N : N ;
  merkantilsystem_nn_1_N : N ;
  mentalsjukhus_nn_1_N : N ;
  memorial_nn_2_N : N ;
  membrum_nn_1_N : N ;
  membran_nn_1_N : N ;
  mellanoel_nn_1_1_N : N ;
  mellanmaalstips_nn_1_1_N : N ;
  melanom_nn_1_N : N ;
  mejl_nn_2_N : N ;
  medium_nn_2_N : N ;
  medikament_nn_1_N : N ;
  medicinglas_nn_1_N : N ;
  medelpris_nn_1_N : N ;
  medelhavstraed_nn_1_1_N : N ;
  medborgarhus_nn_1_N : N ;
  maximum_nn_1_N : N ;
  matsmaeltningssystem_nn_1_1_N : N ;
  matlaadetips_nn_1_1_N : N ;
  materialproblem_nn_1_N : N ;
  material_nn_1_N : N ;
  mat_nn_2_N : N ;
  masspektrum_nn_1_N : N ;
  massiv_nn_1_N : N ;
  masscentrum_nn_1_N : N ;
  marknadspris_nn_1_N : N ;
  maraton_nn_1_N : N ;
  manus_nn_1_N : N ;
  mankemang_nn_1_N : N ;
  manifest_nn_1_N : N ;
  mangrovetraesk_nn_1_1_N : N ;
  mamutfossil_nn_1_N : N ;
  mammuttraed_nn_1_1_N : N ;
  malteserkors_nn_1_N : N ;
  maktcentrum_nn_1_N : N ;
  makroklimat_nn_1_N : N ;
  majsoel_nn_1_1_N : N ;
  majestaet_nn_1_1_N : N ;
  mahognylaminat_nn_1_N : N ;
  mahognyfan_er_nn_1_1_N : N ;
  magplask_nn_1_N : N ;
  magnesiumhus_nn_1_N : N ;
  loevtraed_nn_1_1_N : N ;
  loesbladssystem_nn_1_1_N : N ;
  loenesystem_nn_1_1_N : N ;
  laatgaasystem_nn_1_1_N : N ;
  laangpass_nn_1_1_N : N ;
  laanghus_nn_1_1_N : N ;
  laagpris_nn_1_1_N : N ;
  laaghus_nn_1_1_N : N ;
  laettoel_nn_1_1_N : N ;
  laesglas_nn_1_1_N : N ;
  laesbarhetsindex_nn_1_1_N : N ;
  laerlingssystem_nn_1_1_N : N ;
  laerktraed_nn_1_1_N : N ;
  laensresidens_nn_1_1_N : N ;
  laekarhus_nn_1_1_N : N ;
  laedertyg_nn_1_1_N : N ;
  laeckageproblem_nn_1_1_N : N ;
  lyxproblem_nn_1_N : N ;
  lystergarn_nn_1_N : N ;
  lysozym_nn_1_N : N ;
  lyktglas_nn_1_N : N ;
  lyckorus_nn_1_N : N ;
  lyckorecept_nn_1_N : N ;
  lyckokast_nn_1_N : N ;
  lusthus_nn_1_N : N ;
  lustcentrum_nn_1_N : N ;
  luntlaas_nn_1_1_N : N ;
  lungoedem_nn_1_1_N : N ;
  luftperspektiv_nn_1_N : N ;
  luftkonditioneringssystem_nn_1_N : N ;
  lokus_nn_1_N : N ;
  lokomotiv_nn_1_N : N ;
  logglas_nn_1_N : N ;
  loggertsegel_nn_1_N : N ;
  logaritmsystem_nn_1_N : N ;
  lockpris_nn_1_N : N ;
  ljuskvantum_nn_1_N : N ;
  ljus_nn_1_N : N ;
  ljudsystem_nn_1_N : N ;
  lix_nn_1_N : N ;
  livstraed_nn_1_1_N : N ;
  livspussel_nn_1_N : N ;
  livsproblem_nn_1_N : N ;
  lipom_nn_1_N : N ;
  linssystem_nn_1_N : N ;
  linjespektrum_nn_1_N : N ;
  lingarn_nn_1_N : N ;
  lillsyskon_nn_1_N : N ;
  lillasyskon_nn_1_N : N ;
  likoerglas_nn_1_1_N : N ;
  lexikon_nn_1_N : N ;
  lexem_nn_1_N : N ;
  lerras_nn_1_N : N ;
  lerkrus_nn_1_N : N ;
  legitimitetsproblem_nn_1_N : N ;
  ledsegel_nn_1_N : N ;
  ledmotiv_nn_1_N : N ;
  ledbrosk_nn_1_N : N ;
  led_nn_2_N : N ;
  laxyngel_nn_1_N : N ;
  laxativ_nn_1_N : N ;
  latinsegel_nn_1_N : N ;
  lastbilslass_nn_1_N : N ;
  lass_nn_1_N : N ;
  lappkast_nn_1_N : N ;
  landshoevdingehus_nn_1_1_N : N ;
  landsarkiv_nn_1_N : N ;
  lamm_nn_2_N : N ;
  lamellhus_nn_1_N : N ;
  lagfartsbevis_nn___N : N ;
  lageroel_nn_1_1_N : N ;
  lackmustest_nn_1_N : N ;
  lack_nn_1_N : N ;
  laboratorieexperiment_nn_1_N : N ;
  koersbaerstraed_nn_1_1_N : N ;
  koersbaersfan_er_nn_1_1_N : N ;
  koepcentrum_nn_1_1_N : N ;
  koenshormon_nn_1_1_N : N ;
  kaarhus_nn_1_1_N : N ;
  kaex_nn_1_1_N : N ;
  kaernvapenprov_nn_1_1_N : N ;
  kaernhus_nn_1_1_N : N ;
  kaerleksmums_nn_1_1_N : N ;
  kaerlekslaas_nn_1_1_N : N ;
  kyskhetslaas_nn_1_1_N : N ;
  kylhus_nn_1_N : N ;
  kvittentraed_nn_1_1_N : N ;
  kvinns_nn_1_N : N ;
  kvinnohus_nn_1_N : N ;
  kvinnobroest_nn_1_1_N : N ;
  kvartssekel_nn_1_N : N ;
  kvantum_nn_1_N : N ;
  kvadratmeterpris_nn_1_N : N ;
  kurirpass_nn_1_N : N ;
  kurhus_nn_1_N : N ;
  kungsljus_nn_1_N : N ;
  kungaresidens_nn_1_N : N ;
  kungahus_nn_1_N : N ;
  kundnoejdhetsindex_nn_1_1_N : N ;
  kummel_nn_1_N : N ;
  kulturhus_nn_1_N : N ;
  kulturcentrum_nn_1_N : N ;
  kullsyskon_nn_1_N : N ;
  kraas_nn_2_1_N : N ;
  kraeftkalas_nn_1_1_N : N ;
  kryss_nn_1_N : N ;
  krypin_nn_1_N : N ;
  krux_nn_1_N : N ;
  krus_nn_1_N : N ;
  krukgods_nn_1_N : N ;
  krucifix_nn_1_N : N ;
  kromat_nn_1_N : N ;
  kristallsystem_nn_1_N : N ;
  kristallglas_nn_1_N : N ;
  kreditiv_nn_1_N : N ;
  krax_nn_1_N : N ;
  krakel_nn_1_N : N ;
  kraftcentrum_nn_1_N : N ;
  kosmos_nn_1_N : N ;
  korus_nn_1_N : N ;
  korum_nn_1_N : N ;
  korthus_nn_1_N : N ;
  korsvirkeshus_nn_1_N : N ;
  kors_nn_1_N : N ;
  korridorsystem_nn_1_N : N ;
  korrektiv_nn_1_N : N ;
  koppel_nn_1_N : N ;
  koordinatsystem_nn_1_N : N ;
  kooperativ_nn_1_N : N ;
  konversationslexikon_nn_1_N : N ;
  konungahus_nn_1_N : N ;
  kontorshus_nn_1_N : N ;
  kontinuum_nn_1_N : N ;
  konsumentprisindex_nn_1_N : N ;
  konsumentpris_nn_1_N : N ;
  konstruktionslexikon_nn_1_N : N ;
  konstgraes_nn_1_1_N : N ;
  konsonantsystem_nn_1_N : N ;
  konserthus_nn_1_N : N ;
  konfliktvarsel_nn_1_N : N ;
  kondis_nn_1_N : N ;
  koncept_nn_1_N : N ;
  komplex_nn_1_N : N ;
  kompletteringstest_nn_1_N : N ;
  komplementsystem_nn_1_N : N ;
  kompasshus_nn_1_N : N ;
  kommunalhus_nn_1_N : N ;
  kombinationslaas_nn_1_1_N : N ;
  kollokat_nn_1_N : N ;
  kollektivhus_nn_1_N : N ;
  kollektiv_nn_1_N : N ;
  kolhydrat_nn_1_N : N ;
  kolatraed_nn_1_1_N : N ;
  kol_nn_1_N : N ;
  kodlaas_nn_1_1_N : N ;
  knytkalas_nn_1_N : N ;
  knyst_nn_1_N : N ;
  knott_nn_1_N : N ;
  klaettertraed_nn_1_1_N : N ;
  klys_nn_1_N : N ;
  klorat_nn_1_N : N ;
  klipptempel_nn_1_N : N ;
  klippmassiv_nn_1_N : N ;
  klippljus_nn_1_N : N ;
  klinhus_nn_1_N : N ;
  klimatsystem_nn_1_N : N ;
  klimatalarm_nn_1_N : N ;
  klicklaas_nn_1_1_N : N ;
  klenhus_nn_1_N : N ;
  klatratkomplex_nn_1_N : N ;
  kilopris_nn_1_N : N ;
  kex_nn_1_N : N ;
  kedjehus_nn_1_N : N ;
  kautschuktraed_nn_1_1_N : N ;
  katalogpris_nn_1_N : N ;
  kasus_nn_1_N : N ;
  kastanjetraed_nn_1_1_N : N ;
  kast_nn_2_N : N ;
  kassakreditiv_nn_1_N : N ;
  karriaertips_nn_1_1_N : N ;
  karnapp_nn_1_N : N ;
  karnap_nn_1_N : N ;
  karcinom_nn_1_N : N ;
  karbonat_nn_1_N : N ;
  karat_nn_1_N : N ;
  kapitael_nn_1_1_N : N ;
  kapitel_nn_1_N : N ;
  kannbrosk_nn_1_N : N ;
  kanalsystem_nn_1_N : N ;
  kanalljus_nn_1_N : N ;
  kampeschtraed_nn_1_1_N : N ;
  kampegraes_nn_1_1_N : N ;
  kamerastativ_nn_1_N : N ;
  kameraobjektiv_nn_1_N : N ;
  kallhus_nn_1_N : N ;
  kalas_nn_1_N : N ;
  kakelfix_nn_1_N : N ;
  kakel_nn_1_N : N ;
  kakaotraed_nn_1_1_N : N ;
  kaffetraed_nn_1_1_N : N ;
  kaffekalas_nn_1_N : N ;
  kaffehus_nn_1_N : N ;
  kadersystem_nn_1_N : N ;
  kabinettspass_nn_1_N : N ;
  jaevulskap_nn_1_1_N : N ;
  jaevelskap_nn_1_1_N : N ;
  jaetteplask_nn_1_1_N : N ;
  jaettekast_nn_1_1_N : N ;
  jaetteexperiment_nn_1_1_N : N ;
  jaestextrakt_nn_1_1_N : N ;
  jaernvaegsstaengsel_nn_1_1_N : N ;
  jaernkors_nn_1_1_N : N ;
  jaemfoerpris_nn_1_1_N : N ;
  jungfrubroest_nn_1_1_N : N ;
  julmys_nn_1_N : N ;
  julmotiv_nn_1_N : N ;
  julljus_nn_1_N : N ;
  julklappstips_nn_1_N : N ;
  julgransljus_nn_1_N : N ;
  juleljus_nn_1_N : N ;
  jordagods_nn_1_N : N ;
  johannitkors_nn_1_N : N ;
  johanniterkors_nn_1_N : N ;
  isooktan_nn_1_N : N ;
  isolerglas_nn_1_N : N ;
  isolat_nn_1_N : N ;
  irrbloss_nn_1_N : N ;
  invektiv_nn_1_N : N ;
  intervjuoffer_nn_1_N : N ;
  intervall_nn_1_N : N ;
  internetforum_nn_1_N : N ;
  interimsbevis_nn_1_N : N ;
  intelligenstest_nn_1_N : N ;
  insegel_nn_1_N : N ;
  inresevisum_nn_1_N : N ;
  inpass_nn_1_N : N ;
  inkoepspris_nn_1_1_N : N ;
  inkomstintervall_nn_1_N : N ;
  inkast_nn_1_N : N ;
  initiativ_nn_1_N : N ;
  infix_nn_1_N : N ;
  individ_nn_1_N : N ;
  index_nn_1_N : N ;
  imperativ_nn_2_N : N ;
  id_espektrum_nn_1_1_N : N ;
  idiom_nn_1_N : N ;
  i_nn_1_N : N ;
  hoernhus_nn_1_1_N : N ;
  hoenshus_nn_1_1_N : N ;
  hoens_nn_1_1_N : N ;
  hoeghus_nn_1_1_N : N ;
  haarkors_nn_1_1_N : N ;
  haestlass_nn_1_1_N : N ;
  haenglaas_nn_1_1_N : N ;
  haengbroest_nn_1_1_N : N ;
  haemtpris_nn_1_1_N : N ;
  haelsningsritual_nn_1_1_N : N ;
  haeftplaaster_nn_1_1_N : N ;
  hyss_nn_1_N : N ;
  hyreshus_nn_1_N : N ;
  hypofyshormon_nn_1_N : N ;
  hydrat_nn_1_N : N ;
  huvudmotiv_nn_1_N : N ;
  husras_nn_1_N : N ;
  huskors_nn_1_N : N ;
  husbloss_nn_1_N : N ;
  hus_nn_1_N : N ;
  hundkaex_nn_2_1_N : N ;
  hundkex_nn_1_N : N ;
  hotellkomplex_nn_1_N : N ;
  host_nn_2_N : N ;
  hospits_nn_1_N : N ;
  hospis_nn_1_N : N ;
  hormonsystem_nn_1_N : N ;
  hormon_nn_1_N : N ;
  horisontproblem_nn_1_N : N ;
  horhus_nn_1_N : N ;
  hjullaas_nn_1_1_N : N ;
  hjulkors_nn_1_N : N ;
  hjulhus_nn_1_N : N ;
  hjortron_nn_1_N : N ;
  hindutempel_nn_1_N : N ;
  hemvist_nn_1_N : N ;
  hemlighus_nn_1_N : N ;
  helsyskon_nn_1_N : N ;
  helljus_nn_1_N : N ;
  hektar_nn_1_N : N ;
  hednatempel_nn_1_N : N ;
  hederspris_nn_1_N : N ;
  havsmotiv_nn_1_N : N ;
  harnesk_nn_1_N : N ;
  handlingsalternativ_nn_1_N : N ;
  handlexikon_nn_1_N : N ;
  handelshus_nn_1_N : N ;
  handeksem_nn_1_N : N ;
  halvsyskon_nn_1_N : N ;
  halvsekel_nn_1_N : N ;
  halvmaraton_nn_1_N : N ;
  halvljus_nn_1_N : N ;
  halvgraes_nn_1_1_N : N ;
  halskraas_nn_1_1_N : N ;
  halsbloss_nn_1_N : N ;
  hakkors_nn_1_N : N ;
  hagel_nn_1_N : N ;
  goet_nn_2_1_N : N ;
  gaasbroest_nn_1_1_N : N ;
  gaardstraed_nn_1_1_N : N ;
  gaardshus_nn_1_1_N : N ;
  gaerdsel_nn_1_1_N : N ;
  gymnastikhus_nn_1_N : N ;
  gurgel_nn_1_N : N ;
  gunstbevis_nn_1_N : N ;
  gummitraed_nn_1_1_N : N ;
  guldpris_nn_1_N : N ;
  gudstjaenstritual_nn_1_1_N : N ;
  gudsbevis_nn_1_N : N ;
  gubbtraesk_nn_1_1_N : N ;
  gubbhus_nn_1_N : N ;
  graes_nn_1_1_N : N ;
  graendhus_nn_1_1_N : N ;
  gryn_nn_1_N : N ;
  gruvras_nn_1_N : N ;
  gruvoffer_nn_1_N : N ;
  grupptest_nn_1_N : N ;
  grupphus_nn_1_N : N ;
  grossistpris_nn_1_N : N ;
  gross_nn_1_N : N ;
  grodyngel_nn_1_N : N ;
  grenljus_nn_1_N : N ;
  gravroes_nn_1_1_N : N ;
  gravkummel_nn_1_N : N ;
  graviditetstest_nn_1_N : N ;
  granatsplitter_nn_1_N : N ;
  grammofonarkiv_nn_1_N : N ;
  grafem_nn_1_N : N ;
  gotlandsruss_nn_1_N : N ;
  gomsegel_nn_1_N : N ;
  gods_nn_1_N : N ;
  gobelaengtyg_nn_1_1_N : N ;
  gloeggtest_nn_1_1_N : N ;
  glaedjerus_nn_1_1_N : N ;
  glaedjehus_nn_1_1_N : N ;
  glutamat_nn_1_N : N ;
  glossar_nn_1_N : N ;
  glashus_nn_1_N : N ;
  glas_nn_1_N : N ;
  gissel_nn_1_N : N ;
  georgskors_nn_1_N : N ;
  genusperspektiv_nn_1_N : N ;
  genus_nn_1_N : N ;
  gelaenk_nn_1_1_N : N ;
  gavelroest_nn_1_1_N : N ;
  gavelhus_nn_1_N : N ;
  gatupris_nn_1_N : N ;
  gatukors_nn_1_N : N ;
  gatuhus_nn_1_N : N ;
  gathus_nn_1_N : N ;
  garn_nn_1_N : N ;
  garantibevis_nn_1_N : N ;
  ganglion_nn_1_N : N ;
  galaxspektrum_nn_1_N : N ;
  galaxcentrum_nn_1_N : N ;
  gag_nn_1_N : N ;
  gaffelsegel_nn_1_N : N ;
  foeraeldratraed_nn_1_1_N : N ;
  foertroendevotum_nn_1_1_N : N ;
  foersaeljningspris_nn_1_1_N : N ;
  foersaeljningsled_nn_1_1_N : N ;
  foersaekringssystem_nn_1_1_N : N ;
  foerstoringsglas_nn_1_1_N : N ;
  foerstahandsalternativ_nn_1_1_N : N ;
  foersoningsoffer_nn_1_1_N : N ;
  foersegel_nn_1_1_N : N ;
  foersamlingshus_nn_1_1_N : N ;
  foerraadshus_nn_1_1_N : N ;
  foerled_nn_1_1_N : N ;
  foerlagsbevis_nn_1_1_N : N ;
  foeregaangsexempel_nn_1_1_N : N ;
  foensterglas_nn_1_1_N : N ;
  foeljdproblem_nn_1_1_N : N ;
  faarhus_nn_1_1_N : N ;
  faagelperspektiv_nn_1_1_N : N ;
  faerskoel_nn_1_1_N : N ;
  faergspektrum_nn_1_1_N : N ;
  faerdbevis_nn_1_1_N : N ;
  faengsel_nn_1_1_N : N ;
  faeltsjukhus_nn_1_1_N : N ;
  faelthoens_nn_1_1_N : N ;
  faelgkors_nn_1_1_N : N ;
  faehus_nn_1_1_N : N ;
  fyrljus_nn_1_N : N ;
  fyravaaningshus_nn_1_1_N : N ;
  fyndpris_nn_1_N : N ;
  furstehus_nn_1_N : N ;
  fullblodsproffs_nn_1_N : N ;
  froetraed_nn_1_1_N : N ;
  froehus_nn_1_1_N : N ;
  fraagetest_nn_1_1_N : N ;
  fraemlingspass_nn_1_1_N : N ;
  fraelsegods_nn_1_1_N : N ;
  frystest_nn_1_N : N ;
  frukttraed_nn_1_1_N : N ;
  fritis_nn_1_N : N ;
  fritidsproblem_nn_1_N : N ;
  fritidshus_nn_1_N : N ;
  fripass_nn_1_N : N ;
  frikast_nn_1_N : N ;
  fredspris_nn_1_N : N ;
  fredagsoel_nn_1_1_N : N ;
  fredagsmys_nn_1_N : N ;
  fotopris_nn_1_N : N ;
  fotbollstips_nn_1_N : N ;
  fostertest_nn_1_N : N ;
  fostersyskon_nn_1_N : N ;
  fossil_nn_1_N : N ;
  fosfat_nn_1_N : N ;
  forum_nn_1_N : N ;
  formbildningsproblem_nn_1_N : N ;
  fonem_nn_1_N : N ;
  folkoel_nn_1_1_N : N ;
  fniss_nn_1_N : N ;
  fnask_nn_1_N : N ;
  flyttlass_nn_1_N : N ;
  flygkaos_nn_1_N : N ;
  flodsystem_nn_1_N : N ;
  flintlaas_nn_1_1_N : N ;
  flervaaningshus_nn_1_1_N : N ;
  flervalstest_nn_1_N : N ;
  flerpartisystem_nn_1_N : N ;
  flerfamiljshus_nn_1_N : N ;
  flerbostadshus_nn_1_N : N ;
  fjaerrvaermepris_nn_1_1_N : N ;
  fjaellpanelshus_nn_1_1_N : N ;
  fjolaarsgraes_nn_1_1_N : N ;
  fixativ_nn_1_N : N ;
  fix_nn_2_N : N ;
  fiskyngel_nn_1_N : N ;
  filosofem_nn_1_N : N ;
  filigran_nn_1_N : N ;
  fikontraed_nn_1_1_N : N ;
  fideikommiss_nn_1_N : N ;
  fibrin_nn_1_N : N ;
  fi_nn_1_N : N ;
  fermat_nn_1_N : N ;
  fax_nn_2_N : N ;
  fattighus_nn_1_N : N ;
  fattigdomsbevis_nn_1_N : N ;
  fastlagsris_nn_1_N : N ;
  fastighetspris_nn_1_N : N ;
  fastighetsindex_nn_1_N : N ;
  fasadtegel_nn_1_N : N ;
  fantom_nn_1_N : N ;
  familjemys_nn_1_N : N ;
  familjegods_nn_1_N : N ;
  familjearkiv_nn_1_N : N ;
  falsklarm_nn_1_N : N ;
  falskalarm_nn_1_N : N ;
  faktum_nn_1_N : N ;
  faderskomplex_nn_1_N : N ;
  fadershus_nn_1_N : N ;
  fabrikspris_nn_1_N : N ;
  extrapris_nn_1_N : N ;
  extraljus_nn_1_N : N ;
  extrakt_nn_1_N : N ;
  exlibris_nn_1_N : N ;
  existensminimum_nn_1_N : N ;
  exempel_nn_1_N : N ;
  exantem_nn_1_N : N ;
  ex_nn_1_N : N ;
  ess_nn_1_N : N ;
  epsilon_nn_1_N : N ;
  epos_nn_1_N : N ;
  epidemisjukhus_nn_1_N : N ;
  epicentrum_nn_1_N : N ;
  enzymsystem_nn_1_N : N ;
  enzym_nn_1_N : N ;
  envaaningshus_nn_1_1_N : N ;
  enris_nn_1_N : N ;
  enplanshus_nn_1_N : N ;
  enkammarsystem_nn_1_N : N ;
  enhetspris_nn_1_N : N ;
  enfamiljshus_nn_1_N : N ;
  energisystem_nn_1_N : N ;
  energiomvandlingscentrum_nn_1_N : N ;
  energialternativ_nn_1_N : N ;
  empyem_nn_1_N : N ;
  emfysem_nn_1_N : N ;
  emblem_nn_1_N : N ;
  elstaengsel_nn_1_1_N : N ;
  eldsljus_nn_1_N : N ;
  eldhus_nn_1_N : N ;
  eksem_nn_1_N : N ;
  ekosystem_nn_1_N : N ;
  eftermiddagspass_nn_1_N : N ;
  efterled_nn_1_N : N ;
  efteraccept_nn_1_N : N ;
  ebolavirus_nn_1_N : N ;
  doerrlaas_nn_1_1_N : N ;
  doedsoffer_nn_1_1_N : N ;
  doedsbevis_nn_1_1_N : N ;
  daarhus_nn_1_1_N : N ;
  daecker_nn_1_1_N : N ;
  dyn_nn_2_N : N ;
  duralexglas_nn_1_N : N ;
  duodecimalsystem_nn_1_N : N ;
  dunder_nn_1_N : N ;
  dubbelstjaernsystem_nn_1_1_N : N ;
  dryckesoffer_nn_1_N : N ;
  dryck_nn_2_N : N ;
  druvhagel_nn_1_N : N ;
  droppglas_nn_1_N : N ;
  drogtest_nn_1_N : N ;
  drivhus_nn_1_N : N ;
  dricksglas_nn_1_N : N ;
  drakblodstraed_nn_1_1_N : N ;
  dragplaaster_nn_1_1_N : N ;
  dopningspreparat_nn_1_N : N ;
  dopingpreparat_nn_1_N : N ;
  domkapitel_nn_1_N : N ;
  dokumentkreditiv_nn_1_N : N ;
  doftljus_nn_1_N : N ;
  dna_test_nn_1_N : N ;
  djaevulskap_nn_1_1_N : N ;
  djaevelskap_nn_1_1_N : N ;
  djursjukhus_nn_1_N : N ;
  divertissemang_nn_1_N : N ;
  distikon_nn_1_N : N ;
  diskussionsforum_nn_1_N : N ;
  direktiv_nn_1_N : N ;
  diplomatpass_nn_1_N : N ;
  dinatriumvaetefosfat_nn_1_1_N : N ;
  dimljus_nn_1_N : N ;
  diffraktionsspektrum_nn_1_N : N ;
  diapositiv_nn_1_N : N ;
  diadem_nn_1_N : N ;
  detaljpris_nn_1_N : N ;
  depositionsbevis_nn_1_N : N ;
  delikt_nn_1_N : N ;
  dejtingtips_nn_1_N : N ;
  deficit_nn_1_N : N ;
  decimalsystem_nn_1_N : N ;
  debutalbum_nn_1_N : N ;
  datorvirus_nn_1_N : N ;
  datorsystem_nn_1_N : N ;
  datavirus_nn_1_N : N ;
  datalagringsdirektiv_nn_1_N : N ;
  dass_nn_1_N : N ;
  dagis_nn_1_N : N ;
  dagenefterpiller_nn_1_N : N ;
  dagcentrum_nn_1_N : N ;
  cylinderlaas_nn_1_1_N : N ;
  cykellaas_nn_1_1_N : N ;
  creepegarn_nn_1_1_N : N ;
  cocktailglas_nn_1_N : N ;
  clips_nn_1_N : N ;
  cityljus_nn_1_N : N ;
  citrontraed_nn_1_1_N : N ;
  ciss_nn_1_N : N ;
  cirkelbevis_nn_1_N : N ;
  cirkapris_nn_1_N : N ;
  choklad_nn_2_N : N ;
  chips_nn_1_N : N ;
  chip_nn_1_N : N ;
  chiffer_nn_1_N : N ;
  chi_nn_1_N : N ;
  changemang_nn_1_N : N ;
  champagneglas_nn_1_N : N ;
  cerat_nn_1_N : N ;
  centrum_nn_1_N : N ;
  cenakel_nn_1_N : N ;
  cellulosanitrat_nn_1_N : N ;
  cellulosalack_nn_1_N : N ;
  cellprov_nn_1_N : N ;
  cellmembran_nn_1_N : N ;
  celibat_nn_1_N : N ;
  campus_nn_1_N : N ;
  boersras_nn_1_1_N : N ;
  boerskaos_nn_1_1_N : N ;
  boenhus_nn_1_1_N : N ;
  boenehus_nn_1_1_N : N ;
  baathus_nn_1_1_N : N ;
  baas_nn_1_1_N : N ;
  baarhus_nn_1_1_N : N ;
  byhus_nn_1_N : N ;
  byggvaruhus_nn_1_N : N ;
  byggpass_nn_1_N : N ;
  byggnadskreditiv_nn_1_N : N ;
  byggnadskomplex_nn_1_N : N ;
  bygellaas_nn_1_1_N : N ;
  burhoens_nn_1_1_N : N ;
  budgetalternativ_nn_1_N : N ;
  broest_nn_1_1_N : N ;
  braennvinsglas_nn_1_1_N : N ;
  braennoffer_nn_1_1_N : N ;
  braennglas_nn_1_1_N : N ;
  braennbollskast_nn_1_1_N : N ;
  brytningsindex_nn_1_N : N ;
  brygghus_nn_1_N : N ;
  bruttopris_nn_1_N : N ;
  brunnshus_nn_1_N : N ;
  brunchtest_nn_1_N : N ;
  bruckel_nn_1_N : N ;
  brottsoffer_nn_1_N : N ;
  brosk_nn_1_N : N ;
  brons_nn_2_N : N ;
  bromssystem_nn_1_N : N ;
  bromsljus_nn_1_N : N ;
  brohus_nn_1_N : N ;
  briggsegel_nn_1_N : N ;
  brevinkast_nn_1_N : N ;
  brandsegel_nn_1_N : N ;
  brandoffer_nn_1_N : N ;
  brandlarm_nn_1_N : N ;
  brandalarm_nn_1_N : N ;
  bramsegel_nn_1_N : N ;
  bostadspris_nn_1_N : N ;
  bostadshus_nn_1_N : N ;
  boskapsstaengsel_nn_1_1_N : N ;
  borstgraes_nn_1_1_N : N ;
  borst_nn_1_N : N ;
  borgarhus_nn_1_N : N ;
  bordlaeggningsplenum_nn_1_1_N : N ;
  bopris_nn_1_N : N ;
  bonussystem_nn_1_N : N ;
  bonmot_nn_1_N : N ;
  boningshus_nn_1_N : N ;
  bondkalas_nn_1_N : N ;
  bomullstyg_nn_1_N : N ;
  bomullsgarn_nn_1_N : N ;
  bomsegel_nn_1_N : N ;
  bombsplitter_nn_1_N : N ;
  bomboffer_nn_1_N : N ;
  bollhus_nn_1_N : N ;
  blaabaersris_nn_1_1_N : N ;
  blyhagel_nn_1_N : N ;
  blyacetat_nn_1_N : N ;
  bloss_nn_1_N : N ;
  blodsystem_nn_1_N : N ;
  blodprov_nn_1_N : N ;
  blocksystem_nn_1_N : N ;
  blockhus_nn_1_N : N ;
  blixtlaas_nn_1_1_N : N ;
  blinkljus_nn_1_N : N ;
  bjoernbindsel_nn_1_1_N : N ;
  bjoerkris_nn_1_1_N : N ;
  biyngel_nn_1_N : N ;
  bits_nn_1_N : N ;
  biskopskors_nn_1_N : N ;
  binom_nn_1_N : N ;
  bindsel_nn_1_N : N ;
  bilspackel_nn_1_N : N ;
  billaas_nn_1_1_N : N ;
  billjus_nn_1_N : N ;
  biljettpris_nn_1_N : N ;
  biljardbollsuniversum_nn_1_N : N ;
  bildkryss_nn_1_N : N ;
  bihus_nn_1_N : N ;
  bifokalglas_nn_1_N : N ;
  bidragsfusk_nn_1_N : N ;
  bidevindsegel_nn_1_N : N ;
  bevis_nn_1_N : N ;
  bevattningssystem_nn_1_N : N ;
  betsel_nn_1_N : N ;
  betalningsbevis_nn_1_N : N ;
  beslutskaos_nn_1_N : N ;
  beroendeproblem_nn_1_N : N ;
  bergsmassiv_nn_1_N : N ;
  bensinpris_nn_1_N : N ;
  benrangel_nn_1_N : N ;
  benlaas_nn_1_1_N : N ;
  benhus_nn_1_N : N ;
  benbrosk_nn_1_N : N ;
  beloeningssystem_nn_1_1_N : N ;
  behoerighetsbevis_nn_1_1_N : N ;
  behandlingsalternativ_nn_1_N : N ;
  begreppssystem_nn_1_N : N ;
  begravningskalas_nn_1_N : N ;
  bast_nn_2_N : N ;
  basketproffs_nn_1_N : N ;
  barrtraed_nn_1_1_N : N ;
  barockpalats_nn_1_N : N ;
  barnsjukhus_nn_1_N : N ;
  barnkalas_nn_1_N : N ;
  barnhus_nn_1_N : N ;
  barndomsparadis_nn_1_N : N ;
  barnboerdshus_nn_1_1_N : N ;
  bariumsulfat_nn_1_N : N ;
  barbiturat_nn_1_N : N ;
  bankpalats_nn_1_N : N ;
  bankkapital_nn_1_N : N ;
  bankhus_nn_1_N : N ;
  bandspektrum_nn_1_N : N ;
  banantraed_nn_1_1_N : N ;
  ballongsegel_nn_1_N : N ;
  bakrus_nn_1_N : N ;
  bakljus_nn_1_N : N ;
  badrumskakel_nn_1_N : N ;
  badhus_nn_1_N : N ;
  ax_nn_1_N : N ;
  avskedskalas_nn_1_N : N ;
  avloppssystem_nn_1_N : N ;
  atomspektrum_nn_1_N : N ;
  associationslexikon_nn_1_N : N ;
  ass_nn_1_N : N ;
  as_nn_1_N : N ;
  arsel_nn_1_N : N ;
  aromglas_nn_1_N : N ;
  armlaas_nn_1_1_N : N ;
  armborst_nn_1_N : N ;
  arkiv_nn_1_N : N ;
  arboretum_nn_1_N : N ;
  arbetsprov_nn_1_N : N ;
  arbetsplenum_nn_1_N : N ;
  arbetspass_nn_1_N : N ;
  arbetsminnestest_nn_1_N : N ;
  arbetshus_nn_1_N : N ;
  ar_nn_1_N : N ;
  appendix_nn_1_N : N ;
  appellativ_nn_1_N : N ;
  apelsintraed_nn_1_1_N : N ;
  apbroedstraed_nn_1_1_N : N ;
  antisladdsystem_nn_1_N : N ;
  antikljus_nn_1_N : N ;
  annex_nn_1_N : N ;
  anlagstest_nn_1_N : N ;
  ankbroest_nn_1_1_N : N ;
  ankarklys_nn_1_N : N ;
  andreaskors_nn_1_N : N ;
  andningsenzym_nn_1_N : N ;
  analogibevis_nn_1_N : N ;
  amalgam_nn_1_N : N ;
  alternativ_nn_1_N : N ;
  altarkors_nn_1_N : N ;
  allergen_nn_1_N : N ;
  alkotest_nn_1_N : N ;
  alkolaas_nn_1_1_N : N ;
  alkoholtest_nn_1_N : N ;
  alfkors_nn_1_N : N ;
  album_nn_1_N : N ;
  aktningsbevis_nn_1_N : N ;
  aktiekapital_nn_1_N : N ;
  akrostikon_nn_1_N : N ;
  agnborst_nn_1_N : N ;
  affaerscentrum_nn_1_1_N : N ;
  affix_nn_1_N : N ;
  adventsmys_nn_1_N : N ;
  adjektiv_nn_1_N : N ;
  adhd_symtom_nn_1_N : N ;
  adelsgods_nn_1_N : N ;
  additiv_nn_1_N : N ;
  acetat_nn_1_N : N ;
  accept_nn_1_N : N ;
  acceleratorsystem_nn_1_N : N ;
  Yalelaas_nn_1_1_N : N ;
  MAO_enzym_nn_1_N : N ;
  Kremldirektiv_nn_1_N : N ;
  Ikeavaruhus_nn_1_N : N ;
  DNA_test_nn_1_N : N ;
  Antarktisprojekt_nn_1_N : N ;
  ADHD_symtom_nn_1_N : N ;
  AT_laekare_nn_1_1_N : N ;
  CD_spelare_nn_1_N : N ;
  DVD_spelare_nn_1_N : N ;
  Goeteborgsmaalare_nn_1_1_N : N ;
  MP3_spelare_nn_1_N : N ;
  Moskvaborgmaestare_nn_1_1_N : N ;
  Stureplansmoerdare_nn_1_1_N : N ;
  TV_mottagare_nn_1_N : N ;
  TV_saendare_nn_1_1_N : N ;
  TV_tittare_nn_1_N : N ;
  abortmotstaandare_nn_1_1_N : N ;
  affischpelare_nn_1_N : N ;
  aktieaegare_nn_1_1_N : N ;
  akvarellmaalare_nn_1_1_N : N ;
  alfoerraedare_nn_1_1_N : N ;
  alkoholmissbrukare_nn_1_N : N ;
  allmaenlaekare_nn_1_1_N : N ;
  allsaangsledare_nn_1_1_N : N ;
  allvetare_nn_1_N : N ;
  allaetare_nn_1_1_N : N ;
  alpjaegare_nn_1_1_N : N ;
  alstrare_nn_1_N : N ;
  amatoerforskare_nn_1_1_N : N ;
  amatoersaendare_nn_1_1_N : N ;
  ambassadsekreterare_nn_1_N : N ;
  ambulansfoerare_nn_1_1_N : N ;
  ambulanssjukskoetare_nn_1_1_N : N ;
  ambulanssjukvaardare_nn_1_1_N : N ;
  amerikanare_nn_1_N : N ;
  amningsmobbare_nn_1_N : N ;
  anbudsgivare_nn_1_N : N ;
  andebesvaerjare_nn_1_1_N : N ;
  andeskaadare_nn_1_1_N : N ;
  andeutdrivare_nn_1_N : N ;
  andraklasspassagerare_nn_1_N : N ;
  anfallare_nn_1_N : N ;
  anfallsspelare_nn_1_N : N ;
  anfoerare_nn_1_1_N : N ;
  angelsachsare_nn_1_N : N ;
  angelsaxare_nn_1_N : N ;
  angivare_nn_1_N : N ;
  anglosachsare_nn_1_N : N ;
  anglosaxare_nn_1_N : N ;
  angripare_nn_1_N : N ;
  anhaengare_nn_1_1_N : N ;
  anklagare_nn_1_N : N ;
  anlagsbaerare_nn_1_1_N : N ;
  anlaeggare_nn_1_1_N : N ;
  anlaeggningsarbetare_nn_1_1_N : N ;
  anmaelare_nn_1_1_N : N ;
  anmaerkare_nn_1_1_N : N ;
  annonspelare_nn_1_N : N ;
  anordnare_nn_1_N : N ;
  anskaffare_nn_1_N : N ;
  anstiftare_nn_1_N : N ;
  anstrykare_nn_1_N : N ;
  anstaellare_nn_1_1_N : N ;
  antecknare_nn_1_N : N ;
  antikvitetshandlare_nn_1_N : N ;
  anvisningslaekare_nn_1_1_N : N ;
  anvaendare_nn_1_1_N : N ;
  apotekare_nn_1_N : N ;
  aptitretare_nn_1_N : N ;
  arbetare_nn_1_N : N ;
  arbetarvaeljare_nn_1_1_N : N ;
  arbetsfoermedlare_nn_1_1_N : N ;
  arbetsgivare_nn_1_N : N ;
  arbetskraftsinvandrare_nn_1_N : N ;
  arbetskoepare_nn_1_1_N : N ;
  arbetsledare_nn_1_N : N ;
  arbetstagare_nn_1_N : N ;
  argentinare_nn_1_N : N ;
  arkivarbetare_nn_1_N : N ;
  armbaagsstraeckare_nn_1_1_N : N ;
  artikelfoerfattare_nn_1_1_N : N ;
  arvlaatare_nn_1_1_N : N ;
  arvtagare_nn_1_N : N ;
  asbestarbetare_nn_1_N : N ;
  asaetare_nn_1_1_N : N ;
  atlantaangare_nn_1_1_N : N ;
  atlasspinnare_nn_1_N : N ;
  atmosfaerforskare_nn_1_1_N : N ;
  attackdykare_nn_1_N : N ;
  auktionerare_nn_1_N : N ;
  auktionsfoerraettare_nn_1_1_N : N ;
  auktionsutropare_nn_1_N : N ;
  australiensare_nn_1_N : N ;
  autografjaegare_nn_1_1_N : N ;
  avbitare_nn_1_N : N ;
  avbrytare_nn_1_N : N ;
  avbytare_nn_1_N : N ;
  avdelningslaekare_nn_1_1_N : N ;
  avfuktare_nn_1_N : N ;
  avgudadyrkare_nn_1_N : N ;
  avhoppare_nn_1_N : N ;
  avkylare_nn_1_N : N ;
  avkaennare_nn_1_1_N : N ;
  avlastare_nn_1_N : N ;
  avledare_nn_1_N : N ;
  avloppsrensare_nn_1_N : N ;
  avlaeggare_nn_1_1_N : N ;
  avlaesare_nn_1_1_N : N ;
  avnaemare_nn_1_1_N : N ;
  avskrivare_nn_1_N : N ;
  avskaerare_nn_1_1_N : N ;
  avstickare_nn_1_N : N ;
  avstaengare_nn_1_1_N : N ;
  avstaandsmaetare_nn_1_1_N : N ;
  avsynare_nn_1_N : N ;
  avsaendare_nn_1_1_N : N ;
  avsoekare_nn_1_1_N : N ;
  avtalssekreterare_nn_1_N : N ;
  avtryckare_nn_1_N : N ;
  avtraedare_nn_1_1_N : N ;
  avvikare_nn_1_N : N ;
  avvisare_nn_1_N : N ;
  babblare_nn_1_N : N ;
  bacillbaerare_nn_1_1_N : N ;
  backhoppare_nn_1_N : N ;
  backstugusittare_nn_1_N : N ;
  badare_nn_1_N : N ;
  baddare_nn_1_N : N ;
  badensare_nn_1_N : N ;
  badlaekare_nn_1_1_N : N ;
  bagare_nn_1_N : N ;
  baggboelare_nn_1_1_N : N ;
  bahrainare_nn_1_N : N ;
  bajrare_nn_1_N : N ;
  bakblaasare_nn_1_1_N : N ;
  bakdantare_nn_1_N : N ;
  bakladdare_nn_1_N : N ;
  bakstraevare_nn_1_1_N : N ;
  baktalare_nn_1_N : N ;
  bakaatstraevare_nn_1_1_N : N ;
  balalajkaspelare_nn_1_N : N ;
  balettmaestare_nn_1_1_N : N ;
  balkvaegare_nn_1_1_N : N ;
  banbrytare_nn_1_N : N ;
  bandspelare_nn_1_N : N ;
  banerfoerare_nn_1_1_N : N ;
  bangladeshare_nn_1_N : N ;
  bankomatraanare_nn_1_1_N : N ;
  bankraanare_nn_1_1_N : N ;
  bantamviktare_nn_1_N : N ;
  barberare_nn_1_N : N ;
  barfotalaekare_nn_1_1_N : N ;
  barnamoerdare_nn_1_1_N : N ;
  barnknullare_nn_1_N : N ;
  barnlaekare_nn_1_1_N : N ;
  barnskoetare_nn_1_1_N : N ;
  barnsmugglare_nn_1_N : N ;
  basfiolsfodralsmakare_nn_1_N : N ;
  bassaangare_nn_1_1_N : N ;
  bataljmaalare_nn_1_1_N : N ;
  batteriladdare_nn_1_N : N ;
  batteriprovare_nn_1_N : N ;
  bearbetare_nn_1_N : N ;
  bebyggare_nn_1_N : N ;
  bedragare_nn_1_N : N ;
  bedoemare_nn_1_1_N : N ;
  befattningshavare_nn_1_N : N ;
  befordrare_nn_1_N : N ;
  befraktare_nn_1_N : N ;
  befriare_nn_1_N : N ;
  befraemjare_nn_1_1_N : N ;
  befaelhavare_nn_1_1_N : N ;
  begabbare_nn_1_N : N ;
  behaallare_nn_1_1_N : N ;
  beivrare_nn_1_N : N ;
  bekaempare_nn_1_1_N : N ;
  bekaennare_nn_1_1_N : N ;
  belackare_nn_1_N : N ;
  beledsagare_nn_1_N : N ;
  belgare_nn_1_N : N ;
  benknaeckare_nn_1_1_N : N ;
  beredare_nn_1_N : N ;
  bergbestigare_nn_1_N : N ;
  bergsbestigare_nn_1_N : N ;
  bergsjaegare_nn_1_1_N : N ;
  bergsklaettrare_nn_1_1_N : N ;
  beridare_nn_1_N : N ;
  beraettare_nn_1_1_N : N ;
  besegrare_nn_1_N : N ;
  besittningshavare_nn_1_N : N ;
  beskyddare_nn_1_N : N ;
  beskaellare_nn_1_1_N : N ;
  beskaermare_nn_1_1_N : N ;
  beslagare_nn_1_N : N ;
  beslutfattare_nn_1_N : N ;
  beslutsfattare_nn_1_N : N ;
  bespottare_nn_1_N : N ;
  bestsellerfoerfattare_nn_1_1_N : N ;
  bestaellare_nn_1_1_N : N ;
  besvaerjare_nn_1_1_N : N ;
  besoekare_nn_1_1_N : N ;
  betablockerare_nn_1_N : N ;
  betalare_nn_1_N : N ;
  beteendevetare_nn_1_N : N ;
  beteltuggare_nn_1_N : N ;
  betongblandare_nn_1_N : N ;
  betraktare_nn_1_N : N ;
  bettlare_nn_1_N : N ;
  betvingare_nn_1_N : N ;
  betygkramare_nn_1_N : N ;
  beundrare_nn_1_N : N ;
  bidevindare_nn_1_N : N ;
  bidevindseglare_nn_1_N : N ;
  bidragsfuskare_nn_1_N : N ;
  bidragsgivare_nn_1_N : N ;
  bildammsugare_nn_1_N : N ;
  bildhuggare_nn_1_N : N ;
  bildningsfoeraktare_nn_1_1_N : N ;
  bildsnidare_nn_1_N : N ;
  bildstormare_nn_1_N : N ;
  bilfoerare_nn_1_1_N : N ;
  bilfoersaeljare_nn_1_1_N : N ;
  bilhoegtalare_nn_1_1_N : N ;
  biljettfoersaeljare_nn_1_1_N : N ;
  bilskojare_nn_1_N : N ;
  biltillverkare_nn_1_N : N ;
  bilaegare_nn_1_1_N : N ;
  bindare_nn_1_N : N ;
  biodlare_nn_1_N : N ;
  biograffoerestaandare_nn_1_1_N : N ;
  birfilare_nn_1_N : N ;
  bisittare_nn_1_N : N ;
  bitshaallare_nn_1_1_N : N ;
  biaetare_nn_1_1_N : N ;
  bladminerare_nn_1_N : N ;
  blandare_nn_1_N : N ;
  bleckslagare_nn_1_N : N ;
  blindgaangare_nn_1_1_N : N ;
  blindpassagerare_nn_1_N : N ;
  blockadbrytare_nn_1_N : N ;
  blodgivare_nn_1_N : N ;
  blodledare_nn_1_N : N ;
  blodsugare_nn_1_N : N ;
  bloggare_nn_1_N : N ;
  blomsterhandlare_nn_1_N : N ;
  blottare_nn_1_N : N ;
  bluffmakare_nn_1_N : N ;
  blaecksuddare_nn_1_1_N : N ;
  blaendare_nn_1_1_N : N ;
  blaenkare_nn_1_1_N : N ;
  blaabaersplockare_nn_1_1_N : N ;
  blaasare_nn_1_1_N : N ;
  bloedare_nn_1_1_N : N ;
  bogserare_nn_1_N : N ;
  bokbindare_nn_1_N : N ;
  bokfoerare_nn_1_1_N : N ;
  bokfoerlaeggare_nn_1_1_N : N ;
  bokhandlare_nn_1_N : N ;
  bokhaallare_nn_1_1_N : N ;
  boksamlare_nn_1_N : N ;
  boktryckare_nn_1_N : N ;
  bokaelskare_nn_1_1_N : N ;
  bolagsaegare_nn_1_1_N : N ;
  bolare_nn_1_N : N ;
  bollspelare_nn_1_N : N ;
  bombare_nn_1_N : N ;
  bomullsplockare_nn_1_N : N ;
  bondfaangare_nn_1_1_N : N ;
  bordloepare_nn_1_1_N : N ;
  bordsstudsare_nn_1_N : N ;
  bordstudsare_nn_1_N : N ;
  borgare_nn_1_N : N ;
  borgmaestare_nn_1_1_N : N ;
  borstbindare_nn_1_N : N ;
  borstviskare_nn_1_N : N ;
  boskapsskoetare_nn_1_1_N : N ;
  bostadsraettsinnehavare_nn_1_1_N : N ;
  bosaettare_nn_1_1_N : N ;
  botgoerare_nn_1_1_N : N ;
  bowlare_nn_1_N : N ;
  boxare_nn_1_N : N ;
  brandslaeckare_nn_1_1_N : N ;
  brandvarnare_nn_1_N : N ;
  brasilianare_nn_1_N : N ;
  brastaendare_nn_1_1_N : N ;
  bretagnare_nn_1_N : N ;
  brevbaerare_nn_1_1_N : N ;
  brevskrivare_nn_1_N : N ;
  brevstaellare_nn_1_1_N : N ;
  brevoeppnare_nn_1_1_N : N ;
  brickplockare_nn_1_N : N ;
  bromsare_nn_1_N : N ;
  bropelare_nn_1_N : N ;
  brottare_nn_1_N : N ;
  brukare_nn_1_N : N ;
  bruksarbetare_nn_1_N : N ;
  brukslagare_nn_1_N : N ;
  brummare_nn_1_N : N ;
  bryggare_nn_1_N : N ;
  brytare_nn_1_N : N ;
  braennare_nn_1_1_N : N ;
  braennkammare_nn_1_1_N : N ;
  braennvinsprovare_nn_1_1_N : N ;
  braenslemaetare_nn_1_1_N : N ;
  braensleomvandlare_nn_1_1_N : N ;
  braakmakare_nn_1_1_N : N ;
  broestsimmare_nn_1_1_N : N ;
  bubblare_nn_1_N : N ;
  budbaerare_nn_1_1_N : N ;
  budgeterare_nn_1_N : N ;
  buktalare_nn_1_N : N ;
  bulklastare_nn_1_N : N ;
  bunsenbraennare_nn_1_1_N : N ;
  buntmakare_nn_1_N : N ;
  burgare_nn_1_N : N ;
  burkhaallare_nn_1_1_N : N ;
  burkoeppnare_nn_1_1_N : N ;
  buskoerare_nn_1_1_N : N ;
  busringare_nn_1_N : N ;
  bussfoerare_nn_1_1_N : N ;
  busspassagerare_nn_1_N : N ;
  butiksinnehavare_nn_1_N : N ;
  butiksaegare_nn_1_1_N : N ;
  byggarbetare_nn_1_N : N ;
  byggare_nn_1_N : N ;
  byggmaestare_nn_1_1_N : N ;
  byggnadsarbetare_nn_1_N : N ;
  byggnadssnickare_nn_1_N : N ;
  byraasekreterare_nn_1_1_N : N ;
  bysthaallare_nn_1_1_N : N ;
  baegare_nn_1_1_N : N ;
  baeltespaennare_nn_1_1_N : N ;
  baerare_nn_1_1_N : N ;
  baergare_nn_1_1_N : N ;
  baerpelare_nn_1_1_N : N ;
  baerplockare_nn_1_1_N : N ;
  baestsaeljare_nn_1_1_N : N ;
  baarbaerare_nn_1_1_N : N ;
  baatbyggare_nn_1_1_N : N ;
  boehmare_nn_1_1_N : N ;
  boejare_nn_1_1_N : N ;
  boeneutropare_nn_1_1_N : N ;
  boersjobbare_nn_1_1_N : N ;
  boersmaeklare_nn_1_1_N : N ;
  campare_nn_1_N : N ;
  cancerforskare_nn_1_N : N ;
  cd_spelare_nn_1_N : N ;
  cembalobyggare_nn_1_N : N ;
  cementblandare_nn_1_N : N ;
  ceremonimaestare_nn_1_1_N : N ;
  chanstagare_nn_1_N : N ;
  chefsaaklagare_nn_1_1_N : N ;
  chilenare_nn_1_N : N ;
  cigarettaendare_nn_1_1_N : N ;
  cigarrettaendare_nn_1_1_N : N ;
  cirkelledare_nn_1_N : N ;
  cirkulaerledare_nn_1_1_N : N ;
  dagbarnvaardare_nn_1_1_N : N ;
  dagdrivare_nn_1_N : N ;
  dagdroemmare_nn_1_1_N : N ;
  daghemsfoerestaandare_nn_1_1_N : N ;
  dagloenare_nn_1_1_N : N ;
  dagsverkare_nn_1_N : N ;
  dammsugare_nn_1_N : N ;
  danare_nn_1_N : N ;
  dansare_nn_1_N : N ;
  dansledare_nn_1_N : N ;
  dansmaestare_nn_1_1_N : N ;
  datorprogrammerare_nn_1_N : N ;
  datumvisare_nn_1_N : N ;
  debattdeltagare_nn_1_N : N ;
  deckare_nn_1_N : N ;
  deckarfoerfattare_nn_1_1_N : N ;
  dekorationsmaalare_nn_1_1_N : N ;
  deltagare_nn_1_N : N ;
  deltidare_nn_1_N : N ;
  delaegare_nn_1_1_N : N ;
  demokratifoerespraakare_nn_1_1_N : N ;
  detaljhandlare_nn_1_N : N ;
  diamantskaerare_nn_1_1_N : N ;
  dikare_nn_1_N : N ;
  dikesgraevare_nn_1_1_N : N ;
  diktare_nn_1_N : N ;
  diskare_nn_1_N : N ;
  diskplockare_nn_1_N : N ;
  diskuskastare_nn_1_N : N ;
  distriktslaekare_nn_1_1_N : N ;
  distriktsmaestare_nn_1_1_N : N ;
  diversearbetare_nn_1_N : N ;
  djurlaekare_nn_1_1_N : N ;
  djurplaagare_nn_1_1_N : N ;
  djurskoetare_nn_1_1_N : N ;
  dobblare_nn_1_N : N ;
  domare_nn_1_N : N ;
  doppvaermare_nn_1_1_N : N ;
  dosmaetare_nn_1_1_N : N ;
  dragare_nn_1_N : N ;
  drakflygare_nn_1_N : N ;
  drinkare_nn_1_N : N ;
  drive_nn_1_N : N ;
  droghandlare_nn_1_N : N ;
  drogmissbrukare_nn_1_N : N ;
  droskfoerare_nn_1_1_N : N ;
  dryckesbaegare_nn_1_1_N : N ;
  draapare_nn_1_1_N : N ;
  droemmare_nn_1_1_N : N ;
  droemtydare_nn_1_1_N : N ;
  droenare_nn_1_1_N : N ;
  dubbeldaeckare_nn_1_1_N : N ;
  dubbelgaangare_nn_1_1_N : N ;
  dubblare_nn_1_N : N ;
  dvd_spelare_nn_1_N : N ;
  dvaergbrytare_nn_1_1_N : N ;
  dykare_nn_1_N : N ;
  dynastigrundare_nn_1_N : N ;
  dyngspridare_nn_1_N : N ;
  dyrkare_nn_1_N : N ;
  dyvikare_nn_1_N : N ;
  daeckhaallare_nn_1_1_N : N ;
  daeckspassagerare_nn_1_1_N : N ;
  daemmare_nn_1_1_N : N ;
  daempare_nn_1_1_N : N ;
  doeddansare_nn_1_1_N : N ;
  doedgraevare_nn_1_1_N : N ;
  doepare_nn_1_1_N : N ;
  doerrfoersaeljare_nn_1_1_N : N ;
  doerrknackare_nn_1_1_N : N ;
  doerrstaengare_nn_1_1_N : N ;
  doerrvaktare_nn_1_1_N : N ;
  doerroeppnare_nn_1_1_N : N ;
  e_boklaesare_nn_1_1_N : N ;
  e_postare_nn_1_N : N ;
  effektfraanskiljare_nn_1_1_N : N ;
  effektfoerstaerkare_nn_1_1_N : N ;
  efterapare_nn_1_N : N ;
  efterbildare_nn_1_N : N ;
  efterbraennare_nn_1_1_N : N ;
  efterfoeljare_nn_1_1_N : N ;
  efterhaermare_nn_1_1_N : N ;
  efterslaentrare_nn_1_1_N : N ;
  eftersaegare_nn_1_1_N : N ;
  eftertraedare_nn_1_1_N : N ;
  egotrippare_nn_1_N : N ;
  ekonomifoerestaandare_nn_1_1_N : N ;
  ekspinnare_nn_1_N : N ;
  ekvecklare_nn_1_N : N ;
  elbilsfoerespraakare_nn_1_1_N : N ;
  eldare_nn_1_N : N ;
  eldkastare_nn_1_N : N ;
  eldledare_nn_1_N : N ;
  eldpelare_nn_1_N : N ;
  eldslukare_nn_1_N : N ;
  eldslaeckare_nn_1_1_N : N ;
  eldslaendare_nn_1_1_N : N ;
  eldvaktare_nn_1_N : N ;
  elgraesklippare_nn_1_1_N : N ;
  elmutterdragare_nn_1_N : N ;
  elmaetare_nn_1_1_N : N ;
  enaktare_nn_1_N : N ;
  enbyggare_nn_1_N : N ;
  energifoerbrukare_nn_1_1_N : N ;
  engelskalaerare_nn_1_1_N : N ;
  engelsklaerare_nn_1_1_N : N ;
  enkelkikare_nn_1_N : N ;
  enkelladdare_nn_1_N : N ;
  enrummare_nn_1_N : N ;
  ensamseglare_nn_1_N : N ;
  ensittare_nn_1_N : N ;
  envaaldshaerskare_nn_1_1_N : N ;
  epostare_nn_1_N : N ;
  ersaettare_nn_1_1_N : N ;
  eroevrare_nn_1_1_N : N ;
  espressobryggare_nn_1_N : N ;
  estlaendare_nn_1_1_N : N ;
  etablissemangsfoeretraedare_nn_1_1_N : N ;
  etsare_nn_1_N : N ;
  europamaestare_nn_1_1_N : N ;
  expeditionsledare_nn_1_N : N ;
  expertutredare_nn_1_N : N ;
  exponeringsmaetare_nn_1_1_N : N ;
  extralaerare_nn_1_1_N : N ;
  extremskidaakare_nn_1_1_N : N ;
  fabriksarbetare_nn_1_N : N ;
  fackelbaerare_nn_1_1_N : N ;
  fadermoerdare_nn_1_1_N : N ;
  falkenerare_nn_1_N : N ;
  fallskaermshoppare_nn_1_1_N : N ;
  fallskaermsjaegare_nn_1_1_N : N ;
  falskmyntare_nn_1_N : N ;
  falskspelare_nn_1_N : N ;
  familjefoersoerjare_nn_1_1_N : N ;
  fanbaerare_nn_1_1_N : N ;
  fanjunkare_nn_1_N : N ;
  farmare_nn_1_N : N ;
  farthaallare_nn_1_1_N : N ;
  fastighetsmaeklare_nn_1_1_N : N ;
  fastighetsskoetare_nn_1_1_N : N ;
  fastighetsaegare_nn_1_1_N : N ;
  favoritfoerfattare_nn_1_1_N : N ;
  felfinnare_nn_1_N : N ;
  femaktare_nn_1_N : N ;
  femrummare_nn_1_N : N ;
  femtekolonnare_nn_1_N : N ;
  festdeltagare_nn_1_N : N ;
  festfixare_nn_1_N : N ;
  festtalare_nn_1_N : N ;
  fifflare_nn_1_N : N ;
  filare_nn_1_N : N ;
  fildelare_nn_1_N : N ;
  filippinare_nn_1_N : N ;
  filmare_nn_1_N : N ;
  filmskapare_nn_1_N : N ;
  filmskaadespelare_nn_1_1_N : N ;
  filmtecknare_nn_1_N : N ;
  filosofilaerare_nn_1_1_N : N ;
  finlaendare_nn_1_1_N : N ;
  finsmakare_nn_1_N : N ;
  finsnickare_nn_1_N : N ;
  fiolbyggare_nn_1_N : N ;
  fiolspelare_nn_1_N : N ;
  firmatecknare_nn_1_N : N ;
  fiskare_nn_1_N : N ;
  fixare_nn_1_N : N ;
  fjaellpipare_nn_1_1_N : N ;
  fjaellvandrare_nn_1_1_N : N ;
  fjaermare_nn_1_1_N : N ;
  fjaerrskrivare_nn_1_1_N : N ;
  fjaerrskaadare_nn_1_1_N : N ;
  fjaerrstroembrytare_nn_1_1_N : N ;
  flamlaendare_nn_1_1_N : N ;
  flaskoeppnare_nn_1_1_N : N ;
  flickjaegare_nn_1_1_N : N ;
  flinare_nn_1_N : N ;
  flodaangare_nn_1_1_N : N ;
  flottare_nn_1_N : N ;
  flugsnappare_nn_1_N : N ;
  flygare_nn_1_N : N ;
  flygfoerare_nn_1_1_N : N ;
  flygledare_nn_1_N : N ;
  flygpassagerare_nn_1_N : N ;
  flygplanstillverkare_nn_1_N : N ;
  folkledare_nn_1_N : N ;
  folklivsforskare_nn_1_N : N ;
  folkskolelaerare_nn_1_1_N : N ;
  folkskollaerare_nn_1_1_N : N ;
  folktalare_nn_1_N : N ;
  fondmaeklare_nn_1_1_N : N ;
  fordringsaegare_nn_1_1_N : N ;
  formare_nn_1_N : N ;
  formgivare_nn_1_N : N ;
  fornforskare_nn_1_N : N ;
  forskare_nn_1_N : N ;
  fortsaettare_nn_1_1_N : N ;
  fossiljaegare_nn_1_1_N : N ;
  fossilletare_nn_1_N : N ;
  fosterlandsfoerraedare_nn_1_1_N : N ;
  fostrare_nn_1_N : N ;
  fotbollsledare_nn_1_N : N ;
  fotbollslaektare_nn_1_1_N : N ;
  fotbollsspelare_nn_1_N : N ;
  fotbollstraenare_nn_1_1_N : N ;
  fotgaengare_nn_1_1_N : N ;
  fotohandlare_nn_1_N : N ;
  fotvandrare_nn_1_N : N ;
  frambringare_nn_1_N : N ;
  framkallare_nn_1_N : N ;
  framladdare_nn_1_N : N ;
  framspelare_nn_1_N : N ;
  framtidsforskare_nn_1_N : N ;
  fransklaerare_nn_1_1_N : N ;
  frasmakare_nn_1_N : N ;
  fredsdomare_nn_1_N : N ;
  fredsfoerhandlare_nn_1_1_N : N ;
  fredsmaeklare_nn_1_1_N : N ;
  fredspristagare_nn_1_N : N ;
  fredsstiftare_nn_1_N : N ;
  frestare_nn_1_N : N ;
  friare_nn_1_N : N ;
  fribrottare_nn_1_N : N ;
  fribytare_nn_1_N : N ;
  fridstoerare_nn_1_1_N : N ;
  frifraesare_nn_1_1_N : N ;
  frigoerare_nn_1_1_N : N ;
  friidrottare_nn_1_N : N ;
  frilansare_nn_1_N : N ;
  frilansskaadespelare_nn_1_1_N : N ;
  frimurare_nn_1_N : N ;
  fripassagerare_nn_1_N : N ;
  frisksportare_nn_1_N : N ;
  fritidshusaegare_nn_1_1_N : N ;
  fritidsledare_nn_1_N : N ;
  fritaenkare_nn_1_1_N : N ;
  frossare_nn_1_N : N ;
  frukostaetare_nn_1_1_N : N ;
  frukthandlare_nn_1_N : N ;
  fruktodlare_nn_1_N : N ;
  fruktplockare_nn_1_N : N ;
  fraelsare_nn_1_1_N : N ;
  fraemjare_nn_1_1_N : N ;
  fraagestaellare_nn_1_1_N : N ;
  fraanskiljare_nn_1_1_N : N ;
  fullbordare_nn_1_N : N ;
  fullgoerare_nn_1_1_N : N ;
  fullriggare_nn_1_N : N ;
  fullaendare_nn_1_1_N : N ;
  funderare_nn_1_N : N ;
  fuskare_nn_1_N : N ;
  fuskbyggare_nn_1_N : N ;
  fyrarummare_nn_1_N : N ;
  fyrmaestare_nn_1_1_N : N ;
  fyrrummare_nn_1_N : N ;
  fyrtaktare_nn_1_N : N ;
  fyrvaktare_nn_1_N : N ;
  fyrverkare_nn_1_N : N ;
  fysikforskare_nn_1_N : N ;
  fysiklaerare_nn_1_1_N : N ;
  faektare_nn_1_1_N : N ;
  faektmaestare_nn_1_1_N : N ;
  faeltflygare_nn_1_1_N : N ;
  faeltjaegare_nn_1_1_N : N ;
  faeltkikare_nn_1_1_N : N ;
  faerdledare_nn_1_1_N : N ;
  faerdskrivare_nn_1_1_N : N ;
  faergare_nn_1_1_N : N ;
  faerjepassagerare_nn_1_1_N : N ;
  faagelinventerare_nn_1_1_N : N ;
  faagelmatare_nn_1_1_N : N ;
  faagelskaadare_nn_1_1_N : N ;
  faangvaktare_nn_1_1_N : N ;
  faarfarmare_nn_1_1_N : N ;
  foeljeslagare_nn_1_1_N : N ;
  foensterputsare_nn_1_1_N : N ;
  foenstertittare_nn_1_1_N : N ;
  foerare_nn_1_1_N : N ;
  foerbrukare_nn_1_1_N : N ;
  foerbrytare_nn_1_1_N : N ;
  foerdelare_nn_1_1_N : N ;
  foerdaervare_nn_1_1_N : N ;
  foerebaadare_nn_1_1_N : N ;
  foeredragshaallare_nn_1_1_N : N ;
  foeregaangare_nn_1_1_N : N ;
  foerelaesare_nn_1_1_N : N ;
  foereloepare_nn_1_1_N : N ;
  foerespraakare_nn_1_1_N : N ;
  foerestaellare_nn_1_1_N : N ;
  foerestaandare_nn_1_1_N : N ;
  foeretagare_nn_1_1_N : N ;
  foeretagsledare_nn_1_1_N : N ;
  foeretraedare_nn_1_1_N : N ;
  foerevisare_nn_1_1_N : N ;
  foerfalskare_nn_1_1_N : N ;
  foerfattare_nn_1_1_N : N ;
  foerfaektare_nn_1_1_N : N ;
  foerfaerdigare_nn_1_1_N : N ;
  foerfoeljare_nn_1_1_N : N ;
  foerfoerare_nn_1_1_N : N ;
  foergasare_nn_1_1_N : N ;
  foergyllare_nn_1_1_N : N ;
  foerhandlare_nn_1_1_N : N ;
  foerhaexare_nn_1_1_N : N ;
  foerhoersledare_nn_1_1_N : N ;
  foerintelsefoernekare_nn_1_1_N : N ;
  foerkunnare_nn_1_1_N : N ;
  foerledare_nn_1_1_N : N ;
  foerlorare_nn_1_1_N : N ;
  foerlossare_nn_1_1_N : N ;
  foerlaeggare_nn_1_1_N : N ;
  foerlaenare_nn_1_1_N : N ;
  foerloepare_nn_1_1_N : N ;
  foerloesare_nn_1_1_N : N ;
  foermedlare_nn_1_1_N : N ;
  foermyndare_nn_1_1_N : N ;
  foermaanstagare_nn_1_1_N : N ;
  foernekare_nn_1_1_N : N ;
  foernyare_nn_1_1_N : N ;
  foerpaktare_nn_1_1_N : N ;
  foerraedare_nn_1_1_N : N ;
  foerraettare_nn_1_1_N : N ;
  foerskingrare_nn_1_1_N : N ;
  foerskolelaerare_nn_1_1_N : N ;
  foerskollaerare_nn_1_1_N : N ;
  foerskaerare_nn_1_1_N : N ;
  foersonare_nn_1_1_N : N ;
  foerstagaangskoepare_nn_1_1_N : N ;
  foerstagaangsvaeljare_nn_1_1_N : N ;
  foerstamajtalare_nn_1_1_N : N ;
  foerstaerkare_nn_1_1_N : N ;
  foerstaasigpaaare_nn_1_1_N : N ;
  foerstoerare_nn_1_1_N : N ;
  foersvarare_nn_1_1_N : N ;
  foersvarsspelare_nn_1_1_N : N ;
  foersaekringsgivare_nn_1_1_N : N ;
  foersaeljare_nn_1_1_N : N ;
  foersaenkare_nn_1_1_N : N ;
  foersoeksledare_nn_1_1_N : N ;
  foersoerjare_nn_1_1_N : N ;
  foertalare_nn_1_1_N : N ;
  foertjusare_nn_1_1_N : N ;
  foertrollare_nn_1_1_N : N ;
  foertryckare_nn_1_1_N : N ;
  foerundersoekningsledare_nn_1_1_N : N ;
  foervaltare_nn_1_1_N : N ;
  foervillare_nn_1_1_N : N ;
  foervaeljare_nn_1_1_N : N ;
  foervaermare_nn_1_1_N : N ;
  foeroevare_nn_1_1_N : N ;
  gangsterpolare_nn_1_N : N ;
  garvare_nn_1_N : N ;
  gasbraennare_nn_1_1_N : N ;
  gascognare_nn_1_N : N ;
  gatsopare_nn_1_N : N ;
  gatufoersaeljare_nn_1_1_N : N ;
  geigermaetare_nn_1_1_N : N ;
  gelbgjutare_nn_1_N : N ;
  generalbefaelhavare_nn_1_1_N : N ;
  generalsekreterare_nn_1_N : N ;
  gengaangare_nn_1_1_N : N ;
  genomkoerare_nn_1_1_N : N ;
  genremaalare_nn_1_1_N : N ;
  gensare_nn_1_N : N ;
  geovetare_nn_1_N : N ;
  gerillakrigare_nn_1_N : N ;
  gerillaledare_nn_1_N : N ;
  germankrigare_nn_1_N : N ;
  giftblandare_nn_1_N : N ;
  giftbaegare_nn_1_1_N : N ;
  giljare_nn_1_N : N ;
  gisslantagare_nn_1_N : N ;
  gisslare_nn_1_N : N ;
  gitarrspelare_nn_1_N : N ;
  givare_nn_1_N : N ;
  gjutare_nn_1_N : N ;
  glasblaasare_nn_1_1_N : N ;
  glasmaestare_nn_1_1_N : N ;
  glasmaalare_nn_1_1_N : N ;
  glassbaegare_nn_1_1_N : N ;
  glasskaerare_nn_1_1_N : N ;
  glasslipare_nn_1_N : N ;
  glassaelskare_nn_1_1_N : N ;
  glimtaendare_nn_1_1_N : N ;
  glaedjedoedare_nn_1_1_N : N ;
  gnagare_nn_1_N : N ;
  gnidare_nn_1_N : N ;
  gnistfaangare_nn_1_1_N : N ;
  gnistsaendare_nn_1_1_N : N ;
  gnussare_nn_1_N : N ;
  godkaennare_nn_1_1_N : N ;
  godsaegare_nn_1_1_N : N ;
  godtemplare_nn_1_N : N ;
  golfare_nn_1_N : N ;
  golvlaeggare_nn_1_1_N : N ;
  golvvaardare_nn_1_1_N : N ;
  gradmaetare_nn_1_1_N : N ;
  gralsoekare_nn_1_1_N : N ;
  granitkeramikskaerare_nn_1_1_N : N ;
  granskare_nn_1_N : N ;
  gransaangare_nn_1_1_N : N ;
  gratispassagerare_nn_1_N : N ;
  gravplundrare_nn_1_N : N ;
  grinare_nn_1_N : N ;
  grisfoesare_nn_1_1_N : N ;
  grishandlare_nn_1_N : N ;
  grosshandlare_nn_1_N : N ;
  grottforskare_nn_1_N : N ;
  grottinnevaanare_nn_1_1_N : N ;
  grottinvaanare_nn_1_1_N : N ;
  grovarbetare_nn_1_N : N ;
  grubblare_nn_1_N : N ;
  grundare_nn_1_N : N ;
  grundlaeggare_nn_1_1_N : N ;
  grundpelare_nn_1_N : N ;
  grundskolelaerare_nn_1_1_N : N ;
  gruvarbetare_nn_1_N : N ;
  gruvstigare_nn_1_N : N ;
  graeddmaetare_nn_1_1_N : N ;
  graelmakare_nn_1_1_N : N ;
  graensjaegare_nn_1_1_N : N ;
  graesklippare_nn_1_1_N : N ;
  graesaetare_nn_1_1_N : N ;
  graevare_nn_1_1_N : N ;
  groenlaendare_nn_1_1_N : N ;
  gudsfoernekare_nn_1_1_N : N ;
  gudstjaenstbesoekare_nn_1_1_N : N ;
  guldgraevare_nn_1_1_N : N ;
  guldmakare_nn_1_N : N ;
  guldslagare_nn_1_N : N ;
  guldtaendare_nn_1_1_N : N ;
  gycklare_nn_1_N : N ;
  gynnare_nn_1_N : N ;
  gaelbgjutare_nn_1_1_N : N ;
  gaengledare_nn_1_1_N : N ;
  gaengtappshaallare_nn_1_1_N : N ;
  gaestarbetare_nn_1_1_N : N ;
  gaestforskare_nn_1_1_N : N ;
  gaestgivare_nn_1_1_N : N ;
  gaangare_nn_1_1_N : N ;
  gaapaaare_nn_1_1_N : N ;
  gaardfarihandlare_nn_1_1_N : N ;
  goedselspridare_nn_1_1_N : N ;
  goerare_nn_1_1_N : N ;
  goerdelmakare_nn_1_1_N : N ;
  goeteborgare_nn_1_1_N : N ;
  hackare_nn_1_N : N ;
  hajkaennare_nn_1_1_N : N ;
  halmskakare_nn_1_N : N ;
  halogenstraalkastare_nn_1_1_N : N ;
  halvankare_nn_1_N : N ;
  halvdaeckare_nn_1_1_N : N ;
  halvledare_nn_1_N : N ;
  hamburgare_nn_1_N : N ;
  hamnarbetare_nn_1_N : N ;
  handikappidrottare_nn_1_N : N ;
  handjagare_nn_1_N : N ;
  handlare_nn_1_N : N ;
  handledare_nn_1_N : N ;
  handlaeggare_nn_1_1_N : N ;
  handsekreterare_nn_1_N : N ;
  handtittare_nn_1_N : N ;
  hantlangare_nn_1_N : N ;
  hantverkare_nn_1_N : N ;
  hantverksarbetare_nn_1_N : N ;
  hastighetsmaetare_nn_1_1_N : N ;
  hatare_nn_1_N : N ;
  havskryssare_nn_1_N : N ;
  hedersborgare_nn_1_N : N ;
  hejare_nn_1_N : N ;
  helikopterfoerare_nn_1_1_N : N ;
  helskaeggsluffare_nn_1_1_N : N ;
  heltidsjobbare_nn_1_N : N ;
  hembraennare_nn_1_1_N : N ;
  hemmafixare_nn_1_N : N ;
  hemmansaegare_nn_1_1_N : N ;
  heroinsmugglare_nn_1_N : N ;
  herrnhutare_nn_1_N : N ;
  himlastormare_nn_1_N : N ;
  himmelsfarare_nn_1_N : N ;
  hinderloepare_nn_1_1_N : N ;
  hisstillverkare_nn_1_N : N ;
  historieforskare_nn_1_N : N ;
  historiemaalare_nn_1_1_N : N ;
  historieskrivare_nn_1_N : N ;
  hitmakare_nn_1_N : N ;
  hjullastare_nn_1_N : N ;
  hjulmutterdragare_nn_1_N : N ;
  hjulaangare_nn_1_1_N : N ;
  hjaelpare_nn_1_1_N : N ;
  hjaelpkryssare_nn_1_1_N : N ;
  hjaelplaerare_nn_1_1_N : N ;
  hjaertekrossare_nn_1_1_N : N ;
  hockeyspelare_nn_1_N : N ;
  hollaendare_nn_1_1_N : N ;
  hoppare_nn_1_N : N ;
  hoppledare_nn_1_N : N ;
  hotellaegare_nn_1_1_N : N ;
  hovmaestare_nn_1_1_N : N ;
  hovslagare_nn_1_N : N ;
  huggare_nn_1_N : N ;
  hugsvalare_nn_1_N : N ;
  humleplockare_nn_1_N : N ;
  humoerspelare_nn_1_1_N : N ;
  hundfoerare_nn_1_1_N : N ;
  hundratusentonnare_nn_1_N : N ;
  hundaegare_nn_1_1_N : N ;
  hushaallare_nn_1_1_N : N ;
  huslaekare_nn_1_1_N : N ;
  hustruersaettare_nn_1_1_N : N ;
  hustrumisshandlare_nn_1_N : N ;
  husaegare_nn_1_1_N : N ;
  huvudjaegare_nn_1_1_N : N ;
  huvudlaerare_nn_1_1_N : N ;
  huvudmotstaandare_nn_1_1_N : N ;
  huvudrollsinnehavare_nn_1_N : N ;
  huvudstroembrytare_nn_1_1_N : N ;
  huvudutmanare_nn_1_N : N ;
  hycklare_nn_1_N : N ;
  hyrlaekare_nn_1_1_N : N ;
  hyvlare_nn_1_N : N ;
  haecklare_nn_1_1_N : N ;
  haeckloepare_nn_1_1_N : N ;
  haedare_nn_1_1_N : N ;
  haelare_nn_1_1_N : N ;
  haelgaangare_nn_1_1_N : N ;
  haemnare_nn_1_1_N : N ;
  haemtare_nn_1_1_N : N ;
  haengare_nn_1_1_N : N ;
  haeradsdomare_nn_1_1_N : N ;
  haeradsskrivare_nn_1_1_N : N ;
  haerfoerare_nn_1_1_N : N ;
  haerjare_nn_1_1_N : N ;
  haermare_nn_1_1_N : N ;
  haerskare_nn_1_1_N : N ;
  haestskojare_nn_1_1_N : N ;
  haestskoetare_nn_1_1_N : N ;
  haevdatecknare_nn_1_1_N : N ;
  haexjaegare_nn_1_1_N : N ;
  haexmaestare_nn_1_1_N : N ;
  haallare_nn_1_1_N : N ;
  hoefthaallare_nn_1_1_N : N ;
  hoegerledare_nn_1_1_N : N ;
  hoegfoerraedare_nn_1_1_N : N ;
  hoeginkomsttagare_nn_1_1_N : N ;
  hoeglaendare_nn_1_1_N : N ;
  hoegoddsare_nn_1_1_N : N ;
  hoegstadielaerare_nn_1_1_N : N ;
  hoegtalare_nn_1_1_N : N ;
  hoejdare_nn_1_1_N : N ;
  hoejdhoppare_nn_1_1_N : N ;
  hoejdmaetare_nn_1_1_N : N ;
  hoekare_nn_1_1_N : N ;
  hoerare_nn_1_1_N : N ;
  hoernpelare_nn_1_1_N : N ;
  hoevaendare_nn_1_1_N : N ;
  iPhone_nn_1_N : N ;
  iakttagare_nn_1_N : N ;
  icke_roekare_nn_1_1_N : N ;
  ickeroekare_nn_1_1_N : N ;
  idisslare_nn_1_N : N ;
  idkare_nn_1_N : N ;
  idrottare_nn_1_N : N ;
  idrottsledare_nn_1_N : N ;
  id_egivare_nn_1_1_N : N ;
  inbjudare_nn_1_N : N ;
  inbyggare_nn_1_N : N ;
  industriarbetare_nn_1_N : N ;
  inhoppare_nn_1_N : N ;
  initiativtagare_nn_1_N : N ;
  injektionsmissbrukare_nn_1_N : N ;
  inkomsttagare_nn_1_N : N ;
  inkraektare_nn_1_1_N : N ;
  inkoepare_nn_1_1_N : N ;
  inledare_nn_1_N : N ;
  inmutare_nn_1_N : N ;
  innebyggare_nn_1_N : N ;
  innehavare_nn_1_N : N ;
  innesittare_nn_1_N : N ;
  innevaanare_nn_1_1_N : N ;
  inombordare_nn_1_N : N ;
  inpiskare_nn_1_N : N ;
  inriggare_nn_1_N : N ;
  inropare_nn_1_N : N ;
  insamlare_nn_1_N : N ;
  insektsborttagare_nn_1_N : N ;
  insektsaetare_nn_1_1_N : N ;
  inskrivningsdomare_nn_1_N : N ;
  instiftare_nn_1_N : N ;
  insaendare_nn_1_1_N : N ;
  internetanvaendare_nn_1_1_N : N ;
  intervjuare_nn_1_N : N ;
  intrigmakare_nn_1_N : N ;
  invandrare_nn_1_N : N ;
  inventerare_nn_1_N : N ;
  investerare_nn_1_N : N ;
  invaanare_nn_1_1_N : N ;
  irisblaendare_nn_1_1_N : N ;
  irlaendare_nn_1_1_N : N ;
  isborttagare_nn_1_N : N ;
  isbrytare_nn_1_N : N ;
  ishockeyspelare_nn_1_N : N ;
  iskaellare_nn_1_1_N : N ;
  islaendare_nn_1_1_N : N ;
  istidsforskare_nn_1_N : N ;
  italienare_nn_1_N : N ;
  ivrare_nn_1_N : N ;
  jagare_nn_1_N : N ;
  jaktraettsinnehavare_nn_1_1_N : N ;
  jamare_nn_1_N : N ;
  jasaegare_nn_1_1_N : N ;
  jetsettare_nn_1_N : N ;
  jobbare_nn_1_N : N ;
  jobbsoekare_nn_1_1_N : N ;
  joggare_nn_1_N : N ;
  jonbytare_nn_1_N : N ;
  jordbrukare_nn_1_N : N ;
  jorden_runt_seglare_nn_1_N : N ;
  jordkaellare_nn_1_1_N : N ;
  jordloepare_nn_1_1_N : N ;
  jordaegare_nn_1_1_N : N ;
  justerare_nn_1_N : N ;
  justitieborgmaestare_nn_1_1_N : N ;
  juvelerare_nn_1_N : N ;
  jaegare_nn_1_1_N : N ;
  jaegmaestare_nn_1_1_N : N ;
  jaenkare_nn_1_1_N : N ;
  jaernvaegare_nn_1_1_N : N ;
  jaernaaldersfiskare_nn_1_1_N : N ;
  kabinettssekreterare_nn_1_N : N ;
  kaffebryggare_nn_1_N : N ;
  kaffekokare_nn_1_N : N ;
  kakelskaerare_nn_1_1_N : N ;
  kakelugnsmakare_nn_1_N : N ;
  kakelugnssaettare_nn_1_1_N : N ;
  kalenderbitare_nn_1_N : N ;
  kallkaellare_nn_1_1_N : N ;
  kamelforskare_nn_1_N : N ;
  kamerunare_nn_1_N : N ;
  kammarjunkare_nn_1_N : N ;
  kammarskrivare_nn_1_N : N ;
  kammartjaenare_nn_1_1_N : N ;
  kammaraaklagare_nn_1_1_N : N ;
  kampanjraadgivare_nn_1_1_N : N ;
  kampanjvinnare_nn_1_N : N ;
  kampare_nn_1_N : N ;
  kampsportare_nn_1_N : N ;
  kamrerare_nn_1_N : N ;
  kanadensare_nn_1_N : N ;
  kanalvaeljare_nn_1_1_N : N ;
  kanalaangare_nn_1_1_N : N ;
  kannstoepare_nn_1_1_N : N ;
  kanslisekreterare_nn_1_N : N ;
  kapare_nn_1_N : N ;
  kapellmaestare_nn_1_1_N : N ;
  kappseglare_nn_1_N : N ;
  kapsyloeppnare_nn_1_1_N : N ;
  karaktaersskaadespelare_nn_1_1_N : N ;
  karelare_nn_1_N : N ;
  karikatyrtecknare_nn_1_N : N ;
  kartlaesare_nn_1_1_N : N ;
  kartmaetare_nn_1_1_N : N ;
  kartritare_nn_1_N : N ;
  kassafoervaltare_nn_1_1_N : N ;
  kassettbandspelare_nn_1_N : N ;
  kastilianare_nn_1_N : N ;
  kastratsaangare_nn_1_1_N : N ;
  kejsare_nn_1_N : N ;
  kemilaerare_nn_1_1_N : N ;
  kidnappare_nn_1_N : N ;
  kikare_nn_1_N : N ;
  kistbaerare_nn_1_1_N : N ;
  kittelflickare_nn_1_N : N ;
  kittlare_nn_1_N : N ;
  klandrare_nn_1_N : N ;
  klassfoerestaandare_nn_1_1_N : N ;
  klassfoerraedare_nn_1_1_N : N ;
  klasslaerare_nn_1_1_N : N ;
  klimatforskare_nn_1_N : N ;
  klimatfoernekare_nn_1_1_N : N ;
  klinkerskaerare_nn_1_1_N : N ;
  klippare_nn_1_N : N ;
  klockare_nn_1_N : N ;
  klottrare_nn_1_N : N ;
  klubbmaestare_nn_1_1_N : N ;
  kluddare_nn_1_N : N ;
  klyvare_nn_1_N : N ;
  klaedhaengare_nn_1_1_N : N ;
  klaemmare_nn_1_1_N : N ;
  klaemtare_nn_1_1_N : N ;
  klaettrare_nn_1_1_N : N ;
  klaapare_nn_1_1_N : N ;
  knarkare_nn_1_N : N ;
  knarkbekaempare_nn_1_1_N : N ;
  knarkhandlare_nn_1_N : N ;
  knarklangare_nn_1_N : N ;
  knarksmugglare_nn_1_N : N ;
  knegare_nn_1_N : N ;
  knivlaeggare_nn_1_1_N : N ;
  knogare_nn_1_N : N ;
  knaeppare_nn_1_1_N : N ;
  knaevaermare_nn_1_1_N : N ;
  kofaangare_nn_1_1_N : N ;
  kokare_nn_1_N : N ;
  kolare_nn_1_N : N ;
  kolbaerare_nn_1_1_N : N ;
  kolhaemtare_nn_1_1_N : N ;
  komedifoerfattare_nn_1_1_N : N ;
  kommanditdelaegare_nn_1_1_N : N ;
  kommuninnevaanare_nn_1_1_N : N ;
  kommuninvaanare_nn_1_1_N : N ;
  kongressdeltagare_nn_1_N : N ;
  konkursfoervaltare_nn_1_1_N : N ;
  konsertmaestare_nn_1_1_N : N ;
  konservoeppnare_nn_1_1_N : N ;
  konsistensgivare_nn_1_N : N ;
  konstberidare_nn_1_N : N ;
  konstkaennare_nn_1_1_N : N ;
  konstmaalare_nn_1_1_N : N ;
  konstryttare_nn_1_N : N ;
  konstsamlare_nn_1_N : N ;
  konstskojare_nn_1_N : N ;
  konstaelskare_nn_1_1_N : N ;
  konstaakare_nn_1_1_N : N ;
  kontoinnehavare_nn_1_N : N ;
  kopparslagare_nn_1_N : N ;
  kopplare_nn_1_N : N ;
  kormaestare_nn_1_1_N : N ;
  korruptionsforskare_nn_1_N : N ;
  korsfarare_nn_1_N : N ;
  korsikanare_nn_1_N : N ;
  korsriddare_nn_1_N : N ;
  korsvisare_nn_1_N : N ;
  kortdistansloepare_nn_1_1_N : N ;
  kortlaesare_nn_1_1_N : N ;
  kortspelare_nn_1_N : N ;
  korvaelskare_nn_1_1_N : N ;
  kotknackare_nn_1_N : N ;
  kotpelare_nn_1_N : N ;
  kraftbaerare_nn_1_1_N : N ;
  kreditvaerderare_nn_1_1_N : N ;
  kretensare_nn_1_N : N ;
  krigare_nn_1_N : N ;
  krigsfoerbrytare_nn_1_1_N : N ;
  krigsfoerespraakare_nn_1_1_N : N ;
  krigshetsare_nn_1_N : N ;
  krillaetare_nn_1_1_N : N ;
  kriminalare_nn_1_N : N ;
  krishanterare_nn_1_N : N ;
  kristallmottagare_nn_1_N : N ;
  kronojaegare_nn_1_1_N : N ;
  kroppsarbetare_nn_1_N : N ;
  kroppsbyggare_nn_1_N : N ;
  krubbitare_nn_1_N : N ;
  krukmakare_nn_1_N : N ;
  krypare_nn_1_N : N ;
  kryssare_nn_1_N : N ;
  kraemare_nn_1_1_N : N ;
  kraengningshaemmare_nn_1_1_N : N ;
  kraangelmakare_nn_1_1_N : N ;
  kraanglare_nn_1_1_N : N ;
  kroegare_nn_1_1_N : N ;
  kroenare_nn_1_1_N : N ;
  kroenikefoerfattare_nn_1_1_N : N ;
  kulstoetare_nn_1_1_N : N ;
  kulturarbetare_nn_1_N : N ;
  kulturbaerare_nn_1_1_N : N ;
  kulturtaenkare_nn_1_1_N : N ;
  kungamakare_nn_1_N : N ;
  kungamoerdare_nn_1_1_N : N ;
  kungsfiskare_nn_1_N : N ;
  kunskapare_nn_1_N : N ;
  kupongklippare_nn_1_N : N ;
  kup_evaermare_nn_1_1_N : N ;
  kursare_nn_1_N : N ;
  kursdeltagare_nn_1_N : N ;
  kustjaegare_nn_1_1_N : N ;
  kustpipare_nn_1_N : N ;
  kvackare_nn_1_N : N ;
  kvacksalvare_nn_1_N : N ;
  kvarntorpare_nn_1_N : N ;
  kvarsittare_nn_1_N : N ;
  kvartermaestare_nn_1_1_N : N ;
  kvicksilverpelare_nn_1_N : N ;
  kvinnofoerfoerare_nn_1_1_N : N ;
  kvinnohatare_nn_1_N : N ;
  kvinnolaekare_nn_1_1_N : N ;
  kvinnotjusare_nn_1_N : N ;
  kvaekare_nn_1_1_N : N ;
  kylare_nn_1_N : N ;
  kypare_nn_1_N : N ;
  kyrkobesoekare_nn_1_1_N : N ;
  kyrkolaerare_nn_1_1_N : N ;
  kyrkvaktmaestare_nn_1_1_N : N ;
  kaebblare_nn_1_1_N : N ;
  kaegelspelare_nn_1_1_N : N ;
  kaelkborgare_nn_1_1_N : N ;
  kaellare_nn_1_1_N : N ;
  kaellarmaestare_nn_1_1_N : N ;
  kaennare_nn_1_1_N : N ;
  kaernkraftskramare_nn_1_1_N : N ;
  kaernkraftsmotstaandare_nn_1_1_N : N ;
  kaernvaeljare_nn_1_1_N : N ;
  kaettare_nn_1_1_N : N ;
  kaettingspaennare_nn_1_1_N : N ;
  kaakfarare_nn_1_1_N : N ;
  koeksmaestare_nn_1_1_N : N ;
  koepare_nn_1_1_N : N ;
  koerare_nn_1_1_N : N ;
  koerkortsinnehavare_nn_1_1_N : N ;
  koerledare_nn_1_1_N : N ;
  koernare_nn_1_1_N : N ;
  koerriktningsvisare_nn_1_1_N : N ;
  koersaangare_nn_1_1_N : N ;
  koettbullsaelskare_nn_1_1_N : N ;
  koettaetare_nn_1_1_N : N ;
  laddare_nn_1_N : N ;
  lagledare_nn_1_N : N ;
  lagstiftare_nn_1_N : N ;
  lagtraenare_nn_1_1_N : N ;
  lagvraengare_nn_1_1_N : N ;
  lamphaallare_nn_1_1_N : N ;
  landsfoerraedare_nn_1_1_N : N ;
  landssekreterare_nn_1_N : N ;
  landstrykare_nn_1_N : N ;
  landsvaegsriddare_nn_1_1_N : N ;
  langare_nn_1_N : N ;
  lantarbetare_nn_1_N : N ;
  lantbrevbaerare_nn_1_1_N : N ;
  lantbrukare_nn_1_N : N ;
  lantjunkare_nn_1_N : N ;
  lantmaestare_nn_1_1_N : N ;
  lantmaetare_nn_1_1_N : N ;
  lappsoekare_nn_1_1_N : N ;
  laserpekare_nn_1_N : N ;
  lastare_nn_1_N : N ;
  lastbilsfoerare_nn_1_1_N : N ;
  lasthaallare_nn_1_1_N : N ;
  latinare_nn_1_N : N ;
  latte_nn_1_N : N ;
  ledare_nn_1_N : N ;
  ledsagare_nn_1_N : N ;
  lejdare_nn_1_N : N ;
  lejontaemjare_nn_1_1_N : N ;
  lekare_nn_1_N : N ;
  lekledare_nn_1_N : N ;
  lettlaendare_nn_1_1_N : N ;
  levnadstecknare_nn_1_N : N ;
  licensinnehavare_nn_1_N : N ;
  licenstagare_nn_1_N : N ;
  liechtensteinare_nn_1_N : N ;
  liftare_nn_1_N : N ;
  liggare_nn_1_N : N ;
  ligustersvaermare_nn_1_1_N : N ;
  likare_nn_1_N : N ;
  likriktare_nn_1_N : N ;
  likskaendare_nn_1_1_N : N ;
  lindansare_nn_1_N : N ;
  lindare_nn_1_N : N ;
  lingonplockare_nn_1_N : N ;
  linjedomare_nn_1_N : N ;
  linjerare_nn_1_N : N ;
  linjevaeljare_nn_1_1_N : N ;
  lirare_nn_1_N : N ;
  lismare_nn_1_N : N ;
  litteraturforskare_nn_1_N : N ;
  livraeddare_nn_1_1_N : N ;
  livsbejakare_nn_1_N : N ;
  livsnjutare_nn_1_N : N ;
  livtjaenare_nn_1_1_N : N ;
  ljuddaempare_nn_1_1_N : N ;
  ljudinspelare_nn_1_N : N ;
  ljugare_nn_1_N : N ;
  ljungpipare_nn_1_N : N ;
  ljushaallare_nn_1_1_N : N ;
  ljusslaeckare_nn_1_1_N : N ;
  lodare_nn_1_N : N ;
  logerare_nn_1_N : N ;
  lokalvaardare_nn_1_1_N : N ;
  lokfoerare_nn_1_1_N : N ;
  loppforskare_nn_1_N : N ;
  lotterivinnare_nn_1_N : N ;
  lotusaetare_nn_1_1_N : N ;
  luffare_nn_1_N : N ;
  luftfuktare_nn_1_N : N ;
  luftrenare_nn_1_N : N ;
  luftsmoerjare_nn_1_1_N : N ;
  lufttrycksmaetare_nn_1_1_N : N ;
  luktborttagare_nn_1_N : N ;
  lunchare_nn_1_N : N ;
  lurendrejare_nn_1_N : N ;
  lustloegnare_nn_1_1_N : N ;
  lustmoerdare_nn_1_1_N : N ;
  lustspelsfoerfattare_nn_1_1_N : N ;
  lutningsmaetare_nn_1_1_N : N ;
  lutspelare_nn_1_N : N ;
  lutsaangare_nn_1_1_N : N ;
  luxemburgare_nn_1_N : N ;
  lycksoekare_nn_1_1_N : N ;
  lyktbaerare_nn_1_1_N : N ;
  lyrikaelskare_nn_1_1_N : N ;
  lyssnare_nn_1_N : N ;
  lyxkryssare_nn_1_N : N ;
  laegenhetsinnehavare_nn_1_1_N : N ;
  laekare_nn_1_1_N : N ;
  laekarsekreterare_nn_1_1_N : N ;
  laektare_nn_1_1_N : N ;
  laempare_nn_1_1_N : N ;
  laengdhoppare_nn_1_1_N : N ;
  laengdskidaakare_nn_1_1_N : N ;
  laensaaklagare_nn_1_1_N : N ;
  laentagare_nn_1_1_N : N ;
  laerare_nn_1_1_N : N ;
  laeromaestare_nn_1_1_N : N ;
  laesare_nn_1_1_N : N ;
  laettviktare_nn_1_1_N : N ;
  laaginkomsttagare_nn_1_1_N : N ;
  laagoddsare_nn_1_1_N : N ;
  laagstadielaerare_nn_1_1_N : N ;
  laangfarare_nn_1_1_N : N ;
  laangivare_nn_1_1_N : N ;
  laangkoerare_nn_1_1_N : N ;
  laangliggare_nn_1_1_N : N ;
  laangtradare_nn_1_1_N : N ;
  laantagare_nn_1_1_N : N ;
  laatskrivare_nn_1_1_N : N ;
  loegnare_nn_1_1_N : N ;
  loenearbetare_nn_1_1_N : N ;
  loennmoerdare_nn_1_1_N : N ;
  loentagare_nn_1_1_N : N ;
  loepare_nn_1_1_N : N ;
  loesdrivare_nn_1_1_N : N ;
  loevsaangare_nn_1_1_N : N ;
  loevuppsamlare_nn_1_1_N : N ;
  maffiaavsloejare_nn_1_1_N : N ;
  magborstare_nn_1_N : N ;
  mailare_nn_1_N : N ;
  makthavare_nn_1_N : N ;
  maktutoevare_nn_1_1_N : N ;
  maltesare_nn_1_N : N ;
  manusfoerfattare_nn_1_1_N : N ;
  marginalvaeljare_nn_1_1_N : N ;
  marinmaalare_nn_1_1_N : N ;
  marketentare_nn_1_N : N ;
  marknadsgycklare_nn_1_N : N ;
  marktaeckare_nn_1_1_N : N ;
  markaegare_nn_1_1_N : N ;
  massmoerdare_nn_1_1_N : N ;
  matare_nn_1_N : N ;
  matberedare_nn_1_N : N ;
  matematiklaerare_nn_1_1_N : N ;
  materialspelare_nn_1_N : N ;
  matkaellare_nn_1_1_N : N ;
  mattdomare_nn_1_N : N ;
  mattpiskare_nn_1_N : N ;
  mattsopare_nn_1_N : N ;
  mattvaevare_nn_1_1_N : N ;
  medarbetare_nn_1_N : N ;
  medbedoemare_nn_1_1_N : N ;
  medborgare_nn_1_N : N ;
  medbringare_nn_1_N : N ;
  meddelare_nn_1_N : N ;
  medelinkomsttagare_nn_1_N : N ;
  medelpadare_nn_1_N : N ;
  medeltidstaenkare_nn_1_1_N : N ;
  medhjaelpare_nn_1_1_N : N ;
  medhaallare_nn_1_1_N : N ;
  medianvaeljare_nn_1_1_N : N ;
  medicinare_nn_1_N : N ;
  medlare_nn_1_N : N ;
  medloepare_nn_1_1_N : N ;
  medpassagerare_nn_1_N : N ;
  medspelare_nn_1_N : N ;
  medtaevlare_nn_1_1_N : N ;
  mejare_nn_1_N : N ;
  mejlare_nn_1_N : N ;
  mellanstroembrytare_nn_1_1_N : N ;
  memoarfoerfattare_nn_1_1_N : N ;
  menedare_nn_1_N : N ;
  meningsmotstaandare_nn_1_1_N : N ;
  metallarbetare_nn_1_N : N ;
  metare_nn_1_N : N ;
  meterlikare_nn_1_N : N ;
  middagsaetare_nn_1_1_N : N ;
  militaerbefaelhavare_nn_1_1_N : N ;
  militaerlaekare_nn_1_1_N : N ;
  miljoefoerstoerare_nn_1_1_N : N ;
  miljoehycklare_nn_1_1_N : N ;
  miniatyrmaalare_nn_1_1_N : N ;
  miniraeknare_nn_1_1_N : N ;
  minnestecknare_nn_1_N : N ;
  minsvepare_nn_1_N : N ;
  minsoekare_nn_1_1_N : N ;
  minutvisare_nn_1_N : N ;
  missbrukare_nn_1_N : N ;
  missdaadare_nn_1_1_N : N ;
  misshushaallare_nn_1_1_N : N ;
  missilavfyrare_nn_1_N : N ;
  missnoejesvaeljare_nn_1_1_N : N ;
  mittfaeltare_nn_1_1_N : N ;
  mjoelkare_nn_1_1_N : N ;
  mjoelnare_nn_1_1_N : N ;
  mobilabonnemangsfoersaeljare_nn_1_1_N : N ;
  mobilladdare_nn_1_N : N ;
  moddlare_nn_1_N : N ;
  modeskapare_nn_1_N : N ;
  mokare_nn_1_N : N ;
  monotoniundvikare_nn_1_N : N ;
  mordbraennare_nn_1_1_N : N ;
  motlaesare_nn_1_1_N : N ;
  motorkryssare_nn_1_N : N ;
  motorseglare_nn_1_N : N ;
  motorvaegskramare_nn_1_1_N : N ;
  motorvaermare_nn_1_1_N : N ;
  motspelare_nn_1_N : N ;
  motstaandare_nn_1_1_N : N ;
  mottagare_nn_1_N : N ;
  mp3_spelare_nn_1_N : N ;
  muckare_nn_1_N : N ;
  mullbaersspinnare_nn_1_1_N : N ;
  murare_nn_1_N : N ;
  museivaktmaestare_nn_1_1_N : N ;
  musikfanjunkare_nn_1_N : N ;
  musiklaerare_nn_1_1_N : N ;
  muskelbyggare_nn_1_N : N ;
  muskelstaerkare_nn_1_1_N : N ;
  musketerare_nn_1_N : N ;
  mutterdragare_nn_1_N : N ;
  myggjagare_nn_1_N : N ;
  myglare_nn_1_N : N ;
  myndighetsfoeretraedare_nn_1_1_N : N ;
  myndighetsutoevare_nn_1_1_N : N ;
  mynningsladdare_nn_1_N : N ;
  myrforskare_nn_1_N : N ;
  maeklare_nn_1_1_N : N ;
  maenniskohatare_nn_1_1_N : N ;
  maenniskokaennare_nn_1_1_N : N ;
  maenniskoraettsfoeretraedare_nn_1_1_N : N ;
  maenniskosmugglare_nn_1_1_N : N ;
  maenniskoaetare_nn_1_1_N : N ;
  maeskprovare_nn_1_1_N : N ;
  maestare_nn_1_1_N : N ;
  maesterklottrare_nn_1_1_N : N ;
  maestersaangare_nn_1_1_N : N ;
  maestertaenkare_nn_1_1_N : N ;
  maetare_nn_1_1_N : N ;
  maakare_nn_1_1_N : N ;
  maalare_nn_1_1_N : N ;
  maalarmaestare_nn_1_1_N : N ;
  maaldomare_nn_1_1_N : N ;
  maalspottare_nn_1_1_N : N ;
  maalsaegare_nn_1_1_N : N ;
  maalsoekare_nn_1_1_N : N ;
  maangbyggare_nn_1_1_N : N ;
  maangfrestare_nn_1_1_N : N ;
  maanglare_nn_1_1_N : N ;
  maangsysslare_nn_1_1_N : N ;
  maanlandare_nn_1_1_N : N ;
  moebelsnickare_nn_1_1_N : N ;
  moenstringsliggare_nn_1_1_N : N ;
  moerdare_nn_1_1_N : N ;
  moerklaeggare_nn_1_1_N : N ;
  moersare_nn_1_1_N : N ;
  nagelpetare_nn_1_N : N ;
  nakenbadare_nn_1_N : N ;
  nakenvandrare_nn_1_N : N ;
  namnbaerare_nn_1_1_N : N ;
  napolitanare_nn_1_N : N ;
  narkoslaekare_nn_1_1_N : N ;
  narkotikasmugglare_nn_1_N : N ;
  nasare_nn_1_N : N ;
  nationalistledare_nn_1_N : N ;
  nattfriare_nn_1_N : N ;
  nattkikare_nn_1_N : N ;
  nattlogerare_nn_1_N : N ;
  nattspanare_nn_1_N : N ;
  nattsuddare_nn_1_N : N ;
  nattvandrare_nn_1_N : N ;
  nattvaektare_nn_1_1_N : N ;
  naturforskare_nn_1_N : N ;
  naturlaekare_nn_1_1_N : N ;
  natursaangare_nn_1_1_N : N ;
  naturvetare_nn_1_N : N ;
  naturvaardare_nn_1_1_N : N ;
  naturvaardshandlaeggare_nn_1_1_N : N ;
  navare_nn_1_N : N ;
  navelskaadare_nn_1_1_N : N ;
  neandertalare_nn_1_N : N ;
  nederlaendare_nn_1_1_N : N ;
  nedhalare_nn_1_N : N ;
  nedsmutsare_nn_1_N : N ;
  nejsaegare_nn_1_1_N : N ;
  nerhalare_nn_1_N : N ;
  nersmutsare_nn_1_N : N ;
  newfoundlaendare_nn_1_1_N : N ;
  nobelpristagare_nn_1_N : N ;
  nolltaxerare_nn_1_N : N ;
  notvaendare_nn_1_1_N : N ;
  nybyggare_nn_1_N : N ;
  nyboerjare_nn_1_1_N : N ;
  nydanare_nn_1_N : N ;
  nyhetsmakare_nn_1_N : N ;
  nyhetsupplaesare_nn_1_1_N : N ;
  nykterhetsivrare_nn_1_N : N ;
  nyskapare_nn_1_N : N ;
  nystavare_nn_1_N : N ;
  nyttjare_nn_1_N : N ;
  nytaenkare_nn_1_1_N : N ;
  nyzeelaendare_nn_1_1_N : N ;
  naemnare_nn_1_1_N : N ;
  naeringsidkare_nn_1_1_N : N ;
  naeringslivsledare_nn_1_1_N : N ;
  naetbedragare_nn_1_1_N : N ;
  naetrullare_nn_1_1_N : N ;
  naetsurfare_nn_1_1_N : N ;
  naeverbehaallare_nn_1_1_N : N ;
  noejesfiskare_nn_1_1_N : N ;
  noetknaeckare_nn_1_1_N : N ;
  noetknaeppare_nn_1_1_N : N ;
  oceanaangare_nn_1_1_N : N ;
  ockrare_nn_1_N : N ;
  odlare_nn_1_N : N ;
  officerare_nn_1_N : N ;
  oledare_nn_1_N : N ;
  oliktaenkare_nn_1_1_N : N ;
  oljebraennare_nn_1_1_N : N ;
  oljenivaamaetare_nn_1_1_N : N ;
  oljestroembrytare_nn_1_1_N : N ;
  olympiasegrare_nn_1_N : N ;
  omformare_nn_1_N : N ;
  omkastare_nn_1_N : N ;
  omkopplare_nn_1_N : N ;
  omriktare_nn_1_N : N ;
  omraekningsrysare_nn_1_1_N : N ;
  omskapare_nn_1_N : N ;
  omskiftare_nn_1_N : N ;
  omvandlare_nn_1_N : N ;
  operasaangare_nn_1_1_N : N ;
  operationslaekare_nn_1_1_N : N ;
  opinionsbildare_nn_1_N : N ;
  oppassare_nn_1_N : N ;
  oppbackare_nn_1_N : N ;
  oppfinnare_nn_1_N : N ;
  oppfostrare_nn_1_N : N ;
  oppfoedare_nn_1_1_N : N ;
  oppositionsledare_nn_1_N : N ;
  oppaatstraevare_nn_1_1_N : N ;
  ordbehandlare_nn_1_N : N ;
  orddelare_nn_1_N : N ;
  ordklasstaggare_nn_1_N : N ;
  ordmakare_nn_1_N : N ;
  ordnare_nn_1_N : N ;
  ordryttare_nn_1_N : N ;
  ordvraengare_nn_1_1_N : N ;
  orgeltrampare_nn_1_N : N ;
  orienterare_nn_1_N : N ;
  ormdoedare_nn_1_1_N : N ;
  ormtjusare_nn_1_N : N ;
  orosstiftare_nn_1_N : N ;
  ortdrivare_nn_1_N : N ;
  ostskaerare_nn_1_1_N : N ;
  pajsare_nn_1_N : N ;
  pakethaallare_nn_1_1_N : N ;
  pakistanare_nn_1_N : N ;
  panthavare_nn_1_N : N ;
  pantlaanare_nn_1_1_N : N ;
  pantsaettare_nn_1_1_N : N ;
  paradoxmakare_nn_1_N : N ;
  paragrafryttare_nn_1_N : N ;
  paraguayare_nn_1_N : N ;
  parkeringsmaetare_nn_1_1_N : N ;
  parkettlaeggare_nn_1_1_N : N ;
  parkskoetare_nn_1_1_N : N ;
  partifoeretraedare_nn_1_1_N : N ;
  partigaengare_nn_1_1_N : N ;
  partikelkolliderare_nn_1_N : N ;
  partiledare_nn_1_N : N ;
  partisekreterare_nn_1_N : N ;
  passagerare_nn_1_N : N ;
  passare_nn_1_N : N ;
  passgaangare_nn_1_1_N : N ;
  patentsoekare_nn_1_1_N : N ;
  patronhaallare_nn_1_1_N : N ;
  pekare_nn_1_N : N ;
  pelare_nn_1_N : N ;
  pendlare_nn_1_N : N ;
  pennformerare_nn_1_N : N ;
  pennfaektare_nn_1_1_N : N ;
  penninginsamlare_nn_1_N : N ;
  pennvaessare_nn_1_1_N : N ;
  pensionatsinnehavare_nn_1_N : N ;
  pensionsraadgivare_nn_1_1_N : N ;
  periodare_nn_1_N : N ;
  periodsupare_nn_1_N : N ;
  personallaekare_nn_1_1_N : N ;
  personalutbildare_nn_1_N : N ;
  personsoekare_nn_1_1_N : N ;
  perukmakare_nn_1_N : N ;
  pigtittare_nn_1_N : N ;
  pigtjusare_nn_1_N : N ;
  pilleknarkare_nn_1_N : N ;
  pillertrillare_nn_1_N : N ;
  pipare_nn_1_N : N ;
  piprensare_nn_1_N : N ;
  piproekare_nn_1_1_N : N ;
  pipspaennare_nn_1_1_N : N ;
  pipstoppare_nn_1_N : N ;
  piratsaendare_nn_1_1_N : N ;
  pizzabagare_nn_1_N : N ;
  pladdrare_nn_1_N : N ;
  planerare_nn_1_N : N ;
  plankstrykare_nn_1_N : N ;
  plikthuggare_nn_1_N : N ;
  plockare_nn_1_N : N ;
  pluggare_nn_1_N : N ;
  plundrare_nn_1_N : N ;
  plaagare_nn_1_1_N : N ;
  plaatslagare_nn_1_1_N : N ;
  polare_nn_1_N : N ;
  polismaestare_nn_1_1_N : N ;
  pollare_nn_1_N : N ;
  polospelare_nn_1_N : N ;
  popsaangare_nn_1_1_N : N ;
  portfoeljbaerare_nn_1_1_N : N ;
  portraettmaalare_nn_1_1_N : N ;
  positivhalare_nn_1_N : N ;
  postmaestare_nn_1_1_N : N ;
  potatisskalare_nn_1_N : N ;
  praktbaegare_nn_1_1_N : N ;
  pratmakare_nn_1_N : N ;
  predikare_nn_1_N : N ;
  predikohandledare_nn_1_N : N ;
  prejare_nn_1_N : N ;
  premiebetalare_nn_1_N : N ;
  pressare_nn_1_N : N ;
  presslaektare_nn_1_1_N : N ;
  preussare_nn_1_N : N ;
  prickare_nn_1_N : N ;
  principryttare_nn_1_N : N ;
  prisboxare_nn_1_N : N ;
  prisdomare_nn_1_N : N ;
  prismakikare_nn_1_N : N ;
  pristagare_nn_1_N : N ;
  prisvinnare_nn_1_N : N ;
  privatiseringsivrare_nn_1_N : N ;
  privatlaekare_nn_1_1_N : N ;
  privatlaerare_nn_1_1_N : N ;
  privatmicklare_nn_1_N : N ;
  privatsekreterare_nn_1_N : N ;
  procentare_nn_1_N : N ;
  proffsspelare_nn_1_N : N ;
  proffsvinnare_nn_1_N : N ;
  proffsaakare_nn_1_1_N : N ;
  proggare_nn_1_N : N ;
  programledare_nn_1_N : N ;
  programmerare_nn_1_N : N ;
  programutgivare_nn_1_N : N ;
  programutvecklare_nn_1_N : N ;
  programvaeljare_nn_1_1_N : N ;
  projektledare_nn_1_N : N ;
  provare_nn_1_N : N ;
  provinsiallaekare_nn_1_1_N : N ;
  provinsstaathaallare_nn_1_1_N : N ;
  provryttare_nn_1_N : N ;
  praanglare_nn_1_1_N : N ;
  psalmdiktare_nn_1_N : N ;
  psaltare_nn_1_N : N ;
  puckare_nn_1_N : N ;
  pulslaesare_nn_1_1_N : N ;
  pulverslaeckare_nn_1_1_N : N ;
  pundare_nn_1_N : N ;
  punkare_nn_1_N : N ;
  pyndare_nn_1_N : N ;
  paelsfladdrare_nn_1_1_N : N ;
  paelsjaegare_nn_1_1_N : N ;
  paermbaerare_nn_1_1_N : N ;
  paermslukare_nn_1_1_N : N ;
  paadrivare_nn_1_1_N : N ;
  paahejare_nn_1_1_N : N ;
  paaklaedare_nn_1_1_N : N ;
  paatryckare_nn_1_1_N : N ;
  rabattjaegare_nn_1_1_N : N ;
  racerfoerare_nn_1_1_N : N ;
  rackabajsare_nn_1_N : N ;
  rackare_nn_1_N : N ;
  radiomottagare_nn_1_N : N ;
  radiosaendare_nn_1_1_N : N ;
  radskiftare_nn_1_N : N ;
  radskrivare_nn_1_N : N ;
  raggare_nn_1_N : N ;
  rallare_nn_1_N : N ;
  ramlare_nn_1_N : N ;
  ramsaettare_nn_1_1_N : N ;
  ranchaegare_nn_1_1_N : N ;
  rashetsare_nn_1_N : N ;
  reaktorkramare_nn_1_N : N ;
  rebelledare_nn_1_N : N ;
  redaktionssekreterare_nn_1_N : N ;
  redare_nn_1_N : N ;
  redogoerare_nn_1_1_N : N ;
  refraengsaangare_nn_1_1_N : N ;
  regelryttare_nn_1_N : N ;
  regeringsanhaengare_nn_1_1_N : N ;
  regnmaetare_nn_1_1_N : N ;
  religionsstiftare_nn_1_N : N ;
  remmare_nn_1_N : N ;
  renjaegare_nn_1_1_N : N ;
  renskoetare_nn_1_1_N : N ;
  repborttagare_nn_1_N : N ;
  repslagare_nn_1_N : N ;
  reseledare_nn_1_N : N ;
  reservare_nn_1_N : N ;
  reservspelare_nn_1_N : N ;
  reseskildrare_nn_1_N : N ;
  revisionssekreterare_nn_1_N : N ;
  revolutionsledare_nn_1_N : N ;
  revymakare_nn_1_N : N ;
  rickshawfoerare_nn_1_1_N : N ;
  riddare_nn_1_N : N ;
  riksbyggare_nn_1_N : N ;
  riksfoerestaandare_nn_1_1_N : N ;
  riksfoerraedare_nn_1_1_N : N ;
  rikslikare_nn_1_N : N ;
  riksaaklagare_nn_1_1_N : N ;
  rimmare_nn_1_N : N ;
  ringare_nn_1_N : N ;
  ringdomare_nn_1_N : N ;
  risktagare_nn_1_N : N ;
  ritare_nn_1_N : N ;
  rockvaktmaestare_nn_1_1_N : N ;
  roddare_nn_1_N : N ;
  rolighetsmakare_nn_1_N : N ;
  romanfoerfattare_nn_1_1_N : N ;
  romare_nn_1_N : N ;
  ropare_nn_1_N : N ;
  rorgaengare_nn_1_1_N : N ;
  rotbedragare_nn_1_N : N ;
  rovriddare_nn_1_N : N ;
  rucklare_nn_1_N : N ;
  rufflare_nn_1_N : N ;
  rumlare_nn_1_N : N ;
  rumpsniffare_nn_1_N : N ;
  rumpvaermare_nn_1_1_N : N ;
  runnare_nn_1_N : N ;
  rustare_nn_1_N : N ;
  rusthaallare_nn_1_1_N : N ;
  rustmaestare_nn_1_1_N : N ;
  ryggdunkare_nn_1_N : N ;
  ryktessmidare_nn_1_N : N ;
  rymdfarare_nn_1_N : N ;
  rymmare_nn_1_N : N ;
  rysare_nn_1_N : N ;
  rysklaerare_nn_1_1_N : N ;
  rysslaendare_nn_1_1_N : N ;
  ryttare_nn_1_N : N ;
  ryttmaestare_nn_1_1_N : N ;
  raeddare_nn_1_1_N : N ;
  raeddningsledare_nn_1_1_N : N ;
  raeknare_nn_1_1_N : N ;
  raenksmidare_nn_1_1_N : N ;
  raentmaestare_nn_1_1_N : N ;
  raettare_nn_1_1_N : N ;
  raettsinnehavare_nn_1_1_N : N ;
  raettslaekare_nn_1_1_N : N ;
  raettstjaenare_nn_1_1_N : N ;
  raadgivare_nn_1_1_N : N ;
  raadhuskaellare_nn_1_1_N : N ;
  raanare_nn_1_1_N : N ;
  raanmoerdare_nn_1_1_N : N ;
  raaseglare_nn_1_1_N : N ;
  roedhakesaangare_nn_1_1_N : N ;
  roejdykare_nn_1_1_N : N ;
  roekare_nn_1_1_N : N ;
  roekdykare_nn_1_1_N : N ;
  roekpelare_nn_1_1_N : N ;
  roerlaeggare_nn_1_1_N : N ;
  roermokare_nn_1_1_N : N ;
  roersaangare_nn_1_1_N : N ;
  roevare_nn_1_1_N : N ;
  roevslickare_nn_1_1_N : N ;
  sachsare_nn_1_N : N ;
  sadelmakare_nn_1_N : N ;
  sagoberaettare_nn_1_1_N : N ;
  sakfoerare_nn_1_1_N : N ;
  sakramentsfoervaltare_nn_1_1_N : N ;
  sakaegare_nn_1_1_N : N ;
  salivsugare_nn_1_N : N ;
  salongsuppassare_nn_1_N : N ;
  saltbildare_nn_1_N : N ;
  saltprovare_nn_1_N : N ;
  saltstroeare_nn_1_1_N : N ;
  sambadansare_nn_1_N : N ;
  sambyggare_nn_1_N : N ;
  samhaellsbevarare_nn_1_1_N : N ;
  samhaellsforskare_nn_1_1_N : N ;
  samhaellsfoerbaettrare_nn_1_1_N : N ;
  samhaellshatare_nn_1_1_N : N ;
  samhaellskunskapslaerare_nn_1_1_N : N ;
  samhaellsomstoertare_nn_1_1_N : N ;
  samhaellsplanerare_nn_1_1_N : N ;
  samhaellsvetare_nn_1_1_N : N ;
  samlare_nn_1_N : N ;
  samordnare_nn_1_N : N ;
  samtalsmaetare_nn_1_1_N : N ;
  samtalsraeknare_nn_1_1_N : N ;
  samtidsbetraktare_nn_1_N : N ;
  sandbindare_nn_1_N : N ;
  sandjaegare_nn_1_1_N : N ;
  sandkrypare_nn_1_N : N ;
  sandloepare_nn_1_1_N : N ;
  sandsugare_nn_1_N : N ;
  sandvikare_nn_1_N : N ;
  sanmarinesare_nn_1_N : N ;
  sanningssaegare_nn_1_1_N : N ;
  sanningssoekare_nn_1_1_N : N ;
  sardinare_nn_1_N : N ;
  saxare_nn_1_N : N ;
  scenarbetare_nn_1_N : N ;
  scenkonstarbetare_nn_1_N : N ;
  schackrare_nn_1_N : N ;
  schackspelare_nn_1_N : N ;
  schillerstoevare_nn_1_1_N : N ;
  schweizare_nn_1_N : N ;
  sedlighetsivrare_nn_1_N : N ;
  segelmakare_nn_1_N : N ;
  segelsoemmare_nn_1_1_N : N ;
  seglare_nn_1_N : N ;
  segrare_nn_1_N : N ;
  sejdare_nn_1_N : N ;
  sekreterare_nn_1_N : N ;
  sekundvisare_nn_1_N : N ;
  semesterfirare_nn_1_N : N ;
  seminarielaerare_nn_1_1_N : N ;
  sengaangare_nn_1_1_N : N ;
  separatistledare_nn_1_N : N ;
  serbledare_nn_1_N : N ;
  seriemoerdare_nn_1_1_N : N ;
  serietecknare_nn_1_N : N ;
  sexfoerbrytare_nn_1_1_N : N ;
  sexmaestare_nn_1_1_N : N ;
  sexmoerdare_nn_1_1_N : N ;
  sexraadgivare_nn_1_1_N : N ;
  siare_nn_1_N : N ;
  sicilianare_nn_1_N : N ;
  sigillbevarare_nn_1_N : N ;
  silkespinnare_nn_1_N : N ;
  silkesspinnare_nn_1_N : N ;
  sillstrypare_nn_1_N : N ;
  silverbaegare_nn_1_1_N : N ;
  simlaerare_nn_1_1_N : N ;
  simmare_nn_1_N : N ;
  sinkare_nn_1_N : N ;
  sinnessjuklaekare_nn_1_1_N : N ;
  sjukbaerare_nn_1_1_N : N ;
  sjukskoetare_nn_1_1_N : N ;
  sjukvaardare_nn_1_1_N : N ;
  sjusovare_nn_1_N : N ;
  sjaelasoerjare_nn_1_1_N : N ;
  sjaelvbindare_nn_1_1_N : N ;
  sjaelvfoernekare_nn_1_1_N : N ;
  sjaelvhaerskare_nn_1_1_N : N ;
  sjaelvmordsbombare_nn_1_1_N : N ;
  sjaelvmoerdare_nn_1_1_N : N ;
  sjaelvplaagare_nn_1_1_N : N ;
  sjaelvutloesare_nn_1_1_N : N ;
  sjaaare_nn_1_1_N : N ;
  sjoefarare_nn_1_1_N : N ;
  sjoeroevare_nn_1_1_N : N ;
  skadegoerare_nn_1_1_N : N ;
  skaffare_nn_1_N : N ;
  skapare_nn_1_N : N ;
  skarpraettare_nn_1_1_N : N ;
  skattebetalare_nn_1_N : N ;
  skattefifflare_nn_1_N : N ;
  skattefuskare_nn_1_N : N ;
  skatteindrivare_nn_1_N : N ;
  skattesmitare_nn_1_N : N ;
  skattetrixare_nn_1_N : N ;
  skattmaestare_nn_1_1_N : N ;
  skattsoekare_nn_1_1_N : N ;
  skeppare_nn_1_N : N ;
  skeppsklarerare_nn_1_N : N ;
  skeppsmaeklare_nn_1_1_N : N ;
  skeppsredare_nn_1_N : N ;
  skidaakare_nn_1_1_N : N ;
  skildrare_nn_1_N : N ;
  skiljedomare_nn_1_N : N ;
  skinnare_nn_1_N : N ;
  skivpratare_nn_1_N : N ;
  skivspelare_nn_1_N : N ;
  skoflickare_nn_1_N : N ;
  skogsarbetare_nn_1_N : N ;
  skogshuggare_nn_1_N : N ;
  skogsmaestare_nn_1_1_N : N ;
  skogstraedsfoeraedlare_nn_1_1_N : N ;
  skogvaktare_nn_1_N : N ;
  skojare_nn_1_N : N ;
  skolkare_nn_1_N : N ;
  skolledare_nn_1_N : N ;
  skollaerare_nn_1_1_N : N ;
  skolmaestare_nn_1_1_N : N ;
  skolvaktmaestare_nn_1_1_N : N ;
  skomakare_nn_1_N : N ;
  skonare_nn_1_N : N ;
  skoputsare_nn_1_N : N ;
  skorstensfejare_nn_1_N : N ;
  skrattare_nn_1_N : N ;
  skridskoaakare_nn_1_1_N : N ;
  skriftstaellare_nn_1_1_N : N ;
  skrinnare_nn_1_N : N ;
  skrivare_nn_1_N : N ;
  skrivmaskinstillverkare_nn_1_N : N ;
  skruvdragare_nn_1_N : N ;
  skrymtare_nn_1_N : N ;
  skrytare_nn_1_N : N ;
  skraeckskildrare_nn_1_1_N : N ;
  skraeddare_nn_1_1_N : N ;
  skraenare_nn_1_1_N : N ;
  skraevlare_nn_1_1_N : N ;
  skumslaeckare_nn_1_1_N : N ;
  skvallrare_nn_1_N : N ;
  skyddare_nn_1_N : N ;
  skaemtare_nn_1_1_N : N ;
  skaemttecknare_nn_1_1_N : N ;
  skaendare_nn_1_1_N : N ;
  skaerbraennare_nn_1_1_N : N ;
  skaergaardskryssare_nn_1_1_N : N ;
  skaermslaeckare_nn_1_1_N : N ;
  skaerslipare_nn_1_1_N : N ;
  skaadespelare_nn_1_1_N : N ;
  skaapsupare_nn_1_1_N : N ;
  skoeldhaallare_nn_1_1_N : N ;
  skoenskrivare_nn_1_1_N : N ;
  skoetare_nn_1_1_N : N ;
  sladdhaallare_nn_1_1_N : N ;
  sladdrare_nn_1_N : N ;
  slaktare_nn_1_N : N ;
  slalomaakare_nn_1_1_N : N ;
  slamkrypare_nn_1_N : N ;
  slavarbetare_nn_1_N : N ;
  slavdrivare_nn_1_N : N ;
  slavhandlare_nn_1_N : N ;
  slavsaendare_nn_1_1_N : N ;
  slutare_nn_1_N : N ;
  sloejdare_nn_1_1_N : N ;
  sloesare_nn_1_1_N : N ;
  smakdomare_nn_1_N : N ;
  smakfoerstaerkare_nn_1_1_N : N ;
  smickrare_nn_1_N : N ;
  smidare_nn_1_N : N ;
  smilare_nn_1_N : N ;
  sminkare_nn_1_N : N ;
  smitare_nn_1_N : N ;
  smittbaerare_nn_1_1_N : N ;
  smittskyddslaekare_nn_1_1_N : N ;
  smittskyddssamordnare_nn_1_N : N ;
  smugglare_nn_1_N : N ;
  smygjaegare_nn_1_1_N : N ;
  smaedare_nn_1_1_N : N ;
  smaellare_nn_1_1_N : N ;
  smaaborgare_nn_1_1_N : N ;
  smaabrukare_nn_1_1_N : N ;
  smaafoeretagare_nn_1_1_N : N ;
  smaagnagare_nn_1_1_N : N ;
  smaahandlare_nn_1_1_N : N ;
  smaahusaegare_nn_1_1_N : N ;
  smaajordbrukare_nn_1_1_N : N ;
  smaasparare_nn_1_1_N : N ;
  snabbladdare_nn_1_N : N ;
  snabbvaeljare_nn_1_1_N : N ;
  snarkare_nn_1_N : N ;
  snattare_nn_1_N : N ;
  snedseglare_nn_1_N : N ;
  snickare_nn_1_N : N ;
  snidare_nn_1_N : N ;
  snitsare_nn_1_N : N ;
  snoppare_nn_1_N : N ;
  snyltare_nn_1_N : N ;
  snoepare_nn_1_1_N : N ;
  snoermakare_nn_1_1_N : N ;
  snoescooterfoerare_nn_1_1_N : N ;
  snoeskoterfoerare_nn_1_1_N : N ;
  snoeskottare_nn_1_1_N : N ;
  socialarbetare_nn_1_N : N ;
  socialhjaelpstagare_nn_1_1_N : N ;
  sociallaekare_nn_1_1_N : N ;
  socialmedicinare_nn_1_N : N ;
  sockerbagare_nn_1_N : N ;
  sockerstroeare_nn_1_1_N : N ;
  soffliggare_nn_1_N : N ;
  sol_och_vaarare_nn_1_1_N : N ;
  solbadare_nn_1_N : N ;
  soldyrkare_nn_1_N : N ;
  solforskare_nn_1_N : N ;
  solfaangare_nn_1_1_N : N ;
  solochvaarare_nn_1_1_N : N ;
  solvisare_nn_1_N : N ;
  solvaermefaangare_nn_1_1_N : N ;
  sommarpratare_nn_1_N : N ;
  sommarstugeaegare_nn_1_1_N : N ;
  sophaemtare_nn_1_1_N : N ;
  sopsaeckshaallare_nn_1_1_N : N ;
  sopaakare_nn_1_1_N : N ;
  sorterare_nn_1_N : N ;
  sotare_nn_1_N : N ;
  sovjetmedborgare_nn_1_N : N ;
  spanare_nn_1_N : N ;
  sparare_nn_1_N : N ;
  specerihandlare_nn_1_N : N ;
  specialare_nn_1_N : N ;
  specialdammsugare_nn_1_N : N ;
  speciallaerare_nn_1_1_N : N ;
  spejare_nn_1_N : N ;
  spelare_nn_1_N : N ;
  spetsborgare_nn_1_N : N ;
  spinnare_nn_1_N : N ;
  spisare_nn_1_N : N ;
  splittrare_nn_1_N : N ;
  spridare_nn_1_N : N ;
  springare_nn_1_N : N ;
  spritsmugglare_nn_1_N : N ;
  spraakbrukare_nn_1_1_N : N ;
  spraakforskare_nn_1_1_N : N ;
  spraaklaerare_nn_1_1_N : N ;
  spraakvetare_nn_1_1_N : N ;
  spraakvaardare_nn_1_1_N : N ;
  spaeckhuggare_nn_1_1_N : N ;
  spaenningsdelare_nn_1_1_N : N ;
  spaenningsomvandlare_nn_1_1_N : N ;
  spaenningssoekare_nn_1_1_N : N ;
  spoekskrivare_nn_1_1_N : N ;
  stackare_nn_1_N : N ;
  stadsjeepaegare_nn_1_1_N : N ;
  stadsplanerare_nn_1_N : N ;
  stadssekreterare_nn_1_N : N ;
  stafettlaekare_nn_1_1_N : N ;
  stalkare_nn_1_N : N ;
  stallmaestare_nn_1_1_N : N ;
  stamkrigare_nn_1_N : N ;
  stammare_nn_1_N : N ;
  statare_nn_1_N : N ;
  statssekreterare_nn_1_N : N ;
  statsvetare_nn_1_N : N ;
  stegraeknare_nn_1_1_N : N ;
  stekare_nn_1_N : N ;
  stekburgare_nn_1_N : N ;
  stenhuggare_nn_1_N : N ;
  stenkastare_nn_1_N : N ;
  stensaettare_nn_1_1_N : N ;
  stiftare_nn_1_N : N ;
  stigfinnare_nn_1_N : N ;
  stilbildare_nn_1_N : N ;
  stjaernkroegare_nn_1_1_N : N ;
  stjaernskaadespelare_nn_1_1_N : N ;
  stjaerntraenare_nn_1_1_N : N ;
  stjaerntydare_nn_1_1_N : N ;
  stockholmare_nn_1_N : N ;
  storbolagsaegare_nn_1_1_N : N ;
  storgodsaegare_nn_1_1_N : N ;
  stormaestare_nn_1_1_N : N ;
  storskrytare_nn_1_N : N ;
  storskraevlare_nn_1_1_N : N ;
  storsaeljare_nn_1_1_N : N ;
  storviltjaegare_nn_1_1_N : N ;
  strandpipare_nn_1_N : N ;
  streckkodlaesare_nn_1_1_N : N ;
  streckkodslaesare_nn_1_1_N : N ;
  strejkare_nn_1_N : N ;
  strejkbrytare_nn_1_N : N ;
  stridsdomare_nn_1_N : N ;
  strumphaallare_nn_1_1_N : N ;
  strupsaangare_nn_1_1_N : N ;
  strykare_nn_1_N : N ;
  strypare_nn_1_N : N ;
  straeckare_nn_1_1_N : N ;
  straevpelare_nn_1_1_N : N ;
  straalgaangsmaetare_nn_1_1_N : N ;
  straalkastare_nn_1_1_N : N ;
  straatroevare_nn_1_1_N : N ;
  stroeare_nn_1_1_N : N ;
  stroemavtagare_nn_1_1_N : N ;
  stroembrytare_nn_1_1_N : N ;
  stroemmaetare_nn_1_1_N : N ;
  stroemstaellare_nn_1_1_N : N ;
  stroevare_nn_1_1_N : N ;
  studievaegledare_nn_1_1_N : N ;
  studsare_nn_1_N : N ;
  stugsittare_nn_1_N : N ;
  stuvare_nn_1_N : N ;
  stuveriarbetare_nn_1_N : N ;
  styckjunkare_nn_1_N : N ;
  styckmaestare_nn_1_1_N : N ;
  styckmoerdare_nn_1_1_N : N ;
  stympare_nn_1_N : N ;
  styrkeledare_nn_1_N : N ;
  staedare_nn_1_1_N : N ;
  staellfoeretraedare_nn_1_1_N : N ;
  staemningshoejare_nn_1_1_N : N ;
  staandare_nn_1_1_N : N ;
  staangryttare_nn_1_1_N : N ;
  staathaallare_nn_1_1_N : N ;
  staauppare_nn_1_1_N : N ;
  stoedjepelare_nn_1_1_N : N ;
  stoepplare_nn_1_1_N : N ;
  stoetdaempare_nn_1_1_N : N ;
  stoetfaangare_nn_1_1_N : N ;
  stoettepelare_nn_1_1_N : N ;
  stoevare_nn_1_1_N : N ;
  supare_nn_1_N : N ;
  supraledare_nn_1_N : N ;
  surfare_nn_1_N : N ;
  sutare_nn_1_N : N ;
  svampplockare_nn_1_N : N ;
  svansviftare_nn_1_N : N ;
  svarvare_nn_1_N : N ;
  svenskfoernekare_nn_1_1_N : N ;
  svenskhetsivrare_nn_1_N : N ;
  svensklaerare_nn_1_1_N : N ;
  svetsare_nn_1_N : N ;
  svikare_nn_1_N : N ;
  svindlare_nn_1_N : N ;
  svirare_nn_1_N : N ;
  svaerdbaerare_nn_1_1_N : N ;
  svaerdfejare_nn_1_1_N : N ;
  svaerdsfejare_nn_1_1_N : N ;
  svaerdslukare_nn_1_1_N : N ;
  svaerdsslukare_nn_1_1_N : N ;
  svaermare_nn_1_1_N : N ;
  svaevare_nn_1_1_N : N ;
  svaevarklippare_nn_1_1_N : N ;
  swazilaendare_nn_1_1_N : N ;
  synare_nn_1_N : N ;
  syndare_nn_1_N : N ;
  syraprovare_nn_1_N : N ;
  systemerare_nn_1_N : N ;
  systemutvecklare_nn_1_N : N ;
  saedesledare_nn_1_1_N : N ;
  saekerhetsbrytare_nn_1_1_N : N ;
  saekerhetsraadgivare_nn_1_1_N : N ;
  saekringshaallare_nn_1_1_N : N ;
  saeljare_nn_1_1_N : N ;
  saendare_nn_1_1_N : N ;
  saengfoesare_nn_1_1_N : N ;
  saengroekare_nn_1_1_N : N ;
  saengvaetare_nn_1_1_N : N ;
  saettare_nn_1_1_N : N ;
  saevsaangare_nn_1_1_N : N ;
  saagverksarbetare_nn_1_1_N : N ;
  saagverksjobbare_nn_1_1_N : N ;
  saanganfoerare_nn_1_1_N : N ;
  saangare_nn_1_1_N : N ;
  soekare_nn_1_1_N : N ;
  soelare_nn_1_1_N : N ;
  soemmare_nn_1_1_N : N ;
  soemngaangare_nn_1_1_N : N ;
  soendagsjaegare_nn_1_1_N : N ;
  soetvattensforskare_nn_1_1_N : N ;
  tackjaernsblandare_nn_1_1_N : N ;
  taffeltaeckare_nn_1_1_N : N ;
  tafsare_nn_1_N : N ;
  taggare_nn_1_N : N ;
  takklaettrare_nn_1_1_N : N ;
  taklaeggare_nn_1_1_N : N ;
  takryttare_nn_1_N : N ;
  takskottare_nn_1_N : N ;
  taktaeckare_nn_1_1_N : N ;
  talare_nn_1_N : N ;
  tallmaetare_nn_1_1_N : N ;
  tallriksslickare_nn_1_N : N ;
  tallspinnare_nn_1_N : N ;
  talskrivare_nn_1_N : N ;
  tamburvaktmaestare_nn_1_1_N : N ;
  tandlaekare_nn_1_1_N : N ;
  tandpetare_nn_1_N : N ;
  tangodansare_nn_1_N : N ;
  tankelaesare_nn_1_1_N : N ;
  tankestaellare_nn_1_1_N : N ;
  tape_nn_1_N : N ;
  tapetserare_nn_1_N : N ;
  taskspelare_nn_1_N : N ;
  tattare_nn_1_N : N ;
  tatuerare_nn_1_N : N ;
  teaterbesoekare_nn_1_1_N : N ;
  teaterkikare_nn_1_N : N ;
  teckenskaadare_nn_1_1_N : N ;
  teckentydare_nn_1_N : N ;
  tecknare_nn_1_N : N ;
  tegelbruksarbetare_nn_1_N : N ;
  tegelmaestare_nn_1_1_N : N ;
  tegelslagare_nn_1_N : N ;
  teknikraadgivare_nn_1_1_N : N ;
  tekokare_nn_1_N : N ;
  telefonsvarare_nn_1_N : N ;
  telefonvaektare_nn_1_1_N : N ;
  tempelriddare_nn_1_N : N ;
  temperaturgivare_nn_1_N : N ;
  tempoarbetare_nn_1_N : N ;
  tennisspelare_nn_1_N : N ;
  tenorsaangare_nn_1_1_N : N ;
  terroristledare_nn_1_N : N ;
  testuggare_nn_1_N : N ;
  tevemottagare_nn_1_N : N ;
  tevesaendare_nn_1_1_N : N ;
  tevetittare_nn_1_N : N ;
  textilarbetare_nn_1_N : N ;
  textillaerare_nn_1_1_N : N ;
  thailaendare_nn_1_1_N : N ;
  tibetanare_nn_1_N : N ;
  tidningsledare_nn_1_N : N ;
  tidningslaesare_nn_1_1_N : N ;
  tidstroemstaellare_nn_1_1_N : N ;
  tidtagare_nn_1_N : N ;
  tigare_nn_1_N : N ;
  tiggare_nn_1_N : N ;
  tillbedjare_nn_1_N : N ;
  tillbringare_nn_1_N : N ;
  tillfaellighetsfoerbrytare_nn_1_1_N : N ;
  tillskyndare_nn_1_N : N ;
  tillskaerare_nn_1_1_N : N ;
  tillslutare_nn_1_N : N ;
  tillstaellare_nn_1_1_N : N ;
  tillsynslaerare_nn_1_1_N : N ;
  tilltraedare_nn_1_1_N : N ;
  tillverkare_nn_1_N : N ;
  timlaerare_nn_1_1_N : N ;
  timvisare_nn_1_N : N ;
  tippare_nn_1_N : N ;
  tisslare_nn_1_N : N ;
  titelfoersvarare_nn_1_1_N : N ;
  tittare_nn_1_N : N ;
  tjallare_nn_1_N : N ;
  tjottablaengare_nn_1_1_N : N ;
  tjurfaektare_nn_1_1_N : N ;
  tjurfaektningsmotstaandare_nn_1_1_N : N ;
  tjusare_nn_1_N : N ;
  tjuvfiskare_nn_1_N : N ;
  tjuvgoemmare_nn_1_1_N : N ;
  tjuvjaegare_nn_1_1_N : N ;
  tjyvfiskare_nn_1_N : N ;
  tjyvjaegare_nn_1_1_N : N ;
  tjaenare_nn_1_1_N : N ;
  tjaenstefoerraettare_nn_1_1_N : N ;
  tobakshandlare_nn_1_N : N ;
  toftvaegare_nn_1_1_N : N ;
  tolkare_nn_1_N : N ;
  tolvtaggare_nn_1_N : N ;
  tomtjobbare_nn_1_N : N ;
  tonsaettare_nn_1_1_N : N ;
  tonaarsfoeroevare_nn_1_1_N : N ;
  torktumlare_nn_1_N : N ;
  tornseglare_nn_1_N : N ;
  tornvaektare_nn_1_1_N : N ;
  torpare_nn_1_N : N ;
  torpaegare_nn_1_1_N : N ;
  totempelare_nn_1_N : N ;
  traditionsbaerare_nn_1_1_N : N ;
  trafikdelare_nn_1_N : N ;
  trafikflygare_nn_1_N : N ;
  trafikledare_nn_1_N : N ;
  tragedifoerfattare_nn_1_1_N : N ;
  transportarbetare_nn_1_N : N ;
  travare_nn_1_N : N ;
  treaktare_nn_1_N : N ;
  tremastare_nn_1_N : N ;
  trendsaettare_nn_1_1_N : N ;
  trerummare_nn_1_N : N ;
  trevare_nn_1_N : N ;
  tripplare_nn_1_N : N ;
  trippmaetare_nn_1_1_N : N ;
  tronfoeljare_nn_1_1_N : N ;
  trosbekaennare_nn_1_1_N : N ;
  trosivrare_nn_1_N : N ;
  trosletare_nn_1_N : N ;
  trotjaenare_nn_1_1_N : N ;
  trumpetare_nn_1_N : N ;
  trumslagare_nn_1_N : N ;
  tryckare_nn_1_N : N ;
  tryckbehaallare_nn_1_1_N : N ;
  tryckbraennare_nn_1_1_N : N ;
  tryckkokare_nn_1_N : N ;
  traeblaasare_nn_1_1_N : N ;
  traedgaardsmaestare_nn_1_1_N : N ;
  traedgaardsodlare_nn_1_1_N : N ;
  traedgaardsstaedare_nn_1_1_N : N ;
  traedgaardssaangare_nn_1_1_N : N ;
  traedkramare_nn_1_1_N : N ;
  traedkrypare_nn_1_1_N : N ;
  traenare_nn_1_1_N : N ;
  traesnidare_nn_1_1_N : N ;
  traalare_nn_1_1_N : N ;
  troestare_nn_1_1_N : N ;
  tubkikare_nn_1_N : N ;
  tuktomaestare_nn_1_1_N : N ;
  tullare_nn_1_N : N ;
  tullfoervaltare_nn_1_1_N : N ;
  tumlare_nn_1_N : N ;
  tumsugare_nn_1_N : N ;
  tungomaalstalare_nn_1_1_N : N ;
  tungviktare_nn_1_N : N ;
  tungvrickare_nn_1_N : N ;
  tunnbindare_nn_1_N : N ;
  tv_mottagare_nn_1_N : N ;
  tv_saendare_nn_1_1_N : N ;
  tv_tittare_nn_1_N : N ;
  tvivlare_nn_1_N : N ;
  tvaabyggare_nn_1_1_N : N ;
  tvaamastare_nn_1_1_N : N ;
  tvaarummare_nn_1_1_N : N ;
  tvaastegsavtryckare_nn_1_1_N : N ;
  tvaataktare_nn_1_1_N : N ;
  tyckare_nn_1_N : N ;
  tyngdlyftare_nn_1_N : N ;
  tyrolare_nn_1_N : N ;
  tysklaerare_nn_1_1_N : N ;
  taeljare_nn_1_1_N : N ;
  taeltare_nn_1_1_N : N ;
  taendare_nn_1_1_N : N ;
  taenkare_nn_1_1_N : N ;
  taerningsbaegare_nn_1_1_N : N ;
  taerningsspelare_nn_1_1_N : N ;
  taevlingsledare_nn_1_1_N : N ;
  taagklarerare_nn_1_1_N : N ;
  taagpassagerare_nn_1_1_N : N ;
  taagraanare_nn_1_1_N : N ;
  taagaangare_nn_1_1_N : N ;
  toejningsmaetare_nn_1_1_N : N ;
  toernsaangare_nn_1_1_N : N ;
  ubaatsfoerstoerare_nn_1_1_N : N ;
  ubaatsjagare_nn_1_1_N : N ;
  ufohackare_nn_1_N : N ;
  ukrainare_nn_1_N : N ;
  underbefaelhavare_nn_1_1_N : N ;
  undergoerare_nn_1_1_N : N ;
  underhandlare_nn_1_N : N ;
  underhuggare_nn_1_N : N ;
  underhaallare_nn_1_1_N : N ;
  underklassare_nn_1_N : N ;
  underledare_nn_1_N : N ;
  underlaekare_nn_1_1_N : N ;
  underspaennare_nn_1_1_N : N ;
  understreckare_nn_1_N : N ;
  undersoekare_nn_1_1_N : N ;
  undersoekningsdomare_nn_1_1_N : N ;
  undertecknare_nn_1_N : N ;
  undervisare_nn_1_N : N ;
  ungdomsledare_nn_1_N : N ;
  ungdomsvaeljare_nn_1_1_N : N ;
  ungrare_nn_1_N : N ;
  uppassare_nn_1_N : N ;
  uppbackare_nn_1_N : N ;
  uppdragsgivare_nn_1_N : N ;
  uppdragsmoerdare_nn_1_1_N : N ;
  uppdragstagare_nn_1_N : N ;
  uppesittare_nn_1_N : N ;
  uppfinnare_nn_1_N : N ;
  uppfostrare_nn_1_N : N ;
  uppfoedare_nn_1_1_N : N ;
  uppfoeljare_nn_1_1_N : N ;
  uppgiftslaemnare_nn_1_1_N : N ;
  upphalare_nn_1_N : N ;
  upphandlare_nn_1_N : N ;
  upphittare_nn_1_N : N ;
  upphovsraettsinnehavare_nn_1_1_N : N ;
  uppkomlingsbloggare_nn_1_N : N ;
  uppkoepare_nn_1_1_N : N ;
  upplaesare_nn_1_1_N : N ;
  uppmaerksamhetspaakallare_nn_1_1_N : N ;
  upprorsmakare_nn_1_N : N ;
  upprymmare_nn_1_N : N ;
  uppraettare_nn_1_1_N : N ;
  uppraetthaallare_nn_1_1_N : N ;
  uppsamlare_nn_1_N : N ;
  uppsittare_nn_1_N : N ;
  uppskaerare_nn_1_1_N : N ;
  uppstickare_nn_1_N : N ;
  uppsaettare_nn_1_1_N : N ;
  upptecknare_nn_1_N : N ;
  upptaeckare_nn_1_1_N : N ;
  upptaagsmakare_nn_1_1_N : N ;
  uppviglare_nn_1_N : N ;
  uppaatstraevare_nn_1_1_N : N ;
  urinbyggare_nn_1_N : N ;
  urinledare_nn_1_N : N ;
  urinnevaanare_nn_1_1_N : N ;
  urinvaanare_nn_1_1_N : N ;
  urladdare_nn_1_N : N ;
  urmakare_nn_1_N : N ;
  uruguayare_nn_1_N : N ;
  utbordare_nn_1_N : N ;
  utbrytare_nn_1_N : N ;
  utdragare_nn_1_N : N ;
  uteliggare_nn_1_N : N ;
  utespelare_nn_1_N : N ;
  uteaetare_nn_1_1_N : N ;
  utforskare_nn_1_N : N ;
  utfoersaakare_nn_1_1_N : N ;
  utgivare_nn_1_N : N ;
  utgraevare_nn_1_1_N : N ;
  uthalare_nn_1_N : N ;
  utkastare_nn_1_N : N ;
  utkoerare_nn_1_1_N : N ;
  utlaeggare_nn_1_1_N : N ;
  utlaanare_nn_1_1_N : N ;
  utloepare_nn_1_1_N : N ;
  utloesare_nn_1_1_N : N ;
  utmanare_nn_1_N : N ;
  utnyttjare_nn_1_N : N ;
  utombordare_nn_1_N : N ;
  utpressare_nn_1_N : N ;
  utredare_nn_1_N : N ;
  utriggare_nn_1_N : N ;
  utrikespassagerare_nn_1_N : N ;
  utropare_nn_1_N : N ;
  utstaellare_nn_1_1_N : N ;
  utsugare_nn_1_N : N ;
  uttolkare_nn_1_N : N ;
  uttydare_nn_1_N : N ;
  utvandrare_nn_1_N : N ;
  utoevare_nn_1_1_N : N ;
  vabbare_nn_1_N : N ;
  vadare_nn_1_N : N ;
  vadhaallare_nn_1_1_N : N ;
  vakare_nn_1_N : N ;
  vaktare_nn_1_N : N ;
  vaktmaestare_nn_1_1_N : N ;
  valarbetare_nn_1_N : N ;
  valdeltagare_nn_1_N : N ;
  valfaangare_nn_1_1_N : N ;
  valkare_nn_1_N : N ;
  vallare_nn_1_N : N ;
  valvinnare_nn_1_N : N ;
  vandrare_nn_1_N : N ;
  vanedrinkare_nn_1_N : N ;
  vanefoerbrytare_nn_1_1_N : N ;
  vaneaetare_nn_1_1_N : N ;
  vantspridare_nn_1_N : N ;
  vapendragare_nn_1_N : N ;
  vapenvaegrare_nn_1_1_N : N ;
  varghatare_nn_1_N : N ;
  varmvattenberedare_nn_1_N : N ;
  varmvattensberedare_nn_1_N : N ;
  varuhavare_nn_1_N : N ;
  varvmaetare_nn_1_1_N : N ;
  varvraeknare_nn_1_1_N : N ;
  varvsarbetare_nn_1_N : N ;
  vattenbehaallare_nn_1_1_N : N ;
  vattendelare_nn_1_N : N ;
  vattenkastare_nn_1_N : N ;
  vattenkokare_nn_1_N : N ;
  vattenloepare_nn_1_1_N : N ;
  vattenpelare_nn_1_N : N ;
  vattenrallare_nn_1_N : N ;
  vattenspridare_nn_1_N : N ;
  vattenstaandsvisare_nn_1_1_N : N ;
  vattenvaermare_nn_1_1_N : N ;
  vattnare_nn_1_N : N ;
  vecklare_nn_1_N : N ;
  vedbaerare_nn_1_1_N : N ;
  vederdoepare_nn_1_1_N : N ;
  vedersakare_nn_1_N : N ;
  vedhuggare_nn_1_N : N ;
  venetianare_nn_1_N : N ;
  verkmaestare_nn_1_1_N : N ;
  verkslaekare_nn_1_1_N : N ;
  verkstadsarbetare_nn_1_N : N ;
  verkstaellare_nn_1_1_N : N ;
  vernissagebesoekare_nn_1_1_N : N ;
  versmakare_nn_1_N : N ;
  vertikalskaerare_nn_1_1_N : N ;
  vetenskapare_nn_1_N : N ;
  victoriakorsvinnare_nn_1_N : N ;
  videobandspelare_nn_1_N : N ;
  vikare_nn_1_N : N ;
  viktighetsmakare_nn_1_N : N ;
  viktjusterare_nn_1_N : N ;
  vildbasare_nn_1_N : N ;
  villaaegare_nn_1_1_N : N ;
  vilthandlare_nn_1_N : N ;
  viltvaardare_nn_1_1_N : N ;
  vinare_nn_1_N : N ;
  vindmaetare_nn_1_1_N : N ;
  vindrutespolare_nn_1_N : N ;
  vindrutetorkare_nn_1_N : N ;
  vinglare_nn_1_N : N ;
  vingtaeckare_nn_1_1_N : N ;
  vingaardsarbetare_nn_1_1_N : N ;
  vinkelmaetare_nn_1_1_N : N ;
  vinkaennare_nn_1_1_N : N ;
  vinmakare_nn_1_N : N ;
  vinnare_nn_1_N : N ;
  vinodlare_nn_1_N : N ;
  vinterbadare_nn_1_N : N ;
  vinteridrottare_nn_1_N : N ;
  vinterliggare_nn_1_N : N ;
  visare_nn_1_N : N ;
  viskare_nn_1_N : N ;
  visslare_nn_1_N : N ;
  vissaangare_nn_1_1_N : N ;
  vitsare_nn_1_N : N ;
  voltmaetare_nn_1_1_N : N ;
  vrakletare_nn_1_N : N ;
  vrakplundrare_nn_1_N : N ;
  vraekare_nn_1_1_N : N ;
  vaeckare_nn_1_1_N : N ;
  vaederbesvaerjare_nn_1_1_N : N ;
  vaegare_nn_1_1_N : N ;
  vaegbrytare_nn_1_1_N : N ;
  vaeggpelare_nn_1_1_N : N ;
  vaegledare_nn_1_1_N : N ;
  vaegmaetare_nn_1_1_N : N ;
  vaegrare_nn_1_1_N : N ;
  vaegroejare_nn_1_1_N : N ;
  vaegvisare_nn_1_1_N : N ;
  vaektare_nn_1_1_N : N ;
  vaelgoerare_nn_1_1_N : N ;
  vaeljare_nn_1_1_N : N ;
  vaeltalare_nn_1_1_N : N ;
  vaensteranhaengare_nn_1_1_N : N ;
  vaensterhandsspelare_nn_1_1_N : N ;
  vaepnare_nn_1_1_N : N ;
  vaerdemaetare_nn_1_1_N : N ;
  vaerderare_nn_1_1_N : N ;
  vaerldsborgare_nn_1_1_N : N ;
  vaerldseroevrare_nn_1_1_N : N ;
  vaerldsfoerbaettrare_nn_1_1_N : N ;
  vaerldsmedborgare_nn_1_1_N : N ;
  vaerldsmaestare_nn_1_1_N : N ;
  vaermeledare_nn_1_1_N : N ;
  vaermemaetare_nn_1_1_N : N ;
  vaermevaexlare_nn_1_1_N : N ;
  vaernpliktsvaegrare_nn_1_1_N : N ;
  vaeskryckare_nn_1_1_N : N ;
  vaestindiefarare_nn_1_1_N : N ;
  vaevare_nn_1_1_N : N ;
  vaevspaennare_nn_1_1_N : N ;
  vaexelgivare_nn_1_1_N : N ;
  vaexelryttare_nn_1_1_N : N ;
  vaexelutstaellare_nn_1_1_N : N ;
  vaexlare_nn_1_1_N : N ;
  vaextsamlare_nn_1_1_N : N ;
  vaextaetare_nn_1_1_N : N ;
  vaagbrytare_nn_1_1_N : N ;
  vaagmaestare_nn_1_1_N : N ;
  vaaldsverkare_nn_1_1_N : N ;
  vaardare_nn_1_1_N : N ;
  vaardgivare_nn_1_1_N : N ;
  vaardnadshavare_nn_1_1_N : N ;
  vaardtagare_nn_1_1_N : N ;
  vaartbitare_nn_1_1_N : N ;
  walesare_nn_1_N : N ;
  webblaesare_nn_1_1_N : N ;
  yrkesarbetare_nn_1_N : N ;
  yrkeslaerare_nn_1_1_N : N ;
  yrkesvaegledare_nn_1_1_N : N ;
  zeppelinare_nn_1_N : N ;
  zigenare_nn_1_N : N ;
  aegare_nn_1_1_N : N ;
  aeggkastare_nn_1_1_N : N ;
  aeggkokare_nn_1_1_N : N ;
  aeggledare_nn_1_1_N : N ;
  aeggprickare_nn_1_1_N : N ;
  aeggvaermare_nn_1_1_N : N ;
  aektenskapsbrytare_nn_1_1_N : N ;
  aektenskapsmaeklare_nn_1_1_N : N ;
  aelgjaegare_nn_1_1_N : N ;
  aelgstudsare_nn_1_1_N : N ;
  aelskare_nn_1_1_N : N ;
  aemnesfoeretraedare_nn_1_1_N : N ;
  aemneslaerare_nn_1_1_N : N ;
  aeppelvecklare_nn_1_1_N : N ;
  aerftlighetsforskare_nn_1_1_N : N ;
  aermhaallare_nn_1_1_N : N ;
  aertvecklare_nn_1_1_N : N ;
  aeventyrare_nn_1_1_N : N ;
  aahoerare_nn_1_1_N : N ;
  aakare_nn_1_1_N : N ;
  aakerbrukare_nn_1_1_N : N ;
  aakgraesklippare_nn_1_1_N : N ;
  aaklagare_nn_1_1_N : N ;
  aalfiskare_nn_1_1_N : N ;
  aangare_nn_1_1_N : N ;
  aangkokare_nn_1_1_N : N ;
  aaskledare_nn_1_1_N : N ;
  aaskaadare_nn_1_1_N : N ;
  aaskaadarlaektare_nn_1_1_N : N ;
  aasnedrivare_nn_1_1_N : N ;
  aaterfallsfoerbrytare_nn_1_1_N : N ;
  aaterfoersaeljare_nn_1_1_N : N ;
  aaterloesare_nn_1_1_N : N ;
  aaterstaellare_nn_1_1_N : N ;
  aatersaeljare_nn_1_1_N : N ;
  oedelaeggare_nn_1_1_N : N ;
  oegonlaekare_nn_1_1_N : N ;
  oegontjaenare_nn_1_1_N : N ;
  oegonoeppnare_nn_1_1_N : N ;
  oelsoerplare_nn_1_1_N : N ;
  oelutkoerare_nn_1_1_N : N ;
  oeloeppnare_nn_1_1_N : N ;
  oeppnare_nn_1_1_N : N ;
  oerngottsbandskrusare_nn_1_1_N : N ;
  oeronlaekare_nn_1_1_N : N ;
  oerontasslare_nn_1_1_N : N ;
  oertagaardsmaestare_nn_1_1_N : N ;
  oesterrikare_nn_1_1_N : N ;
  oeststatsledare_nn_1_1_N : N ;
  oeverbefaelhavare_nn_1_1_N : N ;
  oeverbringare_nn_1_1_N : N ;
  oeverdomare_nn_1_1_N : N ;
  oeverdaengare_nn_1_1_N : N ;
  oeverfoermyndare_nn_1_1_N : N ;
  oeverklassare_nn_1_1_N : N ;
  oeverliggare_nn_1_1_N : N ;
  oeverlaekare_nn_1_1_N : N ;
  oeverlaemnare_nn_1_1_N : N ;
  oeverlaerare_nn_1_1_N : N ;
  oeverlaatare_nn_1_1_N : N ;
  oeverloepare_nn_1_1_N : N ;
  oeversittare_nn_1_1_N : N ;
  oeverstaathaallare_nn_1_1_N : N ;
  oeversaettare_nn_1_1_N : N ;
  oevertraedare_nn_1_1_N : N ;
  oevervakare_nn_1_1_N : N ;
  oevningslaerare_nn_1_1_N : N ;
  airbag_nn_1_N : N ;
  allianskollega_nn_1_N : N ;
  alzheimers_nn_1_N : N ;
  amaryllis_nn_1_N : N ;
  ananas_nn_1_N : N ;
  ankar_nn_1_N : N ;
  anno_nn_1_N : N ;
  arresteringsorder_nn_1_N : N ;
  avsalu_nn_1_N : N ;
  avskrot_nn_1_N : N ;
  ayatollah_nn_1_N : N ;
  babord_nn_1_N : N ;
  babysitter_nn_1_N : N ;
  badmintonrack_nn_1_N : N ;
  bagis_nn_1_N : N ;
  bakhas_nn_1_N : N ;
  baluster_nn_1_N : N ;
  banco_nn_1_N : N ;
  banko_nn_1_N : N ;
  bark_nn_2_N : N ;
  bas_nn_3_N : N ;
  basset_nn_1_N : N ;
  belcanto_nn_1_N : N ;
  bellis_nn_1_N : N ;
  besservisser_nn_1_N : N ;
  besserwisser_nn_1_N : N ;
  bestseller_nn_1_N : N ;
  bibelvers_nn_1_N : N ;
  bill_nn_2_N : N ;
  binokel_nn_1_N : N ;
  bit_nn_2_N : N ;
  blankocheck_nn_1_N : N ;
  blinker_nn_1_N : N ;
  blaenk_nn_1_1_N : N ;
  bobsleigh_nn_1_N : N ;
  bolster_nn_1_N : N ;
  bomullstops_nn_1_N : N ;
  boom_nn_1_N : N ;
  bordtennisrack_nn_1_N : N ;
  borr_nn_2_N : N ;
  brats_nn_1_N : N ;
  bris_nn_1_N : N ;
  broiler_nn_1_N : N ;
  braeda_nn_1_1_N : N ;
  broesthoejd_nn_1_1_N : N ;
  budget_nn_1_N : N ;
  bukettgroent_nn_1_1_N : N ;
  bulldozer_nn_1_N : N ;
  bunker_nn_1_N : N ;
  burnus_nn_1_N : N ;
  byggcontainer_nn_1_N : N ;
  byxdress_nn_1_N : N ;
  baers_nn_2_1_N : N ;
  baest_foere_datum_nn_1_1_N : N ;
  baestfoere_datum_nn_1_1_N : N ;
  baestfoeredatum_nn_1_1_N : N ;
  centerforward_nn_1_N : N ;
  centerhalv_nn_1_N : N ;
  centimeter_nn_1_N : N ;
  check_nn_1_N : N ;
  cig_nn_1_N : N ;
  cigg_nn_1_N : N ;
  citydress_nn_1_N : N ;
  clematis_nn_1_N : N ;
  coach_nn_1_N : N ;
  cocktail_nn_1_N : N ;
  complet_nn_1_N : N ;
  container_nn_1_N : N ;
  corpus_nn_1_N : N ;
  cykel_nn_2_N : N ;
  dagens_nn_1_N : N ;
  dagorder_nn_1_N : N ;
  damgambit_nn_1_N : N ;
  dato_nn_1_N : N ;
  datum_nn_1_N : N ;
  debet_nn_1_N : N ;
  decimeter_nn_1_N : N ;
  defroster_nn_1_N : N ;
  dejt_nn_1_N : N ;
  deklarationsdags_nn_1_N : N ;
  diafragma_nn_1_N : N ;
  diamantborr_nn_1_N : N ;
  diktcykel_nn_1_N : N ;
  discjockey_nn_1_N : N ;
  diskjockey_nn_1_N : N ;
  dosis_nn_1_N : N ;
  dress_nn_1_N : N ;
  driftbudget_nn_1_N : N ;
  drop_in_nn_1_N : N ;
  dropin_nn_1_N : N ;
  dubbelnelson_nn_1_N : N ;
  dumper_nn_1_N : N ;
  dunbolster_nn_1_N : N ;
  e_post_nn_1_N : N ;
  eftermiddagsbris_nn_1_N : N ;
  egotripp_nn_1_N : N ;
  eldupphoerorder_nn_1_1_N : N ;
  embarras_nn_1_N : N ;
  en_tous_cas_nn_1_N : N ;
  envig_nn_1_N : N ;
  epost_nn_1_N : N ;
  exodus_nn_1_N : N ;
  falafel_nn_1_N : N ;
  fallout_nn_1_N : N ;
  farm_nn_1_N : N ;
  festivitas_nn_1_N : N ;
  filigram_nn_1_N : N ;
  filosofkollega_nn_1_N : N ;
  flanellpyjamas_nn_1_N : N ;
  flor_nn_2_N : N ;
  fog_nn_2_N : N ;
  formfranska_nn_1_N : N ;
  forward_nn_1_N : N ;
  foxtrot_nn_1_N : N ;
  foxtrott_nn_1_N : N ;
  franska_nn_2_N : N ;
  friholt_nn_1_N : N ;
  frihult_nn_1_N : N ;
  fusion_nn_2_N : N ;
  futt_nn_2_N : N ;
  fyrskaft_nn_1_N : N ;
  fyrspraang_nn_1_1_N : N ;
  foedelsedatum_nn_1_1_N : N ;
  foen_nn_2_1_N : N ;
  foerdevind_nn_1_1_N : N ;
  foerhaallningsorder_nn_1_1_N : N ;
  gambit_nn_1_N : N ;
  gan_nn_1_N : N ;
  gangster_nn_1_N : N ;
  gask_nn_1_N : N ;
  generalorder_nn_1_N : N ;
  getfot_nn_1_N : N ;
  gimmick_nn_1_N : N ;
  gingham_nn_1_N : N ;
  gist_nn_1_N : N ;
  gladiolus_nn_1_N : N ;
  glasprisma_nn_1_N : N ;
  glass_nn_1_N : N ;
  globetrotter_nn_1_N : N ;
  go_nn_2_N : N ;
  golvbraeda_nn_1_1_N : N ;
  gonggong_nn_1_N : N ;
  graal_nn_1_N : N ;
  gral_nn_1_N : N ;
  graaben_nn_1_1_N : N ;
  gurkha_nn_1_N : N ;
  halvmeter_nn_1_N : N ;
  halvnelson_nn_1_N : N ;
  hanrej_nn_1_N : N ;
  happening_nn_1_N : N ;
  has_nn_1_N : N ;
  hast_nn_1_N : N ;
  haubits_nn_1_N : N ;
  havsbris_nn_1_N : N ;
  hejd_nn_1_N : N ;
  helgsmaal_nn_1_1_N : N ;
  high_tech_nn_1_N : N ;
  hoper_nn_1_N : N ;
  hult_nn_1_N : N ;
  hum_nn_1_N : N ;
  hundan_nn_1_N : N ;
  hut_nn_1_N : N ;
  hyllmeter_nn_1_N : N ;
  hoeger_nn_1_1_N : N ;
  hoegflor_nn_1_1_N : N ;
  hoerhaall_nn_1_1_N : N ;
  imprimatur_nn_1_N : N ;
  inka_nn_1_N : N ;
  inkallelseorder_nn_1_N : N ;
  inloesen_nn_1_1_N : N ;
  insider_nn_1_N : N ;
  insteg_nn_1_N : N ;
  interferens_nn_2_N : N ;
  isranunkel_nn_1_N : N ;
  item_nn_1_N : N ;
  jack_nn_2_N : N ;
  jackpot_nn_1_N : N ;
  jazzschlager_nn_1_N : N ;
  jobbcoach_nn_1_N : N ;
  jockey_nn_1_N : N ;
  jojo_nn_1_N : N ;
  jordgubb_nn_1_N : N ;
  jugend_nn_1_N : N ;
  jaetteryck_nn_1_1_N : N ;
  kabinettsorder_nn_1_N : N ;
  kader_nn_1_N : N ;
  kakmix_nn_1_N : N ;
  kaliber_nn_1_N : N ;
  kaliberborr_nn_1_N : N ;
  kallskuret_nn_1_N : N ;
  kapitalbudget_nn_1_N : N ;
  kart_nn_1_N : N ;
  kem_nn_1_N : N ;
  kilogrammeter_nn_1_N : N ;
  kilometer_nn_1_N : N ;
  klematis_nn_1_N : N ;
  klerus_nn_1_N : N ;
  klink_nn_1_N : N ;
  klint_nn_1_N : N ;
  klo_nn_2_N : N ;
  knaster_nn_2_N : N ;
  kniptaangsmanoever_nn_1_1_N : N ;
  knaehoejd_nn_1_1_N : N ;
  kofot_nn_1_N : N ;
  kohl_nn_1_N : N ;
  kollega_nn_1_N : N ;
  kompaniorder_nn_1_N : N ;
  kongressdatum_nn_1_N : N ;
  kont_nn_1_N : N ;
  kontraorder_nn_1_N : N ;
  korpus_nn_1_N : N ;
  kos_nn_1_N : N ;
  kredit_nn_2_N : N ;
  krigsfot_nn_1_N : N ;
  kryddgroent_nn_1_1_N : N ;
  krysantemum_nn_1_N : N ;
  krysshult_nn_1_N : N ;
  kubikdecimeter_nn_1_N : N ;
  kubikmeter_nn_1_N : N ;
  kubikmillimeter_nn_1_N : N ;
  kungsgambit_nn_1_N : N ;
  kurbits_nn_1_N : N ;
  kvadratcentimeter_nn_1_N : N ;
  kvadratkilometer_nn_1_N : N ;
  kvadratmeter_nn_1_N : N ;
  kvart_nn_1_N : N ;
  kved_nn_1_N : N ;
  kvaellsbris_nn_1_1_N : N ;
  koep_slit_och_slaeng_nn_1_1_N : N ;
  lackroller_nn_1_N : N ;
  laissez_faire_nn_1_N : N ;
  lama_nn_3_N : N ;
  landbris_nn_1_N : N ;
  laptop_nn_1_N : N ;
  laptopp_nn_1_N : N ;
  lift_nn_1_N : N ;
  lilleputt_nn_1_N : N ;
  limes_nn_1_N : N ;
  liter_nn_1_N : N ;
  livscykel_nn_1_N : N ;
  lodled_nn_1_N : N ;
  lov_nn_2_N : N ;
  lovart_nn_1_N : N ;
  lues_nn_1_N : N ;
  lund_nn_1_N : N ;
  lyckotripp_nn_1_N : N ;
  lyster_nn_1_N : N ;
  laerktraetrall_nn_1_1_N : N ;
  laangfranska_nn_1_1_N : N ;
  laas_nn_1_1_N : N ;
  loenecheck_nn_1_1_N : N ;
  mannamaan_nn_1_1_N : N ;
  manoever_nn_1_1_N : N ;
  marienglas_nn_1_N : N ;
  marschorder_nn_1_N : N ;
  maskot_nn_1_N : N ;
  maxiroller_nn_1_N : N ;
  menstruationscykel_nn_1_N : N ;
  meter_nn_1_N : N ;
  mikrometer_nn_2_N : N ;
  militaerbudget_nn_1_1_N : N ;
  militaermanoever_nn_1_1_N : N ;
  millimeter_nn_1_N : N ;
  miniroller_nn_1_N : N ;
  misskredit_nn_1_N : N ;
  mix_nn_1_N : N ;
  mixer_nn_1_N : N ;
  monokel_nn_1_N : N ;
  monter_nn_1_N : N ;
  motvaern_nn_1_1_N : N ;
  muck_nn_1_N : N ;
  multum_nn_1_N : N ;
  mumsmums_nn_1_N : N ;
  musa_nn_1_N : N ;
  mysdress_nn_1_N : N ;
  maet_nn_1_1_N : N ;
  maan_nn_1_1_N : N ;
  maancykel_nn_1_1_N : N ;
  nakenskanner_nn_1_N : N ;
  nanometer_nn_1_N : N ;
  nationalbudget_nn_1_N : N ;
  nek_nn_1_N : N ;
  nelson_nn_1_N : N ;
  nen_nn_1_N : N ;
  newtonmeter_nn_1_N : N ;
  nippran_nn_1_N : N ;
  nit_nn_3_N : N ;
  noa_nn_1_N : N ;
  noll_nn_1_N : N ;
  nordanskog_nn_1_N : N ;
  norr_nn_1_N : N ;
  nostalgitripp_nn_1_N : N ;
  numro_nn_1_N : N ;
  naebb_nn_1_1_N : N ;
  naeverkont_nn_1_1_N : N ;
  noedvaern_nn_1_1_N : N ;
  oasis_nn_1_N : N ;
  officerskollega_nn_1_N : N ;
  oldboy_nn_1_N : N ;
  oljetanker_nn_1_N : N ;
  order_nn_1_N : N ;
  oro_nn_2_N : N ;
  otal_nn_1_N : N ;
  otid_nn_1_N : N ;
  oting_nn_1_N : N ;
  pacemaker_nn_1_N : N ;
  paddock_nn_1_N : N ;
  pajas_nn_1_N : N ;
  paria_nn_1_N : N ;
  parkas_nn_1_N : N ;
  parser_nn_1_N : N ;
  pelargonia_nn_1_N : N ;
  pellet_nn_1_N : N ;
  pensioneringsdatum_nn_1_N : N ;
  pipstopp_nn_1_N : N ;
  pir_nn_1_N : N ;
  playboy_nn_1_N : N ;
  ploj_nn_1_N : N ;
  plums_nn_1_N : N ;
  plaed_nn_1_1_N : N ;
  pojk_nn_1_N : N ;
  poster_nn_1_N : N ;
  print_on_demand_nn_1_N : N ;
  prisma_nn_1_N : N ;
  programbudget_nn_1_N : N ;
  psalmvers_nn_1_N : N ;
  purser_nn_1_N : N ;
  pyjamas_nn_1_N : N ;
  paers_nn_1_1_N : N ;
  quiz_nn_1_N : N ;
  quizz_nn_1_N : N ;
  racer_nn_1_N : N ;
  rack_nn_3_N : N ;
  ragnaroek_nn_1_1_N : N ;
  rambudget_nn_1_N : N ;
  ranunkel_nn_1_N : N ;
  ready_made_nn_1_N : N ;
  receiver_nn_1_N : N ;
  regeringskollega_nn_1_N : N ;
  remis_nn_1_N : N ;
  resecheck_nn_1_N : N ;
  ribba_nn_2_N : N ;
  ringfinger_nn_1_N : N ;
  rist_nn_1_N : N ;
  rits_nn_1_N : N ;
  roller_nn_1_N : N ;
  rund_nn_1_N : N ;
  rundhult_nn_1_N : N ;
  ruter_nn_2_N : N ;
  ryck_nn_2_N : N ;
  raeckhaall_nn_1_1_N : N ;
  raad_nn_3_13_N : N ;
  roestcoach_nn_1_1_N : N ;
  sagocykel_nn_1_N : N ;
  samizdat_nn_1_N : N ;
  sarg_nn_1_N : N ;
  scanner_nn_1_N : N ;
  scarf_nn_1_N : N ;
  schilling_nn_1_N : N ;
  schlager_nn_1_N : N ;
  scratch_nn_1_N : N ;
  sec_nn_1_N : N ;
  semitrailer_nn_1_N : N ;
  sexualcykel_nn_1_N : N ;
  shaker_nn_1_N : N ;
  sherpa_nn_1_N : N ;
  sicksack_nn_1_N : N ;
  sitter_nn_1_N : N ;
  sittup_nn_1_N : N ;
  sittupp_nn_1_N : N ;
  situp_nn_1_N : N ;
  situpp_nn_1_N : N ;
  sjutusan_nn_1_N : N ;
  skank_nn_1_N : N ;
  skanner_nn_1_N : N ;
  skenmanoever_nn_1_1_N : N ;
  skidlift_nn_1_N : N ;
  skolaest_nn_2_1_N : N ;
  skuggbudget_nn_1_N : N ;
  slejf_nn_1_N : N ;
  slipover_nn_1_N : N ;
  slugger_nn_1_N : N ;
  slukrist_nn_1_N : N ;
  slump_nn_1_N : N ;
  slaeplift_nn_1_1_N : N ;
  smaafranska_nn_1_1_N : N ;
  smaagangster_nn_1_1_N : N ;
  snutkollega_nn_1_N : N ;
  snoebudget_nn_1_1_N : N ;
  sol_och_vaar_nn_1_1_N : N ;
  solcykel_nn_1_N : N ;
  solochvaar_nn_1_1_N : N ;
  spaltkilometer_nn_1_N : N ;
  spann_nn_1_N : N ;
  spann_nn_2_N : N ;
  sponken_nn_1_N : N ;
  spaang_nn_1_1_N : N ;
  spaanken_nn_1_1_N : N ;
  squashrack_nn_1_N : N ;
  stadsdress_nn_1_N : N ;
  stalker_nn_1_N : N ;
  statsbudget_nn_1_N : N ;
  stenfot_nn_1_N : N ;
  steward_nn_1_N : N ;
  stewart_nn_1_N : N ;
  stopp_nn_2_N : N ;
  stout_nn_1_N : N ;
  stradivarius_nn_1_N : N ;
  styr_nn_1_N : N ;
  styrbord_nn_1_N : N ;
  succ_ethriller_nn_1_1_N : N ;
  sudd_nn_3_N : N ;
  supertanker_nn_1_N : N ;
  suput_nn_1_N : N ;
  surkart_nn_1_N : N ;
  svan_nn_1_N : N ;
  svank_nn_1_N : N ;
  syd_nn_1_N : N ;
  synhaall_nn_1_1_N : N ;
  synopsis_nn_1_N : N ;
  synthesizer_nn_1_N : N ;
  saerklass_nn_1_1_N : N ;
  saat_nn_1_1_N : N ;
  tabelras_nn_1_N : N ;
  tamtam_nn_1_N : N ;
  tandagnisslan_nn_1_N : N ;
  tandborr_nn_1_N : N ;
  tank_nn_2_N : N ;
  tanker_nn_1_N : N ;
  tappborr_nn_1_N : N ;
  tejp_nn_1_N : N ;
  telefonjack_nn_1_N : N ;
  tennisrack_nn_1_N : N ;
  textkorpus_nn_1_N : N ;
  thriller_nn_1_N : N ;
  tillfaellighetsvers_nn_1_1_N : N ;
  tilt_nn_2_N : N ;
  tjotaheiti_nn_1_N : N ;
  tjotahejti_nn_1_N : N ;
  tjottaheiti_nn_1_N : N ;
  tjottahejti_nn_1_N : N ;
  tjaern_nn_1_1_N : N ;
  tops_nn_1_N : N ;
  topspin_nn_1_N : N ;
  tortilla_nn_1_N : N ;
  trailer_nn_1_N : N ;
  trall_nn_2_N : N ;
  transponder_nn_1_N : N ;
  trekvart_nn_1_N : N ;
  treraetters_nn_1_1_N : N ;
  trick_nn_2_N : N ;
  tripp_nn_1_N : N ;
  trumf_nn_1_N : N ;
  tusan_nn_1_N : N ;
  tuskaft_nn_1_N : N ;
  tvesalu_nn_1_N : N ;
  tvaadagarstripp_nn_1_1_N : N ;
  tvaakomponents_nn_1_1_N : N ;
  tvaangsinloesen_nn_1_1_N : N ;
  tvaaskaft_nn_1_1_N : N ;
  undanmanoever_nn_1_1_N : N ;
  undseende_nn_1_N : N ;
  universalborr_nn_1_N : N ;
  uppbrottsorder_nn_1_N : N ;
  uppsjoe_nn_1_1_N : N ;
  utbetalningsorder_nn_1_N : N ;
  utgiftsbudget_nn_1_N : N ;
  vaj_nn_1_N : N ;
  vajsing_nn_1_N : N ;
  vamp_nn_1_N : N ;
  vank_nn_1_N : N ;
  varnagel_nn_1_N : N ;
  venia_nn_1_N : N ;
  vers_nn_1_N : N ;
  vinsch_nn_1_N : N ;
  vintergroent_nn_1_1_N : N ;
  vinterny_nn_1_N : N ;
  vaenster_nn_1_1_N : N ;
  vaerldsformat_nn_1_1_N : N ;
  vaerldsklass_nn_1_1_N : N ;
  vaesen_nn_1_1_N : N ;
  vaan_nn_1_1_N : N ;
  vaarbudget_nn_1_1_N : N ;
  workshop_nn_1_N : N ;
  yrkeskollega_nn_1_N : N ;
  aeppelkart_nn_1_1_N : N ;
  aepplekart_nn_1_1_N : N ;
  aerta_nn_1_1_N : N ;
  aettelaegg_nn_1_1_N : N ;
  aarscykel_nn_1_1_N : N ;
  aatervaendo_nn_1_1_N : N ;
  aatstramningsbudget_nn_1_1_N : N ;
  aattaaarscykel_nn_1_1_N : N ;
  oedesmaal_nn_1_1_N : N ;
  oegonsikte_nn_1_1_N : N ;
  oera_nn_2_1_N : N ;
  oere_nn_1_1_N : N ;
  oeverspel_nn_1_1_N : N ;
  oeverkommando_nn_1_1_N : N ;
  oekenrally_nn_1_1_N : N ;
  aatstramningsprogram_nn_1_1_N : N ;
  aatgaerdsprogram_nn_1_1_N : N ;
  aenglaspel_nn_1_1_N : N ;
  aecklo_nn_1_1_N : N ;
  zoo_nn_1_N : N ;
  zeugma_nn_1_N : N ;
  vaagspel_nn_1_1_N : N ;
  vaexelspel_nn_1_1_N : N ;
  vaexeldiskonto_nn_1_1_N : N ;
  vinterspel_nn_1_N : N ;
  vinterkvarter_nn_1_N : N ;
  vingummi_nn_1_N : N ;
  vindspel_nn_1_N : N ;
  villakvarter_nn_1_N : N ;
  varmgarage_nn_1_N : N ;
  uttalsfel_nn_1_N : N ;
  utspel_nn_1_N : N ;
  utbildningsprogram_nn_1_N : N ;
  uppspel_nn_1_N : N ;
  unigram_nn_1_N : N ;
  underraettelselaeckage_nn_1_1_N : N ;
  underhaallsprogram_nn_1_1_N : N ;
  underhaallningsprogram_nn_1_1_N : N ;
  taerningsspel_nn_1_1_N : N ;
  tv_program_nn_1_N : N ;
  traeningsdataspel_nn_1_1_N : N ;
  traeddiagram_nn_1_1_N : N ;
  tryckfel_nn_1_N : N ;
  trigram_nn_1_N : N ;
  totospel_nn_1_N : N ;
  tornerspel_nn_1_N : N ;
  ton_nn_2_N : N ;
  tjaenstefel_nn_1_1_N : N ;
  tillfriskningsprogram_nn_1_N : N ;
  teveprogram_nn_1_N : N ;
  telegram_nn_1_N : N ;
  telefonsvararprogram_nn_1_N : N ;
  tankefel_nn_1_N : N ;
  talkshowprogram_nn_1_N : N ;
  talfel_nn_1_N : N ;
  saangspel_nn_1_1_N : N ;
  saellskapsspel_nn_1_1_N : N ;
  syrenbuskage_nn_1_N : N ;
  syralaeckage_nn_1_1_N : N ;
  synfel_nn_1_N : N ;
  styrprogram_nn_1_N : N ;
  stroke_nn_1_N : N ;
  stormaktsspel_nn_1_N : N ;
  stolpdiagram_nn_1_N : N ;
  stockankare_nn_1_N : N ;
  stim_nn_1_N : N ;
  stenogram_nn_1_N : N ;
  stapeldiagram_nn_1_N : N ;
  spraakspel_nn_1_1_N : N ;
  spraakfel_nn_1_1_N : N ;
  sprututbytesprogram_nn_1_N : N ;
  spegelmonogram_nn_1_N : N ;
  sorgespel_nn_1_N : N ;
  sommarspel_nn_1_N : N ;
  sociogram_nn_1_N : N ;
  socialreportage_nn_1_N : N ;
  snyftreportage_nn_1_N : N ;
  slutspel_nn_1_N : N ;
  slutrim_nn_1_N : N ;
  slarvfel_nn_1_N : N ;
  skoetrum_nn_1_1_N : N ;
  skoenhetsfel_nn_1_1_N : N ;
  skaadespel_nn_1_1_N : N ;
  skyddsrum_nn_1_N : N ;
  skyddshem_nn_1_N : N ;
  skolhem_nn_1_N : N ;
  sjukhem_nn_1_N : N ;
  singelspel_nn_1_N : N ;
  servgame_nn_1_N : N ;
  serveringsrum_nn_1_N : N ;
  servegame_nn_1_N : N ;
  seriespel_nn_1_N : N ;
  seismogram_nn_1_N : N ;
  scharner_nn_1_N : N ;
  schackspel_nn_1_N : N ;
  satyrspel_nn_1_N : N ;
  samtalsrum_nn_1_N : N ;
  sammantraedesrum_nn_1_1_N : N ;
  samlingsrum_nn_1_N : N ;
  sakfel_nn_1_N : N ;
  sagovaesen_nn_1_1_N : N ;
  sabotage_nn_1_N : N ;
  raevspel_nn_1_1_N : N ;
  raettegaangsfel_nn_1_1_N : N ;
  raenkspel_nn_1_1_N : N ;
  raelsfel_nn_1_1_N : N ;
  raeddningshem_nn_1_1_N : N ;
  rymdprogram_nn_1_N : N ;
  rum_nn_1_N : N ;
  rollspel_nn_1_N : N ;
  roderfel_nn_1_N : N ;
  rim_nn_1_N : N ;
  revider_nn_1_N : N ;
  resereportage_nn_1_N : N ;
  reportage_nn_1_N : N ;
  rehabiliteringshem_nn_1_N : N ;
  reglage_nn_1_N : N ;
  registerton_nn_1_N : N ;
  radioprogram_nn_1_N : N ;
  radiogram_nn_1_N : N ;
  paaklaedningsrum_nn_1_1_N : N ;
  puzzle_nn_1_N : N ;
  provrum_nn_1_N : N ;
  program_nn_1_N : N ;
  privatiseringsprogram_nn_1_N : N ;
  principprogram_nn_1_N : N ;
  pressrevider_nn_1_N : N ;
  presidenthoegkvarter_nn_1_1_N : N ;
  pollendiagram_nn_1_N : N ;
  pogram_nn_1_N : N ;
  pinorum_nn_1_N : N ;
  piktogram_nn_1_N : N ;
  pianospel_nn_1_N : N ;
  personalrum_nn_1_N : N ;
  pentagram_nn_1_N : N ;
  passionsspel_nn_1_N : N ;
  partivaesen_nn_1_1_N : N ;
  partiprogram_nn_1_N : N ;
  parspel_nn_1_N : N ;
  paradrum_nn_1_N : N ;
  pannrum_nn_1_N : N ;
  oscillogram_nn_1_N : N ;
  orrspel_nn_1_N : N ;
  ordspel_nn_1_N : N ;
  omspel_nn_1_N : N ;
  omklaedningsrum_nn_1_1_N : N ;
  oljelaeckage_nn_1_1_N : N ;
  noejesprogram_nn_1_1_N : N ;
  noedrim_nn_1_1_N : N ;
  nyhetstelegram_nn_1_N : N ;
  nyhetsprogram_nn_1_N : N ;
  nyhetsankare_nn_1_N : N ;
  nomogram_nn_1_N : N ;
  nollsummespel_nn_1_N : N ;
  nettoregisterton_nn_1_N : N ;
  naturvaesen_nn_1_1_N : N ;
  narvfel_nn_1_N : N ;
  narrspel_nn_1_N : N ;
  nanogram_nn_1_N : N ;
  n_gram_nn_1_N : N ;
  moerkrum_nn_1_1_N : N ;
  maengddiagram_nn_1_1_N : N ;
  mysteriespel_nn_1_N : N ;
  musettedragspel_nn_1_N : N ;
  murankare_nn_1_N : N ;
  munspel_nn_1_N : N ;
  mottagningsrum_nn_1_N : N ;
  mottagningshem_nn_1_N : N ;
  moringsankare_nn_1_N : N ;
  montage_nn_1_N : N ;
  monogram_nn_1_N : N ;
  moderniseringsprogram_nn_1_N : N ;
  mjukvaruprogram_nn_1_N : N ;
  mirakelspel_nn_1_N : N ;
  minnesfel_nn_1_N : N ;
  milligram_nn_1_N : N ;
  mikrogram_nn_1_N : N ;
  mellanspel_nn_1_N : N ;
  mellanrum_nn_1_N : N ;
  megaton_nn_1_N : N ;
  medelfel_nn_1_N : N ;
  matrum_nn_1_N : N ;
  maskspel_nn_1_N : N ;
  maskinrum_nn_1_N : N ;
  maner_nn_2_N : N ;
  maktspel_nn_1_N : N ;
  laangspel_nn_1_1_N : N ;
  laesrum_nn_1_1_N : N ;
  laerarrum_nn_1_1_N : N ;
  laeggspel_nn_1_1_N : N ;
  laeckage_nn_1_1_N : N ;
  lyxtelegram_nn_1_N : N ;
  lustspel_nn_1_N : N ;
  lunchrum_nn_1_N : N ;
  luftsabotage_nn_1_N : N ;
  luftrum_nn_1_N : N ;
  luftfartssabotage_nn_1_N : N ;
  loppspel_nn_1_N : N ;
  logogram_nn_1_N : N ;
  linsfel_nn_1_N : N ;
  linjespel_nn_1_N : N ;
  libido_nn_1_N : N ;
  lemgram_nn_1_N : N ;
  lastrum_nn_1_N : N ;
  lagspel_nn_1_N : N ;
  lagrum_nn_1_N : N ;
  kyrkorum_nn_1_N : N ;
  kvarter_nn_1_N : N ;
  kurtage_nn_1_N : N ;
  kuratel_nn_1_N : N ;
  kulspel_nn_1_N : N ;
  kroenikespel_nn_1_1_N : N ;
  kryptogram_nn_1_N : N ;
  kronikerhem_nn_1_N : N ;
  kristusmonogram_nn_1_N : N ;
  krillstim_nn_1_N : N ;
  krigsspel_nn_1_N : N ;
  krigsreportage_nn_1_N : N ;
  kraftspel_nn_1_N : N ;
  kortspel_nn_1_N : N ;
  korrekturfel_nn_1_N : N ;
  konvalescenthem_nn_1_N : N ;
  kontrollrum_nn_1_N : N ;
  kontorsrum_nn_1_N : N ;
  konferensrum_nn_1_N : N ;
  kollage_nn_1_N : N ;
  klockspel_nn_1_N : N ;
  klipprum_nn_1_N : N ;
  klientel_nn_1_N : N ;
  klaver_nn_1_N : N ;
  klassrum_nn_1_N : N ;
  klaffel_nn_1_N : N ;
  kiloton_nn_1_N : N ;
  kilogram_nn_1_N : N ;
  killespel_nn_1_N : N ;
  kasus_nn_2_N : N ;
  kardiogram_nn_1_N : N ;
  kardinalfel_nn_1_N : N ;
  karaktaersfel_nn_1_1_N : N ;
  kapprum_nn_1_N : N ;
  kammarspel_nn_1_N : N ;
  kallgarage_nn_1_N : N ;
  julklappsrim_nn_1_N : N ;
  introduktionsprogram_nn_1_N : N ;
  intrigspel_nn_1_N : N ;
  intalan_nn_1_N : N ;
  inrim_nn_1_N : N ;
  inackorderingshem_nn_1_N : N ;
  ideogram_nn_1_N : N ;
  hoerspel_nn_1_1_N : N ;
  hoegkvarter_nn_1_1_N : N ;
  haalrum_nn_1_1_N : N ;
  haelsogym_nn_1_1_N : N ;
  huvudkvarter_nn_1_N : N ;
  hotellrum_nn_1_N : N ;
  hospice_nn_1_N : N ;
  hommage_nn_1_N : N ;
  hologram_nn_1_N : N ;
  hjaertfel_nn_1_1_N : N ;
  hem_nn_1_N : N ;
  hektogram_nn_1_N : N ;
  hastighetsreglage_nn_1_N : N ;
  hasardspel_nn_1_N : N ;
  handlingsprogram_nn_1_N : N ;
  handklaver_nn_1_N : N ;
  handbagage_nn_1_N : N ;
  hamnkvarter_nn_1_N : N ;
  halvrim_nn_1_N : N ;
  gaardsrum_nn_1_1_N : N ;
  gaangspel_nn_1_1_N : N ;
  gaestspel_nn_1_1_N : N ;
  gaestrum_nn_1_1_N : N ;
  gym_nn_1_N : N ;
  gyckelspel_nn_1_N : N ;
  gunrum_nn_1_N : N ;
  gubbslem_nn_1_N : N ;
  groetrim_nn_1_1_N : N ;
  grundfel_nn_1_N : N ;
  gratisspel_nn_1_N : N ;
  gratisprogram_nn_1_N : N ;
  gram_nn_1_N : N ;
  golfspel_nn_1_N : N ;
  glaedjekvarter_nn_1_1_N : N ;
  glapprum_nn_1_N : N ;
  gladiatorspel_nn_1_N : N ;
  gitarrspel_nn_1_N : N ;
  gigaton_nn_1_N : N ;
  generalfel_nn_1_N : N ;
  gasreglage_nn_1_N : N ;
  gaslaeckage_nn_1_1_N : N ;
  garage_nn_1_N : N ;
  game_nn_1_N : N ;
  gaffelankare_nn_1_N : N ;
  foeraeldrahem_nn_1_1_N : N ;
  foervaringsrum_nn_1_1_N : N ;
  foersvarsspel_nn_1_1_N : N ;
  foerspel_nn_1_1_N : N ;
  foerslagsrum_nn_1_1_N : N ;
  foersamlingshem_nn_1_1_N : N ;
  foerraadsrum_nn_1_1_N : N ;
  foerrum_nn_1_1_N : N ;
  foerhoersrum_nn_1_1_N : N ;
  foerdjupningsreportage_nn_1_1_N : N ;
  foedelsehem_nn_1_1_N : N ;
  faergspel_nn_1_1_N : N ;
  faedernehem_nn_1_1_N : N ;
  fritidshem_nn_1_N : N ;
  fotomontage_nn_1_N : N ;
  fotogram_nn_1_N : N ;
  fotfel_nn_1_N : N ;
  fosterhem_nn_1_N : N ;
  formspel_nn_1_N : N ;
  formfel_nn_1_N : N ;
  fonogram_nn_1_N : N ;
  folklustspel_nn_1_N : N ;
  folkhem_nn_1_N : N ;
  floedesdiagram_nn_1_1_N : N ;
  flipperspel_nn_1_N : N ;
  flaggspel_nn_1_N : N ;
  fittstim_nn_1_N : N ;
  fiskstim_nn_1_N : N ;
  finrum_nn_1_N : N ;
  festspel_nn_1_N : N ;
  festprogram_nn_1_N : N ;
  fegspel_nn_1_N : N ;
  featureprogram_nn_1_N : N ;
  fattigkvarter_nn_1_N : N ;
  fastage_nn_1_N : N ;
  fartreglage_nn_1_N : N ;
  fantasispel_nn_1_N : N ;
  faner_nn_1_N : N ;
  familjeprogram_nn_1_N : N ;
  familjehem_nn_1_N : N ;
  familjedaghem_nn_1_N : N ;
  falskspel_nn_1_N : N ;
  faktafel_nn_1_N : N ;
  eremitage_nn_1_N : N ;
  epitel_nn_1_N : N ;
  epigram_nn_1_N : N ;
  enkelspel_nn_1_N : N ;
  enkelrum_nn_1_N : N ;
  engram_nn_1_N : N ;
  enbaeddsrum_nn_1_1_N : N ;
  emballage_nn_1_N : N ;
  elevhem_nn_1_N : N ;
  elektrokardiogram_nn_1_N : N ;
  elektroencefalogram_nn_1_N : N ;
  eldrum_nn_1_N : N ;
  ekipage_nn_1_N : N ;
  egnahem_nn_1_N : N ;
  efterspel_nn_1_N : N ;
  dubbelspel_nn_1_N : N ;
  dubbelrum_nn_1_N : N ;
  dubbelgarage_nn_1_N : N ;
  dubbelfel_nn_1_N : N ;
  drivankare_nn_1_N : N ;
  drillprogram_nn_1_N : N ;
  drickankare_nn_1_N : N ;
  dragspel_nn_1_N : N ;
  dominospel_nn_1_N : N ;
  dokumentaerprogram_nn_1_1_N : N ;
  diskrum_nn_1_N : N ;
  diagram_nn_1_N : N ;
  deponens_nn_1_N : N ;
  dekolletage_nn_1_N : N ;
  deciton_nn_1_N : N ;
  debattprogram_nn_1_N : N ;
  debacle_nn_1_N : N ;
  dataspel_nn_1_N : N ;
  dataprogram_nn_1_N : N ;
  dartspel_nn_1_N : N ;
  damspel_nn_1_N : N ;
  damrum_nn_1_N : N ;
  dagsprogram_nn_1_N : N ;
  dagrum_nn_1_N : N ;
  daghem_nn_1_N : N ;
  college_nn_1_N : N ;
  collage_nn_1_N : N ;
  charner_nn_1_N : N ;
  ceremoniel_nn_1_N : N ;
  centigram_nn_1_N : N ;
  camouflage_nn_1_N : N ;
  boenerum_nn_1_1_N : N ;
  buskage_nn_1_N : N ;
  bubbelgum_nn_1_N : N ;
  broestpumpsutspel_nn_1_1_N : N ;
  broestmjoelkspumpsutspel_nn_1_1_N : N ;
  braedspel_nn_1_1_N : N ;
  brytningsfel_nn_1_N : N ;
  brytarfel_nn_1_N : N ;
  bruttoregisterton_nn_1_N : N ;
  bromsfel_nn_1_N : N ;
  brevtelegram_nn_1_N : N ;
  bostadskvarter_nn_1_N : N ;
  boningsrum_nn_1_N : N ;
  bollspel_nn_1_N : N ;
  bokstavsrim_nn_1_N : N ;
  bogankare_nn_1_N : N ;
  blommogram_nn_1_N : N ;
  blockdiagram_nn_1_N : N ;
  bistaandsprogram_nn_1_1_N : N ;
  biljardspel_nn_1_N : N ;
  bildspel_nn_1_N : N ;
  bildreportage_nn_1_N : N ;
  bildningsfel_nn_1_N : N ;
  bigram_nn_1_N : N ;
  besoeksrum_nn_1_1_N : N ;
  beslutsrum_nn_1_N : N ;
  bergrum_nn_1_N : N ;
  behandlingsrum_nn_1_N : N ;
  behandlingsprogram_nn_1_N : N ;
  behandlingshem_nn_1_N : N ;
  begynnelserim_nn_1_N : N ;
  begravningsspel_nn_1_N : N ;
  barogram_nn_1_N : N ;
  barnhem_nn_1_N : N ;
  barndomshem_nn_1_N : N ;
  barndaghem_nn_1_N : N ;
  baner_nn_1_N : N ;
  bandage_nn_1_N : N ;
  bakgrundsreportage_nn_1_N : N ;
  bagagerum_nn_1_N : N ;
  badrum_nn_1_N : N ;
  avbildningsfel_nn_1_N : N ;
  audiogram_nn_1_N : N ;
  asyndeton_nn_1_N : N ;
  arkadspel_nn_1_N : N ;
  arbetsrum_nn_1_N : N ;
  arbetarkvarter_nn_1_N : N ;
  apspel_nn_1_N : N ;
  apparatrum_nn_1_N : N ;
  apanage_nn_1_N : N ;
  antivirusprogram_nn_1_N : N ;
  ankarspel_nn_1_N : N ;
  ankare_nn_1_N : N ;
  anhaallan_nn_1_1_N : N ;
  anfallsspel_nn_1_N : N ;
  anestesirum_nn_1_N : N ;
  andevaesen_nn_1_1_N : N ;
  anagram_nn_1_N : N ;
  allrum_nn_1_N : N ;
  affaerskvarter_nn_1_1_N : N ;
  affinage_nn_1_N : N ;
  aerogram_nn_1_N : N ;
  adelshem_nn_1_N : N ;
  TV_program_nn_1_N : N ;
  SAP_program_nn_1_N : N ;
  Apolloprogram_nn_1_N : N ;
  xalkoholinnehav_nn_1_N : N ;
  oevervattensfartyg_nn_1_1_N : N ;
  oevertramp_nn_1_1_N : N ;
  oevertidsberg_nn_1_1_N : N ;
  oevertalningsfoersoek_nn_1_1_N : N ;
  oevertag_nn_1_1_N : N ;
  oeversaettningsprov_nn_1_1_N : N ;
  oeversaettningslaan_nn_1_1_N : N ;
  oeverstroemsskydd_nn_1_1_N : N ;
  oeverslag_nn_1_1_N : N ;
  oeverskaap_nn_1_1_N : N ;
  oeverskott_nn_1_1_N : N ;
  oeversiktsverk_nn_1_1_N : N ;
  oeverraskningsmoment_nn_1_1_N : N ;
  oeverraskningsanfall_nn_1_1_N : N ;
  oeverplagg_nn_1_1_N : N ;
  oeverord_nn_1_1_N : N ;
  oeverljudsplan_nn_1_1_N : N ;
  oeverliv_nn_1_1_N : N ;
  oeverlevnadsskael_nn_1_1_N : N ;
  oeverlakan_nn_1_1_N : N ;
  oeverladdningsskydd_nn_1_1_N : N ;
  oeverkaeksben_nn_1_1_N : N ;
  oeverhaeng_nn_1_1_N : N ;
  oeverhettningsskydd_nn_1_1_N : N ;
  oevergaangsverb_nn_1_1_N : N ;
  oevergaangstillstaand_nn_1_1_N : N ;
  oevergrepp_nn_1_1_N : N ;
  oeverfall_nn_1_1_N : N ;
  oeverdaad_nn_1_1_N : N ;
  oeverdrag_nn_1_1_N : N ;
  oeverbud_nn_1_1_N : N ;
  oeverbetyg_nn_1_1_N : N ;
  oeverbegrepp_nn_1_1_N : N ;
  oeverbefael_nn_1_1_N : N ;
  oeststatsfoertryck_nn_1_1_N : N ;
  oesregn_nn_1_1_N : N ;
  oeskar_nn_1_1_N : N ;
  oerngottsband_nn_1_1_N : N ;
  oerngott_nn_1_1_N : N ;
  oerlogsvarv_nn_1_1_N : N ;
  oerlogsfartyg_nn_1_1_N : N ;
  oeppningsbud_nn_1_1_N : N ;
  oenskemaal_nn_1_1_N : N ;
  oenskebarn_nn_1_1_N : N ;
  oelunderlaegg_nn_1_1_N : N ;
  oeknamn_nn_1_1_N : N ;
  oekenlandskap_nn_1_1_N : N ;
  oek_nn_1_1_N : N ;
  oegonroerelsemoenster_nn_1_1_N : N ;
  oegonpar_nn_1_1_N : N ;
  oegonlock_nn_1_1_N : N ;
  oegonhaar_nn_1_1_N : N ;
  oegonbryn_nn_1_1_N : N ;
  oegonblick_nn_1_1_N : N ;
  oedesaar_nn_1_1_N : N ;
  oedesval_nn_1_1_N : N ;
  aatstramningspaket_nn_1_1_N : N ;
  aatstramningsbehov_nn_1_1_N : N ;
  aatgaerdspaket_nn_1_1_N : N ;
  aaterval_nn_1_1_N : N ;
  aaterupplivningsfoersoek_nn_1_1_N : N ;
  aatertaag_nn_1_1_N : N ;
  aaterskall_nn_1_1_N : N ;
  aaterrop_nn_1_1_N : N ;
  aaterkoep_nn_1_1_N : N ;
  aaterkrav_nn_1_1_N : N ;
  aaterfall_nn_1_1_N : N ;
  aaterbud_nn_1_1_N : N ;
  aaterbesoek_nn_1_1_N : N ;
  aatalsbeslut_nn_1_1_N : N ;
  aatal_nn_1_1_N : N ;
  aaskaadningssaett_nn_1_1_N : N ;
  aaskvaeder_nn_1_1_N : N ;
  aaskslag_nn_1_1_N : N ;
  aaskregn_nn_1_1_N : N ;
  aaskmoln_nn_1_1_N : N ;
  aaskdunder_nn_1_1_N : N ;
  aartal_nn_1_1_N : N ;
  aartag_nn_1_1_N : N ;
  aarstryck_nn_1_1_N : N ;
  aarsbarn_nn_1_1_N : N ;
  aarblad_nn_1_1_N : N ;
  aar_nn_1_1_N : N ;
  aangtryck_nn_1_1_N : N ;
  aangstrykjaern_nn_1_1_N : N ;
  aanglok_nn_1_1_N : N ;
  aangkoek_nn_1_1_N : N ;
  aangkraftverk_nn_1_1_N : N ;
  aangkol_nn_1_1_N : N ;
  aangfartyg_nn_1_1_N : N ;
  aangestrop_nn_1_1_N : N ;
  aangestanfall_nn_1_1_N : N ;
  aalskinn_nn_1_1_N : N ;
  aalderstillaegg_nn_1_1_N : N ;
  aaldersskael_nn_1_1_N : N ;
  aaldersbetyg_nn_1_1_N : N ;
  aalbestaand_nn_1_1_N : N ;
  aaklagarbeslut_nn_1_1_N : N ;
  aakerfaelt_nn_1_1_N : N ;
  aakerbaer_nn_1_1_N : N ;
  aakerbruk_nn_1_1_N : N ;
  aakdon_nn_1_1_N : N ;
  aak_nn_1_1_N : N ;
  aaderbraack_nn_1_1_N : N ;
  aaderbrock_nn_1_1_N : N ;
  aeventyrsbad_nn_1_1_N : N ;
  aeventyr_nn_1_1_N : N ;
  aettnummer_nn_1_1_N : N ;
  aettetal_nn_1_1_N : N ;
  aetteled_nn_1_1_N : N ;
  aettartal_nn_1_1_N : N ;
  aerr_nn_1_1_N : N ;
  aermhaal_nn_1_1_N : N ;
  aerkesvin_nn_1_1_N : N ;
  aerkestift_nn_1_1_N : N ;
  aerkenoet_nn_1_1_N : N ;
  aerevarv_nn_1_1_N : N ;
  aenkeaar_nn_1_1_N : N ;
  aenkedok_nn_1_1_N : N ;
  aeng_ljud_nn_1_1_N : N ;
  aendamaal_nn_1_1_N : N ;
  aemnesnamn_nn_1_1_N : N ;
  aemnesjaern_nn_1_1_N : N ;
  aemnesblock_nn_1_1_N : N ;
  aembetsverk_nn_1_1_N : N ;
  aembetsmannajag_nn_1_1_N : N ;
  aembetsbrott_nn_1_1_N : N ;
  aembar_nn_1_1_N : N ;
  aelskogsgnabb_nn_1_1_N : N ;
  aelsklingsprojekt_nn_1_1_N : N ;
  aelgkliv_nn_1_1_N : N ;
  aelgbesoek_nn_1_1_N : N ;
  aektenskapshinder_nn_1_1_N : N ;
  aektenskapsfoerord_nn_1_1_N : N ;
  aektenskapscertifikat_nn_1_1_N : N ;
  aektenskapsbrott_nn_1_1_N : N ;
  aektenskapsbetyg_nn_1_1_N : N ;
  aektenskap_nn_1_1_N : N ;
  aektamakekuvert_nn_1_1_N : N ;
  aeggskal_nn_1_1_N : N ;
  aegglaeggningsroer_nn_1_1_N : N ;
  aeggkorn_nn_1_1_N : N ;
  aegg_nn_1_1_N : N ;
  aegarkrav_nn_1_1_N : N ;
  aegandebehov_nn_1_1_N : N ;
  aedelpekoral_nn_1_1_N : N ;
  zonroer_nn_1_1_N : N ;
  zigenarspraak_nn_1_1_N : N ;
  zigenarliv_nn_1_N : N ;
  zigenarkapell_nn_1_N : N ;
  yxskaft_nn_1_N : N ;
  yxmord_nn_1_N : N ;
  yxhugg_nn_1_N : N ;
  yxblad_nn_1_N : N ;
  ytvattenskikt_nn_1_N : N ;
  yttryck_nn_1_N : N ;
  yttertak_nn_1_N : N ;
  ytterskaer_nn_1_1_N : N ;
  ytterplagg_nn_1_N : N ;
  ytterfoder_nn_1_N : N ;
  ytterfack_nn_1_N : N ;
  ytterdoerrhandtag_nn_1_1_N : N ;
  ytskikt_nn_1_N : N ;
  ytmaatt_nn_1_1_N : N ;
  ytlager_nn_1_N : N ;
  yrvaeder_nn_1_1_N : N ;
  yrkesval_nn_1_N : N ;
  yrkesregister_nn_1_N : N ;
  yrkesliv_nn_1_N : N ;
  yrkesfoerbud_nn_1_1_N : N ;
  yogainstitut_nn_1_N : N ;
  ynnestprov_nn_1_N : N ;
  yngeltraag_nn_1_1_N : N ;
  ymptvaang_nn_1_1_N : N ;
  ympsaar_nn_1_1_N : N ;
  ympsnitt_nn_1_N : N ;
  ymnighetshorn_nn_1_N : N ;
  wienerbroed_nn_1_1_N : N ;
  voertbroed_nn_1_1_N : N ;
  vaatelement_nn_1_1_N : N ;
  vaarvaeder_nn_1_1_N : N ;
  vaartsvin_nn_1_1_N : N ;
  vaartmedel_nn_1_1_N : N ;
  vaarmoln_nn_1_1_N : N ;
  vaardval_nn_1_1_N : N ;
  vaardpaket_nn_1_1_N : N ;
  vaardnadsbidrag_nn_1_1_N : N ;
  vaardintyg_nn_1_1_N : N ;
  vaardfall_nn_1_1_N : N ;
  vaardbidrag_nn_1_1_N : N ;
  vaardbehov_nn_1_1_N : N ;
  vaap_nn_1_1_N : N ;
  vaaningsplan_nn_1_1_N : N ;
  vaaldtaektsfoersoek_nn_1_1_N : N ;
  vaaldsdaad_nn_1_1_N : N ;
  vaaldsbrott_nn_1_1_N : N ;
  vaagsvall_nn_1_1_N : N ;
  vaagplan_nn_1_1_N : N ;
  vaaghaal_nn_1_1_N : N ;
  vaaffeljaern_nn_1_1_N : N ;
  vaadaskott_nn_1_1_N : N ;
  vaextskyddsmedel_nn_1_1_N : N ;
  vaextskott_nn_1_1_N : N ;
  vaextplankton_nn_1_1_N : N ;
  vaexthustak_nn_1_1_N : N ;
  vaexlingslok_nn_1_1_N : N ;
  vaexelstaellverk_nn_1_1_N : N ;
  vaexelstaell_nn_1_1_N : N ;
  vaexelspaar_nn_1_1_N : N ;
  vaexelmynt_nn_1_1_N : N ;
  vaexellok_nn_1_1_N : N ;
  vaexelkontor_nn_1_1_N : N ;
  vaexelbord_nn_1_1_N : N ;
  vaevskael_nn_1_1_N : N ;
  vaevskaft_nn_1_1_N : N ;
  vaevningsmoenster_nn_1_1_N : N ;
  vaetmedel_nn_1_1_N : N ;
  vaesljud_nn_1_1_N : N ;
  vaesen_nn_2_1_N : N ;
  vaerv_nn_1_1_N : N ;
  vaern_nn_1_1_N : N ;
  vaermeaaskvaeder_nn_1_1_N : N ;
  vaermeverk_nn_1_1_N : N ;
  vaermetillaegg_nn_1_1_N : N ;
  vaermeskaap_nn_1_1_N : N ;
  vaermemaatt_nn_1_1_N : N ;
  vaermekraftverk_nn_1_1_N : N ;
  vaermegenomgaangstal_nn_1_1_N : N ;
  vaermeelement_nn_1_1_N : N ;
  vaermebehov_nn_1_1_N : N ;
  vaerldsspraak_nn_1_1_N : N ;
  vaerldsscoop_nn_1_1_N : N ;
  vaerldssamfund_nn_1_1_N : N ;
  vaerldsrekord_nn_1_1_N : N ;
  vaerldsnamn_nn_1_1_N : N ;
  vaerldsmaesterskap_nn_1_1_N : N ;
  vaerldskrig_nn_1_1_N : N ;
  vaerldskedjebrev_nn_1_1_N : N ;
  vaerldshav_nn_1_1_N : N ;
  vaerldsgenomsnitt_nn_1_1_N : N ;
  vaerldsarv_nn_1_1_N : N ;
  vaerdpar_nn_1_1_N : N ;
  vaerdfolk_nn_1_1_N : N ;
  vaerdetransportfoeretag_nn_1_1_N : N ;
  vaerderaan_nn_1_1_N : N ;
  vaerderingsinstrument_nn_1_1_N : N ;
  vaerdepapper_nn_1_1_N : N ;
  vaerdeord_nn_1_1_N : N ;
  vaerdefoeremaal_nn_1_1_N : N ;
  vaerdefall_nn_1_1_N : N ;
  vaerdebrev_nn_1_1_N : N ;
  vaerddjur_nn_1_1_N : N ;
  vaensterknaeck_nn_1_1_N : N ;
  vaensterben_nn_1_1_N : N ;
  vaenskapsband_nn_1_1_N : N ;
  vaelljaern_nn_1_1_N : N ;
  vaelkomsttal_nn_1_1_N : N ;
  vaeljarstoed_nn_1_1_N : N ;
  vaegval_nn_1_1_N : N ;
  vaegskael_nn_1_1_N : N ;
  vaegnaet_nn_1_1_N : N ;
  vaeglag_nn_1_1_N : N ;
  vaegguttag_nn_1_1_N : N ;
  vaeggur_nn_1_1_N : N ;
  vaeggfaelt_nn_1_1_N : N ;
  vaeggband_nn_1_1_N : N ;
  vaedertillstaand_nn_1_1_N : N ;
  vaederstreck_nn_1_1_N : N ;
  vaederskepp_nn_1_1_N : N ;
  vaederomslag_nn_1_1_N : N ;
  vykort_nn_1_N : N ;
  vuxenliv_nn_1_N : N ;
  vulkanutbrott_nn_1_N : N ;
  vraalaak_nn_1_1_N : N ;
  vraal_nn_1_1_N : N ;
  vristben_nn_1_N : N ;
  vridspoleinstrument_nn_1_N : N ;
  vridmoment_nn_1_N : N ;
  vridjaernsinstrument_nn_1_1_N : N ;
  vredesutbrott_nn_1_N : N ;
  vred_nn_1_N : N ;
  vrak_nn_1_N : N ;
  votivskepp_nn_1_N : N ;
  volttal_nn_1_N : N ;
  viv_nn_1_N : N ;
  vittnesskrank_nn_1_N : N ;
  vittnesmaal_nn_1_1_N : N ;
  vittnesfoerhoer_nn_1_1_N : N ;
  vittnesboerd_nn_1_1_N : N ;
  vitsord_nn_1_N : N ;
  vitrinskaap_nn_1_1_N : N ;
  vitesfoerbud_nn_1_1_N : N ;
  vitaminpiller_nn_1_N : N ;
  vitalbehov_nn_1_N : N ;
  visumbrott_nn_1_N : N ;
  visitkort_nn_1_N : N ;
  visir_nn_1_N : N ;
  viseringskort_nn_1_N : N ;
  visefall_nn_1_N : N ;
  visdomsord_nn_1_N : N ;
  visakort_nn_1_N : N ;
  virtuosnummer_nn_1_N : N ;
  vinaar_nn_1_1_N : N ;
  vintervaeglag_nn_1_1_N : N ;
  vintervaeder_nn_1_1_N : N ;
  vinterstaand_nn_1_1_N : N ;
  vinterskinn_nn_1_N : N ;
  vinterpaeron_nn_1_1_N : N ;
  vintermoerker_nn_1_1_N : N ;
  vinterlov_nn_1_N : N ;
  vinterlandskap_nn_1_N : N ;
  vinterhalvaar_nn_1_1_N : N ;
  vinterfoerraad_nn_1_1_N : N ;
  vinterfoder_nn_1_N : N ;
  vinterdaeck_nn_1_1_N : N ;
  vinterbad_nn_1_N : N ;
  vinstnummer_nn_1_N : N ;
  vinnarhaal_nn_1_1_N : N ;
  vinloev_nn_1_1_N : N ;
  vinkelmaatt_nn_1_1_N : N ;
  vinkeljaern_nn_1_1_N : N ;
  vinkelbeslag_nn_1_N : N ;
  vinkelben_nn_1_N : N ;
  vinkelavstaand_nn_1_1_N : N ;
  vingteckningvaevningsmoenster_nn_1_1_N : N ;
  vingslag_nn_1_N : N ;
  vindaegg_nn_1_1_N : N ;
  vindstraak_nn_1_1_N : N ;
  vindskydd_nn_1_N : N ;
  vindskontor_nn_1_N : N ;
  vindruteskydd_nn_1_N : N ;
  vindmaetningsinstrument_nn_1_1_N : N ;
  vindkraftverk_nn_1_N : N ;
  vindkraftsbolag_nn_1_N : N ;
  vindfaang_nn_1_1_N : N ;
  vinddrag_nn_1_N : N ;
  vinbaer_nn_1_1_N : N ;
  vinblad_nn_1_N : N ;
  vinberg_nn_1_N : N ;
  viltstraak_nn_1_1_N : N ;
  viltdjur_nn_1_N : N ;
  vilolaeger_nn_1_1_N : N ;
  villospaar_nn_1_1_N : N ;
  villkor_nn_1_N : N ;
  villebraad_nn_1_1_N : N ;
  villaservitut_nn_1_N : N ;
  vildsvin_nn_1_N : N ;
  vildskott_nn_1_N : N ;
  vilddjur_nn_1_N : N ;
  viktslag_nn_1_N : N ;
  vikon_nn_1_N : N ;
  vikingataag_nn_1_1_N : N ;
  vikingaskepp_nn_1_N : N ;
  vikariestopp_nn_1_N : N ;
  vikariat_nn_1_N : N ;
  vigselformulaer_nn_1_1_N : N ;
  vidertryck_nn_1_N : N ;
  videoklipp_nn_1_N : N ;
  videoband_nn_1_N : N ;
  vick_nn_1_N : N ;
  vetekorn_nn_1_N : N ;
  vetebroed_nn_1_1_N : N ;
  vertikalplan_nn_1_N : N ;
  versmaatt_nn_1_1_N : N ;
  verop_nn_1_N : N ;
  verktyg_nn_1_N : N ;
  verksamhetsaar_nn_1_1_N : N ;
  verksamhetsfaelt_nn_1_1_N : N ;
  verksamhetsbehov_nn_1_N : N ;
  verkjaern_nn_1_1_N : N ;
  verkbord_nn_1_N : N ;
  verk_nn_1_N : N ;
  verifikat_nn_1_N : N ;
  verb_nn_1_N : N ;
  venusberg_nn_1_N : N ;
  ventileringshaal_nn_1_1_N : N ;
  vedfaang_nn_1_1_N : N ;
  vedernamn_nn_1_N : N ;
  vederlag_nn_1_N : N ;
  veckoslut_nn_1_N : N ;
  veckomagasin_nn_1_N : N ;
  veckberg_nn_1_N : N ;
  veck_nn_1_N : N ;
  vaxsigill_nn_1_N : N ;
  vaxkabinett_nn_1_N : N ;
  vaxavtryck_nn_1_N : N ;
  vattenvaesen_nn_1_1_N : N ;
  vattenverk_nn_1_N : N ;
  vattenur_nn_1_N : N ;
  vattentorn_nn_1_N : N ;
  vattensvin_nn_1_N : N ;
  vattenstaandsroer_nn_1_1_N : N ;
  vattenstaand_nn_1_1_N : N ;
  vattenstaenk_nn_1_1_N : N ;
  vattenskott_nn_1_N : N ;
  vattenreningsverk_nn_1_N : N ;
  vattenkraftverk_nn_1_N : N ;
  vattenhaal_nn_1_1_N : N ;
  vattenhjul_nn_1_N : N ;
  vattenfall_nn_1_N : N ;
  vattendrag_nn_1_N : N ;
  vattendjur_nn_1_N : N ;
  vattendjup_nn_1_N : N ;
  vattenbruk_nn_1_N : N ;
  vattenbad_nn_1_N : N ;
  vaterbord_nn_1_N : N ;
  vassroer_nn_1_1_N : N ;
  varvtal_nn_1_N : N ;
  varv_nn_2_N : N ;
  varv_nn_1_N : N ;
  varulaan_nn_1_1_N : N ;
  varuintag_nn_1_N : N ;
  varubud_nn_1_N : N ;
  varseblivningsfenomen_nn_1_N : N ;
  varp_nn_2_N : N ;
  varningsskott_nn_1_N : N ;
  varningsrop_nn_1_N : N ;
  varmblod_nn_1_N : N ;
  varmbad_nn_1_N : N ;
  variationsinstrument_nn_1_N : N ;
  vardagsspraak_nn_1_1_N : N ;
  vardagsliv_nn_1_N : N ;
  vapenstillestaand_nn_1_1_N : N ;
  vapenslag_nn_1_N : N ;
  vapenlager_nn_1_N : N ;
  vapenhot_nn_1_N : N ;
  vapenfynd_nn_1_N : N ;
  vansinnesdaad_nn_1_1_N : N ;
  vanedjur_nn_1_N : N ;
  vandringsaar_nn_1_1_N : N ;
  vandringsvaagroer_nn_1_1_N : N ;
  vandringsfolk_nn_1_N : N ;
  vandrarfolk_nn_1_N : N ;
  vanadinskaft_nn_1_N : N ;
  valv_nn_1_N : N ;
  valutasvin_nn_1_N : N ;
  valutabrott_nn_1_N : N ;
  valthorn_nn_1_N : N ;
  valsaett_nn_1_1_N : N ;
  valsverk_nn_1_N : N ;
  valspraak_nn_1_1_N : N ;
  valresultat_nn_1_N : N ;
  valnederlag_nn_1_N : N ;
  valmtak_nn_1_N : N ;
  vallhorn_nn_1_N : N ;
  valkuvert_nn_1_N : N ;
  valklagomaal_nn_1_1_N : N ;
  valium_nn_1_N : N ;
  valenstal_nn_1_N : N ;
  valdistrikt_nn_1_N : N ;
  valbestaand_nn_1_1_N : N ;
  val_nn_1_N : N ;
  vakttorn_nn_1_N : N ;
  vaksin_nn_1_N : N ;
  vagnsaett_nn_1_1_N : N ;
  vaggtryck_nn_1_N : N ;
  vadben_nn_1_N : N ;
  vad_nn_1_N : N ;
  utviksblad_nn_1_N : N ;
  utvik_nn_1_N : N ;
  utvecklingsstoed_nn_1_1_N : N ;
  utvecklingsspraang_nn_1_1_N : N ;
  utvecklingsplan_nn_1_N : N ;
  uttaag_nn_1_1_N : N ;
  uttryckssaett_nn_1_1_N : N ;
  uttrycksmedel_nn_1_N : N ;
  uttryck_nn_1_N : N ;
  uttal_nn_1_N : N ;
  uttag_nn_1_N : N ;
  utsoendringsorgan_nn_1_1_N : N ;
  utspraang_nn_1_1_N : N ;
  utsnitt_nn_1_N : N ;
  utslaepp_nn_1_1_N : N ;
  utslag_nn_1_N : N ;
  utskaenkningstillstaand_nn_1_1_N : N ;
  utskov_nn_1_N : N ;
  utskott_nn_1_N : N ;
  utskick_nn_1_N : N ;
  utsiktstorn_nn_1_N : N ;
  utrymmesskael_nn_1_1_N : N ;
  utrotningslaeger_nn_1_1_N : N ;
  utropsord_nn_1_N : N ;
  utrop_nn_1_N : N ;
  utrikesflyg_nn_1_N : N ;
  utrikesdepartement_nn_1_N : N ;
  utresetillstaand_nn_1_1_N : N ;
  utresefoerbud_nn_1_1_N : N ;
  utpressningsmedel_nn_1_N : N ;
  utomkvedshavandeskap_nn_1_N : N ;
  utomhusbad_nn_1_N : N ;
  utmaal_nn_1_1_N : N ;
  utmattningssyndrom_nn_1_N : N ;
  utmattningsbrott_nn_1_N : N ;
  utlaegg_nn_1_1_N : N ;
  utlopp_nn_1_N : N ;
  utljud_nn_1_N : N ;
  utlandsuppdrag_nn_1_N : N ;
  utlandssamtal_nn_1_N : N ;
  utklipp_nn_1_N : N ;
  utkikstorn_nn_1_N : N ;
  utjaemningsmandat_nn_1_1_N : N ;
  uthopp_nn_1_N : N ;
  utgaangsmaterial_nn_1_1_N : N ;
  utgaangsdatum_nn_1_1_N : N ;
  utgraevningsresultat_nn_1_1_N : N ;
  utflyttningslaen_nn_1_1_N : N ;
  utfall_nn_1_N : N ;
  utelag_nn_1_N : N ;
  utegaangsfoerbud_nn_1_1_N : N ;
  utegaangsfaar_nn_1_1_N : N ;
  utefaar_nn_1_1_N : N ;
  utdunstningskaerl_nn_1_1_N : N ;
  utdrag_nn_1_N : N ;
  utbud_nn_1_N : N ;
  utbrott_nn_1_N : N ;
  utbildningsgap_nn_1_N : N ;
  utbildningsdepartement_nn_1_N : N ;
  utbildningsbidrag_nn_1_N : N ;
  utbetalningskort_nn_1_N : N ;
  utanverk_nn_1_N : N ;
  utanfoerskap_nn_1_1_N : N ;
  utandningsprov_nn_1_N : N ;
  urverk_nn_1_N : N ;
  urvalsinstrument_nn_1_N : N ;
  urval_nn_1_N : N ;
  urtillstaand_nn_1_1_N : N ;
  urtag_nn_1_N : N ;
  urspraak_nn_1_1_N : N ;
  ursprungscertifikat_nn_1_N : N ;
  ursprung_nn_1_N : N ;
  urogenitalorgan_nn_1_N : N ;
  urladdningsroer_nn_1_1_N : N ;
  urklipp_nn_1_N : N ;
  urinroer_nn_1_1_N : N ;
  urinorgan_nn_1_N : N ;
  uriebrev_nn_1_N : N ;
  urfolk_nn_1_N : N ;
  urdjur_nn_1_N : N ;
  ur_nn_1_N : N ;
  uppvaermningsband_nn_1_1_N : N ;
  uppvakningsoegonblick_nn_1_1_N : N ;
  upptaag_nn_1_1_N : N ;
  upptryck_nn_1_N : N ;
  uppsaatsbrott_nn_1_1_N : N ;
  uppsaat_nn_1_1_N : N ;
  uppsaettningsmaal_nn_1_1_N : N ;
  uppsaettningsinstrument_nn_1_1_N : N ;
  uppsaegningslaan_nn_1_1_N : N ;
  uppsving_nn_1_N : N ;
  uppstaellningsspaar_nn_1_1_N : N ;
  uppstraak_nn_1_1_N : N ;
  uppstickarbolag_nn_1_N : N ;
  uppspraang_nn_1_1_N : N ;
  uppslagsverk_nn_1_N : N ;
  uppslagsord_nn_1_N : N ;
  uppslag_nn_1_N : N ;
  uppskov_nn_1_N : N ;
  uppskjut_nn_1_N : N ;
  uppsatslag_nn_1_N : N ;
  uppsamlingslaeger_nn_1_1_N : N ;
  upprymningsstaal_nn_1_1_N : N ;
  upprorsfoersoek_nn_1_1_N : N ;
  uppror_nn_1_N : N ;
  upprop_nn_1_N : N ;
  upprepningsmoenster_nn_1_1_N : N ;
  uppmaerksamhetsspann_nn_1_1_N : N ;
  uppmaerksamhetsfaelt_nn_1_1_N : N ;
  upploesningsmedel_nn_1_1_N : N ;
  upplaegg_nn_1_1_N : N ;
  upplopp_nn_1_N : N ;
  upplivningsfoersoek_nn_1_1_N : N ;
  uppland_nn_1_N : N ;
  upplag_nn_1_N : N ;
  uppkoep_nn_1_1_N : N ;
  uppkok_nn_1_N : N ;
  upphovsraettsbrott_nn_1_1_N : N ;
  upphopp_nn_1_N : N ;
  uppflaag_nn_1_1_N : N ;
  uppflog_nn_1_N : N ;
  uppehaallsvaeder_nn_1_1_N : N ;
  uppehaallstillstaand_nn_1_1_N : N ;
  uppehaall_nn_1_1_N : N ;
  uppdrag_nn_1_N : N ;
  uppboerdsaar_nn_1_1_N : N ;
  uppbaad_nn_1_1_N : N ;
  uppbygglighetsanspraak_nn_1_1_N : N ;
  uppbud_nn_1_N : N ;
  uppbrott_nn_1_N : N ;
  universitetsbibliotek_nn_1_N : N ;
  universitet_nn_1_N : N ;
  universalspraak_nn_1_1_N : N ;
  universalmedel_nn_1_N : N ;
  universalbegrepp_nn_1_N : N ;
  unionsbrott_nn_1_N : N ;
  unikat_nn_1_N : N ;
  ungnoet_nn_1_1_N : N ;
  ungkarlshotell_nn_1_N : N ;
  ungdomsaar_nn_1_1_N : N ;
  ungdomsverk_nn_1_N : N ;
  ungdomsraad_nn_1_1_N : N ;
  ungdomsfoerbund_nn_1_1_N : N ;
  ungdjur_nn_1_N : N ;
  undsaettningsfoersoek_nn_1_1_N : N ;
  undervisningsspraak_nn_1_1_N : N ;
  undervisningsraad_nn_1_1_N : N ;
  undervisningspaket_nn_1_N : N ;
  undervisningsmaterial_nn_1_N : N ;
  underverk_nn_1_N : N ;
  undertak_nn_1_N : N ;
  understag_nn_1_N : N ;
  underslev_nn_1_N : N ;
  underslag_nn_1_N : N ;
  underskaap_nn_1_1_N : N ;
  underskottsavdrag_nn_1_N : N ;
  underskott_nn_1_N : N ;
  underplagg_nn_1_N : N ;
  underlaegg_nn_1_1_N : N ;
  underliv_nn_1_N : N ;
  underlakan_nn_1_N : N ;
  underlag_nn_1_N : N ;
  underjordsprov_nn_1_N : N ;
  underhaallsfoerband_nn_1_1_N : N ;
  underhaallsbidrag_nn_1_1_N : N ;
  underhaall_nn_1_1_N : N ;
  underhypotek_nn_1_N : N ;
  underhandsbesked_nn_1_N : N ;
  underhandsackord_nn_1_N : N ;
  undergaangshot_nn_1_1_N : N ;
  underfall_nn_1_N : N ;
  underdaeck_nn_1_1_N : N ;
  underdjur_nn_1_N : N ;
  underbud_nn_1_N : N ;
  underbetyg_nn_1_N : N ;
  underbett_nn_1_N : N ;
  underbestaand_nn_1_1_N : N ;
  underben_nn_1_N : N ;
  underbegrepp_nn_1_N : N ;
  underbefael_nn_1_1_N : N ;
  underbarn_nn_1_N : N ;
  undantagstillstaand_nn_1_1_N : N ;
  undantagsfall_nn_1_N : N ;
  undantag_nn_1_N : N ;
  ultraljud_nn_1_N : N ;
  ugnskol_nn_1_N : N ;
  uddljud_nn_1_N : N ;
  uddjaern_nn_1_1_N : N ;
  uddblad_nn_1_N : N ;
  uddaplagg_nn_1_N : N ;
  uddanummer_nn_1_N : N ;
  uddamaal_nn_1_1_N : N ;
  ubaatsnaet_nn_1_1_N : N ;
  ubaatsjaktfartyg_nn_1_1_N : N ;
  toevaeder_nn_1_1_N : N ;
  toernrosasnaar_nn_1_1_N : N ;
  toemningshaal_nn_1_1_N : N ;
  taarben_nn_1_1_N : N ;
  taangbad_nn_1_1_N : N ;
  taajaern_nn_1_1_N : N ;
  taagsaett_nn_1_1_N : N ;
  taagstopp_nn_1_1_N : N ;
  taagraan_nn_1_1_N : N ;
  taag_nn_1_1_N : N ;
  taevlingshumoer_nn_1_1_N : N ;
  taenkesaett_nn_1_1_N : N ;
  taenkespraak_nn_1_1_N : N ;
  taendstift_nn_1_1_N : N ;
  taendsticksmoenster_nn_1_1_N : N ;
  taendroer_nn_1_1_N : N ;
  taendmedel_nn_1_1_N : N ;
  taendaruttag_nn_1_1_N : N ;
  taelttak_nn_1_1_N : N ;
  taelt_nn_1_1_N : N ;
  taeckord_nn_1_1_N : N ;
  taeckningskoep_nn_1_1_N : N ;
  taecknamn_nn_1_1_N : N ;
  taeckhaar_nn_1_1_N : N ;
  taeckfoerband_nn_1_1_N : N ;
  taeckblad_nn_1_1_N : N ;
  typsnitt_nn_1_N : N ;
  typnummer_nn_1_N : N ;
  typfall_nn_1_N : N ;
  tygoeverdrag_nn_1_1_N : N ;
  tygtryck_nn_1_N : N ;
  tygsjok_nn_1_N : N ;
  tygband_nn_1_N : N ;
  tvaatimmarsskift_nn_1_1_N : N ;
  tvaaspann_nn_1_1_N : N ;
  tvaangsmedel_nn_1_1_N : N ;
  tvaamanstaelt_nn_1_1_N : N ;
  tvaamannataelt_nn_1_1_N : N ;
  tvaafrontskrig_nn_1_1_N : N ;
  tvaablad_nn_1_1_N : N ;
  tvaettstaell_nn_1_1_N : N ;
  tvaettstugebraak_nn_1_1_N : N ;
  tvaettresultat_nn_1_1_N : N ;
  tvaettpulver_nn_1_1_N : N ;
  tvaettmedel_nn_1_1_N : N ;
  tvaettfat_nn_1_1_N : N ;
  tvaerstup_nn_1_1_N : N ;
  tvaerstreck_nn_1_1_N : N ;
  tvaerstopp_nn_1_1_N : N ;
  tvaersnitt_nn_1_1_N : N ;
  tvaerskepp_nn_1_1_N : N ;
  tvistemaal_nn_1_1_N : N ;
  tvillingtorn_nn_1_N : N ;
  tvillingpar_nn_1_N : N ;
  tut_nn_2_N : N ;
  tusental_nn_1_N : N ;
  turkfolk_nn_1_N : N ;
  turistmaal_nn_1_1_N : N ;
  turbojetplan_nn_1_N : N ;
  turbinlager_nn_1_N : N ;
  tuppjuck_nn_1_N : N ;
  tuppfjaet_nn_1_1_N : N ;
  tunnvalv_nn_1_N : N ;
  tunnland_nn_1_N : N ;
  tunnelgenombrott_nn_1_N : N ;
  tunnbroed_nn_1_1_N : N ;
  tunnband_nn_1_N : N ;
  tungspets_r_nn_1_N : N ;
  tungrots_r_nn_1_N : N ;
  tungomaal_nn_1_1_N : N ;
  tungljud_nn_1_N : N ;
  tungben_nn_1_N : N ;
  tungband_nn_1_N : N ;
  tun_nn_1_N : N ;
  tumveck_nn_1_N : N ;
  tumult_nn_1_N : N ;
  tumgrepp_nn_1_N : N ;
  tullverk_nn_1_N : N ;
  tullskydd_nn_1_N : N ;
  tullkontor_nn_1_N : N ;
  tuggummipaket_nn_1_N : N ;
  tubroer_nn_1_1_N : N ;
  troestmaal_nn_1_1_N : N ;
  troeskverk_nn_1_1_N : N ;
  troegdjur_nn_1_1_N : N ;
  traangmaal_nn_1_1_N : N ;
  traag_nn_1_1_N : N ;
  traackelstygn_nn_1_1_N : N ;
  traesvaerd_nn_1_1_N : N ;
  traestift_nn_1_1_N : N ;
  traestick_nn_1_1_N : N ;
  traespaan_nn_1_1_N : N ;
  traesnitt_nn_1_1_N : N ;
  traeslott_nn_1_1_N : N ;
  traeslag_nn_1_1_N : N ;
  traeskyddsmedel_nn_1_1_N : N ;
  traeskydd_nn_1_1_N : N ;
  traeskosteg_nn_1_1_N : N ;
  traeskland_nn_1_1_N : N ;
  traeskfolk_nn_1_1_N : N ;
  traenjon_nn_1_1_N : N ;
  traeningsupplaegg_nn_1_1_N : N ;
  traeningslaeger_nn_1_1_N : N ;
  traekol_nn_1_1_N : N ;
  traegolv_nn_1_1_N : N ;
  traefartyg_nn_1_1_N : N ;
  traedstygn_nn_1_1_N : N ;
  traedslag_nn_1_1_N : N ;
  traedgaardsredskap_nn_1_1_N : N ;
  traedgaardsland_nn_1_1_N : N ;
  traeblaasinstrument_nn_1_1_N : N ;
  traeben_nn_1_1_N : N ;
  tryckaar_nn_1_1_N : N ;
  tryckskydd_nn_1_N : N ;
  tryckord_nn_1_N : N ;
  tryckkaerl_nn_1_1_N : N ;
  tryckfoerband_nn_1_1_N : N ;
  tryckalster_nn_1_N : N ;
  tryck_nn_1_N : N ;
  trutaegg_nn_1_1_N : N ;
  trupptransporttaag_nn_1_1_N : N ;
  trupptransportfartyg_nn_1_N : N ;
  truppslag_nn_1_N : N ;
  truppfoerband_nn_1_1_N : N ;
  trumslag_nn_1_N : N ;
  trumskinn_nn_1_N : N ;
  trumfkort_nn_1_N : N ;
  trosskydd_nn_1_N : N ;
  trossdaeck_nn_1_1_N : N ;
  trossamfund_nn_1_N : N ;
  trontal_nn_1_N : N ;
  troninnehav_nn_1_N : N ;
  tronfoeljdskrig_nn_1_1_N : N ;
  trolovningsbarn_nn_1_N : N ;
  trolltyg_nn_1_N : N ;
  trollslag_nn_1_N : N ;
  trollskott_nn_1_N : N ;
  trollmedel_nn_1_N : N ;
  trolleritrick_nn_1_N : N ;
  trollbaer_nn_1_1_N : N ;
  trollbarn_nn_1_N : N ;
  troll_nn_1_N : N ;
  trivialnamn_nn_1_N : N ;
  triumvirat_nn_1_N : N ;
  triumftaag_nn_1_1_N : N ;
  tripp_nn_2_N : N ;
  trick_nn_1_N : N ;
  tribunat_nn_1_N : N ;
  trettital_nn_1_N : N ;
  trettiotal_nn_1_N : N ;
  tretal_nn_1_N : N ;
  trestegshopp_nn_1_N : N ;
  trespann_nn_1_N : N ;
  trendbrott_nn_1_N : N ;
  trendanalysfoeretag_nn_1_1_N : N ;
  treglasfoenster_nn_1_1_N : N ;
  trefaergstryck_nn_1_1_N : N ;
  trapptorn_nn_1_N : N ;
  trappsteg_nn_1_N : N ;
  transporttaag_nn_1_1_N : N ;
  transportnaet_nn_1_1_N : N ;
  transportmedel_nn_1_N : N ;
  transporthjul_nn_1_N : N ;
  transportfoeretag_nn_1_1_N : N ;
  transportfoerbud_nn_1_1_N : N ;
  transportband_nn_1_N : N ;
  transportavtal_nn_1_N : N ;
  transplantat_nn_1_N : N ;
  tranbaer_nn_1_1_N : N ;
  tranben_nn_1_N : N ;
  tramphjul_nn_1_N : N ;
  trampfartyg_nn_1_N : N ;
  traktordaeck_nn_1_1_N : N ;
  trakom_nn_1_N : N ;
  traj_nn_1_N : N ;
  trafiktillstaand_nn_1_1_N : N ;
  trafiksaekerhetsverk_nn_1_1_N : N ;
  trafikkort_nn_1_N : N ;
  trafikkontor_nn_1_N : N ;
  trafikflygplan_nn_1_N : N ;
  traditionsbrott_nn_1_N : N ;
  totalfoerbud_nn_1_1_N : N ;
  totalbelopp_nn_1_N : N ;
  torvtak_nn_1_N : N ;
  torvmossfynd_nn_1_N : N ;
  tortyrredskap_nn_1_N : N ;
  torsdagsnummer_nn_1_N : N ;
  torrelement_nn_1_N : N ;
  torp_nn_1_N : N ;
  tornur_nn_1_N : N ;
  tornfoenster_nn_1_1_N : N ;
  torn_nn_1_N : N ;
  torktumlarfilter_nn_1_N : N ;
  torkstaell_nn_1_1_N : N ;
  torkstreck_nn_1_N : N ;
  torkskaap_nn_1_1_N : N ;
  torkpapper_nn_1_N : N ;
  torkblock_nn_1_N : N ;
  torkarblad_nn_1_N : N ;
  torgstaand_nn_1_1_N : N ;
  torg_nn_1_N : N ;
  tordoen_nn_1_1_N : N ;
  toppskott_nn_1_N : N ;
  topplaan_nn_1_1_N : N ;
  topplock_nn_1_N : N ;
  toppjobb_nn_1_N : N ;
  toppbetyg_nn_1_N : N ;
  tonaarsgaeng_nn_1_1_N : N ;
  tonsteg_nn_1_N : N ;
  tonspraak_nn_1_1_N : N ;
  tonomfaang_nn_1_1_N : N ;
  tonikum_nn_1_N : N ;
  tonfall_nn_1_N : N ;
  tonband_nn_1_N : N ;
  toffeldjur_nn_1_N : N ;
  tobaksmonopol_nn_1_N : N ;
  tobaksflarn_nn_1_N : N ;
  tobaksblad_nn_1_N : N ;
  toalettskaap_nn_1_1_N : N ;
  toalettlock_nn_1_N : N ;
  toalettbord_nn_1_N : N ;
  toalettbesoek_nn_1_1_N : N ;
  tjaerblomster_nn_1_1_N : N ;
  tjaenstgoeringsnummer_nn_1_1_N : N ;
  tjaensteaar_nn_1_1_N : N ;
  tjaenstehjon_nn_1_1_N : N ;
  tjaenstebrev_nn_1_1_N : N ;
  tjaensteavtal_nn_1_1_N : N ;
  tjaelskott_nn_1_1_N : N ;
  tjaell_nn_1_1_N : N ;
  tjyvnyp_nn_1_N : N ;
  tjyvknep_nn_1_N : N ;
  tjuvtryck_nn_1_N : N ;
  tjuvstreck_nn_1_N : N ;
  tjuvnyp_nn_1_N : N ;
  tjuvlarm_nn_1_N : N ;
  tjuvknep_nn_1_N : N ;
  tjuvalarm_nn_1_N : N ;
  tjut_nn_1_N : N ;
  tjugotal_nn_1_N : N ;
  tjuder_nn_1_N : N ;
  tjog_nn_1_N : N ;
  tjack_nn_1_N : N ;
  tittskaap_nn_1_1_N : N ;
  titthaal_nn_1_1_N : N ;
  titelblad_nn_1_N : N ;
  tistron_nn_1_N : N ;
  tippskydd_nn_1_N : N ;
  tippflak_nn_1_N : N ;
  tiotusental_nn_1_N : N ;
  tiotal_nn_1_N : N ;
  tiokronorsmynt_nn_1_N : N ;
  tinningben_nn_1_N : N ;
  tingslag_nn_1_N : N ;
  tingord_nn_1_N : N ;
  ting_nn_2_N : N ;
  ting_nn_1_N : N ;
  timslag_nn_1_N : N ;
  timmerstek_nn_1_N : N ;
  timmerslaep_nn_1_1_N : N ;
  timmermagasin_nn_1_N : N ;
  timmeravlaegg_nn_1_1_N : N ;
  timmer_nn_1_N : N ;
  tillaeggsmandat_nn_1_1_N : N ;
  tillaeggsbelopp_nn_1_1_N : N ;
  tillaegg_nn_1_1_N : N ;
  tillvaegagaangssaett_nn_1_1_N : N ;
  tillverkningsaar_nn_1_1_N : N ;
  tillval_nn_1_N : N ;
  tilltalsord_nn_1_N : N ;
  tilltalsnamn_nn_1_N : N ;
  tilltag_nn_1_N : N ;
  tillstaand_nn_1_1_N : N ;
  tillslag_nn_1_N : N ;
  tillskott_nn_1_N : N ;
  tillrop_nn_1_N : N ;
  tillopp_nn_1_N : N ;
  tillnamn_nn_1_N : N ;
  tillhaall_nn_1_1_N : N ;
  tillgrepp_nn_1_N : N ;
  tillbud_nn_1_N : N ;
  tillbehoer_nn_1_1_N : N ;
  tiggarbrev_nn_1_N : N ;
  tigerspraang_nn_1_1_N : N ;
  tigerskinn_nn_1_N : N ;
  tie_break_nn_1_N : N ;
  tidvattenkraftverk_nn_1_N : N ;
  tidur_nn_1_N : N ;
  tidtagarur_nn_1_N : N ;
  tidsoeverdrag_nn_1_1_N : N ;
  tidsplan_nn_2_N : N ;
  tidsmaatt_nn_1_1_N : N ;
  tidskriftsnummer_nn_1_N : N ;
  tidsfoerlopp_nn_1_1_N : N ;
  tidsfoerdriv_nn_1_1_N : N ;
  tidsdokument_nn_1_N : N ;
  tidsbegrepp_nn_1_N : N ;
  tidroer_nn_1_1_N : N ;
  tidningsstaell_nn_1_1_N : N ;
  tidningsreferat_nn_1_N : N ;
  tidningsfoeretag_nn_1_1_N : N ;
  tidningsbud_nn_1_N : N ;
  tidlaan_nn_1_1_N : N ;
  tidkort_nn_1_N : N ;
  tidkontrollur_nn_1_N : N ;
  tidjordsfenomen_nn_1_N : N ;
  tidevarv_nn_1_N : N ;
  tidelag_nn_1_N : N ;
  tick_nn_1_N : N ;
  tick_tack_nn_1_N : N ;
  thaispraak_nn_1_1_N : N ;
  textavsnitt_nn_1_N : N ;
  teveabonnemang_nn_1_N : N ;
  tetrapak_nn_1_N : N ;
  terraengnamn_nn_1_1_N : N ;
  terrornaetverk_nn_1_1_N : N ;
  terrorhot_nn_1_N : N ;
  terrordaad_nn_1_1_N : N ;
  termoelement_nn_1_N : N ;
  tennislaeger_nn_1_1_N : N ;
  tempus_nn_1_N : N ;
  tempolopp_nn_1_N : N ;
  temperamentsutbrott_nn_1_N : N ;
  temperament_nn_1_N : N ;
  tempeltorn_nn_1_N : N ;
  temanummer_nn_1_N : N ;
  televerk_nn_1_N : N ;
  teleskoproer_nn_1_1_N : N ;
  teleskop_nn_1_N : N ;
  telenaet_nn_1_1_N : N ;
  telegrambud_nn_1_N : N ;
  telefonsvar_nn_1_N : N ;
  telefonsamtal_nn_1_N : N ;
  telefonnaet_nn_1_1_N : N ;
  telefonnummer_nn_1_N : N ;
  telefonkort_nn_1_N : N ;
  telefonbolag_nn_1_N : N ;
  telefonanrop_nn_1_N : N ;
  tegelbruk_nn_1_N : N ;
  tefat_nn_1_N : N ;
  teckenspraak_nn_1_1_N : N ;
  teckenalfabet_nn_1_N : N ;
  teblad_nn_1_N : N ;
  teatersaellskap_nn_1_1_N : N ;
  teaterliv_nn_1_N : N ;
  teaterdistrikt_nn_1_N : N ;
  teaterbesoek_nn_1_1_N : N ;
  team_nn_1_N : N ;
  taxifoenster_nn_1_1_N : N ;
  taxeringsaar_nn_1_1_N : N ;
  taxeringsbeslut_nn_1_N : N ;
  tarsalben_nn_1_N : N ;
  tarmvred_nn_1_N : N ;
  tarmben_nn_1_N : N ;
  tappningsroer_nn_1_1_N : N ;
  tapplager_nn_1_N : N ;
  tapphaal_nn_1_1_N : N ;
  tapp_nn_2_N : N ;
  tapetserarstift_nn_1_N : N ;
  tantalikval_nn_1_N : N ;
  tankstreck_nn_1_N : N ;
  tankgevaer_nn_1_1_N : N ;
  tankfartyg_nn_1_N : N ;
  tankespaar_nn_1_1_N : N ;
  tankemoenster_nn_1_1_N : N ;
  tankeled_nn_1_N : N ;
  tankefoster_nn_1_N : N ;
  tangentplan_nn_1_N : N ;
  tangentinstrument_nn_1_N : N ;
  tangentbord_nn_1_N : N ;
  tandvaardsbidrag_nn_1_1_N : N ;
  tandutskott_nn_1_N : N ;
  tandsnitt_nn_1_N : N ;
  tandskydd_nn_1_N : N ;
  tandlaekarbesoek_nn_1_1_N : N ;
  tandimplantat_nn_1_N : N ;
  tandhjul_nn_1_N : N ;
  tandgenombrott_nn_1_N : N ;
  tandgarnityr_nn_1_N : N ;
  tamsvin_nn_1_N : N ;
  talspraak_nn_1_1_N : N ;
  talroer_nn_1_1_N : N ;
  talorgan_nn_1_N : N ;
  tallrikshjul_nn_1_N : N ;
  tallbarr_nn_1_N : N ;
  talesaett_nn_1_1_N : N ;
  tal_nn_1_N : N ;
  taktstreck_nn_1_N : N ;
  taktslag_nn_1_N : N ;
  takspraang_nn_1_1_N : N ;
  takskaegg_nn_1_1_N : N ;
  takraeck_nn_1_1_N : N ;
  taklagsoel_nn_1_1_N : N ;
  taklag_nn_1_N : N ;
  takistoskop_nn_1_N : N ;
  takfoenster_nn_1_1_N : N ;
  takfall_nn_1_N : N ;
  tak_nn_1_N : N ;
  taggtraadshinder_nn_1_1_N : N ;
  taggpar_nn_1_N : N ;
  tag_nn_1_N : N ;
  taffelberg_nn_1_N : N ;
  tacorecept_nn_1_N : N ;
  tacktal_nn_1_N : N ;
  tackkort_nn_1_N : N ;
  tabuord_nn_1_N : N ;
  soetningsmedel_nn_1_1_N : N ;
  soendagsbarn_nn_1_1_N : N ;
  soemnmedel_nn_1_1_N : N ;
  soekpaadrag_nn_1_1_N : N ;
  soekgraenssnitt_nn_1_1_N : N ;
  saar_nn_1_1_N : N ;
  saangsaett_nn_1_1_N : N ;
  saangprov_nn_1_1_N : N ;
  saall_nn_1_1_N : N ;
  saagverk_nn_1_1_N : N ;
  saagtak_nn_1_1_N : N ;
  saagspaan_nn_1_1_N : N ;
  saagblad_nn_1_1_N : N ;
  saettsord_nn_1_1_N : N ;
  saettskepp_nn_1_1_N : N ;
  saettnaet_nn_1_1_N : N ;
  saett_nn_1_1_N : N ;
  saeteritak_nn_1_1_N : N ;
  saertryck_nn_1_1_N : N ;
  saerkullsbarn_nn_1_1_N : N ;
  saerkullbarn_nn_1_1_N : N ;
  saerfall_nn_1_1_N : N ;
  saerdrag_nn_1_1_N : N ;
  saengbord_nn_1_1_N : N ;
  saendningsuppehaall_nn_1_1_N : N ;
  saendebud_nn_1_1_N : N ;
  saemskskinn_nn_1_1_N : N ;
  saelskinn_nn_1_1_N : N ;
  saellskapsliv_nn_1_1_N : N ;
  saellskapsdjur_nn_1_1_N : N ;
  saellskap_nn_1_1_N : N ;
  saeljstopp_nn_1_1_N : N ;
  saeldjur_nn_1_1_N : N ;
  saekerhetsskael_nn_1_1_N : N ;
  saekerhetspaadrag_nn_1_1_N : N ;
  saekerhetsgrepp_nn_1_1_N : N ;
  saekerhetsavstaand_nn_1_1_N : N ;
  saekerhetsarrangemang_nn_1_1_N : N ;
  saedesslag_nn_1_1_N : N ;
  systerfartyg_nn_1_N : N ;
  systerbarn_nn_1_N : N ;
  systembolag_nn_1_N : N ;
  syskonaektenskap_nn_1_1_N : N ;
  syskonbarn_nn_1_N : N ;
  syrefaelt_nn_1_1_N : N ;
  syntetmaterial_nn_1_N : N ;
  syntaxtraed_nn_1_1_N : N ;
  synsaett_nn_1_1_N : N ;
  synorgan_nn_1_N : N ;
  synonympar_nn_1_N : N ;
  synintryck_nn_1_N : N ;
  synfaelt_nn_1_1_N : N ;
  syndrom_nn_1_N : N ;
  syndikat_nn_1_N : N ;
  syndastraff_nn_1_N : N ;
  syndaregister_nn_1_N : N ;
  syndafall_nn_1_N : N ;
  symmetriplan_nn_1_N : N ;
  syltpaeron_nn_1_1_N : N ;
  sybehoer_nn_1_1_N : N ;
  svaerord_nn_1_1_N : N ;
  svaerdskydd_nn_1_1_N : N ;
  svaerd_nn_1_1_N : N ;
  svaengningstal_nn_1_1_N : N ;
  svaenghjul_nn_1_1_N : N ;
  sviskon_nn_1_N : N ;
  svinn_nn_1_N : N ;
  svinkoett_nn_1_1_N : N ;
  svinhugg_nn_1_N : N ;
  sving_nn_1_N : N ;
  svindleriaatal_nn_1_1_N : N ;
  svin_nn_1_N : N ;
  svettband_nn_1_N : N ;
  svepskael_nn_1_1_N : N ;
  svep_nn_1_N : N ;
  svek_nn_1_N : N ;
  svedjeland_nn_1_N : N ;
  sveamaal_nn_1_1_N : N ;
  svavelpulver_nn_1_N : N ;
  svarvstaal_nn_1_1_N : N ;
  svartsjukebraak_nn_1_1_N : N ;
  svaromaal_nn_1_1_N : N ;
  svar_nn_1_N : N ;
  svanhopp_nn_1_N : N ;
  svampmoln_nn_1_N : N ;
  svampdjur_nn_1_N : N ;
  svalstjaertutspraang_nn_1_1_N : N ;
  svall_nn_1_N : N ;
  svalg_nn_1_N : N ;
  suterraengplan_nn_1_1_N : N ;
  surrogat_nn_1_N : N ;
  surkoersbaer_nn_1_1_N : N ;
  surfoder_nn_1_N : N ;
  surdegsbroed_nn_1_1_N : N ;
  supporterbraak_nn_1_1_N : N ;
  supplement_nn_1_N : N ;
  supernovautbrott_nn_1_N : N ;
  suntaelt_nn_1_1_N : N ;
  sund_nn_1_N : N ;
  sultanrussin_nn_1_N : N ;
  sultanat_nn_1_N : N ;
  sugroer_nn_1_1_N : N ;
  suckljud_nn_1_N : N ;
  substrat_nn_1_N : N ;
  substitut_nn_1_N : N ;
  subjekt_nn_1_N : N ;
  stoevelskaft_nn_1_1_N : N ;
  stoetskydd_nn_1_1_N : N ;
  stoertregn_nn_1_1_N : N ;
  stoertlopp_nn_1_1_N : N ;
  stoerskydd_nn_1_1_N : N ;
  stoerningsmoment_nn_1_1_N : N ;
  stoen_nn_1_1_N : N ;
  stoedteam_nn_1_1_N : N ;
  stoedsamtal_nn_1_1_N : N ;
  stoedpapper_nn_1_1_N : N ;
  stoedkoep_nn_1_1_N : N ;
  stoedjordbruk_nn_1_1_N : N ;
  stoedhjul_nn_1_1_N : N ;
  stoed_nn_1_1_N : N ;
  staand_nn_1_1_N : N ;
  staalverk_nn_1_1_N : N ;
  staaltryck_nn_1_1_N : N ;
  staalstick_nn_1_1_N : N ;
  staalskelett_nn_1_1_N : N ;
  staalroer_nn_1_1_N : N ;
  staalbad_nn_1_1_N : N ;
  staal_nn_1_1_N : N ;
  staev_nn_2_1_N : N ;
  staenkskydd_nn_1_1_N : N ;
  staenk_nn_1_1_N : N ;
  staempelur_nn_1_1_N : N ;
  staemmobeslut_nn_1_1_N : N ;
  staemjaern_nn_1_1_N : N ;
  staemband_nn_1_1_N : N ;
  staellverk_nn_1_1_N : N ;
  staellningssteg_nn_1_1_N : N ;
  staellningskrig_nn_1_1_N : N ;
  staell_nn_1_1_N : N ;
  staedskaap_nn_1_1_N : N ;
  staedredskap_nn_1_1_N : N ;
  staedgrael_nn_1_1_N : N ;
  staedfynd_nn_1_1_N : N ;
  staedbolag_nn_1_1_N : N ;
  staed_nn_1_1_N : N ;
  styvbarn_nn_1_N : N ;
  styrmedel_nn_1_N : N ;
  styrkeprov_nn_1_N : N ;
  styrhjul_nn_1_N : N ;
  styrelseuppdrag_nn_1_N : N ;
  styng_nn_1_N : N ;
  stygn_nn_1_N : N ;
  styckmord_nn_1_N : N ;
  styckebruk_nn_1_N : N ;
  stuproer_nn_1_1_N : N ;
  stup_nn_1_N : N ;
  stunttrick_nn_1_N : N ;
  stugkoep_nn_1_1_N : N ;
  stugfoenster_nn_1_1_N : N ;
  studiosamtal_nn_1_N : N ;
  studieaar_nn_1_1_N : N ;
  studieobjekt_nn_1_N : N ;
  studiemedel_nn_1_N : N ;
  studielaan_nn_1_1_N : N ;
  studiefoerbund_nn_1_1_N : N ;
  studiebidrag_nn_1_N : N ;
  studiebesoek_nn_1_1_N : N ;
  studentflak_nn_1_N : N ;
  studentbetyg_nn_1_N : N ;
  stroevtaag_nn_1_1_N : N ;
  stroemuttag_nn_1_1_N : N ;
  stroemoln_nn_1_1_N : N ;
  stroemhopp_nn_1_1_N : N ;
  stroemavbrott_nn_1_1_N : N ;
  stroejobb_nn_1_1_N : N ;
  stroeg_nn_1_1_N : N ;
  straalskyddsinstitut_nn_1_1_N : N ;
  straaldjur_nn_1_1_N : N ;
  straalben_nn_1_1_N : N ;
  straakinstrument_nn_1_1_N : N ;
  straakdrag_nn_1_1_N : N ;
  straak_nn_1_1_N : N ;
  straenginstrument_nn_1_1_N : N ;
  straeckfoerband_nn_1_1_N : N ;
  straeck_nn_1_1_N : N ;
  strypgrepp_nn_1_N : N ;
  strykjaern_nn_1_1_N : N ;
  strutsaegg_nn_1_1_N : N ;
  struplock_nn_1_N : N ;
  strupljud_nn_1_N : N ;
  strumpeband_nn_1_N : N ;
  strofpar_nn_1_N : N ;
  stroboskop_nn_1_N : N ;
  stridsvaern_nn_1_1_N : N ;
  stridsvagnshinder_nn_1_N : N ;
  stridsrop_nn_1_N : N ;
  stridsmedel_nn_1_N : N ;
  stridsledningsflygplan_nn_1_N : N ;
  stridslarm_nn_1_N : N ;
  stridshorn_nn_1_N : N ;
  stridsflygplan_nn_1_N : N ;
  stridsflyg_nn_1_N : N ;
  stressyndrom_nn_1_N : N ;
  streck_nn_1_N : N ;
  strategidokument_nn_1_N : N ;
  strandhugg_nn_1_N : N ;
  strandfynd_nn_1_N : N ;
  straffregister_nn_1_N : N ;
  straffredskap_nn_1_N : N ;
  straff_nn_1_N : N ;
  storverk_nn_1_N : N ;
  storstadsliv_nn_1_N : N ;
  storskot_nn_1_N : N ;
  storsjoeodjur_nn_1_1_N : N ;
  stormtak_nn_1_N : N ;
  stormningsanfall_nn_1_N : N ;
  stormhinder_nn_1_N : N ;
  stormgrael_nn_1_1_N : N ;
  storleksnummer_nn_1_N : N ;
  storkoek_nn_1_1_N : N ;
  storkrig_nn_1_N : N ;
  storhushaall_nn_1_1_N : N ;
  storgrael_nn_1_1_N : N ;
  storfoeretag_nn_1_1_N : N ;
  stordaad_nn_1_1_N : N ;
  storbraak_nn_1_1_N : N ;
  storbolag_nn_1_N : N ;
  storband_nn_1_N : N ;
  stoppur_nn_1_N : N ;
  stopp_nn_1_N : N ;
  stop_nn_1_N : N ;
  stolpskott_nn_1_N : N ;
  stolpiller_nn_1_N : N ;
  stoftmoln_nn_1_N : N ;
  stoftkorn_nn_1_N : N ;
  stoft_nn_1_N : N ;
  stjaernvalv_nn_1_1_N : N ;
  stjaernskott_nn_1_1_N : N ;
  stjaernpar_nn_1_1_N : N ;
  stjaernfallsregn_nn_1_1_N : N ;
  stjaernfall_nn_1_1_N : N ;
  stjaernevalv_nn_1_1_N : N ;
  stjaerndygn_nn_1_1_N : N ;
  stjaelkstygn_nn_1_1_N : N ;
  stinkdjur_nn_1_N : N ;
  sting_nn_1_N : N ;
  stimulanspaket_nn_1_N : N ;
  stilval_nn_1_N : N ;
  stillestaand_nn_1_1_N : N ;
  stilleben_nn_1_N : N ;
  stildrag_nn_1_N : N ;
  stilbrott_nn_1_N : N ;
  stift_nn_2_N : N ;
  stift_nn_1_N : N ;
  stickspaar_nn_1_1_N : N ;
  stickprov_nn_1_N : N ;
  stickord_nn_1_N : N ;
  stickelbaer_nn_1_1_N : N ;
  stick_nn_1_N : N ;
  stetoskop_nn_1_N : N ;
  stereoskop_nn_1_N : N ;
  stenaaldersfynd_nn_1_1_N : N ;
  stenverktyg_nn_1_N : N ;
  stenskottsskydd_nn_1_N : N ;
  stenskott_nn_1_N : N ;
  stenkol_nn_1_N : N ;
  stenhallon_nn_1_N : N ;
  stengolv_nn_1_N : N ;
  stenbaer_nn_1_1_N : N ;
  stenbrott_nn_1_N : N ;
  stenblock_nn_1_N : N ;
  stekspett_nn_1_N : N ;
  stek_nn_2_N : N ;
  steg_nn_1_N : N ;
  stavhopp_nn_1_N : N ;
  stavbrott_nn_1_N : N ;
  statsskick_nn_1_N : N ;
  statsraad_nn_1_1_N : N ;
  statspapper_nn_1_N : N ;
  statsdepartement_nn_1_N : N ;
  statsbidrag_nn_1_N : N ;
  statsbesoek_nn_1_1_N : N ;
  statsanslag_nn_1_N : N ;
  stationsbefael_nn_1_1_N : N ;
  startspjaell_nn_1_1_N : N ;
  startskott_nn_1_N : N ;
  startskjut_nn_1_N : N ;
  startfaelt_nn_1_1_N : N ;
  startblock_nn_1_N : N ;
  stannplan_nn_1_N : N ;
  standardverk_nn_1_N : N ;
  standardsvar_nn_1_N : N ;
  standardspraak_nn_1_1_N : N ;
  standardprov_nn_1_N : N ;
  standardformulaer_nn_1_1_N : N ;
  standar_nn_1_N : N ;
  stamspraak_nn_1_1_N : N ;
  stamp_nn_2_N : N ;
  stambord_nn_1_N : N ;
  stall_nn_2_N : N ;
  staket_nn_1_N : N ;
  stag_nn_1_N : N ;
  stadsplanekontor_nn_1_N : N ;
  stadshotell_nn_1_N : N ;
  stadsbyggnadskontor_nn_1_N : N ;
  stadsbyggnadsborgarraad_nn_1_1_N : N ;
  stadsbud_nn_1_N : N ;
  stadsbibliotek_nn_1_N : N ;
  stadsbesoek_nn_1_1_N : N ;
  stadion_nn_1_N : N ;
  stackmoln_nn_1_N : N ;
  spoestraff_nn_1_1_N : N ;
  spoersmaal_nn_1_1_N : N ;
  spoekdjur_nn_1_1_N : N ;
  spaarelement_nn_1_1_N : N ;
  spaar_nn_1_1_N : N ;
  spaan_nn_1_1_N : N ;
  spaennband_nn_1_1_N : N ;
  spaedbarn_nn_1_1_N : N ;
  spygatt_nn_1_N : N ;
  sproet_nn_1_1_N : N ;
  spraang_nn_1_1_N : N ;
  spraakroer_nn_1_1_N : N ;
  spraakprov_nn_1_1_N : N ;
  spraakmoenster_nn_1_1_N : N ;
  spraakljud_nn_1_1_N : N ;
  spraakbraak_nn_1_1_N : N ;
  spraak_nn_1_1_N : N ;
  spraengstoff_nn_1_1_N : N ;
  spraengmedel_nn_1_1_N : N ;
  spraengdaad_nn_1_1_N : N ;
  spraengattentat_nn_1_1_N : N ;
  sprut_nn_1_N : N ;
  sprund_nn_1_N : N ;
  spritkoek_nn_1_1_N : N ;
  springpojksjobb_nn_1_N : N ;
  springardrag_nn_1_N : N ;
  spring_nn_2_N : N ;
  spridningsmaatt_nn_1_1_N : N ;
  spratt_nn_1_N : N ;
  sportlov_nn_1_N : N ;
  sportflygplan_nn_1_N : N ;
  spordjur_nn_1_N : N ;
  splittersaar_nn_1_1_N : N ;
  spjaellband_nn_1_1_N : N ;
  spjaell_nn_1_1_N : N ;
  spjut_nn_1_N : N ;
  spiralblock_nn_1_N : N ;
  spionfall_nn_1_N : N ;
  spinnkvalster_nn_1_N : N ;
  spindelnaet_nn_1_1_N : N ;
  spindeldjur_nn_1_N : N ;
  spikband_nn_1_N : N ;
  spikattentat_nn_1_N : N ;
  spett_nn_1_N : N ;
  spenabarn_nn_1_N : N ;
  spelaar_nn_1_1_N : N ;
  spelverk_nn_1_N : N ;
  spelprov_nn_1_N : N ;
  spelkort_nn_1_N : N ;
  spelbord_nn_1_N : N ;
  spel_nn_1_N : N ;
  spektroskop_nn_1_N : N ;
  spegelteleskop_nn_1_N : N ;
  species_nn_1_N : N ;
  specialtaag_nn_1_1_N : N ;
  specialtillstaand_nn_1_1_N : N ;
  specialnummer_nn_1_N : N ;
  sparpaket_nn_1_N : N ;
  sparlaan_nn_1_1_N : N ;
  sparlakan_nn_1_N : N ;
  sparkrav_nn_1_N : N ;
  sparknummer_nn_1_N : N ;
  sparbeting_nn_1_N : N ;
  spant_nn_1_N : N ;
  spanskroer_nn_1_1_N : N ;
  spann_nn_3_N : N ;
  spaningsuppdrag_nn_1_N : N ;
  spaningsplan_nn_1_N : N ;
  spaningsmord_nn_1_N : N ;
  spaningsflyg_nn_1_N : N ;
  spaltkorrektur_nn_1_N : N ;
  spakblock_nn_1_N : N ;
  spadtag_nn_1_N : N ;
  sovrumsfoenster_nn_1_1_N : N ;
  souterraengplan_nn_1_1_N : N ;
  souterrainplan_nn_1_N : N ;
  sound_nn_1_N : N ;
  soulagemang_nn_1_N : N ;
  sotskikt_nn_1_N : N ;
  sotmoln_nn_1_N : N ;
  sortiment_nn_1_N : N ;
  sorteringsverk_nn_1_N : N ;
  sorgflor_nn_1_N : N ;
  sorgeaar_nn_1_1_N : N ;
  sorgebud_nn_1_N : N ;
  sorgebarn_nn_1_N : N ;
  sorgbarn_nn_1_N : N ;
  sorgband_nn_1_N : N ;
  soppkoek_nn_1_1_N : N ;
  sopberg_nn_1_N : N ;
  sonnamn_nn_1_N : N ;
  sommarvaeder_nn_1_1_N : N ;
  sommartorp_nn_1_N : N ;
  sommarregn_nn_1_N : N ;
  sommarmoln_nn_1_N : N ;
  sommarlaeger_nn_1_1_N : N ;
  sommarlov_nn_1_N : N ;
  sommarland_nn_1_N : N ;
  sommarjobb_nn_1_N : N ;
  sommarhalvaar_nn_1_1_N : N ;
  sommargyllen_nn_1_N : N ;
  sommardaeck_nn_1_1_N : N ;
  sommarbarn_nn_1_N : N ;
  solaar_nn_1_1_N : N ;
  solvarv_nn_1_N : N ;
  solv_nn_1_N : N ;
  solur_nn_1_N : N ;
  soltak_nn_1_N : N ;
  solskyddsmedel_nn_1_N : N ;
  solskydd_nn_1_N : N ;
  solskensvaeder_nn_1_1_N : N ;
  solmaal_nn_1_1_N : N ;
  solklipp_nn_1_N : N ;
  solhjul_nn_1_N : N ;
  solfall_nn_1_N : N ;
  soldygn_nn_1_N : N ;
  soldattorp_nn_1_N : N ;
  soldatnamn_nn_1_N : N ;
  solbad_nn_1_N : N ;
  sofflock_nn_1_N : N ;
  soffbord_nn_1_N : N ;
  sockeroeverdrag_nn_1_1_N : N ;
  sockerroer_nn_1_1_N : N ;
  sockerpiller_nn_1_N : N ;
  sockergryn_nn_1_N : N ;
  sockerbruk_nn_1_N : N ;
  sockenbud_nn_1_N : N ;
  societetslejon_nn_1_N : N ;
  socialregister_nn_1_N : N ;
  socialfoersaekringsutskott_nn_1_1_N : N ;
  socialfall_nn_1_N : N ;
  socialbidrag_nn_1_N : N ;
  snoestaket_nn_1_1_N : N ;
  snoeskred_nn_1_1_N : N ;
  snoerliv_nn_1_1_N : N ;
  snoeredskap_nn_1_1_N : N ;
  snoeovaeder_nn_1_1_N : N ;
  snoelandskap_nn_1_1_N : N ;
  snoeklot_nn_1_1_N : N ;
  snoefjaell_nn_1_1_N : N ;
  snoefall_nn_1_1_N : N ;
  snoedjup_nn_1_1_N : N ;
  snoebaer_nn_1_1_N : N ;
  snoebollskrig_nn_1_1_N : N ;
  snaar_nn_1_1_N : N ;
  snaerp_nn_2_1_N : N ;
  snaerj_nn_2_1_N : N ;
  snaepplock_nn_1_1_N : N ;
  snaepp_nn_1_1_N : N ;
  snaelltaag_nn_1_1_N : N ;
  snaeckskal_nn_1_1_N : N ;
  snaeckhjul_nn_1_1_N : N ;
  snaeckdjur_nn_1_1_N : N ;
  snyft_nn_1_N : N ;
  snittbetyg_nn_1_N : N ;
  snitt_nn_1_N : N ;
  snilleverk_nn_1_N : N ;
  snilleprov_nn_1_N : N ;
  snillefoster_nn_1_N : N ;
  snilledrag_nn_1_N : N ;
  snickarverktyg_nn_1_N : N ;
  snedtak_nn_1_N : N ;
  snedstreck_nn_1_N : N ;
  snedsteg_nn_1_N : N ;
  snedspraang_nn_1_1_N : N ;
  snabbtaag_nn_1_1_N : N ;
  snabbstopp_nn_1_N : N ;
  snabbprotokoll_nn_1_N : N ;
  snabbportraett_nn_1_1_N : N ;
  snabbkoep_nn_1_1_N : N ;
  snabbfoerband_nn_1_1_N : N ;
  smoerjmedel_nn_1_1_N : N ;
  smoerjhaal_nn_1_1_N : N ;
  smoergaaspaalaegg_nn_1_1_N : N ;
  smoergaasbord_nn_1_1_N : N ;
  smoerberg_nn_1_1_N : N ;
  smaapaket_nn_1_1_N : N ;
  smaaord_nn_1_1_N : N ;
  smaamynt_nn_1_1_N : N ;
  smaakryp_nn_1_1_N : N ;
  smaajordbruk_nn_1_1_N : N ;
  smaahuslaan_nn_1_1_N : N ;
  smaagrael_nn_1_1_N : N ;
  smaafoeretag_nn_1_1_N : N ;
  smaaflin_nn_1_1_N : N ;
  smaadjur_nn_1_1_N : N ;
  smaabruk_nn_1_1_N : N ;
  smaabarnsaar_nn_1_1_N : N ;
  smaabarnsliv_nn_1_1_N : N ;
  smaabarn_nn_1_1_N : N ;
  smaerttillstaand_nn_1_1_N : N ;
  smaeltverk_nn_1_1_N : N ;
  smaeltskydd_nn_1_1_N : N ;
  smaedeord_nn_1_1_N : N ;
  smaedenamn_nn_1_1_N : N ;
  smyghaal_nn_1_1_N : N ;
  smyckegarnityr_nn_1_N : N ;
  smutsblad_nn_1_N : N ;
  smultron_nn_1_N : N ;
  smugglingsbrott_nn_1_N : N ;
  smugglarskepp_nn_1_N : N ;
  smil_nn_1_N : N ;
  smidesverktyg_nn_1_N : N ;
  smekord_nn_1_N : N ;
  smeknamn_nn_1_N : N ;
  smaldjur_nn_1_N : N ;
  smalben_nn_1_N : N ;
  smakraad_nn_1_1_N : N ;
  sloer_nn_2_1_N : N ;
  sloejmoln_nn_1_1_N : N ;
  slaanbaer_nn_1_1_N : N ;
  slaepp_nn_1_1_N : N ;
  slaep_nn_1_1_N : N ;
  slaengskott_nn_1_1_N : N ;
  slaektregister_nn_1_1_N : N ;
  slaektportraett_nn_1_1_N : N ;
  slaektnamn_nn_1_1_N : N ;
  slaektled_nn_1_1_N : N ;
  slaektdrag_nn_1_1_N : N ;
  slaektbesoek_nn_1_1_N : N ;
  slaektband_nn_1_1_N : N ;
  slaeddon_nn_1_1_N : N ;
  slutstreck_nn_1_N : N ;
  slutsteg_nn_1_N : N ;
  slutresultat_nn_1_N : N ;
  slutprov_nn_1_N : N ;
  slutmaal_nn_1_1_N : N ;
  slutljud_nn_1_N : N ;
  slutfall_nn_1_N : N ;
  slut_nn_1_N : N ;
  slumpurval_nn_1_N : N ;
  slumptal_nn_1_N : N ;
  slott_nn_1_N : N ;
  slitskydd_nn_1_N : N ;
  slitlager_nn_1_N : N ;
  slirskydd_nn_1_N : N ;
  slipsval_nn_1_N : N ;
  slipsnitt_nn_1_N : N ;
  slipresultat_nn_1_N : N ;
  slippapper_nn_1_N : N ;
  slipmedel_nn_1_N : N ;
  slingerskott_nn_1_N : N ;
  slingerbord_nn_1_N : N ;
  sling_nn_1_N : N ;
  slinder_nn_1_N : N ;
  slidhornsdjur_nn_1_N : N ;
  slavuppror_nn_1_N : N ;
  slavlaeger_nn_1_1_N : N ;
  slavarbetslaeger_nn_1_1_N : N ;
  slangspraak_nn_1_1_N : N ;
  slaktdjur_nn_1_N : N ;
  slagverk_nn_1_N : N ;
  slagsvaerd_nn_1_1_N : N ;
  slagstift_nn_1_N : N ;
  slagsmaal_nn_1_1_N : N ;
  slagskepp_nn_1_N : N ;
  slagregn_nn_1_N : N ;
  slagord_nn_1_N : N ;
  slagnummer_nn_1_N : N ;
  slaginstrument_nn_1_N : N ;
  slagfaelt_nn_1_1_N : N ;
  slagbord_nn_1_N : N ;
  slaganfall_nn_1_N : N ;
  slag_nn_1_N : N ;
  sladdbarn_nn_1_N : N ;
  skoetebarn_nn_1_1_N : N ;
  skoetbord_nn_1_1_N : N ;
  skoert_nn_1_1_N : N ;
  skoenhetsmedel_nn_1_1_N : N ;
  skoenhetsideal_nn_1_1_N : N ;
  skoenhetsfoeretag_nn_1_1_N : N ;
  skoeldebrev_nn_1_1_N : N ;
  skaar_nn_1_1_N : N ;
  skaap_nn_1_1_N : N ;
  skaalpund_nn_1_1_N : N ;
  skaadespelarpar_nn_1_1_N : N ;
  skaademynt_nn_1_1_N : N ;
  skaerpedjup_nn_1_1_N : N ;
  skaerp_nn_1_1_N : N ;
  skaer_nn_1_1_N : N ;
  skaemt_nn_1_1_N : N ;
  skaellsord_nn_1_1_N : N ;
  skael_nn_1_1_N : N ;
  skaegg_nn_1_1_N : N ;
  skyttevaern_nn_1_1_N : N ;
  skyttegravskrig_nn_1_N : N ;
  skymford_nn_1_N : N ;
  skyltskaap_nn_1_1_N : N ;
  skyltfoenster_nn_1_1_N : N ;
  skylight_nn_1_N : N ;
  skyfall_nn_1_N : N ;
  skydrag_nn_1_N : N ;
  skyddsoeverdrag_nn_1_1_N : N ;
  skyddsvaern_nn_1_1_N : N ;
  skyddstak_nn_1_N : N ;
  skyddspapper_nn_1_N : N ;
  skyddsombud_nn_1_N : N ;
  skyddsnaet_nn_1_1_N : N ;
  skyddsmedel_nn_1_N : N ;
  skyddslock_nn_1_N : N ;
  skyddshelgon_nn_1_N : N ;
  skydd_nn_2_N : N ;
  skvallerdrev_nn_1_N : N ;
  skvallerbaer_nn_1_1_N : N ;
  skutt_nn_1_N : N ;
  skurpulver_nn_1_N : N ;
  skurmedel_nn_1_N : N ;
  skurlov_nn_1_N : N ;
  skurkstreck_nn_1_N : N ;
  skurgolv_nn_1_N : N ;
  skuramedel_nn_1_N : N ;
  skunkdjur_nn_1_N : N ;
  skumbad_nn_1_N : N ;
  skulderblad_nn_1_N : N ;
  skuldebrev_nn_1_N : N ;
  skuldbelopp_nn_1_N : N ;
  skuggkabinett_nn_1_N : N ;
  skubb_nn_1_N : N ;
  skraal_nn_1_1_N : N ;
  skraepplockningsspjut_nn_1_1_N : N ;
  skraen_nn_1_1_N : N ;
  skraemskott_nn_1_1_N : N ;
  skraeckkabinett_nn_1_1_N : N ;
  skrymt_nn_1_N : N ;
  skruvstaed_nn_1_1_N : N ;
  skruvhaal_nn_1_1_N : N ;
  skruvfoerband_nn_1_1_N : N ;
  skruvavstaand_nn_1_1_N : N ;
  skrubbsaar_nn_1_1_N : N ;
  skrovmaal_nn_1_1_N : N ;
  skrov_nn_1_N : N ;
  skrotupplag_nn_1_N : N ;
  skrivaar_nn_1_1_N : N ;
  skrivunderlaegg_nn_1_1_N : N ;
  skrivsaett_nn_1_1_N : N ;
  skrivplaan_nn_1_1_N : N ;
  skrivmaskinsbord_nn_1_N : N ;
  skrivbordsunderlaegg_nn_1_1_N : N ;
  skrivbordsjobb_nn_1_N : N ;
  skrivbord_nn_1_N : N ;
  skrivblock_nn_1_N : N ;
  skrivarpapper_nn_1_N : N ;
  skrin_nn_1_N : N ;
  skrik_nn_1_N : N ;
  skriftspraak_nn_1_1_N : N ;
  skriftermaal_nn_1_1_N : N ;
  skrev_nn_1_N : N ;
  skred_nn_1_N : N ;
  skrattpaalaegg_nn_1_1_N : N ;
  skratt_nn_1_N : N ;
  skrapsaar_nn_1_1_N : N ;
  skrapfaelt_nn_1_1_N : N ;
  skrank_nn_1_N : N ;
  skovelhjul_nn_1_N : N ;
  skov_nn_1_N : N ;
  skottaar_nn_1_1_N : N ;
  skottkaerrehjul_nn_1_1_N : N ;
  skotthaal_nn_1_1_N : N ;
  skottfaelt_nn_1_1_N : N ;
  skott_nn_1_N : N ;
  skotstek_nn_1_N : N ;
  skothorn_nn_1_N : N ;
  skot_nn_1_N : N ;
  skonummer_nn_1_N : N ;
  skonertskepp_nn_1_N : N ;
  skolaar_nn_1_1_N : N ;
  skolskepp_nn_1_N : N ;
  skolraad_nn_1_1_N : N ;
  skolprov_nn_1_N : N ;
  skolmognadsprov_nn_1_N : N ;
  skollov_nn_1_N : N ;
  skolkoek_nn_1_1_N : N ;
  skolkort_nn_1_N : N ;
  skolflygplan_nn_1_N : N ;
  skolfartyg_nn_1_N : N ;
  skoldistrikt_nn_1_N : N ;
  skolbetyg_nn_1_N : N ;
  skolbarn_nn_1_N : N ;
  skoj_nn_1_N : N ;
  skohorn_nn_1_N : N ;
  skogslandskap_nn_1_N : N ;
  skogsbolag_nn_1_N : N ;
  skodon_nn_1_N : N ;
  skoblock_nn_1_N : N ;
  skjutshaall_nn_1_1_N : N ;
  skjutmaattset_nn_1_1_N : N ;
  skjutmaatt_nn_1_1_N : N ;
  skjutjaern_nn_1_1_N : N ;
  skjutfoenster_nn_1_1_N : N ;
  skjutfaelt_nn_1_1_N : N ;
  skjut_nn_1_N : N ;
  skjul_nn_1_N : N ;
  skivomslag_nn_1_N : N ;
  skivkontrakt_nn_1_N : N ;
  skivbolag_nn_1_N : N ;
  skitaar_nn_1_1_N : N ;
  skissblock_nn_1_N : N ;
  skioptikon_nn_1_N : N ;
  skinnband_nn_1_N : N ;
  skinn_nn_1_N : N ;
  skingringsfoerbud_nn_1_1_N : N ;
  skilsmaessopapper_nn_1_1_N : N ;
  skilsmaessobarn_nn_1_1_N : N ;
  skillingtryck_nn_1_N : N ;
  skiljeset_nn_1_N : N ;
  skiljemynt_nn_1_N : N ;
  skiktmoln_nn_1_N : N ;
  skikt_nn_1_N : N ;
  skift_nn_1_N : N ;
  skiffertak_nn_1_N : N ;
  skidspaar_nn_1_1_N : N ;
  skidfynd_nn_1_N : N ;
  skickebud_nn_1_N : N ;
  skick_nn_1_N : N ;
  skevroder_nn_1_N : N ;
  skevningsroder_nn_1_N : N ;
  skeppund_nn_1_N : N ;
  skeppsvarv_nn_1_N : N ;
  skeppslag_nn_1_N : N ;
  skeppsbrott_nn_1_N : N ;
  skeppsapotek_nn_1_N : N ;
  skepparbrev_nn_1_N : N ;
  skepp_nn_1_N : N ;
  skenaektenskap_nn_1_1_N : N ;
  skenben_nn_1_N : N ;
  sken_nn_1_N : N ;
  skelett_nn_1_N : N ;
  skeddrag_nn_1_N : N ;
  skavsaar_nn_1_1_N : N ;
  skavskydd_nn_1_N : N ;
  skatteverk_nn_1_N : N ;
  skatteuttag_nn_1_N : N ;
  skatteuppskov_nn_1_N : N ;
  skatteunderlag_nn_1_N : N ;
  skattetryck_nn_1_N : N ;
  skattetillaegg_nn_1_1_N : N ;
  skattetak_nn_1_N : N ;
  skattemedel_nn_1_N : N ;
  skattekort_nn_1_N : N ;
  skattefoerslag_nn_1_1_N : N ;
  skattebrott_nn_1_N : N ;
  skattebelopp_nn_1_N : N ;
  skatteavdrag_nn_1_N : N ;
  skarndaeck_nn_1_1_N : N ;
  skarn_nn_1_N : N ;
  skap_nn_1_N : N ;
  skandalmaal_nn_1_1_N : N ;
  skamgrepp_nn_1_N : N ;
  skalv_nn_1_N : N ;
  skalstreck_nn_1_N : N ;
  skallben_nn_1_N : N ;
  skall_nn_1_N : N ;
  skalkorn_nn_1_N : N ;
  skalkeskjul_nn_1_N : N ;
  skaldjur_nn_1_N : N ;
  skal_nn_1_N : N ;
  skak_nn_1_N : N ;
  skaft_nn_1_N : N ;
  skadestaand_nn_1_1_N : N ;
  skadedjur_nn_1_N : N ;
  skabbdjur_nn_1_N : N ;
  sjoeslag_nn_1_1_N : N ;
  sjoesediment_nn_1_1_N : N ;
  sjoeodjur_nn_1_1_N : N ;
  sjoelejon_nn_1_1_N : N ;
  sjoekrig_nn_1_1_N : N ;
  sjoekort_nn_1_1_N : N ;
  sjoekaptensbrev_nn_1_1_N : N ;
  sjoefoerhoer_nn_1_1_N : N ;
  sjoefynd_nn_1_1_N : N ;
  sjoeflygplan_nn_1_1_N : N ;
  sjaap_nn_1_1_N : N ;
  sjaelvaendamaal_nn_1_1_N : N ;
  sjaelvportraett_nn_1_1_N : N ;
  sjaelvmaal_nn_1_1_N : N ;
  sjaelvmordsuppdrag_nn_1_1_N : N ;
  sjaelvmordsfoersoek_nn_1_1_N : N ;
  sjaelvmord_nn_1_1_N : N ;
  sjaelvljud_nn_1_1_N : N ;
  sjaelvhjaelpsraad_nn_1_1_N : N ;
  sjaelstillstaand_nn_1_1_N : N ;
  sjumilakliv_nn_1_N : N ;
  sjuklaeger_nn_1_1_N : N ;
  sjukdomstillstaand_nn_1_1_N : N ;
  sjukdomsfoerlopp_nn_1_1_N : N ;
  sjukbud_nn_1_N : N ;
  sjukbesoek_nn_1_1_N : N ;
  sjukavdrag_nn_1_N : N ;
  sjok_nn_1_N : N ;
  sjapp_nn_1_N : N ;
  sj_ljud_nn_1_N : N ;
  sittben_nn_1_N : N ;
  sittbadkar_nn_1_N : N ;
  sirentjut_nn_1_N : N ;
  sirendjur_nn_1_N : N ;
  sinnesorgan_nn_1_N : N ;
  sinnesintryck_nn_1_N : N ;
  simtag_nn_1_N : N ;
  simsaett_nn_1_1_N : N ;
  simprov_nn_1_N : N ;
  simorgan_nn_1_N : N ;
  simhopp_nn_1_N : N ;
  simhallstak_nn_1_N : N ;
  silvermynt_nn_1_N : N ;
  silverlejon_nn_1_N : N ;
  silverfoeremaal_nn_1_1_N : N ;
  silverfat_nn_1_N : N ;
  silverbroellop_nn_1_1_N : N ;
  silverbrudpar_nn_1_N : N ;
  silverbeslag_nn_1_N : N ;
  silkesband_nn_1_N : N ;
  silkepapper_nn_1_N : N ;
  silikonimplantat_nn_1_N : N ;
  silben_nn_1_N : N ;
  siktbroed_nn_1_1_N : N ;
  signet_nn_1_N : N ;
  signalur_nn_1_N : N ;
  signalstaell_nn_1_1_N : N ;
  signalmoenster_nn_1_1_N : N ;
  signalhorn_nn_1_N : N ;
  signalement_nn_1_N : N ;
  sigill_nn_1_N : N ;
  sifferbetyg_nn_1_N : N ;
  sidroder_nn_1_N : N ;
  sidospaar_nn_1_1_N : N ;
  sidospraang_nn_1_1_N : N ;
  sidoskott_nn_1_N : N ;
  sidoskepp_nn_1_N : N ;
  sidoplan_nn_1_N : N ;
  sidolinjeorgan_nn_1_N : N ;
  sidohandtag_nn_1_N : N ;
  sidogevaer_nn_1_1_N : N ;
  sidodaeck_nn_1_1_N : N ;
  sidobord_nn_1_N : N ;
  sidoarv_nn_1_N : N ;
  sidnummer_nn_1_N : N ;
  sideboard_nn_1_N : N ;
  sibetdjur_nn_1_N : N ;
  shuffle_board_nn_1_N : N ;
  shelterdaeck_nn_1_1_N : N ;
  sexualorgan_nn_1_N : N ;
  sexualmord_nn_1_N : N ;
  sexualbrott_nn_1_N : N ;
  sexspann_nn_1_N : N ;
  sexpartssamtal_nn_1_N : N ;
  sexmord_nn_1_N : N ;
  sexkoep_nn_1_1_N : N ;
  sexklipp_nn_1_N : N ;
  sexhjaelpmedel_nn_1_1_N : N ;
  sexbrott_nn_1_N : N ;
  settlement_nn_1_N : N ;
  set_nn_1_N : N ;
  servitut_nn_1_N : N ;
  serveringsfat_nn_1_N : N ;
  serveringsbord_nn_1_N : N ;
  seriemord_nn_1_N : N ;
  seriemagasin_nn_1_N : N ;
  serafimerband_nn_1_N : N ;
  separat_nn_1_N : N ;
  sentiment_nn_1_N : N ;
  senorgan_nn_1_N : N ;
  senapskorn_nn_1_N : N ;
  semikolon_nn_1_N : N ;
  semestertillaegg_nn_1_1_N : N ;
  semesterfynd_nn_1_N : N ;
  semaforalfabet_nn_1_N : N ;
  seltyg_nn_1_N : N ;
  seldon_nn_1_N : N ;
  selbrott_nn_1_N : N ;
  sel_nn_1_N : N ;
  sekretariat_nn_1_N : N ;
  sekret_nn_1_N : N ;
  sejnfall_nn_1_N : N ;
  segregat_nn_1_N : N ;
  segment_nn_1_N : N ;
  segertaag_nn_1_1_N : N ;
  segermonument_nn_1_N : N ;
  segelstaell_nn_1_1_N : N ;
  segelkapell_nn_1_N : N ;
  segelflygplan_nn_1_N : N ;
  segelflyg_nn_1_N : N ;
  segelfartyg_nn_1_N : N ;
  sedlighetsbrott_nn_1_N : N ;
  sedimentlager_nn_1_N : N ;
  sediment_nn_1_N : N ;
  sedebetyg_nn_1_N : N ;
  scoutlaeger_nn_1_1_N : N ;
  scoop_nn_1_N : N ;
  schwa_ljud_nn_1_N : N ;
  schlagerbraak_nn_1_1_N : N ;
  schlagerbidrag_nn_1_N : N ;
  schatull_nn_1_N : N ;
  schapp_nn_1_N : N ;
  schakt_nn_1_N : N ;
  schackmoenster_nn_1_1_N : N ;
  schackdrag_nn_1_N : N ;
  schackbord_nn_1_N : N ;
  schabrak_nn_1_N : N ;
  schablontillaegg_nn_1_1_N : N ;
  schablonbelopp_nn_1_N : N ;
  schablonavdrag_nn_1_N : N ;
  saxskaer_nn_1_1_N : N ;
  saxredskap_nn_1_N : N ;
  saxblad_nn_1_N : N ;
  sattyg_nn_1_N : N ;
  satsbord_nn_1_N : N ;
  satemspraak_nn_1_1_N : N ;
  sarkom_nn_1_N : N ;
  sanningskrav_nn_1_N : N ;
  sanningskorn_nn_1_N : N ;
  sanningsanspraak_nn_1_1_N : N ;
  sanitetskaerl_nn_1_1_N : N ;
  saneringsmedel_nn_1_N : N ;
  saneringsfartyg_nn_1_N : N ;
  sandur_nn_1_N : N ;
  sandtag_nn_1_N : N ;
  sandspaar_nn_1_1_N : N ;
  sandroer_nn_1_1_N : N ;
  sandrev_nn_1_N : N ;
  sandpapper_nn_1_N : N ;
  sandlaadekrig_nn_1_1_N : N ;
  sandkorn_nn_1_N : N ;
  sandflugebett_nn_1_N : N ;
  sandbad_nn_1_N : N ;
  samvetsaektenskap_nn_1_1_N : N ;
  samvetsstyng_nn_1_N : N ;
  samvetsskael_nn_1_1_N : N ;
  samvetskval_nn_1_N : N ;
  samverkansprojekt_nn_1_N : N ;
  samurajsvaerd_nn_1_1_N : N ;
  samtal_nn_1_N : N ;
  samraad_nn_1_1_N : N ;
  sammetsblomster_nn_1_N : N ;
  sammelnamn_nn_1_N : N ;
  sammelband_nn_1_N : N ;
  sammanskott_nn_1_N : N ;
  sammanhang_nn_1_N : N ;
  sammanfall_nn_1_N : N ;
  sammandrag_nn_1_N : N ;
  sammanbrott_nn_1_N : N ;
  samlingsverk_nn_1_N : N ;
  samlingsnamn_nn_1_N : N ;
  samlingsband_nn_1_N : N ;
  samlarfoeremaal_nn_1_1_N : N ;
  samlarfolk_nn_1_N : N ;
  samlag_nn_1_N : N ;
  samkoep_nn_1_1_N : N ;
  samkvaem_nn_1_1_N : N ;
  samhaellsskikt_nn_1_1_N : N ;
  samhaellsskick_nn_1_1_N : N ;
  samhaellsorgan_nn_1_1_N : N ;
  samhaellskontrakt_nn_1_1_N : N ;
  samhaellsideal_nn_1_1_N : N ;
  samhaellsfoerdrag_nn_1_1_N : N ;
  samfaerdsmedel_nn_1_1_N : N ;
  samfund_nn_1_N : N ;
  sambord_nn_1_N : N ;
  samboavtal_nn_1_N : N ;
  samband_nn_1_N : N ;
  samarv_nn_1_N : N ;
  samarbetsorgan_nn_1_N : N ;
  salutskott_nn_1_N : N ;
  salutorg_nn_1_N : N ;
  salustaand_nn_1_1_N : N ;
  saltverk_nn_1_N : N ;
  saltkar_nn_1_N : N ;
  saltbehov_nn_1_N : N ;
  saltbad_nn_1_N : N ;
  salsgolv_nn_1_N : N ;
  salongslejon_nn_1_N : N ;
  salongsgevaer_nn_1_1_N : N ;
  salningshorn_nn_1_N : N ;
  salladsland_nn_1_N : N ;
  salladsbestick_nn_1_N : N ;
  salighetsmedel_nn_1_N : N ;
  salband_nn_1_N : N ;
  sakskael_nn_1_1_N : N ;
  sakregister_nn_1_N : N ;
  sakramentsskaap_nn_1_1_N : N ;
  sakrament_nn_1_N : N ;
  sakord_nn_1_N : N ;
  sakobjekt_nn_1_N : N ;
  sakkunniguppdrag_nn_1_N : N ;
  sagoslott_nn_1_N : N ;
  sagogryn_nn_1_N : N ;
  sagodjur_nn_1_N : N ;
  saffransbroed_nn_1_1_N : N ;
  sadeltak_nn_1_N : N ;
  sadelskydd_nn_1_N : N ;
  sadelmakarstift_nn_1_N : N ;
  sadelbrott_nn_1_N : N ;
  sabbatsaar_nn_1_1_N : N ;
  sabbatsbrott_nn_1_N : N ;
  roevhaal_nn_1_1_N : N ;
  roetaegg_nn_1_1_N : N ;
  roestkort_nn_1_1_N : N ;
  roestjaern_nn_1_1_N : N ;
  roestetal_nn_1_1_N : N ;
  roerelsemoenster_nn_1_1_N : N ;
  roerelsemaengdsmoment_nn_1_1_N : N ;
  roerblad_nn_1_1_N : N ;
  roer_nn_1_1_N : N ;
  roentgenroer_nn_1_1_N : N ;
  roentgenmikroskop_nn_1_1_N : N ;
  roennbaer_nn_1_1_N : N ;
  roen_nn_1_1_N : N ;
  roekmoln_nn_1_1_N : N ;
  roekfoerbud_nn_1_1_N : N ;
  roekfaang_nn_1_1_N : N ;
  roekelsekar_nn_1_1_N : N ;
  roekbord_nn_1_1_N : N ;
  roedtjut_nn_1_1_N : N ;
  roedskinn_nn_1_1_N : N ;
  roedfilter_nn_1_1_N : N ;
  raatthaal_nn_1_1_N : N ;
  raattdjur_nn_1_1_N : N ;
  raaskinn_nn_1_1_N : N ;
  raanmord_nn_1_1_N : N ;
  raanfoersoek_nn_1_1_N : N ;
  raan_nn_1_1_N : N ;
  raakurr_nn_1_1_N : N ;
  raagkorn_nn_1_1_N : N ;
  raagbroed_nn_1_1_N : N ;
  raadslut_nn_1_1_N : N ;
  raadslag_nn_1_1_N : N ;
  raadjurskid_nn_1_1_N : N ;
  raadjur_nn_1_1_N : N ;
  raad_nn_2_1_N : N ;
  raad_nn_1_1_N : N ;
  raaband_nn_1_1_N : N ;
  raettviseideal_nn_1_1_N : N ;
  raettviseengagemang_nn_1_1_N : N ;
  raettsoevergrepp_nn_1_1_N : N ;
  raettssubjekt_nn_1_1_N : N ;
  raettshjaelpskontor_nn_1_1_N : N ;
  raettsfall_nn_1_1_N : N ;
  raettsbegrepp_nn_1_1_N : N ;
  raetblock_nn_1_1_N : N ;
  raentebesked_nn_1_1_N : N ;
  raenteavdrag_nn_1_1_N : N ;
  raelsbrott_nn_1_1_N : N ;
  raekneverk_nn_1_1_N : N ;
  raeknesaett_nn_1_1_N : N ;
  raekneord_nn_1_1_N : N ;
  raekenskapsaar_nn_1_1_N : N ;
  raeddningspaadrag_nn_1_1_N : N ;
  raeddningspaket_nn_1_1_N : N ;
  raeddningsflyg_nn_1_1_N : N ;
  raeckverk_nn_1_1_N : N ;
  raeck_nn_1_1_N : N ;
  ryttarfolk_nn_1_N : N ;
  rysch_nn_1_N : N ;
  rymdskepp_nn_1_N : N ;
  rymdmaatt_nn_1_1_N : N ;
  ryggstoed_nn_1_1_N : N ;
  ryggslut_nn_1_N : N ;
  ryggskott_nn_1_N : N ;
  ryggradsdjur_nn_1_N : N ;
  ryggornament_nn_1_N : N ;
  ryggmaergsprov_nn_1_1_N : N ;
  ryggbesvaer_nn_1_1_N : N ;
  ryck_nn_1_N : N ;
  rutpapper_nn_1_N : N ;
  rutnaet_nn_1_1_N : N ;
  rutmoenster_nn_1_1_N : N ;
  rutavdrag_nn_1_N : N ;
  rusthaall_nn_1_1_N : N ;
  russin_nn_1_N : N ;
  rusdrycksfoerbud_nn_1_1_N : N ;
  rundjaern_nn_1_1_N : N ;
  rundfoenster_nn_1_1_N : N ;
  rundbrev_nn_1_N : N ;
  rundabordssamtal_nn_1_N : N ;
  rumsnummer_nn_1_N : N ;
  rumptroll_nn_1_N : N ;
  rullrev_nn_1_N : N ;
  rullbord_nn_1_N : N ;
  rullband_nn_1_N : N ;
  rullager_nn_1_N : N ;
  rufftak_nn_1_N : N ;
  rudiment_nn_1_N : N ;
  rovdjur_nn_1_N : N ;
  rov_nn_1_N : N ;
  rotorblad_nn_1_N : N ;
  rotavdrag_nn_1_N : N ;
  rostskyddspigment_nn_1_N : N ;
  rostskyddsmedel_nn_1_N : N ;
  rostskydd_nn_1_N : N ;
  roster_nn_1_N : N ;
  rosettmoenster_nn_1_1_N : N ;
  rosettfoenster_nn_1_1_N : N ;
  rosenmoln_nn_1_N : N ;
  rosenbroed_nn_1_1_N : N ;
  rop_nn_1_N : N ;
  rollfack_nn_1_N : N ;
  rollerhandtag_nn_1_N : N ;
  roll_on_roll_off_fartyg_nn_1_N : N ;
  roder_nn_1_N : N ;
  roddarlag_nn_1_N : N ;
  rockband_nn_1_N : N ;
  ro_ro_fartyg_nn_1_N : N ;
  rivningskontrakt_nn_1_N : N ;
  rivjaern_nn_1_1_N : N ;
  ritualmord_nn_1_N : N ;
  ritkol_nn_1_N : N ;
  ritbord_nn_1_N : N ;
  ritblock_nn_1_N : N ;
  ritbestick_nn_1_N : N ;
  risktal_nn_1_N : N ;
  riskkapitalbolag_nn_1_N : N ;
  risgryn_nn_1_N : N ;
  ringvrak_nn_1_N : N ;
  ringtryck_nn_1_N : N ;
  ringrev_nn_1_N : N ;
  ringberg_nn_1_N : N ;
  riktnummer_nn_1_N : N ;
  riktmedel_nn_1_N : N ;
  riktinstrument_nn_1_N : N ;
  riksuttag_nn_1_N : N ;
  riksspraak_nn_1_1_N : N ;
  rikssamtal_nn_1_N : N ;
  riksraad_nn_1_1_N : N ;
  riksnaet_nn_1_1_N : N ;
  riksmynt_nn_1_N : N ;
  riksgenomsnitt_nn_1_N : N ;
  riksfoerbund_nn_1_1_N : N ;
  riksdagsval_nn_1_N : N ;
  riksdagsprotokoll_nn_1_N : N ;
  riksdagsmandat_nn_1_N : N ;
  riksdagsbeslut_nn_1_N : N ;
  rikemansbarn_nn_1_N : N ;
  riff_nn_1_N : N ;
  ridaafall_nn_1_1_N : N ;
  ridsaar_nn_1_1_N : N ;
  ridkunnighetsprov_nn_1_N : N ;
  riddjur_nn_1_N : N ;
  riddarslag_nn_1_N : N ;
  ribbvalv_nn_1_N : N ;
  revir_nn_1_N : N ;
  reversal_nn_1_N : N ;
  revbensspjaell_nn_1_1_N : N ;
  revben_nn_1_N : N ;
  rev_nn_1_N : N ;
  retardationsfaelt_nn_1_1_N : N ;
  resaarband_nn_1_1_N : N ;
  resultatbesked_nn_1_N : N ;
  resultat_nn_1_N : N ;
  restlager_nn_1_N : N ;
  restaurangkoek_nn_1_1_N : N ;
  restaurangbord_nn_1_N : N ;
  restaurangbesoek_nn_1_1_N : N ;
  ressentiment_nn_1_N : N ;
  resonemangsaektenskap_nn_1_1_N : N ;
  resonemang_nn_1_N : N ;
  resningsbeslut_nn_1_N : N ;
  resmaal_nn_1_1_N : N ;
  reskript_nn_1_N : N ;
  resetillbehoer_nn_1_1_N : N ;
  reservlager_nn_1_N : N ;
  reservat_nn_1_N : N ;
  resefoerbud_nn_1_1_N : N ;
  resebadkar_nn_1_N : N ;
  researrangemang_nn_1_N : N ;
  reseapotek_nn_1_N : N ;
  repetergevaer_nn_1_1_N : N ;
  rep_nn_1_N : N ;
  rensroer_nn_1_1_N : N ;
  renskinn_nn_1_N : N ;
  renlevnadskrav_nn_1_N : N ;
  reningsverk_nn_1_N : N ;
  renhorn_nn_1_N : N ;
  rengoeringsmedel_nn_1_1_N : N ;
  renben_nn_1_N : N ;
  remtyg_nn_1_N : N ;
  remissvar_nn_1_N : N ;
  relationstal_nn_1_N : N ;
  relationsraad_nn_1_1_N : N ;
  rektorat_nn_1_N : N ;
  rekryteringsfoeretag_nn_1_1_N : N ;
  rekordvarvtal_nn_1_N : N ;
  rekord_nn_1_N : N ;
  rekommendationsbrev_nn_1_N : N ;
  reklamtrick_nn_1_N : N ;
  reklamplakat_nn_1_N : N ;
  reklaminslag_nn_1_N : N ;
  rek_nn_1_N : N ;
  regnstaenk_nn_1_1_N : N ;
  regnstaell_nn_1_1_N : N ;
  regnskydd_nn_1_N : N ;
  regnovaeder_nn_1_1_N : N ;
  regnmoln_nn_1_N : N ;
  regn_nn_1_N : N ;
  registreringsnummer_nn_1_N : N ;
  registerutdrag_nn_1_N : N ;
  register_nn_1_N : N ;
  regeringssaett_nn_1_1_N : N ;
  regeringsraad_nn_1_1_N : N ;
  regeringsplan_nn_1_N : N ;
  regeringsorgan_nn_1_N : N ;
  regeringsbeslut_nn_1_N : N ;
  regelverk_nn_1_N : N ;
  regelbrott_nn_1_N : N ;
  regalskepp_nn_1_N : N ;
  reformkrav_nn_1_N : N ;
  referensmaterial_nn_1_N : N ;
  referensbibliotek_nn_1_N : N ;
  referat_nn_1_N : N ;
  redskap_nn_1_N : N ;
  redlighetskrav_nn_1_N : N ;
  recept_nn_1_N : N ;
  recensionsuppdrag_nn_1_N : N ;
  recensionsexemplar_nn_1_N : N ;
  reaplan_nn_1_N : N ;
  reallaeroverk_nn_1_1_N : N ;
  realkapital_nn_1_N : N ;
  reaktorutslaepp_nn_1_1_N : N ;
  reagenspapper_nn_1_N : N ;
  ratsch_nn_1_N : N ;
  ratifikationsinstrument_nn_1_N : N ;
  raster_nn_1_N : N ;
  raskrig_nn_1_N : N ;
  raseriutbrott_nn_1_N : N ;
  rasdjur_nn_1_N : N ;
  rasben_nn_1_N : N ;
  rapsfaelt_nn_1_1_N : N ;
  rapp_nn_2_N : N ;
  rap_nn_1_N : N ;
  ransoneringskort_nn_1_N : N ;
  randhav_nn_1_N : N ;
  randfenomen_nn_1_N : N ;
  randberg_nn_1_N : N ;
  ramverk_nn_1_N : N ;
  ramavtal_nn_1_N : N ;
  raketsteg_nn_1_N : N ;
  raketgevaer_nn_1_1_N : N ;
  rakblad_nn_1_N : N ;
  ragg_nn_2_N : N ;
  raffinemang_nn_1_N : N ;
  radioteleskop_nn_1_N : N ;
  radioroer_nn_1_1_N : N ;
  radiallager_nn_1_N : N ;
  radialdaeck_nn_1_1_N : N ;
  radband_nn_1_N : N ;
  radavstaand_nn_1_1_N : N ;
  radarpar_nn_1_N : N ;
  rackartyg_nn_1_N : N ;
  rack_nn_2_N : N ;
  rabiesutbrott_nn_1_N : N ;
  rabattkort_nn_1_N : N ;
  r_nn_1_N : N ;
  paavehov_nn_1_1_N : N ;
  paatryckningsmedel_nn_1_1_N : N ;
  paaslakan_nn_1_1_N : N ;
  paaslag_nn_1_1_N : N ;
  paaskaegg_nn_1_1_N : N ;
  paaskalamm_nn_1_1_N : N ;
  paarop_nn_1_1_N : N ;
  paalaegg_nn_1_1_N : N ;
  paalverk_nn_1_1_N : N ;
  paalstek_nn_1_1_N : N ;
  paahugg_nn_1_1_N : N ;
  paahopp_nn_1_1_N : N ;
  paahitt_nn_1_1_N : N ;
  paafund_nn_1_1_N : N ;
  paadrag_nn_1_1_N : N ;
  paabud_nn_1_1_N : N ;
  paeron_nn_1_1_N : N ;
  paermebrev_nn_1_1_N : N ;
  paermbrev_nn_1_1_N : N ;
  paermblad_nn_1_1_N : N ;
  paerlsponttak_nn_1_1_N : N ;
  paerlhalsband_nn_1_1_N : N ;
  paerlgryn_nn_1_1_N : N ;
  paerlemormoln_nn_1_1_N : N ;
  paerlband_nn_1_1_N : N ;
  paelsskinn_nn_1_1_N : N ;
  paelsfaar_nn_1_1_N : N ;
  paelsdjur_nn_1_1_N : N ;
  punkband_nn_1_N : N ;
  pungdjur_nn_1_N : N ;
  pumpverk_nn_1_N : N ;
  pulver_nn_1_N : N ;
  pulstaag_nn_1_1_N : N ;
  pulsslag_nn_1_N : N ;
  pulpettak_nn_1_N : N ;
  pukslag_nn_1_N : N ;
  puderunderlag_nn_1_N : N ;
  publiceringsbeslut_nn_1_N : N ;
  pubeshaar_nn_2_1_N : N ;
  psykiaterfoerbund_nn_1_1_N : N ;
  psykfall_nn_1_N : N ;
  psykbryt_nn_1_N : N ;
  psalmodikon_nn_1_N : N ;
  psalmnummer_nn_1_N : N ;
  proevningstillstaand_nn_1_1_N : N ;
  praang_nn_1_1_N : N ;
  praestgaell_nn_1_1_N : N ;
  praestbetyg_nn_1_1_N : N ;
  praent_nn_1_1_N : N ;
  prydnadsfoeremaal_nn_1_1_N : N ;
  provaar_nn_1_1_N : N ;
  provsvar_nn_1_N : N ;
  provstopp_nn_1_N : N ;
  provroersbarn_nn_1_1_N : N ;
  provroer_nn_1_1_N : N ;
  provkoek_nn_1_1_N : N ;
  proverb_nn_1_N : N ;
  prov_nn_1_N : N ;
  protokoll_nn_1_N : N ;
  protesttal_nn_1_N : N ;
  protektorat_nn_1_N : N ;
  proteinslag_nn_1_N : N ;
  proteinbehov_nn_1_N : N ;
  prospekt_nn_1_N : N ;
  proppskaap_nn_1_1_N : N ;
  propellerplan_nn_1_N : N ;
  propagandaoevertag_nn_1_1_N : N ;
  promenadstraak_nn_1_1_N : N ;
  projekt_nn_1_N : N ;
  programspraak_nn_1_1_N : N ;
  programmotek_nn_1_N : N ;
  programmeringsspraak_nn_1_1_N : N ;
  programformat_nn_1_N : N ;
  proggband_nn_1_N : N ;
  profilspaar_nn_1_1_N : N ;
  produktionsmedel_nn_1_N : N ;
  produktionsbortfall_nn_1_N : N ;
  produktionsbolag_nn_1_N : N ;
  problembarn_nn_1_N : N ;
  privilegiebrev_nn_1_N : N ;
  privattryck_nn_1_N : N ;
  privatlaan_nn_1_1_N : N ;
  privatiseringsprojekt_nn_1_N : N ;
  pristak_nn_1_N : N ;
  prisstopp_nn_1_N : N ;
  prisregn_nn_1_N : N ;
  priskrig_nn_1_N : N ;
  prisfall_nn_1_N : N ;
  primaerval_nn_1_1_N : N ;
  primaerlaan_nn_1_1_N : N ;
  primuskoek_nn_1_1_N : N ;
  primtal_nn_1_N : N ;
  primalskrik_nn_1_N : N ;
  preventivpiller_nn_1_N : N ;
  preventivmedel_nn_1_N : N ;
  preventivkrig_nn_1_N : N ;
  prestigeuppdrag_nn_1_N : N ;
  prestigeprojekt_nn_1_N : N ;
  pressveck_nn_1_N : N ;
  presstopp_nn_1_N : N ;
  pressorgan_nn_1_N : N ;
  presskort_nn_1_N : N ;
  pressjaern_nn_1_1_N : N ;
  pressgaeng_nn_1_1_N : N ;
  presidentval_nn_1_N : N ;
  presidentskap_nn_1_N : N ;
  presentkort_nn_1_N : N ;
  presensparticip_nn_1_N : N ;
  presens_nn_1_N : N ;
  prepositionsuttryck_nn_1_N : N ;
  premielaan_nn_1_1_N : N ;
  prejudikat_nn_1_N : N ;
  predikat_nn_1_N : N ;
  precisionsmaatt_nn_1_1_N : N ;
  precedensfall_nn_1_N : N ;
  prat_nn_1_N : N ;
  praktverk_nn_1_N : N ;
  praktkraek_nn_1_1_N : N ;
  praktexemplar_nn_1_N : N ;
  praktband_nn_1_N : N ;
  poaengantal_nn_1_1_N : N ;
  postverk_nn_1_N : N ;
  postulat_nn_1_N : N ;
  postraan_nn_1_1_N : N ;
  postorderfoeretag_nn_1_1_N : N ;
  postnummer_nn_1_N : N ;
  postkort_nn_1_N : N ;
  postkontor_nn_1_N : N ;
  posthorn_nn_1_N : N ;
  postfoerskott_nn_1_1_N : N ;
  postfack_nn_1_N : N ;
  postbud_nn_1_N : N ;
  postament_nn_1_N : N ;
  portvalv_nn_1_N : N ;
  portraett_nn_1_1_N : N ;
  portfoerbud_nn_1_1_N : N ;
  portalbegrepp_nn_1_N : N ;
  porslinsskaap_nn_1_1_N : N ;
  porslinsfilter_nn_1_N : N ;
  pontifikat_nn_1_N : N ;
  pond_nn_1_N : N ;
  pomeransskal_nn_1_N : N ;
  polypropenmaterial_nn_1_N : N ;
  polvaendningsskydd_nn_1_1_N : N ;
  pollenkorn_nn_1_N : N ;
  pollenfynd_nn_1_N : N ;
  polistillslag_nn_1_N : N ;
  polisfoerhoer_nn_1_1_N : N ;
  polisfordon_nn_1_N : N ;
  polisdistrikt_nn_1_N : N ;
  polisbefael_nn_1_1_N : N ;
  polermedel_nn_1_N : N ;
  polentagryn_nn_1_N : N ;
  polderland_nn_1_N : N ;
  polarisationsfilter_nn_1_N : N ;
  polarhav_nn_1_N : N ;
  polarflyg_nn_1_N : N ;
  pojkaar_nn_1_1_N : N ;
  pojkstreck_nn_1_N : N ;
  pojknamn_nn_1_N : N ;
  pojklag_nn_1_N : N ;
  plaatverktyg_nn_1_1_N : N ;
  plaattak_nn_1_1_N : N ;
  plaatskjul_nn_1_1_N : N ;
  plaatschabrak_nn_1_1_N : N ;
  plaatnav_nn_1_1_N : N ;
  plaatmynt_nn_1_1_N : N ;
  plaatkaerl_nn_1_1_N : N ;
  plaan_nn_1_1_N : N ;
  plundringstaag_nn_1_1_N : N ;
  plugg_nn_1_N : N ;
  plommonstop_nn_1_N : N ;
  plommon_nn_1_N : N ;
  plogben_nn_1_N : N ;
  pling_nn_1_N : N ;
  pliktexemplar_nn_1_N : N ;
  plenimaal_nn_1_1_N : N ;
  plebiscit_nn_1_N : N ;
  play_off_nn_1_N : N ;
  plataagupp_nn_1_1_N : N ;
  plataaberg_nn_1_1_N : N ;
  plattjaern_nn_1_1_N : N ;
  platskontor_nn_1_N : N ;
  plastnav_nn_1_N : N ;
  plastlaminat_nn_1_N : N ;
  plastkort_nn_1_N : N ;
  plastflygplan_nn_1_N : N ;
  plastbindemedel_nn_1_N : N ;
  plastbestick_nn_1_N : N ;
  plastband_nn_1_N : N ;
  planschverk_nn_1_N : N ;
  planktondjur_nn_1_N : N ;
  plankton_nn_1_N : N ;
  plankgolv_nn_1_N : N ;
  plank_nn_2_N : N ;
  planeringsorgan_nn_1_N : N ;
  plan_nn_2_N : N ;
  plakat_nn_1_N : N ;
  plagiat_nn_1_N : N ;
  plagg_nn_1_N : N ;
  placeringsobjekt_nn_1_N : N ;
  placeringskort_nn_1_N : N ;
  pjoltersaellskap_nn_1_1_N : N ;
  pix_nn_1_N : N ;
  pivaafoenster_nn_1_1_N : N ;
  pivothjul_nn_1_N : N ;
  pivotfoenster_nn_1_1_N : N ;
  pistolskott_nn_1_N : N ;
  pistolraan_nn_1_1_N : N ;
  pistolhot_nn_1_N : N ;
  pisksnaertskydd_nn_1_1_N : N ;
  piskrapp_nn_1_N : N ;
  pipskaegg_nn_1_1_N : N ;
  pipskaft_nn_1_N : N ;
  pip_nn_2_N : N ;
  pinoredskap_nn_1_N : N ;
  pinnhaal_nn_1_1_N : N ;
  pinakotek_nn_1_N : N ;
  piltraed_nn_1_1_N : N ;
  pilotfall_nn_1_N : N ;
  piller_nn_1_N : N ;
  pilkoger_nn_1_N : N ;
  pigment_nn_1_N : N ;
  piggsvin_nn_1_N : N ;
  pianopling_nn_1_N : N ;
  petrifikat_nn_1_N : N ;
  pessar_nn_1_N : N ;
  perukbraak_nn_1_1_N : N ;
  perspektivfoenster_nn_1_1_N : N ;
  personval_nn_1_N : N ;
  persontaag_nn_1_1_N : N ;
  personregister_nn_1_N : N ;
  personnummer_nn_1_N : N ;
  personnamn_nn_1_N : N ;
  personlighetsdrag_nn_1_N : N ;
  personalblad_nn_1_N : N ;
  perkussionsinstrument_nn_1_N : N ;
  periskop_nn_1_N : N ;
  periodtal_nn_1_N : N ;
  pergamentsbrev_nn_1_N : N ;
  pergamentbrev_nn_1_N : N ;
  pergamentband_nn_1_N : N ;
  perfektparticip_nn_1_N : N ;
  pepparkorn_nn_1_N : N ;
  pepparkaksrekord_nn_1_N : N ;
  pepparkaksbak_nn_1_N : N ;
  pensionaerstillhaall_nn_1_1_N : N ;
  pensionsval_nn_1_N : N ;
  pensionsbrev_nn_1_N : N ;
  pensionat_nn_1_N : N ;
  penseldrag_nn_1_N : N ;
  pennstreck_nn_1_N : N ;
  pennskaft_nn_1_N : N ;
  penningmedel_nn_1_N : N ;
  penninglaan_nn_1_1_N : N ;
  penningbekymmer_nn_1_N : N ;
  penndrag_nn_1_N : N ;
  penisollon_nn_1_N : N ;
  pendelur_nn_1_N : N ;
  pendeltaag_nn_1_1_N : N ;
  pendelavstaand_nn_1_1_N : N ;
  pelarhelgon_nn_1_N : N ;
  pelarbord_nn_1_N : N ;
  pekoral_nn_1_N : N ;
  pediment_nn_1_N : N ;
  patronkoek_nn_1_1_N : N ;
  patriarkat_nn_1_N : N ;
  patientbesoek_nn_1_1_N : N ;
  paternosterverk_nn_1_N : N ;
  paternoster_nn_1_N : N ;
  patentverk_nn_1_N : N ;
  patentmaal_nn_1_1_N : N ;
  patentintraang_nn_1_1_N : N ;
  patent_nn_1_N : N ;
  pastorat_nn_1_N : N ;
  passionssamlag_nn_1_N : N ;
  passerkort_nn_1_N : N ;
  passagerarflygplan_nn_1_N : N ;
  passagerarflyg_nn_1_N : N ;
  partytaelt_nn_1_1_N : N ;
  partsorgan_nn_1_N : N ;
  partnerskap_nn_1_N : N ;
  partitur_nn_1_N : N ;
  partiorgan_nn_1_N : N ;
  partikelregn_nn_1_N : N ;
  partikellock_nn_1_N : N ;
  partidistrikt_nn_1_N : N ;
  particip_nn_1_N : N ;
  partiblock_nn_1_N : N ;
  partialtryck_nn_1_N : N ;
  partaj_nn_1_N : N ;
  parningsorgan_nn_1_N : N ;
  parlament_nn_1_N : N ;
  parkettgolv_nn_1_N : N ;
  pariserhjul_nn_1_N : N ;
  paraplytak_nn_1_N : N ;
  paraplystaell_nn_1_1_N : N ;
  parallellstag_nn_1_N : N ;
  parallellfall_nn_1_N : N ;
  paradnummer_nn_1_N : N ;
  paradiskorn_nn_1_N : N ;
  par_nn_1_N : N ;
  pappersplan_nn_1_N : N ;
  pappersmynt_nn_1_N : N ;
  pappersformat_nn_1_N : N ;
  pappersbruk_nn_1_N : N ;
  pappersark_nn_1_N : N ;
  papper_nn_1_N : N ;
  pappband_nn_1_N : N ;
  papillom_nn_1_N : N ;
  papaverin_nn_1_N : N ;
  pantlaan_nn_1_1_N : N ;
  panterspraang_nn_1_1_N : N ;
  panteon_nn_1_N : N ;
  pantbrev_nn_1_N : N ;
  pansarvaern_nn_1_1_N : N ;
  pansartorn_nn_1_N : N ;
  pansarskott_nn_1_N : N ;
  pansarroer_nn_1_1_N : N ;
  pansarhinder_nn_1_N : N ;
  pansarfordon_nn_1_N : N ;
  pansarfartyg_nn_1_N : N ;
  pansar_nn_1_N : N ;
  panoramafoenster_nn_1_1_N : N ;
  panoptikon_nn_1_N : N ;
  pannkaksmoln_nn_1_N : N ;
  pannben_nn_1_N : N ;
  pannband_nn_1_N : N ;
  panikanfall_nn_1_N : N ;
  pang_nn_1_N : N ;
  paltbroed_nn_1_1_N : N ;
  palmblad_nn_1_N : N ;
  pall_nn_2_N : N ;
  paket_nn_1_N : N ;
  packdjur_nn_1_N : N ;
  p_piller_nn_1_N : N ;
  ozonskikt_nn_1_N : N ;
  ozonlager_nn_1_N : N ;
  oxstyng_nn_1_N : N ;
  oxidationstal_nn_1_N : N ;
  oxidationsmedel_nn_1_N : N ;
  oxdjur_nn_1_N : N ;
  oxbaer_nn_1_1_N : N ;
  ovaeder_nn_1_1_N : N ;
  otrohetsgrael_nn_1_1_N : N ;
  osaekerhetsmoment_nn_1_1_N : N ;
  ostronskal_nn_1_N : N ;
  ostron_nn_1_N : N ;
  oskick_nn_1_N : N ;
  oscilloskop_nn_1_N : N ;
  orv_nn_1_N : N ;
  ortstillaegg_nn_1_1_N : N ;
  ortsavdrag_nn_1_N : N ;
  ortnamn_nn_1_N : N ;
  orsakssammanhang_nn_1_N : N ;
  orsakssamband_nn_1_N : N ;
  orosaar_nn_1_1_N : N ;
  orosmoment_nn_1_N : N ;
  orosmoln_nn_1_N : N ;
  ornament_nn_1_N : N ;
  ormskinn_nn_1_N : N ;
  ormhaar_nn_1_1_N : N ;
  ormbaer_nn_1_1_N : N ;
  originalspraak_nn_1_1_N : N ;
  originalitetskrav_nn_1_N : N ;
  originaldokument_nn_1_N : N ;
  orgelregister_nn_1_N : N ;
  organum_nn_1_N : N ;
  organdonationskort_nn_1_N : N ;
  organ_nn_1_N : N ;
  ordval_nn_1_N : N ;
  ordsvall_nn_1_N : N ;
  ordstaev_nn_1_1_N : N ;
  ordspraak_nn_1_1_N : N ;
  ordslut_nn_1_N : N ;
  ordnaet_nn_1_1_N : N ;
  ordningstal_nn_1_N : N ;
  ordningsnummer_nn_1_N : N ;
  ordkrig_nn_1_N : N ;
  ordfoerraad_nn_1_1_N : N ;
  ordfoerandeskap_nn_1_1_N : N ;
  ordfragment_nn_1_N : N ;
  ordenssaellskap_nn_1_1_N : N ;
  ord_nn_1_N : N ;
  orakelsvar_nn_1_N : N ;
  or_nn_1_N : N ;
  oppsving_nn_1_N : N ;
  oppstaellningsspaar_nn_1_1_N : N ;
  opplaegg_nn_1_1_N : N ;
  oppflaag_nn_1_1_N : N ;
  oppflog_nn_1_N : N ;
  opinionsorgan_nn_1_N : N ;
  operationsbestick_nn_1_N : N ;
  ont_nn_1_N : N ;
  omval_nn_1_N : N ;
  omtryck_nn_1_N : N ;
  omtal_nn_1_N : N ;
  omtag_nn_1_N : N ;
  omslut_nn_1_N : N ;
  omslagspapper_nn_1_N : N ;
  omslag_nn_1_N : N ;
  omlopp_nn_1_N : N ;
  omljud_nn_1_N : N ;
  omkoerningsfoerbud_nn_1_1_N : N ;
  omkoep_nn_1_1_N : N ;
  omhopp_nn_1_N : N ;
  ombud_nn_1_N : N ;
  omblad_nn_1_N : N ;
  olycksaar_nn_1_1_N : N ;
  olyckstillbud_nn_1_N : N ;
  olyckstal_nn_1_N : N ;
  olycksfall_nn_1_N : N ;
  olycksbarn_nn_1_N : N ;
  olvon_nn_1_N : N ;
  ollonsvin_nn_1_N : N ;
  ollonskott_nn_1_N : N ;
  ollon_nn_1_N : N ;
  oljud_nn_1_N : N ;
  oljeutslaepp_nn_1_1_N : N ;
  oljetraag_nn_1_1_N : N ;
  oljetryck_nn_1_N : N ;
  oljestaell_nn_1_1_N : N ;
  oljestopp_nn_1_N : N ;
  oljefaelt_nn_1_1_N : N ;
  oljefilter_nn_1_N : N ;
  oljefat_nn_1_N : N ;
  oljebytartraag_nn_1_1_N : N ;
  oljeborrtorn_nn_1_N : N ;
  oljebolag_nn_1_N : N ;
  oljebad_nn_1_N : N ;
  oljeaggregat_nn_1_N : N ;
  oligopol_nn_1_N : N ;
  oleat_nn_2_N : N ;
  okvaedinsord_nn_1_1_N : N ;
  okvaedingsord_nn_1_1_N : N ;
  okular_nn_1_N : N ;
  oktantal_nn_1_N : N ;
  okben_nn_1_N : N ;
  ok_nn_1_N : N ;
  ohaelsotal_nn_1_1_N : N ;
  oftalmoskop_nn_1_N : N ;
  ofog_nn_1_N : N ;
  offerlamm_nn_1_N : N ;
  odon_nn_1_N : N ;
  odlingslager_nn_1_N : N ;
  odlingsfoersoek_nn_1_1_N : N ;
  odjur_nn_1_N : N ;
  observationsmaterial_nn_1_N : N ;
  obligationslaan_nn_1_1_N : N ;
  objektspraak_nn_1_1_N : N ;
  objekt_nn_1_N : N ;
  obehag_nn_1_N : N ;
  obduktionsresultat_nn_1_N : N ;
  oaktsamhetsbrott_nn_1_N : N ;
  noetstyng_nn_1_1_N : N ;
  noetskal_nn_1_1_N : N ;
  noetkreatur_nn_1_1_N : N ;
  noet_nn_2_1_N : N ;
  noejesfaelt_nn_1_1_N : N ;
  noejesetablissemang_nn_1_1_N : N ;
  noejesdistrikt_nn_1_1_N : N ;
  noejesbegaer_nn_1_1_N : N ;
  noedaar_nn_1_1_N : N ;
  noedstopp_nn_1_1_N : N ;
  noedrop_nn_1_1_N : N ;
  noedmynt_nn_1_1_N : N ;
  noedlaan_nn_1_1_N : N ;
  noedfall_nn_1_1_N : N ;
  noeddop_nn_1_1_N : N ;
  noedanrop_nn_1_1_N : N ;
  naatstaal_nn_1_1_N : N ;
  naalstyng_nn_1_1_N : N ;
  naalstygn_nn_1_1_N : N ;
  naalsting_nn_1_1_N : N ;
  naalsticksangrepp_nn_1_1_N : N ;
  naalstick_nn_1_1_N : N ;
  naalkort_nn_1_1_N : N ;
  naalbrev_nn_1_1_N : N ;
  naadaar_nn_1_1_N : N ;
  naademedel_nn_1_1_N : N ;
  naadehjon_nn_1_1_N : N ;
  naadebord_nn_1_1_N : N ;
  naadaval_nn_1_1_N : N ;
  naadaskott_nn_1_1_N : N ;
  naeverflak_nn_1_1_N : N ;
  naetverk_nn_1_1_N : N ;
  naetuppslagsverk_nn_1_1_N : N ;
  naetfoenster_nn_1_1_N : N ;
  naet_nn_1_1_N : N ;
  naestaegg_nn_1_1_N : N ;
  naesseldjur_nn_1_1_N : N ;
  naesljud_nn_1_1_N : N ;
  naesben_nn_1_1_N : N ;
  naesavtryck_nn_1_1_N : N ;
  naeringsmedel_nn_1_1_N : N ;
  naeringsfaang_nn_1_1_N : N ;
  naektergalsslag_nn_1_1_N : N ;
  naeckrosblad_nn_1_1_N : N ;
  naebbdjur_nn_1_1_N : N ;
  nyaar_nn_1_1_N : N ;
  nyval_nn_1_N : N ;
  nyttofoeremaal_nn_1_1_N : N ;
  nytryck_nn_1_N : N ;
  nytillskott_nn_1_N : N ;
  nystan_nn_1_N : N ;
  nyskott_nn_1_N : N ;
  nypon_nn_1_N : N ;
  nyp_nn_1_N : N ;
  nyord_nn_1_N : N ;
  nylonhjul_nn_1_N : N ;
  nyhetssoek_nn_1_1_N : N ;
  nyhetsblad_nn_1_N : N ;
  nyfoervaerv_nn_1_1_N : N ;
  nyckelskaap_nn_1_1_N : N ;
  nyckelord_nn_1_N : N ;
  nyckelkort_nn_1_N : N ;
  nyckelinslag_nn_1_N : N ;
  nyckelhaal_nn_1_1_N : N ;
  nyckelblomster_nn_1_N : N ;
  nyckelben_nn_1_N : N ;
  nyckelbarn_nn_1_N : N ;
  nyboerjarset_nn_1_1_N : N ;
  nutritionsorgan_nn_1_N : N ;
  nunnedok_nn_1_N : N ;
  nummer_nn_1_N : N ;
  numerus_nn_1_N : N ;
  nukleontal_nn_1_N : N ;
  novitiat_nn_1_N : N ;
  novautbrott_nn_1_N : N ;
  notvarp_nn_1_N : N ;
  notstaal_nn_1_1_N : N ;
  notstaell_nn_1_1_N : N ;
  notplan_nn_1_N : N ;
  notpapper_nn_1_N : N ;
  notlag_nn_1_N : N ;
  notesblock_nn_1_N : N ;
  notblad_nn_1_N : N ;
  notariat_nn_1_N : N ;
  noshjul_nn_1_N : N ;
  normaltillstaand_nn_1_1_N : N ;
  normalmaatt_nn_1_1_N : N ;
  nordanland_nn_1_N : N ;
  nor_nn_1_N : N ;
  nonstopflyg_nn_1_N : N ;
  nonaggressionsfoerdrag_nn_1_1_N : N ;
  nominativsubjekt_nn_1_N : N ;
  nomadfolk_nn_1_N : N ;
  nollutslaepp_nn_1_1_N : N ;
  nollspant_nn_1_N : N ;
  nollplan_nn_1_N : N ;
  nollkorrektur_nn_1_N : N ;
  noaord_nn_1_N : N ;
  noanamn_nn_1_N : N ;
  njutningsmedel_nn_1_N : N ;
  njurbaecken_nn_1_1_N : N ;
  nitfoerband_nn_1_1_N : N ;
  nidingsverk_nn_1_N : N ;
  nidingsdaad_nn_1_1_N : N ;
  ng_ljud_nn_1_N : N ;
  neutrinohav_nn_1_N : N ;
  nervvrak_nn_1_N : N ;
  nervsignalmoenster_nn_1_1_N : N ;
  nervsammanbrott_nn_1_N : N ;
  nervkrig_nn_1_N : N ;
  nerstraak_nn_1_1_N : N ;
  nerslaepp_nn_1_1_N : N ;
  nerslag_nn_1_N : N ;
  nerlaeggningshot_nn_1_1_N : N ;
  nerfall_nn_1_N : N ;
  neonroer_nn_1_1_N : N ;
  nektardrag_nn_1_N : N ;
  nedstraak_nn_1_1_N : N ;
  nedslaepp_nn_1_1_N : N ;
  nedslag_nn_1_N : N ;
  nedlaeggningshot_nn_1_1_N : N ;
  nedfall_nn_1_N : N ;
  nederlag_nn_1_N : N ;
  nedan_nn_1_N : N ;
  nazibrott_nn_1_N : N ;
  navelsvin_nn_1_N : N ;
  navelband_nn_1_N : N ;
  navajoreservat_nn_1_N : N ;
  navahoreservat_nn_1_N : N ;
  nav_nn_1_N : N ;
  naturvaardsverk_nn_1_1_N : N ;
  naturtillstaand_nn_1_1_N : N ;
  naturreservat_nn_1_N : N ;
  naturnamn_nn_1_N : N ;
  naturlaekemedel_nn_1_1_N : N ;
  naturljud_nn_1_N : N ;
  naturhorn_nn_1_N : N ;
  naturhinder_nn_1_N : N ;
  naturfoeremaal_nn_1_1_N : N ;
  naturfolk_nn_1_N : N ;
  naturfenomen_nn_1_N : N ;
  naturbehov_nn_1_N : N ;
  naturbarn_nn_1_N : N ;
  naturaliekabinett_nn_1_N : N ;
  nattaag_nn_1_1_N : N ;
  nattygsbord_nn_1_N : N ;
  nattvardskaerl_nn_1_1_N : N ;
  nattvardsbroed_nn_1_1_N : N ;
  nattvardsbord_nn_1_N : N ;
  nattvardsbarn_nn_1_N : N ;
  nattvak_nn_1_N : N ;
  nattspaar_nn_1_1_N : N ;
  nattslag_nn_1_N : N ;
  nattskift_nn_1_N : N ;
  nattraj_nn_1_N : N ;
  nattmoln_nn_1_N : N ;
  nattlaeger_nn_1_1_N : N ;
  nattkaerl_nn_1_1_N : N ;
  nattfack_nn_1_N : N ;
  nattduksbord_nn_1_N : N ;
  nattdjur_nn_1_N : N ;
  nattbord_nn_1_N : N ;
  nationalspraak_nn_1_1_N : N ;
  nationalkapital_nn_1_N : N ;
  nationalitetsintyg_nn_1_N : N ;
  nationalitetscertifikat_nn_1_N : N ;
  nationalhelgon_nn_1_N : N ;
  nationaldrag_nn_1_N : N ;
  nationalbegrepp_nn_1_N : N ;
  narrstreck_nn_1_N : N ;
  narkotikainnehav_nn_1_N : N ;
  narkotikabrott_nn_1_N : N ;
  narkosmedel_nn_1_N : N ;
  nappatag_nn_1_N : N ;
  napp_nn_1_N : N ;
  nanoroer_nn_1_1_N : N ;
  nanokolroer_nn_1_1_N : N ;
  namnupprop_nn_1_N : N ;
  namnskydd_nn_1_N : N ;
  namnsdagsbarn_nn_1_N : N ;
  namnanrop_nn_1_N : N ;
  namn_nn_1_N : N ;
  nakenbad_nn_1_N : N ;
  najtaag_nn_1_1_N : N ;
  nagg_nn_2_N : N ;
  nagellack_nn_1_N : N ;
  nagelband_nn_1_N : N ;
  nacksving_nn_1_N : N ;
  nackben_nn_1_N : N ;
  nachspil_nn_1_N : N ;
  n_nn_1_N : N ;
  moetesspaar_nn_1_1_N : N ;
  moetesfoerbud_nn_1_1_N : N ;
  moesskapell_nn_1_1_N : N ;
  moerklaeggningsfoersoek_nn_1_1_N : N ;
  moerkertal_nn_1_1_N : N ;
  moerdarband_nn_1_1_N : N ;
  moensterskydd_nn_1_1_N : N ;
  moensterjordbruk_nn_1_1_N : N ;
  moensterdjup_nn_1_1_N : N ;
  moenster_nn_1_1_N : N ;
  moebeloeverdrag_nn_1_1_N : N ;
  moebelfoeretag_nn_1_1_N : N ;
  maattverktyg_nn_1_1_N : N ;
  maattband_nn_1_1_N : N ;
  maatt_nn_1_1_N : N ;
  maasaegg_nn_1_1_N : N ;
  maarddjur_nn_1_1_N : N ;
  maanaar_nn_1_1_N : N ;
  maanvarv_nn_1_1_N : N ;
  maanlandskap_nn_1_1_N : N ;
  maangmiljardbelopp_nn_1_1_N : N ;
  maandygn_nn_1_1_N : N ;
  maandagsexemplar_nn_1_1_N : N ;
  maanadtal_nn_1_1_N : N ;
  maanadssmultron_nn_1_1_N : N ;
  maanadskort_nn_1_1_N : N ;
  maanadsbidrag_nn_1_1_N : N ;
  maalspraak_nn_1_1_N : N ;
  maal_nn_1_1_N : N ;
  maabaer_nn_1_1_N : N ;
  maetverktyg_nn_1_1_N : N ;
  maettningstryck_nn_1_1_N : N ;
  maetredskap_nn_1_1_N : N ;
  maetningstal_nn_1_1_N : N ;
  maetningsfartyg_nn_1_1_N : N ;
  maetinstrument_nn_1_1_N : N ;
  maetetal_nn_1_1_N : N ;
  maetbrev_nn_1_1_N : N ;
  maetbord_nn_1_1_N : N ;
  maetband_nn_1_1_N : N ;
  maesterverk_nn_1_1_N : N ;
  maesterskap_nn_1_1_N : N ;
  maestarprov_nn_1_1_N : N ;
  maestarbrev_nn_1_1_N : N ;
  maessingsinstrument_nn_1_1_N : N ;
  maessingsfotstoed_nn_1_1_N : N ;
  maessinginstrument_nn_1_1_N : N ;
  maessingblaasinstrument_nn_1_1_N : N ;
  maessfall_nn_1_1_N : N ;
  maerkband_nn_1_1_N : N ;
  maergben_nn_1_1_N : N ;
  maenskobarn_nn_1_1_N : N ;
  maenniskoraettsbrott_nn_1_1_N : N ;
  maenniskorov_nn_1_1_N : N ;
  maenniskoliv_nn_1_1_N : N ;
  maenniskolik_nn_1_1_N : N ;
  maenniskofoster_nn_1_1_N : N ;
  maenniskoben_nn_1_1_N : N ;
  maenniskobarn_nn_1_1_N : N ;
  maelarlandskap_nn_1_1_N : N ;
  myskdjur_nn_1_N : N ;
  myraegg_nn_1_1_N : N ;
  myrsteg_nn_1_N : N ;
  myrlejon_nn_1_N : N ;
  myrland_nn_1_N : N ;
  myom_nn_1_N : N ;
  myntverk_nn_1_N : N ;
  mynt_nn_1_N : N ;
  myndighetstillstaand_nn_1_1_N : N ;
  myggnaet_nn_1_1_N : N ;
  myggmedel_nn_1_N : N ;
  myggfoenster_nn_1_1_N : N ;
  myggbett_nn_1_N : N ;
  mygg_nn_1_N : N ;
  mutterknack_nn_1_N : N ;
  mutbrott_nn_1_N : N ;
  musselskal_nn_1_N : N ;
  musklick_nn_1_N : N ;
  musikverk_nn_1_N : N ;
  musikliv_nn_1_N : N ;
  musikinstrument_nn_1_N : N ;
  musikfoerlag_nn_1_1_N : N ;
  museifoeremaal_nn_1_1_N : N ;
  musbarn_nn_1_N : N ;
  murverk_nn_1_N : N ;
  murskift_nn_1_N : N ;
  murmeldjur_nn_1_N : N ;
  murliv_nn_1_N : N ;
  murkroen_nn_1_1_N : N ;
  murintag_nn_1_N : N ;
  murhoern_nn_1_1_N : N ;
  murgroenemoenster_nn_1_1_N : N ;
  murfoerband_nn_1_1_N : N ;
  murband_nn_1_N : N ;
  murarverktyg_nn_1_N : N ;
  munvaeder_nn_1_1_N : N ;
  munsaar_nn_1_1_N : N ;
  munskydd_nn_1_N : N ;
  munlag_nn_1_N : N ;
  munkfoerband_nn_1_1_N : N ;
  multituberkulat_nn_1_N : N ;
  multipeltaag_nn_1_1_N : N ;
  multihandikapp_nn_1_N : N ;
  mullbaersfikon_nn_1_1_N : N ;
  mullbaer_nn_1_1_N : N ;
  mufflonfaar_nn_1_1_N : N ;
  mudderverk_nn_1_N : N ;
  motstaandarlag_nn_1_1_N : N ;
  motstaand_nn_1_1_N : N ;
  motskael_nn_1_1_N : N ;
  motskott_nn_1_N : N ;
  motsatspar_nn_1_N : N ;
  motorstopp_nn_1_N : N ;
  motorskydd_nn_1_N : N ;
  motorljud_nn_1_N : N ;
  motorhotell_nn_1_N : N ;
  motorfordon_nn_1_N : N ;
  motorfartyg_nn_1_N : N ;
  motorcykelstaell_nn_1_1_N : N ;
  motlut_nn_1_N : N ;
  motkrav_nn_1_N : N ;
  motionsspaar_nn_1_1_N : N ;
  motinlaegg_nn_1_1_N : N ;
  mothaall_nn_1_1_N : N ;
  mothugg_nn_1_N : N ;
  motfoerslag_nn_1_1_N : N ;
  motell_nn_1_N : N ;
  motdrag_nn_1_N : N ;
  motbud_nn_1_N : N ;
  motargument_nn_1_N : N ;
  motangrepp_nn_1_N : N ;
  motanfall_nn_1_N : N ;
  mot_nn_1_N : N ;
  mosslik_nn_1_N : N ;
  mossfynd_nn_1_N : N ;
  mossfolk_nn_1_N : N ;
  moskitnaet_nn_1_1_N : N ;
  mosaikmoenster_nn_1_1_N : N ;
  mosaiklandskap_nn_1_N : N ;
  morsarv_nn_1_N : N ;
  morrhaar_nn_1_1_N : N ;
  morkullsstraeck_nn_1_1_N : N ;
  mordfoersoek_nn_1_1_N : N ;
  mordfall_nn_1_N : N ;
  mord_nn_1_N : N ;
  moralbegrepp_nn_1_N : N ;
  monument_nn_1_N : N ;
  monteringshaal_nn_1_1_N : N ;
  monsterfartyg_nn_1_N : N ;
  monster_nn_1_N : N ;
  monopol_nn_1_N : N ;
  monoplan_nn_1_N : N ;
  moment_nn_1_N : N ;
  moln_nn_1_N : N ;
  mollackord_nn_1_N : N ;
  modersmaal_nn_1_1_N : N ;
  moderskepp_nn_1_N : N ;
  modernitetsideal_nn_1_N : N ;
  moderliv_nn_1_N : N ;
  moderfoeretag_nn_1_1_N : N ;
  moderbolag_nn_1_N : N ;
  modeord_nn_1_N : N ;
  modemagasin_nn_1_N : N ;
  modellplan_nn_1_N : N ;
  modellfoersoek_nn_1_1_N : N ;
  modellflygplan_nn_1_N : N ;
  modelejon_nn_1_N : N ;
  mobilsamtal_nn_1_N : N ;
  mobilabonnemang_nn_1_N : N ;
  mjoelon_nn_1_1_N : N ;
  mjoelkoeverskott_nn_1_1_N : N ;
  mjoelkspann_nn_1_1_N : N ;
  mjoelkpaket_nn_1_1_N : N ;
  mjoelkkaerl_nn_1_1_N : N ;
  mjoelkgrymt_nn_1_1_N : N ;
  mjoelkbud_nn_1_1_N : N ;
  mjaelthugg_nn_1_1_N : N ;
  mjukningsmedel_nn_1_N : N ;
  mjukisdjur_nn_1_N : N ;
  mittskepp_nn_1_N : N ;
  mittfaelt_nn_1_1_N : N ;
  mittenlager_nn_1_N : N ;
  missvaextaar_nn_1_1_N : N ;
  misstag_nn_1_N : N ;
  missljud_nn_1_N : N ;
  missionshotell_nn_1_N : N ;
  missionsfoerbund_nn_1_1_N : N ;
  missionsfaelt_nn_1_1_N : N ;
  missionsbudskap_nn_1_N : N ;
  misshandelsfall_nn_1_N : N ;
  missgrepp_nn_1_N : N ;
  missfoerstaand_nn_1_1_N : N ;
  missfoster_nn_1_N : N ;
  missfall_nn_1_N : N ;
  missdaad_nn_1_1_N : N ;
  missbruk_nn_1_N : N ;
  minsvep_nn_1_N : N ;
  minoritetsskydd_nn_1_N : N ;
  minoritetsfolk_nn_1_N : N ;
  minnestal_nn_1_N : N ;
  minnesspaar_nn_1_1_N : N ;
  minnesord_nn_1_N : N ;
  minnesfragment_nn_1_N : N ;
  ministerraad_nn_1_1_N : N ;
  minimibelopp_nn_1_N : N ;
  minfaelt_nn_1_1_N : N ;
  minfartyg_nn_1_N : N ;
  mineraloeverdrag_nn_1_1_N : N ;
  mindretal_nn_1_N : N ;
  minaretfoerbud_nn_1_1_N : N ;
  millimeterpapper_nn_1_N : N ;
  miljoeutskott_nn_1_1_N : N ;
  miljoekrav_nn_1_1_N : N ;
  miljoehaensyn_nn_1_1_N : N ;
  miljoebrott_nn_1_1_N : N ;
  miljoeavtal_nn_1_1_N : N ;
  miljonstoed_nn_1_1_N : N ;
  miljonskadestaand_nn_1_1_N : N ;
  miljonklipp_nn_1_N : N ;
  miljonbelopp_nn_1_N : N ;
  miljardlaan_nn_1_1_N : N ;
  militaerfordon_nn_1_1_N : N ;
  mildvaeder_nn_1_1_N : N ;
  mikroskop_nn_1_N : N ;
  mikrolock_nn_1_N : N ;
  mikrokort_nn_1_N : N ;
  midvinterblot_nn_1_N : N ;
  midsommarblomster_nn_1_N : N ;
  midjemaatt_nn_1_1_N : N ;
  midjeband_nn_1_N : N ;
  middagssaellskap_nn_1_1_N : N ;
  middagsmaal_nn_1_1_N : N ;
  microlock_nn_1_N : N ;
  metodkrav_nn_1_N : N ;
  metermaatt_nn_1_1_N : N ;
  meteorjaern_nn_1_1_N : N ;
  meteoritnedslag_nn_1_N : N ;
  metaspraak_nn_1_1_N : N ;
  metallspaan_nn_1_1_N : N ;
  metallpulver_nn_1_N : N ;
  metallgolv_nn_1_N : N ;
  metallfoeremaal_nn_1_1_N : N ;
  metallbad_nn_1_N : N ;
  metakoek_nn_1_1_N : N ;
  merinofaar_nn_1_1_N : N ;
  menyfoerslag_nn_1_1_N : N ;
  mensskydd_nn_1_N : N ;
  men_nn_1_N : N ;
  mellanverk_nn_1_N : N ;
  mellanting_nn_1_N : N ;
  mellanstick_nn_1_N : N ;
  mellanslag_nn_1_N : N ;
  mellanskikt_nn_1_N : N ;
  mellanrev_nn_1_N : N ;
  mellanregister_nn_1_N : N ;
  mellanmaal_nn_1_1_N : N ;
  mellanlaegg_nn_1_1_N : N ;
  mellanled_nn_1_N : N ;
  mellanhopp_nn_1_N : N ;
  mellanheat_nn_1_N : N ;
  mellandaeck_nn_1_1_N : N ;
  melittafilter_nn_1_N : N ;
  mejlintraang_nn_1_1_N : N ;
  mejlhot_nn_1_N : N ;
  medlut_nn_1_N : N ;
  medljud_nn_1_N : N ;
  medlingsuppdrag_nn_1_N : N ;
  medlingsfoersoek_nn_1_1_N : N ;
  medlingsfoerslag_nn_1_1_N : N ;
  medlemsskap_nn_1_N : N ;
  medlemskort_nn_1_N : N ;
  medlemskap_nn_1_N : N ;
  medlemsfoeretag_nn_1_1_N : N ;
  medlemsantal_nn_1_N : N ;
  mediotek_nn_1_N : N ;
  medieutbud_nn_1_N : N ;
  medieuppbaad_nn_1_1_N : N ;
  medieklimat_nn_1_N : N ;
  mediefoeretag_nn_1_1_N : N ;
  mediedrev_nn_1_N : N ;
  mediatek_nn_1_N : N ;
  mediadrev_nn_1_N : N ;
  medelvattenstaand_nn_1_1_N : N ;
  medeltal_nn_1_N : N ;
  medelhav_nn_1_N : N ;
  medelavstaand_nn_1_1_N : N ;
  medel_nn_1_N : N ;
  meddelelsemedel_nn_1_N : N ;
  medborgarskap_nn_1_N : N ;
  medborgarraettsengagemang_nn_1_1_N : N ;
  medaljongtryck_nn_1_N : N ;
  mayafolk_nn_1_N : N ;
  mausergevaer_nn_1_1_N : N ;
  matvrak_nn_1_N : N ;
  matteprov_nn_1_N : N ;
  matsmaeltningsorgan_nn_1_1_N : N ;
  matrecept_nn_1_N : N ;
  matlarm_nn_1_N : N ;
  matlag_nn_1_N : N ;
  matinkoep_nn_1_1_N : N ;
  matfoerraad_nn_1_1_N : N ;
  materiemoln_nn_1_N : N ;
  materialfoerraad_nn_1_1_N : N ;
  matbroed_nn_1_1_N : N ;
  matbord_nn_1_N : N ;
  matbestick_nn_1_N : N ;
  masverk_nn_1_N : N ;
  mastodontprojekt_nn_1_N : N ;
  masthaal_nn_1_1_N : N ;
  massutskick_nn_1_N : N ;
  masstal_nn_1_N : N ;
  massmord_nn_1_N : N ;
  masskorsband_nn_1_N : N ;
  massageinstitut_nn_1_N : N ;
  massabruk_nn_1_N : N ;
  maskrosbarn_nn_1_N : N ;
  maskmedel_nn_1_N : N ;
  maskinspraak_nn_1_1_N : N ;
  maskingevaer_nn_1_1_N : N ;
  maskinelement_nn_1_N : N ;
  maskhaal_nn_1_1_N : N ;
  martyrskap_nn_1_N : N ;
  martasbekymmer_nn_1_N : N ;
  marsvin_nn_1_N : N ;
  marmorgolv_nn_1_N : N ;
  marmorbord_nn_1_N : N ;
  marknaet_nn_1_1_N : N ;
  marknadstorg_nn_1_N : N ;
  marknadsstaand_nn_1_1_N : N ;
  maratonlopp_nn_1_N : N ;
  man_er_nn_1_1_N : N ;
  manaar_nn_1_1_N : N ;
  manuskript_nn_1_N : N ;
  mantaag_nn_1_1_N : N ;
  manteldjur_nn_1_N : N ;
  mantal_nn_1_N : N ;
  mansnamn_nn_1_N : N ;
  manslaeger_nn_1_1_N : N ;
  manskap_nn_1_N : N ;
  mansideal_nn_1_N : N ;
  mansardtak_nn_1_N : N ;
  mannagryn_nn_1_N : N ;
  manlighetsprov_nn_1_N : N ;
  manlighetsdop_nn_1_N : N ;
  mankoen_nn_1_1_N : N ;
  manhaal_nn_1_1_N : N ;
  manfolk_nn_1_N : N ;
  manfall_nn_1_N : N ;
  mandomsprov_nn_1_N : N ;
  mandelspaan_nn_1_1_N : N ;
  mandat_nn_1_N : N ;
  malmfaelt_nn_1_1_N : N ;
  malmedel_nn_1_N : N ;
  maktoevergrepp_nn_1_1_N : N ;
  maktmedel_nn_1_N : N ;
  maktinnehav_nn_1_N : N ;
  maktblock_nn_1_N : N ;
  maktanspraak_nn_1_1_N : N ;
  majskorn_nn_1_N : N ;
  majoritetsval_nn_1_N : N ;
  majestaetsbrott_nn_1_1_N : N ;
  mail_nn_2_N : N ;
  magsaar_nn_1_1_N : N ;
  magnetkort_nn_1_N : N ;
  magnetfaelt_nn_1_1_N : N ;
  magnetband_nn_1_N : N ;
  maginnehaall_nn_1_1_N : N ;
  magbesvaer_nn_1_1_N : N ;
  magasin_nn_1_N : N ;
  mackbesoek_nn_1_1_N : N ;
  machverk_nn_1_N : N ;
  machtal_nn_1_N : N ;
  macholiv_nn_1_N : N ;
  machoideal_nn_1_N : N ;
  m_nn_1_N : N ;
  loevverk_nn_1_1_N : N ;
  loevfoder_nn_1_1_N : N ;
  loev_nn_1_1_N : N ;
  loesoerekoep_nn_1_1_N : N ;
  loesskaegg_nn_1_1_N : N ;
  loesnummer_nn_1_1_N : N ;
  loesningsmedel_nn_1_1_N : N ;
  loeshaar_nn_1_1_N : N ;
  loesfynd_nn_1_1_N : N ;
  loesenordskrav_nn_1_1_N : N ;
  loesenord_nn_1_1_N : N ;
  loesenbelopp_nn_1_1_N : N ;
  loesebelopp_nn_1_1_N : N ;
  loepsteg_nn_1_1_N : N ;
  loepskift_nn_1_1_N : N ;
  loepord_nn_1_1_N : N ;
  loephjul_nn_1_1_N : N ;
  loepband_nn_1_1_N : N ;
  loep_nn_1_1_N : N ;
  loennmord_nn_1_1_N : N ;
  loennfack_nn_1_1_N : N ;
  loenetillaegg_nn_1_1_N : N ;
  loenetak_nn_1_1_N : N ;
  loenestopp_nn_1_1_N : N ;
  loenepaaslag_nn_1_1_N : N ;
  loenelyft_nn_1_1_N : N ;
  loenekuvert_nn_1_1_N : N ;
  loeneklipp_nn_1_1_N : N ;
  loenebidrag_nn_1_1_N : N ;
  loenebesked_nn_1_1_N : N ;
  loeneavtal_nn_1_1_N : N ;
  loeneavdrag_nn_1_1_N : N ;
  loeneanspraak_nn_1_1_N : N ;
  loekfjaell_nn_1_1_N : N ;
  loeftesbrott_nn_1_1_N : N ;
  loedverktyg_nn_1_1_N : N ;
  laasvred_nn_1_1_N : N ;
  laasbeslag_nn_1_1_N : N ;
  laarbensbrott_nn_1_1_N : N ;
  laarben_nn_1_1_N : N ;
  laar_nn_1_1_N : N ;
  laanord_nn_1_1_N : N ;
  laangtidsvikariat_nn_1_1_N : N ;
  laangtidsskydd_nn_1_1_N : N ;
  laangspant_nn_1_1_N : N ;
  laangskott_nn_1_1_N : N ;
  laangskepp_nn_1_1_N : N ;
  laanglopp_nn_1_1_N : N ;
  laangkok_nn_1_1_N : N ;
  laangbord_nn_1_1_N : N ;
  laanetak_nn_1_1_N : N ;
  laanekoep_nn_1_1_N : N ;
  laanekort_nn_1_1_N : N ;
  laanekontor_nn_1_1_N : N ;
  laanebibliotek_nn_1_1_N : N ;
  laan_nn_1_1_N : N ;
  laagvarv_nn_1_1_N : N ;
  laagtryck_nn_1_1_N : N ;
  laagstadiebarn_nn_1_1_N : N ;
  laagpriskort_nn_1_1_N : N ;
  laagprisflygbolag_nn_1_1_N : N ;
  laagprisbolag_nn_1_1_N : N ;
  laagloenepaaslag_nn_1_1_N : N ;
  laagfjaell_nn_1_1_N : N ;
  laagblad_nn_1_1_N : N ;
  laexprov_nn_1_1_N : N ;
  laexfoerhoer_nn_1_1_N : N ;
  laettbruk_nn_1_1_N : N ;
  laesaar_nn_1_1_N : N ;
  laesuttal_nn_1_1_N : N ;
  laestblock_nn_1_1_N : N ;
  laespljud_nn_1_1_N : N ;
  laeskpapper_nn_1_1_N : N ;
  laesklager_nn_1_1_N : N ;
  laesbarn_nn_1_1_N : N ;
  laeroaar_nn_1_1_N : N ;
  laeroverk_nn_1_1_N : N ;
  laeromedelspaket_nn_1_1_N : N ;
  laeromedel_nn_1_1_N : N ;
  laerlingsaar_nn_1_1_N : N ;
  laerdomsprov_nn_1_1_N : N ;
  laerandemaal_nn_1_1_N : N ;
  laeppstift_nn_1_1_N : N ;
  laeppljud_nn_1_1_N : N ;
  laensraad_nn_1_1_N : N ;
  laenslasarett_nn_1_1_N : N ;
  laenkhjul_nn_1_1_N : N ;
  laengdstreck_nn_1_1_N : N ;
  laengdsnitt_nn_1_1_N : N ;
  laengdmaatt_nn_1_1_N : N ;
  laengdhopp_nn_1_1_N : N ;
  laenderval_nn_1_1_N : N ;
  laen_nn_1_1_N : N ;
  laemplighetsintyg_nn_1_1_N : N ;
  laemmelaar_nn_1_1_N : N ;
  laemmeltaag_nn_1_1_N : N ;
  laekemedelsfoeretag_nn_1_1_N : N ;
  laekemedelsbolag_nn_1_1_N : N ;
  laekemedel_nn_1_1_N : N ;
  laekarrecept_nn_1_1_N : N ;
  laekarintyg_nn_1_1_N : N ;
  laegg_nn_1_1_N : N ;
  laegerbaal_nn_1_1_N : N ;
  laeger_nn_1_1_N : N ;
  laegenhetshotell_nn_1_1_N : N ;
  laederfodral_nn_1_1_N : N ;
  lyxliv_nn_1_N : N ;
  lyxhotell_nn_1_N : N ;
  lysroer_nn_1_1_N : N ;
  lynnesutbrott_nn_1_N : N ;
  lymfkaerl_nn_1_1_N : N ;
  lyktbaer_nn_1_1_N : N ;
  lyftverk_nn_1_N : N ;
  lyftskydd_nn_1_N : N ;
  lyftblock_nn_1_N : N ;
  lyft_nn_1_N : N ;
  lydnadsbrott_nn_1_N : N ;
  lydfolk_nn_1_N : N ;
  lyckoaar_nn_1_1_N : N ;
  lyckotal_nn_1_N : N ;
  lyckopiller_nn_1_N : N ;
  lyckohjul_nn_1_N : N ;
  lutningsstreck_nn_1_N : N ;
  lut_nn_2_N : N ;
  lustslott_nn_1_N : N ;
  lustmord_nn_1_N : N ;
  lustbehov_nn_1_N : N ;
  luserngroenmjoel_nn_1_1_N : N ;
  lungskott_nn_1_N : N ;
  lunchuppehaall_nn_1_1_N : N ;
  lunchbord_nn_1_N : N ;
  lumen_nn_2_N : N ;
  luftvaern_nn_1_1_N : N ;
  lufttryck_nn_1_N : N ;
  luftstreck_nn_1_N : N ;
  luftslott_nn_1_N : N ;
  luftskikt_nn_1_N : N ;
  luftskepp_nn_1_N : N ;
  luftroer_nn_1_1_N : N ;
  luftpistolset_nn_1_N : N ;
  luftlager_nn_1_N : N ;
  lufthaal_nn_1_1_N : N ;
  lufthav_nn_1_N : N ;
  luftgummihjul_nn_1_N : N ;
  luftgevaer_nn_1_1_N : N ;
  luftgap_nn_1_N : N ;
  luftfilter_nn_1_N : N ;
  luftfartyg_nn_1_N : N ;
  luftdrag_nn_1_N : N ;
  luftanfall_nn_1_N : N ;
  luder_nn_1_N : N ;
  luddbraak_nn_1_1_N : N ;
  luciataag_nn_1_1_N : N ;
  lovtal_nn_1_N : N ;
  lovord_nn_1_N : N ;
  lov_nn_3_N : N ;
  lotsdistrikt_nn_1_N : N ;
  loppisfynd_nn_1_N : N ;
  lopp_nn_1_N : N ;
  lokaltaag_nn_1_1_N : N ;
  lokalsamtal_nn_1_N : N ;
  lokalombud_nn_1_N : N ;
  lokalkontor_nn_1_N : N ;
  lokaliseringsstoed_nn_1_1_N : N ;
  lok_nn_1_N : N ;
  lojalitetsband_nn_1_N : N ;
  logementsfartyg_nn_1_N : N ;
  logement_nn_1_N : N ;
  loft_nn_1_N : N ;
  lodstreck_nn_1_N : N ;
  lodskott_nn_1_N : N ;
  lodplan_nn_1_N : N ;
  lodjur_nn_1_N : N ;
  lod_nn_1_N : N ;
  lockrop_nn_1_N : N ;
  lockdjur_nn_1_N : N ;
  lock_nn_2_N : N ;
  ljusaar_nn_1_1_N : N ;
  ljustryck_nn_1_N : N ;
  ljuster_nn_1_N : N ;
  ljussken_nn_1_N : N ;
  ljusnaet_nn_1_1_N : N ;
  ljusmikroskop_nn_1_N : N ;
  ljusfilter_nn_1_N : N ;
  ljusfenomen_nn_1_N : N ;
  ljumskbraack_nn_1_1_N : N ;
  ljudresultat_nn_1_N : N ;
  ljudintryck_nn_1_N : N ;
  ljudhaal_nn_1_1_N : N ;
  ljudbrev_nn_1_N : N ;
  ljudbildband_nn_1_N : N ;
  ljudband_nn_1_N : N ;
  ljud_nn_1_N : N ;
  livtag_nn_1_N : N ;
  livsvillkor_nn_1_N : N ;
  livsverk_nn_1_N : N ;
  livstidsstraff_nn_1_N : N ;
  livsstilsfenomen_nn_1_N : N ;
  livsslut_nn_1_N : N ;
  livsmedel_nn_1_N : N ;
  livselixir_nn_1_N : N ;
  livmoderframfall_nn_1_N : N ;
  livdjur_nn_1_N : N ;
  liv_nn_1_N : N ;
  litteraturspraak_nn_1_1_N : N ;
  litermaatt_nn_1_1_N : N ;
  listverk_nn_1_N : N ;
  listornament_nn_1_N : N ;
  lispund_nn_1_N : N ;
  linoleumsnitt_nn_1_N : N ;
  linneskaap_nn_1_1_N : N ;
  linjeskepp_nn_1_N : N ;
  linjelopp_nn_1_N : N ;
  liniment_nn_1_N : N ;
  lingonpaeron_nn_1_1_N : N ;
  lingon_nn_1_N : N ;
  lindloev_nn_1_1_N : N ;
  lindebarn_nn_1_N : N ;
  linddrag_nn_1_N : N ;
  liljemoenster_nn_1_1_N : N ;
  likfynd_nn_1_N : N ;
  lik_nn_1_N : N ;
  liggunderlag_nn_1_N : N ;
  liggsaar_nn_1_1_N : N ;
  ligg_nn_1_N : N ;
  ligament_nn_1_N : N ;
  liftkort_nn_1_N : N ;
  lieskaft_nn_1_N : N ;
  lider_nn_1_N : N ;
  lexikonprojekt_nn_1_N : N ;
  levnadsaar_nn_1_1_N : N ;
  levnadsvillkor_nn_1_N : N ;
  levnadssaett_nn_1_1_N : N ;
  levnadsmoenster_nn_1_1_N : N ;
  levnadslopp_nn_1_N : N ;
  leverop_nn_1_N : N ;
  leveransavtal_nn_1_N : N ;
  lerkaerl_nn_1_1_N : N ;
  leopardskinn_nn_1_N : N ;
  lekverk_nn_1_N : N ;
  lektorat_nn_1_N : N ;
  lekotek_nn_1_N : N ;
  lejongap_nn_1_N : N ;
  lejon_nn_1_N : N ;
  lejdebrev_nn_1_N : N ;
  legohjon_nn_1_N : N ;
  legoavtal_nn_1_N : N ;
  legg_nn_1_N : N ;
  legat_nn_2_N : N ;
  leg_nn_1_N : N ;
  ledungsskepp_nn_1_N : N ;
  ledord_nn_1_N : N ;
  ledningsorgan_nn_1_N : N ;
  ledningsmaal_nn_1_1_N : N ;
  ledningsmotstaand_nn_1_1_N : N ;
  ledkort_nn_1_N : N ;
  leddjur_nn_1_N : N ;
  ledband_nn_1_N : N ;
  ledarstick_nn_1_N : N ;
  ledarskikt_nn_1_N : N ;
  ledarpar_nn_1_N : N ;
  led_nn_3_N : N ;
  laxkar_nn_1_N : N ;
  laxerpiller_nn_1_N : N ;
  laxermedel_nn_1_N : N ;
  lavemang_nn_1_N : N ;
  lavafaelt_nn_1_1_N : N ;
  laudatur_nn_1_N : N ;
  latinlaeroverk_nn_1_1_N : N ;
  lastnaet_nn_1_1_N : N ;
  lastgaller_nn_1_N : N ;
  lastflak_nn_1_N : N ;
  lastfartyg_nn_1_N : N ;
  lastdjur_nn_1_N : N ;
  lastbilsflak_nn_1_N : N ;
  lasarett_nn_1_N : N ;
  laryngoskop_nn_1_N : N ;
  larvband_nn_1_N : N ;
  larmnummer_nn_1_N : N ;
  larm_nn_1_N : N ;
  lappverk_nn_1_N : N ;
  lantvaern_nn_1_1_N : N ;
  lantdjur_nn_1_N : N ;
  lantbruksuniversitet_nn_1_N : N ;
  lantbruksfoerbund_nn_1_1_N : N ;
  lantbruk_nn_1_N : N ;
  langettstygn_nn_1_N : N ;
  landstingsraad_nn_1_1_N : N ;
  landstingsfoerbund_nn_1_1_N : N ;
  landsting_nn_1_N : N ;
  landssekretariat_nn_1_N : N ;
  landsnummer_nn_1_N : N ;
  landsmaalsalfabet_nn_1_1_N : N ;
  landsmaal_nn_1_1_N : N ;
  landslag_nn_1_N : N ;
  landskap_nn_1_N : N ;
  landningsoegonblick_nn_1_1_N : N ;
  landningsstaell_nn_1_1_N : N ;
  landningshjul_nn_1_N : N ;
  landningsfoerbud_nn_1_1_N : N ;
  land_nn_2_N : N ;
  lampsken_nn_1_N : N ;
  lammspett_nn_1_N : N ;
  lammskinn_nn_1_N : N ;
  lamm_nn_1_N : N ;
  laminat_nn_1_N : N ;
  lamadjur_nn_1_N : N ;
  lakan_nn_1_N : N ;
  lagutskott_nn_1_N : N ;
  lagtempolopp_nn_1_N : N ;
  lagspraak_nn_1_1_N : N ;
  lagraad_nn_1_1_N : N ;
  lagn_nn_1_N : N ;
  laggkaerl_nn_1_1_N : N ;
  laggband_nn_1_N : N ;
  lagfoerslag_nn_1_1_N : N ;
  lagerbaersblad_nn_1_1_N : N ;
  lagerblad_nn_1_N : N ;
  lager_nn_1_N : N ;
  lagbrott_nn_1_N : N ;
  lag_nn_2_N : N ;
  ladugaardstak_nn_1_1_N : N ;
  lad_nn_1_N : N ;
  lackskaerp_nn_1_1_N : N ;
  laboratorieresultat_nn_1_N : N ;
  labb_nn_2_N : N ;
  lab_nn_2_N : N ;
  l_nn_1_N : N ;
  koettsaar_nn_1_1_N : N ;
  koettben_nn_1_1_N : N ;
  koestaell_nn_1_1_N : N ;
  koersbaer_nn_1_1_N : N ;
  koerkortstillstaand_nn_1_1_N : N ;
  koerkortsprov_nn_1_1_N : N ;
  koerkort_nn_1_1_N : N ;
  koerfoerbud_nn_1_1_N : N ;
  koerfaelt_nn_1_1_N : N ;
  koepvillkor_nn_1_1_N : N ;
  koepslut_nn_1_1_N : N ;
  koepkort_nn_1_1_N : N ;
  koepekontrakt_nn_1_1_N : N ;
  koepebroed_nn_1_1_N : N ;
  koepebrev_nn_1_1_N : N ;
  koepeavtal_nn_1_1_N : N ;
  koep_nn_1_1_N : N ;
  koensskaemt_nn_1_1_N : N ;
  koensorgan_nn_1_1_N : N ;
  koensord_nn_1_1_N : N ;
  koenshaar_nn_2_1_N : N ;
  koen_nn_1_1_N : N ;
  koelsvin_nn_1_1_N : N ;
  koekstak_nn_1_1_N : N ;
  koeksfoenster_nn_1_1_N : N ;
  koeksbordssamtal_nn_1_1_N : N ;
  koeksbord_nn_1_1_N : N ;
  koek_nn_1_1_N : N ;
  kaatslag_nn_1_1_N : N ;
  kaettarbaal_nn_1_1_N : N ;
  kaerrhjul_nn_1_1_N : N ;
  kaerr_nn_1_1_N : N ;
  kaeromaal_nn_1_1_N : N ;
  kaernvapenlager_nn_1_1_N : N ;
  kaernvapenkrig_nn_1_1_N : N ;
  kaernvapeninnehav_nn_1_1_N : N ;
  kaernsoenderfall_nn_1_1_N : N ;
  kaernland_nn_1_1_N : N ;
  kaernkraftverk_nn_1_1_N : N ;
  kaerleksaeventyr_nn_1_1_N : N ;
  kaerleksval_nn_1_1_N : N ;
  kaerlekspar_nn_1_1_N : N ;
  kaerleksord_nn_1_1_N : N ;
  kaerlekskval_nn_1_1_N : N ;
  kaerleksknep_nn_1_1_N : N ;
  kaerleksbudskap_nn_1_1_N : N ;
  kaerleksbud_nn_1_1_N : N ;
  kaerleksbrev_nn_1_1_N : N ;
  kaerleksbarn_nn_1_1_N : N ;
  kaerl_nn_1_1_N : N ;
  kaeril_nn_1_1_N : N ;
  kaenslouttryck_nn_1_1_N : N ;
  kaensloutbrott_nn_1_1_N : N ;
  kaenslosvall_nn_1_1_N : N ;
  kaensloengagemang_nn_1_1_N : N ;
  kaenselsproet_nn_1_1_N : N ;
  kaenselorgan_nn_1_1_N : N ;
  kaenselhaar_nn_1_1_N : N ;
  kaempatag_nn_1_1_N : N ;
  kaellspraang_nn_1_1_N : N ;
  kaellmaterial_nn_1_1_N : N ;
  kaelldrag_nn_1_1_N : N ;
  kaellarvalv_nn_1_1_N : N ;
  kaekben_nn_1_1_N : N ;
  kaegelsnitt_nn_1_1_N : N ;
  kytt_nn_1_N : N ;
  kyrktorn_nn_1_N : N ;
  kyrktak_nn_1_N : N ;
  kyrkoaar_nn_1_1_N : N ;
  kyrkospraak_nn_1_1_N : N ;
  kyrkosamfund_nn_1_N : N ;
  kyrkoraad_nn_1_1_N : N ;
  kyrkobruk_nn_1_N : N ;
  kyrkobesoek_nn_1_1_N : N ;
  kyrkfoenster_nn_1_1_N : N ;
  kyrkbroellop_nn_1_1_N : N ;
  kyrkbesoek_nn_1_1_N : N ;
  kylskaapsgaller_nn_1_1_N : N ;
  kylskaap_nn_1_1_N : N ;
  kylroer_nn_1_1_N : N ;
  kyller_nn_1_N : N ;
  kylfack_nn_1_N : N ;
  kylargaller_nn_1_N : N ;
  kvaevegoedselmedel_nn_1_1_N : N ;
  kvaellsskift_nn_1_1_N : N ;
  kvaellsmaal_nn_1_1_N : N ;
  kvitteringsmaal_nn_1_1_N : N ;
  kvisthaal_nn_1_1_N : N ;
  kvinnooevergrepp_nn_1_1_N : N ;
  kvinnoutbrott_nn_1_N : N ;
  kvinnoskratt_nn_1_N : N ;
  kvinnorov_nn_1_N : N ;
  kvinnoplagg_nn_1_N : N ;
  kvinnonamn_nn_1_N : N ;
  kvinnolaeger_nn_1_1_N : N ;
  kvinnoideal_nn_1_N : N ;
  kvinnoben_nn_1_N : N ;
  kvinnfolk_nn_1_N : N ;
  kvastskaft_nn_1_N : N ;
  kvasikontrakt_nn_1_N : N ;
  kvartsur_nn_1_N : N ;
  kvartssamtal_nn_1_N : N ;
  kvartal_nn_1_N : N ;
  kvarnhjul_nn_1_N : N ;
  kvanttal_nn_1_N : N ;
  kvalster_nn_1_N : N ;
  kvalitetskrav_nn_1_N : N ;
  kvalifikationsaar_nn_1_1_N : N ;
  kval_nn_1_N : N ;
  kvadratmaatt_nn_1_1_N : N ;
  kvack_nn_1_N : N ;
  kuvertbroed_nn_1_1_N : N ;
  kuvert_nn_1_N : N ;
  kusinaektenskap_nn_1_1_N : N ;
  kursfall_nn_1_N : N ;
  kurr_nn_2_N : N ;
  kup_efoenster_nn_1_1_N : N ;
  kuppfoersoek_nn_1_1_N : N ;
  kupolvalv_nn_1_N : N ;
  kupoltak_nn_1_N : N ;
  kunskapsstoff_nn_1_N : N ;
  kungsord_nn_1_N : N ;
  kungaval_nn_1_N : N ;
  kungapar_nn_1_N : N ;
  kungamord_nn_1_N : N ;
  kungabrev_nn_1_N : N ;
  kundoenskemaal_nn_1_1_N : N ;
  kundunderlag_nn_1_N : N ;
  kulturspraak_nn_1_1_N : N ;
  kulturraad_nn_1_1_N : N ;
  kulturreservat_nn_1_N : N ;
  kulturmoenster_nn_1_1_N : N ;
  kulturlandskap_nn_1_N : N ;
  kulturlager_nn_1_N : N ;
  kulturinstitut_nn_1_N : N ;
  kulturfolk_nn_1_N : N ;
  kulturevenemang_nn_1_N : N ;
  kulturarv_nn_1_N : N ;
  kultryck_nn_1_N : N ;
  kultfoeremaal_nn_1_1_N : N ;
  kulspaar_nn_1_1_N : N ;
  kulsprutegevaer_nn_1_1_N : N ;
  kulregn_nn_1_N : N ;
  kullerstenstorg_nn_1_N : N ;
  kullager_nn_1_N : N ;
  kulhaal_nn_1_1_N : N ;
  kulgevaer_nn_1_1_N : N ;
  kulfaang_nn_1_1_N : N ;
  kugghjul_nn_1_N : N ;
  kuddvar_nn_1_N : N ;
  kuddkrig_nn_1_N : N ;
  kroeson_nn_1_1_N : N ;
  kroen_nn_1_1_N : N ;
  kraakslott_nn_1_1_N : N ;
  kraakbaer_nn_1_1_N : N ;
  kraengningsprov_nn_1_1_N : N ;
  kraeldjur_nn_1_1_N : N ;
  kraekmedel_nn_1_1_N : N ;
  kraek_nn_1_1_N : N ;
  kraeftdjur_nn_1_1_N : N ;
  kryssvalv_nn_1_N : N ;
  krysstag_nn_1_N : N ;
  kryssningsfartyg_nn_1_N : N ;
  kryssfoerband_nn_1_1_N : N ;
  kryphaal_nn_1_1_N : N ;
  kryp_nn_1_N : N ;
  krutkorn_nn_1_N : N ;
  kruthorn_nn_1_N : N ;
  krusbaer_nn_1_1_N : N ;
  krumspraang_nn_1_1_N : N ;
  krumhorn_nn_1_N : N ;
  krossaar_nn_1_1_N : N ;
  kroppsorgan_nn_1_N : N ;
  kroppshaar_nn_2_1_N : N ;
  kroppsfynd_nn_1_N : N ;
  kronvrak_nn_1_N : N ;
  krontal_nn_1_N : N ;
  kronprinsessbroellop_nn_1_1_N : N ;
  kronblad_nn_1_N : N ;
  kromosompar_nn_1_N : N ;
  krokodilskinn_nn_1_N : N ;
  krogsamtal_nn_1_N : N ;
  krogbesoek_nn_1_1_N : N ;
  kritter_nn_1_N : N ;
  kritstreck_nn_1_N : N ;
  kristidsfoeretag_nn_1_1_N : N ;
  kristallmoenster_nn_1_1_N : N ;
  krispaket_nn_1_N : N ;
  krismedel_nn_1_N : N ;
  krishanteringsraad_nn_1_1_N : N ;
  krishanteringsrecept_nn_1_N : N ;
  kriminalregister_nn_1_N : N ;
  kriminalfall_nn_1_N : N ;
  krikon_nn_1_N : N ;
  krigsaar_nn_1_1_N : N ;
  krigsaeventyr_nn_1_1_N : N ;
  krigsutbrott_nn_1_N : N ;
  krigstaag_nn_1_1_N : N ;
  krigstillstaand_nn_1_1_N : N ;
  krigsslut_nn_1_N : N ;
  krigsskepp_nn_1_N : N ;
  krigsskadestaand_nn_1_1_N : N ;
  krigsraad_nn_1_1_N : N ;
  krigsmonument_nn_1_N : N ;
  krigslik_nn_1_N : N ;
  krigsfoerbrytarmaal_nn_1_1_N : N ;
  krigsfartyg_nn_1_N : N ;
  krigsbrott_nn_1_N : N ;
  krigsbarn_nn_1_N : N ;
  krig_nn_1_N : N ;
  krevadmoln_nn_1_N : N ;
  kretslopp_nn_1_N : N ;
  kretskort_nn_1_N : N ;
  kreolspraak_nn_1_1_N : N ;
  kreolinslag_nn_1_N : N ;
  kreditvaerderingsinstitut_nn_1_1_N : N ;
  kreditvillkor_nn_1_N : N ;
  kreditkort_nn_1_N : N ;
  kreditivbrev_nn_1_N : N ;
  kreditinstitut_nn_1_N : N ;
  kreatur_nn_1_N : N ;
  kravbrev_nn_1_N : N ;
  kravallstaket_nn_1_N : N ;
  krav_nn_1_N : N ;
  kraterberg_nn_1_N : N ;
  kranskaerl_nn_1_1_N : N ;
  kransband_nn_1_N : N ;
  kraftvaermeverk_nn_1_1_N : N ;
  kraftverk_nn_1_N : N ;
  kraftuttryck_nn_1_N : N ;
  krafttag_nn_1_N : N ;
  kraftprov_nn_1_N : N ;
  kraftpaket_nn_1_N : N ;
  kraftord_nn_1_N : N ;
  kraftnaet_nn_1_1_N : N ;
  kraftmedel_nn_1_N : N ;
  kraftfoeretag_nn_1_1_N : N ;
  kraftfaelt_nn_1_1_N : N ;
  kraftfoder_nn_1_N : N ;
  kraftbolag_nn_1_N : N ;
  kraftbehov_nn_1_N : N ;
  kraftaggregat_nn_1_N : N ;
  kotben_nn_1_N : N ;
  kosttillskott_nn_1_N : N ;
  kostraad_nn_1_1_N : N ;
  kostnadsvall_nn_1_N : N ;
  kostnadstak_nn_1_N : N ;
  kostnadsskael_nn_1_1_N : N ;
  kostnadsfoerslag_nn_1_1_N : N ;
  kosmetikafoeretag_nn_1_1_N : N ;
  korvstaand_nn_1_1_N : N ;
  korvskinn_nn_1_N : N ;
  korvjobb_nn_1_N : N ;
  kortslutningsskydd_nn_1_N : N ;
  kortregister_nn_1_N : N ;
  kort_nn_1_N : N ;
  korsvalv_nn_1_N : N ;
  korstaag_nn_1_1_N : N ;
  korsstygn_nn_1_N : N ;
  korsord_nn_1_N : N ;
  korskrank_nn_1_N : N ;
  korsfoerhoer_nn_1_1_N : N ;
  korsben_nn_1_N : N ;
  korsband_nn_1_N : N ;
  korruptionsaatal_nn_1_1_N : N ;
  korruptionsbrott_nn_1_N : N ;
  korrosionsskydd_nn_1_N : N ;
  korrespondenskort_nn_1_N : N ;
  korrelat_nn_1_N : N ;
  korrektur_nn_1_N : N ;
  korr_nn_1_N : N ;
  korngryn_nn_1_N : N ;
  kornbroed_nn_1_1_N : N ;
  korn_nn_1_N : N ;
  korklager_nn_1_N : N ;
  korkgolv_nn_1_N : N ;
  korfoenster_nn_1_1_N : N ;
  korallrev_nn_1_N : N ;
  korallhalsband_nn_1_N : N ;
  koralldjur_nn_1_N : N ;
  kor_nn_1_N : N ;
  koppaerr_nn_1_1_N : N ;
  kopplerimaal_nn_1_1_N : N ;
  koppartak_nn_1_N : N ;
  kopparstick_nn_1_N : N ;
  kopparmynt_nn_1_N : N ;
  kopiepapper_nn_1_N : N ;
  konvolut_nn_1_N : N ;
  konverteringskit_nn_1_N : N ;
  konventionsbrott_nn_1_N : N ;
  konvent_nn_1_N : N ;
  konungamord_nn_1_N : N ;
  kontrolltorn_nn_1_N : N ;
  kontrollorgan_nn_1_N : N ;
  kontrollnummer_nn_1_N : N ;
  kontrollinstrument_nn_1_N : N ;
  kontrollbord_nn_1_N : N ;
  kontrastmedel_nn_1_N : N ;
  kontraktsbrott_nn_1_N : N ;
  kontrakt_nn_1_N : N ;
  kontoutdrag_nn_1_N : N ;
  kontorslandskap_nn_1_N : N ;
  kontorsbud_nn_1_N : N ;
  kontor_nn_1_N : N ;
  kontonummer_nn_1_N : N ;
  kontokort_nn_1_N : N ;
  konterfej_nn_1_N : N ;
  kontantkort_nn_1_N : N ;
  kontaminationsoegonblick_nn_1_1_N : N ;
  konsumtionsmoenster_nn_1_1_N : N ;
  konsumentverk_nn_1_N : N ;
  konsultfoeretag_nn_1_1_N : N ;
  konsulsval_nn_1_N : N ;
  konsulat_nn_1_N : N ;
  konstverk_nn_1_N : N ;
  konstspraak_nn_1_1_N : N ;
  konstruktionsmaterial_nn_1_N : N ;
  konstliv_nn_1_N : N ;
  konstitutorial_nn_1_N : N ;
  konstitutionsutskott_nn_1_N : N ;
  konsthantverk_nn_1_N : N ;
  konstgrepp_nn_1_N : N ;
  konstansfenomen_nn_1_N : N ;
  konserveringsmedel_nn_1_N : N ;
  konossement_nn_1_N : N ;
  konkurrensmedel_nn_1_N : N ;
  konkrement_nn_1_N : N ;
  konkordat_nn_1_N : N ;
  konjunkturstoed_nn_1_1_N : N ;
  konjunkturraad_nn_1_1_N : N ;
  konjunkturomslag_nn_1_N : N ;
  konjunkturinstitut_nn_1_N : N ;
  kongruensfall_nn_1_N : N ;
  konglomerat_nn_1_N : N ;
  konfliktmoenster_nn_1_1_N : N ;
  kondensspaar_nn_1_1_N : N ;
  kondensat_nn_1_N : N ;
  konceptpapper_nn_1_N : N ;
  koncept_nn_2_N : N ;
  koncentrationslaeger_nn_1_1_N : N ;
  koncentrat_nn_1_N : N ;
  kompositmaterial_nn_1_N : N ;
  komplement_nn_1_N : N ;
  kompisgaeng_nn_1_1_N : N ;
  kompilat_nn_1_N : N ;
  kommunikationsnaet_nn_1_1_N : N ;
  kommunikationsmedel_nn_1_N : N ;
  kommunikationsdepartement_nn_1_N : N ;
  kommunfoerbund_nn_1_1_N : N ;
  kommundelsraad_nn_1_1_N : N ;
  kommunblock_nn_1_N : N ;
  kommunalval_nn_1_N : N ;
  kommunalraad_nn_1_1_N : N ;
  kommissariat_nn_1_N : N ;
  kommerseraad_nn_1_1_N : N ;
  kommandorop_nn_1_N : N ;
  kommandoord_nn_1_N : N ;
  kommandomaal_nn_1_1_N : N ;
  kommanditbolag_nn_1_N : N ;
  kometmoln_nn_1_N : N ;
  kombinat_nn_1_N : N ;
  koltbarn_nn_1_N : N ;
  kolsyregevaer_nn_1_1_N : N ;
  kolstaal_nn_1_1_N : N ;
  kolstift_nn_1_N : N ;
  kolroer_nn_1_1_N : N ;
  kolossalformat_nn_1_N : N ;
  kolonisationsfoersoek_nn_1_1_N : N ;
  koloniland_nn_1_N : N ;
  kolonialkrig_nn_1_N : N ;
  kolonat_nn_1_N : N ;
  kolon_nn_1_N : N ;
  kolnanoroer_nn_1_1_N : N ;
  kollisionsskott_nn_1_N : N ;
  kollektivjordbruk_nn_1_N : N ;
  kollektivavtal_nn_1_N : N ;
  kollegieblock_nn_1_N : N ;
  kolikanfall_nn_1_N : N ;
  kolfilter_nn_1_N : N ;
  koldioxidutslaepp_nn_1_1_N : N ;
  kokkaerl_nn_1_1_N : N ;
  kok_nn_1_N : N ;
  koger_nn_1_N : N ;
  kodspraak_nn_1_1_N : N ;
  knaeveck_nn_1_1_N : N ;
  knaeslut_nn_1_1_N : N ;
  knaeskydd_nn_1_1_N : N ;
  knaeroer_nn_1_1_N : N ;
  knaeckebroed_nn_1_1_N : N ;
  knaeck_nn_2_1_N : N ;
  knytskaerp_nn_1_1_N : N ;
  knytnaevsslag_nn_1_1_N : N ;
  knull_nn_1_N : N ;
  knoster_nn_1_N : N ;
  knogjaern_nn_1_1_N : N ;
  knog_nn_1_N : N ;
  knivsaar_nn_1_1_N : N ;
  knivskaft_nn_1_N : N ;
  knivmord_nn_1_N : N ;
  knivhugg_nn_1_N : N ;
  knivblad_nn_1_N : N ;
  knip_nn_1_N : N ;
  knep_nn_1_N : N ;
  kneg_nn_1_N : N ;
  knapptryck_nn_1_N : N ;
  knapphaal_nn_1_1_N : N ;
  knallskott_nn_1_N : N ;
  knack_nn_1_N : N ;
  kloeverblad_nn_1_1_N : N ;
  kloevdjur_nn_1_1_N : N ;
  klaetterrep_nn_1_1_N : N ;
  klaetterjaern_nn_1_1_N : N ;
  klaenningsliv_nn_1_1_N : N ;
  klaedstreck_nn_1_1_N : N ;
  klaedskaap_nn_1_1_N : N ;
  klaedesplagg_nn_1_1_N : N ;
  kluster_nn_1_N : N ;
  klumpackord_nn_1_N : N ;
  klubbslag_nn_1_N : N ;
  klotterplank_nn_1_N : N ;
  klot_nn_1_N : N ;
  kloster_nn_1_N : N ;
  klocktorn_nn_1_N : N ;
  klockslag_nn_1_N : N ;
  kloakdjur_nn_1_N : N ;
  kliv_nn_1_N : N ;
  klippstup_nn_1_N : N ;
  klippotek_nn_1_N : N ;
  klippkort_nn_1_N : N ;
  klippblock_nn_1_N : N ;
  klipp_nn_1_N : N ;
  klimatskael_nn_1_1_N : N ;
  klimathot_nn_1_N : N ;
  klimatavtal_nn_1_N : N ;
  klimat_nn_1_N : N ;
  klickljud_nn_1_N : N ;
  klick_nn_2_N : N ;
  klev_nn_1_N : N ;
  klavikord_nn_1_N : N ;
  klaverutdrag_nn_1_N : N ;
  klavertramp_nn_1_N : N ;
  klassmoerj_nn_1_1_N : N ;
  klasslag_nn_2_N : N ;
  klarskinn_nn_1_N : N ;
  klarmedel_nn_1_N : N ;
  klarbaer_nn_1_1_N : N ;
  klagotjut_nn_1_N : N ;
  klagorop_nn_1_N : N ;
  klagomaal_nn_1_1_N : N ;
  klaffbord_nn_1_N : N ;
  klackjaern_nn_1_1_N : N ;
  kjoltyg_nn_1_N : N ;
  kit_nn_1_N : N ;
  kistebrev_nn_1_N : N ;
  kistbrev_nn_1_N : N ;
  kindben_nn_1_N : N ;
  kilspaar_nn_1_1_N : N ;
  kilopond_nn_1_N : N ;
  kilben_nn_1_N : N ;
  kikhaal_nn_1_1_N : N ;
  kidnappningsfoersoek_nn_1_1_N : N ;
  kid_nn_1_N : N ;
  kejsarsnitt_nn_1_N : N ;
  kedjestygn_nn_1_N : N ;
  kedjeskydd_nn_1_N : N ;
  kedjelyftblock_nn_1_N : N ;
  kedjehjul_nn_1_N : N ;
  kedjebraak_nn_1_1_N : N ;
  kedjebrev_nn_1_N : N ;
  kedjeblock_nn_1_N : N ;
  kebabstaand_nn_1_1_N : N ;
  kavitetsdjur_nn_1_N : N ;
  kavajslag_nn_1_N : N ;
  kattpensionat_nn_1_N : N ;
  katthaar_nn_1_1_N : N ;
  kattdjur_nn_1_N : N ;
  katrinplommon_nn_1_N : N ;
  katodstraaleroer_nn_1_1_N : N ;
  katastrofval_nn_1_N : N ;
  katastroftillstaand_nn_1_1_N : N ;
  katastroflarm_nn_1_N : N ;
  katalognummer_nn_1_N : N ;
  katalogfoeretag_nn_1_1_N : N ;
  kasusspraak_nn_1_1_N : N ;
  kaststygn_nn_1_N : N ;
  kastspjut_nn_1_N : N ;
  kastskydd_nn_1_N : N ;
  kastell_nn_1_N : N ;
  kastblock_nn_1_N : N ;
  kassettdaeck_nn_1_1_N : N ;
  kassettband_nn_1_N : N ;
  kassavalv_nn_1_N : N ;
  kassaskaap_nn_1_1_N : N ;
  kassaskrin_nn_1_N : N ;
  kassandrarop_nn_1_N : N ;
  kassakoep_nn_1_1_N : N ;
  kassakontor_nn_1_N : N ;
  kasernfoerbud_nn_1_1_N : N ;
  karvsnitt_nn_1_N : N ;
  kartotek_nn_1_N : N ;
  kartongbruk_nn_1_N : N ;
  karottunderlaegg_nn_1_1_N : N ;
  karlsbaderbroed_nn_1_1_N : N ;
  karlatag_nn_1_N : N ;
  kardinaltal_nn_1_N : N ;
  kardinalstreck_nn_1_N : N ;
  kardborreband_nn_1_N : N ;
  kardborrband_nn_1_N : N ;
  karbonpapper_nn_1_N : N ;
  karbad_nn_1_N : N ;
  karamellpapper_nn_1_N : N ;
  karaktaersmord_nn_1_1_N : N ;
  karaktaersdrag_nn_1_1_N : N ;
  kar_nn_1_N : N ;
  kapningsfoersoek_nn_1_1_N : N ;
  kapkrusbaer_nn_1_1_N : N ;
  kapital_nn_1_N : N ;
  kapillaerroer_nn_1_1_N : N ;
  kapfaar_nn_1_1_N : N ;
  kapell_nn_1_N : N ;
  kaparbrev_nn_1_N : N ;
  kap_nn_2_N : N ;
  kaosvaeder_nn_1_1_N : N ;
  kanvasband_nn_1_N : N ;
  kantrep_nn_1_N : N ;
  kantbeslag_nn_1_N : N ;
  kantband_nn_1_N : N ;
  kansliraad_nn_1_1_N : N ;
  kanotlaeger_nn_1_1_N : N ;
  kanonvaeder_nn_1_1_N : N ;
  kanontorn_nn_1_N : N ;
  kanonset_nn_1_N : N ;
  kanonlopp_nn_1_N : N ;
  kanonkoep_nn_1_1_N : N ;
  kanondaan_nn_1_1_N : N ;
  kaninhaal_nn_1_1_N : N ;
  kandar_nn_1_N : N ;
  kanalutbud_nn_1_N : N ;
  kamouflageinlaegg_nn_1_1_N : N ;
  kamikazeuppdrag_nn_1_N : N ;
  kamelforskningsprojekt_nn_1_N : N ;
  kameldjur_nn_1_N : N ;
  kalvskinnsband_nn_1_N : N ;
  kalvskinn_nn_1_N : N ;
  kaloriintag_nn_1_N : N ;
  kaloribehov_nn_1_N : N ;
  kallortstillaegg_nn_1_1_N : N ;
  kallgrin_nn_1_N : N ;
  kallelsefoerslag_nn_1_1_N : N ;
  kallelsebrev_nn_1_N : N ;
  kallelsebeslut_nn_1_N : N ;
  kallblod_nn_1_N : N ;
  kallbad_nn_1_N : N ;
  kall_nn_1_N : N ;
  kalkylark_nn_1_N : N ;
  kalkskal_nn_1_N : N ;
  kalksediment_nn_1_N : N ;
  kalkerpapper_nn_1_N : N ;
  kalkbruk_nn_1_N : N ;
  kalkbrott_nn_1_N : N ;
  kalifat_nn_1_N : N ;
  kalfjaell_nn_1_1_N : N ;
  kalenderaar_nn_1_1_N : N ;
  kalenderdygn_nn_1_N : N ;
  kalejdoskop_nn_1_N : N ;
  kaleidoskop_nn_1_N : N ;
  kaktusfikon_nn_1_N : N ;
  kakmaatt_nn_1_1_N : N ;
  kakfat_nn_1_N : N ;
  kakelverktyg_nn_1_N : N ;
  kakbak_nn_1_N : N ;
  kajutdaeck_nn_1_1_N : N ;
  kajdjup_nn_1_N : N ;
  kairotal_nn_1_N : N ;
  kaf_ebord_nn_1_1_N : N ;
  kafferspraak_nn_1_1_N : N ;
  kafferspjut_nn_1_N : N ;
  kafferep_nn_1_N : N ;
  kaffepulver_nn_1_N : N ;
  kaffefilter_nn_1_N : N ;
  kaffefat_nn_1_N : N ;
  kaffebord_nn_1_N : N ;
  kadettfartyg_nn_1_N : N ;
  kadaver_nn_1_N : N ;
  kabinettskort_nn_1_N : N ;
  kabinettsformat_nn_1_N : N ;
  kabinett_nn_1_N : N ;
  kabelskaap_nn_1_1_N : N ;
  kabelgatt_nn_1_N : N ;
  jaevulstyg_nn_1_1_N : N ;
  jaevelstyg_nn_1_1_N : N ;
  jaev_nn_1_1_N : N ;
  jaettesteg_nn_1_1_N : N ;
  jaetteslagsmaal_nn_1_1_N : N ;
  jaettemoln_nn_1_1_N : N ;
  jaetteklot_nn_1_1_N : N ;
  jaettekliv_nn_1_1_N : N ;
  jaetteisberg_nn_1_1_N : N ;
  jaettefoeretag_nn_1_1_N : N ;
  jaetteavtal_nn_1_1_N : N ;
  jaernaar_nn_1_1_N : N ;
  jaernvaegsspaar_nn_1_1_N : N ;
  jaernverk_nn_1_1_N : N ;
  jaernstaket_nn_1_1_N : N ;
  jaernstag_nn_1_1_N : N ;
  jaernspett_nn_1_1_N : N ;
  jaernroer_nn_1_1_N : N ;
  jaernredskap_nn_1_1_N : N ;
  jaerngrepp_nn_1_1_N : N ;
  jaernfoeremaal_nn_1_1_N : N ;
  jaernbroellop_nn_1_1_N : N ;
  jaernbruk_nn_1_1_N : N ;
  jaernblad_nn_1_1_N : N ;
  jaernbeslag_nn_1_1_N : N ;
  jaern_nn_1_1_N : N ;
  jaemviktsorgan_nn_1_1_N : N ;
  jaemnviktsorgan_nn_1_1_N : N ;
  jaemmerrop_nn_1_1_N : N ;
  jaemfoerelsetal_nn_1_1_N : N ;
  jaegarhorn_nn_1_1_N : N ;
  jaegarfoerband_nn_1_1_N : N ;
  jaegarfolk_nn_1_1_N : N ;
  juver_nn_1_N : N ;
  juvelerarfoenster_nn_1_1_N : N ;
  justitieutskott_nn_1_N : N ;
  justitieraad_nn_1_1_N : N ;
  justitiemord_nn_1_N : N ;
  justitiedepartement_nn_1_N : N ;
  jurt_nn_1_N : N ;
  jungfrutal_nn_1_N : N ;
  jungfrustift_nn_1_N : N ;
  jungfruben_nn_1_N : N ;
  julrecept_nn_1_N : N ;
  julpynt_nn_1_N : N ;
  jullov_nn_1_N : N ;
  julkort_nn_1_N : N ;
  julbord_nn_1_N : N ;
  jugendband_nn_1_N : N ;
  judebroed_nn_1_1_N : N ;
  jubileumsaar_nn_1_1_N : N ;
  jubileumsmynt_nn_1_N : N ;
  jubelaar_nn_1_1_N : N ;
  jubelrop_nn_1_N : N ;
  jordtag_nn_1_N : N ;
  jordsvin_nn_1_N : N ;
  jordspjut_nn_1_N : N ;
  jordskred_nn_1_N : N ;
  jordskott_nn_1_N : N ;
  jordskalv_nn_1_N : N ;
  jordregister_nn_1_N : N ;
  jordmaterial_nn_1_N : N ;
  jordlager_nn_1_N : N ;
  jordgolv_nn_1_N : N ;
  jordfynd_nn_1_N : N ;
  jordbruksredskap_nn_1_N : N ;
  jordbrukslandskap_nn_1_N : N ;
  jordbruksdepartement_nn_1_N : N ;
  jordbruk_nn_1_N : N ;
  jordblad_nn_1_N : N ;
  jongitter_nn_1_N : N ;
  jojovaeder_nn_1_1_N : N ;
  jobbskatteavdrag_nn_1_N : N ;
  jobbkoek_nn_1_1_N : N ;
  jobbcoachningsfoeretag_nn_1_1_N : N ;
  jobb_nn_1_N : N ;
  jetset_nn_1_N : N ;
  jetplan_nn_1_N : N ;
  jetflygplan_nn_1_N : N ;
  jesusbarn_nn_1_N : N ;
  jazzband_nn_1_N : N ;
  jarop_nn_1_N : N ;
  jaktspaar_nn_1_1_N : N ;
  jaktslott_nn_1_N : N ;
  jaktprov_nn_1_N : N ;
  jaktplan_nn_1_N : N ;
  jaktlopp_nn_1_N : N ;
  jaktlag_nn_1_N : N ;
  jaktkort_nn_1_N : N ;
  jakthorn_nn_1_N : N ;
  jaktgevaer_nn_1_1_N : N ;
  jaktbrott_nn_1_N : N ;
  jag_nn_1_N : N ;
  jackuttag_nn_1_N : N ;
  jack_nn_1_N : N ;
  it_foeretag_nn_1_1_N : N ;
  istryck_nn_1_N : N ;
  isterband_nn_1_N : N ;
  isskaap_nn_1_1_N : N ;
  isoleringsmaterial_nn_1_N : N ;
  isoleringsband_nn_1_N : N ;
  isolerband_nn_1_N : N ;
  islamtal_nn_1_N : N ;
  iskorn_nn_1_N : N ;
  ishockeyroer_nn_1_1_N : N ;
  ishav_nn_1_N : N ;
  isflak_nn_1_N : N ;
  isblock_nn_1_N : N ;
  isberg_nn_1_N : N ;
  irritationsmoment_nn_1_N : N ;
  irritament_nn_1_N : N ;
  iridiumlager_nn_1_N : N ;
  ip_nummer_nn_1_N : N ;
  investmentbolag_nn_1_N : N ;
  inverterelverk_nn_1_N : N ;
  invandrarverk_nn_1_N : N ;
  invandrarbroellop_nn_1_1_N : N ;
  inval_nn_1_N : N ;
  intaag_nn_1_1_N : N ;
  intyg_nn_1_N : N ;
  intraedestal_nn_1_1_N : N ;
  intraedesprov_nn_1_1_N : N ;
  intraedeskrav_nn_1_1_N : N ;
  intryck_nn_1_N : N ;
  introduktionsbrev_nn_1_N : N ;
  intranaet_nn_1_1_N : N ;
  intjack_nn_1_N : N ;
  intestatarv_nn_1_N : N ;
  intervjuobjekt_nn_1_N : N ;
  interregnum_nn_1_N : N ;
  interneringslaeger_nn_1_1_N : N ;
  internat_nn_1_N : N ;
  interferensmoenster_nn_1_1_N : N ;
  interdikt_nn_1_N : N ;
  intercitytaag_nn_1_1_N : N ;
  intentionsdjup_nn_1_N : N ;
  intellekt_nn_1_N : N ;
  inteckningslaan_nn_1_1_N : N ;
  intag_nn_1_N : N ;
  instrument_nn_1_N : N ;
  institut_nn_1_N : N ;
  installationstal_nn_1_N : N ;
  insnitt_nn_1_N : N ;
  inslaepp_nn_1_1_N : N ;
  inslag_nn_1_N : N ;
  inskott_nn_1_N : N ;
  insideraatal_nn_1_1_N : N ;
  insidermaal_nn_1_1_N : N ;
  insektsmedel_nn_1_N : N ;
  insektsbett_nn_1_N : N ;
  insektsangrepp_nn_1_N : N ;
  inrop_nn_1_N : N ;
  inrikesdepartement_nn_1_N : N ;
  inresetillstaand_nn_1_1_N : N ;
  inomhusgolv_nn_1_N : N ;
  innertak_nn_1_N : N ;
  innerskaer_nn_1_1_N : N ;
  innerdoerrhandtag_nn_1_1_N : N ;
  innehaallsord_nn_1_1_N : N ;
  innehaallsobjekt_nn_1_1_N : N ;
  innehaall_nn_1_1_N : N ;
  innehavarpapper_nn_1_N : N ;
  innehav_nn_1_N : N ;
  innanlaar_nn_1_1_N : N ;
  innanhav_nn_1_N : N ;
  innanfoenster_nn_1_1_N : N ;
  inlaerningsresultat_nn_1_1_N : N ;
  inlaegg_nn_1_1_N : N ;
  inlopp_nn_1_N : N ;
  inljud_nn_1_N : N ;
  inkoep_nn_1_1_N : N ;
  inkomstslag_nn_1_N : N ;
  inkomstmaatt_nn_1_1_N : N ;
  inkomstkort_nn_1_N : N ;
  inkomstbortfall_nn_1_N : N ;
  inkomstbelopp_nn_1_N : N ;
  inkomstbegrepp_nn_1_N : N ;
  inkassobrev_nn_1_N : N ;
  inkallelsebrev_nn_1_N : N ;
  inkabaer_nn_1_1_N : N ;
  initialord_nn_1_N : N ;
  inhopp_nn_1_N : N ;
  inhav_nn_1_N : N ;
  ingoet_nn_1_1_N : N ;
  ingrepp_nn_1_N : N ;
  ingefaerspaeron_nn_1_1_N : N ;
  infusionsdjur_nn_1_N : N ;
  infraljud_nn_1_N : N ;
  informationsorgan_nn_1_N : N ;
  influensafall_nn_1_N : N ;
  influensadoedsfall_nn_1_1_N : N ;
  inflationsskydd_nn_1_N : N ;
  infall_nn_1_N : N ;
  industrifoerbund_nn_1_1_N : N ;
  indrag_nn_1_N : N ;
  indiantjut_nn_1_N : N ;
  indianreservat_nn_1_N : N ;
  indianfolk_nn_1_N : N ;
  indexavtal_nn_1_N : N ;
  incitament_nn_1_N : N ;
  incabaer_nn_1_1_N : N ;
  inboerdeskrig_nn_1_1_N : N ;
  inbrott_nn_1_N : N ;
  inbjudningskort_nn_1_N : N ;
  inbillningsfoster_nn_1_N : N ;
  inbetalningskort_nn_1_N : N ;
  inbegrepp_nn_1_N : N ;
  imskydd_nn_1_N : N ;
  imroer_nn_1_1_N : N ;
  impulskoep_nn_1_1_N : N ;
  importstopp_nn_1_N : N ;
  importfoerbud_nn_1_1_N : N ;
  implantat_nn_1_N : N ;
  imperiekrig_nn_1_N : N ;
  imperialformat_nn_1_N : N ;
  impediment_nn_1_N : N ;
  ilsamtal_nn_1_N : N ;
  illvraal_nn_1_1_N : N ;
  illusionsnummer_nn_1_N : N ;
  illtjut_nn_1_N : N ;
  illdaad_nn_1_1_N : N ;
  ilbud_nn_1_N : N ;
  ifyllnadsprov_nn_1_N : N ;
  idrottsreferat_nn_1_N : N ;
  idrottslag_nn_1_N : N ;
  idolskap_nn_1_N : N ;
  idolportraett_nn_1_1_N : N ;
  identitetskort_nn_1_N : N ;
  ideal_nn_1_N : N ;
  id_kort_nn_1_N : N ;
  icke_spridningsavtal_nn_1_N : N ;
  hoestvaeder_nn_1_1_N : N ;
  hoestregn_nn_1_1_N : N ;
  hoestloev_nn_1_1_N : N ;
  hoestlov_nn_1_1_N : N ;
  hoerselskydd_nn_1_1_N : N ;
  hoerselorgan_nn_1_1_N : N ;
  hoerselben_nn_1_1_N : N ;
  hoerntorn_nn_1_1_N : N ;
  hoernskaap_nn_1_1_N : N ;
  hoern_nn_1_1_N : N ;
  hoensaegg_nn_1_1_N : N ;
  hoensnaet_nn_1_1_N : N ;
  hoensbaer_nn_1_1_N : N ;
  hoelster_nn_1_1_N : N ;
  hoejdhopp_nn_1_1_N : N ;
  hoegvarv_nn_1_1_N : N ;
  hoegtryck_nn_1_1_N : N ;
  hoegtidsaar_nn_1_1_N : N ;
  hoegtidstal_nn_1_1_N : N ;
  hoegrev_nn_1_1_N : N ;
  hoegmaalsbrott_nn_1_1_N : N ;
  hoegloenejobb_nn_1_1_N : N ;
  hoeglager_nn_1_1_N : N ;
  hoegkor_nn_1_1_N : N ;
  hoeghastighetstaag_nn_1_1_N : N ;
  hoegfjaell_nn_1_1_N : N ;
  hoegerben_nn_1_1_N : N ;
  hoegdjur_nn_1_1_N : N ;
  hoegblad_nn_1_1_N : N ;
  hoegben_nn_1_1_N : N ;
  hoeftben_nn_1_1_N : N ;
  haarsvall_nn_1_1_N : N ;
  haarroerskaerl_nn_1_1_N : N ;
  haarroer_nn_1_1_N : N ;
  haarlag_nn_1_1_N : N ;
  haarfaergningsmedel_nn_1_1_N : N ;
  haarband_nn_1_1_N : N ;
  haar_nn_2_1_N : N ;
  haanskratt_nn_1_1_N : N ;
  haangelpar_nn_1_1_N : N ;
  haanflin_nn_1_1_N : N ;
  haalspikband_nn_1_1_N : N ;
  haalslag_nn_1_1_N : N ;
  haalmoenster_nn_1_1_N : N ;
  haallningssaett_nn_1_1_N : N ;
  haalligaang_nn_1_1_N : N ;
  haall_nn_1_1_N : N ;
  haalkort_nn_1_1_N : N ;
  haalfotsinlaegg_nn_1_1_N : N ;
  haal_nn_1_1_N : N ;
  haeststyng_nn_1_1_N : N ;
  haestspann_nn_1_1_N : N ;
  haestdjur_nn_1_1_N : N ;
  haestben_nn_1_1_N : N ;
  haertaag_nn_1_1_N : N ;
  haerskarpar_nn_1_1_N : N ;
  haernadstaag_nn_1_1_N : N ;
  haerjningstaag_nn_1_1_N : N ;
  haerdighetskrav_nn_1_1_N : N ;
  haeradsting_nn_1_1_N : N ;
  haengavtal_nn_1_1_N : N ;
  haendelsefoerlopp_nn_1_1_N : N ;
  haelsotek_nn_1_1_N : N ;
  haelsoskael_nn_1_1_N : N ;
  haelsokort_nn_1_1_N : N ;
  haelsningstal_nn_1_1_N : N ;
  haellregn_nn_1_1_N : N ;
  haelftenbruk_nn_1_1_N : N ;
  haelben_nn_1_1_N : N ;
  haektningsbeslut_nn_1_1_N : N ;
  haeftstift_nn_1_1_N : N ;
  haedelseaatal_nn_1_1_N : N ;
  haecklopp_nn_1_1_N : N ;
  hyvelstaal_nn_1_1_N : N ;
  hyvelspaan_nn_1_1_N : N ;
  hyveljaern_nn_1_1_N : N ;
  hyresvillkor_nn_1_N : N ;
  hyrestillaegg_nn_1_1_N : N ;
  hyreskontrakt_nn_1_N : N ;
  hyresavtal_nn_1_N : N ;
  hypotekslaan_nn_1_1_N : N ;
  hypotek_nn_1_N : N ;
  hydroplan_nn_1_N : N ;
  huvudverb_nn_1_N : N ;
  huvudstraak_nn_1_1_N : N ;
  huvudskael_nn_1_1_N : N ;
  huvudskyddsombud_nn_1_N : N ;
  huvudskydd_nn_1_N : N ;
  huvudord_nn_1_N : N ;
  huvudmoment_nn_1_N : N ;
  huvudlag_nn_1_N : N ;
  huvudkontor_nn_1_N : N ;
  huvudinnehaall_nn_1_1_N : N ;
  huvudhaar_nn_1_1_N : N ;
  huvuddrag_nn_1_N : N ;
  huvudbudskap_nn_1_N : N ;
  huvudavtal_nn_1_N : N ;
  hustrutillaegg_nn_1_1_N : N ;
  hustimmer_nn_1_N : N ;
  hustak_nn_1_N : N ;
  husorgan_nn_1_N : N ;
  husnummer_nn_1_N : N ;
  huskoep_nn_1_1_N : N ;
  hushaallningssaellskap_nn_1_1_N : N ;
  hushaall_nn_1_1_N : N ;
  husgeraad_nn_1_1_N : N ;
  husfoervaerv_nn_1_1_N : N ;
  husfoerhoer_nn_1_1_N : N ;
  husfridsknull_nn_1_N : N ;
  husdjur_nn_1_N : N ;
  husbehov_nn_1_N : N ;
  husapotek_nn_1_N : N ;
  hurrarop_nn_1_N : N ;
  hungerupplopp_nn_1_N : N ;
  hundaar_nn_1_1_N : N ;
  hundvaeder_nn_1_1_N : N ;
  hundslagsmaal_nn_1_1_N : N ;
  hundratusental_nn_1_N : N ;
  hundratal_nn_1_N : N ;
  hundpensionat_nn_1_N : N ;
  hundhaar_nn_1_1_N : N ;
  hundhalsband_nn_1_N : N ;
  hunddjur_nn_1_N : N ;
  hundben_nn_1_N : N ;
  humoer_nn_1_1_N : N ;
  humlesurr_nn_1_N : N ;
  humleblomster_nn_1_N : N ;
  hugskott_nn_1_N : N ;
  huggsaar_nn_1_1_N : N ;
  hugg_nn_1_N : N ;
  hudveck_nn_1_N : N ;
  hudutslag_nn_1_N : N ;
  hudmedel_nn_1_N : N ;
  hudlager_nn_1_N : N ;
  hudhorn_nn_1_N : N ;
  hovslag_nn_1_N : N ;
  hovraettsraad_nn_1_1_N : N ;
  hovkapell_nn_1_N : N ;
  hovdjur_nn_1_N : N ;
  hovbeslag_nn_1_N : N ;
  hov_nn_2_N : N ;
  hotelsebrev_nn_1_N : N ;
  hotell_nn_1_N : N ;
  hot_nn_1_N : N ;
  hostanfall_nn_1_N : N ;
  hospital_nn_1_N : N ;
  horoskop_nn_1_N : N ;
  horn_nn_1_N : N ;
  hormonsvall_nn_1_N : N ;
  horisontalplan_nn_1_N : N ;
  hopptorn_nn_1_N : N ;
  hopprep_nn_1_N : N ;
  hoppfoersoek_nn_1_1_N : N ;
  hopp_nn_1_N : N ;
  hopkok_nn_1_N : N ;
  hopklumpningstillstaand_nn_1_1_N : N ;
  honorar_nn_1_N : N ;
  honnoersord_nn_1_1_N : N ;
  honnoersbord_nn_1_1_N : N ;
  honnoersbetyg_nn_1_1_N : N ;
  hondjur_nn_1_N : N ;
  homoaektenskap_nn_1_1_N : N ;
  homopar_nn_1_N : N ;
  holt_nn_1_N : N ;
  holdingbolag_nn_1_N : N ;
  hockeyroer_nn_1_1_N : N ;
  hjaessben_nn_1_1_N : N ;
  hjaertstopp_nn_1_1_N : N ;
  hjaertstillestaand_nn_1_1_N : N ;
  hjaertslag_nn_1_1_N : N ;
  hjaertljud_nn_1_1_N : N ;
  hjaertelag_nn_1_1_N : N ;
  hjaertekval_nn_1_1_N : N ;
  hjaertegull_nn_1_1_N : N ;
  hjaertegryn_nn_1_1_N : N ;
  hjaertebarn_nn_1_1_N : N ;
  hjaertblad_nn_1_1_N : N ;
  hjaertbarn_nn_1_1_N : N ;
  hjaernslaepp_nn_1_1_N : N ;
  hjaernbihang_nn_1_1_N : N ;
  hjaelteportraett_nn_1_1_N : N ;
  hjaeltedaad_nn_1_1_N : N ;
  hjaelpverb_nn_1_1_N : N ;
  hjaelpspraak_nn_1_1_N : N ;
  hjaelpmedel_nn_1_1_N : N ;
  hjaelpfartyg_nn_1_1_N : N ;
  hjulspaar_nn_1_1_N : N ;
  hjulnav_nn_1_N : N ;
  hjullager_nn_1_N : N ;
  hjulfoenster_nn_1_1_N : N ;
  hjuldjur_nn_1_N : N ;
  hjul_nn_1_N : N ;
  hjortdjur_nn_1_N : N ;
  hjonelag_nn_1_N : N ;
  hjon_nn_1_N : N ;
  hivutbrott_nn_1_N : N ;
  hittebarn_nn_1_N : N ;
  historieverk_nn_1_N : N ;
  hindertrick_nn_1_N : N ;
  hinder_nn_1_N : N ;
  himmelsobjekt_nn_1_N : N ;
  himlafenomen_nn_1_N : N ;
  hetsbrott_nn_1_N : N ;
  heteropar_nn_1_N : N ;
  herrskap_nn_1_N : N ;
  herrlandslag_nn_1_N : N ;
  herrefolk_nn_1_N : N ;
  heroinvrak_nn_1_N : N ;
  herdefolk_nn_1_N : N ;
  herdabrev_nn_1_N : N ;
  hemvaern_nn_1_1_N : N ;
  hemspraak_nn_1_1_N : N ;
  hemsjukvaardsbidrag_nn_1_1_N : N ;
  hemnummer_nn_1_N : N ;
  hemman_nn_1_N : N ;
  hemmalag_nn_1_N : N ;
  hemlaan_nn_1_1_N : N ;
  hemfridsbrott_nn_1_N : N ;
  hembud_nn_1_N : N ;
  hembesoek_nn_1_1_N : N ;
  heltidsjobb_nn_1_N : N ;
  heltal_nn_1_N : N ;
  helskaegg_nn_1_1_N : N ;
  helikopterraan_nn_1_1_N : N ;
  helikon_nn_1_N : N ;
  helhetsintryck_nn_1_N : N ;
  helgon_nn_1_N : N ;
  helgeraan_nn_1_1_N : N ;
  helfabrikat_nn_1_N : N ;
  hedersord_nn_1_N : N ;
  hedersnamn_nn_1_N : N ;
  hedersmord_nn_1_N : N ;
  hedersbegrepp_nn_1_N : N ;
  heat_nn_1_N : N ;
  havsoernspar_nn_1_1_N : N ;
  havsmonster_nn_1_N : N ;
  havsdjup_nn_1_N : N ;
  havsbad_nn_1_N : N ;
  havrekorn_nn_1_N : N ;
  havregryn_nn_1_N : N ;
  havreflarn_nn_1_N : N ;
  havandeskap_nn_1_N : N ;
  hav_nn_1_N : N ;
  hatsamtal_nn_1_N : N ;
  hatportraett_nn_1_1_N : N ;
  hatobjekt_nn_1_N : N ;
  hatbrott_nn_1_N : N ;
  hatbrev_nn_1_N : N ;
  hastverk_nn_1_N : N ;
  harspaar_nn_1_1_N : N ;
  harem_nn_1_N : N ;
  hantverksjobb_nn_1_N : N ;
  hantverk_nn_1_N : N ;
  hanorgan_nn_1_N : N ;
  hangarfartyg_nn_1_N : N ;
  hang_nn_1_N : N ;
  handtag_nn_1_N : N ;
  handslag_nn_1_N : N ;
  handskfack_nn_1_N : N ;
  handlaan_nn_1_1_N : N ;
  handlingssaett_nn_1_1_N : N ;
  handlingsord_nn_1_N : N ;
  handjur_nn_1_N : N ;
  handikapp_nn_1_N : N ;
  handgrepp_nn_1_N : N ;
  handgemaeng_nn_1_1_N : N ;
  handfat_nn_1_N : N ;
  handelsregister_nn_1_N : N ;
  handelskoep_nn_1_1_N : N ;
  handelskontor_nn_1_N : N ;
  handelsfoeretag_nn_1_1_N : N ;
  handelsfoerdrag_nn_1_1_N : N ;
  handelsfartyg_nn_1_N : N ;
  handelsdepartement_nn_1_N : N ;
  handelsbolag_nn_1_N : N ;
  handelsavtal_nn_1_N : N ;
  handbrev_nn_1_N : N ;
  handavtryck_nn_1_N : N ;
  handalfabet_nn_1_N : N ;
  hamnkontor_nn_1_N : N ;
  hammockgaangjaern_nn_1_1_N : N ;
  hammarslag_nn_1_N : N ;
  hammarband_nn_1_N : N ;
  halvaar_nn_1_1_N : N ;
  halvstop_nn_1_N : N ;
  halvslag_nn_1_N : N ;
  halvmaratonlopp_nn_1_N : N ;
  halvklot_nn_1_N : N ;
  halvfabrikat_nn_1_N : N ;
  halvdaeck_nn_1_1_N : N ;
  halvdussin_nn_1_N : N ;
  halvblod_nn_1_N : N ;
  halster_nn_1_N : N ;
  halsjaern_nn_1_1_N : N ;
  halsband_nn_1_N : N ;
  halogenstraalkastarset_nn_1_1_N : N ;
  halofenomen_nn_1_N : N ;
  halmtak_nn_1_N : N ;
  hallucinationstillstaand_nn_1_1_N : N ;
  hallon_nn_1_N : N ;
  hallgolv_nn_1_N : N ;
  halkskydd_nn_1_N : N ;
  halgatt_nn_1_N : N ;
  hakskaegg_nn_1_1_N : N ;
  hakband_nn_1_N : N ;
  hak_nn_1_N : N ;
  hagelkorn_nn_1_N : N ;
  hagelgevaer_nn_1_1_N : N ;
  hagelboesseskott_nn_1_1_N : N ;
  hafsverk_nn_1_N : N ;
  hackningsfoersoek_nn_1_1_N : N ;
  hack_nn_1_N : N ;
  goetvalsverk_nn_1_1_N : N ;
  goetamaal_nn_1_1_N : N ;
  goeromaal_nn_1_1_N : N ;
  goerdeldaeck_nn_1_1_N : N ;
  goekur_nn_1_1_N : N ;
  goekblomster_nn_1_1_N : N ;
  goedselmedel_nn_1_1_N : N ;
  goedningsmedel_nn_1_1_N : N ;
  goeddjur_nn_1_1_N : N ;
  gaavobrev_nn_1_1_N : N ;
  gaavoavtal_nn_1_1_N : N ;
  gaasaegg_nn_1_1_N : N ;
  gaangjaern_nn_1_1_N : N ;
  gaanghjaelpmedel_nn_1_1_N : N ;
  gaangbord_nn_1_1_N : N ;
  gaangavstaand_nn_1_1_N : N ;
  gaahjaelpmedel_nn_1_1_N : N ;
  gaestabud_nn_1_1_N : N ;
  gaesp_nn_1_1_N : N ;
  gaengverktyg_nn_1_1_N : N ;
  gaengstaal_nn_1_1_N : N ;
  gaengkrig_nn_1_1_N : N ;
  gaeng_nn_1_1_N : N ;
  gaelblad_nn_1_1_N : N ;
  gaeddhaeng_nn_1_1_N : N ;
  gyttjebad_nn_1_N : N ;
  gyroskop_nn_1_N : N ;
  gymnastikredskap_nn_1_N : N ;
  gymnastikhopp_nn_1_N : N ;
  gymnasieval_nn_1_N : N ;
  gymkort_nn_1_N : N ;
  gyllental_nn_1_N : N ;
  gyllen_nn_1_N : N ;
  guvernement_nn_1_N : N ;
  gupp_nn_1_N : N ;
  gummiskydd_nn_1_N : N ;
  gummimaterial_nn_1_N : N ;
  gummihjul_nn_1_N : N ;
  gummidaeck_nn_1_1_N : N ;
  gummiband_nn_1_N : N ;
  gull_nn_1_N : N ;
  gulfilter_nn_1_N : N ;
  guldsnitt_nn_1_N : N ;
  guldprov_nn_1_N : N ;
  guldmynt_nn_1_N : N ;
  guldkorn_nn_1_N : N ;
  guldfoeremaal_nn_1_1_N : N ;
  guldfynd_nn_1_N : N ;
  guldbaer_nn_1_1_N : N ;
  guldbroellop_nn_1_1_N : N ;
  guld_nn_1_N : N ;
  gudsord_nn_1_N : N ;
  gudslaan_nn_1_1_N : N ;
  gudbarn_nn_1_N : N ;
  gubbskaegg_nn_1_1_N : N ;
  groetomslag_nn_1_1_N : N ;
  groensaksstaand_nn_1_1_N : N ;
  graavaedersmoln_nn_1_1_N : N ;
  graavaeder_nn_1_1_N : N ;
  graaskaegg_nn_1_1_N : N ;
  graapaeron_nn_1_1_N : N ;
  graabroedrakonvent_nn_1_1_N : N ;
  graevsvin_nn_1_1_N : N ;
  graevschakt_nn_1_1_N : N ;
  graevlingshaar_nn_1_1_N : N ;
  graevlingsgryt_nn_1_1_N : N ;
  graenssnitt_nn_1_1_N : N ;
  graensskikt_nn_1_1_N : N ;
  graensfall_nn_1_1_N : N ;
  graensbraak_nn_1_1_N : N ;
  graen_nn_1_1_N : N ;
  grael_nn_1_1_N : N ;
  grytskaap_nn_1_1_N : N ;
  grytlock_nn_1_N : N ;
  gryt_nn_1_N : N ;
  gruvschakt_nn_1_N : N ;
  gruvhaal_nn_1_1_N : N ;
  gruvfaelt_nn_1_1_N : N ;
  gruvbolag_nn_1_N : N ;
  grustag_nn_1_N : N ;
  gruppsamtal_nn_1_N : N ;
  gruppkorsband_nn_1_N : N ;
  grundvillkor_nn_1_N : N ;
  grundtillstaand_nn_1_1_N : N ;
  grundtal_nn_1_N : N ;
  grundspraak_nn_1_1_N : N ;
  grundskott_nn_1_N : N ;
  grundskolebarn_nn_1_N : N ;
  grundord_nn_1_N : N ;
  grundmaatt_nn_1_1_N : N ;
  grundlagsbrott_nn_1_N : N ;
  grundlag_nn_2_N : N ;
  grundhav_nn_1_N : N ;
  grundelement_nn_1_N : N ;
  grunddrag_nn_1_N : N ;
  grundbrott_nn_1_N : N ;
  grundbelopp_nn_1_N : N ;
  grundbegrepp_nn_1_N : N ;
  grundavdrag_nn_1_N : N ;
  grundackord_nn_1_N : N ;
  grund_nn_2_N : N ;
  gruff_nn_1_N : N ;
  grovkoek_nn_1_1_N : N ;
  grovbruk_nn_1_N : N ;
  grodaegg_nn_1_1_N : N ;
  grodlaar_nn_1_1_N : N ;
  groddjur_nn_1_N : N ;
  groddblad_nn_1_N : N ;
  groblad_nn_1_N : N ;
  grindbeslag_nn_1_N : N ;
  grin_nn_1_N : N ;
  grimskaft_nn_1_N : N ;
  grillspett_nn_1_N : N ;
  griftetal_nn_1_N : N ;
  grevskap_nn_1_N : N ;
  grepp_nn_1_N : N ;
  grenveck_nn_1_N : N ;
  grenuttag_nn_1_N : N ;
  grenhopp_nn_1_N : N ;
  gravoel_nn_1_1_N : N ;
  gravvalv_nn_1_N : N ;
  gravtal_nn_1_N : N ;
  gravskick_nn_1_N : N ;
  gravmonument_nn_1_N : N ;
  gravmaterial_nn_1_N : N ;
  gravkor_nn_1_N : N ;
  gravkapell_nn_1_N : N ;
  gravfaelt_nn_1_1_N : N ;
  gravfynd_nn_1_N : N ;
  gravbrev_nn_1_N : N ;
  gratulationskort_nn_1_N : N ;
  gratulationsbrev_nn_1_N : N ;
  gratisskjut_nn_1_N : N ;
  granulat_nn_1_N : N ;
  granskningsexemplar_nn_1_N : N ;
  grannskap_nn_1_N : N ;
  granbarr_nn_1_N : N ;
  granatgevaer_nn_1_1_N : N ;
  gran_nn_2_N : N ;
  grammofonstift_nn_1_N : N ;
  grahamsbroed_nn_1_1_N : N ;
  gradtal_nn_1_N : N ;
  gradstreck_nn_1_N : N ;
  gradnaet_nn_1_1_N : N ;
  graderverk_nn_1_N : N ;
  grabbatag_nn_1_N : N ;
  gossebarn_nn_1_N : N ;
  goraan_nn_1_1_N : N ;
  gomljud_nn_1_N : N ;
  gomben_nn_1_N : N ;
  golvur_nn_1_N : N ;
  golvskyddspapper_nn_1_N : N ;
  golv_nn_1_N : N ;
  godtrosfoervaerv_nn_1_1_N : N ;
  godstaag_nn_1_1_N : N ;
  godsmagasin_nn_1_N : N ;
  godmanskap_nn_1_N : N ;
  gnistskydd_nn_1_N : N ;
  gnistgap_nn_1_N : N ;
  gnistgaller_nn_1_N : N ;
  gnisselljud_nn_1_N : N ;
  gnabb_nn_1_N : N ;
  glaapord_nn_1_1_N : N ;
  glaedjespraang_nn_1_1_N : N ;
  glaedjerop_nn_1_1_N : N ;
  glaedjebudskap_nn_1_1_N : N ;
  glaedjebud_nn_1_1_N : N ;
  glaedjebetyg_nn_1_1_N : N ;
  glaedjebesked_nn_1_1_N : N ;
  glyptotek_nn_1_N : N ;
  gliom_nn_1_N : N ;
  glinder_nn_1_N : N ;
  glidmedel_nn_1_N : N ;
  glidljud_nn_1_N : N ;
  glidlager_nn_1_N : N ;
  glid_nn_1_N : N ;
  glasoegonfodral_nn_1_1_N : N ;
  glassrecept_nn_1_N : N ;
  glasskaap_nn_1_1_N : N ;
  glasroer_nn_1_1_N : N ;
  glasklot_nn_1_N : N ;
  glasfoeremaal_nn_1_1_N : N ;
  glasbruk_nn_1_N : N ;
  glasberg_nn_1_N : N ;
  glapp_nn_1_N : N ;
  glanspapper_nn_1_N : N ;
  glansnummer_nn_1_N : N ;
  glad_nn_1_N : N ;
  givkort_nn_1_N : N ;
  gitter_nn_1_N : N ;
  gisselslag_nn_1_N : N ;
  gisseldjur_nn_1_N : N ;
  girobesked_nn_1_N : N ;
  gipstak_nn_1_N : N ;
  gipsfoerband_nn_1_1_N : N ;
  ginnungagap_nn_1_N : N ;
  giller_nn_1_N : N ;
  gig_nn_1_N : N ;
  giftutslaepp_nn_1_1_N : N ;
  giftpiller_nn_1_N : N ;
  giftmord_nn_1_N : N ;
  giftmoln_nn_1_N : N ;
  giftermaal_nn_1_1_N : N ;
  gevaersskott_nn_1_1_N : N ;
  gevaer_nn_1_1_N : N ;
  getskaegg_nn_1_1_N : N ;
  getskinn_nn_1_N : N ;
  getingstick_nn_1_N : N ;
  gesaellprov_nn_1_1_N : N ;
  gesaellbrev_nn_1_1_N : N ;
  geschaeft_nn_1_1_N : N ;
  germanfolk_nn_1_N : N ;
  gerillakrig_nn_1_N : N ;
  gerilladaad_nn_1_1_N : N ;
  gentlemannabeslut_nn_1_N : N ;
  genrep_nn_1_N : N ;
  genomtaag_nn_1_1_N : N ;
  genomsnitt_nn_1_N : N ;
  genomslagspapper_nn_1_N : N ;
  genomslag_nn_1_N : N ;
  genombrott_nn_1_N : N ;
  genom_nn_1_N : N ;
  genitivattribut_nn_1_N : N ;
  generalrep_nn_1_N : N ;
  generalkonsulat_nn_1_N : N ;
  generalangrepp_nn_1_N : N ;
  gemyt_nn_1_N : N ;
  gemak_nn_1_N : N ;
  gem_nn_2_N : N ;
  gel_ehallon_nn_1_1_N : N ;
  geiger_mullerroer_nn_1_1_N : N ;
  gehaeng_nn_1_1_N : N ;
  geheimeraad_nn_1_1_N : N ;
  gebit_nn_1_N : N ;
  gavelfaelt_nn_1_1_N : N ;
  gatustaand_nn_1_1_N : N ;
  gatuplan_nn_1_N : N ;
  gatunamn_nn_1_N : N ;
  gatuliv_nn_1_N : N ;
  gatukoek_nn_1_1_N : N ;
  gatukontor_nn_1_N : N ;
  gatubarn_nn_1_N : N ;
  gatt_nn_1_N : N ;
  gatlopp_nn_1_N : N ;
  gathoern_nn_1_1_N : N ;
  gasverk_nn_1_N : N ;
  gasutslaepp_nn_1_1_N : N ;
  gastryck_nn_1_N : N ;
  gastroskop_nn_1_N : N ;
  gasskydd_nn_1_N : N ;
  gasolkoek_nn_1_1_N : N ;
  gasmoln_nn_1_N : N ;
  gasmaskfodral_nn_1_N : N ;
  gaskoek_nn_1_1_N : N ;
  gasklot_nn_1_N : N ;
  garvmedel_nn_1_N : N ;
  garv_nn_1_N : N ;
  garnityr_nn_1_N : N ;
  gardjaern_nn_1_1_N : N ;
  gardinband_nn_1_N : N ;
  garantilaan_nn_1_1_N : N ;
  garantifoerdrag_nn_1_1_N : N ;
  garantibelopp_nn_1_N : N ;
  gapskratt_nn_1_N : N ;
  gapflabb_nn_1_N : N ;
  gap_nn_1_N : N ;
  galvanoskop_nn_1_N : N ;
  galltjut_nn_1_N : N ;
  gallskrik_nn_1_N : N ;
  gallkvalster_nn_1_N : N ;
  gallerverk_nn_1_N : N ;
  gallerstaket_nn_1_N : N ;
  gallerfoenster_nn_1_1_N : N ;
  galler_nn_1_N : N ;
  foeraeldrabesoek_nn_1_1_N : N ;
  foervaervsavdrag_nn_1_1_N : N ;
  foervaerv_nn_1_1_N : N ;
  foervaringsskaap_nn_1_1_N : N ;
  foervaringskaerl_nn_1_1_N : N ;
  foervandlingsstraff_nn_1_1_N : N ;
  foervandlingsnummer_nn_1_1_N : N ;
  foervaltningsutskott_nn_1_1_N : N ;
  foervaltningsbolag_nn_1_1_N : N ;
  foervaltningsbeslut_nn_1_1_N : N ;
  foerundersoekningsprotokoll_nn_1_1_N : N ;
  foertroendeuppdrag_nn_1_1_N : N ;
  foertroenderaad_nn_1_1_N : N ;
  foertroendeglapp_nn_1_1_N : N ;
  foertalsmaal_nn_1_1_N : N ;
  foersoerjningsprojekt_nn_1_1_N : N ;
  foersoeksobjekt_nn_1_1_N : N ;
  foersoeksheat_nn_1_1_N : N ;
  foersoeksdjur_nn_1_1_N : N ;
  foersoek_nn_1_1_N : N ;
  foersaat_nn_1_1_N : N ;
  foersaettsblad_nn_1_1_N : N ;
  foersaeljningsstaand_nn_1_1_N : N ;
  foersaeljningsstopp_nn_1_1_N : N ;
  foersaekringsvillkor_nn_1_1_N : N ;
  foersaekringsskydd_nn_1_1_N : N ;
  foersaekringsinslag_nn_1_1_N : N ;
  foersaekringsbrev_nn_1_1_N : N ;
  foersaekringsbolagskontor_nn_1_1_N : N ;
  foersaekringsbolag_nn_1_1_N : N ;
  foersaekringsbesked_nn_1_1_N : N ;
  foersvarsverk_nn_1_1_N : N ;
  foersvarsutskott_nn_1_1_N : N ;
  foersvarstal_nn_1_1_N : N ;
  foersvarsraster_nn_1_1_N : N ;
  foersvarskrig_nn_1_1_N : N ;
  foersvarsdepartement_nn_1_1_N : N ;
  foerstoerelseverk_nn_1_1_N : N ;
  foerstaandshandikapp_nn_1_1_N : N ;
  foerstaerkningsord_nn_1_1_N : N ;
  foerstoppningsbesvaer_nn_1_1_N : N ;
  foersteg_nn_1_1_N : N ;
  foerstaslag_nn_1_1_N : N ;
  foerstanamn_nn_1_1_N : N ;
  foerstamajtaag_nn_1_1_N : N ;
  foerstamajtal_nn_1_1_N : N ;
  foerstaklasshotell_nn_1_1_N : N ;
  foerstag_nn_1_1_N : N ;
  foerstadagsbrev_nn_1_1_N : N ;
  foersoningsknull_nn_1_1_N : N ;
  foerslag_2_nn_1_1_N : N ;
  foerslag_nn_1_1_N : N ;
  foerskott_nn_1_1_N : N ;
  foerskinn_nn_1_1_N : N ;
  foerskepp_nn_1_1_N : N ;
  foersiktighetsmaatt_nn_1_1_N : N ;
  foersamlingsraad_nn_1_1_N : N ;
  foerraad_nn_1_1_N : N ;
  foerord_nn_1_1_N : N ;
  foernuftsskael_nn_1_1_N : N ;
  foernedringstillstaand_nn_1_1_N : N ;
  foernamn_nn_1_1_N : N ;
  foermoegenhetsbrott_nn_1_1_N : N ;
  foermyndarskap_nn_1_1_N : N ;
  foermaningstal_nn_1_1_N : N ;
  foermak_nn_1_1_N : N ;
  foerlaengningsskaft_nn_1_1_N : N ;
  foerlaengningsroer_nn_1_1_N : N ;
  foerlustaar_nn_1_1_N : N ;
  foerlorargaeng_nn_1_1_N : N ;
  foerlopp_nn_1_1_N : N ;
  foerlagslaan_nn_1_1_N : N ;
  foerlag_2_nn_1_1_N : N ;
  foerlag_nn_1_1_N : N ;
  foerkoep_nn_1_1_N : N ;
  foerhoersprotokoll_nn_1_1_N : N ;
  foerhoer_nn_1_1_N : N ;
  foerhaallningssaett_nn_1_1_N : N ;
  foerhaall_nn_1_1_N : N ;
  foerhinder_nn_1_1_N : N ;
  foerhandlingstrick_nn_1_1_N : N ;
  foerhandlingsbord_nn_1_1_N : N ;
  foerhalningsfoersoek_nn_1_1_N : N ;
  foerfattarportraett_nn_1_1_N : N ;
  foerfattarjag_nn_1_1_N : N ;
  foerfaringssaett_nn_1_1_N : N ;
  foerfalskningsbrott_nn_1_1_N : N ;
  foeretal_nn_1_1_N : N ;
  foeretag_nn_1_1_N : N ;
  foerestaellningssaett_nn_1_1_N : N ;
  foereningsband_nn_1_1_N : N ;
  foeremaal_nn_1_1_N : N ;
  foeredrag_nn_1_1_N : N ;
  foerebud_nn_1_1_N : N ;
  foerdaeck_nn_1_1_N : N ;
  foerdragsbrott_nn_1_1_N : N ;
  foerdrag_nn_1_1_N : N ;
  foerbaettringslaan_nn_1_1_N : N ;
  foerbundsbrev_nn_1_1_N : N ;
  foerbund_nn_1_1_N : N ;
  foerbudslag_nn_1_1_N : N ;
  foerbud_nn_1_1_N : N ;
  foerbrukningsmaterial_nn_1_1_N : N ;
  foerbindelsemedel_nn_1_1_N : N ;
  foerberg_nn_1_1_N : N ;
  foerbehaall_nn_1_1_N : N ;
  foerband_2_nn_1_1_N : N ;
  foerband_nn_1_1_N : N ;
  foensterkuvert_nn_1_1_N : N ;
  foensterkitt_nn_1_1_N : N ;
  foenstergaller_nn_1_1_N : N ;
  foensterbord_nn_1_1_N : N ;
  foensterbleck_nn_1_1_N : N ;
  foensterbeslag_nn_1_1_N : N ;
  foenster_nn_1_1_N : N ;
  foeljebrev_nn_1_1_N : N ;
  foel_nn_1_1_N : N ;
  foedslotal_nn_1_1_N : N ;
  foedseltal_nn_1_1_N : N ;
  foedoraad_nn_1_1_N : N ;
  foedelseaar_nn_1_1_N : N ;
  foedelsetal_nn_1_1_N : N ;
  foedelsenummer_nn_1_1_N : N ;
  foedelsedagsbarn_nn_1_1_N : N ;
  faatal_nn_1_1_N : N ;
  faarskinn_nn_1_1_N : N ;
  faar_nn_1_1_N : N ;
  faanskratt_nn_1_1_N : N ;
  faanguppror_nn_1_1_N : N ;
  faangstredskap_nn_1_1_N : N ;
  faangstfolk_nn_1_1_N : N ;
  faangstfartyg_nn_1_1_N : N ;
  faanglaeger_nn_1_1_N : N ;
  faang_nn_1_1_N : N ;
  faan_nn_1_1_N : N ;
  faamansfoeretag_nn_1_1_N : N ;
  faagelaegg_nn_1_1_N : N ;
  faagelstraeck_nn_1_1_N : N ;
  faageldun_nn_1_1_N : N ;
  faagelbaer_nn_1_1_N : N ;
  faagelbord_nn_1_1_N : N ;
  faagelbad_nn_1_1_N : N ;
  faestjaern_nn_1_1_N : N ;
  faestefolk_nn_1_1_N : N ;
  faergtryck_nn_1_1_N : N ;
  faergpigment_nn_1_1_N : N ;
  faergmoenster_nn_1_1_N : N ;
  faergfilter_nn_1_1_N : N ;
  faergband_nn_1_1_N : N ;
  faergbad_nn_1_1_N : N ;
  faerdmedel_nn_1_1_N : N ;
  faenghaal_nn_1_1_N : N ;
  faengelsestraff_nn_1_1_N : N ;
  faengelsegaller_nn_1_1_N : N ;
  faelttaag_nn_1_1_N : N ;
  faeltslag_nn_1_1_N : N ;
  faeltrop_nn_1_1_N : N ;
  faeltpostkort_nn_1_1_N : N ;
  faeltkoek_nn_1_1_N : N ;
  faeltfoersoek_nn_1_1_N : N ;
  faelt_nn_1_1_N : N ;
  faellbord_nn_1_1_N : N ;
  faedernearv_nn_1_1_N : N ;
  fyrtorn_nn_1_N : N ;
  fyrtal_nn_1_N : N ;
  fyrspann_nn_1_N : N ;
  fyrskepp_nn_1_N : N ;
  fyrradskorn_nn_1_N : N ;
  fyrop_nn_1_N : N ;
  fyrfaergstryck_nn_1_1_N : N ;
  fyrfotadjur_nn_1_N : N ;
  fyrfat_nn_1_N : N ;
  fynd_nn_1_N : N ;
  fyllnadsval_nn_1_N : N ;
  fylleslag_nn_1_N : N ;
  fyllebraak_nn_1_1_N : N ;
  fuskverk_nn_1_N : N ;
  furugolv_nn_1_N : N ;
  funktionssaett_nn_1_1_N : N ;
  funktionshinder_nn_1_N : N ;
  fundament_nn_1_N : N ;
  fullkornsbroed_nn_1_1_N : N ;
  fullblod_nn_1_N : N ;
  fuffens_nn_1_N : N ;
  froeskal_nn_1_1_N : N ;
  fraageord_nn_1_1_N : N ;
  fraageformulaer_nn_1_1_N : N ;
  fraesstaal_nn_1_1_N : N ;
  fraelsehemman_nn_1_1_N : N ;
  frysfoersoek_nn_1_1_N : N ;
  frysfack_nn_1_N : N ;
  fruntimmer_nn_1_N : N ;
  frukostaegg_nn_1_1_N : N ;
  frukostbord_nn_1_N : N ;
  frontavsnitt_nn_1_N : N ;
  frontalangrepp_nn_1_N : N ;
  friaar_nn_1_1_N : N ;
  fritagningsfoersoek_nn_1_1_N : N ;
  frislag_nn_1_N : N ;
  friskluftsintag_nn_1_N : N ;
  friskintyg_nn_1_N : N ;
  friluftsaendamaal_nn_1_1_N : N ;
  friluftsbad_nn_1_N : N ;
  frilansvillkor_nn_1_N : N ;
  friland_nn_1_N : N ;
  frikoep_nn_1_1_N : N ;
  friktionstal_nn_1_N : N ;
  frikort_nn_1_N : N ;
  friidrottslandslag_nn_1_N : N ;
  frihjul_nn_1_N : N ;
  frihetsstraff_nn_1_N : N ;
  frihetskrig_nn_1_N : N ;
  frihetsbrev_nn_1_N : N ;
  frigivningsvillkor_nn_1_N : N ;
  friexemplar_nn_1_N : N ;
  fribrev_nn_1_N : N ;
  fribord_nn_1_N : N ;
  friarbrev_nn_1_N : N ;
  frekvensband_nn_1_N : N ;
  fredsvillkor_nn_1_N : N ;
  fredsuppdrag_nn_1_N : N ;
  fredsslut_nn_1_N : N ;
  fredssamtal_nn_1_N : N ;
  fredsprisval_nn_1_N : N ;
  fredsfoerslag_nn_1_1_N : N ;
  fredsfoerdrag_nn_1_1_N : N ;
  fredsbrott_nn_1_N : N ;
  fredsavtal_nn_1_N : N ;
  frasnaet_nn_1_1_N : N ;
  franskbroed_nn_1_1_N : N ;
  franciskanerkloster_nn_1_N : N ;
  framtidsmaal_nn_1_1_N : N ;
  framstaellningssaett_nn_1_1_N : N ;
  framsteg_nn_1_N : N ;
  framhjul_nn_1_N : N ;
  framgaangsrecept_nn_1_1_N : N ;
  framgaangskoncept_nn_1_1_N : N ;
  framfall_nn_1_N : N ;
  framben_nn_1_N : N ;
  fraktbolag_nn_1_N : N ;
  fraktavtal_nn_1_N : N ;
  fragment_nn_1_N : N ;
  fotvalv_nn_1_N : N ;
  fotstoed_nn_1_1_N : N ;
  fotsteg_nn_1_N : N ;
  fotspaar_nn_1_1_N : N ;
  fotogenkoek_nn_1_1_N : N ;
  fotbollsstadion_nn_1_N : N ;
  fotbollsmaal_nn_1_1_N : N ;
  fotbollslag_nn_1_N : N ;
  fotbollskrig_nn_1_N : N ;
  fotbollsfoerbund_nn_1_1_N : N ;
  fotbollsbraak_nn_1_1_N : N ;
  fotbollfoerbund_nn_1_1_N : N ;
  fotblad_nn_1_N : N ;
  fotbad_nn_1_N : N ;
  fotavtryck_nn_1_N : N ;
  fosterljud_nn_1_N : N ;
  fosterbarn_nn_1_N : N ;
  foster_nn_1_N : N ;
  fostbroedralag_nn_1_1_N : N ;
  fossilgasnaet_nn_1_1_N : N ;
  fossilfynd_nn_1_N : N ;
  fortskaffningsmedel_nn_1_N : N ;
  fortplantningsorgan_nn_1_N : N ;
  fort_nn_1_N : N ;
  forskningsroen_nn_1_1_N : N ;
  forskningsraad_nn_1_1_N : N ;
  forskningsresultat_nn_1_N : N ;
  forskningsprojekt_nn_1_N : N ;
  forskningsinstitut_nn_1_N : N ;
  forskningsfaelt_nn_1_1_N : N ;
  forskningsframsteg_nn_1_N : N ;
  forskningsfartyg_nn_1_N : N ;
  forskarlag_nn_1_N : N ;
  fornminnesbrott_nn_1_N : N ;
  fornfynd_nn_1_N : N ;
  fornfolk_nn_1_N : N ;
  formulaer_nn_1_1_N : N ;
  formspraak_nn_1_1_N : N ;
  formord_nn_1_N : N ;
  formbroed_nn_1_1_N : N ;
  format_nn_1_N : N ;
  fordon_nn_1_N : N ;
  fonotek_nn_1_N : N ;
  fondpapper_nn_1_N : N ;
  fondbolag_nn_1_N : N ;
  folkuniversitet_nn_1_N : N ;
  folkting_nn_1_N : N ;
  folkspraak_nn_1_1_N : N ;
  folkslag_nn_1_N : N ;
  folkmaal_nn_1_1_N : N ;
  folkmord_nn_1_N : N ;
  folklager_nn_1_N : N ;
  folkkoek_nn_1_1_N : N ;
  folketing_nn_1_N : N ;
  folkdjup_nn_1_N : N ;
  folkbibliotek_nn_1_N : N ;
  folk_nn_1_N : N ;
  folioformat_nn_1_N : N ;
  fokalplan_nn_1_N : N ;
  fogeord_nn_1_N : N ;
  fodral_nn_1_N : N ;
  foderblad_nn_1_N : N ;
  foder_nn_1_N : N ;
  flaetverk_nn_1_1_N : N ;
  flaederbaer_nn_1_1_N : N ;
  flaeckborttagningsmedel_nn_1_1_N : N ;
  flyttblock_nn_1_N : N ;
  flytetyg_nn_1_N : N ;
  flyktinglaeger_nn_1_1_N : N ;
  flyktingbarn_nn_1_N : N ;
  flyktfoersoek_nn_1_1_N : N ;
  flygstopp_nn_1_N : N ;
  flygsandsfaelt_nn_1_1_N : N ;
  flygplansroder_nn_1_N : N ;
  flygplan_nn_1_N : N ;
  flyglarm_nn_1_N : N ;
  flygfoerbud_nn_1_1_N : N ;
  flygfoerband_nn_1_1_N : N ;
  flygfaelt_nn_1_1_N : N ;
  flygcertifikat_nn_1_N : N ;
  flygbolag_nn_1_N : N ;
  flygblad_nn_1_N : N ;
  flyganfall_nn_1_N : N ;
  flyg_nn_1_N : N ;
  fluster_nn_1_N : N ;
  flussmedel_nn_1_N : N ;
  flugpapper_nn_1_N : N ;
  flugblomster_nn_1_N : N ;
  flottningstimmer_nn_1_N : N ;
  flottbesoek_nn_1_1_N : N ;
  flor_nn_1_N : N ;
  flodsvin_nn_1_N : N ;
  flockdjur_nn_1_N : N ;
  flintlaasgevaer_nn_1_1_N : N ;
  flin_nn_1_N : N ;
  flimmerhaar_nn_1_1_N : N ;
  flicknamn_nn_1_N : N ;
  flickebarn_nn_1_N : N ;
  flerhandikapp_nn_1_N : N ;
  flerfaergstryck_nn_1_1_N : N ;
  fleece_foder_nn_1_N : N ;
  flatskratt_nn_1_N : N ;
  flatgarv_nn_1_N : N ;
  flatbroed_nn_1_1_N : N ;
  flaskhaal_nn_1_1_N : N ;
  flaskbarn_nn_1_N : N ;
  flarn_nn_1_N : N ;
  flankanfall_nn_1_N : N ;
  flamskyddsmedel_nn_1_N : N ;
  flak_nn_1_N : N ;
  flaggskepp_nn_1_N : N ;
  flabb_nn_2_N : N ;
  fjaet_nn_1_1_N : N ;
  fjaerrtaag_nn_1_1_N : N ;
  fjaelster_nn_1_1_N : N ;
  fjaellpansar_nn_1_1_N : N ;
  fjaellandskap_nn_1_1_N : N ;
  fjaell_nn_1_1_N : N ;
  fjaedermoln_nn_1_1_N : N ;
  fjaederluftgevaer_nn_1_1_N : N ;
  fjun_nn_1_N : N ;
  fjolaar_nn_1_1_N : N ;
  fixerbad_nn_1_N : N ;
  fiskredskap_nn_1_N : N ;
  fisknaet_nn_1_1_N : N ;
  fiskhalster_nn_1_N : N ;
  fiskeredskap_nn_1_N : N ;
  fiskenaet_nn_1_1_N : N ;
  fiskekort_nn_1_N : N ;
  fiskefartyg_nn_1_N : N ;
  fiskedrag_nn_1_N : N ;
  fiskedon_nn_1_N : N ;
  fiskbensmoenster_nn_1_1_N : N ;
  fiskben_nn_1_N : N ;
  firmanamn_nn_1_N : N ;
  fiolblock_nn_1_N : N ;
  finskaap_nn_1_1_N : N ;
  finlir_nn_1_N : N ;
  fingerprov_nn_1_N : N ;
  fingeravtryck_nn_1_N : N ;
  finbruk_nn_1_N : N ;
  finansutskott_nn_1_N : N ;
  finansdepartement_nn_1_N : N ;
  filtrerpapper_nn_1_N : N ;
  filtrat_nn_1_N : N ;
  filter_nn_1_N : N ;
  filspaan_nn_1_1_N : N ;
  filmotek_nn_1_N : N ;
  filmmanuskript_nn_1_N : N ;
  filmklipp_nn_1_N : N ;
  filmavsnitt_nn_1_N : N ;
  filialkontor_nn_1_N : N ;
  filhandtag_nn_1_N : N ;
  fikonspraak_nn_1_1_N : N ;
  fikonloev_nn_1_1_N : N ;
  fikon_nn_1_N : N ;
  fik_nn_1_N : N ;
  fickur_nn_1_N : N ;
  ficklock_nn_1_N : N ;
  fickformat_nn_1_N : N ;
  fettsvansfaar_nn_1_1_N : N ;
  fetblad_nn_1_N : N ;
  festtaag_nn_1_1_N : N ;
  festtal_nn_1_N : N ;
  festbord_nn_1_N : N ;
  ferment_nn_1_N : N ;
  fenomen_nn_1_N : N ;
  femtonaarsstraff_nn_1_1_N : N ;
  femtonhundrameterslopp_nn_1_N : N ;
  femtital_nn_1_N : N ;
  femtiotal_nn_1_N : N ;
  femtal_nn_1_N : N ;
  femkronorsmynt_nn_1_N : N ;
  femfilmskontrakt_nn_1_N : N ;
  felval_nn_1_N : N ;
  feltaenk_nn_1_1_N : N ;
  felsteg_nn_1_N : N ;
  felslut_nn_1_N : N ;
  felgrepp_nn_1_N : N ;
  feldrag_nn_1_N : N ;
  fel_nn_1_N : N ;
  feberanfall_nn_1_N : N ;
  favoritknep_nn_1_N : N ;
  favorithak_nn_1_N : N ;
  favoritfik_nn_1_N : N ;
  fattighjon_nn_1_N : N ;
  fattigdomsstreck_nn_1_N : N ;
  fattigbarn_nn_1_N : N ;
  fat_nn_1_N : N ;
  fastighetslaan_nn_1_1_N : N ;
  fastighetskoep_nn_1_1_N : N ;
  fastighetskontor_nn_1_N : N ;
  fastebrev_nn_1_N : N ;
  farvael_nn_1_1_N : N ;
  fartygsvrak_nn_1_N : N ;
  fartygsskrov_nn_1_N : N ;
  fartygsdaeck_nn_1_1_N : N ;
  fartyg_nn_1_N : N ;
  farthinder_nn_1_N : N ;
  farsarv_nn_1_N : N ;
  fantasiliv_nn_1_N : N ;
  fantasifoster_nn_1_N : N ;
  fantasidjur_nn_1_N : N ;
  fanstyg_nn_1_N : N ;
  fanskap_nn_1_N : N ;
  fan_nn_3_N : N ;
  famntag_nn_1_N : N ;
  familjenamn_nn_1_N : N ;
  familjejordbruk_nn_1_N : N ;
  familjeideal_nn_1_N : N ;
  familjehotell_nn_1_N : N ;
  familjefoeretag_nn_1_1_N : N ;
  familjebolag_nn_1_N : N ;
  familjebidrag_nn_1_N : N ;
  familjeband_nn_1_N : N ;
  falsifikat_nn_1_N : N ;
  fallverk_nn_1_N : N ;
  fallskaermstrick_nn_1_1_N : N ;
  fallrep_nn_1_N : N ;
  fallissemang_nn_1_N : N ;
  fall_nn_1_N : N ;
  faktotum_nn_1_N : N ;
  faksimil_nn_1_N : N ;
  fadervaar_nn_1_1_N : N ;
  fadersnamn_nn_1_N : N ;
  fadersarv_nn_1_N : N ;
  fadermord_nn_1_N : N ;
  fadderbarn_nn_1_N : N ;
  fackverk_nn_1_N : N ;
  fackspraak_nn_1_1_N : N ;
  fackorgan_nn_1_N : N ;
  fackfoerbund_nn_1_1_N : N ;
  fackeltaag_nn_1_1_N : N ;
  fackelblomster_nn_1_N : N ;
  fack_nn_1_N : N ;
  fabrikat_nn_1_N : N ;
  fabeldjur_nn_1_N : N ;
  f_nn_1_N : N ;
  extremvaeder_nn_1_1_N : N ;
  extremfall_nn_1_N : N ;
  extrataag_nn_1_1_N : N ;
  extranummer_nn_1_N : N ;
  extraknaeck_nn_1_1_N : N ;
  externat_nn_1_N : N ;
  exsudat_nn_1_N : N ;
  exsickat_nn_1_N : N ;
  expresstaag_nn_1_1_N : N ;
  expressbud_nn_1_N : N ;
  expressbrev_nn_1_N : N ;
  exportbolag_nn_1_N : N ;
  explosionsoegonblick_nn_1_1_N : N ;
  explosionssaett_nn_1_1_N : N ;
  explosionsfoerlopp_nn_1_1_N : N ;
  expertspraak_nn_1_1_N : N ;
  experimentfaelt_nn_1_1_N : N ;
  experiment_nn_1_N : N ;
  expansionskaerl_nn_1_1_N : N ;
  exkret_nn_1_N : N ;
  existensvillkor_nn_1_N : N ;
  existensmedel_nn_1_N : N ;
  exemplar_nn_1_N : N ;
  evighetsfilter_nn_1_N : N ;
  evenemang_nn_1_N : N ;
  europamaesterskap_nn_1_1_N : N ;
  etsmedel_nn_1_N : N ;
  etikettraad_nn_1_1_N : N ;
  etermediemonopol_nn_1_N : N ;
  etablissement_nn_1_N : N ;
  etablissemang_nn_1_N : N ;
  estradsamtal_nn_1_N : N ;
  eroevringstaag_nn_1_1_N : N ;
  ersaettningsbelopp_nn_1_1_N : N ;
  ersaettningsanspraak_nn_1_1_N : N ;
  ergativsubjekt_nn_1_N : N ;
  epostbrev_nn_1_N : N ;
  epitet_nn_1_N : N ;
  episkopat_nn_1_N : N ;
  episkop_nn_1_N : N ;
  enzymtvaettmedel_nn_1_1_N : N ;
  entreprenoerskap_nn_1_1_N : N ;
  ental_nn_1_N : N ;
  ensamhushaall_nn_1_1_N : N ;
  enkaetsvar_nn_1_1_N : N ;
  enkomponentskitt_nn_1_N : N ;
  enjambemang_nn_1_N : N ;
  enhetsmaatt_nn_1_1_N : N ;
  enhetsflygplan_nn_1_N : N ;
  engaangsligg_nn_1_1_N : N ;
  engagemang_nn_1_N : N ;
  energiverk_nn_1_N : N ;
  energitillstaand_nn_1_1_N : N ;
  energiintag_nn_1_N : N ;
  energiinnehaall_nn_1_1_N : N ;
  energidepartement_nn_1_N : N ;
  energibehov_nn_1_N : N ;
  endossement_nn_1_N : N ;
  endossemang_nn_1_N : N ;
  endagsbesoek_nn_1_1_N : N ;
  enbaer_nn_1_1_N : N ;
  enbet_nn_1_N : N ;
  email_nn_2_N : N ;
  elverk_nn_1_N : N ;
  elvamannalag_nn_1_N : N ;
  eluttag_nn_1_N : N ;
  elnaet_nn_1_1_N : N ;
  ellok_nn_1_N : N ;
  elljusspaar_nn_1_1_N : N ;
  elkraftsaggregat_nn_1_N : N ;
  elixir_nn_1_N : N ;
  elittaenk_nn_1_1_N : N ;
  elitfoerband_nn_1_1_N : N ;
  elfenbenstorn_nn_1_N : N ;
  elevunderlag_nn_1_N : N ;
  elevraad_nn_1_1_N : N ;
  elevfartyg_nn_1_N : N ;
  elementarlaeroverk_nn_1_1_N : N ;
  element_nn_1_N : N ;
  elektroskop_nn_1_N : N ;
  elektronskal_nn_1_N : N ;
  elektronroer_nn_1_1_N : N ;
  elektronpar_nn_1_N : N ;
  elektronmoln_nn_1_N : N ;
  elektronmikroskop_nn_1_N : N ;
  elektrofilter_nn_1_N : N ;
  elektricitetsverk_nn_1_N : N ;
  elefantupplopp_nn_1_N : N ;
  elefantinhopp_nn_1_N : N ;
  eldoeverfall_nn_1_1_N : N ;
  eldupphoer_nn_1_1_N : N ;
  eldstaal_nn_1_1_N : N ;
  eldsken_nn_1_N : N ;
  eldroer_nn_1_1_N : N ;
  eldredskap_nn_1_N : N ;
  eldprov_nn_1_N : N ;
  eldkol_nn_1_N : N ;
  elddop_nn_1_N : N ;
  elddon_nn_1_N : N ;
  eldavstaand_nn_1_1_N : N ;
  ekvatorsplan_nn_1_N : N ;
  ekorrdjur_nn_1_N : N ;
  ekorrbaer_nn_1_1_N : N ;
  ekonomipaket_nn_1_N : N ;
  ekonomibrev_nn_1_N : N ;
  ekolod_nn_1_N : N ;
  ekollon_nn_1_N : N ;
  ekobrott_nn_1_N : N ;
  ekloev_nn_1_1_N : N ;
  ekfat_nn_1_N : N ;
  ejderdun_nn_1_N : N ;
  ejakulat_nn_1_N : N ;
  eggverktyg_nn_1_N : N ;
  eggjaern_nn_1_1_N : N ;
  egenskapsord_nn_1_N : N ;
  egennamn_nn_1_N : N ;
  egendomsbrott_nn_1_N : N ;
  eftertryck_nn_1_N : N ;
  eftersaettsblad_nn_1_1_N : N ;
  efterstygn_nn_1_N : N ;
  efterslag_nn_1_N : N ;
  efterskott_nn_1_N : N ;
  efterord_nn_1_N : N ;
  efternamn_nn_1_N : N ;
  eftermiddagsjobb_nn_1_N : N ;
  efterkrav_nn_1_N : N ;
  effektivitetsargument_nn_1_N : N ;
  edsoeresbrott_nn_1_1_N : N ;
  edsbrott_nn_1_N : N ;
  edikt_nn_1_N : N ;
  ed_nn_2_N : N ;
  ecklesiastikdepartement_nn_1_N : N ;
  ebrev_nn_1_N : N ;
  e_postbrev_nn_1_N : N ;
  e_mail_nn_2_N : N ;
  e_brev_nn_1_N : N ;
  doerrvred_nn_1_1_N : N ;
  doerrhandtag_nn_1_1_N : N ;
  doerrblad_nn_1_1_N : N ;
  doedsaar_nn_1_1_N : N ;
  doedsur_nn_1_1_N : N ;
  doedstal_nn_1_1_N : N ;
  doedssaett_nn_1_1_N : N ;
  doedsstraff_nn_1_1_N : N ;
  doedsskott_nn_1_1_N : N ;
  doedsorsaksregister_nn_1_1_N : N ;
  doedskallefynd_nn_1_1_N : N ;
  doedshot_nn_1_1_N : N ;
  doedsfall_nn_1_1_N : N ;
  doedsbud_nn_1_1_N : N ;
  doedmansgrepp_nn_1_1_N : N ;
  daan_nn_1_1_N : N ;
  daad_nn_1_1_N : N ;
  daeggdjur_nn_1_1_N : N ;
  daecksmanskap_nn_1_1_N : N ;
  daeckjaern_nn_1_1_N : N ;
  daeck_nn_2_1_N : N ;
  daeck_nn_1_1_N : N ;
  dyrtidstillaegg_nn_1_1_N : N ;
  dynlandskap_nn_1_N : N ;
  dygn_nn_1_N : N ;
  dygdemoenster_nn_1_1_N : N ;
  dyblad_nn_1_N : N ;
  duvslag_nn_1_N : N ;
  dussintal_nn_1_N : N ;
  dussin_nn_1_N : N ;
  duschhandtag_nn_1_N : N ;
  durkslag_nn_1_N : N ;
  durkmoenster_nn_1_1_N : N ;
  durackord_nn_1_N : N ;
  duplikat_nn_1_N : N ;
  dun_nn_1_N : N ;
  duggregn_nn_1_N : N ;
  dubbelspaar_nn_1_1_N : N ;
  dubbelroer_nn_1_1_N : N ;
  dubbelnamn_nn_1_N : N ;
  dubbelmord_nn_1_N : N ;
  dubbelhoelster_nn_1_1_N : N ;
  dubbelgrepp_nn_1_N : N ;
  dubbelfoenster_nn_1_1_N : N ;
  dubbelbroellop_nn_1_1_N : N ;
  dubbdaeck_nn_1_1_N : N ;
  droemsaellskap_nn_1_1_N : N ;
  droemslott_nn_1_1_N : N ;
  droemmaal_nn_1_1_N : N ;
  droemliv_nn_1_1_N : N ;
  droemlandskap_nn_1_1_N : N ;
  droejsmaal_nn_1_1_N : N ;
  draapslag_nn_1_1_N : N ;
  draap_nn_1_1_N : N ;
  draeneringsroer_nn_1_1_N : N ;
  draektskick_nn_1_1_N : N ;
  dryckeslag_nn_1_N : N ;
  dryckeskaerl_nn_1_1_N : N ;
  dryckeshorn_nn_1_N : N ;
  druvrussin_nn_1_N : N ;
  drunkningsaar_nn_1_1_N : N ;
  drogmissbruk_nn_1_N : N ;
  drivmedelsbehov_nn_1_N : N ;
  drivmedel_nn_1_N : N ;
  drivhjul_nn_1_N : N ;
  drivgarn_nn_1_N : N ;
  drivband_nn_1_N : N ;
  driftstopp_nn_1_N : N ;
  driftstillstaand_nn_1_1_N : N ;
  driftstillestaand_nn_1_1_N : N ;
  driftsstoed_nn_1_1_N : N ;
  drev_nn_1_N : N ;
  drakskepp_nn_1_N : N ;
  dragstift_nn_1_N : N ;
  dragskaap_nn_1_1_N : N ;
  dragrep_nn_1_N : N ;
  dragprov_nn_1_N : N ;
  dragdjur_nn_1_N : N ;
  dragband_nn_1_N : N ;
  drag_nn_1_N : N ;
  dotterspraak_nn_1_1_N : N ;
  dotterfoeretag_nn_1_1_N : N ;
  dotterbolag_nn_1_N : N ;
  dopp_nn_1_N : N ;
  dopningsbrott_nn_1_N : N ;
  dopnamn_nn_1_N : N ;
  dopingbrott_nn_1_N : N ;
  dop_nn_1_N : N ;
  donationsmedel_nn_1_N : N ;
  donationsbrev_nn_1_N : N ;
  don_nn_1_N : N ;
  domaenverk_nn_1_1_N : N ;
  domstolsverk_nn_1_N : N ;
  domstolsprotokoll_nn_1_N : N ;
  domstolsmaal_nn_1_1_N : N ;
  domstolsbeslut_nn_1_N : N ;
  domslut_nn_1_N : N ;
  domskael_nn_1_1_N : N ;
  domkval_nn_1_N : N ;
  dominohav_nn_1_N : N ;
  dominikankloster_nn_1_N : N ;
  dominikanerkloster_nn_1_N : N ;
  domicil_nn_1_N : N ;
  dollargrin_nn_1_N : N ;
  dokumentskaap_nn_1_1_N : N ;
  dokument_nn_1_N : N ;
  dok_nn_1_N : N ;
  dockskaap_nn_1_1_N : N ;
  djaevulstyg_nn_1_1_N : N ;
  djaevelstyg_nn_1_1_N : N ;
  djurslag_nn_1_N : N ;
  djurskinn_nn_1_N : N ;
  djurplankton_nn_1_N : N ;
  djurkadaver_nn_1_N : N ;
  djurfoersoek_nn_1_1_N : N ;
  djurfoder_nn_1_N : N ;
  djurben_nn_1_N : N ;
  djurangrepp_nn_1_N : N ;
  djur_nn_1_N : N ;
  djuptryck_nn_1_N : N ;
  djuplod_nn_1_N : N ;
  djup_nn_1_N : N ;
  djungelbryn_nn_1_N : N ;
  distriktsmaesterskap_nn_1_1_N : N ;
  distrikt_nn_1_N : N ;
  distributionsfoeretag_nn_1_1_N : N ;
  diskussionsprotokoll_nn_1_N : N ;
  diskstaell_nn_1_1_N : N ;
  diskotek_nn_1_N : N ;
  diskmedel_nn_1_N : N ;
  diskbraack_nn_1_1_N : N ;
  diskbrock_nn_1_N : N ;
  disciplinstraff_nn_1_N : N ;
  disciplinmaal_nn_1_1_N : N ;
  direktskott_nn_1_N : N ;
  direktreferat_nn_1_N : N ;
  diplom_nn_1_N : N ;
  dimmoln_nn_1_N : N ;
  diktverk_nn_1_N : N ;
  diktjag_nn_1_N : N ;
  diktat_nn_1_N : N ;
  dieselkraftverk_nn_1_N : N ;
  dibarn_nn_1_N : N ;
  diarienummer_nn_1_N : N ;
  diamantbroellop_nn_1_1_N : N ;
  diamantbrynstaal_nn_1_1_N : N ;
  dialektord_nn_1_N : N ;
  detonationstryck_nn_1_N : N ;
  detachement_nn_1_N : N ;
  destillat_nn_1_N : N ;
  desinficeringsmedel_nn_1_N : N ;
  desinfektionsmedel_nn_1_N : N ;
  derivat_nn_1_N : N ;
  depaafynd_nn_1_1_N : N ;
  departementsraad_nn_1_1_N : N ;
  departement_nn_1_N : N ;
  demonstrationstaag_nn_1_1_N : N ;
  demonstrationstillstaand_nn_1_1_N : N ;
  demenshandikapp_nn_1_N : N ;
  delstreck_nn_1_N : N ;
  delprojekt_nn_1_N : N ;
  delikatessjaev_nn_1_1_N : N ;
  delfinspraang_nn_1_1_N : N ;
  dekret_nn_1_N : N ;
  dedikationsexemplar_nn_1_N : N ;
  decimaltal_nn_1_N : N ;
  decimalbraak_nn_1_1_N : N ;
  decilitermaatt_nn_1_1_N : N ;
  debattknep_nn_1_N : N ;
  debattinlaegg_nn_1_1_N : N ;
  datorstoed_nn_1_1_N : N ;
  datorintraang_nn_1_1_N : N ;
  datorfodral_nn_1_N : N ;
  dativobjekt_nn_1_N : N ;
  dataregister_nn_1_N : N ;
  datanaet_nn_1_1_N : N ;
  datalagringsfoeretag_nn_1_1_N : N ;
  dataintraang_nn_1_1_N : N ;
  danssteg_nn_1_N : N ;
  danshak_nn_1_N : N ;
  dansgolv_nn_1_N : N ;
  dansband_nn_1_N : N ;
  danaarv_nn_1_N : N ;
  damsaellskap_nn_1_1_N : N ;
  damoklessvaerd_nn_1_1_N : N ;
  dammoln_nn_1_N : N ;
  dammlager_nn_1_N : N ;
  dammkvalster_nn_1_N : N ;
  dammkorn_nn_1_N : N ;
  dammfoersoek_nn_1_1_N : N ;
  dammbindningsmedel_nn_1_N : N ;
  dambesoek_nn_1_1_N : N ;
  dalmaal_nn_1_1_N : N ;
  dagtaag_nn_1_1_N : N ;
  dagsregn_nn_1_N : N ;
  dagsbehov_nn_1_N : N ;
  dagdjur_nn_1_N : N ;
  dagbrott_nn_1_N : N ;
  dagblad_nn_1_N : N ;
  dagbefael_nn_1_1_N : N ;
  dagbarn_nn_1_N : N ;
  cystoskop_nn_1_N : N ;
  cylinderblock_nn_1_N : N ;
  cyklop_nn_2_N : N ;
  cykelstaell_nn_1_1_N : N ;
  cykeldaeck_nn_1_1_N : N ;
  curlingbarn_nn_1_N : N ;
  cumulusmoln_nn_1_N : N ;
  cocktailbaer_nn_1_1_N : N ;
  cocktailbord_nn_1_N : N ;
  cochlearimplantat_nn_1_N : N ;
  cochleaimplantat_nn_1_N : N ;
  civilaektenskap_nn_1_1_N : N ;
  civilstaand_nn_1_1_N : N ;
  civilmaal_nn_1_1_N : N ;
  citronskal_nn_1_N : N ;
  citatord_nn_1_N : N ;
  citat_nn_1_N : N ;
  citadell_nn_1_N : N ;
  cistercienserkloster_nn_1_N : N ;
  cirrusmoln_nn_1_N : N ;
  cirkustaelt_nn_1_1_N : N ;
  cirkusnummer_nn_1_N : N ;
  cirkusdjur_nn_1_N : N ;
  cirkulaerbrev_nn_1_1_N : N ;
  cirkulaer_nn_1_1_N : N ;
  cirkelslut_nn_1_N : N ;
  cirkelsegment_nn_1_N : N ;
  cirkelben_nn_1_N : N ;
  cinematek_nn_1_N : N ;
  cigarrettaendaruttag_nn_1_1_N : N ;
  cigarrettuttag_nn_1_N : N ;
  cigarrettpaket_nn_1_N : N ;
  cigarettaendaruttag_nn_1_1_N : N ;
  cigarettuttag_nn_1_N : N ;
  cigarettpaket_nn_1_N : N ;
  chocktillstaand_nn_1_1_N : N ;
  chockbesked_nn_1_N : N ;
  chefsjobb_nn_1_N : N ;
  chefsfartyg_nn_1_N : N ;
  charmtroll_nn_1_N : N ;
  championat_nn_1_N : N ;
  certifikat_nn_1_N : N ;
  centumspraak_nn_1_1_N : N ;
  centrallasarett_nn_1_N : N ;
  centralkontor_nn_1_N : N ;
  centralfoerbund_nn_1_1_N : N ;
  centerbord_nn_1_N : N ;
  cementroer_nn_1_1_N : N ;
  cellstraff_nn_1_N : N ;
  cellskikt_nn_1_N : N ;
  cellsjok_nn_1_N : N ;
  cash_nn_1_N : N ;
  cancerfall_nn_1_N : N ;
  campingkoek_nn_1_1_N : N ;
  caf_ebord_nn_1_1_N : N ;
  boetesstraff_nn_1_1_N : N ;
  boetesbelopp_nn_1_1_N : N ;
  boesshaall_nn_1_1_N : N ;
  boersbolag_nn_1_1_N : N ;
  boeneanrop_nn_1_1_N : N ;
  boeljeslag_nn_1_1_N : N ;
  boejprov_nn_1_1_N : N ;
  boejningsmoenster_nn_1_1_N : N ;
  baatvaardsmedel_nn_1_1_N : N ;
  baatskjul_nn_1_1_N : N ;
  baatdaeck_nn_1_1_N : N ;
  baatben_nn_1_1_N : N ;
  baalverk_nn_1_1_N : N ;
  baal_nn_2_1_N : N ;
  baagskyttefaelt_nn_1_1_N : N ;
  baagfoenster_nn_1_1_N : N ;
  baagfaelt_nn_1_1_N : N ;
  baerplan_nn_1_1_N : N ;
  baerlager_nn_1_1_N : N ;
  baerhandtag_nn_1_1_N : N ;
  baergningsfoeretag_nn_1_1_N : N ;
  baer_nn_1_1_N : N ;
  baenkskaap_nn_1_1_N : N ;
  baenknummer_nn_1_1_N : N ;
  baendjaern_nn_1_1_N : N ;
  baendelband_nn_1_1_N : N ;
  baeltestvaang_nn_1_1_N : N ;
  baeltdjur_nn_1_1_N : N ;
  baeckenben_nn_1_1_N : N ;
  baecken_nn_1_1_N : N ;
  byxslag_nn_1_N : N ;
  byxben_nn_1_N : N ;
  bytesobjekt_nn_1_N : N ;
  bytesmedel_nn_1_N : N ;
  bytesdjur_nn_1_N : N ;
  bytesbrev_nn_1_N : N ;
  bytesbalansoeverskott_nn_1_1_N : N ;
  bytesbalansunderskott_nn_1_N : N ;
  bystmaatt_nn_1_1_N : N ;
  bymoln_nn_1_N : N ;
  byggstopp_nn_1_N : N ;
  byggprojekt_nn_1_N : N ;
  byggnadsverk_nn_1_N : N ;
  byggnadstillstaand_nn_1_1_N : N ;
  byggnadssaett_nn_1_1_N : N ;
  byggnadsmaterial_nn_1_N : N ;
  byggnadslaan_nn_1_1_N : N ;
  byggnadslov_nn_1_N : N ;
  byggnadskontor_nn_1_N : N ;
  byggnadsfoeretag_nn_1_1_N : N ;
  byggmaterial_nn_1_N : N ;
  bygglov_nn_1_N : N ;
  byggfoeretag_nn_1_1_N : N ;
  byggelement_nn_1_N : N ;
  byggbeslag_nn_1_N : N ;
  bygelhorn_nn_1_N : N ;
  bygdemaal_nn_1_1_N : N ;
  byamaal_nn_1_1_N : N ;
  byalag_nn_1_N : N ;
  butiksraan_nn_1_1_N : N ;
  butiksfoenster_nn_1_1_N : N ;
  busvaeder_nn_1_1_N : N ;
  busskort_nn_1_N : N ;
  busksnaar_nn_1_1_N : N ;
  burspraaksfoenster_nn_1_1_N : N ;
  burspraak_nn_1_1_N : N ;
  burr_nn_1_N : N ;
  burkoel_nn_1_1_N : N ;
  burbrev_nn_1_N : N ;
  bullerkrav_nn_1_N : N ;
  bullerblomster_nn_1_N : N ;
  buller_nn_1_N : N ;
  bullbak_nn_1_N : N ;
  bulkmedel_nn_1_N : N ;
  bulkfartyg_nn_1_N : N ;
  buljongben_nn_1_N : N ;
  bulbjaern_nn_1_1_N : N ;
  bukskott_nn_1_N : N ;
  bukfettslager_nn_1_N : N ;
  buffertlager_nn_1_N : N ;
  budskap_nn_1_N : N ;
  budord_nn_1_N : N ;
  budgetoeverskott_nn_1_1_N : N ;
  budgetaar_nn_1_1_N : N ;
  budgetunderskott_nn_1_N : N ;
  budgetflyg_nn_1_N : N ;
  bud_nn_1_N : N ;
  bubbelbadkar_nn_1_N : N ;
  bubbelbad_nn_1_N : N ;
  broestvaern_nn_1_1_N : N ;
  broestskydd_nn_1_1_N : N ;
  broestsimtag_nn_1_1_N : N ;
  broestregister_nn_1_1_N : N ;
  broestmaatt_nn_1_1_N : N ;
  broestingrepp_nn_1_1_N : N ;
  broestimplantat_nn_1_1_N : N ;
  broestben_nn_1_1_N : N ;
  broestbarn_nn_1_1_N : N ;
  broestarv_nn_1_1_N : N ;
  broellopsresmaal_nn_1_1_N : N ;
  broellopspar_nn_1_1_N : N ;
  broellop_nn_1_1_N : N ;
  broel_nn_1_1_N : N ;
  broedraskap_nn_1_1_N : N ;
  broedrapar_nn_1_1_N : N ;
  broedrafolk_nn_1_1_N : N ;
  broedfat_nn_1_1_N : N ;
  broedbak_nn_1_1_N : N ;
  broed_nn_1_1_N : N ;
  braaktal_nn_1_1_N : N ;
  braakstreck_nn_1_1_N : N ;
  braak_nn_1_1_N : N ;
  braaddjup_nn_1_1_N : N ;
  braackband_nn_1_1_N : N ;
  braack_nn_1_1_N : N ;
  braensletillaegg_nn_1_1_N : N ;
  braenslefoerraad_nn_1_1_N : N ;
  braenslefaelt_nn_1_1_N : N ;
  braenslefilter_nn_1_1_N : N ;
  braensleelement_nn_1_1_N : N ;
  braenslecellskraftverk_nn_1_1_N : N ;
  braennvinsbord_nn_1_1_N : N ;
  braennsaar_nn_1_1_N : N ;
  braennmaterial_nn_1_1_N : N ;
  braennjaern_nn_1_1_N : N ;
  braennhaar_nn_1_1_N : N ;
  braem_nn_1_1_N : N ;
  braedplank_nn_1_1_N : N ;
  braeddavlopp_nn_1_1_N : N ;
  braeckjaern_nn_1_1_N : N ;
  brytningsaar_nn_1_1_N : N ;
  brytblad_nn_1_N : N ;
  brynstaal_nn_1_1_N : N ;
  brynset_nn_1_N : N ;
  bryn_nn_1_N : N ;
  brunnskar_nn_1_N : N ;
  brunkol_nn_1_N : N ;
  brunbaer_nn_1_1_N : N ;
  bruksfoeremaal_nn_1_1_N : N ;
  bruksdjur_nn_1_N : N ;
  bruk_nn_2_N : N ;
  bruk_nn_1_N : N ;
  brudrov_nn_1_N : N ;
  brudpar_nn_1_N : N ;
  brudkoep_nn_1_1_N : N ;
  brovalv_nn_1_N : N ;
  brottsrekvisit_nn_1_N : N ;
  brottsregister_nn_1_N : N ;
  brottningsgrepp_nn_1_N : N ;
  brottmaal_nn_1_1_N : N ;
  brott_nn_2_N : N ;
  brott_nn_1_N : N ;
  brospann_nn_1_N : N ;
  broskverk_nn_1_N : N ;
  brorsbarn_nn_1_N : N ;
  brorsarv_nn_1_N : N ;
  bronsaaldersfynd_nn_1_1_N : N ;
  bronssvaerd_nn_1_1_N : N ;
  bronsmynt_nn_1_N : N ;
  bronkoskop_nn_1_N : N ;
  bromsspaar_nn_1_1_N : N ;
  bromsilverpapper_nn_1_N : N ;
  bromshandtag_nn_1_N : N ;
  bromsgaller_nn_1_N : N ;
  bromsblock_nn_1_N : N ;
  bromsbelaegg_nn_1_1_N : N ;
  bromsband_nn_1_N : N ;
  brolopp_nn_1_N : N ;
  brokar_nn_1_N : N ;
  broderskap_nn_1_N : N ;
  brodermord_nn_1_N : N ;
  broderfolk_nn_1_N : N ;
  brockband_nn_1_N : N ;
  brock_nn_2_N : N ;
  brittsommarvaeder_nn_1_1_N : N ;
  bridgebord_nn_1_N : N ;
  brickunderlaegg_nn_1_1_N : N ;
  brickbord_nn_1_N : N ;
  brickband_nn_1_N : N ;
  brevsvar_nn_1_N : N ;
  brevstaell_nn_1_1_N : N ;
  brevpapper_nn_1_N : N ;
  brevlaadefoeretag_nn_1_1_N : N ;
  brevkort_nn_1_N : N ;
  brevfack_nn_1_N : N ;
  brev_nn_1_N : N ;
  bredbandsfoeretag_nn_1_1_N : N ;
  bredband_nn_1_N : N ;
  break_nn_1_N : N ;
  bravurnummer_nn_1_N : N ;
  bravorop_nn_1_N : N ;
  branschraad_nn_1_1_N : N ;
  brandtorn_nn_1_N : N ;
  brandtal_nn_1_N : N ;
  brandstodsbolag_nn_1_N : N ;
  brandskaap_nn_1_1_N : N ;
  brandroer_nn_1_1_N : N ;
  brandredskap_nn_1_N : N ;
  brandlager_nn_1_N : N ;
  brandfoersaekringsbolag_nn_1_1_N : N ;
  brandbefael_nn_1_1_N : N ;
  brandattentat_nn_1_N : N ;
  bragdlopp_nn_1_N : N ;
  bragdguld_nn_1_N : N ;
  boaegg_nn_1_1_N : N ;
  boxnummer_nn_1_N : N ;
  bowlingklot_nn_1_N : N ;
  bovstreck_nn_1_N : N ;
  bottenskikt_nn_1_N : N ;
  bottensediment_nn_1_N : N ;
  bottenrev_nn_1_N : N ;
  bottenrekord_nn_1_N : N ;
  bottenplan_nn_1_N : N ;
  bottennapp_nn_1_N : N ;
  bottenlaan_nn_1_1_N : N ;
  bottenlag_nn_1_N : N ;
  bottengarn_nn_1_N : N ;
  bottendjur_nn_1_N : N ;
  botemedel_nn_1_N : N ;
  bosaettningsstopp_nn_1_1_N : N ;
  bosaettningslaan_nn_1_1_N : N ;
  bostadstillaegg_nn_1_1_N : N ;
  bostadslaan_nn_1_1_N : N ;
  bostadsfoeretag_nn_1_1_N : N ;
  bostadsfoerbaettringslaan_nn_1_1_N : N ;
  bostadsbolag_nn_1_N : N ;
  bostadsbidrag_nn_1_N : N ;
  bostadsband_nn_1_N : N ;
  boskapsfoder_nn_1_N : N ;
  bortfall_nn_1_N : N ;
  bortalag_nn_1_N : N ;
  borstgarnityr_nn_1_N : N ;
  borrtorn_nn_1_N : N ;
  borrstaal_nn_1_1_N : N ;
  borrspaan_nn_1_1_N : N ;
  borrhaal_nn_1_1_N : N ;
  borgtorn_nn_1_N : N ;
  borgerskap_nn_1_N : N ;
  borgenslaan_nn_1_1_N : N ;
  borgarraad_nn_1_1_N : N ;
  borgarbrev_nn_1_N : N ;
  bordtennisbord_nn_1_N : N ;
  bordssaellskap_nn_1_1_N : N ;
  bordsstaell_nn_1_1_N : N ;
  bordsskick_nn_1_N : N ;
  bordssamtal_nn_1_N : N ;
  bordskick_nn_1_N : N ;
  bordsben_nn_1_N : N ;
  bordsamtal_nn_1_N : N ;
  bord_nn_1_N : N ;
  boomaar_nn_1_1_N : N ;
  bonusbarn_nn_1_N : N ;
  bondfoersoek_nn_1_1_N : N ;
  bondfolk_nn_1_N : N ;
  bondeuppror_nn_1_N : N ;
  bondeuppbaad_nn_1_1_N : N ;
  bondetaag_nn_1_1_N : N ;
  bondehemman_nn_1_N : N ;
  bomullsband_nn_1_N : N ;
  bomskott_nn_1_N : N ;
  bombskydd_nn_1_N : N ;
  bombplan_nn_1_N : N ;
  bombnedslag_nn_1_N : N ;
  bomblarm_nn_1_N : N ;
  bombkrig_nn_1_N : N ;
  bombhot_nn_1_N : N ;
  bombdaad_nn_1_1_N : N ;
  bombattentat_nn_1_N : N ;
  bombardemang_nn_1_N : N ;
  bombanfall_nn_1_N : N ;
  bomaterial_nn_1_N : N ;
  bolaan_nn_1_1_N : N ;
  bolstervar_nn_1_N : N ;
  bollplank_nn_1_N : N ;
  bollhav_nn_1_N : N ;
  bolag_nn_1_N : N ;
  bol_nn_1_N : N ;
  bokverk_nn_1_N : N ;
  bokval_nn_1_N : N ;
  bokuppslag_nn_1_N : N ;
  boktorn_nn_1_N : N ;
  bokstoed_nn_1_1_N : N ;
  bokstavsbarn_nn_1_N : N ;
  bokslut_nn_1_N : N ;
  bokskaap_nn_1_1_N : N ;
  bokomslag_nn_1_N : N ;
  bokollon_nn_1_N : N ;
  bokmagasin_nn_1_N : N ;
  boklaan_nn_1_1_N : N ;
  bokfoerraad_nn_1_1_N : N ;
  bokfoerlag_nn_1_1_N : N ;
  bokfoeringsaar_nn_1_1_N : N ;
  bokfoeringsbrott_nn_1_1_N : N ;
  bokformat_nn_1_N : N ;
  bokband_nn_1_N : N ;
  bohag_nn_1_N : N ;
  bogvisir_nn_1_N : N ;
  bogsproet_nn_1_1_N : N ;
  bogserslaep_nn_1_1_N : N ;
  bogblad_nn_1_N : N ;
  bockverktyg_nn_1_N : N ;
  bockspraang_nn_1_1_N : N ;
  bockskaegg_nn_1_1_N : N ;
  bockprov_nn_1_N : N ;
  bockhorn_nn_1_N : N ;
  bockblad_nn_1_N : N ;
  boardingcard_nn_1_N : N ;
  bloetlaeggningsmedel_nn_1_1_N : N ;
  bloetdjur_nn_1_1_N : N ;
  blaasvaeder_nn_1_1_N : N ;
  blaastaell_nn_1_1_N : N ;
  blaasroer_nn_1_1_N : N ;
  blaasljud_nn_1_1_N : N ;
  blaasinstrument_nn_1_1_N : N ;
  blaashaal_nn_1_1_N : N ;
  blaahjon_nn_1_1_N : N ;
  blaahallon_nn_1_1_N : N ;
  blaabaer_nn_1_1_N : N ;
  blaesterroer_nn_1_1_N : N ;
  blaendverk_nn_1_1_N : N ;
  blaendskydd_nn_1_1_N : N ;
  blaedderblock_nn_1_1_N : N ;
  blaeckhorn_nn_1_1_N : N ;
  blylod_nn_1_N : N ;
  blygdhaar_nn_2_1_N : N ;
  blygdben_nn_1_N : N ;
  blusliv_nn_1_N : N ;
  bluffprojekt_nn_1_N : N ;
  bluffpiller_nn_1_N : N ;
  blot_nn_1_N : N ;
  blomsterbord_nn_1_N : N ;
  blomster_nn_1_N : N ;
  blomskaft_nn_1_N : N ;
  blommoenster_nn_1_1_N : N ;
  blomhoelster_nn_1_1_N : N ;
  blomfoder_nn_1_N : N ;
  blomfjaell_nn_1_1_N : N ;
  blomfat_nn_1_N : N ;
  blombord_nn_1_N : N ;
  blomblad_nn_1_N : N ;
  blogginlaegg_nn_1_1_N : N ;
  blodtryck_nn_1_N : N ;
  blodspaar_nn_1_1_N : N ;
  blodsdaad_nn_1_1_N : N ;
  blodsband_nn_1_N : N ;
  blodkaerlsbraack_nn_1_1_N : N ;
  blodkaerl_nn_1_1_N : N ;
  blodbad_nn_1_N : N ;
  blocktyg_nn_1_N : N ;
  blockadbrott_nn_1_N : N ;
  block_nn_1_N : N ;
  blixtsamtal_nn_1_N : N ;
  blixtnedslag_nn_1_N : N ;
  blixtkrig_nn_1_N : N ;
  blixtbesoek_nn_1_1_N : N ;
  blixtanfall_nn_1_N : N ;
  blink_nn_1_N : N ;
  blindtryck_nn_1_N : N ;
  blindspaar_nn_1_1_N : N ;
  blindskaer_nn_1_1_N : N ;
  blindfoenster_nn_1_1_N : N ;
  blindalfabet_nn_1_N : N ;
  blidvaeder_nn_1_1_N : N ;
  blickfaang_nn_1_1_N : N ;
  blickfaelt_nn_1_1_N : N ;
  blekmedel_nn_1_N : N ;
  bleckblaasinstrument_nn_1_1_N : N ;
  bleck_nn_1_N : N ;
  blankettskaap_nn_1_1_N : N ;
  blandaektenskap_nn_1_1_N : N ;
  blandspraak_nn_1_1_N : N ;
  blandfolk_nn_1_N : N ;
  bladskaft_nn_1_N : N ;
  blad_nn_1_N : N ;
  bjoernskinn_nn_1_1_N : N ;
  bjoernskall_nn_1_1_N : N ;
  bjoernhallon_nn_1_1_N : N ;
  bjoernbaer_nn_1_1_N : N ;
  bjoerkloev_nn_1_1_N : N ;
  bjoerkblad_nn_1_1_N : N ;
  bjaelkverk_nn_1_1_N : N ;
  bjaelklag_nn_1_1_N : N ;
  biverkningsfall_nn_1_N : N ;
  bitsaar_nn_1_1_N : N ;
  bistaandsskepp_nn_1_1_N : N ;
  bistaandsprojekt_nn_1_1_N : N ;
  bistaandsorgan_nn_1_1_N : N ;
  bistaandsmaal_nn_1_1_N : N ;
  bistyng_nn_1_N : N ;
  bisting_nn_1_N : N ;
  bistick_nn_1_N : N ;
  biskopsval_nn_1_N : N ;
  biskopsstift_nn_1_N : N ;
  bisamsvin_nn_1_N : N ;
  biplan_nn_1_N : N ;
  biodrivmedel_nn_1_N : N ;
  biobesoek_nn_1_1_N : N ;
  bindgarn_nn_1_N : N ;
  bindestreck_nn_1_N : N ;
  bindeord_nn_1_N : N ;
  bindemedel_nn_1_N : N ;
  bind_nn_1_N : N ;
  binamn_nn_1_N : N ;
  bilaeger_nn_1_1_N : N ;
  bilvrak_nn_1_N : N ;
  biltak_nn_1_N : N ;
  bilregister_nn_1_N : N ;
  bilnummer_nn_1_N : N ;
  billaan_nn_1_1_N : N ;
  bilkoep_nn_1_1_N : N ;
  biljud_nn_1_N : N ;
  biljettkoep_nn_1_1_N : N ;
  biljettkontor_nn_1_N : N ;
  biljardbord_nn_1_N : N ;
  bilhjul_nn_1_N : N ;
  bilgolv_nn_1_N : N ;
  bilfoenster_nn_1_1_N : N ;
  bildaeck_nn_1_1_N : N ;
  bildverk_nn_1_N : N ;
  bildspraak_nn_1_1_N : N ;
  bildroer_nn_1_1_N : N ;
  bildningsfoerbund_nn_1_1_N : N ;
  bildmaterial_nn_1_N : N ;
  bildinnehav_nn_1_N : N ;
  bildband_nn_1_N : N ;
  biktbarn_nn_1_N : N ;
  bihav_nn_1_N : N ;
  bihang_nn_1_N : N ;
  biffdjur_nn_1_N : N ;
  bifallsrop_nn_1_N : N ;
  bifall_nn_1_N : N ;
  bidragsfoerskott_nn_1_1_N : N ;
  bidrag_nn_1_N : N ;
  bibroed_nn_1_1_N : N ;
  bibliotekslaan_nn_1_1_N : N ;
  biblioteksbord_nn_1_N : N ;
  biblioteksband_nn_1_N : N ;
  bibliotek_nn_1_N : N ;
  bibelsaellskap_nn_1_1_N : N ;
  bibelspraak_nn_1_1_N : N ;
  bibelsamtal_nn_1_N : N ;
  bibelord_nn_1_N : N ;
  bibelcitat_nn_1_N : N ;
  bevismedel_nn_1_N : N ;
  bevismaterial_nn_1_N : N ;
  beviskrav_nn_1_N : N ;
  bevillningsutskott_nn_1_N : N ;
  bevakningsuppdrag_nn_1_N : N ;
  betyg_nn_1_N : N ;
  betydelseskikt_nn_1_N : N ;
  betydelselager_nn_1_N : N ;
  bett_nn_1_N : N ;
  betsmedel_nn_1_N : N ;
  betraktelsesaett_nn_1_1_N : N ;
  betongvalv_nn_1_N : N ;
  betonghinder_nn_1_N : N ;
  betonggolv_nn_1_N : N ;
  betongblock_nn_1_N : N ;
  betongbjaelklag_nn_1_1_N : N ;
  betmedel_nn_1_N : N ;
  beting_nn_1_N : N ;
  betesland_nn_1_N : N ;
  betelblad_nn_1_N : N ;
  beteendemoenster_nn_1_1_N : N ;
  beteckningssaett_nn_1_1_N : N ;
  betasoenderfall_nn_1_1_N : N ;
  betalningsvillkor_nn_1_N : N ;
  betalningsmedel_nn_1_N : N ;
  betalningsavtal_nn_1_N : N ;
  betalningsanstaand_nn_1_1_N : N ;
  besoekstopp_nn_1_1_N : N ;
  besoeksfoerbud_nn_1_1_N : N ;
  besoek_nn_1_1_N : N ;
  besaettningsband_nn_1_1_N : N ;
  besvaerssubjekt_nn_1_1_N : N ;
  besvaersmaal_nn_1_1_N : N ;
  besvaer_nn_1_1_N : N ;
  bestaand_nn_1_1_N : N ;
  bestaemningsord_nn_1_1_N : N ;
  bestaellningsverk_nn_1_1_N : N ;
  bestyr_nn_1_N : N ;
  bestraffningsmedel_nn_1_N : N ;
  bestick_nn_1_N : N ;
  bessemerstaal_nn_1_1_N : N ;
  besprutningsmedel_nn_1_N : N ;
  besparingskrav_nn_1_N : N ;
  besman_nn_1_N : N ;
  beslutsunderlag_nn_1_N : N ;
  beslut_nn_1_N : N ;
  beslagsband_nn_1_N : N ;
  beslag_nn_1_N : N ;
  besked_nn_1_N : N ;
  beskattningsaar_nn_1_1_N : N ;
  besittningsskydd_nn_1_N : N ;
  besiktningsprotokoll_nn_1_N : N ;
  besiktningsinstrument_nn_1_N : N ;
  beraettarjag_nn_1_1_N : N ;
  beraekningssaett_nn_1_1_N : N ;
  bergtroll_nn_1_N : N ;
  bergstup_nn_1_N : N ;
  bergslandskap_nn_1_N : N ;
  bergslager_nn_1_N : N ;
  bergskroen_nn_1_1_N : N ;
  bergskred_nn_1_N : N ;
  berglandskap_nn_1_N : N ;
  bergkroen_nn_1_1_N : N ;
  bergartslager_nn_1_N : N ;
  berg_nn_1_N : N ;
  beredskapsplan_nn_1_N : N ;
  beredskapslager_nn_1_N : N ;
  beredningsutskott_nn_1_N : N ;
  benutskott_nn_1_N : N ;
  bensaar_nn_1_1_N : N ;
  benskydd_nn_1_N : N ;
  bensinstopp_nn_1_N : N ;
  bensinbolag_nn_1_N : N ;
  benfragment_nn_1_N : N ;
  benediktinkloster_nn_1_N : N ;
  benediktinerkloster_nn_1_N : N ;
  benbrott_nn_1_N : N ;
  ben_nn_1_N : N ;
  bemanningsfoeretag_nn_1_1_N : N ;
  belaegringstorn_nn_1_1_N : N ;
  belaegringstillstaand_nn_1_1_N : N ;
  belaegg_nn_1_1_N : N ;
  belopp_nn_1_N : N ;
  belastningsregister_nn_1_N : N ;
  belag_nn_1_N : N ;
  bekaempningsmedel_nn_1_1_N : N ;
  bekymmer_nn_1_N : N ;
  bekraeftelsebehov_nn_1_1_N : N ;
  behovstryck_nn_1_N : N ;
  behov_nn_1_N : N ;
  behandlingssaett_nn_1_1_N : N ;
  behag_nn_1_N : N ;
  begaer_nn_1_1_N : N ;
  begynnelsespraak_nn_1_1_N : N ;
  begrepp_nn_1_N : N ;
  begravningstaag_nn_1_1_N : N ;
  begagnatkoep_nn_1_1_N : N ;
  befaestningsverk_nn_1_1_N : N ;
  befaestningsskydd_nn_1_1_N : N ;
  befaelsuppdrag_nn_1_1_N : N ;
  befael_nn_1_1_N : N ;
  befruktningsoegonblick_nn_1_1_N : N ;
  befrielsekrig_nn_1_N : N ;
  bedoevningsmedel_nn_1_1_N : N ;
  bedraegeribrott_nn_1_1_N : N ;
  bebyggelsenamn_nn_1_N : N ;
  batongstaand_nn_1_1_N : N ;
  batongslag_nn_1_N : N ;
  basaar_nn_1_1_N : N ;
  bastubad_nn_1_N : N ;
  bassetthorn_nn_1_N : N ;
  baspar_nn_1_N : N ;
  baslaeger_nn_1_1_N : N ;
  basfiolsfodral_nn_1_N : N ;
  basbelopp_nn_1_N : N ;
  barskaap_nn_1_1_N : N ;
  barriaerrev_nn_1_1_N : N ;
  barr_nn_1_N : N ;
  barometerstaand_nn_1_1_N : N ;
  barometerfall_nn_1_N : N ;
  barnspraak_nn_1_1_N : N ;
  barnskrik_nn_1_N : N ;
  barnskratt_nn_1_N : N ;
  barnrov_nn_1_N : N ;
  barnkorstaag_nn_1_1_N : N ;
  barnkammarfoenster_nn_1_1_N : N ;
  barnhusbarn_nn_1_N : N ;
  barnhemsbarn_nn_1_N : N ;
  barndop_nn_1_N : N ;
  barndomstillstaand_nn_1_1_N : N ;
  barnbidrag_nn_1_N : N ;
  barnbesoek_nn_1_1_N : N ;
  barnbarnsbarn_nn_1_N : N ;
  barnbarn_nn_1_N : N ;
  barnarov_nn_1_N : N ;
  barnamord_nn_1_N : N ;
  barn_nn_1_N : N ;
  barmhaertighetsverk_nn_1_1_N : N ;
  barmhaertighetsmord_nn_1_1_N : N ;
  barkskepp_nn_1_N : N ;
  barkbroed_nn_1_1_N : N ;
  bantuspraak_nn_1_1_N : N ;
  bantufolk_nn_1_N : N ;
  bantningspiller_nn_1_N : N ;
  bantningsmedel_nn_1_N : N ;
  bantlaer_nn_1_1_N : N ;
  banrekord_nn_1_N : N ;
  bann_nn_1_N : N ;
  bankraan_nn_1_1_N : N ;
  bankomatkort_nn_1_N : N ;
  banklaan_nn_1_1_N : N ;
  bankkort_nn_1_N : N ;
  bankkontor_nn_1_N : N ;
  bankfack_nn_1_N : N ;
  banjoinstrument_nn_1_N : N ;
  banesaar_nn_1_1_N : N ;
  bandyslag_nn_1_N : N ;
  bandyroer_nn_1_1_N : N ;
  bandotek_nn_1_N : N ;
  bandolaer_nn_1_1_N : N ;
  bandjaern_nn_1_1_N : N ;
  banditgaeng_nn_1_1_N : N ;
  bandfordon_nn_1_N : N ;
  band_nn_1_N : N ;
  bamburoer_nn_1_1_N : N ;
  balloptikon_nn_1_N : N ;
  ballongdaeck_nn_1_1_N : N ;
  balkverk_nn_1_N : N ;
  balkmaatt_nn_1_1_N : N ;
  balkanfolk_nn_1_N : N ;
  balansroder_nn_1_N : N ;
  balansorgan_nn_1_N : N ;
  balansnummer_nn_1_N : N ;
  balanshjul_nn_1_N : N ;
  bakaatsteg_nn_1_1_N : N ;
  bakverk_nn_1_N : N ;
  baksteg_nn_1_N : N ;
  bakspaar_nn_1_1_N : N ;
  bakslag_nn_1_N : N ;
  bakpulver_nn_1_N : N ;
  bakplaatspapper_nn_1_1_N : N ;
  bakhaall_nn_1_1_N : N ;
  bakhjul_nn_1_N : N ;
  bakgrundstal_nn_1_N : N ;
  bakgrundsljud_nn_1_N : N ;
  bakdaeck_nn_1_1_N : N ;
  bakben_nn_1_N : N ;
  bakarv_nn_1_N : N ;
  bak_nn_2_N : N ;
  bagatellmaal_nn_1_1_N : N ;
  badrumsskaap_nn_1_1_N : N ;
  badrumsgolv_nn_1_N : N ;
  badlakan_nn_1_N : N ;
  badkar_nn_1_N : N ;
  bad_nn_1_N : N ;
  backstag_nn_1_N : N ;
  backslag_nn_1_N : N ;
  backlandskap_nn_1_N : N ;
  backkroen_nn_1_1_N : N ;
  axplock_nn_1_N : N ;
  axiom_nn_1_N : N ;
  axelset_nn_1_N : N ;
  axellager_nn_1_N : N ;
  axelhoelster_nn_1_1_N : N ;
  axelhaal_nn_1_1_N : N ;
  axelgehaeng_nn_1_1_N : N ;
  axelband_nn_1_N : N ;
  avvaegningsinstrument_nn_1_1_N : N ;
  avvisningsbeslut_nn_1_N : N ;
  avvecklingsbeslut_nn_1_N : N ;
  avtaag_nn_1_1_N : N ;
  avtryck_nn_1_N : N ;
  avtalsbrott_nn_1_N : N ;
  avtal_nn_1_N : N ;
  avsaendarnummer_nn_1_1_N : N ;
  avstaand_nn_1_1_N : N ;
  avsteg_nn_1_N : N ;
  avstamp_nn_1_N : N ;
  avspaerrningsband_nn_1_1_N : N ;
  avspraang_nn_1_1_N : N ;
  avsnitt_nn_1_N : N ;
  avslut_nn_1_N : N ;
  avslag_nn_1_N : N ;
  avskrivningsobjekt_nn_1_N : N ;
  avskedstal_nn_1_N : N ;
  avskedsord_nn_1_N : N ;
  avskedsknull_nn_1_N : N ;
  avskedsbrev_nn_1_N : N ;
  avsked_nn_1_N : N ;
  avrop_nn_1_N : N ;
  avlusningsmedel_nn_1_N : N ;
  avloppsroer_nn_1_1_N : N ;
  avloppsledningsroer_nn_1_1_N : N ;
  avlopp_nn_1_N : N ;
  avljud_nn_1_N : N ;
  avlatsbrev_nn_1_N : N ;
  avkok_nn_1_N : N ;
  avknoppningsfoeretag_nn_1_1_N : N ;
  avkastningskrav_nn_1_N : N ;
  avisofartyg_nn_1_N : N ;
  avhaall_nn_1_1_N : N ;
  avhopp_nn_1_N : N ;
  avgaangsvederlag_nn_1_1_N : N ;
  avgaangskrav_nn_1_1_N : N ;
  avgaangsbidrag_nn_1_1_N : N ;
  avgaangsbetyg_nn_1_1_N : N ;
  avgrundsdjup_nn_1_N : N ;
  avgasroer_nn_1_1_N : N ;
  avfoeringsmedel_nn_1_1_N : N ;
  avflyttningsfoerbud_nn_1_1_N : N ;
  avfettningsmedel_nn_1_N : N ;
  avfallsupplag_nn_1_N : N ;
  avfall_nn_1_N : N ;
  avelsdjur_nn_1_N : N ;
  avdrag_nn_1_N : N ;
  avdelningskontor_nn_1_N : N ;
  avbraeck_nn_1_1_N : N ;
  avbrott_nn_1_N : N ;
  avbetalningsarrangemang_nn_1_N : N ;
  avancemang_nn_1_N : N ;
  automatgevaer_nn_1_1_N : N ;
  auktionsverk_nn_1_N : N ;
  augustipaeron_nn_1_1_N : N ;
  augment_nn_1_N : N ;
  augiasstall_nn_1_N : N ;
  attribut_nn_1_N : N ;
  attentat_nn_1_N : N ;
  attackplan_nn_1_N : N ;
  attackflygplan_nn_1_N : N ;
  attackflyg_nn_1_N : N ;
  atomur_nn_1_N : N ;
  atomnummer_nn_1_N : N ;
  atomkraftmikroskop_nn_1_N : N ;
  atomenergiorgan_nn_1_N : N ;
  atmosfaerstryck_nn_1_1_N : N ;
  atmosfaerslager_nn_1_1_N : N ;
  atelj_efoenster_nn_1_1_N : N ;
  asteroidnedfall_nn_1_N : N ;
  asploev_nn_1_1_N : N ;
  askregn_nn_1_N : N ;
  askmoln_nn_1_N : N ;
  askhot_nn_1_N : N ;
  askfat_nn_1_N : N ;
  arvsanspraak_nn_1_1_N : N ;
  arvsanlag_nn_1_N : N ;
  arvord_nn_1_N : N ;
  arv_nn_1_N : N ;
  artotek_nn_1_N : N ;
  artnamn_nn_1_N : N ;
  artistnamn_nn_1_N : N ;
  artillerimanskap_nn_1_N : N ;
  artillerifoerband_nn_1_1_N : N ;
  arrendekontrakt_nn_1_N : N ;
  arrangemang_nn_1_N : N ;
  arr_nn_1_N : N ;
  arm_egevaer_nn_1_1_N : N ;
  arm_efoerband_nn_1_1_N : N ;
  armveck_nn_1_N : N ;
  armtag_nn_1_N : N ;
  armstoed_nn_1_1_N : N ;
  armhaalsstoed_nn_1_1_N : N ;
  armeringsjaern_nn_1_1_N : N ;
  armbaagsutskott_nn_1_1_N : N ;
  armbaagsskydd_nn_1_1_N : N ;
  armbaagsben_nn_1_1_N : N ;
  armbrott_nn_1_N : N ;
  armbandsur_nn_1_N : N ;
  armband_nn_1_N : N ;
  arkivexemplar_nn_1_N : N ;
  ark_nn_1_N : N ;
  argument_nn_1_N : N ;
  arbetsaar_nn_1_1_N : N ;
  arbetsvillkor_nn_1_N : N ;
  arbetsverktyg_nn_1_N : N ;
  arbetsutskott_nn_1_N : N ;
  arbetstillstaand_nn_1_1_N : N ;
  arbetssaett_nn_1_1_N : N ;
  arbetsredskap_nn_1_N : N ;
  arbetsnamn_nn_1_N : N ;
  arbetsmoment_nn_1_N : N ;
  arbetsmiljoemaal_nn_1_1_N : N ;
  arbetsmiljoebrott_nn_1_1_N : N ;
  arbetsmaterial_nn_1_N : N ;
  arbetslaeger_nn_1_1_N : N ;
  arbetslag_nn_1_N : N ;
  arbetsklimat_nn_1_N : N ;
  arbetshandikapp_nn_1_N : N ;
  arbetsfaelt_nn_1_1_N : N ;
  arbetsdjur_nn_1_N : N ;
  arbetsbord_nn_1_N : N ;
  arbetsavtal_nn_1_N : N ;
  arbetaruppror_nn_1_N : N ;
  arbetarraad_nn_1_1_N : N ;
  arbetarinstitut_nn_1_N : N ;
  aprilvaeder_nn_1_1_N : N ;
  aprilskaemt_nn_1_1_N : N ;
  approbatur_nn_1_N : N ;
  apotek_nn_1_N : N ;
  aplik_nn_1_N : N ;
  apelsinskal_nn_1_N : N ;
  anvaendningssaett_nn_1_1_N : N ;
  antaag_nn_1_1_N : N ;
  antivibrationshandtag_nn_1_N : N ;
  antistatmedel_nn_1_N : N ;
  antioxidationsmedel_nn_1_N : N ;
  antikvariat_nn_1_N : N ;
  antennuttag_nn_1_N : N ;
  anteckningsblock_nn_1_N : N ;
  antal_nn_1_N : N ;
  ansoekningspapper_nn_1_1_N : N ;
  anstaand_nn_1_1_N : N ;
  anstaellningsstopp_nn_1_1_N : N ;
  anstaellningsskydd_nn_1_1_N : N ;
  anstaellningskontrakt_nn_1_1_N : N ;
  anstaellningsavtal_nn_1_1_N : N ;
  anspraak_nn_1_1_N : N ;
  anspann_nn_1_N : N ;
  anslutningsavtal_nn_1_N : N ;
  anslag_nn_1_N : N ;
  ansiktsuttryck_nn_1_N : N ;
  ansiktsskydd_nn_1_N : N ;
  ansiktslyft_nn_1_N : N ;
  ansiktsdrag_nn_1_N : N ;
  anropsnummer_nn_1_N : N ;
  anrop_nn_1_N : N ;
  anonymiseringsverktyg_nn_1_N : N ;
  annuitetslaan_nn_1_1_N : N ;
  annonssvar_nn_1_N : N ;
  anlopp_nn_1_N : N ;
  anletsdrag_nn_1_N : N ;
  anlag_nn_1_N : N ;
  ankaegg_nn_1_1_N : N ;
  ankarslut_nn_1_N : N ;
  ankarjaern_nn_1_1_N : N ;
  anhang_nn_1_N : N ;
  angreppssaett_nn_1_1_N : N ;
  angrepp_nn_1_N : N ;
  angivelsebrott_nn_1_N : N ;
  anfoeringsverb_nn_1_1_N : N ;
  anflog_nn_1_N : N ;
  anfallskrig_nn_1_N : N ;
  anfall_nn_1_N : N ;
  andstraeck_nn_1_1_N : N ;
  andranamn_nn_1_N : N ;
  andrahandsval_nn_1_N : N ;
  andrahandsfoeremaal_nn_1_1_N : N ;
  andrag_nn_1_N : N ;
  andningsuppehaall_nn_1_1_N : N ;
  andningsskydd_nn_1_N : N ;
  andningsroer_nn_1_1_N : N ;
  andningsorgan_nn_1_N : N ;
  andningshaal_nn_1_1_N : N ;
  andhaal_nn_1_1_N : N ;
  andetag_nn_1_N : N ;
  andedrag_nn_1_N : N ;
  anbud_nn_1_N : N ;
  anbrott_nn_1_N : N ;
  analogislut_nn_1_N : N ;
  amt_nn_1_N : N ;
  amperevarv_nn_1_N : N ;
  amorteringslaan_nn_1_1_N : N ;
  amfibieplan_nn_1_N : N ;
  amfetaminbeslag_nn_1_N : N ;
  amendemang_nn_1_N : N ;
  ambulansflyg_nn_1_N : N ;
  ambassadraad_nn_1_1_N : N ;
  amatoerteleskop_nn_1_1_N : N ;
  amatoerprojekt_nn_1_1_N : N ;
  alveolarben_nn_1_N : N ;
  aluminiumsmaeltverk_nn_1_1_N : N ;
  aluminiumpulver_nn_1_N : N ;
  aluminiumnaet_nn_1_1_N : N ;
  althorn_nn_1_N : N ;
  altarskaap_nn_1_1_N : N ;
  altarbrun_nn_1_N : N ;
  altarbord_nn_1_N : N ;
  alster_nn_1_N : N ;
  alspaan_nn_1_1_N : N ;
  alphorn_nn_1_N : N ;
  almanacksblad_nn_1_N : N ;
  allvaedersskydd_nn_1_1_N : N ;
  allvarsord_nn_1_N : N ;
  allting_nn_1_N : N ;
  allshaerjarting_nn_1_1_N : N ;
  allmaenbegrepp_nn_1_1_N : N ;
  allkonstverk_nn_1_N : N ;
  allegat_nn_1_N : N ;
  alfasoenderfall_nn_1_1_N : N ;
  alfabet_nn_1_N : N ;
  alarm_nn_1_N : N ;
  alanin_nn_1_N : N ;
  akutfall_nn_1_N : N ;
  aktiveringsmoenster_nn_1_1_N : N ;
  aktionssaett_nn_1_1_N : N ;
  aktieinnehav_nn_1_N : N ;
  aktiebrev_nn_1_N : N ;
  aktiebolag_nn_1_N : N ;
  akterskepp_nn_1_N : N ;
  akterlik_nn_1_N : N ;
  akterdaeck_nn_1_1_N : N ;
  akantusblad_nn_1_N : N ;
  aikidotrick_nn_1_N : N ;
  agremang_nn_1_N : N ;
  agrarfoerbund_nn_1_1_N : N ;
  agn_nn_1_N : N ;
  aggregationstillstaand_nn_1_1_N : N ;
  aggregat_nn_1_N : N ;
  agglomerat_nn_1_N : N ;
  aftonmaal_nn_1_1_N : N ;
  affaersverk_nn_1_1_N : N ;
  affaersstraak_nn_1_1_N : N ;
  affaersliv_nn_1_1_N : N ;
  affaersfoerslag_nn_1_1_N : N ;
  affaersfoeretag_nn_1_1_N : N ;
  affaersdistrikt_nn_1_1_N : N ;
  affaersbrev_nn_1_1_N : N ;
  affaersavtal_nn_1_1_N : N ;
  affischnamn_nn_1_N : N ;
  affidavit_nn_1_N : N ;
  aeroplan_nn_1_N : N ;
  advokatkontor_nn_1_N : N ;
  adverbial_nn_1_N : N ;
  adverb_nn_1_N : N ;
  adresskort_nn_1_N : N ;
  adoptivbarn_nn_1_N : N ;
  adjektivattribut_nn_1_N : N ;
  adelsbrev_nn_1_N : N ;
  additament_nn_1_N : N ;
  ackusativobjekt_nn_1_N : N ;
  ackordgrepp_nn_1_N : N ;
  ackord_nn_2_N : N ;
  ackord_nn_1_N : N ;
  ackompanjemang_nn_1_N : N ;
  acerolakoersbaer_nn_1_1_N : N ;
  accidenstryck_nn_1_N : N ;
  accelerationsfaelt_nn_1_1_N : N ;
  absolutivsubjekt_nn_1_N : N ;
  absolutivobjekt_nn_1_N : N ;
  absolutbelopp_nn_1_N : N ;
  abortpiller_nn_1_N : N ;
  abortmotstaand_nn_1_1_N : N ;
  abonnemang_nn_1_N : N ;
  aber_nn_1_N : N ;
  abdikationshot_nn_1_N : N ;
  _15_aarsstraff_nn_1_1_N : N ;
  Visakort_nn_1_N : N ;
  Visa_kort_nn_1_N : N ;
  Vietnamkrig_nn_1_N : N ;
  Tjernobylnedfall_nn_1_N : N ;
  TV_abonnemang_nn_1_N : N ;
  Sverigemaesterskap_nn_1_1_N : N ;
  RUT_avdrag_nn_1_N : N ;
  ROT_avdrag_nn_1_N : N ;
  PCB_foerbud_nn_1_1_N : N ;
  Osloavtal_nn_1_N : N ;
  Natomedlemskap_nn_1_N : N ;
  Koepenhamnsackord_nn_1_1_N : N ;
  Koechelnummer_nn_1_1_N : N ;
  Koranbaal_nn_1_1_N : N ;
  Kinabesoek_nn_1_1_N : N ;
  Kairobesoek_nn_1_1_N : N ;
  IT_foeretag_nn_1_1_N : N ;
  IP_nummer_nn_1_N : N ;
  ID_kort_nn_1_N : N ;
  Gripenplan_nn_1_N : N ;
  FN_organ_nn_1_N : N ;
  EU_val_nn_1_N : N ;
  EU_parlament_nn_1_N : N ;
  Antarktisfoerdrag_nn_1_1_N : N ;
  Almedalstal_nn_1_N : N ;
  Almedalental_nn_1_N : N ;
  Alexanderhugg_nn_1_N : N ;
  vikande_nn_1_N : N ;
  vikarierande_nn_1_N : N ;
  viktande_nn_1_N : N ;
  vilande_nn_1_N : N ;
  viljande_nn_1_N : N ;
  villfarande_nn_1_N : N ;
  villkorande_nn_1_N : N ;
  vilsefoerande_nn_1_1_N : N ;
  vilseledande_nn_1_N : N ;
  vimlande_nn_1_N : N ;
  vimsande_nn_1_N : N ;
  vinande_nn_1_N : N ;
  vindande_nn_1_N : N ;
  vindfoerhaallande_nn_1_1_N : N ;
  vindicerande_nn_1_N : N ;
  vindlande_nn_1_N : N ;
  vindpollinerande_nn_1_N : N ;
  vindsurfande_nn_1_N : N ;
  vinglande_nn_1_N : N ;
  vinkande_nn_1_N : N ;
  vinklande_nn_1_N : N ;
  vinnande_nn_1_N : N ;
  vinschande_nn_1_N : N ;
  vinstmaximerande_nn_1_N : N ;
  vinstvarnande_nn_1_N : N ;
  vinterbadande_nn_1_N : N ;
  vinterbonande_nn_1_N : N ;
  vinteraepple_nn_1_1_N : N ;
  vippande_nn_1_N : N ;
  virande_nn_1_N : N ;
  virkande_nn_1_N : N ;
  virrande_nn_1_N : N ;
  virvlande_nn_1_N : N ;
  visande_nn_1_N : N ;
  viserande_nn_1_N : N ;
  visiterande_nn_1_N : N ;
  viskande_nn_1_N : N ;
  vispande_nn_1_N : N ;
  visslande_nn_1_N : N ;
  vissnande_nn_1_N : N ;
  visstidsfoerordnande_nn_1_1_N : N ;
  visualiserande_nn_1_N : N ;
  vitaliserande_nn_1_N : N ;
  vitaminerande_nn_1_N : N ;
  vitaminiserande_nn_1_N : N ;
  vitesfoerelaeggande_nn_1_1_N : N ;
  vitgloedgande_nn_1_1_N : N ;
  vitkalkande_nn_1_N : N ;
  vitlimmande_nn_1_N : N ;
  vitmenande_nn_1_N : N ;
  vitnande_nn_1_N : N ;
  vitrande_nn_1_N : N ;
  vitsande_nn_1_N : N ;
  vitsordande_nn_1_N : N ;
  vittande_nn_1_N : N ;
  vittjande_nn_1_N : N ;
  vittnande_nn_1_N : N ;
  vittrande_nn_1_N : N ;
  vokaliserande_nn_1_N : N ;
  volmande_nn_1_N : N ;
  voltande_nn_1_N : N ;
  voltigerande_nn_1_N : N ;
  vomerande_nn_1_N : N ;
  voterande_nn_1_N : N ;
  vrakande_nn_1_N : N ;
  vrickande_nn_1_N : N ;
  vridande_nn_1_N : N ;
  vraekande_nn_1_1_N : N ;
  vraengande_nn_1_1_N : N ;
  vraalande_nn_1_1_N : N ;
  vraalpluggande_nn_1_1_N : N ;
  vroevlande_nn_1_1_N : N ;
  vulande_nn_1_N : N ;
  vulgariserande_nn_1_N : N ;
  vulkande_nn_1_N : N ;
  vulkaniserande_nn_1_N : N ;
  vurmande_nn_1_N : N ;
  vurpande_nn_1_N : N ;
  vyssande_nn_1_N : N ;
  vyssjande_nn_1_N : N ;
  vaeckande_nn_1_1_N : N ;
  vaederfoerhaallande_nn_1_1_N : N ;
  vaedjande_nn_1_1_N : N ;
  vaedrande_nn_1_1_N : N ;
  vaegande_nn_1_1_N : N ;
  vaeggfaeste_nn_1_1_N : N ;
  vaeggmonterande_nn_1_1_N : N ;
  vaegledande_nn_1_1_N : N ;
  vaegrande_nn_1_1_N : N ;
  vaejande_nn_1_1_N : N ;
  vaelfaegnande_nn_1_1_N : N ;
  vaeljande_nn_1_1_N : N ;
  vaellande_nn_1_1_N : N ;
  vaelsignande_nn_1_1_N : N ;
  vaeltande_nn_1_1_N : N ;
  vaeltrande_nn_1_1_N : N ;
  vaelvande_nn_1_1_N : N ;
  vaemjande_nn_1_1_N : N ;
  vaendande_nn_1_1_N : N ;
  vaenjande_nn_1_1_N : N ;
  vaensterfaeste_nn_1_1_N : N ;
  vaensterknaeckande_nn_1_1_N : N ;
  vaensterprasslande_nn_1_1_N : N ;
  vaenstrande_nn_1_1_N : N ;
  vaentande_nn_1_1_N : N ;
  vaepnande_nn_1_1_N : N ;
  vaerde_nn_1_1_N : N ;
  vaerderande_nn_1_1_N : N ;
  vaerdesaekrande_nn_1_1_N : N ;
  vaerdesaettande_nn_1_1_N : N ;
  vaerjande_nn_1_1_N : N ;
  vaerkande_nn_1_1_N : N ;
  vaermande_nn_1_1_N : N ;
  vaermebehandlande_nn_1_1_N : N ;
  vaermefotograferande_nn_1_1_N : N ;
  vaermeisolerande_nn_1_1_N : N ;
  vaermesteriliserande_nn_1_1_N : N ;
  vaernande_nn_1_1_N : N ;
  vaerpande_nn_1_1_N : N ;
  vaervande_nn_1_1_N : N ;
  vaesende_nn_1_1_N : N ;
  vaessande_nn_1_1_N : N ;
  vaetande_nn_1_1_N : N ;
  vaetskande_nn_1_1_N : N ;
  vaevande_nn_1_1_N : N ;
  vaexande_nn_1_1_N : N ;
  vaexelverkande_nn_1_1_N : N ;
  vaexlande_nn_1_1_N : N ;
  vaadaskjutande_nn_1_1_N : N ;
  vaagande_nn_1_1_N : N ;
  vaagfoerande_nn_1_1_N : N ;
  vaaldgaestande_nn_1_1_N : N ;
  vaaldtagande_nn_1_1_N : N ;
  vaalmande_nn_1_1_N : N ;
  vaannande_nn_1_1_N : N ;
  vaarande_nn_1_1_N : N ;
  vaardande_nn_1_1_N : N ;
  vaardberoende_nn_1_1_N : N ;
  vaardsloesande_nn_1_1_N : N ;
  vaatkolande_nn_1_1_N : N ;
  vaatpressande_nn_1_1_N : N ;
  voerdande_nn_1_1_N : N ;
  x_ande_nn_1_N : N ;
  xande_nn_1_N : N ;
  ylande_nn_1_N : N ;
  ympande_nn_1_N : N ;
  ynglande_nn_1_N : N ;
  ynkande_nn_1_N : N ;
  yppande_nn_1_N : N ;
  yrande_nn_1_N : N ;
  yrkande_nn_1_N : N ;
  ystande_nn_1_N : N ;
  ytbehandlande_nn_1_N : N ;
  yttrande_nn_1_N : N ;
  zappande_nn_1_N : N ;
  zoomande_nn_1_N : N ;
  aecklande_nn_1_1_N : N ;
  aegande_nn_1_1_N : N ;
  aegandefoerhaallande_nn_1_1_N : N ;
  aegnande_nn_1_1_N : N ;
  aektande_nn_1_1_N : N ;
  aeldreboende_nn_1_1_N : N ;
  aelgande_nn_1_1_N : N ;
  aelskande_nn_1_1_N : N ;
  aeltande_nn_1_1_N : N ;
  aembetsaaliggande_nn_1_1_N : N ;
  aemnande_nn_1_1_N : N ;
  aemnesintegrerande_nn_1_1_N : N ;
  aendamaalsenlighetsavvaegande_nn_1_1_N : N ;
  aendande_nn_1_1_N : N ;
  aendrande_nn_1_1_N : N ;
  aendvaendande_nn_1_1_N : N ;
  aengslande_nn_1_1_N : N ;
  aentrande_nn_1_1_N : N ;
  aepple_nn_1_1_N : N ;
  aerande_nn_1_1_N : N ;
  aerekraenkande_nn_1_1_N : N ;
  aerende_nn_1_1_N : N ;
  aergande_nn_1_1_N : N ;
  aerjande_nn_1_1_N : N ;
  aernande_nn_1_1_N : N ;
  aervande_nn_1_1_N : N ;
  aeskande_nn_1_1_N : N ;
  aetande_nn_1_1_N : N ;
  aeventyrande_nn_1_1_N : N ;
  aaberopande_nn_1_1_N : N ;
  aadagalaeggande_nn_1_1_N : N ;
  aaderlaatande_nn_1_1_N : N ;
  aadragande_nn_1_1_N : N ;
  aadrande_nn_1_1_N : N ;
  aadoemande_nn_1_1_N : N ;
  aahoerande_nn_1_1_N : N ;
  aakallande_nn_1_1_N : N ;
  aakande_nn_1_1_N : N ;
  aaklagande_nn_1_1_N : N ;
  aalande_nn_1_1_N : N ;
  aaldersbestaemmande_nn_1_1_N : N ;
  aaldersdiskriminerande_nn_1_1_N : N ;
  aaliggande_nn_1_1_N : N ;
  aalaeggande_nn_1_1_N : N ;
  aangande_nn_1_1_N : N ;
  aangfoervaellande_nn_1_1_N : N ;
  aangkokande_nn_1_1_N : N ;
  aangrande_nn_1_1_N : N ;
  aartionde_nn_1_1_N : N ;
  aartusende_nn_1_1_N : N ;
  aasamkande_nn_1_1_N : N ;
  aaseende_nn_1_1_N : N ;
  aasidosaettande_nn_1_1_N : N ;
  aasiktsregistrerande_nn_1_1_N : N ;
  aaskande_nn_1_1_N : N ;
  aaskaadande_nn_1_1_N : N ;
  aaskaadliggoerande_nn_1_1_N : N ;
  aastadkommande_nn_1_1_N : N ;
  aastundande_nn_1_1_N : N ;
  aasyftande_nn_1_1_N : N ;
  aasaettande_nn_1_1_N : N ;
  aatagande_nn_1_1_N : N ;
  aatalande_nn_1_1_N : N ;
  aateranlaendande_nn_1_1_N : N ;
  aateranpassande_nn_1_1_N : N ;
  aateranskaffande_nn_1_1_N : N ;
  aateranvaendande_nn_1_1_N : N ;
  aaterberaettande_nn_1_1_N : N ;
  aaterbesoekande_nn_1_1_N : N ;
  aaterbetalande_nn_1_1_N : N ;
  aaterbildande_nn_1_1_N : N ;
  aaterboerdande_nn_1_1_N : N ;
  aatereroevrande_nn_1_1_N : N ;
  aaterfallande_nn_1_1_N : N ;
  aaterfinnande_nn_1_1_N : N ;
  aaterflyttande_nn_1_1_N : N ;
  aaterfaaende_nn_1_1_N : N ;
  aaterfoerande_nn_1_1_N : N ;
  aaterfoerenande_nn_1_1_N : N ;
  aaterfoerslutande_nn_1_1_N : N ;
  aaterfoersaekrande_nn_1_1_N : N ;
  aaterfoersaeljande_nn_1_1_N : N ;
  aatergivande_nn_1_1_N : N ;
  aatergaeldande_nn_1_1_N : N ;
  aatergaaende_nn_1_1_N : N ;
  aaterhaemtande_nn_1_1_N : N ;
  aaterhaallande_nn_1_1_N : N ;
  aaterinfoerande_nn_1_1_N : N ;
  aaterinstallerande_nn_1_1_N : N ;
  aaterinsaettande_nn_1_1_N : N ;
  aaterkallande_nn_1_1_N : N ;
  aaterkastande_nn_1_1_N : N ;
  aaterklingande_nn_1_1_N : N ;
  aaterknytande_nn_1_1_N : N ;
  aaterkommande_nn_1_1_N : N ;
  aaterkopplande_nn_1_1_N : N ;
  aaterlaemnande_nn_1_1_N : N ;
  aaterloesande_nn_1_1_N : N ;
  aaterropande_nn_1_1_N : N ;
  aaterskallande_nn_1_1_N : N ;
  aaterspeglande_nn_1_1_N : N ;
  aaterstudsande_nn_1_1_N : N ;
  aaterstaellande_nn_1_1_N : N ;
  aaterstaaende_nn_1_1_N : N ;
  aatersaeljande_nn_1_1_N : N ;
  aatersaendande_nn_1_1_N : N ;
  aatertagande_nn_1_1_N : N ;
  aatertaagande_nn_1_1_N : N ;
  aateruppbyggande_nn_1_1_N : N ;
  aaterupplivande_nn_1_1_N : N ;
  aateruppraettande_nn_1_1_N : N ;
  aateruppstaaende_nn_1_1_N : N ;
  aaterupptagande_nn_1_1_N : N ;
  aateruppvaeckande_nn_1_1_N : N ;
  aaterutstraalande_nn_1_1_N : N ;
  aaterutsaendande_nn_1_1_N : N ;
  aaterverkande_nn_1_1_N : N ;
  aatervinnande_nn_1_1_N : N ;
  aatervaeljande_nn_1_1_N : N ;
  aatervaendande_nn_1_1_N : N ;
  aatfoeljande_nn_1_1_N : N ;
  aatgaerdande_nn_1_1_N : N ;
  aatgaaende_nn_1_1_N : N ;
  aatgoerande_nn_1_1_N : N ;
  aatlydande_nn_1_1_N : N ;
  aatrande_nn_1_1_N : N ;
  aatraaende_nn_1_1_N : N ;
  aatskiljande_nn_1_1_N : N ;
  aatstramande_nn_1_1_N : N ;
  aavilande_nn_1_1_N : N ;
  aavaegabringande_nn_1_1_N : N ;
  oedande_nn_1_1_N : N ;
  oedelaeggande_nn_1_1_N : N ;
  oedmjukande_nn_1_1_N : N ;
  oedslande_nn_1_1_N : N ;
  oegnande_nn_1_1_N : N ;
  oegonflirtande_nn_1_1_N : N ;
  oegonfloertande_nn_1_1_N : N ;
  oekande_nn_1_1_N : N ;
  oelande_nn_1_1_N : N ;
  oemkande_nn_1_1_N : N ;
  oemmande_nn_1_1_N : N ;
  oemsande_nn_1_1_N : N ;
  oenskande_nn_1_1_N : N ;
  oeppnande_nn_1_1_N : N ;
  oerfilande_nn_1_1_N : N ;
  oerlande_nn_1_1_N : N ;
  oeronmaerkande_nn_1_1_N : N ;
  oesande_nn_1_1_N : N ;
  oesregnande_nn_1_1_N : N ;
  oevande_nn_1_1_N : N ;
  oeveranstraengande_nn_1_1_N : N ;
  oeverantvardande_nn_1_1_N : N ;
  oeveranvaendande_nn_1_1_N : N ;
  oeverarbetande_nn_1_1_N : N ;
  oeverbefolkande_nn_1_1_N : N ;
  oeverbevisande_nn_1_1_N : N ;
  oeverbjudande_nn_1_1_N : N ;
  oeverblickande_nn_1_1_N : N ;
  oeverbokande_nn_1_1_N : N ;
  oeverbringande_nn_1_1_N : N ;
  oeverbryggande_nn_1_1_N : N ;
  oeverdimensionerande_nn_1_1_N : N ;
  oeverdoserande_nn_1_1_N : N ;
  oeverdragande_nn_1_1_N : N ;
  oeverdrivande_nn_1_1_N : N ;
  oeverenskommande_nn_1_1_N : N ;
  oeverensstaemmande_nn_1_1_N : N ;
  oeverexponerande_nn_1_1_N : N ;
  oeverfallande_nn_1_1_N : N ;
  oeverflyglande_nn_1_1_N : N ;
  oeverflyttande_nn_1_1_N : N ;
  oeverfloedande_nn_1_1_N : N ;
  oeverfoerande_nn_1_1_N : N ;
  oevergivande_nn_1_1_N : N ;
  oeverglaensande_nn_1_1_N : N ;
  oevergaaende_nn_1_1_N : N ;
  oevergaangsstaelle_nn_1_1_N : N ;
  oevergoedande_nn_1_1_N : N ;
  oeverhettande_nn_1_1_N : N ;
  oeverhopande_nn_1_1_N : N ;
  oeverhoppande_nn_1_1_N : N ;
  oeverhoeljande_nn_1_1_N : N ;
  oeverklagande_nn_1_1_N : N ;
  oeverkompenserande_nn_1_1_N : N ;
  oeverlagrande_nn_1_1_N : N ;
  oeverlappande_nn_1_1_N : N ;
  oeverlevande_nn_1_1_N : N ;
  oeverlistande_nn_1_1_N : N ;
  oeverlaeggande_nn_1_1_N : N ;
  oeverlaemnande_nn_1_1_N : N ;
  oeverlaatande_nn_1_1_N : N ;
  oevermannande_nn_1_1_N : N ;
  oevernattande_nn_1_1_N : N ;
  oeverordnande_nn_1_1_N : N ;
  oeverproevande_nn_1_1_N : N ;
  oeverraskande_nn_1_1_N : N ;
  oeverrumplande_nn_1_1_N : N ;
  oeverraeckande_nn_1_1_N : N ;
  oeverroestande_nn_1_1_N : N ;
  oeverseende_nn_1_1_N : N ;
  oeverskridande_nn_1_1_N : N ;
  oeverskuggande_nn_1_1_N : N ;
  oeverskyggande_nn_1_1_N : N ;
  oeverskylande_nn_1_1_N : N ;
  oeverskaadande_nn_1_1_N : N ;
  oeverskoeljande_nn_1_1_N : N ;
  oeverstegrande_nn_1_1_N : N ;
  oeverstigande_nn_1_1_N : N ;
  oeversvaemmande_nn_1_1_N : N ;
  oeversaendande_nn_1_1_N : N ;
  oeversaettande_nn_1_1_N : N ;
  oevertagande_nn_1_1_N : N ;
  oevertalande_nn_1_1_N : N ;
  oevertecknande_nn_1_1_N : N ;
  oevertrasserande_nn_1_1_N : N ;
  oevertrumfande_nn_1_1_N : N ;
  oevertraedande_nn_1_1_N : N ;
  oevertraeffande_nn_1_1_N : N ;
  oevertygande_nn_1_1_N : N ;
  oeverutnyttjande_nn_1_1_N : N ;
  oevervakande_nn_1_1_N : N ;
  oevervarande_nn_1_1_N : N ;
  oevervinnande_nn_1_1_N : N ;
  oevervintrande_nn_1_1_N : N ;
  oevervaegande_nn_1_1_N : N ;
  oevervaeldigande_nn_1_1_N : N ;
  oevervaeltrande_nn_1_1_N : N ;
  oevervaerderande_nn_1_1_N : N ;
  oegonvraa_nn_1_1_N : N ;
  aasnesto_nn_1_1_N : N ;
  aasneskri_nn_1_1_N : N ;
  aangestskri_nn_1_1_N : N ;
  vinkelknae_nn_1_1_N : N ;
  vibrato_nn_1_N : N ;
  veto_nn_1_N : N ;
  ventilgummi_nn_1_N : N ;
  vedtrae_nn_1_1_N : N ;
  vaxschampo_nn_1_N : N ;
  vattenbi_nn_1_N : N ;
  vallmofroe_nn_1_1_N : N ;
  valfiasko_nn_1_N : N ;
  urskri_nn_1_N : N ;
  urarvabo_nn_1_N : N ;
  ufo_nn_1_N : N ;
  tvistefroe_nn_1_1_N : N ;
  tutti_nn_1_N : N ;
  tuggummi_nn_1_N : N ;
  trae_nn_2_1_N : N ;
  trollspoe_nn_1_1_N : N ;
  tremolo_nn_1_N : N ;
  trema_nn_1_N : N ;
  torrschampo_nn_1_N : N ;
  tivoli_nn_1_N : N ;
  tillgodokvitto_nn_1_N : N ;
  tigerhjaerta_nn_1_1_N : N ;
  tidsschema_nn_1_N : N ;
  telefoto_nn_1_N : N ;
  tapto_nn_1_N : N ;
  tankefroe_nn_1_1_N : N ;
  tabu_nn_1_N : N ;
  saelltrae_nn_1_1_N : N ;
  sumo_nn_2_N : N ;
  suddgummi_nn_1_N : N ;
  styckningsschema_nn_1_N : N ;
  straa_nn_1_1_N : N ;
  sto_nn_1_N : N ;
  stinkfly_nn_1_N : N ;
  stackato_nn_1_N : N ;
  spoe_nn_1_1_N : N ;
  spaerrkonto_nn_1_1_N : N ;
  spri_nn_1_N : N ;
  spinnspoe_nn_1_1_N : N ;
  spikpiano_nn_1_N : N ;
  specialkommando_nn_1_N : N ;
  sparkonto_nn_1_N : N ;
  spa_nn_1_N : N ;
  solrosfroe_nn_1_1_N : N ;
  snyltbi_nn_1_N : N ;
  snabbfoto_nn_1_N : N ;
  smaagli_nn_1_1_N : N ;
  smultronstraa_nn_1_1_N : N ;
  smarto_nn_1_N : N ;
  sly_nn_1_N : N ;
  slantspoe_nn_1_1_N : N ;
  slagtrae_nn_1_1_N : N ;
  skoenhetstuggummi_nn_1_1_N : N ;
  skaekttrae_nn_1_1_N : N ;
  skaektetrae_nn_1_1_N : N ;
  skaeggstraa_nn_1_1_N : N ;
  skumhjaerta_nn_1_1_N : N ;
  skraa_nn_1_1_N : N ;
  skri_nn_1_N : N ;
  sidoaltare_nn_1_N : N ;
  shampoo_nn_1_N : N ;
  sesamfroe_nn_1_1_N : N ;
  scherzo_nn_1_N : N ;
  schema_nn_1_N : N ;
  schampo_nn_1_N : N ;
  saldo_nn_1_N : N ;
  roerelsekommando_nn_1_1_N : N ;
  raattbo_nn_1_1_N : N ;
  rondo_nn_1_N : N ;
  ritardando_nn_1_N : N ;
  ridspoe_nn_1_1_N : N ;
  ri_nn_1_N : N ;
  returporto_nn_1_N : N ;
  restaurangalibi_nn_1_N : N ;
  renhjaerta_nn_1_1_N : N ;
  reklamjippo_nn_1_N : N ;
  randdelta_nn_1_N : N ;
  ramaskri_nn_1_N : N ;
  rally_nn_1_N : N ;
  radergummi_nn_1_N : N ;
  pyjamasparty_nn_1_N : N ;
  pucko_nn_1_N : N ;
  prydnadshjaerta_nn_1_1_N : N ;
  prisrally_nn_1_N : N ;
  pretto_nn_1_N : N ;
  presto_nn_1_N : N ;
  praktfiasko_nn_1_N : N ;
  postgirokonto_nn_1_N : N ;
  postgiro_nn_1_N : N ;
  porto_nn_1_N : N ;
  portamento_nn_1_N : N ;
  pizzicato_nn_1_N : N ;
  pimpelspoe_nn_1_1_N : N ;
  piano_nn_1_N : N ;
  pianissimo_nn_1_N : N ;
  pianino_nn_1_N : N ;
  pervo_nn_1_N : N ;
  personkonto_nn_1_N : N ;
  pentry_nn_1_N : N ;
  peddo_nn_1_N : N ;
  passfoto_nn_1_N : N ;
  party_nn_1_N : N ;
  parlando_nn_1_N : N ;
  paradisfroe_nn_1_1_N : N ;
  pansarhjaerta_nn_1_1_N : N ;
  ostinato_nn_1_N : N ;
  ormbo_nn_1_N : N ;
  okynnesfae_nn_1_1_N : N ;
  odensfly_nn_1_N : N ;
  nyteckning_nn_1_N : N ;
  netto_nn_1_N : N ;
  nattfly_nn_1_N : N ;
  maalfoto_nn_1_1_N : N ;
  maenniskohjaerta_nn_1_1_N : N ;
  maehae_nn_1_1_N : N ;
  mysfyllo_nn_1_N : N ;
  motto_nn_1_N : N ;
  mongo_nn_1_N : N ;
  modershjaerta_nn_1_1_N : N ;
  mjaellschampo_nn_1_1_N : N ;
  mjau_nn_1_N : N ;
  milo_nn_1_N : N ;
  mikrofoto_nn_1_N : N ;
  miko_nn_1_N : N ;
  miffo_nn_1_N : N ;
  metspoe_nn_1_1_N : N ;
  memento_nn_1_N : N ;
  melodrama_nn_1_N : N ;
  medelklassghetto_nn_1_N : N ;
  medelklassgetto_nn_1_N : N ;
  mecka_nn_1_N : N ;
  meccano_nn_1_N : N ;
  mantra_nn_1_N : N ;
  manko_nn_1_N : N ;
  loejtnantshjaerta_nn_1_1_N : N ;
  laerkbo_nn_1_1_N : N ;
  linfroe_nn_1_1_N : N ;
  lemma_nn_1_N : N ;
  lego_nn_1_N : N ;
  legato_nn_1_N : N ;
  largo_nn_1_N : N ;
  largetto_nn_1_N : N ;
  lagtempo_nn_1_N : N ;
  kvitto_nn_1_N : N ;
  kuttrasju_nn_1_N : N ;
  krypto_nn_1_N : N ;
  kostschema_nn_1_N : N ;
  kopplingsschema_nn_1_N : N ;
  konto_nn_1_N : N ;
  konkursbo_nn_1_N : N ;
  kommando_nn_1_N : N ;
  komma_nn_1_N : N ;
  kollo_nn_1_N : N ;
  knae_nn_1_1_N : N ;
  klapptrae_nn_1_1_N : N ;
  kasttrae_nn_1_1_N : N ;
  kastspoe_nn_1_1_N : N ;
  kassakvitto_nn_1_N : N ;
  kasko_nn_1_N : N ;
  kasino_nn_1_N : N ;
  kapitalkonto_nn_1_N : N ;
  kanariefroe_nn_1_1_N : N ;
  kammarpiano_nn_1_N : N ;
  jaettefiasko_nn_1_1_N : N ;
  jaemmerskri_nn_1_1_N : N ;
  jordfly_nn_1_N : N ;
  jordbi_nn_1_N : N ;
  jippo_nn_1_N : N ;
  intermezzo_nn_1_N : N ;
  inferno_nn_1_N : N ;
  impromptu_nn_1_N : N ;
  hoegaltare_nn_1_1_N : N ;
  haarstraa_nn_1_1_N : N ;
  haarschampo_nn_1_1_N : N ;
  haerskri_nn_1_1_N : N ;
  hygglo_nn_1_N : N ;
  hosianna_nn_1_N : N ;
  hjaerta_nn_1_1_N : N ;
  hampfroe_nn_1_1_N : N ;
  halmstraa_nn_1_1_N : N ;
  halmhjaerta_nn_1_1_N : N ;
  halleluja_nn_1_N : N ;
  gyro_nn_1_N : N ;
  gungfly_nn_1_N : N ;
  gummi_nn_1_N : N ;
  graesstraa_nn_1_1_N : N ;
  graesfly_nn_1_1_N : N ;
  grisningsbo_nn_1_N : N ;
  goraa_nn_1_1_N : N ;
  godishjaerta_nn_1_1_N : N ;
  glissando_nn_1_N : N ;
  gli_nn_1_N : N ;
  giro_nn_1_N : N ;
  ghetto_nn_1_N : N ;
  getto_nn_1_N : N ;
  getingbo_nn_1_N : N ;
  gammafly_nn_1_N : N ;
  foerklae_nn_1_1_N : N ;
  foeretagsfiasko_nn_1_1_N : N ;
  foelsto_nn_1_1_N : N ;
  foedsloskri_nn_1_1_N : N ;
  faagelbo_nn_1_1_N : N ;
  fae_nn_1_1_N : N ;
  fyllo_nn_1_N : N ;
  furioso_nn_1_N : N ;
  foto_nn_1_N : N ;
  fortissimo_nn_1_N : N ;
  fortepiano_nn_1_N : N ;
  floedesschema_nn_1_1_N : N ;
  flygfae_nn_1_1_N : N ;
  flygfoto_nn_1_N : N ;
  fly_nn_1_N : N ;
  fjaederfae_nn_1_1_N : N ;
  finansnetto_nn_1_N : N ;
  fiasko_nn_1_N : N ;
  fetto_nn_1_N : N ;
  fetthjaerta_nn_1_1_N : N ;
  familjefoto_nn_1_N : N ;
  fadershjaerta_nn_1_1_N : N ;
  enhetsporto_nn_1_N : N ;
  embryo_nn_1_N : N ;
  eldorado_nn_1_N : N ;
  eldkommando_nn_1_N : N ;
  eko_nn_1_N : N ;
  doedsbo_nn_1_1_N : N ;
  dubbelkommando_nn_1_N : N ;
  diskonto_nn_1_N : N ;
  disko_nn_1_N : N ;
  disco_nn_1_N : N ;
  diminuendo_nn_1_N : N ;
  dilemma_nn_1_N : N ;
  derby_nn_1_N : N ;
  delta_nn_1_N : N ;
  decimalkomma_nn_1_N : N ;
  dakapo_nn_1_N : N ;
  crescendo_nn_1_N : N ;
  credo_nn_1_N : N ;
  cocktailparty_nn_1_N : N ;
  city_nn_1_N : N ;
  checkkonto_nn_1_N : N ;
  baatskraa_nn_1_1_N : N ;
  byxknae_nn_1_1_N : N ;
  busksly_nn_1_N : N ;
  busfroe_nn_1_1_N : N ;
  budgetspa_nn_1_N : N ;
  broellopsfoto_nn_1_1_N : N ;
  braennbollstrae_nn_1_1_N : N ;
  brutto_nn_1_N : N ;
  brudfoto_nn_1_N : N ;
  brevporto_nn_1_N : N ;
  brakfiasko_nn_1_N : N ;
  bortafiasko_nn_1_N : N ;
  bomullsfroe_nn_1_1_N : N ;
  bolltrae_nn_1_1_N : N ;
  bockhornskloeverfroe_nn_1_1_N : N ;
  bo_nn_1_N : N ;
  blixtfoto_nn_1_N : N ;
  bilschampo_nn_1_N : N ;
  bilrally_nn_1_N : N ;
  bi_nn_1_N : N ;
  basebolltrae_nn_1_1_N : N ;
  basebollstrae_nn_1_1_N : N ;
  baseballtrae_nn_1_1_N : N ;
  baseballstrae_nn_1_1_N : N ;
  barnlaekarskraa_nn_1_1_N : N ;
  barnahjaerta_nn_1_1_N : N ;
  bankkonto_nn_1_N : N ;
  bankgiro_nn_1_N : N ;
  balkknae_nn_1_1_N : N ;
  balanskonto_nn_1_N : N ;
  avelssto_nn_1_N : N ;
  arpeggio_nn_1_N : N ;
  arioso_nn_1_N : N ;
  arbetsschema_nn_1_N : N ;
  arbetsbi_nn_1_N : N ;
  anskri_nn_1_N : N ;
  ankarfly_nn_1_N : N ;
  altare_nn_1_N : N ;
  allegro_nn_1_N : N ;
  allegretto_nn_1_N : N ;
  alibi_nn_1_N : N ;
  adjoe_nn_1_1_N : N ;
  adagio_nn_1_N : N ;
  aluminiumfolie_nn_1_N : N ;
  blyfolie_nn_1_N : N ;
  folie_nn_1_N : N ;
  ganglie_nn_1_N : N ;
  plastfolie_nn_1_N : N ;
  silverfolie_nn_1_N : N ;
  staerkelse_nn_1_1_N : N ;
  tennfolie_nn_1_N : N ;
  vaeckelse_nn_1_1_N : N ;
  vaeckelseroerelse_nn_1_1_N : N ;
  vaegfoerbindelse_nn_1_1_N : N ;
  vaelsignelse_nn_1_1_N : N ;
  vaendradie_nn_1_1_N : N ;
  vaenskapsfoerbindelse_nn_1_1_N : N ;
  vaerdefoersaendelse_nn_1_1_N : N ;
  vaerdshusroerelse_nn_1_1_N : N ;
  vaerldsfoersakelse_nn_1_1_N : N ;
  vaerldshaendelse_nn_1_1_N : N ;
  vaerldsmedborgarroerelse_nn_1_1_N : N ;
  vaaglinje_nn_1_1_N : N ;
  vaagroerelse_nn_1_1_N : N ;
  vaardlinje_nn_1_1_N : N ;
  voerdnadsbetygelse_nn_1_1_N : N ;
  ynnestbetygelse_nn_1_N : N ;
  aendelse_nn_1_1_N : N ;
  aerebetygelse_nn_1_1_N : N ;
  aerkefiende_nn_1_1_N : N ;
  aabo_nn_1_1_N : N ;
  aarsberaettelse_nn_1_1_N : N ;
  aasiktsfoerfoeljelse_nn_1_1_N : N ;
  aaterkallelse_nn_1_1_N : N ;
  aateruppstaandelse_nn_1_1_N : N ;
  aateruppvaeckelse_nn_1_1_N : N ;
  oedelaeggelse_nn_1_1_N : N ;
  oegonroerelse_nn_1_1_N : N ;
  oeverenskommelse_nn_1_1_N : N ;
  oeverensstaemmelse_nn_1_1_N : N ;
  oeverlaatelse_nn_1_1_N : N ;
  oevertraedelse_nn_1_1_N : N ;
  oevertygelse_nn_1_1_N : N ;
  DNA_testande_nn_1_N : N ;
  K_maerkande_nn_1_1_N : N ;
  TV_tittande_nn_1_N : N ;
  USB_minne_nn_1_N : N ;
  _1800_talsmode_nn_1_N : N ;
  abbrevierande_nn_1_N : N ;
  abdikerande_nn_1_N : N ;
  abonnerande_nn_1_N : N ;
  aborterande_nn_1_N : N ;
  abraderande_nn_1_N : N ;
  absolverande_nn_1_N : N ;
  absorberande_nn_1_N : N ;
  abstraherande_nn_1_N : N ;
  accederande_nn_1_N : N ;
  accelererande_nn_1_N : N ;
  accentuerande_nn_1_N : N ;
  accepterande_nn_1_N : N ;
  accessande_nn_1_N : N ;
  acklimatiserande_nn_1_N : N ;
  ackommoderande_nn_1_N : N ;
  ackompanjerande_nn_1_N : N ;
  ackorderande_nn_1_N : N ;
  ackordsarbete_nn_1_N : N ;
  ackrediterande_nn_1_N : N ;
  ackumulerande_nn_1_N : N ;
  ackvirerande_nn_1_N : N ;
  adamsaepple_nn_1_1_N : N ;
  adapterande_nn_1_N : N ;
  adderande_nn_1_N : N ;
  adelsmaerke_nn_1_1_N : N ;
  adjungerande_nn_1_N : N ;
  adlande_nn_1_N : N ;
  administrerande_nn_1_N : N ;
  adopterande_nn_1_N : N ;
  adresserande_nn_1_N : N ;
  adsorberande_nn_1_N : N ;
  aducerande_nn_1_N : N ;
  advocerande_nn_1_N : N ;
  affektionsvaerde_nn_1_1_N : N ;
  afficierande_nn_1_N : N ;
  affinerande_nn_1_N : N ;
  affischerande_nn_1_N : N ;
  affaersbitraede_nn_1_1_N : N ;
  afrikaniserande_nn_1_N : N ;
  agande_nn_1_N : N ;
  agerande_nn_1_N : N ;
  agglomererande_nn_1_N : N ;
  agglutinerande_nn_1_N : N ;
  agiterande_nn_1_N : N ;
  agnande_nn_1_N : N ;
  ajournerande_nn_1_N : N ;
  aktande_nn_1_N : N ;
  aktieaegande_nn_1_1_N : N ;
  aktiverande_nn_1_N : N ;
  aktstycke_nn_1_N : N ;
  aktualiserande_nn_1_N : N ;
  alarmerande_nn_1_N : N ;
  alfabetiserande_nn_1_N : N ;
  alfaagelskytte_nn_1_1_N : N ;
  alienerande_nn_1_N : N ;
  allegoriserande_nn_1_N : N ;
  allenastyre_nn_1_N : N ;
  allierande_nn_1_N : N ;
  allittererande_nn_1_N : N ;
  allmaenbildande_nn_1_1_N : N ;
  allmaenintresse_nn_1_1_N : N ;
  allokerande_nn_1_N : N ;
  alluderande_nn_1_N : N ;
  alstrande_nn_1_N : N ;
  altanfaeste_nn_1_1_N : N ;
  altarklaede_nn_1_1_N : N ;
  alternerande_nn_1_N : N ;
  aluminerande_nn_1_N : N ;
  alvluckrande_nn_1_N : N ;
  amalgamerande_nn_1_N : N ;
  ambulerande_nn_1_N : N ;
  amerikaniserande_nn_1_N : N ;
  ammande_nn_1_N : N ;
  amorterande_nn_1_N : N ;
  amplifierande_nn_1_N : N ;
  amplitudmodulerande_nn_1_N : N ;
  amputerande_nn_1_N : N ;
  analyserande_nn_1_N : N ;
  anammande_nn_1_N : N ;
  anande_nn_1_N : N ;
  anbefallande_nn_1_N : N ;
  anbelangande_nn_1_N : N ;
  anbringande_nn_1_N : N ;
  andante_nn_1_N : N ;
  andragande_nn_1_N : N ;
  andrahandsvaerde_nn_1_1_N : N ;
  anfallande_nn_1_N : N ;
  anfallsomraade_nn_1_1_N : N ;
  anfraetande_nn_1_1_N : N ;
  anfaektande_nn_1_1_N : N ;
  anfoerande_nn_1_1_N : N ;
  anfoertroende_nn_1_1_N : N ;
  angivande_nn_1_N : N ;
  anglande_nn_1_N : N ;
  angliserande_nn_1_N : N ;
  angripande_nn_1_N : N ;
  angraensande_nn_1_1_N : N ;
  angoerande_nn_1_1_N : N ;
  anhopande_nn_1_N : N ;
  anhaallande_nn_1_1_N : N ;
  animerande_nn_1_N : N ;
  ankarfaeste_nn_1_1_N : N ;
  anklagande_nn_1_N : N ;
  anknytande_nn_1_N : N ;
  ankommande_nn_1_N : N ;
  ankrande_nn_1_N : N ;
  anlete_nn_1_N : N ;
  anliggande_nn_1_N : N ;
  anlitande_nn_1_N : N ;
  anlaendande_nn_1_1_N : N ;
  anloepande_nn_1_1_N : N ;
  anmanande_nn_1_N : N ;
  anmodande_nn_1_N : N ;
  anmaelande_nn_1_1_N : N ;
  anmaerkande_nn_1_1_N : N ;
  annekterande_nn_1_N : N ;
  annihilerande_nn_1_N : N ;
  annonserande_nn_1_N : N ;
  annoterande_nn_1_N : N ;
  annullerande_nn_1_N : N ;
  anodiserande_nn_1_N : N ;
  anonymiserande_nn_1_N : N ;
  anordnande_nn_1_N : N ;
  anpassande_nn_1_N : N ;
  anrikande_nn_1_N : N ;
  anropande_nn_1_N : N ;
  anraettande_nn_1_1_N : N ;
  ansamlande_nn_1_N : N ;
  ansande_nn_1_N : N ;
  anseende_nn_1_N : N ;
  ansikte_nn_1_N : N ;
  anskaffande_nn_1_N : N ;
  anslagsaeskande_nn_1_1_N : N ;
  anslutande_nn_1_N : N ;
  anslaaende_nn_1_1_N : N ;
  anspelande_nn_1_N : N ;
  anstiftande_nn_1_N : N ;
  anstormande_nn_1_N : N ;
  anstrykande_nn_1_N : N ;
  anstraengande_nn_1_1_N : N ;
  anstaellande_nn_1_1_N : N ;
  anstaaende_nn_1_1_N : N ;
  ansvarande_nn_1_N : N ;
  ansvarsomraade_nn_1_1_N : N ;
  ansvarsutkraevande_nn_1_1_N : N ;
  ansvaellande_nn_1_1_N : N ;
  ansaettande_nn_1_1_N : N ;
  ansoekande_nn_1_1_N : N ;
  antagande_nn_1_N : N ;
  antastande_nn_1_N : N ;
  anteciperande_nn_1_N : N ;
  antecknande_nn_1_N : N ;
  antedaterande_nn_1_N : N ;
  antichambrerande_nn_1_N : N ;
  antikbehandlande_nn_1_N : N ;
  antikfyndande_nn_1_N : N ;
  antikiserande_nn_1_N : N ;
  antraedande_nn_1_1_N : N ;
  antraeffande_nn_1_1_N : N ;
  antvardande_nn_1_N : N ;
  antydande_nn_1_N : N ;
  antaendande_nn_1_1_N : N ;
  antaagande_nn_1_1_N : N ;
  anvisande_nn_1_N : N ;
  anvaendande_nn_1_1_N : N ;
  anvaendningsomraade_nn_1_1_N : N ;
  apostroferande_nn_1_N : N ;
  appellerande_nn_1_N : N ;
  applicerande_nn_1_N : N ;
  applaaderande_nn_1_1_N : N ;
  apporterande_nn_1_N : N ;
  apprecierande_nn_1_N : N ;
  appreterande_nn_1_N : N ;
  approcherande_nn_1_N : N ;
  approximerande_nn_1_N : N ;
  apterande_nn_1_N : N ;
  arbetande_nn_1_N : N ;
  arbete_nn_1_N : N ;
  arbetsbyte_nn_1_N : N ;
  arbetsfoerhaallande_nn_1_1_N : N ;
  arbetsgivarintraede_nn_1_1_N : N ;
  arbetsminne_nn_1_N : N ;
  arbetsomraade_nn_1_1_N : N ;
  arbetspendlande_nn_1_N : N ;
  arbetsstycke_nn_1_N : N ;
  arbetstillfaelle_nn_1_1_N : N ;
  arborrande_nn_1_N : N ;
  arenabygge_nn_1_N : N ;
  argumenterande_nn_1_N : N ;
  arkaiserande_nn_1_N : N ;
  arkebuserande_nn_1_N : N ;
  arkivarbete_nn_1_N : N ;
  arkiverande_nn_1_N : N ;
  armbaagande_nn_1_1_N : N ;
  armerande_nn_1_N : N ;
  arrangerande_nn_1_N : N ;
  arrende_nn_1_N : N ;
  arrenderande_nn_1_N : N ;
  arresterande_nn_1_N : N ;
  arriaergarde_nn_1_1_N : N ;
  arronderande_nn_1_N : N ;
  arsle_nn_1_N : N ;
  artbestaemmande_nn_1_1_N : N ;
  artikulationsstaelle_nn_1_1_N : N ;
  artikulerande_nn_1_N : N ;
  artilleriregemente_nn_1_N : N ;
  artistframtraedande_nn_1_1_N : N ;
  artonhundratalsmode_nn_1_N : N ;
  arvode_nn_1_N : N ;
  arvoderande_nn_1_N : N ;
  arvrike_nn_1_N : N ;
  arvskifte_nn_1_N : N ;
  asande_nn_1_N : N ;
  asfalterande_nn_1_N : N ;
  askande_nn_1_N : N ;
  aspirerande_nn_1_N : N ;
  assignerande_nn_1_N : N ;
  assimilerande_nn_1_N : N ;
  assisterande_nn_1_N : N ;
  associerande_nn_1_N : N ;
  assurerande_nn_1_N : N ;
  atombombande_nn_1_N : N ;
  atrofierande_nn_1_N : N ;
  attackerande_nn_1_N : N ;
  attesterande_nn_1_N : N ;
  attraherande_nn_1_N : N ;
  attrapperande_nn_1_N : N ;
  attribuerande_nn_1_N : N ;
  auktionerande_nn_1_N : N ;
  auktoriserande_nn_1_N : N ;
  auskulterande_nn_1_N : N ;
  autenticerande_nn_1_N : N ;
  autentifierande_nn_1_N : N ;
  autentiserande_nn_1_N : N ;
  automatiserande_nn_1_N : N ;
  avancerande_nn_1_N : N ;
  avande_nn_1_N : N ;
  avannonserande_nn_1_N : N ;
  avbalkande_nn_1_N : N ;
  avbestaellande_nn_1_1_N : N ;
  avbetalande_nn_1_N : N ;
  avbetande_nn_1_N : N ;
  avbildande_nn_1_N : N ;
  avblaasande_nn_1_1_N : N ;
  avbokande_nn_1_N : N ;
  avbrytande_nn_1_N : N ;
  avboejande_nn_1_1_N : N ;
  avboerdande_nn_1_1_N : N ;
  avdagatagande_nn_1_N : N ;
  avdelande_nn_1_N : N ;
  avdramatiserande_nn_1_N : N ;
  avdrivande_nn_1_N : N ;
  avdunstande_nn_1_N : N ;
  avdaemmande_nn_1_1_N : N ;
  avdoemande_nn_1_1_N : N ;
  ave_nn_1_N : N ;
  avfallande_nn_1_N : N ;
  avfattande_nn_1_N : N ;
  avfettande_nn_1_N : N ;
  avflyttande_nn_1_N : N ;
  avfloede_nn_1_1_N : N ;
  avfolkande_nn_1_N : N ;
  avfordrande_nn_1_N : N ;
  avfrostande_nn_1_N : N ;
  avfuktande_nn_1_N : N ;
  avfyrande_nn_1_N : N ;
  avfaerdande_nn_1_1_N : N ;
  avfoerande_nn_1_1_N : N ;
  avgiftande_nn_1_N : N ;
  avgiftsbelaeggande_nn_1_1_N : N ;
  avgivande_nn_1_N : N ;
  avgraensande_nn_1_1_N : N ;
  avgudande_nn_1_N : N ;
  avgaerdande_nn_1_1_N : N ;
  avgaaende_nn_1_1_N : N ;
  avgoerande_nn_1_1_N : N ;
  avhandlande_nn_1_N : N ;
  avhjaelpande_nn_1_1_N : N ;
  avhysande_nn_1_N : N ;
  avhaemtande_nn_1_1_N : N ;
  avhaendande_nn_1_1_N : N ;
  avhaengande_nn_1_1_N : N ;
  avhaerdande_nn_1_1_N : N ;
  avhaallande_nn_1_1_N : N ;
  avhoerande_nn_1_1_N : N ;
  avhoestande_nn_1_1_N : N ;
  avisande_nn_1_N : N ;
  aviserande_nn_1_N : N ;
  avjagande_nn_1_N : N ;
  avjaemnande_nn_1_1_N : N ;
  avkalkande_nn_1_N : N ;
  avkastande_nn_1_N : N ;
  avklarande_nn_1_N : N ;
  avklingande_nn_1_N : N ;
  avklaedande_nn_1_1_N : N ;
  avknoppande_nn_1_N : N ;
  avkoloniserande_nn_1_N : N ;
  avkopplande_nn_1_N : N ;
  avkortande_nn_1_N : N ;
  avkriminaliserande_nn_1_N : N ;
  avkristnande_nn_1_N : N ;
  avkraevande_nn_1_1_N : N ;
  avkunnande_nn_1_N : N ;
  avkoenande_nn_1_1_N : N ;
  avlagrande_nn_1_N : N ;
  avlande_nn_1_N : N ;
  avlastande_nn_1_N : N ;
  avledande_nn_1_N : N ;
  avlidande_nn_1_N : N ;
  avlinge_nn_1_N : N ;
  avlivande_nn_1_N : N ;
  avlockande_nn_1_N : N ;
  avloppsdike_nn_1_N : N ;
  avlossande_nn_1_N : N ;
  avlusande_nn_1_N : N ;
  avlutande_nn_1_N : N ;
  avlysande_nn_1_N : N ;
  avlyssnande_nn_1_N : N ;
  avlaeggande_nn_1_1_N : N ;
  avlaegsnande_nn_1_1_N : N ;
  avlaemnande_nn_1_1_N : N ;
  avlaenkande_nn_1_1_N : N ;
  avlaesande_nn_1_1_N : N ;
  avlaatande_nn_1_1_N : N ;
  avloenande_nn_1_1_N : N ;
  avloepande_nn_1_1_N : N ;
  avloesande_nn_1_1_N : N ;
  avloevande_nn_1_1_N : N ;
  avmagnetiserande_nn_1_N : N ;
  avmaskande_nn_1_N : N ;
  avmastande_nn_1_N : N ;
  avmattande_nn_1_N : N ;
  avmaetande_nn_1_1_N : N ;
  avnavlande_nn_1_N : N ;
  avnazifierande_nn_1_N : N ;
  avnjutande_nn_1_N : N ;
  avpassande_nn_1_N : N ;
  avpatrullerande_nn_1_N : N ;
  avplanande_nn_1_N : N ;
  avpolitiserande_nn_1_N : N ;
  avpolletterande_nn_1_N : N ;
  avportraetterande_nn_1_1_N : N ;
  avpressande_nn_1_N : N ;
  avreagerande_nn_1_N : N ;
  avredande_nn_1_N : N ;
  avregistrerande_nn_1_N : N ;
  avreglerande_nn_1_N : N ;
  avresande_nn_1_N : N ;
  avrinnande_nn_1_N : N ;
  avromantiserande_nn_1_N : N ;
  avrundande_nn_1_N : N ;
  avrustande_nn_1_N : N ;
  avraeknande_nn_1_1_N : N ;
  avraettande_nn_1_1_N : N ;
  avraadande_nn_1_1_N : N ;
  avsaltande_nn_1_N : N ;
  avseende_nn_1_N : N ;
  avseglande_nn_1_N : N ;
  avsjungande_nn_1_N : N ;
  avskaffande_nn_1_N : N ;
  avskavande_nn_1_N : N ;
  avskedande_nn_1_N : N ;
  avskedstagande_nn_1_N : N ;
  avskiljande_nn_1_N : N ;
  avskjutande_nn_1_N : N ;
  avskrivande_nn_1_N : N ;
  avskraeckande_nn_1_1_N : N ;
  avskraedande_nn_1_1_N : N ;
  avskraede_nn_1_1_N : N ;
  avskyende_nn_1_N : N ;
  avskaerande_nn_1_1_N : N ;
  avskaermande_nn_1_1_N : N ;
  avslipande_nn_1_N : N ;
  avslitande_nn_1_N : N ;
  avslutande_nn_1_N : N ;
  avslaaende_nn_1_1_N : N ;
  avsloejande_nn_1_1_N : N ;
  avsmakande_nn_1_N : N ;
  avsmalnande_nn_1_N : N ;
  avsnoppande_nn_1_N : N ;
  avsnoerande_nn_1_1_N : N ;
  avsocialiserande_nn_1_N : N ;
  avsomnande_nn_1_N : N ;
  avspeglande_nn_1_N : N ;
  avspelande_nn_1_N : N ;
  avspisande_nn_1_N : N ;
  avspaerrande_nn_1_1_N : N ;
  avstaliniserande_nn_1_N : N ;
  avstannande_nn_1_N : N ;
  avstavande_nn_1_N : N ;
  avstressande_nn_1_N : N ;
  avstyckande_nn_1_N : N ;
  avstyrande_nn_1_N : N ;
  avstyrkande_nn_1_N : N ;
  avstaellande_nn_1_1_N : N ;
  avstaemmande_nn_1_1_N : N ;
  avstaengande_nn_1_1_N : N ;
  avstaaende_nn_1_1_N : N ;
  avstaandstagande_nn_1_1_N : N ;
  avstoerande_nn_1_1_N : N ;
  avstoetande_nn_1_1_N : N ;
  avsvalnande_nn_1_N : N ;
  avsvavlande_nn_1_N : N ;
  avsvimmande_nn_1_N : N ;
  avsvaerjande_nn_1_1_N : N ;
  avsynande_nn_1_N : N ;
  avsaegande_nn_1_1_N : N ;
  avsaendande_nn_1_1_N : N ;
  avsaagande_nn_1_1_N : N ;
  avsoekande_nn_1_1_N : N ;
  avsoendrande_nn_1_1_N : N ;
  avtackande_nn_1_N : N ;
  avtalande_nn_1_N : N ;
  avtappande_nn_1_N : N ;
  avtecknande_nn_1_N : N ;
  avtjaenande_nn_1_1_N : N ;
  avtonande_nn_1_N : N ;
  avtrappande_nn_1_N : N ;
  avtrubbande_nn_1_N : N ;
  avtraedande_nn_1_1_N : N ;
  avtraede_nn_1_1_N : N ;
  avtunnande_nn_1_N : N ;
  avtvingande_nn_1_N : N ;
  avtvaaende_nn_1_1_N : N ;
  avtaeckande_nn_1_1_N : N ;
  avtaagande_nn_1_1_N : N ;
  avvaktande_nn_1_N : N ;
  avvarande_nn_1_N : N ;
  avvattnande_nn_1_N : N ;
  avvecklande_nn_1_N : N ;
  avverkande_nn_1_N : N ;
  avverkningsarbete_nn_1_N : N ;
  avvikande_nn_1_N : N ;
  avvinnande_nn_1_N : N ;
  avvisande_nn_1_N : N ;
  avvitande_nn_1_N : N ;
  avvittrande_nn_1_N : N ;
  avvaegande_nn_1_1_N : N ;
  avvaendande_nn_1_1_N : N ;
  avvaenjande_nn_1_1_N : N ;
  avvaepnande_nn_1_1_N : N ;
  avvaerjande_nn_1_1_N : N ;
  avyttrande_nn_1_N : N ;
  avaetande_nn_1_1_N : N ;
  axiomatiserande_nn_1_N : N ;
  axlande_nn_1_N : N ;
  babblande_nn_1_N : N ;
  backande_nn_1_N : N ;
  backupande_nn_1_N : N ;
  backuppande_nn_1_N : N ;
  badande_nn_1_N : N ;
  baddande_nn_1_N : N ;
  badstaelle_nn_1_1_N : N ;
  bagageutrymme_nn_1_N : N ;
  bagatelliserande_nn_1_N : N ;
  baggboelande_nn_1_1_N : N ;
  baissande_nn_1_N : N ;
  bajsande_nn_1_N : N ;
  bakande_nn_1_N : N ;
  bakbindande_nn_1_N : N ;
  bakstycke_nn_1_N : N ;
  baksaete_nn_1_1_N : N ;
  baktalande_nn_1_N : N ;
  balande_nn_1_N : N ;
  balanserande_nn_1_N : N ;
  balanssinne_nn_1_N : N ;
  balloterande_nn_1_N : N ;
  balsamerande_nn_1_N : N ;
  banaliserande_nn_1_N : N ;
  bandande_nn_1_N : N ;
  bankande_nn_1_N : N ;
  bankrutterande_nn_1_N : N ;
  banksparande_nn_1_N : N ;
  bannande_nn_1_N : N ;
  bannlysande_nn_1_N : N ;
  bantande_nn_1_N : N ;
  barkande_nn_1_N : N ;
  barkympande_nn_1_N : N ;
  barlastande_nn_1_N : N ;
  barnalstrande_nn_1_N : N ;
  barnansikte_nn_1_N : N ;
  barnasinne_nn_1_N : N ;
  barrande_nn_1_N : N ;
  barrikaderande_nn_1_N : N ;
  basande_nn_1_N : N ;
  baserande_nn_1_N : N ;
  bastande_nn_1_N : N ;
  batongsvingande_nn_1_N : N ;
  baxande_nn_1_N : N ;
  baxnande_nn_1_N : N ;
  bearbetande_nn_1_N : N ;
  beboende_nn_1_N : N ;
  bebyggande_nn_1_N : N ;
  bebaadande_nn_1_1_N : N ;
  beckande_nn_1_N : N ;
  bedarrande_nn_1_N : N ;
  bedragande_nn_1_N : N ;
  bedrivande_nn_1_N : N ;
  bedroevande_nn_1_1_N : N ;
  bedyrande_nn_1_N : N ;
  bedaarande_nn_1_1_N : N ;
  bedoemande_nn_1_1_N : N ;
  bedoevande_nn_1_1_N : N ;
  beedigande_nn_1_N : N ;
  befallande_nn_1_N : N ;
  befarande_nn_1_N : N ;
  beflaeckande_nn_1_1_N : N ;
  befolkande_nn_1_N : N ;
  befordrande_nn_1_N : N ;
  befraktande_nn_1_N : N ;
  befriande_nn_1_N : N ;
  befruktande_nn_1_N : N ;
  befryndande_nn_1_N : N ;
  befraemjande_nn_1_1_N : N ;
  befullmaektigande_nn_1_1_N : N ;
  befaestande_nn_1_1_N : N ;
  begagnande_nn_1_N : N ;
  begapande_nn_1_N : N ;
  begivande_nn_1_N : N ;
  begjutande_nn_1_N : N ;
  beglaensande_nn_1_1_N : N ;
  begravande_nn_1_N : N ;
  begripande_nn_1_N : N ;
  begrundande_nn_1_N : N ;
  begraensande_nn_1_1_N : N ;
  begraatande_nn_1_1_N : N ;
  begynnande_nn_1_N : N ;
  begynnelseskede_nn_1_N : N ;
  begynnelsevaerde_nn_1_1_N : N ;
  begaerande_nn_1_1_N : N ;
  begaaende_nn_1_1_N : N ;
  begaavande_nn_1_1_N : N ;
  behagande_nn_1_N : N ;
  behandlande_nn_1_N : N ;
  behaengande_nn_1_1_N : N ;
  behaerskande_nn_1_1_N : N ;
  behaallande_nn_1_1_N : N ;
  behoevande_nn_1_1_N : N ;
  beivrande_nn_1_N : N ;
  bejakande_nn_1_N : N ;
  bejublande_nn_1_N : N ;
  bekajande_nn_1_N : N ;
  bekantgoerande_nn_1_1_N : N ;
  bekikande_nn_1_N : N ;
  beklagande_nn_1_N : N ;
  beklaedande_nn_1_1_N : N ;
  beknipande_nn_1_N : N ;
  bekommande_nn_1_N : N ;
  bekostande_nn_1_N : N ;
  bekransande_nn_1_N : N ;
  bekrigande_nn_1_N : N ;
  bekraeftande_nn_1_1_N : N ;
  bekroenande_nn_1_1_N : N ;
  bekymrande_nn_1_N : N ;
  bekaempande_nn_1_1_N : N ;
  bekaennande_nn_1_1_N : N ;
  belamrande_nn_1_N : N ;
  belangande_nn_1_N : N ;
  belastande_nn_1_N : N ;
  beledsagande_nn_1_N : N ;
  beleende_nn_1_N : N ;
  beljugande_nn_1_N : N ;
  belysande_nn_1_N : N ;
  belaeggande_nn_1_1_N : N ;
  belaeggningssnoere_nn_1_1_N : N ;
  belaegrande_nn_1_1_N : N ;
  belaete_nn_1_1_N : N ;
  belaanande_nn_1_1_N : N ;
  beloenande_nn_1_1_N : N ;
  bemannande_nn_1_N : N ;
  bemantlande_nn_1_N : N ;
  bemedlande_nn_1_N : N ;
  bemyndigande_nn_1_N : N ;
  bemaengande_nn_1_1_N : N ;
  bemaerkande_nn_1_1_N : N ;
  bemaestrande_nn_1_1_N : N ;
  bemoedande_nn_1_1_N : N ;
  benande_nn_1_N : N ;
  benaemnande_nn_1_1_N : N ;
  benaadande_nn_1_1_N : N ;
  beordrande_nn_1_N : N ;
  bepansrande_nn_1_N : N ;
  beprisande_nn_1_N : N ;
  beprydande_nn_1_N : N ;
  bepudrande_nn_1_N : N ;
  beredande_nn_1_N : N ;
  beredskapsarbete_nn_1_N : N ;
  bergsomraade_nn_1_1_N : N ;
  berikande_nn_1_N : N ;
  beriktigande_nn_1_N : N ;
  beroende_nn_2_N : N ;
  berusande_nn_1_N : N ;
  beraeknande_nn_1_1_N : N ;
  beraettande_nn_1_1_N : N ;
  beroemmande_nn_1_1_N : N ;
  beroerande_nn_1_1_N : N ;
  beroevande_nn_1_1_N : N ;
  besannande_nn_1_N : N ;
  beseglande_nn_1_N : N ;
  besegrande_nn_1_N : N ;
  besiktigande_nn_1_N : N ;
  besinnande_nn_1_N : N ;
  besittande_nn_1_N : N ;
  besjungande_nn_1_N : N ;
  besjaelande_nn_1_1_N : N ;
  beskattande_nn_1_N : N ;
  beskickande_nn_1_N : N ;
  beskjutande_nn_1_N : N ;
  beskrivande_nn_1_N : N ;
  beskuggande_nn_1_N : N ;
  beskyddande_nn_1_N : N ;
  beskyllande_nn_1_N : N ;
  beskaerande_nn_1_1_N : N ;
  beskaermande_nn_1_1_N : N ;
  beslaglaeggande_nn_1_1_N : N ;
  beslagssmide_nn_1_N : N ;
  beslagtagande_nn_1_N : N ;
  beslutande_nn_1_N : N ;
  beslaaende_nn_1_1_N : N ;
  besloejande_nn_1_1_N : N ;
  besmittande_nn_1_N : N ;
  besmoerjande_nn_1_1_N : N ;
  besockrande_nn_1_N : N ;
  besoldande_nn_1_N : N ;
  besparande_nn_1_N : N ;
  bespejande_nn_1_N : N ;
  bespisande_nn_1_N : N ;
  bespolande_nn_1_N : N ;
  bespottande_nn_1_N : N ;
  besprutande_nn_1_N : N ;
  bestickande_nn_1_N : N ;
  bestigande_nn_1_N : N ;
  bestjaelande_nn_1_1_N : N ;
  bestormande_nn_1_N : N ;
  bestraffande_nn_1_N : N ;
  bestridande_nn_1_N : N ;
  bestrykande_nn_1_N : N ;
  bestraalande_nn_1_1_N : N ;
  bestroeende_nn_1_1_N : N ;
  bestyckande_nn_1_N : N ;
  bestyrande_nn_1_N : N ;
  bestyrkande_nn_1_N : N ;
  bestaellande_nn_1_1_N : N ;
  bestaellningsarbete_nn_1_1_N : N ;
  bestaemmande_nn_1_1_N : N ;
  bestaenkande_nn_1_1_N : N ;
  bestaaende_nn_1_1_N : N ;
  besvarande_nn_1_N : N ;
  besvaerande_nn_1_1_N : N ;
  besvaerjande_nn_1_1_N : N ;
  besaettande_nn_1_1_N : N ;
  besaaende_nn_1_1_N : N ;
  besoekande_nn_2_1_N : N ;
  besoerjande_nn_1_1_N : N ;
  betagande_nn_1_N : N ;
  betalande_nn_1_N : N ;
  betalningsfoerelaeggande_nn_1_1_N : N ;
  betande_nn_1_N : N ;
  bete_nn_1_N : N ;
  betecknande_nn_1_N : N ;
  beteende_nn_1_N : N ;
  betesomraade_nn_1_1_N : N ;
  betingande_nn_1_N : N ;
  betingsarbete_nn_1_N : N ;
  betitlande_nn_1_N : N ;
  betittande_nn_1_N : N ;
  betjaenande_nn_1_1_N : N ;
  betonande_nn_1_N : N ;
  betongerande_nn_1_N : N ;
  betroende_nn_1_N : N ;
  betryckande_nn_1_N : N ;
  betryggande_nn_1_N : N ;
  betraedande_nn_1_1_N : N ;
  betraeffande_nn_1_1_N : N ;
  betsande_nn_1_N : N ;
  betslande_nn_1_N : N ;
  bettlande_nn_1_N : N ;
  betungande_nn_1_N : N ;
  betvingande_nn_1_N : N ;
  betvivlande_nn_1_N : N ;
  betydande_nn_1_N : N ;
  betygande_nn_1_N : N ;
  betygssaettande_nn_1_1_N : N ;
  betygsaettande_nn_1_1_N : N ;
  betaeckande_nn_1_1_N : N ;
  betaenkande_nn_1_1_N : N ;
  beundrande_nn_1_N : N ;
  bevakande_nn_1_N : N ;
  bevakningsomraade_nn_1_1_N : N ;
  bevarande_nn_1_N : N ;
  bevattnande_nn_1_N : N ;
  bevekande_nn_1_N : N ;
  beviljande_nn_1_N : N ;
  bevisande_nn_1_N : N ;
  bevistande_nn_1_N : N ;
  bevisvaerde_nn_1_1_N : N ;
  bevittnande_nn_1_N : N ;
  bevaepnande_nn_1_1_N : N ;
  bevaerande_nn_1_1_N : N ;
  bevaerdigande_nn_1_1_N : N ;
  bibehaallande_nn_1_1_N : N ;
  bibelstaelle_nn_1_1_N : N ;
  bibringande_nn_1_N : N ;
  bidande_nn_1_N : N ;
  bidragande_nn_1_N : N ;
  bifallande_nn_1_N : N ;
  bifloede_nn_1_1_N : N ;
  bifogande_nn_1_N : N ;
  biktande_nn_1_N : N ;
  bilande_nn_1_N : N ;
  bilbaelte_nn_1_1_N : N ;
  bildande_nn_1_N : N ;
  bildfloede_nn_1_1_N : N ;
  biljetthaefte_nn_1_1_N : N ;
  bilmaerke_nn_1_1_N : N ;
  bilsaete_nn_1_1_N : N ;
  bilaeggande_nn_1_1_N : N ;
  bindande_nn_1_N : N ;
  bindsle_nn_1_N : N ;
  bindaemne_nn_1_1_N : N ;
  biobraensle_nn_1_1_N : N ;
  biograferande_nn_1_N : N ;
  bisamhaelle_nn_1_1_N : N ;
  biskopsdoeme_nn_1_1_N : N ;
  biskopsmoete_nn_1_1_N : N ;
  biskopssaete_nn_1_1_N : N ;
  bispringande_nn_1_N : N ;
  bisserande_nn_1_N : N ;
  bistraeckande_nn_1_1_N : N ;
  bistaaende_nn_1_1_N : N ;
  bisaettande_nn_1_1_N : N ;
  bitande_nn_1_N : N ;
  bitmaerke_nn_1_1_N : N ;
  bitraedande_nn_1_1_N : N ;
  bitraede_nn_1_1_N : N ;
  bivackerande_nn_1_N : N ;
  biaemne_nn_1_1_N : N ;
  bjudande_nn_1_N : N ;
  bjussande_nn_1_N : N ;
  bjaebbande_nn_1_1_N : N ;
  bjoernande_nn_1_1_N : N ;
  bjoernbindsle_nn_1_1_N : N ;
  bjoernide_nn_1_1_N : N ;
  bladande_nn_1_N : N ;
  bladbyte_nn_1_N : N ;
  bladdrande_nn_1_N : N ;
  blajande_nn_1_N : N ;
  blancherande_nn_1_N : N ;
  blandande_nn_1_N : N ;
  blandningsfoerhaallande_nn_1_1_N : N ;
  blankande_nn_1_N : N ;
  blankpolerande_nn_1_N : N ;
  blarrande_nn_1_N : N ;
  blaskande_nn_1_N : N ;
  blekande_nn_1_N : N ;
  blekansikte_nn_1_N : N ;
  bleknande_nn_1_N : N ;
  blesserande_nn_1_N : N ;
  blickande_nn_1_N : N ;
  blidkande_nn_1_N : N ;
  bliende_nn_1_N : N ;
  bligande_nn_1_N : N ;
  blinderande_nn_1_N : N ;
  blindpressande_nn_1_N : N ;
  blindstyre_nn_1_N : N ;
  blinkande_nn_1_N : N ;
  blippande_nn_1_N : N ;
  blivande_nn_1_N : N ;
  blixtfotograferande_nn_1_N : N ;
  blixtinkallande_nn_1_N : N ;
  blixtrande_nn_1_N : N ;
  blockande_nn_1_N : N ;
  blockerande_nn_1_N : N ;
  blockaemne_nn_1_1_N : N ;
  blodande_nn_1_N : N ;
  blodfloede_nn_1_1_N : N ;
  blodfaergaemne_nn_1_1_N : N ;
  blodvite_nn_1_N : N ;
  blodvaerde_nn_1_1_N : N ;
  bloggande_nn_1_N : N ;
  blomfaeste_nn_1_1_N : N ;
  blomhylle_nn_1_N : N ;
  blomhaenge_nn_1_1_N : N ;
  blomknippe_nn_1_N : N ;
  blommande_nn_1_N : N ;
  blommograferande_nn_1_N : N ;
  blomstrande_nn_1_N : N ;
  blonderande_nn_1_N : N ;
  blossande_nn_1_N : N ;
  blotande_nn_1_N : N ;
  blottande_nn_1_N : N ;
  blottlaeggande_nn_1_1_N : N ;
  bluddrande_nn_1_N : N ;
  bluffande_nn_1_N : N ;
  bluffbygge_nn_1_N : N ;
  blundande_nn_1_N : N ;
  blyande_nn_1_N : N ;
  blaeckande_nn_1_1_N : N ;
  blaedande_nn_1_1_N : N ;
  blaeddrande_nn_1_1_N : N ;
  blaendande_nn_1_1_N : N ;
  blaende_nn_1_1_N : N ;
  blaengande_nn_1_1_N : N ;
  blaenkande_nn_1_1_N : N ;
  blaenke_nn_1_1_N : N ;
  blaestande_nn_1_1_N : N ;
  blaestrande_nn_1_1_N : N ;
  blaakopierande_nn_1_1_N : N ;
  blaakoerande_nn_1_1_N : N ;
  blaamaerke_nn_1_1_N : N ;
  blaanande_nn_1_1_N : N ;
  blaanekande_nn_1_1_N : N ;
  blaasande_nn_1_1_N : N ;
  bloedande_nn_1_1_N : N ;
  bloejbyte_nn_1_1_N : N ;
  bloetande_nn_1_1_N : N ;
  bloetlaeggande_nn_1_1_N : N ;
  bloetnande_nn_1_1_N : N ;
  boaserande_nn_1_N : N ;
  bobbande_nn_1_N : N ;
  bockande_nn_1_N : N ;
  boende_nn_1_N : N ;
  bogserande_nn_1_N : N ;
  bojkottande_nn_1_N : N ;
  bokande_nn_1_N : N ;
  bokfoerande_nn_1_1_N : N ;
  bokmaerke_nn_1_1_N : N ;
  boknande_nn_1_N : N ;
  bokstaverande_nn_1_N : N ;
  bolande_nn_1_N : N ;
  bollande_nn_1_N : N ;
  bollsinne_nn_1_N : N ;
  bolmande_nn_1_N : N ;
  bombande_nn_1_N : N ;
  bombarderande_nn_1_N : N ;
  bombsikte_nn_1_N : N ;
  bommande_nn_1_N : N ;
  bomaerke_nn_1_1_N : N ;
  bonande_nn_1_N : N ;
  bondesamhaelle_nn_1_1_N : N ;
  bondnekande_nn_1_N : N ;
  bongande_nn_1_N : N ;
  boniterande_nn_1_N : N ;
  boomande_nn_1_N : N ;
  bordande_nn_1_N : N ;
  bordlaeggande_nn_1_1_N : N ;
  borgande_nn_1_N : N ;
  borgardoeme_nn_1_1_N : N ;
  borgargarde_nn_1_N : N ;
  borgensaatagande_nn_1_1_N : N ;
  bornerande_nn_1_N : N ;
  borrande_nn_1_N : N ;
  borstande_nn_1_N : N ;
  bortarbetande_nn_1_N : N ;
  bortdomnande_nn_1_N : N ;
  bortdrivande_nn_1_N : N ;
  bortdoeende_nn_1_1_N : N ;
  bortfallande_nn_1_N : N ;
  bortforslande_nn_1_N : N ;
  bortfoerande_nn_1_1_N : N ;
  bortfoerklarande_nn_1_1_N : N ;
  bortgaaende_nn_1_1_N : N ;
  bortlovande_nn_1_N : N ;
  bortmotande_nn_1_N : N ;
  bortopererande_nn_1_N : N ;
  bortrationaliserande_nn_1_N : N ;
  bortresonerande_nn_1_N : N ;
  bortrinnande_nn_1_N : N ;
  bortraeknande_nn_1_1_N : N ;
  bortroevande_nn_1_1_N : N ;
  bortseende_nn_1_N : N ;
  bortskraemmande_nn_1_1_N : N ;
  bortslumpande_nn_1_N : N ;
  bortslutande_nn_1_N : N ;
  borttagande_nn_1_N : N ;
  borttappande_nn_1_N : N ;
  borttorkande_nn_1_N : N ;
  bortvraekande_nn_1_1_N : N ;
  boskifte_nn_1_N : N ;
  bossvaelde_nn_1_1_N : N ;
  bostadsbyggande_nn_1_N : N ;
  bostadsomraade_nn_1_1_N : N ;
  bostaelle_nn_1_1_N : N ;
  botande_nn_1_N : N ;
  botaniserande_nn_1_N : N ;
  bottenfrysande_nn_1_N : N ;
  bottenlaege_nn_1_1_N : N ;
  bottenrevande_nn_1_N : N ;
  bottenskrapande_nn_1_N : N ;
  bottnande_nn_1_N : N ;
  bowlande_nn_1_N : N ;
  boxande_nn_1_N : N ;
  brageloefte_nn_1_1_N : N ;
  brakande_nn_1_N : N ;
  branddike_nn_1_N : N ;
  brandhaerjande_nn_1_1_N : N ;
  brandskattande_nn_1_N : N ;
  braskande_nn_1_N : N ;
  brassande_nn_1_N : N ;
  braverande_nn_1_N : N ;
  bredande_nn_1_N : N ;
  breddande_nn_1_N : N ;
  bredsaaende_nn_1_1_N : N ;
  breende_nn_1_N : N ;
  brevvaexlande_nn_1_1_N : N ;
  briefande_nn_1_N : N ;
  briketterande_nn_1_N : N ;
  briljerande_nn_1_N : N ;
  bringande_nn_1_N : N ;
  brinnande_nn_1_N : N ;
  briserande_nn_1_N : N ;
  bristande_nn_1_N : N ;
  bristlaege_nn_1_1_N : N ;
  bristyrke_nn_1_N : N ;
  broande_nn_1_N : N ;
  broddande_nn_1_N : N ;
  broderande_nn_1_N : N ;
  brofaeste_nn_1_1_N : N ;
  brolaeggande_nn_1_1_N : N ;
  bromerande_nn_1_N : N ;
  bromsande_nn_1_N : N ;
  bronserande_nn_1_N : N ;
  bronsfoergyllande_nn_1_1_N : N ;
  bronsmaerke_nn_1_1_N : N ;
  bronsspaenne_nn_1_1_N : N ;
  broscherande_nn_1_N : N ;
  brosslande_nn_1_N : N ;
  brotschande_nn_1_N : N ;
  brottstillfaelle_nn_1_1_N : N ;
  brottstycke_nn_1_N : N ;
  brottstaelle_nn_1_1_N : N ;
  brucklande_nn_1_N : N ;
  brudfoelje_nn_1_1_N : N ;
  brukande_nn_1_N : N ;
  brukslaaende_nn_1_1_N : N ;
  brukssamhaelle_nn_1_1_N : N ;
  bruksvaerde_nn_1_1_N : N ;
  brummande_nn_1_N : N ;
  brunerande_nn_1_N : N ;
  brunfaergande_nn_1_1_N : N ;
  brusande_nn_1_N : N ;
  brutaliserande_nn_1_N : N ;
  bryende_nn_1_N : N ;
  bryggande_nn_1_N : N ;
  bryggkaffe_nn_1_N : N ;
  brynande_nn_1_N : N ;
  bryne_nn_1_N : N ;
  brytande_nn_1_N : N ;
  braeckande_nn_1_1_N : N ;
  braedande_nn_1_1_N : N ;
  braedbeklaedande_nn_1_1_N : N ;
  braedbeslaaende_nn_1_1_N : N ;
  braeddande_nn_1_1_N : N ;
  braede_nn_1_1_N : N ;
  braedfodrande_nn_1_1_N : N ;
  braedseglande_nn_1_1_N : N ;
  braedslaaende_nn_1_1_N : N ;
  braekande_nn_1_1_N : N ;
  braemande_nn_1_1_N : N ;
  braennande_nn_1_1_N : N ;
  braennlackerande_nn_1_1_N : N ;
  braennmaerkande_nn_1_1_N : N ;
  braennmaerke_nn_1_1_N : N ;
  braennskadande_nn_1_1_N : N ;
  braensle_nn_1_1_N : N ;
  braeserande_nn_1_1_N : N ;
  braette_nn_1_1_N : N ;
  braadskande_nn_1_1_N : N ;
  braakande_nn_1_1_N : N ;
  broeande_nn_1_1_N : N ;
  broedande_nn_1_1_N : N ;
  broedstycke_nn_1_1_N : N ;
  broelande_nn_1_1_N : N ;
  broellopsvittne_nn_1_1_N : N ;
  buande_nn_1_N : N ;
  bubbande_nn_1_N : N ;
  bubblande_nn_1_N : N ;
  budande_nn_1_N : N ;
  budgetarbete_nn_1_N : N ;
  budgeterande_nn_1_N : N ;
  buffande_nn_1_N : N ;
  buffrande_nn_1_N : N ;
  bugande_nn_1_N : N ;
  buggande_nn_1_N : N ;
  buklandande_nn_1_N : N ;
  buktalande_nn_1_N : N ;
  buktande_nn_1_N : N ;
  bullrande_nn_1_N : N ;
  bulnande_nn_1_N : N ;
  bultande_nn_1_N : N ;
  buntande_nn_1_N : N ;
  burgarstaelle_nn_1_1_N : N ;
  burgerstaelle_nn_1_1_N : N ;
  burkande_nn_1_N : N ;
  busande_nn_1_N : N ;
  buskande_nn_1_N : N ;
  busringande_nn_1_N : N ;
  bussande_nn_1_N : N ;
  busvisslande_nn_1_N : N ;
  buteljerande_nn_1_N : N ;
  butiksbitraede_nn_1_1_N : N ;
  bygge_nn_1_N : N ;
  byggnadsminne_nn_1_N : N ;
  bykande_nn_1_N : N ;
  bylte_nn_1_N : N ;
  byomraade_nn_1_1_N : N ;
  byraakratiserande_nn_1_1_N : N ;
  bysnille_nn_1_N : N ;
  bysaettande_nn_1_1_N : N ;
  bytande_nn_1_N : N ;
  byte_nn_1_N : N ;
  bytesvaerde_nn_1_1_N : N ;
  baeddande_nn_1_1_N : N ;
  baelgande_nn_1_1_N : N ;
  baelte_nn_1_1_N : N ;
  baendande_nn_1_1_N : N ;
  baendslande_nn_1_1_N : N ;
  baenslande_nn_1_1_N : N ;
  baerande_nn_1_1_N : N ;
  baergande_nn_1_1_N : N ;
  baersande_nn_1_1_N : N ;
  baettrande_nn_1_1_N : N ;
  baevande_nn_1_1_N : N ;
  baadande_nn_1_1_N : N ;
  baagande_nn_1_1_N : N ;
  baagnande_nn_1_1_N : N ;
  baatande_nn_1_1_N : N ;
  baatbygge_nn_1_1_N : N ;
  boejande_nn_1_1_N : N ;
  boekande_nn_1_1_N : N ;
  boelande_nn_1_1_N : N ;
  boeljande_nn_1_1_N : N ;
  boeljeslagsmaerke_nn_1_1_N : N ;
  boenande_nn_1_1_N : N ;
  boenemoete_nn_1_1_N : N ;
  boenfallande_nn_1_1_N : N ;
  boenhoerande_nn_1_1_N : N ;
  boerande_nn_1_1_N : N ;
  boerjande_nn_1_1_N : N ;
  boersnoterande_nn_1_1_N : N ;
  boestande_nn_1_1_N : N ;
  boetande_nn_1_1_N : N ;
  boetfaellande_nn_1_1_N : N ;
  camouflerande_nn_1_N : N ;
  campande_nn_1_N : N ;
  caterande_nn_1_N : N ;
  cederande_nn_1_N : N ;
  celebrerande_nn_1_N : N ;
  celibatloefte_nn_1_1_N : N ;
  cembalobygge_nn_1_N : N ;
  cementande_nn_1_N : N ;
  cementerande_nn_1_N : N ;
  censurerande_nn_1_N : N ;
  centraliserande_nn_1_N : N ;
  centrande_nn_1_N : N ;
  centrerande_nn_1_N : N ;
  centrifugerande_nn_1_N : N ;
  cernerande_nn_1_N : N ;
  certifierande_nn_1_N : N ;
  champagnesprutande_nn_1_N : N ;
  changerande_nn_1_N : N ;
  changserande_nn_1_N : N ;
  chansande_nn_1_N : N ;
  chanserande_nn_1_N : N ;
  chargerande_nn_1_N : N ;
  charmande_nn_1_N : N ;
  charmerande_nn_1_N : N ;
  chartrande_nn_1_N : N ;
  chattande_nn_1_N : N ;
  checkande_nn_1_N : N ;
  checkhaefte_nn_1_1_N : N ;
  chefande_nn_1_N : N ;
  chevroterande_nn_1_N : N ;
  chiffrerande_nn_1_N : N ;
  chikanerande_nn_1_N : N ;
  chillande_nn_1_N : N ;
  chockande_nn_1_N : N ;
  chockbehandlande_nn_1_N : N ;
  chockerande_nn_1_N : N ;
  chokande_nn_1_N : N ;
  cirklande_nn_1_N : N ;
  cirkulerande_nn_1_N : N ;
  ciselerande_nn_1_N : N ;
  citerande_nn_1_N : N ;
  civiliserande_nn_1_N : N ;
  clearande_nn_1_N : N ;
  crawlande_nn_1_N : N ;
  curaterande_nn_1_N : N ;
  curerande_nn_1_N : N ;
  curlande_nn_1_N : N ;
  cykelstyre_nn_1_N : N ;
  cyklande_nn_1_N : N ;
  daddande_nn_1_N : N ;
  dagdroemmande_nn_1_1_N : N ;
  daggande_nn_1_N : N ;
  dagsverke_nn_1_N : N ;
  dagtecknande_nn_1_N : N ;
  dagtingande_nn_1_N : N ;
  dagtraktamente_nn_1_N : N ;
  dalande_nn_1_N : N ;
  dallrande_nn_1_N : N ;
  daltande_nn_1_N : N ;
  dammande_nn_1_N : N ;
  dammode_nn_1_N : N ;
  dammsugande_nn_1_N : N ;
  dammtorkande_nn_1_N : N ;
  dampande_nn_1_N : N ;
  danande_nn_1_N : N ;
  danglande_nn_1_N : N ;
  dansande_nn_1_N : N ;
  dansbaneelaende_nn_1_1_N : N ;
  dansgille_nn_1_N : N ;
  dansstaelle_nn_1_1_N : N ;
  darrande_nn_1_N : N ;
  daskande_nn_1_N : N ;
  dassande_nn_1_N : N ;
  databehandlande_nn_1_N : N ;
  dataminne_nn_1_N : N ;
  datautbyte_nn_1_N : N ;
  daterande_nn_1_N : N ;
  datoriserande_nn_1_N : N ;
  datorminne_nn_1_N : N ;
  datorsimulerande_nn_1_N : N ;
  dattande_nn_1_N : N ;
  datummaerkande_nn_1_1_N : N ;
  datumparkerande_nn_1_N : N ;
  debarkerande_nn_1_N : N ;
  debatterande_nn_1_N : N ;
  debiterande_nn_1_N : N ;
  debuterande_nn_1_N : N ;
  decentraliserande_nn_1_N : N ;
  dechiffrerande_nn_1_N : N ;
  decimerande_nn_1_N : N ;
  dedicerande_nn_1_N : N ;
  dedikerande_nn_1_N : N ;
  deducerande_nn_1_N : N ;
  defilerande_nn_1_N : N ;
  definierande_nn_1_N : N ;
  deflorerande_nn_1_N : N ;
  deformerande_nn_1_N : N ;
  degande_nn_1_N : N ;
  degenererande_nn_1_N : N ;
  degraderande_nn_1_N : N ;
  dejsande_nn_1_N : N ;
  dejtande_nn_1_N : N ;
  dekanterande_nn_1_N : N ;
  dekapiterande_nn_1_N : N ;
  deklamerande_nn_1_N : N ;
  deklarerande_nn_1_N : N ;
  deklasserande_nn_1_N : N ;
  deklinerande_nn_1_N : N ;
  dekorerande_nn_1_N : N ;
  dekouragerande_nn_1_N : N ;
  dekreterande_nn_1_N : N ;
  delande_nn_1_N : N ;
  delegerande_nn_1_N : N ;
  delgivande_nn_1_N : N ;
  deltidsarbete_nn_1_N : N ;
  demande_nn_1_N : N ;
  demaskerande_nn_1_N : N ;
  dementerande_nn_1_N : N ;
  demilitariserande_nn_1_N : N ;
  demissionerande_nn_1_N : N ;
  demobiliserande_nn_1_N : N ;
  demokratibygge_nn_1_N : N ;
  demokratiserande_nn_1_N : N ;
  demolerande_nn_1_N : N ;
  demonstrerande_nn_1_N : N ;
  demonterande_nn_1_N : N ;
  demoraliserande_nn_1_N : N ;
  denaturaliserande_nn_1_N : N ;
  denaturerande_nn_1_N : N ;
  denoterande_nn_1_N : N ;
  denuderande_nn_1_N : N ;
  deodoriserande_nn_1_N : N ;
  departementsaerende_nn_1_1_N : N ;
  depatrierande_nn_1_N : N ;
  depenserande_nn_1_N : N ;
  deplacerande_nn_1_N : N ;
  deponerande_nn_1_N : N ;
  deporterande_nn_1_N : N ;
  deppande_nn_1_N : N ;
  deprecierande_nn_1_N : N ;
  derangerande_nn_1_N : N ;
  deriverande_nn_1_N : N ;
  desarmerande_nn_1_N : N ;
  desavouerande_nn_1_N : N ;
  desensibiliserande_nn_1_N : N ;
  deserterande_nn_1_N : N ;
  designande_nn_1_N : N ;
  designerande_nn_1_N : N ;
  desinfekterande_nn_1_N : N ;
  desinficerande_nn_1_N : N ;
  desinformerande_nn_1_N : N ;
  desorganiserande_nn_1_N : N ;
  destabiliserande_nn_1_N : N ;
  destillerande_nn_1_N : N ;
  destinerande_nn_1_N : N ;
  destruerande_nn_1_N : N ;
  detacherande_nn_1_N : N ;
  detaljarbete_nn_1_N : N ;
  detaljgranskande_nn_1_N : N ;
  detaljutfoerande_nn_1_1_N : N ;
  detekterande_nn_1_N : N ;
  detektivarbete_nn_1_N : N ;
  determinerande_nn_1_N : N ;
  detonerande_nn_1_N : N ;
  detroniserande_nn_1_N : N ;
  devalverande_nn_1_N : N ;
  devierande_nn_1_N : N ;
  diagnosticerande_nn_1_N : N ;
  diagnostiserande_nn_1_N : N ;
  diagonalande_nn_1_N : N ;
  dialyserande_nn_1_N : N ;
  diande_nn_1_N : N ;
  diariefoerande_nn_1_1_N : N ;
  dibblande_nn_1_N : N ;
  differentierande_nn_1_N : N ;
  diffunderande_nn_1_N : N ;
  diftongerande_nn_1_N : N ;
  digererande_nn_1_N : N ;
  diggande_nn_1_N : N ;
  dignande_nn_1_N : N ;
  dikande_nn_1_N : N ;
  dike_nn_1_N : N ;
  diktande_nn_1_N : N ;
  dikterande_nn_1_N : N ;
  dikthaefte_nn_1_1_N : N ;
  dillande_nn_1_N : N ;
  dimensionerande_nn_1_N : N ;
  dimpande_nn_1_N : N ;
  dinerande_nn_1_N : N ;
  dinglande_nn_1_N : N ;
  diplomerande_nn_1_N : N ;
  dippande_nn_1_N : N ;
  direktinflytande_nn_1_N : N ;
  dirigerande_nn_1_N : N ;
  dirkande_nn_1_N : N ;
  dirrande_nn_1_N : N ;
  disambiguerande_nn_1_N : N ;
  disciplinerande_nn_1_N : N ;
  disharmonierande_nn_1_N : N ;
  diskande_nn_1_N : N ;
  diskonterande_nn_1_N : N ;
  diskrediterande_nn_1_N : N ;
  diskriminerande_nn_1_N : N ;
  diskuterande_nn_1_N : N ;
  diskvalificerande_nn_1_N : N ;
  dispascherande_nn_1_N : N ;
  dispenserande_nn_1_N : N ;
  dispergerande_nn_1_N : N ;
  disponerande_nn_1_N : N ;
  disputerande_nn_1_N : N ;
  dissande_nn_1_N : N ;
  dissekerande_nn_1_N : N ;
  dissimilerande_nn_1_N : N ;
  dissocierande_nn_1_N : N ;
  dissonerande_nn_1_N : N ;
  distanserande_nn_1_N : N ;
  distraherande_nn_1_N : N ;
  distribuerande_nn_1_N : N ;
  divergerande_nn_1_N : N ;
  diversifierande_nn_1_N : N ;
  dividerande_nn_1_N : N ;
  djupfrysande_nn_1_N : N ;
  djuplodande_nn_1_N : N ;
  djupnande_nn_1_N : N ;
  djupsinne_nn_1_N : N ;
  djurlaete_nn_1_1_N : N ;
  doande_nn_1_N : N ;
  dobblande_nn_1_N : N ;
  docerande_nn_1_N : N ;
  dockande_nn_1_N : N ;
  dockansikte_nn_1_N : N ;
  doftande_nn_1_N : N ;
  doftmarkerande_nn_1_N : N ;
  doftsinne_nn_1_N : N ;
  doftaemne_nn_1_1_N : N ;
  dogmatiserande_nn_1_N : N ;
  doktorerande_nn_1_N : N ;
  dokumenterande_nn_1_N : N ;
  domderande_nn_1_N : N ;
  domesticerande_nn_1_N : N ;
  domfaellande_nn_1_1_N : N ;
  domicilierande_nn_1_N : N ;
  dominerande_nn_1_N : N ;
  domnande_nn_1_N : N ;
  dompterande_nn_1_N : N ;
  donande_nn_1_N : N ;
  donerande_nn_1_N : N ;
  donkande_nn_1_N : N ;
  donlaege_nn_1_1_N : N ;
  dopande_nn_1_N : N ;
  doppande_nn_1_N : N ;
  dopvittne_nn_1_N : N ;
  doserande_nn_1_N : N ;
  dosserande_nn_1_N : N ;
  doterande_nn_1_N : N ;
  drabbande_nn_1_N : N ;
  dragande_nn_1_N : N ;
  dragerande_nn_1_N : N ;
  draggande_nn_1_N : N ;
  dragsnoere_nn_1_1_N : N ;
  dramatiserande_nn_1_N : N ;
  draperande_nn_1_N : N ;
  drattande_nn_1_N : N ;
  dravlande_nn_1_N : N ;
  dreglande_nn_1_N : N ;
  drejande_nn_1_N : N ;
  drejvaendande_nn_1_1_N : N ;
  dresserande_nn_1_N : N ;
  drevande_nn_1_N : N ;
  dribblande_nn_1_N : N ;
  drickande_nn_1_N : N ;
  drillande_nn_1_N : N ;
  drivande_nn_1_N : N ;
  drogande_nn_1_N : N ;
  droppande_nn_1_N : N ;
  drottkvaede_nn_1_1_N : N ;
  drullande_nn_1_N : N ;
  drumlande_nn_1_N : N ;
  drunknande_nn_1_N : N ;
  dryftande_nn_1_N : N ;
  drypande_nn_1_N : N ;
  draeglande_nn_1_1_N : N ;
  draektspaenne_nn_1_1_N : N ;
  draellande_nn_1_1_N : N ;
  draemmande_nn_1_1_N : N ;
  draenerande_nn_1_1_N : N ;
  draeneringsdike_nn_1_1_N : N ;
  draeneringsomraade_nn_1_1_N : N ;
  draenkande_nn_1_1_N : N ;
  draepande_nn_1_1_N : N ;
  draasande_nn_1_1_N : N ;
  droejande_nn_1_1_N : N ;
  droemmande_nn_1_1_N : N ;
  droemtydande_nn_1_1_N : N ;
  droenande_nn_1_1_N : N ;
  droesande_nn_1_1_N : N ;
  duande_nn_1_N : N ;
  dubbande_nn_1_N : N ;
  dubbelansikte_nn_1_N : N ;
  dubbelbeskattande_nn_1_N : N ;
  dubbelexponerande_nn_1_N : N ;
  dubblande_nn_1_N : N ;
  dubblerande_nn_1_N : N ;
  duckande_nn_1_N : N ;
  duellerande_nn_1_N : N ;
  dugande_nn_1_N : N ;
  duggande_nn_1_N : N ;
  duggregnande_nn_1_N : N ;
  dukande_nn_1_N : N ;
  dumpande_nn_1_N : N ;
  dunande_nn_1_N : N ;
  dundrande_nn_1_N : N ;
  dunkande_nn_1_N : N ;
  dunsande_nn_1_N : N ;
  dunstande_nn_1_N : N ;
  duntaecke_nn_1_1_N : N ;
  duperande_nn_1_N : N ;
  duplicerande_nn_1_N : N ;
  durkande_nn_1_N : N ;
  duschande_nn_1_N : N ;
  duskande_nn_1_N : N ;
  duvande_nn_1_N : N ;
  duvnande_nn_1_N : N ;
  dykande_nn_1_N : N ;
  dyrkande_nn_1_N : N ;
  daeckande_nn_1_1_N : N ;
  daeckbyte_nn_1_1_N : N ;
  daeggande_nn_1_1_N : N ;
  daemmande_nn_1_1_N : N ;
  daemme_nn_1_1_N : N ;
  daempande_nn_1_1_N : N ;
  daengande_nn_1_1_N : N ;
  daenkande_nn_1_1_N : N ;
  daevnande_nn_1_1_N : N ;
  daanande_nn_1_1_N : N ;
  daarande_nn_1_1_N : N ;
  daasande_nn_1_1_N : N ;
  doedfoerklarande_nn_1_1_N : N ;
  doedlaege_nn_1_1_N : N ;
  doedsrike_nn_1_1_N : N ;
  doeende_nn_1_1_N : N ;
  doeljande_nn_1_1_N : N ;
  doemande_nn_1_1_N : N ;
  doenande_nn_1_1_N : N ;
  doepande_nn_1_1_N : N ;
  doerjande_nn_1_1_N : N ;
  doerrfoerhaenge_nn_1_1_N : N ;
  doevande_nn_1_1_N : N ;
  e_mailande_nn_1_N : N ;
  e_postande_nn_1_N : N ;
  e_postmeddelande_nn_1_N : N ;
  ebbande_nn_1_N : N ;
  ederande_nn_1_N : N ;
  edfaestande_nn_1_1_N : N ;
  effacerande_nn_1_N : N ;
  effektiverande_nn_1_N : N ;
  effektiviserande_nn_1_N : N ;
  effektlaege_nn_1_1_N : N ;
  effektuerande_nn_1_N : N ;
  efterapande_nn_1_N : N ;
  efterarbete_nn_1_N : N ;
  efterbehandlande_nn_1_N : N ;
  efterbildande_nn_1_N : N ;
  efterdaterande_nn_1_N : N ;
  efterdebiterande_nn_1_N : N ;
  efterdoeme_nn_1_1_N : N ;
  efterforskande_nn_1_N : N ;
  efterfraagande_nn_1_1_N : N ;
  efterfoeljande_nn_1_1_N : N ;
  eftergivande_nn_1_N : N ;
  eftergoerande_nn_1_1_N : N ;
  efterhaermande_nn_1_1_N : N ;
  efterhaallande_nn_1_1_N : N ;
  efterhoerande_nn_1_1_N : N ;
  efterkommande_nn_2_N : N ;
  efterlevande_nn_1_N : N ;
  efterliknande_nn_1_N : N ;
  efterlysande_nn_1_N : N ;
  efterlaemnande_nn_1_1_N : N ;
  efterlaatande_nn_1_1_N : N ;
  eftermognande_nn_1_N : N ;
  eftermaele_nn_1_1_N : N ;
  efterrationaliserande_nn_1_N : N ;
  efterseende_nn_1_N : N ;
  eftersinnande_nn_1_N : N ;
  efterstavande_nn_1_N : N ;
  efterstraevande_nn_1_1_N : N ;
  eftersynkroniserande_nn_1_N : N ;
  eftersaegande_nn_1_1_N : N ;
  eftersaendande_nn_1_1_N : N ;
  eftersaettande_nn_1_1_N : N ;
  eftersoekande_nn_1_1_N : N ;
  eftertaxerande_nn_1_N : N ;
  eftertraktande_nn_1_N : N ;
  eftertraedande_nn_1_1_N : N ;
  eftertraaende_nn_1_1_N : N ;
  egaliserande_nn_1_N : N ;
  egenintresse_nn_1_N : N ;
  egensinne_nn_1_N : N ;
  egensvaengande_nn_1_1_N : N ;
  eggande_nn_1_N : N ;
  ejakulerande_nn_1_N : N ;
  ekande_nn_1_N : N ;
  ekfatslagrande_nn_1_N : N ;
  ekiperande_nn_1_N : N ;
  eklaterande_nn_1_N : N ;
  eklaererande_nn_1_1_N : N ;
  ekolodande_nn_1_N : N ;
  ekonomibitraede_nn_1_1_N : N ;
  ekonomiserande_nn_1_N : N ;
  ekvatorialbaelte_nn_1_1_N : N ;
  elaborerande_nn_1_N : N ;
  elastiserande_nn_1_N : N ;
  eldande_nn_1_N : N ;
  eldhaerjande_nn_1_1_N : N ;
  eldsmaerke_nn_1_1_N : N ;
  eldsaekrande_nn_1_1_N : N ;
  eldvaktande_nn_1_N : N ;
  elektrificerande_nn_1_N : N ;
  elektrifierande_nn_1_N : N ;
  elektriserande_nn_1_N : N ;
  elektronhoelje_nn_1_1_N : N ;
  eliderande_nn_1_N : N ;
  eliminerande_nn_1_N : N ;
  eloxerande_nn_1_N : N ;
  eluderande_nn_1_N : N ;
  eluerande_nn_1_N : N ;
  elaende_nn_1_1_N : N ;
  emaljerande_nn_1_N : N ;
  emanciperande_nn_1_N : N ;
  emanerande_nn_1_N : N ;
  emballerande_nn_1_N : N ;
  embarkerande_nn_1_N : N ;
  embellerande_nn_1_N : N ;
  emenderande_nn_1_N : N ;
  emigrerande_nn_1_N : N ;
  emitterande_nn_1_N : N ;
  emotseende_nn_1_N : N ;
  emotstaaende_nn_1_1_N : N ;
  emottagande_nn_1_N : N ;
  emulgerande_nn_1_N : N ;
  emulsionsspraengaemne_nn_1_1_N : N ;
  enande_nn_1_N : N ;
  endosserande_nn_1_N : N ;
  energiknippe_nn_1_N : N ;
  enerverande_nn_1_N : N ;
  engagerande_nn_1_N : N ;
  engaangsvaerde_nn_1_1_N : N ;
  enkelriktande_nn_1_N : N ;
  enkelskrivande_nn_1_N : N ;
  enkeltecknande_nn_1_N : N ;
  enklande_nn_1_N : N ;
  enleverande_nn_1_N : N ;
  enrollerande_nn_1_N : N ;
  ensande_nn_1_N : N ;
  ensilerande_nn_1_N : N ;
  entledigande_nn_1_N : N ;
  entusiasmerande_nn_1_N : N ;
  epilerande_nn_1_N : N ;
  epostande_nn_1_N : N ;
  epostmeddelande_nn_1_N : N ;
  erbjudande_nn_1_N : N ;
  erfarande_nn_1_N : N ;
  erfordrande_nn_1_N : N ;
  erhaallande_nn_1_1_N : N ;
  erigerande_nn_1_N : N ;
  erinrande_nn_1_N : N ;
  erkaennande_nn_1_1_N : N ;
  erlaeggande_nn_1_1_N : N ;
  ernaaende_nn_1_1_N : N ;
  eroderande_nn_1_N : N ;
  ersaettande_nn_1_1_N : N ;
  ertappande_nn_1_N : N ;
  eroevrande_nn_1_1_N : N ;
  eskalerande_nn_1_N : N ;
  eskorterande_nn_1_N : N ;
  esteticerande_nn_1_N : N ;
  estetiserande_nn_1_N : N ;
  estimerande_nn_1_N : N ;
  etablerande_nn_1_N : N ;
  eteriserande_nn_1_N : N ;
  etiketterande_nn_1_N : N ;
  etsande_nn_1_N : N ;
  etymologiserande_nn_1_N : N ;
  europeiserande_nn_1_N : N ;
  evakuerande_nn_1_N : N ;
  evaluerande_nn_1_N : N ;
  evalverande_nn_1_N : N ;
  evangeliserande_nn_1_N : N ;
  evaporerande_nn_1_N : N ;
  examensarbete_nn_1_N : N ;
  examinerande_nn_1_N : N ;
  excellerande_nn_1_N : N ;
  excerperande_nn_1_N : N ;
  exciterande_nn_1_N : N ;
  exekverande_nn_1_N : N ;
  exemplifierande_nn_1_N : N ;
  exercerande_nn_1_N : N ;
  existerande_nn_1_N : N ;
  exkluderande_nn_1_N : N ;
  exkommunicerande_nn_1_N : N ;
  expanderande_nn_1_N : N ;
  expatrierande_nn_1_N : N ;
  expedierande_nn_1_N : N ;
  expektorerande_nn_1_N : N ;
  experimenterande_nn_1_N : N ;
  expertutlaatande_nn_1_1_N : N ;
  explicerande_nn_1_N : N ;
  exploaterande_nn_1_N : N ;
  exploderande_nn_1_N : N ;
  explosionsomraade_nn_1_1_N : N ;
  exponerande_nn_1_N : N ;
  exportberoende_nn_1_N : N ;
  exporterande_nn_1_N : N ;
  exproprierande_nn_1_N : N ;
  exstirperande_nn_1_N : N ;
  extemporerande_nn_1_N : N ;
  extraarbete_nn_1_N : N ;
  extraherande_nn_1_N : N ;
  extraknaeckande_nn_1_1_N : N ;
  extraktivaemne_nn_1_1_N : N ;
  extrapolerande_nn_1_N : N ;
  fablande_nn_1_N : N ;
  fabricerande_nn_1_N : N ;
  fabriksomraade_nn_1_1_N : N ;
  fabulerande_nn_1_N : N ;
  facebookande_nn_1_N : N ;
  facetterande_nn_1_N : N ;
  fadersvaelde_nn_1_1_N : N ;
  fakturerande_nn_1_N : N ;
  falkande_nn_1_N : N ;
  fallande_nn_1_N : N ;
  fallerande_nn_1_N : N ;
  falnande_nn_1_N : N ;
  falsande_nn_1_N : N ;
  falsifierande_nn_1_N : N ;
  falskskyltande_nn_1_N : N ;
  famlande_nn_1_N : N ;
  famnande_nn_1_N : N ;
  fantiserande_nn_1_N : N ;
  farande_nn_1_N : N ;
  fasande_nn_1_N : N ;
  fascinerande_nn_1_N : N ;
  fasetterande_nn_1_N : N ;
  fasonerande_nn_1_N : N ;
  fastande_nn_1_N : N ;
  fastgoerande_nn_1_1_N : N ;
  fasthaallande_nn_1_1_N : N ;
  fastighetstaxerande_nn_1_N : N ;
  fastkedjande_nn_1_N : N ;
  fastklistrande_nn_1_N : N ;
  fastlaeggande_nn_1_1_N : N ;
  fastnande_nn_1_N : N ;
  fastslaaende_nn_1_1_N : N ;
  faststaellande_nn_1_1_N : N ;
  fastsaettande_nn_1_1_N : N ;
  fasttagande_nn_1_N : N ;
  fattande_nn_1_N : N ;
  fattigdomsloefte_nn_1_1_N : N ;
  favoriserande_nn_1_N : N ;
  faxande_nn_1_N : N ;
  fejande_nn_1_N : N ;
  fejkande_nn_1_N : N ;
  felande_nn_1_N : N ;
  felbedoemande_nn_1_1_N : N ;
  felparkerande_nn_1_N : N ;
  feltolkande_nn_1_N : N ;
  fermenterande_nn_1_N : N ;
  fernissande_nn_1_N : N ;
  festande_nn_1_N : N ;
  feterande_nn_1_N : N ;
  fetmande_nn_1_N : N ;
  fetnande_nn_1_N : N ;
  fettaemne_nn_1_1_N : N ;
  fickparkerande_nn_1_N : N ;
  fifflande_nn_1_N : N ;
  figurerande_nn_1_N : N ;
  fikande_nn_1_N : N ;
  filande_nn_1_N : N ;
  filbyte_nn_1_N : N ;
  fileande_nn_1_N : N ;
  filerande_nn_1_N : N ;
  filmande_nn_1_N : N ;
  filmatiserande_nn_1_N : N ;
  filmberaettande_nn_1_1_N : N ;
  filosoferande_nn_1_N : N ;
  filtande_nn_1_N : N ;
  filtrerande_nn_1_N : N ;
  fimpande_nn_1_N : N ;
  finansierande_nn_1_N : N ;
  finbraennande_nn_1_1_N : N ;
  finfoerdelande_nn_1_1_N : N ;
  fingerande_nn_1_N : N ;
  fingrande_nn_1_N : N ;
  fingranskande_nn_1_N : N ;
  fininstaellande_nn_1_1_N : N ;
  finjusterande_nn_1_N : N ;
  finkammande_nn_1_N : N ;
  finkande_nn_1_N : N ;
  finlandiserande_nn_1_N : N ;
  finnande_nn_1_N : N ;
  finputsande_nn_1_N : N ;
  finslipande_nn_1_N : N ;
  finsmide_nn_1_N : N ;
  fintande_nn_1_N : N ;
  fipplande_nn_1_N : N ;
  firande_nn_1_N : N ;
  firmamaerke_nn_1_1_N : N ;
  fisande_nn_1_N : N ;
  fiskafaenge_nn_1_1_N : N ;
  fiskande_nn_1_N : N ;
  fiskelaege_nn_1_1_N : N ;
  fixande_nn_1_N : N ;
  fixerande_nn_1_N : N ;
  fjantande_nn_1_N : N ;
  fjaedrande_nn_1_1_N : N ;
  fjaellande_nn_1_1_N : N ;
  fjaellvandrande_nn_1_1_N : N ;
  fjaermande_nn_1_1_N : N ;
  fjaerrblockerande_nn_1_1_N : N ;
  fjaertande_nn_1_1_N : N ;
  fjaeskande_nn_1_1_N : N ;
  fjaettrande_nn_1_1_N : N ;
  flabbande_nn_1_N : N ;
  flackande_nn_1_N : N ;
  fladdrande_nn_1_N : N ;
  flagande_nn_1_N : N ;
  flaggande_nn_1_N : N ;
  flaggviftande_nn_1_N : N ;
  flagnande_nn_1_N : N ;
  flamberande_nn_1_N : N ;
  flammande_nn_1_N : N ;
  flamsande_nn_1_N : N ;
  flanerande_nn_1_N : N ;
  flankerande_nn_1_N : N ;
  flatskrattande_nn_1_N : N ;
  flatterande_nn_1_N : N ;
  flaxande_nn_1_N : N ;
  flekterande_nn_1_N : N ;
  flerdubblande_nn_1_N : N ;
  flerfaldigande_nn_1_N : N ;
  flexande_nn_1_N : N ;
  flickansikte_nn_1_N : N ;
  flimrande_nn_1_N : N ;
  flinande_nn_1_N : N ;
  flirtande_nn_1_N : N ;
  flockbeteende_nn_1_N : N ;
  flodomraade_nn_1_1_N : N ;
  florerande_nn_1_N : N ;
  flottande_nn_1_N : N ;
  flottyrkokande_nn_1_N : N ;
  fluidiserande_nn_1_N : N ;
  fluktande_nn_1_N : N ;
  fluktuerande_nn_1_N : N ;
  flummande_nn_1_N : N ;
  fluorerande_nn_1_N : N ;
  fluorescerande_nn_1_N : N ;
  fluoriderande_nn_1_N : N ;
  flyende_nn_1_N : N ;
  flygande_nn_1_N : N ;
  flygbombande_nn_1_N : N ;
  flygbraensle_nn_1_1_N : N ;
  flyktande_nn_1_N : N ;
  flytande_nn_1_N : N ;
  flyttande_nn_1_N : N ;
  flaeckande_nn_1_1_N : N ;
  flaekande_nn_1_1_N : N ;
  flaektande_nn_1_1_N : N ;
  flaemtande_nn_1_1_N : N ;
  flaengande_nn_1_1_N : N ;
  flaensande_nn_1_1_N : N ;
  flaeskstycke_nn_1_1_N : N ;
  flaetande_nn_1_1_N : N ;
  flaaende_nn_1_1_N : N ;
  flaahackande_nn_1_1_N : N ;
  flaasande_nn_1_1_N : N ;
  floedande_nn_1_1_N : N ;
  floede_nn_1_1_N : N ;
  floejlande_nn_1_1_N : N ;
  floejtande_nn_1_1_N : N ;
  floertande_nn_1_1_N : N ;
  floete_nn_1_1_N : N ;
  fnaskande_nn_1_N : N ;
  fnattande_nn_1_N : N ;
  fnissande_nn_1_N : N ;
  fnittrande_nn_1_N : N ;
  fnysande_nn_1_N : N ;
  fnoeske_nn_1_1_N : N ;
  fockande_nn_1_N : N ;
  fodervaerde_nn_1_1_N : N ;
  fodrande_nn_1_N : N ;
  fogande_nn_1_N : N ;
  fogstrykande_nn_1_N : N ;
  fokuserande_nn_1_N : N ;
  folierande_nn_1_N : N ;
  folkminne_nn_1_N : N ;
  folkmoete_nn_1_1_N : N ;
  folknoeje_nn_1_1_N : N ;
  folkstyre_nn_1_N : N ;
  folkvaelde_nn_1_1_N : N ;
  fonderande_nn_1_N : N ;
  forcerande_nn_1_N : N ;
  fordrande_nn_1_N : N ;
  fordskraelle_nn_1_1_N : N ;
  forecheckande_nn_1_N : N ;
  formaliserande_nn_1_N : N ;
  formande_nn_1_N : N ;
  formerande_nn_1_N : N ;
  formgivande_nn_1_N : N ;
  formgjutande_nn_1_N : N ;
  formpressande_nn_1_N : N ;
  formsinne_nn_1_N : N ;
  formulerande_nn_1_N : N ;
  fornminne_nn_1_N : N ;
  forsande_nn_1_N : N ;
  forskande_nn_1_N : N ;
  forskningsarbete_nn_1_N : N ;
  forskningsfaeste_nn_1_1_N : N ;
  forskningsomraade_nn_1_1_N : N ;
  forskningssyfte_nn_1_N : N ;
  forslande_nn_1_N : N ;
  fortbestaaende_nn_1_1_N : N ;
  forte_nn_1_N : N ;
  fortfarande_nn_1_N : N ;
  fortgaaende_nn_1_1_N : N ;
  fortlevande_nn_1_N : N ;
  fortloepande_nn_1_1_N : N ;
  fortskridande_nn_1_N : N ;
  fortsaettande_nn_1_1_N : N ;
  fosfaterande_nn_1_N : N ;
  fosforescerande_nn_1_N : N ;
  fossilbraensle_nn_1_1_N : N ;
  fossiliserande_nn_1_N : N ;
  fosterlaege_nn_1_1_N : N ;
  fostrande_nn_1_N : N ;
  fotande_nn_1_N : N ;
  fotarbete_nn_1_N : N ;
  fotograferande_nn_1_N : N ;
  fotokopierande_nn_1_N : N ;
  fotostatkopierande_nn_1_N : N ;
  fotvandrande_nn_1_N : N ;
  fradgande_nn_1_N : N ;
  fragmenterande_nn_1_N : N ;
  fraktande_nn_1_N : N ;
  fraktionerande_nn_1_N : N ;
  framavlande_nn_1_N : N ;
  frambesvaerjande_nn_1_1_N : N ;
  frambringande_nn_1_N : N ;
  frambrytande_nn_1_N : N ;
  frambaerande_nn_1_1_N : N ;
  framfarande_nn_1_N : N ;
  framflyttande_nn_1_N : N ;
  framfoedande_nn_1_1_N : N ;
  framfoerande_nn_1_1_N : N ;
  framgaaende_nn_1_1_N : N ;
  framhaerdande_nn_1_1_N : N ;
  framhaevande_nn_1_1_N : N ;
  framhaallande_nn_1_1_N : N ;
  framkallande_nn_1_N : N ;
  framkastande_nn_1_N : N ;
  framkommande_nn_1_N : N ;
  framlevande_nn_1_N : N ;
  framlidande_nn_1_N : N ;
  framlaeggande_nn_1_1_N : N ;
  frammanande_nn_1_N : N ;
  frammatande_nn_1_N : N ;
  framskinande_nn_1_N : N ;
  framskjutande_nn_1_N : N ;
  framskridande_nn_1_N : N ;
  framskymtande_nn_1_N : N ;
  framstycke_nn_1_N : N ;
  framstaellande_nn_1_1_N : N ;
  framstaaende_nn_1_1_N : N ;
  framsaegande_nn_1_1_N : N ;
  framsaete_nn_1_1_N : N ;
  framtidsloefte_nn_1_1_N : N ;
  framtonande_nn_1_N : N ;
  framtraedande_nn_1_1_N : N ;
  framtvingande_nn_1_N : N ;
  framvisande_nn_1_N : N ;
  framvaexande_nn_1_1_N : N ;
  frankerande_nn_1_N : N ;
  fransande_nn_1_N : N ;
  frapperande_nn_1_N : N ;
  frasande_nn_1_N : N ;
  fraserande_nn_1_N : N ;
  fraterniserande_nn_1_N : N ;
  fredande_nn_1_N : N ;
  fredsstraevande_nn_1_1_N : N ;
  frekvensmodulerande_nn_1_N : N ;
  frekvensomraade_nn_1_1_N : N ;
  frekventerande_nn_1_N : N ;
  frestande_nn_1_N : N ;
  friande_nn_1_N : N ;
  fridlysande_nn_1_N : N ;
  frigivande_nn_1_N : N ;
  frigoerande_nn_1_1_N : N ;
  frihandelsomraade_nn_1_1_N : N ;
  frihetsberoevande_nn_1_1_N : N ;
  frikallande_nn_1_N : N ;
  frikopplande_nn_1_N : N ;
  frikaennande_nn_1_1_N : N ;
  frikoepande_nn_1_1_N : N ;
  frilansande_nn_1_N : N ;
  frilistande_nn_1_N : N ;
  friluftsintresse_nn_1_N : N ;
  friluftsomraade_nn_1_1_N : N ;
  frilaege_nn_1_1_N : N ;
  frilaeggande_nn_1_1_N : N ;
  frimaerkande_nn_1_1_N : N ;
  frimaerke_nn_1_1_N : N ;
  frisinne_nn_1_N : N ;
  friskande_nn_1_N : N ;
  friskanmaelande_nn_1_1_N : N ;
  friskfoerklarande_nn_1_1_N : N ;
  friskskrivande_nn_1_N : N ;
  frisksportande_nn_1_N : N ;
  frislaeppande_nn_1_1_N : N ;
  frispelande_nn_1_N : N ;
  fristaellande_nn_1_1_N : N ;
  frisaettande_nn_1_1_N : N ;
  fritagande_nn_1_N : N ;
  friterande_nn_1_N : N ;
  fritidsomraade_nn_1_1_N : N ;
  fromlande_nn_1_N : N ;
  fronderande_nn_1_N : N ;
  frontande_nn_1_N : N ;
  frossande_nn_1_N : N ;
  frotterande_nn_1_N : N ;
  frukosterande_nn_1_N : N ;
  fruktande_nn_1_N : N ;
  fruktaemne_nn_1_1_N : N ;
  frusande_nn_1_N : N ;
  frustande_nn_1_N : N ;
  frustrerande_nn_1_N : N ;
  frynande_nn_1_N : N ;
  frysande_nn_1_N : N ;
  frystestande_nn_1_N : N ;
  frystorkande_nn_1_N : N ;
  fraelsande_nn_1_1_N : N ;
  fraelsningsmoete_nn_1_1_N : N ;
  fraemjande_nn_1_1_N : N ;
  fraemmande_nn_1_1_N : N ;
  fraesande_nn_1_1_N : N ;
  fraetande_nn_1_1_N : N ;
  fraagande_nn_1_1_N : N ;
  fraandoemande_nn_1_1_N : N ;
  fraanfaelle_nn_1_1_N : N ;
  fraangaaende_nn_1_1_N : N ;
  fraankaennande_nn_1_1_N : N ;
  fraanraeknande_nn_1_1_N : N ;
  fraanseende_nn_1_1_N : N ;
  fraanspelande_nn_1_1_N : N ;
  fraantagande_nn_1_1_N : N ;
  fraantraedande_nn_1_1_N : N ;
  froeande_nn_1_1_N : N ;
  froefaeste_nn_1_1_N : N ;
  froegoemme_nn_1_1_N : N ;
  froejdande_nn_1_1_N : N ;
  froeaemne_nn_1_1_N : N ;
  fuktande_nn_1_N : N ;
  fullbordande_nn_1_N : N ;
  fullfoeljande_nn_1_1_N : N ;
  fullgoerande_nn_1_1_N : N ;
  fullkomnande_nn_1_N : N ;
  fullstaendigande_nn_1_1_N : N ;
  fullaendande_nn_1_1_N : N ;
  fumlande_nn_1_N : N ;
  funderande_nn_1_N : N ;
  fungerande_nn_1_N : N ;
  funkande_nn_1_N : N ;
  funktionerande_nn_1_N : N ;
  funktionsvaerde_nn_1_1_N : N ;
  furnerande_nn_1_N : N ;
  furstendoeme_nn_1_1_N : N ;
  fusionerande_nn_1_N : N ;
  fuskande_nn_1_N : N ;
  fuskbygge_nn_1_N : N ;
  futtande_nn_1_N : N ;
  fylkande_nn_1_N : N ;
  fylke_nn_1_N : N ;
  fyllande_nn_1_N : N ;
  fyllnande_nn_1_N : N ;
  fyndande_nn_1_N : N ;
  fysiljerande_nn_1_N : N ;
  faebodstaelle_nn_1_1_N : N ;
  faegnande_nn_1_1_N : N ;
  faektande_nn_1_1_N : N ;
  faellande_nn_1_1_N : N ;
  faeltarbete_nn_1_1_N : N ;
  faengelsefoerhaallande_nn_1_1_N : N ;
  faengslande_nn_1_1_N : N ;
  faerdighetsaemne_nn_1_1_N : N ;
  faerdigstaellande_nn_1_1_N : N ;
  faergande_nn_1_1_N : N ;
  faerglaeggande_nn_1_1_N : N ;
  faergsinne_nn_1_1_N : N ;
  faergaemne_nn_1_1_N : N ;
  faerjande_nn_1_1_N : N ;
  faerjelaege_nn_1_1_N : N ;
  faerserande_nn_1_1_N : N ;
  faerskande_nn_1_1_N : N ;
  faestande_nn_1_1_N : N ;
  faeste_nn_1_1_N : N ;
  faaende_nn_1_1_N : N ;
  faagelfaenge_nn_1_1_N : N ;
  faallande_nn_1_1_N : N ;
  faangande_nn_1_1_N : N ;
  faangstsamhaelle_nn_1_1_N : N ;
  faanskrattande_nn_1_1_N : N ;
  faarande_nn_1_1_N : N ;
  faarbete_nn_1_1_N : N ;
  foedande_nn_1_1_N : N ;
  foedelsemaerke_nn_1_1_N : N ;
  foedoaemne_nn_1_1_N : N ;
  foelande_nn_1_1_N : N ;
  foeljande_nn_1_1_N : N ;
  foelje_nn_1_1_N : N ;
  foenande_nn_1_1_N : N ;
  foensterbraede_nn_1_1_N : N ;
  foeraktande_nn_1_1_N : N ;
  foerallmaenligande_nn_1_1_N : N ;
  foerande_nn_1_1_N : N ;
  foerandligande_nn_1_1_N : N ;
  foerankrande_nn_1_1_N : N ;
  foeranledande_nn_1_1_N : N ;
  foeranmaelande_nn_1_1_N : N ;
  foerannonserande_nn_1_1_N : N ;
  foeranstaltande_nn_1_1_N : N ;
  foerarbete_nn_1_1_N : N ;
  foerargande_nn_1_1_N : N ;
  foerbannande_nn_1_1_N : N ;
  foerbehaallande_nn_1_1_N : N ;
  foerberedande_nn_1_1_N : N ;
  foerberedelsearbete_nn_1_1_N : N ;
  foerbidande_nn_1_1_N : N ;
  foerbigaaende_nn_1_1_N : N ;
  foerbilligande_nn_1_1_N : N ;
  foerbindande_nn_1_1_N : N ;
  foerbindelsearbete_nn_1_1_N : N ;
  foerbiseende_nn_1_1_N : N ;
  foerbittrande_nn_1_1_N : N ;
  foerbjudande_nn_1_1_N : N ;
  foerblandande_nn_1_1_N : N ;
  foerbleknande_nn_1_1_N : N ;
  foerblindande_nn_1_1_N : N ;
  foerblivande_nn_1_1_N : N ;
  foerbluffande_nn_1_1_N : N ;
  foerbloedande_nn_1_1_N : N ;
  foerborgande_nn_1_1_N : N ;
  foerborgerligande_nn_1_1_N : N ;
  foerbrinnande_nn_1_1_N : N ;
  foerbrukande_nn_1_1_N : N ;
  foerbryllande_nn_1_1_N : N ;
  foerbraennande_nn_1_1_N : N ;
  foerbroedrande_nn_1_1_N : N ;
  foerbuskande_nn_1_1_N : N ;
  foerbyggande_nn_1_1_N : N ;
  foerbytande_nn_1_1_N : N ;
  foerbaettrande_nn_1_1_N : N ;
  foerdelande_nn_1_1_N : N ;
  foerdjupande_nn_1_1_N : N ;
  foerdragande_nn_1_1_N : N ;
  foerdrivande_nn_1_1_N : N ;
  foerdroejande_nn_1_1_N : N ;
  foerdubblande_nn_1_1_N : N ;
  foerdummande_nn_1_1_N : N ;
  foerdunklande_nn_1_1_N : N ;
  foerdyrande_nn_1_1_N : N ;
  foerdystrande_nn_1_1_N : N ;
  foerdaemmande_nn_1_1_N : N ;
  foerdaervande_nn_1_1_N : N ;
  foerdoeljande_nn_1_1_N : N ;
  foerdoemande_nn_1_1_N : N ;
  foere_nn_1_1_N : N ;
  foerebraaende_nn_1_1_N : N ;
  foerebyggande_nn_1_1_N : N ;
  foerebaerande_nn_1_1_N : N ;
  foerebaadande_nn_1_1_N : N ;
  foeredragande_nn_2_1_N : N ;
  foeredoeme_nn_1_1_N : N ;
  foerefallande_nn_1_1_N : N ;
  foeregivande_nn_1_1_N : N ;
  foeregripande_nn_1_1_N : N ;
  foeregaaende_nn_2_1_N : N ;
  foerehavande_nn_1_1_N : N ;
  foerehaallande_nn_1_1_N : N ;
  foerekommande_nn_1_1_N : N ;
  foereliggande_nn_1_1_N : N ;
  foerelaeggande_nn_1_1_N : N ;
  foerelaesande_nn_1_1_N : N ;
  foerenande_nn_1_1_N : N ;
  foerenklande_nn_1_1_N : N ;
  foereskrivande_nn_1_1_N : N ;
  foereslaaende_nn_1_1_N : N ;
  foerespeglande_nn_1_1_N : N ;
  foerespraakande_nn_1_1_N : N ;
  foerespaaende_nn_1_1_N : N ;
  foerestavande_nn_1_1_N : N ;
  foerestaellande_nn_1_1_N : N ;
  foerestaaende_nn_1_1_N : N ;
  foeresvaevande_nn_1_1_N : N ;
  foeretagande_nn_1_1_N : N ;
  foereteende_nn_1_1_N : N ;
  foeretraedande_nn_1_1_N : N ;
  foeretraede_nn_1_1_N : N ;
  foerevarande_nn_1_1_N : N ;
  foerevigande_nn_1_1_N : N ;
  foerevisande_nn_1_1_N : N ;
  foerevitande_nn_1_1_N : N ;
  foerfallande_nn_1_1_N : N ;
  foerfalskande_nn_1_1_N : N ;
  foerfarande_nn_1_1_N : N ;
  foerfattande_nn_1_1_N : N ;
  foerfelande_nn_1_1_N : N ;
  foerfinande_nn_1_1_N : N ;
  foerflackande_nn_1_1_N : N ;
  foerflytande_nn_1_1_N : N ;
  foerflyttande_nn_1_1_N : N ;
  foerfogande_nn_1_1_N : N ;
  foerfranskande_nn_1_1_N : N ;
  foerfrysande_nn_1_1_N : N ;
  foerfraemligande_nn_1_1_N : N ;
  foerfuskande_nn_1_1_N : N ;
  foerfaeande_nn_1_1_N : N ;
  foerfaektande_nn_1_1_N : N ;
  foerfaerande_nn_1_1_N : N ;
  foerfaerdigande_nn_1_1_N : N ;
  foerfaangande_nn_1_1_N : N ;
  foerfoeljande_nn_1_1_N : N ;
  foerfoerande_nn_1_1_N : N ;
  foerfoerdelande_nn_1_1_N : N ;
  foergasande_nn_1_1_N : N ;
  foergiftande_nn_1_1_N : N ;
  foergloemmande_nn_1_1_N : N ;
  foergrovande_nn_1_1_N : N ;
  foergrymmande_nn_1_1_N : N ;
  foergyllande_nn_1_1_N : N ;
  foergaetande_nn_1_1_N : N ;
  foergaaende_nn_1_1_N : N ;
  foergoerande_nn_1_1_N : N ;
  foerhalande_nn_1_1_N : N ;
  foerhandlande_nn_1_1_N : N ;
  foerhandlingslaege_nn_1_1_N : N ;
  foerhindrande_nn_1_1_N : N ;
  foerhydande_nn_1_1_N : N ;
  foerhyrande_nn_1_1_N : N ;
  foerhaenge_nn_1_1_N : N ;
  foerhaerdande_nn_1_1_N : N ;
  foerhaerjande_nn_1_1_N : N ;
  foerhaerligande_nn_1_1_N : N ;
  foerhaerskande_nn_1_1_N : N ;
  foerhaexande_nn_1_1_N : N ;
  foerhaallande_nn_1_1_N : N ;
  foerhaanande_nn_1_1_N : N ;
  foerhoejande_nn_1_1_N : N ;
  foerhoerande_nn_1_1_N : N ;
  foerhoersvittne_nn_1_1_N : N ;
  foerintande_nn_1_1_N : N ;
  foerjagande_nn_1_1_N : N ;
  foerkastande_nn_1_1_N : N ;
  foerklarande_nn_1_1_N : N ;
  foerklingande_nn_1_1_N : N ;
  foerklistrande_nn_1_1_N : N ;
  foerklaede_nn_1_1_N : N ;
  foerknippande_nn_1_1_N : N ;
  foerkolnande_nn_1_1_N : N ;
  foerkommande_nn_1_1_N : N ;
  foerkortande_nn_1_1_N : N ;
  foerkovrande_nn_1_1_N : N ;
  foerkromande_nn_1_1_N : N ;
  foerkroppsligande_nn_1_1_N : N ;
  foerkrossande_nn_1_1_N : N ;
  foerkrympande_nn_1_1_N : N ;
  foerkraamande_nn_1_1_N : N ;
  foerkunnande_nn_1_1_N : N ;
  foerkvaevande_nn_1_1_N : N ;
  foerlamande_nn_1_1_N : N ;
  foerledande_nn_1_1_N : N ;
  foerlidande_nn_1_1_N : N ;
  foerlikande_nn_1_1_N : N ;
  foerlisande_nn_1_1_N : N ;
  foerljudande_nn_1_1_N : N ;
  foerljuvande_nn_1_1_N : N ;
  foerlorande_nn_1_1_N : N ;
  foerlossande_nn_1_1_N : N ;
  foerlossningsarbete_nn_1_1_N : N ;
  foerlustande_nn_1_1_N : N ;
  foerlaeggande_nn_1_1_N : N ;
  foerlaenande_nn_1_1_N : N ;
  foerlaengande_nn_1_1_N : N ;
  foerlaatande_nn_1_1_N : N ;
  foerloejligande_nn_1_1_N : N ;
  foerloepande_nn_1_1_N : N ;
  foerloesande_nn_1_1_N : N ;
  foermanande_nn_1_1_N : N ;
  foermedlande_nn_1_1_N : N ;
  foermenande_nn_2_1_N : N ;
  foermiddagskaffe_nn_1_1_N : N ;
  foermildrande_nn_1_1_N : N ;
  foerminskande_nn_1_1_N : N ;
  foermodande_nn_1_1_N : N ;
  foermultnande_nn_1_1_N : N ;
  foermyndarstyre_nn_1_1_N : N ;
  foermaelande_nn_1_1_N : N ;
  foermaenskligande_nn_1_1_N : N ;
  foermaerkande_nn_1_1_N : N ;
  foermaaende_nn_1_1_N : N ;
  foermaanserbjudande_nn_1_1_N : N ;
  foermoerkande_nn_1_1_N : N ;
  foernedrande_nn_1_1_N : N ;
  foernekande_nn_1_1_N : N ;
  foernicklande_nn_1_1_N : N ;
  foernimmande_nn_1_1_N : N ;
  foernyande_nn_1_1_N : N ;
  foernaermande_nn_1_1_N : N ;
  foernoejande_nn_1_1_N : N ;
  foernoetande_nn_1_1_N : N ;
  foerolaempande_nn_1_1_N : N ;
  foerordande_nn_1_1_N : N ;
  foerordnande_nn_1_1_N : N ;
  foerorenande_nn_1_1_N : N ;
  foerorsakande_nn_1_1_N : N ;
  foeroraettande_nn_1_1_N : N ;
  foerpackande_nn_1_1_N : N ;
  foerpaktande_nn_1_1_N : N ;
  foerpantande_nn_1_1_N : N ;
  foerpassande_nn_1_1_N : N ;
  foerpestande_nn_1_1_N : N ;
  foerpliktande_nn_1_1_N : N ;
  foerpliktigande_nn_1_1_N : N ;
  foerplaegande_nn_1_1_N : N ;
  foerprickande_nn_1_1_N : N ;
  foerringande_nn_1_1_N : N ;
  foerrinnande_nn_1_1_N : N ;
  foerruttnande_nn_1_1_N : N ;
  foerryckande_nn_1_1_N : N ;
  foerryskande_nn_1_1_N : N ;
  foerraentande_nn_1_1_N : N ;
  foerraettande_nn_1_1_N : N ;
  foerraaande_nn_1_1_N : N ;
  foerraadande_nn_1_1_N : N ;
  foerraadsutrymme_nn_1_1_N : N ;
  foersakande_nn_1_1_N : N ;
  foersamlande_nn_1_1_N : N ;
  foerseende_nn_1_1_N : N ;
  foerseglande_nn_1_1_N : N ;
  foersenande_nn_1_1_N : N ;
  foersiggaaende_nn_1_1_N : N ;
  foersilvrande_nn_1_1_N : N ;
  foersinkande_nn_1_1_N : N ;
  foersittande_nn_1_1_N : N ;
  foersjunkande_nn_1_1_N : N ;
  foerskaffande_nn_1_1_N : N ;
  foerskansande_nn_1_1_N : N ;
  foerskingrande_nn_1_1_N : N ;
  foerskjutande_nn_1_1_N : N ;
  foerskonande_nn_1_1_N : N ;
  foerskotterande_nn_1_1_N : N ;
  foerskrivande_nn_1_1_N : N ;
  foerskraeckande_nn_1_1_N : N ;
  foerskyllande_nn_1_1_N : N ;
  foerskaerande_nn_1_1_N : N ;
  foerskoenande_nn_1_1_N : N ;
  foerslappande_nn_1_1_N : N ;
  foerslavande_nn_1_1_N : N ;
  foerslitande_nn_1_1_N : N ;
  foerslutande_nn_1_1_N : N ;
  foerslaaende_nn_1_1_N : N ;
  foersloeande_nn_1_1_N : N ;
  foersloesande_nn_1_1_N : N ;
  foersmaektande_nn_1_1_N : N ;
  foersmaaende_nn_1_1_N : N ;
  foersnillande_nn_1_1_N : N ;
  foersonande_nn_1_1_N : N ;
  foerspillande_nn_1_1_N : N ;
  foerspoerjande_nn_1_1_N : N ;
  foerstatligande_nn_1_1_N : N ;
  foerstelnande_nn_1_1_N : N ;
  foerstenande_nn_1_1_N : N ;
  foerstlingsarbete_nn_1_1_N : N ;
  foerstockande_nn_1_1_N : N ;
  foerstoppande_nn_1_1_N : N ;
  foerstorande_nn_1_1_N : N ;
  foerstraeckande_nn_1_1_N : N ;
  foerstraevande_nn_1_1_N : N ;
  foerstroeende_nn_1_1_N : N ;
  foerstummande_nn_1_1_N : N ;
  foerstaellande_nn_1_1_N : N ;
  foerstaemmande_nn_1_1_N : N ;
  foerstaendigande_nn_1_1_N : N ;
  foerstaerkande_nn_1_1_N : N ;
  foerstaaende_nn_1_1_N : N ;
  foerstoerande_nn_1_1_N : N ;
  foersummande_nn_1_1_N : N ;
  foersurande_nn_1_1_N : N ;
  foersvagande_nn_1_1_N : N ;
  foersvarande_nn_1_1_N : N ;
  foersvarsomraade_nn_1_1_N : N ;
  foersvarsaatagande_nn_1_1_N : N ;
  foersvenskande_nn_1_1_N : N ;
  foersvinnande_nn_1_1_N : N ;
  foersvaerjande_nn_1_1_N : N ;
  foersvaarande_nn_1_1_N : N ;
  foersaekrande_nn_1_1_N : N ;
  foersaeljande_nn_1_1_N : N ;
  foersaemrande_nn_1_1_N : N ;
  foersaendande_nn_1_1_N : N ;
  foersaenkande_nn_1_1_N : N ;
  foersaettande_nn_1_1_N : N ;
  foersoekande_nn_1_1_N : N ;
  foersoerjande_nn_1_1_N : N ;
  foersoerjningslaege_nn_1_1_N : N ;
  foertagande_nn_1_1_N : N ;
  foertalande_nn_1_1_N : N ;
  foertecknande_nn_1_1_N : N ;
  foertennande_nn_1_1_N : N ;
  foertidspensionerande_nn_1_1_N : N ;
  foertigande_nn_1_1_N : N ;
  foertjockande_nn_1_1_N : N ;
  foertjusande_nn_1_1_N : N ;
  foertjaenande_nn_1_1_N : N ;
  foertonande_nn_1_1_N : N ;
  foertorkande_nn_1_1_N : N ;
  foertrampande_nn_1_1_N : N ;
  foertretande_nn_1_1_N : N ;
  foertroende_nn_1_1_N : N ;
  foertrollande_nn_1_1_N : N ;
  foertrustande_nn_1_1_N : N ;
  foertryckande_nn_1_1_N : N ;
  foertrytande_nn_1_1_N : N ;
  foertraengande_nn_1_1_N : N ;
  foertroestande_nn_1_1_N : N ;
  foertullande_nn_1_1_N : N ;
  foertunnande_nn_1_1_N : N ;
  foertvinande_nn_1_1_N : N ;
  foertvivlande_nn_1_1_N : N ;
  foertvaalande_nn_1_1_N : N ;
  foertyckande_nn_1_1_N : N ;
  foertydligande_nn_1_1_N : N ;
  foertyskande_nn_1_1_N : N ;
  foertaeljande_nn_1_1_N : N ;
  foertaenkande_nn_1_1_N : N ;
  foertaerande_nn_1_1_N : N ;
  foertaetande_nn_1_1_N : N ;
  foertoejande_nn_1_1_N : N ;
  foerundersoekande_nn_1_1_N : N ;
  foerundrande_nn_1_1_N : N ;
  foerunnande_nn_1_1_N : N ;
  foerutbestaemmande_nn_1_1_N : N ;
  foerutskickande_nn_1_1_N : N ;
  foerutspaaende_nn_1_1_N : N ;
  foerutsaegande_nn_1_1_N : N ;
  foerutsaettande_nn_1_1_N : N ;
  foervaltande_nn_1_1_N : N ;
  foervaltarskapsomraade_nn_1_1_N : N ;
  foervandlande_nn_1_1_N : N ;
  foervanskande_nn_1_1_N : N ;
  foervarande_nn_1_1_N : N ;
  foervaringsstaelle_nn_1_1_N : N ;
  foervaringsutrymme_nn_1_1_N : N ;
  foervarnande_nn_1_1_N : N ;
  foervedande_nn_1_1_N : N ;
  foervekligande_nn_1_1_N : N ;
  foerverkande_nn_1_1_N : N ;
  foerverkligande_nn_1_1_N : N ;
  foervillande_nn_1_1_N : N ;
  foervirrande_nn_1_1_N : N ;
  foervisande_nn_1_1_N : N ;
  foervissande_nn_1_1_N : N ;
  foervissnande_nn_1_1_N : N ;
  foervittrande_nn_1_1_N : N ;
  foervridande_nn_1_1_N : N ;
  foervraengande_nn_1_1_N : N ;
  foervaegrande_nn_1_1_N : N ;
  foervaellande_nn_1_1_N : N ;
  foervaendande_nn_1_1_N : N ;
  foervaentande_nn_1_1_N : N ;
  foervaerldsligande_nn_1_1_N : N ;
  foervaerrande_nn_1_1_N : N ;
  foervaervande_nn_1_1_N : N ;
  foervaervsarbetande_nn_1_1_N : N ;
  foervaexlande_nn_1_1_N : N ;
  foervaanande_nn_1_1_N : N ;
  foeryngrande_nn_1_1_N : N ;
  foerzinkande_nn_1_1_N : N ;
  foeraedlande_nn_1_1_N : N ;
  foeraedlingsarbete_nn_1_1_N : N ;
  foeraeldramoete_nn_1_1_N : N ;
  foeraendrande_nn_1_1_N : N ;
  foeraendringsarbete_nn_1_1_N : N ;
  foeraerande_nn_1_1_N : N ;
  foeraangande_nn_1_1_N : N ;
  foeroedande_nn_1_1_N : N ;
  foeroedmjukande_nn_1_1_N : N ;
  foeroekande_nn_1_1_N : N ;
  foeroevande_nn_1_1_N : N ;
  foesande_nn_1_1_N : N ;
  gafflande_nn_1_N : N ;
  gaggande_nn_1_N : N ;
  gagnande_nn_1_N : N ;
  galande_nn_1_N : N ;
  galliserande_nn_1_N : N ;
  gallrande_nn_1_N : N ;
  gallskrikande_nn_1_N : N ;
  galltjutande_nn_1_N : N ;
  gallaepple_nn_1_1_N : N ;
  galopperande_nn_1_N : N ;
  galoscherande_nn_1_N : N ;
  galvande_nn_1_N : N ;
  galvaniserande_nn_1_N : N ;
  gamande_nn_1_N : N ;
  ganande_nn_1_N : N ;
  gandhiskynke_nn_1_N : N ;
  gapande_nn_1_N : N ;
  gapflabbande_nn_1_N : N ;
  gapskrattande_nn_1_N : N ;
  garagerande_nn_1_N : N ;
  garande_nn_1_N : N ;
  garanterande_nn_1_N : N ;
  garde_nn_1_N : N ;
  garderande_nn_1_N : N ;
  garnerande_nn_1_N : N ;
  garnisonerande_nn_1_N : N ;
  garrotterande_nn_1_N : N ;
  garvande_nn_1_N : N ;
  garvaemne_nn_1_1_N : N ;
  gasande_nn_1_N : N ;
  gassande_nn_1_N : N ;
  gastande_nn_1_N : N ;
  gasterande_nn_1_N : N ;
  gastkramande_nn_1_N : N ;
  gastroskoperande_nn_1_N : N ;
  gauffrerande_nn_1_N : N ;
  gavelroeste_nn_1_1_N : N ;
  geende_nn_1_N : N ;
  geggande_nn_1_N : N ;
  gelatinerande_nn_1_N : N ;
  geleande_nn_1_N : N ;
  geminerande_nn_1_N : N ;
  genande_nn_1_N : N ;
  gendrivande_nn_1_N : N ;
  generaliserande_nn_1_N : N ;
  generande_nn_1_N : N ;
  generationsskifte_nn_1_N : N ;
  genererande_nn_1_N : N ;
  genfloede_nn_1_1_N : N ;
  gengaeldande_nn_1_1_N : N ;
  genljudande_nn_1_N : N ;
  genmanipulerande_nn_1_N : N ;
  genmaelande_nn_1_1_N : N ;
  genmaele_nn_1_1_N : N ;
  genomarbetande_nn_1_N : N ;
  genomborrande_nn_1_N : N ;
  genombrytande_nn_1_N : N ;
  genomdrivande_nn_1_N : N ;
  genomfarande_nn_1_N : N ;
  genomfoerande_nn_1_1_N : N ;
  genomgaaende_nn_1_1_N : N ;
  genomkorsande_nn_1_N : N ;
  genomlevande_nn_1_N : N ;
  genomlidande_nn_1_N : N ;
  genomlysande_nn_1_N : N ;
  genomsipprande_nn_1_N : N ;
  genomskaadande_nn_1_1_N : N ;
  genomskoeljande_nn_1_1_N : N ;
  genomsnittsvaerde_nn_1_1_N : N ;
  genomstroemmande_nn_1_1_N : N ;
  genomsyrande_nn_1_N : N ;
  genomsoekande_nn_1_1_N : N ;
  genomtraengande_nn_1_1_N : N ;
  genomtaenkande_nn_1_1_N : N ;
  genskjutande_nn_1_N : N ;
  gentagande_nn_1_N : N ;
  geometriserande_nn_1_N : N ;
  geotaggande_nn_1_N : N ;
  germaniserande_nn_1_N : N ;
  gestaltande_nn_1_N : N ;
  gestikulerande_nn_1_N : N ;
  gevaerssikte_nn_1_1_N : N ;
  gevaerssmide_nn_1_1_N : N ;
  gifte_nn_1_N : N ;
  gigande_nn_1_N : N ;
  giggande_nn_1_N : N ;
  giljande_nn_1_N : N ;
  giljotinerande_nn_1_N : N ;
  gillande_nn_1_N : N ;
  gille_nn_1_N : N ;
  gillrande_nn_1_N : N ;
  ginande_nn_1_N : N ;
  gipande_nn_1_N : N ;
  gippande_nn_1_N : N ;
  gipsande_nn_1_N : N ;
  girande_nn_1_N : N ;
  girerande_nn_1_N : N ;
  gissande_nn_1_N : N ;
  gisslande_nn_1_N : N ;
  gisslantagande_nn_1_N : N ;
  gistande_nn_1_N : N ;
  gistnande_nn_1_N : N ;
  gittande_nn_1_N : N ;
  givande_nn_1_N : N ;
  gjordande_nn_1_N : N ;
  gjutande_nn_1_N : N ;
  glammande_nn_1_N : N ;
  glamoriserande_nn_1_N : N ;
  glamouriserande_nn_1_N : N ;
  glanande_nn_1_N : N ;
  glansande_nn_1_N : N ;
  glanskande_nn_1_N : N ;
  glappande_nn_1_N : N ;
  glasande_nn_1_N : N ;
  glaserande_nn_1_N : N ;
  glassande_nn_1_N : N ;
  glasaepple_nn_1_1_N : N ;
  glattande_nn_1_N : N ;
  glesande_nn_1_N : N ;
  glesnande_nn_1_N : N ;
  glidande_nn_1_N : N ;
  glimmande_nn_1_N : N ;
  glimrande_nn_1_N : N ;
  glimtande_nn_1_N : N ;
  glindrande_nn_1_N : N ;
  glipande_nn_1_N : N ;
  glisande_nn_1_N : N ;
  glittrande_nn_1_N : N ;
  gloende_nn_1_N : N ;
  glorifierande_nn_1_N : N ;
  glunkande_nn_1_N : N ;
  gluttande_nn_1_N : N ;
  glaedjande_nn_1_1_N : N ;
  glaedjeaemne_nn_1_1_N : N ;
  glaefsande_nn_1_1_N : N ;
  glaensande_nn_1_1_N : N ;
  glaentande_nn_1_1_N : N ;
  glaettande_nn_1_1_N : N ;
  gloedande_nn_1_1_N : N ;
  gloedbakande_nn_1_1_N : N ;
  gloedgande_nn_1_1_N : N ;
  gloedritande_nn_1_1_N : N ;
  gloedstekande_nn_1_1_N : N ;
  gloedtaendande_nn_1_1_N : N ;
  gloeggande_nn_1_1_N : N ;
  gloemmande_nn_1_1_N : N ;
  gloetande_nn_1_1_N : N ;
  gnagande_nn_1_N : N ;
  gnatande_nn_1_N : N ;
  gnavande_nn_1_N : N ;
  gnetande_nn_1_N : N ;
  gnidande_nn_1_N : N ;
  gnisslande_nn_1_N : N ;
  gnistande_nn_1_N : N ;
  gnistrande_nn_1_N : N ;
  gnoende_nn_1_N : N ;
  gnolande_nn_1_N : N ;
  gnuggande_nn_1_N : N ;
  gnussande_nn_1_N : N ;
  gnyende_nn_1_N : N ;
  gnaeggande_nn_1_1_N : N ;
  gnaellande_nn_1_1_N : N ;
  gnoelande_nn_1_1_N : N ;
  godkaennande_nn_1_1_N : N ;
  godtagande_nn_1_N : N ;
  goffrerande_nn_1_N : N ;
  golfande_nn_1_N : N ;
  golvande_nn_1_N : N ;
  googlande_nn_1_N : N ;
  gormande_nn_1_N : N ;
  gosande_nn_1_N : N ;
  gottgoerande_nn_1_1_N : N ;
  gottskrivande_nn_1_N : N ;
  gouterande_nn_1_N : N ;
  grabbande_nn_1_N : N ;
  gradande_nn_1_N : N ;
  graderande_nn_1_N : N ;
  graduerande_nn_1_N : N ;
  grafiterande_nn_1_N : N ;
  granataepple_nn_1_1_N : N ;
  grannrike_nn_1_N : N ;
  grannraecke_nn_1_1_N : N ;
  granskande_nn_1_N : N ;
  granulerande_nn_1_N : N ;
  grasserande_nn_1_N : N ;
  gratinerande_nn_1_N : N ;
  gratisnoeje_nn_1_1_N : N ;
  grattande_nn_1_N : N ;
  gratulerande_nn_1_N : N ;
  gravande_nn_1_N : N ;
  graverande_nn_1_N : N ;
  graviterande_nn_1_N : N ;
  gravlaeggande_nn_1_1_N : N ;
  gravroese_nn_1_1_N : N ;
  gravsaettande_nn_1_1_N : N ;
  grejande_nn_1_N : N ;
  grenadjaerregemente_nn_1_1_N : N ;
  grenslande_nn_1_N : N ;
  greppande_nn_1_N : N ;
  greppbraede_nn_1_1_N : N ;
  griljerande_nn_1_N : N ;
  grillande_nn_1_N : N ;
  grimaserande_nn_1_N : N ;
  grimerande_nn_1_N : N ;
  grinande_nn_1_N : N ;
  gripande_nn_1_N : N ;
  grisande_nn_1_N : N ;
  groddande_nn_1_N : N ;
  groende_nn_1_N : N ;
  groggande_nn_1_N : N ;
  grovarbete_nn_1_N : N ;
  grovnande_nn_1_N : N ;
  grovplanerande_nn_1_N : N ;
  grovsorterande_nn_1_N : N ;
  grubblande_nn_1_N : N ;
  gruffande_nn_1_N : N ;
  grumlande_nn_1_N : N ;
  grumsande_nn_1_N : N ;
  grundande_nn_1_N : N ;
  grundantagande_nn_1_N : N ;
  grundbehandlande_nn_1_N : N ;
  grunderande_nn_1_N : N ;
  grundlurande_nn_1_N : N ;
  grundlaeggande_nn_1_1_N : N ;
  grundmaalande_nn_1_1_N : N ;
  grundstoetande_nn_1_1_N : N ;
  grundaemne_nn_1_1_N : N ;
  grunnande_nn_1_N : N ;
  grupparbete_nn_1_N : N ;
  gruppboende_nn_1_N : N ;
  grupperande_nn_1_N : N ;
  gruppsaaende_nn_1_1_N : N ;
  grusande_nn_1_N : N ;
  gryende_nn_1_N : N ;
  grymtande_nn_1_N : N ;
  grynande_nn_1_N : N ;
  graeddande_nn_1_1_N : N ;
  graeftande_nn_1_1_N : N ;
  graelande_nn_1_1_N : N ;
  graemande_nn_1_1_N : N ;
  graenslande_nn_1_1_N : N ;
  graensmaerke_nn_1_1_N : N ;
  graensomraade_nn_1_1_N : N ;
  graensvaerde_nn_1_1_N : N ;
  graensoeverskridande_nn_1_1_N : N ;
  graesande_nn_1_1_N : N ;
  graevande_nn_1_1_N : N ;
  graanande_nn_1_1_N : N ;
  graatande_nn_1_1_N : N ;
  groengoedslande_nn_1_1_N : N ;
  groenomraade_nn_1_1_N : N ;
  groenskande_nn_1_1_N : N ;
  groepande_nn_1_1_N : N ;
  groetande_nn_1_1_N : N ;
  gubbvaelde_nn_1_1_N : N ;
  gudabelaete_nn_1_1_N : N ;
  guidande_nn_1_N : N ;
  guldsmide_nn_1_N : N ;
  guldaepple_nn_1_1_N : N ;
  gulfaergande_nn_1_1_N : N ;
  gullande_nn_1_N : N ;
  gulnande_nn_1_N : N ;
  gummerande_nn_1_N : N ;
  gumpande_nn_1_N : N ;
  gungande_nn_1_N : N ;
  gungbraede_nn_1_1_N : N ;
  guppande_nn_1_N : N ;
  gurglande_nn_1_N : N ;
  guskande_nn_1_N : N ;
  guterande_nn_1_N : N ;
  gycklande_nn_1_N : N ;
  gyllenklaede_nn_1_1_N : N ;
  gymnastiserande_nn_1_N : N ;
  gympande_nn_1_N : N ;
  gynnande_nn_1_N : N ;
  gyttrande_nn_1_N : N ;
  gaeckande_nn_1_1_N : N ;
  gaelande_nn_1_1_N : N ;
  gaeldande_nn_1_1_N : N ;
  gaellande_nn_1_1_N : N ;
  gaengande_nn_1_1_N : N ;
  gaenge_nn_1_1_N : N ;
  gaerdande_nn_1_1_N : N ;
  gaerde_nn_1_1_N : N ;
  gaerdslande_nn_1_1_N : N ;
  gaerdsle_nn_1_1_N : N ;
  gaespande_nn_1_1_N : N ;
  gaestande_nn_1_1_N : N ;
  gaestspelande_nn_1_1_N : N ;
  gaaende_nn_1_1_N : N ;
  gaangande_nn_1_1_N : N ;
  gaangrande_nn_1_1_N : N ;
  gaardsomraade_nn_1_1_N : N ;
  goedande_nn_1_1_N : N ;
  goedslande_nn_1_1_N : N ;
  goekande_nn_1_1_N : N ;
  goemmande_nn_1_1_N : N ;
  goemme_nn_1_1_N : N ;
  goemsle_nn_1_1_N : N ;
  goemstaelle_nn_1_1_N : N ;
  goerande_nn_1_1_N : N ;
  goerdlande_nn_1_1_N : N ;
  goete_nn_1_1_N : N ;
  hackande_nn_1_N : N ;
  hackbraede_nn_1_1_N : N ;
  haffande_nn_1_N : N ;
  hafsande_nn_1_N : N ;
  haglande_nn_1_N : N ;
  hajande_nn_1_N : N ;
  hajkande_nn_1_N : N ;
  hakande_nn_1_N : N ;
  halande_nn_1_N : N ;
  halkande_nn_1_N : N ;
  hallelujamoete_nn_1_1_N : N ;
  hallstaemplande_nn_1_1_N : N ;
  hallucinerande_nn_1_N : N ;
  hallaaande_nn_1_1_N : N ;
  halsande_nn_1_N : N ;
  halshuggande_nn_1_N : N ;
  halssmycke_nn_1_N : N ;
  halstrande_nn_1_N : N ;
  haltande_nn_1_N : N ;
  halverande_nn_1_N : N ;
  halvsovande_nn_1_N : N ;
  halvsulande_nn_1_N : N ;
  halvviskande_nn_1_N : N ;
  halvaarsskifte_nn_1_1_N : N ;
  hamburgarstaelle_nn_1_1_N : N ;
  hamburgerstaelle_nn_1_1_N : N ;
  hamlande_nn_1_N : N ;
  hamnande_nn_1_N : N ;
  hamnfoerhaallande_nn_1_1_N : N ;
  hamrande_nn_1_N : N ;
  hamstrande_nn_1_N : N ;
  handarbetande_nn_1_N : N ;
  handarbete_nn_1_N : N ;
  handelsutbyte_nn_1_N : N ;
  handhavande_nn_1_N : N ;
  handikappande_nn_1_N : N ;
  handlande_nn_2_N : N ;
  handledande_nn_1_N : N ;
  handlaeggande_nn_1_1_N : N ;
  handplockande_nn_1_N : N ;
  hankande_nn_1_N : N ;
  hanterande_nn_1_N : N ;
  harangerande_nn_1_N : N ;
  harklande_nn_1_N : N ;
  harmande_nn_1_N : N ;
  harmonierande_nn_1_N : N ;
  harmoniserande_nn_1_N : N ;
  harpunerande_nn_1_N : N ;
  harsklande_nn_1_N : N ;
  hartsande_nn_1_N : N ;
  harvande_nn_1_N : N ;
  hasande_nn_1_N : N ;
  hasarderande_nn_1_N : N ;
  haspande_nn_1_N : N ;
  hasplande_nn_1_N : N ;
  hastande_nn_1_N : N ;
  hatande_nn_1_N : N ;
  hattande_nn_1_N : N ;
  haussande_nn_1_N : N ;
  havande_nn_1_N : N ;
  havererande_nn_1_N : N ;
  havsomraade_nn_1_1_N : N ;
  hedersomnaemnande_nn_1_1_N : N ;
  hedrande_nn_1_N : N ;
  hejande_nn_1_N : N ;
  hejdande_nn_1_N : N ;
  hektograferande_nn_1_N : N ;
  helande_nn_1_N : N ;
  helfoersaekrande_nn_1_1_N : N ;
  helgande_nn_1_N : N ;
  helgarderande_nn_1_N : N ;
  helgonfoerklarande_nn_1_1_N : N ;
  helinackorderande_nn_1_N : N ;
  helsike_nn_1_N : N ;
  helvete_nn_1_N : N ;
  hemarbete_nn_1_N : N ;
  hembitraede_nn_1_1_N : N ;
  hembjudande_nn_1_N : N ;
  hembaerande_nn_1_1_N : N ;
  hemfallande_nn_1_N : N ;
  hemfoerande_nn_1_1_N : N ;
  hemfoerlovande_nn_1_1_N : N ;
  hemkallande_nn_1_N : N ;
  hemlighaallande_nn_1_1_N : N ;
  hemligstaemplande_nn_1_1_N : N ;
  hemstaellande_nn_1_1_N : N ;
  hemsoekande_nn_1_1_N : N ;
  hemvaendande_nn_1_1_N : N ;
  henande_nn_1_N : N ;
  herdaminne_nn_1_N : N ;
  herkulesarbete_nn_1_N : N ;
  heroiserande_nn_1_N : N ;
  herradoeme_nn_1_1_N : N ;
  herravaelde_nn_1_1_N : N ;
  herresaete_nn_1_1_N : N ;
  herrmode_nn_1_N : N ;
  hertigdoeme_nn_1_1_N : N ;
  hesiterande_nn_1_N : N ;
  hetande_nn_1_N : N ;
  hetsande_nn_1_N : N ;
  hettande_nn_1_N : N ;
  hibernerande_nn_1_N : N ;
  hickande_nn_1_N : N ;
  himlande_nn_1_N : N ;
  hindrande_nn_1_N : N ;
  hinkande_nn_1_N : N ;
  hinnande_nn_1_N : N ;
  hisnande_nn_1_N : N ;
  hissande_nn_1_N : N ;
  hissnande_nn_1_N : N ;
  historieberaettande_nn_1_1_N : N ;
  historierande_nn_1_N : N ;
  historiserande_nn_1_N : N ;
  hittande_nn_1_N : N ;
  hivande_nn_1_N : N ;
  hjulande_nn_1_N : N ;
  hjaelpande_nn_1_1_N : N ;
  hjaernbyte_nn_1_1_N : N ;
  hjaernspoeke_nn_1_1_N : N ;
  hjaerntvaettande_nn_1_1_N : N ;
  hoande_nn_1_N : N ;
  hojande_nn_1_N : N ;
  hojtande_nn_1_N : N ;
  holograferande_nn_1_N : N ;
  homogeniserande_nn_1_N : N ;
  honorerande_nn_1_N : N ;
  hopande_nn_1_N : N ;
  hopbringande_nn_1_N : N ;
  hopbuntande_nn_1_N : N ;
  hopdiktande_nn_1_N : N ;
  hopfogande_nn_1_N : N ;
  hopknycklande_nn_1_N : N ;
  hopknytande_nn_1_N : N ;
  hopkopplande_nn_1_N : N ;
  hoplappande_nn_1_N : N ;
  hoppackande_nn_1_N : N ;
  hoppande_nn_1_N : N ;
  hoprafsande_nn_1_N : N ;
  hopskjutande_nn_1_N : N ;
  hopvikande_nn_1_N : N ;
  horande_nn_1_N : N ;
  horisontallaege_nn_1_1_N : N ;
  hospitaliserande_nn_1_N : N ;
  hostande_nn_1_N : N ;
  hotande_nn_1_N : N ;
  hottande_nn_1_N : N ;
  hovnigande_nn_1_N : N ;
  hovrande_nn_1_N : N ;
  huckle_nn_1_N : N ;
  hudflaengande_nn_1_1_N : N ;
  hugfaestande_nn_1_1_N : N ;
  huggande_nn_1_N : N ;
  hugnande_nn_1_N : N ;
  hugsvalande_nn_1_N : N ;
  hulkande_nn_1_N : N ;
  humaniserande_nn_1_N : N ;
  hummande_nn_1_N : N ;
  humusaemne_nn_1_1_N : N ;
  hundare_nn_1_N : N ;
  hundrade_nn_1_N : N ;
  hundraaarsminne_nn_1_1_N : N ;
  hundsande_nn_1_N : N ;
  hundsfotterande_nn_1_N : N ;
  hungerstrejkande_nn_1_N : N ;
  hungrande_nn_1_N : N ;
  hunsande_nn_1_N : N ;
  hurrande_nn_1_N : N ;
  hursarregemente_nn_1_N : N ;
  husbygge_nn_1_N : N ;
  huserande_nn_1_N : N ;
  hushaallande_nn_1_1_N : N ;
  hushaallsarbete_nn_1_1_N : N ;
  hutande_nn_1_N : N ;
  huttlande_nn_1_N : N ;
  huttrande_nn_1_N : N ;
  huve_nn_1_N : N ;
  huvudanfoerande_nn_1_1_N : N ;
  huvudintresse_nn_1_N : N ;
  huvudstycke_nn_1_N : N ;
  huvudsaete_nn_1_1_N : N ;
  huvudvittne_nn_1_N : N ;
  huvudaemne_nn_1_1_N : N ;
  hybble_nn_1_N : N ;
  hybridiserande_nn_1_N : N ;
  hycklande_nn_1_N : N ;
  hydrerande_nn_1_N : N ;
  hyende_nn_1_N : N ;
  hyfsande_nn_1_N : N ;
  hygge_nn_1_N : N ;
  hylande_nn_1_N : N ;
  hyllande_nn_1_N : N ;
  hylle_nn_1_N : N ;
  hymlande_nn_1_N : N ;
  hypnotiserande_nn_1_N : N ;
  hypotiserande_nn_1_N : N ;
  hyrande_nn_1_N : N ;
  hyresreglerande_nn_1_N : N ;
  hysande_nn_1_N : N ;
  hyssjande_nn_1_N : N ;
  hystande_nn_1_N : N ;
  hyttande_nn_1_N : N ;
  hyvande_nn_1_N : N ;
  hyvlande_nn_1_N : N ;
  haeckande_nn_1_1_N : N ;
  haecklande_nn_1_1_N : N ;
  haedande_nn_1_1_N : N ;
  haedankallande_nn_1_1_N : N ;
  haeftande_nn_1_1_N : N ;
  haefte_nn_1_1_N : N ;
  haegnande_nn_1_1_N : N ;
  haegrande_nn_1_1_N : N ;
  haektande_nn_1_1_N : N ;
  haekte_nn_1_1_N : N ;
  haellande_nn_1_1_N : N ;
  haellregnande_nn_1_1_N : N ;
  haelsande_nn_1_1_N : N ;
  haelsningsanfoerande_nn_1_1_N : N ;
  haelsningsfoerfarande_nn_1_1_N : N ;
  haelsolaege_nn_1_1_N : N ;
  haemmande_nn_1_1_N : N ;
  haemnande_nn_1_1_N : N ;
  haemtande_nn_1_1_N : N ;
  haendande_nn_1_1_N : N ;
  haenfoerande_nn_1_1_N : N ;
  haengande_nn_1_1_N : N ;
  haengbrobygge_nn_1_1_N : N ;
  haenge_nn_1_1_N : N ;
  haengsle_nn_1_1_N : N ;
  haengsmycke_nn_1_1_N : N ;
  haenryckande_nn_1_1_N : N ;
  haenseende_nn_1_1_N : N ;
  haenskjutande_nn_1_1_N : N ;
  haensyftande_nn_1_1_N : N ;
  haensynstagande_nn_1_1_N : N ;
  haentydande_nn_1_1_N : N ;
  haenvisande_nn_1_1_N : N ;
  haepnande_nn_1_1_N : N ;
  haerbre_nn_1_1_N : N ;
  haerbaerge_nn_1_1_N : N ;
  haerbaergerande_nn_1_1_N : N ;
  haerdande_nn_1_1_N : N ;
  haerflytande_nn_1_1_N : N ;
  haerjande_nn_1_1_N : N ;
  haerledande_nn_1_1_N : N ;
  haermande_nn_1_1_N : N ;
  haerroerande_nn_1_1_N : N ;
  haerskande_nn_1_1_N : N ;
  haersknande_nn_1_1_N : N ;
  haerstammande_nn_1_1_N : N ;
  haessjande_nn_1_1_N : N ;
  haestansikte_nn_1_1_N : N ;
  haevande_nn_1_1_N : N ;
  haevdande_nn_1_1_N : N ;
  haalande_nn_1_1_N : N ;
  haallande_nn_1_1_N : N ;
  haalslaaende_nn_1_1_N : N ;
  haanande_nn_1_1_N : N ;
  haanflinande_nn_1_1_N : N ;
  haanglande_nn_1_1_N : N ;
  haanleende_nn_1_1_N : N ;
  haanskrattande_nn_1_1_N : N ;
  haardnande_nn_1_1_N : N ;
  haardragande_nn_1_1_N : N ;
  haardtraenande_nn_1_1_N : N ;
  haarfaeste_nn_1_1_N : N ;
  haarmode_nn_1_1_N : N ;
  haarspaenne_nn_1_1_N : N ;
  haavande_nn_1_1_N : N ;
  hoeftskynke_nn_1_1_N : N ;
  hoegaktande_nn_1_1_N : N ;
  hoegfjaellsomraade_nn_1_1_N : N ;
  hoegriskbeteende_nn_1_1_N : N ;
  hoegsaete_nn_1_1_N : N ;
  hoegtidlighaallande_nn_1_1_N : N ;
  hoegtrycksomraade_nn_1_1_N : N ;
  hoejande_nn_1_1_N : N ;
  hoejdlaege_nn_1_1_N : N ;
  hoeljande_nn_1_1_N : N ;
  hoelje_nn_1_1_N : N ;
  hoerande_nn_1_1_N : N ;
  hoersammande_nn_1_1_N : N ;
  hoerselsinne_nn_1_1_N : N ;
  hoestande_nn_1_1_N : N ;
  hoetande_nn_1_1_N : N ;
  hoettande_nn_1_1_N : N ;
  hoevdingasamhaelle_nn_1_1_N : N ;
  iakttagande_nn_1_N : N ;
  ide_nn_1_N : N ;
  idealiserande_nn_1_N : N ;
  idealsamhaelle_nn_1_1_N : N ;
  identifierande_nn_1_N : N ;
  idiotfoerklarande_nn_1_1_N : N ;
  idisslande_nn_1_N : N ;
  idkande_nn_1_N : N ;
  idrottande_nn_1_N : N ;
  idunsaepple_nn_1_1_N : N ;
  id_emoete_nn_1_1_N : N ;
  ifraagakommande_nn_1_1_N : N ;
  ifraagasaettande_nn_1_1_N : N ;
  ignorerande_nn_1_N : N ;
  igaangsaettande_nn_1_1_N : N ;
  ihopbuntande_nn_1_N : N ;
  ihopknycklande_nn_1_N : N ;
  ihopkopplande_nn_1_N : N ;
  ihoppackande_nn_1_N : N ;
  ihopskjutande_nn_1_N : N ;
  ihaagkommande_nn_1_1_N : N ;
  iklaedande_nn_1_1_N : N ;
  ilande_nn_1_N : N ;
  ilandsaettande_nn_1_1_N : N ;
  illtjutande_nn_1_N : N ;
  illuderande_nn_1_N : N ;
  illuminerande_nn_1_N : N ;
  illustrerande_nn_1_N : N ;
  illvraalande_nn_1_1_N : N ;
  imiterande_nn_1_N : N ;
  immande_nn_1_N : N ;
  immatrikulerande_nn_1_N : N ;
  immigrerande_nn_1_N : N ;
  immuniserande_nn_1_N : N ;
  impande_nn_1_N : N ;
  implanterande_nn_1_N : N ;
  implicerande_nn_1_N : N ;
  imploderande_nn_1_N : N ;
  imponerande_nn_1_N : N ;
  importerande_nn_1_N : N ;
  impregnerande_nn_1_N : N ;
  improviserande_nn_1_N : N ;
  inackorderande_nn_1_N : N ;
  inarbetande_nn_1_N : N ;
  inaugurerande_nn_1_N : N ;
  inbakande_nn_1_N : N ;
  inbegripande_nn_1_N : N ;
  inberaeknande_nn_1_1_N : N ;
  inbesparande_nn_1_N : N ;
  inbetalande_nn_1_N : N ;
  inbillande_nn_1_N : N ;
  inbringande_nn_1_N : N ;
  inbyggande_nn_1_N : N ;
  inbyte_nn_1_N : N ;
  indelande_nn_1_N : N ;
  indexerande_nn_1_N : N ;
  indexreglerande_nn_1_N : N ;
  indicerande_nn_1_N : N ;
  indikerande_nn_1_N : N ;
  individualiserande_nn_1_N : N ;
  indoktrinerande_nn_1_N : N ;
  indragande_nn_1_N : N ;
  indrivande_nn_1_N : N ;
  indraenkande_nn_1_1_N : N ;
  inducerande_nn_1_N : N ;
  indunstande_nn_1_N : N ;
  industrialiserande_nn_1_N : N ;
  industriomraade_nn_1_1_N : N ;
  industrisamhaelle_nn_1_1_N : N ;
  infallande_nn_1_N : N ;
  infattande_nn_1_N : N ;
  infekterande_nn_1_N : N ;
  infettande_nn_1_N : N ;
  infiltrerande_nn_1_N : N ;
  infinitivmaerke_nn_1_1_N : N ;
  inflammerande_nn_1_N : N ;
  inflickande_nn_1_N : N ;
  inflikande_nn_1_N : N ;
  influerande_nn_1_N : N ;
  inflytande_nn_1_N : N ;
  inflyttande_nn_1_N : N ;
  inflaetande_nn_1_1_N : N ;
  infloede_nn_1_1_N : N ;
  infodrande_nn_1_N : N ;
  infogande_nn_1_N : N ;
  infordrande_nn_1_N : N ;
  informationsfloede_nn_1_1_N : N ;
  informationsfoerelaeggande_nn_1_1_N : N ;
  informationsmoete_nn_1_1_N : N ;
  informationssamhaelle_nn_1_1_N : N ;
  informationsutbyte_nn_1_N : N ;
  informerande_nn_1_N : N ;
  infriande_nn_1_N : N ;
  infaangande_nn_1_1_N : N ;
  infoerande_nn_1_1_N : N ;
  infoerlivande_nn_1_1_N : N ;
  infoerskaffande_nn_1_1_N : N ;
  ingifte_nn_1_N : N ;
  ingivande_nn_1_N : N ;
  ingjutande_nn_1_N : N ;
  ingraverande_nn_1_N : N ;
  ingripande_nn_1_N : N ;
  ingaaende_nn_1_1_N : N ;
  ingoete_nn_1_1_N : N ;
  inhalerande_nn_1_N : N ;
  inhandlande_nn_1_N : N ;
  inhiberande_nn_1_N : N ;
  inhibiterande_nn_1_N : N ;
  inhysande_nn_1_N : N ;
  inhaegnande_nn_1_1_N : N ;
  inhaemtande_nn_1_1_N : N ;
  inhoestande_nn_1_1_N : N ;
  initierande_nn_1_N : N ;
  injagande_nn_1_N : N ;
  injekterande_nn_1_N : N ;
  injektionsstaelle_nn_1_1_N : N ;
  injicerande_nn_1_N : N ;
  inkallande_nn_1_N : N ;
  inkapslande_nn_1_N : N ;
  inkarnerande_nn_1_N : N ;
  inkasserande_nn_1_N : N ;
  inklarerande_nn_1_N : N ;
  inkluderande_nn_1_N : N ;
  inkokande_nn_1_N : N ;
  inkommande_nn_1_N : N ;
  inkomsttaxerande_nn_1_N : N ;
  inkopplande_nn_1_N : N ;
  inkorporerande_nn_1_N : N ;
  inkraektande_nn_1_1_N : N ;
  inkraevande_nn_1_1_N : N ;
  inkvarterande_nn_1_N : N ;
  inkoepande_nn_1_1_N : N ;
  inlasande_nn_1_N : N ;
  inledande_nn_1_N : N ;
  inledningsskede_nn_1_N : N ;
  inlemmande_nn_1_N : N ;
  inlindande_nn_1_N : N ;
  inlaeggande_nn_1_1_N : N ;
  inlaemnande_nn_1_1_N : N ;
  inlaerande_nn_1_1_N : N ;
  inlaanande_nn_1_1_N : N ;
  inloepande_nn_1_1_N : N ;
  inloesande_nn_1_1_N : N ;
  inmatande_nn_1_N : N ;
  inmundigande_nn_1_N : N ;
  inmutande_nn_1_N : N ;
  inmaengande_nn_1_1_N : N ;
  inmoenstrande_nn_1_1_N : N ;
  innandoeme_nn_1_1_N : N ;
  innanmaete_nn_1_1_N : N ;
  innebaerande_nn_1_1_N : N ;
  innefattande_nn_1_N : N ;
  innehavande_nn_1_N : N ;
  innehaallande_nn_1_1_N : N ;
  innerverande_nn_1_N : N ;
  inneslutande_nn_1_N : N ;
  innestaengande_nn_1_1_N : N ;
  inokulerande_nn_1_N : N ;
  inoljande_nn_1_N : N ;
  inordnande_nn_1_N : N ;
  inpassande_nn_1_N : N ;
  inplantande_nn_1_N : N ;
  inplanterande_nn_1_N : N ;
  inpressande_nn_1_N : N ;
  inprickande_nn_1_N : N ;
  inpraeglande_nn_1_1_N : N ;
  inpraentande_nn_1_1_N : N ;
  inramande_nn_1_N : N ;
  inrangerande_nn_1_N : N ;
  inrapporterande_nn_1_N : N ;
  inredande_nn_1_N : N ;
  inregistrerande_nn_1_N : N ;
  inriktande_nn_1_N : N ;
  inringande_nn_1_N : N ;
  inristande_nn_1_N : N ;
  inropande_nn_1_N : N ;
  inrymmande_nn_1_N : N ;
  inraeknande_nn_1_1_N : N ;
  inraettande_nn_1_1_N : N ;
  insamlande_nn_1_N : N ;
  inscenerande_nn_1_N : N ;
  inseglande_nn_1_N : N ;
  inseminerande_nn_1_N : N ;
  insinuerande_nn_1_N : N ;
  insisterande_nn_1_N : N ;
  insjuknande_nn_1_N : N ;
  inskeppande_nn_1_N : N ;
  inskjutande_nn_1_N : N ;
  inskolande_nn_1_N : N ;
  inskridande_nn_1_N : N ;
  inskrivande_nn_1_N : N ;
  inskraenkande_nn_1_1_N : N ;
  inskaerpande_nn_1_1_N : N ;
  insmygande_nn_1_N : N ;
  insmaeltande_nn_1_1_N : N ;
  insomnande_nn_1_N : N ;
  inspekterande_nn_1_N : N ;
  inspelande_nn_1_N : N ;
  inspirerande_nn_1_N : N ;
  insprutningsmunstycke_nn_1_N : N ;
  inspaerrande_nn_1_1_N : N ;
  installerande_nn_1_N : N ;
  instiftande_nn_1_N : N ;
  institutionaliserande_nn_1_N : N ;
  instruerande_nn_1_N : N ;
  instrumentbraede_nn_1_1_N : N ;
  instrumenterande_nn_1_N : N ;
  instraalande_nn_1_1_N : N ;
  instuderande_nn_1_N : N ;
  instundande_nn_1_N : N ;
  instaellande_nn_1_1_N : N ;
  instaemmande_nn_1_1_N : N ;
  instaengande_nn_1_1_N : N ;
  insugande_nn_1_N : N ;
  insupande_nn_1_N : N ;
  insvepande_nn_1_N : N ;
  insaendande_nn_1_1_N : N ;
  insaettande_nn_1_1_N : N ;
  insoendrande_nn_1_1_N : N ;
  intagande_nn_1_N : N ;
  intalande_nn_1_N : N ;
  intecknande_nn_1_N : N ;
  integrerande_nn_1_N : N ;
  intellektualiserande_nn_1_N : N ;
  intensifierande_nn_1_N : N ;
  intensiverande_nn_1_N : N ;
  interagerande_nn_1_N : N ;
  interfererande_nn_1_N : N ;
  interfolierande_nn_1_N : N ;
  internaliserande_nn_1_N : N ;
  internationaliserande_nn_1_N : N ;
  internerande_nn_1_N : N ;
  interpellerande_nn_1_N : N ;
  interpolerande_nn_1_N : N ;
  interpreterande_nn_1_N : N ;
  interpunkterande_nn_1_N : N ;
  intervenerande_nn_1_N : N ;
  intervjuande_nn_1_N : N ;
  intolkande_nn_1_N : N ;
  intonerande_nn_1_N : N ;
  intresse_nn_1_N : N ;
  intresseomraade_nn_1_1_N : N ;
  intresserande_nn_1_N : N ;
  intrigerande_nn_1_N : N ;
  introducerande_nn_1_N : N ;
  introduktionserbjudande_nn_1_N : N ;
  intrumfande_nn_1_N : N ;
  intraedande_nn_1_1_N : N ;
  intraede_nn_1_1_N : N ;
  intraeffande_nn_1_1_N : N ;
  intraengande_nn_1_1_N : N ;
  intygande_nn_1_N : N ;
  intaagande_nn_1_1_N : N ;
  invaderande_nn_1_N : N ;
  invaggande_nn_1_N : N ;
  invalidiserande_nn_1_N : N ;
  invandrande_nn_1_N : N ;
  invecklande_nn_1_N : N ;
  inventerande_nn_1_N : N ;
  inverkande_nn_1_N : N ;
  inverterande_nn_1_N : N ;
  investerande_nn_1_N : N ;
  invigande_nn_1_N : N ;
  invintrande_nn_1_N : N ;
  inviterande_nn_1_N : N ;
  involverande_nn_1_N : N ;
  invaeljande_nn_1_1_N : N ;
  invaendande_nn_1_1_N : N ;
  invaentande_nn_1_1_N : N ;
  invaevande_nn_1_1_N : N ;
  inympande_nn_1_N : N ;
  inoevande_nn_1_1_N : N ;
  iordningstaellande_nn_1_1_N : N ;
  iriserande_nn_1_N : N ;
  ironiserande_nn_1_N : N ;
  irrande_nn_1_N : N ;
  irriterande_nn_1_N : N ;
  isande_nn_1_N : N ;
  isbaelte_nn_1_1_N : N ;
  iscensaettande_nn_1_1_N : N ;
  isfoerhaallande_nn_1_1_N : N ;
  islamiserande_nn_1_N : N ;
  isolerande_nn_1_N : N ;
  istaecke_nn_1_1_N : N ;
  istaandsaettande_nn_1_1_N : N ;
  itererande_nn_1_N : N ;
  itutande_nn_1_N : N ;
  ivrande_nn_1_N : N ;
  ivaegskickande_nn_1_1_N : N ;
  jabbande_nn_1_N : N ;
  jagande_nn_1_N : N ;
  jakande_nn_1_N : N ;
  jaktbyte_nn_1_N : N ;
  jakttillfaelle_nn_1_1_N : N ;
  jamande_nn_1_N : N ;
  jammande_nn_1_N : N ;
  jamsande_nn_1_N : N ;
  janusanlete_nn_1_N : N ;
  janusansikte_nn_1_N : N ;
  jassande_nn_1_N : N ;
  jazzande_nn_1_N : N ;
  jazzifierande_nn_1_N : N ;
  jobbande_nn_1_N : N ;
  joddlande_nn_1_N : N ;
  joderande_nn_1_N : N ;
  joggande_nn_1_N : N ;
  jojkande_nn_1_N : N ;
  jollrande_nn_1_N : N ;
  joltande_nn_1_N : N ;
  jonglerande_nn_1_N : N ;
  joniserande_nn_1_N : N ;
  jordande_nn_2_N : N ;
  jordbrukarsamhaelle_nn_1_1_N : N ;
  jordfaergaemne_nn_1_1_N : N ;
  jordfaestande_nn_1_1_N : N ;
  jordomraade_nn_1_1_N : N ;
  jordslaaende_nn_1_1_N : N ;
  jordvaerde_nn_1_1_N : N ;
  joxande_nn_1_N : N ;
  jubilerande_nn_1_N : N ;
  jublande_nn_1_N : N ;
  juckande_nn_1_N : N ;
  julande_nn_1_N : N ;
  jumpande_nn_1_N : N ;
  justerande_nn_1_N : N ;
  jympande_nn_1_N : N ;
  jaektande_nn_1_1_N : N ;
  jaemfoerande_nn_1_1_N : N ;
  jaemkande_nn_1_1_N : N ;
  jaemnande_nn_1_1_N : N ;
  jaemnviktslaege_nn_1_1_N : N ;
  jaemstaellande_nn_1_1_N : N ;
  jaemviktslaege_nn_1_1_N : N ;
  jaernraecke_nn_1_1_N : N ;
  jaernskoende_nn_1_1_N : N ;
  jaernstycke_nn_1_1_N : N ;
  jaernvaegsbygge_nn_1_1_N : N ;
  jaesande_nn_1_1_N : N ;
  jaevande_nn_1_1_N : N ;
  joensande_nn_1_1_N : N ;
  k_maerkande_nn_1_1_N : N ;
  kabelfaeste_nn_1_1_N : N ;
  kabelhoelje_nn_1_1_N : N ;
  kablande_nn_1_N : N ;
  kackande_nn_1_N : N ;
  kacklande_nn_1_N : N ;
  kaffe_nn_1_N : N ;
  kaffedrickande_nn_1_N : N ;
  kafferastaemne_nn_1_1_N : N ;
  kajkande_nn_1_N : N ;
  kakdoppande_nn_1_N : N ;
  kaklande_nn_1_N : N ;
  kalandrerande_nn_1_N : N ;
  kalasande_nn_1_N : N ;
  kalavverkande_nn_1_N : N ;
  kalcinerande_nn_1_N : N ;
  kalfatrande_nn_1_N : N ;
  kalhuggande_nn_1_N : N ;
  kalhygge_nn_1_N : N ;
  kalibrerande_nn_1_N : N ;
  kalkande_nn_1_N : N ;
  kalkerande_nn_1_N : N ;
  kalkslaaende_nn_1_1_N : N ;
  kalkylerande_nn_1_N : N ;
  kallande_nn_1_N : N ;
  kallarbetande_nn_1_N : N ;
  kallbearbetande_nn_1_N : N ;
  kallbockande_nn_1_N : N ;
  kalldragande_nn_1_N : N ;
  kallgrinande_nn_1_N : N ;
  kallhamrande_nn_1_N : N ;
  kallmanglande_nn_1_N : N ;
  kallnande_nn_1_N : N ;
  kallpratande_nn_1_N : N ;
  kallpressande_nn_1_N : N ;
  kallroekande_nn_1_1_N : N ;
  kallroerande_nn_1_1_N : N ;
  kallsinne_nn_1_N : N ;
  kallsmidande_nn_1_N : N ;
  kalluftslaege_nn_1_1_N : N ;
  kallvalsande_nn_1_N : N ;
  kalmerande_nn_1_N : N ;
  kalnande_nn_1_N : N ;
  kalorivaerde_nn_1_1_N : N ;
  kalvande_nn_1_N : N ;
  kalaetande_nn_1_1_N : N ;
  kammande_nn_1_N : N ;
  kamouflerande_nn_1_N : N ;
  kampande_nn_1_N : N ;
  kamperande_nn_1_N : N ;
  kanalbygge_nn_1_N : N ;
  kanaliserande_nn_1_N : N ;
  kanande_nn_1_N : N ;
  kanderande_nn_1_N : N ;
  kandiderande_nn_1_N : N ;
  kannelerande_nn_1_N : N ;
  kanonerbjudande_nn_1_N : N ;
  kanoniserande_nn_1_N : N ;
  kanotande_nn_1_N : N ;
  kantande_nn_1_N : N ;
  kanthuggande_nn_1_N : N ;
  kantklippande_nn_1_N : N ;
  kantrande_nn_1_N : N ;
  kapacitetsutnyttjande_nn_1_N : N ;
  kapande_nn_1_N : N ;
  kapitaliserande_nn_1_N : N ;
  kapitalvaerde_nn_1_1_N : N ;
  kapitulerande_nn_1_N : N ;
  kapprustande_nn_1_N : N ;
  kappseglande_nn_1_N : N ;
  kapsejsande_nn_1_N : N ;
  kapslande_nn_1_N : N ;
  karakteriserande_nn_1_N : N ;
  karaktaeriserande_nn_1_1_N : N ;
  karaktaersvittne_nn_1_1_N : N ;
  karambolerande_nn_1_N : N ;
  karande_nn_1_N : N ;
  karboniserande_nn_1_N : N ;
  kardande_nn_1_N : N ;
  kardborrfaeste_nn_1_1_N : N ;
  karikerande_nn_1_N : N ;
  karlansikte_nn_1_N : N ;
  karldagsverke_nn_1_N : N ;
  karterande_nn_1_N : N ;
  kartlaeggande_nn_1_1_N : N ;
  kartonnerande_nn_1_N : N ;
  karvande_nn_1_N : N ;
  kasande_nn_1_N : N ;
  kaskadkopplande_nn_1_N : N ;
  kasserande_nn_1_N : N ;
  kastande_nn_1_N : N ;
  kastmaerke_nn_1_1_N : N ;
  kastrerande_nn_1_N : N ;
  katalogiserande_nn_1_N : N ;
  katalyserande_nn_1_N : N ;
  katastroflaege_nn_1_1_N : N ;
  katedralbygge_nn_1_N : N ;
  kategoriserande_nn_1_N : N ;
  kategoriseringsarbete_nn_1_N : N ;
  katekesstycke_nn_1_N : N ;
  kateteriserande_nn_1_N : N ;
  katetriserande_nn_1_N : N ;
  kattande_nn_1_N : N ;
  kausalfoerhaallande_nn_1_1_N : N ;
  kauteriserande_nn_1_N : N ;
  kavande_nn_1_N : N ;
  kavlande_nn_1_N : N ;
  kedjande_nn_1_N : N ;
  kedjeroekande_nn_1_1_N : N ;
  kejsardoeme_nn_1_1_N : N ;
  kelande_nn_1_N : N ;
  kemisamhaelle_nn_1_1_N : N ;
  kesande_nn_1_N : N ;
  kickande_nn_1_N : N ;
  kidnappande_nn_1_N : N ;
  kikande_nn_1_N : N ;
  kikarsikte_nn_1_N : N ;
  kiknande_nn_1_N : N ;
  kilande_nn_1_N : N ;
  killande_nn_1_N : N ;
  kimmande_nn_1_N : N ;
  kinesande_nn_1_N : N ;
  kinkande_nn_1_N : N ;
  kippande_nn_1_N : N ;
  kirrande_nn_1_N : N ;
  kisande_nn_1_N : N ;
  kissande_nn_1_N : N ;
  kittande_nn_1_N : N ;
  kittlande_nn_1_N : N ;
  klabbande_nn_1_N : N ;
  klackande_nn_1_N : N ;
  kladdande_nn_1_N : N ;
  klaffande_nn_1_N : N ;
  klafsande_nn_1_N : N ;
  klampande_nn_1_N : N ;
  klamrande_nn_1_N : N ;
  klandrande_nn_1_N : N ;
  klankande_nn_1_N : N ;
  klappande_nn_1_N : N ;
  klappbraede_nn_1_1_N : N ;
  klapprande_nn_1_N : N ;
  klarande_nn_1_N : N ;
  klarerande_nn_1_N : N ;
  klargoerande_nn_1_1_N : N ;
  klarlaeggande_nn_1_1_N : N ;
  klarnande_nn_1_N : N ;
  klassamhaelle_nn_1_1_N : N ;
  klassande_nn_1_N : N ;
  klassificerande_nn_1_N : N ;
  klassmaerke_nn_1_1_N : N ;
  klatschande_nn_1_N : N ;
  klavbindande_nn_1_N : N ;
  klemande_nn_1_N : N ;
  klenande_nn_1_N : N ;
  klensmide_nn_1_N : N ;
  kletande_nn_1_N : N ;
  kliande_nn_1_N : N ;
  klibbande_nn_1_N : N ;
  klickande_nn_1_N : N ;
  klimatombyte_nn_1_N : N ;
  klimattoppmoete_nn_1_1_N : N ;
  klimpande_nn_1_N : N ;
  klingande_nn_1_N : N ;
  klinkande_nn_1_N : N ;
  klippande_nn_1_N : N ;
  klippstycke_nn_1_N : N ;
  klirande_nn_1_N : N ;
  klirrande_nn_1_N : N ;
  klistermaerke_nn_1_1_N : N ;
  klistrande_nn_1_N : N ;
  klivande_nn_1_N : N ;
  klockande_nn_1_N : N ;
  klonande_nn_1_N : N ;
  klorerande_nn_1_N : N ;
  klorkolvaete_nn_1_1_N : N ;
  klosterloefte_nn_1_1_N : N ;
  klottrande_nn_1_N : N ;
  klubbande_nn_1_N : N ;
  klubbmaerke_nn_1_1_N : N ;
  kluckande_nn_1_N : N ;
  kluddande_nn_1_N : N ;
  klunkande_nn_1_N : N ;
  klyftande_nn_1_N : N ;
  klyvande_nn_1_N : N ;
  klaeckande_nn_1_1_N : N ;
  klaedande_nn_1_1_N : N ;
  klaedbyte_nn_1_1_N : N ;
  klaede_nn_1_1_N : N ;
  klaedspaenne_nn_1_1_N : N ;
  klaeende_nn_1_1_N : N ;
  klaemmande_nn_1_1_N : N ;
  klaemtande_nn_1_1_N : N ;
  klaengande_nn_1_1_N : N ;
  klaenge_nn_1_1_N : N ;
  klaettrande_nn_1_1_N : N ;
  klaaende_nn_1_1_N : N ;
  klaapande_nn_1_1_N : N ;
  kloesande_nn_1_1_N : N ;
  kloevjande_nn_1_1_N : N ;
  knackande_nn_1_N : N ;
  knagglande_nn_1_N : N ;
  knallande_nn_1_N : N ;
  knapptryckande_nn_1_N : N ;
  knaprande_nn_1_N : N ;
  knarkande_nn_1_N : N ;
  knarrande_nn_1_N : N ;
  knastrande_nn_1_N : N ;
  knatande_nn_1_N : N ;
  knattrande_nn_1_N : N ;
  knegande_nn_1_N : N ;
  knipande_nn_1_N : N ;
  knippe_nn_1_N : N ;
  knipsande_nn_1_N : N ;
  knirkande_nn_1_N : N ;
  knirrande_nn_1_N : N ;
  knistrande_nn_1_N : N ;
  knittrande_nn_1_N : N ;
  knivande_nn_1_N : N ;
  knivmoerdande_nn_1_1_N : N ;
  knixande_nn_1_N : N ;
  knockande_nn_1_N : N ;
  knogande_nn_1_N : N ;
  knollrande_nn_1_N : N ;
  knopande_nn_1_N : N ;
  knorrande_nn_1_N : N ;
  knorvande_nn_1_N : N ;
  knotande_nn_1_N : N ;
  knottrande_nn_1_N : N ;
  knuffande_nn_1_N : N ;
  knullande_nn_1_N : N ;
  knusslande_nn_1_N : N ;
  knuttimrande_nn_1_N : N ;
  knyckande_nn_1_N : N ;
  knycklande_nn_1_N : N ;
  knypplande_nn_1_N : N ;
  knystande_nn_1_N : N ;
  knytande_nn_1_N : N ;
  knyte_nn_1_N : N ;
  knaeande_nn_1_1_N : N ;
  knaeboejande_nn_1_1_N : N ;
  knaeckande_nn_1_1_N : N ;
  knaefallande_nn_1_1_N : N ;
  knaeppande_nn_1_1_N : N ;
  knaeppe_nn_1_1_N : N ;
  knaesaettande_nn_1_1_N : N ;
  knaadande_nn_1_1_N : N ;
  knaapande_nn_1_1_N : N ;
  knoekande_nn_1_1_N : N ;
  knoelande_nn_1_1_N : N ;
  koafferande_nn_1_N : N ;
  koagulerande_nn_1_N : N ;
  kodande_nn_1_N : N ;
  kodifierande_nn_1_N : N ;
  kohandlande_nn_1_N : N ;
  kojande_nn_1_N : N ;
  kojsande_nn_1_N : N ;
  kokande_nn_1_N : N ;
  koketterande_nn_1_N : N ;
  kokkaffe_nn_1_N : N ;
  koksande_nn_1_N : N ;
  kolande_nn_1_N : N ;
  kolkande_nn_1_N : N ;
  kollaberande_nn_1_N : N ;
  kollaborerande_nn_1_N : N ;
  kollande_nn_1_N : N ;
  kollapsande_nn_1_N : N ;
  kollationerande_nn_1_N : N ;
  kollektiviserande_nn_1_N : N ;
  kolliderande_nn_1_N : N ;
  kolonialvaelde_nn_1_1_N : N ;
  koloniserande_nn_1_N : N ;
  kolorerande_nn_1_N : N ;
  kolportagehaefte_nn_1_1_N : N ;
  kolporterande_nn_1_N : N ;
  kolumnutrymme_nn_1_N : N ;
  kolvaete_nn_1_1_N : N ;
  kombinerande_nn_1_N : N ;
  kommande_nn_1_N : N ;
  kommaterande_nn_1_N : N ;
  kommenderande_nn_1_N : N ;
  kommenterande_nn_1_N : N ;
  kommersande_nn_1_N : N ;
  kommersialiserande_nn_1_N : N ;
  kommunaliserande_nn_1_N : N ;
  kommunfullmaektige_nn_1_1_N : N ;
  kommunicerande_nn_1_N : N ;
  kommuterande_nn_1_N : N ;
  kompande_nn_1_N : N ;
  komparerande_nn_1_N : N ;
  kompenserande_nn_1_N : N ;
  kompetensfoerklarande_nn_1_1_N : N ;
  kompetensomraade_nn_1_1_N : N ;
  kompilerande_nn_1_N : N ;
  kompletterande_nn_1_N : N ;
  komplicerande_nn_1_N : N ;
  komplimenterande_nn_1_N : N ;
  komponerande_nn_1_N : N ;
  komposterande_nn_1_N : N ;
  komprimerande_nn_1_N : N ;
  komprometterande_nn_1_N : N ;
  kompromissande_nn_1_N : N ;
  koncentrerande_nn_1_N : N ;
  koncessionerande_nn_1_N : N ;
  koncipierande_nn_1_N : N ;
  kondemnerande_nn_1_N : N ;
  kondenserande_nn_1_N : N ;
  konditionerande_nn_1_N : N ;
  kondolerande_nn_1_N : N ;
  konfererande_nn_1_N : N ;
  konfirmerande_nn_1_N : N ;
  konfiskerande_nn_1_N : N ;
  konfronterande_nn_1_N : N ;
  konfunderande_nn_1_N : N ;
  kongressande_nn_1_N : N ;
  kongruerande_nn_1_N : N ;
  konjugerande_nn_1_N : N ;
  konkande_nn_1_N : N ;
  konkluderande_nn_1_N : N ;
  konkretiserande_nn_1_N : N ;
  konkurrenssamhaelle_nn_1_1_N : N ;
  konkurrerande_nn_1_N : N ;
  konserterande_nn_1_N : N ;
  konsertstycke_nn_1_N : N ;
  konserverande_nn_1_N : N ;
  konsignerande_nn_1_N : N ;
  konsoliderande_nn_1_N : N ;
  konspirerande_nn_1_N : N ;
  konstaterande_nn_1_N : N ;
  konstbefruktande_nn_1_N : N ;
  konstbevattnande_nn_1_N : N ;
  konsternerande_nn_1_N : N ;
  konstituerande_nn_1_N : N ;
  konstrande_nn_1_N : N ;
  konstruerande_nn_1_N : N ;
  konststoppande_nn_1_N : N ;
  konststycke_nn_1_N : N ;
  konsulterande_nn_1_N : N ;
  konsumerande_nn_1_N : N ;
  konsumtionssamhaelle_nn_1_1_N : N ;
  kontaktande_nn_1_N : N ;
  kontaminerande_nn_1_N : N ;
  konterande_nn_1_N : N ;
  kontingenterande_nn_1_N : N ;
  kontoriserande_nn_1_N : N ;
  kontorsarbete_nn_1_N : N ;
  kontorsbitraede_nn_1_1_N : N ;
  kontorsutrymme_nn_1_N : N ;
  kontraherande_nn_1_N : N ;
  kontrakterande_nn_1_N : N ;
  kontramanderande_nn_1_N : N ;
  kontramaerke_nn_1_1_N : N ;
  kontrande_nn_1_N : N ;
  kontrasignerande_nn_1_N : N ;
  kontrasterande_nn_1_N : N ;
  kontribuerande_nn_1_N : N ;
  kontrollerande_nn_1_N : N ;
  kontrollmaerke_nn_1_1_N : N ;
  kontrollsamhaelle_nn_1_1_N : N ;
  kontrollstaemplande_nn_1_1_N : N ;
  kontrollvaegande_nn_1_1_N : N ;
  konturerande_nn_1_N : N ;
  konungadoeme_nn_1_1_N : N ;
  konungarike_nn_1_N : N ;
  konungasaete_nn_1_1_N : N ;
  konvergerande_nn_1_N : N ;
  konversationsstycke_nn_1_N : N ;
  konverserande_nn_1_N : N ;
  konverterande_nn_1_N : N ;
  konvojerande_nn_1_N : N ;
  koopererande_nn_1_N : N ;
  koordinerande_nn_1_N : N ;
  kopierande_nn_1_N : N ;
  koppande_nn_1_N : N ;
  kopplande_nn_1_N : N ;
  kopplingsstycke_nn_1_N : N ;
  kopulerande_nn_1_N : N ;
  korande_nn_1_N : N ;
  korkande_nn_1_N : N ;
  korpande_nn_2_N : N ;
  korrekturlaesande_nn_1_1_N : N ;
  korrelerande_nn_1_N : N ;
  korresponderande_nn_1_N : N ;
  korrigerande_nn_1_N : N ;
  korroderande_nn_1_N : N ;
  korrugerande_nn_1_N : N ;
  korrumperande_nn_1_N : N ;
  korsande_nn_1_N : N ;
  korsbefruktande_nn_1_N : N ;
  korsetterande_nn_1_N : N ;
  korsfaestande_nn_1_1_N : N ;
  korsfoerhoerande_nn_1_1_N : N ;
  kortande_nn_1_N : N ;
  kortpassande_nn_1_N : N ;
  kortslutande_nn_1_N : N ;
  kostande_nn_1_N : N ;
  kostymerande_nn_1_N : N ;
  kovaendande_nn_1_1_N : N ;
  koxande_nn_1_N : N ;
  krackande_nn_1_N : N ;
  krackelerande_nn_1_N : N ;
  krafsande_nn_1_N : N ;
  kraftverksbygge_nn_1_N : N ;
  kramande_nn_1_N : N ;
  kransande_nn_1_N : N ;
  krasande_nn_1_N : N ;
  kraschande_nn_1_N : N ;
  kraschlandande_nn_1_N : N ;
  kratsande_nn_1_N : N ;
  krattande_nn_1_N : N ;
  kravlande_nn_1_N : N ;
  kraxande_nn_1_N : N ;
  kredensande_nn_1_N : N ;
  krediterande_nn_1_N : N ;
  kreerande_nn_1_N : N ;
  kremerande_nn_1_N : N ;
  kreperande_nn_1_N : N ;
  kretande_nn_1_N : N ;
  kretsande_nn_1_N : N ;
  kretsloppssamhaelle_nn_1_1_N : N ;
  kreverande_nn_1_N : N ;
  krigande_nn_1_N : N ;
  krigsbyte_nn_1_N : N ;
  krigsplacerande_nn_1_N : N ;
  kriminaliserande_nn_1_N : N ;
  kringgaerdande_nn_1_1_N : N ;
  kringgaaende_nn_1_1_N : N ;
  kringraennande_nn_1_1_N : N ;
  kringskansande_nn_1_N : N ;
  kringskaerande_nn_1_1_N : N ;
  krisande_nn_1_N : N ;
  krismoete_nn_1_1_N : N ;
  kristalliserande_nn_1_N : N ;
  kristnande_nn_1_N : N ;
  kritande_nn_1_N : N ;
  kritiserande_nn_1_N : N ;
  krockande_nn_1_N : N ;
  krokande_nn_1_N : N ;
  kromande_nn_1_N : N ;
  kromgarvande_nn_1_N : N ;
  krondike_nn_1_N : N ;
  kronvittne_nn_1_N : N ;
  kroppsarbetande_nn_1_N : N ;
  kroppsarbete_nn_1_N : N ;
  kroppsvisiterande_nn_1_N : N ;
  krossande_nn_1_N : N ;
  krubbande_nn_1_N : N ;
  krullande_nn_1_N : N ;
  krumbuktande_nn_1_N : N ;
  krusande_nn_1_N : N ;
  kryllande_nn_1_N : N ;
  krympande_nn_1_N : N ;
  krypande_nn_1_N : N ;
  krypkoerande_nn_1_1_N : N ;
  krypterande_nn_1_N : N ;
  kryssande_nn_1_N : N ;
  krystande_nn_1_N : N ;
  kraelande_nn_1_1_N : N ;
  kraemtande_nn_1_1_N : N ;
  kraengande_nn_1_1_N : N ;
  kraenkande_nn_1_1_N : N ;
  kraeppande_nn_1_1_N : N ;
  kraevande_nn_1_1_N : N ;
  kraamande_nn_1_1_N : N ;
  kraanglande_nn_1_1_N : N ;
  kroekande_nn_1_1_N : N ;
  kroenande_nn_1_1_N : N ;
  kuberande_nn_1_N : N ;
  kuckilurande_nn_1_N : N ;
  kucklande_nn_1_N : N ;
  kuggande_nn_1_N : N ;
  kujonerande_nn_1_N : N ;
  kullande_nn_1_N : N ;
  kullbytterande_nn_1_N : N ;
  kullkastande_nn_1_N : N ;
  kullpratande_nn_1_N : N ;
  kullrande_nn_1_N : N ;
  kulminerande_nn_1_N : N ;
  kulnande_nn_1_N : N ;
  kulsprutenaeste_nn_1_1_N : N ;
  kultiverande_nn_1_N : N ;
  kulturminne_nn_1_N : N ;
  kulturminnesmaerkande_nn_1_1_N : N ;
  kulturminnesmaerke_nn_1_1_N : N ;
  kulturutbyte_nn_1_N : N ;
  kumulerande_nn_1_N : N ;
  kungadoeme_nn_1_1_N : N ;
  kungafoerhaerligande_nn_1_1_N : N ;
  kungarike_nn_1_N : N ;
  kungasaete_nn_1_1_N : N ;
  kungoerande_nn_1_1_N : N ;
  kunskapande_nn_1_N : N ;
  kunskapslaege_nn_1_1_N : N ;
  kunskapssoekande_nn_1_1_N : N ;
  kupande_nn_1_N : N ;
  kuperande_nn_1_N : N ;
  kuppande_nn_1_N : N ;
  kurande_nn_1_N : N ;
  kuraterande_nn_1_N : N ;
  kurerande_nn_1_N : N ;
  kurrande_nn_1_N : N ;
  kursande_nn_1_N : N ;
  kurserande_nn_1_N : N ;
  kursiverande_nn_1_N : N ;
  kurtiserande_nn_1_N : N ;
  kuschande_nn_1_N : N ;
  kusingifte_nn_1_N : N ;
  kuskande_nn_1_N : N ;
  kustomraade_nn_1_1_N : N ;
  kutande_nn_1_N : N ;
  kuttersmycke_nn_1_N : N ;
  kuttrande_nn_1_N : N ;
  kuvande_nn_1_N : N ;
  kuverterande_nn_1_N : N ;
  kvackande_nn_1_N : N ;
  kvaddande_nn_1_N : N ;
  kvadrerande_nn_1_N : N ;
  kvalande_nn_1_N : N ;
  kvalificerande_nn_1_N : N ;
  kvalitetsarbete_nn_1_N : N ;
  kvalitetsgranskande_nn_1_N : N ;
  kvalitetssaekrande_nn_1_1_N : N ;
  kvantifierande_nn_1_N : N ;
  kvarblivande_nn_1_N : N ;
  kvardroejande_nn_1_1_N : N ;
  kvarhaallande_nn_1_1_N : N ;
  kvarlaemnande_nn_1_1_N : N ;
  kvarstannande_nn_1_N : N ;
  kvarstaaende_nn_1_1_N : N ;
  kvartande_nn_1_N : N ;
  kverulerande_nn_1_N : N ;
  kvickande_nn_1_N : N ;
  kvicksilverbetande_nn_1_N : N ;
  kvidande_nn_1_N : N ;
  kvillrande_nn_1_N : N ;
  kviltande_nn_1_N : N ;
  kvinnoarbete_nn_1_N : N ;
  kvinnosmycke_nn_1_N : N ;
  kvinnooede_nn_1_1_N : N ;
  kvintilerande_nn_1_N : N ;
  kvirrande_nn_1_N : N ;
  kvistande_nn_1_N : N ;
  kvittande_nn_1_N : N ;
  kvitterande_nn_1_N : N ;
  kvittrande_nn_1_N : N ;
  kvoterande_nn_1_N : N ;
  kvaedande_nn_1_1_N : N ;
  kvaede_nn_1_1_N : N ;
  kvaekande_nn_1_1_N : N ;
  kvaeljande_nn_1_1_N : N ;
  kvaellande_nn_1_1_N : N ;
  kvaesande_nn_1_1_N : N ;
  kvaevande_nn_1_1_N : N ;
  kyffande_nn_1_N : N ;
  kyffe_nn_1_N : N ;
  kylande_nn_1_N : N ;
  kyllagrande_nn_1_N : N ;
  kylnande_nn_1_N : N ;
  kynne_nn_1_N : N ;
  kyprande_nn_1_N : N ;
  kyrkbokfoerande_nn_1_1_N : N ;
  kyrkbygge_nn_1_N : N ;
  kyrkobokfoerande_nn_1_1_N : N ;
  kyrkomoete_nn_1_1_N : N ;
  kyrkskrivande_nn_1_N : N ;
  kyskhetsbaelte_nn_1_1_N : N ;
  kyskhetsloefte_nn_1_1_N : N ;
  kyssande_nn_1_N : N ;
  kaebblande_nn_1_1_N : N ;
  kaeftande_nn_1_1_N : N ;
  kaekande_nn_1_1_N : N ;
  kaelande_nn_1_1_N : N ;
  kaellfloede_nn_1_1_N : N ;
  kaellsorterande_nn_1_1_N : N ;
  kaeltande_nn_1_1_N : N ;
  kaempande_nn_1_1_N : N ;
  kaennande_nn_1_1_N : N ;
  kaennemaerke_nn_1_1_N : N ;
  kaennetecknande_nn_1_1_N : N ;
  kaenslolaege_nn_1_1_N : N ;
  kaerande_nn_2_1_N : N ;
  kaerleksfoerhaallande_nn_1_1_N : N ;
  kaerleksmoete_nn_1_1_N : N ;
  kaerleksrykte_nn_1_1_N : N ;
  kaernande_nn_1_1_N : N ;
  kaernbraensle_nn_1_1_N : N ;
  kaernminne_nn_1_1_N : N ;
  kaernreaktorbygge_nn_1_1_N : N ;
  kaernrike_nn_1_1_N : N ;
  kaervande_nn_1_1_N : N ;
  kaexande_nn_1_1_N : N ;
  kaankande_nn_1_1_N : N ;
  kaarande_nn_1_1_N : N ;
  kaaserande_nn_1_1_N : N ;
  koeande_nn_1_1_N : N ;
  koelhalande_nn_1_1_N : N ;
  koenande_nn_1_1_N : N ;
  koensbyte_nn_1_1_N : N ;
  koensdiskriminerande_nn_1_1_N : N ;
  koenskvoterande_nn_1_1_N : N ;
  koensumgaenge_nn_1_1_N : N ;
  koepande_nn_1_1_N : N ;
  koepbeteende_nn_1_1_N : N ;
  koerande_nn_1_1_N : N ;
  koernande_nn_1_1_N : N ;
  koettstycke_nn_1_1_N : N ;
  koevande_nn_1_1_N : N ;
  labialiserande_nn_1_N : N ;
  laborerande_nn_1_N : N ;
  lackande_nn_1_N : N ;
  lackerande_nn_1_N : N ;
  laddande_nn_1_N : N ;
  lafsande_nn_1_N : N ;
  lagande_nn_1_N : N ;
  lagarbete_nn_1_N : N ;
  lagerfoerande_nn_1_1_N : N ;
  lagerkransande_nn_1_N : N ;
  lagerkroenande_nn_1_1_N : N ;
  lagfarande_nn_1_N : N ;
  lagfaestande_nn_1_1_N : N ;
  lagfoerande_nn_1_1_N : N ;
  laggande_nn_1_N : N ;
  laggdike_nn_1_N : N ;
  lagomraade_nn_1_1_N : N ;
  lagrande_nn_1_N : N ;
  lagstiftande_nn_1_N : N ;
  lagsoekande_nn_1_1_N : N ;
  lallande_nn_1_N : N ;
  lamenterande_nn_1_N : N ;
  laminerande_nn_1_N : N ;
  lammande_nn_1_N : N ;
  lamslaaende_nn_1_1_N : N ;
  landamaere_nn_1_1_N : N ;
  landande_nn_1_N : N ;
  landfaeste_nn_1_1_N : N ;
  landmaerke_nn_1_1_N : N ;
  landningsmaerke_nn_1_1_N : N ;
  landomraade_nn_1_1_N : N ;
  landsfoervisande_nn_1_1_N : N ;
  landshoevdingeaembete_nn_1_1_N : N ;
  landstigande_nn_1_N : N ;
  landstaelle_nn_1_1_N : N ;
  landsaettande_nn_1_1_N : N ;
  langande_nn_1_N : N ;
  langetterande_nn_1_N : N ;
  lanserande_nn_1_N : N ;
  lantbrukskunnande_nn_1_N : N ;
  lantstaelle_nn_1_1_N : N ;
  lapande_nn_1_N : N ;
  lapiserande_nn_1_N : N ;
  lappande_nn_1_N : N ;
  lapptaecke_nn_1_1_N : N ;
  larmande_nn_1_N : N ;
  larvande_nn_1_N : N ;
  laserande_nn_1_N : N ;
  lasersikte_nn_1_N : N ;
  laskande_nn_1_N : N ;
  lassande_nn_1_N : N ;
  lastande_nn_1_N : N ;
  lastutrymme_nn_1_N : N ;
  latiniserande_nn_1_N : N ;
  latinvaelde_nn_1_1_N : N ;
  lattjande_nn_1_N : N ;
  lavafloede_nn_1_1_N : N ;
  laverande_nn_1_N : N ;
  laxande_nn_1_N : N ;
  laxerande_nn_1_N : N ;
  leasande_nn_1_N : N ;
  ledande_nn_1_N : N ;
  ledarskifte_nn_1_N : N ;
  ledigfoerklarande_nn_1_1_N : N ;
  ledsagande_nn_1_N : N ;
  ledsnande_nn_1_N : N ;
  ledutrymme_nn_1_N : N ;
  leende_nn_1_N : N ;
  legaliserande_nn_1_N : N ;
  legerande_nn_1_N : N ;
  legitimerande_nn_1_N : N ;
  lejande_nn_1_N : N ;
  lejdrande_nn_1_N : N ;
  lekande_nn_1_N : N ;
  lemlaestande_nn_1_1_N : N ;
  lenande_nn_1_N : N ;
  lessnande_nn_1_N : N ;
  letande_nn_1_N : N ;
  lettrande_nn_1_N : N ;
  levande_nn_1_N : N ;
  levandegoerande_nn_1_1_N : N ;
  leve_nn_1_N : N ;
  levererande_nn_1_N : N ;
  levnadsfoerhaallande_nn_1_1_N : N ;
  levnadsoede_nn_1_1_N : N ;
  liberaliserande_nn_1_N : N ;
  licensbelaeggande_nn_1_1_N : N ;
  licenserande_nn_1_N : N ;
  licensierande_nn_1_N : N ;
  licentierande_nn_1_N : N ;
  lidande_nn_1_N : N ;
  lierande_nn_1_N : N ;
  liftande_nn_1_N : N ;
  liggande_nn_1_N : N ;
  likande_nn_1_N : N ;
  liknande_nn_1_N : N ;
  likriktande_nn_1_N : N ;
  likstaellande_nn_1_1_N : N ;
  likviderande_nn_1_N : N ;
  limmande_nn_1_N : N ;
  limaemne_nn_1_1_N : N ;
  lindande_nn_1_N : N ;
  lindrande_nn_1_N : N ;
  linjearbete_nn_1_N : N ;
  linjerande_nn_1_N : N ;
  linkande_nn_1_N : N ;
  linne_nn_2_N : N ;
  lipande_nn_1_N : N ;
  lirande_nn_1_N : N ;
  lirkande_nn_1_N : N ;
  lismande_nn_1_N : N ;
  lisserande_nn_1_N : N ;
  listande_nn_1_N : N ;
  litande_nn_1_N : N ;
  litograferande_nn_1_N : N ;
  litsande_nn_1_N : N ;
  livande_nn_1_N : N ;
  livbaelte_nn_1_1_N : N ;
  livfoersaekrande_nn_1_1_N : N ;
  livgarde_nn_1_N : N ;
  livnaerande_nn_1_1_N : N ;
  livregemente_nn_1_N : N ;
  livstycke_nn_1_N : N ;
  ljudande_nn_1_N : N ;
  ljudisolerande_nn_1_N : N ;
  ljudsaettande_nn_1_1_N : N ;
  ljugande_nn_1_N : N ;
  ljummande_nn_1_N : N ;
  ljungande_nn_1_N : N ;
  ljusfloede_nn_1_1_N : N ;
  ljusfoerhaallande_nn_1_1_N : N ;
  ljuskopierande_nn_1_N : N ;
  ljusnande_nn_1_N : N ;
  ljustrande_nn_1_N : N ;
  lobbande_nn_1_N : N ;
  lockande_nn_1_N : N ;
  lockbete_nn_1_N : N ;
  lockoutande_nn_1_N : N ;
  lodande_nn_1_N : N ;
  logerande_nn_1_N : N ;
  loggande_nn_1_N : N ;
  lokalbedoevande_nn_1_1_N : N ;
  lokalintresse_nn_1_N : N ;
  lokaliserande_nn_1_N : N ;
  lokalsamhaelle_nn_1_1_N : N ;
  lokalsinne_nn_1_N : N ;
  lomande_nn_1_N : N ;
  lommande_nn_1_N : N ;
  loppande_nn_1_N : N ;
  loskande_nn_1_N : N ;
  lossande_nn_1_N : N ;
  lossnande_nn_1_N : N ;
  lotsande_nn_1_N : N ;
  lottande_nn_1_N : N ;
  lovande_nn_1_N : N ;
  lovordande_nn_1_N : N ;
  lovprisande_nn_1_N : N ;
  lovsjungande_nn_1_N : N ;
  lubbande_nn_1_N : N ;
  luckrande_nn_1_N : N ;
  luddande_nn_1_N : N ;
  luffande_nn_1_N : N ;
  luffaransikte_nn_1_N : N ;
  lufsande_nn_1_N : N ;
  luftande_nn_2_N : N ;
  luftlandsaettande_nn_1_1_N : N ;
  luftombyte_nn_1_N : N ;
  lufttorkande_nn_1_N : N ;
  luggande_nn_1_N : N ;
  lugnande_nn_1_N : N ;
  luktande_nn_1_N : N ;
  luktsinne_nn_1_N : N ;
  lullande_nn_1_N : N ;
  lumpande_nn_1_N : N ;
  lunchande_nn_1_N : N ;
  lunchstaelle_nn_1_1_N : N ;
  lungbyte_nn_1_N : N ;
  lunkande_nn_1_N : N ;
  lunnande_nn_1_N : N ;
  luntande_nn_1_N : N ;
  lurande_nn_1_N : N ;
  lurpassande_nn_1_N : N ;
  lusande_nn_1_N : N ;
  luskande_nn_1_N : N ;
  luslaesande_nn_1_1_N : N ;
  lussande_nn_1_N : N ;
  lutande_nn_1_N : N ;
  luteiniserande_nn_1_N : N ;
  luttrande_nn_1_N : N ;
  lyckliggoerande_nn_1_1_N : N ;
  lyckorike_nn_1_N : N ;
  lyckoenskande_nn_1_1_N : N ;
  lydande_nn_1_N : N ;
  lydrike_nn_1_N : N ;
  lyftande_nn_1_N : N ;
  lyktande_nn_1_N : N ;
  lynchande_nn_1_N : N ;
  lynne_nn_1_N : N ;
  lyrande_nn_1_N : N ;
  lysande_nn_1_N : N ;
  lyse_nn_1_N : N ;
  lyssnande_nn_1_N : N ;
  lystmaete_nn_1_1_N : N ;
  lystrande_nn_1_N : N ;
  lysaemne_nn_1_1_N : N ;
  lyte_nn_1_N : N ;
  lyxande_nn_1_N : N ;
  lyxrenoverande_nn_1_N : N ;
  laeande_nn_1_1_N : N ;
  laeckande_nn_1_1_N : N ;
  laederande_nn_1_1_N : N ;
  laege_nn_1_1_N : N ;
  laegenhetsbyte_nn_1_1_N : N ;
  laegessinne_nn_1_1_N : N ;
  laeggande_nn_1_1_N : N ;
  laegrande_nn_1_1_N : N ;
  laekande_nn_1_1_N : N ;
  laekarundersoekande_nn_1_1_N : N ;
  laektrande_nn_1_1_N : N ;
  laemnande_nn_1_1_N : N ;
  laempande_nn_1_1_N : N ;
  laendande_nn_1_1_N : N ;
  laendklaede_nn_1_1_N : N ;
  laendstycke_nn_1_1_N : N ;
  laengande_nn_1_1_N : N ;
  laengtande_nn_1_1_N : N ;
  laenkande_nn_1_1_N : N ;
  laensande_nn_1_1_N : N ;
  laeppjande_nn_1_1_N : N ;
  laerande_nn_1_1_N : N ;
  laerostycke_nn_1_1_N : N ;
  laerosaete_nn_1_1_N : N ;
  laeroaemne_nn_1_1_N : N ;
  laesande_nn_1_1_N : N ;
  laeskande_nn_1_1_N : N ;
  laespande_nn_1_1_N : N ;
  laesvaerde_nn_1_1_N : N ;
  laesaemne_nn_1_1_N : N ;
  laete_nn_1_1_N : N ;
  laettande_nn_1_1_N : N ;
  laettnande_nn_1_1_N : N ;
  laettrande_nn_1_1_N : N ;
  laettsinne_nn_1_1_N : N ;
  laadaemne_nn_1_1_N : N ;
  laagande_nn_1_1_N : N ;
  laagflygande_nn_1_1_N : N ;
  laagprioriterande_nn_1_1_N : N ;
  laagpriskaffe_nn_1_1_N : N ;
  laagtrycksomraade_nn_1_1_N : N ;
  laagvattenmaerke_nn_1_1_N : N ;
  laanande_nn_1_1_N : N ;
  laaneloefte_nn_1_1_N : N ;
  laangtidsparkerande_nn_1_1_N : N ;
  laansparande_nn_1_1_N : N ;
  laarstycke_nn_1_1_N : N ;
  laasande_nn_1_1_N : N ;
  laassande_nn_1_1_N : N ;
  laatande_nn_1_1_N : N ;
  laatsande_nn_1_1_N : N ;
  loedande_nn_1_1_N : N ;
  loeddrande_nn_1_1_N : N ;
  loefte_nn_1_1_N : N ;
  loegande_nn_1_1_N : N ;
  loeje_nn_1_1_N : N ;
  loemsknande_nn_1_1_N : N ;
  loenande_nn_1_1_N : N ;
  loenelaege_nn_1_1_N : N ;
  loennmoerdande_nn_1_1_N : N ;
  loenskalaege_nn_1_1_N : N ;
  loensparande_nn_1_1_N : N ;
  loepande_nn_1_1_N : N ;
  loepnande_nn_1_1_N : N ;
  loesande_nn_1_1_N : N ;
  loesgoerande_nn_1_1_N : N ;
  loesoere_nn_1_1_N : N ;
  loevande_nn_1_1_N : N ;
  macklande_nn_1_N : N ;
  madrasserande_nn_1_N : N ;
  magasinerande_nn_1_N : N ;
  magnetiserande_nn_1_N : N ;
  magpumpande_nn_1_N : N ;
  magrande_nn_1_N : N ;
  mailande_nn_1_N : N ;
  majande_nn_1_N : N ;
  majoritetssamhaelle_nn_1_1_N : N ;
  majoritetsaegande_nn_1_1_N : N ;
  makande_nn_1_N : N ;
  maktskifte_nn_1_N : N ;
  maktoevertagande_nn_1_1_N : N ;
  makulerande_nn_1_N : N ;
  malande_nn_1_N : N ;
  malfoberande_nn_1_N : N ;
  malmande_nn_1_N : N ;
  maltraeterande_nn_1_1_N : N ;
  manande_nn_1_N : N ;
  manglande_nn_1_N : N ;
  manifesterande_nn_1_N : N ;
  manikurerande_nn_1_N : N ;
  manikyrerande_nn_1_N : N ;
  manipulerande_nn_1_N : N ;
  mankerande_nn_1_N : N ;
  manschettyrke_nn_1_N : N ;
  mansintresse_nn_1_N : N ;
  manssamhaelle_nn_1_1_N : N ;
  mantlande_nn_1_N : N ;
  manoeverutrymme_nn_1_1_N : N ;
  manoevrerande_nn_1_1_N : N ;
  marginaliserande_nn_1_N : N ;
  marinerande_nn_1_N : N ;
  markerande_nn_1_N : N ;
  marknadsanpassande_nn_1_N : N ;
  marknadsfoerande_nn_1_1_N : N ;
  marknadslaege_nn_1_1_N : N ;
  marknadsvaerde_nn_1_1_N : N ;
  marknadsvaerderande_nn_1_1_N : N ;
  markomraade_nn_1_1_N : N ;
  marmorerande_nn_1_N : N ;
  maroderande_nn_1_N : N ;
  marscherande_nn_1_N : N ;
  marschlaege_nn_1_1_N : N ;
  marterande_nn_1_N : N ;
  masande_nn_1_N : N ;
  maskande_nn_1_N : N ;
  maskerande_nn_1_N : N ;
  maskuliniserande_nn_1_N : N ;
  massakrerande_nn_1_N : N ;
  massavskedande_nn_1_N : N ;
  masserande_nn_1_N : N ;
  massgripande_nn_1_N : N ;
  massmoete_nn_1_1_N : N ;
  massutdoeende_nn_1_1_N : N ;
  masturberande_nn_1_N : N ;
  matande_nn_1_N : N ;
  matchande_nn_1_N : N ;
  matelasserande_nn_1_N : N ;
  materialiserande_nn_1_N : N ;
  materieutbyte_nn_1_N : N ;
  matstaelle_nn_1_1_N : N ;
  mattande_nn_1_N : N ;
  matterande_nn_1_N : N ;
  mattesnille_nn_1_N : N ;
  matvaegrande_nn_1_1_N : N ;
  mataepple_nn_1_1_N : N ;
  maxande_nn_1_N : N ;
  maximerande_nn_1_N : N ;
  meckande_nn_1_N : N ;
  mecklande_nn_1_N : N ;
  medaljerande_nn_1_N : N ;
  medarbetande_nn_1_N : N ;
  medborgargarde_nn_1_N : N ;
  medborgarinflytande_nn_1_N : N ;
  medborgarsinne_nn_1_N : N ;
  medborgarvittne_nn_1_N : N ;
  medbringande_nn_1_N : N ;
  meddelande_nn_1_N : N ;
  medelvaerde_nn_1_1_N : N ;
  medfoeljande_nn_1_1_N : N ;
  medfoerande_nn_1_1_N : N ;
  medgivande_nn_1_N : N ;
  medicinerande_nn_1_N : N ;
  mediterande_nn_1_N : N ;
  medlande_nn_1_N : N ;
  medlemsmoete_nn_1_1_N : N ;
  medtagande_nn_1_N : N ;
  medverkande_nn_1_N : N ;
  mejande_nn_1_N : N ;
  mejlande_nn_1_N : N ;
  mejlbombande_nn_1_N : N ;
  mejslande_nn_1_N : N ;
  mekande_nn_1_N : N ;
  mekaniserande_nn_1_N : N ;
  mellangaerde_nn_1_1_N : N ;
  mellanhavande_nn_1_N : N ;
  mellanlandande_nn_1_N : N ;
  mellanlaege_nn_1_1_N : N ;
  melonaepple_nn_1_1_N : N ;
  memorerande_nn_1_N : N ;
  menande_nn_1_N : N ;
  menfoere_nn_1_1_N : N ;
  meningsbyte_nn_1_N : N ;
  meningsutbyte_nn_1_N : N ;
  menstruerande_nn_1_N : N ;
  merarbete_nn_1_N : N ;
  merceriserande_nn_1_N : N ;
  meriterande_nn_1_N : N ;
  mervaerde_nn_1_1_N : N ;
  messande_nn_1_N : N ;
  messiasrike_nn_1_N : N ;
  metalliserande_nn_1_N : N ;
  metallvaerde_nn_1_1_N : N ;
  metande_nn_1_N : N ;
  mete_nn_1_N : N ;
  mezzoforte_nn_1_N : N ;
  micrande_nn_1_N : N ;
  mikrande_nn_1_N : N ;
  mikrofilmande_nn_1_N : N ;
  mikrofotograferande_nn_1_N : N ;
  mikrometersikte_nn_1_N : N ;
  mikroskoperande_nn_1_N : N ;
  mildrande_nn_1_N : N ;
  milennieskifte_nn_1_N : N ;
  militariserande_nn_1_N : N ;
  militaeromraade_nn_1_1_N : N ;
  miljoearbete_nn_1_1_N : N ;
  miljoebyte_nn_1_1_N : N ;
  miljoecertifierande_nn_1_1_N : N ;
  miljoemaerkande_nn_1_1_N : N ;
  miljoeombyte_nn_1_1_N : N ;
  miljoetaenkande_nn_1_1_N : N ;
  millennieskifte_nn_1_N : N ;
  mimande_nn_1_N : N ;
  minaretbygge_nn_1_N : N ;
  mineraliserande_nn_1_N : N ;
  mineralaemne_nn_1_1_N : N ;
  minerande_nn_1_N : N ;
  minglande_nn_1_N : N ;
  miniatyriserande_nn_1_N : N ;
  minimerande_nn_1_N : N ;
  ministerstyre_nn_1_N : N ;
  ministeraembete_nn_1_1_N : N ;
  minnande_nn_1_N : N ;
  minne_nn_1_N : N ;
  minnesmaerke_nn_1_1_N : N ;
  minoritetsvaelde_nn_1_1_N : N ;
  minskande_nn_1_N : N ;
  missaktande_nn_1_N : N ;
  missale_nn_1_N : N ;
  missande_nn_1_N : N ;
  missbedoemande_nn_1_1_N : N ;
  missbrukande_nn_1_N : N ;
  missbrukarumgaenge_nn_1_1_N : N ;
  missfirmande_nn_1_N : N ;
  missfaergande_nn_1_1_N : N ;
  missfoerhaallande_nn_1_1_N : N ;
  missfoerstaaende_nn_1_1_N : N ;
  missgynnande_nn_1_N : N ;
  misshagande_nn_1_N : N ;
  misshandlande_nn_1_N : N ;
  missionerande_nn_1_N : N ;
  missiverande_nn_1_N : N ;
  missklaedande_nn_1_1_N : N ;
  misskrediterande_nn_1_N : N ;
  misskaennande_nn_1_1_N : N ;
  misskoetande_nn_1_1_N : N ;
  missledande_nn_1_N : N ;
  misslyckande_nn_1_N : N ;
  missnoeje_nn_1_1_N : N ;
  missprydande_nn_1_N : N ;
  misstagande_nn_1_N : N ;
  misstolkande_nn_1_N : N ;
  misstroende_nn_1_N : N ;
  misstroestande_nn_1_1_N : N ;
  misstyckande_nn_1_N : N ;
  misstydande_nn_1_N : N ;
  misstaenkande_nn_1_1_N : N ;
  misstaenkliggoerande_nn_1_1_N : N ;
  missunnande_nn_1_N : N ;
  missuppfattande_nn_1_N : N ;
  missvisande_nn_1_N : N ;
  missoede_nn_1_1_N : N ;
  mistande_nn_1_N : N ;
  mittraecke_nn_1_1_N : N ;
  mixande_nn_1_N : N ;
  mixtrande_nn_1_N : N ;
  mjauande_nn_1_N : N ;
  mjukande_nn_1_N : N ;
  mjukgoerande_nn_1_1_N : N ;
  mjuklandande_nn_1_N : N ;
  mjuknande_nn_1_N : N ;
  mjoelande_nn_1_1_N : N ;
  mjoelkande_nn_1_1_N : N ;
  mjoelkfloede_nn_1_1_N : N ;
  mobbande_nn_1_N : N ;
  mobiliserande_nn_1_N : N ;
  mobilpratande_nn_1_N : N ;
  mockande_nn_1_N : N ;
  mode_nn_1_N : N ;
  modellbygge_nn_1_N : N ;
  modellerande_nn_1_N : N ;
  modererande_nn_1_N : N ;
  moderniserande_nn_1_N : N ;
  modersskoete_nn_1_1_N : N ;
  modifierande_nn_1_N : N ;
  modulerande_nn_1_N : N ;
  modaerniserande_nn_1_1_N : N ;
  mognande_nn_1_N : N ;
  mojnande_nn_1_N : N ;
  molande_nn_1_N : N ;
  molnhoelje_nn_1_1_N : N ;
  molntaecke_nn_1_1_N : N ;
  moltigande_nn_1_N : N ;
  momsredovisande_nn_1_N : N ;
  mongolrike_nn_1_N : N ;
  monoftongerande_nn_1_N : N ;
  monopoliserande_nn_1_N : N ;
  monterande_nn_1_N : N ;
  mopedande_nn_1_N : N ;
  moppande_nn_1_N : N ;
  moraliserande_nn_1_N : N ;
  mordhotande_nn_1_N : N ;
  morgonmoete_nn_1_1_N : N ;
  morlande_nn_1_N : N ;
  morrande_nn_1_N : N ;
  morsande_nn_1_N : N ;
  morserande_nn_1_N : N ;
  mortificerande_nn_1_N : N ;
  mortifierande_nn_1_N : N ;
  mosande_nn_1_N : N ;
  motande_nn_1_N : N ;
  motarbetande_nn_1_N : N ;
  motbevisande_nn_1_N : N ;
  motionerande_nn_1_N : N ;
  motiverande_nn_1_N : N ;
  motlaesande_nn_1_1_N : N ;
  motorbraensle_nn_1_1_N : N ;
  motoriserande_nn_1_N : N ;
  motsatsfoerhaallande_nn_1_1_N : N ;
  motseende_nn_1_N : N ;
  motstycke_nn_1_N : N ;
  motstaaende_nn_1_1_N : N ;
  motstaandsnaeste_nn_1_1_N : N ;
  motstaandsomraade_nn_1_1_N : N ;
  motsvarande_nn_1_N : N ;
  motsaegande_nn_1_1_N : N ;
  mottagande_nn_1_N : N ;
  motverkande_nn_1_N : N ;
  motvaegande_nn_1_1_N : N ;
  mousserande_nn_1_N : N ;
  muckande_nn_1_N : N ;
  muddrande_nn_1_N : N ;
  mulande_nn_1_N : N ;
  mulbete_nn_1_N : N ;
  muljerande_nn_1_N : N ;
  mullrande_nn_1_N : N ;
  mullvadsarbete_nn_1_N : N ;
  mulnande_nn_1_N : N ;
  multiplicerande_nn_1_N : N ;
  multnande_nn_1_N : N ;
  mumifierande_nn_1_N : N ;
  mumlande_nn_1_N : N ;
  mumsande_nn_1_N : N ;
  municipalsamhaelle_nn_1_1_N : N ;
  munkabaelte_nn_1_1_N : N ;
  munkloefte_nn_1_1_N : N ;
  munstycke_nn_1_N : N ;
  munstycksbyte_nn_1_N : N ;
  murande_nn_1_N : N ;
  murknande_nn_1_N : N ;
  murrande_nn_1_N : N ;
  musicerande_nn_1_N : N ;
  musikstycke_nn_1_N : N ;
  muskelarbete_nn_1_N : N ;
  muskelknippe_nn_1_N : N ;
  muskelsinne_nn_1_N : N ;
  musserande_nn_1_N : N ;
  mutande_nn_1_N : N ;
  muterande_nn_1_N : N ;
  muttrande_nn_1_N : N ;
  myglande_nn_1_N : N ;
  myllande_nn_1_N : N ;
  myllrande_nn_1_N : N ;
  mynnande_nn_1_N : N ;
  myntande_nn_1_N : N ;
  myrsamhaelle_nn_1_1_N : N ;
  mysande_nn_1_N : N ;
  mystifierande_nn_1_N : N ;
  maeklande_nn_1_1_N : N ;
  maeklararvode_nn_1_1_N : N ;
  maektande_nn_1_1_N : N ;
  maelande_nn_1_1_N : N ;
  maeltande_nn_1_1_N : N ;
  maengande_nn_1_1_N : N ;
  maenniskoansikte_nn_1_1_N : N ;
  maenniskoslaekte_nn_1_1_N : N ;
  maenniskovaerde_nn_1_1_N : N ;
  maenniskooede_nn_1_1_N : N ;
  maerglande_nn_1_1_N : N ;
  maerkande_nn_1_1_N : N ;
  maerke_nn_1_1_N : N ;
  maerksnoere_nn_1_1_N : N ;
  maeskande_nn_1_1_N : N ;
  maessande_nn_1_1_N : N ;
  maessingsknaeppe_nn_1_1_N : N ;
  maesterstycke_nn_1_1_N : N ;
  maestrande_nn_1_1_N : N ;
  maetande_nn_1_1_N : N ;
  maetomraade_nn_1_1_N : N ;
  maettande_nn_1_1_N : N ;
  maetvaerde_nn_1_1_N : N ;
  maaende_nn_1_1_N : N ;
  maalande_nn_1_1_N : N ;
  maaleriarbete_nn_1_1_N : N ;
  maalningsarbete_nn_1_1_N : N ;
  maalomraade_nn_1_1_N : N ;
  maalskytte_nn_1_1_N : N ;
  maalsnoere_nn_1_1_N : N ;
  maalsaegarbitraede_nn_1_1_N : N ;
  maanadsskifte_nn_1_1_N : N ;
  maanande_nn_1_1_N : N ;
  maanansikte_nn_1_1_N : N ;
  maangdubblande_nn_1_1_N : N ;
  maangfaldigande_nn_1_1_N : N ;
  maanglande_nn_1_1_N : N ;
  maanskifte_nn_1_1_N : N ;
  maaste_nn_1_1_N : N ;
  maattande_nn_1_1_N : N ;
  moeblerande_nn_1_1_N : N ;
  moeglande_nn_1_1_N : N ;
  moejliggoerande_nn_1_1_N : N ;
  moenstersamhaelle_nn_1_1_N : N ;
  moenstrande_nn_1_1_N : N ;
  moerande_nn_1_1_N : N ;
  moerbultande_nn_1_1_N : N ;
  moerdande_nn_1_1_N : N ;
  moerkande_nn_1_1_N : N ;
  moerklaeggande_nn_1_1_N : N ;
  moerknande_nn_1_1_N : N ;
  moetande_nn_1_1_N : N ;
  moete_nn_1_1_N : N ;
  nackande_nn_1_N : N ;
  nafsande_nn_1_N : N ;
  nagelfarande_nn_1_N : N ;
  nagelklippningsloefte_nn_1_1_N : N ;
  naggande_nn_1_N : N ;
  naglande_nn_1_N : N ;
  najande_nn_1_N : N ;
  nallande_nn_1_N : N ;
  namnande_nn_1_N : N ;
  namnbyte_nn_1_N : N ;
  namnfaestande_nn_1_1_N : N ;
  namngivande_nn_1_N : N ;
  namnvaerde_nn_1_1_N : N ;
  nappande_nn_1_N : N ;
  narande_nn_1_N : N ;
  narkotikaberoende_nn_1_N : N ;
  narrande_nn_1_N : N ;
  narvande_nn_1_N : N ;
  nasalerande_nn_1_N : N ;
  nasaliserande_nn_1_N : N ;
  nasande_nn_1_N : N ;
  nationaldagsfirande_nn_1_N : N ;
  nationalgarde_nn_1_N : N ;
  nationaliserande_nn_1_N : N ;
  nationalitetsmaerke_nn_1_1_N : N ;
  nationalitetsstraevande_nn_1_1_N : N ;
  nationalmedvetande_nn_1_N : N ;
  nationsbygge_nn_1_N : N ;
  nattande_nn_1_N : N ;
  nattarbete_nn_1_N : N ;
  nattlinne_nn_1_N : N ;
  nattsikte_nn_1_N : N ;
  naturaliserande_nn_1_N : N ;
  naturminne_nn_1_N : N ;
  naturminnesmaerke_nn_1_1_N : N ;
  navelskaadande_nn_1_1_N : N ;
  navigerande_nn_1_N : N ;
  navlande_nn_1_N : N ;
  nedarbetande_nn_1_N : N ;
  nedblaasande_nn_1_1_N : N ;
  nedbringande_nn_1_N : N ;
  nedbrytande_nn_1_N : N ;
  nederboerdsomraade_nn_1_1_N : N ;
  nedfrysande_nn_1_N : N ;
  nedgraevande_nn_1_1_N : N ;
  nedgoerande_nn_1_1_N : N ;
  nedisande_nn_1_N : N ;
  nedkallande_nn_1_N : N ;
  nedkastande_nn_1_N : N ;
  nedkavlande_nn_1_N : N ;
  nedklassande_nn_1_N : N ;
  nedkommande_nn_1_N : N ;
  nedlaeggande_nn_1_1_N : N ;
  nedrustande_nn_1_N : N ;
  nedsaltande_nn_1_N : N ;
  nedskrivande_nn_1_N : N ;
  nedslaaende_nn_1_1_N : N ;
  nedstigande_nn_1_N : N ;
  nedsaenkande_nn_1_1_N : N ;
  nedsaettande_nn_1_1_N : N ;
  nedtecknande_nn_1_N : N ;
  nedtransformerande_nn_1_N : N ;
  nedtransponerande_nn_1_N : N ;
  nedtrappande_nn_1_N : N ;
  nedvaerderande_nn_1_1_N : N ;
  negerande_nn_1_N : N ;
  negligerande_nn_1_N : N ;
  negocierande_nn_1_N : N ;
  negotierande_nn_1_N : N ;
  nekande_nn_1_N : N ;
  nerarbetande_nn_1_N : N ;
  nerblaasande_nn_1_1_N : N ;
  nerbringande_nn_1_N : N ;
  nerbrytande_nn_1_N : N ;
  nerfrysande_nn_1_N : N ;
  nergoerande_nn_1_1_N : N ;
  nerisande_nn_1_N : N ;
  nerkallande_nn_1_N : N ;
  nerkastande_nn_1_N : N ;
  nerkavlande_nn_1_N : N ;
  nerklassande_nn_1_N : N ;
  nerkommande_nn_1_N : N ;
  nerlaeggande_nn_1_1_N : N ;
  nerrustande_nn_1_N : N ;
  nersaltande_nn_1_N : N ;
  nerskrivande_nn_1_N : N ;
  nerslaaende_nn_1_1_N : N ;
  nerstigande_nn_1_N : N ;
  nersaenkande_nn_1_1_N : N ;
  nersaettande_nn_1_1_N : N ;
  nertecknande_nn_1_N : N ;
  nertransformerande_nn_1_N : N ;
  nertransponerande_nn_1_N : N ;
  nertrappande_nn_1_N : N ;
  nervknippe_nn_1_N : N ;
  nervaerderande_nn_1_1_N : N ;
  nettosparande_nn_1_N : N ;
  neutraliserande_nn_1_N : N ;
  neutrallaege_nn_1_1_N : N ;
  niande_nn_1_N : N ;
  nickande_nn_1_N : N ;
  niellerande_nn_1_N : N ;
  nigande_nn_1_N : N ;
  nitande_nn_1_N : N ;
  nitrerande_nn_1_N : N ;
  nitaelskande_nn_1_1_N : N ;
  nivellerande_nn_1_N : N ;
  nivaagrupperande_nn_1_1_N : N ;
  njurbaelte_nn_1_1_N : N ;
  njutande_nn_1_N : N ;
  nobbande_nn_1_N : N ;
  nobiliserande_nn_1_N : N ;
  nockande_nn_1_N : N ;
  nojsande_nn_1_N : N ;
  nollande_nn_1_N : N ;
  nollstaellande_nn_1_1_N : N ;
  nollstaelle_nn_1_1_N : N ;
  nolltaxerande_nn_1_N : N ;
  nollaege_nn_1_1_N : N ;
  nomadiserande_nn_1_N : N ;
  nominalvaerde_nn_1_1_N : N ;
  nominerande_nn_1_N : N ;
  nonchalerande_nn_1_N : N ;
  noppande_nn_1_N : N ;
  normaliserande_nn_1_N : N ;
  normerande_nn_1_N : N ;
  norpande_nn_1_N : N ;
  nosande_nn_1_N : N ;
  notande_nn_1_N : N ;
  noterande_nn_1_N : N ;
  notificerande_nn_1_N : N ;
  notifierande_nn_1_N : N ;
  notiserande_nn_1_N : N ;
  nubbande_nn_1_N : N ;
  nuddande_nn_1_N : N ;
  numrerande_nn_1_N : N ;
  nyanlaeggande_nn_1_1_N : N ;
  nyanserande_nn_1_N : N ;
  nyanskaffande_nn_1_N : N ;
  nyanstaellande_nn_1_1_N : N ;
  nybygge_nn_1_N : N ;
  nyckelaemne_nn_1_1_N : N ;
  nydanande_nn_1_N : N ;
  nyemitterande_nn_1_N : N ;
  nyetablerande_nn_1_N : N ;
  nyinvesterande_nn_1_N : N ;
  nylle_nn_1_N : N ;
  nylonsnoere_nn_1_1_N : N ;
  nynnande_nn_1_N : N ;
  nypande_nn_1_N : N ;
  nyplanterande_nn_1_N : N ;
  nystande_nn_1_N : N ;
  nytecknande_nn_1_N : N ;
  nyttande_nn_1_N : N ;
  nyttiggoerande_nn_1_1_N : N ;
  nyttjande_nn_1_N : N ;
  nyvaerde_nn_1_1_N : N ;
  nyaarsloefte_nn_1_1_N : N ;
  naemnande_nn_1_1_N : N ;
  naepsande_nn_1_1_N : N ;
  naerande_nn_1_1_N : N ;
  naerboende_nn_1_1_N : N ;
  naeringsstaelle_nn_1_1_N : N ;
  naeringsvaerde_nn_1_1_N : N ;
  naeringsaemne_nn_1_1_N : N ;
  naermande_nn_1_1_N : N ;
  naermevaerde_nn_1_1_N : N ;
  naeromraade_nn_1_1_N : N ;
  naersamhaelle_nn_1_1_N : N ;
  naerslutande_nn_1_1_N : N ;
  naervarande_nn_1_1_N : N ;
  naestande_nn_1_1_N : N ;
  naeste_nn_1_1_N : N ;
  naetande_nn_1_1_N : N ;
  naethandlande_nn_1_1_N : N ;
  naadande_nn_1_1_N : N ;
  naadevedermaele_nn_1_1_N : N ;
  naaende_nn_1_1_N : N ;
  naalande_nn_1_1_N : N ;
  naatande_nn_1_1_N : N ;
  naatlande_nn_1_1_N : N ;
  noedbromsande_nn_1_1_N : N ;
  noedgande_nn_1_1_N : N ;
  noedlandande_nn_1_1_N : N ;
  noedlaege_nn_1_1_N : N ;
  noedsakande_nn_1_1_N : N ;
  noedsignalerande_nn_1_1_N : N ;
  noedstoppande_nn_1_1_N : N ;
  noedoeppnande_nn_1_1_N : N ;
  noeje_nn_1_1_N : N ;
  noetande_nn_1_1_N : N ;
  noetknaepparansikte_nn_1_1_N : N ;
  obducerande_nn_1_N : N ;
  objektiverande_nn_1_N : N ;
  obligerande_nn_1_N : N ;
  observerande_nn_1_N : N ;
  obstruerande_nn_1_N : N ;
  occidentaliserande_nn_1_N : N ;
  ockrande_nn_1_N : N ;
  ockuperande_nn_1_N : N ;
  ode_nn_1_N : N ;
  odlande_nn_1_N : N ;
  offentliggoerande_nn_1_1_N : N ;
  offererande_nn_1_N : N ;
  officierande_nn_1_N : N ;
  offrande_nn_1_N : N ;
  ofredande_nn_1_N : N ;
  ogillande_nn_1_N : N ;
  ojande_nn_1_N : N ;
  okande_nn_1_N : N ;
  oktanvaerde_nn_1_1_N : N ;
  oktaverande_nn_1_N : N ;
  oktrojerande_nn_1_N : N ;
  okulerande_nn_1_N : N ;
  okvaedande_nn_1_1_N : N ;
  okvaede_nn_1_1_N : N ;
  olande_nn_1_N : N ;
  oljande_nn_1_N : N ;
  oljebyte_nn_1_N : N ;
  oljebaelte_nn_1_1_N : N ;
  ollande_nn_1_N : N ;
  olyckstillfaelle_nn_1_1_N : N ;
  olycksoede_nn_1_1_N : N ;
  omarbetande_nn_1_N : N ;
  ombedjande_nn_1_N : N ;
  ombestyrande_nn_1_N : N ;
  ombesoerjande_nn_1_1_N : N ;
  ombetroende_nn_1_N : N ;
  ombildande_nn_1_N : N ;
  ombrytande_nn_1_N : N ;
  ombyggande_nn_1_N : N ;
  ombyte_nn_1_N : N ;
  omdanande_nn_1_N : N ;
  omdirigerande_nn_1_N : N ;
  omdoeme_nn_1_1_N : N ;
  omfamnande_nn_1_N : N ;
  omfattande_nn_1_N : N ;
  omformande_nn_1_N : N ;
  omfoerande_nn_1_1_N : N ;
  omfoerdelande_nn_1_1_N : N ;
  omfoerhandlande_nn_1_1_N : N ;
  omfoermaelande_nn_1_1_N : N ;
  omgestaltande_nn_1_N : N ;
  omgivande_nn_1_N : N ;
  omgaerdande_nn_1_1_N : N ;
  omhuldande_nn_1_N : N ;
  omhaegnande_nn_1_1_N : N ;
  omhaektande_nn_1_1_N : N ;
  omhaenderhavande_nn_1_1_N : N ;
  omhaendertagande_nn_1_1_N : N ;
  omhaenge_nn_1_1_N : N ;
  omhoeljande_nn_1_1_N : N ;
  omintetgoerande_nn_1_1_N : N ;
  omkastande_nn_1_N : N ;
  omklaedande_nn_1_1_N : N ;
  omklaedningsutrymme_nn_1_1_N : N ;
  omklaeende_nn_1_1_N : N ;
  omkommande_nn_1_N : N ;
  omkransande_nn_1_N : N ;
  omkretsande_nn_1_N : N ;
  omkvaede_nn_1_1_N : N ;
  omkoerande_nn_1_1_N : N ;
  ommoeblerande_nn_1_1_N : N ;
  omnaemnande_nn_1_1_N : N ;
  omorganiserande_nn_1_N : N ;
  omplacerande_nn_1_N : N ;
  omplaastrande_nn_1_1_N : N ;
  omproevande_nn_1_1_N : N ;
  omramande_nn_1_N : N ;
  omringande_nn_1_N : N ;
  omraeknande_nn_1_1_N : N ;
  omraade_nn_1_1_N : N ;
  omseende_nn_1_N : N ;
  omskapande_nn_1_N : N ;
  omskolande_nn_1_N : N ;
  omskrivande_nn_1_N : N ;
  omskulpturerande_nn_1_N : N ;
  omskaerande_nn_1_1_N : N ;
  omskoetande_nn_1_1_N : N ;
  omslingrande_nn_1_N : N ;
  omslutande_nn_1_N : N ;
  omspinnande_nn_1_N : N ;
  omspaennande_nn_1_1_N : N ;
  omstrukturerande_nn_1_N : N ;
  omstraalande_nn_1_1_N : N ;
  omstaellande_nn_1_1_N : N ;
  omstoepande_nn_1_1_N : N ;
  omstoertande_nn_1_1_N : N ;
  omsvepande_nn_1_N : N ;
  omsvaermande_nn_1_1_N : N ;
  omsaettande_nn_1_1_N : N ;
  omtagande_nn_1_N : N ;
  omtalande_nn_1_N : N ;
  omtolkande_nn_1_N : N ;
  omvandlande_nn_1_N : N ;
  omvittnande_nn_1_N : N ;
  omvaeljande_nn_1_1_N : N ;
  omvaelvande_nn_1_1_N : N ;
  omvaendande_nn_1_1_N : N ;
  omvaerderande_nn_1_1_N : N ;
  omvaervande_nn_1_1_N : N ;
  omvaexlande_nn_1_1_N : N ;
  omyndigfoerklarande_nn_1_1_N : N ;
  omaendrande_nn_1_1_N : N ;
  omoejliggoerande_nn_1_1_N : N ;
  onanerande_nn_1_N : N ;
  onaniserande_nn_1_N : N ;
  ondulerande_nn_1_N : N ;
  operadike_nn_1_N : N ;
  operationaliserande_nn_1_N : N ;
  opererande_nn_1_N : N ;
  opinerande_nn_1_N : N ;
  oppammande_nn_1_N : N ;
  opparbetande_nn_1_N : N ;
  oppassande_nn_1_N : N ;
  oppassningsstaelle_nn_1_1_N : N ;
  oppblandande_nn_1_N : N ;
  oppbringande_nn_1_N : N ;
  oppdagande_nn_1_N : N ;
  oppdaterande_nn_1_N : N ;
  oppdelande_nn_1_N : N ;
  oppdrivande_nn_1_N : N ;
  oppeggande_nn_1_N : N ;
  oppfattande_nn_1_N : N ;
  oppfinnande_nn_1_N : N ;
  oppfostrande_nn_1_N : N ;
  oppfriskande_nn_1_N : N ;
  oppfyllande_nn_1_N : N ;
  oppfaangande_nn_1_1_N : N ;
  oppfoedande_nn_1_1_N : N ;
  opphetsande_nn_1_N : N ;
  opphettande_nn_1_N : N ;
  opphittande_nn_1_N : N ;
  opphottande_nn_1_N : N ;
  opphaemtande_nn_1_1_N : N ;
  opphaevande_nn_1_1_N : N ;
  opphoejande_nn_1_1_N : N ;
  opphoerande_nn_1_1_N : N ;
  oppiggande_nn_1_N : N ;
  oppjusterande_nn_1_N : N ;
  oppkallande_nn_1_N : N ;
  oppklarande_nn_1_N : N ;
  opplivande_nn_1_N : N ;
  opplaeggande_nn_1_1_N : N ;
  opplaesande_nn_1_1_N : N ;
  oppmuntrande_nn_1_N : N ;
  opponerande_nn_1_N : N ;
  oppradande_nn_1_N : N ;
  opprensande_nn_1_N : N ;
  oppraeknande_nn_1_1_N : N ;
  oppraettande_nn_1_1_N : N ;
  oppsamlande_nn_1_N : N ;
  oppskjutande_nn_1_N : N ;
  oppsnabbande_nn_1_N : N ;
  oppstaellande_nn_1_1_N : N ;
  oppsugande_nn_1_N : N ;
  oppsummerande_nn_1_N : N ;
  oppsaettande_nn_1_1_N : N ;
  oppsoekande_nn_1_1_N : N ;
  opptagande_nn_1_N : N ;
  opptornande_nn_1_N : N ;
  opptrappande_nn_1_N : N ;
  opptrissande_nn_1_N : N ;
  oppvaktande_nn_1_N : N ;
  oppvisande_nn_1_N : N ;
  oppvaegande_nn_1_1_N : N ;
  oppvaerderande_nn_1_1_N : N ;
  oppvaexande_nn_1_1_N : N ;
  oppaetande_nn_1_1_N : N ;
  oppoevande_nn_1_1_N : N ;
  opterande_nn_1_N : N ;
  optimerande_nn_1_N : N ;
  ordande_nn_1_N : N ;
  ordbyte_nn_1_N : N ;
  ordfloede_nn_1_1_N : N ;
  ordinariesaettande_nn_1_1_N : N ;
  ordinerande_nn_1_N : N ;
  ordnande_nn_1_N : N ;
  ordningssinne_nn_1_N : N ;
  ordskifte_nn_1_N : N ;
  oredande_nn_1_N : N ;
  orenande_nn_1_N : N ;
  orerande_nn_1_N : N ;
  organisationsarbete_nn_1_N : N ;
  organiserande_nn_1_N : N ;
  orgelstycke_nn_1_N : N ;
  orienterande_nn_1_N : N ;
  orienteringsaemne_nn_1_1_N : N ;
  orkande_nn_1_N : N ;
  orkesterdike_nn_1_N : N ;
  orkesterstycke_nn_1_N : N ;
  orkestrerande_nn_1_N : N ;
  ormande_nn_1_N : N ;
  ornamenterande_nn_1_N : N ;
  ornerande_nn_1_N : N ;
  oroande_nn_1_N : N ;
  orsakande_nn_1_N : N ;
  osande_nn_1_N : N ;
  oscillerande_nn_1_N : N ;
  oskadliggoerande_nn_1_1_N : N ;
  oskaerande_nn_1_1_N : N ;
  osnyggande_nn_1_N : N ;
  osynliggoerande_nn_1_1_N : N ;
  osaekrande_nn_1_1_N : N ;
  outande_nn_1_N : N ;
  oxiderande_nn_1_N : N ;
  pH_vaerde_nn_1_1_N : N ;
  pacificerande_nn_1_N : N ;
  packande_nn_1_N : N ;
  paginerande_nn_1_N : N ;
  pajande_nn_1_N : N ;
  paketerande_nn_1_N : N ;
  palataliserande_nn_1_N : N ;
  paljetterande_nn_1_N : N ;
  pallande_nn_1_N : N ;
  palmande_nn_1_N : N ;
  palperande_nn_1_N : N ;
  panelande_nn_1_N : N ;
  panerande_nn_1_N : N ;
  pangande_nn_1_N : N ;
  panorerande_nn_1_N : N ;
  pansarregemente_nn_1_N : N ;
  pansrande_nn_1_N : N ;
  pantande_nn_1_N : N ;
  pantfoerskrivande_nn_1_1_N : N ;
  pantograferande_nn_1_N : N ;
  pantsaettande_nn_1_1_N : N ;
  pappersarbete_nn_1_N : N ;
  papperssnoere_nn_1_1_N : N ;
  paraderande_nn_1_N : N ;
  paradigmskifte_nn_1_N : N ;
  paradisaepple_nn_1_1_N : N ;
  paraferande_nn_1_N : N ;
  paraffinerande_nn_1_N : N ;
  parafraserande_nn_1_N : N ;
  parallelliserande_nn_1_N : N ;
  parallellkopplande_nn_1_N : N ;
  paralyserande_nn_1_N : N ;
  parande_nn_1_N : N ;
  parasiterande_nn_1_N : N ;
  parenterande_nn_1_N : N ;
  parerande_nn_1_N : N ;
  parfymerande_nn_1_N : N ;
  parfoerhaallande_nn_1_1_N : N ;
  parismode_nn_1_N : N ;
  parkerande_nn_1_N : N ;
  parketterande_nn_1_N : N ;
  parlamenterande_nn_1_N : N ;
  parlerande_nn_1_N : N ;
  parodierande_nn_1_N : N ;
  partajande_nn_1_N : N ;
  partande_nn_1_N : N ;
  partiledarbyte_nn_1_N : N ;
  partivaesende_nn_1_1_N : N ;
  passagerarsaete_nn_1_1_N : N ;
  passande_nn_1_N : N ;
  passerande_nn_1_N : N ;
  passiverande_nn_1_N : N ;
  passiviserande_nn_1_N : N ;
  pastorsaembete_nn_1_1_N : N ;
  pastoeriserande_nn_1_1_N : N ;
  patenterande_nn_1_N : N ;
  patinerande_nn_1_N : N ;
  patronbaelte_nn_1_1_N : N ;
  patrullerande_nn_1_N : N ;
  pauperiserande_nn_1_N : N ;
  pausande_nn_1_N : N ;
  pauserande_nn_1_N : N ;
  pauskommaterande_nn_1_N : N ;
  paxande_nn_1_N : N ;
  pejlande_nn_1_N : N ;
  pekande_nn_1_N : N ;
  pelleterande_nn_1_N : N ;
  pendlande_nn_1_N : N ;
  penetrerande_nn_1_N : N ;
  penningfloede_nn_1_1_N : N ;
  pensionerande_nn_1_N : N ;
  pensionssparande_nn_1_N : N ;
  penslande_nn_1_N : N ;
  peppande_nn_1_N : N ;
  pepparsprejande_nn_1_N : N ;
  pepprande_nn_1_N : N ;
  percipierande_nn_1_N : N ;
  perennerande_nn_1_N : N ;
  perforerande_nn_1_N : N ;
  periodiserande_nn_1_N : N ;
  permanentande_nn_1_N : N ;
  permanentondulerande_nn_1_N : N ;
  permitterande_nn_1_N : N ;
  permuterande_nn_1_N : N ;
  persiflerande_nn_1_N : N ;
  personifierande_nn_1_N : N ;
  personkryssande_nn_1_N : N ;
  perspektivskifte_nn_1_N : N ;
  persvaderande_nn_1_N : N ;
  perverterande_nn_1_N : N ;
  petande_nn_1_N : N ;
  petrifierande_nn_1_N : N ;
  pickande_nn_1_N : N ;
  piercingsmycke_nn_1_N : N ;
  pikande_nn_1_N : N ;
  pikerande_nn_1_N : N ;
  pilande_nn_1_N : N ;
  pilkande_nn_1_N : N ;
  pillande_nn_1_N : N ;
  pillrande_nn_1_N : N ;
  pimpande_nn_1_N : N ;
  pimplande_nn_1_N : N ;
  pinande_nn_1_N : N ;
  pincerande_nn_1_N : N ;
  pinglande_nn_1_N : N ;
  pinkande_nn_1_N : N ;
  pinnande_nn_1_N : N ;
  pipande_nn_1_N : N ;
  pippande_nn_1_N : N ;
  pirkande_nn_1_N : N ;
  pirrande_nn_1_N : N ;
  piruetterande_nn_1_N : N ;
  piskande_nn_1_N : N ;
  pissande_nn_1_N : N ;
  pivoterande_nn_1_N : N ;
  pjollrande_nn_1_N : N ;
  pjoskande_nn_1_N : N ;
  pjunkande_nn_1_N : N ;
  placerande_nn_1_N : N ;
  pladdrande_nn_1_N : N ;
  plagierande_nn_1_N : N ;
  planande_nn_1_N : N ;
  planerande_nn_1_N : N ;
  plankande_nn_1_N : N ;
  planlaeggande_nn_1_1_N : N ;
  plantande_nn_1_N : N ;
  planterande_nn_1_N : N ;
  plaskande_nn_1_N : N ;
  plastande_nn_1_N : N ;
  platinerande_nn_1_N : N ;
  platsande_nn_1_N : N ;
  pliggande_nn_1_N : N ;
  pliktande_nn_1_N : N ;
  pliktfaellande_nn_1_1_N : N ;
  plirande_nn_1_N : N ;
  plisserande_nn_1_N : N ;
  plitande_nn_1_N : N ;
  plockande_nn_1_N : N ;
  plogande_nn_1_N : N ;
  plomberande_nn_1_N : N ;
  plottande_nn_1_N : N ;
  plottrande_nn_1_N : N ;
  pluggande_nn_1_N : N ;
  pluggaemne_nn_1_1_N : N ;
  plumpande_nn_1_N : N ;
  plumsande_nn_1_N : N ;
  plundrande_nn_1_N : N ;
  plurrande_nn_1_N : N ;
  plussande_nn_1_N : N ;
  plutande_nn_1_N : N ;
  plysande_nn_1_N : N ;
  plyte_nn_1_N : N ;
  plaederande_nn_1_1_N : N ;
  plaegande_nn_1_1_N : N ;
  plaeterande_nn_1_1_N : N ;
  plaagande_nn_1_1_N : N ;
  plaastrande_nn_1_1_N : N ;
  plaatande_nn_1_1_N : N ;
  ploejande_nn_1_1_N : N ;
  pocherande_nn_1_N : N ;
  pockande_nn_1_N : N ;
  pointerande_nn_1_N : N ;
  pokeransikte_nn_1_N : N ;
  pokulerande_nn_1_N : N ;
  polande_nn_1_N : N ;
  polariserande_nn_1_N : N ;
  polaromraade_nn_1_1_N : N ;
  polemiserande_nn_1_N : N ;
  polerande_nn_1_N : N ;
  polisanmaelande_nn_1_1_N : N ;
  polisarbete_nn_1_N : N ;
  polisbevakande_nn_1_N : N ;
  polisingripande_nn_1_N : N ;
  polisvaesende_nn_1_1_N : N ;
  polisyrke_nn_1_N : N ;
  polisaerende_nn_1_1_N : N ;
  politiserande_nn_1_N : N ;
  polletterande_nn_1_N : N ;
  pollinerande_nn_1_N : N ;
  polstrande_nn_1_N : N ;
  pomaderande_nn_1_N : N ;
  ponerande_nn_1_N : N ;
  poppande_nn_1_N : N ;
  populariserande_nn_1_N : N ;
  porlande_nn_1_N : N ;
  porrsurfande_nn_1_N : N ;
  portande_nn_1_N : N ;
  portfoerbjudande_nn_1_1_N : N ;
  portionerande_nn_1_N : N ;
  portraetterande_nn_1_1_N : N ;
  portskrymsle_nn_1_N : N ;
  poserande_nn_1_N : N ;
  postande_nn_1_N : N ;
  postdaterande_nn_1_N : N ;
  posterande_nn_1_N : N ;
  postponerande_nn_1_N : N ;
  postroestande_nn_1_1_N : N ;
  poststaemplande_nn_1_1_N : N ;
  postulerande_nn_1_N : N ;
  poaengterande_nn_1_1_N : N ;
  praktiserande_nn_1_N : N ;
  prasslande_nn_1_N : N ;
  pratande_nn_1_N : N ;
  prebende_nn_1_N : N ;
  preciserande_nn_1_N : N ;
  precisionsarbete_nn_1_N : N ;
  predestinerande_nn_1_N : N ;
  predicerande_nn_1_N : N ;
  predikande_nn_1_N : N ;
  predisponerande_nn_1_N : N ;
  predominerande_nn_1_N : N ;
  prefabricerande_nn_1_N : N ;
  prefererande_nn_1_N : N ;
  prefigerande_nn_1_N : N ;
  prejande_nn_1_N : N ;
  preludierande_nn_1_N : N ;
  premierande_nn_1_N : N ;
  premiaerkoerande_nn_1_1_N : N ;
  prenumererande_nn_1_N : N ;
  preparerande_nn_1_N : N ;
  presentande_nn_1_N : N ;
  presenterande_nn_1_N : N ;
  preserverande_nn_1_N : N ;
  presidentstyre_nn_1_N : N ;
  presiderande_nn_1_N : N ;
  preskriberande_nn_1_N : N ;
  pressande_nn_1_N : N ;
  presslaeggande_nn_1_1_N : N ;
  pressmeddelande_nn_1_N : N ;
  pressmoete_nn_1_1_N : N ;
  prestaverande_nn_1_N : N ;
  presterande_nn_1_N : N ;
  presumerande_nn_1_N : N ;
  pretenderande_nn_1_N : N ;
  prickande_nn_1_N : N ;
  primaerminne_nn_1_1_N : N ;
  prioriterande_nn_1_N : N ;
  prisande_nn_1_N : N ;
  prisbeloenande_nn_1_1_N : N ;
  prisgivande_nn_1_N : N ;
  prismaerkande_nn_1_1_N : N ;
  prisreglerande_nn_1_N : N ;
  prissaettande_nn_1_1_N : N ;
  privatiserande_nn_1_N : N ;
  privilegierande_nn_1_N : N ;
  proberande_nn_1_N : N ;
  problematiserande_nn_1_N : N ;
  procentande_nn_1_N : N ;
  procentvaerde_nn_1_1_N : N ;
  processande_nn_1_N : N ;
  producerande_nn_1_N : N ;
  produktionsfoerhaallande_nn_1_1_N : N ;
  profanerande_nn_1_N : N ;
  professionaliserande_nn_1_N : N ;
  profeterande_nn_1_N : N ;
  profilerande_nn_1_N : N ;
  profiterande_nn_1_N : N ;
  prognostiserande_nn_1_N : N ;
  programmerande_nn_1_N : N ;
  projektarbete_nn_1_N : N ;
  projekterande_nn_1_N : N ;
  projicerande_nn_1_N : N ;
  proklamerande_nn_1_N : N ;
  proletariserande_nn_1_N : N ;
  prolongerande_nn_1_N : N ;
  promenadkoerande_nn_1_1_N : N ;
  promenerande_nn_1_N : N ;
  promoverande_nn_1_N : N ;
  promulgerande_nn_1_N : N ;
  prononcerande_nn_1_N : N ;
  propagerande_nn_1_N : N ;
  proponerande_nn_1_N : N ;
  proportionerande_nn_1_N : N ;
  proppande_nn_1_N : N ;
  propsande_nn_1_N : N ;
  proskriberande_nn_1_N : N ;
  prospekterande_nn_1_N : N ;
  prostituerande_nn_1_N : N ;
  protegerande_nn_1_N : N ;
  protesterande_nn_1_N : N ;
  protestklickande_nn_1_N : N ;
  protestmoete_nn_1_1_N : N ;
  protestroestande_nn_1_1_N : N ;
  protokollerande_nn_1_N : N ;
  provande_nn_1_N : N ;
  provianterande_nn_1_N : N ;
  provkoerande_nn_1_1_N : N ;
  provocerande_nn_1_N : N ;
  prunkande_nn_1_N : N ;
  prustande_nn_1_N : N ;
  prutande_nn_1_N : N ;
  pruttande_nn_1_N : N ;
  pryande_nn_1_N : N ;
  prydande_nn_1_N : N ;
  prydnadssnoere_nn_1_1_N : N ;
  pryglande_nn_1_N : N ;
  praegelvaerde_nn_1_1_N : N ;
  praeglande_nn_1_1_N : N ;
  praentande_nn_1_1_N : N ;
  praestvigande_nn_1_1_N : N ;
  praestvaelde_nn_1_1_N : N ;
  praestaembete_nn_1_1_N : N ;
  praalande_nn_1_1_N : N ;
  praamande_nn_1_1_N : N ;
  praanglande_nn_1_1_N : N ;
  proejsande_nn_1_1_N : N ;
  proevande_nn_1_1_N : N ;
  psykande_nn_1_N : N ;
  psyke_nn_1_N : N ;
  psykoanalyserande_nn_1_N : N ;
  psykologiserande_nn_1_N : N ;
  publicerande_nn_1_N : N ;
  puddlande_nn_1_N : N ;
  pudlande_nn_1_N : N ;
  pudrande_nn_1_N : N ;
  puffande_nn_1_N : N ;
  pulande_nn_1_N : N ;
  pullande_nn_1_N : N ;
  pulsande_nn_1_N : N ;
  pulserande_nn_1_N : N ;
  pulveriserande_nn_1_N : N ;
  pulverlackerande_nn_1_N : N ;
  pulvriserande_nn_1_N : N ;
  pumpande_nn_1_N : N ;
  pungslaaende_nn_1_1_N : N ;
  punktande_nn_1_N : N ;
  punkterande_nn_1_N : N ;
  punktsvetsande_nn_1_N : N ;
  punsande_nn_1_N : N ;
  purgerande_nn_1_N : N ;
  purknande_nn_1_N : N ;
  purprande_nn_1_N : N ;
  purpurfaergande_nn_1_1_N : N ;
  purrande_nn_1_N : N ;
  pushande_nn_1_N : N ;
  pussande_nn_1_N : N ;
  pusslande_nn_1_N : N ;
  pustande_nn_1_N : N ;
  putande_nn_1_N : N ;
  putsande_nn_1_N : N ;
  puttande_nn_1_N : N ;
  puttrande_nn_1_N : N ;
  pycke_nn_1_N : N ;
  pyntande_nn_1_N : N ;
  pyrande_nn_1_N : N ;
  pyre_nn_1_N : N ;
  pysande_nn_1_N : N ;
  pysslande_nn_1_N : N ;
  pytsande_nn_1_N : N ;
  paelande_nn_1_1_N : N ;
  paerlande_nn_1_1_N : N ;
  paaande_nn_1_1_N : N ;
  paaannonserande_nn_1_1_N : N ;
  paabjudande_nn_1_1_N : N ;
  paaboerdande_nn_1_1_N : N ;
  paaboerjande_nn_1_1_N : N ;
  paadyvlande_nn_1_1_N : N ;
  paafordrande_nn_1_1_N : N ;
  paafoerande_nn_1_1_N : N ;
  paagaaende_nn_1_1_N : N ;
  paakallande_nn_1_1_N : N ;
  paaklaedande_nn_1_1_N : N ;
  paalande_nn_1_1_N : N ;
  paalaeggande_nn_1_1_N : N ;
  paaloedande_nn_1_1_N : N ;
  paaminnande_nn_1_1_N : N ;
  paanyttfoedande_nn_1_1_N : N ;
  paapekande_nn_1_1_N : N ;
  paaropande_nn_1_1_N : N ;
  paaraeknande_nn_1_1_N : N ;
  paaskinande_nn_1_1_N : N ;
  paaskyndande_nn_1_1_N : N ;
  paaspaedande_nn_1_1_N : N ;
  paaspaeende_nn_1_1_N : N ;
  paastaaende_nn_1_1_N : N ;
  paatagande_nn_1_1_N : N ;
  paatalande_nn_1_1_N : N ;
  paatande_nn_1_1_N : N ;
  paatraeffande_nn_1_1_N : N ;
  paatvingande_nn_1_1_N : N ;
  paavedoeme_nn_1_1_N : N ;
  paaverkande_nn_1_1_N : N ;
  paavilande_nn_1_1_N : N ;
  paavisande_nn_1_1_N : N ;
  paayrkande_nn_1_1_N : N ;
  poebelvaelde_nn_1_1_N : N ;
  poelande_nn_1_1_N : N ;
  poerte_nn_1_1_N : N ;
  poesande_nn_1_1_N : N ;
  quiltande_nn_1_N : N ;
  quizande_nn_1_N : N ;
  quizzande_nn_1_N : N ;
  rabatterande_nn_1_N : N ;
  rabattfrimaerke_nn_1_1_N : N ;
  rabatthaefte_nn_1_1_N : N ;
  rackande_nn_1_N : N ;
  radbyte_nn_1_N : N ;
  raderande_nn_1_N : N ;
  radhusomraade_nn_1_1_N : N ;
  radierande_nn_1_N : N ;
  radikaliserande_nn_1_N : N ;
  radionavigerande_nn_1_N : N ;
  raffinerande_nn_1_N : N ;
  rafistulerande_nn_1_N : N ;
  raggande_nn_1_N : N ;
  ragglande_nn_1_N : N ;
  raglande_nn_1_N : N ;
  rakande_nn_1_N : N ;
  raknande_nn_1_N : N ;
  raljerande_nn_1_N : N ;
  ramande_nn_1_N : N ;
  ramlande_nn_1_N : N ;
  rammande_nn_1_N : N ;
  ramponerande_nn_1_N : N ;
  ramsande_nn_1_N : N ;
  randande_nn_1_N : N ;
  rangerande_nn_1_N : N ;
  ranglande_nn_1_N : N ;
  rangordnande_nn_1_N : N ;
  rankande_nn_1_N : N ;
  rannsakande_nn_1_N : N ;
  ransonerande_nn_1_N : N ;
  rantande_nn_1_N : N ;
  rapande_nn_1_N : N ;
  rappande_nn_1_N : N ;
  rappellerande_nn_1_N : N ;
  rapporterande_nn_1_N : N ;
  rasande_nn_1_N : N ;
  rasdiskriminerande_nn_1_N : N ;
  raserande_nn_1_N : N ;
  raspande_nn_1_N : N ;
  rasslande_nn_1_N : N ;
  rastande_nn_1_N : N ;
  ratande_nn_1_N : N ;
  ratificerande_nn_1_N : N ;
  rationaliserande_nn_1_N : N ;
  ratschande_nn_1_N : N ;
  rattande_nn_1_N : N ;
  rayonsilke_nn_1_N : N ;
  reagerande_nn_1_N : N ;
  reaktiverande_nn_1_N : N ;
  reale_nn_1_N : N ;
  realiserande_nn_1_N : N ;
  realvaerde_nn_1_1_N : N ;
  reande_nn_1_N : N ;
  reassurerande_nn_1_N : N ;
  rebellerande_nn_1_N : N ;
  rebellfaeste_nn_1_1_N : N ;
  recenserande_nn_1_N : N ;
  recidiverande_nn_1_N : N ;
  recipierande_nn_1_N : N ;
  reciterande_nn_1_N : N ;
  redande_nn_1_N : N ;
  rede_nn_1_N : N ;
  redigerande_nn_1_N : N ;
  redogoerande_nn_1_1_N : N ;
  redovisande_nn_1_N : N ;
  redubblande_nn_1_N : N ;
  reducerande_nn_1_N : N ;
  refererande_nn_1_N : N ;
  reflekterande_nn_1_N : N ;
  reformerande_nn_1_N : N ;
  reformstraevande_nn_1_1_N : N ;
  refuserande_nn_1_N : N ;
  regale_nn_1_N : N ;
  regalerande_nn_1_N : N ;
  regemente_nn_1_N : N ;
  regenererande_nn_1_N : N ;
  regerande_nn_1_N : N ;
  regeringssammantraede_nn_1_1_N : N ;
  regisserande_nn_1_N : N ;
  registrerande_nn_1_N : N ;
  reglemente_nn_1_N : N ;
  reglementerande_nn_1_N : N ;
  reglerande_nn_1_N : N ;
  regnande_nn_1_N : N ;
  regnomraade_nn_1_1_N : N ;
  regummerande_nn_1_N : N ;
  rehabiliterande_nn_1_N : N ;
  reinkarnerande_nn_1_N : N ;
  rekande_nn_1_N : N ;
  rekapitulerande_nn_1_N : N ;
  reklamerande_nn_1_N : N ;
  reklamsyfte_nn_1_N : N ;
  rekognoscerande_nn_1_N : N ;
  rekognoserande_nn_1_N : N ;
  rekommenderande_nn_1_N : N ;
  rekompenserande_nn_1_N : N ;
  rekonstruerande_nn_1_N : N ;
  rekreationsomraade_nn_1_1_N : N ;
  rekryterande_nn_1_N : N ;
  rektificerande_nn_1_N : N ;
  rektifierande_nn_1_N : N ;
  rektorsomraade_nn_1_1_N : N ;
  rekvirerande_nn_1_N : N ;
  rekylerande_nn_1_N : N ;
  relaterande_nn_1_N : N ;
  relaxande_nn_1_N : N ;
  relegerande_nn_1_N : N ;
  relaeande_nn_1_1_N : N ;
  remissyttrande_nn_1_N : N ;
  remitterande_nn_1_N : N ;
  remmande_nn_1_N : N ;
  remonterande_nn_1_N : N ;
  remplacerande_nn_1_N : N ;
  renande_nn_1_N : N ;
  renderande_nn_1_N : N ;
  rengoerande_nn_1_1_N : N ;
  rengoeringssnoere_nn_1_1_N : N ;
  renmaerke_nn_1_1_N : N ;
  renodlande_nn_1_N : N ;
  renoverande_nn_1_N : N ;
  renoveringsarbete_nn_1_N : N ;
  renrakande_nn_1_N : N ;
  rensande_nn_1_N : N ;
  renskrivande_nn_1_N : N ;
  rentvaaende_nn_1_1_N : N ;
  reorganiserande_nn_1_N : N ;
  repande_nn_1_N : N ;
  reparerande_nn_1_N : N ;
  repartiserande_nn_1_N : N ;
  repatrierande_nn_1_N : N ;
  repellerande_nn_1_N : N ;
  repeterande_nn_1_N : N ;
  replierande_nn_1_N : N ;
  replikerande_nn_1_N : N ;
  replikskifte_nn_1_N : N ;
  representerande_nn_1_N : N ;
  repriserande_nn_1_N : N ;
  reproducerande_nn_1_N : N ;
  resande_nn_3_N : N ;
  reserverande_nn_1_N : N ;
  residerande_nn_1_N : N ;
  resignerande_nn_1_N : N ;
  resistensomraade_nn_1_1_N : N ;
  resolverande_nn_1_N : N ;
  resonerande_nn_1_N : N ;
  resorberande_nn_1_N : N ;
  respekterande_nn_1_N : N ;
  respirerande_nn_1_N : N ;
  restaurerande_nn_1_N : N ;
  resterande_nn_1_N : N ;
  restituerande_nn_1_N : N ;
  resulterande_nn_1_N : N ;
  resumerande_nn_1_N : N ;
  retablerande_nn_1_N : N ;
  retande_nn_1_N : N ;
  retarderande_nn_1_N : N ;
  retirerande_nn_1_N : N ;
  returnerande_nn_1_N : N ;
  retuscherande_nn_1_N : N ;
  revalverande_nn_1_N : N ;
  revande_nn_1_N : N ;
  reveterande_nn_1_N : N ;
  reviderande_nn_1_N : N ;
  revolterande_nn_1_N : N ;
  revolutionerande_nn_1_N : N ;
  riande_nn_1_N : N ;
  rickande_nn_1_N : N ;
  ridande_nn_1_N : N ;
  ridborgarmaerke_nn_1_1_N : N ;
  riggande_nn_1_N : N ;
  rike_nn_1_N : N ;
  rikoschetterande_nn_1_N : N ;
  riksdagssammantraede_nn_1_1_N : N ;
  riksdagsvaelde_nn_1_1_N : N ;
  riksintresse_nn_1_N : N ;
  riksmoete_nn_1_1_N : N ;
  riksroese_nn_1_1_N : N ;
  riktande_nn_1_N : N ;
  riktmaerke_nn_1_1_N : N ;
  rimmande_nn_1_N : N ;
  rimsaltande_nn_1_N : N ;
  ringaktande_nn_1_N : N ;
  ringande_nn_1_N : N ;
  ringbarkande_nn_1_N : N ;
  ringlande_nn_1_N : N ;
  ringmaerkande_nn_1_1_N : N ;
  rinnande_nn_1_N : N ;
  riposterande_nn_1_N : N ;
  risande_nn_1_N : N ;
  riskbygge_nn_1_N : N ;
  riskerande_nn_1_N : N ;
  riskomraade_nn_1_1_N : N ;
  rispande_nn_1_N : N ;
  risslande_nn_1_N : N ;
  ristande_nn_1_N : N ;
  ritande_nn_1_N : N ;
  ritsande_nn_1_N : N ;
  ritschande_nn_1_N : N ;
  ritualiserande_nn_1_N : N ;
  rivaliserande_nn_1_N : N ;
  rivande_nn_1_N : N ;
  rivstartande_nn_1_N : N ;
  roande_nn_1_N : N ;
  robotiserande_nn_1_N : N ;
  rockande_nn_1_N : N ;
  rockerande_nn_1_N : N ;
  rodnande_nn_1_N : N ;
  roende_nn_1_N : N ;
  roffande_nn_1_N : N ;
  rollande_nn_1_N : N ;
  rollskifte_nn_1_N : N ;
  romantiserande_nn_1_N : N ;
  ropande_nn_1_N : N ;
  rosande_nn_1_N : N ;
  rosslande_nn_1_N : N ;
  rostande_nn_1_N : N ;
  rostbehandlande_nn_1_N : N ;
  rostskyddande_nn_1_N : N ;
  rotande_nn_1_N : N ;
  roterande_nn_1_N : N ;
  rotfyllande_nn_1_N : N ;
  rotfaeste_nn_1_1_N : N ;
  rotmaerke_nn_1_1_N : N ;
  rubbande_nn_1_N : N ;
  rubricerande_nn_1_N : N ;
  ruckande_nn_1_N : N ;
  rucklande_nn_1_N : N ;
  rufflande_nn_1_N : N ;
  rufsande_nn_1_N : N ;
  ruggande_nn_1_N : N ;
  ruinerande_nn_1_N : N ;
  rullande_nn_1_N : N ;
  rullbraede_nn_1_1_N : N ;
  rullbaelte_nn_1_1_N : N ;
  rullstolssele_nn_1_N : N ;
  rulltrappsraecke_nn_1_1_N : N ;
  rultande_nn_1_N : N ;
  rumlande_nn_1_N : N ;
  rumphuggande_nn_1_N : N ;
  rumsterande_nn_1_N : N ;
  rundande_nn_1_N : N ;
  rundningsmaerke_nn_1_1_N : N ;
  rundsmoerjande_nn_1_1_N : N ;
  rundstickande_nn_1_N : N ;
  rundstycke_nn_1_N : N ;
  rungande_nn_1_N : N ;
  runkande_nn_1_N : N ;
  runstensomraade_nn_1_1_N : N ;
  runstycke_nn_1_N : N ;
  rusande_nn_1_N : N ;
  ruskande_nn_1_N : N ;
  russificerande_nn_1_N : N ;
  russifierande_nn_1_N : N ;
  rustande_nn_1_N : N ;
  rutande_nn_1_N : N ;
  rutinaerende_nn_1_1_N : N ;
  rutschande_nn_1_N : N ;
  ruttnande_nn_1_N : N ;
  ruvande_nn_1_N : N ;
  ryande_nn_1_N : N ;
  ryckande_nn_1_N : N ;
  ryggande_nn_1_N : N ;
  rygglaege_nn_1_1_N : N ;
  ryggsaecksluffande_nn_1_1_N : N ;
  rykande_nn_1_N : N ;
  ryktande_nn_1_N : N ;
  rykte_nn_1_N : N ;
  rymmande_nn_1_N : N ;
  rynkande_nn_1_N : N ;
  rysande_nn_1_N : N ;
  rytande_nn_1_N : N ;
  rytmiserande_nn_1_N : N ;
  ryttlande_nn_1_N : N ;
  raeckande_nn_1_1_N : N ;
  raecke_nn_1_1_N : N ;
  raeddande_nn_1_1_N : N ;
  raefflande_nn_1_1_N : N ;
  raefsande_nn_1_1_N : N ;
  raeknande_nn_1_1_N : N ;
  raemnande_nn_1_1_N : N ;
  raennande_nn_1_1_N : N ;
  raetande_nn_1_1_N : N ;
  raettande_nn_1_1_N : N ;
  raettegaangsbitraede_nn_1_1_N : N ;
  raettesnoere_nn_1_1_N : N ;
  raettfaerdigande_nn_1_1_N : N ;
  raettfaerdiggoerande_nn_1_1_N : N ;
  raettslaege_nn_1_1_N : N ;
  raettsmedvetande_nn_1_1_N : N ;
  raettssamhaelle_nn_1_1_N : N ;
  raettssaekerhetsintresse_nn_1_1_N : N ;
  raettsvaesende_nn_1_1_N : N ;
  raadande_nn_1_1_N : N ;
  raadbraakande_nn_1_1_N : N ;
  raadfraagande_nn_1_1_N : N ;
  raadfoerande_nn_1_1_N : N ;
  raadgoerande_nn_1_1_N : N ;
  raadlaeggande_nn_1_1_N : N ;
  raadplaegande_nn_1_1_N : N ;
  raadslaaende_nn_1_1_N : N ;
  raaende_nn_1_1_N : N ;
  raagande_nn_1_1_N : N ;
  raakande_nn_1_1_N : N ;
  raamande_nn_1_1_N : N ;
  raamaerke_nn_1_1_N : N ;
  raanande_nn_1_1_N : N ;
  raanbyte_nn_1_1_N : N ;
  raapluggande_nn_1_1_N : N ;
  raarivande_nn_1_1_N : N ;
  raaskalande_nn_1_1_N : N ;
  raaskaellande_nn_1_1_N : N ;
  raastekande_nn_1_1_N : N ;
  raaaemne_nn_1_1_N : N ;
  roedgloedgande_nn_1_1_N : N ;
  roedlistande_nn_1_1_N : N ;
  roedpunktsikte_nn_1_1_N : N ;
  roedpunktssikte_nn_1_1_N : N ;
  roejande_nn_1_1_N : N ;
  roejningsarbete_nn_1_1_N : N ;
  roekande_nn_1_1_N : N ;
  roenande_nn_1_1_N : N ;
  roentgande_nn_1_1_N : N ;
  roentgenfotograferande_nn_1_1_N : N ;
  roerande_nn_1_1_N : N ;
  roerelsesinne_nn_1_1_N : N ;
  roerknippe_nn_1_1_N : N ;
  roesande_nn_1_1_N : N ;
  roese_nn_1_1_N : N ;
  roestande_nn_1_1_N : N ;
  roeste_nn_1_1_N : N ;
  roestlaege_nn_1_1_N : N ;
  roestmaximerande_nn_1_1_N : N ;
  roevande_nn_1_1_N : N ;
  roevknullande_nn_1_1_N : N ;
  sabbande_nn_1_N : N ;
  saboterande_nn_1_N : N ;
  sabrerande_nn_1_N : N ;
  sackande_nn_1_N : N ;
  sadellaege_nn_1_1_N : N ;
  sadeltaecke_nn_1_1_N : N ;
  sadlande_nn_1_N : N ;
  saftande_nn_1_N : N ;
  saggande_nn_1_N : N ;
  saglande_nn_1_N : N ;
  sakande_nn_1_N : N ;
  sakerfoerklarande_nn_1_1_N : N ;
  sakfaellande_nn_1_1_N : N ;
  sakfoerhaallande_nn_1_1_N : N ;
  sakkunnigbetaenkande_nn_1_1_N : N ;
  sakkunnigutlaatande_nn_1_1_N : N ;
  saknande_nn_1_N : N ;
  saktande_nn_1_N : N ;
  sakoere_nn_1_1_N : N ;
  salande_nn_1_N : N ;
  salderande_nn_1_N : N ;
  saligfoerklarande_nn_1_1_N : N ;
  saliverande_nn_1_N : N ;
  saltande_nn_1_N : N ;
  saltsleke_nn_1_N : N ;
  salubjudande_nn_1_N : N ;
  salufoerande_nn_1_1_N : N ;
  saluterande_nn_1_N : N ;
  saluvaerde_nn_1_1_N : N ;
  samarbetande_nn_1_N : N ;
  samarbete_nn_1_N : N ;
  sambeskattande_nn_1_N : N ;
  samboende_nn_2_N : N ;
  samhaelle_nn_1_1_N : N ;
  samhaellsarbete_nn_1_1_N : N ;
  samhaellsingripande_nn_1_1_N : N ;
  samhaellsomraade_nn_1_1_N : N ;
  samhaellsplanerande_nn_1_1_N : N ;
  samkande_nn_1_N : N ;
  samklingande_nn_1_N : N ;
  samkoerande_nn_1_1_N : N ;
  samlande_nn_1_N : N ;
  sammanavlande_nn_1_N : N ;
  sammanbindande_nn_1_N : N ;
  sammanblandande_nn_1_N : N ;
  sammanboende_nn_1_N : N ;
  sammandrabbande_nn_1_N : N ;
  sammandragande_nn_1_N : N ;
  sammanfallande_nn_1_N : N ;
  sammanfattande_nn_1_N : N ;
  sammanflaetande_nn_1_1_N : N ;
  sammanfloede_nn_1_1_N : N ;
  sammanfogande_nn_1_N : N ;
  sammanfoerande_nn_1_1_N : N ;
  sammangaaende_nn_1_1_N : N ;
  sammanhopande_nn_1_N : N ;
  sammanhaengande_nn_1_1_N : N ;
  sammanhaallande_nn_1_1_N : N ;
  sammanjaemkande_nn_1_1_N : N ;
  sammankallande_nn_1_N : N ;
  sammankopplande_nn_1_N : N ;
  sammanlevande_nn_1_N : N ;
  sammanlaeggande_nn_1_1_N : N ;
  sammanlaenkande_nn_1_1_N : N ;
  sammanloepande_nn_1_1_N : N ;
  sammanpackande_nn_1_N : N ;
  sammanpressande_nn_1_N : N ;
  sammanringande_nn_1_N : N ;
  sammanraeknande_nn_1_1_N : N ;
  sammanskjutande_nn_1_N : N ;
  sammanskrivande_nn_1_N : N ;
  sammanslaaende_nn_1_1_N : N ;
  sammansmaeltande_nn_1_1_N : N ;
  sammanstraalande_nn_1_1_N : N ;
  sammanstaellande_nn_1_1_N : N ;
  sammanstoetande_nn_1_1_N : N ;
  sammansvetsande_nn_1_N : N ;
  sammansaettande_nn_1_1_N : N ;
  sammantryckande_nn_1_N : N ;
  sammantraedande_nn_1_1_N : N ;
  sammantraede_nn_1_1_N : N ;
  sammantraeffande_nn_1_1_N : N ;
  sammanvaevande_nn_1_1_N : N ;
  sammanvaexande_nn_1_1_N : N ;
  samordnande_nn_1_N : N ;
  samplande_nn_1_N : N ;
  samraadande_nn_1_1_N : N ;
  samsande_nn_1_N : N ;
  samspelande_nn_1_N : N ;
  samspraakande_nn_1_1_N : N ;
  samtalande_nn_1_N : N ;
  samtalslaege_nn_1_1_N : N ;
  samtalsaemne_nn_1_1_N : N ;
  samtaxerande_nn_1_N : N ;
  samtyckande_nn_1_N : N ;
  samtycke_nn_1_N : N ;
  samvarande_nn_1_N : N ;
  samverkande_nn_1_N : N ;
  samvete_nn_1_N : N ;
  samvaelde_nn_1_1_N : N ;
  samaakande_nn_1_1_N : N ;
  sandande_nn_1_N : N ;
  sandblaestrande_nn_1_1_N : N ;
  sandpapprande_nn_1_N : N ;
  sanerande_nn_1_N : N ;
  sanforiserande_nn_1_N : N ;
  sanktifierande_nn_1_N : N ;
  sanktionerande_nn_1_N : N ;
  sannande_nn_1_N : N ;
  sanningsvittne_nn_1_N : N ;
  saponifierande_nn_1_N : N ;
  sargande_nn_1_N : N ;
  satinerande_nn_1_N : N ;
  satiriserande_nn_1_N : N ;
  satisfierande_nn_1_N : N ;
  satsande_nn_1_N : N ;
  satsbraede_nn_1_1_N : N ;
  saturerande_nn_1_N : N ;
  sauterande_nn_1_N : N ;
  sauverande_nn_1_N : N ;
  savande_nn_1_N : N ;
  saxande_nn_1_N : N ;
  scannande_nn_1_N : N ;
  scenframtraedande_nn_1_1_N : N ;
  scenuppfoerande_nn_1_1_N : N ;
  schabblande_nn_1_N : N ;
  schablonerande_nn_1_N : N ;
  schabloniserande_nn_1_N : N ;
  schablontaxerande_nn_1_N : N ;
  schackande_nn_1_N : N ;
  schackbraede_nn_1_1_N : N ;
  schacklande_nn_1_N : N ;
  schackrande_nn_1_N : N ;
  schaktande_nn_1_N : N ;
  schamponerande_nn_1_N : N ;
  schanghajande_nn_1_N : N ;
  schappande_nn_1_N : N ;
  schasande_nn_1_N : N ;
  schatterande_nn_1_N : N ;
  schavotterande_nn_1_N : N ;
  schematiserande_nn_1_N : N ;
  schveifande_nn_1_N : N ;
  scoutloefte_nn_1_1_N : N ;
  sedimenterande_nn_1_N : N ;
  seedande_nn_1_N : N ;
  seende_nn_1_N : N ;
  segande_nn_1_N : N ;
  segdragande_nn_1_N : N ;
  segelflygande_nn_1_N : N ;
  segelmaerke_nn_1_1_N : N ;
  seghaerdande_nn_1_1_N : N ;
  seglande_nn_1_N : N ;
  segmenterande_nn_1_N : N ;
  segnande_nn_1_N : N ;
  segrande_nn_1_N : N ;
  segregerande_nn_1_N : N ;
  sejdande_nn_1_N : N ;
  sejsande_nn_1_N : N ;
  sekelskifte_nn_1_N : N ;
  sekonderande_nn_1_N : N ;
  sekretessbelaeggande_nn_1_1_N : N ;
  sekulariserande_nn_1_N : N ;
  sekularsnille_nn_1_N : N ;
  sekunderande_nn_1_N : N ;
  sekundaerminne_nn_1_1_N : N ;
  sekvenserande_nn_1_N : N ;
  sekvestrerande_nn_1_N : N ;
  selande_nn_1_N : N ;
  selekterande_nn_1_N : N ;
  semaforerande_nn_1_N : N ;
  semesterarvode_nn_1_N : N ;
  semestrande_nn_1_N : N ;
  seminerande_nn_1_N : N ;
  senarelaeggande_nn_1_1_N : N ;
  sensibiliserande_nn_1_N : N ;
  senterande_nn_1_N : N ;
  separerande_nn_1_N : N ;
  seriekopplande_nn_1_N : N ;
  serietillverkande_nn_1_N : N ;
  servande_nn_1_N : N ;
  serverande_nn_1_N : N ;
  serviceyrke_nn_1_N : N ;
  sexchattande_nn_1_N : N ;
  sexofredande_nn_1_N : N ;
  sexualiserande_nn_1_N : N ;
  sexutnyttjande_nn_1_N : N ;
  shakande_nn_1_N : N ;
  shamponerande_nn_1_N : N ;
  shanghajande_nn_1_N : N ;
  shinglande_nn_1_N : N ;
  shoppande_nn_1_N : N ;
  shortande_nn_1_N : N ;
  showande_nn_1_N : N ;
  shuntande_nn_1_N : N ;
  siande_nn_1_N : N ;
  sickande_nn_1_N : N ;
  sicklande_nn_1_N : N ;
  sicksackande_nn_1_N : N ;
  sidbyte_nn_1_N : N ;
  sidnumrerande_nn_1_N : N ;
  sidolaege_nn_1_1_N : N ;
  sidsteppande_nn_1_N : N ;
  sigillerande_nn_1_N : N ;
  signalerande_nn_1_N : N ;
  signande_nn_1_N : N ;
  signerande_nn_1_N : N ;
  siktande_nn_1_N : N ;
  sikte_nn_1_N : N ;
  silande_nn_1_N : N ;
  silhuetterande_nn_1_N : N ;
  silke_nn_1_N : N ;
  silkesnoere_nn_1_1_N : N ;
  silkessnoere_nn_1_1_N : N ;
  siluetterande_nn_1_N : N ;
  silverinfattande_nn_1_N : N ;
  silversmide_nn_1_N : N ;
  silvrande_nn_1_N : N ;
  simborgarmaerke_nn_1_1_N : N ;
  simbaelte_nn_1_1_N : N ;
  simmande_nn_1_N : N ;
  simmaerke_nn_1_1_N : N ;
  simplifierande_nn_1_N : N ;
  simsande_nn_1_N : N ;
  simulerande_nn_1_N : N ;
  simultantolkande_nn_1_N : N ;
  sinande_nn_1_N : N ;
  singlande_nn_1_N : N ;
  sinkande_nn_1_N : N ;
  sinne_nn_1_N : N ;
  sintrande_nn_1_N : N ;
  sipprande_nn_1_N : N ;
  sirande_nn_1_N : N ;
  sirpande_nn_1_N : N ;
  sirrande_nn_1_N : N ;
  sisande_nn_1_N : N ;
  sisyfusarbete_nn_1_N : N ;
  sittande_nn_1_N : N ;
  sittbraede_nn_1_1_N : N ;
  sittstrejkande_nn_1_N : N ;
  sittupande_nn_1_N : N ;
  sittuppande_nn_1_N : N ;
  situpande_nn_1_N : N ;
  situppande_nn_1_N : N ;
  sjabblande_nn_1_N : N ;
  sjanghajande_nn_1_N : N ;
  sjangserande_nn_1_N : N ;
  sjappande_nn_1_N : N ;
  sjasande_nn_1_N : N ;
  sjaskande_nn_1_N : N ;
  sjavande_nn_1_N : N ;
  sjudande_nn_1_N : N ;
  sjukanmaelande_nn_1_1_N : N ;
  sjuknande_nn_1_N : N ;
  sjukskrivande_nn_1_N : N ;
  sjukvaardsbitraede_nn_1_1_N : N ;
  sjunkande_nn_1_N : N ;
  sjaelvbespeglande_nn_1_1_N : N ;
  sjaelvbevarande_nn_1_1_N : N ;
  sjaelvdoeende_nn_1_1_N : N ;
  sjaelvfinansierande_nn_1_1_N : N ;
  sjaelvfoerhaerligande_nn_1_1_N : N ;
  sjaelvlaekande_nn_1_1_N : N ;
  sjaelvmedvetande_nn_1_1_N : N ;
  sjaelvstyre_nn_1_1_N : N ;
  sjaelvstaendighetsstraevande_nn_1_1_N : N ;
  sjaelvtaendande_nn_1_1_N : N ;
  sjaelvoemkande_nn_1_1_N : N ;
  sjaaande_nn_1_1_N : N ;
  sjoemaerke_nn_1_1_N : N ;
  sjoesaettande_nn_1_1_N : N ;
  skadande_nn_1_N : N ;
  skadereglerande_nn_1_N : N ;
  skadestaandsyrkande_nn_1_1_N : N ;
  skadskjutande_nn_1_N : N ;
  skaffande_nn_1_N : N ;
  skaftande_nn_1_N : N ;
  skakande_nn_1_N : N ;
  skalande_nn_1_N : N ;
  skaldande_nn_1_N : N ;
  skaldestycke_nn_1_N : N ;
  skalkande_nn_1_N : N ;
  skallande_nn_1_N : N ;
  skallrande_nn_1_N : N ;
  skalperande_nn_1_N : N ;
  skamfilande_nn_1_N : N ;
  skandalavsloejande_nn_1_1_N : N ;
  skandaliserande_nn_1_N : N ;
  skanderande_nn_1_N : N ;
  skannande_nn_1_N : N ;
  skapande_nn_1_N : N ;
  skaplynne_nn_1_N : N ;
  skarpsinne_nn_1_N : N ;
  skarvande_nn_1_N : N ;
  skatande_nn_1_N : N ;
  skattande_nn_1_N : N ;
  skattefifflande_nn_1_N : N ;
  skattemaerke_nn_1_1_N : N ;
  skatteplanerande_nn_1_N : N ;
  skatteaerende_nn_1_1_N : N ;
  skattlaeggande_nn_1_1_N : N ;
  skattskrivande_nn_1_N : N ;
  skavande_nn_1_N : N ;
  skedande_nn_1_N : N ;
  skede_nn_1_N : N ;
  skeende_nn_1_N : N ;
  skejtande_nn_1_N : N ;
  skelande_nn_1_N : N ;
  skenande_nn_1_N : N ;
  skeppande_nn_1_N : N ;
  skevande_nn_1_N : N ;
  skevrande_nn_1_N : N ;
  skickande_nn_1_N : N ;
  skidande_nn_1_N : N ;
  skiftande_nn_1_N : N ;
  skiftarbete_nn_1_N : N ;
  skifte_nn_1_N : N ;
  skiktande_nn_1_N : N ;
  skildrande_nn_1_N : N ;
  skiljande_nn_1_N : N ;
  skilje_nn_1_N : N ;
  skiljefoerfarande_nn_1_1_N : N ;
  skimrande_nn_1_N : N ;
  skinande_nn_1_N : N ;
  skingrande_nn_1_N : N ;
  skinnande_nn_1_N : N ;
  skipande_nn_1_N : N ;
  skippande_nn_1_N : N ;
  skirande_nn_1_N : N ;
  skissande_nn_1_N : N ;
  skisserande_nn_1_N : N ;
  skitande_nn_1_N : N ;
  skitstaelle_nn_1_1_N : N ;
  skivande_nn_1_N : N ;
  skivminne_nn_1_N : N ;
  skjutande_nn_1_N : N ;
  skjutsande_nn_1_N : N ;
  skjuvande_nn_1_N : N ;
  skoende_nn_1_N : N ;
  skogsarbete_nn_1_N : N ;
  skogsbete_nn_1_N : N ;
  skogsomraade_nn_1_1_N : N ;
  skojande_nn_1_N : N ;
  skolande_nn_1_N : N ;
  skolarbete_nn_1_N : N ;
  skolbygge_nn_1_N : N ;
  skolkande_nn_1_N : N ;
  skolvaesende_nn_1_1_N : N ;
  skolaemne_nn_1_1_N : N ;
  skonande_nn_1_N : N ;
  skopande_nn_1_N : N ;
  skorrande_nn_1_N : N ;
  skosnoere_nn_1_1_N : N ;
  skotande_nn_1_N : N ;
  skottande_nn_1_N : N ;
  skottskadande_nn_1_N : N ;
  skovlande_nn_1_N : N ;
  skrafferande_nn_1_N : N ;
  skralnande_nn_1_N : N ;
  skraltande_nn_1_N : N ;
  skramlande_nn_1_N : N ;
  skrapande_nn_1_N : N ;
  skrattande_nn_1_N : N ;
  skrevande_nn_1_N : N ;
  skriande_nn_1_N : N ;
  skridande_nn_1_N : N ;
  skrikande_nn_1_N : N ;
  skrinlaeggande_nn_1_1_N : N ;
  skrinnande_nn_1_N : N ;
  skrittande_nn_1_N : N ;
  skrivande_nn_1_N : N ;
  skrivhaefte_nn_1_1_N : N ;
  skrockande_nn_1_N : N ;
  skroderande_nn_1_N : N ;
  skrotande_nn_1_N : N ;
  skrubbande_nn_1_N : N ;
  skrudande_nn_1_N : N ;
  skrumpnande_nn_1_N : N ;
  skruvande_nn_1_N : N ;
  skruvstycke_nn_1_N : N ;
  skrymmande_nn_1_N : N ;
  skrymsle_nn_1_N : N ;
  skrymtande_nn_1_N : N ;
  skrynklande_nn_1_N : N ;
  skrytande_nn_1_N : N ;
  skrytbygge_nn_1_N : N ;
  skraeckvaelde_nn_1_1_N : N ;
  skraedande_nn_1_1_N : N ;
  skraeddande_nn_1_1_N : N ;
  skraeddarsyende_nn_1_1_N : N ;
  skraellande_nn_1_1_N : N ;
  skraelle_nn_1_1_N : N ;
  skraemmande_nn_1_1_N : N ;
  skraenande_nn_1_1_N : N ;
  skraenkande_nn_1_1_N : N ;
  skraepande_nn_1_1_N : N ;
  skraeppande_nn_1_1_N : N ;
  skraevlande_nn_1_1_N : N ;
  skraalande_nn_1_1_N : N ;
  skraamande_nn_1_1_N : N ;
  skubbande_nn_1_N : N ;
  skuddande_nn_1_N : N ;
  skuffande_nn_1_N : N ;
  skuggande_nn_1_N : N ;
  skuggboxande_nn_1_N : N ;
  skuldbelaeggande_nn_1_1_N : N ;
  skulpterande_nn_1_N : N ;
  skulpturerande_nn_1_N : N ;
  skummande_nn_1_N : N ;
  skumpande_nn_1_N : N ;
  skumraskfoerehavande_nn_1_1_N : N ;
  skumtvaettande_nn_1_1_N : N ;
  skurande_nn_1_N : N ;
  skuttande_nn_1_N : N ;
  skvalande_nn_1_N : N ;
  skvallrande_nn_1_N : N ;
  skvalpande_nn_1_N : N ;
  skvaltande_nn_1_N : N ;
  skvimpande_nn_1_N : N ;
  skvisande_nn_1_N : N ;
  skvaettande_nn_1_1_N : N ;
  skyande_nn_1_N : N ;
  skyddande_nn_1_N : N ;
  skyddshoelje_nn_1_1_N : N ;
  skyddsimpregnerande_nn_1_N : N ;
  skyddsomraade_nn_1_1_N : N ;
  skyddsympande_nn_1_N : N ;
  skyende_nn_1_N : N ;
  skyfflande_nn_1_N : N ;
  skyggande_nn_1_N : N ;
  skygge_nn_1_N : N ;
  skylande_nn_1_N : N ;
  skyldrande_nn_1_N : N ;
  skyllande_nn_1_N : N ;
  skyltande_nn_1_N : N ;
  skymfande_nn_1_N : N ;
  skymlande_nn_1_N : N ;
  skymmande_nn_1_N : N ;
  skymtande_nn_1_N : N ;
  skyndande_nn_1_N : N ;
  skynke_nn_1_N : N ;
  skytte_nn_1_N : N ;
  skaeftande_nn_1_1_N : N ;
  skaeggande_nn_1_1_N : N ;
  skaektande_nn_1_1_N : N ;
  skaellande_nn_1_1_N : N ;
  skaelmstycke_nn_1_1_N : N ;
  skaelvande_nn_1_1_N : N ;
  skaemmande_nn_1_1_N : N ;
  skaemtande_nn_1_1_N : N ;
  skaendande_nn_1_1_N : N ;
  skaenkande_nn_1_1_N : N ;
  skaenklande_nn_1_1_N : N ;
  skaerande_nn_1_1_N : N ;
  skaerbraede_nn_1_1_N : N ;
  skaermbildande_nn_1_1_N : N ;
  skaerpande_nn_1_1_N : N ;
  skaerrande_nn_1_1_N : N ;
  skaerskaadande_nn_1_1_N : N ;
  skaervande_nn_1_1_N : N ;
  skaadande_nn_1_1_N : N ;
  skaalande_nn_1_1_N : N ;
  skaallande_nn_1_1_N : N ;
  skaangrande_nn_1_1_N : N ;
  skaapsupande_nn_1_1_N : N ;
  skaapaetande_nn_1_1_N : N ;
  skaarande_nn_1_1_N : N ;
  skoeldemaerke_nn_1_1_N : N ;
  skoeljande_nn_1_1_N : N ;
  skoelpande_nn_1_1_N : N ;
  skoenande_nn_2_1_N : N ;
  skoenhetsvaerde_nn_1_1_N : N ;
  skoenjande_nn_1_1_N : N ;
  skoenmaalande_nn_1_1_N : N ;
  skoenstaxerande_nn_1_1_N : N ;
  skoentaxerande_nn_1_1_N : N ;
  skoerande_nn_1_1_N : N ;
  skoerdande_nn_1_1_N : N ;
  skoernande_nn_1_1_N : N ;
  skoetande_nn_1_1_N : N ;
  skoete_nn_1_1_N : N ;
  skoevlande_nn_1_1_N : N ;
  slabbande_nn_1_N : N ;
  slabbrande_nn_1_N : N ;
  slackande_nn_1_N : N ;
  sladdande_nn_1_N : N ;
  sladdrande_nn_1_N : N ;
  slafande_nn_1_N : N ;
  slafsande_nn_1_N : N ;
  slaggande_nn_1_N : N ;
  slakande_nn_1_N : N ;
  slaknande_nn_1_N : N ;
  slaktande_nn_1_N : N ;
  slammande_nn_1_N : N ;
  slamrande_nn_1_N : N ;
  slamsande_nn_1_N : N ;
  slankande_nn_1_N : N ;
  slanknande_nn_1_N : N ;
  slantande_nn_1_N : N ;
  slappande_nn_1_N : N ;
  slappnande_nn_1_N : N ;
  slarvande_nn_1_N : N ;
  slasande_nn_1_N : N ;
  slaskande_nn_1_N : N ;
  slavande_nn_1_N : N ;
  slavarbete_nn_1_N : N ;
  slaviserande_nn_1_N : N ;
  slavmaerke_nn_1_1_N : N ;
  sleke_nn_1_N : N ;
  slentrianmoerkande_nn_1_1_N : N ;
  slevande_nn_1_N : N ;
  slickande_nn_1_N : N ;
  sliktande_nn_1_N : N ;
  slingrande_nn_1_N : N ;
  slinkande_nn_1_N : N ;
  slintande_nn_1_N : N ;
  slipande_nn_1_N : N ;
  slippande_nn_1_N : N ;
  slirande_nn_1_N : N ;
  slitande_nn_1_N : N ;
  slitsande_nn_1_N : N ;
  slocknande_nn_1_N : N ;
  slokande_nn_1_N : N ;
  slopande_nn_1_N : N ;
  slubbande_nn_1_N : N ;
  sluddrande_nn_1_N : N ;
  sluggande_nn_1_N : N ;
  slukande_nn_1_N : N ;
  slumomraade_nn_1_1_N : N ;
  slumpande_nn_1_N : N ;
  slumrande_nn_1_N : N ;
  slungande_nn_1_N : N ;
  slussande_nn_1_N : N ;
  slutande_nn_1_N : N ;
  slutbehandlande_nn_1_N : N ;
  slutfoerande_nn_1_1_N : N ;
  slutomdoeme_nn_1_1_N : N ;
  slutplaederande_nn_1_1_N : N ;
  slutskede_nn_1_N : N ;
  slutstycke_nn_1_N : N ;
  sluttande_nn_1_N : N ;
  slaeckande_nn_1_1_N : N ;
  slaeggande_nn_1_1_N : N ;
  slaekte_nn_1_1_N : N ;
  slaektskapsfoerhaallande_nn_1_1_N : N ;
  slaengande_nn_1_1_N : N ;
  slaentrande_nn_1_1_N : N ;
  slaepande_nn_1_1_N : N ;
  slaeppande_nn_1_1_N : N ;
  slaetande_nn_1_1_N : N ;
  slaetrakande_nn_1_1_N : N ;
  slaetslipande_nn_1_1_N : N ;
  slaaende_nn_1_1_N : N ;
  slaattande_nn_1_1_N : N ;
  sloeande_nn_1_1_N : N ;
  sloejdande_nn_1_1_N : N ;
  sloerande_nn_1_1_N : N ;
  sloesande_nn_1_1_N : N ;
  sloetittande_nn_1_1_N : N ;
  smackande_nn_1_N : N ;
  smakande_nn_1_N : N ;
  smaksinne_nn_1_N : N ;
  smaksaettande_nn_1_1_N : N ;
  smakaemne_nn_1_1_N : N ;
  smalfilmande_nn_1_N : N ;
  smalnande_nn_1_N : N ;
  smarrande_nn_1_N : N ;
  smashande_nn_1_N : N ;
  smaskande_nn_1_N : N ;
  smattrande_nn_1_N : N ;
  smekande_nn_1_N : N ;
  smetande_nn_1_N : N ;
  smickrande_nn_1_N : N ;
  smidande_nn_1_N : N ;
  smide_nn_1_N : N ;
  smidjebaelte_nn_1_1_N : N ;
  smilande_nn_1_N : N ;
  sminkande_nn_1_N : N ;
  smiskande_nn_1_N : N ;
  smitande_nn_1_N : N ;
  smittande_nn_1_N : N ;
  smittaemne_nn_1_1_N : N ;
  smockande_nn_1_N : N ;
  smsande_nn_1_N : N ;
  smugglande_nn_1_N : N ;
  smulande_nn_1_N : N ;
  smultande_nn_1_N : N ;
  smultronstaelle_nn_1_1_N : N ;
  smusslande_nn_1_N : N ;
  smutsande_nn_1_N : N ;
  smutskastande_nn_1_N : N ;
  smuttande_nn_1_N : N ;
  smyckande_nn_1_N : N ;
  smycke_nn_1_N : N ;
  smygande_nn_1_N : N ;
  smygfilmande_nn_1_N : N ;
  smyglyssnande_nn_1_N : N ;
  smygsupande_nn_1_N : N ;
  smygtittande_nn_1_N : N ;
  smygaetande_nn_1_1_N : N ;
  smaeckande_nn_1_1_N : N ;
  smaedande_nn_1_1_N : N ;
  smaektande_nn_1_1_N : N ;
  smaellande_nn_1_1_N : N ;
  smaeltande_nn_1_1_N : N ;
  smaertande_nn_1_1_N : N ;
  smaertsinne_nn_1_1_N : N ;
  smaettande_nn_1_1_N : N ;
  smaaflinande_nn_1_1_N : N ;
  smaagraelande_nn_1_1_N : N ;
  smaaleende_nn_1_1_N : N ;
  smaapratande_nn_1_1_N : N ;
  smaasjungande_nn_1_1_N : N ;
  smaasovande_nn_1_1_N : N ;
  smaaspringande_nn_1_1_N : N ;
  smaasvaerande_nn_1_1_N : N ;
  smoerande_nn_1_1_N : N ;
  smoerfraesande_nn_1_1_N : N ;
  smoerjande_nn_1_1_N : N ;
  snabbfrysande_nn_1_N : N ;
  snabbgranskande_nn_1_N : N ;
  snabbspolande_nn_1_N : N ;
  snabbspaenne_nn_1_1_N : N ;
  snabbtecknande_nn_1_N : N ;
  snabbutredande_nn_1_N : N ;
  snackande_nn_1_N : N ;
  snaggande_nn_1_N : N ;
  snappande_nn_1_N : N ;
  snapsande_nn_1_N : N ;
  snarande_nn_1_N : N ;
  snarkande_nn_1_N : N ;
  snarpande_nn_1_N : N ;
  snarrande_nn_1_N : N ;
  snaskande_nn_1_N : N ;
  snattande_nn_1_N : N ;
  snattrande_nn_1_N : N ;
  snavande_nn_1_N : N ;
  sneddande_nn_1_N : N ;
  snedparkerande_nn_1_N : N ;
  snedrekryterande_nn_1_N : N ;
  snedstaellande_nn_1_1_N : N ;
  snedvridande_nn_1_N : N ;
  sneglande_nn_1_N : N ;
  snickarbaelte_nn_1_1_N : N ;
  snickarfoerklaede_nn_1_1_N : N ;
  snickrande_nn_1_N : N ;
  snidande_nn_1_N : N ;
  sniffande_nn_1_N : N ;
  snikande_nn_1_N : N ;
  snille_nn_1_N : N ;
  snirklande_nn_1_N : N ;
  snitsande_nn_1_N : N ;
  snitslande_nn_1_N : N ;
  snittande_nn_1_N : N ;
  snobbande_nn_1_N : N ;
  snoende_nn_1_N : N ;
  snokande_nn_1_N : N ;
  snoppande_nn_1_N : N ;
  snorande_nn_1_N : N ;
  snorklande_nn_1_N : N ;
  snortande_nn_1_N : N ;
  snubbande_nn_1_N : N ;
  snubblande_nn_1_N : N ;
  snuddande_nn_1_N : N ;
  snurrande_nn_1_N : N ;
  snusande_nn_1_N : N ;
  snuskande_nn_1_N : N ;
  snusmalande_nn_1_N : N ;
  snuvande_nn_1_N : N ;
  snyftande_nn_1_N : N ;
  snyltande_nn_1_N : N ;
  snytande_nn_1_N : N ;
  snyte_nn_1_N : N ;
  snaeppande_nn_1_1_N : N ;
  snaerjande_nn_1_1_N : N ;
  snaerje_nn_1_1_N : N ;
  snaerpande_nn_1_1_N : N ;
  snaertande_nn_1_1_N : N ;
  snaesande_nn_1_1_N : N ;
  snaevande_nn_1_1_N : N ;
  snaalande_nn_1_1_N : N ;
  snoeande_nn_1_1_N : N ;
  snoebraede_nn_1_1_N : N ;
  snoemulande_nn_1_1_N : N ;
  snoepande_nn_1_1_N : N ;
  snoeplogande_nn_1_1_N : N ;
  snoerande_nn_1_1_N : N ;
  snoere_nn_1_1_N : N ;
  snoerpande_nn_1_1_N : N ;
  snoervlande_nn_1_1_N : N ;
  snoetaecke_nn_1_1_N : N ;
  socialarbete_nn_1_N : N ;
  socialiserande_nn_1_N : N ;
  sockersaltande_nn_1_N : N ;
  sockrande_nn_1_N : N ;
  sodomsaepple_nn_1_1_N : N ;
  soffsurfande_nn_1_N : N ;
  sol_och_vaarande_nn_1_1_N : N ;
  solande_nn_1_N : N ;
  solbadande_nn_1_N : N ;
  solkande_nn_1_N : N ;
  solochvaarande_nn_1_1_N : N ;
  soltorkande_nn_1_N : N ;
  solvande_nn_1_N : N ;
  solverande_nn_1_N : N ;
  sommarnoeje_nn_1_1_N : N ;
  sommarstaelle_nn_1_1_N : N ;
  somnande_nn_1_N : N ;
  sonande_nn_1_N : N ;
  sonderande_nn_1_N : N ;
  sondmatande_nn_1_N : N ;
  sopande_nn_1_N : N ;
  sopbaelte_nn_1_1_N : N ;
  sordinerande_nn_1_N : N ;
  sorgearbete_nn_1_N : N ;
  sorgeaemne_nn_1_1_N : N ;
  sorlande_nn_1_N : N ;
  sorterande_nn_1_N : N ;
  sotande_nn_1_N : N ;
  soulagerande_nn_1_N : N ;
  sovande_nn_1_N : N ;
  sovjetiserande_nn_1_N : N ;
  sovrande_nn_1_N : N ;
  spacklande_nn_1_N : N ;
  spadvaendande_nn_1_1_N : N ;
  spakande_nn_1_N : N ;
  spaknande_nn_1_N : N ;
  spaljerande_nn_1_N : N ;
  spallerande_nn_1_N : N ;
  spaltande_nn_1_N : N ;
  spanande_nn_1_N : N ;
  spankulerande_nn_1_N : N ;
  spanskvaelde_nn_1_1_N : N ;
  sparande_nn_1_N : N ;
  sparkande_nn_1_N : N ;
  sparrande_nn_1_N : N ;
  spatserande_nn_1_N : N ;
  specialarbete_nn_1_N : N ;
  specialintresse_nn_1_N : N ;
  specialiserande_nn_1_N : N ;
  specialomraade_nn_1_1_N : N ;
  specificerande_nn_1_N : N ;
  speciminerande_nn_1_N : N ;
  speglande_nn_1_N : N ;
  spejande_nn_1_N : N ;
  spekulerande_nn_1_N : N ;
  spelande_nn_1_N : N ;
  spelarbyte_nn_1_N : N ;
  spenderande_nn_1_N : N ;
  spetande_nn_1_N : N ;
  spetsande_nn_1_N : N ;
  spettande_nn_1_N : N ;
  spexande_nn_1_N : N ;
  spikande_nn_1_N : N ;
  spilande_nn_1_N : N ;
  spillande_nn_1_N : N ;
  spinnande_nn_1_N : N ;
  spionerande_nn_1_N : N ;
  spirande_nn_1_N : N ;
  spisande_nn_1_N : N ;
  spjaelande_nn_1_1_N : N ;
  spjaelkande_nn_1_1_N : N ;
  spjaellsnoere_nn_1_1_N : N ;
  spjaernande_nn_1_1_N : N ;
  splintande_nn_1_N : N ;
  splissande_nn_1_N : N ;
  splitsande_nn_1_N : N ;
  splittrande_nn_1_N : N ;
  spolande_nn_1_N : N ;
  spolierande_nn_1_N : N ;
  sponsrande_nn_1_N : N ;
  spontande_nn_1_N : N ;
  sporgoemme_nn_1_1_N : N ;
  sporrande_nn_1_N : N ;
  sportande_nn_1_N : N ;
  spottande_nn_1_N : N ;
  sprakande_nn_1_N : N ;
  sprallande_nn_1_N : N ;
  sprattlande_nn_1_N : N ;
  sprayande_nn_1_N : N ;
  spraymunstycke_nn_1_N : N ;
  sprejande_nn_1_N : N ;
  sprejmunstycke_nn_1_N : N ;
  spretande_nn_1_N : N ;
  sprickande_nn_1_N : N ;
  spridande_nn_1_N : N ;
  springande_nn_1_N : N ;
  sprintande_nn_1_N : N ;
  spritande_nn_1_N : N ;
  spritsande_nn_1_N : N ;
  sprittande_nn_1_N : N ;
  sprudlande_nn_1_N : N ;
  sprutande_nn_1_N : N ;
  sprutbyte_nn_1_N : N ;
  sprutlackerande_nn_1_N : N ;
  sprutmaalande_nn_1_1_N : N ;
  spraeckande_nn_1_1_N : N ;
  spraengande_nn_1_1_N : N ;
  spraengarbete_nn_1_1_N : N ;
  spraengningsarbete_nn_1_1_N : N ;
  spraengaemne_nn_1_1_N : N ;
  spraettande_nn_1_1_N : N ;
  spraakande_nn_1_1_N : N ;
  spraakbyte_nn_1_1_N : N ;
  spraakmoete_nn_1_1_N : N ;
  sproetande_nn_1_1_N : N ;
  spurtande_nn_1_N : N ;
  spyende_nn_1_N : N ;
  spaeckande_nn_1_1_N : N ;
  spaedande_nn_1_1_N : N ;
  spaekande_nn_1_1_N : N ;
  spaennande_nn_1_1_N : N ;
  spaenne_nn_1_1_N : N ;
  spaenstande_nn_1_1_N : N ;
  spaentande_nn_1_1_N : N ;
  spaerrande_nn_1_1_N : N ;
  spaaende_nn_1_1_N : N ;
  spaanande_nn_1_1_N : N ;
  spaangande_nn_1_1_N : N ;
  spaantande_nn_1_1_N : N ;
  spaaraemne_nn_1_1_N : N ;
  spoeande_nn_1_1_N : N ;
  spoekande_nn_1_1_N : N ;
  spoeke_nn_1_1_N : N ;
  spoerjande_nn_1_1_N : N ;
  stabiliserande_nn_1_N : N ;
  stackande_nn_1_N : N ;
  stadfaestande_nn_1_1_N : N ;
  stadgande_nn_1_N : N ;
  stadsplanerande_nn_1_N : N ;
  stadvaendande_nn_1_1_N : N ;
  stafferande_nn_1_N : N ;
  stagande_nn_1_N : N ;
  stagnerande_nn_1_N : N ;
  stagvaendande_nn_1_1_N : N ;
  stakande_nn_1_N : N ;
  stalkande_nn_1_N : N ;
  stallande_nn_1_N : N ;
  stammande_nn_1_N : N ;
  stampande_nn_1_N : N ;
  stamsamhaelle_nn_1_1_N : N ;
  standardiserande_nn_1_N : N ;
  stannande_nn_1_N : N ;
  stansande_nn_1_N : N ;
  staplande_nn_1_N : N ;
  stapplande_nn_1_N : N ;
  starrbligande_nn_1_N : N ;
  startande_nn_1_N : N ;
  startsnoere_nn_1_1_N : N ;
  stassande_nn_1_N : N ;
  staterande_nn_1_N : N ;
  stationerande_nn_1_N : N ;
  stationssamhaelle_nn_1_1_N : N ;
  statsbygge_nn_1_N : N ;
  statuerande_nn_1_N : N ;
  stavande_nn_1_N : N ;
  stegande_nn_1_N : N ;
  steglande_nn_1_N : N ;
  stegrande_nn_1_N : N ;
  stekande_nn_1_N : N ;
  stelnande_nn_1_N : N ;
  stenande_nn_1_N : N ;
  stenansikte_nn_1_N : N ;
  stencilerande_nn_1_N : N ;
  stenkastande_nn_1_N : N ;
  stenograferande_nn_1_N : N ;
  stenroese_nn_1_1_N : N ;
  steppande_nn_1_N : N ;
  stereofotograferande_nn_1_N : N ;
  stereotyperande_nn_1_N : N ;
  steriliserande_nn_1_N : N ;
  stickande_nn_1_N : N ;
  stiftande_nn_1_N : N ;
  stigande_nn_1_N : N ;
  stigmatiserande_nn_1_N : N ;
  stilande_nn_1_N : N ;
  stiliserande_nn_1_N : N ;
  stillande_nn_1_N : N ;
  stillnande_nn_1_N : N ;
  stimmande_nn_1_N : N ;
  stimulerande_nn_1_N : N ;
  stingande_nn_1_N : N ;
  stinkande_nn_1_N : N ;
  stipendierande_nn_1_N : N ;
  stipulerande_nn_1_N : N ;
  stirrande_nn_1_N : N ;
  stjaelande_nn_1_1_N : N ;
  stjaelpande_nn_1_1_N : N ;
  stockande_nn_1_N : N ;
  stofferande_nn_1_N : N ;
  stojande_nn_1_N : N ;
  stolpande_nn_1_N : N ;
  stoltserande_nn_1_N : N ;
  stomatolleende_nn_1_N : N ;
  stoppande_nn_1_N : N ;
  storebrorssamhaelle_nn_1_1_N : N ;
  storfurstendoeme_nn_1_1_N : N ;
  storgraatande_nn_1_1_N : N ;
  storhandlande_nn_1_N : N ;
  storhetsvansinne_nn_1_N : N ;
  storknande_nn_1_N : N ;
  stormaktsvaelde_nn_1_1_N : N ;
  stormande_nn_1_N : N ;
  stormskaellande_nn_1_1_N : N ;
  stormsaekrande_nn_1_1_N : N ;
  stormoete_nn_1_1_N : N ;
  storsatsande_nn_1_N : N ;
  straffande_nn_1_N : N ;
  straffarbete_nn_1_N : N ;
  straffomraade_nn_1_1_N : N ;
  straffoerelaeggande_nn_1_1_N : N ;
  stramande_nn_1_N : N ;
  strandande_nn_1_N : N ;
  strandsaettande_nn_1_1_N : N ;
  strangulerande_nn_1_N : N ;
  stratifierande_nn_1_N : N ;
  streakande_nn_1_N : N ;
  streckande_nn_1_N : N ;
  strejkande_nn_1_N : N ;
  stressande_nn_1_N : N ;
  stretande_nn_1_N : N ;
  stretchande_nn_1_N : N ;
  stridande_nn_1_N : N ;
  stridsformerande_nn_1_N : N ;
  stridsgrupperande_nn_1_N : N ;
  stridsaepple_nn_1_1_N : N ;
  striglande_nn_1_N : N ;
  strilande_nn_1_N : N ;
  strimlande_nn_1_N : N ;
  stripande_nn_1_N : N ;
  strippande_nn_1_N : N ;
  strosande_nn_1_N : N ;
  strukturerande_nn_1_N : N ;
  strukturrationaliserande_nn_1_N : N ;
  strulande_nn_1_N : N ;
  struntande_nn_1_N : N ;
  struttande_nn_1_N : N ;
  strykande_nn_1_N : N ;
  strykbraede_nn_1_1_N : N ;
  strypande_nn_1_N : N ;
  strypmaerke_nn_1_1_N : N ;
  straeckande_nn_1_1_N : N ;
  straecklaesande_nn_1_1_N : N ;
  straengande_nn_1_1_N : N ;
  straevande_nn_1_1_N : N ;
  straalande_nn_1_1_N : N ;
  straalknippe_nn_1_1_N : N ;
  straalkonserverande_nn_1_1_N : N ;
  straalningsarbete_nn_1_1_N : N ;
  straalningsbaelte_nn_1_1_N : N ;
  straalskyddsarbete_nn_1_1_N : N ;
  stroeende_nn_1_1_N : N ;
  stroemmande_nn_1_1_N : N ;
  stroepplande_nn_1_1_N : N ;
  stroevande_nn_1_1_N : N ;
  stroevomraade_nn_1_1_N : N ;
  stubbande_nn_1_N : N ;
  studentfirande_nn_1_N : N ;
  studentinflytande_nn_1_N : N ;
  studerande_nn_2_N : N ;
  studieorienterande_nn_1_N : N ;
  studsande_nn_1_N : N ;
  stukande_nn_1_N : N ;
  stultande_nn_1_N : N ;
  stundande_nn_1_N : N ;
  stupande_nn_1_N : N ;
  sturande_nn_1_N : N ;
  stuvande_nn_1_N : N ;
  styckande_nn_1_N : N ;
  stycke_nn_1_N : N ;
  styltande_nn_1_N : N ;
  stympande_nn_1_N : N ;
  styrande_nn_1_N : N ;
  styre_nn_1_N : N ;
  styre_nn_2_N : N ;
  styrkande_nn_1_N : N ;
  styrkefoerhaallande_nn_1_1_N : N ;
  styvande_nn_1_N : N ;
  styvnande_nn_1_N : N ;
  staeckande_nn_1_1_N : N ;
  staedande_nn_1_1_N : N ;
  staedjande_nn_1_1_N : N ;
  staedslande_nn_1_1_N : N ;
  staellande_nn_1_1_N : N ;
  staelle_nn_1_1_N : N ;
  staellningstagande_nn_1_1_N : N ;
  staemmande_nn_1_1_N : N ;
  staemningslaege_nn_1_1_N : N ;
  staemplande_nn_1_1_N : N ;
  staengande_nn_1_1_N : N ;
  staenge_nn_1_1_N : N ;
  staengslande_nn_1_1_N : N ;
  staenkande_nn_1_1_N : N ;
  staerkande_nn_1_1_N : N ;
  staevande_nn_1_1_N : N ;
  staevjande_nn_1_1_N : N ;
  staaende_nn_1_1_N : N ;
  staandande_nn_1_1_N : N ;
  staangande_nn_1_1_N : N ;
  staankande_nn_1_1_N : N ;
  staatande_nn_1_1_N : N ;
  stoedboende_nn_1_1_N : N ;
  stoedjande_nn_1_1_N : N ;
  stoedkoepande_nn_1_1_N : N ;
  stoedomraade_nn_1_1_N : N ;
  stoedroestande_nn_1_1_N : N ;
  stoekande_nn_1_1_N : N ;
  stoenande_nn_1_1_N : N ;
  stoepande_nn_1_1_N : N ;
  stoepplande_nn_1_1_N : N ;
  stoerande_nn_1_1_N : N ;
  stoertande_nn_1_1_N : N ;
  stoetande_nn_1_1_N : N ;
  stoettande_nn_1_1_N : N ;
  stoevlande_nn_1_1_N : N ;
  sublimerande_nn_1_N : N ;
  subordinerande_nn_1_N : N ;
  subsidierande_nn_1_N : N ;
  subskriberande_nn_1_N : N ;
  substantiverande_nn_1_N : N ;
  substituerande_nn_1_N : N ;
  subsumerande_nn_1_N : N ;
  subtraherande_nn_1_N : N ;
  subventionerande_nn_1_N : N ;
  succederande_nn_1_N : N ;
  suckande_nn_1_N : N ;
  suddande_nn_1_N : N ;
  suffigerande_nn_1_N : N ;
  sufflerande_nn_1_N : N ;
  sugande_nn_1_N : N ;
  suggererande_nn_1_N : N ;
  suktande_nn_1_N : N ;
  sulande_nn_1_N : N ;
  summande_nn_1_N : N ;
  summerande_nn_1_N : N ;
  sumpande_nn_1_N : N ;
  sumpomraade_nn_1_1_N : N ;
  supande_nn_1_N : N ;
  superande_nn_1_N : N ;
  supplerande_nn_1_N : N ;
  supponerande_nn_1_N : N ;
  suppurerande_nn_1_N : N ;
  surande_nn_1_N : N ;
  surfande_nn_1_N : N ;
  surfbraede_nn_1_1_N : N ;
  surfingbraede_nn_1_1_N : N ;
  surnande_nn_1_N : N ;
  surrande_nn_1_N : N ;
  susande_nn_1_N : N ;
  suspenderande_nn_1_N : N ;
  sussande_nn_1_N : N ;
  svabbande_nn_1_N : N ;
  svajande_nn_1_N : N ;
  svalkande_nn_1_N : N ;
  svallande_nn_1_N : N ;
  svalnande_nn_1_N : N ;
  svamlande_nn_1_N : N ;
  svankande_nn_1_N : N ;
  svansande_nn_1_N : N ;
  svarande_nn_2_N : N ;
  svartbygge_nn_1_N : N ;
  svartlistande_nn_1_N : N ;
  svartnande_nn_1_N : N ;
  svarvande_nn_1_N : N ;
  svassande_nn_1_N : N ;
  svavlande_nn_1_N : N ;
  svedande_nn_1_N : N ;
  svedjande_nn_1_N : N ;
  svepande_nn_1_N : N ;
  svepe_nn_1_N : N ;
  svetsande_nn_1_N : N ;
  svettande_nn_1_N : N ;
  svidande_nn_1_N : N ;
  svikande_nn_1_N : N ;
  sviktande_nn_1_N : N ;
  svimmande_nn_1_N : N ;
  svindlande_nn_1_N : N ;
  svingande_nn_1_N : N ;
  svinnande_nn_1_N : N ;
  svirande_nn_1_N : N ;
  svirrande_nn_1_N : N ;
  svischande_nn_1_N : N ;
  svullnande_nn_1_N : N ;
  svaeljande_nn_1_1_N : N ;
  svaellande_nn_1_1_N : N ;
  svaeltande_nn_1_1_N : N ;
  svaengande_nn_1_1_N : N ;
  svaerande_nn_1_1_N : N ;
  svaerdfaeste_nn_1_1_N : N ;
  svaermande_nn_1_1_N : N ;
  svaertande_nn_1_1_N : N ;
  svaevande_nn_1_1_N : N ;
  swingande_nn_1_N : N ;
  syende_nn_1_N : N ;
  syftande_nn_1_N : N ;
  syfte_nn_1_N : N ;
  syltande_nn_1_N : N ;
  symboliserande_nn_1_N : N ;
  symbolvaerde_nn_1_1_N : N ;
  sympatiserande_nn_1_N : N ;
  synande_nn_1_N : N ;
  syndande_nn_1_N : N ;
  synkande_nn_1_N : N ;
  synkoperande_nn_1_N : N ;
  synkroniserande_nn_1_N : N ;
  synsinne_nn_1_N : N ;
  syntetiserande_nn_1_N : N ;
  syrande_nn_1_N : N ;
  syrsaettande_nn_1_1_N : N ;
  sysselsaettande_nn_1_1_N : N ;
  sysslande_nn_1_N : N ;
  systematiserande_nn_1_N : N ;
  systemerande_nn_1_N : N ;
  systemskifte_nn_1_N : N ;
  saeckande_nn_1_1_N : N ;
  saede_nn_1_1_N : N ;
  saegande_nn_1_1_N : N ;
  saekerhetsarbete_nn_1_1_N : N ;
  saekerhetsbaelte_nn_1_1_N : N ;
  saekerhetslaege_nn_1_1_N : N ;
  saekerhetssele_nn_1_1_N : N ;
  saekerstaellande_nn_1_1_N : N ;
  saekrande_nn_1_1_N : N ;
  saelghaenge_nn_1_1_N : N ;
  saeljande_nn_1_1_N : N ;
  saellskapande_nn_1_1_N : N ;
  saellskapsnoeje_nn_1_1_N : N ;
  saemskande_nn_1_1_N : N ;
  saemskgarvande_nn_1_1_N : N ;
  saendande_nn_1_1_N : N ;
  saengfoerhaenge_nn_1_1_N : N ;
  saengkammarregemente_nn_1_1_N : N ;
  saengroekande_nn_1_1_N : N ;
  saenkande_nn_1_1_N : N ;
  saenke_nn_1_1_N : N ;
  saerande_nn_1_1_N : N ;
  saerartstaenkande_nn_1_1_N : N ;
  saerbehandlande_nn_1_1_N : N ;
  saerbeskattande_nn_1_1_N : N ;
  saerintresse_nn_1_1_N : N ;
  saermaerke_nn_1_1_N : N ;
  saerskiljande_nn_1_1_N : N ;
  saete_nn_1_1_N : N ;
  saettande_nn_1_1_N : N ;
  saaende_nn_1_1_N : N ;
  saagande_nn_1_1_N : N ;
  saallande_nn_1_1_N : N ;
  saapande_nn_1_1_N : N ;
  saarande_nn_1_1_N : N ;
  saasande_nn_1_1_N : N ;
  saatande_nn_1_1_N : N ;
  saaterande_nn_1_1_N : N ;
  saaverande_nn_1_1_N : N ;
  soekande_nn_2_1_N : N ;
  soelande_nn_1_1_N : N ;
  soemmande_nn_1_1_N : N ;
  soenderdelande_nn_1_1_N : N ;
  soenderfallande_nn_1_1_N : N ;
  soenderhackande_nn_1_1_N : N ;
  soenderrivande_nn_1_1_N : N ;
  soenderspraengande_nn_1_1_N : N ;
  soendrande_nn_1_1_N : N ;
  soerjande_nn_1_1_N : N ;
  soerplande_nn_1_1_N : N ;
  soetande_nn_1_1_N : N ;
  soevande_nn_1_1_N : N ;
  tabellerande_nn_1_N : N ;
  tabuerande_nn_1_N : N ;
  tabulerande_nn_1_N : N ;
  tackande_nn_1_N : N ;
  tacklande_nn_1_N : N ;
  tadlande_nn_1_N : N ;
  tafflande_nn_1_N : N ;
  tafsande_nn_1_N : N ;
  tagande_nn_1_N : N ;
  taggande_nn_1_N : N ;
  taglande_nn_1_N : N ;
  tajmande_nn_1_N : N ;
  takraecke_nn_1_1_N : N ;
  takroeste_nn_1_1_N : N ;
  takterande_nn_1_N : N ;
  talande_nn_1_N : N ;
  talfoerhaallande_nn_1_1_N : N ;
  talgande_nn_1_N : N ;
  talkande_nn_1_N : N ;
  tallande_nn_1_N : N ;
  tamponerande_nn_1_N : N ;
  tandande_nn_1_N : N ;
  tangerande_nn_1_N : N ;
  tankande_nn_1_N : N ;
  tankearbete_nn_1_N : N ;
  tankeutbyte_nn_1_N : N ;
  tankstaelle_nn_1_1_N : N ;
  tapetserande_nn_1_N : N ;
  tappande_nn_1_N : N ;
  tarerande_nn_1_N : N ;
  tarifferande_nn_1_N : N ;
  tarvande_nn_1_N : N ;
  tassande_nn_1_N : N ;
  tasslande_nn_1_N : N ;
  tatuerande_nn_1_N : N ;
  taxande_nn_1_N : N ;
  taxeomraade_nn_1_1_N : N ;
  taxerande_nn_1_N : N ;
  taxeringsvaerde_nn_1_1_N : N ;
  teaterstycke_nn_1_N : N ;
  tecknande_nn_1_N : N ;
  tejpande_nn_1_N : N ;
  tekande_nn_1_N : N ;
  teknifierande_nn_1_N : N ;
  teknikkunnande_nn_1_N : N ;
  telefonerande_nn_1_N : N ;
  telefonsvararmeddelande_nn_1_N : N ;
  telegraferande_nn_1_N : N ;
  televiserande_nn_1_N : N ;
  tempande_nn_1_N : N ;
  temperande_nn_1_N : N ;
  temperaturfoerhaallande_nn_1_1_N : N ;
  temperaturomraade_nn_1_1_N : N ;
  tempererande_nn_1_N : N ;
  tempoarbete_nn_1_N : N ;
  tenderande_nn_1_N : N ;
  tentamenslaesande_nn_1_1_N : N ;
  tentande_nn_1_N : N ;
  tenterande_nn_1_N : N ;
  teoretiserande_nn_1_N : N ;
  terrasserande_nn_1_N : N ;
  terroriserande_nn_1_N : N ;
  tesaurerande_nn_1_N : N ;
  testamente_nn_1_N : N ;
  testamenterande_nn_1_N : N ;
  testande_nn_1_N : N ;
  testvaerde_nn_1_1_N : N ;
  tevetittande_nn_1_N : N ;
  textande_nn_1_N : N ;
  textstycke_nn_1_N : N ;
  tickande_nn_1_N : N ;
  tidfaestande_nn_1_1_N : N ;
  tidigarelaeggande_nn_1_1_N : N ;
  tidsbegraensande_nn_1_1_N : N ;
  tidsbestaemmande_nn_1_1_N : N ;
  tidsfoerhaallande_nn_1_1_N : N ;
  tidsmedvetande_nn_1_N : N ;
  tidsskede_nn_1_N : N ;
  tigande_nn_1_N : N ;
  tiggande_nn_1_N : N ;
  tillagande_nn_1_N : N ;
  tillbakavisande_nn_1_N : N ;
  tillbedjande_nn_1_N : N ;
  tillblandande_nn_1_N : N ;
  tillbringande_nn_1_N : N ;
  tilldelande_nn_1_N : N ;
  tilldoemande_nn_1_1_N : N ;
  tillerkaennande_nn_1_1_N : N ;
  tillfallande_nn_1_N : N ;
  tillfloede_nn_1_1_N : N ;
  tillfogande_nn_1_N : N ;
  tillfredsstaellande_nn_1_1_N : N ;
  tillfrysande_nn_1_N : N ;
  tillfraagande_nn_1_1_N : N ;
  tillfaelle_nn_1_1_N : N ;
  tillfaellighetsarbete_nn_1_1_N : N ;
  tillfaangatagande_nn_1_1_N : N ;
  tillfoerande_nn_1_1_N : N ;
  tillfoersaekrande_nn_1_1_N : N ;
  tillgivande_nn_1_N : N ;
  tillgodohavande_nn_1_N : N ;
  tillgodoraeknande_nn_1_1_N : N ;
  tillgodoseende_nn_1_N : N ;
  tillgripande_nn_1_N : N ;
  tillgaaende_nn_1_1_N : N ;
  tillhandahaallande_nn_1_1_N : N ;
  tillhygge_nn_1_N : N ;
  tillhaallande_nn_1_1_N : N ;
  tillhoerande_nn_1_1_N : N ;
  tillintetgoerande_nn_1_1_N : N ;
  tillkallande_nn_1_N : N ;
  tillkommande_nn_1_N : N ;
  tillkopplande_nn_1_N : N ;
  tillkortakommande_nn_1_N : N ;
  tillkaennagivande_nn_1_1_N : N ;
  tillmaele_nn_1_1_N : N ;
  tillmaetande_nn_1_1_N : N ;
  tillpassande_nn_1_N : N ;
  tillplattande_nn_1_N : N ;
  tillrande_nn_1_N : N ;
  tillredande_nn_1_N : N ;
  tillryggalaeggande_nn_1_1_N : N ;
  tillraeknande_nn_1_1_N : N ;
  tillraettalaeggande_nn_1_1_N : N ;
  tillraettavisande_nn_1_1_N : N ;
  tillraadande_nn_1_1_N : N ;
  tillsatsaemne_nn_1_1_N : N ;
  tillseende_nn_1_N : N ;
  tillskapande_nn_1_N : N ;
  tillskjutande_nn_1_N : N ;
  tillskrivande_nn_1_N : N ;
  tillskyndande_nn_1_N : N ;
  tillskaerande_nn_1_1_N : N ;
  tillslutande_nn_1_N : N ;
  tillspetsande_nn_1_N : N ;
  tillspillogivande_nn_1_N : N ;
  tillstroemmande_nn_1_1_N : N ;
  tillstundande_nn_1_N : N ;
  tillstyrkande_nn_1_N : N ;
  tillstaedjande_nn_1_1_N : N ;
  tillstaellande_nn_1_1_N : N ;
  tillstaaende_nn_1_1_N : N ;
  tillstoetande_nn_1_1_N : N ;
  tillsvidarefoerordnande_nn_1_1_N : N ;
  tillsaegande_nn_1_1_N : N ;
  tillsaettande_nn_1_1_N : N ;
  tillsaettningsaerende_nn_1_1_N : N ;
  tilltalande_nn_1_N : N ;
  tilltroende_nn_1_N : N ;
  tilltraedande_nn_1_1_N : N ;
  tilltraede_nn_1_1_N : N ;
  tilltygande_nn_1_N : N ;
  tilltaeppande_nn_1_1_N : N ;
  tillvalsaemne_nn_1_1_N : N ;
  tillvaratagande_nn_1_N : N ;
  tillverkande_nn_1_N : N ;
  tillvitande_nn_1_N : N ;
  tillvaegabringande_nn_1_1_N : N ;
  tillvaenjande_nn_1_1_N : N ;
  tillvaexande_nn_1_1_N : N ;
  tillvaextaemne_nn_1_1_N : N ;
  tillyxande_nn_1_N : N ;
  tillaeggande_nn_1_1_N : N ;
  tillaegnande_nn_1_1_N : N ;
  tillaemnande_nn_1_1_N : N ;
  tillaempande_nn_1_1_N : N ;
  tillaatande_nn_1_1_N : N ;
  tilloenskande_nn_1_1_N : N ;
  tiltande_nn_1_N : N ;
  timande_nn_1_N : N ;
  timarvode_nn_1_N : N ;
  timrande_nn_1_N : N ;
  tinande_nn_1_N : N ;
  tindrande_nn_1_N : N ;
  tingande_nn_1_N : N ;
  tiodubblande_nn_1_N : N ;
  tiofaldigande_nn_1_N : N ;
  tippande_nn_1_N : N ;
  tipsande_nn_1_N : N ;
  tirande_nn_1_N : N ;
  tisslande_nn_1_N : N ;
  titrerande_nn_1_N : N ;
  tittande_nn_1_N : N ;
  titulerande_nn_1_N : N ;
  tjackande_nn_1_N : N ;
  tjafsande_nn_1_N : N ;
  tjallande_nn_1_N : N ;
  tjatande_nn_1_N : N ;
  tjattrande_nn_1_N : N ;
  tjillande_nn_1_N : N ;
  tjimmande_nn_1_N : N ;
  tjingande_nn_1_N : N ;
  tjoande_nn_1_N : N ;
  tjocknande_nn_1_N : N ;
  tjongande_nn_1_N : N ;
  tjorvande_nn_1_N : N ;
  tjudrande_nn_1_N : N ;
  tjugofaldigande_nn_1_N : N ;
  tjurande_nn_1_N : N ;
  tjusande_nn_1_N : N ;
  tjutande_nn_1_N : N ;
  tjuvande_nn_1_N : N ;
  tjuvhaallande_nn_1_1_N : N ;
  tjuvkopplande_nn_1_N : N ;
  tjuvlyssnande_nn_1_N : N ;
  tjuvmjoelkande_nn_1_1_N : N ;
  tjuvsamhaelle_nn_1_1_N : N ;
  tjuvstartande_nn_1_N : N ;
  tjuvtraenande_nn_1_1_N : N ;
  tjyvande_nn_1_N : N ;
  tjyvhaallande_nn_1_1_N : N ;
  tjyvkopplande_nn_1_N : N ;
  tjyvlyssnande_nn_1_N : N ;
  tjyvmjoelkande_nn_1_1_N : N ;
  tjyvsamhaelle_nn_1_1_N : N ;
  tjyvstartande_nn_1_N : N ;
  tjaelande_nn_1_1_N : N ;
  tjaenande_nn_1_1_N : N ;
  tjaensteaerende_nn_1_1_N : N ;
  tjaenstgoerande_nn_1_1_N : N ;
  tjaerande_nn_1_1_N : N ;
  tockande_nn_1_N : N ;
  tofflande_nn_1_N : N ;
  tolererande_nn_1_N : N ;
  tolkande_nn_1_N : N ;
  tomtande_nn_1_N : N ;
  tomteskrockande_nn_1_N : N ;
  tonande_nn_1_N : N ;
  tonlaege_nn_1_1_N : N ;
  tonomraade_nn_1_1_N : N ;
  tonsaettande_nn_1_1_N : N ;
  toppande_nn_1_N : N ;
  topphuggande_nn_1_N : N ;
  toppmoete_nn_1_1_N : N ;
  toppridande_nn_1_N : N ;
  topsande_nn_1_N : N ;
  tordeende_nn_1_N : N ;
  torderande_nn_1_N : N ;
  torgfoerande_nn_1_1_N : N ;
  torkande_nn_1_N : N ;
  torktumlande_nn_1_N : N ;
  torkaemne_nn_1_1_N : N ;
  tornande_nn_1_N : N ;
  tornerande_nn_1_N : N ;
  torpederande_nn_1_N : N ;
  torrdestillerande_nn_1_N : N ;
  torrhostande_nn_1_N : N ;
  torrkokande_nn_1_N : N ;
  torrlaeggande_nn_1_1_N : N ;
  torrschamponerande_nn_1_N : N ;
  torrslipande_nn_1_N : N ;
  torroekande_nn_1_1_N : N ;
  torskande_nn_1_N : N ;
  torterande_nn_1_N : N ;
  torvande_nn_1_N : N ;
  torvdike_nn_1_N : N ;
  torvtaeckande_nn_1_1_N : N ;
  totalfinansierande_nn_1_N : N ;
  totalfoerbjudande_nn_1_1_N : N ;
  totalfoerlamande_nn_1_1_N : N ;
  totalfoerstoerande_nn_1_1_N : N ;
  totalhavererande_nn_1_N : N ;
  totalvaegrande_nn_1_1_N : N ;
  totalvaerde_nn_1_1_N : N ;
  touchande_nn_1_N : N ;
  toucherande_nn_1_N : N ;
  touperande_nn_1_N : N ;
  tovande_nn_1_N : N ;
  trackande_nn_1_N : N ;
  traderande_nn_1_N : N ;
  trafikerande_nn_1_N : N ;
  trafiklaege_nn_1_1_N : N ;
  trafikmaerke_nn_1_1_N : N ;
  trafikreglerande_nn_1_N : N ;
  tragglande_nn_1_N : N ;
  trajande_nn_1_N : N ;
  trakasserande_nn_1_N : N ;
  traktamente_nn_1_N : N ;
  traktande_nn_1_N : N ;
  trakterande_nn_1_N : N ;
  trakthuggande_nn_1_N : N ;
  trallande_nn_1_N : N ;
  trampande_nn_1_N : N ;
  tramsande_nn_1_N : N ;
  trancherande_nn_1_N : N ;
  transfererande_nn_1_N : N ;
  transformerande_nn_1_N : N ;
  transiterande_nn_1_N : N ;
  transkriberande_nn_1_N : N ;
  translittererande_nn_1_N : N ;
  transmitterande_nn_1_N : N ;
  transmuterande_nn_1_N : N ;
  transpirerande_nn_1_N : N ;
  transplanterande_nn_1_N : N ;
  transponerande_nn_1_N : N ;
  transportberoende_nn_1_N : N ;
  transporterande_nn_1_N : N ;
  transportlaege_nn_1_1_N : N ;
  transumerande_nn_1_N : N ;
  trappraecke_nn_1_1_N : N ;
  trasande_nn_1_N : N ;
  trashande_nn_1_N : N ;
  traskande_nn_1_N : N ;
  trasserande_nn_1_N : N ;
  trasslande_nn_1_N : N ;
  trattande_nn_1_N : N ;
  travande_nn_1_N : N ;
  travesterande_nn_1_N : N ;
  tremulerande_nn_1_N : N ;
  trepanerande_nn_1_N : N ;
  trepunktsbaelte_nn_1_1_N : N ;
  trevande_nn_1_N : N ;
  triangelbyte_nn_1_N : N ;
  triangulerande_nn_1_N : N ;
  tricksande_nn_1_N : N ;
  trierande_nn_1_N : N ;
  triggande_nn_1_N : N ;
  trillande_nn_1_N : N ;
  trimmande_nn_1_N : N ;
  trippande_nn_1_N : N ;
  tripplande_nn_1_N : N ;
  triumferande_nn_1_N : N ;
  trivialiserande_nn_1_N : N ;
  trixande_nn_1_N : N ;
  troende_nn_1_N : N ;
  trohetsloefte_nn_1_1_N : N ;
  trollande_nn_1_N : N ;
  trollbindande_nn_1_N : N ;
  trolovande_nn_1_N : N ;
  trolovningsloefte_nn_1_1_N : N ;
  tronande_nn_1_N : N ;
  tronskifte_nn_1_N : N ;
  trontilltraede_nn_1_1_N : N ;
  troppande_nn_1_N : N ;
  trotsande_nn_1_N : N ;
  trugande_nn_1_N : N ;
  trulande_nn_1_N : N ;
  trumfande_nn_1_N : N ;
  trumlande_nn_1_N : N ;
  trummande_nn_1_N : N ;
  trumminne_nn_1_N : N ;
  trumpetande_nn_1_N : N ;
  trutande_nn_1_N : N ;
  tryckande_nn_1_N : N ;
  trycke_nn_1_N : N ;
  tryckimpregnerande_nn_1_N : N ;
  tryfferande_nn_1_N : N ;
  tryggande_nn_1_N : N ;
  trygghetsboende_nn_1_N : N ;
  trynande_nn_1_N : N ;
  tryne_nn_1_N : N ;
  trytande_nn_1_N : N ;
  traeande_nn_1_1_N : N ;
  traeckande_nn_1_1_N : N ;
  traedande_nn_1_1_N : N ;
  traede_nn_1_1_N : N ;
  traeffande_nn_1_1_N : N ;
  traelande_nn_1_1_N : N ;
  traelarbete_nn_1_1_N : N ;
  traelbindande_nn_1_1_N : N ;
  traenande_nn_1_1_N : N ;
  traengande_nn_1_1_N : N ;
  traengtande_nn_1_1_N : N ;
  traensande_nn_1_1_N : N ;
  traestycke_nn_1_1_N : N ;
  traetande_nn_1_1_N : N ;
  traacklande_nn_1_1_N : N ;
  traadaemne_nn_1_1_N : N ;
  traaende_nn_1_1_N : N ;
  traakande_nn_1_1_N : N ;
  traalande_nn_1_1_N : N ;
  traanande_nn_1_1_N : N ;
  troeghetsnavigerande_nn_1_1_N : N ;
  troeskande_nn_1_1_N : N ;
  troeskelvaerde_nn_1_1_N : N ;
  troestande_nn_1_1_N : N ;
  troettande_nn_1_1_N : N ;
  troettnande_nn_1_1_N : N ;
  tubbande_nn_1_N : N ;
  tudelande_nn_1_N : N ;
  tuffande_nn_1_N : N ;
  tufsande_nn_1_N : N ;
  tuggande_nn_1_N : N ;
  tuktande_nn_1_N : N ;
  tullande_nn_1_N : N ;
  tullbesiktigande_nn_1_N : N ;
  tultande_nn_1_N : N ;
  tumlande_nn_1_N : N ;
  tummande_nn_1_N : N ;
  tungsinne_nn_1_N : N ;
  tungsmycke_nn_1_N : N ;
  tunnande_nn_1_N : N ;
  tunnelbanebygge_nn_1_N : N ;
  tunnelseende_nn_1_N : N ;
  tuperande_nn_1_N : N ;
  turistande_nn_1_N : N ;
  turnerande_nn_1_N : N ;
  tuschande_nn_1_N : N ;
  tuscherande_nn_1_N : N ;
  tusende_nn_1_N : N ;
  tusenaarsrike_nn_1_1_N : N ;
  tussande_nn_1_N : N ;
  tutande_nn_1_N : N ;
  tv_tittande_nn_1_N : N ;
  tvegifte_nn_1_N : N ;
  tvekande_nn_1_N : N ;
  tvinande_nn_1_N : N ;
  tvingande_nn_1_N : N ;
  tvinnande_nn_1_N : N ;
  tvistande_nn_1_N : N ;
  tvisteaemne_nn_1_1_N : N ;
  tvisteaepple_nn_1_1_N : N ;
  tvivlande_nn_1_N : N ;
  tvaerande_nn_1_1_N : N ;
  tvaerbromsande_nn_1_1_N : N ;
  tvaernitande_nn_1_1_N : N ;
  tvaersande_nn_1_1_N : N ;
  tvaerstannande_nn_1_1_N : N ;
  tvaervaendande_nn_1_1_N : N ;
  tvaettande_nn_1_1_N : N ;
  tvaettbraede_nn_1_1_N : N ;
  tvaaende_nn_1_1_N : N ;
  tvaangsarbete_nn_1_1_N : N ;
  tvaangsbaelte_nn_1_1_N : N ;
  tvaangsgifte_nn_1_1_N : N ;
  tvaangsinloesande_nn_1_1_N : N ;
  tvaangskommenderande_nn_1_1_N : N ;
  tvaangslaege_nn_1_1_N : N ;
  tvaangsrekryterande_nn_1_1_N : N ;
  tvaangstatuerande_nn_1_1_N : N ;
  tvaapartsfoerhaallande_nn_1_1_N : N ;
  twistande_nn_1_N : N ;
  twittrande_nn_1_N : N ;
  tyande_nn_1_N : N ;
  tyckande_nn_1_N : N ;
  tycke_nn_1_N : N ;
  tydande_nn_1_N : N ;
  tydliggoerande_nn_1_1_N : N ;
  tyglande_nn_1_N : N ;
  tygstycke_nn_1_N : N ;
  tynande_nn_1_N : N ;
  tyngande_nn_1_N : N ;
  typifierande_nn_1_N : N ;
  typiserande_nn_1_N : N ;
  typvaerde_nn_1_1_N : N ;
  tyranniserande_nn_1_N : N ;
  tystande_nn_1_N : N ;
  tysthetsloefte_nn_1_1_N : N ;
  tystnande_nn_1_N : N ;
  taeckande_nn_1_1_N : N ;
  taeckdikande_nn_1_1_N : N ;
  taeckdike_nn_1_1_N : N ;
  taecke_nn_1_1_N : N ;
  taeljande_nn_1_1_N : N ;
  taeltande_nn_1_1_N : N ;
  taeltmoete_nn_1_1_N : N ;
  taemjande_nn_1_1_N : N ;
  taendande_nn_1_1_N : N ;
  taendaemne_nn_1_1_N : N ;
  taenjande_nn_1_1_N : N ;
  taenkande_nn_1_1_N : N ;
  taerande_nn_1_1_N : N ;
  taernande_nn_1_1_N : N ;
  taetande_nn_1_1_N : N ;
  taetnande_nn_1_1_N : N ;
  taevlande_nn_1_1_N : N ;
  taevlingsseglande_nn_1_1_N : N ;
  taaande_nn_1_1_N : N ;
  taagande_nn_1_1_N : N ;
  taagluffande_nn_1_1_N : N ;
  taalande_nn_1_1_N : N ;
  taarefloede_nn_1_1_N : N ;
  taartande_nn_1_1_N : N ;
  toeande_nn_1_1_N : N ;
  toejande_nn_1_1_N : N ;
  toeltande_nn_1_1_N : N ;
  toemmande_nn_1_1_N : N ;
  toentande_nn_1_1_N : N ;
  toernande_nn_1_1_N : N ;
  toerne_nn_1_1_N : N ;
  toerstande_nn_1_1_N : N ;
  toevande_nn_1_1_N : N ;
  ugglande_nn_1_N : N ;
  ugnsbakande_nn_1_N : N ;
  ugnsgraeddande_nn_1_1_N : N ;
  ugnskokande_nn_1_N : N ;
  ugnsstekande_nn_1_N : N ;
  ugnstorkande_nn_1_N : N ;
  ulkande_nn_1_N : N ;
  ulltaecke_nn_1_1_N : N ;
  ulmande_nn_1_N : N ;
  ultrarapidfotograferande_nn_1_N : N ;
  umbaerande_nn_1_1_N : N ;
  umgaellande_nn_1_1_N : N ;
  umgaenge_nn_1_1_N : N ;
  undangoemmande_nn_1_1_N : N ;
  undanhaallande_nn_1_1_N : N ;
  undanroejande_nn_1_1_N : N ;
  undanskaffande_nn_1_N : N ;
  undanskiftande_nn_1_N : N ;
  undanskymmande_nn_1_N : N ;
  undansnillande_nn_1_N : N ;
  undanstickande_nn_1_N : N ;
  undantagande_nn_1_N : N ;
  undantraengande_nn_1_1_N : N ;
  underanvaendande_nn_1_1_N : N ;
  underarbete_nn_1_N : N ;
  underbalanserande_nn_1_N : N ;
  underbetalande_nn_1_N : N ;
  underbindande_nn_1_N : N ;
  underbjudande_nn_1_N : N ;
  underblaasande_nn_1_1_N : N ;
  underbyggande_nn_1_N : N ;
  underdimensionerande_nn_1_N : N ;
  underdrivande_nn_1_N : N ;
  underexponerande_nn_1_N : N ;
  underfoerstaaende_nn_1_1_N : N ;
  underfoersaekrande_nn_1_1_N : N ;
  undergraevande_nn_1_1_N : N ;
  undergaaende_nn_1_1_N : N ;
  underhandlande_nn_1_N : N ;
  underhaallande_nn_1_1_N : N ;
  underhaallsarbete_nn_1_1_N : N ;
  underjordsarbete_nn_1_N : N ;
  underkastande_nn_1_N : N ;
  underkuvande_nn_1_N : N ;
  underkvistande_nn_1_N : N ;
  underkylande_nn_1_N : N ;
  underkaennande_nn_1_1_N : N ;
  underlappande_nn_1_N : N ;
  underlaettande_nn_1_1_N : N ;
  underlaatande_nn_1_1_N : N ;
  underminerande_nn_1_N : N ;
  underordnande_nn_1_N : N ;
  underrede_nn_1_N : N ;
  underredsbehandlande_nn_1_N : N ;
  underraettande_nn_1_1_N : N ;
  underskattande_nn_1_N : N ;
  underskridande_nn_1_N : N ;
  underslaekte_nn_1_1_N : N ;
  underslaaende_nn_1_1_N : N ;
  understickande_nn_1_N : N ;
  understigande_nn_1_N : N ;
  understreckande_nn_1_N : N ;
  understrykande_nn_1_N : N ;
  understaellande_nn_1_1_N : N ;
  understoedjande_nn_1_1_N : N ;
  undersaeljande_nn_1_1_N : N ;
  undersoekande_nn_1_1_N : N ;
  undertaxerande_nn_1_N : N ;
  undertecknande_nn_1_N : N ;
  undertryckande_nn_1_N : N ;
  undervisande_nn_1_N : N ;
  undervisningsaemne_nn_1_1_N : N ;
  undervaerderande_nn_1_1_N : N ;
  undfallande_nn_1_N : N ;
  undfaegnande_nn_1_1_N : N ;
  undfaaende_nn_1_1_N : N ;
  undgaaende_nn_1_1_N : N ;
  undkommande_nn_1_N : N ;
  undrande_nn_1_N : N ;
  undskyllande_nn_1_N : N ;
  undslippande_nn_1_N : N ;
  undsaettande_nn_1_1_N : N ;
  undulerande_nn_1_N : N ;
  undvarande_nn_1_N : N ;
  undvikande_nn_1_N : N ;
  ungdomsarbete_nn_1_N : N ;
  unifierande_nn_1_N : N ;
  uniformerande_nn_1_N : N ;
  uniformssnoere_nn_1_1_N : N ;
  universalsnille_nn_1_N : N ;
  universitetsaemne_nn_1_1_N : N ;
  unknande_nn_1_N : N ;
  unnande_nn_1_N : N ;
  uppammande_nn_1_N : N ;
  upparbetande_nn_1_N : N ;
  uppassande_nn_1_N : N ;
  uppassningsstaelle_nn_1_1_N : N ;
  uppbjudande_nn_1_N : N ;
  uppblandande_nn_1_N : N ;
  uppbringande_nn_1_N : N ;
  uppbrusande_nn_1_N : N ;
  uppbyggande_nn_1_N : N ;
  uppbyggelsemoete_nn_1_1_N : N ;
  uppbyggnadsskede_nn_1_N : N ;
  uppbaadande_nn_1_1_N : N ;
  uppdagande_nn_1_N : N ;
  uppdaterande_nn_1_N : N ;
  uppdelande_nn_1_N : N ;
  uppdragande_nn_1_N : N ;
  uppdrivande_nn_1_N : N ;
  uppdykande_nn_1_N : N ;
  uppeggande_nn_1_N : N ;
  uppehaallande_nn_1_1_N : N ;
  uppenbarande_nn_1_N : N ;
  uppfattande_nn_1_N : N ;
  uppfinnande_nn_1_N : N ;
  uppfordrande_nn_1_N : N ;
  uppfostrande_nn_1_N : N ;
  uppfriskande_nn_1_N : N ;
  uppfyllande_nn_1_N : N ;
  uppfaangande_nn_1_1_N : N ;
  uppfoedande_nn_1_1_N : N ;
  uppfoerande_nn_1_1_N : N ;
  uppfoerstorande_nn_1_1_N : N ;
  uppgivande_nn_1_N : N ;
  uppgraderande_nn_1_N : N ;
  uppgaaende_nn_1_1_N : N ;
  upphandlande_nn_1_N : N ;
  upphaussande_nn_1_N : N ;
  upphetsande_nn_1_N : N ;
  upphettande_nn_1_N : N ;
  upphittande_nn_1_N : N ;
  upphottande_nn_1_N : N ;
  upphaemtande_nn_1_1_N : N ;
  upphaevande_nn_1_1_N : N ;
  upphoejande_nn_1_1_N : N ;
  upphoerande_nn_1_1_N : N ;
  uppiggande_nn_1_N : N ;
  uppjazzande_nn_1_N : N ;
  uppjusterande_nn_1_N : N ;
  uppkallande_nn_1_N : N ;
  uppklarande_nn_1_N : N ;
  uppkommande_nn_1_N : N ;
  uppkvistande_nn_1_N : N ;
  upplagrande_nn_1_N : N ;
  upplappande_nn_1_N : N ;
  upplevande_nn_1_N : N ;
  upplivande_nn_1_N : N ;
  upplysande_nn_1_N : N ;
  upplaeggande_nn_1_1_N : N ;
  upplaesande_nn_1_1_N : N ;
  upplaatande_nn_1_1_N : N ;
  upploesande_nn_1_1_N : N ;
  uppmanande_nn_1_N : N ;
  uppmarschomraade_nn_1_1_N : N ;
  uppmjukande_nn_1_N : N ;
  uppmuddrande_nn_1_N : N ;
  uppmuntrande_nn_1_N : N ;
  uppmaerksammande_nn_1_1_N : N ;
  uppmaetande_nn_1_1_N : N ;
  uppnaaende_nn_1_1_N : N ;
  uppnaalande_nn_1_1_N : N ;
  uppodlande_nn_1_N : N ;
  uppoffrande_nn_1_N : N ;
  uppradande_nn_1_N : N ;
  uppreklamerande_nn_1_N : N ;
  upprensande_nn_1_N : N ;
  upprepande_nn_1_N : N ;
  uppresande_nn_1_N : N ;
  upprivande_nn_1_N : N ;
  upprustande_nn_1_N : N ;
  upprymmande_nn_1_N : N ;
  uppraeknande_nn_1_1_N : N ;
  uppraennande_nn_1_1_N : N ;
  uppraettande_nn_1_1_N : N ;
  uppraetthaallande_nn_1_1_N : N ;
  upproerande_nn_1_1_N : N ;
  uppsamlande_nn_1_N : N ;
  uppsatsaemne_nn_1_1_N : N ;
  uppskattande_nn_1_N : N ;
  uppskjutande_nn_1_N : N ;
  uppslagssikte_nn_1_N : N ;
  uppslammande_nn_1_N : N ;
  uppslukande_nn_1_N : N ;
  uppsnabbande_nn_1_N : N ;
  uppsnappande_nn_1_N : N ;
  uppspjaelkande_nn_1_1_N : N ;
  uppsprickande_nn_1_N : N ;
  uppspaarande_nn_1_1_N : N ;
  uppstigande_nn_1_N : N ;
  uppstramande_nn_1_N : N ;
  uppstaellande_nn_1_1_N : N ;
  uppstaemmande_nn_1_1_N : N ;
  uppstaaende_nn_1_1_N : N ;
  uppsugande_nn_1_N : N ;
  uppsummerande_nn_1_N : N ;
  uppsaettande_nn_1_1_N : N ;
  uppsoekande_nn_1_1_N : N ;
  upptagande_nn_1_N : N ;
  upptagningsomraade_nn_1_1_N : N ;
  upptaxerande_nn_1_N : N ;
  upptecknande_nn_1_N : N ;
  upptornande_nn_1_N : N ;
  upptrampande_nn_1_N : N ;
  upptrappande_nn_1_N : N ;
  upptrissande_nn_1_N : N ;
  upptraedande_nn_1_1_N : N ;
  upptraede_nn_1_1_N : N ;
  upptaeckande_nn_1_1_N : N ;
  upptaendande_nn_1_1_N : N ;
  uppvaktande_nn_1_N : N ;
  uppviglande_nn_1_N : N ;
  uppvisande_nn_1_N : N ;
  uppvaeckande_nn_1_1_N : N ;
  uppvaegande_nn_1_1_N : N ;
  uppvaerderande_nn_1_1_N : N ;
  uppvaermande_nn_1_1_N : N ;
  uppvaexande_nn_1_1_N : N ;
  uppaetande_nn_1_1_N : N ;
  uppoevande_nn_1_1_N : N ;
  uraktlaatande_nn_1_1_N : N ;
  urartande_nn_1_N : N ;
  urbaniserande_nn_1_N : N ;
  urgerande_nn_1_N : N ;
  urinerande_nn_1_N : N ;
  urkalkande_nn_1_N : N ;
  urlakande_nn_1_N : N ;
  ursakande_nn_1_N : N ;
  ursinne_nn_1_N : N ;
  urskiljande_nn_1_N : N ;
  urskuldande_nn_1_N : N ;
  urskoenjande_nn_1_1_N : N ;
  ursprungslaege_nn_1_1_N : N ;
  ursprungsmaerkande_nn_1_1_N : N ;
  ursaektande_nn_1_1_N : N ;
  uruppfoerande_nn_1_1_N : N ;
  uraemne_nn_1_1_N : N ;
  usb_minne_nn_1_N : N ;
  usurperande_nn_1_N : N ;
  utackorderande_nn_1_N : N ;
  utannonserande_nn_1_N : N ;
  utanordnande_nn_1_N : N ;
  utarbetande_nn_1_N : N ;
  utarmande_nn_1_N : N ;
  utarrenderande_nn_1_N : N ;
  utbalanserande_nn_1_N : N ;
  utbasunerande_nn_1_N : N ;
  utbekommande_nn_1_N : N ;
  utbetalande_nn_1_N : N ;
  utbildande_nn_1_N : N ;
  utbjudande_nn_1_N : N ;
  utbombande_nn_1_N : N ;
  utbredande_nn_1_N : N ;
  utbredningsomraade_nn_1_1_N : N ;
  utbreende_nn_1_N : N ;
  utbringande_nn_1_N : N ;
  utbristande_nn_1_N : N ;
  utbroderande_nn_1_N : N ;
  utbrytande_nn_1_N : N ;
  utbuande_nn_1_N : N ;
  utbyggande_nn_1_N : N ;
  utbygge_nn_1_N : N ;
  utbytande_nn_1_N : N ;
  utbyte_nn_1_N : N ;
  utdebiterande_nn_1_N : N ;
  utdelande_nn_1_N : N ;
  utdikande_nn_1_N : N ;
  utdragande_nn_1_N : N ;
  utdrivande_nn_1_N : N ;
  utdunstande_nn_1_N : N ;
  utdoemande_nn_1_1_N : N ;
  utebliende_nn_1_N : N ;
  uteblivande_nn_1_N : N ;
  utelaemnande_nn_1_1_N : N ;
  utelaasande_nn_1_1_N : N ;
  uteslutande_nn_1_N : N ;
  utestaengande_nn_1_1_N : N ;
  utexaminerande_nn_1_N : N ;
  utexperimenterande_nn_1_N : N ;
  utfallande_nn_1_N : N ;
  utfallsdike_nn_1_N : N ;
  utfiskande_nn_1_N : N ;
  utflaggande_nn_1_N : N ;
  utfloede_nn_1_1_N : N ;
  utfodrande_nn_1_N : N ;
  utfordrande_nn_1_N : N ;
  utformande_nn_1_N : N ;
  utforskande_nn_1_N : N ;
  utfraktande_nn_1_N : N ;
  utfraagande_nn_1_1_N : N ;
  utfyllande_nn_1_N : N ;
  utfaellande_nn_1_1_N : N ;
  utfaerdande_nn_1_1_N : N ;
  utfaestande_nn_1_1_N : N ;
  utfaaende_nn_1_1_N : N ;
  utfoerande_nn_1_1_N : N ;
  utfoersaekrande_nn_1_1_N : N ;
  utfoersaeljande_nn_1_1_N : N ;
  utgeende_nn_1_N : N ;
  utgivande_nn_1_N : N ;
  utgjutande_nn_1_N : N ;
  utglesande_nn_1_N : N ;
  utgrundande_nn_1_N : N ;
  utgraevande_nn_1_1_N : N ;
  utgaaende_nn_1_1_N : N ;
  utgaangslaege_nn_1_1_N : N ;
  utgoerande_nn_1_1_N : N ;
  uthamrande_nn_1_N : N ;
  uthyrande_nn_1_N : N ;
  uthaerdande_nn_1_1_N : N ;
  utjaemnande_nn_1_1_N : N ;
  utkammande_nn_1_N : N ;
  utkastande_nn_1_N : N ;
  utklarande_nn_1_N : N ;
  utklarerande_nn_1_N : N ;
  utklassande_nn_1_N : N ;
  utklyvande_nn_1_N : N ;
  utkommande_nn_1_N : N ;
  utkommenderande_nn_1_N : N ;
  utkonkurrerande_nn_1_N : N ;
  utkorande_nn_1_N : N ;
  utkristalliserande_nn_1_N : N ;
  utkraevande_nn_1_1_N : N ;
  utkvitterande_nn_1_N : N ;
  utkylande_nn_1_N : N ;
  utkaempande_nn_1_1_N : N ;
  utlokaliserande_nn_1_N : N ;
  utlottande_nn_1_N : N ;
  utlovande_nn_1_N : N ;
  utlysande_nn_1_N : N ;
  utlaeggande_nn_1_1_N : N ;
  utlaemnande_nn_1_1_N : N ;
  utlaemningsfoerfarande_nn_1_1_N : N ;
  utlaesande_nn_1_1_N : N ;
  utlaanande_nn_1_1_N : N ;
  utlaatande_nn_1_1_N : N ;
  utloepande_nn_1_1_N : N ;
  utloesande_nn_1_1_N : N ;
  utmanande_nn_1_N : N ;
  utmanoevrerande_nn_1_1_N : N ;
  utmattande_nn_1_N : N ;
  utmejslande_nn_1_N : N ;
  utminuterande_nn_1_N : N ;
  utmynnande_nn_1_N : N ;
  utmaerkande_nn_1_1_N : N ;
  utmaetande_nn_1_1_N : N ;
  utmaalande_nn_1_1_N : N ;
  utmoenstrande_nn_1_1_N : N ;
  utnyttjande_nn_1_N : N ;
  utnaemnande_nn_1_1_N : N ;
  utpekande_nn_1_N : N ;
  utplacerande_nn_1_N : N ;
  utplundrande_nn_1_N : N ;
  utplaanande_nn_1_1_N : N ;
  utposterande_nn_1_N : N ;
  utpressande_nn_1_N : N ;
  utpressningssyfte_nn_1_N : N ;
  utprickande_nn_1_N : N ;
  utprovande_nn_1_N : N ;
  utproevande_nn_1_1_N : N ;
  utraderande_nn_1_N : N ;
  utrangerande_nn_1_N : N ;
  utredande_nn_1_N : N ;
  utredningsarbete_nn_1_N : N ;
  utrensande_nn_1_N : N ;
  utropande_nn_1_N : N ;
  utrotande_nn_1_N : N ;
  utrustande_nn_1_N : N ;
  utrymmande_nn_1_N : N ;
  utrymme_nn_1_N : N ;
  utraettande_nn_1_1_N : N ;
  utroenande_nn_1_1_N : N ;
  utseende_nn_1_N : N ;
  utsirande_nn_1_N : N ;
  utskeppande_nn_1_N : N ;
  utskiljande_nn_1_N : N ;
  utskottsbetaenkande_nn_1_1_N : N ;
  utskrivande_nn_1_N : N ;
  utskaenkande_nn_1_1_N : N ;
  utslungande_nn_1_N : N ;
  utslussande_nn_1_N : N ;
  utslaeckande_nn_1_1_N : N ;
  utslaetande_nn_1_1_N : N ;
  utsmyckande_nn_1_N : N ;
  utspanande_nn_1_N : N ;
  utspisande_nn_1_N : N ;
  utspisningsstaelle_nn_1_1_N : N ;
  utspridande_nn_1_N : N ;
  utspyende_nn_1_N : N ;
  utspaerrande_nn_1_1_N : N ;
  utstakande_nn_1_N : N ;
  utstofferande_nn_1_N : N ;
  utstraeckande_nn_1_1_N : N ;
  utstraalande_nn_1_1_N : N ;
  utstaellande_nn_1_1_N : N ;
  utstaaende_nn_1_1_N : N ;
  utstoetande_nn_1_1_N : N ;
  utsugande_nn_1_N : N ;
  utsynande_nn_1_N : N ;
  utsaede_nn_1_1_N : N ;
  utsaegande_nn_1_1_N : N ;
  utsaendande_nn_1_1_N : N ;
  utsaettande_nn_1_1_N : N ;
  utsoekande_nn_1_1_N : N ;
  utsoendrande_nn_1_1_N : N ;
  uttalande_nn_1_N : N ;
  uttaxerande_nn_1_N : N ;
  uttolkande_nn_1_N : N ;
  uttorkande_nn_1_N : N ;
  uttryckande_nn_1_N : N ;
  uttraedande_nn_1_1_N : N ;
  uttraede_nn_1_1_N : N ;
  uttroettande_nn_1_1_N : N ;
  uttunnande_nn_1_N : N ;
  uttydande_nn_1_N : N ;
  uttaenjande_nn_1_1_N : N ;
  uttoemmande_nn_1_1_N : N ;
  utvandrande_nn_1_N : N ;
  utvecklande_nn_1_N : N ;
  utvecklingsarbete_nn_1_N : N ;
  utvecklingsskede_nn_1_N : N ;
  utverkande_nn_1_N : N ;
  utvidgande_nn_1_N : N ;
  utvinnande_nn_1_N : N ;
  utvisande_nn_1_N : N ;
  utvaeljande_nn_1_1_N : N ;
  utvaerderande_nn_1_1_N : N ;
  utvaexlande_nn_1_1_N : N ;
  utoekande_nn_1_1_N : N ;
  utoevande_nn_1_1_N : N ;
  vabbande_nn_1_N : N ;
  vaccinerande_nn_1_N : N ;
  vacklande_nn_1_N : N ;
  vadande_nn_1_N : N ;
  vadderande_nn_1_N : N ;
  vadstaelle_nn_1_1_N : N ;
  vagabonderande_nn_1_N : N ;
  vaggande_nn_1_N : N ;
  vagnlaege_nn_1_1_N : N ;
  vajande_nn_1_N : N ;
  vakande_nn_1_N : N ;
  vakansfoerordnande_nn_1_1_N : N ;
  vakanssaettande_nn_1_1_N : N ;
  vakantsaettande_nn_1_1_N : N ;
  vaknande_nn_1_N : N ;
  vaksinerande_nn_1_N : N ;
  vaktande_nn_1_N : N ;
  valackande_nn_1_N : N ;
  valborgsmaessofirande_nn_1_1_N : N ;
  valdeltagande_nn_1_N : N ;
  valfuskande_nn_1_N : N ;
  valkande_nn_1_N : N ;
  valkgarvande_nn_1_N : N ;
  vallande_nn_1_N : N ;
  vallfaerdande_nn_1_1_N : N ;
  valloefte_nn_1_1_N : N ;
  valmoete_nn_1_1_N : N ;
  valnande_nn_1_N : N ;
  valpande_nn_1_N : N ;
  valrike_nn_1_N : N ;
  valsande_nn_1_N : N ;
  valstugeavsloejande_nn_1_1_N : N ;
  valutasamarbete_nn_1_N : N ;
  valuterande_nn_1_N : N ;
  valverande_nn_1_N : N ;
  valoeverklagande_nn_1_1_N : N ;
  vampande_nn_1_N : N ;
  vandaliserande_nn_1_N : N ;
  vandrande_nn_1_N : N ;
  vanhedrande_nn_1_N : N ;
  vanhelgande_nn_1_N : N ;
  vankande_nn_1_N : N ;
  vannande_nn_1_N : N ;
  vanprydande_nn_1_N : N ;
  vanrykte_nn_1_N : N ;
  vansinne_nn_1_N : N ;
  vanskoetande_nn_1_1_N : N ;
  vanstyrande_nn_1_N : N ;
  vanstyre_nn_1_N : N ;
  vanstaellande_nn_1_1_N : N ;
  vantolkande_nn_1_N : N ;
  vanvaardande_nn_1_1_N : N ;
  vanvoerdande_nn_1_1_N : N ;
  vanaerande_nn_1_1_N : N ;
  vapenskifte_nn_1_N : N ;
  vapenvaegrande_nn_1_1_N : N ;
  varande_nn_1_N : N ;
  vardagstaenkande_nn_1_1_N : N ;
  vardande_nn_1_N : N ;
  vargande_nn_1_N : N ;
  varierande_nn_1_N : N ;
  varmbonande_nn_1_N : N ;
  varmkoerande_nn_1_1_N : N ;
  varnande_nn_1_N : N ;
  varningsmaerke_nn_1_1_N : N ;
  varpande_nn_1_N : N ;
  varseblivande_nn_1_N : N ;
  varskoende_nn_1_N : N ;
  varslande_nn_1_N : N ;
  varsnande_nn_1_N : N ;
  varudeklarerande_nn_1_N : N ;
  varumaerke_nn_1_1_N : N ;
  varvande_nn_1_N : N ;
  vaskande_nn_1_N : N ;
  vassgoerande_nn_1_1_N : N ;
  vattenfloede_nn_1_1_N : N ;
  vattenhoelje_nn_1_1_N : N ;
  vattenkammande_nn_1_N : N ;
  vattenmaerke_nn_1_1_N : N ;
  vattenvaerde_nn_1_1_N : N ;
  vattnande_nn_1_N : N ;
  vattrande_nn_1_N : N ;
  vaxande_nn_1_N : N ;
  veckande_nn_1_N : N ;
  vecklande_nn_1_N : N ;
  veckohandlande_nn_1_N : N ;
  veckopendlande_nn_1_N : N ;
  vederboerande_nn_1_1_N : N ;
  vedergaellande_nn_1_1_N : N ;
  vederkvickande_nn_1_N : N ;
  vedermaele_nn_1_1_N : N ;
  vedervaagande_nn_1_1_N : N ;
  vegetationsbaelte_nn_1_1_N : N ;
  vegeterande_nn_1_N : N ;
  veklagande_nn_1_N : N ;
  veknande_nn_1_N : N ;
  velande_nn_1_N : N ;
  velouriserande_nn_1_N : N ;
  ventilerande_nn_1_N : N ;
  ventilsnoere_nn_1_1_N : N ;
  verandaraecke_nn_1_1_N : N ;
  verbaliserande_nn_1_N : N ;
  verifierande_nn_1_N : N ;
  verkande_nn_1_N : N ;
  verkliggoerande_nn_1_1_N : N ;
  verklighetsfoerankrande_nn_1_1_N : N ;
  verksamhetsomraade_nn_1_1_N : N ;
  verkstadsarbete_nn_1_N : N ;
  verkstaellande_nn_1_1_N : N ;
  verktygsbaelte_nn_1_1_N : N ;
  versifierande_nn_1_N : N ;
  vertikallaege_nn_1_1_N : N ;
  vetenskapande_nn_1_N : N ;
  vettande_nn_1_N : N ;
  vevande_nn_1_N : N ;
  vevlande_nn_1_N : N ;
  vibrerande_nn_1_N : N ;
  vickande_nn_1_N : N ;
  vidarebefordrande_nn_1_N : N ;
  vidareutbildande_nn_1_N : N ;
  vidareutvecklande_nn_1_N : N ;
  vidbraennande_nn_1_1_N : N ;
  vide_nn_1_N : N ;
  vidgande_nn_1_N : N ;
  vidgaaende_nn_1_1_N : N ;
  vidhaeftande_nn_1_1_N : N ;
  vidhaengande_nn_1_1_N : N ;
  vidhaallande_nn_1_1_N : N ;
  vidimerande_nn_1_N : N ;
  vidkommande_nn_1_N : N ;
  vidlaadande_nn_1_1_N : N ;
  vidmakthaallande_nn_1_1_N : N ;
  vidroerande_nn_1_1_N : N ;
  vidtagande_nn_1_N : N ;
  vidtalande_nn_1_N : N ;
  viftande_nn_1_N : N ;
  vigande_nn_1_N : N ;
  viggande_nn_1_N : N ;
  vigilerande_nn_1_N : N ;
  vigningsloefte_nn_1_1_N : N ;
  villaomraade_nn_1_1_N : N ;
  vilolaege_nn_1_1_N : N ;
  vindbaelte_nn_1_1_N : N ;
  vindfaelle_nn_1_1_N : N ;
  vindskifte_nn_1_N : N ;
  vindsutrymme_nn_1_N : N ;
  vinmaerke_nn_1_1_N : N ;
  vinstsyfte_nn_1_N : N ;
  vippbraede_nn_1_1_N : N ;
  viste_nn_1_N : N ;
  vite_nn_1_N : N ;
  vittne_nn_1_N : N ;
  vokalmoete_nn_1_1_N : N ;
  vulgonaeste_nn_1_1_N : N ;
  vaeckelsemoete_nn_1_1_N : N ;
  vaegarbete_nn_1_1_N : N ;
  vaegbygge_nn_1_1_N : N ;
  vaegdike_nn_1_1_N : N ;
  vaegmaerke_nn_1_1_N : N ;
  vaegraecke_nn_1_1_N : N ;
  vaelde_nn_1_1_N : N ;
  vaelfaerdsbygge_nn_1_1_N : N ;
  vaelfaerdsloefte_nn_1_1_N : N ;
  vaelfaerdssamhaelle_nn_1_1_N : N ;
  vaentevaerde_nn_1_1_N : N ;
  vaerdeomdoeme_nn_1_1_N : N ;
  vaerldsherravaelde_nn_1_1_N : N ;
  vaermefloede_nn_1_1_N : N ;
  vaermeutbyte_nn_1_1_N : N ;
  vaextsamhaelle_nn_1_1_N : N ;
  vaextslaekte_nn_1_1_N : N ;
  vaextaemne_nn_1_1_N : N ;
  vaagstycke_nn_1_1_N : N ;
  vaarbete_nn_1_1_N : N ;
  vaardyrke_nn_1_1_N : N ;
  vaatutrymme_nn_1_1_N : N ;
  wallraffande_nn_1_N : N ;
  ynglingalynne_nn_1_N : N ;
  ynglingasinne_nn_1_N : N ;
  yrke_nn_1_N : N ;
  yrkesarbete_nn_1_N : N ;
  yste_nn_1_N : N ;
  ytterhoelje_nn_1_1_N : N ;
  ytteromraade_nn_1_1_N : N ;
  yxaemne_nn_1_1_N : N ;
  OEstersjoesamarbete_nn_1_1_N : N ;
  aeggviteaemne_nn_1_1_N : N ;
  aegoskifte_nn_1_1_N : N ;
  aektenskapsloefte_nn_1_1_N : N ;
  aembete_nn_1_1_N : N ;
  aemne_nn_1_1_N : N ;
  aemnesomraade_nn_1_1_N : N ;
  aenkesaete_nn_1_1_N : N ;
  aenne_nn_1_1_N : N ;
  aereminne_nn_1_1_N : N ;
  aermbraede_nn_1_1_N : N ;
  aabaeke_nn_1_1_N : N ;
  aakergaerde_nn_1_1_N : N ;
  aakerspoeke_nn_1_1_N : N ;
  aalagille_nn_1_1_N : N ;
  aarhundrade_nn_1_1_N : N ;
  aarsmoete_nn_1_1_N : N ;
  aarsskifte_nn_1_1_N : N ;
  aasiktsutbyte_nn_1_1_N : N ;
  oede_nn_1_1_N : N ;
  oedemarksomraade_nn_1_1_N : N ;
  oegonmaerke_nn_1_1_N : N ;
  oegonvittne_nn_1_1_N : N ;
  oelsinne_nn_1_1_N : N ;
  oeppningsskede_nn_1_1_N : N ;
  oerhaenge_nn_1_1_N : N ;
  oerike_nn_1_1_N : N ;
  oeverarbete_nn_1_1_N : N ;
  oeverfloedssamhaelle_nn_1_1_N : N ;
  oevergaangsskede_nn_1_1_N : N ;
  oeverlaege_nn_1_1_N : N ;
  oeverrede_nn_1_1_N : N ;
  oeverstycke_nn_1_1_N : N ;
  oevertidsarbete_nn_1_1_N : N ;
  oevervakningssamhaelle_nn_1_1_N : N ;
  oevervaelde_nn_1_1_N : N ;
  oevningsaemne_nn_1_1_N : N ;
  oemhetsbetygelse_nn_1_1_N : N ;
  vaen_nn_1_1_N : N ;
  vaeggmadam_nn_1_1_N : N ;
  vraa_nn_1_1_N : N ;
  vinbladsdolma_nn_1_N : N ;
  ungmoe_nn_1_1_N : N ;
  ungersven_nn_1_N : N ;
  ungdomsvaen_nn_1_1_N : N ;
  ungdomsfaengelse_nn_1_1_N : N ;
  underraa_nn_1_1_N : N ;
  taa_nn_1_1_N : N ;
  taeckelse_nn_1_1_N : N ;
  trikolor_nn_1_N : N ;
  toreador_nn_1_N : N ;
  tenor_nn_1_N : N ;
  saangmoe_nn_1_1_N : N ;
  sykomor_nn_1_N : N ;
  sven_nn_1_N : N ;
  stortaa_nn_1_1_N : N ;
  stiftsjungfru_nn_1_N : N ;
  spoekelse_nn_1_1_N : N ;
  spray_nn_1_N : N ;
  spor_nn_1_N : N ;
  spiselvraa_nn_1_1_N : N ;
  spermatofor_nn_1_N : N ;
  spanjor_nn_1_N : N ;
  sonhustru_nn_1_N : N ;
  smoertenor_nn_1_1_N : N ;
  skoeldmoe_nn_1_1_N : N ;
  skraeckfaengelse_nn_1_1_N : N ;
  skolkorridor_nn_1_N : N ;
  sjoejungfru_nn_1_1_N : N ;
  sjukhuskorridor_nn_1_N : N ;
  signor_nn_1_N : N ;
  senor_nn_1_1_N : N ;
  semafor_nn_1_N : N ;
  raa_nn_1_1_N : N ;
  roddarmadam_nn_1_N : N ;
  presidenthustru_nn_1_N : N ;
  portvinstaa_nn_1_1_N : N ;
  por_nn_1_N : N ;
  politikerhustru_nn_1_N : N ;
  polismajor_nn_1_N : N ;
  pojkvaen_nn_1_1_N : N ;
  plasma_nn_1_N : N ;
  pingstvaen_nn_1_1_N : N ;
  pikador_nn_1_N : N ;
  picador_nn_1_N : N ;
  pektaa_nn_1_1_N : N ;
  parallellogram_nn_1_N : N ;
  ovaen_nn_1_1_N : N ;
  ormslaa_nn_1_1_N : N ;
  omnivor_nn_1_N : N ;
  okulage_nn_1_N : N ;
  naesspray_nn_1_1_N : N ;
  naturvaen_nn_1_1_N : N ;
  moe_nn_1_1_N : N ;
  maersraa_nn_1_1_N : N ;
  maenniskovaen_nn_1_1_N : N ;
  minior_nn_1_N : N ;
  meteor_nn_1_N : N ;
  matvraa_nn_1_1_N : N ;
  matador_nn_1_N : N ;
  madam_nn_1_N : N ;
  lyxhustru_nn_1_N : N ;
  livstidsfaengelse_nn_1_1_N : N ;
  lilltaa_nn_1_1_N : N ;
  lantarbetarhustru_nn_1_N : N ;
  labrador_nn_1_N : N ;
  koersven_nn_1_1_N : N ;
  kaaldolma_nn_1_1_N : N ;
  kvinnofaengelse_nn_1_1_N : N ;
  kraftparallellogram_nn_1_N : N ;
  korridor_nn_1_N : N ;
  kondor_nn_1_N : N ;
  kokvraa_nn_1_1_N : N ;
  karnivor_nn_1_N : N ;
  kammarjungfru_nn_1_N : N ;
  jaernjungfru_nn_1_1_N : N ;
  jungfru_nn_1_N : N ;
  hydrofor_nn_1_N : N ;
  hustru_nn_1_N : N ;
  hjaertevaen_nn_1_1_N : N ;
  hjaeltetenor_nn_1_1_N : N ;
  gem_nn_1_N : N ;
  foerfattarvaen_nn_1_1_N : N ;
  faestmoe_nn_1_1_N : N ;
  faengelse_nn_1_1_N : N ;
  flygkorridor_nn_1_N : N ;
  flickvaen_nn_1_1_N : N ;
  farstu_nn_1_N : N ;
  expojkvaen_nn_1_1_N : N ;
  exhustru_nn_1_N : N ;
  exflickvaen_nn_1_1_N : N ;
  elektrofor_nn_1_N : N ;
  efor_nn_1_N : N ;
  dolma_nn_1_N : N ;
  djurvaen_nn_1_1_N : N ;
  display_nn_1_N : N ;
  diplomathustru_nn_1_N : N ;
  dekor_nn_1_N : N ;
  cellplasma_nn_1_N : N ;
  cellfaengelse_nn_1_1_N : N ;
  brevvaen_nn_1_1_N : N ;
  bondhustru_nn_1_N : N ;
  blindraa_nn_1_1_N : N ;
  bihustru_nn_1_N : N ;
  beslutskorridor_nn_1_N : N ;
  begineraa_nn_1_1_N : N ;
  bastu_nn_1_N : N ;
  barnjungfru_nn_1_N : N ;
  barndomsvaen_nn_1_1_N : N ;
  bankirhustru_nn_1_N : N ;
  andretenor_nn_1_N : N ;
  andratenor_nn_1_N : N ;
  anafor_nn_1_N : N ;
  Helsingforsvaen_nn_1_1_N : N ;
  Afghanistantrupp_nn_1_N : N ;
  Arianeraket_nn_1_N : N ;
  Beethovensonat_nn_1_N : N ;
  DNA_profil_nn_1_N : N ;
  EU_korrespondent_nn_1_N : N ;
  FN_tribunal_nn_1_N : N ;
  LO_chef_nn_1_N : N ;
  Linkoepingsbo_nn_1_1_N : N ;
  MAO_aktivitet_nn_1_N : N ;
  Muhammedkarikatyr_nn_1_N : N ;
  Nobelpriskandidat_nn_1_N : N ;
  PCB_halt_nn_1_N : N ;
  PR_kupp_nn_1_N : N ;
  PRkupp_nn_1_N : N ;
  Papyrusaktie_nn_1_N : N ;
  SAS_chef_nn_1_N : N ;
  Stasiagent_nn_1_N : N ;
  Stockholmsfotograf_nn_1_N : N ;
  Stockholmsguide_nn_1_N : N ;
  Stockholmshelg_nn_1_N : N ;
  TV_antenn_nn_1_N : N ;
  TV_apparat_nn_1_N : N ;
  TV_bild_nn_1_N : N ;
  TV_chef_nn_1_N : N ;
  TV_kanal_nn_1_N : N ;
  TV_leverantoer_nn_1_1_N : N ;
  TV_nyhet_nn_1_N : N ;
  TV_reparatoer_nn_1_1_N : N ;
  TV_serie_nn_1_N : N ;
  TV_studio_nn_1_N : N ;
  Tarzanfilm_nn_1_N : N ;
  abiturient_nn_1_N : N ;
  abonnent_nn_1_N : N ;
  abortoer_nn_1_1_N : N ;
  absint_nn_1_N : N ;
  absorptionslinje_nn_1_N : N ;
  accessionskatalog_nn_1_N : N ;
  accesstid_nn_1_N : N ;
  ackompanjatoer_nn_1_1_N : N ;
  ackuschoer_nn_1_1_N : N ;
  ackvisitoer_nn_1_1_N : N ;
  addend_nn_1_N : N ;
  adelsaett_nn_1_1_N : N ;
  adept_nn_1_N : N ;
  adidasgympasko_nn_1_N : N ;
  adjunkt_nn_1_N : N ;
  adjutant_nn_1_N : N ;
  administratoer_nn_1_1_N : N ;
  adonisgestalt_nn_1_N : N ;
  adoratoer_nn_1_1_N : N ;
  adrenalin_nn_1_N : N ;
  adressat_nn_1_N : N ;
  advokatfiskal_nn_1_N : N ;
  advokatyr_nn_1_N : N ;
  aerodrom_nn_1_N : N ;
  aeronaut_nn_1_N : N ;
  affekt_nn_1_N : N ;
  affischoer_nn_1_1_N : N ;
  affaersbank_nn_1_1_N : N ;
  affaerslokal_nn_1_1_N : N ;
  affaerstid_nn_1_1_N : N ;
  affaersuppgoerelse_nn_1_1_N : N ;
  afrofrisyr_nn_1_N : N ;
  aftonpsalm_nn_1_N : N ;
  aftontoalett_nn_1_N : N ;
  aftonvard_nn_1_N : N ;
  agat_nn_1_N : N ;
  agave_nn_1_N : N ;
  agent_nn_1_N : N ;
  agnat_nn_1_N : N ;
  agraff_nn_1_N : N ;
  agrar_nn_1_N : N ;
  agronom_nn_1_N : N ;
  aha_upplevelse_nn_1_N : N ;
  ahaupplevelse_nn_1_N : N ;
  akrobat_nn_1_N : N ;
  akronym_nn_1_N : N ;
  aktie_nn_1_N : N ;
  aktiekupong_nn_1_N : N ;
  aktieportfoelj_nn_1_1_N : N ;
  aktionsart_nn_1_N : N ;
  aktionsradie_nn_1_N : N ;
  aktivum_nn_1_N : N ;
  aktningsbetygelse_nn_1_N : N ;
  aktuarie_nn_1_N : N ;
  aktoer_nn_1_1_N : N ;
  akvanaut_nn_1_N : N ;
  akvarell_nn_1_N : N ;
  akvatint_nn_1_N : N ;
  akvedukt_nn_1_N : N ;
  aladaab_nn_1_1_N : N ;
  alagreck_nn_1_N : N ;
  albumin_nn_1_N : N ;
  alemann_nn_1_N : N ;
  alfametyltyrosin_nn_1_N : N ;
  algoritm_nn_1_N : N ;
  alienationsupplevelse_nn_1_N : N ;
  alkalimetall_nn_1_N : N ;
  alkov_nn_1_N : N ;
  allergitablett_nn_1_N : N ;
  allograf_nn_1_N : N ;
  allomorf_nn_1_N : N ;
  allongeperuk_nn_1_N : N ;
  allstroemsapparat_nn_1_1_N : N ;
  aloe_nn_1_N : N ;
  alp_nn_1_N : N ;
  alpviol_nn_1_N : N ;
  altarrund_nn_1_N : N ;
  altfiol_nn_1_N : N ;
  altitud_nn_1_N : N ;
  alumn_nn_1_N : N ;
  alveolar_nn_1_N : N ;
  amatoer_nn_1_1_N : N ;
  amatoerbestaemmelse_nn_1_1_N : N ;
  ambassad_nn_1_N : N ;
  amerikabiljett_nn_1_N : N ;
  amfetamin_nn_1_N : N ;
  amfibie_nn_1_N : N ;
  amin_nn_1_N : N ;
  amiral_nn_1_N : N ;
  amiralsperson_nn_1_N : N ;
  ammoniumnitrat_nn_1_N : N ;
  amperesekund_nn_1_N : N ;
  amplitud_nn_1_N : N ;
  ampull_nn_1_N : N ;
  anakolut_nn_1_N : N ;
  anakoret_nn_1_N : N ;
  analfabet_nn_1_N : N ;
  anatom_nn_1_N : N ;
  and_nn_1_N : N ;
  andakt_nn_1_N : N ;
  andebesvaerjelse_nn_1_1_N : N ;
  andningsapparat_nn_1_N : N ;
  andraklassbiljett_nn_1_N : N ;
  anekdot_nn_1_N : N ;
  anfallsfront_nn_1_N : N ;
  anfallslinje_nn_1_N : N ;
  anfang_nn_1_N : N ;
  anfart_nn_1_N : N ;
  anfaektelse_nn_1_1_N : N ;
  anfoervant_nn_1_1_N : N ;
  angiosperm_nn_1_N : N ;
  angivelse_nn_1_N : N ;
  angorakatt_nn_1_N : N ;
  anhalt_nn_1_N : N ;
  animatoer_nn_1_1_N : N ;
  anisett_nn_1_N : N ;
  ankargrund_nn_1_N : N ;
  ankbonde_nn_1_N : N ;
  anklagelse_nn_1_N : N ;
  anklagelseakt_nn_1_N : N ;
  anklang_nn_1_N : N ;
  annonsoer_nn_1_1_N : N ;
  anod_nn_1_N : N ;
  anorak_nn_1_N : N ;
  anpassningsklinik_nn_1_N : N ;
  ansiktsnerv_nn_1_N : N ;
  anstalt_nn_1_N : N ;
  anstaltsvistelse_nn_1_N : N ;
  ansoekningstid_nn_1_1_N : N ;
  antenn_nn_1_N : N ;
  antigen_nn_1_N : N ;
  antiklinal_nn_1_N : N ;
  antikvarie_nn_1_N : N ;
  antilop_nn_1_N : N ;
  antipassad_nn_1_N : N ;
  antipod_nn_1_N : N ;
  antitoxin_nn_1_N : N ;
  antropofag_nn_1_N : N ;
  antroposof_nn_1_N : N ;
  anvaendbarhetsaspekt_nn_1_1_N : N ;
  apache_nn_1_N : N ;
  apekatt_nn_1_N : N ;
  apelsinmousse_nn_1_N : N ;
  apelsinsaft_nn_1_N : N ;
  aperitif_nn_1_N : N ;
  apetidin_nn_1_N : N ;
  apologet_nn_1_N : N ;
  applaad_nn_1_1_N : N ;
  apsort_nn_1_N : N ;
  arab_nn_1_N : N ;
  arbetarbostad_nn_1_N : N ;
  arbetarkommun_nn_1_N : N ;
  arbetarroerelse_nn_1_1_N : N ;
  arbetsinstaellelse_nn_1_1_N : N ;
  arbetskamrat_nn_1_N : N ;
  arbetslokal_nn_1_N : N ;
  arbetsloeshetsperiod_nn_1_1_N : N ;
  arbetsmaskin_nn_1_N : N ;
  arbetsmetod_nn_1_N : N ;
  arbetsmoral_nn_1_N : N ;
  arbetsnedlaeggelse_nn_1_1_N : N ;
  arbetsterapeut_nn_1_N : N ;
  areal_nn_1_N : N ;
  areopag_nn_1_N : N ;
  aristokrat_nn_1_N : N ;
  arkad_nn_1_N : N ;
  arketyp_nn_1_N : N ;
  arkivarie_nn_1_N : N ;
  armbaagsnerv_nn_1_1_N : N ;
  armpolyp_nn_1_N : N ;
  armroerelse_nn_1_1_N : N ;
  arm_egeneral_nn_1_1_N : N ;
  arom_nn_1_N : N ;
  arrestlokal_nn_1_N : N ;
  arsenal_nn_1_N : N ;
  art_nn_1_N : N ;
  artefakt_nn_1_N : N ;
  artfraende_nn_1_1_N : N ;
  artighetsbetygelse_nn_1_N : N ;
  artikelserie_nn_1_N : N ;
  artillerigranat_nn_1_N : N ;
  arvfiende_nn_1_N : N ;
  arvfoeljd_nn_1_1_N : N ;
  arvsfoeljd_nn_1_1_N : N ;
  arvslott_nn_1_N : N ;
  arvsynd_nn_1_N : N ;
  arvtant_nn_1_N : N ;
  asfalt_nn_1_N : N ;
  asfaltlack_nn_1_N : N ;
  asfaltmoped_nn_1_N : N ;
  asiat_nn_1_N : N ;
  asimut_nn_1_N : N ;
  asket_nn_1_N : N ;
  aspekt_nn_1_N : N ;
  aspirin_nn_1_N : N ;
  assegaj_nn_1_N : N ;
  assiett_nn_1_N : N ;
  assistent_nn_1_N : N ;
  assuradoer_nn_1_1_N : N ;
  astrakan_nn_2_N : N ;
  asymptot_nn_1_N : N ;
  atenienn_nn_1_N : N ;
  atlet_nn_1_N : N ;
  atmosfaer_nn_1_1_N : N ;
  atoll_nn_1_N : N ;
  atommodell_nn_1_N : N ;
  attack_nn_1_N : N ;
  attiralj_nn_1_N : N ;
  attrapp_nn_1_N : N ;
  aubergine_nn_1_N : N ;
  augustinatt_nn_1_N : N ;
  auteur_nn_1_N : N ;
  autodidakt_nn_1_N : N ;
  autodrom_nn_1_N : N ;
  autograf_nn_1_N : N ;
  autoklav_nn_1_N : N ;
  autokrat_nn_1_N : N ;
  avantloge_nn_1_N : N ;
  avantscen_nn_1_N : N ;
  avart_nn_1_N : N ;
  avbitartaang_nn_1_1_N : N ;
  avec_nn_1_N : N ;
  avfart_nn_1_N : N ;
  avfyrningskod_nn_1_N : N ;
  avgift_nn_1_N : N ;
  avgiftningsklinik_nn_1_N : N ;
  avgrund_nn_1_N : N ;
  avgaeld_nn_1_1_N : N ;
  aviatoer_nn_1_1_N : N ;
  aviseringsperiod_nn_1_N : N ;
  avkoerningsramp_nn_1_1_N : N ;
  avledningsaendelse_nn_1_1_N : N ;
  avmaskningskur_nn_1_N : N ;
  avocado_nn_1_N : N ;
  avokado_nn_1_N : N ;
  avsikt_nn_1_N : N ;
  avspaenningspedagog_nn_1_1_N : N ;
  avstaandskraft_nn_1_1_N : N ;
  avsaegelse_nn_1_1_N : N ;
  avsaettningsbassaeng_nn_1_1_N : N ;
  avtalsperiod_nn_1_N : N ;
  avtalsroerelse_nn_1_1_N : N ;
  avtraedelse_nn_1_1_N : N ;
  avvikelse_nn_1_N : N ;
  aztek_nn_1_N : N ;
  babordsvakt_nn_1_N : N ;
  backanal_nn_1_N : N ;
  backvial_nn_1_N : N ;
  badbassaeng_nn_1_1_N : N ;
  badhytt_nn_1_N : N ;
  badkarseffekt_nn_1_N : N ;
  badsko_nn_1_N : N ;
  badstrand_nn_1_N : N ;
  bagatell_nn_1_N : N ;
  baguette_nn_1_N : N ;
  bahytt_nn_1_N : N ;
  baisse_nn_1_N : N ;
  bajadaer_nn_1_1_N : N ;
  bajonett_nn_1_N : N ;
  bakelse_nn_1_N : N ;
  bakgrund_nn_1_N : N ;
  bakjour_nn_1_N : N ;
  bakslagsventil_nn_1_N : N ;
  bakterie_nn_1_N : N ;
  bakteriofag_nn_1_N : N ;
  bakvikt_nn_1_N : N ;
  balansakt_nn_1_N : N ;
  balanserstaang_nn_1_1_N : N ;
  balett_nn_1_N : N ;
  balkong_nn_1_N : N ;
  balksko_nn_1_N : N ;
  ballad_nn_1_N : N ;
  ballong_nn_1_N : N ;
  balsam_nn_1_N : N ;
  balt_nn_1_N : N ;
  bananrepublik_nn_1_N : N ;
  banderol_nn_1_N : N ;
  banderoll_nn_1_N : N ;
  banjo_nn_1_N : N ;
  bankett_nn_1_N : N ;
  bankomat_nn_1_N : N ;
  bankrutt_nn_1_N : N ;
  bankruttoer_nn_1_1_N : N ;
  bankroerelse_nn_1_1_N : N ;
  banroerelse_nn_1_1_N : N ;
  bantningskur_nn_1_N : N ;
  bar_nn_1_N : N ;
  barack_nn_1_N : N ;
  barbar_nn_1_N : N ;
  bard_nn_1_N : N ;
  bardun_nn_1_N : N ;
  barett_nn_1_N : N ;
  bark_nn_1_N : N ;
  barkaroll_nn_1_N : N ;
  barktaekt_nn_1_1_N : N ;
  barmark_nn_1_N : N ;
  barnavaardscentral_nn_1_1_N : N ;
  barndomsstad_nn_1_N : N ;
  barndomsupplevelse_nn_1_N : N ;
  barnfotomodell_nn_1_N : N ;
  barnklinik_nn_1_N : N ;
  barnsboerd_nn_1_1_N : N ;
  barnsko_nn_1_N : N ;
  barnskoetarlinje_nn_1_1_N : N ;
  barntoalett_nn_1_N : N ;
  barnvakt_nn_1_N : N ;
  barograf_nn_1_N : N ;
  barr_nn_2_N : N ;
  barrikad_nn_1_N : N ;
  barriaer_nn_1_1_N : N ;
  barysfaer_nn_1_1_N : N ;
  basar_nn_1_N : N ;
  basfiol_nn_1_N : N ;
  basgitarr_nn_1_N : N ;
  baslinje_nn_1_N : N ;
  basrelief_nn_1_N : N ;
  bastard_nn_1_N : N ;
  bastonad_nn_1_N : N ;
  basun_nn_1_N : N ;
  batalj_nn_1_N : N ;
  bataljon_nn_1_N : N ;
  batat_nn_1_N : N ;
  batong_nn_1_N : N ;
  batterisekatoer_nn_1_1_N : N ;
  batysfaer_nn_1_1_N : N ;
  bearnaise_nn_1_N : N ;
  bebyggelse_nn_1_N : N ;
  bebaadelse_nn_1_1_N : N ;
  bedrift_nn_1_N : N ;
  bedroevelse_nn_1_1_N : N ;
  beflaeckelse_nn_1_1_N : N ;
  befolkningsstatistik_nn_1_N : N ;
  befordringsgrund_nn_1_N : N ;
  befrielse_nn_1_N : N ;
  befrielseakt_nn_1_N : N ;
  befrielsefront_nn_1_N : N ;
  befrielsekamp_nn_1_N : N ;
  befrielseroerelse_nn_1_1_N : N ;
  befaelselev_nn_1_1_N : N ;
  befaelstalang_nn_1_1_N : N ;
  befaestningslinje_nn_1_1_N : N ;
  begravningsakt_nn_1_N : N ;
  begravningsentreprenoer_nn_1_1_N : N ;
  begravningsmin_nn_1_N : N ;
  begraensningslinje_nn_1_1_N : N ;
  begynnelse_nn_1_N : N ;
  begynnelsebokstav_nn_1_N : N ;
  begaerelse_nn_1_1_N : N ;
  begaavningsreserv_nn_1_1_N : N ;
  behandlingsmetod_nn_1_N : N ;
  behovstillfredsstaellelse_nn_1_1_N : N ;
  bej_nn_1_N : N ;
  bekantskap_nn_1_N : N ;
  bekraeftelse_nn_1_1_N : N ;
  bekaennelse_nn_1_1_N : N ;
  beloeningsmedalj_nn_1_1_N : N ;
  bemaerkelse_nn_1_1_N : N ;
  bensinautomat_nn_1_N : N ;
  berceuse_nn_1_N : N ;
  beredelse_nn_1_N : N ;
  beredningsnaemnd_nn_1_1_N : N ;
  beredskap_nn_1_N : N ;
  beredskapsstat_nn_1_N : N ;
  bergamott_nn_1_N : N ;
  bergand_nn_1_N : N ;
  bergart_nn_1_N : N ;
  bergnymf_nn_1_N : N ;
  bergslag_nn_1_N : N ;
  bergstrakt_nn_1_N : N ;
  beryll_nn_1_N : N ;
  beraekningsmetod_nn_1_1_N : N ;
  beraettartalang_nn_1_1_N : N ;
  beraettarteknik_nn_1_1_N : N ;
  beraettelse_nn_1_1_N : N ;
  beskattningsgrund_nn_1_N : N ;
  beskaermelse_nn_1_1_N : N ;
  beslutsrymd_nn_1_N : N ;
  besmittelse_nn_1_N : N ;
  bespottelse_nn_1_N : N ;
  bestaemmelse_nn_1_1_N : N ;
  besvikelse_nn_1_N : N ;
  besvaerjelse_nn_1_1_N : N ;
  besvaersgrund_nn_1_1_N : N ;
  besoeksfaatoelj_nn_1_1_N : N ;
  betalningsinstaellelse_nn_1_1_N : N ;
  betalningstid_nn_1_N : N ;
  beteendeterapeut_nn_1_N : N ;
  betelpalm_nn_1_N : N ;
  betingelse_nn_1_N : N ;
  betjaeningsavgift_nn_1_1_N : N ;
  betjaent_nn_1_1_N : N ;
  betraktelse_nn_1_N : N ;
  betydelse_nn_1_N : N ;
  betygelse_nn_1_N : N ;
  betygskatalog_nn_1_N : N ;
  bevekelse_nn_1_N : N ;
  bevekelsegrund_nn_1_N : N ;
  bevillningsavgift_nn_1_N : N ;
  beviskraft_nn_1_N : N ;
  biaccent_nn_1_N : N ;
  biavsikt_nn_1_N : N ;
  bibeltext_nn_1_N : N ;
  bibetydelse_nn_1_N : N ;
  bibliofil_nn_1_N : N ;
  bibliograf_nn_1_N : N ;
  bibliotekarie_nn_1_N : N ;
  biblioteksbrand_nn_1_N : N ;
  bibliotekskatalog_nn_1_N : N ;
  bieffekt_nn_1_N : N ;
  biennal_nn_1_N : N ;
  bifenyl_nn_1_N : N ;
  biffko_nn_1_N : N ;
  biflod_nn_1_N : N ;
  bikt_nn_1_N : N ;
  bikvadrat_nn_1_N : N ;
  bilbrand_nn_1_N : N ;
  bildberaettelse_nn_1_1_N : N ;
  bildningsaristokrat_nn_1_N : N ;
  biljettautomat_nn_1_N : N ;
  biljettmaskin_nn_1_N : N ;
  biljettaang_nn_1_1_N : N ;
  bilmaskin_nn_1_N : N ;
  bilpark_nn_1_N : N ;
  bilradio_nn_1_N : N ;
  bilskrotningspremie_nn_1_N : N ;
  bilverkstad_nn_1_N : N ;
  bimetall_nn_1_N : N ;
  bindevokal_nn_1_N : N ;
  biobiljett_nn_1_N : N ;
  biograf_nn_1_N : N ;
  biosfaer_nn_1_1_N : N ;
  bioteknik_nn_1_N : N ;
  biotop_nn_1_N : N ;
  biotyp_nn_1_N : N ;
  biperson_nn_1_N : N ;
  biplanet_nn_1_N : N ;
  birem_nn_1_N : N ;
  bisatsordfoeljd_nn_1_1_N : N ;
  bismak_nn_1_N : N ;
  bivack_nn_1_N : N ;
  bjudcigarr_nn_1_N : N ;
  bjaellko_nn_1_1_N : N ;
  blackout_nn_1_N : N ;
  blam_nn_1_N : N ;
  blamage_nn_1_N : N ;
  blankett_nn_1_N : N ;
  blindpatron_nn_1_N : N ;
  blixtinkallelse_nn_1_N : N ;
  blixtpatron_nn_1_N : N ;
  blockfloejt_nn_1_1_N : N ;
  blocksignal_nn_1_N : N ;
  blodbank_nn_1_N : N ;
  blodcell_nn_1_N : N ;
  blodgivarcentral_nn_1_N : N ;
  blodrand_nn_1_N : N ;
  blodsutgjutelse_nn_1_N : N ;
  blodtyp_nn_1_N : N ;
  blombukett_nn_1_N : N ;
  blond_nn_1_N : N ;
  blaesand_nn_1_1_N : N ;
  blaabaerssaft_nn_1_1_N : N ;
  blaabaerssylt_nn_1_1_N : N ;
  blaalusern_nn_1_1_N : N ;
  bodbetjaent_nn_1_1_N : N ;
  boett_nn_1_N : N ;
  bohem_nn_1_N : N ;
  boj_nn_2_N : N ;
  bojar_nn_1_N : N ;
  bojkott_nn_1_N : N ;
  bokfilm_nn_1_N : N ;
  bokflod_nn_1_N : N ;
  bokstav_nn_1_N : N ;
  bokstavsfoeljd_nn_1_1_N : N ;
  bolagsstyrelse_nn_1_N : N ;
  bolsjevik_nn_1_N : N ;
  bombasm_nn_1_N : N ;
  bomullsflanell_nn_1_N : N ;
  bomullsplantage_nn_1_N : N ;
  bomullsservett_nn_1_N : N ;
  bonbonjaer_nn_1_1_N : N ;
  bonde_nn_1_N : N ;
  bondefred_nn_1_N : N ;
  bondkatt_nn_1_N : N ;
  bonjour_nn_1_N : N ;
  bonnett_nn_1_N : N ;
  bordell_nn_1_N : N ;
  borgensfoerbindelse_nn_1_1_N : N ;
  borgfred_nn_1_N : N ;
  borrmaskin_nn_1_N : N ;
  bostad_nn_1_N : N ;
  bostadsstyrelse_nn_1_N : N ;
  botgoerelse_nn_1_1_N : N ;
  bottenventil_nn_1_N : N ;
  boulevard_nn_1_N : N ;
  bouquet_nn_1_N : N ;
  bourgogne_nn_1_N : N ;
  boutique_nn_1_N : N ;
  boxningslokal_nn_1_N : N ;
  boyscout_nn_1_N : N ;
  bragd_nn_1_N : N ;
  brakteat_nn_1_N : N ;
  bramstaang_nn_1_1_N : N ;
  brand_nn_1_N : N ;
  brandkapten_nn_1_N : N ;
  brandslaeckarattrapp_nn_1_1_N : N ;
  brandsoldat_nn_1_N : N ;
  brandsyn_nn_1_N : N ;
  brant_nn_1_N : N ;
  bravad_nn_1_N : N ;
  bredd_nn_1_N : N ;
  brevfoersaendelse_nn_1_1_N : N ;
  bridong_nn_1_N : N ;
  brigad_nn_1_N : N ;
  brigadgeneral_nn_1_N : N ;
  brikett_nn_1_N : N ;
  brisad_nn_1_N : N ;
  brisansgranat_nn_1_N : N ;
  britt_nn_1_N : N ;
  brokad_nn_1_N : N ;
  brokanal_nn_1_N : N ;
  bromsraket_nn_1_N : N ;
  bromssko_nn_1_N : N ;
  bronsmedalj_nn_1_N : N ;
  brorslott_nn_1_N : N ;
  brorson_nn_1_N : N ;
  brudand_nn_1_N : N ;
  brudbukett_nn_1_N : N ;
  brugd_nn_1_N : N ;
  bruksdisponent_nn_1_N : N ;
  brukspatron_nn_1_N : N ;
  bruksroerelse_nn_1_1_N : N ;
  brunand_nn_1_N : N ;
  brunnskur_nn_1_N : N ;
  brustablett_nn_1_N : N ;
  bruttonationalprodukt_nn_1_N : N ;
  brygd_nn_1_N : N ;
  brytningsexponent_nn_1_N : N ;
  brytningspunkt_nn_1_N : N ;
  braennmanet_nn_1_1_N : N ;
  braennpunkt_nn_1_1_N : N ;
  braennvidd_nn_1_1_N : N ;
  braenslecell_nn_1_1_N : N ;
  braenslekanal_nn_1_1_N : N ;
  broedfrukt_nn_1_1_N : N ;
  broedsbrytelse_nn_1_1_N : N ;
  broellopsnatt_nn_1_1_N : N ;
  broellopssed_nn_1_1_N : N ;
  broellopsvideo_nn_1_1_N : N ;
  broestboeld_nn_1_1_N : N ;
  broestkaramell_nn_1_1_N : N ;
  broestvidd_nn_1_1_N : N ;
  bubbelpool_nn_1_N : N ;
  bukett_nn_1_N : N ;
  bulb_nn_1_N : N ;
  bulevard_nn_1_N : N ;
  bulgar_nn_1_N : N ;
  buljong_nn_1_N : N ;
  bumerang_nn_1_N : N ;
  bundsfoervant_nn_1_1_N : N ;
  burgarbar_nn_1_N : N ;
  burgerbar_nn_1_N : N ;
  busfason_nn_1_N : N ;
  bussarong_nn_1_N : N ;
  bussfoerbindelse_nn_1_1_N : N ;
  busslinje_nn_1_N : N ;
  butan_nn_1_N : N ;
  butelj_nn_1_N : N ;
  butik_nn_1_N : N ;
  butyl_nn_1_N : N ;
  byggnadsstyrelse_nn_1_N : N ;
  byrett_nn_1_N : N ;
  byraaassistent_nn_1_1_N : N ;
  byraakrat_nn_1_1_N : N ;
  baeckforell_nn_1_1_N : N ;
  baegarkorall_nn_1_1_N : N ;
  baegarmanet_nn_1_1_N : N ;
  baenkkamrat_nn_1_1_N : N ;
  baenkslipmaskin_nn_1_1_N : N ;
  baerm_nn_1_1_N : N ;
  baerraket_nn_1_1_N : N ;
  baervidd_nn_1_1_N : N ;
  baagsekund_nn_1_1_N : N ;
  baard_nn_1_1_N : N ;
  b_earnaise_nn_1_1_N : N ;
  boejelse_nn_1_1_N : N ;
  boejningsaendelse_nn_1_1_N : N ;
  boeld_nn_1_1_N : N ;
  boenhoerelse_nn_1_1_N : N ;
  boersstyrelse_nn_1_1_N : N ;
  cabriolet_nn_1_N : N ;
  cancertumoer_nn_1_1_N : N ;
  cape_nn_1_N : N ;
  cedilj_nn_1_N : N ;
  cell_nn_1_N : N ;
  cellkamrat_nn_1_N : N ;
  centaur_nn_1_N : N ;
  centralbank_nn_1_N : N ;
  centralgestalt_nn_1_N : N ;
  centralroerelse_nn_1_1_N : N ;
  centralstyrelse_nn_1_N : N ;
  centrifug_nn_1_N : N ;
  cerise_nn_1_N : N ;
  cert_nn_1_N : N ;
  champagne_nn_1_N : N ;
  chapeau_claque_nn_1_N : N ;
  char_nn_1_N : N ;
  charge_nn_1_N : N ;
  chartreuse_nn_1_N : N ;
  chateaubriand_nn_1_N : N ;
  chef_nn_1_N : N ;
  chemisett_nn_1_N : N ;
  chevelyr_nn_1_N : N ;
  cheviot_nn_1_N : N ;
  chock_nn_1_N : N ;
  cigarett_nn_1_N : N ;
  cigarettautomat_nn_1_N : N ;
  cigarr_nn_1_N : N ;
  cigarrcigarett_nn_1_N : N ;
  cigarrcigarrett_nn_1_N : N ;
  cigarrett_nn_1_N : N ;
  cilie_nn_1_N : N ;
  cirkelroerelse_nn_1_1_N : N ;
  cirkuselefant_nn_1_N : N ;
  cirkusmanege_nn_1_N : N ;
  ciseloer_nn_1_1_N : N ;
  cistern_nn_1_N : N ;
  citronbakelse_nn_1_N : N ;
  citronmousse_nn_1_N : N ;
  citrusfrukt_nn_1_N : N ;
  civilmilitaer_nn_1_1_N : N ;
  civilstat_nn_1_N : N ;
  clown_nn_1_N : N ;
  colibakterie_nn_1_N : N ;
  come_back_nn_1_N : N ;
  comeback_nn_1_N : N ;
  commandotrupp_nn_1_N : N ;
  cortege_nn_1_N : N ;
  cortison_nn_1_N : N ;
  corte_ge_nn_1_1_N : N ;
  coupe_nn_1_N : N ;
  coyote_nn_1_N : N ;
  creme_nn_1_N : N ;
  cre_me_nn_1_1_N : N ;
  cup_nn_1_N : N ;
  cyanobakterie_nn_1_N : N ;
  cykeltrupp_nn_1_N : N ;
  cykelventil_nn_1_N : N ;
  cyklop_nn_1_N : N ;
  cypriot_nn_1_N : N ;
  dadelpalm_nn_1_N : N ;
  dagcentral_nn_1_N : N ;
  dagerrotyp_nn_1_N : N ;
  daggpunkt_nn_1_N : N ;
  dagsbot_nn_1_N : N ;
  dagsranson_nn_1_N : N ;
  dagsversskribent_nn_1_N : N ;
  dagtid_nn_1_N : N ;
  dalbo_nn_1_N : N ;
  dalprofil_nn_1_N : N ;
  damastservett_nn_1_N : N ;
  damejeanne_nn_1_N : N ;
  dammspiral_nn_1_N : N ;
  dammsugaragent_nn_1_N : N ;
  damsko_nn_1_N : N ;
  damtoalett_nn_1_N : N ;
  dansoer_nn_1_1_N : N ;
  databank_nn_1_N : N ;
  datacentral_nn_1_N : N ;
  datafil_nn_1_N : N ;
  datamaskin_nn_1_N : N ;
  datautbytesoeverenskommelse_nn_1_1_N : N ;
  date_nn_1_N : N ;
  datormodell_nn_1_N : N ;
  debatt_nn_1_N : N ;
  debattoer_nn_1_1_N : N ;
  decharge_nn_1_N : N ;
  dechargedebatt_nn_1_N : N ;
  decimal_nn_1_N : N ;
  definitionsmaengd_nn_1_1_N : N ;
  degrand_nn_1_N : N ;
  dejtingsajt_nn_1_N : N ;
  dekad_nn_1_N : N ;
  dekal_nn_1_N : N ;
  deklamatoer_nn_1_1_N : N ;
  deklarationsblankett_nn_1_N : N ;
  dekokt_nn_1_N : N ;
  dekoratoer_nn_1_1_N : N ;
  delegat_nn_1_N : N ;
  delinkvent_nn_1_N : N ;
  delperiod_nn_1_N : N ;
  delrepublik_nn_1_N : N ;
  deltid_nn_1_N : N ;
  demagog_nn_1_N : N ;
  demarkationslinje_nn_1_N : N ;
  demimond_nn_1_N : N ;
  demiurg_nn_1_N : N ;
  demoeffekt_nn_1_N : N ;
  demokrat_nn_1_N : N ;
  demokratiroerelse_nn_1_1_N : N ;
  demonregissoer_nn_1_1_N : N ;
  demonstratoer_nn_1_1_N : N ;
  demotape_nn_1_N : N ;
  dental_nn_1_N : N ;
  deponent_nn_1_N : N ;
  descendent_nn_1_N : N ;
  desertoer_nn_1_1_N : N ;
  desinfektoer_nn_1_1_N : N ;
  despot_nn_1_N : N ;
  dessert_nn_1_N : N ;
  dessinatoer_nn_1_1_N : N ;
  dessaeng_nn_1_1_N : N ;
  destillationsapparat_nn_1_N : N ;
  destinataer_nn_1_1_N : N ;
  destinatoer_nn_1_1_N : N ;
  destruent_nn_1_N : N ;
  detachoer_nn_1_1_N : N ;
  detalj_nn_1_N : N ;
  detektivberaettelse_nn_1_1_N : N ;
  detergent_nn_1_N : N ;
  dextran_nn_1_N : N ;
  dextrin_nn_1_N : N ;
  diafilm_nn_1_N : N ;
  diagnosmetod_nn_1_N : N ;
  diagonal_nn_1_N : N ;
  diakonistyrelse_nn_1_N : N ;
  dialekt_nn_1_N : N ;
  diatrib_nn_1_N : N ;
  diet_nn_1_N : N ;
  differential_nn_1_N : N ;
  diftong_nn_1_N : N ;
  dikteringsmaskin_nn_1_N : N ;
  diminutiv_nn_1_N : N ;
  dinar_nn_1_N : N ;
  dingo_nn_1_N : N ;
  dinosaurie_nn_1_N : N ;
  diperiod_nn_1_N : N ;
  diplomat_nn_1_N : N ;
  diplomatbostad_nn_1_N : N ;
  diplomatportfoelj_nn_1_1_N : N ;
  direktkontakt_nn_1_N : N ;
  direktlinje_nn_1_N : N ;
  direktmetod_nn_1_N : N ;
  dirigent_nn_1_N : N ;
  disciplinbot_nn_1_N : N ;
  diskantklav_nn_1_N : N ;
  diskett_nn_1_N : N ;
  diskofil_nn_1_N : N ;
  diskontoer_nn_1_1_N : N ;
  dispensaer_nn_1_1_N : N ;
  disponent_nn_1_N : N ;
  dispyt_nn_1_N : N ;
  dissident_nn_1_N : N ;
  distribuent_nn_1_N : N ;
  distribunal_nn_1_N : N ;
  distributionscentral_nn_1_N : N ;
  distributoer_nn_1_1_N : N ;
  dityramb_nn_1_N : N ;
  dividend_nn_1_N : N ;
  divisionsgeneral_nn_1_N : N ;
  djonk_nn_1_N : N ;
  djupbergart_nn_1_N : N ;
  djurpark_nn_1_N : N ;
  dna_profil_nn_1_N : N ;
  docent_nn_1_N : N ;
  dockperuk_nn_1_N : N ;
  doft_nn_1_N : N ;
  dogcart_nn_1_N : N ;
  doge_nn_1_N : N ;
  dogm_nn_1_N : N ;
  dokumentportfoelj_nn_1_1_N : N ;
  dolikocefal_nn_1_N : N ;
  dom_nn_2_N : N ;
  domedagsprofet_nn_1_N : N ;
  domestik_nn_1_N : N ;
  domino_nn_1_N : N ;
  domkraft_nn_1_N : N ;
  domkyrkoadjunkt_nn_1_N : N ;
  domptoer_nn_1_1_N : N ;
  domstolsbetjaent_nn_1_1_N : N ;
  domaen_nn_1_1_N : N ;
  dopamin_nn_1_N : N ;
  dopbassaeng_nn_1_1_N : N ;
  doppsko_nn_1_N : N ;
  dorsal_nn_1_N : N ;
  dosekvivalent_nn_1_N : N ;
  doslibell_nn_1_N : N ;
  dotterson_nn_1_N : N ;
  dottertumoer_nn_1_1_N : N ;
  downperiod_nn_1_N : N ;
  dragbasun_nn_1_N : N ;
  dragkamp_nn_1_N : N ;
  dragshow_nn_1_N : N ;
  dragsko_nn_1_N : N ;
  dragstaang_nn_1_1_N : N ;
  draksaadd_nn_1_1_N : N ;
  drasut_nn_1_N : N ;
  dressyr_nn_1_N : N ;
  dressoer_nn_1_1_N : N ;
  drift_nn_2_N : N ;
  drog_nn_1_N : N ;
  drogeffekt_nn_1_N : N ;
  dromedar_nn_1_N : N ;
  dront_nn_1_N : N ;
  drottningsylt_nn_1_N : N ;
  druvboerd_nn_1_1_N : N ;
  druvsaft_nn_1_N : N ;
  dryad_nn_1_N : N ;
  draen_nn_1_1_N : N ;
  droemkandidat_nn_1_1_N : N ;
  droemskapelse_nn_1_1_N : N ;
  dubbelagent_nn_1_N : N ;
  dubbelbredd_nn_1_N : N ;
  dubbelhytt_nn_1_N : N ;
  dubbelkvartett_nn_1_N : N ;
  duchatel_nn_1_N : N ;
  duell_nn_1_N : N ;
  duett_nn_1_N : N ;
  dukat_nn_1_N : N ;
  duplett_nn_1_N : N ;
  duplik_nn_1_N : N ;
  dusoer_nn_1_1_N : N ;
  dykand_nn_1_N : N ;
  dykdalb_nn_1_N : N ;
  dyn_nn_1_N : N ;
  dynamitard_nn_1_N : N ;
  dynamo_nn_1_N : N ;
  dyrtid_nn_1_N : N ;
  dyschatell_nn_1_N : N ;
  daeckbytarhelg_nn_1_1_N : N ;
  daeckventil_nn_1_1_N : N ;
  daeckverkstad_nn_1_1_N : N ;
  daeggdjurstand_nn_1_1_N : N ;
  daeld_nn_1_1_N : N ;
  daarskap_nn_1_1_N : N ;
  doebattang_nn_1_1_N : N ;
  doedperiod_nn_1_1_N : N ;
  doedsbakterie_nn_1_1_N : N ;
  doedsfiende_nn_1_1_N : N ;
  doedshjaelpsdebatt_nn_1_1_N : N ;
  doedskamp_nn_1_1_N : N ;
  doedsklinik_nn_1_1_N : N ;
  doedspatrull_nn_1_1_N : N ;
  doedssynd_nn_1_1_N : N ;
  echelong_nn_1_N : N ;
  ed_nn_1_N : N ;
  edil_nn_1_N : N ;
  efedrin_nn_1_N : N ;
  effekt_nn_1_N : N ;
  efterboerd_nn_1_1_N : N ;
  efterfoeljelse_nn_1_1_N : N ;
  eftergift_nn_1_N : N ;
  efterklang_nn_1_N : N ;
  eftertextnot_nn_1_N : N ;
  eftertrupp_nn_1_N : N ;
  eftertraedarkandidat_nn_1_1_N : N ;
  eftervalsdebatt_nn_1_N : N ;
  egenskap_nn_1_N : N ;
  eggelse_nn_1_N : N ;
  eklog_nn_1_N : N ;
  ekonomlinje_nn_1_N : N ;
  ekoradio_nn_1_N : N ;
  ekotyp_nn_1_N : N ;
  ekvatorialzon_nn_1_N : N ;
  ekvipotentiallinje_nn_1_N : N ;
  ekvivalentvikt_nn_1_N : N ;
  eland_nn_1_N : N ;
  elapparat_nn_1_N : N ;
  elchock_nn_1_N : N ;
  eldbegaengelse_nn_1_1_N : N ;
  eldbrand_nn_1_N : N ;
  eldkanal_nn_1_N : N ;
  eldlinje_nn_1_N : N ;
  eldstad_nn_1_N : N ;
  elektrochock_nn_1_N : N ;
  elektrod_nn_1_N : N ;
  elektrolyt_nn_1_N : N ;
  elektronikkomponent_nn_1_N : N ;
  elektronroersdiod_nn_1_1_N : N ;
  elektrotyp_nn_1_N : N ;
  elementaerkraft_nn_1_1_N : N ;
  elev_nn_1_N : N ;
  elfenbenspalm_nn_1_N : N ;
  elgitarr_nn_1_N : N ;
  elitserie_nn_1_N : N ;
  elittrupp_nn_1_N : N ;
  eloge_nn_1_N : N ;
  elsevir_nn_1_N : N ;
  elvaaarsperiod_nn_1_1_N : N ;
  elzevier_nn_1_N : N ;
  elaendesfoerutsaegelse_nn_1_1_N : N ;
  emalj_nn_1_N : N ;
  emaljplomb_nn_1_N : N ;
  emaljoer_nn_1_1_N : N ;
  emir_nn_1_N : N ;
  emissarie_nn_1_N : N ;
  endiv_nn_1_N : N ;
  endossat_nn_1_N : N ;
  endossent_nn_1_N : N ;
  energiuppgoerelse_nn_1_1_N : N ;
  engaangsfoereteelse_nn_1_1_N : N ;
  engaangsservett_nn_1_1_N : N ;
  enhetsfront_nn_1_N : N ;
  enhetspatron_nn_1_N : N ;
  enkelbiljett_nn_1_N : N ;
  enkelbredd_nn_1_N : N ;
  enkelkvartett_nn_1_N : N ;
  enklav_nn_1_N : N ;
  enmansshow_nn_1_N : N ;
  ensemble_nn_1_N : N ;
  enslinje_nn_1_N : N ;
  entente_nn_1_N : N ;
  entrecote_nn_1_N : N ;
  entrecoote_nn_1_1_N : N ;
  entreprenad_nn_1_N : N ;
  entreprenoer_nn_1_1_N : N ;
  entr_ebiljett_nn_1_1_N : N ;
  entusiastsajt_nn_1_N : N ;
  eosin_nn_1_N : N ;
  epifyt_nn_1_N : N ;
  epilog_nn_1_N : N ;
  epinefrin_nn_1_N : N ;
  episod_nn_1_N : N ;
  epok_nn_1_N : N ;
  epaalett_nn_1_1_N : N ;
  ergonom_nn_1_N : N ;
  erinnye_nn_1_N : N ;
  erosionsstrand_nn_1_N : N ;
  eruptivbergart_nn_1_N : N ;
  erytropoitin_nn_1_N : N ;
  eskapad_nn_1_N : N ;
  eskarp_nn_1_N : N ;
  eskort_nn_1_N : N ;
  eskulap_nn_1_N : N ;
  espadrill_nn_1_N : N ;
  espagnolett_nn_1_N : N ;
  esplanad_nn_1_N : N ;
  essaeuppgift_nn_1_1_N : N ;
  estet_nn_1_N : N ;
  estraddebatt_nn_1_N : N ;
  estradoer_nn_1_1_N : N ;
  etagaer_nn_1_1_N : N ;
  etalong_nn_1_N : N ;
  etan_nn_1_N : N ;
  etapp_nn_1_N : N ;
  etapplinje_nn_1_N : N ;
  etikett_nn_1_N : N ;
  etiop_nn_1_N : N ;
  etnograf_nn_1_N : N ;
  eunuck_nn_1_N : N ;
  evakostym_nn_1_N : N ;
  evertebrat_nn_1_N : N ;
  evighetsmaskin_nn_1_N : N ;
  examinand_nn_1_N : N ;
  excerpt_nn_1_N : N ;
  exeget_nn_1_N : N ;
  exekutoer_nn_1_1_N : N ;
  exilhuvudstad_nn_1_N : N ;
  exoplanet_nn_1_N : N ;
  expeditionsministaer_nn_1_1_N : N ;
  expeditoer_nn_1_1_N : N ;
  expert_nn_1_N : N ;
  exploatoer_nn_1_1_N : N ;
  expo_nn_1_N : N ;
  exponent_nn_1_N : N ;
  exportoer_nn_1_1_N : N ;
  expresident_nn_1_N : N ;
  expressfoersaendelse_nn_1_1_N : N ;
  exterioer_nn_1_1_N : N ;
  extern_nn_1_N : N ;
  extraordinarie_nn_1_N : N ;
  extraranson_nn_1_N : N ;
  fabrikstomt_nn_1_N : N ;
  facett_nn_1_N : N ;
  fackfoereningsroerelse_nn_1_1_N : N ;
  fackidiot_nn_1_N : N ;
  fackterm_nn_1_N : N ;
  fadersgestalt_nn_1_N : N ;
  fagott_nn_1_N : N ;
  faiblesse_nn_1_N : N ;
  fakir_nn_1_N : N ;
  faksimile_nn_1_N : N ;
  fakultetsopponent_nn_1_N : N ;
  falang_nn_1_N : N ;
  falkonett_nn_1_N : N ;
  fallfrukt_nn_1_N : N ;
  fallskaermstrupp_nn_1_1_N : N ;
  fallstudie_nn_1_N : N ;
  familjebiljett_nn_1_N : N ;
  familjestiftelse_nn_1_N : N ;
  fanfar_nn_1_N : N ;
  fantasigestalt_nn_1_N : N ;
  fantasiprodukt_nn_1_N : N ;
  fantasiskapelse_nn_1_N : N ;
  fantasivarelse_nn_1_N : N ;
  fantom_nn_2_N : N ;
  farmaceut_nn_1_N : N ;
  farmacevt_nn_1_N : N ;
  farozon_nn_1_N : N ;
  farsot_nn_1_N : N ;
  fart_nn_1_N : N ;
  fartrand_nn_1_N : N ;
  fasad_nn_1_N : N ;
  fasett_nn_1_N : N ;
  fastighetsmogul_nn_1_N : N ;
  faststaellelse_nn_1_1_N : N ;
  fatabur_nn_1_N : N ;
  fatalietid_nn_1_N : N ;
  fatbur_nn_1_N : N ;
  faun_nn_1_N : N ;
  faute_nn_1_N : N ;
  favoritpsalm_nn_1_N : N ;
  favoritstrand_nn_1_N : N ;
  favoer_nn_1_1_N : N ;
  fejd_nn_1_N : N ;
  felmarginal_nn_1_N : N ;
  femininum_nn_1_N : N ;
  femkamp_nn_1_N : N ;
  femtekolonn_nn_1_N : N ;
  femaarsperiod_nn_1_1_N : N ;
  fenedrin_nn_1_N : N ;
  fenmetralin_nn_1_N : N ;
  fenolftalein_nn_1_N : N ;
  fenotyp_nn_1_N : N ;
  ferie_nn_1_N : N ;
  festival_nn_1_N : N ;
  festlokal_nn_1_N : N ;
  festong_nn_1_N : N ;
  fettreserv_nn_1_N : N ;
  fibrill_nn_1_N : N ;
  fiction_novell_nn_1_N : N ;
  fiende_nn_1_N : N ;
  fiendelinje_nn_1_N : N ;
  fiendskap_nn_1_N : N ;
  filial_nn_1_N : N ;
  filippik_nn_1_N : N ;
  filmfotograf_nn_1_N : N ;
  filmregissoer_nn_1_1_N : N ;
  filmscen_nn_1_N : N ;
  filmstudio_nn_1_N : N ;
  filosof_nn_1_N : N ;
  filtercigarett_nn_1_N : N ;
  filur_nn_1_N : N ;
  fimmelstaang_nn_1_1_N : N ;
  fimmerstaang_nn_1_1_N : N ;
  final_nn_1_N : N ;
  finansdebatt_nn_1_N : N ;
  finansiaer_nn_1_1_N : N ;
  fingeravtrycksaspekt_nn_1_N : N ;
  fingernerv_nn_1_N : N ;
  finnmark_nn_1_N : N ;
  finsko_nn_1_N : N ;
  fint_nn_1_N : N ;
  fiol_nn_1_N : N ;
  fiskeristyrelse_nn_1_N : N ;
  fiskezon_nn_1_N : N ;
  fjaelltrakt_nn_1_1_N : N ;
  fjaerilslarv_nn_1_1_N : N ;
  fladdermusfaatoelj_nn_1_1_N : N ;
  flagell_nn_1_N : N ;
  flagellat_nn_1_N : N ;
  flageolett_nn_1_N : N ;
  flaggkapten_nn_1_N : N ;
  flaggstaang_nn_1_1_N : N ;
  flakong_nn_1_N : N ;
  flamingo_nn_1_N : N ;
  flampunkt_nn_1_N : N ;
  flanell_nn_1_N : N ;
  flanellkostym_nn_1_N : N ;
  flanellograf_nn_1_N : N ;
  flank_nn_1_N : N ;
  flanoer_nn_1_1_N : N ;
  flervalsuppgift_nn_1_N : N ;
  flextid_nn_1_N : N ;
  flockkamrat_nn_1_N : N ;
  flod_nn_1_N : N ;
  flodprofil_nn_1_N : N ;
  flodslaett_nn_1_1_N : N ;
  flodstrand_nn_1_N : N ;
  florett_nn_1_N : N ;
  flottilj_nn_1_N : N ;
  flottyr_nn_1_N : N ;
  flottoer_nn_1_1_N : N ;
  flygbiljett_nn_1_N : N ;
  flygfrakt_nn_1_N : N ;
  flygkapten_nn_1_N : N ;
  flyglinje_nn_1_N : N ;
  flygmaskin_nn_1_N : N ;
  flygplansmodell_nn_1_N : N ;
  flykt_nn_1_N : N ;
  flaeskkotlett_nn_1_1_N : N ;
  floejt_nn_1_1_N : N ;
  floejttravaer_nn_1_1_N : N ;
  folkfront_nn_1_N : N ;
  folkkommissarie_nn_1_N : N ;
  folkkommun_nn_1_N : N ;
  folkmaengd_nn_1_1_N : N ;
  folkpark_nn_1_N : N ;
  folkrepublik_nn_1_N : N ;
  folkroerelse_nn_1_1_N : N ;
  folktribun_nn_1_N : N ;
  fondaktie_nn_1_N : N ;
  fondbestaemmelse_nn_1_1_N : N ;
  fondtapet_nn_1_N : N ;
  fondue_nn_1_N : N ;
  fonograf_nn_1_N : N ;
  fontanell_nn_1_N : N ;
  fontaen_nn_1_1_N : N ;
  forell_nn_1_N : N ;
  formbakelse_nn_1_N : N ;
  forntid_nn_1_N : N ;
  forskarassistent_nn_1_N : N ;
  fortplantningsdrift_nn_1_N : N ;
  fosterson_nn_1_N : N ;
  fotoautomat_nn_1_N : N ;
  fotocell_nn_1_N : N ;
  fotograf_nn_1_N : N ;
  fotogravyr_nn_1_N : N ;
  fotokarriaer_nn_1_1_N : N ;
  fotomodell_nn_1_N : N ;
  frakt_nn_1_N : N ;
  framkallningsapparat_nn_1_N : N ;
  framlob_nn_1_N : N ;
  framtand_nn_1_N : N ;
  framtidsfoerutsaegelse_nn_1_1_N : N ;
  frasliberal_nn_1_N : N ;
  frasradikal_nn_1_N : N ;
  fredsroerelse_nn_1_1_N : N ;
  fredsoeverenskommelse_nn_1_1_N : N ;
  fregatt_nn_1_N : N ;
  frestelse_nn_1_N : N ;
  fribiljett_nn_1_N : N ;
  fribonde_nn_1_N : N ;
  frid_nn_1_N : N ;
  frihetskamp_nn_1_N : N ;
  frikadell_nn_1_N : N ;
  frikallelse_nn_1_N : N ;
  friktionskoefficient_nn_1_N : N ;
  frikyrkoroerelse_nn_1_1_N : N ;
  frikaennelse_nn_1_1_N : N ;
  frilansskribent_nn_1_N : N ;
  frimurarloge_nn_1_N : N ;
  fristad_nn_1_N : N ;
  frisyr_nn_1_N : N ;
  frisyrgel_e_nn_1_1_N : N ;
  frisoerelev_nn_1_1_N : N ;
  fritidsbebyggelse_nn_1_N : N ;
  fritidslokal_nn_1_N : N ;
  fritidspedagog_nn_1_N : N ;
  frityr_nn_1_N : N ;
  frivakt_nn_1_N : N ;
  frivolt_nn_1_N : N ;
  fromage_nn_1_N : N ;
  frondoer_nn_1_1_N : N ;
  front_nn_1_N : N ;
  frontallob_nn_1_N : N ;
  frontfoerbindelse_nn_1_1_N : N ;
  frontlinje_nn_1_N : N ;
  frostnatt_nn_1_N : N ;
  fruktkompott_nn_1_N : N ;
  fruktsaft_nn_1_N : N ;
  fryspunkt_nn_1_N : N ;
  fraelsebonde_nn_1_1_N : N ;
  fraelsningssoldat_nn_1_1_N : N ;
  fraelsningsupplevelse_nn_1_1_N : N ;
  fraemlingslegionaer_nn_1_1_N : N ;
  fraende_nn_1_1_N : N ;
  fraendskap_nn_1_1_N : N ;
  fraesmaskin_nn_1_1_N : N ;
  fraagespalt_nn_1_1_N : N ;
  fraagestund_nn_1_1_N : N ;
  froeplantage_nn_1_1_N : N ;
  funktionaer_nn_1_1_N : N ;
  furie_nn_1_N : N ;
  furir_nn_1_N : N ;
  furnissoer_nn_1_1_N : N ;
  fursteaett_nn_1_1_N : N ;
  futhark_nn_1_N : N ;
  fyllerifoerseelse_nn_1_1_N : N ;
  fyrbackslinje_nn_1_N : N ;
  fyrkant_nn_1_N : N ;
  fyrkaraktaer_nn_1_1_N : N ;
  fysikvetenskap_nn_1_N : N ;
  fysiokrat_nn_1_N : N ;
  faedernestad_nn_1_1_N : N ;
  faeltassistent_nn_1_1_N : N ;
  faeltspat_nn_1_1_N : N ;
  faengelsecell_nn_1_1_N : N ;
  faengelsekund_nn_1_1_N : N ;
  faerd_nn_1_1_N : N ;
  faerdbiljett_nn_1_1_N : N ;
  faergsprutpistol_nn_1_1_N : N ;
  faergstoff_nn_1_1_N : N ;
  faerskmalm_nn_1_1_N : N ;
  faesoer_nn_1_1_N : N ;
  faarfiol_nn_1_1_N : N ;
  faat_nn_1_1_N : N ;
  faatoelj_nn_1_1_N : N ;
  foedelse_nn_1_1_N : N ;
  foedelsekontroll_nn_1_1_N : N ;
  foedelsestad_nn_1_1_N : N ;
  foeljetong_nn_1_1_N : N ;
  foerarhytt_nn_1_1_N : N ;
  foerbannelse_nn_1_1_N : N ;
  foerberedelse_nn_1_1_N : N ;
  foerbindelse_nn_1_1_N : N ;
  foerbindelselinje_nn_1_1_N : N ;
  foerbrytelse_nn_1_1_N : N ;
  foerbundskapten_nn_1_1_N : N ;
  foerbundspresident_nn_1_1_N : N ;
  foerbundsrepublik_nn_1_1_N : N ;
  foerbundsstyrelse_nn_1_1_N : N ;
  foerebraaelse_nn_1_1_N : N ;
  foereningsbank_nn_1_1_N : N ;
  foereningslokal_nn_1_1_N : N ;
  foereningsmaengd_nn_1_1_N : N ;
  foereningsroerelse_nn_1_1_N : N ;
  foeretagsfilial_nn_1_1_N : N ;
  foeretagsstyrelse_nn_1_1_N : N ;
  foereteelse_nn_1_1_N : N ;
  foerfoeljelse_nn_1_1_N : N ;
  foerfoerelse_nn_1_1_N : N ;
  foergripelse_nn_1_1_N : N ;
  foergrund_nn_1_1_N : N ;
  foergrundsgestalt_nn_1_1_N : N ;
  foerhand_nn_1_1_N : N ;
  foerhandlingsmodell_nn_1_1_N : N ;
  foerhandsbukt_nn_1_1_N : N ;
  foerklaringsmodell_nn_1_1_N : N ;
  foerkrigstid_nn_1_1_N : N ;
  foerkunnelse_nn_1_1_N : N ;
  foerlossningsklinik_nn_1_1_N : N ;
  foerlossningstaang_nn_1_1_N : N ;
  foerlustelse_nn_1_1_N : N ;
  foerlaat_nn_1_1_N : N ;
  foermaan_nn_1_1_N : N ;
  foermoerkelse_nn_1_1_N : N ;
  foernatt_nn_1_1_N : N ;
  foernekelse_nn_1_1_N : N ;
  foernimmelse_nn_1_1_N : N ;
  foernyelse_nn_1_1_N : N ;
  foernaermelse_nn_1_1_N : N ;
  foernoejelse_nn_1_1_N : N ;
  foerpatrull_nn_1_1_N : N ;
  foerpliktelse_nn_1_1_N : N ;
  foersakelse_nn_1_1_N : N ;
  foersamlingsassistent_nn_1_1_N : N ;
  foerseelse_nn_1_1_N : N ;
  foerskraeckelse_nn_1_1_N : N ;
  foerstad_nn_1_1_N : N ;
  foerstaklassbiljett_nn_1_1_N : N ;
  foerstaklasshytt_nn_1_1_N : N ;
  foerstavelse_nn_1_1_N : N ;
  foerstoringsapparat_nn_1_1_N : N ;
  foerstroeelse_nn_1_1_N : N ;
  foerstudie_nn_1_1_N : N ;
  foerstaang_nn_1_1_N : N ;
  foerstoerelse_nn_1_1_N : N ;
  foersummelse_nn_1_1_N : N ;
  foersvarskraft_nn_1_1_N : N ;
  foersvarslinje_nn_1_1_N : N ;
  foersyndelse_nn_1_1_N : N ;
  foersaekringsagent_nn_1_1_N : N ;
  foersaekringspremie_nn_1_1_N : N ;
  foersaendelse_nn_1_1_N : N ;
  foersoeksballong_nn_1_1_N : N ;
  foertidsboerd_nn_1_1_N : N ;
  foertrupp_nn_1_1_N : N ;
  foerutbestaemmelse_nn_1_1_N : N ;
  foerutsaegelse_nn_1_1_N : N ;
  foervaltningsberaettelse_nn_1_1_N : N ;
  foervillelse_nn_1_1_N : N ;
  foeraeldrafoermaan_nn_1_1_N : N ;
  foeraelskelse_nn_1_1_N : N ;
  foeraendringstakt_nn_1_1_N : N ;
  foeroedelse_nn_1_1_N : N ;
  foeroedmjukelse_nn_1_1_N : N ;
  g_klav_nn_1_N : N ;
  gaffelantilop_nn_1_N : N ;
  gaffelklo_nn_1_N : N ;
  gagat_nn_1_N : N ;
  gaillarde_nn_1_N : N ;
  galat_nn_1_N : N ;
  galenskap_nn_1_N : N ;
  gall_nn_1_N : N ;
  gallko_nn_1_N : N ;
  galvanotyp_nn_1_N : N ;
  galaer_nn_1_1_N : N ;
  gamet_nn_1_N : N ;
  gammaglobulin_nn_1_N : N ;
  gamaeng_nn_1_1_N : N ;
  ganymed_nn_1_N : N ;
  gard_nn_1_N : N ;
  garderob_nn_1_N : N ;
  garderobiaer_nn_1_1_N : N ;
  garderobsstaang_nn_1_1_N : N ;
  gardinstaang_nn_1_1_N : N ;
  garnison_nn_1_N : N ;
  garsong_nn_1_N : N ;
  gas_nn_2_N : N ;
  gasett_nn_1_N : N ;
  gaskromatograf_nn_1_N : N ;
  gasoltub_nn_1_N : N ;
  gastronom_nn_1_N : N ;
  gasventil_nn_1_N : N ;
  gatumusikant_nn_1_N : N ;
  gayal_nn_1_N : N ;
  gecko_nn_1_N : N ;
  gejd_nn_1_N : N ;
  gel_e_nn_1_1_N : N ;
  gemaal_nn_1_1_N : N ;
  gendarm_nn_1_N : N ;
  genealog_nn_1_N : N ;
  general_nn_1_N : N ;
  generalagent_nn_1_N : N ;
  generalloejtnant_nn_1_1_N : N ;
  generalsperson_nn_1_N : N ;
  genett_nn_1_N : N ;
  genie_nn_1_N : N ;
  genmanipulationsteknik_nn_1_N : N ;
  genomfart_nn_1_N : N ;
  genre_nn_1_N : N ;
  gensaegelse_nn_1_1_N : N ;
  geodet_nn_1_N : N ;
  geograf_nn_1_N : N ;
  geosynklinal_nn_1_N : N ;
  gepard_nn_1_N : N ;
  geridong_nn_1_N : N ;
  gerillaroerelse_nn_1_1_N : N ;
  gestalt_nn_1_N : N ;
  gesaell_nn_1_1_N : N ;
  gevaersgranat_nn_1_1_N : N ;
  gevaerspatron_nn_1_1_N : N ;
  ghasel_nn_1_N : N ;
  giftapparat_nn_1_N : N ;
  giftinformationscentral_nn_1_N : N ;
  gifttand_nn_1_N : N ;
  gigue_nn_1_N : N ;
  ginstkatt_nn_1_N : N ;
  gips_nn_1_N : N ;
  gipyr_nn_1_N : N ;
  giraff_nn_1_N : N ;
  girandole_nn_1_N : N ;
  gitarr_nn_1_N : N ;
  givakt_nn_1_N : N ;
  gjutmodell_nn_1_N : N ;
  gjutrand_nn_1_N : N ;
  glacialperiod_nn_1_N : N ;
  glansperiod_nn_1_N : N ;
  glansroll_nn_1_N : N ;
  glanstid_nn_1_N : N ;
  glassdessert_nn_1_N : N ;
  glassmaskin_nn_1_N : N ;
  glasyr_nn_1_N : N ;
  glesbygd_nn_1_N : N ;
  glidkraem_nn_1_1_N : N ;
  globulin_nn_1_N : N ;
  glossematik_nn_1_N : N ;
  glaedjebetygelse_nn_1_1_N : N ;
  gloedkatod_nn_1_1_N : N ;
  gnagtand_nn_1_N : N ;
  gobelaeng_nn_1_1_N : N ;
  godvikt_nn_1_N : N ;
  golf_nn_2_N : N ;
  golgiapparat_nn_1_N : N ;
  golvramp_nn_1_N : N ;
  gonad_nn_1_N : N ;
  gondoljaer_nn_1_1_N : N ;
  gonfaloniaer_nn_1_1_N : N ;
  gonokock_nn_1_N : N ;
  gottgoerelse_nn_1_1_N : N ;
  gouache_nn_1_N : N ;
  gourmand_nn_1_N : N ;
  gourmet_nn_1_N : N ;
  grace_nn_1_N : N ;
  gradient_nn_1_N : N ;
  gradualpsalm_nn_1_N : N ;
  granat_nn_1_N : N ;
  granatchock_nn_1_N : N ;
  granataepplejuice_nn_1_1_N : N ;
  grand_nn_2_N : N ;
  grandseigneur_nn_1_N : N ;
  grangirlang_nn_1_N : N ;
  grannlaat_nn_1_1_N : N ;
  grapefrukt_nn_1_N : N ;
  gratial_nn_1_N : N ;
  gratie_nn_1_N : N ;
  gratisaktie_nn_1_N : N ;
  gravand_nn_1_N : N ;
  gravitationskraft_nn_1_N : N ;
  gravrelief_nn_1_N : N ;
  gravsed_nn_1_N : N ;
  gravoer_nn_1_1_N : N ;
  green_nn_1_N : N ;
  grek_nn_1_N : N ;
  grekcypriot_nn_1_N : N ;
  grenadin_nn_1_N : N ;
  grenadjaer_nn_1_1_N : N ;
  grift_nn_1_N : N ;
  grisaille_nn_1_N : N ;
  grisbonde_nn_1_N : N ;
  grisett_nn_1_N : N ;
  grisinsulin_nn_1_N : N ;
  grogrund_nn_1_N : N ;
  grossoer_nn_1_1_N : N ;
  grund_nn_1_N : N ;
  grundbetydelse_nn_1_N : N ;
  grundkaraktaer_nn_1_1_N : N ;
  grundkraft_nn_1_N : N ;
  grundlinje_nn_1_N : N ;
  grundperiod_nn_1_N : N ;
  grustaekt_nn_1_1_N : N ;
  gruvdrift_nn_1_N : N ;
  graeddbakelse_nn_1_1_N : N ;
  graemelse_nn_1_1_N : N ;
  graend_nn_1_1_N : N ;
  graensbo_nn_1_1_N : N ;
  graensintaekt_nn_1_1_N : N ;
  graenslinje_nn_1_1_N : N ;
  graensstad_nn_1_1_N : N ;
  graenstrakt_nn_1_1_N : N ;
  graesand_nn_1_1_N : N ;
  graabo_nn_1_1_N : N ;
  guatemaltek_nn_1_N : N ;
  guckusko_nn_1_N : N ;
  gudsfoernekelse_nn_1_1_N : N ;
  gudson_nn_1_N : N ;
  gudstjaenstlokal_nn_1_1_N : N ;
  gudsupplevelse_nn_1_N : N ;
  guide_nn_1_N : N ;
  guldbarr_nn_1_N : N ;
  guldberlock_nn_1_N : N ;
  guldmedalj_nn_1_N : N ;
  guldmedaljoer_nn_1_1_N : N ;
  guldreserv_nn_1_N : N ;
  guldtand_nn_1_N : N ;
  gummiparagraf_nn_1_N : N ;
  gummiplantage_nn_1_N : N ;
  gustavadolfsbakelse_nn_1_N : N ;
  gymnasielinje_nn_1_N : N ;
  gymnastiksko_nn_1_N : N ;
  gymnosperm_nn_1_N : N ;
  gympasko_nn_1_N : N ;
  gyrohorisont_nn_1_N : N ;
  gaeldenaer_nn_1_1_N : N ;
  gaerd_nn_1_1_N : N ;
  gaerningsmannaprofil_nn_1_1_N : N ;
  gaestnatt_nn_1_1_N : N ;
  gaabortskostym_nn_1_1_N : N ;
  gaangart_nn_1_1_N : N ;
  gaangbergart_nn_1_1_N : N ;
  gaanggrift_nn_1_1_N : N ;
  gaangtrafikant_nn_1_1_N : N ;
  gaardsmusikant_nn_1_1_N : N ;
  gaardstomt_nn_1_1_N : N ;
  goedselstad_nn_1_1_N : N ;
  hallonsaft_nn_1_N : N ;
  hallonsylt_nn_1_N : N ;
  haloeffekt_nn_1_N : N ;
  halogen_nn_1_N : N ;
  halsboeld_nn_1_1_N : N ;
  halstablett_nn_1_N : N ;
  halvkolonn_nn_1_N : N ;
  halvkonserv_nn_1_N : N ;
  halvmesyr_nn_1_N : N ;
  halvmetall_nn_1_N : N ;
  halvnot_nn_1_N : N ;
  halvpart_nn_1_N : N ;
  halvprofil_nn_1_N : N ;
  halvvokal_nn_1_N : N ;
  hamnbassaeng_nn_1_1_N : N ;
  hamnkapten_nn_1_N : N ;
  hamnstad_nn_1_N : N ;
  hamnstyrelse_nn_1_N : N ;
  hand_nn_1_N : N ;
  handelsbank_nn_1_N : N ;
  handelsstad_nn_1_N : N ;
  handgranat_nn_1_N : N ;
  handroerelse_nn_1_1_N : N ;
  handvolt_nn_1_N : N ;
  hangar_nn_1_N : N ;
  haptoglobin_nn_1_N : N ;
  harang_nn_1_N : N ;
  harpun_nn_1_N : N ;
  hartsfiol_nn_1_N : N ;
  haschcigarett_nn_1_N : N ;
  hausse_nn_1_N : N ;
  havskatt_nn_1_N : N ;
  havsnymf_nn_1_N : N ;
  havsstrand_nn_1_N : N ;
  hedersbetygelse_nn_1_N : N ;
  hedersledamot_nn_1_N : N ;
  hedersmedalj_nn_1_N : N ;
  hedersskuld_nn_1_N : N ;
  hedersutmaerkelse_nn_1_1_N : N ;
  hekatomb_nn_1_N : N ;
  hektograf_nn_1_N : N ;
  helbraegdagoerelse_nn_1_1_N : N ;
  helg_nn_1_N : N ;
  helgonkult_nn_1_N : N ;
  helhetssyn_nn_1_N : N ;
  helikopterpilot_nn_1_N : N ;
  heliograf_nn_1_N : N ;
  heliostat_nn_1_N : N ;
  heliotrop_nn_1_N : N ;
  helkonserv_nn_1_N : N ;
  hellen_nn_1_N : N ;
  helnot_nn_1_N : N ;
  helvetesmaskin_nn_1_N : N ;
  helaakersbygd_nn_1_1_N : N ;
  hembygd_nn_1_N : N ;
  hemgift_nn_1_N : N ;
  hemisfaer_nn_1_1_N : N ;
  hemkonsulent_nn_1_N : N ;
  hemmason_nn_1_N : N ;
  hemoglobin_nn_1_N : N ;
  hemstad_nn_1_N : N ;
  hemsoekelse_nn_1_1_N : N ;
  hemtrakt_nn_1_N : N ;
  heparin_nn_1_N : N ;
  herdefloejt_nn_1_1_N : N ;
  herdestund_nn_1_N : N ;
  herm_nn_1_N : N ;
  heroin_nn_1_N : N ;
  herrsko_nn_1_N : N ;
  herrtoalett_nn_1_N : N ;
  hetaer_nn_1_1_N : N ;
  hieroglyf_nn_1_N : N ;
  hillebard_nn_1_N : N ;
  himmelspol_nn_1_N : N ;
  himmelssfaer_nn_1_1_N : N ;
  hippodrom_nn_1_N : N ;
  hird_nn_1_N : N ;
  historiett_nn_1_N : N ;
  historik_nn_1_N : N ;
  historiograf_nn_1_N : N ;
  hitteloen_nn_1_1_N : N ;
  hjortronsylt_nn_1_N : N ;
  hjaelplinje_nn_1_1_N : N ;
  hjaelptrupp_nn_1_1_N : N ;
  hjaeltbragd_nn_1_1_N : N ;
  hjaeltebragd_nn_1_1_N : N ;
  hjaerntumoer_nn_1_1_N : N ;
  hjaertattack_nn_1_1_N : N ;
  hjaertinfarkt_nn_1_1_N : N ;
  hjaertkramp_nn_1_1_N : N ;
  hjaertlungmaskin_nn_1_1_N : N ;
  hjaertpunkt_nn_1_1_N : N ;
  homeopat_nn_1_N : N ;
  homilet_nn_1_N : N ;
  homofil_nn_1_N : N ;
  honnoer_nn_1_1_N : N ;
  hord_nn_1_N : N ;
  horisont_nn_1_N : N ;
  horisontlinje_nn_1_N : N ;
  horroer_nn_1_1_N : N ;
  hortonom_nn_1_N : N ;
  hotellbrand_nn_1_N : N ;
  hotelse_nn_1_N : N ;
  hottentott_nn_1_N : N ;
  hovbetjaent_nn_1_1_N : N ;
  hovraettspresident_nn_1_1_N : N ;
  hovstat_nn_1_N : N ;
  hovtaang_nn_1_1_N : N ;
  hudkraem_nn_1_1_N : N ;
  hugenott_nn_1_N : N ;
  huggtand_nn_1_N : N ;
  humuskomponent_nn_1_N : N ;
  hunddressyr_nn_1_N : N ;
  hundpatrull_nn_1_N : N ;
  hundraaarsperiod_nn_1_1_N : N ;
  husandakt_nn_1_N : N ;
  husar_nn_1_N : N ;
  husbonde_nn_1_N : N ;
  husesyn_nn_1_N : N ;
  hushaallsassistent_nn_1_1_N : N ;
  huskur_nn_1_N : N ;
  hustyrann_nn_1_N : N ;
  huvudgaerd_nn_1_1_N : N ;
  huvudlinje_nn_1_N : N ;
  huvudroerelse_nn_1_1_N : N ;
  huvudstad_nn_1_N : N ;
  huvudvaerkstablett_nn_1_1_N : N ;
  hyacint_nn_1_N : N ;
  hydrofyt_nn_1_N : N ;
  hyf_nn_1_N : N ;
  hygrograf_nn_1_N : N ;
  hymn_nn_1_N : N ;
  hypnotisoer_nn_1_1_N : N ;
  hyresbostad_nn_1_N : N ;
  hyreskasern_nn_1_N : N ;
  hytt_nn_1_N : N ;
  haedanfaerd_nn_1_1_N : N ;
  haedelse_nn_1_1_N : N ;
  haeftapparat_nn_1_1_N : N ;
  haelft_nn_1_1_N : N ;
  haelsoeffekt_nn_1_1_N : N ;
  haemsko_nn_1_1_N : N ;
  haendelse_nn_1_1_N : N ;
  haenvaendelse_nn_1_1_N : N ;
  haerdlack_nn_1_1_N : N ;
  haerold_nn_1_1_N : N ;
  haestbonde_nn_1_1_N : N ;
  haestdressyr_nn_1_1_N : N ;
  haestkraft_nn_1_1_N : N ;
  haestkur_nn_1_1_N : N ;
  haestlaengd_nn_1_1_N : N ;
  haestsko_nn_1_1_N : N ;
  haevd_nn_1_1_N : N ;
  haevstaang_nn_1_1_N : N ;
  haexfoerfoeljelse_nn_1_1_N : N ;
  haexsabbat_nn_1_1_N : N ;
  haalven_nn_1_1_N : N ;
  haardmetall_nn_1_1_N : N ;
  haarplattaang_nn_1_1_N : N ;
  hoeft_nn_1_1_N : N ;
  hoeftlinje_nn_1_1_N : N ;
  hoegerhand_nn_1_1_N : N ;
  hoeghastighetslinje_nn_1_1_N : N ;
  hoegrelief_nn_1_1_N : N ;
  hoegskoleadjunkt_nn_1_1_N : N ;
  hoegskoleguide_nn_1_1_N : N ;
  hoegslaett_nn_1_1_N : N ;
  hoegtid_nn_1_1_N : N ;
  hoegtidsstund_nn_1_1_N : N ;
  hoejdpunkt_nn_1_1_N : N ;
  hoeknatt_nn_1_1_N : N ;
  hoerapparat_nn_1_1_N : N ;
  hoerntand_nn_1_1_N : N ;
  iakttagelse_nn_1_N : N ;
  icke_angreppspakt_nn_1_N : N ;
  icke_haendelse_nn_1_1_N : N ;
  icke_metall_nn_1_N : N ;
  idiolekt_nn_1_N : N ;
  idiot_nn_1_N : N ;
  idrottsbragd_nn_1_N : N ;
  idrottsroerelse_nn_1_1_N : N ;
  idrottssko_nn_1_N : N ;
  idyll_nn_1_N : N ;
  illustratoer_nn_1_1_N : N ;
  imitatoer_nn_1_1_N : N ;
  imperfektum_nn_1_N : N ;
  imperialoktav_nn_1_N : N ;
  importoer_nn_1_1_N : N ;
  improvisationsteknik_nn_1_N : N ;
  improvisatoer_nn_1_1_N : N ;
  incident_nn_1_N : N ;
  independent_nn_1_N : N ;
  induktionsapparat_nn_1_N : N ;
  industriaktie_nn_1_N : N ;
  industrilokal_nn_1_N : N ;
  infarkt_nn_1_N : N ;
  infart_nn_1_N : N ;
  infiltratoer_nn_1_1_N : N ;
  inflationsmodell_nn_1_N : N ;
  inflationsspiral_nn_1_N : N ;
  inflationstakt_nn_1_N : N ;
  influensmaskin_nn_1_N : N ;
  inflytelse_nn_1_N : N ;
  informatoer_nn_1_1_N : N ;
  ingenjoerstrupp_nn_1_1_N : N ;
  ingivelse_nn_1_N : N ;
  ingaeld_nn_1_1_N : N ;
  ingaangspsalm_nn_1_1_N : N ;
  initial_nn_1_N : N ;
  injurie_nn_1_N : N ;
  inkallelse_nn_1_N : N ;
  inkubationstid_nn_1_N : N ;
  inkoerningsperiod_nn_1_1_N : N ;
  inlaerningsstudio_nn_1_1_N : N ;
  inneboerd_nn_1_1_N : N ;
  innegrej_nn_1_N : N ;
  innehaallsoeversikt_nn_1_1_N : N ;
  innerstad_nn_1_N : N ;
  innesko_nn_1_N : N ;
  innovatoer_nn_1_1_N : N ;
  inomhusvistelse_nn_1_N : N ;
  inredningsarkitekt_nn_1_N : N ;
  insikt_nn_1_N : N ;
  inskottsvokal_nn_1_N : N ;
  inspelningsstudio_nn_1_N : N ;
  inspicient_nn_1_N : N ;
  inspiratoer_nn_1_1_N : N ;
  installatoer_nn_1_1_N : N ;
  instiftelse_nn_1_N : N ;
  instinkt_nn_1_N : N ;
  instrumentpanel_nn_1_N : N ;
  instaellelse_nn_1_1_N : N ;
  insugningsventil_nn_1_N : N ;
  insulin_nn_1_N : N ;
  insulinchock_nn_1_N : N ;
  insurgent_nn_1_N : N ;
  insaendarskribent_nn_1_1_N : N ;
  integral_nn_1_N : N ;
  integrand_nn_1_N : N ;
  integrationsdebatt_nn_1_N : N ;
  intelligensaristokrat_nn_1_N : N ;
  intendent_nn_1_N : N ;
  intensiv_nn_1_N : N ;
  interdental_nn_1_N : N ;
  interglacial_nn_1_N : N ;
  interimsstyrelse_nn_1_N : N ;
  interioer_nn_1_1_N : N ;
  interlokutoer_nn_1_1_N : N ;
  intern_nn_1_N : N ;
  international_nn_1_N : N ;
  internetoperatoer_nn_1_1_N : N ;
  internetsajt_nn_1_N : N ;
  interpellationsdebatt_nn_1_N : N ;
  interpret_nn_1_N : N ;
  interrimspresident_nn_1_N : N ;
  intjaenandetid_nn_1_1_N : N ;
  intressent_nn_1_N : N ;
  intressesfaer_nn_1_1_N : N ;
  intrig_nn_1_N : N ;
  intrigoer_nn_1_1_N : N ;
  introduktoer_nn_1_1_N : N ;
  intaekt_nn_1_1_N : N ;
  intaektschablon_nn_1_1_N : N ;
  invertebrat_nn_1_N : N ;
  investeringsbank_nn_1_N : N ;
  investmentbank_nn_1_N : N ;
  isbalett_nn_1_N : N ;
  ischiasnerv_nn_1_N : N ;
  isfront_nn_1_N : N ;
  iskonvalje_nn_1_N : N ;
  isoleringscell_nn_1_N : N ;
  isoterm_nn_1_N : N ;
  isotop_nn_1_N : N ;
  isperiod_nn_1_N : N ;
  israel_nn_1_N : N ;
  isrand_nn_1_N : N ;
  istid_nn_1_N : N ;
  jabot_nn_1_N : N ;
  jagmodell_nn_1_N : N ;
  jaguar_nn_1_N : N ;
  jagupplevelse_nn_1_N : N ;
  jaha_upplevelse_nn_1_N : N ;
  jahaupplevelse_nn_1_N : N ;
  jakobskamp_nn_1_N : N ;
  jaktleopard_nn_1_N : N ;
  jaktsignal_nn_1_N : N ;
  jakttabell_nn_1_N : N ;
  jakttid_nn_1_N : N ;
  jamb_nn_1_N : N ;
  jamboree_nn_1_N : N ;
  janitsjar_nn_1_N : N ;
  jardinjaer_nn_1_1_N : N ;
  jargong_nn_1_N : N ;
  jazzbalett_nn_1_N : N ;
  jazzkonsert_nn_1_N : N ;
  jeremiad_nn_1_N : N ;
  jerseyko_nn_1_N : N ;
  jesuitgeneral_nn_1_N : N ;
  jetong_nn_1_N : N ;
  jodtablett_nn_1_N : N ;
  joggingsko_nn_1_N : N ;
  joint_nn_1_N : N ;
  jongloer_nn_1_1_N : N ;
  jordafaerd_nn_1_1_N : N ;
  jordartsmetall_nn_1_N : N ;
  jordatmosfaer_nn_1_1_N : N ;
  jordbruksbebyggelse_nn_1_N : N ;
  jordbruksbygd_nn_1_N : N ;
  jordgubbssaft_nn_1_N : N ;
  jordgubbssylt_nn_1_N : N ;
  jordlott_nn_1_N : N ;
  jordmetall_nn_1_N : N ;
  jordskyld_nn_1_N : N ;
  jordtaekt_nn_1_1_N : N ;
  jour_nn_1_N : N ;
  journal_nn_1_N : N ;
  jubilar_nn_1_N : N ;
  judefoerfoeljelse_nn_1_1_N : N ;
  jugoslav_nn_1_N : N ;
  juice_nn_1_N : N ;
  julgranskaramell_nn_1_N : N ;
  julhelg_nn_1_N : N ;
  julshow_nn_1_N : N ;
  jumbo_nn_1_N : N ;
  jungfruboerd_nn_1_1_N : N ;
  jaekelskap_nn_1_1_N : N ;
  jaemfoerelse_nn_1_1_N : N ;
  jaernaffaer_nn_1_1_N : N ;
  jaernbakterie_nn_1_1_N : N ;
  jaernhand_nn_1_1_N : N ;
  jaernmalm_nn_1_1_N : N ;
  jaernnatt_nn_1_1_N : N ;
  jaernstaang_nn_1_1_N : N ;
  jaernvaruaffaer_nn_1_1_N : N ;
  jaernvaegsbiljett_nn_1_1_N : N ;
  jaernvaegslinje_nn_1_1_N : N ;
  jaernaaldersbonde_nn_1_1_N : N ;
  jaernaaldersbygd_nn_1_1_N : N ;
  kabelsko_nn_1_N : N ;
  kabelskotaang_nn_1_1_N : N ;
  kadett_nn_1_N : N ;
  kadrilj_nn_1_N : N ;
  kaffeautomat_nn_1_N : N ;
  kaffetant_nn_1_N : N ;
  kaf_eroerelse_nn_1_1_N : N ;
  kaj_nn_1_N : N ;
  kajak_nn_1_N : N ;
  kajal_nn_1_N : N ;
  kajavgift_nn_1_N : N ;
  kakaolikoer_nn_1_1_N : N ;
  kakelmaskin_nn_1_N : N ;
  kakelugnsventil_nn_1_N : N ;
  kaksmet_nn_1_N : N ;
  kaktaang_nn_1_1_N : N ;
  kakuminal_nn_1_N : N ;
  kalabalik_nn_1_N : N ;
  kalciumsilikat_nn_1_N : N ;
  kalif_nn_1_N : N ;
  kalkgrund_nn_1_N : N ;
  kalktuff_nn_1_N : N ;
  kallelse_nn_1_N : N ;
  kallelsetid_nn_1_N : N ;
  kallfront_nn_1_N : N ;
  kallpunkt_nn_1_N : N ;
  kallstart_nn_1_N : N ;
  kalmuck_nn_1_N : N ;
  kaloritabell_nn_1_N : N ;
  kalott_nn_1_N : N ;
  kalvill_nn_1_N : N ;
  kalvko_nn_1_N : N ;
  kamel_nn_1_N : N ;
  kameleont_nn_1_N : N ;
  kamelopard_nn_1_N : N ;
  kamin_nn_1_N : N ;
  kammanet_nn_1_N : N ;
  kammardressyr_nn_1_N : N ;
  kamomill_nn_1_N : N ;
  kamp_nn_1_N : N ;
  kamrat_nn_1_N : N ;
  kamtsjadal_nn_1_N : N ;
  kanadick_nn_1_N : N ;
  kanak_nn_1_N : N ;
  kanal_nn_1_N : N ;
  kanalje_nn_1_N : N ;
  kandidat_nn_1_N : N ;
  kanelstaang_nn_1_1_N : N ;
  kanik_nn_1_N : N ;
  kannelyr_nn_1_N : N ;
  kanonad_nn_1_N : N ;
  kanonfotograf_nn_1_N : N ;
  kanoniaer_nn_1_1_N : N ;
  kanonjaer_nn_1_1_N : N ;
  kantele_nn_1_N : N ;
  kapillaer_nn_1_1_N : N ;
  kapitael_nn_2_1_N : N ;
  kapott_nn_1_N : N ;
  kapten_nn_1_N : N ;
  kapun_nn_1_N : N ;
  kapuschong_nn_1_N : N ;
  karabinjaer_nn_1_1_N : N ;
  karaff_nn_1_N : N ;
  karakteristik_nn_1_N : N ;
  karaktaeristik_nn_1_1_N : N ;
  karaktaersroll_nn_1_1_N : N ;
  karantaen_nn_1_1_N : N ;
  karavanseraj_nn_1_N : N ;
  karavell_nn_1_N : N ;
  karbonatsmaeltecell_nn_1_1_N : N ;
  kardel_nn_1_N : N ;
  kardinal_nn_1_N : N ;
  kardinaldygd_nn_1_N : N ;
  kardinalsynd_nn_1_N : N ;
  kardiograf_nn_1_N : N ;
  karel_nn_1_N : N ;
  karet_nn_1_N : N ;
  karikatyr_nn_1_N : N ;
  karneval_nn_1_N : N ;
  karoling_nn_1_N : N ;
  karott_nn_1_N : N ;
  karriaer_nn_1_1_N : N ;
  karriaerdiplomat_nn_1_1_N : N ;
  karronad_nn_1_N : N ;
  kartell_nn_1_N : N ;
  kartspecial_nn_1_N : N ;
  karusell_nn_1_N : N ;
  kasack_nn_1_N : N ;
  kasein_nn_1_N : N ;
  kasematt_nn_1_N : N ;
  kasern_nn_1_N : N ;
  kashmir_nn_1_N : N ;
  kassaaffaer_nn_1_1_N : N ;
  kassako_nn_1_N : N ;
  kassakontrollapparat_nn_1_N : N ;
  kassareserv_nn_1_N : N ;
  kassett_nn_1_N : N ;
  kastal_nn_1_N : N ;
  kastanje_nn_1_N : N ;
  kastmaskin_nn_1_N : N ;
  kastrat_nn_1_N : N ;
  kastrull_nn_1_N : N ;
  kasuar_nn_1_N : N ;
  katafalk_nn_1_N : N ;
  katakomb_nn_1_N : N ;
  katalog_nn_1_N : N ;
  katapult_nn_1_N : N ;
  katarakt_nn_1_N : N ;
  katastrof_nn_1_N : N ;
  katedral_nn_1_N : N ;
  kateket_nn_1_N : N ;
  katod_nn_1_N : N ;
  kattoalett_nn_1_N : N ;
  kattun_nn_1_N : N ;
  kautschukparagraf_nn_1_N : N ;
  kavaj_nn_1_N : N ;
  kavalett_nn_1_N : N ;
  kavalkad_nn_1_N : N ;
  kavall_nn_1_N : N ;
  kavallerichock_nn_1_N : N ;
  kavalleritrupp_nn_1_N : N ;
  kavern_nn_1_N : N ;
  kemikalie_nn_1_N : N ;
  kemomat_nn_1_N : N ;
  kentaur_nn_1_N : N ;
  kerub_nn_1_N : N ;
  kiasm_nn_1_N : N ;
  kibbutz_nn_1_N : N ;
  kilklacksko_nn_1_N : N ;
  kind_nn_1_N : N ;
  kindtand_nn_1_N : N ;
  kinematograf_nn_1_N : N ;
  kippsko_nn_1_N : N ;
  kirurgtaang_nn_1_1_N : N ;
  kissekatt_nn_1_N : N ;
  klackbar_nn_1_N : N ;
  klang_nn_1_N : N ;
  klapperstenstrand_nn_1_N : N ;
  klarinett_nn_1_N : N ;
  klasskamp_nn_1_N : N ;
  klasskamrat_nn_1_N : N ;
  klausul_nn_1_N : N ;
  klenaet_nn_1_1_N : N ;
  klerk_nn_1_N : N ;
  klient_nn_1_N : N ;
  klimatdebatt_nn_1_N : N ;
  klimatmodell_nn_1_N : N ;
  klimatpanel_nn_1_N : N ;
  klinik_nn_1_N : N ;
  klipptaang_nn_1_1_N : N ;
  klo_nn_1_N : N ;
  kloak_nn_1_N : N ;
  klocktid_nn_1_N : N ;
  klon_nn_1_N : N ;
  kloratom_nn_1_N : N ;
  klosett_nn_1_N : N ;
  klostercell_nn_1_N : N ;
  klosterlikoer_nn_1_1_N : N ;
  klotaang_nn_1_1_N : N ;
  klubblokal_nn_1_N : N ;
  klusil_nn_1_N : N ;
  klyft_nn_1_N : N ;
  klaedkod_nn_1_1_N : N ;
  klaettersko_nn_1_1_N : N ;
  knarkkurir_nn_1_N : N ;
  kneippkur_nn_1_N : N ;
  knejpkur_nn_1_N : N ;
  kniptaang_nn_1_1_N : N ;
  knivroerelse_nn_1_1_N : N ;
  ko_nn_1_N : N ;
  koaffoer_nn_1_1_N : N ;
  koboltkanon_nn_1_N : N ;
  kock_nn_2_N : N ;
  kodicill_nn_1_N : N ;
  koefficient_nn_1_N : N ;
  kokapparat_nn_1_N : N ;
  kokard_nn_1_N : N ;
  kokett_nn_1_N : N ;
  kokill_nn_1_N : N ;
  kokong_nn_1_N : N ;
  kokospalm_nn_1_N : N ;
  kokott_nn_1_N : N ;
  kokpunkt_nn_1_N : N ;
  koktid_nn_1_N : N ;
  kolatom_nn_1_N : N ;
  kolbrikett_nn_1_N : N ;
  koldioxidkanal_nn_1_N : N ;
  kolerabakterie_nn_1_N : N ;
  kolibakterie_nn_1_N : N ;
  kolisotop_nn_1_N : N ;
  kollaboratoer_nn_1_1_N : N ;
  kollekt_nn_1_N : N ;
  kollektivnot_nn_1_N : N ;
  kolokvint_nn_1_N : N ;
  kolonilott_nn_1_N : N ;
  kolonisatoer_nn_1_1_N : N ;
  kolonn_nn_1_N : N ;
  kolonnad_nn_1_N : N ;
  kolonnett_nn_1_N : N ;
  kolportoer_nn_1_1_N : N ;
  koltablett_nn_1_N : N ;
  kolumn_nn_1_N : N ;
  komedienn_nn_1_N : N ;
  komet_nn_1_N : N ;
  kommabacill_nn_1_N : N ;
  kommandocentral_nn_1_N : N ;
  kommendoerkapten_nn_1_1_N : N ;
  kommentar_nn_1_N : N ;
  kommissarie_nn_1_N : N ;
  kommod_nn_1_N : N ;
  kommun_nn_1_N : N ;
  kommunalstyrelse_nn_1_N : N ;
  kommunard_nn_1_N : N ;
  kommunikationsakt_nn_1_N : N ;
  kommunikationsradio_nn_1_N : N ;
  kommunikationstabell_nn_1_N : N ;
  kommunikatoer_nn_1_1_N : N ;
  kommunistsympatisoer_nn_1_1_N : N ;
  kommunstyrelse_nn_1_N : N ;
  kompaniadjutant_nn_1_N : N ;
  kompanjon_nn_1_N : N ;
  komplementmaengd_nn_1_1_N : N ;
  komplementaer_nn_1_1_N : N ;
  komplimang_nn_1_N : N ;
  kompositoer_nn_1_1_N : N ;
  kompott_nn_1_N : N ;
  kon_nn_1_N : N ;
  kondom_nn_1_N : N ;
  kondottiaer_nn_1_1_N : N ;
  konfessionarie_nn_1_N : N ;
  konfirmand_nn_1_N : N ;
  konfirmationskostym_nn_1_N : N ;
  konflikt_nn_1_N : N ;
  konklav_nn_1_N : N ;
  konkurrent_nn_1_N : N ;
  konkursdividend_nn_1_N : N ;
  konnaessoer_nn_1_1_N : N ;
  konselj_nn_1_N : N ;
  konseljpresident_nn_1_N : N ;
  konsert_nn_1_N : N ;
  konserv_nn_1_N : N ;
  konserveringsapparat_nn_1_N : N ;
  konspiratoer_nn_1_1_N : N ;
  konstart_nn_1_N : N ;
  konstruktionsgrammatik_nn_1_N : N ;
  konsulent_nn_1_N : N ;
  konsult_nn_1_N : N ;
  konteramiral_nn_1_N : N ;
  kontext_nn_1_N : N ;
  kontinent_nn_1_N : N ;
  kontingent_nn_1_N : N ;
  kontorspulpet_nn_1_N : N ;
  kontorstid_nn_1_N : N ;
  kontrahent_nn_1_N : N ;
  kontraktstid_nn_1_N : N ;
  konungalaengd_nn_1_1_N : N ;
  konungaaett_nn_1_1_N : N ;
  konvalescent_nn_1_N : N ;
  konvalje_nn_1_N : N ;
  kooperatoer_nn_1_1_N : N ;
  koordinat_nn_1_N : N ;
  kopieringsapparat_nn_1_N : N ;
  kopieringsmaskin_nn_1_N : N ;
  kopparspiral_nn_1_N : N ;
  kopparsulfat_nn_1_N : N ;
  koral_nn_1_N : N ;
  korall_nn_1_N : N ;
  kordong_nn_1_N : N ;
  koreograf_nn_1_N : N ;
  korint_nn_1_N : N ;
  korkmaskin_nn_1_N : N ;
  korksmak_nn_1_N : N ;
  kornett_nn_1_N : N ;
  korpral_nn_1_N : N ;
  korrespondent_nn_1_N : N ;
  korsar_nn_1_N : N ;
  korselett_nn_1_N : N ;
  korsett_nn_1_N : N ;
  korsfaestelse_nn_1_1_N : N ;
  korsordskonstruktoer_nn_1_1_N : N ;
  kortege_nn_1_N : N ;
  kortison_nn_1_N : N ;
  kortkatalog_nn_1_N : N ;
  korttidsvikarie_nn_1_N : N ;
  kortvaagsradio_nn_1_1_N : N ;
  korund_nn_1_N : N ;
  korvett_nn_1_N : N ;
  kosack_nn_1_N : N ;
  kosmodrom_nn_1_N : N ;
  kosmonaut_nn_1_N : N ;
  kostym_nn_1_N : N ;
  kotiljong_nn_1_N : N ;
  kotlett_nn_1_N : N ;
  koturn_nn_1_N : N ;
  kovall_nn_1_N : N ;
  krabat_nn_1_N : N ;
  kraftcentral_nn_1_N : N ;
  kraftkonsument_nn_1_N : N ;
  kraftlinje_nn_1_N : N ;
  kramp_nn_1_N : N ;
  kransartaer_nn_1_1_N : N ;
  kranskommun_nn_1_N : N ;
  kravatt_nn_1_N : N ;
  kravell_nn_1_N : N ;
  kravmaskin_nn_1_N : N ;
  kretong_nn_1_N : N ;
  krevad_nn_1_N : N ;
  krigsberedskap_nn_1_N : N ;
  krigsbrottstribunal_nn_1_N : N ;
  krigsfotograf_nn_1_N : N ;
  krigsfoerbrytartribunal_nn_1_1_N : N ;
  krigsfoerbrytelse_nn_1_1_N : N ;
  krigskorrespondent_nn_1_N : N ;
  krisjour_nn_1_N : N ;
  krissituation_nn_1_N : N ;
  kroat_nn_1_N : N ;
  krogkund_nn_1_N : N ;
  krogrecension_nn_1_N : N ;
  krogshow_nn_1_N : N ;
  krokett_nn_1_N : N ;
  kroklinje_nn_1_N : N ;
  krokodil_nn_1_N : N ;
  kromosom_nn_1_N : N ;
  kromosomavvikelse_nn_1_N : N ;
  kronjuvel_nn_1_N : N ;
  kronopark_nn_1_N : N ;
  kronoutskyld_nn_1_N : N ;
  kroppskanal_nn_1_N : N ;
  kroppsroerelse_nn_1_1_N : N ;
  krossmaskin_nn_1_N : N ;
  krumbukt_nn_1_N : N ;
  krusidull_nn_1_N : N ;
  krustad_nn_1_N : N ;
  krustaang_nn_1_1_N : N ;
  krutong_nn_1_N : N ;
  krympfilm_nn_1_N : N ;
  krympmaan_nn_1_1_N : N ;
  kryostat_nn_1_N : N ;
  kryoteknik_nn_1_N : N ;
  krypfil_nn_1_N : N ;
  kryptogam_nn_1_N : N ;
  krysantem_nn_1_N : N ;
  kryssningsraket_nn_1_N : N ;
  kraem_nn_1_1_N : N ;
  kub_nn_1_N : N ;
  kuggstaang_nn_1_1_N : N ;
  kujon_nn_1_N : N ;
  kulak_nn_1_N : N ;
  kullerstenspassage_nn_1_N : N ;
  kullkamrat_nn_1_N : N ;
  kullko_nn_1_N : N ;
  kulskrivmaskin_nn_1_N : N ;
  kult_nn_1_N : N ;
  kulturbygd_nn_1_N : N ;
  kulturchock_nn_1_N : N ;
  kulturdebatt_nn_1_N : N ;
  kulturradikal_nn_1_N : N ;
  kulturskribent_nn_1_N : N ;
  kulventil_nn_1_N : N ;
  kuloer_nn_1_1_N : N ;
  kund_nn_1_N : N ;
  kundkontakt_nn_1_N : N ;
  kungalaengd_nn_1_1_N : N ;
  kungaaett_nn_1_1_N : N ;
  kungsbonde_nn_1_N : N ;
  kungoerelse_nn_1_1_N : N ;
  kunskap_nn_1_N : N ;
  kunskapssyn_nn_1_N : N ;
  kuplett_nn_1_N : N ;
  kupong_nn_1_N : N ;
  kupp_nn_1_N : N ;
  kur_nn_1_N : N ;
  kuriosaspalt_nn_1_N : N ;
  kurskamrat_nn_1_N : N ;
  kursroerelse_nn_1_1_N : N ;
  kurtisoer_nn_1_1_N : N ;
  kustbygd_nn_1_N : N ;
  kustlinje_nn_1_N : N ;
  kustslaett_nn_1_1_N : N ;
  kuststad_nn_1_N : N ;
  kuvertavgift_nn_1_N : N ;
  kvadrat_nn_1_N : N ;
  kvarstad_nn_1_N : N ;
  kvart_nn_2_N : N ;
  kvartett_nn_1_N : N ;
  kvartil_nn_1_N : N ;
  kvidd_nn_1_N : N ;
  kvinnofrisyr_nn_1_N : N ;
  kvinnogestalt_nn_1_N : N ;
  kvinnojour_nn_1_N : N ;
  kvinnoklinik_nn_1_N : N ;
  kvinnoroerelse_nn_1_1_N : N ;
  kvint_nn_1_N : N ;
  kvintett_nn_1_N : N ;
  kvaellsvard_nn_1_1_N : N ;
  kybernetik_nn_1_N : N ;
  kylargardin_nn_1_N : N ;
  kylkonserv_nn_1_N : N ;
  kymograf_nn_1_N : N ;
  kyrassiaer_nn_1_1_N : N ;
  kyrassjaer_nn_1_1_N : N ;
  kyrkoadjunkt_nn_1_N : N ;
  kyrkoavgift_nn_1_N : N ;
  kyrkobyggnad_nn_1_N : N ;
  kyrkokonsert_nn_1_N : N ;
  kyrkoruin_nn_1_N : N ;
  kyrkostrid_nn_1_N : N ;
  kyrkosaang_nn_1_1_N : N ;
  kyrkoton_nn_1_N : N ;
  kyrkotonart_nn_1_N : N ;
  kyrkoverksamhet_nn_1_N : N ;
  kyrkstad_nn_1_N : N ;
  kyskhet_nn_1_N : N ;
  kyskhetsnorm_nn_1_N : N ;
  kaeckhet_nn_1_1_N : N ;
  kaekled_nn_1_1_N : N ;
  kaellarlokal_nn_1_1_N : N ;
  kaellskrift_nn_1_1_N : N ;
  kaemnaersraett_nn_1_1_N : N ;
  kaempagloed_nn_1_1_N : N ;
  kaenslighet_nn_1_1_N : N ;
  kaensloagitation_nn_1_1_N : N ;
  kaensloloeshet_nn_1_1_N : N ;
  kaenslosamhet_nn_1_1_N : N ;
  kaerleksaffaer_nn_1_1_N : N ;
  kaerleksakt_nn_1_1_N : N ;
  kaerleksbard_nn_1_1_N : N ;
  kaerleksbetygelse_nn_1_1_N : N ;
  kaerleksdikt_nn_1_1_N : N ;
  kaerleksdryck_nn_1_1_N : N ;
  kaerleksfoerbindelse_nn_1_1_N : N ;
  kaerlekskonflikt_nn_1_1_N : N ;
  kaerleksnatt_nn_1_1_N : N ;
  kaerleksnovell_nn_1_1_N : N ;
  kaerleksrelation_nn_1_1_N : N ;
  kaerleksrival_nn_1_1_N : N ;
  kaerlekssorg_nn_1_1_N : N ;
  kaernfamilj_nn_1_1_N : N ;
  kaernfrukt_nn_1_1_N : N ;
  kaernfullhet_nn_1_1_N : N ;
  kaernkraftinspektion_nn_1_1_N : N ;
  kaernkraftsoperatoer_nn_1_1_N : N ;
  kaernkraftsaekerhet_nn_1_1_N : N ;
  kaernlinje_nn_1_1_N : N ;
  kaernpunkt_nn_1_1_N : N ;
  kaernreaktion_nn_1_1_N : N ;
  kaerntrupp_nn_1_1_N : N ;
  kaernvapenarsenal_nn_1_1_N : N ;
  kaernvapenexplosion_nn_1_1_N : N ;
  kaernvapenmakt_nn_1_1_N : N ;
  kaernverksamhet_nn_1_1_N : N ;
  kaerrvial_nn_1_1_N : N ;
  kaervaenlighet_nn_1_1_N : N ;
  kaakstad_nn_1_1_N : N ;
  kaasoer_nn_1_1_N : N ;
  koeksmaskin_nn_1_1_N : N ;
  koeldgrad_nn_1_1_N : N ;
  koeldpol_nn_1_1_N : N ;
  koeldpunkt_nn_1_1_N : N ;
  koensakt_nn_1_1_N : N ;
  koenscell_nn_1_1_N : N ;
  koenskaraktaer_nn_1_1_N : N ;
  koensmognad_nn_1_1_N : N ;
  koensroll_nn_1_1_N : N ;
  koensskillnad_nn_1_1_N : N ;
  koensvarelse_nn_1_1_N : N ;
  koepenskap_nn_1_1_N : N ;
  koepstad_nn_1_1_N : N ;
  koer_nn_1_1_N : N ;
  koeregenskap_nn_1_1_N : N ;
  koerlektion_nn_1_1_N : N ;
  koersnaer_nn_1_1_N : N ;
  koertelcell_nn_1_1_N : N ;
  koertid_nn_1_1_N : N ;
  koettbonde_nn_1_1_N : N ;
  koetted_nn_1_1_N : N ;
  koettko_nn_1_1_N : N ;
  koettkonnaessoer_nn_1_1_N : N ;
  koettmarknad_nn_1_1_N : N ;
  koettraett_nn_1_1_N : N ;
  koettsaft_nn_1_1_N : N ;
  labial_nn_1_N : N ;
  labilitet_nn_1_N : N ;
  labiodental_nn_1_N : N ;
  laboration_nn_1_N : N ;
  laboratorieassistent_nn_1_N : N ;
  labyrint_nn_1_N : N ;
  lackfaerg_nn_1_1_N : N ;
  lacksko_nn_1_N : N ;
  lackviol_nn_1_N : N ;
  laddningstid_nn_1_N : N ;
  lagbestaemmelse_nn_1_1_N : N ;
  lagbundenhet_nn_1_N : N ;
  lagerfoeljd_nn_1_1_N : N ;
  lagerkostnad_nn_1_N : N ;
  lagerlokal_nn_1_N : N ;
  lagerserie_nn_1_N : N ;
  lagfart_nn_1_N : N ;
  lagkamrat_nn_1_N : N ;
  lagkapp_nn_1_N : N ;
  lagkapten_nn_1_N : N ;
  laglighet_nn_1_N : N ;
  laglott_nn_1_N : N ;
  lagloeshet_nn_1_1_N : N ;
  lagringskostnad_nn_1_N : N ;
  lagun_nn_1_N : N ;
  lakej_nn_1_N : N ;
  laktalbumin_nn_1_N : N ;
  laktation_nn_1_N : N ;
  lakun_nn_1_N : N ;
  lamell_nn_1_N : N ;
  lamellkontakt_nn_1_N : N ;
  lamentation_nn_1_N : N ;
  lampett_nn_1_N : N ;
  lampfabrik_nn_1_N : N ;
  landbo_nn_1_N : N ;
  landningszon_nn_1_N : N ;
  landpermission_nn_1_N : N ;
  landsantikvarie_nn_1_N : N ;
  landsarkivarie_nn_1_N : N ;
  landsfiskal_nn_1_N : N ;
  landskamp_nn_1_N : N ;
  landskommun_nn_1_N : N ;
  landsortsstad_nn_1_N : N ;
  landstingskatalog_nn_1_N : N ;
  landstingskommun_nn_1_N : N ;
  langett_nn_1_N : N ;
  lansett_nn_1_N : N ;
  lansiaer_nn_1_1_N : N ;
  lantbrukskonsulent_nn_1_N : N ;
  lantbruksnaemnd_nn_1_1_N : N ;
  lantbruksstyrelse_nn_1_N : N ;
  laryngal_nn_1_N : N ;
  laserfaerg_nn_1_1_N : N ;
  laserkanon_nn_1_N : N ;
  laserteknik_nn_1_N : N ;
  lastbarhet_nn_1_N : N ;
  lastbilsbar_nn_1_N : N ;
  lastkaj_nn_1_N : N ;
  lastlinje_nn_1_N : N ;
  lastmaskin_nn_1_N : N ;
  lastprofil_nn_1_N : N ;
  lastvattenlinje_nn_1_N : N ;
  lastzon_nn_1_N : N ;
  lasyr_nn_1_N : N ;
  latenstid_nn_1_N : N ;
  lateral_nn_1_N : N ;
  latinlinje_nn_1_N : N ;
  latitud_nn_1_N : N ;
  lattebar_nn_1_N : N ;
  lavett_nn_1_N : N ;
  lavoar_nn_1_N : N ;
  lavregion_nn_1_N : N ;
  lavyr_nn_1_N : N ;
  laxfiskeraettighet_nn_1_1_N : N ;
  laxfaerg_nn_1_1_N : N ;
  layout_nn_1_N : N ;
  layoutchef_nn_1_N : N ;
  lecitin_nn_1_N : N ;
  ledamot_nn_1_N : N ;
  ledarkult_nn_1_N : N ;
  ledarskribent_nn_1_N : N ;
  ledd_nn_1_N : N ;
  ledighet_nn_1_N : N ;
  ledinflammation_nn_1_N : N ;
  ledningsgrupp_nn_1_N : N ;
  ledningskapacitet_nn_1_N : N ;
  ledningsvaevnad_nn_1_1_N : N ;
  ledsamhet_nn_1_N : N ;
  ledsenhet_nn_1_N : N ;
  ledsnad_nn_1_N : N ;
  ledstaang_nn_1_1_N : N ;
  legalisation_nn_1_N : N ;
  legalitet_nn_1_N : N ;
  legat_nn_1_N : N ;
  legatarie_nn_1_N : N ;
  legation_nn_1_N : N ;
  legion_nn_1_N : N ;
  legionaer_nn_1_1_N : N ;
  legitimation_nn_1_N : N ;
  legitimitet_nn_1_N : N ;
  legotrupp_nn_1_N : N ;
  legymsallad_nn_1_N : N ;
  lekatt_nn_1_N : N ;
  lekdraekt_nn_1_1_N : N ;
  lekfullhet_nn_1_N : N ;
  lekkamrat_nn_1_N : N ;
  lekmannaorganisation_nn_1_N : N ;
  lekpark_nn_1_N : N ;
  leksak_nn_1_N : N ;
  lektid_nn_1_N : N ;
  lektion_nn_1_N : N ;
  lektoer_nn_1_1_N : N ;
  lemonad_nn_1_N : N ;
  leopard_nn_1_N : N ;
  lerhalt_nn_1_N : N ;
  lerslaett_nn_1_1_N : N ;
  lesion_nn_1_N : N ;
  lessenhet_nn_1_N : N ;
  lessnad_nn_1_N : N ;
  lett_nn_1_N : N ;
  leukocyt_nn_1_N : N ;
  levang_nn_1_N : N ;
  leveranstid_nn_1_N : N ;
  leverantoer_nn_1_1_N : N ;
  levercell_nn_1_N : N ;
  levnad_nn_1_N : N ;
  levnadskonstnaer_nn_1_1_N : N ;
  levnadskostnad_nn_1_N : N ;
  lexikograf_nn_1_N : N ;
  libation_nn_1_N : N ;
  libell_nn_1_N : N ;
  libration_nn_1_N : N ;
  licentiat_nn_1_N : N ;
  lid_nn_1_N : N ;
  lidelse_nn_1_N : N ;
  lidelsefullhet_nn_1_N : N ;
  liderlighet_nn_1_N : N ;
  liggetid_nn_1_N : N ;
  lignin_nn_1_N : N ;
  likaloen_nn_1_1_N : N ;
  likbjudarmin_nn_1_N : N ;
  likblaanad_nn_1_1_N : N ;
  likformighet_nn_1_N : N ;
  likfaerd_nn_1_1_N : N ;
  likgiltighet_nn_1_N : N ;
  likhet_nn_1_N : N ;
  liknelse_nn_1_N : N ;
  likstelhet_nn_1_N : N ;
  likstaellighet_nn_1_1_N : N ;
  likstaemmighet_nn_1_1_N : N ;
  likvidation_nn_1_N : N ;
  likviditet_nn_1_N : N ;
  likoer_nn_1_1_N : N ;
  liljekonvalje_nn_1_N : N ;
  lime_nn_1_N : N ;
  limfaerg_nn_1_1_N : N ;
  limit_nn_1_N : N ;
  limitation_nn_1_N : N ;
  limningsmaskin_nn_1_N : N ;
  limnograf_nn_1_N : N ;
  limousine_nn_1_N : N ;
  lingonsaft_nn_1_N : N ;
  lingonsylt_nn_1_N : N ;
  linjal_nn_1_N : N ;
  linje_nn_1_N : N ;
  linjenaemnd_nn_1_1_N : N ;
  linnedraekt_nn_1_1_N : N ;
  linoljefaerg_nn_1_1_N : N ;
  lisen_nn_1_N : N ;
  listprofil_nn_1_N : N ;
  litenhet_nn_1_N : N ;
  litograf_nn_1_N : N ;
  litteraturgenre_nn_1_N : N ;
  litteratursyn_nn_1_N : N ;
  litteratoer_nn_1_1_N : N ;
  liturg_nn_1_N : N ;
  livbojsort_nn_1_N : N ;
  live_show_nn_1_N : N ;
  livklaednad_nn_1_1_N : N ;
  livlighet_nn_1_N : N ;
  livraeddningsdraekt_nn_1_1_N : N ;
  livraett_nn_1_1_N : N ;
  livsbetingelse_nn_1_N : N ;
  livserfarenhet_nn_1_N : N ;
  livsfarlighet_nn_1_N : N ;
  livsform_nn_1_N : N ;
  livsfrukt_nn_1_N : N ;
  livsfoernekelse_nn_1_1_N : N ;
  livskamrat_nn_1_N : N ;
  livskvalitet_nn_1_N : N ;
  livslinje_nn_1_N : N ;
  livslaengd_nn_1_1_N : N ;
  livsloegn_nn_1_1_N : N ;
  livsmedelsaffaer_nn_1_1_N : N ;
  livsmedelsbutik_nn_1_N : N ;
  livsmedelsfaerg_nn_1_1_N : N ;
  livsnerv_nn_1_N : N ;
  livsreaktion_nn_1_N : N ;
  livssituation_nn_1_N : N ;
  livssyn_nn_1_N : N ;
  livsuppgift_nn_1_N : N ;
  livvakt_nn_1_N : N ;
  ljudbild_nn_1_N : N ;
  ljudfilm_nn_1_N : N ;
  ljudfoerbindelse_nn_1_1_N : N ;
  ljudhastighet_nn_1_N : N ;
  ljudkvalitet_nn_1_N : N ;
  ljudskrift_nn_1_N : N ;
  ljumhet_nn_1_N : N ;
  ljumsktrakt_nn_1_N : N ;
  ljusalf_nn_1_N : N ;
  ljusalv_nn_1_N : N ;
  ljusbild_nn_1_N : N ;
  ljusgestalt_nn_1_N : N ;
  ljushastighet_nn_1_N : N ;
  ljuskaenslighet_nn_1_1_N : N ;
  ljuspunkt_nn_1_N : N ;
  ljusramp_nn_1_N : N ;
  ljusskygghet_nn_1_N : N ;
  ljuvhet_nn_1_N : N ;
  ljuvlighet_nn_1_N : N ;
  lob_nn_1_N : N ;
  lobbyverksamhet_nn_1_N : N ;
  lockelse_nn_1_N : N ;
  lockfaerg_nn_1_1_N : N ;
  lockout_nn_1_N : N ;
  locktaang_nn_1_1_N : N ;
  lodlinje_nn_1_N : N ;
  logaritm_nn_1_N : N ;
  loge_nn_2_N : N ;
  logoped_nn_1_N : N ;
  lojalitet_nn_1_N : N ;
  lokalchef_nn_1_N : N ;
  lokalfaerg_nn_1_1_N : N ;
  lokalitet_nn_1_N : N ;
  lokaltid_nn_1_N : N ;
  lokatt_nn_1_N : N ;
  longitud_nn_1_N : N ;
  longoer_nn_1_1_N : N ;
  loppmarknad_nn_1_N : N ;
  lord_nn_1_N : N ;
  lornjett_nn_1_N : N ;
  lossningskaj_nn_1_N : N ;
  lotsled_nn_1_N : N ;
  lott_nn_1_N : N ;
  lottakaar_nn_1_1_N : N ;
  lottaroerelse_nn_1_1_N : N ;
  lounge_nn_1_N : N ;
  lovpsalm_nn_1_N : N ;
  lovsaang_nn_1_1_N : N ;
  loxodrom_nn_1_N : N ;
  luciasaang_nn_1_1_N : N ;
  luddighet_nn_1_N : N ;
  luftaffaer_nn_1_1_N : N ;
  luftakrobat_nn_1_N : N ;
  luftattack_nn_1_N : N ;
  luftballong_nn_1_N : N ;
  luftfartsmyndighet_nn_1_N : N ;
  luftfuktighet_nn_1_N : N ;
  luftfaerd_nn_1_1_N : N ;
  luftighet_nn_1_N : N ;
  luftkonditioneringsapparat_nn_1_N : N ;
  luftkub_nn_1_N : N ;
  luftkvalitet_nn_1_N : N ;
  luftled_nn_1_N : N ;
  luftmaengd_nn_1_1_N : N ;
  luftventil_nn_1_N : N ;
  luftvaegsinfektion_nn_1_1_N : N ;
  luftvaernskanon_nn_1_1_N : N ;
  luktnerv_nn_1_N : N ;
  luktvial_nn_1_N : N ;
  luktviol_nn_1_N : N ;
  luktaert_nn_1_1_N : N ;
  lumbalpunktion_nn_1_N : N ;
  lunation_nn_1_N : N ;
  lunchtid_nn_1_N : N ;
  lunginflammation_nn_1_N : N ;
  lunglob_nn_1_N : N ;
  lungsaecksinflammation_nn_1_1_N : N ;
  lungvaevnad_nn_1_1_N : N ;
  lungoert_nn_1_1_N : N ;
  lupp_nn_1_N : N ;
  lurighet_nn_1_N : N ;
  lusern_nn_1_N : N ;
  lussekatt_nn_1_N : N ;
  lustbarhet_nn_1_N : N ;
  lustfaerd_nn_1_1_N : N ;
  lustighet_nn_1_N : N ;
  lustjakt_nn_1_N : N ;
  lustpark_nn_1_N : N ;
  lustupplevelse_nn_1_N : N ;
  lutningsvariation_nn_1_N : N ;
  luxation_nn_1_N : N ;
  lycklighet_nn_1_N : N ;
  lyckoentreprenoer_nn_1_1_N : N ;
  lydelse_nn_1_N : N ;
  lydstat_nn_1_N : N ;
  lyfthoejd_nn_1_1_N : N ;
  lyftkapacitet_nn_1_N : N ;
  lyftkraft_nn_1_N : N ;
  lyftpunkt_nn_1_N : N ;
  lyktrad_nn_1_N : N ;
  lymfocyt_nn_1_N : N ;
  lysbomb_nn_1_N : N ;
  lysosom_nn_1_N : N ;
  lyspatron_nn_1_N : N ;
  lysraket_nn_1_N : N ;
  lyssnarapparat_nn_1_N : N ;
  lysterfaerg_nn_1_1_N : N ;
  lystnad_nn_1_N : N ;
  lyxighet_nn_1_N : N ;
  lyxkonsumtion_nn_1_N : N ;
  lyxlaegenhet_nn_1_1_N : N ;
  laebbighet_nn_1_1_N : N ;
  laeckerhet_nn_1_1_N : N ;
  laegenhet_nn_1_1_N : N ;
  laegenhetsbrand_nn_1_1_N : N ;
  laekarcentral_nn_1_1_N : N ;
  laekarkaar_nn_1_1_N : N ;
  laekarlegitimation_nn_1_1_N : N ;
  laekarordination_nn_1_1_N : N ;
  laekt_nn_1_1_N : N ;
  laemplighet_nn_1_1_N : N ;
  laend_nn_1_1_N : N ;
  laendergrupp_nn_1_1_N : N ;
  laengdenhet_nn_1_1_N : N ;
  laengdgrad_nn_1_1_N : N ;
  laengdprofil_nn_1_1_N : N ;
  laenkroerelse_nn_1_1_N : N ;
  laenkstation_nn_1_1_N : N ;
  laensarbetsnaemnd_nn_1_1_N : N ;
  laensarkitekt_nn_1_1_N : N ;
  laensbokstav_nn_1_1_N : N ;
  laenskod_nn_1_1_N : N ;
  laenskommunikationscentral_nn_1_1_N : N ;
  laensraett_nn_1_1_N : N ;
  laensskatteraett_nn_1_1_N : N ;
  laensskolnaemnd_nn_1_1_N : N ;
  laensstyrelse_nn_1_1_N : N ;
  laepproerelse_nn_1_1_N : N ;
  laerarkandidat_nn_1_1_N : N ;
  laerarkaar_nn_1_1_N : N ;
  laerarlegitimation_nn_1_1_N : N ;
  laerarlinje_nn_1_1_N : N ;
  laerarroll_nn_1_1_N : N ;
  laerartaethet_nn_1_1_N : N ;
  laerdomsstad_nn_1_1_N : N ;
  laerft_nn_1_1_N : N ;
  laeroanstalt_nn_1_1_N : N ;
  laeroboksnaemnd_nn_1_1_N : N ;
  laerobyggnad_nn_1_1_N : N ;
  laerodikt_nn_1_1_N : N ;
  laesapparat_nn_1_1_N : N ;
  laesart_nn_1_1_N : N ;
  laesbarhet_nn_1_1_N : N ;
  laesefrukt_nn_1_1_N : N ;
  laesesalong_nn_1_1_N : N ;
  laesfaerdighet_nn_1_1_N : N ;
  laesion_nn_1_1_N : N ;
  laeskamrat_nn_1_1_N : N ;
  laeskedryck_nn_1_1_N : N ;
  laeskighet_nn_1_1_N : N ;
  laesklinik_nn_1_1_N : N ;
  laeskstaang_nn_1_1_N : N ;
  laeskunnighet_nn_1_1_N : N ;
  laessvaarighet_nn_1_1_N : N ;
  laesupplevelse_nn_1_1_N : N ;
  laesvaerdhet_nn_1_1_N : N ;
  laettfaerdighet_nn_1_1_N : N ;
  laettmetall_nn_1_1_N : N ;
  laettnad_nn_1_1_N : N ;
  laettsamhet_nn_1_1_N : N ;
  laettsinnighet_nn_1_1_N : N ;
  laettvindighet_nn_2_1_N : N ;
  laagfaerg_nn_1_1_N : N ;
  laaghet_nn_1_1_N : N ;
  laagloeneprofil_nn_1_1_N : N ;
  laagrelief_nn_1_1_N : N ;
  laagsko_nn_1_1_N : N ;
  laagslaett_nn_1_1_N : N ;
  laaneexpedition_nn_1_1_N : N ;
  laaneform_nn_1_1_N : N ;
  laangdistansraket_nn_1_1_N : N ;
  laangfilm_nn_1_1_N : N ;
  laangfaerd_nn_1_1_N : N ;
  laanggardin_nn_1_1_N : N ;
  laanghelg_nn_1_1_N : N ;
  laangledighet_nn_1_1_N : N ;
  laangpromenad_nn_1_1_N : N ;
  laangsynthet_nn_1_1_N : N ;
  laangtur_nn_1_1_N : N ;
  laassmed_nn_1_1_N : N ;
  laatsascigarett_nn_1_1_N : N ;
  laatstoeld_nn_1_1_N : N ;
  loedmetall_nn_1_1_N : N ;
  loeftesskrift_nn_1_1_N : N ;
  loegn_nn_1_1_N : N ;
  loegnaktighet_nn_1_1_N : N ;
  loejlighet_nn_1_1_N : N ;
  loejtnant_nn_1_1_N : N ;
  loekighet_nn_1_1_N : N ;
  loenefil_nn_1_1_N : N ;
  loenefoermaan_nn_1_1_N : N ;
  loenegrad_nn_1_1_N : N ;
  loenekostnad_nn_1_1_N : N ;
  loeneroerelse_nn_1_1_N : N ;
  loeneuppgift_nn_1_1_N : N ;
  loensamhet_nn_1_1_N : N ;
  loentagarfond_nn_1_1_N : N ;
  loepteknik_nn_1_1_N : N ;
  loeptid_nn_1_1_N : N ;
  loepvikt_nn_1_1_N : N ;
  loeslighet_nn_2_1_N : N ;
  loesningsegenskap_nn_1_1_N : N ;
  loevhyddohoegtid_nn_1_1_N : N ;
  loevtaekt_nn_1_1_N : N ;
  machete_nn_1_N : N ;
  machomyt_nn_1_N : N ;
  mackapaer_nn_1_1_N : N ;
  mad_nn_1_N : N ;
  madame_nn_1_N : N ;
  madapolam_nn_1_N : N ;
  madrassfabrik_nn_1_N : N ;
  madrigal_nn_1_N : N ;
  maffiafilm_nn_1_N : N ;
  magistrat_nn_1_N : N ;
  magmabergart_nn_1_N : N ;
  magmaexplosion_nn_1_N : N ;
  magnesiumsulfat_nn_1_N : N ;
  magnetapparat_nn_1_N : N ;
  magnetisoer_nn_1_1_N : N ;
  magnetpol_nn_1_N : N ;
  magnitud_nn_1_N : N ;
  magsaft_nn_1_N : N ;
  magsaarsbakterie_nn_1_1_N : N ;
  magtrakt_nn_1_N : N ;
  magyar_nn_1_N : N ;
  mahognymotorjakt_nn_1_N : N ;
  majestaetsfoerbrytelse_nn_1_1_N : N ;
  majoritet_nn_1_N : N ;
  majoritetskoalition_nn_1_N : N ;
  majstaang_nn_1_1_N : N ;
  makaloeshet_nn_2_1_N : N ;
  maktbefogenhet_nn_1_N : N ;
  maktkamp_nn_1_N : N ;
  maktkoncentration_nn_1_N : N ;
  maktposition_nn_1_N : N ;
  maktsfaer_nn_1_1_N : N ;
  maktstrid_nn_1_N : N ;
  malm_nn_2_N : N ;
  malmfyndighet_nn_1_N : N ;
  malmhalt_nn_1_N : N ;
  malmklang_nn_1_N : N ;
  malmtaekt_nn_1_1_N : N ;
  malmoebo_nn_1_1_N : N ;
  maltdryck_nn_1_N : N ;
  maloer_nn_1_1_N : N ;
  mambo_nn_1_N : N ;
  mammutpopulation_nn_1_N : N ;
  mamsell_nn_1_N : N ;
  manbyggnad_nn_1_N : N ;
  manchesterkostym_nn_1_N : N ;
  mandatperiod_nn_1_N : N ;
  mandrill_nn_1_N : N ;
  manege_nn_1_N : N ;
  manet_nn_1_N : N ;
  mangrove_nn_1_N : N ;
  mangaardsbyggnad_nn_1_1_N : N ;
  manick_nn_1_N : N ;
  manifestation_nn_1_N : N ;
  manipulation_nn_1_N : N ;
  mankill_nn_1_N : N ;
  mannekaeng_nn_1_1_N : N ;
  mansard_nn_1_N : N ;
  manschett_nn_1_N : N ;
  mansdraekt_nn_1_1_N : N ;
  manshoejd_nn_1_1_N : N ;
  manskvartett_nn_1_N : N ;
  manskoer_nn_1_1_N : N ;
  mansperson_nn_1_N : N ;
  mantalslaengd_nn_1_1_N : N ;
  mantelroerelse_nn_1_1_N : N ;
  manual_nn_1_N : N ;
  manoeverkraft_nn_1_1_N : N ;
  mardroemsstart_nn_1_1_N : N ;
  mardroemssyn_nn_1_1_N : N ;
  marg_nn_1_N : N ;
  margarin_nn_1_N : N ;
  marginal_nn_1_N : N ;
  marginaleffekt_nn_1_N : N ;
  marginalintaekt_nn_1_1_N : N ;
  marginalkostnad_nn_1_N : N ;
  marighet_nn_1_N : N ;
  marinkaar_nn_1_1_N : N ;
  marionett_nn_1_N : N ;
  markkonflikt_nn_1_N : N ;
  marknad_nn_1_N : N ;
  marknadsfoeringskupp_nn_1_1_N : N ;
  marknadsmanipulation_nn_1_N : N ;
  marknadsmaessighet_nn_1_1_N : N ;
  marknadsreaktion_nn_1_N : N ;
  marknadsreform_nn_1_N : N ;
  markoer_nn_1_1_N : N ;
  marodoer_nn_1_1_N : N ;
  marschall_nn_1_N : N ;
  marschfart_nn_1_N : N ;
  marshmallow_nn_1_N : N ;
  marskatt_nn_1_N : N ;
  martyr_nn_1_N : N ;
  marviol_nn_1_N : N ;
  maraeng_nn_1_1_N : N ;
  maskeradbal_nn_1_N : N ;
  maskeraddraekt_nn_1_1_N : N ;
  maskinpark_nn_1_N : N ;
  maskintid_nn_1_N : N ;
  maskinverkstad_nn_1_N : N ;
  maskningsaktion_nn_1_N : N ;
  masktaethet_nn_1_1_N : N ;
  maskulinum_nn_1_N : N ;
  maskoer_nn_1_1_N : N ;
  massafabrik_nn_1_N : N ;
  massageapparat_nn_1_N : N ;
  massagefaatoelj_nn_1_1_N : N ;
  massakerklan_nn_1_N : N ;
  massillusion_nn_1_N : N ;
  massivitet_nn_1_N : N ;
  masskommunikation_nn_1_N : N ;
  masslakt_nn_1_N : N ;
  massverkanseffekt_nn_1_N : N ;
  massvaaldtaekt_nn_1_1_N : N ;
  massoer_nn_1_1_N : N ;
  mastodont_nn_1_N : N ;
  masturbation_nn_1_N : N ;
  matbutik_nn_1_N : N ;
  materialisation_nn_1_N : N ;
  materie_nn_1_N : N ;
  matfrukt_nn_1_N : N ;
  matkupong_nn_1_N : N ;
  matlagningsskicklighet_nn_1_N : N ;
  matnyttighet_nn_1_N : N ;
  matpatrull_nn_1_N : N ;
  matranson_nn_1_N : N ;
  matroskostym_nn_1_N : N ;
  matraett_nn_1_1_N : N ;
  matsalong_nn_1_N : N ;
  matsmaeltningsapparat_nn_1_1_N : N ;
  matsmaeltningskanal_nn_1_1_N : N ;
  matthet_nn_1_N : N ;
  mattighet_nn_1_N : N ;
  mattkamp_nn_1_N : N ;
  matvaruaffaer_nn_1_1_N : N ;
  maxfart_nn_1_N : N ;
  maxhastighet_nn_1_N : N ;
  maxill_nn_1_N : N ;
  maxiloen_nn_1_1_N : N ;
  maxim_nn_1_N : N ;
  maximipunkt_nn_1_N : N ;
  mecenat_nn_1_N : N ;
  medalj_nn_1_N : N ;
  medaljong_nn_1_N : N ;
  medaljoer_nn_1_1_N : N ;
  medborgarraettsroerelse_nn_1_1_N : N ;
  medborgenaer_nn_1_1_N : N ;
  medeldistansraket_nn_1_N : N ;
  medelhastighet_nn_1_N : N ;
  medelhoejd_nn_1_1_N : N ;
  medellivslaengd_nn_1_1_N : N ;
  medellaengd_nn_1_1_N : N ;
  medelpunkt_nn_1_N : N ;
  medelsoltid_nn_1_N : N ;
  medelsvensson_nn_1_N : N ;
  medfinansiaer_nn_1_1_N : N ;
  mediabild_nn_1_N : N ;
  medicinalstyrelse_nn_1_N : N ;
  mediebild_nn_1_N : N ;
  mediekanal_nn_1_N : N ;
  mediemogul_nn_1_N : N ;
  medieteknik_nn_1_N : N ;
  medietrend_nn_1_N : N ;
  medieval_nn_1_N : N ;
  meditation_nn_1_N : N ;
  mediuppgift_nn_1_N : N ;
  medlarroll_nn_1_N : N ;
  medlemsavgift_nn_1_N : N ;
  medlemsstat_nn_1_N : N ;
  medlingskommission_nn_1_N : N ;
  medregent_nn_1_N : N ;
  medresenaer_nn_1_1_N : N ;
  medtrafikant_nn_1_N : N ;
  medvetenhet_nn_1_N : N ;
  megakollision_nn_1_N : N ;
  megaskuld_nn_1_N : N ;
  mejerifabrik_nn_1_N : N ;
  melatoninproduktion_nn_1_N : N ;
  melioration_nn_1_N : N ;
  mellanakt_nn_1_N : N ;
  mellanchef_nn_1_N : N ;
  mellanform_nn_1_N : N ;
  mellanhand_nn_1_N : N ;
  mellankrigstid_nn_1_N : N ;
  mellanraett_nn_1_1_N : N ;
  mellanskillnad_nn_1_N : N ;
  mellantid_nn_1_N : N ;
  mened_nn_1_N : N ;
  menighet_nn_1_N : N ;
  meningsbyggnad_nn_1_N : N ;
  meningsfraende_nn_1_1_N : N ;
  meningsloeshet_nn_1_1_N : N ;
  meningsskiljaktighet_nn_1_N : N ;
  menloeshet_nn_1_1_N : N ;
  menstruation_nn_1_N : N ;
  mentalitet_nn_1_N : N ;
  mentalklinik_nn_1_N : N ;
  menuett_nn_1_N : N ;
  meridianhoejd_nn_1_1_N : N ;
  merkostnad_nn_1_N : N ;
  meskalin_nn_1_N : N ;
  mesopotam_nn_1_N : N ;
  mestgynnadnation_nn_1_N : N ;
  metacenterhoejd_nn_1_1_N : N ;
  metall_nn_1_N : N ;
  metallatom_nn_1_N : N ;
  metallicfaerg_nn_1_1_N : N ;
  metallkapmaskin_nn_1_N : N ;
  metallspiral_nn_1_N : N ;
  metallurg_nn_1_N : N ;
  metallvikt_nn_1_N : N ;
  metan_nn_1_N : N ;
  metatablett_nn_1_N : N ;
  meterprototyp_nn_1_N : N ;
  metod_nn_1_N : N ;
  metodsynpunkt_nn_1_N : N ;
  metodvetenskap_nn_1_N : N ;
  metro_nn_1_N : N ;
  metronom_nn_1_N : N ;
  micro_nn_1_N : N ;
  middagshoejd_nn_1_1_N : N ;
  middagstid_nn_1_N : N ;
  middagstystnad_nn_1_N : N ;
  midjetrakt_nn_1_N : N ;
  midskeppssektion_nn_1_N : N ;
  midsommarhelg_nn_1_N : N ;
  midsommarnatt_nn_1_N : N ;
  midsommarstaang_nn_1_1_N : N ;
  midsommartid_nn_1_N : N ;
  migration_nn_1_N : N ;
  migrationskommissionaer_nn_1_1_N : N ;
  migraenattack_nn_1_1_N : N ;
  mikro_nn_1_N : N ;
  mikroalg_nn_1_N : N ;
  mikrob_nn_1_N : N ;
  mikrofilm_nn_1_N : N ;
  mikrofonteknik_nn_1_N : N ;
  mikrosekund_nn_1_N : N ;
  mikrotom_nn_1_N : N ;
  mildhet_nn_1_N : N ;
  militaer_nn_1_1_N : N ;
  militaerkupp_nn_1_1_N : N ;
  militaermakt_nn_1_1_N : N ;
  militaerpromenad_nn_1_1_N : N ;
  militaeruniform_nn_1_1_N : N ;
  miljardaffaer_nn_1_1_N : N ;
  miljardaer_nn_1_1_N : N ;
  miljonpublik_nn_1_N : N ;
  miljonstad_nn_1_N : N ;
  miljonaer_nn_1_1_N : N ;
  miljoegiftshalt_nn_1_1_N : N ;
  miljoetidskrift_nn_1_1_N : N ;
  mim_nn_1_N : N ;
  mimosasallad_nn_1_N : N ;
  min_nn_1_N : N ;
  minaret_nn_1_N : N ;
  minbomb_nn_1_N : N ;
  mineralfaerg_nn_1_1_N : N ;
  mineralhalt_nn_1_N : N ;
  mineralog_nn_1_N : N ;
  minexplosion_nn_1_N : N ;
  minimiloen_nn_1_1_N : N ;
  minimipunkt_nn_1_N : N ;
  ministeransvarighet_nn_1_N : N ;
  ministerportfoelj_nn_1_1_N : N ;
  ministerpresident_nn_1_N : N ;
  ministerstyrelse_nn_1_N : N ;
  ministertaburett_nn_1_N : N ;
  ministaer_nn_1_1_N : N ;
  minnesbild_nn_1_N : N ;
  minnesenhet_nn_1_N : N ;
  minnesfond_nn_1_N : N ;
  minnesfunktion_nn_1_N : N ;
  minnesgaerd_nn_1_1_N : N ;
  minneskonstnaer_nn_1_1_N : N ;
  minneskunskap_nn_1_N : N ;
  minnesrymd_nn_1_N : N ;
  minnesskrift_nn_1_N : N ;
  minnesstod_nn_1_N : N ;
  minnesaang_nn_1_1_N : N ;
  minoritet_nn_1_N : N ;
  mintlikoer_nn_1_1_N : N ;
  minuend_nn_1_N : N ;
  minusgrad_nn_1_N : N ;
  minuspol_nn_1_N : N ;
  minoer_nn_1_1_N : N ;
  mirabell_nn_1_N : N ;
  mirakelkur_nn_1_N : N ;
  misantrop_nn_1_N : N ;
  missbruksproblematik_nn_1_N : N ;
  missfirmelse_nn_1_N : N ;
  missgynnsamhet_nn_1_N : N ;
  misshandelsscen_nn_1_N : N ;
  misshaellighet_nn_1_1_N : N ;
  mission_nn_1_N : N ;
  missionsstation_nn_1_N : N ;
  missionaer_nn_1_1_N : N ;
  missnoejesaktion_nn_1_1_N : N ;
  misstankegrad_nn_1_N : N ;
  misstaenksamhet_nn_1_1_N : N ;
  misaer_nn_1_1_N : N ;
  mitokondrie_nn_1_N : N ;
  mittlinje_nn_1_N : N ;
  mittpunkt_nn_1_N : N ;
  mittpunktsnormal_nn_1_N : N ;
  mjukhet_nn_1_N : N ;
  mjukvaevnad_nn_1_1_N : N ;
  mjoelkaffaer_nn_1_1_N : N ;
  mjoelkbar_nn_1_1_N : N ;
  mjoelkbonde_nn_1_1_N : N ;
  mjoelkcell_nn_1_1_N : N ;
  mjoelkcentral_nn_1_1_N : N ;
  mjoelkkanal_nn_1_1_N : N ;
  mjoelkko_nn_1_1_N : N ;
  mjoelkproducent_nn_1_1_N : N ;
  mjoelkprodukt_nn_1_1_N : N ;
  mjoelkproduktion_nn_1_1_N : N ;
  mjoelksaft_nn_1_1_N : N ;
  mjoelksyrebakterie_nn_1_1_N : N ;
  mjoelktand_nn_1_1_N : N ;
  mjoelkoert_nn_1_1_N : N ;
  mobilitet_nn_1_N : N ;
  mobilskuld_nn_1_N : N ;
  modalitet_nn_1_N : N ;
  modeaffaer_nn_1_1_N : N ;
  modebutik_nn_1_N : N ;
  modejournal_nn_1_N : N ;
  modekarriaer_nn_1_1_N : N ;
  modelinje_nn_1_N : N ;
  modellkarriaer_nn_1_1_N : N ;
  modellstudie_nn_1_N : N ;
  modenyck_nn_1_N : N ;
  moderation_nn_1_N : N ;
  modercell_nn_1_N : N ;
  moderniseringsreform_nn_1_N : N ;
  modernitet_nn_1_N : N ;
  modersgestalt_nn_1_N : N ;
  modesak_nn_1_N : N ;
  modifikation_nn_1_N : N ;
  modul_nn_1_N : N ;
  modulation_nn_1_N : N ;
  mogenhet_nn_1_N : N ;
  mognad_nn_1_N : N ;
  mojaeng_nn_1_1_N : N ;
  molar_nn_1_N : N ;
  molaritet_nn_1_N : N ;
  molekylarattraktion_nn_1_N : N ;
  molekylarkraft_nn_1_N : N ;
  molekylvikt_nn_1_N : N ;
  molnhoejd_nn_1_1_N : N ;
  molnighet_nn_1_N : N ;
  molnkant_nn_1_N : N ;
  molnstod_nn_1_N : N ;
  momang_nn_1_N : N ;
  monad_nn_1_N : N ;
  monark_nn_1_N : N ;
  mondaenitet_nn_1_1_N : N ;
  monoaminoxidas_nn_1_N : N ;
  monoftong_nn_1_N : N ;
  monotonitet_nn_1_N : N ;
  monotype_nn_1_N : N ;
  monseigneur_nn_1_N : N ;
  monsignore_nn_1_N : N ;
  monstruositet_nn_1_N : N ;
  monsun_nn_1_N : N ;
  montoer_nn_1_1_N : N ;
  monumentalbyggnad_nn_1_N : N ;
  monumentalitet_nn_1_N : N ;
  mopedreparation_nn_1_N : N ;
  mor_unge_konflikt_nn_1_N : N ;
  moral_nn_1_N : N ;
  moralitet_nn_1_N : N ;
  moralsed_nn_1_N : N ;
  morbiditet_nn_1_N : N ;
  mordbrand_nn_1_N : N ;
  mordkommission_nn_1_N : N ;
  mordkonspiration_nn_1_N : N ;
  mordlystnad_nn_1_N : N ;
  morell_nn_1_N : N ;
  morgonandakt_nn_1_N : N ;
  morgonboen_nn_1_1_N : N ;
  morgonpsalm_nn_1_N : N ;
  morgonrodnad_nn_1_N : N ;
  morgonstund_nn_1_N : N ;
  morgonsaang_nn_1_1_N : N ;
  mormorsstaang_nn_1_1_N : N ;
  morslott_nn_1_N : N ;
  mortalitet_nn_1_N : N ;
  mortifikation_nn_1_N : N ;
  moraen_nn_1_1_N : N ;
  moraenmark_nn_1_1_N : N ;
  motaktion_nn_1_N : N ;
  motbild_nn_1_N : N ;
  motellchef_nn_1_N : N ;
  motighet_nn_1_N : N ;
  motion_nn_1_N : N ;
  motionsflod_nn_1_N : N ;
  motionsidrott_nn_1_N : N ;
  motionstid_nn_1_N : N ;
  motionaer_nn_1_1_N : N ;
  motivation_nn_1_N : N ;
  motivbild_nn_1_N : N ;
  motkandidat_nn_1_N : N ;
  motkraft_nn_1_N : N ;
  motoreffekt_nn_1_N : N ;
  motorjakt_nn_1_N : N ;
  motorkraft_nn_1_N : N ;
  motortrafikled_nn_1_N : N ;
  motorvaegsfoerbindelse_nn_1_1_N : N ;
  motpart_nn_1_N : N ;
  motpol_nn_1_N : N ;
  motprestation_nn_1_N : N ;
  motreformation_nn_1_N : N ;
  motreplik_nn_1_N : N ;
  motrevolution_nn_1_N : N ;
  motroerelse_nn_1_1_N : N ;
  motskrift_nn_1_N : N ;
  motstrof_nn_1_N : N ;
  motstaandsroerelse_nn_1_1_N : N ;
  motsvarighet_nn_1_N : N ;
  motsaegelse_nn_1_1_N : N ;
  motvikt_nn_1_N : N ;
  motaatgaerd_nn_1_1_N : N ;
  mousse_nn_1_N : N ;
  muffelfaerg_nn_1_1_N : N ;
  mulatt_nn_1_N : N ;
  mullhalt_nn_1_N : N ;
  multiplikand_nn_1_N : N ;
  multiplikation_nn_1_N : N ;
  multiplikationstabell_nn_1_N : N ;
  mumie_nn_1_N : N ;
  mumifikation_nn_1_N : N ;
  munart_nn_1_N : N ;
  munkcell_nn_1_N : N ;
  munklikoer_nn_1_1_N : N ;
  munterhet_nn_1_N : N ;
  muntration_nn_1_N : N ;
  museichef_nn_1_N : N ;
  museiintendent_nn_1_N : N ;
  museikatalog_nn_1_N : N ;
  museikonflikt_nn_1_N : N ;
  musical_nn_1_N : N ;
  musikal_nn_1_N : N ;
  musikalitet_nn_1_N : N ;
  musikelev_nn_1_N : N ;
  musikensemble_nn_1_N : N ;
  musikform_nn_1_N : N ;
  musikgrupp_nn_1_N : N ;
  musikkomposition_nn_1_N : N ;
  musikkvartett_nn_1_N : N ;
  musikkaar_nn_1_1_N : N ;
  musikverksamhet_nn_1_N : N ;
  musikvetenskap_nn_1_N : N ;
  musjik_nn_1_N : N ;
  muskelbyggnad_nn_1_N : N ;
  muskelcell_nn_1_N : N ;
  muskelkraft_nn_1_N : N ;
  muskelkramp_nn_1_N : N ;
  muskellaengd_nn_1_1_N : N ;
  muskelroerelse_nn_1_1_N : N ;
  muskelvaevnad_nn_1_1_N : N ;
  musketoer_nn_1_1_N : N ;
  muskoet_nn_1_1_N : N ;
  muslin_nn_1_N : N ;
  musselform_nn_1_N : N ;
  mustang_nn_1_N : N ;
  mustrakt_nn_1_N : N ;
  mutation_nn_1_N : N ;
  myckenhet_nn_1_N : N ;
  mygglarv_nn_1_N : N ;
  myndighet_nn_1_N : N ;
  myndighetschef_nn_1_N : N ;
  myndighetsperson_nn_1_N : N ;
  myntautomat_nn_1_N : N ;
  myntcirkulation_nn_1_N : N ;
  myntenhet_nn_1_N : N ;
  myntmetall_nn_1_N : N ;
  myntrealisation_nn_1_N : N ;
  myntunion_nn_1_N : N ;
  myntvaloer_nn_1_1_N : N ;
  myntvikt_nn_1_N : N ;
  myosin_nn_1_N : N ;
  myriad_nn_1_N : N ;
  myrkant_nn_1_N : N ;
  myrmalm_nn_1_N : N ;
  myrmark_nn_1_N : N ;
  mysteriereligion_nn_1_N : N ;
  mystifikation_nn_1_N : N ;
  myt_nn_1_N : N ;
  maeklarinformation_nn_1_1_N : N ;
  maektighet_nn_1_1_N : N ;
  maenniskogestalt_nn_1_1_N : N ;
  maenniskohand_nn_1_1_N : N ;
  maenniskojakt_nn_1_1_N : N ;
  maenniskoraettsorganisation_nn_1_1_N : N ;
  maenniskospermie_nn_1_1_N : N ;
  maenniskotand_nn_1_1_N : N ;
  maenniskovaenlighet_nn_1_1_N : N ;
  maensklighet_nn_1_1_N : N ;
  maer_nn_1_1_N : N ;
  maerklighet_nn_1_1_N : N ;
  maerkvaerdighet_nn_1_1_N : N ;
  maersstaang_nn_1_1_N : N ;
  maessdraekt_nn_1_1_N : N ;
  maessingsstaang_nn_1_1_N : N ;
  maetapparat_nn_1_1_N : N ;
  maetarlarv_nn_1_1_N : N ;
  maetbarhet_nn_1_1_N : N ;
  maetmetod_nn_1_1_N : N ;
  maetperiod_nn_1_1_N : N ;
  maettnad_nn_1_1_N : N ;
  maalarfaerg_nn_1_1_N : N ;
  maalgrupp_nn_1_1_N : N ;
  maalkonflikt_nn_1_1_N : N ;
  maalkvot_nn_1_1_N : N ;
  maallinje_nn_1_1_N : N ;
  maalningsteknik_nn_1_1_N : N ;
  maalskillnad_nn_1_1_N : N ;
  maaltid_nn_1_1_N : N ;
  maaltidsdryck_nn_1_1_N : N ;
  maalvakt_nn_1_1_N : N ;
  maanad_nn_1_1_N : N ;
  maanadsloen_nn_1_1_N : N ;
  maanadsskrift_nn_1_1_N : N ;
  maanadstidskrift_nn_1_1_N : N ;
  maanflod_nn_1_1_N : N ;
  maanfaerd_nn_1_1_N : N ;
  maanfoermoerkelse_nn_1_1_N : N ;
  maangalenhet_nn_1_1_N : N ;
  maangalenskap_nn_1_1_N : N ;
  maangfald_nn_1_1_N : N ;
  maangformighet_nn_1_1_N : N ;
  maangkamp_nn_1_1_N : N ;
  maangmiljardaffaer_nn_1_1_N : N ;
  maangsidighet_nn_1_1_N : N ;
  maangtydighet_nn_1_1_N : N ;
  maanviol_nn_1_1_N : N ;
  maattenhet_nn_1_1_N : N ;
  maattsenhet_nn_1_1_N : N ;
  moedravaardscentral_nn_1_1_N : N ;
  moejlighet_nn_1_1_N : N ;
  moenjefaerg_nn_1_1_N : N ;
  moenstringsexpedition_nn_1_1_N : N ;
  moerdarjakt_nn_1_1_N : N ;
  moerkalf_nn_1_1_N : N ;
  moerkalv_nn_1_1_N : N ;
  moerklaeggningsgardin_nn_1_1_N : N ;
  moetesfrihet_nn_1_1_N : N ;
  moetespunkt_nn_1_1_N : N ;
  moetesstation_nn_1_1_N : N ;
  nabo_nn_1_N : N ;
  nabob_nn_1_N : N ;
  nageloert_nn_1_1_N : N ;
  naivitet_nn_1_N : N ;
  najad_nn_1_N : N ;
  nakenakt_nn_1_N : N ;
  nakenbild_nn_1_N : N ;
  nakenhet_nn_1_N : N ;
  nakenkult_nn_1_N : N ;
  nakenmodell_nn_1_N : N ;
  nakenscen_nn_1_N : N ;
  nakenstudie_nn_1_N : N ;
  naketbild_nn_1_N : N ;
  namnaktie_nn_1_N : N ;
  namndikt_nn_1_N : N ;
  namnkunnighet_nn_1_N : N ;
  namnlaengd_nn_1_1_N : N ;
  namnsaekerhet_nn_1_1_N : N ;
  namnunderskrift_nn_1_N : N ;
  namnuppgift_nn_1_N : N ;
  nanosekund_nn_1_N : N ;
  napalmbomb_nn_1_N : N ;
  napoleonbakelse_nn_1_N : N ;
  naprapat_nn_1_N : N ;
  narighet_nn_1_N : N ;
  narkotikaklinik_nn_1_N : N ;
  narrdraekt_nn_1_1_N : N ;
  narvspalt_nn_1_N : N ;
  nasir_nn_1_N : N ;
  nation_nn_1_N : N ;
  nationaldraekt_nn_1_1_N : N ;
  nationalfoermoegenhet_nn_1_1_N : N ;
  nationalistroerelse_nn_1_1_N : N ;
  nationalitet_nn_1_N : N ;
  nationalitetsbokstav_nn_1_N : N ;
  nationalkaraktaer_nn_1_1_N : N ;
  nationalpark_nn_1_N : N ;
  nationalprodukt_nn_1_N : N ;
  nationalraett_nn_1_1_N : N ;
  nationalscen_nn_1_N : N ;
  nationalskald_nn_1_N : N ;
  nationalsport_nn_1_N : N ;
  nationalstat_nn_1_N : N ;
  nationalsaang_nn_1_1_N : N ;
  nationsavgift_nn_1_N : N ;
  nativitet_nn_1_N : N ;
  natriumhalt_nn_1_N : N ;
  natriumkonsumtion_nn_1_N : N ;
  natriumtiosulfat_nn_1_N : N ;
  natt_nn_1_N : N ;
  nattblindhet_nn_1_N : N ;
  nattdraekt_nn_1_1_N : N ;
  nattjour_nn_1_N : N ;
  nattklubbskund_nn_1_N : N ;
  nattkraem_nn_1_1_N : N ;
  nattlaengd_nn_1_1_N : N ;
  nattpatrull_nn_1_N : N ;
  nattstrid_nn_1_N : N ;
  nattvakt_nn_1_N : N ;
  nattvard_nn_1_N : N ;
  nattvardsberedelse_nn_1_N : N ;
  nattviol_nn_1_N : N ;
  nattvaekt_nn_1_1_N : N ;
  naturalisation_nn_1_N : N ;
  naturaportion_nn_1_N : N ;
  naturbetingelse_nn_1_N : N ;
  naturelltapet_nn_1_N : N ;
  naturfilosof_nn_1_N : N ;
  naturformation_nn_1_N : N ;
  naturfaerg_nn_1_1_N : N ;
  naturinstinkt_nn_1_N : N ;
  naturkraft_nn_1_N : N ;
  naturlaekemetod_nn_1_1_N : N ;
  naturmetod_nn_1_N : N ;
  naturnoedvaendighet_nn_1_1_N : N ;
  naturpark_nn_1_N : N ;
  naturprodukt_nn_1_N : N ;
  naturreligion_nn_1_N : N ;
  naturtomt_nn_1_N : N ;
  naturtyp_nn_1_N : N ;
  naturvetenskap_nn_1_N : N ;
  navigation_nn_1_N : N ;
  navigatoer_nn_1_1_N : N ;
  nazistsympatisoer_nn_1_1_N : N ;
  nebulosalinje_nn_1_N : N ;
  necessaer_nn_1_1_N : N ;
  nedbrytningsstation_nn_1_N : N ;
  nederboerdsmaengd_nn_1_1_N : N ;
  nederkant_nn_1_N : N ;
  nedfart_nn_1_N : N ;
  nedfaerd_nn_1_1_N : N ;
  nedlaeggelse_nn_1_1_N : N ;
  nedlaatenhet_nn_1_1_N : N ;
  nedrighet_nn_1_N : N ;
  nedskaerningskonsulent_nn_1_1_N : N ;
  negation_nn_1_N : N ;
  nematod_nn_1_N : N ;
  neodym_nn_2_N : N ;
  neotektonik_nn_1_N : N ;
  nerbrytningsstation_nn_1_N : N ;
  nerfart_nn_1_N : N ;
  nerfaerd_nn_1_1_N : N ;
  nerlaeggelse_nn_1_1_N : N ;
  nerlaatenhet_nn_1_1_N : N ;
  nerv_nn_1_N : N ;
  nervaktivitet_nn_1_N : N ;
  nervattack_nn_1_N : N ;
  nervcell_nn_1_N : N ;
  nervcellsgrupp_nn_1_N : N ;
  nervchock_nn_1_N : N ;
  nervfoerbindelse_nn_1_1_N : N ;
  nervositet_nn_1_N : N ;
  nervvaevnad_nn_1_1_N : N ;
  neslighet_nn_1_N : N ;
  nettofoermoegenhet_nn_1_1_N : N ;
  nettoloen_nn_1_1_N : N ;
  nettoskuld_nn_1_N : N ;
  nettostudietid_nn_1_N : N ;
  neuropat_nn_1_N : N ;
  neurovetenskap_nn_1_N : N ;
  neutralisation_nn_1_N : N ;
  neutralitet_nn_1_N : N ;
  neutrinomodell_nn_1_N : N ;
  neutronbomb_nn_1_N : N ;
  nidation_nn_1_N : N ;
  nidbild_nn_1_N : N ;
  niddikt_nn_1_N : N ;
  nidskrift_nn_1_N : N ;
  nidstaang_nn_1_1_N : N ;
  niece_nn_1_N : N ;
  nipbrant_nn_1_N : N ;
  nipflod_nn_1_N : N ;
  nitlott_nn_1_N : N ;
  nitratbakterie_nn_1_N : N ;
  nitritbakterie_nn_1_N : N ;
  nitroglycerin_nn_1_N : N ;
  nitrogrupp_nn_1_N : N ;
  nivation_nn_1_N : N ;
  nivaaskillnad_nn_1_1_N : N ;
  njurtransplantation_nn_1_N : N ;
  njutningslystnad_nn_1_N : N ;
  nocturne_nn_1_N : N ;
  nod_nn_1_N : N ;
  noggrannhet_nn_1_N : N ;
  nojighet_nn_1_N : N ;
  nokturn_nn_1_N : N ;
  nollpunkt_nn_1_N : N ;
  nomadfamilj_nn_1_N : N ;
  nominalkatalog_nn_1_N : N ;
  nominalloen_nn_1_1_N : N ;
  nonaggression_nn_1_N : N ;
  nonie_nn_1_N : N ;
  nonintervention_nn_1_N : N ;
  noradrenalin_nn_1_N : N ;
  nordbo_nn_1_N : N ;
  nordpol_nn_1_N : N ;
  norepinefrin_nn_1_N : N ;
  norm_nn_1_N : N ;
  normal_nn_1_N : N ;
  normalbild_nn_1_N : N ;
  normalfilm_nn_1_N : N ;
  normalfaerg_nn_1_1_N : N ;
  normalitet_nn_1_N : N ;
  normalmaanad_nn_1_1_N : N ;
  normalstudietid_nn_1_N : N ;
  normaltid_nn_1_N : N ;
  normalton_nn_1_N : N ;
  normalvikt_nn_1_N : N ;
  normand_nn_1_N : N ;
  normloeshet_nn_1_1_N : N ;
  norrskensupplevelse_nn_1_N : N ;
  nosighet_nn_1_N : N ;
  noskighet_nn_1_N : N ;
  noskon_nn_1_N : N ;
  noslaengd_nn_1_1_N : N ;
  nosregion_nn_1_N : N ;
  notabilitet_nn_1_N : N ;
  notarie_nn_1_N : N ;
  notation_nn_1_N : N ;
  notdraekt_nn_1_1_N : N ;
  notifikation_nn_1_N : N ;
  notlinje_nn_1_N : N ;
  notorietet_nn_1_N : N ;
  notrad_nn_1_N : N ;
  novation_nn_1_N : N ;
  novell_nn_1_N : N ;
  novellett_nn_1_N : N ;
  novitet_nn_1_N : N ;
  nuditet_nn_1_N : N ;
  nullitet_nn_1_N : N ;
  numeraer_nn_1_1_N : N ;
  nummerfoeljd_nn_1_1_N : N ;
  nummerpresentatoer_nn_1_1_N : N ;
  nunneoert_nn_1_1_N : N ;
  nuntie_nn_1_N : N ;
  nuspraaklighet_nn_1_1_N : N ;
  nutrition_nn_1_N : N ;
  nyansloeshet_nn_1_1_N : N ;
  nybyggnad_nn_1_N : N ;
  nyck_nn_1_N : N ;
  nyckelfunktion_nn_1_N : N ;
  nyckelposition_nn_1_N : N ;
  nyckelroll_nn_1_N : N ;
  nyckelstaang_nn_1_1_N : N ;
  nyckfullhet_nn_1_N : N ;
  nyemission_nn_1_N : N ;
  nyfikenhet_nn_1_N : N ;
  nygrad_nn_1_N : N ;
  nyhet_nn_1_N : N ;
  nyhetsportal_nn_1_N : N ;
  nyhetsredaktion_nn_1_N : N ;
  nykolonisation_nn_1_N : N ;
  nykterhet_nn_1_N : N ;
  nykterhetsnaemnd_nn_1_1_N : N ;
  nykterhetsroerelse_nn_1_1_N : N ;
  nymf_nn_1_N : N ;
  nymodighet_nn_1_N : N ;
  nyproduktion_nn_1_N : N ;
  nysattack_nn_1_N : N ;
  nyskapelse_nn_1_N : N ;
  nystart_nn_1_N : N ;
  nysoert_nn_1_1_N : N ;
  nyttighet_nn_1_N : N ;
  nyttosynpunkt_nn_1_N : N ;
  nyaarsboen_nn_1_1_N : N ;
  nyaarsnatt_nn_1_1_N : N ;
  naebbsko_nn_1_1_N : N ;
  naepenhet_nn_1_1_N : N ;
  naerbild_nn_1_1_N : N ;
  naerbutik_nn_1_1_N : N ;
  naergaangenhet_nn_1_1_N : N ;
  naerhet_nn_1_1_N : N ;
  naeringsfrihet_nn_1_1_N : N ;
  naeringsverksamhet_nn_1_1_N : N ;
  naerkamp_nn_1_1_N : N ;
  naerpassage_nn_1_1_N : N ;
  naerpunkt_nn_1_1_N : N ;
  naerstrid_nn_1_1_N : N ;
  naersynthet_nn_1_1_N : N ;
  naesprydnad_nn_1_1_N : N ;
  naesselcell_nn_1_1_N : N ;
  naessprej_nn_1_1_N : N ;
  naetattack_nn_1_1_N : N ;
  naetdrog_nn_1_1_N : N ;
  naetgemenskap_nn_1_1_N : N ;
  naetkommunikation_nn_1_1_N : N ;
  naetkontakt_nn_1_1_N : N ;
  naevkamp_nn_1_1_N : N ;
  naalventil_nn_1_1_N : N ;
  noedloegn_nn_1_1_N : N ;
  noedraket_nn_1_1_N : N ;
  noedsituation_nn_1_1_N : N ;
  noedtorftighet_nn_1_1_N : N ;
  noedvaendighet_nn_1_1_N : N ;
  noejeslokal_nn_1_1_N : N ;
  noejesmaskin_nn_1_1_N : N ;
  noejespark_nn_1_1_N : N ;
  noejestur_nn_1_1_N : N ;
  noetbarhet_nn_1_1_N : N ;
  noetfrukt_nn_1_1_N : N ;
  oaktsamhet_nn_1_N : N ;
  oanfaektbarhet_nn_1_1_N : N ;
  oanfaektlighet_nn_1_1_N : N ;
  oanstaendighet_nn_1_1_N : N ;
  oantastbarhet_nn_1_N : N ;
  oantastlighet_nn_1_N : N ;
  oart_nn_1_N : N ;
  oartighet_nn_1_N : N ;
  oavhaengighet_nn_1_1_N : N ;
  obducent_nn_1_N : N ;
  obduktion_nn_1_N : N ;
  obegriplighet_nn_1_N : N ;
  obehaglighet_nn_1_N : N ;
  obehoevlighet_nn_1_1_N : N ;
  obekvaemhet_nn_1_1_N : N ;
  obemaerkthet_nn_1_1_N : N ;
  oberoerdhet_nn_1_1_N : N ;
  obeslutsamhet_nn_1_N : N ;
  obestaembarhet_nn_1_1_N : N ;
  obestaemdhet_nn_1_1_N : N ;
  obestaendighet_nn_1_1_N : N ;
  obetydlighet_nn_1_N : N ;
  obillighet_nn_1_N : N ;
  objektivitet_nn_1_N : N ;
  objektsform_nn_1_N : N ;
  oblat_nn_1_N : N ;
  obligation_nn_1_N : N ;
  oblikvitet_nn_1_N : N ;
  oboe_nn_1_N : N ;
  obscenitet_nn_1_N : N ;
  observation_nn_1_N : N ;
  observationsakt_nn_1_N : N ;
  observationsklinik_nn_1_N : N ;
  observatoer_nn_1_1_N : N ;
  obsklinik_nn_1_N : N ;
  obstipation_nn_1_N : N ;
  obstruent_nn_1_N : N ;
  obstruktion_nn_1_N : N ;
  obygd_nn_1_N : N ;
  oboenhoerlighet_nn_1_1_N : N ;
  occasion_nn_1_N : N ;
  oceanograf_nn_1_N : N ;
  ockasion_nn_1_N : N ;
  ocklusion_nn_1_N : N ;
  ockultation_nn_1_N : N ;
  ockupation_nn_1_N : N ;
  odlingsareal_nn_1_N : N ;
  odlingsmark_nn_1_N : N ;
  odrickbarhet_nn_1_N : N ;
  odoer_nn_1_1_N : N ;
  oegentlighet_nn_1_N : N ;
  oenighet_nn_1_N : N ;
  ofarlighet_nn_1_N : N ;
  offensiv_nn_1_N : N ;
  offentlighet_nn_1_N : N ;
  offerent_nn_1_N : N ;
  offeridentitet_nn_1_N : N ;
  offerroll_nn_1_N : N ;
  offert_nn_1_N : N ;
  officerskamrat_nn_1_N : N ;
  oformlighet_nn_1_N : N ;
  ofrihet_nn_1_N : N ;
  ofullkomlighet_nn_1_N : N ;
  ofullstaendighet_nn_1_1_N : N ;
  ofaerdighet_nn_2_1_N : N ;
  ofaerg_nn_1_1_N : N ;
  ofoerarglighet_nn_1_1_N : N ;
  ofoerenlighet_nn_1_1_N : N ;
  ofoergloemlighet_nn_1_1_N : N ;
  ofoergaenglighet_nn_1_1_N : N ;
  ofoerklarlighet_nn_1_1_N : N ;
  ofoernuftighet_nn_1_1_N : N ;
  ofoerraett_nn_1_1_N : N ;
  ofoerskaemdhet_nn_1_1_N : N ;
  ofoerstaaelighet_nn_1_1_N : N ;
  ofoervaegenhet_nn_1_1_N : N ;
  ofoeraenderlighet_nn_1_1_N : N ;
  ohederlighet_nn_1_N : N ;
  ohygglighet_nn_1_N : N ;
  ohaallbarhet_nn_1_1_N : N ;
  ohoerbarhet_nn_1_1_N : N ;
  ojusthet_nn_1_N : N ;
  ojaemlikhet_nn_1_1_N : N ;
  ojaemnhet_nn_1_1_N : N ;
  okamratlighet_nn_1_N : N ;
  oklarhet_nn_1_N : N ;
  okristlighet_nn_1_N : N ;
  oktett_nn_1_N : N ;
  okunnighet_nn_1_N : N ;
  okynnesjakt_nn_1_N : N ;
  okyskhet_nn_1_N : N ;
  okaenslighet_nn_1_1_N : N ;
  olaglighet_nn_1_N : N ;
  olat_nn_1_N : N ;
  oleat_nn_1_N : N ;
  olefin_nn_1_N : N ;
  olidlighet_nn_1_N : N ;
  olikformighet_nn_1_N : N ;
  olikhet_nn_1_N : N ;
  oliv_nn_1_N : N ;
  olivin_nn_1_N : N ;
  oljebrand_nn_1_N : N ;
  oljefaerg_nn_1_1_N : N ;
  oljenivaavakt_nn_1_1_N : N ;
  oljepalm_nn_1_N : N ;
  oljesanktion_nn_1_N : N ;
  oljestad_nn_1_N : N ;
  olovlighet_nn_1_N : N ;
  olyckshaendelse_nn_1_1_N : N ;
  olyckskamrat_nn_1_N : N ;
  olycksstatistik_nn_1_N : N ;
  olyckstrend_nn_1_N : N ;
  olydighet_nn_1_N : N ;
  olydnad_nn_1_N : N ;
  olympiad_nn_1_N : N ;
  olaegenhet_nn_1_1_N : N ;
  olaeglighet_nn_1_1_N : N ;
  ombyggnad_nn_1_N : N ;
  ombyggnation_nn_1_N : N ;
  omdoemesgillhet_nn_1_1_N : N ;
  omdoemesloeshet_nn_1_1_N : N ;
  omedvetenhet_nn_1_N : N ;
  omelett_nn_1_N : N ;
  omistlighet_nn_1_N : N ;
  omkostnad_nn_1_N : N ;
  omkoerningsfil_nn_1_1_N : N ;
  omloppshastighet_nn_1_N : N ;
  omloppstid_nn_1_N : N ;
  omogenhet_nn_1_N : N ;
  omskiftartangent_nn_1_N : N ;
  omskaerelse_nn_1_1_N : N ;
  omslagsbild_nn_1_N : N ;
  omsorg_nn_1_N : N ;
  omsorgsfullhet_nn_1_N : N ;
  omstart_nn_1_N : N ;
  omstaendighet_nn_1_1_N : N ;
  omvaendelse_nn_1_1_N : N ;
  omvaendningsfilm_nn_1_1_N : N ;
  omvaardnad_nn_1_1_N : N ;
  omaensklighet_nn_1_1_N : N ;
  omaattlighet_nn_1_1_N : N ;
  omoejlighet_nn_1_1_N : N ;
  onaturlighet_nn_1_N : N ;
  ondskefullhet_nn_1_N : N ;
  onykterhet_nn_1_N : N ;
  onyttighet_nn_1_N : N ;
  onoedighet_nn_1_1_N : N ;
  opacitet_nn_1_N : N ;
  opal_nn_1_N : N ;
  operabalett_nn_1_N : N ;
  operabiljett_nn_1_N : N ;
  operakompositoer_nn_1_1_N : N ;
  operation_nn_1_N : N ;
  operationslinje_nn_1_N : N ;
  operatoer_nn_1_1_N : N ;
  opinion_nn_1_N : N ;
  opinionsnaemnd_nn_1_1_N : N ;
  oppbyggnad_nn_1_N : N ;
  oppfart_nn_1_N : N ;
  oppgoerelse_nn_1_1_N : N ;
  opphoejdhet_nn_1_1_N : N ;
  opphoejelse_nn_1_1_N : N ;
  oppkaeftighet_nn_1_1_N : N ;
  opponent_nn_1_N : N ;
  opposition_nn_1_N : N ;
  opptagenhet_nn_1_N : N ;
  option_nn_1_N : N ;
  optionsraett_nn_1_1_N : N ;
  optokomponent_nn_1_N : N ;
  orange_nn_1_N : N ;
  orangutang_nn_1_N : N ;
  oration_nn_1_N : N ;
  orbital_nn_1_N : N ;
  ordaccent_nn_1_N : N ;
  ordalydelse_nn_1_N : N ;
  ordbild_nn_1_N : N ;
  ordblindhet_nn_1_N : N ;
  ordbredd_nn_1_N : N ;
  ordentreprenoer_nn_1_1_N : N ;
  ordform_nn_1_N : N ;
  ordfoeljd_nn_1_1_N : N ;
  ordgrupp_nn_1_N : N ;
  ordinand_nn_1_N : N ;
  ordination_nn_1_N : N ;
  ordkonstnaer_nn_1_1_N : N ;
  ordkonstruktion_nn_1_N : N ;
  ordlaengd_nn_1_1_N : N ;
  ordningsbestaemmelse_nn_1_1_N : N ;
  ordningsfoeljd_nn_1_1_N : N ;
  ordningsfoereskrift_nn_1_1_N : N ;
  ordningsfoerseelse_nn_1_1_N : N ;
  ordningsvakt_nn_1_N : N ;
  ordskillnad_nn_1_N : N ;
  ordskrift_nn_1_N : N ;
  ordstrid_nn_1_N : N ;
  oread_nn_1_N : N ;
  oredlighet_nn_1_N : N ;
  oregelbundenhet_nn_1_N : N ;
  oregelmaessighet_nn_1_1_N : N ;
  orenhet_nn_1_N : N ;
  orenlighet_nn_1_N : N ;
  organcell_nn_1_N : N ;
  organdonation_nn_1_N : N ;
  organell_nn_1_N : N ;
  organisation_nn_1_N : N ;
  organisationsform_nn_1_N : N ;
  organisatoer_nn_1_1_N : N ;
  orgasm_nn_1_N : N ;
  orgie_nn_1_N : N ;
  oriental_nn_1_N : N ;
  orienteringspunkt_nn_1_N : N ;
  originalitet_nn_1_N : N ;
  oriktighet_nn_1_N : N ;
  orimlighet_nn_1_N : N ;
  ornat_nn_1_N : N ;
  orolighet_nn_1_N : N ;
  orsak_nn_1_N : N ;
  ort_nn_1_N : N ;
  ortlinje_nn_1_N : N ;
  ortodrom_nn_1_N : N ;
  ortoped_nn_1_N : N ;
  ortsgrupp_nn_1_N : N ;
  ortstid_nn_1_N : N ;
  oraett_nn_1_1_N : N ;
  oraettfaerdighet_nn_1_1_N : N ;
  osaklighet_nn_1_N : N ;
  oscillation_nn_1_N : N ;
  oscillograf_nn_1_N : N ;
  osed_nn_1_N : N ;
  osedlighet_nn_1_N : N ;
  osjaelviskhet_nn_1_1_N : N ;
  osjaelvstaendighet_nn_1_1_N : N ;
  oskiljaktighet_nn_1_N : N ;
  oskuld_nn_1_N : N ;
  osmaklighet_nn_1_N : N ;
  osmidighet_nn_1_N : N ;
  osportslighet_nn_1_N : N ;
  ostasiat_nn_1_N : N ;
  ostentation_nn_1_N : N ;
  ostkant_nn_1_N : N ;
  ostkraem_nn_1_1_N : N ;
  oststaang_nn_1_1_N : N ;
  osundhet_nn_1_N : N ;
  osynlighet_nn_1_N : N ;
  osaekerhet_nn_1_1_N : N ;
  osaekerhetsrelation_nn_1_1_N : N ;
  otidighet_nn_1_N : N ;
  otidsenlighet_nn_1_N : N ;
  otillboerlighet_nn_1_1_N : N ;
  otillgaenglighet_nn_1_1_N : N ;
  otrevlighet_nn_1_N : N ;
  otrohet_nn_1_N : N ;
  otrohetsaffaer_nn_1_1_N : N ;
  otrohetsuppgift_nn_1_N : N ;
  otrolighet_nn_1_N : N ;
  otryckbarhet_nn_1_N : N ;
  otydlighet_nn_1_N : N ;
  otymplighet_nn_1_N : N ;
  otaeckhet_nn_1_1_N : N ;
  otaethet_nn_1_1_N : N ;
  ouvertyr_nn_1_N : N ;
  oval_nn_1_N : N ;
  ovanlighet_nn_1_N : N ;
  ovation_nn_1_N : N ;
  overall_nn_1_N : N ;
  overheadbild_nn_1_N : N ;
  overksamhet_nn_1_N : N ;
  ovetenhet_nn_1_N : N ;
  ovettighet_nn_1_N : N ;
  ovisshet_nn_1_N : N ;
  ovulation_nn_1_N : N ;
  ovaenlighet_nn_1_1_N : N ;
  ovaenskap_nn_1_1_N : N ;
  ovaesentlighet_nn_1_1_N : N ;
  oxeltand_nn_1_N : N ;
  oxidation_nn_1_N : N ;
  oxidationsreaktion_nn_1_N : N ;
  oxytocin_nn_1_N : N ;
  ozelot_nn_1_N : N ;
  ozonhalt_nn_1_N : N ;
  ozonmaengd_nn_1_1_N : N ;
  ozonreduktion_nn_1_N : N ;
  oaendlighet_nn_1_1_N : N ;
  oaerlighet_nn_1_1_N : N ;
  oaatkomlighet_nn_1_1_N : N ;
  page_nn_1_N : N ;
  pagefrisyr_nn_1_N : N ;
  pagod_nn_1_N : N ;
  paj_nn_1_N : N ;
  paketauktion_nn_1_N : N ;
  paketexpedition_nn_1_N : N ;
  pakt_nn_1_N : N ;
  palatal_nn_1_N : N ;
  palatsrevolution_nn_1_N : N ;
  paleograf_nn_1_N : N ;
  palett_nn_1_N : N ;
  palissad_nn_1_N : N ;
  paljett_nn_1_N : N ;
  palm_nn_1_N : N ;
  palmett_nn_1_N : N ;
  palmplym_nn_1_N : N ;
  palp_nn_1_N : N ;
  palpation_nn_1_N : N ;
  pamflett_nn_1_N : N ;
  panegyrik_nn_1_N : N ;
  paneldebatt_nn_1_N : N ;
  paneldiskussion_nn_1_N : N ;
  panett_nn_1_N : N ;
  panfloejt_nn_1_1_N : N ;
  pang_pangfilm_nn_1_N : N ;
  panikattack_nn_1_N : N ;
  panikaangestattack_nn_1_1_N : N ;
  pannkakssmet_nn_1_N : N ;
  pannlob_nn_1_N : N ;
  pansargeneral_nn_1_N : N ;
  pansargranat_nn_1_N : N ;
  pansartrupp_nn_1_N : N ;
  pant_nn_1_N : N ;
  pantbank_nn_1_N : N ;
  panterkatt_nn_1_N : N ;
  pantlaaneroerelse_nn_1_1_N : N ;
  pantograf_nn_1_N : N ;
  pantomim_nn_1_N : N ;
  pantraett_nn_1_1_N : N ;
  papiljott_nn_1_N : N ;
  papill_nn_1_N : N ;
  pappersmaskin_nn_1_N : N ;
  papperspapiljott_nn_1_N : N ;
  pappersservett_nn_1_N : N ;
  pappkartong_nn_1_N : N ;
  parabolantenn_nn_1_N : N ;
  paradisstrand_nn_1_N : N ;
  paraduniform_nn_1_N : N ;
  paragraf_nn_1_N : N ;
  parallelldam_nn_1_N : N ;
  parallellepiped_nn_1_N : N ;
  parallellgrad_nn_1_N : N ;
  parallellitet_nn_1_N : N ;
  parapet_nn_1_N : N ;
  paraplyorganisation_nn_1_N : N ;
  parce_nn_1_N : N ;
  parcell_nn_1_N : N ;
  parentation_nn_1_N : N ;
  parerstaang_nn_1_1_N : N ;
  parfym_nn_1_N : N ;
  parfymaffaer_nn_1_1_N : N ;
  parfymdoft_nn_1_N : N ;
  parisfrisyr_nn_1_N : N ;
  paritet_nn_1_N : N ;
  park_nn_1_N : N ;
  parkeringsautomat_nn_1_N : N ;
  parkeringsavgift_nn_1_N : N ;
  parkeringsbot_nn_1_N : N ;
  parkeringsvakt_nn_1_N : N ;
  parkett_nn_1_N : N ;
  parkpromenad_nn_1_N : N ;
  parlamentsreform_nn_1_N : N ;
  parlamentaer_nn_1_1_N : N ;
  parloer_nn_1_1_N : N ;
  parningsdrift_nn_1_N : N ;
  parningsdraekt_nn_1_1_N : N ;
  parningsmetod_nn_1_N : N ;
  parningstid_nn_1_N : N ;
  paroll_nn_1_N : N ;
  paroxysm_nn_1_N : N ;
  part_nn_1_N : N ;
  parterr_nn_1_N : N ;
  partialton_nn_1_N : N ;
  partiapparat_nn_1_N : N ;
  partichef_nn_1_N : N ;
  partifaerg_nn_1_1_N : N ;
  partigrupp_nn_1_N : N ;
  partikamrat_nn_1_N : N ;
  partikelegenskap_nn_1_N : N ;
  partikelreaktion_nn_1_N : N ;
  partiledardebatt_nn_1_N : N ;
  partiledarkandidat_nn_1_N : N ;
  partimotion_nn_1_N : N ;
  partiskhet_nn_1_N : N ;
  partistyrelse_nn_1_N : N ;
  partitrohet_nn_1_N : N ;
  partsbehoerighet_nn_1_1_N : N ;
  paskill_nn_1_N : N ;
  passad_nn_1_N : N ;
  passage_nn_1_N : N ;
  passagerarsalong_nn_1_N : N ;
  passepartout_nn_1_N : N ;
  passfrihet_nn_1_N : N ;
  passion_nn_1_N : N ;
  passionsfrukt_nn_1_N : N ;
  passivform_nn_1_N : N ;
  passivitet_nn_1_N : N ;
  passivum_nn_1_N : N ;
  passkontrollant_nn_1_N : N ;
  passopp_nn_1_N : N ;
  passpoal_nn_1_N : N ;
  pastaraett_nn_1_1_N : N ;
  pastasallad_nn_1_N : N ;
  pastej_nn_1_N : N ;
  pastell_nn_1_N : N ;
  pastellfaerg_nn_1_1_N : N ;
  pastill_nn_1_N : N ;
  pastoral_nn_1_N : N ;
  pastoratsadjunkt_nn_1_N : N ;
  pastorsadjunkt_nn_1_N : N ;
  pastorsexpedition_nn_1_N : N ;
  paten_nn_1_N : N ;
  patentadvokat_nn_1_N : N ;
  patient_nn_1_N : N ;
  patriark_nn_1_N : N ;
  patricierslaekt_nn_1_1_N : N ;
  patrull_nn_1_N : N ;
  paulun_nn_1_N : N ;
  pavane_nn_1_N : N ;
  paviljong_nn_1_N : N ;
  peang_nn_1_N : N ;
  pedagog_nn_1_N : N ;
  pedal_nn_1_N : N ;
  pedell_nn_1_N : N ;
  peelingkraem_nn_1_1_N : N ;
  pelarborrmaskin_nn_1_N : N ;
  pelardomkraft_nn_1_N : N ;
  pendang_nn_1_N : N ;
  pendelroerelse_nn_1_1_N : N ;
  pendeltidtabell_nn_1_N : N ;
  pendeltaagstidtabell_nn_1_1_N : N ;
  penetration_nn_1_N : N ;
  penicillin_nn_1_N : N ;
  penisattrapp_nn_1_N : N ;
  penjoar_nn_1_N : N ;
  penningfoersaendelse_nn_1_1_N : N ;
  penninglott_nn_1_N : N ;
  penningmarknad_nn_1_N : N ;
  penningtransaktion_nn_1_N : N ;
  pennmodell_nn_1_N : N ;
  pension_nn_1_N : N ;
  pensionaer_nn_1_1_N : N ;
  pensionaerslaegenhet_nn_1_1_N : N ;
  pepparkaksmarodoer_nn_1_1_N : N ;
  pepparkaksstad_nn_1_N : N ;
  perception_nn_1_N : N ;
  perfektion_nn_1_N : N ;
  perfektum_nn_1_N : N ;
  perfiditet_nn_1_N : N ;
  perforation_nn_1_N : N ;
  period_nn_1_N : N ;
  periodicitet_nn_1_N : N ;
  perkal_nn_1_N : N ;
  perkolation_nn_1_N : N ;
  perkussion_nn_1_N : N ;
  permeabilitet_nn_1_N : N ;
  permission_nn_1_N : N ;
  permittent_nn_1_N : N ;
  permutation_nn_1_N : N ;
  perrong_nn_1_N : N ;
  perrongkant_nn_1_N : N ;
  perseveration_nn_1_N : N ;
  persienn_nn_1_N : N ;
  personage_nn_1_N : N ;
  personalansvarsnaemnd_nn_1_1_N : N ;
  personalchef_nn_1_N : N ;
  personalerfarenhet_nn_1_N : N ;
  personalorganisation_nn_1_N : N ;
  personalpool_nn_1_N : N ;
  personaltaethet_nn_1_1_N : N ;
  personalunion_nn_1_N : N ;
  personattack_nn_1_N : N ;
  personbilsvolym_nn_1_N : N ;
  personifikation_nn_1_N : N ;
  personkontakt_nn_1_N : N ;
  personkult_nn_1_N : N ;
  personlighet_nn_1_N : N ;
  personlighetstyp_nn_1_N : N ;
  persontyp_nn_1_N : N ;
  personuppgift_nn_1_N : N ;
  perspektivbild_nn_1_N : N ;
  perturbation_nn_1_N : N ;
  perversion_nn_1_N : N ;
  perversitet_nn_1_N : N ;
  petition_nn_1_N : N ;
  piaff_nn_1_N : N ;
  pianokonsert_nn_1_N : N ;
  pianolektion_nn_1_N : N ;
  pianosonat_nn_1_N : N ;
  piccolafloejt_nn_1_1_N : N ;
  piccolo_nn_1_N : N ;
  pickup_nn_1_N : N ;
  picot_nn_1_N : N ;
  piedestal_nn_1_N : N ;
  pierrot_nn_1_N : N ;
  pietet_nn_1_N : N ;
  piezoelektricitet_nn_1_N : N ;
  pigdebatt_nn_1_N : N ;
  piket_nn_1_N : N ;
  pikoer_nn_1_1_N : N ;
  pilaff_nn_1_N : N ;
  pilgrim_nn_1_N : N ;
  pilgrimsfaerd_nn_1_1_N : N ;
  pilot_nn_1_N : N ;
  pilotballong_nn_1_N : N ;
  pilotstudie_nn_1_N : N ;
  pilsnerfilm_nn_1_N : N ;
  pinal_nn_1_N : N ;
  pincett_nn_1_N : N ;
  pingsthelg_nn_1_N : N ;
  pinje_nn_1_N : N ;
  pinlighet_nn_1_N : N ;
  pinsamhet_nn_1_N : N ;
  pinupbild_nn_1_N : N ;
  pionjaer_nn_1_1_N : N ;
  pipett_nn_1_N : N ;
  piplaengd_nn_1_1_N : N ;
  pirat_nn_1_N : N ;
  piruett_nn_1_N : N ;
  piskbalkong_nn_1_N : N ;
  piskperuk_nn_1_N : N ;
  pisksnaertoperation_nn_1_1_N : N ;
  pisksnaertsoperation_nn_1_1_N : N ;
  pissoar_nn_1_N : N ;
  pistage_nn_1_N : N ;
  pistong_nn_1_N : N ;
  pizzakartong_nn_1_N : N ;
  placeboeffekt_nn_1_N : N ;
  plage_nn_1_N : N ;
  plagiatanklagelse_nn_1_N : N ;
  planet_nn_1_N : N ;
  planetesimal_nn_1_N : N ;
  planetroerelse_nn_1_1_N : N ;
  planschett_nn_1_N : N ;
  plantage_nn_1_N : N ;
  plastbassaeng_nn_1_1_N : N ;
  plastglob_nn_1_N : N ;
  plasticitet_nn_1_N : N ;
  plastikkirurg_nn_1_N : N ;
  plastikoperation_nn_1_N : N ;
  plastrong_nn_1_N : N ;
  plastsko_nn_1_N : N ;
  plastspiral_nn_1_N : N ;
  plasttrumpet_nn_1_N : N ;
  platsbiljett_nn_1_N : N ;
  platschef_nn_1_N : N ;
  plattdistribution_nn_1_N : N ;
  platthet_nn_2_N : N ;
  plattaang_nn_1_1_N : N ;
  plebej_nn_1_N : N ;
  plejad_nn_1_N : N ;
  pleonasm_nn_1_N : N ;
  plesiosaurie_nn_1_N : N ;
  plomb_nn_1_N : N ;
  plommonsylt_nn_1_N : N ;
  plumphet_nn_1_N : N ;
  pluralitet_nn_1_N : N ;
  plusgrad_nn_1_N : N ;
  pluskvamperfektum_nn_1_N : N ;
  pluspol_nn_1_N : N ;
  plutokrat_nn_1_N : N ;
  plutonchef_nn_1_N : N ;
  pluvialperiod_nn_1_N : N ;
  plym_nn_1_N : N ;
  plysmaskin_nn_1_N : N ;
  plywoodfabrik_nn_1_N : N ;
  plaegsed_nn_1_1_N : N ;
  plaagsamhet_nn_1_1_N : N ;
  plaatfaerg_nn_1_1_N : N ;
  plaatkant_nn_1_1_N : N ;
  ploetslighet_nn_1_1_N : N ;
  poesitradition_nn_1_N : N ;
  poet_nn_1_N : N ;
  pogrom_nn_1_N : N ;
  pojkinstinkt_nn_1_N : N ;
  pokal_nn_1_N : N ;
  pokerprofil_nn_1_N : N ;
  polack_nn_1_N : N ;
  polarexpedition_nn_1_N : N ;
  polarfront_nn_1_N : N ;
  polarisation_nn_1_N : N ;
  polaritet_nn_1_N : N ;
  polaroidfilm_nn_1_N : N ;
  polartrakt_nn_1_N : N ;
  polemik_nn_1_N : N ;
  polermaskin_nn_1_N : N ;
  polerrondell_nn_1_N : N ;
  poliklinik_nn_1_N : N ;
  polischef_nn_1_N : N ;
  polischock_nn_1_N : N ;
  polisintendent_nn_1_N : N ;
  poliskommissarie_nn_1_N : N ;
  poliskund_nn_1_N : N ;
  polismyndighet_nn_1_N : N ;
  polisong_nn_1_N : N ;
  polisorganisation_nn_1_N : N ;
  polispatrull_nn_1_N : N ;
  polisserie_nn_1_N : N ;
  polisstat_nn_1_N : N ;
  polisstation_nn_1_N : N ;
  polisuniform_nn_1_N : N ;
  politruk_nn_1_N : N ;
  polityr_nn_1_N : N ;
  polkett_nn_1_N : N ;
  pollett_nn_1_N : N ;
  pollination_nn_1_N : N ;
  pollution_nn_1_N : N ;
  polsko_nn_1_N : N ;
  polygraf_nn_1_N : N ;
  polymer_nn_1_N : N ;
  polymerisation_nn_1_N : N ;
  polyp_nn_1_N : N ;
  pompong_nn_1_N : N ;
  pontonjaer_nn_1_1_N : N ;
  poolkant_nn_1_N : N ;
  popcornapparat_nn_1_N : N ;
  popgrupp_nn_1_N : N ;
  popkonsert_nn_1_N : N ;
  poplin_nn_1_N : N ;
  popularitet_nn_1_N : N ;
  population_nn_1_N : N ;
  populaerkonsert_nn_1_1_N : N ;
  porfyr_nn_1_N : N ;
  porositet_nn_1_N : N ;
  porrfilm_nn_1_N : N ;
  porrmodell_nn_1_N : N ;
  porslinsaffaer_nn_1_1_N : N ;
  porslinsfaerg_nn_1_1_N : N ;
  portalgestalt_nn_1_N : N ;
  portfoelj_nn_1_1_N : N ;
  portik_nn_1_N : N ;
  portion_nn_1_N : N ;
  portiaer_nn_1_1_N : N ;
  portraettoer_nn_1_1_N : N ;
  portvakt_nn_1_N : N ;
  portoer_nn_1_1_N : N ;
  pose_nn_1_N : N ;
  position_nn_1_N : N ;
  possession_nn_1_N : N ;
  possessionat_nn_1_N : N ;
  postanstalt_nn_1_N : N ;
  postexpedition_nn_1_N : N ;
  postfoersaendelse_nn_1_1_N : N ;
  postkod_nn_1_N : N ;
  postposition_nn_1_N : N ;
  poststation_nn_1_N : N ;
  posttur_nn_1_N : N ;
  posoer_nn_1_1_N : N ;
  potage_nn_1_N : N ;
  potatiskanon_nn_1_N : N ;
  potatissallad_nn_1_N : N ;
  potentat_nn_1_N : N ;
  potential_nn_1_N : N ;
  pott_nn_1_N : N ;
  poulard_nn_1_N : N ;
  poaeng_nn_2_1_N : N ;
  pr_kupp_nn_1_N : N ;
  prakrit_nn_1_N : N ;
  praktfullhet_nn_1_N : N ;
  praktikalitet_nn_1_N : N ;
  praktiskhet_nn_2_N : N ;
  pratstund_nn_1_N : N ;
  preciositet_nn_1_N : N ;
  precision_nn_1_N : N ;
  precisionsroerelse_nn_1_1_N : N ;
  predation_nn_1_N : N ;
  predestination_nn_1_N : N ;
  predikatsfyllnad_nn_1_N : N ;
  predikotur_nn_1_N : N ;
  predisposition_nn_1_N : N ;
  prefekt_nn_1_N : N ;
  preferensaktie_nn_1_N : N ;
  prelat_nn_1_N : N ;
  premie_nn_1_N : N ;
  premieobligation_nn_1_N : N ;
  premiaer_nn_1_1_N : N ;
  premiaerbiljett_nn_1_1_N : N ;
  premolar_nn_1_N : N ;
  prenumeration_nn_1_N : N ;
  preparand_nn_1_N : N ;
  preparation_nn_1_N : N ;
  preposition_nn_1_N : N ;
  present_nn_1_N : N ;
  presentation_nn_1_N : N ;
  presentatoer_nn_1_1_N : N ;
  presidentbostad_nn_1_N : N ;
  preskription_nn_1_N : N ;
  preskriptionstid_nn_1_N : N ;
  presschef_nn_1_N : N ;
  pressfotograf_nn_1_N : N ;
  pressinformatoer_nn_1_1_N : N ;
  pression_nn_1_N : N ;
  presskommissarie_nn_1_N : N ;
  pressmaskin_nn_1_N : N ;
  pressrelease_nn_1_N : N ;
  presstoedsnaemnd_nn_1_1_N : N ;
  prestation_nn_1_N : N ;
  prestav_nn_1_N : N ;
  pretendent_nn_1_N : N ;
  pretention_nn_1_N : N ;
  pretext_nn_1_N : N ;
  pretiositet_nn_1_N : N ;
  prillighet_nn_1_N : N ;
  prim_nn_1_N : N ;
  primarie_nn_1_N : N ;
  primitivitet_nn_1_N : N ;
  primaergrupp_nn_1_1_N : N ;
  primaerkommun_nn_1_1_N : N ;
  primoer_nn_1_1_N : N ;
  principal_nn_1_N : N ;
  prinsgemaal_nn_1_1_N : N ;
  prinsregent_nn_1_N : N ;
  prioritet_nn_1_N : N ;
  prisbomb_nn_1_N : N ;
  prischock_nn_1_N : N ;
  priselasticitet_nn_1_N : N ;
  prisjakt_nn_1_N : N ;
  prissensation_nn_1_N : N ;
  prisuppgift_nn_1_N : N ;
  prisvariation_nn_1_N : N ;
  privatbank_nn_1_N : N ;
  privatdiskontoer_nn_1_1_N : N ;
  privatlektion_nn_1_N : N ;
  privatperson_nn_1_N : N ;
  privatsak_nn_1_N : N ;
  privatscen_nn_1_N : N ;
  prkupp_nn_1_N : N ;
  probabilitet_nn_1_N : N ;
  problembild_nn_1_N : N ;
  procentenhet_nn_1_N : N ;
  procenthalt_nn_1_N : N ;
  procession_nn_1_N : N ;
  producent_nn_1_N : N ;
  produkt_nn_1_N : N ;
  produktion_nn_1_N : N ;
  produktionsapparat_nn_1_N : N ;
  produktionskostnad_nn_1_N : N ;
  produktionsteknik_nn_1_N : N ;
  produktivitet_nn_1_N : N ;
  produktivkraft_nn_1_N : N ;
  produktmaengd_nn_1_1_N : N ;
  profanation_nn_1_N : N ;
  profession_nn_1_N : N ;
  profet_nn_1_N : N ;
  profitoer_nn_1_1_N : N ;
  programchef_nn_1_N : N ;
  programproduktion_nn_1_N : N ;
  programpunkt_nn_1_N : N ;
  programskrift_nn_1_N : N ;
  progression_nn_1_N : N ;
  progressivitet_nn_1_N : N ;
  proinsulin_nn_1_N : N ;
  projektgrupp_nn_1_N : N ;
  projektil_nn_1_N : N ;
  projektion_nn_1_N : N ;
  projektionsapparat_nn_1_N : N ;
  projektoer_nn_1_1_N : N ;
  proklamation_nn_1_N : N ;
  prolaktin_nn_1_N : N ;
  prolongation_nn_1_N : N ;
  promenad_nn_1_N : N ;
  promenadkonsert_nn_1_N : N ;
  promenoar_nn_1_N : N ;
  promiskuitet_nn_1_N : N ;
  promotion_nn_1_N : N ;
  promulgation_nn_1_N : N ;
  prononciation_nn_1_N : N ;
  propagandadikt_nn_1_N : N ;
  propagandafilm_nn_1_N : N ;
  propagandaloegn_nn_1_1_N : N ;
  proponent_nn_1_N : N ;
  proportion_nn_1_N : N ;
  proportional_nn_1_N : N ;
  proportionalitet_nn_1_N : N ;
  proposition_nn_1_N : N ;
  proppfullhet_nn_1_N : N ;
  proprietaer_nn_1_1_N : N ;
  prorogation_nn_1_N : N ;
  prosadikt_nn_1_N : N ;
  proselyt_nn_1_N : N ;
  proskription_nn_1_N : N ;
  prostatacancertumoer_nn_1_1_N : N ;
  prostitution_nn_1_N : N ;
  proteinfabrik_nn_1_N : N ;
  proteinfamilj_nn_1_N : N ;
  protektion_nn_1_N : N ;
  protestaktion_nn_1_N : N ;
  protestroerelse_nn_1_1_N : N ;
  protestskrivelse_nn_1_N : N ;
  protolyt_nn_1_N : N ;
  prototyp_nn_1_N : N ;
  provanstaellningstid_nn_1_1_N : N ;
  provensal_nn_1_N : N ;
  provision_nn_1_N : N ;
  provokation_nn_1_N : N ;
  provokatoer_nn_1_1_N : N ;
  provtur_nn_1_N : N ;
  provuppgift_nn_1_N : N ;
  prudentlighet_nn_1_N : N ;
  prunell_nn_1_N : N ;
  prydhet_nn_1_N : N ;
  prydnad_nn_1_N : N ;
  pryo_nn_1_N : N ;
  praerie_nn_1_1_N : N ;
  praestdraekt_nn_1_1_N : N ;
  praestroll_nn_1_1_N : N ;
  praalighet_nn_1_1_N : N ;
  proevostund_nn_1_1_N : N ;
  proevotid_nn_1_1_N : N ;
  psalm_nn_1_N : N ;
  pseudohaendelse_nn_1_1_N : N ;
  pseudonym_nn_1_N : N ;
  psykopat_nn_1_N : N ;
  psykoterapeut_nn_1_N : N ;
  pubertet_nn_1_N : N ;
  publicitet_nn_1_N : N ;
  publikation_nn_1_N : N ;
  puckadhet_nn_1_N : N ;
  puderkraem_nn_1_1_N : N ;
  puerilitet_nn_1_N : N ;
  pulpet_nn_1_N : N ;
  pult_nn_1_N : N ;
  pulverlack_nn_1_N : N ;
  punkfrisyr_nn_1_N : N ;
  punktion_nn_1_N : N ;
  punktmaengd_nn_1_1_N : N ;
  pupill_nn_1_N : N ;
  purin_nn_1_N : N ;
  putslustighet_nn_1_N : N ;
  pyridin_nn_1_N : N ;
  paer_nn_1_1_N : N ;
  paerlhyacint_nn_1_1_N : N ;
  paermkarusell_nn_1_1_N : N ;
  paert_nn_1_1_N : N ;
  paabyggnad_nn_1_1_N : N ;
  paafart_nn_1_1_N : N ;
  paafoeljd_nn_1_1_N : N ;
  paahittighet_nn_1_1_N : N ;
  paaminnelse_nn_1_1_N : N ;
  paaskhelg_nn_1_1_N : N ;
  paaskrift_nn_1_1_N : N ;
  paavevaerdighet_nn_1_1_N : N ;
  poebelaktighet_nn_1_1_N : N ;
  poebelmentalitet_nn_1_1_N : N ;
  rabarberpaj_nn_1_N : N ;
  rabatt_nn_1_N : N ;
  rabattkupong_nn_1_N : N ;
  radarantenn_nn_1_N : N ;
  radarkontroll_nn_1_N : N ;
  radhusfamilj_nn_1_N : N ;
  radialhastighet_nn_1_N : N ;
  radie_nn_1_N : N ;
  radikaloperation_nn_1_N : N ;
  radio_nn_1_N : N ;
  radioaktivitet_nn_1_N : N ;
  radioamatoer_nn_1_1_N : N ;
  radioandakt_nn_1_N : N ;
  radioantenn_nn_1_N : N ;
  radioapparat_nn_1_N : N ;
  radioisotop_nn_1_N : N ;
  radiokanal_nn_1_N : N ;
  radiolarie_nn_1_N : N ;
  radiosond_nn_1_N : N ;
  radiostation_nn_1_N : N ;
  radiot_nn_1_N : N ;
  radioteknik_nn_1_N : N ;
  radiotaang_nn_1_1_N : N ;
  radslutssignal_nn_1_N : N ;
  raffinad_nn_1_N : N ;
  rafraeschissoer_nn_1_1_N : N ;
  rajd_nn_1_N : N ;
  rakapparat_nn_1_N : N ;
  raket_nn_1_N : N ;
  raketfaerd_nn_1_1_N : N ;
  raketkonstruktoer_nn_1_1_N : N ;
  ramberaettelse_nn_1_1_N : N ;
  ramp_nn_1_N : N ;
  ramverkstad_nn_1_N : N ;
  ranchaegartyp_nn_1_1_N : N ;
  rancune_nn_1_N : N ;
  rand_nn_1_N : N ;
  rappell_nn_1_N : N ;
  rapportoer_nn_1_1_N : N ;
  rapsod_nn_1_N : N ;
  raritet_nn_1_N : N ;
  rasfoerfoeljelse_nn_1_1_N : N ;
  rasorolighet_nn_1_N : N ;
  rate_nn_1_N : N ;
  ratifikation_nn_1_N : N ;
  ration_nn_1_N : N ;
  rationalitet_nn_1_N : N ;
  rattonykterhet_nn_1_N : N ;
  rattstaang_nn_1_1_N : N ;
  ravin_nn_1_N : N ;
  reaktion_nn_1_N : N ;
  reaktionsprodukt_nn_1_N : N ;
  reaktionstid_nn_1_N : N ;
  reaktionszon_nn_1_N : N ;
  reaktorbyggnad_nn_1_N : N ;
  reaktorsaekerhet_nn_1_1_N : N ;
  reaktortyp_nn_1_N : N ;
  realisation_nn_1_N : N ;
  realitet_nn_1_N : N ;
  realkatalog_nn_1_N : N ;
  reallinje_nn_1_N : N ;
  realloen_nn_1_1_N : N ;
  realsaekerhet_nn_1_1_N : N ;
  realunion_nn_1_N : N ;
  rebell_nn_1_N : N ;
  recensent_nn_1_N : N ;
  recension_nn_1_N : N ;
  receptarie_nn_1_N : N ;
  reception_nn_1_N : N ;
  receptivitet_nn_1_N : N ;
  recession_nn_1_N : N ;
  recett_nn_1_N : N ;
  recipiend_nn_1_N : N ;
  recipient_nn_1_N : N ;
  reciprocitet_nn_1_N : N ;
  recitation_nn_1_N : N ;
  redaktion_nn_1_N : N ;
  redd_nn_1_N : N ;
  rederiverksamhet_nn_1_N : N ;
  redingot_nn_1_N : N ;
  redlighet_nn_1_N : N ;
  redogoerelse_nn_1_1_N : N ;
  redovisningsskyldighet_nn_1_N : N ;
  redskapsmetall_nn_1_N : N ;
  reduceringsventil_nn_1_N : N ;
  reduktion_nn_1_N : N ;
  reduplikation_nn_1_N : N ;
  redutt_nn_1_N : N ;
  referensgrupp_nn_1_N : N ;
  referenspunkt_nn_1_N : N ;
  referenssort_nn_1_N : N ;
  referent_nn_1_N : N ;
  refill_nn_1_N : N ;
  reflektion_nn_1_N : N ;
  reflexion_nn_1_N : N ;
  reformation_nn_1_N : N ;
  refraktion_nn_1_N : N ;
  refraeng_nn_1_1_N : N ;
  refug_nn_1_N : N ;
  regal_nn_1_N : N ;
  regelbundenhet_nn_1_N : N ;
  regelefterlevnad_nn_1_N : N ;
  regelmaessighet_nn_1_1_N : N ;
  regelvidrighet_nn_1_N : N ;
  regementschef_nn_1_N : N ;
  regeneration_nn_1_N : N ;
  regent_nn_1_N : N ;
  regentfamilj_nn_1_N : N ;
  regentlaengd_nn_1_1_N : N ;
  regeringsbyggnad_nn_1_N : N ;
  regeringschef_nn_1_N : N ;
  regeringsdeklaration_nn_1_N : N ;
  regeringsform_nn_1_N : N ;
  regeringskoalition_nn_1_N : N ;
  regeringsmakt_nn_1_N : N ;
  regeringsproposition_nn_1_N : N ;
  regeringsraett_nn_1_1_N : N ;
  regimfiende_nn_1_N : N ;
  region_nn_1_N : N ;
  regionstyrelse_nn_1_N : N ;
  regissoer_nn_1_1_N : N ;
  regnmaengd_nn_1_1_N : N ;
  regnperiod_nn_1_N : N ;
  regntid_nn_1_N : N ;
  regression_nn_1_N : N ;
  regularitet_nn_1_N : N ;
  rehabiliteringsplan_nn_1_N : N ;
  reifikation_nn_1_N : N ;
  reinkarnation_nn_1_N : N ;
  rekapitulation_nn_1_N : N ;
  reklam_nn_1_N : N ;
  reklamagent_nn_1_N : N ;
  reklamation_nn_1_N : N ;
  reklamkupp_nn_1_N : N ;
  rekommendation_nn_1_N : N ;
  rekonstruktion_nn_1_N : N ;
  rekreation_nn_1_N : N ;
  rekryt_nn_1_N : N ;
  rektascension_nn_1_N : N ;
  rektifikation_nn_1_N : N ;
  rektion_nn_1_N : N ;
  rektorsexpedition_nn_1_N : N ;
  rekurrensrelation_nn_1_N : N ;
  rekvisition_nn_1_N : N ;
  rekvisitoer_nn_1_1_N : N ;
  relation_nn_1_N : N ;
  relativitet_nn_1_N : N ;
  relaxation_nn_1_N : N ;
  release_nn_1_N : N ;
  reliabilitet_nn_1_N : N ;
  relief_nn_1_N : N ;
  religion_nn_1_N : N ;
  religionsfrihet_nn_1_N : N ;
  religionsfoerfoeljelse_nn_1_1_N : N ;
  religionsurkund_nn_1_N : N ;
  religiositet_nn_1_N : N ;
  relaestation_nn_1_1_N : N ;
  remissdebatt_nn_1_N : N ;
  remittent_nn_1_N : N ;
  renegat_nn_1_N : N ;
  renhet_nn_1_N : N ;
  renhaallningsmyndighet_nn_1_1_N : N ;
  renjakt_nn_1_N : N ;
  renko_nn_1_N : N ;
  renkonterstrid_nn_1_N : N ;
  renlevnad_nn_1_N : N ;
  renlighet_nn_1_N : N ;
  renlaerighet_nn_1_1_N : N ;
  renovation_nn_1_N : N ;
  reostat_nn_1_N : N ;
  reparation_nn_1_N : N ;
  reparatoer_nn_1_1_N : N ;
  repartition_nn_1_N : N ;
  repertoar_nn_1_N : N ;
  repetition_nn_1_N : N ;
  repetitionslokal_nn_1_N : N ;
  repetitoer_nn_1_1_N : N ;
  replik_nn_1_N : N ;
  replipunkt_nn_1_N : N ;
  replokal_nn_1_N : N ;
  repmaanad_nn_1_1_N : N ;
  representation_nn_1_N : N ;
  representationsreform_nn_1_N : N ;
  repressalie_nn_1_N : N ;
  repressalieaatgaerd_nn_1_1_N : N ;
  repression_nn_1_N : N ;
  reprimand_nn_1_N : N ;
  reproduktion_nn_1_N : N ;
  republik_nn_1_N : N ;
  repulsion_nn_1_N : N ;
  reputation_nn_1_N : N ;
  researrangoer_nn_1_1_N : N ;
  resebiljett_nn_1_N : N ;
  resegarderob_nn_1_N : N ;
  reseguide_nn_1_N : N ;
  resektion_nn_1_N : N ;
  resenaer_nn_1_1_N : N ;
  reserv_nn_1_N : N ;
  reservation_nn_1_N : N ;
  reservationsloeshet_nn_1_1_N : N ;
  reservoar_nn_1_N : N ;
  reseskrivmaskin_nn_1_N : N ;
  resguide_nn_1_N : N ;
  residensstad_nn_1_N : N ;
  resignation_nn_1_N : N ;
  resistivitet_nn_1_N : N ;
  reskamrat_nn_1_N : N ;
  resolution_nn_1_N : N ;
  resonoer_nn_1_1_N : N ;
  resorption_nn_1_N : N ;
  respektfullhet_nn_1_N : N ;
  respektloeshet_nn_1_1_N : N ;
  respiration_nn_1_N : N ;
  respondent_nn_1_N : N ;
  restauration_nn_1_N : N ;
  restauratoer_nn_1_1_N : N ;
  restid_nn_1_N : N ;
  restitution_nn_1_N : N ;
  restlaengd_nn_1_1_N : N ;
  restprodukt_nn_1_N : N ;
  restriktion_nn_1_N : N ;
  resaar_nn_1_1_N : N ;
  retardation_nn_1_N : N ;
  retbarhet_nn_1_N : N ;
  retention_nn_1_N : N ;
  retort_nn_1_N : N ;
  retsamhet_nn_1_N : N ;
  returfaerd_nn_1_1_N : N ;
  reunion_nn_1_N : N ;
  revelation_nn_1_N : N ;
  revelj_nn_1_N : N ;
  revision_nn_1_N : N ;
  revisionsberaettelse_nn_1_1_N : N ;
  revoke_nn_1_N : N ;
  revolt_nn_1_N : N ;
  revoltoer_nn_1_1_N : N ;
  revolution_nn_1_N : N ;
  revaer_nn_1_1_N : N ;
  rhizom_nn_1_N : N ;
  ribosom_nn_1_N : N ;
  rickettsie_nn_1_N : N ;
  riddraekt_nn_1_1_N : N ;
  ridhaestdressyr_nn_1_1_N : N ;
  ridkunnighet_nn_1_N : N ;
  ridtur_nn_1_N : N ;
  rififikupp_nn_1_N : N ;
  rikoschett_nn_1_N : N ;
  riksangelaegenhet_nn_1_1_N : N ;
  riksantikvarie_nn_1_N : N ;
  riksarkivarie_nn_1_N : N ;
  riksbank_nn_1_N : N ;
  riksbibliotekarie_nn_1_N : N ;
  riksdagsdebatt_nn_1_N : N ;
  riksdagsgrupp_nn_1_N : N ;
  riksdagsledamot_nn_1_N : N ;
  riksorganisation_nn_1_N : N ;
  riksprototyp_nn_1_N : N ;
  riksraett_nn_1_1_N : N ;
  riksstyrelse_nn_1_N : N ;
  riktighet_nn_1_N : N ;
  riktlinje_nn_1_N : N ;
  riktningskoefficient_nn_1_N : N ;
  riktpunkt_nn_1_N : N ;
  rimlighet_nn_1_N : N ;
  rimsmed_nn_1_N : N ;
  ringart_nn_1_N : N ;
  ringhet_nn_1_N : N ;
  rips_nn_1_N : N ;
  riskgrupp_nn_1_N : N ;
  riskmodell_nn_1_N : N ;
  riskzon_nn_1_N : N ;
  risoll_nn_1_N : N ;
  risraett_nn_1_1_N : N ;
  rit_nn_1_N : N ;
  ritapparat_nn_1_N : N ;
  rival_nn_1_N : N ;
  rivalitet_nn_1_N : N ;
  rivningslaegenhet_nn_1_1_N : N ;
  rivningstomt_nn_1_N : N ;
  rivstart_nn_1_N : N ;
  robe_nn_1_N : N ;
  robinsonad_nn_1_N : N ;
  rockad_nn_1_N : N ;
  rockkonsert_nn_1_N : N ;
  rodd_nn_1_N : N ;
  roddarsaang_nn_1_1_N : N ;
  rodeo_nn_1_N : N ;
  rodnad_nn_1_N : N ;
  rokokodam_nn_1_N : N ;
  rolighet_nn_1_N : N ;
  romanistik_nn_1_N : N ;
  romansvit_nn_1_N : N ;
  romantradition_nn_1_N : N ;
  romb_nn_1_N : N ;
  rond_nn_1_N : N ;
  rondell_nn_1_N : N ;
  rosenkind_nn_1_N : N ;
  rosenrabatt_nn_1_N : N ;
  rosett_nn_1_N : N ;
  rostskyddsfaerg_nn_1_1_N : N ;
  rotation_nn_1_N : N ;
  rotationshastighet_nn_1_N : N ;
  rotfrukt_nn_1_N : N ;
  rotgroensak_nn_1_1_N : N ;
  rotkanal_nn_1_N : N ;
  rotogravyr_nn_1_N : N ;
  rotogravyrbild_nn_1_N : N ;
  rotsak_nn_1_N : N ;
  rottingfaatoelj_nn_1_1_N : N ;
  route_nn_1_N : N ;
  ruinstad_nn_1_N : N ;
  rullgardin_nn_1_N : N ;
  rullskridsko_nn_1_N : N ;
  rumsbredd_nn_1_N : N ;
  rumskamrat_nn_1_N : N ;
  rumslighet_nn_1_N : N ;
  rumaen_nn_1_1_N : N ;
  rundhet_nn_1_N : N ;
  rundhorisont_nn_1_N : N ;
  rundskrivelse_nn_1_N : N ;
  rundtur_nn_1_N : N ;
  runosaang_nn_1_1_N : N ;
  runrad_nn_1_N : N ;
  runskrift_nn_1_N : N ;
  rupie_nn_1_N : N ;
  rusdryck_nn_1_N : N ;
  ruskighet_nn_1_N : N ;
  rusningstid_nn_1_N : N ;
  ruten_nn_1_N : N ;
  rutinoperation_nn_1_N : N ;
  ruttenhet_nn_2_N : N ;
  ryggoperation_nn_1_N : N ;
  ryggrad_nn_1_N : N ;
  ryggtrakt_nn_1_N : N ;
  ryktbarhet_nn_1_N : N ;
  rymd_nn_1_N : N ;
  rymddraekt_nn_1_1_N : N ;
  rymdfartsstyrelse_nn_1_N : N ;
  rymdfaerd_nn_1_1_N : N ;
  rymdpilot_nn_1_N : N ;
  rymdpromenad_nn_1_N : N ;
  rymdraket_nn_1_N : N ;
  rymdsond_nn_1_N : N ;
  rymdstation_nn_1_N : N ;
  rymdstyrelse_nn_1_N : N ;
  rysklektion_nn_1_N : N ;
  ryslighet_nn_1_N : N ;
  rytm_nn_1_N : N ;
  rytmicitet_nn_1_N : N ;
  rytmsektion_nn_1_N : N ;
  raeckvidd_nn_1_1_N : N ;
  raeddningsaktion_nn_1_1_N : N ;
  raeddningschef_nn_1_1_N : N ;
  raeddningsenhet_nn_1_1_N : N ;
  raeddningsoperation_nn_1_1_N : N ;
  raejong_nn_1_1_N : N ;
  raekneapparat_nn_1_1_N : N ;
  raeknekapacitet_nn_1_1_N : N ;
  raeknemaskin_nn_1_1_N : N ;
  raeknesnabbhet_nn_1_1_N : N ;
  raekpaj_nn_1_1_N : N ;
  rael_nn_1_1_N : N ;
  raelighet_nn_1_1_N : N ;
  raelsbusstation_nn_1_1_N : N ;
  raenkfullhet_nn_1_1_N : N ;
  raentabilitet_nn_1_1_N : N ;
  raentemarginal_nn_1_1_N : N ;
  raentesubvention_nn_1_1_N : N ;
  raentetermin_nn_1_1_N : N ;
  raett_nn_2_1_N : N ;
  raettelse_nn_1_1_N : N ;
  raettframhet_nn_1_1_N : N ;
  raettfaerdighet_nn_1_1_N : N ;
  raettighet_nn_1_1_N : N ;
  raettschef_nn_1_1_N : N ;
  raettsinformation_nn_1_1_N : N ;
  raettskapacitet_nn_1_1_N : N ;
  raettsosaekerhet_nn_1_1_N : N ;
  raettspaafoeljd_nn_1_1_N : N ;
  raettssak_nn_1_1_N : N ;
  raettsstat_nn_1_1_N : N ;
  raettssaekerhet_nn_1_1_N : N ;
  raevjakt_nn_1_1_N : N ;
  raadhusraett_nn_1_1_N : N ;
  raadsrepublik_nn_1_1_N : N ;
  raadstuguraett_nn_1_1_N : N ;
  raadsturaett_nn_1_1_N : N ;
  raadstuvuraett_nn_1_1_N : N ;
  raahet_nn_1_1_N : N ;
  raakostaffaer_nn_1_1_N : N ;
  raasockerfabrik_nn_1_1_N : N ;
  roedbetssallad_nn_1_1_N : N ;
  roekbomb_nn_1_1_N : N ;
  roekelse_nn_1_1_N : N ;
  roekgranat_nn_1_1_N : N ;
  roekheroin_nn_1_1_N : N ;
  roekkanal_nn_1_1_N : N ;
  roekspiral_nn_1_1_N : N ;
  roentgenapparat_nn_1_1_N : N ;
  roentgenbild_nn_1_1_N : N ;
  roentgentid_nn_1_1_N : N ;
  roerelse_nn_1_1_N : N ;
  roerelsefrihet_nn_1_1_N : N ;
  roerelsemaengd_nn_1_1_N : N ;
  roerelsesvaarighet_nn_1_1_N : N ;
  roerlighet_nn_1_1_N : N ;
  roermontoer_nn_1_1_N : N ;
  roertaang_nn_1_1_N : N ;
  roestlaengd_nn_1_1_N : N ;
  roestraekningsmaskin_nn_1_1_N : N ;
  roetmaanad_nn_1_1_N : N ;
  roevtrakt_nn_1_1_N : N ;
  sabadill_nn_1_N : N ;
  sabbat_nn_1_N : N ;
  sabbatstermin_nn_1_N : N ;
  sabelbajonett_nn_1_N : N ;
  sabotoer_nn_1_1_N : N ;
  sackarin_nn_1_N : N ;
  sackett_nn_1_N : N ;
  saffranslaengd_nn_1_1_N : N ;
  safir_nn_1_N : N ;
  saftkraem_nn_1_1_N : N ;
  saftstation_nn_1_N : N ;
  sagogestalt_nn_1_N : N ;
  sagopalm_nn_1_N : N ;
  sagostund_nn_1_N : N ;
  sakdebatt_nn_1_N : N ;
  sakdiskussion_nn_1_N : N ;
  saklighet_nn_1_N : N ;
  saknad_nn_1_N : N ;
  sakuppgift_nn_1_N : N ;
  sakoereslaengd_nn_1_1_N : N ;
  saladjaer_nn_1_1_N : N ;
  salighet_nn_1_N : N ;
  salinitet_nn_1_N : N ;
  salivation_nn_1_N : N ;
  sallad_nn_1_N : N ;
  salladsbar_nn_1_N : N ;
  salong_nn_1_N : N ;
  salongsbiljett_nn_1_N : N ;
  salongsbolsjevik_nn_1_N : N ;
  salongsfilosof_nn_1_N : N ;
  salpeterbakterie_nn_1_N : N ;
  salpetersyrlighet_nn_1_N : N ;
  salspatient_nn_1_N : N ;
  saltbassaeng_nn_1_1_N : N ;
  salthalt_nn_1_N : N ;
  saltkoncentration_nn_1_N : N ;
  saltomortal_nn_1_N : N ;
  saltstod_nn_1_N : N ;
  saltoert_nn_1_1_N : N ;
  salut_nn_1_N : N ;
  salutkanon_nn_1_N : N ;
  salvelsefullhet_nn_1_N : N ;
  salvkanon_nn_1_N : N ;
  samarbetsform_nn_1_N : N ;
  samarbetsorganisation_nn_1_N : N ;
  sambo_nn_1_N : N ;
  samdistribution_nn_1_N : N ;
  same_nn_1_N : N ;
  samfaellighet_nn_1_1_N : N ;
  samfaerdsled_nn_1_1_N : N ;
  samhaellsbyggnad_nn_1_1_N : N ;
  samhaellsdebatt_nn_1_1_N : N ;
  samhaellsform_nn_1_1_N : N ;
  samhaellsfunktion_nn_1_1_N : N ;
  samhaellsgrupp_nn_1_1_N : N ;
  samhaellsinformation_nn_1_1_N : N ;
  samhaellskostnad_nn_1_1_N : N ;
  samhaellsnorm_nn_1_1_N : N ;
  samhaellssfaer_nn_1_1_N : N ;
  samhaellssyn_nn_1_1_N : N ;
  samhaellsuppbyggnad_nn_1_1_N : N ;
  samhaellsvarelse_nn_1_1_N : N ;
  samhaellsvetenskap_nn_1_1_N : N ;
  samhoerighet_nn_1_1_N : N ;
  samlevnad_nn_1_N : N ;
  samlingslokal_nn_1_N : N ;
  samlingspunkt_nn_1_N : N ;
  sammansaettningsfabrik_nn_1_1_N : N ;
  sammetsnatt_nn_1_N : N ;
  samojed_nn_1_N : N ;
  samovar_nn_1_N : N ;
  samtalsavgift_nn_1_N : N ;
  samtalsgrupp_nn_1_N : N ;
  samtalsperiod_nn_1_N : N ;
  samtalsterapeut_nn_1_N : N ;
  samtidighet_nn_1_N : N ;
  samtidskommentar_nn_1_N : N ;
  samuraj_nn_1_N : N ;
  samvariation_nn_1_N : N ;
  samverkanskomponent_nn_1_N : N ;
  samvetsattack_nn_1_N : N ;
  samvetsbetaenklighet_nn_1_1_N : N ;
  samvetsfrihet_nn_1_N : N ;
  samvetsfoerebraaelse_nn_1_1_N : N ;
  samvetskonflikt_nn_1_N : N ;
  samvetsloeshet_nn_1_1_N : N ;
  samvetssak_nn_1_N : N ;
  sandal_nn_1_N : N ;
  sandalett_nn_1_N : N ;
  sandbakelse_nn_1_N : N ;
  sanddyn_nn_1_N : N ;
  sandmark_nn_1_N : N ;
  sandstrand_nn_1_N : N ;
  sandtaekt_nn_1_1_N : N ;
  saneringsfastighet_nn_1_N : N ;
  saneringskostnad_nn_1_N : N ;
  sanitet_nn_1_N : N ;
  sanitetsanstalt_nn_1_N : N ;
  sanitetstrupp_nn_1_N : N ;
  sanktifikation_nn_1_N : N ;
  sanktion_nn_1_N : N ;
  sanningsdrog_nn_1_N : N ;
  sannolikhet_nn_1_N : N ;
  sansculotte_nn_1_N : N ;
  sansloeshet_nn_2_1_N : N ;
  sapp_nn_1_N : N ;
  sappoer_nn_1_1_N : N ;
  saprofyt_nn_1_N : N ;
  saraband_nn_1_N : N ;
  saracen_nn_1_N : N ;
  sard_nn_1_N : N ;
  sardell_nn_1_N : N ;
  sarkasm_nn_1_N : N ;
  sarkofag_nn_1_N : N ;
  sarong_nn_1_N : N ;
  sars_nn_1_N : N ;
  satellitbild_nn_1_N : N ;
  satellitradiostation_nn_1_N : N ;
  satellitstat_nn_1_N : N ;
  satin_nn_1_N : N ;
  satir_nn_1_N : N ;
  satisfaktion_nn_1_N : N ;
  satrap_nn_1_N : N ;
  satsaccent_nn_1_N : N ;
  satsbyggnad_nn_1_N : N ;
  satskonstruktion_nn_1_N : N ;
  satstyp_nn_1_N : N ;
  satyr_nn_1_N : N ;
  sataeng_nn_1_1_N : N ;
  saudiarab_nn_1_N : N ;
  savann_nn_1_N : N ;
  savningstid_nn_1_N : N ;
  savojard_nn_1_N : N ;
  savtid_nn_1_N : N ;
  saxdomkraft_nn_1_N : N ;
  sbirr_nn_1_N : N ;
  scenbild_nn_1_N : N ;
  sceninstruktoer_nn_1_1_N : N ;
  scenograf_nn_1_N : N ;
  scenshow_nn_1_N : N ;
  schablonbild_nn_1_N : N ;
  schackningsperiod_nn_1_N : N ;
  schagg_nn_1_N : N ;
  schaktkant_nn_1_N : N ;
  schaktmaskin_nn_1_N : N ;
  schalett_nn_1_N : N ;
  schavott_nn_1_N : N ;
  schejk_nn_1_N : N ;
  schrammelkvartett_nn_1_N : N ;
  schaeslong_nn_1_1_N : N ;
  scintillation_nn_1_N : N ;
  scopolamin_nn_1_N : N ;
  scout_nn_1_N : N ;
  scoutjamboree_nn_1_N : N ;
  scoutkaar_nn_1_1_N : N ;
  scoutpatrull_nn_1_N : N ;
  sedativum_nn_1_N : N ;
  sedelautomat_nn_1_N : N ;
  sedelreserv_nn_1_N : N ;
  sedlighet_nn_1_N : N ;
  sefard_nn_1_N : N ;
  segeljakt_nn_1_N : N ;
  segelkanot_nn_1_N : N ;
  segelled_nn_1_N : N ;
  segelskridsko_nn_1_N : N ;
  seghet_nn_1_N : N ;
  seglation_nn_1_N : N ;
  segregation_nn_1_N : N ;
  seigneur_nn_1_N : N ;
  seismograf_nn_1_N : N ;
  sejour_nn_1_N : N ;
  sekatoer_nn_1_1_N : N ;
  sekretion_nn_1_N : N ;
  sekretaer_nn_1_1_N : N ;
  sekt_nn_1_N : N ;
  sektion_nn_1_N : N ;
  sektmentalitet_nn_1_N : N ;
  sekularisation_nn_1_N : N ;
  sekund_nn_1_N : N ;
  sekundchef_nn_1_N : N ;
  sekundaergrupp_nn_1_1_N : N ;
  sekundaerinfektion_nn_1_1_N : N ;
  sekundaerkommun_nn_1_1_N : N ;
  selektion_nn_1_N : N ;
  selektivitet_nn_1_N : N ;
  selencell_nn_1_N : N ;
  semesterfloert_nn_1_1_N : N ;
  semesterloen_nn_1_1_N : N ;
  semestermaanad_nn_1_1_N : N ;
  semesterort_nn_1_N : N ;
  semestertid_nn_1_N : N ;
  semination_nn_1_N : N ;
  seminstation_nn_1_N : N ;
  seminoer_nn_1_1_N : N ;
  senat_nn_1_N : N ;
  senilitet_nn_1_N : N ;
  sensation_nn_1_N : N ;
  sensibilitet_nn_1_N : N ;
  sensigrupp_nn_1_N : N ;
  sensitivitet_nn_1_N : N ;
  sensitivitetstalang_nn_1_N : N ;
  sensmoral_nn_1_N : N ;
  sensommarnatt_nn_1_N : N ;
  sensualitet_nn_1_N : N ;
  sentimentalitet_nn_1_N : N ;
  separatfred_nn_1_N : N ;
  separation_nn_1_N : N ;
  separatistroerelse_nn_1_1_N : N ;
  septett_nn_1_N : N ;
  seraf_nn_1_N : N ;
  seralj_nn_1_N : N ;
  serb_nn_1_N : N ;
  serenad_nn_1_N : N ;
  serenitet_nn_1_N : N ;
  sergeant_nn_1_N : N ;
  serie_nn_1_N : N ;
  serieproduktion_nn_1_N : N ;
  seriff_nn_1_N : N ;
  seriositet_nn_1_N : N ;
  serotonin_nn_1_N : N ;
  serpent_nn_1_N : N ;
  servelinje_nn_1_N : N ;
  serveringsavgift_nn_1_N : N ;
  servett_nn_1_N : N ;
  servicebostad_nn_1_N : N ;
  servicebutik_nn_1_N : N ;
  servicelaegenhet_nn_1_1_N : N ;
  servicepersonal_nn_1_N : N ;
  servicestation_nn_1_N : N ;
  servilitet_nn_1_N : N ;
  servitoer_nn_1_1_N : N ;
  servlinje_nn_1_N : N ;
  session_nn_1_N : N ;
  sevaerdhet_nn_1_1_N : N ;
  sexaffaer_nn_1_1_N : N ;
  sexakt_nn_1_N : N ;
  sexbomb_nn_1_N : N ;
  sexhaendelse_nn_1_1_N : N ;
  sexklinik_nn_1_N : N ;
  sexleksak_nn_1_N : N ;
  sexmyt_nn_1_N : N ;
  sexsajt_nn_1_N : N ;
  sexscen_nn_1_N : N ;
  sext_nn_1_N : N ;
  sextett_nn_1_N : N ;
  sexualakt_nn_1_N : N ;
  sexualdrift_nn_1_N : N ;
  sexualitet_nn_1_N : N ;
  sexaarsperiod_nn_1_1_N : N ;
  shejk_nn_1_N : N ;
  sheriff_nn_1_N : N ;
  shoppingtur_nn_1_N : N ;
  show_nn_1_N : N ;
  shuntventil_nn_1_N : N ;
  siameskatt_nn_1_N : N ;
  sibet_nn_1_N : N ;
  sibetkatt_nn_1_N : N ;
  sidlinje_nn_1_N : N ;
  sidoapparat_nn_1_N : N ;
  sidobyggnad_nn_1_N : N ;
  sidoeffekt_nn_1_N : N ;
  sidolinje_nn_1_N : N ;
  sidvoerdnad_nn_1_1_N : N ;
  sifferfoeljd_nn_1_1_N : N ;
  sifferkombination_nn_1_N : N ;
  sifferuppgift_nn_1_N : N ;
  signalhastighet_nn_1_N : N ;
  signaltrupp_nn_1_N : N ;
  signataer_nn_1_1_N : N ;
  signataermakt_nn_1_1_N : N ;
  signelse_nn_1_N : N ;
  sikh_nn_1_N : N ;
  siktlinje_nn_1_N : N ;
  silen_nn_1_N : N ;
  silhuett_nn_1_N : N ;
  silkeslarv_nn_1_N : N ;
  sillperiod_nn_1_N : N ;
  sillsallad_nn_1_N : N ;
  sillsallat_nn_1_N : N ;
  siluett_nn_1_N : N ;
  silverhalt_nn_1_N : N ;
  silvermedalj_nn_1_N : N ;
  silversmed_nn_1_N : N ;
  simand_nn_1_N : N ;
  simbassaeng_nn_1_1_N : N ;
  simdraekt_nn_1_1_N : N ;
  simkandidat_nn_1_N : N ;
  simpelhet_nn_1_N : N ;
  simpromotion_nn_1_N : N ;
  simtur_nn_1_N : N ;
  simulation_nn_1_N : N ;
  simultanscen_nn_1_N : N ;
  sinekur_nn_1_N : N ;
  singularitet_nn_1_N : N ;
  sinnebild_nn_1_N : N ;
  sinnesart_nn_1_N : N ;
  sinnescell_nn_1_N : N ;
  sinnesfoernimmelse_nn_1_1_N : N ;
  sinnesnerv_nn_1_N : N ;
  sinnesroerelse_nn_1_1_N : N ;
  sinnesupplevelse_nn_1_N : N ;
  sinnlighet_nn_1_N : N ;
  sinuston_nn_1_N : N ;
  sirat_nn_1_N : N ;
  siren_nn_1_N : N ;
  sirlighet_nn_1_N : N ;
  sitar_nn_1_N : N ;
  sittgrupp_nn_1_N : N ;
  sittstaang_nn_1_1_N : N ;
  situation_nn_1_N : N ;
  situationsbild_nn_1_N : N ;
  sjagg_nn_1_N : N ;
  sjalett_nn_1_N : N ;
  sjaskighet_nn_1_N : N ;
  sjukdomsbild_nn_1_N : N ;
  sjukhet_nn_1_N : N ;
  sjukjournal_nn_1_N : N ;
  sjukledighet_nn_1_N : N ;
  sjuklighet_nn_1_N : N ;
  sjukpension_nn_1_N : N ;
  sjukvikarie_nn_1_N : N ;
  sjukvaardsaffaer_nn_1_1_N : N ;
  sjukvaardsapparat_nn_1_1_N : N ;
  sjukvaardsreform_nn_1_1_N : N ;
  sjukvaardsregion_nn_1_1_N : N ;
  sjunkbomb_nn_1_N : N ;
  sjaelloeshet_nn_1_1_N : N ;
  sjaelsegenskap_nn_1_1_N : N ;
  sjaelsfraende_nn_1_1_N : N ;
  sjaelsfoermoegenhet_nn_1_1_N : N ;
  sjaelskonflikt_nn_1_1_N : N ;
  sjaelsstrid_nn_1_1_N : N ;
  sjaelvanklagelse_nn_1_1_N : N ;
  sjaelvbekaennelse_nn_1_1_N : N ;
  sjaelvbelaatenhet_nn_1_1_N : N ;
  sjaelvbo_nn_1_1_N : N ;
  sjaelvdeklaration_nn_1_1_N : N ;
  sjaelvfoerebraaelse_nn_1_1_N : N ;
  sjaelvfoerhaevelse_nn_1_1_N : N ;
  sjaelvfoernekelse_nn_1_1_N : N ;
  sjaelvgodhet_nn_1_1_N : N ;
  sjaelvhjaelpsentreprenoer_nn_1_1_N : N ;
  sjaelvhjaelpsgenre_nn_1_1_N : N ;
  sjaelviakttagelse_nn_1_1_N : N ;
  sjaelviskhet_nn_1_1_N : N ;
  sjaelvklarhet_nn_1_1_N : N ;
  sjaelvmedvetenhet_nn_1_1_N : N ;
  sjaelvmordsattack_nn_1_1_N : N ;
  sjaelvmordsbomb_nn_1_1_N : N ;
  sjaelvmordskandidat_nn_1_1_N : N ;
  sjaelvmotsaegelse_nn_1_1_N : N ;
  sjaelvstaendighet_nn_1_1_N : N ;
  sjaelvsuggestion_nn_1_1_N : N ;
  sjaelvsaekerhet_nn_1_1_N : N ;
  sjoefrakt_nn_1_1_N : N ;
  sjoefaerd_nn_1_1_N : N ;
  sjoefaagelsjakt_nn_1_1_N : N ;
  sjoekapten_nn_1_1_N : N ;
  sjoeko_nn_1_1_N : N ;
  sjoelaegenhet_nn_1_1_N : N ;
  sjoeroevarkapten_nn_1_1_N : N ;
  sjoestrid_nn_1_1_N : N ;
  sjoetomt_nn_1_1_N : N ;
  sjoevaerdighet_nn_1_1_N : N ;
  skadegoerelse_nn_1_1_N : N ;
  skadeinsekt_nn_1_N : N ;
  skadlighet_nn_1_N : N ;
  skallform_nn_1_N : N ;
  skalp_nn_1_N : N ;
  skalpell_nn_1_N : N ;
  skamlighet_nn_1_N : N ;
  skamloeshet_nn_1_1_N : N ;
  skandal_nn_1_N : N ;
  skandalbild_nn_1_N : N ;
  skandalscen_nn_1_N : N ;
  skandinav_nn_1_N : N ;
  skaparkraft_nn_1_N : N ;
  skapelse_nn_1_N : N ;
  skapelseakt_nn_1_N : N ;
  skapelseberaettelse_nn_1_1_N : N ;
  skapnad_nn_1_N : N ;
  skarphet_nn_2_N : N ;
  skarpsyn_nn_1_N : N ;
  skarvpopulation_nn_1_N : N ;
  skattebefrielse_nn_1_N : N ;
  skattebonde_nn_1_N : N ;
  skattefrihet_nn_1_N : N ;
  skatteintaekt_nn_1_1_N : N ;
  skattekraft_nn_1_N : N ;
  skattelaettnad_nn_1_1_N : N ;
  skattemoral_nn_1_N : N ;
  skattemyndighet_nn_1_N : N ;
  skattereduktion_nn_1_N : N ;
  skattereform_nn_1_N : N ;
  skatterevolt_nn_1_N : N ;
  skattesubvention_nn_1_N : N ;
  skattetabell_nn_1_N : N ;
  skatteuppboerd_nn_1_1_N : N ;
  skavank_nn_1_N : N ;
  skedand_nn_1_N : N ;
  skeloegdhet_nn_1_1_N : N ;
  skenbild_nn_1_N : N ;
  skenfrukt_nn_1_N : N ;
  skengestalt_nn_1_N : N ;
  skenhelighet_nn_1_N : N ;
  skenhaendelse_nn_1_1_N : N ;
  skepnad_nn_1_N : N ;
  skevhet_nn_1_N : N ;
  skickelse_nn_1_N : N ;
  skicklighet_nn_1_N : N ;
  skidort_nn_1_N : N ;
  skidtur_nn_1_N : N ;
  skidtyp_nn_1_N : N ;
  skiktroentgenapparat_nn_1_1_N : N ;
  skiljaktighet_nn_1_N : N ;
  skiljelinje_nn_1_N : N ;
  skiljenaemnd_nn_1_1_N : N ;
  skillnad_nn_1_N : N ;
  skiltvakt_nn_1_N : N ;
  skinnfaatoelj_nn_1_1_N : N ;
  skinnimitation_nn_1_N : N ;
  skitsak_nn_1_N : N ;
  skivaffaer_nn_1_1_N : N ;
  skivbar_nn_1_N : N ;
  skivdistribution_nn_1_N : N ;
  skivstaang_nn_1_1_N : N ;
  sko_nn_1_N : N ;
  skogsbrand_nn_1_N : N ;
  skogskovall_nn_1_N : N ;
  skogsmark_nn_1_N : N ;
  skogstomt_nn_1_N : N ;
  skogsutflykt_nn_1_N : N ;
  skogsvidd_nn_1_N : N ;
  skojighet_nn_1_N : N ;
  skokartong_nn_1_N : N ;
  skokraem_nn_1_1_N : N ;
  skolavgift_nn_1_N : N ;
  skolbrand_nn_1_N : N ;
  skolbyggnad_nn_1_N : N ;
  skolchef_nn_1_N : N ;
  skolelev_nn_1_N : N ;
  skolform_nn_1_N : N ;
  skolgrammatik_nn_1_N : N ;
  skolinspektion_nn_1_N : N ;
  skoljournal_nn_1_N : N ;
  skolkamrat_nn_1_N : N ;
  skolmognad_nn_1_N : N ;
  skolmyndighet_nn_1_N : N ;
  skolmaaltid_nn_1_1_N : N ;
  skolnaemnd_nn_1_1_N : N ;
  skolsituation_nn_1_N : N ;
  skolstyrelse_nn_1_N : N ;
  skolunderbyggnad_nn_1_N : N ;
  skolungdomsidrott_nn_1_N : N ;
  skomakarverkstad_nn_1_N : N ;
  skonert_nn_1_N : N ;
  skoningsloeshet_nn_1_1_N : N ;
  skopofil_nn_1_N : N ;
  skopolamin_nn_1_N : N ;
  skottlinje_nn_1_N : N ;
  skottsekund_nn_1_N : N ;
  skottvidd_nn_1_N : N ;
  skraplott_nn_1_N : N ;
  skrattkramp_nn_1_N : N ;
  skribent_nn_1_N : N ;
  skridsko_nn_1_N : N ;
  skriftbild_nn_1_N : N ;
  skriftspraaklighet_nn_1_1_N : N ;
  skriksession_nn_1_N : N ;
  skrivbordskonstruktion_nn_1_N : N ;
  skrivelse_nn_1_N : N ;
  skrivmaskin_nn_1_N : N ;
  skrivmaskinstangent_nn_1_N : N ;
  skrockfullhet_nn_1_N : N ;
  skrodoer_nn_1_1_N : N ;
  skrotningspremie_nn_1_N : N ;
  skrovlighet_nn_1_N : N ;
  skrupelloeshet_nn_1_1_N : N ;
  skraeckberaettelse_nn_1_1_N : N ;
  skraeckbild_nn_1_1_N : N ;
  skraeckfilm_nn_1_1_N : N ;
  skraecknatt_nn_1_1_N : N ;
  skraecknovell_nn_1_1_N : N ;
  skraeckrubrik_nn_1_1_N : N ;
  skraecksyn_nn_1_1_N : N ;
  skraeckvision_nn_1_1_N : N ;
  skraepprodukt_nn_1_1_N : N ;
  skroeplighet_nn_1_1_N : N ;
  skuggbild_nn_1_N : N ;
  skulderled_nn_1_N : N ;
  skuldfoerbindelse_nn_1_1_N : N ;
  skulpturgrupp_nn_1_N : N ;
  skulpturpark_nn_1_N : N ;
  skulptoer_nn_1_1_N : N ;
  skumhet_nn_2_N : N ;
  skumraskaffaer_nn_1_1_N : N ;
  skunkighet_nn_1_N : N ;
  skurkaktighet_nn_1_N : N ;
  skurkstat_nn_1_N : N ;
  skvallerspalt_nn_1_N : N ;
  skvallertant_nn_1_N : N ;
  skyddsdraekt_nn_1_1_N : N ;
  skyddsfaerg_nn_1_1_N : N ;
  skyddskonsulent_nn_1_N : N ;
  skyddskaar_nn_1_1_N : N ;
  skyddspatron_nn_1_N : N ;
  skyddsstat_nn_1_N : N ;
  skyddsvakt_nn_1_N : N ;
  skyddsaatgaerd_nn_1_1_N : N ;
  skyldighet_nn_1_N : N ;
  skymf_nn_1_N : N ;
  skyttebrigad_nn_1_N : N ;
  skyttegravskant_nn_1_N : N ;
  skyttegrupp_nn_1_N : N ;
  skyttelinje_nn_1_N : N ;
  skyttepaviljong_nn_1_N : N ;
  skyttesalong_nn_1_N : N ;
  skaellko_nn_1_1_N : N ;
  skaemtsamhet_nn_1_1_N : N ;
  skaendlighet_nn_1_1_N : N ;
  skaenk_nn_2_1_N : N ;
  skaergaardsbo_nn_1_1_N : N ;
  skaerhaallfasthet_nn_1_1_N : N ;
  skaermbild_nn_1_1_N : N ;
  skaerningspunkt_nn_1_1_N : N ;
  skaadespelartrupp_nn_1_1_N : N ;
  skoenhet_nn_1_1_N : N ;
  skoenhetsoperation_nn_1_1_N : N ;
  skoenhetssalong_nn_1_1_N : N ;
  skoenhetsupplevelse_nn_1_1_N : N ;
  skoerdeenhet_nn_1_1_N : N ;
  skoerdemaskin_nn_1_1_N : N ;
  skoerdemaanad_nn_1_1_N : N ;
  skoerdetid_nn_1_1_N : N ;
  skoerlevnad_nn_1_1_N : N ;
  skoeterskegrad_nn_1_1_N : N ;
  skoetesynd_nn_1_1_N : N ;
  slaganfallspatient_nn_1_N : N ;
  slagg_nn_1_N : N ;
  slaggmaengd_nn_1_1_N : N ;
  slaglaengd_nn_1_1_N : N ;
  slagseghet_nn_1_N : N ;
  slakteributik_nn_1_N : N ;
  slaktmaanad_nn_1_1_N : N ;
  slarvighet_nn_1_N : N ;
  slaskspalt_nn_1_N : N ;
  slav_nn_2_N : N ;
  slavloen_nn_1_1_N : N ;
  slavstation_nn_1_N : N ;
  slemmighet_nn_2_N : N ;
  slibbighet_nn_1_N : N ;
  slid_nn_1_N : N ;
  slingerkoj_nn_1_N : N ;
  slinkled_nn_1_N : N ;
  slipmaskin_nn_1_N : N ;
  slipprighet_nn_1_N : N ;
  slirighet_nn_2_N : N ;
  slottspark_nn_1_N : N ;
  slottsruin_nn_1_N : N ;
  slovak_nn_1_N : N ;
  sloven_nn_1_N : N ;
  slughet_nn_1_N : N ;
  slutloen_nn_1_1_N : N ;
  slutprodukt_nn_1_N : N ;
  slutpunkt_nn_1_N : N ;
  slutrad_nn_1_N : N ;
  slutskrift_nn_1_N : N ;
  slutspurt_nn_1_N : N ;
  slutstation_nn_1_N : N ;
  slutuppgoerelse_nn_1_1_N : N ;
  slutvinjett_nn_1_N : N ;
  slutvokal_nn_1_N : N ;
  slaektdrift_nn_1_1_N : N ;
  slaektfejd_nn_1_1_N : N ;
  slaektklenod_nn_1_1_N : N ;
  slaektlinje_nn_1_1_N : N ;
  slaendlarv_nn_1_1_N : N ;
  slaent_nn_1_1_N : N ;
  slaepkontakt_nn_1_1_N : N ;
  slaepsko_nn_1_1_N : N ;
  slaett_nn_1_1_N : N ;
  slaettbygd_nn_1_1_N : N ;
  slaettmark_nn_1_1_N : N ;
  slaattermaskin_nn_1_1_N : N ;
  sloehet_nn_1_1_N : N ;
  sloejd_nn_1_1_N : N ;
  sloejdebatt_nn_1_1_N : N ;
  smak_nn_1_N : N ;
  smakfullhet_nn_1_N : N ;
  smaklighet_nn_1_N : N ;
  smakloeshet_nn_1_1_N : N ;
  smakpanel_nn_1_N : N ;
  smaksak_nn_1_N : N ;
  smakupplevelse_nn_1_N : N ;
  smalfilm_nn_1_N : N ;
  smaragd_nn_1_N : N ;
  smarthet_nn_1_N : N ;
  smaskighet_nn_1_N : N ;
  smekmaanad_nn_1_1_N : N ;
  smet_nn_1_N : N ;
  sminkoer_nn_1_1_N : N ;
  smittskyddsmyndighet_nn_1_N : N ;
  smuggelcigarett_nn_1_N : N ;
  smycketyp_nn_1_N : N ;
  smaedebild_nn_1_1_N : N ;
  smaedelse_nn_1_1_N : N ;
  smaedeskrift_nn_1_1_N : N ;
  smaedlighet_nn_1_1_N : N ;
  smaellkaramell_nn_1_1_N : N ;
  smaeltentalpitet_nn_1_1_N : N ;
  smaeltpunkt_nn_1_1_N : N ;
  smaertattack_nn_1_1_N : N ;
  smaertfoernimmelse_nn_1_1_N : N ;
  smaertpunkt_nn_1_1_N : N ;
  smaertupplevelse_nn_1_1_N : N ;
  smaaaktighet_nn_1_1_N : N ;
  smaabarnsaktighet_nn_1_1_N : N ;
  smaabarnsfamilj_nn_1_1_N : N ;
  smaabonde_nn_1_1_N : N ;
  smaaborgerlighet_nn_1_1_N : N ;
  smaadjursklinik_nn_1_1_N : N ;
  smaagrisdoedlighet_nn_1_1_N : N ;
  smaahet_nn_1_1_N : N ;
  smaaplanet_nn_1_1_N : N ;
  smaarolighet_nn_1_1_N : N ;
  smaaraett_nn_1_1_N : N ;
  smaasak_nn_1_1_N : N ;
  smaastad_nn_1_1_N : N ;
  smaastadstjej_nn_1_1_N : N ;
  smaatjej_nn_1_1_N : N ;
  smaattighet_nn_1_1_N : N ;
  smoerbakelse_nn_1_1_N : N ;
  smoerdegspastej_nn_1_1_N : N ;
  smoerjelse_nn_1_1_N : N ;
  snabbguide_nn_1_N : N ;
  snabbhet_nn_1_N : N ;
  snabbkoepsbutik_nn_1_1_N : N ;
  snabbreparation_nn_1_N : N ;
  snabbtaagslinje_nn_1_1_N : N ;
  snabbversion_nn_1_N : N ;
  snabelsko_nn_1_N : N ;
  snackbar_nn_1_N : N ;
  snaskighet_nn_1_N : N ;
  snatterand_nn_1_N : N ;
  snedhet_nn_1_N : N ;
  snedprofil_nn_1_N : N ;
  snickarverkstad_nn_1_N : N ;
  snickerifabrik_nn_1_N : N ;
  snilj_nn_1_N : N ;
  snillrikhet_nn_1_N : N ;
  snittmaengd_nn_1_1_N : N ;
  snurrfaatoelj_nn_1_1_N : N ;
  snurrighet_nn_1_N : N ;
  snuskighet_nn_1_N : N ;
  snyftventil_nn_1_N : N ;
  snaeckart_nn_1_1_N : N ;
  snaellhet_nn_1_1_N : N ;
  snaerjvaevnad_nn_1_1_N : N ;
  snoealg_nn_1_1_N : N ;
  snoeblindhet_nn_1_1_N : N ;
  snoedraekt_nn_1_1_N : N ;
  snoeflingedekoration_nn_1_1_N : N ;
  snoekanon_nn_1_1_N : N ;
  snoeregion_nn_1_1_N : N ;
  snoersko_nn_1_1_N : N ;
  snoerstart_nn_1_1_N : N ;
  snoesko_nn_1_1_N : N ;
  socialassistent_nn_1_N : N ;
  socialavgift_nn_1_N : N ;
  socialbidragskostnad_nn_1_N : N ;
  socialgrupp_nn_1_N : N ;
  socialisation_nn_1_N : N ;
  socialitet_nn_1_N : N ;
  socialliberal_nn_1_N : N ;
  socialloen_nn_1_1_N : N ;
  socialnaemnd_nn_1_1_N : N ;
  socialvetenskap_nn_1_N : N ;
  societet_nn_1_N : N ;
  societetsfotograf_nn_1_N : N ;
  sociolekt_nn_1_N : N ;
  socionom_nn_1_N : N ;
  sociopat_nn_1_N : N ;
  sockendraekt_nn_1_1_N : N ;
  sockerart_nn_1_N : N ;
  sockerbetssaft_nn_1_N : N ;
  sockerglasyr_nn_1_N : N ;
  sockerhalt_nn_1_N : N ;
  sockertaang_nn_1_1_N : N ;
  sodahalt_nn_1_N : N ;
  soffgrupp_nn_1_N : N ;
  softballplan_nn_1_N : N ;
  solanin_nn_1_N : N ;
  solblindhet_nn_1_N : N ;
  solcell_nn_1_N : N ;
  solcellspanel_nn_1_N : N ;
  soldat_nn_1_N : N ;
  soldenaer_nn_1_1_N : N ;
  soldnaer_nn_1_1_N : N ;
  soldraekt_nn_1_1_N : N ;
  solennitet_nn_1_N : N ;
  solfatar_nn_1_N : N ;
  solflod_nn_1_N : N ;
  solfoermoerkelse_nn_1_1_N : N ;
  solidaritet_nn_1_N : N ;
  solidaritetsaatgaerd_nn_1_1_N : N ;
  soliditet_nn_1_N : N ;
  solkatt_nn_1_N : N ;
  solkraem_nn_1_1_N : N ;
  solmisation_nn_1_N : N ;
  solpanel_nn_1_N : N ;
  solroerelse_nn_1_1_N : N ;
  solution_nn_1_N : N ;
  solventil_nn_1_N : N ;
  sommarbostad_nn_1_N : N ;
  sommarfrisyr_nn_1_N : N ;
  sommarkostym_nn_1_N : N ;
  sommarledighet_nn_1_N : N ;
  sommarvistelse_nn_1_N : N ;
  son_nn_1_N : N ;
  sonat_nn_1_N : N ;
  sond_nn_1_N : N ;
  sonett_nn_1_N : N ;
  sonoritet_nn_1_N : N ;
  sonson_nn_1_N : N ;
  sopstation_nn_1_N : N ;
  sorb_nn_1_N : N ;
  sorgdraekt_nn_1_1_N : N ;
  sorgeakt_nn_1_N : N ;
  sorgestund_nn_1_N : N ;
  sorgfaerg_nn_1_1_N : N ;
  sorgkant_nn_1_N : N ;
  sorglighet_nn_1_N : N ;
  sorgloeshet_nn_1_1_N : N ;
  sort_nn_1_N : N ;
  sotbrand_nn_1_N : N ;
  souschef_nn_1_N : N ;
  souterrainbyggnad_nn_1_N : N ;
  souterraengbyggnad_nn_1_1_N : N ;
  souvenir_nn_1_N : N ;
  sovjet_nn_1_N : N ;
  sovjetrepublik_nn_1_N : N ;
  sovstad_nn_1_N : N ;
  sovvagnsbiljett_nn_1_N : N ;
  spalt_nn_1_N : N ;
  spaltfyllnad_nn_1_N : N ;
  spaningspatrull_nn_1_N : N ;
  spanjolett_nn_1_N : N ;
  sparbank_nn_1_N : N ;
  sparform_nn_1_N : N ;
  sparkdraekt_nn_1_1_N : N ;
  spasm_nn_1_N : N ;
  spasticitet_nn_1_N : N ;
  spattighet_nn_1_N : N ;
  speceriaffaer_nn_1_1_N : N ;
  specialitet_nn_1_N : N ;
  specie_nn_1_N : N ;
  specifikation_nn_1_N : N ;
  spedition_nn_1_N : N ;
  speditoer_nn_1_1_N : N ;
  spefullhet_nn_1_N : N ;
  spegelbild_nn_1_N : N ;
  spektralapparat_nn_1_N : N ;
  spektrallinje_nn_1_N : N ;
  spektrograf_nn_1_N : N ;
  spekulation_nn_1_N : N ;
  spelautomat_nn_1_N : N ;
  spelbutik_nn_1_N : N ;
  spelfilm_nn_1_N : N ;
  spelkonsol_nn_1_N : N ;
  spelmark_nn_1_N : N ;
  spelplan_nn_1_N : N ;
  spermabank_nn_1_N : N ;
  spermakvalitet_nn_1_N : N ;
  spermie_nn_1_N : N ;
  spermiemitokondrie_nn_1_N : N ;
  spermiemodercell_nn_1_N : N ;
  spetsfundighet_nn_1_N : N ;
  spetsgardin_nn_1_N : N ;
  spetsighet_nn_2_N : N ;
  spetstaang_nn_1_1_N : N ;
  spiksko_nn_1_N : N ;
  spinalganglie_nn_1_N : N ;
  spindelart_nn_1_N : N ;
  spinell_nn_1_N : N ;
  spinett_nn_1_N : N ;
  spionageanklagelse_nn_1_N : N ;
  spionanklagelse_nn_1_N : N ;
  spiral_nn_1_N : N ;
  spiralroerelse_nn_1_1_N : N ;
  spirellakorsett_nn_1_N : N ;
  spirill_nn_1_N : N ;
  spiritualitet_nn_1_N : N ;
  spiroket_nn_1_N : N ;
  splatterfilm_nn_1_N : N ;
  splitterbomb_nn_1_N : N ;
  spontanitet_nn_1_N : N ;
  sportaffaer_nn_1_1_N : N ;
  sportchef_nn_1_N : N ;
  sportfiskemetod_nn_1_N : N ;
  sportform_nn_1_N : N ;
  sportlegend_nn_1_N : N ;
  sportmodell_nn_1_N : N ;
  sportprestation_nn_1_N : N ;
  sprayburkskonstnaer_nn_1_1_N : N ;
  sprej_nn_1_N : N ;
  spretighet_nn_1_N : N ;
  spridningseffekt_nn_1_N : N ;
  springstilett_nn_1_N : N ;
  springvikarie_nn_1_N : N ;
  spritdryck_nn_1_N : N ;
  sprithalt_nn_1_N : N ;
  spritraettighet_nn_1_1_N : N ;
  spraengaemnespatron_nn_1_1_N : N ;
  spraakbank_nn_1_1_N : N ;
  spraakbarriaer_nn_1_1_N : N ;
  spraakdraekt_nn_1_1_N : N ;
  spraakfamilj_nn_1_1_N : N ;
  spraakfilosof_nn_1_1_N : N ;
  spraakform_nn_1_1_N : N ;
  spraakfaerdighet_nn_1_1_N : N ;
  spraakgrupp_nn_1_1_N : N ;
  spraakkontrollant_nn_1_1_N : N ;
  spraakkunskap_nn_1_1_N : N ;
  spraaklektion_nn_1_1_N : N ;
  spraaklighet_nn_1_1_N : N ;
  spraakriktighet_nn_1_1_N : N ;
  spraakstrid_nn_1_1_N : N ;
  spraakteknik_nn_1_1_N : N ;
  spraakvetenskap_nn_1_1_N : N ;
  spurt_nn_1_N : N ;
  spydighet_nn_1_N : N ;
  spaedbarnsdoedlighet_nn_1_1_N : N ;
  spaennvidd_nn_1_1_N : N ;
  spaerrballong_nn_1_1_N : N ;
  spaerrlinje_nn_1_1_N : N ;
  spaerrvakt_nn_1_1_N : N ;
  spaanad_nn_1_1_N : N ;
  spaarvidd_nn_1_1_N : N ;
  spaarvaegschef_nn_1_1_N : N ;
  spoekbild_nn_1_1_N : N ;
  spoekgestalt_nn_1_1_N : N ;
  spoekstad_nn_1_1_N : N ;
  stab_nn_1_N : N ;
  stabilitet_nn_1_N : N ;
  stabilitetspakt_nn_1_N : N ;
  stabschef_nn_1_N : N ;
  stad_nn_1_N : N ;
  stadfaestelse_nn_1_1_N : N ;
  stadkant_nn_1_N : N ;
  stadsarkitekt_nn_1_N : N ;
  stadsbebyggelse_nn_1_N : N ;
  stadsbild_nn_1_N : N ;
  stadsbo_nn_1_N : N ;
  stadsmission_nn_1_N : N ;
  stadspark_nn_1_N : N ;
  stadssilhuett_nn_1_N : N ;
  stadsstat_nn_1_N : N ;
  stafett_nn_1_N : N ;
  stafylokock_nn_1_N : N ;
  stagflation_nn_1_N : N ;
  stagnation_nn_1_N : N ;
  stamaktie_nn_1_N : N ;
  stamcell_nn_1_N : N ;
  stamkund_nn_1_N : N ;
  stamlinje_nn_1_N : N ;
  stamort_nn_1_N : N ;
  stamton_nn_1_N : N ;
  standard_nn_1_N : N ;
  standardavvikelse_nn_1_N : N ;
  standardspraaklighet_nn_1_1_N : N ;
  stank_nn_1_N : N ;
  stapelstad_nn_1_N : N ;
  starroperation_nn_1_N : N ;
  start_nn_1_N : N ;
  startavgift_nn_1_N : N ;
  startlinje_nn_1_N : N ;
  startpunkt_nn_1_N : N ;
  stat_nn_1_N : N ;
  station_nn_1_N : N ;
  stationsbyggnad_nn_1_N : N ;
  statistik_nn_1_N : N ;
  statministerkandidat_nn_1_N : N ;
  statsangelaegenhet_nn_1_1_N : N ;
  statsapparat_nn_1_N : N ;
  statsbankett_nn_1_N : N ;
  statschef_nn_1_N : N ;
  statshemlighet_nn_1_N : N ;
  statskupp_nn_1_N : N ;
  statsmakt_nn_2_N : N ;
  statsobligation_nn_1_N : N ;
  statsreligion_nn_1_N : N ;
  statsskuld_nn_1_N : N ;
  statsverksproposition_nn_1_N : N ;
  statsvetenskap_nn_1_N : N ;
  statyett_nn_1_N : N ;
  stav_nn_2_N : N ;
  stavelse_nn_1_N : N ;
  stavelseskrift_nn_1_N : N ;
  stavningsreform_nn_1_N : N ;
  stearindoft_nn_1_N : N ;
  steeplechase_nn_1_N : N ;
  stelbenthet_nn_1_N : N ;
  stelhet_nn_1_N : N ;
  stenattack_nn_1_N : N ;
  stencil_nn_1_N : N ;
  stenfrukt_nn_1_N : N ;
  stenograf_nn_1_N : N ;
  stenotop_nn_1_N : N ;
  stereobild_nn_1_N : N ;
  sterilitet_nn_1_N : N ;
  sternalpunktion_nn_1_N : N ;
  stickkontakt_nn_1_N : N ;
  stickmaskin_nn_1_N : N ;
  stickreplik_nn_1_N : N ;
  stiftelse_nn_1_N : N ;
  stiftsadjunkt_nn_1_N : N ;
  stiftsstad_nn_1_N : N ;
  stiftsstyrelse_nn_1_N : N ;
  stifttand_nn_1_N : N ;
  stigarcentral_nn_1_N : N ;
  stigort_nn_1_N : N ;
  stilart_nn_1_N : N ;
  stilett_nn_1_N : N ;
  stilfullhet_nn_1_N : N ;
  stillbild_nn_1_N : N ;
  stillfilm_nn_1_N : N ;
  stillhet_nn_1_N : N ;
  stilloeshet_nn_1_1_N : N ;
  stilsort_nn_1_N : N ;
  stimulansaatgaerd_nn_1_1_N : N ;
  stimuleringsaatgaerd_nn_1_1_N : N ;
  stingslighet_nn_1_N : N ;
  stinkbomb_nn_1_N : N ;
  stipendiat_nn_1_N : N ;
  stipulation_nn_1_N : N ;
  stjaernarkitekt_nn_1_1_N : N ;
  stjaernassociation_nn_1_1_N : N ;
  stjaernbild_nn_1_1_N : N ;
  stjaernkonstellation_nn_1_1_N : N ;
  stjaernmaalvakt_nn_1_1_N : N ;
  stjaerntriplett_nn_1_1_N : N ;
  stjaertand_nn_1_1_N : N ;
  stjaertskulptoer_nn_1_1_N : N ;
  stjaerttrakt_nn_1_1_N : N ;
  stoftmaengd_nn_1_1_N : N ;
  stollighet_nn_1_N : N ;
  stolprad_nn_1_N : N ;
  stolpsko_nn_1_N : N ;
  stolsrad_nn_1_N : N ;
  stolthet_nn_1_N : N ;
  storbonde_nn_1_N : N ;
  storbrand_nn_1_N : N ;
  store_nn_1_N : N ;
  storfamilj_nn_1_N : N ;
  storhet_nn_1_N : N ;
  storhetstid_nn_1_N : N ;
  storkommun_nn_1_N : N ;
  stormakt_nn_1_N : N ;
  stormaktstid_nn_1_N : N ;
  stormarknad_nn_1_N : N ;
  stormflod_nn_1_N : N ;
  stormogul_nn_1_N : N ;
  stormpunkt_nn_1_N : N ;
  storstad_nn_1_N : N ;
  storstadsbo_nn_1_N : N ;
  straffanstalt_nn_1_N : N ;
  straffexpedition_nn_1_N : N ;
  straffpaafoeljd_nn_1_1_N : N ;
  strafftid_nn_1_N : N ;
  stramalj_nn_1_N : N ;
  strand_nn_1_N : N ;
  strandkant_nn_1_N : N ;
  strandlinje_nn_1_N : N ;
  strandpromenad_nn_1_N : N ;
  strandstat_nn_1_N : N ;
  strandtomt_nn_1_N : N ;
  strandtyp_nn_1_N : N ;
  strandoert_nn_1_1_N : N ;
  strangulation_nn_1_N : N ;
  streckkod_nn_1_N : N ;
  strejk_nn_1_N : N ;
  strejkvakt_nn_1_N : N ;
  streptokock_nn_1_N : N ;
  streptomycin_nn_1_N : N ;
  stretchnylon_nn_1_N : N ;
  strid_nn_1_N : N ;
  stridighet_nn_1_N : N ;
  stridsledningscentral_nn_1_N : N ;
  stridsskrift_nn_1_N : N ;
  stridszon_nn_1_N : N ;
  stridsaatgaerd_nn_1_1_N : N ;
  stridulation_nn_1_N : N ;
  striktion_nn_1_N : N ;
  strippshow_nn_1_N : N ;
  strippstaang_nn_1_1_N : N ;
  strof_nn_1_N : N ;
  strukturarbetsloeshet_nn_1_1_N : N ;
  strukturmodell_nn_1_N : N ;
  strulighet_nn_1_N : N ;
  strutsplym_nn_1_N : N ;
  strykarkatt_nn_1_N : N ;
  straakkvartett_nn_1_1_N : N ;
  straalningseffekt_nn_1_1_N : N ;
  straalningsegenskap_nn_1_1_N : N ;
  straalsaekerhetsmyndighet_nn_1_1_N : N ;
  stroekund_nn_1_1_N : N ;
  stuck_nn_1_N : N ;
  stuckatoer_nn_1_1_N : N ;
  student_nn_1_N : N ;
  studentkaar_nn_1_1_N : N ;
  studentnation_nn_1_N : N ;
  studentprenumeration_nn_1_N : N ;
  studentrevolt_nn_1_N : N ;
  studentsaang_nn_1_1_N : N ;
  studie_nn_1_N : N ;
  studiegrupp_nn_1_N : N ;
  studieskuld_nn_1_N : N ;
  studietid_nn_1_N : N ;
  studietradition_nn_1_N : N ;
  studio_nn_1_N : N ;
  stuff_nn_1_N : N ;
  stumfilm_nn_1_N : N ;
  stumhet_nn_1_N : N ;
  stund_nn_1_N : N ;
  stupiditet_nn_1_N : N ;
  stuproersmodell_nn_1_1_N : N ;
  styggelse_nn_1_N : N ;
  stylobat_nn_1_N : N ;
  styrelse_nn_1_N : N ;
  styrelseform_nn_1_N : N ;
  styrelseledamot_nn_1_N : N ;
  styrlastighet_nn_1_N : N ;
  styrstaang_nn_1_1_N : N ;
  styvhet_nn_1_N : N ;
  styvmorsviol_nn_1_N : N ;
  styvnad_nn_1_N : N ;
  styvson_nn_1_N : N ;
  staedambition_nn_1_1_N : N ;
  staemningsbild_nn_1_1_N : N ;
  staempelavgift_nn_1_1_N : N ;
  staeppantilop_nn_1_1_N : N ;
  staalkonstruktion_nn_1_1_N : N ;
  staandort_nn_1_1_N : N ;
  staandpunkt_nn_1_1_N : N ;
  staandraett_nn_1_1_N : N ;
  staandscirkulation_nn_1_1_N : N ;
  staandsperson_nn_1_1_N : N ;
  staang_nn_1_1_N : N ;
  stoedgrupp_nn_1_1_N : N ;
  stoedjecell_nn_1_1_N : N ;
  stoedjepunkt_nn_1_1_N : N ;
  stoedjevaevnad_nn_1_1_N : N ;
  stoedaatgaerd_nn_1_1_N : N ;
  stoekighet_nn_1_1_N : N ;
  stoeldraed_nn_1_1_N : N ;
  stoeratom_nn_1_1_N : N ;
  stoertflod_nn_1_1_N : N ;
  subaltern_nn_1_N : N ;
  subjektivitet_nn_1_N : N ;
  subjunktion_nn_1_N : N ;
  subkontinent_nn_1_N : N ;
  sublimation_nn_1_N : N ;
  subordination_nn_1_N : N ;
  subrett_nn_1_N : N ;
  subskribent_nn_1_N : N ;
  substitution_nn_1_N : N ;
  subtilitet_nn_1_N : N ;
  subtraktion_nn_1_N : N ;
  subvention_nn_1_N : N ;
  succession_nn_1_N : N ;
  suddighet_nn_1_N : N ;
  sufflett_nn_1_N : N ;
  suffloer_nn_1_1_N : N ;
  suffragett_nn_1_N : N ;
  suggestion_nn_1_N : N ;
  sujett_nn_1_N : N ;
  sulfatfabrik_nn_1_N : N ;
  sulfitfabrik_nn_1_N : N ;
  summerton_nn_1_N : N ;
  sumpgasbrand_nn_1_N : N ;
  sumpmark_nn_1_N : N ;
  sundae_nn_1_N : N ;
  sunkighet_nn_1_N : N ;
  superintendent_nn_1_N : N ;
  supermakt_nn_1_N : N ;
  supermodell_nn_1_N : N ;
  supernovaexplosion_nn_1_N : N ;
  superposition_nn_1_N : N ;
  supplik_nn_1_N : N ;
  supposition_nn_1_N : N ;
  supradental_nn_1_N : N ;
  surhet_nn_1_N : N ;
  surhetsgrad_nn_1_N : N ;
  suspension_nn_1_N : N ;
  sutenoer_nn_1_1_N : N ;
  suterraengbyggnad_nn_1_1_N : N ;
  suvenir_nn_1_N : N ;
  suveraenitet_nn_1_1_N : N ;
  svaghet_nn_1_N : N ;
  svamlighet_nn_1_N : N ;
  svarskupong_nn_1_N : N ;
  svartalf_nn_1_N : N ;
  svartnad_nn_1_N : N ;
  svartsynthet_nn_1_N : N ;
  svavelbakterie_nn_1_N : N ;
  svavelhalt_nn_1_N : N ;
  svavelsyrlighet_nn_1_N : N ;
  sved_nn_1_N : N ;
  svekfullhet_nn_1_N : N ;
  svenskbygd_nn_1_N : N ;
  svenskhet_nn_1_N : N ;
  svensklektion_nn_1_N : N ;
  svetsstaang_nn_1_1_N : N ;
  svinaktighet_nn_1_N : N ;
  svit_nn_1_N : N ;
  svullnad_nn_1_N : N ;
  svulstighet_nn_1_N : N ;
  svaeltkonstnaer_nn_1_1_N : N ;
  svaeltloen_nn_1_1_N : N ;
  svaermorsrabatt_nn_1_1_N : N ;
  svaerson_nn_1_1_N : N ;
  svaarbegriplighet_nn_1_1_N : N ;
  svaarfattlighet_nn_1_1_N : N ;
  svaarfoerklarlighet_nn_1_1_N : N ;
  svaarfoerstaaelighet_nn_1_1_N : N ;
  svaarighet_nn_1_1_N : N ;
  swimmingpool_nn_1_N : N ;
  sydfrukt_nn_1_N : N ;
  sydpol_nn_1_N : N ;
  sydstat_nn_1_N : N ;
  syfoereningstant_nn_1_1_N : N ;
  sylf_nn_1_N : N ;
  sylvesterbal_nn_1_N : N ;
  symaskin_nn_1_N : N ;
  symmetrilinje_nn_1_N : N ;
  sympatisoer_nn_1_1_N : N ;
  synapsbassaeng_nn_1_1_N : N ;
  synbild_nn_1_N : N ;
  syncell_nn_1_N : N ;
  synd_nn_1_N : N ;
  syndabekaennelse_nn_1_1_N : N ;
  syndaflod_nn_1_N : N ;
  syndfrihet_nn_1_N : N ;
  synfoernimmelse_nn_1_1_N : N ;
  synkop_nn_1_N : N ;
  synlighet_nn_1_N : N ;
  synnerv_nn_1_N : N ;
  synod_nn_1_N : N ;
  synonymmaengd_nn_1_1_N : N ;
  synpunkt_nn_1_N : N ;
  syo_nn_1_N : N ;
  syokonsulent_nn_1_N : N ;
  syracistern_nn_1_N : N ;
  syreatom_nn_1_N : N ;
  syreisotop_nn_1_N : N ;
  syren_nn_1_N : N ;
  syrgastub_nn_1_N : N ;
  syrlighet_nn_2_N : N ;
  syrtut_nn_1_N : N ;
  syskongrupp_nn_1_N : N ;
  sysselsaettningsgrad_nn_1_1_N : N ;
  systerson_nn_1_N : N ;
  saedescell_nn_1_1_N : N ;
  saekerhet_nn_1_1_N : N ;
  saekerhetsaspekt_nn_1_1_N : N ;
  saekerhetsbestaemmelse_nn_1_1_N : N ;
  saekerhetschef_nn_1_1_N : N ;
  saekerhetsfoereskrift_nn_1_1_N : N ;
  saekerhetstjaenst_nn_1_1_N : N ;
  saekerhetsvakt_nn_1_1_N : N ;
  saekerhetsventil_nn_1_1_N : N ;
  saekerhetsaatgaerd_nn_1_1_N : N ;
  saellhet_nn_1_1_N : N ;
  saellsamhet_nn_1_1_N : N ;
  saellskapsdam_nn_1_1_N : N ;
  saellsynthet_nn_1_1_N : N ;
  saendningsraettighet_nn_1_1_N : N ;
  saengkamrat_nn_1_1_N : N ;
  saengkant_nn_1_1_N : N ;
  saenkningsreaktion_nn_1_1_N : N ;
  saerbo_nn_1_1_N : N ;
  saeregenhet_nn_1_1_N : N ;
  saesong_nn_1_1_N : N ;
  saesongsupptakt_nn_1_1_N : N ;
  saettmaskin_nn_1_1_N : N ;
  saamaskin_nn_1_1_N : N ;
  saangteknik_nn_1_1_N : N ;
  saarbarhet_nn_1_1_N : N ;
  saarighet_nn_1_1_N : N ;
  saarinfektion_nn_1_1_N : N ;
  saarmarkoer_nn_1_1_N : N ;
  saarnad_nn_1_1_N : N ;
  soekaktivitet_nn_1_1_N : N ;
  soemnad_nn_1_1_N : N ;
  soemnsvaarighet_nn_1_1_N : N ;
  soemntablett_nn_1_1_N : N ;
  soemsmaan_nn_1_1_N : N ;
  soendagsbokstav_nn_1_1_N : N ;
  soetsak_nn_1_1_N : N ;
  tabell_nn_1_N : N ;
  taburett_nn_1_N : N ;
  tacksamhet_nn_1_N : N ;
  tacksaegelse_nn_1_1_N : N ;
  tafflighet_nn_1_N : N ;
  takbrand_nn_1_N : N ;
  takhoejd_nn_1_1_N : N ;
  taklaekt_nn_1_1_N : N ;
  taksektion_nn_1_N : N ;
  taksilhuett_nn_1_N : N ;
  taktart_nn_1_N : N ;
  taktloeshet_nn_1_1_N : N ;
  talakt_nn_1_N : N ;
  talang_nn_1_N : N ;
  talangjakt_nn_1_N : N ;
  talangscout_nn_1_N : N ;
  talapparat_nn_1_N : N ;
  talar_nn_1_N : N ;
  talent_nn_1_N : N ;
  talfoeljd_nn_1_1_N : N ;
  talklinik_nn_1_N : N ;
  talkshow_nn_1_N : N ;
  talkoer_nn_1_1_N : N ;
  tallinje_nn_1_N : N ;
  tallriksventil_nn_1_N : N ;
  tallsort_nn_1_N : N ;
  talloert_nn_1_1_N : N ;
  talong_nn_1_N : N ;
  talpedagog_nn_1_N : N ;
  talregistreringsapparat_nn_1_N : N ;
  talroll_nn_1_N : N ;
  talscen_nn_1_N : N ;
  talshow_nn_1_N : N ;
  talsituation_nn_1_N : N ;
  talspraaklighet_nn_1_1_N : N ;
  talsvaarighet_nn_1_1_N : N ;
  tamarind_nn_1_N : N ;
  tampong_nn_1_N : N ;
  tamul_nn_1_N : N ;
  tand_nn_1_N : N ;
  tandborrmaskin_nn_1_N : N ;
  tandboeld_nn_1_1_N : N ;
  tandemmaskin_nn_1_N : N ;
  tandemspermie_nn_1_N : N ;
  tandkonstruktion_nn_1_N : N ;
  tandkraem_nn_1_1_N : N ;
  tandlaekarpraktik_nn_1_1_N : N ;
  tandlaekartid_nn_1_1_N : N ;
  tandloeshet_nn_2_1_N : N ;
  tandrad_nn_1_N : N ;
  tangent_nn_1_N : N ;
  tangeringspunkt_nn_1_N : N ;
  tangorabatt_nn_1_N : N ;
  tankebyggnad_nn_1_N : N ;
  tankedikt_nn_1_N : N ;
  tankeform_nn_1_N : N ;
  tankefrihet_nn_1_N : N ;
  tankekraft_nn_1_N : N ;
  tankemetod_nn_1_N : N ;
  tanketomhet_nn_1_N : N ;
  tanketradition_nn_1_N : N ;
  tankkapacitet_nn_1_N : N ;
  tankloeshet_nn_1_1_N : N ;
  tankomat_nn_1_N : N ;
  tant_nn_1_N : N ;
  tapet_nn_1_N : N ;
  tapetbaard_nn_1_1_N : N ;
  tapetvaad_nn_1_1_N : N ;
  tapisseriaffaer_nn_1_1_N : N ;
  tapperhet_nn_1_N : N ;
  tapperhetsmedalj_nn_1_N : N ;
  tappstation_nn_1_N : N ;
  tariff_nn_1_N : N ;
  tarmbakterie_nn_1_N : N ;
  tarmkanal_nn_1_N : N ;
  tarmroerelse_nn_1_1_N : N ;
  tarmsaft_nn_1_N : N ;
  tartelett_nn_1_N : N ;
  tartrat_nn_1_N : N ;
  tarvlighet_nn_1_N : N ;
  taskighet_nn_1_N : N ;
  tassemark_nn_1_N : N ;
  taxeringsassistent_nn_1_N : N ;
  taxeringsenhet_nn_1_N : N ;
  taxeringsintendent_nn_1_N : N ;
  taxeringslaengd_nn_1_1_N : N ;
  taxeringsmyndighet_nn_1_N : N ;
  taxeringsnaemnd_nn_1_1_N : N ;
  taxikund_nn_1_N : N ;
  taxistation_nn_1_N : N ;
  tazett_nn_1_N : N ;
  teamwork_nn_1_N : N ;
  teaterbiljett_nn_1_N : N ;
  teaterchef_nn_1_N : N ;
  teaterdebatt_nn_1_N : N ;
  teaterdekoration_nn_1_N : N ;
  teatereffekt_nn_1_N : N ;
  teatergrupp_nn_1_N : N ;
  teaterloge_nn_1_N : N ;
  teaterroll_nn_1_N : N ;
  teaterscen_nn_1_N : N ;
  tegelbyggnad_nn_1_N : N ;
  tegelsilhuett_nn_1_N : N ;
  tein_nn_1_N : N ;
  teknikalitet_nn_1_N : N ;
  teknokrat_nn_1_N : N ;
  teleavgift_nn_1_N : N ;
  telefonabonnent_nn_1_N : N ;
  telefonapparat_nn_1_N : N ;
  telefonautomat_nn_1_N : N ;
  telefonhytt_nn_1_N : N ;
  telefonkatalog_nn_1_N : N ;
  telefonkontakt_nn_1_N : N ;
  telefonoperatoer_nn_1_1_N : N ;
  telefonstation_nn_1_N : N ;
  telefonvakt_nn_1_N : N ;
  telefonoer_nn_1_1_N : N ;
  telefoerbindelse_nn_1_1_N : N ;
  telegrafstation_nn_1_N : N ;
  telekommunikation_nn_1_N : N ;
  teleskopfunktion_nn_1_N : N ;
  telestation_nn_1_N : N ;
  temperaturskillnad_nn_1_N : N ;
  tennisplan_nn_1_N : N ;
  tennissko_nn_1_N : N ;
  tennsoldat_nn_1_N : N ;
  tension_nn_1_N : N ;
  tentamensnervositet_nn_1_N : N ;
  tentand_nn_1_N : N ;
  teobromin_nn_1_N : N ;
  teofyllin_nn_1_N : N ;
  teosof_nn_1_N : N ;
  terapeut_nn_1_N : N ;
  terapisession_nn_1_N : N ;
  terebint_nn_1_N : N ;
  term_nn_1_N : N ;
  termin_nn_1_N : N ;
  terminsaffaer_nn_1_1_N : N ;
  terminsavgift_nn_1_N : N ;
  termoelektricitet_nn_1_N : N ;
  termostat_nn_1_N : N ;
  tern_nn_1_N : N ;
  terpen_nn_1_N : N ;
  terrorattack_nn_1_N : N ;
  terroristattack_nn_1_N : N ;
  terraeng_nn_1_1_N : N ;
  tersett_nn_1_N : N ;
  terzett_nn_1_N : N ;
  testbild_nn_1_N : N ;
  testpilot_nn_1_N : N ;
  tetrark_nn_1_N : N ;
  teveantenn_nn_1_N : N ;
  teveapparat_nn_1_N : N ;
  tevebild_nn_1_N : N ;
  tevechef_nn_1_N : N ;
  tevekanal_nn_1_N : N ;
  tevenyhet_nn_1_N : N ;
  tevereparatoer_nn_1_1_N : N ;
  teveserie_nn_1_N : N ;
  tevestudio_nn_1_N : N ;
  text_nn_1_N : N ;
  textilfabrik_nn_1_N : N ;
  textilkonstnaer_nn_1_1_N : N ;
  textrad_nn_1_N : N ;
  thrillerfilm_nn_1_N : N ;
  thyroxin_nn_1_N : N ;
  tid_nn_1_N : N ;
  tidegaerd_nn_1_1_N : N ;
  tidjordskraft_nn_1_N : N ;
  tidloen_nn_1_1_N : N ;
  tidloeshet_nn_1_1_N : N ;
  tidningskant_nn_1_N : N ;
  tidningsredaktion_nn_1_N : N ;
  tidningsspalt_nn_1_N : N ;
  tidningstext_nn_1_N : N ;
  tidningsuppgift_nn_1_N : N ;
  tidpunkt_nn_1_N : N ;
  tidrymd_nn_1_N : N ;
  tidsangivelse_nn_1_N : N ;
  tidsaspekt_nn_1_N : N ;
  tidsbild_nn_1_N : N ;
  tidsekvation_nn_1_N : N ;
  tidsenhet_nn_1_N : N ;
  tidsepok_nn_1_N : N ;
  tidsfoeljd_nn_1_1_N : N ;
  tidskrift_nn_1_N : N ;
  tidskriftsillustration_nn_1_N : N ;
  tidsmarginal_nn_1_N : N ;
  tidsmaskin_nn_1_N : N ;
  tidsmaessighet_nn_1_1_N : N ;
  tidsperiod_nn_1_N : N ;
  tidsrymd_nn_1_N : N ;
  tidsskillnad_nn_1_N : N ;
  tidszon_nn_1_N : N ;
  tidtabell_nn_1_N : N ;
  tidvattenhoejd_nn_1_1_N : N ;
  tidvattenkraft_nn_1_N : N ;
  tigerbalsam_nn_1_N : N ;
  tigerkatt_nn_1_N : N ;
  tillbyggnad_nn_1_N : N ;
  tilldragelse_nn_1_N : N ;
  tillfart_nn_1_N : N ;
  tillflyktsort_nn_1_N : N ;
  tillfaellighet_nn_1_1_N : N ;
  tillfaellighetsdikt_nn_1_1_N : N ;
  tillfoerlitlighet_nn_1_1_N : N ;
  tillgivenhet_nn_1_N : N ;
  tillgjordhet_nn_1_N : N ;
  tillhoerighet_nn_1_1_N : N ;
  tillslagningsteknik_nn_1_N : N ;
  tillstymmelse_nn_1_N : N ;
  tillsynsmyndighet_nn_1_N : N ;
  tillsaegelse_nn_1_1_N : N ;
  tilltalsform_nn_1_N : N ;
  tillverkningskostnad_nn_1_N : N ;
  tillverkningsserie_nn_1_N : N ;
  tillvitelse_nn_1_N : N ;
  tillvaexthastighet_nn_1_1_N : N ;
  tillvaextmodell_nn_1_1_N : N ;
  tillvaextperiod_nn_1_1_N : N ;
  tillaeggskostnad_nn_1_1_N : N ;
  tillaeggspension_nn_1_1_N : N ;
  tillaempningsfoereskrift_nn_1_1_N : N ;
  timlighet_nn_1_N : N ;
  timloen_nn_1_1_N : N ;
  tingsraett_nn_1_1_N : N ;
  tinninglob_nn_1_N : N ;
  tiokamp_nn_1_N : N ;
  tipskupong_nn_1_N : N ;
  tipspromenad_nn_1_N : N ;
  tipsrad_nn_1_N : N ;
  tistelstaang_nn_1_1_N : N ;
  titeldikt_nn_1_N : N ;
  titelnovell_nn_1_N : N ;
  titelroll_nn_1_N : N ;
  titthaalsoperation_nn_1_1_N : N ;
  tjeckoslovak_nn_1_N : N ;
  tjej_nn_1_N : N ;
  tjejslakt_nn_1_N : N ;
  tjockskallighet_nn_1_N : N ;
  tjocktarmstumoer_nn_1_1_N : N ;
  tjurskallighet_nn_1_N : N ;
  tjuvnad_nn_1_N : N ;
  tjuvstart_nn_1_N : N ;
  tjyvstart_nn_1_N : N ;
  tjaenstebostad_nn_1_1_N : N ;
  tjaenstebrevsraett_nn_1_1_N : N ;
  tjaenstefoerseelse_nn_1_1_N : N ;
  tjaenstefoersaendelse_nn_1_1_N : N ;
  tjaenstegrad_nn_1_1_N : N ;
  tjaenstemannaorganisation_nn_1_1_N : N ;
  tjaenstepension_nn_1_1_N : N ;
  tjaenstetid_nn_1_1_N : N ;
  tjaenstledighet_nn_1_1_N : N ;
  tobaksaffaer_nn_1_1_N : N ;
  tobaksbutik_nn_1_N : N ;
  tobaksimportoer_nn_1_1_N : N ;
  toft_nn_1_N : N ;
  tokighet_nn_1_N : N ;
  tokrolighet_nn_1_N : N ;
  tolft_nn_1_N : N ;
  tolkningsmetod_nn_1_N : N ;
  tolkningsmoejlighet_nn_1_1_N : N ;
  tom_nn_1_N : N ;
  tomat_nn_1_N : N ;
  tombutelj_nn_1_N : N ;
  tomhet_nn_1_N : N ;
  tomkartong_nn_1_N : N ;
  tomt_nn_1_N : N ;
  tomtedraekt_nn_1_1_N : N ;
  tomteverkstad_nn_1_N : N ;
  tomtmark_nn_1_N : N ;
  tomtraettsavgaeld_nn_1_1_N : N ;
  tonalitet_nn_1_N : N ;
  tonart_nn_1_N : N ;
  tonett_nn_1_N : N ;
  tonfoeljd_nn_1_1_N : N ;
  tonhoejd_nn_1_1_N : N ;
  tonsill_nn_1_N : N ;
  tonaarsidentitet_nn_1_1_N : N ;
  tonaarsperiod_nn_1_1_N : N ;
  topograf_nn_1_N : N ;
  toppkraft_nn_1_N : N ;
  toppmodell_nn_1_N : N ;
  topposition_nn_1_N : N ;
  toque_nn_1_N : N ;
  torftighet_nn_1_N : N ;
  torgmarknad_nn_1_N : N ;
  torkperiod_nn_1_N : N ;
  torped_nn_1_N : N ;
  torpedattack_nn_1_N : N ;
  torpedtub_nn_1_N : N ;
  torpruin_nn_1_N : N ;
  torrdestillation_nn_1_N : N ;
  torrklosett_nn_1_N : N ;
  torrolighet_nn_1_N : N ;
  torrperiod_nn_1_N : N ;
  torrtid_nn_1_N : N ;
  torsion_nn_1_N : N ;
  tortyranklagelse_nn_1_N : N ;
  torvbrikett_nn_1_N : N ;
  torvbrikettfabrik_nn_1_N : N ;
  torvmullsklosett_nn_1_N : N ;
  torvtaekt_nn_1_1_N : N ;
  tosighet_nn_1_N : N ;
  tossighet_nn_1_N : N ;
  totalbild_nn_1_N : N ;
  totalfoermoerkelse_nn_1_1_N : N ;
  totalitet_nn_1_N : N ;
  totalreflexion_nn_1_N : N ;
  totalvikt_nn_1_N : N ;
  touche_nn_1_N : N ;
  toxicitet_nn_1_N : N ;
  tradition_nn_1_N : N ;
  traffickinganklagelse_nn_1_N : N ;
  trafikled_nn_1_N : N ;
  trafikpilot_nn_1_N : N ;
  trafiksituation_nn_1_N : N ;
  trafiksaekerhet_nn_1_1_N : N ;
  trafiksaekerhetschef_nn_1_1_N : N ;
  trafikvakt_nn_1_N : N ;
  tragedienn_nn_1_N : N ;
  tragoed_nn_1_1_N : N ;
  traktat_nn_1_N : N ;
  traktoer_nn_1_1_N : N ;
  trakyt_nn_1_N : N ;
  tramproerelse_nn_1_1_N : N ;
  trampoert_nn_1_1_N : N ;
  tramsighet_nn_1_N : N ;
  tranbaerssaft_nn_1_1_N : N ;
  trankilitet_nn_1_N : N ;
  transaktion_nn_1_N : N ;
  transfiguration_nn_1_N : N ;
  transformation_nn_1_N : N ;
  transformationsgrammatik_nn_1_N : N ;
  transformatorbrand_nn_1_N : N ;
  transformatorstation_nn_1_N : N ;
  transfusion_nn_1_N : N ;
  transgression_nn_1_N : N ;
  transkription_nn_1_N : N ;
  translitteration_nn_1_N : N ;
  transmission_nn_1_N : N ;
  transmutation_nn_1_N : N ;
  transparang_nn_1_N : N ;
  transperson_nn_1_N : N ;
  transpiration_nn_1_N : N ;
  transplantation_nn_1_N : N ;
  transportsaekerhet_nn_1_1_N : N ;
  transportoer_nn_1_1_N : N ;
  transposition_nn_1_N : N ;
  transsubstantiation_nn_1_N : N ;
  transubstantiation_nn_1_N : N ;
  transuran_nn_1_N : N ;
  trapets_nn_2_N : N ;
  trapetskonstnaer_nn_1_1_N : N ;
  trappfunktion_nn_1_N : N ;
  trassat_nn_1_N : N ;
  trassent_nn_1_N : N ;
  trasslighet_nn_1_N : N ;
  tredjegradsekvation_nn_1_N : N ;
  tredjeopponent_nn_1_N : N ;
  treenighet_nn_1_N : N ;
  trefald_nn_1_N : N ;
  trefaldighet_nn_1_N : N ;
  trekant_nn_1_N : N ;
  trekantsprofil_nn_1_N : N ;
  treklang_nn_1_N : N ;
  trelaekarstation_nn_1_1_N : N ;
  tremaanadersperiod_nn_1_1_N : N ;
  trend_nn_1_N : N ;
  trendighet_nn_1_N : N ;
  trepanation_nn_1_N : N ;
  trerumslaegenhet_nn_1_1_N : N ;
  trestegsraket_nn_1_N : N ;
  trettiodagarsperiod_nn_1_N : N ;
  trevlighet_nn_1_N : N ;
  trevnad_nn_1_N : N ;
  triad_nn_1_N : N ;
  triangelpunkt_nn_1_N : N ;
  tribad_nn_1_N : N ;
  tribun_nn_1_N : N ;
  tribunal_nn_1_N : N ;
  tribut_nn_1_N : N ;
  trickfilm_nn_1_N : N ;
  triennal_nn_1_N : N ;
  triftong_nn_1_N : N ;
  triglyf_nn_1_N : N ;
  trillingnerv_nn_1_N : N ;
  trimningsfunktion_nn_1_N : N ;
  triod_nn_1_N : N ;
  trioxipurin_nn_1_N : N ;
  tripod_nn_1_N : N ;
  trippelpunkt_nn_1_N : N ;
  triptyk_nn_1_N : N ;
  trisslott_nn_1_N : N ;
  triumf_nn_1_N : N ;
  triumvir_nn_1_N : N ;
  trivialitet_nn_1_N : N ;
  trivsamhet_nn_1_N : N ;
  trivselvikt_nn_1_N : N ;
  trixighet_nn_1_N : N ;
  trofasthet_nn_1_N : N ;
  trogenhet_nn_1_N : N ;
  troglodyt_nn_1_N : N ;
  trohet_nn_1_N : N ;
  trohetsed_nn_1_N : N ;
  trohjaertenhet_nn_1_1_N : N ;
  trolldryck_nn_1_N : N ;
  trollerikonstnaer_nn_1_1_N : N ;
  trollkonstnaer_nn_1_1_N : N ;
  trollsaang_nn_1_1_N : N ;
  troloeshet_nn_1_1_N : N ;
  tromb_nn_1_N : N ;
  trombocyt_nn_1_N : N ;
  tronavsaegelse_nn_1_1_N : N ;
  tronfoeljd_nn_1_1_N : N ;
  tronpretendent_nn_1_N : N ;
  trop_nn_1_N : N ;
  tropik_nn_1_N : N ;
  troposfaer_nn_1_1_N : N ;
  trosbekaennelse_nn_1_1_N : N ;
  trosfrihet_nn_1_N : N ;
  trosfraende_nn_1_1_N : N ;
  trosgemenskap_nn_1_N : N ;
  trosroerelse_nn_1_1_N : N ;
  trottoar_nn_1_N : N ;
  trottoarbonde_nn_1_N : N ;
  trottoarkant_nn_1_N : N ;
  trudelutt_nn_1_N : N ;
  trumpetkonsert_nn_1_N : N ;
  trunkmaskin_nn_1_N : N ;
  trupp_nn_1_N : N ;
  trupproerelse_nn_1_1_N : N ;
  tryckaccent_nn_1_N : N ;
  tryckbokstav_nn_1_N : N ;
  tryckdraekt_nn_1_1_N : N ;
  tryckfrihet_nn_1_N : N ;
  tryckfaerg_nn_1_1_N : N ;
  tryckkontakt_nn_1_N : N ;
  tryckluftsapparat_nn_1_N : N ;
  tryckmetod_nn_1_N : N ;
  tryckort_nn_1_N : N ;
  tryckpunkt_nn_1_N : N ;
  trycksak_nn_1_N : N ;
  trycktyp_nn_1_N : N ;
  trygghet_nn_1_N : N ;
  trypsin_nn_1_N : N ;
  traecell_nn_1_1_N : N ;
  traedbank_nn_1_1_N : N ;
  traedestillation_nn_1_1_N : N ;
  traedgaardsarkitekt_nn_1_1_N : N ;
  traedgaardsprydnad_nn_1_1_N : N ;
  traedgaardsaert_nn_1_1_N : N ;
  traeffbild_nn_1_1_N : N ;
  traeffpunkt_nn_1_1_N : N ;
  traeffsaekerhet_nn_1_1_N : N ;
  traegravyr_nn_1_1_N : N ;
  traekonstruktion_nn_1_1_N : N ;
  traengselavgift_nn_1_1_N : N ;
  traengtrupp_nn_1_1_N : N ;
  traeningsdraekt_nn_1_1_N : N ;
  traeprodukt_nn_1_1_N : N ;
  traesko_nn_1_1_N : N ;
  traesnittsillustration_nn_1_1_N : N ;
  traakighet_nn_1_1_N : N ;
  traanad_nn_1_1_N : N ;
  troeghet_nn_2_1_N : N ;
  troejfabrik_nn_1_1_N : N ;
  troeskeleffekt_nn_1_1_N : N ;
  troestegrund_nn_1_1_N : N ;
  troesteskrift_nn_1_1_N : N ;
  tsar_nn_1_N : N ;
  tsarfamilj_nn_1_N : N ;
  tub_nn_1_N : N ;
  tuberkelbakterie_nn_1_N : N ;
  tuberkulin_nn_1_N : N ;
  tubkanon_nn_1_N : N ;
  tulkoert_nn_1_1_N : N ;
  tullavgift_nn_1_N : N ;
  tulldeklaration_nn_1_N : N ;
  tullnaer_nn_1_1_N : N ;
  tullstation_nn_1_N : N ;
  tullunion_nn_1_N : N ;
  tullvisitation_nn_1_N : N ;
  tumsbredd_nn_1_N : N ;
  tumoer_nn_1_1_N : N ;
  tungmetall_nn_1_N : N ;
  tungsinthet_nn_1_N : N ;
  tungoert_nn_1_1_N : N ;
  tunik_nn_1_N : N ;
  tunnelbanefaerd_nn_1_1_N : N ;
  tunnelbanestation_nn_1_N : N ;
  tunneleffekt_nn_1_N : N ;
  turistinformation_nn_1_N : N ;
  turiststation_nn_1_N : N ;
  turkcypriot_nn_1_N : N ;
  turnyr_nn_1_N : N ;
  turochreturbiljett_nn_1_N : N ;
  tusenkonstnaer_nn_1_1_N : N ;
  tussilago_nn_1_N : N ;
  tv_kanal_nn_1_N : N ;
  tv_leverantoer_nn_1_1_N : N ;
  tv_nyhet_nn_1_N : N ;
  tv_reparatoer_nn_1_1_N : N ;
  tv_serie_nn_1_N : N ;
  tv_studio_nn_1_N : N ;
  tvekamp_nn_1_N : N ;
  tveksamhet_nn_1_N : N ;
  tvetydighet_nn_1_N : N ;
  tvillingmaskin_nn_1_N : N ;
  tvistighet_nn_1_N : N ;
  tvaerbrant_nn_1_1_N : N ;
  tvaerfloejt_nn_1_1_N : N ;
  tvaerlinje_nn_1_1_N : N ;
  tvaervetenskap_nn_1_1_N : N ;
  tvaettautomat_nn_1_1_N : N ;
  tvaettbar_nn_1_1_N : N ;
  tvaettmaskin_nn_1_1_N : N ;
  tvaettomat_nn_1_1_N : N ;
  tvaangsmaessighet_nn_1_1_N : N ;
  tvaangssituation_nn_1_1_N : N ;
  tvaangsaatgaerd_nn_1_1_N : N ;
  tvaarumslaegenhet_nn_1_1_N : N ;
  tvaasamhet_nn_1_1_N : N ;
  tvaastavighetsaccent_nn_1_1_N : N ;
  tvaatakt_nn_1_1_N : N ;
  tydlighet_nn_2_N : N ;
  tyfoidbakterie_nn_1_N : N ;
  tygbanderoll_nn_1_N : N ;
  tygbredd_nn_1_N : N ;
  tygkant_nn_1_N : N ;
  tygsko_nn_1_N : N ;
  tykenhet_nn_1_N : N ;
  tyngdacceleration_nn_1_N : N ;
  tyngdloeshet_nn_1_1_N : N ;
  tyngdpunkt_nn_1_N : N ;
  typ_nn_1_N : N ;
  tysklektion_nn_1_N : N ;
  tysthet_nn_1_N : N ;
  tystnad_nn_1_N : N ;
  taeckfaerg_nn_1_1_N : N ;
  taeckningsgrad_nn_1_1_N : N ;
  taeckorganisation_nn_1_1_N : N ;
  taekt_nn_1_1_N : N ;
  taendpatron_nn_1_1_N : N ;
  taendsticksfabrik_nn_1_1_N : N ;
  taenkarpose_nn_1_1_N : N ;
  taenkbarhet_nn_1_1_N : N ;
  taenkvaerdhet_nn_1_1_N : N ;
  taet_nn_1_1_N : N ;
  taethetsvariation_nn_1_1_N : N ;
  taetort_nn_1_1_N : N ;
  taetortsbo_nn_1_1_N : N ;
  taevlingsinstinkt_nn_1_1_N : N ;
  taevlingskamp_nn_1_1_N : N ;
  taagbiljett_nn_1_1_N : N ;
  taaglinje_nn_1_1_N : N ;
  taaglaegenhet_nn_1_1_N : N ;
  taagtid_nn_1_1_N : N ;
  taagtidtabell_nn_1_1_N : N ;
  taagtur_nn_1_1_N : N ;
  taang_nn_1_1_N : N ;
  taargaspatron_nn_1_1_N : N ;
  taarkanal_nn_1_1_N : N ;
  teete_a_teete_nn_1_1_N : N ;
  toejbarhet_nn_1_1_N : N ;
  toentighet_nn_1_1_N : N ;
  ubikvitet_nn_1_N : N ;
  ubaatsjakt_nn_1_1_N : N ;
  uddatalsmetod_nn_1_N : N ;
  ugnsomelett_nn_1_N : N ;
  ukulele_nn_1_N : N ;
  ulloert_nn_1_1_N : N ;
  ultimoaffaer_nn_1_1_N : N ;
  ultraljudsbild_nn_1_N : N ;
  ultrarapidfilm_nn_1_N : N ;
  umbaerlighet_nn_1_1_N : N ;
  umgaengelse_nn_1_1_N : N ;
  umgaengesform_nn_1_1_N : N ;
  umgaengesnorm_nn_1_1_N : N ;
  uncial_nn_1_N : N ;
  undanflykt_nn_1_N : N ;
  undantagsbestaemmelse_nn_1_1_N : N ;
  undantagsraett_nn_1_1_N : N ;
  underart_nn_1_N : N ;
  underbyggnad_nn_1_N : N ;
  underdrift_nn_1_N : N ;
  underdaanighet_nn_1_1_N : N ;
  underemission_nn_1_N : N ;
  underfamilj_nn_1_N : N ;
  underfart_nn_1_N : N ;
  underfundighet_nn_1_N : N ;
  undergardin_nn_1_N : N ;
  undergrund_nn_1_N : N ;
  underhandskontakt_nn_1_N : N ;
  underhaallskostnad_nn_1_1_N : N ;
  underhaallstrupp_nn_1_1_N : N ;
  underkant_nn_1_N : N ;
  underleverantoer_nn_1_1_N : N ;
  underlighet_nn_1_N : N ;
  underljudsfart_nn_1_N : N ;
  underljudshastighet_nn_1_N : N ;
  underlaegsenhet_nn_1_1_N : N ;
  underlaatelse_nn_1_1_N : N ;
  underlaatenhet_nn_1_1_N : N ;
  underlaatenhetssynd_nn_1_1_N : N ;
  underloejtnant_nn_1_1_N : N ;
  undermaalighet_nn_1_1_N : N ;
  underpant_nn_1_N : N ;
  underrubrik_nn_1_N : N ;
  underraett_nn_1_1_N : N ;
  underraettelse_nn_1_1_N : N ;
  underraettelseverksamhet_nn_1_1_N : N ;
  underskrift_nn_1_N : N ;
  understoedsnaemnd_nn_1_1_N : N ;
  undersoekningsmetod_nn_1_1_N : N ;
  underterm_nn_1_N : N ;
  underton_nn_1_N : N ;
  undervattensfoerbindelse_nn_1_1_N : N ;
  undervegetation_nn_1_N : N ;
  undervisningsanstalt_nn_1_N : N ;
  undervisningsskicklighet_nn_1_N : N ;
  undervisningsskyldighet_nn_1_N : N ;
  undfallenhet_nn_1_N : N ;
  undflykt_nn_1_N : N ;
  undfaegnad_nn_1_1_N : N ;
  undsaettningsfond_nn_1_1_N : N ;
  undulat_nn_1_N : N ;
  undulation_nn_1_N : N ;
  ungdomsanstalt_nn_1_N : N ;
  ungdomsarbetsloeshet_nn_1_1_N : N ;
  ungdomsbrottslighet_nn_1_N : N ;
  ungdomsfilm_nn_1_N : N ;
  ungdomsgrupp_nn_1_N : N ;
  ungdomskonsulent_nn_1_N : N ;
  ungdomskriminalitet_nn_1_N : N ;
  ungdomsorganisation_nn_1_N : N ;
  ungdomspraktikant_nn_1_N : N ;
  ungdomsroerelse_nn_1_1_N : N ;
  ungdomssynd_nn_1_N : N ;
  ungdomstid_nn_1_N : N ;
  ungdomsverksamhet_nn_1_N : N ;
  uniform_nn_1_N : N ;
  uniformitet_nn_1_N : N ;
  union_nn_1_N : N ;
  unitarie_nn_1_N : N ;
  universalitet_nn_1_N : N ;
  universitetsadjunkt_nn_1_N : N ;
  universitetsfilial_nn_1_N : N ;
  universitetsinstitution_nn_1_N : N ;
  universitetsstad_nn_1_N : N ;
  uppbyggnad_nn_1_N : N ;
  uppboerd_nn_1_1_N : N ;
  uppboerdslaengd_nn_1_1_N : N ;
  uppboerdstermin_nn_1_1_N : N ;
  uppdragsskribent_nn_1_N : N ;
  uppehaallsort_nn_1_1_N : N ;
  uppenbarelse_nn_1_N : N ;
  uppenbarelsereligion_nn_1_N : N ;
  uppfart_nn_1_N : N ;
  uppfartsramp_nn_1_N : N ;
  uppfostringsanstalt_nn_1_N : N ;
  uppgift_nn_1_N : N ;
  uppgivenhet_nn_1_N : N ;
  uppgaeld_nn_1_1_N : N ;
  uppgoerelse_nn_1_1_N : N ;
  upphoejdhet_nn_1_1_N : N ;
  upphoejelse_nn_1_1_N : N ;
  uppkaeftighet_nn_1_1_N : N ;
  uppkoerningsramp_nn_1_1_N : N ;
  upplagscell_nn_1_N : N ;
  upplevelse_nn_1_N : N ;
  upplaatelse_nn_1_1_N : N ;
  uppmaerksamhet_nn_1_1_N : N ;
  uppriktighet_nn_1_N : N ;
  upprinnelse_nn_1_N : N ;
  uppraettelse_nn_1_1_N : N ;
  uppskalningsmoejlighet_nn_1_1_N : N ;
  uppslagsform_nn_1_N : N ;
  uppstad_nn_1_N : N ;
  uppstickarbank_nn_1_N : N ;
  uppsyn_nn_1_N : N ;
  uppsaegelse_nn_1_1_N : N ;
  uppsaegningstermin_nn_1_1_N : N ;
  uppsaegningstid_nn_1_1_N : N ;
  upptagenhet_nn_1_N : N ;
  upptakt_nn_1_N : N ;
  upptuktelse_nn_1_N : N ;
  upptaeckt_nn_1_1_N : N ;
  upptaecktsfaerd_nn_1_1_N : N ;
  uppvaeckelse_nn_1_1_N : N ;
  ur_ur_kroppen_upplevelse_nn_1_N : N ;
  uraktlaatenhet_nn_1_1_N : N ;
  urbanitet_nn_1_N : N ;
  urbergsterraeng_nn_1_1_N : N ;
  urbild_nn_1_N : N ;
  urcell_nn_1_N : N ;
  urdjurscell_nn_1_N : N ;
  urdaalighet_nn_1_1_N : N ;
  urexplosion_nn_1_N : N ;
  urform_nn_1_N : N ;
  urformation_nn_1_N : N ;
  uridom_nn_1_N : N ;
  urinoar_nn_1_N : N ;
  urinstinkt_nn_1_N : N ;
  urinvaegsinfektion_nn_1_1_N : N ;
  urkund_nn_1_N : N ;
  urminneshaevd_nn_1_1_N : N ;
  urogenitalapparat_nn_1_N : N ;
  ursame_nn_1_N : N ;
  ursprungsart_nn_1_N : N ;
  ursprungscell_nn_1_N : N ;
  ursprungsdokumentation_nn_1_N : N ;
  ursprungsort_nn_1_N : N ;
  ursaekt_nn_1_1_N : N ;
  urtyp_nn_1_N : N ;
  uschlighet_nn_1_N : N ;
  uselhet_nn_1_N : N ;
  uslighet_nn_1_N : N ;
  usurpation_nn_1_N : N ;
  utanfoerskapsmarkoer_nn_1_1_N : N ;
  utanpaaskrift_nn_1_1_N : N ;
  utanskrift_nn_1_N : N ;
  utbildningsexplosion_nn_1_N : N ;
  utbildningslinje_nn_1_N : N ;
  utbildningstid_nn_1_N : N ;
  utbo_nn_1_N : N ;
  utbrytarregion_nn_1_N : N ;
  utbrytarrepublik_nn_1_N : N ;
  utbrytarstat_nn_1_N : N ;
  utbyggnad_nn_1_N : N ;
  utbytbarhet_nn_1_N : N ;
  utfallsrymd_nn_1_N : N ;
  utfart_nn_1_N : N ;
  utflykt_nn_1_N : N ;
  utflyttningslaengd_nn_1_1_N : N ;
  utflaekartrend_nn_1_1_N : N ;
  utfodringsjournal_nn_1_N : N ;
  utfodringsstat_nn_1_N : N ;
  utfyllnad_nn_1_N : N ;
  utfaerd_nn_1_1_N : N ;
  utfaestelse_nn_1_1_N : N ;
  utgift_nn_1_N : N ;
  utgiftsverifikation_nn_1_N : N ;
  utgjutelse_nn_1_N : N ;
  utgaangshastighet_nn_1_1_N : N ;
  utgaangsposition_nn_1_1_N : N ;
  utgaangspunkt_nn_1_1_N : N ;
  utgaangsrad_nn_1_1_N : N ;
  uthaallighet_nn_1_1_N : N ;
  utkant_nn_1_N : N ;
  utkikspunkt_nn_1_N : N ;
  utkorelse_nn_1_N : N ;
  utlandskorrespondent_nn_1_N : N ;
  utlaatelse_nn_1_1_N : N ;
  utmark_nn_1_N : N ;
  utmattningsdepression_nn_1_N : N ;
  utmaerkelse_nn_1_1_N : N ;
  utomhusbar_nn_1_N : N ;
  utomhuskonsert_nn_1_N : N ;
  utomhusvistelse_nn_1_N : N ;
  utpressningssituation_nn_1_N : N ;
  utrikesdebatt_nn_1_N : N ;
  utrikesdeklaration_nn_1_N : N ;
  utrikeskorrespondent_nn_1_N : N ;
  utrymmesstandard_nn_1_N : N ;
  utsikt_nn_1_N : N ;
  utsiktspunkt_nn_1_N : N ;
  utskottsmajoritet_nn_1_N : N ;
  utskrift_nn_1_N : N ;
  utskyld_nn_1_N : N ;
  utslaeppsnation_nn_1_1_N : N ;
  utslaeppsraett_nn_1_1_N : N ;
  utstaellelse_nn_1_1_N : N ;
  utsoekthet_nn_1_1_N : N ;
  uttrycksform_nn_1_N : N ;
  utvecklingsgrad_nn_1_N : N ;
  utvecklingslinje_nn_1_N : N ;
  utvecklingsmoejlighet_nn_1_1_N : N ;
  utvecklingsserie_nn_1_N : N ;
  utvikningsbild_nn_1_N : N ;
  utvinnelsegrad_nn_1_N : N ;
  utvaerderingsenhet_nn_1_1_N : N ;
  uvertyr_nn_1_N : N ;
  vaccination_nn_1_N : N ;
  vaccinatoer_nn_1_1_N : N ;
  vacuumtoalett_nn_1_N : N ;
  vagabond_nn_1_N : N ;
  vaggsaang_nn_1_1_N : N ;
  vagnpark_nn_1_N : N ;
  vakansvikarie_nn_1_N : N ;
  vaknatt_nn_1_N : N ;
  vaksination_nn_1_N : N ;
  vaksinatoer_nn_1_1_N : N ;
  vakt_nn_1_N : N ;
  vaktparad_nn_1_N : N ;
  vaktuniform_nn_1_N : N ;
  vakuumtoalett_nn_1_N : N ;
  valack_nn_1_N : N ;
  valapparat_nn_1_N : N ;
  valdebatt_nn_1_N : N ;
  valfrihet_nn_1_N : N ;
  valfraendskap_nn_1_1_N : N ;
  valgranskningsskommission_nn_1_N : N ;
  valhemlighet_nn_1_N : N ;
  valhaenthet_nn_1_1_N : N ;
  validitet_nn_1_N : N ;
  valkarstaang_nn_1_1_N : N ;
  valkommission_nn_1_N : N ;
  vallbonde_nn_1_N : N ;
  vallfart_nn_1_N : N ;
  vallfartsort_nn_1_N : N ;
  vallfaerd_nn_1_1_N : N ;
  vallmo_nn_1_N : N ;
  vallningstabell_nn_1_N : N ;
  vallokal_nn_1_N : N ;
  vallaengd_nn_1_1_N : N ;
  valmanskaar_nn_1_1_N : N ;
  valmoejlighet_nn_1_1_N : N ;
  valobservatoer_nn_1_1_N : N ;
  valorisation_nn_1_N : N ;
  valparoll_nn_1_N : N ;
  valroerelse_nn_1_1_N : N ;
  valsituation_nn_1_N : N ;
  valspurt_nn_1_N : N ;
  valstakt_nn_1_N : N ;
  valstugeaffaer_nn_1_1_N : N ;
  valsaang_nn_1_1_N : N ;
  valsoer_nn_1_1_N : N ;
  valupptakt_nn_1_N : N ;
  valutaaffaer_nn_1_1_N : N ;
  valutafond_nn_1_N : N ;
  valutaklausul_nn_1_N : N ;
  valutareserv_nn_1_N : N ;
  valutaunion_nn_1_N : N ;
  valoer_nn_1_1_N : N ;
  vampyr_nn_1_N : N ;
  vanart_nn_1_N : N ;
  vandrarcell_nn_1_N : N ;
  vandringscell_nn_1_N : N ;
  vandringsled_nn_1_N : N ;
  vandringspokal_nn_1_N : N ;
  vanesak_nn_1_N : N ;
  vanfoerhet_nn_1_1_N : N ;
  vanillin_nn_1_N : N ;
  vankant_nn_1_N : N ;
  vanlighet_nn_1_N : N ;
  vanprydnad_nn_1_N : N ;
  vansinnighet_nn_1_N : N ;
  vanskapnad_nn_1_N : N ;
  vanskapthet_nn_1_N : N ;
  vansklighet_nn_1_N : N ;
  vanvettighet_nn_1_N : N ;
  vanvoerdnad_nn_1_1_N : N ;
  vapenarsenal_nn_1_N : N ;
  vapenfabrik_nn_1_N : N ;
  vapensmed_nn_1_N : N ;
  vapentyp_nn_1_N : N ;
  vapoer_nn_1_1_N : N ;
  varaktighet_nn_1_N : N ;
  varboeld_nn_1_1_N : N ;
  vardaglighet_nn_1_N : N ;
  vardagsangelaegenhet_nn_1_1_N : N ;
  vardagsraett_nn_1_1_N : N ;
  vardagsupplevelse_nn_1_N : N ;
  varelse_nn_1_N : N ;
  variabilitet_nn_1_N : N ;
  variation_nn_1_N : N ;
  variationsbredd_nn_1_N : N ;
  varietet_nn_1_N : N ;
  varjag_nn_1_N : N ;
  varmfront_nn_1_N : N ;
  varmraett_nn_1_1_N : N ;
  varudeklaration_nn_1_N : N ;
  varumaengd_nn_1_1_N : N ;
  vasall_nn_1_N : N ;
  vasallstat_nn_1_N : N ;
  vattenbyggnad_nn_1_N : N ;
  vattenfaerg_nn_1_1_N : N ;
  vattenhalt_nn_1_N : N ;
  vattenhyacint_nn_1_N : N ;
  vattenkanon_nn_1_N : N ;
  vattenklosett_nn_1_N : N ;
  vattenled_nn_1_N : N ;
  vattenlinje_nn_1_N : N ;
  vattenloeslighet_nn_1_1_N : N ;
  vattennymf_nn_1_N : N ;
  vattenpostventil_nn_1_N : N ;
  vattentaekt_nn_1_1_N : N ;
  vaudeville_nn_1_N : N ;
  veckobiljett_nn_1_N : N ;
  veckohelg_nn_1_N : N ;
  veckotablett_nn_1_N : N ;
  veckotidningsnovell_nn_1_N : N ;
  vedbrand_nn_1_N : N ;
  vederkvickelse_nn_1_N : N ;
  vederpart_nn_1_N : N ;
  vederstygglighet_nn_1_N : N ;
  vedervaerdighet_nn_1_1_N : N ;
  vegetation_nn_1_N : N ;
  vegetationsperiod_nn_1_N : N ;
  vegetationszon_nn_1_N : N ;
  veklighet_nn_1_N : N ;
  velighet_nn_1_N : N ;
  velociped_nn_1_N : N ;
  velodrom_nn_1_N : N ;
  ven_nn_1_N : N ;
  veneration_nn_1_N : N ;
  ventilation_nn_1_N : N ;
  ventilbasun_nn_1_N : N ;
  verbalinspiration_nn_1_N : N ;
  verbalitet_nn_1_N : N ;
  verbalnot_nn_1_N : N ;
  verbform_nn_1_N : N ;
  verbaendelse_nn_1_1_N : N ;
  verifikation_nn_1_N : N ;
  verklighet_nn_1_N : N ;
  verklighetsbakgrund_nn_1_N : N ;
  verklighetsbild_nn_1_N : N ;
  verklighetschock_nn_1_N : N ;
  verkningsgrad_nn_1_N : N ;
  verksamhet_nn_1_N : N ;
  verksamhetsberaettelse_nn_1_1_N : N ;
  verkshoejd_nn_1_1_N : N ;
  verkstad_nn_1_N : N ;
  verkstaellighet_nn_1_1_N : N ;
  verksynd_nn_1_N : N ;
  verktygsmaskin_nn_1_N : N ;
  vernissage_nn_1_N : N ;
  versal_nn_1_N : N ;
  versberaettelse_nn_1_1_N : N ;
  versifikation_nn_1_N : N ;
  versifikatoer_nn_1_1_N : N ;
  version_nn_1_N : N ;
  versrad_nn_1_N : N ;
  vertebrat_nn_1_N : N ;
  vertikal_nn_1_N : N ;
  vertikalprojektion_nn_1_N : N ;
  vestal_nn_1_N : N ;
  vestibul_nn_1_N : N ;
  vetebroedslaengd_nn_1_1_N : N ;
  vetelaengd_nn_1_1_N : N ;
  vetenskap_nn_1_N : N ;
  veterinaer_nn_1_1_N : N ;
  vetesort_nn_1_N : N ;
  vettighet_nn_1_N : N ;
  vettloeshet_nn_1_1_N : N ;
  vettvillighet_nn_1_N : N ;
  vevstaang_nn_1_1_N : N ;
  viadukt_nn_1_N : N ;
  vial_nn_1_N : N ;
  vibration_nn_1_N : N ;
  viceamiral_nn_1_N : N ;
  vicekorpral_nn_1_N : N ;
  vicepresident_nn_1_N : N ;
  vicepresidentkandidat_nn_1_N : N ;
  vidd_nn_1_N : N ;
  video_nn_1_N : N ;
  videoaffaer_nn_1_1_N : N ;
  videobutik_nn_1_N : N ;
  videofilm_nn_1_N : N ;
  videregion_nn_1_N : N ;
  vidfilm_nn_1_N : N ;
  vidimation_nn_1_N : N ;
  vidlyftighet_nn_1_N : N ;
  vidrighet_nn_1_N : N ;
  vidskepelse_nn_1_N : N ;
  vidskeplighet_nn_1_N : N ;
  vidsynthet_nn_1_N : N ;
  vidunderlighet_nn_1_N : N ;
  vielle_nn_1_N : N ;
  vigselakt_nn_1_N : N ;
  vikarie_nn_1_N : N ;
  viktenhet_nn_1_N : N ;
  viktighet_nn_1_N : N ;
  viktnedgaangsaatgaerd_nn_1_1_N : N ;
  viktskillnad_nn_1_N : N ;
  vildand_nn_1_N : N ;
  vildkatt_nn_1_N : N ;
  vildmark_nn_1_N : N ;
  vildmarksbrand_nn_1_N : N ;
  vildnad_nn_1_N : N ;
  vildrensjakt_nn_1_N : N ;
  vilfaatoelj_nn_1_1_N : N ;
  viljeakt_nn_1_N : N ;
  villabrand_nn_1_N : N ;
  villanell_nn_1_N : N ;
  villatomt_nn_1_N : N ;
  villfarelse_nn_1_N : N ;
  villkorskonjunktion_nn_1_N : N ;
  vilopunkt_nn_1_N : N ;
  vimperg_nn_1_N : N ;
  vinbaerssaft_nn_1_1_N : N ;
  vindhastighet_nn_1_N : N ;
  vindikation_nn_1_N : N ;
  vindsbrand_nn_1_N : N ;
  vingbredd_nn_1_N : N ;
  vingfrukt_nn_1_N : N ;
  vinjett_nn_1_N : N ;
  vinkelacceleration_nn_1_N : N ;
  vinkelhastighet_nn_1_N : N ;
  vinkelskillnad_nn_1_N : N ;
  vinnarinstinkt_nn_1_N : N ;
  vinningslystnad_nn_1_N : N ;
  vinorganisation_nn_1_N : N ;
  vinraettighet_nn_1_1_N : N ;
  vinsort_nn_1_N : N ;
  vinstlott_nn_1_N : N ;
  vinstmarginal_nn_1_N : N ;
  vinstmaskin_nn_1_N : N ;
  vinterbostad_nn_1_N : N ;
  vinterdraekt_nn_1_1_N : N ;
  vinterfrukt_nn_1_N : N ;
  vinteridrott_nn_1_N : N ;
  vinterleksak_nn_1_N : N ;
  vintermaanad_nn_1_1_N : N ;
  vinternatt_nn_1_N : N ;
  vintersport_nn_1_N : N ;
  vintertroetthet_nn_1_1_N : N ;
  viol_nn_1_N : N ;
  violinklav_nn_1_N : N ;
  violoncell_nn_1_N : N ;
  virilitet_nn_1_N : N ;
  virkeskvalitet_nn_1_N : N ;
  virrighet_nn_1_N : N ;
  virtuositet_nn_1_N : N ;
  virusinfektion_nn_1_N : N ;
  virvelroerelse_nn_1_1_N : N ;
  viscount_nn_1_N : N ;
  visdomstand_nn_1_N : N ;
  visent_nn_1_N : N ;
  vishet_nn_1_N : N ;
  vision_nn_1_N : N ;
  visionaer_nn_1_1_N : N ;
  visitation_nn_1_N : N ;
  viskositet_nn_1_N : N ;
  visshet_nn_1_N : N ;
  vistelse_nn_1_N : N ;
  vistelseort_nn_1_N : N ;
  vitalf_nn_1_N : N ;
  vitalfoernimmelse_nn_1_1_N : N ;
  vitalitet_nn_1_N : N ;
  vitalkapacitet_nn_1_N : N ;
  vitalv_nn_1_N : N ;
  vitamin_nn_1_N : N ;
  vitamininjektion_nn_1_N : N ;
  vithet_nn_1_N : N ;
  vitmetall_nn_1_N : N ;
  vitnad_nn_1_N : N ;
  vitsighet_nn_1_N : N ;
  vitterhet_nn_1_N : N ;
  vittnesed_nn_1_N : N ;
  vittneskonfrontation_nn_1_N : N ;
  vittnesuppgift_nn_1_N : N ;
  vivacitet_nn_1_N : N ;
  vivisektion_nn_1_N : N ;
  vivisektoer_nn_1_1_N : N ;
  vivoer_nn_1_1_N : N ;
  voidkoefficient_nn_1_N : N ;
  vokabulaer_nn_1_1_N : N ;
  vokal_nn_1_N : N ;
  vokalisation_nn_1_N : N ;
  vokalkvalitet_nn_1_N : N ;
  vokalkvantitet_nn_1_N : N ;
  vokallaengd_nn_1_1_N : N ;
  volauvent_nn_1_N : N ;
  voljaer_nn_1_1_N : N ;
  volontaer_nn_1_1_N : N ;
  voltige_nn_1_N : N ;
  voltigoer_nn_1_1_N : N ;
  volut_nn_1_N : N ;
  volym_nn_1_N : N ;
  volymenhet_nn_1_N : N ;
  volymsenhet_nn_1_N : N ;
  voyeur_nn_1_N : N ;
  vresighet_nn_1_N : N ;
  vridled_nn_1_N : N ;
  vridscen_nn_1_N : N ;
  vraekighet_nn_1_1_N : N ;
  vraangbild_nn_1_1_N : N ;
  vraanghet_nn_1_1_N : N ;
  vulgaritet_nn_1_N : N ;
  vulkapparat_nn_1_N : N ;
  vaederobservation_nn_1_1_N : N ;
  vaegbomb_nn_1_1_N : N ;
  vaegegenskap_nn_1_1_N : N ;
  vaeggbonad_nn_1_1_N : N ;
  vaegkant_nn_1_1_N : N ;
  vaegmaskin_nn_1_1_N : N ;
  vaekt_nn_1_1_N : N ;
  vaeldighet_nn_1_1_N : N ;
  vaelfaegnad_nn_1_1_N : N ;
  vaelfaerdsstat_nn_1_1_N : N ;
  vaelgoerenhet_nn_1_1_N : N ;
  vaelgoerenhetsbasar_nn_1_1_N : N ;
  vaelgoerenhetsorganisation_nn_1_1_N : N ;
  vaeljarkaar_nn_1_1_N : N ;
  vaellevnad_nn_1_1_N : N ;
  vaeltalighet_nn_1_1_N : N ;
  vaelvillighet_nn_1_1_N : N ;
  vaemjelighet_nn_1_1_N : N ;
  vaendpunkt_nn_1_1_N : N ;
  vaenlighet_nn_1_1_N : N ;
  vaenort_nn_1_1_N : N ;
  vaenskaplighet_nn_1_1_N : N ;
  vaensterhand_nn_1_1_N : N ;
  vaensterkoalition_nn_1_1_N : N ;
  vaenstermyt_nn_1_1_N : N ;
  vaensteropposition_nn_1_1_N : N ;
  vaensterradikal_nn_1_1_N : N ;
  vaenstersympatisoer_nn_1_1_N : N ;
  vaensteraasikt_nn_1_1_N : N ;
  vaentetid_nn_1_1_N : N ;
  vaerdefullhet_nn_1_1_N : N ;
  vaerdegrund_nn_1_1_N : N ;
  vaerdemaengd_nn_1_1_N : N ;
  vaerdepappersfond_nn_1_1_N : N ;
  vaerdepappersmarknad_nn_1_1_N : N ;
  vaerderingsnorm_nn_1_1_N : N ;
  vaerdesak_nn_1_1_N : N ;
  vaerdetabell_nn_1_1_N : N ;
  vaerdfamilj_nn_1_1_N : N ;
  vaerdighet_nn_1_1_N : N ;
  vaerjemaalsed_nn_1_1_N : N ;
  vaerktablett_nn_1_1_N : N ;
  vaerldsberoemdhet_nn_1_1_N : N ;
  vaerldsbild_nn_1_1_N : N ;
  vaerldsbrand_nn_1_1_N : N ;
  vaerldscup_nn_1_1_N : N ;
  vaerldsdam_nn_1_1_N : N ;
  vaerldslighet_nn_1_1_N : N ;
  vaerldsmakt_nn_1_1_N : N ;
  vaerldsmarknad_nn_1_1_N : N ;
  vaerldsorganisation_nn_1_1_N : N ;
  vaerldsreligion_nn_1_1_N : N ;
  vaerldsrevolution_nn_1_1_N : N ;
  vaerldsrymd_nn_1_1_N : N ;
  vaerldsstad_nn_1_1_N : N ;
  vaerldstid_nn_1_1_N : N ;
  vaerldsaasikt_nn_1_1_N : N ;
  vaermeapparat_nn_1_1_N : N ;
  vaermebild_nn_1_1_N : N ;
  vaermecentral_nn_1_1_N : N ;
  vaermeenhet_nn_1_1_N : N ;
  vaermeexpansion_nn_1_1_N : N ;
  vaermegrad_nn_1_1_N : N ;
  vaermekapacitet_nn_1_1_N : N ;
  vaermekapacitivitet_nn_1_1_N : N ;
  vaermekonduktivitet_nn_1_1_N : N ;
  vaermekostnad_nn_1_1_N : N ;
  vaermemaengd_nn_1_1_N : N ;
  vaermningsfunktion_nn_1_1_N : N ;
  vaernpliktsmyndighet_nn_1_1_N : N ;
  vaesentlighet_nn_1_1_N : N ;
  vaestfront_nn_1_1_N : N ;
  vaestgot_nn_1_1_N : N ;
  vaestkustsallad_nn_1_1_N : N ;
  vaestmakt_nn_1_1_N : N ;
  vaeteatom_nn_1_1_N : N ;
  vaetebomb_nn_1_1_N : N ;
  vaetejonkoncentration_nn_1_1_N : N ;
  vaetekarbonat_nn_1_1_N : N ;
  vaevnad_nn_1_1_N : N ;
  vaevtyngd_nn_1_1_N : N ;
  vaexelaffaer_nn_1_1_N : N ;
  vaexeldiskont_nn_1_1_N : N ;
  vaexelgaeldenaer_nn_1_1_N : N ;
  vaexelsaang_nn_1_1_N : N ;
  vaexeltrassat_nn_1_1_N : N ;
  vaexeltrassent_nn_1_1_N : N ;
  vaextart_nn_1_1_N : N ;
  vaextcell_nn_1_1_N : N ;
  vaextfamilj_nn_1_1_N : N ;
  vaextfaerg_nn_1_1_N : N ;
  vaextfoeljd_nn_1_1_N : N ;
  vaextlighet_nn_1_1_N : N ;
  vaextlokal_nn_1_1_N : N ;
  vaextmargarin_nn_1_1_N : N ;
  vaextperiod_nn_1_1_N : N ;
  vaextsaft_nn_1_1_N : N ;
  vaextvaevnad_nn_1_1_N : N ;
  vaagform_nn_1_1_N : N ;
  vaagfront_nn_1_1_N : N ;
  vaaghalsighet_nn_1_1_N : N ;
  vaaghoejd_nn_1_1_N : N ;
  vaaglaengd_nn_1_1_N : N ;
  vaagmaestarroll_nn_1_1_N : N ;
  vaaldsamhet_nn_1_1_N : N ;
  vaaldsmentalitet_nn_1_1_N : N ;
  vaaldspiral_nn_1_1_N : N ;
  vaaldsscen_nn_1_1_N : N ;
  vaaldtaekt_nn_1_1_N : N ;
  vaalnad_nn_1_1_N : N ;
  vaardanstalt_nn_1_1_N : N ;
  vaardcentral_nn_1_1_N : N ;
  vaardepression_nn_1_1_N : N ;
  vaardklinik_nn_1_1_N : N ;
  vaardnad_nn_1_1_N : N ;
  vaardsloeshet_nn_1_1_N : N ;
  vaarmaanad_nn_1_1_N : N ;
  vaartermin_nn_1_1_N : N ;
  vaartroetthet_nn_1_1_N : N ;
  vaarvial_nn_1_1_N : N ;
  vaatmark_nn_1_1_N : N ;
  vaatservett_nn_1_1_N : N ;
  voerdnad_nn_1_1_N : N ;
  wattsekund_nn_1_N : N ;
  webanonymitet_nn_1_N : N ;
  westernfilm_nn_1_N : N ;
  whiskysort_nn_1_N : N ;
  yacht_nn_1_N : N ;
  yllevaevnad_nn_1_1_N : N ;
  yngelcell_nn_1_N : N ;
  ypperlighet_nn_1_N : N ;
  yrkesetik_nn_1_N : N ;
  yrkesgrupp_nn_1_N : N ;
  yrkeshemlighet_nn_1_N : N ;
  yrkesinspektion_nn_1_N : N ;
  yrkeskaar_nn_1_1_N : N ;
  ytbergart_nn_1_N : N ;
  yteffekt_nn_1_N : N ;
  ytenhet_nn_1_N : N ;
  ytform_nn_1_N : N ;
  ytlighet_nn_1_N : N ;
  ytmoraen_nn_1_1_N : N ;
  ytterkant_nn_1_N : N ;
  ytterlighet_nn_1_N : N ;
  yttermarginal_nn_1_N : N ;
  yttrandefrihet_nn_1_N : N ;
  ytvidd_nn_1_N : N ;
  yvighet_nn_2_N : N ;
  zefyr_nn_1_N : N ;
  zeppelinarpilot_nn_1_N : N ;
  zinkmalm_nn_1_N : N ;
  zontariff_nn_1_N : N ;
  zygot_nn_1_N : N ;
  aecklighet_nn_1_1_N : N ;
  aedelmetall_nn_1_1_N : N ;
  aedelsmed_nn_1_1_N : N ;
  aegarform_nn_1_1_N : N ;
  aeggcell_nn_1_1_N : N ;
  aeggklaeckningsmaskin_nn_1_1_N : N ;
  aeggstocksinflammation_nn_1_1_N : N ;
  aegiljett_nn_1_1_N : N ;
  aegrett_nn_1_1_N : N ;
  aektenskapskandidat_nn_1_1_N : N ;
  aektenskapsmarknad_nn_1_1_N : N ;
  aektenskapsskillnad_nn_1_1_N : N ;
  aekthet_nn_1_1_N : N ;
  aelgjakt_nn_1_1_N : N ;
  aelsklighet_nn_1_1_N : N ;
  aelsklingsraett_nn_1_1_N : N ;
  aelskvaerdhet_nn_1_1_N : N ;
  aelvstrand_nn_1_1_N : N ;
  aembetsdraekt_nn_1_1_N : N ;
  aembetsed_nn_1_1_N : N ;
  aembetsperiod_nn_1_1_N : N ;
  aembetsplikt_nn_1_1_N : N ;
  aemnesgrupp_nn_1_1_N : N ;
  aemnesintegration_nn_1_1_N : N ;
  aemneskombination_nn_1_1_N : N ;
  aemnessfaer_nn_1_1_N : N ;
  aendamaalsenlighet_nn_1_1_N : N ;
  aendmoraen_nn_1_1_N : N ;
  aendpunkt_nn_1_1_N : N ;
  aendstation_nn_1_1_N : N ;
  aengd_nn_1_1_N : N ;
  aenglakoer_nn_1_1_N : N ;
  aengsmark_nn_1_1_N : N ;
  aengsvial_nn_1_1_N : N ;
  aenkenaad_nn_1_1_N : N ;
  aenkepension_nn_1_1_N : N ;
  aentringsstrid_nn_1_1_N : N ;
  aeppelpaj_nn_1_1_N : N ;
  aerelystnad_nn_1_1_N : N ;
  aereroerighet_nn_1_1_N : N ;
  aeresak_nn_1_1_N : N ;
  aerftlighet_nn_1_1_N : N ;
  aerkerival_nn_1_1_N : N ;
  aerlighet_nn_1_1_N : N ;
  aerrvaevnad_nn_1_1_N : N ;
  aert_nn_1_1_N : N ;
  aetlighet_nn_1_1_N : N ;
  aetstoerningsproblematik_nn_1_1_N : N ;
  aettlaengd_nn_1_1_N : N ;
  aeventyrlighet_nn_1_1_N : N ;
  aeventyrsfilm_nn_1_1_N : N ;
  aakattraktion_nn_1_1_N : N ;
  aakermark_nn_1_1_N : N ;
  aakeraert_nn_1_1_N : N ;
  aaklagarmyndighet_nn_1_1_N : N ;
  aaktur_nn_1_1_N : N ;
  aalderdomlighet_nn_1_1_N : N ;
  aalderdomspension_nn_1_1_N : N ;
  aalderdomssvaghet_nn_1_1_N : N ;
  aaldersgrupp_nn_1_1_N : N ;
  aalderslaangsynthet_nn_1_1_N : N ;
  aalderspension_nn_1_1_N : N ;
  aalderspensionaer_nn_1_1_N : N ;
  aalderspresident_nn_1_1_N : N ;
  aaldersskillnad_nn_1_1_N : N ;
  aangcentral_nn_1_1_N : N ;
  aangestattack_nn_1_1_N : N ;
  aangmaskin_nn_1_1_N : N ;
  aaretruntbostad_nn_1_1_N : N ;
  aarsavgift_nn_1_1_N : N ;
  aarsbokstav_nn_1_1_N : N ;
  aarsmodell_nn_1_1_N : N ;
  aarstid_nn_1_1_N : N ;
  aasikt_nn_1_1_N : N ;
  aasiktsfrihet_nn_1_1_N : N ;
  aasiktsskillnad_nn_1_1_N : N ;
  aaskfront_nn_1_1_N : N ;
  aaskaadlighet_nn_1_1_N : N ;
  aasstaang_nn_1_1_N : N ;
  aatalsimmunitet_nn_1_1_N : N ;
  aatalspunkt_nn_1_1_N : N ;
  aatboerd_nn_1_1_N : N ;
  aaterbetalningsskyldighet_nn_1_1_N : N ;
  aaterfaerd_nn_1_1_N : N ;
  aaterhaallsamhet_nn_1_1_N : N ;
  aaterstod_nn_1_1_N : N ;
  aatervinningscentral_nn_1_1_N : N ;
  aatervinningsstation_nn_1_1_N : N ;
  aatervaendsgraend_nn_1_1_N : N ;
  aatgaerd_nn_1_1_N : N ;
  aatlydnad_nn_1_1_N : N ;
  aatskillnad_nn_1_1_N : N ;
  oedemark_nn_1_1_N : N ;
  oedesstund_nn_1_1_N : N ;
  oedmjukhet_nn_1_1_N : N ;
  oedslighet_nn_1_1_N : N ;
  oegonblicksbild_nn_1_1_N : N ;
  oegonflirt_nn_1_1_N : N ;
  oegonfloert_nn_1_1_N : N ;
  oegonfroejd_nn_1_1_N : N ;
  oegonfaegnad_nn_1_1_N : N ;
  oegonfaerg_nn_1_1_N : N ;
  oegonglob_nn_1_1_N : N ;
  oegoninflammation_nn_1_1_N : N ;
  oegonkontakt_nn_1_1_N : N ;
  oegonoperation_nn_1_1_N : N ;
  oegontand_nn_1_1_N : N ;
  oegonvidd_nn_1_1_N : N ;
  oegrupp_nn_1_1_N : N ;
  oekenrand_nn_1_1_N : N ;
  oelraettighet_nn_1_1_N : N ;
  oemhet_nn_1_1_N : N ;
  oemklighet_nn_1_1_N : N ;
  oemtaalighet_nn_1_1_N : N ;
  oenskeroll_nn_1_1_N : N ;
  oeppenhet_nn_1_1_N : N ;
  oeppettid_nn_1_1_N : N ;
  oeroninflammation_nn_1_1_N : N ;
  oeronlappsfaatoelj_nn_1_1_N : N ;
  oeronoperation_nn_1_1_N : N ;
  oerontrumpet_nn_1_1_N : N ;
  oestasiat_nn_1_1_N : N ;
  oestat_nn_1_1_N : N ;
  oestfront_nn_1_1_N : N ;
  oestgot_nn_1_1_N : N ;
  oestkant_nn_1_1_N : N ;
  oeststat_nn_1_1_N : N ;
  oeverbyggnad_nn_1_1_N : N ;
  oeverdragsdraekt_nn_1_1_N : N ;
  oeverdrift_nn_1_1_N : N ;
  oeverdoedlighet_nn_1_1_N : N ;
  oeverfallsvaaldtaekt_nn_1_1_N : N ;
  oeverfart_nn_1_1_N : N ;
  oeverfurir_nn_1_1_N : N ;
  oeverfaerd_nn_1_1_N : N ;
  oeverfoeringsbild_nn_1_1_N : N ;
  oeverfoeringskapacitet_nn_1_1_N : N ;
  oevergaangsform_nn_1_1_N : N ;
  oevergaangstid_nn_1_1_N : N ;
  oeverhet_nn_1_1_N : N ;
  oeverhoeghet_nn_1_1_N : N ;
  oeverintendent_nn_1_1_N : N ;
  oeverklasstant_nn_1_1_N : N ;
  oeverkonsumtion_nn_1_1_N : N ;
  oeverkaenslighet_nn_1_1_N : N ;
  oeverlevnad_nn_1_1_N : N ;
  oeverlevnadsinstinkt_nn_1_1_N : N ;
  oeverljudsfart_nn_1_1_N : N ;
  oeverlaegsenhet_nn_1_1_N : N ;
  oevernattningslaegenhet_nn_1_1_N : N ;
  oevernattningsmoejlighet_nn_1_1_N : N ;
  oevernaturlighet_nn_1_1_N : N ;
  oeverproduktion_nn_1_1_N : N ;
  oeverraett_nn_1_1_N : N ;
  oeversikt_nn_1_1_N : N ;
  oeverskrift_nn_1_1_N : N ;
  oeverspaendhet_nn_1_1_N : N ;
  oeversteloejtnant_nn_1_1_N : N ;
  oeversyn_nn_1_1_N : N ;
  oeversaettningsmaskin_nn_1_1_N : N ;
  oeverton_nn_1_1_N : N ;
  oevertydlighet_nn_1_1_N : N ;
  oevervakningsbild_nn_1_1_N : N ;
  oeverklassmiljoe_nn_1_1_N : N ;
  oevergaangsmiljoe_nn_1_1_N : N ;
  oeverarmsmuskel_nn_1_1_N : N ;
  oestkustmiljoe_nn_1_1_N : N ;
  oegonmuskel_nn_1_1_N : N ;
  zulu_nn_1_N : N ;
  zeppelinarhangar_nn_1_N : N ;
  yogi_nn_1_N : N ;
  vaextfiber_nn_1_1_N : N ;
  vokabel_nn_1_N : N ;
  variabel_nn_1_N : N ;
  vardagsrumsmoebel_nn_1_1_N : N ;
  valvel_nn_1_N : N ;
  vakuummateria_nn_1_N : N ;
  vacuummateria_nn_1_N : N ;
  vaccinationskoe_nn_1_1_N : N ;
  utemoebel_nn_1_1_N : N ;
  utemiljoe_nn_1_1_N : N ;
  uppvaextmiljoe_nn_1_1_N : N ;
  universitetskansler_nn_1_N : N ;
  turordningsregel_nn_1_N : N ;
  tumregel_nn_1_N : N ;
  tuggmuskel_nn_1_N : N ;
  tuberkel_nn_1_N : N ;
  traefiber_nn_1_1_N : N ;
  traedgaardsmoebel_nn_1_1_N : N ;
  trollformel_nn_1_N : N ;
  trivselregel_nn_1_N : N ;
  trippel_nn_3_N : N ;
  tricepsmuskel_nn_1_N : N ;
  trafikregel_nn_1_N : N ;
  toalettkoe_nn_1_1_N : N ;
  titulaerkonsul_nn_1_1_N : N ;
  textilfiber_nn_1_N : N ;
  teveintervju_nn_1_N : N ;
  tentakel_nn_1_N : N ;
  telefonkoe_nn_1_1_N : N ;
  tandformel_nn_1_N : N ;
  saegen_nn_1_1_N : N ;
  systemkoe_nn_1_1_N : N ;
  syntetfiber_nn_1_N : N ;
  svaermorshistoria_nn_1_1_N : N ;
  straeckarmuskel_nn_1_1_N : N ;
  strukturformel_nn_1_N : N ;
  strandmiljoe_nn_1_1_N : N ;
  stormufti_nn_1_N : N ;
  stipel_nn_1_N : N ;
  stilmoebel_nn_1_1_N : N ;
  stadsmiljoe_nn_1_1_N : N ;
  squaw_nn_1_N : N ;
  spoekhistoria_nn_1_1_N : N ;
  spraakregel_nn_1_1_N : N ;
  spermatozo_nn_1_N : N ;
  spelregel_nn_1_N : N ;
  solmateria_nn_1_N : N ;
  slaekthistoria_nn_1_1_N : N ;
  slutmuskel_nn_1_N : N ;
  skraeckhistoria_nn_1_1_N : N ;
  skrupel_nn_1_N : N ;
  skolmassaker_nn_1_N : N ;
  skjutjaernsintervju_nn_1_1_N : N ;
  skepparhistoria_nn_1_N : N ;
  skelettmuskel_nn_1_N : N ;
  skatteregel_nn_1_N : N ;
  skandalhistoria_nn_1_N : N ;
  sjoevaegsregel_nn_1_1_N : N ;
  sjoefartsregel_nn_1_1_N : N ;
  sjukregel_nn_1_N : N ;
  sjukdomshistoria_nn_1_N : N ;
  sittmoebel_nn_1_1_N : N ;
  sigel_nn_1_N : N ;
  shogun_nn_1_N : N ;
  senior_nn_1_N : N ;
  sebu_nn_1_N : N ;
  samtidsmiljoe_nn_1_1_N : N ;
  roevarhistoria_nn_1_1_N : N ;
  raettsregel_nn_1_1_N : N ;
  rymdmateria_nn_1_N : N ;
  ryggmuskel_nn_1_N : N ;
  ringmuskel_nn_1_N : N ;
  rikskansler_nn_1_N : N ;
  rickshaw_nn_1_N : N ;
  renkonter_nn_1_N : N ;
  regel_nn_1_N : N ;
  ragu_nn_1_N : N ;
  rabbi_nn_1_N : N ;
  pustel_nn_1_N : N ;
  punkteringsspray_nn_1_N : N ;
  psykiater_nn_1_N : N ;
  protozo_nn_1_N : N ;
  prokonsul_nn_1_N : N ;
  prokansler_nn_1_N : N ;
  presstoedsregel_nn_1_1_N : N ;
  presbyter_nn_1_N : N ;
  portmonnae_nn_1_1_N : N ;
  polarmiljoe_nn_1_1_N : N ;
  plastfiber_nn_1_N : N ;
  petitchou_nn_1_N : N ;
  petit_chou_nn_1_N : N ;
  patron_nn_1_N : N ;
  passionshistoria_nn_1_N : N ;
  parafiber_nn_1_N : N ;
  parabel_nn_1_N : N ;
  palaver_nn_1_N : N ;
  ordensregel_nn_1_N : N ;
  onager_nn_1_N : N ;
  okapi_nn_1_N : N ;
  naesselfiber_nn_1_1_N : N ;
  naermiljoe_nn_1_1_N : N ;
  nutidshistoria_nn_1_N : N ;
  nigger_nn_1_N : N ;
  niello_nn_1_N : N ;
  nevoe_nn_1_1_N : N ;
  nerium_nn_1_N : N ;
  neger_nn_1_N : N ;
  naturmiljoe_nn_1_1_N : N ;
  naturfiber_nn_1_N : N ;
  moebel_nn_1_1_N : N ;
  maetningsregel_nn_1_1_N : N ;
  muskelfiber_nn_1_N : N ;
  muskel_nn_1_N : N ;
  musikermiljoe_nn_1_1_N : N ;
  multipel_nn_1_N : N ;
  mufti_nn_1_N : N ;
  mor_nn_2_N : N ;
  mogul_nn_1_N : N ;
  minuskel_nn_1_N : N ;
  minnesregel_nn_1_N : N ;
  miljoe_nn_1_1_N : N ;
  mikrofiber_nn_1_N : N ;
  metazo_nn_1_N : N ;
  metafor_nn_1_N : N ;
  metafiber_nn_1_N : N ;
  mejlintervju_nn_1_N : N ;
  medkonsul_nn_1_N : N ;
  materia_nn_1_N : N ;
  massaker_nn_1_N : N ;
  marabu_nn_1_N : N ;
  maori_nn_1_N : N ;
  mandibel_nn_1_N : N ;
  manchu_nn_1_N : N ;
  majuskel_nn_1_N : N ;
  magmuskel_nn_1_N : N ;
  laarmuskel_nn_1_1_N : N ;
  laanekoe_nn_1_1_N : N ;
  lordkansler_nn_1_N : N ;
  livsmiljoe_nn_1_1_N : N ;
  linnefiber_nn_1_N : N ;
  liftkoe_nn_1_1_N : N ;
  lidandeshistoria_nn_1_N : N ;
  levnadsregel_nn_1_N : N ;
  leverabel_nn_1_N : N ;
  koe_nn_1_1_N : N ;
  kaerlekshistoria_nn_1_1_N : N ;
  kuli_nn_1_N : N ;
  krigsmiljoe_nn_1_1_N : N ;
  krigshistoria_nn_1_N : N ;
  kostfiber_nn_1_N : N ;
  korpuskel_nn_1_N : N ;
  konsul_nn_1_N : N ;
  konstfibermoebel_nn_1_1_N : N ;
  konstfiber_nn_1_N : N ;
  kolibri_nn_1_N : N ;
  kokosfiber_nn_1_N : N ;
  knarkhistoria_nn_1_N : N ;
  klosterregel_nn_1_N : N ;
  klanmassaker_nn_1_N : N ;
  kiwi_nn_1_N : N ;
  kivi_nn_1_N : N ;
  kidnappningshistoria_nn_1_N : N ;
  kazoo_nn_1_N : N ;
  kauri_nn_1_N : N ;
  kassakoe_nn_1_1_N : N ;
  karisma_nn_1_N : N ;
  kaprifolium_nn_1_N : N ;
  kaffer_nn_1_N : N ;
  kadi_nn_1_N : N ;
  junior_nn_1_N : N ;
  juldekor_nn_1_N : N ;
  jordmateria_nn_1_N : N ;
  jobbintervju_nn_1_N : N ;
  jakthistoria_nn_1_N : N ;
  intervju_nn_1_N : N ;
  inkunabel_nn_1_N : N ;
  impressario_nn_1_N : N ;
  hoersaegen_nn_1_1_N : N ;
  hypokonder_nn_1_N : N ;
  hyperbel_nn_1_N : N ;
  huvudregel_nn_1_N : N ;
  hjaertmuskel_nn_1_1_N : N ;
  historia_nn_1_N : N ;
  hemmiljoe_nn_1_1_N : N ;
  handlingsregel_nn_1_N : N ;
  haiku_nn_1_N : N ;
  gurami_nn_1_N : N ;
  gulddekor_nn_1_N : N ;
  grundregel_nn_1_N : N ;
  grammatikregel_nn_1_N : N ;
  gnu_nn_1_N : N ;
  glasfiber_nn_1_N : N ;
  glandel_nn_1_N : N ;
  geranium_nn_1_N : N ;
  genitivmetafor_nn_1_N : N ;
  generalkonsul_nn_1_N : N ;
  foermoerkelsevariabel_nn_1_1_N : N ;
  foerhaallningsregel_nn_1_1_N : N ;
  foerbundskansler_nn_1_1_N : N ;
  friluftsmiljoe_nn_1_1_N : N ;
  framgaangshistoria_nn_1_1_N : N ;
  foyer_nn_1_N : N ;
  forskningsmiljoe_nn_1_1_N : N ;
  formel_nn_1_N : N ;
  foniater_nn_1_N : N ;
  folksaegen_nn_1_1_N : N ;
  flygplanshangar_nn_1_N : N ;
  floskel_nn_1_N : N ;
  fingerstraeckarmuskel_nn_1_1_N : N ;
  fingerboejarmuskel_nn_1_1_N : N ;
  filmhistoria_nn_1_N : N ;
  fiber_nn_1_N : N ;
  farao_nn_1_N : N ;
  familjeplaneringsregel_nn_1_N : N ;
  fabel_nn_1_N : N ;
  essae_nn_1_1_N : N ;
  enkoensregel_nn_1_1_N : N ;
  emu_nn_1_N : N ;
  eforus_nn_1_N : N ;
  dramaturgi_nn_1_N : N ;
  drakma_nn_1_N : N ;
  drachma_nn_1_N : N ;
  dossier_nn_1_N : N ;
  donjuan_nn_1_N : N ;
  djurfabel_nn_1_N : N ;
  djupintervju_nn_1_N : N ;
  djungel_nn_1_N : N ;
  deltamuskel_nn_1_N : N ;
  ciliarmuskel_nn_1_N : N ;
  boejmuskel_nn_1_1_N : N ;
  boejarmuskel_nn_1_1_N : N ;
  bukmuskel_nn_1_N : N ;
  broestmuskel_nn_1_1_N : N ;
  broedkoe_nn_1_1_N : N ;
  bruttoformel_nn_1_N : N ;
  bostadsmiljoe_nn_1_1_N : N ;
  bostadskoe_nn_1_1_N : N ;
  bonusregel_nn_1_N : N ;
  boggi_nn_1_N : N ;
  bistro_nn_1_N : N ;
  bilkoe_nn_1_1_N : N ;
  biljardkoe_nn_1_1_N : N ;
  bicepsmuskel_nn_1_N : N ;
  bibelkanon_nn_1_N : N ;
  bevattningsregel_nn_1_N : N ;
  besvaerjelseformel_nn_1_1_N : N ;
  benmuskel_nn_1_N : N ;
  bastfiber_nn_1_N : N ;
  bakgrundsvariabel_nn_1_N : N ;
  badrumsmoebel_nn_1_1_N : N ;
  armmuskel_nn_1_N : N ;
  arkiater_nn_1_N : N ;
  arbetstidsregel_nn_1_N : N ;
  arbetsmiljoe_nn_1_1_N : N ;
  arbetsintervju_nn_1_N : N ;
  apotekskoe_nn_1_1_N : N ;
  anstaellningsintervju_nn_1_1_N : N ;
  ansiktsmuskel_nn_1_N : N ;
  amatoerregel_nn_1_1_N : N ;
  aguti_nn_1_N : N ;
  TV_intervju_nn_1_N : N ;
  Katynmassaker_nn_1_N : N ;
  IKEA_moebel_nn_1_1_N : N ;
  A_bomb_nn_1_N : N ;
  A_vitaminbrist_nn_1_N : N ;
  Administrator_nn_1_N : N ;
  Afrikatrad_nn_1_N : N ;
  B_vitaminbrist_nn_1_N : N ;
  Ballograf_nn_1_N : N ;
  Citroen_nn_1_N : N ;
  DNA_molekyl_nn_1_N : N ;
  DNA_sekvens_nn_1_N : N ;
  DVD_film_nn_1_N : N ;
  Dramatenchef_nn_1_N : N ;
  EU_kommission_nn_1_N : N ;
  Facebookbild_nn_1_N : N ;
  Facebookgrupp_nn_1_N : N ;
  G_kraft_nn_1_N : N ;
  G_punkt_nn_1_N : N ;
  Hausdorffdimension_nn_1_N : N ;
  Higgsboson_nn_1_N : N ;
  Hiroshimabomb_nn_1_N : N ;
  Hitchcockfilm_nn_1_N : N ;
  Kubakris_nn_1_N : N ;
  MP3_bok_nn_1_N : N ;
  Marylandaccent_nn_1_N : N ;
  Medelshavskultur_nn_1_N : N ;
  Mosebok_nn_1_N : N ;
  Natosoldat_nn_1_N : N ;
  Oxfordstudent_nn_1_N : N ;
  PIN_kod_nn_1_N : N ;
  Parisflygplats_nn_1_N : N ;
  Rembrandt_nn_1_N : N ;
  SCOPE_rapport_nn_1_N : N ;
  Salazar_regim_nn_1_N : N ;
  Sokratesdialog_nn_1_N : N ;
  Stillahavsskvadron_nn_1_N : N ;
  Stureplansprofil_nn_1_N : N ;
  Sverigedemokrat_nn_1_N : N ;
  TV_evangelist_nn_1_N : N ;
  TV_konferens_nn_1_N : N ;
  TV_mast_nn_1_N : N ;
  TV_predikant_nn_1_N : N ;
  TV_producent_nn_1_N : N ;
  TV_profil_nn_1_N : N ;
  TV_signal_nn_1_N : N ;
  VVS_armatur_nn_1_N : N ;
  Vellingemoderat_nn_1_N : N ;
  Vietnamveteran_nn_1_N : N ;
  X_kromosom_nn_1_N : N ;
  Y_kromosom_nn_1_N : N ;
  a_bomb_nn_1_N : N ;
  abakus_nn_1_N : N ;
  abbreviation_nn_1_N : N ;
  abbreviatur_nn_1_N : N ;
  abdikation_nn_1_N : N ;
  aberration_nn_1_N : N ;
  abessiv_nn_1_N : N ;
  abilitet_nn_1_N : N ;
  ablation_nn_1_N : N ;
  ablativ_nn_1_N : N ;
  abnormitet_nn_1_N : N ;
  abolition_nn_1_N : N ;
  abolitionist_nn_1_N : N ;
  aborigin_nn_1_N : N ;
  abort_nn_1_N : N ;
  abortraett_nn_1_1_N : N ;
  abrasion_nn_1_N : N ;
  abrovink_nn_1_N : N ;
  abrovinsch_nn_1_N : N ;
  abscess_nn_1_N : N ;
  absens_nn_1_N : N ;
  absid_nn_1_N : N ;
  absolution_nn_1_N : N ;
  absolutism_nn_1_N : N ;
  absolutist_nn_1_N : N ;
  absolutiv_nn_1_N : N ;
  absorption_nn_1_N : N ;
  abstraktion_nn_1_N : N ;
  absurdism_nn_1_N : N ;
  absurditet_nn_1_N : N ;
  acceleration_nn_1_N : N ;
  accelerator_nn_1_N : N ;
  acceleratormaskin_nn_1_N : N ;
  accent_nn_1_N : N ;
  accept_nn_2_N : N ;
  acceptant_nn_1_N : N ;
  acceptkredit_nn_1_N : N ;
  access_nn_1_N : N ;
  accession_nn_1_N : N ;
  accessoar_nn_1_N : N ;
  accidens_nn_1_N : N ;
  accis_nn_1_N : N ;
  acetaldehyd_nn_1_N : N ;
  aciditet_nn_1_N : N ;
  acklamation_nn_1_N : N ;
  ackommodation_nn_1_N : N ;
  ackordsloen_nn_1_1_N : N ;
  ackumulation_nn_1_N : N ;
  ackumulator_nn_1_N : N ;
  ackusativ_nn_1_N : N ;
  ackvisition_nn_1_N : N ;
  actionfilm_nn_1_N : N ;
  adaptation_nn_1_N : N ;
  adaption_nn_1_N : N ;
  addiktion_nn_1_N : N ;
  addiktolog_nn_1_N : N ;
  addition_nn_1_N : N ;
  adduktion_nn_1_N : N ;
  adelsdam_nn_1_N : N ;
  adelsslaekt_nn_1_1_N : N ;
  adenit_nn_1_N : N ;
  adessiv_nn_1_N : N ;
  adhesion_nn_1_N : N ;
  adjunktion_nn_1_N : N ;
  adjunktur_nn_1_N : N ;
  administration_nn_1_N : N ;
  administrator_nn_1_N : N ;
  admonition_nn_1_N : N ;
  adoptant_nn_1_N : N ;
  adoption_nn_1_N : N ;
  adress_nn_1_N : N ;
  adsorption_nn_1_N : N ;
  adventist_nn_1_N : N ;
  advers_nn_1_N : N ;
  advokat_nn_1_N : N ;
  advokatbyraa_nn_1_1_N : N ;
  aerogel_nn_1_N : N ;
  aerosol_nn_1_N : N ;
  affektation_nn_1_N : N ;
  affektion_nn_1_N : N ;
  affinitet_nn_1_N : N ;
  affisch_nn_1_N : N ;
  affischkampanj_nn_1_N : N ;
  affaer_nn_1_1_N : N ;
  affaersfastighet_nn_1_1_N : N ;
  affaersresenaer_nn_1_1_N : N ;
  affaerstransaktion_nn_1_1_N : N ;
  affaersverksamhet_nn_1_1_N : N ;
  afghan_nn_1_N : N ;
  aforism_nn_1_N : N ;
  afrikan_nn_1_N : N ;
  afroamerikan_nn_1_N : N ;
  aftonboen_nn_1_1_N : N ;
  aftondraekt_nn_1_1_N : N ;
  aftongudstjaenst_nn_1_1_N : N ;
  aftonmaaltid_nn_1_1_N : N ;
  aftonrodnad_nn_1_N : N ;
  aftonstund_nn_1_N : N ;
  aftonsaang_nn_1_1_N : N ;
  agens_nn_1_N : N ;
  agentfilm_nn_1_N : N ;
  agentur_nn_1_N : N ;
  agglomeration_nn_1_N : N ;
  agglutination_nn_1_N : N ;
  aggregation_nn_1_N : N ;
  aggregationsform_nn_1_N : N ;
  aggression_nn_1_N : N ;
  aggressivitet_nn_1_N : N ;
  agitation_nn_1_N : N ;
  agitator_nn_1_N : N ;
  agnosticism_nn_1_N : N ;
  aidsmedicin_nn_1_N : N ;
  aidspanik_nn_1_N : N ;
  air_nn_1_N : N ;
  airbagsensor_nn_1_N : N ;
  akademist_nn_1_N : N ;
  akant_nn_1_N : N ;
  akropol_nn_1_N : N ;
  akt_nn_1_N : N ;
  aktant_nn_1_N : N ;
  aktieboers_nn_1_1_N : N ;
  aktieemission_nn_1_N : N ;
  aktiekurs_nn_1_N : N ;
  aktiemajoritet_nn_1_N : N ;
  aktiepost_nn_1_N : N ;
  aktievinst_nn_1_N : N ;
  aktion_nn_1_N : N ;
  aktionsgrupp_nn_1_N : N ;
  aktionsturbin_nn_1_N : N ;
  aktivism_nn_1_N : N ;
  aktivist_nn_1_N : N ;
  aktivitet_nn_1_N : N ;
  aktor_nn_1_N : N ;
  aktris_nn_1_N : N ;
  aktsamhet_nn_1_N : N ;
  aktsamhetsplikt_nn_1_N : N ;
  aktualitet_nn_1_N : N ;
  akut_nn_1_N : N ;
  akvakultur_nn_1_N : N ;
  akvamarin_nn_1_N : N ;
  akvarellfaerg_nn_1_1_N : N ;
  akvarellist_nn_1_N : N ;
  akvavit_nn_1_N : N ;
  alan_nn_1_N : N ;
  alant_nn_1_N : N ;
  alarmist_nn_1_N : N ;
  alarmsignal_nn_1_N : N ;
  alban_nn_1_N : N ;
  albatross_nn_1_N : N ;
  albigens_nn_1_N : N ;
  albinism_nn_1_N : N ;
  aldehyd_nn_1_N : N ;
  alexandrin_nn_1_N : N ;
  alf_nn_1_N : N ;
  alfons_nn_1_N : N ;
  alg_nn_1_N : N ;
  algolog_nn_1_N : N ;
  alienation_nn_1_N : N ;
  alkaloid_nn_1_N : N ;
  alkan_nn_1_N : N ;
  alkanol_nn_1_N : N ;
  alkemist_nn_1_N : N ;
  alkohol_nn_1_N : N ;
  alkoholhalt_nn_1_N : N ;
  alkoholism_nn_1_N : N ;
  alkoholist_nn_1_N : N ;
  alkoholistanstalt_nn_1_N : N ;
  alkoholkonsumtion_nn_1_N : N ;
  alkoholpsykos_nn_1_N : N ;
  alkoholskatt_nn_1_N : N ;
  alkyd_nn_1_N : N ;
  alkyl_nn_1_N : N ;
  alkyn_nn_1_N : N ;
  allativ_nn_1_N : N ;
  allel_nn_1_N : N ;
  allemansfond_nn_1_N : N ;
  allergimedicin_nn_1_N : N ;
  allergolog_nn_1_N : N ;
  allians_nn_1_N : N ;
  alligator_nn_1_N : N ;
  allitteration_nn_1_N : N ;
  allkonstnaer_nn_1_1_N : N ;
  allmogedraekt_nn_1_1_N : N ;
  allmogekultur_nn_1_N : N ;
  allmogevaevnad_nn_1_1_N : N ;
  allmaengiltighet_nn_1_1_N : N ;
  allmaenhet_nn_1_1_N : N ;
  allmaenprevention_nn_1_1_N : N ;
  allofon_nn_1_N : N ;
  allokution_nn_1_N : N ;
  allsaang_nn_1_1_N : N ;
  allusion_nn_1_N : N ;
  allvarsamhet_nn_1_N : N ;
  all_e_nn_1_1_N : N ;
  almanack_nn_1_N : N ;
  alpidyll_nn_1_N : N ;
  alpinism_nn_1_N : N ;
  alpinist_nn_1_N : N ;
  altan_nn_1_N : N ;
  altarprydnad_nn_1_N : N ;
  altartjaenst_nn_1_1_N : N ;
  alteration_nn_1_N : N ;
  alternativkurs_nn_1_N : N ;
  altfloejt_nn_1_1_N : N ;
  altruism_nn_1_N : N ;
  altruist_nn_1_N : N ;
  altroest_nn_1_1_N : N ;
  altviolin_nn_1_N : N ;
  aluminiumfabrik_nn_1_N : N ;
  aluminiumjon_nn_1_N : N ;
  aluminiumlinjal_nn_1_N : N ;
  alv_nn_2_N : N ;
  alvarsmark_nn_1_N : N ;
  alveol_nn_1_N : N ;
  amanuens_nn_1_N : N ;
  amarant_nn_1_N : N ;
  amason_nn_1_N : N ;
  amatoerastronom_nn_1_1_N : N ;
  amatoeridrott_nn_1_1_N : N ;
  amatoerism_nn_1_1_N : N ;
  amazon_nn_1_N : N ;
  ambassadris_nn_1_N : N ;
  ambassadoer_nn_1_1_N : N ;
  ambassadoerspost_nn_1_1_N : N ;
  ambiguitet_nn_1_N : N ;
  ambition_nn_1_N : N ;
  ambitionssak_nn_1_N : N ;
  ambulans_nn_1_N : N ;
  amerikan_nn_1_N : N ;
  amerikanism_nn_1_N : N ;
  ametist_nn_1_N : N ;
  amfibolit_nn_1_N : N ;
  amid_nn_1_N : N ;
  ammonit_nn_1_N : N ;
  ammunition_nn_1_N : N ;
  amoralism_nn_1_N : N ;
  amoralitet_nn_1_N : N ;
  amorfism_nn_1_N : N ;
  amorin_nn_1_N : N ;
  amorteringsplan_nn_1_N : N ;
  amputation_nn_1_N : N ;
  amulett_nn_1_N : N ;
  amylas_nn_1_N : N ;
  anabaptism_nn_1_N : N ;
  anabaptist_nn_1_N : N ;
  anabol_nn_1_N : N ;
  anakronism_nn_1_N : N ;
  analfabetism_nn_1_N : N ;
  analys_nn_1_N : N ;
  analysmetodik_nn_1_N : N ;
  anamnes_nn_1_N : N ;
  ananassallad_nn_1_N : N ;
  anapest_nn_1_N : N ;
  anarkism_nn_1_N : N ;
  anarkist_nn_1_N : N ;
  anarkosyndikalism_nn_1_N : N ;
  anarkosyndikalist_nn_1_N : N ;
  anastas_nn_1_N : N ;
  ancestor_nn_1_N : N ;
  anciennitet_nn_1_N : N ;
  andaktsstund_nn_1_N : N ;
  andedraekt_nn_1_1_N : N ;
  andfigur_nn_1_N : N ;
  andhaemtningspaus_nn_1_1_N : N ;
  andjakt_nn_1_N : N ;
  andningspaus_nn_1_N : N ;
  andningsreaktion_nn_1_N : N ;
  andningssvaarighet_nn_1_1_N : N ;
  andorran_nn_1_N : N ;
  andragradsekvation_nn_1_N : N ;
  andrahandsbutik_nn_1_N : N ;
  andrahandsfaktorer_nn_1_N : N ;
  andrahandsinformation_nn_1_N : N ;
  andrahandsuppgift_nn_1_N : N ;
  andraplats_nn_1_N : N ;
  andrechef_nn_1_N : N ;
  androgyn_nn_1_N : N ;
  android_nn_1_N : N ;
  anemon_nn_1_N : N ;
  anestesiolog_nn_1_N : N ;
  anfallsbas_nn_1_N : N ;
  angelaegenhet_nn_1_1_N : N ;
  anglicism_nn_1_N : N ;
  anglist_nn_1_N : N ;
  anglaes_nn_1_1_N : N ;
  angolan_nn_1_N : N ;
  angreppspunkt_nn_1_N : N ;
  anilinfaerg_nn_1_1_N : N ;
  animation_nn_1_N : N ;
  animism_nn_1_N : N ;
  animositet_nn_1_N : N ;
  aningsloeshet_nn_1_1_N : N ;
  anjon_nn_1_N : N ;
  ankarplats_nn_1_N : N ;
  anklagelsepunkt_nn_1_N : N ;
  anklagelseskrift_nn_1_N : N ;
  ankomst_nn_1_N : N ;
  ankomstkommun_nn_1_N : N ;
  ankomsttid_nn_1_N : N ;
  ankringsplats_nn_1_N : N ;
  anlaeggningskostnad_nn_1_1_N : N ;
  anlaeggningsplats_nn_1_1_N : N ;
  anmarsch_nn_1_N : N ;
  anmaelningsbenaegenhet_nn_1_1_N : N ;
  anmaelningstid_nn_1_1_N : N ;
  annalist_nn_1_N : N ;
  annektion_nn_1_N : N ;
  annexion_nn_1_N : N ;
  annihilation_nn_1_N : N ;
  annons_nn_1_N : N ;
  annonsbojkott_nn_1_N : N ;
  annonsbyraa_nn_1_1_N : N ;
  annonskampanj_nn_1_N : N ;
  annonsplats_nn_1_N : N ;
  annotation_nn_1_N : N ;
  annuitet_nn_1_N : N ;
  anonymitet_nn_1_N : N ;
  anpassningsgrupp_nn_1_N : N ;
  anropssignal_nn_1_N : N ;
  ansats_nn_1_N : N ;
  ansiktsform_nn_1_N : N ;
  ansiktsfaerg_nn_1_1_N : N ;
  ansiktskraem_nn_1_1_N : N ;
  ansiktsmask_nn_1_N : N ;
  ansiktsoval_nn_1_N : N ;
  anskaffningskostnad_nn_1_N : N ;
  anskraemlighet_nn_1_1_N : N ;
  anslutningskontakt_nn_1_N : N ;
  anslutningspunkt_nn_1_N : N ;
  anspraaksloeshet_nn_1_1_N : N ;
  anstaltspastor_nn_1_N : N ;
  anstaellningskommitt_e_nn_1_1_N : N ;
  anstaellningsraettighet_nn_1_1_N : N ;
  anstaellningstid_nn_1_1_N : N ;
  anstaendighet_nn_1_1_N : N ;
  anstoetlighet_nn_1_1_N : N ;
  ansvarsfrihet_nn_1_N : N ;
  ansvarsnaemnd_nn_1_1_N : N ;
  ansvarspaafoeljd_nn_1_1_N : N ;
  ansvarsskyldighet_nn_1_N : N ;
  antagonism_nn_1_N : N ;
  antagonist_nn_1_N : N ;
  antecipation_nn_1_N : N ;
  antefix_nn_1_N : N ;
  anticyklon_nn_1_N : N ;
  antidiskrimineringsbyraa_nn_1_1_N : N ;
  antiguan_nn_1_N : N ;
  antiintellektualism_nn_1_N : N ;
  antikommunism_nn_1_N : N ;
  antikorruptionsaktivist_nn_1_N : N ;
  antikorruptionskonferens_nn_1_N : N ;
  antikvitet_nn_1_N : N ;
  antimakass_nn_1_N : N ;
  antimilitarism_nn_1_N : N ;
  antimilitarist_nn_1_N : N ;
  antioxidant_nn_1_N : N ;
  antirynkkraem_nn_1_1_N : N ;
  antisemit_nn_1_N : N ;
  antisemitism_nn_1_N : N ;
  antisionism_nn_1_N : N ;
  antites_nn_1_N : N ;
  antivirusexpert_nn_1_N : N ;
  antiaalderskraem_nn_1_1_N : N ;
  antonym_nn_1_N : N ;
  antropoid_nn_1_N : N ;
  antropolog_nn_1_N : N ;
  antropomorfism_nn_1_N : N ;
  anvisningskommun_nn_1_N : N ;
  anvaendargrupp_nn_1_1_N : N ;
  anvaendbarhet_nn_1_1_N : N ;
  anvaendningsmoejlighet_nn_1_1_N : N ;
  aorist_nn_1_N : N ;
  apart_nn_1_N : N ;
  apartheidregim_nn_1_N : N ;
  apelsin_nn_1_N : N ;
  apelsinmarmelad_nn_1_N : N ;
  apertur_nn_1_N : N ;
  apokalyps_nn_1_N : N ;
  apostrof_nn_1_N : N ;
  apoteksvaext_nn_1_1_N : N ;
  apoteos_nn_1_N : N ;
  apparans_nn_1_N : N ;
  apparat_nn_1_N : N ;
  apparatur_nn_1_N : N ;
  apparition_nn_1_N : N ;
  appell_nn_1_N : N ;
  appellant_nn_1_N : N ;
  appendicit_nn_1_N : N ;
  apperception_nn_1_N : N ;
  applikation_nn_1_N : N ;
  applikatur_nn_1_N : N ;
  apport_nn_1_N : N ;
  apposition_nn_1_N : N ;
  appretur_nn_1_N : N ;
  appretyr_nn_1_N : N ;
  approach_nn_1_N : N ;
  approximation_nn_1_N : N ;
  aprikos_nn_1_N : N ;
  aptitlighet_nn_1_N : N ;
  aptitloeshet_nn_1_1_N : N ;
  arabesk_nn_1_N : N ;
  arabist_nn_1_N : N ;
  aramid_nn_1_N : N ;
  arbetargrupp_nn_1_N : N ;
  arbetarklass_nn_1_N : N ;
  arbetarsaang_nn_1_1_N : N ;
  arbetsanstalt_nn_1_N : N ;
  arbetsbredd_nn_1_N : N ;
  arbetschef_nn_1_N : N ;
  arbetsdraekt_nn_1_1_N : N ;
  arbetsfoertjaenst_nn_1_1_N : N ;
  arbetsgivaravgift_nn_1_N : N ;
  arbetsgrupp_nn_1_N : N ;
  arbetshypotes_nn_1_N : N ;
  arbetsinkomst_nn_1_N : N ;
  arbetsinsats_nn_1_N : N ;
  arbetskonflikt_nn_1_N : N ;
  arbetskostnad_nn_1_N : N ;
  arbetslivserfarenhet_nn_1_N : N ;
  arbetslivsfond_nn_1_N : N ;
  arbetslaengd_nn_1_1_N : N ;
  arbetsloen_nn_1_1_N : N ;
  arbetsloeshet_nn_1_1_N : N ;
  arbetsmarknad_nn_1_N : N ;
  arbetsmarknadskonflikt_nn_1_N : N ;
  arbetsmarknadsaatgaerd_nn_1_1_N : N ;
  arbetsmaengd_nn_1_1_N : N ;
  arbetsnarkoman_nn_1_N : N ;
  arbetsnaemnd_nn_1_1_N : N ;
  arbetsplan_nn_1_N : N ;
  arbetsplats_nn_1_N : N ;
  arbetspremiss_nn_1_N : N ;
  arbetsrelation_nn_1_N : N ;
  arbetssaang_nn_1_1_N : N ;
  arbetstemperatur_nn_1_N : N ;
  arbetstid_nn_1_N : N ;
  arbetstvist_nn_1_N : N ;
  arbetsuppgift_nn_1_N : N ;
  argumentation_nn_1_N : N ;
  arian_nn_1_N : N ;
  arianism_nn_1_N : N ;
  arkaism_nn_1_N : N ;
  arkeolog_nn_1_N : N ;
  arkipelag_nn_1_N : N ;
  arkitekt_nn_1_N : N ;
  arkitektur_nn_1_N : N ;
  arkitrav_nn_1_N : N ;
  arkivolt_nn_1_N : N ;
  arksignatur_nn_1_N : N ;
  armatur_nn_1_N : N ;
  armbaagsled_nn_1_1_N : N ;
  armkraft_nn_1_N : N ;
  armled_nn_1_N : N ;
  armlaengd_nn_1_1_N : N ;
  armslaengd_nn_1_1_N : N ;
  armtrakt_nn_1_N : N ;
  arm_e_nn_1_1_N : N ;
  arm_eattach_e_nn_1_1_N : N ;
  arm_echef_nn_1_1_N : N ;
  arm_ekommunik_e_nn_1_1_N : N ;
  arm_ekaar_nn_1_1_N : N ;
  arm_eorganisation_nn_1_1_N : N ;
  arm_estab_nn_1_1_N : N ;
  arrangoer_nn_1_1_N : N ;
  arrendator_nn_1_N : N ;
  arrendeavgift_nn_1_N : N ;
  arrest_nn_1_N : N ;
  arrestant_nn_1_N : N ;
  arrivist_nn_1_N : N ;
  arsenikhalt_nn_1_N : N ;
  arsenikkis_nn_1_N : N ;
  artbank_nn_1_N : N ;
  artdatabank_nn_1_N : N ;
  arterioskleros_nn_1_N : N ;
  artighet_nn_1_N : N ;
  artighetsfras_nn_1_N : N ;
  artighetsvisit_nn_1_N : N ;
  artikulation_nn_1_N : N ;
  artikulationsbas_nn_1_N : N ;
  artilleriduell_nn_1_N : N ;
  artilleripjaes_nn_1_1_N : N ;
  artillerist_nn_1_N : N ;
  artist_nn_1_N : N ;
  artrit_nn_1_N : N ;
  artros_nn_1_N : N ;
  artskillnad_nn_1_N : N ;
  artaer_nn_1_1_N : N ;
  arvsfaktor_nn_1_N : N ;
  arvsfond_nn_1_N : N ;
  arvskatt_nn_1_N : N ;
  arvsmolekyl_nn_1_N : N ;
  arvsraett_nn_1_1_N : N ;
  arvsskatt_nn_1_N : N ;
  arvstvist_nn_1_N : N ;
  asfaltemulsion_nn_1_N : N ;
  askenas_nn_1_N : N ;
  askeruption_nn_1_N : N ;
  asketism_nn_1_N : N ;
  askexplosion_nn_1_N : N ;
  askkoncentration_nn_1_N : N ;
  askkris_nn_1_N : N ;
  asocialitet_nn_1_N : N ;
  aspirant_nn_1_N : N ;
  aspiration_nn_1_N : N ;
  assessor_nn_1_N : N ;
  assignant_nn_1_N : N ;
  assignation_nn_1_N : N ;
  assimilation_nn_1_N : N ;
  assistans_nn_1_N : N ;
  association_nn_1_N : N ;
  assonans_nn_1_N : N ;
  assurans_nn_1_N : N ;
  asterisk_nn_1_N : N ;
  asteroid_nn_1_N : N ;
  astigmatism_nn_1_N : N ;
  astrakan_nn_1_N : N ;
  astrolog_nn_1_N : N ;
  astronaut_nn_1_N : N ;
  astronautik_nn_1_N : N ;
  astronom_nn_1_N : N ;
  asyl_nn_1_N : N ;
  asyndes_nn_1_N : N ;
  atavism_nn_1_N : N ;
  ateism_nn_1_N : N ;
  ateist_nn_1_N : N ;
  atelj_e_nn_1_1_N : N ;
  atelj_ebild_nn_1_1_N : N ;
  ateroskleros_nn_1_N : N ;
  atlas_nn_1_N : N ;
  atmosfaerkemist_nn_1_1_N : N ;
  atom_nn_1_N : N ;
  atombomb_nn_1_N : N ;
  atomenergiorganisation_nn_1_N : N ;
  atomgrupp_nn_1_N : N ;
  atomism_nn_1_N : N ;
  atomjon_nn_1_N : N ;
  atomkraftsutbyggnad_nn_1_N : N ;
  atomreaktor_nn_1_N : N ;
  atomvikt_nn_1_N : N ;
  att_sats_nn_1_N : N ;
  attach_e_nn_1_1_N : N ;
  attentator_nn_1_N : N ;
  attest_nn_1_N : N ;
  attityd_nn_1_N : N ;
  attraktion_nn_1_N : N ;
  attraktionskraft_nn_1_N : N ;
  attribution_nn_1_N : N ;
  au_pair_nn_1_N : N ;
  audiens_nn_1_N : N ;
  auditoer_nn_1_1_N : N ;
  augur_nn_1_N : N ;
  auktion_nn_1_N : N ;
  auktionist_nn_1_N : N ;
  auktor_nn_1_N : N ;
  auktorisation_nn_1_N : N ;
  auktoritet_nn_1_N : N ;
  auskultant_nn_1_N : N ;
  auskultation_nn_1_N : N ;
  autencitet_nn_1_N : N ;
  autenticitet_nn_1_N : N ;
  autism_nn_1_N : N ;
  autist_nn_1_N : N ;
  autodaf_e_nn_1_1_N : N ;
  automat_nn_1_N : N ;
  automation_nn_1_N : N ;
  automatkarbin_nn_1_N : N ;
  automobil_nn_1_N : N ;
  autopilot_nn_1_N : N ;
  avannons_nn_1_N : N ;
  avans_nn_1_N : N ;
  avantgardism_nn_1_N : N ;
  avantgardist_nn_1_N : N ;
  avatar_nn_1_N : N ;
  avbetalningsplan_nn_1_N : N ;
  avbild_nn_1_N : N ;
  avboen_nn_1_1_N : N ;
  avdelningschef_nn_1_N : N ;
  avdelningsdirektoer_nn_1_1_N : N ;
  avdragsmoejlighet_nn_1_1_N : N ;
  aveny_nn_1_N : N ;
  avers_nn_1_N : N ;
  aversion_nn_1_N : N ;
  avfyrningsprocedur_nn_1_N : N ;
  avfaerd_nn_1_1_N : N ;
  avgudabild_nn_1_N : N ;
  avgaangsklass_nn_1_1_N : N ;
  avis_nn_1_N : N ;
  avitaminos_nn_1_N : N ;
  avlastningsplats_nn_1_N : N ;
  avlyssningsapparatur_nn_1_N : N ;
  avmagnetiseringsprocess_nn_1_N : N ;
  avmarsch_nn_1_N : N ;
  avocadosaas_nn_1_1_N : N ;
  avokadosaas_nn_1_1_N : N ;
  avraettningsplats_nn_1_1_N : N ;
  avsaknad_nn_1_N : N ;
  avsats_nn_1_N : N ;
  avskedsdikt_nn_1_N : N ;
  avskedsfest_nn_1_N : N ;
  avskedsturn_e_nn_1_1_N : N ;
  avskedsvisit_nn_1_N : N ;
  avskildhet_nn_1_N : N ;
  avskrift_nn_1_N : N ;
  avslutningsfest_nn_1_N : N ;
  avstjaelpningscentral_nn_1_1_N : N ;
  avstjaelpningsplats_nn_1_1_N : N ;
  avstaandsinformation_nn_1_1_N : N ;
  avtalsfrihet_nn_1_N : N ;
  avvaenjningstid_nn_1_1_N : N ;
  axelinflammation_nn_1_N : N ;
  axion_nn_1_N : N ;
  azerbajdzjan_nn_1_N : N ;
  babian_nn_1_N : N ;
  babydraekt_nn_1_1_N : N ;
  babysketch_nn_1_N : N ;
  bacill_nn_1_N : N ;
  backant_nn_1_N : N ;
  badanstalt_nn_1_N : N ;
  baddraekt_nn_1_1_N : N ;
  badgaest_nn_1_1_N : N ;
  badkarskant_nn_1_N : N ;
  badort_nn_1_N : N ;
  badrumsfaerg_nn_1_1_N : N ;
  badturist_nn_1_N : N ;
  badvakt_nn_1_N : N ;
  bahaman_nn_1_N : N ;
  bakgrundsfigur_nn_1_N : N ;
  bakgrundston_nn_1_N : N ;
  bakkant_nn_1_N : N ;
  bakljusramp_nn_1_N : N ;
  bakprojektion_nn_1_N : N ;
  baksidestext_nn_1_N : N ;
  baktericid_nn_1_N : N ;
  bakterieart_nn_1_N : N ;
  bakterieinfektion_nn_1_N : N ;
  bakteriekultur_nn_1_N : N ;
  bakteriolog_nn_1_N : N ;
  bal_nn_2_N : N ;
  balans_nn_1_N : N ;
  balanskonstnaer_nn_1_1_N : N ;
  baldakin_nn_1_N : N ;
  balettdans_nn_1_N : N ;
  balettdansoes_nn_1_1_N : N ;
  baljvaext_nn_1_1_N : N ;
  ballast_nn_1_N : N ;
  ballograf_nn_1_N : N ;
  ballongfamilj_nn_1_N : N ;
  ballongfaerd_nn_1_1_N : N ;
  ballonggas_nn_1_N : N ;
  balneolog_nn_1_N : N ;
  balsamin_nn_1_N : N ;
  balsamterpentin_nn_1_N : N ;
  baluns_nn_1_N : N ;
  balustrad_nn_1_N : N ;
  banalitet_nn_1_N : N ;
  banan_nn_1_N : N ;
  banankontakt_nn_1_N : N ;
  bandgenerator_nn_1_N : N ;
  bandit_nn_1_N : N ;
  bandstation_nn_1_N : N ;
  bandtraktor_nn_1_N : N ;
  bank_nn_2_N : N ;
  bankdirektoer_nn_1_1_N : N ;
  bankinspektion_nn_1_N : N ;
  bankir_nn_1_N : N ;
  bankkollaps_nn_1_N : N ;
  bankkund_nn_1_N : N ;
  banksektor_nn_1_N : N ;
  banvakt_nn_1_N : N ;
  baptism_nn_1_N : N ;
  baptist_nn_1_N : N ;
  baptistpastor_nn_1_N : N ;
  baptistpredikant_nn_1_N : N ;
  barbarism_nn_1_N : N ;
  bardisan_nn_1_N : N ;
  bariton_nn_1_N : N ;
  barkass_nn_1_N : N ;
  barlast_nn_1_N : N ;
  barmhaertighet_nn_1_1_N : N ;
  barnadoedlighet_nn_1_1_N : N ;
  barnavaardsnaemnd_nn_1_1_N : N ;
  barndos_nn_1_N : N ;
  barnfamilj_nn_1_N : N ;
  barngrupp_nn_1_N : N ;
  barnkoer_nn_1_1_N : N ;
  barnneurolog_nn_1_N : N ;
  barnomsorgsavgift_nn_1_N : N ;
  barnomsorgskostnad_nn_1_N : N ;
  barnroest_nn_1_1_N : N ;
  barnsak_nn_1_N : N ;
  barnslighet_nn_1_N : N ;
  barnsoldat_nn_1_N : N ;
  barnvaelgoerenhetsorganisation_nn_1_1_N : N ;
  barockkonst_nn_1_N : N ;
  baron_nn_1_N : N ;
  barospirator_nn_1_N : N ;
  barrdoft_nn_1_N : N ;
  barrikadstrid_nn_1_N : N ;
  barrskogsgraens_nn_1_1_N : N ;
  barrskogsregion_nn_1_N : N ;
  barrtraedssort_nn_1_1_N : N ;
  baryton_nn_1_N : N ;
  bas_nn_2_N : N ;
  basenhet_nn_1_N : N ;
  basfiolsfodralsmakaregesaell_nn_1_1_N : N ;
  basfaerdighet_nn_1_1_N : N ;
  basilisk_nn_1_N : N ;
  basist_nn_1_N : N ;
  bask_nn_1_N : N ;
  basorganisation_nn_1_N : N ;
  basroest_nn_1_1_N : N ;
  basstation_nn_1_N : N ;
  bassaeng_nn_1_1_N : N ;
  bastardform_nn_1_N : N ;
  bastcell_nn_1_N : N ;
  bastion_nn_1_N : N ;
  baston_nn_1_N : N ;
  bataljonsadjutant_nn_1_N : N ;
  bataljonschef_nn_1_N : N ;
  batist_nn_1_N : N ;
  batterist_nn_1_N : N ;
  bearnaisesaas_nn_1_1_N : N ;
  bearnaes_nn_1_1_N : N ;
  bearnaessaas_nn_1_1_N : N ;
  beckasin_nn_1_N : N ;
  bedraeglighet_nn_1_1_N : N ;
  bedroevlighet_nn_1_1_N : N ;
  beduin_nn_1_N : N ;
  befintlighet_nn_1_N : N ;
  befogenhet_nn_1_N : N ;
  befolkningsexplosion_nn_1_N : N ;
  befolkningsgrupp_nn_1_N : N ;
  befolkningspyramid_nn_1_N : N ;
  befrielsearm_e_nn_1_1_N : N ;
  befaelsgrad_nn_1_1_N : N ;
  befaengdhet_nn_1_1_N : N ;
  begivenhet_nn_1_N : N ;
  begravningsbyraa_nn_1_1_N : N ;
  begravningsgaest_nn_1_1_N : N ;
  begravningsmarsch_nn_1_N : N ;
  begravningsplats_nn_1_N : N ;
  begravningsprocession_nn_1_N : N ;
  begravningspsalm_nn_1_N : N ;
  begreppsanalys_nn_1_N : N ;
  begreppsapparat_nn_1_N : N ;
  begreppsexercis_nn_1_N : N ;
  begreppsnivaa_nn_1_1_N : N ;
  begriplighet_nn_1_N : N ;
  begynnelsehastighet_nn_1_N : N ;
  begynnelseloen_nn_1_1_N : N ;
  begaerlighet_nn_1_1_N : N ;
  behagfullhet_nn_1_N : N ;
  behaglighet_nn_1_N : N ;
  behandlingsenhet_nn_1_N : N ;
  behaviorism_nn_1_N : N ;
  behaviorist_nn_1_N : N ;
  behjaertenhet_nn_1_1_N : N ;
  behovloeshet_nn_1_1_N : N ;
  behovsprincip_nn_1_N : N ;
  behoerighet_nn_1_1_N : N ;
  beklaednad_nn_1_1_N : N ;
  bekostnad_nn_1_N : N ;
  bekvaemlighet_nn_1_1_N : N ;
  bekaennelsefrihet_nn_1_1_N : N ;
  bekaennelseroman_nn_1_1_N : N ;
  bekaennelseskrift_nn_1_1_N : N ;
  belastningsuppgift_nn_1_N : N ;
  belemnit_nn_1_N : N ;
  belevenhet_nn_1_N : N ;
  belletrist_nn_1_N : N ;
  belysningsarmatur_nn_1_N : N ;
  belaegenhet_nn_1_1_N : N ;
  belaeggningsgrad_nn_1_1_N : N ;
  belaesenhet_nn_1_1_N : N ;
  belaesthet_nn_1_1_N : N ;
  belaaningsgrad_nn_1_1_N : N ;
  belaatenhet_nn_1_1_N : N ;
  benediktin_nn_1_N : N ;
  benhinneinflammation_nn_1_N : N ;
  benkirurg_nn_1_N : N ;
  benprotes_nn_1_N : N ;
  benrest_nn_1_N : N ;
  bensinmotor_nn_1_N : N ;
  bensinskatt_nn_1_N : N ;
  bensinstation_nn_1_N : N ;
  bensintillsats_nn_1_N : N ;
  benskoerhet_nn_1_1_N : N ;
  bensubstans_nn_1_N : N ;
  bensvulst_nn_1_N : N ;
  bentonit_nn_1_N : N ;
  bentrakt_nn_1_N : N ;
  benvaevnad_nn_1_1_N : N ;
  benaegenhet_nn_1_1_N : N ;
  beredskapstjaenst_nn_1_1_N : N ;
  beredvillighet_nn_1_N : N ;
  berggrund_nn_1_N : N ;
  bergkristall_nn_1_N : N ;
  bergsbestigningsexpedition_nn_1_N : N ;
  bergsbrant_nn_1_N : N ;
  bergsbygd_nn_1_N : N ;
  bergsformation_nn_1_N : N ;
  bergsglaciaer_nn_1_1_N : N ;
  bergsplataa_nn_1_1_N : N ;
  berlock_nn_1_N : N ;
  bernaes_nn_1_1_N : N ;
  bernaessaas_nn_1_1_N : N ;
  bersaa_nn_1_1_N : N ;
  berusningsgrad_nn_1_N : N ;
  beraekningsgrund_nn_1_1_N : N ;
  beraettarkonst_nn_1_1_N : N ;
  beraettarroest_nn_1_1_N : N ;
  beroemdhet_nn_1_1_N : N ;
  beroemlighet_nn_1_1_N : N ;
  beroeringsassociation_nn_1_1_N : N ;
  beroeringselektricitet_nn_1_1_N : N ;
  beroeringspunkt_nn_1_1_N : N ;
  besatthet_nn_1_N : N ;
  besinningsloeshet_nn_1_1_N : N ;
  besittningsraett_nn_1_1_N : N ;
  beskaffenhet_nn_1_N : N ;
  beskattningsnaemnd_nn_1_1_N : N ;
  beskattningsprincip_nn_1_N : N ;
  beskhet_nn_1_N : N ;
  beskickningschef_nn_1_N : N ;
  beskyddarverksamhet_nn_1_N : N ;
  beskaeftighet_nn_1_1_N : N ;
  beslagssmed_nn_1_N : N ;
  beslutnivaa_nn_1_1_N : N ;
  beslutsamhet_nn_1_N : N ;
  beslutsnivaa_nn_1_1_N : N ;
  beslutsprocess_nn_1_N : N ;
  besparingstorped_nn_1_N : N ;
  besserwisserattityd_nn_1_N : N ;
  bestaellningsavgift_nn_1_1_N : N ;
  bestaemmelseort_nn_1_1_N : N ;
  bestaendighet_nn_1_1_N : N ;
  besvaerlighet_nn_1_1_N : N ;
  besvaersinstans_nn_1_1_N : N ;
  besvaersmyndighet_nn_1_1_N : N ;
  besvaersskrift_nn_1_1_N : N ;
  besvaerstid_nn_1_1_N : N ;
  besynnerlighet_nn_1_N : N ;
  besoeksadress_nn_1_1_N : N ;
  besoeksrestriktion_nn_1_1_N : N ;
  besoekstid_nn_1_1_N : N ;
  betalkurs_nn_1_N : N ;
  betalningsbalans_nn_1_N : N ;
  betalningsfrist_nn_1_N : N ;
  betalningstermin_nn_1_N : N ;
  betatron_nn_1_N : N ;
  beteendevetenskap_nn_1_N : N ;
  betesmark_nn_1_N : N ;
  betesplats_nn_1_N : N ;
  betkampanj_nn_1_N : N ;
  betong_nn_1_N : N ;
  betongfaerg_nn_1_1_N : N ;
  betongmaskin_nn_1_N : N ;
  betongvibrator_nn_1_N : N ;
  bets_nn_1_N : N ;
  betydelsenyans_nn_1_N : N ;
  betydenhet_nn_1_N : N ;
  betygsavskrift_nn_1_N : N ;
  betygsgrad_nn_1_N : N ;
  betygsnaemnd_nn_1_1_N : N ;
  betaenketid_nn_1_1_N : N ;
  betaenklighet_nn_1_1_N : N ;
  bevattningskanal_nn_1_N : N ;
  bevissvaarighet_nn_1_1_N : N ;
  bevaagenhet_nn_1_1_N : N ;
  bhutanes_nn_1_N : N ;
  bias_nn_1_N : N ;
  bibelhandskrift_nn_1_N : N ;
  bibelkommission_nn_1_N : N ;
  bibelkonkordans_nn_1_N : N ;
  biblicism_nn_1_N : N ;
  biblioman_nn_1_N : N ;
  biblioteksavgift_nn_1_N : N ;
  bidragsmiljon_nn_1_N : N ;
  bidragsskyldighet_nn_1_N : N ;
  bid_e_nn_1_1_N : N ;
  biffrad_nn_1_N : N ;
  bifigur_nn_1_N : N ;
  biform_nn_1_N : N ;
  bifurkation_nn_1_N : N ;
  bigamist_nn_1_N : N ;
  bigarraa_nn_1_1_N : N ;
  bihaaleinflammation_nn_1_1_N : N ;
  biinkomst_nn_1_N : N ;
  bilaccis_nn_1_N : N ;
  bilaffaer_nn_1_1_N : N ;
  bilantenn_nn_1_N : N ;
  bilbok_e_nn_1_1_N : N ;
  bild_nn_1_N : N ;
  bildkonst_nn_1_N : N ;
  bildmonitor_nn_1_N : N ;
  bildningsanstalt_nn_1_N : N ;
  bildningsgrad_nn_1_N : N ;
  bildningsnivaa_nn_1_1_N : N ;
  bildningsorganisation_nn_1_N : N ;
  bildningsroman_nn_1_N : N ;
  bildningsverksamhet_nn_1_N : N ;
  bildredaktoer_nn_1_1_N : N ;
  bildsignal_nn_1_N : N ;
  bildskrift_nn_1_N : N ;
  bildstod_nn_1_N : N ;
  bildstrid_nn_1_N : N ;
  bildsvit_nn_1_N : N ;
  bildtelefon_nn_1_N : N ;
  bildtext_nn_1_N : N ;
  bildvaevnad_nn_1_1_N : N ;
  bilfabrik_nn_1_N : N ;
  bilfabrikoer_nn_1_1_N : N ;
  bilfaerd_nn_1_1_N : N ;
  bilingualism_nn_1_N : N ;
  bilism_nn_1_N : N ;
  bilist_nn_1_N : N ;
  biljard_nn_1_N : N ;
  biljardsalong_nn_1_N : N ;
  biljett_nn_1_N : N ;
  biljettexpedition_nn_1_N : N ;
  biljettinkomst_nn_1_N : N ;
  biljettkontroll_nn_1_N : N ;
  biljon_nn_1_N : N ;
  bilkaross_nn_1_N : N ;
  bilkonstruktoer_nn_1_1_N : N ;
  bilkrasch_nn_1_N : N ;
  bilkup_e_nn_1_1_N : N ;
  bilkaar_nn_1_1_N : N ;
  bilkaarist_nn_1_1_N : N ;
  billast_nn_1_N : N ;
  billiard_nn_1_N : N ;
  billighet_nn_1_N : N ;
  billion_nn_1_N : N ;
  bilmotor_nn_1_N : N ;
  bilnavigator_nn_1_N : N ;
  bilradioapparat_nn_1_N : N ;
  bilskatt_nn_1_N : N ;
  bilstoeld_nn_1_1_N : N ;
  biltelefon_nn_1_N : N ;
  biltur_nn_1_N : N ;
  bimetallism_nn_1_N : N ;
  bindehinneinflammation_nn_1_N : N ;
  bindesubstans_nn_1_N : N ;
  bindningstid_nn_1_N : N ;
  biobank_nn_1_N : N ;
  biocid_nn_1_N : N ;
  biogas_nn_1_N : N ;
  biografbyraa_nn_1_1_N : N ;
  biokemist_nn_1_N : N ;
  biolog_nn_1_N : N ;
  biomstaendighet_nn_1_1_N : N ;
  biopremiaer_nn_1_1_N : N ;
  bioreaktor_nn_1_N : N ;
  biosalong_nn_1_N : N ;
  bipolaritet_nn_1_N : N ;
  biprodukt_nn_1_N : N ;
  biroll_nn_1_N : N ;
  bisak_nn_1_N : N ;
  bisats_nn_1_N : N ;
  bisektris_nn_1_N : N ;
  bisexualitet_nn_1_N : N ;
  biskopsvisitation_nn_1_N : N ;
  bissauguinean_nn_1_N : N ;
  biton_nn_1_N : N ;
  bitterhet_nn_1_N : N ;
  biverkningsrapport_nn_1_N : N ;
  bjaebbighet_nn_1_1_N : N ;
  bjoerkregion_nn_1_1_N : N ;
  bjoernjakt_nn_1_1_N : N ;
  bjoerntjaenst_nn_1_1_N : N ;
  bladlaengd_nn_1_1_N : N ;
  blancmang_e_nn_1_1_N : N ;
  blandform_nn_1_N : N ;
  blandfaerg_nn_1_1_N : N ;
  blandkultur_nn_1_N : N ;
  blandras_nn_1_N : N ;
  blandtyp_nn_1_N : N ;
  blankningsaffaer_nn_1_1_N : N ;
  blankoaccept_nn_1_N : N ;
  blankofullmakt_nn_1_N : N ;
  blankokredit_nn_1_N : N ;
  blankotransport_nn_1_N : N ;
  blekhet_nn_1_N : N ;
  blessyr_nn_1_N : N ;
  blidgrad_nn_1_N : N ;
  blindtarmsinflammation_nn_1_N : N ;
  blindtarmsoperation_nn_1_N : N ;
  blixtvisit_nn_1_N : N ;
  blockad_nn_1_N : N ;
  blockalmanack_nn_1_N : N ;
  blockgraens_nn_1_1_N : N ;
  blodapelsin_nn_1_N : N ;
  blodcirkulation_nn_1_N : N ;
  blodgrupp_nn_1_N : N ;
  blodighet_nn_1_N : N ;
  blodsdiamant_nn_1_N : N ;
  blodsvulst_nn_1_N : N ;
  blodtransfusion_nn_1_N : N ;
  blodoeverfyllnad_nn_1_1_N : N ;
  bloggosfaer_nn_1_1_N : N ;
  blomdoft_nn_1_N : N ;
  blomform_nn_1_N : N ;
  blommighet_nn_1_N : N ;
  blomningstid_nn_1_N : N ;
  blomsteraffaer_nn_1_1_N : N ;
  blomsterdoft_nn_1_N : N ;
  blomstermaanad_nn_1_1_N : N ;
  blomsterrabatt_nn_1_N : N ;
  blomstertid_nn_1_N : N ;
  blomsteruppsats_nn_1_N : N ;
  blomstervas_nn_1_N : N ;
  blomstringsperiod_nn_1_N : N ;
  blomstringstid_nn_1_N : N ;
  blomvas_nn_1_N : N ;
  blomvaext_nn_1_1_N : N ;
  blondin_nn_1_N : N ;
  blyackumulator_nn_1_N : N ;
  blyazid_nn_1_N : N ;
  blyfaerg_nn_1_1_N : N ;
  blyghet_nn_1_N : N ;
  blygsamhet_nn_1_N : N ;
  blyhalt_nn_1_N : N ;
  blyoxid_nn_1_N : N ;
  blytyngd_nn_1_N : N ;
  blaendrisk_nn_1_1_N : N ;
  blaagroenalg_nn_1_1_N : N ;
  blaamusseron_nn_1_1_N : N ;
  blaanad_nn_1_1_N : N ;
  blaaskatarr_nn_1_1_N : N ;
  blaaspistol_nn_1_1_N : N ;
  bloedighet_nn_1_1_N : N ;
  bobin_nn_1_N : N ;
  boendeform_nn_1_N : N ;
  boendekostnad_nn_1_N : N ;
  boghoejd_nn_1_1_N : N ;
  bokauktion_nn_1_N : N ;
  bokfoeringsskyldighet_nn_1_1_N : N ;
  bokmarknad_nn_1_N : N ;
  bokrad_nn_1_N : N ;
  bokstavlighet_nn_1_N : N ;
  bokstavsinspiration_nn_1_N : N ;
  bokversion_nn_1_N : N ;
  bolid_nn_1_N : N ;
  bolin_nn_1_N : N ;
  bolivian_nn_1_N : N ;
  bollplan_nn_1_N : N ;
  bolsjevism_nn_1_N : N ;
  bolaanekris_nn_1_1_N : N ;
  bolaanekund_nn_1_1_N : N ;
  bomb_nn_1_N : N ;
  bombattack_nn_1_N : N ;
  bombraid_nn_1_N : N ;
  bombraed_nn_1_1_N : N ;
  bombskyddssektion_nn_1_N : N ;
  bomullsvaevnad_nn_1_1_N : N ;
  bomullsvaext_nn_1_1_N : N ;
  bonad_nn_1_N : N ;
  bondearm_e_nn_1_1_N : N ;
  bondegeneration_nn_1_N : N ;
  bondekultur_nn_1_N : N ;
  bondeprotest_nn_1_N : N ;
  bondeslaekt_nn_1_1_N : N ;
  bondfamilj_nn_1_N : N ;
  bondpermission_nn_1_N : N ;
  bonitet_nn_1_N : N ;
  bonusklass_nn_1_N : N ;
  boplats_nn_1_N : N ;
  borddans_nn_1_N : N ;
  bordeaux_nn_1_N : N ;
  bordellverksamhet_nn_1_N : N ;
  bordsboen_nn_1_1_N : N ;
  bordsdam_nn_1_N : N ;
  bordsdryck_nn_1_N : N ;
  bordservis_nn_1_N : N ;
  bordsgaest_nn_1_1_N : N ;
  bordskamrat_nn_1_N : N ;
  bordskant_nn_1_N : N ;
  bordskavaljer_nn_1_N : N ;
  bordsservis_nn_1_N : N ;
  bordsuppsats_nn_1_N : N ;
  borgarfamilj_nn_1_N : N ;
  borgarklass_nn_1_N : N ;
  borgarslaekt_nn_1_1_N : N ;
  borgenaer_nn_1_1_N : N ;
  borgenaersed_nn_1_1_N : N ;
  borgerlighet_nn_1_N : N ;
  borgruin_nn_1_N : N ;
  borkarbid_nn_1_N : N ;
  borrlaengd_nn_1_1_N : N ;
  bortamatch_nn_1_N : N ;
  bortaplan_nn_1_N : N ;
  boskapsmarknad_nn_1_N : N ;
  boskillnad_nn_1_N : N ;
  boson_nn_1_N : N ;
  bostadsadress_nn_1_N : N ;
  bostadsexpert_nn_1_N : N ;
  bostadsinspektion_nn_1_N : N ;
  bostadskooperation_nn_1_N : N ;
  bostadskredit_nn_1_N : N ;
  bostadslaegenhet_nn_1_1_N : N ;
  bostadsmarknad_nn_1_N : N ;
  bostadsnaemnd_nn_1_1_N : N ;
  bostadsproduktion_nn_1_N : N ;
  bostadsraett_nn_1_1_N : N ;
  bostonvals_nn_1_N : N ;
  bosaettningsaffaer_nn_1_1_N : N ;
  bosaettningsort_nn_1_1_N : N ;
  botanist_nn_1_N : N ;
  bottenformation_nn_1_N : N ;
  bottenfaerg_nn_1_1_N : N ;
  bottenkurs_nn_1_N : N ;
  bottenloeshet_nn_1_1_N : N ;
  bottenmagnet_nn_1_N : N ;
  bottensats_nn_1_N : N ;
  bottin_nn_1_N : N ;
  botulism_nn_1_N : N ;
  boudoir_nn_1_N : N ;
  boxningsmatch_nn_1_N : N ;
  brakfest_nn_1_N : N ;
  braksucc_e_nn_1_1_N : N ;
  braman_nn_1_N : N ;
  bramanism_nn_1_N : N ;
  bramin_nn_1_N : N ;
  brandbomb_nn_1_N : N ;
  brandchef_nn_1_N : N ;
  brandingenjoer_nn_1_1_N : N ;
  brandinspektion_nn_1_N : N ;
  brandinspektoer_nn_1_1_N : N ;
  brandkaar_nn_1_1_N : N ;
  brandorsak_nn_1_N : N ;
  brandpost_nn_1_N : N ;
  brandrest_nn_1_N : N ;
  brandskatt_nn_1_N : N ;
  brandstation_nn_1_N : N ;
  brandvakt_nn_1_N : N ;
  bransch_nn_1_N : N ;
  brasilian_nn_1_N : N ;
  bravurroll_nn_1_N : N ;
  breddgrad_nn_1_N : N ;
  breddidrott_nn_1_N : N ;
  breton_nn_1_N : N ;
  brevbomb_nn_1_N : N ;
  brevhemlighet_nn_1_N : N ;
  brevroman_nn_1_N : N ;
  bricklunch_nn_1_N : N ;
  bridreaktor_nn_1_N : N ;
  brigadchef_nn_1_N : N ;
  brigadoer_nn_1_1_N : N ;
  brigantin_nn_1_N : N ;
  briljant_nn_1_N : N ;
  brisans_nn_1_N : N ;
  brisant_nn_1_N : N ;
  brist_nn_1_N : N ;
  bristfaellighet_nn_1_1_N : N ;
  bristsituation_nn_1_N : N ;
  broavgift_nn_1_N : N ;
  brodyr_nn_1_N : N ;
  brodoes_nn_1_1_N : N ;
  brokighet_nn_1_N : N ;
  bromid_nn_1_N : N ;
  bromism_nn_1_N : N ;
  bromsmedicin_nn_1_N : N ;
  bromspedal_nn_1_N : N ;
  bronkit_nn_1_N : N ;
  brons_nn_1_N : N ;
  bronsstaty_nn_1_N : N ;
  bronsstatyett_nn_1_N : N ;
  brosch_nn_1_N : N ;
  broschyr_nn_1_N : N ;
  broskvaevnad_nn_1_1_N : N ;
  brottningskamp_nn_1_N : N ;
  brottningsmatch_nn_1_N : N ;
  brottslighet_nn_1_N : N ;
  brottsplats_nn_1_N : N ;
  brottsplatsexpert_nn_1_N : N ;
  brottsprovokation_nn_1_N : N ;
  bruklighet_nn_1_N : N ;
  brukningsenhet_nn_1_N : N ;
  bruksort_nn_1_N : N ;
  brumkoer_nn_1_1_N : N ;
  brunalg_nn_1_N : N ;
  brunch_nn_1_N : N ;
  brunett_nn_1_N : N ;
  brunnsort_nn_1_N : N ;
  brunoert_nn_1_1_N : N ;
  brutalitet_nn_1_N : N ;
  bruttodraektighet_nn_1_1_N : N ;
  bruttoinkomst_nn_1_N : N ;
  bruttoloen_nn_1_1_N : N ;
  bruttovinst_nn_1_N : N ;
  bryggkant_nn_1_N : N ;
  bryggplats_nn_1_N : N ;
  brylaa_nn_1_1_N : N ;
  bryolog_nn_1_N : N ;
  brytningsperiod_nn_1_N : N ;
  brytningstid_nn_1_N : N ;
  brytpunkt_nn_1_N : N ;
  braennvinsadvokat_nn_1_1_N : N ;
  braenslecellskonstruktion_nn_1_1_N : N ;
  braenslecellstyp_nn_1_1_N : N ;
  braensledepaa_nn_1_1_N : N ;
  braenslegas_nn_1_1_N : N ;
  braenslekris_nn_1_1_N : N ;
  braensletyp_nn_1_1_N : N ;
  braesch_nn_1_1_N : N ;
  braanad_nn_1_1_N : N ;
  broedkant_nn_1_1_N : N ;
  broellopsdikt_nn_1_1_N : N ;
  broellopsfest_nn_1_1_N : N ;
  broellopsgaest_nn_1_1_N : N ;
  broellopsmarsch_nn_1_1_N : N ;
  broellopsplan_nn_1_1_N : N ;
  broellopspoet_nn_1_1_N : N ;
  broellopspresent_nn_1_1_N : N ;
  broestbild_nn_1_1_N : N ;
  broestcancerdiagnos_nn_1_1_N : N ;
  broestkatarr_nn_1_1_N : N ;
  broestkompression_nn_1_1_N : N ;
  broestoperation_nn_1_1_N : N ;
  broestton_nn_1_1_N : N ;
  bubon_nn_1_N : N ;
  budbyraa_nn_1_1_N : N ;
  buddhism_nn_1_N : N ;
  buddhist_nn_1_N : N ;
  buddism_nn_1_N : N ;
  buddist_nn_1_N : N ;
  budgetmotion_nn_1_N : N ;
  budgetproposition_nn_1_N : N ;
  budgetvariant_nn_1_N : N ;
  budoar_nn_1_N : N ;
  buffertkapacitet_nn_1_N : N ;
  buffertstat_nn_1_N : N ;
  bufflighet_nn_1_N : N ;
  buff_e_nn_1_1_N : N ;
  bukhinneinflammation_nn_1_N : N ;
  bukt_nn_1_N : N ;
  bulklast_nn_1_N : N ;
  bulletin_nn_1_N : N ;
  bulnad_nn_1_N : N ;
  bultpistol_nn_1_N : N ;
  bulvan_nn_1_N : N ;
  bulvanverksamhet_nn_1_N : N ;
  bunkringsplats_nn_1_N : N ;
  bunkringsstation_nn_1_N : N ;
  burgarrestaurang_nn_1_N : N ;
  burgerrestaurang_nn_1_N : N ;
  burgund_nn_1_N : N ;
  burlesk_nn_1_N : N ;
  burman_nn_1_N : N ;
  burmes_nn_1_N : N ;
  buskagitation_nn_1_N : N ;
  bussankomst_nn_1_N : N ;
  busschauffoer_nn_1_1_N : N ;
  busshaallplats_nn_1_1_N : N ;
  busslast_nn_1_N : N ;
  busstation_nn_1_N : N ;
  bussterminal_nn_1_N : N ;
  busstidtabell_nn_1_N : N ;
  busstransport_nn_1_N : N ;
  busstur_nn_1_N : N ;
  byff_e_nn_1_1_N : N ;
  bygd_nn_1_N : N ;
  byggarbetsplats_nn_1_N : N ;
  byggdispens_nn_1_N : N ;
  byggkostnad_nn_1_N : N ;
  bygglekplats_nn_1_N : N ;
  byggnad_nn_1_N : N ;
  byggnadskonstruktion_nn_1_N : N ;
  byggnadskredit_nn_1_N : N ;
  byggnadsnaemnd_nn_1_1_N : N ;
  byggnadsplan_nn_1_N : N ;
  byggnadsplats_nn_1_N : N ;
  byggnation_nn_1_N : N ;
  byggnorm_nn_1_N : N ;
  byggplan_nn_1_N : N ;
  byggsats_nn_1_N : N ;
  byggstart_nn_1_N : N ;
  byggtid_nn_1_N : N ;
  bymosk_e_nn_1_1_N : N ;
  byraa_nn_2_1_N : N ;
  byraachef_nn_1_1_N : N ;
  byraadirektoer_nn_1_1_N : N ;
  byraakratism_nn_1_1_N : N ;
  bysamfaellighet_nn_1_1_N : N ;
  bysantin_nn_1_N : N ;
  bysantinism_nn_1_N : N ;
  byst_nn_1_N : N ;
  bytesaffaer_nn_1_1_N : N ;
  byteslaegenhet_nn_1_1_N : N ;
  byxdraekt_nn_1_1_N : N ;
  baeckravin_nn_1_1_N : N ;
  baenkplats_nn_1_1_N : N ;
  baenkrad_nn_1_1_N : N ;
  baerfrekvens_nn_1_1_N : N ;
  baergarloen_nn_1_1_N : N ;
  baermark_nn_1_1_N : N ;
  baernaes_nn_1_1_N : N ;
  baernaessaas_nn_1_1_N : N ;
  baevernylonoverall_nn_1_1_N : N ;
  baagform_nn_1_1_N : N ;
  baagfris_nn_1_1_N : N ;
  baagminut_nn_1_1_N : N ;
  baalvaext_nn_1_1_N : N ;
  baatankomst_nn_1_1_N : N ;
  baatfaerd_nn_1_1_N : N ;
  baatlaegenhet_nn_1_1_N : N ;
  baatmotor_nn_1_1_N : N ;
  baatnad_nn_1_1_N : N ;
  baatplats_nn_1_1_N : N ;
  baatterminal_nn_1_1_N : N ;
  baattidtabell_nn_1_1_N : N ;
  baattransport_nn_1_1_N : N ;
  baattur_nn_1_1_N : N ;
  b_earnaisesaas_nn_1_1_N : N ;
  boejhaallfasthet_nn_1_1_N : N ;
  boejningsform_nn_1_1_N : N ;
  boen_nn_1_1_N : N ;
  boenegudstjaenst_nn_1_1_N : N ;
  boeneramp_nn_1_1_N : N ;
  boeneskrift_nn_1_1_N : N ;
  boenestund_nn_1_1_N : N ;
  boenvaext_nn_1_1_N : N ;
  boers_nn_2_1_N : N ;
  boersanalys_nn_1_1_N : N ;
  boerskrasch_nn_1_1_N : N ;
  boerskurs_nn_1_1_N : N ;
  boersspekulant_nn_1_1_N : N ;
  boersspekulation_nn_1_1_N : N ;
  boerstelegraf_nn_1_1_N : N ;
  calvados_nn_1_N : N ;
  campingplats_nn_1_N : N ;
  cancerform_nn_1_N : N ;
  cancerogen_nn_1_N : N ;
  cancerrisk_nn_1_N : N ;
  cancersvulst_nn_1_N : N ;
  carcinogen_nn_1_N : N ;
  celebritet_nn_1_N : N ;
  cellist_nn_1_N : N ;
  cellstruktur_nn_1_N : N ;
  celltyp_nn_1_N : N ;
  cellulosaetanol_nn_1_N : N ;
  cellulosafabrik_nn_1_N : N ;
  cellulosamolekyl_nn_1_N : N ;
  cellulosaplast_nn_1_N : N ;
  celsiusgrad_nn_1_N : N ;
  celt_nn_1_N : N ;
  cembalist_nn_1_N : N ;
  cementfaerg_nn_1_1_N : N ;
  censor_nn_1_N : N ;
  centerism_nn_1_N : N ;
  centerpartist_nn_1_N : N ;
  centerprofil_nn_1_N : N ;
  central_nn_1_N : N ;
  centralafrikan_nn_1_N : N ;
  centralanstalt_nn_1_N : N ;
  centralantenn_nn_1_N : N ;
  centralbankschef_nn_1_N : N ;
  centralbyggnad_nn_1_N : N ;
  centralbyraa_nn_1_1_N : N ;
  centralenhet_nn_1_N : N ;
  centralfigur_nn_1_N : N ;
  centralism_nn_1_N : N ;
  centralkommitt_e_nn_1_1_N : N ;
  centralmakt_nn_1_N : N ;
  centralnaemnd_nn_1_1_N : N ;
  centralorganisation_nn_1_N : N ;
  centralort_nn_1_N : N ;
  centralpunkt_nn_1_N : N ;
  centralstation_nn_1_N : N ;
  cesarism_nn_1_N : N ;
  cession_nn_1_N : N ;
  cesur_nn_1_N : N ;
  champinjon_nn_1_N : N ;
  chans_nn_1_N : N ;
  chanson_nn_1_N : N ;
  chansonett_nn_1_N : N ;
  charabang_nn_1_N : N ;
  charad_nn_1_N : N ;
  charg_e_d_affaires_nn_1_1_N : N ;
  charkuterist_nn_1_N : N ;
  charlatan_nn_1_N : N ;
  charmkurs_nn_1_N : N ;
  charmloeshet_nn_1_1_N : N ;
  charmoffensiv_nn_1_N : N ;
  charmoer_nn_1_1_N : N ;
  charterturist_nn_1_N : N ;
  chassidism_nn_1_N : N ;
  chattkonversation_nn_1_N : N ;
  chauffoer_nn_1_1_N : N ;
  chauss_e_nn_1_1_N : N ;
  chauvinism_nn_1_N : N ;
  chauvinist_nn_1_N : N ;
  checkkredit_nn_1_N : N ;
  checkloen_nn_1_1_N : N ;
  chefredaktoer_nn_1_1_N : N ;
  chefsekonom_nn_1_N : N ;
  chefsideolog_nn_1_N : N ;
  chefskirurg_nn_1_N : N ;
  chefsmikrobiolog_nn_1_N : N ;
  chemis_nn_1_N : N ;
  chiffong_nn_1_N : N ;
  chiffonj_e_nn_1_1_N : N ;
  chikan_nn_1_N : N ;
  chilen_nn_1_N : N ;
  chimpans_nn_1_N : N ;
  chimaer_nn_1_1_N : N ;
  chinjong_nn_1_N : N ;
  chockbild_nn_1_N : N ;
  chockfas_nn_1_N : N ;
  choklad_nn_1_N : N ;
  ciceron_nn_1_N : N ;
  cigarettaendarkontakt_nn_1_1_N : N ;
  cigarill_nn_1_N : N ;
  cigarrettaendarkontakt_nn_1_1_N : N ;
  cigarrill_nn_1_N : N ;
  cineast_nn_1_N : N ;
  cirkeldefinition_nn_1_N : N ;
  cirkelprocess_nn_1_N : N ;
  cirkelsektor_nn_1_N : N ;
  cirkulation_nn_1_N : N ;
  cirkulationsplats_nn_1_N : N ;
  cirkumflex_nn_1_N : N ;
  cirkusartist_nn_1_N : N ;
  cirkusbyggnad_nn_1_N : N ;
  cisterciens_nn_1_N : N ;
  citation_nn_1_N : N ;
  citrin_nn_1_N : N ;
  citroen_nn_1_N : N ;
  citron_nn_1_N : N ;
  citrondoft_nn_1_N : N ;
  civilekonom_nn_1_N : N ;
  civilingenjoer_nn_1_1_N : N ;
  civilisation_nn_1_N : N ;
  civilist_nn_1_N : N ;
  civilprocess_nn_1_N : N ;
  clairobscur_nn_1_N : N ;
  clementin_nn_1_N : N ;
  cloqu_e_nn_1_1_N : N ;
  colombian_nn_1_N : N ;
  consensuskultur_nn_1_N : N ;
  consomm_e_nn_1_1_N : N ;
  coronacell_nn_1_N : N ;
  costarican_nn_1_N : N ;
  cotangent_nn_1_N : N ;
  coverversion_nn_1_N : N ;
  croissant_nn_1_N : N ;
  croquis_nn_1_N : N ;
  cuban_nn_1_N : N ;
  cumuluscell_nn_1_N : N ;
  curator_nn_1_N : N ;
  curlingfinal_nn_1_N : N ;
  cyanid_nn_1_N : N ;
  cyberbrottslighet_nn_1_N : N ;
  cykelstoeld_nn_1_1_N : N ;
  cykelutflykt_nn_1_N : N ;
  cyklist_nn_1_N : N ;
  cykloid_nn_1_N : N ;
  cyklon_nn_1_N : N ;
  cyklonfamilj_nn_1_N : N ;
  cyklotron_nn_1_N : N ;
  cymbal_nn_1_N : N ;
  cynism_nn_1_N : N ;
  cypress_nn_1_N : N ;
  dadaism_nn_1_N : N ;
  dadaist_nn_1_N : N ;
  dagloen_nn_1_1_N : N ;
  dagort_nn_1_N : N ;
  dagsled_nn_1_N : N ;
  dagsmarsch_nn_1_N : N ;
  dagsnyhet_nn_1_N : N ;
  dagstemperatur_nn_1_N : N ;
  dagstidningsredaktoer_nn_1_1_N : N ;
  dagsvers_nn_1_N : N ;
  daktyl_nn_1_N : N ;
  daldans_nn_1_N : N ;
  dam_nn_1_N : N ;
  damask_nn_1_N : N ;
  damast_nn_1_N : N ;
  damfrisoer_nn_1_1_N : N ;
  damkoer_nn_1_1_N : N ;
  dampjaes_nn_1_1_N : N ;
  danism_nn_1_N : N ;
  dans_nn_1_N : N ;
  dansbandskultur_nn_1_N : N ;
  danskonst_nn_1_N : N ;
  danslektion_nn_1_N : N ;
  dansrestaurang_nn_1_N : N ;
  dansrytm_nn_1_N : N ;
  danssalong_nn_1_N : N ;
  dansoes_nn_1_1_N : N ;
  darwinism_nn_1_N : N ;
  darwinist_nn_1_N : N ;
  dat_nn_1_N : N ;
  databas_nn_1_N : N ;
  datainsamlingskampanj_nn_1_N : N ;
  dataintraangsskandal_nn_1_1_N : N ;
  datakommunikation_nn_1_N : N ;
  datamaengd_nn_1_1_N : N ;
  dataterminal_nn_1_N : N ;
  dativ_nn_1_N : N ;
  dator_nn_1_N : N ;
  datoradress_nn_1_N : N ;
  datortelefon_nn_1_N : N ;
  datumgraens_nn_1_1_N : N ;
  debilitet_nn_1_N : N ;
  debit_nn_1_N : N ;
  debut_nn_1_N : N ;
  debutant_nn_1_N : N ;
  debutroman_nn_1_N : N ;
  decentralisation_nn_1_N : N ;
  dedikation_nn_1_N : N ;
  deduktion_nn_1_N : N ;
  defaitism_nn_1_N : N ;
  defaitist_nn_1_N : N ;
  defekt_nn_1_N : N ;
  defil_e_nn_1_1_N : N ;
  definition_nn_1_N : N ;
  deflagration_nn_1_N : N ;
  deflation_nn_1_N : N ;
  defloration_nn_1_N : N ;
  deformation_nn_1_N : N ;
  deformitet_nn_1_N : N ;
  degeneration_nn_1_N : N ;
  deglaciation_nn_1_N : N ;
  degradation_nn_1_N : N ;
  degression_nn_1_N : N ;
  deism_nn_1_N : N ;
  deist_nn_1_N : N ;
  dekan_nn_1_N : N ;
  deklamation_nn_1_N : N ;
  deklarant_nn_1_N : N ;
  deklaration_nn_1_N : N ;
  deklination_nn_1_N : N ;
  dekoration_nn_1_N : N ;
  dekorationslist_nn_1_N : N ;
  delaktighet_nn_1_N : N ;
  delativ_nn_1_N : N ;
  delegation_nn_1_N : N ;
  delfin_nn_1_N : N ;
  delikatess_nn_1_N : N ;
  delirant_nn_1_N : N ;
  delkultur_nn_1_N : N ;
  dellikvid_nn_1_N : N ;
  delmaengd_nn_1_1_N : N ;
  delstat_nn_1_N : N ;
  demarsch_nn_1_N : N ;
  demenspatient_nn_1_N : N ;
  demensrisk_nn_1_N : N ;
  demission_nn_1_N : N ;
  demokratism_nn_1_N : N ;
  demon_nn_1_N : N ;
  demonstrant_nn_1_N : N ;
  demonstration_nn_1_N : N ;
  demonstrationsfrihet_nn_1_N : N ;
  demonstratris_nn_1_N : N ;
  demoralisation_nn_1_N : N ;
  denar_nn_1_N : N ;
  denaturalisation_nn_1_N : N ;
  dendrit_nn_1_N : N ;
  dendrolog_nn_1_N : N ;
  denotation_nn_1_N : N ;
  densitet_nn_1_N : N ;
  dentist_nn_1_N : N ;
  denudation_nn_1_N : N ;
  deodorant_nn_1_N : N ;
  departementschef_nn_1_N : N ;
  depens_nn_1_N : N ;
  depersonalisation_nn_1_N : N ;
  depesch_nn_1_N : N ;
  depeschbyraa_nn_1_1_N : N ;
  depolarisator_nn_1_N : N ;
  deportation_nn_1_N : N ;
  deportationsort_nn_1_N : N ;
  deposition_nn_1_N : N ;
  depravation_nn_1_N : N ;
  depression_nn_1_N : N ;
  depressionsdiagnos_nn_1_N : N ;
  deprivation_nn_1_N : N ;
  deputation_nn_1_N : N ;
  depaa_nn_1_1_N : N ;
  derivation_nn_1_N : N ;
  dermatit_nn_1_N : N ;
  dermatolog_nn_1_N : N ;
  dervisch_nn_1_N : N ;
  dervischdans_nn_1_N : N ;
  desegregation_nn_1_N : N ;
  deshabill_e_nn_1_1_N : N ;
  designstudent_nn_1_N : N ;
  desillusion_nn_1_N : N ;
  desinfektion_nn_1_N : N ;
  desinformation_nn_1_N : N ;
  desinsektion_nn_1_N : N ;
  desintegration_nn_1_N : N ;
  deskription_nn_1_N : N ;
  desorganisation_nn_1_N : N ;
  desperation_nn_1_N : N ;
  despotism_nn_1_N : N ;
  dessertsaas_nn_1_1_N : N ;
  destillation_nn_1_N : N ;
  destination_nn_1_N : N ;
  destinationsort_nn_1_N : N ;
  destruktion_nn_1_N : N ;
  detaljist_nn_1_N : N ;
  detaljplan_nn_1_N : N ;
  detektiv_nn_1_N : N ;
  detektivroman_nn_1_N : N ;
  detektor_nn_1_N : N ;
  determination_nn_1_N : N ;
  determinism_nn_1_N : N ;
  determinist_nn_1_N : N ;
  detonation_nn_1_N : N ;
  detonationshastighet_nn_1_N : N ;
  detonationszon_nn_1_N : N ;
  detonator_nn_1_N : N ;
  deuteron_nn_1_N : N ;
  deutron_nn_1_N : N ;
  deviation_nn_1_N : N ;
  devis_nn_1_N : N ;
  diabas_nn_1_N : N ;
  diabild_nn_1_N : N ;
  diagnos_nn_1_N : N ;
  diakon_nn_1_N : N ;
  diakonissanstalt_nn_1_N : N ;
  dialektolog_nn_1_N : N ;
  dialog_nn_1_N : N ;
  dialys_nn_1_N : N ;
  diamant_nn_1_N : N ;
  diarr_e_nn_1_1_N : N ;
  diastas_nn_1_N : N ;
  dieselgenerator_nn_1_N : N ;
  dieselhybrid_nn_1_N : N ;
  dieselmotor_nn_1_N : N ;
  dietist_nn_1_N : N ;
  differens_nn_1_N : N ;
  differentialekvation_nn_1_N : N ;
  differentialkalkyl_nn_1_N : N ;
  diffraktion_nn_1_N : N ;
  diffusion_nn_1_N : N ;
  digestion_nn_1_N : N ;
  dignitet_nn_1_N : N ;
  dignitaer_nn_1_1_N : N ;
  digression_nn_1_N : N ;
  diklin_nn_1_N : N ;
  dikotyledon_nn_1_N : N ;
  dikt_nn_1_N : N ;
  diktafon_nn_1_N : N ;
  diktarfursteroll_nn_1_N : N ;
  diktargrupp_nn_1_N : N ;
  diktart_nn_1_N : N ;
  diktator_nn_1_N : N ;
  diktatur_nn_1_N : N ;
  diktaturregim_nn_1_N : N ;
  diktion_nn_1_N : N ;
  dikvaeveoxid_nn_1_1_N : N ;
  dilatation_nn_1_N : N ;
  dilettant_nn_1_N : N ;
  dilettantism_nn_1_N : N ;
  diligens_nn_1_N : N ;
  dillsaas_nn_1_1_N : N ;
  dimension_nn_1_N : N ;
  dimission_nn_1_N : N ;
  dimorfism_nn_1_N : N ;
  dimridaa_nn_1_1_N : N ;
  dinosaur_nn_1_N : N ;
  dinosaurieart_nn_1_N : N ;
  din_e_nn_1_1_N : N ;
  diod_nn_1_N : N ;
  diorit_nn_1_N : N ;
  dioskur_nn_1_N : N ;
  diplomingenjoer_nn_1_1_N : N ;
  dipol_nn_1_N : N ;
  dipsoman_nn_1_N : N ;
  diptyk_nn_1_N : N ;
  direkthet_nn_1_N : N ;
  direktion_nn_1_N : N ;
  direktor_nn_1_N : N ;
  direktris_nn_1_N : N ;
  direktoer_nn_1_1_N : N ;
  dirigism_nn_1_N : N ;
  dis_nn_2_N : N ;
  disackarid_nn_1_N : N ;
  disciplin_nn_1_N : N ;
  disciplingraens_nn_1_1_N : N ;
  disciplinpaafoeljd_nn_1_1_N : N ;
  disjunktion_nn_1_N : N ;
  diskant_nn_1_N : N ;
  diskmaskin_nn_1_N : N ;
  diskontinuitet_nn_1_N : N ;
  diskordans_nn_1_N : N ;
  diskrepans_nn_1_N : N ;
  diskretion_nn_1_N : N ;
  diskurs_nn_1_N : N ;
  diskussion_nn_1_N : N ;
  diskvalifikation_nn_1_N : N ;
  dislokation_nn_1_N : N ;
  dispasch_nn_1_N : N ;
  dispaschoer_nn_1_1_N : N ;
  dispens_nn_1_N : N ;
  dispersion_nn_1_N : N ;
  disponibilitet_nn_1_N : N ;
  disposition_nn_1_N : N ;
  dispositionsfond_nn_1_N : N ;
  disproportion_nn_1_N : N ;
  disputation_nn_1_N : N ;
  dissektion_nn_1_N : N ;
  dissertation_nn_1_N : N ;
  dissimilation_nn_1_N : N ;
  dissociation_nn_1_N : N ;
  dissonans_nn_1_N : N ;
  dissonant_nn_1_N : N ;
  distans_nn_1_N : N ;
  distinktion_nn_1_N : N ;
  distorsion_nn_1_N : N ;
  distraktion_nn_1_N : N ;
  distraktor_nn_1_N : N ;
  distribution_nn_1_N : N ;
  disoes_nn_1_1_N : N ;
  divan_nn_1_N : N ;
  divergens_nn_1_N : N ;
  diversion_nn_1_N : N ;
  divis_nn_1_N : N ;
  division_nn_1_N : N ;
  divisionschef_nn_1_N : N ;
  divisor_nn_1_N : N ;
  djupbild_nn_1_N : N ;
  djupdimension_nn_1_N : N ;
  djupsinnighet_nn_1_N : N ;
  djupstruktur_nn_1_N : N ;
  djurart_nn_1_N : N ;
  djurbok_nn_1_N : N ;
  djurgrupp_nn_1_N : N ;
  djurraettsaktivist_nn_1_1_N : N ;
  djurskyddsinspektoer_nn_1_1_N : N ;
  djaeklighet_nn_1_1_N : N ;
  djaervhet_nn_1_1_N : N ;
  djaevlighet_nn_1_1_N : N ;
  dna_molekyl_nn_1_N : N ;
  dna_sekvens_nn_1_N : N ;
  doakoer_nn_1_1_N : N ;
  docentur_nn_1_N : N ;
  dogmatism_nn_1_N : N ;
  doktor_nn_1_N : N ;
  doktorand_nn_1_N : N ;
  doktorsdisputation_nn_1_N : N ;
  doktorsgrad_nn_1_N : N ;
  doktorspromotion_nn_1_N : N ;
  doktrin_nn_1_N : N ;
  doktrinarism_nn_1_N : N ;
  dokumentalist_nn_1_N : N ;
  dokumentation_nn_1_N : N ;
  dokumentaer_nn_1_1_N : N ;
  dokumentaerfilm_nn_1_1_N : N ;
  dokumentaerroman_nn_1_1_N : N ;
  dolkstoetslegend_nn_1_1_N : N ;
  dollarturist_nn_1_N : N ;
  dolomit_nn_1_N : N ;
  domared_nn_1_N : N ;
  domaredans_nn_1_N : N ;
  domarkaar_nn_1_1_N : N ;
  domarornat_nn_1_N : N ;
  domarpost_nn_1_N : N ;
  dombok_nn_1_N : N ;
  domedagspredikant_nn_1_N : N ;
  dominant_nn_1_N : N ;
  dominikan_nn_1_N : N ;
  domptoersfason_nn_1_1_N : N ;
  domaenintendent_nn_1_1_N : N ;
  donation_nn_1_N : N ;
  donator_nn_1_N : N ;
  dopattest_nn_1_N : N ;
  dos_nn_1_N : N ;
  dossi_e_nn_1_1_N : N ;
  dotation_nn_1_N : N ;
  dottercell_nn_1_N : N ;
  dottersvulst_nn_1_N : N ;
  doubl_e_nn_2_1_N : N ;
  doyen_nn_1_N : N ;
  drabant_nn_1_N : N ;
  drabantstat_nn_1_N : N ;
  dragenhet_nn_2_N : N ;
  draghaallfasthet_nn_1_1_N : N ;
  dragoman_nn_1_N : N ;
  dragon_nn_1_N : N ;
  drag_e_nn_1_1_N : N ;
  dramaturg_nn_1_N : N ;
  dressin_nn_1_N : N ;
  drevjakt_nn_1_N : N ;
  driftkostnad_nn_1_N : N ;
  driftskostnad_nn_1_N : N ;
  drifttid_nn_1_N : N ;
  drivkraft_nn_1_N : N ;
  droppinfektion_nn_1_N : N ;
  druid_nn_1_N : N ;
  drullighet_nn_1_N : N ;
  drumlighet_nn_1_N : N ;
  drus_nn_1_N : N ;
  dryck_nn_1_N : N ;
  dryckesservis_nn_1_N : N ;
  dryghet_nn_1_N : N ;
  draekt_nn_1_1_N : N ;
  draektighet_nn_1_1_N : N ;
  draengtjaenst_nn_1_1_N : N ;
  draetselnaemnd_nn_1_1_N : N ;
  draaplighet_nn_1_1_N : N ;
  droembild_nn_1_1_N : N ;
  droembok_nn_1_1_N : N ;
  droemgraens_nn_1_1_N : N ;
  droemstart_nn_1_1_N : N ;
  droemsyn_nn_1_1_N : N ;
  droemtydningsbok_nn_1_1_N : N ;
  droenarattack_nn_1_1_N : N ;
  droenarraed_nn_1_1_N : N ;
  dualism_nn_1_N : N ;
  dualist_nn_1_N : N ;
  dubbelbeckasin_nn_1_N : N ;
  dubbelhet_nn_1_N : N ;
  dubbelkontakt_nn_1_N : N ;
  dubbelkoer_nn_1_1_N : N ;
  dubbelmadrass_nn_1_N : N ;
  dubbelnatur_nn_1_N : N ;
  dubbelrevolution_nn_1_N : N ;
  dubbelroll_nn_1_N : N ;
  dubbelspaarsutbyggnad_nn_1_1_N : N ;
  dubblett_nn_1_N : N ;
  dubbl_e_nn_2_1_N : N ;
  dublett_nn_1_N : N ;
  duellant_nn_1_N : N ;
  duglighet_nn_1_N : N ;
  dukt_nn_1_N : N ;
  dulcian_nn_1_N : N ;
  dumhet_nn_1_N : N ;
  dumskallemajoritet_nn_1_N : N ;
  dunkelhet_nn_1_N : N ;
  dunst_nn_1_N : N ;
  duodes_nn_1_N : N ;
  duplexfaerg_nn_1_1_N : N ;
  duplikator_nn_1_N : N ;
  dureform_nn_1_N : N ;
  duroplast_nn_1_N : N ;
  duschkraem_nn_1_1_N : N ;
  dussinroman_nn_1_N : N ;
  dust_nn_1_N : N ;
  dvd_film_nn_1_N : N ;
  dvaerggalax_nn_1_1_N : N ;
  dvaergschimpans_nn_1_1_N : N ;
  dygd_nn_1_N : N ;
  dygnsrytm_nn_1_N : N ;
  dykardraekt_nn_1_1_N : N ;
  dynamism_nn_1_N : N ;
  dyrbarhet_nn_1_N : N ;
  dyrort_nn_1_N : N ;
  dyrortsgrupp_nn_1_N : N ;
  dys_nn_1_N : N ;
  dysterhet_nn_1_N : N ;
  daeckdimension_nn_1_1_N : N ;
  daeckslast_nn_1_1_N : N ;
  daeggdjursgrupp_nn_1_1_N : N ;
  daeggdjurstyp_nn_1_1_N : N ;
  daalighet_nn_1_1_N : N ;
  daaraktighet_nn_1_1_N : N ;
  daasighet_nn_1_1_N : N ;
  doedlighet_nn_1_1_N : N ;
  doedsannons_nn_1_1_N : N ;
  doedsattest_nn_1_1_N : N ;
  doedsdans_nn_1_1_N : N ;
  doedsfas_nn_1_1_N : N ;
  doedskrasch_nn_1_1_N : N ;
  doedsmask_nn_1_1_N : N ;
  doedsorsak_nn_1_1_N : N ;
  doedsstelhet_nn_1_1_N : N ;
  doedsstund_nn_1_1_N : N ;
  doedstystnad_nn_1_1_N : N ;
  doerrfaerg_nn_1_1_N : N ;
  doerrknackningskampanj_nn_1_1_N : N ;
  doerrpost_nn_1_1_N : N ;
  doerrvakt_nn_1_1_N : N ;
  doevhet_nn_1_1_N : N ;
  e_bok_nn_1_N : N ;
  e_tidskrift_nn_1_N : N ;
  e_vetenskap_nn_1_N : N ;
  ebenist_nn_1_N : N ;
  ecuadorian_nn_1_N : N ;
  edition_nn_1_N : N ;
  efemerid_nn_1_N : N ;
  effektfaktor_nn_1_N : N ;
  effektivitet_nn_1_N : N ;
  efterbild_nn_1_N : N ;
  efterboers_nn_1_1_N : N ;
  efterfest_nn_1_N : N ;
  eftergivenhet_nn_1_N : N ;
  efterhandskonstruktion_nn_1_N : N ;
  efterkonstruktion_nn_1_N : N ;
  efterkontroll_nn_1_N : N ;
  efterkrigstid_nn_1_N : N ;
  efterlevnad_nn_1_N : N ;
  eftermiddagssejour_nn_1_N : N ;
  efterraett_nn_1_1_N : N ;
  eftersats_nn_1_N : N ;
  efterskrift_nn_1_N : N ;
  egalitet_nn_1_N : N ;
  egendomlighet_nn_1_N : N ;
  egendomsaffaer_nn_1_1_N : N ;
  egenfrekvens_nn_1_N : N ;
  egenhet_nn_1_N : N ;
  egenskapsgenitiv_nn_1_N : N ;
  egocentricitet_nn_1_N : N ;
  egoism_nn_1_N : N ;
  egoist_nn_1_N : N ;
  egotism_nn_1_N : N ;
  egyptolog_nn_1_N : N ;
  ejakulation_nn_1_N : N ;
  ejektor_nn_1_N : N ;
  ekiperingsaffaer_nn_1_1_N : N ;
  eklekticism_nn_1_N : N ;
  eklips_nn_1_N : N ;
  ekolobby_nn_1_N : N ;
  ekolog_nn_1_N : N ;
  ekonom_nn_1_N : N ;
  ekonomibyggnad_nn_1_N : N ;
  ekonomichef_nn_1_N : N ;
  ekonomikroenikoer_nn_1_1_N : N ;
  ekoturist_nn_1_N : N ;
  ekumenism_nn_1_N : N ;
  ekvation_nn_1_N : N ;
  ekvatorialguinean_nn_1_N : N ;
  ekvilibrist_nn_1_N : N ;
  ekvivalent_nn_1_N : N ;
  elakhet_nn_1_N : N ;
  elandantilop_nn_1_N : N ;
  elasticitet_nn_1_N : N ;
  elasticitetsgraens_nn_1_1_N : N ;
  elativ_nn_1_N : N ;
  elbilspionjaer_nn_1_1_N : N ;
  elboers_nn_1_1_N : N ;
  eldhastighet_nn_1_N : N ;
  eldsats_nn_1_N : N ;
  eldsignal_nn_1_N : N ;
  eldstod_nn_1_N : N ;
  eldstrid_nn_1_N : N ;
  elefant_nn_1_N : N ;
  elektor_nn_1_N : N ;
  elektorsroest_nn_1_1_N : N ;
  elektricitet_nn_1_N : N ;
  elektricitetsmaengd_nn_1_1_N : N ;
  elektrikermejselsats_nn_1_N : N ;
  elektroingenjoer_nn_1_1_N : N ;
  elektrolys_nn_1_N : N ;
  elektromagnet_nn_1_N : N ;
  elektromagnetism_nn_1_N : N ;
  elektromotor_nn_1_N : N ;
  elektron_nn_1_N : N ;
  elektronegativitet_nn_1_N : N ;
  elektronmikroskopbild_nn_1_N : N ;
  elektrostriktion_nn_1_N : N ;
  elementarbok_nn_1_N : N ;
  elementfaerg_nn_1_1_N : N ;
  elevation_nn_1_N : N ;
  elevator_nn_1_N : N ;
  elgenerator_nn_1_N : N ;
  elhybrid_nn_1_N : N ;
  elimination_nn_1_N : N ;
  elision_nn_1_N : N ;
  elit_nn_1_N : N ;
  elitidrott_nn_1_N : N ;
  elitism_nn_1_N : N ;
  elitkaar_nn_1_1_N : N ;
  elitsoldat_nn_1_N : N ;
  ellips_nn_1_N : N ;
  ellipsoid_nn_1_N : N ;
  elmarknad_nn_1_N : N ;
  elmotor_nn_1_N : N ;
  elongation_nn_1_N : N ;
  elpistol_nn_1_N : N ;
  elusion_nn_1_N : N ;
  elvispfabrik_nn_1_N : N ;
  emaljfaerg_nn_1_1_N : N ;
  emanation_nn_1_N : N ;
  emancipation_nn_1_N : N ;
  embryolog_nn_1_N : N ;
  emendation_nn_1_N : N ;
  emigrant_nn_1_N : N ;
  emigration_nn_1_N : N ;
  eminens_nn_1_N : N ;
  emission_nn_1_N : N ;
  emissionskurs_nn_1_N : N ;
  emollition_nn_1_N : N ;
  emotion_nn_1_N : N ;
  empirism_nn_1_N : N ;
  empirist_nn_1_N : N ;
  emulsion_nn_1_N : N ;
  emulsionsfaerg_nn_1_1_N : N ;
  encefalit_nn_1_N : N ;
  encyklopedist_nn_1_N : N ;
  endokrinolog_nn_1_N : N ;
  endonym_nn_1_N : N ;
  energidryck_nn_1_N : N ;
  energieffektivitet_nn_1_N : N ;
  energiform_nn_1_N : N ;
  energifoerlust_nn_1_1_N : N ;
  energikoncentration_nn_1_N : N ;
  energimarknad_nn_1_N : N ;
  energimix_nn_1_N : N ;
  energimaengd_nn_1_1_N : N ;
  energiskatt_nn_1_N : N ;
  energivinst_nn_1_N : N ;
  enfoeraeldersfamilj_nn_1_1_N : N ;
  engelskakurs_nn_1_N : N ;
  engelskalektion_nn_1_N : N ;
  engelskkurs_nn_1_N : N ;
  engelsklektion_nn_1_N : N ;
  englergrad_nn_1_N : N ;
  engrossist_nn_1_N : N ;
  engaangsdos_nn_1_1_N : N ;
  engaangskostnad_nn_1_1_N : N ;
  engaangsskatt_nn_1_1_N : N ;
  enhet_nn_1_N : N ;
  enhetslast_nn_1_N : N ;
  enhetsvektor_nn_1_N : N ;
  enighet_nn_1_N : N ;
  enkelbeckasin_nn_1_N : N ;
  enkelhet_nn_1_N : N ;
  enkelrad_nn_1_N : N ;
  enkaet_nn_1_1_N : N ;
  enmanspublik_nn_1_N : N ;
  enpartistat_nn_1_N : N ;
  enpersonsfamilj_nn_1_N : N ;
  enrumslaegenhet_nn_1_1_N : N ;
  ensak_nn_1_N : N ;
  ensamhet_nn_1_N : N ;
  ensamraett_nn_1_1_N : N ;
  enskildhet_nn_1_N : N ;
  entent_nn_1_N : N ;
  entitet_nn_1_N : N ;
  entomolog_nn_1_N : N ;
  entresol_nn_1_N : N ;
  entresoll_nn_1_N : N ;
  entr_e_nn_1_1_N : N ;
  entr_eavgift_nn_1_1_N : N ;
  entr_eraett_nn_1_1_N : N ;
  entusiast_nn_1_N : N ;
  entydighet_nn_1_N : N ;
  enumeration_nn_1_N : N ;
  environg_nn_1_N : N ;
  envaegskommunikation_nn_1_1_N : N ;
  envaaningsbarack_nn_1_1_N : N ;
  eon_nn_1_N : N ;
  epatraktor_nn_1_N : N ;
  epidemolog_nn_1_N : N ;
  epiduralblockad_nn_1_N : N ;
  epifys_nn_1_N : N ;
  epigon_nn_1_N : N ;
  epikurism_nn_1_N : N ;
  epistyl_nn_1_N : N ;
  epitelcell_nn_1_N : N ;
  erbarmlighet_nn_1_N : N ;
  erektion_nn_1_N : N ;
  eremit_nn_1_N : N ;
  erfarenhet_nn_1_N : N ;
  erfarenhetsbank_nn_1_N : N ;
  erfarenhetssfaer_nn_1_1_N : N ;
  ergativ_nn_1_N : N ;
  eritrean_nn_1_N : N ;
  erosion_nn_1_N : N ;
  erotoman_nn_1_N : N ;
  ersaettningsnivaa_nn_1_1_N : N ;
  eruption_nn_1_N : N ;
  eskalation_nn_1_N : N ;
  eskapism_nn_1_N : N ;
  eskimaa_nn_1_1_N : N ;
  esperantist_nn_1_N : N ;
  esprit_nn_2_N : N ;
  essayist_nn_1_N : N ;
  essayistik_nn_1_N : N ;
  essens_nn_2_N : N ;
  essiv_nn_1_N : N ;
  essaebok_nn_1_1_N : N ;
  essaeist_nn_1_1_N : N ;
  est_nn_1_N : N ;
  esterplast_nn_1_N : N ;
  esteticism_nn_1_N : N ;
  estrad_nn_1_N : N ;
  estradartist_nn_1_N : N ;
  eterisation_nn_1_N : N ;
  eternell_nn_1_N : N ;
  etnicitet_nn_1_N : N ;
  etnocentrism_nn_1_N : N ;
  etnolog_nn_1_N : N ;
  etolog_nn_1_N : N ;
  etrusk_nn_1_N : N ;
  ettrumslaegenhet_nn_1_1_N : N ;
  etyd_nn_1_N : N ;
  etymolog_nn_1_N : N ;
  eudemonism_nn_1_N : N ;
  eufemism_nn_1_N : N ;
  eumenid_nn_1_N : N ;
  eurokalabalik_nn_1_N : N ;
  eurokommunism_nn_1_N : N ;
  eurokris_nn_1_N : N ;
  europaboers_nn_1_1_N : N ;
  europid_nn_1_N : N ;
  eurovision_nn_1_N : N ;
  evangeliebok_nn_1_N : N ;
  evangelietext_nn_1_N : N ;
  evangelisation_nn_1_N : N ;
  evangelist_nn_1_N : N ;
  evaporation_nn_1_N : N ;
  eventualitet_nn_1_N : N ;
  evighet_nn_1_N : N ;
  evolution_nn_1_N : N ;
  evolutionism_nn_1_N : N ;
  evolutionist_nn_1_N : N ;
  evolutionsbiolog_nn_1_N : N ;
  evolutionsmekanism_nn_1_N : N ;
  exakthet_nn_1_N : N ;
  exaltation_nn_1_N : N ;
  examensuppgift_nn_1_N : N ;
  examination_nn_1_N : N ;
  examinator_nn_1_N : N ;
  excellens_nn_1_N : N ;
  excentricitet_nn_1_N : N ;
  excerpist_nn_1_N : N ;
  excess_nn_1_N : N ;
  excision_nn_1_N : N ;
  excitation_nn_1_N : N ;
  exekution_nn_1_N : N ;
  exekutionspluton_nn_1_N : N ;
  exekutiv_nn_1_N : N ;
  exekutor_nn_1_N : N ;
  exempelloeshet_nn_1_1_N : N ;
  exemplifikation_nn_1_N : N ;
  exercis_nn_1_N : N ;
  exhibitionism_nn_1_N : N ;
  exhibitionist_nn_1_N : N ;
  existens_nn_1_N : N ;
  existensform_nn_1_N : N ;
  existentialism_nn_1_N : N ;
  exklamation_nn_1_N : N ;
  exklav_nn_1_N : N ;
  exklusivitet_nn_1_N : N ;
  exkommunikation_nn_1_N : N ;
  exkretion_nn_1_N : N ;
  exkurs_nn_1_N : N ;
  exkursion_nn_1_N : N ;
  exonym_nn_1_N : N ;
  exorcism_nn_1_N : N ;
  exorcist_nn_1_N : N ;
  exotism_nn_1_N : N ;
  expansion_nn_1_N : N ;
  expansionism_nn_1_N : N ;
  expansionsplan_nn_1_N : N ;
  expedit_nn_1_N : N ;
  expedition_nn_1_N : N ;
  expeditionschef_nn_1_N : N ;
  expeditionskaar_nn_1_1_N : N ;
  expeditionsvakt_nn_1_N : N ;
  expektoration_nn_1_N : N ;
  experimentator_nn_1_N : N ;
  experimentstation_nn_1_N : N ;
  expertgrupp_nn_1_N : N ;
  expertkommentator_nn_1_N : N ;
  expertkommitt_e_nn_1_1_N : N ;
  explikation_nn_1_N : N ;
  explosion_nn_1_N : N ;
  explosionsmotor_nn_1_N : N ;
  explosionsrisk_nn_1_N : N ;
  exponentialfunktion_nn_1_N : N ;
  export_nn_1_N : N ;
  exportinkomst_nn_1_N : N ;
  exportmarknad_nn_1_N : N ;
  exposition_nn_1_N : N ;
  expos_e_nn_1_1_N : N ;
  express_nn_1_N : N ;
  expressbyraa_nn_1_1_N : N ;
  expressionism_nn_1_N : N ;
  expressionist_nn_1_N : N ;
  expressivitet_nn_1_N : N ;
  expropriation_nn_1_N : N ;
  exsickator_nn_1_N : N ;
  exspiration_nn_1_N : N ;
  extension_nn_1_N : N ;
  extrainkomst_nn_1_N : N ;
  extrakongress_nn_1_N : N ;
  extraktion_nn_1_N : N ;
  extraktor_nn_1_N : N ;
  extrapolation_nn_1_N : N ;
  extratur_nn_1_N : N ;
  extravagans_nn_1_N : N ;
  extrem_nn_1_N : N ;
  extremism_nn_1_N : N ;
  extremist_nn_1_N : N ;
  extremitet_nn_1_N : N ;
  extremnationalist_nn_1_N : N ;
  fabrik_nn_1_N : N ;
  fabrikant_nn_1_N : N ;
  fabrikation_nn_1_N : N ;
  fabriksbyggnad_nn_1_N : N ;
  fabrikoer_nn_1_1_N : N ;
  facebookbild_nn_1_N : N ;
  facebookgrupp_nn_1_N : N ;
  facilitet_nn_1_N : N ;
  fackkunskap_nn_1_N : N ;
  fackordbok_nn_1_N : N ;
  facktidskrift_nn_1_N : N ;
  fackutskottsprincip_nn_1_N : N ;
  fadersfigur_nn_1_N : N ;
  fadaes_nn_1_1_N : N ;
  fajans_nn_1_N : N ;
  fajansfabrik_nn_1_N : N ;
  fajt_nn_1_N : N ;
  fakticitet_nn_1_N : N ;
  faktoid_nn_1_N : N ;
  faktor_nn_1_N : N ;
  faktoranalys_nn_1_N : N ;
  fakultet_nn_1_N : N ;
  fakultetsgraens_nn_1_1_N : N ;
  falangist_nn_1_N : N ;
  falangstrid_nn_1_N : N ;
  falkjakt_nn_1_N : N ;
  fallenhet_nn_1_N : N ;
  fallhoejd_nn_1_1_N : N ;
  falsettroest_nn_1_1_N : N ;
  falskhet_nn_1_N : N ;
  familj_nn_1_N : N ;
  familjaritet_nn_1_N : N ;
  familjebild_nn_1_N : N ;
  familjefejd_nn_1_N : N ;
  familjehemlighet_nn_1_N : N ;
  familjepension_nn_1_N : N ;
  familjerabatt_nn_1_N : N ;
  familjetradition_nn_1_N : N ;
  fanatism_nn_1_N : N ;
  fanerogam_nn_1_N : N ;
  fantasibild_nn_1_N : N ;
  fantasifigur_nn_1_N : N ;
  fantasifullhet_nn_1_N : N ;
  fantasiloeshet_nn_1_1_N : N ;
  fantast_nn_1_N : N ;
  fantombild_nn_1_N : N ;
  fanvakt_nn_1_N : N ;
  fariseism_nn_1_N : N ;
  farkost_nn_1_N : N ;
  farled_nn_1_N : N ;
  farlighet_nn_1_N : N ;
  farmakolog_nn_1_N : N ;
  farmakop_e_nn_1_1_N : N ;
  farmardomkraft_nn_1_N : N ;
  fars_nn_1_N : N ;
  fartygsbyggartradition_nn_1_N : N ;
  fartygsincident_nn_1_N : N ;
  fartygskapten_nn_1_N : N ;
  fartygskatastrof_nn_1_N : N ;
  fartygskollision_nn_1_N : N ;
  fartygskonvoj_nn_1_N : N ;
  fartygskurs_nn_1_N : N ;
  fartygslast_nn_1_N : N ;
  fartygstyp_nn_1_N : N ;
  fas_nn_1_N : N ;
  fasan_nn_1_N : N ;
  fasansfullhet_nn_1_N : N ;
  fascination_nn_1_N : N ;
  fascism_nn_1_N : N ;
  fascist_nn_1_N : N ;
  faskin_nn_1_N : N ;
  faslighet_nn_1_N : N ;
  fason_nn_1_N : N ;
  fastemaanad_nn_1_1_N : N ;
  fastetid_nn_1_N : N ;
  fasthet_nn_1_N : N ;
  fastighet_nn_1_N : N ;
  fastighetsaffaer_nn_1_1_N : N ;
  fastighetsbyraa_nn_1_1_N : N ;
  fastighetskris_nn_1_N : N ;
  fastighetsskatt_nn_1_N : N ;
  fastighetsspekulation_nn_1_N : N ;
  fatalism_nn_1_N : N ;
  fatalist_nn_1_N : N ;
  fatalitet_nn_1_N : N ;
  fattbarhet_nn_1_N : N ;
  faunist_nn_1_N : N ;
  favorit_nn_1_N : N ;
  favoritaccessoar_nn_1_N : N ;
  favoritbild_nn_1_N : N ;
  favoritrestaurang_nn_1_N : N ;
  favoritraett_nn_1_1_N : N ;
  februarioffensiv_nn_1_N : N ;
  federalism_nn_1_N : N ;
  federalist_nn_1_N : N ;
  federation_nn_1_N : N ;
  feghet_nn_1_N : N ;
  felaktighet_nn_1_N : N ;
  feldiagnos_nn_1_N : N ;
  femdygnsprognos_nn_1_N : N ;
  femininform_nn_1_N : N ;
  feminism_nn_1_N : N ;
  feminist_nn_1_N : N ;
  fempunktsplan_nn_1_N : N ;
  femrumslaegenhet_nn_1_1_N : N ;
  femtiotalist_nn_1_N : N ;
  femtitalist_nn_1_N : N ;
  femtocell_nn_1_N : N ;
  femaarsplan_nn_1_1_N : N ;
  fennicism_nn_1_N : N ;
  fennoman_nn_1_N : N ;
  fenol_nn_1_N : N ;
  fenomenalism_nn_1_N : N ;
  fenoplast_nn_1_N : N ;
  feodalism_nn_1_N : N ;
  fermitet_nn_1_N : N ;
  ferrit_nn_1_N : N ;
  fertilitet_nn_1_N : N ;
  fest_nn_1_N : N ;
  festarrangoer_nn_1_1_N : N ;
  festdraekt_nn_1_1_N : N ;
  festivitet_nn_1_N : N ;
  festkamrat_nn_1_N : N ;
  festlighet_nn_1_N : N ;
  festmaaltid_nn_1_1_N : N ;
  feston_nn_1_N : N ;
  festskrift_nn_1_N : N ;
  fetisch_nn_1_N : N ;
  fetischism_nn_1_N : N ;
  fetischist_nn_1_N : N ;
  fets_nn_1_N : N ;
  fetthalt_nn_1_N : N ;
  fettloeslighet_nn_1_1_N : N ;
  fettvaevnad_nn_1_1_N : N ;
  fez_nn_1_N : N ;
  fial_nn_1_N : N ;
  fiaskokonferens_nn_1_N : N ;
  fibertillsats_nn_1_N : N ;
  fibervaext_nn_1_1_N : N ;
  fibrinogen_nn_1_N : N ;
  fickhandbok_nn_1_N : N ;
  fickkalkylator_nn_1_N : N ;
  fickstoeld_nn_1_1_N : N ;
  fidjian_nn_1_N : N ;
  fiendearm_e_nn_1_1_N : N ;
  fiendesoldat_nn_1_N : N ;
  fientlighet_nn_1_N : N ;
  fiffighet_nn_1_N : N ;
  fight_nn_1_N : N ;
  figur_nn_1_N : N ;
  figurant_nn_1_N : N ;
  figuration_nn_1_N : N ;
  fijian_nn_1_N : N ;
  fikapaus_nn_1_N : N ;
  fiktion_nn_1_N : N ;
  fiktionalism_nn_1_N : N ;
  fil_nn_1_N : N ;
  filantrop_nn_1_N : N ;
  filatelist_nn_1_N : N ;
  file_nn_1_N : N ;
  filipin_nn_1_N : N ;
  film_nn_1_N : N ;
  filmaffisch_nn_1_N : N ;
  filmaskin_nn_1_N : N ;
  filmatelj_e_nn_1_1_N : N ;
  filmbild_nn_1_N : N ;
  filmdebut_nn_1_N : N ;
  filmexpert_nn_1_N : N ;
  filmfars_nn_1_N : N ;
  filmfestival_nn_1_N : N ;
  filmmatin_e_nn_1_1_N : N ;
  filmpremiaer_nn_1_1_N : N ;
  filmproducent_nn_1_N : N ;
  filmprofessor_nn_1_N : N ;
  filmtidskrift_nn_1_N : N ;
  filmversion_nn_1_N : N ;
  filmvetenskap_nn_1_N : N ;
  filolog_nn_1_N : N ;
  fil_e_nn_1_1_N : N ;
  finalist_nn_1_N : N ;
  finalplats_nn_1_N : N ;
  finanschef_nn_1_N : N ;
  finansinspektion_nn_1_N : N ;
  finanskrasch_nn_1_N : N ;
  finanskris_nn_1_N : N ;
  finansmarknad_nn_1_N : N ;
  finansplan_nn_1_N : N ;
  finess_nn_1_N : N ;
  fingerbredd_nn_1_N : N ;
  fingerfaerg_nn_1_1_N : N ;
  fingerled_nn_1_N : N ;
  fingertoppsnyans_nn_1_N : N ;
  fingeroert_nn_1_1_N : N ;
  finhet_nn_2_N : N ;
  finkart_nn_1_N : N ;
  finkaenslighet_nn_1_1_N : N ;
  finlandism_nn_1_N : N ;
  finnkamp_nn_1_N : N ;
  finskhet_nn_1_N : N ;
  finstruktur_nn_1_N : N ;
  fintlighet_nn_1_N : N ;
  finurlighet_nn_1_N : N ;
  fioritur_nn_1_N : N ;
  firmafest_nn_1_N : N ;
  firngraens_nn_1_1_N : N ;
  fischy_nn_1_N : N ;
  fiskal_nn_1_N : N ;
  fiskart_nn_1_N : N ;
  fiskegraens_nn_1_1_N : N ;
  fiskenation_nn_1_N : N ;
  fiskfil_e_nn_1_1_N : N ;
  fiskfaers_nn_1_1_N : N ;
  fiskfaangst_nn_1_1_N : N ;
  fiskmaaltid_nn_1_1_N : N ;
  fiskraett_nn_1_1_N : N ;
  fisksaas_nn_1_1_N : N ;
  fission_nn_1_N : N ;
  fissur_nn_1_N : N ;
  fittrakt_nn_1_N : N ;
  fixeringsbild_nn_1_N : N ;
  fixpunkt_nn_1_N : N ;
  fixtur_nn_1_N : N ;
  fjollighet_nn_1_N : N ;
  fjaederdraekt_nn_1_1_N : N ;
  fjaedertyp_nn_1_1_N : N ;
  fjaedringsmekanism_nn_1_1_N : N ;
  fjaellbilist_nn_1_1_N : N ;
  fjaellplataa_nn_1_1_N : N ;
  fjaellturist_nn_1_1_N : N ;
  fjaerdegradsekvation_nn_1_1_N : N ;
  fjaerilsart_nn_1_1_N : N ;
  fjaerrkontroll_nn_1_1_N : N ;
  fjaerrpunkt_nn_1_1_N : N ;
  fjaerrskrivmaskin_nn_1_1_N : N ;
  flackbanepjaes_nn_1_1_N : N ;
  flagellant_nn_1_N : N ;
  flaggvakt_nn_1_N : N ;
  flamencogitarrist_nn_1_N : N ;
  flamskvaevnad_nn_1_1_N : N ;
  flasknosdelfin_nn_1_N : N ;
  flatulens_nn_1_N : N ;
  flektion_nn_1_N : N ;
  flerbarnsfamilj_nn_1_N : N ;
  flerhet_nn_1_N : N ;
  flerordsenhet_nn_1_N : N ;
  flexion_nn_1_N : N ;
  flexur_nn_1_N : N ;
  flickbok_nn_1_N : N ;
  flickbokstradition_nn_1_N : N ;
  flickkoer_nn_1_1_N : N ;
  flickmatch_nn_1_N : N ;
  flickpension_nn_1_N : N ;
  flickroest_nn_1_1_N : N ;
  flight_nn_1_N : N ;
  flimmercell_nn_1_N : N ;
  flockinstinkt_nn_1_N : N ;
  flodterrass_nn_1_N : N ;
  florettfaektningskurs_nn_1_1_N : N ;
  florin_nn_1_N : N ;
  florist_nn_1_N : N ;
  floskelpatriot_nn_1_N : N ;
  flotation_nn_1_N : N ;
  flottbas_nn_1_N : N ;
  flottenhet_nn_1_N : N ;
  flottist_nn_1_N : N ;
  flottled_nn_1_N : N ;
  flottstrateg_nn_1_N : N ;
  fluffighet_nn_1_N : N ;
  fluid_nn_1_N : N ;
  fluktuation_nn_1_N : N ;
  fluorhalt_nn_1_N : N ;
  fluorid_nn_1_N : N ;
  fluss_nn_1_N : N ;
  flygankomst_nn_1_N : N ;
  flygattach_e_nn_1_1_N : N ;
  flygattack_nn_1_N : N ;
  flygbas_nn_1_N : N ;
  flygbasbarack_nn_1_N : N ;
  flygbild_nn_1_N : N ;
  flygbomb_nn_1_N : N ;
  flygelbyggnad_nn_1_N : N ;
  flygfaerd_nn_1_1_N : N ;
  flygfoerbudszon_nn_1_1_N : N ;
  flyghastighet_nn_1_N : N ;
  flygkapacitet_nn_1_N : N ;
  flygkatastrof_nn_1_N : N ;
  flygkonst_nn_1_N : N ;
  flygkaar_nn_1_1_N : N ;
  flygledarstrejk_nn_1_N : N ;
  flyglaegenhet_nn_1_1_N : N ;
  flygplanskabin_nn_1_N : N ;
  flygplats_nn_1_N : N ;
  flygraed_nn_1_1_N : N ;
  flygskrift_nn_1_N : N ;
  flygsaekerhetsexpert_nn_1_1_N : N ;
  flygsaekerhetskonsult_nn_1_1_N : N ;
  flygterminal_nn_1_N : N ;
  flygtidtabell_nn_1_N : N ;
  flygtransport_nn_1_N : N ;
  flygtur_nn_1_N : N ;
  flygvapenchef_nn_1_N : N ;
  flyktighet_nn_2_N : N ;
  flyktingfamilj_nn_1_N : N ;
  flyktmekanism_nn_1_N : N ;
  flyktmoejlighet_nn_1_1_N : N ;
  flyktreaktion_nn_1_N : N ;
  flyktrisk_nn_1_N : N ;
  flyttkartong_nn_1_N : N ;
  flaerdfullhet_nn_1_1_N : N ;
  flaerdloeshet_nn_1_1_N : N ;
  flaeskfil_e_nn_1_1_N : N ;
  flaeskfaers_nn_1_1_N : N ;
  flaeskkarr_e_nn_1_1_N : N ;
  floejtist_nn_1_1_N : N ;
  floejtton_nn_1_1_N : N ;
  floert_nn_1_1_N : N ;
  floets_nn_1_1_N : N ;
  fnoskighet_nn_1_N : N ;
  foaje_nn_1_N : N ;
  foaj_e_nn_1_1_N : N ;
  fockmast_nn_1_N : N ;
  fodermark_nn_1_N : N ;
  fodermaengd_nn_1_1_N : N ;
  fodervaext_nn_1_1_N : N ;
  fokaldistans_nn_1_N : N ;
  foliant_nn_1_N : N ;
  folkarm_e_nn_1_1_N : N ;
  folkbank_nn_1_N : N ;
  folkbildningstidskrift_nn_1_N : N ;
  folkbok_nn_1_N : N ;
  folkdans_nn_1_N : N ;
  folkdikt_nn_1_N : N ;
  folkdraekt_nn_1_1_N : N ;
  folkfest_nn_1_N : N ;
  folkgrupp_nn_1_N : N ;
  folkhemsidyll_nn_1_N : N ;
  folkkongress_nn_1_N : N ;
  folklighet_nn_1_N : N ;
  folklorist_nn_1_N : N ;
  folkopinion_nn_1_N : N ;
  folkpartist_nn_1_N : N ;
  folkpension_nn_1_N : N ;
  folkpensionaer_nn_1_1_N : N ;
  folkrepresentant_nn_1_N : N ;
  folkrepresentation_nn_1_N : N ;
  folksaang_nn_1_1_N : N ;
  folktaethet_nn_1_1_N : N ;
  folkvettsexpert_nn_1_N : N ;
  folkviseton_nn_1_N : N ;
  fon_nn_1_N : N ;
  fond_nn_1_N : N ;
  fond_nn_2_N : N ;
  fondboers_nn_1_1_N : N ;
  fondemission_nn_1_N : N ;
  fondkommissionaer_nn_1_1_N : N ;
  fondy_nn_1_N : N ;
  font_nn_1_N : N ;
  fordonskolonn_nn_1_N : N ;
  fordonsvikt_nn_1_N : N ;
  form_nn_2_N : N ;
  formaldehyd_nn_1_N : N ;
  formalism_nn_1_N : N ;
  formalist_nn_1_N : N ;
  formalitet_nn_1_N : N ;
  formant_nn_1_N : N ;
  formation_nn_1_N : N ;
  formelenhet_nn_1_N : N ;
  formsak_nn_1_N : N ;
  fornsak_nn_1_N : N ;
  forsfaerd_nn_1_1_N : N ;
  forskargrupp_nn_1_N : N ;
  forskarkonspiration_nn_1_N : N ;
  forskarledighet_nn_1_N : N ;
  forskningsfaerd_nn_1_1_N : N ;
  forskningsingenjoer_nn_1_1_N : N ;
  forskningsinsats_nn_1_N : N ;
  forskningskompetens_nn_1_N : N ;
  forskningsmetodik_nn_1_N : N ;
  forskningsorganisation_nn_1_N : N ;
  forskningsprocess_nn_1_N : N ;
  forskningsstation_nn_1_N : N ;
  fortbildningskurs_nn_1_N : N ;
  fortifikation_nn_1_N : N ;
  fortifikationskaar_nn_1_1_N : N ;
  fortkomst_nn_1_N : N ;
  fosforit_nn_1_N : N ;
  fosforsyracell_nn_1_N : N ;
  fossilisation_nn_1_N : N ;
  fossilletarexpedition_nn_1_N : N ;
  fosterfamilj_nn_1_N : N ;
  fot_nn_1_N : N ;
  fotbollsexpert_nn_1_N : N ;
  fotbollshuligan_nn_1_N : N ;
  fotbollsmatch_nn_1_N : N ;
  fotbollsplan_nn_1_N : N ;
  fotled_nn_1_N : N ;
  fotnot_nn_1_N : N ;
  fotoaffaer_nn_1_1_N : N ;
  fotoatelj_e_nn_1_1_N : N ;
  fotoelektricitet_nn_1_N : N ;
  fotogenmotor_nn_1_N : N ;
  foton_nn_1_N : N ;
  fotoresistor_nn_1_N : N ;
  fotosfaer_nn_1_1_N : N ;
  fotosyntes_nn_1_N : N ;
  fotpedal_nn_1_N : N ;
  fotsoldat_nn_1_N : N ;
  fotvaardssalong_nn_1_1_N : N ;
  fraktion_nn_1_N : N ;
  fraktkostnad_nn_1_N : N ;
  fraktsats_nn_1_N : N ;
  fraktterminal_nn_1_N : N ;
  fraktur_nn_2_N : N ;
  framextremitet_nn_1_N : N ;
  framfaerd_nn_1_1_N : N ;
  framgaangsevangelist_nn_1_1_N : N ;
  framkant_nn_1_N : N ;
  framkomlighet_nn_1_N : N ;
  frammarsch_nn_1_N : N ;
  framstegsoptimism_nn_1_N : N ;
  framtid_nn_1_N : N ;
  framtidsbild_nn_1_N : N ;
  framtidsbransch_nn_1_N : N ;
  framtidskalkyl_nn_1_N : N ;
  framtidsplan_nn_1_N : N ;
  framtidssyn_nn_1_N : N ;
  framtidsutsikt_nn_1_N : N ;
  framtidsversion_nn_1_N : N ;
  framtidsvision_nn_1_N : N ;
  framtidsvy_nn_1_N : N ;
  franciskan_nn_1_N : N ;
  frank_nn_1_N : N ;
  frankist_nn_1_N : N ;
  franskklassicism_nn_1_N : N ;
  franskkurs_nn_1_N : N ;
  fransklektion_nn_1_N : N ;
  fransos_nn_1_N : N ;
  fransaes_nn_1_1_N : N ;
  fras_nn_1_N : N ;
  fred_nn_1_N : N ;
  fredagsboen_nn_1_1_N : N ;
  fredagsboers_nn_1_1_N : N ;
  fredsaktivist_nn_1_N : N ;
  fredskonferens_nn_1_N : N ;
  fredskongress_nn_1_N : N ;
  fredskaar_nn_1_1_N : N ;
  fredspristagarfavorit_nn_1_N : N ;
  fredsprocess_nn_1_N : N ;
  fredstid_nn_1_N : N ;
  frekvens_nn_1_N : N ;
  freon_nn_1_N : N ;
  fresk_nn_1_N : N ;
  friarfaerd_nn_1_1_N : N ;
  frigiditet_nn_1_N : N ;
  frigivningsnaemnd_nn_1_1_N : N ;
  frigjordhet_nn_1_N : N ;
  frihet_nn_1_N : N ;
  frihetsgrad_nn_1_N : N ;
  frihetssymbol_nn_1_N : N ;
  friidrott_nn_1_N : N ;
  frikass_e_nn_1_1_N : N ;
  friktion_nn_1_N : N ;
  frikyrklighet_nn_1_N : N ;
  frikyrkopastor_nn_1_N : N ;
  frikaar_nn_1_1_N : N ;
  frilansjournalist_nn_1_N : N ;
  friplats_nn_1_N : N ;
  fris_nn_1_N : N ;
  fris_2_nn_1_N : N ;
  frisersalong_nn_1_N : N ;
  frispraakighet_nn_1_1_N : N ;
  frist_nn_1_N : N ;
  fristat_nn_1_N : N ;
  frisoer_nn_1_1_N : N ;
  frisoersalong_nn_1_1_N : N ;
  fritidsaktivitet_nn_1_N : N ;
  fritidsnaemnd_nn_1_1_N : N ;
  frivillighet_nn_1_N : N ;
  frivilligorganisation_nn_1_N : N ;
  frivolitet_nn_1_N : N ;
  frizon_nn_1_N : N ;
  fromhet_nn_1_N : N ;
  frontespis_nn_1_N : N ;
  fronton_nn_1_N : N ;
  frontong_nn_1_N : N ;
  frontsoldat_nn_1_N : N ;
  frontzon_nn_1_N : N ;
  frosch_nn_1_N : N ;
  frosthaerdighet_nn_1_1_N : N ;
  frostkaenslighet_nn_1_1_N : N ;
  frott_e_nn_1_1_N : N ;
  frukostbuff_e_nn_1_1_N : N ;
  frukostmeny_nn_1_N : N ;
  frukostrast_nn_1_N : N ;
  frukt_nn_1_N : N ;
  fruktaffaer_nn_1_1_N : N ;
  fruktbarhet_nn_1_N : N ;
  fruktsallad_nn_1_N : N ;
  fruktsmak_nn_1_N : N ;
  fruktsaas_nn_1_1_N : N ;
  frustration_nn_1_N : N ;
  fryntlighet_nn_1_N : N ;
  fraeckhet_nn_1_1_N : N ;
  fraemlingslegion_nn_1_1_N : N ;
  fraageform_nn_1_1_N : N ;
  fraagementalitet_nn_1_1_N : N ;
  fraagesats_nn_1_1_N : N ;
  fraagesport_nn_1_1_N : N ;
  fraageton_nn_1_1_N : N ;
  froejd_nn_1_1_N : N ;
  froevaext_nn_1_1_N : N ;
  ftalat_nn_1_N : N ;
  fuktighet_nn_1_N : N ;
  fulhet_nn_1_N : N ;
  fulkultur_nn_1_N : N ;
  fullblodsindian_nn_1_N : N ;
  fulleren_nn_1_N : N ;
  fullkomlighet_nn_1_N : N ;
  fullmakt_nn_1_N : N ;
  fullstaendighet_nn_1_1_N : N ;
  fulloedighet_nn_1_1_N : N ;
  fumlighet_nn_1_N : N ;
  fundamentalism_nn_1_N : N ;
  fundamentalist_nn_1_N : N ;
  fundamentalsats_nn_1_N : N ;
  funktion_nn_1_N : N ;
  funktionalism_nn_1_N : N ;
  funktionalist_nn_1_N : N ;
  furstlighet_nn_1_N : N ;
  fusion_nn_1_N : N ;
  futilitet_nn_1_N : N ;
  futtighet_nn_1_N : N ;
  futurism_nn_1_N : N ;
  futurist_nn_1_N : N ;
  futurolog_nn_1_N : N ;
  fyllerist_nn_1_N : N ;
  fyllnad_nn_1_N : N ;
  fyndighet_nn_1_N : N ;
  fyndort_nn_1_N : N ;
  fyndplats_nn_1_N : N ;
  fyrarumslaegenhet_nn_1_1_N : N ;
  fyrkantighet_nn_1_N : N ;
  fyrrumslaegenhet_nn_1_1_N : N ;
  fyrtakt_nn_1_N : N ;
  fyrtaktsmotor_nn_1_N : N ;
  fyrtiotalism_nn_1_N : N ;
  fyrtiotalist_nn_1_N : N ;
  fyrtioaarskris_nn_1_1_N : N ;
  fyrtitalism_nn_1_N : N ;
  fyrtitalist_nn_1_N : N ;
  fyrtiaarskris_nn_1_1_N : N ;
  fyrverkeripjaes_nn_1_1_N : N ;
  fysikbok_nn_1_N : N ;
  fysikprofessor_nn_1_N : N ;
  fysiokratism_nn_1_N : N ;
  fysiolog_nn_1_N : N ;
  fytotron_nn_1_N : N ;
  faebless_nn_1_1_N : N ;
  faegnad_nn_1_1_N : N ;
  faektningsmatch_nn_1_1_N : N ;
  faeltarm_e_nn_1_1_N : N ;
  faeltbiolog_nn_1_1_N : N ;
  faeltjaegarkaar_nn_1_1_N : N ;
  faeltkirurg_nn_1_1_N : N ;
  faeltpraest_nn_1_1_N : N ;
  faeltskaer_nn_1_1_N : N ;
  faelttaagsplan_nn_1_1_N : N ;
  faeltuniform_nn_1_1_N : N ;
  faenad_nn_1_1_N : N ;
  faengelsechef_nn_1_1_N : N ;
  faengelsedirektoer_nn_1_1_N : N ;
  faerdighet_nn_1_1_N : N ;
  faerdled_nn_1_1_N : N ;
  faerg_nn_1_1_N : N ;
  faergbild_nn_1_1_N : N ;
  faergfilm_nn_1_1_N : N ;
  faergillustration_nn_1_1_N : N ;
  faergkontrast_nn_1_1_N : N ;
  faergkaenslighet_nn_1_1_N : N ;
  faergnyans_nn_1_1_N : N ;
  faergreproduktion_nn_1_1_N : N ;
  faergtemperatur_nn_1_1_N : N ;
  faergton_nn_1_1_N : N ;
  faerjeankomst_nn_1_1_N : N ;
  faerjelaegenhet_nn_1_1_N : N ;
  faerjeterminal_nn_1_1_N : N ;
  faerjetidtabell_nn_1_1_N : N ;
  faerjetransport_nn_1_1_N : N ;
  faerjetur_nn_1_1_N : N ;
  faermitet_nn_1_1_N : N ;
  faers_nn_1_1_N : N ;
  faestningskommendant_nn_1_1_N : N ;
  faestpunkt_nn_1_1_N : N ;
  faafaenglighet_nn_1_1_N : N ;
  faagelart_nn_1_1_N : N ;
  faageldans_nn_1_1_N : N ;
  faageljakt_nn_1_1_N : N ;
  faagelpopulation_nn_1_1_N : N ;
  faangdraekt_nn_1_1_N : N ;
  faangst_nn_1_1_N : N ;
  faangstkultur_nn_1_1_N : N ;
  faangstplats_nn_1_1_N : N ;
  faangtransport_nn_1_1_N : N ;
  faangvaardsanstalt_nn_1_1_N : N ;
  faanighet_nn_1_1_N : N ;
  foedelseattest_nn_1_1_N : N ;
  foedelsebygd_nn_1_1_N : N ;
  foedelsedagsfest_nn_1_1_N : N ;
  foedelsedagspresent_nn_1_1_N : N ;
  foedelseort_nn_1_1_N : N ;
  foedoorganism_nn_1_1_N : N ;
  foedsloraett_nn_1_1_N : N ;
  foeljd_nn_1_1_N : N ;
  foeljdsats_nn_1_1_N : N ;
  foeljsamhet_nn_1_1_N : N ;
  foensterfaerg_nn_1_1_N : N ;
  foensterluft_nn_1_1_N : N ;
  foensternisch_nn_1_1_N : N ;
  foensterplats_nn_1_1_N : N ;
  foensterpost_nn_1_1_N : N ;
  foeraktfullhet_nn_1_1_N : N ;
  foeraktlighet_nn_1_1_N : N ;
  foerarglighet_nn_1_1_N : N ;
  foerarkabin_nn_1_1_N : N ;
  foerarplats_nn_1_1_N : N ;
  foerbandsplats_nn_1_1_N : N ;
  foerbehaallsamhet_nn_1_1_N : N ;
  foerberedelsetid_nn_1_1_N : N ;
  foerbifart_nn_1_1_N : N ;
  foerbifartsled_nn_1_1_N : N ;
  foerbindelseled_nn_1_1_N : N ;
  foerbraenningsmotor_nn_1_1_N : N ;
  foerbraenningsprodukt_nn_1_1_N : N ;
  foerbundsstat_nn_1_1_N : N ;
  foerbyggnad_nn_1_1_N : N ;
  foerbaettringspotential_nn_1_1_N : N ;
  foerboen_nn_1_1_N : N ;
  foerdjupningskurs_nn_1_1_N : N ;
  foerdomsfullhet_nn_1_1_N : N ;
  foerdragsamhet_nn_1_1_N : N ;
  foerdroejningstaktik_nn_1_1_N : N ;
  foerebild_nn_1_1_N : N ;
  foerekomst_nn_1_1_N : N ;
  foereningsfrihet_nn_1_1_N : N ;
  foereningspunkt_nn_1_1_N : N ;
  foerenlighet_nn_1_1_N : N ;
  foeresats_nn_1_1_N : N ;
  foereskrift_nn_1_1_N : N ;
  foerestaellningsrepertoar_nn_1_1_N : N ;
  foeretagsamhet_nn_1_1_N : N ;
  foeretagsekonom_nn_1_1_N : N ;
  foeretagsnaemnd_nn_1_1_N : N ;
  foeretagsvinst_nn_1_1_N : N ;
  foerfallsperiod_nn_1_1_N : N ;
  foerfattningsstridighet_nn_1_1_N : N ;
  foerfaerlighet_nn_1_1_N : N ;
  foerfoerelsekonst_nn_1_1_N : N ;
  foergriplighet_nn_1_1_N : N ;
  foergrundsfigur_nn_1_1_N : N ;
  foergaenglighet_nn_1_1_N : N ;
  foerhalningstaktik_nn_1_1_N : N ;
  foerhandlingsdelegation_nn_1_1_N : N ;
  foerhandsinformation_nn_1_1_N : N ;
  foerhatlighet_nn_1_1_N : N ;
  foerhaardnad_nn_1_1_N : N ;
  foerhoersutskrift_nn_1_1_N : N ;
  foerklaednad_nn_1_1_N : N ;
  foerlagsverksamhet_nn_1_1_N : N ;
  foerlikningskommission_nn_1_1_N : N ;
  foerlossningsanstalt_nn_1_1_N : N ;
  foerlust_nn_1_1_N : N ;
  foerlaegenhet_nn_1_1_N : N ;
  foerlaeggningsort_nn_1_1_N : N ;
  foermatch_nn_1_1_N : N ;
  foermoegenhet_nn_1_1_N : N ;
  foermoegenhetsraett_nn_1_1_N : N ;
  foermoegenhetsskatt_nn_1_1_N : N ;
  foernekelsefas_nn_1_1_N : N ;
  foernimbarhet_nn_1_1_N : N ;
  foernuftsloeshet_nn_1_1_N : N ;
  foernumstighet_nn_1_1_N : N ;
  foernaemhet_nn_1_1_N : N ;
  foernaemitet_nn_1_1_N : N ;
  foernoedenhet_nn_1_1_N : N ;
  foeroreningsgrad_nn_1_1_N : N ;
  foerort_nn_1_1_N : N ;
  foerplaegnad_nn_1_1_N : N ;
  foerpost_nn_1_1_N : N ;
  foerpubertet_nn_1_1_N : N ;
  foerruttnelsegas_nn_1_1_N : N ;
  foerruttnelseprocess_nn_1_1_N : N ;
  foerraediskhet_nn_1_1_N : N ;
  foerraett_nn_1_1_N : N ;
  foersamlingsbok_nn_1_1_N : N ;
  foersamlingsfrihet_nn_1_1_N : N ;
  foersamlingspraest_nn_1_1_N : N ;
  foersats_nn_1_1_N : N ;
  foerseningskampanj_nn_1_1_N : N ;
  foersiktighet_nn_1_1_N : N ;
  foersiktighetsprincip_nn_1_1_N : N ;
  foersiktighetsaatgaerd_nn_1_1_N : N ;
  foerskraecklighet_nn_1_1_N : N ;
  foersoningsfest_nn_1_1_N : N ;
  foersoningsgest_nn_1_1_N : N ;
  foerstagradsekvation_nn_1_1_N : N ;
  foerstahandsuppgift_nn_1_1_N : N ;
  foerstainstans_nn_1_1_N : N ;
  foerstaplats_nn_1_1_N : N ;
  foerstaaarsstudent_nn_1_1_N : N ;
  foersumlighet_nn_1_1_N : N ;
  foersvarsadvokat_nn_1_1_N : N ;
  foersvarsallians_nn_1_1_N : N ;
  foersvarsattach_e_nn_1_1_N : N ;
  foersvarsdator_nn_1_1_N : N ;
  foersvarsfunktion_nn_1_1_N : N ;
  foersvarsgrenschef_nn_1_1_N : N ;
  foersvarshemlighet_nn_1_1_N : N ;
  foersvarskostnad_nn_1_1_N : N ;
  foersvarsmekanism_nn_1_1_N : N ;
  foersvarsskrift_nn_1_1_N : N ;
  foersvarsstab_nn_1_1_N : N ;
  foersaekringsbolagskontorist_nn_1_1_N : N ;
  foersaekringsmarknad_nn_1_1_N : N ;
  foersaekringspolis_nn_1_1_N : N ;
  foersaeljningsbransch_nn_1_1_N : N ;
  foersaeljningschef_nn_1_1_N : N ;
  foersaeljningsort_nn_1_1_N : N ;
  foersaeljningssucc_e_nn_1_1_N : N ;
  foersaeljningsvinst_nn_1_1_N : N ;
  foersaeljningsvolym_nn_1_1_N : N ;
  foersaettslins_nn_1_1_N : N ;
  foersaatlighet_nn_1_1_N : N ;
  foersoekskanin_nn_1_1_N : N ;
  foersoeksperson_nn_1_1_N : N ;
  foersoeksverksamhet_nn_1_1_N : N ;
  foersoerjningsanstalt_nn_1_1_N : N ;
  foertalskampanj_nn_1_1_N : N ;
  foertidspension_nn_1_1_N : N ;
  foertjaenst_nn_1_1_N : N ;
  foertretlighet_nn_1_1_N : N ;
  foertroendekris_nn_1_1_N : N ;
  foertroendepost_nn_1_1_N : N ;
  foertrogenhet_nn_1_1_N : N ;
  foertrolighet_nn_1_1_N : N ;
  foertraefflighet_nn_1_1_N : N ;
  foertraengningsmekanism_nn_1_1_N : N ;
  foerunderlighet_nn_1_1_N : N ;
  foervaltningsbyggnad_nn_1_1_N : N ;
  foervaltningsraett_nn_1_1_N : N ;
  foervandlingskonstnaer_nn_1_1_N : N ;
  foervandlingsprocess_nn_1_1_N : N ;
  foervaringsmoejlighet_nn_1_1_N : N ;
  foervaringsplats_nn_1_1_N : N ;
  foervisningsort_nn_1_1_N : N ;
  foervaervsverksamhet_nn_1_1_N : N ;
  foeraeldrakreativitet_nn_1_1_N : N ;
  foeraeldraledighet_nn_1_1_N : N ;
  foeraendringsprocess_nn_1_1_N : N ;
  g_draekt_nn_1_1_N : N ;
  g_kraft_nn_1_N : N ;
  g_punkt_nn_1_N : N ;
  gabon_nn_2_N : N ;
  gabones_nn_1_N : N ;
  gael_nn_1_N : N ;
  gaffellaengd_nn_1_1_N : N ;
  gagnelighet_nn_1_N : N ;
  gagnvaext_nn_1_1_N : N ;
  galadraekt_nn_1_1_N : N ;
  galapremiaer_nn_1_1_N : N ;
  galauniform_nn_1_N : N ;
  galax_nn_1_N : N ;
  galeas_nn_1_N : N ;
  galjon_nn_1_N : N ;
  galjonsbild_nn_1_N : N ;
  galjonsfigur_nn_1_N : N ;
  gallerist_nn_1_N : N ;
  gallicism_nn_1_N : N ;
  gallion_nn_1_N : N ;
  galon_nn_2_N : N ;
  galopp_nn_1_N : N ;
  galoppad_nn_1_N : N ;
  galosch_nn_1_N : N ;
  galvanism_nn_1_N : N ;
  gamasch_nn_1_N : N ;
  gammaldans_nn_1_N : N ;
  gammalkommunist_nn_1_N : N ;
  gammalvals_nn_1_N : N ;
  gammeldans_nn_1_N : N ;
  gammelkommunist_nn_1_N : N ;
  gammelmoderat_nn_1_N : N ;
  gammeltantsgarderob_nn_1_N : N ;
  gammelvals_nn_1_N : N ;
  ganasch_nn_1_N : N ;
  gangsterism_nn_1_N : N ;
  gans_nn_1_N : N ;
  garagedomkraft_nn_1_N : N ;
  garageuppfart_nn_1_N : N ;
  garagevakt_nn_1_N : N ;
  garant_nn_1_N : N ;
  garantifond_nn_1_N : N ;
  garderobi_e_nn_1_1_N : N ;
  gardessoldat_nn_1_N : N ;
  gardian_nn_1_N : N ;
  gardin_nn_1_N : N ;
  gardinluft_nn_1_N : N ;
  gardist_nn_1_N : N ;
  garnisonspraest_nn_1_1_N : N ;
  garcon_nn_1_1_N : N ;
  gas_nn_1_N : N ;
  gasackumulator_nn_1_N : N ;
  gasell_nn_1_N : N ;
  gaseruption_nn_1_N : N ;
  gasexplosion_nn_1_N : N ;
  gasgenerator_nn_1_N : N ;
  gaskatastrof_nn_1_N : N ;
  gasmask_nn_1_N : N ;
  gasmotor_nn_1_N : N ;
  gaspedal_nn_1_N : N ;
  gaspollett_nn_1_N : N ;
  gastrit_nn_1_N : N ;
  gastub_nn_1_N : N ;
  gasturbin_nn_1_N : N ;
  gatudemonstration_nn_1_N : N ;
  gatumanifestation_nn_1_N : N ;
  gatuprotest_nn_1_N : N ;
  gatuscen_nn_1_N : N ;
  gaullism_nn_1_N : N ;
  gaullist_nn_1_N : N ;
  gaur_nn_1_N : N ;
  gavial_nn_1_N : N ;
  gavott_nn_1_N : N ;
  geg_nn_1_N : N ;
  gemenhet_nn_1_N : N ;
  gemensamhet_nn_1_N : N ;
  gemenskap_nn_2_N : N ;
  gemenskapsform_nn_1_N : N ;
  gemination_nn_1_N : N ;
  gems_nn_1_N : N ;
  gemytlighet_nn_1_N : N ;
  gen_nn_1_N : N ;
  genbank_nn_1_N : N ;
  generaldirektoer_nn_1_1_N : N ;
  generalguvernoer_nn_1_1_N : N ;
  generalisation_nn_1_N : N ;
  generaliseringsprocess_nn_1_N : N ;
  generalist_nn_1_N : N ;
  generalitet_nn_2_N : N ;
  generalmajor_nn_1_N : N ;
  generalpaus_nn_1_N : N ;
  generalplan_nn_1_N : N ;
  generalpostdirektoer_nn_1_1_N : N ;
  generalprevention_nn_1_N : N ;
  generalrepetition_nn_1_N : N ;
  generalstab_nn_1_N : N ;
  generalstabsnivaa_nn_1_1_N : N ;
  generalstrejk_nn_1_N : N ;
  generation_nn_1_N : N ;
  generationstid_nn_1_N : N ;
  generator_nn_1_N : N ;
  generatris_nn_1_N : N ;
  generositet_nn_1_N : N ;
  genialitet_nn_1_N : N ;
  genitiv_nn_1_N : N ;
  genmanipulation_nn_1_N : N ;
  genocid_nn_1_N : N ;
  genombrottsbok_nn_1_N : N ;
  genomfartsled_nn_1_N : N ;
  genommarsch_nn_1_N : N ;
  genomslaepplighet_nn_1_1_N : N ;
  genomsnittsinkomst_nn_1_N : N ;
  genomsnittsskatt_nn_1_N : N ;
  genotyp_nn_1_N : N ;
  genpool_nn_1_N : N ;
  gentjaenst_nn_1_1_N : N ;
  genusvetenskap_nn_1_N : N ;
  geofon_nn_1_N : N ;
  geografibok_nn_1_N : N ;
  geolog_nn_1_N : N ;
  geologiprofessor_nn_1_N : N ;
  geotropism_nn_1_N : N ;
  geovetenskap_nn_1_N : N ;
  geridon_nn_1_N : N ;
  gerillaveteran_nn_1_N : N ;
  german_nn_1_N : N ;
  germanism_nn_1_N : N ;
  germanist_nn_1_N : N ;
  gesant_nn_1_N : N ;
  gesims_nn_1_N : N ;
  gesimslist_nn_1_N : N ;
  gest_nn_1_N : N ;
  gestaltningsform_nn_1_N : N ;
  gestikulation_nn_1_N : N ;
  get_nn_1_N : N ;
  gevaerspost_nn_1_1_N : N ;
  gevaerssmed_nn_1_1_N : N ;
  ghanan_nn_1_N : N ;
  ghanes_nn_1_N : N ;
  gibbon_nn_1_N : N ;
  giftbok_nn_1_N : N ;
  giftgas_nn_1_N : N ;
  gifthalt_nn_1_N : N ;
  giftighet_nn_1_N : N ;
  giftinformation_nn_1_N : N ;
  giftinjektion_nn_1_N : N ;
  giftmaengd_nn_1_1_N : N ;
  gifttransport_nn_1_N : N ;
  gigant_nn_1_N : N ;
  giljarfaerd_nn_1_1_N : N ;
  giljotin_nn_1_N : N ;
  gillessocialism_nn_1_N : N ;
  giltighet_nn_1_N : N ;
  giltighetstid_nn_1_N : N ;
  ginseng_nn_2_N : N ;
  ginst_nn_1_N : N ;
  gipsbyst_nn_1_N : N ;
  girighet_nn_1_N : N ;
  girland_nn_1_N : N ;
  girlang_nn_1_N : N ;
  gisslansituation_nn_1_N : N ;
  gitarrist_nn_1_N : N ;
  givmildhet_nn_1_N : N ;
  glaciolog_nn_1_N : N ;
  glaciaer_nn_1_1_N : N ;
  glaciaernisch_nn_1_1_N : N ;
  gladiator_nn_1_N : N ;
  glasighet_nn_1_N : N ;
  glaskaraff_nn_1_N : N ;
  glasmaestardiamant_nn_1_1_N : N ;
  glaspokal_nn_1_N : N ;
  glassbomb_nn_1_N : N ;
  glasskaerardiamant_nn_1_1_N : N ;
  glasvakt_nn_1_N : N ;
  glidfriktion_nn_1_N : N ;
  glidkontakt_nn_1_N : N ;
  glisoert_nn_1_1_N : N ;
  glittergirlang_nn_1_N : N ;
  glob_nn_1_N : N ;
  glycerid_nn_1_N : N ;
  glycin_nn_1_N : N ;
  glykol_nn_1_N : N ;
  glykopeptid_nn_1_N : N ;
  glaedjedans_nn_1_1_N : N ;
  glaedjefest_nn_1_1_N : N ;
  glaedjekalkyl_nn_1_1_N : N ;
  glaettighet_nn_1_1_N : N ;
  glaamighet_nn_1_1_N : N ;
  gloed_nn_1_1_N : N ;
  gloedlampsfabrik_nn_1_1_N : N ;
  gnejs_nn_1_N : N ;
  gnet_nn_1_N : N ;
  gnidningselektricitet_nn_1_N : N ;
  gnistinduktor_nn_1_N : N ;
  gniststation_nn_1_N : N ;
  gnom_nn_1_N : N ;
  gnomon_nn_1_N : N ;
  gnosticism_nn_1_N : N ;
  gnuggbild_nn_1_N : N ;
  godhet_nn_1_N : N ;
  godhjaertenhet_nn_1_1_N : N ;
  godsak_nn_1_N : N ;
  godsexpedition_nn_1_N : N ;
  godsstation_nn_1_N : N ;
  godsterminal_nn_1_N : N ;
  godstransport_nn_1_N : N ;
  godtycklighet_nn_1_N : N ;
  golvfaerg_nn_1_1_N : N ;
  gon_nn_1_N : N ;
  gondol_nn_1_N : N ;
  gonorr_e_nn_1_1_N : N ;
  gorgon_nn_1_N : N ;
  gosskoer_nn_1_1_N : N ;
  got_nn_1_N : N ;
  gourm_e_nn_1_1_N : N ;
  grad_nn_1_N : N ;
  gradation_nn_1_N : N ;
  gradlist_nn_1_N : N ;
  gradskillnad_nn_1_N : N ;
  gradaeng_nn_1_1_N : N ;
  graf_nn_1_N : N ;
  grafen_nn_1_N : N ;
  grafit_nn_1_N : N ;
  grafolog_nn_1_N : N ;
  grammatik_nn_1_N : N ;
  grammatikbok_nn_1_N : N ;
  grammofon_nn_1_N : N ;
  grammolekyl_nn_1_N : N ;
  granatattack_nn_1_N : N ;
  granatkartesch_nn_1_N : N ;
  granimitation_nn_1_N : N ;
  granit_nn_1_N : N ;
  grannfastighet_nn_1_N : N ;
  grannfejd_nn_1_N : N ;
  grannlagenhet_nn_1_N : N ;
  grannstat_nn_1_N : N ;
  granskningskommission_nn_1_N : N ;
  granskningsnaemnd_nn_1_1_N : N ;
  gransort_nn_1_N : N ;
  granulation_nn_1_N : N ;
  granulationsvaevnad_nn_1_1_N : N ;
  gratialist_nn_1_N : N ;
  gratifikation_nn_1_N : N ;
  gratin_nn_1_N : N ;
  gratisplats_nn_1_N : N ;
  gratulant_nn_1_N : N ;
  gratulation_nn_1_N : N ;
  grataeng_nn_1_1_N : N ;
  gravation_nn_1_N : N ;
  gravbyggnad_nn_1_N : N ;
  gravdikt_nn_1_N : N ;
  gravenstein_nn_1_N : N ;
  graviditet_nn_1_N : N ;
  graviditetsdagbok_nn_1_N : N ;
  gravitation_nn_1_N : N ;
  gravitationskollaps_nn_1_N : N ;
  gravitationskonstant_nn_1_N : N ;
  gravitet_nn_1_N : N ;
  graviton_nn_1_N : N ;
  gravplats_nn_1_N : N ;
  gravyr_nn_1_N : N ;
  gravyrmaskin_nn_1_N : N ;
  grecism_nn_1_N : N ;
  greppbarhet_nn_2_N : N ;
  grillbar_nn_1_N : N ;
  grimas_nn_1_N : N ;
  grinighet_nn_1_N : N ;
  grisfest_nn_1_N : N ;
  grisskandal_nn_1_N : N ;
  grobarhet_nn_1_N : N ;
  grobian_nn_1_N : N ;
  grossess_nn_1_N : N ;
  grossist_nn_1_N : N ;
  grotesk_nn_1_N : N ;
  grovhet_nn_1_N : N ;
  grovkornighet_nn_2_N : N ;
  grumlighet_nn_1_N : N ;
  grundavgift_nn_1_N : N ;
  grundbok_nn_1_N : N ;
  grundenhet_nn_1_N : N ;
  grundfond_nn_1_N : N ;
  grundform_nn_1_N : N ;
  grundfaerg_nn_1_1_N : N ;
  grundkurs_nn_1_N : N ;
  grundlighet_nn_1_N : N ;
  grundloen_nn_1_1_N : N ;
  grundorsak_nn_1_N : N ;
  grundplan_nn_1_N : N ;
  grundsats_nn_1_N : N ;
  grundskatt_nn_1_N : N ;
  grundtes_nn_1_N : N ;
  grundtext_nn_1_N : N ;
  grundton_nn_1_N : N ;
  grupp_nn_1_N : N ;
  gruppbild_nn_1_N : N ;
  gruppchef_nn_1_N : N ;
  gruppgenitiv_nn_1_N : N ;
  gruppidentitet_nn_1_N : N ;
  grusplan_nn_1_N : N ;
  gruvexplosion_nn_1_N : N ;
  gruvkompass_nn_1_N : N ;
  gruvlighet_nn_1_N : N ;
  gruvstrejk_nn_1_N : N ;
  grymhet_nn_1_N : N ;
  grymthastighet_nn_1_N : N ;
  grynighet_nn_1_N : N ;
  graeddfil_nn_2_1_N : N ;
  graeddhalt_nn_1_1_N : N ;
  graens_nn_1_1_N : N ;
  graensbastion_nn_1_1_N : N ;
  graenskontroll_nn_1_1_N : N ;
  graenskostnad_nn_1_1_N : N ;
  graenspolis_nn_2_1_N : N ;
  graenssnittsdokumentation_nn_1_1_N : N ;
  graensvakt_nn_1_1_N : N ;
  graesklippningsmaskin_nn_1_1_N : N ;
  graeslighet_nn_1_1_N : N ;
  graesmaanad_nn_1_1_N : N ;
  graesplan_nn_1_1_N : N ;
  graesrotskampanj_nn_1_1_N : N ;
  graesvaext_nn_1_1_N : N ;
  graevargeneration_nn_1_1_N : N ;
  graevarjournalist_nn_1_1_N : N ;
  graevgrupp_nn_1_1_N : N ;
  graevmaskin_nn_1_1_N : N ;
  graanad_nn_1_1_N : N ;
  graasossefalang_nn_1_1_N : N ;
  graatattack_nn_1_1_N : N ;
  graaton_nn_1_1_N : N ;
  graazon_nn_1_1_N : N ;
  groenalg_nn_1_1_N : N ;
  groenmognad_nn_1_1_N : N ;
  groenraett_nn_1_1_N : N ;
  groensak_nn_1_1_N : N ;
  groensallad_nn_1_1_N : N ;
  guatemalan_nn_1_N : N ;
  guayanan_nn_1_N : N ;
  gudabild_nn_1_N : N ;
  gudadryck_nn_1_N : N ;
  gudomlighet_nn_1_N : N ;
  gudsbild_nn_1_N : N ;
  gudstjaenst_nn_1_1_N : N ;
  gudstjaenstfrekvens_nn_1_1_N : N ;
  gudstjaensttid_nn_1_1_N : N ;
  guinean_nn_1_N : N ;
  gulasch_nn_2_N : N ;
  gulaschbaron_nn_1_N : N ;
  gulddukat_nn_1_N : N ;
  guldfasan_nn_1_N : N ;
  guldfestong_nn_1_N : N ;
  guldhalt_nn_1_N : N ;
  guldkant_nn_1_N : N ;
  guldrusch_nn_1_N : N ;
  guldrush_nn_1_N : N ;
  guldsmed_nn_1_N : N ;
  guldspadejury_nn_1_N : N ;
  guldstrid_nn_1_N : N ;
  gullighet_nn_1_N : N ;
  gulnad_nn_1_N : N ;
  gunst_nn_1_N : N ;
  gurklist_nn_1_N : N ;
  gurkvaext_nn_1_1_N : N ;
  gustavian_nn_1_N : N ;
  guttural_nn_1_N : N ;
  guvernant_nn_1_N : N ;
  guvernoer_nn_1_1_N : N ;
  guyanan_nn_1_N : N ;
  gyckelbild_nn_1_N : N ;
  gymnasieekonom_nn_1_N : N ;
  gymnasieingenjoer_nn_1_1_N : N ;
  gymnasieinspektoer_nn_1_1_N : N ;
  gymnasist_nn_1_N : N ;
  gymnast_nn_1_N : N ;
  gymnastikdirektoer_nn_1_1_N : N ;
  gymnastikdraekt_nn_1_1_N : N ;
  gymnastiklektion_nn_1_N : N ;
  gynekolog_nn_1_N : N ;
  gyrokompass_nn_1_N : N ;
  gyroskopkompass_nn_1_N : N ;
  gyrostabilisator_nn_1_N : N ;
  gaeckmast_nn_1_1_N : N ;
  gael_nn_2_1_N : N ;
  gaems_nn_1_1_N : N ;
  gaenginsats_nn_1_1_N : N ;
  gaengverktygssats_nn_1_1_N : N ;
  gaerningsmannaprofilgrupp_nn_1_1_N : N ;
  gaerningsort_nn_1_1_N : N ;
  gaerningsperson_nn_1_1_N : N ;
  gaest_nn_1_1_N : N ;
  gaestatom_nn_1_1_N : N ;
  gaestbok_nn_1_1_N : N ;
  gaestmolekyl_nn_1_1_N : N ;
  gaestroll_nn_1_1_N : N ;
  gaang_nn_2_1_N : N ;
  gaangjaernsled_nn_1_1_N : N ;
  gaangled_nn_1_1_N : N ;
  gaardsplan_nn_1_1_N : N ;
  gaardsplats_nn_1_1_N : N ;
  gaatfullhet_nn_1_1_N : N ;
  gaavoskatt_nn_1_1_N : N ;
  goejemaanad_nn_1_1_N : N ;
  goet_nn_3_13_N : N ;
  goeticism_nn_1_1_N : N ;
  habilitet_nn_1_N : N ;
  habit_nn_1_N : N ;
  hagmark_nn_1_N : N ;
  hakparentes_nn_1_N : N ;
  halkrisk_nn_1_N : N ;
  halltelefon_nn_1_N : N ;
  hallucination_nn_1_N : N ;
  hallucinogen_nn_1_N : N ;
  halmmadrass_nn_1_N : N ;
  halsfluss_nn_1_N : N ;
  halskatarr_nn_1_N : N ;
  halt_nn_1_N : N ;
  halvbild_nn_1_N : N ;
  halvbutelj_nn_1_N : N ;
  halvfigur_nn_1_N : N ;
  halvfaerdighet_nn_1_1_N : N ;
  halvhet_nn_1_N : N ;
  halvklass_nn_1_N : N ;
  halvledardiod_nn_1_N : N ;
  halvlitersbutelj_nn_1_N : N ;
  halvpension_nn_1_N : N ;
  halvtid_nn_1_N : N ;
  halvton_nn_1_N : N ;
  hamburgarbar_nn_1_N : N ;
  hamburgarrestaurang_nn_1_N : N ;
  hamburgerbar_nn_1_N : N ;
  hamburgerrestaurang_nn_1_N : N ;
  hamit_nn_1_N : N ;
  hammarattack_nn_1_N : N ;
  hamnarbetarstrejk_nn_1_N : N ;
  hamndirektion_nn_1_N : N ;
  handbok_nn_1_N : N ;
  handbollsmatch_nn_1_N : N ;
  handdator_nn_1_N : N ;
  handelsled_nn_1_N : N ;
  handelsplats_nn_1_N : N ;
  handelssanktion_nn_1_N : N ;
  handenhet_nn_1_N : N ;
  handfallenhet_nn_1_N : N ;
  handgranatduell_nn_1_N : N ;
  handgriplighet_nn_1_N : N ;
  handikappidrott_nn_1_N : N ;
  handikapporganisation_nn_1_N : N ;
  handkontroll_nn_1_N : N ;
  handkraem_nn_1_1_N : N ;
  handled_nn_1_N : N ;
  handlingsfrihet_nn_1_N : N ;
  handsbredd_nn_1_N : N ;
  handskrift_nn_1_N : N ;
  handstilsexpert_nn_1_N : N ;
  hangarversion_nn_1_N : N ;
  hanteringskostnad_nn_1_N : N ;
  hanteringsrisk_nn_1_N : N ;
  hantverkarsats_nn_1_N : N ;
  hantverksskicklighet_nn_1_N : N ;
  haremsdam_nn_1_N : N ;
  harlekin_nn_1_N : N ;
  harmloeshet_nn_1_1_N : N ;
  harpist_nn_1_N : N ;
  harpoton_nn_1_N : N ;
  hastighet_nn_1_N : N ;
  hastighetsgraens_nn_1_1_N : N ;
  hastighetskontroll_nn_1_N : N ;
  hatgrupp_nn_1_N : N ;
  haverikommission_nn_1_N : N ;
  haverist_nn_1_N : N ;
  havretraktor_nn_1_N : N ;
  havsanemon_nn_1_N : N ;
  havshorisont_nn_1_N : N ;
  havskajak_nn_1_N : N ;
  havsnivaa_nn_1_1_N : N ;
  havsorganism_nn_1_N : N ;
  havstulpan_nn_1_N : N ;
  havsvaext_nn_1_1_N : N ;
  hbt_person_nn_1_N : N ;
  hedersdoktor_nn_1_N : N ;
  hedersgaest_nn_1_1_N : N ;
  hederskonflikt_nn_1_N : N ;
  hederskultur_nn_1_N : N ;
  hedersplats_nn_1_N : N ;
  hederspost_nn_1_N : N ;
  hederssak_nn_1_N : N ;
  hedersvakt_nn_1_N : N ;
  hedmark_nn_1_N : N ;
  hednamission_nn_1_N : N ;
  hednatid_nn_1_N : N ;
  hedonism_nn_1_N : N ;
  hedonist_nn_1_N : N ;
  hejdloeshet_nn_1_1_N : N ;
  helbild_nn_1_N : N ;
  helbutelj_nn_1_N : N ;
  helfigur_nn_1_N : N ;
  helgonbild_nn_1_N : N ;
  helgonlegend_nn_1_N : N ;
  helgonstaty_nn_1_N : N ;
  helhet_nn_1_N : N ;
  helhetsbild_nn_1_N : N ;
  helighet_nn_1_N : N ;
  helikopterkrasch_nn_1_N : N ;
  helikopterkupp_nn_1_N : N ;
  helkroppsdos_nn_1_N : N ;
  hellenism_nn_1_N : N ;
  helpension_nn_1_N : N ;
  helsidesannons_nn_1_N : N ;
  heltid_nn_1_N : N ;
  heltidsloen_nn_1_1_N : N ;
  helton_nn_1_N : N ;
  hematit_nn_1_N : N ;
  hemdator_nn_1_N : N ;
  hemgalax_nn_1_N : N ;
  hemhoerighet_nn_1_1_N : N ;
  hemlighet_nn_1_N : N ;
  hemmahoerighet_nn_1_1_N : N ;
  hemmamatch_nn_1_N : N ;
  hemmaopinion_nn_1_N : N ;
  hemmaplan_nn_1_N : N ;
  hemort_nn_1_N : N ;
  hemsamarit_nn_1_N : N ;
  hemskhet_nn_1_N : N ;
  hemskillnad_nn_1_N : N ;
  hemtjaenst_nn_1_1_N : N ;
  hemtrevlighet_nn_1_N : N ;
  hemtrevnad_nn_2_N : N ;
  hemuppgift_nn_1_N : N ;
  hemvaernschef_nn_1_1_N : N ;
  hepatit_nn_1_N : N ;
  herbicid_nn_1_N : N ;
  herdedikt_nn_1_N : N ;
  hermafrodit_nn_1_N : N ;
  hermelin_nn_1_N : N ;
  heroinist_nn_1_N : N ;
  heroism_nn_1_N : N ;
  heros_nn_1_N : N ;
  herrgaardsbyggnad_nn_1_1_N : N ;
  herrnhutism_nn_1_N : N ;
  heshet_nn_1_N : N ;
  heteroklis_nn_1_N : N ;
  heteronorm_nn_1_N : N ;
  heteronormativitet_nn_1_N : N ;
  heterozygot_nn_1_N : N ;
  hetman_nn_1_N : N ;
  hetsighet_nn_1_N : N ;
  hetsjakt_nn_1_N : N ;
  hettit_nn_1_N : N ;
  hibernation_nn_1_N : N ;
  hieroglyfinskrift_nn_1_N : N ;
  higgsboson_nn_1_N : N ;
  himmelsfaerd_nn_1_1_N : N ;
  himmelsglob_nn_1_N : N ;
  himmelshoejd_nn_1_1_N : N ;
  hinduism_nn_1_N : N ;
  hippolog_nn_1_N : N ;
  hiskelighet_nn_1_N : N ;
  hisklighet_nn_1_N : N ;
  hissinstallation_nn_1_N : N ;
  histolog_nn_1_N : N ;
  historicism_nn_1_N : N ;
  historiebok_nn_1_N : N ;
  historierevisionist_nn_1_N : N ;
  historievetenskap_nn_1_N : N ;
  historism_nn_1_N : N ;
  histrion_nn_1_N : N ;
  hjulbas_nn_1_N : N ;
  hjulsats_nn_1_N : N ;
  hjaelmprydnad_nn_1_1_N : N ;
  hjaelpklass_nn_1_1_N : N ;
  hjaelpmotor_nn_1_1_N : N ;
  hjaelporganisation_nn_1_1_N : N ;
  hjaelpsamhet_nn_1_1_N : N ;
  hjaelpvetenskap_nn_1_1_N : N ;
  hjaeltedikt_nn_1_1_N : N ;
  hjaelteroll_nn_1_1_N : N ;
  hjaernaktivitet_nn_1_1_N : N ;
  hjaerncell_nn_1_1_N : N ;
  hjaernhinneinflammation_nn_1_1_N : N ;
  hjaerninflammation_nn_1_1_N : N ;
  hjaernoperation_nn_1_1_N : N ;
  hjaerntrust_nn_1_1_N : N ;
  hjaernvolym_nn_1_1_N : N ;
  hjaertaktivitet_nn_1_1_N : N ;
  hjaerteangelaegenhet_nn_1_1_N : N ;
  hjaertefroejd_nn_1_1_N : N ;
  hjaertesak_nn_1_1_N : N ;
  hjaertesorg_nn_1_1_N : N ;
  hjaertetrakt_nn_1_1_N : N ;
  hjaertinnerlighet_nn_1_1_N : N ;
  hjaertkirurg_nn_1_1_N : N ;
  hjaertlighet_nn_1_1_N : N ;
  hjaertloeshet_nn_1_1_N : N ;
  hjaertoperation_nn_1_1_N : N ;
  hjaertrytm_nn_1_1_N : N ;
  hjaerttrakt_nn_1_1_N : N ;
  hjaerttransplantation_nn_1_1_N : N ;
  hjaertverksamhet_nn_1_1_N : N ;
  hmong_nn_1_N : N ;
  holism_nn_1_N : N ;
  holonym_nn_1_N : N ;
  homofon_nn_1_N : N ;
  homogenitet_nn_1_N : N ;
  homograf_nn_1_N : N ;
  homokultur_nn_1_N : N ;
  homonym_nn_1_N : N ;
  homosexualitet_nn_1_N : N ;
  homozygot_nn_1_N : N ;
  honduran_nn_1_N : N ;
  honnoerspost_nn_1_1_N : N ;
  honungsmelon_nn_1_N : N ;
  honungsproducent_nn_1_N : N ;
  hoplit_nn_1_N : N ;
  hoppfullhet_nn_1_N : N ;
  hopploeshet_nn_1_1_N : N ;
  hormonbalans_nn_1_N : N ;
  hormonfunktion_nn_1_N : N ;
  hormonhalt_nn_1_N : N ;
  hormonproduktion_nn_1_N : N ;
  hornist_nn_1_N : N ;
  hostattack_nn_1_N : N ;
  hotbild_nn_1_N : N ;
  hotellfoaj_e_nn_1_1_N : N ;
  hotellgaest_nn_1_1_N : N ;
  hotellobby_nn_1_N : N ;
  hotfullhet_nn_1_N : N ;
  hotnivaa_nn_1_1_N : N ;
  hovdam_nn_1_N : N ;
  hovleverantoer_nn_1_1_N : N ;
  hovpredikant_nn_1_N : N ;
  hovraett_nn_1_1_N : N ;
  hudcancerform_nn_1_N : N ;
  hudcell_nn_1_N : N ;
  hudfaerg_nn_1_1_N : N ;
  hudinflammation_nn_1_N : N ;
  hudspecialist_nn_1_N : N ;
  hudterapeut_nn_1_N : N ;
  hudtransplantation_nn_1_N : N ;
  hugnad_nn_1_N : N ;
  huligan_nn_1_N : N ;
  humanism_nn_1_N : N ;
  humanist_nn_1_N : N ;
  humanitet_nn_1_N : N ;
  humanvetenskap_nn_1_N : N ;
  hummersaas_nn_1_1_N : N ;
  humoresk_nn_1_N : N ;
  humorist_nn_1_N : N ;
  humushalt_nn_1_N : N ;
  humuskoncentration_nn_1_N : N ;
  humussubstans_nn_1_N : N ;
  hundkurs_nn_1_N : N ;
  hundras_nn_1_N : N ;
  hundskatt_nn_1_N : N ;
  hundskulptur_nn_1_N : N ;
  hundvakt_nn_1_N : N ;
  hungerstrejk_nn_1_N : N ;
  hunn_nn_1_N : N ;
  husarloejtnant_nn_1_1_N : N ;
  husbyggnad_nn_1_N : N ;
  husdoktor_nn_1_N : N ;
  husfasad_nn_1_N : N ;
  husgrund_nn_1_N : N ;
  hushaallsbok_nn_1_1_N : N ;
  huspredikant_nn_1_N : N ;
  husrad_nn_1_N : N ;
  hustomt_nn_1_N : N ;
  hutloeshet_nn_1_1_N : N ;
  huvudanstalt_nn_1_N : N ;
  huvudbok_nn_1_N : N ;
  huvudbonad_nn_1_N : N ;
  huvudbyggnad_nn_1_N : N ;
  huvudentr_e_nn_1_1_N : N ;
  huvudfasad_nn_1_N : N ;
  huvudfigur_nn_1_N : N ;
  huvudform_nn_1_N : N ;
  huvudfunktion_nn_1_N : N ;
  huvudinkomst_nn_1_N : N ;
  huvudled_nn_1_N : N ;
  huvudloeshet_nn_1_1_N : N ;
  huvudmotor_nn_1_N : N ;
  huvudorsak_nn_1_N : N ;
  huvudort_nn_1_N : N ;
  huvudperson_nn_1_N : N ;
  huvudpunkt_nn_1_N : N ;
  huvudroll_nn_1_N : N ;
  huvudraett_nn_1_1_N : N ;
  huvudsak_nn_1_N : N ;
  huvudsats_nn_1_N : N ;
  huvudton_nn_1_N : N ;
  huvudtrakt_nn_1_N : N ;
  huvuduppgift_nn_1_N : N ;
  hybrid_nn_1_N : N ;
  hydrofon_nn_1_N : N ;
  hydrokultur_nn_1_N : N ;
  hydrolog_nn_1_N : N ;
  hydrolys_nn_1_N : N ;
  hydroxid_nn_1_N : N ;
  hydroxidjon_nn_1_N : N ;
  hygglighet_nn_1_N : N ;
  hygienist_nn_1_N : N ;
  hygienkampanj_nn_1_N : N ;
  hyllningsdikt_nn_1_N : N ;
  hyllningssaang_nn_1_1_N : N ;
  hylsnyckelsats_nn_1_N : N ;
  hylssats_nn_1_N : N ;
  hyperbol_nn_1_N : N ;
  hyperinflation_nn_1_N : N ;
  hyperit_nn_1_N : N ;
  hypernym_nn_1_N : N ;
  hyperonym_nn_1_N : N ;
  hypersvecism_nn_1_N : N ;
  hypertext_nn_1_N : N ;
  hypnos_nn_1_N : N ;
  hypnoskurs_nn_1_N : N ;
  hypnotism_nn_1_N : N ;
  hypofys_nn_1_N : N ;
  hypokrit_nn_1_N : N ;
  hyponym_nn_1_N : N ;
  hypotes_nn_1_N : N ;
  hyresgaest_nn_1_1_N : N ;
  hyreslaegenhet_nn_1_1_N : N ;
  hyresmarknad_nn_1_N : N ;
  hyresnaemnd_nn_1_1_N : N ;
  hyresraett_nn_1_1_N : N ;
  hyresstrejk_nn_1_N : N ;
  hyrestvist_nn_1_N : N ;
  hyvelbredd_nn_1_N : N ;
  haeckningsplats_nn_1_1_N : N ;
  haeftpistol_nn_1_1_N : N ;
  haegnad_nn_1_1_N : N ;
  haektesvakt_nn_1_1_N : N ;
  haektningstid_nn_1_1_N : N ;
  haellkonst_nn_1_1_N : N ;
  haellmark_nn_1_1_N : N ;
  haelsningsfras_nn_1_1_N : N ;
  haelsodryck_nn_1_1_N : N ;
  haelsofantast_nn_1_1_N : N ;
  haelsofarlighet_nn_1_1_N : N ;
  haelsokontroll_nn_1_1_N : N ;
  haelsorisk_nn_1_1_N : N ;
  haelsovaadlighet_nn_1_1_N : N ;
  haelsovaardskostnad_nn_1_1_N : N ;
  haelsovaardsnaemnd_nn_1_1_N : N ;
  haemndaktion_nn_1_1_N : N ;
  haemndattack_nn_1_1_N : N ;
  haemndeaktion_nn_1_1_N : N ;
  haemndlystnad_nn_1_1_N : N ;
  haemndrekyl_nn_1_1_N : N ;
  haemningsloeshet_nn_1_1_N : N ;
  haendelsehorisont_nn_1_1_N : N ;
  haengkoj_nn_1_1_N : N ;
  haensynsfullhet_nn_1_1_N : N ;
  haensynsloeshet_nn_1_1_N : N ;
  haenthet_nn_1_1_N : N ;
  haepnad_nn_1_1_N : N ;
  haeradsraett_nn_1_1_N : N ;
  haerdighet_nn_1_1_N : N ;
  haerdningstid_nn_1_1_N : N ;
  haerdplast_nn_1_1_N : N ;
  haerdtid_nn_1_1_N : N ;
  haerlighet_nn_1_1_N : N ;
  haernad_nn_1_1_N : N ;
  haerskarfamilj_nn_1_1_N : N ;
  haerskarklass_nn_1_1_N : N ;
  haesthovsoert_nn_1_1_N : N ;
  haestkastanj_nn_1_1_N : N ;
  haestras_nn_1_1_N : N ;
  haestskomagnet_nn_1_1_N : N ;
  haeststaty_nn_1_1_N : N ;
  haesttjej_nn_1_1_N : N ;
  haetskhet_nn_1_1_N : N ;
  haexdans_nn_1_1_N : N ;
  haexjakt_nn_1_1_N : N ;
  haexkonspiration_nn_1_1_N : N ;
  haexkonst_nn_1_1_N : N ;
  haexkraft_nn_1_1_N : N ;
  haexprocess_nn_1_1_N : N ;
  haagkomst_nn_1_1_N : N ;
  haalighet_nn_1_1_N : N ;
  haallbarhet_nn_1_1_N : N ;
  haalldam_nn_1_1_N : N ;
  haallfasthet_nn_1_1_N : N ;
  haallplats_nn_1_1_N : N ;
  haallpunkt_nn_1_1_N : N ;
  haalltid_nn_1_1_N : N ;
  haanfullhet_nn_1_1_N : N ;
  haarbeklaednad_nn_1_1_N : N ;
  haardhet_nn_2_1_N : N ;
  haardplast_nn_1_1_N : N ;
  haarfrisoer_nn_1_1_N : N ;
  haarfaerg_nn_1_1_N : N ;
  haarvegetation_nn_1_1_N : N ;
  hoeftled_nn_1_1_N : N ;
  hoeftledsoperation_nn_1_1_N : N ;
  hoegenergikollision_nn_1_1_N : N ;
  hoegerkoalition_nn_1_1_N : N ;
  hoegermajoritet_nn_1_1_N : N ;
  hoegermyt_nn_1_1_N : N ;
  hoegform_nn_2_1_N : N ;
  hoegfrekvens_nn_1_1_N : N ;
  hoeghet_nn_1_1_N : N ;
  hoegkonjunktur_nn_1_1_N : N ;
  hoegkultur_nn_1_1_N : N ;
  hoegmaalsprocess_nn_1_1_N : N ;
  hoegplataa_nn_1_1_N : N ;
  hoegrestaandsdam_nn_1_1_N : N ;
  hoegrestaandskultur_nn_1_1_N : N ;
  hoegriskfond_nn_1_1_N : N ;
  hoegriskmatch_nn_1_1_N : N ;
  hoegskolelektor_nn_1_1_N : N ;
  hoegskoleplats_nn_1_1_N : N ;
  hoegsaesong_nn_1_1_N : N ;
  hoegtidlighet_nn_1_1_N : N ;
  hoegtidsdraekt_nn_1_1_N : N ;
  hoegvakt_nn_1_1_N : N ;
  hoegvoerdighet_nn_1_1_N : N ;
  hoejd_nn_1_1_N : N ;
  hoejdskillnad_nn_1_1_N : N ;
  hoerbarhet_nn_1_1_N : N ;
  hoerselklass_nn_1_1_N : N ;
  hoertelefon_nn_1_1_N : N ;
  hoestkantarell_nn_1_1_N : N ;
  hoestmaanad_nn_1_1_N : N ;
  hoestslakt_nn_1_1_N : N ;
  hoestsaesong_nn_1_1_N : N ;
  hoesttermin_nn_1_1_N : N ;
  hoeviskhet_nn_1_1_N : N ;
  hoevlighet_nn_1_1_N : N ;
  hoevlighetsvisit_nn_1_1_N : N ;
  icke_muslim_nn_1_N : N ;
  icke_specialist_nn_1_N : N ;
  ickevaaldsentusiast_nn_1_1_N : N ;
  idealbild_nn_1_N : N ;
  idealism_nn_1_N : N ;
  idealist_nn_1_N : N ;
  idealitet_nn_1_N : N ;
  identifikation_nn_1_N : N ;
  identifikationsprocess_nn_1_N : N ;
  identitet_nn_1_N : N ;
  identitetskris_nn_1_N : N ;
  ideolog_nn_1_N : N ;
  idol_nn_1_N : N ;
  idrott_nn_1_N : N ;
  idrottsdraekt_nn_1_1_N : N ;
  idrottsplats_nn_1_N : N ;
  idrottsprestation_nn_1_N : N ;
  id_eassociation_nn_1_1_N : N ;
  igenkaenningsfaktor_nn_1_1_N : N ;
  igenkaenningssignal_nn_1_1_N : N ;
  ignorant_nn_1_N : N ;
  ihaagkomst_nn_1_1_N : N ;
  ihaalighet_nn_1_1_N : N ;
  ikon_nn_1_N : N ;
  ikonostas_nn_1_N : N ;
  iktyolog_nn_1_N : N ;
  illegalitet_nn_1_N : N ;
  illegitimitet_nn_1_N : N ;
  illslughet_nn_1_N : N ;
  illumination_nn_1_N : N ;
  illusion_nn_1_N : N ;
  illusionist_nn_1_N : N ;
  illusionsloeshet_nn_1_1_N : N ;
  illustration_nn_1_N : N ;
  illvillighet_nn_1_N : N ;
  illyr_nn_1_N : N ;
  ilmarsch_nn_1_N : N ;
  imitation_nn_1_N : N ;
  immatrikulation_nn_1_N : N ;
  immigrant_nn_1_N : N ;
  immigration_nn_1_N : N ;
  immission_nn_1_N : N ;
  immunbrist_nn_1_N : N ;
  immunitet_nn_1_N : N ;
  immunolog_nn_1_N : N ;
  imperativ_nn_1_N : N ;
  imperator_nn_1_N : N ;
  imperialism_nn_1_N : N ;
  imperialist_nn_1_N : N ;
  impertinens_nn_1_N : N ;
  implikation_nn_1_N : N ;
  implosion_nn_1_N : N ;
  impopularitet_nn_1_N : N ;
  import_nn_1_N : N ;
  importavgift_nn_1_N : N ;
  importkvot_nn_1_N : N ;
  impost_nn_1_N : N ;
  impressionism_nn_1_N : N ;
  impressionist_nn_1_N : N ;
  improvisation_nn_1_N : N ;
  impuls_nn_1_N : N ;
  impulsivitet_nn_1_N : N ;
  inadvertens_nn_1_N : N ;
  inaktivitet_nn_1_N : N ;
  inauguration_nn_1_N : N ;
  inbilskhet_nn_1_N : N ;
  inbjudningsskrift_nn_1_N : N ;
  incest_nn_1_N : N ;
  indelningsgrund_nn_1_N : N ;
  indelningsprincip_nn_1_N : N ;
  indian_nn_1_N : N ;
  indianbok_nn_1_N : N ;
  indifferentism_nn_1_N : N ;
  indigestion_nn_1_N : N ;
  indignation_nn_1_N : N ;
  indikation_nn_1_N : N ;
  indikativ_nn_1_N : N ;
  indikator_nn_1_N : N ;
  indiskretion_nn_1_N : N ;
  indisposition_nn_1_N : N ;
  individakt_nn_1_N : N ;
  individualism_nn_1_N : N ;
  individualist_nn_1_N : N ;
  individualitet_nn_1_N : N ;
  individualprevention_nn_1_N : N ;
  indolog_nn_1_N : N ;
  indones_nn_1_N : N ;
  induktion_nn_1_N : N ;
  induktionsmotor_nn_1_N : N ;
  induktor_nn_1_N : N ;
  industrialism_nn_1_N : N ;
  industridiamant_nn_1_N : N ;
  industriprodukt_nn_1_N : N ;
  industriregion_nn_1_N : N ;
  inessiv_nn_1_N : N ;
  infant_nn_1_N : N ;
  infanterimarsch_nn_1_N : N ;
  infanterist_nn_1_N : N ;
  infantilism_nn_1_N : N ;
  infartsled_nn_1_N : N ;
  infektion_nn_1_N : N ;
  infiltration_nn_1_N : N ;
  infinitiv_nn_1_N : N ;
  inflammation_nn_1_N : N ;
  inflation_nn_1_N : N ;
  inflationsfas_nn_1_N : N ;
  influens_nn_1_N : N ;
  influensamedicin_nn_1_N : N ;
  informant_nn_1_N : N ;
  information_nn_1_N : N ;
  informationsbroschyr_nn_1_N : N ;
  informationsbyraa_nn_1_1_N : N ;
  informationschef_nn_1_N : N ;
  informator_nn_1_N : N ;
  infrastruktur_nn_1_N : N ;
  infusion_nn_1_N : N ;
  ingefaersvaext_nn_1_1_N : N ;
  ingenjoer_nn_1_1_N : N ;
  ingenjoersstudent_nn_1_1_N : N ;
  ingenjoersvetenskap_nn_1_1_N : N ;
  ingeny_nn_1_N : N ;
  ingrediens_nn_1_N : N ;
  ingress_nn_1_N : N ;
  ingaangsloen_nn_1_1_N : N ;
  ingaangsmarsch_nn_1_1_N : N ;
  inhalation_nn_1_N : N ;
  inhalator_nn_1_N : N ;
  inhibitor_nn_1_N : N ;
  inhyseshjon_nn_1_N : N ;
  inhaegnad_nn_1_1_N : N ;
  initialsvaarighet_nn_1_1_N : N ;
  initiation_nn_1_N : N ;
  initiationsrit_nn_1_N : N ;
  injektion_nn_1_N : N ;
  injektor_nn_1_N : N ;
  inkaindian_nn_1_N : N ;
  inkarnation_nn_1_N : N ;
  inklination_nn_1_N : N ;
  inkomst_nn_1_N : N ;
  inkomstpost_nn_1_N : N ;
  inkomstskatt_nn_1_N : N ;
  inkomstskillnad_nn_1_N : N ;
  inkongruens_nn_1_N : N ;
  inkonsekvens_nn_1_N : N ;
  inkrustation_nn_1_N : N ;
  inkubation_nn_1_N : N ;
  inkvisition_nn_1_N : N ;
  inkvisitor_nn_1_N : N ;
  inledningsrad_nn_1_N : N ;
  inloggningsuppgift_nn_1_N : N ;
  inlaerningsplataa_nn_1_1_N : N ;
  inmarsch_nn_1_N : N ;
  inmatningsbredd_nn_1_N : N ;
  innehaallsanalys_nn_1_1_N : N ;
  innehaallsdeklaration_nn_1_1_N : N ;
  innervation_nn_1_N : N ;
  innovation_nn_1_N : N ;
  innovationskaskad_nn_1_N : N ;
  inokulation_nn_1_N : N ;
  inombordsmotor_nn_1_N : N ;
  inomhusidrott_nn_1_N : N ;
  inredningsdetalj_nn_1_N : N ;
  inredningsgenialitet_nn_1_N : N ;
  inremission_nn_1_N : N ;
  insats_nn_1_N : N ;
  insatslaegenhet_nn_1_1_N : N ;
  insekt_nn_1_N : N ;
  insekticid_nn_1_N : N ;
  insemination_nn_1_N : N ;
  insinuation_nn_1_N : N ;
  inskolningsprocess_nn_1_N : N ;
  inskrift_nn_1_N : N ;
  inskription_nn_1_N : N ;
  inskrivningsbok_nn_1_N : N ;
  inskraenkthet_nn_1_1_N : N ;
  insolation_nn_1_N : N ;
  inspektion_nn_1_N : N ;
  inspektor_nn_1_N : N ;
  inspektoer_nn_1_1_N : N ;
  inspiration_nn_1_N : N ;
  insprutningsmotor_nn_1_N : N ;
  instabilitet_nn_1_N : N ;
  installand_nn_1_N : N ;
  installation_nn_1_N : N ;
  installator_nn_1_N : N ;
  instans_nn_1_N : N ;
  institution_nn_1_N : N ;
  instruktion_nn_1_N : N ;
  instruktionsmanual_nn_1_N : N ;
  instruktoer_nn_1_1_N : N ;
  instrumentalist_nn_1_N : N ;
  instrumentation_nn_1_N : N ;
  instaellsamhet_nn_1_1_N : N ;
  insubordination_nn_1_N : N ;
  insufficiens_nn_1_N : N ;
  integralkalkyl_nn_1_N : N ;
  integration_nn_1_N : N ;
  integritet_nn_1_N : N ;
  intellektualism_nn_1_N : N ;
  intellektualist_nn_1_N : N ;
  intelligens_nn_1_N : N ;
  intelligenskvot_nn_1_N : N ;
  intendentur_nn_1_N : N ;
  intendenturtjaenst_nn_1_1_N : N ;
  intension_nn_1_N : N ;
  intensitet_nn_1_N : N ;
  intention_nn_1_N : N ;
  interaktion_nn_1_N : N ;
  interferens_nn_1_N : N ;
  interglacialtid_nn_1_N : N ;
  interjektion_nn_1_N : N ;
  internationalism_nn_1_N : N ;
  internationalist_nn_1_N : N ;
  internist_nn_1_N : N ;
  internutredningsgrupp_nn_1_N : N ;
  interpellant_nn_1_N : N ;
  interpellation_nn_1_N : N ;
  interpolation_nn_1_N : N ;
  interpretation_nn_1_N : N ;
  interpunktion_nn_1_N : N ;
  intervention_nn_1_N : N ;
  intighet_nn_1_N : N ;
  intimist_nn_1_N : N ;
  intimitet_nn_1_N : N ;
  intonation_nn_1_N : N ;
  intoxikation_nn_1_N : N ;
  intressegemenskap_nn_1_N : N ;
  intressegrupp_nn_1_N : N ;
  intressekonflikt_nn_1_N : N ;
  intresseorganisation_nn_1_N : N ;
  intrigant_nn_1_N : N ;
  introduktion_nn_1_N : N ;
  introduktionskurs_nn_1_N : N ;
  introspektion_nn_1_N : N ;
  introversion_nn_1_N : N ;
  intraedesavgift_nn_1_1_N : N ;
  intubation_nn_1_N : N ;
  intuition_nn_1_N : N ;
  intaektsmoejlighet_nn_1_1_N : N ;
  inuit_nn_1_N : N ;
  invalid_nn_1_N : N ;
  invaliditet_nn_1_N : N ;
  invandrargrupp_nn_1_N : N ;
  invandrarklass_nn_1_N : N ;
  invandrarteatergrupp_nn_1_N : N ;
  invandringskvot_nn_1_N : N ;
  invasion_nn_1_N : N ;
  invasionsarm_e_nn_1_1_N : N ;
  inventariebok_nn_1_N : N ;
  invers_nn_1_N : N ;
  inversion_nn_1_N : N ;
  investeringsfond_nn_1_N : N ;
  investeringsform_nn_1_N : N ;
  invintringsprocess_nn_1_N : N ;
  invit_nn_1_N : N ;
  invitation_nn_1_N : N ;
  invokation_nn_1_N : N ;
  irredentism_nn_1_N : N ;
  irreligiositet_nn_1_N : N ;
  irrfaerd_nn_1_1_N : N ;
  irrigation_nn_1_N : N ;
  irritation_nn_1_N : N ;
  isbrytarassistans_nn_1_N : N ;
  isbrytaregenskap_nn_1_N : N ;
  isjakt_nn_1_N : N ;
  iskant_nn_1_N : N ;
  iskonvalj_nn_1_N : N ;
  iskristall_nn_1_N : N ;
  islamism_nn_1_N : N ;
  islamist_nn_1_N : N ;
  ism_nn_1_N : N ;
  isobar_nn_1_N : N ;
  isogloss_nn_1_N : N ;
  isogon_nn_1_N : N ;
  isolationism_nn_1_N : N ;
  isolator_nn_1_N : N ;
  isoleringsklass_nn_1_N : N ;
  isomer_nn_1_N : N ;
  israelit_nn_1_N : N ;
  israpport_nn_1_N : N ;
  isrevy_nn_1_N : N ;
  iteration_nn_1_N : N ;
  ivorian_nn_1_N : N ;
  jackett_nn_1_N : N ;
  jagillusion_nn_1_N : N ;
  jagsvaghet_nn_1_N : N ;
  jainism_nn_1_N : N ;
  jakobin_nn_1_N : N ;
  jakt_nn_1_N : N ;
  jaktavgift_nn_1_N : N ;
  jaktexpedition_nn_1_N : N ;
  jaktmark_nn_1_N : N ;
  jakttrof_e_nn_1_1_N : N ;
  jamaican_nn_1_N : N ;
  jamaikan_nn_1_N : N ;
  jansenism_nn_1_N : N ;
  japan_nn_1_N : N ;
  japanes_nn_1_N : N ;
  japroposition_nn_1_N : N ;
  jaroest_nn_1_1_N : N ;
  jasmin_nn_1_N : N ;
  javan_nn_1_N : N ;
  javanes_nn_1_N : N ;
  jemenit_nn_1_N : N ;
  jesuit_nn_1_N : N ;
  jetmotor_nn_1_N : N ;
  jingoism_nn_1_N : N ;
  jobbighet_nn_2_N : N ;
  jobbprognos_nn_1_N : N ;
  jobbras_nn_1_N : N ;
  jobbsoekaraktivitet_nn_1_1_N : N ;
  jobspost_nn_1_N : N ;
  jockej_nn_1_N : N ;
  joggingtur_nn_1_N : N ;
  johannesoert_nn_1_1_N : N ;
  johannit_nn_1_N : N ;
  jon_nn_1_N : N ;
  jonisation_nn_1_N : N ;
  joniseringstendens_nn_1_N : N ;
  jonkill_nn_1_N : N ;
  jonkvill_nn_1_N : N ;
  jordanalys_nn_1_N : N ;
  jordart_nn_1_N : N ;
  jordbruksmark_nn_1_N : N ;
  jordbruksmaskin_nn_1_N : N ;
  jordbruksnaemnd_nn_1_1_N : N ;
  jordbruksprodukt_nn_1_N : N ;
  jordbruksreform_nn_1_N : N ;
  jordebok_nn_1_N : N ;
  jordfaerg_nn_1_1_N : N ;
  jordglob_nn_1_N : N ;
  jordmagnetism_nn_1_N : N ;
  jordreform_nn_1_N : N ;
  jordrotation_nn_1_N : N ;
  jordskalvsaktivist_nn_1_N : N ;
  jordtroetthet_nn_1_1_N : N ;
  jordtyp_nn_1_N : N ;
  jorsskalvsaktivist_nn_1_N : N ;
  jos_nn_1_N : N ;
  jourbutik_nn_1_N : N ;
  journalfilm_nn_1_N : N ;
  journalist_nn_1_N : N ;
  jovialitet_nn_1_N : N ;
  jubeldoktor_nn_1_N : N ;
  jubelfest_nn_1_N : N ;
  jubelidiot_nn_1_N : N ;
  judenhet_nn_1_N : N ;
  julboen_nn_1_1_N : N ;
  juldekoration_nn_1_N : N ;
  julfest_nn_1_N : N ;
  julfilm_nn_1_N : N ;
  julgransprydnad_nn_1_N : N ;
  julgrupp_nn_1_N : N ;
  julsaang_nn_1_1_N : N ;
  jurisdiktion_nn_1_N : N ;
  jurist_nn_1_N : N ;
  jury_nn_1_N : N ;
  jus_nn_1_N : N ;
  justeringsmoejlighet_nn_1_1_N : N ;
  juvel_nn_1_N : N ;
  juveleraraffaer_nn_1_1_N : N ;
  juvelerarbutik_nn_1_N : N ;
  juverinflammation_nn_1_N : N ;
  juvervaevnad_nn_1_1_N : N ;
  juxtaposition_nn_1_N : N ;
  jaegarbataljon_nn_1_1_N : N ;
  jaegarloejtnant_nn_1_1_N : N ;
  jaeklighet_nn_1_1_N : N ;
  jaemfoerelsetjaenst_nn_1_1_N : N ;
  jaemlikhet_nn_1_1_N : N ;
  jaemmerlighet_nn_1_1_N : N ;
  jaemstaelldhet_nn_1_1_N : N ;
  jaemstaelldhetsdiskussion_nn_1_1_N : N ;
  jaernkatastrof_nn_1_1_N : N ;
  jaernmanufaktur_nn_1_1_N : N ;
  jaernoxid_nn_1_1_N : N ;
  jaernproduktion_nn_1_1_N : N ;
  jaernridaa_nn_1_1_N : N ;
  jaernsulfid_nn_1_1_N : N ;
  jaernvaegssignal_nn_1_1_N : N ;
  jaernvaegsstation_nn_1_1_N : N ;
  jaernvaegsstrejk_nn_1_1_N : N ;
  jaernvaegsviadukt_nn_1_1_N : N ;
  jaernoert_nn_1_1_N : N ;
  jaetteraed_nn_1_1_N : N ;
  jaettetyfon_nn_1_1_N : N ;
  jaevlighet_nn_1_1_N : N ;
  kabal_nn_1_N : N ;
  kabar_e_nn_1_1_N : N ;
  kabbalism_nn_1_N : N ;
  kabbalist_nn_1_N : N ;
  kabellaengd_nn_1_1_N : N ;
  kabin_nn_1_N : N ;
  kabyl_nn_1_N : N ;
  kabyss_nn_1_N : N ;
  kadaverlydnad_nn_1_N : N ;
  kadens_nn_1_N : N ;
  kadettkaar_nn_1_1_N : N ;
  kadmiumjon_nn_1_N : N ;
  kafferast_nn_1_N : N ;
  kaftan_nn_1_N : N ;
  kajman_nn_1_N : N ;
  kajplats_nn_1_N : N ;
  kajutpost_nn_1_N : N ;
  kakelugnsnisch_nn_1_N : N ;
  kakiuniform_nn_1_N : N ;
  kakt_e_nn_1_1_N : N ;
  kalabass_nn_1_N : N ;
  kalamitet_nn_1_N : N ;
  kalcedon_nn_1_N : N ;
  kalciumhydroxid_nn_1_N : N ;
  kalciumoxid_nn_1_N : N ;
  kalebass_nn_1_N : N ;
  kalendermaanad_nn_1_1_N : N ;
  kalesch_nn_1_N : N ;
  kalfaktor_nn_1_N : N ;
  kaliumhydroxid_nn_1_N : N ;
  kaliumjon_nn_1_N : N ;
  kalk_nn_1_N : N ;
  kalkalg_nn_1_N : N ;
  kalkformation_nn_1_N : N ;
  kalkfaerg_nn_1_1_N : N ;
  kalkhalt_nn_1_N : N ;
  kalkjon_nn_1_N : N ;
  kalkon_nn_1_N : N ;
  kalkrest_nn_1_N : N ;
  kalkyl_nn_1_N : N ;
  kalkylator_nn_1_N : N ;
  kallblodighet_nn_1_N : N ;
  kalmark_nn_1_N : N ;
  kaloribomb_nn_1_N : N ;
  kalorijakt_nn_1_N : N ;
  kalrest_nn_1_N : N ;
  kalufs_nn_1_N : N ;
  kalvfrikass_e_nn_1_1_N : N ;
  kalvinism_nn_1_N : N ;
  kalvinist_nn_1_N : N ;
  kalvrulad_nn_1_N : N ;
  kalvrullad_nn_1_N : N ;
  kambodjan_nn_1_N : N ;
  kamelmedicin_nn_1_N : N ;
  kamelritt_nn_1_N : N ;
  kamerajakt_nn_1_N : N ;
  kammarammunition_nn_1_N : N ;
  kammarraett_nn_1_1_N : N ;
  kampanil_nn_1_N : N ;
  kampanj_nn_1_N : N ;
  kampanjstab_nn_1_N : N ;
  kampkonst_nn_1_N : N ;
  kamporganisation_nn_1_N : N ;
  kampsport_nn_1_N : N ;
  kampsaang_nn_1_1_N : N ;
  kampuchean_nn_1_N : N ;
  kamratlighet_nn_1_N : N ;
  kam_e_nn_1_1_N : N ;
  kan_nn_1_N : N ;
  kanalchef_nn_1_N : N ;
  kanap_e_nn_1_1_N : N ;
  kandidatur_nn_1_N : N ;
  kanfas_nn_1_N : N ;
  kanin_nn_1_N : N ;
  kanjon_nn_1_N : N ;
  kannibal_nn_1_N : N ;
  kannibalism_nn_1_N : N ;
  kanon_nn_2_N : N ;
  kanonaffaer_nn_1_1_N : N ;
  kanonisation_nn_1_N : N ;
  kanonisationsprocess_nn_1_N : N ;
  kanoniseringsprocess_nn_1_N : N ;
  kanot_nn_1_N : N ;
  kanotist_nn_1_N : N ;
  kansler_nn_1_N : N ;
  kanslist_nn_1_N : N ;
  kant_nn_1_N : N ;
  kantarell_nn_1_N : N ;
  kantat_nn_1_N : N ;
  kantighet_nn_2_N : N ;
  kantin_nn_1_N : N ;
  kanton_nn_1_N : N ;
  kantor_nn_1_N : N ;
  kantrad_nn_1_N : N ;
  kantvaext_nn_1_1_N : N ;
  kanyl_nn_1_N : N ;
  kanzon_nn_1_N : N ;
  kanzonett_nn_1_N : N ;
  kapacitet_nn_1_N : N ;
  kapacitetsbrist_nn_1_N : N ;
  kaparkapten_nn_1_N : N ;
  kapillaritet_nn_1_N : N ;
  kapitalfoerlust_nn_1_1_N : N ;
  kapitalinkomst_nn_1_N : N ;
  kapitalism_nn_1_N : N ;
  kapitalist_nn_1_N : N ;
  kapitaliststat_nn_1_N : N ;
  kapitalmarknad_nn_1_N : N ;
  kapitalvinst_nn_1_N : N ;
  kapitulation_nn_1_N : N ;
  kaplan_nn_1_N : N ;
  kapmaskin_nn_1_N : N ;
  kaprifol_nn_1_N : N ;
  kapriol_nn_1_N : N ;
  kapris_nn_1_N : N ;
  kapson_nn_1_N : N ;
  kapsyl_nn_1_N : N ;
  kapucin_nn_1_N : N ;
  kapybar_nn_1_N : N ;
  karaffin_nn_1_N : N ;
  karaktaer_nn_1_1_N : N ;
  karaktaersart_nn_1_1_N : N ;
  karaktaerstyp_nn_1_1_N : N ;
  karamell_nn_1_N : N ;
  karamellfabrik_nn_1_N : N ;
  karamellfaerg_nn_1_1_N : N ;
  karamellsaas_nn_1_1_N : N ;
  karavan_nn_1_N : N ;
  karbamid_nn_1_N : N ;
  karbas_nn_1_N : N ;
  karbid_nn_1_N : N ;
  karbin_nn_1_N : N ;
  karbonatjon_nn_1_N : N ;
  karburator_nn_1_N : N ;
  karcinogen_nn_1_N : N ;
  kardan_nn_1_N : N ;
  kardiolog_nn_1_N : N ;
  kardus_nn_1_N : N ;
  karess_nn_1_N : N ;
  karismasignal_nn_1_N : N ;
  karkas_nn_1_N : N ;
  karled_nn_1_N : N ;
  karmelit_nn_1_N : N ;
  karnation_nn_1_N : N ;
  karneol_nn_1_N : N ;
  karnis_nn_1_N : N ;
  karolin_nn_1_N : N ;
  kaross_nn_1_N : N ;
  karriaerism_nn_1_1_N : N ;
  karriaerist_nn_1_1_N : N ;
  karr_e_nn_1_1_N : N ;
  karst_nn_1_N : N ;
  kartbild_nn_1_N : N ;
  kartbok_nn_1_N : N ;
  kartesch_nn_1_N : N ;
  kartong_nn_1_N : N ;
  kartonist_nn_1_N : N ;
  kartprojektion_nn_1_N : N ;
  kartritartradition_nn_1_N : N ;
  kartusch_nn_1_N : N ;
  kartusian_nn_1_N : N ;
  karyatid_nn_1_N : N ;
  kaskad_nn_1_N : N ;
  kaskelot_nn_1_N : N ;
  kaskelott_nn_1_N : N ;
  kaskett_nn_1_N : N ;
  kassaapparat_nn_1_N : N ;
  kassabok_nn_1_N : N ;
  kassabrist_nn_1_N : N ;
  kassadirektoer_nn_1_1_N : N ;
  kassapjaes_nn_1_1_N : N ;
  kassarabatt_nn_1_N : N ;
  kassation_nn_1_N : N ;
  kassun_nn_1_N : N ;
  kassoer_nn_1_1_N : N ;
  kast_nn_1_N : N ;
  kastanj_nn_1_N : N ;
  kastanjett_nn_1_N : N ;
  kastellan_nn_1_N : N ;
  kastilian_nn_1_N : N ;
  kastpjaes_nn_1_1_N : N ;
  kasun_nn_1_N : N ;
  katakres_nn_1_N : N ;
  katalan_nn_1_N : N ;
  katalysator_nn_1_N : N ;
  katamaran_nn_1_N : N ;
  katarr_nn_1_N : N ;
  katastroffilm_nn_1_N : N ;
  katastrofhanteringsmyndighet_nn_1_N : N ;
  katastrofsituation_nn_1_N : N ;
  katedersocialism_nn_1_N : N ;
  katekes_nn_1_N : N ;
  katet_nn_1_N : N ;
  katjon_nn_1_N : N ;
  katolicism_nn_1_N : N ;
  katolik_nn_1_N : N ;
  katt_nn_1_N : N ;
  kattras_nn_1_N : N ;
  kaus_nn_1_N : N ;
  kausalitet_nn_1_N : N ;
  kausalsats_nn_1_N : N ;
  kaution_nn_1_N : N ;
  kavaljer_nn_1_N : N ;
  kavallerist_nn_1_N : N ;
  kavitation_nn_1_N : N ;
  kavitet_nn_1_N : N ;
  kazak_nn_1_N : N ;
  kebab_nn_1_N : N ;
  ked_nn_1_N : N ;
  kediv_nn_1_N : N ;
  kedjemolekyl_nn_1_N : N ;
  kedjereaktion_nn_1_N : N ;
  kejsarpingvin_nn_1_N : N ;
  kejsartron_nn_1_N : N ;
  kelim_nn_1_N : N ;
  kelt_nn_1_N : N ;
  kemibok_nn_1_N : N ;
  kemiprofessor_nn_1_N : N ;
  kemist_nn_1_N : N ;
  kenyan_nn_1_N : N ;
  ketch_nn_1_N : N ;
  khan_nn_1_N : N ;
  khmer_nn_1_N : N ;
  kickstart_nn_1_N : N ;
  kikarlins_nn_1_N : N ;
  kikaert_nn_1_1_N : N ;
  kilometerskatt_nn_1_N : N ;
  kinaalkaloid_nn_1_N : N ;
  kinarestaurang_nn_1_N : N ;
  kines_nn_1_N : N ;
  kiosk_nn_1_N : N ;
  kirgis_nn_1_N : N ;
  kirgiz_nn_1_N : N ;
  kiropraktor_nn_1_N : N ;
  kirurg_nn_1_N : N ;
  kirurgmask_nn_1_N : N ;
  kis_nn_1_N : N ;
  kiselalg_nn_1_N : N ;
  kiselkristall_nn_1_N : N ;
  kiton_nn_1_N : N ;
  kitslighet_nn_1_N : N ;
  klad_nn_1_N : N ;
  klagoskrift_nn_1_N : N ;
  klagosaang_nn_1_1_N : N ;
  klagotid_nn_1_N : N ;
  klagoton_nn_1_N : N ;
  klammerpistol_nn_1_N : N ;
  klamydiavaccin_nn_1_N : N ;
  klan_nn_1_N : N ;
  klangfaerg_nn_1_1_N : N ;
  klansoldat_nn_1_N : N ;
  klanstrid_nn_1_N : N ;
  klantighet_nn_1_N : N ;
  klappjakt_nn_1_N : N ;
  klarhet_nn_1_N : N ;
  klarinettist_nn_1_N : N ;
  klarsignal_nn_1_N : N ;
  klass_nn_1_N : N ;
  klassbok_nn_1_N : N ;
  klassicism_nn_1_N : N ;
  klassicitet_nn_1_N : N ;
  klassifikation_nn_1_N : N ;
  klassik_nn_1_N : N ;
  klasskillnad_nn_1_N : N ;
  klasskonferens_nn_1_N : N ;
  klassmarkoer_nn_1_1_N : N ;
  klassresenaer_nn_1_1_N : N ;
  klasstruktur_nn_1_N : N ;
  klatrat_nn_1_N : N ;
  klatrathydrat_nn_1_N : N ;
  klav_nn_1_N : N ;
  klavecin_nn_1_N : N ;
  klaviatur_nn_1_N : N ;
  klementin_nn_1_N : N ;
  klenod_nn_1_N : N ;
  klensmed_nn_1_N : N ;
  kleptoman_nn_1_N : N ;
  klerikalism_nn_1_N : N ;
  kletighet_nn_1_N : N ;
  klich_e_nn_1_1_N : N ;
  klimataktivist_nn_1_N : N ;
  klimatalarmist_nn_1_N : N ;
  klimatgraens_nn_1_1_N : N ;
  klimatkonferens_nn_1_N : N ;
  klimatkris_nn_1_N : N ;
  klimatmedvetenhet_nn_1_N : N ;
  klimatsmarthet_nn_1_N : N ;
  klimatvariation_nn_1_N : N ;
  klimatzon_nn_1_N : N ;
  klimataatgaerd_nn_1_1_N : N ;
  klippbredd_nn_1_N : N ;
  klippformation_nn_1_N : N ;
  klipphoejd_nn_1_1_N : N ;
  klipskhet_nn_1_N : N ;
  klockklang_nn_1_N : N ;
  klocksignal_nn_1_N : N ;
  klokhet_nn_1_N : N ;
  klorfenol_nn_1_N : N ;
  klorid_nn_1_N : N ;
  klosterruin_nn_1_N : N ;
  klubblaengd_nn_1_1_N : N ;
  klumpighet_nn_1_N : N ;
  klurighet_nn_1_N : N ;
  klusterbomb_nn_1_N : N ;
  kluvenhet_nn_1_N : N ;
  klyvningsreaktion_nn_1_N : N ;
  klaededraekt_nn_1_1_N : N ;
  klaednad_nn_1_1_N : N ;
  klaedsmak_nn_1_1_N : N ;
  klaengvaext_nn_1_1_N : N ;
  klaerobskyr_nn_1_1_N : N ;
  klaettervaext_nn_1_1_N : N ;
  kloevsadelbyggnad_nn_1_1_N : N ;
  kloevsadelsbyggnad_nn_1_1_N : N ;
  knagglighet_nn_1_N : N ;
  knalltransport_nn_1_N : N ;
  knapphet_nn_1_N : N ;
  knapptelefon_nn_1_N : N ;
  knasighet_nn_1_N : N ;
  knektmentalitet_nn_1_N : N ;
  knepighet_nn_1_N : N ;
  knivighet_nn_1_N : N ;
  knivkontakt_nn_1_N : N ;
  knockdown_nn_1_N : N ;
  knockout_nn_1_N : N ;
  knollrighet_nn_1_N : N ;
  knotighet_nn_1_N : N ;
  knusslighet_nn_1_N : N ;
  knutpunkt_nn_1_N : N ;
  knypplingskurs_nn_1_N : N ;
  knaeled_nn_1_1_N : N ;
  knaeoperation_nn_1_1_N : N ;
  knaeppfamilj_nn_1_1_N : N ;
  knaetrakt_nn_1_1_N : N ;
  knoelighet_nn_1_1_N : N ;
  koaffyr_nn_1_N : N ;
  koagulation_nn_1_N : N ;
  koalition_nn_1_N : N ;
  kobolthalt_nn_1_N : N ;
  koboltjon_nn_1_N : N ;
  kod_nn_1_N : N ;
  kodifikation_nn_1_N : N ;
  kofferdist_nn_1_N : N ;
  kognat_nn_1_N : N ;
  kognition_nn_1_N : N ;
  kohesion_nn_1_N : N ;
  kohort_nn_1_N : N ;
  koj_nn_1_N : N ;
  kokainism_nn_1_N : N ;
  kokarreaktor_nn_1_N : N ;
  kokbok_nn_1_N : N ;
  kokboksstoeld_nn_1_1_N : N ;
  kolchos_nn_1_N : N ;
  koldioxid_nn_1_N : N ;
  koldioxidhalt_nn_1_N : N ;
  koldioxidmolekyl_nn_1_N : N ;
  kolfloets_nn_1_1_N : N ;
  kolhalt_nn_1_N : N ;
  kolj_e_nn_1_1_N : N ;
  kollaps_nn_1_N : N ;
  kollast_nn_1_N : N ;
  kollation_nn_1_N : N ;
  kollegialitet_nn_1_N : N ;
  kollektion_nn_1_N : N ;
  kollektivfil_nn_1_N : N ;
  kollektivism_nn_1_N : N ;
  kollektor_nn_1_N : N ;
  kollision_nn_1_N : N ;
  kollisionskurs_nn_1_N : N ;
  kolloid_nn_1_N : N ;
  kollokation_nn_1_N : N ;
  kollusion_nn_1_N : N ;
  kolofon_nn_1_N : N ;
  kolonialarm_e_nn_1_1_N : N ;
  kolonialexpansion_nn_1_N : N ;
  kolonialiseringsprocess_nn_1_N : N ;
  kolonialism_nn_1_N : N ;
  kolonialmakt_nn_1_N : N ;
  kolonisation_nn_1_N : N ;
  kolonisationstid_nn_1_N : N ;
  koloratur_nn_1_N : N ;
  koloratursopran_nn_1_N : N ;
  kolorism_nn_1_N : N ;
  kolorist_nn_1_N : N ;
  kolorit_nn_1_N : N ;
  koloss_nn_1_N : N ;
  kolskiss_nn_1_N : N ;
  kolsyraassimilation_nn_1_N : N ;
  kolsyremaskin_nn_1_N : N ;
  kolsyrepatron_nn_1_N : N ;
  kolsyrepistol_nn_1_N : N ;
  kolumnist_nn_1_N : N ;
  kolvmotor_nn_1_N : N ;
  kombattant_nn_1_N : N ;
  kombination_nn_1_N : N ;
  kombinationsmaattsats_nn_1_1_N : N ;
  komediant_nn_1_N : N ;
  komitativ_nn_1_N : N ;
  kommandoroest_nn_1_1_N : N ;
  kommendant_nn_1_N : N ;
  kommendantur_nn_1_N : N ;
  kommendoer_nn_1_1_N : N ;
  kommentator_nn_1_N : N ;
  kommentatorsfunktion_nn_1_N : N ;
  kommers_nn_1_N : N ;
  kommission_nn_1_N : N ;
  kommissionaer_nn_1_1_N : N ;
  kommitt_e_nn_1_1_N : N ;
  kommunalnivaa_nn_1_1_N : N ;
  kommunalnaemnd_nn_1_1_N : N ;
  kommunalskatt_nn_1_N : N ;
  kommunikant_nn_1_N : N ;
  kommunikation_nn_1_N : N ;
  kommunikationssatellit_nn_1_N : N ;
  kommunikator_nn_1_N : N ;
  kommunik_e_nn_1_1_N : N ;
  kommunion_nn_1_N : N ;
  kommunism_nn_1_N : N ;
  kommunist_nn_1_N : N ;
  kommunistdiktatur_nn_1_N : N ;
  kommunistregim_nn_1_N : N ;
  kommunnivaa_nn_1_1_N : N ;
  kommunreform_nn_1_N : N ;
  kommutator_nn_1_N : N ;
  kompanichef_nn_1_N : N ;
  komparation_nn_1_N : N ;
  komparativ_nn_1_N : N ;
  kompars_nn_1_N : N ;
  kompass_nn_1_N : N ;
  kompasskurs_nn_1_N : N ;
  kompensation_nn_1_N : N ;
  kompensator_nn_1_N : N ;
  kompetens_nn_1_N : N ;
  kompilation_nn_1_N : N ;
  kompilator_nn_1_N : N ;
  komplementfaerg_nn_1_1_N : N ;
  kompletteringsproposition_nn_1_N : N ;
  komplexitet_nn_1_N : N ;
  komplikation_nn_1_N : N ;
  komplott_nn_1_N : N ;
  komponent_nn_1_N : N ;
  komponist_nn_1_N : N ;
  komposant_nn_1_N : N ;
  komposit_nn_1_N : N ;
  komposition_nn_1_N : N ;
  kompost_nn_1_N : N ;
  kompress_nn_1_N : N ;
  kompression_nn_1_N : N ;
  kompressor_nn_1_N : N ;
  komprimator_nn_1_N : N ;
  kompromiss_nn_1_N : N ;
  koncentration_nn_1_N : N ;
  koncentrationssvaarighet_nn_1_1_N : N ;
  konception_nn_1_N : N ;
  koncern_nn_1_N : N ;
  koncernchef_nn_1_N : N ;
  koncession_nn_1_N : N ;
  koncessionsavgift_nn_1_N : N ;
  kondensation_nn_1_N : N ;
  kondensator_nn_1_N : N ;
  kondensor_nn_1_N : N ;
  kondition_nn_1_N : N ;
  konditor_nn_1_N : N ;
  kondoleans_nn_1_N : N ;
  konduktivitet_nn_1_N : N ;
  konduktor_nn_1_N : N ;
  konduktoer_nn_1_1_N : N ;
  konfederation_nn_1_N : N ;
  konfektion_nn_1_N : N ;
  konfektyrbutik_nn_1_N : N ;
  konferens_nn_1_N : N ;
  konfession_nn_1_N : N ;
  konfessionalism_nn_1_N : N ;
  konfiguration_nn_1_N : N ;
  konfirmandklass_nn_1_N : N ;
  konfirmation_nn_1_N : N ;
  konfirmationspraest_nn_1_1_N : N ;
  konfiskation_nn_1_N : N ;
  konfliktdiamant_nn_1_N : N ;
  konfliktregion_nn_1_N : N ;
  konfliktsituation_nn_1_N : N ;
  konformism_nn_1_N : N ;
  konformist_nn_1_N : N ;
  konformitet_nn_1_N : N ;
  konfrontation_nn_1_N : N ;
  konfucianism_nn_1_N : N ;
  konfusion_nn_1_N : N ;
  kongoles_nn_1_N : N ;
  kongregation_nn_1_N : N ;
  kongress_nn_1_N : N ;
  kongressplats_nn_1_N : N ;
  kongruens_nn_1_N : N ;
  konicitet_nn_1_N : N ;
  konjak_nn_1_N : N ;
  konjektur_nn_1_N : N ;
  konjugation_nn_1_N : N ;
  konjunktion_nn_1_N : N ;
  konjunktiv_nn_1_N : N ;
  konjunktur_nn_1_N : N ;
  konjunkturrapport_nn_1_N : N ;
  konklusion_nn_1_N : N ;
  konkordans_nn_1_N : N ;
  konkretion_nn_1_N : N ;
  konkretism_nn_1_N : N ;
  konkubin_nn_1_N : N ;
  konkurrensmarknad_nn_1_N : N ;
  konkurs_nn_1_N : N ;
  konkursrealisation_nn_1_N : N ;
  konnotation_nn_1_N : N ;
  konnaessans_nn_1_1_N : N ;
  konsekvens_nn_1_N : N ;
  konsekvensanalys_nn_1_N : N ;
  konsensuskultur_nn_1_N : N ;
  konsertaffisch_nn_1_N : N ;
  konsertturn_e_nn_1_1_N : N ;
  konservatism_nn_1_N : N ;
  konservator_nn_1_N : N ;
  konservfabrik_nn_1_N : N ;
  konsideration_nn_1_N : N ;
  konsignation_nn_1_N : N ;
  konsilians_nn_1_N : N ;
  konsistens_nn_1_N : N ;
  konsol_nn_1_N : N ;
  konsomm_e_nn_1_1_N : N ;
  konsonans_nn_1_N : N ;
  konsonant_nn_1_N : N ;
  konspiration_nn_1_N : N ;
  konst_nn_1_N : N ;
  konstant_nn_1_N : N ;
  konstellation_nn_1_N : N ;
  konsternation_nn_1_N : N ;
  konstform_nn_1_N : N ;
  konstfullhet_nn_1_N : N ;
  konstfaerdighet_nn_1_1_N : N ;
  konstfoervant_nn_1_1_N : N ;
  konstighet_nn_1_N : N ;
  konstituent_nn_1_N : N ;
  konstitution_nn_1_N : N ;
  konstloeshet_nn_1_1_N : N ;
  konstnaer_nn_1_1_N : N ;
  konstnaerslaegenhet_nn_1_1_N : N ;
  konstpaus_nn_1_N : N ;
  konstruktion_nn_1_N : N ;
  konstruktionsdetalj_nn_1_N : N ;
  konstruktoer_nn_1_1_N : N ;
  konstsalong_nn_1_N : N ;
  konsularjurisdiktion_nn_1_N : N ;
  konsultation_nn_1_N : N ;
  konsument_nn_1_N : N ;
  konsumentkooperation_nn_1_N : N ;
  konsumtion_nn_1_N : N ;
  konsumtionsmoejlighet_nn_1_1_N : N ;
  konsumtionsskatt_nn_1_N : N ;
  konsumtionsskillnad_nn_1_N : N ;
  kontakt_nn_1_N : N ;
  kontaktannons_nn_1_N : N ;
  kontaktinfektion_nn_1_N : N ;
  kontaktlins_nn_1_N : N ;
  kontaktperson_nn_1_N : N ;
  kontamination_nn_1_N : N ;
  kontemplation_nn_1_N : N ;
  kontinentalplataa_nn_1_1_N : N ;
  kontinuitet_nn_1_N : N ;
  kontokurant_nn_1_N : N ;
  kontorist_nn_1_N : N ;
  kontorsbyggnad_nn_1_N : N ;
  kontorschef_nn_1_N : N ;
  kontorsplats_nn_1_N : N ;
  kontostoeld_nn_1_1_N : N ;
  kontrabok_nn_1_N : N ;
  kontradans_nn_1_N : N ;
  kontradiktion_nn_1_N : N ;
  kontraindikation_nn_1_N : N ;
  kontraktion_nn_1_N : N ;
  kontraproposition_nn_1_N : N ;
  kontrarevolution_nn_1_N : N ;
  kontrast_nn_1_N : N ;
  kontribution_nn_1_N : N ;
  kontroll_nn_2_N : N ;
  kontrollant_nn_1_N : N ;
  kontrollavgift_nn_1_N : N ;
  kontrollgrupp_nn_1_N : N ;
  kontrollikon_nn_1_N : N ;
  kontrollmekanism_nn_1_N : N ;
  kontrollrutin_nn_1_N : N ;
  kontrollstation_nn_1_N : N ;
  kontrolluppgift_nn_1_N : N ;
  kontrolloer_nn_1_1_N : N ;
  kontrovers_nn_1_N : N ;
  kontur_nn_1_N : N ;
  kontusion_nn_1_N : N ;
  konungabok_nn_1_N : N ;
  konungaed_nn_1_N : N ;
  konvalescenstid_nn_1_N : N ;
  konvalj_nn_1_N : N ;
  konvektion_nn_1_N : N ;
  konvektionszon_nn_1_N : N ;
  konvention_nn_1_N : N ;
  konventionalism_nn_1_N : N ;
  konversation_nn_1_N : N ;
  konversion_nn_1_N : N ;
  konvertit_nn_1_N : N ;
  konvoj_nn_1_N : N ;
  konvojattack_nn_1_N : N ;
  konvulsion_nn_1_N : N ;
  kooperation_nn_1_N : N ;
  koordination_nn_1_N : N ;
  koordinator_nn_1_N : N ;
  kopiator_nn_1_N : N ;
  kopist_nn_1_N : N ;
  kopplingspedal_nn_1_N : N ;
  kopplingston_nn_1_N : N ;
  kopt_nn_1_N : N ;
  kopulation_nn_1_N : N ;
  koralbok_nn_1_N : N ;
  korean_nn_1_N : N ;
  korist_nn_1_N : N ;
  korkapparat_nn_1_N : N ;
  korkcell_nn_1_N : N ;
  korkpistol_nn_1_N : N ;
  korkvaevnad_nn_1_1_N : N ;
  kormoran_nn_1_N : N ;
  kornettist_nn_1_N : N ;
  kornisch_nn_1_N : N ;
  korporation_nn_1_N : N ;
  korporatism_nn_1_N : N ;
  korporativism_nn_1_N : N ;
  korrasion_nn_1_N : N ;
  korrektion_nn_1_N : N ;
  korrektionsanstalt_nn_1_N : N ;
  korrelation_nn_1_N : N ;
  korrespondens_nn_1_N : N ;
  korrespondenskurs_nn_1_N : N ;
  korrosion_nn_1_N : N ;
  korrosionsinhibitor_nn_1_N : N ;
  korruption_nn_1_N : N ;
  korruptionsnivaa_nn_1_1_N : N ;
  korruptionsskandal_nn_1_N : N ;
  korsfarararm_e_nn_1_1_N : N ;
  korsfararstat_nn_1_N : N ;
  korsikan_nn_1_N : N ;
  korspollination_nn_1_N : N ;
  korsreferens_nn_1_N : N ;
  korstaagskroenikoer_nn_1_1_N : N ;
  kortdistans_nn_1_N : N ;
  kortfilm_nn_1_N : N ;
  kortform_nn_1_N : N ;
  korthet_nn_1_N : N ;
  kortisol_nn_1_N : N ;
  kortkonst_nn_1_N : N ;
  kortroman_nn_1_N : N ;
  kortstoeld_nn_1_1_N : N ;
  korvfabrik_nn_1_N : N ;
  korvfabrikoer_nn_1_1_N : N ;
  korvkiosk_nn_1_N : N ;
  korvmaskin_nn_1_N : N ;
  kosackdans_nn_1_N : N ;
  kosackhetman_nn_1_N : N ;
  kosmetikaaffaer_nn_1_1_N : N ;
  kosmetolog_nn_1_N : N ;
  kosmolog_nn_1_N : N ;
  kosmopolit_nn_1_N : N ;
  kosovar_nn_1_N : N ;
  kostbarhet_nn_1_N : N ;
  kostnad_nn_1_N : N ;
  kostymbal_nn_1_N : N ;
  kostympjaes_nn_1_1_N : N ;
  kotled_nn_1_N : N ;
  kotlettrad_nn_1_N : N ;
  koyot_nn_1_N : N ;
  kraal_nn_1_N : N ;
  kraft_nn_1_N : N ;
  kraftekvation_nn_1_N : N ;
  kraftloeshet_nn_1_1_N : N ;
  kraftsport_nn_1_N : N ;
  kraftstation_nn_1_N : N ;
  kraftaatgaerd_nn_1_1_N : N ;
  kral_nn_1_N : N ;
  krasch_nn_2_N : N ;
  kraschan_nn_1_N : N ;
  krasslighet_nn_1_N : N ;
  kravall_nn_1_N : N ;
  kravallpolis_nn_2_N : N ;
  kravspecifikation_nn_1_N : N ;
  kreation_nn_1_N : N ;
  kreativitet_nn_1_N : N ;
  kredit_nn_1_N : N ;
  kreditfoerlust_nn_1_1_N : N ;
  kreditmarknad_nn_1_N : N ;
  kreditor_nn_1_N : N ;
  kremlolog_nn_1_N : N ;
  kreol_nn_1_N : N ;
  kreolkultur_nn_1_N : N ;
  kretin_nn_1_N : N ;
  kretinism_nn_1_N : N ;
  krigsdagbok_nn_1_N : N ;
  krigsdans_nn_1_N : N ;
  krigsdekoration_nn_1_N : N ;
  krigsdiamant_nn_1_N : N ;
  krigsinsats_nn_1_N : N ;
  krigskolportoer_nn_1_1_N : N ;
  krigskredit_nn_1_N : N ;
  krigsmakt_nn_1_N : N ;
  krigsprofitoer_nn_1_1_N : N ;
  krigsrisk_nn_1_N : N ;
  krigsroman_nn_1_N : N ;
  krigsskaadeplats_nn_1_1_N : N ;
  krigszon_nn_1_N : N ;
  kriminalinspektoer_nn_1_1_N : N ;
  kriminalitet_nn_1_N : N ;
  kriminaljournalist_nn_1_N : N ;
  kriminalpolis_nn_2_N : N ;
  kriminalroman_nn_1_N : N ;
  kriminolog_nn_1_N : N ;
  kringelikrokighet_nn_1_N : N ;
  kringelkrokighet_nn_1_N : N ;
  kringinformation_nn_1_N : N ;
  krinolin_nn_1_N : N ;
  kris_nn_1_N : N ;
  krisfond_nn_1_N : N ;
  krisgrupp_nn_1_N : N ;
  kristall_nn_1_N : N ;
  kristallform_nn_1_N : N ;
  kristallins_nn_1_N : N ;
  kristallisation_nn_1_N : N ;
  kristdemokrat_nn_1_N : N ;
  kristelefon_nn_1_N : N ;
  kristenhet_nn_1_N : N ;
  kristid_nn_1_N : N ;
  krisaatgaerd_nn_1_1_N : N ;
  kriticism_nn_1_N : N ;
  kritik_nn_1_N : N ;
  krogrond_nn_1_N : N ;
  krogvakt_nn_1_N : N ;
  krokan_nn_1_N : N ;
  krokighet_nn_1_N : N ;
  kromdetalj_nn_1_N : N ;
  kromlist_nn_1_N : N ;
  kronjurist_nn_1_N : N ;
  kroppsbild_nn_1_N : N ;
  kroppsbomb_nn_1_N : N ;
  kroppsbyggnad_nn_1_N : N ;
  kroppscell_nn_1_N : N ;
  kroppsform_nn_1_N : N ;
  kroppsfunktion_nn_1_N : N ;
  kroppskonstitution_nn_1_N : N ;
  kroppslighet_nn_1_N : N ;
  kroppsspraaksexpert_nn_1_1_N : N ;
  kroppstemperatur_nn_1_N : N ;
  kroppsvikt_nn_1_N : N ;
  kroppsvisitation_nn_1_N : N ;
  kroppsvaevnad_nn_1_1_N : N ;
  krukvaext_nn_1_1_N : N ;
  krumelur_nn_1_N : N ;
  krutgas_nn_1_N : N ;
  krutmotor_nn_1_N : N ;
  krutsort_nn_1_N : N ;
  kryddgroensak_nn_1_1_N : N ;
  kryddsaas_nn_1_1_N : N ;
  kryddvaext_nn_1_1_N : N ;
  kryddoert_nn_1_1_N : N ;
  kryphaallfasthet_nn_1_1_N : N ;
  kryptofascist_nn_1_N : N ;
  kryptonazist_nn_1_N : N ;
  krysolit_nn_1_N : N ;
  krysopras_nn_1_N : N ;
  kryssmast_nn_1_N : N ;
  kryssningsdestination_nn_1_N : N ;
  kryssningsmissil_nn_1_N : N ;
  kryssroest_nn_1_1_N : N ;
  kraeftfaangst_nn_1_1_N : N ;
  kraeftpremiaer_nn_1_1_N : N ;
  kraeftsvulst_nn_1_1_N : N ;
  kraeftsaesong_nn_1_1_N : N ;
  kraeldjurstyp_nn_1_1_N : N ;
  kraenkningskaenslighet_nn_1_1_N : N ;
  kraanglighet_nn_1_1_N : N ;
  kroenikebok_nn_1_1_N : N ;
  kroenikoer_nn_1_1_N : N ;
  kuban_nn_1_N : N ;
  kubism_nn_1_N : N ;
  kubist_nn_1_N : N ;
  kuktrakt_nn_1_N : N ;
  kulighet_nn_1_N : N ;
  kuliss_nn_1_N : N ;
  kulled_nn_1_N : N ;
  kulmination_nn_1_N : N ;
  kulsprutebataljon_nn_1_N : N ;
  kulsprutepistol_nn_1_N : N ;
  kultivator_nn_1_N : N ;
  kultplats_nn_1_N : N ;
  kultur_nn_1_N : N ;
  kulturaktivitet_nn_1_N : N ;
  kulturattach_e_nn_1_1_N : N ;
  kulturekonom_nn_1_N : N ;
  kulturelit_nn_1_N : N ;
  kulturform_nn_1_N : N ;
  kulturinstitution_nn_1_N : N ;
  kulturkollision_nn_1_N : N ;
  kulturperson_nn_1_N : N ;
  kulturpersonlighet_nn_1_N : N ;
  kulturredaktion_nn_1_N : N ;
  kulturrelativism_nn_1_N : N ;
  kulturrevolution_nn_1_N : N ;
  kulturskillnad_nn_1_N : N ;
  kulturvaext_nn_1_1_N : N ;
  kumpan_nn_1_N : N ;
  kumulation_nn_1_N : N ;
  kundnoejdhetsenkaet_nn_1_1_N : N ;
  kundservicechef_nn_1_N : N ;
  kungaed_nn_1_N : N ;
  kungafamilj_nn_1_N : N ;
  kungatron_nn_1_N : N ;
  kunglighet_nn_1_N : N ;
  kunskapskontroll_nn_1_N : N ;
  kunskapsmaskin_nn_1_N : N ;
  kunskapsnivaa_nn_1_1_N : N ;
  kupidon_nn_1_N : N ;
  kupol_nn_1_N : N ;
  kupplan_nn_1_N : N ;
  kup_e_nn_1_1_N : N ;
  kuranstalt_nn_1_N : N ;
  kurator_nn_1_N : N ;
  kurd_nn_1_N : N ;
  kurgan_nn_1_N : N ;
  kuriositet_nn_1_N : N ;
  kurir_nn_1_N : N ;
  kurort_nn_1_N : N ;
  kurragoemmajakt_nn_1_1_N : N ;
  kurs_nn_1_N : N ;
  kursiv_nn_1_N : N ;
  kursor_nn_1_N : N ;
  kursplan_nn_1_N : N ;
  kurtis_nn_1_N : N ;
  kurtisan_nn_1_N : N ;
  kurvatur_nn_1_N : N ;
  kusin_nn_1_N : N ;
  kuslighet_nn_1_N : N ;
  kust_nn_1_N : N ;
  kustod_nn_1_N : N ;
  kustort_nn_1_N : N ;
  kutym_nn_1_N : N ;
  kuvoes_nn_1_1_N : N ;
  kvadrant_nn_1_N : N ;
  kvadriljon_nn_1_N : N ;
  kvadrillion_nn_1_N : N ;
  kvadrupelallians_nn_1_N : N ;
  kvalifikation_nn_1_N : N ;
  kvalitet_nn_1_N : N ;
  kvalitetsauktion_nn_1_N : N ;
  kvalitetsjournalistik_nn_1_N : N ;
  kvalitetskontroll_nn_1_N : N ;
  kvalitetsnorm_nn_1_N : N ;
  kvalitetsprodukt_nn_1_N : N ;
  kvalit_e_nn_1_1_N : N ;
  kvalmighet_nn_1_N : N ;
  kvantitet_nn_1_N : N ;
  kvarskatt_nn_1_N : N ;
  kvarterspolis_nn_1_N : N ;
  kvarts_nn_1_N : N ;
  kvartsbutelj_nn_1_N : N ;
  kvartsfigur_nn_1_N : N ;
  kvartsfinal_nn_1_N : N ;
  kvartsit_nn_1_N : N ;
  kvartskristall_nn_1_N : N ;
  kvartslivskris_nn_1_N : N ;
  kvartston_nn_1_N : N ;
  kvasar_nn_1_N : N ;
  kvasikristall_nn_1_N : N ;
  kverulant_nn_1_N : N ;
  kvickhet_nn_1_N : N ;
  kvietism_nn_1_N : N ;
  kvinnoaffaer_nn_1_1_N : N ;
  kvinnobild_nn_1_N : N ;
  kvinnodraekt_nn_1_1_N : N ;
  kvinnokoer_nn_1_1_N : N ;
  kvinnonatur_nn_1_N : N ;
  kvinnopraest_nn_1_1_N : N ;
  kvinnoroll_nn_1_N : N ;
  kvinnoraettsaktivist_nn_1_1_N : N ;
  kvinnoroest_nn_1_1_N : N ;
  kvinnoskulptur_nn_1_N : N ;
  kvinnsperson_nn_1_N : N ;
  kvittens_nn_1_N : N ;
  kvot_nn_1_N : N ;
  kvaellsignal_nn_1_1_N : N ;
  kvaellskurs_nn_1_1_N : N ;
  kvaellsmaaltid_nn_1_1_N : N ;
  kvaellssammankomst_nn_1_1_N : N ;
  kvaellstidningsrubrik_nn_1_1_N : N ;
  kvaeveoxid_nn_1_1_N : N ;
  kylapparat_nn_1_N : N ;
  kylarglykol_nn_1_N : N ;
  kylighet_nn_2_N : N ;
  kylskaapsmagnet_nn_1_1_N : N ;
  kynolog_nn_1_N : N ;
  kyrass_nn_1_N : N ;
  kyrkbok_nn_1_N : N ;
  kyrkbyggnad_nn_1_N : N ;
  kyrkobok_nn_1_N : N ;
  kyrkohandbok_nn_1_N : N ;
  kaellskatt_nn_1_1_N : N ;
  kaendismassoer_nn_1_1_N : N ;
  kaeng_nn_1_1_N : N ;
  kaensloikon_nn_1_1_N : N ;
  kaerlekskris_nn_1_1_N : N ;
  kaerleksroman_nn_1_1_N : N ;
  kaerleksstrejk_nn_1_1_N : N ;
  kaerlsvulst_nn_1_1_N : N ;
  kaernreaktor_nn_1_1_N : N ;
  kaar_nn_1_1_N : N ;
  koeksbordsturn_e_nn_1_1_N : N ;
  koeksvaext_nn_1_1_N : N ;
  koepenickiad_nn_1_1_N : N ;
  koepkurs_nn_1_1_N : N ;
  koettfaersskandal_nn_1_1_N : N ;
  laborant_nn_1_N : N ;
  laborator_nn_1_N : N ;
  laddningsregulator_nn_1_N : N ;
  laestadian_nn_1_N : N ;
  laestadianism_nn_1_N : N ;
  lagbok_nn_1_N : N ;
  lagerbok_nn_1_N : N ;
  lagringsfoerlust_nn_1_1_N : N ;
  lagtext_nn_1_N : N ;
  lakonism_nn_1_N : N ;
  laktovegetarian_nn_1_N : N ;
  lamaism_nn_1_N : N ;
  lammfaers_nn_1_1_N : N ;
  lam_e_nn_1_1_N : N ;
  lan_nn_1_N : N ;
  landningsfarkost_nn_1_N : N ;
  landstingsdirektoer_nn_1_1_N : N ;
  landtransport_nn_1_N : N ;
  landaa_nn_1_1_N : N ;
  langobard_nn_1_N : N ;
  langust_nn_1_N : N ;
  lankes_nn_1_N : N ;
  lantbruksdirektoer_nn_1_1_N : N ;
  lanternin_nn_1_N : N ;
  lantras_nn_1_N : N ;
  larmrapport_nn_1_N : N ;
  larmsignal_nn_1_N : N ;
  larv_nn_1_N : N ;
  larvtraktor_nn_1_N : N ;
  laryngit_nn_1_N : N ;
  laryngolog_nn_1_N : N ;
  lasaron_nn_1_N : N ;
  last_nn_1_N : N ;
  lastageplats_nn_1_N : N ;
  lastbilschauffoer_nn_1_1_N : N ;
  lastbilstransport_nn_1_N : N ;
  lasur_nn_1_N : N ;
  latinamerikan_nn_1_N : N ;
  latinism_nn_1_N : N ;
  latinlektor_nn_1_N : N ;
  lativ_nn_1_N : N ;
  latrin_nn_1_N : N ;
  lavin_nn_1_N : N ;
  laxfile_nn_1_N : N ;
  laxfil_e_nn_1_1_N : N ;
  lazzaron_nn_1_N : N ;
  led_nn_1_N : N ;
  ledarplats_nn_1_N : N ;
  ledgaangsreumatism_nn_1_1_N : N ;
  ledighetskommitt_e_nn_1_1_N : N ;
  legend_nn_1_N : N ;
  legendar_nn_1_N : N ;
  legislatur_nn_1_N : N ;
  legitimist_nn_1_N : N ;
  legosoldat_nn_1_N : N ;
  leguan_nn_1_N : N ;
  lekplats_nn_1_N : N ;
  leksaksfigur_nn_1_N : N ;
  leksakspistol_nn_1_N : N ;
  lektor_nn_1_N : N ;
  lektorstjaenst_nn_1_1_N : N ;
  lektris_nn_1_N : N ;
  lemur_nn_1_N : N ;
  leninism_nn_1_N : N ;
  lergoeksroest_nn_1_1_N : N ;
  lestadian_nn_1_N : N ;
  lestadianism_nn_1_N : N ;
  levantin_nn_1_N : N ;
  leverans_nn_1_N : N ;
  leverpastej_nn_1_N : N ;
  levit_nn_1_N : N ;
  levnadsnivaa_nn_1_1_N : N ;
  lexfras_nn_1_N : N ;
  lexikolog_nn_1_N : N ;
  lexikonresurs_nn_1_N : N ;
  lian_nn_1_N : N ;
  libanes_nn_1_N : N ;
  liberal_nn_1_N : N ;
  liberalism_nn_1_N : N ;
  liberian_nn_1_N : N ;
  libertin_nn_1_N : N ;
  libertinism_nn_1_N : N ;
  librettist_nn_1_N : N ;
  licens_nn_1_N : N ;
  ligatur_nn_1_N : N ;
  liggplats_nn_1_N : N ;
  ligist_nn_1_N : N ;
  ligur_nn_1_N : N ;
  liktor_nn_1_N : N ;
  likvid_nn_1_N : N ;
  likvidator_nn_1_N : N ;
  liljekonvalj_nn_1_N : N ;
  liljevaext_nn_1_1_N : N ;
  limousin_nn_1_N : N ;
  lingvist_nn_1_N : N ;
  linnedamast_nn_1_N : N ;
  lins_nn_1_N : N ;
  lipas_nn_1_N : N ;
  lipid_nn_1_N : N ;
  list_nn_1_N : N ;
  lisoes_nn_1_1_N : N ;
  litotes_nn_1_N : N ;
  litteratur_nn_1_N : N ;
  litteraturingenjoer_nn_1_1_N : N ;
  litteraturprofessor_nn_1_N : N ;
  livdrabant_nn_1_N : N ;
  livskris_nn_1_N : N ;
  livsmedelskontroll_nn_1_N : N ;
  livsmedelskonvoj_nn_1_N : N ;
  livsmedelsproducent_nn_1_N : N ;
  livsmedelstillsats_nn_1_N : N ;
  livsnatur_nn_1_N : N ;
  livsprincip_nn_1_N : N ;
  livsprocess_nn_1_N : N ;
  livsstilsfaktor_nn_1_N : N ;
  livsstilsoas_nn_1_N : N ;
  ljudbok_nn_1_N : N ;
  ljudfrekvens_nn_1_N : N ;
  ljudkuliss_nn_1_N : N ;
  ljudnivaa_nn_1_1_N : N ;
  ljudsignal_nn_1_N : N ;
  ljungvaext_nn_1_1_N : N ;
  ljuslist_nn_1_N : N ;
  ljussignal_nn_1_N : N ;
  lobby_nn_1_N : N ;
  lobbyinsats_nn_1_N : N ;
  loggbok_nn_1_N : N ;
  logotyp_nn_1_N : N ;
  lokal_nn_1_N : N ;
  lokalpatriot_nn_1_N : N ;
  lokalredaktoer_nn_1_1_N : N ;
  lokaltelefon_nn_1_N : N ;
  lokativ_nn_1_N : N ;
  lokomobil_nn_1_N : N ;
  lokomotor_nn_1_N : N ;
  lotsplats_nn_1_N : N ;
  lotssignal_nn_1_N : N ;
  lottovinst_nn_1_N : N ;
  lubrikator_nn_1_N : N ;
  luciafest_nn_1_N : N ;
  luft_nn_2_N : N ;
  luftfarkost_nn_1_N : N ;
  luftkompressor_nn_1_N : N ;
  luftkuddefarkost_nn_1_N : N ;
  luftmadrass_nn_1_N : N ;
  luftmast_nn_1_N : N ;
  luftpistol_nn_1_N : N ;
  luftroerskatarr_nn_1_1_N : N ;
  lufttemperatur_nn_1_N : N ;
  lufttransport_nn_1_N : N ;
  lukt_nn_1_N : N ;
  lummervaext_nn_1_1_N : N ;
  lunch_nn_1_N : N ;
  lunchbuff_e_nn_1_1_N : N ;
  lunchrast_nn_1_N : N ;
  lunchrestaurang_nn_1_N : N ;
  lunett_nn_1_N : N ;
  lungkatarr_nn_1_N : N ;
  lupin_nn_1_N : N ;
  lussefest_nn_1_N : N ;
  lustgas_nn_1_N : N ;
  lustimpuls_nn_1_N : N ;
  lutheran_nn_1_N : N ;
  lutheranism_nn_1_N : N ;
  lynett_nn_1_N : N ;
  lysdiod_nn_1_N : N ;
  lysgas_nn_1_N : N ;
  lyspistol_nn_1_N : N ;
  lysroersarmatur_nn_1_1_N : N ;
  lyssats_nn_1_N : N ;
  lyssnarpost_nn_1_N : N ;
  lyxklass_nn_1_N : N ;
  lyxskatt_nn_1_N : N ;
  laegesanalys_nn_1_1_N : N ;
  laegesrapport_nn_1_1_N : N ;
  laegstanivaa_nn_1_1_N : N ;
  laekarbok_nn_1_1_N : N ;
  laekarpraktik_nn_1_1_N : N ;
  laekemedelskontroll_nn_1_1_N : N ;
  laekevaext_nn_1_1_N : N ;
  laengd_nn_1_1_N : N ;
  laensarbetsdirektoer_nn_1_1_N : N ;
  laensstolslingvist_nn_1_1_N : N ;
  laerarinneroest_nn_1_1_N : N ;
  laerdomsgigant_nn_1_1_N : N ;
  laerobok_nn_1_1_N : N ;
  laerobokssats_nn_1_1_N : N ;
  laeroplan_nn_1_1_N : N ;
  laerosats_nn_1_1_N : N ;
  laesebok_nn_1_1_N : N ;
  laeskedrycksannons_nn_1_1_N : N ;
  laeskedrycksproducent_nn_1_1_N : N ;
  laesklass_nn_1_1_N : N ;
  laespraest_nn_1_1_N : N ;
  laest_nn_1_1_N : N ;
  laestadian_nn_1_1_N : N ;
  laestadianism_nn_1_1_N : N ;
  laettmatros_nn_1_1_N : N ;
  laettvariant_nn_1_1_N : N ;
  laettvattenreaktor_nn_1_1_N : N ;
  laagbudgetturist_nn_1_1_N : N ;
  laagfrekvens_nn_1_1_N : N ;
  laagkonjunktur_nn_1_1_N : N ;
  laaglandsras_nn_1_1_N : N ;
  laagsaesong_nn_1_1_N : N ;
  laanefest_nn_1_1_N : N ;
  laangdans_nn_1_1_N : N ;
  laangdistans_nn_1_1_N : N ;
  laangkalsongsdebut_nn_1_1_N : N ;
  laangmarsch_nn_1_1_N : N ;
  laangtidsprognos_nn_1_1_N : N ;
  laangtradarchauffoer_nn_1_1_N : N ;
  laangtradarmotor_nn_1_1_N : N ;
  laatsasfigur_nn_1_1_N : N ;
  laatsaskamrat_nn_1_1_N : N ;
  laattext_nn_1_1_N : N ;
  lxstadian_nn_1_N : N ;
  lxstadianism_nn_1_N : N ;
  loegndetektor_nn_1_1_N : N ;
  loegnkampanj_nn_1_1_N : N ;
  loekkupol_nn_1_1_N : N ;
  loeksaas_nn_1_1_N : N ;
  loekvaext_nn_1_1_N : N ;
  loen_nn_1_1_N : N ;
  loeneklass_nn_1_1_N : N ;
  loenenivaa_nn_1_1_N : N ;
  loeneplan_nn_1_1_N : N ;
  loeneprotest_nn_1_1_N : N ;
  loenerutin_nn_1_1_N : N ;
  machiavellism_nn_1_N : N ;
  madagask_nn_1_N : N ;
  madrass_nn_1_N : N ;
  magdans_nn_1_N : N ;
  magdansoes_nn_1_1_N : N ;
  magkatarr_nn_1_N : N ;
  magmedicin_nn_1_N : N ;
  magnat_nn_1_N : N ;
  magnet_nn_1_N : N ;
  magnetism_nn_1_N : N ;
  magnetkompass_nn_1_N : N ;
  magnetofon_nn_1_N : N ;
  magnetron_nn_1_N : N ;
  magnumbutelj_nn_1_N : N ;
  majonnaes_nn_1_1_N : N ;
  majonnaessaas_nn_1_1_N : N ;
  major_nn_1_N : N ;
  makron_nn_1_N : N ;
  makt_nn_2_N : N ;
  maktbalans_nn_1_N : N ;
  maktbas_nn_1_N : N ;
  maktfaktor_nn_1_N : N ;
  maktsymbol_nn_1_N : N ;
  malaj_nn_1_N : N ;
  malakit_nn_1_N : N ;
  malariaparasit_nn_1_N : N ;
  malariavaccin_nn_1_N : N ;
  malmtransport_nn_1_N : N ;
  maltes_nn_1_N : N ;
  manchesterkavaj_nn_1_N : N ;
  manchesterliberalism_nn_1_N : N ;
  mandarin_nn_1_N : N ;
  mandolin_nn_1_N : N ;
  manetdoktorand_nn_1_N : N ;
  manganin_nn_1_N : N ;
  manierism_nn_1_N : N ;
  manikeism_nn_1_N : N ;
  manikur_nn_1_N : N ;
  manikurist_nn_1_N : N ;
  manikyrist_nn_1_N : N ;
  manschauvinism_nn_1_N : N ;
  mansroest_nn_1_1_N : N ;
  mantilj_nn_1_N : N ;
  manufaktur_nn_1_N : N ;
  maoism_nn_1_N : N ;
  mardroemsjulfest_nn_1_1_N : N ;
  marginalinkomst_nn_1_N : N ;
  marginalskatt_nn_1_N : N ;
  marin_nn_1_N : N ;
  marinad_nn_1_N : N ;
  marinarkeolog_nn_1_N : N ;
  marinattach_e_nn_1_1_N : N ;
  marinbiolog_nn_1_N : N ;
  marindirektoer_nn_1_1_N : N ;
  marinsoldat_nn_1_N : N ;
  mark_nn_1_N : N ;
  markeffektfarkost_nn_1_N : N ;
  markis_nn_1_N : N ;
  marknadsfundamentalism_nn_1_N : N ;
  marknadsplats_nn_1_N : N ;
  marknivaa_nn_1_1_N : N ;
  markorganism_nn_1_N : N ;
  markplan_nn_1_N : N ;
  marktjaenst_nn_1_1_N : N ;
  marmelad_nn_1_N : N ;
  marmorbyst_nn_1_N : N ;
  marockan_nn_1_N : N ;
  marsch_nn_1_N : N ;
  marsian_nn_1_N : N ;
  marsk_nn_1_N : N ;
  marxism_nn_1_N : N ;
  marxist_nn_1_N : N ;
  maraengsviss_nn_1_1_N : N ;
  mask_nn_2_N : N ;
  maskdiarr_e_nn_1_1_N : N ;
  maskerad_nn_1_N : N ;
  maskin_nn_1_N : N ;
  maskinist_nn_1_N : N ;
  maskinpistol_nn_1_N : N ;
  maskintelegraf_nn_1_N : N ;
  masochism_nn_1_N : N ;
  masochist_nn_1_N : N ;
  massfaangst_nn_1_1_N : N ;
  masskonst_nn_1_N : N ;
  masskultur_nn_1_N : N ;
  massprotest_nn_1_N : N ;
  masspsykos_nn_1_N : N ;
  mast_nn_1_N : N ;
  matalarmist_nn_1_N : N ;
  match_nn_1_N : N ;
  materialism_nn_1_N : N ;
  materialist_nn_1_N : N ;
  materialkonstant_nn_1_N : N ;
  materiegas_nn_1_N : N ;
  materietransport_nn_1_N : N ;
  matgaest_nn_1_1_N : N ;
  matin_e_nn_1_1_N : N ;
  matkonserv_nn_1_N : N ;
  matkultur_nn_1_N : N ;
  matlagningskonst_nn_1_N : N ;
  matlaadeleverans_nn_1_1_N : N ;
  matpurist_nn_1_N : N ;
  matrast_nn_1_N : N ;
  matrest_nn_1_N : N ;
  matris_nn_1_N : N ;
  matros_nn_1_N : N ;
  matservis_nn_1_N : N ;
  matutin_nn_1_N : N ;
  mauserpistol_nn_1_N : N ;
  maximitemperatur_nn_1_N : N ;
  maxlast_nn_1_N : N ;
  mazarin_nn_1_N : N ;
  medaljplats_nn_1_N : N ;
  medeldistans_nn_1_N : N ;
  medelinkomst_nn_1_N : N ;
  medelklass_nn_1_N : N ;
  medelproportional_nn_1_N : N ;
  medeltemperatur_nn_1_N : N ;
  medelaalderskris_nn_1_1_N : N ;
  median_nn_1_N : N ;
  medicin_nn_1_N : N ;
  medicinalvaext_nn_1_1_N : N ;
  medvetandenivaa_nn_1_1_N : N ;
  megafon_nn_1_N : N ;
  megalit_nn_1_N : N ;
  megaloman_nn_1_N : N ;
  mejerist_nn_1_N : N ;
  mekanism_nn_1_N : N ;
  melatonin_nn_1_N : N ;
  melatoninnivaa_nn_1_1_N : N ;
  mellanbok_nn_1_N : N ;
  mellankultur_nn_1_N : N ;
  mellansubstans_nn_1_N : N ;
  melodram_nn_1_N : N ;
  melon_nn_1_N : N ;
  memoarbok_nn_1_N : N ;
  memorial_nn_1_N : N ;
  mendelism_nn_1_N : N ;
  menisk_nn_1_N : N ;
  menopaus_nn_1_N : N ;
  mensur_nn_1_N : N ;
  mentalism_nn_1_N : N ;
  mentor_nn_1_N : N ;
  meny_nn_1_N : N ;
  meridian_nn_1_N : N ;
  merit_nn_1_N : N ;
  merkantilism_nn_1_N : N ;
  merkantilist_nn_1_N : N ;
  merkaptan_nn_1_N : N ;
  meronym_nn_1_N : N ;
  mervaerdesskatt_nn_1_1_N : N ;
  mesallians_nn_1_N : N ;
  mesan_nn_1_N : N ;
  mesanmast_nn_1_N : N ;
  meson_nn_1_N : N ;
  mestis_nn_1_N : N ;
  metabolism_nn_1_N : N ;
  metalldetektor_nn_1_N : N ;
  metalloid_nn_1_N : N ;
  metalloxid_nn_1_N : N ;
  metallrusch_nn_1_N : N ;
  metallspekulant_nn_1_N : N ;
  metamorfos_nn_1_N : N ;
  metastas_nn_1_N : N ;
  metates_nn_1_N : N ;
  meteorit_nn_1_N : N ;
  meteorolog_nn_1_N : N ;
  metodiklektor_nn_1_N : N ;
  metodism_nn_1_N : N ;
  metodist_nn_1_N : N ;
  metropol_nn_1_N : N ;
  metropolit_nn_1_N : N ;
  mexikan_nn_1_N : N ;
  mezzanin_nn_1_N : N ;
  mezzosopran_nn_1_N : N ;
  middagsgaest_nn_1_1_N : N ;
  middagsrast_nn_1_N : N ;
  migrant_nn_1_N : N ;
  mikrobiolog_nn_1_N : N ;
  mikrodator_nn_1_N : N ;
  mikrofon_nn_1_N : N ;
  mikroorganism_nn_1_N : N ;
  mikrotelefon_nn_1_N : N ;
  milis_nn_1_N : N ;
  militarism_nn_1_N : N ;
  militarist_nn_1_N : N ;
  militaerallians_nn_1_1_N : N ;
  militaerattach_e_nn_1_1_N : N ;
  militaerbas_nn_1_1_N : N ;
  militaerblockad_nn_1_1_N : N ;
  militaerdiktatur_nn_1_1_N : N ;
  militaerkolonn_nn_1_1_N : N ;
  militaermarsch_nn_1_1_N : N ;
  militaerpolis_nn_2_1_N : N ;
  miljard_nn_1_N : N ;
  miljon_nn_1_N : N ;
  miljonklass_nn_1_N : N ;
  miljonloen_nn_1_1_N : N ;
  miljoeaktivist_nn_1_1_N : N ;
  miljoekatastrof_nn_1_1_N : N ;
  miljoekonsekvens_nn_1_1_N : N ;
  miljoevinst_nn_1_1_N : N ;
  milliard_nn_1_N : N ;
  million_nn_1_N : N ;
  mineraltillsats_nn_1_N : N ;
  miniatyr_nn_1_N : N ;
  minidator_nn_1_N : N ;
  minimitemperatur_nn_1_N : N ;
  ministerialbok_nn_1_N : N ;
  ministerpost_nn_1_N : N ;
  minnesbok_nn_1_N : N ;
  minnesfest_nn_1_N : N ;
  minnesfoerlust_nn_1_1_N : N ;
  minnesgudstjaenst_nn_1_1_N : N ;
  minneskonst_nn_1_N : N ;
  minut_nn_2_N : N ;
  mirakelmedicin_nn_1_N : N ;
  miss_nn_2_N : N ;
  missil_nn_1_N : N ;
  missroman_nn_1_N : N ;
  mixtur_nn_1_N : N ;
  mjoelkskandal_nn_1_1_N : N ;
  moar_e_nn_1_1_N : N ;
  mobbningskampanj_nn_1_N : N ;
  mobil_nn_1_N : N ;
  mobiliseringsplats_nn_1_N : N ;
  mobiltelefon_nn_1_N : N ;
  mockasin_nn_1_N : N ;
  modeatelj_e_nn_1_1_N : N ;
  modell_nn_1_N : N ;
  moderat_nn_1_N : N ;
  moderator_nn_1_N : N ;
  modernism_nn_1_N : N ;
  modernist_nn_1_N : N ;
  modist_nn_1_N : N ;
  modulator_nn_1_N : N ;
  mohammedan_nn_1_N : N ;
  mohammedanism_nn_1_N : N ;
  mohikan_nn_1_N : N ;
  molekyl_nn_1_N : N ;
  molekylaerbiolog_nn_1_1_N : N ;
  mollusk_nn_1_N : N ;
  molnrest_nn_1_N : N ;
  monarkist_nn_1_N : N ;
  monegask_nn_1_N : N ;
  mongol_nn_1_N : N ;
  mongolism_nn_1_N : N ;
  monism_nn_1_N : N ;
  monist_nn_1_N : N ;
  monitor_nn_1_N : N ;
  monokotyledon_nn_1_N : N ;
  monokultur_nn_1_N : N ;
  monolit_nn_1_N : N ;
  monolog_nn_1_N : N ;
  monoman_nn_1_N : N ;
  monopolism_nn_1_N : N ;
  monopolist_nn_1_N : N ;
  monopolkapitalism_nn_1_N : N ;
  monosackarid_nn_1_N : N ;
  monoteism_nn_1_N : N ;
  monsterkultur_nn_1_N : N ;
  monstrans_nn_1_N : N ;
  montenegrin_nn_1_N : N ;
  moped_nn_1_N : N ;
  mopedist_nn_1_N : N ;
  moralism_nn_1_N : N ;
  moralist_nn_1_N : N ;
  moralnihilism_nn_1_N : N ;
  morfemgraens_nn_1_1_N : N ;
  morfinist_nn_1_N : N ;
  morfogenes_nn_1_N : N ;
  morgongudstjaenst_nn_1_1_N : N ;
  morian_nn_1_N : N ;
  morisk_nn_1_N : N ;
  mormon_nn_1_N : N ;
  mormonism_nn_1_N : N ;
  morsesignal_nn_1_N : N ;
  mosaik_nn_1_N : N ;
  moskit_nn_1_N : N ;
  moskovit_nn_1_N : N ;
  mosk_e_nn_1_1_N : N ;
  mosk_evandal_nn_1_1_N : N ;
  mosskultur_nn_1_N : N ;
  motbok_nn_1_N : N ;
  motdemonstrant_nn_1_N : N ;
  motett_nn_1_N : N ;
  motivationskonsult_nn_1_N : N ;
  motkultur_nn_1_N : N ;
  motoffensiv_nn_1_N : N ;
  motor_nn_1_N : N ;
  motorcykelpolis_nn_1_N : N ;
  motorcyklist_nn_1_N : N ;
  motorism_nn_1_N : N ;
  motorist_nn_1_N : N ;
  motrytm_nn_1_N : N ;
  motsats_nn_1_N : N ;
  motstaandarsoldat_nn_1_1_N : N ;
  mp3_bok_nn_1_N : N ;
  mufflon_nn_1_N : N ;
  muhammedan_nn_1_N : N ;
  muhammedanism_nn_1_N : N ;
  multimiljardaer_nn_1_1_N : N ;
  multimiljonaer_nn_1_1_N : N ;
  multiplikator_nn_1_N : N ;
  musch_nn_1_N : N ;
  muselman_nn_1_N : N ;
  musikant_nn_1_N : N ;
  musikdirektoer_nn_1_1_N : N ;
  musikfestival_nn_1_N : N ;
  musikgudstjaenst_nn_1_1_N : N ;
  musikolog_nn_1_N : N ;
  muskelreumatism_nn_1_N : N ;
  muskulatur_nn_1_N : N ;
  muslim_nn_1_N : N ;
  musseron_nn_1_N : N ;
  must_nn_1_N : N ;
  mustasch_nn_1_N : N ;
  mutagen_nn_1_N : N ;
  mutant_nn_1_N : N ;
  mutexpert_nn_1_N : N ;
  mutskandal_nn_1_N : N ;
  mykolog_nn_1_N : N ;
  myndighetsrepresentant_nn_1_N : N ;
  myon_nn_1_N : N ;
  myrgaest_nn_1_1_N : N ;
  myrvaext_nn_1_1_N : N ;
  mysticism_nn_1_N : N ;
  myterist_nn_1_N : N ;
  mytoman_nn_1_N : N ;
  maeld_nn_1_1_N : N ;
  maengd_nn_1_1_N : N ;
  maenniskofigur_nn_1_1_N : N ;
  maenniskoras_nn_1_1_N : N ;
  maenniskoraettsaktivist_nn_1_1_N : N ;
  maenniskoroest_nn_1_1_N : N ;
  maessbok_nn_1_1_N : N ;
  maessingsdetalj_nn_1_1_N : N ;
  maestarklass_nn_1_1_N : N ;
  maetapparatur_nn_1_1_N : N ;
  maetress_nn_1_1_N : N ;
  maalarbok_nn_1_1_N : N ;
  maalbrottsroest_nn_1_1_N : N ;
  maalchans_nn_1_1_N : N ;
  maalfigur_nn_1_1_N : N ;
  maanadskontroll_nn_1_1_N : N ;
  maandistans_nn_1_1_N : N ;
  maanfas_nn_1_1_N : N ;
  maangmiljonaer_nn_1_1_N : N ;
  maattsats_nn_1_1_N : N ;
  moensterbok_nn_1_1_N : N ;
  moetesplats_nn_1_1_N : N ;
  naivism_nn_1_N : N ;
  naivist_nn_1_N : N ;
  nakendans_nn_1_N : N ;
  nakendansoes_nn_1_1_N : N ;
  nakenkultur_nn_1_N : N ;
  namnkredit_nn_1_N : N ;
  narciss_nn_1_N : N ;
  narcissism_nn_1_N : N ;
  narkoanalys_nn_1_N : N ;
  narkoman_nn_1_N : N ;
  narkos_nn_1_N : N ;
  nasal_nn_1_N : N ;
  nationalekonom_nn_1_N : N ;
  nationalinkomst_nn_1_N : N ;
  nationalism_nn_1_N : N ;
  nationalist_nn_1_N : N ;
  nationalsocialism_nn_1_N : N ;
  nationalsocialist_nn_1_N : N ;
  nationalstereotyp_nn_1_N : N ;
  nationsgraens_nn_1_1_N : N ;
  nationsinspektor_nn_1_N : N ;
  nationskurator_nn_1_N : N ;
  natriumhydroxid_nn_1_N : N ;
  nattin_e_nn_1_1_N : N ;
  nattmarsch_nn_1_N : N ;
  nattvardsgudstjaenst_nn_1_1_N : N ;
  natur_nn_2_N : N ;
  naturalism_nn_1_N : N ;
  naturalist_nn_1_N : N ;
  naturgas_nn_1_N : N ;
  naturism_nn_1_N : N ;
  naturist_nn_1_N : N ;
  naturkatastrof_nn_1_N : N ;
  naturkonstant_nn_1_N : N ;
  naturmedicin_nn_1_N : N ;
  naturresurs_nn_1_N : N ;
  navigationssatellit_nn_1_N : N ;
  naziarkitektur_nn_1_N : N ;
  nazism_nn_1_N : N ;
  nazist_nn_1_N : N ;
  neapolitan_nn_1_N : N ;
  nedslagsplats_nn_1_N : N ;
  nefrit_nn_1_N : N ;
  negativism_nn_1_N : N ;
  neglig_e_nn_1_1_N : N ;
  negress_nn_1_N : N ;
  negroid_nn_1_N : N ;
  nejd_nn_1_N : N ;
  nejlikvaext_nn_1_1_N : N ;
  nejroest_nn_1_1_N : N ;
  nekrofil_nn_1_N : N ;
  nekrolog_nn_1_N : N ;
  nektarin_nn_1_N : N ;
  neodymmagnet_nn_1_N : N ;
  neoimpressionism_nn_1_N : N ;
  neoklassicism_nn_1_N : N ;
  neokolonialism_nn_1_N : N ;
  neolog_nn_1_N : N ;
  neongas_nn_1_N : N ;
  nepales_nn_1_N : N ;
  nepotism_nn_1_N : N ;
  nereid_nn_1_N : N ;
  nerslagsplats_nn_1_N : N ;
  nervgas_nn_1_N : N ;
  nervimpuls_nn_1_N : N ;
  nervkollaps_nn_1_N : N ;
  nervmedicin_nn_1_N : N ;
  nervsignal_nn_1_N : N ;
  nestorian_nn_1_N : N ;
  nestorianism_nn_1_N : N ;
  nettoinkomst_nn_1_N : N ;
  nettovinst_nn_1_N : N ;
  neurit_nn_1_N : N ;
  neurofysiolog_nn_1_N : N ;
  neurolog_nn_1_N : N ;
  neuros_nn_1_N : N ;
  neutralism_nn_1_N : N ;
  neutralist_nn_1_N : N ;
  neutron_nn_1_N : N ;
  nicaraguan_nn_1_N : N ;
  nigerian_nn_1_N : N ;
  nihilism_nn_1_N : N ;
  nihilist_nn_1_N : N ;
  nikotinism_nn_1_N : N ;
  nikotinist_nn_1_N : N ;
  niodagarsturn_e_nn_1_1_N : N ;
  niomannakommitt_e_nn_1_1_N : N ;
  nisch_nn_1_N : N ;
  nittiotalism_nn_1_N : N ;
  nittiotalist_nn_1_N : N ;
  nittitalism_nn_1_N : N ;
  nittitalist_nn_1_N : N ;
  nivaa_nn_1_1_N : N ;
  nockout_nn_1_N : N ;
  nomad_nn_1_N : N ;
  nomenklatur_nn_1_N : N ;
  nominalism_nn_1_N : N ;
  nominalist_nn_1_N : N ;
  nominativ_nn_1_N : N ;
  nonkombattant_nn_1_N : N ;
  nonkonformism_nn_1_N : N ;
  nonkonformist_nn_1_N : N ;
  nonsensvers_nn_1_N : N ;
  nordamerikan_nn_1_N : N ;
  nordgraens_nn_1_1_N : N ;
  nordism_nn_1_N : N ;
  nordist_nn_1_N : N ;
  nordjemenit_nn_1_N : N ;
  nordkorean_nn_1_N : N ;
  nordkust_nn_1_N : N ;
  nordyemenit_nn_1_N : N ;
  normaliseringsprocess_nn_1_N : N ;
  norvagism_nn_1_N : N ;
  nostalgipjaes_nn_1_1_N : N ;
  not_nn_1_N : N ;
  notis_nn_1_N : N ;
  nototenioid_nn_1_N : N ;
  nougat_nn_1_N : N ;
  novellist_nn_1_N : N ;
  novis_nn_1_N : N ;
  nudism_nn_1_N : N ;
  nudist_nn_1_N : N ;
  nugat_nn_1_N : N ;
  nukleid_nn_1_N : N ;
  nukleon_nn_1_N : N ;
  nukleotid_nn_1_N : N ;
  nuklid_nn_1_N : N ;
  nummerbyraa_nn_1_1_N : N ;
  nummerrevy_nn_1_N : N ;
  nunatack_nn_1_N : N ;
  nunatak_nn_1_N : N ;
  nuntiatur_nn_1_N : N ;
  nutritionist_nn_1_N : N ;
  nyans_nn_1_N : N ;
  nyboerjarbok_nn_1_1_N : N ;
  nyckelperson_nn_1_N : N ;
  nyckelroman_nn_1_N : N ;
  nyfascism_nn_1_N : N ;
  nyhetsbyraa_nn_1_1_N : N ;
  nyhumanism_nn_1_N : N ;
  nyklassicism_nn_1_N : N ;
  nykolonialism_nn_1_N : N ;
  nykterism_nn_1_N : N ;
  nykterist_nn_1_N : N ;
  nymfoman_nn_1_N : N ;
  nynazism_nn_1_N : N ;
  nynazist_nn_1_N : N ;
  nyplatonism_nn_1_N : N ;
  nypremiaer_nn_1_1_N : N ;
  nyrealism_nn_1_N : N ;
  nyttjandefrekvens_nn_1_N : N ;
  nyttovaext_nn_1_1_N : N ;
  nyaarsfest_nn_1_1_N : N ;
  naemnd_nn_1_1_N : N ;
  naeringsbrist_nn_1_1_N : N ;
  naeringslivskonsult_nn_1_1_N : N ;
  naeringsprocess_nn_1_1_N : N ;
  naeskatarr_nn_1_1_N : N ;
  naestkusin_nn_1_1_N : N ;
  naetkampanj_nn_1_1_N : N ;
  naetkultur_nn_1_1_N : N ;
  naetmelon_nn_1_1_N : N ;
  naalmikrofon_nn_1_1_N : N ;
  noedsignal_nn_1_1_N : N ;
  noet_nn_1_1_N : N ;
  oas_nn_1_N : N ;
  obduktionsrapport_nn_1_N : N ;
  obelisk_nn_1_N : N ;
  obestaemdhetsprincip_nn_1_1_N : N ;
  objektivism_nn_1_N : N ;
  objektskatt_nn_1_N : N ;
  oblast_nn_1_N : N ;
  obligat_nn_1_N : N ;
  oblik_nn_1_N : N ;
  obol_nn_1_N : N ;
  observationsklass_nn_1_N : N ;
  obsidian_nn_1_N : N ;
  obsklass_nn_1_N : N ;
  obskurant_nn_1_N : N ;
  obskurantism_nn_1_N : N ;
  obskurantist_nn_1_N : N ;
  ocean_nn_1_N : N ;
  ockultism_nn_1_N : N ;
  ockupant_nn_1_N : N ;
  odalisk_nn_1_N : N ;
  odlingsgraens_nn_1_1_N : N ;
  odlingssaesong_nn_1_1_N : N ;
  odontolog_nn_1_N : N ;
  offeranod_nn_1_N : N ;
  offerfest_nn_1_N : N ;
  offerrit_nn_1_N : N ;
  officersaspirant_nn_1_N : N ;
  officiant_nn_1_N : N ;
  officin_nn_1_N : N ;
  oktanol_nn_1_N : N ;
  oktant_nn_1_N : N ;
  oktav_nn_1_N : N ;
  oktod_nn_1_N : N ;
  oktogon_nn_1_N : N ;
  oktroj_nn_1_N : N ;
  okynnesstrejk_nn_1_N : N ;
  oligark_nn_1_N : N ;
  oljenivaa_nn_1_1_N : N ;
  oljevaext_nn_1_1_N : N ;
  ollonpistol_nn_1_N : N ;
  olvonvaext_nn_1_1_N : N ;
  olycksfallsfrekvens_nn_1_N : N ;
  olyckskatastrof_nn_1_N : N ;
  olycksplats_nn_1_N : N ;
  olycksprofet_nn_1_N : N ;
  omblandningsprocess_nn_1_N : N ;
  omdoemesbrist_nn_1_1_N : N ;
  omslagsrevers_nn_1_N : N ;
  omsaettningsskatt_nn_1_1_N : N ;
  omvandlingsprocess_nn_1_N : N ;
  onkolog_nn_1_N : N ;
  operationalism_nn_1_N : N ;
  operationsbas_nn_1_N : N ;
  operator_nn_1_N : N ;
  operatris_nn_1_N : N ;
  operett_nn_1_N : N ;
  opinionsanalys_nn_1_N : N ;
  oppblaasningsfas_nn_1_1_N : N ;
  opportunism_nn_1_N : N ;
  opportunist_nn_1_N : N ;
  oppositionsaktivist_nn_1_N : N ;
  oppstaellningsplats_nn_1_1_N : N ;
  oppstaellningssignal_nn_1_1_N : N ;
  optant_nn_1_N : N ;
  optativ_nn_1_N : N ;
  optimism_nn_1_N : N ;
  optimist_nn_1_N : N ;
  optionsskandal_nn_1_N : N ;
  orant_nn_1_N : N ;
  orator_nn_1_N : N ;
  ordbok_nn_1_N : N ;
  ordfoerekomst_nn_1_1_N : N ;
  ordklass_nn_1_N : N ;
  ordningspolis_nn_2_N : N ;
  ordningsprincip_nn_1_N : N ;
  ordonnans_nn_1_N : N ;
  orficism_nn_1_N : N ;
  orfism_nn_1_N : N ;
  organisationskommitt_e_nn_1_1_N : N ;
  organisationsstruktur_nn_1_N : N ;
  organism_nn_1_N : N ;
  organist_nn_1_N : N ;
  orientalism_nn_1_N : N ;
  orientalist_nn_1_N : N ;
  originaltext_nn_1_N : N ;
  orkan_nn_1_N : N ;
  orkesterplats_nn_1_N : N ;
  orkid_e_nn_1_1_N : N ;
  orkid_evaext_nn_1_1_N : N ;
  ormbunksvaext_nn_1_1_N : N ;
  ornamentist_nn_1_N : N ;
  ornitolog_nn_1_N : N ;
  ortikon_nn_1_N : N ;
  ortoceratit_nn_1_N : N ;
  ortodoxism_nn_1_N : N ;
  ortolan_nn_1_N : N ;
  ortoptist_nn_1_N : N ;
  ortoptris_nn_1_N : N ;
  oryx_nn_1_N : N ;
  oscillator_nn_1_N : N ;
  oskarian_nn_1_N : N ;
  osman_nn_1_N : N ;
  osteolog_nn_1_N : N ;
  osteoporos_nn_1_N : N ;
  ostjak_nn_1_N : N ;
  ostkust_nn_1_N : N ;
  ostracism_nn_1_N : N ;
  ostrest_nn_1_N : N ;
  ostsaas_nn_1_1_N : N ;
  otit_nn_1_N : N ;
  otjaenst_nn_1_1_N : N ;
  otolog_nn_1_N : N ;
  otrohetsskandal_nn_1_N : N ;
  ottoman_nn_1_N : N ;
  ottomotor_nn_1_N : N ;
  overhead_projektor_nn_1_N : N ;
  overheadprojektor_nn_1_N : N ;
  oxfil_e_nn_1_1_N : N ;
  oxid_nn_1_N : N ;
  oxroulad_nn_1_N : N ;
  oxrullad_nn_1_N : N ;
  ozonmolekyl_nn_1_N : N ;
  p_plats_nn_1_N : N ;
  pacifism_nn_1_N : N ;
  pacifist_nn_1_N : N ;
  pakistan_nn_1_N : N ;
  paladin_nn_1_N : N ;
  paleontolog_nn_1_N : N ;
  paletaa_nn_1_1_N : N ;
  palimpsest_nn_1_N : N ;
  pallasch_nn_1_N : N ;
  pallplats_nn_1_N : N ;
  pamflettist_nn_1_N : N ;
  pampusch_nn_1_N : N ;
  panaman_nn_1_N : N ;
  panasch_nn_1_N : N ;
  panel_nn_1_N : N ;
  pangpjaes_nn_1_1_N : N ;
  panhellenism_nn_1_N : N ;
  pankreatit_nn_1_N : N ;
  pannaa_nn_1_1_N : N ;
  panteism_nn_1_N : N ;
  panteist_nn_1_N : N ;
  papegojtulpan_nn_1_N : N ;
  papillon_nn_1_N : N ;
  papism_nn_1_N : N ;
  papuan_nn_1_N : N ;
  papyross_nn_1_N : N ;
  papyrus_nn_1_N : N ;
  paracervikalblockad_nn_1_N : N ;
  parad_nn_1_N : N ;
  paradentit_nn_1_N : N ;
  paradmarsch_nn_1_N : N ;
  paradox_nn_1_N : N ;
  parafras_nn_1_N : N ;
  paragon_nn_1_N : N ;
  paraguayan_nn_1_N : N ;
  parallell_nn_1_N : N ;
  parallellism_nn_1_N : N ;
  parallellklass_nn_1_N : N ;
  paralys_nn_1_N : N ;
  parasit_nn_1_N : N ;
  parasitism_nn_1_N : N ;
  paravan_nn_1_N : N ;
  pardans_nn_1_N : N ;
  parentator_nn_1_N : N ;
  parentes_nn_1_N : N ;
  pares_nn_1_N : N ;
  parfait_nn_1_N : N ;
  parikurs_nn_1_N : N ;
  parkeringsplats_nn_1_N : N ;
  parlamentarism_nn_1_N : N ;
  parnass_nn_1_N : N ;
  parodontit_nn_1_N : N ;
  paronym_nn_1_N : N ;
  partidisciplin_nn_1_N : N ;
  partikelaccelerator_nn_1_N : N ;
  partikongress_nn_1_N : N ;
  partikularism_nn_1_N : N ;
  partiledarpost_nn_1_N : N ;
  partisan_nn_1_N : N ;
  partistrateg_nn_1_N : N ;
  partitiv_nn_1_N : N ;
  partonym_nn_1_N : N ;
  parveny_nn_1_N : N ;
  passagerarplats_nn_1_N : N ;
  passkontroll_nn_1_N : N ;
  pastagrataeng_nn_1_1_N : N ;
  pastisch_nn_1_N : N ;
  pastor_nn_1_N : N ;
  patentmedicin_nn_1_N : N ;
  patiens_nn_1_N : N ;
  patientplats_nn_1_N : N ;
  patogen_nn_1_N : N ;
  patolog_nn_1_N : N ;
  patriot_nn_1_N : N ;
  patriotism_nn_1_N : N ;
  patris_nn_1_N : N ;
  patron_nn_2_N : N ;
  patt_nn_1_N : N ;
  pat_e_nn_1_1_N : N ;
  pauperism_nn_1_N : N ;
  paus_nn_1_N : N ;
  paussignal_nn_1_N : N ;
  pedant_nn_1_N : N ;
  pederast_nn_1_N : N ;
  pedikurist_nn_1_N : N ;
  pedikyrist_nn_1_N : N ;
  pedofil_nn_1_N : N ;
  pegas_nn_1_N : N ;
  pegmatit_nn_1_N : N ;
  pekbok_nn_1_N : N ;
  pekines_nn_1_N : N ;
  pekinges_nn_1_N : N ;
  pekoralist_nn_1_N : N ;
  pelargon_nn_1_N : N ;
  pelerin_nn_1_N : N ;
  pelikan_nn_1_N : N ;
  peltonturbin_nn_1_N : N ;
  pendeltaagsankomst_nn_1_1_N : N ;
  pendyl_nn_1_N : N ;
  pennalism_nn_1_N : N ;
  pennalist_nn_1_N : N ;
  pens_e_nn_1_1_N : N ;
  peon_nn_1_N : N ;
  perenn_nn_1_N : N ;
  perfektionism_nn_1_N : N ;
  perfektionist_nn_1_N : N ;
  perforator_nn_1_N : N ;
  perifon_nn_1_N : N ;
  perifras_nn_1_N : N ;
  peristyl_nn_1_N : N ;
  peritonit_nn_1_N : N ;
  perkolator_nn_1_N : N ;
  peroxid_nn_1_N : N ;
  persimon_nn_1_N : N ;
  person_nn_1_N : N ;
  personal_nn_1_N : N ;
  personalism_nn_1_N : N ;
  persondator_nn_1_N : N ;
  personvalskampanj_nn_1_N : N ;
  peruan_nn_1_N : N ;
  peruk_nn_1_N : N ;
  pessimism_nn_1_N : N ;
  pessimist_nn_1_N : N ;
  pest_nn_1_N : N ;
  pesticid_nn_1_N : N ;
  pestilens_nn_1_N : N ;
  petitess_nn_1_N : N ;
  pianist_nn_1_N : N ;
  pianopedal_nn_1_N : N ;
  pickadoll_nn_1_N : N ;
  pietism_nn_1_N : N ;
  pietist_nn_1_N : N ;
  pigroman_nn_1_N : N ;
  pikaresk_nn_1_N : N ;
  pikareskroman_nn_1_N : N ;
  pikkadoll_nn_1_N : N ;
  piktur_nn_1_N : N ;
  pik_e_nn_1_1_N : N ;
  pilall_e_nn_1_1_N : N ;
  pilotstrejk_nn_1_N : N ;
  pincen_e_nn_1_1_N : N ;
  pingstpastor_nn_1_N : N ;
  pingvin_nn_1_N : N ;
  pingvinturist_nn_1_N : N ;
  pinjong_nn_1_N : N ;
  pion_nn_1_N : N ;
  pirog_nn_1_N : N ;
  pist_nn_1_N : N ;
  pistasch_nn_1_N : N ;
  pistill_nn_1_N : N ;
  pistol_nn_1_N : N ;
  pivot_nn_1_N : N ;
  pivaa_nn_1_1_N : N ;
  pjaes_nn_1_1_N : N ;
  pladderkultur_nn_1_N : N ;
  plafond_nn_1_N : N ;
  plagiator_nn_1_N : N ;
  plaidoyer_nn_1_N : N ;
  plakett_nn_1_N : N ;
  plan_nn_1_N : N ;
  plan_nn_3_N : N ;
  planktonvaext_nn_1_1_N : N ;
  plansch_nn_1_N : N ;
  plast_nn_1_N : N ;
  platan_nn_1_N : N ;
  platonism_nn_1_N : N ;
  plats_nn_1_N : N ;
  plattityd_nn_1_N : N ;
  plataa_nn_1_1_N : N ;
  pleurit_nn_1_N : N ;
  plikt_nn_1_N : N ;
  pliss_e_nn_1_1_N : N ;
  plural_nn_1_N : N ;
  pluralism_nn_1_N : N ;
  pluton_nn_1_N : N ;
  plymasch_nn_1_N : N ;
  plymaa_nn_1_1_N : N ;
  plysch_nn_1_N : N ;
  plaedoaj_e_nn_1_1_N : N ;
  plaanbok_nn_1_1_N : N ;
  plaatlist_nn_1_1_N : N ;
  plaatpolis_nn_1_1_N : N ;
  pocketbok_nn_1_N : N ;
  podest_nn_1_N : N ;
  pointillism_nn_1_N : N ;
  pojkbok_nn_1_N : N ;
  pol_nn_1_N : N ;
  polarisator_nn_1_N : N ;
  polis_nn_2_N : N ;
  polisarrest_nn_1_N : N ;
  polisaspirant_nn_1_N : N ;
  polisnatur_nn_1_N : N ;
  polistjaenst_nn_1_1_N : N ;
  politbyraa_nn_1_1_N : N ;
  pollenfoerekomst_nn_1_1_N : N ;
  polonaes_nn_1_1_N : N ;
  polyamid_nn_1_N : N ;
  polycentrism_nn_1_N : N ;
  polyfosfat_nn_1_N : N ;
  polyglott_nn_1_N : N ;
  polygon_nn_1_N : N ;
  polyhistor_nn_1_N : N ;
  polysyndes_nn_1_N : N ;
  polyteism_nn_1_N : N ;
  pomerans_nn_1_N : N ;
  pomolog_nn_1_N : N ;
  ponton_nn_1_N : N ;
  pool_nn_1_N : N ;
  pop_nn_2_N : N ;
  popularisator_nn_1_N : N ;
  populism_nn_1_N : N ;
  populist_nn_1_N : N ;
  populaerkultur_nn_1_1_N : N ;
  porslinsfigur_nn_1_N : N ;
  portal_nn_1_N : N ;
  portalfigur_nn_1_N : N ;
  portep_e_nn_1_1_N : N ;
  portraettbyst_nn_1_1_N : N ;
  porttelefon_nn_1_N : N ;
  portugis_nn_1_N : N ;
  positiv_nn_2_N : N ;
  positivism_nn_1_N : N ;
  positivist_nn_1_N : N ;
  positron_nn_1_N : N ;
  post_nn_2_N : N ;
  postadress_nn_1_N : N ;
  postiljon_nn_1_N : N ;
  postisch_nn_1_N : N ;
  postkup_e_nn_1_1_N : N ;
  postmodernism_nn_1_N : N ;
  postmodernist_nn_1_N : N ;
  postroest_nn_1_1_N : N ;
  potatispur_e_nn_1_1_N : N ;
  potatisvaext_nn_1_1_N : N ;
  potemkinkuliss_nn_1_N : N ;
  potens_nn_1_N : N ;
  pragmatism_nn_1_N : N ;
  praktik_nn_1_N : N ;
  praktikant_nn_1_N : N ;
  praktikplats_nn_1_N : N ;
  praktpjaes_nn_1_1_N : N ;
  pralin_nn_1_N : N ;
  preceptor_nn_1_N : N ;
  preceptur_nn_1_N : N ;
  predator_nn_1_N : N ;
  predikant_nn_1_N : N ;
  predikokonst_nn_1_N : N ;
  predikotext_nn_1_N : N ;
  prefektur_nn_1_N : N ;
  preferens_nn_1_N : N ;
  preliminaerskatt_nn_1_1_N : N ;
  premiss_nn_1_N : N ;
  premiaerfaangst_nn_1_1_N : N ;
  premiaerministerpost_nn_1_1_N : N ;
  prenumerant_nn_1_N : N ;
  preparator_nn_1_N : N ;
  preparatris_nn_1_N : N ;
  presbyterian_nn_1_N : N ;
  president_nn_1_N : N ;
  presidentur_nn_1_N : N ;
  presidentvalskampanj_nn_1_N : N ;
  pressbyraa_nn_1_1_N : N ;
  presskonferens_nn_1_N : N ;
  prestationsloen_nn_1_1_N : N ;
  pretor_nn_1_N : N ;
  pretorian_nn_1_N : N ;
  primat_nn_2_N : N ;
  primatolog_nn_1_N : N ;
  primfaktor_nn_1_N : N ;
  primitivism_nn_1_N : N ;
  primogenitur_nn_1_N : N ;
  primtalsfaktor_nn_1_N : N ;
  primaerkredit_nn_1_1_N : N ;
  princip_nn_1_N : N ;
  prior_nn_1_N : N ;
  pris_nn_3_N : N ;
  prisfest_nn_1_N : N ;
  priskurant_nn_1_N : N ;
  prisnivaa_nn_1_1_N : N ;
  privatdetektiv_nn_1_N : N ;
  privatist_nn_1_N : N ;
  privatpraktik_nn_1_N : N ;
  procedur_nn_1_N : N ;
  process_nn_1_N : N ;
  processingenjoer_nn_1_1_N : N ;
  processor_nn_1_N : N ;
  produktframtagningsprocess_nn_1_N : N ;
  produktionsfaktor_nn_1_N : N ;
  produktionsskatt_nn_1_N : N ;
  professionalism_nn_1_N : N ;
  professor_nn_1_N : N ;
  professur_nn_1_N : N ;
  proffsdemonstrant_nn_1_N : N ;
  profil_nn_1_N : N ;
  profit_nn_1_N : N ;
  profoss_nn_1_N : N ;
  prognos_nn_1_N : N ;
  proinspektor_nn_1_N : N ;
  projektor_nn_1_N : N ;
  prokurator_nn_1_N : N ;
  prokurist_nn_1_N : N ;
  prolaps_nn_1_N : N ;
  proletaer_nn_1_1_N : N ;
  prolog_nn_1_N : N ;
  prominens_nn_1_N : N ;
  promotor_nn_1_N : N ;
  propagandist_nn_1_N : N ;
  proportionalism_nn_1_N : N ;
  propyl_nn_1_N : N ;
  propaa_nn_1_1_N : N ;
  prorektor_nn_1_N : N ;
  prosaist_nn_1_N : N ;
  prosektor_nn_1_N : N ;
  prostatit_nn_1_N : N ;
  protagonist_nn_1_N : N ;
  proteinanalys_nn_1_N : N ;
  proteinkemist_nn_1_N : N ;
  proteinmolekyl_nn_1_N : N ;
  protektionism_nn_1_N : N ;
  protektor_nn_1_N : N ;
  protes_nn_1_N : N ;
  protest_nn_1_N : N ;
  protestant_nn_1_N : N ;
  protestantism_nn_1_N : N ;
  protestkultur_nn_1_N : N ;
  protestroest_nn_1_1_N : N ;
  proteststrejk_nn_1_N : N ;
  protolys_nn_1_N : N ;
  proton_nn_1_N : N ;
  protonkarusell_nn_1_N : N ;
  protuberans_nn_1_N : N ;
  provanalys_nn_1_N : N ;
  proveniens_nn_1_N : N ;
  provins_nn_1_N : N ;
  provinsialism_nn_1_N : N ;
  prydnadsdetalj_nn_1_N : N ;
  prydnadsfigur_nn_1_N : N ;
  prydnadslist_nn_1_N : N ;
  prydnadsvaext_nn_1_1_N : N ;
  praest_nn_1_1_N : N ;
  praestgaardsarrendator_nn_1_1_N : N ;
  psalmbok_nn_1_N : N ;
  psalmist_nn_1_N : N ;
  psykoanalys_nn_1_N : N ;
  psykolog_nn_1_N : N ;
  psykologiprofessor_nn_1_N : N ;
  psykos_nn_1_N : N ;
  publicist_nn_1_N : N ;
  publik_nn_1_N : N ;
  publikan_nn_1_N : N ;
  puckelpist_nn_1_N : N ;
  pugilism_nn_1_N : N ;
  pugilist_nn_1_N : N ;
  puls_nn_1_N : N ;
  pulsar_nn_1_N : N ;
  pultron_nn_1_N : N ;
  pumpmotor_nn_1_N : N ;
  pumpsats_nn_1_N : N ;
  pundkris_nn_1_N : N ;
  punkt_nn_1_N : N ;
  punkteringssprej_nn_1_N : N ;
  punktinsats_nn_1_N : N ;
  punktskatt_nn_1_N : N ;
  punktur_nn_1_N : N ;
  punschpralin_nn_1_N : N ;
  purism_nn_1_N : N ;
  purist_nn_1_N : N ;
  puritan_nn_1_N : N ;
  puritanism_nn_1_N : N ;
  pur_e_nn_1_1_N : N ;
  putsch_nn_1_N : N ;
  pyelit_nn_1_N : N ;
  pylon_nn_1_N : N ;
  pyramid_nn_1_N : N ;
  pyrit_nn_1_N : N ;
  pyroklast_nn_1_N : N ;
  pyroman_nn_1_N : N ;
  paaannons_nn_1_1_N : N ;
  paalmast_nn_1_1_N : N ;
  paastaaendesats_nn_1_1_N : N ;
  quenell_nn_1_N : N ;
  rabbin_nn_1_N : N ;
  rabulism_nn_1_N : N ;
  rabulist_nn_1_N : N ;
  rad_nn_1_N : N ;
  radannons_nn_1_N : N ;
  radarreflektor_nn_1_N : N ;
  radian_nn_1_N : N ;
  radiator_nn_1_N : N ;
  radikal_nn_1_N : N ;
  radikalism_nn_1_N : N ;
  radiogrammofon_nn_1_N : N ;
  radiolog_nn_1_N : N ;
  radiopjaes_nn_1_1_N : N ;
  radioroest_nn_1_1_N : N ;
  radiosignal_nn_1_N : N ;
  radiotelefon_nn_1_N : N ;
  radiotelegrafist_nn_1_N : N ;
  raggmunkmix_nn_1_N : N ;
  raid_nn_1_N : N ;
  raketbas_nn_1_N : N ;
  raketmotor_nn_1_N : N ;
  ranch_nn_1_N : N ;
  randplataa_nn_1_1_N : N ;
  rangplats_nn_1_N : N ;
  ranson_nn_1_N : N ;
  ranunkelvaext_nn_1_1_N : N ;
  rapport_nn_1_N : N ;
  rapportbok_nn_1_N : N ;
  ras_nn_1_N : N ;
  rasism_nn_1_N : N ;
  rasist_nn_1_N : N ;
  rasistskandal_nn_1_N : N ;
  rast_nn_1_N : N ;
  rastplats_nn_1_N : N ;
  rationalism_nn_1_N : N ;
  rationalist_nn_1_N : N ;
  rattfyllerist_nn_1_N : N ;
  ravefest_nn_1_N : N ;
  ravelin_nn_1_N : N ;
  reaktionsfas_nn_1_N : N ;
  reaktionsmotor_nn_1_N : N ;
  reaktionstemperatur_nn_1_N : N ;
  reaktionaer_nn_1_1_N : N ;
  reaktor_nn_1_N : N ;
  reaktorkatastrof_nn_1_N : N ;
  realisationsvinst_nn_1_N : N ;
  realism_nn_1_N : N ;
  realist_nn_1_N : N ;
  reamotor_nn_1_N : N ;
  reassurans_nn_1_N : N ;
  recentior_nn_1_N : N ;
  receptdatabas_nn_1_N : N ;
  receptionist_nn_1_N : N ;
  receptor_nn_1_N : N ;
  receptur_nn_1_N : N ;
  recess_nn_1_N : N ;
  recherch_nn_1_N : N ;
  recit_nn_1_N : N ;
  redaktoer_nn_1_1_N : N ;
  redikyl_nn_1_N : N ;
  redoxprocess_nn_1_N : N ;
  referens_nn_1_N : N ;
  reflektor_nn_1_N : N ;
  reflex_nn_1_N : N ;
  reform_nn_1_N : N ;
  reformator_nn_1_N : N ;
  reformism_nn_1_N : N ;
  reformist_nn_1_N : N ;
  refraktor_nn_1_N : N ;
  regementspastor_nn_1_N : N ;
  regenerator_nn_1_N : N ;
  regeringspost_nn_1_N : N ;
  regim_nn_1_N : N ;
  regionalism_nn_1_N : N ;
  regionplan_nn_1_N : N ;
  registrator_nn_1_N : N ;
  regnoverall_nn_1_N : N ;
  regolit_nn_1_N : N ;
  regress_nn_1_N : N ;
  regulator_nn_1_N : N ;
  rejvfest_nn_1_N : N ;
  reklamaffisch_nn_1_N : N ;
  reklambroschyr_nn_1_N : N ;
  reklambyraa_nn_1_1_N : N ;
  reklampaus_nn_1_N : N ;
  rekordnivaa_nn_1_1_N : N ;
  rektor_nn_1_N : N ;
  rekurrens_nn_1_N : N ;
  rekyl_nn_1_N : N ;
  relativism_nn_1_N : N ;
  relativist_nn_1_N : N ;
  relativsats_nn_1_N : N ;
  relik_nn_1_N : N ;
  relikt_nn_1_N : N ;
  rembours_nn_1_N : N ;
  rembrandt_nn_1_N : N ;
  remburs_nn_1_N : N ;
  reminiscens_nn_1_N : N ;
  remis_nn_2_N : N ;
  remiss_nn_1_N : N ;
  remissinstans_nn_1_N : N ;
  remont_nn_1_N : N ;
  remouladsaas_nn_1_1_N : N ;
  remuladsaas_nn_1_1_N : N ;
  rengoeringssats_nn_1_1_N : N ;
  rentier_nn_1_N : N ;
  rentj_e_nn_1_1_N : N ;
  rentr_e_nn_1_1_N : N ;
  renaessans_nn_1_1_N : N ;
  renaessansarkitektur_nn_1_1_N : N ;
  renaessanskonst_nn_1_1_N : N ;
  reol_nn_1_N : N ;
  reportagebok_nn_1_N : N ;
  reporterlegend_nn_1_N : N ;
  representant_nn_1_N : N ;
  repris_nn_1_N : N ;
  reptil_nn_1_N : N ;
  republikan_nn_1_N : N ;
  resandebok_nn_1_N : N ;
  research_nn_1_N : N ;
  resebyraa_nn_1_1_N : N ;
  resegrammofon_nn_1_N : N ;
  resehandbok_nn_1_N : N ;
  reservant_nn_1_N : N ;
  resistor_nn_1_N : N ;
  resklass_nn_1_N : N ;
  resonemangskarusell_nn_1_N : N ;
  respirator_nn_1_N : N ;
  respit_nn_1_N : N ;
  rest_nn_1_N : N ;
  restaurang_nn_1_N : N ;
  restauranggaest_nn_1_1_N : N ;
  restaurant_nn_1_N : N ;
  restaurator_nn_1_N : N ;
  restauratris_nn_1_N : N ;
  restriktivitetsprincip_nn_1_N : N ;
  restskatt_nn_1_N : N ;
  resultant_nn_1_N : N ;
  resum_e_nn_1_1_N : N ;
  resurs_nn_1_N : N ;
  resursbas_nn_1_N : N ;
  resurskris_nn_1_N : N ;
  resaarmadrass_nn_1_1_N : N ;
  retor_nn_1_N : N ;
  retorikexpert_nn_1_N : N ;
  retronym_nn_1_N : N ;
  retraett_nn_1_1_N : N ;
  retraettplats_nn_1_1_N : N ;
  retur_nn_1_N : N ;
  returmatch_nn_1_N : N ;
  retusch_nn_1_N : N ;
  reumatism_nn_1_N : N ;
  reumatolog_nn_1_N : N ;
  revansch_nn_1_N : N ;
  revanschism_nn_1_N : N ;
  reveny_nn_1_N : N ;
  reverens_nn_1_N : N ;
  revers_nn_1_N : N ;
  revisionism_nn_1_N : N ;
  revisionist_nn_1_N : N ;
  revisor_nn_1_N : N ;
  revolutionaer_nn_1_1_N : N ;
  revy_nn_1_N : N ;
  revyartist_nn_1_N : N ;
  rh_faktor_nn_1_N : N ;
  riboflavin_nn_1_N : N ;
  ridikyl_nn_1_N : N ;
  ridinstruktoer_nn_1_1_N : N ;
  ridaa_nn_1_1_N : N ;
  rigorism_nn_1_N : N ;
  riksdagsplats_nn_1_N : N ;
  riksgraens_nn_1_1_N : N ;
  riksskandal_nn_1_N : N ;
  ringdans_nn_1_N : N ;
  ringstruktur_nn_1_N : N ;
  ripost_nn_1_N : N ;
  risk_nn_1_N : N ;
  riskanalys_nn_1_N : N ;
  riskfaktor_nn_1_N : N ;
  riskkapitalist_nn_1_N : N ;
  risknivaa_nn_1_1_N : N ;
  ritt_nn_1_N : N ;
  ritualism_nn_1_N : N ;
  rob_nn_1_N : N ;
  robotkrasch_nn_1_N : N ;
  robotroest_nn_1_1_N : N ;
  rockfestival_nn_1_N : N ;
  rojalism_nn_1_N : N ;
  rojalist_nn_1_N : N ;
  roll_on_deodorant_nn_1_N : N ;
  roll_nn_1_N : N ;
  rollator_nn_1_N : N ;
  rollfigur_nn_1_N : N ;
  rom_nn_2_N : N ;
  roman_nn_1_N : N ;
  romanist_nn_1_N : N ;
  romans_nn_1_N : N ;
  romboid_nn_1_N : N ;
  rosmarin_nn_1_N : N ;
  rot_nn_1_N : N ;
  rotationsmotor_nn_1_N : N ;
  rotor_nn_1_N : N ;
  roulad_nn_1_N : N ;
  roulett_nn_1_N : N ;
  rousseauan_nn_1_N : N ;
  rousseauanism_nn_1_N : N ;
  rubin_nn_1_N : N ;
  rubrik_nn_1_N : N ;
  ruderatvaext_nn_1_1_N : N ;
  ruin_nn_1_N : N ;
  rulad_nn_1_N : N ;
  rulett_nn_1_N : N ;
  rullad_nn_1_N : N ;
  rullator_nn_1_N : N ;
  rumslast_nn_1_N : N ;
  rumstemperatur_nn_1_N : N ;
  rundabordskonferens_nn_1_N : N ;
  runolog_nn_1_N : N ;
  ruptur_nn_1_N : N ;
  rusch_nn_1_N : N ;
  rush_nn_1_N : N ;
  rutin_nn_1_N : N ;
  rutt_nn_1_N : N ;
  ryggmuskelparalys_nn_1_N : N ;
  ryggsaecksturist_nn_1_1_N : N ;
  rymdfarkost_nn_1_N : N ;
  ryskkurs_nn_1_N : N ;
  ryttarstaty_nn_1_N : N ;
  raed_nn_1_1_N : N ;
  raeddningsinsats_nn_1_1_N : N ;
  raeddningsplan_nn_1_1_N : N ;
  raeddningstjaenst_nn_1_1_N : N ;
  raefst_nn_1_1_N : N ;
  raentenivaa_nn_1_1_N : N ;
  raentesats_nn_1_1_N : N ;
  raett_nn_3_13_N : N ;
  raettshaverist_nn_1_1_N : N ;
  raettsprincip_nn_1_1_N : N ;
  raettstvist_nn_1_1_N : N ;
  raaoljemotor_nn_1_1_N : N ;
  roekdetektor_nn_1_1_N : N ;
  roekgas_nn_1_1_N : N ;
  roekkup_e_nn_1_1_N : N ;
  roekmask_nn_1_1_N : N ;
  roekridaa_nn_1_1_N : N ;
  roektopas_nn_1_1_N : N ;
  roerelsedetektor_nn_1_1_N : N ;
  roerelseinkomst_nn_1_1_N : N ;
  roerelsevinst_nn_1_1_N : N ;
  roest_nn_1_1_N : N ;
  sabin_nn_1_N : N ;
  sadelplats_nn_1_N : N ;
  sadism_nn_1_N : N ;
  sadist_nn_1_N : N ;
  sado_masochism_nn_1_N : N ;
  saft_nn_1_N : N ;
  saftsaas_nn_1_1_N : N ;
  sagesperson_nn_1_N : N ;
  sagobok_nn_1_N : N ;
  sagofigur_nn_1_N : N ;
  sahib_nn_1_N : N ;
  sajt_nn_1_N : N ;
  sak_nn_1_N : N ;
  salin_nn_1_N : N ;
  salmonellafaers_nn_1_1_N : N ;
  salongskommunist_nn_1_N : N ;
  saloon_nn_1_N : N ;
  salpingit_nn_1_N : N ;
  saltkristall_nn_1_N : N ;
  saltvaext_nn_1_1_N : N ;
  salvadoran_nn_1_N : N ;
  salvationist_nn_1_N : N ;
  samarbetsplan_nn_1_N : N ;
  samarit_nn_1_N : N ;
  samekultur_nn_1_N : N ;
  samhaellsfasad_nn_1_1_N : N ;
  samhaellsinsats_nn_1_1_N : N ;
  samhaellsklass_nn_1_1_N : N ;
  samhaellspyramid_nn_1_1_N : N ;
  samhaellsrepresentant_nn_1_1_N : N ;
  samhaellssymbol_nn_1_1_N : N ;
  samlingslins_nn_1_N : N ;
  samlingsplats_nn_1_N : N ;
  sammankomst_nn_1_N : N ;
  sammansaettningsanalys_nn_1_1_N : N ;
  sammelplats_nn_1_N : N ;
  samnit_nn_1_N : N ;
  samoan_nn_1_N : N ;
  sampan_nn_1_N : N ;
  sandvaext_nn_1_1_N : N ;
  saneringsplan_nn_1_N : N ;
  sannolikhetskalkyl_nn_1_N : N ;
  sanskulott_nn_1_N : N ;
  saotomean_nn_1_N : N ;
  sarafan_nn_1_N : N ;
  sardin_nn_1_N : N ;
  satanism_nn_1_N : N ;
  satanist_nn_1_N : N ;
  satellit_nn_1_N : N ;
  sats_nn_1_N : N ;
  satsanalys_nn_1_N : N ;
  saturnaliefest_nn_1_N : N ;
  saturnism_nn_1_N : N ;
  saut_e_nn_1_1_N : N ;
  savarin_nn_1_N : N ;
  saxofon_nn_1_N : N ;
  saxofonist_nn_1_N : N ;
  scen_nn_1_N : N ;
  schablon_nn_1_N : N ;
  schackpjaes_nn_1_1_N : N ;
  schah_nn_1_N : N ;
  schakal_nn_1_N : N ;
  schakaa_nn_1_1_N : N ;
  schaman_nn_1_N : N ;
  schamanism_nn_1_N : N ;
  schampopatron_nn_1_N : N ;
  schartauan_nn_1_N : N ;
  schartauanism_nn_1_N : N ;
  schematism_nn_1_N : N ;
  schersmin_nn_1_N : N ;
  schimpans_nn_1_N : N ;
  schism_nn_1_N : N ;
  schlagertext_nn_1_N : N ;
  science_fictionroman_nn_1_N : N ;
  scientist_nn_1_N : N ;
  scientolog_nn_1_N : N ;
  seans_nn_1_N : N ;
  sed_nn_1_N : N ;
  sedan_nn_1_N : N ;
  sederoman_nn_1_N : N ;
  sedes_nn_1_N : N ;
  sefyr_nn_1_N : N ;
  segerfest_nn_1_N : N ;
  seglats_nn_1_N : N ;
  sekant_nn_1_N : N ;
  sekin_nn_1_N : N ;
  sekond_nn_1_N : N ;
  sekterism_nn_1_N : N ;
  sektor_nn_1_N : N ;
  sekularpraest_nn_1_1_N : N ;
  sekundant_nn_1_N : N ;
  sekvens_nn_1_N : N ;
  selot_nn_1_N : N ;
  semesterplan_nn_1_N : N ;
  semesterromans_nn_1_N : N ;
  semifinal_nn_1_N : N ;
  semifinalplats_nn_1_N : N ;
  seminarist_nn_1_N : N ;
  semit_nn_1_N : N ;
  semitist_nn_1_N : N ;
  senar_nn_1_N : N ;
  senator_nn_1_N : N ;
  senegales_nn_1_N : N ;
  sensor_nn_1_N : N ;
  sensualism_nn_1_N : N ;
  sentens_nn_1_N : N ;
  separatism_nn_1_N : N ;
  separatist_nn_1_N : N ;
  separator_nn_1_N : N ;
  seriefigur_nn_1_N : N ;
  seriematch_nn_1_N : N ;
  serpentin_nn_1_N : N ;
  serval_nn_1_N : N ;
  servilism_nn_1_N : N ;
  servis_nn_1_N : N ;
  servitris_nn_1_N : N ;
  servomotor_nn_1_N : N ;
  sexdebut_nn_1_N : N ;
  sexexpert_nn_1_N : N ;
  sexism_nn_1_N : N ;
  sexolog_nn_1_N : N ;
  sexskandal_nn_1_N : N ;
  sexsymbol_nn_1_N : N ;
  sextant_nn_1_N : N ;
  sextjaenst_nn_1_1_N : N ;
  sextol_nn_1_N : N ;
  sfinx_nn_1_N : N ;
  sfaer_nn_1_1_N : N ;
  sfaeroid_nn_1_1_N : N ;
  shah_nn_1_N : N ;
  shaman_nn_1_N : N ;
  shamanism_nn_1_N : N ;
  shiamuslim_nn_1_N : N ;
  shiit_nn_1_N : N ;
  shintoism_nn_1_N : N ;
  siames_nn_1_N : N ;
  sicilian_nn_1_N : N ;
  sidoentr_e_nn_1_1_N : N ;
  sidoinkomst_nn_1_N : N ;
  sifon_nn_1_N : N ;
  signal_nn_1_N : N ;
  signalbok_nn_1_N : N ;
  signalist_nn_1_N : N ;
  signalpistol_nn_1_N : N ;
  signalsubstans_nn_1_N : N ;
  signatur_nn_1_N : N ;
  signifikans_nn_1_N : N ;
  silikonlist_nn_1_N : N ;
  silkeskanin_nn_1_N : N ;
  sillfil_e_nn_1_1_N : N ;
  silverfasan_nn_1_N : N ;
  silverpokal_nn_1_N : N ;
  silverservis_nn_1_N : N ;
  sims_nn_1_N : N ;
  simulant_nn_1_N : N ;
  simulator_nn_1_N : N ;
  simultanism_nn_1_N : N ;
  singales_nn_1_N : N ;
  singaporian_nn_1_N : N ;
  singular_nn_1_N : N ;
  sinkadus_nn_1_N : N ;
  sinolog_nn_1_N : N ;
  sinuit_nn_1_N : N ;
  sinusit_nn_1_N : N ;
  sionism_nn_1_N : N ;
  sionist_nn_1_N : N ;
  sioux_nn_1_N : N ;
  sittplats_nn_1_N : N ;
  sittstrejk_nn_1_N : N ;
  sjakal_nn_1_N : N ;
  sjukdomsdiagnos_nn_1_N : N ;
  sjukgymnast_nn_1_N : N ;
  sjukhusdirektoer_nn_1_1_N : N ;
  sjukhusentr_e_nn_1_1_N : N ;
  sjuktransport_nn_1_N : N ;
  sjundedagsadventist_nn_1_N : N ;
  sjuraettersmeny_nn_1_1_N : N ;
  sjaelvanalys_nn_1_1_N : N ;
  sjaelvhjaelpsbok_nn_1_1_N : N ;
  sjaelvhjaelpsbransch_nn_1_1_N : N ;
  sjaelvmordsrisk_nn_1_1_N : N ;
  sjaelvrisk_nn_1_1_N : N ;
  sjoeelefant_nn_1_1_N : N ;
  sjoefyllerist_nn_1_1_N : N ;
  sjoeleopard_nn_1_1_N : N ;
  sjoerapport_nn_1_1_N : N ;
  sjoetransport_nn_1_1_N : N ;
  skald_nn_1_N : N ;
  skaldekonst_nn_1_N : N ;
  skaldjursrest_nn_1_N : N ;
  skallbas_nn_1_N : N ;
  skalaer_nn_1_1_N : N ;
  skandinavism_nn_1_N : N ;
  skandinavist_nn_1_N : N ;
  skanism_nn_1_N : N ;
  skarab_e_nn_1_1_N : N ;
  skatt_nn_1_N : N ;
  skatt_nn_2_N : N ;
  skattebas_nn_1_N : N ;
  skatteingenjoer_nn_1_1_N : N ;
  skatteinkomst_nn_1_N : N ;
  skatteklass_nn_1_N : N ;
  skattekverulant_nn_1_N : N ;
  skattenivaa_nn_1_1_N : N ;
  skatteprincip_nn_1_N : N ;
  skatteprotest_nn_1_N : N ;
  skattesats_nn_1_N : N ;
  skepticism_nn_1_N : N ;
  sketch_nn_1_N : N ;
  skidskyttestafett_nn_1_N : N ;
  skinnkavaj_nn_1_N : N ;
  skipod_nn_1_N : N ;
  skiss_nn_1_N : N ;
  skivbolagsdirektoer_nn_1_1_N : N ;
  skjutjaernsjournalist_nn_1_1_N : N ;
  skleros_nn_1_N : N ;
  skogskornell_nn_1_N : N ;
  skolavslutningsfest_nn_1_N : N ;
  skolbok_nn_1_N : N ;
  skoldans_nn_1_N : N ;
  skoldirektoer_nn_1_1_N : N ;
  skolinspektoer_nn_1_1_N : N ;
  skolklass_nn_1_N : N ;
  skollunch_nn_1_N : N ;
  skolmognadsklass_nn_1_N : N ;
  skolpolis_nn_1_N : N ;
  skolt_nn_1_N : N ;
  skoluppsats_nn_1_N : N ;
  skolaest_nn_1_1_N : N ;
  skomakarrealism_nn_1_N : N ;
  skorpion_nn_1_N : N ;
  skrattfest_nn_1_N : N ;
  skrattparoxysm_nn_1_N : N ;
  skrift_nn_1_N : N ;
  skriftkonst_nn_1_N : N ;
  skrivbok_nn_1_N : N ;
  skrivbyraa_nn_1_1_N : N ;
  skrivkonst_nn_1_N : N ;
  skrivplats_nn_1_N : N ;
  skrotskulptur_nn_1_N : N ;
  skraelldus_nn_1_1_N : N ;
  skraellvinst_nn_1_1_N : N ;
  skraepkultur_nn_1_1_N : N ;
  skuld_nn_1_N : N ;
  skuldkris_nn_1_N : N ;
  skulptris_nn_1_N : N ;
  skulptur_nn_1_N : N ;
  skumgummimadrass_nn_1_N : N ;
  skurkregim_nn_1_N : N ;
  skvadron_nn_1_N : N ;
  skyddsmask_nn_1_N : N ;
  skyddsmekanism_nn_1_N : N ;
  skyt_nn_1_N : N ;
  skaelmroman_nn_1_1_N : N ;
  skaergaardsturist_nn_1_1_N : N ;
  skaadeplats_nn_1_1_N : N ;
  skaadeprocess_nn_1_1_N : N ;
  skoerdefest_nn_1_1_N : N ;
  slagmask_nn_1_N : N ;
  slagskatt_nn_1_N : N ;
  slagskeppsmatros_nn_1_N : N ;
  slakt_nn_1_N : N ;
  slaktmask_nn_1_N : N ;
  slavism_nn_1_N : N ;
  slavist_nn_1_N : N ;
  slidmotor_nn_1_N : N ;
  slingervaext_nn_1_1_N : N ;
  slutfas_nn_1_N : N ;
  slutoffensiv_nn_1_N : N ;
  slutsats_nn_1_N : N ;
  slaekt_nn_1_1_N : N ;
  slaatterfest_nn_1_1_N : N ;
  smalmeny_nn_1_N : N ;
  smed_nn_1_N : N ;
  sminkexpert_nn_1_N : N ;
  sminkoes_nn_1_1_N : N ;
  smittkoppsvaccin_nn_1_N : N ;
  smittorisk_nn_1_N : N ;
  smutskastningskampanj_nn_1_N : N ;
  smygimpuls_nn_1_N : N ;
  smygpremiaer_nn_1_1_N : N ;
  smaertreceptor_nn_1_1_N : N ;
  smaabarnsbok_nn_1_1_N : N ;
  smaadetalj_nn_1_1_N : N ;
  smaaligist_nn_1_1_N : N ;
  smaaorganism_nn_1_1_N : N ;
  snabbkurs_nn_1_N : N ;
  snabblunch_nn_1_N : N ;
  snabbmatsrestaurang_nn_1_N : N ;
  snabbregulator_nn_1_N : N ;
  snabbremiss_nn_1_N : N ;
  snabbrepris_nn_1_N : N ;
  snabbskiss_nn_1_N : N ;
  snabbtelefon_nn_1_N : N ;
  snabbvisit_nn_1_N : N ;
  snobbism_nn_1_N : N ;
  snyltgaest_nn_1_1_N : N ;
  snyltvaext_nn_1_1_N : N ;
  snoekristall_nn_1_1_N : N ;
  snoeprognos_nn_1_1_N : N ;
  snoerapport_nn_1_1_N : N ;
  soar_e_nn_1_1_N : N ;
  socialantropolog_nn_1_N : N ;
  socialbyraa_nn_1_1_N : N ;
  socialdemokrat_nn_1_N : N ;
  socialdirektoer_nn_1_1_N : N ;
  socialism_nn_1_N : N ;
  socialist_nn_1_N : N ;
  socialklass_nn_1_N : N ;
  socialliberalism_nn_1_N : N ;
  socialpsykolog_nn_1_N : N ;
  socialrealism_nn_1_N : N ;
  sociolog_nn_1_N : N ;
  sockerkampanj_nn_1_N : N ;
  sockermolekyl_nn_1_N : N ;
  soffit_nn_1_N : N ;
  sofism_nn_1_N : N ;
  sofist_nn_1_N : N ;
  soldatfigur_nn_1_N : N ;
  solfest_nn_1_N : N ;
  solipsism_nn_1_N : N ;
  solist_nn_1_N : N ;
  solitaer_nn_1_1_N : N ;
  solreflex_nn_1_N : N ;
  sommaradress_nn_1_N : N ;
  sommargaest_nn_1_1_N : N ;
  somnambul_nn_1_N : N ;
  somnambulism_nn_1_N : N ;
  sonant_nn_1_N : N ;
  sonatin_nn_1_N : N ;
  sopran_nn_1_N : N ;
  sordin_nn_1_N : N ;
  sorg_nn_1_N : N ;
  sorgegudstjaenst_nn_1_1_N : N ;
  sorgeprocess_nn_1_N : N ;
  sottis_nn_1_N : N ;
  sousafon_nn_1_N : N ;
  souterrain_nn_1_N : N ;
  souterraeng_nn_1_1_N : N ;
  sovchos_nn_1_N : N ;
  sovmask_nn_1_N : N ;
  sovplats_nn_1_N : N ;
  spalj_e_nn_1_1_N : N ;
  spannmaalsleverans_nn_1_1_N : N ;
  sparagmit_nn_1_N : N ;
  sparbanksbok_nn_1_N : N ;
  spartakist_nn_1_N : N ;
  spartan_nn_1_N : N ;
  specerist_nn_1_N : N ;
  special_nn_1_N : N ;
  specialist_nn_1_N : N ;
  specialistkompetens_nn_1_N : N ;
  specialklass_nn_1_N : N ;
  spekulant_nn_1_N : N ;
  spekulationskarusell_nn_1_N : N ;
  speleolog_nn_1_N : N ;
  spelplan_nn_2_N : N ;
  spens_nn_1_N : N ;
  spermadonator_nn_1_N : N ;
  spermatozoid_nn_1_N : N ;
  spetskompetens_nn_1_N : N ;
  spikpistol_nn_1_N : N ;
  spion_nn_1_N : N ;
  spiralgalax_nn_1_N : N ;
  spirant_nn_1_N : N ;
  spiritism_nn_1_N : N ;
  spiritist_nn_1_N : N ;
  spiritualism_nn_1_N : N ;
  spiritualist_nn_1_N : N ;
  spondylit_nn_1_N : N ;
  spond_e_nn_1_1_N : N ;
  sponsor_nn_1_N : N ;
  spont_nn_1_N : N ;
  spontanism_nn_1_N : N ;
  sport_nn_1_N : N ;
  sportjournalist_nn_1_N : N ;
  sporvaext_nn_1_1_N : N ;
  spridningslins_nn_1_N : N ;
  spritspion_nn_1_N : N ;
  sprutnarkoman_nn_1_N : N ;
  sprutpistol_nn_1_N : N ;
  spraengarbetsplats_nn_1_1_N : N ;
  spraenggas_nn_1_1_N : N ;
  spraengaemnesmolekyl_nn_1_1_N : N ;
  spraakkonsult_nn_1_1_N : N ;
  spraakkurs_nn_1_1_N : N ;
  spraakpolis_nn_1_1_N : N ;
  spraakprofessor_nn_1_1_N : N ;
  spraakresurs_nn_1_1_N : N ;
  spraangmarsch_nn_1_1_N : N ;
  spaenningsregulator_nn_1_1_N : N ;
  spaens_nn_1_1_N : N ;
  spaerrdiod_nn_1_1_N : N ;
  spaadomskonst_nn_1_1_N : N ;
  spaant_nn_1_1_N : N ;
  spoekfigur_nn_1_1_N : N ;
  squash_nn_2_N : N ;
  srilankes_nn_1_N : N ;
  stabilisator_nn_1_N : N ;
  stadsplan_nn_1_N : N ;
  staffagefigur_nn_1_N : N ;
  stalagmit_nn_1_N : N ;
  stalaktit_nn_1_N : N ;
  stalinism_nn_1_N : N ;
  stalinist_nn_1_N : N ;
  stambok_nn_1_N : N ;
  stamgaest_nn_1_1_N : N ;
  stand_in_nn_1_N : N ;
  standardingrediens_nn_1_N : N ;
  stans_nn_2_N : N ;
  stapelplats_nn_1_N : N ;
  startgenerator_nn_1_N : N ;
  startmotor_nn_1_N : N ;
  startpistol_nn_1_N : N ;
  stas_nn_1_N : N ;
  stationsinspektor_nn_1_N : N ;
  statist_nn_1_N : N ;
  stativ_nn_2_N : N ;
  stator_nn_1_N : N ;
  statsepidemolog_nn_1_N : N ;
  statsgeolog_nn_1_N : N ;
  statsrevisor_nn_1_N : N ;
  statsraadslunch_nn_1_1_N : N ;
  statur_nn_1_N : N ;
  statussymbol_nn_1_N : N ;
  statut_nn_1_N : N ;
  staty_nn_1_N : N ;
  steglits_nn_1_N : N ;
  stenos_nn_1_N : N ;
  stentorsroest_nn_1_1_N : N ;
  stenaaldersnivaa_nn_1_1_N : N ;
  steradian_nn_1_N : N ;
  stereotyp_nn_1_N : N ;
  sterin_nn_1_N : N ;
  steroid_nn_1_N : N ;
  sterol_nn_1_N : N ;
  stilfigur_nn_1_N : N ;
  stilikon_nn_1_N : N ;
  stilist_nn_1_N : N ;
  stilkonsekvens_nn_1_N : N ;
  stimulans_nn_1_N : N ;
  stimulator_nn_1_N : N ;
  stirlingmotor_nn_1_N : N ;
  stjaernfigur_nn_1_1_N : N ;
  stjaernjurist_nn_1_1_N : N ;
  stjaernmotor_nn_1_1_N : N ;
  stod_nn_1_N : N ;
  stofil_nn_1_N : N ;
  stoicism_nn_1_N : N ;
  stomatit_nn_1_N : N ;
  stoppsignal_nn_1_N : N ;
  storasysterattityd_nn_1_N : N ;
  stordator_nn_1_N : N ;
  stordonator_nn_1_N : N ;
  storfavorit_nn_1_N : N ;
  stormast_nn_1_N : N ;
  storoffensiv_nn_1_N : N ;
  storstrejk_nn_1_N : N ;
  storvinst_nn_1_N : N ;
  story_nn_1_N : N ;
  strabism_nn_1_N : N ;
  straffnivaa_nn_1_1_N : N ;
  strandfavorit_nn_1_N : N ;
  strandrestaurang_nn_1_N : N ;
  strandvaext_nn_1_1_N : N ;
  strapats_nn_1_N : N ;
  strateg_nn_1_N : N ;
  stridsgas_nn_1_N : N ;
  stridsplats_nn_1_N : N ;
  strokekris_nn_1_N : N ;
  struktur_nn_1_N : N ;
  strukturalism_nn_1_N : N ;
  strukturalist_nn_1_N : N ;
  strupkatarr_nn_1_N : N ;
  stryknindos_nn_1_N : N ;
  straaldos_nn_1_1_N : N ;
  straalningsdos_nn_1_1_N : N ;
  straalningskommitt_e_nn_1_1_N : N ;
  straalrisk_nn_1_1_N : N ;
  stroekurs_nn_1_1_N : N ;
  stroemmingsfil_e_nn_1_1_N : N ;
  stubin_nn_1_N : N ;
  stuckatur_nn_1_N : N ;
  studieplats_nn_1_N : N ;
  studierektor_nn_1_N : N ;
  stylit_nn_1_N : N ;
  styrelsepost_nn_1_N : N ;
  styrsignal_nn_1_N : N ;
  staepp_nn_1_1_N : N ;
  staeppnomad_nn_1_1_N : N ;
  staaplats_nn_1_1_N : N ;
  stoedfestival_nn_1_1_N : N ;
  stoedinsats_nn_1_1_N : N ;
  stoeld_nn_1_1_N : N ;
  stoeldturn_e_nn_1_1_N : N ;
  stoevlett_nn_1_1_N : N ;
  subdominant_nn_1_N : N ;
  subjektivism_nn_1_N : N ;
  subkultur_nn_1_N : N ;
  substans_nn_1_N : N ;
  succe_es_nn_1_1_N : N ;
  succ_e_nn_1_1_N : N ;
  suckulent_nn_1_N : N ;
  sudanes_nn_1_N : N ;
  suffl_e_nn_1_1_N : N ;
  suffloes_nn_1_1_N : N ;
  sugfas_nn_1_N : N ;
  suicidrisk_nn_1_N : N ;
  sulfid_nn_1_N : N ;
  sulky_nn_1_N : N ;
  sultan_nn_1_N : N ;
  sumer_nn_1_N : N ;
  sunnimuslim_nn_1_N : N ;
  sunnit_nn_1_N : N ;
  superdator_nn_1_N : N ;
  superegoism_nn_1_N : N ;
  superellips_nn_1_N : N ;
  superlativ_nn_1_N : N ;
  supermatch_nn_1_N : N ;
  supervinst_nn_1_N : N ;
  suppleant_nn_1_N : N ;
  supplikant_nn_1_N : N ;
  supranaturalism_nn_1_N : N ;
  suprematism_nn_1_N : N ;
  sup_e_nn_1_1_N : N ;
  surinames_nn_1_N : N ;
  surpris_nn_1_N : N ;
  surrealism_nn_1_N : N ;
  suspensoar_nn_1_N : N ;
  sutan_nn_1_N : N ;
  suterraeng_nn_1_1_N : N ;
  sutur_nn_1_N : N ;
  suveraen_nn_1_1_N : N ;
  svajmast_nn_1_N : N ;
  svampparasit_nn_1_N : N ;
  svampvaext_nn_1_1_N : N ;
  svansmotor_nn_1_N : N ;
  svartkonst_nn_1_N : N ;
  svartlistningsgraens_nn_1_1_N : N ;
  svavelpredikant_nn_1_N : N ;
  svecism_nn_1_N : N ;
  svekoman_nn_1_N : N ;
  svenskamerikan_nn_1_N : N ;
  svenskkurs_nn_1_N : N ;
  svetselektrod_nn_1_N : N ;
  svulst_nn_1_N : N ;
  svaeltkatastrof_nn_1_1_N : N ;
  svaenghjulsmagnet_nn_1_1_N : N ;
  svaerdsdans_nn_1_1_N : N ;
  svaevfarkost_nn_1_1_N : N ;
  sybarit_nn_1_N : N ;
  sydafrikan_nn_1_N : N ;
  sydjemenit_nn_1_N : N ;
  sydkorean_nn_1_N : N ;
  sydkust_nn_1_N : N ;
  sydyemenit_nn_1_N : N ;
  sykofant_nn_1_N : N ;
  sylfid_nn_1_N : N ;
  syllogism_nn_1_N : N ;
  sylt_nn_1_N : N ;
  symbiont_nn_1_N : N ;
  symbol_nn_1_N : N ;
  symbolism_nn_1_N : N ;
  symbolist_nn_1_N : N ;
  symbolsekvens_nn_1_N : N ;
  symbolskatt_nn_1_N : N ;
  symfys_nn_1_N : N ;
  sympatistrejk_nn_1_N : N ;
  syn_nn_1_N : N ;
  synaps_nn_1_N : N ;
  syndikalism_nn_1_N : N ;
  syndikalist_nn_1_N : N ;
  synergism_nn_1_N : N ;
  synklinal_nn_1_N : N ;
  synkpuls_nn_1_N : N ;
  synkretism_nn_1_N : N ;
  synkronism_nn_1_N : N ;
  synkrotron_nn_1_N : N ;
  synonym_nn_1_N : N ;
  synonymordbok_nn_1_N : N ;
  synops_nn_1_N : N ;
  syntax_nn_1_N : N ;
  syntaxanalys_nn_1_N : N ;
  syntes_nn_1_N : N ;
  syntet_nn_1_N : N ;
  syremolekyl_nn_1_N : N ;
  syrenbersaa_nn_1_1_N : N ;
  syretransport_nn_1_N : N ;
  syrgasmask_nn_1_N : N ;
  syrgasmolekyl_nn_1_N : N ;
  saekerhetskontroll_nn_1_1_N : N ;
  saekerhetspolis_nn_2_1_N : N ;
  saekerhetsrisk_nn_1_1_N : N ;
  saellskapsdans_nn_1_1_N : N ;
  saengkammarfars_nn_1_1_N : N ;
  saerklass_nn_2_1_N : N ;
  saadd_nn_1_1_N : N ;
  saang_nn_1_1_N : N ;
  saangtext_nn_1_1_N : N ;
  saas_nn_1_1_N : N ;
  saat_e_nn_1_1_N : N ;
  soekmotor_nn_1_1_N : N ;
  soemnapn_e_nn_1_1_N : N ;
  soergaardsidyll_nn_1_1_N : N ;
  tabellskatt_nn_1_N : N ;
  tablett_nn_1_N : N ;
  tabloid_nn_1_N : N ;
  tablaa_nn_1_1_N : N ;
  tabugraens_nn_1_1_N : N ;
  tabulator_nn_1_N : N ;
  tabulatur_nn_1_N : N ;
  tacksaegelsefest_nn_1_1_N : N ;
  tacksaegelsegudstjaenst_nn_1_1_N : N ;
  tadzjik_nn_1_N : N ;
  tagelmadrass_nn_1_N : N ;
  taiwanes_nn_1_N : N ;
  takaltan_nn_1_N : N ;
  takfris_nn_1_N : N ;
  takgesims_nn_1_N : N ;
  taklagsfest_nn_1_N : N ;
  taklist_nn_1_N : N ;
  takt_nn_1_N : N ;
  taktik_nn_1_N : N ;
  talbok_nn_1_N : N ;
  talesperson_nn_1_N : N ;
  taliban_nn_1_N : N ;
  talibanrebell_nn_1_N : N ;
  talisman_nn_1_N : N ;
  talmanskonferens_nn_1_N : N ;
  talpjaes_nn_1_1_N : N ;
  tamarisk_nn_1_N : N ;
  tambur_nn_1_N : N ;
  tamburin_nn_1_N : N ;
  tamburmajor_nn_1_N : N ;
  tamil_nn_1_N : N ;
  tandhygienist_nn_1_N : N ;
  tandlist_nn_1_N : N ;
  tandprotes_nn_1_N : N ;
  tangakalsong_nn_1_N : N ;
  tangerin_nn_1_N : N ;
  tangokavaljer_nn_1_N : N ;
  tankefigur_nn_1_N : N ;
  tankenoet_nn_1_1_N : N ;
  tankvolym_nn_1_N : N ;
  taoism_nn_1_N : N ;
  taoist_nn_1_N : N ;
  tapir_nn_1_N : N ;
  tappt_nn_1_N : N ;
  tarmgas_nn_1_N : N ;
  tarmkatarr_nn_1_N : N ;
  tars_nn_1_N : N ;
  tatar_nn_1_N : N ;
  taxichauffoer_nn_1_1_N : N ;
  teaterdirektoer_nn_1_1_N : N ;
  teaterfigur_nn_1_N : N ;
  teaterfoaj_e_nn_1_1_N : N ;
  teatermaskinist_nn_1_N : N ;
  teaterpjaes_nn_1_1_N : N ;
  tegelstensroman_nn_1_N : N ;
  teism_nn_1_N : N ;
  teknik_nn_1_N : N ;
  teknikbransch_nn_1_N : N ;
  teknikjournalist_nn_1_N : N ;
  teknolog_nn_1_N : N ;
  telefon_nn_1_N : N ;
  telefonist_nn_1_N : N ;
  telefonkiosk_nn_1_N : N ;
  telefonkonferens_nn_1_N : N ;
  telefonsignal_nn_1_N : N ;
  telegraf_nn_1_N : N ;
  telegrafist_nn_1_N : N ;
  telegramadress_nn_1_N : N ;
  telegrambyraa_nn_1_1_N : N ;
  telesatellit_nn_1_N : N ;
  temperatur_nn_1_N : N ;
  temperaturregulator_nn_1_N : N ;
  tendens_nn_1_N : N ;
  tennisjournalist_nn_1_N : N ;
  tenorbaryton_nn_1_N : N ;
  tenorsaxofon_nn_1_N : N ;
  tensid_nn_1_N : N ;
  tentamensbok_nn_1_N : N ;
  tentator_nn_1_N : N ;
  teodolit_nn_1_N : N ;
  teolog_nn_1_N : N ;
  terass_nn_1_N : N ;
  terminal_nn_1_N : N ;
  terminolog_nn_1_N : N ;
  termistor_nn_1_N : N ;
  termit_nn_1_N : N ;
  termoplast_nn_1_N : N ;
  termoregulator_nn_1_N : N ;
  terrakottasoldat_nn_1_N : N ;
  terrass_nn_1_N : N ;
  terrin_nn_1_N : N ;
  territorialgraens_nn_1_1_N : N ;
  terrorism_nn_1_N : N ;
  terrorist_nn_1_N : N ;
  terrorplan_nn_1_N : N ;
  terraengfoerlust_nn_1_1_N : N ;
  terraengvinst_nn_1_1_N : N ;
  ters_nn_1_N : N ;
  terzin_nn_1_N : N ;
  tes_nn_1_N : N ;
  testamentsexekutor_nn_1_N : N ;
  testator_nn_1_N : N ;
  testreaktor_nn_1_N : N ;
  tetragon_nn_1_N : N ;
  tetraklorid_nn_1_N : N ;
  tetrapod_nn_1_N : N ;
  teuton_nn_1_N : N ;
  teve_evangelist_nn_1_N : N ;
  teveevangelist_nn_1_N : N ;
  tevekonferens_nn_1_N : N ;
  tevemast_nn_1_N : N ;
  tevepredikant_nn_1_N : N ;
  teveproducent_nn_1_N : N ;
  teveprofil_nn_1_N : N ;
  tevesignal_nn_1_N : N ;
  textbok_nn_1_N : N ;
  textfoerlust_nn_1_1_N : N ;
  textil_nn_1_N : N ;
  textilkurs_nn_1_N : N ;
  textur_nn_1_N : N ;
  thairestaurang_nn_1_N : N ;
  tiamin_nn_1_N : N ;
  tibetan_nn_1_N : N ;
  tidebok_nn_1_N : N ;
  tidningskiosk_nn_1_N : N ;
  tidningsnotis_nn_1_N : N ;
  tidsfaktor_nn_1_N : N ;
  tidsfrist_nn_1_N : N ;
  tidsfoerlust_nn_1_1_N : N ;
  tidsgraens_nn_1_1_N : N ;
  tidsplan_nn_1_N : N ;
  tidssignal_nn_1_N : N ;
  tidsvinst_nn_1_N : N ;
  tillsats_nn_1_N : N ;
  tillsatslins_nn_1_N : N ;
  tillverkningsprocess_nn_1_N : N ;
  tillvaextprognos_nn_1_1_N : N ;
  tillaeggsplats_nn_1_1_N : N ;
  timbal_nn_1_N : N ;
  tinktur_nn_1_N : N ;
  tiominutersrast_nn_1_N : N ;
  tiotalism_nn_1_N : N ;
  tiotalist_nn_1_N : N ;
  tirad_nn_1_N : N ;
  titan_nn_1_N : N ;
  titelmatch_nn_1_N : N ;
  tittarsucc_e_nn_1_1_N : N ;
  titulatur_nn_1_N : N ;
  tjeck_nn_1_N : N ;
  tjejbacill_nn_1_N : N ;
  tjejmagnet_nn_1_N : N ;
  tjetjen_nn_1_N : N ;
  tjurfaektningssaesong_nn_1_1_N : N ;
  tjaenst_nn_1_1_N : N ;
  tjaenst_nn_2_1_N : N ;
  tjaenstesektor_nn_1_1_N : N ;
  toalett_nn_1_N : N ;
  tobakist_nn_1_N : N ;
  tobakskiosk_nn_1_N : N ;
  togoles_nn_1_N : N ;
  tolerans_nn_1_N : N ;
  tolvmilsgraens_nn_1_1_N : N ;
  tomahawk_nn_1_N : N ;
  tomahaak_nn_1_1_N : N ;
  tomtemask_nn_1_N : N ;
  tomtgraens_nn_1_1_N : N ;
  ton_nn_1_N : N ;
  tongan_nn_1_N : N ;
  tonsur_nn_1_N : N ;
  tonaarsabort_nn_1_1_N : N ;
  tonaarsidol_nn_1_1_N : N ;
  topas_nn_1_N : N ;
  toppdomaen_nn_1_1_N : N ;
  toppkonferens_nn_1_N : N ;
  toppmast_nn_1_N : N ;
  toppnivaa_nn_1_1_N : N ;
  toppost_nn_1_N : N ;
  tordoensroest_nn_1_1_N : N ;
  torkcentrifug_nn_1_N : N ;
  torkkatastrof_nn_1_N : N ;
  tortyr_nn_1_N : N ;
  tosk_nn_1_N : N ;
  totalisator_nn_1_N : N ;
  totalitarism_nn_1_N : N ;
  totemism_nn_1_N : N ;
  toup_e_nn_1_1_N : N ;
  tour_nn_1_N : N ;
  tournedos_nn_1_N : N ;
  toxikolog_nn_1_N : N ;
  trad_nn_1_N : N ;
  traditionalism_nn_1_N : N ;
  traditionalist_nn_1_N : N ;
  trafikant_nn_1_N : N ;
  trafikexpert_nn_1_N : N ;
  trafikkontroll_nn_1_N : N ;
  trafikplats_nn_1_N : N ;
  trafiksignal_nn_1_N : N ;
  trakt_nn_1_N : N ;
  traktor_nn_1_N : N ;
  traktur_nn_1_N : N ;
  trak_e_nn_1_1_N : N ;
  trampolin_nn_1_N : N ;
  tranch_nn_1_N : N ;
  transaktionsanalys_nn_1_N : N ;
  transduktor_nn_1_N : N ;
  transformator_nn_1_N : N ;
  transistor_nn_1_N : N ;
  transitlast_nn_1_N : N ;
  translativ_nn_1_N : N ;
  translator_nn_1_N : N ;
  transport_nn_1_N : N ;
  transportmekanism_nn_1_N : N ;
  transportprocess_nn_1_N : N ;
  transversal_nn_1_N : N ;
  transvestism_nn_1_N : N ;
  transvestit_nn_1_N : N ;
  transvestitism_nn_1_N : N ;
  trapets_nn_1_N : N ;
  trapetsoid_nn_1_N : N ;
  trappavsats_nn_1_N : N ;
  trattkantarell_nn_1_N : N ;
  travers_nn_1_N : N ;
  travsulky_nn_1_N : N ;
  trebetygskurs_nn_1_N : N ;
  tredagarskonferens_nn_1_N : N ;
  tredjeplats_nn_1_N : N ;
  tremilsgraens_nn_1_1_N : N ;
  tremulant_nn_1_N : N ;
  trendanalys_nn_1_N : N ;
  trepan_nn_1_N : N ;
  treraettersmeny_nn_1_1_N : N ;
  triangelmatch_nn_1_N : N ;
  triangelreflex_nn_1_N : N ;
  tribadism_nn_1_N : N ;
  tribalism_nn_1_N : N ;
  trikin_nn_1_N : N ;
  trikaa_nn_1_1_N : N ;
  triljon_nn_1_N : N ;
  trillingkristall_nn_1_N : N ;
  trillion_nn_1_N : N ;
  trilobit_nn_1_N : N ;
  triol_nn_1_N : N ;
  triplett_nn_1_N : N ;
  trippelallians_nn_1_N : N ;
  trirem_nn_1_N : N ;
  triton_nn_1_N : N ;
  triumfator_nn_1_N : N ;
  trivselfaktor_nn_1_N : N ;
  trioer_nn_1_1_N : N ;
  trof_e_nn_1_1_N : N ;
  trojan_nn_1_N : N ;
  trok_e_nn_1_1_N : N ;
  trolldomsrit_nn_1_N : N ;
  trollerikonst_nn_1_N : N ;
  trollkonst_nn_1_N : N ;
  trombon_nn_1_N : N ;
  trombonist_nn_1_N : N ;
  trombos_nn_1_N : N ;
  tron_nn_1_N : N ;
  tropism_nn_1_N : N ;
  trossats_nn_1_N : N ;
  trotskism_nn_1_N : N ;
  trotskist_nn_1_N : N ;
  trubadur_nn_1_N : N ;
  truism_nn_1_N : N ;
  trumpet_nn_1_N : N ;
  trumpetsignal_nn_1_N : N ;
  trumrytm_nn_1_N : N ;
  trupptransport_nn_1_N : N ;
  trust_nn_1_N : N ;
  tryckkabin_nn_1_N : N ;
  trycksats_nn_1_N : N ;
  tryckvattenreaktor_nn_1_N : N ;
  tryckvattensreaktor_nn_1_N : N ;
  trygghetsnarkoman_nn_1_N : N ;
  trymaa_nn_1_1_N : N ;
  traedgraens_nn_1_1_N : N ;
  traedgaardsexpert_nn_1_1_N : N ;
  traedgaardstraktor_nn_1_1_N : N ;
  traedstruktur_nn_1_1_N : N ;
  traengselskatt_nn_1_1_N : N ;
  traeningsoverall_nn_1_1_N : N ;
  traeskodans_nn_1_1_N : N ;
  tsarregim_nn_1_N : N ;
  tsunamikatastrof_nn_1_N : N ;
  tuff_nn_1_N : N ;
  tukan_nn_1_N : N ;
  tullkontroll_nn_1_N : N ;
  tulpan_nn_1_N : N ;
  tummelplats_nn_1_N : N ;
  tungus_nn_1_N : N ;
  tungvattenreaktor_nn_1_N : N ;
  tunnelbanekiosk_nn_1_N : N ;
  tunneldiod_nn_1_N : N ;
  tup_e_nn_1_1_N : N ;
  tur_nn_1_N : N ;
  turban_nn_1_N : N ;
  turbin_nn_1_N : N ;
  turbinmotor_nn_1_N : N ;
  turbojetmotor_nn_1_N : N ;
  turbomotor_nn_1_N : N ;
  turbopropmotor_nn_1_N : N ;
  turism_nn_1_N : N ;
  turist_nn_1_N : N ;
  turistbroschyr_nn_1_N : N ;
  turistbyraa_nn_1_1_N : N ;
  turisthandbok_nn_1_N : N ;
  turistklass_nn_1_N : N ;
  turkmen_nn_1_N : N ;
  turkos_nn_1_N : N ;
  turmalin_nn_1_N : N ;
  turn_e_nn_1_1_N : N ;
  tuvaluan_nn_1_N : N ;
  tv_evangelist_nn_1_N : N ;
  tv_konferens_nn_1_N : N ;
  tv_predikant_nn_1_N : N ;
  tv_producent_nn_1_N : N ;
  tv_tablaa_nn_1_1_N : N ;
  tvillingkristall_nn_1_N : N ;
  tvist_nn_1_N : N ;
  tvaangsneuros_nn_1_1_N : N ;
  tvaataktsmotor_nn_1_1_N : N ;
  tweedkavaj_nn_1_N : N ;
  tyfon_nn_1_N : N ;
  tygrest_nn_1_N : N ;
  tympanon_nn_1_N : N ;
  tyngd_nn_1_N : N ;
  typograf_nn_1_N : N ;
  tyrann_nn_1_N : N ;
  tyristor_nn_1_N : N ;
  tyskkurs_nn_1_N : N ;
  taeckadress_nn_1_1_N : N ;
  taeljstenskamin_nn_1_1_N : N ;
  taendkulemotor_nn_1_1_N : N ;
  taendsats_nn_1_1_N : N ;
  taenkebok_nn_1_1_N : N ;
  taetataet_nn_1_1_N : N ;
  taetningslist_nn_1_1_N : N ;
  taetplats_nn_1_1_N : N ;
  taevlingscyklist_nn_1_1_N : N ;
  taevlingsjury_nn_1_1_N : N ;
  taevlingsklass_nn_1_1_N : N ;
  taagankomst_nn_1_1_N : N ;
  taagkup_e_nn_1_1_N : N ;
  taagtransport_nn_1_1_N : N ;
  toes_nn_1_1_N : N ;
  ubikvist_nn_1_N : N ;
  ukas_nn_1_N : N ;
  ulan_nn_1_N : N ;
  ultracentrifug_nn_1_N : N ;
  ultramontanism_nn_1_N : N ;
  ultranationalist_nn_1_N : N ;
  umbellat_nn_1_N : N ;
  undergaangsspekulant_nn_1_1_N : N ;
  underhaallskolonn_nn_1_1_N : N ;
  underhaallstjaenst_nn_1_1_N : N ;
  underingenjoer_nn_1_1_N : N ;
  underinstans_nn_1_N : N ;
  underkurs_nn_1_N : N ;
  undermast_nn_1_N : N ;
  undersats_nn_1_N : N ;
  undervattensfarkost_nn_1_N : N ;
  undin_nn_1_N : N ;
  ungdomsbok_nn_1_N : N ;
  ungdomskultur_nn_1_N : N ;
  ungdomspraktik_nn_1_N : N ;
  ungkommunist_nn_1_N : N ;
  ungsocialism_nn_1_N : N ;
  unisexoverall_nn_1_N : N ;
  unitarism_nn_1_N : N ;
  unitarist_nn_1_N : N ;
  universalism_nn_1_N : N ;
  universalist_nn_1_N : N ;
  universalsilikon_nn_1_N : N ;
  universitetslektor_nn_1_N : N ;
  universitetsrektor_nn_1_N : N ;
  uppblaasningsfas_nn_1_1_N : N ;
  uppbrottssignal_nn_1_N : N ;
  uppboerdsbok_nn_1_1_N : N ;
  uppenbarelsebok_nn_1_N : N ;
  upplagringsplats_nn_1_N : N ;
  upplagsplats_nn_1_N : N ;
  uppmaningssats_nn_1_N : N ;
  uppmarsch_nn_1_N : N ;
  uppsats_nn_1_N : N ;
  uppslagsbok_nn_1_N : N ;
  uppstaellningsplats_nn_1_1_N : N ;
  uppstaellningssignal_nn_1_1_N : N ;
  urarvakonkurs_nn_1_N : N ;
  urbanism_nn_1_N : N ;
  urbergsplataa_nn_1_1_N : N ;
  ureas_nn_1_N : N ;
  uretanplast_nn_1_N : N ;
  uridiot_nn_1_N : N ;
  urocean_nn_1_N : N ;
  urolog_nn_1_N : N ;
  urpremiaer_nn_1_1_N : N ;
  ursprungsattest_nn_1_N : N ;
  urtext_nn_1_N : N ;
  urvalsprocess_nn_1_N : N ;
  usans_nn_1_N : N ;
  usurpator_nn_1_N : N ;
  utbildningsnivaa_nn_1_1_N : N ;
  uteplats_nn_1_N : N ;
  utgiftspost_nn_1_N : N ;
  utgiftsskatt_nn_1_N : N ;
  utgraevningsplats_nn_1_1_N : N ;
  utgaangsmarsch_nn_1_1_N : N ;
  utilism_nn_1_N : N ;
  utilist_nn_1_N : N ;
  utilitarism_nn_1_N : N ;
  utilitarist_nn_1_N : N ;
  utkiksplats_nn_1_N : N ;
  utkikspost_nn_1_N : N ;
  utlandslektor_nn_1_N : N ;
  utlandssoldat_nn_1_N : N ;
  utmarsch_nn_1_N : N ;
  utombordsmotor_nn_1_N : N ;
  utopist_nn_1_N : N ;
  utpost_nn_1_N : N ;
  utslagningsmekanism_nn_1_N : N ;
  utslagsroest_nn_1_1_N : N ;
  utslaeppsgraens_nn_1_1_N : N ;
  utvecklingsoptimism_nn_1_N : N ;
  utvecklingspessimism_nn_1_N : N ;
  utvecklingsprocess_nn_1_N : N ;
  utvaext_nn_1_1_N : N ;
  uvular_nn_1_N : N ;
  uzbek_nn_1_N : N ;
  vacuumregulator_nn_1_N : N ;
  vagabondnatur_nn_1_N : N ;
  vagant_nn_1_N : N ;
  vaginism_nn_1_N : N ;
  vagnslast_nn_1_N : N ;
  vagong_nn_1_N : N ;
  vakans_nn_1_N : N ;
  vaktarrest_nn_1_N : N ;
  vaktpost_nn_1_N : N ;
  vakuumregulator_nn_1_N : N ;
  valaffisch_nn_1_N : N ;
  valbyraa_nn_1_1_N : N ;
  valens_nn_1_N : N ;
  valenselektron_nn_1_N : N ;
  valfoerlust_nn_1_1_N : N ;
  valkampanj_nn_1_N : N ;
  vallmovaext_nn_1_1_N : N ;
  vallon_nn_1_N : N ;
  vallvaext_nn_1_1_N : N ;
  valmagnet_nn_1_N : N ;
  valplats_nn_1_N : N ;
  valrossmustasch_nn_1_N : N ;
  vals_nn_2_N : N ;
  valstrateg_nn_1_N : N ;
  valstugeaktivist_nn_1_N : N ;
  valutakurs_nn_1_N : N ;
  valvinst_nn_1_N : N ;
  vampyrroman_nn_1_N : N ;
  van_nn_1_N : N ;
  vandal_nn_1_N : N ;
  vandalism_nn_1_N : N ;
  vapenbok_nn_1_N : N ;
  vapendans_nn_1_N : N ;
  varan_nn_1_N : N ;
  vardagsfest_nn_1_N : N ;
  vardagsfras_nn_1_N : N ;
  vardagsmatin_e_nn_1_1_N : N ;
  varians_nn_1_N : N ;
  variant_nn_1_N : N ;
  variator_nn_1_N : N ;
  variet_e_nn_1_1_N : N ;
  variet_eartist_nn_1_1_N : N ;
  varmluftpistol_nn_1_N : N ;
  varmluftsridaa_nn_1_1_N : N ;
  varningssignal_nn_1_N : N ;
  varseloverall_nn_1_N : N ;
  varuskatt_nn_1_N : N ;
  varutransport_nn_1_N : N ;
  vas_nn_1_N : N ;
  vattenbrist_nn_1_N : N ;
  vattenfas_nn_1_N : N ;
  vattenkonst_nn_1_N : N ;
  vattenkultur_nn_1_N : N ;
  vattenlist_nn_1_N : N ;
  vattenmelon_nn_1_N : N ;
  vattennivaa_nn_1_1_N : N ;
  vattenorganism_nn_1_N : N ;
  vattenpistol_nn_1_N : N ;
  vattenpost_nn_1_N : N ;
  vattentemperatur_nn_1_N : N ;
  vattentortyr_nn_1_N : N ;
  vattentransport_nn_1_N : N ;
  vattenturbin_nn_1_N : N ;
  vattenvaext_nn_1_1_N : N ;
  vaxapplikator_nn_1_N : N ;
  vaxfigur_nn_1_N : N ;
  vedkast_nn_1_N : N ;
  vegan_nn_1_N : N ;
  veganism_nn_1_N : N ;
  vegetarian_nn_1_N : N ;
  vegetarianism_nn_1_N : N ;
  vegetarism_nn_1_N : N ;
  vektor_nn_1_N : N ;
  velar_nn_1_N : N ;
  vend_nn_1_N : N ;
  venereolog_nn_1_N : N ;
  venetian_nn_1_N : N ;
  venezolan_nn_1_N : N ;
  venezuelan_nn_1_N : N ;
  ventil_nn_1_N : N ;
  ventilator_nn_1_N : N ;
  verbalfaktor_nn_1_N : N ;
  verbalism_nn_1_N : N ;
  verifieringsprocess_nn_1_N : N ;
  verism_nn_1_N : N ;
  verktygssats_nn_1_N : N ;
  vernissagefest_nn_1_N : N ;
  vesir_nn_1_N : N ;
  vestibulit_nn_1_N : N ;
  veteran_nn_1_N : N ;
  veterinaerkontroll_nn_1_1_N : N ;
  vevgrammofon_nn_1_N : N ;
  vibrafon_nn_1_N : N ;
  vibrant_nn_1_N : N ;
  vibrator_nn_1_N : N ;
  vibrion_nn_1_N : N ;
  victorianism_nn_1_N : N ;
  videosignal_nn_1_N : N ;
  vietnames_nn_1_N : N ;
  vigselannons_nn_1_N : N ;
  vigvam_nn_1_N : N ;
  vikt_nn_1_N : N ;
  viktfoerlust_nn_1_1_N : N ;
  viktklass_nn_1_N : N ;
  viktorianism_nn_1_N : N ;
  vildkanin_nn_1_N : N ;
  villkorsbisats_nn_1_N : N ;
  vilopaus_nn_1_N : N ;
  viloplats_nn_1_N : N ;
  vindindustrilobby_nn_1_N : N ;
  vinfest_nn_1_N : N ;
  vinkaraff_nn_1_N : N ;
  vinkellinjal_nn_1_N : N ;
  vinkelpredikant_nn_1_N : N ;
  vinproducent_nn_1_N : N ;
  vinst_nn_1_N : N ;
  vinstchans_nn_1_N : N ;
  vinstdelningsskatt_nn_1_N : N ;
  vinstkalkyl_nn_1_N : N ;
  vinstplan_nn_1_N : N ;
  vinterfarkost_nn_1_N : N ;
  vinterkampanj_nn_1_N : N ;
  vinyl_nn_2_N : N ;
  violin_nn_1_N : N ;
  violinist_nn_1_N : N ;
  violoncellist_nn_1_N : N ;
  virolog_nn_1_N : N ;
  virtuos_nn_1_N : N ;
  virusrisk_nn_1_N : N ;
  visbok_nn_1_N : N ;
  visir_nn_2_N : N ;
  visit_nn_1_N : N ;
  visitator_nn_1_N : N ;
  vitalism_nn_1_N : N ;
  vitbok_nn_1_N : N ;
  vitnosdelfin_nn_1_N : N ;
  vitrin_nn_1_N : N ;
  voall_nn_1_N : N ;
  vokalis_nn_1_N : N ;
  vokalism_nn_1_N : N ;
  vokalist_nn_1_N : N ;
  vokativ_nn_1_N : N ;
  volang_nn_1_N : N ;
  volt_nn_2_N : N ;
  voltan_nn_1_N : N ;
  voluntarism_nn_1_N : N ;
  vombat_nn_1_N : N ;
  vrakrest_nn_1_N : N ;
  vrist_nn_1_N : N ;
  vulkan_nn_1_N : N ;
  vulkanisator_nn_1_N : N ;
  vulkanism_nn_1_N : N ;
  vulkanit_nn_1_N : N ;
  vulst_nn_1_N : N ;
  vurm_nn_1_N : N ;
  vuxendos_nn_1_N : N ;
  vy_nn_1_N : N ;
  vykortstext_nn_1_N : N ;
  vykortsvy_nn_1_N : N ;
  vaeckelsepredikant_nn_1_1_N : N ;
  vaederleksrapport_nn_1_1_N : N ;
  vaederprognos_nn_1_1_N : N ;
  vaederrapport_nn_1_1_N : N ;
  vaedersatellit_nn_1_1_N : N ;
  vaeggtelefon_nn_1_1_N : N ;
  vaelfaerdskris_nn_1_1_N : N ;
  vaelkomstfest_nn_1_1_N : N ;
  vaendplats_nn_1_1_N : N ;
  vaenskapsmatch_nn_1_1_N : N ;
  vaensterkroenikoer_nn_1_1_N : N ;
  vaensterprofessor_nn_1_1_N : N ;
  vaensterrebell_nn_1_1_N : N ;
  vaenstersocialism_nn_1_1_N : N ;
  vaenstersocialist_nn_1_1_N : N ;
  vaentjaenst_nn_1_1_N : N ;
  vaerdeanalys_nn_1_1_N : N ;
  vaerdefoerlust_nn_1_1_N : N ;
  vaerdenihilism_nn_1_1_N : N ;
  vaerdestruktur_nn_1_1_N : N ;
  vaerdetransport_nn_1_1_N : N ;
  vaerdmolekyl_nn_1_1_N : N ;
  vaerdvaext_nn_1_1_N : N ;
  vaerldsartist_nn_1_1_N : N ;
  vaerldsatlas_nn_1_1_N : N ;
  vaerldsfederalism_nn_1_1_N : N ;
  vaerldskapitalism_nn_1_1_N : N ;
  vaerldspremiaer_nn_1_1_N : N ;
  vaerldssucc_e_nn_1_1_N : N ;
  vaermefoerlust_nn_1_1_N : N ;
  vaermeisolator_nn_1_1_N : N ;
  vaermemotor_nn_1_1_N : N ;
  vaermeradiator_nn_1_1_N : N ;
  vaernpliktsarm_e_nn_1_1_N : N ;
  vaervningskampanj_nn_1_1_N : N ;
  vaestkust_nn_1_1_N : N ;
  vaestkustaccent_nn_1_1_N : N ;
  vaestsamoan_nn_1_1_N : N ;
  vaetegenerator_nn_1_1_N : N ;
  vaetejon_nn_1_1_N : N ;
  vaetekarbonatjon_nn_1_1_N : N ;
  vaetgashybrid_nn_1_1_N : N ;
  vaetgasmolekyl_nn_1_1_N : N ;
  vaetskefoerlust_nn_1_1_N : N ;
  vaetskekontroll_nn_1_1_N : N ;
  vaetskenivaa_nn_1_1_N : N ;
  vaevplast_nn_1_1_N : N ;
  vaexelaccept_nn_1_1_N : N ;
  vaexelkredit_nn_1_1_N : N ;
  vaexelkurs_nn_1_1_N : N ;
  vaext_nn_1_1_N : N ;
  vaextbas_nn_1_1_N : N ;
  vaextgraens_nn_1_1_N : N ;
  vaexthusgas_nn_1_1_N : N ;
  vaextplats_nn_1_1_N : N ;
  vaextsaesong_nn_1_1_N : N ;
  vaad_nn_1_1_N : N ;
  vaadevill_nn_1_1_N : N ;
  vaagbalans_nn_1_1_N : N ;
  vaagnatur_nn_1_1_N : N ;
  vaaldstendens_nn_1_1_N : N ;
  vaard_nn_2_1_N : N ;
  vaardpersonal_nn_1_1_N : N ;
  vaardplats_nn_1_1_N : N ;
  vaarvaext_nn_1_1_N : N ;
  wagon_nn_1_N : N ;
  wankelmotor_nn_1_N : N ;
  webbdomaen_nn_1_1_N : N ;
  webbplats_nn_1_N : N ;
  webbtjaenst_nn_1_1_N : N ;
  whiskybutelj_nn_1_N : N ;
  wienervals_nn_1_N : N ;
  wienklassicism_nn_1_N : N ;
  wigwam_nn_1_N : N ;
  worcestersaas_nn_1_1_N : N ;
  x_koordinat_nn_1_N : N ;
  x_kromosom_nn_1_N : N ;
  xylofon_nn_1_N : N ;
  y_koordinat_nn_1_N : N ;
  y_kromosom_nn_1_N : N ;
  yawl_nn_1_N : N ;
  yrkesarm_e_nn_1_1_N : N ;
  yrkespraktik_nn_1_N : N ;
  ytstruktur_nn_1_N : N ;
  yttriumoxid_nn_1_N : N ;
  zelot_nn_1_N : N ;
  zenitdistans_nn_1_N : N ;
  zigenarkaravan_nn_1_N : N ;
  zirkon_nn_1_N : N ;
  zirkoniumoxid_nn_1_N : N ;
  zon_nn_1_N : N ;
  zoolog_nn_1_N : N ;
  aedelfasan_nn_1_1_N : N ;
  aedelgas_nn_1_1_N : N ;
  aektenskapsallians_nn_1_1_N : N ;
  aektenskapsannons_nn_1_1_N : N ;
  aektenskapsbyraa_nn_1_1_N : N ;
  aelgfigur_nn_1_1_N : N ;
  aemneskonferens_nn_1_1_N : N ;
  aenglafigur_nn_1_1_N : N ;
  aerkekretin_nn_1_1_N : N ;
  aerkereaktionaer_nn_1_1_N : N ;
  aertpur_e_nn_1_1_N : N ;
  aertvaext_nn_1_1_N : N ;
  aett_nn_1_1_N : N ;
  aeventyrsbok_nn_1_1_N : N ;
  aeventyrsroman_nn_1_1_N : N ;
  aahoerarplats_nn_1_1_N : N ;
  aakervaext_nn_1_1_N : N ;
  aaldersgraens_nn_1_1_N : N ;
  aaldersklass_nn_1_1_N : N ;
  aaldersstruktur_nn_1_1_N : N ;
  aangackumulator_nn_1_1_N : N ;
  aangestneuros_nn_1_1_N : N ;
  aanggenerator_nn_1_1_N : N ;
  aangturbin_nn_1_1_N : N ;
  aarmiljon_nn_1_1_N : N ;
  aarsbok_nn_1_1_N : N ;
  aarsdos_nn_1_1_N : N ;
  aarsinkomst_nn_1_1_N : N ;
  aarsklass_nn_1_1_N : N ;
  aarskurs_nn_1_1_N : N ;
  aarsmedeltemperatur_nn_1_1_N : N ;
  aartalsexercis_nn_1_1_N : N ;
  aasiktsdiktatur_nn_1_1_N : N ;
  aasiktspluralism_nn_1_1_N : N ;
  aaterfoereningsprocess_nn_1_1_N : N ;
  aaterhaemtningsfas_nn_1_1_N : N ;
  aaterremiss_nn_1_1_N : N ;
  aatertjaenst_nn_1_1_N : N ;
  aattiotalism_nn_1_1_N : N ;
  aattiotalist_nn_1_1_N : N ;
  aattitalism_nn_1_1_N : N ;
  aattitalist_nn_1_1_N : N ;
  aattondelsfinal_nn_1_1_N : N ;
  oegonprotes_nn_1_1_N : N ;
  oekenvaext_nn_1_1_N : N ;
  oeljett_nn_1_1_N : N ;
  oenskesats_nn_1_1_N : N ;
  oerlogsbas_nn_1_1_N : N ;
  oerlogsmatros_nn_1_1_N : N ;
  oert_nn_1_1_N : N ;
  oestkust_nn_1_1_N : N ;
  oeverdirektoer_nn_1_1_N : N ;
  oeverdos_nn_1_1_N : N ;
  oeverfoeringskarakteristik_nn_1_1_N : N ;
  oeverfoeringskaraktaeristik_nn_1_1_N : N ;
  oevergaangsmetall_nn_1_1_N : N ;
  oeverhetsperson_nn_1_1_N : N ;
  oeveringenjoer_nn_1_1_N : N ;
  oeverklass_nn_1_1_N : N ;
  oeverklassaccent_nn_1_1_N : N ;
  oeverkurs_nn_1_1_N : N ;
  oeverlast_nn_1_1_N : N ;
  oeverlevnadschans_nn_1_1_N : N ;
  oeverlevnadskurs_nn_1_1_N : N ;
  oeversiktsplan_nn_1_1_N : N ;
  oeverstepraest_nn_1_1_N : N ;
  oeversitteri_nn_1_1_N : N ;
  oevergaangsstadium_nn_1_1_N : N ;
  oeverdel_nn_1_1_N : N ;
  oestrogen_nn_1_1_N : N ;
  oenskedroem_nn_1_1_N : N ;
  oelkaf_e_nn_1_1_N : N ;
  oelbryggeri_nn_1_1_N : N ;
  oegonsten_nn_1_1_N : N ;
  aattondel_nn_1_1_N : N ;
  aattondedel_nn_1_1_N : N ;
  aattiondel_nn_1_1_N : N ;
  aarlom_nn_1_1_N : N ;
  aargaangsvin_nn_1_1_N : N ;
  aangbageri_nn_1_1_N : N ;
  aaldersstadium_nn_1_1_N : N ;
  aakerren_nn_1_1_N : N ;
  aakeri_nn_1_1_N : N ;
  aakerfraeken_nn_1_1_N : N ;
  aegodel_nn_1_1_N : N ;
  aeggtoddy_nn_1_1_N : N ;
  aegarandel_nn_1_1_N : N ;
  aedelsten_nn_1_1_N : N ;
  ytterlighetsparti_nn_1_N : N ;
  yngelstadium_nn_1_N : N ;
  ympstam_nn_1_N : N ;
  yankeejib_nn_1_N : N ;
  vaam_nn_1_1_N : N ;
  vaagkam_nn_1_1_N : N ;
  vaextstam_nn_1_1_N : N ;
  vaextgift_nn_1_1_N : N ;
  vaextfett_nn_1_1_N : N ;
  vaexelstroem_nn_1_1_N : N ;
  vaevkam_nn_1_1_N : N ;
  vaeveri_nn_1_1_N : N ;
  vaensterparti_nn_1_1_N : N ;
  vaegren_nn_1_1_N : N ;
  vaegbom_nn_1_1_N : N ;
  vom_nn_1_N : N ;
  vitvin_nn_1_N : N ;
  vittvin_nn_1_N : N ;
  vitbroderi_nn_1_N : N ;
  virvelstroem_nn_1_1_N : N ;
  vintagevin_nn_1_N : N ;
  vinland_nn_1_N : N ;
  vineri_nn_1_N : N ;
  vin_nn_1_N : N ;
  vilostadium_nn_1_N : N ;
  vildstam_nn_1_N : N ;
  vildren_nn_1_N : N ;
  vertikalstroem_nn_1_1_N : N ;
  verbstam_nn_1_N : N ;
  verbalstam_nn_1_N : N ;
  vedstam_nn_1_N : N ;
  vax_nn_1_N : N ;
  vattenstroem_nn_1_1_N : N ;
  vattengel_nn_1_N : N ;
  vaterbom_nn_1_N : N ;
  varuparti_nn_1_N : N ;
  varumaerkeshaveri_nn_1_1_N : N ;
  varpbom_nn_1_N : N ;
  vapengren_nn_1_N : N ;
  valmaskineri_nn_1_N : N ;
  valkokeri_nn_1_N : N ;
  valkeri_nn_1_N : N ;
  vaktmaesteri_nn_1_1_N : N ;
  utvecklingsstadium_nn_1_N : N ;
  utvecklingsland_nn_1_N : N ;
  utslaeppsland_nn_1_1_N : N ;
  utdragssoem_nn_1_1_N : N ;
  ursprungsland_nn_1_N : N ;
  urmakeri_nn_1_N : N ;
  uppstroem_nn_1_1_N : N ;
  universalgeni_nn_1_N : N ;
  ungstadium_nn_1_N : N ;
  ungmor_nn_1_N : N ;
  ungdomssvaermeri_nn_1_1_N : N ;
  ungdomsfylleri_nn_1_N : N ;
  understroem_nn_1_1_N : N ;
  underdel_nn_1_N : N ;
  u_land_nn_1_N : N ;
  toem_nn_1_1_N : N ;
  tygbom_nn_1_N : N ;
  tvaaondel_nn_1_1_N : N ;
  tvaaendel_nn_1_1_N : N ;
  tvaetteri_nn_1_1_N : N ;
  tvistsoem_nn_1_1_N : N ;
  tusendel_nn_1_N : N ;
  tusendedel_nn_1_N : N ;
  turiststroem_nn_1_1_N : N ;
  turistland_nn_1_N : N ;
  tuppkam_nn_1_N : N ;
  tunnbinderi_nn_1_N : N ;
  traesnideri_nn_1_1_N : N ;
  traedstam_nn_1_1_N : N ;
  trae_nn_1_1_N : N ;
  tryckeri_nn_1_N : N ;
  trolleri_nn_1_N : N ;
  triljondel_nn_1_N : N ;
  trettondel_nn_1_N : N ;
  trettiondel_nn_1_N : N ;
  trefasstroem_nn_1_1_N : N ;
  tredjedel_nn_1_N : N ;
  transfett_nn_1_N : N ;
  trakasseri_nn_1_N : N ;
  trafikstroem_nn_1_1_N : N ;
  toxafen_nn_1_N : N ;
  totalhaveri_nn_1_N : N ;
  torsdagsmorgon_nn_1_N : N ;
  torsdagmorgon_nn_1_N : N ;
  torrbatteri_nn_1_N : N ;
  torkeri_nn_1_N : N ;
  tolvvoltsbatteri_nn_1_N : N ;
  tolftedel_nn_1_N : N ;
  tokeri_nn_1_N : N ;
  toddy_nn_1_N : N ;
  tjyveri_nn_1_N : N ;
  tjuveri_nn_1_N : N ;
  tjugondel_nn_1_N : N ;
  tjugondedel_nn_1_N : N ;
  tisdagsmorgon_nn_1_N : N ;
  tisdagmorgon_nn_1_N : N ;
  tiondel_nn_1_N : N ;
  tiondedel_nn_1_N : N ;
  tiggeri_nn_1_N : N ;
  tidvattenstroem_nn_1_1_N : N ;
  the_nn_1_N : N ;
  textparti_nn_1_N : N ;
  testimonium_nn_1_N : N ;
  testbatteri_nn_1_N : N ;
  teslastroem_nn_1_1_N : N ;
  territorium_nn_1_N : N ;
  terrarium_nn_1_N : N ;
  ten_nn_1_N : N ;
  tellurium_nn_1_N : N ;
  teatermaskineri_nn_1_N : N ;
  te_nn_1_N : N ;
  tavelgalleri_nn_1_N : N ;
  taskspeleri_nn_1_N : N ;
  tapisseri_nn_1_N : N ;
  tamren_nn_1_N : N ;
  tambursoem_nn_1_1_N : N ;
  tallstam_nn_1_N : N ;
  taktdel_nn_1_N : N ;
  takkam_nn_1_N : N ;
  soendagsmorgon_nn_1_1_N : N ;
  soendagmorgon_nn_1_1_N : N ;
  soem_nn_1_1_N : N ;
  saetteri_nn_1_1_N : N ;
  saeteri_nn_1_1_N : N ;
  saekerhetsrelae_nn_1_1_N : N ;
  symposium_nn_1_N : N ;
  svaangrem_nn_1_1_N : N ;
  svaermorsdroem_nn_1_1_N : N ;
  svaermor_nn_1_1_N : N ;
  svaermeri_nn_1_1_N : N ;
  svinfett_nn_1_N : N ;
  svineri_nn_1_N : N ;
  svindleri_nn_1_N : N ;
  svettrem_nn_1_N : N ;
  svagstroem_nn_1_1_N : N ;
  suppositorium_nn_1_N : N ;
  supinum_nn_1_N : N ;
  summer_nn_1_N : N ;
  styvmor_nn_1_N : N ;
  stygger_nn_1_N : N ;
  stuveri_nn_1_N : N ;
  stuteri_nn_1_N : N ;
  studium_nn_1_N : N ;
  stroem_nn_1_1_N : N ;
  strike_nn_1_N : N ;
  storslam_nn_1_N : N ;
  storsegelbom_nn_1_N : N ;
  stolleri_nn_1_N : N ;
  stipendium_nn_1_N : N ;
  stenoeken_nn_1_1_N : N ;
  stenparti_nn_1_N : N ;
  stenhuggeri_nn_1_N : N ;
  sten_nn_1_N : N ;
  startbatteri_nn_1_N : N ;
  starkvin_nn_1_N : N ;
  starkstroem_nn_1_1_N : N ;
  standardinventarium_nn_1_N : N ;
  standardhyckleri_nn_1_N : N ;
  stam_nn_1_N : N ;
  stadium_nn_1_N : N ;
  stadion_nn_2_N : N ;
  stabskompani_nn_1_N : N ;
  spoekeri_nn_1_1_N : N ;
  spaerrbom_nn_1_1_N : N ;
  spaennrem_nn_1_1_N : N ;
  spraakstam_nn_1_1_N : N ;
  spraaklaboratorium_nn_1_1_N : N ;
  sportgren_nn_1_N : N ;
  sporangium_nn_1_N : N ;
  spioneri_nn_1_N : N ;
  spinneri_nn_1_N : N ;
  spinnakerbom_nn_1_N : N ;
  spegelfaekteri_nn_1_1_N : N ;
  specialstudium_nn_1_N : N ;
  spatium_nn_1_N : N ;
  sovmorgon_nn_1_N : N ;
  solbatteri_nn_1_N : N ;
  solarium_nn_1_N : N ;
  sofisteri_nn_1_N : N ;
  sockerraffinaderi_nn_1_N : N ;
  sockerbageri_nn_1_N : N ;
  snoermakeri_nn_1_1_N : N ;
  snuskhummer_nn_1_N : N ;
  snus_nn_1_N : N ;
  snobberi_nn_1_N : N ;
  snideri_nn_1_N : N ;
  snickeri_nn_1_N : N ;
  snatteri_nn_1_N : N ;
  snaskeri_nn_1_N : N ;
  smoer_nn_1_1_N : N ;
  smaatteri_nn_1_1_N : N ;
  smaasven_nn_1_1_N : N ;
  smaelteri_nn_1_1_N : N ;
  smygsoem_nn_1_1_N : N ;
  smuggleri_nn_1_N : N ;
  smink_nn_1_N : N ;
  smideri_nn_1_N : N ;
  slaedparti_nn_1_1_N : N ;
  slutklaem_nn_1_1_N : N ;
  slottsvin_nn_1_N : N ;
  slom_nn_1_N : N ;
  sliperi_nn_1_N : N ;
  slarverland_nn_1_N : N ;
  slam_nn_2_N : N ;
  slakteri_nn_1_N : N ;
  slagbom_nn_1_N : N ;
  skaadespelardroem_nn_1_1_N : N ;
  skaeggtoem_nn_1_1_N : N ;
  skymmel_nn_2_N : N ;
  skraedderi_nn_1_1_N : N ;
  skrymteri_nn_1_N : N ;
  skriveri_nn_1_N : N ;
  skriftstaelleri_nn_1_1_N : N ;
  skomakeri_nn_1_N : N ;
  skojeri_nn_1_N : N ;
  skogsparti_nn_1_N : N ;
  skimmel_nn_1_N : N ;
  skidgymnasium_nn_1_N : N ;
  skeppsbyggeri_nn_1_N : N ;
  skandalskriveri_nn_1_N : N ;
  skafferi_nn_1_N : N ;
  sjoeroeveri_nn_1_1_N : N ;
  sjoefartsmuseum_nn_1_1_N : N ;
  sjaaperi_nn_1_1_N : N ;
  sjaettedel_nn_1_1_N : N ;
  sjaelvstudium_nn_1_1_N : N ;
  sjaelvplaageri_nn_1_1_N : N ;
  sjaelvbedraegeri_nn_1_1_N : N ;
  sjundedel_nn_1_N : N ;
  silversalt_nn_1_N : N ;
  signeri_nn_1_N : N ;
  sidendraperi_nn_1_N : N ;
  shoppingcenter_nn_1_N : N ;
  sextrakasseri_nn_1_N : N ;
  sextiaarsjubileum_nn_1_1_N : N ;
  sextioaarsjubileum_nn_1_1_N : N ;
  septennium_nn_1_N : N ;
  seminarium_nn_1_N : N ;
  sekundaerstroem_nn_1_1_N : N ;
  sekundaerstadium_nn_1_1_N : N ;
  segelmakeri_nn_1_N : N ;
  schaeferi_nn_1_1_N : N ;
  schweizeri_nn_1_N : N ;
  schattersoem_nn_1_1_N : N ;
  schackparti_nn_1_N : N ;
  sceneri_nn_1_N : N ;
  satsdel_nn_1_N : N ;
  saponin_nn_1_N : N ;
  sanndroem_nn_1_1_N : N ;
  sanktuarium_nn_1_N : N ;
  sanitetskompani_nn_1_N : N ;
  sandoeken_nn_1_1_N : N ;
  sanatorium_nn_1_N : N ;
  sammelsurium_nn_1_N : N ;
  samlingsparti_nn_1_N : N ;
  sameland_nn_1_N : N ;
  saltoeken_nn_1_1_N : N ;
  salteri_nn_1_N : N ;
  salt_nn_2_N : N ;
  salpetersjuderi_nn_1_N : N ;
  sakrilegium_nn_1_N : N ;
  sagoland_nn_1_N : N ;
  sadelmakeri_nn_1_N : N ;
  sadelbom_nn_1_N : N ;
  roeveri_nn_1_1_N : N ;
  roerdrom_nn_1_1_N : N ;
  roekeri_nn_1_1_N : N ;
  roedvin_nn_1_1_N : N ;
  raenksmideri_nn_1_1_N : N ;
  ryggparti_nn_1_N : N ;
  rundmun_nn_1_N : N ;
  rovdjursstam_nn_1_N : N ;
  rotisseri_nn_1_N : N ;
  ros_evin_nn_1_1_N : N ;
  rosteri_nn_1_N : N ;
  rosenmun_nn_1_N : N ;
  rofferi_nn_1_N : N ;
  roderhaveri_nn_1_N : N ;
  riksmuseum_nn_1_N : N ;
  riksdagsparti_nn_1_N : N ;
  rhenvin_nn_1_N : N ;
  resonemangsparti_nn_1_N : N ;
  resestipendium_nn_1_N : N ;
  repetitorium_nn_1_N : N ;
  renseri_nn_1_N : N ;
  renhetsdroem_nn_1_1_N : N ;
  rendezvous_nn_1_N : N ;
  ren_nn_1_N : N ;
  rem_nn_1_N : N ;
  relae_nn_1_1_N : N ;
  rekryteringsland_nn_1_N : N ;
  regeringsparti_nn_1_N : N ;
  regeringsmedlem_nn_1_N : N ;
  regeringskansli_nn_1_N : N ;
  refektorium_nn_1_N : N ;
  rederi_nn_1_N : N ;
  raljeri_nn_1_N : N ;
  raffinaderi_nn_1_N : N ;
  paerldraperi_nn_1_1_N : N ;
  paerlbroderi_nn_1_1_N : N ;
  praangleri_nn_1_1_N : N ;
  praestseminarium_nn_1_1_N : N ;
  prydnadssoem_nn_1_1_N : N ;
  prydnadskam_nn_1_N : N ;
  provisorium_nn_1_N : N ;
  protein_nn_1_N : N ;
  prosteri_nn_1_N : N ;
  proseminarium_nn_1_N : N ;
  proscenium_nn_1_N : N ;
  programland_nn_1_N : N ;
  problemformuleringsprivilegium_nn_1_N : N ;
  privilegium_nn_1_N : N ;
  preteritum_nn_1_N : N ;
  presseri_nn_1_N : N ;
  presidium_nn_1_N : N ;
  premium_nn_1_N : N ;
  preludium_nn_1_N : N ;
  potpurri_nn_1_N : N ;
  postseminarium_nn_1_N : N ;
  postludium_nn_1_N : N ;
  portvin_nn_1_N : N ;
  portionssnus_nn_1_N : N ;
  porslin_nn_1_N : N ;
  pokerparti_nn_1_N : N ;
  podium_nn_1_N : N ;
  plaatslageri_nn_1_1_N : N ;
  plattsoem_nn_1_1_N : N ;
  planetarium_nn_1_N : N ;
  pikanteri_nn_1_N : N ;
  persongalleri_nn_1_N : N ;
  perborat_nn_1_N : N ;
  penninghaeleri_nn_1_1_N : N ;
  pen_nn_1_N : N ;
  pedofilhysteri_nn_1_N : N ;
  pedanteri_nn_1_N : N ;
  partnerskapsland_nn_1_N : N ;
  partimedlem_nn_1_N : N ;
  partikelstroem_nn_1_1_N : N ;
  partikellaboratorium_nn_1_N : N ;
  parti_nn_1_N : N ;
  parfymeri_nn_1_N : N ;
  parallelltrapets_nn_1_N : N ;
  papeteri_nn_1_N : N ;
  palae_nn_1_1_N : N ;
  palmvin_nn_1_N : N ;
  palliativ_nn_1_N : N ;
  ovarium_nn_1_N : N ;
  ovandel_nn_1_N : N ;
  ossuarium_nn_1_N : N ;
  ormgift_nn_1_N : N ;
  orkestermedlem_nn_1_N : N ;
  orgelpreludium_nn_1_N : N ;
  orgelharmonium_nn_1_N : N ;
  ordstam_nn_1_N : N ;
  ordrytteri_nn_1_N : N ;
  ordklyveri_nn_1_N : N ;
  ordfoerandeland_nn_1_1_N : N ;
  ordensmedlem_nn_1_N : N ;
  oratorium_nn_1_N : N ;
  orangeri_nn_1_N : N ;
  oppstroem_nn_1_1_N : N ;
  oppositionsparti_nn_1_N : N ;
  operettland_nn_1_N : N ;
  onsdagsmorgon_nn_1_N : N ;
  onsdagmorgon_nn_1_N : N ;
  oljeslageri_nn_1_N : N ;
  oljeraffinaderi_nn_1_N : N ;
  oljeland_nn_1_N : N ;
  offertorium_nn_1_N : N ;
  observatorium_nn_1_N : N ;
  obligatorium_nn_1_N : N ;
  noerderi_nn_1_1_N : N ;
  naeversoem_nn_1_1_N : N ;
  naetbedraegeri_nn_1_1_N : N ;
  naerstudium_nn_1_1_N : N ;
  naersalt_nn_1_1_N : N ;
  naeringssalt_nn_1_1_N : N ;
  naeringsgren_nn_1_1_N : N ;
  niondel_nn_1_N : N ;
  niondedel_nn_1_N : N ;
  nervgift_nn_1_N : N ;
  nektarium_nn_1_N : N ;
  natursceneri_nn_1_N : N ;
  nattvardsvin_nn_1_N : N ;
  nattfrieri_nn_1_N : N ;
  nationalmuseum_nn_1_N : N ;
  nationalgalleri_nn_1_N : N ;
  nagelsoem_nn_1_1_N : N ;
  nackdel_nn_1_N : N ;
  moessrem_nn_1_1_N : N ;
  moebelsnickeri_nn_1_1_N : N ;
  maandagsmorgon_nn_1_1_N : N ;
  maandagmorgon_nn_1_1_N : N ;
  maaleri_nn_1_1_N : N ;
  maelteri_nn_1_1_N : N ;
  myteri_nn_1_N : N ;
  mysterium_nn_1_N : N ;
  myrten_nn_1_N : N ;
  mycelium_nn_1_N : N ;
  musteri_nn_1_N : N ;
  musikkonservatorium_nn_1_N : N ;
  musikkaf_e_nn_1_1_N : N ;
  musikgymnasium_nn_1_N : N ;
  museum_nn_1_N : N ;
  municipium_nn_1_N : N ;
  mun_nn_1_N : N ;
  motstroem_nn_1_1_N : N ;
  motgift_nn_1_N : N ;
  moselvin_nn_1_N : N ;
  mosaiksoem_nn_1_1_N : N ;
  mormorsmor_nn_1_N : N ;
  mormor_nn_1_N : N ;
  morgon_nn_1_N : N ;
  moratorium_nn_1_N : N ;
  mor_nn_1_N : N ;
  modermun_nn_1_N : N ;
  moderland_nn_1_N : N ;
  mjoel_nn_1_1_N : N ;
  mjukdel_nn_1_N : N ;
  mittparti_nn_1_N : N ;
  mittenparti_nn_1_N : N ;
  missnoejesparti_nn_1_1_N : N ;
  ministerium_nn_1_N : N ;
  mineralsalt_nn_1_N : N ;
  mineralmuseum_nn_1_N : N ;
  millennium_nn_1_N : N ;
  miljoeministerium_nn_1_1_N : N ;
  miljoegift_nn_1_1_N : N ;
  miljondel_nn_1_N : N ;
  miljonbedraegeri_nn_1_1_N : N ;
  miljarddel_nn_1_N : N ;
  milennium_nn_1_N : N ;
  mikrofonbom_nn_1_N : N ;
  mikrobryggeri_nn_1_N : N ;
  menageri_nn_1_N : N ;
  mellanstadium_nn_1_N : N ;
  mellanparti_nn_1_N : N ;
  mejeri_nn_1_N : N ;
  medstroem_nn_1_1_N : N ;
  medlemsland_nn_1_N : N ;
  medlem_nn_1_N : N ;
  mausoleum_nn_1_N : N ;
  matland_nn_1_N : N ;
  matfett_nn_1_N : N ;
  materiestroem_nn_1_1_N : N ;
  maskinhaveri_nn_1_N : N ;
  maskineri_nn_1_N : N ;
  martyrium_nn_1_N : N ;
  marketeri_nn_1_N : N ;
  marketenteri_nn_1_N : N ;
  mardroem_nn_1_1_N : N ;
  manslem_nn_1_N : N ;
  mammutstam_nn_1_N : N ;
  malstroem_nn_1_1_N : N ;
  majmorgon_nn_1_N : N ;
  magmun_nn_1_N : N ;
  loesgom_nn_1_1_N : N ;
  loerdagsmorgon_nn_1_1_N : N ;
  loerdagmorgon_nn_1_1_N : N ;
  loekstam_nn_1_1_N : N ;
  laatsasland_nn_1_1_N : N ;
  laagstadium_nn_1_1_N : N ;
  laadvin_nn_1_1_N : N ;
  laettvin_nn_1_1_N : N ;
  laettmargarin_nn_1_1_N : N ;
  laerarkollegium_nn_1_1_N : N ;
  laeppsnus_nn_1_1_N : N ;
  laeppsmink_nn_1_1_N : N ;
  laemmel_nn_1_1_N : N ;
  laem_nn_1_1_N : N ;
  laeckergom_nn_1_1_N : N ;
  lysin_nn_1_N : N ;
  lymmel_nn_1_N : N ;
  lyceum_nn_1_N : N ;
  lurendrejeri_nn_1_N : N ;
  luftstroem_nn_1_1_N : N ;
  luciamorgon_nn_1_N : N ;
  lotteri_nn_1_N : N ;
  lom_nn_1_N : N ;
  livstidsmedlem_nn_1_N : N ;
  livr_e_nn_1_1_N : N ;
  livrem_nn_1_N : N ;
  livmodermun_nn_1_N : N ;
  litiumbatteri_nn_1_N : N ;
  linspinneri_nn_1_N : N ;
  lingeri_nn_1_N : N ;
  limkokeri_nn_1_N : N ;
  lillslam_nn_1_N : N ;
  likstroem_nn_1_1_N : N ;
  likgift_nn_1_N : N ;
  lem_nn_1_N : N ;
  legendarium_nn_1_N : N ;
  lantvin_nn_1_N : N ;
  lantmaeteri_nn_1_1_N : N ;
  langarn_nn_1_N : N ;
  landskansli_nn_1_N : N ;
  landsfoerraederi_nn_1_1_N : N ;
  land_nn_1_N : N ;
  laddstroem_nn_1_1_N : N ;
  laddningsstroem_nn_1_1_N : N ;
  laboratorium_nn_1_N : N ;
  koettvin_nn_1_1_N : N ;
  kaaseri_nn_1_1_N : N ;
  kaarobligatorium_nn_1_1_N : N ;
  kaetteri_nn_1_1_N : N ;
  kaernkraftshaveri_nn_1_1_N : N ;
  kaendiseri_nn_1_1_N : N ;
  kaekrem_nn_1_1_N : N ;
  kaekparti_nn_1_1_N : N ;
  kyrksocken_nn_1_N : N ;
  kymation_nn_1_N : N ;
  kvacksalveri_nn_1_N : N ;
  kummel_nn_2_N : N ;
  kulturland_nn_1_N : N ;
  kryperi_nn_1_N : N ;
  krukmakeri_nn_1_N : N ;
  kroppsfett_nn_1_N : N ;
  kroppsdel_nn_1_N : N ;
  kriterium_nn_1_N : N ;
  krematorium_nn_1_N : N ;
  kranium_nn_1_N : N ;
  kotteri_nn_1_N : N ;
  kortbedraegeri_nn_1_1_N : N ;
  korollarium_nn_1_N : N ;
  koppleri_nn_1_N : N ;
  konviktorium_nn_1_N : N ;
  konvenansparti_nn_1_N : N ;
  konstmuseum_nn_1_N : N ;
  konstharts_nn_1_N : N ;
  konstgalleri_nn_1_N : N ;
  konsortium_nn_1_N : N ;
  konsonantstam_nn_1_N : N ;
  konsistorium_nn_1_N : N ;
  konsilium_nn_1_N : N ;
  konservatorium_nn_1_N : N ;
  konditori_nn_1_N : N ;
  kompendium_nn_1_N : N ;
  kompani_nn_1_N : N ;
  kommunistparti_nn_1_N : N ;
  kommunistland_nn_1_N : N ;
  kommerskollegium_nn_1_N : N ;
  kolumbarium_nn_1_N : N ;
  kollokvium_nn_1_N : N ;
  kollegium_nn_1_N : N ;
  kol_14_laboratorium_nn_1_N : N ;
  koketteri_nn_1_N : N ;
  kokeri_nn_1_N : N ;
  knoelstam_nn_1_1_N : N ;
  knutbroderi_nn_1_N : N ;
  kloevjeren_nn_1_1_N : N ;
  klaem_nn_1_1_N : N ;
  klyvarbom_nn_1_N : N ;
  klumpsoem_nn_1_1_N : N ;
  klubbmedlem_nn_1_N : N ;
  klassresedroem_nn_1_1_N : N ;
  klarlack_nn_1_N : N ;
  klanteri_nn_1_N : N ;
  klammeri_nn_1_N : N ;
  klam_nn_1_N : N ;
  kineseri_nn_1_N : N ;
  kilrem_nn_1_N : N ;
  kedjesoem_nn_1_1_N : N ;
  kavalleri_nn_1_N : N ;
  katastrofsceneri_nn_1_N : N ;
  kastsoem_nn_1_1_N : N ;
  karotin_nn_1_N : N ;
  karosseri_nn_1_N : N ;
  kaperi_nn_1_N : N ;
  kantsoem_nn_1_1_N : N ;
  kansli_nn_1_N : N ;
  kanongjuteri_nn_1_N : N ;
  kannstoeperi_nn_1_1_N : N ;
  kam_nn_1_N : N ;
  kalkbraenneri_nn_1_1_N : N ;
  kalisalt_nn_1_N : N ;
  kalenderbiteri_nn_1_N : N ;
  kalendarium_nn_1_N : N ;
  kaf_e_nn_1_1_N : N ;
  kafferosteri_nn_1_N : N ;
  kafe_nn_1_N : N ;
  jaernsalt_nn_1_1_N : N ;
  jaegarkompani_nn_1_1_N : N ;
  julhysteri_nn_1_N : N ;
  julevangelium_nn_1_N : N ;
  juldagsmorgon_nn_1_N : N ;
  jubileum_nn_1_N : N ;
  jordstroem_nn_1_1_N : N ;
  jordstam_nn_1_N : N ;
  jobberi_nn_1_N : N ;
  jetstroem_nn_1_1_N : N ;
  inventarium_nn_1_N : N ;
  interludium_nn_1_N : N ;
  instroem_nn_1_1_N : N ;
  instrumentarium_nn_1_N : N ;
  insomningsdroem_nn_1_1_N : N ;
  insektsgift_nn_1_N : N ;
  ingenium_nn_1_N : N ;
  infanterikompani_nn_1_N : N ;
  industriland_nn_1_N : N ;
  indicium_nn_1_N : N ;
  indianstam_nn_1_N : N ;
  imperium_nn_1_N : N ;
  idrottskompani_nn_1_N : N ;
  idrottsgymnasium_nn_1_N : N ;
  idrottsgren_nn_1_N : N ;
  i_land_nn_1_N : N ;
  hoenseri_nn_1_1_N : N ;
  hoekeri_nn_1_1_N : N ;
  hoegstadium_nn_1_1_N : N ;
  hoegland_nn_1_1_N : N ;
  hoegglansvax_nn_1_1_N : N ;
  hoegfoerraederi_nn_1_1_N : N ;
  hoegerparti_nn_1_1_N : N ;
  hoeftparti_nn_1_1_N : N ;
  haarrem_nn_1_1_N : N ;
  haarklyveri_nn_1_1_N : N ;
  haexeri_nn_1_1_N : N ;
  haengparti_nn_1_1_N : N ;
  haelsocenter_nn_1_1_N : N ;
  haeleri_nn_1_1_N : N ;
  hyckleri_nn_1_N : N ;
  husmor_nn_1_N : N ;
  hundraaarsjubileum_nn_1_1_N : N ;
  hummer_nn_1_N : N ;
  horologium_nn_1_N : N ;
  hjaernstam_nn_1_1_N : N ;
  hivstam_nn_1_N : N ;
  histamin_nn_1_N : N ;
  hetvin_nn_1_N : N ;
  herbarium_nn_1_N : N ;
  hen_nn_1_N : N ;
  hemlighetsmakeri_nn_1_N : N ;
  hemland_nn_1_N : N ;
  hembageri_nn_1_N : N ;
  hedersmedlem_nn_1_N : N ;
  hederskompani_nn_1_N : N ;
  havsstroem_nn_1_1_N : N ;
  haveri_nn_1_N : N ;
  harts_nn_1_N : N ;
  harmonium_nn_1_N : N ;
  hardangersoem_nn_1_1_N : N ;
  handrem_nn_1_N : N ;
  handelskompani_nn_1_N : N ;
  handelsgymnasium_nn_1_N : N ;
  hammel_nn_1_N : N ;
  halsrem_nn_1_N : N ;
  goepen_nn_1_1_N : N ;
  gaestgiveri_nn_1_1_N : N ;
  gaelbgjuteri_nn_1_1_N : N ;
  gaeckeri_nn_1_1_N : N ;
  gymnasium_nn_1_N : N ;
  gyckleri_nn_1_N : N ;
  gummiharts_nn_1_N : N ;
  guldslageri_nn_1_N : N ;
  guldmakeri_nn_1_N : N ;
  gulddrageri_nn_1_N : N ;
  gudmor_nn_1_N : N ;
  guanin_nn_1_N : N ;
  graaskimmel_nn_1_1_N : N ;
  grundstam_nn_1_N : N ;
  grubbleri_nn_1_N : N ;
  groteskeri_nn_1_N : N ;
  grisplaageri_nn_1_1_N : N ;
  griseri_nn_1_N : N ;
  grillfaengeri_nn_1_1_N : N ;
  gren_nn_1_N : N ;
  granstam_nn_1_N : N ;
  grannland_nn_1_N : N ;
  gom_nn_1_N : N ;
  golvvax_nn_1_N : N ;
  golvlack_nn_1_N : N ;
  gobelaengbroderi_nn_1_1_N : N ;
  gloedstroem_nn_1_1_N : N ;
  glossarium_nn_1_N : N ;
  glasmaesteri_nn_1_1_N : N ;
  glasblaaseri_nn_1_1_N : N ;
  gjuteri_nn_1_N : N ;
  gift_nn_1_N : N ;
  gevaerskompani_nn_1_1_N : N ;
  gevaersfaktori_nn_1_1_N : N ;
  gerundivum_nn_1_N : N ;
  gerundium_nn_1_N : N ;
  germanstam_nn_1_N : N ;
  geni_nn_1_N : N ;
  gelbgjuteri_nn_1_N : N ;
  gel_nn_1_N : N ;
  gasstroem_nn_1_1_N : N ;
  garveri_nn_1_N : N ;
  garnbom_nn_1_N : N ;
  galleri_nn_1_N : N ;
  galanteri_nn_1_N : N ;
  foersoeksgymnasium_nn_1_1_N : N ;
  foersaekringsbedraegeri_nn_1_1_N : N ;
  foersvarsgren_nn_1_1_N : N ;
  foerstadium_nn_1_1_N : N ;
  foersamlingsmedlem_nn_1_1_N : N ;
  foerraederi_nn_1_1_N : N ;
  foerintelsemuseum_nn_1_1_N : N ;
  foerhoersrumssceneri_nn_1_1_N : N ;
  foerdel_nn_1_1_N : N ;
  foegderi_nn_1_1_N : N ;
  foedgeni_nn_1_1_N : N ;
  faaneri_nn_1_1_N : N ;
  faagelkam_nn_1_1_N : N ;
  faergeri_nn_1_1_N : N ;
  faeltstudium_nn_1_1_N : N ;
  faedernesland_nn_1_1_N : N ;
  fyrverkeri_nn_1_N : N ;
  futurum_nn_1_N : N ;
  froeparti_nn_1_1_N : N ;
  fraeken_nn_1_1_N : N ;
  fryseri_nn_1_N : N ;
  fruktvin_nn_1_N : N ;
  friluftsmuseum_nn_1_N : N ;
  frieri_nn_1_N : N ;
  fribyteri_nn_1_N : N ;
  fredagsmorgon_nn_1_N : N ;
  fredagmorgon_nn_1_N : N ;
  frasmakeri_nn_1_N : N ;
  framtidsland_nn_1_N : N ;
  framtidsdroem_nn_1_1_N : N ;
  framstegsparti_nn_1_N : N ;
  framstam_nn_1_N : N ;
  fotografi_nn_1_N : N ;
  fostermor_nn_1_N : N ;
  fosterland_nn_1_N : N ;
  forskningslaboratorium_nn_1_N : N ;
  forskningscenter_nn_1_N : N ;
  folkstam_nn_1_N : N ;
  folkparti_nn_1_N : N ;
  folkland_nn_1_N : N ;
  flygfotografi_nn_1_N : N ;
  florilegium_nn_1_N : N ;
  flerbarnsmor_nn_1_N : N ;
  fjaellaemmel_nn_1_1_N : N ;
  fjaellparti_nn_1_1_N : N ;
  fjomperi_nn_1_N : N ;
  fjolleri_nn_1_N : N ;
  fjanteri_nn_1_N : N ;
  fixkam_nn_1_N : N ;
  fiskvin_nn_1_N : N ;
  fiskmun_nn_1_N : N ;
  fiskeri_nn_1_N : N ;
  finsnickeri_nn_1_N : N ;
  fiendeland_nn_1_N : N ;
  fett_nn_1_N : N ;
  femtioaarsjubileum_nn_1_1_N : N ;
  femtedel_nn_1_N : N ;
  feeri_nn_1_N : N ;
  feberdroem_nn_1_1_N : N ;
  farmor_nn_1_N : N ;
  fantasteri_nn_1_N : N ;
  familjemedlem_nn_1_N : N ;
  falsarium_nn_1_N : N ;
  faktori_nn_1_N : N ;
  experimentgymnasium_nn_1_N : N ;
  exkrement_nn_1_N : N ;
  examinatorium_nn_1_N : N ;
  evangelium_nn_1_N : N ;
  euroland_nn_1_N : N ;
  epitafium_nn_1_N : N ;
  epitaf_nn_1_N : N ;
  enhetsparti_nn_1_N : N ;
  enfraageparti_nn_1_1_N : N ;
  endorfin_nn_1_N : N ;
  en_nn_1_N : N ;
  emaljlack_nn_1_N : N ;
  elstroem_nn_1_1_N : N ;
  ekvatorialstroem_nn_1_1_N : N ;
  ekovin_nn_1_N : N ;
  efterkrigsdecennium_nn_1_N : N ;
  effektsoekeri_nn_1_1_N : N ;
  duschdraperi_nn_1_N : N ;
  dummer_nn_1_N : N ;
  dumbom_nn_1_N : N ;
  dubbelsalt_nn_1_N : N ;
  droemmeri_nn_1_1_N : N ;
  droem_nn_1_1_N : N ;
  drummel_nn_1_N : N ;
  drogeri_nn_1_N : N ;
  drivrem_nn_1_N : N ;
  draperi_nn_1_N : N ;
  dormitorium_nn_1_N : N ;
  dominion_nn_1_N : N ;
  diplomatarium_nn_1_N : N ;
  dioxin_nn_1_N : N ;
  dilleri_nn_1_N : N ;
  dikesren_nn_1_N : N ;
  diarium_nn_1_N : N ;
  dialogparti_nn_1_N : N ;
  detaljstudium_nn_1_N : N ;
  dessertvin_nn_1_N : N ;
  del_nn_1_N : N ;
  decennium_nn_1_N : N ;
  datorhaveri_nn_1_N : N ;
  datahaveri_nn_1_N : N ;
  dagdroemmeri_nn_1_1_N : N ;
  dagdroem_nn_1_1_N : N ;
  corps_de_logi_nn_1_N : N ;
  clowneri_nn_1_N : N ;
  chassi_nn_1_N : N ;
  charlataneri_nn_1_N : N ;
  charkuteri_nn_1_N : N ;
  certeparti_nn_1_N : N ;
  centerparti_nn_1_N : N ;
  center_nn_2_N : N ;
  cellgift_nn_1_N : N ;
  caf_e_nn_1_1_N : N ;
  cafe_nn_1_N : N ;
  baatbyggeri_nn_1_1_N : N ;
  baerrem_nn_1_1_N : N ;
  burleskeri_nn_1_N : N ;
  broestparti_nn_1_1_N : N ;
  broedskriveri_nn_1_1_N : N ;
  braennvinsdestilleri_nn_1_1_N : N ;
  braennvinsbraenneri_nn_1_1_N : N ;
  braennvin_nn_1_1_N : N ;
  braenneri_nn_1_1_N : N ;
  bryggeri_nn_1_N : N ;
  bryderi_nn_1_N : N ;
  brudgum_nn_1_N : N ;
  brodersoem_nn_1_1_N : N ;
  broderland_nn_1_N : N ;
  broderi_nn_1_N : N ;
  breviarium_nn_1_N : N ;
  bredmun_nn_1_N : N ;
  bourgognevin_nn_1_N : N ;
  borstbinderi_nn_1_N : N ;
  bordsvin_nn_1_N : N ;
  bordsmargarin_nn_1_N : N ;
  bordeauxvin_nn_1_N : N ;
  bonvax_nn_1_N : N ;
  bomullsspinneri_nn_1_N : N ;
  bom_nn_1_N : N ;
  boktryckeri_nn_1_N : N ;
  bokstipendium_nn_1_N : N ;
  bokbinderi_nn_1_N : N ;
  bodmeri_nn_1_N : N ;
  blybatteri_nn_1_N : N ;
  blodprotein_nn_1_N : N ;
  blindparti_nn_1_N : N ;
  blekeri_nn_1_N : N ;
  bleckslageri_nn_1_N : N ;
  bistaandsland_nn_1_1_N : N ;
  bisarreri_nn_1_N : N ;
  binderi_nn_1_N : N ;
  bilvax_nn_1_N : N ;
  bildsnideri_nn_1_N : N ;
  bildhuggeri_nn_1_N : N ;
  bildgalleri_nn_1_N : N ;
  bilbyggeri_nn_1_N : N ;
  bilbatteri_nn_1_N : N ;
  biland_nn_1_N : N ;
  bigotteri_nn_1_N : N ;
  bigift_nn_1_N : N ;
  betongparti_nn_1_N : N ;
  besaettningsmedlem_nn_1_1_N : N ;
  bestaandsdel_nn_1_1_N : N ;
  bergsstam_nn_1_N : N ;
  bergskam_nn_1_N : N ;
  bergkam_nn_1_N : N ;
  benporslin_nn_1_N : N ;
  beneficium_nn_1_N : N ;
  belysningsstroem_nn_1_1_N : N ;
  begynnelsestadium_nn_1_N : N ;
  bedraegeri_nn_1_1_N : N ;
  batteri_nn_1_N : N ;
  bariumsalt_nn_1_N : N ;
  baptisterium_nn_1_N : N ;
  bandmedlem_nn_1_N : N ;
  bakstroem_nn_1_1_N : N ;
  bagerimargarin_nn_1_N : N ;
  bageri_nn_1_N : N ;
  badsalt_nn_1_N : N ;
  backstroem_nn_1_1_N : N ;
  backhammer_nn_1_N : N ;
  axelrem_nn_1_N : N ;
  aviarium_nn_1_N : N ;
  auditorium_nn_1_N : N ;
  atrium_nn_1_N : N ;
  astrofotografi_nn_1_N : N ;
  arvland_nn_1_N : N ;
  arvedel_nn_1_N : N ;
  artilleribatteri_nn_1_N : N ;
  arbetarstam_nn_1_N : N ;
  arbetarparti_nn_1_N : N ;
  arbetareparti_nn_1_N : N ;
  arabland_nn_1_N : N ;
  aphelium_nn_1_N : N ;
  antihistamin_nn_1_N : N ;
  antidot_nn_1_N : N ;
  antependium_nn_1_N : N ;
  angiveri_nn_1_N : N ;
  alpland_nn_1_N : N ;
  alluvium_nn_1_N : N ;
  allodium_nn_1_N : N ;
  allod_nn_1_N : N ;
  alliansparti_nn_1_N : N ;
  alkali_nn_1_N : N ;
  akvarium_nn_1_N : N ;
  aktionsstroem_nn_1_1_N : N ;
  akterdel_nn_1_N : N ;
  afrokam_nn_1_N : N ;
  afelium_nn_1_N : N ;
  adelsprivilegium_nn_1_N : N ;
  abstrakt_nn_1_N : N ;
  _60_aarsjubileum_nn_1_1_N : N ;
  _3_fasstroem_nn_1_1_N : N ;
  Vadstenadiarium_nn_1_N : N ;
  U_land_nn_1_N : N ;
  OECD_land_nn_1_N : N ;
  Medelhavsland_nn_1_N : N ;
  Malmoekaf_e_nn_1_1_N : N ;
  I_land_nn_1_N : N ;
  Efta_land_nn_1_N : N ;
  EU_land_nn_1_N : N ;
  Delftporslin_nn_1_N : N ;
  C_vitamin_nn_1_N : N ;
  B_vitamin_nn_1_N : N ;
  A_vitamin_nn_1_N : N ;
  Munchlitografi_nn_1_N : N ;
  abb_e_nn_1_1_N : N ;
  abc_bok_nn_1_N : N ;
  afasi_nn_1_N : N ;
  affaersid_e_nn_1_1_N : N ;
  agnosi_nn_1_N : N ;
  agoni_nn_1_N : N ;
  akademi_nn_1_N : N ;
  akromegali_nn_1_N : N ;
  alexi_nn_1_N : N ;
  allegori_nn_1_N : N ;
  allergi_nn_1_N : N ;
  alpget_nn_1_N : N ;
  ami_nn_1_N : N ;
  amnesi_nn_1_N : N ;
  amnesti_nn_1_N : N ;
  amyotrofi_nn_1_N : N ;
  analogi_nn_1_N : N ;
  andaktsbok_nn_1_N : N ;
  anemi_nn_1_N : N ;
  anestesi_nn_1_N : N ;
  angoraget_nn_1_N : N ;
  annotationsbok_nn_1_N : N ;
  anomali_nn_1_N : N ;
  anomi_nn_1_N : N ;
  anorexi_nn_1_N : N ;
  anteckningsbok_nn_1_N : N ;
  antifoni_nn_1_N : N ;
  antinomi_nn_1_N : N ;
  antipati_nn_1_N : N ;
  antologi_nn_1_N : N ;
  apati_nn_1_N : N ;
  apologi_nn_1_N : N ;
  apoplexi_nn_1_N : N ;
  approximationsteori_nn_1_N : N ;
  arbetsbok_nn_1_N : N ;
  aristokrati_nn_1_N : N ;
  arrowrot_nn_1_N : N ;
  artbildningsteori_nn_1_N : N ;
  arytmi_nn_1_N : N ;
  asteni_nn_1_N : N ;
  asymmetri_nn_1_N : N ;
  ataxi_nn_1_N : N ;
  atomteori_nn_1_N : N ;
  atoni_nn_1_N : N ;
  atrofi_nn_1_N : N ;
  atypi_nn_1_N : N ;
  autarki_nn_1_N : N ;
  autopsi_nn_1_N : N ;
  autotypi_nn_1_N : N ;
  avi_nn_1_N : N ;
  avsnoerningsteori_nn_1_1_N : N ;
  bakfot_nn_1_N : N ;
  baklaengesordbok_nn_1_1_N : N ;
  bankbok_nn_1_N : N ;
  bankkamrer_nn_1_N : N ;
  barnbok_nn_1_N : N ;
  barnkoloni_nn_1_N : N ;
  begravningsbok_nn_1_N : N ;
  begravningsceremoni_nn_1_N : N ;
  benget_nn_1_N : N ;
  bergsget_nn_1_N : N ;
  beslutshierarki_nn_1_N : N ;
  besoeksbok_nn_1_1_N : N ;
  betelnoet_nn_1_1_N : N ;
  betsockerindustri_nn_1_N : N ;
  bibliografi_nn_1_N : N ;
  bilderbok_nn_1_N : N ;
  bilindustri_nn_1_N : N ;
  biljettbok_nn_1_N : N ;
  biografi_nn_1_N : N ;
  biologibok_nn_1_N : N ;
  birot_nn_1_N : N ;
  biskvi_nn_1_N : N ;
  bisturi_nn_1_N : N ;
  bladfot_nn_1_N : N ;
  blandekonomi_nn_1_N : N ;
  blasfemi_nn_1_N : N ;
  blini_nn_1_N : N ;
  blaedderbok_nn_1_1_N : N ;
  bockfot_nn_1_N : N ;
  bok_nn_1_N : N ;
  bovfysionomi_nn_1_N : N ;
  broderbok_nn_1_N : N ;
  bronkografi_nn_1_N : N ;
  bronkoskopi_nn_1_N : N ;
  bulimi_nn_1_N : N ;
  byggnadsindustri_nn_1_N : N ;
  byraakrati_nn_1_1_N : N ;
  boenbok_nn_1_1_N : N ;
  cashewnoet_nn_1_1_N : N ;
  cellulosaindustri_nn_1_N : N ;
  ceremoni_nn_1_N : N ;
  chockterapi_nn_1_N : N ;
  cirkelperiferi_nn_1_N : N ;
  collier_nn_1_N : N ;
  conferencier_nn_1_N : N ;
  conf_erencier_nn_1_1_N : N ;
  croupier_nn_1_N : N ;
  cyberstrategi_nn_1_N : N ;
  cystoskopi_nn_1_N : N ;
  dagbok_nn_1_N : N ;
  dagerrotypi_nn_1_N : N ;
  datortomografi_nn_1_N : N ;
  debutbok_nn_1_N : N ;
  delkategori_nn_1_N : N ;
  dementi_nn_1_N : N ;
  demokrati_nn_1_N : N ;
  deponi_nn_1_N : N ;
  despoti_nn_1_N : N ;
  dikotomi_nn_1_N : N ;
  dimorfi_nn_1_N : N ;
  dioptri_nn_1_N : N ;
  disharmoni_nn_1_N : N ;
  djurfot_nn_1_N : N ;
  dolikocefali_nn_1_N : N ;
  dominoteori_nn_1_N : N ;
  dubbelnoet_nn_1_1_N : N ;
  dynasti_nn_1_N : N ;
  dysenteri_nn_1_N : N ;
  dysfori_nn_1_N : N ;
  dyslexi_nn_1_N : N ;
  dyspepsi_nn_1_N : N ;
  dystopi_nn_1_N : N ;
  dystrofi_nn_1_N : N ;
  eklampsi_nn_1_N : N ;
  ekonomi_nn_1_N : N ;
  ektomi_nn_1_N : N ;
  elegi_nn_1_N : N ;
  elektroencefalografi_nn_1_N : N ;
  elektrokardiografi_nn_1_N : N ;
  elektronmikroskopi_nn_1_N : N ;
  elitteori_nn_1_N : N ;
  emboli_nn_1_N : N ;
  encefalografi_nn_1_N : N ;
  encyklopedi_nn_1_N : N ;
  endemi_nn_1_N : N ;
  energi_nn_1_N : N ;
  energiteori_nn_1_N : N ;
  envoy_e_nn_1_1_N : N ;
  epidemi_nn_1_N : N ;
  epikur_e_nn_1_1_N : N ;
  epilepsi_nn_1_N : N ;
  epizooti_nn_1_N : N ;
  espri_nn_2_N : N ;
  essay_nn_1_N : N ;
  etymologi_nn_1_N : N ;
  eufoni_nn_1_N : N ;
  eufori_nn_1_N : N ;
  europ_e_nn_1_1_N : N ;
  eurytmi_nn_1_N : N ;
  evolutionsteori_nn_1_N : N ;
  fantasi_nn_1_N : N ;
  faris_e_nn_1_1_N : N ;
  favoritmelodi_nn_1_N : N ;
  fe_nn_1_N : N ;
  feberepidemi_nn_1_N : N ;
  fetmaepidemi_nn_1_N : N ;
  filist_e_nn_1_1_N : N ;
  filmkomedi_nn_1_N : N ;
  filologi_nn_1_N : N ;
  filosofi_nn_1_N : N ;
  flygindustri_nn_1_N : N ;
  flaeskhare_nn_1_1_N : N ;
  fobi_nn_1_N : N ;
  folkdemokrati_nn_1_N : N ;
  folketymologi_nn_1_N : N ;
  folkhemsideologi_nn_1_N : N ;
  folkhemskoryf_e_nn_1_1_N : N ;
  folkhemsnostalgi_nn_1_N : N ;
  folkmelodi_nn_1_N : N ;
  framfot_nn_1_N : N ;
  fysionomi_nn_1_N : N ;
  faelthare_nn_1_1_N : N ;
  faerglitografi_nn_1_1_N : N ;
  faagelfot_nn_1_1_N : N ;
  foerestaellningskategori_nn_1_1_N : N ;
  foerfoeljelsemani_nn_1_1_N : N ;
  foerpackningsindustri_nn_1_1_N : N ;
  foersvarsstrategi_nn_1_1_N : N ;
  galil_e_nn_1_1_N : N ;
  garanti_nn_1_N : N ;
  gastroskopi_nn_1_N : N ;
  genealogi_nn_1_N : N ;
  genterapi_nn_1_N : N ;
  geometri_nn_1_N : N ;
  glaci_nn_1_N : N ;
  glossolali_nn_1_N : N ;
  grafteori_nn_1_N : N ;
  gramkalori_nn_1_N : N ;
  gripfot_nn_1_N : N ;
  grundid_e_nn_1_1_N : N ;
  grundteori_nn_1_N : N ;
  gruppterapi_nn_1_N : N ;
  graesflaecksfobi_nn_1_1_N : N ;
  graesrot_nn_1_1_N : N ;
  gaangfot_nn_1_1_N : N ;
  gaasfot_nn_1_1_N : N ;
  habitu_e_nn_1_1_N : N ;
  hare_nn_1_N : N ;
  harmoni_nn_1_N : N ;
  hasselnoet_nn_1_1_N : N ;
  hebr_e_nn_1_1_N : N ;
  hegemoni_nn_1_N : N ;
  heresi_nn_1_N : N ;
  hierarki_nn_1_N : N ;
  hindu_nn_1_N : N ;
  hjaernatrofi_nn_1_1_N : N ;
  hjaerterot_nn_1_1_N : N ;
  hokus_pokusterapi_nn_1_N : N ;
  holonymi_nn_1_N : N ;
  homologi_nn_1_N : N ;
  homonymi_nn_1_N : N ;
  hundallergi_nn_1_N : N ;
  huvudideologi_nn_1_N : N ;
  hyllningsceremoni_nn_1_N : N ;
  hyperbor_e_nn_1_1_N : N ;
  hypernymi_nn_1_N : N ;
  hyperonymi_nn_1_N : N ;
  hypertrofi_nn_1_N : N ;
  hypokondri_nn_1_N : N ;
  hypomani_nn_1_N : N ;
  hyponymi_nn_1_N : N ;
  haelsningsceremoni_nn_1_1_N : N ;
  haalfot_nn_1_1_N : N ;
  hoegerfot_nn_1_1_N : N ;
  hoegteknologi_nn_1_1_N : N ;
  ideologi_nn_1_N : N ;
  idiosynkrasi_nn_1_N : N ;
  idioti_nn_1_N : N ;
  id_e_nn_1_1_N : N ;
  indoeurop_e_nn_1_1_N : N ;
  industri_nn_1_N : N ;
  infami_nn_1_N : N ;
  inflationsteori_nn_1_N : N ;
  informationsteknologi_nn_1_N : N ;
  ingenjoersvetenskapsakademi_nn_1_1_N : N ;
  inkomstgaranti_nn_1_N : N ;
  ironi_nn_1_N : N ;
  ischuri_nn_1_N : N ;
  islamofobi_nn_1_N : N ;
  isomeri_nn_1_N : N ;
  isomorfi_nn_1_N : N ;
  jalusi_nn_1_N : N ;
  joniseringsenergi_nn_1_N : N ;
  jordnoet_nn_1_1_N : N ;
  julgransfot_nn_1_N : N ;
  jaernindustri_nn_1_1_N : N ;
  joenseri_nn_1_1_N : N ;
  kakafoni_nn_1_N : N ;
  kakofoni_nn_1_N : N ;
  kald_e_nn_1_1_N : N ;
  kalkomani_nn_1_N : N ;
  kalori_nn_1_N : N ;
  kamelpoesi_nn_1_N : N ;
  kamrer_nn_1_N : N ;
  kanan_e_nn_1_1_N : N ;
  kasjunoet_nn_1_1_N : N ;
  katalepsi_nn_1_N : N ;
  katastrofteori_nn_1_N : N ;
  kategori_nn_1_N : N ;
  kemiindustri_nn_1_N : N ;
  kemoterapi_nn_1_N : N ;
  klimatstrategi_nn_1_N : N ;
  klaetterfot_nn_1_1_N : N ;
  knoelrot_nn_1_1_N : N ;
  kokosnoet_nn_1_1_N : N ;
  koloni_nn_1_N : N ;
  komedi_nn_1_N : N ;
  konferencier_nn_1_N : N ;
  konferenciaer_nn_1_1_N : N ;
  konspirationsteori_nn_1_N : N ;
  konstakademi_nn_1_N : N ;
  konstindustri_nn_1_N : N ;
  koryf_e_nn_1_1_N : N ;
  kosmogoni_nn_1_N : N ;
  kosmologi_nn_1_N : N ;
  krestomati_nn_1_N : N ;
  krigshierarki_nn_1_N : N ;
  krigsindustri_nn_1_N : N ;
  kroki_nn_1_N : N ;
  kromolitografi_nn_1_N : N ;
  kronkoloni_nn_1_N : N ;
  kronologi_nn_1_N : N ;
  kubikrot_nn_1_N : N ;
  kukrot_nn_1_N : N ;
  kvadratrot_nn_1_N : N ;
  kaernteknologi_nn_1_1_N : N ;
  kaernvapenstrategi_nn_1_1_N : N ;
  kaalrot_nn_1_1_N : N ;
  lakritsrot_nn_1_N : N ;
  lampfot_nn_1_N : N ;
  laryngoskopi_nn_1_N : N ;
  lejonfot_nn_1_N : N ;
  leukemi_nn_1_N : N ;
  litografi_nn_1_N : N ;
  liturgi_nn_1_N : N ;
  lobotomi_nn_1_N : N ;
  luftemboli_nn_1_N : N ;
  luftrot_nn_1_N : N ;
  lungemboli_nn_1_N : N ;
  lungrot_nn_1_N : N ;
  laanegaranti_nn_1_1_N : N ;
  loenegaranti_nn_1_1_N : N ;
  mammografi_nn_1_N : N ;
  mani_nn_1_N : N ;
  manik_e_nn_1_1_N : N ;
  mardroemsfantasi_nn_1_1_N : N ;
  marknadsekonomi_nn_1_N : N ;
  maskopi_nn_1_N : N ;
  medaljceremoni_nn_1_N : N ;
  melodi_nn_1_N : N ;
  meronymi_nn_1_N : N ;
  metallfot_nn_1_N : N ;
  metallindustri_nn_1_N : N ;
  metodologi_nn_1_N : N ;
  metonymi_nn_1_N : N ;
  mjoelkallergi_nn_1_1_N : N ;
  moatj_e_nn_1_1_N : N ;
  monarki_nn_1_N : N ;
  monografi_nn_1_N : N ;
  morfologi_nn_1_N : N ;
  morot_nn_1_N : N ;
  mossrot_nn_1_N : N ;
  muskelatrofi_nn_1_N : N ;
  muskotnoet_nn_1_1_N : N ;
  mytologi_nn_1_N : N ;
  moebelfot_nn_1_1_N : N ;
  nagelrot_nn_1_N : N ;
  nanoteknologi_nn_1_N : N ;
  narkotikastrategi_nn_1_N : N ;
  nasar_e_nn_1_1_N : N ;
  nedslagsteori_nn_1_N : N ;
  nejlikrot_nn_1_N : N ;
  nerslagsteori_nn_1_N : N ;
  nostalgi_nn_1_N : N ;
  nyckelindustri_nn_1_N : N ;
  naeckrosrot_nn_1_1_N : N ;
  naesrot_nn_1_1_N : N ;
  odyss_e_nn_1_1_N : N ;
  oftalmi_nn_1_N : N ;
  oligarki_nn_1_N : N ;
  ontologi_nn_1_N : N ;
  ordfot_nn_1_N : N ;
  ordrot_nn_1_N : N ;
  orsakskategori_nn_1_N : N ;
  ortodoxi_nn_1_N : N ;
  ortografi_nn_1_N : N ;
  ostalgi_nn_1_N : N ;
  ovariotomi_nn_1_N : N ;
  paddfot_nn_1_N : N ;
  pandemi_nn_1_N : N ;
  pannkaksteori_nn_1_N : N ;
  parafasi_nn_1_N : N ;
  paranoet_nn_1_1_N : N ;
  parodi_nn_1_N : N ;
  paronymi_nn_1_N : N ;
  partisympati_nn_1_N : N ;
  partonymi_nn_1_N : N ;
  patologi_nn_1_N : N ;
  pekannoet_nn_1_1_N : N ;
  periferi_nn_1_N : N ;
  peripeti_nn_1_N : N ;
  pinjenoet_nn_1_1_N : N ;
  pistagenoet_nn_1_1_N : N ;
  pistaschnoet_nn_1_1_N : N ;
  planekonomi_nn_1_N : N ;
  plantageekonomi_nn_1_N : N ;
  plastindustri_nn_1_N : N ;
  plutokrati_nn_1_N : N ;
  pneumoni_nn_1_N : N ;
  poesi_nn_1_N : N ;
  pollenallergi_nn_1_N : N ;
  polyfoni_nn_1_N : N ;
  portier_nn_1_N : N ;
  prisceremoni_nn_1_N : N ;
  processindustri_nn_1_N : N ;
  propyl_e_nn_1_1_N : N ;
  prosodi_nn_1_N : N ;
  proteg_e_nn_1_1_N : N ;
  psalmodi_nn_1_N : N ;
  psykopati_nn_1_N : N ;
  psykoterapi_nn_1_N : N ;
  pygm_e_nn_1_1_N : N ;
  paelsallergi_nn_1_1_N : N ;
  paalrot_nn_1_1_N : N ;
  paaskhare_nn_1_1_N : N ;
  rapsodi_nn_1_N : N ;
  religionsfilosofi_nn_1_N : N ;
  remi_nn_1_N : N ;
  restidsgaranti_nn_1_N : N ;
  rou_e_nn_1_1_N : N ;
  ryssfobi_nn_1_N : N ;
  raaget_nn_1_1_N : N ;
  raavaruekonomi_nn_1_1_N : N ;
  roekmani_nn_1_1_N : N ;
  sadduc_e_nn_1_1_N : N ;
  salongskomedi_nn_1_N : N ;
  samtidsdystopi_nn_1_N : N ;
  sannolikhetsteori_nn_1_N : N ;
  satrapi_nn_1_N : N ;
  satsmelodi_nn_1_N : N ;
  schizofreni_nn_1_N : N ;
  schweizernoet_nn_1_1_N : N ;
  seborr_e_nn_1_1_N : N ;
  sedekomedi_nn_1_N : N ;
  serigrafi_nn_1_N : N ;
  sexfantasi_nn_1_N : N ;
  signaturmelodi_nn_1_N : N ;
  silkeshare_nn_1_N : N ;
  simfot_nn_1_N : N ;
  sinnesanalogi_nn_1_N : N ;
  sjaelvbiografi_nn_1_1_N : N ;
  sjaelvhjaelpsindustri_nn_1_1_N : N ;
  skogsindustri_nn_1_N : N ;
  skuggindustri_nn_1_N : N ;
  solenergiteknologi_nn_1_N : N ;
  sopprot_nn_1_N : N ;
  sorti_nn_1_N : N ;
  spelmani_nn_1_N : N ;
  spinalanestesi_nn_1_N : N ;
  spraakteknologi_nn_1_1_N : N ;
  spraakteori_nn_1_1_N : N ;
  spaedget_nn_1_1_N : N ;
  stare_nn_1_N : N ;
  statushierarki_nn_1_N : N ;
  stenget_nn_1_N : N ;
  stereotypi_nn_1_N : N ;
  stomi_nn_1_N : N ;
  storindustri_nn_1_N : N ;
  strategi_nn_1_N : N ;
  stroboskopi_nn_1_N : N ;
  strumpfot_nn_1_N : N ;
  stroemstare_nn_1_1_N : N ;
  styltrot_nn_1_N : N ;
  svartfot_nn_1_N : N ;
  sydoesteurop_e_nn_1_1_N : N ;
  symfoni_nn_1_N : N ;
  symmetri_nn_1_N : N ;
  sympati_nn_1_N : N ;
  synestesi_nn_1_N : N ;
  synonymi_nn_1_N : N ;
  saekerhetsfilosofi_nn_1_1_N : N ;
  saengfot_nn_1_1_N : N ;
  saagverksindustri_nn_1_1_N : N ;
  takistoskopi_nn_1_N : N ;
  takykardi_nn_1_N : N ;
  talteknologi_nn_1_N : N ;
  tandrot_nn_1_N : N ;
  tassfot_nn_1_N : N ;
  tautologi_nn_1_N : N ;
  taxonomi_nn_1_N : N ;
  teaterhabitu_e_nn_1_1_N : N ;
  teceremoni_nn_1_N : N ;
  teknokrati_nn_1_N : N ;
  teknologi_nn_1_N : N ;
  tekoindustri_nn_1_N : N ;
  telepati_nn_1_N : N ;
  teogoni_nn_1_N : N ;
  teokrati_nn_1_N : N ;
  teori_nn_1_N : N ;
  terapi_nn_1_N : N ;
  terminologi_nn_1_N : N ;
  tetralogi_nn_1_N : N ;
  textilindustri_nn_1_N : N ;
  tillverkningsindustri_nn_1_N : N ;
  tomografi_nn_1_N : N ;
  topologi_nn_1_N : N ;
  toppenergi_nn_1_N : N ;
  tragedi_nn_1_N : N ;
  tragikomedi_nn_1_N : N ;
  travesti_nn_1_N : N ;
  trilogi_nn_1_N : N ;
  trollhare_nn_1_N : N ;
  trutkoloni_nn_1_N : N ;
  traedrot_nn_1_1_N : N ;
  traeindustri_nn_1_1_N : N ;
  tyfoidepidemi_nn_1_N : N ;
  typografi_nn_1_N : N ;
  typologi_nn_1_N : N ;
  tyskhare_nn_1_N : N ;
  undervisningsteknologi_nn_1_N : N ;
  upplysningsfilosofi_nn_1_N : N ;
  upplysningsid_e_nn_1_1_N : N ;
  upptagningsceremoni_nn_1_N : N ;
  ursmaellsteori_nn_1_1_N : N ;
  utopi_nn_1_N : N ;
  utsugarekonomi_nn_1_N : N ;
  vadfot_nn_1_N : N ;
  valnoet_nn_1_1_N : N ;
  valsmelodi_nn_1_N : N ;
  valstrategi_nn_1_N : N ;
  varvsindustri_nn_1_N : N ;
  vasektomi_nn_1_N : N ;
  verkstadsindustri_nn_1_N : N ;
  versfot_nn_1_N : N ;
  vetenskapsakademi_nn_1_N : N ;
  vindindustri_nn_1_N : N ;
  virusepidemi_nn_1_N : N ;
  vokalharmoni_nn_1_N : N ;
  vaelfaerdsideologi_nn_1_1_N : N ;
  vaendelrot_nn_1_1_N : N ;
  vaensterfot_nn_1_1_N : N ;
  vaerdehierarki_nn_1_1_N : N ;
  vaermeekonomi_nn_1_1_N : N ;
  vaevarstare_nn_1_1_N : N ;
  vaardgaranti_nn_1_1_N : N ;
  vaardplatsgaranti_nn_1_1_N : N ;
  xylografi_nn_1_N : N ;
  yrkeskategori_nn_1_N : N ;
  aelsklingsid_e_nn_1_1_N : N ;
  aelsklingsmelodi_nn_1_1_N : N ;
  aalandsrot_nn_1_1_N : N ;
  aarfot_nn_1_1_N : N ;
  oeppningsceremoni_nn_1_1_N : N ;
  oevergaangsteknologi_nn_1_1_N : N ;
  Jupitermaane_nn_1_1_N : N ;
  abborre_nn_1_N : N ;
  abborrpinne_nn_1_N : N ;
  aborre_nn_1_N : N ;
  actionrulle_nn_1_N : N ;
  adventsljusstake_nn_1_N : N ;
  adventsstake_nn_1_N : N ;
  aftonhandske_nn_1_N : N ;
  albuske_nn_1_N : N ;
  alfahanne_nn_1_N : N ;
  alkotte_nn_1_N : N ;
  amorbaage_nn_1_1_N : N ;
  andrake_nn_1_N : N ;
  aortabaage_nn_1_1_N : N ;
  arbetshandske_nn_1_N : N ;
  arbetstimme_nn_1_N : N ;
  armbaage_nn_1_1_N : N ;
  arve_nn_1_N : N ;
  asbagge_nn_1_N : N ;
  backe_nn_1_N : N ;
  badborste_nn_1_N : N ;
  bagge_nn_1_N : N ;
  baktanke_nn_1_N : N ;
  bakvinge_nn_1_N : N ;
  bale_nn_1_N : N ;
  balle_nn_1_N : N ;
  ballongpojke_nn_1_N : N ;
  banknisse_nn_1_N : N ;
  bannstraale_nn_1_1_N : N ;
  barkborre_nn_1_N : N ;
  barkspade_nn_1_N : N ;
  barrtraedskotte_nn_1_1_N : N ;
  basse_nn_1_N : N ;
  benstomme_nn_1_N : N ;
  benstraale_nn_1_1_N : N ;
  bergknalle_nn_1_N : N ;
  bergkulle_nn_1_N : N ;
  bete_nn_2_N : N ;
  beteshage_nn_1_N : N ;
  betongpaale_nn_1_1_N : N ;
  bildrulle_2_nn_1_N : N ;
  biltvaettborste_nn_1_1_N : N ;
  bimaane_nn_1_1_N : N ;
  bindbjaelke_nn_1_1_N : N ;
  binge_nn_1_N : N ;
  bisamoxe_nn_1_N : N ;
  bisonoxe_nn_1_N : N ;
  bitanke_nn_1_N : N ;
  bjaelke_nn_1_1_N : N ;
  bjoerkhage_nn_1_1_N : N ;
  bjoernbaersbuske_nn_1_1_N : N ;
  bladbagge_nn_1_N : N ;
  blankborste_nn_1_N : N ;
  blodsdroppe_nn_1_N : N ;
  blomklase_nn_1_N : N ;
  blaavinge_nn_1_1_N : N ;
  bogsergalge_nn_1_N : N ;
  bokkasse_nn_1_N : N ;
  bokrulle_nn_1_N : N ;
  boktrave_nn_1_N : N ;
  bollkalle_nn_1_N : N ;
  bollpojke_nn_1_N : N ;
  bomullsbuske_nn_1_N : N ;
  bomullspinne_nn_1_N : N ;
  bordsgranne_nn_1_N : N ;
  borste_nn_1_N : N ;
  botanikspade_nn_1_N : N ;
  botanistspade_nn_1_N : N ;
  bottenbjaelke_nn_1_1_N : N ;
  boxhandske_nn_1_N : N ;
  brandstege_nn_1_N : N ;
  broderbaage_nn_1_1_N : N ;
  bronsborste_nn_1_N : N ;
  brudsporre_nn_1_N : N ;
  brushane_nn_1_N : N ;
  bryte_nn_1_N : N ;
  braakstake_nn_1_1_N : N ;
  broedbagge_nn_1_1_N : N ;
  broedkavle_nn_1_1_N : N ;
  broedspade_nn_1_1_N : N ;
  budkavle_nn_1_N : N ;
  bulle_nn_1_N : N ;
  bunke_nn_1_N : N ;
  buse_nn_1_N : N ;
  buske_nn_1_N : N ;
  buteljborste_nn_1_N : N ;
  baelgvante_nn_1_1_N : N ;
  baenkgranne_nn_1_1_N : N ;
  baerbjaelke_nn_1_1_N : N ;
  baerbuske_nn_1_1_N : N ;
  baerkasse_nn_1_1_N : N ;
  baerkotte_nn_1_1_N : N ;
  baerpaase_nn_1_1_N : N ;
  baade_nn_1_1_N : N ;
  baage_nn_1_1_N : N ;
  cellgranne_nn_1_N : N ;
  cirkelbaage_nn_1_1_N : N ;
  collegepojke_nn_1_N : N ;
  crosshandske_nn_1_N : N ;
  daggdroppe_nn_1_N : N ;
  dammsugarpaase_nn_1_1_N : N ;
  deltavinge_nn_1_N : N ;
  dimbaage_nn_1_1_N : N ;
  dinge_nn_1_N : N ;
  dokumentpacke_nn_1_N : N ;
  domherre_nn_1_N : N ;
  drake_nn_1_N : N ;
  droppe_nn_1_N : N ;
  drulle_nn_1_N : N ;
  druvklase_nn_1_N : N ;
  draase_nn_1_1_N : N ;
  droese_nn_1_1_N : N ;
  dubbeltimme_nn_1_N : N ;
  dunge_nn_1_N : N ;
  dvaergbuske_nn_1_1_N : N ;
  dykarbagge_nn_1_N : N ;
  dynamitgubbe_nn_1_N : N ;
  dyngbagge_nn_1_N : N ;
  daeckpaase_nn_1_1_N : N ;
  daare_nn_1_1_N : N ;
  doerrstolpe_nn_1_1_N : N ;
  eftermiddagstimme_nn_1_N : N ;
  ekbacke_nn_1_N : N ;
  ekorre_nn_1_N : N ;
  ekoxe_nn_1_N : N ;
  elborste_nn_1_N : N ;
  elefantbete_nn_1_N : N ;
  elektronstraale_nn_1_1_N : N ;
  elstolpe_nn_1_N : N ;
  enbacke_nn_1_N : N ;
  enbuske_nn_1_N : N ;
  enkeltimme_nn_1_N : N ;
  falafelbulle_nn_1_N : N ;
  farsgubbe_nn_1_N : N ;
  fartdaare_nn_1_1_N : N ;
  fastlagsbulle_nn_1_N : N ;
  festprisse_nn_1_N : N ;
  fettisdagsbulle_nn_1_N : N ;
  filbunke_nn_1_N : N ;
  filklove_nn_1_N : N ;
  filmrulle_nn_1_N : N ;
  filmtrave_nn_1_N : N ;
  filterpaase_nn_1_1_N : N ;
  fingervante_nn_1_N : N ;
  finne_nn_1_N : N ;
  finnjolle_nn_1_N : N ;
  firre_nn_1_N : N ;
  fiskbulle_nn_1_N : N ;
  fiskgjuse_nn_1_N : N ;
  fiskpinne_nn_1_N : N ;
  fjuttholme_nn_1_N : N ;
  fjaederbuske_nn_1_1_N : N ;
  fjaedervinge_nn_1_1_N : N ;
  flakmoppe_nn_1_N : N ;
  flanellborste_nn_1_N : N ;
  flaskborste_nn_1_N : N ;
  flotte_nn_1_N : N ;
  flygekorre_nn_1_N : N ;
  flygplansvinge_nn_1_N : N ;
  foderpaase_nn_1_1_N : N ;
  framvinge_nn_1_N : N ;
  fruktpaase_nn_1_1_N : N ;
  fruktsporre_nn_1_N : N ;
  fullmaane_nn_1_1_N : N ;
  faelgborste_nn_1_1_N : N ;
  faagelvinge_nn_1_1_N : N ;
  faale_nn_1_1_N : N ;
  faange_nn_1_1_N : N ;
  faarahage_nn_1_1_N : N ;
  foensterbaage_nn_1_1_N : N ;
  foensterstolpe_nn_1_1_N : N ;
  foerseningstimme_nn_1_1_N : N ;
  galgbacke_nn_1_N : N ;
  galge_nn_1_N : N ;
  gammastraale_nn_1_1_N : N ;
  garnspole_nn_1_N : N ;
  gatpojke_nn_1_N : N ;
  gelike_nn_1_N : N ;
  generaloeverste_nn_1_1_N : N ;
  gesimsbaage_nn_1_1_N : N ;
  gjuse_nn_1_N : N ;
  glac_ehandske_nn_1_1_N : N ;
  glansbagge_nn_1_N : N ;
  glasspinne_nn_1_N : N ;
  glasoegonbaage_nn_1_1_N : N ;
  glidarkille_nn_1_N : N ;
  gode_nn_1_N : N ;
  golvbjaelke_nn_1_1_N : N ;
  gombaage_nn_1_1_N : N ;
  gomspene_nn_1_N : N ;
  gosse_nn_1_N : N ;
  grabbnaeve_nn_1_1_N : N ;
  granne_nn_1_N : N ;
  grannpojke_nn_1_N : N ;
  grepe_nn_1_N : N ;
  grepe_nn_2_N : N ;
  greve_nn_1_N : N ;
  grilljanne_nn_1_N : N ;
  grinolle_nn_1_N : N ;
  grundtanke_nn_1_N : N ;
  gruvlave_nn_1_N : N ;
  grymtoxe_nn_1_N : N ;
  gryningstimme_nn_1_N : N ;
  grytvante_nn_1_N : N ;
  graenspaale_nn_1_1_N : N ;
  graalle_nn_1_1_N : N ;
  graasosse_nn_1_1_N : N ;
  gubbe_nn_1_N : N ;
  guldspade_nn_1_N : N ;
  gulsporre_nn_1_N : N ;
  gummihandske_nn_1_N : N ;
  gumse_nn_1_N : N ;
  gute_nn_1_N : N ;
  gymnastiktimme_nn_1_N : N ;
  gaelbaage_nn_1_1_N : N ;
  gaestrike_nn_1_1_N : N ;
  gaardskulle_nn_1_1_N : N ;
  gaase_nn_1_1_N : N ;
  goerdelbaage_nn_1_1_N : N ;
  goesstake_nn_1_1_N : N ;
  hage_nn_1_N : N ;
  hake_nn_1_N : N ;
  hallonbuske_nn_1_N : N ;
  halskrage_nn_1_N : N ;
  halvbuske_nn_1_N : N ;
  halvmaane_nn_1_1_N : N ;
  halvtimme_nn_1_N : N ;
  hanbjaelke_nn_1_1_N : N ;
  handklove_nn_1_N : N ;
  handljusstake_nn_1_N : N ;
  handlove_nn_1_N : N ;
  handske_nn_1_N : N ;
  handskriftsrulle_nn_1_N : N ;
  hane_nn_1_N : N ;
  hanne_nn_1_N : N ;
  harhanne_nn_1_N : N ;
  hattkulle_nn_1_N : N ;
  havsabborre_nn_1_N : N ;
  herdegosse_nn_1_N : N ;
  herre_nn_1_N : N ;
  hetsporre_nn_1_N : N ;
  himlastege_nn_1_N : N ;
  hjaelmpaase_nn_1_1_N : N ;
  holme_nn_1_N : N ;
  hopp_i_landkalle_nn_1_N : N ;
  hoppbacke_nn_1_N : N ;
  hornbaage_nn_1_1_N : N ;
  hotellpojke_nn_1_N : N ;
  huggkubbe_nn_1_N : N ;
  hundslaede_nn_1_1_N : N ;
  hurtbulle_nn_1_N : N ;
  hushaallsrulle_nn_1_1_N : N ;
  husse_nn_1_N : N ;
  huvudtanke_nn_1_N : N ;
  haestkrake_nn_1_1_N : N ;
  haestskobaage_nn_1_1_N : N ;
  haaltimme_nn_1_1_N : N ;
  haarborste_nn_1_1_N : N ;
  haardhandske_nn_1_1_N : N ;
  haarrulle_nn_1_1_N : N ;
  hoensarve_nn_1_1_N : N ;
  hoeskulle_nn_1_1_N : N ;
  hoesaate_nn_1_1_N : N ;
  induktionsspole_nn_1_N : N ;
  infanterispade_nn_1_N : N ;
  jakobsstege_nn_1_N : N ;
  jeppe_nn_1_N : N ;
  jolle_nn_1_N : N ;
  jonstraale_nn_1_1_N : N ;
  jordekorre_nn_1_N : N ;
  jordgubbe_nn_1_N : N ;
  jordpaase_nn_1_1_N : N ;
  julkasse_nn_1_N : N ;
  julkaerve_nn_1_1_N : N ;
  julle_nn_1_N : N ;
  jute_nn_2_N : N ;
  jycke_nn_1_N : N ;
  jaemlike_nn_1_1_N : N ;
  jaemte_nn_1_1_N : N ;
  jaernpinne_nn_1_1_N : N ;
  jaerpe_nn_1_1_N : N ;
  joesse_nn_1_1_N : N ;
  kaffebuske_nn_1_N : N ;
  kagge_nn_1_N : N ;
  kalkonrulle_nn_1_N : N ;
  kalvjaerpe_nn_1_1_N : N ;
  kanelbulle_nn_1_N : N ;
  kappe_nn_1_N : N ;
  kardborre_nn_1_N : N ;
  karriaerstege_nn_1_1_N : N ;
  kase_nn_1_N : N ;
  kasse_nn_1_N : N ;
  katodstraale_nn_1_1_N : N ;
  katse_nn_1_N : N ;
  kavajkrage_nn_1_N : N ;
  kavle_nn_1_N : N ;
  kaxe_nn_1_N : N ;
  kikaertsbulle_nn_1_1_N : N ;
  kille_nn_1_N : N ;
  kindpaase_nn_1_1_N : N ;
  kisse_nn_1_N : N ;
  klabbe_nn_1_N : N ;
  klabbskoete_nn_1_1_N : N ;
  klase_nn_1_N : N ;
  klave_nn_1_N : N ;
  klove_nn_1_N : N ;
  knagge_nn_1_N : N ;
  knalle_nn_1_N : N ;
  knape_nn_1_N : N ;
  knatte_nn_1_N : N ;
  knoge_nn_1_N : N ;
  knorrhane_nn_1_N : N ;
  knutte_nn_1_N : N ;
  knytnaeve_nn_1_1_N : N ;
  knaeppbagge_nn_1_1_N : N ;
  kobbe_nn_1_N : N ;
  kohage_nn_1_N : N ;
  kolborste_nn_1_N : N ;
  kolbulle_nn_1_N : N ;
  koloradoskalbagge_nn_1_N : N ;
  kontaktborste_nn_1_N : N ;
  korpvinge_nn_1_N : N ;
  kortoxe_nn_1_N : N ;
  korvgubbe_nn_1_N : N ;
  kotte_nn_1_N : N ;
  krage_nn_1_N : N ;
  kraghandske_nn_1_N : N ;
  krake_nn_1_N : N ;
  kriminaldaare_nn_1_1_N : N ;
  krusbaersbuske_nn_1_1_N : N ;
  krutgubbe_nn_1_N : N ;
  kubbe_nn_1_N : N ;
  kudde_nn_1_N : N ;
  kugge_nn_1_N : N ;
  kulkaerve_nn_1_1_N : N ;
  kulle_nn_1_N : N ;
  kulle_nn_2_N : N ;
  kulturknutte_nn_1_N : N ;
  kungstanke_nn_1_N : N ;
  kurre_nn_1_N : N ;
  kuse_nn_1_N : N ;
  kvarnvinge_nn_1_N : N ;
  kyrkbacke_nn_1_N : N ;
  kaeke_nn_1_1_N : N ;
  kaelkbacke_nn_1_1_N : N ;
  kaelke_nn_1_1_N : N ;
  kaerngubbe_nn_1_1_N : N ;
  kaerve_nn_1_1_N : N ;
  kaette_nn_1_1_N : N ;
  kaaldolme_nn_1_1_N : N ;
  kaare_nn_1_1_N : N ;
  kaarknutte_nn_1_1_N : N ;
  koeksrulle_nn_1_1_N : N ;
  koettbulle_nn_1_1_N : N ;
  labbe_nn_1_N : N ;
  labradorhanne_nn_1_N : N ;
  lackrulle_nn_1_N : N ;
  laddningsstolpe_nn_1_N : N ;
  laddstolpe_nn_1_N : N ;
  lagaardsbacke_nn_1_1_N : N ;
  lakanspaase_nn_1_1_N : N ;
  lake_nn_1_N : N ;
  lantgreve_nn_1_N : N ;
  lappvante_nn_1_N : N ;
  latoxe_nn_1_N : N ;
  lave_nn_1_N : N ;
  ledningsstolpe_nn_1_N : N ;
  lektionstimme_nn_1_N : N ;
  lie_nn_1_N : N ;
  like_nn_1_N : N ;
  liljekulle_nn_1_N : N ;
  lillpojke_nn_1_N : N ;
  limborste_nn_1_N : N ;
  limpinne_nn_1_N : N ;
  lingonbuske_nn_1_N : N ;
  ljumske_nn_1_N : N ;
  ljusbaage_nn_1_1_N : N ;
  ljusstake_nn_1_N : N ;
  ljusstraale_nn_1_1_N : N ;
  loge_nn_1_N : N ;
  love_nn_1_N : N ;
  luftstrupe_nn_1_N : N ;
  lunchtimme_nn_1_N : N ;
  lunne_nn_1_N : N ;
  lunnkaelke_nn_1_1_N : N ;
  lussebulle_nn_1_N : N ;
  lustigkurre_nn_1_N : N ;
  lyktgubbe_nn_1_N : N ;
  lyktstolpe_nn_1_N : N ;
  laerkvinge_nn_1_1_N : N ;
  laerpojke_nn_1_1_N : N ;
  laagmosse_nn_1_1_N : N ;
  loevkasse_nn_1_1_N : N ;
  mage_nn_1_N : N ;
  majbagge_nn_1_N : N ;
  malpaase_nn_1_1_N : N ;
  manke_nn_1_N : N ;
  markgreve_nn_1_N : N ;
  massbjaesse_nn_1_1_N : N ;
  mastkrage_nn_1_N : N ;
  matkasse_nn_1_N : N ;
  matstrupe_nn_1_N : N ;
  matte_nn_2_N : N ;
  mede_nn_1_N : N ;
  metallbaage_nn_1_1_N : N ;
  middagstimme_nn_1_N : N ;
  milstolpe_nn_1_N : N ;
  misse_nn_1_N : N ;
  mjukbagge_nn_1_N : N ;
  mjaelte_nn_1_1_N : N ;
  mjaerde_nn_1_1_N : N ;
  mjoelbagge_nn_1_1_N : N ;
  mjoelke_nn_1_1_N : N ;
  mjoelpaase_nn_1_1_N : N ;
  molngubbe_nn_1_N : N ;
  moppe_nn_1_N : N ;
  morgontimme_nn_1_N : N ;
  mosse_nn_1_N : N ;
  mule_nn_1_N : N ;
  multe_nn_1_N : N ;
  munkavle_nn_1_N : N ;
  murre_nn_1_N : N ;
  muskelknutte_nn_1_N : N ;
  muskelspole_nn_1_N : N ;
  myrbagge_nn_1_N : N ;
  myrholme_nn_1_N : N ;
  myskoxe_nn_1_N : N ;
  maergstraale_nn_1_1_N : N ;
  maesspojke_nn_1_1_N : N ;
  maabaersbuske_nn_1_1_N : N ;
  maalarborste_nn_1_1_N : N ;
  maalstolpe_nn_1_1_N : N ;
  maane_nn_1_1_N : N ;
  nabbe_nn_1_N : N ;
  nacke_nn_1_N : N ;
  namne_nn_1_N : N ;
  nate_nn_1_N : N ;
  nedfoersbacke_nn_1_1_N : N ;
  nemesistanke_nn_1_N : N ;
  nerfoersbacke_nn_1_1_N : N ;
  njure_nn_1_N : N ;
  norrbagge_nn_1_N : N ;
  nubbe_nn_1_N : N ;
  nyboerjarbaage_nn_1_1_N : N ;
  nystpinne_nn_1_N : N ;
  naesborre_nn_1_1_N : N ;
  naesvinge_nn_1_1_N : N ;
  naetvinge_nn_1_1_N : N ;
  naeve_nn_1_1_N : N ;
  odygdspaase_nn_1_1_N : N ;
  okbaage_nn_1_1_N : N ;
  oleanderbuske_nn_1_N : N ;
  olle_nn_1_N : N ;
  ollonborre_nn_1_N : N ;
  optimistjolle_nn_1_N : N ;
  ormbunke_nn_1_N : N ;
  orne_nn_1_N : N ;
  orre_nn_1_N : N ;
  oxe_nn_1_N : N ;
  oxjaerpe_nn_1_1_N : N ;
  p_rulle_nn_1_N : N ;
  packe_nn_1_N : N ;
  papperskasse_nn_1_N : N ;
  papperspelle_nn_1_N : N ;
  papperspaase_nn_1_1_N : N ;
  papyrusrulle_nn_1_N : N ;
  partikelstraale_nn_1_1_N : N ;
  patte_nn_1_N : N ;
  pekpinne_nn_1_N : N ;
  penningpaase_nn_1_1_N : N ;
  pepparkaksgubbe_nn_1_N : N ;
  pergamentrulle_nn_1_N : N ;
  persedelpaase_nn_1_1_N : N ;
  pilbaage_nn_1_1_N : N ;
  pillerbagge_nn_1_N : N ;
  pinne_nn_1_N : N ;
  pipkrage_nn_1_N : N ;
  planteringsspade_nn_1_N : N ;
  plastbaage_nn_1_1_N : N ;
  plastpaase_nn_1_1_N : N ;
  plastsoppaase_nn_1_1_N : N ;
  pojke_nn_1_N : N ;
  polokrage_nn_1_N : N ;
  praktbagge_nn_1_N : N ;
  pressgranne_nn_1_N : N ;
  prisse_nn_1_N : N ;
  prydnadsbuske_nn_1_N : N ;
  praelle_nn_1_1_N : N ;
  praestkrage_nn_1_1_N : N ;
  puckeloxe_nn_1_N : N ;
  puke_nn_1_N : N ;
  pulkabacke_nn_1_N : N ;
  putte_nn_1_N : N ;
  paale_nn_1_1_N : N ;
  paase_nn_1_1_N : N ;
  rackelhane_nn_1_N : N ;
  rakborste_nn_1_N : N ;
  rapsbagge_nn_1_N : N ;
  rattkaelke_nn_1_1_N : N ;
  regnbaage_nn_1_1_N : N ;
  regndroppe_nn_1_N : N ;
  renhaallningsgubbe_nn_1_1_N : N ;
  renoxe_nn_1_N : N ;
  repstege_nn_1_N : N ;
  rese_nn_1_N : N ;
  ricinbuske_nn_1_N : N ;
  riddarsporre_nn_1_N : N ;
  risvase_nn_1_N : N ;
  rorpinne_nn_1_N : N ;
  rosenbuske_nn_1_N : N ;
  rotborste_nn_1_N : N ;
  rugge_nn_1_N : N ;
  rulle_nn_1_N : N ;
  rumsgranne_nn_1_N : N ;
  rundbaage_nn_1_1_N : N ;
  ryktborste_nn_1_N : N ;
  ryssgubbe_nn_1_N : N ;
  raetstege_nn_1_1_N : N ;
  raetvinge_nn_1_1_N : N ;
  saffransbulle_nn_1_N : N ;
  salskrake_nn_1_N : N ;
  sate_nn_1_N : N ;
  schillerkrage_nn_1_N : N ;
  sci_fi_rulle_nn_1_N : N ;
  segeljolle_nn_1_N : N ;
  segmentbaage_nn_1_1_N : N ;
  sejte_nn_1_N : N ;
  sekundaerspole_nn_1_1_N : N ;
  sele_nn_1_N : N ;
  serve_nn_1_N : N ;
  sexualdaare_nn_1_1_N : N ;
  signalspade_nn_1_N : N ;
  sillbulle_nn_1_N : N ;
  sillmjoelke_nn_1_1_N : N ;
  simflotte_nn_1_N : N ;
  simplexpaale_nn_1_1_N : N ;
  sittpinne_nn_1_N : N ;
  sjalkrage_nn_1_N : N ;
  sjoeborre_nn_1_1_N : N ;
  sjoemanskrage_nn_1_1_N : N ;
  sjoeorre_nn_1_1_N : N ;
  skalbagge_nn_1_N : N ;
  skalle_nn_1_N : N ;
  skampaale_nn_1_1_N : N ;
  skarvrulle_nn_1_N : N ;
  skate_nn_1_N : N ;
  skeppspojke_nn_1_N : N ;
  skidbacke_nn_1_N : N ;
  skidhandske_nn_1_N : N ;
  skinnbagge_nn_1_N : N ;
  skinnkaelke_nn_1_1_N : N ;
  skitgubbe_nn_1_N : N ;
  skjortkrage_nn_1_N : N ;
  skjutskaare_nn_1_1_N : N ;
  skoborste_nn_1_N : N ;
  skogsbacke_nn_1_N : N ;
  skogsbagge_nn_1_N : N ;
  skolpojke_nn_1_N : N ;
  skotte_nn_1_N : N ;
  skottspole_nn_1_N : N ;
  skrake_nn_1_N : N ;
  skrothaemtningsgubbe_nn_1_1_N : N ;
  skulle_nn_1_N : N ;
  skurborste_nn_1_N : N ;
  skvaltorre_nn_1_N : N ;
  skaare_nn_1_1_N : N ;
  slagpaase_nn_1_1_N : N ;
  slangbaage_nn_1_1_N : N ;
  slase_nn_1_N : N ;
  slice_nn_1_N : N ;
  slickepinne_nn_1_N : N ;
  slypinne_nn_1_N : N ;
  slaede_nn_1_1_N : N ;
  slaengkaelke_nn_1_1_N : N ;
  slaanbaersbuske_nn_1_1_N : N ;
  smidesljusstake_nn_1_N : N ;
  smutspaase_nn_1_1_N : N ;
  smaapojke_nn_1_1_N : N ;
  smoergaasnisse_nn_1_1_N : N ;
  smoerspade_nn_1_1_N : N ;
  snapphane_nn_1_N : N ;
  snubbe_nn_1_N : N ;
  snusgubbe_nn_1_N : N ;
  snuskpelle_nn_1_N : N ;
  snytbagge_nn_1_N : N ;
  snoebollsbuske_nn_1_1_N : N ;
  snoeborste_nn_1_1_N : N ;
  snoedroppe_nn_1_1_N : N ;
  snoegubbe_nn_1_1_N : N ;
  snoeslaede_nn_1_1_N : N ;
  societetsstege_nn_1_N : N ;
  solstraale_nn_1_1_N : N ;
  soltimme_nn_1_N : N ;
  sopbacke_nn_1_N : N ;
  sopborste_nn_1_N : N ;
  soppaase_nn_1_1_N : N ;
  sotarmurre_nn_1_N : N ;
  spade_nn_1_N : N ;
  sparre_nn_1_N : N ;
  spene_nn_1_N : N ;
  spetsbaage_nn_1_1_N : N ;
  spinnrulle_nn_1_N : N ;
  spjaele_nn_1_1_N : N ;
  spole_nn_1_N : N ;
  sporre_nn_1_N : N ;
  sprakfaale_nn_1_1_N : N ;
  sprattelgubbe_nn_1_N : N ;
  springpojke_nn_1_N : N ;
  spraettbaage_nn_1_1_N : N ;
  spypaase_nn_1_1_N : N ;
  spoektimme_nn_1_1_N : N ;
  stabbe_nn_1_N : N ;
  stake_nn_1_N : N ;
  staketstolpe_nn_1_N : N ;
  stallbacke_nn_1_N : N ;
  stege_nn_1_N : N ;
  stegpinne_nn_1_N : N ;
  stekspade_nn_1_N : N ;
  stele_nn_1_N : N ;
  stingpinne_nn_1_N : N ;
  stjaerngranne_nn_1_1_N : N ;
  stolle_nn_1_N : N ;
  stolpe_nn_1_N : N ;
  stomme_nn_1_N : N ;
  storskrake_nn_1_N : N ;
  storstadskille_nn_1_N : N ;
  strandflate_nn_1_N : N ;
  streckgubbe_nn_1_N : N ;
  stridssele_nn_1_N : N ;
  strupe_nn_1_N : N ;
  strykpojke_nn_1_N : N ;
  straevbaage_nn_1_1_N : N ;
  straake_nn_1_1_N : N ;
  straale_nn_1_1_N : N ;
  stubbe_nn_1_N : N ;
  staalborste_nn_1_1_N : N ;
  staandkrage_nn_1_1_N : N ;
  supermaane_nn_1_1_N : N ;
  svale_nn_1_N : N ;
  sverigefinne_nn_1_N : N ;
  svettdroppe_nn_1_N : N ;
  sybaage_nn_1_1_N : N ;
  saedeskaerve_nn_1_1_N : N ;
  saelgbuske_nn_1_1_N : N ;
  saelle_nn_1_1_N : N ;
  saate_nn_1_1_N : N ;
  tabbe_nn_1_N : N ;
  taggstraale_nn_1_1_N : N ;
  taggtraadsrulle_nn_1_1_N : N ;
  takbjaelke_nn_1_1_N : N ;
  taksparre_nn_1_N : N ;
  taktpinne_nn_1_N : N ;
  talgoxe_nn_1_N : N ;
  tandborste_nn_1_N : N ;
  tapetborste_nn_1_N : N ;
  tebuske_nn_1_N : N ;
  tejprulle_nn_1_N : N ;
  telefonstolpe_nn_1_N : N ;
  tepaase_nn_1_1_N : N ;
  tidmaane_nn_1_1_N : N ;
  tiggarpaase_nn_1_1_N : N ;
  timme_nn_1_N : N ;
  timmerflotte_nn_1_N : N ;
  tinne_nn_1_N : N ;
  tistelborre_nn_1_N : N ;
  tjomme_nn_1_N : N ;
  tjurnacke_nn_1_N : N ;
  tjuvbagge_nn_1_N : N ;
  tjuvpojke_nn_1_N : N ;
  tokstolle_nn_1_N : N ;
  tonaarspojke_nn_1_1_N : N ;
  tordmule_nn_1_N : N ;
  torvmosse_nn_1_N : N ;
  torvspade_nn_1_N : N ;
  totempaale_nn_1_1_N : N ;
  trappstege_nn_1_N : N ;
  trave_nn_1_N : N ;
  trimmerspole_nn_1_N : N ;
  triumfbaage_nn_1_1_N : N ;
  trumpinne_nn_1_N : N ;
  tryckfelsnisse_nn_1_N : N ;
  traedgaardsbuske_nn_1_1_N : N ;
  traedgaardsspade_nn_1_1_N : N ;
  traepinne_nn_1_1_N : N ;
  traadrulle_nn_1_1_N : N ;
  tumme_nn_1_N : N ;
  tumvante_nn_1_N : N ;
  tungspene_nn_1_N : N ;
  tutte_nn_1_N : N ;
  tvaerbjaelke_nn_1_1_N : N ;
  tvaangstanke_nn_1_1_N : N ;
  tvaavinge_nn_1_1_N : N ;
  tygrulle_nn_1_N : N ;
  taeckvinge_nn_1_1_N : N ;
  taeltpinne_nn_1_1_N : N ;
  taendspole_nn_1_1_N : N ;
  taange_nn_1_1_N : N ;
  taanglake_nn_1_1_N : N ;
  taartspade_nn_1_1_N : N ;
  toernbuske_nn_1_1_N : N ;
  udde_nn_1_N : N ;
  ugnsspade_nn_1_N : N ;
  underkaeke_nn_1_1_N : N ;
  undersaate_nn_1_1_N : N ;
  undervisningstimme_nn_1_N : N ;
  unge_nn_1_N : N ;
  ungherre_nn_1_N : N ;
  uppfoersbacke_nn_1_1_N : N ;
  uppsamlingsborste_nn_1_N : N ;
  uppsamlingskasse_nn_1_N : N ;
  urnkulle_nn_1_N : N ;
  urormbunke_nn_1_N : N ;
  uroxe_nn_1_N : N ;
  utfoersbacke_nn_1_1_N : N ;
  utvikningspojke_nn_1_N : N ;
  vallpojke_nn_1_N : N ;
  valvbaage_nn_1_1_N : N ;
  vante_nn_1_N : N ;
  varde_nn_1_N : N ;
  vargtimme_nn_1_N : N ;
  vase_nn_1_N : N ;
  vassrugge_nn_1_N : N ;
  vattendroppe_nn_1_N : N ;
  vattenskinnbagge_nn_1_N : N ;
  vattenstraale_nn_1_1_N : N ;
  veckotimme_nn_1_N : N ;
  vedbacke_nn_1_N : N ;
  vedborre_nn_1_N : N ;
  vederlike_nn_1_N : N ;
  vedpinne_nn_1_N : N ;
  vedtrave_nn_1_N : N ;
  veke_nn_1_N : N ;
  vele_nn_1_N : N ;
  vetebulle_nn_1_N : N ;
  vette_nn_1_N : N ;
  vevstake_nn_1_N : N ;
  vigge_nn_1_N : N ;
  vilde_nn_1_N : N ;
  vinbaersbuske_nn_1_1_N : N ;
  vinge_nn_1_N : N ;
  vingelpelle_nn_1_N : N ;
  vise_nn_1_N : N ;
  vitsippsbacke_nn_1_N : N ;
  vaestgoete_nn_1_1_N : N ;
  vaette_nn_1_1_N : N ;
  vaale_nn_1_1_N : N ;
  vaardkase_nn_1_1_N : N ;
  vaatarve_nn_1_1_N : N ;
  wire_nn_1_N : N ;
  aende_nn_1_1_N : N ;
  aetpinne_nn_1_1_N : N ;
  aakpaase_nn_1_1_N : N ;
  aarpinne_nn_1_1_N : N ;
  aaterfoereningstanke_nn_1_1_N : N ;
  oelgubbe_nn_1_1_N : N ;
  oestgoete_nn_1_1_N : N ;
  oeverkaeke_nn_1_1_N : N ;
  oeverste_nn_1_1_N : N ;
  oeversaate_nn_1_1_N : N ;
  ABS_broms_nn_1_N : N ;
  EU_minister_nn_1_N : N ;
  Higgspartikel_nn_1_N : N ;
  Mercedes_nn_1_N : N ;
  Rolls_nn_1_N : N ;
  Saab_nn_1_N : N ;
  T_shirt_nn_1_N : N ;
  TV_skaerm_nn_1_1_N : N ;
  VAB_dag_nn_1_N : N ;
  VAB_nn_1_N : N ;
  VABB_dag_nn_1_N : N ;
  VABB_nn_1_N : N ;
  Volkswagenbuss_nn_1_N : N ;
  Z_partikel_nn_1_N : N ;
  _5_punktslaser_nn_1_N : N ;
  abborrfisk_nn_1_N : N ;
  abbot_nn_1_N : N ;
  absorber_nn_1_N : N ;
  ackommodationsvaexel_nn_1_1_N : N ;
  adapter_nn_1_N : N ;
  adelskalender_nn_1_N : N ;
  adelskrets_nn_1_N : N ;
  adonis_nn_1_N : N ;
  adoptivfoeraelder_nn_1_1_N : N ;
  adrenalinkick_nn_1_N : N ;
  adressbuss_nn_1_N : N ;
  adresskalender_nn_1_N : N ;
  adventskalender_nn_1_N : N ;
  advokatstorm_nn_1_N : N ;
  akantus_nn_1_N : N ;
  akilleshael_nn_1_1_N : N ;
  akter_nn_1_N : N ;
  akterspegel_nn_1_N : N ;
  akvariefisk_nn_1_N : N ;
  al_nn_1_N : N ;
  alfapartikel_nn_1_N : N ;
  alfaagel_nn_1_1_N : N ;
  alkekung_nn_1_N : N ;
  alkfaagel_nn_1_1_N : N ;
  alkoholometer_nn_1_N : N ;
  allhelgonadag_nn_1_N : N ;
  allvaedersstoevel_nn_1_1_N : N ;
  alm_nn_1_N : N ;
  aln_nn_1_N : N ;
  alt_nn_1_N : N ;
  alternatvinkel_nn_1_N : N ;
  alunskiffer_nn_1_N : N ;
  alvplog_nn_1_N : N ;
  ambulanshelikopter_nn_1_N : N ;
  amfiteater_nn_1_N : N ;
  amiralstitel_nn_1_N : N ;
  ampel_nn_1_N : N ;
  amperemeter_nn_1_N : N ;
  analsfinkter_nn_1_N : N ;
  andfaagel_nn_1_1_N : N ;
  andrabas_nn_1_N : N ;
  andrebas_nn_1_N : N ;
  anemometer_nn_1_N : N ;
  aneroidbarometer_nn_1_N : N ;
  anfallsvinkel_nn_1_N : N ;
  angel_nn_1_N : N ;
  angorajumper_nn_1_N : N ;
  ankarboj_nn_1_N : N ;
  ankarkabel_nn_1_N : N ;
  ankel_nn_1_N : N ;
  ankomsthall_nn_1_N : N ;
  anloppshamn_nn_1_N : N ;
  annandag_nn_1_N : N ;
  ansedel_nn_1_N : N ;
  ansjovis_nn_1_N : N ;
  anslutningsbox_nn_1_N : N ;
  anslutningskabel_nn_1_N : N ;
  anslutningsserver_nn_1_N : N ;
  antennkabel_nn_1_N : N ;
  antennkoertel_nn_1_1_N : N ;
  antibarbarus_nn_1_N : N ;
  antiklimax_nn_1_N : N ;
  antikropp_nn_1_N : N ;
  antikvitetshandel_nn_1_N : N ;
  antipartikel_nn_1_N : N ;
  aortaklaff_nn_1_N : N ;
  apel_nn_1_N : N ;
  apostel_nn_1_N : N ;
  app_nn_1_N : N ;
  arbetshaest_nn_1_1_N : N ;
  arbetsmarknadsminister_nn_1_N : N ;
  arbetsseger_nn_1_N : N ;
  arborr_nn_1_N : N ;
  arenateater_nn_1_N : N ;
  areometer_nn_1_N : N ;
  arm_nn_1_N : N ;
  armbindel_nn_1_N : N ;
  armcylinder_nn_1_N : N ;
  armstump_nn_1_N : N ;
  arm_ehelikopter_nn_1_1_N : N ;
  arm_ehaest_nn_1_1_N : N ;
  artikel_nn_1_N : N ;
  arvprins_nn_1_N : N ;
  as_nn_2_N : N ;
  asfaagel_nn_1_1_N : N ;
  ask_nn_1_N : N ;
  askkopp_nn_1_N : N ;
  askonsdag_nn_1_N : N ;
  askpartikel_nn_1_N : N ;
  asp_nn_1_N : N ;
  aster_nn_1_N : N ;
  astralkropp_nn_1_N : N ;
  atomubaat_nn_1_1_N : N ;
  atomvinter_nn_1_N : N ;
  attackhelikopter_nn_1_N : N ;
  audiometer_nn_1_N : N ;
  audit_nn_1_N : N ;
  augustisol_nn_1_N : N ;
  avelshingst_nn_1_N : N ;
  avenbok_nn_1_N : N ;
  avgaangshall_nn_1_1_N : N ;
  avskedskyss_nn_1_N : N ;
  axel_nn_1_N : N ;
  axeldiameter_nn_1_N : N ;
  axelklaff_nn_1_N : N ;
  axelmuff_nn_1_N : N ;
  back_nn_1_N : N ;
  backfisch_nn_1_N : N ;
  backspegel_nn_1_N : N ;
  backvaexel_nn_1_1_N : N ;
  baddjaevel_nn_1_1_N : N ;
  badhandduk_nn_1_N : N ;
  badmintonracket_nn_1_N : N ;
  badrumsspegel_nn_1_N : N ;
  bag_in_box_nn_1_N : N ;
  bag_nn_1_N : N ;
  bagarbod_nn_1_N : N ;
  bagg_nn_1_N : N ;
  bajonettspets_nn_1_N : N ;
  bak_nn_1_N : N ;
  bakaxel_nn_1_N : N ;
  bakaxelvaexel_nn_1_1_N : N ;
  bakflygel_nn_1_N : N ;
  bakgaard_nn_1_1_N : N ;
  bakkropp_nn_1_N : N ;
  bakplaat_nn_1_1_N : N ;
  baktass_nn_1_N : N ;
  bakteriehaerd_nn_1_1_N : N ;
  bakugn_nn_1_N : N ;
  bal_nn_1_N : N ;
  balansplog_nn_1_N : N ;
  balk_nn_1_N : N ;
  ballongprick_nn_1_N : N ;
  ban_nn_1_N : N ;
  bandhund_nn_1_N : N ;
  bandstump_nn_1_N : N ;
  bandvimpel_nn_1_N : N ;
  bang_nn_1_N : N ;
  bangaard_nn_1_1_N : N ;
  banhall_nn_1_N : N ;
  bank_nn_1_N : N ;
  bankvaexel_nn_1_1_N : N ;
  banvagn_nn_1_N : N ;
  bardisk_nn_1_N : N ;
  bardval_nn_1_N : N ;
  barkbaat_nn_1_1_N : N ;
  barkis_nn_1_N : N ;
  barlastkoel_nn_1_1_N : N ;
  barm_nn_1_N : N ;
  barncykel_nn_1_N : N ;
  barndomskompis_nn_1_N : N ;
  barnkropp_nn_1_N : N ;
  barnsaeng_nn_1_1_N : N ;
  barockstil_nn_1_N : N ;
  barometer_nn_1_N : N ;
  bartender_nn_1_N : N ;
  barvinter_nn_1_N : N ;
  bas_nn_1_N : N ;
  basker_nn_1_N : N ;
  bastardnaektergal_nn_1_1_N : N ;
  basvinkel_nn_1_N : N ;
  batting_nn_1_N : N ;
  beatnik_nn_1_N : N ;
  bebis_nn_1_N : N ;
  befaestningsgrav_nn_1_1_N : N ;
  begravningskrans_nn_1_N : N ;
  bekantskapskrets_nn_1_N : N ;
  belaeggningsstaempel_nn_1_1_N : N ;
  benfisk_nn_1_N : N ;
  benjaminfikus_nn_1_N : N ;
  benmaergscancer_nn_1_1_N : N ;
  bensinmack_nn_1_N : N ;
  bensintank_nn_1_N : N ;
  benspets_nn_1_N : N ;
  benstamp_nn_1_N : N ;
  bergakung_nn_1_N : N ;
  bergborr_nn_1_N : N ;
  bergfink_nn_1_N : N ;
  berghaell_nn_1_1_N : N ;
  bergis_nn_1_N : N ;
  bergklack_nn_1_N : N ;
  bergrygg_nn_1_N : N ;
  bergsrygg_nn_1_N : N ;
  bergstopp_nn_1_N : N ;
  bergtall_nn_1_N : N ;
  bergtopp_nn_1_N : N ;
  berguv_nn_1_N : N ;
  bergvaegg_nn_1_1_N : N ;
  bergaas_nn_1_1_N : N ;
  berkis_nn_1_N : N ;
  bermudarigg_nn_1_N : N ;
  bertel_nn_1_N : N ;
  besk_nn_1_N : N ;
  bessemerugn_nn_1_N : N ;
  best_nn_1_N : N ;
  bet_nn_1_N : N ;
  betalartikel_nn_1_N : N ;
  betapartikel_nn_1_N : N ;
  beting_nn_2_N : N ;
  betongbaedd_nn_1_1_N : N ;
  bettel_nn_1_N : N ;
  bibel_nn_1_N : N ;
  bidrottning_nn_1_N : N ;
  biff_nn_1_N : N ;
  bigaard_nn_1_1_N : N ;
  bikloev_nn_1_1_N : N ;
  biktstol_nn_1_N : N ;
  bil_nn_1_N : N ;
  bilbroms_nn_1_N : N ;
  bildskaerm_nn_1_1_N : N ;
  biljardkaepp_nn_1_1_N : N ;
  bilklaedsel_nn_1_1_N : N ;
  bill_nn_1_N : N ;
  billots_nn_1_N : N ;
  bilnyckel_nn_1_N : N ;
  bilplaat_nn_1_1_N : N ;
  bilrock_nn_1_N : N ;
  biltunnel_nn_1_N : N ;
  bindel_nn_1_N : N ;
  bindenyckel_nn_1_N : N ;
  bindesaeck_nn_1_1_N : N ;
  bindvaev_nn_1_1_N : N ;
  bindvaevskapsel_nn_1_1_N : N ;
  bingel_nn_1_N : N ;
  binnikemask_nn_1_N : N ;
  bioduk_nn_1_N : N ;
  biograforgel_nn_1_N : N ;
  biografteater_nn_1_N : N ;
  biskop_nn_1_N : N ;
  biskopsskrud_nn_1_N : N ;
  biskopsstav_nn_1_N : N ;
  biskoeldkoertel_nn_1_1_N : N ;
  bisol_nn_1_N : N ;
  bisp_nn_1_N : N ;
  bistaandsminister_nn_1_1_N : N ;
  bisvaerm_nn_1_1_N : N ;
  bit_nn_1_N : N ;
  bitestikel_nn_1_N : N ;
  bittermandel_nn_1_N : N ;
  bitvarg_nn_1_N : N ;
  bivraak_nn_1_1_N : N ;
  bjoerk_nn_1_1_N : N ;
  bjoerknaever_nn_1_1_N : N ;
  bjoerksopp_nn_1_1_N : N ;
  bjoerktrast_nn_1_1_N : N ;
  bjoern_nn_1_1_N : N ;
  bjoernhund_nn_1_1_N : N ;
  bjoernsax_nn_1_1_N : N ;
  black_nn_1_N : N ;
  bladkrans_nn_1_N : N ;
  bladstekel_nn_1_N : N ;
  blandningskran_nn_1_N : N ;
  blandrashund_nn_1_N : N ;
  blanklax_nn_1_N : N ;
  blankovaexel_nn_1_1_N : N ;
  blanksej_nn_1_N : N ;
  blankaal_nn_1_1_N : N ;
  blazer_nn_1_N : N ;
  bleckplaat_nn_1_1_N : N ;
  blekfis_nn_1_N : N ;
  bleking_nn_1_N : N ;
  bleknos_nn_1_N : N ;
  blick_nn_1_N : N ;
  blidvinter_nn_1_N : N ;
  blindbock_nn_1_N : N ;
  blindbroms_nn_1_N : N ;
  blindhund_nn_1_N : N ;
  blindtarm_nn_1_N : N ;
  blink_nn_2_N : N ;
  blinkfyr_nn_1_N : N ;
  blip_nn_1_N : N ;
  blipp_nn_1_N : N ;
  blixt_nn_1_N : N ;
  blixtfyr_nn_1_N : N ;
  blodbok_nn_1_N : N ;
  blodhund_nn_1_N : N ;
  blodigel_nn_1_N : N ;
  blodkropp_nn_1_N : N ;
  blodpalt_nn_1_N : N ;
  blodplaett_nn_1_1_N : N ;
  blodpoel_nn_1_1_N : N ;
  blogg_nn_1_N : N ;
  blomaxel_nn_1_N : N ;
  blomholk_nn_1_N : N ;
  blomkalk_nn_1_N : N ;
  blomknopp_nn_1_N : N ;
  blomkolv_nn_1_N : N ;
  blomkorg_nn_1_N : N ;
  blomkrans_nn_1_N : N ;
  blomkvast_nn_1_N : N ;
  blomkaepp_nn_1_1_N : N ;
  blomkaalssvamp_nn_1_1_N : N ;
  blomsterbaedd_nn_1_1_N : N ;
  blomsterhandel_nn_1_N : N ;
  blomsterkrans_nn_1_N : N ;
  blomsterkvast_nn_1_N : N ;
  blomstjaelk_nn_1_1_N : N ;
  bluff_nn_1_N : N ;
  blunder_nn_1_N : N ;
  blus_nn_1_N : N ;
  blydagg_nn_1_N : N ;
  blyerts_nn_1_N : N ;
  blykoel_nn_1_1_N : N ;
  blymantel_nn_1_N : N ;
  blaeckfisk_nn_1_1_N : N ;
  blaeckkoertel_nn_1_1_N : N ;
  blaeckplump_nn_1_1_N : N ;
  blaecksvamp_nn_1_1_N : N ;
  blaecksaeck_nn_1_1_N : N ;
  blaeng_nn_1_1_N : N ;
  blaenkfyr_nn_1_1_N : N ;
  blaes_nn_1_1_N : N ;
  blaesbock_nn_1_1_N : N ;
  blaester_nn_1_1_N : N ;
  blaesterugn_nn_1_1_N : N ;
  blaahaj_nn_1_1_N : N ;
  blaaklint_nn_1_1_N : N ;
  blaames_nn_1_1_N : N ;
  blaaraev_nn_1_1_N : N ;
  blaasbaelg_nn_1_1_N : N ;
  blaashals_nn_1_1_N : N ;
  blaashalskoertel_nn_1_1_N : N ;
  blaasmask_nn_1_1_N : N ;
  blaasorkester_nn_1_1_N : N ;
  blaaval_nn_1_1_N : N ;
  blaavitling_nn_1_1_N : N ;
  bob_nn_1_N : N ;
  bobb_nn_1_N : N ;
  bock_nn_1_N : N ;
  bockvinkel_nn_1_N : N ;
  bod_nn_1_N : N ;
  bodknodd_nn_1_N : N ;
  bofink_nn_1_N : N ;
  bog_nn_1_N : N ;
  bogpropeller_nn_1_N : N ;
  bogsertross_nn_1_N : N ;
  boj_nn_1_N : N ;
  bok_nn_2_N : N ;
  bokbuss_nn_1_N : N ;
  bokcirkel_nn_1_N : N ;
  bokhandel_nn_1_N : N ;
  bokmal_nn_1_N : N ;
  bokrygg_nn_1_N : N ;
  bokstavsstans_nn_1_N : N ;
  bokstavstrael_nn_1_1_N : N ;
  boktitel_nn_1_N : N ;
  boktrycksstil_nn_1_N : N ;
  boll_nn_1_N : N ;
  bolmoertsskivling_nn_1_1_N : N ;
  bombkrater_nn_1_N : N ;
  bomcylinder_nn_1_N : N ;
  bomsadel_nn_1_N : N ;
  bomullsbal_nn_1_N : N ;
  bomullstuss_nn_1_N : N ;
  bonddraeng_nn_1_1_N : N ;
  bondehaer_nn_1_1_N : N ;
  bong_nn_1_N : N ;
  bonus_nn_1_N : N ;
  bordhyvel_nn_1_N : N ;
  bordsfilt_nn_1_N : N ;
  bordsspegel_nn_1_N : N ;
  bordtennisracket_nn_1_N : N ;
  borg_nn_1_N : N ;
  borggaard_nn_1_1_N : N ;
  borr_nn_1_N : N ;
  borrchuck_nn_1_N : N ;
  borrdiameter_nn_1_N : N ;
  borrjigg_nn_1_N : N ;
  borrspindel_nn_1_N : N ;
  borstmask_nn_1_N : N ;
  borstsvans_nn_1_N : N ;
  bortaseger_nn_1_N : N ;
  bortbyting_nn_1_N : N ;
  boskapshjord_nn_1_N : N ;
  boss_nn_1_N : N ;
  bot_nn_2_N : N ;
  botdag_nn_1_N : N ;
  bottenkran_nn_1_N : N ;
  bottenskvaett_nn_1_1_N : N ;
  bov_nn_1_N : N ;
  boveteplaett_nn_1_1_N : N ;
  bowlinghall_nn_1_N : N ;
  box_nn_1_N : N ;
  boxer_nn_1_N : N ;
  boxervalp_nn_1_N : N ;
  brallis_nn_1_N : N ;
  brandartikel_nn_1_N : N ;
  brandgavel_nn_1_N : N ;
  brandgrav_nn_1_N : N ;
  brandhaerd_nn_1_1_N : N ;
  brandmur_nn_1_N : N ;
  brandsvamp_nn_1_N : N ;
  brasklapp_nn_1_N : N ;
  brat_nn_1_N : N ;
  bredspackel_nn_1_N : N ;
  brems_nn_1_N : N ;
  brevpress_nn_1_N : N ;
  brigg_nn_1_N : N ;
  brikettpress_nn_1_N : N ;
  brikollstoet_nn_1_1_N : N ;
  brink_nn_1_N : N ;
  brissling_nn_1_N : N ;
  brits_nn_1_N : N ;
  brobaenk_nn_1_1_N : N ;
  brock_nn_1_N : N ;
  brockfaagel_nn_1_1_N : N ;
  brodd_nn_1_N : N ;
  brodersax_nn_1_N : N ;
  brok_nn_1_N : N ;
  brokspett_nn_1_N : N ;
  broms_nn_1_N : N ;
  bromsback_nn_1_N : N ;
  bromscylinder_nn_1_N : N ;
  bromsklaff_nn_1_N : N ;
  bromskloss_nn_1_N : N ;
  bromsskaerm_nn_1_1_N : N ;
  bromsvagn_nn_1_N : N ;
  bropeng_nn_1_N : N ;
  bropenning_nn_1_N : N ;
  brorskaal_nn_1_1_N : N ;
  brorsskaal_nn_1_1_N : N ;
  broskfisk_nn_1_N : N ;
  broskskivling_nn_1_N : N ;
  brosksvamp_nn_1_N : N ;
  brotsch_nn_1_N : N ;
  brottsling_nn_1_N : N ;
  browning_nn_1_N : N ;
  brud_nn_1_N : N ;
  brudnaebb_nn_1_1_N : N ;
  brudpall_nn_1_N : N ;
  brudpaell_nn_1_1_N : N ;
  brudstol_nn_1_N : N ;
  brudsaeng_nn_1_1_N : N ;
  bruksartikel_nn_1_N : N ;
  brukshund_nn_1_N : N ;
  brul_epudding_nn_1_1_N : N ;
  brumbas_nn_1_N : N ;
  brunn_nn_1_N : N ;
  brunnssvaengel_nn_1_1_N : N ;
  brylling_nn_1_N : N ;
  bryl_epudding_nn_1_1_N : N ;
  brysselspets_nn_1_N : N ;
  brytningsvinkel_nn_1_N : N ;
  braedd_nn_1_1_N : N ;
  braedgaard_nn_1_1_N : N ;
  braennvinsbas_nn_1_1_N : N ;
  braenslestav_nn_1_1_N : N ;
  braensletank_nn_1_1_N : N ;
  broeding_nn_1_1_N : N ;
  broedkavel_nn_1_1_N : N ;
  broedkorg_nn_1_1_N : N ;
  broednagg_nn_1_1_N : N ;
  broedpudding_nn_1_1_N : N ;
  broedrost_nn_1_1_N : N ;
  broellopsbuss_nn_1_1_N : N ;
  broestcancer_nn_1_1_N : N ;
  broestkorg_nn_1_1_N : N ;
  broestkoertel_nn_1_1_N : N ;
  broestlapp_nn_1_1_N : N ;
  broestmur_nn_1_1_N : N ;
  broet_nn_1_1_N : N ;
  broetling_nn_1_1_N : N ;
  budkavel_nn_1_N : N ;
  buff_nn_1_N : N ;
  buffel_nn_1_N : N ;
  buffelhjord_nn_1_N : N ;
  buffert_nn_1_N : N ;
  bug_nn_1_N : N ;
  bugg_nn_2_N : N ;
  buggfix_nn_1_N : N ;
  buk_nn_1_N : N ;
  bukgjord_nn_1_N : N ;
  bukspottkoertel_nn_1_1_N : N ;
  buksvaager_nn_1_1_N : N ;
  bukvaegg_nn_1_1_N : N ;
  bulldogg_nn_1_N : N ;
  bullerbas_nn_1_N : N ;
  bult_nn_1_N : N ;
  bultsax_nn_1_N : N ;
  bumling_nn_1_N : N ;
  bunt_nn_1_N : N ;
  bur_nn_1_N : N ;
  burfaagel_nn_1_1_N : N ;
  burk_nn_1_N : N ;
  business_nn_1_N : N ;
  buss_nn_1_N : N ;
  butikstjuv_nn_1_N : N ;
  buxbom_nn_1_N : N ;
  bygel_nn_1_N : N ;
  bygelhaest_nn_1_1_N : N ;
  byggkloss_nn_1_N : N ;
  byggmiss_nn_1_N : N ;
  byggnadssockel_nn_1_N : N ;
  byggtork_nn_1_N : N ;
  byk_nn_1_N : N ;
  byling_nn_1_N : N ;
  bystdrottning_nn_1_N : N ;
  byting_nn_1_N : N ;
  byx_nn_1_N : N ;
  byxbak_nn_1_N : N ;
  byxholk_nn_1_N : N ;
  baebis_nn_1_1_N : N ;
  baeck_nn_1_1_N : N ;
  baeckahaest_nn_1_1_N : N ;
  baeckroeding_nn_1_1_N : N ;
  baeckoering_nn_1_1_N : N ;
  baedd_nn_1_1_N : N ;
  baegarsvamp_nn_1_1_N : N ;
  baelg_nn_1_1_N : N ;
  baendsel_nn_1_1_N : N ;
  baengel_nn_1_1_N : N ;
  baenk_nn_1_1_N : N ;
  baenkspis_nn_1_1_N : N ;
  baensel_nn_1_1_N : N ;
  baerfis_nn_1_1_N : N ;
  baersaerk_nn_1_1_N : N ;
  baestis_nn_1_1_N : N ;
  baever_nn_1_1_N : N ;
  baagfil_nn_1_1_N : N ;
  baagskytt_nn_1_1_N : N ;
  baak_nn_1_1_N : N ;
  baal_nn_1_1_N : N ;
  baalgeting_nn_1_1_N : N ;
  baar_nn_1_1_N : N ;
  baat_nn_1_1_N : N ;
  baatsmansstol_nn_1_1_N : N ;
  boeckling_nn_1_1_N : N ;
  boedel_nn_1_1_N : N ;
  boedelsdraeng_nn_1_1_N : N ;
  boeg_nn_1_1_N : N ;
  boej_nn_1_1_N : N ;
  boendag_nn_1_1_N : N ;
  boengrodd_nn_1_1_N : N ;
  boenhas_nn_1_1_N : N ;
  boers_nn_1_1_N : N ;
  boerting_nn_1_1_N : N ;
  cab_nn_1_N : N ;
  cabb_nn_1_N : N ;
  camping_nn_1_N : N ;
  cancer_nn_1_N : N ;
  cappuccinokopp_nn_1_N : N ;
  ceder_nn_1_N : N ;
  celsiustermometer_nn_1_N : N ;
  census_nn_1_N : N ;
  center_nn_1_N : N ;
  centerback_nn_1_N : N ;
  champagnesabel_nn_1_N : N ;
  champagnevisp_nn_1_N : N ;
  champinjonbaedd_nn_1_1_N : N ;
  chat_nn_1_N : N ;
  chatt_nn_1_N : N ;
  cheddarost_nn_1_N : N ;
  chiffernyckel_nn_1_N : N ;
  chokladbit_nn_1_N : N ;
  chokladglass_nn_1_N : N ;
  chokladpudding_nn_1_N : N ;
  chuck_nn_1_N : N ;
  cigarettfimp_nn_1_N : N ;
  cigarettroek_nn_1_1_N : N ;
  cigarrettfimp_nn_1_N : N ;
  cigarrettroek_nn_1_1_N : N ;
  ciklidfisk_nn_1_N : N ;
  ciliarkropp_nn_1_N : N ;
  cirkel_nn_1_N : N ;
  cirkus_nn_1_N : N ;
  cissus_nn_1_N : N ;
  citrus_nn_1_N : N ;
  civilminister_nn_1_N : N ;
  clitoris_nn_1_N : N ;
  club_blazer_nn_1_N : N ;
  cockpit_nn_1_N : N ;
  codex_nn_1_N : N ;
  contortatall_nn_1_N : N ;
  cosinus_nn_1_N : N ;
  crosschecking_nn_1_N : N ;
  cumulus_nn_1_N : N ;
  curlingfoeraelder_nn_1_1_N : N ;
  cykel_nn_1_N : N ;
  cykelergometer_nn_1_N : N ;
  cykelnyckel_nn_1_N : N ;
  cykelsadel_nn_1_N : N ;
  cyklometer_nn_1_N : N ;
  cylinder_nn_1_N : N ;
  cylinderpress_nn_1_N : N ;
  dadel_nn_1_N : N ;
  dagakarl_nn_1_N : N ;
  dager_nn_1_N : N ;
  dagg_nn_2_N : N ;
  daggert_nn_1_N : N ;
  daggmask_nn_1_N : N ;
  dagkarl_nn_1_N : N ;
  dagpenning_nn_1_N : N ;
  dagsedel_nn_1_N : N ;
  dal_nn_1_N : N ;
  dalahaest_nn_1_1_N : N ;
  dalkarl_nn_1_N : N ;
  dalmas_nn_1_N : N ;
  damcykel_nn_1_N : N ;
  damhatt_nn_1_N : N ;
  damm_nn_1_N : N ;
  dank_nn_1_N : N ;
  dansk_nn_1_N : N ;
  danslek_nn_1_N : N ;
  dansorkester_nn_1_N : N ;
  darraal_nn_1_1_N : N ;
  darwinfink_nn_1_N : N ;
  dataskaerm_nn_1_1_N : N ;
  datorvaexel_nn_1_1_N : N ;
  datumstaempel_nn_1_1_N : N ;
  debattartikel_nn_1_N : N ;
  debetsedel_nn_1_N : N ;
  decemberkvaell_nn_1_1_N : N ;
  deg_nn_1_N : N ;
  degel_nn_1_N : N ;
  deklinationsnaal_nn_1_1_N : N ;
  densitometer_nn_1_N : N ;
  densometer_nn_1_N : N ;
  dessertgaffel_nn_1_N : N ;
  dessertost_nn_1_N : N ;
  diamanttjuv_nn_1_N : N ;
  diameter_nn_1_N : N ;
  diesel_nn_1_N : N ;
  differentialspaerr_nn_1_1_N : N ;
  differentialvaexel_nn_1_1_N : N ;
  digel_nn_1_N : N ;
  digelpress_nn_1_N : N ;
  digitalbox_nn_1_N : N ;
  dilatationsfog_nn_1_N : N ;
  dillkvist_nn_1_N : N ;
  dimbank_nn_1_N : N ;
  diopter_nn_1_N : N ;
  dip_nn_1_N : N ;
  diplomatkrets_nn_1_N : N ;
  dipp_nn_1_N : N ;
  direktvaexel_nn_1_1_N : N ;
  dirk_nn_1_N : N ;
  discipel_nn_1_N : N ;
  disk_nn_1_N : N ;
  diskbaenk_nn_1_1_N : N ;
  diskus_nn_1_N : N ;
  distansbygel_nn_1_N : N ;
  diversehandel_nn_1_N : N ;
  djuphavsfisk_nn_1_N : N ;
  djuping_nn_1_N : N ;
  djupmask_nn_1_N : N ;
  djurgaard_nn_1_1_N : N ;
  djurhud_nn_1_N : N ;
  djurkropp_nn_1_N : N ;
  djurparksvarg_nn_1_N : N ;
  djurtarm_nn_1_N : N ;
  djaevel_nn_1_1_N : N ;
  dockteater_nn_1_N : N ;
  dodekaeder_nn_1_N : N ;
  dogg_nn_1_N : N ;
  dokusaapakaendis_nn_1_1_N : N ;
  doldis_nn_1_N : N ;
  dolk_nn_1_N : N ;
  dollarsedel_nn_1_N : N ;
  dom_nn_1_N : N ;
  dominikansyster_nn_1_N : N ;
  domkrets_nn_1_N : N ;
  domprost_nn_1_N : N ;
  domssoendag_nn_1_1_N : N ;
  domstol_nn_1_N : N ;
  domsoendag_nn_1_1_N : N ;
  doning_nn_1_N : N ;
  dopfunt_nn_1_N : N ;
  dopping_nn_1_N : N ;
  dopskaal_nn_1_1_N : N ;
  dorn_nn_1_N : N ;
  dosbarometer_nn_1_N : N ;
  dosimeter_nn_1_N : N ;
  dovhjort_nn_1_N : N ;
  dragbil_nn_1_N : N ;
  dragbaenk_nn_1_1_N : N ;
  dragg_nn_1_N : N ;
  draghaest_nn_1_1_N : N ;
  dragnagel_nn_1_N : N ;
  dragpress_nn_1_N : N ;
  drakhuvudfisk_nn_1_N : N ;
  drakstjaert_nn_1_1_N : N ;
  dressing_nn_1_N : N ;
  drever_nn_1_N : N ;
  drevhund_nn_1_N : N ;
  drevkarl_nn_1_N : N ;
  drickspeng_nn_1_N : N ;
  drill_nn_1_N : N ;
  drillborr_nn_1_N : N ;
  drilling_nn_1_N : N ;
  drillstav_nn_1_N : N ;
  drink_nn_1_N : N ;
  drittel_nn_1_N : N ;
  driv_nn_1_N : N ;
  drivaxel_nn_1_N : N ;
  drivbaenk_nn_1_1_N : N ;
  drivfjaeder_nn_1_1_N : N ;
  droghandel_nn_1_N : N ;
  droppspets_nn_1_N : N ;
  drossel_nn_1_N : N ;
  drots_nn_1_N : N ;
  drott_nn_1_N : N ;
  drottning_nn_1_N : N ;
  drufs_nn_1_N : N ;
  drul_nn_1_N : N ;
  drullputt_nn_1_N : N ;
  druvflaeder_nn_1_1_N : N ;
  draeng_nn_1_1_N : N ;
  draett_nn_1_1_N : N ;
  droeg_nn_1_1_N : N ;
  droeglapp_nn_1_1_N : N ;
  droemdejt_nn_1_1_N : N ;
  dubb_nn_1_N : N ;
  dubbel_nn_1_N : N ;
  dubbelbiff_nn_1_N : N ;
  dubbelsaeng_nn_1_1_N : N ;
  dubbeltrast_nn_1_N : N ;
  duffel_nn_1_N : N ;
  duk_nn_1_N : N ;
  dummerjoens_nn_1_1_N : N ;
  dumming_nn_1_N : N ;
  dumsnut_nn_1_N : N ;
  dumstrut_nn_1_N : N ;
  dunk_nn_1_N : N ;
  duns_nn_1_N : N ;
  durk_nn_1_N : N ;
  dusch_nn_1_N : N ;
  duschhandduk_nn_1_N : N ;
  duskaal_nn_1_1_N : N ;
  duvfaagel_nn_1_1_N : N ;
  duvhoek_nn_1_1_N : N ;
  duvjaevel_nn_1_1_N : N ;
  dvaerg_nn_1_1_N : N ;
  dvaergbjoerk_nn_1_1_N : N ;
  dvaerghamster_nn_1_1_N : N ;
  dvaerghund_nn_1_1_N : N ;
  dvaergmaas_nn_1_1_N : N ;
  dvaergtall_nn_1_1_N : N ;
  dyckert_nn_1_N : N ;
  dymling_nn_1_N : N ;
  dymmelonsdag_nn_1_N : N ;
  dynamometer_nn_1_N : N ;
  dyrgrip_nn_1_N : N ;
  dyrk_nn_1_N : N ;
  dysterkvist_nn_1_N : N ;
  dyvik_nn_1_N : N ;
  daeckel_nn_1_1_N : N ;
  daempbox_nn_1_1_N : N ;
  daevert_nn_1_1_N : N ;
  daexel_nn_1_1_N : N ;
  daarfink_nn_1_1_N : N ;
  doeding_nn_1_1_N : N ;
  doedsbaedd_nn_1_1_N : N ;
  doedsstoet_nn_1_1_N : N ;
  doedsaengel_nn_1_1_N : N ;
  doegling_nn_1_1_N : N ;
  doeing_nn_1_1_N : N ;
  doerj_nn_1_1_N : N ;
  doerr_nn_1_1_N : N ;
  doerrkarm_nn_1_1_N : N ;
  doerrkrans_nn_1_1_N : N ;
  doerrspegel_nn_1_1_N : N ;
  does_nn_1_1_N : N ;
  ebonitstav_nn_1_N : N ;
  ecklesiastikminister_nn_1_N : N ;
  edamerost_nn_1_N : N ;
  efterhoest_nn_1_1_N : N ;
  eftermiddagslur_nn_1_N : N ;
  eftersits_nn_1_N : N ;
  efterslaeng_nn_1_1_N : N ;
  eftervinter_nn_1_N : N ;
  egg_nn_1_N : N ;
  ejder_nn_1_N : N ;
  ek_nn_1_N : N ;
  ekbock_nn_1_N : N ;
  eker_nn_1_N : N ;
  elaking_nn_1_N : N ;
  eld_nn_2_N : N ;
  eldgaffel_nn_1_N : N ;
  eldhund_nn_1_N : N ;
  eldhaerd_nn_1_1_N : N ;
  eldkvast_nn_1_N : N ;
  eldsalamander_nn_1_N : N ;
  eldsjael_nn_1_1_N : N ;
  eldskur_nn_1_N : N ;
  eldstorm_nn_1_N : N ;
  elektrikermejsel_nn_1_N : N ;
  elektrometer_nn_1_N : N ;
  elektronblixt_nn_1_N : N ;
  elektronikmejsel_nn_1_N : N ;
  elektronugn_nn_1_N : N ;
  elementarpartikel_nn_1_N : N ;
  elementpensel_nn_1_N : N ;
  elhyvel_nn_1_N : N ;
  elkabel_nn_1_N : N ;
  elorgel_nn_1_N : N ;
  elpropp_nn_1_N : N ;
  elspis_nn_1_N : N ;
  elvisp_nn_1_N : N ;
  embryosaeck_nn_1_1_N : N ;
  emitter_nn_1_N : N ;
  engaangsartikel_nn_1_1_N : N ;
  engaangshandduk_nn_1_1_N : N ;
  engaangsnaesduk_nn_1_1_N : N ;
  enhetscirkel_nn_1_N : N ;
  enkelbiff_nn_1_N : N ;
  enkelsaeng_nn_1_1_N : N ;
  enmanslivbaat_nn_1_1_N : N ;
  enmansvalkrets_nn_1_N : N ;
  ensamfoeraelder_nn_1_1_N : N ;
  ensfyr_nn_1_N : N ;
  ensling_nn_1_N : N ;
  enstoering_nn_1_1_N : N ;
  entumsspik_nn_1_N : N ;
  entypsbaat_nn_1_1_N : N ;
  enaeggstvilling_nn_1_1_N : N ;
  epistel_nn_1_N : N ;
  ergometer_nn_1_N : N ;
  ersaettningsbuss_nn_1_1_N : N ;
  eskader_nn_1_N : N ;
  eskimaahund_nn_1_1_N : N ;
  ester_nn_1_N : N ;
  eter_nn_1_N : N ;
  evighetskalender_nn_1_N : N ;
  excenter_nn_1_N : N ;
  exoftalmometer_nn_1_N : N ;
  expertkrets_nn_1_N : N ;
  explosionshaerd_nn_1_1_N : N ;
  exportartikel_nn_1_N : N ;
  extrafilt_nn_1_N : N ;
  extrasol_nn_1_N : N ;
  fackminister_nn_1_N : N ;
  fadder_nn_1_N : N ;
  faktafolder_nn_1_N : N ;
  falk_nn_1_N : N ;
  fallgrop_nn_1_N : N ;
  fallos_nn_1_N : N ;
  fallseger_nn_1_N : N ;
  fals_nn_1_N : N ;
  familjekrets_nn_1_N : N ;
  famn_nn_1_N : N ;
  fanborg_nn_1_N : N ;
  farfoeraelder_nn_1_1_N : N ;
  fargalt_nn_1_N : N ;
  farlighetsstaempel_nn_1_1_N : N ;
  fartygsorkester_nn_1_N : N ;
  fasadpensel_nn_1_N : N ;
  faskikel_nn_1_N : N ;
  faster_nn_1_N : N ;
  fastlagssoendag_nn_1_1_N : N ;
  fataliedag_nn_1_N : N ;
  fattiglapp_nn_1_N : N ;
  fax_nn_1_N : N ;
  feber_nn_1_N : N ;
  febertermometer_nn_1_N : N ;
  febertopp_nn_1_N : N ;
  fegis_nn_1_N : N ;
  felraekningspeng_nn_1_1_N : N ;
  femhundrakronorssedel_nn_1_N : N ;
  femling_nn_1_N : N ;
  fempunktslaser_nn_1_N : N ;
  femtidollarsedel_nn_1_N : N ;
  femtikronorssedel_nn_1_N : N ;
  femtilapp_nn_1_N : N ;
  femtiodollarsedel_nn_1_N : N ;
  femtiokronorssedel_nn_1_N : N ;
  femtioaarsdag_nn_1_1_N : N ;
  femtiaarsdag_nn_1_1_N : N ;
  femtumsspik_nn_1_N : N ;
  fender_nn_1_N : N ;
  fendert_nn_1_N : N ;
  fenkoel_nn_1_1_N : N ;
  fenval_nn_1_N : N ;
  festkompis_nn_1_N : N ;
  festkvaell_nn_1_1_N : N ;
  festutstyrsel_nn_1_N : N ;
  fetknopp_nn_1_N : N ;
  fetsill_nn_1_N : N ;
  fetstil_nn_1_N : N ;
  fettisdag_nn_1_N : N ;
  fettkoertel_nn_1_1_N : N ;
  fettlever_nn_1_N : N ;
  fettvalk_nn_1_N : N ;
  fiberspik_nn_1_N : N ;
  fickpeng_nn_1_N : N ;
  fickspegel_nn_1_N : N ;
  ficktjuv_nn_1_N : N ;
  fidus_nn_1_N : N ;
  fikus_nn_1_N : N ;
  fil_nn_2_N : N ;
  filibuster_nn_1_N : N ;
  filister_nn_1_N : N ;
  filt_nn_1_N : N ;
  filtspets_nn_1_N : N ;
  fimbulvinter_nn_1_N : N ;
  fimp_nn_1_N : N ;
  finalmiss_nn_1_N : N ;
  finansminister_nn_1_N : N ;
  finansvalp_nn_1_N : N ;
  finger_nn_1_N : N ;
  fingerborg_nn_1_N : N ;
  fingerhud_nn_1_N : N ;
  fingernagel_nn_1_N : N ;
  fingersvamp_nn_1_N : N ;
  fingertopp_nn_1_N : N ;
  finish_nn_1_N : N ;
  fink_nn_1_N : N ;
  finkfaagel_nn_1_1_N : N ;
  finlandssvensk_nn_1_N : N ;
  fis_nn_1_N : N ;
  fisk_nn_1_N : N ;
  fiskebank_nn_1_N : N ;
  fiskhamn_nn_1_N : N ;
  fiskmaas_nn_1_1_N : N ;
  fisknot_nn_1_N : N ;
  fiskpudding_nn_1_N : N ;
  fisksump_nn_1_N : N ;
  fistel_nn_1_N : N ;
  fix_nn_1_N : N ;
  fjant_nn_1_N : N ;
  fjord_nn_1_N : N ;
  fjordhaest_nn_1_1_N : N ;
  fjording_nn_1_N : N ;
  fjaeder_nn_1_1_N : N ;
  fjaederpensel_nn_1_1_N : N ;
  fjaederskrud_nn_1_1_N : N ;
  fjaellbjoerk_nn_1_1_N : N ;
  fjaellbrud_nn_1_1_N : N ;
  fjaellbaeck_nn_1_1_N : N ;
  fjaellraev_nn_1_1_N : N ;
  fjaellsemester_nn_1_1_N : N ;
  fjaellskivling_nn_1_1_N : N ;
  fjaellvraak_nn_1_1_N : N ;
  fjaellvaerld_nn_1_1_N : N ;
  fjaerd_nn_1_1_N : N ;
  fjaerr_nn_1_1_N : N ;
  fjaerris_nn_1_1_N : N ;
  fjaersing_nn_1_1_N : N ;
  fjaert_nn_1_1_N : N ;
  fjaesker_nn_1_1_N : N ;
  fjoel_nn_1_1_N : N ;
  flabb_nn_1_N : N ;
  flamugn_nn_1_N : N ;
  flark_nn_1_N : N ;
  flaskhals_nn_1_N : N ;
  flaskkurbits_nn_1_N : N ;
  flatfisk_nn_1_N : N ;
  flax_nn_1_N : N ;
  flermansvalkrets_nn_1_N : N ;
  fles_nn_1_N : N ;
  flickkalv_nn_1_N : N ;
  flik_nn_1_N : N ;
  flock_nn_1_N : N ;
  flodarm_nn_1_N : N ;
  flodbraedd_nn_1_1_N : N ;
  flodbaedd_nn_1_1_N : N ;
  floddal_nn_1_N : N ;
  flodhaest_nn_1_1_N : N ;
  flodiller_nn_1_N : N ;
  flodkroek_nn_1_1_N : N ;
  flogroenn_nn_1_1_N : N ;
  flop_nn_1_N : N ;
  flopp_nn_1_N : N ;
  flox_nn_1_N : N ;
  flukt_nn_1_N : N ;
  flygbaat_nn_1_1_N : N ;
  flygel_nn_1_N : N ;
  flygfisk_nn_1_N : N ;
  flyghund_nn_1_N : N ;
  flygkropp_nn_1_N : N ;
  flygroenn_nn_1_1_N : N ;
  flykting_nn_1_N : N ;
  flytt_nn_1_N : N ;
  flyttfaagel_nn_1_1_N : N ;
  flyttgroet_nn_1_1_N : N ;
  flyttkarl_nn_1_N : N ;
  flytvaest_nn_1_1_N : N ;
  flaeck_nn_1_1_N : N ;
  flaeder_nn_1_1_N : N ;
  flaekt_nn_1_1_N : N ;
  flaens_nn_1_1_N : N ;
  flaerp_nn_1_1_N : N ;
  flaesktaerning_nn_1_1_N : N ;
  flaeskaenger_nn_1_1_N : N ;
  floej_nn_1_1_N : N ;
  floejel_nn_1_1_N : N ;
  fnasker_nn_1_N : N ;
  fnoesksvamp_nn_1_1_N : N ;
  fock_nn_1_N : N ;
  fodervaerd_nn_1_1_N : N ;
  fog_nn_1_N : N ;
  fogsvans_nn_1_N : N ;
  folder_nn_1_N : N ;
  folkbaat_nn_1_1_N : N ;
  folkis_nn_1_N : N ;
  folkparksorkester_nn_1_N : N ;
  folkstorm_nn_1_N : N ;
  follikel_nn_1_N : N ;
  fondstaempel_nn_1_1_N : N ;
  form_nn_1_N : N ;
  formelbil_nn_1_N : N ;
  fornborg_nn_1_N : N ;
  fors_nn_1_N : N ;
  fortel_nn_1_N : N ;
  fossing_nn_1_N : N ;
  fosterfoeraelder_nn_1_1_N : N ;
  fostersyster_nn_1_N : N ;
  fotbroms_nn_1_N : N ;
  fotknoel_nn_1_1_N : N ;
  fotoblixt_nn_1_N : N ;
  fotografiplaat_nn_1_1_N : N ;
  fotometer_nn_1_N : N ;
  fotsack_nn_1_N : N ;
  frack_nn_1_N : N ;
  fraktsedel_nn_1_N : N ;
  framaxel_nn_1_N : N ;
  framgaffel_nn_1_N : N ;
  framstoet_nn_1_1_N : N ;
  framtass_nn_1_N : N ;
  framvagn_nn_1_N : N ;
  frankostaempel_nn_1_1_N : N ;
  frans_nn_1_N : N ;
  freak_nn_1_N : N ;
  fredageftermiddag_nn_1_N : N ;
  fredagkvaell_nn_1_1_N : N ;
  fredagseftermiddag_nn_1_N : N ;
  fredagskvaell_nn_1_1_N : N ;
  fredsaengel_nn_1_1_N : N ;
  fregattfaagel_nn_1_1_N : N ;
  friggebod_nn_1_N : N ;
  frihamn_nn_1_N : N ;
  frihetsapostel_nn_1_N : N ;
  frikrets_nn_1_N : N ;
  frilans_nn_1_N : N ;
  friluftsdag_nn_1_N : N ;
  frimickel_nn_1_N : N ;
  friplaat_nn_1_1_N : N ;
  frisedel_nn_1_N : N ;
  friskus_nn_1_N : N ;
  fritidsgaard_nn_1_1_N : N ;
  frott_ehandduk_nn_1_1_N : N ;
  frukost_nn_1_N : N ;
  frukostmiddag_nn_1_N : N ;
  fruktvaegg_nn_1_1_N : N ;
  fruntimmerskarl_nn_1_N : N ;
  frys_nn_1_N : N ;
  frysbox_nn_1_N : N ;
  frysdisk_nn_1_N : N ;
  fraeckis_nn_1_1_N : N ;
  fraelsarkrans_nn_1_1_N : N ;
  fraelsejord_nn_1_1_N : N ;
  fraes_nn_1_1_N : N ;
  froekapsel_nn_1_1_N : N ;
  froetall_nn_1_1_N : N ;
  ful_nn_1_N : N ;
  fuling_nn_1_N : N ;
  fullblodshaest_nn_1_1_N : N ;
  furstbiskop_nn_1_N : N ;
  furunkel_nn_1_N : N ;
  fuskpaels_nn_1_1_N : N ;
  futt_nn_1_N : N ;
  fux_nn_1_N : N ;
  fylking_nn_1_N : N ;
  fyllbult_nn_1_N : N ;
  fyr_nn_1_N : N ;
  fyrbaak_nn_1_1_N : N ;
  fyrfoting_nn_1_N : N ;
  fyrk_nn_1_N : N ;
  fyrling_nn_1_N : N ;
  fyrmaenning_nn_1_1_N : N ;
  fyrtumsspik_nn_1_N : N ;
  fyrvaeppling_nn_1_1_N : N ;
  faebod_nn_1_1_N : N ;
  faelg_nn_1_1_N : N ;
  faell_nn_1_1_N : N ;
  faellkniv_nn_1_1_N : N ;
  faellkoel_nn_1_1_N : N ;
  faeltmarskalk_nn_1_1_N : N ;
  faenrik_nn_1_1_N : N ;
  faerdknaepp_nn_1_1_N : N ;
  faerghandel_nn_1_1_N : N ;
  faergklick_nn_1_1_N : N ;
  faering_nn_1_1_N : N ;
  faerskpotatis_nn_1_1_N : N ;
  faerskvarudisk_nn_1_1_N : N ;
  faeroeing_nn_1_1_N : N ;
  faesting_nn_1_1_N : N ;
  faagel_nn_1_1_N : N ;
  faagelbur_nn_1_1_N : N ;
  faagelfjaeder_nn_1_1_N : N ;
  faagelholk_nn_1_1_N : N ;
  faagelhund_nn_1_1_N : N ;
  faall_nn_1_1_N : N ;
  faallbaenk_nn_1_1_N : N ;
  faangstgrop_nn_1_1_N : N ;
  faarbogsaerm_nn_1_1_N : N ;
  faarhjord_nn_1_1_N : N ;
  faarhund_nn_1_1_N : N ;
  faarost_nn_1_1_N : N ;
  foedopartikel_nn_1_1_N : N ;
  foedsel_nn_1_1_N : N ;
  foeljesedel_nn_1_1_N : N ;
  foensterbaenk_nn_1_1_N : N ;
  foensterglugg_nn_1_1_N : N ;
  foensterhasp_nn_1_1_N : N ;
  foensterkarm_nn_1_1_N : N ;
  foensterlav_nn_1_1_N : N ;
  foensterrektangel_nn_1_1_N : N ;
  foenstersmyg_nn_1_1_N : N ;
  foer_nn_1_1_N : N ;
  foerarsits_nn_1_1_N : N ;
  foerbandsartikel_nn_1_1_N : N ;
  foerbrukningsartikel_nn_1_1_N : N ;
  foerbundsdag_nn_1_1_N : N ;
  foerdetting_nn_1_1_N : N ;
  foerestaellningsvaerld_nn_1_1_N : N ;
  foergaard_nn_1_1_N : N ;
  foerhall_nn_1_1_N : N ;
  foerning_nn_1_1_N : N ;
  foerpik_nn_1_1_N : N ;
  foerskoleaalder_nn_1_1_N : N ;
  foerskaerargaffel_nn_1_1_N : N ;
  foerskaerarkniv_nn_1_1_N : N ;
  foersommarkvaell_nn_1_1_N : N ;
  foerstling_nn_1_1_N : N ;
  foerstugukvist_nn_1_1_N : N ;
  foerstukvist_nn_1_1_N : N ;
  foerstaev_nn_1_1_N : N ;
  foersvarsminister_nn_1_1_N : N ;
  foersaekringspeng_nn_1_1_N : N ;
  foersaeljningsdisk_nn_1_1_N : N ;
  foervaringsask_nn_1_1_N : N ;
  foervaringsbox_nn_1_1_N : N ;
  foervinter_nn_1_1_N : N ;
  foeraelder_nn_1_1_N : N ;
  foeraeldrabalk_nn_1_1_N : N ;
  foeraeldradag_nn_1_1_N : N ;
  gabonhuggorm_nn_1_N : N ;
  gadd_nn_1_N : N ;
  gaddstekel_nn_1_N : N ;
  gaff_nn_1_N : N ;
  gaffel_nn_1_N : N ;
  gaffelbit_nn_1_N : N ;
  gaffelbock_nn_1_N : N ;
  gaffelhjort_nn_1_N : N ;
  gaffelrigg_nn_1_N : N ;
  gaffeltruck_nn_1_N : N ;
  gaj_nn_1_N : N ;
  galder_nn_1_N : N ;
  galgfaagel_nn_1_1_N : N ;
  gallstekel_nn_1_N : N ;
  gallup_nn_1_N : N ;
  galning_nn_1_N : N ;
  galt_nn_1_N : N ;
  galvanometer_nn_1_N : N ;
  galaerslav_nn_1_1_N : N ;
  gam_nn_1_N : N ;
  gamling_nn_1_N : N ;
  gaphals_nn_1_N : N ;
  gapsax_nn_1_N : N ;
  garfaagel_nn_1_1_N : N ;
  garnhank_nn_1_N : N ;
  gaskran_nn_1_N : N ;
  gaskropp_nn_1_N : N ;
  gasometer_nn_1_N : N ;
  gasspis_nn_1_N : N ;
  gast_nn_1_N : N ;
  gatuteater_nn_1_N : N ;
  gavel_nn_1_N : N ;
  gejser_nn_1_N : N ;
  gelatinkapsel_nn_1_N : N ;
  gel_esvamp_nn_1_1_N : N ;
  genomsnittssvensk_nn_1_N : N ;
  genuafock_nn_1_N : N ;
  geodimeter_nn_1_N : N ;
  gers_nn_1_N : N ;
  getabock_nn_1_N : N ;
  getapel_nn_1_N : N ;
  geting_nn_1_N : N ;
  getingsvaerm_nn_1_1_N : N ;
  getmjoelksost_nn_1_1_N : N ;
  getost_nn_1_N : N ;
  getvaeppling_nn_1_1_N : N ;
  gevaerskolv_nn_1_1_N : N ;
  giffel_nn_1_N : N ;
  giftermaalsbalk_nn_1_1_N : N ;
  giftkapsel_nn_1_N : N ;
  giftkoertel_nn_1_1_N : N ;
  giftspindel_nn_1_N : N ;
  gifttagg_nn_1_N : N ;
  gigg_nn_1_N : N ;
  ginbalk_nn_1_N : N ;
  gip_nn_1_N : N ;
  gipp_nn_1_N : N ;
  gir_nn_1_N : N ;
  gistgaard_nn_1_1_N : N ;
  giv_nn_1_N : N ;
  gjord_nn_1_N : N ;
  glaciaeris_nn_1_1_N : N ;
  glasbjoerk_nn_1_1_N : N ;
  glasbult_nn_1_N : N ;
  glashandduk_nn_1_N : N ;
  glaskolv_nn_1_N : N ;
  glaskropp_nn_1_N : N ;
  glasmonter_nn_1_N : N ;
  glasstrut_nn_1_N : N ;
  glasvar_nn_1_N : N ;
  glasaal_nn_1_1_N : N ;
  glattmask_nn_1_N : N ;
  glav_nn_1_N : N ;
  gletscher_nn_1_N : N ;
  glimt_nn_1_N : N ;
  gliring_nn_1_N : N ;
  glis_nn_2_N : N ;
  glop_nn_1_N : N ;
  glottisstoet_nn_1_1_N : N ;
  glugg_nn_1_N : N ;
  glunt_nn_1_N : N ;
  glytt_nn_1_N : N ;
  gloedbaedd_nn_1_1_N : N ;
  gloedkropp_nn_1_1_N : N ;
  gloegg_nn_1_1_N : N ;
  gnet_nn_2_N : N ;
  gnoding_nn_1_N : N ;
  gnaellmaans_nn_1_1_N : N ;
  gnaellspik_nn_1_1_N : N ;
  goddagspilt_nn_1_N : N ;
  goding_nn_1_N : N ;
  godis_nn_2_N : N ;
  godsvagn_nn_1_N : N ;
  golvbrunn_nn_1_N : N ;
  golvbrunnssil_nn_1_N : N ;
  golvregel_nn_1_N : N ;
  golvsil_nn_1_N : N ;
  golvvaexel_nn_1_1_N : N ;
  goniometer_nn_1_N : N ;
  gordonsetter_nn_1_N : N ;
  grabb_nn_1_N : N ;
  gradmejsel_nn_1_N : N ;
  gradtapp_nn_1_N : N ;
  grafitdegel_nn_1_N : N ;
  gran_nn_1_N : N ;
  gratisskjuts_nn_1_N : N ;
  grav_nn_1_N : N ;
  gravimeter_nn_1_N : N ;
  gravlax_nn_1_N : N ;
  gravstickel_nn_1_N : N ;
  grenspets_nn_1_N : N ;
  grenvinkel_nn_1_N : N ;
  grevetitel_nn_1_N : N ;
  griffel_nn_1_N : N ;
  grill_nn_1_N : N ;
  grind_nn_1_N : N ;
  grindslant_nn_1_N : N ;
  grindval_nn_1_N : N ;
  grip_nn_1_N : N ;
  gris_nn_1_N : N ;
  griskulting_nn_1_N : N ;
  grissel_nn_1_N : N ;
  grissvans_nn_1_N : N ;
  grodd_nn_1_N : N ;
  groddknopp_nn_1_N : N ;
  grodfisk_nn_1_N : N ;
  grogg_nn_1_N : N ;
  grop_nn_1_N : N ;
  grovtarm_nn_1_N : N ;
  grundbult_nn_1_N : N ;
  grundplaat_nn_1_1_N : N ;
  grundval_nn_1_N : N ;
  grusgrop_nn_1_N : N ;
  gruvarbetarstoevel_nn_1_1_N : N ;
  gruvhund_nn_1_N : N ;
  grythund_nn_1_N : N ;
  grytlapp_nn_1_N : N ;
  graeddvisp_nn_1_1_N : N ;
  graelmaans_nn_1_1_N : N ;
  graeshoppssvaerm_nn_1_1_N : N ;
  graesmask_nn_1_1_N : N ;
  graevling_nn_1_1_N : N ;
  graevlingshund_nn_1_1_N : N ;
  graaal_nn_1_1_N : N ;
  graahund_nn_1_1_N : N ;
  graahaeger_nn_1_1_N : N ;
  graalax_nn_1_1_N : N ;
  graames_nn_1_1_N : N ;
  graasej_nn_1_1_N : N ;
  graasparv_nn_1_1_N : N ;
  graaspett_nn_1_1_N : N ;
  graasael_nn_1_1_N : N ;
  graatrut_nn_1_1_N : N ;
  graaval_nn_1_1_N : N ;
  groenfink_nn_1_1_N : N ;
  groening_nn_1_1_N : N ;
  groenlandsval_nn_1_1_N : N ;
  groenling_nn_1_1_N : N ;
  groenmoegelost_nn_1_1_N : N ;
  groenspett_nn_1_1_N : N ;
  groet_nn_1_1_N : N ;
  groetfrukost_nn_1_1_N : N ;
  groetrock_nn_1_1_N : N ;
  gubbjaevel_nn_1_1_N : N ;
  gubbstrutt_nn_1_N : N ;
  gud_nn_1_N : N ;
  guding_nn_1_N : N ;
  guldfisk_nn_1_N : N ;
  guldfux_nn_1_N : N ;
  guldkalv_nn_1_N : N ;
  guldklimp_nn_1_N : N ;
  guldmakrill_nn_1_N : N ;
  guldplants_nn_1_N : N ;
  guldstekel_nn_1_N : N ;
  guldstaempel_nn_1_1_N : N ;
  guldaalder_nn_1_1_N : N ;
  gulesaeck_nn_1_1_N : N ;
  guling_nn_1_N : N ;
  gulkropp_nn_1_N : N ;
  gullegris_nn_1_N : N ;
  gullgris_nn_1_N : N ;
  gulsparv_nn_1_N : N ;
  gulsaeck_nn_1_1_N : N ;
  gummikabel_nn_1_N : N ;
  gummisnodd_nn_1_N : N ;
  gummistoevel_nn_1_1_N : N ;
  gump_nn_1_N : N ;
  gumpkoertel_nn_1_1_N : N ;
  gunghaest_nn_1_1_N : N ;
  gunstling_nn_1_N : N ;
  gylf_nn_1_N : N ;
  gylling_nn_1_N : N ;
  gaeddsax_nn_1_1_N : N ;
  gael_nn_1_1_N : N ;
  gaengback_nn_1_1_N : N ;
  gaengtapp_nn_1_1_N : N ;
  gaengtolk_nn_1_1_N : N ;
  gaerdesgaard_nn_1_1_N : N ;
  gaerdsgaard_nn_1_1_N : N ;
  gaerdsgaardsstoer_nn_1_1_N : N ;
  gaerdsmyg_nn_1_1_N : N ;
  gaers_nn_1_1_N : N ;
  gaessling_nn_1_1_N : N ;
  gaestgivargaard_nn_1_1_N : N ;
  gaesthandduk_nn_1_1_N : N ;
  gaestring_nn_1_1_N : N ;
  gaang_nn_1_1_N : N ;
  gaanglaat_nn_1_1_N : N ;
  gaangstol_nn_1_1_N : N ;
  gaard_nn_1_1_N : N ;
  gaardag_nn_1_1_N : N ;
  gaardagskvaell_nn_1_1_N : N ;
  gaarding_nn_1_1_N : N ;
  gaardskarl_nn_1_1_N : N ;
  gaardvar_nn_1_1_N : N ;
  gaasfjaeder_nn_1_1_N : N ;
  gaaskarl_nn_1_1_N : N ;
  gaastav_nn_1_1_N : N ;
  gaastol_nn_1_1_N : N ;
  gaat_nn_1_1_N : N ;
  goedkyckling_nn_1_1_N : N ;
  goedselstack_nn_1_1_N : N ;
  goek_nn_1_1_N : N ;
  goel_nn_1_1_N : N ;
  goeling_nn_1_1_N : N ;
  goerdel_nn_1_1_N : N ;
  goes_nn_1_1_N : N ;
  goet_nn_1_1_N : N ;
  goeteborgsvits_nn_1_1_N : N ;
  habitus_nn_1_N : N ;
  hackkyckling_nn_1_N : N ;
  hackspett_nn_1_N : N ;
  hagtorn_nn_1_N : N ;
  haj_nn_1_N : N ;
  hajk_nn_1_N : N ;
  hajmal_nn_1_N : N ;
  haklapp_nn_1_N : N ;
  hakspets_nn_1_N : N ;
  hall_nn_1_N : N ;
  hallick_nn_1_N : N ;
  halling_nn_1_N : N ;
  hallonmask_nn_1_N : N ;
  hallspegel_nn_1_N : N ;
  hallstaempel_nn_1_1_N : N ;
  halmstack_nn_1_N : N ;
  hals_nn_1_N : N ;
  halsduk_nn_1_N : N ;
  halsgrop_nn_1_N : N ;
  halsmandel_nn_1_N : N ;
  halvback_nn_1_N : N ;
  halvcirkel_nn_1_N : N ;
  halvknop_nn_1_N : N ;
  halvsyster_nn_1_N : N ;
  halvvaerld_nn_1_1_N : N ;
  hammarhaj_nn_1_N : N ;
  hammelsadel_nn_1_N : N ;
  hammock_nn_1_N : N ;
  hammondorgel_nn_1_N : N ;
  hamn_nn_1_N : N ;
  hamster_nn_1_N : N ;
  handbroms_nn_1_N : N ;
  handduk_nn_1_N : N ;
  handel_nn_2_N : N ;
  handelsbod_nn_1_N : N ;
  handelsminister_nn_1_N : N ;
  handelstraedgaard_nn_1_1_N : N ;
  handfull_nn_1_N : N ;
  handkyss_nn_1_N : N ;
  handpenning_nn_1_N : N ;
  handspegel_nn_1_N : N ;
  handstil_nn_1_N : N ;
  handvinsch_nn_1_N : N ;
  hank_nn_1_N : N ;
  hantel_nn_1_N : N ;
  harkrank_nn_1_N : N ;
  harpalt_nn_1_N : N ;
  harr_nn_1_N : N ;
  hartass_nn_1_N : N ;
  harv_nn_1_N : N ;
  hasp_nn_1_N : N ;
  haspel_nn_1_N : N ;
  hassel_nn_1_N : N ;
  hasselsnok_nn_1_N : N ;
  hatt_nn_1_N : N ;
  hattask_nn_1_N : N ;
  hattsvamp_nn_1_N : N ;
  haubitz_nn_1_N : N ;
  havregrynsgroet_nn_1_1_N : N ;
  havsborstmask_nn_1_N : N ;
  havsfaagel_nn_1_1_N : N ;
  havsis_nn_1_N : N ;
  havskraeftstjaert_nn_1_1_N : N ;
  havslax_nn_1_N : N ;
  havsmus_nn_1_N : N ;
  havstrut_nn_1_N : N ;
  havsutter_nn_1_N : N ;
  havtorn_nn_1_N : N ;
  hearing_nn_1_N : N ;
  hed_nn_1_N : N ;
  hedersknyffel_nn_1_N : N ;
  hederskodex_nn_1_N : N ;
  hedersmantel_nn_1_N : N ;
  hederstitel_nn_1_N : N ;
  hedning_nn_1_N : N ;
  hejduk_nn_1_N : N ;
  helgdag_nn_1_N : N ;
  helikopter_nn_1_N : N ;
  helkvaell_nn_1_1_N : N ;
  hembygdsgaard_nn_1_1_N : N ;
  hemligstaempel_nn_1_1_N : N ;
  hemlock_nn_1_N : N ;
  hemmakvaell_nn_1_1_N : N ;
  hemmarock_nn_1_N : N ;
  hemmaseger_nn_1_N : N ;
  herrcykel_nn_1_N : N ;
  herrdubbel_nn_1_N : N ;
  herrgaard_nn_1_1_N : N ;
  herrgaardsost_nn_1_1_N : N ;
  herrgaardsvagn_nn_1_1_N : N ;
  herrsingel_nn_1_N : N ;
  hertig_nn_1_N : N ;
  hexameter_nn_1_N : N ;
  hibiskus_nn_1_N : N ;
  higgspartikel_nn_1_N : N ;
  himlakropp_nn_1_N : N ;
  himmelssaeng_nn_1_1_N : N ;
  hind_nn_1_N : N ;
  hinderbock_nn_1_N : N ;
  hingst_nn_1_N : N ;
  hink_nn_1_N : N ;
  hiss_nn_1_N : N ;
  hisskorg_nn_1_N : N ;
  hjord_nn_1_N : N ;
  hjort_nn_1_N : N ;
  hjortsadel_nn_1_N : N ;
  hjulaxel_nn_1_N : N ;
  hjulmutter_nn_1_N : N ;
  hjaelm_nn_1_1_N : N ;
  hjaeltehund_nn_1_1_N : N ;
  hjaernbalk_nn_1_1_N : N ;
  hjaernskaal_nn_1_1_N : N ;
  hjaernstorm_nn_1_1_N : N ;
  hjaertesuck_nn_1_1_N : N ;
  hjaertklaff_nn_1_1_N : N ;
  hjaertsaeck_nn_1_1_N : N ;
  hoj_nn_1_N : N ;
  holk_nn_1_N : N ;
  homovigsel_nn_1_N : N ;
  honungsskivling_nn_1_N : N ;
  hop_nn_1_N : N ;
  hoppstjaert_nn_1_1_N : N ;
  horbock_nn_1_N : N ;
  horsgoek_nn_1_1_N : N ;
  horst_nn_1_N : N ;
  host_nn_1_N : N ;
  hov_nn_1_N : N ;
  hovmarskalk_nn_1_N : N ;
  hovnarr_nn_1_N : N ;
  hovreporter_nn_1_N : N ;
  hud_nn_1_N : N ;
  hudflik_nn_1_N : N ;
  hudflaeck_nn_1_1_N : N ;
  huggmejsel_nn_1_N : N ;
  hulk_nn_1_N : N ;
  hulling_nn_1_N : N ;
  humbug_nn_1_N : N ;
  hund_nn_1_N : N ;
  hundlort_nn_1_N : N ;
  hundrakronorssedel_nn_1_N : N ;
  hundralapp_nn_1_N : N ;
  hundring_nn_1_N : N ;
  hundvalp_nn_1_N : N ;
  hundaexing_nn_1_1_N : N ;
  hunk_nn_1_N : N ;
  hurts_nn_1_N : N ;
  husbock_nn_1_N : N ;
  husdjursartikel_nn_1_N : N ;
  husgavel_nn_1_N : N ;
  husgud_nn_1_N : N ;
  hushaallsgris_nn_1_1_N : N ;
  hushaallsost_nn_1_1_N : N ;
  huskropp_nn_1_N : N ;
  husvagn_nn_1_N : N ;
  hutch_nn_1_N : N ;
  hutt_nn_1_N : N ;
  huv_nn_1_N : N ;
  huvudaxel_nn_1_N : N ;
  huvudnyckel_nn_1_N : N ;
  huvudstol_nn_1_N : N ;
  huvudsvaal_nn_1_1_N : N ;
  huvudtitel_nn_1_N : N ;
  hydrokopter_nn_1_N : N ;
  hygrometer_nn_1_N : N ;
  hylsnyckel_nn_1_N : N ;
  hyperlaenk_nn_1_1_N : N ;
  hypsometer_nn_1_N : N ;
  hyreshaj_nn_1_N : N ;
  hyresvaerd_nn_1_1_N : N ;
  hyvel_nn_1_N : N ;
  hyvelbaenk_nn_1_1_N : N ;
  haeck_nn_1_1_N : N ;
  haeckfaagel_nn_1_1_N : N ;
  haecksax_nn_1_1_N : N ;
  haeger_nn_1_1_N : N ;
  haegg_nn_1_1_N : N ;
  hael_nn_1_1_N : N ;
  haell_nn_1_1_N : N ;
  haelsing_nn_1_1_N : N ;
  haelsobrunn_nn_1_1_N : N ;
  haempling_nn_1_1_N : N ;
  haengbjoerk_nn_1_1_N : N ;
  haengbuk_nn_1_1_N : N ;
  haengdal_nn_1_1_N : N ;
  haer_nn_1_1_N : N ;
  haeradshoevding_nn_1_1_N : N ;
  haerd_nn_1_1_N : N ;
  haerfaagel_nn_1_1_N : N ;
  haerjedaling_nn_1_1_N : N ;
  haerk_nn_1_1_N : N ;
  haermask_nn_1_1_N : N ;
  haermfaagel_nn_1_1_N : N ;
  haervel_nn_1_1_N : N ;
  haest_nn_1_1_N : N ;
  haesthov_nn_1_1_N : N ;
  haestrygg_nn_1_1_N : N ;
  haestskjuts_nn_1_1_N : N ;
  haestsvans_nn_1_1_N : N ;
  haevarm_nn_1_1_N : N ;
  haevarmslyft_nn_1_1_N : N ;
  haevel_nn_1_1_N : N ;
  haevert_nn_1_1_N : N ;
  haevstaangsarm_nn_1_1_N : N ;
  haexkittel_nn_1_1_N : N ;
  haabrand_nn_1_1_N : N ;
  haakaering_nn_1_1_N : N ;
  haalkael_nn_1_1_N : N ;
  haalslev_nn_1_1_N : N ;
  haarddisk_nn_1_1_N : N ;
  haarding_nn_1_1_N : N ;
  haarfoen_nn_1_1_N : N ;
  haarnaal_nn_1_1_N : N ;
  haarpensel_nn_1_1_N : N ;
  haarsaeck_nn_1_1_N : N ;
  haartest_nn_1_1_N : N ;
  haartofs_nn_1_1_N : N ;
  haartork_nn_1_1_N : N ;
  haartuss_nn_1_1_N : N ;
  haav_nn_1_1_N : N ;
  hoeg_nn_1_1_N : N ;
  hoegaffel_nn_1_1_N : N ;
  hoegborg_nn_1_1_N : N ;
  hoegbaenk_nn_1_1_N : N ;
  hoegerarm_nn_1_1_N : N ;
  hoegerflygel_nn_1_1_N : N ;
  hoegergir_nn_1_1_N : N ;
  hoeghastighetstunnel_nn_1_1_N : N ;
  hoegrestaandskrets_nn_1_1_N : N ;
  hoegtryckskabel_nn_1_1_N : N ;
  hoegtrycksrygg_nn_1_1_N : N ;
  hoejdrygg_nn_1_1_N : N ;
  hoek_nn_1_1_N : N ;
  hoensbur_nn_1_1_N : N ;
  hoensfaagel_nn_1_1_N : N ;
  hoensgaard_nn_1_1_N : N ;
  hoerlur_nn_1_1_N : N ;
  hoest_nn_1_1_N : N ;
  hoestack_nn_1_1_N : N ;
  hoeststorm_nn_1_1_N : N ;
  hoesaeck_nn_1_1_N : N ;
  hoetapp_nn_1_1_N : N ;
  hoetork_nn_1_1_N : N ;
  hoevding_nn_1_1_N : N ;
  ibis_nn_1_N : N ;
  ibisfaagel_nn_1_1_N : N ;
  icing_nn_1_N : N ;
  id_nn_1_N : N ;
  idegran_nn_1_N : N ;
  idrottsdag_nn_1_N : N ;
  idrottshall_nn_1_N : N ;
  id_evaerld_nn_1_1_N : N ;
  igel_nn_1_N : N ;
  igelkott_nn_1_N : N ;
  ikosaeder_nn_1_N : N ;
  il_nn_1_N : N ;
  ilex_nn_1_N : N ;
  illbatting_nn_1_N : N ;
  iller_nn_1_N : N ;
  imperialsaeng_nn_1_1_N : N ;
  imposttull_nn_1_N : N ;
  inbrottstjuv_nn_1_N : N ;
  industriminister_nn_1_N : N ;
  industrirobot_nn_1_N : N ;
  industrisemester_nn_1_N : N ;
  infallsvinkel_nn_1_N : N ;
  infektionshaerd_nn_1_1_N : N ;
  inflammationshaerd_nn_1_1_N : N ;
  informationsdisk_nn_1_N : N ;
  infrastrukturminister_nn_1_N : N ;
  infoeding_nn_1_1_N : N ;
  inhamn_nn_1_N : N ;
  inhysing_nn_1_N : N ;
  ink_nn_1_N : N ;
  inklinationsnaal_nn_1_1_N : N ;
  inlandsis_nn_1_N : N ;
  inner_nn_1_N : N ;
  inrikesminister_nn_1_N : N ;
  inseglingsfyr_nn_1_N : N ;
  insektsnaal_nn_1_1_N : N ;
  insektssax_nn_1_N : N ;
  insjoefisk_nn_1_1_N : N ;
  installationskabel_nn_1_N : N ;
  institutionsteater_nn_1_N : N ;
  intelligensaalder_nn_1_1_N : N ;
  internetartikel_nn_1_N : N ;
  invandrarteater_nn_1_N : N ;
  inaelvsmask_nn_1_1_N : N ;
  iris_nn_1_N : N ;
  is_nn_1_N : N ;
  isbill_nn_1_N : N ;
  isboj_nn_1_N : N ;
  isbrodd_nn_1_N : N ;
  isdubb_nn_1_N : N ;
  isfaagel_nn_1_1_N : N ;
  isglass_nn_1_N : N ;
  ishall_nn_1_N : N ;
  islandslav_nn_1_N : N ;
  islandssill_nn_1_N : N ;
  ispigg_nn_1_N : N ;
  ispik_nn_1_N : N ;
  istapp_nn_1_N : N ;
  isterbuk_nn_1_N : N ;
  isvak_nn_1_N : N ;
  jab_nn_1_N : N ;
  jabb_nn_1_N : N ;
  jackpropp_nn_1_N : N ;
  jaggernaut_nn_1_N : N ;
  jak_nn_1_N : N ;
  jaktfalk_nn_1_N : N ;
  jakthund_nn_1_N : N ;
  jaktrobot_nn_1_N : N ;
  jaktspindel_nn_1_N : N ;
  jan_nn_1_N : N ;
  jarl_nn_1_N : N ;
  jaspis_nn_1_N : N ;
  jazzlaat_nn_1_1_N : N ;
  jazzorkester_nn_1_N : N ;
  jeep_nn_1_N : N ;
  jig_nn_1_N : N ;
  jigg_nn_1_N : N ;
  jobbarkompis_nn_1_N : N ;
  jojk_nn_1_N : N ;
  joker_nn_1_N : N ;
  jokk_nn_1_N : N ;
  jolster_nn_1_N : N ;
  jonflaeck_nn_1_1_N : N ;
  jord_nn_1_N : N ;
  jordabalk_nn_1_N : N ;
  jordborr_nn_1_N : N ;
  jordbruksminister_nn_1_N : N ;
  jorddrott_nn_1_N : N ;
  jordfraes_nn_1_1_N : N ;
  jordgeting_nn_1_N : N ;
  jordgubbsskoerd_nn_1_1_N : N ;
  jordkabel_nn_1_N : N ;
  jordpartikel_nn_1_N : N ;
  jordskredsseger_nn_1_N : N ;
  jordstoet_nn_1_1_N : N ;
  jubeldag_nn_1_N : N ;
  judaskyss_nn_1_N : N ;
  judaspeng_nn_1_N : N ;
  jukebox_nn_1_N : N ;
  jul_nn_1_N : N ;
  julbock_nn_1_N : N ;
  juldag_nn_1_N : N ;
  julgran_nn_1_N : N ;
  julgris_nn_1_N : N ;
  julkaktus_nn_1_N : N ;
  julkalender_nn_1_N : N ;
  julklapp_nn_1_N : N ;
  jullaat_nn_1_1_N : N ;
  julp_nn_1_N : N ;
  jumbojet_nn_1_N : N ;
  jumper_nn_1_N : N ;
  jungfrubur_nn_1_N : N ;
  jungfrufoedsel_nn_1_1_N : N ;
  jungfrusvaerm_nn_1_1_N : N ;
  junker_nn_1_N : N ;
  justitieminister_nn_1_N : N ;
  jaegarbiff_nn_1_1_N : N ;
  jaekel_nn_1_1_N : N ;
  jaemmerdal_nn_1_1_N : N ;
  jaemstaelldhetsbonus_nn_1_1_N : N ;
  jaemthund_nn_1_1_N : N ;
  jaernbalk_nn_1_1_N : N ;
  jaernek_nn_1_1_N : N ;
  jaernekkrans_nn_1_1_N : N ;
  jaernhandel_nn_1_1_N : N ;
  jaernplaat_nn_1_1_N : N ;
  jaernsparv_nn_1_1_N : N ;
  jaernspis_nn_1_1_N : N ;
  jaernvaruhandel_nn_1_1_N : N ;
  jaernvaegsraels_nn_1_1_N : N ;
  jaerv_nn_1_1_N : N ;
  jaestsvamp_nn_1_1_N : N ;
  jaettegalt_nn_1_1_N : N ;
  jaetteskraell_nn_1_1_N : N ;
  jaettespindel_nn_1_1_N : N ;
  jaetteval_nn_1_1_N : N ;
  jaevel_nn_1_1_N : N ;
  jaakk_nn_1_1_N : N ;
  joekel_nn_1_1_N : N ;
  joens_nn_1_1_N : N ;
  k_pist_nn_1_N : N ;
  kabar_eorkester_nn_1_1_N : N ;
  kabel_nn_1_N : N ;
  kabelbrunn_nn_1_N : N ;
  kabinbaat_nn_1_1_N : N ;
  kaffebal_nn_1_N : N ;
  kaffeduk_nn_1_N : N ;
  kaffegoek_nn_1_1_N : N ;
  kaffekask_nn_1_N : N ;
  kaffekittel_nn_1_N : N ;
  kaffekopp_nn_1_N : N ;
  kaffemoster_nn_1_N : N ;
  kaffepetter_nn_1_N : N ;
  kafferbuffel_nn_1_N : N ;
  kaffetaar_nn_1_1_N : N ;
  kaf_evagn_nn_1_1_N : N ;
  kajsvaerm_nn_1_1_N : N ;
  kaktus_nn_1_N : N ;
  kalander_nn_1_N : N ;
  kalender_nn_1_N : N ;
  kalenderstav_nn_1_N : N ;
  kalibertolk_nn_1_N : N ;
  kalk_nn_2_N : N ;
  kalkonsmoergaas_nn_1_1_N : N ;
  kalkugn_nn_1_N : N ;
  kallbaenk_nn_1_1_N : N ;
  kalldusch_nn_1_N : N ;
  kalling_nn_1_N : N ;
  kallmangel_nn_1_N : N ;
  kallnaal_nn_1_1_N : N ;
  kallskaenk_nn_1_1_N : N ;
  kallsup_nn_1_N : N ;
  kalorimeter_nn_1_N : N ;
  kalv_nn_1_N : N ;
  kamaxel_nn_1_N : N ;
  kamelhjord_nn_1_N : N ;
  kamelsadel_nn_1_N : N ;
  kamelsaeck_nn_1_1_N : N ;
  kameravinkel_nn_1_N : N ;
  kammarorkester_nn_1_N : N ;
  kamp_nn_2_N : N ;
  kampkonstkrets_nn_1_N : N ;
  kams_nn_1_N : N ;
  kanariefaagel_nn_1_1_N : N ;
  kandelaber_nn_1_N : N ;
  kanister_nn_1_N : N ;
  kanthyvel_nn_1_N : N ;
  kantnaal_nn_1_1_N : N ;
  kanvasduk_nn_1_N : N ;
  kapp_nn_1_N : N ;
  kapprock_nn_1_N : N ;
  kappseglingsbaat_nn_1_1_N : N ;
  kappsaeck_nn_1_1_N : N ;
  kapsel_nn_1_N : N ;
  karamellpudding_nn_1_N : N ;
  karatstaempel_nn_1_1_N : N ;
  karbunkel_nn_1_N : N ;
  kardanaxel_nn_1_N : N ;
  kardinalbiskop_nn_1_N : N ;
  kardnubb_nn_1_N : N ;
  karljohanssvamp_nn_1_N : N ;
  karlslok_nn_1_N : N ;
  karm_nn_1_N : N ;
  karp_nn_1_N : N ;
  karpfisk_nn_1_N : N ;
  kartnagel_nn_1_N : N ;
  karusellhaest_nn_1_1_N : N ;
  kaschmirsjal_nn_1_N : N ;
  kaserngaard_nn_1_1_N : N ;
  kashmirsjal_nn_1_N : N ;
  kask_nn_1_N : N ;
  kasperteater_nn_1_N : N ;
  kateder_nn_1_N : N ;
  kateter_nn_1_N : N ;
  kattass_nn_1_N : N ;
  kattfisk_nn_1_N : N ;
  kautschuk_nn_1_N : N ;
  kavaljersflygel_nn_1_N : N ;
  kavel_nn_1_N : N ;
  kavring_nn_1_N : N ;
  kedjebroms_nn_1_N : N ;
  kedjevaexel_nn_1_1_N : N ;
  kejsarhaer_nn_1_1_N : N ;
  kelgris_nn_1_N : N ;
  kennel_nn_1_N : N ;
  kenning_nn_1_N : N ;
  keps_nn_1_N : N ;
  kick_nn_1_N : N ;
  kikkran_nn_1_N : N ;
  kil_nn_1_N : N ;
  kilhael_nn_1_1_N : N ;
  kilklack_nn_1_N : N ;
  killing_nn_1_N : N ;
  kilt_nn_1_N : N ;
  kindpuss_nn_1_N : N ;
  kindpust_nn_1_N : N ;
  kink_nn_1_N : N ;
  kip_nn_1_N : N ;
  kis_nn_2_N : N ;
  kissemiss_nn_1_N : N ;
  kittel_nn_1_N : N ;
  kitteldal_nn_1_N : N ;
  kjol_nn_1_N : N ;
  kjortel_nn_1_N : N ;
  klabb_nn_1_N : N ;
  klabbskoet_nn_1_1_N : N ;
  klack_nn_1_N : N ;
  klackstoevel_nn_1_1_N : N ;
  kladd_nn_1_N : N ;
  klaff_nn_1_N : N ;
  klagomur_nn_1_N : N ;
  klamp_nn_1_N : N ;
  klant_nn_1_N : N ;
  klapp_nn_1_N : N ;
  klatsch_nn_1_N : N ;
  klibbal_nn_1_N : N ;
  klick_nn_1_N : N ;
  klimax_nn_1_N : N ;
  klimp_nn_1_N : N ;
  klippdass_nn_1_N : N ;
  klipper_nn_1_N : N ;
  klipperstaev_nn_1_1_N : N ;
  klippfisk_nn_1_N : N ;
  klippfyr_nn_1_N : N ;
  klipping_nn_1_N : N ;
  klippspik_nn_1_N : N ;
  klippvaegg_nn_1_1_N : N ;
  klitoris_nn_1_N : N ;
  klockboj_nn_1_N : N ;
  klockstapel_nn_1_N : N ;
  klockstraeng_nn_1_1_N : N ;
  kloss_nn_1_N : N ;
  klostersyster_nn_1_N : N ;
  klotblixt_nn_1_N : N ;
  klots_nn_1_N : N ;
  klubb_nn_1_N : N ;
  klubbsandwich_nn_1_N : N ;
  kludd_nn_2_N : N ;
  klump_nn_1_N : N ;
  klumpedump_nn_1_N : N ;
  klumpeduns_nn_1_N : N ;
  klumpfisk_nn_1_N : N ;
  klunk_nn_1_N : N ;
  kluns_nn_1_N : N ;
  kluring_nn_1_N : N ;
  klut_nn_1_N : N ;
  klyv_nn_1_N : N ;
  klaedespersedel_nn_1_1_N : N ;
  klaedmal_nn_1_1_N : N ;
  klaedsel_nn_1_1_N : N ;
  klaepp_nn_1_1_N : N ;
  klaett_nn_1_1_N : N ;
  klaetterfaagel_nn_1_1_N : N ;
  kloev_nn_1_1_N : N ;
  kloevjesadel_nn_1_1_N : N ;
  kloevsadel_nn_1_1_N : N ;
  knackvurst_nn_1_N : N ;
  knall_nn_1_N : N ;
  knap_nn_1_N : N ;
  knapp_nn_1_N : N ;
  knarkarkvart_nn_1_N : N ;
  knarr_nn_2_N : N ;
  knast_nn_1_N : N ;
  knatting_nn_1_N : N ;
  knekt_nn_1_N : N ;
  knick_nn_1_N : N ;
  kniv_nn_1_N : N ;
  knivbroms_nn_1_N : N ;
  knivrygg_nn_1_N : N ;
  knivsrygg_nn_1_N : N ;
  knivsudd_nn_1_N : N ;
  knix_nn_1_N : N ;
  knodd_nn_1_N : N ;
  knop_nn_1_N : N ;
  knopp_nn_1_N : N ;
  knorr_nn_1_N : N ;
  knot_nn_1_N : N ;
  knubbsael_nn_1_1_N : N ;
  knuff_nn_1_N : N ;
  knut_nn_1_N : N ;
  knyck_nn_1_N : N ;
  knytblus_nn_1_N : N ;
  knaeck_nn_1_1_N : N ;
  knaeckepil_nn_1_1_N : N ;
  knaehund_nn_1_1_N : N ;
  knaepp_nn_1_1_N : N ;
  knaeskaal_nn_1_1_N : N ;
  knaetofs_nn_1_1_N : N ;
  knaevelborr_nn_1_1_N : N ;
  knaevring_nn_1_1_N : N ;
  knoedel_nn_1_1_N : N ;
  knoel_nn_1_1_N : N ;
  knoelpaak_nn_1_1_N : N ;
  knoelsvan_nn_1_1_N : N ;
  knoes_nn_1_1_N : N ;
  koaxialkabel_nn_1_N : N ;
  kobbel_nn_1_N : N ;
  kock_nn_1_N : N ;
  kodex_nn_1_N : N ;
  koff_nn_1_N : N ;
  koffernagel_nn_1_N : N ;
  koffert_nn_1_N : N ;
  koffertfisk_nn_1_N : N ;
  kogg_nn_1_N : N ;
  kohud_nn_1_N : N ;
  kokalv_nn_1_N : N ;
  kokbarometer_nn_1_N : N ;
  kokgrop_nn_1_N : N ;
  kokvagn_nn_1_N : N ;
  kolbox_nn_1_N : N ;
  kolerakyrkogaard_nn_1_1_N : N ;
  koling_nn_1_N : N ;
  koll_nn_1_N : N ;
  kolryss_nn_1_N : N ;
  kolt_nn_1_N : N ;
  koltrast_nn_1_N : N ;
  kolumntitel_nn_1_N : N ;
  kolv_nn_1_N : N ;
  kolvhals_nn_1_N : N ;
  komissmantel_nn_1_N : N ;
  komminister_nn_1_N : N ;
  kommunikationsminister_nn_1_N : N ;
  kompassnaal_nn_1_1_N : N ;
  kompis_nn_1_N : N ;
  komplementvinkel_nn_1_N : N ;
  koncentrationsdag_nn_1_N : N ;
  konfektskaal_nn_1_1_N : N ;
  konfirmationsbibel_nn_1_N : N ;
  konjakskrans_nn_1_N : N ;
  konprick_nn_1_N : N ;
  konstapel_nn_1_N : N ;
  konsthall_nn_1_N : N ;
  konstnaerskrets_nn_1_1_N : N ;
  konstnaerssjael_nn_1_1_N : N ;
  kontinentalsockel_nn_1_N : N ;
  kontorsslav_nn_1_N : N ;
  kontraalt_nn_1_N : N ;
  kontrabas_nn_1_N : N ;
  kontraktsprost_nn_1_N : N ;
  kontrollstaempel_nn_1_1_N : N ;
  konventikel_nn_1_N : N ;
  konverter_nn_1_N : N ;
  koordinataxel_nn_1_N : N ;
  kopiesvarv_nn_1_N : N ;
  kopp_nn_1_N : N ;
  kopparorm_nn_1_N : N ;
  kopparplaat_nn_1_1_N : N ;
  korallorm_nn_1_N : N ;
  korg_nn_1_N : N ;
  kork_nn_1_N : N ;
  korkek_nn_1_N : N ;
  korkskruv_nn_1_N : N ;
  kornblixt_nn_1_N : N ;
  kornbod_nn_1_N : N ;
  kornknarr_nn_1_N : N ;
  kornaaker_nn_1_1_N : N ;
  korp_nn_1_N : N ;
  korsettfjaeder_nn_1_1_N : N ;
  korsnaebb_nn_1_1_N : N ;
  korsrygg_nn_1_N : N ;
  korsspindel_nn_1_N : N ;
  korsvimpel_nn_1_N : N ;
  korv_nn_1_N : N ;
  korvmoj_nn_1_N : N ;
  korvsmoergaas_nn_1_1_N : N ;
  koster_nn_1_N : N ;
  kosvans_nn_1_N : N ;
  kotlettfisk_nn_1_N : N ;
  kpist_nn_1_N : N ;
  kraftkarl_nn_1_N : N ;
  kraftmejsel_nn_1_N : N ;
  kraftpartikel_nn_1_N : N ;
  kragsnibb_nn_1_N : N ;
  kragstoevel_nn_1_1_N : N ;
  krakmandel_nn_1_N : N ;
  kram_nn_1_N : N ;
  kramsfaagel_nn_1_1_N : N ;
  kran_nn_1_N : N ;
  kranbalk_nn_1_N : N ;
  krankik_nn_1_N : N ;
  krans_nn_1_N : N ;
  krater_nn_1_N : N ;
  krats_nn_1_N : N ;
  krets_nn_1_N : N ;
  krevadblixt_nn_1_N : N ;
  krigsbuss_nn_1_N : N ;
  kris_nn_2_N : N ;
  kristallaxel_nn_1_N : N ;
  kristallskaal_nn_1_1_N : N ;
  kristtorn_nn_1_N : N ;
  kritikstorm_nn_1_N : N ;
  krock_nn_1_N : N ;
  krog_nn_1_N : N ;
  krok_nn_1_N : N ;
  kroksabel_nn_1_N : N ;
  krokus_nn_1_N : N ;
  kronbrud_nn_1_N : N ;
  kronhjort_nn_1_N : N ;
  kronhaest_nn_1_1_N : N ;
  kronmutter_nn_1_N : N ;
  kronojord_nn_1_N : N ;
  kronometer_nn_1_N : N ;
  kronprins_nn_1_N : N ;
  kroppaas_nn_1_1_N : N ;
  kross_nn_1_N : N ;
  krumstav_nn_1_N : N ;
  krustaatel_nn_1_1_N : N ;
  krutdurk_nn_1_N : N ;
  krympling_nn_1_N : N ;
  krypskytt_nn_1_N : N ;
  kryssmejsel_nn_1_N : N ;
  kryssningsrobot_nn_1_N : N ;
  kraeftbur_nn_1_1_N : N ;
  kraeklatjuv_nn_1_1_N : N ;
  kraakfaagel_nn_1_1_N : N ;
  kraasnaal_nn_1_1_N : N ;
  kroek_nn_1_1_N : N ;
  kroesus_nn_1_1_N : N ;
  kubb_nn_1_N : N ;
  kuf_nn_1_N : N ;
  kuggvaexel_nn_1_1_N : N ;
  kuk_nn_1_N : N ;
  kuling_nn_1_N : N ;
  kulkvarn_nn_1_N : N ;
  kull_nn_1_N : N ;
  kult_nn_2_N : N ;
  kulting_nn_1_N : N ;
  kulturartikel_nn_1_N : N ;
  kulturkrets_nn_1_N : N ;
  kulvert_nn_1_N : N ;
  kundkrets_nn_1_N : N ;
  kundvagn_nn_1_N : N ;
  kungatitel_nn_1_N : N ;
  kungsfaagel_nn_1_1_N : N ;
  kungshoeg_nn_1_1_N : N ;
  kungstiger_nn_1_N : N ;
  kur_nn_2_N : N ;
  kusk_nn_1_N : N ;
  kuskbock_nn_1_N : N ;
  kustfisk_nn_1_N : N ;
  kut_nn_1_N : N ;
  kutter_nn_2_N : N ;
  kutting_nn_1_N : N ;
  kvader_nn_1_N : N ;
  kvark_nn_1_N : N ;
  kvarkklimp_nn_1_N : N ;
  kvarn_nn_1_N : N ;
  kvart_nn_3_N : N ;
  kvarting_nn_1_N : N ;
  kvass_nn_1_N : N ;
  kvast_nn_1_N : N ;
  kvastfening_nn_1_N : N ;
  kvastprick_nn_1_N : N ;
  kvigkalv_nn_1_N : N ;
  kvist_nn_1_N : N ;
  kvaell_nn_1_1_N : N ;
  kyckling_nn_1_N : N ;
  kyl_nn_1_N : N ;
  kylbox_nn_1_N : N ;
  kyldisk_nn_1_N : N ;
  kylklamp_nn_1_N : N ;
  kyp_nn_1_N : N ;
  kypert_nn_1_N : N ;
  kyrkbibel_nn_1_N : N ;
  kyrkbaenk_nn_1_1_N : N ;
  kyrkobibel_nn_1_N : N ;
  kyrkogaard_nn_1_1_N : N ;
  kyrkstoet_nn_1_1_N : N ;
  kyrktupp_nn_1_N : N ;
  kyrkvaerd_nn_1_1_N : N ;
  kyss_nn_1_N : N ;
  kaeft_nn_1_1_N : N ;
  kaegel_nn_1_1_N : N ;
  kael_nn_1_1_N : N ;
  kaellarhals_nn_1_1_N : N ;
  kaelling_nn_1_1_N : N ;
  kaempagrav_nn_1_1_N : N ;
  kaempalek_nn_1_1_N : N ;
  kaendis_nn_1_1_N : N ;
  kaengurupung_nn_1_1_N : N ;
  kaenning_nn_1_1_N : N ;
  kaenslostraeng_nn_1_1_N : N ;
  kaepp_nn_1_1_N : N ;
  kaepphaest_nn_1_1_N : N ;
  kaering_nn_1_1_N : N ;
  kaeringknop_nn_1_1_N : N ;
  kaerlekstunnel_nn_1_1_N : N ;
  kaernpartikel_nn_1_1_N : N ;
  kaernstridsspets_nn_1_1_N : N ;
  kaerrhoek_nn_1_1_N : N ;
  kaerring_nn_1_1_N : N ;
  kaetting_nn_1_1_N : N ;
  kaettingdiameter_nn_1_1_N : N ;
  kaak_nn_1_1_N : N ;
  kaallapp_nn_1_1_N : N ;
  kaalmask_nn_1_1_N : N ;
  kaarpamp_nn_1_1_N : N ;
  koeckenmoedding_nn_1_1_N : N ;
  koekkenmoedding_nn_1_1_N : N ;
  koekshandduk_nn_1_1_N : N ;
  koekssax_nn_1_1_N : N ;
  koeksspis_nn_1_1_N : N ;
  koel_nn_1_1_N : N ;
  koeldknaepp_nn_1_1_N : N ;
  koenskoertel_nn_1_1_N : N ;
  koeping_nn_1_1_N : N ;
  koerkarl_nn_1_1_N : N ;
  koertel_nn_1_1_N : N ;
  koettbullssmoergaas_nn_1_1_N : N ;
  lab_nn_1_N : N ;
  labb_nn_1_N : N ;
  laboratorierock_nn_1_N : N ;
  lackpensel_nn_1_N : N ;
  lag_nn_1_N : N ;
  lagbalk_nn_1_N : N ;
  lager_nn_2_N : N ;
  lagerbox_nn_1_N : N ;
  lagerkrans_nn_1_N : N ;
  lagg_nn_1_N : N ;
  lagkarl_nn_1_N : N ;
  lakansspets_nn_1_N : N ;
  lammsadel_nn_1_N : N ;
  lampskaerm_nn_1_1_N : N ;
  landborg_nn_1_N : N ;
  landis_nn_1_N : N ;
  landnot_nn_1_N : N ;
  landrygg_nn_1_N : N ;
  landshoevding_nn_1_1_N : N ;
  landsknekt_nn_1_N : N ;
  landsvaegsbuss_nn_1_1_N : N ;
  landvad_nn_1_N : N ;
  langos_nn_1_N : N ;
  lans_nn_1_N : N ;
  lansettfisk_nn_1_N : N ;
  lantdag_nn_1_N : N ;
  lanthandel_nn_1_N : N ;
  lantis_nn_1_N : N ;
  lantmarskalk_nn_1_N : N ;
  lantrasgris_nn_1_N : N ;
  lapp_nn_1_N : N ;
  lapphund_nn_1_N : N ;
  lapplandsgran_nn_1_N : N ;
  lappsparv_nn_1_N : N ;
  lapsus_nn_1_N : N ;
  larver_nn_1_N : N ;
  laser_nn_1_N : N ;
  lask_nn_1_N : N ;
  lastpall_nn_1_N : N ;
  lathund_nn_1_N : N ;
  latmask_nn_1_N : N ;
  lav_nn_1_N : N ;
  lavendeltvaal_nn_1_1_N : N ;
  lavinhund_nn_1_N : N ;
  lax_nn_1_N : N ;
  laxfisk_nn_1_N : N ;
  laxgaard_nn_1_1_N : N ;
  laxstjaert_nn_1_1_N : N ;
  laxoering_nn_1_1_N : N ;
  leasing_nn_1_N : N ;
  ledarhund_nn_1_N : N ;
  ledfyr_nn_1_N : N ;
  ledkapsel_nn_1_N : N ;
  ledskaal_nn_1_1_N : N ;
  legoknekt_nn_1_N : N ;
  lejd_nn_1_N : N ;
  lejdbaat_nn_1_1_N : N ;
  lejongrop_nn_1_N : N ;
  lek_nn_1_N : N ;
  lekfisk_nn_1_N : N ;
  leksakshaest_nn_1_1_N : N ;
  lercylinder_nn_1_N : N ;
  lergoek_nn_1_1_N : N ;
  lerhaerd_nn_1_1_N : N ;
  lerjord_nn_1_N : N ;
  lerskiffer_nn_1_N : N ;
  leraaker_nn_1_1_N : N ;
  lev_nn_1_N : N ;
  lever_nn_1_N : N ;
  leverflaeck_nn_1_1_N : N ;
  leverpastejsmoergaas_nn_1_1_N : N ;
  levnadsaalder_nn_1_1_N : N ;
  lieknagg_nn_1_N : N ;
  liggvagn_nn_1_N : N ;
  liguster_nn_1_N : N ;
  likflaeck_nn_1_1_N : N ;
  liksvamp_nn_1_N : N ;
  liktorn_nn_1_N : N ;
  lillasyster_nn_1_N : N ;
  lillaxel_nn_1_N : N ;
  lillfinger_nn_1_N : N ;
  lillfingertopp_nn_1_N : N ;
  lillsemester_nn_1_N : N ;
  limerick_nn_1_N : N ;
  limgoerdel_nn_1_1_N : N ;
  lind_nn_1_N : N ;
  lindorm_nn_1_N : N ;
  linlugg_nn_1_N : N ;
  linsdiameter_nn_1_N : N ;
  lintott_nn_1_N : N ;
  linaaker_nn_1_1_N : N ;
  lipsill_nn_1_N : N ;
  liter_nn_2_N : N ;
  livboj_nn_1_N : N ;
  livbaat_nn_1_1_N : N ;
  livmoderhals_nn_1_N : N ;
  livslust_nn_1_N : N ;
  ljudbang_nn_1_N : N ;
  ljudboj_nn_1_N : N ;
  ljugarbaenk_nn_1_1_N : N ;
  ljusblixt_nn_1_N : N ;
  ljusbrunn_nn_1_N : N ;
  ljusglimt_nn_1_N : N ;
  ljusgaard_nn_1_1_N : N ;
  ljuskrans_nn_1_N : N ;
  ljuskrets_nn_1_N : N ;
  ljusorgel_nn_1_N : N ;
  ljuspartikel_nn_1_N : N ;
  ljusrektangel_nn_1_N : N ;
  lobb_nn_1_N : N ;
  lock_nn_1_N : N ;
  lockfaagel_nn_1_1_N : N ;
  lodenrock_nn_1_N : N ;
  lodis_nn_1_N : N ;
  loftbod_nn_1_N : N ;
  logg_nn_1_N : N ;
  loggert_nn_1_N : N ;
  look_nn_1_N : N ;
  loop_nn_1_N : N ;
  looping_nn_1_N : N ;
  loppcirkus_nn_1_N : N ;
  loppis_nn_1_N : N ;
  lort_nn_1_N : N ;
  lots_nn_1_N : N ;
  lottsedel_nn_1_N : N ;
  lotus_nn_1_N : N ;
  lov_nn_1_N : N ;
  lubb_nn_1_N : N ;
  luciakrans_nn_1_N : N ;
  luftgrop_nn_1_N : N ;
  luftpropeller_nn_1_N : N ;
  luftsluss_nn_1_N : N ;
  luftspaerr_nn_1_1_N : N ;
  luftsaeck_nn_1_1_N : N ;
  luftvaernsrobot_nn_1_1_N : N ;
  lugg_nn_1_N : N ;
  lumparkompis_nn_1_N : N ;
  lumpfisk_nn_1_N : N ;
  lungfisk_nn_1_N : N ;
  lungsaeck_nn_1_1_N : N ;
  lunnefaagel_nn_1_1_N : N ;
  luns_nn_1_N : N ;
  lur_nn_1_N : N ;
  lurifax_nn_1_N : N ;
  lurk_nn_1_N : N ;
  luskung_nn_1_N : N ;
  luspudel_nn_1_N : N ;
  lust_nn_1_N : N ;
  lustgaard_nn_1_1_N : N ;
  lut_nn_1_N : N ;
  lutfisk_nn_1_N : N ;
  luv_nn_1_N : N ;
  luxmeter_nn_1_N : N ;
  lyckoslant_nn_1_N : N ;
  lycktraeff_nn_1_1_N : N ;
  lydkonung_nn_1_N : N ;
  lydkung_nn_1_N : N ;
  lyftkran_nn_1_N : N ;
  lyftsax_nn_1_N : N ;
  lymfkoertel_nn_1_1_N : N ;
  lyrfaagel_nn_1_1_N : N ;
  lyrtorsk_nn_1_N : N ;
  lysboj_nn_1_N : N ;
  lysmask_nn_1_N : N ;
  lyxartikel_nn_1_N : N ;
  lyxsmoergaas_nn_1_1_N : N ;
  langos_nn_1_1_N : N ;
  laederlapp_nn_1_1_N : N ;
  laegel_nn_1_1_N : N ;
  laegerboedel_nn_1_1_N : N ;
  laegg_nn_2_1_N : N ;
  laekarrock_nn_1_1_N : N ;
  laengdaxel_nn_1_1_N : N ;
  laengsdal_nn_1_1_N : N ;
  laenk_nn_1_1_N : N ;
  laens_nn_1_1_N : N ;
  laepp_nn_1_1_N : N ;
  laerk_nn_1_1_N : N ;
  laerkfalk_nn_1_1_N : N ;
  laerostol_nn_1_1_N : N ;
  laerpeng_nn_1_1_N : N ;
  laesarstorm_nn_1_1_N : N ;
  laesdag_nn_1_1_N : N ;
  laesecirkel_nn_1_1_N : N ;
  laesekrets_nn_1_1_N : N ;
  laettgrogg_nn_1_1_N : N ;
  laetting_nn_1_1_N : N ;
  laettjord_nn_1_1_N : N ;
  laettkloev_nn_1_1_N : N ;
  laettviktsmotorcykel_nn_1_1_N : N ;
  laadspik_nn_1_1_N : N ;
  laagsniff_nn_1_1_N : N ;
  laangduk_nn_1_1_N : N ;
  laangfinger_nn_1_1_N : N ;
  laangfredag_nn_1_1_N : N ;
  laangfaerdsbuss_nn_1_1_N : N ;
  laanggrogg_nn_1_1_N : N ;
  laangnaebb_nn_1_1_N : N ;
  laangrev_nn_1_1_N : N ;
  laangschal_nn_1_1_N : N ;
  laangsjal_nn_1_1_N : N ;
  laar_nn_2_1_N : N ;
  laarbenshals_nn_1_1_N : N ;
  laarding_nn_1_1_N : N ;
  laaring_nn_1_1_N : N ;
  laaskolv_nn_1_1_N : N ;
  laasmutter_nn_1_1_N : N ;
  laassprint_nn_1_1_N : N ;
  laat_nn_1_1_N : N ;
  loedfog_nn_1_1_N : N ;
  loedkolv_nn_1_1_N : N ;
  loegnhals_nn_1_1_N : N ;
  loek_nn_1_1_N : N ;
  loekknopp_nn_1_1_N : N ;
  loenn_nn_1_1_N : N ;
  loepeost_nn_1_1_N : N ;
  loepgrav_nn_1_1_N : N ;
  loepost_nn_1_1_N : N ;
  loepsedel_nn_1_1_N : N ;
  loepvagn_nn_1_1_N : N ;
  loerdageftermiddag_nn_1_1_N : N ;
  loerdagkvaell_nn_1_1_N : N ;
  loerdagseftermiddag_nn_1_1_N : N ;
  loerdagskvaell_nn_1_1_N : N ;
  loesenpenning_nn_1_1_N : N ;
  loesenskilling_nn_1_1_N : N ;
  loesepenning_nn_1_1_N : N ;
  loeseskilling_nn_1_1_N : N ;
  loeshaest_nn_1_1_N : N ;
  loeskekarl_nn_1_1_N : N ;
  loeskerkarl_nn_1_1_N : N ;
  loesrygg_nn_1_1_N : N ;
  loessjord_nn_1_1_N : N ;
  loesoegonfrans_nn_1_1_N : N ;
  loet_nn_1_1_N : N ;
  loevbiff_nn_1_1_N : N ;
  loevblaas_nn_1_1_N : N ;
  loevjord_nn_1_1_N : N ;
  loevmask_nn_1_1_N : N ;
  loevsmyg_nn_1_1_N : N ;
  mack_nn_1_N : N ;
  maffiaboss_nn_1_N : N ;
  maggoerdel_nn_1_1_N : N ;
  magister_nn_1_N : N ;
  maglev_nn_1_N : N ;
  magnetnaal_nn_1_1_N : N ;
  majbrud_nn_1_N : N ;
  majsgroet_nn_1_1_N : N ;
  majskolv_nn_1_N : N ;
  makrill_nn_1_N : N ;
  maktkrets_nn_1_N : N ;
  mal_nn_1_N : N ;
  mall_nn_1_N : N ;
  malm_nn_1_N : N ;
  malmkropp_nn_1_N : N ;
  malmkross_nn_1_N : N ;
  malmkoertel_nn_1_1_N : N ;
  malteserhund_nn_1_N : N ;
  mammonstrael_nn_1_1_N : N ;
  mammut_nn_1_N : N ;
  man_nn_2_N : N ;
  mandel_nn_1_N : N ;
  mandelpotatis_nn_1_N : N ;
  mangel_nn_1_N : N ;
  mannagrynsgroet_nn_1_1_N : N ;
  mannalav_nn_1_N : N ;
  mannaaalder_nn_1_1_N : N ;
  manometer_nn_1_N : N ;
  mansgris_nn_1_N : N ;
  mansaalder_nn_1_1_N : N ;
  mantel_nn_1_N : N ;
  mapp_nn_1_N : N ;
  marinminister_nn_1_N : N ;
  marionetteater_nn_1_N : N ;
  marskalk_nn_1_N : N ;
  marskalkstav_nn_1_N : N ;
  martall_nn_1_N : N ;
  marulk_nn_1_N : N ;
  mas_nn_1_N : N ;
  maser_nn_1_N : N ;
  mask_nn_1_N : N ;
  maskinhall_nn_1_N : N ;
  maskinpress_nn_1_N : N ;
  master_nn_1_N : N ;
  mastfisk_nn_1_N : N ;
  mastkorg_nn_1_N : N ;
  masugn_nn_1_N : N ;
  masurbjoerk_nn_1_1_N : N ;
  matarbuss_nn_1_N : N ;
  matbit_nn_1_N : N ;
  matjessill_nn_1_N : N ;
  matjord_nn_1_N : N ;
  matpotatis_nn_1_N : N ;
  matrikel_nn_1_N : N ;
  matsedel_nn_1_N : N ;
  matsvamp_nn_1_N : N ;
  matsaeck_nn_1_1_N : N ;
  matsaeckssmoergaas_nn_1_1_N : N ;
  matvaruhall_nn_1_N : N ;
  maximitermometer_nn_1_N : N ;
  meander_nn_1_N : N ;
  medbrottsling_nn_1_N : N ;
  medeldistansrobot_nn_1_N : N ;
  medelaalder_nn_1_1_N : N ;
  medicinreporter_nn_1_N : N ;
  mediecirkus_nn_1_N : N ;
  medlemstapp_nn_1_N : N ;
  medsyster_nn_1_N : N ;
  medvurst_nn_1_N : N ;
  megaskraell_nn_1_1_N : N ;
  mejlbox_nn_1_N : N ;
  mejsel_nn_1_N : N ;
  mellankropp_nn_1_N : N ;
  mellanspett_nn_1_N : N ;
  mellanvaerd_nn_1_1_N : N ;
  mentometer_nn_1_N : N ;
  mercedes_nn_1_N : N ;
  meridiancirkel_nn_1_N : N ;
  mes_nn_1_N : N ;
  mesfaagel_nn_1_1_N : N ;
  mesost_nn_1_N : N ;
  metallhandel_nn_1_N : N ;
  metallsvarv_nn_1_N : N ;
  meteorkrater_nn_1_N : N ;
  meter_nn_2_N : N ;
  meterstav_nn_1_N : N ;
  metmask_nn_1_N : N ;
  metrev_nn_1_N : N ;
  metvurst_nn_1_N : N ;
  mick_nn_1_N : N ;
  mickel_nn_1_N : N ;
  microvaagsugn_nn_1_1_N : N ;
  middagslur_nn_1_N : N ;
  midfastosoendag_nn_1_1_N : N ;
  midnattssol_nn_1_N : N ;
  midsommardag_nn_1_N : N ;
  midvinter_nn_1_N : N ;
  migrationsminister_nn_1_N : N ;
  mikrometer_nn_1_N : N ;
  mikrovaagsugn_nn_1_1_N : N ;
  militaerorkester_nn_1_1_N : N ;
  miljoebov_nn_1_1_N : N ;
  miljoeminister_nn_1_1_N : N ;
  miljoeskurk_nn_1_1_N : N ;
  minigran_nn_1_N : N ;
  minimitermometer_nn_1_N : N ;
  minister_nn_1_N : N ;
  ministerbaenk_nn_1_1_N : N ;
  mink_nn_1_N : N ;
  minnesbuss_nn_1_N : N ;
  minneslund_nn_1_N : N ;
  minsting_nn_1_N : N ;
  mispel_nn_1_N : N ;
  miss_nn_1_N : N ;
  missgaerningsbalk_nn_1_1_N : N ;
  missionsbokhandel_nn_1_N : N ;
  mistel_nn_1_N : N ;
  mistlur_nn_1_N : N ;
  mjukis_nn_1_N : N ;
  mjukost_nn_1_N : N ;
  mjoelkhink_nn_1_1_N : N ;
  mjoelkkoertel_nn_1_1_N : N ;
  mjoelkspegel_nn_1_1_N : N ;
  mjoelskivling_nn_1_1_N : N ;
  mockakopp_nn_1_N : N ;
  mockasked_nn_1_N : N ;
  moderlut_nn_1_N : N ;
  modersfamn_nn_1_N : N ;
  moj_nn_2_N : N ;
  molnbank_nn_1_N : N ;
  molntapp_nn_1_N : N ;
  molohamn_nn_1_N : N ;
  momentnyckel_nn_1_N : N ;
  mongolflaeck_nn_1_1_N : N ;
  monstersvamp_nn_1_N : N ;
  mopp_nn_1_N : N ;
  mops_nn_1_N : N ;
  mordaengel_nn_1_1_N : N ;
  morfoeraelder_nn_1_1_N : N ;
  morgondag_nn_1_N : N ;
  morgonrock_nn_1_N : N ;
  moringsboj_nn_1_N : N ;
  morsefyr_nn_1_N : N ;
  morsgris_nn_1_N : N ;
  mortel_nn_1_N : N ;
  moster_nn_1_N : N ;
  motionscykel_nn_1_N : N ;
  motivkrets_nn_1_N : N ;
  motorcykel_nn_1_N : N ;
  motorcylinder_nn_1_N : N ;
  motortorpedbaat_nn_1_1_N : N ;
  motorvagn_nn_1_N : N ;
  motorvaermarkabel_nn_1_1_N : N ;
  motstoet_nn_1_1_N : N ;
  mudd_nn_1_N : N ;
  muff_nn_1_N : N ;
  muffel_nn_1_N : N ;
  muffelugn_nn_1_N : N ;
  mugg_nn_1_N : N ;
  mullbaenk_nn_1_1_N : N ;
  mullsork_nn_1_N : N ;
  mumrik_nn_1_N : N ;
  munk_nn_1_N : N ;
  munkavel_nn_1_N : N ;
  munkorg_nn_1_N : N ;
  munsbit_nn_1_N : N ;
  muntergoek_nn_1_1_N : N ;
  munvinkel_nn_1_N : N ;
  mupp_nn_1_N : N ;
  mur_nn_1_N : N ;
  murfog_nn_1_N : N ;
  murmel_nn_1_N : N ;
  murslev_nn_1_N : N ;
  murvel_nn_1_N : N ;
  mus_nn_2_N : N ;
  museimonter_nn_1_N : N ;
  muskoetgaffel_nn_1_1_N : N ;
  mutkolv_nn_1_N : N ;
  mutsedel_nn_1_N : N ;
  mutter_nn_1_N : N ;
  myling_nn_1_N : N ;
  myndighetsaalder_nn_1_1_N : N ;
  myndling_nn_1_N : N ;
  mynningsarm_nn_1_N : N ;
  mynningsbroms_nn_1_N : N ;
  myr_nn_1_N : N ;
  myrdrottning_nn_1_N : N ;
  myrkott_nn_1_N : N ;
  myrslok_nn_1_N : N ;
  myrspov_nn_1_N : N ;
  myrstack_nn_1_N : N ;
  myskhjort_nn_1_N : N ;
  myskoxkalv_nn_1_N : N ;
  maenniskohaj_nn_1_1_N : N ;
  maenniskohamn_nn_1_1_N : N ;
  maenniskokropp_nn_1_1_N : N ;
  maergelgrav_nn_1_1_N : N ;
  maergelskiffer_nn_1_1_N : N ;
  maergflaeck_nn_1_1_N : N ;
  maerkduk_nn_1_1_N : N ;
  maerr_nn_1_1_N : N ;
  maers_nn_1_1_N : N ;
  maess_nn_1_1_N : N ;
  maessingsspik_nn_1_1_N : N ;
  maesskrud_nn_1_1_N : N ;
  maesterlots_nn_1_1_N : N ;
  maesterskapstitel_nn_1_1_N : N ;
  maag_nn_1_1_N : N ;
  maalarduk_nn_1_1_N : N ;
  maalarkludd_nn_1_1_N : N ;
  maalarrock_nn_1_1_N : N ;
  maalbur_nn_1_1_N : N ;
  maalgaard_nn_1_1_N : N ;
  maalskytt_nn_1_1_N : N ;
  maandageftermiddag_nn_1_1_N : N ;
  maandagkvaell_nn_1_1_N : N ;
  maandagseftermiddag_nn_1_1_N : N ;
  maandagskvaell_nn_1_1_N : N ;
  maangfaldsbarometer_nn_1_1_N : N ;
  maangfoting_nn_1_1_N : N ;
  maangaard_nn_1_1_N : N ;
  maankalender_nn_1_1_N : N ;
  maankrater_nn_1_1_N : N ;
  maard_nn_1_1_N : N ;
  maas_nn_1_1_N : N ;
  maasfaagel_nn_1_1_N : N ;
  moebelbuss_nn_1_1_N : N ;
  moebelklaedsel_nn_1_1_N : N ;
  moebelspik_nn_1_1_N : N ;
  moebeltass_nn_1_1_N : N ;
  moebelvinkel_nn_1_1_N : N ;
  moegelost_nn_1_1_N : N ;
  moegelsvamp_nn_1_1_N : N ;
  moenstergaard_nn_1_1_N : N ;
  moerdarhund_nn_1_1_N : N ;
  moerdarsnigel_nn_1_1_N : N ;
  moerk_nn_1_1_N : N ;
  moert_nn_1_1_N : N ;
  nackman_nn_1_N : N ;
  nackspaerr_nn_1_1_N : N ;
  nacktofs_nn_1_N : N ;
  nagel_nn_1_N : N ;
  nagelbaedd_nn_1_1_N : N ;
  nagelbaenk_nn_1_1_N : N ;
  nagelsax_nn_1_N : N ;
  nagelspets_nn_1_N : N ;
  nagg_nn_1_N : N ;
  namnplaat_nn_1_1_N : N ;
  namnsdag_nn_1_N : N ;
  namnsedel_nn_1_N : N ;
  namnstandert_nn_1_N : N ;
  namnstaempel_nn_1_1_N : N ;
  nanobot_nn_1_N : N ;
  nanopartikel_nn_1_N : N ;
  napp_nn_2_N : N ;
  nar_nn_1_N : N ;
  narkotikahaj_nn_1_N : N ;
  narkotikarotel_nn_1_N : N ;
  narr_nn_1_N : N ;
  narrspegel_nn_1_N : N ;
  nationaldag_nn_1_N : N ;
  nationalitetsmatrikel_nn_1_N : N ;
  nationalteater_nn_1_N : N ;
  natronlut_nn_1_N : N ;
  nattfaagel_nn_1_1_N : N ;
  natthamn_nn_1_N : N ;
  nattis_nn_1_N : N ;
  nattklubb_nn_1_N : N ;
  nattsmyg_nn_1_N : N ;
  nattstol_nn_1_N : N ;
  nattsyster_nn_1_N : N ;
  nattsaeck_nn_1_1_N : N ;
  nattvardskalk_nn_1_N : N ;
  naturhamn_nn_1_N : N ;
  navarborr_nn_1_N : N ;
  navel_nn_1_N : N ;
  navelflaeck_nn_1_1_N : N ;
  navkapsel_nn_1_N : N ;
  nedslagskrater_nn_1_N : N ;
  nerslagskrater_nn_1_N : N ;
  nervstump_nn_1_N : N ;
  neutrinopartikel_nn_1_N : N ;
  newfoundlandshund_nn_1_N : N ;
  nick_nn_1_N : N ;
  niding_nn_1_N : N ;
  nimrod_nn_1_N : N ;
  niotumsspik_nn_1_N : N ;
  nippel_nn_1_N : N ;
  nit_nn_2_N : N ;
  nitnagel_nn_1_N : N ;
  nitstamp_nn_1_N : N ;
  nitstans_nn_1_N : N ;
  nobb_nn_1_N : N ;
  nock_nn_1_N : N ;
  nollcirkel_nn_1_N : N ;
  nopp_nn_1_N : N ;
  nordsvensk_nn_1_N : N ;
  norrgoek_nn_1_1_N : N ;
  norrkvint_nn_1_N : N ;
  norrlandshaest_nn_1_1_N : N ;
  nors_nn_1_N : N ;
  nos_nn_1_N : N ;
  noshoerningsbebis_nn_1_1_N : N ;
  noskorg_nn_1_N : N ;
  nosspets_nn_1_N : N ;
  not_nn_2_N : N ;
  novemberkvaell_nn_1_1_N : N ;
  nubb_nn_1_N : N ;
  nudel_nn_1_N : N ;
  nudelwok_nn_1_N : N ;
  nummerhaest_nn_1_1_N : N ;
  nummerplaat_nn_1_1_N : N ;
  nyckel_nn_1_N : N ;
  nyhetsreporter_nn_1_N : N ;
  nying_nn_1_N : N ;
  naebbknoel_nn_1_1_N : N ;
  naebbval_nn_1_1_N : N ;
  naektergal_nn_1_1_N : N ;
  naeringsminister_nn_1_1_N : N ;
  naerking_nn_1_1_N : N ;
  naesduk_nn_1_1_N : N ;
  naesknaepp_nn_1_1_N : N ;
  naesrygg_nn_1_1_N : N ;
  naesspets_nn_1_1_N : N ;
  naestipp_nn_1_1_N : N ;
  naetartikel_nn_1_1_N : N ;
  naetbur_nn_1_1_N : N ;
  naetsax_nn_1_1_N : N ;
  naettelduk_nn_1_1_N : N ;
  naetting_nn_1_1_N : N ;
  naever_nn_1_1_N : N ;
  naad_nn_2_1_N : N ;
  naal_nn_1_1_N : N ;
  naalpeng_nn_1_1_N : N ;
  naalspets_nn_1_1_N : N ;
  naat_nn_1_1_N : N ;
  noedbroms_nn_1_1_N : N ;
  noedhamn_nn_1_1_N : N ;
  noedvaendighetsartikel_nn_1_1_N : N ;
  noejeshall_nn_1_1_N : N ;
  noerd_nn_1_1_N : N ;
  noetvivel_nn_1_1_N : N ;
  odugling_nn_1_N : N ;
  officersmaess_nn_1_1_N : N ;
  ograesfisk_nn_1_1_N : N ;
  oktaeder_nn_1_N : N ;
  okynneshund_nn_1_N : N ;
  oleander_nn_1_N : N ;
  olivkvist_nn_1_N : N ;
  oljebrunn_nn_1_N : N ;
  oljerock_nn_1_N : N ;
  oljeskiffer_nn_1_N : N ;
  oljesump_nn_1_N : N ;
  oljevaev_nn_1_1_N : N ;
  ollonmask_nn_1_N : N ;
  olm_nn_1_N : N ;
  olycksfaagel_nn_1_1_N : N ;
  omgiv_nn_1_N : N ;
  omnibus_nn_1_N : N ;
  omnibuss_nn_1_N : N ;
  omnifyr_nn_1_N : N ;
  omsving_nn_1_N : N ;
  onkel_nn_1_N : N ;
  onsdageftermiddag_nn_1_N : N ;
  onsdagkvaell_nn_1_1_N : N ;
  onsdagseftermiddag_nn_1_N : N ;
  onsdagskvaell_nn_1_1_N : N ;
  onyx_nn_1_N : N ;
  operetteater_nn_1_N : N ;
  opossum_nn_1_N : N ;
  ordlek_nn_1_N : N ;
  ordvirvel_nn_1_N : N ;
  ordvits_nn_1_N : N ;
  orgel_nn_1_N : N ;
  orkester_nn_1_N : N ;
  orlovssedel_nn_1_N : N ;
  orm_nn_1_N : N ;
  ormgran_nn_1_N : N ;
  ormgrop_nn_1_N : N ;
  ormvraak_nn_1_1_N : N ;
  ornaesbjoerk_nn_1_1_N : N ;
  oroshaerd_nn_1_1_N : N ;
  orrfaagel_nn_1_1_N : N ;
  ort_nn_2_N : N ;
  ortolansparv_nn_1_N : N ;
  ost_nn_1_N : N ;
  osthyvel_nn_1_N : N ;
  ostmask_nn_1_N : N ;
  ostronbank_nn_1_N : N ;
  ostskalk_nn_1_N : N ;
  ostsmoergaas_nn_1_1_N : N ;
  otaecking_nn_1_1_N : N ;
  oxel_nn_1_N : N ;
  oxlaegg_nn_1_1_N : N ;
  oxtungsvamp_nn_1_N : N ;
  packbox_nn_1_N : N ;
  packlaar_nn_1_1_N : N ;
  packsadel_nn_1_N : N ;
  packtross_nn_1_N : N ;
  paddel_nn_1_N : N ;
  paketeringsdisk_nn_1_N : N ;
  palestinasjal_nn_1_N : N ;
  pall_nn_1_N : N ;
  palmsoendag_nn_1_1_N : N ;
  pals_nn_1_N : N ;
  palt_nn_1_N : N ;
  pamp_nn_1_N : N ;
  pankreaskoertel_nn_1_1_N : N ;
  pannbiff_nn_1_N : N ;
  pannspegel_nn_1_N : N ;
  pansarbil_nn_1_N : N ;
  pansarmal_nn_1_N : N ;
  pansarvagn_nn_1_N : N ;
  pansarvaernsrobot_nn_1_1_N : N ;
  panter_nn_1_N : N ;
  papegojfisk_nn_1_N : N ;
  pappershandduk_nn_1_N : N ;
  pappershandel_nn_1_N : N ;
  papperskorg_nn_1_N : N ;
  papperskvarn_nn_1_N : N ;
  pappersnaesduk_nn_1_1_N : N ;
  papperspeng_nn_1_N : N ;
  papperssax_nn_1_N : N ;
  papperstiger_nn_1_N : N ;
  papperstuss_nn_1_N : N ;
  pappspik_nn_1_N : N ;
  parabellum_nn_1_N : N ;
  paradisfaagel_nn_1_1_N : N ;
  parallellcirkel_nn_1_N : N ;
  parameter_nn_1_N : N ;
  parerplaat_nn_1_1_N : N ;
  parhaest_nn_1_1_N : N ;
  parisersmoergaas_nn_1_1_N : N ;
  parkbaenk_nn_1_1_N : N ;
  parkeringsbroms_nn_1_N : N ;
  parkettstav_nn_1_N : N ;
  parningslek_nn_1_N : N ;
  partikel_nn_1_N : N ;
  partikelkross_nn_1_N : N ;
  parvel_nn_1_N : N ;
  passbit_nn_1_N : N ;
  passbaat_nn_1_1_N : N ;
  passersedel_nn_1_N : N ;
  passus_nn_1_N : N ;
  patentsmoergaas_nn_1_1_N : N ;
  pater_nn_1_N : N ;
  paternosterhiss_nn_1_N : N ;
  patientplaat_nn_1_1_N : N ;
  patt_nn_2_N : N ;
  pausfaagel_nn_1_1_N : N ;
  pegel_nn_1_N : N ;
  pekfinger_nn_1_N : N ;
  pekfingernagel_nn_1_N : N ;
  pellejoens_nn_1_1_N : N ;
  pendel_nn_1_N : N ;
  peng_nn_1_N : N ;
  penning_nn_1_N : N ;
  pennkniv_nn_1_N : N ;
  pensel_nn_1_N : N ;
  pensionsaalder_nn_1_1_N : N ;
  pentameter_nn_1_N : N ;
  pepparkaksgris_nn_1_N : N ;
  perimeter_nn_1_N : N ;
  perpendikel_nn_1_N : N ;
  persedel_nn_1_N : N ;
  persianpaels_nn_1_1_N : N ;
  personvagn_nn_1_N : N ;
  petimaeter_nn_1_1_N : N ;
  petmoj_nn_1_N : N ;
  physalis_nn_1_N : N ;
  piasavakvast_nn_1_N : N ;
  piassavakvast_nn_1_N : N ;
  piaster_nn_1_N : N ;
  pick_nn_1_N : N ;
  picknick_nn_1_N : N ;
  piercing_nn_1_N : N ;
  pigg_nn_1_N : N ;
  pigghaj_nn_1_N : N ;
  piggvar_nn_1_N : N ;
  pik_nn_1_N : N ;
  pikstav_nn_1_N : N ;
  pil_nn_1_N : N ;
  pilaster_nn_1_N : N ;
  pilfink_nn_1_N : N ;
  pilgrimsfalk_nn_1_N : N ;
  pilgrimsstav_nn_1_N : N ;
  pilk_nn_1_N : N ;
  pilspets_nn_1_N : N ;
  pilt_nn_1_N : N ;
  pimpel_nn_1_N : N ;
  pingst_nn_1_N : N ;
  pingstdag_nn_1_N : N ;
  pinnharv_nn_1_N : N ;
  pinscher_nn_1_N : N ;
  pip_nn_1_N : N ;
  pipping_nn_1_N : N ;
  pipsvamp_nn_1_N : N ;
  pirk_nn_1_N : N ;
  piskklatsch_nn_1_N : N ;
  piskmask_nn_1_N : N ;
  piskslaeng_nn_1_1_N : N ;
  pisksnaert_nn_1_1_N : N ;
  pistagemandel_nn_1_N : N ;
  pistaschmandel_nn_1_N : N ;
  pitt_nn_1_N : N ;
  pivotvagn_nn_1_N : N ;
  pivaavagn_nn_1_1_N : N ;
  pjatt_nn_1_N : N ;
  planhyvel_nn_1_N : N ;
  plants_nn_1_N : N ;
  plastcykel_nn_1_N : N ;
  plastgaffel_nn_1_N : N ;
  plattfisk_nn_1_N : N ;
  platting_nn_1_N : N ;
  plattmask_nn_1_N : N ;
  pligg_nn_1_N : N ;
  plint_nn_1_N : N ;
  plister_nn_1_N : N ;
  plit_nn_2_N : N ;
  plog_nn_1_N : N ;
  plogbill_nn_1_N : N ;
  plugg_nn_2_N : N ;
  plugghaest_nn_1_1_N : N ;
  pluggskivling_nn_1_N : N ;
  plump_nn_1_N : N ;
  plumpudding_nn_1_N : N ;
  pluring_nn_1_N : N ;
  plutt_nn_1_N : N ;
  plaett_nn_1_1_N : N ;
  plaettlagg_nn_1_1_N : N ;
  plaat_nn_1_1_N : N ;
  plaatsax_nn_1_1_N : N ;
  ploes_nn_1_1_N : N ;
  pocket_nn_1_N : N ;
  pointer_nn_1_N : N ;
  pojkbyting_nn_1_N : N ;
  pojkcykel_nn_1_N : N ;
  pojkfnasker_nn_1_N : N ;
  pojkhals_nn_1_N : N ;
  pojkorkester_nn_1_N : N ;
  pojkspoling_nn_1_N : N ;
  pojkvasker_nn_1_N : N ;
  polaris_nn_1_N : N ;
  polarraev_nn_1_1_N : N ;
  polcirkel_nn_1_N : N ;
  polder_nn_1_N : N ;
  polishelikopter_nn_1_N : N ;
  polishund_nn_1_N : N ;
  poliskonstapel_nn_1_N : N ;
  politikus_nn_1_N : N ;
  polkagris_nn_1_N : N ;
  polkropp_nn_1_N : N ;
  polohaest_nn_1_1_N : N ;
  polyeder_nn_1_N : N ;
  polyester_nn_1_N : N ;
  polyeter_nn_1_N : N ;
  poplinrock_nn_1_N : N ;
  poplaat_nn_1_1_N : N ;
  poppel_nn_1_N : N ;
  pormask_nn_1_N : N ;
  porslinsdegel_nn_1_N : N ;
  porslinsskaal_nn_1_1_N : N ;
  porsvamp_nn_1_N : N ;
  port_nn_1_N : N ;
  portklapp_nn_1_N : N ;
  portnyckel_nn_1_N : N ;
  postbox_nn_1_N : N ;
  postremissvaexel_nn_1_1_N : N ;
  poststaempel_nn_1_1_N : N ;
  postvaexel_nn_1_1_N : N ;
  potatis_nn_1_N : N ;
  potentiometer_nn_1_N : N ;
  poaengseger_nn_1_1_N : N ;
  pratkvarn_nn_1_N : N ;
  precisionsmejsel_nn_1_N : N ;
  predikstol_nn_1_N : N ;
  premiaerminister_nn_1_1_N : N ;
  presenning_nn_1_N : N ;
  presentask_nn_1_N : N ;
  press_nn_1_N : N ;
  prick_nn_1_N : N ;
  prins_nn_1_N : N ;
  pris_nn_4_N : N ;
  prislapp_nn_1_N : N ;
  profithaj_nn_1_N : N ;
  prokrustesbaedd_nn_1_1_N : N ;
  promenadkaepp_nn_1_1_N : N ;
  promenadseger_nn_1_N : N ;
  propagandaminister_nn_1_N : N ;
  propeller_nn_1_N : N ;
  propelleraxel_nn_1_N : N ;
  propp_nn_1_N : N ;
  prost_nn_1_N : N ;
  prostatacancer_nn_1_N : N ;
  proteststorm_nn_1_N : N ;
  protonkniv_nn_1_N : N ;
  prutt_nn_1_N : N ;
  prydnadsartikel_nn_1_N : N ;
  prydnadsfjaeder_nn_1_1_N : N ;
  prydnadsgavel_nn_1_N : N ;
  prydnadskrans_nn_1_N : N ;
  prydnadsvaev_nn_1_1_N : N ;
  pryl_nn_1_N : N ;
  pryttel_nn_1_N : N ;
  praeriehund_nn_1_1_N : N ;
  praerievarg_nn_1_1_N : N ;
  praestgaard_nn_1_1_N : N ;
  praestgaardslaenstol_nn_1_1_N : N ;
  praestost_nn_1_1_N : N ;
  praestrock_nn_1_1_N : N ;
  praestskrud_nn_1_1_N : N ;
  praesttitel_nn_1_1_N : N ;
  praam_nn_1_1_N : N ;
  psykrometer_nn_1_N : N ;
  pub_nn_1_N : N ;
  puck_nn_1_N : N ;
  puckel_nn_1_N : N ;
  puckelrygg_nn_1_N : N ;
  pudding_nn_1_N : N ;
  pudel_nn_1_N : N ;
  puff_nn_1_N : N ;
  puffert_nn_1_N : N ;
  pullmanvagn_nn_1_N : N ;
  pullover_nn_1_N : N ;
  pulpit_nn_1_N : N ;
  puls_nn_2_N : N ;
  pump_nn_1_N : N ;
  pumpernickel_nn_1_N : N ;
  pumpkolv_nn_1_N : N ;
  pumpstoevel_nn_1_1_N : N ;
  punch_nn_1_N : N ;
  pung_nn_1_N : N ;
  punggraevling_nn_1_1_N : N ;
  pungmes_nn_1_N : N ;
  puns_nn_1_N : N ;
  puss_nn_1_N : N ;
  pust_nn_1_N : N ;
  putt_nn_1_N : N ;
  puttefnask_nn_1_N : N ;
  putting_nn_1_N : N ;
  pyknometer_nn_1_N : N ;
  pynt_nn_2_N : N ;
  pyrometer_nn_1_N : N ;
  pyrrhusseger_nn_1_N : N ;
  pyrrusseger_nn_1_N : N ;
  pys_nn_1_N : N ;
  pyssling_nn_1_N : N ;
  pyts_nn_1_N : N ;
  paell_nn_1_1_N : N ;
  paels_nn_1_1_N : N ;
  paelsfarm_nn_1_1_N : N ;
  paelssael_nn_1_1_N : N ;
  paelsaenger_nn_1_1_N : N ;
  paerlbaat_nn_1_1_N : N ;
  paerlspont_nn_1_1_N : N ;
  paerlstav_nn_1_1_N : N ;
  paerm_nn_1_1_N : N ;
  paesk_nn_1_1_N : N ;
  paafaagel_nn_1_1_N : N ;
  paafaagelsfjaeder_nn_1_1_N : N ;
  paag_nn_1_1_N : N ;
  paahaengsvagn_nn_1_1_N : N ;
  paak_nn_1_1_N : N ;
  paalaeggskalv_nn_1_1_N : N ;
  paask_nn_1_1_N : N ;
  paaskdag_nn_1_1_N : N ;
  paaskkaering_nn_1_1_N : N ;
  paaskkaerring_nn_1_1_N : N ;
  paasksmaell_nn_1_1_N : N ;
  paataar_nn_1_1_N : N ;
  poel_nn_1_1_N : N ;
  quisling_nn_1_N : N ;
  rabbis_nn_1_N : N ;
  racercykel_nn_1_N : N ;
  rack_nn_1_N : N ;
  racket_nn_1_N : N ;
  radarfyr_nn_1_N : N ;
  radarskaerm_nn_1_1_N : N ;
  radiofyr_nn_1_N : N ;
  radiolaenk_nn_1_1_N : N ;
  radiometer_nn_1_N : N ;
  radiotagg_nn_1_N : N ;
  raggarbrud_nn_1_N : N ;
  rakhyvel_nn_1_N : N ;
  rakspegel_nn_1_N : N ;
  rakstrigel_nn_1_N : N ;
  raktvaal_nn_1_1_N : N ;
  rall_nn_1_N : N ;
  rallarbas_nn_1_N : N ;
  ram_nn_1_N : N ;
  ramm_nn_1_N : N ;
  rangerbangaard_nn_1_1_N : N ;
  rankfoting_nn_1_N : N ;
  rapp_nn_1_N : N ;
  rapportkarl_nn_1_N : N ;
  rapsaaker_nn_1_1_N : N ;
  raring_nn_1_N : N ;
  rasp_nn_1_N : N ;
  rastgaard_nn_1_1_N : N ;
  ratt_nn_1_N : N ;
  rattvaexel_nn_1_1_N : N ;
  rauk_nn_1_N : N ;
  ravaillac_nn_1_N : N ;
  reaktorhaerd_nn_1_1_N : N ;
  rebus_nn_1_N : N ;
  receptionsdisk_nn_1_N : N ;
  reflektometer_nn_1_N : N ;
  regel_nn_2_N : N ;
  regelbaat_nn_1_1_N : N ;
  regeringsbaenk_nn_1_1_N : N ;
  regeringskrets_nn_1_N : N ;
  regnskur_nn_1_N : N ;
  reklampeng_nn_1_N : N ;
  rekordbonus_nn_1_N : N ;
  rektangel_nn_1_N : N ;
  reling_nn_1_N : N ;
  renfaell_nn_1_1_N : N ;
  renhjord_nn_1_N : N ;
  renlav_nn_1_N : N ;
  renskinnspaels_nn_1_1_N : N ;
  rentjur_nn_1_N : N ;
  reporter_nn_1_N : N ;
  restaurangvagn_nn_1_N : N ;
  retriever_nn_1_N : N ;
  returkapsel_nn_1_N : N ;
  rev_nn_2_N : N ;
  revel_nn_1_N : N ;
  revolver_nn_1_N : N ;
  revorm_nn_1_N : N ;
  ribbstol_nn_1_N : N ;
  ridhaest_nn_1_1_N : N ;
  ridstoevel_nn_1_1_N : N ;
  riesenschnauzer_nn_1_N : N ;
  rigel_nn_1_N : N ;
  rigg_nn_1_N : N ;
  riksdag_nn_1_N : N ;
  riksmarskalk_nn_1_N : N ;
  riksnyckel_nn_1_N : N ;
  rikthyvel_nn_1_N : N ;
  riktkarl_nn_1_N : N ;
  rimturs_nn_1_N : N ;
  ring_nn_1_N : N ;
  ringlek_nn_1_N : N ;
  ringmask_nn_1_N : N ;
  ringorm_nn_1_N : N ;
  ringpaerm_nn_1_1_N : N ;
  ringraev_nn_1_1_N : N ;
  ringtrast_nn_1_N : N ;
  rink_nn_1_N : N ;
  rippel_nn_1_N : N ;
  rishoeg_nn_1_1_N : N ;
  rivningskaak_nn_1_1_N : N ;
  robbert_nn_1_N : N ;
  robot_nn_1_N : N ;
  rock_nn_1_N : N ;
  rockslusk_nn_1_N : N ;
  roddarbaenk_nn_1_1_N : N ;
  roddarslav_nn_1_N : N ;
  rodel_nn_1_N : N ;
  rolighetsminister_nn_1_N : N ;
  roll_nn_2_N : N ;
  rollmops_nn_1_N : N ;
  rolls_nn_1_N : N ;
  romarhaer_nn_1_1_N : N ;
  roquefortost_nn_1_N : N ;
  rorkult_nn_1_N : N ;
  rosenfink_nn_1_N : N ;
  rosengaard_nn_1_1_N : N ;
  rosenkrans_nn_1_N : N ;
  roskarl_nn_1_N : N ;
  rosling_nn_1_N : N ;
  rospigg_nn_1_N : N ;
  rost_nn_2_N : N ;
  rostbiff_nn_1_N : N ;
  rostsvamp_nn_1_N : N ;
  rotationsaxel_nn_1_N : N ;
  rotationspress_nn_1_N : N ;
  rotel_nn_1_N : N ;
  rotknoel_nn_1_1_N : N ;
  rotting_nn_1_N : N ;
  rough_nn_1_N : N ;
  rovfisk_nn_1_N : N ;
  rovfaagel_nn_1_1_N : N ;
  rubank_nn_1_N : N ;
  rubrikstil_nn_1_N : N ;
  ruff_nn_1_N : N ;
  rullstensaas_nn_1_1_N : N ;
  rundel_nn_1_N : N ;
  rundhaell_nn_1_1_N : N ;
  rundmask_nn_1_N : N ;
  runometer_nn_1_N : N ;
  runstav_nn_1_N : N ;
  ruskprick_nn_1_N : N ;
  rustibuss_nn_1_N : N ;
  rutsch_nn_1_N : N ;
  rygg_nn_1_N : N ;
  ryggbiff_nn_1_N : N ;
  ryggsaeck_nn_1_1_N : N ;
  rymdkapsel_nn_1_N : N ;
  rymdvinkel_nn_1_N : N ;
  rymling_nn_1_N : N ;
  ryss_nn_1_N : N ;
  raeddningshelikopter_nn_1_1_N : N ;
  raekel_nn_1_1_N : N ;
  raeksmoergaas_nn_1_1_N : N ;
  raels_nn_1_1_N : N ;
  raelsbuss_nn_1_1_N : N ;
  raennil_nn_1_1_N : N ;
  raenning_nn_1_1_N : N ;
  raensel_nn_1_1_N : N ;
  raev_nn_1_1_N : N ;
  raevfarm_nn_1_1_N : N ;
  raevhund_nn_1_1_N : N ;
  raevpaels_nn_1_1_N : N ;
  raevsax_nn_1_1_N : N ;
  raevsvans_nn_1_1_N : N ;
  raabandsknop_nn_1_1_N : N ;
  raabiff_nn_1_1_N : N ;
  raabock_nn_1_1_N : N ;
  raadjurssadel_nn_1_1_N : N ;
  raagaaker_nn_1_1_N : N ;
  raak_nn_1_1_N : N ;
  raanock_nn_1_1_N : N ;
  raasop_nn_1_1_N : N ;
  raattsvans_nn_1_1_N : N ;
  roedbok_nn_1_1_N : N ;
  roeding_nn_1_1_N : N ;
  roedraev_nn_1_1_N : N ;
  roedspov_nn_1_1_N : N ;
  roedstjaert_nn_1_1_N : N ;
  roedvingetrast_nn_1_1_N : N ;
  roedvaeppling_nn_1_1_N : N ;
  roejel_nn_1_1_N : N ;
  roek_nn_1_1_N : N ;
  roekgaard_nn_1_1_N : N ;
  roekrock_nn_1_1_N : N ;
  roeksvamp_nn_1_1_N : N ;
  roenn_nn_1_1_N : N ;
  roersopp_nn_1_1_N : N ;
  roerspis_nn_1_1_N : N ;
  roersvamp_nn_1_1_N : N ;
  roestsedel_nn_1_1_N : N ;
  roev_nn_1_1_N : N ;
  saab_nn_1_N : N ;
  sabbik_nn_1_N : N ;
  sabel_nn_1_N : N ;
  sadel_nn_1_N : N ;
  sadelfilt_nn_1_N : N ;
  sadelgjord_nn_1_N : N ;
  safirnaal_nn_1_1_N : N ;
  saftglass_nn_1_N : N ;
  saftpress_nn_1_N : N ;
  sagokrets_nn_1_N : N ;
  sagoprins_nn_1_N : N ;
  sal_nn_1_N : N ;
  salamander_nn_1_N : N ;
  salladsskaal_nn_1_1_N : N ;
  salongsbaat_nn_1_1_N : N ;
  salongsorkester_nn_1_N : N ;
  salongsruff_nn_1_N : N ;
  salongsvagn_nn_1_N : N ;
  saltgrop_nn_1_N : N ;
  saltvattensfisk_nn_1_N : N ;
  saluhall_nn_1_N : N ;
  samhaellskropp_nn_1_1_N : N ;
  samlingspaerm_nn_1_1_N : N ;
  samvetspeng_nn_1_N : N ;
  sandbank_nn_1_N : N ;
  sandblaester_nn_1_1_N : N ;
  sandhed_nn_1_N : N ;
  sandjord_nn_1_N : N ;
  sandmask_nn_1_N : N ;
  sandrevel_nn_1_N : N ;
  sandstorm_nn_1_N : N ;
  sandwich_nn_1_N : N ;
  sanitetsartikel_nn_1_N : N ;
  sanitetshund_nn_1_N : N ;
  sanktbernhardshund_nn_1_N : N ;
  sarv_nn_1_N : N ;
  satkaering_nn_1_1_N : N ;
  satkaerring_nn_1_1_N : N ;
  sax_nn_1_N : N ;
  saxarm_nn_1_N : N ;
  saxnaebb_nn_1_1_N : N ;
  saxskalm_nn_1_N : N ;
  saxskaenkel_nn_1_1_N : N ;
  saxsprint_nn_1_N : N ;
  schackel_nn_1_N : N ;
  schajas_nn_1_N : N ;
  schaktugn_nn_1_N : N ;
  schal_nn_1_N : N ;
  schnauzer_nn_1_N : N ;
  schnitzel_nn_1_N : N ;
  schottis_nn_1_N : N ;
  schweizerost_nn_1_N : N ;
  schaefer_nn_1_1_N : N ;
  schaeferhund_nn_1_1_N : N ;
  schaefervalp_nn_1_1_N : N ;
  schaes_nn_1_1_N : N ;
  scooter_nn_1_N : N ;
  sedel_nn_1_N : N ;
  sedelpress_nn_1_N : N ;
  sedlighetsapostel_nn_1_N : N ;
  sedlighetsrotel_nn_1_N : N ;
  segelduk_nn_1_N : N ;
  seger_nn_1_N : N ;
  segerkrans_nn_1_N : N ;
  segerkyss_nn_1_N : N ;
  seglarstoevel_nn_1_1_N : N ;
  seismometer_nn_1_N : N ;
  sej_nn_1_N : N ;
  sejdel_nn_1_N : N ;
  sejsing_nn_1_N : N ;
  sekreterarfaagel_nn_1_1_N : N ;
  sektorfyr_nn_1_N : N ;
  semester_nn_1_N : N ;
  semesterpeng_nn_1_N : N ;
  senapsdeg_nn_1_N : N ;
  senhoest_nn_1_1_N : N ;
  senvinter_nn_1_N : N ;
  senvaar_nn_1_1_N : N ;
  septiktank_nn_1_N : N ;
  seriekrock_nn_1_N : N ;
  server_nn_1_N : N ;
  serveringsvagn_nn_1_N : N ;
  servicebox_nn_1_N : N ;
  servobroms_nn_1_N : N ;
  setter_nn_1_N : N ;
  sexfoting_nn_1_N : N ;
  sexkantsnyckel_nn_1_N : N ;
  sexling_nn_1_N : N ;
  sexpack_nn_1_N : N ;
  sexslav_nn_1_N : N ;
  sextumsspik_nn_1_N : N ;
  sfinkter_nn_1_N : N ;
  sfaerometer_nn_1_1_N : N ;
  shop_nn_1_N : N ;
  shorting_nn_1_N : N ;
  shunt_nn_1_N : N ;
  sick_nn_1_N : N ;
  sickel_nn_1_N : N ;
  sickling_nn_1_N : N ;
  sidennaesduk_nn_1_1_N : N ;
  sidenskaerm_nn_1_1_N : N ;
  sidensvans_nn_1_N : N ;
  sidodal_nn_1_N : N ;
  sidovinkel_nn_1_N : N ;
  sidskruv_nn_1_N : N ;
  sifferkarl_nn_1_N : N ;
  sifferstans_nn_1_N : N ;
  sigillstamp_nn_1_N : N ;
  sigillstaempel_nn_1_1_N : N ;
  sik_nn_1_N : N ;
  sikahjort_nn_1_N : N ;
  sikel_nn_1_N : N ;
  sikt_nn_2_N : N ;
  sil_nn_1_N : N ;
  silkesmask_nn_1_N : N ;
  silketass_nn_1_N : N ;
  sill_nn_1_N : N ;
  sillbit_nn_1_N : N ;
  sillblixt_nn_1_N : N ;
  sillfrukost_nn_1_N : N ;
  sillkung_nn_1_N : N ;
  sillpudding_nn_1_N : N ;
  silltrut_nn_1_N : N ;
  sillval_nn_1_N : N ;
  silverfisk_nn_1_N : N ;
  silvergran_nn_1_N : N ;
  silvergrogg_nn_1_N : N ;
  silvermagister_nn_1_N : N ;
  silverpeng_nn_1_N : N ;
  silverpenning_nn_1_N : N ;
  silverpoppel_nn_1_N : N ;
  silverraev_nn_1_1_N : N ;
  silverslev_nn_1_N : N ;
  silverstaempel_nn_1_1_N : N ;
  simfaagel_nn_1_1_N : N ;
  simhall_nn_1_N : N ;
  simmagister_nn_1_N : N ;
  simshyvel_nn_1_N : N ;
  simultantolk_nn_1_N : N ;
  singel_nn_1_N : N ;
  sinus_nn_1_N : N ;
  sisel_nn_1_N : N ;
  sits_nn_1_N : N ;
  sittbrunn_nn_1_N : N ;
  sittopp_nn_1_N : N ;
  sittvagn_nn_1_N : N ;
  sjajas_nn_1_N : N ;
  sjal_nn_1_N : N ;
  sjasker_nn_1_N : N ;
  sjubb_nn_1_N : N ;
  sjukbaedd_nn_1_1_N : N ;
  sjukhusbaedd_nn_1_1_N : N ;
  sjukhusfoedsel_nn_1_1_N : N ;
  sjukhussaeng_nn_1_1_N : N ;
  sjukling_nn_1_N : N ;
  sjuksyster_nn_1_N : N ;
  sjukvaardsartikel_nn_1_1_N : N ;
  sjuling_nn_1_N : N ;
  sjurygg_nn_1_N : N ;
  sjutumsspik_nn_1_N : N ;
  sjael_nn_1_1_N : N ;
  sjaelvkem_nn_1_1_N : N ;
  sjaelvlaens_nn_1_1_N : N ;
  sjaelvspilling_nn_1_1_N : N ;
  sjoebod_nn_1_1_N : N ;
  sjoebuss_nn_1_1_N : N ;
  sjoefaagel_nn_1_1_N : N ;
  sjoehaest_nn_1_1_N : N ;
  sjoekortsplotter_nn_1_1_N : N ;
  sjoemansblus_nn_1_1_N : N ;
  sjoemansknop_nn_1_1_N : N ;
  sjoeorm_nn_1_1_N : N ;
  sjoepung_nn_1_1_N : N ;
  sjoestoevel_nn_1_1_N : N ;
  skackel_nn_1_N : N ;
  skakel_nn_1_N : N ;
  skalk_nn_1_N : N ;
  skalm_nn_1_N : N ;
  skamflaeck_nn_1_1_N : N ;
  skandalmiss_nn_1_N : N ;
  skans_nn_1_N : N ;
  skarf_nn_1_N : N ;
  skarpsill_nn_1_N : N ;
  skarv_nn_1_N : N ;
  skattekil_nn_1_N : N ;
  skattesmaell_nn_1_1_N : N ;
  skattkammarvaexel_nn_1_1_N : N ;
  skattmas_nn_1_N : N ;
  skattsedel_nn_1_N : N ;
  sked_nn_1_N : N ;
  skepparkrans_nn_1_N : N ;
  skeppsbaat_nn_1_1_N : N ;
  skeppshandel_nn_1_N : N ;
  skeppsmask_nn_1_N : N ;
  skidsemester_nn_1_N : N ;
  skidstav_nn_1_N : N ;
  skiffer_nn_1_N : N ;
  skiftnyckel_nn_1_N : N ;
  skilling_nn_1_N : N ;
  skilsmaessofoeraelder_nn_1_1_N : N ;
  skinnerbur_nn_1_N : N ;
  skinnfaell_nn_1_1_N : N ;
  skinnklaedsel_nn_1_1_N : N ;
  skinnpaj_nn_1_N : N ;
  skinnvaest_nn_1_1_N : N ;
  skit_nn_1_N : N ;
  skitlaat_nn_1_1_N : N ;
  skitstoevel_nn_1_1_N : N ;
  skivbroms_nn_1_N : N ;
  skivling_nn_1_N : N ;
  skivsvamp_nn_1_N : N ;
  skjortblus_nn_1_N : N ;
  skjuts_nn_1_N : N ;
  skjutvinkel_nn_1_N : N ;
  skock_nn_1_N : N ;
  skog_nn_1_N : N ;
  skogsbaeck_nn_1_1_N : N ;
  skogsfaagel_nn_1_1_N : N ;
  skolbuss_nn_1_N : N ;
  skolbaenk_nn_1_1_N : N ;
  skolfux_nn_1_N : N ;
  skolgaard_nn_1_1_N : N ;
  skolmagister_nn_1_N : N ;
  skolskjuts_nn_1_N : N ;
  skolsyster_nn_1_N : N ;
  skopcylinder_nn_1_N : N ;
  skorv_nn_2_N : N ;
  skoter_nn_1_N : N ;
  skottglugg_nn_1_N : N ;
  skovel_nn_1_N : N ;
  skrattgrop_nn_1_N : N ;
  skrattmaas_nn_1_1_N : N ;
  skrattspegel_nn_1_N : N ;
  skrikhals_nn_1_N : N ;
  skrivstil_nn_1_N : N ;
  skrothoeg_nn_1_1_N : N ;
  skrott_nn_1_N : N ;
  skrubb_nn_1_N : N ;
  skrud_nn_1_N : N ;
  skrutt_nn_2_N : N ;
  skruv_nn_1_N : N ;
  skruvmejsel_nn_1_N : N ;
  skruvnyckel_nn_1_N : N ;
  skruvtving_nn_1_N : N ;
  skrytmaans_nn_1_1_N : N ;
  skraeck_nn_1_1_N : N ;
  skraell_nn_1_1_N : N ;
  skraellseger_nn_1_1_N : N ;
  skraapuk_nn_1_1_N : N ;
  skuff_nn_1_N : N ;
  skuffert_nn_1_N : N ;
  skuggspelsteater_nn_1_N : N ;
  skuldsedel_nn_1_N : N ;
  skult_nn_1_N : N ;
  skumgummiracket_nn_1_N : N ;
  skummis_nn_1_N : N ;
  skunk_nn_1_N : N ;
  skur_nn_1_N : N ;
  skurduk_nn_1_N : N ;
  skurhink_nn_1_N : N ;
  skurk_nn_1_N : N ;
  skvader_nn_1_N : N ;
  skvalbank_nn_1_N : N ;
  skvallerkaering_nn_1_1_N : N ;
  skvallermoster_nn_1_N : N ;
  skvallerspegel_nn_1_N : N ;
  skvaltkvarn_nn_1_N : N ;
  skvis_nn_1_N : N ;
  skvaett_nn_1_1_N : N ;
  skyddsgrav_nn_1_N : N ;
  skyddskropp_nn_1_N : N ;
  skyddsling_nn_1_N : N ;
  skyddsrock_nn_1_N : N ;
  skyddstull_nn_1_N : N ;
  skyddsaengel_nn_1_1_N : N ;
  skyffel_nn_1_N : N ;
  skygglapp_nn_1_N : N ;
  skyl_nn_1_N : N ;
  skyllerkur_nn_1_N : N ;
  skylt_nn_1_N : N ;
  skyltdockekropp_nn_1_N : N ;
  skyltsoendag_nn_1_1_N : N ;
  skylttjuv_nn_1_N : N ;
  skymt_nn_1_N : N ;
  skytt_nn_1_N : N ;
  skyttegrav_nn_1_N : N ;
  skyttegrop_nn_1_N : N ;
  skyttel_nn_1_N : N ;
  skaeck_nn_1_1_N : N ;
  skaeggdopping_nn_1_1_N : N ;
  skaegglapp_nn_1_1_N : N ;
  skaeggmunsmal_nn_1_1_N : N ;
  skaektstol_nn_1_1_N : N ;
  skaelm_nn_1_1_N : N ;
  skaenk_nn_1_1_N : N ;
  skaenkel_nn_1_1_N : N ;
  skaergaard_nn_1_1_N : N ;
  skaergaardsis_nn_1_1_N : N ;
  skaerkarl_nn_1_1_N : N ;
  skaerkniv_nn_1_1_N : N ;
  skaerm_nn_1_1_N : N ;
  skaermytsel_nn_1_1_N : N ;
  skaermytsling_nn_1_1_N : N ;
  skaertorsdag_nn_1_1_N : N ;
  skaerv_nn_1_1_N : N ;
  skaadis_nn_1_1_N : N ;
  skaal_nn_1_1_N : N ;
  skaalgrop_nn_1_1_N : N ;
  skaalsvamp_nn_1_1_N : N ;
  skaaning_nn_1_1_N : N ;
  skaank_nn_1_1_N : N ;
  skaapbil_nn_1_1_N : N ;
  skaapsaeng_nn_1_1_N : N ;
  skaapvagn_nn_1_1_N : N ;
  skoel_nn_1_1_N : N ;
  skoeld_nn_1_1_N : N ;
  skoeldborg_nn_1_1_N : N ;
  skoeldkoertel_nn_1_1_N : N ;
  skoeldkoertelcancer_nn_1_1_N : N ;
  skoeljkopp_nn_1_1_N : N ;
  skoelp_nn_1_1_N : N ;
  skoenhetsdrottning_nn_1_1_N : N ;
  skoenhetsflaeck_nn_1_1_N : N ;
  skoenhetsmiss_nn_1_1_N : N ;
  skoerd_nn_1_1_N : N ;
  skoerpil_nn_1_1_N : N ;
  skoet_nn_1_1_N : N ;
  sladd_nn_1_N : N ;
  slaf_nn_1_N : N ;
  slafs_nn_1_N : N ;
  slagborr_nn_1_N : N ;
  slagfjaeder_nn_1_1_N : N ;
  slaghoek_nn_1_1_N : N ;
  slang_nn_1_N : N ;
  slant_nn_1_N : N ;
  slarver_nn_1_N : N ;
  slash_nn_1_N : N ;
  slashas_nn_1_N : N ;
  slask_nn_2_N : N ;
  slatt_nn_1_N : N ;
  slav_nn_1_N : N ;
  slejs_nn_1_N : N ;
  slemsvamp_nn_1_N : N ;
  slemsaeck_nn_1_1_N : N ;
  slev_nn_1_N : N ;
  slick_nn_1_N : N ;
  slickepott_nn_1_N : N ;
  slidkrans_nn_1_N : N ;
  slingerbult_nn_1_N : N ;
  slingerkoel_nn_1_1_N : N ;
  slip_nn_1_N : N ;
  sliper_nn_1_N : N ;
  slipkloss_nn_1_N : N ;
  slips_nn_1_N : N ;
  slits_nn_1_N : N ;
  slitvarg_nn_1_N : N ;
  slog_nn_1_N : N ;
  slok_nn_1_N : N ;
  slottsknekt_nn_1_N : N ;
  slow_fox_nn_1_N : N ;
  slubb_nn_1_N : N ;
  slump_nn_2_N : N ;
  slumsyster_nn_1_N : N ;
  slup_nn_1_N : N ;
  slurk_nn_1_N : N ;
  slusk_nn_1_N : N ;
  sluss_nn_1_N : N ;
  slutartikel_nn_1_N : N ;
  slyngel_nn_1_N : N ;
  slaedhund_nn_1_1_N : N ;
  slaedmed_nn_1_1_N : N ;
  slaekting_nn_1_1_N : N ;
  slaeng_nn_1_1_N : N ;
  slaengkyss_nn_1_1_N : N ;
  slaeplogg_nn_1_1_N : N ;
  slaepnot_nn_1_1_N : N ;
  slaepvad_nn_1_1_N : N ;
  slaetfog_nn_1_1_N : N ;
  slaetharv_nn_1_1_N : N ;
  slaetprick_nn_1_1_N : N ;
  slaetsvamp_nn_1_1_N : N ;
  slaetvar_nn_1_1_N : N ;
  slaatter_nn_1_1_N : N ;
  slaattermyr_nn_1_1_N : N ;
  sloefock_nn_1_1_N : N ;
  sloejdspaentkniv_nn_1_1_N : N ;
  sloejskivling_nn_1_1_N : N ;
  sloejstjaert_nn_1_1_N : N ;
  smack_nn_1_N : N ;
  smalvaegg_nn_1_1_N : N ;
  smash_nn_1_N : N ;
  smatt_nn_1_N : N ;
  smidespust_nn_1_N : N ;
  smilfink_nn_1_N : N ;
  smilgrop_nn_1_N : N ;
  smitthaerd_nn_1_1_N : N ;
  smittohaerd_nn_1_1_N : N ;
  smoking_nn_1_N : N ;
  smulgraat_nn_1_1_N : N ;
  smurf_nn_1_N : N ;
  smutsgris_nn_1_N : N ;
  smutstitel_nn_1_N : N ;
  smutt_nn_1_N : N ;
  smyg_nn_1_N : N ;
  smygvinkel_nn_1_N : N ;
  smaeck_nn_1_1_N : N ;
  smaell_nn_1_1_N : N ;
  smaeltdegel_nn_1_1_N : N ;
  smaeltost_nn_1_1_N : N ;
  smaeltpropp_nn_1_1_N : N ;
  smaeltugn_nn_1_1_N : N ;
  smaabarnsfoeraelder_nn_1_1_N : N ;
  smaabil_nn_1_1_N : N ;
  smaabaatshamn_nn_1_1_N : N ;
  smaacitrus_nn_1_1_N : N ;
  smaadopping_nn_1_1_N : N ;
  smaaeker_nn_1_1_N : N ;
  smaafaagel_nn_1_1_N : N ;
  smaagris_nn_1_1_N : N ;
  smaapeng_nn_1_1_N : N ;
  smaaskrak_nn_1_1_N : N ;
  smaaspov_nn_1_1_N : N ;
  smaatting_nn_1_1_N : N ;
  smoerbult_nn_1_1_N : N ;
  smoergaas_nn_1_1_N : N ;
  smoergaasgaffel_nn_1_1_N : N ;
  smoergaaskniv_nn_1_1_N : N ;
  smoerjgrop_nn_1_1_N : N ;
  smoerjhall_nn_1_1_N : N ;
  smoerkniv_nn_1_1_N : N ;
  smoersopp_nn_1_1_N : N ;
  smoersvamp_nn_1_1_N : N ;
  snabbuss_nn_1_N : N ;
  snabel_nn_1_N : N ;
  snackis_nn_1_N : N ;
  snaps_nn_1_N : N ;
  snasker_nn_1_N : N ;
  snedhiss_nn_1_N : N ;
  snes_nn_1_N : N ;
  snibb_nn_1_N : N ;
  snibbskaal_nn_1_1_N : N ;
  snickarbaenk_nn_1_1_N : N ;
  sniff_nn_1_N : N ;
  snigel_nn_1_N : N ;
  snilleblixt_nn_1_N : N ;
  snip_nn_1_N : N ;
  snirkel_nn_1_N : N ;
  snitsel_nn_1_N : N ;
  snitt_nn_2_N : N ;
  snobb_nn_1_N : N ;
  snodd_nn_1_N : N ;
  snok_nn_1_N : N ;
  snopp_nn_1_N : N ;
  snorbroms_nn_1_N : N ;
  snorgers_nn_1_N : N ;
  snorgaers_nn_1_1_N : N ;
  snork_nn_1_N : N ;
  snorkel_nn_1_N : N ;
  snorvalp_nn_1_N : N ;
  snudd_nn_1_N : N ;
  snurrevad_nn_1_N : N ;
  snusker_nn_1_N : N ;
  snusmumrik_nn_1_N : N ;
  snusnaesduk_nn_1_1_N : N ;
  snut_nn_1_N : N ;
  snutt_nn_1_N : N ;
  snuttefilt_nn_1_N : N ;
  snygging_nn_1_N : N ;
  snyting_nn_1_N : N ;
  snaeckskruv_nn_1_1_N : N ;
  snaeckvaexel_nn_1_1_N : N ;
  snaeppfaagel_nn_1_1_N : N ;
  snaert_nn_1_1_N : N ;
  snaaljaap_nn_1_1_N : N ;
  snaalmaans_nn_1_1_N : N ;
  snaalvarg_nn_1_1_N : N ;
  snoepegel_nn_1_1_N : N ;
  snoeping_nn_1_1_N : N ;
  snoeplog_nn_1_1_N : N ;
  snoerpvad_nn_1_1_N : N ;
  snoerstump_nn_1_1_N : N ;
  snoerstoevel_nn_1_1_N : N ;
  snoescooter_nn_1_1_N : N ;
  snoeskoter_nn_1_1_N : N ;
  snoeskrud_nn_1_1_N : N ;
  snoeskyffel_nn_1_1_N : N ;
  snoesparv_nn_1_1_N : N ;
  snoestorm_nn_1_1_N : N ;
  snoevinter_nn_1_1_N : N ;
  sobel_nn_1_N : N ;
  socialfoersaekringsminister_nn_1_1_N : N ;
  socialminister_nn_1_N : N ;
  sockel_nn_1_N : N ;
  sockerloenn_nn_1_1_N : N ;
  sockerskaal_nn_1_1_N : N ;
  sockertopp_nn_1_N : N ;
  soffpotatis_nn_1_N : N ;
  sojabiff_nn_1_N : N ;
  sol_nn_2_N : N ;
  solavaexel_nn_1_1_N : N ;
  solbaenk_nn_1_1_N : N ;
  solcirkel_nn_1_N : N ;
  soldatrock_nn_1_N : N ;
  solfjaeder_nn_1_1_N : N ;
  solflaeck_nn_1_1_N : N ;
  solsemester_nn_1_N : N ;
  solsnibb_nn_1_N : N ;
  solstol_nn_1_N : N ;
  solvarg_nn_1_N : N ;
  solvkaepp_nn_1_1_N : N ;
  sommareftermiddag_nn_1_N : N ;
  sommarfaagel_nn_1_1_N : N ;
  sommargylling_nn_1_N : N ;
  sommarpotatis_nn_1_N : N ;
  sommarsemester_nn_1_N : N ;
  sop_nn_1_N : N ;
  sopkvast_nn_1_N : N ;
  sopp_nn_1_N : N ;
  soppskaal_nn_1_1_N : N ;
  soppslev_nn_1_N : N ;
  sopskyffel_nn_1_N : N ;
  soptipp_nn_1_N : N ;
  sorbetglass_nn_1_N : N ;
  sorgmantel_nn_1_N : N ;
  sorgpil_nn_1_N : N ;
  sork_nn_1_N : N ;
  sortimentask_nn_1_N : N ;
  sotpartikel_nn_1_N : N ;
  sotsvamp_nn_1_N : N ;
  sovbrits_nn_1_N : N ;
  sovsaeck_nn_1_1_N : N ;
  sovvagn_nn_1_N : N ;
  spackel_nn_2_N : N ;
  spak_nn_1_N : N ;
  spargris_nn_1_N : N ;
  spark_nn_1_N : N ;
  sparkcykel_nn_1_N : N ;
  sparkstoetting_nn_1_1_N : N ;
  sparring_nn_1_N : N ;
  sparris_nn_1_N : N ;
  sparslant_nn_1_N : N ;
  sparv_nn_1_N : N ;
  sparvfink_nn_1_N : N ;
  sparvhoek_nn_1_1_N : N ;
  spatel_nn_1_N : N ;
  spefaagel_nn_1_1_N : N ;
  spegel_nn_1_N : N ;
  spelevinker_nn_1_N : N ;
  spermamottagarsaeck_nn_1_1_N : N ;
  spets_nn_1_N : N ;
  spetsartikel_nn_1_N : N ;
  spetsbov_nn_1_N : N ;
  spetsgavel_nn_1_N : N ;
  spetshund_nn_1_N : N ;
  spigg_nn_1_N : N ;
  spik_nn_1_N : N ;
  spikspets_nn_1_N : N ;
  spilkum_nn_1_N : N ;
  spindel_nn_1_N : N ;
  spindelbult_nn_1_N : N ;
  spindelvaev_nn_1_1_N : N ;
  spinnaker_nn_1_N : N ;
  spinnrock_nn_1_N : N ;
  spiralfjaeder_nn_1_1_N : N ;
  spiralkabel_nn_1_N : N ;
  spis_nn_1_N : N ;
  spisel_nn_1_N : N ;
  spiselkrans_nn_1_N : N ;
  spiskrans_nn_1_N : N ;
  spjutspets_nn_1_N : N ;
  spjuver_nn_1_N : N ;
  spjaelsaeng_nn_1_1_N : N ;
  splejk_nn_1_N : N ;
  spliss_nn_1_N : N ;
  splits_nn_1_N : N ;
  spoling_nn_1_N : N ;
  spolmask_nn_1_N : N ;
  sporkapsel_nn_1_N : N ;
  sporsaeck_nn_1_1_N : N ;
  sportreporter_nn_1_N : N ;
  sportvagn_nn_1_N : N ;
  spottkoertel_nn_1_1_N : N ;
  spottstrit_nn_1_N : N ;
  spottstyver_nn_1_N : N ;
  spov_nn_1_N : N ;
  sprickdal_nn_1_N : N ;
  springbock_nn_1_N : N ;
  springbrunn_nn_1_N : N ;
  springmask_nn_1_N : N ;
  springschas_nn_1_N : N ;
  springsjas_nn_1_N : N ;
  sprint_nn_1_N : N ;
  sprits_nn_1_N : N ;
  sprittermometer_nn_1_N : N ;
  sprutspets_nn_1_N : N ;
  sprygel_nn_1_N : N ;
  spraengkapsel_nn_1_1_N : N ;
  spraett_nn_1_1_N : N ;
  spraetthoek_nn_1_1_N : N ;
  sproejs_nn_1_1_N : N ;
  sputnik_nn_1_N : N ;
  spaedgris_nn_1_1_N : N ;
  spaennvinkel_nn_1_1_N : N ;
  spaerr_nn_1_1_N : N ;
  spaarhund_nn_1_1_N : N ;
  spaarmejsel_nn_1_1_N : N ;
  spaarvagn_nn_1_1_N : N ;
  spoekpartikel_nn_1_1_N : N ;
  squashracket_nn_1_N : N ;
  stabbur_nn_1_N : N ;
  stack_nn_1_N : N ;
  stadsbuss_nn_1_N : N ;
  stadsjeep_nn_1_N : N ;
  stadsteater_nn_1_N : N ;
  stagg_nn_1_N : N ;
  stall_nn_3_N : N ;
  stallknekt_nn_1_N : N ;
  stamp_nn_1_N : N ;
  stampkvarn_nn_1_N : N ;
  standert_nn_1_N : N ;
  stannfaagel_nn_1_1_N : N ;
  stanning_nn_1_N : N ;
  stans_nn_1_N : N ;
  stapel_nn_1_N : N ;
  stapelbaedd_nn_1_1_N : N ;
  starbaat_nn_1_1_N : N ;
  startgrop_nn_1_N : N ;
  startkabel_nn_1_N : N ;
  startnyckel_nn_1_N : N ;
  startvev_nn_1_N : N ;
  stationsvagn_nn_1_N : N ;
  statsminister_nn_1_N : N ;
  stav_nn_1_N : N ;
  stegbil_nn_1_N : N ;
  stegbaat_nn_1_1_N : N ;
  stek_nn_1_N : N ;
  stekel_nn_1_N : N ;
  stenbit_nn_1_N : N ;
  stenbock_nn_1_N : N ;
  stenbumling_nn_1_N : N ;
  stendoes_nn_1_1_N : N ;
  stenfalk_nn_1_N : N ;
  stenhaell_nn_1_1_N : N ;
  stenknaeck_nn_1_1_N : N ;
  stenkross_nn_1_N : N ;
  stensopp_nn_1_N : N ;
  stickel_nn_1_N : N ;
  stickert_nn_1_N : N ;
  stickling_nn_1_N : N ;
  stig_nn_1_N : N ;
  stigbygel_nn_1_N : N ;
  stil_nn_1_N : N ;
  stilettkaepp_nn_1_1_N : N ;
  stilldrink_nn_1_N : N ;
  stilton_nn_1_N : N ;
  stinksvamp_nn_1_N : N ;
  stins_nn_1_N : N ;
  stirr_nn_1_N : N ;
  stjaelk_nn_1_1_N : N ;
  stjaernkusk_nn_1_1_N : N ;
  stjaernmejsel_nn_1_1_N : N ;
  stjaernskaadis_nn_1_1_N : N ;
  stjaernsmaell_nn_1_1_N : N ;
  stjaert_nn_1_1_N : N ;
  stjaertfjaeder_nn_1_1_N : N ;
  stjaertmes_nn_1_1_N : N ;
  stock_nn_1_N : N ;
  stockfisk_nn_1_N : N ;
  stoftpartikel_nn_1_N : N ;
  stol_nn_1_N : N ;
  stoll_nn_1_N : N ;
  stolpbod_nn_1_N : N ;
  stolsits_nn_1_N : N ;
  stolsrygg_nn_1_N : N ;
  stomp_nn_1_N : N ;
  stoppnaal_nn_1_1_N : N ;
  storasyster_nn_1_N : N ;
  storbaat_nn_1_1_N : N ;
  storcirkel_nn_1_N : N ;
  storhertig_nn_1_N : N ;
  stork_nn_1_N : N ;
  storm_nn_1_N : N ;
  stormbaat_nn_1_1_N : N ;
  stormfaagel_nn_1_1_N : N ;
  storspov_nn_1_N : N ;
  storsvensk_nn_1_N : N ;
  stortopp_nn_1_N : N ;
  stortaanagel_nn_1_1_N : N ;
  storvaest_nn_1_1_N : N ;
  straff_nn_2_N : N ;
  strandartikel_nn_1_N : N ;
  streber_nn_1_N : N ;
  stridis_nn_1_N : N ;
  stridsspets_nn_1_N : N ;
  stridstupp_nn_1_N : N ;
  stridsvagn_nn_1_N : N ;
  strigel_nn_1_N : N ;
  stril_nn_1_N : N ;
  strit_nn_1_N : N ;
  stropp_nn_1_N : N ;
  stross_nn_1_N : N ;
  strudel_nn_1_N : N ;
  strumphael_nn_1_1_N : N ;
  strupcancer_nn_1_N : N ;
  strut_nn_1_N : N ;
  struts_nn_1_N : N ;
  strutsfjaeder_nn_1_1_N : N ;
  strykfaagel_nn_1_1_N : N ;
  straeckbaenk_nn_1_1_N : N ;
  straeng_nn_1_1_N : N ;
  straakorkester_nn_1_1_N : N ;
  straalkropp_nn_1_1_N : N ;
  stroemkrets_nn_1_1_N : N ;
  stroemvirvel_nn_1_1_N : N ;
  stubb_nn_1_N : N ;
  studentteater_nn_1_N : N ;
  studiecirkel_nn_1_N : N ;
  studiedag_nn_1_N : N ;
  studiepenning_nn_1_N : N ;
  studs_nn_1_N : N ;
  stump_nn_1_N : N ;
  stuss_nn_1_N : N ;
  stut_nn_1_N : N ;
  stuv_nn_1_N : N ;
  stuvbit_nn_1_N : N ;
  stygging_nn_1_N : N ;
  styrfjaeder_nn_1_1_N : N ;
  styrketaar_nn_1_1_N : N ;
  styrstav_nn_1_N : N ;
  styrvaexel_nn_1_1_N : N ;
  styvfoeraelder_nn_1_1_N : N ;
  staellmutter_nn_1_1_N : N ;
  staemgaffel_nn_1_1_N : N ;
  staempel_nn_1_1_N : N ;
  staengel_nn_1_1_N : N ;
  staev_nn_1_1_N : N ;
  staafraes_nn_1_1_N : N ;
  staalfjaeder_nn_1_1_N : N ;
  staalspik_nn_1_1_N : N ;
  staaltingest_nn_1_1_N : N ;
  staalvajer_nn_1_1_N : N ;
  staandman_nn_1_1_N : N ;
  stoer_nn_1_1_N : N ;
  stoet_nn_1_1_N : N ;
  stoevel_nn_1_1_N : N ;
  stoevelklack_nn_1_1_N : N ;
  stoevelspets_nn_1_1_N : N ;
  suck_nn_1_N : N ;
  sudd_nn_1_N : N ;
  sug_nn_1_N : N ;
  sugkopp_nn_1_N : N ;
  sump_nn_2_N : N ;
  sumpbaever_nn_1_1_N : N ;
  sup_nn_1_N : N ;
  superjet_nn_1_N : N ;
  superkarg_nn_1_N : N ;
  supplementvinkel_nn_1_N : N ;
  supporter_nn_1_N : N ;
  surapel_nn_1_N : N ;
  svabb_nn_1_N : N ;
  sval_nn_1_N : N ;
  svalgmandel_nn_1_N : N ;
  svalstjaert_nn_1_1_N : N ;
  svamp_nn_1_N : N ;
  svanhals_nn_1_N : N ;
  svankrygg_nn_1_N : N ;
  svans_nn_1_N : N ;
  svanstipp_nn_1_N : N ;
  svartaboershaj_nn_1_1_N : N ;
  svarthakedopping_nn_1_N : N ;
  svarting_nn_1_N : N ;
  svartrock_nn_1_N : N ;
  svarv_nn_1_N : N ;
  svarvstol_nn_1_N : N ;
  svavelroek_nn_1_1_N : N ;
  svensk_nn_1_N : N ;
  svets_nn_1_N : N ;
  svettkoertel_nn_1_1_N : N ;
  svibel_nn_1_N : N ;
  svid_nn_1_N : N ;
  svikt_nn_1_N : N ;
  sving_nn_2_N : N ;
  svinpaels_nn_1_1_N : N ;
  svinrygg_nn_1_N : N ;
  svirvel_nn_1_N : N ;
  svivel_nn_1_N : N ;
  svaeng_nn_1_1_N : N ;
  svaengel_nn_1_1_N : N ;
  svaengningskrets_nn_1_1_N : N ;
  svaengom_nn_1_1_N : N ;
  svaerdfisk_nn_1_1_N : N ;
  svaerfoeraelder_nn_1_1_N : N ;
  svaerm_nn_1_1_N : N ;
  svaager_nn_1_1_N : N ;
  svaal_nn_1_1_N : N ;
  sweater_nn_1_N : N ;
  swing_nn_2_N : N ;
  swingpjatt_nn_1_N : N ;
  sydvaest_nn_2_1_N : N ;
  syl_nn_1_N : N ;
  syll_nn_1_N : N ;
  symfoniorkester_nn_1_N : N ;
  symmetriaxel_nn_1_N : N ;
  syndabock_nn_1_N : N ;
  syndapeng_nn_1_N : N ;
  synk_nn_1_N : N ;
  synt_nn_1_N : N ;
  syntetklaedsel_nn_1_1_N : N ;
  synvinkel_nn_1_N : N ;
  syrinx_nn_1_N : N ;
  syskonbaedd_nn_1_1_N : N ;
  syssling_nn_1_N : N ;
  syster_nn_1_N : N ;
  saeck_nn_1_1_N : N ;
  saecksvamp_nn_1_1_N : N ;
  saedesskyl_nn_1_1_N : N ;
  saekerhetsbroms_nn_1_1_N : N ;
  saekerhetssprint_nn_1_1_N : N ;
  sael_nn_1_1_N : N ;
  saelg_nn_1_1_N : N ;
  saelkut_nn_1_1_N : N ;
  saeng_nn_1_1_N : N ;
  saenggavel_nn_1_1_N : N ;
  saerk_nn_1_1_N : N ;
  saerling_nn_1_1_N : N ;
  saeter_nn_1_1_N : N ;
  saetesgaard_nn_1_1_N : N ;
  saettpotatis_nn_1_1_N : N ;
  saag_nn_1_1_N : N ;
  saagbock_nn_1_1_N : N ;
  saagfisk_nn_1_1_N : N ;
  saangarfaagel_nn_1_1_N : N ;
  saangfaagel_nn_1_1_N : N ;
  saangsvan_nn_1_1_N : N ;
  saapaskaadis_nn_1_1_N : N ;
  soedergoek_nn_1_1_N : N ;
  soederkis_nn_1_1_N : N ;
  soedersol_nn_1_1_N : N ;
  soendageftermiddag_nn_1_1_N : N ;
  soendagkvaell_nn_1_1_N : N ;
  soendagseftermiddag_nn_1_1_N : N ;
  soendagskvaell_nn_1_1_N : N ;
  soetmandel_nn_1_1_N : N ;
  soetnos_nn_1_1_N : N ;
  soetpotatis_nn_1_1_N : N ;
  t_shirt_nn_1_N : N ;
  tacksaegelsedag_nn_1_1_N : N ;
  taffel_nn_1_N : N ;
  tafs_nn_1_N : N ;
  tagelmask_nn_1_N : N ;
  tagetes_nn_1_N : N ;
  tagg_nn_1_N : N ;
  taggfening_nn_1_N : N ;
  tagghuding_nn_1_N : N ;
  taggsvamp_nn_1_N : N ;
  takbox_nn_1_N : N ;
  taknock_nn_1_N : N ;
  takometer_nn_1_N : N ;
  takregel_nn_1_N : N ;
  takymeter_nn_1_N : N ;
  takaas_nn_1_1_N : N ;
  talarstol_nn_1_N : N ;
  talgdank_nn_1_N : N ;
  talgkoertel_nn_1_1_N : N ;
  tall_nn_1_N : N ;
  tallbit_nn_1_N : N ;
  tallbock_nn_1_N : N ;
  tallkottkoertel_nn_1_1_N : N ;
  tallkottskoertel_nn_1_1_N : N ;
  tallriksharv_nn_1_N : N ;
  tallstekel_nn_1_N : N ;
  taltrast_nn_1_N : N ;
  tamfaagel_nn_1_1_N : N ;
  tamp_nn_1_N : N ;
  tandemcykel_nn_1_N : N ;
  tandfistel_nn_1_N : N ;
  tandhals_nn_1_N : N ;
  tandhyvel_nn_1_N : N ;
  tandhaevel_nn_1_1_N : N ;
  tandval_nn_1_N : N ;
  tank_nn_1_N : N ;
  tapisserinaal_nn_1_1_N : N ;
  tapp_nn_1_N : N ;
  tappkran_nn_1_N : N ;
  tarantel_nn_1_N : N ;
  tarm_nn_1_N : N ;
  tarmfistel_nn_1_N : N ;
  tartarbiff_nn_1_N : N ;
  tartarsmoergaas_nn_1_1_N : N ;
  task_nn_1_N : N ;
  tass_nn_1_N : N ;
  tavelsudd_nn_1_N : N ;
  tax_nn_1_N : N ;
  taxameter_nn_1_N : N ;
  taxeringskalender_nn_1_N : N ;
  taxibil_nn_1_N : N ;
  taxvalp_nn_1_N : N ;
  teater_nn_1_N : N ;
  teg_nn_1_N : N ;
  tejst_nn_1_N : N ;
  tekopp_nn_1_N : N ;
  telefonlur_nn_1_N : N ;
  telefonvaexel_nn_1_1_N : N ;
  telegrafnyckel_nn_1_N : N ;
  telemeter_nn_1_N : N ;
  teleprinter_nn_1_N : N ;
  telfer_nn_1_N : N ;
  teln_nn_1_N : N ;
  temp_nn_1_N : N ;
  tender_nn_1_N : N ;
  tennisracket_nn_1_N : N ;
  termometer_nn_1_N : N ;
  termos_nn_1_N : N ;
  termostapel_nn_1_N : N ;
  terraengscooter_nn_1_1_N : N ;
  terraengskoter_nn_1_1_N : N ;
  terraengvinkel_nn_1_1_N : N ;
  tesaurus_nn_1_N : N ;
  test_nn_2_N : N ;
  testcykel_nn_1_N : N ;
  testikel_nn_1_N : N ;
  tetraeder_nn_1_N : N ;
  tevagn_nn_1_N : N ;
  teveskaerm_nn_1_1_N : N ;
  textskaerm_nn_1_1_N : N ;
  tidningsartikel_nn_1_N : N ;
  tidningsblunder_nn_1_N : N ;
  tidskriftsartikel_nn_1_N : N ;
  tidsaalder_nn_1_1_N : N ;
  tiger_nn_1_N : N ;
  tigerhaj_nn_1_N : N ;
  tigerorm_nn_1_N : N ;
  tik_nn_1_N : N ;
  tillhaallarfjaeder_nn_1_1_N : N ;
  timcirkel_nn_1_N : N ;
  timing_nn_1_N : N ;
  timmerbroet_nn_1_1_N : N ;
  timmerlaens_nn_1_1_N : N ;
  timmersax_nn_1_N : N ;
  timmersvans_nn_1_N : N ;
  tingest_nn_1_N : N ;
  tinning_nn_1_N : N ;
  tiofoting_nn_1_N : N ;
  tiokronorssedel_nn_1_N : N ;
  tipp_nn_1_N : N ;
  tir_nn_1_N : N ;
  tisdageftermiddag_nn_1_N : N ;
  tisdagkvaell_nn_1_1_N : N ;
  tisdagseftermiddag_nn_1_N : N ;
  tisdagskvaell_nn_1_1_N : N ;
  tistel_nn_1_N : N ;
  titel_nn_1_N : N ;
  titt_nn_1_N : N ;
  tittarstorm_nn_1_N : N ;
  tittglugg_nn_1_N : N ;
  tjalk_nn_1_N : N ;
  tjejkompis_nn_1_N : N ;
  tjockhuding_nn_1_N : N ;
  tjockis_nn_1_N : N ;
  tjocktarm_nn_1_N : N ;
  tjugondedag_nn_1_N : N ;
  tjur_nn_1_N : N ;
  tjuv_nn_1_N : N ;
  tjuvpojksglimt_nn_1_N : N ;
  tjuvskytt_nn_1_N : N ;
  tjuvstryker_nn_1_N : N ;
  tjuvtitt_nn_1_N : N ;
  tjyv_nn_1_N : N ;
  tjyvtitt_nn_1_N : N ;
  tjaeder_nn_1_1_N : N ;
  tjaedertupp_nn_1_1_N : N ;
  tjaerdal_nn_1_1_N : N ;
  toalettartikel_nn_1_N : N ;
  toalettsits_nn_1_N : N ;
  toalettvaal_nn_1_1_N : N ;
  toastmaster_nn_1_N : N ;
  tobis_nn_1_N : N ;
  tobiskung_nn_1_N : N ;
  tofs_nn_1_N : N ;
  tofsmes_nn_1_N : N ;
  tofsskivling_nn_1_N : N ;
  tok_nn_1_N : N ;
  toker_nn_1_N : N ;
  tolk_nn_1_N : N ;
  tolvfingertarm_nn_1_N : N ;
  tolvskilling_nn_1_N : N ;
  tonarm_nn_1_N : N ;
  tonfisk_nn_1_N : N ;
  topp_nn_1_N : N ;
  topphaest_nn_1_1_N : N ;
  topping_nn_1_N : N ;
  toppknopp_nn_1_N : N ;
  tordyvel_nn_1_N : N ;
  tork_nn_1_N : N ;
  torkhandduk_nn_1_N : N ;
  torn_nn_2_N : N ;
  tornfalk_nn_1_N : N ;
  tornister_nn_1_N : N ;
  torpedbaat_nn_1_1_N : N ;
  torris_nn_2_N : N ;
  torrnaal_nn_1_1_N : N ;
  torsdageftermiddag_nn_1_N : N ;
  torsdagkvaell_nn_1_1_N : N ;
  torsdagseftermiddag_nn_1_N : N ;
  torsdagskvaell_nn_1_1_N : N ;
  torsk_nn_1_N : N ;
  torskfisk_nn_1_N : N ;
  torvjord_nn_1_N : N ;
  tosing_nn_1_N : N ;
  tott_nn_1_N : N ;
  trafikfyr_nn_1_N : N ;
  trak_egael_nn_1_1_N : N ;
  trall_nn_1_N : N ;
  trallvagn_nn_1_N : N ;
  trampbil_nn_1_N : N ;
  trampcykel_nn_1_N : N ;
  trampkvarn_nn_1_N : N ;
  trampsax_nn_1_N : N ;
  transithall_nn_1_N : N ;
  transitohamn_nn_1_N : N ;
  transmitter_nn_1_N : N ;
  transversalaxel_nn_1_N : N ;
  trapp_nn_1_N : N ;
  trappgavel_nn_1_N : N ;
  trappsmyg_nn_1_N : N ;
  trashank_nn_1_N : N ;
  trasselsudd_nn_1_N : N ;
  trast_nn_1_N : N ;
  trastfaagel_nn_1_1_N : N ;
  tratt_nn_1_N : N ;
  trattprick_nn_1_N : N ;
  trattskivling_nn_1_N : N ;
  travhaest_nn_1_1_N : N ;
  tredjedag_nn_1_N : N ;
  trehjuling_nn_1_N : N ;
  tremaenning_nn_1_1_N : N ;
  trench_nn_1_N : N ;
  trenchcoat_nn_1_N : N ;
  tresnibb_nn_1_N : N ;
  tretumsspik_nn_1_N : N ;
  tretaar_nn_1_1_N : N ;
  treudd_nn_1_N : N ;
  trevaegskran_nn_1_1_N : N ;
  triangel_nn_1_N : N ;
  trilling_nn_1_N : N ;
  trillingfoedsel_nn_1_1_N : N ;
  trimeter_nn_1_N : N ;
  trimtank_nn_1_N : N ;
  trindmask_nn_1_N : N ;
  trippel_nn_2_N : N ;
  trippelfoedsel_nn_1_1_N : N ;
  trippelseger_nn_1_N : N ;
  trips_nn_1_N : N ;
  trojeborg_nn_1_N : N ;
  trolleybuss_nn_1_N : N ;
  trollkarl_nn_1_N : N ;
  trollkaering_nn_1_1_N : N ;
  trollkaerring_nn_1_1_N : N ;
  trollstav_nn_1_N : N ;
  tropikfaagel_nn_1_1_N : N ;
  tropp_nn_1_N : N ;
  trosartikel_nn_1_N : N ;
  trosgoerdel_nn_1_1_N : N ;
  tross_nn_1_N : N ;
  trosshaest_nn_1_1_N : N ;
  trotsaalder_nn_1_1_N : N ;
  trubbnos_nn_1_N : N ;
  truck_nn_1_N : N ;
  truls_nn_1_N : N ;
  trumbroms_nn_1_N : N ;
  trumvirvel_nn_1_N : N ;
  trunk_nn_1_N : N ;
  trut_nn_1_N : N ;
  tryckpress_nn_1_N : N ;
  tryckstil_nn_1_N : N ;
  tryffel_nn_2_N : N ;
  tryffelsvamp_nn_1_N : N ;
  traebock_nn_1_1_N : N ;
  traedgaard_nn_1_1_N : N ;
  traedgaardssax_nn_1_1_N : N ;
  traedsvamp_nn_1_1_N : N ;
  traedtopp_nn_1_1_N : N ;
  traeff_nn_1_1_N : N ;
  traefrack_nn_1_1_N : N ;
  traefraes_nn_1_1_N : N ;
  traehaest_nn_1_1_N : N ;
  traekarl_nn_1_1_N : N ;
  traekloss_nn_1_1_N : N ;
  trael_nn_1_1_N : N ;
  traemask_nn_1_1_N : N ;
  traemortel_nn_1_1_N : N ;
  traens_nn_1_1_N : N ;
  traeskostoevel_nn_1_1_N : N ;
  traeskaal_nn_1_1_N : N ;
  traeslev_nn_1_1_N : N ;
  traeslip_nn_1_1_N : N ;
  traestav_nn_1_1_N : N ;
  traesvarv_nn_1_1_N : N ;
  traevaruhandel_nn_1_1_N : N ;
  traad_nn_1_1_N : N ;
  traadbuss_nn_1_1_N : N ;
  traaddiameter_nn_1_1_N : N ;
  traadduk_nn_1_1_N : N ;
  traadmask_nn_1_1_N : N ;
  traadsax_nn_1_1_N : N ;
  traadskivling_nn_1_1_N : N ;
  traadspik_nn_1_1_N : N ;
  traagdal_nn_1_1_N : N ;
  traak_nn_2_1_N : N ;
  traakmaans_nn_1_1_N : N ;
  traal_nn_1_1_N : N ;
  troeskel_nn_1_1_N : N ;
  troest_nn_2_1_N : N ;
  troestnapp_nn_1_1_N : N ;
  tuffing_nn_1_N : N ;
  tuggbuss_nn_1_N : N ;
  tull_nn_1_N : N ;
  tullmur_nn_1_N : N ;
  tummetott_nn_1_N : N ;
  tumnagel_nn_1_N : N ;
  tumskruv_nn_1_N : N ;
  tungmask_nn_1_N : N ;
  tungrygg_nn_1_N : N ;
  tungspets_nn_1_N : N ;
  tunnel_nn_1_N : N ;
  tunnelugn_nn_1_N : N ;
  tunnstav_nn_1_N : N ;
  tunntarm_nn_1_N : N ;
  tupp_nn_1_N : N ;
  tuppkyckling_nn_1_N : N ;
  tupplur_nn_1_N : N ;
  turistsaeng_nn_1_1_N : N ;
  turk_nn_1_N : N ;
  turn_ebuss_nn_1_1_N : N ;
  turs_nn_1_N : N ;
  tusenfoting_nn_1_N : N ;
  tusenkronorssedel_nn_1_N : N ;
  tusenlapp_nn_1_N : N ;
  tuss_nn_1_N : N ;
  tut_nn_1_N : N ;
  tuting_nn_1_N : N ;
  tutt_nn_1_N : N ;
  tuvtaatel_nn_1_1_N : N ;
  tv_skaerm_nn_1_1_N : N ;
  tvestjaert_nn_1_1_N : N ;
  tvilling_nn_1_N : N ;
  tvillingfoedsel_nn_1_1_N : N ;
  tvillingsyster_nn_1_N : N ;
  tvillingvagn_nn_1_N : N ;
  tving_nn_1_N : N ;
  tvaeraxel_nn_1_1_N : N ;
  tvaerbalk_nn_1_1_N : N ;
  tvaernit_nn_1_1_N : N ;
  tvaervigg_nn_1_1_N : N ;
  tvaett_nn_1_1_N : N ;
  tvaettlapp_nn_1_1_N : N ;
  tvaahjuling_nn_1_1_N : N ;
  tvaal_nn_1_1_N : N ;
  tvaalask_nn_1_1_N : N ;
  tvaalkopp_nn_1_1_N : N ;
  tvaamaenning_nn_1_1_N : N ;
  tvaatumsspik_nn_1_1_N : N ;
  tvaavaaningsbuss_nn_1_1_N : N ;
  tvaaaeggstvilling_nn_1_1_N : N ;
  tygel_nn_1_N : N ;
  tykobrahedag_nn_1_N : N ;
  tyllschal_nn_1_N : N ;
  tyllsjal_nn_1_N : N ;
  tysk_nn_1_N : N ;
  taeckmantel_nn_1_1_N : N ;
  taeltsaeng_nn_1_1_N : N ;
  taendningsnyckel_nn_1_1_N : N ;
  taendsticksask_nn_1_1_N : N ;
  taethetstopp_nn_1_1_N : N ;
  taetting_nn_1_1_N : N ;
  taettingfaagel_nn_1_1_N : N ;
  taanagel_nn_1_1_N : N ;
  taar_nn_1_1_N : N ;
  taaredal_nn_1_1_N : N ;
  taarkoertel_nn_1_1_N : N ;
  taarpil_nn_1_1_N : N ;
  taarsaeck_nn_1_1_N : N ;
  taaspets_nn_1_1_N : N ;
  taat_nn_1_1_N : N ;
  toelp_nn_1_1_N : N ;
  toent_nn_1_1_N : N ;
  toern_nn_1_1_N : N ;
  toerntagg_nn_1_1_N : N ;
  u_baat_nn_1_1_N : N ;
  ubaat_nn_1_1_N : N ;
  udd_nn_1_N : N ;
  ugn_nn_1_N : N ;
  ugnsfisk_nn_1_N : N ;
  ugnsplaat_nn_1_1_N : N ;
  ulk_nn_1_N : N ;
  ullsax_nn_1_N : N ;
  ulltork_nn_1_N : N ;
  ulltott_nn_1_N : N ;
  ulster_nn_1_N : N ;
  ulv_nn_1_N : N ;
  umgaengeskrets_nn_1_1_N : N ;
  underarm_nn_1_N : N ;
  underbaedd_nn_1_1_N : N ;
  underdomstol_nn_1_N : N ;
  underhaallningsorkester_nn_1_1_N : N ;
  underkropp_nn_1_N : N ;
  undertitel_nn_1_N : N ;
  undervattenskropp_nn_1_N : N ;
  undervattenstroeskel_nn_1_1_N : N ;
  undsaettningshaer_nn_1_1_N : N ;
  ungdomsbrottsling_nn_1_N : N ;
  ungdomsgaard_nn_1_1_N : N ;
  unghaest_nn_1_1_N : N ;
  ungkarl_nn_1_N : N ;
  ungsvensk_nn_1_N : N ;
  ungtall_nn_1_N : N ;
  ungtupp_nn_1_N : N ;
  ungturk_nn_1_N : N ;
  uniformsrock_nn_1_N : N ;
  uniformsslips_nn_1_N : N ;
  unikabox_nn_1_N : N ;
  universitetsbokhandel_nn_1_N : N ;
  universitetsmatrikel_nn_1_N : N ;
  uppesittarkvaell_nn_1_1_N : N ;
  upphalningsbaedd_nn_1_1_N : N ;
  upprorshaerd_nn_1_1_N : N ;
  uppsatstitel_nn_1_N : N ;
  uppsittarkvaell_nn_1_1_N : N ;
  ur_nn_2_N : N ;
  uranstapel_nn_1_N : N ;
  urfjaellsjord_nn_1_1_N : N ;
  urfaagel_nn_1_1_N : N ;
  uribag_nn_1_N : N ;
  urinbrunn_nn_1_N : N ;
  urinkur_nn_1_N : N ;
  urnebrandgrop_nn_1_N : N ;
  urnyckel_nn_1_N : N ;
  ursmaell_nn_1_1_N : N ;
  usling_nn_1_N : N ;
  utbildningsminister_nn_1_N : N ;
  utbrytarkung_nn_1_N : N ;
  utboeling_nn_1_1_N : N ;
  utboerding_nn_1_1_N : N ;
  utegrill_nn_1_N : N ;
  utekvaell_nn_1_1_N : N ;
  utetermometer_nn_1_N : N ;
  utgaard_nn_1_1_N : N ;
  uthamn_nn_1_N : N ;
  uthusnyckel_nn_1_N : N ;
  utkik_nn_1_N : N ;
  utlandssvensk_nn_1_N : N ;
  utrikeshandelsminister_nn_1_N : N ;
  utrikesminister_nn_1_N : N ;
  utstyrsel_nn_1_N : N ;
  utter_nn_1_N : N ;
  utvikningsbrud_nn_1_N : N ;
  utviksbrud_nn_1_N : N ;
  uv_nn_1_N : N ;
  vab_dag_nn_1_N : N ;
  vab_nn_1_N : N ;
  vabb_dag_nn_1_N : N ;
  vabb_nn_1_N : N ;
  vabbdag_nn_1_N : N ;
  vabdag_nn_1_N : N ;
  vacuumbroms_nn_1_N : N ;
  vacuummeter_nn_1_N : N ;
  vad_nn_3_N : N ;
  vadarfaagel_nn_1_1_N : N ;
  vadd_nn_1_N : N ;
  vagel_nn_1_N : N ;
  vagn_nn_1_N : N ;
  vagnborg_nn_1_N : N ;
  vagnhall_nn_1_N : N ;
  vagnshaest_nn_1_1_N : N ;
  vagnskorg_nn_1_N : N ;
  vajer_nn_1_N : N ;
  vak_nn_1_N : N ;
  vakfaagel_nn_1_1_N : N ;
  vaktel_nn_1_N : N ;
  vakthund_nn_1_N : N ;
  vaktkur_nn_1_N : N ;
  vakuumbroms_nn_1_N : N ;
  vakuummeter_nn_1_N : N ;
  val_nn_2_N : N ;
  valbarometer_nn_1_N : N ;
  valbiskop_nn_1_N : N ;
  valfisk_nn_1_N : N ;
  valk_nn_1_N : N ;
  valkrets_nn_1_N : N ;
  vall_nn_1_N : N ;
  vallgrav_nn_1_N : N ;
  vallhund_nn_1_N : N ;
  valp_nn_1_N : N ;
  valross_nn_1_N : N ;
  vals_nn_1_N : N ;
  valsedel_nn_1_N : N ;
  valseger_nn_1_N : N ;
  valskaerm_nn_1_1_N : N ;
  vandringsfisk_nn_1_N : N ;
  vandringsstav_nn_1_N : N ;
  vaniljgiffel_nn_1_N : N ;
  vapenrock_nn_1_N : N ;
  varbygel_nn_1_N : N ;
  vardagsfestutstyrsel_nn_1_N : N ;
  varfaagel_nn_1_1_N : N ;
  varg_nn_1_N : N ;
  vargavinter_nn_1_N : N ;
  varggrop_nn_1_N : N ;
  varhaerd_nn_1_1_N : N ;
  variometer_nn_1_N : N ;
  varningstriangel_nn_1_N : N ;
  varp_nn_1_N : N ;
  varubil_nn_1_N : N ;
  varubuss_nn_1_N : N ;
  varuvagn_nn_1_N : N ;
  vask_nn_1_N : N ;
  vasker_nn_1_N : N ;
  vass_nn_1_N : N ;
  vattencykel_nn_1_N : N ;
  vattenfaagel_nn_1_1_N : N ;
  vattenkran_nn_1_N : N ;
  vattenpuss_nn_1_N : N ;
  vattenpoel_nn_1_1_N : N ;
  vattensalamander_nn_1_N : N ;
  vattenspindel_nn_1_N : N ;
  vattenstaempel_nn_1_1_N : N ;
  vattensaeng_nn_1_1_N : N ;
  vattentroeskel_nn_1_1_N : N ;
  vattenvirvel_nn_1_N : N ;
  vaxskivling_nn_1_N : N ;
  vaxstapel_nn_1_N : N ;
  veckodag_nn_1_N : N ;
  veckopeng_nn_1_N : N ;
  vedbod_nn_1_N : N ;
  vedettbaat_nn_1_1_N : N ;
  vedkap_nn_1_N : N ;
  vedlaar_nn_1_1_N : N ;
  vedspis_nn_1_N : N ;
  vegetationsknopp_nn_1_N : N ;
  vehikel_nn_1_N : N ;
  vekling_nn_1_N : N ;
  veling_nn_1_N : N ;
  ventilfjaeder_nn_1_1_N : N ;
  ventrikel_nn_1_N : N ;
  verkningskrets_nn_1_N : N ;
  verksamhetskrets_nn_1_N : N ;
  verkstadsklubb_nn_1_N : N ;
  vertikalcirkel_nn_1_N : N ;
  vertikalvinkel_nn_1_N : N ;
  vertolhelikopter_nn_1_N : N ;
  vesper_nn_1_N : N ;
  vetegrodd_nn_1_N : N ;
  vetekrans_nn_1_N : N ;
  vettvilling_nn_1_N : N ;
  vev_nn_1_N : N ;
  vevarm_nn_1_N : N ;
  vevaxel_nn_1_N : N ;
  vevling_nn_1_N : N ;
  vevtapp_nn_1_N : N ;
  vicekonung_nn_1_N : N ;
  vicekung_nn_1_N : N ;
  vicevaerd_nn_1_1_N : N ;
  vickel_nn_1_N : N ;
  videsparv_nn_1_N : N ;
  vigg_nn_1_N : N ;
  vigkvast_nn_1_N : N ;
  vigsel_nn_1_N : N ;
  vik_nn_1_N : N ;
  viking_nn_1_N : N ;
  vikskaerm_nn_1_1_N : N ;
  viktigpetter_nn_1_N : N ;
  viktualiehandel_nn_1_N : N ;
  vildapel_nn_1_N : N ;
  vildfaagel_nn_1_1_N : N ;
  vilding_nn_1_N : N ;
  vilodag_nn_1_N : N ;
  vilopuls_nn_1_N : N ;
  viltspegel_nn_1_N : N ;
  vimpel_nn_1_N : N ;
  vinbaal_nn_1_1_N : N ;
  vind_nn_1_N : N ;
  vindboejtel_nn_1_1_N : N ;
  vindel_nn_1_N : N ;
  vindfloejel_nn_1_1_N : N ;
  vindil_nn_1_N : N ;
  vindpust_nn_1_N : N ;
  vindskaerm_nn_1_1_N : N ;
  vindstoet_nn_1_1_N : N ;
  vindtunnel_nn_1_N : N ;
  ving_nn_1_N : N ;
  vingklaff_nn_1_N : N ;
  vingmutter_nn_1_N : N ;
  vingplog_nn_1_N : N ;
  vingspegel_nn_1_N : N ;
  vingspets_nn_1_N : N ;
  vingaard_nn_1_1_N : N ;
  vink_nn_1_N : N ;
  vinkel_nn_1_N : N ;
  vinkelarm_nn_1_N : N ;
  vinkelborr_nn_1_N : N ;
  vinkelroller_nn_1_N : N ;
  vinkelslip_nn_1_N : N ;
  vinkelspets_nn_1_N : N ;
  vinskaenk_nn_1_1_N : N ;
  vinter_nn_1_N : N ;
  vintereftermiddag_nn_1_N : N ;
  vinterkvaell_nn_1_1_N : N ;
  vinterspaarvagn_nn_1_1_N : N ;
  vinterstoevel_nn_1_1_N : N ;
  vintertraedgaard_nn_1_1_N : N ;
  vinthund_nn_1_N : N ;
  vip_nn_1_N : N ;
  vipp_nn_1_N : N ;
  vippstjaert_nn_1_1_N : N ;
  virginiahjort_nn_1_N : N ;
  virvel_nn_1_N : N ;
  virvelstorm_nn_1_N : N ;
  visp_nn_1_N : N ;
  visper_nn_1_N : N ;
  visthusbod_nn_1_N : N ;
  vitfisk_nn_1_N : N ;
  vitling_nn_1_N : N ;
  vitmoegelost_nn_1_1_N : N ;
  vitnos_nn_1_N : N ;
  vitplister_nn_1_N : N ;
  vitrock_nn_1_N : N ;
  vitryss_nn_1_N : N ;
  vitraev_nn_1_1_N : N ;
  vits_nn_1_N : N ;
  vitsvanshjort_nn_1_N : N ;
  vittling_nn_1_N : N ;
  vitval_nn_1_N : N ;
  vivel_nn_1_N : N ;
  vojlock_nn_1_N : N ;
  volm_nn_1_N : N ;
  voltmeter_nn_1_N : N ;
  vomb_nn_1_N : N ;
  vorstehhund_nn_1_N : N ;
  vraklax_nn_1_N : N ;
  vrestall_nn_1_N : N ;
  vret_nn_1_N : N ;
  vridningsaxel_nn_1_N : N ;
  vril_nn_1_N : N ;
  vraak_nn_1_1_N : N ;
  vulkankrater_nn_1_N : N ;
  vurst_nn_1_N : N ;
  vaebel_nn_1_1_N : N ;
  vaederil_nn_1_1_N : N ;
  vaedersol_nn_1_1_N : N ;
  vaeg_nn_1_1_N : N ;
  vaegg_nn_1_1_N : N ;
  vaeggregel_nn_1_1_N : N ;
  vaeghyvel_nn_1_1_N : N ;
  vaegtistel_nn_1_1_N : N ;
  vaegtorn_nn_1_1_N : N ;
  vaegtull_nn_1_1_N : N ;
  vaegtunnel_nn_1_1_N : N ;
  vaeljarbarometer_nn_1_1_N : N ;
  vaelkomstfrukost_nn_1_1_N : N ;
  vaelkomstskaal_nn_1_1_N : N ;
  vaell_nn_1_1_N : N ;
  vaelling_nn_1_1_N : N ;
  vaellusting_nn_1_1_N : N ;
  vaelt_nn_1_1_N : N ;
  vaendkrets_nn_1_1_N : N ;
  vaenkrets_nn_1_1_N : N ;
  vaensterarm_nn_1_1_N : N ;
  vaensterflygel_nn_1_1_N : N ;
  vaenstergir_nn_1_1_N : N ;
  vaenthall_nn_1_1_N : N ;
  vaeppling_nn_1_1_N : N ;
  vaerd_nn_1_1_N : N ;
  vaering_nn_1_1_N : N ;
  vaerk_nn_1_1_N : N ;
  vaerldsaxel_nn_1_1_N : N ;
  vaerldsaalder_nn_1_1_N : N ;
  vaernfaagel_nn_1_1_N : N ;
  vaernpliktsriksdag_nn_1_1_N : N ;
  vaersting_nn_1_1_N : N ;
  vaest_nn_1_1_N : N ;
  vaestergoek_nn_1_1_N : N ;
  vaestgoetaklimax_nn_1_1_N : N ;
  vaestgoetaspets_nn_1_1_N : N ;
  vaesttysk_nn_1_1_N : N ;
  vaetsketermometer_nn_1_1_N : N ;
  vaetterroeding_nn_1_1_N : N ;
  vaev_nn_1_1_N : N ;
  vaevarfink_nn_1_1_N : N ;
  vaevarfaagel_nn_1_1_N : N ;
  vaevkaepp_nn_1_1_N : N ;
  vaevsked_nn_1_1_N : N ;
  vaevskyttel_nn_1_1_N : N ;
  vaevstol_nn_1_1_N : N ;
  vaexel_nn_1_1_N : N ;
  vaexelspak_nn_1_1_N : N ;
  vaextpress_nn_1_1_N : N ;
  vaextstekel_nn_1_1_N : N ;
  vaag_nn_2_1_N : N ;
  vaagdal_nn_1_1_N : N ;
  vaaghals_nn_1_1_N : N ;
  vaagtopp_nn_1_1_N : N ;
  vaaldsbrottsling_nn_1_1_N : N ;
  vaaldsrotel_nn_1_1_N : N ;
  vaalm_nn_1_1_N : N ;
  vaang_nn_1_1_N : N ;
  vaaningssaeng_nn_1_1_N : N ;
  vaar_nn_1_1_N : N ;
  vaaradonis_nn_1_1_N : N ;
  vaard_nn_3_13_N : N ;
  vaarsol_nn_1_1_N : N ;
  vaartbjoerk_nn_1_1_N : N ;
  vaartgaard_nn_1_1_N : N ;
  vaartkaktus_nn_1_1_N : N ;
  vaartsvets_nn_1_1_N : N ;
  vaarvinter_nn_1_1_N : N ;
  webblaenk_nn_1_1_N : N ;
  whippet_nn_1_N : N ;
  wienerschnitzel_nn_1_N : N ;
  wok_nn_1_N : N ;
  x_axel_nn_1_N : N ;
  y_axel_nn_1_N : N ;
  ymp_nn_1_N : N ;
  ympkvist_nn_1_N : N ;
  yngling_nn_1_N : N ;
  ynkrygg_nn_1_N : N ;
  yrkeskodex_nn_1_N : N ;
  yrkestitel_nn_1_N : N ;
  ytter_nn_1_N : N ;
  ytterrock_nn_1_N : N ;
  yttervinkel_nn_1_N : N ;
  aedelgran_nn_1_1_N : N ;
  aedelost_nn_1_1_N : N ;
  aedling_nn_1_1_N : N ;
  aefsing_nn_1_1_N : N ;
  aeggkastning_nn_1_1_N : N ;
  aeggkokning_nn_1_1_N : N ;
  aeggkopp_nn_1_1_N : N ;
  aeggledartratt_nn_1_1_N : N ;
  aegglossning_nn_1_1_N : N ;
  aeggost_nn_1_1_N : N ;
  aeggsked_nn_1_1_N : N ;
  aeggsnodd_nn_1_1_N : N ;
  aeggstanning_nn_1_1_N : N ;
  aeggstav_nn_1_1_N : N ;
  aeggstock_nn_1_1_N : N ;
  aeggsvamp_nn_1_1_N : N ;
  aeggsaeck_nn_1_1_N : N ;
  aegodelning_nn_1_1_N : N ;
  aegogradering_nn_1_1_N : N ;
  aegretthaeger_nn_1_1_N : N ;
  aeldreminister_nn_1_1_N : N ;
  aeldresatsning_nn_1_1_N : N ;
  aelg_nn_1_1_N : N ;
  aelgkalv_nn_1_1_N : N ;
  aelgskog_nn_1_1_N : N ;
  aelgstek_nn_1_1_N : N ;
  aelgvarning_nn_1_1_N : N ;
  aelling_nn_1_1_N : N ;
  aelskling_nn_1_1_N : N ;
  aelsklingsost_nn_1_1_N : N ;
  aelv_nn_1_1_N : N ;
  aelvbrink_nn_1_1_N : N ;
  aelvbaedd_nn_1_1_N : N ;
  aelvdaling_nn_1_1_N : N ;
  aelvdrottning_nn_1_1_N : N ;
  aelvkvarn_nn_1_1_N : N ;
  aelvmynning_nn_1_1_N : N ;
  aembetsmannaregering_nn_1_1_N : N ;
  aembetsskrud_nn_1_1_N : N ;
  aembetsstaellning_nn_1_1_N : N ;
  aembetstitel_nn_1_1_N : N ;
  aemnesintegrering_nn_1_1_N : N ;
  aemnesomsaettning_nn_1_1_N : N ;
  aendring_nn_1_1_N : N ;
  aendtarm_nn_1_1_N : N ;
  aendvaendning_nn_1_1_N : N ;
  aeng_nn_1_1_N : N ;
  aengel_nn_1_1_N : N ;
  aenger_nn_1_1_N : N ;
  aengshoek_nn_1_1_N : N ;
  aengsknarr_nn_1_1_N : N ;
  aenkedrottning_nn_1_1_N : N ;
  aenkestoet_nn_1_1_N : N ;
  aenkling_nn_1_1_N : N ;
  aenterpik_nn_1_1_N : N ;
  aentring_nn_1_1_N : N ;
  aeppelskrott_nn_1_1_N : N ;
  aeppelskrutt_nn_1_1_N : N ;
  aeppleskrott_nn_1_1_N : N ;
  aerekraenkning_nn_1_1_N : N ;
  aerendehandlaeggning_nn_1_1_N : N ;
  aereport_nn_1_1_N : N ;
  aereraeddning_nn_1_1_N : N ;
  aeretitel_nn_1_1_N : N ;
  aerftlighetslag_nn_1_1_N : N ;
  aerjkrok_nn_1_1_N : N ;
  aerkebiskop_nn_1_1_N : N ;
  aerkehertig_nn_1_1_N : N ;
  aerkeskurk_nn_1_1_N : N ;
  aerkeaengel_nn_1_1_N : N ;
  aerm_nn_1_1_N : N ;
  aermlinning_nn_1_1_N : N ;
  aerrbildning_nn_1_1_N : N ;
  aerrtatuering_nn_1_1_N : N ;
  aesping_nn_1_1_N : N ;
  aetning_nn_1_1_N : N ;
  aetstoerning_nn_1_1_N : N ;
  aettiksinlaeggning_nn_1_1_N : N ;
  aettling_nn_1_1_N : N ;
  aexing_nn_1_1_N : N ;
  aahoerardag_nn_1_1_N : N ;
  aakarhaest_nn_1_1_N : N ;
  aakarkamp_nn_1_1_N : N ;
  aaker_nn_1_1_N : N ;
  aakerjord_nn_1_1_N : N ;
  aakerlapp_nn_1_1_N : N ;
  aakersork_nn_1_1_N : N ;
  aakerspergel_nn_1_1_N : N ;
  aakerteg_nn_1_1_N : N ;
  aakertistel_nn_1_1_N : N ;
  aakroek_nn_1_1_N : N ;
  aal_nn_1_1_N : N ;
  aalder_nn_1_1_N : N ;
  aaldersspaerr_nn_1_1_N : N ;
  aalspets_nn_1_1_N : N ;
  aam_nn_1_1_N : N ;
  aangblaester_nn_1_1_N : N ;
  aangbaat_nn_1_1_N : N ;
  aangslup_nn_1_1_N : N ;
  aangvinsch_nn_1_1_N : N ;
  aangvaelt_nn_1_1_N : N ;
  aarsdag_nn_1_1_N : N ;
  aarskull_nn_1_1_N : N ;
  aartull_nn_1_1_N : N ;
  aas_nn_1_1_N : N ;
  aasgrop_nn_1_1_N : N ;
  aatel_nn_1_1_N : N ;
  aaterupprepning_nn_1_1_N : N ;
  aaterupptagning_nn_1_1_N : N ;
  aaterverkning_nn_1_1_N : N ;
  aatervinning_nn_1_1_N : N ;
  aathutning_nn_1_1_N : N ;
  aatstramning_nn_1_1_N : N ;
  aattatimmarsdag_nn_1_1_N : N ;
  aattatumsspik_nn_1_1_N : N ;
  aattaaaring_nn_1_1_N : N ;
  aattling_nn_1_1_N : N ;
  oedebygdsvaeg_nn_1_1_N : N ;
  oedegaard_nn_1_1_N : N ;
  oedesdag_nn_1_1_N : N ;
  oegonbindel_nn_1_1_N : N ;
  oegonbrynshoejning_nn_1_1_N : N ;
  oegonfrans_nn_1_1_N : N ;
  oegonrullning_nn_1_1_N : N ;
  oegonsjukdom_nn_1_1_N : N ;
  oegonspegel_nn_1_1_N : N ;
  oegontagg_nn_1_1_N : N ;
  oegonvinkel_nn_1_1_N : N ;
  oegonvittnesskildring_nn_1_1_N : N ;
  oekenvandring_nn_1_1_N : N ;
  oekenvind_nn_1_1_N : N ;
  oekning_nn_1_1_N : N ;
  oekstock_nn_1_1_N : N ;
  oelandsgaard_nn_1_1_N : N ;
  oelandshaest_nn_1_1_N : N ;
  oelback_nn_1_1_N : N ;
  oelburk_nn_1_1_N : N ;
  oelhall_nn_1_1_N : N ;
  oelservering_nn_1_1_N : N ;
  oeltillverkning_nn_1_1_N : N ;
  oeluff_nn_1_1_N : N ;
  oelaenning_nn_1_1_N : N ;
  oemsning_nn_1_1_N : N ;
  oenskering_nn_1_1_N : N ;
  oenskning_nn_1_1_N : N ;
  oeppnaknapp_nn_1_1_N : N ;
  oeppning_nn_1_1_N : N ;
  oerfil_nn_1_1_N : N ;
  oerfilsdom_nn_1_1_N : N ;
  oerflik_nn_1_1_N : N ;
  oering_nn_1_1_N : N ;
  oern_nn_1_1_N : N ;
  oernblick_nn_1_1_N : N ;
  oerongaang_nn_1_1_N : N ;
  oeronpropp_nn_1_1_N : N ;
  oeronsjukdom_nn_1_1_N : N ;
  oeronsnibb_nn_1_1_N : N ;
  oeronsusning_nn_1_1_N : N ;
  oersnibb_nn_1_1_N : N ;
  oertagaard_nn_1_1_N : N ;
  oertesaeng_nn_1_1_N : N ;
  oertsaeng_nn_1_1_N : N ;
  oertug_nn_1_1_N : N ;
  oesning_nn_1_1_N : N ;
  oesterbottning_nn_1_1_N : N ;
  oesterlaenning_nn_1_1_N : N ;
  oestersjoefisk_nn_1_1_N : N ;
  oesttysk_nn_1_1_N : N ;
  oeveranstraengning_nn_1_1_N : N ;
  oeveranvaendning_nn_1_1_N : N ;
  oeverarbetning_nn_1_1_N : N ;
  oeverarm_nn_1_1_N : N ;
  oeverbefolkning_nn_1_1_N : N ;
  oeverbehandling_nn_1_1_N : N ;
  oeverbelastning_nn_1_1_N : N ;
  oeverbelaeggning_nn_1_1_N : N ;
  oeverbjudning_nn_1_1_N : N ;
  oeverblick_nn_1_1_N : N ;
  oeverbaedd_nn_1_1_N : N ;
  oeverdebitering_nn_1_1_N : N ;
  oeverdimensionering_nn_1_1_N : N ;
  oeverdomstol_nn_1_1_N : N ;
  oeverdosering_nn_1_1_N : N ;
  oeverensfyr_nn_1_1_N : N ;
  oeverexponering_nn_1_1_N : N ;
  oeverflygning_nn_1_1_N : N ;
  oeverflyttning_nn_1_1_N : N ;
  oeverfoering_nn_1_1_N : N ;
  oevergaang_nn_1_1_N : N ;
  oevergaangsstil_nn_1_1_N : N ;
  oevergaangsaalder_nn_1_1_N : N ;
  oeverhalning_nn_1_1_N : N ;
  oeverhandsfraes_nn_1_1_N : N ;
  oeverhandsknop_nn_1_1_N : N ;
  oeverhettning_nn_1_1_N : N ;
  oeverhopning_nn_1_1_N : N ;
  oeverhoppning_nn_1_1_N : N ;
  oeverhoeljning_nn_1_1_N : N ;
  oeverilning_nn_1_1_N : N ;
  oeverinlaerning_nn_1_1_N : N ;
  oeverjaesning_nn_1_1_N : N ;
  oeverkamning_nn_1_1_N : N ;
  oeverklivning_nn_1_1_N : N ;
  oeverkompensering_nn_1_1_N : N ;
  oeverkorsning_nn_1_1_N : N ;
  oeverkragning_nn_1_1_N : N ;
  oeverkropp_nn_1_1_N : N ;
  oeverlapp_nn_1_1_N : N ;
  oeverlappning_nn_1_1_N : N ;
  oeverloppsgaerning_nn_1_1_N : N ;
  oeverlaeggning_nn_1_1_N : N ;
  oeverlaemning_nn_1_1_N : N ;
  oeverlaepp_nn_1_1_N : N ;
  oevernattning_nn_1_1_N : N ;
  oeverraskning_nn_1_1_N : N ;
  oeverrock_nn_1_1_N : N ;
  oeverrumpling_nn_1_1_N : N ;
  oeverraeckning_nn_1_1_N : N ;
  oeverroestning_nn_1_1_N : N ;
  oeverskattning_nn_1_1_N : N ;
  oeverskeppningsbaat_nn_1_1_N : N ;
  oeverskjutning_nn_1_1_N : N ;
  oeverskruv_nn_1_1_N : N ;
  oeverskuggning_nn_1_1_N : N ;
  oeverskylning_nn_1_1_N : N ;
  oeverskoeljning_nn_1_1_N : N ;
  oeverslagsberaekning_nn_1_1_N : N ;
  oeverspaenning_nn_1_1_N : N ;
  oeverstigning_nn_1_1_N : N ;
  oeverstrykning_nn_1_1_N : N ;
  oeverstroemning_nn_1_1_N : N ;
  oeversvaemning_nn_1_1_N : N ;
  oeversaendning_nn_1_1_N : N ;
  oeversaettning_nn_1_1_N : N ;
  oevertalning_nn_1_1_N : N ;
  oeverteckning_nn_1_1_N : N ;
  oevertrassering_nn_1_1_N : N ;
  oevertaeckning_nn_1_1_N : N ;
  oevervakning_nn_1_1_N : N ;
  oevervakningsutrustning_nn_1_1_N : N ;
  oevervallning_nn_1_1_N : N ;
  oevervaegning_nn_1_1_N : N ;
  oevervaerdering_nn_1_1_N : N ;
  oevervaexel_nn_1_1_N : N ;
  oevervaaning_nn_1_1_N : N ;
  oevning_nn_1_1_N : N ;
  oevningsrymning_nn_1_1_N : N ;
  oevningsskjutning_nn_1_1_N : N ;
  oevaerld_nn_1_1_N : N ;
  ytterdel_nn_1_N : N ;
  vaextdel_nn_1_1_N : N ;
  vaerldsdel_nn_1_1_N : N ;
  vaeljarandel_nn_1_1_N : N ;
  vinstandel_nn_1_N : N ;
  utvecklingsgren_nn_1_N : N ;
  urkalksten_nn_1_N : N ;
  traedgren_nn_1_1_N : N ;
  trottoarsten_nn_1_N : N ;
  tegelsten_nn_1_N : N ;
  tegelskorsten_nn_1_N : N ;
  stoetesten_nn_1_1_N : N ;
  stordriftsfoerdel_nn_1_1_N : N ;
  stjaertdel_nn_1_1_N : N ;
  stadsdel_nn_1_N : N ;
  spraengsten_nn_1_1_N : N ;
  smaasten_nn_1_1_N : N ;
  smaadel_nn_1_1_N : N ;
  slutsten_nn_1_N : N ;
  slipsten_nn_1_N : N ;
  slicksten_nn_1_N : N ;
  skorsten_nn_1_N : N ;
  sextiondel_nn_1_N : N ;
  sextiondedel_nn_1_N : N ;
  raennsten_nn_1_1_N : N ;
  runsten_nn_1_N : N ;
  rullsten_nn_1_N : N ;
  reservdel_nn_1_N : N ;
  pungsten_nn_1_N : N ;
  oxalatsten_nn_1_N : N ;
  orddel_nn_1_N : N ;
  nyckelsten_nn_1_N : N ;
  njursten_nn_1_N : N ;
  nervgren_nn_1_N : N ;
  nederdel_nn_1_N : N ;
  natursten_nn_1_N : N ;
  maansten_nn_1_1_N : N ;
  mursten_nn_1_N : N ;
  minnessten_nn_1_N : N ;
  milsten_nn_1_N : N ;
  meteorsten_nn_1_N : N ;
  metalldel_nn_1_N : N ;
  mellandel_nn_1_N : N ;
  maskindel_nn_1_N : N ;
  marknadsandel_nn_1_N : N ;
  loepsten_nn_1_1_N : N ;
  loeparsten_nn_1_1_N : N ;
  landsdel_nn_1_N : N ;
  kvarnsten_nn_1_N : N ;
  kvadersten_nn_1_N : N ;
  kulturdel_nn_1_N : N ;
  kullersten_nn_1_N : N ;
  kragsten_nn_1_N : N ;
  konkurrensfoerdel_nn_1_1_N : N ;
  kommundel_nn_1_N : N ;
  klappersten_nn_1_N : N ;
  kiselsten_nn_1_N : N ;
  kantsten_nn_1_N : N ;
  hoernsten_nn_1_1_N : N ;
  haelsofoerdel_nn_1_1_N : N ;
  huvuddel_nn_1_N : N ;
  hundradel_nn_1_N : N ;
  hundradedel_nn_1_N : N ;
  hjaerndel_nn_1_1_N : N ;
  halvaedelsten_nn_1_1_N : N ;
  graasten_nn_1_1_N : N ;
  graenssten_nn_1_1_N : N ;
  grundsten_nn_1_N : N ;
  gravsten_nn_1_N : N ;
  grangren_nn_1_N : N ;
  glaettsten_nn_1_1_N : N ;
  gatsten_nn_1_N : N ;
  gallsten_nn_1_N : N ;
  framdel_nn_1_N : N ;
  fjaerdedel_nn_1_1_N : N ;
  fabriksskorsten_nn_1_N : N ;
  droppsten_nn_1_N : N ;
  djurdel_nn_1_N : N ;
  byggsten_nn_1_N : N ;
  byggnadssten_nn_1_N : N ;
  bullersten_nn_1_N : N ;
  braakdel_nn_1_1_N : N ;
  brynsten_nn_1_N : N ;
  boutredare_nn_1_N : N ;
  blaassten_nn_1_1_N : N ;
  bindsten_nn_1_N : N ;
  bildsten_nn_1_N : N ;
  bidragsdel_nn_1_N : N ;
  bautasten_nn_1_N : N ;
  bandel_nn_1_N : N ;
  bakdel_nn_1_N : N ;
  Berlinmur_nn_1_N : N ;
  DNA_sekvensering_nn_1_N : N ;
  DNA_straeng_nn_1_1_N : N ;
  DNA_testning_nn_1_N : N ;
  DNA_uppsaettning_nn_1_1_N : N ;
  EU_utvidgning_nn_1_N : N ;
  Golgatavandring_nn_1_N : N ;
  Jantelag_nn_1_N : N ;
  Kafkastaemning_nn_1_1_N : N ;
  Koranbraenning_nn_1_1_N : N ;
  LCD_skaerm_nn_1_1_N : N ;
  LED_belysning_nn_1_N : N ;
  Oxfordkommatering_nn_1_N : N ;
  PCB_foerening_nn_1_1_N : N ;
  PCB_foergiftning_nn_1_1_N : N ;
  PVC_belaeggning_nn_1_1_N : N ;
  SIFO_undersoekning_nn_1_1_N : N ;
  Sifoundersoekning_nn_1_1_N : N ;
  Statoilmack_nn_1_N : N ;
  Soedermalmvaaning_nn_1_1_N : N ;
  TV_saendning_nn_1_1_N : N ;
  TV_oevervakning_nn_1_1_N : N ;
  USB_sladd_nn_1_N : N ;
  asgam_nn_1_N : N ;
  askhoeg_nn_1_1_N : N ;
  askpuff_nn_1_N : N ;
  asktipp_nn_1_N : N ;
  aspirering_nn_1_N : N ;
  assignering_nn_1_N : N ;
  assimilering_nn_1_N : N ;
  assistering_nn_1_N : N ;
  associering_nn_1_N : N ;
  assurering_nn_1_N : N ;
  asylmottagning_nn_1_N : N ;
  atelj_evaaning_nn_1_1_N : N ;
  atlasbindning_nn_1_N : N ;
  atletklubb_nn_1_N : N ;
  atombombsfaellning_nn_1_1_N : N ;
  atrofiering_nn_1_N : N ;
  attackering_nn_1_N : N ;
  attestering_nn_1_N : N ;
  attitydfoeraendring_nn_1_1_N : N ;
  attitydundersoekning_nn_1_1_N : N ;
  attrahering_nn_1_N : N ;
  attrappering_nn_1_N : N ;
  attribuering_nn_1_N : N ;
  attributsamling_nn_1_N : N ;
  auktionering_nn_1_N : N ;
  auktorisering_nn_1_N : N ;
  auskultering_nn_1_N : N ;
  autenticering_nn_1_N : N ;
  autentifiering_nn_1_N : N ;
  autentisering_nn_1_N : N ;
  automatisering_nn_1_N : N ;
  automatsaekring_nn_1_1_N : N ;
  avancering_nn_1_N : N ;
  avannonsering_nn_1_N : N ;
  avbalkning_nn_1_N : N ;
  avbasning_nn_1_N : N ;
  avbestaellning_nn_1_1_N : N ;
  avbetalning_nn_1_N : N ;
  avbetingning_nn_1_N : N ;
  avbetning_nn_1_N : N ;
  avbildning_nn_1_N : N ;
  avbindning_nn_1_N : N ;
  avbitning_nn_1_N : N ;
  avblaasning_nn_1_1_N : N ;
  avbokning_nn_1_N : N ;
  avbrytning_nn_1_N : N ;
  avbraenning_nn_1_1_N : N ;
  avbroestning_nn_1_1_N : N ;
  avbaering_nn_1_1_N : N ;
  avbaerning_nn_1_1_N : N ;
  avboejning_nn_1_1_N : N ;
  avdelning_nn_1_N : N ;
  avdramatisering_nn_1_N : N ;
  avdunstning_nn_1_N : N ;
  avfallsbrunn_nn_1_N : N ;
  avfallskvarn_nn_1_N : N ;
  avfattning_nn_1_N : N ;
  avfettning_nn_1_N : N ;
  avflyttning_nn_1_N : N ;
  avfolkning_nn_1_N : N ;
  avfrostning_nn_1_N : N ;
  avfyrning_nn_1_N : N ;
  avfaelling_nn_1_1_N : N ;
  avfoering_nn_1_1_N : N ;
  avgasfoergiftning_nn_1_1_N : N ;
  avgiftning_nn_1_N : N ;
  avgjutning_nn_1_N : N ;
  avgrening_nn_1_N : N ;
  avgraensning_nn_1_1_N : N ;
  avgud_nn_1_N : N ;
  avgaerdning_nn_1_1_N : N ;
  avgaang_nn_1_1_N : N ;
  avhandling_nn_1_N : N ;
  avhuggning_nn_1_N : N ;
  avhyvling_nn_1_N : N ;
  avhaellning_nn_1_1_N : N ;
  avhaellningsoeppning_nn_1_1_N : N ;
  avhaemtning_nn_1_1_N : N ;
  avhaestning_nn_1_1_N : N ;
  avisering_nn_1_N : N ;
  avisningsanlaeggning_nn_1_1_N : N ;
  avjaemning_nn_1_1_N : N ;
  avkastning_nn_1_N : N ;
  avklappning_nn_1_N : N ;
  avklippning_nn_1_N : N ;
  avklaedning_nn_1_1_N : N ;
  avknoppning_nn_1_N : N ;
  avkolonisering_nn_1_N : N ;
  avkomling_nn_1_N : N ;
  avkoppling_nn_1_N : N ;
  avkortning_nn_1_N : N ;
  avkriminalisering_nn_1_N : N ;
  avkrok_nn_1_N : N ;
  avkraengning_nn_1_1_N : N ;
  avkraevning_nn_1_1_N : N ;
  avkylning_nn_1_N : N ;
  avlagring_nn_1_N : N ;
  avlastning_nn_1_N : N ;
  avledning_nn_1_N : N ;
  avloppsbrunn_nn_1_N : N ;
  avloppsledning_nn_1_N : N ;
  avloppsrensning_nn_1_N : N ;
  avloppsrensningsslang_nn_1_N : N ;
  avlusning_nn_1_N : N ;
  avlysning_nn_1_N : N ;
  avlyssning_nn_1_N : N ;
  avlyssningsutrustning_nn_1_N : N ;
  avlaeggning_nn_1_1_N : N ;
  avlaemning_nn_1_1_N : N ;
  avlaesning_nn_1_1_N : N ;
  avloening_nn_1_1_N : N ;
  avloepning_nn_1_1_N : N ;
  avloesning_nn_1_1_N : N ;
  avloevning_nn_1_1_N : N ;
  avmagnetisering_nn_1_N : N ;
  avmagring_nn_1_N : N ;
  avmaskning_nn_1_N : N ;
  avmattning_nn_1_N : N ;
  avmaetning_nn_1_1_N : N ;
  avmoenstring_nn_1_1_N : N ;
  avnazifiering_nn_1_N : N ;
  avnypning_nn_1_N : N ;
  avpassning_nn_1_N : N ;
  avpatrullering_nn_1_N : N ;
  avplaning_nn_1_N : N ;
  avpolitisering_nn_1_N : N ;
  avpollettering_nn_1_N : N ;
  avportraettering_nn_1_1_N : N ;
  avreagering_nn_1_N : N ;
  avredning_nn_1_N : N ;
  avregistrering_nn_1_N : N ;
  avreglering_nn_1_N : N ;
  avringning_nn_1_N : N ;
  avrinning_nn_1_N : N ;
  avritning_nn_1_N : N ;
  avrivning_nn_1_N : N ;
  avromantisering_nn_1_N : N ;
  avrundning_nn_1_N : N ;
  avrustning_nn_1_N : N ;
  avraekning_nn_1_1_N : N ;
  avraettning_nn_1_1_N : N ;
  avsaktning_nn_1_N : N ;
  avsegling_nn_1_N : N ;
  avsiktsfoerklaring_nn_1_1_N : N ;
  avsittning_nn_1_N : N ;
  avskaffning_nn_1_N : N ;
  avskavning_nn_1_N : N ;
  avskedsfoerestaellning_nn_1_1_N : N ;
  avskedshaelsning_nn_1_1_N : N ;
  avskedsmiddag_nn_1_N : N ;
  avskedsuppvaktning_nn_1_N : N ;
  avskjutning_nn_1_N : N ;
  avskrivning_nn_1_N : N ;
  avskraeckning_nn_1_1_N : N ;
  avskraedeshoeg_nn_1_1_N : N ;
  avskraedning_nn_1_1_N : N ;
  avskaermning_nn_1_1_N : N ;
  avskaerning_nn_1_1_N : N ;
  avslappning_nn_1_N : N ;
  avslappningsoevning_nn_1_1_N : N ;
  avslipning_nn_1_N : N ;
  avslutning_nn_1_N : N ;
  avsloejning_nn_1_1_N : N ;
  avsmakning_nn_1_N : N ;
  avsmalning_nn_1_N : N ;
  avsmaeltning_nn_1_1_N : N ;
  avsnaesning_nn_1_1_N : N ;
  avsnoerning_nn_1_1_N : N ;
  avsocialisering_nn_1_N : N ;
  avspark_nn_1_N : N ;
  avspegling_nn_1_N : N ;
  avspelning_nn_1_N : N ;
  avspisning_nn_1_N : N ;
  avspaenning_nn_1_1_N : N ;
  avspaerrning_nn_1_1_N : N ;
  avstalinisering_nn_1_N : N ;
  avstavning_nn_1_N : N ;
  avstickning_nn_1_N : N ;
  avstigning_nn_1_N : N ;
  avstjaelpning_nn_1_1_N : N ;
  avstyckning_nn_1_N : N ;
  avstaellning_nn_1_1_N : N ;
  avstaempling_nn_1_1_N : N ;
  avstaengning_nn_1_1_N : N ;
  avstaandsbedoemning_nn_1_1_N : N ;
  avstaandsmaetning_nn_1_1_N : N ;
  avstoetning_nn_1_1_N : N ;
  avsugning_nn_1_N : N ;
  avsvalkning_nn_1_N : N ;
  avsvalning_nn_1_N : N ;
  avsvaerjning_nn_1_1_N : N ;
  avsyning_nn_1_N : N ;
  avsaendning_nn_1_1_N : N ;
  avsaettning_nn_1_1_N : N ;
  avsaagning_nn_1_1_N : N ;
  avsoendring_nn_1_1_N : N ;
  avtackning_nn_1_N : N ;
  avtagning_nn_1_N : N ;
  avtagsvaeg_nn_1_1_N : N ;
  avtalsfoerhandling_nn_1_1_N : N ;
  avtappning_nn_1_N : N ;
  avteckning_nn_1_N : N ;
  avtoning_nn_1_N : N ;
  avtryckning_nn_1_N : N ;
  avtunning_nn_1_N : N ;
  avtvagning_nn_1_N : N ;
  avtyning_nn_1_N : N ;
  avtaeckning_nn_1_1_N : N ;
  avveckling_nn_1_N : N ;
  avverkning_nn_1_N : N ;
  avvisning_nn_1_N : N ;
  avvaeg_nn_1_1_N : N ;
  avvaegning_nn_1_1_N : N ;
  avvaendning_nn_1_1_N : N ;
  avvaenjning_nn_1_1_N : N ;
  avvaerjning_nn_1_1_N : N ;
  avaakning_nn_1_1_N : N ;
  axelkoppling_nn_1_N : N ;
  axelriktning_nn_1_N : N ;
  axelryckning_nn_1_N : N ;
  axiomatisering_nn_1_N : N ;
  axionfoertaetning_nn_1_1_N : N ;
  babianroev_nn_1_1_N : N ;
  backhoppning_nn_1_N : N ;
  backning_nn_1_N : N ;
  badanlaeggning_nn_1_1_N : N ;
  baddning_nn_1_N : N ;
  badinraettning_nn_1_1_N : N ;
  badmintonboll_nn_1_N : N ;
  badning_nn_1_N : N ;
  badrumsdoerr_nn_1_1_N : N ;
  badrumsflaekt_nn_1_1_N : N ;
  bagageinlaemning_nn_1_1_N : N ;
  bagagestropp_nn_1_N : N ;
  bagagevagn_nn_1_N : N ;
  bagatellisering_nn_1_N : N ;
  bajonettfattning_nn_1_N : N ;
  bajshoeg_nn_1_1_N : N ;
  bakdoerr_nn_1_1_N : N ;
  bakgrundsstraalning_nn_1_1_N : N ;
  bakladdning_nn_1_N : N ;
  baklaengesvandring_nn_1_1_N : N ;
  bakning_nn_1_N : N ;
  bakport_nn_1_N : N ;
  bakvagn_nn_1_N : N ;
  bakvaeg_nn_1_1_N : N ;
  bakvaegg_nn_1_1_N : N ;
  balansering_nn_1_N : N ;
  balansrubbning_nn_1_N : N ;
  balansraekning_nn_1_1_N : N ;
  balansvaag_nn_1_1_N : N ;
  balkanisering_nn_1_N : N ;
  balklaenning_nn_1_1_N : N ;
  balkongdoerr_nn_1_1_N : N ;
  ballongbluff_nn_1_N : N ;
  ballongboll_nn_1_N : N ;
  ballotering_nn_1_N : N ;
  balsal_nn_1_N : N ;
  balsamering_nn_1_N : N ;
  baltutlaemning_nn_1_1_N : N ;
  banalisering_nn_1_N : N ;
  bananstock_nn_1_N : N ;
  bandsaag_nn_1_1_N : N ;
  bandupptagning_nn_1_N : N ;
  bandyboll_nn_1_N : N ;
  baning_nn_1_N : N ;
  banklag_nn_1_N : N ;
  bankruttering_nn_1_N : N ;
  bankruttfoerklaring_nn_1_1_N : N ;
  banloepning_nn_1_1_N : N ;
  bannlysning_nn_1_N : N ;
  banskjutning_nn_1_N : N ;
  bantning_nn_1_N : N ;
  banvall_nn_1_N : N ;
  barbarhoevding_nn_1_1_N : N ;
  barberarstol_nn_1_N : N ;
  barfotaloepning_nn_1_1_N : N ;
  barfotamunk_nn_1_N : N ;
  bariumfoerening_nn_1_1_N : N ;
  barlastning_nn_1_N : N ;
  barmhaertighetsgaerning_nn_1_1_N : N ;
  barnasjael_nn_1_1_N : N ;
  barnbegraensning_nn_1_1_N : N ;
  barnbespisning_nn_1_N : N ;
  barncrosshjaelm_nn_1_1_N : N ;
  barndom_nn_1_N : N ;
  barnfattigdom_nn_1_N : N ;
  barnfoerlamning_nn_1_1_N : N ;
  barnhemsplacering_nn_1_N : N ;
  barnlek_nn_1_N : N ;
  barnparkering_nn_1_N : N ;
  barnpassning_nn_1_N : N ;
  barnsjukdom_nn_1_N : N ;
  barnteckning_nn_1_N : N ;
  barnvagn_nn_1_N : N ;
  barrikadering_nn_1_N : N ;
  barrskog_nn_1_N : N ;
  barservering_nn_1_N : N ;
  barstol_nn_1_N : N ;
  baseboll_nn_2_N : N ;
  basering_nn_1_N : N ;
  basketboll_nn_2_N : N ;
  basning_nn_1_N : N ;
  bassning_nn_1_N : N ;
  bastingering_nn_1_N : N ;
  bastkjol_nn_1_N : N ;
  bastufoerening_nn_1_1_N : N ;
  bastuklubb_nn_1_N : N ;
  basunstoet_nn_1_1_N : N ;
  basvaeg_nn_1_1_N : N ;
  bataljmaalning_nn_1_1_N : N ;
  batteriladdning_nn_1_N : N ;
  batteritaendning_nn_1_1_N : N ;
  bearbetning_nn_1_N : N ;
  bebaadning_nn_1_1_N : N ;
  bedarrning_nn_1_N : N ;
  bedoemning_nn_1_1_N : N ;
  bedoevning_nn_1_1_N : N ;
  befallning_nn_1_N : N ;
  befattning_nn_1_N : N ;
  befjaedring_nn_1_1_N : N ;
  befolkning_nn_1_N : N ;
  befolkningsundersoekning_nn_1_1_N : N ;
  befolkningsoekning_nn_1_1_N : N ;
  befordring_nn_1_N : N ;
  befordringsgaang_nn_1_1_N : N ;
  befraktning_nn_1_N : N ;
  befruktning_nn_1_N : N ;
  befaelsfoering_nn_1_1_N : N ;
  befaelsstaellning_nn_1_1_N : N ;
  befaestning_nn_1_1_N : N ;
  begapning_nn_1_N : N ;
  begeistring_nn_1_N : N ;
  begjutning_nn_1_N : N ;
  beglaensning_nn_1_1_N : N ;
  begravning_nn_1_N : N ;
  begravningsdag_nn_1_N : N ;
  begreppsbestaemning_nn_1_1_N : N ;
  begreppsbildning_nn_1_N : N ;
  begreppsfoervirring_nn_1_1_N : N ;
  begraensning_nn_1_1_N : N ;
  begaavning_nn_1_1_N : N ;
  behandling_nn_1_N : N ;
  behovsproevning_nn_1_1_N : N ;
  behaengning_nn_1_1_N : N ;
  behaerskning_nn_1_1_N : N ;
  behaallning_nn_1_1_N : N ;
  behaaring_nn_1_1_N : N ;
  bejakning_nn_1_N : N ;
  bekanting_nn_1_N : N ;
  beklaedning_nn_1_1_N : N ;
  beklaemning_nn_1_1_N : N ;
  bekransning_nn_1_N : N ;
  bekroening_nn_1_1_N : N ;
  bekvaemlighetsinraettning_nn_1_1_N : N ;
  bekaempning_nn_1_1_N : N ;
  belastning_nn_1_N : N ;
  beledsagning_nn_1_N : N ;
  belysning_nn_1_N : N ;
  belaeggning_nn_1_1_N : N ;
  belaeggningsring_nn_1_1_N : N ;
  belaegring_nn_1_1_N : N ;
  belaaning_nn_1_1_N : N ;
  beloening_nn_1_1_N : N ;
  bemanning_nn_1_N : N ;
  benbildning_nn_1_N : N ;
  benediktinermunk_nn_1_N : N ;
  benling_nn_1_N : N ;
  bensindunk_nn_1_N : N ;
  bensinfoerbrukning_nn_1_1_N : N ;
  bensinpump_nn_1_N : N ;
  bensinskattehoejning_nn_1_1_N : N ;
  benaemning_nn_1_1_N : N ;
  benaadning_nn_1_1_N : N ;
  bepansring_nn_1_N : N ;
  beprisning_nn_1_N : N ;
  beredning_nn_1_N : N ;
  beredskapslagring_nn_1_N : N ;
  bergbestigning_nn_1_N : N ;
  bergborrning_nn_1_N : N ;
  bergsbestigning_nn_1_N : N ;
  bergshantering_nn_1_N : N ;
  bergskedjebildning_nn_1_N : N ;
  bergsklaettring_nn_1_1_N : N ;
  bergssluttning_nn_1_N : N ;
  bergvind_nn_1_N : N ;
  beroendestaellning_nn_1_1_N : N ;
  berusning_nn_1_N : N ;
  beraekning_nn_1_1_N : N ;
  beraettarbegaavning_nn_1_1_N : N ;
  beraettarstil_nn_1_1_N : N ;
  beroering_nn_1_1_N : N ;
  besiffring_nn_1_N : N ;
  besiktning_nn_1_N : N ;
  besinning_nn_1_N : N ;
  besittning_nn_1_N : N ;
  beskattning_nn_1_N : N ;
  beskickning_nn_1_N : N ;
  beskjutning_nn_1_N : N ;
  beskrivning_nn_1_N : N ;
  beskuggning_nn_1_N : N ;
  beskyllning_nn_1_N : N ;
  beskaerning_nn_1_1_N : N ;
  beskaadning_nn_1_1_N : N ;
  besloejning_nn_1_1_N : N ;
  besmanskrok_nn_1_N : N ;
  besoldning_nn_1_N : N ;
  besparing_nn_1_N : N ;
  besparingsskog_nn_1_N : N ;
  bespejning_nn_1_N : N ;
  bespisning_nn_1_N : N ;
  besprutning_nn_1_N : N ;
  bessemerblaasning_nn_1_1_N : N ;
  bestickfoering_nn_1_1_N : N ;
  bestickning_nn_1_N : N ;
  bestigning_nn_1_N : N ;
  bestormning_nn_1_N : N ;
  bestraffning_nn_1_N : N ;
  bestrykning_nn_1_N : N ;
  bestraalning_nn_1_1_N : N ;
  bestyckning_nn_1_N : N ;
  bestaellning_nn_1_1_N : N ;
  bestaemning_nn_1_1_N : N ;
  bestaenkning_nn_1_1_N : N ;
  bestoertning_nn_1_1_N : N ;
  besvaerjning_nn_1_1_N : N ;
  besvaershandling_nn_1_1_N : N ;
  besvaershaenvisning_nn_1_1_N : N ;
  besaettning_nn_1_1_N : N ;
  besoeksdag_nn_1_1_N : N ;
  besoeksnaering_nn_1_1_N : N ;
  besoeksstol_nn_1_1_N : N ;
  betalning_nn_1_N : N ;
  betalningsanmaerkning_nn_1_1_N : N ;
  betastraalning_nn_1_1_N : N ;
  beteckning_nn_1_N : N ;
  beteendebehandling_nn_1_N : N ;
  beteendeforskning_nn_1_N : N ;
  beteenderubbning_nn_1_N : N ;
  beteltuggning_nn_1_N : N ;
  betesgaang_nn_1_1_N : N ;
  betesslaepp_nn_1_1_N : N ;
  betingning_nn_1_N : N ;
  betingslaesning_nn_1_1_N : N ;
  betjaening_nn_1_1_N : N ;
  betning_nn_1_N : N ;
  betodling_nn_1_N : N ;
  betongering_nn_1_N : N ;
  betonghaeck_nn_1_1_N : N ;
  betoning_nn_1_N : N ;
  betsning_nn_1_N : N ;
  betydelsefoerskjutning_nn_1_1_N : N ;
  betydelsefoeraendring_nn_1_1_N : N ;
  betydelseglidning_nn_1_N : N ;
  betydelseutveckling_nn_1_N : N ;
  betyghoejning_nn_1_1_N : N ;
  betygshoejning_nn_1_1_N : N ;
  betygssaenkning_nn_1_1_N : N ;
  betygssaettning_nn_1_1_N : N ;
  betygsaenkning_nn_1_1_N : N ;
  betygsaettning_nn_1_1_N : N ;
  betaeckning_nn_1_1_N : N ;
  bevakning_nn_1_N : N ;
  bevattning_nn_1_N : N ;
  bevattningsanlaeggning_nn_1_1_N : N ;
  bevillning_nn_1_N : N ;
  bevisfoering_nn_1_1_N : N ;
  bevisfoervanskning_nn_1_1_N : N ;
  bevisning_nn_1_N : N ;
  bevisproevning_nn_1_1_N : N ;
  bevissaekring_nn_1_1_N : N ;
  bevisvaerdering_nn_1_1_N : N ;
  bevaepning_nn_1_1_N : N ;
  bevaering_nn_1_1_N : N ;
  bibelfoerklaring_nn_1_1_N : N ;
  bibeltolkning_nn_1_N : N ;
  bibeloeversaettning_nn_1_1_N : N ;
  biblioteksbelysning_nn_1_N : N ;
  biedermeierstil_nn_1_N : N ;
  bifallsstorm_nn_1_N : N ;
  bifallsyttring_nn_1_N : N ;
  biffstek_nn_1_N : N ;
  bihandling_nn_1_N : N ;
  bilbesiktning_nn_1_N : N ;
  bildhaallning_nn_1_1_N : N ;
  bildning_nn_1_N : N ;
  bildningsgaang_nn_1_1_N : N ;
  bildtolkning_nn_1_N : N ;
  bildoeverfoering_nn_1_1_N : N ;
  bilfoersaekring_nn_1_1_N : N ;
  biljardboll_nn_1_N : N ;
  biljettbokning_nn_1_N : N ;
  biljettfoersaeljning_nn_1_1_N : N ;
  biljettvisering_nn_1_N : N ;
  bilkrock_nn_1_N : N ;
  bilkyrkogaard_nn_1_1_N : N ;
  bilkoerning_nn_1_1_N : N ;
  bilparkering_nn_1_N : N ;
  bilprovning_nn_1_N : N ;
  bilratt_nn_1_N : N ;
  bilrengoering_nn_1_1_N : N ;
  bilring_nn_1_N : N ;
  bilschamposvamp_nn_1_N : N ;
  bilskrot_nn_1_N : N ;
  bilskrotning_nn_1_N : N ;
  bilstol_nn_1_N : N ;
  biltillverkning_nn_1_N : N ;
  biltvaett_nn_1_1_N : N ;
  biltaevling_nn_1_1_N : N ;
  bilvaeg_nn_1_1_N : N ;
  bilaakning_nn_1_1_N : N ;
  bindning_nn_1_N : N ;
  bindnaal_nn_1_1_N : N ;
  bindvaevssaeck_nn_1_1_N : N ;
  bindvaevstraad_nn_1_1_N : N ;
  binaering_nn_1_1_N : N ;
  biodling_nn_1_N : N ;
  biofoerestaellning_nn_1_1_N : N ;
  biografering_nn_1_N : N ;
  biskopsstol_nn_1_N : N ;
  bissering_nn_1_N : N ;
  bistock_nn_1_N : N ;
  bistaandsfoervaltning_nn_1_1_N : N ;
  bisaettning_nn_1_1_N : N ;
  bivackering_nn_1_N : N ;
  biverkning_nn_1_N : N ;
  bivaeg_nn_1_1_N : N ;
  bjudning_nn_1_N : N ;
  bjoernram_nn_1_1_N : N ;
  bjoerntraad_nn_1_1_N : N ;
  bladfoting_nn_1_N : N ;
  bladning_nn_1_N : N ;
  bladstaellning_nn_1_1_N : N ;
  blanchering_nn_1_N : N ;
  blandning_nn_1_N : N ;
  blandskog_nn_1_N : N ;
  blankning_nn_1_N : N ;
  blankofoersaeljning_nn_1_1_N : N ;
  blankpolering_nn_1_N : N ;
  blasonering_nn_1_N : N ;
  bleckburk_nn_1_N : N ;
  blekning_nn_1_N : N ;
  blessering_nn_1_N : N ;
  blinddoerr_nn_1_1_N : N ;
  blindering_nn_1_N : N ;
  blindflygning_nn_1_N : N ;
  blindlandning_nn_1_N : N ;
  blindpressning_nn_1_N : N ;
  blingning_nn_1_N : N ;
  blinkning_nn_1_N : N ;
  blinning_nn_1_N : N ;
  blippning_nn_1_N : N ;
  blixtbelysning_nn_1_N : N ;
  blixtfotografering_nn_1_N : N ;
  blixtutryckning_nn_1_N : N ;
  blockbildning_nn_1_N : N ;
  blockering_nn_1_N : N ;
  blockvagn_nn_1_N : N ;
  bloddoping_nn_1_N : N ;
  blodflaeck_nn_1_1_N : N ;
  blodfoergiftning_nn_1_1_N : N ;
  blodkorv_nn_1_N : N ;
  blodkraekning_nn_1_1_N : N ;
  blodpropp_nn_1_N : N ;
  blodprovstagning_nn_1_N : N ;
  blodpudding_nn_1_N : N ;
  blodpuddingsbit_nn_1_N : N ;
  blodpump_nn_1_N : N ;
  blodsjukdom_nn_1_N : N ;
  blodspenning_nn_1_N : N ;
  blodspottning_nn_1_N : N ;
  blodstallning_nn_1_N : N ;
  blodstillning_nn_1_N : N ;
  blodstockning_nn_1_N : N ;
  blodstoertning_nn_1_1_N : N ;
  blodsvettning_nn_1_N : N ;
  blodtappning_nn_1_N : N ;
  blodutgjutning_nn_1_N : N ;
  blodvallning_nn_1_N : N ;
  blodvittring_nn_1_N : N ;
  blodoeverfoering_nn_1_1_N : N ;
  blombefruktning_nn_1_N : N ;
  blomflock_nn_1_N : N ;
  blommografering_nn_1_N : N ;
  blomning_nn_1_N : N ;
  blomsterfoermedling_nn_1_1_N : N ;
  blomstergaard_nn_1_1_N : N ;
  blomsterloek_nn_1_1_N : N ;
  blomsterodling_nn_1_N : N ;
  blomstertraedgaard_nn_1_1_N : N ;
  blomsteraeng_nn_1_1_N : N ;
  blomstring_nn_1_N : N ;
  blomstaellning_nn_1_1_N : N ;
  blondering_nn_1_N : N ;
  blottlaeggning_nn_1_1_N : N ;
  blyfoerening_nn_1_1_N : N ;
  blyfoergiftning_nn_1_1_N : N ;
  blygdlaepp_nn_1_1_N : N ;
  blaeckflaeck_nn_1_1_N : N ;
  blaedning_nn_1_1_N : N ;
  blaendning_nn_1_1_N : N ;
  blaengning_nn_1_1_N : N ;
  blaenkning_nn_1_1_N : N ;
  blaakopiering_nn_1_1_N : N ;
  blaasfoting_nn_1_1_N : N ;
  blaasning_nn_1_1_N : N ;
  bloedning_nn_1_1_N : N ;
  bloetlaeggning_nn_1_1_N : N ;
  bloetning_nn_1_1_N : N ;
  boaorm_nn_1_N : N ;
  boasering_nn_1_N : N ;
  boboll_nn_2_N : N ;
  bockbraenning_nn_1_1_N : N ;
  bockning_nn_1_N : N ;
  bodelning_nn_1_N : N ;
  bodybuilding_nn_1_N : N ;
  boendesegregering_nn_1_N : N ;
  bogserbaat_nn_1_1_N : N ;
  bogsering_nn_1_N : N ;
  bohuslaening_nn_1_1_N : N ;
  bohuslaenning_nn_1_1_N : N ;
  bojkottning_nn_1_N : N ;
  bokbindning_nn_1_N : N ;
  bokbraenning_nn_1_1_N : N ;
  bokdamm_nn_1_N : N ;
  bokfoering_nn_1_1_N : N ;
  bokklubb_nn_1_N : N ;
  bokning_nn_1_N : N ;
  boksamling_nn_1_N : N ;
  bokskog_nn_1_N : N ;
  bokstavering_nn_1_N : N ;
  bokstavsbeteckning_nn_1_N : N ;
  bokstavsordning_nn_1_N : N ;
  bolagsordning_nn_1_N : N ;
  bolagsskog_nn_1_N : N ;
  bollbehandling_nn_1_N : N ;
  bollning_nn_1_N : N ;
  bolsterstock_nn_1_N : N ;
  bolstervagn_nn_1_N : N ;
  bombardering_nn_1_N : N ;
  bombering_nn_1_N : N ;
  bombfaellning_nn_1_1_N : N ;
  bombning_nn_1_N : N ;
  bombtillverkning_nn_1_N : N ;
  bomullsklaenning_nn_1_1_N : N ;
  bomullstraad_nn_1_1_N : N ;
  bomullsvaev_nn_1_1_N : N ;
  bondebefolkning_nn_1_N : N ;
  bondeskog_nn_1_N : N ;
  bondgaard_nn_1_1_N : N ;
  bondlurk_nn_1_N : N ;
  bondlaepp_nn_1_1_N : N ;
  boning_nn_1_N : N ;
  bonitering_nn_1_N : N ;
  bonnlaepp_nn_1_1_N : N ;
  boplatsgraevning_nn_1_1_N : N ;
  bordduk_nn_1_N : N ;
  bordlaeggning_nn_1_1_N : N ;
  bordning_nn_1_N : N ;
  bordsbestaellning_nn_1_1_N : N ;
  bordskniv_nn_1_N : N ;
  borgarbevaepning_nn_1_1_N : N ;
  bornering_nn_1_N : N ;
  borrhaalsvaegg_nn_1_1_N : N ;
  borrigg_nn_1_N : N ;
  borrning_nn_1_N : N ;
  borrplattform_nn_1_N : N ;
  borrsvaeng_nn_1_1_N : N ;
  borrutrustning_nn_1_N : N ;
  borstning_nn_1_N : N ;
  bortafoersaekring_nn_1_1_N : N ;
  bortarbetning_nn_1_N : N ;
  bortblaasning_nn_1_1_N : N ;
  bortdomning_nn_1_N : N ;
  bortdrivning_nn_1_N : N ;
  bortdoemning_nn_1_1_N : N ;
  bortforsling_nn_1_N : N ;
  bortfoerklaring_nn_1_1_N : N ;
  bortlaeggning_nn_1_1_N : N ;
  bortmotning_nn_1_N : N ;
  bortodling_nn_1_N : N ;
  bortrationalisering_nn_1_N : N ;
  bortresonering_nn_1_N : N ;
  bortryckning_nn_1_N : N ;
  bortskrivning_nn_1_N : N ;
  bortslumpning_nn_1_N : N ;
  bortspolning_nn_1_N : N ;
  bortstoetning_nn_1_1_N : N ;
  bortsaettning_nn_1_1_N : N ;
  borttraengning_nn_1_1_N : N ;
  borttvagning_nn_1_N : N ;
  boskapsstock_nn_1_N : N ;
  boskapsuppfoedning_nn_1_1_N : N ;
  bostadsfoermedling_nn_1_1_N : N ;
  bostadsraettsfoerening_nn_1_1_N : N ;
  bosaettning_nn_1_1_N : N ;
  botanisering_nn_1_N : N ;
  botgoering_nn_1_1_N : N ;
  botoxfoerlamning_nn_1_1_N : N ;
  bottenavlagring_nn_1_N : N ;
  bottenfaellning_nn_1_1_N : N ;
  bottenkvark_nn_1_N : N ;
  bottenkaenning_nn_1_1_N : N ;
  bottenstock_nn_1_N : N ;
  bottenvaaning_nn_1_1_N : N ;
  bottning_nn_1_N : N ;
  bouppteckning_nn_1_N : N ;
  boutredning_nn_1_N : N ;
  boxboll_nn_1_N : N ;
  boxning_nn_1_N : N ;
  boxningsring_nn_1_N : N ;
  boxningstraening_nn_1_1_N : N ;
  brainstorming_nn_1_N : N ;
  brakmiddag_nn_1_N : N ;
  brakskit_nn_1_N : N ;
  brandbil_nn_1_N : N ;
  branddoerr_nn_1_1_N : N ;
  brandfoersaekring_nn_1_1_N : N ;
  brandkaarsutryckning_nn_1_1_N : N ;
  brandskattning_nn_1_N : N ;
  brandskyddslagstiftning_nn_1_N : N ;
  brandslang_nn_1_N : N ;
  brandoevning_nn_1_1_N : N ;
  branschfoerening_nn_1_1_N : N ;
  branschtidning_nn_1_N : N ;
  breddning_nn_1_N : N ;
  bredvidlaesning_nn_1_1_N : N ;
  brevbaering_nn_1_1_N : N ;
  brevlapp_nn_1_N : N ;
  brevlaadetoemning_nn_1_1_N : N ;
  brevsamling_nn_1_N : N ;
  brevskoerd_nn_1_1_N : N ;
  brevstil_nn_1_N : N ;
  brevvaexling_nn_1_1_N : N ;
  brevvaag_nn_1_1_N : N ;
  brickduk_nn_1_N : N ;
  brickvaevning_nn_1_1_N : N ;
  brikettering_nn_1_N : N ;
  briljering_nn_1_N : N ;
  brisering_nn_1_N : N ;
  bristning_nn_1_N : N ;
  bristsjukdom_nn_1_N : N ;
  brobelastning_nn_1_N : N ;
  brodering_nn_1_N : N ;
  brodernaal_nn_1_1_N : N ;
  broderskaerlek_nn_1_1_N : N ;
  bromering_nn_1_N : N ;
  bromfoergiftning_nn_1_1_N : N ;
  bromsfading_nn_1_N : N ;
  bromsning_nn_1_N : N ;
  bromsstraalning_nn_1_1_N : N ;
  bronsering_nn_1_N : N ;
  bronsknapp_nn_1_N : N ;
  bronsaaldersgrav_nn_1_1_N : N ;
  broschering_nn_1_N : N ;
  broslagning_nn_1_N : N ;
  brottning_nn_1_N : N ;
  brottningsring_nn_1_N : N ;
  brottsbevakning_nn_1_N : N ;
  brottsplatsundersoekning_nn_1_1_N : N ;
  brottsrubricering_nn_1_N : N ;
  brottsutredning_nn_1_N : N ;
  brooeppning_nn_1_1_N : N ;
  brudklaenning_nn_1_1_N : N ;
  brudoeverlaemning_nn_1_1_N : N ;
  brukning_nn_1_N : N ;
  bruksanvisning_nn_1_N : N ;
  brukslev_nn_1_N : N ;
  brumbjoern_nn_1_1_N : N ;
  brunering_nn_1_N : N ;
  brunnsdrickning_nn_1_N : N ;
  brutalisering_nn_1_N : N ;
  bruttobehaallning_nn_1_1_N : N ;
  bryggarbil_nn_1_N : N ;
  bryggvaag_nn_1_1_N : N ;
  brytbladskniv_nn_1_N : N ;
  brytning_nn_1_N : N ;
  braeckkorv_nn_1_1_N : N ;
  braeckning_nn_1_1_N : N ;
  braedgaang_nn_1_1_N : N ;
  braedvaegg_nn_1_1_N : N ;
  braekning_nn_1_1_N : N ;
  braennboll_nn_2_1_N : N ;
  braenning_nn_1_1_N : N ;
  braennlackering_nn_1_1_N : N ;
  braennmaerkning_nn_1_1_N : N ;
  braennugn_nn_1_1_N : N ;
  braennvinsdestillering_nn_1_1_N : N ;
  braensleransonering_nn_1_1_N : N ;
  braesering_nn_1_1_N : N ;
  broedbit_nn_1_1_N : N ;
  broedburk_nn_1_1_N : N ;
  broedkniv_nn_1_1_N : N ;
  broellopsdag_nn_1_1_N : N ;
  broellopsklaenning_nn_1_1_N : N ;
  broestfoerstoring_nn_1_1_N : N ;
  broestgaang_nn_1_1_N : N ;
  broestning_nn_1_1_N : N ;
  broestpump_nn_1_1_N : N ;
  budgetering_nn_1_N : N ;
  budgivning_nn_1_N : N ;
  budkavleloepning_nn_1_1_N : N ;
  budning_nn_1_N : N ;
  buffertloesning_nn_1_1_N : N ;
  buggning_nn_1_N : N ;
  bugning_nn_1_N : N ;
  buktning_nn_1_N : N ;
  buljongtaerning_nn_1_1_N : N ;
  bullerskaerm_nn_1_1_N : N ;
  bultning_nn_1_N : N ;
  buntning_nn_1_N : N ;
  burkslav_nn_1_N : N ;
  buskoerning_nn_1_1_N : N ;
  busringning_nn_1_N : N ;
  bussavgaang_nn_1_1_N : N ;
  busskrock_nn_1_N : N ;
  bussning_nn_1_N : N ;
  busvissling_nn_1_N : N ;
  buteljering_nn_1_N : N ;
  butiksdoerr_nn_1_1_N : N ;
  butiksstaengningslag_nn_1_1_N : N ;
  bygdeborg_nn_1_N : N ;
  bygdegaard_nn_1_1_N : N ;
  byggarbetskran_nn_1_N : N ;
  byggflopp_nn_1_N : N ;
  bygglag_nn_1_N : N ;
  byggnadsstil_nn_1_N : N ;
  byggnadsstaellning_nn_1_1_N : N ;
  byggning_nn_1_N : N ;
  byggstaellning_nn_1_1_N : N ;
  byordning_nn_1_N : N ;
  byraakratisering_nn_1_1_N : N ;
  bysaettning_nn_1_1_N : N ;
  byteshushaallning_nn_1_1_N : N ;
  byvaeg_nn_1_1_N : N ;
  byxkjol_nn_1_N : N ;
  baeckenfoertraengning_nn_1_1_N : N ;
  baeckmynning_nn_1_1_N : N ;
  baeddning_nn_1_1_N : N ;
  baeddutrustning_nn_1_1_N : N ;
  baelteslaeggning_nn_1_1_N : N ;
  baendning_nn_1_1_N : N ;
  baergning_nn_1_1_N : N ;
  baergningsbil_nn_1_1_N : N ;
  baering_nn_1_1_N : N ;
  baerplansbaat_nn_1_1_N : N ;
  baerstol_nn_1_1_N : N ;
  baettring_nn_1_1_N : N ;
  baevning_nn_1_1_N : N ;
  baaggaang_nn_1_1_N : N ;
  baagstraeng_nn_1_1_N : N ;
  baagsvetsning_nn_1_1_N : N ;
  baagsaag_nn_1_1_N : N ;
  baalrullning_nn_1_1_N : N ;
  baatavgaang_nn_1_1_N : N ;
  baatgrav_nn_1_1_N : N ;
  baatklubb_nn_1_1_N : N ;
  baattaevling_nn_1_1_N : N ;
  boejning_nn_1_1_N : N ;
  boekning_nn_1_1_N : N ;
  boeljegaang_nn_1_1_N : N ;
  boelning_nn_1_1_N : N ;
  boenesal_nn_1_1_N : N ;
  boenpall_nn_1_1_N : N ;
  boersnotering_nn_1_1_N : N ;
  boersuppgaang_nn_1_1_N : N ;
  boessinsamling_nn_1_1_N : N ;
  calmettevaccinering_nn_1_N : N ;
  camouflering_nn_1_N : N ;
  cancerbehandling_nn_1_N : N ;
  cancerforskning_nn_1_N : N ;
  canceruppfoeljning_nn_1_1_N : N ;
  cannabisodling_nn_1_N : N ;
  canossavandring_nn_1_N : N ;
  cedering_nn_1_N : N ;
  cederskog_nn_1_N : N ;
  celebrering_nn_1_N : N ;
  cellandning_nn_1_N : N ;
  celldelning_nn_1_N : N ;
  cellgiftsbehandling_nn_1_N : N ;
  cellspaenning_nn_1_1_N : N ;
  celltraad_nn_1_1_N : N ;
  cellulosafoertunning_nn_1_1_N : N ;
  cellvaegg_nn_1_1_N : N ;
  cembalotillverkning_nn_1_N : N ;
  cementering_nn_1_N : N ;
  censurering_nn_1_N : N ;
  centralfoervaltning_nn_1_1_N : N ;
  centralisering_nn_1_N : N ;
  centralregering_nn_1_N : N ;
  centrering_nn_1_N : N ;
  centrifugalpump_nn_1_N : N ;
  centrifugering_nn_1_N : N ;
  cernering_nn_1_N : N ;
  certifiering_nn_1_N : N ;
  champagnebaergning_nn_1_1_N : N ;
  champagnekork_nn_1_N : N ;
  changering_nn_1_N : N ;
  changsering_nn_1_N : N ;
  chansering_nn_1_N : N ;
  chansning_nn_1_N : N ;
  chanstagning_nn_1_N : N ;
  chargering_nn_1_N : N ;
  charmering_nn_1_N : N ;
  charmkvark_nn_1_N : N ;
  checkraekning_nn_1_1_N : N ;
  chefsflytt_nn_1_N : N ;
  chefsstaellning_nn_1_1_N : N ;
  chevrotering_nn_1_N : N ;
  chiffonggarnering_nn_1_N : N ;
  chiffongklaenning_nn_1_1_N : N ;
  chiffrering_nn_1_N : N ;
  chikanering_nn_1_N : N ;
  chimpning_nn_1_N : N ;
  chockbehandling_nn_1_N : N ;
  chockering_nn_1_N : N ;
  chokladboll_nn_1_N : N ;
  cirkelsaag_nn_1_1_N : N ;
  cirkulationspump_nn_1_N : N ;
  cirkulationsrubbning_nn_1_N : N ;
  cirkulering_nn_1_N : N ;
  cirkusfoerestaellning_nn_1_1_N : N ;
  cirkusvagn_nn_1_N : N ;
  ciselering_nn_1_N : N ;
  cisterciensermunk_nn_1_N : N ;
  citering_nn_1_N : N ;
  civilbefolkning_nn_1_N : N ;
  civilbegravning_nn_1_N : N ;
  civilisering_nn_1_N : N ;
  civillag_nn_1_N : N ;
  cloisonvaegg_nn_1_1_N : N ;
  clubstek_nn_1_N : N ;
  cocktailbjudning_nn_1_N : N ;
  cortisonbehandling_nn_1_N : N ;
  coverlaat_nn_1_1_N : N ;
  cowboyhatt_nn_1_N : N ;
  crosshjaelm_nn_1_1_N : N ;
  curlingtaevling_nn_1_1_N : N ;
  cykelhjaelm_nn_1_1_N : N ;
  cykelkrock_nn_1_N : N ;
  cykelkrok_nn_1_N : N ;
  cykelpump_nn_1_N : N ;
  cykelram_nn_1_N : N ;
  cykelslang_nn_1_N : N ;
  cykeltaevling_nn_1_1_N : N ;
  cylinderhatt_nn_1_N : N ;
  dagavdelning_nn_1_N : N ;
  dagboksanteckning_nn_1_N : N ;
  dagbrytning_nn_1_N : N ;
  dagbraeckning_nn_1_1_N : N ;
  dagenefterstaemning_nn_1_1_N : N ;
  daggryning_nn_1_N : N ;
  dagjaemning_nn_1_1_N : N ;
  dagning_nn_1_N : N ;
  dagordning_nn_1_N : N ;
  dagskryssning_nn_1_N : N ;
  dagstidning_nn_1_N : N ;
  dagteckning_nn_1_N : N ;
  dagoeppning_nn_1_1_N : N ;
  dalgaang_nn_1_1_N : N ;
  dallring_nn_1_N : N ;
  dalmaalning_nn_1_1_N : N ;
  dalning_nn_1_N : N ;
  dalsluttning_nn_1_N : N ;
  dalslaenning_nn_1_1_N : N ;
  dalvind_nn_1_N : N ;
  damaskering_nn_1_N : N ;
  damastduk_nn_1_N : N ;
  dambjudning_nn_1_N : N ;
  damfrisering_nn_1_N : N ;
  dammanlaeggning_nn_1_1_N : N ;
  dammport_nn_1_N : N ;
  dammpump_nn_1_N : N ;
  dammsugarfoersaeljning_nn_1_1_N : N ;
  dammsugning_nn_1_N : N ;
  damning_nn_1_N : N ;
  damtidning_nn_1_N : N ;
  daning_nn_1_N : N ;
  danstillstaellning_nn_1_1_N : N ;
  darrning_nn_1_N : N ;
  dartpil_nn_1_N : N ;
  dataanlaeggning_nn_1_1_N : N ;
  databehandling_nn_1_N : N ;
  datainsamling_nn_1_N : N ;
  datakoerning_nn_1_1_N : N ;
  datasimulering_nn_1_N : N ;
  datering_nn_1_N : N ;
  datoranlaeggning_nn_1_1_N : N ;
  datorbehandling_nn_1_N : N ;
  datorberaekning_nn_1_1_N : N ;
  datorsimulering_nn_1_N : N ;
  datorsladd_nn_1_N : N ;
  datorutrustning_nn_1_N : N ;
  datummaerkning_nn_1_1_N : N ;
  datumparkering_nn_1_N : N ;
  debarkering_nn_1_N : N ;
  debattering_nn_1_N : N ;
  debitering_nn_1_N : N ;
  debutering_nn_1_N : N ;
  decentralisering_nn_1_N : N ;
  dechiffrering_nn_1_N : N ;
  decimering_nn_1_N : N ;
  deckardrottning_nn_1_N : N ;
  deckarkung_nn_1_N : N ;
  dedicering_nn_1_N : N ;
  dedikering_nn_1_N : N ;
  deducering_nn_1_N : N ;
  defilering_nn_1_N : N ;
  definiering_nn_1_N : N ;
  deflorering_nn_1_N : N ;
  deformering_nn_1_N : N ;
  degenerering_nn_1_N : N ;
  degradering_nn_1_N : N ;
  dekantering_nn_1_N : N ;
  dekapitering_nn_1_N : N ;
  deklamering_nn_1_N : N ;
  deklarering_nn_1_N : N ;
  deklassering_nn_1_N : N ;
  deklinering_nn_1_N : N ;
  dekolletering_nn_1_N : N ;
  dekorationsgran_nn_1_N : N ;
  dekorationsmaalning_nn_1_1_N : N ;
  dekorering_nn_1_N : N ;
  dekouragering_nn_1_N : N ;
  dekretering_nn_1_N : N ;
  delbetalning_nn_1_N : N ;
  delegering_nn_1_N : N ;
  delgivning_nn_1_N : N ;
  delkaskofoersaekring_nn_1_1_N : N ;
  delning_nn_1_N : N ;
  deltaevling_nn_1_1_N : N ;
  demaskering_nn_1_N : N ;
  demenssjukdom_nn_1_N : N ;
  dementering_nn_1_N : N ;
  demilitarisering_nn_1_N : N ;
  demissionering_nn_1_N : N ;
  demobilisering_nn_1_N : N ;
  demoinspelning_nn_1_N : N ;
  demokratisering_nn_1_N : N ;
  demokratiutveckling_nn_1_N : N ;
  demolering_nn_1_N : N ;
  demonstrering_nn_1_N : N ;
  demontering_nn_1_N : N ;
  demoralisering_nn_1_N : N ;
  denaturalisering_nn_1_N : N ;
  denaturering_nn_1_N : N ;
  denotering_nn_1_N : N ;
  denudering_nn_1_N : N ;
  denuklearisering_nn_1_N : N ;
  deodorisering_nn_1_N : N ;
  depatriering_nn_1_N : N ;
  depensering_nn_1_N : N ;
  deplacering_nn_1_N : N ;
  deponering_nn_1_N : N ;
  deportering_nn_1_N : N ;
  depreciering_nn_1_N : N ;
  derangering_nn_1_N : N ;
  derivering_nn_1_N : N ;
  desarmering_nn_1_N : N ;
  desavouering_nn_1_N : N ;
  desensibilisering_nn_1_N : N ;
  desertering_nn_1_N : N ;
  designering_nn_1_N : N ;
  designtaevling_nn_1_1_N : N ;
  desinfektering_nn_1_N : N ;
  desinficering_nn_1_N : N ;
  desinformering_nn_1_N : N ;
  desorganisering_nn_1_N : N ;
  desorientering_nn_1_N : N ;
  dessertkniv_nn_1_N : N ;
  dessertsked_nn_1_N : N ;
  desserttallrik_nn_1_N : N ;
  destillering_nn_1_N : N ;
  destinering_nn_1_N : N ;
  destruering_nn_1_N : N ;
  destruktionsanlaeggning_nn_1_1_N : N ;
  detachering_nn_1_N : N ;
  detaljanmaerkning_nn_1_1_N : N ;
  detaljering_nn_1_N : N ;
  detaljkaennedom_nn_1_1_N : N ;
  detaljrikedom_nn_1_N : N ;
  detaljritning_nn_1_N : N ;
  detektering_nn_1_N : N ;
  determinering_nn_1_N : N ;
  detonering_nn_1_N : N ;
  detronisering_nn_1_N : N ;
  devalvering_nn_1_N : N ;
  deviering_nn_1_N : N ;
  diagnosticering_nn_1_N : N ;
  diagnostisering_nn_1_N : N ;
  dialysering_nn_1_N : N ;
  diamantring_nn_1_N : N ;
  dieselpump_nn_1_N : N ;
  differentiering_nn_1_N : N ;
  diffundering_nn_1_N : N ;
  diftongering_nn_1_N : N ;
  digerering_nn_1_N : N ;
  digivning_nn_1_N : N ;
  dikeskoerning_nn_1_1_N : N ;
  dikning_nn_1_N : N ;
  diktarbegaavning_nn_1_1_N : N ;
  diktering_nn_1_N : N ;
  diktning_nn_1_N : N ;
  diktsamling_nn_1_N : N ;
  dimbildning_nn_1_N : N ;
  dimensionering_nn_1_N : N ;
  dimensionsavverkning_nn_1_N : N ;
  dinering_nn_1_N : N ;
  diplomering_nn_1_N : N ;
  direktinsprutning_nn_1_N : N ;
  direktsaendning_nn_1_1_N : N ;
  direkttraeff_nn_1_1_N : N ;
  dirigering_nn_1_N : N ;
  disciplinering_nn_1_N : N ;
  disharmoniering_nn_1_N : N ;
  diskning_nn_2_N : N ;
  diskontering_nn_1_N : N ;
  diskreditering_nn_1_N : N ;
  diskriminering_nn_1_N : N ;
  diskrimineringslagstiftning_nn_1_N : N ;
  disktorkning_nn_1_N : N ;
  diskuskastning_nn_1_N : N ;
  diskutering_nn_1_N : N ;
  diskvalificering_nn_1_N : N ;
  dispaschering_nn_1_N : N ;
  dispensering_nn_1_N : N ;
  dispergering_nn_1_N : N ;
  disponering_nn_1_N : N ;
  disputering_nn_1_N : N ;
  dissekering_nn_1_N : N ;
  dissociering_nn_1_N : N ;
  dissonering_nn_1_N : N ;
  distansering_nn_1_N : N ;
  distansflygning_nn_1_N : N ;
  distansundervisning_nn_1_N : N ;
  distrahering_nn_1_N : N ;
  distribuering_nn_1_N : N ;
  divergering_nn_1_N : N ;
  diversifiering_nn_1_N : N ;
  dividering_nn_1_N : N ;
  djupavslappning_nn_1_N : N ;
  djupborrning_nn_1_N : N ;
  djupbrytning_nn_1_N : N ;
  djupdykning_nn_1_N : N ;
  djuphavsgrav_nn_1_N : N ;
  djuplek_nn_1_N : N ;
  djuplodning_nn_1_N : N ;
  djuptallrik_nn_1_N : N ;
  djupurladdning_nn_1_N : N ;
  djurfoeraedling_nn_1_1_N : N ;
  djurskyddsfoerening_nn_1_1_N : N ;
  djurskyddslagstiftning_nn_1_N : N ;
  djurutstaellning_nn_1_1_N : N ;
  dna_sekvensering_nn_1_N : N ;
  dna_straeng_nn_1_1_N : N ;
  dna_testning_nn_1_N : N ;
  dna_uppsaettning_nn_1_1_N : N ;
  docering_nn_2_N : N ;
  doftmarkering_nn_1_N : N ;
  dogmatisering_nn_1_N : N ;
  doktorering_nn_1_N : N ;
  doktorsavhandling_nn_1_N : N ;
  doktorshatt_nn_1_N : N ;
  doktorsring_nn_1_N : N ;
  dokumentering_nn_1_N : N ;
  dokumentsamling_nn_1_N : N ;
  dolkstoet_nn_1_1_N : N ;
  domarring_nn_1_N : N ;
  domdering_nn_1_N : N ;
  domedagspredikning_nn_1_N : N ;
  domedagsstaemning_nn_1_1_N : N ;
  domesticering_nn_1_N : N ;
  domiciliering_nn_1_N : N ;
  dominering_nn_1_N : N ;
  dominikanermunk_nn_1_N : N ;
  dominikanmunk_nn_1_N : N ;
  domkyrkofoersamling_nn_1_1_N : N ;
  domning_nn_1_N : N ;
  domptering_nn_1_N : N ;
  domstolsfoerhandling_nn_1_1_N : N ;
  donationsjord_nn_1_N : N ;
  donering_nn_1_N : N ;
  dopning_nn_1_N : N ;
  doppning_nn_1_N : N ;
  dosering_nn_1_N : N ;
  dossering_nn_1_N : N ;
  dotering_nn_1_N : N ;
  dotterfoersamling_nn_1_1_N : N ;
  drabbning_nn_1_N : N ;
  dragering_nn_1_N : N ;
  draggning_nn_1_N : N ;
  dragkrok_nn_1_N : N ;
  draglapp_nn_1_N : N ;
  dragning_nn_1_N : N ;
  dragpressning_nn_1_N : N ;
  dragupprepning_nn_1_N : N ;
  dragvaeg_nn_1_1_N : N ;
  dramatisering_nn_1_N : N ;
  drapering_nn_1_N : N ;
  dressering_nn_1_N : N ;
  dressyrridning_nn_1_N : N ;
  dribbling_nn_1_N : N ;
  drickning_nn_1_N : N ;
  drivning_nn_1_N : N ;
  droppkork_nn_1_N : N ;
  droskbil_nn_1_N : N ;
  drullefoersaekring_nn_1_1_N : N ;
  drunkning_nn_1_N : N ;
  dryftning_nn_1_N : N ;
  drypning_nn_1_N : N ;
  draenering_nn_1_1_N : N ;
  droemtydning_nn_1_1_N : N ;
  droemvaerld_nn_1_1_N : N ;
  dubbelbindning_nn_1_N : N ;
  dubbelbluff_nn_1_N : N ;
  dubbelbrytning_nn_1_N : N ;
  dubbeldoerr_nn_1_1_N : N ;
  dubbelexponering_nn_1_N : N ;
  dubbelmening_nn_1_N : N ;
  dubbelsaekring_nn_1_1_N : N ;
  dubbeltraeff_nn_1_1_N : N ;
  dubbeloern_nn_1_1_N : N ;
  dubblering_nn_1_N : N ;
  dubbning_nn_1_N : N ;
  duellering_nn_1_N : N ;
  dukagaang_nn_1_1_N : N ;
  dukning_nn_1_N : N ;
  dumpning_nn_1_N : N ;
  dunboll_nn_1_N : N ;
  dundergud_nn_1_N : N ;
  dunkning_nn_1_N : N ;
  dupering_nn_1_N : N ;
  duplicering_nn_1_N : N ;
  duschslang_nn_1_N : N ;
  duschvaegg_nn_1_1_N : N ;
  duvning_nn_1_N : N ;
  dygnsring_nn_1_N : N ;
  dykarutrustning_nn_1_N : N ;
  dykning_nn_1_N : N ;
  dynggrep_nn_1_N : N ;
  dyning_nn_1_N : N ;
  dypoel_nn_1_1_N : N ;
  dyrortsgruppering_nn_1_N : N ;
  dyvik_2_nn_1_N : N ;
  daeckmaerkning_nn_1_1_N : N ;
  daemning_nn_1_1_N : N ;
  daempning_nn_1_1_N : N ;
  daaning_nn_1_1_N : N ;
  doed_nn_1_1_N : N ;
  doedsdom_nn_1_1_N : N ;
  doedsflygning_nn_1_1_N : N ;
  doedsryckning_nn_1_1_N : N ;
  doedsskjutning_nn_1_1_N : N ;
  doerroeppning_nn_1_1_N : N ;
  doevning_nn_1_1_N : N ;
  e_tidning_nn_1_N : N ;
  edering_nn_1_N : N ;
  edgaang_nn_1_1_N : N ;
  effacering_nn_1_N : N ;
  effektivering_nn_1_N : N ;
  effektivisering_nn_1_N : N ;
  effektuering_nn_1_N : N ;
  effektoekning_nn_1_1_N : N ;
  efterapning_nn_1_N : N ;
  efterbesiktning_nn_1_N : N ;
  efterbeskattning_nn_1_N : N ;
  efterbestaellning_nn_1_1_N : N ;
  efterbevakning_nn_1_N : N ;
  efterbildning_nn_1_N : N ;
  efterblomning_nn_1_N : N ;
  efterblomstring_nn_1_N : N ;
  efterbloedning_nn_1_1_N : N ;
  efterdatering_nn_1_N : N ;
  efterdebitering_nn_1_N : N ;
  efterdyning_nn_1_N : N ;
  efterforskning_nn_1_N : N ;
  efterfraagning_nn_1_1_N : N ;
  eftergranskning_nn_1_N : N ;
  efterhaermning_nn_1_1_N : N ;
  efterjaesning_nn_1_1_N : N ;
  efterkokning_nn_1_N : N ;
  efterkaenning_nn_1_1_N : N ;
  efterlysning_nn_1_N : N ;
  efterlaemning_nn_1_1_N : N ;
  eftermiddag_nn_1_N : N ;
  eftermiddagsrusning_nn_1_N : N ;
  efterproevning_nn_1_1_N : N ;
  efterrationalisering_nn_1_N : N ;
  efterraekning_nn_1_1_N : N ;
  efterskalv_nn_1_N : N ;
  efterslaeckning_nn_1_1_N : N ;
  efterslaepning_nn_1_1_N : N ;
  efterspaning_nn_1_N : N ;
  efterstavning_nn_1_N : N ;
  eftersupning_nn_1_N : N ;
  eftersynkronisering_nn_1_N : N ;
  eftersaegning_nn_1_1_N : N ;
  eftersaendning_nn_1_1_N : N ;
  eftersoekning_nn_1_1_N : N ;
  eftertaxering_nn_1_N : N ;
  efterundersoekning_nn_1_1_N : N ;
  efterutbildning_nn_1_N : N ;
  efterverkning_nn_1_N : N ;
  egalisering_nn_1_N : N ;
  egendom_nn_1_N : N ;
  egendomsfoersaekring_nn_1_1_N : N ;
  egendomsfoersaeljning_nn_1_1_N : N ;
  egenkaerlek_nn_1_1_N : N ;
  egensvaengning_nn_1_1_N : N ;
  egoboostning_nn_1_N : N ;
  ejakulering_nn_1_N : N ;
  ekdoerr_nn_1_1_N : N ;
  ekipering_nn_1_N : N ;
  eklatering_nn_1_N : N ;
  eklaerering_nn_1_1_N : N ;
  ekonomiavdelning_nn_1_N : N ;
  ekonomifoerpackning_nn_1_1_N : N ;
  ekonomisering_nn_1_N : N ;
  ekonomiutbildning_nn_1_N : N ;
  ekonomutbildning_nn_1_N : N ;
  ekskog_nn_1_N : N ;
  ekstock_nn_1_N : N ;
  elaborering_nn_1_N : N ;
  elastisering_nn_1_N : N ;
  elavlaesning_nn_1_1_N : N ;
  elbil_nn_1_N : N ;
  eldgivning_nn_1_N : N ;
  eldledning_nn_1_N : N ;
  eldning_nn_1_N : N ;
  eldsignalering_nn_1_N : N ;
  eldslaeckning_nn_1_1_N : N ;
  eldstaellning_nn_1_1_N : N ;
  elektrificering_nn_1_N : N ;
  elektrifiering_nn_1_N : N ;
  elektrisering_nn_1_N : N ;
  elektronparbindning_nn_1_N : N ;
  elementarladdning_nn_1_N : N ;
  elfenbensbit_nn_1_N : N ;
  elfoerbrukning_nn_1_1_N : N ;
  elfoersoerjning_nn_1_1_N : N ;
  elhybridbil_nn_1_N : N ;
  elidering_nn_1_N : N ;
  eliminering_nn_1_N : N ;
  elkedjesaag_nn_1_1_N : N ;
  elkoppling_nn_1_N : N ;
  elledning_nn_1_N : N ;
  eloxering_nn_1_N : N ;
  eludering_nn_1_N : N ;
  eluering_nn_1_N : N ;
  elvaaaring_nn_1_1_N : N ;
  elaendesskildring_nn_1_1_N : N ;
  emaljering_nn_1_N : N ;
  emaljfyllning_nn_1_N : N ;
  emaljinlaeggning_nn_1_1_N : N ;
  emaljmaalning_nn_1_1_N : N ;
  emancipering_nn_1_N : N ;
  emanering_nn_1_N : N ;
  emballering_nn_1_N : N ;
  embarkering_nn_1_N : N ;
  embellering_nn_1_N : N ;
  emendering_nn_1_N : N ;
  emigrering_nn_1_N : N ;
  emittering_nn_1_N : N ;
  empirestil_nn_1_N : N ;
  emulgering_nn_1_N : N ;
  endossering_nn_1_N : N ;
  energieffektivisering_nn_1_N : N ;
  energifoersoerjning_nn_1_1_N : N ;
  energiomstaellning_nn_1_1_N : N ;
  energiomsaettning_nn_1_1_N : N ;
  energiomvandling_nn_1_N : N ;
  energiskog_nn_1_N : N ;
  energiutstraalning_nn_1_1_N : N ;
  energiutveckling_nn_1_N : N ;
  enervering_nn_1_N : N ;
  enfoting_nn_1_N : N ;
  engagering_nn_1_N : N ;
  engaangstallrik_nn_1_1_N : N ;
  enhetsladdning_nn_1_N : N ;
  enhjuling_nn_1_N : N ;
  enhoerning_nn_1_1_N : N ;
  enkelknaeppning_nn_1_1_N : N ;
  enkaetundersoekning_nn_1_1_N : N ;
  enlevering_nn_1_N : N ;
  enmansfoerestaellning_nn_1_1_N : N ;
  enmansgrav_nn_1_N : N ;
  enrollering_nn_1_N : N ;
  ensamflygning_nn_1_N : N ;
  ensamgaard_nn_1_1_N : N ;
  ensamvarg_nn_1_N : N ;
  ensilering_nn_1_N : N ;
  enstensmur_nn_1_N : N ;
  entr_edoerr_nn_1_1_N : N ;
  entusiasmering_nn_1_N : N ;
  epilering_nn_1_N : N ;
  erfarenhetsvaerld_nn_1_1_N : N ;
  erigering_nn_1_N : N ;
  erinring_nn_1_N : N ;
  erodering_nn_1_N : N ;
  ersaettning_nn_1_1_N : N ;
  ertappning_nn_1_N : N ;
  eroevring_nn_1_1_N : N ;
  eskalering_nn_1_N : N ;
  eskortering_nn_1_N : N ;
  essaysamling_nn_1_N : N ;
  essaesamling_nn_1_1_N : N ;
  esteticering_nn_1_N : N ;
  estetisering_nn_1_N : N ;
  estimering_nn_1_N : N ;
  etablering_nn_1_N : N ;
  etagevaaning_nn_1_1_N : N ;
  etanolbil_nn_1_N : N ;
  eterisering_nn_1_N : N ;
  etikettering_nn_1_N : N ;
  etiolering_nn_1_N : N ;
  etsning_nn_1_N : N ;
  ettaaring_nn_1_1_N : N ;
  ettoering_nn_1_1_N : N ;
  etymologisering_nn_1_N : N ;
  europavaeg_nn_1_1_N : N ;
  europeisering_nn_1_N : N ;
  evakuering_nn_1_N : N ;
  evaluering_nn_1_N : N ;
  evalvering_nn_1_N : N ;
  evangelisering_nn_1_N : N ;
  evaporering_nn_1_N : N ;
  evolutionsforskning_nn_1_N : N ;
  examinering_nn_1_N : N ;
  excellering_nn_1_N : N ;
  excerpering_nn_1_N : N ;
  excitering_nn_1_N : N ;
  exekvering_nn_1_N : N ;
  exempelsamling_nn_1_N : N ;
  exemplifiering_nn_1_N : N ;
  exercering_nn_1_N : N ;
  exkludering_nn_1_N : N ;
  exkommunicering_nn_1_N : N ;
  exkung_nn_1_N : N ;
  expandering_nn_1_N : N ;
  expatriering_nn_1_N : N ;
  expediering_nn_1_N : N ;
  expeditionsregering_nn_1_N : N ;
  expektorering_nn_1_N : N ;
  experimentering_nn_1_N : N ;
  explicering_nn_1_N : N ;
  exploatering_nn_1_N : N ;
  explodering_nn_1_N : N ;
  exponering_nn_1_N : N ;
  exportering_nn_1_N : N ;
  expropriering_nn_1_N : N ;
  exstirpering_nn_1_N : N ;
  extemporering_nn_1_N : N ;
  exterioerbedoemning_nn_1_1_N : N ;
  extrahering_nn_1_N : N ;
  extrapolering_nn_1_N : N ;
  extremskidaakning_nn_1_1_N : N ;
  fabricering_nn_1_N : N ;
  fabriksport_nn_1_N : N ;
  fabulering_nn_1_N : N ;
  facettering_nn_1_N : N ;
  fackfoerening_nn_1_1_N : N ;
  fackklubb_nn_1_N : N ;
  faktagranskning_nn_1_N : N ;
  fakturering_nn_1_N : N ;
  fallbeskrivning_nn_1_N : N ;
  fallering_nn_1_N : N ;
  fallskaerm_nn_1_1_N : N ;
  fallvind_nn_1_N : N ;
  falsifiering_nn_1_N : N ;
  falskskyltning_nn_1_N : N ;
  falukorv_nn_1_N : N ;
  familjegrav_nn_1_N : N ;
  familjemiddag_nn_1_N : N ;
  familjepenning_nn_1_N : N ;
  familjeplanering_nn_1_N : N ;
  familjeraadgivning_nn_1_1_N : N ;
  familjeunderhaallning_nn_1_1_N : N ;
  fantasivaerld_nn_1_1_N : N ;
  fantisering_nn_1_N : N ;
  fardag_nn_1_N : N ;
  fartminskning_nn_1_N : N ;
  fartspaerr_nn_1_1_N : N ;
  fartygsbesaettning_nn_1_1_N : N ;
  fartygsstormning_nn_1_N : N ;
  fartygstjaenstgoering_nn_1_1_N : N ;
  fascinering_nn_1_N : N ;
  fasettering_nn_1_N : N ;
  fasfoerskjutning_nn_1_1_N : N ;
  faskinkniv_nn_1_N : N ;
  fasonering_nn_1_N : N ;
  fasspaenning_nn_1_1_N : N ;
  fastbindning_nn_1_N : N ;
  fasthaallning_nn_1_1_N : N ;
  fastighetsfoersaeljning_nn_1_1_N : N ;
  fastighetstaxering_nn_1_N : N ;
  fastlaenning_nn_1_1_N : N ;
  fastsaettning_nn_1_1_N : N ;
  fasttagning_nn_1_N : N ;
  fattigdom_nn_1_N : N ;
  fattigdomsminskning_nn_1_N : N ;
  fattning_nn_1_N : N ;
  favorisering_nn_1_N : N ;
  febersjukdom_nn_1_N : N ;
  fejning_nn_1_N : N ;
  felbedoemning_nn_1_1_N : N ;
  felbehandling_nn_1_N : N ;
  felberaekning_nn_1_1_N : N ;
  felhandling_nn_1_N : N ;
  felinvestering_nn_1_N : N ;
  fellaesning_nn_1_1_N : N ;
  felnavigering_nn_1_N : N ;
  felparkering_nn_1_N : N ;
  felraekning_nn_1_1_N : N ;
  felsatsning_nn_1_N : N ;
  felskrivning_nn_1_N : N ;
  felsaegning_nn_1_1_N : N ;
  feltolkning_nn_1_N : N ;
  felutveckling_nn_1_N : N ;
  femdelning_nn_1_N : N ;
  femtiooering_nn_1_1_N : N ;
  femtioering_nn_1_1_N : N ;
  femtonaaring_nn_1_1_N : N ;
  femaaring_nn_1_1_N : N ;
  femoering_nn_1_1_N : N ;
  fermentering_nn_1_N : N ;
  ferrolegering_nn_1_N : N ;
  festdag_nn_1_N : N ;
  festivalluff_nn_1_N : N ;
  festklaenning_nn_1_1_N : N ;
  festmiddag_nn_1_N : N ;
  festsal_nn_1_N : N ;
  feststaemning_nn_1_1_N : N ;
  festvaaning_nn_1_1_N : N ;
  fetering_nn_1_N : N ;
  fettfoerbraenning_nn_1_1_N : N ;
  fetthaerdning_nn_1_1_N : N ;
  fettklump_nn_1_N : N ;
  fiberblandning_nn_1_N : N ;
  fickkniv_nn_1_N : N ;
  fickparkering_nn_1_N : N ;
  figurering_nn_1_N : N ;
  figurteckning_nn_1_N : N ;
  figuraakning_nn_1_1_N : N ;
  fildelning_nn_1_N : N ;
  filering_nn_1_N : N ;
  filibustring_nn_1_N : N ;
  filkoerning_nn_1_1_N : N ;
  filmatisering_nn_1_N : N ;
  filmframkallning_nn_1_N : N ;
  filmgranskning_nn_1_N : N ;
  filminspelning_nn_1_N : N ;
  filmklippning_nn_1_N : N ;
  filmning_nn_1_N : N ;
  filmsnutt_nn_1_N : N ;
  filmvisning_nn_1_N : N ;
  filning_nn_1_N : N ;
  filosofering_nn_1_N : N ;
  filthatt_nn_1_N : N ;
  filtrering_nn_1_N : N ;
  fimpsug_nn_1_N : N ;
  finansfoervaltning_nn_1_1_N : N ;
  finanshaj_nn_1_N : N ;
  finansiering_nn_1_N : N ;
  fingering_nn_1_N : N ;
  fingerknaeppning_nn_1_1_N : N ;
  fingerring_nn_1_N : N ;
  fingersaettning_nn_1_1_N : N ;
  fingervisning_nn_1_N : N ;
  finingaang_nn_1_1_N : N ;
  finjustering_nn_1_N : N ;
  finkamning_nn_1_N : N ;
  finlandisering_nn_1_N : N ;
  finlek_nn_1_N : N ;
  fintvaett_nn_1_1_N : N ;
  fiolstraeng_nn_1_1_N : N ;
  firmateckning_nn_1_N : N ;
  firning_nn_1_N : N ;
  fiskdamm_nn_1_N : N ;
  fiskebaat_nn_1_1_N : N ;
  fiskebaatsbesaettning_nn_1_1_N : N ;
  fiskekrok_nn_1_N : N ;
  fiskelag_nn_1_N : N ;
  fiskkrok_nn_1_N : N ;
  fiskodling_nn_1_N : N ;
  fiskstjaert_nn_1_1_N : N ;
  fiskvandring_nn_1_N : N ;
  fixering_nn_1_N : N ;
  fjortonaaring_nn_1_1_N : N ;
  fjaederboll_nn_1_1_N : N ;
  fjaedervaag_nn_1_1_N : N ;
  fjaedring_nn_1_1_N : N ;
  fjaellning_nn_1_1_N : N ;
  fjaellsluttning_nn_1_1_N : N ;
  fjaelltopp_nn_1_1_N : N ;
  fjaellvandring_nn_1_1_N : N ;
  fjaerding_nn_1_1_N : N ;
  fjaerrblockering_nn_1_1_N : N ;
  fjaerrvaermegranskning_nn_1_1_N : N ;
  flaggbraenning_nn_1_1_N : N ;
  flaggdag_nn_1_N : N ;
  flaggning_nn_1_N : N ;
  flaggskaendning_nn_1_1_N : N ;
  flaggviftning_nn_1_N : N ;
  flakvagn_nn_1_N : N ;
  flambering_nn_1_N : N ;
  flanering_nn_1_N : N ;
  flankering_nn_1_N : N ;
  flaskkastning_nn_1_N : N ;
  flaskoeppning_nn_1_1_N : N ;
  flattering_nn_1_N : N ;
  flaxning_nn_1_N : N ;
  flektering_nn_1_N : N ;
  flerording_nn_1_N : N ;
  flexislang_nn_1_N : N ;
  flodbaat_nn_1_1_N : N ;
  flodgud_nn_1_N : N ;
  flodmynning_nn_1_N : N ;
  floppsatsning_nn_1_N : N ;
  florering_nn_1_N : N ;
  florettfaektning_nn_1_1_N : N ;
  flottflaeck_nn_1_1_N : N ;
  flottning_nn_1_N : N ;
  flottoevning_nn_1_1_N : N ;
  flugsvamp_nn_1_N : N ;
  fluidisering_nn_1_N : N ;
  fluktuering_nn_1_N : N ;
  fluorbehandling_nn_1_N : N ;
  fluorering_nn_1_N : N ;
  fluorescering_nn_1_N : N ;
  fluoridering_nn_1_N : N ;
  flygavgaang_nn_1_1_N : N ;
  flygkapning_nn_1_N : N ;
  flygledning_nn_1_N : N ;
  flygning_nn_1_N : N ;
  flygplansbesaettning_nn_1_1_N : N ;
  flygplatsservering_nn_1_N : N ;
  flygstol_nn_1_N : N ;
  flygstoerning_nn_1_1_N : N ;
  flygutbildning_nn_1_N : N ;
  flygvaeg_nn_1_1_N : N ;
  flyktingmottagning_nn_1_N : N ;
  flyktvaeg_nn_1_1_N : N ;
  flytning_nn_1_N : N ;
  flyttning_nn_1_N : N ;
  flytvaestlag_nn_1_1_N : N ;
  flaeckborttagning_nn_1_1_N : N ;
  flaekning_nn_1_1_N : N ;
  flaektning_nn_1_1_N : N ;
  flaemtning_nn_1_1_N : N ;
  flaengning_nn_1_1_N : N ;
  flaeskkorv_nn_1_1_N : N ;
  flaesklaegg_nn_1_1_N : N ;
  flaesklaepp_nn_1_1_N : N ;
  flaetning_nn_1_1_N : N ;
  flaahackning_nn_1_1_N : N ;
  flaasning_nn_1_1_N : N ;
  fnissning_nn_1_N : N ;
  fnysning_nn_1_N : N ;
  fobitraening_nn_1_1_N : N ;
  fockning_nn_1_N : N ;
  fogning_nn_1_N : N ;
  fogstrykning_nn_1_N : N ;
  fokusering_nn_1_N : N ;
  foliehatt_nn_1_N : N ;
  foliering_nn_1_N : N ;
  folkbildning_nn_1_N : N ;
  folkbokfoering_nn_1_1_N : N ;
  folkdiktning_nn_1_N : N ;
  folkdomstol_nn_1_N : N ;
  folkfoerdrivning_nn_1_1_N : N ;
  folkfoersamling_nn_1_1_N : N ;
  folkhop_nn_1_N : N ;
  folklek_nn_1_N : N ;
  folklivsforskning_nn_1_N : N ;
  folklivsskildring_nn_1_N : N ;
  folkminskning_nn_1_N : N ;
  folkomflyttning_nn_1_N : N ;
  folkomroestning_nn_1_1_N : N ;
  folkresning_nn_1_N : N ;
  folkraekning_nn_1_1_N : N ;
  folksamling_nn_1_N : N ;
  folksjukdom_nn_1_N : N ;
  folkvandring_nn_1_N : N ;
  folkoekning_nn_1_1_N : N ;
  fondering_nn_1_N : N ;
  fondmaalning_nn_1_1_N : N ;
  fontaenkraekning_nn_1_1_N : N ;
  fontaenpump_nn_1_1_N : N ;
  forcering_nn_1_N : N ;
  fordonsuppstaellning_nn_1_1_N : N ;
  fordring_nn_1_N : N ;
  formalisering_nn_1_N : N ;
  formbildning_nn_1_N : N ;
  formering_nn_1_N : N ;
  formfullaendning_nn_1_1_N : N ;
  formgivning_nn_1_N : N ;
  formning_nn_1_N : N ;
  formpressning_nn_1_N : N ;
  formrikedom_nn_1_N : N ;
  formulering_nn_1_N : N ;
  fornlaemning_nn_1_1_N : N ;
  fornminnesfoerening_nn_1_1_N : N ;
  fornminneslag_nn_1_N : N ;
  fornminnessamling_nn_1_N : N ;
  fornminnesskylt_nn_1_N : N ;
  forskarutbildning_nn_1_N : N ;
  forskning_nn_1_N : N ;
  forskningsfinansiering_nn_1_N : N ;
  forskningsinriktning_nn_1_N : N ;
  forsraenning_nn_1_1_N : N ;
  fortbildning_nn_1_N : N ;
  fortifikationsfoervaltning_nn_1_1_N : N ;
  fortkoerning_nn_1_1_N : N ;
  fortplantning_nn_1_N : N ;
  fortskridning_nn_1_N : N ;
  fortsaettning_nn_1_1_N : N ;
  forumtidning_nn_1_N : N ;
  fosfatering_nn_1_N : N ;
  fosforescering_nn_1_N : N ;
  fossilgasledning_nn_1_N : N ;
  fossilisering_nn_1_N : N ;
  fossilminskning_nn_1_N : N ;
  fossilsamling_nn_1_N : N ;
  fosterfoerdrivning_nn_1_1_N : N ;
  fosterutveckling_nn_1_N : N ;
  fotbjudning_nn_1_N : N ;
  fotboll_nn_2_N : N ;
  fotogendunk_nn_1_N : N ;
  fotografering_nn_1_N : N ;
  fotokopiering_nn_1_N : N ;
  fotostatkopiering_nn_1_N : N ;
  fotosaettning_nn_1_1_N : N ;
  fotpall_nn_1_N : N ;
  fotstaellning_nn_1_1_N : N ;
  fotvandring_nn_1_N : N ;
  fraktionering_nn_1_N : N ;
  frakturstil_nn_1_N : N ;
  frambesvaerjning_nn_1_1_N : N ;
  framflyttning_nn_1_N : N ;
  framfoerhaallning_nn_1_1_N : N ;
  framgaang_nn_1_1_N : N ;
  framgaangsvind_nn_1_1_N : N ;
  framkallning_nn_1_N : N ;
  framkropp_nn_1_N : N ;
  framkoerning_nn_1_1_N : N ;
  framladdning_nn_1_N : N ;
  framlaeggning_nn_1_1_N : N ;
  frammaning_nn_1_N : N ;
  frammatning_nn_1_N : N ;
  frampressning_nn_1_N : N ;
  framryckning_nn_1_N : N ;
  framskjutning_nn_1_N : N ;
  framspelning_nn_1_N : N ;
  framstaellning_nn_1_1_N : N ;
  framsaegning_nn_1_1_N : N ;
  framtagning_nn_1_N : N ;
  framtidsforskning_nn_1_N : N ;
  framtidssatsning_nn_1_N : N ;
  framtoning_nn_1_N : N ;
  framvisning_nn_1_N : N ;
  franciskanermunk_nn_1_N : N ;
  frankering_nn_1_N : N ;
  frappering_nn_1_N : N ;
  frasering_nn_1_N : N ;
  fraternisering_nn_1_N : N ;
  fredag_nn_1_N : N ;
  fredagsmiddag_nn_1_N : N ;
  fredsdomstol_nn_1_N : N ;
  fredsforskning_nn_1_N : N ;
  fredsfoerening_nn_1_1_N : N ;
  fredsfoerhandling_nn_1_1_N : N ;
  frekvensmodulering_nn_1_N : N ;
  frekventering_nn_1_N : N ;
  freskomaalning_nn_1_1_N : N ;
  fribrottning_nn_1_N : N ;
  fridag_nn_1_N : N ;
  fridlysning_nn_1_N : N ;
  fridskraenkning_nn_1_1_N : N ;
  frifoersamling_nn_1_1_N : N ;
  frigivning_nn_1_N : N ;
  frihandsteckning_nn_1_N : N ;
  frikoppling_nn_1_N : N ;
  frikyrkofoersamling_nn_1_1_N : N ;
  frikoepning_nn_1_1_N : N ;
  friluftsskog_nn_1_N : N ;
  frimaerkssamling_nn_1_1_N : N ;
  frisering_nn_1_N : N ;
  friskrivning_nn_1_N : N ;
  friskytt_nn_1_N : N ;
  frispark_nn_1_N : N ;
  frisoerstol_nn_1_1_N : N ;
  fritagning_nn_1_N : N ;
  fritering_nn_1_N : N ;
  fritidsbaat_nn_1_1_N : N ;
  fritidsfoervaltning_nn_1_1_N : N ;
  fritidssysselsaettning_nn_1_1_N : N ;
  frityrdeg_nn_1_N : N ;
  friaakning_nn_1_1_N : N ;
  frondering_nn_1_N : N ;
  frontalkrock_nn_1_N : N ;
  frontallobsstoerning_nn_1_1_N : N ;
  frontbildning_nn_1_N : N ;
  frontkommendering_nn_1_N : N ;
  fronttjaenstgoering_nn_1_1_N : N ;
  frossbrytning_nn_1_N : N ;
  frostspraengning_nn_1_1_N : N ;
  frottering_nn_1_N : N ;
  frott_erock_nn_1_1_N : N ;
  frukostering_nn_1_N : N ;
  fruktbarhetsgud_nn_1_N : N ;
  fruktkniv_nn_1_N : N ;
  fruktkorg_nn_1_N : N ;
  fruktodling_nn_1_N : N ;
  fruktskaal_nn_1_1_N : N ;
  fruktsaettning_nn_1_1_N : N ;
  frukttraedgaard_nn_1_1_N : N ;
  frusning_nn_1_N : N ;
  frustning_nn_1_N : N ;
  frustrering_nn_1_N : N ;
  frysfoerpackning_nn_1_1_N : N ;
  frysning_nn_1_N : N ;
  fraelsning_nn_1_1_N : N ;
  fraemling_nn_1_1_N : N ;
  fraesning_nn_1_1_N : N ;
  fraetning_nn_1_1_N : N ;
  fraagestaellning_nn_1_1_N : N ;
  fraagetaevling_nn_1_1_N : N ;
  fraanlandsvind_nn_1_1_N : N ;
  fraanraekning_nn_1_1_N : N ;
  fraanvarodag_nn_1_1_N : N ;
  froeodling_nn_1_1_N : N ;
  fuktflaeck_nn_1_1_N : N ;
  fuktning_nn_1_N : N ;
  fullkomning_nn_1_N : N ;
  fullmaktslag_nn_1_N : N ;
  fulltraeff_nn_1_1_N : N ;
  fullvaerdesfoersaekring_nn_1_1_N : N ;
  fullaendning_nn_1_1_N : N ;
  fulvinkling_nn_1_N : N ;
  fundering_nn_1_N : N ;
  funktionering_nn_1_N : N ;
  funktionsnedsaettning_nn_1_1_N : N ;
  furnering_nn_1_N : N ;
  fusionering_nn_1_N : N ;
  fuskflygning_nn_1_N : N ;
  fusklapp_nn_1_N : N ;
  fyllhund_nn_1_N : N ;
  fyllnadstjaenstgoering_nn_1_1_N : N ;
  fyllning_nn_1_N : N ;
  fyratimmarsflygning_nn_1_N : N ;
  fyraaaring_nn_1_1_N : N ;
  fyrhandssaettning_nn_1_1_N : N ;
  fyrhjuling_nn_1_N : N ;
  fyrhoerning_nn_1_1_N : N ;
  fyrsiding_nn_1_N : N ;
  fyrtioaaring_nn_1_1_N : N ;
  fyrtiaaring_nn_1_1_N : N ;
  fysikforskning_nn_1_N : N ;
  fysiljering_nn_1_N : N ;
  faebodvall_nn_1_1_N : N ;
  faedernegaard_nn_1_1_N : N ;
  faegring_nn_1_1_N : N ;
  faehund_nn_1_1_N : N ;
  faektning_nn_1_1_N : N ;
  faellkil_nn_1_1_N : N ;
  faellning_nn_1_1_N : N ;
  faellstol_nn_1_1_N : N ;
  faeltbegravning_nn_1_1_N : N ;
  faeltmaetning_nn_1_1_N : N ;
  faelttjaenstgoering_nn_1_1_N : N ;
  faelttjaenstoevning_nn_1_1_N : N ;
  faengelsedom_nn_1_1_N : N ;
  faerdighetstraening_nn_1_1_N : N ;
  faerdriktning_nn_1_1_N : N ;
  faerdvaeg_nn_1_1_N : N ;
  faergblandning_nn_1_1_N : N ;
  faergflaeck_nn_1_1_N : N ;
  faergfoeraendring_nn_1_1_N : N ;
  faerglaeggning_nn_1_1_N : N ;
  faergning_nn_1_1_N : N ;
  faergrivning_nn_1_1_N : N ;
  faergsammansaettning_nn_1_1_N : N ;
  faergskiftning_nn_1_1_N : N ;
  faergspridning_nn_1_1_N : N ;
  faergsaettning_nn_1_1_N : N ;
  faerjeavgaang_nn_1_1_N : N ;
  faersering_nn_1_1_N : N ;
  faerskning_nn_1_1_N : N ;
  faestanordning_nn_1_1_N : N ;
  faestkrok_nn_1_1_N : N ;
  faestning_nn_1_1_N : N ;
  faestningsmur_nn_1_1_N : N ;
  faestningsvall_nn_1_1_N : N ;
  faestskruv_nn_1_1_N : N ;
  faagelskaadning_nn_1_1_N : N ;
  faagelvurm_nn_1_1_N : N ;
  faallning_nn_1_1_N : N ;
  faangeshandling_nn_1_1_N : N ;
  faangstanordning_nn_1_1_N : N ;
  faangstkrok_nn_1_1_N : N ;
  faangutvaexling_nn_1_1_N : N ;
  faantratt_nn_1_1_N : N ;
  faarahjord_nn_1_1_N : N ;
  foedelsedag_nn_1_1_N : N ;
  foedelsedagsmiddag_nn_1_1_N : N ;
  foedkrok_nn_1_1_N : N ;
  foedslovaerk_nn_1_1_N : N ;
  foegderifoervaltning_nn_1_1_N : N ;
  foeljdsjukdom_nn_1_1_N : N ;
  foeljdverkning_nn_1_1_N : N ;
  foeljebil_nn_1_1_N : N ;
  foelning_nn_1_1_N : N ;
  foensterputsduk_nn_1_1_N : N ;
  foensteroeppning_nn_1_1_N : N ;
  foeraning_nn_1_1_N : N ;
  foerankring_nn_1_1_N : N ;
  foeranledning_nn_1_1_N : N ;
  foeranmaelning_nn_1_1_N : N ;
  foerannonsering_nn_1_1_N : N ;
  foeranstaltning_nn_1_1_N : N ;
  foerbehandling_nn_1_1_N : N ;
  foerbindelsegrav_nn_1_1_N : N ;
  foerbindelsegaang_nn_1_1_N : N ;
  foerbindelselaenk_nn_1_1_N : N ;
  foerbindning_nn_1_1_N : N ;
  foerbistring_nn_1_1_N : N ;
  foerbittring_nn_1_1_N : N ;
  foerblandning_nn_1_1_N : N ;
  foerbloedning_nn_1_1_N : N ;
  foerbrukning_nn_1_1_N : N ;
  foerbraenning_nn_1_1_N : N ;
  foerbroedring_nn_1_1_N : N ;
  foerbundsregering_nn_1_1_N : N ;
  foerbytning_nn_1_1_N : N ;
  foerbaettring_nn_1_1_N : N ;
  foerdelning_nn_1_1_N : N ;
  foerdjupning_nn_1_1_N : N ;
  foerdom_nn_1_1_N : N ;
  foerdrivning_nn_1_1_N : N ;
  foerdroejning_nn_1_1_N : N ;
  foerdubbling_nn_1_1_N : N ;
  foerdyring_nn_1_1_N : N ;
  foerdaemning_nn_1_1_N : N ;
  foeredragning_nn_1_1_N : N ;
  foerelaesning_nn_1_1_N : N ;
  foerelaesningssal_nn_1_1_N : N ;
  foerening_nn_1_1_N : N ;
  foereningslaenk_nn_1_1_N : N ;
  foerenkling_nn_1_1_N : N ;
  foerespegling_nn_1_1_N : N ;
  foerestavning_nn_1_1_N : N ;
  foerestaellning_nn_1_1_N : N ;
  foeretagsledning_nn_1_1_N : N ;
  foerevisning_nn_1_1_N : N ;
  foerevaendning_nn_1_1_N : N ;
  foerfallodag_nn_1_1_N : N ;
  foerfalskning_nn_1_1_N : N ;
  foerfattargaerning_nn_1_1_N : N ;
  foerfattarskildring_nn_1_1_N : N ;
  foerfattning_nn_1_1_N : N ;
  foerfattningsdomstol_nn_1_1_N : N ;
  foerfining_nn_1_1_N : N ;
  foerflackning_nn_1_1_N : N ;
  foerflyttning_nn_1_1_N : N ;
  foerfogandelag_nn_1_1_N : N ;
  foerfriskning_nn_1_1_N : N ;
  foerfrysning_nn_1_1_N : N ;
  foerfraagning_nn_1_1_N : N ;
  foerfuskning_nn_1_1_N : N ;
  foergasning_nn_1_1_N : N ;
  foergiftning_nn_1_1_N : N ;
  foergrening_nn_1_1_N : N ;
  foergroning_nn_1_1_N : N ;
  foergubbning_nn_1_1_N : N ;
  foergudning_nn_1_1_N : N ;
  foergyllning_nn_1_1_N : N ;
  foergoerning_nn_1_1_N : N ;
  foerhalning_nn_1_1_N : N ;
  foerhandling_nn_1_1_N : N ;
  foerhandsbestaellning_nn_1_1_N : N ;
  foerhoppning_nn_1_1_N : N ;
  foerhuggning_nn_1_1_N : N ;
  foerhydning_nn_1_1_N : N ;
  foerhyrning_nn_1_1_N : N ;
  foerhaerdning_nn_1_1_N : N ;
  foerhaerjning_nn_1_1_N : N ;
  foerhaexning_nn_1_1_N : N ;
  foerhaallning_nn_1_1_N : N ;
  foerhaaning_nn_1_1_N : N ;
  foerhoejning_nn_1_1_N : N ;
  foerkalkning_nn_1_1_N : N ;
  foerkastelsedom_nn_1_1_N : N ;
  foerkastning_nn_1_1_N : N ;
  foerklaring_nn_1_1_N : N ;
  foerklistring_nn_1_1_N : N ;
  foerklistring_2_nn_1_1_N : N ;
  foerklyftning_nn_1_1_N : N ;
  foerklaedeskjol_nn_1_1_N : N ;
  foerknippning_nn_1_1_N : N ;
  foerkolning_nn_1_1_N : N ;
  foerkonstling_nn_1_1_N : N ;
  foerkortning_nn_1_1_N : N ;
  foerkroppning_nn_1_1_N : N ;
  foerkrossning_nn_1_1_N : N ;
  foerkrympning_nn_1_1_N : N ;
  foerkvaevning_nn_1_1_N : N ;
  foerkylning_nn_1_1_N : N ;
  foerkaenning_nn_1_1_N : N ;
  foerkaerlek_nn_1_1_N : N ;
  foerladdning_nn_1_1_N : N ;
  foerlamning_nn_1_1_N : N ;
  foerlikning_nn_1_1_N : N ;
  foerlisning_nn_1_1_N : N ;
  foerlossning_nn_1_1_N : N ;
  foerlovning_nn_1_1_N : N ;
  foerlovningsring_nn_1_1_N : N ;
  foerlaeggning_nn_1_1_N : N ;
  foerlaengning_nn_1_1_N : N ;
  foerlaengningssladd_nn_1_1_N : N ;
  foerlaening_nn_1_1_N : N ;
  foerloepning_nn_1_1_N : N ;
  foerloesning_nn_1_1_N : N ;
  foermaning_nn_1_1_N : N ;
  foermedling_nn_1_1_N : N ;
  foerminskning_nn_1_1_N : N ;
  foermultning_nn_1_1_N : N ;
  foermyndarregering_nn_1_1_N : N ;
  foermaelning_nn_1_1_N : N ;
  foermoerkning_nn_1_1_N : N ;
  foernagling_nn_1_1_N : N ;
  foernedring_nn_1_1_N : N ;
  foerolaempning_nn_1_1_N : N ;
  foerordning_nn_1_1_N : N ;
  foerorening_nn_1_1_N : N ;
  foerortstraedgaard_nn_1_1_N : N ;
  foerpackning_nn_1_1_N : N ;
  foerpaktning_nn_1_1_N : N ;
  foerpantning_nn_1_1_N : N ;
  foerpassning_nn_1_1_N : N ;
  foerpestning_nn_1_1_N : N ;
  foerplaegning_nn_1_1_N : N ;
  foerpostfaektning_nn_1_1_N : N ;
  foerprickning_nn_1_1_N : N ;
  foerpuppning_nn_1_1_N : N ;
  foerregling_nn_1_1_N : N ;
  foerryckning_nn_1_1_N : N ;
  foerraentning_nn_1_1_N : N ;
  foerraettning_nn_1_1_N : N ;
  foersamling_nn_1_1_N : N ;
  foersegling_nn_1_1_N : N ;
  foersening_nn_1_1_N : N ;
  foersinkning_nn_1_1_N : N ;
  foersjunkning_nn_1_1_N : N ;
  foerskansning_nn_1_1_N : N ;
  foerskiffring_nn_1_1_N : N ;
  foerskingring_nn_1_1_N : N ;
  foerskjutning_nn_1_1_N : N ;
  foerskoning_nn_1_1_N : N ;
  foerskottering_nn_1_1_N : N ;
  foerskrivning_nn_1_1_N : N ;
  foerskaemning_nn_1_1_N : N ;
  foerskoening_nn_1_1_N : N ;
  foerslappning_nn_1_1_N : N ;
  foerslavning_nn_1_1_N : N ;
  foerslitning_nn_1_1_N : N ;
  foerslutning_nn_1_1_N : N ;
  foersloesning_nn_1_1_N : N ;
  foersnillning_nn_1_1_N : N ;
  foersockring_nn_1_1_N : N ;
  foersoning_nn_1_1_N : N ;
  foerspaenning_nn_1_1_N : N ;
  foerstelning_nn_1_1_N : N ;
  foerstening_nn_1_1_N : N ;
  foerstoppning_nn_1_1_N : N ;
  foerstoring_nn_1_1_N : N ;
  foerstraeckning_nn_1_1_N : N ;
  foerstaellning_nn_1_1_N : N ;
  foerstaemning_nn_1_1_N : N ;
  foerstaerkning_nn_1_1_N : N ;
  foerstaaelseram_nn_1_1_N : N ;
  foerstoering_nn_1_1_N : N ;
  foersumpning_nn_1_1_N : N ;
  foersurning_nn_1_1_N : N ;
  foersvagning_nn_1_1_N : N ;
  foersvarsanlaeggning_nn_1_1_N : N ;
  foersvarsnedskaerning_nn_1_1_N : N ;
  foersvarsplanering_nn_1_1_N : N ;
  foersvarsstaellning_nn_1_1_N : N ;
  foersaegning_nn_1_1_N : N ;
  foersaekring_nn_1_1_N : N ;
  foersaeljning_nn_1_1_N : N ;
  foersaeljningsdag_nn_1_1_N : N ;
  foersaemring_nn_1_1_N : N ;
  foersaendning_nn_1_1_N : N ;
  foersaenkning_nn_1_1_N : N ;
  foersaettning_nn_1_1_N : N ;
  foersaapning_nn_1_1_N : N ;
  foersoeksdamm_nn_1_1_N : N ;
  foersoerjning_nn_1_1_N : N ;
  foersoerjningsinraettning_nn_1_1_N : N ;
  foerteckning_nn_1_1_N : N ;
  foertenning_nn_1_1_N : N ;
  foertidspensionering_nn_1_1_N : N ;
  foertidsroestning_nn_1_1_N : N ;
  foertimring_nn_1_1_N : N ;
  foertjockning_nn_1_1_N : N ;
  foertjusning_nn_1_1_N : N ;
  foertoning_nn_1_1_N : N ;
  foertorkning_nn_1_1_N : N ;
  foertrampning_nn_1_1_N : N ;
  foertroendemaetning_nn_1_1_N : N ;
  foertroendeomroestning_nn_1_1_N : N ;
  foertrollning_nn_1_1_N : N ;
  foertryckning_nn_1_1_N : N ;
  foertraengning_nn_1_1_N : N ;
  foertullning_nn_1_1_N : N ;
  foertunning_nn_1_1_N : N ;
  foertvining_nn_1_1_N : N ;
  foertvaett_nn_1_1_N : N ;
  foertvaalning_nn_1_1_N : N ;
  foertaendning_nn_1_1_N : N ;
  foertaering_nn_1_1_N : N ;
  foertaetning_nn_1_1_N : N ;
  foertoejning_nn_1_1_N : N ;
  foertoejningsring_nn_1_1_N : N ;
  foerundersoekning_nn_1_1_N : N ;
  foerutsaettning_nn_1_1_N : N ;
  foervaltning_nn_1_1_N : N ;
  foervandling_nn_1_1_N : N ;
  foervanskning_nn_1_1_N : N ;
  foervaring_nn_1_1_N : N ;
  foervaringsback_nn_1_1_N : N ;
  foervaringshall_nn_1_1_N : N ;
  foervaringskorg_nn_1_1_N : N ;
  foervarning_nn_1_1_N : N ;
  foerveckling_nn_1_1_N : N ;
  foervedning_nn_1_1_N : N ;
  foervirring_nn_1_1_N : N ;
  foervisning_nn_1_1_N : N ;
  foervissning_nn_1_1_N : N ;
  foervittring_nn_1_1_N : N ;
  foervridning_nn_1_1_N : N ;
  foervraengning_nn_1_1_N : N ;
  foervaellning_nn_1_1_N : N ;
  foervaendning_nn_1_1_N : N ;
  foervaentning_nn_1_1_N : N ;
  foervaerring_nn_1_1_N : N ;
  foervaexling_nn_1_1_N : N ;
  foervaexlingslek_nn_1_1_N : N ;
  foervaaning_nn_1_1_N : N ;
  foeryngring_nn_1_1_N : N ;
  foeryngringsbeskaering_nn_1_1_N : N ;
  foerzinkning_nn_1_1_N : N ;
  foeraedling_nn_1_1_N : N ;
  foeraeldrafoersaekring_nn_1_1_N : N ;
  foeraeldrapenning_nn_1_1_N : N ;
  foeraendring_nn_1_1_N : N ;
  foeroekning_nn_1_1_N : N ;
  foeroevning_nn_1_1_N : N ;
  foesning_nn_1_1_N : N ;
  gabondoerr_nn_1_1_N : N ;
  gaffellyft_nn_1_N : N ;
  galafoerestaellning_nn_1_1_N : N ;
  galamiddag_nn_1_N : N ;
  galavagn_nn_1_N : N ;
  galaxbildning_nn_1_N : N ;
  galaxhop_nn_1_N : N ;
  galaxvaerld_nn_1_1_N : N ;
  gallbildning_nn_1_N : N ;
  gallerdurk_nn_1_N : N ;
  gallergrind_nn_1_N : N ;
  galleriskog_nn_1_N : N ;
  gallgaang_nn_1_1_N : N ;
  gallisering_nn_1_N : N ;
  gallring_nn_1_N : N ;
  gallupmaetning_nn_1_1_N : N ;
  galoppering_nn_1_N : N ;
  galopptaevling_nn_1_1_N : N ;
  galoschering_nn_1_N : N ;
  galvanisering_nn_1_N : N ;
  gammalstavning_nn_1_N : N ;
  gammastraalning_nn_1_1_N : N ;
  gapning_nn_1_N : N ;
  gapstock_nn_1_N : N ;
  garagering_nn_1_N : N ;
  garantering_nn_1_N : N ;
  garantifoersaekring_nn_1_1_N : N ;
  gardering_nn_1_N : N ;
  garderobsdoerr_nn_1_1_N : N ;
  gardinkrok_nn_1_N : N ;
  gardinring_nn_1_N : N ;
  garnering_nn_1_N : N ;
  garnisonering_nn_1_N : N ;
  garrottering_nn_1_N : N ;
  garvning_nn_1_N : N ;
  gasbil_nn_1_N : N ;
  gasbilsfoersaeljning_nn_1_1_N : N ;
  gasblandning_nn_1_N : N ;
  gasfoergiftning_nn_1_1_N : N ;
  gasledning_nn_1_N : N ;
  gasolgrill_nn_1_N : N ;
  gasraekning_nn_1_1_N : N ;
  gassvetsning_nn_1_N : N ;
  gastering_nn_1_N : N ;
  gastkramning_nn_1_N : N ;
  gastroskopering_nn_1_N : N ;
  gasurladdning_nn_1_N : N ;
  gatlaeggning_nn_1_1_N : N ;
  gatubelysning_nn_1_N : N ;
  gatubelaeggning_nn_1_1_N : N ;
  gatukorsning_nn_1_N : N ;
  gauffrering_nn_1_N : N ;
  gel_eklump_nn_1_1_N : N ;
  gemensamhetsgrav_nn_1_N : N ;
  geminering_nn_1_N : N ;
  gendrivning_nn_1_N : N ;
  generalfoersamling_nn_1_1_N : N ;
  generalisering_nn_1_N : N ;
  generalmoenstring_nn_1_1_N : N ;
  generationsvaexling_nn_1_1_N : N ;
  generering_nn_1_N : N ;
  genering_nn_1_N : N ;
  genfordring_nn_1_N : N ;
  genfoeraendring_nn_1_1_N : N ;
  genmanipulering_nn_1_N : N ;
  genmodifiering_nn_1_N : N ;
  genomarbetning_nn_1_N : N ;
  genomblaeddring_nn_1_1_N : N ;
  genombloedning_nn_1_1_N : N ;
  genomborrning_nn_1_N : N ;
  genombrytning_nn_1_N : N ;
  genomfartsvaeg_nn_1_1_N : N ;
  genomfoering_nn_1_1_N : N ;
  genomfoerning_nn_1_1_N : N ;
  genomgaang_nn_1_1_N : N ;
  genomklappning_nn_1_N : N ;
  genomkorsning_nn_1_N : N ;
  genomlysning_nn_1_N : N ;
  genomlaesning_nn_1_1_N : N ;
  genommoenstring_nn_1_1_N : N ;
  genomraekning_nn_1_1_N : N ;
  genomsippring_nn_1_N : N ;
  genomskaerning_nn_1_1_N : N ;
  genomstroemning_nn_1_1_N : N ;
  genomsyrning_nn_1_N : N ;
  genomsoekning_nn_1_1_N : N ;
  genomtrampning_nn_1_N : N ;
  genomtraengning_nn_1_1_N : N ;
  genskjutning_nn_1_N : N ;
  genstaemning_nn_1_1_N : N ;
  genterapibehandling_nn_1_N : N ;
  genvaeg_nn_1_1_N : N ;
  geometrisering_nn_1_N : N ;
  gering_nn_1_N : N ;
  geringssaag_nn_1_1_N : N ;
  germanisering_nn_1_N : N ;
  gestaltning_nn_1_N : N ;
  gestikulering_nn_1_N : N ;
  gesaellvandring_nn_1_1_N : N ;
  gevaersmynning_nn_1_1_N : N ;
  gevaersstock_nn_1_1_N : N ;
  giftavdunstning_nn_1_N : N ;
  giftbetning_nn_1_N : N ;
  giftorm_nn_1_N : N ;
  giktring_nn_1_N : N ;
  giljotinering_nn_1_N : N ;
  gindrink_nn_1_N : N ;
  ginvaeg_nn_1_1_N : N ;
  gipsavgjutning_nn_1_N : N ;
  gipsform_nn_1_N : N ;
  gipsklump_nn_1_N : N ;
  gipsvaegg_nn_1_1_N : N ;
  girering_nn_1_N : N ;
  girigbuk_nn_1_N : N ;
  girning_nn_1_N : N ;
  gissning_nn_1_N : N ;
  gissningslek_nn_1_N : N ;
  gissningstaevling_nn_1_1_N : N ;
  givning_nn_1_N : N ;
  gjutform_nn_1_N : N ;
  gjutning_nn_1_N : N ;
  glaciaerbrunn_nn_1_1_N : N ;
  glaciaerport_nn_1_1_N : N ;
  glaciaeraelv_nn_1_1_N : N ;
  gladiatorgrav_nn_1_N : N ;
  glamorisering_nn_1_N : N ;
  glamourisering_nn_1_N : N ;
  glanskning_nn_1_N : N ;
  glansning_nn_1_N : N ;
  glappning_nn_1_N : N ;
  glasbit_nn_1_N : N ;
  glasblaasning_nn_1_1_N : N ;
  glasburk_nn_1_N : N ;
  glasdoerr_nn_1_1_N : N ;
  glasering_nn_1_N : N ;
  glasframstaellning_nn_1_1_N : N ;
  glashuv_nn_1_N : N ;
  glasmaalning_nn_1_1_N : N ;
  glasplaat_nn_1_1_N : N ;
  glasskaal_nn_1_1_N : N ;
  glasvaegg_nn_1_1_N : N ;
  glasoegonbjoern_nn_1_1_N : N ;
  glasoegonorm_nn_1_1_N : N ;
  glattning_nn_1_N : N ;
  glidning_nn_1_N : N ;
  glidtackling_nn_1_N : N ;
  glorifiering_nn_1_N : N ;
  glaedjebetygssaettning_nn_1_1_N : N ;
  glaedjetaar_nn_1_1_N : N ;
  glaedjeyttring_nn_1_1_N : N ;
  glaefsning_nn_1_1_N : N ;
  glaettning_nn_1_1_N : N ;
  gloedgning_nn_1_1_N : N ;
  gloedhoeg_nn_1_1_N : N ;
  gloedning_nn_1_1_N : N ;
  gloedritning_nn_1_1_N : N ;
  gloedtraad_nn_1_1_N : N ;
  gnagning_nn_1_N : N ;
  gnidning_nn_1_N : N ;
  gnistbildning_nn_1_N : N ;
  gnisttaendning_nn_1_1_N : N ;
  gnuggning_nn_1_N : N ;
  gnaeggning_nn_1_1_N : N ;
  godbit_nn_1_N : N ;
  godsmottagning_nn_1_N : N ;
  goffrering_nn_1_N : N ;
  golfboll_nn_1_N : N ;
  golfturnering_nn_1_N : N ;
  golgatavandring_nn_1_N : N ;
  golvbelaeggning_nn_1_1_N : N ;
  golvmopp_nn_1_N : N ;
  gomklyvning_nn_1_N : N ;
  googling_nn_1_N : N ;
  gotlaenning_nn_1_1_N : N ;
  gottkoepsfoerklaring_nn_1_1_N : N ;
  goutering_nn_1_N : N ;
  gradbeteckning_nn_1_N : N ;
  gradboejning_nn_1_1_N : N ;
  gradering_nn_1_N : N ;
  gradmaetning_nn_1_1_N : N ;
  gradsaag_nn_1_1_N : N ;
  gradualavhandling_nn_1_N : N ;
  graduering_nn_1_N : N ;
  grafitering_nn_1_N : N ;
  granatbeskjutning_nn_1_N : N ;
  granattraeff_nn_1_1_N : N ;
  granhaeck_nn_1_1_N : N ;
  grannkung_nn_1_N : N ;
  granskning_nn_1_N : N ;
  granskog_nn_1_N : N ;
  granulering_nn_1_N : N ;
  grassering_nn_1_N : N ;
  gratinering_nn_1_N : N ;
  gratistidning_nn_1_N : N ;
  gratulering_nn_1_N : N ;
  gravering_nn_1_N : N ;
  gravhaell_nn_1_1_N : N ;
  gravhoeg_nn_1_1_N : N ;
  gravitationslag_nn_1_N : N ;
  gravitationsstraalning_nn_1_1_N : N ;
  gravitering_nn_1_N : N ;
  gravplundring_nn_1_N : N ;
  gravskaendning_nn_1_1_N : N ;
  gravsvepning_nn_1_N : N ;
  gravsaettning_nn_1_1_N : N ;
  gravvaard_nn_1_1_N : N ;
  gravoeppning_nn_1_1_N : N ;
  grenledning_nn_1_N : N ;
  griljering_nn_1_N : N ;
  grimasering_nn_1_N : N ;
  grimering_nn_1_N : N ;
  grindoeppning_nn_1_1_N : N ;
  griskastrering_nn_1_N : N ;
  grisning_nn_1_N : N ;
  grizzlybjoern_nn_1_1_N : N ;
  groning_nn_1_N : N ;
  grottbjoern_nn_1_1_N : N ;
  grottforskning_nn_1_N : N ;
  grottgaang_nn_1_1_N : N ;
  grottingaang_nn_1_1_N : N ;
  grottmynning_nn_1_N : N ;
  grottmaalning_nn_1_1_N : N ;
  grovlek_nn_1_N : N ;
  grovplanering_nn_1_N : N ;
  grovsortering_nn_1_N : N ;
  grumling_nn_1_N : N ;
  grundering_nn_1_N : N ;
  grundforskning_nn_1_N : N ;
  grundfoerbaettring_nn_1_1_N : N ;
  grundkaenning_nn_1_1_N : N ;
  grundlag_nn_1_N : N ;
  grundlagsaendring_nn_1_1_N : N ;
  grundlaeggning_nn_1_1_N : N ;
  grundmur_nn_1_N : N ;
  grundmaalning_nn_1_1_N : N ;
  grundning_nn_1_N : N ;
  grundstaellning_nn_1_1_N : N ;
  grundstaemning_nn_1_1_N : N ;
  grundstoetning_nn_1_1_N : N ;
  grundutbildning_nn_1_N : N ;
  gruppering_nn_1_N : N ;
  gruppfoersaekring_nn_1_1_N : N ;
  gruppsmoerjning_nn_1_1_N : N ;
  grusgaang_nn_1_1_N : N ;
  grusvaeg_nn_1_1_N : N ;
  gruvbrytning_nn_1_N : N ;
  gruvgaang_nn_1_1_N : N ;
  gruvoeppning_nn_1_1_N : N ;
  grymtning_nn_1_N : N ;
  gryning_nn_1_N : N ;
  grynkorv_nn_1_N : N ;
  grynvaelling_nn_1_1_N : N ;
  grytstek_nn_1_N : N ;
  graeddning_nn_1_1_N : N ;
  graeddsaettning_nn_1_1_N : N ;
  graensbevakning_nn_1_1_N : N ;
  graensdragning_nn_1_1_N : N ;
  graenspostering_nn_1_1_N : N ;
  graenssaettning_nn_1_1_N : N ;
  graesflaeck_nn_1_1_N : N ;
  graesklippning_nn_1_1_N : N ;
  graesplaett_nn_1_1_N : N ;
  graesstraeng_nn_1_1_N : N ;
  graesvall_nn_1_1_N : N ;
  graesaenkling_nn_1_1_N : N ;
  graevblogg_nn_1_1_N : N ;
  graevning_nn_1_1_N : N ;
  graamunk_nn_1_1_N : N ;
  groengoedsling_nn_1_1_N : N ;
  groengoeling_nn_1_1_N : N ;
  groensaksblandning_nn_1_1_N : N ;
  groensaksodling_nn_1_1_N : N ;
  groensakstallrik_nn_1_1_N : N ;
  groepning_nn_1_1_N : N ;
  gudaskymning_nn_1_N : N ;
  gudom_nn_1_N : N ;
  gudsdom_nn_1_N : N ;
  gudstjaenstordning_nn_1_1_N : N ;
  guldkran_nn_1_N : N ;
  guldkrog_nn_1_N : N ;
  guldlegering_nn_1_N : N ;
  guldpressning_nn_1_N : N ;
  guldtraad_nn_1_1_N : N ;
  guldtaeckning_nn_1_1_N : N ;
  guldvaskning_nn_1_N : N ;
  guldvaag_nn_1_1_N : N ;
  gulfaergning_nn_1_1_N : N ;
  gulning_nn_1_N : N ;
  gummering_nn_1_N : N ;
  gummiboll_nn_1_N : N ;
  gummibaat_nn_1_1_N : N ;
  gummipigg_nn_1_N : N ;
  gummipropp_nn_1_N : N ;
  gummislang_nn_1_N : N ;
  gungning_nn_1_N : N ;
  gungstol_nn_1_N : N ;
  gungstaellning_nn_1_1_N : N ;
  guppning_nn_1_N : N ;
  gurkstav_nn_1_N : N ;
  gutering_nn_1_N : N ;
  gymnasieutbildning_nn_1_N : N ;
  gymnastiksal_nn_1_N : N ;
  gymnastisering_nn_1_N : N ;
  gyttring_nn_1_N : N ;
  gaengning_nn_1_1_N : N ;
  gaengtatuering_nn_1_1_N : N ;
  gaerdning_nn_1_1_N : N ;
  gaerning_nn_1_1_N : N ;
  gaespning_nn_1_1_N : N ;
  gaestning_nn_1_1_N : N ;
  gaestriking_nn_1_1_N : N ;
  gaestriklaenning_nn_1_1_N : N ;
  gaestrumsdoerr_nn_1_1_N : N ;
  gaabock_nn_1_1_N : N ;
  gaangbock_nn_1_1_N : N ;
  gaangstig_nn_1_1_N : N ;
  gaangvaeg_nn_1_1_N : N ;
  gaavohandling_nn_1_1_N : N ;
  goedning_nn_1_1_N : N ;
  goedsling_nn_1_1_N : N ;
  goerdelfaestning_nn_1_1_N : N ;
  habilitering_nn_1_N : N ;
  hackning_nn_1_N : N ;
  hackordning_nn_1_N : N ;
  hagelskur_nn_1_N : N ;
  hagelstorm_nn_1_N : N ;
  hagelsvaerm_nn_1_1_N : N ;
  hagtornshaeck_nn_1_1_N : N ;
  hakning_nn_1_N : N ;
  halkkrock_nn_1_N : N ;
  halkkoerning_nn_1_1_N : N ;
  halkning_nn_1_N : N ;
  halkvarning_nn_1_N : N ;
  hallucinering_nn_1_N : N ;
  hallaenning_nn_1_1_N : N ;
  halmhatt_nn_1_N : N ;
  halning_nn_1_N : N ;
  halshuggning_nn_1_N : N ;
  halsring_nn_1_N : N ;
  haltning_nn_1_N : N ;
  halvering_nn_1_N : N ;
  halvgud_nn_1_N : N ;
  halvlek_nn_1_N : N ;
  halvsanning_nn_1_N : N ;
  halvtidsfrigivning_nn_1_N : N ;
  halvviskning_nn_1_N : N ;
  handboll_nn_2_N : N ;
  handdukstork_nn_1_N : N ;
  handklappning_nn_1_N : N ;
  handkvarn_nn_1_N : N ;
  handledning_nn_1_N : N ;
  handling_nn_1_N : N ;
  handlingsfoerlamning_nn_1_1_N : N ;
  handlaeggning_nn_1_1_N : N ;
  handpump_nn_1_N : N ;
  handpaalaeggning_nn_1_1_N : N ;
  handrygg_nn_1_N : N ;
  handraeckning_nn_1_1_N : N ;
  handskakning_nn_1_N : N ;
  handskriftsavdelning_nn_1_N : N ;
  handskriftssamling_nn_1_N : N ;
  handsaag_nn_1_1_N : N ;
  handtryckning_nn_1_N : N ;
  handtvagning_nn_1_N : N ;
  handtvaett_nn_1_1_N : N ;
  handuppraeckning_nn_1_1_N : N ;
  hantering_nn_1_N : N ;
  hantverksfoerening_nn_1_1_N : N ;
  harangering_nn_1_N : N ;
  harkling_nn_1_N : N ;
  harlaepp_nn_1_1_N : N ;
  harmoniering_nn_1_N : N ;
  harmonisering_nn_1_N : N ;
  harpunering_nn_1_N : N ;
  harstig_nn_1_N : N ;
  hartsning_nn_1_N : N ;
  hasardering_nn_1_N : N ;
  hastighetstaevling_nn_1_1_N : N ;
  hastighetsaakning_nn_1_1_N : N ;
  hatkaerlek_nn_1_1_N : N ;
  hattstock_nn_1_N : N ;
  havandeskapsfoergiftning_nn_1_1_N : N ;
  haverering_nn_1_N : N ;
  havsarm_nn_1_N : N ;
  havsgud_nn_1_N : N ;
  havskappsegling_nn_1_N : N ;
  havsvik_nn_1_N : N ;
  havsvind_nn_1_N : N ;
  havsoern_nn_1_1_N : N ;
  hedendom_nn_1_N : N ;
  hedersbevisning_nn_1_N : N ;
  hedersdomstol_nn_1_N : N ;
  hejaklack_nn_1_N : N ;
  hejarklack_nn_1_N : N ;
  hektografering_nn_1_N : N ;
  heldag_nn_1_N : N ;
  helfoersaekring_nn_1_1_N : N ;
  helgardering_nn_1_N : N ;
  helgedom_nn_1_N : N ;
  helgmaalsringning_nn_1_1_N : N ;
  helgonfoerklaring_nn_1_1_N : N ;
  helinackordering_nn_1_N : N ;
  helomvaendning_nn_1_1_N : N ;
  hembjudning_nn_1_N : N ;
  hembraenning_nn_1_1_N : N ;
  hembygdsfoerening_nn_1_1_N : N ;
  hemfoerlossning_nn_1_1_N : N ;
  hemfoerlovning_nn_1_1_N : N ;
  hemfoersaekring_nn_1_1_N : N ;
  hemfoersaeljning_nn_1_1_N : N ;
  hemgaang_nn_1_1_N : N ;
  hemhjaelp_nn_1_1_N : N ;
  heminredning_nn_1_N : N ;
  hemmansklyvning_nn_1_N : N ;
  hemstaellning_nn_1_1_N : N ;
  hemsoekning_nn_1_1_N : N ;
  heroinkung_nn_1_N : N ;
  heroisering_nn_1_N : N ;
  herrekipering_nn_1_N : N ;
  herrhatt_nn_1_N : N ;
  herrtidning_nn_1_N : N ;
  hesitering_nn_1_N : N ;
  hetsning_nn_1_N : N ;
  hetvattentvaett_nn_1_1_N : N ;
  hetvaegg_nn_1_1_N : N ;
  hibernering_nn_1_N : N ;
  hickning_nn_1_N : N ;
  himladrottning_nn_1_N : N ;
  hinderloepning_nn_1_1_N : N ;
  hindersproevning_nn_1_1_N : N ;
  hissdoerr_nn_1_1_N : N ;
  hisshall_nn_1_N : N ;
  historiefoerfalskning_nn_1_1_N : N ;
  historiemaalning_nn_1_1_N : N ;
  historiering_nn_1_N : N ;
  historieskrivning_nn_1_N : N ;
  historisering_nn_1_N : N ;
  hivlagstiftning_nn_1_N : N ;
  hivning_nn_1_N : N ;
  hjortkalv_nn_1_N : N ;
  hjulfjaedring_nn_1_1_N : N ;
  hjulning_nn_1_N : N ;
  hjulupphaengning_nn_1_1_N : N ;
  hjaelpbaat_nn_1_1_N : N ;
  hjaelpsaendning_nn_1_1_N : N ;
  hjaeltedoed_nn_1_1_N : N ;
  hjaernbloedning_nn_1_1_N : N ;
  hjaernsjukdom_nn_1_1_N : N ;
  hjaernskakning_nn_1_1_N : N ;
  hjaernvindling_nn_1_1_N : N ;
  hjaertklappning_nn_1_1_N : N ;
  hjaertsjukdom_nn_1_1_N : N ;
  hjaertskoeld_nn_1_1_N : N ;
  hjaessbjudning_nn_1_1_N : N ;
  hobbyutbildning_nn_1_N : N ;
  hojtning_nn_1_N : N ;
  holmgaang_nn_1_1_N : N ;
  holografering_nn_1_N : N ;
  homogenisering_nn_1_N : N ;
  honorering_nn_1_N : N ;
  honung_nn_1_N : N ;
  hopblandning_nn_1_N : N ;
  hopbringning_nn_1_N : N ;
  hopdragning_nn_1_N : N ;
  hopfogning_nn_1_N : N ;
  hopklumpning_nn_1_N : N ;
  hopknytning_nn_1_N : N ;
  hopkoppling_nn_1_N : N ;
  hoplappning_nn_1_N : N ;
  hopning_nn_1_N : N ;
  hoppackning_nn_1_N : N ;
  hoppsnurrspark_nn_1_N : N ;
  hoppstaellning_nn_1_1_N : N ;
  hopptraening_nn_1_1_N : N ;
  hoprullning_nn_1_N : N ;
  hopslagning_nn_1_N : N ;
  hopsmaeltning_nn_2_1_N : N ;
  hopvikning_nn_1_N : N ;
  hospitalisering_nn_1_N : N ;
  hostning_nn_1_N : N ;
  hotellmatsal_nn_1_N : N ;
  hotellvaerd_nn_1_1_N : N ;
  hottning_nn_1_N : N ;
  hovnigning_nn_1_N : N ;
  hudflaengning_nn_1_1_N : N ;
  hudsjukdom_nn_1_N : N ;
  hudoemsning_nn_1_1_N : N ;
  huggkrok_nn_1_N : N ;
  huggning_nn_1_N : N ;
  huggorm_nn_1_N : N ;
  humanisering_nn_1_N : N ;
  humifiering_nn_1_N : N ;
  humusfoerening_nn_1_1_N : N ;
  hundblick_nn_1_N : N ;
  hundgaard_nn_1_1_N : N ;
  hundhetsning_nn_1_N : N ;
  hundkapploepning_nn_1_1_N : N ;
  hundraaaring_nn_1_1_N : N ;
  hundsfottering_nn_1_N : N ;
  hundskit_nn_1_N : N ;
  husbil_nn_1_N : N ;
  husbaat_nn_1_1_N : N ;
  husering_nn_1_N : N ;
  hushaallning_nn_1_1_N : N ;
  hushaallsvaag_nn_1_1_N : N ;
  husknut_nn_1_N : N ;
  husmorsfoerening_nn_1_1_N : N ;
  husrannsakning_nn_1_N : N ;
  husundersoekning_nn_1_1_N : N ;
  husvaegg_nn_1_1_N : N ;
  husvaerd_nn_1_1_N : N ;
  huvudbjudning_nn_1_N : N ;
  huvudduk_nn_1_N : N ;
  huvudfoerhandling_nn_1_1_N : N ;
  huvudgaard_nn_1_1_N : N ;
  huvudingaang_nn_1_1_N : N ;
  huvudledning_nn_1_N : N ;
  huvudnaering_nn_1_1_N : N ;
  huvudraekning_nn_1_1_N : N ;
  huvudskakning_nn_1_N : N ;
  huvudskaal_nn_1_1_N : N ;
  huvudvattenledning_nn_1_N : N ;
  huvudvridning_nn_1_N : N ;
  huvudvaeg_nn_1_1_N : N ;
  hybridbil_nn_1_N : N ;
  hybridisering_nn_1_N : N ;
  hydratisering_nn_1_N : N ;
  hydraullyft_nn_1_N : N ;
  hydrering_nn_1_N : N ;
  hydroforpump_nn_1_N : N ;
  hyggesbraenning_nn_1_1_N : N ;
  hyllning_nn_1_N : N ;
  hypnotisering_nn_1_N : N ;
  hypoteksfoerening_nn_1_1_N : N ;
  hypotisering_nn_1_N : N ;
  hyresbetalning_nn_1_N : N ;
  hyresgaestfoerening_nn_1_1_N : N ;
  hyreslag_nn_1_N : N ;
  hyresreglering_nn_1_N : N ;
  hyressaettning_nn_1_1_N : N ;
  hyssjning_nn_1_N : N ;
  hyvning_nn_1_N : N ;
  haeckloepning_nn_1_1_N : N ;
  haeckning_nn_1_1_N : N ;
  haeftning_nn_1_1_N : N ;
  haegring_nn_1_1_N : N ;
  haektning_nn_1_1_N : N ;
  haektningsfoerhandling_nn_1_1_N : N ;
  haellning_nn_1_1_N : N ;
  haellristning_nn_1_1_N : N ;
  haelsning_nn_1_1_N : N ;
  haelsoraadgivning_nn_1_1_N : N ;
  haemning_nn_1_1_N : N ;
  haemtning_nn_1_1_N : N ;
  haendelseutveckling_nn_1_1_N : N ;
  haengning_nn_1_1_N : N ;
  haengselkjol_nn_1_1_N : N ;
  haenryckning_nn_1_1_N : N ;
  haensyftning_nn_1_1_N : N ;
  haentydning_nn_1_1_N : N ;
  haenvisning_nn_1_1_N : N ;
  haerbaergering_nn_1_1_N : N ;
  haerdning_nn_1_1_N : N ;
  haerjning_nn_1_1_N : N ;
  haerledning_nn_1_1_N : N ;
  haermoenstring_nn_1_1_N : N ;
  haerordning_nn_1_1_N : N ;
  haerskning_nn_1_1_N : N ;
  haerstamning_nn_1_1_N : N ;
  haessjning_nn_1_1_N : N ;
  haestkapploepning_nn_1_1_N : N ;
  haestspillning_nn_1_1_N : N ;
  haestvagn_nn_1_1_N : N ;
  haestvandring_nn_1_1_N : N ;
  haevning_nn_1_1_N : N ;
  haexring_nn_1_1_N : N ;
  haallfasthetsberaekning_nn_1_1_N : N ;
  haallning_nn_1_1_N : N ;
  haalslagning_nn_1_1_N : N ;
  haalvaeg_nn_1_1_N : N ;
  haardag_nn_1_1_N : N ;
  haardkorv_nn_1_1_N : N ;
  haardloedning_nn_1_1_N : N ;
  haardtraening_nn_1_1_N : N ;
  haarfaellning_nn_1_1_N : N ;
  haarfaergning_nn_1_1_N : N ;
  haarknut_nn_1_1_N : N ;
  haarlock_nn_1_1_N : N ;
  haarlaeggning_nn_1_1_N : N ;
  haartott_nn_1_1_N : N ;
  haartvaett_nn_1_1_N : N ;
  haaruppsaettning_nn_1_1_N : N ;
  haavning_nn_1_1_N : N ;
  hoeftvrickning_nn_1_1_N : N ;
  hoegaktning_nn_1_1_N : N ;
  hoegerknapp_nn_1_1_N : N ;
  hoegerkrok_nn_1_1_N : N ;
  hoegerregering_nn_1_1_N : N ;
  hoegersvaeng_nn_1_1_N : N ;
  hoegervind_nn_1_1_N : N ;
  hoegervridning_nn_1_1_N : N ;
  hoeghastighetsjaernvaeg_nn_1_1_N : N ;
  hoeglaesning_nn_1_1_N : N ;
  hoegskoleutbildning_nn_1_1_N : N ;
  hoegspaenning_nn_1_1_N : N ;
  hoegspaenningsledning_nn_1_1_N : N ;
  hoegtidsdag_nn_1_1_N : N ;
  hoegtryckstvaett_nn_1_1_N : N ;
  hoegvall_nn_1_1_N : N ;
  hoejdbestaemning_nn_1_1_N : N ;
  hoejdhoppstaevling_nn_1_1_N : N ;
  hoejdinstaellning_nn_1_1_N : N ;
  hoejdmaetning_nn_1_1_N : N ;
  hoejdstraeckning_nn_1_1_N : N ;
  hoejning_nn_1_1_N : N ;
  hoeljning_nn_1_1_N : N ;
  hoersal_nn_1_1_N : N ;
  hoerselgaang_nn_1_1_N : N ;
  hoestdagjaemning_nn_1_1_N : N ;
  hoestorientering_nn_1_1_N : N ;
  hoetorgsmaalning_nn_1_1_N : N ;
  hoevolm_nn_1_1_N : N ;
  hoevaalm_nn_1_1_N : N ;
  idealisering_nn_1_N : N ;
  idealvaerld_nn_1_1_N : N ;
  identifiering_nn_1_N : N ;
  idrottsfoerening_nn_1_1_N : N ;
  idrottsklubb_nn_1_N : N ;
  idrottstaevling_nn_1_1_N : N ;
  id_efattigdom_nn_1_1_N : N ;
  id_eklaeckning_nn_1_1_N : N ;
  id_erikedom_nn_1_1_N : N ;
  ifyllning_nn_1_N : N ;
  igentaeppning_nn_1_1_N : N ;
  ignorering_nn_1_N : N ;
  igaangsaettning_nn_1_1_N : N ;
  illgaerning_nn_1_1_N : N ;
  illudering_nn_1_N : N ;
  illuminering_nn_1_N : N ;
  illustrering_nn_1_N : N ;
  ilning_nn_1_N : N ;
  imitering_nn_1_N : N ;
  immatrikulering_nn_1_N : N ;
  immigrering_nn_1_N : N ;
  immunbristsjukdom_nn_1_N : N ;
  immunisering_nn_1_N : N ;
  implicering_nn_1_N : N ;
  implodering_nn_1_N : N ;
  imponering_nn_1_N : N ;
  importering_nn_1_N : N ;
  impregnering_nn_1_N : N ;
  improvisering_nn_1_N : N ;
  inackordering_nn_1_N : N ;
  inandning_nn_1_N : N ;
  inaugurering_nn_1_N : N ;
  inberaekning_nn_1_1_N : N ;
  inbesparing_nn_1_N : N ;
  inbetalning_nn_1_N : N ;
  inbillning_nn_1_N : N ;
  inbjudning_nn_1_N : N ;
  inblandning_nn_1_N : N ;
  inblick_nn_1_N : N ;
  inbokning_nn_1_N : N ;
  inbromsning_nn_1_N : N ;
  inbrytning_nn_1_N : N ;
  inbuktning_nn_1_N : N ;
  inburning_nn_1_N : N ;
  indelning_nn_1_N : N ;
  indexering_nn_1_N : N ;
  indexreglering_nn_1_N : N ;
  indianhoevding_nn_1_1_N : N ;
  indicering_nn_1_N : N ;
  indikering_nn_1_N : N ;
  individualisering_nn_1_N : N ;
  indoktrinering_nn_1_N : N ;
  indragning_nn_1_N : N ;
  indrivning_nn_1_N : N ;
  indraenkning_nn_1_1_N : N ;
  inducering_nn_1_N : N ;
  indunstning_nn_1_N : N ;
  industrialisering_nn_1_N : N ;
  infartsport_nn_1_N : N ;
  infattning_nn_1_N : N ;
  infektering_nn_1_N : N ;
  infektionssjukdom_nn_1_N : N ;
  infiltrering_nn_1_N : N ;
  inflammering_nn_1_N : N ;
  inflickning_nn_1_N : N ;
  influering_nn_1_N : N ;
  inflygning_nn_1_N : N ;
  inflyttning_nn_1_N : N ;
  inflaetning_nn_1_1_N : N ;
  infogning_nn_1_N : N ;
  infordring_nn_1_N : N ;
  informationsbehandling_nn_1_N : N ;
  informationssoekning_nn_1_1_N : N ;
  informering_nn_1_N : N ;
  infragrill_nn_1_N : N ;
  infrastruktursatsning_nn_1_N : N ;
  infrysning_nn_1_N : N ;
  infaestning_nn_1_1_N : N ;
  infoerlivning_nn_1_1_N : N ;
  ingenjoersutbildning_nn_1_1_N : N ;
  ingjutning_nn_1_N : N ;
  ingravering_nn_1_N : N ;
  ingaang_nn_1_1_N : N ;
  ingaangsdoerr_nn_1_1_N : N ;
  ingaangsspaenning_nn_1_1_N : N ;
  inhalering_nn_1_N : N ;
  inhibering_nn_1_N : N ;
  inhibitering_nn_1_N : N ;
  inhuggning_nn_1_N : N ;
  inhysning_nn_1_N : N ;
  inhoestning_nn_1_1_N : N ;
  initiering_nn_1_N : N ;
  injektering_nn_1_N : N ;
  injektionsnaal_nn_1_1_N : N ;
  injicering_nn_1_N : N ;
  inkapsling_nn_1_N : N ;
  inkarnering_nn_1_N : N ;
  inkassering_nn_1_N : N ;
  inklarering_nn_1_N : N ;
  inkludering_nn_1_N : N ;
  inkomstbeskattning_nn_1_N : N ;
  inkomstskattesaenkning_nn_1_1_N : N ;
  inkomsttaxering_nn_1_N : N ;
  inkomstoekning_nn_1_1_N : N ;
  inkoppling_nn_1_N : N ;
  inkorg_nn_1_N : N ;
  inkorporering_nn_1_N : N ;
  inkraektning_nn_1_1_N : N ;
  inkvartering_nn_1_N : N ;
  inkoepsavdelning_nn_1_1_N : N ;
  inkoerning_nn_1_1_N : N ;
  inkoersport_nn_1_1_N : N ;
  inlasning_nn_1_N : N ;
  inledning_nn_1_N : N ;
  inlindning_nn_1_N : N ;
  inloggning_nn_1_N : N ;
  inlaeggning_nn_1_1_N : N ;
  inlaemning_nn_1_1_N : N ;
  inlaerning_nn_1_1_N : N ;
  inlaesning_nn_1_1_N : N ;
  inlaaning_nn_1_1_N : N ;
  inlaasning_nn_1_1_N : N ;
  inloepning_nn_1_1_N : N ;
  inloesning_nn_1_1_N : N ;
  inmatning_nn_1_N : N ;
  inmutning_nn_1_N : N ;
  inmaengning_nn_1_1_N : N ;
  inmaetning_nn_1_1_N : N ;
  inmoenstring_nn_1_1_N : N ;
  innanlaesning_nn_1_1_N : N ;
  innehaallning_nn_1_1_N : N ;
  innehaallsfoerteckning_nn_1_1_N : N ;
  innekrog_nn_1_N : N ;
  innerdoerr_nn_1_1_N : N ;
  innerslang_nn_1_N : N ;
  innervering_nn_1_N : N ;
  innervaegg_nn_1_1_N : N ;
  inneslutning_nn_1_N : N ;
  innoetning_nn_1_1_N : N ;
  inokulering_nn_1_N : N ;
  inoljning_nn_1_N : N ;
  inomhusbelysning_nn_1_N : N ;
  inomhusforskning_nn_1_N : N ;
  inpackning_nn_1_N : N ;
  inpassning_nn_1_N : N ;
  inpetning_nn_1_N : N ;
  inplantering_nn_1_N : N ;
  inplantning_nn_1_N : N ;
  inpluggning_nn_1_N : N ;
  inpressning_nn_1_N : N ;
  inpraentning_nn_1_1_N : N ;
  inramning_nn_1_N : N ;
  inrangering_nn_1_N : N ;
  inrapportering_nn_1_N : N ;
  inredning_nn_1_N : N ;
  inregistrering_nn_1_N : N ;
  inridning_nn_1_N : N ;
  inrikesavgaang_nn_1_1_N : N ;
  inriktning_nn_1_N : N ;
  inristning_nn_1_N : N ;
  inropning_nn_1_N : N ;
  inrusning_nn_1_N : N ;
  inryckning_nn_1_N : N ;
  inrymning_nn_1_N : N ;
  inraekning_nn_1_1_N : N ;
  inraettning_nn_1_1_N : N ;
  inroestning_nn_1_1_N : N ;
  insamling_nn_1_N : N ;
  inscenering_nn_1_N : N ;
  insegling_nn_1_N : N ;
  insektsbefruktning_nn_1_N : N ;
  insektssamling_nn_1_N : N ;
  inseminering_nn_1_N : N ;
  insinuering_nn_1_N : N ;
  insistering_nn_1_N : N ;
  insjungning_nn_1_N : N ;
  inskeppning_nn_1_N : N ;
  inskjutning_nn_1_N : N ;
  inskolning_nn_1_N : N ;
  inskrivning_nn_1_N : N ;
  inskrivningsdag_nn_1_N : N ;
  inskraenkning_nn_1_1_N : N ;
  inskaerning_nn_1_1_N : N ;
  inskaerpning_nn_1_1_N : N ;
  insmuggling_nn_1_N : N ;
  insmygning_nn_1_N : N ;
  insmoerjning_nn_1_1_N : N ;
  inspark_nn_1_N : N ;
  inspektering_nn_1_N : N ;
  inspelning_nn_1_N : N ;
  inspelningsknapp_nn_1_N : N ;
  inspirering_nn_1_N : N ;
  insprutning_nn_1_N : N ;
  inspaerrning_nn_1_1_N : N ;
  installationsfoerelaesning_nn_1_1_N : N ;
  installering_nn_1_N : N ;
  instiftning_nn_1_N : N ;
  institutionalisering_nn_1_N : N ;
  instoppning_nn_1_N : N ;
  instroduktionsfoerelaesning_nn_1_1_N : N ;
  instruering_nn_1_N : N ;
  instrumentbelysning_nn_1_N : N ;
  instrumentering_nn_1_N : N ;
  instrumentflygning_nn_1_N : N ;
  instraalning_nn_1_1_N : N ;
  instudering_nn_1_N : N ;
  instuvning_nn_1_N : N ;
  instaellning_nn_1_1_N : N ;
  instaengning_nn_1_1_N : N ;
  insugning_nn_1_N : N ;
  insupning_nn_1_N : N ;
  insvepning_nn_1_N : N ;
  insvaengning_nn_1_1_N : N ;
  insyltning_nn_1_N : N ;
  insaendning_nn_1_1_N : N ;
  insaettning_nn_1_1_N : N ;
  insoendring_nn_1_1_N : N ;
  intagning_nn_1_N : N ;
  intagningshandling_nn_1_N : N ;
  intagsdamm_nn_1_N : N ;
  intalning_nn_1_N : N ;
  inteckning_nn_1_N : N ;
  integralhjaelm_nn_1_1_N : N ;
  integrering_nn_1_N : N ;
  intellektualisering_nn_1_N : N ;
  intelligensmaetning_nn_1_1_N : N ;
  intensifiering_nn_1_N : N ;
  intensivering_nn_1_N : N ;
  intensivundersoekning_nn_1_1_N : N ;
  intensivvaardsavdelning_nn_1_1_N : N ;
  intensivvaardsutrustning_nn_1_1_N : N ;
  interagering_nn_1_N : N ;
  interferering_nn_1_N : N ;
  interfoliering_nn_1_N : N ;
  interimsregering_nn_1_N : N ;
  interioerbelysning_nn_1_1_N : N ;
  internalisering_nn_1_N : N ;
  internationalisering_nn_1_N : N ;
  internering_nn_1_N : N ;
  internutbildning_nn_1_N : N ;
  internutredning_nn_1_N : N ;
  interpellering_nn_1_N : N ;
  interpolering_nn_1_N : N ;
  interpretering_nn_1_N : N ;
  interpunktering_nn_1_N : N ;
  intervenering_nn_1_N : N ;
  intervjuundersoekning_nn_1_1_N : N ;
  intimitetsstoerning_nn_1_1_N : N ;
  intonering_nn_1_N : N ;
  intorkning_nn_1_N : N ;
  intressering_nn_1_N : N ;
  intrigering_nn_1_N : N ;
  intrimning_nn_1_N : N ;
  introducering_nn_1_N : N ;
  intraengling_nn_1_1_N : N ;
  intumning_nn_1_N : N ;
  intvaalning_nn_1_1_N : N ;
  invadering_nn_1_N : N ;
  invalidisering_nn_1_N : N ;
  invandrarbefolkning_nn_1_N : N ;
  invandring_nn_1_N : N ;
  invandringsvaeg_nn_1_1_N : N ;
  inventariefoerteckning_nn_1_1_N : N ;
  inventering_nn_1_N : N ;
  inverkning_nn_1_N : N ;
  invertering_nn_1_N : N ;
  investering_nn_1_N : N ;
  invigning_nn_1_N : N ;
  invintring_nn_1_N : N ;
  invitering_nn_1_N : N ;
  involvering_nn_1_N : N ;
  invaegning_nn_1_1_N : N ;
  invaendning_nn_1_1_N : N ;
  invaentning_nn_1_1_N : N ;
  invaevning_nn_1_1_N : N ;
  inympning_nn_1_N : N ;
  inoevning_nn_1_1_N : N ;
  irisering_nn_1_N : N ;
  ironisering_nn_1_N : N ;
  irrgaang_nn_1_1_N : N ;
  irritering_nn_1_N : N ;
  isbildning_nn_1_N : N ;
  isbit_nn_1_N : N ;
  isbjoern_nn_1_1_N : N ;
  isbrytning_nn_1_N : N ;
  iscensaettning_nn_1_1_N : N ;
  ishink_nn_1_N : N ;
  isklump_nn_1_N : N ;
  iskravning_nn_1_N : N ;
  islossning_nn_1_N : N ;
  islaenning_nn_1_1_N : N ;
  isolering_nn_1_N : N ;
  isoleringsavdelning_nn_1_N : N ;
  isotopmaetning_nn_1_1_N : N ;
  ispropp_nn_1_N : N ;
  isskruvning_nn_1_N : N ;
  issmaeltning_nn_1_1_N : N ;
  istaandsaettning_nn_1_1_N : N ;
  isvarning_nn_1_N : N ;
  isvind_nn_1_N : N ;
  isaelv_nn_1_1_N : N ;
  isaettning_nn_1_1_N : N ;
  iterering_nn_1_N : N ;
  jabirustork_nn_1_N : N ;
  jagfoerestaellning_nn_1_1_N : N ;
  jagupploesning_nn_1_1_N : N ;
  jaktfoerordning_nn_1_1_N : N ;
  jaktkniv_nn_1_N : N ;
  jaktridning_nn_1_N : N ;
  jamning_nn_1_N : N ;
  jantelag_nn_1_N : N ;
  jazzifiering_nn_1_N : N ;
  jethjaelm_nn_1_1_N : N ;
  jobbskattesaenkning_nn_1_1_N : N ;
  jodering_nn_1_N : N ;
  joggling_nn_1_N : N ;
  jonbildning_nn_1_N : N ;
  jonbindning_nn_1_N : N ;
  jonfoerening_nn_1_1_N : N ;
  jonglering_nn_1_N : N ;
  jonisering_nn_1_N : N ;
  jordavsoendring_nn_1_1_N : N ;
  jordbegravning_nn_1_N : N ;
  jordbruksbefolkning_nn_1_N : N ;
  jordbaevning_nn_1_1_N : N ;
  jorddelning_nn_1_N : N ;
  jordegendom_nn_1_N : N ;
  jordflytning_nn_1_N : N ;
  jordfaestning_nn_1_1_N : N ;
  jordfoerbaettring_nn_1_1_N : N ;
  jordfoerstoering_nn_1_1_N : N ;
  jordledning_nn_1_N : N ;
  jordutdelning_nn_1_N : N ;
  jordvall_nn_1_N : N ;
  jordvaerdestegring_nn_1_1_N : N ;
  jubilering_nn_1_N : N ;
  judasgaerning_nn_1_1_N : N ;
  judendom_nn_1_N : N ;
  julbelysning_nn_1_N : N ;
  julgransbelysning_nn_1_N : N ;
  julgransplundring_nn_1_N : N ;
  julskyltning_nn_1_N : N ;
  jultallrik_nn_1_N : N ;
  jultidning_nn_1_N : N ;
  jungfrualstring_nn_1_N : N ;
  jungfrudom_nn_1_N : N ;
  justerarm_nn_1_N : N ;
  justering_nn_1_N : N ;
  jyllaenning_nn_1_1_N : N ;
  jaegarbefolkning_nn_1_1_N : N ;
  jaegarhatt_nn_1_1_N : N ;
  jaemkning_nn_1_1_N : N ;
  jaemtlaenning_nn_1_1_N : N ;
  jaerndoerr_nn_1_1_N : N ;
  jaernframstaellning_nn_1_1_N : N ;
  jaerngrind_nn_1_1_N : N ;
  jaernhantering_nn_1_1_N : N ;
  jaernhaell_nn_1_1_N : N ;
  jaernklump_nn_1_1_N : N ;
  jaernlegering_nn_1_1_N : N ;
  jaernring_nn_1_1_N : N ;
  jaerntillverkning_nn_1_1_N : N ;
  jaerntraad_nn_1_1_N : N ;
  jaernvaeg_nn_1_1_N : N ;
  jaernvaegsinvestering_nn_1_1_N : N ;
  jaernvaegsknut_nn_1_1_N : N ;
  jaernvaegskorsning_nn_1_1_N : N ;
  jaernvaegsvagn_nn_1_1_N : N ;
  jaernvaegsoevergaang_nn_1_1_N : N ;
  jaesning_nn_1_1_N : N ;
  jaetteflopp_nn_1_1_N : N ;
  jaetteorm_nn_1_1_N : N ;
  jaettesockerbit_nn_1_1_N : N ;
  joekelport_nn_1_1_N : N ;
  kabelgenomfoering_nn_1_1_N : N ;
  kaderoevning_nn_1_1_N : N ;
  kaffeersaettning_nn_1_1_N : N ;
  kaffeflaeck_nn_1_1_N : N ;
  kaffekokning_nn_1_N : N ;
  kaffekvarn_nn_1_N : N ;
  kaffeservering_nn_1_N : N ;
  kaffesked_nn_1_N : N ;
  kafkastaemning_nn_1_1_N : N ;
  kajskoning_nn_1_N : N ;
  kakburk_nn_1_N : N ;
  kakelugn_nn_1_N : N ;
  kakform_nn_1_N : N ;
  kalandrering_nn_1_N : N ;
  kalcinering_nn_1_N : N ;
  kalenderfotografering_nn_1_N : N ;
  kalfatring_nn_1_N : N ;
  kalibrering_nn_1_N : N ;
  kalibreringsknapp_nn_1_N : N ;
  kalkanhopning_nn_1_N : N ;
  kalkering_nn_1_N : N ;
  kalkmaalning_nn_1_1_N : N ;
  kalkstenshaell_nn_1_1_N : N ;
  kalkstenskaak_nn_1_1_N : N ;
  kalkstensvaegg_nn_1_1_N : N ;
  kalkylering_nn_1_N : N ;
  kallelsegaerning_nn_1_1_N : N ;
  kallmur_nn_1_N : N ;
  kallsaag_nn_1_1_N : N ;
  kalluftsflaekt_nn_1_1_N : N ;
  kalmering_nn_1_N : N ;
  kalvkyckling_nn_1_N : N ;
  kalvlaegg_nn_1_1_N : N ;
  kalvning_nn_1_N : N ;
  kalvstek_nn_1_N : N ;
  kalvstaellning_nn_1_1_N : N ;
  kamelforskning_nn_1_N : N ;
  kammarskjutning_nn_1_N : N ;
  kammarskruv_nn_1_N : N ;
  kamning_nn_1_N : N ;
  kamouflering_nn_1_N : N ;
  kampanjraekning_nn_1_1_N : N ;
  kampering_nn_1_N : N ;
  kamphund_nn_1_N : N ;
  kamratpaaverkning_nn_1_1_N : N ;
  kanalbaat_nn_1_1_N : N ;
  kanalisering_nn_1_N : N ;
  kanalkrock_nn_1_N : N ;
  kandering_nn_1_N : N ;
  kandidering_nn_1_N : N ;
  kannelering_nn_1_N : N ;
  kanonbaat_nn_1_1_N : N ;
  kanonisering_nn_1_N : N ;
  kanonlock_nn_1_N : N ;
  kanonport_nn_1_N : N ;
  kanthuggning_nn_1_N : N ;
  kantklippning_nn_1_N : N ;
  kapacitetshoejning_nn_1_1_N : N ;
  kapacitetsoekning_nn_1_1_N : N ;
  kapitalavkastning_nn_1_N : N ;
  kapitalbeskattning_nn_1_N : N ;
  kapitalbildning_nn_1_N : N ;
  kapitalfoerstoering_nn_1_1_N : N ;
  kapitalfoersaekring_nn_1_1_N : N ;
  kapitalinkomstbeskattning_nn_1_N : N ;
  kapitalinvestering_nn_1_N : N ;
  kapitalisering_nn_1_N : N ;
  kapitalplacering_nn_1_N : N ;
  kapitelindelning_nn_1_N : N ;
  kapitelsal_nn_1_N : N ;
  kapitulering_nn_1_N : N ;
  kapning_nn_1_N : N ;
  kappkoerning_nn_1_1_N : N ;
  kapploepning_nn_1_1_N : N ;
  kapprustning_nn_1_N : N ;
  kappsegling_nn_1_N : N ;
  kappsimning_nn_1_N : N ;
  kappvaendning_nn_1_1_N : N ;
  kapsling_nn_1_N : N ;
  kapsaag_nn_1_1_N : N ;
  karakolering_nn_1_N : N ;
  karakterisering_nn_1_N : N ;
  karaktaerisering_nn_1_1_N : N ;
  karaktaersfoerdjupning_nn_1_1_N : N ;
  karaktaersskildring_nn_1_1_N : N ;
  karambolering_nn_1_N : N ;
  karatering_nn_1_N : N ;
  karatespark_nn_1_N : N ;
  karborundumduk_nn_1_N : N ;
  kardanknut_nn_1_N : N ;
  kardanupphaengning_nn_1_1_N : N ;
  kardborreknaeppning_nn_1_1_N : N ;
  karensdag_nn_1_N : N ;
  karikering_nn_1_N : N ;
  karmskruv_nn_1_N : N ;
  karmstol_nn_1_N : N ;
  karriaerfoersaekring_nn_1_1_N : N ;
  karriaervaeg_nn_1_1_N : N ;
  karstbildning_nn_1_N : N ;
  kartanteckning_nn_1_N : N ;
  kartering_nn_1_N : N ;
  kartlaeggning_nn_1_1_N : N ;
  kartlaesning_nn_1_1_N : N ;
  kartonnering_nn_1_N : N ;
  karvstock_nn_1_N : N ;
  kaskadkoppling_nn_1_N : N ;
  kaskofoersaekring_nn_1_1_N : N ;
  kassabehaallning_nn_1_1_N : N ;
  kassationsdomstol_nn_1_N : N ;
  kassering_nn_1_N : N ;
  kastning_nn_1_N : N ;
  kastrering_nn_1_N : N ;
  kastvind_nn_1_N : N ;
  kasusanvaendning_nn_1_1_N : N ;
  katalogisering_nn_1_N : N ;
  katalysering_nn_1_N : N ;
  katapultstol_nn_1_N : N ;
  katastrofvarning_nn_1_N : N ;
  katederundervisning_nn_1_N : N ;
  kategoriklyvning_nn_1_N : N ;
  kategorisering_nn_1_N : N ;
  kateterisering_nn_1_N : N ;
  katetrisering_nn_1_N : N ;
  kattskit_nn_1_N : N ;
  kauterisering_nn_1_N : N ;
  kedjefoering_nn_1_1_N : N ;
  kedjesaag_nn_1_1_N : N ;
  kejsaroern_nn_1_1_N : N ;
  kemtvaett_nn_1_1_N : N ;
  keramikform_nn_1_N : N ;
  kesning_nn_1_N : N ;
  kidnappning_nn_1_N : N ;
  kilram_nn_1_N : N ;
  kilspaerr_nn_1_1_N : N ;
  kiselfoerening_nn_1_1_N : N ;
  kittling_nn_1_N : N ;
  kittning_nn_1_N : N ;
  kjolfaall_nn_1_1_N : N ;
  klabbstroemming_nn_1_1_N : N ;
  klackring_nn_1_N : N ;
  klackspark_nn_1_N : N ;
  klanhoevding_nn_1_1_N : N ;
  klappning_nn_1_N : N ;
  klarering_nn_1_N : N ;
  klarning_nn_1_N : N ;
  klassificering_nn_1_N : N ;
  klassindelning_nn_1_N : N ;
  klasslag_nn_1_N : N ;
  klassmotsaettning_nn_1_1_N : N ;
  klassundervisning_nn_1_N : N ;
  klatschning_nn_1_N : N ;
  klenspaenning_nn_1_1_N : N ;
  klickning_nn_1_N : N ;
  klimakteriesvallning_nn_1_N : N ;
  klimatanlaeggning_nn_1_1_N : N ;
  klimatfoeraendring_nn_1_1_N : N ;
  klimatsvaengning_nn_1_1_N : N ;
  klimatvaersting_nn_1_1_N : N ;
  klimatvaexling_nn_1_1_N : N ;
  klimataendring_nn_1_1_N : N ;
  klippgrav_nn_1_N : N ;
  klippmaalning_nn_1_1_N : N ;
  klippning_nn_1_N : N ;
  klivning_nn_1_N : N ;
  kloasongvaegg_nn_1_1_N : N ;
  klockarkaerlek_nn_1_1_N : N ;
  klockklaepp_nn_1_1_N : N ;
  klockringning_nn_1_N : N ;
  klonering_nn_1_N : N ;
  klorering_nn_1_N : N ;
  klostermur_nn_1_N : N ;
  klostertraedgaard_nn_1_1_N : N ;
  klotgrill_nn_1_N : N ;
  klotterutredning_nn_1_N : N ;
  kluckning_nn_1_N : N ;
  klunkning_nn_1_N : N ;
  klyvning_nn_1_N : N ;
  klyvsaag_nn_1_1_N : N ;
  klyvoeppning_nn_1_1_N : N ;
  klaeckning_nn_1_1_N : N ;
  klaedhoeg_nn_1_1_N : N ;
  klaedkorg_nn_1_1_N : N ;
  klaedning_nn_1_1_N : N ;
  klaedseltvaett_nn_1_1_N : N ;
  klaedstorlek_nn_1_1_N : N ;
  klaedtvaett_nn_1_1_N : N ;
  klaemdag_nn_1_1_N : N ;
  klaemtning_nn_1_1_N : N ;
  klaengning_nn_1_1_N : N ;
  klaenning_nn_1_1_N : N ;
  klaetterstaellning_nn_1_1_N : N ;
  klaettring_nn_1_1_N : N ;
  kloesning_nn_1_1_N : N ;
  knackkorv_nn_1_N : N ;
  knackning_nn_1_N : N ;
  knakning_nn_1_N : N ;
  knallhatt_nn_1_N : N ;
  knappnaal_nn_1_1_N : N ;
  knapptryckning_nn_1_N : N ;
  knarkarbrud_nn_1_N : N ;
  knarkhund_nn_1_N : N ;
  knarkning_nn_1_N : N ;
  knarrning_nn_1_N : N ;
  knasboll_nn_1_N : N ;
  knipning_nn_1_N : N ;
  knivkastning_nn_1_N : N ;
  knivsegg_nn_1_N : N ;
  knixning_nn_1_N : N ;
  knoppning_nn_1_N : N ;
  knoppsprickning_nn_1_N : N ;
  knoppsaettning_nn_1_1_N : N ;
  knuffning_nn_1_N : N ;
  knyckning_nn_1_N : N ;
  knyppling_nn_1_N : N ;
  knytning_nn_1_N : N ;
  knaeboejning_nn_1_1_N : N ;
  knaeckform_nn_1_1_N : N ;
  knaeckning_nn_1_1_N : N ;
  knaeppgoek_nn_1_1_N : N ;
  knaeppning_nn_1_1_N : N ;
  knaadning_nn_1_1_N : N ;
  koaffering_nn_1_N : N ;
  koagulering_nn_1_N : N ;
  koalitionsregering_nn_1_N : N ;
  kodifiering_nn_1_N : N ;
  kodvaexling_nn_1_1_N : N ;
  kofferdamm_nn_1_N : N ;
  kokettering_nn_1_N : N ;
  kokkorv_nn_1_N : N ;
  kokning_nn_1_N : N ;
  kokosboll_nn_1_N : N ;
  koksning_nn_1_N : N ;
  kolbit_nn_1_N : N ;
  kolboll_nn_1_N : N ;
  koleld_nn_1_N : N ;
  kolfoerening_nn_1_1_N : N ;
  kolhoeg_nn_1_1_N : N ;
  kollabering_nn_1_N : N ;
  kollaborering_nn_1_N : N ;
  kollationering_nn_1_N : N ;
  kollekthaav_nn_1_1_N : N ;
  kollektivanslutning_nn_1_N : N ;
  kollektivanstaellning_nn_1_1_N : N ;
  kollektivfoersaekring_nn_1_1_N : N ;
  kollektivisering_nn_1_N : N ;
  kollidering_nn_1_N : N ;
  kolmonoxidfoergiftning_nn_1_1_N : N ;
  kolning_nn_1_N : N ;
  kolonisering_nn_1_N : N ;
  kolonnordning_nn_1_N : N ;
  kolorering_nn_1_N : N ;
  kolosfoergiftning_nn_1_1_N : N ;
  koloxidfoergiftning_nn_1_1_N : N ;
  kolportering_nn_1_N : N ;
  koltavdelning_nn_1_N : N ;
  kolteckning_nn_1_N : N ;
  koltraad_nn_1_1_N : N ;
  kombinationstaevling_nn_1_1_N : N ;
  kombinering_nn_1_N : N ;
  kommatering_nn_1_N : N ;
  kommendering_nn_1_N : N ;
  kommentering_nn_1_N : N ;
  kommersialisering_nn_1_N : N ;
  kommitt_efoerordning_nn_1_1_N : N ;
  kommunalfoervaltning_nn_1_1_N : N ;
  kommunalisering_nn_1_N : N ;
  kommunallag_nn_1_N : N ;
  kommunicering_nn_1_N : N ;
  kommunistvaerld_nn_1_1_N : N ;
  kommunledning_nn_1_N : N ;
  kommunsammanslagning_nn_1_N : N ;
  kommutering_nn_1_N : N ;
  komparering_nn_1_N : N ;
  kompassriktning_nn_1_N : N ;
  kompensering_nn_1_N : N ;
  kompilering_nn_1_N : N ;
  komplettering_nn_1_N : N ;
  komplicering_nn_1_N : N ;
  komplimentering_nn_1_N : N ;
  komponering_nn_1_N : N ;
  kompositstock_nn_1_N : N ;
  kompostering_nn_1_N : N ;
  kompostkvarn_nn_1_N : N ;
  komprimering_nn_1_N : N ;
  kompromettering_nn_1_N : N ;
  koncentrationslaesning_nn_1_1_N : N ;
  koncentrationsstoerning_nn_1_1_N : N ;
  koncentrering_nn_1_N : N ;
  koncernledning_nn_1_N : N ;
  koncessionering_nn_1_N : N ;
  koncipiering_nn_1_N : N ;
  kondemnering_nn_1_N : N ;
  kondensering_nn_1_N : N ;
  konditionering_nn_1_N : N ;
  kondolering_nn_1_N : N ;
  konferenstolk_nn_1_N : N ;
  konferering_nn_1_N : N ;
  konfirmationsklaenning_nn_1_1_N : N ;
  konfirmationsundervisning_nn_1_N : N ;
  konfirmering_nn_1_N : N ;
  konfiskering_nn_1_N : N ;
  konflikthaerd_nn_1_1_N : N ;
  konfrontering_nn_1_N : N ;
  konfundering_nn_1_N : N ;
  kongruensboejning_nn_1_1_N : N ;
  kongruering_nn_1_N : N ;
  konjugering_nn_1_N : N ;
  konjunkturfoerbaettring_nn_1_1_N : N ;
  konkludering_nn_1_N : N ;
  konkning_nn_1_N : N ;
  konkretisering_nn_1_N : N ;
  konkurrering_nn_1_N : N ;
  konkursbevakning_nn_1_N : N ;
  konsertering_nn_1_N : N ;
  konserthall_nn_1_N : N ;
  konservburk_nn_1_N : N ;
  konservering_nn_1_N : N ;
  konsignering_nn_1_N : N ;
  konsolidering_nn_1_N : N ;
  konspirering_nn_1_N : N ;
  konstatering_nn_1_N : N ;
  konstbevattning_nn_1_N : N ;
  konsternering_nn_1_N : N ;
  konstflygning_nn_1_N : N ;
  konstfoerelaesning_nn_1_1_N : N ;
  konstfoerening_nn_1_1_N : N ;
  konstituering_nn_1_N : N ;
  konstlaederfoerstaerkning_nn_1_1_N : N ;
  konstmaalning_nn_1_1_N : N ;
  konstridning_nn_1_N : N ;
  konstriktning_nn_1_N : N ;
  konstruering_nn_1_N : N ;
  konstruktionsritning_nn_1_N : N ;
  konstsamling_nn_1_N : N ;
  konstsatsning_nn_1_N : N ;
  konststil_nn_1_N : N ;
  konstutstaellning_nn_1_1_N : N ;
  konstaakning_nn_1_1_N : N ;
  konsultering_nn_1_N : N ;
  konsumentfoerening_nn_1_1_N : N ;
  konsumentupplysning_nn_1_N : N ;
  konsumering_nn_1_N : N ;
  kontaktledning_nn_1_N : N ;
  kontaminering_nn_1_N : N ;
  kontering_nn_1_N : N ;
  kontingentering_nn_1_N : N ;
  kontorisering_nn_1_N : N ;
  kontorsdoerr_nn_1_1_N : N ;
  kontorsstol_nn_1_N : N ;
  kontrahering_nn_1_N : N ;
  kontraktering_nn_1_N : N ;
  kontraktsfoerhandling_nn_1_1_N : N ;
  kontramandering_nn_1_N : N ;
  kontrasignering_nn_1_N : N ;
  kontrastering_nn_1_N : N ;
  kontribuering_nn_1_N : N ;
  kontring_nn_1_N : N ;
  kontrollbesiktning_nn_1_N : N ;
  kontrollering_nn_1_N : N ;
  kontrollfreak_nn_1_N : N ;
  kontrollundersoekning_nn_1_1_N : N ;
  kontrollvaegning_nn_1_1_N : N ;
  kontumaciedom_nn_1_N : N ;
  konturering_nn_1_N : N ;
  kontursaag_nn_1_1_N : N ;
  konung_nn_1_N : N ;
  konvergering_nn_1_N : N ;
  konversering_nn_1_N : N ;
  konvertering_nn_1_N : N ;
  konvojering_nn_1_N : N ;
  kooperering_nn_1_N : N ;
  koordinering_nn_1_N : N ;
  kopiering_nn_1_N : N ;
  kopparledning_nn_1_N : N ;
  koppling_nn_1_N : N ;
  koppympning_nn_1_N : N ;
  kopulering_nn_1_N : N ;
  koravslutning_nn_1_N : N ;
  kordongskruv_nn_1_N : N ;
  korgboll_nn_2_N : N ;
  korgstol_nn_1_N : N ;
  korkning_nn_1_N : N ;
  korkskruvslock_nn_1_N : N ;
  korkskoerd_nn_1_1_N : N ;
  korngrynsvaelling_nn_1_1_N : N ;
  korpglugg_nn_1_N : N ;
  korpning_nn_2_N : N ;
  korpussoekning_nn_1_1_N : N ;
  korrekturlaesning_nn_1_1_N : N ;
  korrelering_nn_1_N : N ;
  korrespondensundervisning_nn_1_N : N ;
  korrespondering_nn_1_N : N ;
  korrigering_nn_1_N : N ;
  korrodering_nn_1_N : N ;
  korrugering_nn_1_N : N ;
  korrumpering_nn_1_N : N ;
  korruptionsraettegaang_nn_1_1_N : N ;
  korsbefruktning_nn_1_N : N ;
  korseld_nn_1_N : N ;
  korsettering_nn_1_N : N ;
  korsgaang_nn_1_1_N : N ;
  korshaenvisning_nn_1_1_N : N ;
  korsning_nn_1_N : N ;
  korsordstidning_nn_1_N : N ;
  korsvaeg_nn_1_1_N : N ;
  kortegebil_nn_1_N : N ;
  kortegevaeg_nn_1_1_N : N ;
  kortisonbehandling_nn_1_N : N ;
  kortlek_nn_1_N : N ;
  kortling_nn_1_N : N ;
  kortpassning_nn_1_N : N ;
  kortslutning_nn_1_N : N ;
  korttidsparkering_nn_1_N : N ;
  kortvaegg_nn_1_1_N : N ;
  kortvaagsbehandling_nn_1_1_N : N ;
  korvstoppning_nn_1_N : N ;
  korvtillverkning_nn_1_N : N ;
  kosing_nn_1_N : N ;
  kosterbaat_nn_1_1_N : N ;
  kosthaallning_nn_1_1_N : N ;
  kostig_nn_1_N : N ;
  kostnadsbesparing_nn_1_N : N ;
  kostnadsersaettning_nn_1_1_N : N ;
  kostnadsram_nn_1_N : N ;
  kostnadsutveckling_nn_1_N : N ;
  kostnadsoekning_nn_1_1_N : N ;
  kostymering_nn_1_N : N ;
  kotknackning_nn_1_N : N ;
  kovaendning_nn_1_1_N : N ;
  koxning_nn_1_N : N ;
  krackelering_nn_1_N : N ;
  krackning_nn_1_N : N ;
  krafsning_nn_1_N : N ;
  kraftanstraengning_nn_1_1_N : N ;
  kraftfoerbrukning_nn_1_1_N : N ;
  kraftfoersoerjning_nn_1_1_N : N ;
  kraftledning_nn_1_N : N ;
  kraftmaetning_nn_1_1_N : N ;
  kraftsamling_nn_1_N : N ;
  kraftverksdamm_nn_1_N : N ;
  kraftyttring_nn_1_N : N ;
  kraftoeverfoering_nn_1_1_N : N ;
  kragknapp_nn_1_N : N ;
  kramning_nn_1_N : N ;
  krampryckning_nn_1_N : N ;
  kransnedlaeggning_nn_1_1_N : N ;
  kratervaegg_nn_1_1_N : N ;
  krateroeppning_nn_1_1_N : N ;
  kravallskoeld_nn_1_1_N : N ;
  kravattnaal_nn_1_1_N : N ;
  kraxning_nn_1_N : N ;
  kreatursbesaettning_nn_1_1_N : N ;
  kredensning_nn_1_N : N ;
  kreditering_nn_1_N : N ;
  kreditgivning_nn_1_N : N ;
  kreditupplysning_nn_1_N : N ;
  kreditupplysningslag_nn_1_N : N ;
  kreditvaerdering_nn_1_1_N : N ;
  kreditaatstramning_nn_1_1_N : N ;
  kreering_nn_1_N : N ;
  kremering_nn_1_N : N ;
  krenelering_nn_1_N : N ;
  krepering_nn_1_N : N ;
  kretsgaang_nn_1_1_N : N ;
  kretsning_nn_1_N : N ;
  krevering_nn_1_N : N ;
  krigargrav_nn_1_N : N ;
  krigfoering_nn_1_1_N : N ;
  krigsfoerklaring_nn_1_1_N : N ;
  krigsgud_nn_1_N : N ;
  krigshaerd_nn_1_1_N : N ;
  krigsmaalning_nn_1_1_N : N ;
  krigsplacering_nn_1_N : N ;
  krigsskildring_nn_1_N : N ;
  krigstjaenstgoering_nn_1_1_N : N ;
  kriminalisering_nn_1_N : N ;
  kringgaerdning_nn_1_1_N : N ;
  kringraenning_nn_1_1_N : N ;
  kringskansning_nn_1_N : N ;
  kringskaerning_nn_1_1_N : N ;
  kringutrustning_nn_1_N : N ;
  kringvaeg_nn_1_1_N : N ;
  krishushaallning_nn_1_1_N : N ;
  krisstaemning_nn_1_1_N : N ;
  kristallisering_nn_1_N : N ;
  kristendom_nn_1_N : N ;
  kristendomsundervisning_nn_1_N : N ;
  kristning_nn_1_N : N ;
  kritisering_nn_1_N : N ;
  krogsvaeng_nn_1_1_N : N ;
  krokvaeg_nn_1_1_N : N ;
  kromosomuppsaettning_nn_1_1_N : N ;
  kronbjudning_nn_1_N : N ;
  kropp_nn_1_N : N ;
  kroppsfixering_nn_1_N : N ;
  kroppsstorlek_nn_1_N : N ;
  kroppsstaellning_nn_1_1_N : N ;
  kroppsvisitering_nn_1_N : N ;
  kroppsoeppning_nn_1_1_N : N ;
  kroppsoevning_nn_1_1_N : N ;
  krossning_nn_1_N : N ;
  krusning_nn_1_N : N ;
  krutkaering_nn_1_1_N : N ;
  krutkaerring_nn_1_1_N : N ;
  kryddbod_nn_1_N : N ;
  kryddning_nn_1_N : N ;
  krympning_nn_1_N : N ;
  kryptering_nn_1_N : N ;
  kryssning_nn_1_N : N ;
  kryssroestning_nn_1_1_N : N ;
  krystning_nn_1_N : N ;
  krystvaerk_nn_1_1_N : N ;
  kraekning_nn_1_1_N : N ;
  kraengning_nn_1_1_N : N ;
  kraenkning_nn_1_1_N : N ;
  kroekning_nn_1_1_N : N ;
  kroening_nn_1_1_N : N ;
  kubering_nn_1_N : N ;
  kuggning_nn_1_N : N ;
  kujonering_nn_1_N : N ;
  kukring_nn_1_N : N ;
  kulknapp_nn_1_N : N ;
  kullbyttering_nn_1_N : N ;
  kullkastning_nn_1_N : N ;
  kulminering_nn_1_N : N ;
  kulram_nn_1_N : N ;
  kulsprutavdelning_nn_1_N : N ;
  kulspruteskytt_nn_1_N : N ;
  kulstoetning_nn_1_1_N : N ;
  kulthandling_nn_1_N : N ;
  kultivering_nn_1_N : N ;
  kulturgaerning_nn_1_1_N : N ;
  kulturkrock_nn_1_N : N ;
  kulturskymning_nn_1_N : N ;
  kultursnobb_nn_1_N : N ;
  kultursponsring_nn_1_N : N ;
  kulturyttring_nn_1_N : N ;
  kuloertvaett_nn_1_1_N : N ;
  kumulering_nn_1_N : N ;
  kung_nn_1_N : N ;
  kunglighetsvurm_nn_1_N : N ;
  kungsgaard_nn_1_1_N : N ;
  kungsvaeg_nn_1_1_N : N ;
  kungsoern_nn_1_1_N : N ;
  kunskapslyft_nn_1_N : N ;
  kupering_nn_1_N : N ;
  kupolgrav_nn_1_N : N ;
  kup_edoerr_nn_1_1_N : N ;
  kurering_nn_1_N : N ;
  kurirsaeck_nn_1_1_N : N ;
  kurragoemmalek_nn_1_1_N : N ;
  kurrning_nn_1_N : N ;
  kursbeskrivning_nn_1_N : N ;
  kursering_nn_1_N : N ;
  kursivering_nn_1_N : N ;
  kursnotering_nn_1_N : N ;
  kursstegring_nn_1_N : N ;
  kursutveckling_nn_1_N : N ;
  kursaendring_nn_1_1_N : N ;
  kurtisering_nn_1_N : N ;
  kurvmall_nn_1_N : N ;
  kurvtagning_nn_1_N : N ;
  kustbevakning_nn_1_N : N ;
  kuvertering_nn_1_N : N ;
  kvadrering_nn_1_N : N ;
  kvalificering_nn_1_N : N ;
  kvalitetsgranskning_nn_1_N : N ;
  kvalitetssaekring_nn_1_1_N : N ;
  kvantifiering_nn_1_N : N ;
  kvarndamm_nn_1_N : N ;
  kvarsittning_nn_1_N : N ;
  kvartsback_nn_1_N : N ;
  kverulering_nn_1_N : N ;
  kvicksilverfoerening_nn_1_1_N : N ;
  kvinnofridskraenkning_nn_1_1_N : N ;
  kvinnofoernedring_nn_1_1_N : N ;
  kvinnograv_nn_1_N : N ;
  kvinnosjukdom_nn_1_N : N ;
  kvintilering_nn_1_N : N ;
  kvittering_nn_1_N : N ;
  kvittning_nn_1_N : N ;
  kvotering_nn_1_N : N ;
  kvotflykting_nn_1_N : N ;
  kvaeljning_nn_1_1_N : N ;
  kvaellning_nn_1_1_N : N ;
  kvaellsfoerelaesning_nn_1_1_N : N ;
  kvaellstidning_nn_1_1_N : N ;
  kvaellsunderhaallning_nn_1_1_N : N ;
  kvaesning_nn_1_1_N : N ;
  kvaevning_nn_1_1_N : N ;
  kylflaeck_nn_1_1_N : N ;
  kylflaekt_nn_1_1_N : N ;
  kylledning_nn_1_N : N ;
  kylning_nn_1_N : N ;
  kylskaapsdoerr_nn_1_1_N : N ;
  kylvagn_nn_1_N : N ;
  kyrkbokfoering_nn_1_1_N : N ;
  kyrkbaat_nn_1_1_N : N ;
  kyrkmur_nn_1_N : N ;
  kyrkobokfoering_nn_1_1_N : N ;
  kyrkogaardsfoervaltning_nn_1_1_N : N ;
  kyrkohaell_nn_1_1_N : N ;
  kyrkoledning_nn_1_N : N ;
  kyrkoordning_nn_1_N : N ;
  kyrkotagning_nn_1_N : N ;
  kyrksal_nn_1_N : N ;
  kyrktagning_nn_1_N : N ;
  kyssning_nn_1_N : N ;
  kaeftsmaell_nn_1_1_N : N ;
  kaellarvaaning_nn_1_1_N : N ;
  kaellfoerteckning_nn_1_1_N : N ;
  kaellhaenvisning_nn_1_1_N : N ;
  kaelning_nn_1_1_N : N ;
  kaendisblogg_nn_1_1_N : N ;
  kaendispryl_nn_1_1_N : N ;
  kaennedom_nn_1_1_N : N ;
  kaenslovaerld_nn_1_1_N : N ;
  kaeringknut_nn_1_1_N : N ;
  kaerlek_nn_1_1_N : N ;
  kaerleksfoerklaring_nn_1_1_N : N ;
  kaerleksgud_nn_1_1_N : N ;
  kaerleksgaerning_nn_1_1_N : N ;
  kaerlsjukdom_nn_1_1_N : N ;
  kaernforskning_nn_1_1_N : N ;
  kaernklyvning_nn_1_1_N : N ;
  kaernkraftsnedlaeggning_nn_1_1_N : N ;
  kaernladdning_nn_1_1_N : N ;
  kaernvapenbegraensning_nn_1_1_N : N ;
  kaernvapenprovspraengning_nn_1_1_N : N ;
  kaerraeng_nn_1_1_N : N ;
  kaakstrykning_nn_1_1_N : N ;
  kaasering_nn_1_1_N : N ;
  kaaseristil_nn_1_1_N : N ;
  kaatbock_nn_1_1_N : N ;
  koeksdoerr_nn_1_1_N : N ;
  koeksflaekt_nn_1_1_N : N ;
  koeksingaang_nn_1_1_N : N ;
  koeksstol_nn_1_1_N : N ;
  koekssvamp_nn_1_1_N : N ;
  koekstraedgaard_nn_1_1_N : N ;
  koelapp_nn_1_1_N : N ;
  koelbaat_nn_1_1_N : N ;
  koeldblandning_nn_1_1_N : N ;
  koelhalning_nn_1_1_N : N ;
  koelstraeckning_nn_1_1_N : N ;
  koensdiskriminering_nn_1_1_N : N ;
  koensfoerdelning_nn_1_1_N : N ;
  koenskvotering_nn_1_1_N : N ;
  koenssegregering_nn_1_1_N : N ;
  koenssjukdom_nn_1_1_N : N ;
  koensutjaemning_nn_1_1_N : N ;
  koepeskilling_nn_1_1_N : N ;
  koerning_nn_1_1_N : N ;
  koerteloeppning_nn_1_1_N : N ;
  koervaeg_nn_1_1_N : N ;
  koettkvarn_nn_1_1_N : N ;
  labialisering_nn_1_N : N ;
  laborering_nn_1_N : N ;
  labourregering_nn_1_N : N ;
  lackering_nn_1_N : N ;
  lackning_nn_1_N : N ;
  laddindicering_nn_1_N : N ;
  laddindikering_nn_1_N : N ;
  laddning_nn_1_N : N ;
  laddram_nn_1_N : N ;
  laddstock_nn_1_N : N ;
  ladugaard_nn_1_1_N : N ;
  lagberedning_nn_1_N : N ;
  lagergaang_nn_1_1_N : N ;
  lagerkroening_nn_1_1_N : N ;
  lagersmatt_nn_1_N : N ;
  lagfaestning_nn_1_1_N : N ;
  lagkappsimning_nn_1_N : N ;
  lagning_nn_1_N : N ;
  lagskipning_nn_1_N : N ;
  lagskaerpning_nn_1_1_N : N ;
  lagstiftning_nn_1_N : N ;
  lagsoekning_nn_1_1_N : N ;
  lagtillaempning_nn_1_1_N : N ;
  laguppstaellning_nn_1_1_N : N ;
  lagaendring_nn_1_1_N : N ;
  lagaard_nn_1_1_N : N ;
  lallning_nn_1_N : N ;
  lamellkoppling_nn_1_N : N ;
  lamentering_nn_1_N : N ;
  laminering_nn_1_N : N ;
  lammkorv_nn_1_N : N ;
  lamning_nn_1_N : N ;
  lampanordning_nn_1_N : N ;
  landgaang_nn_1_1_N : N ;
  landhoejning_nn_1_1_N : N ;
  landkaenning_nn_1_1_N : N ;
  landning_nn_1_N : N ;
  landsbygdsbefolkning_nn_1_N : N ;
  landsflykting_nn_1_N : N ;
  landsfoervisning_nn_1_1_N : N ;
  landskapslag_nn_1_N : N ;
  landskapsskildring_nn_1_N : N ;
  landslag_nn_2_N : N ;
  landstigning_nn_1_N : N ;
  landstigningsbaat_nn_1_1_N : N ;
  landsvaeg_nn_1_1_N : N ;
  landsaettning_nn_1_1_N : N ;
  landvind_nn_1_N : N ;
  landvinning_nn_1_N : N ;
  langettering_nn_1_N : N ;
  langning_nn_1_N : N ;
  lansering_nn_1_N : N ;
  lantegendom_nn_1_N : N ;
  lantgaard_nn_1_1_N : N ;
  lanthushaallning_nn_1_1_N : N ;
  lapisering_nn_1_N : N ;
  lapplaenning_nn_1_1_N : N ;
  lappning_nn_1_N : N ;
  lappskrivning_nn_1_N : N ;
  larmfoerlaeggning_nn_1_1_N : N ;
  larmminering_nn_1_N : N ;
  lasering_nn_1_N : N ;
  laserstraalning_nn_1_1_N : N ;
  laskning_nn_1_N : N ;
  lassning_nn_1_N : N ;
  lastbil_nn_1_N : N ;
  lastbilskrock_nn_1_N : N ;
  lastkran_nn_1_N : N ;
  lastning_nn_1_N : N ;
  lastport_nn_1_N : N ;
  lastvagn_nn_1_N : N ;
  latexmaalning_nn_1_1_N : N ;
  latinisering_nn_1_N : N ;
  lavering_nn_1_N : N ;
  laxering_nn_1_N : N ;
  laxning_nn_1_N : N ;
  lcd_skaerm_nn_1_1_N : N ;
  ledarbegaavning_nn_1_1_N : N ;
  ledfoerslitning_nn_1_1_N : N ;
  ledgaang_nn_2_1_N : N ;
  ledning_nn_1_N : N ;
  ledtraad_nn_1_1_N : N ;
  legalisering_nn_1_N : N ;
  legering_nn_1_N : N ;
  legitimering_nn_1_N : N ;
  legobit_nn_1_N : N ;
  legotillverkning_nn_1_N : N ;
  lejning_nn_1_N : N ;
  lekboll_nn_1_N : N ;
  lekdamm_nn_1_N : N ;
  leksaksbil_nn_1_N : N ;
  leksaksbjoern_nn_1_1_N : N ;
  leksaksbaat_nn_1_1_N : N ;
  lekvandring_nn_1_N : N ;
  lemlaestning_nn_1_1_N : N ;
  lerklining_nn_1_N : N ;
  lervaegg_nn_1_1_N : N ;
  lervaelling_nn_1_1_N : N ;
  letning_nn_1_N : N ;
  leverering_nn_1_N : N ;
  leverskrumpning_nn_1_N : N ;
  levnadsbeskrivning_nn_1_N : N ;
  levnadsteckning_nn_1_N : N ;
  levnadsvisdom_nn_1_N : N ;
  liberalisering_nn_1_N : N ;
  licensering_nn_1_N : N ;
  licensiering_nn_1_N : N ;
  licentiering_nn_1_N : N ;
  liering_nn_1_N : N ;
  liggning_nn_1_N : N ;
  likbesiktning_nn_1_N : N ;
  likfoergiftning_nn_1_1_N : N ;
  likhoeg_nn_1_1_N : N ;
  liksiding_nn_1_N : N ;
  likskaendning_nn_1_1_N : N ;
  likspaenning_nn_1_1_N : N ;
  liksvepning_nn_1_N : N ;
  liktyding_nn_1_N : N ;
  likvagn_nn_1_N : N ;
  likvidering_nn_1_N : N ;
  limning_nn_1_N : N ;
  limpaastrykning_nn_1_1_N : N ;
  limring_nn_1_N : N ;
  limtillverkning_nn_1_N : N ;
  linbraakning_nn_1_1_N : N ;
  lindning_nn_1_N : N ;
  lindring_nn_1_N : N ;
  linearritning_nn_1_N : N ;
  linjeblockering_nn_1_N : N ;
  linjefoering_nn_1_1_N : N ;
  linjering_nn_1_N : N ;
  linneduk_nn_1_N : N ;
  linneklaenning_nn_1_1_N : N ;
  linning_nn_1_N : N ;
  lirkning_nn_1_N : N ;
  lissering_nn_1_N : N ;
  litografering_nn_1_N : N ;
  litteraturanvisning_nn_1_N : N ;
  litteraturfoerteckning_nn_1_1_N : N ;
  litteraturhaenvisning_nn_1_1_N : N ;
  litteratursoekning_nn_1_1_N : N ;
  livfoersaekring_nn_1_1_N : N ;
  livraeddning_nn_1_1_N : N ;
  livraeddningsbaat_nn_1_1_N : N ;
  livsfoering_nn_1_1_N : N ;
  livsgaerning_nn_1_1_N : N ;
  livshaallning_nn_1_1_N : N ;
  livslag_nn_1_N : N ;
  livsmedelsfoersoerjning_nn_1_1_N : N ;
  livsmedelslag_nn_1_N : N ;
  livsstil_nn_1_N : N ;
  livsstilsfoeraendring_nn_1_1_N : N ;
  livstidsdom_nn_1_N : N ;
  livstraad_nn_1_1_N : N ;
  livsutveckling_nn_1_N : N ;
  livsyttring_nn_1_N : N ;
  livsaaskaadning_nn_1_1_N : N ;
  ljuddaempning_nn_1_1_N : N ;
  ljudfoeraendring_nn_1_1_N : N ;
  ljudinspelning_nn_1_N : N ;
  ljudisolering_nn_1_N : N ;
  ljudlag_nn_1_N : N ;
  ljudskridning_nn_1_N : N ;
  ljudstoet_nn_1_1_N : N ;
  ljudupprepning_nn_1_N : N ;
  ljudupptagning_nn_1_N : N ;
  ljudvall_nn_1_N : N ;
  ljudaatergivning_nn_1_1_N : N ;
  ljudoeverfoering_nn_1_1_N : N ;
  ljungeld_nn_1_N : N ;
  ljusbehandling_nn_1_N : N ;
  ljusbrytning_nn_1_N : N ;
  ljusflaeck_nn_1_1_N : N ;
  ljushuggning_nn_1_N : N ;
  ljuskopiering_nn_1_N : N ;
  ljusning_nn_1_N : N ;
  ljusstraalning_nn_1_1_N : N ;
  ljussaettning_nn_1_1_N : N ;
  ljusutstraalning_nn_1_1_N : N ;
  lockning_nn_1_N : N ;
  lodning_nn_1_N : N ;
  loftgaang_nn_1_1_N : N ;
  logering_nn_1_N : N ;
  lojalitetsfoerklaring_nn_1_1_N : N ;
  lokalavdelning_nn_1_N : N ;
  lokalbedoevning_nn_1_1_N : N ;
  lokalbefolkning_nn_1_N : N ;
  lokalisering_nn_1_N : N ;
  lokalkaennedom_nn_1_1_N : N ;
  lokaltidning_nn_1_N : N ;
  loserstil_nn_1_N : N ;
  loservaerld_nn_1_1_N : N ;
  lossning_nn_1_N : N ;
  lotsbaat_nn_1_1_N : N ;
  lotsning_nn_1_N : N ;
  lottdragning_nn_1_N : N ;
  lotusstaellning_nn_1_1_N : N ;
  lovning_nn_1_N : N ;
  luftbevakning_nn_1_N : N ;
  luftboll_nn_1_N : N ;
  luftfjaedring_nn_1_1_N : N ;
  luftfoerorening_nn_1_1_N : N ;
  luftgevaersskjutning_nn_1_1_N : N ;
  luftkonditionering_nn_1_N : N ;
  luftledning_nn_1_N : N ;
  luftning_nn_1_N : N ;
  luftpump_nn_1_N : N ;
  luftrumsring_nn_1_N : N ;
  lufttrycksfoeraendring_nn_1_1_N : N ;
  luftvaeg_nn_1_1_N : N ;
  luftvaermepump_nn_1_1_N : N ;
  luftvaexling_nn_1_1_N : N ;
  lumbalbedoevning_nn_1_1_N : N ;
  lumpbod_nn_1_N : N ;
  lunchrusning_nn_1_N : N ;
  lungsjukdom_nn_1_N : N ;
  lurpassning_nn_1_N : N ;
  lushund_nn_1_N : N ;
  luteinisering_nn_1_N : N ;
  lutherdom_nn_1_N : N ;
  lutning_nn_1_N : N ;
  lyckoenskning_nn_1_1_N : N ;
  lyftanordning_nn_1_N : N ;
  lyftarm_nn_1_N : N ;
  lyftkrok_nn_1_N : N ;
  lyftning_nn_1_N : N ;
  lynchning_nn_1_N : N ;
  lynchstaemning_nn_1_1_N : N ;
  lysknapp_nn_1_N : N ;
  lysning_nn_1_N : N ;
  lysningsmottagning_nn_1_N : N ;
  lystring_nn_1_N : N ;
  lyxbil_nn_1_N : N ;
  lyxfoerpackning_nn_1_1_N : N ;
  lyxgaard_nn_1_1_N : N ;
  lyxkryssning_nn_1_N : N ;
  lyxpryl_nn_1_N : N ;
  lyxrenovering_nn_1_N : N ;
  lyxvaaning_nn_1_1_N : N ;
  laeckerbit_nn_1_1_N : N ;
  laedering_nn_1_1_N : N ;
  laegenhetsvisning_nn_1_1_N : N ;
  laegereld_nn_1_1_N : N ;
  laegesbestaemning_nn_1_1_N : N ;
  laegesfoeraendring_nn_1_1_N : N ;
  laegessummering_nn_1_1_N : N ;
  laeggning_nn_1_1_N : N ;
  laekarmottagning_nn_1_1_N : N ;
  laekarundersoekning_nn_1_1_N : N ;
  laekedom_nn_1_1_N : N ;
  laekemedelslag_nn_1_1_N : N ;
  laekning_nn_1_1_N : N ;
  laemning_nn_1_1_N : N ;
  laemplighetsrpoevning_nn_1_1_N : N ;
  laengdloepning_nn_1_1_N : N ;
  laengdmarkering_nn_1_1_N : N ;
  laengdriktning_nn_1_1_N : N ;
  laengdutvidgning_nn_1_1_N : N ;
  laengdaakning_nn_1_1_N : N ;
  laensbeteckning_nn_1_1_N : N ;
  laensning_nn_1_1_N : N ;
  laenspump_nn_1_1_N : N ;
  laenstol_nn_1_1_N : N ;
  laensvaeg_nn_1_1_N : N ;
  laeppavlaesning_nn_1_1_N : N ;
  laerarfortbildning_nn_1_1_N : N ;
  laerdom_nn_1_1_N : N ;
  laerftbindning_nn_1_1_N : N ;
  laerling_nn_1_1_N : N ;
  laerlingsutbildning_nn_1_1_N : N ;
  laerosal_nn_1_1_N : N ;
  laesbegaavning_nn_1_1_N : N ;
  laesesal_nn_1_1_N : N ;
  laesning_nn_1_1_N : N ;
  laespning_nn_1_1_N : N ;
  laesoevning_nn_1_1_N : N ;
  laexlaesning_nn_1_1_N : N ;
  laaghjuling_nn_1_1_N : N ;
  laagspaenning_nn_1_1_N : N ;
  laaneansoekning_nn_1_1_N : N ;
  laangboll_nn_1_1_N : N ;
  laangbaenk_nn_1_1_N : N ;
  laangdistansloepning_nn_1_1_N : N ;
  laanglotsning_nn_1_1_N : N ;
  laangsalning_nn_1_1_N : N ;
  laangtidsbehandling_nn_1_1_N : N ;
  laangtidsfoervaring_nn_1_1_N : N ;
  laangtidsparkering_nn_1_1_N : N ;
  laangvaegg_nn_1_1_N : N ;
  laaringsvind_nn_1_1_N : N ;
  laasanordning_nn_1_1_N : N ;
  laasning_nn_1_1_N : N ;
  laassaslek_nn_1_1_N : N ;
  laassasvaerld_nn_1_1_N : N ;
  laasskruv_nn_1_1_N : N ;
  laatsasbrottning_nn_1_1_N : N ;
  laatsaslek_nn_1_1_N : N ;
  laatsasvaerld_nn_1_1_N : N ;
  loedning_nn_1_1_N : N ;
  loegning_nn_1_1_N : N ;
  loeksill_nn_1_1_N : N ;
  loenebildning_nn_1_1_N : N ;
  loenedumpning_nn_1_1_N : N ;
  loenefoerhandling_nn_1_1_N : N ;
  loenefoerhoejning_nn_1_1_N : N ;
  loeneglidning_nn_1_1_N : N ;
  loenehoejning_nn_1_1_N : N ;
  loeneslav_nn_1_1_N : N ;
  loenesaettning_nn_1_1_N : N ;
  loeneutveckling_nn_1_1_N : N ;
  loeneoekning_nn_1_1_N : N ;
  loening_nn_1_1_N : N ;
  loennbraenning_nn_1_1_N : N ;
  loenngaang_nn_1_1_N : N ;
  loennkrog_nn_1_1_N : N ;
  loepeld_nn_1_1_N : N ;
  loepknut_nn_1_1_N : N ;
  loepning_nn_1_1_N : N ;
  loepring_nn_1_1_N : N ;
  loeptik_nn_1_1_N : N ;
  loerdag_nn_1_1_N : N ;
  loesegendom_nn_1_1_N : N ;
  loesning_nn_1_1_N : N ;
  loesslaeppning_nn_1_1_N : N ;
  loevblandskog_nn_1_1_N : N ;
  loevfaellning_nn_1_1_N : N ;
  loevhoeg_nn_1_1_N : N ;
  loevsal_nn_1_1_N : N ;
  loevskog_nn_1_1_N : N ;
  loevsprickning_nn_1_1_N : N ;
  loevsug_nn_1_1_N : N ;
  loevsaag_nn_1_1_N : N ;
  loevsaagning_nn_1_1_N : N ;
  loevaeng_nn_1_1_N : N ;
  madrassering_nn_1_N : N ;
  madrassnaal_nn_1_1_N : N ;
  magasinering_nn_1_N : N ;
  maggrop_nn_1_N : N ;
  magnesiumlegering_nn_1_N : N ;
  magnetisering_nn_1_N : N ;
  magnettaendning_nn_1_1_N : N ;
  magsjukdom_nn_1_N : N ;
  magsaeck_nn_1_1_N : N ;
  magoevning_nn_1_1_N : N ;
  mahognylaminatdoerr_nn_1_1_N : N ;
  majoritetsregering_nn_1_N : N ;
  maktfoerdelning_nn_1_1_N : N ;
  maktfoerskjutning_nn_1_1_N : N ;
  maktstaellning_nn_1_1_N : N ;
  makulering_nn_1_N : N ;
  malfobering_nn_1_N : N ;
  malmgaard_nn_1_1_N : N ;
  malning_nn_1_N : N ;
  maltraetering_nn_1_1_N : N ;
  mammaklaenning_nn_1_1_N : N ;
  manchesterhaengselkjol_nn_1_1_N : N ;
  mandatfoerdelning_nn_1_1_N : N ;
  mandom_nn_1_N : N ;
  manifestering_nn_1_N : N ;
  manikurering_nn_1_N : N ;
  manikyrering_nn_1_N : N ;
  maning_nn_1_N : N ;
  manipulering_nn_1_N : N ;
  mankering_nn_1_N : N ;
  manschettknapp_nn_1_N : N ;
  mansgrav_nn_1_N : N ;
  mantalsskrivning_nn_1_N : N ;
  mantelstyrning_nn_1_N : N ;
  manusgenomgaang_nn_1_1_N : N ;
  manoevrering_nn_1_1_N : N ;
  maratonfoerhandling_nn_1_1_N : N ;
  marginalanteckning_nn_1_N : N ;
  marginalbeskattning_nn_1_N : N ;
  marginaliseraing_nn_1_N : N ;
  marinering_nn_1_N : N ;
  marinledning_nn_1_N : N ;
  marinmaalning_nn_1_1_N : N ;
  markegaang_nn_1_1_N : N ;
  markering_nn_1_N : N ;
  marknadsfoering_nn_1_1_N : N ;
  marknadsundersoekning_nn_1_1_N : N ;
  marknadsvaerdering_nn_1_1_N : N ;
  markvaeg_nn_1_1_N : N ;
  marmorering_nn_1_N : N ;
  marmorhaell_nn_1_1_N : N ;
  marodering_nn_1_N : N ;
  marschdrill_nn_1_N : N ;
  marschering_nn_1_N : N ;
  marschriktning_nn_1_N : N ;
  martering_nn_1_N : N ;
  maskering_nn_1_N : N ;
  maskinskrivning_nn_1_N : N ;
  maskintvaett_nn_1_1_N : N ;
  maskinoeversaettning_nn_1_1_N : N ;
  maskning_nn_1_N : N ;
  maskulinisering_nn_1_N : N ;
  massagestol_nn_1_N : N ;
  massakerskytt_nn_1_N : N ;
  massakrering_nn_1_N : N ;
  massarrestering_nn_1_N : N ;
  massavraettning_nn_1_1_N : N ;
  massavskedning_nn_1_N : N ;
  massdoed_nn_1_1_N : N ;
  massering_nn_1_N : N ;
  massfattigdom_nn_1_N : N ;
  massgrav_nn_1_N : N ;
  masshaektning_nn_1_1_N : N ;
  massraettegaang_nn_1_1_N : N ;
  massuppsaegning_nn_1_1_N : N ;
  massvaccinering_nn_1_N : N ;
  masturbering_nn_1_N : N ;
  matarledning_nn_1_N : N ;
  matavfallskvarn_nn_1_N : N ;
  matchboll_nn_1_N : N ;
  matelassering_nn_1_N : N ;
  materialisering_nn_1_N : N ;
  materialsamling_nn_1_N : N ;
  materieforskning_nn_1_N : N ;
  matfoergiftning_nn_1_1_N : N ;
  mathaallning_nn_1_1_N : N ;
  matkorg_nn_1_N : N ;
  matlagning_nn_1_N : N ;
  matning_nn_1_N : N ;
  matsal_nn_1_N : N ;
  matservering_nn_2_N : N ;
  matsked_nn_1_N : N ;
  matsmaeltning_nn_1_1_N : N ;
  mattallrik_nn_1_N : N ;
  mattering_nn_1_N : N ;
  mattpiskning_nn_1_N : N ;
  mattpiskstaellning_nn_1_1_N : N ;
  maxikjol_nn_1_N : N ;
  maximering_nn_1_N : N ;
  mc_lyft_nn_1_N : N ;
  medaljering_nn_1_N : N ;
  medaljutdelning_nn_1_N : N ;
  medbestaemmandelag_nn_1_1_N : N ;
  medelklassfoerdom_nn_1_1_N : N ;
  medelsanvisning_nn_1_N : N ;
  medelskoerd_nn_1_1_N : N ;
  medelstorlek_nn_1_N : N ;
  medeltidsmaalning_nn_1_1_N : N ;
  medelvaeg_nn_1_1_N : N ;
  medgaang_nn_1_1_N : N ;
  medicinbluff_nn_1_N : N ;
  medicinboll_nn_1_N : N ;
  medicinering_nn_1_N : N ;
  mediebevakning_nn_1_N : N ;
  mediedamm_nn_1_N : N ;
  medisterkorv_nn_1_N : N ;
  meditering_nn_1_N : N ;
  medlemsfoerhandling_nn_1_1_N : N ;
  medling_nn_1_N : N ;
  medvind_nn_1_N : N ;
  mejerifoerening_nn_1_1_N : N ;
  mekanisering_nn_1_N : N ;
  mellandag_nn_1_N : N ;
  mellanlandning_nn_1_N : N ;
  mellanriksvaeg_nn_1_1_N : N ;
  mellanrumsfoerening_nn_1_1_N : N ;
  mellanvaeg_nn_1_1_N : N ;
  mellanvaegg_nn_1_1_N : N ;
  mellanvaaning_nn_1_1_N : N ;
  memorering_nn_1_N : N ;
  mening_nn_1_N : N ;
  meningsbrytning_nn_1_N : N ;
  meningsriktning_nn_1_N : N ;
  meningsyttring_nn_1_N : N ;
  menstruering_nn_1_N : N ;
  mentalsjukdom_nn_1_N : N ;
  mentalvaardsinraettning_nn_1_1_N : N ;
  mercerisering_nn_1_N : N ;
  meritering_nn_1_N : N ;
  meritfoerteckning_nn_1_1_N : N ;
  metallbit_nn_1_N : N ;
  metallfoergiftning_nn_1_1_N : N ;
  metallgjutning_nn_1_N : N ;
  metallisering_nn_1_N : N ;
  metallkorg_nn_1_N : N ;
  metallmugg_nn_1_N : N ;
  metallring_nn_1_N : N ;
  metallsaag_nn_1_1_N : N ;
  metalltraad_nn_1_1_N : N ;
  metkrok_nn_1_N : N ;
  metylering_nn_1_N : N ;
  microhatt_nn_1_N : N ;
  middag_nn_1_N : N ;
  middagsbjudning_nn_1_N : N ;
  middagsklaenning_nn_1_1_N : N ;
  midgetbil_nn_1_N : N ;
  migrantbaat_nn_1_1_N : N ;
  mikrofiberduk_nn_1_N : N ;
  mikrofotografering_nn_1_N : N ;
  mikrohatt_nn_1_N : N ;
  mikroskopering_nn_1_N : N ;
  mildring_nn_1_N : N ;
  militarisering_nn_1_N : N ;
  militaerdomstol_nn_1_1_N : N ;
  militaerfoerlaeggning_nn_1_1_N : N ;
  militaerfoervaltning_nn_1_1_N : N ;
  militaerpostering_nn_1_1_N : N ;
  militaertjaenstgoering_nn_1_1_N : N ;
  militaeroevning_nn_1_1_N : N ;
  miljardsatsning_nn_1_N : N ;
  miljoninvestering_nn_1_N : N ;
  miljoebil_nn_1_1_N : N ;
  miljoebilssatsning_nn_1_1_N : N ;
  miljoecertifiering_nn_1_1_N : N ;
  miljoefoerorening_nn_1_1_N : N ;
  miljoefoerstoering_nn_1_1_N : N ;
  miljoefoersaemring_nn_1_1_N : N ;
  miljoefoervaltning_nn_1_1_N : N ;
  miljoemaerkning_nn_1_1_N : N ;
  miljoeskildring_nn_1_1_N : N ;
  mineralgaang_nn_1_1_N : N ;
  mineralisering_nn_1_N : N ;
  mineralutvinning_nn_1_N : N ;
  minering_nn_1_N : N ;
  mingaang_nn_1_1_N : N ;
  miniatyrisering_nn_1_N : N ;
  miniatyrmaalning_nn_1_1_N : N ;
  minibil_nn_1_N : N ;
  miniersaettning_nn_1_1_N : N ;
  minikjol_nn_1_N : N ;
  minimering_nn_1_N : N ;
  minnesanteckning_nn_1_N : N ;
  minnesteckning_nn_1_N : N ;
  minnesvaard_nn_2_1_N : N ;
  minoritetsregering_nn_1_N : N ;
  minoritetsstaellning_nn_1_1_N : N ;
  minroejning_nn_1_1_N : N ;
  minskning_nn_1_N : N ;
  minspaerr_nn_1_1_N : N ;
  minsvepning_nn_1_N : N ;
  missaktning_nn_1_N : N ;
  missanpassning_nn_1_N : N ;
  missbedoemning_nn_1_1_N : N ;
  missbildning_nn_1_N : N ;
  missfaergning_nn_1_1_N : N ;
  missgaerning_nn_1_1_N : N ;
  missionering_nn_1_N : N ;
  missivering_nn_1_N : N ;
  misskreditering_nn_1_N : N ;
  missraekning_nn_1_1_N : N ;
  misstolkning_nn_1_N : N ;
  misstroendefoerklaring_nn_1_1_N : N ;
  misstydning_nn_1_N : N ;
  misstaemning_nn_1_1_N : N ;
  misstaenkliggoering_nn_1_1_N : N ;
  missuppfattning_nn_1_N : N ;
  missvisning_nn_1_N : N ;
  mistning_nn_1_N : N ;
  mittelgaang_nn_1_1_N : N ;
  mjukdelsbehandling_nn_1_N : N ;
  mjoelkflytning_nn_1_1_N : N ;
  mjoelkfoerpackning_nn_1_1_N : N ;
  mjoelkgrymtning_nn_1_1_N : N ;
  mjoelkgaang_nn_1_1_N : N ;
  mjoelkpall_nn_1_1_N : N ;
  mjoelkstockning_nn_1_1_N : N ;
  mobilisering_nn_1_N : N ;
  mobilraekning_nn_1_1_N : N ;
  modellberaekning_nn_1_1_N : N ;
  modellering_nn_1_N : N ;
  modelljaernvaeg_nn_1_1_N : N ;
  moderering_nn_1_N : N ;
  modernisering_nn_1_N : N ;
  modernaering_nn_1_1_N : N ;
  modetidning_nn_1_N : N ;
  modeuppvisning_nn_1_N : N ;
  modevisning_nn_1_N : N ;
  modifiering_nn_1_N : N ;
  modulering_nn_1_N : N ;
  modaernisering_nn_1_1_N : N ;
  molnbildning_nn_1_N : N ;
  molnhop_nn_1_N : N ;
  molntott_nn_1_N : N ;
  momsredovisning_nn_1_N : N ;
  monoftongering_nn_1_N : N ;
  monopolisering_nn_1_N : N ;
  monopolstaellning_nn_1_1_N : N ;
  monsunkantring_nn_1_N : N ;
  montagearm_nn_1_N : N ;
  montering_nn_1_N : N ;
  monteringsanvisning_nn_1_N : N ;
  monteringsskruv_nn_1_N : N ;
  morakniv_nn_1_N : N ;
  moralisering_nn_1_N : N ;
  morddom_nn_1_N : N ;
  mordraettegaang_nn_1_1_N : N ;
  mordstaempling_nn_1_1_N : N ;
  morgonavgaang_nn_1_1_N : N ;
  morgonsamling_nn_1_N : N ;
  morgontidning_nn_1_N : N ;
  morgonvind_nn_1_N : N ;
  moring_nn_1_N : N ;
  morrning_nn_1_N : N ;
  morsering_nn_1_N : N ;
  mortelstoet_nn_1_1_N : N ;
  mortificering_nn_1_N : N ;
  mortifiering_nn_1_N : N ;
  moraensluttning_nn_1_1_N : N ;
  motbevisning_nn_1_N : N ;
  motgaang_nn_1_1_N : N ;
  motionering_nn_1_N : N ;
  motionsanlaeggning_nn_1_1_N : N ;
  motionshall_nn_1_N : N ;
  motivering_nn_1_N : N ;
  motlaesning_nn_1_1_N : N ;
  motorbaat_nn_1_1_N : N ;
  motorcykelhjaelm_nn_1_1_N : N ;
  motorcykellyft_nn_1_N : N ;
  motorcykeltaevling_nn_1_1_N : N ;
  motorhuv_nn_1_N : N ;
  motorisering_nn_1_N : N ;
  motorlyft_nn_1_N : N ;
  motorsaag_nn_1_1_N : N ;
  motorvaeg_nn_1_1_N : N ;
  motstaemning_nn_1_1_N : N ;
  motstaandshaerd_nn_1_1_N : N ;
  motstaandssvetsning_nn_1_1_N : N ;
  motsaettning_nn_1_1_N : N ;
  mottagarsaeck_nn_1_1_N : N ;
  mottagning_nn_1_N : N ;
  motvind_nn_1_N : N ;
  moussering_nn_1_N : N ;
  muljering_nn_1_N : N ;
  mullvad_nn_1_N : N ;
  mullvadshoeg_nn_1_1_N : N ;
  mulning_nn_1_N : N ;
  multiplicering_nn_1_N : N ;
  mumifiering_nn_1_N : N ;
  mumsning_nn_1_N : N ;
  mun_mot_muninblaasning_nn_1_1_N : N ;
  mundering_nn_1_N : N ;
  munfull_nn_1_N : N ;
  munkorgslag_nn_1_N : N ;
  munkstol_nn_1_N : N ;
  munskaenk_nn_1_1_N : N ;
  muralmaalning_nn_1_1_N : N ;
  murstock_nn_1_N : N ;
  musarm_nn_1_N : N ;
  museifoerening_nn_1_1_N : N ;
  museisal_nn_1_N : N ;
  musicering_nn_1_N : N ;
  musikanlaeggning_nn_1_1_N : N ;
  musikstil_nn_1_N : N ;
  muskelbristning_nn_1_N : N ;
  muskelbaat_nn_1_1_N : N ;
  muskelfoerlamning_nn_1_1_N : N ;
  muskelfoertvining_nn_1_1_N : N ;
  muskelring_nn_1_N : N ;
  muskelryckning_nn_1_N : N ;
  muskelsammandragning_nn_1_N : N ;
  muskelspaenning_nn_1_1_N : N ;
  muskelstraeckning_nn_1_1_N : N ;
  muskeltraad_nn_1_1_N : N ;
  muslinsklaenning_nn_1_1_N : N ;
  musselodling_nn_1_N : N ;
  mussering_nn_1_N : N ;
  mutering_nn_1_N : N ;
  myggnaetsdoerr_nn_1_1_N : N ;
  myndighetsfoerklaring_nn_1_1_N : N ;
  mynning_nn_1_N : N ;
  myntsamling_nn_1_N : N ;
  myrkrypning_nn_1_N : N ;
  myrstig_nn_1_N : N ;
  mysning_nn_1_N : N ;
  mystifiering_nn_1_N : N ;
  mytbildning_nn_1_N : N ;
  mytifiering_nn_1_N : N ;
  mytspridning_nn_1_N : N ;
  maenniskokaennedom_nn_1_1_N : N ;
  maenniskokaerlek_nn_1_1_N : N ;
  maenniskoomflyttning_nn_1_1_N : N ;
  maenniskoskildring_nn_1_1_N : N ;
  maenniskouppfattning_nn_1_1_N : N ;
  maerkesdag_nn_1_1_N : N ;
  maerkning_nn_1_1_N : N ;
  maerling_nn_1_1_N : N ;
  maerlspik_nn_1_1_N : N ;
  maeskning_nn_1_1_N : N ;
  maesshall_nn_1_1_N : N ;
  maessingsknapp_nn_1_1_N : N ;
  maessingstraad_nn_1_1_N : N ;
  maetning_nn_1_1_N : N ;
  maettning_nn_1_1_N : N ;
  maalangivning_nn_1_1_N : N ;
  maalarkniv_nn_1_1_N : N ;
  maalarstaellning_nn_1_1_N : N ;
  maalforskning_nn_1_1_N : N ;
  maalgaang_nn_1_1_N : N ;
  maalkung_nn_1_1_N : N ;
  maalning_nn_1_1_N : N ;
  maalskjutning_nn_1_1_N : N ;
  maalspaning_nn_1_1_N : N ;
  maalstyrning_nn_1_1_N : N ;
  maalstaellning_nn_1_1_N : N ;
  maalsaettning_nn_1_1_N : N ;
  maanadspeng_nn_1_1_N : N ;
  maanadspenning_nn_1_1_N : N ;
  maanbaevning_nn_1_1_N : N ;
  maandag_nn_1_1_N : N ;
  maanghoerning_nn_1_1_N : N ;
  maangmiljoninvestering_nn_1_1_N : N ;
  maangsiding_nn_1_1_N : N ;
  maanlandning_nn_1_1_N : N ;
  maasflock_nn_1_1_N : N ;
  maattagning_nn_1_1_N : N ;
  maattstock_nn_1_1_N : N ;
  moebelflyttning_nn_1_1_N : N ;
  moebelfoersaeljning_nn_1_1_N : N ;
  moebelstil_nn_1_1_N : N ;
  moeblering_nn_1_1_N : N ;
  moedom_nn_1_1_N : N ;
  moegelhund_nn_1_1_N : N ;
  moegeltraad_nn_1_1_N : N ;
  moenstring_nn_1_1_N : N ;
  moerbultning_nn_1_1_N : N ;
  moerdeg_nn_1_1_N : N ;
  moerkerkoerning_nn_1_1_N : N ;
  moerklaeggning_nn_1_1_N : N ;
  moerkning_nn_2_1_N : N ;
  moesskaerm_nn_1_1_N : N ;
  nackbjudning_nn_1_N : N ;
  nackknut_nn_1_N : N ;
  nafsning_nn_1_N : N ;
  nagelbitning_nn_1_N : N ;
  nagelfil_nn_1_N : N ;
  nagelklippning_nn_1_N : N ;
  naggning_nn_1_N : N ;
  najoegonstropp_nn_1_1_N : N ;
  nakenblankning_nn_1_N : N ;
  namnberedning_nn_1_N : N ;
  namnfoerklaring_nn_1_1_N : N ;
  namnfoeraendring_nn_1_1_N : N ;
  namngivning_nn_1_N : N ;
  namninsamling_nn_1_N : N ;
  namnlag_nn_1_N : N ;
  namnskylt_nn_1_N : N ;
  namnteckning_nn_1_N : N ;
  nanotraad_nn_1_1_N : N ;
  narkotikafoersaeljning_nn_1_1_N : N ;
  narkotikahund_nn_1_N : N ;
  narkotikautredning_nn_1_N : N ;
  narkotikautskrivning_nn_1_N : N ;
  narval_nn_1_N : N ;
  nasalering_nn_1_N : N ;
  nasalisering_nn_1_N : N ;
  nationalfoerening_nn_1_1_N : N ;
  nationalfoersamling_nn_1_1_N : N ;
  nationalisering_nn_1_N : N ;
  nationalitetsbeteckning_nn_1_N : N ;
  nationalitetshandling_nn_1_N : N ;
  nattkorv_nn_1_N : N ;
  nattmangling_nn_1_N : N ;
  nattorientering_nn_1_N : N ;
  nattrock_nn_1_N : N ;
  nattstaellning_nn_1_1_N : N ;
  nattvardsgaang_nn_1_1_N : N ;
  nattvardsundervisning_nn_1_N : N ;
  naturahushaallning_nn_1_1_N : N ;
  naturalisering_nn_1_N : N ;
  naturbegaavning_nn_1_1_N : N ;
  naturbesjaelning_nn_1_1_N : N ;
  naturlag_nn_1_N : N ;
  naturrikedom_nn_1_N : N ;
  naturskildring_nn_1_N : N ;
  naturskog_nn_1_N : N ;
  naturstig_nn_1_N : N ;
  naturtillgaang_nn_1_1_N : N ;
  navelskaadning_nn_1_1_N : N ;
  navelstraeng_nn_1_1_N : N ;
  navigationsvarning_nn_1_N : N ;
  navigering_nn_1_N : N ;
  nedblodning_nn_1_N : N ;
  nedbrytning_nn_1_N : N ;
  nedbraenning_nn_1_1_N : N ;
  nedbusning_nn_1_N : N ;
  nedbaeddning_nn_1_1_N : N ;
  neddragning_nn_1_N : N ;
  nederlagsstaemning_nn_1_1_N : N ;
  nedflyttning_nn_1_N : N ;
  nedfrysning_nn_1_N : N ;
  nedgraevning_nn_1_1_N : N ;
  nedgaang_nn_1_1_N : N ;
  nedhuggning_nn_1_N : N ;
  nedkastning_nn_1_N : N ;
  nedladdning_nn_1_N : N ;
  nedlaeggning_nn_1_1_N : N ;
  nedmejning_nn_1_N : N ;
  nedrustning_nn_1_N : N ;
  nedraekning_nn_1_1_N : N ;
  nedsaltning_nn_1_N : N ;
  nedskjutning_nn_1_N : N ;
  nedskrivning_nn_1_N : N ;
  nedskaerning_nn_1_1_N : N ;
  nedslaktning_nn_1_N : N ;
  nedslaeckning_nn_1_1_N : N ;
  nedsmutsning_nn_1_N : N ;
  nedstigning_nn_1_N : N ;
  nedstrykning_nn_1_N : N ;
  nedsvaertning_nn_1_1_N : N ;
  nedsaenkning_nn_1_1_N : N ;
  nedsaettning_nn_1_1_N : N ;
  nedsoelning_nn_1_1_N : N ;
  nedtagning_nn_1_N : N ;
  nedtoning_nn_1_N : N ;
  nedtransformering_nn_1_N : N ;
  nedtransponering_nn_1_N : N ;
  nedtrappning_nn_1_N : N ;
  nedtryckning_nn_1_N : N ;
  nedvaerdering_nn_1_1_N : N ;
  negerboll_nn_1_N : N ;
  negering_nn_1_N : N ;
  negligering_nn_1_N : N ;
  negociering_nn_1_N : N ;
  negotiering_nn_1_N : N ;
  neonskylt_nn_1_N : N ;
  nerblodning_nn_1_N : N ;
  nerbrytning_nn_1_N : N ;
  nerbraenning_nn_1_1_N : N ;
  nerbusning_nn_1_N : N ;
  nerbaeddning_nn_1_1_N : N ;
  nerdragning_nn_1_N : N ;
  nerfrysning_nn_1_N : N ;
  nergraevning_nn_1_1_N : N ;
  nergaang_nn_1_1_N : N ;
  nerhuggning_nn_1_N : N ;
  nerkastning_nn_1_N : N ;
  nerkvark_nn_1_N : N ;
  nerladdning_nn_1_N : N ;
  nerlaeggning_nn_1_1_N : N ;
  nermejning_nn_1_N : N ;
  nerrustning_nn_1_N : N ;
  nerraekning_nn_1_1_N : N ;
  nersaltning_nn_1_N : N ;
  nerskjutning_nn_1_N : N ;
  nerskaerning_nn_1_1_N : N ;
  nerslaktning_nn_1_N : N ;
  nersmutsning_nn_1_N : N ;
  nerstigning_nn_1_N : N ;
  nerstrykning_nn_1_N : N ;
  nersvaertning_nn_1_1_N : N ;
  nersaenkning_nn_1_1_N : N ;
  nersaettning_nn_1_1_N : N ;
  nersoelning_nn_1_1_N : N ;
  nertagning_nn_1_N : N ;
  nertoning_nn_1_N : N ;
  nertransformering_nn_1_N : N ;
  nertransponering_nn_1_N : N ;
  nertrappning_nn_1_N : N ;
  nertryckning_nn_1_N : N ;
  nervkittling_nn_1_N : N ;
  nervknut_nn_1_N : N ;
  nervretning_nn_1_N : N ;
  nervryckning_nn_1_N : N ;
  nervsjukdom_nn_1_N : N ;
  nervtraad_nn_1_1_N : N ;
  nervaerdering_nn_1_1_N : N ;
  nettobehaallning_nn_1_1_N : N ;
  neutralisering_nn_1_N : N ;
  neutralitetsfoerklaring_nn_1_1_N : N ;
  neutrinofoertaetning_nn_1_1_N : N ;
  neutronstraalning_nn_1_1_N : N ;
  nickning_nn_1_N : N ;
  nickpump_nn_1_N : N ;
  niellering_nn_1_N : N ;
  nigning_nn_1_N : N ;
  nioaaring_nn_1_1_N : N ;
  nitrering_nn_1_N : N ;
  nitrofoerening_nn_1_1_N : N ;
  nittonaaring_nn_1_1_N : N ;
  nivellering_nn_1_N : N ;
  nivaagruppering_nn_1_1_N : N ;
  njutning_nn_1_N : N ;
  nobilisering_nn_1_N : N ;
  nolledning_nn_1_N : N ;
  nollning_nn_1_N : N ;
  nollspaenning_nn_1_1_N : N ;
  nolltaxering_nn_1_N : N ;
  nomadisering_nn_1_N : N ;
  nominering_nn_1_N : N ;
  nonchalering_nn_1_N : N ;
  nordanvind_nn_1_N : N ;
  nordsluttning_nn_1_N : N ;
  normalfoerdelning_nn_1_1_N : N ;
  normalgaard_nn_1_1_N : N ;
  normalisering_nn_1_N : N ;
  normering_nn_1_N : N ;
  normupploesning_nn_1_1_N : N ;
  norrbottning_nn_1_N : N ;
  norrlandsaelv_nn_1_1_N : N ;
  norrlaenning_nn_1_1_N : N ;
  noshoerning_nn_1_1_N : N ;
  noshoerningskalv_nn_1_1_N : N ;
  nosring_nn_1_N : N ;
  notariatavdelning_nn_1_N : N ;
  notdragning_nn_1_N : N ;
  notering_nn_1_N : N ;
  notificering_nn_1_N : N ;
  notifiering_nn_1_N : N ;
  notisering_nn_1_N : N ;
  notvaexling_nn_1_1_N : N ;
  novellpristaevling_nn_1_1_N : N ;
  novellsamling_nn_1_N : N ;
  nummerkarl_nn_1_N : N ;
  nummerlapp_nn_1_N : N ;
  nummerskylt_nn_1_N : N ;
  nummerskyltsbelysning_nn_1_N : N ;
  numrering_nn_1_N : N ;
  nuppning_nn_1_N : N ;
  nutidsorientering_nn_1_N : N ;
  nutidsskildring_nn_1_N : N ;
  nyanlaeggning_nn_1_1_N : N ;
  nyansering_nn_1_N : N ;
  nyanskaffning_nn_1_N : N ;
  nyanstaellning_nn_1_1_N : N ;
  nybearbetning_nn_1_N : N ;
  nybildning_nn_1_N : N ;
  nyckelretning_nn_1_N : N ;
  nydaning_nn_1_N : N ;
  nyemittering_nn_1_N : N ;
  nyeroevring_nn_1_1_N : N ;
  nyetablering_nn_1_N : N ;
  nyhetisering_nn_1_N : N ;
  nyhetsbevakning_nn_1_N : N ;
  nyhetsfoermedling_nn_1_1_N : N ;
  nyhetsvaerdering_nn_1_1_N : N ;
  nyintagning_nn_1_N : N ;
  nyinvestering_nn_1_N : N ;
  nykomling_nn_1_N : N ;
  nykterhetsfoerening_nn_1_1_N : N ;
  nylonstraeng_nn_1_1_N : N ;
  nylaenning_nn_1_1_N : N ;
  nylaesning_nn_1_1_N : N ;
  nyodling_nn_1_N : N ;
  nyordning_nn_1_N : N ;
  nyorientering_nn_1_N : N ;
  nyplantering_nn_1_N : N ;
  nypning_nn_1_N : N ;
  nyrekrytering_nn_1_N : N ;
  nysning_nn_1_N : N ;
  nystavning_nn_1_N : N ;
  nystning_nn_1_N : N ;
  nytolkning_nn_1_N : N ;
  nytaendning_nn_1_1_N : N ;
  nyuppsaettning_nn_1_1_N : N ;
  nyzeelaenning_nn_1_1_N : N ;
  nyaarsdag_nn_1_1_N : N ;
  naering_nn_1_1_N : N ;
  naeringslivstopp_nn_1_1_N : N ;
  naeringsloesning_nn_1_1_N : N ;
  naerspaning_nn_1_1_N : N ;
  naesandning_nn_1_1_N : N ;
  naesgaang_nn_1_1_N : N ;
  naesring_nn_1_1_N : N ;
  naetbevakning_nn_1_1_N : N ;
  naetbluff_nn_1_1_N : N ;
  naetbokning_nn_1_1_N : N ;
  naetboll_nn_1_1_N : N ;
  naetdoerr_nn_1_1_N : N ;
  naetspaenning_nn_1_1_N : N ;
  naettidning_nn_1_1_N : N ;
  naettopp_nn_1_1_N : N ;
  naeverkorg_nn_1_1_N : N ;
  naeverlur_nn_1_1_N : N ;
  naadastoet_nn_1_1_N : N ;
  naadeansoekning_nn_1_1_N : N ;
  naadning_nn_1_1_N : N ;
  naalfil_nn_1_1_N : N ;
  noedfallsutvaeg_nn_1_1_N : N ;
  noedlandning_nn_1_1_N : N ;
  noedloesning_nn_1_1_N : N ;
  noedsignalering_nn_1_1_N : N ;
  noedutgaang_nn_1_1_N : N ;
  noejdfoerklaring_nn_1_1_N : N ;
  noejesbaat_nn_1_1_N : N ;
  noejeskoerning_nn_1_1_N : N ;
  noetning_nn_1_1_N : N ;
  obducering_nn_1_N : N ;
  obildning_nn_1_N : N ;
  objektivering_nn_1_N : N ;
  obligering_nn_1_N : N ;
  observering_nn_1_N : N ;
  obstruering_nn_1_N : N ;
  occidentalisering_nn_1_N : N ;
  ockupering_nn_1_N : N ;
  odling_nn_1_N : N ;
  offerering_nn_1_N : N ;
  offerstock_nn_1_N : N ;
  officiering_nn_1_N : N ;
  ograesbekaempning_nn_1_1_N : N ;
  ogaerning_nn_1_1_N : N ;
  oktavering_nn_1_N : N ;
  oktrojering_nn_1_N : N ;
  okulering_nn_1_N : N ;
  oljebekaempning_nn_1_1_N : N ;
  oljeborrning_nn_1_N : N ;
  oljeeldning_nn_1_N : N ;
  oljeinpackning_nn_1_N : N ;
  oljeledning_nn_1_N : N ;
  oljemaalning_nn_1_1_N : N ;
  oljerigg_nn_1_N : N ;
  oljering_nn_1_N : N ;
  oljesanering_nn_1_N : N ;
  oljeutvinning_nn_1_N : N ;
  ollning_nn_1_N : N ;
  ollonskog_nn_1_N : N ;
  olycksfallsfoersaekring_nn_1_1_N : N ;
  olyckskorp_nn_1_N : N ;
  omarbetning_nn_1_N : N ;
  ombesoerjning_nn_1_1_N : N ;
  ombildning_nn_1_N : N ;
  omblandning_nn_1_N : N ;
  ombordlaeggning_nn_1_1_N : N ;
  ombrytning_nn_1_N : N ;
  omdaning_nn_1_N : N ;
  omdirigering_nn_1_N : N ;
  omfamning_nn_1_N : N ;
  omfattning_nn_1_N : N ;
  omflyttning_nn_1_N : N ;
  omformning_nn_1_N : N ;
  omfoerdelning_nn_1_1_N : N ;
  omfoermaelning_nn_1_1_N : N ;
  omgestaltning_nn_1_N : N ;
  omgivning_nn_1_N : N ;
  omgjutning_nn_1_N : N ;
  omgruppering_nn_1_N : N ;
  omgaerdning_nn_1_1_N : N ;
  omgaang_nn_1_1_N : N ;
  omhuldning_nn_1_N : N ;
  omkalfatring_nn_1_N : N ;
  omkastning_nn_1_N : N ;
  omklaedning_nn_1_1_N : N ;
  omkostymering_nn_1_N : N ;
  omkoerning_nn_1_1_N : N ;
  omladdning_nn_1_N : N ;
  omlaeggning_nn_1_1_N : N ;
  ommaalning_nn_1_1_N : N ;
  ommoeblering_nn_1_1_N : N ;
  omorganisering_nn_1_N : N ;
  omplacering_nn_1_N : N ;
  omplantering_nn_1_N : N ;
  omproevning_nn_1_1_N : N ;
  omramning_nn_1_N : N ;
  omredigering_nn_1_N : N ;
  omreglering_nn_1_N : N ;
  omringning_nn_1_N : N ;
  omraekning_nn_1_1_N : N ;
  omroering_nn_1_1_N : N ;
  omroerning_nn_1_1_N : N ;
  omroestning_nn_1_1_N : N ;
  omsegling_nn_1_N : N ;
  omskolning_nn_1_N : N ;
  omskrivning_nn_1_N : N ;
  omskulpturering_nn_1_N : N ;
  omslutning_nn_1_N : N ;
  omspinning_nn_1_N : N ;
  omspaenning_nn_1_1_N : N ;
  omstigning_nn_1_N : N ;
  omstrukturering_nn_1_N : N ;
  omstaellning_nn_1_1_N : N ;
  omstoepning_nn_1_1_N : N ;
  omsvaengning_nn_1_1_N : N ;
  omsaettning_nn_1_1_N : N ;
  omsaettningstillgaang_nn_1_1_N : N ;
  omtagning_nn_1_N : N ;
  omtolkning_nn_1_N : N ;
  omtuggning_nn_1_N : N ;
  omvandling_nn_1_N : N ;
  omvaeg_nn_1_1_N : N ;
  omvaeljning_nn_1_1_N : N ;
  omvaelvning_nn_1_1_N : N ;
  omvaendning_nn_1_1_N : N ;
  omvaerdering_nn_1_1_N : N ;
  omvaerld_nn_1_1_N : N ;
  omvaexling_nn_1_1_N : N ;
  omyndigfoerklaring_nn_1_1_N : N ;
  omyndighetsfoerklaring_nn_1_1_N : N ;
  onanering_nn_1_N : N ;
  onanisering_nn_1_N : N ;
  ondulering_nn_1_N : N ;
  onsdag_nn_1_N : N ;
  oordning_nn_1_N : N ;
  operationalisering_nn_1_N : N ;
  operationsring_nn_1_N : N ;
  operationssal_nn_1_N : N ;
  operering_nn_1_N : N ;
  opinering_nn_1_N : N ;
  opinionsbildning_nn_1_N : N ;
  opinionsmaetning_nn_1_1_N : N ;
  opinionssvaengning_nn_1_1_N : N ;
  opinionsundersoekning_nn_1_1_N : N ;
  opinionsyttring_nn_1_N : N ;
  opparbetning_nn_1_N : N ;
  oppassning_nn_1_N : N ;
  oppbackning_nn_1_N : N ;
  oppbindning_nn_1_N : N ;
  oppblaasning_nn_1_1_N : N ;
  oppdatering_nn_1_N : N ;
  oppdelning_nn_1_N : N ;
  oppdukning_nn_1_N : N ;
  oppfattning_nn_1_N : N ;
  oppfinning_nn_1_N : N ;
  oppfostring_nn_1_N : N ;
  oppfoedning_nn_1_1_N : N ;
  oppfoeljning_nn_1_1_N : N ;
  oppgaang_nn_1_1_N : N ;
  opphetsning_nn_1_N : N ;
  opphettning_nn_1_N : N ;
  opphostning_nn_1_N : N ;
  opphottning_nn_1_N : N ;
  opphaemtning_nn_1_1_N : N ;
  opphaengning_nn_1_1_N : N ;
  opphoejning_nn_1_1_N : N ;
  oppjustering_nn_1_N : N ;
  oppkastning_nn_1_N : N ;
  oppkoerning_nn_1_1_N : N ;
  oppkoersvaeg_nn_1_1_N : N ;
  oppladdning_nn_1_N : N ;
  opplaeggning_nn_1_1_N : N ;
  opponering_nn_1_N : N ;
  oppraekning_nn_1_1_N : N ;
  oppskjutning_nn_1_N : N ;
  oppskrivning_nn_1_N : N ;
  oppstaellning_nn_1_1_N : N ;
  oppstoetning_nn_1_1_N : N ;
  oppsugning_nn_1_N : N ;
  oppsummering_nn_1_N : N ;
  opptagning_nn_1_N : N ;
  oppvaktning_nn_1_N : N ;
  oppvisning_nn_1_N : N ;
  oppvaegning_nn_1_1_N : N ;
  oppvaerdering_nn_1_1_N : N ;
  optering_nn_1_N : N ;
  optimering_nn_1_N : N ;
  ordbehandling_nn_1_N : N ;
  ordbildning_nn_1_N : N ;
  ordboejning_nn_1_1_N : N ;
  orderstock_nn_1_N : N ;
  ordfogning_nn_1_N : N ;
  ordfoerklaring_nn_1_1_N : N ;
  ordinering_nn_1_N : N ;
  ordklassindelning_nn_1_N : N ;
  ordning_nn_1_N : N ;
  ordrikedom_nn_1_N : N ;
  ordvaendning_nn_1_1_N : N ;
  ordvaexling_nn_1_1_N : N ;
  orering_nn_1_N : N ;
  organisering_nn_1_N : N ;
  orientering_nn_1_N : N ;
  orienteringstaevling_nn_1_1_N : N ;
  orkesterfoerening_nn_1_1_N : N ;
  orkestrering_nn_1_N : N ;
  ormknut_nn_1_N : N ;
  ormoern_nn_1_1_N : N ;
  ornamentering_nn_1_N : N ;
  ornering_nn_1_N : N ;
  ortnamnsforskning_nn_1_N : N ;
  osanning_nn_1_N : N ;
  oscillering_nn_1_N : N ;
  ostframstaellning_nn_1_1_N : N ;
  ostkrok_nn_1_N : N ;
  ostronfoergiftning_nn_1_1_N : N ;
  ostronkniv_nn_1_N : N ;
  osynliggoering_nn_1_1_N : N ;
  ovalsvarvning_nn_1_N : N ;
  ovanvaaning_nn_1_1_N : N ;
  oxidering_nn_1_N : N ;
  oxstek_nn_1_N : N ;
  oxvandring_nn_1_N : N ;
  ozonminskning_nn_1_N : N ;
  pacificering_nn_1_N : N ;
  packkorg_nn_1_N : N ;
  packning_nn_1_N : N ;
  paginering_nn_1_N : N ;
  pajdeg_nn_1_N : N ;
  pajkastning_nn_1_N : N ;
  paketering_nn_1_N : N ;
  paketinlaemning_nn_1_1_N : N ;
  paketloesning_nn_1_1_N : N ;
  paketutlaemning_nn_1_1_N : N ;
  palatalisering_nn_1_N : N ;
  palatsmur_nn_1_N : N ;
  palettkniv_nn_1_N : N ;
  paljettering_nn_1_N : N ;
  paljettklaenning_nn_1_1_N : N ;
  palpering_nn_1_N : N ;
  paltrockkvarn_nn_1_N : N ;
  panamahatt_nn_1_N : N ;
  panaschering_nn_1_N : N ;
  panering_nn_1_N : N ;
  panorering_nn_1_N : N ;
  pansarbaat_nn_1_1_N : N ;
  pansarplaat_nn_1_1_N : N ;
  pantburk_nn_1_N : N ;
  pantning_nn_1_N : N ;
  pantografering_nn_1_N : N ;
  pappburk_nn_1_N : N ;
  pappersbit_nn_1_N : N ;
  pappersbunt_nn_1_N : N ;
  pappersinsamling_nn_1_N : N ;
  papperskniv_nn_1_N : N ;
  papperslapp_nn_1_N : N ;
  pappersmugg_nn_1_N : N ;
  papperssaeck_nn_1_1_N : N ;
  papperstallrik_nn_1_N : N ;
  papperstidning_nn_1_N : N ;
  papperstillverkning_nn_1_N : N ;
  pappskylt_nn_1_N : N ;
  papptallrik_nn_1_N : N ;
  paprikaring_nn_1_N : N ;
  paradering_nn_1_N : N ;
  paradmaalning_nn_1_1_N : N ;
  paraduppstaellning_nn_1_1_N : N ;
  parafering_nn_1_N : N ;
  paraffinering_nn_1_N : N ;
  parafrasering_nn_1_N : N ;
  parallellisering_nn_1_N : N ;
  parallellkoppling_nn_1_N : N ;
  parallellvaerld_nn_1_1_N : N ;
  paralysering_nn_1_N : N ;
  parasitering_nn_1_N : N ;
  parentering_nn_1_N : N ;
  parering_nn_1_N : N ;
  parfymering_nn_1_N : N ;
  parkering_nn_1_N : N ;
  parkettering_nn_1_N : N ;
  parlamentering_nn_1_N : N ;
  parlering_nn_1_N : N ;
  parning_nn_1_N : N ;
  parodiering_nn_1_N : N ;
  partibildning_nn_1_N : N ;
  partikelstraalning_nn_1_1_N : N ;
  partiledarutfraagning_nn_1_1_N : N ;
  partiledning_nn_1_N : N ;
  partispraengning_nn_1_1_N : N ;
  partispaerr_nn_1_1_N : N ;
  partisympatimaetning_nn_1_1_N : N ;
  partitopp_nn_1_N : N ;
  paraakning_nn_1_1_N : N ;
  passadvind_nn_1_N : N ;
  passagerarbaat_nn_1_1_N : N ;
  passagerarstol_nn_1_N : N ;
  passering_nn_1_N : N ;
  passivering_nn_1_N : N ;
  passivisering_nn_1_N : N ;
  passning_nn_1_N : N ;
  pastellmaalning_nn_1_1_N : N ;
  pastoerisering_nn_1_1_N : N ;
  patentering_nn_1_N : N ;
  patinering_nn_1_N : N ;
  patrullbil_nn_1_N : N ;
  patrullbaat_nn_1_1_N : N ;
  patrullering_nn_1_N : N ;
  pauperisering_nn_1_N : N ;
  pausering_nn_1_N : N ;
  pauskommatering_nn_1_N : N ;
  pejling_nn_1_N : N ;
  pekning_nn_1_N : N ;
  pekskaerm_nn_1_1_N : N ;
  pelargaang_nn_1_1_N : N ;
  pelarhall_nn_1_N : N ;
  pelarsal_nn_1_N : N ;
  pelletering_nn_1_N : N ;
  pendeltaagsavgaang_nn_1_1_N : N ;
  penetrering_nn_1_N : N ;
  penisring_nn_1_N : N ;
  penninghushaallning_nn_1_1_N : N ;
  penninginsamling_nn_1_N : N ;
  penningpung_nn_1_N : N ;
  penningtilldelning_nn_1_N : N ;
  pennteckning_nn_1_N : N ;
  penselfoering_nn_1_1_N : N ;
  pensionering_nn_1_N : N ;
  pensioneringsdag_nn_1_N : N ;
  pensionsfoersaekring_nn_1_1_N : N ;
  pensionsinbetalning_nn_1_N : N ;
  pensling_nn_1_N : N ;
  pepparkaksdeg_nn_1_N : N ;
  pepparkvarn_nn_1_N : N ;
  perceptionsstoerning_nn_1_1_N : N ;
  percipiering_nn_1_N : N ;
  perennering_nn_1_N : N ;
  perforering_nn_1_N : N ;
  pergamentbit_nn_1_N : N ;
  periodindelning_nn_1_N : N ;
  periodisering_nn_1_N : N ;
  permanentondulering_nn_1_N : N ;
  permittering_nn_1_N : N ;
  permutering_nn_1_N : N ;
  persiflering_nn_1_N : N ;
  personalavdelning_nn_1_N : N ;
  personalingaang_nn_1_1_N : N ;
  personalmatsal_nn_1_N : N ;
  personaltidning_nn_1_N : N ;
  personalutbildning_nn_1_N : N ;
  personbeskrivning_nn_1_N : N ;
  personbil_nn_1_N : N ;
  personfoersaekring_nn_1_1_N : N ;
  personifiering_nn_1_N : N ;
  personkryssning_nn_1_N : N ;
  personlighetsklyvning_nn_1_N : N ;
  personlighetsstoerning_nn_1_1_N : N ;
  personsammansaettning_nn_1_1_N : N ;
  personundersoekning_nn_1_1_N : N ;
  personvaag_nn_1_1_N : N ;
  perspektivfoerflyttning_nn_1_1_N : N ;
  perspektivfoerskjutning_nn_1_1_N : N ;
  persvadering_nn_1_N : N ;
  perukstock_nn_1_N : N ;
  pervertering_nn_1_N : N ;
  peterspenning_nn_1_N : N ;
  petning_nn_1_N : N ;
  petrifiering_nn_1_N : N ;
  pianospelning_nn_1_N : N ;
  pianostol_nn_1_N : N ;
  pigmentering_nn_1_N : N ;
  pikering_nn_1_N : N ;
  piketbil_nn_1_N : N ;
  pilkastning_nn_1_N : N ;
  pillerburk_nn_1_N : N ;
  pilotundersoekning_nn_1_1_N : N ;
  pilsnerkorv_nn_1_N : N ;
  pincering_nn_1_N : N ;
  ping_pongboll_nn_1_N : N ;
  pingpongboll_nn_1_N : N ;
  pinkning_nn_1_N : N ;
  pinnstol_nn_1_N : N ;
  piruettering_nn_1_N : N ;
  piskning_nn_1_N : N ;
  piskstaellning_nn_1_1_N : N ;
  pitepalt_nn_1_N : N ;
  pivotering_nn_1_N : N ;
  pizzabit_nn_1_N : N ;
  pjatthatt_nn_1_N : N ;
  placering_nn_1_N : N ;
  pladderblogg_nn_1_N : N ;
  plagiering_nn_1_N : N ;
  planering_nn_1_N : N ;
  planetbildning_nn_1_N : N ;
  planhushaallning_nn_1_1_N : N ;
  plankgaang_nn_1_1_N : N ;
  plankorsning_nn_1_N : N ;
  plankstek_nn_1_N : N ;
  planlaeggning_nn_1_1_N : N ;
  planloesning_nn_1_1_N : N ;
  planmaetning_nn_1_1_N : N ;
  planritning_nn_1_N : N ;
  plantering_nn_1_N : N ;
  plaskdamm_nn_1_N : N ;
  plaskning_nn_1_N : N ;
  plastback_nn_1_N : N ;
  plastdunk_nn_1_N : N ;
  plastkork_nn_1_N : N ;
  plastlur_nn_1_N : N ;
  plastpil_nn_1_N : N ;
  plastpryl_nn_1_N : N ;
  plastring_nn_1_N : N ;
  plastsked_nn_1_N : N ;
  plastsaeck_nn_1_1_N : N ;
  platinering_nn_1_N : N ;
  platsansoekning_nn_1_1_N : N ;
  plattfil_nn_1_N : N ;
  plattform_nn_1_N : N ;
  plattfoting_nn_1_N : N ;
  plattlaeggning_nn_1_1_N : N ;
  pliggning_nn_1_N : N ;
  pliktfaellning_nn_1_1_N : N ;
  plissering_nn_1_N : N ;
  plockning_nn_1_N : N ;
  plombering_nn_1_N : N ;
  pluggning_nn_1_N : N ;
  plumpning_nn_1_N : N ;
  plundring_nn_1_N : N ;
  plaedering_nn_1_1_N : N ;
  plaetering_nn_1_1_N : N ;
  plaatfaelg_nn_1_1_N : N ;
  plaathuv_nn_1_1_N : N ;
  ploejning_nn_1_1_N : N ;
  pochering_nn_1_N : N ;
  poesilaesning_nn_1_1_N : N ;
  pointering_nn_1_N : N ;
  pojkskildring_nn_1_N : N ;
  pojkvaerld_nn_1_1_N : N ;
  pokulering_nn_1_N : N ;
  polarforskning_nn_1_N : N ;
  polarisering_nn_1_N : N ;
  polemisering_nn_1_N : N ;
  polerduk_nn_1_N : N ;
  polering_nn_1_N : N ;
  polersvamp_nn_1_N : N ;
  polhemsknut_nn_1_N : N ;
  polisanmaelning_nn_1_1_N : N ;
  polisbevakning_nn_1_N : N ;
  polisbil_nn_1_N : N ;
  polisfoerordning_nn_1_1_N : N ;
  polishjaelm_nn_1_1_N : N ;
  polisspaning_nn_1_N : N ;
  polistjaenstgoering_nn_1_1_N : N ;
  polisundersoekning_nn_1_1_N : N ;
  polisutryckning_nn_1_N : N ;
  politisering_nn_1_N : N ;
  pollenslang_nn_1_N : N ;
  pollettering_nn_1_N : N ;
  pollinering_nn_1_N : N ;
  poloboll_nn_1_N : N ;
  polvaendning_nn_1_1_N : N ;
  polymerbelaeggning_nn_1_1_N : N ;
  polymerloesning_nn_1_1_N : N ;
  pomadering_nn_1_N : N ;
  ponering_nn_1_N : N ;
  popularisering_nn_1_N : N ;
  porrklubb_nn_1_N : N ;
  porrtidning_nn_1_N : N ;
  porslinskrossning_nn_1_N : N ;
  porslinsmaalning_nn_1_1_N : N ;
  porslinssaekring_nn_1_1_N : N ;
  porslinstillverkning_nn_1_N : N ;
  portgaang_nn_1_1_N : N ;
  portingaang_nn_1_1_N : N ;
  portionering_nn_1_N : N ;
  portraettering_nn_1_1_N : N ;
  portuppgaang_nn_1_1_N : N ;
  posering_nn_1_N : N ;
  positionsbestaemning_nn_1_1_N : N ;
  postanvisning_nn_1_N : N ;
  postbaat_nn_1_1_N : N ;
  postdatering_nn_1_N : N ;
  postering_nn_1_N : N ;
  postponering_nn_1_N : N ;
  postulering_nn_1_N : N ;
  postutdelning_nn_1_N : N ;
  potatisskoerd_nn_1_1_N : N ;
  poaengstaellning_nn_1_1_N : N ;
  poaengtering_nn_1_1_N : N ;
  praktiktjaenstgoering_nn_1_1_N : N ;
  praktisering_nn_1_N : N ;
  praktmaalning_nn_1_1_N : N ;
  precisering_nn_1_N : N ;
  precisionsskjutning_nn_1_N : N ;
  predestinering_nn_1_N : N ;
  predicering_nn_1_N : N ;
  predikning_nn_1_N : N ;
  predikosamling_nn_1_N : N ;
  predisponering_nn_1_N : N ;
  predominering_nn_1_N : N ;
  prefabricering_nn_1_N : N ;
  prefigering_nn_1_N : N ;
  prejning_nn_1_N : N ;
  preludiering_nn_1_N : N ;
  premiering_nn_1_N : N ;
  prenumerering_nn_1_N : N ;
  preparering_nn_1_N : N ;
  presentering_nn_1_N : N ;
  preservering_nn_1_N : N ;
  presidering_nn_1_N : N ;
  preskribering_nn_1_N : N ;
  presslaeggning_nn_1_1_N : N ;
  pressmottagning_nn_1_N : N ;
  pressning_nn_1_N : N ;
  presstraeff_nn_1_1_N : N ;
  prestavering_nn_1_N : N ;
  prestering_nn_1_N : N ;
  presumering_nn_1_N : N ;
  pretendering_nn_1_N : N ;
  prickning_nn_1_N : N ;
  prickskytt_nn_1_N : N ;
  principfoerklaring_nn_1_1_N : N ;
  prinsessklaenning_nn_1_1_N : N ;
  prinsesstaartbit_nn_1_1_N : N ;
  prinskorv_nn_1_N : N ;
  prioritering_nn_1_N : N ;
  prioritetsordning_nn_1_N : N ;
  prisbeloening_nn_1_1_N : N ;
  prisbluff_nn_1_N : N ;
  prisfoeraendring_nn_1_1_N : N ;
  prisgivning_nn_1_N : N ;
  prishoejning_nn_1_1_N : N ;
  prispall_nn_1_N : N ;
  prisreglering_nn_1_N : N ;
  prisstegring_nn_1_N : N ;
  prissaettning_nn_1_1_N : N ;
  pristaevling_nn_1_1_N : N ;
  prisutdelning_nn_1_N : N ;
  prisoekning_nn_1_1_N : N ;
  privatbil_nn_1_N : N ;
  privategendom_nn_1_N : N ;
  privatisering_nn_1_N : N ;
  privatsnok_nn_1_N : N ;
  privatsnut_nn_1_N : N ;
  privilegiering_nn_1_N : N ;
  probering_nn_1_N : N ;
  problemanlaeggning_nn_1_1_N : N ;
  problematisering_nn_1_N : N ;
  problemdeg_nn_1_N : N ;
  problemdiktning_nn_1_N : N ;
  problemformulering_nn_1_N : N ;
  problemorientering_nn_1_N : N ;
  problemstaellning_nn_1_1_N : N ;
  processordning_nn_1_N : N ;
  producering_nn_1_N : N ;
  produktplanering_nn_1_N : N ;
  profanering_nn_1_N : N ;
  professionalisering_nn_1_N : N ;
  professorstillsaettning_nn_1_1_N : N ;
  profetering_nn_1_N : N ;
  profilering_nn_1_N : N ;
  profitering_nn_1_N : N ;
  prognostisering_nn_1_N : N ;
  programbudgetering_nn_1_N : N ;
  programfoerklaring_nn_1_1_N : N ;
  programmering_nn_1_N : N ;
  programstyrning_nn_1_N : N ;
  programvaerd_nn_1_1_N : N ;
  progressivfjaedring_nn_1_1_N : N ;
  projektering_nn_1_N : N ;
  projicering_nn_1_N : N ;
  proklamering_nn_1_N : N ;
  proletarisering_nn_1_N : N ;
  prolongering_nn_1_N : N ;
  promenadstig_nn_1_N : N ;
  promenadvaeg_nn_1_1_N : N ;
  promenering_nn_1_N : N ;
  promovering_nn_1_N : N ;
  promulgering_nn_1_N : N ;
  prononcering_nn_1_N : N ;
  propagering_nn_1_N : N ;
  proponering_nn_1_N : N ;
  proportionering_nn_1_N : N ;
  proppsaekring_nn_1_1_N : N ;
  prosastil_nn_1_N : N ;
  proskribering_nn_1_N : N ;
  prospektering_nn_1_N : N ;
  prostgaard_nn_1_1_N : N ;
  prostituering_nn_1_N : N ;
  protegering_nn_1_N : N ;
  proteinforskning_nn_1_N : N ;
  protestering_nn_1_N : N ;
  protestklickning_nn_1_N : N ;
  protokollering_nn_1_N : N ;
  protonladdning_nn_1_N : N ;
  provanstaellning_nn_1_1_N : N ;
  provbit_nn_1_N : N ;
  proviantering_nn_1_N : N ;
  provkoerning_nn_1_1_N : N ;
  provning_nn_1_N : N ;
  provocering_nn_1_N : N ;
  provraekning_nn_1_1_N : N ;
  provroersbefruktning_nn_1_1_N : N ;
  provskjutning_nn_1_N : N ;
  provspraengning_nn_1_1_N : N ;
  provtagning_nn_1_N : N ;
  provtjaenstgoering_nn_1_1_N : N ;
  provoeversaettning_nn_1_1_N : N ;
  prustning_nn_1_N : N ;
  prutning_nn_1_N : N ;
  praegling_nn_1_1_N : N ;
  praentning_nn_1_1_N : N ;
  praestgaardstraedgaard_nn_1_1_N : N ;
  praesttillsaettning_nn_1_1_N : N ;
  praestutbildning_nn_1_1_N : N ;
  praestvigning_nn_1_1_N : N ;
  proevning_nn_1_1_N : N ;
  psykoanalysering_nn_1_N : N ;
  psykologisering_nn_1_N : N ;
  pubertetsyngling_nn_1_N : N ;
  pubesring_nn_1_N : N ;
  pubisring_nn_1_N : N ;
  publicering_nn_1_N : N ;
  puffaerm_nn_1_1_N : N ;
  pulsering_nn_1_N : N ;
  pulstagning_nn_1_N : N ;
  pulverisering_nn_1_N : N ;
  pulvrisering_nn_1_N : N ;
  pungbjoern_nn_1_1_N : N ;
  punktbevakning_nn_1_N : N ;
  punktering_nn_1_N : N ;
  punsning_nn_1_N : N ;
  purgering_nn_1_N : N ;
  purjoloek_nn_1_1_N : N ;
  pusselbit_nn_1_N : N ;
  pustning_nn_1_N : N ;
  putsduk_nn_1_N : N ;
  putsning_nn_1_N : N ;
  pyjamasgylf_nn_1_N : N ;
  pytonorm_nn_1_N : N ;
  paelsboll_nn_1_1_N : N ;
  paerlstickning_nn_1_1_N : N ;
  paaannonsering_nn_1_1_N : N ;
  paabackning_nn_1_1_N : N ;
  paafrestning_nn_1_1_N : N ;
  paafyllnadsfoerpackning_nn_1_1_N : N ;
  paafyllning_nn_1_1_N : N ;
  paafyllningspip_nn_1_1_N : N ;
  paahaelsning_nn_1_1_N : N ;
  paaknaeppning_nn_1_1_N : N ;
  paakaenning_nn_1_1_N : N ;
  paakoerning_nn_1_1_N : N ;
  paalandsvind_nn_1_1_N : N ;
  paalkran_nn_1_1_N : N ;
  paalning_nn_1_1_N : N ;
  paalaeggning_nn_1_1_N : N ;
  paapaelsning_nn_1_1_N : N ;
  paaringning_nn_1_1_N : N ;
  paaropning_nn_1_1_N : N ;
  paasegling_nn_1_1_N : N ;
  paaskeld_nn_1_1_N : N ;
  paaskyndning_nn_1_1_N : N ;
  paaspaedning_nn_1_1_N : N ;
  paastoetning_nn_1_1_N : N ;
  paasaettning_nn_1_1_N : N ;
  paatagning_nn_1_1_N : N ;
  paatryckning_nn_1_1_N : N ;
  paataendning_nn_1_1_N : N ;
  paaverkning_nn_1_1_N : N ;
  paavisning_nn_1_1_N : N ;
  poebelhop_nn_1_1_N : N ;
  poesmunk_nn_1_1_N : N ;
  poesning_nn_1_1_N : N ;
  rabattering_nn_1_N : N ;
  racerbil_nn_1_N : N ;
  racerbaat_nn_1_1_N : N ;
  racingbaat_nn_1_1_N : N ;
  radering_nn_1_N : N ;
  raderkniv_nn_1_N : N ;
  radiakbehandling_nn_1_N : N ;
  radiering_nn_1_N : N ;
  radikalisering_nn_1_N : N ;
  radioavlyssning_nn_1_N : N ;
  radiobil_nn_1_N : N ;
  radionavigering_nn_1_N : N ;
  radiopejling_nn_1_N : N ;
  radiostraalning_nn_1_1_N : N ;
  radiostyrning_nn_1_N : N ;
  radiostoerning_nn_1_1_N : N ;
  radiosaendning_nn_1_1_N : N ;
  radioutsaendning_nn_1_1_N : N ;
  raffinering_nn_1_N : N ;
  rafistulering_nn_1_N : N ;
  raggarbil_nn_1_N : N ;
  raggaraak_nn_1_1_N : N ;
  raggmunk_nn_1_N : N ;
  raglanaerm_nn_1_1_N : N ;
  rakkniv_nn_1_N : N ;
  rakning_nn_1_N : N ;
  raljering_nn_1_N : N ;
  rallarsving_nn_1_N : N ;
  ramning_nn_1_N : N ;
  ramponering_nn_1_N : N ;
  randanmaerkning_nn_1_1_N : N ;
  randanteckning_nn_1_N : N ;
  randbildning_nn_1_N : N ;
  randning_nn_1_N : N ;
  rangering_nn_1_N : N ;
  rangordning_nn_1_N : N ;
  rannsakning_nn_1_N : N ;
  ransonering_nn_1_N : N ;
  rapning_nn_1_N : N ;
  rappellering_nn_1_N : N ;
  rappning_nn_1_N : N ;
  rapportering_nn_1_N : N ;
  rasblandning_nn_1_N : N ;
  rasdiskriminering_nn_1_N : N ;
  rasering_nn_1_N : N ;
  rasfoerdom_nn_1_1_N : N ;
  raspning_nn_1_N : N ;
  ratificering_nn_1_N : N ;
  rationalisering_nn_1_N : N ;
  reagering_nn_1_N : N ;
  reaktivering_nn_1_N : N ;
  realisering_nn_1_N : N ;
  realloenesaenkning_nn_1_1_N : N ;
  realtidsbearbetning_nn_1_N : N ;
  reassurering_nn_1_N : N ;
  rebellering_nn_1_N : N ;
  recensering_nn_1_N : N ;
  recidivering_nn_1_N : N ;
  recipiering_nn_1_N : N ;
  recitering_nn_1_N : N ;
  redigering_nn_1_N : N ;
  redning_nn_1_N : N ;
  redovisning_nn_1_N : N ;
  reducering_nn_1_N : N ;
  reduktionsdelning_nn_1_N : N ;
  referensram_nn_1_N : N ;
  referering_nn_1_N : N ;
  reflektering_nn_1_N : N ;
  reformering_nn_1_N : N ;
  refusering_nn_1_N : N ;
  regalering_nn_1_N : N ;
  regelutformning_nn_1_N : N ;
  regenerering_nn_1_N : N ;
  regering_nn_1_N : N ;
  regeringsplattform_nn_1_N : N ;
  regissering_nn_1_N : N ;
  registerknapp_nn_1_N : N ;
  registrering_nn_1_N : N ;
  registreringsskylt_nn_1_N : N ;
  reglementering_nn_1_N : N ;
  reglering_nn_1_N : N ;
  regling_nn_1_N : N ;
  regnrock_nn_1_N : N ;
  regnskog_nn_1_N : N ;
  regnskogsskoevling_nn_1_1_N : N ;
  regummering_nn_1_N : N ;
  rehabilitering_nn_1_N : N ;
  reinkarnering_nn_1_N : N ;
  rekapitulering_nn_1_N : N ;
  reklamering_nn_1_N : N ;
  rekognoscering_nn_1_N : N ;
  rekognosering_nn_1_N : N ;
  rekommendering_nn_1_N : N ;
  rekompensering_nn_1_N : N ;
  rekonstruering_nn_1_N : N ;
  rekordsatsning_nn_1_N : N ;
  rekreationsanlaeggning_nn_1_1_N : N ;
  rekreationsskog_nn_1_N : N ;
  rekrytering_nn_1_N : N ;
  rektificering_nn_1_N : N ;
  rektifiering_nn_1_N : N ;
  rekvirering_nn_1_N : N ;
  rekylering_nn_1_N : N ;
  relatering_nn_1_N : N ;
  relegering_nn_1_N : N ;
  relingsmanning_nn_1_N : N ;
  remittering_nn_1_N : N ;
  remontering_nn_1_N : N ;
  remplacering_nn_1_N : N ;
  rendering_nn_1_N : N ;
  rengoering_nn_1_1_N : N ;
  rengoeringsduk_nn_1_1_N : N ;
  renhaallning_nn_1_1_N : N ;
  renovering_nn_1_N : N ;
  renskiljning_nn_1_N : N ;
  renskrivning_nn_1_N : N ;
  rensning_nn_1_N : N ;
  rensningsnaal_nn_1_1_N : N ;
  renstek_nn_1_N : N ;
  renstratt_nn_1_N : N ;
  reorganisering_nn_1_N : N ;
  reparering_nn_1_N : N ;
  repartisering_nn_1_N : N ;
  repatriering_nn_1_N : N ;
  repellering_nn_1_N : N ;
  repetering_nn_1_N : N ;
  repetitionsoevning_nn_1_1_N : N ;
  repliering_nn_1_N : N ;
  replikering_nn_1_N : N ;
  representering_nn_1_N : N ;
  reprisering_nn_1_N : N ;
  reproducering_nn_1_N : N ;
  repoevning_nn_1_1_N : N ;
  resebeskrivning_nn_1_N : N ;
  resemugg_nn_1_N : N ;
  reservering_nn_1_N : N ;
  reservnaering_nn_1_1_N : N ;
  reseraekning_nn_1_1_N : N ;
  reseskildring_nn_1_N : N ;
  resignering_nn_1_N : N ;
  resning_nn_1_N : N ;
  resolvering_nn_1_N : N ;
  resonering_nn_1_N : N ;
  resorbering_nn_1_N : N ;
  respektering_nn_1_N : N ;
  respirering_nn_1_N : N ;
  restaurangbaat_nn_1_1_N : N ;
  restaurangmiddag_nn_1_N : N ;
  restaurering_nn_1_N : N ;
  restituering_nn_1_N : N ;
  resultatfoerbaettring_nn_1_1_N : N ;
  resultatredovisning_nn_1_N : N ;
  resultatraekning_nn_1_1_N : N ;
  resultering_nn_1_N : N ;
  resumering_nn_1_N : N ;
  resursoeverfoering_nn_1_1_N : N ;
  resvaeg_nn_1_1_N : N ;
  resaarstickning_nn_1_1_N : N ;
  retablering_nn_1_N : N ;
  retardering_nn_1_N : N ;
  retirering_nn_1_N : N ;
  retning_nn_1_N : N ;
  retrogradavledning_nn_1_N : N ;
  returnering_nn_1_N : N ;
  retuschering_nn_1_N : N ;
  revalvering_nn_1_N : N ;
  revetering_nn_1_N : N ;
  revidering_nn_1_N : N ;
  revirpinkning_nn_1_N : N ;
  revning_nn_1_N : N ;
  revoltering_nn_1_N : N ;
  revolutionering_nn_1_N : N ;
  ridning_nn_1_N : N ;
  ridtaevling_nn_1_1_N : N ;
  ridvaeg_nn_1_1_N : N ;
  rigling_nn_1_N : N ;
  rikedom_nn_1_N : N ;
  rikoschettering_nn_1_N : N ;
  riksdagsordning_nn_1_N : N ;
  riksdagsspaerr_nn_1_1_N : N ;
  riksplanering_nn_1_N : N ;
  rikssal_nn_1_N : N ;
  rikstidning_nn_1_N : N ;
  riksvaeg_nn_1_1_N : N ;
  riktning_nn_1_N : N ;
  rimflaetning_nn_1_1_N : N ;
  ringaktning_nn_1_N : N ;
  ringmur_nn_1_N : N ;
  ringning_nn_1_N : N ;
  riojaprovning_nn_1_N : N ;
  ripostering_nn_1_N : N ;
  riskbedoemning_nn_1_1_N : N ;
  riskering_nn_1_N : N ;
  riskspridning_nn_1_N : N ;
  riskuppfattning_nn_1_N : N ;
  rispning_nn_1_N : N ;
  ristning_nn_1_N : N ;
  ritning_nn_1_N : N ;
  ritualisering_nn_1_N : N ;
  rivalisering_nn_1_N : N ;
  rivning_nn_1_N : N ;
  robotisering_nn_1_N : N ;
  rockering_nn_1_N : N ;
  rockring_nn_1_N : N ;
  rockaerm_nn_1_1_N : N ;
  roddbaat_nn_1_1_N : N ;
  roddtaevling_nn_1_1_N : N ;
  rollbesaettning_nn_1_1_N : N ;
  romantisering_nn_1_N : N ;
  rondellhund_nn_1_N : N ;
  rosenstock_nn_1_N : N ;
  rossling_nn_1_N : N ;
  rostflaeck_nn_1_1_N : N ;
  rostning_nn_1_N : N ;
  rostskyddsbehandling_nn_1_N : N ;
  rotering_nn_1_N : N ;
  rotfyllning_nn_1_N : N ;
  rotstock_nn_1_N : N ;
  rottraad_nn_1_1_N : N ;
  rubbning_nn_1_N : N ;
  rubinsamling_nn_1_N : N ;
  rubricering_nn_1_N : N ;
  ruckning_nn_1_N : N ;
  ruggning_nn_1_N : N ;
  ruinering_nn_1_N : N ;
  ruinhoeg_nn_1_1_N : N ;
  rullning_nn_1_N : N ;
  rullstol_nn_1_N : N ;
  rullvagn_nn_1_N : N ;
  rumpstek_nn_1_N : N ;
  rumsbestaellning_nn_1_1_N : N ;
  rumsfoermedling_nn_1_1_N : N ;
  rumskroekning_nn_1_1_N : N ;
  rumstering_nn_1_N : N ;
  rumsuppfattning_nn_1_N : N ;
  rundfil_nn_1_N : N ;
  rundflygning_nn_1_N : N ;
  rundfraagning_nn_1_1_N : N ;
  rundmaalning_nn_1_1_N : N ;
  rundning_nn_1_N : N ;
  rundringning_nn_1_N : N ;
  rundsmoerjning_nn_1_1_N : N ;
  rundtoern_nn_1_1_N : N ;
  rundvandring_nn_1_N : N ;
  runkning_nn_1_N : N ;
  ruskning_nn_1_N : N ;
  rusning_nn_1_N : N ;
  russificering_nn_1_N : N ;
  russifiering_nn_1_N : N ;
  rustning_nn_1_N : N ;
  ruvning_nn_1_N : N ;
  ryckning_nn_1_N : N ;
  ryggdunkning_nn_1_N : N ;
  ryggmaergsbedoevning_nn_1_1_N : N ;
  ryggning_nn_1_N : N ;
  ryggskoeld_nn_1_1_N : N ;
  ryggstraeckning_nn_1_1_N : N ;
  ryktespridning_nn_1_N : N ;
  ryktesspridning_nn_1_N : N ;
  rymdsatsning_nn_1_N : N ;
  rymning_nn_1_N : N ;
  rynkning_nn_1_N : N ;
  rysning_nn_1_N : N ;
  rytmisering_nn_1_N : N ;
  ryttargaang_nn_1_1_N : N ;
  ryttarlek_nn_1_N : N ;
  ryttaruppvisning_nn_1_N : N ;
  raeckning_nn_1_1_N : N ;
  raeddning_nn_1_1_N : N ;
  raeffling_nn_1_1_N : N ;
  raekkryssning_nn_1_1_N : N ;
  raekning_nn_1_1_N : N ;
  raentehoejning_nn_1_1_N : N ;
  raetning_nn_1_1_N : N ;
  raetstickning_nn_1_1_N : N ;
  raettegaang_nn_1_1_N : N ;
  raettegaangsdag_nn_1_1_N : N ;
  raettning_nn_1_1_N : N ;
  raettskipning_nn_1_1_N : N ;
  raettskrivning_nn_1_1_N : N ;
  raettskraenkning_nn_1_1_N : N ;
  raettsordning_nn_1_1_N : N ;
  raettssal_nn_1_1_N : N ;
  raettsskipning_nn_1_1_N : N ;
  raettstavning_nn_1_1_N : N ;
  raettstillaempning_nn_1_1_N : N ;
  raettsuppfattning_nn_1_1_N : N ;
  raadbraakning_nn_1_1_N : N ;
  raadfraagning_nn_1_1_N : N ;
  raadgivning_nn_1_1_N : N ;
  raadplaegning_nn_1_1_N : N ;
  raadsfoersamling_nn_1_1_N : N ;
  raagaang_nn_1_1_N : N ;
  raamning_nn_1_1_N : N ;
  raattskit_nn_1_1_N : N ;
  roedlistning_nn_1_1_N : N ;
  roejning_nn_1_1_N : N ;
  roejsaag_nn_1_1_N : N ;
  roekdykning_nn_1_1_N : N ;
  roekgaang_nn_1_1_N : N ;
  roekning_nn_1_1_N : N ;
  roekpuff_nn_1_1_N : N ;
  roekring_nn_1_1_N : N ;
  roentgenbehandling_nn_1_1_N : N ;
  roentgenfotografering_nn_1_1_N : N ;
  roentgenstraalning_nn_1_1_N : N ;
  roentgenundersoekning_nn_1_1_N : N ;
  roerbrunn_nn_1_1_N : N ;
  roerelseriktning_nn_1_1_N : N ;
  roerelsestoerning_nn_1_1_N : N ;
  roering_nn_1_1_N : N ;
  roerledning_nn_1_1_N : N ;
  roesning_nn_1_1_N : N ;
  roestmaximering_nn_1_1_N : N ;
  roestning_nn_1_1_N : N ;
  roestraekning_nn_1_1_N : N ;
  roevarhoevding_nn_1_1_N : N ;
  sabelfaektning_nn_1_1_N : N ;
  sabotering_nn_1_N : N ;
  sabrering_nn_1_N : N ;
  sackning_nn_1_N : N ;
  sadelknapp_nn_1_N : N ;
  sadelmakarnaal_nn_1_1_N : N ;
  saftspaenning_nn_1_1_N : N ;
  saftstroemning_nn_1_1_N : N ;
  sagosamling_nn_1_N : N ;
  sagovaerld_nn_1_1_N : N ;
  sakframstaellning_nn_1_1_N : N ;
  sakfoerklaring_nn_1_1_N : N ;
  sakfoersaekring_nn_1_1_N : N ;
  sakkunnigberedning_nn_1_N : N ;
  sakkunnigproevning_nn_1_1_N : N ;
  sakkaennedom_nn_1_1_N : N ;
  sakproevning_nn_1_1_N : N ;
  sakupplysning_nn_1_N : N ;
  saldering_nn_1_N : N ;
  saligfoerklaring_nn_1_1_N : N ;
  salighetsvaeg_nn_1_1_N : N ;
  saligprisning_nn_1_N : N ;
  salivering_nn_1_N : N ;
  salivsug_nn_1_N : N ;
  salning_nn_1_N : N ;
  saloondoerr_nn_1_1_N : N ;
  saltavlagring_nn_1_N : N ;
  saltbil_nn_1_N : N ;
  saltdamm_nn_1_N : N ;
  saltloesning_nn_1_1_N : N ;
  saltutvinning_nn_1_N : N ;
  saltaeng_nn_1_1_N : N ;
  salutdag_nn_1_N : N ;
  salutering_nn_1_N : N ;
  salutskjutning_nn_1_N : N ;
  sambeskattning_nn_1_N : N ;
  samhaellsbevakning_nn_1_1_N : N ;
  samhaellsordning_nn_1_1_N : N ;
  samhaellsplanering_nn_1_1_N : N ;
  samhaellsskildring_nn_1_1_N : N ;
  samhaellsstyrning_nn_1_1_N : N ;
  samhaellsstaellning_nn_1_1_N : N ;
  samhaellsutveckling_nn_1_1_N : N ;
  samhaellsoevervakning_nn_1_1_N : N ;
  samkoerning_nn_1_1_N : N ;
  samlagsstaellning_nn_1_1_N : N ;
  samling_nn_1_N : N ;
  samlingsregering_nn_1_N : N ;
  samlingssal_nn_1_N : N ;
  sammanbindning_nn_1_N : N ;
  sammanblandning_nn_1_N : N ;
  sammandrabbning_nn_1_N : N ;
  sammandragning_nn_1_N : N ;
  sammanfattning_nn_1_N : N ;
  sammanfogning_nn_1_N : N ;
  sammanhopning_nn_1_N : N ;
  sammanhaallning_nn_1_1_N : N ;
  sammanjaemkning_nn_1_1_N : N ;
  sammankoppling_nn_1_N : N ;
  sammanlaeggning_nn_1_1_N : N ;
  sammanlaeggningsavhandling_nn_1_1_N : N ;
  sammanlaenkning_nn_1_1_N : N ;
  sammanpackning_nn_1_N : N ;
  sammanringning_nn_1_N : N ;
  sammanraekning_nn_1_1_N : N ;
  sammanskrivning_nn_1_N : N ;
  sammanslagning_nn_1_N : N ;
  sammanslutning_nn_1_N : N ;
  sammansmaeltning_nn_1_1_N : N ;
  sammanstaellning_nn_1_1_N : N ;
  sammanstoetning_nn_1_1_N : N ;
  sammansvetsning_nn_1_N : N ;
  sammansvaerjning_nn_1_1_N : N ;
  sammansaettning_nn_1_1_N : N ;
  sammantraedesordning_nn_1_1_N : N ;
  sammanvaevning_nn_1_1_N : N ;
  sammanvaexning_nn_1_1_N : N ;
  samordning_nn_1_N : N ;
  sampling_nn_1_N : N ;
  samregering_nn_1_N : N ;
  samsaendning_nn_1_1_N : N ;
  samtalsmarkering_nn_1_N : N ;
  samtaxering_nn_1_N : N ;
  samtidsskildring_nn_1_N : N ;
  sandblaestring_nn_1_1_N : N ;
  sandform_nn_1_N : N ;
  sandsaeck_nn_1_1_N : N ;
  sanering_nn_1_N : N ;
  sanforisering_nn_1_N : N ;
  sanktifiering_nn_1_N : N ;
  sanktionering_nn_1_N : N ;
  sanning_nn_1_N : N ;
  sannolikhetsberaekning_nn_1_1_N : N ;
  sansning_nn_1_N : N ;
  saponifiering_nn_1_N : N ;
  sardinburk_nn_1_N : N ;
  sargning_nn_1_N : N ;
  satinering_nn_1_N : N ;
  satirisering_nn_1_N : N ;
  satisfiering_nn_1_N : N ;
  satsbindning_nn_1_N : N ;
  satsfogning_nn_1_N : N ;
  satsfoerkortning_nn_1_1_N : N ;
  satskommatering_nn_1_N : N ;
  satsloesning_nn_1_1_N : N ;
  satsning_nn_1_N : N ;
  saturering_nn_1_N : N ;
  sautering_nn_1_N : N ;
  sauvering_nn_1_N : N ;
  savning_nn_1_N : N ;
  saxkrok_nn_1_N : N ;
  saxning_nn_1_N : N ;
  scanning_nn_1_N : N ;
  scenanvisning_nn_1_N : N ;
  scenbearbetning_nn_1_N : N ;
  scenfoeraendring_nn_1_1_N : N ;
  sceningaang_nn_1_1_N : N ;
  scenuppsaettning_nn_1_1_N : N ;
  scenvind_nn_1_N : N ;
  scenvaexling_nn_1_1_N : N ;
  scenoeppning_nn_1_1_N : N ;
  schablonering_nn_1_N : N ;
  schablonisering_nn_1_N : N ;
  schablontaxering_nn_1_N : N ;
  schackturnering_nn_1_N : N ;
  schalottenloek_nn_1_1_N : N ;
  schamponering_nn_1_N : N ;
  schanghajning_nn_1_N : N ;
  schasning_nn_1_N : N ;
  schattering_nn_1_N : N ;
  schavottering_nn_1_N : N ;
  schematisering_nn_1_N : N ;
  schumring_nn_1_N : N ;
  schaeferhatt_nn_1_1_N : N ;
  scouthaelsning_nn_1_1_N : N ;
  scoutlag_nn_1_N : N ;
  seccomaalning_nn_1_1_N : N ;
  sedelbraenning_nn_1_1_N : N ;
  sedelstock_nn_1_N : N ;
  sedeltaeckning_nn_1_1_N : N ;
  sedeskildring_nn_1_N : N ;
  sedimentering_nn_1_N : N ;
  segelbaergning_nn_1_1_N : N ;
  segelbaat_nn_1_1_N : N ;
  segelflygning_nn_1_N : N ;
  segelfoering_nn_1_1_N : N ;
  segerstaemning_nn_1_1_N : N ;
  segling_nn_1_N : N ;
  seglingsbeskrivning_nn_1_N : N ;
  segmentering_nn_1_N : N ;
  segregering_nn_1_N : N ;
  segring_nn_1_N : N ;
  sejsning_nn_1_N : N ;
  sekondering_nn_1_N : N ;
  sekretessproevning_nn_1_1_N : N ;
  sekretionsrubbning_nn_1_N : N ;
  sektorport_nn_1_N : N ;
  sekularisering_nn_1_N : N ;
  sekundering_nn_1_N : N ;
  sekundaerbelysning_nn_1_1_N : N ;
  sekvensering_nn_1_N : N ;
  sekvestrering_nn_1_N : N ;
  selektering_nn_1_N : N ;
  selning_nn_1_N : N ;
  semaforering_nn_1_N : N ;
  semesterdag_nn_1_N : N ;
  semesterersaettning_nn_1_1_N : N ;
  seminering_nn_1_N : N ;
  senarelaeggning_nn_1_1_N : N ;
  senknut_nn_1_N : N ;
  sensibilisering_nn_1_N : N ;
  sensitivitetstraening_nn_1_1_N : N ;
  sensitraening_nn_1_1_N : N ;
  sentering_nn_1_N : N ;
  separatfjaedring_nn_1_1_N : N ;
  separatutstaellning_nn_1_1_N : N ;
  separering_nn_1_N : N ;
  sepiatoning_nn_1_N : N ;
  serieinlaerning_nn_1_1_N : N ;
  seriekoppling_nn_1_N : N ;
  serietidning_nn_1_N : N ;
  serietidningstappning_nn_1_N : N ;
  serietillverkning_nn_1_N : N ;
  serpentinisering_nn_1_N : N ;
  servboll_nn_1_N : N ;
  serveboll_nn_1_N : N ;
  servering_nn_1_N : N ;
  serveringsgaang_nn_1_1_N : N ;
  serveringskork_nn_1_N : N ;
  servettbrytning_nn_1_N : N ;
  servettring_nn_1_N : N ;
  servicebil_nn_1_N : N ;
  serviceinraettning_nn_1_1_N : N ;
  servicenaering_nn_1_1_N : N ;
  servisledning_nn_1_N : N ;
  servitrisbak_nn_1_N : N ;
  servitrisklapp_nn_1_N : N ;
  servostyrning_nn_1_N : N ;
  setboll_nn_1_N : N ;
  sexbrottsutredning_nn_1_N : N ;
  sexkoepslag_nn_1_1_N : N ;
  sextiofemaarsdag_nn_1_1_N : N ;
  sextioaarsdag_nn_1_1_N : N ;
  sextonaaring_nn_1_1_N : N ;
  sexualisering_nn_1_N : N ;
  sexualupplysning_nn_1_N : N ;
  sexaaring_nn_1_1_N : N ;
  shamponering_nn_1_N : N ;
  shanghajning_nn_1_N : N ;
  shoppingvagn_nn_1_N : N ;
  shortning_nn_1_N : N ;
  showdrill_nn_1_N : N ;
  showvaerd_nn_1_1_N : N ;
  shuntkoppling_nn_1_N : N ;
  sidnumrering_nn_1_N : N ;
  sidobelysning_nn_1_N : N ;
  sidoblick_nn_1_N : N ;
  sidodoerr_nn_1_1_N : N ;
  sidoingaang_nn_1_1_N : N ;
  sidojustering_nn_1_N : N ;
  sidovaeg_nn_1_1_N : N ;
  sidovaegg_nn_1_1_N : N ;
  sidvagn_nn_1_N : N ;
  sidvall_nn_1_N : N ;
  sifferraekning_nn_1_1_N : N ;
  sifoundersoekning_nn_1_1_N : N ;
  sightseeing_nn_1_N : N ;
  sigillering_nn_1_N : N ;
  sigillring_nn_1_N : N ;
  signalduk_nn_1_N : N ;
  signaleld_nn_1_N : N ;
  signalering_nn_1_N : N ;
  signalspaning_nn_1_N : N ;
  signering_nn_1_N : N ;
  signetring_nn_1_N : N ;
  signifikansproevning_nn_1_1_N : N ;
  siktduk_nn_1_N : N ;
  siktning_nn_1_N : N ;
  siktram_nn_1_N : N ;
  silduk_nn_1_N : N ;
  silhuettering_nn_1_N : N ;
  silkesodling_nn_1_N : N ;
  silkestraad_nn_1_1_N : N ;
  sillhaj_nn_1_N : N ;
  sillinlaeggning_nn_1_1_N : N ;
  sillvrakning_nn_1_N : N ;
  silning_nn_1_N : N ;
  siluettering_nn_1_N : N ;
  silverprobering_nn_1_N : N ;
  silversked_nn_1_N : N ;
  silvertraad_nn_1_1_N : N ;
  simklubb_nn_1_N : N ;
  simning_nn_1_N : N ;
  simplifiering_nn_1_N : N ;
  simtraening_nn_1_1_N : N ;
  simtaevling_nn_1_1_N : N ;
  simulering_nn_1_N : N ;
  simultantolkning_nn_1_N : N ;
  sinkning_nn_1_N : N ;
  sinnesfoerfattning_nn_1_1_N : N ;
  sinnesfoervirring_nn_1_1_N : N ;
  sinnesrubbning_nn_1_N : N ;
  sinnessjukdom_nn_1_N : N ;
  sinnesstaemning_nn_1_1_N : N ;
  sinnesundersoekning_nn_1_1_N : N ;
  sinnesaendring_nn_1_1_N : N ;
  sittning_nn_1_N : N ;
  sittstaellning_nn_1_1_N : N ;
  sjanghajning_nn_1_N : N ;
  sjangsering_nn_1_N : N ;
  sjudning_nn_1_N : N ;
  sjuglasvagn_nn_1_N : N ;
  sjukdag_nn_1_N : N ;
  sjukdom_nn_1_N : N ;
  sjukdomsfoerklaring_nn_1_1_N : N ;
  sjukersaettning_nn_1_1_N : N ;
  sjukfoersaekring_nn_1_1_N : N ;
  sjukhusavdelning_nn_1_N : N ;
  sjukhussal_nn_1_N : N ;
  sjukpenning_nn_1_N : N ;
  sjukpenningutbetalning_nn_1_N : N ;
  sjukskrivning_nn_1_N : N ;
  sjukskoeterskeutbildning_nn_1_1_N : N ;
  sjukvaardsfoersaekring_nn_1_1_N : N ;
  sjukvaardsutbildning_nn_1_1_N : N ;
  sjukvaardsutrustning_nn_1_1_N : N ;
  sjunkning_nn_1_N : N ;
  sjuttonaaring_nn_1_1_N : N ;
  sjuaaring_nn_1_1_N : N ;
  sjaelaringning_nn_1_1_N : N ;
  sjaelavandring_nn_1_1_N : N ;
  sjaelssjukdom_nn_1_1_N : N ;
  sjaelvaktning_nn_1_1_N : N ;
  sjaelvalstring_nn_1_1_N : N ;
  sjaelvantaendning_nn_1_1_N : N ;
  sjaelvbefruktning_nn_1_1_N : N ;
  sjaelvbehaerskning_nn_1_1_N : N ;
  sjaelvbespegling_nn_1_1_N : N ;
  sjaelvbetjaening_nn_1_1_N : N ;
  sjaelvbildning_nn_1_1_N : N ;
  sjaelvfinansiering_nn_1_1_N : N ;
  sjaelvfoeryngring_nn_1_1_N : N ;
  sjaelvhushaallning_nn_1_1_N : N ;
  sjaelvhaeckling_nn_1_1_N : N ;
  sjaelvkaennedom_nn_1_1_N : N ;
  sjaelvlaekning_nn_1_1_N : N ;
  sjaelvservering_nn_1_1_N : N ;
  sjaelvspaekning_nn_1_1_N : N ;
  sjaelvstaendighetsfoerklaring_nn_1_1_N : N ;
  sjaelvtaendning_nn_1_1_N : N ;
  sjaelvuppfattning_nn_1_1_N : N ;
  sjaelvuppoffring_nn_1_1_N : N ;
  sjaelvurladdning_nn_1_1_N : N ;
  sjaelvutplaaning_nn_1_1_N : N ;
  sjoeavlagring_nn_1_1_N : N ;
  sjoebjoern_nn_1_1_N : N ;
  sjoefoerklaring_nn_1_1_N : N ;
  sjoehaevning_nn_1_1_N : N ;
  sjoemaning_nn_1_1_N : N ;
  sjoemansfoermedling_nn_1_1_N : N ;
  sjoemansklaenning_nn_1_1_N : N ;
  sjoemanssaeck_nn_1_1_N : N ;
  sjoemansutbildning_nn_1_1_N : N ;
  sjoemaetning_nn_1_1_N : N ;
  sjoereglering_nn_1_1_N : N ;
  sjoeraeddning_nn_1_1_N : N ;
  sjoesaettning_nn_1_1_N : N ;
  skadeersaettning_nn_1_1_N : N ;
  skadereglering_nn_1_N : N ;
  skadeverkning_nn_1_N : N ;
  skadevaerdering_nn_1_1_N : N ;
  skaffning_nn_1_N : N ;
  skakning_nn_1_N : N ;
  skallbloedning_nn_1_1_N : N ;
  skallerorm_nn_1_N : N ;
  skallgaang_nn_1_1_N : N ;
  skalning_nn_1_N : N ;
  skalpering_nn_1_N : N ;
  skamfilning_nn_1_N : N ;
  skamstock_nn_1_N : N ;
  skandalisering_nn_1_N : N ;
  skandaltidning_nn_1_N : N ;
  skandering_nn_1_N : N ;
  skanning_nn_1_N : N ;
  skarpskytt_nn_1_N : N ;
  skarvsladd_nn_1_N : N ;
  skattebetalning_nn_1_N : N ;
  skattehoejning_nn_1_1_N : N ;
  skatteinbetalning_nn_1_N : N ;
  skattelag_nn_1_N : N ;
  skattepeng_nn_1_N : N ;
  skatteplanering_nn_1_N : N ;
  skattesmitning_nn_1_N : N ;
  skattesaenkning_nn_1_1_N : N ;
  skatteutjaemning_nn_1_1_N : N ;
  skattevaexling_nn_1_1_N : N ;
  skatteaaterbaering_nn_1_1_N : N ;
  skattlaeggning_nn_1_1_N : N ;
  skattning_nn_1_N : N ;
  skavning_nn_1_N : N ;
  skedstork_nn_1_N : N ;
  skenavraettning_nn_1_1_N : N ;
  skendraenkning_nn_1_1_N : N ;
  skenfaektning_nn_1_1_N : N ;
  skenraettegaang_nn_1_1_N : N ;
  skenskarv_nn_1_N : N ;
  skenvaerld_nn_1_1_N : N ;
  skeppning_nn_1_N : N ;
  skeppsmaetning_nn_1_1_N : N ;
  skeppssaettning_nn_1_1_N : N ;
  skevning_nn_1_N : N ;
  skickning_nn_1_N : N ;
  skidanlaeggning_nn_1_1_N : N ;
  skiddrottning_nn_1_N : N ;
  skidhjaelm_nn_1_1_N : N ;
  skidhoppning_nn_1_N : N ;
  skidloepning_nn_1_1_N : N ;
  skidtaevling_nn_1_1_N : N ;
  skidaakning_nn_1_1_N : N ;
  skiftning_nn_1_N : N ;
  skiktning_nn_1_N : N ;
  skildring_nn_1_N : N ;
  skiljedom_nn_1_N : N ;
  skiljedomstol_nn_1_N : N ;
  skiljemur_nn_1_N : N ;
  skiljevaeg_nn_1_1_N : N ;
  skiljevaegg_nn_1_1_N : N ;
  skinnbit_nn_1_N : N ;
  skirning_nn_1_N : N ;
  skissering_nn_1_N : N ;
  skitvaag_nn_1_1_N : N ;
  skivinspelning_nn_1_N : N ;
  skivsamling_nn_1_N : N ;
  skivtallrik_nn_1_N : N ;
  skjortaerm_nn_1_1_N : N ;
  skjutdoerr_nn_1_1_N : N ;
  skjutning_nn_1_N : N ;
  skjutriktning_nn_1_N : N ;
  skjututbildning_nn_1_N : N ;
  skoborstning_nn_1_N : N ;
  skogbit_nn_1_N : N ;
  skogsavverkning_nn_1_N : N ;
  skogsfoerbaettring_nn_1_1_N : N ;
  skogsfoervaltning_nn_1_1_N : N ;
  skogsgallring_nn_1_N : N ;
  skogsgud_nn_1_N : N ;
  skogsskoevling_nn_1_1_N : N ;
  skogsvandring_nn_1_N : N ;
  skogsvaeg_nn_1_1_N : N ;
  skolavslutning_nn_1_N : N ;
  skolbildning_nn_1_N : N ;
  skoldag_nn_1_N : N ;
  skolfoervaltning_nn_1_1_N : N ;
  skolgrind_nn_1_N : N ;
  skoljazztaevling_nn_1_1_N : N ;
  skolkning_nn_1_N : N ;
  skolning_nn_1_N : N ;
  skolridning_nn_1_N : N ;
  skolsal_nn_1_N : N ;
  skolskjutning_nn_1_N : N ;
  skolundervisning_nn_1_N : N ;
  skolungdom_nn_1_N : N ;
  skolutbildning_nn_1_N : N ;
  skolvaeg_nn_1_1_N : N ;
  skoloevning_nn_1_1_N : N ;
  skoning_nn_1_N : N ;
  skorrning_nn_1_N : N ;
  skorstensmur_nn_1_N : N ;
  skottdag_nn_1_N : N ;
  skottlossning_nn_1_N : N ;
  skottning_nn_1_N : N ;
  skottpeng_nn_1_N : N ;
  skottskog_nn_1_N : N ;
  skraffering_nn_1_N : N ;
  skrapning_nn_1_N : N ;
  skridning_nn_1_N : N ;
  skridskosegling_nn_1_N : N ;
  skridskoaakning_nn_1_1_N : N ;
  skrinlaeggning_nn_1_1_N : N ;
  skrivbordsstol_nn_1_N : N ;
  skrivmaskinsstol_nn_1_N : N ;
  skrivning_nn_1_N : N ;
  skrivsal_nn_1_N : N ;
  skrivoevning_nn_1_1_N : N ;
  skrockning_nn_1_N : N ;
  skrodering_nn_1_N : N ;
  skrotbil_nn_1_N : N ;
  skrothaemtning_nn_1_1_N : N ;
  skrotning_nn_1_N : N ;
  skrubbning_nn_1_N : N ;
  skruvkrok_nn_1_N : N ;
  skrynkling_nn_1_N : N ;
  skraeckskildring_nn_1_1_N : N ;
  skraecktackling_nn_1_1_N : N ;
  skraedning_nn_1_1_N : N ;
  skraenfock_nn_1_1_N : N ;
  skraephoeg_nn_1_1_N : N ;
  skraepkorg_nn_1_1_N : N ;
  skubbning_nn_1_N : N ;
  skuggboxning_nn_1_N : N ;
  skuggloesning_nn_1_1_N : N ;
  skuggning_nn_1_N : N ;
  skuggregering_nn_1_N : N ;
  skuldavskrivning_nn_1_N : N ;
  skulptering_nn_1_N : N ;
  skulpturering_nn_1_N : N ;
  skumpakork_nn_1_N : N ;
  skumpning_nn_1_N : N ;
  skumtvaett_nn_1_1_N : N ;
  skumtvaettning_nn_1_1_N : N ;
  skumutrustning_nn_1_N : N ;
  skurning_nn_1_N : N ;
  skyddsduk_nn_1_N : N ;
  skyddsgud_nn_1_N : N ;
  skyddsimpregnering_nn_1_N : N ;
  skyddsmur_nn_1_N : N ;
  skyddsslang_nn_1_N : N ;
  skyltning_nn_1_N : N ;
  skymning_nn_1_N : N ;
  skyttegaang_nn_1_1_N : N ;
  skyttekung_nn_1_N : N ;
  skaektkniv_nn_1_1_N : N ;
  skaellning_nn_1_1_N : N ;
  skaelvning_nn_1_1_N : N ;
  skaemtteckning_nn_1_1_N : N ;
  skaendning_nn_1_1_N : N ;
  skaepkorg_nn_1_1_N : N ;
  skaeregg_nn_1_1_N : N ;
  skaermbildsundersoekning_nn_1_1_N : N ;
  skaerning_nn_1_1_N : N ;
  skaerskaadning_nn_1_1_N : N ;
  skaerstock_nn_1_1_N : N ;
  skaallning_nn_1_1_N : N ;
  skaapdoerr_nn_1_1_N : N ;
  skoeljning_nn_1_1_N : N ;
  skoenhetstaevling_nn_1_1_N : N ;
  skoenmaalning_nn_1_1_N : N ;
  skoenstaxering_nn_1_1_N : N ;
  skoentaxering_nn_1_1_N : N ;
  skoerdeuppskattning_nn_1_1_N : N ;
  skoevling_nn_1_1_N : N ;
  slagbjoern_nn_1_1_N : N ;
  slaggfaerskning_nn_1_1_N : N ;
  slagordning_nn_1_N : N ;
  slagvaexling_nn_1_1_N : N ;
  slagaentring_nn_1_1_N : N ;
  slaktning_nn_1_N : N ;
  slalomport_nn_1_N : N ;
  slamsugning_nn_1_N : N ;
  slamsugningsbil_nn_1_N : N ;
  slangkoppling_nn_1_N : N ;
  slantsingling_nn_1_N : N ;
  slaskhink_nn_1_N : N ;
  slasktratt_nn_1_N : N ;
  slavisering_nn_1_N : N ;
  slentrianfoerestaellning_nn_1_1_N : N ;
  slentrianmoerkning_nn_1_1_N : N ;
  slickning_nn_1_N : N ;
  slidkniv_nn_1_N : N ;
  slintning_nn_1_N : N ;
  slipsknut_nn_1_N : N ;
  slipsvamp_nn_1_N : N ;
  slirkoppling_nn_1_N : N ;
  slirning_nn_1_N : N ;
  slitning_nn_1_N : N ;
  slokhatt_nn_1_N : N ;
  slopning_nn_1_N : N ;
  slottssal_nn_1_N : N ;
  slottsstek_nn_1_N : N ;
  slottsvallgrav_nn_1_N : N ;
  slungboll_nn_1_N : N ;
  slungning_nn_1_N : N ;
  slussport_nn_1_N : N ;
  slutfoervaring_nn_1_1_N : N ;
  slutledning_nn_1_N : N ;
  slutplaedering_nn_1_1_N : N ;
  sluttning_nn_1_N : N ;
  slaeckning_nn_1_1_N : N ;
  slaektforskning_nn_1_1_N : N ;
  slaektgaard_nn_1_1_N : N ;
  slaektledning_nn_1_1_N : N ;
  slaengning_nn_1_1_N : N ;
  slaepring_nn_1_1_N : N ;
  slaepvagn_nn_1_1_N : N ;
  slaepvagnskoppling_nn_1_1_N : N ;
  slaetloepning_nn_1_1_N : N ;
  slaetning_nn_1_1_N : N ;
  slaetstickning_nn_1_1_N : N ;
  slaetvaelling_nn_1_1_N : N ;
  slaatterkniv_nn_1_1_N : N ;
  slaatteraeng_nn_1_1_N : N ;
  sloejdkniv_nn_1_1_N : N ;
  smackning_nn_1_N : N ;
  smakbit_nn_1_N : N ;
  smakloek_nn_1_1_N : N ;
  smakriktning_nn_1_N : N ;
  smaskning_nn_1_N : N ;
  smedlaerling_nn_1_1_N : N ;
  smedslaerling_nn_1_1_N : N ;
  smekning_nn_1_N : N ;
  smetning_nn_1_N : N ;
  sminkning_nn_1_N : N ;
  smitning_nn_1_N : N ;
  smittovaeg_nn_1_1_N : N ;
  smittooevervakning_nn_1_1_N : N ;
  smokingklaenning_nn_1_1_N : N ;
  smuggling_nn_1_N : N ;
  smygfilmning_nn_1_N : N ;
  smygvaeg_nn_1_1_N : N ;
  smaelek_nn_1_1_N : N ;
  smaeltning_nn_1_1_N : N ;
  smaeltsaekring_nn_1_1_N : N ;
  smaergelduk_nn_1_1_N : N ;
  smaertbehandling_nn_1_1_N : N ;
  smaerthaemning_nn_1_1_N : N ;
  smaertlindring_nn_1_1_N : N ;
  smaalaenning_nn_1_1_N : N ;
  smaaloek_nn_1_1_N : N ;
  smaaskog_nn_1_1_N : N ;
  smaatvaett_nn_1_1_N : N ;
  smoerboll_nn_1_1_N : N ;
  smoerjanordning_nn_1_1_N : N ;
  smoerjning_nn_1_1_N : N ;
  smoerklick_nn_1_1_N : N ;
  snabbavveckling_nn_1_N : N ;
  snabbkoppling_nn_1_N : N ;
  snabbmiddag_nn_1_N : N ;
  snarkning_nn_1_N : N ;
  snavning_nn_1_N : N ;
  sneddning_nn_1_N : N ;
  snedfoerdelning_nn_1_1_N : N ;
  snedparkering_nn_1_N : N ;
  snedrekrytering_nn_1_N : N ;
  snedtaendning_nn_1_1_N : N ;
  snedvridning_nn_1_N : N ;
  snoppning_nn_1_N : N ;
  snortning_nn_1_N : N ;
  snubbelsladd_nn_1_N : N ;
  snubbeltraad_nn_1_1_N : N ;
  snurrstol_nn_1_N : N ;
  snustillverkning_nn_1_N : N ;
  snuthaeck_nn_1_1_N : N ;
  snyftning_nn_1_N : N ;
  snytning_nn_1_N : N ;
  snaerjning_nn_1_1_N : N ;
  snaarskog_nn_1_1_N : N ;
  snoeboll_nn_1_1_N : N ;
  snoemulning_nn_1_1_N : N ;
  snoeplogning_nn_1_1_N : N ;
  snoepning_nn_1_1_N : N ;
  snoerning_nn_1_1_N : N ;
  snoerpning_nn_1_1_N : N ;
  snoervling_nn_1_1_N : N ;
  snoeroejning_nn_1_1_N : N ;
  snoesmaeltning_nn_1_1_N : N ;
  snoetillgaang_nn_1_1_N : N ;
  snoevall_nn_1_1_N : N ;
  socialfoersaekring_nn_1_1_N : N ;
  socialfoervaltning_nn_1_1_N : N ;
  socialisering_nn_1_N : N ;
  sockerbildning_nn_1_N : N ;
  sockerbindning_nn_1_N : N ;
  sockerbit_nn_1_N : N ;
  sockerroersodling_nn_1_1_N : N ;
  sockertillverkning_nn_1_N : N ;
  solbelysning_nn_1_N : N ;
  solbestraalning_nn_1_1_N : N ;
  solbaergning_nn_1_1_N : N ;
  solcellsanlaeggning_nn_1_1_N : N ;
  soldag_nn_1_N : N ;
  soldathop_nn_1_N : N ;
  soldatutrustning_nn_1_N : N ;
  solgud_nn_1_N : N ;
  solhatt_nn_1_N : N ;
  solinstraalning_nn_1_1_N : N ;
  solklaenning_nn_1_1_N : N ;
  solnedgaang_nn_1_1_N : N ;
  solspraengning_nn_1_1_N : N ;
  solstraalning_nn_1_1_N : N ;
  soluppgaang_nn_1_1_N : N ;
  solvering_nn_1_N : N ;
  sommargotlaenning_nn_1_1_N : N ;
  sommarhatt_nn_1_N : N ;
  sommarklaenning_nn_1_1_N : N ;
  sommarvind_nn_1_N : N ;
  sommaraeng_nn_1_1_N : N ;
  sondering_nn_1_N : N ;
  sondmatning_nn_1_N : N ;
  sopbil_nn_1_N : N ;
  soppfoerpackning_nn_1_1_N : N ;
  sopptallrik_nn_1_N : N ;
  sopsaeck_nn_1_1_N : N ;
  sordinering_nn_1_N : N ;
  sorgedag_nn_1_N : N ;
  sortering_nn_1_N : N ;
  sotbildning_nn_1_N : N ;
  soteld_nn_1_N : N ;
  soulagering_nn_1_N : N ;
  souterrainvaaning_nn_1_1_N : N ;
  souterraengvaaning_nn_1_1_N : N ;
  sovjetisering_nn_1_N : N ;
  sovsal_nn_1_N : N ;
  sovstaellning_nn_1_1_N : N ;
  spackelkniv_nn_1_N : N ;
  spaljering_nn_1_N : N ;
  spallering_nn_1_N : N ;
  spaning_nn_1_N : N ;
  spankulering_nn_1_N : N ;
  spannmaalsskoerd_nn_1_1_N : N ;
  spatsering_nn_1_N : N ;
  specialbegaavning_nn_1_1_N : N ;
  specialbestaellning_nn_1_1_N : N ;
  specialdomstol_nn_1_N : N ;
  specialisering_nn_1_N : N ;
  specialmotivering_nn_1_N : N ;
  specialundervisning_nn_1_N : N ;
  specificering_nn_1_N : N ;
  speciminering_nn_1_N : N ;
  spegelfaektning_nn_1_1_N : N ;
  spegling_nn_1_N : N ;
  spekulering_nn_1_N : N ;
  spelning_nn_1_N : N ;
  spelomgaang_nn_1_1_N : N ;
  speloeppning_nn_1_1_N : N ;
  spenordning_nn_1_N : N ;
  spermabildning_nn_1_N : N ;
  spetsduk_nn_1_N : N ;
  spetsning_nn_1_N : N ;
  spikning_nn_1_N : N ;
  spillning_nn_1_N : N ;
  spindeltraad_nn_1_1_N : N ;
  spionering_nn_1_N : N ;
  spionflygning_nn_1_N : N ;
  spiselhaell_nn_1_1_N : N ;
  spiselkrok_nn_1_N : N ;
  spiselmur_nn_1_N : N ;
  spishaell_nn_1_1_N : N ;
  spiskrok_nn_1_N : N ;
  spisning_nn_1_N : N ;
  spjutkastning_nn_1_N : N ;
  spjaelgrind_nn_1_1_N : N ;
  spjaelkning_nn_1_1_N : N ;
  spjaelning_nn_1_1_N : N ;
  splitsning_nn_1_N : N ;
  splittring_nn_1_N : N ;
  spoliering_nn_1_N : N ;
  spolning_nn_1_N : N ;
  sponsring_nn_1_N : N ;
  spontning_nn_1_N : N ;
  sporrning_nn_1_N : N ;
  sportbil_nn_1_N : N ;
  sportdykning_nn_1_N : N ;
  sporthall_nn_1_N : N ;
  sportklubb_nn_1_N : N ;
  sprakning_nn_1_N : N ;
  sprickbildning_nn_1_N : N ;
  sprickning_nn_1_N : N ;
  spridarvagn_nn_1_N : N ;
  spridning_nn_1_N : N ;
  springning_nn_1_N : N ;
  sprinkleranlaeggning_nn_1_1_N : N ;
  spritning_nn_1_N : N ;
  sprittning_nn_1_N : N ;
  sprutavraettning_nn_1_1_N : N ;
  sprutlackering_nn_1_N : N ;
  sprutning_nn_1_N : N ;
  spraeckning_nn_1_1_N : N ;
  spraengladdning_nn_1_1_N : N ;
  spraengning_nn_1_1_N : N ;
  spraettning_nn_1_1_N : N ;
  spraakanvaendning_nn_1_1_N : N ;
  spraakbehandling_nn_1_1_N : N ;
  spraakfoerbistring_nn_1_1_N : N ;
  spraakinlaerning_nn_1_1_N : N ;
  spraakundervisning_nn_1_1_N : N ;
  spyboll_nn_1_N : N ;
  spaeckkorv_nn_1_1_N : N ;
  spaeckning_nn_1_1_N : N ;
  spaedning_nn_1_1_N : N ;
  spaekning_nn_1_1_N : N ;
  spaennarm_nn_1_1_N : N ;
  spaenning_nn_1_1_N : N ;
  spaenningsjustering_nn_1_1_N : N ;
  spaennram_nn_1_1_N : N ;
  spaentning_nn_1_1_N : N ;
  spaerrning_nn_1_1_N : N ;
  spaadom_nn_1_1_N : N ;
  spaakaering_nn_1_1_N : N ;
  spaankorg_nn_1_1_N : N ;
  spaansug_nn_1_1_N : N ;
  spaantning_nn_1_1_N : N ;
  spaarning_nn_1_1_N : N ;
  spaarsaekring_nn_1_1_N : N ;
  spaarvaeg_nn_1_1_N : N ;
  spoeslitning_nn_1_1_N : N ;
  squashboll_nn_1_N : N ;
  stabilisering_nn_1_N : N ;
  stackning_nn_1_N : N ;
  stadsmur_nn_1_N : N ;
  stadsplanering_nn_1_N : N ;
  stadsport_nn_1_N : N ;
  stadsskog_nn_1_N : N ;
  stafettloepning_nn_1_1_N : N ;
  staffering_nn_1_N : N ;
  stafflimaalning_nn_1_1_N : N ;
  stagnering_nn_1_N : N ;
  stagvaendning_nn_1_1_N : N ;
  stamhoevding_nn_1_1_N : N ;
  stamning_nn_1_N : N ;
  stampning_nn_1_N : N ;
  standardhoejning_nn_1_1_N : N ;
  standardisering_nn_1_N : N ;
  standardloesning_nn_1_1_N : N ;
  stansning_nn_1_N : N ;
  stapelavloepning_nn_1_1_N : N ;
  startpall_nn_1_N : N ;
  statering_nn_1_N : N ;
  stationering_nn_1_N : N ;
  statsbegravning_nn_1_N : N ;
  statsbildning_nn_1_N : N ;
  statsfoerfattning_nn_1_1_N : N ;
  statsfoervaltning_nn_1_1_N : N ;
  statsraadsberedning_nn_1_1_N : N ;
  statsraadsbil_nn_1_1_N : N ;
  statsraadsmiddag_nn_1_1_N : N ;
  statsvaelvning_nn_1_1_N : N ;
  statuering_nn_1_N : N ;
  stavning_nn_1_N : N ;
  stegpall_nn_1_N : N ;
  stegring_nn_1_N : N ;
  stegraeknartaevling_nn_1_1_N : N ;
  stekning_nn_1_N : N ;
  stelning_nn_1_N : N ;
  stenansamling_nn_1_N : N ;
  stenblick_nn_1_N : N ;
  stencilering_nn_1_N : N ;
  stenfaestning_nn_1_1_N : N ;
  stening_nn_1_N : N ;
  stenkastning_nn_1_N : N ;
  stenkolsbit_nn_1_N : N ;
  stenlaeggning_nn_1_1_N : N ;
  stenmur_nn_1_N : N ;
  stenografering_nn_1_N : N ;
  stensaettning_nn_1_1_N : N ;
  stenvaegg_nn_1_1_N : N ;
  stenaaldersgrav_nn_1_1_N : N ;
  stereoanlaeggning_nn_1_1_N : N ;
  stereofotografering_nn_1_N : N ;
  stereotypering_nn_1_N : N ;
  sterilisering_nn_1_N : N ;
  stickning_nn_1_N : N ;
  stickpropp_nn_1_N : N ;
  stickprovsundersoekning_nn_1_1_N : N ;
  sticksaag_nn_1_1_N : N ;
  stigarledning_nn_1_N : N ;
  stigmatisering_nn_1_N : N ;
  stigning_nn_1_N : N ;
  stilbrytning_nn_1_N : N ;
  stilisering_nn_1_N : N ;
  stilriktning_nn_1_N : N ;
  stiloevning_nn_1_1_N : N ;
  stimulering_nn_1_N : N ;
  stipendiering_nn_1_N : N ;
  stipulering_nn_1_N : N ;
  stjaelpning_nn_1_1_N : N ;
  stjaernbetaeckning_nn_1_1_N : N ;
  stjaernhop_nn_1_1_N : N ;
  stjaernkock_nn_1_1_N : N ;
  stjaernkoppling_nn_1_1_N : N ;
  stockbaat_nn_1_1_N : N ;
  stockeld_nn_1_N : N ;
  stockning_nn_1_N : N ;
  stoffering_nn_1_N : N ;
  stolgaang_nn_1_1_N : N ;
  stoltsering_nn_1_N : N ;
  stoppboll_nn_1_N : N ;
  stoppning_nn_1_N : N ;
  stoppskylt_nn_1_N : N ;
  stoppsvaeng_nn_1_1_N : N ;
  storbildskaerm_nn_1_1_N : N ;
  storcirkelsegling_nn_1_N : N ;
  storfoerpackning_nn_1_1_N : N ;
  storhandling_nn_1_N : N ;
  storkning_nn_1_N : N ;
  storlek_nn_1_N : N ;
  storleksordning_nn_1_N : N ;
  stormarskalk_nn_1_N : N ;
  stormavdelning_nn_1_N : N ;
  stormhatt_nn_1_N : N ;
  stormil_nn_1_N : N ;
  stormning_nn_1_N : N ;
  stormvarning_nn_1_N : N ;
  stormvind_nn_1_N : N ;
  storproviantering_nn_1_N : N ;
  storsatsning_nn_1_N : N ;
  storskog_nn_1_N : N ;
  storstaedning_nn_1_1_N : N ;
  straffdom_nn_1_N : N ;
  strafflag_nn_1_N : N ;
  strafflindring_nn_1_N : N ;
  stramning_nn_1_N : N ;
  strandning_nn_1_N : N ;
  strandsluttning_nn_1_N : N ;
  strandvall_nn_1_N : N ;
  strandaeng_nn_1_1_N : N ;
  strangulering_nn_1_N : N ;
  stratifiering_nn_1_N : N ;
  stridsformering_nn_1_N : N ;
  stridsgruppering_nn_1_N : N ;
  stridsledning_nn_1_N : N ;
  stridsmundering_nn_1_N : N ;
  stridsskjutning_nn_1_N : N ;
  stridsstaellning_nn_1_1_N : N ;
  stridsuppstaellning_nn_1_1_N : N ;
  stridsvagnsdrivning_nn_1_N : N ;
  strippklubb_nn_1_N : N ;
  strippning_nn_1_N : N ;
  strokebehandling_nn_1_N : N ;
  strontiumfoerening_nn_1_1_N : N ;
  strukturering_nn_1_N : N ;
  strukturfoeraendring_nn_1_1_N : N ;
  strukturomvandling_nn_1_N : N ;
  strukturrationalisering_nn_1_N : N ;
  strykning_nn_1_N : N ;
  stryktvaett_nn_1_1_N : N ;
  strypning_nn_1_N : N ;
  straeckning_nn_1_1_N : N ;
  straabassjukdom_nn_1_1_N : N ;
  straahatt_nn_1_1_N : N ;
  straalbehandling_nn_1_1_N : N ;
  straalkniv_nn_1_1_N : N ;
  straalkonservering_nn_1_1_N : N ;
  straalning_nn_1_1_N : N ;
  stroembrytarknapp_nn_1_1_N : N ;
  stroemfoertraengning_nn_1_1_N : N ;
  stroemkantring_nn_1_1_N : N ;
  stroemledning_nn_1_1_N : N ;
  stroemming_nn_1_1_N : N ;
  stroemning_nn_1_1_N : N ;
  stroemring_nn_1_1_N : N ;
  stubbkvarn_nn_1_N : N ;
  studering_nn_1_N : N ;
  studieorientering_nn_1_N : N ;
  studievaeg_nn_1_1_N : N ;
  studioinspelning_nn_1_N : N ;
  studsning_nn_1_N : N ;
  stugdoerr_nn_1_1_N : N ;
  stugknut_nn_1_N : N ;
  stukning_nn_1_N : N ;
  stupstock_nn_1_N : N ;
  stuvning_nn_1_N : N ;
  styckning_nn_1_N : N ;
  stympning_nn_1_N : N ;
  styrinraettning_nn_1_1_N : N ;
  styrketraening_nn_1_1_N : N ;
  styrning_nn_1_N : N ;
  styvning_nn_1_N : N ;
  staeckning_nn_1_1_N : N ;
  staeddag_nn_1_1_N : N ;
  staedning_nn_1_1_N : N ;
  staedvagn_nn_1_1_N : N ;
  staellning_nn_1_1_N : N ;
  staemlaepp_nn_1_1_N : N ;
  staemning_nn_1_1_N : N ;
  staempling_nn_1_1_N : N ;
  staengning_nn_1_1_N : N ;
  staenkskaerm_nn_1_1_N : N ;
  staalframstaellning_nn_1_1_N : N ;
  staallegering_nn_1_1_N : N ;
  staalram_nn_1_1_N : N ;
  staalring_nn_1_1_N : N ;
  staalroersstol_nn_1_1_N : N ;
  staalskoeld_nn_1_1_N : N ;
  staaltraad_nn_1_1_N : N ;
  staandkrok_nn_1_1_N : N ;
  staanggaang_nn_1_1_N : N ;
  staangkorv_nn_1_1_N : N ;
  staangning_nn_1_1_N : N ;
  staangstoertning_nn_1_1_N : N ;
  staankning_nn_1_1_N : N ;
  staauppfoerestaellning_nn_1_1_N : N ;
  stoedroestning_nn_1_1_N : N ;
  stoedundervisning_nn_1_1_N : N ;
  stoerning_nn_1_1_N : N ;
  stoerthjaelm_nn_1_1_N : N ;
  stoertning_nn_1_1_N : N ;
  stoevelknekt_nn_1_1_N : N ;
  sublimering_nn_1_N : N ;
  subordinering_nn_1_N : N ;
  subsidiering_nn_1_N : N ;
  subskribering_nn_1_N : N ;
  substantivering_nn_1_N : N ;
  substituering_nn_1_N : N ;
  subsumering_nn_1_N : N ;
  subtrahering_nn_1_N : N ;
  subventionering_nn_1_N : N ;
  succedering_nn_1_N : N ;
  successionsordning_nn_1_N : N ;
  suffigering_nn_1_N : N ;
  sufflering_nn_1_N : N ;
  suggerering_nn_1_N : N ;
  sugning_nn_1_N : N ;
  summering_nn_1_N : N ;
  sumpskog_nn_1_N : N ;
  superbil_nn_1_N : N ;
  superflopp_nn_1_N : N ;
  superfoerening_nn_1_1_N : N ;
  supergalaxhop_nn_1_N : N ;
  superhop_nn_1_N : N ;
  supering_nn_1_N : N ;
  superpamp_nn_1_N : N ;
  supersnut_nn_1_N : N ;
  supplering_nn_1_N : N ;
  supponering_nn_1_N : N ;
  supporterklubb_nn_1_N : N ;
  suppurering_nn_1_N : N ;
  supraledning_nn_1_N : N ;
  surbrunn_nn_1_N : N ;
  surdeg_nn_1_N : N ;
  surfning_nn_1_N : N ;
  surstek_nn_1_N : N ;
  surstroemming_nn_1_1_N : N ;
  susning_nn_1_N : N ;
  suspendering_nn_1_N : N ;
  suterraengvaaning_nn_1_1_N : N ;
  svackning_nn_1_N : N ;
  svalgaang_nn_1_1_N : N ;
  svallning_nn_1_N : N ;
  svampsjukdom_nn_1_N : N ;
  svampskog_nn_1_N : N ;
  svamptraad_nn_1_1_N : N ;
  svansfoering_nn_1_1_N : N ;
  svartlistning_nn_1_N : N ;
  svartmaalning_nn_1_1_N : N ;
  svarvning_nn_1_N : N ;
  svavelbindning_nn_1_N : N ;
  svavelfoerening_nn_1_1_N : N ;
  svavelomsaettning_nn_1_1_N : N ;
  svendom_nn_1_N : N ;
  svennelur_nn_1_N : N ;
  svepning_nn_1_N : N ;
  svetsning_nn_1_N : N ;
  svetsslang_nn_1_N : N ;
  svetstraad_nn_1_1_N : N ;
  svettflaeck_nn_1_1_N : N ;
  svettning_nn_1_N : N ;
  svimning_nn_1_N : N ;
  svinbesaettning_nn_1_1_N : N ;
  svinuppfoedning_nn_1_1_N : N ;
  svordom_nn_1_N : N ;
  svaellning_nn_1_1_N : N ;
  svaeltdoed_nn_1_1_N : N ;
  svaengarm_nn_1_1_N : N ;
  svaengdoerr_nn_1_1_N : N ;
  svaengning_nn_1_1_N : N ;
  svaevning_nn_1_1_N : N ;
  swingkung_nn_1_N : N ;
  sydlaenning_nn_1_1_N : N ;
  syftning_nn_1_N : N ;
  syfoerening_nn_1_1_N : N ;
  syltberedning_nn_1_N : N ;
  syltburk_nn_1_N : N ;
  syltloek_nn_1_1_N : N ;
  symbolhandling_nn_1_N : N ;
  symbolisering_nn_1_N : N ;
  symboltolkning_nn_1_N : N ;
  sympatisering_nn_1_N : N ;
  synkopering_nn_1_N : N ;
  synkronisering_nn_1_N : N ;
  synkrotronljusring_nn_1_N : N ;
  synsjukdom_nn_1_N : N ;
  syntetisering_nn_1_N : N ;
  synaal_nn_1_1_N : N ;
  syrenhaeck_nn_1_1_N : N ;
  syskonkaerlek_nn_1_1_N : N ;
  sysselsaettning_nn_1_1_N : N ;
  systematisering_nn_1_N : N ;
  sytraad_nn_1_1_N : N ;
  saeckloepning_nn_1_1_N : N ;
  saedestork_nn_1_1_N : N ;
  saedesuttoemning_nn_1_1_N : N ;
  saekerhetsanordning_nn_1_1_N : N ;
  saekerhetskrok_nn_1_1_N : N ;
  saekerhetsnaal_nn_1_1_N : N ;
  saekerhetssal_nn_1_1_N : N ;
  saekring_nn_1_1_N : N ;
  saendning_nn_1_1_N : N ;
  saenggrind_nn_1_1_N : N ;
  saenkhaav_nn_1_1_N : N ;
  saenkning_nn_1_1_N : N ;
  saenkvaag_nn_1_1_N : N ;
  saerbeskattning_nn_1_1_N : N ;
  saerkvark_nn_1_1_N : N ;
  saerlevandeutredning_nn_1_1_N : N ;
  saerstaellning_nn_1_1_N : N ;
  saetesbjudning_nn_1_1_N : N ;
  saettning_nn_1_1_N : N ;
  saevsparv_nn_1_1_N : N ;
  saagkedjefil_nn_1_1_N : N ;
  saagkvarn_nn_1_1_N : N ;
  saagning_nn_1_1_N : N ;
  saallning_nn_1_1_N : N ;
  saanglek_nn_1_1_N : N ;
  saangtaevling_nn_1_1_N : N ;
  saangoevning_nn_1_1_N : N ;
  saaskopp_nn_1_1_N : N ;
  saatering_nn_1_1_N : N ;
  saavering_nn_1_1_N : N ;
  soeckendag_nn_1_1_N : N ;
  soedermanlaenning_nn_1_1_N : N ;
  soekning_nn_1_1_N : N ;
  soelkorv_nn_1_1_N : N ;
  soemnstoerning_nn_1_1_N : N ;
  soendag_nn_1_1_N : N ;
  soendagskoerning_nn_1_1_N : N ;
  soenderdelning_nn_1_1_N : N ;
  soenderspraengning_nn_1_1_N : N ;
  soendring_nn_1_1_N : N ;
  soerlaenning_nn_1_1_N : N ;
  soermlaenning_nn_1_1_N : N ;
  soevning_nn_1_1_N : N ;
  tabellering_nn_1_N : N ;
  tabuering_nn_1_N : N ;
  tabulering_nn_1_N : N ;
  tackling_nn_1_N : N ;
  taffelvaag_nn_1_1_N : N ;
  taftbindning_nn_1_N : N ;
  taggtraad_nn_1_1_N : N ;
  tagning_nn_1_N : N ;
  tajming_nn_1_N : N ;
  takbrunn_nn_1_N : N ;
  takflaekt_nn_1_1_N : N ;
  takhuv_nn_1_N : N ;
  takresning_nn_1_N : N ;
  takrygg_nn_1_N : N ;
  takstol_nn_1_N : N ;
  taktbeteckning_nn_1_N : N ;
  taktering_nn_1_N : N ;
  taktikroestning_nn_1_1_N : N ;
  taktaeckning_nn_1_1_N : N ;
  takvaaning_nn_1_1_N : N ;
  tallrik_nn_1_N : N ;
  tallskog_nn_1_N : N ;
  talrubbning_nn_1_N : N ;
  taltratt_nn_1_N : N ;
  tamponering_nn_1_N : N ;
  tandborstmugg_nn_1_N : N ;
  tandborstning_nn_1_N : N ;
  tandemridning_nn_1_N : N ;
  tandfyllning_nn_1_N : N ;
  tandfaellning_nn_1_1_N : N ;
  tandlagning_nn_1_N : N ;
  tandlossning_nn_1_N : N ;
  tandlaekarskylt_nn_1_1_N : N ;
  tandlaekarstol_nn_1_1_N : N ;
  tandlaekarundersoekning_nn_1_1_N : N ;
  tandning_nn_1_N : N ;
  tandreglering_nn_1_N : N ;
  tandsprickning_nn_1_N : N ;
  tandstaellning_nn_1_1_N : N ;
  tandtraad_nn_1_1_N : N ;
  tanduppsaettning_nn_1_1_N : N ;
  tandutdragning_nn_1_N : N ;
  tandvall_nn_1_N : N ;
  tandvaardsfoersaekring_nn_1_1_N : N ;
  tandoemsning_nn_1_1_N : N ;
  tangering_nn_1_N : N ;
  tankbil_nn_1_N : N ;
  tankebollning_nn_1_N : N ;
  tankegaang_nn_1_1_N : N ;
  tankelag_nn_1_N : N ;
  tankelek_nn_1_N : N ;
  tankelaesning_nn_1_1_N : N ;
  tanketraad_nn_1_1_N : N ;
  tankeoeverfoering_nn_1_1_N : N ;
  tankeoevning_nn_1_1_N : N ;
  tankning_nn_1_N : N ;
  tankvagn_nn_1_N : N ;
  tapetdoerr_nn_1_1_N : N ;
  tapetsering_nn_1_N : N ;
  tappning_nn_1_N : N ;
  tarering_nn_1_N : N ;
  tariffering_nn_1_N : N ;
  tarmfoertraengning_nn_1_1_N : N ;
  tarmskoeljning_nn_1_1_N : N ;
  taskmoert_nn_1_1_N : N ;
  tatuering_nn_1_N : N ;
  taxering_nn_1_N : N ;
  teaterfoerestaellning_nn_1_1_N : N ;
  teaterviskning_nn_1_N : N ;
  tebjudning_nn_1_N : N ;
  teckenfoerklaring_nn_1_1_N : N ;
  teckengivning_nn_1_N : N ;
  teckning_nn_1_N : N ;
  teddybjoern_nn_1_1_N : N ;
  tedrickning_nn_1_N : N ;
  tegelmur_nn_1_N : N ;
  tegelugn_nn_1_N : N ;
  tegelvaegg_nn_1_1_N : N ;
  tegploejning_nn_1_1_N : N ;
  tehuv_nn_1_N : N ;
  teknifiering_nn_1_N : N ;
  teknikutveckling_nn_1_N : N ;
  teknikoeverfoering_nn_1_1_N : N ;
  tekning_nn_1_N : N ;
  telefonavlyssning_nn_1_N : N ;
  telefonering_nn_1_N : N ;
  telefonledning_nn_1_N : N ;
  telefonpaaringning_nn_1_1_N : N ;
  telefonsladd_nn_1_N : N ;
  telefontraad_nn_1_1_N : N ;
  telefonvaeckning_nn_1_1_N : N ;
  telegrafering_nn_1_N : N ;
  telegrafutrustning_nn_1_N : N ;
  televisering_nn_1_N : N ;
  telning_nn_1_N : N ;
  temadag_nn_1_N : N ;
  tempelgaard_nn_1_1_N : N ;
  temperaturfoerdelning_nn_1_1_N : N ;
  temperaturfoeraendring_nn_1_1_N : N ;
  temperaturhoejning_nn_1_1_N : N ;
  temperaturstraalning_nn_1_1_N : N ;
  temperatursvaengning_nn_1_1_N : N ;
  temperatursaenkning_nn_1_1_N : N ;
  temperaturvaexling_nn_1_1_N : N ;
  temperering_nn_2_N : N ;
  tempering_nn_1_N : N ;
  tempobeteckning_nn_1_N : N ;
  tempusvaexling_nn_1_1_N : N ;
  tennisboll_nn_1_N : N ;
  tennisframgaang_nn_1_1_N : N ;
  tentering_nn_1_N : N ;
  teoretisering_nn_1_N : N ;
  teoribildning_nn_1_N : N ;
  terrassering_nn_1_N : N ;
  terrorbombning_nn_1_N : N ;
  terrorhotbedoemning_nn_1_1_N : N ;
  terrorisering_nn_1_N : N ;
  terroristlagstiftning_nn_1_N : N ;
  terrorvarning_nn_1_N : N ;
  terraengbil_nn_1_1_N : N ;
  terraengkoerning_nn_1_1_N : N ;
  terraengloepning_nn_1_1_N : N ;
  tesaurering_nn_1_N : N ;
  tesked_nn_1_N : N ;
  testamentering_nn_1_N : N ;
  testflygning_nn_1_N : N ;
  tevesaendning_nn_1_1_N : N ;
  teveoevervakning_nn_1_1_N : N ;
  textbearbetning_nn_1_N : N ;
  textbehandling_nn_1_N : N ;
  textning_nn_1_N : N ;
  texttolkning_nn_1_N : N ;
  tideraekning_nn_1_1_N : N ;
  tidjordsforskning_nn_1_N : N ;
  tidmaetning_nn_1_1_N : N ;
  tidning_nn_1_N : N ;
  tidningsbunt_nn_1_N : N ;
  tidningsdrottning_nn_1_N : N ;
  tidningskung_nn_1_N : N ;
  tidningsutbaerning_nn_1_1_N : N ;
  tidningsutgivning_nn_1_N : N ;
  tidsbefraktning_nn_1_N : N ;
  tidsberaekning_nn_1_1_N : N ;
  tidsbesparing_nn_1_N : N ;
  tidsbestaellning_nn_1_1_N : N ;
  tidsbestaemning_nn_1_1_N : N ;
  tidsdelning_nn_1_N : N ;
  tidsfoerskjutning_nn_1_1_N : N ;
  tidsomstaellning_nn_1_1_N : N ;
  tidspil_nn_1_N : N ;
  tidsriktning_nn_1_N : N ;
  tidsskildring_nn_1_N : N ;
  tidsuppfattning_nn_1_N : N ;
  tidtagning_nn_1_N : N ;
  tigersaag_nn_1_1_N : N ;
  tiggarmunk_nn_1_N : N ;
  tiggarstav_nn_1_N : N ;
  tillagning_nn_1_N : N ;
  tillbakabildning_nn_1_N : N ;
  tillbakablick_nn_1_N : N ;
  tillbakavisning_nn_1_N : N ;
  tillblandning_nn_1_N : N ;
  tilldelning_nn_1_N : N ;
  tillfartsvaeg_nn_1_1_N : N ;
  tillfogning_nn_1_N : N ;
  tillfrysning_nn_1_N : N ;
  tillfaangatagning_nn_1_1_N : N ;
  tillfoerlitlighetstaevling_nn_1_1_N : N ;
  tillgaang_nn_1_1_N : N ;
  tilljaemning_nn_1_1_N : N ;
  tillknaeppning_nn_1_1_N : N ;
  tillmakning_nn_1_N : N ;
  tillnyktring_nn_1_N : N ;
  tillpassning_nn_1_N : N ;
  tillplattning_nn_1_N : N ;
  tillraettavisning_nn_1_1_N : N ;
  tillskapning_nn_1_N : N ;
  tillskjutning_nn_1_N : N ;
  tillskaerarkniv_nn_1_1_N : N ;
  tillskaerning_nn_1_1_N : N ;
  tillslagning_nn_1_N : N ;
  tillslutning_nn_1_N : N ;
  tillspetsning_nn_1_N : N ;
  tillspillogivning_nn_1_N : N ;
  tillstroemning_nn_1_1_N : N ;
  tillstaellning_nn_1_1_N : N ;
  tillstaengning_nn_1_1_N : N ;
  tillsaegning_nn_1_1_N : N ;
  tillsaettning_nn_1_1_N : N ;
  tilltvaalning_nn_1_1_N : N ;
  tilltaeppning_nn_1_1_N : N ;
  tillverkning_nn_1_N : N ;
  tillverkningsutrustning_nn_1_N : N ;
  tillvaenjning_nn_1_1_N : N ;
  tillyxning_nn_1_N : N ;
  tillaempning_nn_1_1_N : N ;
  tilloekning_nn_1_1_N : N ;
  tilloenskning_nn_1_1_N : N ;
  timmeravverkning_nn_1_N : N ;
  timmerblaedning_nn_1_1_N : N ;
  timmerdoning_nn_1_N : N ;
  timmerflottning_nn_1_N : N ;
  timmerstock_nn_1_N : N ;
  timpenning_nn_1_N : N ;
  tingsmeritering_nn_1_N : N ;
  tingssal_nn_1_N : N ;
  tioaaring_nn_1_1_N : N ;
  tiooering_nn_1_1_N : N ;
  tippvagn_nn_1_N : N ;
  tipstaevling_nn_1_1_N : N ;
  tisdag_nn_1_N : N ;
  titanskruv_nn_1_N : N ;
  titelbortlaeggning_nn_1_1_N : N ;
  titrering_nn_1_N : N ;
  tittarflopp_nn_1_N : N ;
  tittarframgaang_nn_1_1_N : N ;
  tittartaevling_nn_1_1_N : N ;
  titulering_nn_1_N : N ;
  tjocklek_nn_1_N : N ;
  tjugoettaaring_nn_1_1_N : N ;
  tjugofemaaring_nn_1_1_N : N ;
  tjugofemoering_nn_1_1_N : N ;
  tjugofyraaaring_nn_1_1_N : N ;
  tjugokilossaeck_nn_1_1_N : N ;
  tjugotreaaring_nn_1_1_N : N ;
  tjugotvaaaaring_nn_1_1_N : N ;
  tjugoaaring_nn_1_1_N : N ;
  tjugufemaaring_nn_1_1_N : N ;
  tjugufemoering_nn_1_1_N : N ;
  tjuguaaring_nn_1_1_N : N ;
  tjurfaektning_nn_1_1_N : N ;
  tjurrusning_nn_1_N : N ;
  tjusarlock_nn_1_N : N ;
  tjusning_nn_1_N : N ;
  tjutning_nn_1_N : N ;
  tjuvkikning_nn_1_N : N ;
  tjuvtankning_nn_1_N : N ;
  tjyvkikning_nn_1_N : N ;
  tjyvtankning_nn_1_N : N ;
  tjaelknoel_nn_1_1_N : N ;
  tjaellossning_nn_1_1_N : N ;
  tjaenstebil_nn_1_1_N : N ;
  tjaenstefoerraettning_nn_1_1_N : N ;
  tjaenstestaellning_nn_1_1_N : N ;
  tjaenstgoering_nn_1_1_N : N ;
  tjaerframstaellning_nn_1_1_N : N ;
  toalettring_nn_1_N : N ;
  toalettstol_nn_1_N : N ;
  tobaksodling_nn_1_N : N ;
  tolerering_nn_1_N : N ;
  tolkning_nn_1_N : N ;
  tolvhundratalsmunk_nn_1_N : N ;
  tolvaaring_nn_1_1_N : N ;
  tomatodling_nn_1_N : N ;
  tomgaangsfoerbrukning_nn_1_1_N : N ;
  tomtning_nn_1_N : N ;
  tonbildning_nn_1_N : N ;
  tonetsning_nn_1_N : N ;
  tongaang_nn_1_1_N : N ;
  toning_nn_1_N : N ;
  tonmaalning_nn_1_1_N : N ;
  tonsaettning_nn_1_1_N : N ;
  tontraeffning_nn_1_1_N : N ;
  tonaaring_nn_1_1_N : N ;
  toppbefattning_nn_1_N : N ;
  toppbegaavning_nn_1_1_N : N ;
  toppfoerstaerkning_nn_1_1_N : N ;
  topphuggning_nn_1_N : N ;
  toppkvark_nn_1_N : N ;
  toppning_nn_1_N : N ;
  toppridning_nn_1_N : N ;
  tordering_nn_1_N : N ;
  torgdag_nn_1_N : N ;
  torkduk_nn_1_N : N ;
  torkflaeck_nn_1_1_N : N ;
  torkhuv_nn_1_N : N ;
  torkning_nn_1_N : N ;
  torkugn_nn_1_N : N ;
  tornavslutning_nn_1_N : N ;
  tornering_nn_1_N : N ;
  torpedering_nn_1_N : N ;
  torpedoevning_nn_1_1_N : N ;
  torrboll_nn_1_N : N ;
  torrdestillering_nn_1_N : N ;
  torrlaeggning_nn_1_1_N : N ;
  torrschamponering_nn_1_N : N ;
  torrskaffning_nn_1_N : N ;
  torsdag_nn_1_N : N ;
  torsdagstidning_nn_1_N : N ;
  torsionsfjaedring_nn_1_1_N : N ;
  tortering_nn_1_N : N ;
  torvgrav_nn_1_N : N ;
  torvutvinning_nn_1_N : N ;
  totalfinansiering_nn_1_N : N ;
  totalhaverering_nn_1_N : N ;
  totalkvaddning_nn_1_N : N ;
  totalsabbning_nn_1_N : N ;
  touchering_nn_1_N : N ;
  toupering_nn_1_N : N ;
  tradering_nn_1_N : N ;
  trafikering_nn_1_N : N ;
  trafikfoersaekring_nn_1_1_N : N ;
  trafikledning_nn_1_N : N ;
  trafikreglering_nn_1_N : N ;
  trafikstockning_nn_1_N : N ;
  trafikvarning_nn_1_N : N ;
  trakassering_nn_1_N : N ;
  traktblaedning_nn_1_1_N : N ;
  traktering_nn_1_N : N ;
  traktorslaepvagn_nn_1_1_N : N ;
  trampbaat_nn_1_1_N : N ;
  trampning_nn_1_N : N ;
  transferering_nn_1_N : N ;
  transformering_nn_1_N : N ;
  transitering_nn_1_N : N ;
  transkribering_nn_1_N : N ;
  translitterering_nn_1_N : N ;
  transmittering_nn_1_N : N ;
  transmutering_nn_1_N : N ;
  transpirering_nn_1_N : N ;
  transplantering_nn_1_N : N ;
  transponering_nn_1_N : N ;
  transportanordning_nn_1_N : N ;
  transportering_nn_1_N : N ;
  transportvagn_nn_1_N : N ;
  transumering_nn_1_N : N ;
  trappgrind_nn_1_N : N ;
  trapphall_nn_1_N : N ;
  trappuppgaang_nn_1_1_N : N ;
  trassering_nn_1_N : N ;
  travestering_nn_1_N : N ;
  travtaevling_nn_1_1_N : N ;
  tredelning_nn_1_N : N ;
  tredjegaangstillsaettning_nn_1_1_N : N ;
  tredskodom_nn_1_N : N ;
  trehoerning_nn_1_1_N : N ;
  tremiljarderssatsning_nn_1_N : N ;
  tremulering_nn_1_N : N ;
  trepanering_nn_1_N : N ;
  trepartiregering_nn_1_N : N ;
  trerading_nn_1_N : N ;
  treraettersmiddag_nn_1_1_N : N ;
  trettonaaring_nn_1_1_N : N ;
  treaaring_nn_1_1_N : N ;
  triangelkoppling_nn_1_N : N ;
  triangelmaetning_nn_1_1_N : N ;
  triangulering_nn_1_N : N ;
  triering_nn_1_N : N ;
  triggning_nn_1_N : N ;
  trimmertraad_nn_1_1_N : N ;
  trimning_nn_1_N : N ;
  trippelkrock_nn_1_N : N ;
  triumfering_nn_1_N : N ;
  triumfvagn_nn_1_N : N ;
  trivialisering_nn_1_N : N ;
  trolldeg_nn_1_N : N ;
  trolldom_nn_1_N : N ;
  trolovning_nn_1_N : N ;
  trolovningsring_nn_1_N : N ;
  tronbestigning_nn_1_N : N ;
  tronfoeljdsordning_nn_1_1_N : N ;
  tronsal_nn_1_N : N ;
  tropikhjaelm_nn_1_1_N : N ;
  trosfoerestaellning_nn_1_1_N : N ;
  trosinriktning_nn_1_N : N ;
  trossfyllning_nn_1_N : N ;
  trossning_nn_1_N : N ;
  trosuppfattning_nn_1_N : N ;
  trottoarservering_nn_1_N : N ;
  trubadurdiktning_nn_1_N : N ;
  trugning_nn_1_N : N ;
  trumpetstoet_nn_1_1_N : N ;
  trumstock_nn_1_N : N ;
  truppfoerflyttning_nn_1_1_N : N ;
  truppfoering_nn_1_1_N : N ;
  truppfoerstaerkning_nn_1_1_N : N ;
  tryckform_nn_1_N : N ;
  tryckimpregnering_nn_1_N : N ;
  tryckknapp_nn_1_N : N ;
  tryckluftsavlaesning_nn_1_1_N : N ;
  tryckluftsslang_nn_1_N : N ;
  tryckning_nn_1_N : N ;
  tryckreducering_nn_1_N : N ;
  trycksmoerjning_nn_1_1_N : N ;
  tryckoekning_nn_1_1_N : N ;
  tryffelhund_nn_1_N : N ;
  tryffering_nn_1_N : N ;
  trygghetsfoersaekring_nn_1_1_N : N ;
  traebelaeggning_nn_1_1_N : N ;
  traebit_nn_1_1_N : N ;
  traeckning_nn_1_1_N : N ;
  traedfaellning_nn_1_1_N : N ;
  traedgaardsanlaeggning_nn_1_1_N : N ;
  traedgaardsbelysning_nn_1_1_N : N ;
  traedgaardsdamm_nn_1_1_N : N ;
  traedgaardsgaang_nn_1_1_N : N ;
  traedgaardsodling_nn_1_1_N : N ;
  traedgaardsslang_nn_1_1_N : N ;
  traedning_nn_1_1_N : N ;
  traednaal_nn_1_1_N : N ;
  traedplantering_nn_1_1_N : N ;
  traedplanteringsdag_nn_1_1_N : N ;
  traeffning_nn_1_1_N : N ;
  traefil_nn_1_1_N : N ;
  traeform_nn_1_1_N : N ;
  traefoersockring_nn_1_1_N : N ;
  traefoeraedling_nn_1_1_N : N ;
  traeklamp_nn_1_1_N : N ;
  traekaak_nn_1_1_N : N ;
  traeldom_nn_1_1_N : N ;
  traengning_nn_1_1_N : N ;
  traening_nn_1_1_N : N ;
  traeport_nn_1_1_N : N ;
  traeram_nn_1_1_N : N ;
  traesked_nn_1_1_N : N ;
  traeskruv_nn_1_1_N : N ;
  traeslup_nn_1_1_N : N ;
  traesnittsstock_nn_1_1_N : N ;
  traackeltraad_nn_1_1_N : N ;
  traackling_nn_1_1_N : N ;
  traadbindning_nn_1_1_N : N ;
  traaddragning_nn_1_1_N : N ;
  traadknapp_nn_1_1_N : N ;
  traakning_nn_1_1_N : N ;
  troeghetsnavigering_nn_1_1_N : N ;
  tsunamivarning_nn_1_N : N ;
  tubbning_nn_1_N : N ;
  tudelning_nn_1_N : N ;
  tuggummibit_nn_1_N : N ;
  tullag_nn_1_N : N ;
  tullbesiktning_nn_1_N : N ;
  tullsnok_nn_1_N : N ;
  tulpanloek_nn_1_1_N : N ;
  tulpanaeng_nn_1_1_N : N ;
  tumstock_nn_1_N : N ;
  tunnelbanebombning_nn_1_N : N ;
  tupering_nn_1_N : N ;
  tuppfaektning_nn_1_1_N : N ;
  turistfoerening_nn_1_1_N : N ;
  turistnaering_nn_1_1_N : N ;
  turnering_nn_1_N : N ;
  turordning_nn_1_N : N ;
  tuschering_nn_1_N : N ;
  tuschteckning_nn_1_N : N ;
  tussning_nn_1_N : N ;
  tv_saendning_nn_1_1_N : N ;
  tvagning_nn_1_N : N ;
  tvivelshaallning_nn_1_1_N : N ;
  tvaervaendning_nn_1_1_N : N ;
  tvaettbjoern_nn_1_1_N : N ;
  tvaetthall_nn_1_1_N : N ;
  tvaettinraettning_nn_1_1_N : N ;
  tvaettkorg_nn_1_1_N : N ;
  tvaettsvamp_nn_1_1_N : N ;
  tvaangsfoerestaellning_nn_1_1_N : N ;
  tvaangsintagning_nn_1_1_N : N ;
  tvaangskommendering_nn_1_1_N : N ;
  tvaangslag_nn_1_1_N : N ;
  tvaangsrekrytering_nn_1_1_N : N ;
  tvaarading_nn_1_1_N : N ;
  tvaaskaftsbindning_nn_1_1_N : N ;
  tvaaaaring_nn_1_1_N : N ;
  tvaaoering_nn_1_1_N : N ;
  tydlighetskommatering_nn_1_N : N ;
  tydning_nn_1_N : N ;
  tygboll_nn_1_N : N ;
  tygbunt_nn_1_N : N ;
  tyglapp_nn_1_N : N ;
  tyngdkraftsstoerning_nn_1_1_N : N ;
  tyngdlyftning_nn_1_N : N ;
  typbesiktning_nn_1_N : N ;
  typifiering_nn_1_N : N ;
  typisering_nn_1_N : N ;
  tyrannisering_nn_1_N : N ;
  tyrolerhatt_nn_1_N : N ;
  taeckdikning_nn_1_1_N : N ;
  taeckning_nn_1_1_N : N ;
  taeljkniv_nn_1_1_N : N ;
  taeltstol_nn_1_1_N : N ;
  taemjning_nn_1_1_N : N ;
  taendhatt_nn_1_1_N : N ;
  taendning_nn_1_1_N : N ;
  taenjning_nn_1_1_N : N ;
  taerning_nn_1_1_N : N ;
  taetning_nn_1_1_N : N ;
  taetplacering_nn_1_1_N : N ;
  taevling_nn_1_1_N : N ;
  taevlingsbil_nn_1_1_N : N ;
  taevlingsledning_nn_1_1_N : N ;
  taevlingslek_nn_1_1_N : N ;
  taevlingssegling_nn_1_1_N : N ;
  taagavgaang_nn_1_1_N : N ;
  taagkrock_nn_1_1_N : N ;
  taagordning_nn_1_1_N : N ;
  taagurspaarning_nn_1_1_N : N ;
  taahaevning_nn_1_1_N : N ;
  toejning_nn_1_1_N : N ;
  toemning_nn_1_1_N : N ;
  toemring_nn_1_1_N : N ;
  uggleboll_nn_1_N : N ;
  ugnshaell_nn_1_1_N : N ;
  ugnsinfodring_nn_1_N : N ;
  ugnskolning_nn_1_N : N ;
  ultrarapidfotografering_nn_1_N : N ;
  undanlaeggning_nn_1_1_N : N ;
  undanroejning_nn_1_1_N : N ;
  undanskuffning_nn_1_N : N ;
  undansnillning_nn_1_N : N ;
  undantagslag_nn_1_N : N ;
  undantagsstaellning_nn_1_1_N : N ;
  undantraengning_nn_1_1_N : N ;
  undanvindsvaendning_nn_1_1_N : N ;
  underanvaendning_nn_1_1_N : N ;
  underavdelning_nn_1_N : N ;
  underbalansering_nn_1_N : N ;
  underbefolkning_nn_1_N : N ;
  underbefaelsutbildning_nn_1_1_N : N ;
  underbelaeggning_nn_1_1_N : N ;
  underbemanning_nn_1_N : N ;
  underbetalning_nn_1_N : N ;
  underbjudning_nn_1_N : N ;
  underdimensionering_nn_1_N : N ;
  underexponering_nn_1_N : N ;
  undergraevning_nn_1_1_N : N ;
  undergaang_nn_1_1_N : N ;
  undergaangsstaemning_nn_1_1_N : N ;
  underhandling_nn_1_N : N ;
  underhaallning_nn_1_1_N : N ;
  underjaesning_nn_1_1_N : N ;
  underkjol_nn_1_N : N ;
  underklaenning_nn_1_1_N : N ;
  underkuvning_nn_1_N : N ;
  underlaepp_nn_1_1_N : N ;
  underlaettning_nn_1_1_N : N ;
  undermedicinering_nn_1_N : N ;
  undermening_nn_1_N : N ;
  underminering_nn_1_N : N ;
  undermaalning_nn_1_1_N : N ;
  undernaering_nn_1_1_N : N ;
  underordning_nn_1_N : N ;
  underredsbehandling_nn_1_N : N ;
  underskattning_nn_1_N : N ;
  understrykning_nn_1_N : N ;
  understaellning_nn_1_1_N : N ;
  understoedsfoerening_nn_1_1_N : N ;
  understoet_nn_1_1_N : N ;
  undersysselsaettning_nn_1_1_N : N ;
  undersaeljning_nn_1_1_N : N ;
  undersoekning_nn_1_1_N : N ;
  undertaxering_nn_1_N : N ;
  undertraad_nn_1_1_N : N ;
  underutveckling_nn_1_N : N ;
  undervattensbaat_nn_1_1_N : N ;
  undervisning_nn_1_N : N ;
  undervaerdering_nn_1_1_N : N ;
  undervaaning_nn_1_1_N : N ;
  undring_nn_1_N : N ;
  undskyllning_nn_1_N : N ;
  undsaettning_nn_1_1_N : N ;
  undulering_nn_1_N : N ;
  ungdom_nn_1_N : N ;
  ungdomsfoermedling_nn_1_1_N : N ;
  ungdomskaerlek_nn_1_1_N : N ;
  ungskog_nn_1_N : N ;
  unifiering_nn_1_N : N ;
  uniformering_nn_1_N : N ;
  uniformsbeteckning_nn_1_N : N ;
  uniformshatt_nn_1_N : N ;
  uniformsknapp_nn_1_N : N ;
  unionsupploesning_nn_1_1_N : N ;
  universalbegaavning_nn_1_1_N : N ;
  universalkniv_nn_1_N : N ;
  universalknut_nn_1_N : N ;
  universitetsutbildning_nn_1_N : N ;
  upparbetning_nn_1_N : N ;
  uppassning_nn_1_N : N ;
  uppbackning_nn_1_N : N ;
  uppbindning_nn_1_N : N ;
  uppbjudning_nn_1_N : N ;
  uppblandning_nn_1_N : N ;
  uppblomstring_nn_1_N : N ;
  uppblaasning_nn_1_1_N : N ;
  uppbringning_nn_1_N : N ;
  uppbrottsstaemning_nn_1_1_N : N ;
  uppbrusning_nn_1_N : N ;
  uppboerdsdag_nn_1_1_N : N ;
  uppdatering_nn_1_N : N ;
  uppdelning_nn_1_N : N ;
  uppdragsforskning_nn_1_N : N ;
  uppdrivning_nn_1_N : N ;
  uppdukning_nn_1_N : N ;
  uppdyrkning_nn_1_N : N ;
  uppfartsvaeg_nn_1_1_N : N ;
  uppfattning_nn_1_N : N ;
  uppfinning_nn_1_N : N ;
  uppfordring_nn_1_N : N ;
  uppfostring_nn_1_N : N ;
  uppfriskning_nn_1_N : N ;
  uppfoedning_nn_1_1_N : N ;
  uppfoeljning_nn_1_1_N : N ;
  uppgrundning_nn_1_N : N ;
  uppgaang_nn_1_1_N : N ;
  upphandling_nn_1_N : N ;
  upphetsning_nn_1_N : N ;
  upphettning_nn_1_N : N ;
  upphostning_nn_1_N : N ;
  upphottning_nn_1_N : N ;
  upphaemtning_nn_1_1_N : N ;
  upphaengning_nn_1_1_N : N ;
  upphaengningskrok_nn_1_1_N : N ;
  upphoejning_nn_1_1_N : N ;
  uppjustering_nn_1_N : N ;
  uppkastning_nn_1_N : N ;
  uppklarning_nn_1_N : N ;
  uppkolning_nn_1_N : N ;
  uppkomling_nn_1_N : N ;
  uppkvark_nn_1_N : N ;
  uppkoerning_nn_1_1_N : N ;
  uppkoersvaeg_nn_1_1_N : N ;
  uppladdning_nn_1_N : N ;
  upplevelselaesning_nn_1_1_N : N ;
  upplevelsemaximering_nn_1_N : N ;
  upplevelsevandring_nn_1_N : N ;
  upplivning_nn_1_N : N ;
  uppluckring_nn_1_N : N ;
  upplysning_nn_1_N : N ;
  upplaeggning_nn_1_1_N : N ;
  upplaenning_nn_1_1_N : N ;
  upplaesning_nn_1_1_N : N ;
  upplaexning_nn_1_1_N : N ;
  upplaaning_nn_1_1_N : N ;
  upploesning_nn_1_1_N : N ;
  uppmaning_nn_1_N : N ;
  uppmjukning_nn_1_N : N ;
  uppmuntring_nn_1_N : N ;
  uppmaetning_nn_1_1_N : N ;
  uppoffring_nn_1_N : N ;
  uppreklamering_nn_1_N : N ;
  upprensning_nn_1_N : N ;
  upprepning_nn_1_N : N ;
  uppresning_nn_1_N : N ;
  uppretning_nn_1_N : N ;
  uppringning_nn_1_N : N ;
  upprinning_nn_1_N : N ;
  upprivning_nn_1_N : N ;
  upprullning_nn_1_N : N ;
  upprustning_nn_1_N : N ;
  uppryckning_nn_1_N : N ;
  uppraekning_nn_1_1_N : N ;
  uppraenning_nn_1_1_N : N ;
  upproejning_nn_1_1_N : N ;
  uppsamling_nn_1_N : N ;
  uppsamlingssaeck_nn_1_1_N : N ;
  uppsittning_nn_1_N : N ;
  uppsjungning_nn_1_N : N ;
  uppskalning_nn_1_N : N ;
  uppskattning_nn_1_N : N ;
  uppskjutning_nn_1_N : N ;
  uppskrivning_nn_1_N : N ;
  uppslukning_nn_1_N : N ;
  uppslutning_nn_1_N : N ;
  uppspaltning_nn_1_N : N ;
  uppspelning_nn_1_N : N ;
  uppsplittring_nn_1_N : N ;
  uppspaerrning_nn_1_1_N : N ;
  uppstigning_nn_1_N : N ;
  uppstoppning_nn_1_N : N ;
  uppstramning_nn_1_N : N ;
  uppstraeckning_nn_1_1_N : N ;
  uppstaellning_nn_1_1_N : N ;
  uppstoetning_nn_1_1_N : N ;
  uppsugning_nn_1_N : N ;
  uppsummering_nn_1_N : N ;
  uppsaegning_nn_1_1_N : N ;
  uppsaegningsraekning_nn_1_1_N : N ;
  uppsaettning_nn_1_1_N : N ;
  uppsoekning_nn_1_1_N : N ;
  upptagning_nn_1_N : N ;
  upptaxering_nn_1_N : N ;
  uppteckning_nn_1_N : N ;
  upptining_nn_1_N : N ;
  upptrampning_nn_1_N : N ;
  upptrappning_nn_1_N : N ;
  upptryckning_nn_1_N : N ;
  upptraedning_nn_1_1_N : N ;
  uppvaktning_nn_1_N : N ;
  uppvigling_nn_1_N : N ;
  uppvind_nn_1_N : N ;
  uppvisning_nn_1_N : N ;
  uppvaegning_nn_1_1_N : N ;
  uppvaerdering_nn_1_1_N : N ;
  uppvaermning_nn_1_1_N : N ;
  uppoevning_nn_1_1_N : N ;
  uralstring_nn_1_N : N ;
  uranbrytning_nn_1_N : N ;
  uranutvinning_nn_1_N : N ;
  urartning_nn_1_N : N ;
  urbanisering_nn_1_N : N ;
  urbefolkning_nn_1_N : N ;
  urbraenning_nn_1_1_N : N ;
  urgering_nn_1_N : N ;
  urgroepning_nn_1_1_N : N ;
  urholkning_nn_1_N : N ;
  urinavsoendring_nn_1_1_N : N ;
  urinering_nn_1_N : N ;
  urinfoergiftning_nn_1_1_N : N ;
  urinstockning_nn_1_N : N ;
  urintraengning_nn_1_1_N : N ;
  urinvaeg_nn_1_1_N : N ;
  urkristendom_nn_1_N : N ;
  urkundsforskning_nn_1_N : N ;
  urkundsfoerfalskning_nn_1_1_N : N ;
  urladdning_nn_1_N : N ;
  urlakning_nn_1_N : N ;
  urlastning_nn_1_N : N ;
  urledvrickning_nn_1_N : N ;
  urledvridning_nn_1_N : N ;
  urnegrav_nn_1_N : N ;
  urngrav_nn_1_N : N ;
  urnsaettning_nn_1_1_N : N ;
  urogenitaloeppning_nn_1_1_N : N ;
  urringning_nn_1_N : N ;
  urskiljning_nn_1_N : N ;
  urskillning_nn_1_N : N ;
  urskog_nn_1_N : N ;
  ursprungsbefolkning_nn_1_N : N ;
  ursprungsbeteckning_nn_1_N : N ;
  urspaarning_nn_1_1_N : N ;
  urtappning_nn_1_N : N ;
  urvalsundersoekning_nn_1_1_N : N ;
  usb_sladd_nn_1_N : N ;
  usurpering_nn_1_N : N ;
  utackordering_nn_1_N : N ;
  utandning_nn_1_N : N ;
  utannonsering_nn_1_N : N ;
  utanordning_nn_1_N : N ;
  utarbetning_nn_1_N : N ;
  utarrendering_nn_1_N : N ;
  utbalansering_nn_1_N : N ;
  utbasunering_nn_1_N : N ;
  utbasuning_nn_1_N : N ;
  utbetalning_nn_1_N : N ;
  utbildning_nn_1_N : N ;
  utbildningsvaeg_nn_1_1_N : N ;
  utblick_nn_1_N : N ;
  utblaasning_nn_1_1_N : N ;
  utbredning_nn_1_N : N ;
  utbrodering_nn_1_N : N ;
  utbrytning_nn_1_N : N ;
  utbuktning_nn_1_N : N ;
  utbytesbil_nn_1_N : N ;
  utbaering_nn_1_1_N : N ;
  utbaerning_nn_1_1_N : N ;
  utdebitering_nn_1_N : N ;
  utdelning_nn_1_N : N ;
  utdikning_nn_1_N : N ;
  utdockning_nn_1_N : N ;
  utdragning_nn_1_N : N ;
  utdragssaeng_nn_1_1_N : N ;
  utdrivning_nn_1_N : N ;
  utdunstning_nn_1_N : N ;
  utdoemning_nn_1_1_N : N ;
  utelaemning_nn_1_1_N : N ;
  uteservering_nn_1_N : N ;
  uteslutning_nn_1_N : N ;
  utestaengning_nn_1_1_N : N ;
  utexaminering_nn_1_N : N ;
  utexperimentering_nn_1_N : N ;
  utfallsport_nn_1_N : N ;
  utfartsvaeg_nn_1_1_N : N ;
  utflaggning_nn_1_N : N ;
  utflyttning_nn_1_N : N ;
  utflaekning_nn_1_1_N : N ;
  utfodring_nn_1_N : N ;
  utformning_nn_1_N : N ;
  utforskning_nn_1_N : N ;
  utfrysning_nn_1_N : N ;
  utfraagning_nn_1_1_N : N ;
  utfyllning_nn_1_N : N ;
  utfaellning_nn_1_1_N : N ;
  utfoering_nn_1_1_N : N ;
  utfoersaekring_nn_1_1_N : N ;
  utfoersaeljning_nn_1_1_N : N ;
  utfoersaakning_nn_1_1_N : N ;
  utgallring_nn_1_N : N ;
  utgivning_nn_1_N : N ;
  utgjutning_nn_1_N : N ;
  utglesning_nn_1_N : N ;
  utgraevning_nn_1_1_N : N ;
  utgaang_nn_1_1_N : N ;
  utgaangsfoerutsaettning_nn_1_1_N : N ;
  utgaangsstaellning_nn_1_1_N : N ;
  utgoedsling_nn_1_1_N : N ;
  uthuggning_nn_1_N : N ;
  uthungring_nn_1_N : N ;
  uthusvaegg_nn_1_1_N : N ;
  uthyrning_nn_1_N : N ;
  uthaallighetsloepning_nn_1_1_N : N ;
  uthaallighetstaevling_nn_1_1_N : N ;
  uthaallning_nn_1_1_N : N ;
  utjaemning_nn_1_1_N : N ;
  utkastning_nn_1_N : N ;
  utklarering_nn_1_N : N ;
  utklassning_nn_1_N : N ;
  utklaedning_nn_1_1_N : N ;
  utklaengning_nn_1_1_N : N ;
  utkommendering_nn_1_N : N ;
  utkonkurrering_nn_1_N : N ;
  utkragning_nn_1_N : N ;
  utkristallisering_nn_1_N : N ;
  utkraevning_nn_1_1_N : N ;
  utkvittering_nn_1_N : N ;
  utkvittning_nn_1_N : N ;
  utkylning_nn_1_N : N ;
  utkoerning_nn_1_1_N : N ;
  utloggning_nn_1_N : N ;
  utlokalisering_nn_1_N : N ;
  utlysning_nn_1_N : N ;
  utlaeggning_nn_1_1_N : N ;
  utlaemning_nn_1_1_N : N ;
  utlaenning_nn_1_1_N : N ;
  utlaenningslag_nn_1_1_N : N ;
  utlaaning_nn_1_1_N : N ;
  utloesning_nn_1_1_N : N ;
  utmaning_nn_1_N : N ;
  utmanoevrering_nn_1_1_N : N ;
  utmatning_nn_1_N : N ;
  utmattning_nn_1_N : N ;
  utminutering_nn_1_N : N ;
  utmaerkning_nn_1_1_N : N ;
  utmaetning_nn_1_1_N : N ;
  utmaalning_nn_1_1_N : N ;
  utnaemning_nn_1_1_N : N ;
  utnoetning_nn_1_1_N : N ;
  utomhusbelysning_nn_1_N : N ;
  utomjording_nn_1_N : N ;
  utpekning_nn_1_N : N ;
  utplacering_nn_1_N : N ;
  utplaaning_nn_1_1_N : N ;
  utpressning_nn_1_N : N ;
  utpressningsraettegaang_nn_1_1_N : N ;
  utprickning_nn_1_N : N ;
  utradering_nn_1_N : N ;
  utrangering_nn_1_N : N ;
  utredning_nn_1_N : N ;
  utrensning_nn_1_N : N ;
  utrikesavgaang_nn_1_1_N : N ;
  utrotning_nn_1_N : N ;
  utrullning_nn_1_N : N ;
  utrustning_nn_1_N : N ;
  utryckning_nn_1_N : N ;
  utrymning_nn_1_N : N ;
  utraekning_nn_1_1_N : N ;
  utraettning_nn_1_1_N : N ;
  utseendefixering_nn_1_N : N ;
  utsining_nn_1_N : N ;
  utsirning_nn_1_N : N ;
  utskeppning_nn_1_N : N ;
  utskiftning_nn_1_N : N ;
  utskrivning_nn_1_N : N ;
  utskaellning_nn_1_1_N : N ;
  utskaenkning_nn_1_1_N : N ;
  utskaerning_nn_1_1_N : N ;
  utskaapning_nn_1_1_N : N ;
  utslagning_nn_1_N : N ;
  utslagstaevling_nn_1_1_N : N ;
  utslungning_nn_1_N : N ;
  utslussning_nn_1_N : N ;
  utslutning_nn_1_N : N ;
  utslaeckning_nn_1_1_N : N ;
  utslaeppsminskning_nn_1_1_N : N ;
  utslaetning_nn_1_1_N : N ;
  utsmyckning_nn_1_N : N ;
  utspaning_nn_1_N : N ;
  utspark_nn_1_N : N ;
  utspisning_nn_1_N : N ;
  utspaedning_nn_1_1_N : N ;
  utspaenning_nn_1_1_N : N ;
  utspaerrning_nn_1_1_N : N ;
  utstakning_nn_1_N : N ;
  utstoffering_nn_1_N : N ;
  utstraeckning_nn_1_1_N : N ;
  utstraalning_nn_1_1_N : N ;
  utstaellning_nn_1_1_N : N ;
  utstoetning_nn_1_1_N : N ;
  utsugning_nn_1_N : N ;
  utsvaellning_nn_1_1_N : N ;
  utsvaevning_nn_1_1_N : N ;
  utsyning_nn_1_N : N ;
  utsaegning_nn_1_1_N : N ;
  utsaendning_nn_1_1_N : N ;
  utsoekning_nn_1_1_N : N ;
  utsoendring_nn_1_1_N : N ;
  uttagning_nn_1_N : N ;
  uttalsbeteckning_nn_1_N : N ;
  uttaxering_nn_1_N : N ;
  uttolkning_nn_1_N : N ;
  uttorkning_nn_1_N : N ;
  uttroettning_nn_1_1_N : N ;
  uttydning_nn_1_N : N ;
  uttaenjning_nn_1_1_N : N ;
  uttoemning_nn_1_1_N : N ;
  utvandring_nn_1_N : N ;
  utveckling_nn_1_N : N ;
  utvecklingsgaang_nn_1_1_N : N ;
  utvecklingsrubbning_nn_1_N : N ;
  utvecklingsstoerning_nn_1_1_N : N ;
  utvecklingsvaeg_nn_1_1_N : N ;
  utvidgning_nn_1_N : N ;
  utvikning_nn_1_N : N ;
  utvinning_nn_1_N : N ;
  utvisning_nn_1_N : N ;
  utvaeg_nn_1_1_N : N ;
  utvaerdering_nn_1_1_N : N ;
  utvaexling_nn_1_1_N : N ;
  utoekning_nn_1_1_N : N ;
  vaccinering_nn_1_N : N ;
  vacuumfoerpackning_nn_1_1_N : N ;
  vacuumpump_nn_1_N : N ;
  vacuumsug_nn_1_N : N ;
  vacuumtorkning_nn_1_N : N ;
  vaddering_nn_1_N : N ;
  vadhaallning_nn_1_1_N : N ;
  vadhaallningslag_nn_1_1_N : N ;
  vadning_nn_1_N : N ;
  vadslagning_nn_1_N : N ;
  vagabondering_nn_1_N : N ;
  vagnbjoern_nn_1_1_N : N ;
  vagnsdoerr_nn_1_1_N : N ;
  vagnshaeck_nn_1_1_N : N ;
  vagnskadefoersaekring_nn_1_1_N : N ;
  vagnsport_nn_1_N : N ;
  vagnstock_nn_1_N : N ;
  vaksinering_nn_1_N : N ;
  vaktavloesning_nn_1_1_N : N ;
  vakthaallning_nn_1_1_N : N ;
  vakuumfoerpackning_nn_1_1_N : N ;
  vakuumpump_nn_1_N : N ;
  vakuumsug_nn_1_N : N ;
  vakuumtorkning_nn_1_N : N ;
  valberedning_nn_1_N : N ;
  valbod_nn_1_N : N ;
  valgranskning_nn_1_N : N ;
  vallmoodling_nn_1_N : N ;
  vallokalsundersoekning_nn_1_1_N : N ;
  valomgaang_nn_1_1_N : N ;
  valpning_nn_1_N : N ;
  valutareglering_nn_1_N : N ;
  valutering_nn_1_N : N ;
  valutgaang_nn_1_1_N : N ;
  valvering_nn_1_N : N ;
  valvind_nn_1_N : N ;
  valvport_nn_1_N : N ;
  valvslagning_nn_1_N : N ;
  vandalisering_nn_1_N : N ;
  vandring_nn_1_N : N ;
  vandringsutstaellning_nn_1_1_N : N ;
  vanebildning_nn_1_N : N ;
  vanfoerestaellning_nn_1_1_N : N ;
  vansinneskoerning_nn_1_1_N : N ;
  vantolkning_nn_1_N : N ;
  vantskruv_nn_1_N : N ;
  vapenlek_nn_1_N : N ;
  vapenskoeld_nn_1_1_N : N ;
  varbildning_nn_1_N : N ;
  vardag_nn_1_N : N ;
  vardagsmiddag_nn_1_N : N ;
  vargering_nn_1_N : N ;
  vargflock_nn_1_N : N ;
  variering_nn_1_N : N ;
  varmhaallning_nn_1_1_N : N ;
  varmluftsflaekt_nn_1_1_N : N ;
  varning_nn_1_N : N ;
  varpning_nn_1_N : N ;
  varptraad_nn_1_1_N : N ;
  varseblivning_nn_1_N : N ;
  varubelaaning_nn_1_1_N : N ;
  varubeteckning_nn_1_N : N ;
  varudeklarering_nn_1_N : N ;
  varulv_nn_1_N : N ;
  varutransportbil_nn_1_N : N ;
  vattenavlaesning_nn_1_1_N : N ;
  vattenavrinning_nn_1_N : N ;
  vattenblomning_nn_1_N : N ;
  vattendomstol_nn_1_N : N ;
  vattenfoerorening_nn_1_1_N : N ;
  vattenkoppling_nn_1_N : N ;
  vattenkvarn_nn_1_N : N ;
  vattenledning_nn_1_N : N ;
  vattenloesning_nn_1_1_N : N ;
  vattenpump_nn_1_N : N ;
  vattenreglering_nn_1_N : N ;
  vattenrening_nn_1_N : N ;
  vattenring_nn_1_N : N ;
  vattensamling_nn_1_N : N ;
  vattenslang_nn_1_N : N ;
  vattensork_nn_1_N : N ;
  vattensaeck_nn_1_1_N : N ;
  vattentrampning_nn_1_N : N ;
  vattenvaeg_nn_1_1_N : N ;
  vattenoesning_nn_1_1_N : N ;
  vattring_nn_1_N : N ;
  vattvaelling_nn_1_1_N : N ;
  vaxduk_nn_1_N : N ;
  vaxning_nn_1_N : N ;
  vaxpropp_nn_1_N : N ;
  veckning_nn_1_N : N ;
  veckoavdelning_nn_1_N : N ;
  veckohandling_nn_1_N : N ;
  veckopendling_nn_1_N : N ;
  veckotidning_nn_1_N : N ;
  vedergaellning_nn_1_1_N : N ;
  vedhuggning_nn_1_N : N ;
  vedhoeg_nn_1_1_N : N ;
  vedkapning_nn_1_N : N ;
  vedkapsaag_nn_1_1_N : N ;
  vedklyv_nn_1_N : N ;
  vedsaag_nn_1_1_N : N ;
  velourisering_nn_1_N : N ;
  ventilationsflaekt_nn_1_1_N : N ;
  ventilering_nn_1_N : N ;
  ventilhatt_nn_1_N : N ;
  verandadoerr_nn_1_1_N : N ;
  verbalisering_nn_1_N : N ;
  verbhandling_nn_1_N : N ;
  verbsammansaettning_nn_1_1_N : N ;
  verifiering_nn_1_N : N ;
  verklighetsbeskrivning_nn_1_N : N ;
  verkning_nn_1_N : N ;
  verkstadsfoerening_nn_1_1_N : N ;
  verkstadskran_nn_1_N : N ;
  verktygskrok_nn_1_N : N ;
  vernalisering_nn_1_N : N ;
  versbindning_nn_1_N : N ;
  versifiering_nn_1_N : N ;
  veteranbil_nn_1_N : N ;
  veterinaerbesiktning_nn_1_1_N : N ;
  vibrering_nn_1_N : N ;
  vickning_nn_1_N : N ;
  vidareutbildning_nn_1_N : N ;
  vidareutveckling_nn_1_N : N ;
  vidbraenning_nn_1_1_N : N ;
  vidgning_nn_1_N : N ;
  vidhaeftning_nn_1_1_N : N ;
  vidhaengning_nn_1_1_N : N ;
  vidimering_nn_1_N : N ;
  vidraekning_nn_1_1_N : N ;
  viftning_nn_1_N : N ;
  viggning_nn_1_N : N ;
  vigilering_nn_1_N : N ;
  vigning_nn_1_N : N ;
  vigselring_nn_1_N : N ;
  vikariering_nn_1_N : N ;
  vikdoerr_nn_1_1_N : N ;
  vikingagrav_nn_1_N : N ;
  vikning_nn_1_N : N ;
  viktkastning_nn_1_N : N ;
  viktklubb_nn_1_N : N ;
  viktminskning_nn_1_N : N ;
  viktning_nn_1_N : N ;
  viktoekning_nn_1_1_N : N ;
  vildsvinsflock_nn_1_N : N ;
  viljeanstraengning_nn_1_1_N : N ;
  viljefoerklaring_nn_1_1_N : N ;
  viljefoerlamning_nn_1_1_N : N ;
  viljehandling_nn_1_N : N ;
  viljeinriktning_nn_1_N : N ;
  viljeriktning_nn_1_N : N ;
  viljeyttring_nn_1_N : N ;
  villovaeg_nn_1_1_N : N ;
  vilseledning_nn_1_N : N ;
  vilstol_nn_1_N : N ;
  viltplantering_nn_1_N : N ;
  vind_nn_2_N : N ;
  vindflaekt_nn_1_1_N : N ;
  vindicering_nn_1_N : N ;
  vindkantring_nn_1_N : N ;
  vindling_nn_1_N : N ;
  vindmaetning_nn_1_1_N : N ;
  vindning_nn_1_N : N ;
  vindpollinering_nn_1_N : N ;
  vindriktning_nn_1_N : N ;
  vindvridning_nn_1_N : N ;
  vindaendring_nn_1_1_N : N ;
  vingglidning_nn_1_N : N ;
  vingteckning_nn_1_N : N ;
  vingud_nn_1_N : N ;
  vinkling_nn_1_N : N ;
  vinkning_nn_1_N : N ;
  vinkork_nn_1_N : N ;
  vinning_nn_1_N : N ;
  vinodling_nn_1_N : N ;
  vinprovning_nn_1_N : N ;
  vinservering_nn_1_N : N ;
  vinskoerd_nn_1_1_N : N ;
  vinstdelning_nn_1_N : N ;
  vinstminskning_nn_1_N : N ;
  vinstock_nn_1_N : N ;
  vinstutdelning_nn_1_N : N ;
  vinstvarning_nn_1_N : N ;
  vinterdag_nn_1_N : N ;
  vinterhamn_nn_1_N : N ;
  vinterhaempling_nn_1_1_N : N ;
  vinterlek_nn_1_N : N ;
  vintervaeg_nn_1_1_N : N ;
  vipparm_nn_1_N : N ;
  vippkoppling_nn_1_N : N ;
  virkesmaetning_nn_1_1_N : N ;
  virkkrok_nn_1_N : N ;
  virkning_nn_1_N : N ;
  virknaal_nn_1_1_N : N ;
  virussjukdom_nn_1_N : N ;
  virvelvind_nn_1_N : N ;
  visdom_nn_1_N : N ;
  visering_nn_1_N : N ;
  visitering_nn_1_N : N ;
  viskning_nn_1_N : N ;
  visning_nn_1_N : N ;
  vissling_nn_1_N : N ;
  visstidsanstaellning_nn_1_1_N : N ;
  visualisering_nn_1_N : N ;
  vitalfaergning_nn_1_1_N : N ;
  vitalisering_nn_1_N : N ;
  vitaminburk_nn_1_N : N ;
  vitaminering_nn_1_N : N ;
  vitaminisering_nn_1_N : N ;
  vitgloedgning_nn_1_1_N : N ;
  vitloek_nn_1_1_N : N ;
  vitmening_nn_1_N : N ;
  vitterlek_nn_1_N : N ;
  vittring_nn_1_N : N ;
  vokabelsamling_nn_1_N : N ;
  vokalisering_nn_1_N : N ;
  vokalvaexling_nn_1_1_N : N ;
  volframnaal_nn_1_1_N : N ;
  volleyboll_nn_2_N : N ;
  volmning_nn_1_N : N ;
  voltigering_nn_1_N : N ;
  vomering_nn_1_N : N ;
  votering_nn_1_N : N ;
  voteringsskylt_nn_1_N : N ;
  vrakning_nn_1_N : N ;
  vrakplundring_nn_1_N : N ;
  vrickning_nn_1_N : N ;
  vridning_nn_1_N : N ;
  vristlaenk_nn_1_1_N : N ;
  vraekning_nn_1_1_N : N ;
  vraengning_nn_1_1_N : N ;
  vulgarisering_nn_1_N : N ;
  vulkanisering_nn_1_N : N ;
  vulkanvarning_nn_1_N : N ;
  vuxenvaerld_nn_1_1_N : N ;
  vaeckning_nn_1_1_N : N ;
  vaederkvarn_nn_1_1_N : N ;
  vaederlek_nn_1_1_N : N ;
  vaedermaetning_nn_1_1_N : N ;
  vaederspaenning_nn_1_1_N : N ;
  vaegbelaeggning_nn_1_1_N : N ;
  vaegfoerening_nn_1_1_N : N ;
  vaegfoervaltning_nn_1_1_N : N ;
  vaeggarm_nn_1_1_N : N ;
  vaeggmaalning_nn_1_1_N : N ;
  vaeggtidning_nn_1_1_N : N ;
  vaeghaallning_nn_1_1_N : N ;
  vaeginvestering_nn_1_1_N : N ;
  vaegkorsning_nn_1_1_N : N ;
  vaegkrog_nn_1_1_N : N ;
  vaeglag_nn_2_1_N : N ;
  vaegledning_nn_1_1_N : N ;
  vaegning_nn_1_1_N : N ;
  vaegport_nn_1_1_N : N ;
  vaegskylt_nn_1_1_N : N ;
  vaegspaerr_nn_1_1_N : N ;
  vaejning_nn_1_1_N : N ;
  vaelgaerning_nn_1_1_N : N ;
  vaeljarundersoekning_nn_1_1_N : N ;
  vaelkomsthaelsning_nn_1_1_N : N ;
  vaelkomstmiddag_nn_1_1_N : N ;
  vaellning_nn_1_1_N : N ;
  vaellsvetsning_nn_1_1_N : N ;
  vaelskrivning_nn_1_1_N : N ;
  vaelvning_nn_1_1_N : N ;
  vaendning_nn_1_1_N : N ;
  vaendrostning_nn_1_1_N : N ;
  vaenskapskram_nn_1_1_N : N ;
  vaensterknapp_nn_1_1_N : N ;
  vaensterregering_nn_1_1_N : N ;
  vaenstersvaeng_nn_1_1_N : N ;
  vaenstertidning_nn_1_1_N : N ;
  vaentsal_nn_1_1_N : N ;
  vaerdehandling_nn_1_1_N : N ;
  vaerdeminskning_nn_1_1_N : N ;
  vaerdering_nn_1_1_N : N ;
  vaerdestegring_nn_1_1_N : N ;
  vaerdesaettning_nn_1_1_N : N ;
  vaerdeoekning_nn_1_1_N : N ;
  vaerdshusvaerd_nn_1_1_N : N ;
  vaerdvaexling_nn_1_1_N : N ;
  vaerld_nn_1_1_N : N ;
  vaerldsomsegling_nn_1_1_N : N ;
  vaerldsordning_nn_1_1_N : N ;
  vaerldsuppfattning_nn_1_1_N : N ;
  vaerldsutstaellning_nn_1_1_N : N ;
  vaerldsaaskaadning_nn_1_1_N : N ;
  vaermeanlaeggning_nn_1_1_N : N ;
  vaermebehandling_nn_1_1_N : N ;
  vaermedaempning_nn_1_1_N : N ;
  vaermefotografering_nn_1_1_N : N ;
  vaermeisolering_nn_1_1_N : N ;
  vaermeledning_nn_1_1_N : N ;
  vaermepump_nn_1_1_N : N ;
  vaermeskoeld_nn_1_1_N : N ;
  vaermespridning_nn_1_1_N : N ;
  vaermesterilisering_nn_1_1_N : N ;
  vaermestraalning_nn_1_1_N : N ;
  vaermeutveckling_nn_1_1_N : N ;
  vaermeutvidgning_nn_1_1_N : N ;
  vaermlaenning_nn_1_1_N : N ;
  vaermning_nn_1_1_N : N ;
  vaernpliktstjaenstgoering_nn_1_1_N : N ;
  vaervning_nn_1_1_N : N ;
  vaesning_nn_1_1_N : N ;
  vaessning_nn_1_1_N : N ;
  vaestanflaekt_nn_1_1_N : N ;
  vaesterbottning_nn_1_1_N : N ;
  vaesterlaenning_nn_1_1_N : N ;
  vaestklaenning_nn_1_1_N : N ;
  vaestmanlaenning_nn_1_1_N : N ;
  vaestvind_nn_1_1_N : N ;
  vaetgasbil_nn_1_1_N : N ;
  vaetning_nn_1_1_N : N ;
  vaetskeansamling_nn_1_1_N : N ;
  vaetskeersaettning_nn_1_1_N : N ;
  vaetskefjaedring_nn_1_1_N : N ;
  vaevbindning_nn_1_1_N : N ;
  vaevknut_nn_1_1_N : N ;
  vaevnadsodling_nn_1_1_N : N ;
  vaevning_nn_1_1_N : N ;
  vaexelfoerregling_nn_1_1_N : N ;
  vaexellaesning_nn_1_1_N : N ;
  vaexellaadslyft_nn_1_1_N : N ;
  vaexelomsaettning_nn_1_1_N : N ;
  vaexelspaksknopp_nn_1_1_N : N ;
  vaexelspaenning_nn_1_1_N : N ;
  vaexelundervisning_nn_1_1_N : N ;
  vaexling_nn_1_1_N : N ;
  vaextfaergning_nn_1_1_N : N ;
  vaextfoeraedling_nn_1_1_N : N ;
  vaexthusodling_nn_1_1_N : N ;
  vaextnaering_nn_1_1_N : N ;
  vaextsjukdom_nn_1_1_N : N ;
  vaexttraad_nn_1_1_N : N ;
  vaextvaerld_nn_1_1_N : N ;
  vaadaskjutning_nn_1_1_N : N ;
  vaadeld_nn_1_1_N : N ;
  vaaffelbindning_nn_1_1_N : N ;
  vaagskaal_nn_1_1_N : N ;
  vaaldgaestning_nn_1_1_N : N ;
  vaaldsgaerning_nn_1_1_N : N ;
  vaaldshandling_nn_1_1_N : N ;
  vaaldsskildring_nn_1_1_N : N ;
  vaaldtagning_nn_1_1_N : N ;
  vaalmning_nn_1_1_N : N ;
  vaaning_nn_1_1_N : N ;
  vaarbrytning_nn_1_1_N : N ;
  vaarbaeck_nn_1_1_N : N ;
  vaardag_nn_1_1_N : N ;
  vaardagjaemning_nn_1_1_N : N ;
  vaardavdelning_nn_1_1_N : N ;
  vaarloek_nn_1_1_N : N ;
  vaarriksdag_nn_1_1_N : N ;
  vaarstaedning_nn_1_1_N : N ;
  vaaroeversvaemning_nn_1_1_N : N ;
  vaatsugning_nn_1_1_N : N ;
  wienerkorv_nn_1_N : N ;
  ympning_nn_1_N : N ;
  yngeldamm_nn_1_N : N ;
  ynkedom_nn_1_N : N ;
  yrkesorientering_nn_1_N : N ;
  yrkessjukdom_nn_1_N : N ;
  yrkesutbildning_nn_1_N : N ;
  yrkesvaegledning_nn_1_1_N : N ;
  ytavvaegning_nn_1_1_N : N ;
  ytspaenning_nn_1_1_N : N ;
  ytterdoerr_nn_1_1_N : N ;
  ytterlighetsriktning_nn_1_N : N ;
  yttervaegg_nn_1_1_N : N ;
  yttervaerld_nn_1_1_N : N ;
  yttrandefrihetslag_nn_1_N : N ;
  yttring_nn_1_N : N ;
  zappning_nn_1_N : N ;
  zigenarhoevding_nn_1_1_N : N ;
  aadal_nn_1_1_N : N ;
  aaderfoerkalkning_nn_1_1_N : N ;
  aaderlaatning_nn_1_1_N : N ;
  aadring_nn_1_1_N : N ;
  aakerbit_nn_1_1_N : N ;
  aakerstig_nn_1_1_N : N ;
  aakervall_nn_1_1_N : N ;
  aaklapp_nn_1_1_N : N ;
  aakning_nn_1_1_N : N ;
  aalderdom_nn_1_1_N : N ;
  aalderdomsfoersaekring_nn_1_1_N : N ;
  aaldersbestaemning_nn_1_1_N : N ;
  aaldersdiskriminering_nn_1_1_N : N ;
  aaldersforskning_nn_1_1_N : N ;
  aaldersfoerdelning_nn_1_1_N : N ;
  aaldersfoeraendring_nn_1_1_N : N ;
  aalderssjukdom_nn_1_1_N : N ;
  aaldring_nn_1_1_N : N ;
  aalning_nn_1_1_N : N ;
  aalaenning_nn_1_1_N : N ;
  aamning_nn_1_1_N : N ;
  aamynning_nn_1_1_N : N ;
  aanganlaeggning_nn_1_1_N : N ;
  aangbildning_nn_1_1_N : N ;
  aangermanlaenning_nn_1_1_N : N ;
  aangning_nn_1_1_N : N ;
  aargaang_nn_1_1_N : N ;
  aaring_nn_1_1_N : N ;
  aarskursintegrering_nn_1_1_N : N ;
  aarsredovisning_nn_1_1_N : N ;
  aarsring_nn_1_1_N : N ;
  aarstidsvind_nn_1_1_N : N ;
  aarstidsvaexling_nn_1_1_N : N ;
  aasiktsbildning_nn_1_1_N : N ;
  aasiktsregistrering_nn_1_1_N : N ;
  aasiktsriktning_nn_1_1_N : N ;
  aasiktsyttring_nn_1_1_N : N ;
  aaskknall_nn_1_1_N : N ;
  aaskaadarhop_nn_1_1_N : N ;
  aaskaadning_nn_1_1_N : N ;
  aaskaadningsundervisning_nn_1_1_N : N ;
  aasnespark_nn_1_1_N : N ;
  aatalsanmaelning_nn_1_1_N : N ;
  aatdragning_nn_1_1_N : N ;
  aateranpassning_nn_1_1_N : N ;
  aateranvaendning_nn_1_1_N : N ;
  aaterbetalning_nn_1_1_N : N ;
  aaterblick_nn_1_1_N : N ;
  aaterbaering_nn_1_1_N : N ;
  aatereroevring_nn_1_1_N : N ;
  aaterflyttning_nn_1_1_N : N ;
  aaterfoerening_nn_1_1_N : N ;
  aaterfoering_nn_1_1_N : N ;
  aaterfoersaekring_nn_1_1_N : N ;
  aaterfoersaeljning_nn_1_1_N : N ;
  aatergivning_nn_1_1_N : N ;
  aaterhaemtning_nn_1_1_N : N ;
  aaterinsaettning_nn_1_1_N : N ;
  aaterinvestering_nn_1_1_N : N ;
  aaterkastning_nn_1_1_N : N ;
  aaterknytning_nn_1_1_N : N ;
  aaterkoppling_nn_1_1_N : N ;
  aaterlaemning_nn_1_1_N : N ;
  aaterloesning_nn_1_1_N : N ;
  aaterplantering_nn_1_1_N : N ;
  aatersamling_nn_1_1_N : N ;
  aaterspegling_nn_1_1_N : N ;
  aaterstudsning_nn_1_1_N : N ;
  aatersaendning_nn_1_1_N : N ;
  aatertagning_nn_1_1_N : N ;
  aaterupplivning_nn_1_1_N : N ;
  aaskby_nn_1_1_N : N ;
  aader_nn_1_1_N : N ;
  vaexelfordran_nn_1_1_N : N ;
  visafton_nn_1_N : N ;
  vindby_nn_1_N : N ;
  valborgsmaessoafton_nn_1_1_N : N ;
  urmoder_nn_1_N : N ;
  uppmuntran_nn_1_N : N ;
  undran_nn_1_N : N ;
  tsardotter_nn_1_N : N ;
  traetoffel_nn_1_1_N : N ;
  trettondedagsafton_nn_1_N : N ;
  trettondagsafton_nn_1_N : N ;
  toffel_nn_1_N : N ;
  teateranmaelan_nn_1_1_N : N ;
  systerdotter_nn_1_N : N ;
  svaerdotter_nn_1_1_N : N ;
  surrogatmoder_nn_1_N : N ;
  styvdotter_nn_1_N : N ;
  stugby_nn_1_N : N ;
  stormby_nn_1_N : N ;
  storby_nn_1_N : N ;
  stammoder_nn_1_N : N ;
  sondotter_nn_1_N : N ;
  sommar_nn_1_N : N ;
  sky_nn_1_N : N ;
  sexbarnsmoder_nn_1_N : N ;
  sensommar_nn_1_N : N ;
  semesterby_nn_1_N : N ;
  sanningsfoersaekran_nn_1_1_N : N ;
  sameby_nn_1_N : N ;
  radondotter_nn_1_N : N ;
  paaskafton_nn_1_1_N : N ;
  pulsaader_nn_1_1_N : N ;
  poesiafton_nn_1_N : N ;
  pippi_nn_1_N : N ;
  pingstafton_nn_1_N : N ;
  nyaarsafton_nn_1_1_N : N ;
  motfordran_nn_1_N : N ;
  moder_nn_1_N : N ;
  mjoelkaader_nn_1_1_N : N ;
  missnoejesanmaelan_nn_1_1_N : N ;
  midsommarafton_nn_1_N : N ;
  midsommar_nn_1_N : N ;
  laekardotter_nn_1_1_N : N ;
  lungpulsaader_nn_1_1_N : N ;
  litteraturanmaelan_nn_1_1_N : N ;
  kaellaader_nn_1_1_N : N ;
  kyrkby_nn_1_N : N ;
  kycklingmoder_nn_1_N : N ;
  klubbafton_nn_1_N : N ;
  kastby_nn_1_N : N ;
  julafton_nn_1_N : N ;
  indiansommar_nn_1_N : N ;
  hoegsommar_nn_1_1_N : N ;
  hemmadotter_nn_1_N : N ;
  helgdagsafton_nn_1_N : N ;
  helafton_nn_1_N : N ;
  guddotter_nn_1_N : N ;
  gruvarbetardotter_nn_1_N : N ;
  giftverkan_nn_1_N : N ;
  genfordran_nn_1_N : N ;
  foersaekran_nn_1_1_N : N ;
  foersommar_nn_1_1_N : N ;
  faelttaevlan_nn_1_1_N : N ;
  fritidsby_nn_1_N : N ;
  framstaellan_nn_1_1_N : N ;
  fosterdotter_nn_1_N : N ;
  fordran_nn_1_N : N ;
  foppatoffel_nn_1_N : N ;
  filttoffel_nn_1_N : N ;
  erinran_nn_1_N : N ;
  eftersommar_nn_1_N : N ;
  dotterdotter_nn_1_N : N ;
  dotter_nn_1_N : N ;
  djaevul_nn_1_1_N : N ;
  diplomatdotter_nn_1_N : N ;
  byggmaestardotter_nn_1_1_N : N ;
  by_nn_1_N : N ;
  brorsdotter_nn_1_N : N ;
  brittsommar_nn_1_N : N ;
  bokanmaelan_nn_1_1_N : N ;
  blodaader_nn_1_1_N : N ;
  befordran_nn_1_N : N ;
  barnby_nn_1_N : N ;
  badtoffel_nn_1_N : N ;
  anmaelan_nn_2_1_N : N ;
  anmoder_nn_1_N : N ;
  andur_nn_1_N : N ;
  andel_nn_1_N : N ;
  afton_nn_1_N : N ;
  Foppatoffel_nn_1_N : N ;
  alpros_nn_1_N : N ;
  anfallsvaag_nn_1_1_N : N ;
  beostare_nn_1_N : N ;
  blodvaag_nn_1_1_N : N ;
  baervaag_nn_1_1_N : N ;
  chockvaag_nn_1_1_N : N ;
  flodvaag_nn_1_1_N : N ;
  gravitationsvaag_nn_1_1_N : N ;
  havsvaag_nn_1_1_N : N ;
  hoegervaag_nn_1_1_N : N ;
  ibisros_nn_1_N : N ;
  julros_nn_1_N : N ;
  klaetterros_nn_1_1_N : N ;
  kompassros_nn_1_N : N ;
  kortvaag_nn_1_1_N : N ;
  ljudvaag_nn_1_1_N : N ;
  ljusvaag_nn_1_1_N : N ;
  luftvaag_nn_1_1_N : N ;
  lump_nn_1_N : N ;
  laangvaag_nn_1_1_N : N ;
  maskros_nn_1_N : N ;
  massakervaag_nn_1_1_N : N ;
  mellanvaag_nn_1_1_N : N ;
  mikrovaag_nn_1_1_N : N ;
  mossros_nn_1_N : N ;
  maanadsros_nn_1_1_N : N ;
  normaliseringsvaag_nn_1_1_N : N ;
  nyponros_nn_1_N : N ;
  naeckros_nn_1_1_N : N ;
  ordros_nn_1_N : N ;
  radarvaag_nn_1_1_N : N ;
  radiovaag_nn_1_1_N : N ;
  rallarros_nn_1_N : N ;
  ros_nn_1_N : N ;
  raanvaag_nn_1_1_N : N ;
  sannolikhetsvaag_nn_1_1_N : N ;
  sidenros_nn_1_N : N ;
  silvervaag_nn_1_1_N : N ;
  sinusvaag_nn_1_1_N : N ;
  solros_nn_1_N : N ;
  spekulationsvaag_nn_1_1_N : N ;
  stockros_nn_1_N : N ;
  stoetvaag_nn_1_1_N : N ;
  svallvaag_nn_1_1_N : N ;
  svettros_nn_1_N : N ;
  teros_nn_1_N : N ;
  tryckvaag_nn_1_1_N : N ;
  toernros_nn_1_1_N : N ;
  ultrakortvaag_nn_1_1_N : N ;
  vindros_nn_1_N : N ;
  vaetteros_nn_1_1_N : N ;
  vaag_nn_1_1_N : N ;
  vaaldsvaag_nn_1_1_N : N ;
  yllelump_nn_1_N : N ;
  trikloretylen_nn_1_N : N ;
  terylen_nn_1_N : N ;
  styren_nn_1_N : N ;
  selen_nn_1_N : N ;
  propen_nn_1_N : N ;
  polystyren_nn_1_N : N ;
  polypropen_nn_1_N : N ;
  polyeten_nn_1_N : N ;
  naftalen_nn_1_N : N ;
  molybden_nn_1_N : N ;
  metylen_nn_1_N : N ;
  fotogen_nn_1_N : N ;
  flygfotogen_nn_1_N : N ;
  etylen_nn_1_N : N ;
  eten_nn_1_N : N ;
  bensen_nn_1_N : N ;
  acetylen_nn_1_N : N ;
  IT_jaette_nn_1_1_N : N ;
  Linn_elaerjunge_nn_1_1_N : N ;
  Rikspolisstyrelse_nn_1_N : N ;
  ande_nn_1_N : N ;
  ankunge_nn_1_N : N ;
  antihjaelte_nn_1_1_N : N ;
  arvfurste_nn_1_N : N ;
  arvinge_nn_1_N : N ;
  askunge_nn_1_N : N ;
  aspdunge_nn_1_N : N ;
  avgrundsande_nn_1_N : N ;
  bakarvinge_nn_1_N : N ;
  bakaende_nn_1_1_N : N ;
  ballongmage_nn_1_N : N ;
  barfotalasse_nn_1_N : N ;
  barnraettskaempe_nn_1_1_N : N ;
  barnunge_nn_1_N : N ;
  barrikadkaempe_nn_1_1_N : N ;
  beagle_nn_1_N : N ;
  bildrulle_nn_1_N : N ;
  binjure_nn_1_N : N ;
  bjaesse_nn_1_1_N : N ;
  bladmage_nn_1_N : N ;
  blatte_nn_1_N : N ;
  blindrote_nn_1_N : N ;
  blaadaare_nn_1_1_N : N ;
  blaahake_nn_1_1_N : N ;
  brosme_nn_1_N : N ;
  brottsmisstanke_nn_1_N : N ;
  brudborste_nn_1_N : N ;
  brunte_nn_1_N : N ;
  bryggerijaette_nn_1_1_N : N ;
  broestarvinge_nn_1_1_N : N ;
  broethake_nn_1_1_N : N ;
  bultskalle_nn_1_N : N ;
  busunge_nn_1_N : N ;
  byfogde_nn_1_N : N ;
  byfaane_nn_1_1_N : N ;
  byggherre_nn_1_N : N ;
  byggjaette_nn_1_1_N : N ;
  byggnadsstomme_nn_1_N : N ;
  byaeldste_nn_1_1_N : N ;
  baatshake_nn_1_1_N : N ;
  chibbe_nn_1_N : N ;
  chirre_nn_1_N : N ;
  choke_nn_1_N : N ;
  demokratifoerkaempe_nn_1_1_N : N ;
  diktarfurste_nn_1_N : N ;
  djaekne_nn_1_1_N : N ;
  dockkudde_nn_1_N : N ;
  dumskalle_nn_1_N : N ;
  dununge_nn_1_N : N ;
  duvunge_nn_1_N : N ;
  dyborre_nn_1_N : N ;
  daeggdjursunge_nn_1_1_N : N ;
  doedskalle_nn_1_1_N : N ;
  ejderdunskudde_nn_1_N : N ;
  ejderunge_nn_1_N : N ;
  eldsvaadeunge_nn_1_1_N : N ;
  elementarande_nn_1_N : N ;
  feodalherre_nn_1_N : N ;
  filttomte_nn_1_N : N ;
  finkunge_nn_1_N : N ;
  flickunge_nn_1_N : N ;
  flintskalle_nn_1_N : N ;
  flodhaestunge_nn_1_1_N : N ;
  flaabuse_nn_1_1_N : N ;
  fogde_nn_1_N : N ;
  folkhjaelte_nn_1_1_N : N ;
  folle_nn_1_N : N ;
  fotaende_nn_1_1_N : N ;
  fraktjaette_nn_1_1_N : N ;
  framaende_nn_1_1_N : N ;
  friherre_nn_1_N : N ;
  frihetshjaelte_nn_1_1_N : N ;
  frihetskaempe_nn_1_1_N : N ;
  fraekne_nn_1_1_N : N ;
  furste_nn_1_N : N ;
  faeltherre_nn_1_1_N : N ;
  faagelunge_nn_1_1_N : N ;
  faane_nn_1_1_N : N ;
  faaraherde_nn_1_1_N : N ;
  faarskalle_nn_1_1_N : N ;
  foelunge_nn_1_1_N : N ;
  foerkaempe_nn_1_1_N : N ;
  foerstaserve_nn_1_1_N : N ;
  gatunge_nn_1_N : N ;
  gepardunge_nn_1_N : N ;
  glarre_nn_1_N : N ;
  godsherre_nn_1_N : N ;
  gorillaunge_nn_1_N : N ;
  gravidmage_nn_1_N : N ;
  grisunge_nn_1_N : N ;
  grundstomme_nn_1_N : N ;
  gruvfogde_nn_1_N : N ;
  graedde_nn_1_1_N : N ;
  graagosse_nn_1_1_N : N ;
  gudunge_nn_1_N : N ;
  guldbagge_nn_1_N : N ;
  gullgosse_nn_1_N : N ;
  gaagosse_nn_1_1_N : N ;
  gaasunge_nn_1_1_N : N ;
  goekunge_nn_1_1_N : N ;
  hamnbuse_nn_1_N : N ;
  hamnfogde_nn_1_N : N ;
  herde_nn_1_N : N ;
  herre_nn_2_N : N ;
  hjaelte_nn_1_1_N : N ;
  horunge_nn_1_N : N ;
  hustomte_nn_1_N : N ;
  huvudkudde_nn_1_N : N ;
  haemndeande_nn_1_1_N : N ;
  haengmage_nn_1_1_N : N ;
  haallhake_nn_1_1_N : N ;
  hoegstadieunge_nn_1_1_N : N ;
  isbjoernsunge_nn_1_1_N : N ;
  it_jaette_nn_1_1_N : N ;
  jordande_nn_1_N : N ;
  jude_nn_1_N : N ;
  jultomte_nn_1_N : N ;
  jaernhake_nn_1_1_N : N ;
  jaervunge_nn_1_1_N : N ;
  jaette_nn_1_1_N : N ;
  kamelherde_nn_1_N : N ;
  kammarherre_nn_1_N : N ;
  karbinhake_nn_1_N : N ;
  kattunge_nn_1_N : N ;
  keramiktomte_nn_1_N : N ;
  klantskalle_nn_1_N : N ;
  knaeppskalle_nn_1_1_N : N ;
  konstfiberkudde_nn_1_N : N ;
  kopplerimisstanke_nn_1_N : N ;
  korgosse_nn_1_N : N ;
  korre_nn_1_N : N ;
  korruptionsmisstanke_nn_1_N : N ;
  kortaende_nn_1_1_N : N ;
  krigsfaange_nn_1_1_N : N ;
  krigsherre_nn_1_N : N ;
  krigshjaelte_nn_1_1_N : N ;
  krockkudde_nn_1_N : N ;
  kronofogde_nn_1_N : N ;
  kulmage_nn_1_N : N ;
  kurfurste_nn_1_N : N ;
  kyrkoherde_nn_1_N : N ;
  kaempe_nn_1_1_N : N ;
  lammunge_nn_1_N : N ;
  landsfogde_nn_1_N : N ;
  landsaende_nn_1_1_N : N ;
  livsarvinge_nn_1_N : N ;
  livsmedelsjaette_nn_1_1_N : N ;
  livstidsfaange_nn_1_1_N : N ;
  luftande_nn_1_N : N ;
  luftkudde_nn_1_N : N ;
  luftskalle_nn_1_N : N ;
  laekemedelsjaette_nn_1_1_N : N ;
  laensherre_nn_1_1_N : N ;
  laerjunge_nn_1_1_N : N ;
  laeskjaette_nn_1_1_N : N ;
  laeskaende_nn_1_1_N : N ;
  loepmage_nn_1_1_N : N ;
  loesmage_nn_1_1_N : N ;
  make_nn_1_N : N ;
  markservice_nn_1_N : N ;
  massage_nn_1_N : N ;
  massjaette_nn_1_1_N : N ;
  matchhjaelte_nn_1_1_N : N ;
  matte_nn_1_N : N ;
  meddelelse_nn_1_N : N ;
  medfaange_nn_1_1_N : N ;
  miljoebuse_nn_1_1_N : N ;
  miljoefoerstoerelse_nn_1_1_N : N ;
  miljoehjaelte_nn_1_1_N : N ;
  milkshake_nn_1_N : N ;
  minestrone_nn_1_N : N ;
  misstanke_nn_1_N : N ;
  mjukskalle_nn_1_N : N ;
  mjoelkmage_nn_1_1_N : N ;
  monke_nn_1_N : N ;
  musiktomte_nn_1_N : N ;
  muskelmage_nn_1_N : N ;
  mussemajje_nn_1_N : N ;
  musunge_nn_1_N : N ;
  mutgubbe_nn_1_N : N ;
  maenniskoande_nn_1_1_N : N ;
  maenniskoraettskaempe_nn_1_1_N : N ;
  maesshake_nn_1_1_N : N ;
  maangubbe_nn_1_1_N : N ;
  maasunge_nn_1_1_N : N ;
  moebeljaette_nn_1_1_N : N ;
  moensterfaange_nn_1_1_N : N ;
  moenstergosse_nn_1_1_N : N ;
  nalle_nn_1_N : N ;
  nare_nn_1_N : N ;
  nasse_nn_1_N : N ;
  nationalhjaelte_nn_1_1_N : N ;
  nervaende_nn_1_1_N : N ;
  nickhake_nn_1_N : N ;
  nisse_nn_1_N : N ;
  nitskalle_nn_1_N : N ;
  nonpareille_nn_1_N : N ;
  nordostpassage_nn_1_N : N ;
  noshoerningsunge_nn_1_1_N : N ;
  nymaane_nn_1_1_N : N ;
  naervarelse_nn_1_1_N : N ;
  naestunge_nn_1_1_N : N ;
  naetmage_nn_1_1_N : N ;
  ofoerstaaelse_nn_1_1_N : N ;
  omtanke_nn_1_N : N ;
  oppfyllelse_nn_1_N : N ;
  ostbaage_nn_1_1_N : N ;
  otillfredsstaellelse_nn_1_1_N : N ;
  oxfordroerelse_nn_1_1_N : N ;
  panikunge_nn_1_N : N ;
  pappskalle_nn_1_N : N ;
  pingstroerelse_nn_1_1_N : N ;
  pinoande_nn_1_N : N ;
  pliktuppfyllelse_nn_1_N : N ;
  plaagoande_nn_1_1_N : N ;
  plaatmage_nn_1_1_N : N ;
  pojkbokshjaelte_nn_1_1_N : N ;
  prestige_nn_1_N : N ;
  priffe_nn_1_N : N ;
  prydnadskudde_nn_1_N : N ;
  pubbeunge_nn_1_N : N ;
  putmage_nn_1_N : N ;
  paalle_nn_1_1_N : N ;
  paave_nn_1_1_N : N ;
  rackarunge_nn_1_N : N ;
  ragtime_nn_1_N : N ;
  rasse_nn_1_N : N ;
  rave_nn_1_N : N ;
  reggae_nn_1_N : N ;
  renmage_nn_1_N : N ;
  repaende_nn_1_1_N : N ;
  riksfurste_nn_1_N : N ;
  rikspolisstyrelse_nn_1_N : N ;
  rote_nn_1_N : N ;
  ruelse_nn_1_N : N ;
  rumpnisse_nn_1_N : N ;
  raeknenisse_nn_1_1_N : N ;
  raennstensunge_nn_1_1_N : N ;
  raettfaerdiggoerelse_nn_1_1_N : N ;
  raage_nn_1_1_N : N ;
  roedhake_nn_1_1_N : N ;
  roentgenstraale_nn_1_1_N : N ;
  sagohjaelte_nn_1_1_N : N ;
  saltlake_nn_1_N : N ;
  salvelse_nn_1_N : N ;
  samhaellsservice_nn_1_1_N : N ;
  samvetsfaange_nn_1_1_N : N ;
  sandhavre_nn_1_N : N ;
  sandkrasse_nn_1_N : N ;
  sanningslidelse_nn_1_N : N ;
  satunge_nn_1_N : N ;
  scoutroerelse_nn_1_1_N : N ;
  segerherre_nn_1_N : N ;
  segerhjaelte_nn_1_1_N : N ;
  service_nn_1_N : N ;
  shake_nn_1_N : N ;
  sidenkudde_nn_1_N : N ;
  sidoarvinge_nn_1_N : N ;
  sinnesglaedje_nn_1_1_N : N ;
  sittkudde_nn_1_N : N ;
  sjaelvhaevdelse_nn_1_1_N : N ;
  sjaelvstyrelse_nn_1_1_N : N ;
  sjaelvoevervinnelse_nn_1_1_N : N ;
  skadeglaedje_nn_1_1_N : N ;
  skandalunge_nn_1_N : N ;
  skare_nn_1_N : N ;
  skeppsgosse_nn_1_N : N ;
  skiffle_nn_1_N : N ;
  skinnknutte_nn_1_N : N ;
  skinnskalle_nn_1_N : N ;
  skogsdunge_nn_1_N : N ;
  skolgosse_nn_1_N : N ;
  skrumpnjure_nn_1_N : N ;
  skruvskalle_nn_1_N : N ;
  skyddsande_nn_1_N : N ;
  skoenande_nn_1_1_N : N ;
  skoenhetsjaette_nn_1_1_N : N ;
  slagskaempe_nn_1_1_N : N ;
  slivovice_nn_1_N : N ;
  slottsherre_nn_1_N : N ;
  smalaende_nn_1_1_N : N ;
  smaapaave_nn_1_1_N : N ;
  smoergaaskrasse_nn_1_1_N : N ;
  snickarglaedje_nn_1_1_N : N ;
  snorre_nn_1_N : N ;
  snorunge_nn_1_N : N ;
  snusjaette_nn_1_1_N : N ;
  socialstyrelse_nn_1_N : N ;
  software_nn_1_N : N ;
  solvaerme_nn_1_1_N : N ;
  sosse_nn_1_N : N ;
  spikskalle_nn_1_N : N ;
  spiselvaerme_nn_1_1_N : N ;
  sportfaane_nn_1_1_N : N ;
  sprue_nn_1_N : N ;
  spaerrhake_nn_1_1_N : N ;
  stiltje_nn_1_N : N ;
  stjaerngosse_nn_1_1_N : N ;
  stjaertgosse_nn_1_1_N : N ;
  storfurste_nn_1_N : N ;
  straffaange_nn_1_1_N : N ;
  strip_tease_nn_1_N : N ;
  striptease_nn_1_N : N ;
  strutsmage_nn_1_N : N ;
  stugvaerme_nn_1_1_N : N ;
  staalstomme_nn_1_1_N : N ;
  staalwire_nn_1_1_N : N ;
  svartskalle_nn_1_N : N ;
  svenne_nn_1_N : N ;
  syffe_nn_1_N : N ;
  syndafoerlaatelse_nn_1_1_N : N ;
  synekdoke_nn_1_N : N ;
  synkope_nn_1_N : N ;
  systole_nn_1_N : N ;
  saelunge_nn_1_1_N : N ;
  saengvaerme_nn_1_1_N : N ;
  saetthake_nn_1_1_N : N ;
  talldunge_nn_1_N : N ;
  tanke_nn_1_N : N ;
  tempelherre_nn_1_N : N ;
  tillblivelse_nn_1_N : N ;
  tillfredsstaellelse_nn_1_1_N : N ;
  tillintetgoerelse_nn_1_1_N : N ;
  tillaegnelse_nn_1_1_N : N ;
  tillaatelse_nn_1_1_N : N ;
  timbre_nn_1_N : N ;
  tjirre_nn_1_N : N ;
  tjockskalle_nn_1_N : N ;
  tjorre_nn_1_N : N ;
  tjurskalle_nn_1_N : N ;
  tjaele_nn_1_1_N : N ;
  tjaensteande_nn_1_1_N : N ;
  toffelhjaelte_nn_1_1_N : N ;
  tomte_nn_1_N : N ;
  tomtebisse_nn_1_N : N ;
  tomtegubbe_nn_1_N : N ;
  tomtenisse_nn_1_N : N ;
  toppaende_nn_1_1_N : N ;
  totalitetsbetydelse_nn_1_N : N ;
  trance_nn_1_N : N ;
  trasunge_nn_1_N : N ;
  trendnisse_nn_1_N : N ;
  trollgubbe_nn_1_N : N ;
  trollunge_nn_1_N : N ;
  tronarvinge_nn_1_N : N ;
  traekarlsbridge_nn_1_1_N : N ;
  traeningsglaedje_nn_1_1_N : N ;
  traeskalle_nn_1_1_N : N ;
  taete_nn_1_1_N : N ;
  ugnsvaerme_nn_1_1_N : N ;
  underkastelse_nn_1_N : N ;
  undersoekningsfaange_nn_1_1_N : N ;
  undervaerme_nn_1_1_N : N ;
  ungkyrkoroerelse_nn_1_1_N : N ;
  universalarvinge_nn_1_N : N ;
  uppbyggelse_nn_1_N : N ;
  uppfyllelse_nn_1_N : N ;
  uppgivelse_nn_1_N : N ;
  uppslagsaende_nn_1_1_N : N ;
  uppstaandelse_nn_1_1_N : N ;
  upptaeckarglaedje_nn_1_1_N : N ;
  utlevelse_nn_1_N : N ;
  valfurste_nn_1_N : N ;
  vallkrasse_nn_1_N : N ;
  vardagsfoerstaaelse_nn_1_1_N : N ;
  vargunge_nn_1_N : N ;
  vassle_nn_1_N : N ;
  vattenaloe_nn_1_N : N ;
  vattenkrasse_nn_1_N : N ;
  vattenskalle_nn_1_N : N ;
  veckoaende_nn_1_1_N : N ;
  veckaende_nn_1_1_N : N ;
  vejde_nn_1_N : N ;
  vildhavre_nn_1_N : N ;
  vinkelhake_nn_1_N : N ;
  vinnarskalle_nn_1_N : N ;
  visirlinje_nn_1_N : N ;
  vispgraedde_nn_1_1_N : N ;
  voile_nn_1_N : N ;
  vovve_nn_1_N : N ;
  vrede_nn_1_N : N ;
  vaemjelse_nn_1_1_N : N ;
  vaerldsberoemmelse_nn_1_1_N : N ;
  vaerme_nn_1_1_N : N ;
  vaermeroerelse_nn_1_1_N : N ;
  vaextroerelse_nn_1_1_N : N ;
  aelsklingsnalle_nn_1_1_N : N ;
  aengsgroee_nn_1_1_N : N ;
  aenterhake_nn_1_1_N : N ;
  aaminnelse_nn_1_1_N : N ;
  aangbildningsvaerme_nn_1_1_N : N ;
  aaterfoedelse_nn_1_1_N : N ;
  aaterstaellelse_nn_1_1_N : N ;
  aaterupplevelse_nn_1_1_N : N ;
  oelmage_nn_1_1_N : N ;
  oenskeuppfyllelse_nn_1_1_N : N ;
  oermage_nn_1_1_N : N ;
  oernbraekne_nn_1_1_N : N ;
  oevervaerme_nn_1_1_N : N ;
  Almedalsvecka_nn_1_N : N ;
  Asien_rundresa_nn_1_N : N ;
  Bachfuga_nn_1_N : N ;
  Bromelia_nn_1_N : N ;
  Brommamamma_nn_1_N : N ;
  C_durskala_nn_1_N : N ;
  Centauristjaerna_nn_1_1_N : N ;
  DNA_kedja_nn_1_N : N ;
  Dubaifrossa_nn_1_N : N ;
  EHEC_smitta_nn_1_N : N ;
  Fia_nn_1_N : N ;
  Frimurareorden_nn_1_N : N ;
  Frimurarorden_nn_1_N : N ;
  Gotlandsfaerja_nn_1_1_N : N ;
  Hagasessa_nn_1_N : N ;
  Hollywoodfru_nn_1_N : N ;
  ID_bricka_nn_1_N : N ;
  Japanoro_nn_1_N : N ;
  LED_lampa_nn_1_N : N ;
  Marsresa_nn_1_N : N ;
  Merca_nn_1_N : N ;
  Mersa_nn_1_N : N ;
  Montessoriskola_nn_1_N : N ;
  Maangfaldsbarometer_nn_1_1_N : N ;
  PCB_olja_nn_1_N : N ;
  Palestinafraaga_nn_1_1_N : N ;
  SAS_flygvaerdinna_nn_1_1_N : N ;
  Stockholmsarena_nn_1_N : N ;
  Strindbergsutgaava_nn_1_1_N : N ;
  T_troeja_nn_1_1_N : N ;
  TV_kamera_nn_1_N : N ;
  TV_ruta_nn_1_N : N ;
  TV_soffa_nn_1_N : N ;
  TV_saapa_nn_1_1_N : N ;
  Tjernobylolycka_nn_1_N : N ;
  Viagra_nn_1_N : N ;
  Visbyvecka_nn_1_N : N ;
  Volvo_nn_1_N : N ;
  Vaetternrunda_nn_1_1_N : N ;
  Zlatan_groda_nn_1_N : N ;
  _1_kanthylsa_nn_1_N : N ;
  _1_kantshylsa_nn_1_N : N ;
  _2_taktsolja_nn_1_N : N ;
  _40_aaring_nn_1_1_N : N ;
  abbedissa_nn_1_N : N ;
  abbreviering_nn_1_N : N ;
  abdikering_nn_1_N : N ;
  abessinska_nn_1_N : N ;
  abonnering_nn_1_N : N ;
  abortering_nn_1_N : N ;
  abortfraaga_nn_1_1_N : N ;
  abortraadgivning_nn_2_1_N : N ;
  abradering_nn_1_N : N ;
  abskissa_nn_1_N : N ;
  absolvering_nn_1_N : N ;
  absorbering_nn_1_N : N ;
  absorberingsfoermaaga_nn_1_1_N : N ;
  abstrahering_nn_1_N : N ;
  abstraktionsfoermaaga_nn_1_1_N : N ;
  accedering_nn_1_N : N ;
  accelerering_nn_1_N : N ;
  accentfoerskjutning_nn_1_1_N : N ;
  accentuering_nn_1_N : N ;
  acceptering_nn_1_N : N ;
  aceton_nn_1_N : N ;
  acetylenlampa_nn_1_N : N ;
  acetylsalicylsyra_nn_1_N : N ;
  ackja_nn_1_N : N ;
  acklimatisering_nn_1_N : N ;
  ackommodering_nn_1_N : N ;
  ackompanjering_nn_1_N : N ;
  ackordering_nn_1_N : N ;
  ackordssaettning_nn_1_1_N : N ;
  ackordsaettning_nn_1_1_N : N ;
  ackreditering_nn_1_N : N ;
  ackumulering_nn_1_N : N ;
  ackuschoerska_nn_1_1_N : N ;
  ackvirering_nn_1_N : N ;
  actionstjaerna_nn_1_1_N : N ;
  adaptering_nn_1_N : N ;
  addering_nn_1_N : N ;
  adel_nn_1_N : N ;
  adjungering_nn_1_N : N ;
  administrering_nn_1_N : N ;
  adoptering_nn_1_N : N ;
  adressering_nn_1_N : N ;
  adresslapp_nn_1_N : N ;
  adsorbering_nn_1_N : N ;
  aducering_nn_1_N : N ;
  adventsstjaerna_nn_1_1_N : N ;
  advocering_nn_1_N : N ;
  adxukiboena_nn_1_1_N : N ;
  afficiering_nn_1_N : N ;
  affinering_nn_1_N : N ;
  affischering_nn_1_N : N ;
  affrikata_nn_1_N : N ;
  affaersbegaavning_nn_1_1_N : N ;
  affaersgata_nn_1_1_N : N ;
  affaerskedja_nn_1_1_N : N ;
  affaersresa_nn_1_1_N : N ;
  affaersstaellning_nn_1_1_N : N ;
  affaersvaerld_nn_1_1_N : N ;
  afghanska_nn_1_N : N ;
  afghanska_nn_2_N : N ;
  afrikanisering_nn_1_N : N ;
  afrikanska_nn_1_N : N ;
  aftonklaenning_nn_1_1_N : N ;
  aftonskola_nn_1_N : N ;
  aftonstjaerna_nn_1_1_N : N ;
  aftontidning_nn_1_N : N ;
  aga_nn_2_N : N ;
  agenda_nn_1_N : N ;
  agglomerering_nn_1_N : N ;
  agglutinering_nn_1_N : N ;
  aggressionshaemning_nn_1_1_N : N ;
  agitationsvisa_nn_1_N : N ;
  agitering_nn_1_N : N ;
  ajournering_nn_1_N : N ;
  akacia_nn_1_N : N ;
  akillessena_nn_1_N : N ;
  akleja_nn_1_N : N ;
  aktersnurra_nn_1_N : N ;
  akterstaev_nn_1_1_N : N ;
  aktfoerklaring_nn_1_1_N : N ;
  aktgivning_nn_1_N : N ;
  aktiehandel_nn_1_N : N ;
  aktiesparklubb_nn_1_N : N ;
  aktiestock_nn_1_N : N ;
  aktieutdelning_nn_1_N : N ;
  aktivering_nn_1_N : N ;
  aktivitetsersaettning_nn_1_1_N : N ;
  aktning_nn_1_N : N ;
  aktualisering_nn_1_N : N ;
  akustikplatta_nn_1_N : N ;
  akutavdelning_nn_1_N : N ;
  akutmottagning_nn_1_N : N ;
  akvaplaning_nn_1_N : N ;
  akvarellutstaellning_nn_1_1_N : N ;
  alarmering_nn_1_N : N ;
  alarmklocka_nn_1_N : N ;
  alba_nn_1_N : N ;
  albanska_nn_1_N : N ;
  albanska_nn_2_N : N ;
  alfabetisering_nn_1_N : N ;
  alfastraalning_nn_1_1_N : N ;
  algblomning_nn_1_N : N ;
  algebra_nn_1_N : N ;
  algeriska_nn_1_N : N ;
  algmatta_nn_1_N : N ;
  algtvaett_nn_1_1_N : N ;
  alienering_nn_1_N : N ;
  alika_nn_1_N : N ;
  alisarin_nn_1_N : N ;
  alka_nn_1_N : N ;
  alkanna_nn_1_N : N ;
  alkoholfoertaering_nn_1_1_N : N ;
  alla_nn_1_N : N ;
  allegorisering_nn_1_N : N ;
  allfarvaeg_nn_1_1_N : N ;
  allhelgonamaessa_nn_1_1_N : N ;
  alliansring_nn_1_N : N ;
  alliering_nn_1_N : N ;
  allitterering_nn_1_N : N ;
  allmosa_nn_1_N : N ;
  allmaenbegaavning_nn_1_1_N : N ;
  allmaenbildning_nn_1_1_N : N ;
  allmaenning_nn_1_1_N : N ;
  allmaentjaenstgoering_nn_1_1_N : N ;
  allokering_nn_1_N : N ;
  allriskfoersaekring_nn_1_1_N : N ;
  allroundsaag_nn_1_1_N : N ;
  allsvenska_nn_1_N : N ;
  alludering_nn_1_N : N ;
  almanacka_nn_1_N : N ;
  alpacka_nn_1_N : N ;
  alruna_nn_1_N : N ;
  alstring_nn_1_N : N ;
  altanbraeda_nn_1_1_N : N ;
  altandoerr_nn_1_1_N : N ;
  altarduk_nn_1_N : N ;
  altargaang_nn_1_1_N : N ;
  altarlykta_nn_1_N : N ;
  altarmaalning_nn_1_1_N : N ;
  altarring_nn_1_N : N ;
  altartavla_nn_1_N : N ;
  altea_nn_1_N : N ;
  alternativfraaga_nn_1_1_N : N ;
  alternering_nn_1_N : N ;
  altita_nn_1_N : N ;
  altstaemma_nn_1_1_N : N ;
  aluminering_nn_1_N : N ;
  alun_nn_1_N : N ;
  alvar_nn_1_N : N ;
  amalgamering_nn_1_N : N ;
  amatoerbombtillverkning_nn_1_1_N : N ;
  ambulanssjukskoeterska_nn_1_1_N : N ;
  ambulering_nn_1_N : N ;
  amerikanisering_nn_1_N : N ;
  amerikanska_nn_1_N : N ;
  amerikanska_nn_2_N : N ;
  amfora_nn_1_N : N ;
  aminosyra_nn_1_N : N ;
  amma_nn_1_N : N ;
  ammoniakloesning_nn_1_1_N : N ;
  ammoniumnitratloesning_nn_1_1_N : N ;
  ammunitionsvaeska_nn_1_1_N : N ;
  amnestilag_nn_1_N : N ;
  amortering_nn_1_N : N ;
  amplifiering_nn_1_N : N ;
  amplitudmodulering_nn_1_N : N ;
  amputering_nn_1_N : N ;
  amsaga_nn_1_N : N ;
  amoeba_nn_1_1_N : N ;
  anakonda_nn_1_N : N ;
  analfena_nn_1_N : N ;
  analogibildning_nn_1_N : N ;
  analysering_nn_1_N : N ;
  analoeppning_nn_1_1_N : N ;
  anbefallning_nn_1_N : N ;
  anblick_nn_1_N : N ;
  anblaaspipa_nn_1_1_N : N ;
  anbringning_nn_1_N : N ;
  andefattigdom_nn_1_N : N ;
  andelsfoerening_nn_1_1_N : N ;
  andemening_nn_1_N : N ;
  andevaerld_nn_1_1_N : N ;
  andhaemtning_nn_1_1_N : N ;
  andning_nn_1_N : N ;
  andorranska_nn_1_N : N ;
  andrabil_nn_1_N : N ;
  andraderivata_nn_1_N : N ;
  andrahandskaella_nn_1_1_N : N ;
  andraplacering_nn_1_N : N ;
  andraslagsfoermaaga_nn_1_1_N : N ;
  andratidning_nn_1_N : N ;
  anekdotflora_nn_1_N : N ;
  anflygning_nn_1_N : N ;
  anfraetning_nn_1_1_N : N ;
  anfaektning_nn_1_1_N : N ;
  anfoering_nn_1_1_N : N ;
  angina_nn_1_N : N ;
  anglisering_nn_1_N : N ;
  angolanska_nn_1_N : N ;
  anhopning_nn_1_N : N ;
  anhaengarskara_nn_1_1_N : N ;
  anhoerigdag_nn_1_1_N : N ;
  anilin_nn_1_N : N ;
  animering_nn_1_N : N ;
  aning_nn_1_N : N ;
  anisolja_nn_1_N : N ;
  anka_nn_1_N : N ;
  ankarkropp_nn_1_N : N ;
  ankarkaetting_nn_1_1_N : N ;
  ankarlindning_nn_1_N : N ;
  ankarstock_nn_1_N : N ;
  ankdamm_nn_1_N : N ;
  ankelsocka_nn_1_N : N ;
  anklaepp_nn_1_1_N : N ;
  anknytning_nn_1_N : N ;
  ankring_nn_1_N : N ;
  anledning_nn_1_N : N ;
  anliggning_nn_1_N : N ;
  anliggningsyta_nn_1_N : N ;
  anlaeggning_nn_1_1_N : N ;
  anlaeggningstillgaang_nn_1_1_N : N ;
  anlaeggningsyta_nn_1_1_N : N ;
  anloepning_nn_1_1_N : N ;
  anmaning_nn_1_N : N ;
  anmaelning_nn_1_1_N : N ;
  anmaerkning_nn_1_1_N : N ;
  annektering_nn_1_N : N ;
  annexfoersamling_nn_1_1_N : N ;
  annexkyrka_nn_1_N : N ;
  annihilering_nn_1_N : N ;
  annonsering_nn_1_N : N ;
  annonstavla_nn_1_N : N ;
  annonstidning_nn_1_N : N ;
  annotering_nn_1_N : N ;
  annullering_nn_1_N : N ;
  anodisering_nn_1_N : N ;
  anonymisering_nn_1_N : N ;
  anordning_nn_1_N : N ;
  anpassling_nn_1_N : N ;
  anpassning_nn_1_N : N ;
  anpassningsfoermaaga_nn_1_1_N : N ;
  anrikning_nn_1_N : N ;
  anrikningsanlaeggning_nn_1_1_N : N ;
  anropning_nn_1_N : N ;
  anropsknapp_nn_1_N : N ;
  anraettning_nn_1_1_N : N ;
  ansamling_nn_1_N : N ;
  ansatsbana_nn_1_N : N ;
  ansiktsbjudning_nn_1_N : N ;
  ansiktsfoerlamning_nn_1_1_N : N ;
  ansiktslyftning_nn_1_N : N ;
  ansiktsskada_nn_1_N : N ;
  anskaffning_nn_1_N : N ;
  anslagsframstaellning_nn_1_1_N : N ;
  anslagstavla_nn_1_N : N ;
  anslutning_nn_1_N : N ;
  anslutningssladd_nn_1_N : N ;
  ansning_nn_1_N : N ;
  anspelning_nn_1_N : N ;
  anspaenning_nn_1_1_N : N ;
  anstormning_nn_1_N : N ;
  anstrykning_nn_1_N : N ;
  anstraengning_nn_1_1_N : N ;
  anstaellning_nn_1_1_N : N ;
  ansvarighetsfoersaekring_nn_1_1_N : N ;
  ansvaring_nn_1_N : N ;
  ansvarsfoersaekring_nn_1_1_N : N ;
  ansvaellning_nn_1_1_N : N ;
  ansaettning_nn_1_1_N : N ;
  ansaettningsskruv_nn_1_1_N : N ;
  ansoekning_nn_1_1_N : N ;
  ansoekningshandling_nn_1_1_N : N ;
  antagning_nn_1_N : N ;
  antavla_nn_1_N : N ;
  antecipering_nn_1_N : N ;
  anteckning_nn_1_N : N ;
  antedatering_nn_1_N : N ;
  antepenultima_nn_1_N : N ;
  antiabortlag_nn_1_N : N ;
  antibiotika_nn_1_N : N ;
  antichambrering_nn_1_N : N ;
  antiguanska_nn_1_N : N ;
  antikisering_nn_1_N : N ;
  antikvitetssamling_nn_1_N : N ;
  antimon_nn_1_N : N ;
  antiskating_nn_1_N : N ;
  antydning_nn_1_N : N ;
  antaendning_nn_1_1_N : N ;
  anvisning_nn_1_N : N ;
  anvaendning_nn_1_1_N : N ;
  anvaendningsloesning_nn_1_1_N : N ;
  apa_nn_1_N : N ;
  apartheidlag_nn_1_N : N ;
  apelsinklyfta_nn_1_N : N ;
  apelsinmoussetaarta_nn_1_1_N : N ;
  aphjaerna_nn_1_1_N : N ;
  aphona_nn_1_N : N ;
  apmaenniska_nn_1_1_N : N ;
  apollofjaeril_nn_1_1_N : N ;
  apostrofering_nn_1_N : N ;
  apotekskedja_nn_1_N : N ;
  appellationsdomstol_nn_1_N : N ;
  appellering_nn_1_N : N ;
  applicering_nn_1_N : N ;
  applaadering_nn_1_1_N : N ;
  applaadaaska_nn_1_1_N : N ;
  apportering_nn_1_N : N ;
  appreciering_nn_1_N : N ;
  appretering_nn_1_N : N ;
  approchering_nn_1_N : N ;
  approximering_nn_1_N : N ;
  aprildag_nn_1_N : N ;
  aptering_nn_1_N : N ;
  ara_nn_1_N : N ;
  arabiska_nn_1_N : N ;
  arabiska_nn_2_N : N ;
  aralia_nn_1_N : N ;
  arameiska_nn_1_N : N ;
  arbetarfoerening_nn_1_1_N : N ;
  arbetarregering_nn_1_N : N ;
  arbetsbelastning_nn_1_N : N ;
  arbetsbelysning_nn_1_N : N ;
  arbetsbeskrivning_nn_1_N : N ;
  arbetsbaenk_nn_1_1_N : N ;
  arbetsboerda_nn_1_1_N : N ;
  arbetsdag_nn_1_N : N ;
  arbetsdelning_nn_1_N : N ;
  arbetsdomstol_nn_1_N : N ;
  arbetsfoermedling_nn_1_1_N : N ;
  arbetsfoermaaga_nn_1_1_N : N ;
  arbetsfoermaageutredning_nn_1_1_N : N ;
  arbetsgivarefoerening_nn_1_1_N : N ;
  arbetsgivarfoerening_nn_1_1_N : N ;
  arbetsinraettning_nn_1_1_N : N ;
  arbetsjacka_nn_1_N : N ;
  arbetskarl_nn_1_N : N ;
  arbetsmarknadsutbildning_nn_1_N : N ;
  arbetsmyra_nn_1_N : N ;
  arbetsmaetning_nn_1_1_N : N ;
  arbetsordning_nn_1_N : N ;
  arbetsplatsolycka_nn_1_N : N ;
  arbetsskada_nn_1_N : N ;
  arbetsstyrka_nn_1_N : N ;
  arbetstidsreglering_nn_1_N : N ;
  arbetstraening_nn_1_1_N : N ;
  arbetsvecka_nn_1_N : N ;
  arbetsvilja_nn_1_N : N ;
  arbetsvaerdering_nn_1_1_N : N ;
  area_nn_1_N : N ;
  arena_nn_1_N : N ;
  argbigga_nn_1_N : N ;
  argentinska_nn_1_N : N ;
  argon_nn_1_N : N ;
  argumentering_nn_1_N : N ;
  aria_nn_1_N : N ;
  ariadnetraad_nn_1_1_N : N ;
  arkaisering_nn_1_N : N ;
  arkebusering_nn_1_N : N ;
  arkivering_nn_1_N : N ;
  arkivsamling_nn_1_N : N ;
  armada_nn_1_N : N ;
  armborstpil_nn_1_N : N ;
  armborstskytt_nn_1_N : N ;
  armbrytning_nn_1_N : N ;
  armboejning_nn_1_1_N : N ;
  armeniska_nn_1_N : N ;
  armeniska_nn_2_N : N ;
  armering_nn_1_N : N ;
  armflaeta_nn_1_1_N : N ;
  armfoting_nn_1_N : N ;
  armfoering_nn_1_1_N : N ;
  armhaevning_nn_1_1_N : N ;
  armhaala_nn_1_1_N : N ;
  armkrok_nn_1_N : N ;
  armring_nn_1_N : N ;
  armskada_nn_1_N : N ;
  armstyrka_nn_1_N : N ;
  arm_eavdelning_nn_1_1_N : N ;
  arm_efoerdelning_nn_1_1_N : N ;
  aromkupa_nn_1_N : N ;
  arrangering_nn_1_N : N ;
  arrendering_nn_1_N : N ;
  arrestavdelning_nn_1_N : N ;
  arrestering_nn_1_N : N ;
  arrondering_nn_1_N : N ;
  arsenikfoergiftning_nn_1_1_N : N ;
  artbestaemning_nn_1_1_N : N ;
  artbildning_nn_1_N : N ;
  artikulering_nn_1_N : N ;
  artilleribeskjutning_nn_1_N : N ;
  artistbana_nn_1_N : N ;
  artonaaring_nn_1_1_N : N ;
  artonaarsdag_nn_1_1_N : N ;
  arvejord_nn_1_N : N ;
  arvfoerening_nn_1_1_N : N ;
  arvodering_nn_1_N : N ;
  arvsmassa_nn_1_N : N ;
  asagud_nn_1_N : N ;
  asatro_nn_1_N : N ;
  asbestcement_nn_1_N : N ;
  asbestlunga_nn_1_N : N ;
  asbestplatta_nn_1_N : N ;
  asbestsanering_nn_1_N : N ;
  asfaltering_nn_1_N : N ;
  asfaltplatta_nn_1_N : N ;
  asfyxiskada_nn_1_N : N ;
  asiatiska_nn_1_N : N ;
  aska_nn_1_N : N ;
  askorbinsyra_nn_1_N : N ;
  associationsbana_nn_1_N : N ;
  associationskedja_nn_1_N : N ;
  assuransspruta_nn_1_N : N ;
  assyriska_nn_1_N : N ;
  assyriska_nn_2_N : N ;
  asynja_nn_1_N : N ;
  atlas_nn_2_N : N ;
  atlaskota_nn_1_N : N ;
  atombrygga_nn_1_N : N ;
  atomklocka_nn_1_N : N ;
  atomkaerna_nn_1_1_N : N ;
  atommassa_nn_1_N : N ;
  atropin_nn_1_N : N ;
  attach_evaeska_nn_1_1_N : N ;
  attackfoermaaga_nn_1_1_N : N ;
  attika_nn_1_N : N ;
  attila_nn_1_N : N ;
  au_pair_flicka_nn_1_N : N ;
  auerlampa_nn_1_N : N ;
  auerstrumpa_nn_1_N : N ;
  augustidag_nn_1_N : N ;
  auktoritetstro_nn_1_N : N ;
  aula_nn_1_N : N ;
  australiska_nn_1_N : N ;
  autostrada_nn_1_N : N ;
  ava_nn_1_N : N ;
  avdelningsskoeterska_nn_1_1_N : N ;
  avel_nn_1_N : N ;
  avfallsraavara_nn_1_1_N : N ;
  aviga_nn_1_N : N ;
  avigsida_nn_1_N : N ;
  avisa_nn_1_N : N ;
  avkomma_nn_1_N : N ;
  avresa_nn_1_N : N ;
  avraekningsnota_nn_1_1_N : N ;
  avraettningslista_nn_1_1_N : N ;
  avslappningsskiva_nn_1_N : N ;
  avstaellningsyta_nn_1_1_N : N ;
  axelboessa_nn_1_1_N : N ;
  axelremsvaeska_nn_1_1_N : N ;
  axillarkrycka_nn_1_N : N ;
  ayatolla_nn_1_N : N ;
  azalea_nn_1_N : N ;
  azerbajdzjanska_nn_1_N : N ;
  azerbajdzjanska_nn_2_N : N ;
  babordsaara_nn_1_1_N : N ;
  babusjka_nn_1_N : N ;
  babybyxa_nn_1_N : N ;
  babylycka_nn_1_N : N ;
  backa_nn_1_N : N ;
  backgammon_nn_1_N : N ;
  backsippa_nn_1_N : N ;
  backstuga_nn_1_N : N ;
  backsvala_nn_1_N : N ;
  backsoeta_nn_1_1_N : N ;
  bacon_nn_1_N : N ;
  badbyxa_nn_1_N : N ;
  badflicka_nn_1_N : N ;
  badkappa_nn_1_N : N ;
  badklippa_nn_1_N : N ;
  badminton_nn_1_N : N ;
  badmoessa_nn_1_1_N : N ;
  badresa_nn_1_N : N ;
  badsjoe_nn_1_1_N : N ;
  badstuga_nn_1_N : N ;
  bagage_nn_2_N : N ;
  bagagekaerra_nn_1_1_N : N ;
  bagagelucka_nn_1_N : N ;
  bagarmoessa_nn_1_1_N : N ;
  bagarstuga_nn_1_N : N ;
  bahamanska_nn_1_N : N ;
  bahrainska_nn_1_N : N ;
  bajonettbalja_nn_1_N : N ;
  bakficka_nn_1_N : N ;
  bakfylla_nn_1_N : N ;
  bakgata_nn_1_N : N ;
  bakkappa_nn_1_N : N ;
  baklampa_nn_1_N : N ;
  baklucka_nn_1_N : N ;
  baklaexa_nn_1_1_N : N ;
  bakruta_nn_1_N : N ;
  baksida_nn_1_N : N ;
  baksmaella_nn_1_1_N : N ;
  bakaenda_nn_1_1_N : N ;
  balalajka_nn_1_N : N ;
  balettflicka_nn_1_N : N ;
  balja_nn_1_N : N ;
  ballerina_nn_1_N : N ;
  balsa_nn_1_N : N ;
  baltiska_nn_1_N : N ;
  bamba_nn_1_N : N ;
  bambusoffa_nn_1_N : N ;
  bana_nn_1_N : N ;
  bananfluga_nn_1_N : N ;
  bandyklubba_nn_1_N : N ;
  bangladeshiska_nn_1_N : N ;
  bankirfirma_nn_1_N : N ;
  bannbulla_nn_1_N : N ;
  barbadiska_nn_1_N : N ;
  barnafoederska_nn_1_1_N : N ;
  barnaskara_nn_1_N : N ;
  barnatro_nn_1_N : N ;
  barnflicka_nn_1_N : N ;
  barnkammarsaga_nn_1_N : N ;
  barnmisshandel_nn_1_N : N ;
  barnmorska_nn_1_N : N ;
  barnpiga_nn_1_N : N ;
  barnporrhaerva_nn_1_1_N : N ;
  barnsaga_nn_1_N : N ;
  barnskottkaerra_nn_1_1_N : N ;
  barnskoeterska_nn_1_1_N : N ;
  barnsmugglarliga_nn_1_N : N ;
  barnsnor_nn_1_N : N ;
  barnstuga_nn_1_N : N ;
  barnsaengskvinna_nn_1_1_N : N ;
  barnvattenkanna_nn_1_N : N ;
  barnvisa_nn_1_N : N ;
  barockpaerla_nn_1_1_N : N ;
  baronessa_nn_1_N : N ;
  barrskogsnunna_nn_1_N : N ;
  barrtraedsplanta_nn_1_1_N : N ;
  basilika_nn_1_N : N ;
  baskiska_nn_1_N : N ;
  baskiska_nn_2_N : N ;
  basplatta_nn_1_N : N ;
  basstraecka_nn_1_1_N : N ;
  basstaemma_nn_1_1_N : N ;
  bastmatta_nn_1_N : N ;
  bastrumma_nn_1_N : N ;
  bastuba_nn_1_N : N ;
  basvara_nn_1_N : N ;
  basyta_nn_1_N : N ;
  batteriklaemma_nn_1_1_N : N ;
  bazooka_nn_1_N : N ;
  bea_nn_1_N : N ;
  bebaadelsedag_nn_1_1_N : N ;
  beckpaerla_nn_1_1_N : N ;
  bedragerska_nn_1_N : N ;
  begonia_nn_1_N : N ;
  begravningskassa_nn_1_N : N ;
  begraensningsyta_nn_1_1_N : N ;
  behaa_nn_1_1_N : N ;
  bekymmersrynka_nn_1_N : N ;
  belastningsskada_nn_1_N : N ;
  belgiska_nn_1_N : N ;
  beliziska_nn_1_N : N ;
  belysningsmaessa_nn_1_1_N : N ;
  belysningsstyrka_nn_1_N : N ;
  bemaerkelsedag_nn_1_1_N : N ;
  bena_nn_1_N : N ;
  benaska_nn_1_N : N ;
  benediktinerorden_nn_1_N : N ;
  benediktinorden_nn_1_N : N ;
  bengaedda_nn_1_1_N : N ;
  benhinna_nn_1_N : N ;
  beninska_nn_1_N : N ;
  benknota_nn_1_N : N ;
  benpipa_nn_1_N : N ;
  benroeta_nn_1_1_N : N ;
  benskada_nn_1_N : N ;
  benskena_nn_1_N : N ;
  bensoesyra_nn_1_N : N ;
  berg_och_dalbana_nn_1_N : N ;
  bergbana_nn_1_N : N ;
  berggylta_nn_1_N : N ;
  bergolja_nn_1_N : N ;
  bergsgorilla_nn_1_N : N ;
  bergskedja_nn_1_N : N ;
  bergsklyfta_nn_1_N : N ;
  bergskreva_nn_1_N : N ;
  bergssida_nn_1_N : N ;
  bergsskola_nn_1_N : N ;
  bergsyra_nn_1_N : N ;
  beraettarfoermaaga_nn_1_1_N : N ;
  besksoeta_nn_1_1_N : N ;
  beslutsfoermaaga_nn_1_1_N : N ;
  besprutningsvaetska_nn_1_1_N : N ;
  besvaersinlaga_nn_1_1_N : N ;
  beta_nn_1_N : N ;
  betalningsdag_nn_1_N : N ;
  betalningsvilja_nn_1_N : N ;
  betongsugga_nn_1_N : N ;
  bettskena_nn_1_N : N ;
  betydelselaera_nn_1_1_N : N ;
  betygsskala_nn_1_N : N ;
  beundrarinna_nn_1_N : N ;
  bevakningsinlaga_nn_1_N : N ;
  bevakningskedja_nn_1_N : N ;
  bevisboerda_nn_1_1_N : N ;
  beviskedja_nn_1_N : N ;
  bhutanesiska_nn_1_N : N ;
  biavel_nn_1_N : N ;
  bibana_nn_1_N : N ;
  bibliofilupplaga_nn_1_N : N ;
  bibliotekshoegskola_nn_1_1_N : N ;
  biblomma_nn_1_N : N ;
  biceps_nn_1_N : N ;
  bicepssena_nn_1_N : N ;
  biffyxa_nn_1_N : N ;
  bigata_nn_1_N : N ;
  bihuva_nn_1_N : N ;
  bihaala_nn_1_1_N : N ;
  bikarbonat_nn_1_N : N ;
  bikrona_nn_1_N : N ;
  bikupa_nn_1_N : N ;
  bila_nn_1_N : N ;
  bilaga_nn_1_N : N ;
  bilbana_nn_1_N : N ;
  bildgaata_nn_1_1_N : N ;
  bildkarta_nn_1_N : N ;
  bildningsvaerme_nn_1_1_N : N ;
  bildruta_nn_1_N : N ;
  bilfaerja_nn_1_1_N : N ;
  biljettficka_nn_1_N : N ;
  biljetthaerva_nn_1_1_N : N ;
  biljettlucka_nn_1_N : N ;
  bilkarta_nn_1_N : N ;
  billa_nn_1_N : N ;
  billampa_nn_1_N : N ;
  billighetsupplaga_nn_1_N : N ;
  billykta_nn_1_N : N ;
  bilolycka_nn_1_N : N ;
  bilruta_nn_1_N : N ;
  bilsjuka_nn_1_N : N ;
  bilskola_nn_1_N : N ;
  bilslaepkaerra_nn_1_1_N : N ;
  bilyxa_nn_1_N : N ;
  binda_nn_1_N : N ;
  bindehinna_nn_1_N : N ;
  bindsula_nn_1_N : N ;
  bindvaevshinna_nn_1_1_N : N ;
  binga_nn_1_N : N ;
  bingobricka_nn_1_N : N ;
  binka_nn_1_N : N ;
  biomassa_nn_1_N : N ;
  bira_nn_1_N : N ;
  bisamraatta_nn_1_1_N : N ;
  biskopskraeckla_nn_1_1_N : N ;
  biskopskraekla_nn_1_1_N : N ;
  biskopsmoessa_nn_1_1_N : N ;
  bissauguineanska_nn_1_N : N ;
  bisyssla_nn_1_N : N ;
  bittermandelolja_nn_1_N : N ;
  bittersoeta_nn_1_1_N : N ;
  bjugg_nn_1_N : N ;
  bjaellra_nn_1_1_N : N ;
  bjoerkna_nn_1_1_N : N ;
  bjoernfloka_nn_1_1_N : N ;
  bjoernhona_nn_1_1_N : N ;
  bjoerninna_nn_1_1_N : N ;
  bjoernloka_nn_1_1_N : N ;
  bjoernskinnsmoessa_nn_1_1_N : N ;
  bladloppa_nn_1_N : N ;
  bladmossa_nn_1_N : N ;
  bladskaerarmyra_nn_1_1_N : N ;
  blaffa_nn_1_N : N ;
  blanddricka_nn_1_N : N ;
  blanka_nn_1_N : N ;
  blanksmoerja_nn_1_1_N : N ;
  blaska_nn_1_N : N ;
  bleke_nn_1_N : N ;
  blekingseka_nn_1_N : N ;
  blekingska_nn_1_N : N ;
  blekingska_nn_2_N : N ;
  blekvaetska_nn_1_1_N : N ;
  blemma_nn_1_N : N ;
  blida_nn_1_N : N ;
  blinda_nn_1_N : N ;
  blindbotten_nn_1_N : N ;
  blindgata_nn_1_N : N ;
  blindkarta_nn_1_N : N ;
  blindlykta_nn_1_N : N ;
  blindnaessla_nn_1_1_N : N ;
  blindpipa_nn_1_N : N ;
  blindskola_nn_1_N : N ;
  blinkhinna_nn_1_N : N ;
  blixtlampa_nn_1_N : N ;
  blockalmanacka_nn_1_N : N ;
  blockskiva_nn_1_N : N ;
  blocktalja_nn_1_N : N ;
  blocktrissa_nn_1_N : N ;
  blod_nn_1_N : N ;
  blodblaasa_nn_1_1_N : N ;
  blodnaeva_nn_1_1_N : N ;
  blodplasma_nn_1_N : N ;
  blodriska_nn_1_N : N ;
  blodsockersvacka_nn_1_N : N ;
  blodvaetska_nn_1_1_N : N ;
  blombotten_nn_1_N : N ;
  blomkrona_nn_1_N : N ;
  blomkruka_nn_1_N : N ;
  blomlaada_nn_1_1_N : N ;
  blomma_nn_1_N : N ;
  blomplanta_nn_1_N : N ;
  blomsterflicka_nn_1_N : N ;
  blomsterfoersaeljerska_nn_1_1_N : N ;
  blomsterlaada_nn_1_1_N : N ;
  blomsterspruta_nn_1_N : N ;
  blotta_nn_1_N : N ;
  bluffaktura_nn_1_N : N ;
  blunddocka_nn_1_N : N ;
  blyaska_nn_1_N : N ;
  blyblomma_nn_1_N : N ;
  blyertspenna_nn_1_N : N ;
  blyglete_nn_1_N : N ;
  blykula_nn_1_N : N ;
  blaecka_nn_1_1_N : N ;
  blaeckblaasa_nn_1_1_N : N ;
  blaeckpenna_nn_1_1_N : N ;
  blaeddra_nn_1_1_N : N ;
  blaendskiva_nn_1_1_N : N ;
  blaabaerspannkaka_nn_1_1_N : N ;
  blaaduva_nn_1_1_N : N ;
  blaaholts_nn_1_1_N : N ;
  blaajacka_nn_1_1_N : N ;
  blaaklocka_nn_1_1_N : N ;
  blaakopia_nn_1_1_N : N ;
  blaakraaka_nn_1_1_N : N ;
  blaamussla_nn_1_1_N : N ;
  blaapenna_nn_1_1_N : N ;
  blaasa_nn_1_1_N : N ;
  blaasippa_nn_1_1_N : N ;
  blaaslampa_nn_1_1_N : N ;
  blaastrumpa_nn_1_1_N : N ;
  blaasyra_nn_1_1_N : N ;
  blaatira_nn_1_1_N : N ;
  blaatunga_nn_1_1_N : N ;
  bloeja_nn_1_1_N : N ;
  bloejaalder_nn_1_1_N : N ;
  bloetroeta_nn_1_1_N : N ;
  boa_nn_1_N : N ;
  bobba_nn_1_N : N ;
  bockbro_nn_1_N : N ;
  bodega_nn_1_N : N ;
  bodlaenga_nn_1_1_N : N ;
  bogserlina_nn_1_N : N ;
  bohuseka_nn_1_N : N ;
  bohuslaenska_nn_1_1_N : N ;
  bohuslaenska_nn_2_1_N : N ;
  boja_nn_1_N : N ;
  bokhylla_nn_1_N : N ;
  boklaada_nn_1_1_N : N ;
  bokmaessa_nn_1_1_N : N ;
  bokrea_nn_1_N : N ;
  boksida_nn_1_N : N ;
  bokstavstro_nn_1_N : N ;
  bolagsstaemma_nn_1_1_N : N ;
  bolivianska_nn_1_N : N ;
  bolaaneraenta_nn_1_1_N : N ;
  bombmatta_nn_1_N : N ;
  bomolja_nn_1_N : N ;
  bomullsfroekaka_nn_1_1_N : N ;
  bomullsfroeolja_nn_1_1_N : N ;
  bomullsskjorta_nn_1_N : N ;
  bondboena_nn_1_1_N : N ;
  bondepraktika_nn_1_N : N ;
  bondflicka_nn_1_N : N ;
  bondmora_nn_1_N : N ;
  bondska_nn_1_N : N ;
  bondstuga_nn_1_N : N ;
  bondtolva_nn_1_N : N ;
  bondvischa_nn_1_N : N ;
  bongotrumma_nn_1_N : N ;
  boprisbubbla_nn_1_N : N ;
  bordeauxvaetska_nn_1_1_N : N ;
  bordskiva_nn_1_N : N ;
  bordskrydda_nn_1_N : N ;
  bordslampa_nn_1_N : N ;
  bordsskiva_nn_1_N : N ;
  borgarskola_nn_1_N : N ;
  borgenssumma_nn_1_N : N ;
  boricka_nn_1_N : N ;
  borrklinka_nn_1_N : N ;
  borrkrona_nn_1_N : N ;
  borrkaerna_nn_1_1_N : N ;
  borrmussla_nn_1_N : N ;
  borrningsolycka_nn_1_N : N ;
  borstnejlika_nn_1_N : N ;
  borsyra_nn_1_N : N ;
  bortresa_nn_1_N : N ;
  bortaenda_nn_1_1_N : N ;
  bosniska_nn_1_N : N ;
  bostadsbubbla_nn_1_N : N ;
  bostadslaenga_nn_1_1_N : N ;
  bostongurka_nn_1_N : N ;
  botox_nn_1_N : N ;
  botswanska_nn_1_N : N ;
  botten_nn_1_N : N ;
  bottenplatta_nn_1_N : N ;
  bottenskola_nn_1_N : N ;
  bottenskrapa_nn_1_N : N ;
  bottenskyla_nn_1_N : N ;
  bottenyta_nn_1_N : N ;
  bowlingbana_nn_1_N : N ;
  bracka_nn_1_N : N ;
  brakskiva_nn_1_N : N ;
  bralla_nn_1_N : N ;
  brandbotten_nn_1_N : N ;
  brandfackla_nn_1_N : N ;
  brandgata_nn_1_N : N ;
  brandskada_nn_1_N : N ;
  brandspruta_nn_1_N : N ;
  brandstyrka_nn_1_N : N ;
  branschvana_nn_1_N : N ;
  brasa_nn_1_N : N ;
  brasilianska_nn_1_N : N ;
  bravuraria_nn_1_N : N ;
  braxen_nn_1_N : N ;
  braxenmygga_nn_1_N : N ;
  braxenpanka_nn_1_N : N ;
  breccia_nn_1_N : N ;
  bredsida_nn_1_N : N ;
  bretagniska_nn_1_N : N ;
  bretagniska_nn_2_N : N ;
  bretonska_nn_1_N : N ;
  bretonska_nn_2_N : N ;
  brevduva_nn_1_N : N ;
  brevfraaga_nn_1_1_N : N ;
  brevlaada_nn_1_1_N : N ;
  brevskola_nn_1_N : N ;
  bricka_nn_1_N : N ;
  briljantin_nn_1_N : N ;
  bringa_nn_1_N : N ;
  brinnstraecka_nn_1_1_N : N ;
  bristvara_nn_1_N : N ;
  brittiska_nn_1_N : N ;
  brittmaessa_nn_1_1_N : N ;
  bro_nn_1_N : N ;
  brobana_nn_1_N : N ;
  brokista_nn_1_N : N ;
  brolla_nn_1_N : N ;
  bromelia_nn_1_N : N ;
  bromsolja_nn_1_N : N ;
  bromsskiva_nn_1_N : N ;
  bromsstraecka_nn_1_1_N : N ;
  bromstrumma_nn_1_N : N ;
  bromsvaetska_nn_1_1_N : N ;
  bromvaetesyra_nn_1_1_N : N ;
  bronskanna_nn_1_N : N ;
  bronstavla_nn_1_N : N ;
  bronsaalder_nn_1_1_N : N ;
  bronsaaldersmaenniska_nn_1_1_N : N ;
  broolycka_nn_1_N : N ;
  broplanka_nn_1_N : N ;
  brorsa_nn_1_N : N ;
  broskhinna_nn_1_N : N ;
  broskskiva_nn_1_N : N ;
  brottsjoe_nn_1_1_N : N ;
  brottyta_nn_1_N : N ;
  brudfraemma_nn_1_1_N : N ;
  brudgaava_nn_1_1_N : N ;
  brudkrona_nn_1_N : N ;
  brudsloeja_nn_1_1_N : N ;
  brudtaerna_nn_1_1_N : N ;
  bruksvaerdeshyra_nn_1_1_N : N ;
  bruneiska_nn_1_N : N ;
  brunkulla_nn_1_N : N ;
  brunroeta_nn_1_1_N : N ;
  brunskjorta_nn_1_N : N ;
  brunskaera_nn_1_1_N : N ;
  brutta_nn_1_N : N ;
  brygga_nn_1_N : N ;
  brynja_nn_1_N : N ;
  brysselmatta_nn_1_N : N ;
  brytboena_nn_1_1_N : N ;
  brytningsfoermaaga_nn_1_1_N : N ;
  braeken_nn_1_1_N : N ;
  braennblaasa_nn_1_1_N : N ;
  braennlack_nn_1_1_N : N ;
  braennolja_nn_1_1_N : N ;
  braennskada_nn_1_1_N : N ;
  braennvinsnaesa_nn_1_1_N : N ;
  braennyta_nn_1_1_N : N ;
  braennaessla_nn_1_1_N : N ;
  braesma_nn_1_1_N : N ;
  braess_nn_1_1_N : N ;
  braaka_nn_1_1_N : N ;
  braate_nn_1_1_N : N ;
  broedkaka_nn_1_1_N : N ;
  broedskiva_nn_1_1_N : N ;
  broedsmula_nn_1_1_N : N ;
  broellopsgaava_nn_1_1_N : N ;
  broellopsresa_nn_1_1_N : N ;
  broellopstaarta_nn_1_1_N : N ;
  broellopsyra_nn_1_1_N : N ;
  broesta_nn_1_1_N : N ;
  broestfena_nn_1_1_N : N ;
  broestficka_nn_1_1_N : N ;
  broesthaala_nn_1_1_N : N ;
  broestkota_nn_1_1_N : N ;
  broestvaarta_nn_1_1_N : N ;
  bubbla_nn_1_N : N ;
  buckla_nn_1_N : N ;
  buddha_nn_1_N : N ;
  budgetresa_nn_1_N : N ;
  buffa_nn_1_N : N ;
  buffaopera_nn_1_N : N ;
  buffringsfoermaaga_nn_1_1_N : N ;
  bukhinna_nn_1_N : N ;
  bukhaala_nn_1_1_N : N ;
  bukspott_nn_1_N : N ;
  bula_nn_1_N : N ;
  buldan_nn_1_N : N ;
  bulgariska_nn_1_N : N ;
  bulgariska_nn_2_N : N ;
  bulgur_nn_1_N : N ;
  bulla_nn_1_N : N ;
  bullermatta_nn_1_N : N ;
  bullerskada_nn_1_N : N ;
  bullshit_nn_1_N : N ;
  bunkringsolja_nn_1_N : N ;
  burka_nn_1_N : N ;
  burkinska_nn_1_N : N ;
  burmanska_nn_1_N : N ;
  burmanska_nn_2_N : N ;
  burmesiska_nn_1_N : N ;
  burmesiska_nn_2_N : N ;
  burundiska_nn_1_N : N ;
  buskskvaetta_nn_1_1_N : N ;
  bussresa_nn_1_N : N ;
  buteljbotten_nn_1_N : N ;
  butikskedja_nn_1_N : N ;
  butterkaka_nn_1_N : N ;
  bygata_nn_1_N : N ;
  byggfirma_nn_1_N : N ;
  bygglaada_nn_1_1_N : N ;
  byggnadsbraate_nn_1_1_N : N ;
  byggnadsfirma_nn_1_N : N ;
  bykgryta_nn_1_N : N ;
  byracka_nn_1_N : N ;
  byraa_nn_1_1_N : N ;
  byraalaada_nn_1_1_N : N ;
  byskola_nn_1_N : N ;
  byssja_nn_1_N : N ;
  bystaemma_nn_1_1_N : N ;
  byteshandel_nn_1_N : N ;
  bytesvara_nn_1_N : N ;
  bytta_nn_1_N : N ;
  byxa_nn_1_N : N ;
  byxficka_nn_1_N : N ;
  byxhaella_nn_1_1_N : N ;
  byxklaemma_nn_1_1_N : N ;
  byxklaada_nn_1_1_N : N ;
  baeddjacka_nn_1_1_N : N ;
  baeddsoffa_nn_1_1_N : N ;
  baelgkamera_nn_1_1_N : N ;
  baelta_nn_1_1_N : N ;
  baernstenssyra_nn_1_1_N : N ;
  baers_nn_1_1_N : N ;
  baersa_nn_1_1_N : N ;
  baersa_nn_2_1_N : N ;
  baest_foere_dag_nn_1_1_N : N ;
  baestfoere_dag_nn_1_1_N : N ;
  baestfoeredag_nn_1_1_N : N ;
  baestsaeljarlista_nn_1_1_N : N ;
  baevergaell_nn_1_1_N : N ;
  baevernylon_nn_1_1_N : N ;
  baeverraatta_nn_1_1_N : N ;
  baada_nn_1_1_N : N ;
  baagbro_nn_1_1_N : N ;
  baaglampa_nn_1_1_N : N ;
  baarlaerka_nn_1_1_N : N ;
  baatbotten_nn_1_1_N : N ;
  baatbrygga_nn_1_1_N : N ;
  baatmaessa_nn_1_1_N : N ;
  baatmoessa_nn_1_1_N : N ;
  baatresa_nn_1_1_N : N ;
  baatvagga_nn_1_1_N : N ;
  baatyxa_nn_1_1_N : N ;
  boelja_nn_1_1_N : N ;
  boena_nn_1_1_N : N ;
  boenematta_nn_1_1_N : N ;
  boenskida_nn_1_1_N : N ;
  boerda_nn_1_1_N : N ;
  boerdsadel_nn_1_1_N : N ;
  boersoro_nn_1_1_N : N ;
  boersyra_nn_1_1_N : N ;
  boessa_nn_1_1_N : N ;
  boetessumma_nn_1_1_N : N ;
  boevel_nn_1_1_N : N ;
  cafeteria_nn_1_N : N ;
  caldera_nn_1_N : N ;
  camorra_nn_1_N : N ;
  campinglampa_nn_1_N : N ;
  campingstuga_nn_1_N : N ;
  cancerfara_nn_1_N : N ;
  cantilena_nn_1_N : N ;
  casanova_nn_1_N : N ;
  cavatina_nn_1_N : N ;
  cedroolja_nn_1_N : N ;
  celesta_nn_1_N : N ;
  cella_nn_1_N : N ;
  cellkaerna_nn_1_1_N : N ;
  cellofan_nn_1_N : N ;
  cellstoff_nn_1_N : N ;
  cement_nn_1_N : N ;
  centimeterskala_nn_1_N : N ;
  centralafrikanska_nn_1_N : N ;
  centralkyrka_nn_1_N : N ;
  centralskola_nn_1_N : N ;
  cerebrospinalvaetska_nn_1_1_N : N ;
  chagrin_nn_1_N : N ;
  chagraeng_nn_1_1_N : N ;
  champagnebaksmaella_nn_1_1_N : N ;
  champagneflaska_nn_1_N : N ;
  charkuterivara_nn_1_N : N ;
  charkvara_nn_1_N : N ;
  charterresa_nn_1_N : N ;
  checklista_nn_1_N : N ;
  checksumma_nn_1_N : N ;
  chilenska_nn_1_N : N ;
  chinchilla_nn_1_N : N ;
  chokladkaka_nn_1_N : N ;
  chokladlycka_nn_1_N : N ;
  chokladtaarta_nn_1_1_N : N ;
  cigarettlimpa_nn_1_N : N ;
  cigarrettlimpa_nn_1_N : N ;
  cigarrlaada_nn_1_1_N : N ;
  cikada_nn_1_N : N ;
  ciklidfiskfauna_nn_1_N : N ;
  cineraria_nn_1_N : N ;
  cirkelbana_nn_1_N : N ;
  cirkusarena_nn_1_N : N ;
  cistercienserorden_nn_1_N : N ;
  cisterciensorden_nn_1_N : N ;
  citronfjaeril_nn_1_1_N : N ;
  citrongraesolja_nn_1_1_N : N ;
  citronolja_nn_1_N : N ;
  citronsyra_nn_1_N : N ;
  cittra_nn_1_N : N ;
  cittra_nn_2_N : N ;
  coca_nn_1_N : N ;
  cocacola_nn_1_N : N ;
  cokacola_nn_1_N : N ;
  cokakola_nn_1_N : N ;
  cola_nn_1_N : N ;
  collegeflicka_nn_1_N : N ;
  collegetroeja_nn_1_1_N : N ;
  colombianska_nn_1_N : N ;
  comoriska_nn_1_N : N ;
  costaricanska_nn_1_N : N ;
  couronne_nn_1_N : N ;
  cous_cous_nn_1_N : N ;
  couscous_nn_1_N : N ;
  cricketklubba_nn_1_N : N ;
  curia_nn_1_N : N ;
  currygryta_nn_1_N : N ;
  cyan_nn_1_N : N ;
  cyanvaetesyra_nn_1_1_N : N ;
  cykelbana_nn_1_N : N ;
  cykelkedja_nn_1_N : N ;
  cykelklaemma_nn_1_1_N : N ;
  cykellykta_nn_1_N : N ;
  cypriotiska_nn_1_N : N ;
  cysta_nn_1_N : N ;
  cytoplasma_nn_1_N : N ;
  dadda_nn_1_N : N ;
  dag_nn_1_N : N ;
  dagfjaeril_nn_1_1_N : N ;
  daggkaapa_nn_1_1_N : N ;
  dagisfroeken_nn_1_1_N : N ;
  daglega_nn_1_N : N ;
  dagligstuga_nn_1_N : N ;
  dagligvara_nn_1_N : N ;
  dagmamma_nn_1_N : N ;
  dagskassa_nn_1_N : N ;
  dagslaenda_nn_1_1_N : N ;
  dagsresa_nn_1_N : N ;
  dahlia_nn_1_N : N ;
  dalbotten_nn_1_N : N ;
  dalkjusa_nn_1_N : N ;
  dalkulla_nn_1_N : N ;
  dalripa_nn_1_N : N ;
  dalska_nn_1_N : N ;
  dalslaendska_nn_1_1_N : N ;
  dalslaendska_nn_2_1_N : N ;
  dalsaenka_nn_1_1_N : N ;
  damaskenerklinga_nn_1_N : N ;
  dambinda_nn_1_N : N ;
  damfrisoerska_nn_1_1_N : N ;
  dammgoemma_nn_1_1_N : N ;
  dammlucka_nn_1_N : N ;
  dammlunga_nn_1_N : N ;
  dammraatta_nn_1_1_N : N ;
  dammtrasa_nn_1_N : N ;
  dammussla_nn_1_N : N ;
  dammvippa_nn_1_N : N ;
  damsida_nn_1_N : N ;
  damskjorta_nn_1_N : N ;
  damstrumpa_nn_1_N : N ;
  damvaeska_nn_1_1_N : N ;
  dansbana_nn_1_N : N ;
  dansbandsvecka_nn_1_N : N ;
  danska_nn_1_N : N ;
  danska_nn_2_N : N ;
  dansskola_nn_1_N : N ;
  darrocka_nn_1_N : N ;
  darttavla_nn_1_N : N ;
  data_nn_2_N : N ;
  datormaessa_nn_1_1_N : N ;
  davidsstjaerna_nn_1_1_N : N ;
  debetsida_nn_1_N : N ;
  deja_nn_1_N : N ;
  dekorationsbrasa_nn_1_N : N ;
  delstraecka_nn_1_1_N : N ;
  denim_nn_1_N : N ;
  derivata_nn_1_N : N ;
  designskola_nn_1_N : N ;
  detaljfraaga_nn_1_1_N : N ;
  detaljhandel_nn_1_N : N ;
  detaljkarta_nn_1_N : N ;
  dia_nn_1_N : N ;
  diakonissa_nn_1_N : N ;
  dieselolja_nn_1_N : N ;
  digitalkamera_nn_1_N : N ;
  digitallaada_nn_1_1_N : N ;
  dildo_nn_1_N : N ;
  dille_nn_1_N : N ;
  dillkrona_nn_1_N : N ;
  dimma_nn_1_N : N ;
  dimsloeja_nn_1_1_N : N ;
  discokula_nn_1_N : N ;
  diskbalja_nn_1_N : N ;
  diskblomma_nn_1_N : N ;
  diskho_nn_1_N : N ;
  diskontnota_nn_1_N : N ;
  disktrasa_nn_1_N : N ;
  distanshoegskola_nn_1_1_N : N ;
  ditresa_nn_1_N : N ;
  diva_nn_1_N : N ;
  divisionsfana_nn_1_N : N ;
  djiboutiska_nn_1_N : N ;
  djuphavsbotten_nn_1_N : N ;
  djurblod_nn_1_N : N ;
  djurraettsfraaga_nn_1_1_N : N ;
  dna_kedja_nn_1_N : N ;
  docka_nn_1_N : N ;
  doft_nn_2_N : N ;
  doja_nn_1_N : N ;
  doktorska_nn_1_N : N ;
  dokusaapa_nn_1_1_N : N ;
  dollarprinsessa_nn_1_N : N ;
  dolma_nn_2_N : N ;
  dominikanerorden_nn_1_N : N ;
  dominikanorden_nn_1_N : N ;
  dominikanska_nn_1_N : N ;
  dominikiska_nn_1_N : N ;
  dominobricka_nn_1_N : N ;
  domkraftsolja_nn_1_N : N ;
  domkyrka_nn_1_N : N ;
  domsaga_nn_1_N : N ;
  domvilla_nn_1_N : N ;
  dona_nn_1_N : N ;
  donkeypanna_nn_1_N : N ;
  donna_nn_1_N : N ;
  dopaminblaasa_nn_1_1_N : N ;
  dopinghaerva_nn_1_1_N : N ;
  dopningshaerva_nn_1_1_N : N ;
  dosa_nn_1_N : N ;
  dragglina_nn_1_N : N ;
  dragharmonika_nn_1_N : N ;
  dragkedja_nn_1_N : N ;
  dragkista_nn_1_N : N ;
  dragkaerra_nn_1_1_N : N ;
  draglina_nn_1_N : N ;
  dragningslista_nn_1_N : N ;
  dragskiva_nn_1_N : N ;
  dragstyrka_nn_1_N : N ;
  drakslinga_nn_1_N : N ;
  drakoedla_nn_1_1_N : N ;
  drapa_nn_1_N : N ;
  drav_nn_1_N : N ;
  dregel_nn_1_N : N ;
  drejskiva_nn_1_N : N ;
  drevkedja_nn_1_N : N ;
  dricka_nn_2_N : N ;
  driftkucku_nn_1_N : N ;
  drillflicka_nn_1_N : N ;
  drillsnaeppa_nn_1_1_N : N ;
  driva_nn_1_N : N ;
  drivhusplanta_nn_1_N : N ;
  drivkedja_nn_1_N : N ;
  drivlina_nn_1_N : N ;
  droppflaska_nn_1_N : N ;
  droppnaesa_nn_1_1_N : N ;
  droska_nn_1_N : N ;
  drottningkrona_nn_1_N : N ;
  drunkningsolycka_nn_1_N : N ;
  druva_nn_1_N : N ;
  druvgurka_nn_1_N : N ;
  dryckesvisa_nn_1_N : N ;
  dryckjom_nn_1_N : N ;
  draegel_nn_1_1_N : N ;
  droejsmaalsraenta_nn_1_1_N : N ;
  droemresa_nn_1_1_N : N ;
  droemrumpa_nn_1_1_N : N ;
  dubbelbotten_nn_1_N : N ;
  dubbelboessa_nn_1_1_N : N ;
  dubbelhaka_nn_1_N : N ;
  dubbelstjaerna_nn_1_1_N : N ;
  duenna_nn_1_N : N ;
  duma_nn_1_N : N ;
  dumdumkula_nn_1_N : N ;
  durra_nn_1_N : N ;
  durskala_nn_1_N : N ;
  dussinmaenniska_nn_1_1_N : N ;
  dussinvara_nn_1_N : N ;
  duva_nn_1_N : N ;
  duvkulla_nn_1_N : N ;
  dybotten_nn_1_N : N ;
  dykarklocka_nn_1_N : N ;
  dymmelvecka_nn_1_N : N ;
  dyna_nn_1_N : N ;
  dynt_nn_1_N : N ;
  dysa_nn_1_N : N ;
  dyscha_nn_1_N : N ;
  dyvika_nn_1_N : N ;
  daeckmaerkningsklaemma_nn_1_1_N : N ;
  daecksplanka_nn_1_1_N : N ;
  daadra_nn_1_1_N : N ;
  doedsdag_nn_1_1_N : N ;
  doedsfara_nn_1_1_N : N ;
  doedsfaella_nn_1_1_N : N ;
  doedskallefjaeril_nn_1_1_N : N ;
  doedslista_nn_1_1_N : N ;
  doedsmisshandel_nn_1_1_N : N ;
  doedsolycka_nn_1_1_N : N ;
  doedsruna_nn_1_1_N : N ;
  doedssiffra_nn_1_1_N : N ;
  doedsstjaerna_nn_1_1_N : N ;
  doedsvaanda_nn_1_1_N : N ;
  doerrkedja_nn_1_1_N : N ;
  doerrklocka_nn_1_1_N : N ;
  doerrmatta_nn_1_1_N : N ;
  ebenholts_nn_1_N : N ;
  ecuadorianska_nn_1_N : N ;
  eda_nn_1_N : N ;
  edda_nn_1_N : N ;
  efterleverska_nn_1_N : N ;
  efterraettssoppa_nn_1_1_N : N ;
  egennytta_nn_1_N : N ;
  egyptiska_nn_1_N : N ;
  egyptiska_nn_2_N : N ;
  ehec_smitta_nn_1_N : N ;
  ejderhona_nn_1_N : N ;
  eka_nn_1_N : N ;
  ekonomilaera_nn_1_1_N : N ;
  ekvatorialguineanska_nn_1_N : N ;
  ekvipotentialyta_nn_1_N : N ;
  eldfluga_nn_1_N : N ;
  eldkula_nn_1_N : N ;
  eldningsolja_nn_1_N : N ;
  eldslaaga_nn_1_1_N : N ;
  eldspruta_nn_1_N : N ;
  eldsvaada_nn_1_1_N : N ;
  eldyta_nn_1_N : N ;
  elefantskoeldpadda_nn_1_1_N : N ;
  elektronbana_nn_1_N : N ;
  elektronkamera_nn_1_N : N ;
  elementarskola_nn_1_N : N ;
  elevlista_nn_1_N : N ;
  elevskola_nn_1_N : N ;
  elljusslinga_nn_1_N : N ;
  elplatta_nn_1_N : N ;
  elritsa_nn_1_N : N ;
  elva_nn_1_N : N ;
  embargo_nn_1_N : N ;
  emiratiska_nn_1_N : N ;
  emma_nn_1_N : N ;
  encyklika_nn_1_N : N ;
  energikaella_nn_1_1_N : N ;
  engelska_nn_1_N : N ;
  engelska_nn_2_N : N ;
  engaangsflaska_nn_1_1_N : N ;
  enkelstjaerna_nn_1_1_N : N ;
  enkrona_nn_1_N : N ;
  enplansvilla_nn_1_N : N ;
  entita_nn_1_N : N ;
  eolsharpa_nn_1_N : N ;
  era_nn_1_N : N ;
  eremitkraefta_nn_1_1_N : N ;
  eriksgata_nn_1_N : N ;
  eritreanska_nn_1_N : N ;
  eritreanska_nn_2_N : N ;
  erosionsskada_nn_1_N : N ;
  ersmaessa_nn_1_1_N : N ;
  eskimaaiska_nn_1_1_N : N ;
  eskortflicka_nn_1_N : N ;
  eskortkvinna_nn_1_N : N ;
  essaefraaga_nn_1_1_N : N ;
  estlaendska_nn_1_1_N : N ;
  estniska_nn_1_N : N ;
  estniska_nn_2_N : N ;
  eterflaska_nn_1_N : N ;
  etiopiska_nn_1_N : N ;
  etiopiska_nn_2_N : N ;
  etruskiska_nn_1_N : N ;
  etruskiska_nn_2_N : N ;
  etta_nn_1_N : N ;
  ettermyra_nn_1_N : N ;
  euforbia_nn_1_N : N ;
  eukalyptusolja_nn_1_N : N ;
  eurasiska_nn_1_N : N ;
  europeiska_nn_1_N : N ;
  eva_nn_1_N : N ;
  evighetsblomma_nn_1_N : N ;
  examensfraaga_nn_1_1_N : N ;
  exfru_nn_1_N : N ;
  expansionsvilja_nn_1_N : N ;
  experimentlusta_nn_1_N : N ;
  exploateringsyta_nn_1_N : N ;
  explosiva_nn_1_N : N ;
  extralampa_nn_1_N : N ;
  extraupplaga_nn_1_N : N ;
  fabrikslaenga_nn_1_1_N : N ;
  fabrikspipa_nn_1_N : N ;
  fackhoegskola_nn_1_1_N : N ;
  fackla_nn_1_N : N ;
  fackprosa_nn_1_N : N ;
  fackskola_nn_1_N : N ;
  faddergala_nn_1_N : N ;
  faddergaava_nn_1_1_N : N ;
  fakta_nn_1_N : N ;
  faktagroda_nn_1_N : N ;
  faktura_nn_1_N : N ;
  fallbila_nn_1_N : N ;
  fallmaalstavla_nn_1_1_N : N ;
  fallolycka_nn_1_N : N ;
  falltavla_nn_1_N : N ;
  fallucka_nn_1_N : N ;
  familjeflicka_nn_1_N : N ;
  fana_nn_1_N : N ;
  fantomsmaerta_nn_1_1_N : N ;
  fara_nn_1_N : N ;
  farhaaga_nn_1_1_N : N ;
  farin_nn_1_N : N ;
  farsa_nn_1_N : N ;
  farstutrappa_nn_1_N : N ;
  fartkamera_nn_1_N : N ;
  fartygsbotten_nn_1_N : N ;
  fartygslucka_nn_1_N : N ;
  fartygssida_nn_1_N : N ;
  fasa_nn_1_N : N ;
  fasadplatta_nn_1_N : N ;
  fasta_nn_1_N : N ;
  fastedag_nn_1_N : N ;
  fastighetsbubbla_nn_1_N : N ;
  fastkedja_nn_1_N : N ;
  fastlagsbulla_nn_1_N : N ;
  fattigdomsfaella_nn_1_1_N : N ;
  fattigstuga_nn_1_N : N ;
  fattningsfoermaaga_nn_1_1_N : N ;
  fattningsgaava_nn_1_1_N : N ;
  fatwa_nn_1_N : N ;
  fauna_nn_1_N : N ;
  favoritskaadespelerska_nn_1_1_N : N ;
  feberkurva_nn_1_N : N ;
  fela_nn_1_N : N ;
  felkaella_nn_1_1_N : N ;
  fembarnsmamma_nn_1_N : N ;
  femdagarsvecka_nn_1_N : N ;
  femetta_nn_1_N : N ;
  femfemma_nn_1_N : N ;
  femkrona_nn_1_N : N ;
  femma_nn_1_N : N ;
  femtiometersstraecka_nn_1_1_N : N ;
  fena_nn_1_N : N ;
  fenoxisyra_nn_1_N : N ;
  ferieskola_nn_1_N : N ;
  fernissa_nn_1_N : N ;
  ferritkaerna_nn_1_1_N : N ;
  festvaerdinna_nn_1_1_N : N ;
  fettisdagsbulla_nn_1_N : N ;
  fettpaerla_nn_1_1_N : N ;
  fettspruta_nn_1_N : N ;
  fettsyra_nn_1_N : N ;
  fia_nn_1_N : N ;
  fibbla_nn_1_N : N ;
  fiberplatta_nn_1_N : N ;
  fibula_nn_1_N : N ;
  ficka_nn_1_N : N ;
  ficklampa_nn_1_N : N ;
  fickplunta_nn_1_N : N ;
  fijianska_nn_1_N : N ;
  fijianska_nn_2_N : N ;
  fika_nn_1_N : N ;
  fikahoerna_nn_1_1_N : N ;
  fiktionsprosa_nn_1_N : N ;
  filippinska_nn_1_N : N ;
  filmkamera_nn_1_N : N ;
  filmskaadespelerska_nn_1_1_N : N ;
  filmstjaerna_nn_1_1_N : N ;
  filterludd_nn_1_N : N ;
  filtyta_nn_1_N : N ;
  fingerblomma_nn_1_N : N ;
  fingerborgsblomma_nn_1_N : N ;
  fingerskiva_nn_1_N : N ;
  fingertuta_nn_1_N : N ;
  finka_nn_1_N : N ;
  finkelolja_nn_1_N : N ;
  finkaensla_nn_1_1_N : N ;
  finlandssvenska_nn_1_N : N ;
  finlandssvenska_nn_2_N : N ;
  finlaendska_nn_1_1_N : N ;
  finska_nn_1_N : N ;
  finska_nn_2_N : N ;
  fiollaada_nn_1_1_N : N ;
  firma_nn_1_N : N ;
  fiskblaasa_nn_1_1_N : N ;
  fiskelycka_nn_1_N : N ;
  fiskeolycka_nn_1_N : N ;
  fiskestuga_nn_1_N : N ;
  fiskguano_nn_1_N : N ;
  fiskleverolja_nn_1_N : N ;
  fiskolja_nn_1_N : N ;
  fisksoppa_nn_1_N : N ;
  fisktrappa_nn_1_N : N ;
  fisktaerna_nn_1_1_N : N ;
  fiskaadra_nn_1_1_N : N ;
  fiskoedla_nn_1_1_N : N ;
  fitta_nn_1_N : N ;
  fixstjaerna_nn_1_1_N : N ;
  fjolla_nn_1_N : N ;
  fjong_nn_1_N : N ;
  fjaederdosa_nn_1_1_N : N ;
  fjaedermygga_nn_1_1_N : N ;
  fjaella_nn_1_1_N : N ;
  fjaellkedja_nn_1_1_N : N ;
  fjaellripa_nn_1_1_N : N ;
  fjaellsjoe_nn_1_1_N : N ;
  fjaellstuga_nn_1_1_N : N ;
  fjaellsyra_nn_1_1_N : N ;
  fjaelluggla_nn_1_1_N : N ;
  fjaeril_nn_1_1_N : N ;
  fjaerilsblomma_nn_1_1_N : N ;
  flaga_nn_1_N : N ;
  flagga_nn_1_N : N ;
  flagglina_nn_1_N : N ;
  flamlaendska_nn_1_1_N : N ;
  flamlaendska_nn_2_1_N : N ;
  flamma_nn_1_N : N ;
  flaska_nn_1_N : N ;
  flata_nn_1_N : N ;
  fleece_nn_1_N : N ;
  flerbarnsmamma_nn_1_N : N ;
  flervalsfraaga_nn_1_1_N : N ;
  flexklocka_nn_1_N : N ;
  flicka_nn_1_N : N ;
  flickbokshjaeltinna_nn_1_1_N : N ;
  flickskola_nn_1_N : N ;
  flickslaenda_nn_1_1_N : N ;
  flinga_nn_1_N : N ;
  flinta_nn_1_N : N ;
  flintyxa_nn_1_N : N ;
  flis_nn_1_N : N ;
  flisa_nn_1_N : N ;
  flo_nn_1_N : N ;
  flodfaara_nn_1_1_N : N ;
  flodkrabba_nn_1_N : N ;
  flora_nn_1_N : N ;
  flossa_nn_1_N : N ;
  flotta_nn_1_N : N ;
  flottbro_nn_1_N : N ;
  fluga_nn_1_N : N ;
  flugsmaella_nn_1_1_N : N ;
  flugvifta_nn_1_N : N ;
  flundra_nn_1_N : N ;
  flunsa_nn_1_N : N ;
  fluor_nn_1_N : N ;
  flygflotta_nn_1_N : N ;
  flygmyra_nn_1_N : N ;
  flygplanstoa_nn_1_N : N ;
  flygvaerdinna_nn_1_1_N : N ;
  flygoedla_nn_1_1_N : N ;
  flytdocka_nn_1_N : N ;
  flyttlaada_nn_1_1_N : N ;
  flaedermaergskula_nn_1_1_N : N ;
  flaerpa_nn_1_1_N : N ;
  flaeskpannkaka_nn_1_1_N : N ;
  flaeta_nn_1_1_N : N ;
  flaahacka_nn_1_1_N : N ;
  floertkula_nn_1_1_N : N ;
  floertlampa_nn_1_1_N : N ;
  fnoeskticka_nn_1_1_N : N ;
  focus_nn_1_N : N ;
  foderbeta_nn_1_N : N ;
  foderkaka_nn_1_N : N ;
  foderlada_nn_1_N : N ;
  fogmassa_nn_1_N : N ;
  fogspruta_nn_1_N : N ;
  fokus_nn_1_N : N ;
  folkhoegskola_nn_1_1_N : N ;
  folkmassa_nn_1_N : N ;
  folkriksdag_nn_1_N : N ;
  folksaga_nn_1_N : N ;
  folkskola_nn_1_N : N ;
  folkspillra_nn_1_N : N ;
  folktro_nn_1_N : N ;
  folkvilja_nn_1_N : N ;
  folkvisa_nn_1_N : N ;
  fondmaeklarfirma_nn_1_1_N : N ;
  fora_nn_1_N : N ;
  formalin_nn_1_N : N ;
  formfraaga_nn_1_1_N : N ;
  formkurva_nn_1_N : N ;
  formlaera_nn_1_1_N : N ;
  formsvacka_nn_1_N : N ;
  fornegyptiska_nn_1_N : N ;
  forskningsresa_nn_1_N : N ;
  forsythia_nn_1_N : N ;
  forsaerla_nn_1_1_N : N ;
  fortplantningsfoermaaga_nn_1_1_N : N ;
  fortsaettningsskola_nn_1_1_N : N ;
  fosforsyra_nn_1_N : N ;
  fosterhinna_nn_1_N : N ;
  fosterskada_nn_1_N : N ;
  fotboja_nn_1_N : N ;
  fotbollsarena_nn_1_N : N ;
  fotbollskedja_nn_1_N : N ;
  fotbollsstjaerna_nn_1_1_N : N ;
  fotbollstuta_nn_1_N : N ;
  fotogenlampa_nn_1_N : N ;
  fotokarta_nn_1_N : N ;
  fotokopia_nn_1_N : N ;
  fotostatkopia_nn_1_N : N ;
  fotplatta_nn_1_N : N ;
  fotskada_nn_1_N : N ;
  fotskrapa_nn_1_N : N ;
  fotsula_nn_1_N : N ;
  fotvaarta_nn_1_1_N : N ;
  fotaenda_nn_1_1_N : N ;
  fraktfirma_nn_1_N : N ;
  fralla_nn_1_N : N ;
  framficka_nn_1_N : N ;
  framgaangssaga_nn_1_1_N : N ;
  framsida_nn_1_N : N ;
  framstegstro_nn_1_N : N ;
  framtidsfraaga_nn_1_1_N : N ;
  framtidstro_nn_1_N : N ;
  framaenda_nn_1_1_N : N ;
  franciskanerorden_nn_1_N : N ;
  franciskanorden_nn_1_N : N ;
  franska_nn_1_N : N ;
  fransyska_nn_1_N : N ;
  frasvaaffla_nn_1_1_N : N ;
  fredagsbilaga_nn_1_N : N ;
  fredsduva_nn_1_N : N ;
  fredspipa_nn_1_N : N ;
  fredsstyrka_nn_1_N : N ;
  fresia_nn_1_N : N ;
  frihandel_nn_1_N : N ;
  frikativa_nn_1_N : N ;
  friktionsvaerme_nn_1_1_N : N ;
  frikyrka_nn_1_N : N ;
  frilista_nn_1_N : N ;
  frilla_nn_1_N : N ;
  friluftsvana_nn_1_N : N ;
  frimurareorden_nn_1_N : N ;
  frimurarorden_nn_1_N : N ;
  frisiska_nn_1_N : N ;
  frisiska_nn_2_N : N ;
  friskola_nn_1_N : N ;
  frissa_nn_1_N : N ;
  frisoerska_nn_1_1_N : N ;
  fritidsstuga_nn_1_N : N ;
  frossa_nn_1_N : N ;
  frostdimma_nn_1_N : N ;
  frostfjaeril_nn_1_1_N : N ;
  frostskada_nn_1_N : N ;
  frostskyddsvaetska_nn_1_1_N : N ;
  fru_nn_1_N : N ;
  fruga_nn_1_N : N ;
  frukostbricka_nn_1_N : N ;
  frukostvaerdinna_nn_1_1_N : N ;
  fruktkaka_nn_1_N : N ;
  fruktkaerna_nn_1_1_N : N ;
  fruktsoppa_nn_1_N : N ;
  frysloppa_nn_1_N : N ;
  fraenka_nn_1_1_N : N ;
  fraeta_nn_1_1_N : N ;
  fraetskada_nn_1_1_N : N ;
  fraaga_nn_1_1_N : N ;
  fraansida_nn_1_1_N : N ;
  froeken_nn_1_1_N : N ;
  froeplanta_nn_1_1_N : N ;
  froevita_nn_1_1_N : N ;
  ftalsyra_nn_1_N : N ;
  fuchsia_nn_1_N : N ;
  fuga_nn_1_N : N ;
  fuksin_nn_1_N : N ;
  fuktskada_nn_1_N : N ;
  fura_nn_1_N : N ;
  furu_nn_1_N : N ;
  furuplanka_nn_1_N : N ;
  fylgia_nn_1_N : N ;
  fylgja_nn_1_N : N ;
  fylla_nn_1_N : N ;
  fylldille_nn_1_N : N ;
  fyllkaja_nn_1_N : N ;
  fyllnadsmassa_nn_1_N : N ;
  fyndgruva_nn_1_N : N ;
  fyra_nn_1_N : N ;
  fyrtiotimmarsvecka_nn_1_N : N ;
  fyrtitimmarsvecka_nn_1_N : N ;
  faebodstinta_nn_1_1_N : N ;
  faegata_nn_1_1_N : N ;
  faella_nn_1_1_N : N ;
  faeltflaska_nn_1_1_N : N ;
  faeltmarskalkinna_nn_1_1_N : N ;
  faeltstyrka_nn_1_1_N : N ;
  faengelsehaala_nn_1_1_N : N ;
  faergkrita_nn_1_1_N : N ;
  faerglaera_nn_1_1_N : N ;
  faerglaada_nn_1_1_N : N ;
  faergpenna_nn_1_1_N : N ;
  faergskala_nn_1_1_N : N ;
  faergskrapa_nn_1_1_N : N ;
  faergspruta_nn_1_1_N : N ;
  faerja_nn_1_1_N : N ;
  faerjeolycka_nn_1_1_N : N ;
  faerla_nn_1_1_N : N ;
  faerna_nn_1_1_N : N ;
  faerskvara_nn_1_1_N : N ;
  faeroeiska_nn_1_1_N : N ;
  faeroeiska_nn_2_1_N : N ;
  faestmanssoffa_nn_1_1_N : N ;
  faestplatta_nn_1_1_N : N ;
  faagelinfluensa_nn_1_1_N : N ;
  faagelskraemma_nn_1_1_N : N ;
  faagelsnara_nn_1_1_N : N ;
  faageloe_nn_1_1_N : N ;
  faalla_nn_1_1_N : N ;
  faanglina_nn_1_1_N : N ;
  faara_nn_1_1_N : N ;
  faaravel_nn_1_1_N : N ;
  faarticka_nn_1_1_N : N ;
  foedelsedagsgaava_nn_1_1_N : N ;
  foedelsedagstaarta_nn_1_1_N : N ;
  foedslovaanda_nn_1_1_N : N ;
  foeljdfraaga_nn_1_1_N : N ;
  foeljeslagarinna_nn_1_1_N : N ;
  foensterbraeda_nn_1_1_N : N ;
  foensterlucka_nn_1_1_N : N ;
  foensterputs_nn_2_1_N : N ;
  foensterputsvaetska_nn_1_1_N : N ;
  foensterruta_nn_1_1_N : N ;
  foerargelseklippa_nn_1_1_N : N ;
  foerarruta_nn_1_1_N : N ;
  foerbandslaada_nn_1_1_N : N ;
  foeredragningslista_nn_1_1_N : N ;
  foerestaellningsfoermaaga_nn_1_1_N : N ;
  foerestaandarinna_nn_1_1_N : N ;
  foerfattarinna_nn_1_1_N : N ;
  foerhandlingsbricka_nn_1_1_N : N ;
  foerhandlingsfraaga_nn_1_1_N : N ;
  foerhandlingsrunda_nn_1_1_N : N ;
  foerhandskopia_nn_1_1_N : N ;
  foerkaensla_nn_1_1_N : N ;
  foerlaga_nn_1_1_N : N ;
  foerlossningsskada_nn_1_1_N : N ;
  foermiddag_nn_1_1_N : N ;
  foermaaga_nn_1_1_N : N ;
  foernuftstro_nn_1_1_N : N ;
  foerortslaerarinna_nn_1_1_N : N ;
  foerortsskola_nn_1_1_N : N ;
  foerskola_nn_1_1_N : N ;
  foersoningsgaava_nn_1_1_N : N ;
  foersoningslaera_nn_1_1_N : N ;
  foerstadsvilla_nn_1_1_N : N ;
  foerstamajblomma_nn_1_1_N : N ;
  foerstaresa_nn_1_1_N : N ;
  foerstasida_nn_1_1_N : N ;
  foerstaslagsfoermaaga_nn_1_1_N : N ;
  foerstaupplaga_nn_1_1_N : N ;
  foerstfoederska_nn_1_1_N : N ;
  foerstubro_nn_1_1_N : N ;
  foerstuga_nn_1_1_N : N ;
  foerstugubro_nn_1_1_N : N ;
  foerstoerelselusta_nn_1_1_N : N ;
  foersvarshoegskola_nn_1_1_N : N ;
  foersvarsinlaga_nn_1_1_N : N ;
  foersaekringskassa_nn_1_1_N : N ;
  foersaeljerska_nn_1_1_N : N ;
  foersaeljningsvana_nn_1_1_N : N ;
  foersoerjningsboerda_nn_1_1_N : N ;
  foertroendefraaga_nn_1_1_N : N ;
  foertroendeklyfta_nn_1_1_N : N ;
  foertoejningslina_nn_1_1_N : N ;
  foervaervskaella_nn_1_1_N : N ;
  foeryngringsyta_nn_1_1_N : N ;
  gabardin_nn_1_N : N ;
  gabon_nn_1_N : N ;
  gabonesiska_nn_1_N : N ;
  gaeliska_nn_1_N : N ;
  gaeliska_nn_2_N : N ;
  gaffelapa_nn_1_N : N ;
  gala_nn_1_N : N ;
  galeja_nn_1_N : N ;
  galenpanna_nn_1_N : N ;
  galla_nn_1_N : N ;
  gallblomma_nn_1_N : N ;
  gallblaasa_nn_1_1_N : N ;
  galleria_nn_1_N : N ;
  gallmygga_nn_1_N : N ;
  gallsyra_nn_1_N : N ;
  gallussyra_nn_1_N : N ;
  galon_nn_1_N : N ;
  galoschhaka_nn_1_N : N ;
  galoschhylla_nn_1_N : N ;
  gambiska_nn_1_N : N ;
  gammakamera_nn_1_N : N ;
  garantisumma_nn_1_N : N ;
  gardenia_nn_1_N : N ;
  gardinkappa_nn_1_N : N ;
  gardinspringa_nn_1_N : N ;
  garndocka_nn_1_N : N ;
  garnhaerva_nn_1_1_N : N ;
  garvsyra_nn_1_N : N ;
  gasbinda_nn_1_N : N ;
  gasbubbla_nn_1_N : N ;
  gasklocka_nn_1_N : N ;
  gaslampa_nn_1_N : N ;
  gaslykta_nn_1_N : N ;
  gaslaecka_nn_1_1_N : N ;
  gaslaera_nn_1_1_N : N ;
  gaslaaga_nn_1_1_N : N ;
  gasmassa_nn_1_N : N ;
  gasolin_nn_1_N : N ;
  gasskiva_nn_1_N : N ;
  gata_nn_1_N : N ;
  gatflicka_nn_1_N : N ;
  gatlykta_nn_1_N : N ;
  gatslinka_nn_1_N : N ;
  gausskurva_nn_1_N : N ;
  geckooedla_nn_1_1_N : N ;
  gegg_nn_1_N : N ;
  geisha_nn_1_N : N ;
  gelada_nn_1_N : N ;
  gelatin_nn_1_N : N ;
  gel_eraatta_nn_1_1_N : N ;
  generalska_nn_1_N : N ;
  generalstabskarta_nn_1_N : N ;
  generationsklyfta_nn_1_N : N ;
  gengaava_nn_1_1_N : N ;
  genomfartsgata_nn_1_N : N ;
  genomresa_nn_1_N : N ;
  genomslagsfoermaaga_nn_1_1_N : N ;
  genomslagskopia_nn_1_N : N ;
  genomtraengningsfoermaaga_nn_1_1_N : N ;
  gensaga_nn_1_N : N ;
  gentiana_nn_1_N : N ;
  genua_nn_1_N : N ;
  georgiska_nn_1_N : N ;
  georgiska_nn_2_N : N ;
  gerilla_nn_1_N : N ;
  geringslaada_nn_1_1_N : N ;
  getingbilla_nn_1_N : N ;
  getingmidja_nn_1_N : N ;
  gevaerskula_nn_1_1_N : N ;
  gevaersolja_nn_1_1_N : N ;
  gevaerspipa_nn_1_1_N : N ;
  gevaersvaeska_nn_1_1_N : N ;
  ghananska_nn_1_N : N ;
  giftblaasa_nn_1_1_N : N ;
  giftlaera_nn_1_1_N : N ;
  giftspruta_nn_1_N : N ;
  giftstadga_nn_1_N : N ;
  giga_nn_1_N : N ;
  gillesstuga_nn_1_N : N ;
  gillestuga_nn_1_N : N ;
  gin_nn_1_N : N ;
  gina_nn_1_N : N ;
  gipa_nn_1_N : N ;
  gipsplatta_nn_1_N : N ;
  gipsskiva_nn_1_N : N ;
  gjutflaska_nn_1_N : N ;
  gjutjaernsbro_nn_1_1_N : N ;
  gjutjaernsgryta_nn_1_1_N : N ;
  gjutmassa_nn_1_N : N ;
  glacialraeffla_nn_1_1_N : N ;
  glaciaerraeffla_nn_1_1_N : N ;
  glada_nn_1_N : N ;
  glasblaasarpipa_nn_1_1_N : N ;
  glasflaska_nn_1_N : N ;
  glasharmonika_nn_1_N : N ;
  glashylla_nn_1_N : N ;
  glashytta_nn_1_N : N ;
  glaskanna_nn_1_N : N ;
  glasklocka_nn_1_N : N ;
  glaskula_nn_1_N : N ;
  glasmassa_nn_1_N : N ;
  glaspaerla_nn_1_1_N : N ;
  glasruta_nn_1_N : N ;
  glasskiva_nn_1_N : N ;
  glasslycka_nn_1_N : N ;
  glasstaarta_nn_1_1_N : N ;
  glasveranda_nn_1_N : N ;
  glasvingefjaeril_nn_1_1_N : N ;
  glasvaetska_nn_1_1_N : N ;
  glete_nn_1_N : N ;
  glidsalva_nn_1_N : N ;
  glimlampa_nn_1_N : N ;
  glipa_nn_1_N : N ;
  gloria_nn_1_N : N ;
  glosa_nn_1_N : N ;
  glossa_nn_1_N : N ;
  gloxinia_nn_1_N : N ;
  glukos_nn_1_N : N ;
  glutaminsyra_nn_1_N : N ;
  gluttsnaeppa_nn_1_1_N : N ;
  glycerin_nn_1_N : N ;
  glykos_nn_1_N : N ;
  glaedjedag_nn_1_1_N : N ;
  glaedjeflicka_nn_1_1_N : N ;
  glaedjefnatt_nn_1_1_N : N ;
  glaedjeyra_nn_1_1_N : N ;
  glaenta_nn_1_1_N : N ;
  gloedhoppa_nn_1_1_N : N ;
  gloedlampa_nn_1_1_N : N ;
  gloedstrumpa_nn_1_1_N : N ;
  gloeggpanna_nn_1_1_N : N ;
  gloeggryta_nn_1_1_N : N ;
  gloemskekurva_nn_1_1_N : N ;
  gnista_nn_1_N : N ;
  gnista_nn_2_N : N ;
  gniststraecka_nn_1_1_N : N ;
  go_go_flicka_nn_1_N : N ;
  godislycka_nn_1_N : N ;
  godnattsaga_nn_1_N : N ;
  godsfinka_nn_1_N : N ;
  godsaegarinna_nn_1_1_N : N ;
  godtemplarorden_nn_1_N : N ;
  goja_nn_2_N : N ;
  golfbana_nn_1_N : N ;
  golfbyxa_nn_1_N : N ;
  golfklubba_nn_1_N : N ;
  golfresa_nn_1_N : N ;
  golfrunda_nn_1_N : N ;
  golfskjorta_nn_1_N : N ;
  golfstjaerna_nn_1_1_N : N ;
  golvklocka_nn_1_N : N ;
  golvlampa_nn_1_N : N ;
  golvmatta_nn_1_N : N ;
  golvtrasa_nn_1_N : N ;
  golvyta_nn_1_N : N ;
  gorgonzola_nn_1_N : N ;
  gorilla_nn_1_N : N ;
  gotiska_nn_1_N : N ;
  gotlaendska_nn_1_1_N : N ;
  gotlaendska_nn_2_1_N : N ;
  gottkoepsvara_nn_1_1_N : N ;
  gradskiva_nn_1_N : N ;
  grammatika_nn_1_N : N ;
  grammofonskiva_nn_1_N : N ;
  granatskaerva_nn_1_1_N : N ;
  granataeppelkaerna_nn_1_1_N : N ;
  grannosaemja_nn_1_1_N : N ;
  grannsocken_nn_1_N : N ;
  grannstjaerna_nn_1_1_N : N ;
  grannstuga_nn_1_N : N ;
  granplanta_nn_1_N : N ;
  granspira_nn_1_N : N ;
  gravgaava_nn_1_1_N : N ;
  graviditetsvecka_nn_1_N : N ;
  gravkista_nn_1_N : N ;
  gravkyrka_nn_1_N : N ;
  gravsaenka_nn_1_1_N : N ;
  gravurna_nn_1_N : N ;
  greja_nn_1_N : N ;
  grekinna_nn_1_N : N ;
  grekiska_nn_1_N : N ;
  grekiska_nn_2_N : N ;
  grenadiska_nn_1_N : N ;
  grenklyka_nn_1_N : N ;
  greppmatta_nn_1_N : N ;
  greppyta_nn_1_N : N ;
  grevekrona_nn_1_N : N ;
  grevinna_nn_1_N : N ;
  grevysebra_nn_1_N : N ;
  grevyzebra_nn_1_N : N ;
  griffeltavla_nn_1_N : N ;
  grimma_nn_1_N : N ;
  grindstuga_nn_1_N : N ;
  grissla_nn_1_N : N ;
  groda_nn_1_N : N ;
  groddplanta_nn_1_N : N ;
  groploeja_nn_1_1_N : N ;
  grosshandel_nn_1_N : N ;
  grosshandelsfirma_nn_1_N : N ;
  grotta_nn_1_N : N ;
  grottmaenniska_nn_1_1_N : N ;
  grottskreva_nn_1_N : N ;
  grovsyssla_nn_1_N : N ;
  grubba_nn_1_N : N ;
  grundhyra_nn_1_N : N ;
  grundskola_nn_1_N : N ;
  grundsaerskola_nn_1_1_N : N ;
  grundyta_nn_1_N : N ;
  grunka_nn_1_N : N ;
  gruppresa_nn_1_N : N ;
  gruva_nn_1_N : N ;
  gruvolycka_nn_1_N : N ;
  gruvstoetta_nn_1_1_N : N ;
  grynna_nn_1_N : N ;
  gryta_nn_1_N : N ;
  graebba_nn_1_1_N : N ;
  graeddsnipa_nn_1_1_N : N ;
  graeddtaarta_nn_1_1_N : N ;
  graefta_nn_1_1_N : N ;
  graensdragningsfraaga_nn_1_1_N : N ;
  graensnytta_nn_1_1_N : N ;
  graesfjaeril_nn_1_1_N : N ;
  graeshoppa_nn_1_1_N : N ;
  graesmatta_nn_1_1_N : N ;
  graesnejlika_nn_1_1_N : N ;
  graestorva_nn_1_1_N : N ;
  graestuva_nn_1_1_N : N ;
  graesaenka_nn_1_1_N : N ;
  graevskopa_nn_1_1_N : N ;
  graalla_nn_1_1_N : N ;
  graasalva_nn_1_1_N : N ;
  graasida_nn_1_1_N : N ;
  graasiska_nn_1_1_N : N ;
  graasugga_nn_1_1_N : N ;
  graaterska_nn_1_1_N : N ;
  graatonsskala_nn_1_1_N : N ;
  graavacka_nn_1_1_N : N ;
  groeda_nn_1_1_N : N ;
  groenbena_nn_1_1_N : N ;
  groenkulla_nn_1_1_N : N ;
  groenlaendska_nn_1_1_N : N ;
  groenlaendska_nn_2_1_N : N ;
  groenmalt_nn_1_1_N : N ;
  groensakssoppa_nn_1_1_N : N ;
  groensiska_nn_1_1_N : N ;
  groenska_nn_1_1_N : N ;
  groenyta_nn_1_1_N : N ;
  guano_nn_1_N : N ;
  guatemalanska_nn_1_N : N ;
  gudagaava_nn_1_1_N : N ;
  gudalaera_nn_1_1_N : N ;
  gudasaga_nn_1_N : N ;
  gudinna_nn_1_N : N ;
  gudstjaenstdag_nn_1_1_N : N ;
  gudstro_nn_1_N : N ;
  guineanska_nn_1_N : N ;
  gula_nn_1_N : N ;
  gulblaasa_nn_1_1_N : N ;
  guldbaggegala_nn_1_N : N ;
  guldgruva_nn_1_N : N ;
  guldhoena_nn_1_1_N : N ;
  guldkedja_nn_1_N : N ;
  guldklocka_nn_1_N : N ;
  guldkrona_nn_1_N : N ;
  guldpenna_nn_1_N : N ;
  guldpaerla_nn_1_1_N : N ;
  guldtacka_nn_1_N : N ;
  gullhoena_nn_1_1_N : N ;
  gullpudra_nn_1_N : N ;
  gullviva_nn_1_N : N ;
  gulmaara_nn_1_1_N : N ;
  gulsippa_nn_1_N : N ;
  gulskiva_nn_1_N : N ;
  gulaerla_nn_1_1_N : N ;
  gumma_nn_1_N : N ;
  gummiplatta_nn_1_N : N ;
  gummislaegga_nn_1_1_N : N ;
  gumphoena_nn_1_1_N : N ;
  gunga_nn_1_N : N ;
  gungbraeda_nn_1_1_N : N ;
  gura_nn_1_N : N ;
  gurka_nn_1_N : N ;
  gurkskiva_nn_1_N : N ;
  gutniska_nn_1_N : N ;
  guyananska_nn_1_N : N ;
  gydja_nn_1_N : N ;
  gylta_nn_1_N : N ;
  gymnasieskola_nn_1_N : N ;
  gyttja_nn_1_N : N ;
  gaedda_nn_1_1_N : N ;
  gaeldstuga_nn_1_1_N : N ;
  gaeliska_nn_1_1_N : N ;
  gaeliska_nn_2_1_N : N ;
  gaelspringa_nn_1_1_N : N ;
  gaenga_nn_1_1_N : N ;
  gaengkloppa_nn_1_1_N : N ;
  gaerningslaera_nn_1_1_N : N ;
  gaestflagga_nn_1_1_N : N ;
  gaestlista_nn_1_1_N : N ;
  gaestriklaendska_nn_1_1_N : N ;
  gaestrikska_nn_1_1_N : N ;
  gaagata_nn_1_1_N : N ;
  gaangbana_nn_1_1_N : N ;
  gaangbro_nn_1_1_N : N ;
  gaanggata_nn_1_1_N : N ;
  gaardfarihandel_nn_1_1_N : N ;
  gaardslykta_nn_1_1_N : N ;
  gaaspenna_nn_1_1_N : N ;
  gaata_nn_1_1_N : N ;
  gaava_nn_1_1_N : N ;
  goedselraenna_nn_1_1_N : N ;
  goekblomma_nn_1_1_N : N ;
  goekklocka_nn_1_1_N : N ;
  goekotta_nn_1_1_N : N ;
  goektyta_nn_1_1_N : N ;
  goemma_nn_1_1_N : N ;
  goeteborgska_nn_1_1_N : N ;
  goeteborgska_nn_2_1_N : N ;
  hacka_nn_1_N : N ;
  hagelboessa_nn_1_1_N : N ;
  hagga_nn_1_N : N ;
  haitiska_nn_1_N : N ;
  haitiska_nn_2_N : N ;
  hajfena_nn_1_N : N ;
  haka_nn_1_N : N ;
  hakeboessa_nn_1_1_N : N ;
  hakkorsflagga_nn_1_N : N ;
  halkbana_nn_1_N : N ;
  hallkyrka_nn_1_N : N ;
  hallmatta_nn_1_N : N ;
  hallongrotta_nn_1_N : N ;
  hallaendska_nn_1_1_N : N ;
  hallaendska_nn_2_1_N : N ;
  hallaaa_nn_1_1_N : N ;
  halmplatta_nn_1_N : N ;
  halogenlampa_nn_1_N : N ;
  halskedja_nn_1_N : N ;
  halskota_nn_1_N : N ;
  halva_nn_1_N : N ;
  halvapa_nn_1_N : N ;
  halvflaska_nn_1_N : N ;
  halvmara_nn_1_N : N ;
  halvpanna_nn_1_N : N ;
  halvskugga_nn_1_N : N ;
  halvstrumpa_nn_1_N : N ;
  halvtrappa_nn_1_N : N ;
  halvoe_nn_1_1_N : N ;
  hambostinta_nn_1_N : N ;
  hanblomma_nn_1_N : N ;
  handboja_nn_1_N : N ;
  handel_nn_1_N : N ;
  handelsflotta_nn_1_N : N ;
  handelshoegskola_nn_1_1_N : N ;
  handelsresa_nn_1_N : N ;
  handelsskola_nn_1_N : N ;
  handelsvara_nn_1_N : N ;
  handflata_nn_1_N : N ;
  handikappfraaga_nn_1_1_N : N ;
  handkassa_nn_1_N : N ;
  handlampa_nn_1_N : N ;
  handlingsmaenniska_nn_1_1_N : N ;
  handtralla_nn_1_N : N ;
  handvaeska_nn_1_1_N : N ;
  handyxa_nn_1_N : N ;
  hangarfartygsflotta_nn_1_N : N ;
  harhona_nn_1_N : N ;
  harmonika_nn_1_N : N ;
  harmonilaera_nn_1_1_N : N ;
  harpa_nn_1_N : N ;
  harpya_nn_1_N : N ;
  harpyja_nn_1_N : N ;
  harskramla_nn_1_N : N ;
  harsyra_nn_1_N : N ;
  hasch_nn_1_N : N ;
  haschhisch_nn_1_N : N ;
  haschisch_nn_1_N : N ;
  hatkaensla_nn_1_1_N : N ;
  hatthylla_nn_1_N : N ;
  havrekaka_nn_1_N : N ;
  havsbotten_nn_1_N : N ;
  havsfru_nn_1_N : N ;
  havskraefta_nn_1_1_N : N ;
  havssula_nn_1_N : N ;
  havsyta_nn_1_N : N ;
  hebreiska_nn_1_N : N ;
  heder_nn_1_N : N ;
  hedersgaava_nn_1_1_N : N ;
  hederskaensla_nn_1_1_N : N ;
  hederspascha_nn_1_N : N ;
  hejaramsa_nn_1_N : N ;
  hela_nn_1_N : N ;
  helgeflundra_nn_1_N : N ;
  helgongloria_nn_1_N : N ;
  helikopterplatta_nn_1_N : N ;
  helsida_nn_1_N : N ;
  heltaeckningsmatta_nn_1_1_N : N ;
  hemfoederska_nn_1_1_N : N ;
  hemlaexa_nn_1_1_N : N ;
  hemmafru_nn_1_N : N ;
  hemresa_nn_1_N : N ;
  hemsida_nn_1_N : N ;
  hemvaernsstyrka_nn_1_1_N : N ;
  herdepipa_nn_1_N : N ;
  heroinhandel_nn_1_N : N ;
  herpessalva_nn_1_N : N ;
  herrbyxa_nn_1_N : N ;
  herredag_nn_1_N : N ;
  herrsida_nn_1_N : N ;
  hertiginna_nn_1_N : N ;
  hettitiska_nn_1_N : N ;
  himmel_nn_1_N : N ;
  himmelsfaerdsdag_nn_1_1_N : N ;
  hinderbana_nn_1_N : N ;
  hinna_nn_1_N : N ;
  hinnkraefta_nn_1_1_N : N ;
  hippa_nn_1_N : N ;
  hispa_nn_1_N : N ;
  hitlista_nn_1_N : N ;
  hitresa_nn_1_N : N ;
  hjulmutterhylsa_nn_1_N : N ;
  hjulsida_nn_1_N : N ;
  hjaelpgumma_nn_1_1_N : N ;
  hjaelpreda_nn_1_1_N : N ;
  hjaeltekista_nn_1_1_N : N ;
  hjaeltesaga_nn_1_1_N : N ;
  hjaeltinna_nn_1_1_N : N ;
  hjaerna_nn_1_1_N : N ;
  hjaerngympa_nn_1_1_N : N ;
  hjaernhalva_nn_1_1_N : N ;
  hjaernhinna_nn_1_1_N : N ;
  hjaernskada_nn_1_1_N : N ;
  hjaertefraaga_nn_1_1_N : N ;
  hjaertmussla_nn_1_1_N : N ;
  hjaertstilla_nn_1_1_N : N ;
  hjaessa_nn_1_1_N : N ;
  ho_nn_1_N : N ;
  hockeyklubba_nn_1_N : N ;
  hollaendska_nn_1_1_N : N ;
  hollaendska_nn_2_1_N : N ;
  homma_nn_1_N : N ;
  hona_nn_1_N : N ;
  honblomma_nn_1_N : N ;
  honduranska_nn_1_N : N ;
  honungskaka_nn_1_N : N ;
  hoppjerka_nn_1_N : N ;
  hora_nn_1_N : N ;
  horngaedda_nn_1_1_N : N ;
  hornhinna_nn_1_N : N ;
  hornkrona_nn_1_N : N ;
  hornsugga_nn_1_N : N ;
  hornuggla_nn_1_N : N ;
  hortensia_nn_1_N : N ;
  hosta_nn_1_N : N ;
  hostia_nn_1_N : N ;
  hotellmatta_nn_1_N : N ;
  hotellstaederska_nn_1_1_N : N ;
  hottentotska_nn_1_N : N ;
  hottentotska_nn_2_N : N ;
  hudficka_nn_1_N : N ;
  hudolja_nn_1_N : N ;
  hudsalva_nn_1_N : N ;
  hudspricka_nn_1_N : N ;
  huggsexa_nn_1_N : N ;
  huldra_nn_1_N : N ;
  humla_nn_1_N : N ;
  humle_nn_1_N : N ;
  humleblomma_nn_1_N : N ;
  hummertina_nn_1_N : N ;
  humussyra_nn_1_N : N ;
  humoermaenniska_nn_1_1_N : N ;
  hundapa_nn_1_N : N ;
  hundkoja_nn_1_N : N ;
  hundloka_nn_1_N : N ;
  hundracka_nn_1_N : N ;
  hundrova_nn_1_N : N ;
  hurril_nn_1_N : N ;
  husa_nn_1_N : N ;
  husdjursavel_nn_1_N : N ;
  husfluga_nn_1_N : N ;
  husfru_nn_1_N : N ;
  husfoerestaandarinna_nn_1_1_N : N ;
  hushaallerska_nn_1_1_N : N ;
  hushaallskassa_nn_1_1_N : N ;
  hushaallssyssla_nn_1_1_N : N ;
  huslaenga_nn_1_1_N : N ;
  hussvala_nn_1_N : N ;
  hustrumisshandel_nn_1_N : N ;
  huva_nn_1_N : N ;
  huvudfraaga_nn_1_1_N : N ;
  huvudgata_nn_1_N : N ;
  huvudmassa_nn_1_N : N ;
  huvudstyrka_nn_1_N : N ;
  hydda_nn_1_N : N ;
  hydra_nn_1_N : N ;
  hydraulolja_nn_1_N : N ;
  hyena_nn_1_N : N ;
  hygienfraaga_nn_1_1_N : N ;
  hylla_nn_1_N : N ;
  hylsa_nn_1_N : N ;
  hynda_nn_1_N : N ;
  hypotenusa_nn_1_N : N ;
  hyra_nn_1_N : N ;
  hyrestvaaa_nn_1_1_N : N ;
  hyska_nn_1_N : N ;
  hysteri_nn_1_N : N ;
  hysterika_nn_1_N : N ;
  hytta_nn_1_N : N ;
  haeckla_nn_1_1_N : N ;
  haeckloeperska_nn_1_1_N : N ;
  haekta_nn_1_1_N : N ;
  haella_nn_1_1_N : N ;
  haelleflundra_nn_1_1_N : N ;
  haellkista_nn_1_1_N : N ;
  haelsena_nn_1_1_N : N ;
  haelsingska_nn_1_1_N : N ;
  haelsingska_nn_2_1_N : N ;
  haelsofara_nn_1_1_N : N ;
  haelsokaella_nn_1_1_N : N ;
  haelsolaera_nn_1_1_N : N ;
  haelta_nn_1_1_N : N ;
  haemndgudinna_nn_1_1_N : N ;
  haemtpizza_nn_1_1_N : N ;
  haengbana_nn_1_1_N : N ;
  haengbro_nn_1_1_N : N ;
  haengmatta_nn_1_1_N : N ;
  haengraenna_nn_1_1_N : N ;
  haerdsmaelta_nn_1_1_N : N ;
  haerjedalska_nn_1_1_N : N ;
  haerjedalska_nn_2_1_N : N ;
  haermapa_nn_1_1_N : N ;
  haerskara_nn_1_1_N : N ;
  haerskarinna_nn_1_1_N : N ;
  haerva_nn_1_1_N : N ;
  haessja_nn_1_1_N : N ;
  haestgrimma_nn_1_1_N : N ;
  haestkapploepningsbana_nn_1_1_N : N ;
  haestkaerra_nn_1_1_N : N ;
  haestraefsa_nn_1_1_N : N ;
  haetta_nn_1_1_N : N ;
  haexa_nn_1_1_N : N ;
  haala_nn_1_1_N : N ;
  haallbarhetsdag_nn_1_1_N : N ;
  haallfasthetslaera_nn_1_1_N : N ;
  haalremsa_nn_1_1_N : N ;
  haalspetskula_nn_1_1_N : N ;
  haarbotten_nn_1_1_N : N ;
  haardblykula_nn_1_1_N : N ;
  haardvaluta_nn_1_1_N : N ;
  haardvara_nn_1_1_N : N ;
  haarfrissa_nn_1_1_N : N ;
  haarfrisoerska_nn_1_1_N : N ;
  haarnaalskurva_nn_1_1_N : N ;
  haarolja_nn_1_1_N : N ;
  haarpiska_nn_1_1_N : N ;
  haarsida_nn_1_1_N : N ;
  haarslinga_nn_1_1_N : N ;
  hoeftkurva_nn_1_1_N : N ;
  hoegadel_nn_1_1_N : N ;
  hoegbana_nn_1_1_N : N ;
  hoegerkurva_nn_1_1_N : N ;
  hoegeraara_nn_1_1_N : N ;
  hoegfaerdsblaasa_nn_1_1_N : N ;
  hoeghastighetsbana_nn_1_1_N : N ;
  hoeghastighetshandel_nn_1_1_N : N ;
  hoeghastighetskamera_nn_1_1_N : N ;
  hoegkinesiska_nn_1_1_N : N ;
  hoegmaessa_nn_1_1_N : N ;
  hoegprosa_nn_1_1_N : N ;
  hoegsjoeflotta_nn_1_1_N : N ;
  hoegskola_nn_1_1_N : N ;
  hoegtyska_nn_1_1_N : N ;
  hoejdkarta_nn_1_1_N : N ;
  hoejdkurva_nn_1_1_N : N ;
  hoekuggla_nn_1_1_N : N ;
  hoelja_nn_1_1_N : N ;
  hoena_nn_1_1_N : N ;
  hoensgryta_nn_1_1_N : N ;
  hoenshjaerna_nn_1_1_N : N ;
  hoerna_nn_1_1_N : N ;
  hoernflagga_nn_1_1_N : N ;
  hoernlampa_nn_1_1_N : N ;
  hoersaga_nn_1_1_N : N ;
  hoerselskada_nn_1_1_N : N ;
  hoerselsnaecka_nn_1_1_N : N ;
  hoerselvilla_nn_1_1_N : N ;
  hoersnaecka_nn_1_1_N : N ;
  hoestdag_nn_1_1_N : N ;
  hoestgryta_nn_1_1_N : N ;
  hoestgyttja_nn_1_1_N : N ;
  hoestkyla_nn_1_1_N : N ;
  hoetjuga_nn_1_1_N : N ;
  iakttagelsefoermaaga_nn_1_1_N : N ;
  id_bricka_nn_1_N : N ;
  id_nn_3_N : N ;
  idealmaenniska_nn_1_1_N : N ;
  identitetsbricka_nn_1_N : N ;
  idrottsarena_nn_1_N : N ;
  idrottskvinna_nn_1_N : N ;
  idrottsstjaerna_nn_1_1_N : N ;
  id_elaera_nn_1_1_N : N ;
  id_elaera_nn_2_1_N : N ;
  id_espruta_nn_1_1_N : N ;
  illvilja_nn_1_N : N ;
  importfirma_nn_1_N : N ;
  improvisationsfoermaaga_nn_1_1_N : N ;
  imruta_nn_1_N : N ;
  inavel_nn_1_N : N ;
  indexsiffra_nn_1_N : N ;
  indianhydda_nn_1_N : N ;
  indiankvinna_nn_1_N : N ;
  indianska_nn_1_N : N ;
  indikatorlampa_nn_1_N : N ;
  indiska_nn_1_N : N ;
  indonesiska_nn_1_N : N ;
  indonesiska_nn_2_N : N ;
  industriolja_nn_1_N : N ;
  industriolycka_nn_1_N : N ;
  infantinna_nn_1_N : N ;
  infartsraenna_nn_1_1_N : N ;
  influensa_nn_1_N : N ;
  infravaerme_nn_1_1_N : N ;
  injektionsspruta_nn_1_N : N ;
  inkomstklyfta_nn_1_N : N ;
  inkomstkaella_nn_1_1_N : N ;
  inkomstsumma_nn_1_N : N ;
  inkoepslista_nn_1_1_N : N ;
  inlaga_nn_1_N : N ;
  inlandsbana_nn_1_N : N ;
  inlevelsefoermaaga_nn_1_1_N : N ;
  inlaeggningsgurka_nn_1_1_N : N ;
  inlaemningsdag_nn_1_1_N : N ;
  inlaaningsraenta_nn_1_1_N : N ;
  innerbana_nn_1_N : N ;
  innerficka_nn_1_N : N ;
  innerkurva_nn_1_N : N ;
  innersida_nn_1_N : N ;
  inresa_nn_1_N : N ;
  insatsstyrka_nn_1_N : N ;
  inseglingsraenna_nn_1_1_N : N ;
  insektsblomma_nn_1_N : N ;
  insida_nn_1_N : N ;
  insjoe_nn_1_1_N : N ;
  inspirationskaella_nn_1_1_N : N ;
  institutionsskada_nn_1_N : N ;
  instrumentbraeda_nn_1_1_N : N ;
  instrumentlaada_nn_1_1_N : N ;
  instrumentvaeska_nn_1_1_N : N ;
  intarsia_nn_1_N : N ;
  intelligentsia_nn_1_N : N ;
  internatskola_nn_1_N : N ;
  internetsida_nn_1_N : N ;
  intervjufraaga_nn_1_1_N : N ;
  intressefokus_nn_1_N : N ;
  inventarielista_nn_1_N : N ;
  invertsaapa_nn_1_1_N : N ;
  inaega_nn_1_1_N : N ;
  irakiska_nn_1_N : N ;
  iranska_nn_1_N : N ;
  iranska_nn_2_N : N ;
  iriska_nn_1_N : N ;
  iriska_nn_2_N : N ;
  irlaendska_nn_1_1_N : N ;
  irlaendska_nn_2_1_N : N ;
  irrlaera_nn_1_1_N : N ;
  isbana_nn_1_N : N ;
  isbjoernshona_nn_1_1_N : N ;
  isblomma_nn_1_N : N ;
  isblaasa_nn_1_1_N : N ;
  isgata_nn_1_N : N ;
  ishavsdimma_nn_1_N : N ;
  ishockeyklubba_nn_1_N : N ;
  iskana_nn_1_N : N ;
  islandstroeja_nn_1_1_N : N ;
  islaendska_nn_1_1_N : N ;
  islaendska_nn_2_1_N : N ;
  ismassa_nn_1_N : N ;
  isoleringsruta_nn_1_N : N ;
  isprinsessa_nn_1_N : N ;
  israeliska_nn_1_N : N ;
  israeffla_nn_1_1_N : N ;
  israenna_nn_1_1_N : N ;
  issjoe_nn_1_1_N : N ;
  isskrapa_nn_1_N : N ;
  isterhaka_nn_1_N : N ;
  isyxa_nn_1_N : N ;
  italienska_nn_1_N : N ;
  italienska_nn_2_N : N ;
  ivorianska_nn_1_N : N ;
  jacka_nn_1_N : N ;
  jacketkrona_nn_1_N : N ;
  jackettbyxa_nn_1_N : N ;
  jackficka_nn_1_N : N ;
  jaglina_nn_1_N : N ;
  jakobinmoessa_nn_1_1_N : N ;
  jaktresa_nn_1_N : N ;
  jaktvaeska_nn_1_1_N : N ;
  jamaicanska_nn_1_N : N ;
  januarikyla_nn_1_N : N ;
  japanska_nn_1_N : N ;
  japanska_nn_2_N : N ;
  jeansficka_nn_1_N : N ;
  jemenitiska_nn_1_N : N ;
  jenka_nn_1_N : N ;
  jesuitorden_nn_1_N : N ;
  jet_lag_nn_1_N : N ;
  jet_lagg_nn_1_N : N ;
  jetlag_nn_1_N : N ;
  jetlagg_nn_1_N : N ;
  jetslinga_nn_1_N : N ;
  jetaalder_nn_1_1_N : N ;
  jockeymoessa_nn_1_1_N : N ;
  johanniterorden_nn_1_N : N ;
  johannitorden_nn_1_N : N ;
  jonfaella_nn_1_1_N : N ;
  jonkaella_nn_1_1_N : N ;
  jordanska_nn_1_N : N ;
  jordbana_nn_1_N : N ;
  jordhacka_nn_1_N : N ;
  jordhaala_nn_1_1_N : N ;
  jordkula_nn_1_N : N ;
  jordkaerna_nn_1_1_N : N ;
  jordlega_nn_1_N : N ;
  jordloppa_nn_1_N : N ;
  jordremsa_nn_1_N : N ;
  jordraenta_nn_1_1_N : N ;
  jordstjaerna_nn_1_1_N : N ;
  jorduggla_nn_1_N : N ;
  jordyta_nn_1_N : N ;
  jordaertskocka_nn_1_1_N : N ;
  jubelaasna_nn_1_1_N : N ;
  judetyska_nn_1_N : N ;
  judinna_nn_1_N : N ;
  juft_nn_1_N : N ;
  juggemaffia_nn_1_N : N ;
  jugoslaviska_nn_1_N : N ;
  julfemma_nn_1_N : N ;
  julgranskula_nn_1_N : N ;
  julgransmatta_nn_1_N : N ;
  julgaava_nn_1_1_N : N ;
  julhandel_nn_1_N : N ;
  julifoermiddag_nn_1_1_N : N ;
  juligroenska_nn_1_1_N : N ;
  julkrubba_nn_1_N : N ;
  julotta_nn_1_N : N ;
  julskinka_nn_1_N : N ;
  julstjaerna_nn_1_1_N : N ;
  julstrumpa_nn_1_N : N ;
  jungfruresa_nn_1_N : N ;
  jungfruslaenda_nn_1_1_N : N ;
  junta_nn_1_N : N ;
  jurta_nn_1_N : N ;
  jute_nn_1_N : N ;
  jyllaendska_nn_1_1_N : N ;
  jyllaendska_nn_2_1_N : N ;
  jaegarstenaalder_nn_1_1_N : N ;
  jaemstaelldhetsskilsmaessa_nn_1_1_N : N ;
  jaemtlaendska_nn_1_1_N : N ;
  jaemtlaendska_nn_2_1_N : N ;
  jaemtska_nn_1_1_N : N ;
  jaemtska_nn_2_1_N : N ;
  jaenta_nn_1_1_N : N ;
  jaernbana_nn_1_1_N : N ;
  jaernkaerna_nn_1_1_N : N ;
  jaernlunga_nn_1_1_N : N ;
  jaernsmaelta_nn_1_1_N : N ;
  jaernvara_nn_1_1_N : N ;
  jaernvilja_nn_1_1_N : N ;
  jaernvaegsbro_nn_1_1_N : N ;
  jaernvaegsskena_nn_1_1_N : N ;
  jaernyxa_nn_1_1_N : N ;
  jaernaalder_nn_1_1_N : N ;
  jaettebubbla_nn_1_1_N : N ;
  jaettegryta_nn_1_1_N : N ;
  jaettekvinna_nn_1_1_N : N ;
  jaettestjaerna_nn_1_1_N : N ;
  jaetteoedla_nn_1_1_N : N ;
  jaettinna_nn_1_1_N : N ;
  jaevsfraaga_nn_1_1_N : N ;
  kabbeleka_nn_1_N : N ;
  kabbleka_nn_1_N : N ;
  kabelbro_nn_1_N : N ;
  kabelvinda_nn_1_N : N ;
  kabinettsfraaga_nn_1_1_N : N ;
  kabinvaeska_nn_1_1_N : N ;
  kackerlacka_nn_1_N : N ;
  kadettskola_nn_1_N : N ;
  kafeteria_nn_1_N : N ;
  kaffebricka_nn_1_N : N ;
  kaffeboena_nn_1_1_N : N ;
  kaffehalva_nn_1_N : N ;
  kaffehurra_nn_1_N : N ;
  kaffekanna_nn_1_N : N ;
  kaffepanna_nn_1_N : N ;
  kaja_nn_1_N : N ;
  kajalpenna_nn_1_N : N ;
  kajuta_nn_1_N : N ;
  kaka_nn_1_N : N ;
  kakadua_nn_1_N : N ;
  kakao_nn_1_N : N ;
  kakaoboena_nn_1_1_N : N ;
  kakelplatta_nn_1_N : N ;
  kakelugnslucka_nn_1_N : N ;
  kalabasspumpa_nn_1_N : N ;
  kalasbyxa_nn_1_N : N ;
  kalaskula_nn_1_N : N ;
  kalaspingla_nn_1_N : N ;
  kalciumsulfat_nn_1_N : N ;
  kalebasspumpa_nn_1_N : N ;
  kalendervecka_nn_1_N : N ;
  kaliumsulfat_nn_1_N : N ;
  kalkerlaerft_nn_1_1_N : N ;
  kalkstensplatta_nn_1_N : N ;
  kalla_nn_1_N : N ;
  kallelselista_nn_1_N : N ;
  kallhyra_nn_1_N : N ;
  kallkaella_nn_1_1_N : N ;
  kallskaenka_nn_1_1_N : N ;
  kalvlaeggsgryta_nn_1_1_N : N ;
  kalvsylta_nn_1_N : N ;
  kamarilla_nn_1_N : N ;
  kambodjanska_nn_1_N : N ;
  kamelia_nn_1_N : N ;
  kamelklocka_nn_1_N : N ;
  kamera_nn_1_N : N ;
  kamerunska_nn_1_N : N ;
  kamkofta_nn_1_N : N ;
  kammarfru_nn_1_N : N ;
  kammussla_nn_1_N : N ;
  kampvilja_nn_1_N : N ;
  kana_nn_1_N : N ;
  kanadensiska_nn_1_N : N ;
  kandidatlista_nn_1_N : N ;
  kanelbulla_nn_1_N : N ;
  kanelflaeta_nn_1_1_N : N ;
  kaninhaala_nn_1_1_N : N ;
  kanna_nn_1_N : N ;
  kannibalgryta_nn_1_N : N ;
  kanonkula_nn_1_N : N ;
  kanonlucka_nn_1_N : N ;
  kanotresa_nn_1_N : N ;
  kanslisvenska_nn_1_N : N ;
  kantblomma_nn_1_N : N ;
  kantilena_nn_1_N : N ;
  kaolin_nn_1_N : N ;
  kapduva_nn_1_N : N ;
  kapitalvara_nn_1_N : N ;
  kappa_nn_1_N : N ;
  kapphylla_nn_1_N : N ;
  kapskiva_nn_1_N : N ;
  kapucinapa_nn_1_N : N ;
  kapucinerorden_nn_1_N : N ;
  kapucinorden_nn_1_N : N ;
  kapverdiska_nn_1_N : N ;
  kapybara_nn_1_N : N ;
  kara_nn_1_N : N ;
  karakteristika_nn_1_N : N ;
  karaktaeristika_nn_1_1_N : N ;
  karaktaersstyrka_nn_1_1_N : N ;
  karbidlampa_nn_1_N : N ;
  karbolsyra_nn_1_N : N ;
  karbonkopia_nn_1_N : N ;
  karbonsyra_nn_1_N : N ;
  karboxylsyra_nn_1_N : N ;
  karda_nn_1_N : N ;
  karduan_nn_1_N : N ;
  karelska_nn_1_N : N ;
  karelska_nn_2_N : N ;
  kareta_nn_1_N : N ;
  karl_nn_1_N : N ;
  karlakarl_nn_1_N : N ;
  karljohanssoffa_nn_1_N : N ;
  karltorka_nn_1_N : N ;
  karmeliterorden_nn_1_N : N ;
  karmelitorden_nn_1_N : N ;
  karmin_nn_1_N : N ;
  karminsyra_nn_1_N : N ;
  karmosin_nn_1_N : N ;
  karta_nn_1_N : N ;
  karteschkula_nn_1_N : N ;
  kartlampa_nn_1_N : N ;
  kartlaesarlampa_nn_1_1_N : N ;
  kartotekslaada_nn_1_1_N : N ;
  kartusianerorden_nn_1_N : N ;
  kartusianorden_nn_1_N : N ;
  kaschmir_nn_1_N : N ;
  kaschmirtroeja_nn_1_1_N : N ;
  kashmirtroeja_nn_1_1_N : N ;
  kasperdocka_nn_1_N : N ;
  kassa_nn_1_N : N ;
  kassa_nn_2_N : N ;
  kassakista_nn_1_N : N ;
  kassalaada_nn_1_1_N : N ;
  kassoerska_nn_1_1_N : N ;
  kastbana_nn_1_N : N ;
  kastilianska_nn_1_N : N ;
  kastilianska_nn_2_N : N ;
  kasuslaera_nn_1_1_N : N ;
  kat_nn_1_N : N ;
  katalanska_nn_1_N : N ;
  katalanska_nn_2_N : N ;
  kataloglaada_nn_1_1_N : N ;
  katastrofkaensla_nn_1_1_N : N ;
  katastrofsiffra_nn_1_N : N ;
  katedralsklocka_nn_1_N : N ;
  katedralskola_nn_1_N : N ;
  katsa_nn_1_N : N ;
  katta_nn_1_N : N ;
  kattgina_nn_1_N : N ;
  kattlucka_nn_1_N : N ;
  kattuggla_nn_1_N : N ;
  kaukasiska_nn_1_N : N ;
  kaustika_nn_1_N : N ;
  kavajficka_nn_1_N : N ;
  kavelbro_nn_1_N : N ;
  kazakiska_nn_1_N : N ;
  kazakiska_nn_2_N : N ;
  kedja_nn_1_N : N ;
  kejsarinna_nn_1_N : N ;
  kejsarkrona_nn_1_N : N ;
  keltiska_nn_1_N : N ;
  keltiska_nn_2_N : N ;
  kenyanska_nn_1_N : N ;
  keramikkruka_nn_1_N : N ;
  keramiklampa_nn_1_N : N ;
  keramikskaerva_nn_1_1_N : N ;
  kicka_nn_1_N : N ;
  kilremsskiva_nn_1_N : N ;
  kindkedja_nn_1_N : N ;
  kindknota_nn_1_N : N ;
  kindkota_nn_1_N : N ;
  kinesiska_nn_1_N : N ;
  kinesiska_nn_2_N : N ;
  kinin_nn_1_N : N ;
  kirgisiska_nn_1_N : N ;
  kirgisiska_nn_2_N : N ;
  kirgiziska_nn_1_N : N ;
  kirgiziska_nn_2_N : N ;
  kiribatiska_nn_1_N : N ;
  kisel_nn_1_N : N ;
  kiselgur_nn_1_N : N ;
  kiselplatta_nn_1_N : N ;
  kiselsyra_nn_1_N : N ;
  kista_nn_1_N : N ;
  kitin_nn_1_N : N ;
  kitsch_nn_1_N : N ;
  kjusa_nn_1_N : N ;
  kladdkaka_nn_1_N : N ;
  klaffbro_nn_1_N : N ;
  klagovisa_nn_1_N : N ;
  klangbotten_nn_1_N : N ;
  klappa_nn_1_N : N ;
  klappbrygga_nn_1_N : N ;
  klappbraeda_nn_1_1_N : N ;
  klassklyfta_nn_1_N : N ;
  klasslista_nn_1_N : N ;
  klassmamma_nn_1_N : N ;
  klasspappa_nn_1_N : N ;
  klassresa_nn_1_N : N ;
  klentro_nn_1_N : N ;
  klimakteriehaexa_nn_1_1_N : N ;
  klimatfraaga_nn_1_1_N : N ;
  klimatlaera_nn_1_1_N : N ;
  klinga_nn_1_N : N ;
  klinka_nn_1_N : N ;
  klippa_nn_1_N : N ;
  klippdocka_nn_1_N : N ;
  klipphaala_nn_1_1_N : N ;
  klippskreva_nn_1_N : N ;
  klippstuga_nn_1_N : N ;
  klisterremsa_nn_1_N : N ;
  klivstaetta_nn_1_1_N : N ;
  klocka_nn_1_N : N ;
  klockgroda_nn_1_N : N ;
  klockkedja_nn_1_N : N ;
  klorlaecka_nn_1_1_N : N ;
  klorofyll_nn_1_N : N ;
  klorsyra_nn_1_N : N ;
  klorvaetesyra_nn_1_1_N : N ;
  klosterkyrka_nn_1_N : N ;
  klosterorden_nn_1_N : N ;
  klotyta_nn_1_N : N ;
  klubba_nn_1_N : N ;
  klubbjacka_nn_1_N : N ;
  klumpsumma_nn_1_N : N ;
  klunga_nn_1_N : N ;
  klyfta_nn_1_N : N ;
  klyka_nn_1_N : N ;
  klyscha_nn_1_N : N ;
  klyvyxa_nn_1_N : N ;
  klaednypa_nn_1_1_N : N ;
  klaedtrasa_nn_1_1_N : N ;
  klaemma_nn_1_1_N : N ;
  klaengranka_nn_1_1_N : N ;
  kloeversnaerja_nn_1_1_N : N ;
  kloevsadelkyrka_nn_1_1_N : N ;
  kloevsadelskyrka_nn_1_1_N : N ;
  knalldosa_nn_1_N : N ;
  knapadel_nn_1_N : N ;
  knapphaalsblomma_nn_1_1_N : N ;
  knarkhandel_nn_1_N : N ;
  knarkhaerva_nn_1_1_N : N ;
  knipa_nn_1_N : N ;
  knippa_nn_1_N : N ;
  knivlaada_nn_1_1_N : N ;
  knivslida_nn_1_N : N ;
  knota_nn_1_N : N ;
  knottra_nn_1_N : N ;
  knuta_nn_1_N : N ;
  knutlampa_nn_1_N : N ;
  knutpiska_nn_1_N : N ;
  knyppeldyna_nn_1_N : N ;
  knaebyxa_nn_1_1_N : N ;
  knaeckfraaga_nn_1_1_N : N ;
  knaeppkaenga_nn_1_1_N : N ;
  knaeskada_nn_1_1_N : N ;
  knaestrumpa_nn_1_1_N : N ;
  koala_nn_1_N : N ;
  kobra_nn_1_N : N ;
  kobrygga_nn_1_N : N ;
  kocka_nn_1_N : N ;
  kockmoessa_nn_1_1_N : N ;
  kodein_nn_1_N : N ;
  koffein_nn_1_N : N ;
  kofferdiflotta_nn_1_N : N ;
  kofta_nn_1_N : N ;
  kohandel_nn_1_N : N ;
  koine_nn_1_N : N ;
  koja_nn_1_N : N ;
  koka_nn_1_N : N ;
  kokain_nn_1_N : N ;
  kokainhandel_nn_1_N : N ;
  kokainliga_nn_1_N : N ;
  kokakola_nn_1_N : N ;
  kokerska_nn_1_N : N ;
  koklaada_nn_1_1_N : N ;
  koklaaga_nn_1_1_N : N ;
  kokoskaka_nn_1_N : N ;
  kokosmatta_nn_1_N : N ;
  kokplatta_nn_1_N : N ;
  kola_nn_1_N : N ;
  kola_nn_2_N : N ;
  kolartro_nn_1_N : N ;
  kolbotten_nn_1_N : N ;
  koleraflagga_nn_1_N : N ;
  kolesterol_nn_1_N : N ;
  kolgruva_nn_1_N : N ;
  kolgruveolycka_nn_1_N : N ;
  kolja_nn_1_N : N ;
  kolmila_nn_1_N : N ;
  kolonialvara_nn_1_N : N ;
  kolonistuga_nn_1_N : N ;
  koloratursaangerska_nn_1_1_N : N ;
  kolstybbsbana_nn_1_N : N ;
  kolsyra_nn_1_N : N ;
  koltaalder_nn_1_1_N : N ;
  koma_nn_1_N : N ;
  kombinationsfoermaaga_nn_1_1_N : N ;
  kommandobrygga_nn_1_N : N ;
  kommunistgerilla_nn_1_N : N ;
  komocka_nn_1_N : N ;
  komoriska_nn_1_N : N ;
  kompaktkamera_nn_1_N : N ;
  kompaktskiva_nn_1_N : N ;
  kompoundkaerna_nn_1_1_N : N ;
  kompromissvilja_nn_1_N : N ;
  kona_nn_1_N : N ;
  koncentrationsfoermaaga_nn_1_1_N : N ;
  kondens_nn_1_N : N ;
  kondensationskaerna_nn_1_1_N : N ;
  kondensstrimma_nn_1_N : N ;
  konfirmandresa_nn_1_N : N ;
  kongolesiska_nn_1_N : N ;
  konjakskupa_nn_1_N : N ;
  konjunkturkurva_nn_1_N : N ;
  konkursmassa_nn_1_N : N ;
  konstliga_nn_1_N : N ;
  konstmassa_nn_1_N : N ;
  konstskola_nn_1_N : N ;
  konsulinna_nn_1_N : N ;
  konsumentfraaga_nn_1_1_N : N ;
  konsumtionsvara_nn_1_N : N ;
  kontaktkopia_nn_1_N : N ;
  kontorsflicka_nn_1_N : N ;
  kontorsraatta_nn_1_1_N : N ;
  kontorsvana_nn_1_N : N ;
  konungakrona_nn_1_N : N ;
  kopia_nn_1_N : N ;
  koppa_nn_1_N : N ;
  koppargruva_nn_1_N : N ;
  kopparaalder_nn_1_1_N : N ;
  kopparoedla_nn_1_1_N : N ;
  koptiska_nn_1_N : N ;
  kopula_nn_1_N : N ;
  koralloe_nn_1_1_N : N ;
  korda_nn_1_N : N ;
  koreanska_nn_1_N : N ;
  koreanska_nn_2_N : N ;
  korkboessa_nn_1_1_N : N ;
  korkmassa_nn_1_N : N ;
  korkmatta_nn_1_N : N ;
  korksula_nn_1_N : N ;
  korniska_nn_1_N : N ;
  korona_nn_1_N : N ;
  korruptionshaerva_nn_1_1_N : N ;
  korsbensflaeta_nn_1_1_N : N ;
  korsikanska_nn_1_N : N ;
  korsikanska_nn_2_N : N ;
  korskota_nn_1_N : N ;
  korskyrka_nn_1_N : N ;
  kortbyxa_nn_1_N : N ;
  kortlaada_nn_1_1_N : N ;
  kortprosa_nn_1_N : N ;
  kortrunda_nn_1_N : N ;
  kortsida_nn_1_N : N ;
  korttidsvecka_nn_1_N : N ;
  kortvara_nn_1_N : N ;
  kortaenda_nn_1_1_N : N ;
  korvgryta_nn_1_N : N ;
  korvkaka_nn_1_N : N ;
  korvmacka_nn_1_N : N ;
  korvsjoe_nn_1_1_N : N ;
  korvskiva_nn_1_N : N ;
  kosa_nn_1_N : N ;
  koskaella_nn_1_1_N : N ;
  kosovanska_nn_1_N : N ;
  kossa_nn_1_N : N ;
  kostvana_nn_1_N : N ;
  kota_nn_1_N : N ;
  krabba_nn_1_N : N ;
  krabbtaska_nn_1_N : N ;
  kraftkaella_nn_1_1_N : N ;
  kramla_nn_1_N : N ;
  krampa_nn_1_N : N ;
  kranskulla_nn_1_N : N ;
  krasch_nn_1_N : N ;
  kraterbotten_nn_1_N : N ;
  kratersjoe_nn_1_1_N : N ;
  kratta_nn_1_N : N ;
  kreditoro_nn_1_N : N ;
  kremla_nn_1_N : N ;
  kreolska_nn_1_N : N ;
  kreolska_nn_2_N : N ;
  kreosotolja_nn_1_N : N ;
  kria_nn_1_N : N ;
  kricka_nn_1_N : N ;
  krigaradel_nn_1_N : N ;
  krigsflotta_nn_1_N : N ;
  krigsgudinna_nn_1_N : N ;
  krigssjukskoeterska_nn_1_1_N : N ;
  krigsskada_nn_1_N : N ;
  kringla_nn_1_N : N ;
  kristallkrona_nn_1_N : N ;
  kristallkula_nn_1_N : N ;
  kristallolja_nn_1_N : N ;
  krita_nn_1_N : N ;
  kritpipa_nn_1_N : N ;
  kroatiska_nn_1_N : N ;
  kroatiska_nn_2_N : N ;
  krogronda_nn_1_N : N ;
  krogrunda_nn_1_N : N ;
  kroknaesa_nn_1_1_N : N ;
  krom_nn_1_N : N ;
  kromsyra_nn_1_N : N ;
  krona_nn_1_N : N ;
  kronprinsessa_nn_1_N : N ;
  kronaertskocka_nn_1_1_N : N ;
  kronaertskocksbotten_nn_1_1_N : N ;
  kroppkaka_nn_1_N : N ;
  kroppshydda_nn_1_N : N ;
  kroppsskada_nn_1_N : N ;
  kroppsstrumpa_nn_1_N : N ;
  kroppsstyrka_nn_1_N : N ;
  kroppsvaetska_nn_1_1_N : N ;
  krosskada_nn_1_N : N ;
  krubba_nn_1_N : N ;
  kruka_nn_1_N : N ;
  krukskaerva_nn_1_1_N : N ;
  krusta_nn_1_N : N ;
  krycka_nn_1_N : N ;
  krydda_nn_1_N : N ;
  krydda_nn_2_N : N ;
  kryddnejlika_nn_1_N : N ;
  krypta_nn_1_N : N ;
  krypton_nn_1_N : N ;
  krysantemumplanta_nn_1_N : N ;
  kraeckla_nn_1_1_N : N ;
  kraefta_nn_1_1_N : N ;
  kraefta_nn_2_1_N : N ;
  kraeftskiva_nn_1_1_N : N ;
  kraekla_nn_1_1_N : N ;
  kraemla_nn_1_1_N : N ;
  kraempa_nn_1_1_N : N ;
  kraeppnylon_nn_1_1_N : N ;
  kraeva_nn_1_1_N : N ;
  kraaka_nn_1_1_N : N ;
  kraaksyra_nn_1_1_N : N ;
  kroenika_nn_1_1_N : N ;
  kubanska_nn_1_N : N ;
  kuggfraaga_nn_1_1_N : N ;
  kula_nn_1_N : N ;
  kulbana_nn_1_N : N ;
  kulla_nn_1_N : N ;
  kullerbytta_nn_1_N : N ;
  kulpenna_nn_1_N : N ;
  kulspetspenna_nn_1_N : N ;
  kulspruta_nn_1_N : N ;
  kulturmaenniska_nn_1_1_N : N ;
  kultursida_nn_1_N : N ;
  kummin_nn_1_N : N ;
  kungakrona_nn_1_N : N ;
  kungskrabba_nn_1_N : N ;
  kungsaengslilja_nn_1_1_N : N ;
  kungsaadra_nn_1_1_N : N ;
  kunskapskaella_nn_1_1_N : N ;
  kupa_nn_1_N : N ;
  kurdiska_nn_1_N : N ;
  kurdiska_nn_2_N : N ;
  kuria_nn_1_N : N ;
  kurirresa_nn_1_N : N ;
  kurva_nn_1_N : N ;
  kustflotta_nn_1_N : N ;
  kustremsa_nn_1_N : N ;
  kustsnaeppa_nn_1_1_N : N ;
  kuststraecka_nn_1_1_N : N ;
  kuvertvaeska_nn_1_1_N : N ;
  kuwaitiska_nn_1_N : N ;
  kvagga_nn_1_N : N ;
  kvarleva_nn_1_N : N ;
  kvartslampa_nn_1_N : N ;
  kvicksilvergruva_nn_1_N : N ;
  kvicksilverlampa_nn_1_N : N ;
  kviga_nn_1_N : N ;
  kvinna_nn_1_N : N ;
  kvinnofraaga_nn_1_1_N : N ;
  kvinnofaella_nn_1_1_N : N ;
  kvinnosakskvinna_nn_1_N : N ;
  kvissla_nn_1_N : N ;
  kvistruna_nn_1_N : N ;
  kvaellsdimma_nn_1_1_N : N ;
  kvaellsfaerja_nn_1_1_N : N ;
  kvaellskyla_nn_1_1_N : N ;
  kvaellsmaenniska_nn_1_1_N : N ;
  kvaevningsskada_nn_1_1_N : N ;
  kyla_nn_1_N : N ;
  kylarvaetska_nn_1_1_N : N ;
  kylskada_nn_1_N : N ;
  kylvaeska_nn_1_1_N : N ;
  kymriska_nn_1_N : N ;
  kyndelsmaessa_nn_1_1_N : N ;
  kyrka_nn_1_N : N ;
  kyrkklocka_nn_1_N : N ;
  kyrkostaemma_nn_1_1_N : N ;
  kyrkslaviska_nn_1_N : N ;
  kaegelbana_nn_1_1_N : N ;
  kaegla_nn_1_1_N : N ;
  kaekhaala_nn_1_1_N : N ;
  kaella_nn_1_1_N : N ;
  kaellartrappa_nn_1_1_N : N ;
  kaellsjoe_nn_1_1_N : N ;
  kaenga_nn_1_1_N : N ;
  kaensla_nn_1_1_N : N ;
  kaenslokyla_nn_1_1_N : N ;
  kaenslomaenniska_nn_1_1_N : N ;
  kaeppkrycka_nn_1_1_N : N ;
  kaeresta_nn_1_1_N : N ;
  kaerleksgudinna_nn_1_1_N : N ;
  kaerlekssaga_nn_1_1_N : N ;
  kaerleksvisa_nn_1_1_N : N ;
  kaerna_nn_1_1_N : N ;
  kaernfraaga_nn_1_1_N : N ;
  kaerngumma_nn_1_1_N : N ;
  kaernkraftsolycka_nn_1_1_N : N ;
  kaernskugga_nn_1_1_N : N ;
  kaerra_nn_1_1_N : N ;
  kaerrsnaeppa_nn_1_1_N : N ;
  kaada_nn_1_1_N : N ;
  kaalfjaeril_nn_1_1_N : N ;
  kaalsoppa_nn_1_1_N : N ;
  kaapa_nn_1_1_N : N ;
  kaaranda_nn_1_1_N : N ;
  kaasa_nn_1_1_N : N ;
  kaasoerprosa_nn_1_1_N : N ;
  kaata_nn_1_1_N : N ;
  koebricka_nn_1_1_N : N ;
  koeksa_nn_1_1_N : N ;
  koekssoffa_nn_1_1_N : N ;
  koeldskada_nn_1_1_N : N ;
  koelfena_nn_1_1_N : N ;
  koelna_nn_1_1_N : N ;
  koelskena_nn_1_1_N : N ;
  koepesumma_nn_1_1_N : N ;
  koeplada_nn_1_1_N : N ;
  koerbana_nn_1_1_N : N ;
  koerkortsaalder_nn_1_1_N : N ;
  koersla_nn_1_1_N : N ;
  koerstraecka_nn_1_1_N : N ;
  koervisa_nn_1_1_N : N ;
  koettfluga_nn_1_1_N : N ;
  koettfaerslimpa_nn_1_1_N : N ;
  koettgryta_nn_1_1_N : N ;
  koettsida_nn_1_1_N : N ;
  koettskada_nn_1_1_N : N ;
  koettskiva_nn_1_1_N : N ;
  koettslamsa_nn_1_1_N : N ;
  koettsoppa_nn_1_1_N : N ;
  koettyxa_nn_1_1_N : N ;
  labialpipa_nn_1_N : N ;
  labialstaemma_nn_1_1_N : N ;
  laboratoriekuriosa_nn_1_N : N ;
  laboratorieraatta_nn_1_1_N : N ;
  lada_nn_1_N : N ;
  ladusvala_nn_1_N : N ;
  lagerkona_nn_1_N : N ;
  lagsaga_nn_1_N : N ;
  lagunsjoe_nn_1_1_N : N ;
  lakansremsa_nn_1_N : N ;
  lama_nn_1_N : N ;
  lama_nn_2_N : N ;
  lampa_nn_1_N : N ;
  lampkupa_nn_1_N : N ;
  lampolja_nn_1_N : N ;
  lana_nn_1_N : N ;
  landbrygga_nn_1_N : N ;
  landkrabba_nn_1_N : N ;
  landmassa_nn_1_N : N ;
  landmina_nn_1_N : N ;
  landningsbana_nn_1_N : N ;
  landremsa_nn_1_N : N ;
  landsida_nn_1_N : N ;
  landskapsblomma_nn_1_N : N ;
  landsmaninna_nn_1_N : N ;
  landsnaecka_nn_1_1_N : N ;
  landsplaaga_nn_1_1_N : N ;
  landstraecka_nn_1_1_N : N ;
  landsaenda_nn_1_1_N : N ;
  landtunga_nn_1_N : N ;
  lanka_nn_1_N : N ;
  lankesiska_nn_1_N : N ;
  lanolin_nn_1_N : N ;
  lantan_nn_1_N : N ;
  lanterna_nn_1_N : N ;
  lantlolla_nn_1_N : N ;
  laotiska_nn_1_N : N ;
  laotiska_nn_2_N : N ;
  lapkojs_nn_1_N : N ;
  lappkojs_nn_1_N : N ;
  lapplisa_nn_1_N : N ;
  lapplaendska_nn_1_1_N : N ;
  lappskojs_nn_1_N : N ;
  lapska_nn_1_N : N ;
  lapska_nn_2_N : N ;
  lapskojs_nn_1_N : N ;
  larmklocka_nn_1_N : N ;
  larva_nn_1_N : N ;
  laserskiva_nn_1_N : N ;
  lastbrygga_nn_1_N : N ;
  lastlucka_nn_1_N : N ;
  lastplatta_nn_1_N : N ;
  lastyta_nn_1_N : N ;
  lastaasna_nn_1_1_N : N ;
  latex_nn_1_N : N ;
  latinamerikanska_nn_1_N : N ;
  latmaja_nn_1_N : N ;
  latta_nn_1_N : N ;
  laura_nn_1_N : N ;
  lava_nn_1_N : N ;
  lavasjoe_nn_1_1_N : N ;
  lavskrika_nn_1_N : N ;
  laxkista_nn_1_N : N ;
  laxraenna_nn_1_1_N : N ;
  laxsida_nn_1_N : N ;
  laxtrappa_nn_1_N : N ;
  ledarsida_nn_1_N : N ;
  leddocka_nn_1_N : N ;
  ledningsfoermaaga_nn_1_1_N : N ;
  ledsagarinna_nn_1_N : N ;
  ledstjaerna_nn_1_1_N : N ;
  ledvaetska_nn_1_1_N : N ;
  ledyta_nn_1_N : N ;
  lega_nn_1_N : N ;
  leidenflaska_nn_1_N : N ;
  leidnerflaska_nn_1_N : N ;
  lejoninna_nn_1_N : N ;
  lejonkula_nn_1_N : N ;
  lekattfaella_nn_1_1_N : N ;
  leksaksboessa_nn_1_1_N : N ;
  lekskola_nn_1_N : N ;
  lekstuga_nn_1_N : N ;
  lera_nn_1_N : N ;
  lerbotten_nn_1_N : N ;
  lerduva_nn_1_N : N ;
  lerkruka_nn_1_N : N ;
  lerskaerva_nn_1_1_N : N ;
  lesothiska_nn_1_N : N ;
  lettiska_nn_1_N : N ;
  lettiska_nn_2_N : N ;
  lettlaendska_nn_1_1_N : N ;
  lettlaendska_nn_2_1_N : N ;
  levermossa_nn_1_N : N ;
  leverpastejmacka_nn_1_N : N ;
  levnadsbana_nn_1_N : N ;
  levnadssaga_nn_1_N : N ;
  libanesiska_nn_1_N : N ;
  libbsticka_nn_1_N : N ;
  liberianska_nn_1_N : N ;
  libsticka_nn_1_N : N ;
  libyska_nn_1_N : N ;
  liechtensteinska_nn_1_N : N ;
  liga_nn_1_N : N ;
  ligghoena_nn_1_1_N : N ;
  liggsoffa_nn_1_N : N ;
  ligusterfjaeril_nn_1_1_N : N ;
  likkista_nn_1_N : N ;
  likvaka_nn_1_N : N ;
  likvida_nn_1_N : N ;
  lilja_nn_1_N : N ;
  lillflicka_nn_1_N : N ;
  lillstuga_nn_1_N : N ;
  lillvaerdinna_nn_1_1_N : N ;
  limaboena_nn_1_1_N : N ;
  limklaemma_nn_1_1_N : N ;
  limpa_nn_1_N : N ;
  limsticka_nn_1_N : N ;
  lina_nn_1_N : N ;
  linbana_nn_1_N : N ;
  linda_nn_1_N : N ;
  lindblomma_nn_1_N : N ;
  lingonmos_nn_1_N : N ;
  lingonristuva_nn_1_N : N ;
  lingonruta_nn_1_N : N ;
  linnea_nn_1_N : N ;
  linolensyra_nn_1_N : N ;
  linoleum_nn_1_N : N ;
  linoleummatta_nn_1_N : N ;
  linolja_nn_1_N : N ;
  linolsyra_nn_1_N : N ;
  linong_nn_1_N : N ;
  linskiva_nn_1_N : N ;
  linssoppa_nn_1_N : N ;
  lira_nn_1_N : N ;
  lista_nn_1_N : N ;
  listetta_nn_1_N : N ;
  litania_nn_1_N : N ;
  litauiska_nn_1_N : N ;
  litauiska_nn_2_N : N ;
  littera_nn_1_N : N ;
  livlina_nn_1_N : N ;
  livmoderhaala_nn_1_1_N : N ;
  livmodersslemhinna_nn_1_N : N ;
  livraenta_nn_1_1_N : N ;
  livs_nn_1_N : N ;
  livsfraaga_nn_1_1_N : N ;
  livslaaga_nn_1_1_N : N ;
  livsmedelskedja_nn_1_N : N ;
  livstro_nn_1_N : N ;
  livsvilja_nn_1_N : N ;
  ljudkaella_nn_1_1_N : N ;
  ljudlaera_nn_1_1_N : N ;
  ljudslinga_nn_1_N : N ;
  ljudspringa_nn_1_N : N ;
  ljudstyrka_nn_1_N : N ;
  ljuskrona_nn_1_N : N ;
  ljuskaegla_nn_1_1_N : N ;
  ljuskaella_nn_1_1_N : N ;
  ljuslykta_nn_1_N : N ;
  ljuspenna_nn_1_N : N ;
  ljusslinga_nn_1_N : N ;
  ljusstyrka_nn_1_N : N ;
  ljusterapilampa_nn_1_N : N ;
  ljustuta_nn_1_N : N ;
  lo_nn_1_N : N ;
  lobelia_nn_1_N : N ;
  lodboessa_nn_1_1_N : N ;
  lodlina_nn_1_N : N ;
  logga_nn_1_N : N ;
  loggia_nn_1_N : N ;
  loggskaedda_nn_1_1_N : N ;
  loka_nn_1_N : N ;
  lolla_nn_1_N : N ;
  loppa_nn_1_N : N ;
  loska_nn_1_N : N ;
  losta_nn_1_N : N ;
  lotta_nn_1_N : N ;
  lucia_nn_1_N : N ;
  luciakrona_nn_1_N : N ;
  lucka_nn_1_N : N ;
  ludd_nn_1_N : N ;
  luftbro_nn_1_N : N ;
  luftbubbla_nn_1_N : N ;
  luftboessa_nn_1_1_N : N ;
  luftflotta_nn_1_N : N ;
  luftmaska_nn_1_N : N ;
  luftmassa_nn_1_N : N ;
  lufttrumma_nn_1_N : N ;
  luftvapenkula_nn_1_N : N ;
  luktflaska_nn_1_N : N ;
  luma_nn_1_N : N ;
  lumberjacka_nn_1_N : N ;
  lunchlaada_nn_1_1_N : N ;
  lunchvana_nn_1_N : N ;
  lunga_nn_1_N : N ;
  lungblaasa_nn_1_1_N : N ;
  lungroeta_nn_1_1_N : N ;
  lungsnaecka_nn_1_1_N : N ;
  lunta_nn_1_N : N ;
  lusekofta_nn_1_N : N ;
  lussebulla_nn_1_N : N ;
  lustkaensla_nn_1_1_N : N ;
  luta_nn_1_N : N ;
  luva_nn_1_N : N ;
  luxemburgska_nn_1_N : N ;
  lya_nn_1_N : N ;
  lycka_nn_2_N : N ;
  lyckokaensla_nn_1_1_N : N ;
  lyckostjaerna_nn_1_1_N : N ;
  lyftbro_nn_1_N : N ;
  lykta_nn_1_N : N ;
  lyra_nn_1_N : N ;
  lysraeka_nn_1_1_N : N ;
  lysroerslampa_nn_1_1_N : N ;
  lyssnarskara_nn_1_N : N ;
  lyxfaella_nn_1_1_N : N ;
  lyxlya_nn_1_N : N ;
  lyxskinka_nn_1_N : N ;
  lyxvara_nn_1_N : N ;
  lyxvilla_nn_1_N : N ;
  laebba_nn_1_1_N : N ;
  laecka_nn_1_1_N : N ;
  laederjacka_nn_1_1_N : N ;
  laederkula_nn_1_1_N : N ;
  laederslida_nn_1_1_N : N ;
  laegda_nn_1_1_N : N ;
  laegerskola_nn_1_1_N : N ;
  laendflaeta_nn_1_1_N : N ;
  laendkota_nn_1_1_N : N ;
  laenga_nn_1_1_N : N ;
  laengdspricka_nn_1_1_N : N ;
  laenkroeta_nn_1_1_N : N ;
  laera_nn_1_1_N : N ;
  laerarhoegskola_nn_1_1_N : N ;
  laerarinna_nn_1_1_N : N ;
  laerdomsskola_nn_1_1_N : N ;
  laerka_nn_1_1_N : N ;
  laesarskara_nn_1_1_N : N ;
  laesfoermaaga_nn_1_1_N : N ;
  laeshoerna_nn_1_1_N : N ;
  laesida_nn_1_1_N : N ;
  laeskaenda_nn_1_1_N : N ;
  laeslampa_nn_1_1_N : N ;
  laespenna_nn_1_1_N : N ;
  laesplatta_nn_1_1_N : N ;
  laexa_nn_1_1_N : N ;
  laada_nn_1_1_N : N ;
  laadkamera_nn_1_1_N : N ;
  laaga_nn_1_1_N : N ;
  laagadel_nn_1_1_N : N ;
  laagbudgetdokusaapa_nn_1_1_N : N ;
  laagbudgetresa_nn_1_1_N : N ;
  laagenergilampa_nn_1_1_N : N ;
  laagprosa_nn_1_1_N : N ;
  laagtyska_nn_1_1_N : N ;
  laanga_nn_1_1_N : N ;
  laangbyxa_nn_1_1_N : N ;
  laangpanna_nn_1_1_N : N ;
  laangprosa_nn_1_1_N : N ;
  laangsida_nn_1_1_N : N ;
  laangstrumpa_nn_1_1_N : N ;
  laarkaka_nn_1_1_N : N ;
  laasbricka_nn_1_1_N : N ;
  laasfirma_nn_1_1_N : N ;
  laashylsa_nn_1_1_N : N ;
  laasolja_nn_1_1_N : N ;
  laassaskaka_nn_1_1_N : N ;
  laatsaskaka_nn_1_1_N : N ;
  loeddra_nn_1_1_N : N ;
  loedpenna_nn_1_1_N : N ;
  loeja_nn_1_1_N : N ;
  loeneklyfta_nn_1_1_N : N ;
  loennruna_nn_1_1_N : N ;
  loepa_nn_1_1_N : N ;
  loeparbana_nn_1_1_N : N ;
  loeplina_nn_1_1_N : N ;
  loepmaska_nn_1_1_N : N ;
  loepsedelsresa_nn_1_1_N : N ;
  loepsnara_nn_1_1_N : N ;
  loerdagsbilaga_nn_1_1_N : N ;
  loerdagsfoermiddag_nn_1_1_N : N ;
  loerdagshippa_nn_1_1_N : N ;
  loesensumma_nn_1_1_N : N ;
  loesesumma_nn_1_1_N : N ;
  loesnaesa_nn_1_1_N : N ;
  loevgroda_nn_1_1_N : N ;
  loevkoja_nn_1_1_N : N ;
  loevmossa_nn_1_1_N : N ;
  loevruska_nn_1_1_N : N ;
  loevtraedsglaenta_nn_1_1_N : N ;
  macedonska_nn_1_N : N ;
  macedonska_nn_2_N : N ;
  macka_nn_1_N : N ;
  madagaskiska_nn_1_N : N ;
  madeleinekaka_nn_1_N : N ;
  madonna_nn_1_N : N ;
  madra_nn_1_N : N ;
  maduska_nn_1_N : N ;
  maffia_nn_1_N : N ;
  maffialiga_nn_1_N : N ;
  magasinkaerra_nn_1_1_N : N ;
  magenta_nn_1_N : N ;
  maginfluensa_nn_1_N : N ;
  magma_nn_1_N : N ;
  magnetkamera_nn_1_N : N ;
  magnetmina_nn_1_N : N ;
  magnetremsa_nn_1_N : N ;
  magnetroentgenkamera_nn_1_1_N : N ;
  magnolia_nn_1_N : N ;
  magruta_nn_1_N : N ;
  magsjuka_nn_1_N : N ;
  magsmitta_nn_1_N : N ;
  magsmaerta_nn_1_1_N : N ;
  magsyra_nn_1_N : N ;
  maharadja_nn_1_N : N ;
  mahatma_nn_1_N : N ;
  mahognyyta_nn_1_N : N ;
  mahonia_nn_1_N : N ;
  majblomma_nn_1_N : N ;
  majdag_nn_1_N : N ;
  majmorgonhimmel_nn_1_N : N ;
  majsflinga_nn_1_N : N ;
  majshylsa_nn_1_N : N ;
  maka_nn_1_N : N ;
  makassarolja_nn_1_N : N ;
  makedoniska_nn_2_N : N ;
  makedonska_nn_1_N : N ;
  makedonska_nn_2_N : N ;
  maktfraaga_nn_1_1_N : N ;
  maktmaenniska_nn_1_1_N : N ;
  malajiska_nn_1_N : N ;
  malajiska_nn_2_N : N ;
  malariamygga_nn_1_N : N ;
  malawiska_nn_1_N : N ;
  malaysiska_nn_1_N : N ;
  maldiviska_nn_1_N : N ;
  maldiviska_nn_2_N : N ;
  maliska_nn_1_N : N ;
  malja_nn_1_N : N ;
  mallgroda_nn_1_N : N ;
  malmficka_nn_1_N : N ;
  malmgruva_nn_1_N : N ;
  malt_nn_1_N : N ;
  malteserorden_nn_1_N : N ;
  maltesiska_nn_1_N : N ;
  maltesiska_nn_2_N : N ;
  malva_nn_1_N : N ;
  mamba_nn_1_N : N ;
  mamma_nn_1_N : N ;
  manchesterjacka_nn_1_N : N ;
  manchuiska_nn_1_N : N ;
  manchuiska_nn_2_N : N ;
  mandelblomma_nn_1_N : N ;
  mandelkaka_nn_1_N : N ;
  mandelmassa_nn_1_N : N ;
  mandelolja_nn_1_N : N ;
  mandorla_nn_1_N : N ;
  mandragora_nn_1_N : N ;
  mangan_nn_1_N : N ;
  manlucka_nn_1_N : N ;
  manna_nn_1_N : N ;
  manslukerska_nn_1_N : N ;
  manssida_nn_1_N : N ;
  mansslukerska_nn_1_N : N ;
  mantelskura_nn_1_N : N ;
  mantelyta_nn_1_N : N ;
  mantissa_nn_1_N : N ;
  mara_nn_1_N : N ;
  mara_nn_2_N : N ;
  marihuana_nn_1_N : N ;
  marijuana_nn_1_N : N ;
  marimba_nn_1_N : N ;
  marina_nn_1_N : N ;
  marinstyrka_nn_1_N : N ;
  markatta_nn_1_N : N ;
  marklaera_nn_1_1_N : N ;
  marknadshyra_nn_1_N : N ;
  marknadsraenta_nn_1_1_N : N ;
  markyta_nn_1_N : N ;
  marleka_nn_1_N : N ;
  marmorskiva_nn_1_N : N ;
  marmortrappa_nn_1_N : N ;
  marockanska_nn_1_N : N ;
  marsala_nn_1_N : N ;
  marsipantaarta_nn_1_1_N : N ;
  martorn_nn_1_N : N ;
  martyrgloria_nn_1_N : N ;
  martyrstaempel_nn_1_1_N : N ;
  mascara_nn_1_N : N ;
  maska_nn_1_N : N ;
  maskinvara_nn_1_N : N ;
  massa_nn_1_N : N ;
  massa_nn_2_N : N ;
  masurka_nn_1_N : N ;
  materieera_nn_1_N : N ;
  matlaada_nn_1_1_N : N ;
  matmamma_nn_1_N : N ;
  matolja_nn_1_N : N ;
  matro_nn_1_N : N ;
  matrona_nn_1_N : N ;
  matsmaeltningsvaetska_nn_1_1_N : N ;
  matsaecksvaeska_nn_1_1_N : N ;
  matta_nn_1_N : N ;
  mattskiva_nn_1_N : N ;
  matvana_nn_1_N : N ;
  matvara_nn_1_N : N ;
  matvarukedja_nn_1_N : N ;
  mauretanska_nn_1_N : N ;
  mauritiska_nn_1_N : N ;
  maxtaxa_nn_1_N : N ;
  mazurka_nn_1_N : N ;
  mc_byxa_nn_1_N : N ;
  meanderslinga_nn_1_N : N ;
  medaljliga_nn_1_N : N ;
  medborgaranda_nn_1_N : N ;
  medelkoerstraecka_nn_1_1_N : N ;
  medelmaatta_nn_1_1_N : N ;
  medelpadska_nn_1_N : N ;
  medelpadska_nn_2_N : N ;
  medeltidsmaenniska_nn_1_1_N : N ;
  medmaenniska_nn_1_1_N : N ;
  medusa_nn_1_N : N ;
  mefa_nn_1_N : N ;
  megaera_nn_1_1_N : N ;
  melanesiska_nn_1_N : N ;
  melitta_nn_1_N : N ;
  mellanhjaerna_nn_1_1_N : N ;
  mellanriksbana_nn_1_N : N ;
  mellanskola_nn_1_N : N ;
  melodiradio_nn_1_N : N ;
  melodislinga_nn_1_N : N ;
  melodistaemma_nn_1_1_N : N ;
  membranskada_nn_1_N : N ;
  merca_nn_1_N : N ;
  meritlista_nn_1_N : N ;
  mersa_nn_1_N : N ;
  mesopotamiska_nn_1_N : N ;
  metallbricka_nn_1_N : N ;
  metallkula_nn_1_N : N ;
  metervara_nn_1_N : N ;
  metodlaera_nn_1_1_N : N ;
  mexikanska_nn_1_N : N ;
  mexitegelvilla_nn_1_N : N ;
  mickelsmaessa_nn_1_1_N : N ;
  middagstimma_nn_1_N : N ;
  midja_nn_1_N : N ;
  mikronesiska_nn_1_N : N ;
  mila_nn_1_N : N ;
  militaerjunta_nn_1_1_N : N ;
  militaerskola_nn_1_1_N : N ;
  miljoefraaga_nn_1_1_N : N ;
  miljoeskada_nn_1_1_N : N ;
  millimeterraettvisa_nn_1_1_N : N ;
  mimosa_nn_1_N : N ;
  mina_nn_1_N : N ;
  mindervaerdeskaensla_nn_1_1_N : N ;
  mineralolja_nn_1_N : N ;
  mineralvattenflaska_nn_1_N : N ;
  minestronesoppa_nn_1_N : N ;
  miniatyrflaska_nn_1_N : N ;
  miniflaska_nn_1_N : N ;
  minimisiffra_nn_1_N : N ;
  minnesbeta_nn_1_N : N ;
  minnesgaava_nn_1_1_N : N ;
  minnesruna_nn_1_N : N ;
  minnessiffra_nn_1_N : N ;
  minnestavla_nn_1_N : N ;
  minnesvilla_nn_1_N : N ;
  minussida_nn_1_N : N ;
  minuthandel_nn_1_N : N ;
  mirakelflicka_nn_1_N : N ;
  missbruksfraaga_nn_1_1_N : N ;
  misshandel_nn_1_N : N ;
  missionskyrka_nn_1_N : N ;
  misskoetsel_nn_1_1_N : N ;
  missne_nn_1_N : N ;
  misstro_nn_1_N : N ;
  missaemja_nn_1_1_N : N ;
  mitella_nn_1_N : N ;
  mitra_nn_1_N : N ;
  mittbena_nn_1_N : N ;
  mittel_nn_1_N : N ;
  mjukvaluta_nn_1_N : N ;
  mjukvara_nn_1_N : N ;
  mjaela_nn_1_1_N : N ;
  mjaell_nn_1_1_N : N ;
  mjoeldryga_nn_1_1_N : N ;
  mjoelkfeber_nn_1_1_N : N ;
  mjoelkkossa_nn_1_1_N : N ;
  mjoelksyra_nn_1_1_N : N ;
  mjoelktetra_nn_1_1_N : N ;
  mjoelnarmatte_nn_1_1_N : N ;
  mo_nn_1_N : N ;
  mocka_nn_1_N : N ;
  modedocka_nn_1_N : N ;
  modekedja_nn_1_N : N ;
  modellera_nn_1_N : N ;
  moderkaka_nn_1_N : N ;
  moderniseringsagenda_nn_1_N : N ;
  moderskaensla_nn_1_1_N : N ;
  moderstjaerna_nn_1_1_N : N ;
  moldaviska_nn_1_N : N ;
  moldaviska_nn_2_N : N ;
  molekylkedja_nn_1_N : N ;
  molnmassa_nn_1_N : N ;
  monegaskiska_nn_1_N : N ;
  mongoliska_nn_1_N : N ;
  mono_nn_1_N : N ;
  montenegrinska_nn_1_N : N ;
  mora_nn_1_N : N ;
  moraklocka_nn_1_N : N ;
  moralkaka_nn_1_N : N ;
  mordgaata_nn_1_1_N : N ;
  morfin_nn_1_N : N ;
  morgondimma_nn_1_N : N ;
  morgongaava_nn_1_1_N : N ;
  morgonmaenniska_nn_1_1_N : N ;
  morgonstjaerna_nn_1_1_N : N ;
  morkulla_nn_1_N : N ;
  morotbladloppa_nn_1_N : N ;
  morotsfluga_nn_1_N : N ;
  morotskaka_nn_1_N : N ;
  morsa_nn_1_N : N ;
  morsgumma_nn_1_N : N ;
  morssida_nn_1_N : N ;
  mosel_nn_1_N : N ;
  mosippa_nn_1_N : N ;
  mosnaeppa_nn_1_1_N : N ;
  mossa_nn_1_N : N ;
  motfraaga_nn_1_1_N : N ;
  motionsvana_nn_1_N : N ;
  motorcykelolycka_nn_1_N : N ;
  motorstyrka_nn_1_N : N ;
  motorsaagskedja_nn_1_1_N : N ;
  motvilja_nn_1_N : N ;
  movipa_nn_1_N : N ;
  mocambikiska_nn_1_1_N : N ;
  mula_nn_1_N : N ;
  mullsyra_nn_1_N : N ;
  mulltoa_nn_1_N : N ;
  mullvadssyrsa_nn_1_N : N ;
  mulaasna_nn_1_1_N : N ;
  mumma_nn_1_N : N ;
  mungiga_nn_1_N : N ;
  mungipa_nn_1_N : N ;
  mungo_nn_2_N : N ;
  munharmonika_nn_1_N : N ;
  munhaefta_nn_1_1_N : N ;
  munhaala_nn_1_1_N : N ;
  munkhaetta_nn_1_1_N : N ;
  munkkaapa_nn_1_1_N : N ;
  munkorden_nn_1_N : N ;
  munlaesa_nn_1_1_N : N ;
  munslemhinna_nn_1_N : N ;
  munta_nn_1_N : N ;
  murarskjorta_nn_1_N : N ;
  murbraecka_nn_1_1_N : N ;
  murgroena_nn_1_1_N : N ;
  murkla_nn_1_N : N ;
  murkrona_nn_1_N : N ;
  mursida_nn_1_N : N ;
  mushona_nn_1_N : N ;
  musikhoegskola_nn_1_1_N : N ;
  musikskala_nn_1_N : N ;
  musikskola_nn_1_N : N ;
  musikstaemma_nn_1_1_N : N ;
  muskatdruva_nn_1_N : N ;
  muskelmassa_nn_1_N : N ;
  muskelsena_nn_1_N : N ;
  muskelstyrka_nn_1_N : N ;
  muskotblomma_nn_1_N : N ;
  musmamma_nn_1_N : N ;
  mussla_nn_1_N : N ;
  muta_nn_1_N : N ;
  muthaerva_nn_1_1_N : N ;
  mutterbricka_nn_1_N : N ;
  mygga_nn_1_N : N ;
  mykorrhiza_nn_1_N : N ;
  mylla_nn_1_N : N ;
  mylta_nn_1_N : N ;
  mynningsflamma_nn_1_N : N ;
  mynta_nn_1_N : N ;
  myntlucka_nn_1_N : N ;
  myntlaada_nn_1_1_N : N ;
  myra_nn_1_N : N ;
  myrlejonslaenda_nn_1_1_N : N ;
  myrlilja_nn_1_N : N ;
  myrra_nn_1_N : N ;
  myrsyra_nn_1_N : N ;
  myrtenkrona_nn_1_N : N ;
  myskmadra_nn_1_N : N ;
  myskolja_nn_1_N : N ;
  maelta_nn_1_1_N : N ;
  maengdlaera_nn_1_1_N : N ;
  maenniska_nn_1_1_N : N ;
  maenniskoapa_nn_1_1_N : N ;
  maenniskoboerda_nn_1_1_N : N ;
  maenniskofoeda_nn_1_1_N : N ;
  maenniskohandel_nn_1_1_N : N ;
  maenniskomassa_nn_1_1_N : N ;
  maenniskorovshaerva_nn_1_1_N : N ;
  maenska_nn_1_1_N : N ;
  maergel_nn_1_1_N : N ;
  maergpipa_nn_1_1_N : N ;
  maergskida_nn_1_1_N : N ;
  maerkesskjorta_nn_1_1_N : N ;
  maerkesvara_nn_1_1_N : N ;
  maerkpenna_nn_1_1_N : N ;
  maerkrulla_nn_1_1_N : N ;
  maerla_nn_1_1_N : N ;
  maessa_nn_1_1_N : N ;
  maessjacka_nn_1_1_N : N ;
  maesskjorta_nn_1_1_N : N ;
  maestarinna_nn_1_1_N : N ;
  maetarfjaeril_nn_1_1_N : N ;
  maetsticka_nn_1_1_N : N ;
  maalarskola_nn_1_1_N : N ;
  maalbrottsstaemma_nn_1_1_N : N ;
  maalkamera_nn_1_1_N : N ;
  maalla_nn_1_1_N : N ;
  maaltavla_nn_1_1_N : N ;
  maaltidsdricka_nn_1_1_N : N ;
  maaltorka_nn_1_1_N : N ;
  maalyta_nn_1_1_N : N ;
  maanbana_nn_1_1_N : N ;
  maangata_nn_1_1_N : N ;
  maanskiva_nn_1_1_N : N ;
  maanskugga_nn_1_1_N : N ;
  maanskaera_nn_1_1_N : N ;
  maara_nn_1_1_N : N ;
  maatta_nn_1_1_N : N ;
  moebelfirma_nn_1_1_N : N ;
  moebelmaessa_nn_1_1_N : N ;
  moebeltrissa_nn_1_1_N : N ;
  moeda_nn_1_1_N : N ;
  moedomshinna_nn_1_1_N : N ;
  moehippa_nn_1_1_N : N ;
  moella_nn_1_1_N : N ;
  moenja_nn_1_1_N : N ;
  moensterkarta_nn_1_1_N : N ;
  moerja_nn_1_1_N : N ;
  moessa_nn_1_1_N : N ;
  nackskada_nn_1_N : N ;
  nafta_nn_1_N : N ;
  naftalin_nn_1_N : N ;
  nagajka_nn_1_N : N ;
  namibiska_nn_1_N : N ;
  namnlista_nn_1_N : N ;
  namntavla_nn_1_N : N ;
  nankin_nn_1_N : N ;
  nanking_nn_1_N : N ;
  nanoblomma_nn_1_N : N ;
  nappa_nn_1_N : N ;
  nappflaska_nn_1_N : N ;
  narduslilja_nn_1_N : N ;
  narkotika_nn_1_N : N ;
  narkotikahandel_nn_1_N : N ;
  narrkaapa_nn_1_1_N : N ;
  narrluva_nn_1_N : N ;
  nationalflagga_nn_1_N : N ;
  nationalitetsflagga_nn_1_N : N ;
  nationalitetsspillra_nn_1_N : N ;
  nationalkyrka_nn_1_N : N ;
  nationsflagga_nn_1_N : N ;
  natriumbikarbonat_nn_1_N : N ;
  natriumlampa_nn_1_N : N ;
  natroncellulosa_nn_1_N : N ;
  natronsalpeter_nn_1_N : N ;
  nattblacka_nn_1_N : N ;
  nattblomma_nn_1_N : N ;
  nattduksbordslaada_nn_1_1_N : N ;
  nattfjaeril_nn_1_1_N : N ;
  natthimmel_nn_1_N : N ;
  nattkappa_nn_1_N : N ;
  nattklocka_nn_1_N : N ;
  nattkyla_nn_1_N : N ;
  nattlampa_nn_1_N : N ;
  nattlucka_nn_1_N : N ;
  nattmara_nn_1_N : N ;
  nattmoessa_nn_1_1_N : N ;
  nattro_nn_1_N : N ;
  nattsexa_nn_1_N : N ;
  nattskatta_nn_1_N : N ;
  nattskjorta_nn_1_N : N ;
  nattskaerra_nn_1_1_N : N ;
  nattskoeterska_nn_1_1_N : N ;
  nattslaenda_nn_1_1_N : N ;
  nattuggla_nn_1_N : N ;
  naturgoedsel_nn_1_1_N : N ;
  naturlaera_nn_1_1_N : N ;
  naturmaenniska_nn_1_1_N : N ;
  nauriska_nn_1_N : N ;
  navelbinda_nn_1_N : N ;
  navelludd_nn_1_N : N ;
  naver_nn_1_N : N ;
  neandertalmaenniska_nn_1_1_N : N ;
  nebulosa_nn_1_N : N ;
  nederlaendska_nn_1_1_N : N ;
  nederlaendska_nn_2_1_N : N ;
  nedresa_nn_1_N : N ;
  nejlika_nn_1_N : N ;
  nejlikolja_nn_1_N : N ;
  neodym_nn_1_N : N ;
  nepalesiska_nn_1_N : N ;
  nepalesiska_nn_2_N : N ;
  nervbana_nn_1_N : N ;
  nervfeber_nn_1_N : N ;
  nervskada_nn_1_N : N ;
  nervskida_nn_1_N : N ;
  nervsmaerta_nn_1_1_N : N ;
  nervaenda_nn_1_1_N : N ;
  nesa_nn_1_N : N ;
  neutrinofaella_nn_1_1_N : N ;
  neutronstjaerna_nn_1_1_N : N ;
  nia_nn_1_N : N ;
  nicaraguanska_nn_1_N : N ;
  nickedocka_nn_1_N : N ;
  nickel_nn_1_N : N ;
  nidvisa_nn_1_N : N ;
  nigerianska_nn_1_N : N ;
  nigeriska_nn_1_N : N ;
  nikotin_nn_1_N : N ;
  nikt_nn_1_N : N ;
  niohaalsbana_nn_1_1_N : N ;
  nipa_nn_1_N : N ;
  nippertippa_nn_1_N : N ;
  nissa_nn_1_N : N ;
  nisseflicka_nn_1_N : N ;
  nitbricka_nn_1_N : N ;
  nitrocellulosa_nn_1_N : N ;
  niuiska_nn_1_N : N ;
  nivaakarta_nn_1_1_N : N ;
  nivaakurva_nn_1_1_N : N ;
  nivaayta_nn_1_1_N : N ;
  njurskada_nn_1_N : N ;
  njutningsmaenniska_nn_1_1_N : N ;
  noja_nn_1_N : N ;
  nolla_nn_1_N : N ;
  nolltaxa_nn_1_N : N ;
  nomadskola_nn_1_N : N ;
  nona_nn_1_N : N ;
  nonsens_nn_1_N : N ;
  noppa_nn_1_N : N ;
  noppra_nn_1_N : N ;
  nordkoreanska_nn_1_N : N ;
  nordsida_nn_1_N : N ;
  nordstjaerneorden_nn_1_1_N : N ;
  normalprosa_nn_1_N : N ;
  norna_nn_1_N : N ;
  norna_nn_2_N : N ;
  norrbottniska_nn_1_N : N ;
  norrbottniska_nn_2_N : N ;
  norrkoepingsnaesa_nn_1_1_N : N ;
  norrlaendska_nn_1_1_N : N ;
  norrlaendska_nn_2_1_N : N ;
  norrsida_nn_1_N : N ;
  norska_nn_1_N : N ;
  norska_nn_2_N : N ;
  nosgrimma_nn_1_N : N ;
  nota_nn_1_N : N ;
  notsiffra_nn_1_N : N ;
  nova_nn_1_N : N ;
  nubbevisa_nn_1_N : N ;
  nucka_nn_1_N : N ;
  nuffra_nn_1_N : N ;
  nukleinsyra_nn_1_N : N ;
  nummerbricka_nn_1_N : N ;
  nummerflicka_nn_1_N : N ;
  nummerskiva_nn_1_N : N ;
  nummertavla_nn_1_N : N ;
  nuna_nn_1_N : N ;
  nunna_nn_1_N : N ;
  nunneorden_nn_1_N : N ;
  nusvenska_nn_1_N : N ;
  nutria_nn_1_N : N ;
  nyckelharpa_nn_1_N : N ;
  nyckelknippa_nn_1_N : N ;
  nyckelpiga_nn_1_N : N ;
  nygrekiska_nn_1_N : N ;
  nyhetstorka_nn_1_N : N ;
  nyingsbrasa_nn_1_N : N ;
  nylon_nn_1_N : N ;
  nylonskjorta_nn_1_N : N ;
  nylonstrumpa_nn_1_N : N ;
  nylonutsida_nn_1_N : N ;
  nylaendska_nn_1_1_N : N ;
  nylaendska_nn_2_1_N : N ;
  nynorska_nn_1_N : N ;
  nypa_nn_1_N : N ;
  nyponsoppa_nn_1_N : N ;
  nyrokoko_nn_1_N : N ;
  nysnoe_nn_1_1_N : N ;
  nystkrona_nn_1_N : N ;
  nyststjaerna_nn_1_1_N : N ;
  nystvinda_nn_1_N : N ;
  nysvenska_nn_1_N : N ;
  nytta_nn_1_N : N ;
  nyutgaava_nn_1_1_N : N ;
  nyzeelaendska_nn_1_1_N : N ;
  nyaarsgaava_nn_1_1_N : N ;
  nyaarsvaka_nn_1_1_N : N ;
  naebba_nn_1_1_N : N ;
  naebbgaedda_nn_1_1_N : N ;
  naeringskedja_nn_1_1_N : N ;
  naeringskaella_nn_1_1_N : N ;
  naerkingska_nn_1_1_N : N ;
  naerkingska_nn_2_1_N : N ;
  naerradio_nn_1_1_N : N ;
  naervaro_nn_1_1_N : N ;
  naesa_nn_1_1_N : N ;
  naesbraenna_nn_1_1_N : N ;
  naeshaala_nn_1_1_N : N ;
  naespaerla_nn_1_1_N : N ;
  naesselfeber_nn_1_1_N : N ;
  naesselfjaeril_nn_1_1_N : N ;
  naesselsoppa_nn_1_1_N : N ;
  naessla_nn_1_1_N : N ;
  naesta_nn_1_1_N : N ;
  naestaeppa_nn_1_1_N : N ;
  naethandel_nn_1_1_N : N ;
  naethinna_nn_1_1_N : N ;
  naetmaska_nn_1_1_N : N ;
  naetstrumpa_nn_1_1_N : N ;
  naettroeja_nn_1_1_N : N ;
  naetupplaga_nn_1_1_N : N ;
  naetvana_nn_1_1_N : N ;
  naeva_nn_1_1_N : N ;
  naadegaava_nn_1_1_N : N ;
  naaldyna_nn_1_1_N : N ;
  naalfiltmatta_nn_1_1_N : N ;
  naalfiltsmatta_nn_1_1_N : N ;
  noedsituationslampa_nn_1_1_N : N ;
  noedvaendighetsvara_nn_1_1_N : N ;
  noejespappa_nn_1_1_N : N ;
  noejesresa_nn_1_1_N : N ;
  noetkraaka_nn_1_1_N : N ;
  noetkaerna_nn_1_1_N : N ;
  noetmassa_nn_1_1_N : N ;
  noetolja_nn_1_1_N : N ;
  noetskrika_nn_1_1_N : N ;
  noetvaecka_nn_1_1_N : N ;
  ocarina_nn_1_N : N ;
  ockerhyra_nn_1_N : N ;
  ockerraenta_nn_1_1_N : N ;
  ockra_nn_1_N : N ;
  odal_nn_1_N : N ;
  odaaga_nn_1_1_N : N ;
  oegennytta_nn_1_N : N ;
  offergaava_nn_1_1_N : N ;
  offerkista_nn_1_N : N ;
  offerstaempel_nn_1_1_N : N ;
  ofoermaaga_nn_1_1_N : N ;
  ohyra_nn_1_N : N ;
  okarina_nn_1_N : N ;
  oktoberhimmel_nn_1_N : N ;
  okunnighetsstaempel_nn_1_1_N : N ;
  olein_nn_1_N : N ;
  olivolja_nn_1_N : N ;
  olja_nn_1_N : N ;
  oljedaadra_nn_1_1_N : N ;
  oljefernissa_nn_1_N : N ;
  oljekaka_nn_1_N : N ;
  oljekanna_nn_1_N : N ;
  oljekaella_nn_1_1_N : N ;
  oljelampa_nn_1_N : N ;
  oljelykta_nn_1_N : N ;
  oljelaecka_nn_1_1_N : N ;
  oljesyra_nn_1_N : N ;
  olla_nn_1_N : N ;
  ollondroeppel_nn_1_1_N : N ;
  olofsmaessa_nn_1_1_N : N ;
  olsmaessa_nn_1_1_N : N ;
  olustkaensla_nn_1_1_N : N ;
  olycka_nn_1_N : N ;
  olycksdag_nn_1_N : N ;
  olycksprofetia_nn_1_N : N ;
  omanska_nn_1_N : N ;
  omdoemesfraaga_nn_1_1_N : N ;
  omdoemesfoermaaga_nn_1_1_N : N ;
  omfoederska_nn_1_1_N : N ;
  omloppsbana_nn_1_N : N ;
  omstaellningsfraaga_nn_1_1_N : N ;
  omaenniska_nn_1_1_N : N ;
  ondska_nn_1_N : N ;
  opera_nn_1_N : N ;
  operasaangerska_nn_1_1_N : N ;
  opinionssiffra_nn_1_N : N ;
  opiumhandel_nn_1_N : N ;
  opiumhaerva_nn_1_1_N : N ;
  opiumhaala_nn_1_1_N : N ;
  opiumpipa_nn_1_N : N ;
  oppfattningsfoermaaga_nn_1_1_N : N ;
  oppfinningsfoermaaga_nn_1_1_N : N ;
  opphaemta_nn_1_1_N : N ;
  orchestra_nn_1_N : N ;
  orden_nn_1_N : N ;
  ordensstjaerna_nn_1_1_N : N ;
  ordflaeta_nn_1_1_N : N ;
  ordfoerandeklubba_nn_1_1_N : N ;
  ordgaata_nn_1_1_N : N ;
  ordinata_nn_1_N : N ;
  ordlista_nn_1_N : N ;
  ordningsfraaga_nn_1_1_N : N ;
  ordningsmaenniska_nn_1_1_N : N ;
  ordningsstadga_nn_1_N : N ;
  oreda_nn_1_N : N ;
  oregano_nn_1_N : N ;
  organza_nn_1_N : N ;
  orgelpipa_nn_1_N : N ;
  orgelstaemma_nn_1_1_N : N ;
  orienteringslampa_nn_1_N : N ;
  orienteringstavla_nn_1_N : N ;
  origo_nn_1_N : N ;
  orkanstyrka_nn_1_N : N ;
  orkestra_nn_1_N : N ;
  ormblaasa_nn_1_1_N : N ;
  ormmaenniska_nn_1_1_N : N ;
  ormolja_nn_1_N : N ;
  ormslinga_nn_1_N : N ;
  ormstjaerna_nn_1_1_N : N ;
  ormtunga_nn_1_N : N ;
  oro_nn_1_N : N ;
  orsakskedja_nn_1_N : N ;
  ortsula_nn_1_N : N ;
  oraettvisa_nn_1_1_N : N ;
  oskaerpa_nn_1_1_N : N ;
  ossobuco_nn_1_N : N ;
  ostbricka_nn_1_N : N ;
  osteria_nn_1_N : N ;
  ostfluga_nn_1_N : N ;
  ostjakiska_nn_1_N : N ;
  ostkaka_nn_1_N : N ;
  ostkupa_nn_1_N : N ;
  ostmacka_nn_1_N : N ;
  ostmassa_nn_1_N : N ;
  ostra_nn_1_N : N ;
  ostskiva_nn_1_N : N ;
  ostvassla_nn_1_N : N ;
  osaemja_nn_1_1_N : N ;
  otrivsel_nn_1_N : N ;
  otro_nn_1_N : N ;
  otta_nn_1_N : N ;
  otursdag_nn_1_N : N ;
  otaecka_nn_1_1_N : N ;
  ouzo_nn_1_N : N ;
  ovana_nn_1_N : N ;
  ovandager_nn_1_N : N ;
  ovansida_nn_1_N : N ;
  ovilja_nn_1_N : N ;
  oxalsyra_nn_1_N : N ;
  oxalaettiksyra_nn_1_1_N : N ;
  oxfordskola_nn_1_N : N ;
  oxtunga_nn_1_N : N ;
  oxvecka_nn_1_N : N ;
  ozon_nn_1_N : N ;
  p_ruta_nn_1_N : N ;
  packningsdosa_nn_1_N : N ;
  packaasna_nn_1_1_N : N ;
  padda_nn_1_N : N ;
  paella_nn_1_N : N ;
  pagina_nn_1_N : N ;
  paketkaerra_nn_1_1_N : N ;
  paketresa_nn_1_N : N ;
  pakistanska_nn_1_N : N ;
  palauiska_nn_1_N : N ;
  palauiska_nn_2_N : N ;
  palisander_nn_1_N : N ;
  pall_nn_3_N : N ;
  palmitin_nn_1_N : N ;
  palmitinsyra_nn_1_N : N ;
  palmkaerna_nn_1_1_N : N ;
  palmolja_nn_1_N : N ;
  palsternacka_nn_1_N : N ;
  paltkoma_nn_1_N : N ;
  panama_nn_1_N : N ;
  panamanska_nn_1_N : N ;
  panda_nn_1_N : N ;
  panelhoena_nn_1_1_N : N ;
  panka_nn_1_N : N ;
  panna_nn_1_N : N ;
  pannhaala_nn_1_1_N : N ;
  pannkaka_nn_1_N : N ;
  pannlampa_nn_1_N : N ;
  panoramakamera_nn_1_N : N ;
  pansarskjorta_nn_1_N : N ;
  papaya_nn_1_N : N ;
  papegoja_nn_1_N : N ;
  papp_nn_1_N : N ;
  pappa_nn_1_N : N ;
  pappersblomma_nn_1_N : N ;
  pappersklaemma_nn_1_1_N : N ;
  papperskula_nn_1_N : N ;
  pappersmassa_nn_1_N : N ;
  pappersremsa_nn_1_N : N ;
  pappersstjaerna_nn_1_1_N : N ;
  papperssvala_nn_1_N : N ;
  pappersupplaga_nn_1_N : N ;
  papplaada_nn_1_1_N : N ;
  pappurna_nn_1_N : N ;
  paprika_nn_1_N : N ;
  paradgata_nn_1_N : N ;
  paraffin_nn_1_N : N ;
  paraguayanska_nn_1_N : N ;
  paranoia_nn_1_N : N ;
  parasitfluga_nn_1_N : N ;
  parfymflaska_nn_1_N : N ;
  parkeringsficka_nn_1_N : N ;
  parkeringslampa_nn_1_N : N ;
  parkum_nn_1_N : N ;
  parstuga_nn_1_N : N ;
  partianda_nn_1_N : N ;
  partifaalla_nn_1_1_N : N ;
  partihandel_nn_1_N : N ;
  partipiska_nn_1_N : N ;
  partsinlaga_nn_1_N : N ;
  pascha_nn_1_N : N ;
  pasma_nn_1_N : N ;
  passagerarsiffra_nn_1_N : N ;
  passionsblomma_nn_1_N : N ;
  passionsvecka_nn_1_N : N ;
  pasta_nn_1_N : N ;
  pasta_nn_2_N : N ;
  pastramiskinka_nn_1_N : N ;
  pata_nn_1_N : N ;
  patella_nn_1_N : N ;
  patina_nn_1_N : N ;
  patronhylsa_nn_1_N : N ;
  patronspruta_nn_1_N : N ;
  patronvaeska_nn_1_1_N : N ;
  pava_nn_1_N : N ;
  pedofilhaerva_nn_1_1_N : N ;
  pejlskiva_nn_1_N : N ;
  pellagra_nn_1_N : N ;
  pendel_nn_2_N : N ;
  penis_nn_1_N : N ;
  penna_nn_1_N : N ;
  penningsumma_nn_1_N : N ;
  pensionsfraaga_nn_1_1_N : N ;
  pensionskassa_nn_1_N : N ;
  pensionaerstillvaro_nn_1_1_N : N ;
  penultima_nn_1_N : N ;
  pepparkaka_nn_1_N : N ;
  pepparmynta_nn_1_N : N ;
  pepparmyntsolja_nn_1_N : N ;
  pepsin_nn_1_N : N ;
  perestrojka_nn_1_N : N ;
  pergola_nn_1_N : N ;
  periferivinkel_nn_1_N : N ;
  persika_nn_1_N : N ;
  persilja_nn_1_N : N ;
  persiska_nn_1_N : N ;
  persiska_nn_2_N : N ;
  personalfraaga_nn_1_1_N : N ;
  personalstyrka_nn_1_N : N ;
  personfraaga_nn_1_1_N : N ;
  personskada_nn_1_N : N ;
  perstorpsplatta_nn_1_N : N ;
  perstorpsskiva_nn_1_N : N ;
  peruanska_nn_1_N : N ;
  petita_nn_1_N : N ;
  petroleum_nn_1_N : N ;
  petunia_nn_1_N : N ;
  pianola_nn_1_N : N ;
  piassava_nn_1_N : N ;
  piazza_nn_1_N : N ;
  piccola_nn_1_N : N ;
  picka_nn_1_N : N ;
  pickelhuva_nn_1_N : N ;
  pidginengelska_nn_1_N : N ;
  piga_nn_1_N : N ;
  pikhacka_nn_1_N : N ;
  pikrinsyra_nn_1_N : N ;
  pikyxa_nn_1_N : N ;
  pilotjacka_nn_1_N : N ;
  pilsnerflaska_nn_1_N : N ;
  pimpinella_nn_1_N : N ;
  pina_nn_1_N : N ;
  pingla_nn_1_N : N ;
  pingstlilja_nn_1_N : N ;
  pinnmo_nn_1_N : N ;
  pinnsoffa_nn_1_N : N ;
  pinuppa_nn_1_N : N ;
  pipa_nn_1_N : N ;
  piplaerka_nn_1_1_N : N ;
  pipolja_nn_1_N : N ;
  piratbyxa_nn_1_N : N ;
  piraya_nn_1_N : N ;
  pirka_nn_1_N : N ;
  pirra_nn_1_N : N ;
  piska_nn_1_N : N ;
  pisksnaertskada_nn_1_1_N : N ;
  pisksnaertsskada_nn_1_1_N : N ;
  pistolkula_nn_1_N : N ;
  pistolvaeska_nn_1_1_N : N ;
  pizza_nn_1_N : N ;
  pizzeria_nn_1_N : N ;
  pjaexa_nn_1_1_N : N ;
  placebo_nn_1_N : N ;
  placenta_nn_1_N : N ;
  plack_nn_1_N : N ;
  pladuska_nn_1_N : N ;
  planetbana_nn_1_N : N ;
  planhalva_nn_1_N : N ;
  plank_nn_1_N : N ;
  planka_nn_1_N : N ;
  planta_nn_1_N : N ;
  plantskola_nn_1_N : N ;
  plastbalja_nn_1_N : N ;
  plastellina_nn_1_N : N ;
  plastflaska_nn_1_N : N ;
  plastpappa_nn_1_N : N ;
  plastpulka_nn_1_N : N ;
  plastraefsa_nn_1_1_N : N ;
  plastskiva_nn_1_N : N ;
  plastaalder_nn_1_1_N : N ;
  platina_nn_1_N : N ;
  platssiffra_nn_1_N : N ;
  platta_nn_1_N : N ;
  plattyska_nn_1_N : N ;
  pliktaara_nn_1_1_N : N ;
  plita_nn_1_N : N ;
  plogfaara_nn_1_1_N : N ;
  plogtilta_nn_1_N : N ;
  plunta_nn_1_N : N ;
  plaeter_nn_1_1_N : N ;
  plaaga_nn_1_1_N : N ;
  plaanboksfraaga_nn_1_1_N : N ;
  plaatskada_nn_1_1_N : N ;
  podager_nn_1_N : N ;
  poetissa_nn_1_N : N ;
  pojkflicka_nn_1_N : N ;
  poker_nn_1_N : N ;
  polardimma_nn_1_N : N ;
  polaroidkamera_nn_1_N : N ;
  polarvinter_nn_1_N : N ;
  polenta_nn_1_N : N ;
  polerpasta_nn_1_N : N ;
  polio_nn_1_N : N ;
  polisbricka_nn_1_N : N ;
  poliskedja_nn_1_N : N ;
  poliskvinna_nn_1_N : N ;
  polisstyrka_nn_1_N : N ;
  politikermisstro_nn_1_N : N ;
  politikervecka_nn_1_N : N ;
  polka_nn_1_N : N ;
  pollenplaaga_nn_1_1_N : N ;
  polo_nn_1_N : N ;
  polo_nn_2_N : N ;
  poloklubba_nn_1_N : N ;
  polotroeja_nn_1_1_N : N ;
  polska_nn_1_N : N ;
  polska_nn_2_N : N ;
  polynesiska_nn_1_N : N ;
  polynia_nn_1_N : N ;
  pomada_nn_1_N : N ;
  pompa_nn_1_N : N ;
  pontonbro_nn_1_N : N ;
  pontonbrygga_nn_1_N : N ;
  popdaenga_nn_1_1_N : N ;
  porrstjaerna_nn_1_1_N : N ;
  porslinsblomma_nn_1_N : N ;
  porslinskula_nn_1_N : N ;
  porslinsyta_nn_1_N : N ;
  portugisiska_nn_1_N : N ;
  portugisiska_nn_2_N : N ;
  portvaktssyssla_nn_1_N : N ;
  positivvisa_nn_1_N : N ;
  postilla_nn_1_N : N ;
  postlaada_nn_1_1_N : N ;
  postorder_nn_1_N : N ;
  potatisklyfta_nn_1_N : N ;
  potatisnaesa_nn_1_1_N : N ;
  potentialyta_nn_1_N : N ;
  potta_nn_1_N : N ;
  pottaska_nn_1_N : N ;
  pracka_nn_1_N : N ;
  prao_nn_1_N : N ;
  prata_nn_1_N : N ;
  pratbubbla_nn_1_N : N ;
  pratsjuka_nn_1_N : N ;
  pratsoffa_nn_1_N : N ;
  presenterbricka_nn_1_N : N ;
  pressgurka_nn_1_N : N ;
  pressylta_nn_1_N : N ;
  prestationsprinsessa_nn_1_N : N ;
  prilla_nn_1_N : N ;
  primadonna_nn_1_N : N ;
  primer_nn_1_N : N ;
  primklocka_nn_1_N : N ;
  primula_nn_1_N : N ;
  primaerkaella_nn_1_1_N : N ;
  principfraaga_nn_1_1_N : N ;
  principmaenniska_nn_1_1_N : N ;
  prinsessa_nn_1_N : N ;
  prinsesstaarta_nn_1_1_N : N ;
  priorinna_nn_1_N : N ;
  prioriteringsfraaga_nn_1_1_N : N ;
  prislista_nn_1_N : N ;
  privatskola_nn_1_N : N ;
  procentsiffra_nn_1_N : N ;
  professorska_nn_1_N : N ;
  profetia_nn_1_N : N ;
  progala_nn_1_N : N ;
  programvara_nn_1_N : N ;
  projektilbana_nn_1_N : N ;
  projektionsyta_nn_1_N : N ;
  prokura_nn_1_N : N ;
  promemoria_nn_1_N : N ;
  promenadgata_nn_1_N : N ;
  promenadlimpa_nn_1_N : N ;
  propaganda_nn_1_N : N ;
  propan_nn_1_N : N ;
  prosa_nn_1_N : N ;
  prostata_nn_1_N : N ;
  prostitutionshaerva_nn_1_1_N : N ;
  proteinkedja_nn_1_N : N ;
  protestvilja_nn_1_N : N ;
  protoplasma_nn_1_N : N ;
  provdocka_nn_1_N : N ;
  provensalska_nn_1_N : N ;
  provensalska_nn_2_N : N ;
  proviantlista_nn_1_N : N ;
  provkarta_nn_1_N : N ;
  prya_nn_1_N : N ;
  prydnadsblomma_nn_1_N : N ;
  prydnadsstjaerna_nn_1_1_N : N ;
  praegel_nn_1_1_N : N ;
  praestinna_nn_1_1_N : N ;
  praestkappa_nn_1_1_N : N ;
  praestaenka_nn_1_1_N : N ;
  psykoanalyssoffa_nn_1_N : N ;
  pubertetsflicka_nn_1_N : N ;
  pudersnoe_nn_1_1_N : N ;
  pudervippa_nn_1_N : N ;
  puffra_nn_1_N : N ;
  puka_nn_1_N : N ;
  pulka_nn_1_N : N ;
  pulla_nn_1_N : N ;
  pulpa_nn_1_N : N ;
  pulsklocka_nn_1_N : N ;
  pulversoppa_nn_1_N : N ;
  puma_nn_1_N : N ;
  pumpa_nn_1_N : N ;
  pungraatta_nn_1_1_N : N ;
  punka_nn_1_N : N ;
  puppa_nn_1_N : N ;
  purpursnaecka_nn_1_1_N : N ;
  pusta_nn_1_N : N ;
  puta_nn_1_N : N ;
  putstrasa_nn_1_N : N ;
  pyjamasficka_nn_1_N : N ;
  pyrola_nn_1_N : N ;
  pyspunka_nn_1_N : N ;
  pyttipanna_nn_1_N : N ;
  paerla_nn_1_1_N : N ;
  paerlemo_nn_1_1_N : N ;
  paerlemorfjaeril_nn_1_1_N : N ;
  paerlhoena_nn_1_1_N : N ;
  paerlmussla_nn_1_1_N : N ;
  paerlplatta_nn_1_1_N : N ;
  paerluggla_nn_1_1_N : N ;
  paeronskiva_nn_1_1_N : N ;
  paeronsoda_nn_1_1_N : N ;
  paerta_nn_1_1_N : N ;
  paaa_nn_1_1_N : N ;
  paalaga_nn_1_1_N : N ;
  paasklilja_nn_1_1_N : N ;
  paaskvecka_nn_1_1_N : N ;
  poebel_nn_1_1_N : N ;
  poelsa_nn_1_1_N : N ;
  qatariska_nn_1_N : N ;
  rabarber_nn_1_N : N ;
  rabarberkaka_nn_1_N : N ;
  racka_nn_1_N : N ;
  radda_nn_1_N : N ;
  radiokaella_nn_1_1_N : N ;
  radja_nn_1_N : N ;
  radon_nn_1_N : N ;
  raffel_nn_2_N : N ;
  raga_nn_1_N : N ;
  ragata_nn_1_N : N ;
  raggsocka_nn_1_N : N ;
  raja_nn_1_N : N ;
  raka_nn_1_N : N ;
  rakstraecka_nn_1_1_N : N ;
  ramloesa_nn_1_1_N : N ;
  rampfeber_nn_1_N : N ;
  ramsa_nn_1_N : N ;
  rana_nn_1_N : N ;
  randsjoe_nn_1_1_N : N ;
  rangrulla_nn_1_N : N ;
  rangskala_nn_1_N : N ;
  ranka_nn_1_N : N ;
  rankinglista_nn_1_N : N ;
  rankningslista_nn_1_N : N ;
  rappakalja_nn_1_N : N ;
  rapphoena_nn_1_1_N : N ;
  rapskaka_nn_1_N : N ;
  rapsolja_nn_1_N : N ;
  rapsplanta_nn_1_N : N ;
  rapstjaerna_nn_1_1_N : N ;
  rasfraaga_nn_1_1_N : N ;
  rasmassa_nn_1_N : N ;
  rattfylla_nn_1_N : N ;
  razzia_nn_1_N : N ;
  rea_nn_1_N : N ;
  reaktionsfoermaaga_nn_1_1_N : N ;
  realskola_nn_1_N : N ;
  reda_nn_1_N : N ;
  regatta_nn_1_N : N ;
  regeringssida_nn_1_N : N ;
  regnbaagshinna_nn_1_1_N : N ;
  regnkappa_nn_1_N : N ;
  regnskugga_nn_1_N : N ;
  reklampenna_nn_1_N : N ;
  reklamtillvaro_nn_1_N : N ;
  rekordsiffra_nn_1_N : N ;
  rekvisita_nn_1_N : N ;
  religionslaera_nn_1_1_N : N ;
  remissa_nn_1_N : N ;
  remsa_nn_1_N : N ;
  renat_nn_1_N : N ;
  renfana_nn_1_N : N ;
  renlaerighetsiver_nn_1_1_N : N ;
  renskav_nn_1_N : N ;
  renskoetsel_nn_1_1_N : N ;
  renslucka_nn_1_N : N ;
  renaessansmaenniska_nn_1_1_N : N ;
  repa_nn_1_N : N ;
  reptilhjaerna_nn_1_1_N : N ;
  repaenda_nn_1_1_N : N ;
  resa_nn_1_N : N ;
  reseda_nn_1_N : N ;
  reservoarpenna_nn_1_N : N ;
  reservpappa_nn_1_N : N ;
  resfeber_nn_1_N : N ;
  reskontra_nn_1_N : N ;
  resonansbotten_nn_1_N : N ;
  resonanslaada_nn_1_1_N : N ;
  resultatlista_nn_1_N : N ;
  resvana_nn_1_N : N ;
  resvaeska_nn_1_1_N : N ;
  resaarbyxa_nn_1_1_N : N ;
  retina_nn_1_N : N ;
  retsina_nn_1_N : N ;
  retsticka_nn_1_N : N ;
  returresa_nn_1_N : N ;
  reva_nn_1_N : N ;
  revoltanda_nn_1_N : N ;
  revsmoerblomma_nn_1_1_N : N ;
  ria_nn_1_N : N ;
  ribba_nn_1_N : N ;
  ricinolja_nn_1_N : N ;
  ridbana_nn_1_N : N ;
  ridbyxa_nn_1_N : N ;
  riddarorden_nn_1_N : N ;
  ridpiska_nn_1_N : N ;
  ridskola_nn_1_N : N ;
  riksdagskvinna_nn_1_N : N ;
  riksha_nn_1_N : N ;
  riksolycka_nn_1_N : N ;
  riksstaemma_nn_1_1_N : N ;
  rikssvenska_nn_1_N : N ;
  rimkroenika_nn_1_1_N : N ;
  ringblomma_nn_1_N : N ;
  ringbrynja_nn_1_N : N ;
  ringduva_nn_1_N : N ;
  ringhoerna_nn_1_1_N : N ;
  ringklocka_nn_1_N : N ;
  ripa_nn_1_N : N ;
  risbastu_nn_1_N : N ;
  riska_nn_1_N : N ;
  riskaka_nn_1_N : N ;
  risotto_nn_1_N : N ;
  rispa_nn_1_N : N ;
  rissla_nn_1_N : N ;
  ro_nn_1_N : N ;
  robothandel_nn_1_N : N ;
  rocka_nn_1_N : N ;
  rockficka_nn_1_N : N ;
  rokoko_nn_1_N : N ;
  rollista_nn_1_N : N ;
  romarinna_nn_1_N : N ;
  rosenolja_nn_1_N : N ;
  rotbloeta_nn_1_1_N : N ;
  rottingsoffa_nn_1_N : N ;
  rotunda_nn_1_N : N ;
  rotvaelska_nn_1_1_N : N ;
  rotvaelta_nn_1_1_N : N ;
  rova_nn_1_N : N ;
  ruda_nn_1_N : N ;
  ruff_nn_2_N : N ;
  ruffhaexa_nn_1_1_N : N ;
  rulla_nn_1_N : N ;
  rullbraeda_nn_1_1_N : N ;
  rullskida_nn_1_N : N ;
  rullskridskobana_nn_1_N : N ;
  rulltrappa_nn_1_N : N ;
  rulltaarta_nn_1_1_N : N ;
  rulta_nn_1_N : N ;
  rumba_nn_1_N : N ;
  rumpa_nn_1_N : N ;
  rumaenska_nn_1_1_N : N ;
  rumaenska_nn_2_1_N : N ;
  runa_nn_1_N : N ;
  runda_nn_1_N : N ;
  rundfraaga_nn_1_1_N : N ;
  rundkula_nn_1_N : N ;
  rundkyrka_nn_1_N : N ;
  rundradio_nn_1_N : N ;
  rundresa_nn_1_N : N ;
  rundsticka_nn_1_N : N ;
  ruschelbana_nn_1_N : N ;
  ruschelkana_nn_1_N : N ;
  ruska_nn_1_N : N ;
  ruta_nn_1_N : N ;
  rutchbana_nn_1_N : N ;
  rutchelbana_nn_1_N : N ;
  rutchelkana_nn_1_N : N ;
  rutchkana_nn_1_N : N ;
  rutschbana_nn_1_N : N ;
  rutschelbana_nn_1_N : N ;
  rutschelkana_nn_1_N : N ;
  rutschkana_nn_1_N : N ;
  ruvlaada_nn_1_1_N : N ;
  rwandiska_nn_1_N : N ;
  rya_nn_1_N : N ;
  rygga_nn_1_N : N ;
  ryggfena_nn_1_N : N ;
  ryggkota_nn_1_N : N ;
  ryggtavla_nn_1_N : N ;
  ryggaasstuga_nn_1_1_N : N ;
  ryktskrapa_nn_1_N : N ;
  rymdfaerja_nn_1_1_N : N ;
  rymdresa_nn_1_N : N ;
  rymdaalder_nn_1_1_N : N ;
  rynka_nn_1_N : N ;
  ryska_nn_1_N : N ;
  ryska_nn_2_N : N ;
  ryssja_nn_1_N : N ;
  rysslaendska_nn_1_1_N : N ;
  raecka_nn_1_1_N : N ;
  raeddhaaga_nn_1_1_N : N ;
  raeddningsklocka_nn_1_1_N : N ;
  raeddningsplanka_nn_1_1_N : N ;
  raeddningsstyrka_nn_1_1_N : N ;
  raedisa_nn_1_1_N : N ;
  raedsel_nn_1_1_N : N ;
  raeffla_nn_1_1_N : N ;
  raefsa_nn_1_1_N : N ;
  raeka_nn_1_1_N : N ;
  raekfrossa_nn_1_1_N : N ;
  raekmacka_nn_1_1_N : N ;
  raeknedosa_nn_1_1_N : N ;
  raekneramsa_nn_1_1_N : N ;
  raeknesticka_nn_1_1_N : N ;
  raemna_nn_1_1_N : N ;
  raenna_nn_1_1_N : N ;
  raennarbana_nn_1_1_N : N ;
  raennsnara_nn_1_1_N : N ;
  raenta_nn_1_1_N : N ;
  raeta_nn_1_1_N : N ;
  raetoromanska_nn_1_1_N : N ;
  raetsida_nn_1_1_N : N ;
  raetskiva_nn_1_1_N : N ;
  raettika_nn_1_1_N : N ;
  raettsfraaga_nn_1_1_N : N ;
  raettsfoermaaga_nn_1_1_N : N ;
  raettslaera_nn_1_1_N : N ;
  raettsroeta_nn_1_1_N : N ;
  raettvisa_nn_1_1_N : N ;
  raevrumpa_nn_1_1_N : N ;
  raadjursolycka_nn_1_1_N : N ;
  raadstu_nn_1_1_N : N ;
  raadstuga_nn_1_1_N : N ;
  raaglimpa_nn_1_1_N : N ;
  raak_nn_2_1_N : N ;
  raaka_nn_1_1_N : N ;
  raakopia_nn_1_1_N : N ;
  raanarhuva_nn_1_1_N : N ;
  raanarluva_nn_1_1_N : N ;
  raaolja_nn_1_1_N : N ;
  raaraka_nn_1_1_N : N ;
  raastyrka_nn_1_1_N : N ;
  raatta_nn_1_1_N : N ;
  raattfaella_nn_1_1_N : N ;
  raavara_nn_1_1_N : N ;
  roedbena_nn_1_1_N : N ;
  roedbeta_nn_1_1_N : N ;
  roedkloever_nn_1_1_N : N ;
  roedlista_nn_1_1_N : N ;
  roedmyra_nn_1_1_N : N ;
  roedockra_nn_1_1_N : N ;
  roedpenna_nn_1_1_N : N ;
  roedspotta_nn_1_1_N : N ;
  roedspaetta_nn_1_1_N : N ;
  roedstrumpa_nn_1_1_N : N ;
  roedtunga_nn_1_1_N : N ;
  roejarskiva_nn_1_1_N : N ;
  roekruta_nn_1_1_N : N ;
  roekslinga_nn_1_1_N : N ;
  roekstrimma_nn_1_1_N : N ;
  roelleka_nn_1_1_N : N ;
  roellika_nn_1_1_N : N ;
  roentgenkamera_nn_1_1_N : N ;
  roera_nn_1_1_N : N ;
  roera_nn_2_1_N : N ;
  roerelsefoermaaga_nn_1_1_N : N ;
  roerhoena_nn_1_1_N : N ;
  roestraettsfraaga_nn_1_1_N : N ;
  roestspringa_nn_1_1_N : N ;
  roeststyrka_nn_1_1_N : N ;
  roeta_nn_1_1_N : N ;
  s_kurva_nn_1_N : N ;
  sabadillaettika_nn_1_1_N : N ;
  sabelbalja_nn_1_N : N ;
  sabelklinga_nn_1_N : N ;
  sabellilja_nn_1_N : N ;
  sachertaarta_nn_1_1_N : N ;
  sadeldyna_nn_1_N : N ;
  sadelnaesa_nn_1_1_N : N ;
  sadelputa_nn_1_N : N ;
  saffian_nn_1_N : N ;
  saffran_nn_1_N : N ;
  saffransbulla_nn_1_N : N ;
  saffranspannkaka_nn_1_N : N ;
  saftkanna_nn_1_N : N ;
  saftsoppa_nn_1_N : N ;
  saga_nn_1_N : N ;
  sago_nn_1_N : N ;
  sagohoerna_nn_1_1_N : N ;
  sagoprinsessa_nn_1_N : N ;
  sagosoppa_nn_1_N : N ;
  saiga_nn_1_N : N ;
  saintpaulia_nn_1_N : N ;
  sakfraaga_nn_1_1_N : N ;
  sakprosa_nn_1_N : N ;
  sakristia_nn_1_N : N ;
  sakskada_nn_1_N : N ;
  salicylsyra_nn_1_N : N ;
  salighetslaera_nn_1_1_N : N ;
  salladsgurka_nn_1_N : N ;
  salmonella_nn_1_N : N ;
  salomonska_nn_1_N : N ;
  salpeter_nn_1_N : N ;
  salpetergruva_nn_1_N : N ;
  salpetersyra_nn_1_N : N ;
  saltgruva_nn_1_N : N ;
  saltgurka_nn_1_N : N ;
  saltimbocca_nn_1_N : N ;
  saltkaella_nn_1_1_N : N ;
  saltlaanga_nn_1_1_N : N ;
  saltsjoe_nn_1_1_N : N ;
  saltsjoebadsanda_nn_1_1_N : N ;
  saltsyra_nn_1_N : N ;
  saltvattensnaecka_nn_1_1_N : N ;
  salubrin_nn_1_N : N ;
  salva_nn_1_N : N ;
  salvadoranska_nn_1_N : N ;
  salvarsan_nn_1_N : N ;
  salvia_nn_1_N : N ;
  samaritlaada_nn_1_1_N : N ;
  samba_nn_1_N : N ;
  sambuca_nn_1_N : N ;
  sambuca_nn_2_N : N ;
  samfaerdsel_nn_1_1_N : N ;
  samhaellsanda_nn_1_1_N : N ;
  samhaellsfara_nn_1_1_N : N ;
  samhaellslaera_nn_1_1_N : N ;
  samhaellsnytta_nn_1_1_N : N ;
  samhoerighetskaensla_nn_1_1_N : N ;
  samiska_nn_1_N : N ;
  samlarsyssla_nn_1_N : N ;
  samoanska_nn_1_N : N ;
  samoanska_nn_2_N : N ;
  samojediska_nn_1_N : N ;
  samsara_nn_1_N : N ;
  samskola_nn_1_N : N ;
  samsu_nn_1_N : N ;
  samtidsprosa_nn_1_N : N ;
  samvaro_nn_1_N : N ;
  samvetsfraaga_nn_1_1_N : N ;
  samvetsro_nn_1_N : N ;
  sandbotten_nn_1_N : N ;
  sandel_nn_1_N : N ;
  sandelolja_nn_1_N : N ;
  sandfluga_nn_1_N : N ;
  sandflundra_nn_1_N : N ;
  sandkaka_nn_1_N : N ;
  sandlilja_nn_1_N : N ;
  sandloppa_nn_1_N : N ;
  sandlaada_nn_1_1_N : N ;
  sandmussla_nn_1_N : N ;
  sandnejlika_nn_1_N : N ;
  sandnoerel_nn_1_1_N : N ;
  sandpaerla_nn_1_1_N : N ;
  sandraeka_nn_1_1_N : N ;
  sandskaedda_nn_1_1_N : N ;
  sandstenstrappa_nn_1_N : N ;
  sandvita_nn_1_N : N ;
  sandoedla_nn_1_1_N : N ;
  saneringsfirma_nn_1_N : N ;
  sangria_nn_1_N : N ;
  sanitetsbinda_nn_1_N : N ;
  sanitetsflagga_nn_1_N : N ;
  sanktpaulia_nn_1_N : N ;
  sanmarinska_nn_1_N : N ;
  sannsaga_nn_1_N : N ;
  saotomeanska_nn_1_N : N ;
  sardiniska_nn_1_N : N ;
  sardiniska_nn_2_N : N ;
  sardinska_nn_1_N : N ;
  sardinska_nn_2_N : N ;
  sardiska_nn_1_N : N ;
  sardiska_nn_2_N : N ;
  sargasso_nn_1_N : N ;
  satellitbana_nn_1_N : N ;
  satellitkamera_nn_1_N : N ;
  satellitkarta_nn_1_N : N ;
  satellitradio_nn_1_N : N ;
  satmara_nn_1_N : N ;
  satsbraeda_nn_1_1_N : N ;
  satsflaeta_nn_1_1_N : N ;
  satslaera_nn_1_1_N : N ;
  satsyta_nn_1_N : N ;
  saudiarabiska_nn_1_N : N ;
  sauna_nn_1_N : N ;
  scarlatina_nn_1_N : N ;
  scenskola_nn_1_N : N ;
  scenvana_nn_1_N : N ;
  schackbraeda_nn_1_1_N : N ;
  schaktmassa_nn_1_N : N ;
  schanker_nn_1_N : N ;
  scharlakansfeber_nn_1_N : N ;
  schwarzwaldtaarta_nn_1_1_N : N ;
  schweiziska_nn_1_N : N ;
  scilla_nn_1_N : N ;
  scripta_nn_1_N : N ;
  sebra_nn_1_N : N ;
  sedelaera_nn_1_1_N : N ;
  sedimentkaerna_nn_1_1_N : N ;
  sedlighetsiver_nn_1_N : N ;
  sedvana_nn_1_N : N ;
  sedvaenja_nn_1_1_N : N ;
  segelarea_nn_1_N : N ;
  segelraenna_nn_1_1_N : N ;
  segelskuta_nn_1_N : N ;
  segelyta_nn_1_N : N ;
  segerhuva_nn_1_N : N ;
  segeryra_nn_1_N : N ;
  seglarmoessa_nn_1_1_N : N ;
  sekter_nn_1_N : N ;
  sekundaerskola_nn_1_1_N : N ;
  sekvester_nn_1_N : N ;
  selektionslaera_nn_1_1_N : N ;
  selleribotten_nn_1_N : N ;
  semaforflagga_nn_1_N : N ;
  semesterkamera_nn_1_N : N ;
  semesterkassa_nn_1_N : N ;
  seminavel_nn_1_N : N ;
  semla_nn_1_N : N ;
  sena_nn_1_N : N ;
  senegalesiska_nn_1_N : N ;
  senhinna_nn_1_N : N ;
  senna_nn_1_N : N ;
  sensitiva_nn_1_N : N ;
  senskida_nn_1_N : N ;
  sensommarfluga_nn_1_N : N ;
  sepia_nn_1_N : N ;
  septima_nn_1_N : N ;
  sequoia_nn_1_N : N ;
  serbiska_nn_1_N : N ;
  serbokroatiska_nn_1_N : N ;
  serieruta_nn_1_N : N ;
  serveruta_nn_1_N : N ;
  servicelucka_nn_1_N : N ;
  servruta_nn_1_N : N ;
  sessa_nn_1_N : N ;
  sexa_nn_1_N : N ;
  sexhaerva_nn_1_1_N : N ;
  seychelliska_nn_1_N : N ;
  senora_nn_1_1_N : N ;
  senorita_nn_1_1_N : N ;
  shetlandstroeja_nn_1_1_N : N ;
  shingel_nn_1_N : N ;
  shoppinggalleria_nn_1_N : N ;
  shoppingrunda_nn_1_N : N ;
  shoppingvaeska_nn_1_1_N : N ;
  showvaerdinna_nn_1_1_N : N ;
  sibetolja_nn_1_N : N ;
  sibylla_nn_1_N : N ;
  sicilianska_nn_1_N : N ;
  sida_nn_1_N : N ;
  sidbena_nn_1_N : N ;
  sidenapa_nn_1_N : N ;
  sidobana_nn_1_N : N ;
  sidogata_nn_1_N : N ;
  sidolanterna_nn_1_N : N ;
  sidoruta_nn_1_N : N ;
  siena_nn_1_N : N ;
  sierraleonska_nn_1_N : N ;
  sierska_nn_1_N : N ;
  siesta_nn_1_N : N ;
  siffersumma_nn_1_N : N ;
  siffertavla_nn_1_N : N ;
  siffra_nn_1_N : N ;
  signalbana_nn_1_N : N ;
  signalflagga_nn_1_N : N ;
  signalkraefta_nn_1_1_N : N ;
  signora_nn_1_N : N ;
  signorina_nn_1_N : N ;
  sikloeja_nn_1_1_N : N ;
  siktkaka_nn_1_N : N ;
  siktruta_nn_1_N : N ;
  siktskaara_nn_1_1_N : N ;
  siktstraecka_nn_1_1_N : N ;
  silkeapa_nn_1_N : N ;
  silkesapa_nn_1_N : N ;
  silkesatlas_nn_1_N : N ;
  silkesbehaa_nn_1_1_N : N ;
  silkesfjaeril_nn_1_1_N : N ;
  silkesstrumpa_nn_1_N : N ;
  silkestrumpa_nn_1_N : N ;
  sillbricka_nn_1_N : N ;
  sillgrissla_nn_1_N : N ;
  sillguano_nn_1_N : N ;
  sillaada_nn_1_1_N : N ;
  silverfemma_nn_1_N : N ;
  silvergruva_nn_1_N : N ;
  silvertacka_nn_1_N : N ;
  silvertaerna_nn_1_1_N : N ;
  simblaasa_nn_1_1_N : N ;
  simbyxa_nn_1_N : N ;
  simdyna_nn_1_N : N ;
  simfena_nn_1_N : N ;
  simpa_nn_1_N : N ;
  simskola_nn_1_N : N ;
  simsnaeppa_nn_1_1_N : N ;
  sinfonia_nn_1_N : N ;
  singalesiska_nn_1_N : N ;
  singalesiska_nn_2_N : N ;
  singaporianska_nn_1_N : N ;
  singel_nn_2_N : N ;
  singelmamma_nn_1_N : N ;
  singelolycka_nn_1_N : N ;
  sinnesnaervaro_nn_1_1_N : N ;
  sinnesro_nn_1_N : N ;
  sinnesvilla_nn_1_N : N ;
  sinter_nn_1_N : N ;
  sinuskurva_nn_1_N : N ;
  sippa_nn_1_N : N ;
  sirapslimpa_nn_1_N : N ;
  sirocko_nn_1_N : N ;
  sisalhampa_nn_1_N : N ;
  siska_nn_1_N : N ;
  sista_minutenresa_nn_1_N : N ;
  sista_nn_1_N : N ;
  sisu_nn_1_N : N ;
  sittbraeda_nn_1_1_N : N ;
  sittdyna_nn_1_N : N ;
  sjana_nn_1_N : N ;
  sjua_nn_1_N : N ;
  sjubarnspappa_nn_1_N : N ;
  sjudagarsvecka_nn_1_N : N ;
  sjuka_nn_1_N : N ;
  sjukfraanvaro_nn_1_1_N : N ;
  sjukkassa_nn_1_N : N ;
  sjukskoeterska_nn_1_1_N : N ;
  sjukskoeterskeskola_nn_1_1_N : N ;
  sjukstuga_nn_1_N : N ;
  sjustjaerna_nn_1_1_N : N ;
  sjuttioaarsaalder_nn_1_1_N : N ;
  sjaelamaessa_nn_1_1_N : N ;
  sjaelsadel_nn_1_1_N : N ;
  sjaelsfraanvaro_nn_1_1_N : N ;
  sjaelsnaervaro_nn_1_1_N : N ;
  sjaelsro_nn_1_1_N : N ;
  sjaelsstyrka_nn_1_1_N : N ;
  sjaelsvaanda_nn_1_1_N : N ;
  sjaelvspricka_nn_1_1_N : N ;
  sjoe_nn_1_1_N : N ;
  sjoebotten_nn_1_1_N : N ;
  sjoegurka_nn_1_1_N : N ;
  sjoemansbyxa_nn_1_1_N : N ;
  sjoemanskista_nn_1_1_N : N ;
  sjoemansvisa_nn_1_1_N : N ;
  sjoemina_nn_1_1_N : N ;
  sjoeolycka_nn_1_1_N : N ;
  sjoepenna_nn_1_1_N : N ;
  sjoestjaerna_nn_1_1_N : N ;
  sjoetunga_nn_1_1_N : N ;
  sjoevana_nn_1_1_N : N ;
  sjoeyta_nn_1_1_N : N ;
  skada_nn_1_N : N ;
  skafferihylla_nn_1_N : N ;
  skala_nn_1_N : N ;
  skallra_nn_1_N : N ;
  skallskada_nn_1_N : N ;
  skalmeja_nn_1_N : N ;
  skamkaensla_nn_1_1_N : N ;
  skamvraa_nn_1_1_N : N ;
  skaparanda_nn_1_N : N ;
  skara_nn_1_N : N ;
  skarsnoe_nn_1_1_N : N ;
  skarvklaemma_nn_1_1_N : N ;
  skata_nn_1_N : N ;
  skatnaeva_nn_1_1_N : N ;
  skattefraaga_nn_1_1_N : N ;
  skattefoermaaga_nn_1_1_N : N ;
  skattekrona_nn_1_N : N ;
  skatteskala_nn_1_N : N ;
  skattgoemma_nn_1_1_N : N ;
  skena_nn_1_N : N ;
  skepplista_nn_1_N : N ;
  skeppsbro_nn_1_N : N ;
  skeppsklocka_nn_1_N : N ;
  skeppsskorpa_nn_1_N : N ;
  skida_nn_1_N : N ;
  skidresa_nn_1_N : N ;
  skifferolja_nn_1_N : N ;
  skifferplatta_nn_1_N : N ;
  skilsmaessa_nn_1_1_N : N ;
  skinka_nn_1_N : N ;
  skinnjacka_nn_1_N : N ;
  skinnsoffa_nn_1_N : N ;
  skiva_nn_1_N : N ;
  skjorta_nn_1_N : N ;
  skjutbana_nn_1_N : N ;
  skjutlucka_nn_1_N : N ;
  skocka_nn_1_N : N ;
  skogsblomma_nn_1_N : N ;
  skogsduva_nn_1_N : N ;
  skogsfru_nn_1_N : N ;
  skogsglaenta_nn_1_1_N : N ;
  skogshoegskola_nn_1_1_N : N ;
  skogsjacka_nn_1_N : N ;
  skogsmulleskola_nn_1_N : N ;
  skogsnaeva_nn_1_1_N : N ;
  skogsskoetsel_nn_1_1_N : N ;
  skogssnuva_nn_1_N : N ;
  skogssnaeppa_nn_1_1_N : N ;
  skogsstjaerna_nn_1_1_N : N ;
  skola_nn_1_N : N ;
  skolflicka_nn_1_N : N ;
  skolfranska_nn_1_N : N ;
  skolfroeken_nn_1_1_N : N ;
  skolmoessa_nn_1_1_N : N ;
  skolradio_nn_1_N : N ;
  skolresa_nn_1_N : N ;
  skolskoeterska_nn_1_1_N : N ;
  skolaalder_nn_1_1_N : N ;
  skopa_nn_1_N : N ;
  skorpa_nn_1_N : N ;
  skosmoerja_nn_1_1_N : N ;
  skosula_nn_1_N : N ;
  skoterkaenga_nn_1_1_N : N ;
  skotska_nn_1_N : N ;
  skotska_nn_2_N : N ;
  skottavla_nn_1_N : N ;
  skottkaerra_nn_1_1_N : N ;
  skottningsolycka_nn_1_N : N ;
  skottskada_nn_1_N : N ;
  skrabba_nn_1_N : N ;
  skramla_nn_1_N : N ;
  skranka_nn_1_N : N ;
  skrapa_nn_1_N : N ;
  skrattrynka_nn_1_N : N ;
  skrattsalva_nn_1_N : N ;
  skreva_nn_1_N : N ;
  skridskobana_nn_1_N : N ;
  skridskoprinsessa_nn_1_N : N ;
  skrika_nn_1_N : N ;
  skrinda_nn_1_N : N ;
  skripta_nn_1_N : N ;
  skrivarfoermaaga_nn_1_1_N : N ;
  skrivbordslampa_nn_1_N : N ;
  skrivbordslaada_nn_1_1_N : N ;
  skrivfoermaaga_nn_1_1_N : N ;
  skrivhoerna_nn_1_1_N : N ;
  skrivklaada_nn_1_1_N : N ;
  skrivtavla_nn_1_N : N ;
  skrubba_nn_1_N : N ;
  skrumplever_nn_1_N : N ;
  skrutt_nn_1_N : N ;
  skrymsla_nn_1_N : N ;
  skrymt_nn_2_N : N ;
  skrynkla_nn_1_N : N ;
  skraeckpropaganda_nn_1_1_N : N ;
  skraeckoedla_nn_1_1_N : N ;
  skraedyxa_nn_1_1_N : N ;
  skraemsel_nn_1_1_N : N ;
  skraemselhicka_nn_1_1_N : N ;
  skraemselpropaganda_nn_1_1_N : N ;
  skraeppa_nn_1_1_N : N ;
  skraaanda_nn_1_1_N : N ;
  skraama_nn_1_1_N : N ;
  skroena_nn_1_1_N : N ;
  skugga_nn_1_N : N ;
  skuggsida_nn_1_N : N ;
  skuldboerda_nn_1_1_N : N ;
  skuldergoerdel_nn_1_1_N : N ;
  skuldfaella_nn_1_1_N : N ;
  skuldkaensla_nn_1_1_N : N ;
  skuldra_nn_1_N : N ;
  skuldraenta_nn_1_1_N : N ;
  skumbubbla_nn_1_N : N ;
  skumpa_nn_1_N : N ;
  skurgumma_nn_1_N : N ;
  skurtrasa_nn_1_N : N ;
  skuta_nn_1_N : N ;
  skvallerbytta_nn_1_N : N ;
  skvallertacka_nn_1_N : N ;
  skvallertaska_nn_1_N : N ;
  skvalta_nn_1_N : N ;
  skvaetta_nn_1_1_N : N ;
  skyltdocka_nn_1_N : N ;
  skyltlaada_nn_1_1_N : N ;
  skyskrapa_nn_1_N : N ;
  skytteskaelva_nn_1_1_N : N ;
  skaedda_nn_1_1_N : N ;
  skaeggbotten_nn_1_1_N : N ;
  skaeggvaarta_nn_1_1_N : N ;
  skaekta_nn_1_1_N : N ;
  skaella_nn_1_1_N : N ;
  skaelva_nn_1_1_N : N ;
  skaeppa_nn_1_1_N : N ;
  skaera_nn_1_1_N : N ;
  skaerbraeda_nn_1_1_N : N ;
  skaerboena_nn_1_1_N : N ;
  skaerflaecka_nn_1_1_N : N ;
  skaergaardsoe_nn_1_1_N : N ;
  skaerlaada_nn_1_1_N : N ;
  skaermmoessa_nn_1_1_N : N ;
  skaerpa_nn_1_1_N : N ;
  skaerpiplaerka_nn_1_1_N : N ;
  skaerra_nn_1_1_N : N ;
  skaerva_nn_1_1_N : N ;
  skaadebana_nn_1_1_N : N ;
  skaadespelerska_nn_1_1_N : N ;
  skaalsnaecka_nn_1_1_N : N ;
  skaanska_nn_1_1_N : N ;
  skaanska_nn_2_1_N : N ;
  skaara_nn_1_1_N : N ;
  skoeka_nn_1_1_N : N ;
  skoeldpadda_nn_1_1_N : N ;
  skoeljkanna_nn_1_1_N : N ;
  skoenprosa_nn_1_1_N : N ;
  skoera_nn_1_1_N : N ;
  skoerdetroeska_nn_1_1_N : N ;
  skoeterska_nn_1_1_N : N ;
  skoetsel_nn_1_1_N : N ;
  slabbertacka_nn_1_N : N ;
  slabbkista_nn_1_N : N ;
  sladdklaemma_nn_1_1_N : N ;
  sladdlampa_nn_1_N : N ;
  slafsa_nn_1_N : N ;
  slaga_nn_1_N : N ;
  slagdaenga_nn_1_1_N : N ;
  slagruta_nn_1_N : N ;
  slagsida_nn_1_N : N ;
  slagskugga_nn_1_N : N ;
  slaguggla_nn_1_N : N ;
  slaksida_nn_1_N : N ;
  slalomskida_nn_1_N : N ;
  slamfluga_nn_1_N : N ;
  slampa_nn_1_N : N ;
  slamsa_nn_1_N : N ;
  slana_nn_1_N : N ;
  slangbella_nn_1_N : N ;
  slanggurka_nn_1_N : N ;
  slangklaemma_nn_1_1_N : N ;
  slarva_nn_1_N : N ;
  slarvpotta_nn_1_N : N ;
  slarvsylta_nn_1_N : N ;
  slavhandel_nn_1_N : N ;
  slavinna_nn_1_N : N ;
  slavtillvaro_nn_1_N : N ;
  slemhinna_nn_1_N : N ;
  slida_nn_1_N : N ;
  slinga_nn_1_N : N ;
  slinka_nn_1_N : N ;
  slipersolja_nn_1_N : N ;
  slipmassa_nn_1_N : N ;
  slippasta_nn_1_N : N ;
  slira_nn_1_N : N ;
  slitbana_nn_1_N : N ;
  slityta_nn_1_N : N ;
  slivovica_nn_1_N : N ;
  slottsfru_nn_1_N : N ;
  slottskyrka_nn_1_N : N ;
  slovakiska_nn_1_N : N ;
  slovakiska_nn_2_N : N ;
  slovenska_nn_1_N : N ;
  slovenska_nn_2_N : N ;
  slunga_nn_1_N : N ;
  slusstrappa_nn_1_N : N ;
  slutfaara_nn_1_1_N : N ;
  slutnota_nn_1_N : N ;
  slutstraecka_nn_1_1_N : N ;
  slutsumma_nn_1_N : N ;
  slya_nn_1_N : N ;
  slyklinga_nn_1_N : N ;
  slyna_nn_1_N : N ;
  slynga_nn_1_N : N ;
  slaegga_nn_1_1_N : N ;
  slaektkroenika_nn_1_1_N : N ;
  slaektsaga_nn_1_1_N : N ;
  slaektskap_nn_1_1_N : N ;
  slaenda_nn_1_1_N : N ;
  slaendtrissa_nn_1_1_N : N ;
  slaenggunga_nn_1_1_N : N ;
  slaengkappa_nn_1_1_N : N ;
  slaengpolska_nn_1_1_N : N ;
  slaepkaerra_nn_1_1_N : N ;
  slaeplina_nn_1_1_N : N ;
  slaetbana_nn_1_1_N : N ;
  slaa_nn_1_1_N : N ;
  slaan_nn_1_1_N : N ;
  slaatta_nn_1_1_N : N ;
  slaatterblomma_nn_1_1_N : N ;
  sloedricka_nn_1_1_N : N ;
  sloeja_nn_1_1_N : N ;
  smakfraaga_nn_1_1_N : N ;
  smakstyrka_nn_1_N : N ;
  smalnaesapa_nn_1_1_N : N ;
  smalaenda_nn_1_1_N : N ;
  smedhalva_nn_1_N : N ;
  smedja_nn_1_N : N ;
  smegma_nn_1_N : N ;
  smeka_nn_1_N : N ;
  smetana_nn_1_N : N ;
  sminkerska_nn_1_N : N ;
  smita_nn_1_N : N ;
  smitningsolycka_nn_1_N : N ;
  smitta_nn_1_N : N ;
  smittkoppa_nn_1_N : N ;
  smittkaella_nn_1_1_N : N ;
  smocka_nn_1_N : N ;
  smokingskjorta_nn_1_N : N ;
  smula_nn_1_N : N ;
  smultrontunga_nn_1_N : N ;
  smaella_nn_1_1_N : N ;
  smaelta_nn_1_1_N : N ;
  smaeltvaerme_nn_1_1_N : N ;
  smaergel_nn_1_1_N : N ;
  smaerta_nn_1_1_N : N ;
  smaerttroeskel_nn_1_1_N : N ;
  smaabarnsmamma_nn_1_1_N : N ;
  smaabildskamera_nn_1_1_N : N ;
  smaabrygga_nn_1_1_N : N ;
  smaaflicka_nn_1_1_N : N ;
  smaakaka_nn_1_1_N : N ;
  smaalaendska_nn_1_1_N : N ;
  smaalaendska_nn_2_1_N : N ;
  smaaskola_nn_1_1_N : N ;
  smaasnaeppa_nn_1_1_N : N ;
  smoerblomma_nn_1_1_N : N ;
  smoergaasskinka_nn_1_1_N : N ;
  smoergaastaarta_nn_1_1_N : N ;
  smoerja_nn_1_1_N : N ;
  smoerjkanna_nn_1_1_N : N ;
  smoerjolja_nn_1_1_N : N ;
  smoerkula_nn_1_1_N : N ;
  smoersyra_nn_1_1_N : N ;
  snabbcement_nn_1_N : N ;
  snabbkassa_nn_1_N : N ;
  snabbkoepskassa_nn_1_1_N : N ;
  snabbplatta_nn_1_N : N ;
  snabbskilsmaessa_nn_1_1_N : N ;
  snapsvisa_nn_1_N : N ;
  snara_nn_1_N : N ;
  snarreva_nn_1_N : N ;
  snedbena_nn_1_N : N ;
  snedremsa_nn_1_N : N ;
  snedruta_nn_1_N : N ;
  snedslaa_nn_1_1_N : N ;
  snilja_nn_1_N : N ;
  sniljeflossa_nn_1_N : N ;
  snipa_nn_1_N : N ;
  snippa_nn_1_N : N ;
  snittblomma_nn_1_N : N ;
  snittyta_nn_1_N : N ;
  snoa_nn_1_N : N ;
  snobbraenna_nn_1_1_N : N ;
  snor_nn_1_N : N ;
  snubba_nn_1_N : N ;
  snugga_nn_1_N : N ;
  snultra_nn_1_N : N ;
  snurra_nn_1_N : N ;
  snusdosa_nn_1_N : N ;
  snuva_nn_1_N : N ;
  snyggma_nn_1_N : N ;
  snaecka_nn_1_1_N : N ;
  snaeckmaergel_nn_1_1_N : N ;
  snaeppa_nn_1_1_N : N ;
  snaerja_nn_1_1_N : N ;
  snaerjmaara_nn_1_1_N : N ;
  snaerpa_nn_1_1_N : N ;
  snaerta_nn_1_1_N : N ;
  snaesa_nn_1_1_N : N ;
  snaarvinda_nn_1_1_N : N ;
  snoe_nn_1_1_N : N ;
  snoebraeda_nn_1_1_N : N ;
  snoedriva_nn_1_1_N : N ;
  snoeflinga_nn_1_1_N : N ;
  snoehalka_nn_1_1_N : N ;
  snoekedja_nn_1_1_N : N ;
  snoeklocka_nn_1_1_N : N ;
  snoelega_nn_1_1_N : N ;
  snoelykta_nn_1_1_N : N ;
  snoeripa_nn_1_1_N : N ;
  snoerkaenga_nn_1_1_N : N ;
  snoeskata_nn_1_1_N : N ;
  snoeskorpa_nn_1_1_N : N ;
  snoeslunga_nn_1_1_N : N ;
  snoestjaerna_nn_1_1_N : N ;
  snoeyra_nn_1_1_N : N ;
  so_nn_1_N : N ;
  socialhoegskola_nn_1_1_N : N ;
  socka_nn_1_N : N ;
  socken_nn_1_N : N ;
  sockenstuga_nn_1_N : N ;
  sockerbeta_nn_1_N : N ;
  sockerdricka_nn_1_N : N ;
  sockerkaka_nn_1_N : N ;
  sockerpulla_nn_1_N : N ;
  sockerskorpa_nn_1_N : N ;
  soda_nn_1_N : N ;
  sodamassa_nn_1_N : N ;
  soffa_nn_1_N : N ;
  soja_nn_1_N : N ;
  sojaboena_nn_1_1_N : N ;
  sojakaka_nn_1_N : N ;
  solariehoena_nn_1_1_N : N ;
  solbraenna_nn_1_1_N : N ;
  solcellsvaeska_nn_1_1_N : N ;
  soldatkappa_nn_1_N : N ;
  soldataenka_nn_1_1_N : N ;
  solgata_nn_1_N : N ;
  solkurva_nn_1_N : N ;
  sollampa_nn_1_N : N ;
  sololja_nn_1_N : N ;
  solresa_nn_1_N : N ;
  solsida_nn_1_N : N ;
  solskensdag_nn_1_N : N ;
  solstrimma_nn_1_N : N ;
  soltimma_nn_1_N : N ;
  solveranda_nn_1_N : N ;
  solvaenda_nn_1_1_N : N ;
  somaliska_nn_1_N : N ;
  somaliska_nn_2_N : N ;
  sommardag_nn_1_N : N ;
  sommardimma_nn_1_N : N ;
  sommarfjaeril_nn_1_1_N : N ;
  sommarhetta_nn_1_N : N ;
  sommarstuga_nn_1_N : N ;
  sommartorka_nn_1_N : N ;
  sommarvecka_nn_1_N : N ;
  sommarvilla_nn_1_N : N ;
  sopa_nn_1_N : N ;
  sopmaja_nn_1_N : N ;
  soppa_nn_1_N : N ;
  soppa_nn_2_N : N ;
  sopsaeckskaerra_nn_1_1_N : N ;
  soptunna_nn_1_N : N ;
  sorgsloeja_nn_1_1_N : N ;
  sossekvinna_nn_1_N : N ;
  sothoena_nn_1_1_N : N ;
  spanjorska_nn_1_N : N ;
  spanska_nn_1_N : N ;
  sparboessa_nn_1_1_N : N ;
  sparkassa_nn_1_N : N ;
  sparkbyxa_nn_1_N : N ;
  sparlakanslaexa_nn_1_1_N : N ;
  sparlaaga_nn_1_1_N : N ;
  sparrissoppa_nn_1_N : N ;
  sparvuggla_nn_1_N : N ;
  specialkarta_nn_1_N : N ;
  specialskola_nn_1_N : N ;
  specialstyrka_nn_1_N : N ;
  speed_nn_1_N : N ;
  speedwaybana_nn_1_N : N ;
  spegelkaerna_nn_1_1_N : N ;
  spegelreflexkamera_nn_1_N : N ;
  spelbricka_nn_1_N : N ;
  speldosa_nn_1_N : N ;
  spelhaala_nn_1_1_N : N ;
  spelmansstaemma_nn_1_1_N : N ;
  spelrazzia_nn_1_N : N ;
  sperma_nn_1_N : N ;
  speta_nn_1_N : N ;
  spetsbyxa_nn_1_N : N ;
  spettekaka_nn_1_N : N ;
  spettkaka_nn_1_N : N ;
  spetaelska_nn_1_1_N : N ;
  spikklubba_nn_1_N : N ;
  spikmatta_nn_1_N : N ;
  spillkraaka_nn_1_1_N : N ;
  spillolja_nn_1_N : N ;
  spillra_nn_1_N : N ;
  spillaanga_nn_1_1_N : N ;
  spilta_nn_1_N : N ;
  spilaapipa_nn_1_1_N : N ;
  spindelapa_nn_1_N : N ;
  spindelhona_nn_1_N : N ;
  spinnarfjaeril_nn_1_1_N : N ;
  spionkamera_nn_1_N : N ;
  spira_nn_1_N : N ;
  spiralbotten_nn_1_N : N ;
  spiralnebulosa_nn_1_N : N ;
  spiraltrappa_nn_1_N : N ;
  spirea_nn_1_N : N ;
  spirituosa_nn_1_N : N ;
  spirlaanga_nn_1_1_N : N ;
  spiselhylla_nn_1_N : N ;
  spishylla_nn_1_N : N ;
  spiskupa_nn_1_N : N ;
  spiskaapa_nn_1_1_N : N ;
  spisplatta_nn_1_N : N ;
  spjaela_nn_1_1_N : N ;
  spjaellaada_nn_1_1_N : N ;
  splittra_nn_1_N : N ;
  spolarvaetska_nn_1_1_N : N ;
  sponk_nn_1_N : N ;
  sportarena_nn_1_N : N ;
  sportlovsstuga_nn_1_N : N ;
  sportmoessa_nn_1_1_N : N ;
  sportsida_nn_1_N : N ;
  sportstuga_nn_1_N : N ;
  spottloska_nn_1_N : N ;
  spovsnaeppa_nn_1_1_N : N ;
  sprayflaska_nn_1_N : N ;
  sprejflaska_nn_1_N : N ;
  spricka_nn_1_N : N ;
  spridningskaella_nn_1_1_N : N ;
  springa_nn_1_N : N ;
  springflicka_nn_1_N : N ;
  springkaella_nn_1_1_N : N ;
  springnota_nn_1_N : N ;
  spritpenna_nn_1_N : N ;
  spruta_nn_1_N : N ;
  spraenglista_nn_1_1_N : N ;
  spraakfakta_nn_1_1_N : N ;
  spraaklaera_nn_1_1_N : N ;
  spraakresa_nn_1_1_N : N ;
  spraangbraeda_nn_1_1_N : N ;
  spya_nn_1_N : N ;
  spyfluga_nn_1_N : N ;
  spaeddricka_nn_1_1_N : N ;
  spaennbuckla_nn_1_1_N : N ;
  spaerrlista_nn_1_1_N : N ;
  spaetta_nn_1_1_N : N ;
  spaagumma_nn_1_1_N : N ;
  spaakvinna_nn_1_1_N : N ;
  spaana_nn_1_1_N : N ;
  spaank_nn_1_1_N : N ;
  spaanplatta_nn_1_1_N : N ;
  spaanskiva_nn_1_1_N : N ;
  spoektimma_nn_1_1_N : N ;
  srilankesiska_nn_1_N : N ;
  stabiliseringsfena_nn_1_N : N ;
  stabskarta_nn_1_N : N ;
  stackmyra_nn_1_N : N ;
  stadga_nn_1_N : N ;
  stadga_nn_2_N : N ;
  stadiontuta_nn_1_N : N ;
  stadsgroenska_nn_1_1_N : N ;
  stadskaerna_nn_1_1_N : N ;
  stadsresa_nn_1_N : N ;
  stallykta_nn_1_N : N ;
  stambana_nn_1_N : N ;
  stamtavla_nn_1_N : N ;
  stamvoertstyrka_nn_1_1_N : N ;
  standardklyscha_nn_1_N : N ;
  stapelvara_nn_1_N : N ;
  starkvara_nn_1_N : N ;
  startbana_nn_1_N : N ;
  startfaalla_nn_1_1_N : N ;
  startstraecka_nn_1_1_N : N ;
  statsfru_nn_1_N : N ;
  statskassa_nn_1_N : N ;
  statskvinna_nn_1_N : N ;
  statsnytta_nn_1_N : N ;
  status_nn_1_N : N ;
  stavkyrka_nn_1_N : N ;
  stavlampa_nn_1_N : N ;
  stearin_nn_1_N : N ;
  stearinsyra_nn_1_N : N ;
  steglitsa_nn_1_N : N ;
  stekpanna_nn_1_N : N ;
  stekyta_nn_1_N : N ;
  stenbotten_nn_1_N : N ;
  stenbraecka_nn_1_1_N : N ;
  stendammlunga_nn_1_N : N ;
  stenflisa_nn_1_N : N ;
  stenkaka_nn_1_N : N ;
  stenkista_nn_1_N : N ;
  stenkolstjaera_nn_1_1_N : N ;
  stenlunga_nn_1_N : N ;
  stenplatta_nn_1_N : N ;
  stenskvaetta_nn_1_1_N : N ;
  stensoeta_nn_1_1_N : N ;
  stentavla_nn_1_N : N ;
  stentorsstaemma_nn_1_1_N : N ;
  stentrappa_nn_1_N : N ;
  stenyxa_nn_1_N : N ;
  stenaalder_nn_1_1_N : N ;
  stenaaldershjaerna_nn_1_1_N : N ;
  stenaaldersyxa_nn_1_1_N : N ;
  stereo_nn_1_N : N ;
  stia_nn_1_N : N ;
  sticka_nn_1_N : N ;
  stiftsfroeken_nn_1_1_N : N ;
  stilblomma_nn_1_N : N ;
  stinta_nn_1_N : N ;
  stjaerna_nn_1_1_N : N ;
  stjaernblomma_nn_1_1_N : N ;
  stjaernhimmel_nn_1_1_N : N ;
  stjaernkarta_nn_1_1_N : N ;
  stjaertfena_nn_1_1_N : N ;
  stjaertgympa_nn_1_1_N : N ;
  stoa_nn_1_N : N ;
  stockholmska_nn_1_N : N ;
  stockholmska_nn_2_N : N ;
  stofthydda_nn_1_N : N ;
  stoftsloeja_nn_1_1_N : N ;
  stola_nn_1_N : N ;
  stolla_nn_1_N : N ;
  stolsdyna_nn_1_N : N ;
  stopplykta_nn_1_N : N ;
  storbedragerska_nn_1_N : N ;
  stordia_nn_1_N : N ;
  storhjaerna_nn_1_1_N : N ;
  storkova_nn_1_N : N ;
  stormlykta_nn_1_N : N ;
  stormstyrka_nn_1_N : N ;
  stormsvala_nn_1_N : N ;
  storskotsskena_nn_1_N : N ;
  storstjaerna_nn_1_1_N : N ;
  storstuga_nn_1_N : N ;
  stortavla_nn_1_N : N ;
  stortroeja_nn_1_1_N : N ;
  straffskala_nn_1_N : N ;
  strandskata_nn_1_N : N ;
  strandsnaecka_nn_1_1_N : N ;
  strega_nn_1_N : N ;
  stridsfraaga_nn_1_1_N : N ;
  stridsklubba_nn_1_N : N ;
  stridsvana_nn_1_N : N ;
  stridsyxa_nn_1_N : N ;
  striga_nn_1_N : N ;
  strimla_nn_1_N : N ;
  strimma_nn_1_N : N ;
  stripa_nn_1_N : N ;
  strippa_nn_1_N : N ;
  struma_nn_1_N : N ;
  strumpa_nn_1_N : N ;
  strumpbyxa_nn_1_N : N ;
  strumpebandsorden_nn_1_N : N ;
  strumpsticka_nn_1_N : N ;
  struntsumma_nn_1_N : N ;
  struva_nn_1_N : N ;
  strykbraeda_nn_1_1_N : N ;
  strykerska_nn_1_N : N ;
  strykkappa_nn_1_N : N ;
  stryknin_nn_1_N : N ;
  stryksticka_nn_1_N : N ;
  straecka_nn_1_1_N : N ;
  straeva_nn_1_1_N : N ;
  straalblomma_nn_1_1_N : N ;
  straalningsera_nn_1_1_N : N ;
  straalputa_nn_1_1_N : N ;
  straalskada_nn_1_1_N : N ;
  straamatta_nn_1_1_N : N ;
  straaroeta_nn_1_1_N : N ;
  stroemfaara_nn_1_1_N : N ;
  stroemkaella_nn_1_1_N : N ;
  stroemmingsflundra_nn_1_1_N : N ;
  stroemstyrka_nn_1_1_N : N ;
  stroemvaerme_nn_1_1_N : N ;
  stroessel_nn_1_1_N : N ;
  studentmoessa_nn_1_1_N : N ;
  studieovana_nn_1_N : N ;
  studieresa_nn_1_N : N ;
  studsmatta_nn_1_N : N ;
  stuga_nn_1_N : N ;
  stulta_nn_1_N : N ;
  stumpa_nn_1_N : N ;
  stupa_nn_1_N : N ;
  stupa_nn_2_N : N ;
  stupraenna_nn_1_1_N : N ;
  stybb_nn_1_N : N ;
  stylta_nn_1_N : N ;
  styrka_nn_1_N : N ;
  styrlina_nn_1_N : N ;
  styrsel_nn_1_N : N ;
  styvmamma_nn_1_N : N ;
  styvpappa_nn_1_N : N ;
  staederska_nn_1_1_N : N ;
  staedfru_nn_1_1_N : N ;
  staedgumma_nn_1_1_N : N ;
  staemma_nn_1_1_N : N ;
  staempel_nn_2_1_N : N ;
  staempeldyna_nn_1_1_N : N ;
  staempelklocka_nn_1_1_N : N ;
  staetta_nn_1_1_N : N ;
  staeva_nn_1_1_N : N ;
  staafela_nn_1_1_N : N ;
  staalpenna_nn_1_1_N : N ;
  staalpipa_nn_1_1_N : N ;
  staalrundkula_nn_1_1_N : N ;
  staalskena_nn_1_1_N : N ;
  staangpiska_nn_1_1_N : N ;
  staanka_nn_1_1_N : N ;
  stoedgala_nn_1_1_N : N ;
  stoeldliga_nn_1_1_N : N ;
  stoerboena_nn_1_1_N : N ;
  stoetsida_nn_1_1_N : N ;
  stoetta_nn_1_1_N : N ;
  subba_nn_1_N : N ;
  sublimat_nn_1_N : N ;
  suckat_nn_1_N : N ;
  sudanesiska_nn_1_N : N ;
  sugga_nn_1_N : N ;
  sula_nn_1_N : N ;
  sulfa_nn_1_N : N ;
  sulfatmassa_nn_1_N : N ;
  summa_nn_1_N : N ;
  sumo_nn_1_N : N ;
  sumphoena_nn_1_1_N : N ;
  superdiva_nn_1_N : N ;
  superhopslinga_nn_1_N : N ;
  supernova_nn_1_N : N ;
  superstjaerna_nn_1_1_N : N ;
  supervaetska_nn_1_1_N : N ;
  sura_nn_1_N : N ;
  surfbraeda_nn_1_1_N : N ;
  surfingbraeda_nn_1_1_N : N ;
  surfplatta_nn_1_N : N ;
  surinamesiska_nn_1_N : N ;
  surpuppa_nn_1_N : N ;
  surrogatmamma_nn_1_N : N ;
  svacka_nn_1_N : N ;
  svada_nn_1_N : N ;
  svagdricka_nn_1_N : N ;
  svala_nn_1_N : N ;
  svalka_nn_1_N : N ;
  svanskota_nn_1_N : N ;
  svanoedla_nn_1_1_N : N ;
  svarthaetta_nn_1_1_N : N ;
  svartmyra_nn_1_N : N ;
  svartskjorta_nn_1_N : N ;
  svartsnaeppa_nn_1_1_N : N ;
  svartsoppa_nn_1_N : N ;
  svastika_nn_1_N : N ;
  svavelblomma_nn_1_N : N ;
  svavelsticka_nn_1_N : N ;
  svavelsyra_nn_1_N : N ;
  svecia_nn_1_N : N ;
  sveda_nn_1_N : N ;
  svedja_nn_1_N : N ;
  svengelska_nn_1_N : N ;
  svensexa_nn_1_N : N ;
  svenska_nn_1_N : N ;
  svenska_nn_2_N : N ;
  svenskmannaanda_nn_1_N : N ;
  svetsloppa_nn_1_N : N ;
  svettpaerla_nn_1_1_N : N ;
  svicka_nn_1_N : N ;
  svindel_nn_1_N : N ;
  svindlerihaerva_nn_1_1_N : N ;
  svingel_nn_1_N : N ;
  svininfluensa_nn_1_N : N ;
  svinmaalla_nn_1_1_N : N ;
  svinotta_nn_1_N : N ;
  svinskoetsel_nn_1_1_N : N ;
  svaegerska_nn_1_1_N : N ;
  svaengbro_nn_1_1_N : N ;
  svaerdsklinga_nn_1_1_N : N ;
  svaerdslilja_nn_1_1_N : N ;
  svaerta_nn_1_1_N : N ;
  swastika_nn_1_N : N ;
  swazilaendska_nn_1_1_N : N ;
  sydafrikanska_nn_1_N : N ;
  sydkoreanska_nn_1_N : N ;
  sydsida_nn_1_N : N ;
  syjunta_nn_1_N : N ;
  sylta_nn_1_N : N ;
  syltgurka_nn_1_N : N ;
  syltkaka_nn_1_N : N ;
  symaskinsolja_nn_1_N : N ;
  synagoga_nn_1_N : N ;
  synfoermaaga_nn_1_1_N : N ;
  synvilla_nn_1_N : N ;
  syra_nn_1_N : N ;
  syreupptagningsfoermaaga_nn_1_1_N : N ;
  syriska_nn_1_N : N ;
  syriska_nn_2_N : N ;
  syrra_nn_1_N : N ;
  syrsa_nn_1_N : N ;
  syskonskara_nn_1_N : N ;
  syssla_nn_1_N : N ;
  syssla_nn_2_N : N ;
  systemkamera_nn_1_N : N ;
  saeckkaerra_nn_1_1_N : N ;
  saeckpipa_nn_1_1_N : N ;
  saed_nn_1_1_N : N ;
  saedesblaasa_nn_1_1_N : N ;
  saedeskaerna_nn_1_1_N : N ;
  saedesvaetska_nn_1_1_N : N ;
  saedesaerla_nn_1_1_N : N ;
  saekerhetskedja_nn_1_1_N : N ;
  saekerhetslampa_nn_1_1_N : N ;
  saekerhetslina_nn_1_1_N : N ;
  saekerhetsmassa_nn_1_1_N : N ;
  saekerhetstaendsticka_nn_1_1_N : N ;
  saellskapsmaenniska_nn_1_1_N : N ;
  saellskapsresa_nn_1_1_N : N ;
  saelta_nn_1_1_N : N ;
  saemja_nn_1_1_N : N ;
  saenghimmel_nn_1_1_N : N ;
  saenglampa_nn_1_1_N : N ;
  saenka_nn_1_1_N : N ;
  saerfraaga_nn_1_1_N : N ;
  saerpraegel_nn_1_1_N : N ;
  saerskola_nn_1_1_N : N ;
  saesongsinfluensa_nn_1_1_N : N ;
  saa_nn_1_1_N : N ;
  saagkedja_nn_1_1_N : N ;
  saagklinga_nn_1_1_N : N ;
  saangerska_nn_1_1_N : N ;
  saanggudinna_nn_1_1_N : N ;
  saanglaerka_nn_1_1_N : N ;
  saapa_nn_1_1_N : N ;
  saapbubbla_nn_1_1_N : N ;
  saapopera_nn_1_1_N : N ;
  saarskada_nn_1_1_N : N ;
  saarskorpa_nn_1_1_N : N ;
  saaskanna_nn_1_1_N : N ;
  soeder_nn_1_1_N : N ;
  soedermanlaendska_nn_1_1_N : N ;
  soedermanlaendska_nn_2_1_N : N ;
  soedersida_nn_1_1_N : N ;
  soelja_nn_1_1_N : N ;
  soemmerska_nn_1_1_N : N ;
  soemntuta_nn_1_1_N : N ;
  soendagsbilaga_nn_1_1_N : N ;
  soendagspappa_nn_1_1_N : N ;
  soendagsskola_nn_1_1_N : N ;
  soendagsskolefroeken_nn_1_1_N : N ;
  soerja_nn_1_1_N : N ;
  soermlaendska_nn_1_1_N : N ;
  soermlaendska_nn_2_1_N : N ;
  soerpa_nn_1_1_N : N ;
  soetma_nn_1_1_N : N ;
  soetvattensnaecka_nn_1_1_N : N ;
  t_troeja_nn_1_1_N : N ;
  tabasco_nn_1_N : N ;
  tacka_nn_1_N : N ;
  tadzjikiska_nn_1_N : N ;
  tadzjikiska_nn_2_N : N ;
  taft_nn_1_N : N ;
  tagelskjorta_nn_1_N : N ;
  taggbraeken_nn_1_1_N : N ;
  taiga_nn_1_N : N ;
  taiwanesiska_nn_1_N : N ;
  taiwanesiska_nn_2_N : N ;
  tajga_nn_1_N : N ;
  takhimmel_nn_1_N : N ;
  takkrona_nn_1_N : N ;
  taklampa_nn_1_N : N ;
  takpanna_nn_1_N : N ;
  takpapp_nn_1_N : N ;
  takplatta_nn_1_N : N ;
  takraenna_nn_1_1_N : N ;
  talarlista_nn_1_N : N ;
  talegaava_nn_1_1_N : N ;
  taleskvinna_nn_1_N : N ;
  talfoermaaga_nn_1_1_N : N ;
  talja_nn_1_N : N ;
  talkskiffer_nn_1_N : N ;
  tallbarrsolja_nn_1_N : N ;
  tallolja_nn_1_N : N ;
  tallplanta_nn_1_N : N ;
  tallticka_nn_1_N : N ;
  talltita_nn_1_N : N ;
  tamduva_nn_1_N : N ;
  tana_nn_1_N : N ;
  tandbrygga_nn_1_N : N ;
  tandhaala_nn_1_1_N : N ;
  tandkrona_nn_1_N : N ;
  tandpasta_nn_1_N : N ;
  tandpulpa_nn_1_N : N ;
  tandroeta_nn_1_1_N : N ;
  tandskoeterska_nn_1_1_N : N ;
  tandsticka_nn_1_N : N ;
  tandyta_nn_1_N : N ;
  tankebana_nn_1_N : N ;
  tankekedja_nn_1_N : N ;
  tankemoeda_nn_1_1_N : N ;
  tankereda_nn_1_N : N ;
  tankeskaerpa_nn_1_1_N : N ;
  tankesmedja_nn_1_N : N ;
  tankevilla_nn_1_N : N ;
  tankevurpa_nn_1_N : N ;
  tanks_nn_1_N : N ;
  tannin_nn_1_N : N ;
  tantal_nn_1_N : N ;
  tanzaniska_nn_1_N : N ;
  tapioka_nn_1_N : N ;
  tara_nn_1_N : N ;
  tarantella_nn_1_N : N ;
  tarlatan_nn_1_N : N ;
  tarmludd_nn_1_N : N ;
  taro_nn_1_N : N ;
  tartan_nn_1_N : N ;
  taska_nn_1_N : N ;
  taverna_nn_1_N : N ;
  tavla_nn_1_N : N ;
  taxa_nn_1_N : N ;
  taxiresa_nn_1_N : N ;
  tchadiska_nn_1_N : N ;
  teaterapa_nn_1_N : N ;
  teatervana_nn_1_N : N ;
  techno_nn_1_N : N ;
  teckenruta_nn_1_N : N ;
  teckningslista_nn_1_N : N ;
  teflonhjaerna_nn_1_1_N : N ;
  tefra_nn_1_N : N ;
  tegellera_nn_1_N : N ;
  tegelpanna_nn_1_N : N ;
  tegelplatta_nn_1_N : N ;
  tegfaara_nn_1_1_N : N ;
  tehuva_nn_1_N : N ;
  tekaka_nn_1_N : N ;
  tekanna_nn_1_N : N ;
  telefonfroeken_nn_1_1_N : N ;
  telegrafremsa_nn_1_N : N ;
  televisionskamera_nn_1_N : N ;
  tellur_nn_1_N : N ;
  tempelherreorden_nn_1_N : N ;
  tempera_nn_1_N : N ;
  temperamentsmaenniska_nn_1_1_N : N ;
  temperaturskala_nn_1_N : N ;
  tennbricka_nn_1_N : N ;
  tennisbana_nn_1_N : N ;
  tenorstaemma_nn_1_1_N : N ;
  tenta_nn_1_N : N ;
  tequila_nn_1_N : N ;
  terapisoffa_nn_1_N : N ;
  terminologifraaga_nn_1_1_N : N ;
  termobyxa_nn_1_N : N ;
  termokappa_nn_1_N : N ;
  terpentin_nn_1_N : N ;
  terrakotta_nn_1_N : N ;
  terraengbana_nn_1_1_N : N ;
  tespiskaerra_nn_1_1_N : N ;
  testikelcancer_nn_1_N : N ;
  tetra_nn_1_N : N ;
  tevekamera_nn_1_N : N ;
  teveronika_nn_1_N : N ;
  teveruta_nn_1_N : N ;
  tevesoffa_nn_1_N : N ;
  tevesaapa_nn_1_1_N : N ;
  textyta_nn_1_N : N ;
  thailaendska_nn_1_1_N : N ;
  thinner_nn_1_N : N ;
  tia_nn_1_N : N ;
  tiara_nn_1_N : N ;
  tibetanska_nn_1_N : N ;
  tibetanska_nn_2_N : N ;
  ticka_nn_1_N : N ;
  tidloesa_nn_1_1_N : N ;
  tidningsanka_nn_1_N : N ;
  tidningsbilaga_nn_1_N : N ;
  tidningssida_nn_1_N : N ;
  tidningsupplaga_nn_1_N : N ;
  tidsanda_nn_1_N : N ;
  tidsaxel_nn_1_N : N ;
  tidsfraaga_nn_1_1_N : N ;
  tidsskala_nn_1_N : N ;
  tigerkaka_nn_1_N : N ;
  tigerlilja_nn_1_N : N ;
  tiggarliga_nn_1_N : N ;
  tiggarorden_nn_1_N : N ;
  tilja_nn_1_N : N ;
  tillfoersel_nn_1_1_N : N ;
  tilltro_nn_1_N : N ;
  tillvaro_nn_1_N : N ;
  tillvaextfraaga_nn_1_1_N : N ;
  tillvaextfoermaaga_nn_1_1_N : N ;
  tillvaextkurva_nn_1_1_N : N ;
  tillvaextstyrka_nn_1_1_N : N ;
  tilt_nn_1_N : N ;
  tilta_nn_1_N : N ;
  timaxel_nn_1_N : N ;
  timer_nn_1_N : N ;
  timma_nn_1_N : N ;
  timmerkoja_nn_1_N : N ;
  timmerlaensa_nn_1_1_N : N ;
  tina_nn_1_N : N ;
  tinner_nn_1_N : N ;
  tiokrona_nn_1_N : N ;
  tiosyra_nn_1_N : N ;
  tipsrunda_nn_1_N : N ;
  tischa_nn_1_N : N ;
  tisdagssoppa_nn_1_N : N ;
  tisha_nn_1_N : N ;
  tita_nn_1_N : N ;
  titan_nn_2_N : N ;
  titelsida_nn_1_N : N ;
  tjeckiska_nn_1_N : N ;
  tjeckiska_nn_2_N : N ;
  tjeckoslovakiska_nn_1_N : N ;
  tjeka_nn_1_N : N ;
  tjetjenska_nn_1_N : N ;
  tjetjenska_nn_2_N : N ;
  tjocka_nn_1_N : N ;
  tjockolja_nn_1_N : N ;
  tjocktroeja_nn_1_1_N : N ;
  tjuga_nn_1_N : N ;
  tjugoaattaaarsaalder_nn_1_1_N : N ;
  tjuvgoemma_nn_1_1_N : N ;
  tjuvsena_nn_1_N : N ;
  tjaenarinna_nn_1_1_N : N ;
  tjaensteflicka_nn_1_1_N : N ;
  tjaenstekvinna_nn_1_1_N : N ;
  tjaenstepiga_nn_1_1_N : N ;
  tjaensteresa_nn_1_1_N : N ;
  tjaera_nn_1_1_N : N ;
  toa_nn_1_N : N ;
  tobakspipa_nn_1_N : N ;
  tobaksplanta_nn_1_N : N ;
  tobaksstrimla_nn_1_N : N ;
  tobaksvara_nn_1_N : N ;
  tobisgrissla_nn_1_N : N ;
  toccata_nn_1_N : N ;
  toffelblomma_nn_1_N : N ;
  tofslaerka_nn_1_1_N : N ;
  tofsvipa_nn_1_N : N ;
  tofu_nn_1_N : N ;
  toga_nn_1_N : N ;
  togolesiska_nn_1_N : N ;
  toka_nn_1_N : N ;
  tokajer_nn_1_N : N ;
  tokmorsa_nn_1_N : N ;
  tokvaenster_nn_1_1_N : N ;
  tolklina_nn_1_N : N ;
  tolkningsfraaga_nn_1_1_N : N ;
  tolta_nn_1_N : N ;
  tolva_nn_1_N : N ;
  tolvkanthylsa_nn_1_N : N ;
  tolvkantshylsa_nn_1_N : N ;
  tolvaarsaalder_nn_1_1_N : N ;
  tombola_nn_1_N : N ;
  tomflaska_nn_1_N : N ;
  tomlaada_nn_1_1_N : N ;
  tomteluva_nn_1_N : N ;
  tomtyta_nn_1_N : N ;
  tonganska_nn_1_N : N ;
  tonganska_nn_2_N : N ;
  tonika_nn_1_N : N ;
  tonskala_nn_1_N : N ;
  tonstyrka_nn_1_N : N ;
  tonaarsflicka_nn_1_1_N : N ;
  topplanterna_nn_1_N : N ;
  toppluva_nn_1_N : N ;
  topplaenta_nn_1_1_N : N ;
  topplaerka_nn_1_1_N : N ;
  topploesa_nn_1_1_N : N ;
  toppmurkla_nn_1_N : N ;
  topproeta_nn_1_1_N : N ;
  toppaenda_nn_1_1_N : N ;
  tordoensstaemma_nn_1_1_N : N ;
  torggumma_nn_1_N : N ;
  torghandel_nn_1_N : N ;
  torka_nn_1_N : N ;
  torklina_nn_1_N : N ;
  torklaada_nn_1_1_N : N ;
  torktumlarludd_nn_1_N : N ;
  tornsnaecka_nn_1_1_N : N ;
  tornspira_nn_1_N : N ;
  tornsvala_nn_1_N : N ;
  tornuggla_nn_1_N : N ;
  torpedkula_nn_1_N : N ;
  torpstuga_nn_1_N : N ;
  torraka_nn_1_N : N ;
  torrdocka_nn_1_N : N ;
  torrfluga_nn_1_N : N ;
  torrspricka_nn_1_N : N ;
  torrvedssticka_nn_1_N : N ;
  torroeta_nn_1_1_N : N ;
  torskleverolja_nn_1_N : N ;
  torta_nn_1_N : N ;
  torva_nn_1_N : N ;
  tosa_nn_1_N : N ;
  tossa_nn_1_N : N ;
  totalskugga_nn_1_N : N ;
  totalyta_nn_1_N : N ;
  totem_nn_1_N : N ;
  toto_nn_1_N : N ;
  tova_nn_1_N : N ;
  toxin_nn_1_N : N ;
  trafikolycka_nn_1_N : N ;
  trafikpulsaader_nn_1_1_N : N ;
  traktorkaerra_nn_1_1_N : N ;
  traktoerpanna_nn_1_1_N : N ;
  tralla_nn_1_N : N ;
  trampa_nn_1_N : N ;
  trampdyna_nn_1_N : N ;
  trampmina_nn_1_N : N ;
  trana_nn_1_N : N ;
  tranlampa_nn_1_N : N ;
  transa_nn_1_N : N ;
  transfer_nn_1_N : N ;
  transhora_nn_1_N : N ;
  transistorradio_nn_1_N : N ;
  transitresa_nn_1_N : N ;
  transportbana_nn_1_N : N ;
  transportkaerra_nn_1_1_N : N ;
  transportstraecka_nn_1_1_N : N ;
  transsubstantiationslaera_nn_1_1_N : N ;
  transubstantiationslaera_nn_1_1_N : N ;
  trappa_nn_1_N : N ;
  trappkaerra_nn_1_1_N : N ;
  trappskiva_nn_1_N : N ;
  trasa_nn_1_N : N ;
  trasdocka_nn_1_N : N ;
  trasmaja_nn_1_N : N ;
  trasmatta_nn_1_N : N ;
  tratta_nn_1_N : N ;
  trav_nn_1_N : N ;
  travbana_nn_1_N : N ;
  trea_nn_1_N : N ;
  tredagarsfeber_nn_1_N : N ;
  tredjedagsfrossa_nn_1_N : N ;
  tredska_nn_1_N : N ;
  trekarlspolska_nn_1_N : N ;
  trekloever_nn_1_1_N : N ;
  trekvartsstrumpa_nn_1_N : N ;
  trettifemaarsaalder_nn_1_1_N : N ;
  trettiofemaarsaalder_nn_1_1_N : N ;
  triangelsida_nn_1_N : N ;
  trikaavara_nn_1_1_N : N ;
  trilla_nn_1_N : N ;
  trilska_nn_1_N : N ;
  trindsnoe_nn_1_1_N : N ;
  trindyxa_nn_1_N : N ;
  trinidadiska_nn_1_N : N ;
  trippel_nn_1_N : N ;
  trippelstjaerna_nn_1_1_N : N ;
  trippelvaccin_nn_1_N : N ;
  trissa_nn_1_N : N ;
  trivialskola_nn_1_N : N ;
  trivsel_nn_1_N : N ;
  tro_nn_1_N : N ;
  trojka_nn_1_N : N ;
  trollcirkel_nn_1_N : N ;
  trollhoppa_nn_1_N : N ;
  trollkvinna_nn_1_N : N ;
  trollpacka_nn_1_N : N ;
  trollruna_nn_1_N : N ;
  trollslaenda_nn_1_1_N : N ;
  trolltrumma_nn_1_N : N ;
  tromla_nn_1_N : N ;
  tronfoeljerska_nn_1_1_N : N ;
  tronhimmel_nn_1_N : N ;
  trosa_nn_1_N : N ;
  troslaera_nn_1_1_N : N ;
  trossbotten_nn_1_N : N ;
  trosskvinna_nn_1_N : N ;
  trubbnaesa_nn_1_1_N : N ;
  truga_nn_1_N : N ;
  trumhinna_nn_1_N : N ;
  trumhaala_nn_1_1_N : N ;
  trumma_nn_1_N : N ;
  trumpetblomma_nn_1_N : N ;
  truppnaervaro_nn_1_1_N : N ;
  truppstyrka_nn_1_N : N ;
  tryckspruta_nn_1_N : N ;
  tryckstyrka_nn_1_N : N ;
  tryckyta_nn_1_N : N ;
  tryffel_nn_1_N : N ;
  tryga_nn_1_N : N ;
  trygghetskaensla_nn_1_1_N : N ;
  traecellulosa_nn_1_1_N : N ;
  traeda_nn_1_1_N : N ;
  traedflora_nn_1_1_N : N ;
  traedgaardsblomma_nn_1_1_N : N ;
  traedgaardsboena_nn_1_1_N : N ;
  traedgaardskratta_nn_1_1_N : N ;
  traedgaardsmaestarfru_nn_1_1_N : N ;
  traedgaardsnejlika_nn_1_1_N : N ;
  traedgaardspiga_nn_1_1_N : N ;
  traedgaardsskoetsel_nn_1_1_N : N ;
  traedgaardssnaecka_nn_1_1_N : N ;
  traedgaardstaeppa_nn_1_1_N : N ;
  traedkoja_nn_1_1_N : N ;
  traedkrona_nn_1_1_N : N ;
  traedlaerka_nn_1_1_N : N ;
  traedocka_nn_1_1_N : N ;
  traedpiplaerka_nn_1_1_N : N ;
  traefibermassa_nn_1_1_N : N ;
  traefiberplatta_nn_1_1_N : N ;
  traefiberskiva_nn_1_1_N : N ;
  traeflisa_nn_1_1_N : N ;
  traemassa_nn_1_1_N : N ;
  traengsel_nn_1_1_N : N ;
  traeningsskola_nn_1_1_N : N ;
  traeplanka_nn_1_1_N : N ;
  traeplatta_nn_1_1_N : N ;
  traeribba_nn_1_1_N : N ;
  traeskfeber_nn_1_1_N : N ;
  traeskiva_nn_1_1_N : N ;
  traeskrinda_nn_1_1_N : N ;
  traesnipa_nn_1_1_N : N ;
  traespillra_nn_1_1_N : N ;
  traeta_nn_1_1_N : N ;
  traetjaera_nn_1_1_N : N ;
  traevara_nn_1_1_N : N ;
  traeyta_nn_1_1_N : N ;
  traadmina_nn_1_1_N : N ;
  traadradio_nn_1_1_N : N ;
  troeja_nn_1_1_N : N ;
  troejficka_nn_1_1_N : N ;
  troeska_nn_1_1_N : N ;
  troeskellaada_nn_1_1_N : N ;
  troesklada_nn_1_1_N : N ;
  troetthetskaensla_nn_1_1_N : N ;
  tsetsefluga_nn_1_N : N ;
  tuba_nn_1_N : N ;
  tuftmatta_nn_1_N : N ;
  tugga_nn_1_N : N ;
  tuggyta_nn_1_N : N ;
  tuja_nn_1_N : N ;
  tullstadga_nn_1_N : N ;
  tulta_nn_1_N : N ;
  tumskala_nn_1_N : N ;
  tundra_nn_1_N : N ;
  tunga_nn_1_N : N ;
  tunghaefta_nn_1_1_N : N ;
  tungsida_nn_1_N : N ;
  tunika_nn_1_N : N ;
  tunisiska_nn_1_N : N ;
  tunna_nn_1_N : N ;
  tunnelbana_nn_1_N : N ;
  tunnpannkaka_nn_1_N : N ;
  turiststuga_nn_1_N : N ;
  turistvaluta_nn_1_N : N ;
  turistoe_nn_1_1_N : N ;
  turkiska_nn_1_N : N ;
  turkiska_nn_2_N : N ;
  turkmenska_nn_1_N : N ;
  turkmenska_nn_2_N : N ;
  turksadel_nn_1_N : N ;
  turlista_nn_1_N : N ;
  turturduva_nn_1_N : N ;
  tusch_nn_1_N : N ;
  tuschpenna_nn_1_N : N ;
  tusenbladstaarta_nn_1_1_N : N ;
  tusenskoena_nn_1_1_N : N ;
  tuta_nn_1_N : N ;
  tutta_nn_1_N : N ;
  tuva_nn_1_N : N ;
  tuvaluanska_nn_1_N : N ;
  tuvaluanska_nn_2_N : N ;
  tv_kamera_nn_1_N : N ;
  tv_ruta_nn_1_N : N ;
  tvaga_nn_1_N : N ;
  tvillingflicka_nn_1_N : N ;
  tvillingkaerna_nn_1_1_N : N ;
  tvillingstjaerna_nn_1_1_N : N ;
  tvistefraaga_nn_1_1_N : N ;
  tvaerficka_nn_1_1_N : N ;
  tvaergata_nn_1_1_N : N ;
  tvaerslaa_nn_1_1_N : N ;
  tvaettbraeda_nn_1_1_N : N ;
  tvaettklaemma_nn_1_1_N : N ;
  tvaettlina_nn_1_1_N : N ;
  tvaettstuga_nn_1_1_N : N ;
  tvaaa_nn_1_1_N : N ;
  tvaabarnspappa_nn_1_1_N : N ;
  tvaakammarlykta_nn_1_1_N : N ;
  tvaakrona_nn_1_1_N : N ;
  tvaalflinga_nn_1_1_N : N ;
  tvaalopera_nn_1_1_N : N ;
  tvaangstroeja_nn_1_1_N : N ;
  tvaasitssoffa_nn_1_1_N : N ;
  tvaataktsolja_nn_1_1_N : N ;
  tyda_nn_1_N : N ;
  tyfoidfeber_nn_1_N : N ;
  tygremsa_nn_1_N : N ;
  tygtrasa_nn_1_N : N ;
  tyll_nn_1_N : N ;
  tyrolska_nn_1_N : N ;
  tyska_nn_1_N : N ;
  tyska_nn_2_N : N ;
  taeckjacka_nn_1_1_N : N ;
  taeckmatta_nn_1_1_N : N ;
  taendsticka_nn_1_1_N : N ;
  taendstiftshylsa_nn_1_1_N : N ;
  taendvaetska_nn_1_1_N : N ;
  taenkarpanna_nn_1_1_N : N ;
  taennlika_nn_1_1_N : N ;
  taeppa_nn_1_1_N : N ;
  taerna_nn_1_1_N : N ;
  taetningsmassa_nn_1_1_N : N ;
  taevlingsbana_nn_1_1_N : N ;
  taevlingsmaenniska_nn_1_1_N : N ;
  taaga_nn_1_1_N : N ;
  taagresa_nn_1_1_N : N ;
  taagstraecka_nn_1_1_N : N ;
  taagvaerdinna_nn_1_1_N : N ;
  taahaetta_nn_1_1_N : N ;
  taangraeka_nn_1_1_N : N ;
  taargasdimma_nn_1_1_N : N ;
  taarta_nn_1_1_N : N ;
  taartbotten_nn_1_1_N : N ;
  toe_nn_1_1_N : N ;
  toerel_nn_1_1_N : N ;
  toernekrona_nn_1_1_N : N ;
  toernskata_nn_1_1_N : N ;
  ubaatsfaella_nn_1_1_N : N ;
  ubaatsklocka_nn_1_1_N : N ;
  uddabyxa_nn_1_N : N ;
  ugandiska_nn_1_N : N ;
  uggla_nn_1_N : N ;
  ugnskappa_nn_1_N : N ;
  ugnskaapa_nn_1_1_N : N ;
  ugnslucka_nn_1_N : N ;
  ugnspannkaka_nn_1_N : N ;
  ugnssvaerta_nn_1_1_N : N ;
  ugnstjaera_nn_1_1_N : N ;
  ukrainska_nn_1_N : N ;
  ukrainska_nn_2_N : N ;
  ullapa_nn_1_N : N ;
  ullhandskrabba_nn_1_N : N ;
  ullolja_nn_1_N : N ;
  ullsida_nn_1_N : N ;
  ullstrumpa_nn_1_N : N ;
  ultima_nn_1_N : N ;
  ultrahoeger_nn_1_1_N : N ;
  umbra_nn_1_N : N ;
  undantagsmaenniska_nn_1_1_N : N ;
  undantagstillvaro_nn_1_N : N ;
  underarmskrycka_nn_1_N : N ;
  underblomma_nn_1_N : N ;
  underbyxa_nn_1_N : N ;
  undergaangsprofetia_nn_1_1_N : N ;
  underlagskarta_nn_1_N : N ;
  undersida_nn_1_N : N ;
  underskoeterska_nn_1_1_N : N ;
  understaemma_nn_1_1_N : N ;
  understoedskassa_nn_1_1_N : N ;
  understoedstagaranda_nn_1_1_N : N ;
  undertroeja_nn_1_1_N : N ;
  undervattensboelja_nn_1_1_N : N ;
  undervattenskamera_nn_1_N : N ;
  undervisningstimma_nn_1_N : N ;
  undsaettningsstyrka_nn_1_1_N : N ;
  undulantfeber_nn_1_N : N ;
  ungdomsflamma_nn_1_N : N ;
  ungdomsfraaga_nn_1_1_N : N ;
  ungdomskaella_nn_1_1_N : N ;
  ungdomsskola_nn_1_N : N ;
  ungdomsvaardsskola_nn_1_1_N : N ;
  ungerska_nn_1_N : N ;
  ungerska_nn_2_N : N ;
  ungkarlsflicka_nn_1_N : N ;
  ungkarlsvana_nn_1_N : N ;
  unglotta_nn_1_N : N ;
  ungsugga_nn_1_N : N ;
  uniformsbyxa_nn_1_N : N ;
  uniformsjacka_nn_1_N : N ;
  uniformsmoessa_nn_1_1_N : N ;
  unika_nn_1_N : N ;
  universalkarta_nn_1_N : N ;
  uppenbarelsetro_nn_1_N : N ;
  uppfattningsfoermaaga_nn_1_1_N : N ;
  uppfinningsfoermaaga_nn_1_1_N : N ;
  upphaemta_nn_1_1_N : N ;
  upphaengningsoegla_nn_1_1_N : N ;
  upplaga_nn_1_N : N ;
  upplagesiffra_nn_1_N : N ;
  upplandskyrka_nn_1_N : N ;
  upplega_nn_1_N : N ;
  upplaendska_nn_1_1_N : N ;
  upplaendska_nn_2_1_N : N ;
  upploesningsfoermaaga_nn_1_1_N : N ;
  uppmaerksamhetsfoermaaga_nn_1_1_N : N ;
  uppnaesa_nn_1_1_N : N ;
  uppropslista_nn_1_N : N ;
  upprorsanda_nn_1_N : N ;
  uppskovsraenta_nn_1_1_N : N ;
  uppslagsaenda_nn_1_1_N : N ;
  uppsugningsfoermaaga_nn_1_1_N : N ;
  uppsvenska_nn_1_N : N ;
  upptaecktsresa_nn_1_1_N : N ;
  uran_nn_1_N : N ;
  urea_nn_1_N : N ;
  urfinska_nn_1_N : N ;
  urgermanska_nn_1_N : N ;
  urinblaasa_nn_1_1_N : N ;
  urinstaemma_nn_1_1_N : N ;
  urinsyra_nn_1_N : N ;
  urmaenniska_nn_1_1_N : N ;
  urna_nn_1_N : N ;
  urnordiska_nn_1_N : N ;
  urskiljningsfoermaaga_nn_1_1_N : N ;
  urskillningsfoermaaga_nn_1_1_N : N ;
  ursoppa_nn_1_N : N ;
  urtavla_nn_1_N : N ;
  uruguayanska_nn_1_N : N ;
  utanfoerskapskaensla_nn_1_1_N : N ;
  utanlaexa_nn_1_1_N : N ;
  utanpaaskjorta_nn_1_1_N : N ;
  utantillaexa_nn_1_1_N : N ;
  utbildningsklyfta_nn_1_N : N ;
  utdragslaada_nn_1_1_N : N ;
  utdragssoffa_nn_1_N : N ;
  utevaro_nn_1_N : N ;
  utfoersel_nn_1_1_N : N ;
  utfoersgaava_nn_1_1_N : N ;
  utfoersloepa_nn_1_1_N : N ;
  utgaava_nn_1_1_N : N ;
  utklaedsel_nn_1_1_N : N ;
  utlandsresa_nn_1_N : N ;
  utlandssvenska_nn_1_N : N ;
  utlaendska_nn_1_1_N : N ;
  utlaendska_nn_2_1_N : N ;
  utmattningsskada_nn_1_N : N ;
  utomhuslampa_nn_1_N : N ;
  utresa_nn_1_N : N ;
  utrikeshandel_nn_1_N : N ;
  utrikiska_nn_1_N : N ;
  utsaga_nn_1_N : N ;
  utsida_nn_1_N : N ;
  utskottsvara_nn_1_N : N ;
  utslagsfraaga_nn_1_1_N : N ;
  utvecklingslaera_nn_1_1_N : N ;
  utvecklingstrappa_nn_1_N : N ;
  utaega_nn_1_1_N : N ;
  uzbekiska_nn_1_N : N ;
  uzbekiska_nn_2_N : N ;
  vacuumklocka_nn_1_N : N ;
  vacuumlampa_nn_1_N : N ;
  vadeinlaga_nn_1_N : N ;
  vademecum_nn_1_N : N ;
  vadmal_nn_1_N : N ;
  vagga_nn_1_N : N ;
  vaggvisa_nn_1_N : N ;
  vagina_nn_1_N : N ;
  vaja_nn_1_N : N ;
  vaka_nn_1_N : N ;
  vaktbricka_nn_1_N : N ;
  vaktstyrka_nn_1_N : N ;
  vakuumklocka_nn_1_N : N ;
  vakuumlampa_nn_1_N : N ;
  vala_nn_1_N : N ;
  valeriana_nn_1_N : N ;
  valkyria_nn_1_N : N ;
  valkyrja_nn_1_N : N ;
  valla_nn_1_N : N ;
  vallflicka_nn_1_N : N ;
  vallista_nn_1_N : N ;
  vallmoblomma_nn_1_N : N ;
  valmar_nn_1_N : N ;
  valnoetstaarta_nn_1_1_N : N ;
  valpropaganda_nn_1_N : N ;
  valstuga_nn_1_N : N ;
  valurna_nn_1_N : N ;
  valuta_nn_1_N : N ;
  valutahandel_nn_1_N : N ;
  valutaoro_nn_1_N : N ;
  vana_nn_1_N : N ;
  vanadin_nn_1_N : N ;
  vandel_nn_1_N : N ;
  vandrarkaenga_nn_1_1_N : N ;
  vanemaenniska_nn_1_1_N : N ;
  vanheder_nn_1_N : N ;
  vaniljvisp_nn_1_N : N ;
  vanna_nn_1_N : N ;
  vanskoetsel_nn_1_1_N : N ;
  vantrivsel_nn_1_N : N ;
  vantro_nn_1_N : N ;
  vanuatiska_nn_1_N : N ;
  vanuatiska_nn_2_N : N ;
  vanaera_nn_1_1_N : N ;
  vapenembargo_nn_1_N : N ;
  vapenvila_nn_1_N : N ;
  vara_nn_1_N : N ;
  varblaasa_nn_1_1_N : N ;
  vardagsmaenniska_nn_1_1_N : N ;
  vardagsprosa_nn_1_N : N ;
  vardagsrekvisita_nn_1_N : N ;
  varghona_nn_1_N : N ;
  varginna_nn_1_N : N ;
  vargtimma_nn_1_N : N ;
  varningsflagga_nn_1_N : N ;
  varningsklocka_nn_1_N : N ;
  varningslampa_nn_1_N : N ;
  varpa_nn_1_N : N ;
  varpsticka_nn_1_N : N ;
  varptrikaa_nn_1_1_N : N ;
  varuhylla_nn_1_N : N ;
  varvsfluga_nn_1_N : N ;
  vasaorden_nn_1_N : N ;
  vaselin_nn_1_N : N ;
  vassla_nn_1_N : N ;
  vattenblaasa_nn_1_1_N : N ;
  vattenflaska_nn_1_N : N ;
  vattenkanna_nn_1_N : N ;
  vattenkloever_nn_1_1_N : N ;
  vattenkaella_nn_1_1_N : N ;
  vattenloppa_nn_1_N : N ;
  vattenlaecka_nn_1_1_N : N ;
  vattenmassa_nn_1_N : N ;
  vattenpipa_nn_1_N : N ;
  vattenpolo_nn_1_N : N ;
  vattenraenna_nn_1_1_N : N ;
  vattenskada_nn_1_N : N ;
  vattenskida_nn_1_N : N ;
  vattenspegel_nn_1_N : N ;
  vattenspruta_nn_1_N : N ;
  vattentunna_nn_1_N : N ;
  vattenyta_nn_1_N : N ;
  vattenaanga_nn_1_1_N : N ;
  vattenoedla_nn_1_1_N : N ;
  vaxblomma_nn_1_N : N ;
  vaxboena_nn_1_1_N : N ;
  vaxdocka_nn_1_N : N ;
  vaxkaka_nn_1_N : N ;
  vaxtavla_nn_1_N : N ;
  vecka_nn_1_N : N ;
  veckobilaga_nn_1_N : N ;
  veckotimma_nn_1_N : N ;
  veckoaenda_nn_1_1_N : N ;
  veckaenda_nn_1_1_N : N ;
  vedergaellningsfoermaaga_nn_1_1_N : N ;
  vedergaellningslaera_nn_1_1_N : N ;
  vedermoeda_nn_1_1_N : N ;
  vedervilja_nn_1_N : N ;
  vegamoessa_nn_1_1_N : N ;
  vela_nn_1_N : N ;
  velourpappa_nn_1_N : N ;
  velvetin_nn_1_N : N ;
  vendetta_nn_1_N : N ;
  ventilruta_nn_1_N : N ;
  vepa_nn_1_N : N ;
  veranda_nn_1_N : N ;
  verandatrappa_nn_1_N : N ;
  verbena_nn_1_N : N ;
  verktygslaada_nn_1_1_N : N ;
  verktygsvaeska_nn_1_1_N : N ;
  verslaera_nn_1_1_N : N ;
  vespa_nn_1_N : N ;
  vessla_nn_1_N : N ;
  vetebulla_nn_1_N : N ;
  veteflaeta_nn_1_1_N : N ;
  vetekaka_nn_1_N : N ;
  veteskiva_nn_1_N : N ;
  viagra_nn_1_N : N ;
  vicker_nn_1_N : N ;
  vidja_nn_1_N : N ;
  vietnamesiska_nn_1_N : N ;
  vietnamesiska_nn_2_N : N ;
  vigilia_nn_1_N : N ;
  viktoria_nn_1_N : N ;
  vikunja_nn_1_N : N ;
  vila_nn_1_N : N ;
  vildavel_nn_1_N : N ;
  vildbana_nn_1_N : N ;
  vildhjaerna_nn_1_1_N : N ;
  vildpersilja_nn_1_N : N ;
  vildsvinsolycka_nn_1_N : N ;
  vilja_nn_1_N : N ;
  viljemaenniska_nn_1_1_N : N ;
  viljestyrka_nn_1_N : N ;
  villa_nn_1_N : N ;
  villa_nn_2_N : N ;
  villervalla_nn_1_N : N ;
  villolaera_nn_1_1_N : N ;
  vilomassa_nn_1_N : N ;
  viltbana_nn_1_N : N ;
  vimba_nn_1_N : N ;
  vimma_nn_1_N : N ;
  vina_nn_1_N : N ;
  vinbergssnaecka_nn_1_1_N : N ;
  vinda_nn_1_N : N ;
  vindblomma_nn_1_N : N ;
  vindbro_nn_1_N : N ;
  vindbrygga_nn_1_N : N ;
  vindeltrappa_nn_1_N : N ;
  vindjacka_nn_1_N : N ;
  vindruta_nn_1_N : N ;
  vindruva_nn_1_N : N ;
  vindsida_nn_1_N : N ;
  vindskala_nn_1_N : N ;
  vindskida_nn_1_N : N ;
  vindskiva_nn_1_N : N ;
  vindskupa_nn_1_N : N ;
  vindstilla_nn_1_N : N ;
  vindstrappa_nn_1_N : N ;
  vindstyrka_nn_1_N : N ;
  vindtygsjacka_nn_1_N : N ;
  vinflaska_nn_1_N : N ;
  vingpenna_nn_1_N : N ;
  vinkelsumma_nn_1_N : N ;
  vinlista_nn_1_N : N ;
  vinranka_nn_1_N : N ;
  vinruta_nn_1_N : N ;
  vinstlista_nn_1_N : N ;
  vinstuga_nn_1_N : N ;
  vinsyra_nn_1_N : N ;
  vinterdvala_nn_1_N : N ;
  vintergata_nn_1_N : N ;
  vintergroena_nn_1_1_N : N ;
  vinterhimmel_nn_1_N : N ;
  vinterkraek_nn_1_1_N : N ;
  vinterkraeksjuka_nn_1_1_N : N ;
  vinterkyla_nn_1_N : N ;
  vinterstjaerna_nn_1_1_N : N ;
  vintervila_nn_1_N : N ;
  vinaeger_nn_1_1_N : N ;
  vinaettika_nn_1_1_N : N ;
  viola_nn_1_N : N ;
  vipa_nn_1_N : N ;
  vippa_nn_1_N : N ;
  vippbraeda_nn_1_1_N : N ;
  vira_nn_1_N : N ;
  vira_nn_2_N : N ;
  virrhjaerna_nn_1_1_N : N ;
  virrpanna_nn_1_N : N ;
  visa_nn_1_N : N ;
  vischa_nn_1_N : N ;
  visdomskaella_nn_1_1_N : N ;
  vishetslaera_nn_1_1_N : N ;
  visirskiva_nn_1_N : N ;
  viska_nn_1_N : N ;
  visp_nn_2_N : N ;
  visselpipa_nn_1_N : N ;
  vissla_nn_1_N : N ;
  vita_nn_1_N : N ;
  vitbeta_nn_1_N : N ;
  vitiligo_nn_1_N : N ;
  vitkloever_nn_1_1_N : N ;
  vitlinglyra_nn_1_N : N ;
  vitloeksklyfta_nn_1_1_N : N ;
  vitmossa_nn_1_N : N ;
  vitmaara_nn_1_1_N : N ;
  vitriol_nn_1_N : N ;
  vitriololja_nn_1_N : N ;
  vitryska_nn_1_N : N ;
  vitryska_nn_2_N : N ;
  vitsippa_nn_1_N : N ;
  vittlinglyra_nn_1_N : N ;
  vittnesutsaga_nn_1_N : N ;
  vittra_nn_1_N : N ;
  vitvara_nn_1_N : N ;
  viva_nn_1_N : N ;
  vodka_nn_1_N : N ;
  voffla_nn_1_N : N ;
  vokalissa_nn_1_N : N ;
  volfram_nn_1_N : N ;
  volta_nn_1_N : N ;
  volvo_nn_1_N : N ;
  voodoo_nn_1_N : N ;
  votivgaava_nn_1_1_N : N ;
  vrakeka_nn_1_N : N ;
  vrakspillra_nn_1_N : N ;
  vraalapa_nn_1_1_N : N ;
  vulkanaska_nn_1_N : N ;
  vulkankaegla_nn_1_1_N : N ;
  vulkanoe_nn_1_1_N : N ;
  vulva_nn_1_N : N ;
  vurpa_nn_1_N : N ;
  vuvuzela_nn_1_N : N ;
  vaecka_nn_1_1_N : N ;
  vaeckarklocka_nn_1_1_N : N ;
  vaedergalla_nn_1_1_N : N ;
  vaederkarta_nn_1_1_N : N ;
  vaederlaada_nn_1_1_N : N ;
  vaedjobana_nn_1_1_N : N ;
  vaedur_nn_1_1_N : N ;
  vaegbana_nn_1_1_N : N ;
  vaegbro_nn_1_1_N : N ;
  vaegbula_nn_1_1_N : N ;
  vaegfaerja_nn_1_1_N : N ;
  vaegghylla_nn_1_1_N : N ;
  vaeggklocka_nn_1_1_N : N ;
  vaeggmossa_nn_1_1_N : N ;
  vaeggplatta_nn_1_1_N : N ;
  vaeggyta_nn_1_1_N : N ;
  vaegkurva_nn_1_1_N : N ;
  vaegskrapa_nn_1_1_N : N ;
  vaegstraecka_nn_1_1_N : N ;
  vaegtrumma_nn_1_1_N : N ;
  vaegvaarda_nn_1_1_N : N ;
  vaeljarskara_nn_1_1_N : N ;
  vaelkomma_nn_1_1_N : N ;
  vaellingklocka_nn_1_1_N : N ;
  vaelmaaga_nn_1_1_N : N ;
  vaelskrivningsfroeken_nn_1_1_N : N ;
  vaelta_nn_1_1_N : N ;
  vaelvilja_nn_1_1_N : N ;
  vaenda_nn_1_1_N : N ;
  vaendskiva_nn_1_1_N : N ;
  vaengaava_nn_1_1_N : N ;
  vaeninna_nn_1_1_N : N ;
  vaenster_nn_2_1_N : N ;
  vaensterkurva_nn_1_1_N : N ;
  vaenstersida_nn_1_1_N : N ;
  vaensteraara_nn_1_1_N : N ;
  vaentelista_nn_1_1_N : N ;
  vaerdegrundsfraaga_nn_1_1_N : N ;
  vaerdelaera_nn_1_1_N : N ;
  vaerdepappershandel_nn_1_1_N : N ;
  vaerdeskala_nn_1_1_N : N ;
  vaerdinna_nn_1_1_N : N ;
  vaerja_nn_1_1_N : N ;
  vaerjningsskada_nn_1_1_N : N ;
  vaerldsetta_nn_1_1_N : N ;
  vaerldsgaata_nn_1_1_N : N ;
  vaerldshandel_nn_1_1_N : N ;
  vaerldskarta_nn_1_1_N : N ;
  vaerldsmaestarinna_nn_1_1_N : N ;
  vaerldssmaerta_nn_1_1_N : N ;
  vaerldstrea_nn_1_1_N : N ;
  vaerldsvana_nn_1_1_N : N ;
  vaerma_nn_1_1_N : N ;
  vaerme_nn_2_1_N : N ;
  vaermebildskamera_nn_1_1_N : N ;
  vaermeblemma_nn_1_1_N : N ;
  vaermeboelja_nn_1_1_N : N ;
  vaermedyna_nn_1_1_N : N ;
  vaermeflaska_nn_1_1_N : N ;
  vaermekamera_nn_1_1_N : N ;
  vaermekaella_nn_1_1_N : N ;
  vaermelampa_nn_1_1_N : N ;
  vaermeledningspanna_nn_1_1_N : N ;
  vaermelaera_nn_1_1_N : N ;
  vaermepanna_nn_1_1_N : N ;
  vaermeplatta_nn_1_1_N : N ;
  vaermeslinga_nn_1_1_N : N ;
  vaermestuga_nn_1_1_N : N ;
  vaermetillfoersel_nn_1_1_N : N ;
  vaermlaendska_nn_1_1_N : N ;
  vaermlaendska_nn_2_1_N : N ;
  vaeska_nn_1_1_N : N ;
  vaester_nn_1_1_N : N ;
  vaesteraasgurka_nn_1_1_N : N ;
  vaestgotiska_nn_1_1_N : N ;
  vaestgoetska_nn_1_1_N : N ;
  vaestgoetska_nn_2_1_N : N ;
  vaestmanlaendska_nn_1_1_N : N ;
  vaestmanlaendska_nn_2_1_N : N ;
  vaeta_nn_1_1_N : N ;
  vaetekaerna_nn_1_1_N : N ;
  vaetska_nn_1_1_N : N ;
  vaetsketillfoersel_nn_1_1_N : N ;
  vaeverska_nn_1_1_N : N ;
  vaevnadsvaetska_nn_1_1_N : N ;
  vaevsolv_nn_1_1_N : N ;
  vaexelkassa_nn_1_1_N : N ;
  vaexellaada_nn_1_1_N : N ;
  vaexeltunga_nn_1_1_N : N ;
  vaada_nn_1_1_N : N ;
  vaaffla_nn_1_1_N : N ;
  vaagpapp_nn_1_1_N : N ;
  vaaldsporr_nn_1_1_N : N ;
  vaanda_nn_1_1_N : N ;
  vaarblomma_nn_1_1_N : N ;
  vaardarinna_nn_1_1_N : N ;
  vaardskada_nn_1_1_N : N ;
  vaarkaensla_nn_1_1_N : N ;
  vaarsoppa_nn_1_1_N : N ;
  vaarta_nn_1_1_N : N ;
  vaarvintervecka_nn_1_1_N : N ;
  vaatmassa_nn_1_1_N : N ;
  vaatskrapa_nn_1_1_N : N ;
  vaatvara_nn_1_1_N : N ;
  voertstyrka_nn_1_1_N : N ;
  walesiska_nn_1_N : N ;
  walesiska_nn_2_N : N ;
  walkover_nn_1_N : N ;
  webbkamera_nn_1_N : N ;
  webbsida_nn_1_N : N ;
  wiltonmatta_nn_1_N : N ;
  wolfram_nn_1_N : N ;
  xantippa_nn_1_N : N ;
  xerotin_nn_1_N : N ;
  yakuza_nn_1_N : N ;
  yllestrumpa_nn_1_N : N ;
  yngelkaka_nn_1_N : N ;
  yngelroeta_nn_1_1_N : N ;
  ynk_nn_1_N : N ;
  yoga_nn_1_N : N ;
  yra_nn_1_N : N ;
  yrhaetta_nn_1_1_N : N ;
  yrkesheder_nn_1_N : N ;
  yrkeskvinna_nn_1_N : N ;
  yrkesskada_nn_1_N : N ;
  yrkesskola_nn_1_N : N ;
  yrsel_nn_1_N : N ;
  yrsnoe_nn_1_1_N : N ;
  yta_nn_1_N : N ;
  ytterbana_nn_1_N : N ;
  ytterficka_nn_1_N : N ;
  ytterkurva_nn_1_N : N ;
  yttersida_nn_1_N : N ;
  yttersula_nn_1_N : N ;
  yttrandefrihetsfraaga_nn_1_1_N : N ;
  yxa_nn_1_N : N ;
  zebra_nn_1_N : N ;
  zigenarflicka_nn_1_N : N ;
  zigenska_nn_1_N : N ;
  zinkfeber_nn_1_N : N ;
  zinksalva_nn_1_N : N ;
  zinkaanga_nn_1_1_N : N ;
  zinnia_nn_1_N : N ;
  zontaxa_nn_1_N : N ;
  aeckelkaensla_nn_1_1_N : N ;
  aedelskaanska_nn_1_1_N : N ;
  aega_nn_1_1_N : N ;
  aeggblaasa_nn_1_1_N : N ;
  aegghinna_nn_1_1_N : N ;
  aegghoena_nn_1_1_N : N ;
  aeggkaka_nn_1_1_N : N ;
  aeggklocka_nn_1_1_N : N ;
  aegglaada_nn_1_1_N : N ;
  aeggplanta_nn_1_1_N : N ;
  aeggroera_nn_1_1_N : N ;
  aeggstockscancer_nn_1_1_N : N ;
  aeggula_nn_1_1_N : N ;
  aeggvita_nn_1_1_N : N ;
  aeggvitegiva_nn_1_1_N : N ;
  aektenskapsaalder_nn_1_1_N : N ;
  aelgskav_nn_1_1_N : N ;
  aelskarinna_nn_1_1_N : N ;
  aelsklingsblomma_nn_1_1_N : N ;
  aelta_nn_1_1_N : N ;
  aelva_nn_1_1_N : N ;
  aelvfaara_nn_1_1_N : N ;
  aembetsadel_nn_1_1_N : N ;
  aembetsmannaadel_nn_1_1_N : N ;
  aenda_nn_1_1_N : N ;
  aenda_nn_2_1_N : N ;
  aendyta_nn_1_1_N : N ;
  aenglamakerska_nn_1_1_N : N ;
  aenglaskara_nn_1_1_N : N ;
  aengsblomma_nn_1_1_N : N ;
  aengspiplaerka_nn_1_1_N : N ;
  aengsruta_nn_1_1_N : N ;
  aengsskaera_nn_1_1_N : N ;
  aengssyra_nn_1_1_N : N ;
  aenka_nn_1_1_N : N ;
  aenkefru_nn_1_1_N : N ;
  aenterbila_nn_1_1_N : N ;
  aeppelkaka_nn_1_1_N : N ;
  aeppelmos_nn_1_1_N : N ;
  aeppelsyra_nn_1_1_N : N ;
  aepplekaka_nn_1_1_N : N ;
  aepplemos_nn_1_1_N : N ;
  aepplesyra_nn_1_1_N : N ;
  aera_nn_1_1_N : N ;
  aerftlighetslaera_nn_1_1_N : N ;
  aeril_nn_1_1_N : N ;
  aerla_nn_1_1_N : N ;
  aermbraeda_nn_1_1_N : N ;
  aertbalja_nn_1_1_N : N ;
  aerthjaerna_nn_1_1_N : N ;
  aertreva_nn_1_1_N : N ;
  aertskida_nn_1_1_N : N ;
  aertskocka_nn_1_1_N : N ;
  aertsoppa_nn_1_1_N : N ;
  aessja_nn_1_1_N : N ;
  aettartavla_nn_1_1_N : N ;
  aettestupa_nn_1_1_N : N ;
  aettetavla_nn_1_1_N : N ;
  aettika_nn_1_1_N : N ;
  aettiksgurka_nn_1_1_N : N ;
  aettiksyra_nn_1_1_N : N ;
  aeventyrslusta_nn_1_1_N : N ;
  aevja_nn_1_1_N : N ;
  aa_nn_2_1_N : N ;
  aada_nn_1_1_N : N ;
  aaderhinna_nn_1_1_N : N ;
  aadra_nn_1_1_N : N ;
  aahaaga_nn_1_1_N : N ;
  aakarbrasa_nn_1_1_N : N ;
  aakerbinda_nn_1_1_N : N ;
  aakerhoena_nn_1_1_N : N ;
  aakervinda_nn_1_1_N : N ;
  aakomma_nn_1_1_N : N ;
  aalderdomskraempa_nn_1_1_N : N ;
  aalderskraempa_nn_1_1_N : N ;
  aaldfru_nn_1_1_N : N ;
  aalhomma_nn_1_1_N : N ;
  aalkista_nn_1_1_N : N ;
  aalkusa_nn_1_1_N : N ;
  aalla_nn_1_1_N : N ;
  aalaendska_nn_1_1_N : N ;
  aalaendska_nn_2_1_N : N ;
  aaminnelsedag_nn_1_1_N : N ;
  aanga_nn_1_1_N : N ;
  aangbaatsbrygga_nn_1_1_N : N ;
  aangbaatsraenna_nn_1_1_N : N ;
  aangbaatsvissla_nn_1_1_N : N ;
  aanger_nn_1_1_N : N ;
  aangervecka_nn_1_1_N : N ;
  aangestkaensla_nn_1_1_N : N ;
  aangpanna_nn_1_1_N : N ;
  aangradio_nn_1_1_N : N ;
  aangvissla_nn_1_1_N : N ;
  aara_nn_1_1_N : N ;
  aaretruntolja_nn_1_1_N : N ;
  aarklyka_nn_1_1_N : N ;
  aarsstaemma_nn_1_1_N : N ;
  aarta_nn_1_1_N : N ;
  aaska_nn_1_1_N : N ;
  aaskaadarmassa_nn_1_1_N : N ;
  aasna_nn_1_1_N : N ;
  aasnebrygga_nn_1_1_N : N ;
  aaterfallsfeber_nn_1_1_N : N ;
  aaterfoederska_nn_1_1_N : N ;
  aaterresa_nn_1_1_N : N ;
  aatervaendsgata_nn_1_1_N : N ;
  aatraa_nn_1_1_N : N ;
  aatsida_nn_1_1_N : N ;
  aatta_nn_1_1_N : N ;
  aattlingmamma_nn_1_1_N : N ;
  oe_nn_2_1_N : N ;
  oedekyrka_nn_1_1_N : N ;
  oedesfraaga_nn_1_1_N : N ;
  oedesgudinna_nn_1_1_N : N ;
  oedestro_nn_1_1_N : N ;
  oedestuga_nn_1_1_N : N ;
  oedla_nn_1_1_N : N ;
  oegla_nn_1_1_N : N ;
  oegonbotten_nn_1_1_N : N ;
  oegonhinna_nn_1_1_N : N ;
  oegonhaala_nn_1_1_N : N ;
  oegonkamera_nn_1_1_N : N ;
  oegonskugga_nn_1_1_N : N ;
  oegonvita_nn_1_1_N : N ;
  oeken_nn_1_1_N : N ;
  oekenhetta_nn_1_1_N : N ;
  oekenraatta_nn_1_1_N : N ;
  oekenstjaerna_nn_1_1_N : N ;
  oelandsvaenda_nn_1_1_N : N ;
  oelflaska_nn_1_1_N : N ;
  oelstuga_nn_1_1_N : N ;
  oelsupa_nn_1_1_N : N ;
  oelaendska_nn_1_1_N : N ;
  oelaendska_nn_2_1_N : N ;
  oemkyla_nn_1_1_N : N ;
  oenskelista_nn_1_1_N : N ;
  oerlig_nn_1_1_N : N ;
  oerlog_nn_1_1_N : N ;
  oerlogsflagga_nn_1_1_N : N ;
  oernbraeken_nn_1_1_N : N ;
  oernnaesa_nn_1_1_N : N ;
  oeronmussla_nn_1_1_N : N ;
  oeronsnaecka_nn_1_1_N : N ;
  oertkrydda_nn_1_1_N : N ;
  oester_nn_1_1_N : N ;
  oestgotiska_nn_1_1_N : N ;
  oestgoetska_nn_1_1_N : N ;
  oestgoetska_nn_2_1_N : N ;
  oeverfralla_nn_1_1_N : N ;
  oeverklassflicka_nn_1_1_N : N ;
  oeverklasspraegel_nn_1_1_N : N ;
  oeverkucku_nn_1_1_N : N ;
  oeverleva_nn_1_1_N : N ;
  oeverlevnadsficka_nn_1_1_N : N ;
  oeverlevnadsfoermaaga_nn_1_1_N : N ;
  oevermaenniska_nn_1_1_N : N ;
  oevernit_nn_1_1_N : N ;
  oeverresa_nn_1_1_N : N ;
  oeversida_nn_1_1_N : N ;
  oeverskottsaanga_nn_1_1_N : N ;
  oeverskoeterska_nn_1_1_N : N ;
  oeverstrykningspenna_nn_1_1_N : N ;
  oevertalningsfoermaaga_nn_1_1_N : N ;
  oevertro_nn_1_1_N : N ;
  oevervakningskamera_nn_1_1_N : N ;
  Calzone_nn_1_N : N ;
  acne_nn_1_N : N ;
  akne_nn_1_N : N ;
  allmoge_nn_1_N : N ;
  anstiftelse_nn_1_N : N ;
  apokope_nn_1_N : N ;
  arbetarskyddsstyrelse_nn_1_N : N ;
  arbetsglaedje_nn_1_1_N : N ;
  arbetsmarknadsstyrelse_nn_1_N : N ;
  auktionsbridge_nn_1_N : N ;
  avlelse_nn_1_N : N ;
  bastuvaerme_nn_1_1_N : N ;
  bensoe_nn_1_N : N ;
  beraettarglaedje_nn_1_1_N : N ;
  beroemmelse_nn_1_1_N : N ;
  besique_nn_1_N : N ;
  bezique_nn_1_N : N ;
  blankooeverlaatelse_nn_1_1_N : N ;
  blaaelse_nn_1_1_N : N ;
  blaavaerme_nn_1_1_N : N ;
  borstnate_nn_1_N : N ;
  bortaende_nn_1_1_N : N ;
  bouillabaisse_nn_1_N : N ;
  boule_nn_1_N : N ;
  bourgeoisie_nn_1_N : N ;
  breakdance_nn_1_N : N ;
  bridge_nn_1_N : N ;
  calzone_nn_1_N : N ;
  carambole_nn_1_N : N ;
  centralvaerme_nn_1_1_N : N ;
  chamotte_nn_1_N : N ;
  charmeuse_nn_1_N : N ;
  clairvoyance_nn_1_N : N ;
  cre_me_de_la_cre_me_nn_1_1_N : N ;
  deadline_nn_1_N : N ;
  duchesse_nn_1_N : N ;
  d_etente_nn_1_1_N : N ;
  doepelse_nn_1_1_N : N ;
  eau_de_cologne_nn_1_N : N ;
  eau_de_toilette_nn_1_N : N ;
  eau_de_vie_nn_1_N : N ;
  eftermassage_nn_1_N : N ;
  efterraettelse_nn_1_1_N : N ;
  eftertanke_nn_1_N : N ;
  eftervaerme_nn_1_1_N : N ;
  egenroerelse_nn_1_1_N : N ;
  elvaerme_nn_1_1_N : N ;
  empire_nn_1_N : N ;
  festglaedje_nn_1_1_N : N ;
  fjaerrvaerme_nn_1_1_N : N ;
  flyghavre_nn_1_N : N ;
  folklore_nn_1_N : N ;
  frigoerelse_nn_1_1_N : N ;
  furore_nn_1_N : N ;
  faergskalle_nn_1_1_N : N ;
  foerargelse_nn_1_1_N : N ;
  foerbudslinje_nn_1_1_N : N ;
  foerdoemelse_nn_1_1_N : N ;
  foerfoerstaaelse_nn_1_1_N : N ;
  foergaengelse_nn_1_1_N : N ;
  foerintelse_nn_1_1_N : N ;
  foerkastelse_nn_1_1_N : N ;
  foerkrosselse_nn_1_1_N : N ;
  foerlaatelse_nn_1_1_N : N ;
  foerruttnelse_nn_1_1_N : N ;
  foerstockelse_nn_1_1_N : N ;
  foerstaaelse_nn_1_1_N : N ;
  foertappelse_nn_1_1_N : N ;
  foertrytelse_nn_1_1_N : N ;
  georgette_nn_1_N : N ;
  geovaerme_nn_1_1_N : N ;
  glace_nn_1_N : N ;
  glaedje_nn_1_1_N : N ;
  golvvaerme_nn_1_1_N : N ;
  grodnate_nn_1_N : N ;
  grunge_nn_1_N : N ;
  gruyere_nn_1_N : N ;
  groee_nn_1_1_N : N ;
  gaeddnate_nn_1_1_N : N ;
  hackelse_nn_1_N : N ;
  hardcore_nn_1_N : N ;
  havre_nn_1_N : N ;
  helgelse_nn_1_N : N ;
  herrgaardsallmoge_nn_1_1_N : N ;
  historiefoerstaaelse_nn_1_1_N : N ;
  hjaertmassage_nn_1_1_N : N ;
  hollandaise_nn_1_N : N ;
  house_nn_1_N : N ;
  haenfoerelse_nn_1_1_N : N ;
  haengivelse_nn_1_1_N : N ;
  haevdelse_nn_1_1_N : N ;
  image_nn_1_N : N ;
  inlevelse_nn_1_N : N ;
  jade_nn_1_N : N ;
  jordvaerme_nn_1_1_N : N ;
  juvermassage_nn_1_N : N ;
  kaffegraedde_nn_1_1_N : N ;
  karaoke_nn_1_N : N ;
  karate_nn_1_N : N ;
  kille_nn_2_N : N ;
  knylhavre_nn_1_N : N ;
  kontraktsbridge_nn_1_N : N ;
  krasse_nn_1_N : N ;
  kroppsvaerme_nn_1_1_N : N ;
  kryddkrasse_nn_1_N : N ;
  kultje_nn_1_N : N ;
  kundservice_nn_1_N : N ;
  kunskapslidelse_nn_1_N : N ;
  kvanne_nn_1_N : N ;
  kaeraste_nn_1_1_N : N ;
  lasagne_nn_1_N : N ;
  levnadsglaedje_nn_1_1_N : N ;
  livsande_nn_1_N : N ;
  livsbejakelse_nn_1_N : N ;
  livsglaedje_nn_1_1_N : N ;
  lomme_nn_1_N : N ;
  laesfoerstaaelse_nn_1_1_N : N ;
  Afghanistaninsats_nn_1_N : N ;
  BNP_tillvaext_nn_1_1_N : N ;
  Banverkspersonal_nn_1_N : N ;
  Bonnierkoncern_nn_1_N : N ;
  C_dur_nn_1_N : N ;
  Cointreau_nn_1_N : N ;
  EHEC_nn_1_N : N ;
  Gnosjoeanda_nn_1_1_N : N ;
  Greenwichmeridian_nn_1_N : N ;
  Hultsfredsfestival_nn_1_N : N ;
  Haargalaat_nn_1_1_N : N ;
  Kevlar_nn_1_N : N ;
  Kirunatrakt_nn_1_N : N ;
  Kleopatragestalt_nn_1_N : N ;
  Kramforstrakt_nn_1_N : N ;
  LKAB_konflikt_nn_1_N : N ;
  Mellanoesternkonflikt_nn_1_1_N : N ;
  Melodifestival_nn_1_N : N ;
  Miljoefoervaltning_nn_1_1_N : N ;
  Mississippiflod_nn_1_N : N ;
  Missouriflod_nn_1_N : N ;
  Moskvatrogenhet_nn_1_N : N ;
  Moskvavaenlighet_nn_1_1_N : N ;
  Newcastlesjuka_nn_1_N : N ;
  Newcastlesmitta_nn_1_N : N ;
  Sheratonstil_nn_1_N : N ;
  Sir_nn_1_N : N ;
  Skolinspektion_nn_1_N : N ;
  Stockholmsboers_nn_1_1_N : N ;
  Stockholmsregion_nn_1_N : N ;
  Stockholmstrakt_nn_1_N : N ;
  Straalsaekerhetsmyndighet_nn_1_1_N : N ;
  T_sprit_nn_1_N : N ;
  TV_reklam_nn_1_N : N ;
  Tokyoboers_nn_1_1_N : N ;
  USA_vaenlighet_nn_1_1_N : N ;
  Vaxholmskonflikt_nn_1_N : N ;
  Vietnampolitik_nn_1_N : N ;
  Vaerldsbank_nn_1_1_N : N ;
  Vaerldsnaturfond_nn_1_1_N : N ;
  Vaexjoetrakt_nn_1_1_N : N ;
  abandon_nn_1_N : N ;
  abstinens_nn_1_N : N ;
  abundans_nn_1_N : N ;
  acetylengas_nn_1_N : N ;
  ackordshets_nn_1_N : N ;
  ackuratess_nn_1_N : N ;
  action_nn_1_N : N ;
  adelskultur_nn_1_N : N ;
  administratoersstatus_nn_1_1_N : N ;
  adolescens_nn_1_N : N ;
  aerodynamik_nn_1_N : N ;
  aeronautik_nn_1_N : N ;
  affaersmoral_nn_1_1_N : N ;
  ag_nn_1_N : N ;
  aga_nn_1_N : N ;
  agnrost_nn_1_N : N ;
  agrikultur_nn_1_N : N ;
  aids_nn_1_N : N ;
  aikido_nn_1_N : N ;
  akrobatik_nn_1_N : N ;
  akryl_nn_1_N : N ;
  aktualism_nn_1_N : N ;
  aktualitetspress_nn_1_N : N ;
  akupunktur_nn_1_N : N ;
  akustik_nn_1_N : N ;
  akvaristik_nn_1_N : N ;
  alabaster_nn_1_N : N ;
  alarmism_nn_1_N : N ;
  alcantara_nn_1_N : N ;
  alfalfa_nn_1_N : N ;
  alkoholpolitik_nn_1_N : N ;
  allfader_nn_1_N : N ;
  allmaenanda_nn_1_1_N : N ;
  almsav_nn_1_N : N ;
  almsjuka_nn_1_N : N ;
  alpacka_nn_2_N : N ;
  alsikekloever_nn_1_1_N : N ;
  alunit_nn_1_N : N ;
  alv_nn_1_N : N ;
  alzheimer_nn_1_N : N ;
  ambivalens_nn_1_N : N ;
  ambra_nn_1_N : N ;
  ambrosia_nn_1_N : N ;
  ambulanspersonal_nn_1_N : N ;
  ammoniak_nn_1_N : N ;
  ammoniumklorid_nn_1_N : N ;
  analeptik_nn_1_N : N ;
  and_nn_2_N : N ;
  anda_nn_1_N : N ;
  andaktslitteratur_nn_1_N : N ;
  andtaeppa_nn_1_1_N : N ;
  angostura_nn_1_N : N ;
  anis_nn_1_N : N ;
  ankism_nn_1_N : N ;
  annatto_nn_1_N : N ;
  anorexihets_nn_1_N : N ;
  ans_nn_1_N : N ;
  anstoet_nn_1_1_N : N ;
  ansvarskaensla_nn_1_1_N : N ;
  antabus_nn_1_N : N ;
  antibiotikaresistens_nn_1_N : N ;
  antietablissemangsretorik_nn_1_N : N ;
  antik_nn_1_N : N ;
  antikrist_nn_1_N : N ;
  antikva_nn_1_N : N ;
  antimonglans_nn_1_N : N ;
  antiseptik_nn_1_N : N ;
  antracit_nn_1_N : N ;
  anus_nn_1_N : N ;
  apartheid_nn_1_N : N ;
  apatit_nn_1_N : N ;
  aplomb_nn_1_N : N ;
  apologetik_nn_1_N : N ;
  april_nn_1_N : N ;
  aptit_nn_1_N : N ;
  arbetsbrist_nn_1_N : N ;
  arbetsiver_nn_1_N : N ;
  arbetslust_nn_1_N : N ;
  arbetsmarknadspolitik_nn_1_N : N ;
  arbetsmarknadsstatistik_nn_1_N : N ;
  arbetsro_nn_1_N : N ;
  argot_nn_1_N : N ;
  argumentationsanalys_nn_1_N : N ;
  aritmetik_nn_1_N : N ;
  ark_nn_2_N : N ;
  arkitektonik_nn_1_N : N ;
  arkitekturpolitik_nn_1_N : N ;
  armagnac_nn_1_N : N ;
  arrak_nn_1_N : N ;
  arrakpunch_nn_1_N : N ;
  arrakpunsch_nn_1_N : N ;
  arrogans_nn_1_N : N ;
  arsenik_nn_1_N : N ;
  asbest_nn_1_N : N ;
  asbestos_nn_1_N : N ;
  aseptik_nn_1_N : N ;
  askes_nn_1_N : N ;
  astat_nn_1_N : N ;
  astma_nn_1_N : N ;
  astrofysik_nn_1_N : N ;
  atomfysik_nn_1_N : N ;
  atomkraft_nn_1_N : N ;
  attan_nn_1_N : N ;
  aubergin_nn_1_N : N ;
  augusti_nn_1_N : N ;
  aura_nn_1_N : N ;
  automatik_nn_1_N : N ;
  avdrift_nn_1_N : N ;
  avfoeda_nn_1_1_N : N ;
  avglans_nn_1_N : N ;
  aviatik_nn_1_N : N ;
  avkomst_nn_1_N : N ;
  avrad_nn_1_N : N ;
  avskraeckningspolitik_nn_1_1_N : N ;
  avund_nn_1_N : N ;
  avundsjuka_nn_1_N : N ;
  axsvingel_nn_1_N : N ;
  ayahuasca_nn_1_N : N ;
  azimut_nn_1_N : N ;
  baccarat_nn_1_N : N ;
  backanis_nn_1_N : N ;
  backhand_nn_1_N : N ;
  backpacking_nn_1_N : N ;
  backtimjan_nn_1_N : N ;
  bakelit_nn_1_N : N ;
  bakgrundsmusik_nn_1_N : N ;
  baksidesreklam_nn_1_N : N ;
  balata_nn_1_N : N ;
  ballistik_nn_1_N : N ;
  bambu_nn_1_N : N ;
  bane_nn_1_N : N ;
  bangolf_nn_1_N : N ;
  banverkspersonal_nn_1_N : N ;
  barfrost_nn_1_N : N ;
  barnfetma_nn_1_N : N ;
  barnporr_nn_1_N : N ;
  barnsaengsfeber_nn_1_1_N : N ;
  barock_nn_1_N : N ;
  barocklyrik_nn_1_N : N ;
  barockmusik_nn_1_N : N ;
  baryt_nn_1_N : N ;
  basalt_nn_1_N : N ;
  baseball_nn_1_N : N ;
  baseboll_nn_1_N : N ;
  basedow_nn_1_N : N ;
  basfoeda_nn_1_1_N : N ;
  basis_nn_1_N : N ;
  basket_nn_1_N : N ;
  basketboll_nn_1_N : N ;
  batik_nn_1_N : N ;
  batteridrift_nn_1_N : N ;
  batterield_nn_1_N : N ;
  batteriradio_nn_1_N : N ;
  bauxit_nn_1_N : N ;
  bebop_nn_1_N : N ;
  becherovka_nn_1_N : N ;
  befolkningspolitik_nn_1_N : N ;
  befolkningstillvaext_nn_1_1_N : N ;
  befaestningskonst_nn_1_1_N : N ;
  behagsjuka_nn_1_N : N ;
  beige_nn_1_N : N ;
  belladonna_nn_1_N : N ;
  bellit_nn_1_N : N ;
  belaegringskonst_nn_1_1_N : N ;
  benjamin_nn_1_N : N ;
  bensin_nn_1_N : N ;
  bensinbrist_nn_1_N : N ;
  bensol_nn_1_N : N ;
  bentuberkulos_nn_1_N : N ;
  bentyl_nn_1_N : N ;
  benved_nn_1_N : N ;
  berberis_nn_1_N : N ;
  besick_nn_1_N : N ;
  beska_nn_1_N : N ;
  beskaellaresjuka_nn_1_1_N : N ;
  beskaellarsjuka_nn_1_1_N : N ;
  beslutsaangest_nn_1_1_N : N ;
  betel_nn_1_N : N ;
  betygshets_nn_1_N : N ;
  betygsstress_nn_1_N : N ;
  bibelkritik_nn_1_N : N ;
  bilbingo_nn_1_N : N ;
  bilbransch_nn_1_N : N ;
  bildhuggarkonst_nn_1_N : N ;
  bildningstoerst_nn_1_1_N : N ;
  bildradio_nn_1_N : N ;
  bildskaerpa_nn_1_1_N : N ;
  biltrafik_nn_1_N : N ;
  bingo_nn_1_N : N ;
  bio_nn_1_N : N ;
  biodynamik_nn_1_N : N ;
  biofysik_nn_1_N : N ;
  biogenes_nn_1_N : N ;
  biografpublik_nn_1_N : N ;
  biomedicin_nn_1_N : N ;
  biorytm_nn_1_N : N ;
  bisam_nn_1_N : N ;
  bischoff_nn_1_N : N ;
  biskoetsel_nn_1_1_N : N ;
  bison_nn_1_N : N ;
  bistaandspolitik_nn_1_1_N : N ;
  bjaellerklang_nn_1_1_N : N ;
  bjoerkgraens_nn_1_1_N : N ;
  bjoerksav_nn_1_1_N : N ;
  bjoernmossa_nn_1_1_N : N ;
  bladkaal_nn_1_1_N : N ;
  bladmetall_nn_1_N : N ;
  bladrullsjuka_nn_1_N : N ;
  blandsaed_nn_1_1_N : N ;
  blankis_nn_1_N : N ;
  blanksvaerta_nn_1_1_N : N ;
  blankvers_nn_1_N : N ;
  blast_nn_1_N : N ;
  blastula_nn_1_N : N ;
  bleckmusik_nn_1_N : N ;
  blixthalka_nn_1_N : N ;
  blockchoklad_nn_1_N : N ;
  blockpolitik_nn_1_N : N ;
  blodbrist_nn_1_N : N ;
  blodcancer_nn_1_N : N ;
  blodfoerlust_nn_1_1_N : N ;
  blodhosta_nn_1_N : N ;
  blodkraefta_nn_1_1_N : N ;
  blodsmystik_nn_1_N : N ;
  blodsaenka_nn_1_1_N : N ;
  blodtoerst_nn_1_1_N : N ;
  blomkaal_nn_1_1_N : N ;
  blomst_nn_1_N : N ;
  blomvass_nn_1_N : N ;
  blues_nn_1_N : N ;
  blund_nn_1_N : N ;
  blygd_nn_1_N : N ;
  blyglans_nn_1_N : N ;
  blygsel_nn_1_N : N ;
  blymoenja_nn_1_1_N : N ;
  blysalva_nn_1_N : N ;
  blytetraetyl_nn_1_N : N ;
  blyaettika_nn_1_1_N : N ;
  blaabaerssoppa_nn_1_1_N : N ;
  blaaeld_nn_1_1_N : N ;
  blaais_nn_1_1_N : N ;
  blaakaal_nn_1_1_N : N ;
  blaalera_nn_1_1_N : N ;
  blaasjuka_nn_1_1_N : N ;
  blaast_nn_1_1_N : N ;
  blaataatel_nn_1_1_N : N ;
  blaaved_nn_1_1_N : N ;
  bloedarsjuka_nn_1_1_N : N ;
  bloeta_nn_1_1_N : N ;
  bloetsnoe_nn_1_1_N : N ;
  board_nn_1_N : N ;
  boccia_nn_1_N : N ;
  bockhornskloever_nn_1_1_N : N ;
  bokmakulatur_nn_1_N : N ;
  bokstavsmystik_nn_1_N : N ;
  boktryckarkonst_nn_1_N : N ;
  bomullstrikaa_nn_1_1_N : N ;
  bondkomik_nn_1_N : N ;
  bondaanger_nn_1_1_N : N ;
  bor_nn_1_N : N ;
  borax_nn_1_N : N ;
  bordtennis_nn_1_N : N ;
  borgarpress_nn_1_N : N ;
  borgis_nn_1_N : N ;
  bornyr_nn_1_N : N ;
  borsjtj_nn_1_N : N ;
  bortavaro_nn_1_N : N ;
  bortovaro_nn_1_N : N ;
  bortsida_nn_1_N : N ;
  boskapsdrift_nn_1_N : N ;
  boskapspest_nn_1_N : N ;
  boskapsskoetsel_nn_1_1_N : N ;
  bostadsbrist_nn_1_N : N ;
  bostadspolitik_nn_1_N : N ;
  boston_nn_1_N : N ;
  bot_nn_1_N : N ;
  botanik_nn_1_N : N ;
  bottenis_nn_1_N : N ;
  bottenmoraen_nn_1_1_N : N ;
  boulevardpress_nn_1_N : N ;
  bourbon_nn_1_N : N ;
  bowling_nn_1_N : N ;
  brakved_nn_1_N : N ;
  brandfara_nn_1_N : N ;
  bravur_nn_1_N : N ;
  bredsaadd_nn_1_1_N : N ;
  bresilja_nn_1_N : N ;
  brevcensur_nn_1_N : N ;
  briljans_nn_1_N : N ;
  brilliant_nn_1_N : N ;
  brio_nn_1_N : N ;
  bristningsgraens_nn_1_1_N : N ;
  britanniametall_nn_1_N : N ;
  brom_nn_1_N : N ;
  bromsservo_nn_1_N : N ;
  bromyl_nn_1_N : N ;
  bronkialastma_nn_1_N : N ;
  brottsjournalistik_nn_1_N : N ;
  brottskonkurrens_nn_1_N : N ;
  brudmystik_nn_1_N : N ;
  brukskonst_nn_1_N : N ;
  brunkaal_nn_1_1_N : N ;
  brunockra_nn_1_N : N ;
  brunrost_nn_1_N : N ;
  brunst_nn_1_N : N ;
  bryggdans_nn_1_N : N ;
  bryggerijaest_nn_1_1_N : N ;
  bryggjaest_nn_1_1_N : N ;
  brysselkaal_nn_1_1_N : N ;
  brytningsgraens_nn_1_1_N : N ;
  braenslebrist_nn_1_1_N : N ;
  braadska_nn_1_1_N : N ;
  broedfoeda_nn_1_1_N : N ;
  broedsaed_nn_1_1_N : N ;
  broedtext_nn_1_1_N : N ;
  broestmjoelk_nn_1_1_N : N ;
  buckram_nn_1_N : N ;
  budgetdisciplin_nn_1_N : N ;
  budgetpolitik_nn_1_N : N ;
  budo_nn_1_N : N ;
  bugg_nn_1_N : N ;
  bukfetma_nn_1_N : N ;
  bukfylla_nn_1_N : N ;
  bulk_nn_1_N : N ;
  bush_nn_1_N : N ;
  buskis_nn_1_N : N ;
  buskteater_nn_1_N : N ;
  busstrafik_nn_1_N : N ;
  butanol_nn_1_N : N ;
  butylalkohol_nn_1_N : N ;
  byggnadskonst_nn_1_N : N ;
  bytesbalans_nn_1_N : N ;
  byxaangest_nn_1_1_N : N ;
  baeltros_nn_1_1_N : N ;
  baenkpress_nn_1_1_N : N ;
  baerkraft_nn_1_1_N : N ;
  baestsaeljarism_nn_1_1_N : N ;
  baattrafik_nn_1_1_N : N ;
  boeldpest_nn_1_1_N : N ;
  calypso_nn_1_N : N ;
  camembert_nn_1_N : N ;
  canasta_nn_1_N : N ;
  cancan_nn_1_N : N ;
  cannabis_nn_1_N : N ;
  casting_nn_1_N : N ;
  catering_nn_1_N : N ;
  cateringbransch_nn_1_N : N ;
  catgut_nn_1_N : N ;
  celebritetsjournalistik_nn_1_N : N ;
  cellini_nn_1_N : N ;
  cellulas_nn_1_N : N ;
  celluloid_nn_1_N : N ;
  cellulosa_nn_1_N : N ;
  cellulosavadd_nn_1_N : N ;
  celsiusskala_nn_1_N : N ;
  censur_nn_1_N : N ;
  centercourt_nn_1_N : N ;
  centrallyrik_nn_1_N : N ;
  centralradio_nn_1_N : N ;
  centrecourt_nn_1_N : N ;
  cha_cha_nn_1_N : N ;
  chark_nn_1_N : N ;
  charleston_nn_1_N : N ;
  charm_nn_1_N : N ;
  charta_nn_1_N : N ;
  charter_nn_1_N : N ;
  cherimoya_nn_1_N : N ;
  chevreau_nn_1_N : N ;
  chilesalpeter_nn_1_N : N ;
  chilisaas_nn_1_1_N : N ;
  chimping_nn_1_N : N ;
  chintz_nn_1_N : N ;
  cicero_nn_1_N : N ;
  cider_nn_1_N : N ;
  cikoria_nn_1_N : N ;
  cinnober_nn_1_N : N ;
  cirrus_nn_1_N : N ;
  citronmeliss_nn_1_N : N ;
  citronsorbet_nn_1_N : N ;
  civilfoersvarspersonal_nn_1_1_N : N ;
  clearing_nn_1_N : N ;
  clinch_nn_1_N : N ;
  clou_nn_1_N : N ;
  cocktailmusik_nn_1_N : N ;
  cointreau_nn_1_N : N ;
  coitus_nn_1_N : N ;
  consensus_nn_1_N : N ;
  copyright_nn_1_N : N ;
  cortex_nn_1_N : N ;
  cotangens_nn_1_N : N ;
  countrymusik_nn_1_N : N ;
  crawl_nn_1_N : N ;
  cred_nn_1_N : N ;
  credd_nn_1_N : N ;
  creme_nn_2_N : N ;
  cricket_nn_1_N : N ;
  crust_nn_1_N : N ;
  cre_me_nn_2_1_N : N ;
  csardas_nn_1_N : N ;
  curacao_nn_1_1_N : N ;
  curling_nn_1_N : N ;
  cyanos_nn_1_N : N ;
  cybernetik_nn_1_N : N ;
  cyklamat_nn_1_N : N ;
  dagg_nn_1_N : N ;
  dagsmeja_nn_1_N : N ;
  dagspress_nn_1_N : N ;
  dalskida_nn_1_N : N ;
  damslalom_nn_1_N : N ;
  dansmusik_nn_1_N : N ;
  danssjuka_nn_1_N : N ;
  dart_nn_1_N : N ;
  datakraft_nn_1_N : N ;
  datalingvistik_nn_1_N : N ;
  datapolitik_nn_1_N : N ;
  datavision_nn_1_N : N ;
  datordrift_nn_1_N : N ;
  datorlingvistik_nn_1_N : N ;
  datten_nn_1_N : N ;
  december_nn_1_N : N ;
  defensiv_nn_1_N : N ;
  deg_nn_2_N : N ;
  dekadans_nn_1_N : N ;
  dekadens_nn_1_N : N ;
  dekalog_nn_1_N : N ;
  dekanus_nn_1_N : N ;
  dekorglans_nn_1_N : N ;
  dekorputs_nn_1_N : N ;
  demens_nn_1_N : N ;
  demi_sec_nn_1_N : N ;
  descendens_nn_1_N : N ;
  design_nn_1_N : N ;
  detaljskaerpa_nn_1_1_N : N ;
  diagnostik_nn_1_N : N ;
  dialektik_nn_1_N : N ;
  dialogpedagogik_nn_1_N : N ;
  diaspora_nn_1_N : N ;
  didaktik_nn_1_N : N ;
  dietetik_nn_1_N : N ;
  dietik_nn_1_N : N ;
  digitalis_nn_1_N : N ;
  diktan_nn_1_N : N ;
  diktkonst_nn_1_N : N ;
  dill_nn_1_N : N ;
  dimfrost_nn_1_N : N ;
  dioptrik_nn_1_N : N ;
  diplomatik_nn_1_N : N ;
  diplomatpost_nn_1_N : N ;
  dipmix_nn_1_N : N ;
  direktreklam_nn_1_N : N ;
  disciplinstress_nn_1_N : N ;
  disco_nn_2_N : N ;
  discomusik_nn_1_N : N ;
  disko_nn_2_N : N ;
  diskomusik_nn_1_N : N ;
  dixieland_nn_1_N : N ;
  djupkultur_nn_1_N : N ;
  djurhaelsa_nn_1_1_N : N ;
  djurkrets_nn_1_N : N ;
  djurmat_nn_1_N : N ;
  djurornamentik_nn_1_N : N ;
  djurskoetsel_nn_1_1_N : N ;
  dogmatik_nn_1_N : N ;
  dominans_nn_1_N : N ;
  domvaerjo_nn_1_1_N : N ;
  don_nn_2_N : N ;
  doping_nn_1_N : N ;
  dopplereffekt_nn_1_N : N ;
  dragkraft_nn_1_N : N ;
  dragracing_nn_1_N : N ;
  dragspelsmusik_nn_1_N : N ;
  dram_nn_1_N : N ;
  dramatik_nn_1_N : N ;
  drank_nn_1_N : N ;
  dricks_nn_1_N : N ;
  drift_nn_1_N : N ;
  drivhuseffekt_nn_1_N : N ;
  drivis_nn_1_N : N ;
  drivsand_nn_1_N : N ;
  drivsnoe_nn_1_1_N : N ;
  drivved_nn_1_N : N ;
  drygsel_nn_1_N : N ;
  draegg_nn_1_1_N : N ;
  draell_nn_1_1_N : N ;
  draetsel_nn_1_1_N : N ;
  droeppel_nn_1_1_N : N ;
  dualis_nn_1_N : N ;
  dubbelmoral_nn_1_N : N ;
  dubbeltimma_nn_1_N : N ;
  dur_nn_1_N : N ;
  duvpolitik_nn_1_N : N ;
  dvala_nn_1_N : N ;
  dvaergvaext_nn_1_1_N : N ;
  dygnsvila_nn_1_N : N ;
  dykarsjuka_nn_1_N : N ;
  dynamik_nn_1_N : N ;
  dynamit_nn_1_N : N ;
  dynga_nn_1_N : N ;
  daeckglans_nn_1_1_N : N ;
  daan_nn_2_1_N : N ;
  doedis_nn_1_1_N : N ;
  doedsjoe_nn_1_1_N : N ;
  doedsmetal_nn_1_1_N : N ;
  doedsmetall_nn_1_1_N : N ;
  doedsskugga_nn_1_1_N : N ;
  doedsaangest_nn_1_1_N : N ;
  e_mail_nn_1_N : N ;
  ebb_nn_1_N : N ;
  ebonit_nn_1_N : N ;
  edelweiss_nn_1_N : N ;
  efterglans_nn_1_N : N ;
  efterkultur_nn_1_N : N ;
  eftermiddagstrafik_nn_1_N : N ;
  efterputs_nn_1_N : N ;
  eftervaext_nn_1_1_N : N ;
  egard_nn_1_N : N ;
  egid_nn_1_N : N ;
  egyptienne_nn_1_N : N ;
  ehec_nn_1_N : N ;
  eidetik_nn_1_N : N ;
  ekliptika_nn_1_N : N ;
  ekonomiklass_nn_1_N : N ;
  ekonomipersonal_nn_1_N : N ;
  ekumenik_nn_1_N : N ;
  ekvidistans_nn_1_N : N ;
  ekvilibristik_nn_1_N : N ;
  ekvivalens_nn_1_N : N ;
  eld_nn_1_N : N ;
  eld_nn_3_N : N ;
  elddisciplin_nn_1_N : N ;
  eldfara_nn_1_N : N ;
  eldrift_nn_1_N : N ;
  elefantsjuka_nn_1_N : N ;
  elegans_nn_1_N : N ;
  elektroakustik_nn_1_N : N ;
  elektrodynamik_nn_1_N : N ;
  elektrofores_nn_1_N : N ;
  elektrofysik_nn_1_N : N ;
  elektronik_nn_1_N : N ;
  elektrostatik_nn_1_N : N ;
  elektroteknik_nn_1_N : N ;
  elementaranalys_nn_1_N : N ;
  elfenbenssvaerta_nn_1_1_N : N ;
  elitgymnastik_nn_1_N : N ;
  elmotordrift_nn_1_N : N ;
  elokvens_nn_1_N : N ;
  eloquentia_nn_1_N : N ;
  elvaaarsgraens_nn_1_1_N : N ;
  email_nn_1_N : N ;
  emblematik_nn_1_N : N ;
  embonpoint_nn_1_N : N ;
  emfas_nn_1_N : N ;
  emmentaler_nn_1_N : N ;
  empir_nn_1_N : N ;
  energipolitik_nn_1_N : N ;
  engaangsnatur_nn_1_1_N : N ;
  enhetsskola_nn_1_N : N ;
  enkeltimma_nn_1_N : N ;
  enmansteater_nn_1_N : N ;
  entusiasm_nn_1_N : N ;
  epigrafik_nn_1_N : N ;
  epik_nn_1_N : N ;
  episkopalkyrka_nn_1_N : N ;
  erkaensla_nn_1_1_N : N ;
  erotik_nn_1_N : N ;
  esparto_nn_1_N : N ;
  espresso_nn_1_N : N ;
  esprit_nn_1_N : N ;
  essens_nn_1_N : N ;
  essaeistik_nn_1_1_N : N ;
  estetik_nn_1_N : N ;
  etanol_nn_1_N : N ;
  etenplast_nn_1_N : N ;
  etik_nn_1_N : N ;
  etyl_nn_1_N : N ;
  etylalkohol_nn_1_N : N ;
  eugenik_nn_1_N : N ;
  eukalyptus_nn_1_N : N ;
  euroislam_nn_1_N : N ;
  eurovaluta_nn_1_N : N ;
  evidens_nn_1_N : N ;
  exeges_nn_1_N : N ;
  exegetik_nn_1_N : N ;
  exil_nn_1_N : N ;
  exoftalmus_nn_1_N : N ;
  expertis_nn_1_N : N ;
  exportsprit_nn_1_N : N ;
  exspektans_nn_1_N : N ;
  extas_nn_1_N : N ;
  extrapersonal_nn_1_N : N ;
  extremhoeger_nn_1_1_N : N ;
  extremvaenster_nn_1_1_N : N ;
  facklitteratur_nn_1_N : N ;
  fackpress_nn_1_N : N ;
  factoring_nn_1_N : N ;
  fading_nn_1_N : N ;
  faktur_nn_1_N : N ;
  falerner_nn_1_N : N ;
  fallandesjuka_nn_1_N : N ;
  fallfara_nn_1_N : N ;
  falsett_nn_1_N : N ;
  familjekaensla_nn_1_1_N : N ;
  familjepolitik_nn_1_N : N ;
  fanken_nn_1_N : N ;
  fantastik_nn_1_N : N ;
  fartygstrafik_nn_1_N : N ;
  fasen_nn_1_N : N ;
  fasingen_nn_1_N : N ;
  faunistik_nn_1_N : N ;
  feberhetta_nn_1_N : N ;
  februari_nn_1_N : N ;
  feedback_nn_1_N : N ;
  femkort_nn_1_N : N ;
  fetaost_nn_1_N : N ;
  fetma_nn_1_N : N ;
  fiberoptik_nn_1_N : N ;
  fickparkerbarhet_nn_1_N : N ;
  fiction_nn_1_N : N ;
  figurlighet_nn_1_N : N ;
  fikenhet_nn_1_N : N ;
  fil_nn_3_N : N ;
  filerbarhet_nn_1_N : N ;
  filering_nn_2_N : N ;
  filler_nn_1_N : N ;
  filmatiserbarhet_nn_1_N : N ;
  filmcensur_nn_1_N : N ;
  filmjoelk_nn_1_1_N : N ;
  filmmusik_nn_1_N : N ;
  filtrerbarhet_nn_1_N : N ;
  finansierbarhet_nn_1_N : N ;
  finanspolitik_nn_1_N : N ;
  finansraett_nn_1_1_N : N ;
  fingerbarhet_nn_1_N : N ;
  fingerfaerdighet_nn_1_1_N : N ;
  fingerkrok_nn_1_N : N ;
  fingertoppskaensla_nn_1_1_N : N ;
  finhet_nn_1_N : N ;
  finhyllthet_nn_1_N : N ;
  finjusterbarhet_nn_1_N : N ;
  finkalibrighet_nn_1_N : N ;
  finkel_nn_1_N : N ;
  finklaeddhet_nn_1_1_N : N ;
  finkornighet_nn_1_N : N ;
  finkultur_nn_1_N : N ;
  finlandiserbarhet_nn_1_N : N ;
  finmaskighet_nn_1_N : N ;
  finmat_nn_1_N : N ;
  finmotorik_nn_1_N : N ;
  finnighet_nn_1_N : N ;
  finputs_nn_1_N : N ;
  finsprit_nn_1_N : N ;
  finstil_nn_1_N : N ;
  finstaemdhet_nn_1_1_N : N ;
  fipplighet_nn_1_N : N ;
  firn_nn_1_N : N ;
  fisfoernaemhet_nn_1_1_N : N ;
  fiskdoed_nn_1_1_N : N ;
  fiskevaard_nn_1_1_N : N ;
  fisklikhet_nn_1_N : N ;
  fisktomhet_nn_1_N : N ;
  fixerbarhet_nn_1_N : N ;
  fixhet_nn_1_N : N ;
  fjantighet_nn_1_N : N ;
  fjantstaempel_nn_1_1_N : N ;
  fjompighet_nn_1_N : N ;
  fjuttighet_nn_1_N : N ;
  fjaederlaetthet_nn_1_1_N : N ;
  fjaedervikt_nn_1_1_N : N ;
  fjaedringskapacitet_nn_1_1_N : N ;
  fjaellighet_nn_1_1_N : N ;
  fjaellikhet_nn_1_1_N : N ;
  fjaellnatur_nn_1_1_N : N ;
  fjaelluft_nn_1_1_N : N ;
  fjaerhet_nn_1_1_N : N ;
  fjaerilseffekt_nn_1_1_N : N ;
  fjaerrblockerbarhet_nn_1_1_N : N ;
  fjaerrtrafik_nn_1_1_N : N ;
  fjaeskighet_nn_1_1_N : N ;
  flabbighet_nn_1_N : N ;
  flackeld_nn_1_N : N ;
  flackhet_nn_1_N : N ;
  fladdrighet_nn_1_N : N ;
  flagg_nn_1_N : N ;
  flaggduk_nn_1_N : N ;
  flamberbarhet_nn_1_N : N ;
  flammighet_nn_1_N : N ;
  flamsighet_nn_1_N : N ;
  flamskhet_nn_1_N : N ;
  flankerbarhet_nn_1_N : N ;
  flaskbrist_nn_1_N : N ;
  flaskpost_nn_1_N : N ;
  flathet_nn_1_N : N ;
  flatterbarhet_nn_1_N : N ;
  flaxighet_nn_1_N : N ;
  flegma_nn_1_N : N ;
  flekterbarhet_nn_1_N : N ;
  flensost_nn_1_N : N ;
  flercellighet_nn_1_N : N ;
  flerspraakighet_nn_1_1_N : N ;
  flerstaemmighet_nn_1_1_N : N ;
  flertydighet_nn_1_N : N ;
  flexibilitet_nn_1_N : N ;
  flickaktighet_nn_1_N : N ;
  flikighet_nn_1_N : N ;
  flimrighet_nn_1_N : N ;
  flinkhet_nn_1_N : N ;
  flint_nn_1_N : N ;
  flintskallighet_nn_1_N : N ;
  flirt_nn_1_N : N ;
  flirtighet_nn_1_N : N ;
  flisighet_nn_1_N : N ;
  flit_nn_1_N : N ;
  flockighet_nn_1_N : N ;
  floristik_nn_1_N : N ;
  flotthet_nn_1_N : N ;
  flottighet_nn_1_N : N ;
  flugvikt_nn_1_N : N ;
  fluidiserbarhet_nn_1_N : N ;
  flummighet_nn_1_N : N ;
  flumpedagogik_nn_1_N : N ;
  fluorerbarhet_nn_1_N : N ;
  fluorescens_nn_1_N : N ;
  fluoriderbarhet_nn_1_N : N ;
  flusspat_nn_1_N : N ;
  flyfotadhet_nn_1_N : N ;
  flygbensin_nn_1_N : N ;
  flygfaerdighet_nn_1_1_N : N ;
  flygghet_nn_1_N : N ;
  flygpersonal_nn_1_N : N ;
  flygplansluft_nn_1_N : N ;
  flygpost_nn_1_N : N ;
  flygsand_nn_1_N : N ;
  flygsaekerhet_nn_1_1_N : N ;
  flygtrafik_nn_1_N : N ;
  flyhaenthet_nn_1_1_N : N ;
  flykt_nn_2_N : N ;
  flyktfara_nn_1_N : N ;
  flyktighet_nn_1_N : N ;
  flyktingpolitik_nn_1_N : N ;
  flythjaelp_nn_1_1_N : N ;
  flytjord_nn_1_N : N ;
  flytsand_nn_1_N : N ;
  flyttbarhet_nn_1_N : N ;
  flyttlasspolitik_nn_1_N : N ;
  flytungadhet_nn_1_N : N ;
  flaeckfeber_nn_1_1_N : N ;
  flaeckfrihet_nn_1_1_N : N ;
  flaeckighet_nn_1_1_N : N ;
  flaecktyfus_nn_1_1_N : N ;
  flaedermaerg_nn_1_1_N : N ;
  flaenghet_nn_1_1_N : N ;
  flaengighet_nn_1_1_N : N ;
  flaerd_nn_1_1_N : N ;
  flaerdfrihet_nn_1_1_N : N ;
  flaeskighet_nn_1_1_N : N ;
  floertighet_nn_1_1_N : N ;
  fnatt_nn_1_N : N ;
  fnissighet_nn_1_N : N ;
  fnittrighet_nn_1_N : N ;
  fodersaed_nn_1_1_N : N ;
  foglighet_nn_1_N : N ;
  fokuserbarhet_nn_1_N : N ;
  folierbarhet_nn_1_N : N ;
  folio_nn_1_N : N ;
  folkfoersoerjning_nn_1_1_N : N ;
  folkhaelsa_nn_1_1_N : N ;
  folkilskenhet_nn_1_N : N ;
  folkkonst_nn_1_N : N ;
  folkloristik_nn_1_N : N ;
  folkmakt_nn_1_N : N ;
  folkmedicin_nn_1_N : N ;
  folkmusik_nn_1_N : N ;
  folkrikhet_nn_1_N : N ;
  folkraett_nn_1_1_N : N ;
  folkskygghet_nn_1_N : N ;
  folktandvaard_nn_1_1_N : N ;
  folkteater_nn_1_N : N ;
  folktomhet_nn_1_N : N ;
  folkton_nn_1_N : N ;
  folktraengsel_nn_1_1_N : N ;
  folkundervisning_nn_1_N : N ;
  folkupplysning_nn_1_N : N ;
  folkvandringstid_nn_1_N : N ;
  fonderbarhet_nn_1_N : N ;
  fondmaeklarbransch_nn_1_1_N : N ;
  fonetik_nn_1_N : N ;
  foniatrik_nn_1_N : N ;
  forcerbarhet_nn_1_N : N ;
  fordringsfullhet_nn_1_N : N ;
  forehand_nn_1_N : N ;
  form_nn_3_N : N ;
  formaliserbarhet_nn_1_N : N ;
  formbarhet_nn_1_N : N ;
  formbundenhet_nn_1_N : N ;
  formerbarhet_nn_1_N : N ;
  formlighet_nn_1_N : N ;
  formloeshet_nn_1_1_N : N ;
  formmaessighet_nn_1_1_N : N ;
  formrikhet_nn_1_N : N ;
  formsand_nn_1_N : N ;
  formskoenhet_nn_1_1_N : N ;
  formula_nn_1_N : N ;
  formulerbarhet_nn_1_N : N ;
  fornforskning_nn_1_N : N ;
  fornhet_nn_1_N : N ;
  fornkunskap_nn_1_N : N ;
  forskarvaerld_nn_1_1_N : N ;
  forskningspolitik_nn_1_N : N ;
  fortfaerdighet_nn_1_1_N : N ;
  fortgaang_nn_1_1_N : N ;
  fortvaro_nn_1_N : N ;
  fosfaterbarhet_nn_1_N : N ;
  fosforescens_nn_1_N : N ;
  fossilbransch_nn_1_N : N ;
  fossilfoersaeljning_nn_1_1_N : N ;
  fossilgas_nn_1_N : N ;
  fossiliserbarhet_nn_1_N : N ;
  fosterjord_nn_1_N : N ;
  fosterlandskaerlek_nn_1_1_N : N ;
  fosterlaendskhet_nn_1_1_N : N ;
  fosterstaellning_nn_1_1_N : N ;
  fotboll_nn_1_N : N ;
  fotbollsfeber_nn_1_N : N ;
  fotograferbarhet_nn_1_N : N ;
  fotografik_nn_1_N : N ;
  fotokonst_nn_1_N : N ;
  fotokopierbarhet_nn_1_N : N ;
  fotostatkopierbarhet_nn_1_N : N ;
  fotriktighet_nn_1_N : N ;
  fotsvett_nn_1_N : N ;
  fottvagning_nn_1_N : N ;
  fotvaenlighet_nn_1_1_N : N ;
  fotvaard_nn_1_1_N : N ;
  foulard_nn_1_N : N ;
  foxtrottakt_nn_1_N : N ;
  fradga_nn_1_N : N ;
  fragmenterbarhet_nn_1_N : N ;
  fragmentering_nn_1_N : N ;
  fragmentisering_nn_1_N : N ;
  fraktionerbarhet_nn_1_N : N ;
  fraktur_nn_1_N : N ;
  framdrivning_nn_1_N : N ;
  framfart_nn_1_N : N ;
  framfusighet_nn_1_N : N ;
  framgaangsrikhet_nn_1_1_N : N ;
  framkomst_nn_1_N : N ;
  framstegsanda_nn_1_N : N ;
  framstegsvaenlighet_nn_1_1_N : N ;
  framstaellningskonst_nn_1_1_N : N ;
  framsynthet_nn_1_N : N ;
  framtunghet_nn_1_N : N ;
  framvaext_nn_1_1_N : N ;
  framaatanda_nn_1_1_N : N ;
  franchising_nn_1_N : N ;
  frangulabark_nn_1_N : N ;
  frankerbarhet_nn_1_N : N ;
  frankhet_nn_1_N : N ;
  fransighet_nn_1_N : N ;
  franskhet_nn_1_N : N ;
  franskspraakighet_nn_1_1_N : N ;
  franskundervisning_nn_1_N : N ;
  fraserbarhet_nn_1_N : N ;
  fredlighet_nn_1_N : N ;
  fredloeshet_nn_1_1_N : N ;
  fredsplikt_nn_1_N : N ;
  fredsvaenlighet_nn_1_1_N : N ;
  frejd_nn_1_N : N ;
  frejdighet_nn_1_N : N ;
  frekvensmodulerbarhet_nn_1_N : N ;
  frekventerbarhet_nn_1_N : N ;
  fridfullhet_nn_1_N : N ;
  fridloeshet_nn_1_1_N : N ;
  fridsamhet_nn_1_N : N ;
  frifraesighet_nn_1_1_N : N ;
  frigaang_nn_1_1_N : N ;
  frihetlighet_nn_1_N : N ;
  frihetstid_nn_1_N : N ;
  frikostighet_nn_1_N : N ;
  friktionsvaexling_nn_1_1_N : N ;
  frilanstillvaro_nn_1_N : N ;
  frimodighet_nn_1_N : N ;
  fris_nn_2_N : N ;
  friserbarhet_nn_1_N : N ;
  friskhet_nn_1_N : N ;
  friskluft_nn_1_N : N ;
  friskluftsventilation_nn_1_N : N ;
  frisksport_nn_1_N : N ;
  friskvaard_nn_1_1_N : N ;
  fristil_nn_1_N : N ;
  friterbarhet_nn_1_N : N ;
  fritid_nn_1_N : N ;
  fritidspolitik_nn_1_N : N ;
  frivilligtjaenst_nn_1_1_N : N ;
  frivaard_nn_1_1_N : N ;
  frodighet_nn_1_N : N ;
  fromhet_nn_2_N : N ;
  fromhetsiver_nn_1_N : N ;
  fromsinthet_nn_1_N : N ;
  fronderbarhet_nn_1_N : N ;
  frontnederboerd_nn_1_1_N : N ;
  fronttjaenst_nn_1_1_N : N ;
  frost_nn_1_N : N ;
  frostighet_nn_1_N : N ;
  frosttaalighet_nn_1_1_N : N ;
  frotterbarhet_nn_1_N : N ;
  fruktansvaerdhet_nn_1_1_N : N ;
  fruktighet_nn_1_N : N ;
  fruktloeshet_nn_1_1_N : N ;
  fruktos_nn_1_N : N ;
  fruktsamhet_nn_1_N : N ;
  fruktskorv_nn_1_N : N ;
  fruktved_nn_1_N : N ;
  fruntimmersvecka_nn_1_N : N ;
  frusenhet_nn_1_N : N ;
  frustrerbarhet_nn_1_N : N ;
  frystejp_nn_1_N : N ;
  frystaalighet_nn_1_1_N : N ;
  fraeknighet_nn_1_1_N : N ;
  fraelsthet_nn_1_1_N : N ;
  fraemlingsfientlighet_nn_1_1_N : N ;
  fraenhet_nn_1_1_N : N ;
  fraeschhet_nn_1_1_N : N ;
  fraeschoer_nn_1_1_N : N ;
  fraagvishet_nn_1_1_N : N ;
  fraandockning_nn_1_1_N : N ;
  fraanskiljning_nn_1_1_N : N ;
  fraanvaro_nn_1_1_N : N ;
  froejdefullhet_nn_1_1_N : N ;
  fugu_nn_1_N : N ;
  fukt_nn_1_N : N ;
  fullfoeljd_nn_1_1_N : N ;
  fullgodhet_nn_1_N : N ;
  fullgaangenhet_nn_1_1_N : N ;
  fullhet_nn_1_N : N ;
  fullmogenhet_nn_1_N : N ;
  fullproppning_nn_1_N : N ;
  fullskalighet_nn_1_N : N ;
  fullstaemmighet_nn_1_1_N : N ;
  fulltalighet_nn_1_N : N ;
  fulltonighet_nn_1_N : N ;
  fullvuxenhet_nn_1_N : N ;
  fullvaerdighet_nn_1_1_N : N ;
  fulsnygghet_nn_1_N : N ;
  fundersamhet_nn_1_N : N ;
  funk_nn_1_N : N ;
  funkis_nn_1_N : N ;
  funktionsduglighet_nn_1_N : N ;
  funktionsoduglighet_nn_1_N : N ;
  fur_nn_1_N : N ;
  furnerbarhet_nn_1_N : N ;
  furor_nn_1_N : N ;
  furst_nn_1_N : N ;
  fusionerbarhet_nn_1_N : N ;
  fyllighet_nn_1_N : N ;
  fyndjakt_nn_1_N : N ;
  fyraprocentsspaerr_nn_1_1_N : N ;
  fyrdelning_nn_1_N : N ;
  fyrdubbling_nn_1_N : N ;
  fyrfilighet_nn_1_N : N ;
  fyrgradighet_nn_1_N : N ;
  fyrhjulighet_nn_1_N : N ;
  fyrkloever_nn_1_1_N : N ;
  fysik_nn_1_N : N ;
  fysiljerbarhet_nn_1_N : N ;
  faeaktighet_nn_1_1_N : N ;
  faelb_nn_1_1_N : N ;
  faelgrengoering_nn_1_1_N : N ;
  faelgtvaett_nn_1_1_N : N ;
  faellbarhet_nn_1_1_N : N ;
  faeltmaessighet_nn_1_1_N : N ;
  faeltpost_nn_1_1_N : N ;
  faeltpostcensur_nn_1_1_N : N ;
  faelttjaenst_nn_1_1_N : N ;
  faenkaal_nn_1_1_N : N ;
  faerdigjaesning_nn_1_1_N : N ;
  faerdigmat_nn_1_1_N : N ;
  faerdkost_nn_1_1_N : N ;
  faerdtjaenst_nn_1_1_N : N ;
  faergbehandling_nn_1_1_N : N ;
  faergbestaendighet_nn_1_1_N : N ;
  faergblindhet_nn_1_1_N : N ;
  faergborttagning_nn_1_1_N : N ;
  faergglans_nn_1_1_N : N ;
  faerggrannhet_nn_1_1_N : N ;
  faergkonstans_nn_1_1_N : N ;
  faergloeshet_nn_1_1_N : N ;
  faergprakt_nn_1_1_N : N ;
  faergrikedom_nn_1_1_N : N ;
  faergrikhet_nn_1_1_N : N ;
  faergsprutning_nn_1_1_N : N ;
  faergstarkhet_nn_1_1_N : N ;
  faerjetrafik_nn_1_1_N : N ;
  faernbock_nn_1_1_N : N ;
  faerserbarhet_nn_1_1_N : N ;
  faerskhet_nn_1_1_N : N ;
  faerskmat_nn_1_1_N : N ;
  faafaenga_nn_1_1_N : N ;
  faafaenghet_nn_1_1_N : N ;
  faagelkunnighet_nn_1_1_N : N ;
  faagelmat_nn_1_1_N : N ;
  faagelsaang_nn_1_1_N : N ;
  faageltraeck_nn_1_1_N : N ;
  faaglalaat_nn_1_1_N : N ;
  faakunnighet_nn_1_1_N : N ;
  faamaeldhet_nn_1_1_N : N ;
  faang_nn_2_1_N : N ;
  faangenskap_nn_1_1_N : N ;
  faangvaard_nn_1_1_N : N ;
  faaordighet_nn_1_1_N : N ;
  faaraktighet_nn_1_1_N : N ;
  faarsvingel_nn_1_1_N : N ;
  faarull_nn_1_1_N : N ;
  faatalighet_nn_1_1_N : N ;
  faavitskhet_nn_1_1_N : N ;
  foeda_nn_1_1_N : N ;
  foehn_nn_1_1_N : N ;
  foeljdenlighet_nn_1_1_N : N ;
  foeljdriktighet_nn_1_1_N : N ;
  foen_nn_1_1_N : N ;
  foensterputs_nn_1_1_N : N ;
  foensterputsning_nn_1_1_N : N ;
  foerannonserbarhet_nn_1_1_N : N ;
  foerbehaallsloeshet_nn_1_1_N : N ;
  foerbindlighet_nn_1_1_N : N ;
  foerbjudenhet_nn_1_1_N : N ;
  foerbudslagstiftning_nn_1_1_N : N ;
  foerbundenhet_nn_1_1_N : N ;
  foerbundsark_nn_1_1_N : N ;
  foerbaetterlighet_nn_1_1_N : N ;
  foerdelaktighet_nn_1_1_N : N ;
  foerdelningspolitik_nn_1_1_N : N ;
  foerdoldhet_nn_1_1_N : N ;
  foerdomsfrihet_nn_1_1_N : N ;
  foerdragenhet_nn_1_1_N : N ;
  foerdunstning_nn_1_1_N : N ;
  foerdaervlighet_nn_1_1_N : N ;
  foerdoemdhet_nn_1_1_N : N ;
  foerdoemlighet_nn_1_1_N : N ;
  foerebildlighet_nn_1_1_N : N ;
  foeredoemlighet_nn_1_1_N : N ;
  foerefintlighet_nn_1_1_N : N ;
  foereningsraett_nn_1_1_N : N ;
  foeretagaranda_nn_1_1_N : N ;
  foeretagsbot_nn_1_1_N : N ;
  foeretagshaelsovaard_nn_1_1_N : N ;
  foeretagstaethet_nn_1_1_N : N ;
  foeretraedesraett_nn_1_1_N : N ;
  foerfallenhet_nn_1_1_N : N ;
  foerfarenhet_nn_1_1_N : N ;
  foerflugenhet_nn_1_1_N : N ;
  foerfoganderaett_nn_1_1_N : N ;
  foergraemdhet_nn_1_1_N : N ;
  foergraatenhet_nn_1_1_N : N ;
  foerhandenvaro_nn_1_1_N : N ;
  foerhandlingsbarhet_nn_1_1_N : N ;
  foerhandlingsraett_nn_1_1_N : N ;
  foerhandscensur_nn_1_1_N : N ;
  foerhoppningsfullhet_nn_1_1_N : N ;
  foerhud_nn_1_1_N : N ;
  foerhudsfoertraengning_nn_1_1_N : N ;
  foerhydningspapp_nn_1_1_N : N ;
  foerkastlighet_nn_1_1_N : N ;
  foerklaringskraft_nn_1_1_N : N ;
  foerklarlighet_nn_1_1_N : N ;
  foerklaeddhet_nn_1_1_N : N ;
  foerkommenhet_nn_1_1_N : N ;
  foerkromning_nn_1_1_N : N ;
  foerkrympthet_nn_1_1_N : N ;
  foerkyldhet_nn_1_1_N : N ;
  foerkoepsraett_nn_1_1_N : N ;
  foerkoersraett_nn_1_1_N : N ;
  foerljugenhet_nn_1_1_N : N ;
  foerlustighet_nn_1_1_N : N ;
  foerlustrikedom_nn_1_1_N : N ;
  foerlaesthet_nn_1_1_N : N ;
  foerlaatlighet_nn_1_1_N : N ;
  foermedvetenhet_nn_1_1_N : N ;
  foermyndaraktighet_nn_1_1_N : N ;
  foermaetenhet_nn_1_1_N : N ;
  foermaanlighet_nn_1_1_N : N ;
  foermaansraett_nn_1_1_N : N ;
  foerna_nn_1_1_N : N ;
  foernuftighet_nn_1_1_N : N ;
  foernuftsstridighet_nn_1_1_N : N ;
  foernuftsvidrighet_nn_1_1_N : N ;
  foernybarhet_nn_1_1_N : N ;
  foernyelsebarhet_nn_1_1_N : N ;
  foernaemlighet_nn_1_1_N : N ;
  foernoejdhet_nn_1_1_N : N ;
  foernoejsamhet_nn_1_1_N : N ;
  foerromantik_nn_1_1_N : N ;
  foerryckthet_nn_1_1_N : N ;
  foersagdhet_nn_1_1_N : N ;
  foersigkommenhet_nn_1_1_N : N ;
  foersjunkenhet_nn_1_1_N : N ;
  foerskotterbarhet_nn_1_1_N : N ;
  foerskraeckthet_nn_1_1_N : N ;
  foerskraemdhet_nn_1_1_N : N ;
  foerskaemdhet_nn_1_1_N : N ;
  foerslagenhet_nn_1_1_N : N ;
  foersmak_nn_1_1_N : N ;
  foersmaedlighet_nn_1_1_N : N ;
  foersoffning_nn_1_1_N : N ;
  foersonlighet_nn_1_1_N : N ;
  foersorg_nn_1_1_N : N ;
  foerstfoedsloraett_nn_1_1_N : N ;
  foerstklassighet_nn_1_1_N : N ;
  foerstroeddhet_nn_1_1_N : N ;
  foerstuckenhet_nn_1_1_N : N ;
  foerstulenhet_nn_1_1_N : N ;
  foerstaemdhet_nn_1_1_N : N ;
  foerstaaelighet_nn_1_1_N : N ;
  foerstaandighet_nn_1_1_N : N ;
  foerstoerdhet_nn_1_1_N : N ;
  foersumbarhet_nn_1_1_N : N ;
  foersupenhet_nn_1_1_N : N ;
  foersvarbarhet_nn_1_1_N : N ;
  foersvarlighet_nn_1_1_N : N ;
  foersvarsberedskap_nn_1_1_N : N ;
  foersvarsloeshet_nn_1_1_N : N ;
  foersvarsmakt_nn_1_1_N : N ;
  foersvarspolitik_nn_1_1_N : N ;
  foersyn_nn_1_1_N : N ;
  foersynthet_nn_1_1_N : N ;
  foersoerjningsbalans_nn_1_1_N : N ;
  foersoerjningspolitik_nn_1_1_N : N ;
  foertegenhet_nn_1_1_N : N ;
  foertidspensionerbarhet_nn_1_1_N : N ;
  foertjaenstfullhet_nn_1_1_N : N ;
  foertret_nn_1_1_N : N ;
  foertroendearbetstid_nn_1_1_N : N ;
  foertroendefullhet_nn_1_1_N : N ;
  foertrytsamhet_nn_1_1_N : N ;
  foertur_nn_1_1_N : N ;
  foertaenksamhet_nn_1_1_N : N ;
  foerundersoekningssekretess_nn_1_1_N : N ;
  foerundransvaerdhet_nn_1_1_N : N ;
  foerutbestaemdhet_nn_1_1_N : N ;
  foerutsaegbarhet_nn_1_1_N : N ;
  foerutsaegelsekraft_nn_1_1_N : N ;
  foerutsaettningsloeshet_nn_1_1_N : N ;
  foervetenhet_nn_1_1_N : N ;
  foervuxenhet_nn_1_1_N : N ;
  foervaegenhet_nn_1_1_N : N ;
  foervaendhet_nn_1_1_N : N ;
  foervaentansfullhet_nn_1_1_N : N ;
  foervaervslystenhet_nn_1_1_N : N ;
  foeraektenskaplighet_nn_1_1_N : N ;
  foeraeldrakaerlek_nn_1_1_N : N ;
  foeraeldraloeshet_nn_1_1_N : N ;
  foeraenderlighet_nn_1_1_N : N ;
  gabbro_nn_1_N : N ;
  gaddloeshet_nn_1_1_N : N ;
  gaggighet_nn_1_N : N ;
  gagnerikhet_nn_1_N : N ;
  gagnloeshet_nn_1_1_N : N ;
  gagnrikhet_nn_1_N : N ;
  gala_nn_2_N : N ;
  galaktos_nn_1_N : N ;
  galalit_nn_1_N : N ;
  galenhet_nn_1_N : N ;
  galgenfrist_nn_1_N : N ;
  galla_nn_2_N : N ;
  gallfeber_nn_1_N : N ;
  gallimatias_nn_1_N : N ;
  gallimattias_nn_1_N : N ;
  galliserbarhet_nn_1_N : N ;
  gallisering_nn_2_N : N ;
  gallsjukhet_nn_1_N : N ;
  gallspraengdhet_nn_1_1_N : N ;
  galmeja_nn_1_N : N ;
  galoppsport_nn_1_N : N ;
  galoscherbarhet_nn_1_N : N ;
  galtlukt_nn_1_N : N ;
  galvaniserbarhet_nn_1_N : N ;
  galvanoplastik_nn_1_N : N ;
  galvanoteknik_nn_1_N : N ;
  gammalhoeger_nn_1_1_N : N ;
  gammalkristenhet_nn_1_N : N ;
  gammalkyrklighet_nn_1_N : N ;
  gammalmodighet_nn_1_N : N ;
  gammaltestamentlighet_nn_1_N : N ;
  gamman_nn_1_N : N ;
  gangraen_nn_1_1_N : N ;
  gangsterromantik_nn_1_N : N ;
  gapighet_nn_1_N : N ;
  garagerbarhet_nn_1_N : N ;
  garanterbarhet_nn_1_N : N ;
  garderbarhet_nn_1_N : N ;
  garderobssorg_nn_1_N : N ;
  garnerbarhet_nn_1_N : N ;
  garnisonerbarhet_nn_1_N : N ;
  garrotterbarhet_nn_1_N : N ;
  gasbetong_nn_1_N : N ;
  gasbrand_nn_1_N : N ;
  gasbrist_nn_1_N : N ;
  gasdynamik_nn_1_N : N ;
  gasform_nn_1_N : N ;
  gasol_nn_1_N : N ;
  gasrikedom_nn_1_N : N ;
  gassighet_nn_1_N : N ;
  gastroskoperbarhet_nn_1_N : N ;
  gastrulering_nn_1_N : N ;
  gatufred_nn_1_N : N ;
  gatufrid_nn_1_N : N ;
  gatumusik_nn_1_N : N ;
  gauffrerbarhet_nn_1_N : N ;
  gedigenhet_nn_1_N : N ;
  gegga_nn_1_N : N ;
  geggamoja_nn_1_N : N ;
  geggighet_nn_1_N : N ;
  geist_nn_1_N : N ;
  gelatinerbarhet_nn_1_N : N ;
  gelatinering_nn_1_N : N ;
  gelcoat_nn_1_N : N ;
  gelform_nn_1_N : N ;
  gemensamhetskaensla_nn_1_1_N : N ;
  gemenskap_nn_1_N : N ;
  geminerbarhet_nn_1_N : N ;
  genans_nn_1_N : N ;
  genbankning_nn_1_N : N ;
  generalbas_nn_1_N : N ;
  generaliserbarhet_nn_1_N : N ;
  generalissimus_nn_1_N : N ;
  generatorgas_nn_1_N : N ;
  generbarhet_nn_1_N : N ;
  genererbarhet_nn_1_N : N ;
  genes_nn_1_N : N ;
  genetik_nn_1_N : N ;
  genever_nn_1_N : N ;
  gengas_nn_1_N : N ;
  gengaangarlikhet_nn_1_1_N : N ;
  genius_nn_1_N : N ;
  genklang_nn_1_N : N ;
  genmanipulerbarhet_nn_1_N : N ;
  genomdumhet_nn_1_N : N ;
  genomfaerd_nn_1_1_N : N ;
  genomfoerbarhet_nn_1_1_N : N ;
  genomskinlighet_nn_1_N : N ;
  genomslagskraft_nn_1_N : N ;
  genomsnittlighet_nn_1_N : N ;
  genomsvettighet_nn_1_N : N ;
  genomtraenglighet_nn_1_1_N : N ;
  genomtaenkthet_nn_1_1_N : N ;
  genstridighet_nn_1_N : N ;
  genstraevighet_nn_1_1_N : N ;
  genstoertighet_nn_1_1_N : N ;
  genteknik_nn_1_N : N ;
  gentiljess_nn_1_N : N ;
  genusforskning_nn_1_N : N ;
  geodynamik_nn_1_N : N ;
  geofysik_nn_1_N : N ;
  geoid_nn_1_N : N ;
  geometriserbarhet_nn_1_N : N ;
  geopolitik_nn_1_N : N ;
  georgianskhet_nn_1_N : N ;
  geoteknik_nn_1_N : N ;
  geriatrik_nn_1_N : N ;
  germaniserbarhet_nn_1_N : N ;
  germanistik_nn_1_N : N ;
  gestik_nn_1_N : N ;
  getmjoelk_nn_1_1_N : N ;
  getpors_nn_1_N : N ;
  getrams_nn_1_N : N ;
  gettofiering_nn_1_N : N ;
  giftasvuxenhet_nn_1_N : N ;
  giftoraett_nn_1_1_N : N ;
  gikt_nn_1_N : N ;
  giktbrutenhet_nn_1_N : N ;
  giljarstraat_nn_1_1_N : N ;
  giljotinerbarhet_nn_1_N : N ;
  gillhet_nn_1_N : N ;
  ginseng_nn_1_N : N ;
  gipsputs_nn_1_N : N ;
  girerbarhet_nn_1_N : N ;
  gisslan_nn_1_N : N ;
  gistenhet_nn_1_N : N ;
  gitarrmusik_nn_1_N : N ;
  givenhet_nn_1_N : N ;
  gjutbarhet_nn_1_N : N ;
  gjutbetong_nn_1_N : N ;
  gjutsand_nn_1_N : N ;
  glaciaersmaeltning_nn_1_1_N : N ;
  gladhet_nn_1_N : N ;
  gladlynthet_nn_1_N : N ;
  gladporr_nn_1_N : N ;
  glammighet_nn_1_N : N ;
  glamoriserbarhet_nn_1_N : N ;
  glamour_nn_1_N : N ;
  glamouriserbarhet_nn_1_N : N ;
  glans_nn_1_N : N ;
  glansfullhet_nn_1_N : N ;
  glansighet_nn_1_N : N ;
  glansis_nn_1_N : N ;
  glanskhet_nn_1_N : N ;
  glanskis_nn_1_N : N ;
  glansloeshet_nn_1_1_N : N ;
  glansull_nn_1_N : N ;
  glapphet_nn_1_N : N ;
  glaserbarhet_nn_1_N : N ;
  glasfiberull_nn_1_N : N ;
  glasfibervaev_nn_1_1_N : N ;
  glasfluss_nn_1_N : N ;
  glasmaestarsill_nn_1_1_N : N ;
  glasnost_nn_1_N : N ;
  glasrengoering_nn_1_1_N : N ;
  glassighet_nn_1_N : N ;
  glasull_nn_1_N : N ;
  glasoert_nn_1_1_N : N ;
  glatthet_nn_1_N : N ;
  glattis_nn_1_N : N ;
  glencheck_nn_1_N : N ;
  gleshet_nn_1_N : N ;
  glia_nn_1_N : N ;
  glidflygning_nn_1_N : N ;
  glidflykt_nn_1_N : N ;
  glima_nn_1_N : N ;
  glis_nn_1_N : N ;
  glittrighet_nn_1_N : N ;
  globalisering_nn_1_N : N ;
  glorifierbarhet_nn_1_N : N ;
  glosoegdhet_nn_1_1_N : N ;
  glupskhet_nn_1_N : N ;
  glutenintolerans_nn_1_N : N ;
  glycerol_nn_1_N : N ;
  glykolys_nn_1_N : N ;
  glyptik_nn_1_N : N ;
  glyttighet_nn_1_N : N ;
  glaedjefylldhet_nn_1_1_N : N ;
  glaedjerusighet_nn_1_1_N : N ;
  gloeggsoerpling_nn_1_1_N : N ;
  gloemska_nn_1_1_N : N ;
  gloemskhet_nn_1_1_N : N ;
  gnatighet_nn_1_N : N ;
  gnetighet_nn_1_N : N ;
  gnidenhet_nn_1_N : N ;
  gnist_nn_1_N : N ;
  gnistrighet_nn_1_N : N ;
  gnosis_nn_1_N : N ;
  gnuss_nn_1_N : N ;
  gnutta_nn_1_N : N ;
  gnaellighet_nn_1_1_N : N ;
  go_nn_1_N : N ;
  godhetsfullhet_nn_1_N : N ;
  godhaellighet_nn_1_1_N : N ;
  godisjakt_nn_1_N : N ;
  godispanik_nn_1_N : N ;
  godissugenhet_nn_1_N : N ;
  godlynthet_nn_1_N : N ;
  godmodighet_nn_1_N : N ;
  godsinthet_nn_1_N : N ;
  godstrafik_nn_1_N : N ;
  godsaegarstil_nn_1_1_N : N ;
  godtagbarhet_nn_1_N : N ;
  godtrogenhet_nn_1_N : N ;
  godvillighet_nn_1_N : N ;
  goffrerbarhet_nn_1_N : N ;
  goja_nn_1_N : N ;
  golf_nn_1_N : N ;
  gomspalt_nn_1_N : N ;
  goodwill_nn_1_N : N ;
  googlingsbarhet_nn_1_N : N ;
  gossamer_nn_1_N : N ;
  gotik_nn_1_N : N ;
  gotlaendskhet_nn_1_1_N : N ;
  gotskhet_nn_1_N : N ;
  gouterbarhet_nn_1_N : N ;
  graderbarhet_nn_1_N : N ;
  gradhet_nn_1_N : N ;
  graduerbarhet_nn_1_N : N ;
  grafik_nn_1_N : N ;
  grafiterbarhet_nn_1_N : N ;
  grain_nn_1_N : N ;
  granateld_nn_1_N : N ;
  granbark_nn_1_N : N ;
  grand_guignol_nn_1_N : N ;
  grandezza_nn_1_N : N ;
  grandioshet_nn_1_N : N ;
  granitkeramik_nn_1_N : N ;
  grannhet_nn_1_N : N ;
  grannsynthet_nn_1_N : N ;
  grannsaemja_nn_1_1_N : N ;
  granntyckthet_nn_1_N : N ;
  granulerbarhet_nn_1_N : N ;
  granved_nn_1_N : N ;
  gratinerbarhet_nn_1_N : N ;
  gratulerbarhet_nn_1_N : N ;
  gravallvarlighet_nn_1_N : N ;
  graverbarhet_nn_1_N : N ;
  gravhet_nn_1_N : N ;
  gravis_nn_1_N : N ;
  gravlikhet_nn_1_N : N ;
  gravor_nn_1_N : N ;
  gravrost_nn_1_N : N ;
  gravyrkonst_nn_1_N : N ;
  grenighet_nn_1_N : N ;
  greppbarhet_nn_1_N : N ;
  greppriktighet_nn_1_N : N ;
  greppvaenlighet_nn_1_1_N : N ;
  grevlighet_nn_1_N : N ;
  griftefrid_nn_1_N : N ;
  griljerbarhet_nn_1_N : N ;
  grimerbarhet_nn_1_N : N ;
  gripbarhet_nn_1_N : N ;
  gripenhet_nn_1_N : N ;
  gripreflex_nn_1_N : N ;
  grismat_nn_1_N : N ;
  grisuppfoedning_nn_1_1_N : N ;
  gropemalj_nn_1_N : N ;
  gropighet_nn_1_N : N ;
  grottekvarn_nn_1_N : N ;
  grovhuggenhet_nn_1_N : N ;
  grovkalibrighet_nn_1_N : N ;
  grovkornighet_nn_1_N : N ;
  grovplanerbarhet_nn_1_N : N ;
  grovsorterbarhet_nn_1_N : N ;
  grumsighet_nn_1_N : N ;
  grunderbarhet_nn_1_N : N ;
  grundfoersoerjning_nn_1_1_N : N ;
  grundhet_nn_1_N : N ;
  grundloeshet_nn_1_1_N : N ;
  grundsyn_nn_1_N : N ;
  gruppdynamik_nn_1_N : N ;
  grupperbarhet_nn_1_N : N ;
  grupptillhoerighet_nn_1_1_N : N ;
  gruvgas_nn_1_N : N ;
  gruvsamhet_nn_1_N : N ;
  grymhet_nn_2_N : N ;
  grytfot_nn_1_N : N ;
  graedda_nn_1_1_N : N ;
  graeddfil_nn_1_1_N : N ;
  graeddighet_nn_1_1_N : N ;
  graelaktighet_nn_1_1_N : N ;
  graelighet_nn_1_1_N : N ;
  graellhet_nn_1_1_N : N ;
  graelsjuka_nn_1_1_N : N ;
  graelsjukhet_nn_1_1_N : N ;
  graeng_nn_1_1_N : N ;
  graensloeshet_nn_1_1_N : N ;
  graenspolis_nn_1_1_N : N ;
  graensvaag_nn_1_1_N : N ;
  graeshalm_nn_1_1_N : N ;
  graesloek_nn_1_1_N : N ;
  graesrotsnivaa_nn_1_1_N : N ;
  graessvaal_nn_1_1_N : N ;
  graestorv_nn_1_1_N : N ;
  graesvaext_nn_2_1_N : N ;
  graettenhet_nn_1_1_N : N ;
  graevarjournalistik_nn_1_1_N : N ;
  graevjournalistik_nn_1_1_N : N ;
  graevlingsjakt_nn_1_1_N : N ;
  graaaktighet_nn_1_1_N : N ;
  graablekhet_nn_1_1_N : N ;
  graadaskighet_nn_1_1_N : N ;
  graahaarighet_nn_1_1_N : N ;
  graakallhet_nn_1_1_N : N ;
  graakil_nn_1_1_N : N ;
  graamurrighet_nn_1_1_N : N ;
  graaregnighet_nn_1_1_N : N ;
  graaskala_nn_1_1_N : N ;
  graaskimlighet_nn_1_1_N : N ;
  graaspraengdhet_nn_1_1_N : N ;
  graastarr_nn_1_1_N : N ;
  graat_nn_1_1_N : N ;
  graatfaerdighet_nn_1_1_N : N ;
  graatmildhet_nn_1_1_N : N ;
  graaaert_nn_1_1_N : N ;
  groenaktighet_nn_1_1_N : N ;
  groenblekhet_nn_1_1_N : N ;
  groenblindhet_nn_1_1_N : N ;
  groenhet_nn_1_1_N : N ;
  groenkaal_nn_1_1_N : N ;
  groenkoeping_nn_1_1_N : N ;
  groenkoepingsmaessighet_nn_1_1_N : N ;
  groensoppa_nn_1_1_N : N ;
  groenstarr_nn_1_1_N : N ;
  groenaadrighet_nn_1_1_N : N ;
  groetighet_nn_1_1_N : N ;
  groetlunk_nn_1_1_N : N ;
  groetmyndighet_nn_1_1_N : N ;
  guarani_nn_1_N : N ;
  gubbighet_nn_1_N : N ;
  gubbknarrighet_nn_1_N : N ;
  gubbsjuka_nn_1_N : N ;
  gubbsjukhet_nn_1_N : N ;
  gudaktighet_nn_1_N : N ;
  gudamakt_nn_1_N : N ;
  gudelighet_nn_1_N : N ;
  gudfruktighet_nn_1_N : N ;
  gudlighet_nn_1_N : N ;
  gudloeshet_nn_1_1_N : N ;
  gudomliggoering_nn_1_1_N : N ;
  gudsfred_nn_1_N : N ;
  gudsfoergaetenhet_nn_1_1_N : N ;
  gudsnaadelighet_nn_1_1_N : N ;
  gudsnaadlighet_nn_1_1_N : N ;
  gulaktighet_nn_1_N : N ;
  gulasch_nn_1_N : N ;
  gulblekhet_nn_1_N : N ;
  guldfeber_nn_1_N : N ;
  guldglans_nn_1_N : N ;
  guldmyntfot_nn_1_N : N ;
  guldpunkt_nn_1_N : N ;
  guldsand_nn_1_N : N ;
  guldtoerst_nn_1_1_N : N ;
  gullebrand_nn_1_N : N ;
  gulltrav_nn_1_N : N ;
  gulmetall_nn_1_N : N ;
  gulockra_nn_1_N : N ;
  gulsiktighet_nn_1_N : N ;
  gulsot_nn_1_N : N ;
  gulvial_nn_1_N : N ;
  gummerbarhet_nn_1_N : N ;
  gummigutta_nn_1_N : N ;
  gungighet_nn_1_N : N ;
  gunstbenaegenhet_nn_1_1_N : N ;
  gunstighet_nn_1_N : N ;
  guppighet_nn_1_N : N ;
  gurkmeja_nn_1_N : N ;
  gut_nn_1_N : N ;
  guterbarhet_nn_1_N : N ;
  gutt_nn_1_N : N ;
  guttaperka_nn_1_N : N ;
  gyllenduk_nn_1_N : N ;
  gyllenlack_nn_1_N : N ;
  gymnastik_nn_1_N : N ;
  gymnastiserbarhet_nn_1_N : N ;
  gympa_nn_1_N : N ;
  gymping_nn_1_N : N ;
  gynnsamhet_nn_1_N : N ;
  gyroprincip_nn_1_N : N ;
  gyttjighet_nn_1_N : N ;
  gyttrighet_nn_1_N : N ;
  gaecksamhet_nn_1_1_N : N ;
  gaeld_nn_1_1_N : N ;
  gaellenhet_nn_1_1_N : N ;
  gaellhet_nn_1_1_N : N ;
  gaenglighet_nn_1_1_N : N ;
  gaespighet_nn_1_1_N : N ;
  gaestfrihet_nn_1_1_N : N ;
  gaestvaenlighet_nn_1_1_N : N ;
  gaangbarhet_nn_1_1_N : N ;
  gaapaaighet_nn_1_1_N : N ;
  gaardsfoersaeljning_nn_1_1_N : N ;
  gaardsstaedning_nn_1_1_N : N ;
  gaashud_nn_1_1_N : N ;
  gaaslever_nn_1_1_N : N ;
  gaasmarsch_nn_1_1_N : N ;
  gaasoert_nn_1_1_N : N ;
  goedsel_nn_1_1_N : N ;
  goekmat_nn_1_1_N : N ;
  goekaert_nn_1_1_N : N ;
  goerlighet_nn_1_1_N : N ;
  goetmetall_nn_1_1_N : N ;
  goetterdaemmerung_nn_1_1_N : N ;
  hackhosta_nn_1_N : N ;
  hackighet_nn_1_N : N ;
  hackmat_nn_1_N : N ;
  hafsighet_nn_1_N : N ;
  hagalenhet_nn_1_N : N ;
  hajj_nn_1_N : N ;
  hajjakt_nn_1_N : N ;
  halhet_nn_1_N : N ;
  halka_nn_1_N : N ;
  halkighet_nn_1_N : N ;
  halkskyddstejp_nn_1_N : N ;
  hallraett_nn_1_1_N : N ;
  hallucinerbarhet_nn_1_N : N ;
  halm_nn_1_N : N ;
  halsbraenna_nn_1_1_N : N ;
  halsstarrighet_nn_1_N : N ;
  halthet_nn_1_N : N ;
  haltloeshet_nn_1_1_N : N ;
  halvbildning_nn_1_N : N ;
  halvblindhet_nn_1_N : N ;
  halvdager_nn_1_N : N ;
  halvdvala_nn_1_N : N ;
  halvdoedhet_nn_1_1_N : N ;
  halverbarhet_nn_1_N : N ;
  halveringstid_nn_1_N : N ;
  halvgenomskinlighet_nn_1_N : N ;
  halvgaangenhet_nn_1_1_N : N ;
  halvklotformighet_nn_1_N : N ;
  halvkvaedenhet_nn_1_1_N : N ;
  halvnakenhet_nn_1_N : N ;
  halvruttenhet_nn_1_N : N ;
  halvskymning_nn_1_N : N ;
  halvslutenhet_nn_1_N : N ;
  halvsnagg_nn_1_N : N ;
  halvspraakighet_nn_1_1_N : N ;
  halvstatlighet_nn_1_N : N ;
  halvsoemn_nn_1_1_N : N ;
  halvtimma_nn_1_N : N ;
  halvvuxenhet_nn_1_N : N ;
  halvoeppenhet_nn_1_1_N : N ;
  hamling_nn_1_N : N ;
  hampa_nn_1_N : N ;
  hampdaan_nn_1_1_N : N ;
  handbojning_nn_1_N : N ;
  handboll_nn_1_N : N ;
  handelsbalans_nn_1_N : N ;
  handelspolitik_nn_1_N : N ;
  handelsraett_nn_1_1_N : N ;
  handfasthet_nn_1_N : N ;
  handgriplighet_nn_2_N : N ;
  handikappolitik_nn_1_N : N ;
  handikappvaard_nn_1_1_N : N ;
  handkraft_nn_1_N : N ;
  handlingsberedskap_nn_1_N : N ;
  handlingskraft_nn_1_N : N ;
  handlingskraftighet_nn_1_N : N ;
  hands_nn_1_N : N ;
  handsvett_nn_1_N : N ;
  handtvaett_nn_2_1_N : N ;
  hanfot_nn_1_N : N ;
  hanterbarhet_nn_1_N : N ;
  hanterlighet_nn_1_N : N ;
  hantverksmaessighet_nn_1_1_N : N ;
  harangerbarhet_nn_1_N : N ;
  harkloever_nn_1_1_N : N ;
  harm_nn_1_N : N ;
  harmfullhet_nn_1_N : N ;
  harmfylldhet_nn_1_N : N ;
  harmlighet_nn_1_N : N ;
  harmonik_nn_1_N : N ;
  harmoniserbarhet_nn_1_N : N ;
  harmsenhet_nn_1_N : N ;
  harmynthet_nn_1_N : N ;
  harpest_nn_1_N : N ;
  harpunerbarhet_nn_1_N : N ;
  hasard_nn_1_N : N ;
  hasarderbarhet_nn_1_N : N ;
  haschroekning_nn_1_1_N : N ;
  hatfullhet_nn_1_N : N ;
  hatfylldhet_nn_1_N : N ;
  hatstaemning_nn_1_1_N : N ;
  hattighet_nn_1_N : N ;
  hausa_nn_1_N : N ;
  havererbarhet_nn_1_N : N ;
  haverrot_nn_1_N : N ;
  havremust_nn_1_N : N ;
  havresoppa_nn_1_N : N ;
  havsluft_nn_1_N : N ;
  havsraett_nn_1_1_N : N ;
  havsutsikt_nn_1_N : N ;
  hedenhet_nn_1_N : N ;
  hedenhoes_nn_1_1_N : N ;
  hederlighet_nn_1_N : N ;
  hedersamhet_nn_1_N : N ;
  hedervaerdhet_nn_1_1_N : N ;
  hektograferbarhet_nn_1_N : N ;
  helgarderbarhet_nn_1_N : N ;
  helgd_nn_1_N : N ;
  helgjutenhet_nn_1_N : N ;
  helgtrafik_nn_1_N : N ;
  helicobacter_nn_1_N : N ;
  helicobakter_nn_1_N : N ;
  helikobacter_nn_1_N : N ;
  helikobakter_nn_1_N : N ;
  helinackorderbarhet_nn_1_N : N ;
  helnykterhet_nn_1_N : N ;
  helskotta_nn_1_N : N ;
  helstatlighet_nn_1_N : N ;
  hembryggning_nn_1_N : N ;
  hembygdsromantik_nn_1_N : N ;
  hemfrid_nn_1_N : N ;
  hemkomst_nn_1_N : N ;
  hemkunskap_nn_1_N : N ;
  hemkaensla_nn_1_1_N : N ;
  hemlighetsfullhet_nn_1_N : N ;
  hemloeshet_nn_1_1_N : N ;
  hemmablindhet_nn_1_N : N ;
  hemmafront_nn_1_N : N ;
  hemmastaddhet_nn_1_N : N ;
  hemortsraett_nn_1_1_N : N ;
  hemsjuka_nn_1_N : N ;
  hemsjukvaard_nn_1_1_N : N ;
  hemskhet_nn_2_N : N ;
  hemsloejd_nn_1_1_N : N ;
  hemtamhet_nn_1_N : N ;
  hemtrevnad_nn_1_N : N ;
  hemvaeg_nn_1_1_N : N ;
  hemvaevdhet_nn_1_1_N : N ;
  hemvaard_nn_1_1_N : N ;
  henna_nn_1_N : N ;
  heraldik_nn_1_N : N ;
  hermeneutik_nn_1_N : N ;
  heroinbranch_nn_1_N : N ;
  heroinproduktion_nn_1_N : N ;
  heroinsmuggling_nn_1_N : N ;
  heroiserbarhet_nn_1_N : N ;
  herpes_nn_1_N : N ;
  herreloeshet_nn_1_1_N : N ;
  herrgaardsdrift_nn_1_1_N : N ;
  heterogenhet_nn_1_N : N ;
  heterogenitet_nn_1_N : N ;
  heterosexualitet_nn_1_N : N ;
  hetluft_nn_1_N : N ;
  hets_nn_1_N : N ;
  hetspolitik_nn_1_N : N ;
  hetsaetning_nn_1_1_N : N ;
  hetta_nn_1_N : N ;
  heuristik_nn_1_N : N ;
  hiatus_nn_1_N : N ;
  hicka_nn_1_N : N ;
  himlapaell_nn_1_1_N : N ;
  himlarand_nn_1_N : N ;
  himmelsmekanik_nn_1_N : N ;
  hin_nn_1_N : N ;
  hinderloeshet_nn_1_1_N : N ;
  hindersamhet_nn_1_N : N ;
  hindersloeshet_nn_1_1_N : N ;
  hinsida_nn_1_N : N ;
  hipphet_nn_1_N : N ;
  hirs_nn_1_N : N ;
  hispighet_nn_1_N : N ;
  historieloeshet_nn_1_1_N : N ;
  historierbarhet_nn_1_N : N ;
  historiserbarhet_nn_1_N : N ;
  hjordinstinkt_nn_1_N : N ;
  hjulbenthet_nn_1_N : N ;
  hjaelp_nn_1_1_N : N ;
  hjaelplighet_nn_1_1_N : N ;
  hjaelploeshet_nn_1_1_N : N ;
  hjaeltemodighet_nn_1_1_N : N ;
  hjaeltestatus_nn_1_1_N : N ;
  hjaernbark_nn_1_1_N : N ;
  hjaerndoed_nn_1_1_N : N ;
  hjaernforskning_nn_1_1_N : N ;
  hjaerngymnastik_nn_1_1_N : N ;
  hjaernsubstans_nn_1_1_N : N ;
  hjaerntvaett_nn_1_1_N : N ;
  hjaert_lungraeddning_nn_1_1_N : N ;
  hjaertansfroejd_nn_1_1_N : N ;
  hjaertanskaer_nn_1_1_N : N ;
  hjaertegodhet_nn_1_1_N : N ;
  hjaertform_nn_1_1_N : N ;
  hjaertinsufficiens_nn_1_1_N : N ;
  hjaertnupenhet_nn_1_1_N : N ;
  hjaertsvikt_nn_1_1_N : N ;
  hjaertaengslighet_nn_1_1_N : N ;
  holograferbarhet_nn_1_N : N ;
  homiletik_nn_1_N : N ;
  homo_nn_1_N : N ;
  homogenhet_nn_1_N : N ;
  homogeniserbarhet_nn_1_N : N ;
  honorerbarhet_nn_1_N : N ;
  honungslenhet_nn_1_N : N ;
  hopbitenhet_nn_1_N : N ;
  hopfaellbarhet_nn_1_1_N : N ;
  hopkrympning_nn_1_N : N ;
  hoppighet_nn_1_N : N ;
  hopsmaeltning_nn_1_1_N : N ;
  hoptryckbarhet_nn_1_N : N ;
  hornboskap_nn_1_N : N ;
  hornhud_nn_1_N : N ;
  hornloeshet_nn_1_1_N : N ;
  hornmusik_nn_1_N : N ;
  hortikultur_nn_1_N : N ;
  hospitaliserbarhet_nn_1_N : N ;
  hospitaliseringseffekt_nn_1_N : N ;
  hostighet_nn_1_N : N ;
  hot_nn_2_N : N ;
  hotchpotchsoppa_nn_1_N : N ;
  hovnarrstaempel_nn_1_1_N : N ;
  hovsamhet_nn_1_N : N ;
  hudcancer_nn_1_N : N ;
  hudloeshet_nn_1_1_N : N ;
  hudvaenlighet_nn_1_1_N : N ;
  hug_nn_1_N : N ;
  hugnesamhet_nn_1_N : N ;
  hula_hula_nn_1_N : N ;
  huldhet_nn_1_N : N ;
  humaniserbarhet_nn_1_N : N ;
  hummus_nn_1_N : N ;
  humus_nn_1_N : N ;
  humusbundenhet_nn_1_N : N ;
  hundkaex_nn_1_1_N : N ;
  hundmat_nn_1_N : N ;
  hundsfotterbarhet_nn_1_N : N ;
  hunger_nn_1_N : N ;
  hungersnoed_nn_1_1_N : N ;
  hungrighet_nn_1_N : N ;
  hurtighet_nn_1_N : N ;
  husarrest_nn_1_N : N ;
  husdjursskoetsel_nn_1_1_N : N ;
  huserbarhet_nn_1_N : N ;
  husfrid_nn_1_N : N ;
  huslighet_nn_1_N : N ;
  huslaekekonst_nn_1_1_N : N ;
  husmanskost_nn_1_N : N ;
  husvillhet_nn_1_N : N ;
  huvudfoeda_nn_1_1_N : N ;
  huvudjakt_nn_1_N : N ;
  huvudpart_nn_1_N : N ;
  huvudvaerk_nn_1_1_N : N ;
  hybridiserbarhet_nn_1_N : N ;
  hybris_nn_1_N : N ;
  hydraulik_nn_1_N : N ;
  hydrerbarhet_nn_1_N : N ;
  hydrodynamik_nn_1_N : N ;
  hydrokinon_nn_1_N : N ;
  hydrosfaer_nn_1_1_N : N ;
  hydrostatik_nn_1_N : N ;
  hyfs_nn_1_N : N ;
  hyfsning_nn_1_N : N ;
  hyperkorrekthet_nn_1_N : N ;
  hyperkaenslighet_nn_1_1_N : N ;
  hypermodernhet_nn_1_N : N ;
  hypnotiserbarhet_nn_1_N : N ;
  hypotalamus_nn_1_N : N ;
  hypotax_nn_1_N : N ;
  hypotiserbarhet_nn_1_N : N ;
  hysbarhet_nn_1_N : N ;
  haeckling_nn_1_1_N : N ;
  haediskhet_nn_1_1_N : N ;
  haeftighet_nn_1_1_N : N ;
  haelleflinta_nn_1_1_N : N ;
  haelsa_nn_1_1_N : N ;
  haelsokost_nn_1_1_N : N ;
  haelsomedvetenhet_nn_1_1_N : N ;
  haelsopolitik_nn_1_1_N : N ;
  haelsosamhet_nn_1_1_N : N ;
  haelsovaard_nn_1_1_N : N ;
  haemnd_nn_1_1_N : N ;
  haemndgirighet_nn_1_1_N : N ;
  haemndlystenhet_nn_1_1_N : N ;
  haemtmat_nn_1_1_N : N ;
  haendelsefattighet_nn_1_1_N : N ;
  haendelseloeshet_nn_1_1_N : N ;
  haendelserikhet_nn_1_1_N : N ;
  haendighet_nn_1_1_N : N ;
  haenfoerdhet_nn_1_1_N : N ;
  haengighet_nn_1_1_N : N ;
  haengivenhet_nn_1_1_N : N ;
  haenryckthet_nn_1_1_N : N ;
  haensjunkenhet_nn_1_1_N : N ;
  haepenhet_nn_1_1_N : N ;
  haerbaergerbarhet_nn_1_1_N : N ;
  haerkomst_nn_1_1_N : N ;
  haerlighet_nn_2_1_N : N ;
  haermning_nn_1_1_N : N ;
  haerskenhet_nn_1_1_N : N ;
  haersklystenhet_nn_1_1_N : N ;
  haestpolo_nn_1_1_N : N ;
  haestskoetsel_nn_1_1_N : N ;
  haevdvunnenhet_nn_1_1_N : N ;
  haag_nn_1_1_N : N ;
  haagloeshet_nn_1_1_N : N ;
  haallningsloeshet_nn_1_1_N : N ;
  haalspetsammunition_nn_1_1_N : N ;
  haaltimma_nn_1_1_N : N ;
  haaloegdhet_nn_1_1_N : N ;
  haarbevuxenhet_nn_1_1_N : N ;
  haardfoerhet_nn_1_1_N : N ;
  haardhet_nn_1_1_N : N ;
  haardhjaertenhet_nn_1_1_N : N ;
  haardhaenthet_nn_1_1_N : N ;
  haardkokthet_nn_1_1_N : N ;
  haardnackenhet_nn_1_1_N : N ;
  haardporr_nn_1_1_N : N ;
  haardrock_nn_1_1_N : N ;
  haardsmaelthet_nn_1_1_N : N ;
  haarighet_nn_1_1_N : N ;
  haarloeshet_nn_1_1_N : N ;
  haarroerskraft_nn_1_1_N : N ;
  haarsmaan_nn_1_1_N : N ;
  haarvaext_nn_1_1_N : N ;
  haarvaard_nn_1_1_N : N ;
  hoefeber_nn_1_1_N : N ;
  hoegaktningsfullhet_nn_1_1_N : N ;
  hoegborenhet_nn_1_1_N : N ;
  hoegborgerlighet_nn_1_1_N : N ;
  hoegdragenhet_nn_1_1_N : N ;
  hoeger_nn_2_1_N : N ;
  hoegerextremism_nn_1_1_N : N ;
  hoegerhaenthet_nn_1_1_N : N ;
  hoegerkristenhet_nn_1_1_N : N ;
  hoegerpolitik_nn_1_1_N : N ;
  hoegerpopulism_nn_1_1_N : N ;
  hoegerregel_nn_1_1_N : N ;
  hoegertrafik_nn_1_1_N : N ;
  hoegflod_nn_1_1_N : N ;
  hoegform_nn_1_1_N : N ;
  hoegfaerd_nn_1_1_N : N ;
  hoegfaerdighet_nn_1_1_N : N ;
  hoegfaerdsdjaevul_nn_1_1_N : N ;
  hoegfoernaemhet_nn_1_1_N : N ;
  hoegglans_nn_1_1_N : N ;
  hoegklassighet_nn_1_1_N : N ;
  hoegkyrklighet_nn_1_1_N : N ;
  hoegljuddhet_nn_1_1_N : N ;
  hoeglaenthet_nn_1_1_N : N ;
  hoegmodighet_nn_1_1_N : N ;
  hoegresthet_nn_1_1_N : N ;
  hoegsinthet_nn_1_1_N : N ;
  hoegstatus_nn_1_1_N : N ;
  hoegstaemdhet_nn_1_1_N : N ;
  hoegtrafik_nn_1_1_N : N ;
  hoegvuxenhet_nn_1_1_N : N ;
  hoegvaelborenhet_nn_1_1_N : N ;
  hoegvaerdighet_nn_1_1_N : N ;
  hoegvaexthet_nn_1_1_N : N ;
  hoegoensklighet_nn_1_1_N : N ;
  hoejdled_nn_1_1_N : N ;
  hoekpolitik_nn_1_1_N : N ;
  hoensighet_nn_1_1_N : N ;
  hoerbarhetstroeskel_nn_1_1_N : N ;
  hoersamhet_nn_1_1_N : N ;
  hoersel_nn_1_1_N : N ;
  hoesnuva_nn_1_1_N : N ;
  hoestfrost_nn_1_1_N : N ;
  hoestsol_nn_1_1_N : N ;
  hoestsaed_nn_1_1_N : N ;
  hoestsaadd_nn_1_1_N : N ;
  hoetorgskonst_nn_1_1_N : N ;
  iblandning_nn_1_N : N ;
  id_nn_2_N : N ;
  idealiserbarhet_nn_1_N : N ;
  idelighet_nn_1_N : N ;
  identifierbarhet_nn_1_N : N ;
  idiotsaekerhet_nn_1_1_N : N ;
  idoghet_nn_1_N : N ;
  idrottsgymnastik_nn_1_N : N ;
  idrottslighet_nn_1_N : N ;
  idrottsmedicin_nn_1_N : N ;
  id_efattighet_nn_1_1_N : N ;
  id_eflykt_nn_1_1_N : N ;
  id_erikhet_nn_1_1_N : N ;
  igenkaenning_nn_1_1_N : N ;
  igenkaennlighet_nn_1_1_N : N ;
  igensaettning_nn_1_1_N : N ;
  ignorans_nn_1_N : N ;
  ignorerbarhet_nn_1_N : N ;
  ihopfaellbarhet_nn_1_1_N : N ;
  ihaerdighet_nn_1_1_N : N ;
  ihaallighet_nn_1_1_N : N ;
  ikat_nn_1_N : N ;
  ilastning_nn_1_N : N ;
  ilfart_nn_1_N : N ;
  illavulenhet_nn_1_N : N ;
  illfundighet_nn_1_N : N ;
  illistighet_nn_1_N : N ;
  illmarighet_nn_1_N : N ;
  illparighet_nn_1_N : N ;
  illuminerbarhet_nn_1_N : N ;
  illustrerbarhet_nn_1_N : N ;
  ilska_nn_1_N : N ;
  ilskenhet_nn_1_N : N ;
  ilskhet_nn_1_N : N ;
  imbecillhet_nn_1_N : N ;
  imiterbarhet_nn_1_N : N ;
  imma_nn_1_N : N ;
  immanens_nn_1_N : N ;
  immaterialraett_nn_1_1_N : N ;
  immatrikulerbarhet_nn_1_N : N ;
  immighet_nn_1_N : N ;
  immigrerbarhet_nn_1_N : N ;
  immuniserbarhet_nn_1_N : N ;
  impedans_nn_1_N : N ;
  impetigo_nn_1_N : N ;
  implanterbarhet_nn_1_N : N ;
  implicerbarhet_nn_1_N : N ;
  implicithet_nn_1_N : N ;
  imploderbarhet_nn_1_N : N ;
  imponerbarhet_nn_1_N : N ;
  importerbarhet_nn_1_N : N ;
  impotens_nn_1_N : N ;
  impregnerbarhet_nn_1_N : N ;
  improviserbarhet_nn_1_N : N ;
  impulskontroll_nn_1_N : N ;
  inackorderbarhet_nn_1_N : N ;
  inaugurerbarhet_nn_1_N : N ;
  inbillningssjukhet_nn_1_N : N ;
  inbitenhet_nn_1_N : N ;
  inblaasning_nn_1_1_N : N ;
  inbundenhet_nn_1_N : N ;
  incidentberedskap_nn_1_N : N ;
  indefinithet_nn_1_N : N ;
  indexerbarhet_nn_1_N : N ;
  indexreglerbarhet_nn_1_N : N ;
  indicerbarhet_nn_1_N : N ;
  indifferens_nn_1_N : N ;
  indigenatsraett_nn_1_1_N : N ;
  indignationslitteratur_nn_1_N : N ;
  indigo_nn_1_N : N ;
  indikerbarhet_nn_1_N : N ;
  indirekthet_nn_1_N : N ;
  indiskrethet_nn_1_N : N ;
  individualiserbarhet_nn_1_N : N ;
  indoktrinerbarhet_nn_1_N : N ;
  indolens_nn_1_N : N ;
  indragenhet_nn_1_N : N ;
  indraektighet_nn_1_1_N : N ;
  inducerbarhet_nn_1_N : N ;
  induktans_nn_1_N : N ;
  industrialiserbarhet_nn_1_N : N ;
  industridoed_nn_1_1_N : N ;
  industripolitik_nn_1_N : N ;
  inexakthet_nn_1_N : N ;
  infallsrikhet_nn_1_N : N ;
  infantiliserbarhet_nn_1_N : N ;
  infantilisering_nn_1_N : N ;
  infekterbarhet_nn_1_N : N ;
  infiltrerbarhet_nn_1_N : N ;
  infinithet_nn_1_N : N ;
  inflammerbarhet_nn_1_N : N ;
  influerbarhet_nn_1_N : N ;
  inflytelserikhet_nn_1_N : N ;
  informationskrigfoering_nn_1_1_N : N ;
  informationsplikt_nn_1_N : N ;
  informationsrikhet_nn_1_N : N ;
  informationsstress_nn_1_N : N ;
  informerbarhet_nn_1_N : N ;
  infrastrukturalitet_nn_1_N : N ;
  infoeddhet_nn_1_1_N : N ;
  infoersel_nn_1_1_N : N ;
  ingefaera_nn_1_1_N : N ;
  ingefaersdricka_nn_1_1_N : N ;
  ingraverbarhet_nn_1_N : N ;
  ingroddhet_nn_1_N : N ;
  inhalerbarhet_nn_1_N : N ;
  inhiberbarhet_nn_1_N : N ;
  inhibiterbarhet_nn_1_N : N ;
  initiativkraft_nn_1_N : N ;
  initiativrikhet_nn_1_N : N ;
  initierbarhet_nn_1_N : N ;
  injekterbarhet_nn_1_N : N ;
  injicerbarhet_nn_1_N : N ;
  inkarnerbarhet_nn_1_N : N ;
  inkasserbarhet_nn_1_N : N ;
  inklarerbarhet_nn_1_N : N ;
  inkluderbarhet_nn_1_N : N ;
  inknappning_nn_1_N : N ;
  inkompetens_nn_1_N : N ;
  inkomsttaxerbarhet_nn_1_N : N ;
  inkontinens_nn_1_N : N ;
  inkorporerbarhet_nn_1_N : N ;
  inkorrekthet_nn_1_N : N ;
  inkroekthet_nn_1_1_N : N ;
  inkvarterbarhet_nn_1_N : N ;
  inlaerningssvaarighet_nn_1_1_N : N ;
  innehaallslighet_nn_1_1_N : N ;
  innehaallsloeshet_nn_1_1_N : N ;
  innehaallsmaessighet_nn_1_1_N : N ;
  innehaallsrikhet_nn_1_1_N : N ;
  innehaallstomhet_nn_1_1_N : N ;
  innerhand_nn_1_N : N ;
  innerlighet_nn_1_N : N ;
  innerverbarhet_nn_1_N : N ;
  inokulerbarhet_nn_1_N : N ;
  inomhusluft_nn_1_N : N ;
  inomvetenskaplighet_nn_1_N : N ;
  inplanterbarhet_nn_1_N : N ;
  inprogrammering_nn_1_N : N ;
  input_nn_1_N : N ;
  inpyrdhet_nn_1_N : N ;
  inrangerbarhet_nn_1_N : N ;
  inrapporterbarhet_nn_1_N : N ;
  inregistrerbarhet_nn_1_N : N ;
  inrikespolitik_nn_1_N : N ;
  inrikestrafik_nn_1_N : N ;
  inringning_nn_1_N : N ;
  inraettning_nn_2_1_N : N ;
  inscenerbarhet_nn_1_N : N ;
  insektskunnighet_nn_1_N : N ;
  inseminerbarhet_nn_1_N : N ;
  insiktsfullhet_nn_1_N : N ;
  insinuerbarhet_nn_1_N : N ;
  insolvens_nn_1_N : N ;
  inspekterbarhet_nn_1_N : N ;
  inspirerbarhet_nn_1_N : N ;
  installerbarhet_nn_1_N : N ;
  institutionaliserbarhet_nn_1_N : N ;
  instruerbarhet_nn_1_N : N ;
  instrumentalis_nn_1_N : N ;
  instrumentalmusik_nn_1_N : N ;
  instrumenterbarhet_nn_1_N : N ;
  instuderbarhet_nn_1_N : N ;
  instaellbarhet_nn_1_1_N : N ;
  instaellningsbarhet_nn_1_1_N : N ;
  instaengdhet_nn_1_1_N : N ;
  insyn_nn_1_N : N ;
  intagsluft_nn_1_N : N ;
  integrationspolitik_nn_1_N : N ;
  integrerbarhet_nn_1_N : N ;
  intellektualiserbarhet_nn_1_N : N ;
  intelligentia_nn_1_N : N ;
  intensifierbarhet_nn_1_N : N ;
  intensiverbarhet_nn_1_N : N ;
  intensivvaard_nn_1_1_N : N ;
  interfolierbarhet_nn_1_N : N ;
  internaliserbarhet_nn_1_N : N ;
  internationaliserbarhet_nn_1_N : N ;
  internerbarhet_nn_1_N : N ;
  interpellerbarhet_nn_1_N : N ;
  interpolerbarhet_nn_1_N : N ;
  interpreterbarhet_nn_1_N : N ;
  interpunkterbarhet_nn_1_N : N ;
  intervenerbarhet_nn_1_N : N ;
  intimisering_nn_1_N : N ;
  intimrakning_nn_1_N : N ;
  intimsfaer_nn_1_1_N : N ;
  intolerans_nn_1_N : N ;
  intonerbarhet_nn_1_N : N ;
  intresseloeshet_nn_1_1_N : N ;
  intresserbarhet_nn_1_N : N ;
  introducerbarhet_nn_1_N : N ;
  introverthet_nn_1_N : N ;
  invaderbarhet_nn_1_N : N ;
  invalidiserbarhet_nn_1_N : N ;
  invallning_nn_1_N : N ;
  invandhet_nn_1_N : N ;
  invandrarfientlighet_nn_1_N : N ;
  invandrarpolitik_nn_1_N : N ;
  invandrartaethet_nn_1_1_N : N ;
  invandrarundervisning_nn_1_N : N ;
  invandringspolitik_nn_1_N : N ;
  inventerbarhet_nn_1_N : N ;
  inverterbarhet_nn_1_N : N ;
  investerbarhet_nn_1_N : N ;
  investeringspolitik_nn_1_N : N ;
  investitur_nn_1_N : N ;
  inviterbarhet_nn_1_N : N ;
  involverbarhet_nn_1_N : N ;
  inaelvskorv_nn_1_1_N : N ;
  inaatvaendhet_nn_1_1_N : N ;
  irrelevans_nn_1_N : N ;
  irriterbarhet_nn_1_N : N ;
  irrlaerighet_nn_1_1_N : N ;
  isabellafaerg_nn_1_1_N : N ;
  isagogik_nn_1_N : N ;
  isbark_nn_1_N : N ;
  isbergssallad_nn_1_N : N ;
  isbraenna_nn_1_1_N : N ;
  ischias_nn_1_N : N ;
  ischoklad_nn_1_N : N ;
  isdans_nn_1_N : N ;
  ishalka_nn_1_N : N ;
  iskyla_nn_1_N : N ;
  islam_nn_1_N : N ;
  islamiserbarhet_nn_1_N : N ;
  islamisering_nn_1_N : N ;
  isolerbarhet_nn_1_N : N ;
  isop_nn_1_N : N ;
  isracing_nn_1_N : N ;
  issoerja_nn_1_1_N : N ;
  istadaraett_nn_1_1_N : N ;
  istadighet_nn_1_N : N ;
  itererbarhet_nn_1_N : N ;
  iver_nn_1_N : N ;
  ivrighet_nn_1_N : N ;
  jackighet_nn_1_N : N ;
  jacquard_nn_1_N : N ;
  jadeit_nn_1_N : N ;
  jagdrift_nn_1_N : N ;
  jagform_nn_1_N : N ;
  jagkaensla_nn_1_1_N : N ;
  jakaranda_nn_1_N : N ;
  jaktbarhet_nn_1_N : N ;
  jaktlycka_nn_1_N : N ;
  jaktraett_nn_1_1_N : N ;
  jaktvaard_nn_1_1_N : N ;
  jams_nn_1_N : N ;
  jamsrot_nn_1_N : N ;
  janitsjarmusik_nn_1_N : N ;
  januari_nn_1_N : N ;
  jass_nn_1_N : N ;
  java_nn_1_N : N ;
  jazz_nn_1_N : N ;
  jazzifierbarhet_nn_1_N : N ;
  jazzighet_nn_1_N : N ;
  jerikoros_nn_1_N : N ;
  jet_nn_1_N : N ;
  jetdrift_nn_1_N : N ;
  jiddisch_nn_1_N : N ;
  jiujitsu_nn_1_N : N ;
  jobbcoachning_nn_1_N : N ;
  jobbighet_nn_1_N : N ;
  jod_nn_1_N : N ;
  joderbarhet_nn_1_N : N ;
  jodoform_nn_1_N : N ;
  jodsprit_nn_1_N : N ;
  jogging_nn_1_N : N ;
  joggning_nn_1_N : N ;
  jolmighet_nn_1_N : N ;
  jonglerbarhet_nn_1_N : N ;
  joniserbarhet_nn_1_N : N ;
  jonosfaer_nn_1_1_N : N ;
  jordaxel_nn_1_N : N ;
  jordbruksforskning_nn_1_N : N ;
  jordbrukspolitik_nn_1_N : N ;
  jordbundenhet_nn_1_N : N ;
  jordbaevningssaekerhet_nn_1_1_N : N ;
  jordemoder_nn_1_N : N ;
  jordflykt_nn_1_N : N ;
  jordgubbssmak_nn_1_N : N ;
  jordighet_nn_1_N : N ;
  jordlikhet_nn_1_N : N ;
  jordmantel_nn_1_N : N ;
  jordmaan_nn_1_1_N : N ;
  jordroek_nn_1_1_N : N ;
  jordskorpa_nn_1_N : N ;
  jordskugga_nn_1_N : N ;
  jota_nn_2_N : N ;
  journalistik_nn_1_N : N ;
  jourtjaenst_nn_1_1_N : N ;
  judekristenhet_nn_1_N : N ;
  judo_nn_1_N : N ;
  jugendstil_nn_1_N : N ;
  julfoersaeljning_nn_1_1_N : N ;
  juli_nn_1_N : N ;
  julledighet_nn_1_N : N ;
  julmust_nn_1_N : N ;
  julstaemning_nn_1_1_N : N ;
  jultrafik_nn_1_N : N ;
  jumpa_nn_1_N : N ;
  jungfrulighet_nn_1_N : N ;
  juni_nn_1_N : N ;
  juridik_nn_1_N : N ;
  jurisprudens_nn_1_N : N ;
  justehet_nn_1_N : N ;
  justess_nn_1_N : N ;
  justhet_nn_1_N : N ;
  justis_nn_1_N : N ;
  justitiekansler_nn_1_N : N ;
  jutskhet_nn_1_N : N ;
  juvelornamentik_nn_1_N : N ;
  jympa_nn_1_N : N ;
  jymping_nn_1_N : N ;
  jaektighet_nn_1_1_N : N ;
  jaemboerdighet_nn_1_1_N : N ;
  jaemfoerbarhet_nn_1_1_N : N ;
  jaemfoerlighet_nn_1_1_N : N ;
  jaemgodhet_nn_1_1_N : N ;
  jaemmerlaat_nn_1_1_N : N ;
  jaemngodhet_nn_1_1_N : N ;
  jaemnhet_nn_1_1_N : N ;
  jaemnstarkhet_nn_1_1_N : N ;
  jaemnstorhet_nn_1_1_N : N ;
  jaemntjockhet_nn_1_1_N : N ;
  jaemnvarmhet_nn_1_1_N : N ;
  jaemnvikt_nn_1_1_N : N ;
  jaemnaarighet_nn_1_1_N : N ;
  jaemspelthet_nn_1_1_N : N ;
  jaemstarkhet_nn_1_1_N : N ;
  jaemstorhet_nn_1_1_N : N ;
  jaemstaelldhetspolitik_nn_1_1_N : N ;
  jaemtjockhet_nn_1_1_N : N ;
  jaemtskhet_nn_1_1_N : N ;
  jaemvikt_nn_1_1_N : N ;
  jaernbetong_nn_1_1_N : N ;
  jaernbrist_nn_1_1_N : N ;
  jaernboerd_nn_1_1_N : N ;
  jaernfysik_nn_1_1_N : N ;
  jaernglans_nn_1_1_N : N ;
  jaernhaelsa_nn_1_1_N : N ;
  jaernhaardhet_nn_1_1_N : N ;
  jaernkoll_nn_1_1_N : N ;
  jaernockra_nn_1_1_N : N ;
  jaernrikhet_nn_1_1_N : N ;
  jaernspat_nn_1_1_N : N ;
  jaernsvamp_nn_1_1_N : N ;
  jaernvitriol_nn_1_1_N : N ;
  jaernvaegspolitik_nn_1_1_N : N ;
  jaernvaegstrafik_nn_1_1_N : N ;
  jaest_nn_1_1_N : N ;
  jaettedumhet_nn_1_1_N : N ;
  jaettesnygghet_nn_1_1_N : N ;
  jaettesnaellhet_nn_1_1_N : N ;
  jaettestorhet_nn_1_1_N : N ;
  jaettevaext_nn_1_1_N : N ;
  jaevighet_nn_1_1_N : N ;
  joensighet_nn_1_1_N : N ;
  kabbala_nn_1_N : N ;
  kabel_teve_nn_1_N : N ;
  kabeljo_nn_1_N : N ;
  kabelteve_nn_1_N : N ;
  kabinettspolitik_nn_1_N : N ;
  kabinpersonal_nn_1_N : N ;
  kadaverdisciplin_nn_1_N : N ;
  kaffesugenhet_nn_1_N : N ;
  kaffesump_nn_1_N : N ;
  kaffeved_nn_1_N : N ;
  kalandrerbarhet_nn_1_N : N ;
  kalasmat_nn_1_N : N ;
  kalcinerbarhet_nn_1_N : N ;
  kalciumklorid_nn_1_N : N ;
  kalhet_nn_1_N : N ;
  kalibrerbarhet_nn_1_N : N ;
  kaliforniskhet_nn_1_N : N ;
  kalihunger_nn_1_N : N ;
  kalikaa_nn_1_1_N : N ;
  kalilut_nn_1_N : N ;
  kalisalpeter_nn_1_N : N ;
  kaliumklorid_nn_1_N : N ;
  kalkerbarhet_nn_1_N : N ;
  kalkfattighet_nn_1_N : N ;
  kalkmjoelk_nn_1_1_N : N ;
  kalkputs_nn_1_N : N ;
  kalkrikhet_nn_1_N : N ;
  kalkspat_nn_1_N : N ;
  kalkylerbarhet_nn_1_N : N ;
  kallavfettning_nn_1_N : N ;
  kallbrand_nn_1_N : N ;
  kallbraecka_nn_1_1_N : N ;
  kallelseraett_nn_1_1_N : N ;
  kalljord_nn_1_N : N ;
  kallpermanent_nn_1_N : N ;
  kallsinnighet_nn_1_N : N ;
  kallskaal_nn_1_1_N : N ;
  kallsvett_nn_1_N : N ;
  kalluft_nn_1_N : N ;
  kalmerbarhet_nn_1_N : N ;
  kalmus_nn_1_N : N ;
  kalops_nn_1_N : N ;
  kalorifattighet_nn_1_N : N ;
  kaloririkhet_nn_1_N : N ;
  kaluv_nn_1_N : N ;
  kalvbraess_nn_1_1_N : N ;
  kalvdans_nn_1_N : N ;
  kalvkyl_nn_1_N : N ;
  kalvningsfeber_nn_1_N : N ;
  kalvost_nn_1_N : N ;
  kambrik_nn_1_N : N ;
  kameleontiskhet_nn_1_N : N ;
  kamelmjoelk_nn_1_1_N : N ;
  kamelskoetsel_nn_1_1_N : N ;
  kamelull_nn_1_N : N ;
  kameraoevervakning_nn_1_1_N : N ;
  kamfer_nn_1_N : N ;
  kamlott_nn_1_N : N ;
  kammarduk_nn_1_N : N ;
  kammarmusik_nn_1_N : N ;
  kamouflerbarhet_nn_1_N : N ;
  kampanjjournalistik_nn_1_N : N ;
  kampesch_nn_1_N : N ;
  kampkonstnaerlighet_nn_1_1_N : N ;
  kampoduglighet_nn_1_N : N ;
  kamratanda_nn_1_N : N ;
  kamratkaensla_nn_1_1_N : N ;
  kanaliserbarhet_nn_1_N : N ;
  kanderbarhet_nn_1_N : N ;
  kandiderbarhet_nn_1_N : N ;
  kanelbullsdoft_nn_1_N : N ;
  kangas_nn_1_N : N ;
  kaninpuls_nn_1_N : N ;
  kannelerbarhet_nn_1_N : N ;
  kanoneld_nn_1_N : N ;
  kanonfoeda_nn_1_1_N : N ;
  kanoniserbarhet_nn_1_N : N ;
  kanonmat_nn_1_N : N ;
  kanotpaddling_nn_1_N : N ;
  kanslistil_nn_1_N : N ;
  kantighet_nn_1_N : N ;
  kantning_nn_1_N : N ;
  kantstoetthet_nn_1_1_N : N ;
  kanvas_nn_1_N : N ;
  kap_nn_1_N : N ;
  kapacitans_nn_1_N : N ;
  kapillaerkraft_nn_1_1_N : N ;
  kapitalexport_nn_1_N : N ;
  kapitalflykt_nn_1_N : N ;
  kapitaliserbarhet_nn_1_N : N ;
  kapitalstinnhet_nn_1_N : N ;
  kapock_nn_1_N : N ;
  kapprakhet_nn_1_N : N ;
  kapris_nn_2_N : N ;
  kaptenloejtnant_nn_1_1_N : N ;
  karakteriserbarhet_nn_1_N : N ;
  karaktaeriserbarhet_nn_1_1_N : N ;
  karaktaersfasthet_nn_1_1_N : N ;
  karaktaersloeshet_nn_1_1_N : N ;
  karambolerbarhet_nn_1_N : N ;
  karamboll_nn_1_N : N ;
  karantaensflagg_nn_1_1_N : N ;
  karbol_nn_1_N : N ;
  karboniserbarhet_nn_1_N : N ;
  karbonisering_nn_1_N : N ;
  karburatorsprit_nn_1_N : N ;
  kardemumma_nn_1_N : N ;
  kardull_nn_1_N : N ;
  karens_nn_1_N : N ;
  karenstid_nn_1_N : N ;
  karghet_nn_1_N : N ;
  karies_nn_1_N : N ;
  karikerbarhet_nn_1_N : N ;
  karlaktighet_nn_1_N : N ;
  karlavulenhet_nn_1_N : N ;
  karlgalenhet_nn_1_N : N ;
  karljohan_nn_1_N : N ;
  karljohansstil_nn_1_N : N ;
  karltokighet_nn_1_N : N ;
  karriaerlystnad_nn_1_1_N : N ;
  karskhet_nn_1_N : N ;
  karterbarhet_nn_1_N : N ;
  kartighet_nn_1_N : N ;
  kartong_nn_2_N : N ;
  kartonnerbarhet_nn_1_N : N ;
  kasper_nn_1_N : N ;
  kassava_nn_1_N : N ;
  kasseler_nn_1_N : N ;
  kasserbarhet_nn_1_N : N ;
  kassettradio_nn_1_N : N ;
  kasshet_nn_1_N : N ;
  kassler_nn_1_N : N ;
  kassunsjuka_nn_1_N : N ;
  kasteld_nn_1_N : N ;
  kastloeshet_nn_1_1_N : N ;
  kastor_nn_1_N : N ;
  kastrerbarhet_nn_1_N : N ;
  kastsjuka_nn_1_N : N ;
  kasuistik_nn_1_N : N ;
  kasunsjuka_nn_1_N : N ;
  katalogiserbarhet_nn_1_N : N ;
  katalys_nn_1_N : N ;
  katalyserbarhet_nn_1_N : N ;
  katastrofhantering_nn_1_N : N ;
  kategoriserbarhet_nn_1_N : N ;
  kateteriserbarhet_nn_1_N : N ;
  katetriserbarhet_nn_1_N : N ;
  katgut_nn_1_N : N ;
  katighet_nn_1_N : N ;
  katt_nn_2_N : N ;
  kattaktighet_nn_1_N : N ;
  kattblick_nn_1_N : N ;
  kattfot_nn_1_N : N ;
  kattmat_nn_1_N : N ;
  kattmynta_nn_1_N : N ;
  kattost_nn_1_N : N ;
  kattpest_nn_1_N : N ;
  kattsand_nn_1_N : N ;
  kauteriserbarhet_nn_1_N : N ;
  kaxighet_nn_1_N : N ;
  kedjehastighet_nn_1_N : N ;
  kedjespaenning_nn_1_1_N : N ;
  kejsar_nn_1_N : N ;
  kejsarlikhet_nn_1_N : N ;
  kejsarstil_nn_1_N : N ;
  kejserlighet_nn_1_N : N ;
  kelenhet_nn_1_N : N ;
  kelighet_nn_1_N : N ;
  kelp_nn_1_N : N ;
  kelsjukhet_nn_1_N : N ;
  kemiteknik_nn_1_N : N ;
  keramik_nn_1_N : N ;
  keso_nn_1_N : N ;
  ketchup_nn_1_N : N ;
  kevlar_nn_1_N : N ;
  kick_off_nn_1_N : N ;
  kikhosta_nn_1_N : N ;
  kiliasm_nn_1_N : N ;
  killerinstinkt_nn_1_N : N ;
  killighet_nn_1_N : N ;
  killkaerlek_nn_1_1_N : N ;
  kilskrift_nn_1_N : N ;
  kimroek_nn_1_1_N : N ;
  kina_nn_1_N : N ;
  kinabark_nn_1_N : N ;
  kinamat_nn_1_N : N ;
  kindergarten_nn_1_N : N ;
  kinematik_nn_1_N : N ;
  kinetik_nn_1_N : N ;
  kinkighet_nn_1_N : N ;
  kiosklitteratur_nn_1_N : N ;
  kiropraktik_nn_1_N : N ;
  kirskaal_nn_1_1_N : N ;
  kiselkarbid_nn_1_N : N ;
  kissnoedighet_nn_1_1_N : N ;
  kittlighet_nn_1_N : N ;
  kjolloeshet_nn_1_1_N : N ;
  kladdighet_nn_1_N : N ;
  kladistik_nn_1_N : N ;
  klagolaat_nn_1_1_N : N ;
  klamydia_nn_1_N : N ;
  klandervaerdhet_nn_1_1_N : N ;
  klangfullhet_nn_1_N : N ;
  klangloeshet_nn_1_1_N : N ;
  klapper_nn_2_N : N ;
  klappgroet_nn_1_1_N : N ;
  klappshopping_nn_1_N : N ;
  klarerbarhet_nn_1_N : N ;
  klarsyn_nn_1_N : N ;
  klarsynthet_nn_1_N : N ;
  klartext_nn_1_N : N ;
  klartaenkthet_nn_1_1_N : N ;
  klarvakenhet_nn_1_N : N ;
  klaroegdhet_nn_1_1_N : N ;
  klassificerbarhet_nn_1_N : N ;
  klassloeshet_nn_1_1_N : N ;
  klassmedvetenhet_nn_1_N : N ;
  klasstillhoerighet_nn_1_1_N : N ;
  klatschighet_nn_1_N : N ;
  klemighet_nn_1_N : N ;
  klenhet_nn_1_N : N ;
  klenmodighet_nn_1_N : N ;
  klentrogenhet_nn_1_N : N ;
  klenvuxenhet_nn_1_N : N ;
  klibbighet_nn_1_N : N ;
  klimatalarmism_nn_1_N : N ;
  klimatforskning_nn_1_N : N ;
  klimatstatistik_nn_1_N : N ;
  klimataangest_nn_1_1_N : N ;
  klippighet_nn_1_N : N ;
  klistervalla_nn_1_N : N ;
  klistrighet_nn_1_N : N ;
  klockarfar_nn_1_N : N ;
  klockform_nn_1_N : N ;
  klockljung_nn_1_N : N ;
  klockradio_nn_1_N : N ;
  klockrenhet_nn_1_N : N ;
  klor_nn_1_N : N ;
  klorerbarhet_nn_1_N : N ;
  klorex_nn_1_N : N ;
  klorkalk_nn_1_N : N ;
  kloroform_nn_1_N : N ;
  klossighet_nn_1_N : N ;
  klot_nn_2_N : N ;
  klotrundhet_nn_1_N : N ;
  klotsporighet_nn_1_N : N ;
  klottrighet_nn_1_N : N ;
  klumpfot_nn_1_N : N ;
  klunsighet_nn_1_N : N ;
  klyftighet_nn_1_N : N ;
  klyftpotatis_nn_1_N : N ;
  klyschighet_nn_1_N : N ;
  klyvbarhet_nn_1_N : N ;
  klaedgalenhet_nn_1_1_N : N ;
  klaedpoker_nn_1_1_N : N ;
  klaedsamhet_nn_1_1_N : N ;
  klaedsoemnad_nn_1_1_N : N ;
  klaemmighet_nn_1_1_N : N ;
  klaengighet_nn_1_1_N : N ;
  klaervoajans_nn_1_1_N : N ;
  klaada_nn_1_1_N : N ;
  klaafingrighet_nn_1_1_N : N ;
  kloevertroetthet_nn_1_1_N : N ;
  knack_nn_2_N : N ;
  knackighet_nn_1_N : N ;
  knalhet_nn_1_N : N ;
  knallgas_nn_1_N : N ;
  knallhet_nn_1_N : N ;
  knapphaendighet_nn_1_1_N : N ;
  knaprighet_nn_1_N : N ;
  knarkbekaempning_nn_1_1_N : N ;
  knarklangning_nn_1_N : N ;
  knarksmuggling_nn_1_N : N ;
  knarrighet_nn_1_N : N ;
  knasprighet_nn_1_N : N ;
  knastrighet_nn_1_N : N ;
  knipslughet_nn_1_N : N ;
  knittel_nn_1_N : N ;
  knivskarphet_nn_1_N : N ;
  knoppighet_nn_1_N : N ;
  knottrighet_nn_1_N : N ;
  knubbighet_nn_1_N : N ;
  knyckighet_nn_1_N : N ;
  knaeckthet_nn_1_1_N : N ;
  knaepphet_nn_1_1_N : N ;
  knaesittning_nn_1_1_N : N ;
  knaesvaghet_nn_1_1_N : N ;
  knaadbarhet_nn_1_1_N : N ;
  knoekfullhet_nn_1_1_N : N ;
  knoelaktighet_nn_1_1_N : N ;
  knoelros_nn_1_1_N : N ;
  koafferbarhet_nn_1_N : N ;
  koagulerbarhet_nn_1_N : N ;
  kobenthet_nn_1_N : N ;
  kobingo_nn_1_N : N ;
  kobolt_nn_1_N : N ;
  koboltglans_nn_1_N : N ;
  kod_nn_2_N : N ;
  kodifierbarhet_nn_1_N : N ;
  kodilj_nn_1_N : N ;
  koexistens_nn_1_N : N ;
  koherens_nn_1_N : N ;
  koineisering_nn_1_N : N ;
  koka_nn_2_N : N ;
  koketthet_nn_1_N : N ;
  kokkonst_nn_1_N : N ;
  kokos_nn_1_N : N ;
  kokosmjoelk_nn_1_1_N : N ;
  koks_nn_1_N : N ;
  kol_14_metod_nn_1_N : N ;
  koldioxidavskiljning_nn_1_N : N ;
  koldioxidlagring_nn_1_N : N ;
  koldisulfid_nn_1_N : N ;
  kolera_nn_1_N : N ;
  kolik_nn_1_N : N ;
  kolit_nn_1_N : N ;
  koll_nn_2_N : N ;
  kollastkapacitet_nn_1_N : N ;
  kollationerbarhet_nn_1_N : N ;
  kollekta_nn_1_N : N ;
  kollektiviserbarhet_nn_1_N : N ;
  kollektivtrafik_nn_1_N : N ;
  koller_nn_1_N : N ;
  kollrighet_nn_1_N : N ;
  kolm_nn_1_N : N ;
  kolmilning_nn_1_N : N ;
  kolmonoxid_nn_1_N : N ;
  kolon_nn_2_N : N ;
  kolonialpolitik_nn_1_N : N ;
  kolonialstil_nn_1_N : N ;
  kolonialtid_nn_1_N : N ;
  koloniserbarhet_nn_1_N : N ;
  kolorerbarhet_nn_1_N : N ;
  koloxid_nn_1_N : N ;
  kolportagemaessighet_nn_1_1_N : N ;
  kolporterbarhet_nn_1_N : N ;
  kolstybb_nn_1_N : N ;
  kolsvavla_nn_1_N : N ;
  kolsyresnoe_nn_1_1_N : N ;
  koltetraklorid_nn_1_N : N ;
  kombinabilitet_nn_1_N : N ;
  kombinerbarhet_nn_1_N : N ;
  komfort_nn_1_N : N ;
  komik_nn_1_N : N ;
  komjoelk_nn_1_1_N : N ;
  kommandoton_nn_1_N : N ;
  kommaterbarhet_nn_1_N : N ;
  kommenderbarhet_nn_1_N : N ;
  kommenterbarhet_nn_1_N : N ;
  kommersialiserbarhet_nn_1_N : N ;
  kommiss_nn_1_N : N ;
  kommunaliserbarhet_nn_1_N : N ;
  kommunicerbarhet_nn_1_N : N ;
  kommuterbarhet_nn_1_N : N ;
  kompakthet_nn_1_N : N ;
  kompanjonskap_nn_1_N : N ;
  komparerbarhet_nn_1_N : N ;
  kompenserbarhet_nn_1_N : N ;
  kompetensutveckling_nn_1_N : N ;
  kompilerbarhet_nn_1_N : N ;
  kompledighet_nn_1_N : N ;
  kompletterbarhet_nn_1_N : N ;
  kompletthet_nn_1_N : N ;
  komplexhet_nn_1_N : N ;
  komplicerbarhet_nn_1_N : N ;
  komplimenterbarhet_nn_1_N : N ;
  komponerbarhet_nn_1_N : N ;
  komposterbarhet_nn_1_N : N ;
  komposteringsbarhet_nn_1_N : N ;
  komprimerbarhet_nn_1_N : N ;
  komprometterbarhet_nn_1_N : N ;
  kompromissloeshet_nn_1_1_N : N ;
  koncentrerbarhet_nn_1_N : N ;
  koncessionerbarhet_nn_1_N : N ;
  koncilians_nn_1_N : N ;
  koncipierbarhet_nn_1_N : N ;
  koncishet_nn_1_N : N ;
  kondemnerbarhet_nn_1_N : N ;
  kondenserbarhet_nn_1_N : N ;
  kondis_nn_2_N : N ;
  konditionerbarhet_nn_1_N : N ;
  kondolerbarhet_nn_1_N : N ;
  konduktans_nn_1_N : N ;
  konfekt_nn_1_N : N ;
  konfessionsloeshet_nn_1_1_N : N ;
  konfirmandundervisning_nn_1_N : N ;
  konfirmerbarhet_nn_1_N : N ;
  konfiskerbarhet_nn_1_N : N ;
  konfliktraedsla_nn_1_1_N : N ;
  konfliktskygghet_nn_1_N : N ;
  konfronterbarhet_nn_1_N : N ;
  konfunderbarhet_nn_1_N : N ;
  kongruenthet_nn_1_N : N ;
  kongruerbarhet_nn_1_N : N ;
  konjugerbarhet_nn_1_N : N ;
  konjunktivit_nn_1_N : N ;
  konjunkturpolitik_nn_1_N : N ;
  konkluderbarhet_nn_1_N : N ;
  konkrethet_nn_1_N : N ;
  konkretiserbarhet_nn_1_N : N ;
  konkurrens_nn_1_N : N ;
  konkurrenskraft_nn_1_N : N ;
  konkurrensutsatthet_nn_1_N : N ;
  konkursmaessighet_nn_1_1_N : N ;
  konsekventhet_nn_1_N : N ;
  konsensus_nn_1_N : N ;
  konserverbarhet_nn_1_N : N ;
  konsignerbarhet_nn_1_N : N ;
  konsoliderbarhet_nn_1_N : N ;
  konstans_nn_1_N : N ;
  konstaterbarhet_nn_1_N : N ;
  konsternerbarhet_nn_1_N : N ;
  konstflit_nn_1_N : N ;
  konstfoerfarenhet_nn_1_1_N : N ;
  konstgjordhet_nn_1_N : N ;
  konstgoedsel_nn_1_1_N : N ;
  konstituerbarhet_nn_1_N : N ;
  konstkritik_nn_1_N : N ;
  konstmusik_nn_1_N : N ;
  konstmaessighet_nn_1_1_N : N ;
  konstnaerlighet_nn_1_1_N : N ;
  konstnaersblick_nn_1_1_N : N ;
  konstnaerstaethet_nn_1_1_N : N ;
  konstrikhet_nn_1_N : N ;
  konstruerbarhet_nn_1_N : N ;
  konstskicklighet_nn_1_N : N ;
  konstsloejd_nn_1_1_N : N ;
  konsulterbarhet_nn_1_N : N ;
  konsumentpolitik_nn_1_N : N ;
  konsumerbarhet_nn_1_N : N ;
  kontaminerbarhet_nn_1_N : N ;
  kontenans_nn_1_N : N ;
  kontenta_nn_1_N : N ;
  konterbarhet_nn_1_N : N ;
  kontinentaldrift_nn_1_N : N ;
  kontingenterbarhet_nn_1_N : N ;
  kontinuerlighet_nn_1_N : N ;
  kontoriserbarhet_nn_1_N : N ;
  kontraherbarhet_nn_1_N : N ;
  kontrakterbarhet_nn_1_N : N ;
  kontraktsenlighet_nn_1_N : N ;
  kontraktsvidrighet_nn_1_N : N ;
  kontramanderbarhet_nn_1_N : N ;
  kontraoktav_nn_1_N : N ;
  kontrapunkt_nn_1_N : N ;
  kontrasignerbarhet_nn_1_N : N ;
  kontrasterbarhet_nn_1_N : N ;
  kontribuerbarhet_nn_1_N : N ;
  kontroll_nn_1_N : N ;
  kontrollerbarhet_nn_1_N : N ;
  konturerbarhet_nn_1_N : N ;
  konturloeshet_nn_1_1_N : N ;
  konturskarphet_nn_1_N : N ;
  konungslighet_nn_1_N : N ;
  konvalescens_nn_1_N : N ;
  konvenans_nn_1_N : N ;
  konvergens_nn_1_N : N ;
  konvergerbarhet_nn_1_N : N ;
  konverserbarhet_nn_1_N : N ;
  konverterbarhet_nn_1_N : N ;
  konvojerbarhet_nn_1_N : N ;
  koordinerbarhet_nn_1_N : N ;
  kopierbarhet_nn_1_N : N ;
  kopparglans_nn_1_N : N ;
  kopparkis_nn_1_N : N ;
  kopparaerg_nn_1_1_N : N ;
  koppaerrighet_nn_1_1_N : N ;
  kopra_nn_1_N : N ;
  koran_nn_1_N : N ;
  kord_nn_1_N : N ;
  korderoj_nn_1_N : N ;
  korgboll_nn_1_N : N ;
  koriander_nn_1_N : N ;
  korndraell_nn_1_1_N : N ;
  kornighet_nn_1_N : N ;
  kornsnoe_nn_1_1_N : N ;
  koronarskleros_nn_1_N : N ;
  korplaat_nn_1_1_N : N ;
  korpning_nn_1_N : N ;
  korporationsidrott_nn_1_N : N ;
  korpulens_nn_1_N : N ;
  korpuslingvistik_nn_1_N : N ;
  korrekthet_nn_1_N : N ;
  korrelerbarhet_nn_1_N : N ;
  korridorpolitik_nn_1_N : N ;
  korrigerbarhet_nn_1_N : N ;
  korroderbarhet_nn_1_N : N ;
  korrugerbarhet_nn_1_N : N ;
  korrumperbarhet_nn_1_N : N ;
  korrupthet_nn_1_N : N ;
  korruptionsbekaempning_nn_1_1_N : N ;
  korsetterbarhet_nn_1_N : N ;
  korsvaedring_nn_1_1_N : N ;
  kortbenthet_nn_1_N : N ;
  kortfristighet_nn_1_N : N ;
  korthuggenhet_nn_1_N : N ;
  korthaarighet_nn_1_1_N : N ;
  kortklippning_nn_1_N : N ;
  kortklippthet_nn_1_N : N ;
  kortsiktighet_nn_1_N : N ;
  kortskallighet_nn_1_N : N ;
  kortsynthet_nn_1_N : N ;
  korttidsfoervaring_nn_1_1_N : N ;
  korttaenkthet_nn_1_1_N : N ;
  kortvarighet_nn_1_N : N ;
  kortvuxenhet_nn_1_N : N ;
  kortvaexthet_nn_1_1_N : N ;
  korvighet_nn_1_N : N ;
  kosa_nn_2_N : N ;
  koschenill_nn_1_N : N ;
  koskit_nn_1_N : N ;
  kosmetik_nn_1_N : N ;
  kosmetika_nn_1_N : N ;
  kost_nn_1_N : N ;
  kostlighet_nn_1_N : N ;
  kostsamhet_nn_1_N : N ;
  kostymerbarhet_nn_1_N : N ;
  kova_nn_1_N : N ;
  kox_nn_1_N : N ;
  kooegdhet_nn_1_1_N : N ;
  krabbhet_nn_1_N : N ;
  krackelerbarhet_nn_1_N : N ;
  krackelyr_nn_1_N : N ;
  krafsighet_nn_1_N : N ;
  kraftfullhet_nn_1_N : N ;
  kraftighet_nn_1_N : N ;
  kraftnedsaettning_nn_1_1_N : N ;
  kraftutveckling_nn_1_N : N ;
  kragloeshet_nn_1_1_N : N ;
  kramhet_nn_1_N : N ;
  krampaktighet_nn_1_N : N ;
  kramsnoe_nn_1_1_N : N ;
  krankhet_nn_1_N : N ;
  krapp_nn_1_N : N ;
  krasshet_nn_1_N : N ;
  kravallpolis_nn_1_N : N ;
  kravloeshet_nn_1_1_N : N ;
  kravretorik_nn_1_N : N ;
  kreationism_nn_1_N : N ;
  kreatursloeshet_nn_1_1_N : N ;
  kreatursskoetsel_nn_1_1_N : N ;
  kredd_nn_1_N : N ;
  kreddighet_nn_1_N : N ;
  krediterbarhet_nn_1_N : N ;
  kreerbarhet_nn_1_N : N ;
  kremerbarhet_nn_1_N : N ;
  kremlvaenlighet_nn_1_1_N : N ;
  kreolisering_nn_1_N : N ;
  kreoliseringsforskning_nn_1_N : N ;
  kreperbarhet_nn_1_N : N ;
  kreverbarhet_nn_1_N : N ;
  kricket_nn_1_N : N ;
  krigarkast_nn_1_N : N ;
  krigsiver_nn_1_N : N ;
  krigskonst_nn_1_N : N ;
  krigslist_nn_1_N : N ;
  krigslycka_nn_1_N : N ;
  krigsplacerbarhet_nn_1_N : N ;
  krigspropaganda_nn_1_N : N ;
  krigsraett_nn_1_1_N : N ;
  krigstjaenst_nn_1_1_N : N ;
  krigstroetthet_nn_1_1_N : N ;
  krill_nn_1_N : N ;
  kriminaliserbarhet_nn_1_N : N ;
  kriminalistik_nn_1_N : N ;
  kriminaljournalistik_nn_1_N : N ;
  kriminalpolis_nn_1_N : N ;
  kriminalpolitik_nn_1_N : N ;
  kriminalteknik_nn_1_N : N ;
  kriminalvaard_nn_1_1_N : N ;
  kringsjuka_nn_1_N : N ;
  kringsyn_nn_1_N : N ;
  kringsynthet_nn_1_N : N ;
  krishantering_nn_1_N : N ;
  krishjaelp_nn_1_1_N : N ;
  krismedvetenhet_nn_1_N : N ;
  krispighet_nn_1_N : N ;
  krispolitik_nn_1_N : N ;
  kristalliserbarhet_nn_1_N : N ;
  kristallos_nn_1_N : N ;
  kristlighet_nn_1_N : N ;
  kristtrogenhet_nn_1_N : N ;
  kristyr_nn_1_N : N ;
  kritiklust_nn_1_N : N ;
  kritikloeshet_nn_1_1_N : N ;
  kritiserbarhet_nn_1_N : N ;
  krittid_nn_1_N : N ;
  krocket_nn_1_N : N ;
  krokant_nn_1_N : N ;
  kroknaesthet_nn_1_1_N : N ;
  krokryggighet_nn_1_N : N ;
  krokvuxenhet_nn_1_N : N ;
  krollsplint_nn_1_N : N ;
  kromatik_nn_1_N : N ;
  kromning_nn_1_N : N ;
  kroppsaga_nn_1_N : N ;
  kroppsbehaaring_nn_1_1_N : N ;
  kroppskontakt_nn_1_N : N ;
  kroppskontroll_nn_1_N : N ;
  kroppskultur_nn_1_N : N ;
  kroppslighet_nn_2_N : N ;
  kroppspulsaader_nn_1_1_N : N ;
  kroppstyngd_nn_1_N : N ;
  kroppsvisiterbarhet_nn_1_N : N ;
  krullhaarighet_nn_1_1_N : N ;
  krullighet_nn_1_N : N ;
  krumhet_nn_1_N : N ;
  krumpenhet_nn_1_N : N ;
  krupp_nn_1_N : N ;
  kruserlighet_nn_1_N : N ;
  krushaarighet_nn_1_1_N : N ;
  krusidullighet_nn_1_N : N ;
  kruska_nn_1_N : N ;
  kruskaal_nn_1_1_N : N ;
  krusmynta_nn_1_N : N ;
  kruspersilja_nn_1_N : N ;
  krutroek_nn_1_1_N : N ;
  kruttorrhet_nn_1_N : N ;
  kryckestaat_nn_1_1_N : N ;
  kryckighet_nn_1_N : N ;
  kryhet_nn_1_N : N ;
  kryolit_nn_1_N : N ;
  krypterbarhet_nn_1_N : N ;
  kryss_nn_2_N : N ;
  kraeftgaang_nn_1_1_N : N ;
  kraeftpest_nn_1_1_N : N ;
  kraekfaerdighet_nn_1_1_N : N ;
  kraem_nn_2_1_N : N ;
  kraepp_nn_1_1_N : N ;
  kraesenhet_nn_1_1_N : N ;
  kraeslighet_nn_1_1_N : N ;
  kraakspark_nn_1_1_N : N ;
  kraaksaang_nn_1_1_N : N ;
  kraakvicker_nn_1_1_N : N ;
  kraakvinkel_nn_1_1_N : N ;
  kraamning_nn_1_1_N : N ;
  kroekthet_nn_1_1_N : N ;
  kuberbarhet_nn_1_N : N ;
  kujonerbarhet_nn_1_N : N ;
  kulenhet_nn_1_N : N ;
  kull_nn_2_N : N ;
  kullighet_nn_1_N : N ;
  kullrighet_nn_1_N : N ;
  kulsinter_nn_1_N : N ;
  kultis_nn_1_N : N ;
  kultiverbarhet_nn_1_N : N ;
  kulturarrogans_nn_1_N : N ;
  kulturfientlighet_nn_1_N : N ;
  kulturjournalistik_nn_1_N : N ;
  kulturminnesvaard_nn_1_1_N : N ;
  kulturpolitik_nn_1_N : N ;
  kultursvaeng_nn_1_1_N : N ;
  kuloerthet_nn_1_1_N : N ;
  kumulerbarhet_nn_1_N : N ;
  kumys_nn_1_N : N ;
  kundnoejdhet_nn_1_1_N : N ;
  kundtjaenst_nn_1_1_N : N ;
  kungaglans_nn_1_N : N ;
  kunnighet_nn_1_N : N ;
  kunskapshunger_nn_1_N : N ;
  kunskapstoerst_nn_1_1_N : N ;
  kuperbarhet_nn_1_N : N ;
  kupighet_nn_1_N : N ;
  kupolformighet_nn_1_N : N ;
  kuppberedskap_nn_1_N : N ;
  kuraterbarhet_nn_1_N : N ;
  kurerbarhet_nn_1_N : N ;
  kurialstil_nn_1_N : N ;
  kurra_nn_1_N : N ;
  kurragoemma_nn_1_1_N : N ;
  kursiverbarhet_nn_1_N : N ;
  kurtiserbarhet_nn_1_N : N ;
  kurvighet_nn_1_N : N ;
  kurvteknik_nn_1_N : N ;
  kustfart_nn_1_N : N ;
  kustradio_nn_1_N : N ;
  kusttrafik_nn_1_N : N ;
  kutryggighet_nn_1_N : N ;
  kuverterbarhet_nn_1_N : N ;
  kvacksalverilagstiftning_nn_1_N : N ;
  kvadratur_nn_1_N : N ;
  kvadrerbarhet_nn_1_N : N ;
  kvalfullhet_nn_1_N : N ;
  kvalfylldhet_nn_1_N : N ;
  kvalificerbarhet_nn_1_N : N ;
  kvalitetstid_nn_1_N : N ;
  kvantelektrodynamik_nn_1_N : N ;
  kvantfysik_nn_1_N : N ;
  kvantifierbarhet_nn_1_N : N ;
  kvantmekanik_nn_1_N : N ;
  kvarg_nn_1_N : N ;
  kvark_nn_2_N : N ;
  kvarka_nn_1_N : N ;
  kvarlaatenskap_nn_1_1_N : N ;
  kvarto_nn_1_N : N ;
  kvass_nn_2_N : N ;
  kvassia_nn_1_N : N ;
  kvavhet_nn_1_N : N ;
  kverulans_nn_1_N : N ;
  kvickrot_nn_1_N : N ;
  kvicksand_nn_1_N : N ;
  kvicktaenkthet_nn_1_1_N : N ;
  kvickoegdhet_nn_1_1_N : N ;
  kvillajabark_nn_1_N : N ;
  kvinnlighet_nn_1_N : N ;
  kvinnofientlighet_nn_1_N : N ;
  kvinnofrid_nn_1_N : N ;
  kvinnokamp_nn_1_N : N ;
  kvinnopolitik_nn_1_N : N ;
  kvinnosak_nn_1_N : N ;
  kvinnosida_nn_1_N : N ;
  kvintessens_nn_1_N : N ;
  kvisslighet_nn_1_N : N ;
  kvistighet_nn_1_N : N ;
  kvistloeshet_nn_1_1_N : N ;
  kvistning_nn_1_N : N ;
  kvitterbarhet_nn_1_N : N ;
  kvittrighet_nn_1_N : N ;
  kvoterbarhet_nn_1_N : N ;
  kvaellslighet_nn_1_1_N : N ;
  kvaellsluft_nn_1_1_N : N ;
  kvaellsmat_nn_1_1_N : N ;
  kvaellspress_nn_1_1_N : N ;
  kvaevebalans_nn_1_1_N : N ;
  kvaevgas_nn_1_1_N : N ;
  kyffighet_nn_1_N : N ;
  kylighet_nn_1_N : N ;
  kylsighet_nn_1_N : N ;
  kylslagenhet_nn_1_N : N ;
  kyndel_nn_1_N : N ;
  kyrklighet_nn_1_N : N ;
  kyrkofrid_nn_1_N : N ;
  kyrkogaang_nn_1_1_N : N ;
  kyrkomusik_nn_1_N : N ;
  kyrkostat_nn_1_N : N ;
  kyrkotukt_nn_1_N : N ;
  kyrksamhet_nn_1_N : N ;
  kysstaeckhet_nn_1_1_N : N ;
  kyssaekerhet_nn_1_1_N : N ;
  kaegelformighet_nn_1_1_N : N ;
  kaelkborgerlighet_nn_1_1_N : N ;
  kaellforskning_nn_1_1_N : N ;
  kaellkod_nn_1_1_N : N ;
  kaellkritik_nn_1_1_N : N ;
  kaellsorterbarhet_nn_1_1_N : N ;
  kaellsortering_nn_1_1_N : N ;
  kaempighet_nn_1_1_N : N ;
  kaendhet_nn_1_1_N : N ;
  kaeng_nn_2_1_N : N ;
  kaennarblick_nn_1_1_N : N ;
  kaennarmin_nn_1_1_N : N ;
  kaennbarhet_nn_1_1_N : N ;
  kaensel_nn_1_1_N : N ;
  kaenslofylldhet_nn_1_1_N : N ;
  kaensloloeshet_nn_2_1_N : N ;
  kaenslomaessighet_nn_1_1_N : N ;
  kaerhet_nn_1_1_N : N ;
  kaeringtand_nn_1_1_N : N ;
  kaerkommenhet_nn_1_1_N : N ;
  kaerleksfullhet_nn_1_1_N : N ;
  kaerlekskrankhet_nn_1_1_N : N ;
  kaerlekslycka_nn_1_1_N : N ;
  kaerlekslyrik_nn_1_1_N : N ;
  kaerleksloeshet_nn_1_1_N : N ;
  kaerleksoert_nn_1_1_N : N ;
  kaerlighet_nn_1_1_N : N ;
  kaerlkramp_nn_1_1_N : N ;
  kaernbraenslehantering_nn_1_1_N : N ;
  kaernfur_nn_1_1_N : N ;
  kaernfysik_nn_1_1_N : N ;
  kaernis_nn_1_1_N : N ;
  kaernkraft_nn_1_1_N : N ;
  kaernkraftskapacitet_nn_1_1_N : N ;
  kaernkraftsutbyggnad_nn_1_1_N : N ;
  kaernmjoelk_nn_1_1_N : N ;
  kaernteknik_nn_1_1_N : N ;
  kaernved_nn_1_1_N : N ;
  kaervhet_nn_1_1_N : N ;
  kaeraelskelighet_nn_1_1_N : N ;
  kaeraelsklighet_nn_1_1_N : N ;
  kaettja_nn_1_1_N : N ;
  kaettjefullhet_nn_1_1_N : N ;
  kaadrikhet_nn_1_1_N : N ;
  kaal_nn_1_1_N : N ;
  kaathet_nn_1_1_N : N ;
  kaatma_nn_1_1_N : N ;
  koeld_nn_1_1_N : N ;
  koeldbestaendighet_nn_1_1_N : N ;
  koeldhaerdighet_nn_1_1_N : N ;
  koenlighet_nn_1_1_N : N ;
  koenloeshet_nn_1_1_N : N ;
  koensapartheid_nn_1_1_N : N ;
  koensbehaaring_nn_1_1_N : N ;
  koensbundenhet_nn_1_1_N : N ;
  koensdiskriminerbarhet_nn_1_1_N : N ;
  koensdrift_nn_1_1_N : N ;
  koenskvoterbarhet_nn_1_1_N : N ;
  koenskyla_nn_1_1_N : N ;
  koenslighet_nn_1_1_N : N ;
  koensmakt_nn_1_1_N : N ;
  koensmaktsordning_nn_1_1_N : N ;
  koensmogenhet_nn_1_1_N : N ;
  koenspanik_nn_1_1_N : N ;
  koensstympning_nn_1_1_N : N ;
  koephets_nn_1_1_N : N ;
  koepkraft_nn_1_1_N : N ;
  koeplust_nn_1_1_N : N ;
  koerbarhet_nn_1_1_N : N ;
  koerdhet_nn_1_1_N : N ;
  koersel_nn_1_1_N : N ;
  koersaang_nn_1_1_N : N ;
  koervel_nn_1_1_N : N ;
  koettboskap_nn_1_1_N : N ;
  koettfaers_nn_1_1_N : N ;
  koettighet_nn_1_1_N : N ;
  koettproduktion_nn_1_1_N : N ;
  koettslighet_nn_1_1_N : N ;
  labialiserbarhet_nn_1_N : N ;
  labrador_nn_2_N : N ;
  lack_nn_2_N : N ;
  lackerbarhet_nn_1_N : N ;
  lackmus_nn_1_N : N ;
  lacknafta_nn_1_N : N ;
  ladylikhet_nn_1_N : N ;
  lafsighet_nn_1_N : N ;
  lag_nn_3_N : N ;
  laganda_nn_1_N : N ;
  lagenlighet_nn_1_N : N ;
  lager_nn_3_N : N ;
  lagerkoers_nn_1_1_N : N ;
  lagfarenhet_nn_1_N : N ;
  lagiskhet_nn_1_N : N ;
  lagklokhet_nn_1_N : N ;
  lagkunskap_nn_1_N : N ;
  laglydighet_nn_1_N : N ;
  laglydnad_nn_1_N : N ;
  lagomhet_nn_1_N : N ;
  lagring_nn_1_N : N ;
  lagstridighet_nn_1_N : N ;
  lakka_nn_1_N : N ;
  lakrits_nn_1_N : N ;
  laktos_nn_1_N : N ;
  laktosintolerans_nn_1_N : N ;
  lambada_nn_1_N : N ;
  lamenterbarhet_nn_1_N : N ;
  lamhet_nn_1_N : N ;
  laminerbarhet_nn_1_N : N ;
  landsbygd_nn_1_N : N ;
  landsflykt_nn_1_N : N ;
  landsfoerraediskhet_nn_1_1_N : N ;
  landslagstraening_nn_1_1_N : N ;
  landsort_nn_1_N : N ;
  landsortsmaessighet_nn_1_1_N : N ;
  landsraett_nn_1_1_N : N ;
  landssorg_nn_1_N : N ;
  landstorm_nn_1_N : N ;
  langetterbarhet_nn_1_N : N ;
  lank_nn_1_N : N ;
  lanserbarhet_nn_1_N : N ;
  lantlighet_nn_1_N : N ;
  lantluft_nn_1_N : N ;
  lapidarstil_nn_1_N : N ;
  lapis_nn_1_N : N ;
  lapiserbarhet_nn_1_N : N ;
  lappsjuka_nn_1_N : N ;
  lapskhet_nn_1_N : N ;
  larmberedskap_nn_1_N : N ;
  larvighet_nn_1_N : N ;
  laserbarhet_nn_1_N : N ;
  lastelighet_nn_1_N : N ;
  lastfullhet_nn_1_N : N ;
  lasting_nn_1_N : N ;
  latens_nn_1_N : N ;
  latenthet_nn_1_N : N ;
  lathet_nn_1_N : N ;
  latiniserbarhet_nn_1_N : N ;
  latinkunnighet_nn_1_N : N ;
  lavendel_nn_1_N : N ;
  laverbarhet_nn_1_N : N ;
  lavinfara_nn_1_N : N ;
  lavinrisk_nn_1_N : N ;
  lealoeshet_nn_1_1_N : N ;
  leda_nn_1_N : N ;
  ledbrutenhet_nn_1_N : N ;
  ledgaang_nn_1_1_N : N ;
  ledhet_nn_1_N : N ;
  ledsyn_nn_1_N : N ;
  ledung_nn_1_N : N ;
  legaliserbarhet_nn_1_N : N ;
  legerbarhet_nn_1_N : N ;
  legitimerbarhet_nn_1_N : N ;
  legitimitetsprincip_nn_1_N : N ;
  lehet_nn_1_N : N ;
  lejdtrafik_nn_1_N : N ;
  lejonpart_nn_1_N : N ;
  lekamlighet_nn_1_N : N ;
  lekfaerdighet_nn_1_1_N : N ;
  leklystenhet_nn_1_N : N ;
  lektionstimma_nn_1_N : N ;
  lektyr_nn_1_N : N ;
  lemmalytthet_nn_1_N : N ;
  lenhet_nn_1_N : N ;
  lepra_nn_1_N : N ;
  leptit_nn_1_N : N ;
  leveranssaekerhet_nn_1_1_N : N ;
  levererbarhet_nn_1_N : N ;
  levertran_nn_1_N : N ;
  levnadsafton_nn_1_N : N ;
  levnadsfoering_nn_1_1_N : N ;
  levnadskonst_nn_1_N : N ;
  levnadslust_nn_1_N : N ;
  levnadsstandard_nn_1_N : N ;
  levnadstroetthet_nn_1_1_N : N ;
  lex_nn_1_N : N ;
  lexikostatistik_nn_1_N : N ;
  lias_nn_1_N : N ;
  liberaliserbarhet_nn_1_N : N ;
  licenserbarhet_nn_1_N : N ;
  licensierbarhet_nn_1_N : N ;
  licentierbarhet_nn_1_N : N ;
  lidelsefrihet_nn_1_N : N ;
  lierbarhet_nn_1_N : N ;
  liggriktighet_nn_1_N : N ;
  liggsaed_nn_1_1_N : N ;
  likbenthet_nn_1_N : N ;
  likblekhet_nn_1_N : N ;
  liklukt_nn_1_N : N ;
  liknoejdhet_nn_1_1_N : N ;
  likriktning_nn_1_N : N ;
  liksidighet_nn_1_N : N ;
  likstyckning_nn_1_N : N ;
  liktydighet_nn_1_N : N ;
  likviderbarhet_nn_1_N : N ;
  likvaerdhet_nn_1_1_N : N ;
  likvaerdighet_nn_1_1_N : N ;
  lillebror_nn_1_N : N ;
  lillefar_nn_1_N : N ;
  lillhjaerna_nn_1_1_N : N ;
  limonit_nn_1_N : N ;
  lindans_nn_1_N : N ;
  lindrighet_nn_1_N : N ;
  lingondricka_nn_1_N : N ;
  lingvistik_nn_1_N : N ;
  linhaarighet_nn_1_1_N : N ;
  linjefart_nn_1_N : N ;
  linjerbarhet_nn_1_N : N ;
  linjerenhet_nn_1_N : N ;
  linjetrafik_nn_1_N : N ;
  lisa_nn_1_N : N ;
  lisserbarhet_nn_1_N : N ;
  listighet_nn_1_N : N ;
  litervikt_nn_1_N : N ;
  litograferbarhet_nn_1_N : N ;
  litosfaer_nn_1_1_N : N ;
  litteraturkritik_nn_1_N : N ;
  litteraturvetenskap_nn_1_N : N ;
  livaktighet_nn_1_N : N ;
  livegenhet_nn_1_N : N ;
  livegenskap_nn_1_N : N ;
  livfullhet_nn_1_N : N ;
  livhank_nn_1_N : N ;
  livloeshet_nn_1_1_N : N ;
  livmoder_nn_1_N : N ;
  livsduglighet_nn_1_N : N ;
  livsfara_nn_1_N : N ;
  livskraft_nn_1_N : N ;
  livskraftighet_nn_1_N : N ;
  livskaensla_nn_1_1_N : N ;
  livsleda_nn_1_N : N ;
  livsluft_nn_1_N : N ;
  livsmedelsbrist_nn_1_N : N ;
  livsmedelspolitik_nn_1_N : N ;
  livsmedelsproduktion_nn_1_N : N ;
  livsnjutartillvaro_nn_1_N : N ;
  livsnoedvaendighet_nn_1_1_N : N ;
  livstid_nn_1_N : N ;
  livsviktighet_nn_1_N : N ;
  livsvaenlighet_nn_1_1_N : N ;
  ljudenlighet_nn_1_N : N ;
  ljudisolerbarhet_nn_1_N : N ;
  ljudlighet_nn_1_N : N ;
  ljudloeshet_nn_1_1_N : N ;
  ljudradio_nn_1_N : N ;
  ljudsvaghet_nn_1_N : N ;
  ljudsymbolik_nn_1_N : N ;
  ljumhet_nn_2_N : N ;
  ljummenhet_nn_1_N : N ;
  ljung_nn_1_N : N ;
  ljusbestaendighet_nn_1_1_N : N ;
  ljusblindhet_nn_1_N : N ;
  ljusbrist_nn_1_N : N ;
  ljusfoering_nn_1_1_N : N ;
  ljushet_nn_1_N : N ;
  ljushyllthet_nn_1_N : N ;
  ljushaarighet_nn_1_1_N : N ;
  ljuskopierbarhet_nn_1_N : N ;
  ljuslagdhet_nn_1_N : N ;
  ljuslockighet_nn_1_N : N ;
  ljuslaetthet_nn_1_1_N : N ;
  ljusreklam_nn_1_N : N ;
  ljussvaghet_nn_1_N : N ;
  ljusvall_nn_1_N : N ;
  lockighet_nn_1_N : N ;
  lodbarhet_nn_1_N : N ;
  lodraethet_nn_1_1_N : N ;
  logerbarhet_nn_1_N : N ;
  logik_nn_1_N : N ;
  logistik_nn_1_N : N ;
  lojhet_nn_1_N : N ;
  lokaliserbarhet_nn_1_N : N ;
  lokaliseringspolitik_nn_1_N : N ;
  lokalpolitik_nn_1_N : N ;
  lokalpress_nn_1_N : N ;
  lokalradio_nn_1_N : N ;
  lokaltrafik_nn_1_N : N ;
  lokalvaard_nn_1_1_N : N ;
  lomhoerdhet_nn_1_1_N : N ;
  loran_nn_1_N : N ;
  lortighet_nn_1_N : N ;
  lotshjaelp_nn_1_1_N : N ;
  lotsplikt_nn_1_N : N ;
  lottloeshet_nn_1_1_N : N ;
  lovgirighet_nn_1_N : N ;
  lovlighet_nn_1_N : N ;
  lovvaerdhet_nn_1_1_N : N ;
  lucia_nn_2_N : N ;
  luckerhet_nn_1_N : N ;
  ludenhet_nn_1_N : N ;
  luff_nn_1_N : N ;
  lufsighet_nn_1_N : N ;
  luft_nn_1_N : N ;
  luftfart_nn_1_N : N ;
  luftpost_nn_1_N : N ;
  lufttillfoersel_nn_1_1_N : N ;
  lufttomhet_nn_1_N : N ;
  lufttaethet_nn_1_1_N : N ;
  luftvaernseld_nn_1_1_N : N ;
  lugg_nn_2_N : N ;
  luggighet_nn_1_N : N ;
  luggslitenhet_nn_1_N : N ;
  lugnhet_nn_1_N : N ;
  luktfrihet_nn_1_N : N ;
  luktloeshet_nn_1_1_N : N ;
  luktsvaghet_nn_1_N : N ;
  lullighet_nn_1_N : N ;
  lumbago_nn_1_N : N ;
  luminiscens_nn_1_N : N ;
  lummighet_nn_1_N : N ;
  lump_nn_2_N : N ;
  lumpenhet_nn_1_N : N ;
  lumpighet_nn_1_N : N ;
  lumpull_nn_1_N : N ;
  lungbrand_nn_1_N : N ;
  lungcancer_nn_1_N : N ;
  lungpaj_nn_1_N : N ;
  lungsjuka_nn_1_N : N ;
  lungsjukhet_nn_1_N : N ;
  lungsot_nn_1_N : N ;
  lungtuberkulos_nn_1_N : N ;
  lunk_nn_1_N : N ;
  lunsighet_nn_1_N : N ;
  lupus_nn_1_N : N ;
  lurvighet_nn_1_N : N ;
  luspankhet_nn_1_N : N ;
  lusse_nn_1_N : N ;
  lusta_nn_1_N : N ;
  lustelighet_nn_1_N : N ;
  lustfylldhet_nn_1_N : N ;
  luteiniserbarhet_nn_1_N : N ;
  lycka_nn_1_N : N ;
  lyckosamhet_nn_1_N : N ;
  lycksalighet_nn_1_N : N ;
  lydaktighet_nn_1_N : N ;
  lydnad_nn_1_N : N ;
  lyhoerdhet_nn_1_1_N : N ;
  lymfa_nn_1_N : N ;
  lymmelaktighet_nn_1_N : N ;
  lynchmobb_nn_1_N : N ;
  lynnighet_nn_1_N : N ;
  lyrik_nn_1_N : N ;
  lyrism_nn_1_N : N ;
  lyskraft_nn_1_N : N ;
  lysol_nn_1_N : N ;
  lystenhet_nn_1_N : N ;
  lysved_nn_1_N : N ;
  lyteskomik_nn_1_N : N ;
  lytthet_nn_1_N : N ;
  lyx_nn_1_N : N ;
  lyxkonsumering_nn_1_N : N ;
  lyxmat_nn_1_N : N ;
  lyxrenoverbarhet_nn_1_N : N ;
  laederbarhet_nn_1_1_N : N ;
  laederhud_nn_1_1_N : N ;
  laeglighet_nn_1_1_N : N ;
  laekarhjaelp_nn_1_1_N : N ;
  laekarvetenskap_nn_1_1_N : N ;
  laekarvaard_nn_1_1_N : N ;
  laekekonst_nn_1_1_N : N ;
  laekepedagogik_nn_1_1_N : N ;
  laemplighetsproevning_nn_1_1_N : N ;
  laengtansfullhet_nn_1_1_N : N ;
  laenskriminal_nn_1_1_N : N ;
  laenspolis_nn_1_1_N : N ;
  laenspumpning_nn_1_1_N : N ;
  laeppglans_nn_1_1_N : N ;
  laeraktighet_nn_1_1_N : N ;
  laerarloeshet_nn_1_1_N : N ;
  laerdhet_nn_1_1_N : N ;
  laerlingstid_nn_1_1_N : N ;
  laeroboksaktighet_nn_1_1_N : N ;
  laerorikhet_nn_1_1_N : N ;
  laerotid_nn_1_1_N : N ;
  laeslighet_nn_1_1_N : N ;
  laeslust_nn_1_1_N : N ;
  laessvaghet_nn_1_1_N : N ;
  laesvaenlighet_nn_1_1_N : N ;
  laettantaendlighet_nn_1_1_N : N ;
  laettbegriplighet_nn_1_1_N : N ;
  laettbetong_nn_1_1_N : N ;
  laettfattlighet_nn_1_1_N : N ;
  laettfil_nn_1_1_N : N ;
  laettflyktighet_nn_1_1_N : N ;
  laettframkomlighet_nn_1_1_N : N ;
  laettfoerklarlighet_nn_1_1_N : N ;
  laettfoerstaaelighet_nn_1_1_N : N ;
  laetthanterlighet_nn_1_1_N : N ;
  laetthet_nn_1_1_N : N ;
  laettillgaenglighet_nn_1_1_N : N ;
  laettja_nn_1_1_N : N ;
  laettjefullhet_nn_1_1_N : N ;
  laettklaeddhet_nn_1_1_N : N ;
  laettkokthet_nn_1_1_N : N ;
  laettkoepthet_nn_1_1_N : N ;
  laettleddhet_nn_1_1_N : N ;
  laettlaesthet_nn_1_1_N : N ;
  laettloeslighet_nn_1_1_N : N ;
  laettloesthet_nn_1_1_N : N ;
  laettmjoelk_nn_1_1_N : N ;
  laettretlighet_nn_1_1_N : N ;
  laettrogenhet_nn_1_1_N : N ;
  laettroerdhet_nn_1_1_N : N ;
  laettroerlighet_nn_1_1_N : N ;
  laettskraemdhet_nn_1_1_N : N ;
  laettskoetthet_nn_1_1_N : N ;
  laettsmaelthet_nn_1_1_N : N ;
  laettstekthet_nn_1_1_N : N ;
  laettstoetthet_nn_1_1_N : N ;
  laettvikt_nn_1_1_N : N ;
  laettviktighet_nn_1_1_N : N ;
  laettvindighet_nn_1_1_N : N ;
  laettoemdhet_nn_1_1_N : N ;
  laettoeverskaadlighet_nn_1_1_N : N ;
  laagbudgetturism_nn_1_1_N : N ;
  laaghjulighet_nn_1_1_N : N ;
  laagkyrklighet_nn_1_1_N : N ;
  laaglandsboskap_nn_1_1_N : N ;
  laaglaenthet_nn_1_1_N : N ;
  laagmaeldhet_nn_1_1_N : N ;
  laagprioriterbarhet_nn_1_1_N : N ;
  laagpriskonkurrens_nn_1_1_N : N ;
  laagsinthet_nn_1_1_N : N ;
  laagstatus_nn_1_1_N : N ;
  laagsvavlighet_nn_1_1_N : N ;
  laagvuxenhet_nn_1_1_N : N ;
  laagvaerdighet_nn_1_1_N : N ;
  laagvaexthet_nn_1_1_N : N ;
  laangbenthet_nn_1_1_N : N ;
  laangdragenhet_nn_1_1_N : N ;
  laangfristighet_nn_1_1_N : N ;
  laanggrundhet_nn_1_1_N : N ;
  laanghaarighet_nn_1_1_N : N ;
  laangkatekes_nn_1_1_N : N ;
  laanglighet_nn_1_1_N : N ;
  laangmjoelk_nn_1_1_N : N ;
  laangmodighet_nn_1_1_N : N ;
  laangnaesthet_nn_1_1_N : N ;
  laangrandighet_nn_1_1_N : N ;
  laangsamhet_nn_1_1_N : N ;
  laangsiktighet_nn_1_1_N : N ;
  laangsinthet_nn_1_1_N : N ;
  laangskallighet_nn_1_1_N : N ;
  laangsoekthet_nn_1_1_N : N ;
  laangtidsparkerbarhet_nn_1_1_N : N ;
  laangtidssjukfraanvaro_nn_1_1_N : N ;
  laangtidssjukhet_nn_1_1_N : N ;
  laangtradighet_nn_1_1_N : N ;
  laangtraadighet_nn_1_1_N : N ;
  laangtraakighet_nn_1_1_N : N ;
  laangvarighet_nn_1_1_N : N ;
  laangved_nn_1_1_N : N ;
  laangvaard_nn_1_1_N : N ;
  laasbarhet_nn_1_1_N : N ;
  laat_nn_2_1_N : N ;
  laatgaapolitik_nn_1_1_N : N ;
  loeddrighet_nn_1_1_N : N ;
  loedighet_nn_1_1_N : N ;
  loeftesrikhet_nn_1_1_N : N ;
  loemskhet_nn_1_1_N : N ;
  loenedumpningspolitik_nn_1_1_N : N ;
  loenepolitik_nn_1_1_N : N ;
  loeneraettvisa_nn_1_1_N : N ;
  loenloeshet_nn_1_1_N : N ;
  loennlighet_nn_1_1_N : N ;
  loennskrift_nn_1_1_N : N ;
  loepskhet_nn_1_1_N : N ;
  loeptraening_nn_1_1_N : N ;
  loerdagstrafik_nn_1_1_N : N ;
  loesaktighet_nn_1_1_N : N ;
  loesbarhet_nn_1_1_N : N ;
  loesdrift_nn_1_1_N : N ;
  loeshet_nn_1_1_N : N ;
  loeslighet_nn_1_1_N : N ;
  loesmynthet_nn_1_1_N : N ;
  loesningsraett_nn_1_1_N : N ;
  loesnummerfoersaeljning_nn_1_1_N : N ;
  loesryckthet_nn_1_1_N : N ;
  loess_nn_1_1_N : N ;
  loesslaeppthet_nn_1_1_N : N ;
  loessnoe_nn_1_1_N : N ;
  loestagbarhet_nn_1_1_N : N ;
  loevrikedom_nn_1_1_N : N ;
  loevtunnhet_nn_1_1_N : N ;
  macchiato_nn_1_N : N ;
  madeira_nn_1_N : N ;
  madrasserbarhet_nn_1_N : N ;
  maestro_nn_1_N : N ;
  maffighet_nn_1_N : N ;
  magasinerbarhet_nn_1_N : N ;
  magerhet_nn_1_N : N ;
  magerlagdhet_nn_1_N : N ;
  magkaensla_nn_1_1_N : N ;
  magnesit_nn_1_N : N ;
  magnetiserbarhet_nn_1_N : N ;
  magnetit_nn_1_N : N ;
  magnificens_nn_1_N : N ;
  magstarkhet_nn_1_N : N ;
  magsurhet_nn_1_N : N ;
  mahjong_nn_1_N : N ;
  mail_nn_1_N : N ;
  maj_nn_1_N : N ;
  maj_nn_2_N : N ;
  majestaetlighet_nn_1_1_N : N ;
  majolika_nn_1_N : N ;
  majs_nn_1_N : N ;
  majsena_nn_1_N : N ;
  majsjuka_nn_1_N : N ;
  majsol_nn_1_N : N ;
  makaberhet_nn_1_N : N ;
  makadam_nn_1_N : N ;
  makaloeshet_nn_1_1_N : N ;
  maklighet_nn_1_N : N ;
  mako_nn_1_N : N ;
  makt_nn_1_N : N ;
  maktfullkomlighet_nn_1_N : N ;
  makthunger_nn_1_N : N ;
  maktlystenhet_nn_1_N : N ;
  maktloeshet_nn_1_1_N : N ;
  maktpolitik_nn_1_N : N ;
  maktstinnhet_nn_1_N : N ;
  maktutoevning_nn_1_1_N : N ;
  makulatur_nn_1_N : N ;
  makulerbarhet_nn_1_N : N ;
  malaga_nn_1_N : N ;
  malaria_nn_1_N : N ;
  malfoberbarhet_nn_1_N : N ;
  malis_nn_1_N : N ;
  mallighet_nn_1_N : N ;
  malmslig_nn_1_N : N ;
  maltos_nn_1_N : N ;
  maltraeterbarhet_nn_1_1_N : N ;
  malvasir_nn_1_N : N ;
  malaetenhet_nn_1_1_N : N ;
  maloert_nn_1_1_N : N ;
  mammaledighet_nn_1_N : N ;
  mammighet_nn_1_N : N ;
  mammon_nn_1_N : N ;
  mammutjakt_nn_1_N : N ;
  mana_nn_1_N : N ;
  manbarhet_nn_1_N : N ;
  manchester_nn_1_N : N ;
  manetforskning_nn_1_N : N ;
  mangold_nn_1_N : N ;
  manhaftighet_nn_1_N : N ;
  manifesterbarhet_nn_1_N : N ;
  manikurerbarhet_nn_1_N : N ;
  manikyr_nn_1_N : N ;
  manikyrerbarhet_nn_1_N : N ;
  manilla_nn_1_N : N ;
  maniok_nn_1_N : N ;
  manipulerbarhet_nn_1_N : N ;
  manlighet_nn_1_N : N ;
  mannakraft_nn_1_N : N ;
  mansbot_nn_1_N : N ;
  mansdominans_nn_1_N : N ;
  manstukt_nn_1_N : N ;
  manoeverduglighet_nn_1_1_N : N ;
  manoevrerbarhet_nn_1_1_N : N ;
  maraskino_nn_1_N : N ;
  marasm_nn_1_N : N ;
  mardroemslikhet_nn_1_1_N : N ;
  mareld_nn_1_N : N ;
  marginaliserbarhet_nn_1_N : N ;
  marinerbarhet_nn_1_N : N ;
  markavvattning_nn_1_N : N ;
  markerbarhet_nn_1_N : N ;
  marketing_nn_1_N : N ;
  marknadsvaerderbarhet_nn_1_1_N : N ;
  marmorerbarhet_nn_1_N : N ;
  marokaeng_nn_1_1_N : N ;
  mars_nn_1_N : N ;
  marscherbarhet_nn_1_N : N ;
  marschmusik_nn_1_N : N ;
  marschtakt_nn_1_N : N ;
  marseljaes_nn_1_1_N : N ;
  marsipan_nn_1_N : N ;
  marterbarhet_nn_1_N : N ;
  martyrdoed_nn_1_1_N : N ;
  mas_nn_2_N : N ;
  maskerbarhet_nn_1_N : N ;
  maskeringstejp_nn_1_N : N ;
  maskinlaesbarhet_nn_1_1_N : N ;
  maskinmaessighet_nn_1_1_N : N ;
  maskinskrift_nn_1_N : N ;
  maskuliniserbarhet_nn_1_N : N ;
  masonit_nn_1_N : N ;
  massakrerbarhet_nn_1_N : N ;
  massarbetsloeshet_nn_1_1_N : N ;
  massaved_nn_1_N : N ;
  masserbarhet_nn_1_N : N ;
  massinvandring_nn_1_N : N ;
  massloeshet_nn_1_1_N : N ;
  massproduktion_nn_1_N : N ;
  massvaelt_nn_1_1_N : N ;
  mastighet_nn_1_N : N ;
  mastix_nn_1_N : N ;
  mat_nn_1_N : N ;
  matbrist_nn_1_N : N ;
  matchning_nn_1_N : N ;
  matelasserbarhet_nn_1_N : N ;
  matematik_nn_1_N : N ;
  materialiserbarhet_nn_1_N : N ;
  matlust_nn_1_N : N ;
  matmor_nn_1_N : N ;
  matservering_nn_1_N : N ;
  mattbrottning_nn_1_N : N ;
  mattejp_nn_1_N : N ;
  matterbarhet_nn_1_N : N ;
  matthet_nn_2_N : N ;
  mattram_nn_1_N : N ;
  maximerbarhet_nn_1_N : N ;
  mc_aakning_nn_1_1_N : N ;
  medaljerbarhet_nn_1_N : N ;
  medansvarighet_nn_1_N : N ;
  medborgarraett_nn_1_1_N : N ;
  medborgerlighet_nn_1_N : N ;
  medbrottslighet_nn_1_N : N ;
  meddelaktighet_nn_1_N : N ;
  meddelandeplikt_nn_1_N : N ;
  meddelsamhet_nn_1_N : N ;
  medelbarhet_nn_1_N : N ;
  medelloeshet_nn_1_1_N : N ;
  medelmaattighet_nn_1_1_N : N ;
  medelsol_nn_1_N : N ;
  medeltid_nn_1_N : N ;
  medfarenhet_nn_1_N : N ;
  medfoeddhet_nn_1_1_N : N ;
  medgoerlighet_nn_1_1_N : N ;
  medhjaelp_nn_1_1_N : N ;
  mediamakt_nn_1_N : N ;
  mediapolitik_nn_1_N : N ;
  medicinalvikt_nn_1_N : N ;
  medicinerbarhet_nn_1_N : N ;
  medielogik_nn_1_N : N ;
  mediemakt_nn_1_N : N ;
  mediepolitik_nn_1_N : N ;
  medierapportering_nn_1_N : N ;
  mediokerhet_nn_1_N : N ;
  medkaensla_nn_1_1_N : N ;
  medlidsamhet_nn_1_N : N ;
  medmaensklighet_nn_1_1_N : N ;
  medskyldighet_nn_1_N : N ;
  medtagenhet_nn_1_N : N ;
  medvetandegoering_nn_1_1_N : N ;
  medvetsloeshet_nn_1_1_N : N ;
  mejl_nn_1_N : N ;
  mejram_nn_1_N : N ;
  mekanik_nn_1_N : N ;
  mekaniserbarhet_nn_1_N : N ;
  mekvaenlighet_nn_1_1_N : N ;
  melass_nn_1_N : N ;
  melinit_nn_1_N : N ;
  mellankalv_nn_1_N : N ;
  mellankomst_nn_1_N : N ;
  mellanmaensklighet_nn_1_1_N : N ;
  mellanvikt_nn_1_N : N ;
  melodik_nn_1_N : N ;
  memorerbarhet_nn_1_N : N ;
  meningit_nn_1_N : N ;
  meningsfullhet_nn_1_N : N ;
  meningsfylldhet_nn_1_N : N ;
  menlighet_nn_1_N : N ;
  mens_nn_1_N : N ;
  mensvaerk_nn_1_1_N : N ;
  mentalsjukhet_nn_1_N : N ;
  mentalvaard_nn_1_1_N : N ;
  mentol_nn_1_N : N ;
  merceriserbarhet_nn_1_N : N ;
  meriterbarhet_nn_1_N : N ;
  merpart_nn_1_N : N ;
  mersmak_nn_1_N : N ;
  mesaktighet_nn_1_N : N ;
  mesighet_nn_1_N : N ;
  metaforik_nn_1_N : N ;
  metafysik_nn_1_N : N ;
  metalliserbarhet_nn_1_N : N ;
  metallsloejd_nn_1_1_N : N ;
  metallsmak_nn_1_N : N ;
  metangas_nn_1_N : N ;
  metanhydrat_nn_1_N : N ;
  metanis_nn_1_N : N ;
  metanklatrat_nn_1_N : N ;
  metanol_nn_1_N : N ;
  metodik_nn_1_N : N ;
  metrik_nn_1_N : N ;
  metyl_nn_1_N : N ;
  metylalkohol_nn_1_N : N ;
  middagsmat_nn_1_N : N ;
  middagssol_nn_1_N : N ;
  midnatt_nn_1_N : N ;
  migraen_nn_1_1_N : N ;
  mikroelektronik_nn_1_N : N ;
  mikrofotograferbarhet_nn_1_N : N ;
  mikroskoperbarhet_nn_1_N : N ;
  mikrosoemn_nn_1_1_N : N ;
  milanesiskhet_nn_1_N : N ;
  mildsinthet_nn_1_N : N ;
  mildoegdhet_nn_1_1_N : N ;
  miliartuberkulos_nn_1_N : N ;
  militariserbarhet_nn_1_N : N ;
  militaermusik_nn_1_1_N : N ;
  militaerpolis_nn_1_1_N : N ;
  militaertjaenst_nn_1_1_N : N ;
  miljoebalk_nn_1_1_N : N ;
  miljoefarlighet_nn_1_1_N : N ;
  miljoemedvetenhet_nn_1_1_N : N ;
  miljoemaessighet_nn_1_1_N : N ;
  miljoepolitik_nn_1_1_N : N ;
  miljoeskydd_nn_1_1_N : N ;
  miljoevaenlighet_nn_1_1_N : N ;
  miljoevaard_nn_1_1_N : N ;
  mimik_nn_1_N : N ;
  mindervaerdighet_nn_1_1_N : N ;
  minderaarighet_nn_1_1_N : N ;
  mineraliserbarhet_nn_1_N : N ;
  mineralull_nn_1_N : N ;
  minerbarhet_nn_1_N : N ;
  minett_nn_1_N : N ;
  miniatyriserbarhet_nn_1_N : N ;
  minigolf_nn_1_N : N ;
  minimerbarhet_nn_1_N : N ;
  minnesgodhet_nn_1_N : N ;
  minneskonst_nn_2_N : N ;
  minnesrikhet_nn_1_N : N ;
  minnesvaerdhet_nn_1_1_N : N ;
  minnesvaard_nn_1_1_N : N ;
  minoritetsforskning_nn_1_N : N ;
  minskhet_nn_1_N : N ;
  mint_nn_1_N : N ;
  minutlaeggning_nn_1_1_N : N ;
  missbelaatenhet_nn_1_1_N : N ;
  misshaglighet_nn_1_N : N ;
  misshushaallning_nn_1_1_N : N ;
  missionsdag_nn_1_N : N ;
  missis_nn_1_N : N ;
  missiverbarhet_nn_1_N : N ;
  missklaedsamhet_nn_1_1_N : N ;
  misskrediterbarhet_nn_1_N : N ;
  misskund_nn_1_N : N ;
  misskundsamhet_nn_1_N : N ;
  misskoetsamhet_nn_1_1_N : N ;
  missledning_nn_1_N : N ;
  misslynthet_nn_1_N : N ;
  missmodighet_nn_1_N : N ;
  missnoejdhet_nn_1_1_N : N ;
  missnoejesretorik_nn_1_1_N : N ;
  missriktning_nn_1_N : N ;
  misstrogenhet_nn_1_N : N ;
  missunnsamhet_nn_1_N : N ;
  missvaext_nn_1_1_N : N ;
  mist_nn_1_N : N ;
  mister_nn_1_N : N ;
  mistighet_nn_1_N : N ;
  mistral_nn_1_N : N ;
  mitt_nn_1_N : N ;
  mixed_nn_1_N : N ;
  mjukporr_nn_1_N : N ;
  mjaekighet_nn_1_1_N : N ;
  mjaellhet_nn_1_1_N : N ;
  mjaellighet_nn_1_1_N : N ;
  mjaeltbrand_nn_1_1_N : N ;
  mjaeltsjuka_nn_1_1_N : N ;
  mjaeltsjukhet_nn_1_1_N : N ;
  mjoeldagg_nn_1_1_N : N ;
  mjoelighet_nn_1_1_N : N ;
  mjoelk_nn_1_1_N : N ;
  mjoelkboskap_nn_1_1_N : N ;
  mjoelkchoklad_nn_1_1_N : N ;
  mjoelkighet_nn_1_1_N : N ;
  mjoelkskorv_nn_1_1_N : N ;
  mjoelkstinnhet_nn_1_1_N : N ;
  mjoelksvullenhet_nn_1_1_N : N ;
  mnemoteknik_nn_1_N : N ;
  mobb_nn_1_N : N ;
  mobbing_nn_1_N : N ;
  mobbning_nn_1_N : N ;
  mobilfoersaeljning_nn_1_1_N : N ;
  mobiliserbarhet_nn_1_N : N ;
  modallogik_nn_1_N : N ;
  modd_nn_1_N : N ;
  modellerbarhet_nn_1_N : N ;
  modererbarhet_nn_1_N : N ;
  moderiktighet_nn_1_N : N ;
  moderlighet_nn_1_N : N ;
  moderniserbarhet_nn_1_N : N ;
  moderraett_nn_1_1_N : N ;
  moderskaerlek_nn_1_1_N : N ;
  modersmjoelk_nn_1_1_N : N ;
  modesthet_nn_1_N : N ;
  modevaerld_nn_1_1_N : N ;
  modfaelldhet_nn_1_1_N : N ;
  modifierbarhet_nn_1_N : N ;
  modloeshet_nn_1_1_N : N ;
  modstulenhet_nn_1_N : N ;
  modulerbarhet_nn_1_N : N ;
  modaerniserbarhet_nn_1_1_N : N ;
  mohair_nn_1_N : N ;
  mohaer_nn_1_1_N : N ;
  mojhet_nn_1_N : N ;
  mol_nn_1_N : N ;
  moll_nn_1_N : N ;
  mollstaemdhet_nn_1_1_N : N ;
  molok_nn_1_N : N ;
  molokenhet_nn_1_N : N ;
  molybdenglans_nn_1_N : N ;
  moms_nn_1_N : N ;
  monoftongerbarhet_nn_1_N : N ;
  monopoliserbarhet_nn_1_N : N ;
  monsieur_nn_1_N : N ;
  monterbarhet_nn_1_N : N ;
  monteringstejp_nn_1_N : N ;
  monumentalkonst_nn_1_N : N ;
  mopsighet_nn_1_N : N ;
  moralpanik_nn_1_N : N ;
  mordlust_nn_1_N : N ;
  mordlystenhet_nn_1_N : N ;
  morgonpigghet_nn_1_N : N ;
  morgonrusning_nn_1_N : N ;
  morgonsol_nn_1_N : N ;
  morgontroetthet_nn_1_1_N : N ;
  morgonvaekt_nn_1_1_N : N ;
  morron_nn_1_N : N ;
  morserbarhet_nn_1_N : N ;
  morskhet_nn_1_N : N ;
  mortificerbarhet_nn_1_N : N ;
  mortifierbarhet_nn_1_N : N ;
  mosaiksjuka_nn_1_N : N ;
  mosighet_nn_1_N : N ;
  mosning_nn_1_N : N ;
  mossbelupenhet_nn_1_N : N ;
  mossighet_nn_1_N : N ;
  mossljung_nn_1_N : N ;
  mosstorv_nn_1_N : N ;
  mosterlighet_nn_1_N : N ;
  moteld_nn_1_N : N ;
  motionsgymnastik_nn_1_N : N ;
  motionsraett_nn_1_1_N : N ;
  motiverbarhet_nn_1_N : N ;
  motocross_nn_1_N : N ;
  motorik_nn_1_N : N ;
  motoriserbarhet_nn_1_N : N ;
  motorrengoering_nn_1_1_N : N ;
  motorsport_nn_1_N : N ;
  motortvaett_nn_1_1_N : N ;
  motspaenstighet_nn_1_1_N : N ;
  motstridighet_nn_1_N : N ;
  motstraevighet_nn_1_1_N : N ;
  motstaandskraft_nn_1_1_N : N ;
  motstaandsloeshet_nn_1_1_N : N ;
  motsaegelsefullhet_nn_1_1_N : N ;
  motsaettlighet_nn_1_1_N : N ;
  mottaglighet_nn_1_N : N ;
  motvillighet_nn_1_N : N ;
  motyl_nn_1_N : N ;
  muck_nn_2_N : N ;
  muddrighet_nn_1_N : N ;
  mugg_nn_2_N : N ;
  mulenhet_nn_1_N : N ;
  muljerbarhet_nn_1_N : N ;
  mull_nn_1_N : N ;
  mullighet_nn_1_N : N ;
  multegroet_nn_1_1_N : N ;
  multenhet_nn_1_N : N ;
  multikonst_nn_1_N : N ;
  multiplicerbarhet_nn_1_N : N ;
  multiresistens_nn_1_N : N ;
  multisjukhet_nn_1_N : N ;
  mumifierbarhet_nn_1_N : N ;
  mumsighet_nn_1_N : N ;
  munblaast_nn_1_1_N : N ;
  munkskrift_nn_1_N : N ;
  muntlighet_nn_1_N : N ;
  munvighet_nn_1_N : N ;
  muppighet_nn_1_N : N ;
  murkenhet_nn_1_N : N ;
  murrighet_nn_1_N : N ;
  museimaessighet_nn_1_1_N : N ;
  musik_nn_1_N : N ;
  muskat_nn_1_N : N ;
  muskatell_nn_1_N : N ;
  muskelvaerk_nn_1_1_N : N ;
  muskot_nn_1_N : N ;
  must_nn_2_N : N ;
  mustighet_nn_1_N : N ;
  muterbarhet_nn_1_N : N ;
  muzak_nn_1_N : N ;
  myllighet_nn_1_N : N ;
  myndighetsutoevning_nn_1_1_N : N ;
  myntfot_nn_1_N : N ;
  mysk_nn_1_N : N ;
  mystifierbarhet_nn_1_N : N ;
  mystik_nn_1_N : N ;
  maell_nn_1_1_N : N ;
  maenniskofientlighet_nn_1_1_N : N ;
  maenniskolikhet_nn_1_1_N : N ;
  maenniskoraettskamp_nn_1_1_N : N ;
  maenniskosmuggling_nn_1_1_N : N ;
  maenniskoson_nn_1_1_N : N ;
  maenniskosyn_nn_1_1_N : N ;
  maenniskovaerdighet_nn_1_1_N : N ;
  maerg_nn_1_1_N : N ;
  maergfullhet_nn_1_1_N : N ;
  maergloeshet_nn_1_1_N : N ;
  maerkbarhet_nn_1_1_N : N ;
  maerkesmystik_nn_1_1_N : N ;
  maerkesraett_nn_1_1_N : N ;
  maesk_nn_1_1_N : N ;
  maessing_nn_1_1_N : N ;
  maessingsmusik_nn_1_1_N : N ;
  maessling_nn_1_1_N : N ;
  maester_nn_1_1_N : N ;
  maesterlighet_nn_1_1_N : N ;
  maestersaang_nn_1_1_N : N ;
  maetthet_nn_1_1_N : N ;
  maettsamhet_nn_1_1_N : N ;
  maalfarlighet_nn_1_1_N : N ;
  maalloeshet_nn_1_1_N : N ;
  maalmedvetenhet_nn_1_1_N : N ;
  maanformighet_nn_1_1_N : N ;
  maangfaldighet_nn_1_1_N : N ;
  maanggestaltning_nn_1_1_N : N ;
  maangkunnighet_nn_1_1_N : N ;
  maangordighet_nn_1_1_N : N ;
  maangspraakighet_nn_1_1_N : N ;
  maangstavighet_nn_1_1_N : N ;
  maangstaemmighet_nn_1_1_N : N ;
  maangvetenskaplighet_nn_1_1_N : N ;
  maangaarighet_nn_1_1_N : N ;
  maanhet_nn_1_1_N : N ;
  maanmark_nn_1_1_N : N ;
  maansing_nn_1_1_N : N ;
  maar_nn_1_1_N : N ;
  maarten_nn_1_1_N : N ;
  maartensgaas_nn_1_1_N : N ;
  maattfullhet_nn_1_1_N : N ;
  maattlighet_nn_1_1_N : N ;
  maattloeshet_nn_1_1_N : N ;
  moeblerbarhet_nn_1_1_N : N ;
  moedosamhet_nn_1_1_N : N ;
  moedravaard_nn_1_1_N : N ;
  moegeltvaett_nn_1_1_N : N ;
  moeglighet_nn_1_1_N : N ;
  moenstergillhet_nn_1_1_N : N ;
  moerhet_nn_1_1_N : N ;
  moerjighet_nn_1_1_N : N ;
  moerkblondhet_nn_1_1_N : N ;
  moerkerdoed_nn_1_1_N : N ;
  moerkhet_nn_1_1_N : N ;
  moerkhaarighet_nn_1_1_N : N ;
  moerkning_nn_1_1_N : N ;
  moerkraedsla_nn_1_1_N : N ;
  moerksyn_nn_1_1_N : N ;
  naboraett_nn_1_1_N : N ;
  nackstyvhet_nn_1_N : N ;
  nackvaerk_nn_1_1_N : N ;
  nadir_nn_1_N : N ;
  naivhet_nn_1_N : N ;
  namnfrejd_nn_1_N : N ;
  namnloeshet_nn_1_1_N : N ;
  nanoteknik_nn_1_N : N ;
  napalm_nn_1_N : N ;
  nardus_nn_1_N : N ;
  narkomanvaard_nn_1_1_N : N ;
  narkotikabekaempning_nn_1_1_N : N ;
  narkotikasmuggling_nn_1_N : N ;
  narraktighet_nn_1_N : N ;
  narv_nn_1_N : N ;
  nasalerbarhet_nn_1_N : N ;
  nasaliserbarhet_nn_1_N : N ;
  nationaliserbarhet_nn_1_N : N ;
  nationalitetsprincip_nn_1_N : N ;
  nationalkaensla_nn_1_1_N : N ;
  nationalromantik_nn_1_N : N ;
  natriumklorid_nn_1_N : N ;
  natteffekt_nn_1_N : N ;
  nattfrost_nn_1_N : N ;
  nattkvist_nn_1_N : N ;
  nattluft_nn_1_N : N ;
  nattsvarthet_nn_1_N : N ;
  nattsoemn_nn_1_1_N : N ;
  nattvardsgemenskap_nn_1_N : N ;
  nattvila_nn_1_N : N ;
  natur_nn_1_N : N ;
  naturaliserbarhet_nn_1_N : N ;
  naturenlighet_nn_1_N : N ;
  naturis_nn_1_N : N ;
  naturkosmetik_nn_1_N : N ;
  naturkunskap_nn_1_N : N ;
  naturkunskapsundervisning_nn_1_N : N ;
  naturlighet_nn_1_N : N ;
  naturmetaforik_nn_1_N : N ;
  naturmystik_nn_1_N : N ;
  naturraett_nn_1_1_N : N ;
  naturskoenhet_nn_1_1_N : N ;
  naturstridighet_nn_1_N : N ;
  naturvetenskaplighet_nn_1_N : N ;
  naturvidrighet_nn_1_N : N ;
  naturvaard_nn_1_1_N : N ;
  nautik_nn_1_N : N ;
  navalmedicin_nn_1_N : N ;
  navigerbarhet_nn_1_N : N ;
  nedbrytbarhet_nn_1_N : N ;
  nederboerd_nn_1_1_N : N ;
  nedkomst_nn_1_N : N ;
  nedslagenhet_nn_1_N : N ;
  nedstaemdhet_nn_1_1_N : N ;
  nedstoertning_nn_1_1_N : N ;
  nedtransformerbarhet_nn_1_N : N ;
  nedtransponerbarhet_nn_1_N : N ;
  nedtryckthet_nn_1_N : N ;
  nedtystning_nn_1_N : N ;
  nedvaerderbarhet_nn_1_1_N : N ;
  nedaatgaang_nn_1_1_N : N ;
  negerbarhet_nn_1_N : N ;
  negligerbarhet_nn_1_N : N ;
  negocierbarhet_nn_1_N : N ;
  negotierbarhet_nn_1_N : N ;
  nekros_nn_1_N : N ;
  nemesis_nn_1_N : N ;
  nerkomst_nn_1_N : N ;
  nertid_nn_1_N : N ;
  nertransformerbarhet_nn_1_N : N ;
  nertransponerbarhet_nn_1_N : N ;
  nerts_nn_1_N : N ;
  nertsbisam_nn_1_N : N ;
  nertystning_nn_1_N : N ;
  nertz_nn_1_N : N ;
  nertzbisam_nn_1_N : N ;
  nervighet_nn_1_N : N ;
  nervpress_nn_1_N : N ;
  nervaerderbarhet_nn_1_1_N : N ;
  nerz_nn_1_N : N ;
  nerzbisam_nn_1_N : N ;
  neraatgaang_nn_1_1_N : N ;
  nessosdraekt_nn_1_1_N : N ;
  nessusdraekt_nn_1_1_N : N ;
  nettovikt_nn_1_N : N ;
  neuralisering_nn_1_N : N ;
  neurotisering_nn_1_N : N ;
  neutraliserbarhet_nn_1_N : N ;
  nidskhet_nn_1_N : N ;
  niellerbarhet_nn_1_N : N ;
  nimbus_nn_1_N : N ;
  niob_nn_1_N : N ;
  nipprighet_nn_1_N : N ;
  nitiskhet_nn_1_N : N ;
  nitrerbarhet_nn_1_N : N ;
  nitrolit_nn_1_N : N ;
  nivellerbarhet_nn_1_N : N ;
  nivaagrupperbarhet_nn_1_1_N : N ;
  njugghet_nn_1_N : N ;
  njugghaenthet_nn_1_1_N : N ;
  njurtalg_nn_1_N : N ;
  njutbarhet_nn_1_N : N ;
  njutningsfullhet_nn_1_N : N ;
  njutningsrikedom_nn_1_N : N ;
  nobiliserbarhet_nn_1_N : N ;
  nobless_nn_1_N : N ;
  nollmeridian_nn_1_N : N ;
  nolltillvaext_nn_1_1_N : N ;
  nolltolerans_nn_1_N : N ;
  noltighet_nn_1_N : N ;
  nominerbarhet_nn_1_N : N ;
  nonchalans_nn_1_N : N ;
  nonchalerbarhet_nn_1_N : N ;
  nonpareil_nn_1_N : N ;
  noppighet_nn_1_N : N ;
  nord_nn_1_N : N ;
  nordost_nn_1_N : N ;
  nordsjoefart_nn_1_1_N : N ;
  nordvaest_nn_1_1_N : N ;
  nordoest_nn_1_1_N : N ;
  normalblyghet_nn_1_N : N ;
  normaliserbarhet_nn_1_N : N ;
  normalkraft_nn_1_N : N ;
  normalpotential_nn_1_N : N ;
  normalskolekompetens_nn_1_N : N ;
  normerbarhet_nn_1_N : N ;
  norskhet_nn_1_N : N ;
  nosserot_nn_1_N : N ;
  noterbarhet_nn_1_N : N ;
  notificerbarhet_nn_1_N : N ;
  notifierbarhet_nn_1_N : N ;
  notiserbarhet_nn_1_N : N ;
  notskrift_nn_1_N : N ;
  notsaekerhet_nn_1_1_N : N ;
  novellistik_nn_1_N : N ;
  november_nn_1_N : N ;
  novemberskymning_nn_1_N : N ;
  nuckighet_nn_1_N : N ;
  numismatik_nn_1_N : N ;
  nummerordning_nn_1_N : N ;
  numrerbarhet_nn_1_N : N ;
  nutid_nn_1_N : N ;
  nyanserbarhet_nn_1_N : N ;
  nyantik_nn_1_N : N ;
  nyemitterbarhet_nn_1_N : N ;
  nyetablerbarhet_nn_1_N : N ;
  nygotik_nn_1_N : N ;
  nyhetsbrist_nn_1_N : N ;
  nyhetsjakt_nn_1_N : N ;
  nyinvesterbarhet_nn_1_N : N ;
  nykterhetsvaard_nn_1_1_N : N ;
  nyliberalism_nn_1_N : N ;
  nyplanterbarhet_nn_1_N : N ;
  nyrikhet_nn_1_N : N ;
  nyromantik_nn_1_N : N ;
  nyterhet_nn_1_N : N ;
  nytestamentlighet_nn_1_N : N ;
  nyttighetsmoral_nn_1_N : N ;
  nyttjanderaett_nn_1_1_N : N ;
  nyttokonst_nn_1_N : N ;
  nyttomoral_nn_1_N : N ;
  nyttotrafik_nn_1_N : N ;
  naebbighet_nn_1_1_N : N ;
  naeck_nn_1_1_N : N ;
  naeckning_nn_1_1_N : N ;
  naemnbarhet_nn_1_1_N : N ;
  naemnvaerdhet_nn_1_1_N : N ;
  naepst_nn_1_1_N : N ;
  naerighet_nn_1_1_N : N ;
  naeringsflit_nn_1_1_N : N ;
  naeringslivspolitik_nn_1_1_N : N ;
  naeringspolitik_nn_1_1_N : N ;
  naeringsrikhet_nn_1_1_N : N ;
  naerkontakt_nn_1_1_N : N ;
  naerskyldhet_nn_1_1_N : N ;
  naerstudering_nn_1_1_N : N ;
  naervarorapportering_nn_1_1_N : N ;
  naesselkaal_nn_1_1_N : N ;
  naeston_nn_1_1_N : N ;
  naesvishet_nn_1_1_N : N ;
  naetcensur_nn_1_1_N : N ;
  naetdrift_nn_1_1_N : N ;
  naetformighet_nn_1_1_N : N ;
  naethinneavlossning_nn_1_1_N : N ;
  naetporr_nn_1_1_N : N ;
  naetthet_nn_1_1_N : N ;
  naetverksforskning_nn_1_1_N : N ;
  naevgroet_nn_1_1_N : N ;
  naevraett_nn_1_1_N : N ;
  naad_nn_1_1_N : N ;
  naadastol_nn_1_1_N : N ;
  naadatid_nn_1_1_N : N ;
  naadelighet_nn_1_1_N : N ;
  noed_nn_1_1_N : N ;
  noedbeddhet_nn_1_1_N : N ;
  noeddhet_nn_1_1_N : N ;
  noedflagg_nn_1_1_N : N ;
  noedhjaelp_nn_1_1_N : N ;
  noedproviant_nn_1_1_N : N ;
  noedraett_nn_1_1_N : N ;
  noedslakt_nn_1_1_N : N ;
  noedstaelldhet_nn_1_1_N : N ;
  noedtorft_nn_1_1_N : N ;
  noedvaernsraett_nn_1_1_N : N ;
  noejaktighet_nn_1_1_N : N ;
  noejdhet_nn_1_1_N : N ;
  noejesbransch_nn_1_1_N : N ;
  noejesjakt_nn_1_1_N : N ;
  noejsamhet_nn_1_1_N : N ;
  noerdighet_nn_1_1_N : N ;
  noetboskap_nn_1_1_N : N ;
  noetchoklad_nn_1_1_N : N ;
  noetkreatursdrift_nn_1_1_N : N ;
  noetningsbestaendighet_nn_1_1_N : N ;
  noetningsresistans_nn_1_1_N : N ;
  oabbrevierbarhet_nn_1_N : N ;
  oabdikerbarhet_nn_1_N : N ;
  oabonnerbarhet_nn_1_N : N ;
  oaborterbarhet_nn_1_N : N ;
  oabraderbarhet_nn_1_N : N ;
  oabsolverbarhet_nn_1_N : N ;
  oabsorberbarhet_nn_1_N : N ;
  oabstraherbarhet_nn_1_N : N ;
  oaccederbarhet_nn_1_N : N ;
  oaccelererbarhet_nn_1_N : N ;
  oaccentuerbarhet_nn_1_N : N ;
  oaccepterbarhet_nn_1_N : N ;
  oacklimatiserbarhet_nn_1_N : N ;
  oackommoderbarhet_nn_1_N : N ;
  oackompanjerbarhet_nn_1_N : N ;
  oackorderbarhet_nn_1_N : N ;
  oackrediterbarhet_nn_1_N : N ;
  oackumulerbarhet_nn_1_N : N ;
  oackvirerbarhet_nn_1_N : N ;
  oadapterbarhet_nn_1_N : N ;
  oadderbarhet_nn_1_N : N ;
  oadjungerbarhet_nn_1_N : N ;
  oadministrerbarhet_nn_1_N : N ;
  oadopterbarhet_nn_1_N : N ;
  oadresserbarhet_nn_1_N : N ;
  oadsorberbarhet_nn_1_N : N ;
  oaducerbarhet_nn_1_N : N ;
  oadvocerbarhet_nn_1_N : N ;
  oafficierbarhet_nn_1_N : N ;
  oaffinerbarhet_nn_1_N : N ;
  oaffischerbarhet_nn_1_N : N ;
  oafrikaniserbarhet_nn_1_N : N ;
  oagerbarhet_nn_1_N : N ;
  oagglomererbarhet_nn_1_N : N ;
  oagglutinerbarhet_nn_1_N : N ;
  oagiterbarhet_nn_1_N : N ;
  oajournerbarhet_nn_1_N : N ;
  oaktiverbarhet_nn_1_N : N ;
  oaktualiserbarhet_nn_1_N : N ;
  oalarmerbarhet_nn_1_N : N ;
  oalfabetiserbarhet_nn_1_N : N ;
  oalienerbarhet_nn_1_N : N ;
  oallegoriserbarhet_nn_1_N : N ;
  oallierbarhet_nn_1_N : N ;
  oallittererbarhet_nn_1_N : N ;
  oallokerbarhet_nn_1_N : N ;
  oalluderbarhet_nn_1_N : N ;
  oalternerbarhet_nn_1_N : N ;
  oaluminerbarhet_nn_1_N : N ;
  oamalgamerbarhet_nn_1_N : N ;
  oambulerbarhet_nn_1_N : N ;
  oamerikaniserbarhet_nn_1_N : N ;
  oamorterbarhet_nn_1_N : N ;
  oamplifierbarhet_nn_1_N : N ;
  oamputerbarhet_nn_1_N : N ;
  oanalyserbarhet_nn_1_N : N ;
  oandlighet_nn_1_N : N ;
  oanfraetthet_nn_1_1_N : N ;
  oangenaemhet_nn_1_1_N : N ;
  oangliserbarhet_nn_1_N : N ;
  oangripbarhet_nn_1_N : N ;
  oangriplighet_nn_1_N : N ;
  oanimerbarhet_nn_1_N : N ;
  oannekterbarhet_nn_1_N : N ;
  oannihilerbarhet_nn_1_N : N ;
  oannonserbarhet_nn_1_N : N ;
  oannoterbarhet_nn_1_N : N ;
  oannullerbarhet_nn_1_N : N ;
  oanodiserbarhet_nn_1_N : N ;
  oanonymiserbarhet_nn_1_N : N ;
  oansenlighet_nn_1_N : N ;
  oansvarighet_nn_1_N : N ;
  oantagbarhet_nn_1_N : N ;
  oantaglighet_nn_1_N : N ;
  oanteciperbarhet_nn_1_N : N ;
  oantedaterbarhet_nn_1_N : N ;
  oantichambrerbarhet_nn_1_N : N ;
  oantikiserbarhet_nn_1_N : N ;
  oantraeffbarhet_nn_1_1_N : N ;
  oanvaendbarhet_nn_1_1_N : N ;
  oapostroferbarhet_nn_1_N : N ;
  oappellerbarhet_nn_1_N : N ;
  oapplicerbarhet_nn_1_N : N ;
  oapplaaderbarhet_nn_1_1_N : N ;
  oapporterbarhet_nn_1_N : N ;
  oapprecierbarhet_nn_1_N : N ;
  oappreterbarhet_nn_1_N : N ;
  oapprocherbarhet_nn_1_N : N ;
  oapproximerbarhet_nn_1_N : N ;
  oapterbarhet_nn_1_N : N ;
  oaptitlighet_nn_1_N : N ;
  oargumenterbarhet_nn_1_N : N ;
  oarkaiserbarhet_nn_1_N : N ;
  oarkebuserbarhet_nn_1_N : N ;
  oarkiverbarhet_nn_1_N : N ;
  oarmerbarhet_nn_1_N : N ;
  oarrangerbarhet_nn_1_N : N ;
  oarrenderbarhet_nn_1_N : N ;
  oarresterbarhet_nn_1_N : N ;
  oarronderbarhet_nn_1_N : N ;
  oartikulerbarhet_nn_1_N : N ;
  oarvoderbarhet_nn_1_N : N ;
  oasfalterbarhet_nn_1_N : N ;
  oaspirerbarhet_nn_1_N : N ;
  oassignerbarhet_nn_1_N : N ;
  oassimilerbarhet_nn_1_N : N ;
  oassisterbarhet_nn_1_N : N ;
  oassocierbarhet_nn_1_N : N ;
  oassurerbarhet_nn_1_N : N ;
  oatrofierbarhet_nn_1_N : N ;
  oattackerbarhet_nn_1_N : N ;
  oattesterbarhet_nn_1_N : N ;
  oattraherbarhet_nn_1_N : N ;
  oattrapperbarhet_nn_1_N : N ;
  oattribuerbarhet_nn_1_N : N ;
  oauktionerbarhet_nn_1_N : N ;
  oauktoriserbarhet_nn_1_N : N ;
  oauskulterbarhet_nn_1_N : N ;
  oautenticerbarhet_nn_1_N : N ;
  oautentifierbarhet_nn_1_N : N ;
  oautentiserbarhet_nn_1_N : N ;
  oautomatiserbarhet_nn_1_N : N ;
  oavancerbarhet_nn_1_N : N ;
  oavannonserbarhet_nn_1_N : N ;
  oavdramatiserbarhet_nn_1_N : N ;
  oaviserbarhet_nn_1_N : N ;
  oavkoloniserbarhet_nn_1_N : N ;
  oavkriminaliserbarhet_nn_1_N : N ;
  oavlaatlighet_nn_1_1_N : N ;
  oavmagnetiserbarhet_nn_1_N : N ;
  oavmystifierbarhet_nn_1_N : N ;
  oavmaetthet_nn_1_1_N : N ;
  oavnazifierbarhet_nn_1_N : N ;
  oavpatrullerbarhet_nn_1_N : N ;
  oavpolitiserbarhet_nn_1_N : N ;
  oavpolletterbarhet_nn_1_N : N ;
  oavportraetterbarhet_nn_1_1_N : N ;
  oavreagerbarhet_nn_1_N : N ;
  oavregistrerbarhet_nn_1_N : N ;
  oavreglerbarhet_nn_1_N : N ;
  oavromantiserbarhet_nn_1_N : N ;
  oavsiktlighet_nn_1_N : N ;
  oavsocialiserbarhet_nn_1_N : N ;
  oavstaliniserbarhet_nn_1_N : N ;
  oavsaettlighet_nn_1_1_N : N ;
  oavvisbarhet_nn_1_N : N ;
  oavvislighet_nn_1_N : N ;
  oavytterlighet_nn_1_N : N ;
  oaxiomatiserbarhet_nn_1_N : N ;
  obagatelliserbarhet_nn_1_N : N ;
  obalans_nn_1_N : N ;
  obalanserbarhet_nn_1_N : N ;
  oballoterbarhet_nn_1_N : N ;
  obalsamerbarhet_nn_1_N : N ;
  obanaliserbarhet_nn_1_N : N ;
  obankrutterbarhet_nn_1_N : N ;
  obarmhaertighet_nn_1_1_N : N ;
  obarrikaderbarhet_nn_1_N : N ;
  obaserbarhet_nn_1_N : N ;
  obducerbarhet_nn_1_N : N ;
  obeatifierbarhet_nn_1_N : N ;
  obeboelighet_nn_1_N : N ;
  obefintlighet_nn_1_N : N ;
  obehoerighet_nn_1_1_N : N ;
  obenaegenhet_nn_1_1_N : N ;
  obereddhet_nn_1_N : N ;
  oberaeknelighet_nn_1_1_N : N ;
  oberoemdhet_nn_1_1_N : N ;
  oberoerbarhet_nn_1_1_N : N ;
  obesatthet_nn_1_N : N ;
  obeskrivbarhet_nn_1_N : N ;
  obeskrivlighet_nn_1_N : N ;
  obesticklighet_nn_1_N : N ;
  obestridlighet_nn_1_N : N ;
  obestaellbarhet_nn_1_1_N : N ;
  obetalbarhet_nn_1_N : N ;
  obetongerbarhet_nn_1_N : N ;
  obetvinglighet_nn_1_N : N ;
  obetaenksamhet_nn_1_1_N : N ;
  obetaenkthet_nn_1_1_N : N ;
  obeveklighet_nn_1_N : N ;
  obildbarhet_nn_1_N : N ;
  obiograferbarhet_nn_1_N : N ;
  obisserbarhet_nn_1_N : N ;
  obivackerbarhet_nn_1_N : N ;
  objektfoerlust_nn_1_1_N : N ;
  objektiverbarhet_nn_1_N : N ;
  oblancherbarhet_nn_1_N : N ;
  oblankpolerbarhet_nn_1_N : N ;
  oblesserbarhet_nn_1_N : N ;
  oblidhet_nn_1_N : N ;
  oblidkelighet_nn_1_N : N ;
  obligerbarhet_nn_1_N : N ;
  oblikhet_nn_1_N : N ;
  oblinderbarhet_nn_1_N : N ;
  oblockerbarhet_nn_1_N : N ;
  oblodighet_nn_1_N : N ;
  oblommograferbarhet_nn_1_N : N ;
  oblonderbarhet_nn_1_N : N ;
  oblyghet_nn_1_N : N ;
  oboaserbarhet_nn_1_N : N ;
  obogserbarhet_nn_1_N : N ;
  obokstaverbarhet_nn_1_N : N ;
  obombarderbarhet_nn_1_N : N ;
  oboniterbarhet_nn_1_N : N ;
  obortresonerbarhet_nn_1_N : N ;
  obotfaerdighet_nn_1_1_N : N ;
  obotlighet_nn_1_N : N ;
  obriketterbarhet_nn_1_N : N ;
  obriserbarhet_nn_1_N : N ;
  obroderbarhet_nn_1_N : N ;
  obromerbarhet_nn_1_N : N ;
  obronserbarhet_nn_1_N : N ;
  obroscherbarhet_nn_1_N : N ;
  obrottslighet_nn_1_N : N ;
  obrukbarhet_nn_1_N : N ;
  obruklighet_nn_1_N : N ;
  obrunerbarhet_nn_1_N : N ;
  obrutaliserbarhet_nn_1_N : N ;
  obrytbarhet_nn_1_N : N ;
  obraeserbarhet_nn_1_1_N : N ;
  observans_nn_1_N : N ;
  observerbarhet_nn_1_N : N ;
  obskurhet_nn_1_N : N ;
  obskyrhet_nn_1_N : N ;
  obsolethet_nn_1_N : N ;
  obstetrik_nn_1_N : N ;
  obstruktionspolitik_nn_1_N : N ;
  obudgeterbarhet_nn_1_N : N ;
  obundenhet_nn_1_N : N ;
  obuteljerbarhet_nn_1_N : N ;
  obyraakratiserbarhet_nn_1_1_N : N ;
  obaendighet_nn_1_1_N : N ;
  oboejlighet_nn_1_1_N : N ;
  ocamouflerbarhet_nn_1_N : N ;
  occident_nn_1_N : N ;
  occidentaliserbarhet_nn_1_N : N ;
  ocederbarhet_nn_1_N : N ;
  ocelebrerbarhet_nn_1_N : N ;
  ocementerbarhet_nn_1_N : N ;
  ocensurerbarhet_nn_1_N : N ;
  ocentraliserbarhet_nn_1_N : N ;
  ocentrerbarhet_nn_1_N : N ;
  ocentrifugerbarhet_nn_1_N : N ;
  ocernerbarhet_nn_1_N : N ;
  ochargerbarhet_nn_1_N : N ;
  ocharmerbarhet_nn_1_N : N ;
  ochevroterbarhet_nn_1_N : N ;
  ochiffrerbarhet_nn_1_N : N ;
  ochikanerbarhet_nn_1_N : N ;
  ochockerbarhet_nn_1_N : N ;
  ocirkulerbarhet_nn_1_N : N ;
  ociselerbarhet_nn_1_N : N ;
  ociterbarhet_nn_1_N : N ;
  ociviliserbarhet_nn_1_N : N ;
  ockulthet_nn_1_N : N ;
  ockupationspolitik_nn_1_N : N ;
  ockuperbarhet_nn_1_N : N ;
  ocuraterbarhet_nn_1_N : N ;
  ocurerbarhet_nn_1_N : N ;
  odaterbarhet_nn_1_N : N ;
  odatoriserbarhet_nn_1_N : N ;
  odebarkerbarhet_nn_1_N : N ;
  odebatterbarhet_nn_1_N : N ;
  odebiterbarhet_nn_1_N : N ;
  odecentraliserbarhet_nn_1_N : N ;
  odechiffrerbarhet_nn_1_N : N ;
  odecimerbarhet_nn_1_N : N ;
  odedicerbarhet_nn_1_N : N ;
  odedikerbarhet_nn_1_N : N ;
  odeducerbarhet_nn_1_N : N ;
  odefilerbarhet_nn_1_N : N ;
  odefinierbarhet_nn_1_N : N ;
  odeflorerbarhet_nn_1_N : N ;
  odeformerbarhet_nn_1_N : N ;
  odegenererbarhet_nn_1_N : N ;
  odegraderbarhet_nn_1_N : N ;
  odekanterbarhet_nn_1_N : N ;
  odekapiterbarhet_nn_1_N : N ;
  odeklamerbarhet_nn_1_N : N ;
  odeklarerbarhet_nn_1_N : N ;
  odeklasserbarhet_nn_1_N : N ;
  odeklinerbarhet_nn_1_N : N ;
  odekorerbarhet_nn_1_N : N ;
  odekouragerbarhet_nn_1_N : N ;
  odekreterbarhet_nn_1_N : N ;
  odelbarhet_nn_1_N : N ;
  odelegerbarhet_nn_1_N : N ;
  odemaskerbarhet_nn_1_N : N ;
  odementerbarhet_nn_1_N : N ;
  odemilitariserbarhet_nn_1_N : N ;
  odemobiliserbarhet_nn_1_N : N ;
  odemokratiserbarhet_nn_1_N : N ;
  odemolerbarhet_nn_1_N : N ;
  odemoniserbarhet_nn_1_N : N ;
  odemonstrerbarhet_nn_1_N : N ;
  odemonterbarhet_nn_1_N : N ;
  odemoraliserbarhet_nn_1_N : N ;
  odenaturaliserbarhet_nn_1_N : N ;
  odenaturerbarhet_nn_1_N : N ;
  odenoterbarhet_nn_1_N : N ;
  odenuderbarhet_nn_1_N : N ;
  odeodoriserbarhet_nn_1_N : N ;
  odepatrierbarhet_nn_1_N : N ;
  odepenserbarhet_nn_1_N : N ;
  odeplacerbarhet_nn_1_N : N ;
  odeponerbarhet_nn_1_N : N ;
  odeporterbarhet_nn_1_N : N ;
  odeprecierbarhet_nn_1_N : N ;
  oderangerbarhet_nn_1_N : N ;
  oderiverbarhet_nn_1_N : N ;
  odesarmerbarhet_nn_1_N : N ;
  odesavouerbarhet_nn_1_N : N ;
  odesensibiliserbarhet_nn_1_N : N ;
  odesignerbarhet_nn_1_N : N ;
  odesinfekterbarhet_nn_1_N : N ;
  odesinficerbarhet_nn_1_N : N ;
  odesinformerbarhet_nn_1_N : N ;
  odesorganiserbarhet_nn_1_N : N ;
  odestabiliserbarhet_nn_1_N : N ;
  odestillerbarhet_nn_1_N : N ;
  odestinerbarhet_nn_1_N : N ;
  odestruerbarhet_nn_1_N : N ;
  odetacherbarhet_nn_1_N : N ;
  odetekterbarhet_nn_1_N : N ;
  odeterminerbarhet_nn_1_N : N ;
  odetonerbarhet_nn_1_N : N ;
  odetroniserbarhet_nn_1_N : N ;
  odevalverbarhet_nn_1_N : N ;
  odiagnosticerbarhet_nn_1_N : N ;
  odiagnostiserbarhet_nn_1_N : N ;
  odialyserbarhet_nn_1_N : N ;
  odifferentierbarhet_nn_1_N : N ;
  odiffunderbarhet_nn_1_N : N ;
  odiftongerbarhet_nn_1_N : N ;
  odigererbarhet_nn_1_N : N ;
  odikterbarhet_nn_1_N : N ;
  odimensionerbarhet_nn_1_N : N ;
  odiplomerbarhet_nn_1_N : N ;
  odirigerbarhet_nn_1_N : N ;
  odisambiguerbarhet_nn_1_N : N ;
  odisciplinerbarhet_nn_1_N : N ;
  odisharmonierbarhet_nn_1_N : N ;
  odiskonterbarhet_nn_1_N : N ;
  odiskrediterbarhet_nn_1_N : N ;
  odiskriminerbarhet_nn_1_N : N ;
  odiskuterbarhet_nn_1_N : N ;
  odiskvalificerbarhet_nn_1_N : N ;
  odispascherbarhet_nn_1_N : N ;
  odispenserbarhet_nn_1_N : N ;
  odispergerbarhet_nn_1_N : N ;
  odisponerbarhet_nn_1_N : N ;
  odisputerbarhet_nn_1_N : N ;
  odissekerbarhet_nn_1_N : N ;
  odissimilerbarhet_nn_1_N : N ;
  odissocierbarhet_nn_1_N : N ;
  odistanserbarhet_nn_1_N : N ;
  odistraherbarhet_nn_1_N : N ;
  odistribuerbarhet_nn_1_N : N ;
  odivergerbarhet_nn_1_N : N ;
  odiversifierbarhet_nn_1_N : N ;
  odividerbarhet_nn_1_N : N ;
  odlingsbarhet_nn_1_N : N ;
  odocerbarhet_nn_1_N : N ;
  odogmatiserbarhet_nn_1_N : N ;
  odokumenterbarhet_nn_1_N : N ;
  odomesticerbarhet_nn_1_N : N ;
  odomicilierbarhet_nn_1_N : N ;
  odominerbarhet_nn_1_N : N ;
  odompterbarhet_nn_1_N : N ;
  odonerbarhet_nn_1_N : N ;
  odoserbarhet_nn_1_N : N ;
  odosserbarhet_nn_1_N : N ;
  odoterbarhet_nn_1_N : N ;
  odragerbarhet_nn_1_N : N ;
  odramatiserbarhet_nn_1_N : N ;
  odraperbarhet_nn_1_N : N ;
  odresserbarhet_nn_1_N : N ;
  odryghet_nn_1_N : N ;
  odraeglighet_nn_1_1_N : N ;
  odraenerbarhet_nn_1_1_N : N ;
  odubblerbarhet_nn_1_N : N ;
  oduglighet_nn_1_N : N ;
  oduperbarhet_nn_1_N : N ;
  oduplicerbarhet_nn_1_N : N ;
  odygd_nn_1_N : N ;
  odygdighet_nn_1_N : N ;
  odoedlighet_nn_1_1_N : N ;
  odoert_nn_1_1_N : N ;
  oederbarhet_nn_1_N : N ;
  oeffacerbarhet_nn_1_N : N ;
  oeffektiverbarhet_nn_1_N : N ;
  oeffektiviserbarhet_nn_1_N : N ;
  oeffektuerbarhet_nn_1_N : N ;
  oefterdaterbarhet_nn_1_N : N ;
  oefterdebiterbarhet_nn_1_N : N ;
  oeftergivlighet_nn_1_N : N ;
  oefterhaermlighet_nn_1_1_N : N ;
  oefterrationaliserbarhet_nn_1_N : N ;
  oefterraettlighet_nn_1_1_N : N ;
  oeftersynkroniserbarhet_nn_1_N : N ;
  oeftertaxerbarhet_nn_1_N : N ;
  oegaliserbarhet_nn_1_N : N ;
  oegennyttighet_nn_1_N : N ;
  oegentlighet_nn_2_N : N ;
  oekiperbarhet_nn_1_N : N ;
  oeklaterbarhet_nn_1_N : N ;
  oeklaererbarhet_nn_1_1_N : N ;
  oekonomiserbarhet_nn_1_N : N ;
  oelaborerbarhet_nn_1_N : N ;
  oelastiserbarhet_nn_1_N : N ;
  oelektrificerbarhet_nn_1_N : N ;
  oelektrifierbarhet_nn_1_N : N ;
  oelektriserbarhet_nn_1_N : N ;
  oeliderbarhet_nn_1_N : N ;
  oeliminerbarhet_nn_1_N : N ;
  oeloxerbarhet_nn_1_N : N ;
  oeluderbarhet_nn_1_N : N ;
  oeluerbarhet_nn_1_N : N ;
  oemaljerbarhet_nn_1_N : N ;
  oemanciperbarhet_nn_1_N : N ;
  oemballerbarhet_nn_1_N : N ;
  oembarkerbarhet_nn_1_N : N ;
  oembellerbarhet_nn_1_N : N ;
  oemenderbarhet_nn_1_N : N ;
  oemigrerbarhet_nn_1_N : N ;
  oemitterbarhet_nn_1_N : N ;
  oemotstaandlighet_nn_1_1_N : N ;
  oemotsaeglighet_nn_1_1_N : N ;
  oemottaglighet_nn_1_N : N ;
  oemulgerbarhet_nn_1_N : N ;
  oendosserbarhet_nn_1_N : N ;
  oenerverbarhet_nn_1_N : N ;
  oengagerbarhet_nn_1_N : N ;
  oenleverbarhet_nn_1_N : N ;
  oenrollerbarhet_nn_1_N : N ;
  oensilerbarhet_nn_1_N : N ;
  oentusiasmerbarhet_nn_1_N : N ;
  oepilerbarhet_nn_1_N : N ;
  oerfarenhet_nn_1_N : N ;
  oerhoerdhet_nn_1_1_N : N ;
  oerigerbarhet_nn_1_N : N ;
  oeroderbarhet_nn_1_N : N ;
  oersaettlighet_nn_1_1_N : N ;
  oeskalerbarhet_nn_1_N : N ;
  oeskorterbarhet_nn_1_N : N ;
  oesteticerbarhet_nn_1_N : N ;
  oestetiserbarhet_nn_1_N : N ;
  oestimerbarhet_nn_1_N : N ;
  oetablerbarhet_nn_1_N : N ;
  oeteriserbarhet_nn_1_N : N ;
  oetiketterbarhet_nn_1_N : N ;
  oetymologiserbarhet_nn_1_N : N ;
  oeuropeiserbarhet_nn_1_N : N ;
  oevakuerbarhet_nn_1_N : N ;
  oevaluerbarhet_nn_1_N : N ;
  oevalverbarhet_nn_1_N : N ;
  oevaporerbarhet_nn_1_N : N ;
  oexaminerbarhet_nn_1_N : N ;
  oexcerperbarhet_nn_1_N : N ;
  oexciterbarhet_nn_1_N : N ;
  oexekverbarhet_nn_1_N : N ;
  oexemplifierbarhet_nn_1_N : N ;
  oexercerbarhet_nn_1_N : N ;
  oexkluderbarhet_nn_1_N : N ;
  oexkommunicerbarhet_nn_1_N : N ;
  oexpanderbarhet_nn_1_N : N ;
  oexpatrierbarhet_nn_1_N : N ;
  oexpedierbarhet_nn_1_N : N ;
  oexpektorerbarhet_nn_1_N : N ;
  oexplicerbarhet_nn_1_N : N ;
  oexploaterbarhet_nn_1_N : N ;
  oexploderbarhet_nn_1_N : N ;
  oexponerbarhet_nn_1_N : N ;
  oexporterbarhet_nn_1_N : N ;
  oexproprierbarhet_nn_1_N : N ;
  oexstirperbarhet_nn_1_N : N ;
  oextemporerbarhet_nn_1_N : N ;
  oextraherbarhet_nn_1_N : N ;
  oextrapolerbarhet_nn_1_N : N ;
  ofabricerbarhet_nn_1_N : N ;
  ofabulerbarhet_nn_1_N : N ;
  ofacetterbarhet_nn_1_N : N ;
  ofakturerbarhet_nn_1_N : N ;
  ofalsifierbarhet_nn_1_N : N ;
  ofantiserbarhet_nn_1_N : N ;
  ofantlighet_nn_1_N : N ;
  ofascinerbarhet_nn_1_N : N ;
  ofasetterbarhet_nn_1_N : N ;
  ofasonerbarhet_nn_1_N : N ;
  ofattbarhet_nn_1_N : N ;
  ofattlighet_nn_1_N : N ;
  ofavoriserbarhet_nn_1_N : N ;
  ofelbarhet_nn_1_N : N ;
  ofermenterbarhet_nn_1_N : N ;
  ofeterbarhet_nn_1_N : N ;
  offentlighetsprincip_nn_1_N : N ;
  offentligraettslighet_nn_1_1_N : N ;
  offererbarhet_nn_1_N : N ;
  offergaerd_nn_1_1_N : N ;
  offset_nn_1_N : N ;
  ofilerbarhet_nn_1_N : N ;
  ofilmatiserbarhet_nn_1_N : N ;
  ofiltrerbarhet_nn_1_N : N ;
  ofinansierbarhet_nn_1_N : N ;
  ofingerbarhet_nn_1_N : N ;
  ofinjusterbarhet_nn_1_N : N ;
  ofinlandiserbarhet_nn_1_N : N ;
  ofixerbarhet_nn_1_N : N ;
  oflamberbarhet_nn_1_N : N ;
  oflankerbarhet_nn_1_N : N ;
  oflatterbarhet_nn_1_N : N ;
  oflekterbarhet_nn_1_N : N ;
  ofluidiserbarhet_nn_1_N : N ;
  ofluorerbarhet_nn_1_N : N ;
  ofluoriderbarhet_nn_1_N : N ;
  ofokuserbarhet_nn_1_N : N ;
  ofolierbarhet_nn_1_N : N ;
  ofonderbarhet_nn_1_N : N ;
  oforcerbarhet_nn_1_N : N ;
  oformaliserbarhet_nn_1_N : N ;
  oformerbarhet_nn_1_N : N ;
  oformulerbarhet_nn_1_N : N ;
  ofosfaterbarhet_nn_1_N : N ;
  ofossiliserbarhet_nn_1_N : N ;
  ofotograferbarhet_nn_1_N : N ;
  ofragmenterbarhet_nn_1_N : N ;
  ofraktionerbarhet_nn_1_N : N ;
  oframkomlighet_nn_1_N : N ;
  ofrankerbarhet_nn_1_N : N ;
  ofraserbarhet_nn_1_N : N ;
  ofred_nn_1_N : N ;
  ofrekventerbarhet_nn_1_N : N ;
  ofrid_nn_1_N : N ;
  ofriserbarhet_nn_1_N : N ;
  ofriterbarhet_nn_1_N : N ;
  ofrivillighet_nn_1_N : N ;
  ofronderbarhet_nn_1_N : N ;
  ofrotterbarhet_nn_1_N : N ;
  ofruktbarhet_nn_1_N : N ;
  ofruktsamhet_nn_1_N : N ;
  ofrustrerbarhet_nn_1_N : N ;
  ofraankomlighet_nn_1_1_N : N ;
  oftalmiatrik_nn_1_N : N ;
  ofullgaangenhet_nn_1_1_N : N ;
  ofurnerbarhet_nn_1_N : N ;
  ofusionerbarhet_nn_1_N : N ;
  ofysiljerbarhet_nn_1_N : N ;
  ofaerd_nn_1_1_N : N ;
  ofaerdighet_nn_1_1_N : N ;
  ofaerserbarhet_nn_1_1_N : N ;
  ofoerannonserbarhet_nn_1_1_N : N ;
  ofoerbehaallsamhet_nn_1_1_N : N ;
  ofoerbereddhet_nn_1_1_N : N ;
  ofoerbraennelighet_nn_1_1_N : N ;
  ofoerbaetterlighet_nn_1_1_N : N ;
  ofoerdelaktighet_nn_1_1_N : N ;
  ofoerdragsamhet_nn_1_1_N : N ;
  ofoeretagsamhet_nn_1_1_N : N ;
  ofoergriplighet_nn_1_1_N : N ;
  ofoergaetlighet_nn_1_1_N : N ;
  ofoerhet_nn_1_1_N : N ;
  ofoerliknelighet_nn_1_1_N : N ;
  ofoerlaatlighet_nn_1_1_N : N ;
  ofoermaerkthet_nn_1_1_N : N ;
  ofoermoegenhet_nn_1_1_N : N ;
  ofoerneklighet_nn_1_1_N : N ;
  ofoernoejdhet_nn_1_1_N : N ;
  ofoerryckthet_nn_1_1_N : N ;
  ofoersiktighet_nn_1_1_N : N ;
  ofoerskotterbarhet_nn_1_1_N : N ;
  ofoerskraeckthet_nn_1_1_N : N ;
  ofoerskylldhet_nn_1_1_N : N ;
  ofoersonlighet_nn_1_1_N : N ;
  ofoerstaelldhet_nn_1_1_N : N ;
  ofoerstaemdhet_nn_1_1_N : N ;
  ofoerstaandighet_nn_1_1_N : N ;
  ofoerstoerbarhet_nn_1_1_N : N ;
  ofoerstoerdhet_nn_1_1_N : N ;
  ofoersvarlighet_nn_1_1_N : N ;
  ofoersynthet_nn_1_1_N : N ;
  ofoertjusthet_nn_1_1_N : N ;
  ofoertjaenthet_nn_1_1_N : N ;
  ofoertrutenhet_nn_1_1_N : N ;
  ofoertroettlighet_nn_1_1_N : N ;
  ofoertydbarhet_nn_1_1_N : N ;
  ofoertaeckthet_nn_1_1_N : N ;
  ofoerutbestaemdhet_nn_1_1_N : N ;
  ofoerutsebarhet_nn_1_1_N : N ;
  ofoerutseddhet_nn_1_1_N : N ;
  ofoerutspaaddhet_nn_1_1_N : N ;
  ofoerutsaegbarhet_nn_1_1_N : N ;
  ofoervitlighet_nn_1_1_N : N ;
  ofoerytterlighet_nn_1_1_N : N ;
  ogalliserbarhet_nn_1_N : N ;
  ogaloscherbarhet_nn_1_N : N ;
  ogalvaniserbarhet_nn_1_N : N ;
  ogaragerbarhet_nn_1_N : N ;
  ogaranterbarhet_nn_1_N : N ;
  ogarderbarhet_nn_1_N : N ;
  ogarnerbarhet_nn_1_N : N ;
  ogarnisonerbarhet_nn_1_N : N ;
  ogarrotterbarhet_nn_1_N : N ;
  ogastroskoperbarhet_nn_1_N : N ;
  ogauffrerbarhet_nn_1_N : N ;
  ogelatinerbarhet_nn_1_N : N ;
  ogeminerbarhet_nn_1_N : N ;
  ogeneraliserbarhet_nn_1_N : N ;
  ogenerbarhet_nn_1_N : N ;
  ogenererbarhet_nn_1_N : N ;
  ogenomfoerbarhet_nn_1_1_N : N ;
  ogenomskinlighet_nn_1_N : N ;
  ogenomslaepplighet_nn_1_1_N : N ;
  ogenomtraenglighet_nn_1_1_N : N ;
  ogenomtaenkthet_nn_1_1_N : N ;
  ogensaeglighet_nn_1_1_N : N ;
  ogeometriserbarhet_nn_1_N : N ;
  ogermaniserbarhet_nn_1_N : N ;
  ogiftighet_nn_1_N : N ;
  ogiljotinerbarhet_nn_1_N : N ;
  ogillhet_nn_1_N : N ;
  ogiltighet_nn_1_N : N ;
  ogirerbarhet_nn_1_N : N ;
  oglamoriserbarhet_nn_1_N : N ;
  oglamouriserbarhet_nn_1_N : N ;
  oglaserbarhet_nn_1_N : N ;
  oglorifierbarhet_nn_1_N : N ;
  ogoffrerbarhet_nn_1_N : N ;
  ogouterbarhet_nn_1_N : N ;
  ograderbarhet_nn_1_N : N ;
  ograduerbarhet_nn_1_N : N ;
  ografiterbarhet_nn_1_N : N ;
  ogranulerbarhet_nn_1_N : N ;
  ogratinerbarhet_nn_1_N : N ;
  ogratulerbarhet_nn_1_N : N ;
  ograverbarhet_nn_1_N : N ;
  ogriljerbarhet_nn_1_N : N ;
  ogrimerbarhet_nn_1_N : N ;
  ogripbarhet_nn_1_N : N ;
  ogrunderbarhet_nn_1_N : N ;
  ogrupperbarhet_nn_1_N : N ;
  ogudaktighet_nn_1_N : N ;
  ogudlighet_nn_1_N : N ;
  ogummerbarhet_nn_1_N : N ;
  ogunstighet_nn_1_N : N ;
  oguterbarhet_nn_1_N : N ;
  ogymnastiserbarhet_nn_1_N : N ;
  ogynnsamhet_nn_1_N : N ;
  ogaestvaenlighet_nn_1_1_N : N ;
  ogoerlighet_nn_1_1_N : N ;
  ohallucinerbarhet_nn_1_N : N ;
  ohalverbarhet_nn_1_N : N ;
  ohanterbarhet_nn_1_N : N ;
  ohanterlighet_nn_1_N : N ;
  oharangerbarhet_nn_1_N : N ;
  oharmoniserbarhet_nn_1_N : N ;
  oharpunerbarhet_nn_1_N : N ;
  ohasarderbarhet_nn_1_N : N ;
  ohavererbarhet_nn_1_N : N ;
  ohektograferbarhet_nn_1_N : N ;
  ohelighet_nn_1_N : N ;
  oheroiserbarhet_nn_1_N : N ;
  ohistorierbarhet_nn_1_N : N ;
  ohistoriserbarhet_nn_1_N : N ;
  ohjaelplighet_nn_1_1_N : N ;
  oholograferbarhet_nn_1_N : N ;
  ohomogeniserbarhet_nn_1_N : N ;
  ohonorerbarhet_nn_1_N : N ;
  ohospitaliserbarhet_nn_1_N : N ;
  ohumaniserbarhet_nn_1_N : N ;
  ohundsfotterbarhet_nn_1_N : N ;
  ohuserbarhet_nn_1_N : N ;
  ohybridiserbarhet_nn_1_N : N ;
  ohydrerbarhet_nn_1_N : N ;
  ohypnotiserbarhet_nn_1_N : N ;
  ohypotiserbarhet_nn_1_N : N ;
  ohysbarhet_nn_1_N : N ;
  ohaelsa_nn_1_1_N : N ;
  ohaelsosamhet_nn_1_1_N : N ;
  ohaengdhet_nn_1_1_N : N ;
  ohaerbaergerbarhet_nn_1_1_N : N ;
  ohoeljdhet_nn_1_1_N : N ;
  ohoersamhet_nn_1_1_N : N ;
  ohoevlighet_nn_1_1_N : N ;
  oidealiserbarhet_nn_1_N : N ;
  oidentifierbarhet_nn_1_N : N ;
  oigenkaennlighet_nn_1_1_N : N ;
  oignorerbarhet_nn_1_N : N ;
  oilluminerbarhet_nn_1_N : N ;
  oillustrerbarhet_nn_1_N : N ;
  oimiterbarhet_nn_1_N : N ;
  oimmatrikulerbarhet_nn_1_N : N ;
  oimmigrerbarhet_nn_1_N : N ;
  oimmuniserbarhet_nn_1_N : N ;
  oimplanterbarhet_nn_1_N : N ;
  oimplicerbarhet_nn_1_N : N ;
  oimploderbarhet_nn_1_N : N ;
  oimponerbarhet_nn_1_N : N ;
  oimporterbarhet_nn_1_N : N ;
  oimpregnerbarhet_nn_1_N : N ;
  oimproviserbarhet_nn_1_N : N ;
  oinackorderbarhet_nn_1_N : N ;
  oinaugurerbarhet_nn_1_N : N ;
  oindexerbarhet_nn_1_N : N ;
  oindexreglerbarhet_nn_1_N : N ;
  oindicerbarhet_nn_1_N : N ;
  oindikerbarhet_nn_1_N : N ;
  oindividualiserbarhet_nn_1_N : N ;
  oindoktrinerbarhet_nn_1_N : N ;
  oinducerbarhet_nn_1_N : N ;
  oindustrialiserbarhet_nn_1_N : N ;
  oinfantiliserbarhet_nn_1_N : N ;
  oinfekterbarhet_nn_1_N : N ;
  oinfiltrerbarhet_nn_1_N : N ;
  oinflammerbarhet_nn_1_N : N ;
  oinfluerbarhet_nn_1_N : N ;
  oinformerbarhet_nn_1_N : N ;
  oingraverbarhet_nn_1_N : N ;
  oinhalerbarhet_nn_1_N : N ;
  oinhiberbarhet_nn_1_N : N ;
  oinhibiterbarhet_nn_1_N : N ;
  oinitierbarhet_nn_1_N : N ;
  oinjekterbarhet_nn_1_N : N ;
  oinjicerbarhet_nn_1_N : N ;
  oinkarnerbarhet_nn_1_N : N ;
  oinkasserbarhet_nn_1_N : N ;
  oinklarerbarhet_nn_1_N : N ;
  oinkluderbarhet_nn_1_N : N ;
  oinkorporerbarhet_nn_1_N : N ;
  oinkvarterbarhet_nn_1_N : N ;
  oinnerverbarhet_nn_1_N : N ;
  oinnestaengdhet_nn_1_1_N : N ;
  oinokulerbarhet_nn_1_N : N ;
  oinplanterbarhet_nn_1_N : N ;
  oinrangerbarhet_nn_1_N : N ;
  oinrapporterbarhet_nn_1_N : N ;
  oinregistrerbarhet_nn_1_N : N ;
  oinscenerbarhet_nn_1_N : N ;
  oinseminerbarhet_nn_1_N : N ;
  oinsinuerbarhet_nn_1_N : N ;
  oinskraenkthet_nn_1_1_N : N ;
  oinspekterbarhet_nn_1_N : N ;
  oinspirerbarhet_nn_1_N : N ;
  oinstallerbarhet_nn_1_N : N ;
  oinstitutionaliserbarhet_nn_1_N : N ;
  oinstruerbarhet_nn_1_N : N ;
  oinstrumenterbarhet_nn_1_N : N ;
  oinstuderbarhet_nn_1_N : N ;
  oinstaengdhet_nn_1_1_N : N ;
  ointaglighet_nn_1_N : N ;
  ointegrerbarhet_nn_1_N : N ;
  ointellektualiserbarhet_nn_1_N : N ;
  ointelligenthet_nn_1_N : N ;
  ointensifierbarhet_nn_1_N : N ;
  ointensiverbarhet_nn_1_N : N ;
  ointerfolierbarhet_nn_1_N : N ;
  ointernaliserbarhet_nn_1_N : N ;
  ointernationaliserbarhet_nn_1_N : N ;
  ointernerbarhet_nn_1_N : N ;
  ointerpellerbarhet_nn_1_N : N ;
  ointerpolerbarhet_nn_1_N : N ;
  ointerpreterbarhet_nn_1_N : N ;
  ointerpunkterbarhet_nn_1_N : N ;
  ointervenerbarhet_nn_1_N : N ;
  ointonerbarhet_nn_1_N : N ;
  ointresserbarhet_nn_1_N : N ;
  ointroducerbarhet_nn_1_N : N ;
  oinvaderbarhet_nn_1_N : N ;
  oinvalidiserbarhet_nn_1_N : N ;
  oinventerbarhet_nn_1_N : N ;
  oinverterbarhet_nn_1_N : N ;
  oinvesterbarhet_nn_1_N : N ;
  oinvigdhet_nn_1_N : N ;
  oinviterbarhet_nn_1_N : N ;
  oinvolverbarhet_nn_1_N : N ;
  oirriterbarhet_nn_1_N : N ;
  oislamiserbarhet_nn_1_N : N ;
  oisolerbarhet_nn_1_N : N ;
  oitererbarhet_nn_1_N : N ;
  ojazzifierbarhet_nn_1_N : N ;
  ojoderbarhet_nn_1_N : N ;
  ojonglerbarhet_nn_1_N : N ;
  ojoniserbarhet_nn_1_N : N ;
  ojusterbarhet_nn_1_N : N ;
  ojaemfoerbarhet_nn_1_1_N : N ;
  ojaemfoerlighet_nn_1_1_N : N ;
  ojaemstaelldhet_nn_1_1_N : N ;
  ojaevighet_nn_1_1_N : N ;
  okalandrerbarhet_nn_1_N : N ;
  okalcinerbarhet_nn_1_N : N ;
  okalibrerbarhet_nn_1_N : N ;
  okalkerbarhet_nn_1_N : N ;
  okalkylerbarhet_nn_1_N : N ;
  okalmerbarhet_nn_1_N : N ;
  okamouflerbarhet_nn_1_N : N ;
  okanaliserbarhet_nn_1_N : N ;
  okanderbarhet_nn_1_N : N ;
  okandiderbarhet_nn_1_N : N ;
  okannelerbarhet_nn_1_N : N ;
  okanoniserbarhet_nn_1_N : N ;
  okapitaliserbarhet_nn_1_N : N ;
  okarakteriserbarhet_nn_1_N : N ;
  okaraktaeriserbarhet_nn_1_1_N : N ;
  okarambolerbarhet_nn_1_N : N ;
  okarboniserbarhet_nn_1_N : N ;
  okarikerbarhet_nn_1_N : N ;
  okarterbarhet_nn_1_N : N ;
  okartonnerbarhet_nn_1_N : N ;
  okasserbarhet_nn_1_N : N ;
  okastrerbarhet_nn_1_N : N ;
  okatalogiserbarhet_nn_1_N : N ;
  okatalyserbarhet_nn_1_N : N ;
  okategoriserbarhet_nn_1_N : N ;
  okateteriserbarhet_nn_1_N : N ;
  okatetriserbarhet_nn_1_N : N ;
  okauteriserbarhet_nn_1_N : N ;
  oklanderlighet_nn_1_N : N ;
  oklarerbarhet_nn_1_N : N ;
  oklassificerbarhet_nn_1_N : N ;
  oklokhet_nn_1_N : N ;
  oklorerbarhet_nn_1_N : N ;
  oklaeddhet_nn_1_1_N : N ;
  okoafferbarhet_nn_1_N : N ;
  okoagulerbarhet_nn_1_N : N ;
  okodifierbarhet_nn_1_N : N ;
  okollationerbarhet_nn_1_N : N ;
  okollektiviserbarhet_nn_1_N : N ;
  okoloniserbarhet_nn_1_N : N ;
  okolorerbarhet_nn_1_N : N ;
  okolporterbarhet_nn_1_N : N ;
  okombinerbarhet_nn_1_N : N ;
  okommaterbarhet_nn_1_N : N ;
  okommenderbarhet_nn_1_N : N ;
  okommenterbarhet_nn_1_N : N ;
  okommersialiserbarhet_nn_1_N : N ;
  okommunaliserbarhet_nn_1_N : N ;
  okommunicerbarhet_nn_1_N : N ;
  okommuterbarhet_nn_1_N : N ;
  okomparerbarhet_nn_1_N : N ;
  okompenserbarhet_nn_1_N : N ;
  okompilerbarhet_nn_1_N : N ;
  okompletterbarhet_nn_1_N : N ;
  okomplicerbarhet_nn_1_N : N ;
  okomplimenterbarhet_nn_1_N : N ;
  okomponerbarhet_nn_1_N : N ;
  okomposterbarhet_nn_1_N : N ;
  okomprimerbarhet_nn_1_N : N ;
  okomprometterbarhet_nn_1_N : N ;
  okoncentrerbarhet_nn_1_N : N ;
  okoncessionerbarhet_nn_1_N : N ;
  okoncipierbarhet_nn_1_N : N ;
  okondemnerbarhet_nn_1_N : N ;
  okondenserbarhet_nn_1_N : N ;
  okonditionerbarhet_nn_1_N : N ;
  okondolerbarhet_nn_1_N : N ;
  okonfirmerbarhet_nn_1_N : N ;
  okonfiskerbarhet_nn_1_N : N ;
  okonfronterbarhet_nn_1_N : N ;
  okonfunderbarhet_nn_1_N : N ;
  okongruerbarhet_nn_1_N : N ;
  okonjugerbarhet_nn_1_N : N ;
  okonkluderbarhet_nn_1_N : N ;
  okonkretiserbarhet_nn_1_N : N ;
  okonserverbarhet_nn_1_N : N ;
  okonsignerbarhet_nn_1_N : N ;
  okonsoliderbarhet_nn_1_N : N ;
  okonstaterbarhet_nn_1_N : N ;
  okonsternerbarhet_nn_1_N : N ;
  okonstituerbarhet_nn_1_N : N ;
  okonstruerbarhet_nn_1_N : N ;
  okonsulterbarhet_nn_1_N : N ;
  okonsumerbarhet_nn_1_N : N ;
  okontaminerbarhet_nn_1_N : N ;
  okonterbarhet_nn_1_N : N ;
  okontingenterbarhet_nn_1_N : N ;
  okontoriserbarhet_nn_1_N : N ;
  okontraherbarhet_nn_1_N : N ;
  okontrakterbarhet_nn_1_N : N ;
  okontramanderbarhet_nn_1_N : N ;
  okontrasignerbarhet_nn_1_N : N ;
  okontrasterbarhet_nn_1_N : N ;
  okontribuerbarhet_nn_1_N : N ;
  okontrollerbarhet_nn_1_N : N ;
  okonturerbarhet_nn_1_N : N ;
  okonvergerbarhet_nn_1_N : N ;
  okonverserbarhet_nn_1_N : N ;
  okonverterbarhet_nn_1_N : N ;
  okonvojerbarhet_nn_1_N : N ;
  okoordinerbarhet_nn_1_N : N ;
  okopierbarhet_nn_1_N : N ;
  okorrelerbarhet_nn_1_N : N ;
  okorrigerbarhet_nn_1_N : N ;
  okorroderbarhet_nn_1_N : N ;
  okorrugerbarhet_nn_1_N : N ;
  okorrumperbarhet_nn_1_N : N ;
  okorsetterbarhet_nn_1_N : N ;
  okostymerbarhet_nn_1_N : N ;
  okrackelerbarhet_nn_1_N : N ;
  okrediterbarhet_nn_1_N : N ;
  okreerbarhet_nn_1_N : N ;
  okremerbarhet_nn_1_N : N ;
  okreperbarhet_nn_1_N : N ;
  okreverbarhet_nn_1_N : N ;
  okriminaliserbarhet_nn_1_N : N ;
  okristalliserbarhet_nn_1_N : N ;
  okritiserbarhet_nn_1_N : N ;
  okroppslighet_nn_1_N : N ;
  okrossbarhet_nn_1_N : N ;
  okrypterbarhet_nn_1_N : N ;
  okraenkbarhet_nn_1_1_N : N ;
  oktober_nn_1_N : N ;
  oktrojerbarhet_nn_1_N : N ;
  okuberbarhet_nn_1_N : N ;
  okujonerbarhet_nn_1_N : N ;
  okulerbarhet_nn_1_N : N ;
  okultiverbarhet_nn_1_N : N ;
  okultur_nn_1_N : N ;
  okumulerbarhet_nn_1_N : N ;
  okunskap_nn_1_N : N ;
  okuperbarhet_nn_1_N : N ;
  okuraterbarhet_nn_1_N : N ;
  okurerbarhet_nn_1_N : N ;
  okursiverbarhet_nn_1_N : N ;
  okurtiserbarhet_nn_1_N : N ;
  okuverterbarhet_nn_1_N : N ;
  okuvlighet_nn_1_N : N ;
  okvadrerbarhet_nn_1_N : N ;
  okvalificerbarhet_nn_1_N : N ;
  okvantifierbarhet_nn_1_N : N ;
  okvinnlighet_nn_1_N : N ;
  okvitterbarhet_nn_1_N : N ;
  okvoterbarhet_nn_1_N : N ;
  okynnighet_nn_1_N : N ;
  okyrklighet_nn_1_N : N ;
  okaendhet_nn_1_1_N : N ;
  olabialiserbarhet_nn_1_N : N ;
  olackerbarhet_nn_1_N : N ;
  olamenterbarhet_nn_1_N : N ;
  olaminerbarhet_nn_1_N : N ;
  olangetterbarhet_nn_1_N : N ;
  olanserbarhet_nn_1_N : N ;
  olapiserbarhet_nn_1_N : N ;
  olaserbarhet_nn_1_N : N ;
  olatiniserbarhet_nn_1_N : N ;
  olaverbarhet_nn_1_N : N ;
  olegaliserbarhet_nn_1_N : N ;
  olegerbarhet_nn_1_N : N ;
  olegitimerbarhet_nn_1_N : N ;
  olevererbarhet_nn_1_N : N ;
  oliberaliserbarhet_nn_1_N : N ;
  olicenserbarhet_nn_1_N : N ;
  olicensierbarhet_nn_1_N : N ;
  olicentierbarhet_nn_1_N : N ;
  olierbarhet_nn_1_N : N ;
  olikviderbarhet_nn_1_N : N ;
  olinjerbarhet_nn_1_N : N ;
  olisserbarhet_nn_1_N : N ;
  olitograferbarhet_nn_1_N : N ;
  oljebekaempningsberedskap_nn_1_1_N : N ;
  oljebestaendighet_nn_1_1_N : N ;
  oljeduk_nn_1_N : N ;
  oljedoed_nn_1_1_N : N ;
  oljefilm_nn_1_N : N ;
  oljekonsumtion_nn_1_N : N ;
  oljerikhet_nn_1_N : N ;
  oljighet_nn_1_N : N ;
  ologerbarhet_nn_1_N : N ;
  ologiskhet_nn_1_N : N ;
  olokaliserbarhet_nn_1_N : N ;
  olust_nn_1_N : N ;
  olustighet_nn_1_N : N ;
  oluteiniserbarhet_nn_1_N : N ;
  olycklighet_nn_1_N : N ;
  olycksalighet_nn_1_N : N ;
  olycksdigerhet_nn_1_N : N ;
  olyxrenoverbarhet_nn_1_N : N ;
  olaederbarhet_nn_1_1_N : N ;
  olaeklighet_nn_1_1_N : N ;
  olaemplighet_nn_1_1_N : N ;
  olaendighet_nn_1_1_N : N ;
  olaengdhet_nn_1_1_N : N ;
  olaerdhet_nn_1_1_N : N ;
  olaesbarhet_nn_1_1_N : N ;
  olaeslighet_nn_1_1_N : N ;
  olaat_nn_1_1_N : N ;
  oloensamhet_nn_1_1_N : N ;
  oloesbarhet_nn_1_1_N : N ;
  oloeslighet_nn_1_1_N : N ;
  omadrasserbarhet_nn_1_N : N ;
  omagasinerbarhet_nn_1_N : N ;
  omagnetiserbarhet_nn_1_N : N ;
  omakulerbarhet_nn_1_N : N ;
  omalfoberbarhet_nn_1_N : N ;
  omaltraeterbarhet_nn_1_1_N : N ;
  omanifesterbarhet_nn_1_N : N ;
  omanikurerbarhet_nn_1_N : N ;
  omanikyrerbarhet_nn_1_N : N ;
  omanipulerbarhet_nn_1_N : N ;
  omanlighet_nn_1_N : N ;
  omanoevrerbarhet_nn_1_1_N : N ;
  omarginaliserbarhet_nn_1_N : N ;
  omarinerbarhet_nn_1_N : N ;
  omarkerbarhet_nn_1_N : N ;
  omarmorerbarhet_nn_1_N : N ;
  omarscherbarhet_nn_1_N : N ;
  omarterbarhet_nn_1_N : N ;
  omaskerbarhet_nn_1_N : N ;
  omaskuliniserbarhet_nn_1_N : N ;
  omassakrerbarhet_nn_1_N : N ;
  omasserbarhet_nn_1_N : N ;
  omatelasserbarhet_nn_1_N : N ;
  omaterialiserbarhet_nn_1_N : N ;
  omatterbarhet_nn_1_N : N ;
  omaximerbarhet_nn_1_N : N ;
  ombytlighet_nn_1_N : N ;
  omdirigerbarhet_nn_1_N : N ;
  omedaljerbarhet_nn_1_N : N ;
  omedelbarhet_nn_1_N : N ;
  omedgoerlighet_nn_1_1_N : N ;
  omedicinerbarhet_nn_1_N : N ;
  omekaniserbarhet_nn_1_N : N ;
  omemorerbarhet_nn_1_N : N ;
  omerceriserbarhet_nn_1_N : N ;
  omeriterbarhet_nn_1_N : N ;
  ometalliserbarhet_nn_1_N : N ;
  omfaangsrikhet_nn_1_1_N : N ;
  omikroskoperbarhet_nn_1_N : N ;
  omildhet_nn_1_N : N ;
  omilitariserbarhet_nn_1_N : N ;
  omineraliserbarhet_nn_1_N : N ;
  ominerbarhet_nn_1_N : N ;
  ominiatyriserbarhet_nn_1_N : N ;
  ominimerbarhet_nn_1_N : N ;
  omissiverbarhet_nn_1_N : N ;
  omisskrediterbarhet_nn_1_N : N ;
  omisskaennelighet_nn_1_1_N : N ;
  omisskaennlighet_nn_1_1_N : N ;
  omisstaenksamhet_nn_1_1_N : N ;
  omkrets_nn_1_N : N ;
  ommoeblerbarhet_nn_1_1_N : N ;
  omnejd_nn_1_N : N ;
  omnipotens_nn_1_N : N ;
  omobiliserbarhet_nn_1_N : N ;
  omodellerbarhet_nn_1_N : N ;
  omodererbarhet_nn_1_N : N ;
  omoderniserbarhet_nn_1_N : N ;
  omodifierbarhet_nn_1_N : N ;
  omodulerbarhet_nn_1_N : N ;
  omodaerniserbarhet_nn_1_1_N : N ;
  omonoftongerbarhet_nn_1_N : N ;
  omonopoliserbarhet_nn_1_N : N ;
  omonterbarhet_nn_1_N : N ;
  omoral_nn_1_N : N ;
  omorganisation_nn_1_N : N ;
  omorganiserbarhet_nn_1_N : N ;
  omorserbarhet_nn_1_N : N ;
  omortificerbarhet_nn_1_N : N ;
  omortifierbarhet_nn_1_N : N ;
  omotiverbarhet_nn_1_N : N ;
  omotoriserbarhet_nn_1_N : N ;
  omotstaandlighet_nn_1_1_N : N ;
  omotsaeglighet_nn_1_1_N : N ;
  omottaglighet_nn_1_N : N ;
  omplacerbarhet_nn_1_N : N ;
  oms_nn_1_N : N ;
  omskulpturerbarhet_nn_1_N : N ;
  omsorgsvaard_nn_1_1_N : N ;
  omstriddhet_nn_1_N : N ;
  omstrukturerbarhet_nn_1_N : N ;
  omstaendlighet_nn_1_1_N : N ;
  omstoertning_nn_1_1_N : N ;
  omsyn_nn_1_N : N ;
  omtyckthet_nn_1_N : N ;
  omtaenksamhet_nn_1_1_N : N ;
  omuljerbarhet_nn_1_N : N ;
  omultiplicerbarhet_nn_1_N : N ;
  omumifierbarhet_nn_1_N : N ;
  omutbarhet_nn_1_N : N ;
  omuterbarhet_nn_1_N : N ;
  omutlighet_nn_1_N : N ;
  omvaendbarhet_nn_1_1_N : N ;
  omvaerderbarhet_nn_1_1_N : N ;
  omyndighet_nn_1_N : N ;
  omystifierbarhet_nn_1_N : N ;
  omaengdhet_nn_1_1_N : N ;
  omaerklighet_nn_1_1_N : N ;
  omaetlighet_nn_1_1_N : N ;
  omaettlighet_nn_1_1_N : N ;
  omoeblerbarhet_nn_1_1_N : N ;
  onasalerbarhet_nn_1_N : N ;
  onasaliserbarhet_nn_1_N : N ;
  onationaliserbarhet_nn_1_N : N ;
  onatur_nn_1_N : N ;
  onaturaliserbarhet_nn_1_N : N ;
  onavigerbarhet_nn_1_N : N ;
  ondsinthet_nn_1_N : N ;
  ondulerbarhet_nn_1_N : N ;
  one_step_nn_1_N : N ;
  onedtransformerbarhet_nn_1_N : N ;
  onedtransponerbarhet_nn_1_N : N ;
  onedvaerderbarhet_nn_1_1_N : N ;
  onegerbarhet_nn_1_N : N ;
  onegligerbarhet_nn_1_N : N ;
  onegocierbarhet_nn_1_N : N ;
  onegotierbarhet_nn_1_N : N ;
  oneklighet_nn_1_N : N ;
  onertransformerbarhet_nn_1_N : N ;
  onertransponerbarhet_nn_1_N : N ;
  onervaerderbarhet_nn_1_1_N : N ;
  onestep_nn_1_N : N ;
  oneutraliserbarhet_nn_1_N : N ;
  oniellerbarhet_nn_1_N : N ;
  onitrerbarhet_nn_1_N : N ;
  onivellerbarhet_nn_1_N : N ;
  onobiliserbarhet_nn_1_N : N ;
  onominerbarhet_nn_1_N : N ;
  ononchalerbarhet_nn_1_N : N ;
  onormaliserbarhet_nn_1_N : N ;
  onormerbarhet_nn_1_N : N ;
  onoslighet_nn_1_N : N ;
  onoterbarhet_nn_1_N : N ;
  onotificerbarhet_nn_1_N : N ;
  onotifierbarhet_nn_1_N : N ;
  onotiserbarhet_nn_1_N : N ;
  onumrerbarhet_nn_1_N : N ;
  onyanserbarhet_nn_1_N : N ;
  onaemnbarhet_nn_1_1_N : N ;
  onaabarhet_nn_1_1_N : N ;
  onaad_nn_1_1_N : N ;
  onaadighet_nn_1_1_N : N ;
  onoejaktighet_nn_1_1_N : N ;
  oobducerbarhet_nn_1_N : N ;
  oobjektiverbarhet_nn_1_N : N ;
  oobligerbarhet_nn_1_N : N ;
  oobserverbarhet_nn_1_N : N ;
  ooccidentaliserbarhet_nn_1_N : N ;
  oockuperbarhet_nn_1_N : N ;
  ooffererbarhet_nn_1_N : N ;
  ooktrojerbarhet_nn_1_N : N ;
  ookulerbarhet_nn_1_N : N ;
  oolit_nn_1_N : N ;
  oombeddhet_nn_1_N : N ;
  oomdirigerbarhet_nn_1_N : N ;
  oomkullkastlighet_nn_1_N : N ;
  oomkullrunkelighet_nn_1_N : N ;
  oommoeblerbarhet_nn_1_1_N : N ;
  oomorganiserbarhet_nn_1_N : N ;
  oomplacerbarhet_nn_1_N : N ;
  oomskulpturerbarhet_nn_1_N : N ;
  oomstrukturerbarhet_nn_1_N : N ;
  oomtvistlighet_nn_1_N : N ;
  oomvaerderbarhet_nn_1_1_N : N ;
  oondulerbarhet_nn_1_N : N ;
  ooperationaliserbarhet_nn_1_N : N ;
  oopererbarhet_nn_1_N : N ;
  oopponerbarhet_nn_1_N : N ;
  ooptimerbarhet_nn_1_N : N ;
  oordentlighet_nn_1_N : N ;
  oordinerbarhet_nn_1_N : N ;
  oorganiserbarhet_nn_1_N : N ;
  oorganiskhet_nn_1_N : N ;
  oorienterbarhet_nn_1_N : N ;
  oorkestrerbarhet_nn_1_N : N ;
  oornamenterbarhet_nn_1_N : N ;
  oornerbarhet_nn_1_N : N ;
  oortodoxhet_nn_1_N : N ;
  ooxiderbarhet_nn_1_N : N ;
  opacificerbarhet_nn_1_N : N ;
  opaginerbarhet_nn_1_N : N ;
  opaketerbarhet_nn_1_N : N ;
  opakteknik_nn_1_N : N ;
  opalataliserbarhet_nn_1_N : N ;
  opalescens_nn_1_N : N ;
  opaljetterbarhet_nn_1_N : N ;
  opalperbarhet_nn_1_N : N ;
  opanerbarhet_nn_1_N : N ;
  opanorerbarhet_nn_1_N : N ;
  opantograferbarhet_nn_1_N : N ;
  oparaderbarhet_nn_1_N : N ;
  oparaferbarhet_nn_1_N : N ;
  oparaffinerbarhet_nn_1_N : N ;
  oparafraserbarhet_nn_1_N : N ;
  oparallelliserbarhet_nn_1_N : N ;
  oparalyserbarhet_nn_1_N : N ;
  oparerbarhet_nn_1_N : N ;
  oparfymerbarhet_nn_1_N : N ;
  oparkerbarhet_nn_1_N : N ;
  oparketterbarhet_nn_1_N : N ;
  oparodierbarhet_nn_1_N : N ;
  opartiskhet_nn_1_N : N ;
  opasserbarhet_nn_1_N : N ;
  opassiverbarhet_nn_1_N : N ;
  opassiviserbarhet_nn_1_N : N ;
  opasslighet_nn_1_N : N ;
  opastoeriserbarhet_nn_1_1_N : N ;
  opatenterbarhet_nn_1_N : N ;
  opatinerbarhet_nn_1_N : N ;
  opatrullerbarhet_nn_1_N : N ;
  opauperiserbarhet_nn_1_N : N ;
  opauserbarhet_nn_1_N : N ;
  opelleterbarhet_nn_1_N : N ;
  openetrerbarhet_nn_1_N : N ;
  opensionerbarhet_nn_1_N : N ;
  operapublik_nn_1_N : N ;
  operationaliserbarhet_nn_1_N : N ;
  operationsanalys_nn_1_N : N ;
  opercipierbarhet_nn_1_N : N ;
  opererbarhet_nn_1_N : N ;
  operforerbarhet_nn_1_N : N ;
  operiodiserbarhet_nn_1_N : N ;
  opermitterbarhet_nn_1_N : N ;
  opermuterbarhet_nn_1_N : N ;
  opersiflerbarhet_nn_1_N : N ;
  opersonifierbarhet_nn_1_N : N ;
  opersonlighet_nn_1_N : N ;
  opersvaderbarhet_nn_1_N : N ;
  operverterbarhet_nn_1_N : N ;
  opetrifierbarhet_nn_1_N : N ;
  opikerbarhet_nn_1_N : N ;
  opincerbarhet_nn_1_N : N ;
  opiumroekning_nn_1_1_N : N ;
  opkonst_nn_1_N : N ;
  oplacerbarhet_nn_1_N : N ;
  oplagierbarhet_nn_1_N : N ;
  oplanerbarhet_nn_1_N : N ;
  oplanterbarhet_nn_1_N : N ;
  oplatinerbarhet_nn_1_N : N ;
  oplisserbarhet_nn_1_N : N ;
  oplomberbarhet_nn_1_N : N ;
  oplaeterbarhet_nn_1_1_N : N ;
  opocherbarhet_nn_1_N : N ;
  opointerbarhet_nn_1_N : N ;
  opolariserbarhet_nn_1_N : N ;
  opolerbarhet_nn_1_N : N ;
  opolitiserbarhet_nn_1_N : N ;
  opolletterbarhet_nn_1_N : N ;
  opollinerbarhet_nn_1_N : N ;
  opomaderbarhet_nn_1_N : N ;
  opopulariserbarhet_nn_1_N : N ;
  oportionerbarhet_nn_1_N : N ;
  oportraetterbarhet_nn_1_1_N : N ;
  opostdaterbarhet_nn_1_N : N ;
  oposterbarhet_nn_1_N : N ;
  opostponerbarhet_nn_1_N : N ;
  opostulerbarhet_nn_1_N : N ;
  opoaengterbarhet_nn_1_1_N : N ;
  oppfinningsrikhet_nn_1_N : N ;
  oppfaellbarhet_nn_1_1_N : N ;
  opphinnelighet_nn_1_N : N ;
  oppjusterbarhet_nn_1_N : N ;
  oppklaeddhet_nn_1_1_N : N ;
  oppknaeppthet_nn_1_1_N : N ;
  oppkoerdhet_nn_1_1_N : N ;
  oppochnedvaendhet_nn_1_1_N : N ;
  oppochnervaendhet_nn_1_1_N : N ;
  opponerbarhet_nn_1_N : N ;
  opportunhet_nn_1_N : N ;
  opportunitetsprincip_nn_1_N : N ;
  oppsummerbarhet_nn_1_N : N ;
  oppvaerderbarhet_nn_1_1_N : N ;
  oppvaext_nn_1_1_N : N ;
  oppaanedvaendhet_nn_1_1_N : N ;
  oppaanervaendhet_nn_1_1_N : N ;
  opraktiserbarhet_nn_1_N : N ;
  opraktiskhet_nn_1_N : N ;
  opreciserbarhet_nn_1_N : N ;
  oprecishet_nn_1_N : N ;
  opredestinerbarhet_nn_1_N : N ;
  opredicerbarhet_nn_1_N : N ;
  opredisponerbarhet_nn_1_N : N ;
  oprefabricerbarhet_nn_1_N : N ;
  oprefererbarhet_nn_1_N : N ;
  oprefigerbarhet_nn_1_N : N ;
  opreludierbarhet_nn_1_N : N ;
  opremierbarhet_nn_1_N : N ;
  opreparerbarhet_nn_1_N : N ;
  opresenterbarhet_nn_1_N : N ;
  opreserverbarhet_nn_1_N : N ;
  opreskriberbarhet_nn_1_N : N ;
  opresterbarhet_nn_1_N : N ;
  opresumerbarhet_nn_1_N : N ;
  oprioriterbarhet_nn_1_N : N ;
  oprivatiserbarhet_nn_1_N : N ;
  oprivilegierbarhet_nn_1_N : N ;
  oproberbarhet_nn_1_N : N ;
  oproblematiserbarhet_nn_1_N : N ;
  oproducerbarhet_nn_1_N : N ;
  oprofanerbarhet_nn_1_N : N ;
  oprofessionaliserbarhet_nn_1_N : N ;
  oprofilerbarhet_nn_1_N : N ;
  oprognostiserbarhet_nn_1_N : N ;
  oprogrammerbarhet_nn_1_N : N ;
  oprojekterbarhet_nn_1_N : N ;
  oprojicerbarhet_nn_1_N : N ;
  oproklamerbarhet_nn_1_N : N ;
  oproletariserbarhet_nn_1_N : N ;
  oprolongerbarhet_nn_1_N : N ;
  opromoverbarhet_nn_1_N : N ;
  opromulgerbarhet_nn_1_N : N ;
  oprononcerbarhet_nn_1_N : N ;
  oproponerbarhet_nn_1_N : N ;
  oproportionerbarhet_nn_1_N : N ;
  oproportionerlighet_nn_1_N : N ;
  oproskriberbarhet_nn_1_N : N ;
  oprospekterbarhet_nn_1_N : N ;
  oprotegerbarhet_nn_1_N : N ;
  oprotokollerbarhet_nn_1_N : N ;
  oprovocerbarhet_nn_1_N : N ;
  opsykologiserbarhet_nn_1_N : N ;
  optik_nn_1_N : N ;
  optimerbarhet_nn_1_N : N ;
  optoelektronik_nn_1_N : N ;
  opublicerbarhet_nn_1_N : N ;
  opulens_nn_1_N : N ;
  opulveriserbarhet_nn_1_N : N ;
  opulvriserbarhet_nn_1_N : N ;
  opunkterbarhet_nn_1_N : N ;
  opurgerbarhet_nn_1_N : N ;
  opaaannonserbarhet_nn_1_1_N : N ;
  opaalitlighet_nn_1_1_N : N ;
  opaaverkbarhet_nn_1_1_N : N ;
  orabatterbarhet_nn_1_N : N ;
  oraderbarhet_nn_1_N : N ;
  oradierbarhet_nn_1_N : N ;
  oradikaliserbarhet_nn_1_N : N ;
  oraffinerbarhet_nn_1_N : N ;
  oramponerbarhet_nn_1_N : N ;
  orangerbarhet_nn_1_N : N ;
  oransonerbarhet_nn_1_N : N ;
  orappellerbarhet_nn_1_N : N ;
  orapporterbarhet_nn_1_N : N ;
  oraserbarhet_nn_1_N : N ;
  oratificerbarhet_nn_1_N : N ;
  orationaliserbarhet_nn_1_N : N ;
  ordagrannhet_nn_1_N : N ;
  orddoevhet_nn_1_1_N : N ;
  ordentlighet_nn_1_N : N ;
  ordfattighet_nn_1_N : N ;
  ordhaallighet_nn_1_1_N : N ;
  ordinerbarhet_nn_1_N : N ;
  ordkarghet_nn_1_N : N ;
  ordknapphet_nn_1_N : N ;
  ordloeshet_nn_1_1_N : N ;
  ordningsamhet_nn_1_N : N ;
  ordningsbot_nn_1_N : N ;
  ordningsmakt_nn_1_N : N ;
  ordningspolis_nn_1_N : N ;
  ordrikhet_nn_1_N : N ;
  ordsemantik_nn_1_N : N ;
  ordstumhet_nn_1_N : N ;
  oreaktiverbarhet_nn_1_N : N ;
  orealiserbarhet_nn_1_N : N ;
  oreassurerbarhet_nn_1_N : N ;
  orecenserbarhet_nn_1_N : N ;
  orecipierbarhet_nn_1_N : N ;
  oreciterbarhet_nn_1_N : N ;
  oredigerbarhet_nn_1_N : N ;
  oredighet_nn_1_N : N ;
  oreducerbarhet_nn_1_N : N ;
  orefererbarhet_nn_1_N : N ;
  oreflekterbarhet_nn_1_N : N ;
  oreformerbarhet_nn_1_N : N ;
  orefuserbarhet_nn_1_N : N ;
  oregalerbarhet_nn_1_N : N ;
  oregenererbarhet_nn_1_N : N ;
  oregerbarhet_nn_1_N : N ;
  oregerlighet_nn_1_N : N ;
  oregisserbarhet_nn_1_N : N ;
  oregistrerbarhet_nn_1_N : N ;
  oreglementerbarhet_nn_1_N : N ;
  oreglerbarhet_nn_1_N : N ;
  oregummerbarhet_nn_1_N : N ;
  orehabiliterbarhet_nn_1_N : N ;
  oreinkarnerbarhet_nn_1_N : N ;
  orekapitulerbarhet_nn_1_N : N ;
  oreklamerbarhet_nn_1_N : N ;
  orekognoscerbarhet_nn_1_N : N ;
  orekognoserbarhet_nn_1_N : N ;
  orekommenderbarhet_nn_1_N : N ;
  orekompenserbarhet_nn_1_N : N ;
  orekonstruerbarhet_nn_1_N : N ;
  orekryterbarhet_nn_1_N : N ;
  orektificerbarhet_nn_1_N : N ;
  orektifierbarhet_nn_1_N : N ;
  orekvirerbarhet_nn_1_N : N ;
  orelaterbarhet_nn_1_N : N ;
  orelegerbarhet_nn_1_N : N ;
  oremitterbarhet_nn_1_N : N ;
  oremplacerbarhet_nn_1_N : N ;
  orenderbarhet_nn_1_N : N ;
  orenoverbarhet_nn_1_N : N ;
  oreorganiserbarhet_nn_1_N : N ;
  oreparerbarhet_nn_1_N : N ;
  orepartiserbarhet_nn_1_N : N ;
  orepatrierbarhet_nn_1_N : N ;
  orepellerbarhet_nn_1_N : N ;
  orepeterbarhet_nn_1_N : N ;
  orepresenterbarhet_nn_1_N : N ;
  orepriserbarhet_nn_1_N : N ;
  oreproducerbarhet_nn_1_N : N ;
  oreserverbarhet_nn_1_N : N ;
  oresolverbarhet_nn_1_N : N ;
  oresonlighet_nn_1_N : N ;
  oresorberbarhet_nn_1_N : N ;
  orespekterbarhet_nn_1_N : N ;
  orespirerbarhet_nn_1_N : N ;
  orestaurerbarhet_nn_1_N : N ;
  orestituerbarhet_nn_1_N : N ;
  oresumerbarhet_nn_1_N : N ;
  oretablerbarhet_nn_1_N : N ;
  oretarderbarhet_nn_1_N : N ;
  oreturnerbarhet_nn_1_N : N ;
  oretuscherbarhet_nn_1_N : N ;
  orevalverbarhet_nn_1_N : N ;
  oreveterbarhet_nn_1_N : N ;
  oreviderbarhet_nn_1_N : N ;
  orevolutionerbarhet_nn_1_N : N ;
  organisation_nn_2_N : N ;
  organiserbarhet_nn_1_N : N ;
  orgelmusik_nn_1_N : N ;
  orgelpunkt_nn_1_N : N ;
  orgiasm_nn_1_N : N ;
  orient_nn_1_N : N ;
  orientalistik_nn_1_N : N ;
  orienterbarhet_nn_1_N : N ;
  oritualiserbarhet_nn_1_N : N ;
  ork_nn_1_N : N ;
  orkesloeshet_nn_1_1_N : N ;
  orkestermusik_nn_1_N : N ;
  orkestik_nn_1_N : N ;
  orkestrerbarhet_nn_1_N : N ;
  orkloeshet_nn_1_1_N : N ;
  ormrot_nn_1_N : N ;
  ornamenterbarhet_nn_1_N : N ;
  ornamentik_nn_1_N : N ;
  ornerbarhet_nn_1_N : N ;
  orobotiserbarhet_nn_1_N : N ;
  orockerbarhet_nn_1_N : N ;
  orogenes_nn_1_N : N ;
  oromantiserbarhet_nn_1_N : N ;
  oroterbarhet_nn_1_N : N ;
  orsaklighet_nn_1_N : N ;
  orsaksbestaemdhet_nn_1_1_N : N ;
  orsaksmaessighet_nn_1_1_N : N ;
  orselj_nn_1_N : N ;
  ortodoxhet_nn_1_N : N ;
  ortoklas_nn_1_N : N ;
  orubblighet_nn_1_N : N ;
  orubricerbarhet_nn_1_N : N ;
  oruinerbarhet_nn_1_N : N ;
  orundhet_nn_1_N : N ;
  orussificerbarhet_nn_1_N : N ;
  orussifierbarhet_nn_1_N : N ;
  orygglighet_nn_1_N : N ;
  orytmiserbarhet_nn_1_N : N ;
  oraeddhet_nn_1_1_N : N ;
  oraeknelighet_nn_1_1_N : N ;
  oraettmaetighet_nn_1_1_N : N ;
  oraettraadighet_nn_1_1_N : N ;
  oroerbarhet_nn_1_1_N : N ;
  oroerdhet_nn_1_1_N : N ;
  oroerlighet_nn_1_1_N : N ;
  osaboterbarhet_nn_1_N : N ;
  osabrerbarhet_nn_1_N : N ;
  osakkunnighet_nn_1_N : N ;
  osalderbarhet_nn_1_N : N ;
  osalighet_nn_1_N : N ;
  osaluterbarhet_nn_1_N : N ;
  osamtaxerbarhet_nn_1_N : N ;
  osanerbarhet_nn_1_N : N ;
  osanforiserbarhet_nn_1_N : N ;
  osanktifierbarhet_nn_1_N : N ;
  osanktionerbarhet_nn_1_N : N ;
  osannfaerdighet_nn_1_1_N : N ;
  osannolikhet_nn_1_N : N ;
  osaponifierbarhet_nn_1_N : N ;
  osatinerbarhet_nn_1_N : N ;
  osatisfierbarhet_nn_1_N : N ;
  osaturerbarhet_nn_1_N : N ;
  osauterbarhet_nn_1_N : N ;
  osauverbarhet_nn_1_N : N ;
  oschablonerbarhet_nn_1_N : N ;
  oschabloniserbarhet_nn_1_N : N ;
  oschamponerbarhet_nn_1_N : N ;
  oschatterbarhet_nn_1_N : N ;
  oschematiserbarhet_nn_1_N : N ;
  osedimenterbarhet_nn_1_N : N ;
  osedvanlighet_nn_1_N : N ;
  osegmenterbarhet_nn_1_N : N ;
  osegregerbarhet_nn_1_N : N ;
  osekonderbarhet_nn_1_N : N ;
  osekulariserbarhet_nn_1_N : N ;
  osekunderbarhet_nn_1_N : N ;
  osekvestrerbarhet_nn_1_N : N ;
  oselekterbarhet_nn_1_N : N ;
  osemaforerbarhet_nn_1_N : N ;
  oseminerbarhet_nn_1_N : N ;
  osensibiliserbarhet_nn_1_N : N ;
  osenterbarhet_nn_1_N : N ;
  oseparerbarhet_nn_1_N : N ;
  oserverbarhet_nn_1_N : N ;
  osexualiserbarhet_nn_1_N : N ;
  oshamponerbarhet_nn_1_N : N ;
  osigillerbarhet_nn_1_N : N ;
  osignalerbarhet_nn_1_N : N ;
  osignerbarhet_nn_1_N : N ;
  osiktbarhet_nn_1_N : N ;
  osiktighet_nn_1_N : N ;
  osilhuetterbarhet_nn_1_N : N ;
  osiluetterbarhet_nn_1_N : N ;
  osimplifierbarhet_nn_1_N : N ;
  osimulerbarhet_nn_1_N : N ;
  osinlighet_nn_1_N : N ;
  osinnlighet_nn_1_N : N ;
  osis_nn_1_N : N ;
  oskadlighet_nn_1_N : N ;
  oskalperbarhet_nn_1_N : N ;
  oskandaliserbarhet_nn_1_N : N ;
  oskanderbarhet_nn_1_N : N ;
  oskaplighet_nn_1_N : N ;
  oskarphet_nn_1_N : N ;
  oskattbarhet_nn_1_N : N ;
  oskicklighet_nn_1_N : N ;
  oskisserbarhet_nn_1_N : N ;
  oskrafferbarhet_nn_1_N : N ;
  oskuldsfullhet_nn_1_N : N ;
  oskulpterbarhet_nn_1_N : N ;
  oskulpturerbarhet_nn_1_N : N ;
  oskyldighet_nn_1_N : N ;
  oskaelighet_nn_1_1_N : N ;
  oskoenhet_nn_1_1_N : N ;
  oslagbarhet_nn_1_N : N ;
  oslaviserbarhet_nn_1_N : N ;
  oslaecklighet_nn_1_1_N : N ;
  osmak_nn_1_N : N ;
  osmidbarhet_nn_1_N : N ;
  osmos_nn_1_N : N ;
  osmund_nn_1_N : N ;
  osmaeltbarhet_nn_1_1_N : N ;
  osnedrekryterbarhet_nn_1_N : N ;
  osnygghet_nn_1_N : N ;
  osocialiserbarhet_nn_1_N : N ;
  osolverbarhet_nn_1_N : N ;
  osonderbarhet_nn_1_N : N ;
  osordinerbarhet_nn_1_N : N ;
  osorterbarhet_nn_1_N : N ;
  osoulagerbarhet_nn_1_N : N ;
  osovjetiserbarhet_nn_1_N : N ;
  ospaljerbarhet_nn_1_N : N ;
  ospallerbarhet_nn_1_N : N ;
  ospecialiserbarhet_nn_1_N : N ;
  ospecificerbarhet_nn_1_N : N ;
  ospeciminerbarhet_nn_1_N : N ;
  ospekulerbarhet_nn_1_N : N ;
  ospelbarhet_nn_1_N : N ;
  ospenderbarhet_nn_1_N : N ;
  ospolierbarhet_nn_1_N : N ;
  ost_nn_2_N : N ;
  ostabiliserbarhet_nn_1_N : N ;
  ostadighet_nn_1_N : N ;
  ostafferbarhet_nn_1_N : N ;
  ostan_nn_1_N : N ;
  ostandardiserbarhet_nn_1_N : N ;
  ostationerbarhet_nn_1_N : N ;
  ostatuerbarhet_nn_1_N : N ;
  ostencilerbarhet_nn_1_N : N ;
  ostenograferbarhet_nn_1_N : N ;
  ostereotyperbarhet_nn_1_N : N ;
  osteriliserbarhet_nn_1_N : N ;
  osthyvelsprincip_nn_1_N : N ;
  ostighet_nn_1_N : N ;
  ostigmatiserbarhet_nn_1_N : N ;
  ostiliserbarhet_nn_1_N : N ;
  ostimulerbarhet_nn_1_N : N ;
  ostipendierbarhet_nn_1_N : N ;
  ostipulerbarhet_nn_1_N : N ;
  ostofferbarhet_nn_1_N : N ;
  ostrafflighet_nn_1_N : N ;
  ostrangulerbarhet_nn_1_N : N ;
  ostratifierbarhet_nn_1_N : N ;
  ostridighet_nn_1_N : N ;
  ostronoert_nn_1_1_N : N ;
  ostrukturerbarhet_nn_1_N : N ;
  ostuderbarhet_nn_1_N : N ;
  ostyrighet_nn_1_N : N ;
  ostaemdhet_nn_1_1_N : N ;
  ostoerdhet_nn_1_1_N : N ;
  osublimerbarhet_nn_1_N : N ;
  osubordinerbarhet_nn_1_N : N ;
  osubsidierbarhet_nn_1_N : N ;
  osubskriberbarhet_nn_1_N : N ;
  osubstantiverbarhet_nn_1_N : N ;
  osubstituerbarhet_nn_1_N : N ;
  osubsumerbarhet_nn_1_N : N ;
  osubtraherbarhet_nn_1_N : N ;
  osubventionerbarhet_nn_1_N : N ;
  osuccederbarhet_nn_1_N : N ;
  osuffigerbarhet_nn_1_N : N ;
  osufflerbarhet_nn_1_N : N ;
  osuggererbarhet_nn_1_N : N ;
  osummerbarhet_nn_1_N : N ;
  osupplerbarhet_nn_1_N : N ;
  osupponerbarhet_nn_1_N : N ;
  osurfbarhet_nn_1_N : N ;
  osuspenderbarhet_nn_1_N : N ;
  osviklighet_nn_1_N : N ;
  osymboliserbarhet_nn_1_N : N ;
  osynkoperbarhet_nn_1_N : N ;
  osynkroniserbarhet_nn_1_N : N ;
  osyntetiserbarhet_nn_1_N : N ;
  osystematiserbarhet_nn_1_N : N ;
  osaegbarhet_nn_1_1_N : N ;
  osaeglighet_nn_1_1_N : N ;
  osaeljbarhet_nn_1_1_N : N ;
  osaellhet_nn_1_1_N : N ;
  osaellskaplighet_nn_1_1_N : N ;
  osaenkbarhet_nn_1_1_N : N ;
  osaarbarhet_nn_1_1_N : N ;
  osaaterbarhet_nn_1_1_N : N ;
  osaaverbarhet_nn_1_1_N : N ;
  osoekthet_nn_1_1_N : N ;
  otabellerbarhet_nn_1_N : N ;
  otabuerbarhet_nn_1_N : N ;
  otacksamhet_nn_1_N : N ;
  otadlighet_nn_1_N : N ;
  otalighet_nn_1_N : N ;
  otamponerbarhet_nn_1_N : N ;
  otangerbarhet_nn_1_N : N ;
  otapetserbarhet_nn_1_N : N ;
  otarerbarhet_nn_1_N : N ;
  otarifferbarhet_nn_1_N : N ;
  otatuerbarhet_nn_1_N : N ;
  otaxerbarhet_nn_1_N : N ;
  oteknifierbarhet_nn_1_N : N ;
  otelefonerbarhet_nn_1_N : N ;
  otelegraferbarhet_nn_1_N : N ;
  oteleviserbarhet_nn_1_N : N ;
  otemperbarhet_nn_1_N : N ;
  otempererbarhet_nn_1_N : N ;
  otenterbarhet_nn_1_N : N ;
  oterrasserbarhet_nn_1_N : N ;
  oterroriserbarhet_nn_1_N : N ;
  otesaurerbarhet_nn_1_N : N ;
  otestamenterbarhet_nn_1_N : N ;
  otillfoerlitlighet_nn_1_1_N : N ;
  otillraecklighet_nn_1_1_N : N ;
  otillraeknelighet_nn_1_1_N : N ;
  otillstaendighet_nn_1_1_N : N ;
  otillaemplighet_nn_1_1_N : N ;
  otillaatlighet_nn_1_1_N : N ;
  otitrerbarhet_nn_1_N : N ;
  otitulerbarhet_nn_1_N : N ;
  otjusighet_nn_1_N : N ;
  otjaenlighet_nn_1_1_N : N ;
  otolererbarhet_nn_1_N : N ;
  otorderbarhet_nn_1_N : N ;
  otorpederbarhet_nn_1_N : N ;
  otorterbarhet_nn_1_N : N ;
  otoucherbarhet_nn_1_N : N ;
  otouperbarhet_nn_1_N : N ;
  otraderbarhet_nn_1_N : N ;
  otrafikerbarhet_nn_1_N : N ;
  otrakasserbarhet_nn_1_N : N ;
  otrakterbarhet_nn_1_N : N ;
  otrancherbarhet_nn_1_N : N ;
  otransfererbarhet_nn_1_N : N ;
  otransformerbarhet_nn_1_N : N ;
  otransiterbarhet_nn_1_N : N ;
  otranskriberbarhet_nn_1_N : N ;
  otranslittererbarhet_nn_1_N : N ;
  otransmitterbarhet_nn_1_N : N ;
  otransmuterbarhet_nn_1_N : N ;
  otransplanterbarhet_nn_1_N : N ;
  otransponerbarhet_nn_1_N : N ;
  otransporterbarhet_nn_1_N : N ;
  otransumerbarhet_nn_1_N : N ;
  otrasserbarhet_nn_1_N : N ;
  otravesterbarhet_nn_1_N : N ;
  otrepanerbarhet_nn_1_N : N ;
  otriangulerbarhet_nn_1_N : N ;
  otrierbarhet_nn_1_N : N ;
  otrivialiserbarhet_nn_1_N : N ;
  otrivsamhet_nn_1_N : N ;
  otryfferbarhet_nn_1_N : N ;
  otrygghet_nn_1_N : N ;
  otroestlighet_nn_1_1_N : N ;
  otroettlighet_nn_1_1_N : N ;
  ottesaang_nn_1_1_N : N ;
  otukt_nn_1_N : N ;
  otuperbarhet_nn_1_N : N ;
  otur_nn_1_N : N ;
  oturlighet_nn_1_N : N ;
  oturnerbarhet_nn_1_N : N ;
  otursamhet_nn_1_N : N ;
  otursfoerfoeljdhet_nn_1_1_N : N ;
  otuscherbarhet_nn_1_N : N ;
  otvetydighet_nn_1_N : N ;
  otvivelaktighet_nn_1_N : N ;
  otvungenhet_nn_1_N : N ;
  otydbarhet_nn_1_N : N ;
  otypifierbarhet_nn_1_N : N ;
  otypiserbarhet_nn_1_N : N ;
  otyranniserbarhet_nn_1_N : N ;
  otaemjbarhet_nn_1_1_N : N ;
  otaenjbarhet_nn_1_1_N : N ;
  otaenkbarhet_nn_1_1_N : N ;
  otaalighet_nn_1_1_N : N ;
  otoerstighet_nn_1_1_N : N ;
  oumbaerlighet_nn_1_1_N : N ;
  ounderbalanserbarhet_nn_1_N : N ;
  ounderdimensionerbarhet_nn_1_N : N ;
  ounderexponerbarhet_nn_1_N : N ;
  ounderminerbarhet_nn_1_N : N ;
  oundertaxerbarhet_nn_1_N : N ;
  oundervaerderbarhet_nn_1_1_N : N ;
  oundgaenglighet_nn_1_1_N : N ;
  oundviklighet_nn_1_N : N ;
  ounifierbarhet_nn_1_N : N ;
  ouniformerbarhet_nn_1_N : N ;
  ouppdaterbarhet_nn_1_N : N ;
  ouppfattbarhet_nn_1_N : N ;
  ouppgraderbarhet_nn_1_N : N ;
  oupphinnelighet_nn_1_N : N ;
  oupphoerlighet_nn_1_1_N : N ;
  ouppjusterbarhet_nn_1_N : N ;
  oupplysthet_nn_1_N : N ;
  oupploeslighet_nn_1_1_N : N ;
  ouppmaerksamhet_nn_1_1_N : N ;
  ouppnaaelighet_nn_1_1_N : N ;
  ouppreklamerbarhet_nn_1_N : N ;
  ouppraeknelighet_nn_1_1_N : N ;
  ouppskattbarhet_nn_1_N : N ;
  ouppsummerbarhet_nn_1_N : N ;
  ouppsaegbarhet_nn_1_1_N : N ;
  ouppsaatlighet_nn_1_1_N : N ;
  oupptaxerbarhet_nn_1_N : N ;
  ouppvaerderbarhet_nn_1_1_N : N ;
  ourbaniserbarhet_nn_1_N : N ;
  oursaektlighet_nn_1_1_N : N ;
  ousurperbarhet_nn_1_N : N ;
  outackorderbarhet_nn_1_N : N ;
  outannonserbarhet_nn_1_N : N ;
  outarrenderbarhet_nn_1_N : N ;
  outbalanserbarhet_nn_1_N : N ;
  outbasunerbarhet_nn_1_N : N ;
  outbroderbarhet_nn_1_N : N ;
  outdebiterbarhet_nn_1_N : N ;
  outexaminerbarhet_nn_1_N : N ;
  outexperimenterbarhet_nn_1_N : N ;
  outfoerbarhet_nn_1_1_N : N ;
  outgrundlighet_nn_1_N : N ;
  outhaerdlighet_nn_1_1_N : N ;
  outklarerbarhet_nn_1_N : N ;
  outkommenderbarhet_nn_1_N : N ;
  outkonkurrerbarhet_nn_1_N : N ;
  outkristalliserbarhet_nn_1_N : N ;
  outkvitterbarhet_nn_1_N : N ;
  outlokaliserbarhet_nn_1_N : N ;
  outmanoevrerbarhet_nn_1_1_N : N ;
  outminuterbarhet_nn_1_N : N ;
  outplacerbarhet_nn_1_N : N ;
  outplaanlighet_nn_1_1_N : N ;
  outposterbarhet_nn_1_N : N ;
  output_nn_1_N : N ;
  outraderbarhet_nn_1_N : N ;
  outrangerbarhet_nn_1_N : N ;
  outrannsaklighet_nn_1_N : N ;
  outrotlighet_nn_1_N : N ;
  outsagdhet_nn_1_N : N ;
  outsinlighet_nn_1_N : N ;
  outslitlighet_nn_1_N : N ;
  outslaecklighet_nn_1_1_N : N ;
  outstofferbarhet_nn_1_N : N ;
  outsaegbarhet_nn_1_1_N : N ;
  outsaeglighet_nn_1_1_N : N ;
  outtalbarhet_nn_1_N : N ;
  outtaxerbarhet_nn_1_N : N ;
  outtroettlighet_nn_1_1_N : N ;
  outtoemlighet_nn_1_1_N : N ;
  outvaerderbarhet_nn_1_1_N : N ;
  ovaccinerbarhet_nn_1_N : N ;
  ovadderbarhet_nn_1_N : N ;
  ovaksinerbarhet_nn_1_N : N ;
  ovaluterbarhet_nn_1_N : N ;
  ovalverbarhet_nn_1_N : N ;
  ovandaliserbarhet_nn_1_N : N ;
  ovansklighet_nn_1_N : N ;
  ovarierbarhet_nn_1_N : N ;
  ovarsamhet_nn_1_N : N ;
  ovederhaeftighet_nn_1_1_N : N ;
  ovederlaegglighet_nn_1_1_N : N ;
  ovedersaeglighet_nn_1_1_N : N ;
  ovelouriserbarhet_nn_1_N : N ;
  oventilerbarhet_nn_1_N : N ;
  overbaliserbarhet_nn_1_N : N ;
  overhead_nn_1_N : N ;
  overifierbarhet_nn_1_N : N ;
  overklighet_nn_1_N : N ;
  oversifierbarhet_nn_1_N : N ;
  ovetbarhet_nn_1_N : N ;
  ovetenskaplighet_nn_1_N : N ;
  ovetskap_nn_1_N : N ;
  ovidimerbarhet_nn_1_N : N ;
  ovighet_nn_1_N : N ;
  oviktighet_nn_1_N : N ;
  ovillighet_nn_1_N : N ;
  ovillkorlighet_nn_1_N : N ;
  ovindicerbarhet_nn_1_N : N ;
  oviserbarhet_nn_1_N : N ;
  ovishet_nn_1_N : N ;
  ovisiterbarhet_nn_1_N : N ;
  ovisualiserbarhet_nn_1_N : N ;
  ovitaliserbarhet_nn_1_N : N ;
  ovitaminerbarhet_nn_1_N : N ;
  ovitaminiserbarhet_nn_1_N : N ;
  ovokaliserbarhet_nn_1_N : N ;
  ovulgariserbarhet_nn_1_N : N ;
  ovulkaniserbarhet_nn_1_N : N ;
  ovaeld_nn_1_1_N : N ;
  ovaeldighet_nn_1_1_N : N ;
  ovaerderbarhet_nn_1_1_N : N ;
  ovaerderlighet_nn_1_1_N : N ;
  ovaerdighet_nn_1_1_N : N ;
  ovaerldslighet_nn_1_1_N : N ;
  ovaalighet_nn_1_1_N : N ;
  oxdans_nn_1_N : N ;
  oxdrift_nn_1_N : N ;
  oxiderbarhet_nn_1_N : N ;
  ozokerit_nn_1_N : N ;
  oaetbarhet_nn_1_1_N : N ;
  oaetlighet_nn_1_1_N : N ;
  oaaterinstallerbarhet_nn_1_1_N : N ;
  oaaterkallelighet_nn_1_1_N : N ;
  ooemhet_nn_1_1_N : N ;
  ooeverbryggbarhet_nn_1_1_N : N ;
  ooeverbrygglighet_nn_1_1_N : N ;
  ooeverdimensionerbarhet_nn_1_1_N : N ;
  ooeverdoserbarhet_nn_1_1_N : N ;
  ooeverexponerbarhet_nn_1_1_N : N ;
  ooeverkomlighet_nn_1_1_N : N ;
  ooeverkompenserbarhet_nn_1_1_N : N ;
  ooeverlagdhet_nn_1_1_N : N ;
  ooeverskaadlighet_nn_1_1_N : N ;
  ooeverstiglighet_nn_1_1_N : N ;
  ooeversaettlighet_nn_1_1_N : N ;
  ooevertrasserbarhet_nn_1_1_N : N ;
  ooevertraefflighet_nn_1_1_N : N ;
  ooevertaenkthet_nn_1_1_N : N ;
  ooevervinnelighet_nn_1_1_N : N ;
  ooevervinnerlighet_nn_1_1_N : N ;
  ooevervinnlighet_nn_1_1_N : N ;
  ooevervaerderbarhet_nn_1_1_N : N ;
  pacificerbarhet_nn_1_N : N ;
  packis_nn_1_N : N ;
  paddling_nn_1_N : N ;
  paddslakt_nn_1_N : N ;
  paffhet_nn_1_N : N ;
  paginerbarhet_nn_1_N : N ;
  pajighet_nn_1_N : N ;
  paketerbarhet_nn_1_N : N ;
  palataliserbarhet_nn_1_N : N ;
  paljetterbarhet_nn_1_N : N ;
  palperbarhet_nn_1_N : N ;
  paltighet_nn_1_N : N ;
  pampas_nn_1_N : N ;
  pampighet_nn_1_N : N ;
  panerbarhet_nn_1_N : N ;
  pangasius_nn_1_N : N ;
  panik_nn_1_N : N ;
  panikmejl_nn_1_N : N ;
  panikaangest_nn_1_1_N : N ;
  pankhet_nn_1_N : N ;
  panorerbarhet_nn_1_N : N ;
  pansarfaerg_nn_1_1_N : N ;
  pansarsjael_nn_1_1_N : N ;
  pantograferbarhet_nn_1_N : N ;
  papegojsjuka_nn_1_N : N ;
  paperback_nn_1_N : N ;
  pappaledighet_nn_1_N : N ;
  pappersexercis_nn_1_N : N ;
  papperslump_nn_1_N : N ;
  pappersmyntfot_nn_1_N : N ;
  pappighet_nn_1_N : N ;
  pappsloejd_nn_1_1_N : N ;
  paraderbarhet_nn_1_N : N ;
  paraferbarhet_nn_1_N : N ;
  paraffinerbarhet_nn_1_N : N ;
  parafraserbarhet_nn_1_N : N ;
  parallax_nn_1_N : N ;
  parallelliserbarhet_nn_1_N : N ;
  paralyserbarhet_nn_1_N : N ;
  parasoemn_nn_1_1_N : N ;
  paratax_nn_1_N : N ;
  paratyfus_nn_1_N : N ;
  pardon_nn_1_N : N ;
  parerbarhet_nn_1_N : N ;
  parfymerbarhet_nn_1_N : N ;
  parian_nn_1_N : N ;
  parkerbarhet_nn_1_N : N ;
  parketterbarhet_nn_1_N : N ;
  parklek_nn_1_N : N ;
  parmesanost_nn_1_N : N ;
  parodierbarhet_nn_1_N : N ;
  parsing_nn_1_N : N ;
  parsning_nn_1_N : N ;
  partenogenes_nn_1_N : N ;
  partigaengarjournalistik_nn_1_1_N : N ;
  partiloeshet_nn_1_1_N : N ;
  partisplittring_nn_1_N : N ;
  partitillhoerighet_nn_1_1_N : N ;
  passerbarhet_nn_1_N : N ;
  passform_nn_1_N : N ;
  passgaang_nn_1_1_N : N ;
  passiverbarhet_nn_1_N : N ;
  passiviserbarhet_nn_1_N : N ;
  passlighet_nn_1_N : N ;
  pastis_nn_1_N : N ;
  pastischkaraktaer_nn_1_1_N : N ;
  pastoeriserbarhet_nn_1_1_N : N ;
  patellarreflex_nn_1_N : N ;
  patenterbarhet_nn_1_N : N ;
  patentfaerg_nn_1_1_N : N ;
  patetik_nn_1_N : N ;
  patientsekretess_nn_1_N : N ;
  patinerbarhet_nn_1_N : N ;
  patristik_nn_1_N : N ;
  patronatsraett_nn_1_1_N : N ;
  patrullerbarhet_nn_1_N : N ;
  pauperiserbarhet_nn_1_N : N ;
  pauserbarhet_nn_1_N : N ;
  pauskommaterbarhet_nn_1_N : N ;
  peakning_nn_1_N : N ;
  pedagogik_nn_1_N : N ;
  pediatrik_nn_1_N : N ;
  pedikur_nn_1_N : N ;
  pedikyr_nn_1_N : N ;
  pedofilskraeck_nn_1_1_N : N ;
  peeling_nn_1_N : N ;
  pegamoid_nn_1_N : N ;
  pekfingervals_nn_1_N : N ;
  pelleterbarhet_nn_1_N : N ;
  pelota_nn_1_N : N ;
  pemmikan_nn_1_N : N ;
  pendeltrafik_nn_1_N : N ;
  pendeltaagstrafik_nn_1_1_N : N ;
  penetrerbarhet_nn_1_N : N ;
  pengabrist_nn_1_N : N ;
  pengarullning_nn_1_N : N ;
  pengastinnhet_nn_1_N : N ;
  penisavund_nn_1_N : N ;
  penitens_nn_1_N : N ;
  penningbrist_nn_1_N : N ;
  penningpolitik_nn_1_N : N ;
  penningstinnhet_nn_1_N : N ;
  penningtvaett_nn_1_1_N : N ;
  penningoert_nn_1_1_N : N ;
  pensionerbarhet_nn_1_N : N ;
  pensionsraett_nn_1_1_N : N ;
  pentateuk_nn_1_N : N ;
  pentatonik_nn_1_N : N ;
  pepita_nn_1_N : N ;
  pepitarutighet_nn_1_N : N ;
  pepparmint_nn_1_N : N ;
  pepparmynt_nn_1_N : N ;
  pepparrot_nn_1_N : N ;
  pepparsprej_nn_1_N : N ;
  percipierbarhet_nn_1_N : N ;
  perfekthet_nn_1_N : N ;
  perforerbarhet_nn_1_N : N ;
  periferhet_nn_1_N : N ;
  periodiserbarhet_nn_1_N : N ;
  peristaltik_nn_1_N : N ;
  permafrost_nn_1_N : N ;
  permanens_nn_1_N : N ;
  permanent_nn_1_N : N ;
  permanenthet_nn_1_N : N ;
  permanentning_nn_1_N : N ;
  permanentondulerbarhet_nn_1_N : N ;
  permitterbarhet_nn_1_N : N ;
  permutationsraett_nn_1_1_N : N ;
  permuterbarhet_nn_1_N : N ;
  perplexhet_nn_1_N : N ;
  persedelvaard_nn_1_1_N : N ;
  persian_nn_1_N : N ;
  persiflerbarhet_nn_1_N : N ;
  personalbrist_nn_1_N : N ;
  personalpolitik_nn_1_N : N ;
  personalvaard_nn_1_1_N : N ;
  personifierbarhet_nn_1_N : N ;
  personlighet_nn_2_N : N ;
  personpolitik_nn_1_N : N ;
  persontrafik_nn_1_N : N ;
  perspektivloeshet_nn_1_1_N : N ;
  persvaderbarhet_nn_1_N : N ;
  pervershet_nn_1_N : N ;
  perverterbarhet_nn_1_N : N ;
  pestilensrot_nn_1_N : N ;
  pestskraap_nn_1_1_N : N ;
  petighet_nn_1_N : N ;
  petit_nn_1_N : N ;
  petrifierbarhet_nn_1_N : N ;
  petsaekerhet_nn_1_1_N : N ;
  petting_nn_1_N : N ;
  pianomusik_nn_1_N : N ;
  pietetsfullhet_nn_1_N : N ;
  pietetsloeshet_nn_1_1_N : N ;
  piff_nn_1_N : N ;
  piffighet_nn_1_N : N ;
  pigghet_nn_1_N : N ;
  pikantsaas_nn_1_1_N : N ;
  pikerbarhet_nn_1_N : N ;
  pillrighet_nn_1_N : N ;
  pilskhet_nn_1_N : N ;
  pilsnabbhet_nn_1_N : N ;
  piloert_nn_1_1_N : N ;
  pimpinetthet_nn_1_N : N ;
  pincerbarhet_nn_1_N : N ;
  ping_pong_nn_1_N : N ;
  pingis_nn_1_N : N ;
  pingpong_nn_1_N : N ;
  pingstvaenlighet_nn_1_1_N : N ;
  pinknoedighet_nn_1_1_N : N ;
  pinnighet_nn_1_N : N ;
  pinnved_nn_1_N : N ;
  pinroek_nn_1_1_N : N ;
  piphas_nn_1_N : N ;
  pipighet_nn_1_N : N ;
  piptobak_nn_1_N : N ;
  pirrighet_nn_1_N : N ;
  pissighet_nn_1_N : N ;
  pitprops_nn_1_N : N ;
  pjoskighet_nn_1_N : N ;
  pjunkighet_nn_1_N : N ;
  pjaakighet_nn_1_1_N : N ;
  placerbarhet_nn_1_N : N ;
  pladdrighet_nn_1_N : N ;
  plagierbarhet_nn_1_N : N ;
  planenlighet_nn_1_N : N ;
  planerbarhet_nn_1_N : N ;
  planhet_nn_1_N : N ;
  planloeshet_nn_1_1_N : N ;
  planmaessighet_nn_1_1_N : N ;
  planterbarhet_nn_1_N : N ;
  plastellin_nn_1_N : N ;
  plastik_nn_1_N : N ;
  platinablondhet_nn_1_N : N ;
  platinerbarhet_nn_1_N : N ;
  platsbrist_nn_1_N : N ;
  plattektonik_nn_1_N : N ;
  plattfot_nn_1_N : N ;
  platthet_nn_1_N : N ;
  playback_nn_1_N : N ;
  plebs_nn_1_N : N ;
  pliktfoergaetenhet_nn_1_1_N : N ;
  pliktkaensla_nn_1_1_N : N ;
  pliktskyldighet_nn_1_N : N ;
  plikttrogenhet_nn_1_N : N ;
  plikttrohet_nn_1_N : N ;
  plisserbarhet_nn_1_N : N ;
  plockighet_nn_1_N : N ;
  plockmat_nn_1_N : N ;
  plomberbarhet_nn_1_N : N ;
  plottrighet_nn_1_N : N ;
  plufsighet_nn_1_N : N ;
  pluralis_nn_1_N : N ;
  plussighet_nn_1_N : N ;
  pluttighet_nn_1_N : N ;
  plywood_nn_1_N : N ;
  plaegning_nn_1_1_N : N ;
  plaeterbarhet_nn_1_1_N : N ;
  plaatbearbetning_nn_1_1_N : N ;
  ploeroes_nn_1_1_N : N ;
  pneumatik_nn_1_N : N ;
  pocherbarhet_nn_1_N : N ;
  pocker_nn_1_N : N ;
  podsoljord_nn_1_N : N ;
  poetik_nn_1_N : N ;
  pointerbarhet_nn_1_N : N ;
  pojkaktighet_nn_1_N : N ;
  polardag_nn_1_N : N ;
  polariserbarhet_nn_1_N : N ;
  polarluft_nn_1_N : N ;
  polarnatt_nn_1_N : N ;
  polerbarhet_nn_1_N : N ;
  polhoejd_nn_1_1_N : N ;
  poliomyelit_nn_1_N : N ;
  polis_nn_1_N : N ;
  polish_nn_1_N : N ;
  polismakt_nn_1_N : N ;
  polistejp_nn_1_N : N ;
  politess_nn_1_N : N ;
  politik_nn_1_N : N ;
  politiserbarhet_nn_1_N : N ;
  pollenanalys_nn_1_N : N ;
  polletterbarhet_nn_1_N : N ;
  pollinerbarhet_nn_1_N : N ;
  polskhet_nn_1_N : N ;
  polyuretan_nn_1_N : N ;
  polyvinylklorid_nn_1_N : N ;
  pomaderbarhet_nn_1_N : N ;
  pomp_nn_1_N : N ;
  pomperipossaeffekt_nn_1_N : N ;
  pondus_nn_1_N : N ;
  pop_nn_1_N : N ;
  popkonst_nn_1_N : N ;
  popmusik_nn_1_N : N ;
  popp_nn_1_N : N ;
  poppighet_nn_1_N : N ;
  populariserbarhet_nn_1_N : N ;
  populas_nn_1_N : N ;
  populaerkulturalitet_nn_1_1_N : N ;
  populaermusik_nn_1_1_N : N ;
  populaerpress_nn_1_1_N : N ;
  populaervetenskap_nn_1_1_N : N ;
  populaervetenskaplighet_nn_1_1_N : N ;
  porr_nn_1_N : N ;
  porrighet_nn_1_N : N ;
  pors_nn_1_N : N ;
  portionerbarhet_nn_1_N : N ;
  portofrihet_nn_1_N : N ;
  portraetterbarhet_nn_1_1_N : N ;
  portraettlikhet_nn_1_1_N : N ;
  post_nn_1_N : N ;
  postdaterbarhet_nn_1_N : N ;
  posterbarhet_nn_1_N : N ;
  posterioritet_nn_1_N : N ;
  postgaang_nn_1_1_N : N ;
  postponerbarhet_nn_1_N : N ;
  postulerbarhet_nn_1_N : N ;
  potkes_nn_1_N : N ;
  potkaes_nn_1_1_N : N ;
  pottraening_nn_1_1_N : N ;
  pottskraeck_nn_1_1_N : N ;
  poaengloeshet_nn_1_1_N : N ;
  poaengterbarhet_nn_1_1_N : N ;
  pragmatik_nn_1_N : N ;
  prakt_nn_1_N : N ;
  praktiserbarhet_nn_1_N : N ;
  praktiskhet_nn_1_N : N ;
  pratsamhet_nn_1_N : N ;
  pratsjukhet_nn_1_N : N ;
  praxis_nn_1_N : N ;
  precedens_nn_1_N : N ;
  preciserbarhet_nn_1_N : N ;
  predestinerbarhet_nn_1_N : N ;
  predicerbarhet_nn_1_N : N ;
  predikatlogik_nn_1_N : N ;
  predisponerbarhet_nn_1_N : N ;
  preexistens_nn_1_N : N ;
  prefabricerbarhet_nn_1_N : N ;
  prefererbarhet_nn_1_N : N ;
  prefigerbarhet_nn_1_N : N ;
  pregnans_nn_1_N : N ;
  preludierbarhet_nn_1_N : N ;
  premierbarhet_nn_1_N : N ;
  premium_nn_2_N : N ;
  preparerbarhet_nn_1_N : N ;
  presenterbarhet_nn_1_N : N ;
  preserverbarhet_nn_1_N : N ;
  preskriberbarhet_nn_1_N : N ;
  press_nn_2_N : N ;
  pressdetalj_nn_1_N : N ;
  pressetik_nn_1_N : N ;
  pressfrihet_nn_1_N : N ;
  presspan_nn_1_N : N ;
  prestationsaangest_nn_1_1_N : N ;
  presterbarhet_nn_1_N : N ;
  prestigefylldhet_nn_1_N : N ;
  presumerbarhet_nn_1_N : N ;
  prevention_nn_1_N : N ;
  prickighet_nn_1_N : N ;
  pricksaekerhet_nn_1_1_N : N ;
  primtalsdifferentiering_nn_1_N : N ;
  primaervaard_nn_1_1_N : N ;
  principfasthet_nn_1_N : N ;
  principloeshet_nn_1_1_N : N ;
  prioriterbarhet_nn_1_N : N ;
  prisbillighet_nn_1_N : N ;
  priskontroll_nn_1_N : N ;
  prispress_nn_1_N : N ;
  prisreglerbarhet_nn_1_N : N ;
  prisvaerdhet_nn_1_1_N : N ;
  privatiserbarhet_nn_1_N : N ;
  privatraett_nn_1_1_N : N ;
  privilegierbarhet_nn_1_N : N ;
  proamerikanskhet_nn_1_N : N ;
  proberbarhet_nn_1_N : N ;
  problematik_nn_1_N : N ;
  problematiserbarhet_nn_1_N : N ;
  processraett_nn_1_1_N : N ;
  producerbarhet_nn_1_N : N ;
  produktframtagning_nn_1_N : N ;
  produktutveckling_nn_1_N : N ;
  profanerbarhet_nn_1_N : N ;
  professionaliserbarhet_nn_1_N : N ;
  professionalitet_nn_1_N : N ;
  professorlighet_nn_1_N : N ;
  proffsighet_nn_1_N : N ;
  profilerbarhet_nn_1_N : N ;
  profylax_nn_1_N : N ;
  prog_nn_1_N : N ;
  progg_nn_1_N : N ;
  prognostiserbarhet_nn_1_N : N ;
  programenlighet_nn_1_N : N ;
  programkod_nn_1_N : N ;
  programmerbarhet_nn_1_N : N ;
  programmusik_nn_1_N : N ;
  progress_nn_1_N : N ;
  proisraeliskhet_nn_1_N : N ;
  projekterbarhet_nn_1_N : N ;
  projicerbarhet_nn_1_N : N ;
  proklamerbarhet_nn_1_N : N ;
  prokurdiskhet_nn_1_N : N ;
  proletariserbarhet_nn_1_N : N ;
  prolongerbarhet_nn_1_N : N ;
  promenadtakt_nn_1_N : N ;
  promoverbarhet_nn_1_N : N ;
  proms_nn_1_N : N ;
  promulgerbarhet_nn_1_N : N ;
  prononcerbarhet_nn_1_N : N ;
  propalestinskhet_nn_1_N : N ;
  propanol_nn_1_N : N ;
  propedeutik_nn_1_N : N ;
  propenplast_nn_1_N : N ;
  proponerbarhet_nn_1_N : N ;
  proportionerbarhet_nn_1_N : N ;
  proportionerlighet_nn_1_N : N ;
  proppmaetthet_nn_1_1_N : N ;
  props_nn_1_N : N ;
  proskriberbarhet_nn_1_N : N ;
  prospekterbarhet_nn_1_N : N ;
  protegerbarhet_nn_1_N : N ;
  proteinrikhet_nn_1_N : N ;
  protetik_nn_1_N : N ;
  protokollerbarhet_nn_1_N : N ;
  proviant_nn_1_N : N ;
  provocerbarhet_nn_1_N : N ;
  prustrot_nn_1_N : N ;
  prutmaan_nn_1_1_N : N ;
  pruttighet_nn_1_N : N ;
  prydlighet_nn_1_N : N ;
  pryltokighet_nn_1_N : N ;
  praektighet_nn_1_1_N : N ;
  praesterlighet_nn_1_1_N : N ;
  psittakos_nn_1_N : N ;
  psoriasis_nn_1_N : N ;
  psykoanalyserbarhet_nn_1_N : N ;
  psykofysik_nn_1_N : N ;
  psykolingvistik_nn_1_N : N ;
  psykologhjaelp_nn_1_1_N : N ;
  psykologiserbarhet_nn_1_N : N ;
  psykoprofylax_nn_1_N : N ;
  psykoteknik_nn_1_N : N ;
  psykotropiskhet_nn_1_N : N ;
  publicerbarhet_nn_1_N : N ;
  publicistik_nn_1_N : N ;
  puckelryggighet_nn_1_N : N ;
  pucklighet_nn_1_N : N ;
  pudrett_nn_1_N : N ;
  pudrighet_nn_1_N : N ;
  puertoricanskhet_nn_1_N : N ;
  pugilistik_nn_1_N : N ;
  pulkaakning_nn_1_1_N : N ;
  pulverform_nn_1_N : N ;
  pulveriserbarhet_nn_1_N : N ;
  pulverlackerbarhet_nn_1_N : N ;
  pulvriserbarhet_nn_1_N : N ;
  pundighet_nn_1_N : N ;
  pungdjaevul_nn_1_1_N : N ;
  punk_nn_1_N : N ;
  punkterbarhet_nn_1_N : N ;
  punktgravyr_nn_1_N : N ;
  punktlighet_nn_1_N : N ;
  punktmusik_nn_1_N : N ;
  punktskrift_nn_1_N : N ;
  punsch_nn_1_N : N ;
  purgerbarhet_nn_1_N : N ;
  purhet_nn_1_N : N ;
  purkenhet_nn_1_N : N ;
  pussighet_nn_1_N : N ;
  puts_nn_1_N : N ;
  putthet_nn_1_N : N ;
  puttrighet_nn_1_N : N ;
  pyroteknik_nn_1_N : N ;
  pyrschjakt_nn_1_N : N ;
  pysslighet_nn_1_N : N ;
  pyton_nn_1_N : N ;
  pytt_nn_1_N : N ;
  paelsdesign_nn_1_1_N : N ;
  paerk_nn_1_1_N : N ;
  paeronsmak_nn_1_1_N : N ;
  paaannonserbarhet_nn_1_1_N : N ;
  paadrivning_nn_1_1_N : N ;
  paaflugenhet_nn_1_1_N : N ;
  paaklaeddhet_nn_1_1_N : N ;
  paaklaedning_nn_1_1_N : N ;
  paalitlighet_nn_1_1_N : N ;
  paapasslighet_nn_1_1_N : N ;
  paaskledighet_nn_1_1_N : N ;
  paasktrafik_nn_1_1_N : N ;
  paassjuka_nn_1_1_N : N ;
  paastridighet_nn_1_1_N : N ;
  paastrykning_nn_1_1_N : N ;
  paastaaelighet_nn_1_1_N : N ;
  paasyn_nn_1_1_N : N ;
  paatagbarhet_nn_1_1_N : N ;
  paataglighet_nn_1_1_N : N ;
  paataendhet_nn_1_1_N : N ;
  paavekyrka_nn_1_1_N : N ;
  paaverkbarhet_nn_1_1_N : N ;
  paavestol_nn_1_1_N : N ;
  paavisbarhet_nn_1_1_N : N ;
  paavislighet_nn_1_1_N : N ;
  paavlighet_nn_1_1_N : N ;
  paavaext_nn_1_1_N : N ;
  paaoekt_nn_1_1_N : N ;
  poelsighet_nn_1_1_N : N ;
  poesighet_nn_1_1_N : N ;
  rabatterbarhet_nn_1_N : N ;
  rabies_nn_1_N : N ;
  rabiesskraeck_nn_1_1_N : N ;
  racing_nn_1_N : N ;
  rackaraktighet_nn_1_N : N ;
  racklighet_nn_1_N : N ;
  radarkommunikation_nn_1_N : N ;
  raderbarhet_nn_1_N : N ;
  radiak_nn_1_N : N ;
  radierbarhet_nn_1_N : N ;
  radikaliserbarhet_nn_1_N : N ;
  radiodramatik_nn_1_N : N ;
  radiofysik_nn_1_N : N ;
  radiokommunikation_nn_1_N : N ;
  radiolag_nn_1_N : N ;
  radionavigerbarhet_nn_1_N : N ;
  radionaemnd_nn_1_1_N : N ;
  radiotrafik_nn_1_N : N ;
  raffighet_nn_1_N : N ;
  raffinerbarhet_nn_1_N : N ;
  rafflighet_nn_1_N : N ;
  ragg_nn_1_N : N ;
  raggighet_nn_1_N : N ;
  raglan_nn_1_N : N ;
  raketdrift_nn_1_N : N ;
  raketfart_nn_1_N : N ;
  rakhet_nn_1_N : N ;
  rakitis_nn_1_N : N ;
  raklinjighet_nn_1_N : N ;
  raljans_nn_1_N : N ;
  rallycross_nn_1_N : N ;
  ramadan_nn_1_N : N ;
  rammelbuljong_nn_1_N : N ;
  ramponerbarhet_nn_1_N : N ;
  rams_nn_1_N : N ;
  ramstarkhet_nn_1_N : N ;
  randighet_nn_1_N : N ;
  randomiserbarhet_nn_1_N : N ;
  rang_nn_1_N : N ;
  rangerbarhet_nn_1_N : N ;
  ranglighet_nn_1_N : N ;
  rankhet_nn_1_N : N ;
  rankighet_nn_1_N : N ;
  ransonerbarhet_nn_1_N : N ;
  rap_nn_2_N : N ;
  rapmusik_nn_1_N : N ;
  rapp_nn_3_N : N ;
  rappellerbarhet_nn_1_N : N ;
  rapphet_nn_1_N : N ;
  rapporterbarhet_nn_1_N : N ;
  rapporteringsplikt_nn_1_N : N ;
  raps_nn_1_N : N ;
  rarhet_nn_1_N : N ;
  rasdiskriminerbarhet_nn_1_N : N ;
  raserbarhet_nn_1_N : N ;
  rashets_nn_1_N : N ;
  raskhet_nn_1_N : N ;
  raspighet_nn_1_N : N ;
  rassegregation_nn_1_N : N ;
  rastafarisekt_nn_1_N : N ;
  rastloeshet_nn_1_1_N : N ;
  rasaatskillnad_nn_1_1_N : N ;
  ratificerbarhet_nn_1_N : N ;
  rationaliserbarhet_nn_1_N : N ;
  rationalitetsskepsis_nn_1_N : N ;
  rayonull_nn_1_N : N ;
  reaktionsdrift_nn_1_N : N ;
  reaktiverbarhet_nn_1_N : N ;
  reaktorfysik_nn_1_N : N ;
  real_nn_1_N : N ;
  realiserbarhet_nn_1_N : N ;
  realpolitik_nn_1_N : N ;
  reassurerbarhet_nn_1_N : N ;
  recenserbarhet_nn_1_N : N ;
  recipierbarhet_nn_1_N : N ;
  reciterbarhet_nn_1_N : N ;
  redbarhet_nn_1_N : N ;
  redigerbarhet_nn_1_N : N ;
  redighet_nn_1_N : N ;
  redloeshet_nn_1_1_N : N ;
  redobogenhet_nn_1_N : N ;
  redskapsgymnastik_nn_1_N : N ;
  reducerbarhet_nn_1_N : N ;
  redundans_nn_1_N : N ;
  reexport_nn_1_N : N ;
  referenslitteratur_nn_1_N : N ;
  refererbarhet_nn_1_N : N ;
  reflekterbarhet_nn_1_N : N ;
  reflexionsloeshet_nn_1_1_N : N ;
  reflexivitet_nn_1_N : N ;
  reflexmaessighet_nn_1_1_N : N ;
  reformerbarhet_nn_1_N : N ;
  reformpolitik_nn_1_N : N ;
  reformvaenlighet_nn_1_1_N : N ;
  refuserbarhet_nn_1_N : N ;
  regalerbarhet_nn_1_N : N ;
  regelloeshet_nn_1_1_N : N ;
  regelraetthet_nn_1_1_N : N ;
  regenererbarhet_nn_1_N : N ;
  regerbarhet_nn_1_N : N ;
  regeringsduglighet_nn_1_N : N ;
  regeringsstaellning_nn_1_1_N : N ;
  regeringsstaellning_nn_2_1_N : N ;
  regerlighet_nn_1_N : N ;
  regimkritiskhet_nn_1_N : N ;
  regionalpolitik_nn_1_N : N ;
  regionmusik_nn_1_N : N ;
  regionpolitik_nn_1_N : N ;
  regionspolitik_nn_1_N : N ;
  regisserbarhet_nn_1_N : N ;
  registrerbarhet_nn_1_N : N ;
  reglementerbarhet_nn_1_N : N ;
  reglementsenlighet_nn_1_N : N ;
  reglementsvidrighet_nn_1_N : N ;
  reglerbarhet_nn_1_N : N ;
  reglerteknik_nn_1_N : N ;
  regnighet_nn_1_N : N ;
  regntunghet_nn_1_N : N ;
  regntaethet_nn_1_1_N : N ;
  regular_nn_1_N : N ;
  regummerbarhet_nn_1_N : N ;
  rehabiliterbarhet_nn_1_N : N ;
  reinkarnerbarhet_nn_1_N : N ;
  rejv_nn_1_N : N ;
  rekapitulerbarhet_nn_1_N : N ;
  reklambransch_nn_1_N : N ;
  reklamerbarhet_nn_1_N : N ;
  rekognoscerbarhet_nn_1_N : N ;
  rekognoserbarhet_nn_1_N : N ;
  rekommenderbarhet_nn_1_N : N ;
  rekompenserbarhet_nn_1_N : N ;
  rekonstruerbarhet_nn_1_N : N ;
  rekonvalescens_nn_1_N : N ;
  rekorderlighet_nn_1_N : N ;
  rekordfart_nn_1_N : N ;
  rekordform_nn_1_N : N ;
  rekreationspolitik_nn_1_N : N ;
  rekryterbarhet_nn_1_N : N ;
  rektificerbarhet_nn_1_N : N ;
  rektifierbarhet_nn_1_N : N ;
  rekvirerbarhet_nn_1_N : N ;
  relaterbarhet_nn_1_N : N ;
  relegerbarhet_nn_1_N : N ;
  relevans_nn_1_N : N ;
  religionskunskap_nn_1_N : N ;
  religionstillhoerighet_nn_1_1_N : N ;
  religionsutoevning_nn_1_1_N : N ;
  remanens_nn_1_N : N ;
  remissbehandling_nn_1_N : N ;
  remitterbarhet_nn_1_N : N ;
  remplacerbarhet_nn_1_N : N ;
  renderbarhet_nn_1_N : N ;
  rendrift_nn_1_N : N ;
  renhaarighet_nn_1_1_N : N ;
  rening_nn_1_N : N ;
  renodling_nn_1_N : N ;
  renoverbarhet_nn_1_N : N ;
  renrasighet_nn_1_N : N ;
  rensbarhet_nn_1_N : N ;
  reorganiserbarhet_nn_1_N : N ;
  reparerbarhet_nn_1_N : N ;
  repartiserbarhet_nn_1_N : N ;
  repatrierbarhet_nn_1_N : N ;
  repellerbarhet_nn_1_N : N ;
  repeterbarhet_nn_1_N : N ;
  representerbarhet_nn_1_N : N ;
  repriserbarhet_nn_1_N : N ;
  reproducerbarhet_nn_1_N : N ;
  reproducering_nn_2_N : N ;
  reputerlighet_nn_1_N : N ;
  resejournalistik_nn_1_N : N ;
  reserverbarhet_nn_1_N : N ;
  resistans_nn_1_N : N ;
  resistens_nn_1_N : N ;
  resistenthet_nn_1_N : N ;
  reslighet_nn_1_N : N ;
  resoluthet_nn_1_N : N ;
  resolverbarhet_nn_1_N : N ;
  reson_nn_1_N : N ;
  resonans_nn_1_N : N ;
  resonlighet_nn_1_N : N ;
  resorberbarhet_nn_1_N : N ;
  respekt_nn_1_N : N ;
  respekterbarhet_nn_1_N : N ;
  respirerbarhet_nn_1_N : N ;
  respons_nn_1_N : N ;
  restaurangbransch_nn_1_N : N ;
  restauranghypotes_nn_1_N : N ;
  restaurerbarhet_nn_1_N : N ;
  restituerbarhet_nn_1_N : N ;
  restloeshet_nn_1_1_N : N ;
  restriktivitet_nn_1_N : N ;
  resultatloeshet_nn_1_1_N : N ;
  resumerbarhet_nn_1_N : N ;
  resursbrist_nn_1_N : N ;
  retablerbarhet_nn_1_N : N ;
  retarderbarhet_nn_1_N : N ;
  retentionsraett_nn_1_1_N : N ;
  retfullhet_nn_1_N : N ;
  rethosta_nn_1_N : N ;
  retlighet_nn_1_N : N ;
  retorik_nn_1_N : N ;
  returnerbarhet_nn_1_N : N ;
  retuscherbarhet_nn_1_N : N ;
  revalverbarhet_nn_1_N : N ;
  reveterbarhet_nn_1_N : N ;
  reviderbarhet_nn_1_N : N ;
  revolutionerbarhet_nn_1_N : N ;
  rhenskhet_nn_1_N : N ;
  rhythm_and_blues_nn_1_N : N ;
  ribb_nn_1_N : N ;
  ribos_nn_1_N : N ;
  rickighet_nn_1_N : N ;
  ridderlighet_nn_1_N : N ;
  ridsport_nn_1_N : N ;
  rikhaltighet_nn_1_N : N ;
  rikhet_nn_1_N : N ;
  riklighet_nn_1_N : N ;
  riksgaeld_nn_1_1_N : N ;
  rikspolitik_nn_1_N : N ;
  riksstat_nn_1_N : N ;
  riksviktighet_nn_1_N : N ;
  rimfrost_nn_1_N : N ;
  ringformighet_nn_1_N : N ;
  ringrostighet_nn_1_N : N ;
  ringside_nn_1_N : N ;
  risgrynsgroet_nn_1_1_N : N ;
  riskfrihet_nn_1_N : N ;
  riskfylldhet_nn_1_N : N ;
  riskvillighet_nn_1_N : N ;
  ritualiserbarhet_nn_1_N : N ;
  robotiserbarhet_nn_1_N : N ;
  robusthet_nn_1_N : N ;
  rock_n_roll_nn_1_N : N ;
  rock_nn_2_N : N ;
  rockerbarhet_nn_1_N : N ;
  rockmusik_nn_1_N : N ;
  roderloeshet_nn_1_1_N : N ;
  rofylldhet_nn_1_N : N ;
  roloeshet_nn_1_1_N : N ;
  romantik_nn_1_N : N ;
  romantiserbarhet_nn_1_N : N ;
  rondoer_nn_1_1_N : N ;
  roquefort_nn_1_N : N ;
  rosenaktighet_nn_1_N : N ;
  rosengaang_nn_1_1_N : N ;
  rosenkaal_nn_1_1_N : N ;
  rosslighet_nn_1_N : N ;
  rost_nn_1_N : N ;
  rostighet_nn_1_N : N ;
  rotfasthet_nn_1_N : N ;
  rotloeshet_nn_1_1_N : N ;
  rots_nn_1_N : N ;
  rottingflaetning_nn_1_1_N : N ;
  rovdrift_nn_1_N : N ;
  rovgirighet_nn_1_N : N ;
  rubbing_nn_1_N : N ;
  rubricerbarhet_nn_1_N : N ;
  rucklighet_nn_1_N : N ;
  ruffighet_nn_1_N : N ;
  rufsighet_nn_1_N : N ;
  ruggighet_nn_1_N : N ;
  ruinerbarhet_nn_1_N : N ;
  ruljangs_nn_1_N : N ;
  rullbarhet_nn_1_N : N ;
  rultighet_nn_1_N : N ;
  rumhet_nn_1_N : N ;
  rumsarrest_nn_1_N : N ;
  rumstid_nn_1_N : N ;
  rumtid_nn_1_N : N ;
  rundgaang_nn_1_1_N : N ;
  rundhyllthet_nn_1_N : N ;
  rundhaenthet_nn_1_1_N : N ;
  rundkullighet_nn_1_N : N ;
  rundlagdhet_nn_1_N : N ;
  rundlighet_nn_1_N : N ;
  rundnaetthet_nn_1_1_N : N ;
  ruschighet_nn_1_N : N ;
  rusighet_nn_1_N : N ;
  rusningstrafik_nn_1_N : N ;
  russificerbarhet_nn_1_N : N ;
  russifierbarhet_nn_1_N : N ;
  rusttjaenst_nn_1_1_N : N ;
  rutighet_nn_1_N : N ;
  ruttenhet_nn_1_N : N ;
  rybs_nn_1_N : N ;
  ryckighet_nn_1_N : N ;
  ryggmaerg_nn_1_1_N : N ;
  ryggradsloeshet_nn_1_1_N : N ;
  ryggsaecksturism_nn_1_1_N : N ;
  rykt_nn_1_N : N ;
  rykteskarusell_nn_1_N : N ;
  rymdfart_nn_1_N : N ;
  rymdkapploepning_nn_1_1_N : N ;
  rymdmedicin_nn_1_N : N ;
  rymdtrafik_nn_1_N : N ;
  rymdvikt_nn_1_N : N ;
  rymlighet_nn_1_N : N ;
  rymningssaekerhet_nn_1_1_N : N ;
  rynkfrihet_nn_1_N : N ;
  rynkighet_nn_1_N : N ;
  ryps_nn_1_N : N ;
  rysansvaerdhet_nn_1_1_N : N ;
  ryschighet_nn_1_N : N ;
  ryskhet_nn_1_N : N ;
  ryskspraakighet_nn_1_1_N : N ;
  ryskundervisning_nn_1_N : N ;
  ryskvaenlighet_nn_1_1_N : N ;
  rysskraeck_nn_1_1_N : N ;
  rytmik_nn_1_N : N ;
  rytmiserbarhet_nn_1_N : N ;
  raeddhet_nn_1_1_N : N ;
  raeddningsloeshet_nn_1_1_N : N ;
  raedsla_nn_1_1_N : N ;
  raekenskap_nn_1_1_N : N ;
  raentefot_nn_1_1_N : N ;
  raethet_nn_1_1_N : N ;
  raetlinjighet_nn_1_1_N : N ;
  raett_nn_1_1_N : N ;
  raetthet_nn_1_1_N : N ;
  raettmaetighet_nn_1_1_N : N ;
  raettrogenhet_nn_1_1_N : N ;
  raettraadighet_nn_1_1_N : N ;
  raettsenlighet_nn_1_1_N : N ;
  raettshaveristiskhet_nn_1_1_N : N ;
  raettshjaelp_nn_1_1_N : N ;
  raettsinnighet_nn_1_1_N : N ;
  raettskaffenhet_nn_1_1_N : N ;
  raettskaensla_nn_1_1_N : N ;
  raettslighet_nn_1_1_N : N ;
  raettsloeshet_nn_1_1_N : N ;
  raettsmedicin_nn_1_1_N : N ;
  raettspolitik_nn_1_1_N : N ;
  raettsstridighet_nn_1_1_N : N ;
  raettsvetenskap_nn_1_1_N : N ;
  raettsvidrighet_nn_1_1_N : N ;
  raetvinklighet_nn_1_1_N : N ;
  raaddighet_nn_1_1_N : N ;
  raadighet_nn_1_1_N : N ;
  raadjursjakt_nn_1_1_N : N ;
  raadlighet_nn_1_1_N : N ;
  raadloeshet_nn_1_1_N : N ;
  raadvillhet_nn_1_1_N : N ;
  raag_nn_1_1_N : N ;
  raagblondhet_nn_1_1_N : N ;
  raagmjoelsgroet_nn_1_1_N : N ;
  raagsikt_nn_1_1_N : N ;
  raakost_nn_1_1_N : N ;
  raamjoelk_nn_1_1_N : N ;
  raanutveckling_nn_1_1_N : N ;
  raavarufoersoerjning_nn_1_1_N : N ;
  roedaktighet_nn_1_1_N : N ;
  roedblindhet_nn_1_1_N : N ;
  roedblondhet_nn_1_1_N : N ;
  roedbrusighet_nn_1_1_N : N ;
  roedflammighet_nn_1_1_N : N ;
  roedfaerg_nn_1_1_N : N ;
  roedfoerskjutning_nn_1_1_N : N ;
  roedgroenblindhet_nn_1_1_N : N ;
  roedhaarighet_nn_1_1_N : N ;
  roedklint_nn_1_1_N : N ;
  roedkaal_nn_1_1_N : N ;
  roedlaetthet_nn_1_1_N : N ;
  roedloek_nn_1_1_N : N ;
  roedmosighet_nn_1_1_N : N ;
  roednaesthet_nn_1_1_N : N ;
  roedsot_nn_1_1_N : N ;
  roedsprit_nn_1_1_N : N ;
  roedspraengdhet_nn_1_1_N : N ;
  roedoegdhet_nn_1_1_N : N ;
  roekavvaenjning_nn_1_1_N : N ;
  roekhosta_nn_1_1_N : N ;
  roekighet_nn_1_1_N : N ;
  roeklukt_nn_1_1_N : N ;
  roeksvaghet_nn_1_1_N : N ;
  roekthet_nn_1_1_N : N ;
  roekutveckling_nn_1_1_N : N ;
  roentgenblick_nn_1_1_N : N ;
  roentgendiagnostik_nn_1_1_N : N ;
  roentgenfotograferbarhet_nn_1_1_N : N ;
  roer_mig_ej_nn_1_1_N : N ;
  roerdhet_nn_1_1_N : N ;
  roerelsesjuka_nn_1_1_N : N ;
  roermigej_nn_1_1_N : N ;
  roerpost_nn_1_1_N : N ;
  roestklang_nn_1_1_N : N ;
  roestraett_nn_1_1_N : N ;
  roestskolkning_nn_1_1_N : N ;
  sabelbenthet_nn_1_N : N ;
  saboterbarhet_nn_1_N : N ;
  sabrerbarhet_nn_1_N : N ;
  sackaros_nn_1_N : N ;
  sadelformighet_nn_1_N : N ;
  sadelstad_nn_1_N : N ;
  saffransfaerg_nn_1_1_N : N ;
  saftighet_nn_1_N : N ;
  saftloeshet_nn_1_1_N : N ;
  sagalitteratur_nn_1_N : N ;
  sagatid_nn_1_N : N ;
  sagolikhet_nn_1_N : N ;
  saint_nn_1_N : N ;
  sakfoerstaandighet_nn_1_1_N : N ;
  sakkunnighet_nn_1_N : N ;
  sakkunskap_nn_1_N : N ;
  sakloeshet_nn_1_1_N : N ;
  sakpolitik_nn_1_N : N ;
  sakrosankthet_nn_1_N : N ;
  sakraett_nn_1_1_N : N ;
  saktfaerdighet_nn_1_1_N : N ;
  saktmodighet_nn_1_N : N ;
  salat_nn_1_N : N ;
  salderbarhet_nn_1_N : N ;
  salep_nn_1_N : N ;
  salepsrot_nn_1_N : N ;
  salicylbomull_nn_1_N : N ;
  salighet_nn_2_N : N ;
  saliv_nn_1_N : N ;
  sallat_nn_1_N : N ;
  salmiak_nn_1_N : N ;
  salmiaksprit_nn_1_N : N ;
  salongsfaehighet_nn_1_1_N : N ;
  salongsmusik_nn_1_N : N ;
  saltbemaengdhet_nn_1_1_N : N ;
  saltfisk_nn_1_N : N ;
  saltglasyr_nn_1_N : N ;
  salthet_nn_1_N : N ;
  saltighet_nn_1_N : N ;
  saltstaenkthet_nn_1_1_N : N ;
  saluterbarhet_nn_1_N : N ;
  salveld_nn_1_N : N ;
  samarbetsvillighet_nn_1_N : N ;
  samdraekt_nn_1_1_N : N ;
  samexistens_nn_1_N : N ;
  samfaellighet_nn_2_1_N : N ;
  samfaerd_nn_1_1_N : N ;
  samhaellelighet_nn_1_1_N : N ;
  samhaellsfarlighet_nn_1_1_N : N ;
  samhaellsfientlighet_nn_1_1_N : N ;
  samhaellsfraanvaendhet_nn_1_1_N : N ;
  samhaellshjaelp_nn_1_1_N : N ;
  samhaellsjournalistik_nn_1_1_N : N ;
  samhaellskritik_nn_1_1_N : N ;
  samhaellskunskap_nn_1_1_N : N ;
  samhaellsnyttighet_nn_1_1_N : N ;
  samhaellspolitik_nn_1_1_N : N ;
  samhaellstillvaendhet_nn_1_1_N : N ;
  samhaellsvetenskaplighet_nn_1_1_N : N ;
  samhaellsvaard_nn_1_1_N : N ;
  samklang_nn_1_N : N ;
  samkaensla_nn_1_1_N : N ;
  samlagsdebut_nn_1_N : N ;
  samlarinstinkt_nn_1_N : N ;
  sammanhaallighet_nn_1_1_N : N ;
  sammansatthet_nn_1_N : N ;
  sammanstoertning_nn_1_1_N : N ;
  sammet_nn_1_N : N ;
  sammetsmjukhet_nn_1_N : N ;
  sammaeld_nn_1_1_N : N ;
  samraadsraett_nn_1_1_N : N ;
  samsikt_nn_1_N : N ;
  samspelthet_nn_1_N : N ;
  samstaemdhet_nn_1_1_N : N ;
  samstaemmighet_nn_1_1_N : N ;
  samsyn_nn_1_N : N ;
  samtalston_nn_1_N : N ;
  samtaxerbarhet_nn_1_N : N ;
  samtid_nn_1_N : N ;
  samtidskaensla_nn_1_1_N : N ;
  samtrafik_nn_1_N : N ;
  samum_nn_1_N : N ;
  samvetsfrid_nn_1_N : N ;
  samvetsgrannhet_nn_1_N : N ;
  samvetsnoed_nn_1_1_N : N ;
  samvetsoemhet_nn_1_1_N : N ;
  samaeganderaett_nn_1_1_N : N ;
  sand_nn_1_N : N ;
  sandflykt_nn_1_N : N ;
  sandighet_nn_1_N : N ;
  sandnarv_nn_1_N : N ;
  sandtrav_nn_1_N : N ;
  sanerbarhet_nn_1_N : N ;
  sanforiserbarhet_nn_1_N : N ;
  sanitetsteknik_nn_1_N : N ;
  sankhet_nn_1_N : N ;
  sanktifierbarhet_nn_1_N : N ;
  sanktionerbarhet_nn_1_N : N ;
  sanktionspolitik_nn_1_N : N ;
  sannfaerdighet_nn_1_1_N : N ;
  sannhet_nn_1_N : N ;
  sanningsenlighet_nn_1_N : N ;
  sanningshalt_nn_1_N : N ;
  sanningskaerlek_nn_1_1_N : N ;
  sanningsloeshet_nn_1_1_N : N ;
  sannskyldighet_nn_1_N : N ;
  sannspaaddhet_nn_1_1_N : N ;
  sans_nn_1_N : N ;
  sanskrit_nn_1_N : N ;
  sansloeshet_nn_1_1_N : N ;
  saponifierbarhet_nn_1_N : N ;
  sardonyx_nn_1_N : N ;
  sargassotaang_nn_1_1_N : N ;
  satanskult_nn_1_N : N ;
  satinerbarhet_nn_1_N : N ;
  satisfierbarhet_nn_1_N : N ;
  satthet_nn_1_N : N ;
  saturerbarhet_nn_1_N : N ;
  satyriasis_nn_1_N : N ;
  satyriskhet_nn_1_N : N ;
  sauerkraut_nn_1_N : N ;
  sauterbarhet_nn_1_N : N ;
  sauternes_nn_1_N : N ;
  sauverbarhet_nn_1_N : N ;
  sav_nn_1_N : N ;
  savoir_faire_nn_1_N : N ;
  savojkaal_nn_1_1_N : N ;
  saxformighet_nn_1_N : N ;
  scatsaang_nn_1_1_N : N ;
  scenkonst_nn_1_N : N ;
  scenskraeck_nn_1_1_N : N ;
  schablonerbarhet_nn_1_N : N ;
  schabloniserbarhet_nn_1_N : N ;
  schablonmaessighet_nn_1_1_N : N ;
  schablontaxerbarhet_nn_1_N : N ;
  schamponerbarhet_nn_1_N : N ;
  schatterbarhet_nn_1_N : N ;
  schau_nn_1_N : N ;
  schellack_nn_1_N : N ;
  schematiserbarhet_nn_1_N : N ;
  schizzighet_nn_1_N : N ;
  schlagermusik_nn_1_N : N ;
  schnellklops_nn_1_N : N ;
  schrammelmusik_nn_1_N : N ;
  schvaback_nn_1_N : N ;
  schvung_nn_1_N : N ;
  schvungfullhet_nn_1_N : N ;
  schvungighet_nn_1_N : N ;
  schwabach_nn_1_N : N ;
  schwung_nn_1_N : N ;
  schwungfullhet_nn_1_N : N ;
  schwungighet_nn_1_N : N ;
  schyssthet_nn_1_N : N ;
  schysthet_nn_1_N : N ;
  sciencefictionlitteratur_nn_1_N : N ;
  scouting_nn_1_N : N ;
  scrotum_nn_1_N : N ;
  sebarhet_nn_1_N : N ;
  sedesamhet_nn_1_N : N ;
  sedesloeshet_nn_1_1_N : N ;
  sedighet_nn_1_N : N ;
  sedimenterbarhet_nn_1_N : N ;
  sedum_nn_1_N : N ;
  sedvaneraett_nn_1_1_N : N ;
  sedvanlighet_nn_1_N : N ;
  sefir_nn_1_N : N ;
  segelbarhet_nn_1_N : N ;
  segelfart_nn_1_N : N ;
  segelflykt_nn_1_N : N ;
  segelsport_nn_1_N : N ;
  segerrikhet_nn_1_N : N ;
  segerrusighet_nn_1_N : N ;
  segersaellhet_nn_1_1_N : N ;
  segervisshet_nn_1_N : N ;
  segmenterbarhet_nn_1_N : N ;
  segregerbarhet_nn_1_N : N ;
  sejd_nn_1_N : N ;
  sejm_nn_1_N : N ;
  sekonderbarhet_nn_1_N : N ;
  sekretess_nn_1_N : N ;
  sekt_nn_2_N : N ;
  sekulariserbarhet_nn_1_N : N ;
  sekunderbarhet_nn_1_N : N ;
  sekundaerluft_nn_1_1_N : N ;
  sekvestrerbarhet_nn_1_N : N ;
  selekterbarhet_nn_1_N : N ;
  sellerikaal_nn_1_1_N : N ;
  semaforerbarhet_nn_1_N : N ;
  semantik_nn_1_N : N ;
  seminerbarhet_nn_1_N : N ;
  semiotik_nn_1_N : N ;
  senantik_nn_1_N : N ;
  senap_nn_1_N : N ;
  senapsgas_nn_1_N : N ;
  senfaerdighet_nn_1_1_N : N ;
  sengaangaraktighet_nn_1_1_N : N ;
  senhet_nn_1_N : N ;
  senighet_nn_1_N : N ;
  senior_nn_2_N : N ;
  senklapp_nn_1_N : N ;
  senrenaessans_nn_1_1_N : N ;
  sensationsjournalistik_nn_1_N : N ;
  sensationslystnad_nn_1_N : N ;
  sensibiliserbarhet_nn_1_N : N ;
  senterbarhet_nn_1_N : N ;
  separationsaangest_nn_1_1_N : N ;
  separerbarhet_nn_1_N : N ;
  sepsis_nn_1_N : N ;
  september_nn_1_N : N ;
  septuagesima_nn_1_N : N ;
  serumdiagnostik_nn_1_N : N ;
  serverbarhet_nn_1_N : N ;
  servicekaensla_nn_1_1_N : N ;
  sesam_nn_1_N : N ;
  sexagesima_nn_1_N : N ;
  sexdubbling_nn_1_N : N ;
  sexlust_nn_1_N : N ;
  sexmobbing_nn_1_N : N ;
  sexualiserbarhet_nn_1_N : N ;
  sexualkunskap_nn_1_N : N ;
  sexualradikalitet_nn_1_N : N ;
  sfragistik_nn_1_N : N ;
  shag_nn_1_N : N ;
  shamponerbarhet_nn_1_N : N ;
  shantung_nn_1_N : N ;
  shelf_nn_1_N : N ;
  shelfis_nn_1_N : N ;
  shetlandsull_nn_1_N : N ;
  shia_nn_1_N : N ;
  shipping_nn_1_N : N ;
  shirting_nn_1_N : N ;
  shopping_nn_1_N : N ;
  showbiz_nn_1_N : N ;
  sial_nn_1_N : N ;
  sicksack_nn_2_N : N ;
  siderit_nn_1_N : N ;
  sideros_nn_1_N : N ;
  sidnumrerbarhet_nn_1_N : N ;
  sidohaensyn_nn_1_1_N : N ;
  sifferblindhet_nn_1_N : N ;
  sigillerbarhet_nn_1_N : N ;
  signalerbarhet_nn_1_N : N ;
  signaltjaenst_nn_1_1_N : N ;
  signaloeverfoering_nn_1_1_N : N ;
  signerbarhet_nn_1_N : N ;
  sikt_nn_1_N : N ;
  siktbarhet_nn_1_N : N ;
  siktighet_nn_1_N : N ;
  silhuetterbarhet_nn_1_N : N ;
  silikos_nn_1_N : N ;
  silkesbomull_nn_1_N : N ;
  silkighet_nn_1_N : N ;
  silt_nn_1_N : N ;
  siluetterbarhet_nn_1_N : N ;
  silverblondhet_nn_1_N : N ;
  silverbromid_nn_1_N : N ;
  silverglans_nn_1_N : N ;
  silverklang_nn_1_N : N ;
  silverklorid_nn_1_N : N ;
  silverputs_nn_1_N : N ;
  silvertejp_nn_1_N : N ;
  silveroert_nn_1_1_N : N ;
  silvrighet_nn_1_N : N ;
  simhud_nn_1_N : N ;
  simkunnighet_nn_1_N : N ;
  simmighet_nn_1_N : N ;
  simplextrafik_nn_1_N : N ;
  simplifierbarhet_nn_1_N : N ;
  simulerbarhet_nn_1_N : N ;
  singularis_nn_1_N : N ;
  sinisterhet_nn_1_N : N ;
  sinnesfrid_nn_1_N : N ;
  sinnessjukhet_nn_1_N : N ;
  sinnessjukvaard_nn_1_1_N : N ;
  sinnessloehet_nn_1_1_N : N ;
  sinnessvaghet_nn_1_N : N ;
  sinnevaerld_nn_1_1_N : N ;
  sinnrikhet_nn_1_N : N ;
  sipphet_nn_1_N : N ;
  sir_nn_2_N : N ;
  sirap_nn_1_N : N ;
  sirapssoethet_nn_1_1_N : N ;
  siratlighet_nn_1_N : N ;
  sisal_nn_1_N : N ;
  sittriktighet_nn_1_N : N ;
  sittvaenlighet_nn_1_1_N : N ;
  situationskomik_nn_1_N : N ;
  sjabbighet_nn_1_N : N ;
  sjaslik_nn_1_N : N ;
  sjavighet_nn_1_N : N ;
  sjukgymnastik_nn_1_N : N ;
  sjukhussjuka_nn_1_N : N ;
  sjukhusvaard_nn_1_1_N : N ;
  sjukpeng_nn_1_N : N ;
  sjukvaard_nn_1_1_N : N ;
  sjukvaardspersonal_nn_1_1_N : N ;
  sjukvaardspolitik_nn_1_1_N : N ;
  sjysthet_nn_1_N : N ;
  sjaelanoed_nn_1_1_N : N ;
  sjaelavaard_nn_1_1_N : N ;
  sjaelfullhet_nn_1_1_N : N ;
  sjaelsfinhet_nn_1_1_N : N ;
  sjaelslighet_nn_1_1_N : N ;
  sjaelsnoed_nn_1_1_N : N ;
  sjaelssjukhet_nn_1_1_N : N ;
  sjaelvbevarelsedrift_nn_1_1_N : N ;
  sjaelvdisciplin_nn_1_1_N : N ;
  sjaelvfinansierbarhet_nn_1_1_N : N ;
  sjaelvfoerbraenning_nn_1_1_N : N ;
  sjaelvfoernedring_nn_1_1_N : N ;
  sjaelvfoersoerjning_nn_1_1_N : N ;
  sjaelvhjaelp_nn_1_1_N : N ;
  sjaelvhjaelpslitteratur_nn_1_1_N : N ;
  sjaelvhaerlighet_nn_1_1_N : N ;
  sjaelvkontroll_nn_1_1_N : N ;
  sjaelvkritik_nn_1_1_N : N ;
  sjaelvkaensla_nn_1_1_N : N ;
  sjaelvkaerlek_nn_1_1_N : N ;
  sjaelvlaerdhet_nn_1_1_N : N ;
  sjaelvraettfaerdighet_nn_1_1_N : N ;
  sjaelvraadighet_nn_1_1_N : N ;
  sjaelvskrivenhet_nn_1_1_N : N ;
  sjaelvstart_nn_1_1_N : N ;
  sjaelvsvaaldighet_nn_1_1_N : N ;
  sjaelvsaadd_nn_1_1_N : N ;
  sjaelvtillit_nn_1_1_N : N ;
  sjaelvtillraecklighet_nn_1_1_N : N ;
  sjaelvtaekt_nn_1_1_N : N ;
  sjaelvupplevdhet_nn_1_1_N : N ;
  sjaelvupptagenhet_nn_1_1_N : N ;
  sjaelvverksamhet_nn_1_1_N : N ;
  sjaapighet_nn_1_1_N : N ;
  sjoebris_nn_1_1_N : N ;
  sjoeduglighet_nn_1_1_N : N ;
  sjoefart_nn_1_1_N : N ;
  sjoefartspolitik_nn_1_1_N : N ;
  sjoegaang_nn_1_1_N : N ;
  sjoeluft_nn_1_1_N : N ;
  sjoemalm_nn_1_1_N : N ;
  sjoemansbiff_nn_1_1_N : N ;
  sjoenoed_nn_1_1_N : N ;
  sjoenoet_nn_1_1_N : N ;
  sjoeraett_nn_1_1_N : N ;
  sjoeroek_nn_1_1_N : N ;
  sjoesjuka_nn_1_1_N : N ;
  sjoesjukhet_nn_1_1_N : N ;
  sjoesaekerhet_nn_1_1_N : N ;
  sjoeutsikt_nn_1_1_N : N ;
  sjoevildhet_nn_1_1_N : N ;
  sjoevaeg_nn_1_1_N : N ;
  skabb_nn_1_N : N ;
  skabbighet_nn_1_N : N ;
  skadedjursbekaempning_nn_1_1_N : N ;
  skadereglerbarhet_nn_1_N : N ;
  skadesloeshet_nn_1_1_N : N ;
  skadestaandsskyldighet_nn_1_1_N : N ;
  skaktaalighet_nn_1_1_N : N ;
  skaldegaava_nn_1_1_N : N ;
  skalenlighet_nn_1_N : N ;
  skalkaktighet_nn_1_N : N ;
  skallighet_nn_1_N : N ;
  skalloeshet_nn_1_1_N : N ;
  skalperbarhet_nn_1_N : N ;
  skamsenhet_nn_1_N : N ;
  skandaliserbarhet_nn_1_N : N ;
  skanderbarhet_nn_1_N : N ;
  skaplighet_nn_1_N : N ;
  skarpblick_nn_1_N : N ;
  skarphet_nn_1_N : N ;
  skarpsinnighet_nn_1_N : N ;
  skarpsynthet_nn_1_N : N ;
  skarpsaas_nn_1_1_N : N ;
  skarpoegdhet_nn_1_1_N : N ;
  skatteflykt_nn_1_N : N ;
  skatteplanerbarhet_nn_1_N : N ;
  skatteplikt_nn_1_N : N ;
  skattepliktighet_nn_1_N : N ;
  skattepolitik_nn_1_N : N ;
  skattepopulism_nn_1_N : N ;
  skattskyldighet_nn_1_N : N ;
  skavllerpress_nn_1_N : N ;
  skedsovning_nn_1_N : N ;
  skeleton_nn_1_N : N ;
  skelettmuskulatur_nn_1_N : N ;
  skeloert_nn_1_1_N : N ;
  skenbarhet_nn_1_N : N ;
  skendoedhet_nn_1_1_N : N ;
  skenplockning_nn_1_N : N ;
  skeppsfart_nn_1_N : N ;
  skeppsproviant_nn_1_N : N ;
  skepsis_nn_1_N : N ;
  skiffrighet_nn_1_N : N ;
  skiljbarhet_nn_1_N : N ;
  skineffekt_nn_1_N : N ;
  skinntorrhet_nn_1_N : N ;
  skirhet_nn_1_N : N ;
  skisserbarhet_nn_1_N : N ;
  skitfoernaemhet_nn_1_1_N : N ;
  skitnoedighet_nn_1_1_N : N ;
  skitsnygghet_nn_1_N : N ;
  skittraakighet_nn_1_1_N : N ;
  skitviktighet_nn_1_N : N ;
  skjutbarhet_nn_1_N : N ;
  skogfattighet_nn_1_N : N ;
  skogighet_nn_1_N : N ;
  skogklaeddhet_nn_1_1_N : N ;
  skogloeshet_nn_1_1_N : N ;
  skogsdoed_nn_1_1_N : N ;
  skogsgenetik_nn_1_N : N ;
  skogsgraens_nn_1_1_N : N ;
  skogshushaallning_nn_1_1_N : N ;
  skogsrand_nn_1_N : N ;
  skogsterraeng_nn_1_1_N : N ;
  skogsvaard_nn_1_1_N : N ;
  skolastik_nn_1_N : N ;
  skolgaang_nn_1_1_N : N ;
  skolhaelsovaard_nn_1_1_N : N ;
  skolios_nn_1_N : N ;
  skoljazz_nn_1_N : N ;
  skolmat_nn_1_N : N ;
  skolmatematik_nn_1_N : N ;
  skolmaestaraktighet_nn_1_1_N : N ;
  skolpersonal_nn_1_N : N ;
  skolpolitik_nn_1_N : N ;
  skolsjukhet_nn_1_N : N ;
  skoltroetthet_nn_1_1_N : N ;
  skongaang_nn_1_1_N : N ;
  skonsamhet_nn_1_N : N ;
  skorbut_nn_1_N : N ;
  skorstensroek_nn_1_1_N : N ;
  skorv_nn_1_N : N ;
  skorvighet_nn_1_N : N ;
  skotskhet_nn_1_N : N ;
  skottfrihet_nn_1_N : N ;
  skottraeddhet_nn_1_1_N : N ;
  skottsaekerhet_nn_1_1_N : N ;
  skrabbighet_nn_1_N : N ;
  skrafferbarhet_nn_1_N : N ;
  skrajhet_nn_1_N : N ;
  skralhet_nn_1_N : N ;
  skraltighet_nn_1_N : N ;
  skramlighet_nn_1_N : N ;
  skranglighet_nn_1_N : N ;
  skrapnos_nn_1_N : N ;
  skrattlust_nn_1_N : N ;
  skriftlighet_nn_1_N : N ;
  skrikighet_nn_1_N : N ;
  skritt_nn_1_N : N ;
  skrivbordsjournalistik_nn_1_N : N ;
  skrivbordstjaenst_nn_1_1_N : N ;
  skrivkramp_nn_1_N : N ;
  skrivkunnighet_nn_1_N : N ;
  skrot_nn_2_N : N ;
  skrumpenhet_nn_1_N : N ;
  skruttighet_nn_1_N : N ;
  skruvis_nn_1_N : N ;
  skrynklighet_nn_1_N : N ;
  skrytsamhet_nn_1_N : N ;
  skraellhosta_nn_1_1_N : N ;
  skraellighet_nn_1_1_N : N ;
  skraepighet_nn_1_1_N : N ;
  skraepmat_nn_1_1_N : N ;
  skraepplockning_nn_1_1_N : N ;
  skraeppost_nn_1_1_N : N ;
  skraevlighet_nn_1_1_N : N ;
  skuggighet_nn_1_N : N ;
  skuggloeshet_nn_1_1_N : N ;
  skuldfrihet_nn_1_N : N ;
  skuldloeshet_nn_1_1_N : N ;
  skuldsatthet_nn_1_N : N ;
  skuldsaettning_nn_1_1_N : N ;
  skuldtyngdhet_nn_1_N : N ;
  skulpterbarhet_nn_1_N : N ;
  skulpturerbarhet_nn_1_N : N ;
  skumhet_nn_1_N : N ;
  skummighet_nn_1_N : N ;
  skummjoelk_nn_1_1_N : N ;
  skumpighet_nn_1_N : N ;
  skumplast_nn_1_N : N ;
  skumplasttejp_nn_1_N : N ;
  skumoegdhet_nn_1_1_N : N ;
  skvalleraktighet_nn_1_N : N ;
  skvallerkaal_nn_1_1_N : N ;
  skvallrighet_nn_1_N : N ;
  skvalmusik_nn_1_N : N ;
  skvalpighet_nn_1_N : N ;
  skvattram_nn_1_N : N ;
  skyddsimpregnerbarhet_nn_1_N : N ;
  skyddsloeshet_nn_1_1_N : N ;
  skyddstillsyn_nn_1_N : N ;
  skyddstjaenst_nn_1_1_N : N ;
  skygghet_nn_1_N : N ;
  skyighet_nn_1_N : N ;
  skymflighet_nn_1_N : N ;
  skyndsamhet_nn_1_N : N ;
  skytteltrafik_nn_1_N : N ;
  skaeckighet_nn_1_1_N : N ;
  skaeftighet_nn_1_1_N : N ;
  skaeggighet_nn_1_1_N : N ;
  skaegglav_nn_1_1_N : N ;
  skaeggloeshet_nn_1_1_N : N ;
  skaeggstubb_nn_1_1_N : N ;
  skaeggsvamp_nn_1_1_N : N ;
  skaekt_nn_1_1_N : N ;
  skaelighet_nn_1_1_N : N ;
  skaelmaktighet_nn_1_1_N : N ;
  skaelmskhet_nn_1_1_N : N ;
  skaelvesot_nn_1_1_N : N ;
  skaelvosot_nn_1_1_N : N ;
  skaemdhet_nn_1_1_N : N ;
  skaemmighet_nn_1_1_N : N ;
  skaenkelhjaelp_nn_1_1_N : N ;
  skaerhet_nn_1_1_N : N ;
  skaerkapacitet_nn_1_1_N : N ;
  skaerpning_nn_1_1_N : N ;
  skaerpthet_nn_1_1_N : N ;
  skaerseld_nn_1_1_N : N ;
  skaertorv_nn_1_1_N : N ;
  skaadespelarkonst_nn_1_1_N : N ;
  skaalformighet_nn_1_1_N : N ;
  skaalighet_nn_1_1_N : N ;
  skaalrost_nn_1_1_N : N ;
  skaanskhet_nn_1_1_N : N ;
  skaapmat_nn_1_1_N : N ;
  skoeldpadd_nn_1_1_N : N ;
  skoeldpaddsjakt_nn_1_1_N : N ;
  skoenhet_nn_2_1_N : N ;
  skoenhetssoemn_nn_1_1_N : N ;
  skoenhetsvaard_nn_1_1_N : N ;
  skoenjbarhet_nn_1_1_N : N ;
  skoenlitteratur_nn_1_1_N : N ;
  skoenlockighet_nn_1_1_N : N ;
  skoenskrift_nn_1_1_N : N ;
  skoenstaxerbarhet_nn_1_1_N : N ;
  skoentaxerbarhet_nn_1_1_N : N ;
  skoerbjugg_nn_1_1_N : N ;
  skoerbjuggsoert_nn_1_1_N : N ;
  skoerdeand_nn_1_1_N : N ;
  skoerhet_nn_1_1_N : N ;
  skoerl_nn_1_1_N : N ;
  skoetsamhet_nn_1_1_N : N ;
  slabbhet_nn_1_N : N ;
  slabbighet_nn_1_N : N ;
  slackhet_nn_1_N : N ;
  sladdighet_nn_1_N : N ;
  sladdrighet_nn_1_N : N ;
  slafsighet_nn_1_N : N ;
  slagfaerdighet_nn_1_1_N : N ;
  slaggighet_nn_1_N : N ;
  slagkraft_nn_1_N : N ;
  slagkraftighet_nn_1_N : N ;
  slagordsmaessighet_nn_1_1_N : N ;
  slagrodd_nn_1_N : N ;
  slagtaalighet_nn_1_1_N : N ;
  slagvolym_nn_1_N : N ;
  slakhet_nn_1_N : N ;
  slaktvikt_nn_1_N : N ;
  slalom_nn_1_N : N ;
  slamfaerg_nn_1_1_N : N ;
  slammighet_nn_1_N : N ;
  slampighet_nn_1_N : N ;
  slamsighet_nn_1_N : N ;
  slang_nn_2_N : N ;
  slangloeshet_nn_1_1_N : N ;
  slangning_nn_1_N : N ;
  slankhet_nn_1_N : N ;
  slankighet_nn_1_N : N ;
  slapphet_nn_1_N : N ;
  slapphaenthet_nn_1_1_N : N ;
  slappzappning_nn_1_N : N ;
  slapstick_nn_1_N : N ;
  slaskighet_nn_1_N : N ;
  slattrighet_nn_1_N : N ;
  slaviserbarhet_nn_1_N : N ;
  slaviskhet_nn_1_N : N ;
  slavistik_nn_1_N : N ;
  slemhet_nn_1_N : N ;
  slemloesning_nn_1_1_N : N ;
  slemmighet_nn_1_N : N ;
  slentrian_nn_1_N : N ;
  sliddrighet_nn_1_N : N ;
  slig_nn_1_N : N ;
  slingrighet_nn_1_N : N ;
  slinkighet_nn_1_N : N ;
  slipning_nn_1_N : N ;
  slirighet_nn_1_N : N ;
  sliskighet_nn_1_N : N ;
  slitsamhet_nn_1_N : N ;
  slitstarkhet_nn_1_N : N ;
  slittaalighet_nn_1_1_N : N ;
  slivovits_nn_1_N : N ;
  slivovitz_nn_1_N : N ;
  sliwowitz_nn_1_N : N ;
  slosill_nn_1_N : N ;
  slottslikhet_nn_1_N : N ;
  sluddrighet_nn_1_N : N ;
  slumpmaessighet_nn_1_1_N : N ;
  sluring_nn_1_N : N ;
  slurpning_nn_1_N : N ;
  sluskighet_nn_1_N : N ;
  slutenhet_nn_1_N : N ;
  slutenvaard_nn_1_1_N : N ;
  slutgiltighet_nn_1_N : N ;
  slutkoerdhet_nn_1_1_N : N ;
  slutlighet_nn_1_N : N ;
  sluttamp_nn_1_N : N ;
  slaengighet_nn_1_1_N : N ;
  slaepighet_nn_1_1_N : N ;
  slaepphaenthet_nn_1_1_N : N ;
  slaepsamhet_nn_1_1_N : N ;
  slaethet_nn_1_1_N : N ;
  slaethaarighet_nn_1_1_N : N ;
  sloedryck_nn_1_1_N : N ;
  sloehet_nn_2_1_N : N ;
  sloer_nn_1_1_N : N ;
  sloesaktighet_nn_1_1_N : N ;
  sloesinthet_nn_1_1_N : N ;
  sloesaed_nn_1_1_N : N ;
  smalhet_nn_1_N : N ;
  smalspaarighet_nn_1_1_N : N ;
  smalt_nn_1_N : N ;
  smalts_nn_1_N : N ;
  smarrighet_nn_1_N : N ;
  smekmaanadslyx_nn_1_1_N : N ;
  smeksamhet_nn_1_N : N ;
  smetighet_nn_1_N : N ;
  smidbarhet_nn_1_N : N ;
  smidighet_nn_1_N : N ;
  smilighet_nn_1_N : N ;
  smilskhet_nn_1_N : N ;
  sminkrot_nn_1_N : N ;
  smittfrihet_nn_1_N : N ;
  smittosamhet_nn_1_N : N ;
  smittsamhet_nn_1_N : N ;
  smittspridning_nn_1_N : N ;
  smittspaarning_nn_1_1_N : N ;
  smock_nn_1_N : N ;
  smockfullhet_nn_1_N : N ;
  smog_nn_1_N : N ;
  smolt_nn_1_N : N ;
  smuggelsprit_nn_1_N : N ;
  smulighet_nn_1_N : N ;
  smuts_nn_1_N : N ;
  smutsighet_nn_1_N : N ;
  smutskastning_nn_1_N : N ;
  smutslitteratur_nn_1_N : N ;
  smutstvaett_nn_1_1_N : N ;
  smygislamisering_nn_1_N : N ;
  smygroekning_nn_1_1_N : N ;
  smaeckerhet_nn_1_1_N : N ;
  smaeckfethet_nn_1_1_N : N ;
  smaeckfullhet_nn_1_1_N : N ;
  smaeckighet_nn_1_1_N : N ;
  smaellfethet_nn_1_1_N : N ;
  smaeltmetall_nn_1_1_N : N ;
  smaertaktivering_nn_1_1_N : N ;
  smaertfrihet_nn_1_1_N : N ;
  smaertgraens_nn_1_1_N : N ;
  smaerthet_nn_1_1_N : N ;
  smaerting_nn_1_1_N : N ;
  smaertsamhet_nn_1_1_N : N ;
  smaerttaalighet_nn_1_1_N : N ;
  smaaelakhet_nn_1_1_N : N ;
  smaagnabbighet_nn_1_1_N : N ;
  smaakornighet_nn_1_1_N : N ;
  smaasinthet_nn_1_1_N : N ;
  smaaskalighet_nn_1_1_N : N ;
  smaaviktighet_nn_1_1_N : N ;
  smaavaexthet_nn_1_1_N : N ;
  smoerdeg_nn_1_1_N : N ;
  smoergaasmat_nn_1_1_N : N ;
  smoerjighet_nn_1_1_N : N ;
  smoerkraem_nn_1_1_N : N ;
  smoersaang_nn_1_1_N : N ;
  snabbeld_nn_1_N : N ;
  snabbloeslighet_nn_1_1_N : N ;
  snabbmat_nn_1_N : N ;
  snabbskrift_nn_1_N : N ;
  snabbtaenkthet_nn_1_1_N : N ;
  snackesalighet_nn_1_N : N ;
  snacksalighet_nn_1_N : N ;
  snagg_nn_1_N : N ;
  snarfagerhet_nn_1_N : N ;
  snarfyndighet_nn_1_N : N ;
  snarfaerdighet_nn_1_1_N : N ;
  snarhet_nn_1_N : N ;
  snarlighet_nn_1_N : N ;
  snarlikhet_nn_1_N : N ;
  snarstuckenhet_nn_1_N : N ;
  snartaenkthet_nn_1_1_N : N ;
  snarvackerhet_nn_1_N : N ;
  snedparkerbarhet_nn_1_N : N ;
  snedrekryterbarhet_nn_1_N : N ;
  snedrygg_nn_1_N : N ;
  snedvinklighet_nn_1_N : N ;
  snedoegdhet_nn_1_1_N : N ;
  snibbighet_nn_1_N : N ;
  snigelfart_nn_1_N : N ;
  snigelpost_nn_1_N : N ;
  snikenhet_nn_1_N : N ;
  snip_nn_2_N : N ;
  snirklighet_nn_1_N : N ;
  snits_nn_1_N : N ;
  snitsighet_nn_1_N : N ;
  snobbighet_nn_1_N : N ;
  snofsighet_nn_1_N : N ;
  snopenhet_nn_1_N : N ;
  snorighet_nn_1_N : N ;
  snorkighet_nn_1_N : N ;
  snubblighet_nn_1_N : N ;
  snurr_nn_1_N : N ;
  snurrbarhet_nn_1_N : N ;
  snusfoernuftighet_nn_1_1_N : N ;
  snustorrhet_nn_1_N : N ;
  snut_nn_2_N : N ;
  snutfagerhet_nn_1_N : N ;
  snutmoral_nn_1_N : N ;
  snuttifiering_nn_1_N : N ;
  snygghet_nn_1_N : N ;
  snyltrot_nn_1_N : N ;
  snaerjighet_nn_1_1_N : N ;
  snaertighet_nn_1_1_N : N ;
  snaesighet_nn_1_1_N : N ;
  snaevhet_nn_1_1_N : N ;
  snaalblaast_nn_1_1_N : N ;
  snaalhet_nn_1_1_N : N ;
  snaalskjuts_nn_1_1_N : N ;
  snoebark_nn_1_1_N : N ;
  snoedhet_nn_1_1_N : N ;
  snoedrift_nn_1_1_N : N ;
  snoegraens_nn_1_1_N : N ;
  snoemodd_nn_1_1_N : N ;
  snoeplighet_nn_1_1_N : N ;
  snoerikhet_nn_1_1_N : N ;
  snoerpighet_nn_1_1_N : N ;
  snoerraethet_nn_1_1_N : N ;
  snoervlighet_nn_1_1_N : N ;
  snoeroejningskapacitet_nn_1_1_N : N ;
  snoeroejningspersonal_nn_1_1_N : N ;
  snoeskottning_nn_1_1_N : N ;
  snoesvaeng_nn_1_1_N : N ;
  socialhjaelp_nn_1_1_N : N ;
  socialiserbarhet_nn_1_N : N ;
  socialmedicin_nn_1_N : N ;
  socialpolitik_nn_1_N : N ;
  socialtjaenst_nn_1_1_N : N ;
  socialvaard_nn_1_1_N : N ;
  sociolingvistik_nn_1_N : N ;
  sockengaang_nn_1_1_N : N ;
  sockerhaltighet_nn_1_N : N ;
  sockerkakssmet_nn_1_N : N ;
  sockerkist_nn_1_N : N ;
  sockerkuloer_nn_1_1_N : N ;
  sockerlag_nn_1_N : N ;
  sockerrikhet_nn_1_N : N ;
  sockerrot_nn_1_N : N ;
  sockerroersproduktion_nn_1_1_N : N ;
  sockersjuka_nn_1_N : N ;
  sockersoethet_nn_1_1_N : N ;
  sockrighet_nn_1_N : N ;
  sodaoert_nn_1_1_N : N ;
  sofistik_nn_1_N : N ;
  softball_nn_1_N : N ;
  sojamjoelk_nn_1_1_N : N ;
  sol_nn_1_N : N ;
  solarplexus_nn_1_N : N ;
  solbraendhet_nn_1_1_N : N ;
  sold_nn_1_N : N ;
  soldatesk_nn_1_N : N ;
  solfattighet_nn_1_N : N ;
  solgaard_nn_1_1_N : N ;
  solhoejd_nn_1_1_N : N ;
  solighet_nn_1_N : N ;
  solkighet_nn_1_N : N ;
  solkust_nn_1_N : N ;
  solosaang_nn_1_1_N : N ;
  solring_nn_1_N : N ;
  solroek_nn_1_1_N : N ;
  soltid_nn_1_N : N ;
  solvens_nn_1_N : N ;
  solverbarhet_nn_1_N : N ;
  solvind_nn_1_N : N ;
  sommaraktighet_nn_1_N : N ;
  sommardraekt_nn_1_1_N : N ;
  sommarsjuka_nn_1_N : N ;
  sommarsvettighet_nn_1_N : N ;
  sommartid_nn_1_N : N ;
  somrighet_nn_1_N : N ;
  sonatform_nn_1_N : N ;
  sonderbarhet_nn_1_N : N ;
  sonlighet_nn_1_N : N ;
  soppatorsk_nn_1_N : N ;
  soppighet_nn_1_N : N ;
  sopranklav_nn_1_N : N ;
  sopsortering_nn_1_N : N ;
  sorbet_nn_1_N : N ;
  sordinerbarhet_nn_1_N : N ;
  sorgbundenhet_nn_1_N : N ;
  sorgelaat_nn_1_1_N : N ;
  sorgemusik_nn_1_N : N ;
  sorgesamhet_nn_1_N : N ;
  sorgetid_nn_1_N : N ;
  sorgfrihet_nn_1_N : N ;
  sorgfaellighet_nn_1_1_N : N ;
  sorglustighet_nn_1_N : N ;
  sorgmodighet_nn_1_N : N ;
  sorgmusik_nn_1_N : N ;
  sorgsenhet_nn_1_N : N ;
  sorgtyngdhet_nn_1_N : N ;
  sorterbarhet_nn_1_N : N ;
  sot_nn_2_N : N ;
  sotdoed_nn_1_1_N : N ;
  sotsaeng_nn_1_1_N : N ;
  soul_nn_1_N : N ;
  soulagerbarhet_nn_1_N : N ;
  soulmusik_nn_1_N : N ;
  soumak_nn_1_N : N ;
  sovjetiserbarhet_nn_1_N : N ;
  spagat_nn_1_N : N ;
  spakhet_nn_1_N : N ;
  spaljerbarhet_nn_1_N : N ;
  spallation_nn_1_N : N ;
  spallerbarhet_nn_1_N : N ;
  spannmaal_nn_1_1_N : N ;
  spannmaalsfoersoerjning_nn_1_1_N : N ;
  spannmaalssmuggling_nn_1_1_N : N ;
  spanskhet_nn_1_N : N ;
  spanskspraakighet_nn_1_1_N : N ;
  sparsamhet_nn_1_N : N ;
  spatt_nn_1_N : N ;
  spearing_nn_1_N : N ;
  specialiserbarhet_nn_1_N : N ;
  specialistvaard_nn_1_1_N : N ;
  specificerbarhet_nn_1_N : N ;
  speciminerbarhet_nn_1_N : N ;
  specnaz_nn_1_N : N ;
  speedway_nn_1_N : N ;
  spefylldhet_nn_1_N : N ;
  spegelblankhet_nn_1_N : N ;
  spegelskrift_nn_1_N : N ;
  spektralanalys_nn_1_N : N ;
  spekulerbarhet_nn_1_N : N ;
  spelbarhet_nn_1_N : N ;
  speldjaevul_nn_1_1_N : N ;
  spenat_nn_1_N : N ;
  spenderbarhet_nn_1_N : N ;
  spenslighet_nn_1_N : N ;
  spetsbaagestil_nn_1_1_N : N ;
  spetsbaagsstil_nn_1_1_N : N ;
  spetsforskning_nn_1_N : N ;
  spetsfot_nn_1_N : N ;
  spetsighet_nn_1_N : N ;
  spetsnaz_nn_1_N : N ;
  spetsvinklighet_nn_1_N : N ;
  spikrakhet_nn_1_N : N ;
  spiksaekerhet_nn_1_1_N : N ;
  spilltid_nn_1_N : N ;
  spindellikhet_nn_1_N : N ;
  spindeltunnhet_nn_1_N : N ;
  spindelvaevsaktighet_nn_1_1_N : N ;
  spindelvaevstunnhet_nn_1_1_N : N ;
  spinkighet_nn_1_N : N ;
  spioneriverksamhet_nn_1_N : N ;
  spionskraeck_nn_1_1_N : N ;
  spiritus_nn_1_N : N ;
  spis_nn_2_N : N ;
  splint_nn_1_N : N ;
  splitcane_nn_1_N : N ;
  spolformighet_nn_1_N : N ;
  spolierbarhet_nn_1_N : N ;
  spondylos_nn_1_N : N ;
  sportighet_nn_1_N : N ;
  sportlovstrafik_nn_1_N : N ;
  sportslighet_nn_1_N : N ;
  spotskhet_nn_1_N : N ;
  sprallighet_nn_1_N : N ;
  sprayhood_nn_1_N : N ;
  sprickfaerdighet_nn_1_1_N : N ;
  sprickighet_nn_1_N : N ;
  spriddhet_nn_1_N : N ;
  springflod_nn_1_N : N ;
  sprit_nn_1_N : N ;
  spritlukt_nn_1_N : N ;
  sprutlackerbarhet_nn_1_N : N ;
  sprutt_nn_1_N : N ;
  spraecklighet_nn_1_1_N : N ;
  spraengdeg_nn_1_1_N : N ;
  spraengfullhet_nn_1_1_N : N ;
  spraengfylldhet_nn_1_1_N : N ;
  spraengkraft_nn_1_1_N : N ;
  spraenglaerdhet_nn_1_1_N : N ;
  spraettighet_nn_1_1_N : N ;
  spraakkunnighet_nn_1_1_N : N ;
  spraakkaensla_nn_1_1_N : N ;
  spraaksamhet_nn_1_1_N : N ;
  spraakslaektskap_nn_1_1_N : N ;
  spraakvaard_nn_1_1_N : N ;
  sproedhet_nn_1_1_N : N ;
  spyfaerdighet_nn_1_1_N : N ;
  spaeddryck_nn_1_1_N : N ;
  spaedhet_nn_1_1_N : N ;
  spaendhet_nn_1_1_N : N ;
  spaennbetong_nn_1_1_N : N ;
  spaenning_nn_2_1_N : N ;
  spaenst_nn_1_1_N : N ;
  spaenstighet_nn_1_1_N : N ;
  spaerreld_nn_1_1_N : N ;
  spaetlese_nn_1_1_N : N ;
  spaarkapacitet_nn_1_1_N : N ;
  spaarloeshet_nn_1_1_N : N ;
  spaarmetall_nn_1_1_N : N ;
  spoekaktighet_nn_1_1_N : N ;
  spoeklikhet_nn_1_1_N : N ;
  squash_nn_1_N : N ;
  stabbighet_nn_1_N : N ;
  stabiliserbarhet_nn_1_N : N ;
  stadighet_nn_1_N : N ;
  stadsbyggnad_nn_1_N : N ;
  stadsgas_nn_1_N : N ;
  stadsplanerbarhet_nn_1_N : N ;
  stafferbarhet_nn_1_N : N ;
  stajling_nn_1_N : N ;
  stalking_nn_1_N : N ;
  stalkning_nn_1_N : N ;
  standardiserbarhet_nn_1_N : N ;
  standardislam_nn_1_N : N ;
  stanniol_nn_1_N : N ;
  star_nn_1_N : N ;
  starkhet_nn_1_N : N ;
  starksprit_nn_1_N : N ;
  starr_nn_1_N : N ;
  stass_nn_1_N : N ;
  statik_nn_1_N : N ;
  stationerbarhet_nn_1_N : N ;
  statlighet_nn_1_N : N ;
  statskunskap_nn_1_N : N ;
  statskyrka_nn_1_N : N ;
  statsloeshet_nn_1_1_N : N ;
  statsmakt_nn_1_N : N ;
  statsraett_nn_1_1_N : N ;
  statuerbarhet_nn_1_N : N ;
  stegloeshet_nn_1_1_N : N ;
  stelkramp_nn_1_N : N ;
  stencilerbarhet_nn_1_N : N ;
  stendoedhet_nn_1_1_N : N ;
  stendoevhet_nn_1_1_N : N ;
  stenhaardhet_nn_1_1_N : N ;
  stenkoll_nn_1_N : N ;
  stenkolsperiod_nn_1_N : N ;
  stenograferbarhet_nn_1_N : N ;
  stenstil_nn_1_N : N ;
  step_nn_1_N : N ;
  stepp_nn_1_N : N ;
  stereofotograferbarhet_nn_1_N : N ;
  stereotyperbarhet_nn_1_N : N ;
  steriliserbarhet_nn_1_N : N ;
  sterling_nn_1_N : N ;
  sternum_nn_1_N : N ;
  stickighet_nn_1_N : N ;
  stigloeshet_nn_1_1_N : N ;
  stigmatiserbarhet_nn_1_N : N ;
  stilenlighet_nn_1_N : N ;
  stilighet_nn_1_N : N ;
  stiliserbarhet_nn_1_N : N ;
  stilistik_nn_1_N : N ;
  stilkaensla_nn_1_1_N : N ;
  stillsamhet_nn_1_N : N ;
  stilrenhet_nn_1_N : N ;
  stimmighet_nn_1_N : N ;
  stimulerbarhet_nn_1_N : N ;
  stinnhet_nn_1_N : N ;
  stipendierbarhet_nn_1_N : N ;
  stipulerbarhet_nn_1_N : N ;
  stirrighet_nn_1_N : N ;
  stjaern_nn_1_1_N : N ;
  stjaernevaerld_nn_1_1_N : N ;
  stjaernformighet_nn_1_1_N : N ;
  stjaernlikhet_nn_1_1_N : N ;
  stjaernstatus_nn_1_1_N : N ;
  stjaerntid_nn_1_1_N : N ;
  stjaernoegdhet_nn_1_1_N : N ;
  stock_car_nn_1_N : N ;
  stockdumhet_nn_1_N : N ;
  stofferbarhet_nn_1_N : N ;
  stoiskhet_nn_1_N : N ;
  stomjoelk_nn_1_1_N : N ;
  stopplikt_nn_1_N : N ;
  stor_nn_1_N : N ;
  stordrift_nn_1_N : N ;
  storebror_nn_1_N : N ;
  storfinans_nn_1_N : N ;
  storkoeksmat_nn_1_1_N : N ;
  stormaktspolitik_nn_1_N : N ;
  stormeld_nn_1_N : N ;
  stormfrihet_nn_1_N : N ;
  stormighet_nn_1_N : N ;
  stormrikhet_nn_1_N : N ;
  stormsaekerhet_nn_1_1_N : N ;
  storordighet_nn_1_N : N ;
  storpublik_nn_1_N : N ;
  storrutighet_nn_1_N : N ;
  storsinthet_nn_1_N : N ;
  storskalighet_nn_1_N : N ;
  storslagenhet_nn_1_N : N ;
  storslalom_nn_1_N : N ;
  storstadsskymning_nn_1_N : N ;
  storstilthet_nn_1_N : N ;
  storvaexthet_nn_1_1_N : N ;
  storoegdhet_nn_1_1_N : N ;
  straffbarhet_nn_1_N : N ;
  straffloeshet_nn_1_1_N : N ;
  straffrabatt_nn_1_N : N ;
  straffraett_nn_1_1_N : N ;
  strakbenthet_nn_1_N : N ;
  strakhet_nn_1_N : N ;
  stramhet_nn_1_N : N ;
  strandraett_nn_1_1_N : N ;
  strandraag_nn_1_1_N : N ;
  strangulerbarhet_nn_1_N : N ;
  strass_nn_1_N : N ;
  stratifierbarhet_nn_1_N : N ;
  stratosfaer_nn_1_1_N : N ;
  stratus_nn_1_N : N ;
  stress_nn_1_N : N ;
  stressighet_nn_1_N : N ;
  stresstaalighet_nn_1_1_N : N ;
  stridbarhet_nn_1_N : N ;
  stridhet_nn_1_N : N ;
  stridsberedskap_nn_1_N : N ;
  stridsduglighet_nn_1_N : N ;
  stridsformerbarhet_nn_1_N : N ;
  stridsgrupperbarhet_nn_1_N : N ;
  stridskraft_nn_1_N : N ;
  stridslust_nn_1_N : N ;
  stridslystnad_nn_1_N : N ;
  strikthet_nn_1_N : N ;
  strimmighet_nn_1_N : N ;
  stringens_nn_1_N : N ;
  stringenthet_nn_1_N : N ;
  stripp_nn_1_N : N ;
  stronghet_nn_1_N : N ;
  stroppighet_nn_1_N : N ;
  strukturerbarhet_nn_1_N : N ;
  strukturrationaliserbarhet_nn_1_N : N ;
  struntfoernaemhet_nn_1_1_N : N ;
  struntviktighet_nn_1_N : N ;
  strutspolitik_nn_1_N : N ;
  struttighet_nn_1_N : N ;
  strykraeddhet_nn_1_1_N : N ;
  stryktaeckhet_nn_1_1_N : N ;
  stryktaalighet_nn_1_1_N : N ;
  strypsjuka_nn_1_N : N ;
  straenghet_nn_1_1_N : N ;
  straevhet_nn_1_1_N : N ;
  straevhaarighet_nn_1_1_N : N ;
  straevsamhet_nn_1_1_N : N ;
  straadoed_nn_1_1_N : N ;
  straakmusik_nn_1_1_N : N ;
  straalglans_nn_1_1_N : N ;
  straalkonserverbarhet_nn_1_1_N : N ;
  straalningssaekerhet_nn_1_1_N : N ;
  straalsjuka_nn_1_1_N : N ;
  straalsvamp_nn_1_1_N : N ;
  straasaed_nn_1_1_N : N ;
  straat_nn_1_1_N : N ;
  stroemkarl_nn_1_1_N : N ;
  stroemloeshet_nn_1_1_N : N ;
  stubbighet_nn_1_N : N ;
  stuckenhet_nn_1_N : N ;
  studenttillstroemning_nn_1_1_N : N ;
  studerbarhet_nn_1_N : N ;
  studiehjaelp_nn_1_1_N : N ;
  studieorienterbarhet_nn_1_N : N ;
  stundlighet_nn_1_N : N ;
  stuns_nn_1_N : N ;
  stupfullhet_nn_1_N : N ;
  stupor_nn_1_N : N ;
  sturskhet_nn_1_N : N ;
  stut_nn_2_N : N ;
  stygghet_nn_1_N : N ;
  styling_nn_1_N : N ;
  styrbarhet_nn_1_N : N ;
  styrenplast_nn_1_N : N ;
  styrfart_nn_1_N : N ;
  styrol_nn_1_N : N ;
  styvmoderlighet_nn_1_N : N ;
  styvsinthet_nn_1_N : N ;
  staemningsfullhet_nn_1_1_N : N ;
  staendighet_nn_1_1_N : N ;
  staerkelserikhet_nn_1_1_N : N ;
  staalhaardhet_nn_1_1_N : N ;
  staalull_nn_1_1_N : N ;
  staandaktighet_nn_1_1_N : N ;
  staandmaessighet_nn_1_1_N : N ;
  staandsmaessighet_nn_1_1_N : N ;
  staat_nn_1_1_N : N ;
  staatlighet_nn_1_1_N : N ;
  stoeddighet_nn_1_1_N : N ;
  stoeldsaekerhet_nn_1_1_N : N ;
  stoepis_nn_1_1_N : N ;
  stoerighet_nn_1_1_N : N ;
  stoetthet_nn_1_1_N : N ;
  stoettaalighet_nn_1_1_N : N ;
  subbighet_nn_1_N : N ;
  sublimerbarhet_nn_1_N : N ;
  sublimering_nn_2_N : N ;
  sublimhet_nn_1_N : N ;
  subordinerbarhet_nn_1_N : N ;
  subsidierbarhet_nn_1_N : N ;
  subsistens_nn_1_N : N ;
  subskriberbarhet_nn_1_N : N ;
  substantiverbarhet_nn_1_N : N ;
  substantivsjuka_nn_1_N : N ;
  substituerbarhet_nn_1_N : N ;
  subsumerbarhet_nn_1_N : N ;
  subtraherbarhet_nn_1_N : N ;
  subventionerbarhet_nn_1_N : N ;
  succederbarhet_nn_1_N : N ;
  suffigerbarhet_nn_1_N : N ;
  suffisans_nn_1_N : N ;
  sufflerbarhet_nn_1_N : N ;
  suggererbarhet_nn_1_N : N ;
  sughoejd_nn_1_1_N : N ;
  summerbarhet_nn_1_N : N ;
  sump_nn_1_N : N ;
  sumpgas_nn_1_N : N ;
  sumpighet_nn_1_N : N ;
  sundhet_nn_1_N : N ;
  sunna_nn_1_N : N ;
  sunni_nn_1_N : N ;
  superbhet_nn_1_N : N ;
  supermaktsstatus_nn_1_N : N ;
  supermarket_nn_1_N : N ;
  supersmaskighet_nn_1_N : N ;
  supersnabbhet_nn_1_N : N ;
  superspeed_nn_1_N : N ;
  superstarkhet_nn_1_N : N ;
  supertungvikt_nn_1_N : N ;
  superviktighet_nn_1_N : N ;
  supplerbarhet_nn_1_N : N ;
  supponerbarhet_nn_1_N : N ;
  support_nn_1_N : N ;
  surf_nn_1_N : N ;
  surfbarhet_nn_1_N : N ;
  surfing_nn_1_N : N ;
  surhet_nn_2_N : N ;
  surkaal_nn_1_1_N : N ;
  surmjoelk_nn_1_1_N : N ;
  surmulenhet_nn_1_N : N ;
  suroegdhet_nn_1_1_N : N ;
  suspekthet_nn_1_N : N ;
  suspenderbarhet_nn_1_N : N ;
  svackighet_nn_1_N : N ;
  svagsinthet_nn_1_N : N ;
  svagsynthet_nn_1_N : N ;
  svagtonighet_nn_1_N : N ;
  svajning_nn_1_N : N ;
  svalhet_nn_1_N : N ;
  svallis_nn_1_N : N ;
  svaloert_nn_1_1_N : N ;
  svampighet_nn_1_N : N ;
  svanesaang_nn_1_1_N : N ;
  svankighet_nn_1_N : N ;
  svarsloeshet_nn_1_1_N : N ;
  svartmalm_nn_1_N : N ;
  svartmuskighet_nn_1_N : N ;
  svartrost_nn_1_N : N ;
  svartrot_nn_1_N : N ;
  svartsjuka_nn_1_N : N ;
  svartsjukhet_nn_1_N : N ;
  svartsprit_nn_1_N : N ;
  svartsyn_nn_1_N : N ;
  svaveldioxid_nn_1_N : N ;
  svavelkis_nn_1_N : N ;
  svekfrihet_nn_1_N : N ;
  sveklighet_nn_1_N : N ;
  svekloeshet_nn_1_1_N : N ;
  svenskhetsvurm_nn_1_N : N ;
  svenskspraakighet_nn_1_1_N : N ;
  svensktoppsmusik_nn_1_N : N ;
  svenskull_nn_1_N : N ;
  svenskundervisning_nn_1_N : N ;
  svett_nn_1_N : N ;
  svetthet_nn_1_N : N ;
  svettighet_nn_1_N : N ;
  sviklighet_nn_1_N : N ;
  svimfaerdighet_nn_1_1_N : N ;
  svindyrhet_nn_1_N : N ;
  svinkallhet_nn_1_N : N ;
  svintur_nn_1_N : N ;
  svunnenhet_nn_1_N : N ;
  svaelt_nn_1_1_N : N ;
  svaeltfoeddhet_nn_1_1_N : N ;
  svaeltgraens_nn_1_1_N : N ;
  svaeltkost_nn_1_1_N : N ;
  svaengbarhet_nn_1_1_N : N ;
  svaengdhet_nn_1_1_N : N ;
  svaengighet_nn_1_1_N : N ;
  svaerdlikhet_nn_1_1_N : N ;
  svaerdlaengd_nn_1_1_N : N ;
  svaerdsloeshet_nn_1_1_N : N ;
  svaagerpolitik_nn_1_1_N : N ;
  svaangremspolitik_nn_1_1_N : N ;
  svaaravvislighet_nn_1_1_N : N ;
  svaarbedoemdhet_nn_1_1_N : N ;
  svaardefinierbarhet_nn_1_1_N : N ;
  svaarframkomlighet_nn_1_1_N : N ;
  svaarfoerenlighet_nn_1_1_N : N ;
  svaargenomtraenglighet_nn_1_1_N : N ;
  svaarhanterlighet_nn_1_1_N : N ;
  svaarhet_nn_1_1_N : N ;
  svaarintaglighet_nn_1_1_N : N ;
  svaarlaesthet_nn_1_1_N : N ;
  svaarloesthet_nn_1_1_N : N ;
  svaarmodighet_nn_1_1_N : N ;
  svaarpaavisbarhet_nn_1_1_N : N ;
  svaarsmaelthet_nn_1_1_N : N ;
  svaarsaaldhet_nn_1_1_N : N ;
  svaartillgaenglighet_nn_1_1_N : N ;
  svaaroeverblickbarhet_nn_1_1_N : N ;
  svaaroeverskaadlighet_nn_1_1_N : N ;
  sweepstake_nn_1_N : N ;
  swing_nn_1_N : N ;
  swingball_nn_1_N : N ;
  swingmusik_nn_1_N : N ;
  sydost_nn_1_N : N ;
  sydvaest_nn_1_1_N : N ;
  sydoest_nn_1_1_N : N ;
  syffisans_nn_1_N : N ;
  syfilis_nn_1_N : N ;
  sylfidiskhet_nn_1_N : N ;
  symbios_nn_1_N : N ;
  symbolik_nn_1_N : N ;
  symboliserbarhet_nn_1_N : N ;
  symptomfrihet_nn_1_N : N ;
  symtomfrihet_nn_1_N : N ;
  syn_nn_2_N : N ;
  synbarhet_nn_1_N : N ;
  synbarlighet_nn_1_N : N ;
  syndfullhet_nn_1_N : N ;
  syndighet_nn_1_N : N ;
  synkning_nn_1_N : N ;
  synkoperbarhet_nn_1_N : N ;
  synkroniserbarhet_nn_1_N : N ;
  synrand_nn_1_N : N ;
  synskhet_nn_1_N : N ;
  syntetiserbarhet_nn_1_N : N ;
  syperbhet_nn_1_N : N ;
  syrafasthet_nn_1_N : N ;
  syrebrist_nn_1_N : N ;
  syrefattighet_nn_1_N : N ;
  syrerikhet_nn_1_N : N ;
  syreupptagning_nn_1_N : N ;
  syrgas_nn_1_N : N ;
  syrlighet_nn_1_N : N ;
  sysselsaettningspolitik_nn_1_1_N : N ;
  syssloloeshet_nn_1_1_N : N ;
  systemanalys_nn_1_N : N ;
  systematik_nn_1_N : N ;
  systematiserbarhet_nn_1_N : N ;
  systemering_nn_1_N : N ;
  saeckighet_nn_1_1_N : N ;
  saeckvaev_nn_1_1_N : N ;
  saekerhetsbalans_nn_1_1_N : N ;
  saekerhetspersonal_nn_1_1_N : N ;
  saekerhetspolis_nn_1_1_N : N ;
  saekerhetspolitik_nn_1_1_N : N ;
  saeljakt_nn_1_1_N : N ;
  saeljbarhet_nn_1_1_N : N ;
  saellskaplighet_nn_1_1_N : N ;
  saellskapsgraat_nn_1_1_N : N ;
  saellskapssjukhet_nn_1_1_N : N ;
  saellspordhet_nn_1_1_N : N ;
  saenghalm_nn_1_1_N : N ;
  saerart_nn_1_1_N : N ;
  saerklassighet_nn_1_1_N : N ;
  saerskildhet_nn_1_1_N : N ;
  saev_nn_1_1_N : N ;
  saevlighet_nn_1_1_N : N ;
  saallningsprocedur_nn_1_1_N : N ;
  saang_nn_2_1_N : N ;
  saangbarhet_nn_1_1_N : N ;
  saanglighet_nn_1_1_N : N ;
  saangroest_nn_1_1_N : N ;
  saasighet_nn_1_1_N : N ;
  saaterbarhet_nn_1_1_N : N ;
  saaverbarhet_nn_1_1_N : N ;
  soekbarhet_nn_1_1_N : N ;
  soekthet_nn_1_1_N : N ;
  soelighet_nn_1_1_N : N ;
  soemn_nn_1_1_N : N ;
  soemnbrist_nn_1_1_N : N ;
  soemngaangaraktighet_nn_1_1_N : N ;
  soemnighet_nn_1_1_N : N ;
  soemnloeshet_nn_1_1_N : N ;
  soemnsjuka_nn_1_1_N : N ;
  soemntunghet_nn_1_1_N : N ;
  soenderbraendhet_nn_1_1_N : N ;
  soendrighet_nn_1_1_N : N ;
  soetaktighet_nn_1_1_N : N ;
  soethet_nn_1_1_N : N ;
  soetmjoelk_nn_1_1_N : N ;
  soetsliskighet_nn_1_1_N : N ;
  soetsurhet_nn_1_1_N : N ;
  tabellerbarhet_nn_1_N : N ;
  tablettform_nn_1_N : N ;
  tabubelaeggning_nn_1_1_N : N ;
  tabuerbarhet_nn_1_N : N ;
  tacknaemlighet_nn_1_1_N : N ;
  tacksamhetsskuld_nn_1_N : N ;
  tafatt_nn_1_N : N ;
  tafatthet_nn_1_N : N ;
  taffelmusik_nn_1_N : N ;
  tafsighet_nn_1_N : N ;
  taggfenighet_nn_1_N : N ;
  taggighet_nn_1_N : N ;
  tajning_nn_1_N : N ;
  tajthet_nn_1_N : N ;
  takfot_nn_1_N : N ;
  takloek_nn_1_1_N : N ;
  takt_nn_2_N : N ;
  taktfasthet_nn_1_N : N ;
  taktfullhet_nn_1_N : N ;
  taktkaensla_nn_1_1_N : N ;
  talangfullhet_nn_1_N : N ;
  talangloeshet_nn_1_1_N : N ;
  talarkonst_nn_1_N : N ;
  talekonst_nn_1_N : N ;
  taleraett_nn_1_1_N : N ;
  talfoerhet_nn_1_1_N : N ;
  talg_nn_1_N : N ;
  talgighet_nn_1_N : N ;
  talgoegdhet_nn_1_1_N : N ;
  talk_nn_1_N : N ;
  talkighet_nn_1_N : N ;
  tallbark_nn_1_N : N ;
  tallrikhet_nn_1_N : N ;
  tallriksis_nn_1_N : N ;
  tallstrunt_nn_1_N : N ;
  talloeshet_nn_1_1_N : N ;
  talmystik_nn_1_N : N ;
  talrikhet_nn_1_N : N ;
  talsymbolik_nn_1_N : N ;
  talsyntes_nn_1_N : N ;
  talteknik_nn_1_N : N ;
  taltraengdhet_nn_1_1_N : N ;
  talvaard_nn_1_1_N : N ;
  tamhet_nn_1_N : N ;
  tamponerbarhet_nn_1_N : N ;
  tampongsjuka_nn_1_N : N ;
  tandlikhet_nn_1_N : N ;
  tandloeshet_nn_1_1_N : N ;
  tandstatus_nn_1_N : N ;
  tandtraadning_nn_1_1_N : N ;
  tandvaenlighet_nn_1_1_N : N ;
  tandvaerk_nn_1_1_N : N ;
  tandvaard_nn_1_1_N : N ;
  tangens_nn_1_N : N ;
  tangerbarhet_nn_1_N : N ;
  tankedigerhet_nn_1_N : N ;
  tankeflykt_nn_1_N : N ;
  tankelyrik_nn_1_N : N ;
  tankemaessighet_nn_1_1_N : N ;
  tankeverksamhet_nn_1_N : N ;
  tankevaerld_nn_1_1_N : N ;
  tankfullhet_nn_1_N : N ;
  tankspriddhet_nn_1_N : N ;
  tantaktighet_nn_1_N : N ;
  tantalit_nn_1_N : N ;
  tantighet_nn_1_N : N ;
  tapetserbarhet_nn_1_N : N ;
  tarerbarhet_nn_1_N : N ;
  tarifferbarhet_nn_1_N : N ;
  tarok_nn_1_N : N ;
  tartar_nn_1_N : N ;
  tartarsaas_nn_1_1_N : N ;
  tatuerbarhet_nn_1_N : N ;
  tax_free_nn_1_N : N ;
  taxerbarhet_nn_1_N : N ;
  taxis_nn_1_N : N ;
  teak_nn_1_N : N ;
  teaterkritik_nn_1_N : N ;
  teaterpublik_nn_1_N : N ;
  teckentolkning_nn_1_N : N ;
  teckningsraett_nn_1_1_N : N ;
  tegelfaerg_nn_1_1_N : N ;
  teint_nn_1_N : N ;
  teknifierbarhet_nn_1_N : N ;
  tektonik_nn_1_N : N ;
  telefonerbarhet_nn_1_N : N ;
  telefonjour_nn_1_N : N ;
  telegraferbarhet_nn_1_N : N ;
  telegramstil_nn_1_N : N ;
  telematik_nn_1_N : N ;
  teletex_nn_1_N : N ;
  televiserbarhet_nn_1_N : N ;
  television_nn_1_N : N ;
  telex_nn_1_N : N ;
  tematik_nn_1_N : N ;
  temperamentsfullhet_nn_1_N : N ;
  temperaturbestaendighet_nn_1_1_N : N ;
  temperaturkaenslighet_nn_1_1_N : N ;
  temperaturutveckling_nn_1_N : N ;
  temperbarhet_nn_1_N : N ;
  tempererbarhet_nn_1_N : N ;
  temperering_nn_1_N : N ;
  tennis_nn_1_N : N ;
  tennisarm_nn_1_N : N ;
  tennpest_nn_1_N : N ;
  tenterbarhet_nn_1_N : N ;
  terasstvaett_nn_1_1_N : N ;
  termik_nn_1_N : N ;
  terminalvaard_nn_1_1_N : N ;
  termit_nn_2_N : N ;
  termodynamik_nn_1_N : N ;
  terrasserbarhet_nn_1_N : N ;
  territ_nn_1_N : N ;
  terrorbalans_nn_1_N : N ;
  terrorberedskap_nn_1_N : N ;
  terroriserbarhet_nn_1_N : N ;
  terroristspaarning_nn_1_1_N : N ;
  tertiaerperiod_nn_1_1_N : N ;
  tertiaertid_nn_1_1_N : N ;
  tesaurerbarhet_nn_1_N : N ;
  testamenterbarhet_nn_1_N : N ;
  testighet_nn_1_N : N ;
  tetanus_nn_1_N : N ;
  teutoniskhet_nn_1_N : N ;
  teve_nn_1_N : N ;
  tevereklam_nn_1_N : N ;
  textilkonst_nn_1_N : N ;
  textilsloejd_nn_1_1_N : N ;
  textkritik_nn_1_N : N ;
  textreklam_nn_1_N : N ;
  teaerenpris_nn_1_1_N : N ;
  thai_nn_1_N : N ;
  thaimat_nn_1_N : N ;
  thalamus_nn_1_N : N ;
  thorax_nn_1_N : N ;
  thymus_nn_1_N : N ;
  tibast_nn_1_N : N ;
  tidigarelaeggning_nn_1_1_N : N ;
  tidighet_nn_1_N : N ;
  tidjord_nn_1_N : N ;
  tidlighet_nn_1_N : N ;
  tidningsbransch_nn_1_N : N ;
  tidningsdoed_nn_1_1_N : N ;
  tidsenlighet_nn_1_N : N ;
  tidslighet_nn_1_N : N ;
  tidsnoed_nn_1_1_N : N ;
  tidspress_nn_1_N : N ;
  tidsriktning_nn_2_N : N ;
  tidsutdraekt_nn_1_1_N : N ;
  tidsaatgaang_nn_1_1_N : N ;
  tigerrandighet_nn_1_N : N ;
  tigerstrimmighet_nn_1_N : N ;
  tighthet_nn_1_N : N ;
  tillbakadragenhet_nn_1_N : N ;
  tillbakagaang_nn_1_1_N : N ;
  tillboerlighet_nn_1_1_N : N ;
  tillflykt_nn_1_N : N ;
  tillfriskning_nn_1_N : N ;
  tillfaelleslitteratur_nn_1_1_N : N ;
  tillfoersikt_nn_1_1_N : N ;
  tillgift_nn_1_N : N ;
  tillgaenglighet_nn_1_1_N : N ;
  tillhjaelp_nn_1_1_N : N ;
  tillit_nn_1_N : N ;
  tillitsfullhet_nn_1_N : N ;
  tillknaeppthet_nn_1_1_N : N ;
  tillkomst_nn_1_N : N ;
  tillraecklighet_nn_1_1_N : N ;
  tillraeknelighet_nn_1_1_N : N ;
  tillraadlighet_nn_1_1_N : N ;
  tillstaendighet_nn_1_1_N : N ;
  tillsyn_nn_1_N : N ;
  tilltagsenhet_nn_1_N : N ;
  tilltaenkthet_nn_1_1_N : N ;
  tilluft_nn_1_N : N ;
  tillvandhet_nn_1_N : N ;
  tillvaext_nn_1_1_N : N ;
  tillvaextkritik_nn_1_1_N : N ;
  tillaeggsstat_nn_1_1_N : N ;
  tillaemplighet_nn_1_1_N : N ;
  tillaatlighet_nn_1_1_N : N ;
  timjan_nn_1_N : N ;
  timotej_nn_1_N : N ;
  tingsraettspersonal_nn_1_1_N : N ;
  tipstjaenst_nn_1_1_N : N ;
  titelsjuka_nn_1_N : N ;
  titelsjukhet_nn_1_N : N ;
  titrerbarhet_nn_1_N : N ;
  tittut_nn_1_N : N ;
  titulerbarhet_nn_1_N : N ;
  tjafsighet_nn_1_N : N ;
  tjockhet_nn_1_N : N ;
  tjockmjoelk_nn_1_1_N : N ;
  tjugoett_nn_1_N : N ;
  tjugondag_nn_1_N : N ;
  tjurighet_nn_1_N : N ;
  tjurved_nn_1_N : N ;
  tjuskraft_nn_1_N : N ;
  tjuvaktighet_nn_1_N : N ;
  tjuvfiskning_nn_1_N : N ;
  tjuvjakt_nn_1_N : N ;
  tjuvroekning_nn_1_1_N : N ;
  tjuvtittning_nn_1_N : N ;
  tjuvtjockhet_nn_1_N : N ;
  tjyvaktighet_nn_1_N : N ;
  tjyvjakt_nn_1_N : N ;
  tjyvroekning_nn_1_1_N : N ;
  tjyvtittning_nn_1_N : N ;
  tjyvtjockhet_nn_1_N : N ;
  tjaenlighet_nn_1_1_N : N ;
  tjaenstaktighet_nn_1_1_N : N ;
  tjaenstbarhet_nn_1_1_N : N ;
  tjaensteplikt_nn_1_1_N : N ;
  tjaenstevikt_nn_1_1_N : N ;
  tjaenstfrihet_nn_1_1_N : N ;
  tjaenstvillighet_nn_1_1_N : N ;
  tjaerimpregnering_nn_1_1_N : N ;
  tjaerpapp_nn_1_1_N : N ;
  tjaerved_nn_1_1_N : N ;
  toast_nn_1_N : N ;
  tobak_nn_1_N : N ;
  tobleronepolitik_nn_1_N : N ;
  tofsighet_nn_1_N : N ;
  tolererbarhet_nn_1_N : N ;
  tolvfaldighet_nn_1_N : N ;
  tolvtonsmusik_nn_1_N : N ;
  tomatsaas_nn_1_1_N : N ;
  tombak_nn_1_N : N ;
  tomgaang_nn_1_1_N : N ;
  tomgaangskoerning_nn_1_1_N : N ;
  tomhetskaensla_nn_1_1_N : N ;
  tomhaenthet_nn_1_1_N : N ;
  tomtebolycka_nn_1_N : N ;
  tomtefar_nn_1_N : N ;
  tomtraett_nn_1_1_N : N ;
  tondoevhet_nn_1_1_N : N ;
  tonic_nn_1_N : N ;
  tonkonst_nn_1_N : N ;
  tonloeshet_nn_1_1_N : N ;
  tonsaekerhet_nn_1_1_N : N ;
  tonus_nn_1_N : N ;
  tonvikt_nn_1_N : N ;
  toppbrand_nn_1_N : N ;
  toppeld_nn_1_N : N ;
  toppfart_nn_1_N : N ;
  toppform_nn_1_N : N ;
  toppformighet_nn_1_N : N ;
  toppighet_nn_1_N : N ;
  toppklass_nn_1_N : N ;
  toppstyrdhet_nn_1_N : N ;
  topsning_nn_1_N : N ;
  torderbarhet_nn_1_N : N ;
  torgskraeck_nn_1_1_N : N ;
  torpederbarhet_nn_1_N : N ;
  torrdestillerbarhet_nn_1_N : N ;
  torrfisk_nn_1_N : N ;
  torrhet_nn_1_N : N ;
  torrhosta_nn_1_N : N ;
  torris_nn_1_N : N ;
  torrjaest_nn_1_1_N : N ;
  torrmjoelk_nn_1_1_N : N ;
  torrnaalsgravyr_nn_1_1_N : N ;
  torrschamponerbarhet_nn_1_N : N ;
  torrskoddhet_nn_1_N : N ;
  torrsprit_nn_1_N : N ;
  torrsubstans_nn_1_N : N ;
  torrved_nn_1_N : N ;
  torroegdhet_nn_1_1_N : N ;
  torsk_nn_2_N : N ;
  torterbarhet_nn_1_N : N ;
  torv_nn_1_N : N ;
  torvaktighet_nn_1_N : N ;
  torvmull_nn_1_N : N ;
  totalfinansierbarhet_nn_1_N : N ;
  totalfotboll_nn_1_N : N ;
  toucherbarhet_nn_1_N : N ;
  touchmetod_nn_1_N : N ;
  touperbarhet_nn_1_N : N ;
  tovighet_nn_1_N : N ;
  traderbarhet_nn_1_N : N ;
  traditionsenlighet_nn_1_N : N ;
  tradjazz_nn_1_N : N ;
  trafficking_nn_1_N : N ;
  trafik_nn_1_N : N ;
  trafikdoed_nn_1_1_N : N ;
  trafikerbarhet_nn_1_N : N ;
  trafikfarlighet_nn_1_N : N ;
  trafikpolitik_nn_1_N : N ;
  trafikreglerbarhet_nn_1_N : N ;
  tragglighet_nn_1_N : N ;
  tragik_nn_1_N : N ;
  trakasserbarhet_nn_1_N : N ;
  traktan_nn_1_N : N ;
  trakterbarhet_nn_1_N : N ;
  trampfart_nn_1_N : N ;
  tran_nn_1_N : N ;
  trancherbarhet_nn_1_N : N ;
  trandans_nn_1_N : N ;
  tranedans_nn_1_N : N ;
  trans_nn_1_N : N ;
  transcendens_nn_1_N : N ;
  transcendenthet_nn_1_N : N ;
  transfererbarhet_nn_1_N : N ;
  transformerbarhet_nn_1_N : N ;
  transiterbarhet_nn_1_N : N ;
  transitivitet_nn_1_N : N ;
  transkriberbarhet_nn_1_N : N ;
  translittererbarhet_nn_1_N : N ;
  transmitterbarhet_nn_1_N : N ;
  transmuterbarhet_nn_1_N : N ;
  transnationalitet_nn_1_N : N ;
  transparenthet_nn_1_N : N ;
  transplanterbarhet_nn_1_N : N ;
  transponerbarhet_nn_1_N : N ;
  transporterbarhet_nn_1_N : N ;
  transsylvanskhet_nn_1_N : N ;
  transumerbarhet_nn_1_N : N ;
  trapp_nn_2_N : N ;
  trappstaedning_nn_1_1_N : N ;
  traselegans_nn_1_N : N ;
  trasighet_nn_1_N : N ;
  trasserbarhet_nn_1_N : N ;
  trattformighet_nn_1_N : N ;
  trav_nn_2_N : N ;
  travesterbarhet_nn_1_N : N ;
  travsport_nn_1_N : N ;
  trebenthet_nn_1_N : N ;
  tredskhet_nn_1_N : N ;
  tredubbling_nn_1_N : N ;
  treenighetsmystik_nn_1_N : N ;
  trefaldighetssoendag_nn_1_1_N : N ;
  trefilighet_nn_1_N : N ;
  trefjaerdedelstakt_nn_1_1_N : N ;
  trefot_nn_1_N : N ;
  trendkaenslighet_nn_1_1_N : N ;
  trendriktighet_nn_1_N : N ;
  trepanerbarhet_nn_1_N : N ;
  trestavighet_nn_1_N : N ;
  tretakt_nn_1_N : N ;
  tretand_nn_1_N : N ;
  trettondag_nn_1_N : N ;
  trettondedag_nn_1_N : N ;
  trevinklighet_nn_1_N : N ;
  trial_and_error_nn_1_N : N ;
  trial_nn_1_N : N ;
  triangulerbarhet_nn_1_N : N ;
  trierbarhet_nn_1_N : N ;
  trift_nn_1_N : N ;
  trikinos_nn_1_N : N ;
  trilskhet_nn_1_N : N ;
  trindhet_nn_1_N : N ;
  trindsaed_nn_1_1_N : N ;
  triss_nn_1_N : N ;
  tristess_nn_1_N : N ;
  tristhet_nn_1_N : N ;
  trivialiserbarhet_nn_1_N : N ;
  trixighet_nn_2_N : N ;
  trolighet_nn_1_N : N ;
  trollkraft_nn_1_N : N ;
  trollkrets_nn_1_N : N ;
  trollkunnighet_nn_1_N : N ;
  trollmakt_nn_1_N : N ;
  trolskhet_nn_1_N : N ;
  trosfasthet_nn_1_N : N ;
  trosfrid_nn_1_N : N ;
  trosgloed_nn_1_1_N : N ;
  troskyldighet_nn_1_N : N ;
  trostolerans_nn_1_N : N ;
  trosvisshet_nn_1_N : N ;
  trotsighet_nn_1_N : N ;
  trottoarhyfs_nn_1_N : N ;
  trotyl_nn_1_N : N ;
  trovaerdhet_nn_1_1_N : N ;
  trovaerdighet_nn_1_1_N : N ;
  trubbighet_nn_1_N : N ;
  trubbnosighet_nn_1_N : N ;
  trubbnaesthet_nn_1_1_N : N ;
  trubbvinklighet_nn_1_N : N ;
  trulighet_nn_1_N : N ;
  trulsighet_nn_1_N : N ;
  trumeld_nn_1_N : N ;
  trumpenhet_nn_1_N : N ;
  trumsjuka_nn_1_N : N ;
  trupptjaenst_nn_1_1_N : N ;
  tryckbarhet_nn_1_N : N ;
  tryckimpregnerbarhet_nn_1_N : N ;
  tryckkaenslighet_nn_1_1_N : N ;
  tryckluft_nn_1_N : N ;
  tryckstarkhet_nn_1_N : N ;
  trycksvaghet_nn_1_N : N ;
  trycksvaerta_nn_1_1_N : N ;
  trycksaekerhet_nn_1_1_N : N ;
  tryckthet_nn_1_N : N ;
  tryfferbarhet_nn_1_N : N ;
  trygghet_nn_2_N : N ;
  traeaktighet_nn_1_1_N : N ;
  traeck_nn_1_1_N : N ;
  traedgaardskonst_nn_1_1_N : N ;
  traeflis_nn_1_1_N : N ;
  traegenhet_nn_1_1_N : N ;
  traeighet_nn_1_1_N : N ;
  traelighet_nn_1_1_N : N ;
  traeng_nn_1_1_N : N ;
  traengdhet_nn_1_1_N : N ;
  traeskallighet_nn_1_1_N : N ;
  traesloejd_nn_1_1_N : N ;
  traesmak_nn_1_1_N : N ;
  traesprit_nn_1_1_N : N ;
  traetgirighet_nn_1_1_N : N ;
  traeull_nn_1_1_N : N ;
  traadformighet_nn_1_1_N : N ;
  traadloeshet_nn_1_1_N : N ;
  traadmatning_nn_1_1_N : N ;
  traakfotboll_nn_1_1_N : N ;
  traangboddhet_nn_1_1_N : N ;
  traanghet_nn_1_1_N : N ;
  traangsinthet_nn_1_1_N : N ;
  traangsyn_nn_1_1_N : N ;
  traangsynthet_nn_1_1_N : N ;
  traansjukhet_nn_1_1_N : N ;
  troegbeddhet_nn_1_1_N : N ;
  troeghet_nn_1_1_N : N ;
  troeghetskraft_nn_1_1_N : N ;
  troeghetslag_nn_1_1_N : N ;
  troeghetsnavigerbarhet_nn_1_1_N : N ;
  troeglaesthet_nn_1_1_N : N ;
  troegroerlighet_nn_1_1_N : N ;
  troegtaenkthet_nn_1_1_N : N ;
  troest_nn_1_1_N : N ;
  troesterikhet_nn_1_1_N : N ;
  troestloeshet_nn_1_1_N : N ;
  troestrikhet_nn_1_1_N : N ;
  troetthet_nn_1_1_N : N ;
  troettkoerdhet_nn_1_1_N : N ;
  troettsamhet_nn_1_1_N : N ;
  tuberkulos_nn_1_N : N ;
  tuffhet_nn_1_N : N ;
  tufsighet_nn_1_N : N ;
  tuggtobak_nn_1_N : N ;
  tukt_nn_1_N : N ;
  tuktighet_nn_1_N : N ;
  tulipanaros_nn_1_N : N ;
  tullfrihet_nn_1_N : N ;
  tullpliktighet_nn_1_N : N ;
  tullpolitik_nn_1_N : N ;
  tummeliten_nn_1_N : N ;
  tumrullning_nn_1_N : N ;
  tungkoerdhet_nn_1_1_N : N ;
  tunglaesthet_nn_1_1_N : N ;
  tungroddhet_nn_1_N : N ;
  tungrot_nn_1_N : N ;
  tungsamhet_nn_1_N : N ;
  tungspat_nn_1_N : N ;
  tungsoevdhet_nn_1_1_N : N ;
  tungvikt_nn_1_N : N ;
  tunnhet_nn_1_N : N ;
  tunnhaarighet_nn_1_1_N : N ;
  tunnklaeddhet_nn_1_1_N : N ;
  tunnplaat_nn_1_1_N : N ;
  tunnsaaddhet_nn_1_1_N : N ;
  tuperbarhet_nn_1_N : N ;
  tur_nn_2_N : N ;
  turbulens_nn_1_N : N ;
  turf_nn_1_N : N ;
  turisttaethet_nn_1_1_N : N ;
  turlighet_nn_1_N : N ;
  turnerbarhet_nn_1_N : N ;
  tursamhet_nn_1_N : N ;
  tuscherbarhet_nn_1_N : N ;
  tuvstarr_nn_1_N : N ;
  tv_reklam_nn_1_N : N ;
  tvedraekt_nn_1_1_N : N ;
  tvehaagsenhet_nn_1_1_N : N ;
  tvekloeshet_nn_1_1_N : N ;
  tvillinglikhet_nn_1_N : N ;
  tvills_nn_1_N : N ;
  tvinsot_nn_1_N : N ;
  tvivelaktighet_nn_1_N : N ;
  tvivelsamhet_nn_1_N : N ;
  tvivelsjukhet_nn_1_N : N ;
  tvaerarghet_nn_1_1_N : N ;
  tvaerbranthet_nn_1_1_N : N ;
  tvaerfacklighet_nn_1_1_N : N ;
  tvaerhand_nn_1_1_N : N ;
  tvaerhet_nn_1_1_N : N ;
  tvaermaetthet_nn_1_1_N : N ;
  tvaerrandighet_nn_1_1_N : N ;
  tvaerspagat_nn_1_1_N : N ;
  tvaersaekerhet_nn_1_1_N : N ;
  tvaervetenskaplighet_nn_1_1_N : N ;
  tvaettbarhet_nn_1_1_N : N ;
  tvaafjaerdedelstakt_nn_1_1_N : N ;
  tvaaformighet_nn_1_1_N : N ;
  tvaahjulighet_nn_1_1_N : N ;
  tvaahaenthet_nn_1_1_N : N ;
  tvaalfagerhet_nn_1_1_N : N ;
  tvaalighet_nn_1_1_N : N ;
  tvaangfrihet_nn_1_1_N : N ;
  tvaangskommenderbarhet_nn_1_1_N : N ;
  tvaangsrekryterbarhet_nn_1_1_N : N ;
  tvaangstatuerbarhet_nn_1_1_N : N ;
  tvaangsvaard_nn_1_1_N : N ;
  tvaaspraakighet_nn_1_1_N : N ;
  tvaastavighet_nn_1_1_N : N ;
  tweed_nn_1_N : N ;
  twill_nn_1_N : N ;
  twist_nn_1_N : N ;
  tyckmyckenhet_nn_1_N : N ;
  tydbarhet_nn_1_N : N ;
  tydlighet_nn_1_N : N ;
  tyfus_nn_1_N : N ;
  tygelloeshet_nn_1_1_N : N ;
  tygtjaenst_nn_1_1_N : N ;
  tymus_nn_1_N : N ;
  tyngdkraft_nn_1_N : N ;
  tyngdlag_nn_1_N : N ;
  typifierbarhet_nn_1_N : N ;
  typiserbarhet_nn_1_N : N ;
  typiskhet_nn_1_N : N ;
  tyranniserbarhet_nn_1_N : N ;
  tyskhet_nn_1_N : N ;
  tyskspraakighet_nn_1_1_N : N ;
  tyskundervisning_nn_1_N : N ;
  tystlaatenhet_nn_1_1_N : N ;
  tystnadsed_nn_1_N : N ;
  tystnadsplikt_nn_1_N : N ;
  taeckelighet_nn_1_1_N : N ;
  taeckhet_nn_1_1_N : N ;
  taeltduk_nn_1_1_N : N ;
  taenjbarhet_nn_1_1_N : N ;
  taerdhet_nn_1_1_N : N ;
  taethet_nn_1_1_N : N ;
  taetmjoelk_nn_1_1_N : N ;
  taetortstrafik_nn_1_1_N : N ;
  taettbebyggdhet_nn_1_1_N : N ;
  taettklippthet_nn_1_1_N : N ;
  taetoert_nn_1_1_N : N ;
  taagtrafik_nn_1_1_N : N ;
  taalighet_nn_1_1_N : N ;
  taalmodighet_nn_1_1_N : N ;
  taang_nn_2_1_N : N ;
  taardraenkthet_nn_1_1_N : N ;
  taargas_nn_1_1_N : N ;
  taartspadeprincip_nn_1_1_N : N ;
  taaroegdhet_nn_1_1_N : N ;
  taaspetsdans_nn_1_1_N : N ;
  toecknighet_nn_1_1_N : N ;
  toelpaktighet_nn_1_1_N : N ;
  toelpighet_nn_1_1_N : N ;
  toelt_nn_1_1_N : N ;
  toernighet_nn_1_1_N : N ;
  toernrosasoemn_nn_1_1_N : N ;
  toerst_nn_1_1_N : N ;
  toerstighet_nn_1_1_N : N ;
  u_hjaelp_nn_1_1_N : N ;
  uddighet_nn_1_N : N ;
  uddloeshet_nn_1_1_N : N ;
  uggleved_nn_1_N : N ;
  ugnseldfasthet_nn_1_N : N ;
  ull_nn_1_N : N ;
  ullhaarighet_nn_1_1_N : N ;
  ullighet_nn_1_N : N ;
  ullsvett_nn_1_N : N ;
  ultrarapidfotograferbarhet_nn_1_N : N ;
  ultrasnabbhet_nn_1_N : N ;
  umgaengeskonst_nn_1_1_N : N ;
  umgaengesraett_nn_1_1_N : N ;
  umgaengeston_nn_1_1_N : N ;
  undandraekt_nn_1_1_N : N ;
  undangoemdhet_nn_1_1_N : N ;
  undanskymdhet_nn_1_N : N ;
  undantagsloeshet_nn_1_1_N : N ;
  underarmsmuskulatur_nn_1_N : N ;
  underbalans_nn_1_N : N ;
  underbalanserbarhet_nn_1_N : N ;
  underbarhet_nn_1_N : N ;
  underdimensionerbarhet_nn_1_N : N ;
  underexponerbarhet_nn_1_N : N ;
  underfullhet_nn_1_N : N ;
  underfoerstaaddhet_nn_1_1_N : N ;
  undergivenhet_nn_1_N : N ;
  undergroundmusik_nn_1_N : N ;
  undergaangsromantik_nn_1_1_N : N ;
  underhaltighet_nn_1_N : N ;
  underhud_nn_1_N : N ;
  underhaallningsbransch_nn_1_1_N : N ;
  underjaest_nn_1_1_N : N ;
  underklass_nn_1_N : N ;
  underklassighet_nn_1_N : N ;
  undermedvetenhet_nn_1_N : N ;
  underminerbarhet_nn_1_N : N ;
  undermaensklighet_nn_1_1_N : N ;
  undernaerdhet_nn_1_1_N : N ;
  underrapportering_nn_1_N : N ;
  underraettelsetjaenst_nn_1_1_N : N ;
  undersamhet_nn_1_N : N ;
  underskog_nn_1_N : N ;
  underskoenhet_nn_1_1_N : N ;
  understyrdhet_nn_1_N : N ;
  undersaetsighet_nn_1_1_N : N ;
  undersaatlighet_nn_1_1_N : N ;
  undersoekningsmetod_nn_2_1_N : N ;
  undersoekningsplikt_nn_1_1_N : N ;
  undertalighet_nn_1_N : N ;
  undertaxerbarhet_nn_1_N : N ;
  undervattensgaang_nn_1_1_N : N ;
  undervikt_nn_1_N : N ;
  underviktighet_nn_1_N : N ;
  undervisningsmetodik_nn_1_N : N ;
  undervaerderbarhet_nn_1_1_N : N ;
  underaarighet_nn_1_1_N : N ;
  undfallenhetspolitik_nn_1_N : N ;
  undransvaerdhet_nn_1_1_N : N ;
  ungdomlighet_nn_1_N : N ;
  ungdomspolis_nn_1_N : N ;
  ungdomspolitik_nn_1_N : N ;
  ungdomsvaard_nn_1_1_N : N ;
  ungefaerlighet_nn_1_1_N : N ;
  ungflicksaktighet_nn_1_N : N ;
  ungkyrklighet_nn_1_N : N ;
  ungrenaessans_nn_1_1_N : N ;
  unifierbarhet_nn_1_N : N ;
  uniformerbarhet_nn_1_N : N ;
  uniformhet_nn_1_N : N ;
  uniformsplikt_nn_1_N : N ;
  universaltid_nn_1_N : N ;
  unkenhet_nn_1_N : N ;
  uppblaasthet_nn_1_1_N : N ;
  uppbragthet_nn_1_N : N ;
  uppbyggelselitteratur_nn_1_N : N ;
  uppbygglighet_nn_1_N : N ;
  uppdaterbarhet_nn_1_N : N ;
  uppenbarhet_nn_1_N : N ;
  uppfattning_nn_2_N : N ;
  uppfinningsrikhet_nn_1_N : N ;
  uppfaellbarhet_nn_1_1_N : N ;
  uppgraderbarhet_nn_1_N : N ;
  upphinnelighet_nn_1_N : N ;
  upphovsmannaraett_nn_1_1_N : N ;
  upphovsraett_nn_1_1_N : N ;
  uppjusterbarhet_nn_1_N : N ;
  uppklaeddhet_nn_1_1_N : N ;
  uppknaeppthet_nn_1_1_N : N ;
  uppkomst_nn_1_N : N ;
  uppkoerdhet_nn_1_1_N : N ;
  upplagespiral_nn_1_N : N ;
  upplagsnaering_nn_1_1_N : N ;
  upplysningstid_nn_1_N : N ;
  upplysthet_nn_1_N : N ;
  uppmjukningspolitik_nn_1_N : N ;
  uppnosighet_nn_1_N : N ;
  uppnaesthet_nn_1_1_N : N ;
  uppnaaelighet_nn_1_1_N : N ;
  uppochnedvaendhet_nn_1_1_N : N ;
  uppochnervaendhet_nn_1_1_N : N ;
  uppreklamerbarhet_nn_1_N : N ;
  upprymdhet_nn_1_N : N ;
  upproerdhet_nn_1_1_N : N ;
  uppsikt_nn_1_N : N ;
  uppskraemdhet_nn_1_1_N : N ;
  uppslagsrikhet_nn_1_N : N ;
  uppsluppenhet_nn_1_N : N ;
  uppspelthet_nn_1_N : N ;
  uppstraeckthet_nn_1_1_N : N ;
  uppstudsighet_nn_1_N : N ;
  uppsummerbarhet_nn_1_N : N ;
  uppsvaelldhet_nn_1_1_N : N ;
  uppsaendning_nn_1_1_N : N ;
  uppsaatlighet_nn_1_1_N : N ;
  upptaxerbarhet_nn_1_N : N ;
  upptorkning_nn_1_N : N ;
  upptaendhet_nn_1_1_N : N ;
  uppvaerderbarhet_nn_1_1_N : N ;
  uppvaext_nn_1_1_N : N ;
  uppaanedvaendhet_nn_1_1_N : N ;
  uppaanervaendhet_nn_1_1_N : N ;
  ur_nn_3_N : N ;
  urbaniserbarhet_nn_1_N : N ;
  uretan_nn_1_N : N ;
  urfaanighet_nn_1_1_N : N ;
  urholkning_nn_2_N : N ;
  urin_nn_1_N : N ;
  urkundlighet_nn_1_N : N ;
  urmodighet_nn_1_N : N ;
  ursinnighet_nn_1_N : N ;
  urskiljbarhet_nn_1_N : N ;
  urskiljningsloeshet_nn_1_1_N : N ;
  urskillningsloeshet_nn_1_1_N : N ;
  ursnygghet_nn_1_N : N ;
  ursprunglighet_nn_1_N : N ;
  urstyvhet_nn_1_N : N ;
  ursaektlighet_nn_1_1_N : N ;
  urtagbarhet_nn_1_N : N ;
  urtid_nn_1_N : N ;
  urtjusighet_nn_1_N : N ;
  urvattning_nn_1_N : N ;
  uraaldrighet_nn_1_1_N : N ;
  usurperbarhet_nn_1_N : N ;
  utackorderbarhet_nn_1_N : N ;
  utandningsluft_nn_1_N : N ;
  utannonserbarhet_nn_1_N : N ;
  utarrenderbarhet_nn_1_N : N ;
  utbalanserbarhet_nn_1_N : N ;
  utbasunerbarhet_nn_1_N : N ;
  utbildningspolitik_nn_1_N : N ;
  utbreddhet_nn_1_N : N ;
  utbroderbarhet_nn_1_N : N ;
  utbraendhet_nn_1_1_N : N ;
  utbudspolitik_nn_1_N : N ;
  utbyggbarhet_nn_1_N : N ;
  utdebiterbarhet_nn_1_N : N ;
  utdragbarhet_nn_1_N : N ;
  utdoedhet_nn_1_1_N : N ;
  uteffekt_nn_1_N : N ;
  uteslutningsmetod_nn_1_N : N ;
  utexaminerbarhet_nn_1_N : N ;
  utexperimenterbarhet_nn_1_N : N ;
  utfattighet_nn_1_N : N ;
  utfiskning_nn_1_N : N ;
  utfrysthet_nn_1_N : N ;
  utfaellbarhet_nn_1_1_N : N ;
  utfoerbarhet_nn_1_1_N : N ;
  utfoerlighet_nn_1_1_N : N ;
  utgiftsdisciplin_nn_1_N : N ;
  utgrening_nn_1_N : N ;
  uthaerdlighet_nn_1_1_N : N ;
  utjord_nn_1_N : N ;
  utklarerbarhet_nn_1_N : N ;
  utkommenderbarhet_nn_1_N : N ;
  utkomst_nn_1_N : N ;
  utkonkurrerbarhet_nn_1_N : N ;
  utkristalliserbarhet_nn_1_N : N ;
  utkvitterbarhet_nn_1_N : N ;
  utkyldhet_nn_1_N : N ;
  utkoerdhet_nn_1_1_N : N ;
  utlandsfoersaeljning_nn_1_1_N : N ;
  utlandstjaenst_nn_1_1_N : N ;
  utledhet_nn_1_N : N ;
  utlokaliserbarhet_nn_1_N : N ;
  utmanoevrerbarhet_nn_1_1_N : N ;
  utminuterbarhet_nn_1_N : N ;
  utmaergling_nn_1_1_N : N ;
  utmaerkthet_nn_1_1_N : N ;
  utnoetthet_nn_1_1_N : N ;
  utomhusloepning_nn_1_1_N : N ;
  utomkroppslighet_nn_1_N : N ;
  utommaensklighet_nn_1_1_N : N ;
  utomordentlighet_nn_1_N : N ;
  utomaektenskaplighet_nn_1_1_N : N ;
  utplacerbarhet_nn_1_N : N ;
  utplattning_nn_1_N : N ;
  utposterbarhet_nn_1_N : N ;
  utraderbarhet_nn_1_N : N ;
  utrangerbarhet_nn_1_N : N ;
  utrikespolitik_nn_1_N : N ;
  utrikestrafik_nn_1_N : N ;
  utrymmesbrist_nn_1_N : N ;
  utsago_nn_1_N : N ;
  utsatthet_nn_1_N : N ;
  utsiktsloeshet_nn_1_1_N : N ;
  utskaemdhet_nn_1_1_N : N ;
  utskaergaard_nn_1_1_N : N ;
  utsot_nn_1_N : N ;
  utspriddhet_nn_1_N : N ;
  utspridning_nn_1_N : N ;
  utspaeddhet_nn_1_1_N : N ;
  utspaendhet_nn_1_1_N : N ;
  utstofferbarhet_nn_1_N : N ;
  utstoetthet_nn_1_1_N : N ;
  utsvaengdhet_nn_1_1_N : N ;
  utsoevdhet_nn_1_1_N : N ;
  uttagsbeskattning_nn_1_N : N ;
  uttalsenlighet_nn_1_N : N ;
  uttaxerbarhet_nn_1_N : N ;
  uttjaenthet_nn_1_1_N : N ;
  uttryckbarhet_nn_1_N : N ;
  uttrycklighet_nn_1_N : N ;
  uttrycksfullhet_nn_1_N : N ;
  uttrycksloeshet_nn_1_1_N : N ;
  uttaenjbarhet_nn_1_1_N : N ;
  uttaenkthet_nn_1_1_N : N ;
  utvaldhet_nn_1_N : N ;
  utvecklingsmaessighet_nn_1_1_N : N ;
  utvidgningspolitik_nn_1_N : N ;
  utvaendighet_nn_1_1_N : N ;
  utvaerderbarhet_nn_1_1_N : N ;
  utaatvaendhet_nn_1_1_N : N ;
  utoevning_nn_1_1_N : N ;
  vaccinbrist_nn_1_N : N ;
  vaccinerbarhet_nn_1_N : N ;
  vaccineringsturbulens_nn_1_N : N ;
  vackerhet_nn_1_N : N ;
  vadbarhet_nn_1_N : N ;
  vadderbarhet_nn_1_N : N ;
  vaghet_nn_1_N : N ;
  vakenhet_nn_1_N : N ;
  vaksamhet_nn_1_N : N ;
  vaksinerbarhet_nn_1_N : N ;
  valbarhet_nn_1_N : N ;
  valborg_nn_1_N : N ;
  valborgsmaess_nn_1_1_N : N ;
  valboskap_nn_1_N : N ;
  valfaangst_nn_1_1_N : N ;
  valfoervantskap_nn_1_1_N : N ;
  valkighet_nn_1_N : N ;
  valkning_nn_1_N : N ;
  valmatematik_nn_1_N : N ;
  valpaktighet_nn_1_N : N ;
  valpighet_nn_1_N : N ;
  valpsjuka_nn_1_N : N ;
  valrav_nn_1_N : N ;
  valraett_nn_1_1_N : N ;
  valtran_nn_1_N : N ;
  valutapolitik_nn_1_N : N ;
  valuterbarhet_nn_1_N : N ;
  valverbarhet_nn_1_N : N ;
  vampighet_nn_1_N : N ;
  vanadinbrytning_nn_1_N : N ;
  vanartighet_nn_1_N : N ;
  vandaliserbarhet_nn_1_N : N ;
  vandringslust_nn_1_N : N ;
  vanemaessighet_nn_1_1_N : N ;
  vanfrejd_nn_1_N : N ;
  vanhederlighet_nn_1_N : N ;
  vanhelgd_nn_1_N : N ;
  vanhet_nn_1_N : N ;
  vanhaevd_nn_1_1_N : N ;
  vanilj_nn_1_N : N ;
  vankelmodighet_nn_1_N : N ;
  vanmakt_nn_1_N : N ;
  vanmaektighet_nn_1_1_N : N ;
  vanskaplighet_nn_1_N : N ;
  vanstarkhet_nn_1_N : N ;
  vanstaellning_nn_1_1_N : N ;
  vantrogenhet_nn_1_N : N ;
  vanvaard_nn_1_1_N : N ;
  vanvoerdighet_nn_1_1_N : N ;
  vapenfoerhet_nn_1_1_N : N ;
  vapenloeshet_nn_1_1_N : N ;
  vapenmakt_nn_1_N : N ;
  vapentjaenst_nn_1_1_N : N ;
  vapentraening_nn_1_1_N : N ;
  vapenvaard_nn_1_1_N : N ;
  vardagslunk_nn_1_N : N ;
  vardagslyx_nn_1_N : N ;
  vardagsmat_nn_1_N : N ;
  vardagsrasism_nn_1_N : N ;
  vargflocksjakt_nn_1_N : N ;
  vargtaethet_nn_1_1_N : N ;
  vargurin_nn_1_N : N ;
  variansanalys_nn_1_N : N ;
  variationskalkyl_nn_1_N : N ;
  varierbarhet_nn_1_N : N ;
  varkunnsamhet_nn_1_N : N ;
  varlighet_nn_1_N : N ;
  varmblodighet_nn_1_N : N ;
  varmgaang_nn_1_1_N : N ;
  varmhet_nn_1_N : N ;
  varmluft_nn_1_N : N ;
  varsamhet_nn_1_N : N ;
  varudeklarationsnaemnd_nn_1_1_N : N ;
  varudeklarerbarhet_nn_1_N : N ;
  varukaennedom_nn_1_1_N : N ;
  varvighet_nn_1_N : N ;
  vaskmalm_nn_1_N : N ;
  vaskning_nn_1_N : N ;
  vassbuk_nn_1_N : N ;
  vasshet_nn_1_N : N ;
  vasslighet_nn_1_N : N ;
  vattenbyggnadskonst_nn_1_N : N ;
  vattenfasthet_nn_1_N : N ;
  vattenfoerbrukning_nn_1_1_N : N ;
  vattenfoersoerjning_nn_1_1_N : N ;
  vattenkastning_nn_1_N : N ;
  vattenkraft_nn_1_N : N ;
  vattenkaenslighet_nn_1_1_N : N ;
  vattenpest_nn_1_N : N ;
  vattenplaning_nn_1_N : N ;
  vattenraett_nn_1_1_N : N ;
  vattensjukhet_nn_1_N : N ;
  vattentaethet_nn_1_1_N : N ;
  vattentaalighet_nn_1_1_N : N ;
  vattgroet_nn_1_1_N : N ;
  vattnighet_nn_1_N : N ;
  vattning_nn_1_N : N ;
  vattrighet_nn_1_N : N ;
  vattsot_nn_1_N : N ;
  vattuskraeck_nn_1_1_N : N ;
  vattusot_nn_1_N : N ;
  vaxblekhet_nn_1_N : N ;
  veckighet_nn_1_N : N ;
  veckopress_nn_1_N : N ;
  veckoslutstrafik_nn_1_N : N ;
  veckovillhet_nn_1_N : N ;
  ved_nn_1_N : N ;
  vederhaeftighet_nn_1_1_N : N ;
  vederlaeggning_nn_1_1_N : N ;
  vegetering_nn_1_N : N ;
  vekhet_nn_1_N : N ;
  velour_nn_1_N : N ;
  velouriserbarhet_nn_1_N : N ;
  velaeng_nn_1_1_N : N ;
  vemodighet_nn_1_N : N ;
  ventilerbarhet_nn_1_N : N ;
  verbaliserbarhet_nn_1_N : N ;
  verifierbarhet_nn_1_N : N ;
  verkanseld_nn_1_N : N ;
  verkhelighet_nn_1_N : N ;
  verklighetsflykt_nn_1_N : N ;
  verkningseld_nn_1_N : N ;
  verkningsfullhet_nn_1_N : N ;
  verkningsloeshet_nn_1_1_N : N ;
  vermouth_nn_1_N : N ;
  vermut_nn_1_N : N ;
  versifierbarhet_nn_1_N : N ;
  verv_nn_1_N : N ;
  vetbarhet_nn_1_N : N ;
  vetenskaplighet_nn_1_N : N ;
  veteranpolitik_nn_1_N : N ;
  veterinaermedicin_nn_1_1_N : N ;
  vetgirighet_nn_1_N : N ;
  vetoraett_nn_1_1_N : N ;
  vetskap_nn_1_N : N ;
  vettskraemdhet_nn_1_1_N : N ;
  vickighet_nn_1_N : N ;
  vidbraendhet_nn_1_1_N : N ;
  videoert_nn_1_1_N : N ;
  vidhet_nn_1_N : N ;
  vidimerbarhet_nn_1_N : N ;
  vidstraeckthet_nn_1_1_N : N ;
  vidsyn_nn_1_N : N ;
  vighet_nn_1_N : N ;
  vigilans_nn_1_N : N ;
  vigoer_nn_1_1_N : N ;
  vikingatid_nn_1_N : N ;
  viktloeshet_nn_1_1_N : N ;
  viktnedgaang_nn_1_1_N : N ;
  viktualievikt_nn_1_N : N ;
  vikunjaull_nn_1_N : N ;
  vildhet_nn_1_N : N ;
  vildhonung_nn_1_N : N ;
  vildsinthet_nn_1_N : N ;
  vildsvinsjakt_nn_1_N : N ;
  viljekraft_nn_1_N : N ;
  viljeloeshet_nn_1_1_N : N ;
  viljemaessighet_nn_1_1_N : N ;
  viljestarkhet_nn_1_N : N ;
  viljesvaghet_nn_1_N : N ;
  villighet_nn_1_N : N ;
  villkorlighet_nn_1_N : N ;
  villkorsloeshet_nn_1_1_N : N ;
  villraadighet_nn_1_1_N : N ;
  villsamhet_nn_1_N : N ;
  vilostad_nn_1_N : N ;
  vilsamhet_nn_1_N : N ;
  viltsmak_nn_1_N : N ;
  viltvaard_nn_1_1_N : N ;
  vimmelkantighet_nn_1_N : N ;
  vimsighet_nn_1_N : N ;
  vinbransch_nn_1_N : N ;
  vindhet_nn_1_N : N ;
  vindicerbarhet_nn_1_N : N ;
  vindkraft_nn_1_N : N ;
  vindpollinerbarhet_nn_1_N : N ;
  vindoegdhet_nn_1_1_N : N ;
  vingklippning_nn_1_N : N ;
  vinglighet_nn_1_N : N ;
  vingloeshet_nn_1_1_N : N ;
  vinjaest_nn_1_1_N : N ;
  vinkonsumtion_nn_1_N : N ;
  vinproduktion_nn_1_N : N ;
  vinstmaximerbarhet_nn_1_N : N ;
  vintercykling_nn_1_N : N ;
  vintergaeck_nn_1_1_N : N ;
  vinterhaerdighet_nn_1_1_N : N ;
  vinterkoeld_nn_1_1_N : N ;
  vinterlighet_nn_1_N : N ;
  vintersol_nn_1_N : N ;
  vintersaed_nn_1_1_N : N ;
  vintersoemn_nn_1_1_N : N ;
  vintertid_nn_1_N : N ;
  vintrighet_nn_1_N : N ;
  vinyl_nn_1_N : N ;
  vinylglans_nn_1_N : N ;
  vinylklorid_nn_1_N : N ;
  vinaegrett_nn_1_1_N : N ;
  violdoft_nn_1_N : N ;
  vippighet_nn_1_N : N ;
  virak_nn_1_N : N ;
  virkesfaangst_nn_1_1_N : N ;
  virtuosmaessighet_nn_1_1_N : N ;
  virulens_nn_1_N : N ;
  viserbarhet_nn_1_N : N ;
  visionsloeshet_nn_1_1_N : N ;
  visiterbarhet_nn_1_N : N ;
  viskos_nn_1_N : N ;
  vislighet_nn_1_N : N ;
  vismut_nn_1_N : N ;
  vispighet_nn_1_N : N ;
  vissnesjuka_nn_1_N : N ;
  vissaang_nn_1_1_N : N ;
  visualiserbarhet_nn_1_N : N ;
  vitaktighet_nn_1_N : N ;
  vitaliserbarhet_nn_1_N : N ;
  vitalkraft_nn_1_N : N ;
  vitaminerbarhet_nn_1_N : N ;
  vitaminiserbarhet_nn_1_N : N ;
  vitaminrikhet_nn_1_N : N ;
  vitaxighet_nn_1_N : N ;
  vithyllthet_nn_1_N : N ;
  vithaarighet_nn_1_1_N : N ;
  vitkaal_nn_1_1_N : N ;
  vitmaessing_nn_1_1_N : N ;
  vitskaeggighet_nn_1_1_N : N ;
  vittberesthet_nn_1_N : N ;
  vittberoemdhet_nn_1_1_N : N ;
  vittnesgillhet_nn_1_N : N ;
  vittvaett_nn_1_1_N : N ;
  vitved_nn_1_N : N ;
  vivianit_nn_1_N : N ;
  vokalbalans_nn_1_N : N ;
  vokaliserbarhet_nn_1_N : N ;
  vokalmusik_nn_1_N : N ;
  volleyboll_nn_1_N : N ;
  volontering_nn_1_N : N ;
  volymvikt_nn_1_N : N ;
  voyeuristiskhet_nn_1_N : N ;
  vredhet_nn_1_N : N ;
  vrenskhet_nn_1_N : N ;
  vresved_nn_1_N : N ;
  vridbarhet_nn_1_N : N ;
  vridenhet_nn_1_N : N ;
  vraalflotthet_nn_1_1_N : N ;
  vraangvishet_nn_1_1_N : N ;
  vulgariserbarhet_nn_1_N : N ;
  vulkaniserbarhet_nn_1_N : N ;
  vulstighet_nn_1_N : N ;
  vuxenmobbning_nn_1_N : N ;
  vaedd_nn_1_1_N : N ;
  vaederbestaendighet_nn_1_1_N : N ;
  vaederlekstjaenst_nn_1_1_N : N ;
  vaederspaendhet_nn_1_1_N : N ;
  vaederstinnhet_nn_1_1_N : N ;
  vaedertjaenst_nn_1_1_N : N ;
  vaeft_nn_1_1_N : N ;
  vaegdoed_nn_1_1_N : N ;
  vaeggmonterbarhet_nn_1_1_N : N ;
  vaegkost_nn_1_1_N : N ;
  vaegtrafik_nn_1_1_N : N ;
  vaegvillhet_nn_1_1_N : N ;
  vaelavvaegdhet_nn_1_1_N : N ;
  vaelbegriplighet_nn_1_1_N : N ;
  vaelbehoevlighet_nn_1_1_N : N ;
  vaelbestaelldhet_nn_1_1_N : N ;
  vaelbesoekthet_nn_1_1_N : N ;
  vaelbetaldhet_nn_1_1_N : N ;
  vaelbetaenkthet_nn_1_1_N : N ;
  vaeld_nn_1_1_N : N ;
  vaelfaerd_nn_1_1_N : N ;
  vaelfaerdspolitik_nn_1_1_N : N ;
  vaelfoerenlighet_nn_1_1_N : N ;
  vaelfoerklarlighet_nn_1_1_N : N ;
  vaelfoerstaaelighet_nn_1_1_N : N ;
  vaelfoerstaandighet_nn_1_1_N : N ;
  vaelfoertjaenthet_nn_1_1_N : N ;
  vaelgaang_nn_1_1_N : N ;
  vaelklaeddhet_nn_1_1_N : N ;
  vaelkaendhet_nn_1_1_N : N ;
  vaellovlighet_nn_1_1_N : N ;
  vaellukt_nn_1_1_N : N ;
  vaellust_nn_1_1_N : N ;
  vaellustighet_nn_1_1_N : N ;
  vaelmening_nn_1_1_N : N ;
  vaelmenthet_nn_1_1_N : N ;
  vaelnaerdhet_nn_1_1_N : N ;
  vaelskapthet_nn_1_1_N : N ;
  vaelskhet_nn_1_1_N : N ;
  vaelskoetthet_nn_1_1_N : N ;
  vaelsmordhet_nn_1_1_N : N ;
  vaelstaelldhet_nn_1_1_N : N ;
  vaelvdhet_nn_1_1_N : N ;
  vaelvishet_nn_1_1_N : N ;
  vaelvaexthet_nn_1_1_N : N ;
  vaendbarhet_nn_1_1_N : N ;
  vaenfasthet_nn_1_1_N : N ;
  vaenhet_nn_1_1_N : N ;
  vaenlighet_nn_2_1_N : N ;
  vaenskap_nn_1_1_N : N ;
  vaensterextremism_nn_1_1_N : N ;
  vaensterhaenthet_nn_1_1_N : N ;
  vaensterpolitik_nn_1_1_N : N ;
  vaenstervridning_nn_1_1_N : N ;
  vaensaellhet_nn_1_1_N : N ;
  vaerdebestaendighet_nn_1_1_N : N ;
  vaerdefasthet_nn_1_1_N : N ;
  vaerdegemenskap_nn_1_1_N : N ;
  vaerdeloeshet_nn_1_1_N : N ;
  vaerdemaessighet_nn_1_1_N : N ;
  vaerdepost_nn_1_1_N : N ;
  vaerderbarhet_nn_1_1_N : N ;
  vaerdesaekerhet_nn_1_1_N : N ;
  vaerdhet_nn_1_1_N : N ;
  vaerjo_nn_1_1_N : N ;
  vaerldsbank_nn_1_1_N : N ;
  vaerldserfarenhet_nn_1_1_N : N ;
  vaerldsfientlighet_nn_1_1_N : N ;
  vaerldsfred_nn_1_1_N : N ;
  vaerldsfraanvaendhet_nn_1_1_N : N ;
  vaerldsfoersaeljning_nn_1_1_N : N ;
  vaerldsklokhet_nn_1_1_N : N ;
  vaerldskaendhet_nn_1_1_N : N ;
  vaerldskaennedom_nn_1_1_N : N ;
  vaerldslitteratur_nn_1_1_N : N ;
  vaerldsnaturfond_nn_1_1_N : N ;
  vaerldspolitik_nn_1_1_N : N ;
  vaerldspress_nn_1_1_N : N ;
  vaerldssjael_nn_1_1_N : N ;
  vaerldsvishet_nn_1_1_N : N ;
  vaermebestaendighet_nn_1_1_N : N ;
  vaermeeffekt_nn_1_1_N : N ;
  vaermeekvivalent_nn_1_1_N : N ;
  vaermefotograferbarhet_nn_1_1_N : N ;
  vaermegenomgaang_nn_1_1_N : N ;
  vaermeisolerbarhet_nn_1_1_N : N ;
  vaermesteriliserbarhet_nn_1_1_N : N ;
  vaermetaalighet_nn_1_1_N : N ;
  vaernkraft_nn_1_1_N : N ;
  vaernloeshet_nn_1_1_N : N ;
  vaernplikt_nn_1_1_N : N ;
  vaernpliktstid_nn_1_1_N : N ;
  vaerpsjuka_nn_1_1_N : N ;
  vaerpsjukhet_nn_1_1_N : N ;
  vaest_nn_2_1_N : N ;
  vaestanvind_nn_1_1_N : N ;
  vaestvinddrift_nn_1_1_N : N ;
  vaestvaerld_nn_1_1_N : N ;
  vaetekraft_nn_1_1_N : N ;
  vaeteperoxid_nn_1_1_N : N ;
  vaetesulfid_nn_1_1_N : N ;
  vaetesuperoxid_nn_1_1_N : N ;
  vaetgas_nn_1_1_N : N ;
  vaetgasdrift_nn_1_1_N : N ;
  vaetgasrikhet_nn_1_1_N : N ;
  vaetskebalans_nn_1_1_N : N ;
  vaetskebrist_nn_1_1_N : N ;
  vaetskeform_nn_1_1_N : N ;
  vaetskekultur_nn_1_1_N : N ;
  vaetskighet_nn_1_1_N : N ;
  vaexkraft_nn_1_1_N : N ;
  vaexlingsrikhet_nn_1_1_N : N ;
  vaexthuseffekt_nn_1_1_N : N ;
  vaextkraft_nn_1_1_N : N ;
  vaextkraftighet_nn_1_1_N : N ;
  vaextvaerk_nn_1_1_N : N ;
  vaexvaerk_nn_1_1_N : N ;
  vaadlighet_nn_1_1_N : N ;
  vaaffeldag_nn_1_1_N : N ;
  vaagformighet_nn_1_1_N : N ;
  vaagighet_nn_1_1_N : N ;
  vaagkraft_nn_1_1_N : N ;
  vaagmekanik_nn_1_1_N : N ;
  vaagmaestarpolitik_nn_1_1_N : N ;
  vaagraethet_nn_1_1_N : N ;
  vaagsamhet_nn_1_1_N : N ;
  vaaldsutsatthet_nn_1_1_N : N ;
  vaapighet_nn_1_1_N : N ;
  vaarbrodd_nn_1_1_N : N ;
  vaard_nn_1_1_N : N ;
  vaardagjaemningspunkt_nn_1_1_N : N ;
  vaardsamhet_nn_1_1_N : N ;
  vaarflod_nn_1_1_N : N ;
  vaarfrost_nn_1_1_N : N ;
  vaarfrudag_nn_1_1_N : N ;
  vaarluft_nn_1_1_N : N ;
  vaarsaed_nn_1_1_N : N ;
  vaartighet_nn_1_1_N : N ;
  vaathet_nn_1_1_N : N ;
  vaatstarkhet_nn_1_1_N : N ;
  vaatvarmhet_nn_1_1_N : N ;
  voerdighet_nn_1_1_N : N ;
  voerdnadsfullhet_nn_1_1_N : N ;
  voerdnadsvaerdhet_nn_1_1_N : N ;
  voerdsamhet_nn_1_1_N : N ;
  voert_nn_1_1_N : N ;
  wajang_nn_1_N : N ;
  waldorfpedagogik_nn_1_N : N ;
  wallraffning_nn_1_N : N ;
  web_nn_1_N : N ;
  webb_nn_1_N : N ;
  webbsupport_nn_1_N : N ;
  webbtelevision_nn_1_N : N ;
  webbteve_nn_1_N : N ;
  wellpapp_nn_1_N : N ;
  weltervikt_nn_1_N : N ;
  weltschmerz_nn_1_N : N ;
  whist_nn_1_N : N ;
  ymnighet_nn_1_N : N ;
  ympningsplikt_nn_1_N : N ;
  ynkansvaerdhet_nn_1_1_N : N ;
  ynklighet_nn_1_N : N ;
  ynnest_nn_1_N : N ;
  yoghurt_nn_1_N : N ;
  yppighet_nn_1_N : N ;
  yrhet_nn_1_N : N ;
  yrkesmaessighet_nn_1_1_N : N ;
  yrkesskicklighet_nn_1_N : N ;
  yrkestrafik_nn_1_N : N ;
  yrkesverksamhet_nn_1_N : N ;
  yrvakenhet_nn_1_N : N ;
  ysterhet_nn_1_N : N ;
  yteld_nn_1_N : N ;
  ytterhud_nn_1_N : N ;
  yttranderaett_nn_1_1_N : N ;
  ytved_nn_1_N : N ;
  yvighet_nn_1_N : N ;
  yxlaegg_nn_1_1_N : N ;
  zenit_nn_1_N : N ;
  zeolit_nn_1_N : N ;
  zigenarmusik_nn_1_N : N ;
  zink_nn_1_N : N ;
  zinkspat_nn_1_N : N ;
  zodiak_nn_1_N : N ;
  zontid_nn_1_N : N ;
  zoom_nn_1_N : N ;
  aedelfisk_nn_1_1_N : N ;
  aedelhet_nn_1_1_N : N ;
  aedelkorall_nn_1_1_N : N ;
  aedelmodighet_nn_1_1_N : N ;
  aedelaerg_nn_1_1_N : N ;
  aeganderaett_nn_1_1_N : N ;
  aeggfaerg_nn_1_1_N : N ;
  aegglaeggning_nn_1_1_N : N ;
  aeggsjukhet_nn_1_1_N : N ;
  aegofred_nn_1_1_N : N ;
  aektenskaplighet_nn_1_1_N : N ;
  aeldreomsorg_nn_1_1_N : N ;
  aeldrevaard_nn_1_1_N : N ;
  aelghud_nn_1_1_N : N ;
  aelskog_nn_1_1_N : N ;
  aelskogskrankhet_nn_1_1_N : N ;
  aelvaexing_nn_1_1_N : N ;
  aemnesintegrerbarhet_nn_1_1_N : N ;
  aemnesmetodik_nn_1_1_N : N ;
  aendalykt_nn_1_1_N : N ;
  aendamaalsloeshet_nn_1_1_N : N ;
  aendlighet_nn_1_1_N : N ;
  aendloeshet_nn_1_1_N : N ;
  aenglalikhet_nn_1_1_N : N ;
  aenglamat_nn_1_1_N : N ;
  aenglavakt_nn_1_1_N : N ;
  aengsboll_nn_1_1_N : N ;
  aengslighet_nn_1_1_N : N ;
  aengsull_nn_1_1_N : N ;
  aeppelpraektighet_nn_1_1_N : N ;
  aeppelskorv_nn_1_1_N : N ;
  aeppleskorv_nn_1_1_N : N ;
  aerbarhet_nn_1_1_N : N ;
  aerefoergaetenhet_nn_1_1_N : N ;
  aeregirighet_nn_1_1_N : N ;
  aereloeshet_nn_1_1_N : N ;
  aerenpris_nn_1_1_N : N ;
  aerevoerdighet_nn_1_1_N : N ;
  aerftlighetsforskning_nn_1_1_N : N ;
  aerg_nn_1_1_N : N ;
  aergighet_nn_1_1_N : N ;
  aering_nn_1_1_N : N ;
  aermloeshet_nn_1_1_N : N ;
  aerofullhet_nn_1_1_N : N ;
  aerofylldhet_nn_1_1_N : N ;
  aerorikhet_nn_1_1_N : N ;
  aerrighet_nn_1_1_N : N ;
  aertighet_nn_1_1_N : N ;
  aervdabalk_nn_1_1_N : N ;
  aetbarhet_nn_1_1_N : N ;
  aettiksprit_nn_1_1_N : N ;
  aaboraett_nn_1_1_N : N ;
  aabrodd_nn_1_1_N : N ;
  aabaekighet_nn_1_1_N : N ;
  aabaeklighet_nn_1_1_N : N ;
  aadrighet_nn_1_1_N : N ;
  aagren_nn_1_1_N : N ;
  aakersenap_nn_1_1_N : N ;
  aaksjuka_nn_1_1_N : N ;
  aaksjukhet_nn_1_1_N : N ;
  aalderssvaghet_nn_1_1_N : N ;
  aalderstyngdhet_nn_1_1_N : N ;
  aaldrighet_nn_1_1_N : N ;
  aaldringsvaard_nn_1_1_N : N ;
  aangdrift_nn_1_1_N : N ;
  aangerfrist_nn_1_1_N : N ;
  aangerfullhet_nn_1_1_N : N ;
  aangerkoepthet_nn_1_1_N : N ;
  aangest_nn_1_1_N : N ;
  aangestfullhet_nn_1_1_N : N ;
  aangestfylldhet_nn_1_1_N : N ;
  aangestsvett_nn_1_1_N : N ;
  aangkraft_nn_1_1_N : N ;
  aarbraeckthet_nn_1_1_N : N ;
  aarsgaang_nn_1_1_N : N ;
  aarsmoraen_nn_1_1_N : N ;
  aarsvaext_nn_1_1_N : N ;
  aasiktsgemenskap_nn_1_1_N : N ;
  aasiktsmaessighet_nn_1_1_N : N ;
  aasiktsregistrerbarhet_nn_1_1_N : N ;
  aasklikhet_nn_1_1_N : N ;
  aasnemjoelk_nn_1_1_N : N ;
  aasyn_nn_1_1_N : N ;
  aatalbarhet_nn_1_1_N : N ;
  aatalseftergift_nn_1_1_N : N ;
  aatalsraett_nn_1_1_N : N ;
  aateljakt_nn_1_1_N : N ;
  aaterbetalningsraett_nn_1_1_N : N ;
  aaterbetalningstakt_nn_1_1_N : N ;
  aaterglans_nn_1_1_N : N ;
  aatergaang_nn_1_1_N : N ;
  aatergaangstull_nn_1_1_N : N ;
  aaterinstallerbarhet_nn_1_1_N : N ;
  aaterklang_nn_1_1_N : N ;
  aaterkomst_nn_1_1_N : N ;
  aaterkoepsraett_nn_1_1_N : N ;
  aatervandring_nn_1_1_N : N ;
  aatervaeg_nn_1_1_N : N ;
  aatervaext_nn_1_1_N : N ;
  aatgaang_nn_1_1_N : N ;
  aatkomlighet_nn_1_1_N : N ;
  aatkomst_nn_1_1_N : N ;
  aatraavaerdhet_nn_1_1_N : N ;
  aatskillnadsloeshet_nn_1_1_N : N ;
  aattkantighet_nn_1_1_N : N ;
  _elan_nn_1_1_N : N ;
  oedesbestaemdhet_nn_1_1_N : N ;
  oedesdigerhet_nn_1_1_N : N ;
  oedesgemenskap_nn_1_1_N : N ;
  oegonblicklighet_nn_1_1_N : N ;
  oegondiagnostik_nn_1_1_N : N ;
  oegonskenlighet_nn_1_1_N : N ;
  oegontroest_nn_1_1_N : N ;
  oekensand_nn_1_1_N : N ;
  oekaendhet_nn_1_1_N : N ;
  oelandstok_nn_1_1_N : N ;
  oeldrickning_nn_1_1_N : N ;
  oelost_nn_1_1_N : N ;
  oemhet_nn_2_1_N : N ;
  oemkansvaerdhet_nn_1_1_N : N ;
  oemsesidighet_nn_1_1_N : N ;
  oemsinthet_nn_1_1_N : N ;
  oensklighet_nn_1_1_N : N ;
  oenskvaerdhet_nn_1_1_N : N ;
  oeppenhjaertighet_nn_1_1_N : N ;
  oeppenhjaertlighet_nn_1_1_N : N ;
  oeppenvaard_nn_1_1_N : N ;
  oer_nn_1_1_N : N ;
  oerlogsflagg_nn_1_1_N : N ;
  oernkoll_nn_1_1_N : N ;
  oerraag_nn_1_1_N : N ;
  oest_nn_1_1_N : N ;
  oestanvind_nn_1_1_N : N ;
  oestergoek_nn_1_1_N : N ;
  oeveraktivitet_nn_1_1_N : N ;
  oeverbetoning_nn_1_1_N : N ;
  oeverbevisning_nn_1_1_N : N ;
  oeverblickbarhet_nn_1_1_N : N ;
  oeverbudspolitik_nn_1_1_N : N ;
  oeverdiagnostik_nn_1_1_N : N ;
  oeverdimensionerbarhet_nn_1_1_N : N ;
  oeverdoserbarhet_nn_1_1_N : N ;
  oeverdaadighet_nn_1_1_N : N ;
  oeverexponerbarhet_nn_1_1_N : N ;
  oeverfiskning_nn_1_1_N : N ;
  oeverfloedighet_nn_1_1_N : N ;
  oeverfullhet_nn_1_1_N : N ;
  oeverfylldhet_nn_1_1_N : N ;
  oeverfoertjusthet_nn_1_1_N : N ;
  oevergivenhet_nn_1_1_N : N ;
  oevergaangsstat_nn_1_1_N : N ;
  oeverhand_nn_1_1_N : N ;
  oeverhetlighet_nn_1_1_N : N ;
  oeverhud_nn_1_1_N : N ;
  oeverhaerdighet_nn_1_1_N : N ;
  oeverjordiskhet_nn_1_1_N : N ;
  oeverklassighet_nn_1_1_N : N ;
  oeverkomlighet_nn_1_1_N : N ;
  oeverkompenserbarhet_nn_1_1_N : N ;
  oeverlackerbarhet_nn_1_1_N : N ;
  oeverlackeringsbarhet_nn_1_1_N : N ;
  oeverladdning_nn_1_1_N : N ;
  oeverlagdhet_nn_1_1_N : N ;
  oeverlastning_nn_1_1_N : N ;
  oeverlevnadsdrift_nn_1_1_N : N ;
  oeverlevnadsaangest_nn_1_1_N : N ;
  oeverlycklighet_nn_1_1_N : N ;
  oevermakt_nn_1_1_N : N ;
  oevermodighet_nn_1_1_N : N ;
  oevermognad_nn_1_1_N : N ;
  oevermaektighet_nn_1_1_N : N ;
  oevermaensklighet_nn_1_1_N : N ;
  oevermaetthet_nn_1_1_N : N ;
  oevermaettnad_nn_1_1_N : N ;
  oevermaalningsbarhet_nn_1_1_N : N ;
  oeversiktlighet_nn_1_1_N : N ;
  oeversinnlighet_nn_1_1_N : N ;
  oeverskaadlighet_nn_1_1_N : N ;
  oeverskoeljningssaekerhet_nn_1_1_N : N ;
  oeverstiglighet_nn_1_1_N : N ;
  oeverstyrdhet_nn_1_1_N : N ;
  oeversvinnelighet_nn_1_1_N : N ;
  oeversvinnlighet_nn_1_1_N : N ;
  oeversynthet_nn_1_1_N : N ;
  oeversaettningskvalitet_nn_1_1_N : N ;
  oevertalighet_nn_1_1_N : N ;
  oevertid_nn_1_1_N : N ;
  oevertrasserbarhet_nn_1_1_N : N ;
  oevertaenkthet_nn_1_1_N : N ;
  oevervikt_nn_1_1_N : N ;
  oeverviktighet_nn_1_1_N : N ;
  oevervaerderbarhet_nn_1_1_N : N ;
  oevervaext_nn_1_1_N : N ;
  oeveraarighet_nn_1_1_N : N ;
  oeveroesning_nn_1_1_N : N ;
  oevlighet_nn_1_1_N : N ;
  aktsam_av_1_A : A ;
  allmaen_av_1_1_A : A ;
  allvarsam_av_1_A : A ;
  ankommen_av_1_A : A ;
  arbetsam_av_1_A : A ;
  avhaallsam_av_1_1_A : A ;
  avsigkommen_av_1_A : A ;
  avundsam_av_1_A : A ;
  bekymmersam_av_1_A : A ;
  beslutsam_av_1_A : A ;
  bestaellsam_av_1_1_A : A ;
  betaenksam_av_1_1_A : A ;
  blygsam_av_1_A : A ;
  bortkommen_av_1_A : A ;
  brydsam_av_1_A : A ;
  bullersam_av_1_A : A ;
  dum_av_1_A : A ;
  doevstum_av_1_1_A : A ;
  eftertaenksam_av_1_1_A : A ;
  ensam_av_1_A : A ;
  erkaennsam_av_1_1_A : A ;
  finspunnen_av_1_A : A ;
  fisktom_av_1_A : A ;
  folktom_av_1_A : A ;
  fridsam_av_1_A : A ;
  from_av_1_A : A ;
  fruktsam_av_1_A : A ;
  fundersam_av_1_A : A ;
  faegnesam_av_1_1_A : A ;
  faageltom_av_1_1_A : A ;
  foeljsam_av_1_1_A : A ;
  foerbehaallsam_av_1_1_A : A ;
  foerdragsam_av_1_1_A : A ;
  foeretagsam_av_1_1_A : A ;
  foerkommen_av_1_1_A : A ;
  foernoejsam_av_1_1_A : A ;
  foersigkommen_av_1_1_A : A ;
  foertrytsam_av_1_1_A : A ;
  foertaenksam_av_1_1_A : A ;
  foervunnen_av_1_1_A : A ;
  gemensam_av_1_A : A ;
  genomdum_av_1_A : A ;
  gruvsam_av_1_A : A ;
  grym_av_1_A : A ;
  gynnsam_av_1_A : A ;
  gaecksam_av_1_1_A : A ;
  hedersam_av_1_A : A ;
  hindersam_av_1_A : A ;
  hjaelpsam_av_1_1_A : A ;
  hopkommen_av_1_A : A ;
  hovsam_av_1_A : A ;
  hugnesam_av_1_A : A ;
  haelsosam_av_1_1_A : A ;
  haevdvunnen_av_1_1_A : A ;
  hoersam_av_1_1_A : A ;
  innehaallstom_av_1_1_A : A ;
  instaellsam_av_1_1_A : A ;
  jaettedum_av_1_1_A : A ;
  klaedsam_av_1_1_A : A ;
  kostsam_av_1_A : A ;
  kraftvunnen_av_1_A : A ;
  krum_av_1_A : A ;
  kyrksam_av_1_A : A ;
  kaenslosam_av_1_1_A : A ;
  kaerkommen_av_1_1_A : A ;
  lagvunnen_av_1_A : A ;
  ledsam_av_1_A : A ;
  legendomspunnen_av_1_A : A ;
  liten_av_1_A : A ;
  ljum_av_1_A : A ;
  ljummen_av_1_A : A ;
  lufttom_av_1_A : A ;
  lyckosam_av_1_A : A ;
  laettfunnen_av_1_1_A : A ;
  laettsam_av_1_1_A : A ;
  laettvunnen_av_1_1_A : A ;
  laangsam_av_1_1_A : A ;
  loensam_av_1_1_A : A ;
  meddelsam_av_1_A : A ;
  medlidsam_av_1_A : A ;
  missgynnsam_av_1_A : A ;
  missklaedsam_av_1_1_A : A ;
  misskundsam_av_1_A : A ;
  misskoetsam_av_1_1_A : A ;
  misstaenksam_av_1_1_A : A ;
  missunnsam_av_1_A : A ;
  mytomspunnen_av_1_A : A ;
  maettsam_av_1_1_A : A ;
  moedosam_av_1_1_A : A ;
  nummen_av_1_A : A ;
  nytillkommen_av_1_A : A ;
  nyutkommen_av_1_A : A ;
  nyvunnen_av_1_A : A ;
  noejsam_av_1_1_A : A ;
  oaktsam_av_1_A : A ;
  obeslutsam_av_1_A : A ;
  obetaenksam_av_1_1_A : A ;
  obrunnen_av_1_A : A ;
  ofruktsam_av_1_A : A ;
  ofoerbehaallsam_av_1_1_A : A ;
  ofoerdragsam_av_1_1_A : A ;
  ofoeretagsam_av_1_1_A : A ;
  ogynnsam_av_1_A : A ;
  ohaelsosam_av_1_1_A : A ;
  ohoersam_av_1_1_A : A ;
  oloensam_av_1_1_A : A ;
  omisstaenksam_av_1_1_A : A ;
  omtaenksam_av_1_1_A : A ;
  ordningsam_av_1_A : A ;
  ordstum_av_1_A : A ;
  otacksam_av_1_A : A ;
  otrivsam_av_1_A : A ;
  otursam_av_1_A : A ;
  ouppmaerksam_av_1_1_A : A ;
  ovarsam_av_1_A : A ;
  overksam_av_1_A : A ;
  ovaelkommen_av_1_1_A : A ;
  ooem_av_1_1_A : A ;
  passagerartom_av_1_A : A ;
  pinsam_av_1_A : A ;
  plaagsam_av_1_1_A : A ;
  pratsam_av_1_A : A ;
  paakommen_av_1_1_A : A ;
  retsam_av_1_A : A ;
  rum_av_1_A : A ;
  raettfram_av_1_1_A : A ;
  sagoomspunnen_av_1_A : A ;
  samvetsoem_av_1_1_A : A ;
  sedesam_av_1_A : A ;
  senkommen_av_1_A : A ;
  skonsam_av_1_A : A ;
  skrytsam_av_1_A : A ;
  skum_av_1_A : A ;
  skyndsam_av_1_A : A ;
  skaemtsam_av_1_1_A : A ;
  skaaltom_av_1_1_A : A ;
  skoetsam_av_1_1_A : A ;
  slem_av_1_A : A ;
  slitsam_av_1_A : A ;
  slaepsam_av_1_1_A : A ;
  smeksam_av_1_A : A ;
  smittosam_av_1_A : A ;
  smittsam_av_1_A : A ;
  smaertsam_av_1_1_A : A ;
  sorgesam_av_1_A : A ;
  sparsam_av_1_A : A ;
  spraaksam_av_1_1_A : A ;
  stillsam_av_1_A : A ;
  stockdum_av_1_A : A ;
  straevsam_av_1_1_A : A ;
  stum_av_1_A : A ;
  svaarfunnen_av_1_1_A : A ;
  saegenomspunnen_av_1_1_A : A ;
  saellsam_av_1_1_A : A ;
  tacksam_av_1_A : A ;
  tanketom_av_1_A : A ;
  tom_av_1_A : A ;
  trivsam_av_1_A : A ;
  troettsam_av_1_1_A : A ;
  tungsam_av_1_A : A ;
  tursam_av_1_A : A ;
  tveksam_av_1_A : A ;
  tvivelsam_av_1_A : A ;
  undersam_av_1_A : A ;
  uppmaerksam_av_1_1_A : A ;
  utbrunnen_av_1_A : A ;
  vaksam_av_1_A : A ;
  varkunnsam_av_1_A : A ;
  varsam_av_1_A : A ;
  verksam_av_1_A : A ;
  villsam_av_1_A : A ;
  vilsam_av_1_A : A ;
  vilsekommen_av_1_A : A ;
  vaelfunnen_av_1_1_A : A ;
  vaelkommen_av_1_1_A : A ;
  vaagsam_av_1_1_A : A ;
  vaaldsam_av_1_1_A : A ;
  vaardsam_av_1_1_A : A ;
  voerdsam_av_1_1_A : A ;
  yrkesverksam_av_1_A : A ;
  aaterhaallsam_av_1_1_A : A ;
  oem_av_1_1_A : A ;
  bra_av_1_A : A ;
  faa_av_1_1_A : A ;
  gammal_av_1_A : A ;
  naera_av_1_1_A : A ;
  rekordfaa_av_1_1_A : A ;
  urgammal_av_1_A : A ;
  oevervaald_nn_1_1_N : N ;
  oevertryck_nn_1_1_N : N ;
  oevermaatt_nn_1_1_N : N ;
  oevermod_nn_1_1_N : N ;
  oeverjag_nn_1_1_N : N ;
  oeverhus_nn_1_1_N : N ;
  oeverhetsfjaesk_nn_1_1_N : N ;
  oeverfloed_nn_1_1_N : N ;
  oeverbruk_nn_1_1_N : N ;
  oeverbett_nn_1_1_N : N ;
  oestron_nn_1_1_N : N ;
  oesterland_nn_1_1_N : N ;
  oestblock_nn_1_1_N : N ;
  oes_nn_1_1_N : N ;
  oerspraang_nn_1_1_N : N ;
  oeronvax_nn_1_1_N : N ;
  oekenklimat_nn_1_1_N : N ;
  oegonmaatt_nn_1_1_N : N ;
  oegondropp_nn_1_1_N : N ;
  aattital_nn_1_1_N : N ;
  aattiotal_nn_1_1_N : N ;
  aatersken_nn_1_1_N : N ;
  aaterbruk_nn_1_1_N : N ;
  aat_nn_1_1_N : N ;
  aaskaadningsmaterial_nn_1_1_N : N ;
  aaskmuller_nn_1_1_N : N ;
  aasiktsfoertryck_nn_1_1_N : N ;
  aalmoerker_nn_1_1_N : N ;
  aaldersstreck_nn_1_1_N : N ;
  aalamoerker_nn_1_1_N : N ;
  aakerograes_nn_1_1_N : N ;
  aendtrae_nn_1_1_N : N ;
  aemnesinnehaall_nn_1_1_N : N ;
  aembetsmannaansvar_nn_1_1_N : N ;
  aembetsansvar_nn_1_1_N : N ;
  aeltgraes_nn_1_1_N : N ;
  aelgkoett_nn_1_1_N : N ;
  aelggraes_nn_1_1_N : N ;
  aeldrehat_nn_1_1_N : N ;
  aeggvitebehov_nn_1_1_N : N ;
  aeggpulver_nn_1_1_N : N ;
  aedeltrae_nn_1_1_N : N ;
  aedelmod_nn_1_1_N : N ;
  zodiakalljus_nn_1_N : N ;
  zirkonium_nn_1_N : N ;
  yttrium_nn_1_N : N ;
  ytterspaar_nn_1_1_N : N ;
  ytterbium_nn_1_N : N ;
  yppandefoerbud_nn_1_1_N : N ;
  yl_nn_1_N : N ;
  xenon_nn_1_N : N ;
  xantofyll_nn_1_N : N ;
  vaatrumssilikon_nn_1_1_N : N ;
  vaarbruk_nn_1_1_N : N ;
  vaald_nn_1_1_N : N ;
  vaagmaesteri_nn_1_1_N : N ;
  vaextskydd_nn_1_1_N : N ;
  vaextliv_nn_1_1_N : N ;
  vaexelrytteri_nn_1_1_N : N ;
  vaexelbruk_nn_1_1_N : N ;
  vaestficksformat_nn_1_1_N : N ;
  vaesterland_nn_1_1_N : N ;
  vaesterhav_nn_1_1_N : N ;
  vaestblock_nn_1_1_N : N ;
  vaermeslag_nn_1_1_N : N ;
  vaermedis_nn_1_1_N : N ;
  vaerldsfoerakt_nn_1_1_N : N ;
  vaerldsallt_nn_1_1_N : N ;
  vaerdskap_nn_1_1_N : N ;
  vaensterprassel_nn_1_1_N : N ;
  vaelstaand_nn_1_1_N : N ;
  vaellstaal_nn_1_1_N : N ;
  vaelljud_nn_1_1_N : N ;
  vaelbehag_nn_1_1_N : N ;
  vaegverk_nn_1_1_N : N ;
  vaegsmuts_nn_1_1_N : N ;
  vaegsalt_nn_1_1_N : N ;
  vaeggrepp_nn_1_1_N : N ;
  vaederkorn_nn_1_1_N : N ;
  vuxenstudiestoed_nn_1_1_N : N ;
  vurmeri_nn_1_N : N ;
  vulgaerlatin_nn_1_1_N : N ;
  vroevel_nn_1_1_N : N ;
  vredesmod_nn_1_N : N ;
  vrakjaern_nn_1_1_N : N ;
  vrakgods_nn_1_N : N ;
  vokalmummel_nn_1_N : N ;
  vitterfolk_nn_1_N : N ;
  vitbleck_nn_1_N : N ;
  virrvarr_nn_1_N : N ;
  vintersolstaand_nn_1_1_N : N ;
  vinstbegaer_nn_1_1_N : N ;
  vingleri_nn_1_N : N ;
  vingel_nn_1_N : N ;
  vingbrus_nn_1_N : N ;
  vindtyg_nn_1_N : N ;
  vindsus_nn_1_N : N ;
  vindrufs_nn_1_N : N ;
  vin_nn_2_N : N ;
  vimmel_nn_1_N : N ;
  vilt_nn_1_N : N ;
  villabyggnadsraseri_nn_1_N : N ;
  vildvin_nn_1_N : N ;
  vi_nn_1_N : N ;
  vett_nn_1_N : N ;
  vetemjoelsklister_nn_1_1_N : N ;
  vetemjoel_nn_1_1_N : N ;
  vetekli_nn_1_N : N ;
  verktygsstaal_nn_1_1_N : N ;
  verkskydd_nn_1_N : N ;
  verksamhetsbegaer_nn_1_1_N : N ;
  verkbly_nn_1_N : N ;
  venushaar_nn_1_1_N : N ;
  vemod_nn_1_N : N ;
  velum_nn_1_N : N ;
  vedmaatt_nn_1_1_N : N ;
  vederlagsgods_nn_1_N : N ;
  vattningsfoerbud_nn_1_1_N : N ;
  vattenmotstaand_nn_1_1_N : N ;
  vattenliv_nn_1_N : N ;
  vattenbryn_nn_1_N : N ;
  vattenblask_nn_1_N : N ;
  vask_nn_2_N : N ;
  varuoeverfloed_nn_1_1_N : N ;
  vardagsbruk_nn_1_N : N ;
  var_nn_1_N : N ;
  vapenunderhaall_nn_1_1_N : N ;
  vapenskrammel_nn_1_N : N ;
  vapenfett_nn_1_N : N ;
  vapenbrak_nn_1_N : N ;
  vanvett_nn_1_N : N ;
  vankelmod_nn_1_N : N ;
  vaniljsocker_nn_1_N : N ;
  valoertryck_nn_1_1_N : N ;
  valoermaaleri_nn_1_1_N : N ;
  valskolk_nn_1_N : N ;
  valsjaern_nn_1_1_N : N ;
  valnoetstrae_nn_1_1_N : N ;
  vallhoe_nn_1_1_N : N ;
  valfusk_nn_1_N : N ;
  valflaesk_nn_1_1_N : N ;
  valfiffel_nn_1_N : N ;
  vak_nn_2_N : N ;
  vagabondliv_nn_1_N : N ;
  vaccinationstvaang_nn_1_1_N : N ;
  utsugeri_nn_1_N : N ;
  utrum_nn_1_N : N ;
  utrikesflyg_nn_2_N : N ;
  utredningsmaterial_nn_1_N : N ;
  utomhusbruk_nn_1_N : N ;
  utland_nn_1_N : N ;
  uteliv_nn_1_N : N ;
  utefoersvar_nn_1_1_N : N ;
  utebruk_nn_1_N : N ;
  urplock_nn_1_N : N ;
  urberg_nn_1_N : N ;
  uranbly_nn_1_N : N ;
  upptag_nn_1_N : N ;
  upphovsraettsjidder_nn_1_1_N : N ;
  upphov_nn_1_N : N ;
  uppboerdsverk_nn_1_1_N : N ;
  ungkarlsliv_nn_1_N : N ;
  ung_av_1_A : A ;
  undervisningsbruk_nn_1_N : N ;
  undertryck_nn_1_N : N ;
  understoedsrytteri_nn_1_1_N : N ;
  understoed_nn_1_1_N : N ;
  undermaal_nn_1_1_N : N ;
  underlaeder_nn_1_1_N : N ;
  underland_nn_1_N : N ;
  underhaallningsvaald_nn_1_1_N : N ;
  umgaengesvett_nn_1_1_N : N ;
  umgaengesliv_nn_1_1_N : N ;
  ullhaar_nn_1_1_N : N ;
  ullgarn_nn_1_N : N ;
  ullfett_nn_1_N : N ;
  taalamod_nn_1_1_N : N ;
  taenk_nn_1_1_N : N ;
  tyskhat_nn_1_N : N ;
  tyranni_nn_1_N : N ;
  tvaatusental_nn_1_1_N : N ;
  tvaatal_nn_1_1_N : N ;
  tvaaskift_nn_1_1_N : N ;
  tvaang_nn_1_1_N : N ;
  tvaalloedder_nn_1_1_N : N ;
  tvaaledarsystem_nn_1_1_N : N ;
  tvaahundratal_nn_1_1_N : N ;
  tvaerdrag_nn_1_1_N : N ;
  tvivelsmaal_nn_1_1_N : N ;
  tungel_nn_1_N : N ;
  tung_av_1_A : A ;
  tummel_nn_1_N : N ;
  tullvaesen_nn_1_1_N : N ;
  tulium_nn_1_N : N ;
  tugg_nn_1_N : N ;
  traak_nn_1_1_N : N ;
  traadglas_nn_1_1_N : N ;
  traetugg_nn_1_1_N : N ;
  traesocker_nn_1_1_N : N ;
  traesk_nn_2_1_N : N ;
  traejon_nn_1_1_N : N ;
  traeavfall_nn_1_1_N : N ;
  trycktrae_nn_1_1_N : N ;
  trug_nn_1_N : N ;
  trots_nn_1_N : N ;
  trollmos_nn_1_N : N ;
  tritium_nn_1_N : N ;
  trettonhundratal_nn_1_N : N ;
  tresteg_nn_1_N : N ;
  treskiftesbruk_nn_1_N : N ;
  treskift_nn_1_N : N ;
  trehundratal_nn_1_N : N ;
  trassel_nn_1_N : N ;
  trasproletariat_nn_1_N : N ;
  transportvaesen_nn_1_1_N : N ;
  trams_nn_1_N : N ;
  trampgraes_nn_1_1_N : N ;
  tramp_nn_1_N : N ;
  traggel_nn_1_N : N ;
  trafikflyg_nn_1_N : N ;
  trafikbuller_nn_1_N : N ;
  trafikbrus_nn_1_N : N ;
  totalintryck_nn_1_N : N ;
  totalfoersvar_nn_1_1_N : N ;
  torvstroe_nn_1_1_N : N ;
  torsklevertran_nn_1_N : N ;
  torrfoder_nn_1_N : N ;
  torrdis_nn_1_N : N ;
  torium_nn_1_N : N ;
  torgvimmel_nn_1_N : N ;
  tonval_nn_1_N : N ;
  tomtjobberi_nn_1_N : N ;
  tolvhundratal_nn_1_N : N ;
  toluen_nn_1_N : N ;
  tokprat_nn_1_N : N ;
  tobaksbruk_nn_1_N : N ;
  toapapper_nn_1_N : N ;
  toalettpapper_nn_1_N : N ;
  tjaerdrev_nn_1_1_N : N ;
  tjaenstefolk_nn_1_1_N : N ;
  tjuvspraak_nn_1_1_N : N ;
  tjuvgods_nn_1_N : N ;
  tjurfaektningsfoersvar_nn_1_1_N : N ;
  tjugohundratal_nn_1_N : N ;
  tjo_nn_1_N : N ;
  tjatter_nn_1_N : N ;
  tjat_nn_1_N : N ;
  tjall_nn_1_N : N ;
  tjafs_nn_1_N : N ;
  tissel_nn_1_N : N ;
  tiohundratal_nn_1_N : N ;
  tingeltangel_nn_1_N : N ;
  tilltugg_nn_1_N : N ;
  tilltal_nn_1_N : N ;
  tillsynsansvar_nn_1_N : N ;
  tidningspapper_nn_1_N : N ;
  tidelagsfoerbud_nn_1_1_N : N ;
  thomasfosfat_nn_1_N : N ;
  thaisiden_nn_1_N : N ;
  textilspill_nn_1_N : N ;
  tetraetylbly_nn_1_N : N ;
  testosteron_nn_1_N : N ;
  tertiaersystem_nn_1_1_N : N ;
  terbium_nn_1_N : N ;
  tennlod_nn_1_N : N ;
  tenn_nn_1_N : N ;
  teleschack_nn_1_N : N ;
  telegramspraak_nn_1_1_N : N ;
  telefax_nn_1_N : N ;
  telefaksimil_nn_1_N : N ;
  teknetium_nn_1_N : N ;
  teflon_nn_1_N : N ;
  teblask_nn_1_N : N ;
  tassel_nn_1_N : N ;
  tarv_nn_1_N : N ;
  tantsnusk_nn_1_N : N ;
  tankeliv_nn_1_N : N ;
  tankeinnehaall_nn_1_1_N : N ;
  tankegods_nn_1_N : N ;
  tankedjup_nn_1_N : N ;
  tandvaardsstoed_nn_1_1_N : N ;
  tandkoett_nn_1_1_N : N ;
  tandkitt_nn_1_N : N ;
  tandguld_nn_1_N : N ;
  tandem_nn_1_N : N ;
  tandben_nn_1_N : N ;
  tamiflu_nn_1_N : N ;
  tallium_nn_1_N : N ;
  tal_nn_2_N : N ;
  takdropp_nn_1_N : N ;
  taglingsgarn_nn_1_N : N ;
  tag_nn_2_N : N ;
  taffelland_nn_1_N : N ;
  tadel_nn_1_N : N ;
  tackjaern_nn_1_1_N : N ;
  soetsug_nn_1_1_N : N ;
  soenderfall_nn_1_1_N : N ;
  soel_nn_1_1_N : N ;
  soek_nn_1_1_N : N ;
  saekerhetstaenk_nn_1_1_N : N ;
  saekerhetsraad_nn_1_1_N : N ;
  saedesbruk_nn_1_1_N : N ;
  systerskap_nn_1_N : N ;
  syskonskap_nn_1_N : N ;
  syndetikon_nn_1_N : N ;
  svaarmod_nn_1_1_N : N ;
  svaagerskap_nn_1_1_N : N ;
  svaagerlag_nn_1_1_N : N ;
  svisch_nn_1_N : N ;
  svir_nn_1_N : N ;
  svinlaeder_nn_1_1_N : N ;
  svinblod_nn_1_N : N ;
  svenskhat_nn_1_N : N ;
  svedjebruk_nn_1_N : N ;
  svavel_nn_1_N : N ;
  svartkrut_nn_1_N : N ;
  svammel_nn_1_N : N ;
  svaj_nn_1_N : N ;
  sus_nn_1_N : N ;
  surr_nn_1_N : N ;
  superi_nn_1_N : N ;
  superfosfat_nn_1_N : N ;
  sunk_nn_1_N : N ;
  sug_nn_2_N : N ;
  sudderi_nn_1_N : N ;
  sudd_nn_2_N : N ;
  stoeveltramp_nn_1_1_N : N ;
  stoev_nn_1_1_N : N ;
  stoeldgods_nn_1_1_N : N ;
  stoek_nn_1_1_N : N ;
  staank_nn_1_1_N : N ;
  staangjaern_nn_1_1_N : N ;
  staahej_nn_1_1_N : N ;
  staerkelseklister_nn_1_1_N : N ;
  staengningsdags_nn_1_1_N : N ;
  styckverk_nn_1_N : N ;
  styckegods_nn_1_N : N ;
  studiestoed_nn_1_1_N : N ;
  studentliv_nn_1_N : N ;
  stroeveri_nn_1_1_N : N ;
  stroesocker_nn_1_1_N : N ;
  stroemningsmotstaand_nn_1_1_N : N ;
  stroebroed_nn_1_1_N : N ;
  stroe_nn_1_1_N : N ;
  straalskydd_nn_1_1_N : N ;
  straalningstryck_nn_1_1_N : N ;
  straalkastarsken_nn_1_1_N : N ;
  straalkastarljus_nn_2_1_N : N ;
  straafoder_nn_1_1_N : N ;
  stryktips_nn_1_N : N ;
  stryk_nn_1_N : N ;
  struntprat_nn_1_N : N ;
  strunt_nn_1_N : N ;
  strul_nn_1_N : N ;
  strontium_nn_1_N : N ;
  stridstummel_nn_1_N : N ;
  stridsbuller_nn_1_N : N ;
  strandskydd_nn_1_N : N ;
  storvilt_nn_1_N : N ;
  storting_nn_1_N : N ;
  stor_av_1_A : A ;
  stoj_nn_1_N : N ;
  stjaernstoff_nn_1_1_N : N ;
  stjaernkoett_nn_1_1_N : N ;
  stiftsband_nn_1_N : N ;
  stensalt_nn_1_N : N ;
  stengods_nn_1_N : N ;
  stekflaesk_nn_1_1_N : N ;
  statsverk_nn_1_N : N ;
  startkapital_nn_1_N : N ;
  stamp_nn_3_N : N ;
  stadsliv_nn_1_N : N ;
  spoeregn_nn_1_1_N : N ;
  spaeck_nn_1_1_N : N ;
  spraakbruk_nn_1_1_N : N ;
  spritmissbruk_nn_1_N : N ;
  spring_nn_1_N : N ;
  sprattel_nn_1_N : N ;
  spott_nn_1_N : N ;
  sportsmanship_nn_1_N : N ;
  sportliv_nn_1_N : N ;
  sporrstraeck_nn_1_1_N : N ;
  split_nn_1_N : N ;
  spisbroed_nn_1_1_N : N ;
  spill_nn_1_N : N ;
  specialstaal_nn_1_1_N : N ;
  spaltlaeder_nn_1_1_N : N ;
  spad_nn_1_N : N ;
  spackel_nn_1_N : N ;
  sovel_nn_1_N : N ;
  sotarspraak_nn_1_1_N : N ;
  sot_nn_1_N : N ;
  sorl_nn_1_N : N ;
  sorgmod_nn_1_N : N ;
  sommarsolstaand_nn_1_1_N : N ;
  sommarmoerker_nn_1_1_N : N ;
  sommargraes_nn_1_1_N : N ;
  solsting_nn_1_N : N ;
  solsken_nn_1_N : N ;
  solregn_nn_1_N : N ;
  solnedgaangsljus_nn_1_1_N : N ;
  solk_nn_1_N : N ;
  solgass_nn_1_N : N ;
  soldis_nn_1_N : N ;
  soldatmaterial_nn_1_N : N ;
  sojamjoel_nn_1_1_N : N ;
  sockersug_nn_1_N : N ;
  socker_nn_1_N : N ;
  snoeslask_nn_1_1_N : N ;
  snoeregn_nn_1_1_N : N ;
  snoemoegel_nn_1_1_N : N ;
  snoemos_nn_1_1_N : N ;
  snoeglopp_nn_1_1_N : N ;
  snoedrev_nn_1_1_N : N ;
  snaerp_nn_1_1_N : N ;
  snaerjgraes_nn_1_1_N : N ;
  snaerj_nn_1_1_N : N ;
  snaellod_nn_1_1_N : N ;
  snusk_nn_1_N : N ;
  snusfoernuft_nn_1_1_N : N ;
  sniff_nn_2_N : N ;
  snicksnack_nn_1_N : N ;
  snatter_nn_1_N : N ;
  snask_nn_1_N : N ;
  snapphaneri_nn_1_N : N ;
  snafs_nn_1_N : N ;
  snack_nn_1_N : N ;
  snabbsvarvstaal_nn_1_1_N : N ;
  snabbstaal_nn_1_1_N : N ;
  snabblaan_nn_1_1_N : N ;
  smoerpapper_nn_1_1_N : N ;
  smoerjfett_nn_1_1_N : N ;
  smoerj_nn_1_1_N : N ;
  smoergaaspapper_nn_1_1_N : N ;
  smaavilt_nn_1_1_N : N ;
  smaaprat_nn_1_1_N : N ;
  smaaplock_nn_1_1_N : N ;
  smaakrafs_nn_1_1_N : N ;
  smaafolk_nn_1_1_N : N ;
  smaabroed_nn_1_1_N : N ;
  smaaborgerskap_nn_1_1_N : N ;
  smaell_nn_2_1_N : N ;
  smaeck_nn_2_1_N : N ;
  smussel_nn_1_N : N ;
  smult_nn_1_N : N ;
  smuggel_nn_1_N : N ;
  smorlaeder_nn_1_1_N : N ;
  smolk_nn_1_N : N ;
  smittskydd_nn_1_N : N ;
  smisk_nn_1_N : N ;
  smidesjaern_nn_1_1_N : N ;
  smicker_nn_1_N : N ;
  smek_nn_1_N : N ;
  smatter_nn_1_N : N ;
  smask_nn_1_N : N ;
  smack_nn_2_N : N ;
  sloeseri_nn_1_1_N : N ;
  sloekorn_nn_1_1_N : N ;
  sloejfoerbud_nn_1_1_N : N ;
  sloedder_nn_1_1_N : N ;
  slaepljus_nn_1_1_N : N ;
  sludder_nn_1_N : N ;
  slit_nn_1_N : N ;
  slisk_nn_1_N : N ;
  slipstvaang_nn_1_1_N : N ;
  slidder_nn_1_N : N ;
  slaveri_nn_1_N : N ;
  slask_nn_1_N : N ;
  slarv_nn_1_N : N ;
  slams_nn_1_N : N ;
  slammer_nn_1_N : N ;
  slaktavfall_nn_1_N : N ;
  slaglod_nn_1_N : N ;
  slafs_nn_2_N : N ;
  sladder_nn_1_N : N ;
  slack_nn_1_N : N ;
  slabb_nn_1_N : N ;
  skoeldbrosk_nn_1_1_N : N ;
  skaadespeleri_nn_1_1_N : N ;
  skaadebroed_nn_1_1_N : N ;
  skaervfroe_nn_1_1_N : N ;
  skaell_nn_1_1_N : N ;
  skymningsland_nn_1_N : N ;
  skymningsdunkel_nn_1_N : N ;
  skymmel_nn_1_N : N ;
  skygd_nn_1_N : N ;
  skydd_nn_1_N : N ;
  skvalp_nn_1_N : N ;
  skvaller_nn_1_N : N ;
  skval_nn_1_N : N ;
  skumrask_nn_1_N : N ;
  skraavaesen_nn_1_1_N : N ;
  skraevel_nn_1_1_N : N ;
  skraep_nn_1_1_N : N ;
  skraeckel_nn_1_1_N : N ;
  skryt_nn_1_N : N ;
  skrot_nn_1_N : N ;
  skrock_nn_1_N : N ;
  skrivmaskinsknatter_nn_1_N : N ;
  skravel_nn_1_N : N ;
  skrap_nn_1_N : N ;
  skrammel_nn_1_N : N ;
  skotthaall_nn_1_1_N : N ;
  skoskav_nn_1_N : N ;
  skorr_nn_1_N : N ;
  skorpmjoel_nn_1_1_N : N ;
  skolvaesen_nn_1_1_N : N ;
  skolk_nn_1_N : N ;
  skogsland_nn_1_N : N ;
  skogsbryn_nn_1_N : N ;
  skogsbruk_nn_1_N : N ;
  skitsnack_nn_1_N : N ;
  skitprat_nn_1_N : N ;
  skinneri_nn_1_N : N ;
  skimmer_nn_1_N : N ;
  skiftesbruk_nn_1_N : N ;
  skattefusk_nn_1_N : N ;
  skattefiffel_nn_1_N : N ;
  skandium_nn_1_N : N ;
  skaller_nn_1_N : N ;
  skadestaandsansvar_nn_1_1_N : N ;
  sjoemanskap_nn_1_1_N : N ;
  sjoegraes_nn_1_1_N : N ;
  sjoefylleri_nn_1_1_N : N ;
  sjoefolk_nn_1_1_N : N ;
  sjoefartsverk_nn_1_1_N : N ;
  sjoebefael_nn_1_1_N : N ;
  sjoeartilleri_nn_1_1_N : N ;
  sjaa_nn_1_1_N : N ;
  sjaelvsvaald_nn_1_1_N : N ;
  sjaelvskryt_nn_1_1_N : N ;
  sjaelvkostnadspris_nn_1_1_N : N ;
  sjaelvhushaall_nn_1_1_N : N ;
  sjaelvfoersvar_nn_1_1_N : N ;
  sjaelvfoerakt_nn_1_1_N : N ;
  sjaelsliv_nn_1_1_N : N ;
  sjaelataag_nn_1_1_N : N ;
  sjuttonhundratal_nn_1_N : N ;
  sjuttital_nn_1_N : N ;
  sjuttiotal_nn_1_N : N ;
  sittflaesk_nn_1_1_N : N ;
  sis_nn_1_N : N ;
  sirp_nn_1_N : N ;
  sir_nn_1_N : N ;
  sinnestillstaand_nn_1_1_N : N ;
  sinneslugn_nn_1_N : N ;
  sinnelag_nn_1_N : N ;
  sink_nn_1_N : N ;
  simultanschack_nn_1_N : N ;
  simpelkort_nn_1_N : N ;
  silvernitrat_nn_1_N : N ;
  silverblad_nn_1_N : N ;
  sillmjoel_nn_1_1_N : N ;
  sillavfall_nn_1_N : N ;
  silkespapper_nn_1_N : N ;
  silicium_nn_1_N : N ;
  sileshaar_nn_1_1_N : N ;
  siktmjoel_nn_1_1_N : N ;
  siktdjup_nn_1_N : N ;
  signalskydd_nn_1_N : N ;
  siffertips_nn_1_N : N ;
  sidflaesk_nn_1_1_N : N ;
  sidentrae_nn_1_1_N : N ;
  siden_nn_1_N : N ;
  sexualsystem_nn_1_N : N ;
  sexualliv_nn_1_N : N ;
  sextonhundratal_nn_1_N : N ;
  sextital_nn_1_N : N ;
  sextiotal_nn_1_N : N ;
  sexmissbruk_nn_1_N : N ;
  sex_nn_1_N : N ;
  senknarr_nn_1_N : N ;
  seniorat_nn_1_N : N ;
  sendrag_nn_1_N : N ;
  segelgarn_nn_1_N : N ;
  sefirgarn_nn_1_N : N ;
  sedefoerfall_nn_1_1_N : N ;
  sedefoerdaerv_nn_1_1_N : N ;
  screentryck_nn_1_N : N ;
  schaa_nn_1_1_N : N ;
  scharlakan_nn_1_N : N ;
  schacker_nn_1_N : N ;
  schack_nn_1_N : N ;
  schabbelverk_nn_1_N : N ;
  scenuttal_nn_1_N : N ;
  sanningsserum_nn_1_N : N ;
  sanitetsporslin_nn_1_N : N ;
  sanitetsgods_nn_1_N : N ;
  sandeltrae_nn_1_1_N : N ;
  samvetstvaang_nn_1_1_N : N ;
  samtalsspraak_nn_1_1_N : N ;
  samspraak_nn_1_1_N : N ;
  samordningsansvar_nn_1_N : N ;
  samliv_nn_1_N : N ;
  samhaellsstoed_nn_1_1_N : N ;
  samhaellsmaskineri_nn_1_1_N : N ;
  samhaellsliv_nn_1_1_N : N ;
  samfoerstaand_nn_1_1_N : N ;
  sambruk_nn_1_N : N ;
  sambovaald_nn_1_1_N : N ;
  samarium_nn_1_N : N ;
  saltspad_nn_1_N : N ;
  salt_nn_1_N : N ;
  salicylsyrepulver_nn_1_N : N ;
  saktmod_nn_1_N : N ;
  saksoekeri_nn_1_1_N : N ;
  sakocker_nn_1_N : N ;
  sakfoerstaand_nn_1_1_N : N ;
  sagoskimmer_nn_1_N : N ;
  sagomjoel_nn_1_1_N : N ;
  sagg_nn_1_N : N ;
  saftfoder_nn_1_N : N ;
  sadeltryck_nn_1_N : N ;
  sabelskrammel_nn_1_N : N ;
  sabb_nn_1_N : N ;
  roevslickeri_nn_1_1_N : N ;
  roevarspraak_nn_1_1_N : N ;
  roevarliv_nn_1_1_N : N ;
  roestskolk_nn_1_1_N : N ;
  roersocker_nn_1_1_N : N ;
  roellakan_nn_1_1_N : N ;
  roelakan_nn_1_1_N : N ;
  roekverk_nn_1_1_N : N ;
  raattgift_nn_1_1_N : N ;
  raattfrat_nn_1_1_N : N ;
  raasocker_nn_1_1_N : N ;
  raasiden_nn_1_1_N : N ;
  raaris_nn_1_1_N : N ;
  raaplugg_nn_1_1_N : N ;
  raagmjoel_nn_1_1_N : N ;
  raaglas_nn_1_1_N : N ;
  raevgift_nn_1_1_N : N ;
  raettvisepatos_nn_1_1_N : N ;
  raettsvaesen_nn_1_1_N : N ;
  raettsmedicinalverk_nn_1_1_N : N ;
  raettshaveri_nn_1_1_N : N ;
  rytteri_nn_1_N : N ;
  rysslaeder_nn_1_1_N : N ;
  rysshat_nn_1_N : N ;
  rymdskrot_nn_1_N : N ;
  rymdgrus_nn_1_N : N ;
  rutenium_nn_1_N : N ;
  rusk_nn_1_N : N ;
  runtknulleri_nn_1_N : N ;
  rundsnack_nn_1_N : N ;
  rummel_nn_1_N : N ;
  rufs_nn_1_N : N ;
  ruffel_nn_1_N : N ;
  rubinglas_nn_1_N : N ;
  rubidium_nn_1_N : N ;
  rottryck_nn_1_N : N ;
  rotmos_nn_1_N : N ;
  rotenon_nn_1_N : N ;
  rosentrae_nn_1_1_N : N ;
  ros_nn_2_N : N ;
  rodium_nn_1_N : N ;
  rivebroed_nn_1_1_N : N ;
  riv_nn_1_N : N ;
  ritsch_nn_1_N : N ;
  rispapper_nn_1_N : N ;
  riskkapital_nn_1_N : N ;
  risbraennvin_nn_1_1_N : N ;
  ris_nn_2_N : N ;
  ring_nn_2_N : N ;
  rindlaeder_nn_1_1_N : N ;
  rimmeri_nn_1_N : N ;
  rikssvaerd_nn_1_1_N : N ;
  riksplan_nn_1_N : N ;
  riksmaal_nn_1_1_N : N ;
  ridderskap_nn_1_N : N ;
  rhenium_nn_1_N : N ;
  resgods_nn_1_N : N ;
  reptrick_nn_1_N : N ;
  representanthus_nn_1_N : N ;
  renomm_e_nn_1_1_N : N ;
  renkoett_nn_1_1_N : N ;
  realgenus_nn_1_N : N ;
  rayon_nn_1_N : N ;
  rattfylleri_nn_1_N : N ;
  rassel_nn_1_N : N ;
  rasp_nn_2_N : N ;
  rashat_nn_1_N : N ;
  raseri_nn_1_N : N ;
  rampljus_nn_1_N : N ;
  rakloedder_nn_1_1_N : N ;
  rajgraes_nn_1_1_N : N ;
  raffel_nn_1_N : N ;
  radium_nn_1_N : N ;
  radiokol_nn_1_N : N ;
  radiobrus_nn_1_N : N ;
  rabbel_nn_1_N : N ;
  rabalder_nn_1_N : N ;
  paat_nn_1_1_N : N ;
  paaskris_nn_1_1_N : N ;
  paaskpyssel_nn_1_1_N : N ;
  paahaeng_nn_1_1_N : N ;
  paabroed_nn_1_1_N : N ;
  paabraa_nn_1_1_N : N ;
  paerlsocker_nn_1_1_N : N ;
  paerlgarn_nn_1_1_N : N ;
  paelsverk_nn_1_1_N : N ;
  pyssel_nn_1_N : N ;
  pynt_nn_1_N : N ;
  pyngel_nn_1_N : N ;
  putter_nn_1_N : N ;
  punktalglas_nn_1_N : N ;
  pulsval_nn_1_N : N ;
  pudersocker_nn_1_N : N ;
  puder_nn_1_N : N ;
  puckel_nn_2_N : N ;
  publiktryck_nn_1_N : N ;
  publikhav_nn_1_N : N ;
  pubeshaar_nn_1_1_N : N ;
  proejs_nn_1_1_N : N ;
  praal_nn_1_1_N : N ;
  praeststaand_nn_1_1_N : N ;
  praestestaand_nn_1_1_N : N ;
  praesterskap_nn_1_1_N : N ;
  prygel_nn_1_N : N ;
  pryderi_nn_1_N : N ;
  prunk_nn_1_N : N ;
  protokoll_nn_2_N : N ;
  protaktinium_nn_1_N : N ;
  prometium_nn_1_N : N ;
  promenadavstaand_nn_1_1_N : N ;
  proletariat_nn_1_N : N ;
  progesteron_nn_1_N : N ;
  profiljaern_nn_1_1_N : N ;
  procenteri_nn_1_N : N ;
  privatliv_nn_1_N : N ;
  pris_nn_2_N : N ;
  primat_nn_1_N : N ;
  preusseri_nn_1_N : N ;
  presstoed_nn_1_1_N : N ;
  pressglas_nn_1_N : N ;
  pressfoder_nn_1_N : N ;
  presidentmaterial_nn_1_N : N ;
  prejeri_nn_1_N : N ;
  pratbehov_nn_1_N : N ;
  prassel_nn_1_N : N ;
  praseodym_nn_1_N : N ;
  potatismos_nn_1_N : N ;
  potatismjoel_nn_1_1_N : N ;
  potatisbraennvin_nn_1_1_N : N ;
  porl_nn_1_N : N ;
  polonium_nn_1_N : N ;
  pollen_nn_1_N : N ;
  polkahaar_nn_1_1_N : N ;
  politikerfoerakt_nn_1_1_N : N ;
  polertrassel_nn_1_N : N ;
  polarsken_nn_1_N : N ;
  pock_nn_1_N : N ;
  plaatskrammel_nn_1_1_N : N ;
  plutonium_nn_1_N : N ;
  plut_nn_1_N : N ;
  plurr_nn_1_N : N ;
  plotter_nn_1_N : N ;
  plommonbraennvin_nn_1_1_N : N ;
  plock_nn_1_N : N ;
  plit_nn_1_N : N ;
  plexiglas_nn_1_N : N ;
  plask_nn_1_N : N ;
  plantryck_nn_1_N : N ;
  pladder_nn_1_N : N ;
  pjunk_nn_1_N : N ;
  pjosk_nn_1_N : N ;
  pjoller_nn_1_N : N ;
  piss_nn_1_N : N ;
  pisk_nn_1_N : N ;
  pipverk_nn_1_N : N ;
  pink_nn_1_N : N ;
  pingel_nn_1_N : N ;
  pill_nn_1_N : N ;
  pilgift_nn_1_N : N ;
  pet_nn_1_N : N ;
  personalbehov_nn_1_N : N ;
  personalansvar_nn_1_N : N ;
  persiljesmoer_nn_1_1_N : N ;
  perihelium_nn_1_N : N ;
  perigeum_nn_1_N : N ;
  pentylpulver_nn_1_N : N ;
  penningvaesen_nn_1_1_N : N ;
  penninglotteri_nn_1_N : N ;
  penninggraes_nn_1_1_N : N ;
  pengaslarv_nn_1_N : N ;
  penetrationstvaang_nn_1_1_N : N ;
  peneplan_nn_1_N : N ;
  pdf_format_nn_1_N : N ;
  patriarkskaegg_nn_1_1_N : N ;
  patrask_nn_1_N : N ;
  patos_nn_1_N : N ;
  passtvaang_nn_1_1_N : N ;
  partistoed_nn_1_1_N : N ;
  pariserliv_nn_1_N : N ;
  parenkym_nn_1_N : N ;
  parallellaxiom_nn_1_N : N ;
  pampasgraes_nn_1_1_N : N ;
  palmfett_nn_1_N : N ;
  palladium_nn_1_N : N ;
  paketgods_nn_1_N : N ;
  pack_nn_1_N : N ;
  oxygen_nn_1_N : N ;
  oxlaeder_nn_1_1_N : N ;
  oxkoett_nn_1_1_N : N ;
  oxblod_nn_1_N : N ;
  ovaesen_nn_1_1_N : N ;
  ovett_nn_1_N : N ;
  ovanlaeder_nn_1_1_N : N ;
  otyg_nn_1_N : N ;
  otium_nn_1_N : N ;
  otack_nn_1_N : N ;
  osmium_nn_1_N : N ;
  os_nn_1_N : N ;
  ormspott_nn_1_N : N ;
  ormserum_nn_1_N : N ;
  ormetter_nn_1_N : N ;
  orlov_nn_1_N : N ;
  ordbajs_nn_1_N : N ;
  oralsex_nn_1_N : N ;
  orakelspraak_nn_1_1_N : N ;
  opris_nn_1_N : N ;
  opptag_nn_1_N : N ;
  opium_nn_1_N : N ;
  opalglas_nn_1_N : N ;
  omland_nn_1_N : N ;
  omfaang_nn_1_1_N : N ;
  omak_nn_1_N : N ;
  oljetyg_nn_1_N : N ;
  oljespill_nn_1_N : N ;
  oljepapper_nn_1_N : N ;
  oljekraftfoder_nn_1_N : N ;
  oljegrus_nn_1_N : N ;
  oktogen_nn_1_N : N ;
  oknytt_nn_1_N : N ;
  oidipuskomplex_nn_1_N : N ;
  ohaegn_nn_1_1_N : N ;
  ograes_nn_1_1_N : N ;
  ofoerstaand_nn_1_1_N : N ;
  ofoernuft_nn_1_1_N : N ;
  oflyt_nn_1_N : N ;
  odelsting_nn_1_N : N ;
  ocker_nn_1_N : N ;
  noetkoett_nn_1_1_N : N ;
  noethaar_nn_1_1_N : N ;
  noetfnas_nn_1_1_N : N ;
  noejesliv_nn_1_1_N : N ;
  noedtvaang_nn_1_1_N : N ;
  naadebroed_nn_1_1_N : N ;
  naethat_nn_1_1_N : N ;
  naesblod_nn_1_1_N : N ;
  naeringsliv_nn_1_1_N : N ;
  naerfoersvar_nn_1_1_N : N ;
  nyspulver_nn_1_N : N ;
  nysilver_nn_1_N : N ;
  nys_nn_1_N : N ;
  nylatin_nn_1_N : N ;
  nyhetsmakeri_nn_1_N : N ;
  nu_nn_1_N : N ;
  novembermoerker_nn_1_1_N : N ;
  norrsken_nn_1_N : N ;
  normaltryck_nn_1_N : N ;
  nomadliv_nn_1_N : N ;
  nollnolltal_nn_1_N : N ;
  nollnoll_tal_nn_1_N : N ;
  nojs_nn_1_N : N ;
  nobelium_nn_1_N : N ;
  nittonhundraaattiotal_nn_1_1_N : N ;
  nittonhundratrettiotal_nn_1_N : N ;
  nittonhundratjugotal_nn_1_N : N ;
  nittonhundratiotal_nn_1_N : N ;
  nittonhundratal_nn_1_N : N ;
  nittonhundrasjuttiotal_nn_1_N : N ;
  nittonhundrasextiotal_nn_1_N : N ;
  nittonhundranittiotal_nn_1_N : N ;
  nittonhundrafyrtiotal_nn_1_N : N ;
  nittonhundrafemtiotal_nn_1_N : N ;
  nittital_nn_1_N : N ;
  nittiotal_nn_1_N : N ;
  nitrogen_nn_1_N : N ;
  nitrerstaal_nn_1_1_N : N ;
  nit_nn_1_N : N ;
  nickelstaal_nn_1_1_N : N ;
  nickelkromstaal_nn_1_1_N : N ;
  neurosedyn_nn_1_N : N ;
  neptunium_nn_1_N : N ;
  neon_nn_1_N : N ;
  negerkorn_nn_1_N : N ;
  negerblod_nn_1_N : N ;
  naturtrae_nn_1_1_N : N ;
  naturskydd_nn_1_N : N ;
  naturliv_nn_1_N : N ;
  nattsudd_nn_1_N : N ;
  nattmoerker_nn_1_1_N : N ;
  nattlogi_nn_1_N : N ;
  nattliv_nn_1_N : N ;
  natronglas_nn_1_N : N ;
  natron_nn_1_N : N ;
  natrium_nn_1_N : N ;
  namnblaeck_nn_1_1_N : N ;
  namnam_nn_1_N : N ;
  naketmaaleri_nn_1_1_N : N ;
  nageltraang_nn_1_1_N : N ;
  nackhaar_nn_1_1_N : N ;
  nabolag_nn_1_N : N ;
  moessparti_nn_1_1_N : N ;
  moegel_nn_1_1_N : N ;
  maansken_nn_1_1_N : N ;
  maanljus_nn_1_1_N : N ;
  maangsyssleri_nn_1_1_N : N ;
  maangskriveri_nn_1_1_N : N ;
  maangleri_nn_1_1_N : N ;
  maangguderi_nn_1_1_N : N ;
  maaltidstvaang_nn_1_1_N : N ;
  maalbrott_nn_1_1_N : N ;
  maessingsblaenk_nn_1_1_N : N ;
  maerkblaeck_nn_1_1_N : N ;
  maenniskomaterial_nn_1_1_N : N ;
  maenniskofoerakt_nn_1_1_N : N ;
  maenniskoblod_nn_1_1_N : N ;
  myxoedem_nn_1_1_N : N ;
  myogen_nn_1_N : N ;
  myntvaesen_nn_1_1_N : N ;
  myndighetssnack_nn_1_N : N ;
  myller_nn_1_N : N ;
  mygel_nn_1_N : N ;
  musivguld_nn_1_N : N ;
  murr_nn_1_N : N ;
  murbruk_nn_1_N : N ;
  munklatin_nn_1_N : N ;
  mummel_nn_1_N : N ;
  muller_nn_1_N : N ;
  mudder_nn_1_N : N ;
  moulin_egarn_nn_1_1_N : N ;
  mottryck_nn_1_N : N ;
  motorbuller_nn_1_N : N ;
  motljus_nn_1_N : N ;
  mos_nn_1_N : N ;
  morsealfabet_nn_1_N : N ;
  morr_nn_1_N : N ;
  morgonhumoer_nn_1_1_N : N ;
  moras_nn_2_N : N ;
  monopol_nn_2_N : N ;
  mollskinn_nn_1_N : N ;
  moj_nn_1_N : N ;
  moderskap_nn_1_N : N ;
  mod_nn_1_N : N ;
  mobilprat_nn_1_N : N ;
  mjoelksocker_nn_1_1_N : N ;
  mjoelkglas_nn_1_1_N : N ;
  mjoelkfett_nn_1_1_N : N ;
  mjoeldamm_nn_1_1_N : N ;
  mjoed_nn_1_1_N : N ;
  mjuklod_nn_1_N : N ;
  missmod_nn_1_N : N ;
  misshumoer_nn_1_1_N : N ;
  misshag_nn_1_N : N ;
  mischmasch_nn_1_N : N ;
  minoritetsfoertryck_nn_1_1_N : N ;
  minnesstoed_nn_1_1_N : N ;
  miljoevaern_nn_1_1_N : N ;
  migrationsverk_nn_1_N : N ;
  middagsvett_nn_1_N : N ;
  meteorstoft_nn_1_N : N ;
  metadon_nn_1_N : N ;
  messmoer_nn_1_1_N : N ;
  mendelevium_nn_1_N : N ;
  mellanguld_nn_1_N : N ;
  medloeperi_nn_1_1_N : N ;
  medieetablissemang_nn_1_N : N ;
  medhaall_nn_1_1_N : N ;
  medeltidslatin_nn_1_N : N ;
  medansvar_nn_1_N : N ;
  max_nn_1_N : N ;
  matsvinn_nn_1_N : N ;
  matsmoer_nn_1_1_N : N ;
  matsilver_nn_1_N : N ;
  matriarkat_nn_1_N : N ;
  matos_nn_1_N : N ;
  matklet_nn_1_N : N ;
  matavfall_nn_1_N : N ;
  maskfrat_nn_1_N : N ;
  marskland_nn_1_N : N ;
  marknadsgyckel_nn_1_N : N ;
  margraes_nn_1_1_N : N ;
  manschettproletariat_nn_1_N : N ;
  mannamod_nn_1_N : N ;
  mannagraes_nn_1_1_N : N ;
  maltsocker_nn_1_N : N ;
  maktspraak_nn_1_1_N : N ;
  maktmissbruk_nn_1_N : N ;
  maktbegaer_nn_1_1_N : N ;
  majsmjoel_nn_1_1_N : N ;
  majoritetsfoertryck_nn_1_1_N : N ;
  magnesium_nn_1_N : N ;
  magknip_nn_1_N : N ;
  mackel_nn_1_N : N ;
  loevtrae_nn_1_1_N : N ;
  loevsly_nn_1_1_N : N ;
  loesgodis_nn_1_1_N : N ;
  loerdagsgodis_nn_1_1_N : N ;
  loedder_nn_1_1_N : N ;
  loed_nn_1_1_N : N ;
  laangmod_nn_1_1_N : N ;
  laang_av_1_1_A : A ;
  laagland_nn_1_1_N : N ;
  laag_av_1_1_A : A ;
  laettspackel_nn_1_1_N : N ;
  laess_nn_1_1_N : N ;
  laeskeblask_nn_1_1_N : N ;
  laeseri_nn_1_1_N : N ;
  laerktrae_nn_1_1_N : N ;
  laerjungaskap_nn_1_1_N : N ;
  laensvaesen_nn_1_1_N : N ;
  laektarvaald_nn_1_1_N : N ;
  laekkoett_nn_1_1_N : N ;
  laekarslarv_nn_1_1_N : N ;
  laegerliv_nn_1_1_N : N ;
  laeder_nn_1_1_N : N ;
  ly_nn_1_N : N ;
  lutetium_nn_1_N : N ;
  lungmos_nn_1_N : N ;
  lumppapper_nn_1_N : N ;
  lullull_nn_1_N : N ;
  luktsalt_nn_1_N : N ;
  lugn_nn_1_N : N ;
  luftmotstaand_nn_1_1_N : N ;
  luftfoersvar_nn_1_1_N : N ;
  luffarschack_nn_1_N : N ;
  lov_nn_4_N : N ;
  lokalfoersvar_nn_1_1_N : N ;
  loden_nn_1_N : N ;
  ljusskimmer_nn_1_N : N ;
  ljusglitter_nn_1_N : N ;
  ljusdunkel_nn_1_N : N ;
  ljug_nn_1_N : N ;
  livsmod_nn_1_N : N ;
  livsmedelsverk_nn_1_N : N ;
  livsmedelsavfall_nn_1_N : N ;
  litium_nn_1_N : N ;
  lismeri_nn_1_N : N ;
  lir_nn_1_N : N ;
  linjeflyg_nn_1_N : N ;
  lingonris_nn_1_N : N ;
  lin_nn_1_N : N ;
  liggegods_nn_1_N : N ;
  levnadsvett_nn_1_N : N ;
  levebroed_nn_1_1_N : N ;
  lergods_nn_1_N : N ;
  lekmannafoerstaand_nn_1_1_N : N ;
  ledarskap_nn_1_N : N ;
  laurentium_nn_1_N : N ;
  latin_nn_1_N : N ;
  larv_nn_2_N : N ;
  lantsmoer_nn_1_1_N : N ;
  lantmannaparti_nn_1_N : N ;
  land_nn_3_N : N ;
  lammkoett_nn_1_1_N : N ;
  lamelltrae_nn_1_1_N : N ;
  lafs_nn_1_N : N ;
  koettvilt_nn_1_1_N : N ;
  koettklister_nn_1_1_N : N ;
  koettberg_nn_1_1_N : N ;
  koettben_nn_2_1_N : N ;
  koett_nn_1_1_N : N ;
  koersbaerstrae_nn_1_1_N : N ;
  koensliv_nn_1_1_N : N ;
  koenshaar_nn_1_1_N : N ;
  koekslatin_nn_1_1_N : N ;
  koeksavfall_nn_1_1_N : N ;
  kaalsuperi_nn_1_1_N : N ;
  kaex_nn_2_1_N : N ;
  kaernvetemjoel_nn_1_1_N : N ;
  kaernkraftsmotstaand_nn_1_1_N : N ;
  kaernkraftsavfall_nn_1_1_N : N ;
  kaernbraensleavfall_nn_1_1_N : N ;
  kaerleksliv_nn_1_1_N : N ;
  kaerleksgnabb_nn_1_1_N : N ;
  kaeringprat_nn_1_1_N : N ;
  kaenslopjunk_nn_1_1_N : N ;
  kaensloliv_nn_1_1_N : N ;
  kaendisskap_nn_1_1_N : N ;
  kaempahumoer_nn_1_1_N : N ;
  kaelt_nn_1_1_N : N ;
  kaek_nn_1_1_N : N ;
  kaebbleri_nn_1_1_N : N ;
  kaebbel_nn_1_1_N : N ;
  kyrksilver_nn_1_N : N ;
  kyrkolatin_nn_1_N : N ;
  kvitter_nn_1_N : N ;
  kvinnovaald_nn_1_1_N : N ;
  kvinnospraak_nn_1_1_N : N ;
  kvinnokoen_nn_1_1_N : N ;
  kvinnohat_nn_1_N : N ;
  kvinnofoertryck_nn_1_1_N : N ;
  kvicksilver_nn_1_N : N ;
  kvickdrag_nn_1_N : N ;
  kvalm_nn_1_N : N ;
  kutter_nn_1_N : N ;
  kustland_nn_1_N : N ;
  kustklimat_nn_1_N : N ;
  kustband_nn_1_N : N ;
  kustartilleri_nn_1_N : N ;
  kurr_nn_1_N : N ;
  kunskapsbegaer_nn_1_1_N : N ;
  kulturliv_nn_1_N : N ;
  kulturfoerakt_nn_1_1_N : N ;
  kucku_nn_1_N : N ;
  kuckeliku_nn_1_N : N ;
  kuckel_nn_1_N : N ;
  kubikmaatt_nn_1_1_N : N ;
  kroesamos_nn_1_1_N : N ;
  kroeneri_nn_1_1_N : N ;
  kraas_nn_1_1_N : N ;
  kraangel_nn_1_1_N : N ;
  kraeks_nn_1_1_N : N ;
  kraeftsmoer_nn_1_1_N : N ;
  kryddsalt_nn_1_N : N ;
  krut_nn_1_N : N ;
  krus_nn_2_N : N ;
  krullhaar_nn_1_1_N : N ;
  krull_nn_1_N : N ;
  krubb_nn_1_N : N ;
  kross_nn_2_N : N ;
  kroppsspraak_nn_1_1_N : N ;
  kroppshaar_nn_1_1_N : N ;
  kroppsfoerakt_nn_1_1_N : N ;
  kromlaeder_nn_1_1_N : N ;
  krogsorl_nn_1_N : N ;
  kringsnack_nn_1_N : N ;
  krimskrams_nn_1_N : N ;
  krigsvaesen_nn_1_1_N : N ;
  krigskontraband_nn_1_N : N ;
  kreditvaesen_nn_1_1_N : N ;
  kras_nn_1_N : N ;
  krams_nn_1_N : N ;
  kram_nn_2_N : N ;
  kraftspraak_nn_1_1_N : N ;
  kraftpapper_nn_1_N : N ;
  krafs_nn_1_N : N ;
  krabbasnaar_nn_1_1_N : N ;
  korsdrag_nn_1_N : N ;
  korridorsnack_nn_1_N : N ;
  kontrollbehov_nn_1_N : N ;
  kontraband_nn_1_N : N ;
  kontinentalklimat_nn_1_N : N ;
  kontaktbehov_nn_1_N : N ;
  konsumtionsfrosseri_nn_1_N : N ;
  konsum_nn_1_N : N ;
  konstsiden_nn_1_N : N ;
  konstnaerskap_nn_1_1_N : N ;
  konstlaeder_nn_1_1_N : N ;
  konstklotter_nn_1_N : N ;
  konstglas_nn_1_N : N ;
  konsistensfett_nn_1_N : N ;
  konkurrensverk_nn_1_N : N ;
  komp_nn_1_N : N ;
  komissbroed_nn_1_1_N : N ;
  komihaag_nn_1_1_N : N ;
  kolos_nn_1_N : N ;
  kolmoerker_nn_1_1_N : N ;
  kolifej_nn_1_N : N ;
  koksalt_nn_1_N : N ;
  kokoshaar_nn_1_1_N : N ;
  kokosfett_nn_1_N : N ;
  kokkoett_nn_1_1_N : N ;
  knaap_nn_1_1_N : N ;
  knussel_nn_1_N : N ;
  know_how_nn_1_N : N ;
  knotter_nn_1_N : N ;
  knot_nn_2_N : N ;
  knorr_nn_2_N : N ;
  knivavstaand_nn_1_1_N : N ;
  knitter_nn_1_N : N ;
  knirr_nn_1_N : N ;
  knirk_nn_1_N : N ;
  knatter_nn_1_N : N ;
  knaster_nn_1_N : N ;
  knarr_nn_1_N : N ;
  knark_nn_1_N : N ;
  knallpulver_nn_1_N : N ;
  knallkvicksilver_nn_1_N : N ;
  knak_nn_1_N : N ;
  kloes_nn_1_1_N : N ;
  klaaperi_nn_1_1_N : N ;
  klaemkaeckhet_nn_1_1_N : N ;
  kludderi_nn_1_N : N ;
  kludder_nn_1_N : N ;
  kludd_nn_1_N : N ;
  kluck_nn_1_N : N ;
  klotter_nn_1_N : N ;
  klokskap_nn_1_N : N ;
  klister_nn_1_N : N ;
  klirr_nn_1_N : N ;
  klipulver_nn_1_N : N ;
  klink_nn_2_N : N ;
  kling_nn_1_N : N ;
  klimatavtryck_nn_1_N : N ;
  klifs_nn_1_N : N ;
  klibb_nn_1_N : N ;
  kli_nn_1_N : N ;
  klet_nn_1_N : N ;
  kleresi_nn_1_N : N ;
  klenmod_nn_1_N : N ;
  klasstryk_nn_1_N : N ;
  klasshat_nn_1_N : N ;
  klarspraak_nn_1_1_N : N ;
  klapper_nn_1_N : N ;
  klank_nn_1_N : N ;
  klander_nn_1_N : N ;
  klamp_nn_2_N : N ;
  klafs_nn_1_N : N ;
  kladd_nn_2_N : N ;
  klabb_nn_2_N : N ;
  kiv_nn_1_N : N ;
  kitt_nn_1_N : N ;
  kiss_nn_1_N : N ;
  kiseldamm_nn_1_N : N ;
  kink_nn_2_N : N ;
  kinaschack_nn_1_N : N ;
  kel_nn_1_N : N ;
  kaveldun_nn_1_N : N ;
  kattsilver_nn_1_N : N ;
  kattguld_nn_1_N : N ;
  kassaklirr_nn_1_N : N ;
  karlsbadersalt_nn_1_N : N ;
  kardgarn_nn_1_N : N ;
  karborundum_nn_1_N : N ;
  karbonsystem_nn_1_N : N ;
  kaos_nn_1_N : N ;
  kanslispraak_nn_1_1_N : N ;
  kanslihus_nn_1_N : N ;
  kandisocker_nn_1_N : N ;
  kanariegraes_nn_1_1_N : N ;
  kamratskap_nn_1_N : N ;
  kamgarn_nn_1_N : N ;
  kamferliniment_nn_1_N : N ;
  kamelhaar_nn_1_1_N : N ;
  kamelgarn_nn_1_N : N ;
  kamaraderi_nn_1_N : N ;
  kalvkoett_nn_1_1_N : N ;
  kallprat_nn_1_N : N ;
  kalkstroe_nn_1_1_N : N ;
  kalkonkoett_nn_1_1_N : N ;
  kalkmjoel_nn_1_1_N : N ;
  kalkljus_nn_1_N : N ;
  kaliumpermanganat_nn_1_N : N ;
  kaliumnitrat_nn_1_N : N ;
  kaliumkarbonat_nn_1_N : N ;
  kalium_nn_1_N : N ;
  kalciumkarbonat_nn_1_N : N ;
  kalciumfosfat_nn_1_N : N ;
  kalcium_nn_1_N : N ;
  kakaosmoer_nn_1_1_N : N ;
  kakaopulver_nn_1_N : N ;
  kakaofett_nn_1_N : N ;
  kafferkorn_nn_1_N : N ;
  kaffedopp_nn_1_N : N ;
  kaffebroed_nn_1_1_N : N ;
  kadmium_nn_1_N : N ;
  kadettyg_nn_1_N : N ;
  kackel_nn_1_N : N ;
  kackalorum_nn_1_N : N ;
  kabintryck_nn_1_N : N ;
  jaestgrums_nn_1_1_N : N ;
  jaesfoder_nn_1_1_N : N ;
  jaernskrot_nn_1_1_N : N ;
  jaernpulver_nn_1_1_N : N ;
  jaernkitt_nn_1_1_N : N ;
  jaemnmod_nn_1_1_N : N ;
  jaekt_nn_1_1_N : N ;
  jungfruvax_nn_1_N : N ;
  jungfrustaand_nn_1_1_N : N ;
  jungfrulin_nn_1_N : N ;
  juloel_nn_1_1_N : N ;
  julpyssel_nn_1_N : N ;
  judehat_nn_1_N : N ;
  judafolk_nn_1_N : N ;
  jubel_nn_1_N : N ;
  jox_nn_1_N : N ;
  jordvax_nn_1_N : N ;
  jordslag_nn_1_N : N ;
  jordsken_nn_1_N : N ;
  jordnoetssmoer_nn_1_1_N : N ;
  jordklot_nn_1_N : N ;
  jordeliv_nn_1_N : N ;
  jordbeck_nn_1_N : N ;
  joller_nn_1_N : N ;
  johannesbroed_nn_1_1_N : N ;
  joddel_nn_1_N : N ;
  jidder_nn_1_N : N ;
  jam_nn_1_N : N ;
  jaktflyg_nn_1_N : N ;
  isterflott_nn_1_N : N ;
  ister_nn_1_N : N ;
  iridium_nn_1_N : N ;
  invertsocker_nn_1_N : N ;
  intraang_nn_1_1_N : N ;
  interferon_nn_1_N : N ;
  integritetsskydd_nn_1_N : N ;
  instinktliv_nn_1_N : N ;
  inrikesflyg_nn_1_N : N ;
  inresefoerbud_nn_1_1_N : N ;
  inomhusbruk_nn_1_N : N ;
  innebruk_nn_1_N : N ;
  inlandsklimat_nn_1_N : N ;
  inland_nn_1_N : N ;
  inkraam_nn_1_1_N : N ;
  inkafolk_nn_1_N : N ;
  ingenmansland_nn_1_N : N ;
  infanteri_nn_1_N : N ;
  indium_nn_1_N : N ;
  indianliv_nn_1_N : N ;
  indelningsverk_nn_1_N : N ;
  immunfoersvar_nn_1_1_N : N ;
  ilgods_nn_1_N : N ;
  igelkottsfoersvar_nn_1_1_N : N ;
  ickevaald_nn_1_1_N : N ;
  icke_vaald_nn_1_1_N : N ;
  hoestrusk_nn_1_1_N : N ;
  hoestmoerker_nn_1_1_N : N ;
  hoestbruk_nn_1_1_N : N ;
  hoegvilt_nn_1_1_N : N ;
  hoegsommarljus_nn_1_1_N : N ;
  hoegmod_nn_1_1_N : N ;
  hoeg_av_1_1_A : A ;
  hoeftmaatt_nn_1_1_N : N ;
  hoe_nn_1_1_N : N ;
  haardlod_nn_1_1_N : N ;
  haardbly_nn_1_1_N : N ;
  haarburr_nn_1_1_N : N ;
  haaravfall_nn_1_1_N : N ;
  haar_nn_1_1_N : N ;
  haangel_nn_1_1_N : N ;
  haan_nn_1_1_N : N ;
  haaltegel_nn_1_1_N : N ;
  haestbajs_nn_1_1_N : N ;
  haeng_nn_1_1_N : N ;
  haemndbegaer_nn_1_1_N : N ;
  haelsotillstaand_nn_1_1_N : N ;
  haelsoskydd_nn_1_1_N : N ;
  haelleberg_nn_1_1_N : N ;
  haegn_nn_1_1_N : N ;
  hysch_hysch_nn_1_N : N ;
  hyckel_nn_1_N : N ;
  huvudtryck_nn_1_N : N ;
  huvudmannaskap_nn_1_N : N ;
  huvudbry_nn_1_N : N ;
  huvudansvar_nn_1_N : N ;
  huttleri_nn_1_N : N ;
  husmansfolk_nn_1_N : N ;
  hushaallspapper_nn_1_1_N : N ;
  husfolk_nn_1_N : N ;
  husbondfolk_nn_1_N : N ;
  hundliv_nn_1_N : N ;
  hundbajs_nn_1_N : N ;
  hull_nn_1_N : N ;
  hornlager_nn_1_N : N ;
  hormoslyr_nn_1_N : N ;
  hor_nn_1_N : N ;
  hopplock_nn_1_N : N ;
  honkoen_nn_1_1_N : N ;
  homosex_nn_1_N : N ;
  holmium_nn_1_N : N ;
  hokuspokus_nn_1_N : N ;
  hjaertflimmer_nn_1_1_N : N ;
  hjaertelag_nn_2_1_N : N ;
  hjaerteblod_nn_1_1_N : N ;
  hjaertblod_nn_1_1_N : N ;
  hjaeltemod_nn_1_1_N : N ;
  hjaelmtvaang_nn_1_1_N : N ;
  hjorthornssalt_nn_1_N : N ;
  hittegods_nn_1_N : N ;
  historiemaaleri_nn_1_1_N : N ;
  himlavalv_nn_1_N : N ;
  heterosex_nn_1_N : N ;
  hemmaliv_nn_1_N : N ;
  hemmabruk_nn_1_N : N ;
  hemliv_nn_1_N : N ;
  helaar_nn_1_1_N : N ;
  helium_nn_1_N : N ;
  helikopterbuller_nn_1_N : N ;
  havssalt_nn_1_N : N ;
  havsklimat_nn_1_N : N ;
  havsglitter_nn_1_N : N ;
  havsbryn_nn_1_N : N ;
  havsbrus_nn_1_N : N ;
  havsband_nn_1_N : N ;
  havremjoel_nn_1_1_N : N ;
  hattparti_nn_1_N : N ;
  hat_nn_1_N : N ;
  hankoen_nn_1_1_N : N ;
  handlag_nn_1_N : N ;
  hamburgerkoett_nn_1_1_N : N ;
  halvsiden_nn_1_N : N ;
  halvmoerker_nn_1_1_N : N ;
  halvdunkel_nn_1_N : N ;
  hallaa_nn_1_1_N : N ;
  haikuformat_nn_1_N : N ;
  hafs_nn_1_N : N ;
  hafnium_nn_1_N : N ;
  habegaer_nn_1_1_N : N ;
  gaardsfolk_nn_1_1_N : N ;
  gytter_nn_1_N : N ;
  gyllenlaeder_nn_1_1_N : N ;
  gyckel_nn_1_N : N ;
  gurkmejpapper_nn_1_N : N ;
  gung_nn_1_N : N ;
  gullris_nn_1_N : N ;
  gullregn_nn_1_N : N ;
  guldregn_nn_1_N : N ;
  groenmoegel_nn_1_1_N : N ;
  groengraes_nn_1_1_N : N ;
  groenfoder_nn_1_1_N : N ;
  graaverk_nn_1_1_N : N ;
  graapapper_nn_1_1_N : N ;
  graadask_nn_1_1_N : N ;
  graaberg_nn_1_1_N : N ;
  graeddvisp_nn_2_1_N : N ;
  gryningsljus_nn_1_N : N ;
  grymt_nn_1_N : N ;
  gry_nn_1_N : N ;
  grus_nn_1_N : N ;
  grupptryck_nn_1_N : N ;
  gruppsex_nn_1_N : N ;
  grundkapital_nn_1_N : N ;
  grums_nn_1_N : N ;
  grummel_nn_1_N : N ;
  grubbel_nn_1_N : N ;
  grovspackel_nn_1_N : N ;
  grovsalt_nn_1_N : N ;
  grovfoder_nn_1_N : N ;
  grov_av_1_A : A ;
  groll_nn_1_N : N ;
  grodspott_nn_1_N : N ;
  grodperspektiv_nn_1_N : N ;
  grenverk_nn_1_N : N ;
  grejs_nn_1_N : N ;
  gravgods_nn_1_N : N ;
  gravallvar_nn_1_N : N ;
  granulom_nn_1_N : N ;
  granpollen_nn_1_N : N ;
  grannelag_nn_1_N : N ;
  grann_nn_1_N : N ;
  grand_nn_1_N : N ;
  grahamsmjoel_nn_1_1_N : N ;
  gottis_nn_1_N : N ;
  gorr_nn_1_N : N ;
  golvdrag_nn_1_N : N ;
  godis_nn_1_N : N ;
  godemanskap_nn_1_N : N ;
  gnoel_nn_1_1_N : N ;
  gnaell_nn_1_1_N : N ;
  gnaegg_nn_1_1_N : N ;
  gny_nn_1_N : N ;
  gnistregn_nn_1_N : N ;
  gnissel_nn_1_N : N ;
  gnideri_nn_1_N : N ;
  gnat_nn_1_N : N ;
  gnag_nn_1_N : N ;
  gloedljus_nn_1_1_N : N ;
  glaefs_nn_1_1_N : N ;
  glykogen_nn_1_N : N ;
  glycerylnitrat_nn_1_N : N ;
  gluten_nn_1_N : N ;
  glopp_nn_1_N : N ;
  glittertryck_nn_1_N : N ;
  glitter_nn_1_N : N ;
  glimmer_nn_2_N : N ;
  glimljus_nn_1_N : N ;
  glaukom_nn_1_N : N ;
  glaubersalt_nn_1_N : N ;
  glasmaaleri_nn_1_1_N : N ;
  glanssot_nn_1_N : N ;
  gjutstaal_nn_1_1_N : N ;
  gjutjaern_nn_1_1_N : N ;
  gjutgods_nn_1_N : N ;
  gipsmurbruk_nn_1_N : N ;
  gipsbruk_nn_1_N : N ;
  germanium_nn_1_N : N ;
  gepaeck_nn_1_1_N : N ;
  gentlemannablod_nn_1_N : N ;
  gensvar_nn_1_N : N ;
  genljud_nn_1_N : N ;
  generalitet_nn_1_N : N ;
  gendarmeri_nn_1_N : N ;
  gehoer_nn_1_1_N : N ;
  gatuvaald_nn_1_1_N : N ;
  gatuvimmel_nn_1_N : N ;
  gass_nn_1_N : N ;
  gap_nn_2_N : N ;
  galoschbett_nn_1_N : N ;
  gallium_nn_1_N : N ;
  galej_nn_1_N : N ;
  gagn_nn_1_N : N ;
  gagg_nn_1_N : N ;
  gadolinium_nn_1_N : N ;
  foeraeldraskap_nn_1_1_N : N ;
  foeraeldraansvar_nn_1_1_N : N ;
  foervaervsliv_nn_1_1_N : N ;
  foervar_nn_1_1_N : N ;
  foervaltarskap_nn_1_1_N : N ;
  foertryck_nn_1_1_N : N ;
  foertal_nn_1_1_N : N ;
  foersoerjningsstoed_nn_1_1_N : N ;
  foersvarsvaesen_nn_1_1_N : N ;
  foersvar_nn_1_1_N : N ;
  foerstaand_nn_1_1_N : N ;
  foerspraang_nn_1_1_N : N ;
  foersamlingsliv_nn_1_1_N : N ;
  foernaem_av_1_1_A : A ;
  foernuft_nn_1_1_N : N ;
  foermynderskap_nn_1_1_N : N ;
  foermynderi_nn_1_1_N : N ;
  foermaksflimmer_nn_1_1_N : N ;
  foerfattarskap_nn_1_1_N : N ;
  foerfall_nn_1_1_N : N ;
  foereningsliv_nn_1_1_N : N ;
  foerdaerv_nn_1_1_N : N ;
  foerakt_nn_1_1_N : N ;
  faarsex_nn_1_1_N : N ;
  faarkoett_nn_1_1_N : N ;
  faagelkvitter_nn_1_1_N : N ;
  faestfolk_nn_1_1_N : N ;
  faeltartilleri_nn_1_1_N : N ;
  fyrvaesen_nn_1_1_N : N ;
  fyrtital_nn_1_N : N ;
  fyrtiotal_nn_1_N : N ;
  fylleri_nn_1_N : N ;
  fuskeri_nn_1_N : N ;
  fusk_nn_1_N : N ;
  furutrae_nn_1_1_N : N ;
  furan_nn_1_N : N ;
  fullkornsmjoel_nn_1_1_N : N ;
  fullkorn_nn_1_N : N ;
  fubb_nn_1_N : N ;
  froemjoel_nn_1_1_N : N ;
  fraes_nn_2_1_N : N ;
  fraemlingskap_nn_1_1_N : N ;
  fraemlingshat_nn_1_1_N : N ;
  fruktsocker_nn_1_N : N ;
  fruktsalt_nn_1_N : N ;
  fruktkoett_nn_1_1_N : N ;
  frosseri_nn_1_N : N ;
  fromleri_nn_1_N : N ;
  fritaenkeri_nn_1_1_N : N ;
  friteringsfett_nn_1_N : N ;
  frimureri_nn_1_N : N ;
  friluftsliv_nn_1_N : N ;
  friluftshaall_nn_1_1_N : N ;
  frihetsbegaer_nn_1_1_N : N ;
  frat_nn_1_N : N ;
  fras_nn_2_N : N ;
  francium_nn_1_N : N ;
  fraktgods_nn_1_N : N ;
  fotfolk_nn_1_N : N ;
  fortsaettningskrig_nn_1_1_N : N ;
  fortbestaand_nn_1_1_N : N ;
  forstvaesen_nn_1_1_N : N ;
  fornyrdislag_nn_1_N : N ;
  formgods_nn_1_N : N ;
  fondmaekleri_nn_1_1_N : N ;
  folkvimmel_nn_1_N : N ;
  folkvett_nn_1_N : N ;
  folkliv_nn_1_N : N ;
  folkfoerakt_nn_1_1_N : N ;
  fnitter_nn_1_N : N ;
  fnas_nn_1_N : N ;
  flaaspatos_nn_1_1_N : N ;
  flaas_nn_1_1_N : N ;
  flaeskkoett_nn_1_1_N : N ;
  flaesk_nn_1_1_N : N ;
  flaeng_nn_1_1_N : N ;
  flyttningsfoerbud_nn_1_1_N : N ;
  flyt_nn_1_N : N ;
  flyg_nn_2_N : N ;
  flussglas_nn_1_N : N ;
  flott_nn_1_N : N ;
  florsocker_nn_1_N : N ;
  flock_nn_2_N : N ;
  floatglas_nn_1_N : N ;
  flintgods_nn_1_N : N ;
  flimmer_nn_1_N : N ;
  flertal_nn_1_N : N ;
  flax_nn_2_N : N ;
  flams_nn_1_N : N ;
  fladder_nn_1_N : N ;
  fjaesk_nn_1_1_N : N ;
  fjaederstaal_nn_1_1_N : N ;
  fjaedergraes_nn_1_1_N : N ;
  fjortonhundratal_nn_1_N : N ;
  fjant_nn_2_N : N ;
  fiskrens_nn_1_N : N ;
  fiskmjoel_nn_1_1_N : N ;
  fisklir_nn_1_N : N ;
  firmament_nn_1_N : N ;
  finspackel_nn_1_N : N ;
  fingerblaeck_nn_1_1_N : N ;
  fiffel_nn_1_N : N ;
  ferrum_nn_1_N : N ;
  fermium_nn_1_N : N ;
  feodalvaesen_nn_1_1_N : N ;
  femtontal_nn_1_N : N ;
  femtonhundratal_nn_1_N : N ;
  feministtjafs_nn_1_N : N ;
  felfinneri_nn_1_N : N ;
  fel_nn_2_N : N ;
  fatoel_nn_1_1_N : N ;
  fattigunderstoed_nn_1_1_N : N ;
  fastlandsklimat_nn_1_N : N ;
  fastland_nn_1_N : N ;
  farinsocker_nn_1_N : N ;
  faderskap_nn_1_N : N ;
  fackelsken_nn_1_N : N ;
  exportoel_nn_1_1_N : N ;
  exportfoerbud_nn_1_1_N : N ;
  etyn_nn_1_N : N ;
  etter_nn_1_N : N ;
  etappvaesen_nn_1_1_N : N ;
  espartograes_nn_1_1_N : N ;
  ersaettningsansvar_nn_1_1_N : N ;
  eremitliv_nn_1_N : N ;
  erbium_nn_1_N : N ;
  epigoneri_nn_1_N : N ;
  enspann_nn_1_N : N ;
  enkorn_nn_1_N : N ;
  emsersalt_nn_1_N : N ;
  emaljglas_nn_1_N : N ;
  elvahundratal_nn_1_N : N ;
  elskrot_nn_1_N : N ;
  elljus_nn_1_N : N ;
  elfenbenspapper_nn_1_N : N ;
  elfenben_nn_1_N : N ;
  elektrostaal_nn_1_1_N : N ;
  elektron_nn_2_N : N ;
  elefantgraes_nn_1_1_N : N ;
  eldunderstoed_nn_1_1_N : N ;
  eldskydd_nn_1_N : N ;
  eldhav_nn_1_N : N ;
  ektoderm_nn_1_N : N ;
  ekorrhjul_nn_1_N : N ;
  einsteinium_nn_1_N : N ;
  egendomsfolk_nn_1_N : N ;
  eftertrav_nn_1_N : N ;
  eftersoek_nn_1_1_N : N ;
  eftersnack_nn_1_N : N ;
  efterplock_nn_1_N : N ;
  efterlevandeskydd_nn_1_N : N ;
  effektgarn_nn_1_N : N ;
  edsansvar_nn_1_N : N ;
  doesnack_nn_1_1_N : N ;
  doen_nn_1_1_N : N ;
  doedsfoerakt_nn_1_1_N : N ;
  doedkoett_nn_1_1_N : N ;
  daas_nn_1_1_N : N ;
  daeng_nn_1_1_N : N ;
  dysprosium_nn_1_N : N ;
  dykeri_nn_1_N : N ;
  dusk_nn_1_N : N ;
  duraluminium_nn_1_N : N ;
  duodesformat_nn_1_N : N ;
  dunkel_nn_1_N : N ;
  dunk_nn_2_N : N ;
  dubbfoerbud_nn_1_1_N : N ;
  dubbelliv_nn_1_N : N ;
  dubbdaecksfoerbud_nn_1_1_N : N ;
  droenarliv_nn_1_1_N : N ;
  druvsocker_nn_1_N : N ;
  dropp_nn_1_N : N ;
  drogsug_nn_1_N : N ;
  drivhusklimat_nn_1_N : N ;
  driveri_nn_1_N : N ;
  driftvaern_nn_1_1_N : N ;
  driftliv_nn_1_N : N ;
  drev_nn_2_N : N ;
  dravel_nn_1_N : N ;
  drakblod_nn_1_N : N ;
  drag_nn_2_N : N ;
  dotterskap_nn_1_N : N ;
  dopp_nn_2_N : N ;
  donk_nn_1_N : N ;
  dokumentpapper_nn_1_N : N ;
  dobbel_nn_1_N : N ;
  djurskydd_nn_1_N : N ;
  djurplaageri_nn_1_1_N : N ;
  djurliv_nn_1_N : N ;
  djurfoerbud_nn_1_1_N : N ;
  djuphav_nn_1_N : N ;
  dis_nn_1_N : N ;
  direktflyg_nn_1_N : N ;
  dipsan_nn_1_N : N ;
  dingeldangel_nn_1_N : N ;
  dillkoett_nn_1_1_N : N ;
  dilettanteri_nn_1_N : N ;
  deuterium_nn_1_N : N ;
  desengagemang_nn_1_N : N ;
  depaastoed_nn_1_1_N : N ;
  deplacement_nn_1_N : N ;
  dekorum_nn_1_N : N ;
  dasspapper_nn_1_N : N ;
  dask_nn_1_N : N ;
  darrgraes_nn_1_1_N : N ;
  darr_nn_1_N : N ;
  dansvimmel_nn_1_N : N ;
  danskhat_nn_1_N : N ;
  dansfoerbud_nn_1_1_N : N ;
  damm_nn_2_N : N ;
  damaskenerstaal_nn_1_1_N : N ;
  dalt_nn_1_N : N ;
  dallergraes_nn_1_1_N : N ;
  daller_nn_1_N : N ;
  dalj_nn_1_N : N ;
  dagslaendeliv_nn_1_1_N : N ;
  dagsljus_nn_1_N : N ;
  dagdriveri_nn_1_N : N ;
  dagdrivarliv_nn_1_N : N ;
  cylinderglas_nn_1_N : N ;
  cybersex_nn_1_N : N ;
  cyankalium_nn_1_N : N ;
  curium_nn_1_N : N ;
  civilmotstaand_nn_1_1_N : N ;
  civilfoersvar_nn_1_1_N : N ;
  civilflyg_nn_1_N : N ;
  cityliv_nn_1_N : N ;
  citrat_nn_1_N : N ;
  chipssug_nn_1_N : N ;
  chefsskap_nn_1_N : N ;
  chefskap_nn_1_N : N ;
  charpi_nn_1_N : N ;
  cesium_nn_1_N : N ;
  cerium_nn_1_N : N ;
  centralfoersvar_nn_1_1_N : N ;
  cedrat_nn_1_N : N ;
  californium_nn_1_N : N ;
  boel_nn_1_1_N : N ;
  boek_nn_1_1_N : N ;
  boejtrae_nn_1_1_N : N ;
  baagljus_nn_1_1_N : N ;
  baag_nn_1_1_N : N ;
  baersaerkaraseri_nn_1_1_N : N ;
  baergningsvaeder_nn_1_1_N : N ;
  byggdamm_nn_1_N : N ;
  buteljlack_nn_1_N : N ;
  buteljglas_nn_1_N : N ;
  butadien_nn_1_N : N ;
  busliv_nn_1_N : N ;
  bus_nn_1_N : N ;
  burskap_nn_1_N : N ;
  burkafoerbud_nn_1_1_N : N ;
  bunkstaal_nn_1_1_N : N ;
  buljongkoett_nn_1_1_N : N ;
  buktaleri_nn_1_N : N ;
  bukfett_nn_1_N : N ;
  bubbel_nn_1_N : N ;
  broestsocker_nn_1_1_N : N ;
  braennstaal_nn_1_1_N : N ;
  braeck_nn_1_1_N : N ;
  bry_nn_1_N : N ;
  brus_nn_1_N : N ;
  brudbroed_nn_1_1_N : N ;
  bromural_nn_1_N : N ;
  brodergarn_nn_1_N : N ;
  briljantglas_nn_1_N : N ;
  braxengraes_nn_1_1_N : N ;
  brass_nn_1_N : N ;
  brandvaesen_nn_1_1_N : N ;
  brandskydd_nn_1_N : N ;
  brandmansgrepp_nn_1_N : N ;
  brandfoersvar_nn_1_1_N : N ;
  brak_nn_1_N : N ;
  box_nn_2_N : N ;
  botulin_nn_1_N : N ;
  bottentryck_nn_1_N : N ;
  bottenskrap_nn_1_N : N ;
  bostadsbestaand_nn_1_1_N : N ;
  boss_nn_2_N : N ;
  bosch_nn_1_N : N ;
  borgarstaand_nn_1_1_N : N ;
  bordssilver_nn_1_N : N ;
  bordssalt_nn_1_N : N ;
  bordsilver_nn_1_N : N ;
  bondland_nn_1_N : N ;
  bondfoerstaand_nn_1_1_N : N ;
  bondfoernuft_nn_1_1_N : N ;
  bondestaand_nn_1_1_N : N ;
  bomullstrassel_nn_1_N : N ;
  bomullskrut_nn_1_N : N ;
  bombflyg_nn_1_N : N ;
  boleri_nn_1_N : N ;
  boktryck_nn_1_N : N ;
  bokmaal_nn_1_1_N : N ;
  bokhantverk_nn_1_N : N ;
  bohemliv_nn_1_N : N ;
  bockoel_nn_1_1_N : N ;
  bloetfoder_nn_1_1_N : N ;
  blaatrae_nn_1_1_N : N ;
  blaaregn_nn_1_1_N : N ;
  blaeckpulver_nn_1_1_N : N ;
  blaeck_nn_1_1_N : N ;
  blysocker_nn_1_N : N ;
  blyglas_nn_1_N : N ;
  blygdhaar_nn_1_1_N : N ;
  bly_nn_1_N : N ;
  bludder_nn_1_N : N ;
  blomstoft_nn_1_N : N ;
  blomsterspraak_nn_1_1_N : N ;
  blodsocker_nn_1_N : N ;
  blodserum_nn_1_N : N ;
  blodregn_nn_1_N : N ;
  blodomlopp_nn_1_N : N ;
  blodlutssalt_nn_1_N : N ;
  blodlutsalt_nn_1_N : N ;
  blixtpulver_nn_1_N : N ;
  blixtljus_nn_1_N : N ;
  bling_nn_1_N : N ;
  bling_bling_nn_1_N : N ;
  blindschack_nn_1_N : N ;
  blig_nn_1_N : N ;
  blask_nn_1_N : N ;
  blarr_nn_1_N : N ;
  blankskinn_nn_1_N : N ;
  blankningsfoerbud_nn_1_1_N : N ;
  blanklaeder_nn_1_1_N : N ;
  blankettraseri_nn_1_N : N ;
  blandfoder_nn_1_N : N ;
  blaj_nn_1_N : N ;
  blaggarn_nn_1_N : N ;
  bladverk_nn_1_N : N ;
  bladsilver_nn_1_N : N ;
  bladmoegel_nn_1_1_N : N ;
  bladguld_nn_1_N : N ;
  bladder_nn_1_N : N ;
  bjoerksly_nn_1_1_N : N ;
  bjoerkpollen_nn_1_1_N : N ;
  bjaefs_nn_1_1_N : N ;
  bjaebb_nn_1_1_N : N ;
  bivax_nn_1_N : N ;
  bittersalt_nn_1_N : N ;
  bitsocker_nn_1_N : N ;
  bitryck_nn_1_N : N ;
  bistaand_nn_1_1_N : N ;
  bister_nn_1_N : N ;
  bir_nn_1_N : N ;
  bevattningsfoerbud_nn_1_1_N : N ;
  bettleri_nn_1_N : N ;
  betsocker_nn_1_N : N ;
  betryck_nn_1_N : N ;
  betalsex_nn_1_N : N ;
  beskaerm_nn_1_1_N : N ;
  beskydd_nn_1_N : N ;
  beryllium_nn_1_N : N ;
  berkelium_nn_1_N : N ;
  bergsklimat_nn_1_N : N ;
  bergsbruk_nn_1_N : N ;
  bergsartilleri_nn_1_N : N ;
  bergland_nn_1_N : N ;
  benmjoel_nn_1_1_N : N ;
  belaegringsartilleri_nn_1_1_N : N ;
  beknip_nn_1_N : N ;
  begabberi_nn_1_N : N ;
  befael_nn_2_1_N : N ;
  beckmoerker_nn_1_1_N : N ;
  beck_nn_1_N : N ;
  bast_nn_1_N : N ;
  barnplaageri_nn_1_1_N : N ;
  barnbeck_nn_1_N : N ;
  barium_nn_1_N : N ;
  barbari_nn_1_N : N ;
  banverk_nn_1_N : N ;
  banunderhaall_nn_1_1_N : N ;
  bankvaesen_nn_1_1_N : N ;
  balsatrae_nn_1_1_N : N ;
  baktal_nn_1_N : N ;
  bakland_nn_1_N : N ;
  bakgrundssorl_nn_1_N : N ;
  bakdanteri_nn_1_N : N ;
  bajs_nn_1_N : N ;
  baggboeleri_nn_1_1_N : N ;
  badortsliv_nn_1_N : N ;
  badfoerbud_nn_1_1_N : N ;
  babbel_nn_1_N : N ;
  ax_nn_2_N : N ;
  avskrap_nn_1_N : N ;
  avsidesliv_nn_1_N : N ;
  avrens_nn_1_N : N ;
  avguderi_nn_1_N : N ;
  avfallsfoder_nn_1_N : N ;
  augustimaansken_nn_1_1_N : N ;
  atmosfaertryck_nn_1_1_N : N ;
  asktrae_nn_1_1_N : N ;
  arvegods_nn_1_N : N ;
  artonhundraaattiotal_nn_1_1_N : N ;
  artonhundratal_nn_1_N : N ;
  artonhundrasjuttiotal_nn_1_N : N ;
  artonhundranittiotal_nn_1_N : N ;
  artistliv_nn_1_N : N ;
  artisteri_nn_1_N : N ;
  artilleri_nn_1_N : N ;
  arm_eunderstoed_nn_1_1_N : N ;
  armod_nn_1_N : N ;
  arbetsliv_nn_1_N : N ;
  arbetsfolk_nn_1_N : N ;
  arbetarskydd_nn_1_N : N ;
  apogeum_nn_1_N : N ;
  apex_nn_1_N : N ;
  ansvar_nn_1_N : N ;
  angoragarn_nn_1_N : N ;
  analsex_nn_1_N : N ;
  amningsfoerakt_nn_1_1_N : N ;
  ammonium_nn_1_N : N ;
  amiralitet_nn_1_N : N ;
  americium_nn_1_N : N ;
  aluminium_nn_1_N : N ;
  allvar_nn_1_N : N ;
  allt_nn_1_N : N ;
  allmaengods_nn_1_1_N : N ;
  alkoholmissbruk_nn_1_N : N ;
  alfapet_nn_1_N : N ;
  alexanderhugg_nn_1_N : N ;
  aktinium_nn_1_N : N ;
  agg_nn_1_N : N ;
  agatglas_nn_1_N : N ;
  advent_nn_1_N : N ;
  adertonhundratal_nn_1_N : N ;
  adelsstaand_nn_1_1_N : N ;
  adelskap_nn_1_N : N ;
  _90_tal_nn_1_N : N ;
  _80_tal_nn_1_N : N ;
  _70_tal_nn_1_N : N ;
  _60_tal_nn_1_N : N ;
  _50_tal_nn_1_N : N ;
  _40_tal_nn_1_N : N ;
  _30_tal_nn_1_N : N ;
  _2000_tal_nn_1_N : N ;
  _20_tal_nn_1_N : N ;
  _1990_tal_nn_1_N : N ;
  _1980_tal_nn_1_N : N ;
  _1970_tal_nn_1_N : N ;
  _1960_tal_nn_1_N : N ;
  _1950_tal_nn_1_N : N ;
  _1940_tal_nn_1_N : N ;
  _1930_tal_nn_1_N : N ;
  _1920_tal_nn_1_N : N ;
  _1910_tal_nn_1_N : N ;
  _1900_tal_nn_1_N : N ;
  _1890_tal_nn_1_N : N ;
  _1880_tal_nn_1_N : N ;
  _1870_tal_nn_1_N : N ;
  _1800_tal_nn_1_N : N ;
  _1700_tal_nn_1_N : N ;
  _1600_tal_nn_1_N : N ;
  _1500_tal_nn_1_N : N ;
  _1400_tal_nn_1_N : N ;
  _1300_tal_nn_1_N : N ;
  _1200_tal_nn_1_N : N ;
  _1100_tal_nn_1_N : N ;
  _00_tal_nn_1_N : N ;
  Vaegverk_nn_1_1_N : N ;
  Trafiksaekerhetsverk_nn_1_1_N : N ;
  Trafikkontor_nn_1_N : N ;
  Teutoburgerslag_nn_1_N : N ;
  Stockholmssyndrom_nn_1_N : N ;
  Stadsbyggnadskontor_nn_1_N : N ;
  Sovjetsystem_nn_1_N : N ;
  Skolverk_nn_1_N : N ;
  Sjoefartsverk_nn_1_1_N : N ;
  Patentverk_nn_1_N : N ;
  Palmehat_nn_1_N : N ;
  Norrmalmstorgssyndrom_nn_1_N : N ;
  Naturvaardsverk_nn_1_1_N : N ;
  Monopol_nn_1_N : N ;
  Migrationsverk_nn_1_N : N ;
  Livsmedelsverk_nn_1_N : N ;
  Lissabonfoerdrag_nn_1_1_N : N ;
  Krimkrig_nn_1_N : N ;
  Koreakrig_nn_1_N : N ;
  Europaraadsparlament_nn_1_1_N : N ;
  Europaraad_nn_1_1_N : N ;
  Europaparlament_nn_1_N : N ;
  Banverk_nn_1_N : N ;
  Alfapet_nn_1_N : N ;
  Moskvatrogen_av_1_A : A ;
  Stasianstaelld_av_1_1_A : A ;
  Volvoanstaelld_av_1_1_A : A ;
  absurd_av_1_A : A ;
  aktningsvaerd_av_1_1_A : A ;
  alkoholfri_av_1_A : A ;
  alliansfri_av_1_A : A ;
  allvarstyngd_av_1_A : A ;
  amorteringsfri_av_1_A : A ;
  andtruten_av_1_A : A ;
  angelaegen_av_1_1_A : A ;
  anlupen_av_1_A : A ;
  anmaerkningsvaerd_av_1_1_A : A ;
  anskriven_av_1_A : A ;
  anstruken_av_1_A : A ;
  anstraengd_av_1_1_A : A ;
  anstucken_av_1_A : A ;
  anstaelld_av_1_1_A : A ;
  ansvaelld_av_1_1_A : A ;
  arbetsfri_av_1_A : A ;
  artegen_av_1_A : A ;
  artskild_av_1_A : A ;
  askfri_av_1_A : A ;
  auktoritetsbunden_av_1_A : A ;
  avfallen_av_1_A : A ;
  avgiftsfri_av_1_A : A ;
  avgjord_av_1_A : A ;
  avhaengd_av_1_1_A : A ;
  avhaallen_av_1_1_A : A ;
  avlagd_av_1_A : A ;
  avlaegsen_av_1_1_A : A ;
  avsevaerd_av_1_1_A : A ;
  avskild_av_1_A : A ;
  avskyvaerd_av_1_1_A : A ;
  avslagen_av_1_A : A ;
  avtaerd_av_1_1_A : A ;
  avundsvaerd_av_1_1_A : A ;
  barnfoerbjuden_av_1_1_A : A ;
  barntillaaten_av_1_1_A : A ;
  beaktansvaerd_av_1_1_A : A ;
  befaren_av_1_A : A ;
  befaengd_av_1_1_A : A ;
  begiven_av_1_A : A ;
  behjaertansvaerd_av_1_1_A : A ;
  beklagansvaerd_av_1_1_A : A ;
  beklaemd_av_1_1_A : A ;
  bekymmerfri_av_1_A : A ;
  bekymmersfri_av_1_A : A ;
  belaegen_av_1_1_A : A ;
  belaaten_av_1_1_A : A ;
  benfri_av_1_A : A ;
  benhaard_av_1_1_A : A ;
  benaegen_av_1_1_A : A ;
  bergtagen_av_1_A : A ;
  beriden_av_1_A : A ;
  beroemd_av_1_1_A : A ;
  beroemvaerd_av_1_1_A : A ;
  beroerd_av_1_1_A : A ;
  beroeringsfri_av_1_1_A : A ;
  beskaerd_av_1_1_A : A ;
  besluten_av_1_A : A ;
  bestaemd_av_1_1_A : A ;
  besutten_av_1_A : A ;
  besviken_av_1_A : A ;
  besvaersfri_av_1_1_A : A ;
  betagen_av_1_A : A ;
  betalningsfri_av_1_A : A ;
  betraengd_av_1_1_A : A ;
  betygsfri_av_1_A : A ;
  beundransvaerd_av_1_1_A : A ;
  bevuxen_av_1_A : A ;
  bevaagen_av_1_1_A : A ;
  bibehaallen_av_1_1_A : A ;
  bibelkristen_av_1_A : A ;
  bibelspraengd_av_1_1_A : A ;
  bibeltrogen_av_1_A : A ;
  bienn_av_1_A : A ;
  bilburen_av_1_A : A ;
  bilfri_av_1_A : A ;
  bindgalen_av_1_A : A ;
  bingosugen_av_1_A : A ;
  biten_av_1_A : A ;
  blanksliten_av_1_A : A ;
  bleklagd_av_1_A : A ;
  blodspraengd_av_1_1_A : A ;
  blodstinn_av_1_A : A ;
  blottstaelld_av_1_1_A : A ;
  blyfri_av_1_A : A ;
  blykyld_av_1_A : A ;
  blaendfri_av_1_1_A : A ;
  blaaanlupen_av_1_1_A : A ;
  blaafrusen_av_1_1_A : A ;
  blaaoegd_av_1_1_A : A ;
  bogbruten_av_1_A : A ;
  boken_av_1_A : A ;
  boklaerd_av_1_1_A : A ;
  bokstavstrogen_av_1_A : A ;
  boren_av_1_A : A ;
  bortbjuden_av_1_A : A ;
  bortgloemd_av_1_1_A : A ;
  bortkoerd_av_1_1_A : A ;
  brickvaevd_av_1_1_A : A ;
  brisken_av_1_A : A ;
  brunoegd_av_1_1_A : A ;
  brusten_av_1_A : A ;
  bruten_av_1_A : A ;
  bryggmald_av_1_A : A ;
  bryggmalen_av_1_A : A ;
  braeddfylld_av_1_1_A : A ;
  braadmogen_av_1_1_A : A ;
  bukstinn_av_1_A : A ;
  bunden_av_1_A : A ;
  burgen_av_1_A : A ;
  butiksanstaelld_av_1_1_A : A ;
  baald_av_1_1_A : A ;
  boejd_av_1_1_A : A ;
  centralstyrd_av_1_A : A ;
  chosefri_av_1_A : A ;
  civilanstaelld_av_1_1_A : A ;
  danskaegd_av_1_1_A : A ;
  deltidsanstaelld_av_1_1_A : A ;
  diamantbelagd_av_1_A : A ;
  dimhoeljd_av_1_1_A : A ;
  dold_av_1_A : A ;
  dragen_av_1_A : A ;
  dragfri_av_1_A : A ;
  driven_av_1_A : A ;
  droppfri_av_1_A : A ;
  drucken_av_1_A : A ;
  durkdriven_av_1_A : A ;
  duven_av_1_A : A ;
  dygnetruntoeppen_av_1_1_A : A ;
  dyrkansvaerd_av_1_1_A : A ;
  dyrkfri_av_1_A : A ;
  daeven_av_1_1_A : A ;
  doedsdoemd_av_1_1_A : A ;
  edsvuren_av_1_A : A ;
  efterbliven_av_1_A : A ;
  efterfoeljansvaerd_av_1_1_A : A ;
  eftergiven_av_1_A : A ;
  eftergjord_av_1_A : A ;
  efterhaengsen_av_1_1_A : A ;
  efterlaaten_av_1_1_A : A ;
  efterstraevansvaerd_av_1_1_A : A ;
  efterstaelld_av_1_1_A : A ;
  eftertraktansvaerd_av_1_1_A : A ;
  egen_av_1_A : A ;
  eldfaengd_av_1_1_A : A ;
  empatistoerd_av_1_1_A : A ;
  enskild_av_1_A : A ;
  entraegen_av_1_1_A : A ;
  enveten_av_1_A : A ;
  envaerd_av_1_1_A : A ;
  enoegd_av_1_1_A : A ;
  erfaren_av_1_A : A ;
  ettstruken_av_1_A : A ;
  fabriksny_av_1_A : A ;
  fallen_av_1_A : A ;
  farofylld_av_1_A : A ;
  fartfylld_av_1_A : A ;
  fastfrusen_av_1_A : A ;
  feberfri_av_1_A : A ;
  felfri_av_1_A : A ;
  felslagen_av_1_A : A ;
  felstaelld_av_1_1_A : A ;
  fetlagd_av_1_A : A ;
  fiken_av_1_A : A ;
  finskuren_av_1_A : A ;
  finskaegd_av_1_1_A : A ;
  finstaemd_av_1_1_A : A ;
  fjaerrstyrd_av_1_1_A : A ;
  flaeckfri_av_1_1_A : A ;
  flaerdfri_av_1_1_A : A ;
  folkilsken_av_1_A : A ;
  folkvald_av_1_A : A ;
  formbunden_av_1_A : A ;
  fossilfri_av_1_A : A ;
  framliden_av_1_A : A ;
  framskjuten_av_1_A : A ;
  framskriden_av_1_A : A ;
  framaatboejd_av_1_1_A : A ;
  franskstyrd_av_1_A : A ;
  fri_av_1_A : A ;
  friboren_av_1_A : A ;
  frigjord_av_1_A : A ;
  friktionsfri_av_1_A : A ;
  friskriven_av_1_A : A ;
  frostbiten_av_1_A : A ;
  frostfri_av_1_A : A ;
  fruktansvaerd_av_1_1_A : A ;
  frusen_av_1_A : A ;
  fraankoerd_av_1_1_A : A ;
  fraanskild_av_1_1_A : A ;
  fullbelagd_av_1_A : A ;
  fullbetald_av_1_A : A ;
  fullgaangen_av_1_1_A : A ;
  fullmogen_av_1_A : A ;
  fullvuxen_av_1_A : A ;
  fylld_av_1_A : A ;
  faengelsedoemd_av_1_1_A : A ;
  faerggrann_av_1_1_A : A ;
  faagelfri_av_1_1_A : A ;
  faamaeld_av_1_1_A : A ;
  faangen_av_1_1_A : A ;
  foerbigaangen_av_1_1_A : A ;
  foerbjuden_av_1_1_A : A ;
  foerbunden_av_1_1_A : A ;
  foerdold_av_1_1_A : A ;
  foerdomsfri_av_1_1_A : A ;
  foerdragen_av_1_1_A : A ;
  foerdroemd_av_1_1_A : A ;
  foerdoemd_av_1_1_A : A ;
  foerfallen_av_1_1_A : A ;
  foerfaren_av_1_1_A : A ;
  foerflugen_av_1_1_A : A ;
  foerfluten_av_1_1_A : A ;
  foerfrusen_av_1_1_A : A ;
  foergjord_av_1_1_A : A ;
  foergraemd_av_1_1_A : A ;
  foergraaten_av_1_1_A : A ;
  foerkristen_av_1_1_A : A ;
  foerkyld_av_1_1_A : A ;
  foerliden_av_1_1_A : A ;
  foerljugen_av_1_1_A : A ;
  foerlupen_av_1_1_A : A ;
  foerlaegen_av_1_1_A : A ;
  foermedveten_av_1_1_A : A ;
  foermaeld_av_1_1_A : A ;
  foermaeten_av_1_1_A : A ;
  foermoegen_av_1_1_A : A ;
  foernoejd_av_1_1_A : A ;
  foerrymd_av_1_1_A : A ;
  foersagd_av_1_1_A : A ;
  foersjunken_av_1_1_A : A ;
  foerskraemd_av_1_1_A : A ;
  foerskaemd_av_1_1_A : A ;
  foerslagen_av_1_1_A : A ;
  foerstucken_av_1_1_A : A ;
  foerstulen_av_1_1_A : A ;
  foerstaemd_av_1_1_A : A ;
  foerstoerd_av_1_1_A : A ;
  foersupen_av_1_1_A : A ;
  foertegen_av_1_1_A : A ;
  foertroendevald_av_1_1_A : A ;
  foertrogen_av_1_1_A : A ;
  foerundransvaerd_av_1_1_A : A ;
  foerutbestaemd_av_1_1_A : A ;
  foerveten_av_1_1_A : A ;
  foervuxen_av_1_1_A : A ;
  foervaegen_av_1_1_A : A ;
  foervaervslysten_av_1_1_A : A ;
  foervaanansvaerd_av_1_1_A : A ;
  foeraeldrafri_av_1_1_A : A ;
  galen_av_1_A : A ;
  gallspraengd_av_1_1_A : A ;
  gammalkristen_av_1_A : A ;
  gedigen_av_1_A : A ;
  genombruten_av_1_A : A ;
  genomfoerkyld_av_1_1_A : A ;
  genomvaevd_av_1_1_A : A ;
  giftasvuxen_av_1_A : A ;
  giftfri_av_1_A : A ;
  giktbruten_av_1_A : A ;
  girvuxen_av_1_A : A ;
  gisten_av_1_A : A ;
  given_av_1_A : A ;
  givmild_av_1_A : A ;
  glosoegd_av_1_1_A : A ;
  glutenfri_av_1_A : A ;
  glaedjefylld_av_1_1_A : A ;
  gniden_av_1_A : A ;
  godissugen_av_1_A : A ;
  godtrogen_av_1_A : A ;
  grann_av_1_A : A ;
  gripen_av_1_A : A ;
  grovhuggen_av_1_A : A ;
  grundlaerd_av_1_1_A : A ;
  graetten_av_1_1_A : A ;
  graaspraengd_av_1_1_A : A ;
  graatmild_av_1_1_A : A ;
  groenmogen_av_1_1_A : A ;
  gudsfoergaeten_av_1_1_A : A ;
  gunstbenaegen_av_1_1_A : A ;
  gaeldbunden_av_1_1_A : A ;
  gaellen_av_1_1_A : A ;
  gaestfri_av_1_1_A : A ;
  hagalen_av_1_A : A ;
  halkfri_av_1_A : A ;
  halvenskild_av_1_A : A ;
  halvfylld_av_1_A : A ;
  halvgaangen_av_1_1_A : A ;
  halvkvaeden_av_1_1_A : A ;
  halvkvaevd_av_1_1_A : A ;
  halvnaken_av_1_A : A ;
  halvsluten_av_1_A : A ;
  halvvuxen_av_1_A : A ;
  halvoeppen_av_1_1_A : A ;
  handfallen_av_1_A : A ;
  handgjord_av_1_A : A ;
  handgaangen_av_1_1_A : A ;
  handskriven_av_1_A : A ;
  harmfylld_av_1_A : A ;
  harmsen_av_1_A : A ;
  hatfylld_av_1_A : A ;
  heden_av_1_A : A ;
  hedervaerd_av_1_1_A : A ;
  hejvild_av_1_A : A ;
  heldragen_av_1_A : A ;
  helgfri_av_1_A : A ;
  helgjuten_av_1_A : A ;
  heliumfylld_av_1_A : A ;
  heltidsanstaelld_av_1_1_A : A ;
  helaegd_av_1_1_A : A ;
  hembryggd_av_1_A : A ;
  hemgjord_av_1_A : A ;
  hemkoerd_av_1_1_A : A ;
  hemmabyggd_av_1_A : A ;
  hemmagjord_av_1_A : A ;
  hemvaevd_av_1_1_A : A ;
  himlaboren_av_1_A : A ;
  hjaertnupen_av_1_1_A : A ;
  hopbiten_av_1_A : A ;
  hopbyggd_av_1_A : A ;
  hopfaelld_av_1_1_A : A ;
  hopkrupen_av_1_A : A ;
  hopsjunken_av_1_A : A ;
  hopslagen_av_1_A : A ;
  hopsnoerd_av_1_1_A : A ;
  hopvuxen_av_1_A : A ;
  huld_av_1_A : A ;
  humusbunden_av_1_A : A ;
  haelsomedveten_av_1_1_A : A ;
  haemndlysten_av_1_1_A : A ;
  haenfoerd_av_1_1_A : A ;
  haengiven_av_1_1_A : A ;
  haensjunken_av_1_1_A : A ;
  haensoven_av_1_1_A : A ;
  haepen_av_1_1_A : A ;
  haersken_av_1_1_A : A ;
  haersklysten_av_1_1_A : A ;
  haertagen_av_1_1_A : A ;
  haestdragen_av_1_1_A : A ;
  haallen_av_1_1_A : A ;
  haaloegd_av_1_1_A : A ;
  haarbevuxen_av_1_1_A : A ;
  haard_av_1_1_A : A ;
  haardfrusen_av_1_1_A : A ;
  hoegboren_av_1_1_A : A ;
  hoegburen_av_1_1_A : A ;
  hoegdragen_av_1_1_A : A ;
  hoegerkristen_av_1_1_A : A ;
  hoegfaerdsgalen_av_1_1_A : A ;
  hoegstaemd_av_1_1_A : A ;
  hoegvuxen_av_1_1_A : A ;
  hoegvaelboren_av_1_1_A : A ;
  icke_kristen_av_1_A : A ;
  ifoerd_av_1_1_A : A ;
  igenmulen_av_1_A : A ;
  igenvuxen_av_1_A : A ;
  ihjaelskraemd_av_1_1_A : A ;
  ihopfaelld_av_1_1_A : A ;
  ihoplagd_av_1_A : A ;
  illavulen_av_1_A : A ;
  illusionsfri_av_1_A : A ;
  ilsken_av_1_A : A ;
  impulsstyrd_av_1_A : A ;
  inbegripen_av_1_A : A ;
  inbiten_av_1_A : A ;
  inbunden_av_1_A : A ;
  inbyggd_av_1_A : A ;
  indragen_av_1_A : A ;
  infallen_av_1_A : A ;
  infrusen_av_1_A : A ;
  infaelld_av_1_1_A : A ;
  inkoerd_av_1_1_A : A ;
  inlagd_av_1_A : A ;
  inlaerd_av_1_1_A : A ;
  inpyrd_av_1_A : A ;
  insjunken_av_1_A : A ;
  inslagen_av_1_A : A ;
  insnaerjd_av_1_1_A : A ;
  inspraengd_av_1_1_A : A ;
  instaelld_av_1_1_A : A ;
  instaengd_av_1_1_A : A ;
  insvaengd_av_1_1_A : A ;
  intagen_av_1_A : A ;
  invaendningsfri_av_1_1_A : A ;
  inaatboejd_av_1_1_A : A ;
  isfri_av_1_A : A ;
  iskyld_av_1_A : A ;
  jordbunden_av_1_A : A ;
  judekristen_av_1_A : A ;
  jaemstaelld_av_1_1_A : A ;
  jaernhaard_av_1_1_A : A ;
  jaettenoejd_av_1_1_A : A ;
  kabelslagen_av_1_A : A ;
  kaffesugen_av_1_A : A ;
  kallskuren_av_1_A : A ;
  kammarlaerd_av_1_1_A : A ;
  kapitalstinn_av_1_A : A ;
  karlavulen_av_1_A : A ;
  karlgalen_av_1_A : A ;
  karriaerlysten_av_1_1_A : A ;
  kelen_av_1_A : A ;
  klanderfri_av_1_A : A ;
  klandervaerd_av_1_1_A : A ;
  klarvaken_av_1_A : A ;
  klaroegd_av_1_1_A : A ;
  klassmedveten_av_1_A : A ;
  klentrogen_av_1_A : A ;
  klenvuxen_av_1_A : A ;
  klimatmedveten_av_1_A : A ;
  klinkbyggd_av_1_A : A ;
  kluven_av_1_A : A ;
  klaedgalen_av_1_1_A : A ;
  knall_av_1_A : A ;
  knallhaard_av_1_1_A : A ;
  knallorange_av_1_A : A ;
  knivskuren_av_1_A : A ;
  knuten_av_1_A : A ;
  kokmald_av_1_A : A ;
  koldioxidfri_av_1_A : A ;
  kollektivanstaelld_av_1_1_A : A ;
  kommunaegd_av_1_1_A : A ;
  konfliktfylld_av_1_A : A ;
  konfliktstoerd_av_1_1_A : A ;
  konstfrusen_av_1_A : A ;
  konstfoerfaren_av_1_1_A : A ;
  konstgjord_av_1_A : A ;
  konstvaevd_av_1_1_A : A ;
  korthuggen_av_1_A : A ;
  kortvuxen_av_1_A : A ;
  kostnadsfri_av_1_A : A ;
  kooegd_av_1_1_A : A ;
  kringbyggd_av_1_A : A ;
  kringvaervd_av_1_1_A : A ;
  krismedveten_av_1_A : A ;
  kristen_av_1_A : A ;
  kristtrogen_av_1_A : A ;
  krokvuxen_av_1_A : A ;
  krossfri_av_1_A : A ;
  krumpen_av_1_A : A ;
  kry_av_1_A : A ;
  krympfri_av_1_A : A ;
  kraesen_av_1_1_A : A ;
  kulen_av_1_A : A ;
  kvalfylld_av_1_A : A ;
  kvargloemd_av_1_1_A : A ;
  kvickoegd_av_1_1_A : A ;
  kvistfri_av_1_A : A ;
  kvaellsoeppen_av_1_1_A : A ;
  kylslagen_av_1_A : A ;
  kaenslofylld_av_1_1_A : A ;
  kaernfri_av_1_1_A : A ;
  kaernvapenfri_av_1_1_A : A ;
  koensbunden_av_1_1_A : A ;
  koensmogen_av_1_1_A : A ;
  koepgalen_av_1_1_A : A ;
  koerd_av_1_1_A : A ;
  lagbunden_av_1_A : A ;
  lagd_av_1_A : A ;
  lagfaren_av_1_A : A ;
  lagfaangen_av_1_1_A : A ;
  lagvigd_av_1_A : A ;
  laktosfri_av_1_A : A ;
  laserstyrd_av_1_A : A ;
  le_av_1_A : A ;
  ledbruten_av_1_A : A ;
  ledsen_av_1_A : A ;
  leklysten_av_1_A : A ;
  lessen_av_1_A : A ;
  licensfri_av_1_A : A ;
  lidelsefri_av_1_A : A ;
  liknoejd_av_1_1_A : A ;
  likvaerd_av_1_1_A : A ;
  livdoemd_av_1_1_A : A ;
  livegen_av_1_A : A ;
  livstidsdoemd_av_1_1_A : A ;
  ljuslagd_av_1_A : A ;
  lomhoerd_av_1_1_A : A ;
  lovvaerd_av_1_1_A : A ;
  luddfri_av_1_A : A ;
  luden_av_1_A : A ;
  luftburen_av_1_A : A ;
  luftkyld_av_1_A : A ;
  luggsliten_av_1_A : A ;
  luktfri_av_1_A : A ;
  lumpen_av_1_A : A ;
  lustfylld_av_1_A : A ;
  lyhoerd_av_1_1_A : A ;
  lysten_av_1_A : A ;
  laengstfoerfluten_av_1_1_A : A ;
  laerd_av_1_1_A : A ;
  laesvaerd_av_1_1_A : A ;
  laettfaangen_av_1_1_A : A ;
  laettkoerd_av_1_1_A : A ;
  laettrogen_av_1_1_A : A ;
  laettroerd_av_1_1_A : A ;
  laettskraemd_av_1_1_A : A ;
  laettstyrd_av_1_1_A : A ;
  laettoemd_av_1_1_A : A ;
  laagmaeld_av_1_1_A : A ;
  laagvuxen_av_1_1_A : A ;
  laanfaangen_av_1_1_A : A ;
  laangdragen_av_1_1_A : A ;
  laasningsfri_av_1_1_A : A ;
  loerdagsstaengd_av_1_1_A : A ;
  loerdagsoeppen_av_1_1_A : A ;
  loevtunn_av_1_1_A : A ;
  magerlagd_av_1_A : A ;
  maktlysten_av_1_A : A ;
  maktstinn_av_1_A : A ;
  malaeten_av_1_1_A : A ;
  mandeloegd_av_1_1_A : A ;
  mangrann_av_1_A : A ;
  mantalsskriven_av_1_A : A ;
  maskinskriven_av_1_A : A ;
  maskstungen_av_1_A : A ;
  maskaeten_av_1_1_A : A ;
  mattbelagd_av_1_A : A ;
  medfaren_av_1_A : A ;
  medhavd_av_1_A : A ;
  medtagen_av_1_A : A ;
  medveten_av_1_A : A ;
  meningsfylld_av_1_A : A ;
  merbemaeld_av_1_1_A : A ;
  mild_av_1_A : A ;
  mildoegd_av_1_1_A : A ;
  miljoemedveten_av_1_1_A : A ;
  minnesvaerd_av_1_1_A : A ;
  missbelaaten_av_1_1_A : A ;
  missnoejd_av_1_1_A : A ;
  misstrogen_av_1_A : A ;
  mjoelkstinn_av_1_1_A : A ;
  modfaelld_av_1_1_A : A ;
  modstulen_av_1_A : A ;
  mogen_av_1_A : A ;
  mollstaemd_av_1_1_A : A ;
  molnfri_av_1_A : A ;
  molnhoeljd_av_1_1_A : A ;
  moloken_av_1_A : A ;
  morddoemd_av_1_1_A : A ;
  mordlysten_av_1_A : A ;
  mossbelupen_av_1_A : A ;
  mulen_av_1_A : A ;
  multen_av_1_A : A ;
  murken_av_1_A : A ;
  maalmedveten_av_1_1_A : A ;
  maangbesjungen_av_1_1_A : A ;
  maattbestaelld_av_1_1_A : A ;
  moedofylld_av_1_1_A : A ;
  moenstervaevd_av_1_1_A : A ;
  moerklagd_av_1_1_A : A ;
  naken_av_1_A : A ;
  namnkristen_av_1_A : A ;
  narvhuggen_av_1_A : A ;
  natriumkyld_av_1_A : A ;
  nattfrusen_av_1_A : A ;
  nattgaangen_av_1_1_A : A ;
  nattstaanden_av_1_1_A : A ;
  naturbunden_av_1_A : A ;
  naturtrogen_av_1_A : A ;
  nedbruten_av_1_A : A ;
  neddragen_av_1_A : A ;
  nederlagstyngd_av_1_A : A ;
  nedfaelld_av_1_1_A : A ;
  nedgaangen_av_1_1_A : A ;
  nedlaaten_av_1_1_A : A ;
  nedringd_av_1_A : A ;
  nedskaelld_av_1_1_A : A ;
  nedslagen_av_1_A : A ;
  nedsliten_av_1_A : A ;
  nedsmord_av_1_A : A ;
  nedspilld_av_1_A : A ;
  nedstaemd_av_1_1_A : A ;
  nedsupen_av_1_A : A ;
  nedsutten_av_1_A : A ;
  nedaervd_av_1_1_A : A ;
  nedaatboejd_av_1_1_A : A ;
  nerbruten_av_1_A : A ;
  nerdragen_av_1_A : A ;
  nerfaelld_av_1_1_A : A ;
  nergaangen_av_1_1_A : A ;
  nerlaaten_av_1_1_A : A ;
  nerringd_av_1_A : A ;
  nerskaelld_av_1_1_A : A ;
  nerslagen_av_1_A : A ;
  nersliten_av_1_A : A ;
  nersmord_av_1_A : A ;
  nerspilld_av_1_A : A ;
  nerstaemd_av_1_1_A : A ;
  nersupen_av_1_A : A ;
  nersutten_av_1_A : A ;
  neraervd_av_1_1_A : A ;
  neraatboejd_av_1_1_A : A ;
  njutningslysten_av_1_A : A ;
  noggrann_av_1_A : A ;
  norskaegd_av_1_1_A : A ;
  ny_av_1_A : A ;
  nybliven_av_1_A : A ;
  nybruten_av_1_A : A ;
  nybryggd_av_1_A : A ;
  nyburen_av_1_A : A ;
  nybyggd_av_1_A : A ;
  nyfallen_av_1_A : A ;
  nyfiken_av_1_A : A ;
  nygaangen_av_1_1_A : A ;
  nylagd_av_1_A : A ;
  nytaeljd_av_1_1_A : A ;
  nyuppfoerd_av_1_1_A : A ;
  nyupphaengd_av_1_1_A : A ;
  nyutslagen_av_1_A : A ;
  nyutsprungen_av_1_A : A ;
  nyvald_av_1_A : A ;
  nyvorden_av_1_A : A ;
  naemnvaerd_av_1_1_A : A ;
  naepen_av_1_1_A : A ;
  naerbelaegen_av_1_1_A : A ;
  naergaangen_av_1_1_A : A ;
  naerlagd_av_1_1_A : A ;
  naerskyld_av_1_1_A : A ;
  naestliden_av_1_1_A : A ;
  naetansluten_av_1_1_A : A ;
  noedbjuden_av_1_1_A : A ;
  noedstaelld_av_1_1_A : A ;
  noedtvungen_av_1_1_A : A ;
  noedvuxen_av_1_1_A : A ;
  noejd_av_1_1_A : A ;
  noejeslysten_av_1_1_A : A ;
  oanbefalld_av_1_A : A ;
  oanfoerd_av_1_1_A : A ;
  oanmaeld_av_1_1_A : A ;
  oanstraengd_av_1_1_A : A ;
  oanstaelld_av_1_1_A : A ;
  oansvaelld_av_1_1_A : A ;
  oavbestaelld_av_1_1_A : A ;
  oavbruten_av_1_A : A ;
  oavboejd_av_1_1_A : A ;
  oavdaemd_av_1_1_A : A ;
  oavdoemd_av_1_1_A : A ;
  oavfoerd_av_1_1_A : A ;
  oavgjord_av_1_A : A ;
  oavhaengd_av_1_1_A : A ;
  oavhoerd_av_1_1_A : A ;
  oavkraevd_av_1_1_A : A ;
  oavkyld_av_1_A : A ;
  oavskavd_av_1_A : A ;
  oavsnoerd_av_1_1_A : A ;
  oavstyrd_av_1_A : A ;
  oavstaelld_av_1_1_A : A ;
  oavstaemd_av_1_1_A : A ;
  oavstoerd_av_1_1_A : A ;
  oavvaegd_av_1_1_A : A ;
  oavvaerjd_av_1_1_A : A ;
  obebyggd_av_1_A : A ;
  obedoemd_av_1_1_A : A ;
  obefalld_av_1_A : A ;
  obefaren_av_1_A : A ;
  obegaerd_av_1_1_A : A ;
  obehaengd_av_1_1_A : A ;
  obehoevd_av_1_1_A : A ;
  obemaengd_av_1_1_A : A ;
  obenaegen_av_1_1_A : A ;
  oberoemd_av_1_1_A : A ;
  oberoerd_av_1_1_A : A ;
  obeskuren_av_1_A : A ;
  obeskylld_av_1_A : A ;
  obestaelld_av_1_1_A : A ;
  obestaemd_av_1_1_A : A ;
  obesoerjd_av_1_1_A : A ;
  obetagen_av_1_A : A ;
  obetald_av_1_A : A ;
  objuden_av_1_A : A ;
  obokfoerd_av_1_1_A : A ;
  obortfoerd_av_1_1_A : A ;
  obruten_av_1_A : A ;
  obryggd_av_1_A : A ;
  obunden_av_1_A : A ;
  obyggd_av_1_A : A ;
  oboejd_av_1_1_A : A ;
  oboenhoerd_av_1_1_A : A ;
  odraemd_av_1_1_A : A ;
  odroemd_av_1_1_A : A ;
  odaemd_av_1_1_A : A ;
  odaengd_av_1_1_A : A ;
  odoemd_av_1_1_A : A ;
  oefterfoeljd_av_1_1_A : A ;
  oefterhoerd_av_1_1_A : A ;
  oemotsagd_av_1_A : A ;
  oerfaren_av_1_A : A ;
  oerhoerd_av_1_1_A : A ;
  ofarliggjord_av_1_A : A ;
  offentliganstaelld_av_1_1_A : A ;
  oflaengd_av_1_1_A : A ;
  oframfoerd_av_1_1_A : A ;
  oframhaevd_av_1_1_A : A ;
  oframstaelld_av_1_1_A : A ;
  oframtraengd_av_1_1_A : A ;
  ofri_av_1_A : A ;
  ofullfoeljd_av_1_1_A : A ;
  ofullgaangen_av_1_1_A : A ;
  ofylld_av_1_A : A ;
  ofaelld_av_1_1_A : A ;
  ofoeljd_av_1_1_A : A ;
  ofoeranmaeld_av_1_1_A : A ;
  ofoerbyggd_av_1_1_A : A ;
  ofoerd_av_1_1_A : A ;
  ofoerdroejd_av_1_1_A : A ;
  ofoerdaemd_av_1_1_A : A ;
  ofoerdoemd_av_1_1_A : A ;
  ofoerebyggd_av_1_1_A : A ;
  ofoerestaelld_av_1_1_A : A ;
  ofoerfoeljd_av_1_1_A : A ;
  ofoerfoerd_av_1_1_A : A ;
  ofoergloemd_av_1_1_A : A ;
  ofoergylld_av_1_1_A : A ;
  ofoerhyrd_av_1_1_A : A ;
  ofoerhoejd_av_1_1_A : A ;
  ofoerhoerd_av_1_1_A : A ;
  ofoerkvaevd_av_1_1_A : A ;
  ofoerlaengd_av_1_1_A : A ;
  ofoermaeld_av_1_1_A : A ;
  ofoermoegen_av_1_1_A : A ;
  ofoernoejd_av_1_1_A : A ;
  ofoerskylld_av_1_1_A : A ;
  ofoerskaemd_av_1_1_A : A ;
  ofoerspilld_av_1_1_A : A ;
  ofoerstaelld_av_1_1_A : A ;
  ofoerstaemd_av_1_1_A : A ;
  ofoerstoerd_av_1_1_A : A ;
  ofoersoerjd_av_1_1_A : A ;
  ofoertruten_av_1_1_A : A ;
  ofoertraengd_av_1_1_A : A ;
  ofoertaerd_av_1_1_A : A ;
  ofoertoejd_av_1_1_A : A ;
  ofoerutbestaemd_av_1_1_A : A ;
  ofoervraengd_av_1_1_A : A ;
  ofoervaegen_av_1_1_A : A ;
  ofoervaelld_av_1_1_A : A ;
  ogenomfoerd_av_1_1_A : A ;
  ogenomskoeljd_av_1_1_A : A ;
  ogenomtraengd_av_1_1_A : A ;
  ogjord_av_1_A : A ;
  ogloemd_av_1_1_A : A ;
  ognagd_av_1_A : A ;
  ognavd_av_1_A : A ;
  ograevd_av_1_1_A : A ;
  ogoemd_av_1_1_A : A ;
  ohyrd_av_1_A : A ;
  ohaelld_av_1_1_A : A ;
  ohaenfoerd_av_1_1_A : A ;
  ohaengd_av_1_1_A : A ;
  ohaevd_av_1_1_A : A ;
  ohoejd_av_1_1_A : A ;
  ohoeljd_av_1_1_A : A ;
  ohoerd_av_1_1_A : A ;
  oinbunden_av_1_A : A ;
  oinbyggd_av_1_A : A ;
  oinfoerd_av_1_1_A : A ;
  oinkraevd_av_1_1_A : A ;
  oinlaerd_av_1_1_A : A ;
  oinmaengd_av_1_1_A : A ;
  oinnestaengd_av_1_1_A : A ;
  oinrymd_av_1_A : A ;
  oinstaemd_av_1_1_A : A ;
  oinstaengd_av_1_1_A : A ;
  ointraengd_av_1_1_A : A ;
  oinvigd_av_1_A : A ;
  oinvaevd_av_1_1_A : A ;
  ojaemfoerd_av_1_1_A : A ;
  ojaemstaelld_av_1_1_A : A ;
  oklaemd_av_1_1_A : A ;
  oklaengd_av_1_1_A : A ;
  oknaeboejd_av_1_1_A : A ;
  okorsfoerhoerd_av_1_1_A : A ;
  okraengd_av_1_1_A : A ;
  okraevd_av_1_1_A : A ;
  okvald_av_1_A : A ;
  okvardroejd_av_1_1_A : A ;
  okvaeden_av_1_1_A : A ;
  okvaevd_av_1_1_A : A ;
  okyld_av_1_A : A ;
  okoerd_av_1_1_A : A ;
  okoevd_av_1_1_A : A ;
  olejd_av_1_A : A ;
  oljefri_av_1_A : A ;
  oljeriven_av_1_A : A ;
  olaengd_av_1_1_A : A ;
  olaerd_av_1_1_A : A ;
  omedfoerd_av_1_1_A : A ;
  omedveten_av_1_A : A ;
  omgjord_av_1_A : A ;
  omild_av_1_A : A ;
  omogen_av_1_A : A ;
  omotsagd_av_1_A : A ;
  omotvaegd_av_1_1_A : A ;
  omskriven_av_1_A : A ;
  omskruten_av_1_A : A ;
  omaengd_av_1_1_A : A ;
  onaerd_av_1_1_A : A ;
  oombestyrd_av_1_A : A ;
  oombesoerjd_av_1_1_A : A ;
  oomfoerd_av_1_1_A : A ;
  oomhoeljd_av_1_1_A : A ;
  oomskuren_av_1_A : A ;
  oomvaelvd_av_1_1_A : A ;
  oomvaervd_av_1_1_A : A ;
  oploejd_av_1_1_A : A ;
  oppbunden_av_1_A : A ;
  oppflugen_av_1_A : A ;
  oppfaelld_av_1_1_A : A ;
  oppgjord_av_1_A : A ;
  opphoejd_av_1_1_A : A ;
  oppknuten_av_1_A : A ;
  oppkoerd_av_1_1_A : A ;
  opplagd_av_1_A : A ;
  opptagen_av_1_A : A ;
  oppvuxen_av_1_A : A ;
  opaafoerd_av_1_1_A : A ;
  opaatald_av_1_1_A : A ;
  orange_av_1_A : A ;
  ordagrann_av_1_A : A ;
  ordtrogen_av_1_A : A ;
  oregelbunden_av_1_A : A ;
  oringd_av_1_A : A ;
  orsaksbestaemd_av_1_1_A : A ;
  orymd_av_1_A : A ;
  oraettfaangen_av_1_1_A : A ;
  oroejd_av_1_1_A : A ;
  oroerd_av_1_1_A : A ;
  osagd_av_1_A : A ;
  osamkoerd_av_1_1_A : A ;
  osammanfoerd_av_1_1_A : A ;
  osammanringd_av_1_A : A ;
  osammanstaelld_av_1_1_A : A ;
  osammanvaevd_av_1_1_A : A ;
  osann_av_1_A : A ;
  oskavd_av_1_A : A ;
  oskriven_av_1_A : A ;
  oskyld_av_1_A : A ;
  oskyld_2_av_1_A : A ;
  oslagen_av_1_A : A ;
  osmord_av_1_A : A ;
  osnuten_av_1_A : A ;
  ospard_av_1_A : A ;
  ostruken_av_1_A : A ;
  ostaemd_av_1_1_A : A ;
  ostoerd_av_1_1_A : A ;
  osvuren_av_1_A : A ;
  osaald_av_1_1_A : A ;
  otillfredsstaelld_av_1_1_A : A ;
  otillaaten_av_1_1_A : A ;
  otrogen_av_1_A : A ;
  otursfoerfoeljd_av_1_1_A : A ;
  otvungen_av_1_A : A ;
  otaemd_av_1_1_A : A ;
  otaemjd_av_1_1_A : A ;
  ouppfylld_av_1_A : A ;
  ouppgjord_av_1_A : A ;
  ouppskuren_av_1_A : A ;
  ouppvaermd_av_1_1_A : A ;
  outgiven_av_1_A : A ;
  outhyrd_av_1_A : A ;
  outsagd_av_1_A : A ;
  outvuxen_av_1_A : A ;
  oveten_av_1_A : A ;
  ovigd_av_1_A : A ;
  ooeverlagd_av_1_1_A : A ;
  ooevervaegd_av_1_1_A : A ;
  panikslagen_av_1_A : A ;
  pengastinn_av_1_A : A ;
  penningstinn_av_1_A : A ;
  perenn_av_1_A : A ;
  pivothaengd_av_1_1_A : A ;
  pivaahaengd_av_1_1_A : A ;
  planskild_av_1_A : A ;
  plastbunden_av_1_A : A ;
  pliktfoergaeten_av_1_1_A : A ;
  pliktmedveten_av_1_A : A ;
  plikttrogen_av_1_A : A ;
  portofri_av_1_A : A ;
  prestigefylld_av_1_A : A ;
  prickfri_av_1_A : A ;
  prismedveten_av_1_A : A ;
  prisvaerd_av_1_1_A : A ;
  privatanstaelld_av_1_1_A : A ;
  privataegd_av_1_1_A : A ;
  problemfri_av_1_A : A ;
  purken_av_1_A : A ;
  paaflugen_av_1_1_A : A ;
  paastruken_av_1_1_A : A ;
  radiostyrd_av_1_A : A ;
  reaktionsbenaegen_av_1_1_A : A ;
  receptbelagd_av_1_A : A ;
  receptfri_av_1_A : A ;
  redobogen_av_1_A : A ;
  reformbenaegen_av_1_1_A : A ;
  regelbunden_av_1_A : A ;
  regeringsstyrd_av_1_A : A ;
  ressugen_av_1_A : A ;
  revanschlysten_av_1_A : A ;
  revanschsugen_av_1_A : A ;
  riskfri_av_1_A : A ;
  riskfylld_av_1_A : A ;
  rofylld_av_1_A : A ;
  rosettstaelld_av_1_1_A : A ;
  rostfri_av_1_A : A ;
  rovlysten_av_1_A : A ;
  rullstolsbunden_av_1_A : A ;
  rundlagd_av_1_A : A ;
  rutten_av_1_A : A ;
  rynkfri_av_1_A : A ;
  rysansvaerd_av_1_1_A : A ;
  raeddhaagsen_av_1_1_A : A ;
  raettrogen_av_1_1_A : A ;
  raa_av_1_1_A : A ;
  raaroerd_av_1_1_A : A ;
  raattaeten_av_1_1_A : A ;
  roedgraaten_av_1_1_A : A ;
  roedspraengd_av_1_1_A : A ;
  roedoegd_av_1_1_A : A ;
  roekfri_av_1_1_A : A ;
  roeksugen_av_1_1_A : A ;
  roerd_av_1_1_A : A ;
  sadelbruten_av_1_A : A ;
  saltbemaengd_av_1_1_A : A ;
  samfaelld_av_1_1_A : A ;
  sammald_av_1_A : A ;
  sammalen_av_1_A : A ;
  sammanbiten_av_1_A : A ;
  sammanhaallen_av_1_1_A : A ;
  sammanlagd_av_1_A : A ;
  sammanslagen_av_1_A : A ;
  sammantagen_av_1_A : A ;
  samstaemd_av_1_1_A : A ;
  samvetsgrann_av_1_A : A ;
  sann_av_1_A : A ;
  schemabunden_av_1_A : A ;
  schemalagd_av_1_A : A ;
  segdragen_av_1_A : A ;
  segelfri_av_1_A : A ;
  seglingsfri_av_1_A : A ;
  segmogen_av_1_A : A ;
  segsliten_av_1_A : A ;
  selbruten_av_1_A : A ;
  semesterstaengd_av_1_1_A : A ;
  sensationslysten_av_1_A : A ;
  sevaerd_av_1_1_A : A ;
  sicken_av_1_A : A ;
  sinnessloe_av_1_1_A : A ;
  sistliden_av_1_A : A ;
  sjaelvbelaaten_av_1_1_A : A ;
  sjaelvfallen_av_1_1_A : A ;
  sjaelvlaerd_av_1_1_A : A ;
  sjaelvmedveten_av_1_1_A : A ;
  sjaelvmordsbenaegen_av_1_1_A : A ;
  sjaelvpaatagen_av_1_1_A : A ;
  sjaelvskriven_av_1_1_A : A ;
  sjaelvupplevd_av_1_1_A : A ;
  sjaelvupptagen_av_1_1_A : A ;
  sjaelvvald_av_1_1_A : A ;
  sjoevild_av_1_1_A : A ;
  skambelagd_av_1_A : A ;
  skamsen_av_1_A : A ;
  skarpskuren_av_1_A : A ;
  skarpoegd_av_1_1_A : A ;
  skattefri_av_1_A : A ;
  skeloegd_av_1_1_A : A ;
  skeppsbruten_av_1_A : A ;
  sketen_av_1_A : A ;
  skild_av_1_A : A ;
  skogbevuxen_av_1_A : A ;
  skolmogen_av_1_A : A ;
  skrajsen_av_1_A : A ;
  skrattlysten_av_1_A : A ;
  skriftlaerd_av_1_1_A : A ;
  skrumpen_av_1_A : A ;
  skrupelfri_av_1_A : A ;
  skrynkelfri_av_1_A : A ;
  skraeckfylld_av_1_1_A : A ;
  skraeckslagen_av_1_1_A : A ;
  skraa_av_1_1_A : A ;
  skuldfri_av_1_A : A ;
  skuldmedveten_av_1_A : A ;
  skuldtyngd_av_1_A : A ;
  skumoegd_av_1_1_A : A ;
  skyddsvaerd_av_1_1_A : A ;
  skyld_av_1_A : A ;
  skaemd_av_1_1_A : A ;
  slagroerd_av_1_1_A : A ;
  sliten_av_1_A : A ;
  sluten_av_1_A : A ;
  slutkoerd_av_1_1_A : A ;
  slutsaald_av_1_1_A : A ;
  slaengd_av_1_1_A : A ;
  slaetstruken_av_1_1_A : A ;
  sloe_av_1_1_A : A ;
  smittfri_av_1_A : A ;
  smutsorange_av_1_A : A ;
  smaertfri_av_1_1_A : A ;
  smaaskuren_av_1_1_A : A ;
  smaavuxen_av_1_1_A : A ;
  snabbgjord_av_1_A : A ;
  snarkfri_av_1_A : A ;
  snarstucken_av_1_A : A ;
  snedgaangen_av_1_1_A : A ;
  snedskuren_av_1_A : A ;
  snedoegd_av_1_1_A : A ;
  sniken_av_1_A : A ;
  snopen_av_1_A : A ;
  snoetyngd_av_1_1_A : A ;
  sockerfri_av_1_A : A ;
  soldrucken_av_1_A : A ;
  solenn_av_1_A : A ;
  solmogen_av_1_A : A ;
  soluppvaermd_av_1_1_A : A ;
  sorgbunden_av_1_A : A ;
  sorgfri_av_1_A : A ;
  sorgsen_av_1_A : A ;
  sorgtyngd_av_1_A : A ;
  spefylld_av_1_A : A ;
  spelsugen_av_1_A : A ;
  spicken_av_1_A : A ;
  spindeltunn_av_1_A : A ;
  spindelvaevstunn_av_1_1_A : A ;
  splitterny_av_1_A : A ;
  spraengfylld_av_1_1_A : A ;
  spraenglaerd_av_1_1_A : A ;
  stamanstaelld_av_1_1_A : A ;
  statsanstaelld_av_1_1_A : A ;
  statsaegd_av_1_1_A : A ;
  stelfrusen_av_1_A : A ;
  stenhaard_av_1_1_A : A ;
  steningsdoemd_av_1_1_A : A ;
  stenlagd_av_1_A : A ;
  stinn_av_1_A : A ;
  stjaernoegd_av_1_1_A : A ;
  stoftfylld_av_1_A : A ;
  storslagen_av_1_A : A ;
  storvulen_av_1_A : A ;
  storvuxen_av_1_A : A ;
  storoegd_av_1_1_A : A ;
  straffri_av_1_A : A ;
  stridslysten_av_1_A : A ;
  strykfri_av_1_A : A ;
  stucken_av_1_A : A ;
  staelld_av_1_1_A : A ;
  staemningstyngd_av_1_1_A : A ;
  staalhaard_av_1_1_A : A ;
  sugen_av_1_A : A ;
  surmulen_av_1_A : A ;
  suroegd_av_1_1_A : A ;
  svenskaegd_av_1_1_A : A ;
  svullen_av_1_A : A ;
  svulten_av_1_A : A ;
  svuren_av_1_A : A ;
  svaengd_av_1_1_A : A ;
  svaarbedoemd_av_1_1_A : A ;
  svaarsjungen_av_1_1_A : A ;
  svaarsaald_av_1_1_A : A ;
  symptomfri_av_1_A : A ;
  symtomfri_av_1_A : A ;
  syndfri_av_1_A : A ;
  saellspord_av_1_1_A : A ;
  saeregen_av_1_1_A : A ;
  saerskild_av_1_1_A : A ;
  saald_av_1_1_A : A ;
  soemndrucken_av_1_1_A : A ;
  soenderkoerd_av_1_1_A : A ;
  tabubelagd_av_1_A : A ;
  tadelfri_av_1_A : A ;
  tagen_av_1_A : A ;
  talgoegd_av_1_1_A : A ;
  taltraengd_av_1_1_A : A ;
  temperamentsfri_av_1_A : A ;
  tidsbunden_av_1_A : A ;
  tidsinstaelld_av_1_1_A : A ;
  tidsmedveten_av_1_A : A ;
  tidstrogen_av_1_A : A ;
  tillbakadragen_av_1_A : A ;
  tillbyggd_av_1_A : A ;
  tillfredsstaelld_av_1_1_A : A ;
  tillgiven_av_1_A : A ;
  tillgjord_av_1_A : A ;
  tillintetgjord_av_1_A : A ;
  tillsammantagen_av_1_A : A ;
  tillslagen_av_1_A : A ;
  tillspillogiven_av_1_A : A ;
  tilltagen_av_1_A : A ;
  tilltagsen_av_1_A : A ;
  tillaendalupen_av_1_1_A : A ;
  tillaaten_av_1_1_A : A ;
  tjaelfri_av_1_1_A : A ;
  tjaelfrusen_av_1_1_A : A ;
  tocken_av_1_A : A ;
  tomoegd_av_1_1_A : A ;
  toppen_av_1_A : A ;
  toppstyrd_av_1_A : A ;
  torroegd_av_1_1_A : A ;
  traditionsbunden_av_1_A : A ;
  traditionstyngd_av_1_A : A ;
  trasgrann_av_1_A : A ;
  trestruken_av_1_A : A ;
  treven_av_1_A : A ;
  trilsken_av_1_A : A ;
  trogen_av_1_A : A ;
  trosslagen_av_1_A : A ;
  trovaerd_av_1_1_A : A ;
  trumpen_av_1_A : A ;
  traedmogen_av_1_1_A : A ;
  traefri_av_1_1_A : A ;
  traegen_av_1_1_A : A ;
  traengd_av_1_1_A : A ;
  traetlysten_av_1_1_A : A ;
  traadsliten_av_1_1_A : A ;
  troettkoerd_av_1_1_A : A ;
  tullfri_av_1_A : A ;
  tungkoerd_av_1_1_A : A ;
  tungsoevd_av_1_1_A : A ;
  tunn_av_1_A : A ;
  tunnsliten_av_1_A : A ;
  tvehaagsen_av_1_1_A : A ;
  tvungen_av_1_A : A ;
  tvaerhuggen_av_1_1_A : A ;
  tvaerilsken_av_1_1_A : A ;
  tvaerskuren_av_1_1_A : A ;
  tvaastruken_av_1_1_A : A ;
  tyckmycken_av_1_A : A ;
  tyken_av_1_A : A ;
  tystlaaten_av_1_1_A : A ;
  taenkvaerd_av_1_1_A : A ;
  taerd_av_1_1_A : A ;
  taettbebyggd_av_1_1_A : A ;
  taettskriven_av_1_1_A : A ;
  taaroegd_av_1_1_A : A ;
  toeckenhoeljd_av_1_1_A : A ;
  undangjord_av_1_A : A ;
  undangoemd_av_1_1_A : A ;
  undanlagd_av_1_A : A ;
  undanskymd_av_1_A : A ;
  undanstaelld_av_1_1_A : A ;
  undantagsfri_av_1_A : A ;
  underfoersoerjd_av_1_1_A : A ;
  undergiven_av_1_A : A ;
  underhaallsfri_av_1_1_A : A ;
  underkyld_av_1_A : A ;
  underlaegsen_av_1_1_A : A ;
  undermedveten_av_1_A : A ;
  undernaerd_av_1_1_A : A ;
  understucken_av_1_A : A ;
  understyrd_av_1_A : A ;
  undfallen_av_1_A : A ;
  undransvaerd_av_1_1_A : A ;
  unken_av_1_A : A ;
  uppbunden_av_1_A : A ;
  uppburen_av_1_A : A ;
  uppdaemd_av_1_1_A : A ;
  uppflugen_av_1_A : A ;
  uppfaelld_av_1_1_A : A ;
  uppgiven_av_1_A : A ;
  uppgjord_av_1_A : A ;
  upphoejd_av_1_1_A : A ;
  uppknuten_av_1_A : A ;
  uppkoerd_av_1_1_A : A ;
  upplagd_av_1_A : A ;
  upplupen_av_1_A : A ;
  upploejd_av_1_1_A : A ;
  uppringd_av_1_A : A ;
  uppriven_av_1_A : A ;
  upprutten_av_1_A : A ;
  upprymd_av_1_A : A ;
  upproerd_av_1_1_A : A ;
  uppsagd_av_1_A : A ;
  uppskraemd_av_1_1_A : A ;
  uppsluppen_av_1_A : A ;
  uppstaanden_av_1_1_A : A ;
  uppsvullen_av_1_A : A ;
  uppsvaelld_av_1_1_A : A ;
  upptagen_av_1_A : A ;
  uppvuxen_av_1_A : A ;
  uppaatboejd_av_1_1_A : A ;
  urfaelld_av_1_1_A : A ;
  urnupen_av_1_A : A ;
  urtagen_av_1_A : A ;
  urvuxen_av_1_A : A ;
  utbyggd_av_1_A : A ;
  utdragen_av_1_A : A ;
  utdrucken_av_1_A : A ;
  utflugen_av_1_A : A ;
  utfrusen_av_1_A : A ;
  utkyld_av_1_A : A ;
  utkoerd_av_1_1_A : A ;
  utledsen_av_1_A : A ;
  utlaerd_av_1_1_A : A ;
  utsagd_av_1_A : A ;
  utskaelld_av_1_1_A : A ;
  utskaemd_av_1_1_A : A ;
  utslagen_av_1_A : A ;
  utsliten_av_1_A : A ;
  utsprungen_av_1_A : A ;
  utstyrd_av_1_A : A ;
  utstaelld_av_1_1_A : A ;
  utsvulten_av_1_A : A ;
  utsvaengd_av_1_1_A : A ;
  utsaald_av_1_1_A : A ;
  utsoevd_av_1_1_A : A ;
  uttaenjd_av_1_1_A : A ;
  uttoejd_av_1_1_A : A ;
  utvald_av_1_A : A ;
  utvecklingsstoerd_av_1_1_A : A ;
  utaatboejd_av_1_1_A : A ;
  vaken_av_1_A : A ;
  valen_av_1_A : A ;
  valfri_av_1_A : A ;
  vanekristen_av_1_A : A ;
  vantrogen_av_1_A : A ;
  vapenfri_av_1_A : A ;
  vattenburen_av_1_A : A ;
  vattenfri_av_1_A : A ;
  vattenfylld_av_1_A : A ;
  vattenkyld_av_1_A : A ;
  veckony_av_1_A : A ;
  vedertagen_av_1_A : A ;
  verklighetstrogen_av_1_A : A ;
  vettskraemd_av_1_1_A : A ;
  vidoeppen_av_1_1_A : A ;
  vild_av_1_A : A ;
  vildvuxen_av_1_A : A ;
  vilsegaangen_av_1_1_A : A ;
  vilsen_av_1_A : A ;
  vinddriven_av_1_A : A ;
  vindoegd_av_1_1_A : A ;
  vingbruten_av_1_A : A ;
  vinningslysten_av_1_A : A ;
  vissen_av_1_A : A ;
  vittberoemd_av_1_1_A : A ;
  vriden_av_1_A : A ;
  vuxen_av_1_A : A ;
  vaederbiten_av_1_1_A : A ;
  vaederstinn_av_1_1_A : A ;
  vaelavvaegd_av_1_1_A : A ;
  vaelbehaallen_av_1_1_A : A ;
  vaelbelaegen_av_1_1_A : A ;
  vaelbestaelld_av_1_1_A : A ;
  vaelbetald_av_1_1_A : A ;
  vaelboren_av_1_1_A : A ;
  vaelbyggd_av_1_1_A : A ;
  vaelfylld_av_1_1_A : A ;
  vaelgjord_av_1_1_A : A ;
  vaelhaengd_av_1_1_A : A ;
  vaelhaallen_av_1_1_A : A ;
  vaelnaerd_av_1_1_A : A ;
  vaelploejd_av_1_1_A : A ;
  vaelskriven_av_1_1_A : A ;
  vaelskuren_av_1_1_A : A ;
  vaelsmord_av_1_1_A : A ;
  vaelstaelld_av_1_1_A : A ;
  vaeltagen_av_1_1_A : A ;
  vaelvd_av_1_1_A : A ;
  vaelvuxen_av_1_1_A : A ;
  vaenstervriden_av_1_1_A : A ;
  vaerd_av_1_1_A : A ;
  vaerderingsfri_av_1_1_A : A ;
  vaerkbruten_av_1_1_A : A ;
  vaerldsberoemd_av_1_1_A : A ;
  vaerldserfaren_av_1_1_A : A ;
  vaesensskild_av_1_1_A : A ;
  vaetskefylld_av_1_1_A : A ;
  vaevburen_av_1_1_A : A ;
  vaaldtaektsdoemd_av_1_1_A : A ;
  voerdnadsvaerd_av_1_1_A : A ;
  whiskysprucken_av_1_A : A ;
  yllen_av_1_A : A ;
  ynkansvaerd_av_1_1_A : A ;
  yrvaken_av_1_A : A ;
  yverboren_av_1_A : A ;
  aelskvaerd_av_1_1_A : A ;
  aerefoergaeten_av_1_1_A : A ;
  aerelysten_av_1_1_A : A ;
  aerofylld_av_1_1_A : A ;
  aeventyrslysten_av_1_1_A : A ;
  aalderstigen_av_1_1_A : A ;
  aalderstyngd_av_1_1_A : A ;
  aangestfylld_av_1_1_A : A ;
  aapen_av_1_1_A : A ;
  aatgaangen_av_1_1_A : A ;
  aatraavaerd_av_1_1_A : A ;
  oedesbestaemd_av_1_1_A : A ;
  oemkansvaerd_av_1_1_A : A ;
  oenskvaerd_av_1_1_A : A ;
  oeppen_av_1_1_A : A ;
  oeverbliven_av_1_1_A : A ;
  oeverbyggd_av_1_1_A : A ;
  oeverdriven_av_1_1_A : A ;
  oeverfylld_av_1_1_A : A ;
  oeverfoerd_av_1_1_A : A ;
  oevergiven_av_1_1_A : A ;
  oeverkoerd_av_1_1_A : A ;
  oeverlagd_av_1_1_A : A ;
  oeverlupen_av_1_1_A : A ;
  oeverlaegsen_av_1_1_A : A ;
  oevermogen_av_1_1_A : A ;
  oeversiggiven_av_1_1_A : A ;
  oeverstyrd_av_1_1_A : A ;
  oeverstaanden_av_1_1_A : A ;
  oevervuxen_av_1_1_A : A ;
  Bristoltrakt_nn_1_N : N ;
  C14_metod_nn_1_N : N ;
  E_godkaend_av_1_1_A : A ;
  Eisenhowerepok_nn_1_N : N ;
  Europaunion_nn_1_N : N ;
  IB_avsloejande_nn_1_1_N : N ;
  Internet_nn_1_N : N ;
  Ljubjankafaengelse_nn_1_1_N : N ;
  Nationalencyklopedi_nn_1_N : N ;
  OCR_ande_nn_1_N : N ;
  OCRande_nn_1_N : N ;
  OK_av_1_A : A ;
  Risk_nn_1_N : N ;
  Stillahavsfiske_nn_1_N : N ;
  Stockholmsomraade_nn_1_1_N : N ;
  USA_vaenlig_av_1_1_A : A ;
  abbrevierbarhet_nn_1_N : N ;
  abdikerbarhet_nn_1_N : N ;
  abonnerbarhet_nn_1_N : N ;
  aborterbarhet_nn_1_N : N ;
  abortraadgivning_nn_1_1_N : N ;
  abraderbarhet_nn_1_N : N ;
  abrupthet_nn_1_N : N ;
  absoluthet_nn_1_N : N ;
  absolverbarhet_nn_1_N : N ;
  absorberbarhet_nn_1_N : N ;
  abstraherbarhet_nn_1_N : N ;
  abstrakthet_nn_1_N : N ;
  absurdhet_nn_1_N : N ;
  accederbarhet_nn_1_N : N ;
  accelererbarhet_nn_1_N : N ;
  accentuerbarhet_nn_1_N : N ;
  accepterbarhet_nn_1_N : N ;
  acklimatiserbarhet_nn_1_N : N ;
  ackommoderbarhet_nn_1_N : N ;
  ackompanjerbarhet_nn_1_N : N ;
  ackorderbarhet_nn_1_N : N ;
  ackrediterbarhet_nn_1_N : N ;
  ackumulerbarhet_nn_1_N : N ;
  ackvirerbarhet_nn_1_N : N ;
  adamsdraekt_nn_1_1_N : N ;
  adapterbarhet_nn_1_N : N ;
  adderbarhet_nn_1_N : N ;
  adelshoegfaerd_nn_1_1_N : N ;
  adenoid_av_1_A : A ;
  adjungerbarhet_nn_1_N : N ;
  adlighet_nn_1_N : N ;
  administrerbarhet_nn_1_N : N ;
  adopterbarhet_nn_1_N : N ;
  adresserbarhet_nn_1_N : N ;
  adsorberbarhet_nn_1_N : N ;
  adstringerande_av_1_A : A ;
  aducerbarhet_nn_1_N : N ;
  advocerbarhet_nn_1_N : N ;
  advokathjaelp_nn_1_1_N : N ;
  aerologi_nn_1_N : N ;
  aerosolform_nn_1_N : N ;
  afficierbarhet_nn_1_N : N ;
  affinerbarhet_nn_1_N : N ;
  affischerbarhet_nn_1_N : N ;
  affaersdrivande_av_1_1_A : A ;
  affaersmaessighet_nn_1_1_N : N ;
  afrikaans_nn_1_N : N ;
  afrikaniserbarhet_nn_1_N : N ;
  agerbarhet_nn_1_N : N ;
  aggande_av_1_A : A ;
  agglomererbarhet_nn_1_N : N ;
  agglutinerbarhet_nn_1_N : N ;
  agiterbarhet_nn_1_N : N ;
  agorafobi_nn_1_N : N ;
  agrikulturkemi_nn_1_N : N ;
  agronomi_nn_1_N : N ;
  ajour_av_1_A : A ;
  ajournerbarhet_nn_1_N : N ;
  akribi_nn_1_N : N ;
  aktiesparande_nn_1_N : N ;
  aktiverbarhet_nn_1_N : N ;
  aktningsfullhet_nn_1_N : N ;
  aktningsvaerdhet_nn_1_1_N : N ;
  aktualiserbarhet_nn_1_N : N ;
  akuthjaelp_nn_1_1_N : N ;
  akutvaard_nn_1_1_N : N ;
  alabasterliknande_av_1_A : A ;
  alarmerande_av_1_A : A ;
  alarmerbarhet_nn_1_N : N ;
  albuminuri_nn_1_N : N ;
  ale_nn_1_N : N ;
  alfabetiserbarhet_nn_1_N : N ;
  algologi_nn_1_N : N ;
  algonk_nn_1_N : N ;
  alienerbarhet_nn_1_N : N ;
  alkaliblaatt_nn_1_1_N : N ;
  alkemi_nn_1_N : N ;
  alkoholmissbrukande_nn_1_N : N ;
  alkoholsvaghet_nn_1_N : N ;
  alldaglighet_nn_1_N : N ;
  allegoriserbarhet_nn_1_N : N ;
  allehanda_av_1_A : A ;
  allemansraett_nn_1_1_N : N ;
  allen_av_1_A : A ;
  allena_av_1_A : A ;
  allenaraadande_av_1_1_A : A ;
  allergologi_nn_1_N : N ;
  allierbarhet_nn_1_N : N ;
  allittererbarhet_nn_1_N : N ;
  allmakt_nn_1_N : N ;
  allmaenfarlighet_nn_1_1_N : N ;
  allmaenmaensklighet_nn_1_1_N : N ;
  allmaennelighet_nn_1_1_N : N ;
  allmaennyttighet_nn_1_1_N : N ;
  allmaenpraktiserande_av_1_1_A : A ;
  allokerbarhet_nn_1_N : N ;
  allomfattande_av_1_A : A ;
  allopati_nn_1_N : N ;
  allraheligaste_av_1_A : A ;
  allround_av_1_A : A ;
  allseende_av_1_A : A ;
  allsidighet_nn_1_N : N ;
  allskoens_av_1_1_A : A ;
  allsmaektighet_nn_1_1_N : N ;
  allsvaaldighet_nn_1_1_N : N ;
  alltomfattande_av_1_A : A ;
  alluderbarhet_nn_1_N : N ;
  allvarlighet_nn_1_N : N ;
  allvarstyngdhet_nn_1_N : N ;
  allvetande_av_1_A : A ;
  allvishet_nn_1_N : N ;
  allvaeders_av_1_1_A : A ;
  alme_nn_1_N : N ;
  alteasirap_nn_1_N : N ;
  alternerbarhet_nn_1_N : N ;
  aluminerbarhet_nn_1_N : N ;
  amalgamerbarhet_nn_1_N : N ;
  amatoermaessighet_nn_1_1_N : N ;
  ambidextri_nn_1_N : N ;
  ambiofoni_nn_1_N : N ;
  ambulerbarhet_nn_1_N : N ;
  amerikaniserbarhet_nn_1_N : N ;
  amning_nn_1_N : N ;
  amorterbarhet_nn_1_N : N ;
  amperhet_nn_1_N : N ;
  amplifierbarhet_nn_1_N : N ;
  amplitudmodulerbarhet_nn_1_N : N ;
  amputerbarhet_nn_1_N : N ;
  analyserbarhet_nn_1_N : N ;
  anarki_nn_1_N : N ;
  anatomi_nn_1_N : N ;
  andaktsfullhet_nn_1_N : N ;
  andaktsutoevning_nn_1_1_N : N ;
  andefattighet_nn_1_N : N ;
  andeloeshet_nn_1_1_N : N ;
  andfaaddhet_nn_1_1_N : N ;
  andlighet_nn_1_N : N ;
  andloeshet_nn_1_1_N : N ;
  andmat_nn_1_N : N ;
  andnoed_nn_1_1_N : N ;
  andraplans_av_1_A : A ;
  androfobi_nn_1_N : N ;
  androgynhet_nn_1_N : N ;
  andryghet_nn_1_N : N ;
  andtrutenhet_nn_1_N : N ;
  andaektighet_nn_1_1_N : N ;
  anestesiologi_nn_1_N : N ;
  angelologi_nn_1_N : N ;
  angenaemhet_nn_1_1_N : N ;
  angiografi_nn_1_N : N ;
  angiologi_nn_1_N : N ;
  angiverilag_nn_1_N : N ;
  angliserbarhet_nn_1_N : N ;
  angoraull_nn_1_N : N ;
  angraensande_av_1_1_A : A ;
  anhoerighet_nn_1_1_N : N ;
  anhoeriginvandring_nn_1_1_N : N ;
  animerbarhet_nn_1_N : N ;
  ankommenhet_nn_1_N : N ;
  anlupenhet_nn_1_N : N ;
  anlaeggande_nn_1_1_N : N ;
  anlaeggning_nn_2_1_N : N ;
  anmaelningsplikt_nn_1_1_N : N ;
  anmaerkningsvaerdhet_nn_1_1_N : N ;
  annalkande_av_1_A : A ;
  annalkande_nn_1_N : N ;
  annekterbarhet_nn_1_N : N ;
  annihilerbarhet_nn_1_N : N ;
  annonserbarhet_nn_1_N : N ;
  annorlunda_av_1_A : A ;
  annoterbarhet_nn_1_N : N ;
  annullerbarhet_nn_1_N : N ;
  anodiserbarhet_nn_1_N : N ;
  anonymhet_nn_1_N : N ;
  anonymiserbarhet_nn_1_N : N ;
  anorektiskhet_nn_1_N : N ;
  anpart_nn_1_N : N ;
  anpassbarhet_nn_1_N : N ;
  anpasslighet_nn_1_N : N ;
  anrikhet_nn_1_N : N ;
  anseddhet_nn_1_N : N ;
  ansenlighet_nn_1_N : N ;
  ansiktsblind_av_1_A : A ;
  ansiktsigenkaenning_nn_1_1_N : N ;
  anslagsbeviljande_av_1_A : A ;
  anslagsgivande_av_1_A : A ;
  anslaaende_av_1_1_A : A ;
  anspraaksfullhet_nn_1_1_N : N ;
  anspaend_av_1_1_A : A ;
  anspaendhet_nn_1_1_N : N ;
  anstaltsvaard_nn_1_1_N : N ;
  anstrukenhet_nn_1_N : N ;
  anstraengande_av_1_1_A : A ;
  anstraengdhet_nn_1_1_N : N ;
  anstuckenhet_nn_1_N : N ;
  anstaellningstrygghet_nn_1_1_N : N ;
  ansvarighet_nn_1_N : N ;
  ansvarsfullhet_nn_1_N : N ;
  ansvarskaennande_av_1_1_A : A ;
  ansvarskaennande_nn_1_1_N : N ;
  ansvarsloeshet_nn_1_1_N : N ;
  ansvarstagande_av_1_A : A ;
  ansvarstagande_nn_1_N : N ;
  ansvaelldhet_nn_1_1_N : N ;
  antaglighet_nn_1_N : N ;
  anteciperbarhet_nn_1_N : N ;
  antedaterbarhet_nn_1_N : N ;
  anti_av_1_A : A ;
  antichambrerbarhet_nn_1_N : N ;
  antikiserbarhet_nn_1_N : N ;
  antimateria_nn_1_N : N ;
  antipsykiatri_nn_1_N : N ;
  antropofagi_nn_1_N : N ;
  antropologi_nn_1_N : N ;
  antroposofi_nn_1_N : N ;
  antraeffbarhet_nn_1_1_N : N ;
  anvaendarvaenlighet_nn_1_1_N : N ;
  aorta_nn_1_N : N ;
  apa_av_1_A : A ;
  apliknande_av_1_A : A ;
  apostroferbarhet_nn_1_N : N ;
  appellerbarhet_nn_1_N : N ;
  applicerbarhet_nn_1_N : N ;
  applaaderbarhet_nn_1_1_N : N ;
  apporterbarhet_nn_1_N : N ;
  apprecierbarhet_nn_1_N : N ;
  appreterbarhet_nn_1_N : N ;
  approcherbarhet_nn_1_N : N ;
  approximerbarhet_nn_1_N : N ;
  apterbarhet_nn_1_N : N ;
  aptitretande_av_1_A : A ;
  arabisktalande_av_1_A : A ;
  arabvaerld_nn_1_1_N : N ;
  arbetsamhet_nn_1_N : N ;
  arbetsbesparande_av_1_A : A ;
  arbetsduglighet_nn_1_N : N ;
  arbetsform_nn_1_N : N ;
  arbetsfred_nn_1_N : N ;
  arbetsfoerdelning_nn_1_1_N : N ;
  arbetsfoerhet_nn_1_1_N : N ;
  arbetsintensitet_nn_1_N : N ;
  arbetskraft_nn_1_N : N ;
  arbetskraftsinvandring_nn_1_N : N ;
  arbetsorganisation_nn_1_N : N ;
  arbetsraett_nn_1_1_N : N ;
  arbetsskraeck_nn_1_1_N : N ;
  arbetsskygghet_nn_1_N : N ;
  arbetstakt_nn_1_N : N ;
  arbetsterapi_nn_1_N : N ;
  arbetsvillighet_nn_1_N : N ;
  arbetsvaard_nn_1_1_N : N ;
  arbitrage_nn_1_N : N ;
  arghet_nn_1_N : N ;
  argsinthet_nn_1_N : N ;
  argumenterbarhet_nn_1_N : N ;
  argumentrikedom_nn_1_N : N ;
  arid_av_1_A : A ;
  arkaiserbarhet_nn_1_N : N ;
  arkebuserbarhet_nn_1_N : N ;
  arkeikum_nn_1_N : N ;
  arkeologi_nn_1_N : N ;
  arkiverbarhet_nn_1_N : N ;
  arkivforskning_nn_1_N : N ;
  armerbarhet_nn_1_N : N ;
  armgaang_nn_1_1_N : N ;
  armhet_nn_1_N : N ;
  armsvett_nn_1_N : N ;
  arrangerbarhet_nn_1_N : N ;
  arrenderbarhet_nn_1_N : N ;
  arresterbarhet_nn_1_N : N ;
  arronderbarhet_nn_1_N : N ;
  arsenikvaete_nn_1_1_N : N ;
  artegenhet_nn_1_N : N ;
  artfraemmande_av_1_1_A : A ;
  artikulerbarhet_nn_1_N : N ;
  artillerield_nn_1_N : N ;
  artonaarsmyndighet_nn_1_1_N : N ;
  artrikhet_nn_1_N : N ;
  artskildhet_nn_1_N : N ;
  arvloeshet_nn_1_1_N : N ;
  arvoderbarhet_nn_1_N : N ;
  asatroende_av_1_A : A ;
  asfalterbarhet_nn_1_N : N ;
  askblond_av_1_A : A ;
  aske_nn_1_N : N ;
  askfrihet_nn_1_N : N ;
  askspridning_nn_1_N : N ;
  aspbark_nn_1_N : N ;
  aspe_nn_1_N : N ;
  aspirerbarhet_nn_1_N : N ;
  assignerbarhet_nn_1_N : N ;
  assimilerbarhet_nn_1_N : N ;
  assisterbarhet_nn_1_N : N ;
  associationspsykologi_nn_1_N : N ;
  associationsrikedom_nn_1_N : N ;
  associerbarhet_nn_1_N : N ;
  assurerbarhet_nn_1_N : N ;
  astrologi_nn_1_N : N ;
  astronomi_nn_1_N : N ;
  asylraett_nn_1_1_N : N ;
  ataraxi_nn_1_N : N ;
  atomenergi_nn_1_N : N ;
  atrofierbarhet_nn_1_N : N ;
  attackerbarhet_nn_1_N : N ;
  attesterbarhet_nn_1_N : N ;
  attraherbarhet_nn_1_N : N ;
  attrapperbarhet_nn_1_N : N ;
  attribuerbarhet_nn_1_N : N ;
  audiologi_nn_1_N : N ;
  auktionerbarhet_nn_1_N : N ;
  auktoriserbarhet_nn_1_N : N ;
  auktoritetsbundenhet_nn_1_N : N ;
  auktorraett_nn_1_1_N : N ;
  auktorsraett_nn_1_1_N : N ;
  auskulterbarhet_nn_1_N : N ;
  autenticerbarhet_nn_1_N : N ;
  autentifierbarhet_nn_1_N : N ;
  autentiserbarhet_nn_1_N : N ;
  automatateori_nn_1_N : N ;
  automateld_nn_1_N : N ;
  automatiserbarhet_nn_1_N : N ;
  automatteori_nn_1_N : N ;
  autonomi_nn_1_N : N ;
  av_av_1_A : A ;
  avancerbarhet_nn_1_N : N ;
  avannonserbarhet_nn_1_N : N ;
  avantgarde_nn_1_N : N ;
  avbindande_nn_1_N : N ;
  avblaendning_nn_1_1_N : N ;
  avdragsraett_nn_1_1_N : N ;
  avdramatiserbarhet_nn_1_N : N ;
  aversionsterapi_nn_1_N : N ;
  avfallsvirke_nn_1_N : N ;
  avfaellighet_nn_1_1_N : N ;
  avgasrening_nn_1_N : N ;
  avgiftsfrihet_nn_1_N : N ;
  avgoerande_av_1_1_A : A ;
  avhumaniserande_nn_1_N : N ;
  avhumanisering_nn_1_N : N ;
  avhysning_nn_1_N : N ;
  avhaengighet_nn_1_1_N : N ;
  avhaallsamhet_nn_1_1_N : N ;
  aviserbarhet_nn_1_N : N ;
  avisning_nn_1_N : N ;
  avkoloniserbarhet_nn_1_N : N ;
  avkomstraett_nn_1_1_N : N ;
  avkriminaliserbarhet_nn_1_N : N ;
  avkristning_nn_1_N : N ;
  avlat_nn_1_N : N ;
  avlaegsenhet_nn_1_1_N : N ;
  avlaesbarhet_nn_1_1_N : N ;
  avlaanghet_nn_1_1_N : N ;
  avmagnetiserbarhet_nn_1_N : N ;
  avmystifierande_nn_1_N : N ;
  avmystifierbarhet_nn_1_N : N ;
  avmystifiering_nn_1_N : N ;
  avmaetthet_nn_1_1_N : N ;
  avnazifierbarhet_nn_1_N : N ;
  avoghet_nn_1_N : N ;
  avpatrullerbarhet_nn_1_N : N ;
  avpersonifierande_nn_1_N : N ;
  avpersonifiering_nn_1_N : N ;
  avpolitiserbarhet_nn_1_N : N ;
  avpolletterbarhet_nn_1_N : N ;
  avportraetterbarhet_nn_1_1_N : N ;
  avprickning_nn_1_N : N ;
  avradikaliserande_nn_1_N : N ;
  avradikalisering_nn_1_N : N ;
  avreagerbarhet_nn_1_N : N ;
  avregistrerbarhet_nn_1_N : N ;
  avreglerbarhet_nn_1_N : N ;
  avromantiserbarhet_nn_1_N : N ;
  avsides_av_1_A : A ;
  avsigkommenhet_nn_1_N : N ;
  avsiktlighet_nn_1_N : N ;
  avskiljning_nn_1_N : N ;
  avskogning_nn_1_N : N ;
  avskyvaerdhet_nn_1_1_N : N ;
  avslagenhet_nn_1_N : N ;
  avsmak_nn_1_N : N ;
  avsocialiserbarhet_nn_1_N : N ;
  avspaend_av_1_1_A : A ;
  avspaendhet_nn_1_1_N : N ;
  avstaliniserbarhet_nn_1_N : N ;
  avsaettande_nn_1_1_N : N ;
  avsaettlighet_nn_1_1_N : N ;
  avtagande_av_1_A : A ;
  avtagande_nn_1_N : N ;
  avtagbarhet_nn_1_N : N ;
  avtalsenlighet_nn_1_N : N ;
  avtalsraett_nn_1_1_N : N ;
  avtalsslutande_av_1_A : A ;
  avtorkning_nn_1_N : N ;
  avtrubbning_nn_1_N : N ;
  avtaerdhet_nn_1_1_N : N ;
  avundsamhet_nn_1_N : N ;
  avundsjukhet_nn_1_N : N ;
  avundsvaerdhet_nn_1_1_N : N ;
  avvattning_nn_1_N : N ;
  avvikande_av_1_A : A ;
  avvaepnande_av_1_1_A : A ;
  avytterlighet_nn_1_N : N ;
  axande_nn_1_N : N ;
  axiomatiserbarhet_nn_1_N : N ;
  ayrshireboskap_nn_1_N : N ;
  azur_nn_1_N : N ;
  bacillskraeck_nn_1_1_N : N ;
  backighet_nn_1_N : N ;
  bagage_nn_1_N : N ;
  bagatelliserbarhet_nn_1_N : N ;
  bajskorv_nn_1_N : N ;
  bakdantande_nn_1_N : N ;
  bakersta_av_1_A : A ;
  bakfullhet_nn_1_N : N ;
  bakis_av_1_A : A ;
  bakom_av_1_A : A ;
  bakomliggande_av_1_A : A ;
  bakomsittande_av_1_A : A ;
  bakslughet_nn_1_N : N ;
  baktericid_av_1_A : A ;
  bakteriedoedande_av_1_1_A : A ;
  bakteriologi_nn_1_N : N ;
  baktunghet_nn_1_N : N ;
  bakvaend_av_1_1_A : A ;
  bakvaendhet_nn_1_1_N : N ;
  bakaatblickande_av_1_1_A : A ;
  bakaatraeknande_av_1_1_A : A ;
  bakaatstraevande_av_1_1_A : A ;
  balanserbarhet_nn_1_N : N ;
  balansgaang_nn_1_1_N : N ;
  ballhet_nn_1_N : N ;
  balloterbarhet_nn_1_N : N ;
  balneologi_nn_1_N : N ;
  balsamdoftande_av_1_A : A ;
  balsamerbarhet_nn_1_N : N ;
  banaliserbarhet_nn_1_N : N ;
  banbrytande_av_1_A : A ;
  bandkantning_nn_1_N : N ;
  banghet_nn_1_N : N ;
  bankrutterbarhet_nn_1_N : N ;
  banskytte_nn_1_N : N ;
  bantamvikt_nn_1_N : N ;
  bantningshysteri_nn_1_N : N ;
  barfota_av_1_A : A ;
  barhet_nn_1_N : N ;
  barklag_nn_1_N : N ;
  barnarbetskraft_nn_1_N : N ;
  barnavaard_nn_1_1_N : N ;
  barndomsforskning_nn_1_N : N ;
  barndomsminne_nn_1_N : N ;
  barnfoerbjudenhet_nn_1_1_N : N ;
  barnledighet_nn_1_N : N ;
  barnloeshet_nn_1_1_N : N ;
  barnomsorg_nn_1_N : N ;
  barnpornografi_nn_1_N : N ;
  barnsmuggling_nn_1_N : N ;
  barnsnoed_nn_1_1_N : N ;
  barnsaekerhet_nn_1_1_N : N ;
  barntillsyn_nn_1_N : N ;
  barntillaatenhet_nn_1_1_N : N ;
  barrikaderbarhet_nn_1_N : N ;
  barrved_nn_1_N : N ;
  barskhet_nn_1_N : N ;
  baserbarhet_nn_1_N : N ;
  bastanthet_nn_1_N : N ;
  batongsvingande_av_1_A : A ;
  beaktande_nn_1_N : N ;
  beatifierande_nn_1_N : N ;
  beatifierbarhet_nn_1_N : N ;
  beatifiering_nn_1_N : N ;
  beboelighet_nn_1_N : N ;
  bebolighet_nn_1_N : N ;
  beckighet_nn_1_N : N ;
  bedjande_av_1_A : A ;
  bedjande_nn_1_N : N ;
  bedaarande_av_1_1_A : A ;
  beende_av_1_A : A ;
  beende_nn_1_N : N ;
  befallande_av_1_A : A ;
  befinnande_nn_1_N : N ;
  befriande_av_1_A : A ;
  befaelhavande_av_1_1_A : A ;
  begabbande_nn_1_N : N ;
  begivenhet_nn_2_N : N ;
  begravningshjaelp_nn_1_1_N : N ;
  begravningspoesi_nn_1_N : N ;
  begreppslighet_nn_1_N : N ;
  begreppsmaessighet_nn_1_1_N : N ;
  behagsjukhet_nn_1_N : N ;
  behandlingsbarhet_nn_1_N : N ;
  behjaelplighet_nn_1_1_N : N ;
  behaendighet_nn_1_1_N : N ;
  behoevande_av_1_1_A : A ;
  behoevlighet_nn_1_1_N : N ;
  beklaglighet_nn_1_N : N ;
  beklaemdhet_nn_1_1_N : N ;
  beklaemmande_av_1_1_A : A ;
  bekvaemhet_nn_1_1_N : N ;
  bekvaemlighetsflagg_nn_1_1_N : N ;
  bekymmersamhet_nn_1_N : N ;
  bekymmersloeshet_nn_1_1_N : N ;
  belysande_av_1_A : A ;
  bemaelde_av_1_1_A : A ;
  bemaerkthet_nn_1_1_N : N ;
  bemoetande_nn_1_1_N : N ;
  benhaardhet_nn_1_1_N : N ;
  benmaerg_nn_1_1_N : N ;
  bensinfoersaeljning_nn_1_1_N : N ;
  bensinslukande_av_1_A : A ;
  bensinsnaalhet_nn_1_1_N : N ;
  beresthet_nn_1_N : N ;
  bergighet_nn_1_N : N ;
  bergis_av_1_A : A ;
  bergsaekerhet_nn_1_1_N : N ;
  berlinerblaatt_nn_1_1_N : N ;
  beroende_av_1_A : A ;
  beroende_nn_1_N : N ;
  beroendeframkallande_av_1_A : A ;
  berusande_av_1_A : A ;
  beraeknande_av_1_1_A : A ;
  beraeknelighet_nn_1_1_N : N ;
  beraettande_av_1_1_A : A ;
  beraettigande_nn_1_1_N : N ;
  beroemvaerdhet_nn_1_1_N : N ;
  beroeringsskraeck_nn_1_1_N : N ;
  beseende_nn_1_N : N ;
  besinningsfullhet_nn_1_N : N ;
  besittningstagande_nn_1_N : N ;
  beskattningsbarhet_nn_1_N : N ;
  beskattningsgrundande_av_1_A : A ;
  beskattningsmakt_nn_1_N : N ;
  beskattningsraett_nn_1_1_N : N ;
  beskedlighet_nn_1_N : N ;
  beskrivande_av_1_A : A ;
  beskrivbarhet_nn_1_N : N ;
  beskaadande_nn_1_1_N : N ;
  beslagsraett_nn_1_1_N : N ;
  beslutanderaett_nn_1_1_N : N ;
  beslutenhet_nn_1_N : N ;
  beslutenlighet_nn_1_N : N ;
  beslutfattande_av_1_A : A ;
  beslutfattande_nn_1_N : N ;
  beslutfoerhet_nn_1_1_N : N ;
  beslutmaessighet_nn_1_1_N : N ;
  beslutsenlighet_nn_1_N : N ;
  beslutsfattande_av_1_A : A ;
  beslutsfattande_nn_1_N : N ;
  beslutsfoerhet_nn_1_1_N : N ;
  beslutsmaessighet_nn_1_1_N : N ;
  beslutsraett_nn_1_1_N : N ;
  besserwissrande_nn_1_N : N ;
  bestickande_av_1_A : A ;
  besticklighet_nn_1_N : N ;
  bestaellsamhet_nn_1_1_N : N ;
  bestaellt_av_1_1_A : A ;
  bestaembarhet_nn_1_1_N : N ;
  bestaemdhet_nn_1_1_N : N ;
  bestaemmanderaett_nn_1_1_N : N ;
  bestaaende_av_1_1_A : A ;
  bestaandande_av_1_1_A : A ;
  bestaandsbildande_av_1_1_A : A ;
  bestoerthet_nn_1_1_N : N ;
  besudlande_nn_1_N : N ;
  besudling_nn_1_N : N ;
  besuttenhet_nn_1_N : N ;
  besvikenhet_nn_1_N : N ;
  besvaerande_av_1_1_A : A ;
  besvaersraett_nn_1_1_N : N ;
  betagande_av_1_A : A ;
  betagenhet_nn_1_N : N ;
  betalbarhet_nn_1_N : N ;
  betalningsskyldighet_nn_1_N : N ;
  betastraalande_av_1_1_A : A ;
  betecknande_av_1_A : A ;
  beteendepsykologi_nn_1_N : N ;
  beteendeterapi_nn_1_N : N ;
  betongerbarhet_nn_1_N : N ;
  betraktande_nn_1_N : N ;
  betroddhet_nn_1_N : N ;
  betryckthet_nn_1_N : N ;
  betryggande_av_1_A : A ;
  betraengdhet_nn_1_1_N : N ;
  betungande_av_1_A : A ;
  betvingande_av_1_A : A ;
  betydande_av_1_A : A ;
  betydelsebaerande_av_1_1_A : A ;
  betydelsefullhet_nn_1_N : N ;
  betydelseloeshet_nn_1_1_N : N ;
  betydlighet_nn_1_N : N ;
  betygsjaekt_nn_1_1_N : N ;
  betaenksamhet_nn_1_1_N : N ;
  beundransvaerdhet_nn_1_1_N : N ;
  bevekande_av_1_A : A ;
  bevisbarhet_nn_1_N : N ;
  beviskraftighet_nn_1_N : N ;
  bevislighet_nn_1_N : N ;
  bevisskyldighet_nn_1_N : N ;
  bi_av_1_A : A ;
  bibelforskning_nn_1_N : N ;
  bibelkristenhet_nn_1_N : N ;
  bibelkunnighet_nn_1_N : N ;
  bibelspraengdhet_nn_1_1_N : N ;
  bibeltrogenhet_nn_1_N : N ;
  bibliomani_nn_1_N : N ;
  bibliometri_nn_1_N : N ;
  bidragande_av_1_A : A ;
  biff_av_1_A : A ;
  biffighet_nn_1_N : N ;
  bigami_nn_1_N : N ;
  bildande_av_1_A : A ;
  bildbarhet_nn_1_N : N ;
  bildlighet_nn_1_N : N ;
  bildlikhet_nn_1_N : N ;
  bildminne_nn_1_N : N ;
  bildmaessighet_nn_1_1_N : N ;
  bildningshoegfaerd_nn_1_1_N : N ;
  bildprakt_nn_1_N : N ;
  bildrikedom_nn_1_N : N ;
  bildskoenhet_nn_1_1_N : N ;
  bildtelegrafi_nn_1_N : N ;
  billighet_nn_2_N : N ;
  bilning_nn_1_N : N ;
  bilsjukhet_nn_1_N : N ;
  biltoghet_nn_1_N : N ;
  bilaeggning_nn_1_1_N : N ;
  bindande_av_1_A : A ;
  bindgalenhet_nn_1_N : N ;
  bingosugenhet_nn_1_N : N ;
  binjurebark_nn_1_N : N ;
  biobankning_nn_1_N : N ;
  biogasproduktion_nn_1_N : N ;
  biogasrening_nn_1_N : N ;
  biogeografi_nn_1_N : N ;
  biograferbarhet_nn_1_N : N ;
  biokemi_nn_1_N : N ;
  bioklimatologi_nn_1_N : N ;
  biokronologi_nn_1_N : N ;
  biologi_nn_1_N : N ;
  biometri_nn_1_N : N ;
  bisarrhet_nn_1_N : N ;
  biskoplighet_nn_1_N : N ;
  bisserbarhet_nn_1_N : N ;
  bisterhet_nn_1_N : N ;
  bitande_av_1_A : A ;
  bitraedande_av_1_1_A : A ;
  bitskhet_nn_1_N : N ;
  bittelitenhet_nn_1_N : N ;
  bitterljuvhet_nn_1_N : N ;
  bittersta_av_1_A : A ;
  bivackerbarhet_nn_1_N : N ;
  bjaerthet_nn_1_1_N : N ;
  bjoerke_nn_1_1_N : N ;
  bjoerklag_nn_1_1_N : N ;
  bjoerkved_nn_1_1_N : N ;
  bjoernliknande_av_1_1_A : A ;
  blackhet_nn_1_N : N ;
  blackighet_nn_1_N : N ;
  bladroett_nn_1_1_N : N ;
  bladspaenning_nn_1_1_N : N ;
  blancherbarhet_nn_1_N : N ;
  blanddryck_nn_1_N : N ;
  blankhet_nn_1_N : N ;
  blankpolerbarhet_nn_1_N : N ;
  blaskighet_nn_1_N : N ;
  blas_e_av_1_1_A : A ;
  blecksmak_nn_1_N : N ;
  blekfethet_nn_1_N : N ;
  blekjord_nn_1_N : N ;
  bleklagdhet_nn_1_N : N ;
  bleksiktighet_nn_1_N : N ;
  bleksot_nn_1_N : N ;
  blesserbarhet_nn_1_N : N ;
  blickpunkt_nn_1_N : N ;
  blickstilla_av_1_A : A ;
  blidhet_nn_1_N : N ;
  blind_av_1_A : A ;
  blinderbarhet_nn_1_N : N ;
  blindhet_nn_1_N : N ;
  blindskrift_nn_1_N : N ;
  blingande_nn_1_N : N ;
  blivande_av_1_A : A ;
  blixtfotograferbarhet_nn_1_N : N ;
  blixtrande_av_1_A : A ;
  blixtsnabbhet_nn_1_N : N ;
  blockerbarhet_nn_1_N : N ;
  blockighet_nn_1_N : N ;
  blockmark_nn_1_N : N ;
  blocktaenkande_nn_1_1_N : N ;
  blockoeverskridande_av_1_1_A : A ;
  bloddrypande_av_1_A : A ;
  blodfattighet_nn_1_N : N ;
  blodfullhet_nn_1_N : N ;
  blodgivning_nn_1_N : N ;
  blodgaang_nn_1_1_N : N ;
  blodisande_av_1_A : A ;
  blodloeshet_nn_1_1_N : N ;
  blodmat_nn_1_N : N ;
  blodrot_nn_1_N : N ;
  blodshaemnd_nn_1_1_N : N ;
  blodsmak_nn_1_N : N ;
  blodspraengdhet_nn_1_1_N : N ;
  blodstensmalm_nn_1_N : N ;
  blodstillande_av_1_A : A ;
  blodstinnhet_nn_1_N : N ;
  blodsugande_av_1_A : A ;
  blodtoerstighet_nn_1_1_N : N ;
  blomjord_nn_1_N : N ;
  blommograferbarhet_nn_1_N : N ;
  blomsterhonung_nn_1_N : N ;
  blomsterprakt_nn_1_N : N ;
  blond_av_1_A : A ;
  blonderbarhet_nn_1_N : N ;
  blondhet_nn_1_N : N ;
  blottstaelldhet_nn_1_1_N : N ;
  blygult_nn_1_N : N ;
  blytunghet_nn_1_N : N ;
  blyvitt_nn_1_N : N ;
  blaendande_av_1_1_A : A ;
  blaaaktighet_nn_1_1_N : N ;
  blaablodighet_nn_1_1_N : N ;
  blaafoerskjutning_nn_1_1_N : N ;
  blaahet_nn_1_1_N : N ;
  blaajord_nn_1_1_N : N ;
  blaakopierbarhet_nn_1_1_N : N ;
  blaasprit_nn_1_1_N : N ;
  blaasthet_nn_1_1_N : N ;
  blaastaang_nn_1_1_N : N ;
  blaasurhet_nn_1_1_N : N ;
  blaasoert_nn_1_1_N : N ;
  blaaoegdhet_nn_1_1_N : N ;
  bloethet_nn_1_1_N : N ;
  boaserbarhet_nn_1_N : N ;
  boboll_nn_1_N : N ;
  bockbenthet_nn_1_N : N ;
  bocktoerne_nn_1_1_N : N ;
  bodraekt_nn_1_1_N : N ;
  bofasthet_nn_1_N : N ;
  bofaellighet_nn_1_1_N : N ;
  bogserbarhet_nn_1_N : N ;
  boke_nn_1_N : N ;
  bokenhet_nn_1_N : N ;
  bokform_nn_1_N : N ;
  bokfoeringsmaessighet_nn_1_1_N : N ;
  bokfoeringsplikt_nn_1_1_N : N ;
  boklighet_nn_1_N : N ;
  boklaerdhet_nn_1_1_N : N ;
  boklaesande_av_1_1_A : A ;
  boklaesande_nn_1_1_N : N ;
  bokskrivande_av_1_A : A ;
  bokskrivande_nn_1_N : N ;
  bokstaverbarhet_nn_1_N : N ;
  bokstavsskrift_nn_1_N : N ;
  bokstavstrogenhet_nn_1_N : N ;
  boksynthet_nn_1_N : N ;
  bolmoert_nn_1_1_N : N ;
  bombarderbarhet_nn_1_N : N ;
  bombfasthet_nn_1_N : N ;
  bombsaekerhet_nn_1_1_N : N ;
  bomull_nn_1_N : N ;
  bonddryghet_nn_1_N : N ;
  bondesjael_nn_1_1_N : N ;
  bondskhet_nn_1_N : N ;
  bondslughet_nn_1_N : N ;
  bondtur_nn_1_N : N ;
  boniterbarhet_nn_1_N : N ;
  bordslinne_nn_1_N : N ;
  borgerlighet_nn_2_N : N ;
  borstighet_nn_1_N : N ;
  borstloeshet_nn_1_1_N : N ;
  bortfoerklaringsteologi_nn_1_1_N : N ;
  bortgivande_nn_1_N : N ;
  bortgloemdhet_nn_1_1_N : N ;
  bortgaang_nn_1_1_N : N ;
  bortkommenhet_nn_1_N : N ;
  bortresonerbarhet_nn_1_N : N ;
  bortresthet_nn_1_N : N ;
  bortskaffande_nn_1_N : N ;
  bortskaffning_nn_1_N : N ;
  borttagning_nn_1_N : N ;
  bortvikt_nn_1_N : N ;
  bortvaend_av_1_1_A : A ;
  boskap_nn_1_N : N ;
  boskapsskoetande_av_1_1_A : A ;
  bossighet_nn_1_N : N ;
  bostadsloeshet_nn_1_1_N : N ;
  bostadssparande_nn_1_N : N ;
  botfaerdighet_nn_1_1_N : N ;
  botlighet_nn_1_N : N ;
  botten_av_1_A : A ;
  bottendaalighet_nn_1_1_N : N ;
  bottenhederlighet_nn_1_N : N ;
  bottenlevande_av_1_A : A ;
  bovaktighet_nn_1_N : N ;
  bovete_nn_1_N : N ;
  boxkalv_nn_1_N : N ;
  bra_av_2_A : A ;
  brackighet_nn_1_N : N ;
  brackvattenlevande_av_1_A : A ;
  brailleskrift_nn_1_N : N ;
  brakycefali_nn_1_N : N ;
  brandfarlighet_nn_1_N : N ;
  brandhaerdighet_nn_1_1_N : N ;
  brandlukt_nn_1_N : N ;
  brandroek_nn_1_1_N : N ;
  brandstod_nn_1_N : N ;
  brandsaekerhet_nn_1_1_N : N ;
  branschledande_av_1_A : A ;
  branthet_nn_1_N : N ;
  braskande_av_1_A : A ;
  brasved_nn_1_N : N ;
  bredbarhet_nn_1_N : N ;
  bredbenthet_nn_1_N : N ;
  bredbladighet_nn_1_N : N ;
  bredbraettighet_nn_1_1_N : N ;
  bredhet_nn_1_N : N ;
  bredmynthet_nn_1_N : N ;
  bredrandighet_nn_1_N : N ;
  bredskyggighet_nn_1_N : N ;
  bredspaarighet_nn_1_1_N : N ;
  bremsande_nn_1_N : N ;
  bremsning_nn_1_N : N ;
  brevlaadeliknande_av_1_1_A : A ;
  brevskrivande_av_1_A : A ;
  brevskrivande_nn_1_N : N ;
  briketterbarhet_nn_1_N : N ;
  brinnande_av_1_A : A ;
  briserbarhet_nn_1_N : N ;
  briskenhet_nn_1_N : N ;
  bristande_av_1_A : A ;
  brobyggnad_nn_1_N : N ;
  broderbarhet_nn_1_N : N ;
  broderlighet_nn_1_N : N ;
  brodersilke_nn_1_N : N ;
  brokbladighet_nn_1_N : N ;
  brokblommighet_nn_1_N : N ;
  bromerbarhet_nn_1_N : N ;
  bromskraft_nn_1_N : N ;
  bromtymolblaatt_nn_1_1_N : N ;
  bromvaete_nn_1_1_N : N ;
  bronserbarhet_nn_1_N : N ;
  bronsfaerg_nn_1_1_N : N ;
  broscherbarhet_nn_1_N : N ;
  brottsbalk_nn_1_N : N ;
  brottsbekaempning_nn_1_1_N : N ;
  brottsfoerebyggande_av_1_1_A : A ;
  brottshistoria_nn_1_N : N ;
  brottsutredande_nn_1_N : N ;
  brukbarhet_nn_1_N : N ;
  brunaktighet_nn_1_N : N ;
  brunbraend_av_1_1_A : A ;
  brunerbarhet_nn_1_N : N ;
  brunglaensande_av_1_1_A : A ;
  brunhet_nn_1_N : N ;
  brunhaarighet_nn_1_1_N : N ;
  brunjord_nn_1_N : N ;
  brunmurrighet_nn_1_N : N ;
  brunrutighet_nn_1_N : N ;
  brunstighet_nn_1_N : N ;
  brunoegdhet_nn_1_1_N : N ;
  brustenhet_nn_1_N : N ;
  brutaliserbarhet_nn_1_N : N ;
  bruttovikt_nn_1_N : N ;
  bryddhet_nn_1_N : N ;
  brydsamhet_nn_1_N : N ;
  bryologi_nn_1_N : N ;
  bryskhet_nn_1_N : N ;
  braeckage_nn_1_1_N : N ;
  braecklighet_nn_1_1_N : N ;
  braeckthet_nn_1_1_N : N ;
  braeddfullhet_nn_1_1_N : N ;
  braeddfylldhet_nn_1_1_N : N ;
  braennande_av_1_1_A : A ;
  braennbarhet_nn_1_1_N : N ;
  braennboll_nn_1_1_N : N ;
  braenne_nn_1_1_N : N ;
  braennlackerbarhet_nn_1_1_N : N ;
  braenntorv_nn_1_1_N : N ;
  braenslefoerbrukning_nn_1_1_N : N ;
  braenslesnaalhet_nn_1_1_N : N ;
  braensleaatgaang_nn_1_1_N : N ;
  braeserbarhet_nn_1_1_N : N ;
  braaddjuphet_nn_1_1_N : N ;
  braadhet_nn_1_1_N : N ;
  braadmogenhet_nn_1_1_N : N ;
  braadskande_av_1_1_A : A ;
  braakighet_nn_1_1_N : N ;
  braattom_av_1_1_A : A ;
  broedloeshet_nn_1_1_N : N ;
  broedstil_nn_1_1_N : N ;
  broestklang_nn_1_1_N : N ;
  broestlidande_nn_1_1_N : N ;
  broestsugande_av_1_1_A : A ;
  bubblighet_nn_1_N : N ;
  bucklighet_nn_1_N : N ;
  budgeterbarhet_nn_1_N : N ;
  buffelaktighet_nn_1_N : N ;
  bukighet_nn_1_N : N ;
  bukstinnhet_nn_1_N : N ;
  buktighet_nn_1_N : N ;
  bullerdaempande_av_1_1_A : A ;
  bullerdaempning_nn_1_1_N : N ;
  bullerfoerminskande_av_1_1_A : A ;
  bullersamhet_nn_1_N : N ;
  bullighet_nn_1_N : N ;
  bullrighet_nn_1_N : N ;
  bulsighet_nn_1_N : N ;
  bundenhet_nn_1_N : N ;
  bunkrande_nn_1_N : N ;
  bunkring_nn_1_N : N ;
  burgenhet_nn_1_N : N ;
  burkmat_nn_1_N : N ;
  burrighet_nn_1_N : N ;
  busighet_nn_1_N : N ;
  buskablyghet_nn_1_N : N ;
  buskighet_nn_1_N : N ;
  buskliknande_av_1_A : A ;
  buss_av_1_A : A ;
  bussighet_nn_1_N : N ;
  buteljerbarhet_nn_1_N : N ;
  butterhet_nn_1_N : N ;
  byggande_nn_1_N : N ;
  byggenskap_nn_1_N : N ;
  byggnadsvirke_nn_1_N : N ;
  byke_nn_1_N : N ;
  bylsighet_nn_1_N : N ;
  byraakratiserbarhet_nn_1_1_N : N ;
  byxis_av_1_A : A ;
  byxloeshet_nn_1_1_N : N ;
  baelgliknande_av_1_1_A : A ;
  baenghet_nn_1_1_N : N ;
  baerande_av_1_1_A : A ;
  baerbarhet_nn_1_1_N : N ;
  baerhjaelp_nn_1_1_N : N ;
  baerighet_nn_1_1_N : N ;
  baerkraftighet_nn_1_1_N : N ;
  baerplockning_nn_1_1_N : N ;
  baersaerkagaang_nn_1_1_N : N ;
  baagformighet_nn_1_1_N : N ;
  baagskytte_nn_1_1_N : N ;
  baaldhet_nn_1_1_N : N ;
  baangstyrighet_nn_1_1_N : N ;
  baarbaerning_nn_1_1_N : N ;
  baatfart_nn_1_1_N : N ;
  baatliknande_av_1_1_A : A ;
  baatvaard_nn_1_1_N : N ;
  boegdoed_nn_1_1_N : N ;
  boejbarhet_nn_1_1_N : N ;
  boejdhet_nn_1_1_N : N ;
  boejlighet_nn_1_1_N : N ;
  boenkaffe_nn_1_1_N : N ;
  boerd_nn_1_1_N : N ;
  boerdighet_nn_1_1_N : N ;
  boerdshoegfaerd_nn_1_1_N : N ;
  boerdsraett_nn_1_1_N : N ;
  boerdsstolthet_nn_1_1_N : N ;
  boersnoterbarhet_nn_1_1_N : N ;
  boersutveckling_nn_1_1_N : N ;
  cabotage_nn_1_N : N ;
  camouflerbarhet_nn_1_N : N ;
  camphet_nn_1_N : N ;
  cancerbekaempning_nn_1_1_N : N ;
  cancerframkallande_av_1_A : A ;
  cancerspridning_nn_1_N : N ;
  catch_as_catch_can_nn_1_N : N ;
  cederbarhet_nn_1_N : N ;
  celebrerbarhet_nn_1_N : N ;
  cellbiologi_nn_1_N : N ;
  cellskraeck_nn_1_1_N : N ;
  cellterapi_nn_1_N : N ;
  cementerbarhet_nn_1_N : N ;
  cendr_e_av_1_1_A : A ;
  censurerbarhet_nn_1_N : N ;
  centraliserbarhet_nn_1_N : N ;
  centralstimulerande_av_1_A : A ;
  centrerbarhet_nn_1_N : N ;
  centrifugalkraft_nn_1_N : N ;
  centrifugerbarhet_nn_1_N : N ;
  centripetalkraft_nn_1_N : N ;
  cepe_av_1_A : A ;
  cerise_av_1_A : A ;
  cernerbarhet_nn_1_N : N ;
  cervelatkorv_nn_1_N : N ;
  champagnesprutande_av_1_A : A ;
  chansloeshet_nn_1_1_N : N ;
  chargerbarhet_nn_1_N : N ;
  charmerbarhet_nn_1_N : N ;
  charmfullhet_nn_1_N : N ;
  charmighet_nn_1_N : N ;
  chef_d_oeuvre_nn_1_N : N ;
  chevroterbarhet_nn_1_N : N ;
  chichet_nn_1_N : N ;
  chiffrerbarhet_nn_1_N : N ;
  chikanerbarhet_nn_1_N : N ;
  chimpande_nn_1_N : N ;
  chockerbarhet_nn_1_N : N ;
  chockrosa_av_1_A : A ;
  cigarettfoersaeljning_nn_1_1_N : N ;
  cigarettroekning_nn_1_1_N : N ;
  cirkelform_nn_1_N : N ;
  cirkelgaang_nn_1_1_N : N ;
  cirkelrund_av_1_A : A ;
  cirkelrundhet_nn_1_N : N ;
  cirkulerbarhet_nn_1_N : N ;
  ciselerbarhet_nn_1_N : N ;
  citerbarhet_nn_1_N : N ;
  citrussmak_nn_1_N : N ;
  civiliserbarhet_nn_1_N : N ;
  civilkurage_nn_1_N : N ;
  civilraett_nn_1_1_N : N ;
  coolhet_nn_1_N : N ;
  corioliskraft_nn_1_N : N ;
  courtage_nn_1_N : N ;
  crazy_av_1_A : A ;
  curare_nn_1_N : N ;
  curaterbarhet_nn_1_N : N ;
  curerbarhet_nn_1_N : N ;
  cyanvaete_nn_1_1_N : N ;
  cyberrymd_nn_1_N : N ;
  cybervaerld_nn_1_1_N : N ;
  cykelaakning_nn_1_1_N : N ;
  cykling_nn_1_N : N ;
  cytologi_nn_1_N : N ;
  dagblind_av_1_A : A ;
  dagblindhet_nn_1_N : N ;
  dagenefterhuvudvaerk_nn_1_1_N : N ;
  daggighet_nn_1_N : N ;
  daghavande_av_1_A : A ;
  dagjaemningspunkt_nn_1_1_N : N ;
  daglighet_nn_1_N : N ;
  dagsens_av_1_A : A ;
  dagslaege_nn_1_1_N : N ;
  dagvill_av_1_A : A ;
  dagvillhet_nn_1_N : N ;
  dagvaard_nn_1_1_N : N ;
  damfotboll_nn_1_N : N ;
  dammighet_nn_1_N : N ;
  dammsaekerhet_nn_1_1_N : N ;
  dan_av_1_A : A ;
  dann_av_1_A : A ;
  danskhet_nn_1_N : N ;
  dansktalande_av_1_A : A ;
  dansundervisning_nn_1_N : N ;
  darrande_av_1_A : A ;
  darrhaenthet_nn_1_1_N : N ;
  darrighet_nn_1_N : N ;
  daskighet_nn_1_N : N ;
  dassighet_nn_1_N : N ;
  datalagring_nn_1_N : N ;
  datalogi_nn_1_N : N ;
  daterbarhet_nn_1_N : N ;
  datorfoersaeljning_nn_1_1_N : N ;
  datoriserbarhet_nn_1_N : N ;
  datorisering_nn_1_N : N ;
  datorkommunikation_nn_1_N : N ;
  datorkraft_nn_1_N : N ;
  datumparkerbarhet_nn_1_N : N ;
  debarkerbarhet_nn_1_N : N ;
  debatterbarhet_nn_1_N : N ;
  debiterbarhet_nn_1_N : N ;
  decentraliserbarhet_nn_1_N : N ;
  dechiffrerbarhet_nn_1_N : N ;
  decimerbarhet_nn_1_N : N ;
  dedicerbarhet_nn_1_N : N ;
  dedikerbarhet_nn_1_N : N ;
  deducerbarhet_nn_1_N : N ;
  defilerbarhet_nn_1_N : N ;
  definierbarhet_nn_1_N : N ;
  definithet_nn_1_N : N ;
  definitionsmaessighet_nn_1_1_N : N ;
  deflorerbarhet_nn_1_N : N ;
  deformerbarhet_nn_1_N : N ;
  degenererbarhet_nn_1_N : N ;
  degraderbarhet_nn_1_N : N ;
  dejlighet_nn_1_N : N ;
  dejting_nn_1_N : N ;
  dekalkomani_nn_1_N : N ;
  dekanterbarhet_nn_1_N : N ;
  dekapiterbarhet_nn_1_N : N ;
  deklamerbarhet_nn_1_N : N ;
  deklarerbarhet_nn_1_N : N ;
  deklasserbarhet_nn_1_N : N ;
  deklinerbarhet_nn_1_N : N ;
  dekomposition_nn_1_N : N ;
  dekorerbarhet_nn_1_N : N ;
  dekouragerbarhet_nn_1_N : N ;
  dekreterbarhet_nn_1_N : N ;
  delbarhet_nn_1_N : N ;
  delegerbarhet_nn_1_N : N ;
  delfaaende_nn_1_1_N : N ;
  deltagande_av_1_A : A ;
  deltagande_nn_1_N : N ;
  deltidsarbetande_av_1_A : A ;
  demagogi_nn_1_N : N ;
  demaskerbarhet_nn_1_N : N ;
  demensutveckling_nn_1_N : N ;
  dementerbarhet_nn_1_N : N ;
  demeriterande_av_1_A : A ;
  demilitariserbarhet_nn_1_N : N ;
  demobiliserbarhet_nn_1_N : N ;
  demografi_nn_1_N : N ;
  demokratiserbarhet_nn_1_N : N ;
  demolerbarhet_nn_1_N : N ;
  demoni_nn_1_N : N ;
  demoniserbarhet_nn_1_N : N ;
  demonisering_nn_1_N : N ;
  demonologi_nn_1_N : N ;
  demonstrerbarhet_nn_1_N : N ;
  demonterbarhet_nn_1_N : N ;
  demoraliserbarhet_nn_1_N : N ;
  denaturaliserbarhet_nn_1_N : N ;
  denaturerbarhet_nn_1_N : N ;
  dendrokronologi_nn_1_N : N ;
  dendrologi_nn_1_N : N ;
  denoterbarhet_nn_1_N : N ;
  denuderbarhet_nn_1_N : N ;
  deodoriserbarhet_nn_1_N : N ;
  depatrierbarhet_nn_1_N : N ;
  depenserbarhet_nn_1_N : N ;
  deplacerbarhet_nn_1_N : N ;
  deponerbarhet_nn_1_N : N ;
  deporterbarhet_nn_1_N : N ;
  deppighet_nn_1_N : N ;
  deprecierbarhet_nn_1_N : N ;
  deprimerande_av_1_A : A ;
  derangerbarhet_nn_1_N : N ;
  deriverbarhet_nn_1_N : N ;
  dermatologi_nn_1_N : N ;
  desarmerbarhet_nn_1_N : N ;
  desavouerbarhet_nn_1_N : N ;
  desensibiliserbarhet_nn_1_N : N ;
  designerbarhet_nn_1_N : N ;
  desinfekterbarhet_nn_1_N : N ;
  desinficerbarhet_nn_1_N : N ;
  desinformerbarhet_nn_1_N : N ;
  desorganiserbarhet_nn_1_N : N ;
  destabiliserande_av_1_A : A ;
  destabiliserbarhet_nn_1_N : N ;
  destillerbarhet_nn_1_N : N ;
  destinerbarhet_nn_1_N : N ;
  destruerbarhet_nn_1_N : N ;
  detacherbarhet_nn_1_N : N ;
  detaljrikhet_nn_1_N : N ;
  detekterbarhet_nn_1_N : N ;
  determinerbarhet_nn_1_N : N ;
  detonerbarhet_nn_1_N : N ;
  detroniserbarhet_nn_1_N : N ;
  devalverbarhet_nn_1_N : N ;
  devon_nn_1_N : N ;
  dhivehi_nn_1_N : N ;
  diagnosticerbarhet_nn_1_N : N ;
  diagnostiserbarhet_nn_1_N : N ;
  diakoni_nn_1_N : N ;
  dialektforskning_nn_1_N : N ;
  dialektgeografi_nn_1_N : N ;
  dialektologi_nn_1_N : N ;
  dialogform_nn_1_N : N ;
  dialyserbarhet_nn_1_N : N ;
  diatermi_nn_1_N : N ;
  diddling_nn_1_N : N ;
  dieselmotorrengoering_nn_1_1_N : N ;
  differentierbarhet_nn_1_N : N ;
  diffunderbarhet_nn_1_N : N ;
  difteri_nn_1_N : N ;
  diftongerbarhet_nn_1_N : N ;
  digerdoed_nn_1_1_N : N ;
  digererbarhet_nn_1_N : N ;
  diglossi_nn_1_N : N ;
  dikterbarhet_nn_1_N : N ;
  dilande_nn_1_N : N ;
  dilettantmaessighet_nn_1_1_N : N ;
  dimensionerbarhet_nn_1_N : N ;
  dimmighet_nn_1_N : N ;
  ding_av_1_A : A ;
  dinghet_nn_1_N : N ;
  dinkel_nn_1_N : N ;
  diploid_av_1_A : A ;
  diplomati_nn_1_N : N ;
  diplomerbarhet_nn_1_N : N ;
  dipsomani_nn_1_N : N ;
  direktdemokrati_nn_1_N : N ;
  direktionskraft_nn_1_N : N ;
  direktlyftande_av_1_A : A ;
  direktsaendande_nn_1_1_N : N ;
  direktverkande_av_1_A : A ;
  dirigerbarhet_nn_1_N : N ;
  disambiguerbarhet_nn_1_N : N ;
  disciplinerbarhet_nn_1_N : N ;
  disharmonierbarhet_nn_1_N : N ;
  disighet_nn_1_N : N ;
  diskning_nn_1_N : N ;
  diskonterbarhet_nn_1_N : N ;
  diskontinuerlighet_nn_1_N : N ;
  diskrediterbarhet_nn_1_N : N ;
  diskriminerbarhet_nn_1_N : N ;
  diskrimineringsbekaempning_nn_1_1_N : N ;
  diskuterbarhet_nn_1_N : N ;
  diskvalificerbarhet_nn_1_N : N ;
  dispascherbarhet_nn_1_N : N ;
  dispenserbarhet_nn_1_N : N ;
  dispergerbarhet_nn_1_N : N ;
  disponerbarhet_nn_1_N : N ;
  dispositionsraett_nn_1_1_N : N ;
  disproportionerlighet_nn_1_N : N ;
  disputerbarhet_nn_1_N : N ;
  dissekerbarhet_nn_1_N : N ;
  dissimilerbarhet_nn_1_N : N ;
  dissimilering_nn_1_N : N ;
  dissocierbarhet_nn_1_N : N ;
  distanserbarhet_nn_1_N : N ;
  distansritt_nn_1_N : N ;
  distraherbarhet_nn_1_N : N ;
  distribuerbarhet_nn_1_N : N ;
  distrae_av_1_1_A : A ;
  dithoerande_av_1_1_A : A ;
  dito_av_1_A : A ;
  dittillsvarande_av_1_A : A ;
  divergerbarhet_nn_1_N : N ;
  diverse_av_1_A : A ;
  diversifierbarhet_nn_1_N : N ;
  dividerbarhet_nn_1_N : N ;
  djungeltelegraf_nn_1_N : N ;
  djupborrande_av_1_A : A ;
  djupfuktande_av_1_A : A ;
  djupgaaende_av_1_1_A : A ;
  djupgaaende_nn_1_1_N : N ;
  djuphet_nn_1_N : N ;
  djuplodande_av_1_A : A ;
  djuppsykologi_nn_1_N : N ;
  djupsoemn_nn_1_1_N : N ;
  djuptaenkthet_nn_1_1_N : N ;
  djuranatomi_nn_1_N : N ;
  djurgeografi_nn_1_N : N ;
  djurhaallning_nn_1_1_N : N ;
  djuriskhet_nn_1_N : N ;
  djurliknande_av_1_A : A ;
  djurpsykologi_nn_1_N : N ;
  djurrike_nn_1_N : N ;
  djurtillsyn_nn_1_N : N ;
  djuruppfoedning_nn_1_1_N : N ;
  djurvaenlighet_nn_1_1_N : N ;
  djurvaerld_nn_1_1_N : N ;
  djaevla_av_1_1_A : A ;
  dna_testande_nn_1_N : N ;
  docerbarhet_nn_1_N : N ;
  docering_nn_1_N : N ;
  dockaktighet_nn_1_N : N ;
  doftloeshet_nn_1_1_N : N ;
  doftmarkerbarhet_nn_1_N : N ;
  doftsvaghet_nn_1_N : N ;
  dogmatiserbarhet_nn_1_N : N ;
  dokumenterbarhet_nn_1_N : N ;
  doldhet_nn_1_N : N ;
  dollardiplomati_nn_1_N : N ;
  dolskhet_nn_1_N : N ;
  domedag_nn_1_N : N ;
  domesticerbarhet_nn_1_N : N ;
  domhavande_av_1_A : A ;
  domicilierbarhet_nn_1_N : N ;
  dominerande_av_1_A : A ;
  dominerbarhet_nn_1_N : N ;
  dompterbarhet_nn_1_N : N ;
  domsraett_nn_1_1_N : N ;
  donerbarhet_nn_1_N : N ;
  dopaminkaenslighet_nn_1_1_N : N ;
  doppardag_nn_1_N : N ;
  dopparedag_nn_1_N : N ;
  dorskhet_nn_1_N : N ;
  doserbarhet_nn_1_N : N ;
  dosimetri_nn_1_N : N ;
  dosserbarhet_nn_1_N : N ;
  doterbarhet_nn_1_N : N ;
  dotterlighet_nn_1_N : N ;
  dovhet_nn_1_N : N ;
  dragenhet_nn_1_N : N ;
  dragerbarhet_nn_1_N : N ;
  draghjaelp_nn_1_1_N : N ;
  draglaege_nn_1_1_N : N ;
  dragningskraft_nn_1_N : N ;
  dramatiserbarhet_nn_1_N : N ;
  draperbarhet_nn_1_N : N ;
  dresserbarhet_nn_1_N : N ;
  drickbarhet_nn_1_N : N ;
  driftande_nn_1_N : N ;
  driftighet_nn_1_N : N ;
  driftning_nn_1_N : N ;
  driftsaekerhet_nn_1_1_N : N ;
  dristighet_nn_1_N : N ;
  drivande_av_1_A : A ;
  drivenhet_nn_1_N : N ;
  drivflykt_nn_1_N : N ;
  drogberoende_nn_1_N : N ;
  drogmissbrukande_av_1_A : A ;
  druckenhet_nn_1_N : N ;
  drummelaktighet_nn_1_N : N ;
  dryckenskap_nn_1_N : N ;
  draeglighet_nn_1_1_N : N ;
  draenage_nn_1_1_N : N ;
  draenerbarhet_nn_1_1_N : N ;
  draenkbarhet_nn_1_1_N : N ;
  draenkning_nn_1_1_N : N ;
  draepande_av_1_1_A : A ;
  droemlikhet_nn_1_1_N : N ;
  droemliknande_av_1_1_A : A ;
  droemmil_nn_1_1_N : N ;
  droemskhet_nn_1_1_N : N ;
  droemsoemn_nn_1_1_N : N ;
  dubbelarbetande_av_1_A : A ;
  dubbelexponerbarhet_nn_1_N : N ;
  dubbelhandsfattning_nn_1_N : N ;
  dubbelhaeftande_av_1_1_A : A ;
  dubbelseende_nn_1_N : N ;
  dubbelsyn_nn_1_N : N ;
  dubbeltydighet_nn_1_N : N ;
  dubbelverkande_av_1_A : A ;
  dubblerbarhet_nn_1_N : N ;
  dubbslitage_nn_1_N : N ;
  duettsaang_nn_1_1_N : N ;
  dugande_av_1_A : A ;
  duktighet_nn_1_N : N ;
  dumdristighet_nn_1_N : N ;
  dumdryghet_nn_1_N : N ;
  dumkaat_av_1_1_A : A ;
  dunderhonung_nn_1_N : N ;
  dunstighet_nn_1_N : N ;
  duperbarhet_nn_1_N : N ;
  duplicerbarhet_nn_1_N : N ;
  durumvete_nn_1_N : N ;
  duvenhet_nn_1_N : N ;
  dvaergaktighet_nn_1_1_N : N ;
  dvaergalaat_nn_1_1_N : N ;
  dybloethet_nn_1_1_N : N ;
  dygdighet_nn_1_N : N ;
  dygnsvill_av_1_A : A ;
  dygnsvillhet_nn_1_N : N ;
  dyighet_nn_1_N : N ;
  dyngsurhet_nn_1_N : N ;
  dyrhet_nn_1_N : N ;
  dyrkansvaerdhet_nn_1_1_N : N ;
  dyrkoepthet_nn_1_1_N : N ;
  dystopiskhet_nn_1_N : N ;
  dyvelstraeck_nn_1_1_N : N ;
  daeckavtagning_nn_1_1_N : N ;
  daesthet_nn_1_1_N : N ;
  daevenhet_nn_1_1_N : N ;
  daadkraft_nn_1_1_N : N ;
  daadloeshet_nn_1_1_N : N ;
  daalig_av_1_1_A : A ;
  daatid_nn_1_1_N : N ;
  daatida_av_1_1_A : A ;
  daavarande_av_1_1_A : A ;
  doe_av_1_1_A : A ;
  doeblekhet_nn_1_1_N : N ;
  doedande_av_1_1_A : A ;
  doedande_nn_1_1_N : N ;
  doedbraend_av_1_1_A : A ;
  doedhet_nn_1_1_N : N ;
  doedlighet_nn_2_1_N : N ;
  doedsblekhet_nn_1_1_N : N ;
  doedsfoeraktande_av_1_1_A : A ;
  doedshjaelp_nn_1_1_N : N ;
  doedssjukhet_nn_1_1_N : N ;
  doedstraakighet_nn_1_1_N : N ;
  doedstroetthet_nn_1_1_N : N ;
  doedtid_nn_1_1_N : N ;
  doedvikt_nn_1_1_N : N ;
  doerrknackning_nn_1_1_N : N ;
  doevblind_av_1_1_A : A ;
  doevblindhet_nn_1_1_N : N ;
  doevstumhet_nn_1_1_N : N ;
  ederbarhet_nn_1_N : N ;
  edlighet_nn_1_N : N ;
  edsoere_nn_1_1_N : N ;
  efemeridtid_nn_1_N : N ;
  effacerbarhet_nn_1_N : N ;
  effektfullhet_nn_1_N : N ;
  effektiverbarhet_nn_1_N : N ;
  effektiviserbarhet_nn_1_N : N ;
  effektloeshet_nn_1_1_N : N ;
  effektskapande_av_1_A : A ;
  effektuerbarhet_nn_1_N : N ;
  efter_av_1_A : A ;
  efterblivenhet_nn_1_N : N ;
  efterdaterbarhet_nn_1_N : N ;
  efterdebiterbarhet_nn_1_N : N ;
  efterdoemlighet_nn_1_1_N : N ;
  efterfoeljd_nn_1_1_N : N ;
  eftergivlighet_nn_1_N : N ;
  efterhand_nn_1_N : N ;
  efterhaengsenhet_nn_1_1_N : N ;
  efterklokhet_nn_1_N : N ;
  efterlevande_av_1_A : A ;
  efterliggande_av_1_A : A ;
  efterlaatenhet_nn_1_1_N : N ;
  eftermiddagskaffe_nn_1_N : N ;
  efternatt_nn_1_N : N ;
  efterrationaliserbarhet_nn_1_N : N ;
  eftersaknad_nn_1_N : N ;
  eftersinnande_av_1_A : A ;
  efterskaenkande_nn_1_1_N : N ;
  efterskaenkning_nn_1_1_N : N ;
  efterskoerd_nn_1_1_N : N ;
  efterslaentrande_av_1_1_A : A ;
  eftersmak_nn_1_N : N ;
  efterstraevansvaerdhet_nn_1_1_N : N ;
  eftersyn_nn_1_N : N ;
  eftersynkroniserbarhet_nn_1_N : N ;
  eftersoekthet_nn_1_1_N : N ;
  eftertaxerbarhet_nn_1_N : N ;
  eftertorkning_nn_1_N : N ;
  eftertraktansvaerdhet_nn_1_1_N : N ;
  eftertrycklighet_nn_1_N : N ;
  eftertaenksamhet_nn_1_1_N : N ;
  eftervishet_nn_1_N : N ;
  eftervaerld_nn_1_1_N : N ;
  eftervaard_nn_1_1_N : N ;
  egaliserbarhet_nn_1_N : N ;
  egenart_nn_1_N : N ;
  egendomsgemenskap_nn_1_N : N ;
  egendomsloeshet_nn_1_1_N : N ;
  egenhaendighet_nn_1_1_N : N ;
  egenmaektighet_nn_1_1_N : N ;
  egennyttighet_nn_1_N : N ;
  egenraettfaerdighet_nn_1_1_N : N ;
  egenraadighet_nn_1_1_N : N ;
  egensinnighet_nn_1_N : N ;
  egenvaerde_nn_1_1_N : N ;
  egoboostande_nn_1_N : N ;
  egyptologi_nn_1_N : N ;
  eke_nn_1_N : N ;
  ekiperbarhet_nn_1_N : N ;
  eklaterbarhet_nn_1_N : N ;
  eklut_nn_1_N : N ;
  eklaererbarhet_nn_1_1_N : N ;
  ekologi_nn_1_N : N ;
  ekonometri_nn_1_N : N ;
  ekonomie_av_1_A : A ;
  ekonomiraett_nn_1_1_N : N ;
  ekonomiserbarhet_nn_1_N : N ;
  ekorrliknande_av_1_A : A ;
  ekvatorshoejd_nn_1_1_N : N ;
  ekvirke_nn_1_N : N ;
  elaborerbarhet_nn_1_N : N ;
  elastiserbarhet_nn_1_N : N ;
  eldfarlighet_nn_1_N : N ;
  eldfasthet_nn_1_N : N ;
  eldfaengdhet_nn_1_1_N : N ;
  eldhaerdighet_nn_1_1_N : N ;
  eldighet_nn_1_N : N ;
  eldkraft_nn_1_N : N ;
  eldskrift_nn_1_N : N ;
  eldsprutande_av_1_A : A ;
  eldsaekerhet_nn_1_1_N : N ;
  elefanthud_nn_1_N : N ;
  elektrificerbarhet_nn_1_N : N ;
  elektrifierbarhet_nn_1_N : N ;
  elektriserbarhet_nn_1_N : N ;
  elektrokemi_nn_1_N : N ;
  elektrometallurgi_nn_1_N : N ;
  elektroterapi_nn_1_N : N ;
  elenergi_nn_1_N : N ;
  elevhaelsovaard_nn_1_1_N : N ;
  elevvaard_nn_1_1_N : N ;
  eliderbarhet_nn_1_N : N ;
  eliminerbarhet_nn_1_N : N ;
  elittaenkande_nn_1_1_N : N ;
  elkonsumtion_nn_1_N : N ;
  elkraft_nn_1_N : N ;
  elmseld_nn_1_N : N ;
  eloxerbarhet_nn_1_N : N ;
  eltejp_nn_1_N : N ;
  eluderbarhet_nn_1_N : N ;
  eluerbarhet_nn_1_N : N ;
  eluvium_nn_1_N : N ;
  elaenda_av_1_1_A : A ;
  elaendighet_nn_1_1_N : N ;
  emaljerbarhet_nn_1_N : N ;
  emanciperbarhet_nn_1_N : N ;
  emballerbarhet_nn_1_N : N ;
  embarkerbarhet_nn_1_N : N ;
  embellerbarhet_nn_1_N : N ;
  emblematiskhet_nn_1_N : N ;
  embryologi_nn_1_N : N ;
  emenderbarhet_nn_1_N : N ;
  emigrerbarhet_nn_1_N : N ;
  eminenthet_nn_1_N : N ;
  emitterbarhet_nn_1_N : N ;
  emmervete_nn_1_N : N ;
  emotionaliserande_nn_1_N : N ;
  emotionalisering_nn_1_N : N ;
  empati_nn_1_N : N ;
  empiri_nn_1_N : N ;
  emulgerbarhet_nn_1_N : N ;
  enahanda_av_1_A : A ;
  enaraadande_av_1_1_A : A ;
  enastaaende_av_1_1_A : A ;
  enaxlighet_nn_1_N : N ;
  enbenthet_nn_1_N : N ;
  encellighet_nn_1_N : N ;
  endaste_av_1_A : A ;
  endokrinologi_nn_1_N : N ;
  endosserbarhet_nn_1_N : N ;
  endraekt_nn_1_1_N : N ;
  ene_nn_1_N : N ;
  energibesparande_av_1_A : A ;
  energifoerbrukning_nn_1_1_N : N ;
  energikraevande_av_1_1_A : A ;
  energiprincip_nn_1_N : N ;
  energirikhet_nn_1_N : N ;
  energisparande_av_1_A : A ;
  energiupptagande_av_1_A : A ;
  enerverbarhet_nn_1_N : N ;
  enfald_nn_1_N : N ;
  enfaldighet_nn_1_N : N ;
  enfas_av_1_A : A ;
  enformighet_nn_1_N : N ;
  engagerbarhet_nn_1_N : N ;
  engelskaundervisning_nn_1_N : N ;
  engelskspraakighet_nn_1_1_N : N ;
  engelskspaakighet_nn_1_1_N : N ;
  engelsktalande_av_1_A : A ;
  engelskundervisning_nn_1_N : N ;
  engifte_nn_1_N : N ;
  engaangs_av_1_1_A : A ;
  engaangskaraktaer_nn_1_1_N : N ;
  enhetlighet_nn_1_N : N ;
  enhjulighet_nn_1_N : N ;
  enhaellighet_nn_1_1_N : N ;
  enkelspaarighet_nn_1_1_N : N ;
  enklang_nn_1_N : N ;
  enklavisering_nn_1_N : N ;
  enkomponents_av_1_A : A ;
  enleverbarhet_nn_1_N : N ;
  enormhet_nn_1_N : N ;
  enpolighet_nn_1_N : N ;
  enpucklighet_nn_1_N : N ;
  enrollerbarhet_nn_1_N : N ;
  ens_av_1_A : A ;
  ensamanlaendande_av_1_1_A : A ;
  ensamkommande_av_1_A : A ;
  ensamstaaende_av_1_1_A : A ;
  ense_av_1_A : A ;
  ensidighet_nn_1_N : N ;
  ensilage_nn_1_N : N ;
  ensilerbarhet_nn_1_N : N ;
  enskifte_nn_1_N : N ;
  enslighet_nn_1_N : N ;
  enspraakighet_nn_1_1_N : N ;
  enspaend_av_1_1_A : A ;
  enstaka_av_1_A : A ;
  enstavighet_nn_1_N : N ;
  enstavighetsaccent_nn_1_N : N ;
  enstaemmighet_nn_1_1_N : N ;
  enstaendighet_nn_1_1_N : N ;
  enstoerighet_nn_1_1_N : N ;
  entalpi_nn_1_N : N ;
  entomologi_nn_1_N : N ;
  entonighet_nn_1_N : N ;
  entropi_nn_1_N : N ;
  entraegenhet_nn_1_1_N : N ;
  entusiasmerbarhet_nn_1_N : N ;
  envetenhet_nn_1_N : N ;
  envishet_nn_1_N : N ;
  envaelde_nn_1_1_N : N ;
  envaeldighet_nn_1_1_N : N ;
  envaaldsmakt_nn_1_1_N : N ;
  enoegdhet_nn_1_1_N : N ;
  eoarkeikum_nn_1_N : N ;
  eocen_nn_1_N : N ;
  epidemiologi_nn_1_N : N ;
  epilerbarhet_nn_1_N : N ;
  epistemologi_nn_1_N : N ;
  epokgoerande_av_1_1_A : A ;
  erfarenhetsmaessighet_nn_1_1_N : N ;
  erforderlighet_nn_1_N : N ;
  ergonomi_nn_1_N : N ;
  erigerbarhet_nn_1_N : N ;
  erisaepple_nn_1_1_N : N ;
  erkaend_av_1_1_A : A ;
  erkaendhet_nn_1_1_N : N ;
  erkaennsamhet_nn_1_1_N : N ;
  eroderbarhet_nn_1_N : N ;
  erotiserande_nn_1_N : N ;
  erotisering_nn_1_N : N ;
  erotomani_nn_1_N : N ;
  ersaettlighet_nn_1_1_N : N ;
  ersaettningsskyldighet_nn_1_1_N : N ;
  eskalerbarhet_nn_1_N : N ;
  eskatologi_nn_1_N : N ;
  eskorterbarhet_nn_1_N : N ;
  esperanto_nn_1_N : N ;
  espri_nn_1_N : N ;
  esteticerbarhet_nn_1_N : N ;
  estetiserbarhet_nn_1_N : N ;
  estimerbarhet_nn_1_N : N ;
  etablerbarhet_nn_1_N : N ;
  eteriserbarhet_nn_1_N : N ;
  etiketterbarhet_nn_1_N : N ;
  etiologi_nn_1_N : N ;
  etnografi_nn_1_N : N ;
  etnologi_nn_1_N : N ;
  etologi_nn_1_N : N ;
  etruskologi_nn_1_N : N ;
  ettrighet_nn_1_N : N ;
  etymologiserbarhet_nn_1_N : N ;
  eukalyptusdoftande_av_1_A : A ;
  europeiserbarhet_nn_1_N : N ;
  europid_av_1_A : A ;
  europium_nn_1_N : N ;
  eutanasi_nn_1_N : N ;
  evakuerbarhet_nn_1_N : N ;
  evaluerbarhet_nn_1_N : N ;
  evalverbarhet_nn_1_N : N ;
  evaporerbarhet_nn_1_N : N ;
  evinnerlighet_nn_1_N : N ;
  evolutionsmaessighet_nn_1_1_N : N ;
  evaerdlighet_nn_1_1_N : N ;
  examinerbarhet_nn_1_N : N ;
  excerperbarhet_nn_1_N : N ;
  exciterbarhet_nn_1_N : N ;
  exekverbarhet_nn_1_N : N ;
  exemplifierbarhet_nn_1_N : N ;
  exercerbarhet_nn_1_N : N ;
  existensberaettigande_nn_1_1_N : N ;
  exkluderbarhet_nn_1_N : N ;
  exkommunicerbarhet_nn_1_N : N ;
  expanderbarhet_nn_1_N : N ;
  expansionstakt_nn_1_N : N ;
  expatrierbarhet_nn_1_N : N ;
  expedierbarhet_nn_1_N : N ;
  expektorerbarhet_nn_1_N : N ;
  experimentalkirurgi_nn_1_N : N ;
  explicerbarhet_nn_1_N : N ;
  explicithet_nn_1_N : N ;
  exploaterbarhet_nn_1_N : N ;
  exploderbarhet_nn_1_N : N ;
  exponerbarhet_nn_1_N : N ;
  exporterbarhet_nn_1_N : N ;
  exproprierbarhet_nn_1_N : N ;
  exstirperbarhet_nn_1_N : N ;
  extemporerbarhet_nn_1_N : N ;
  exterritorialraett_nn_1_1_N : N ;
  extra_av_1_A : A ;
  extraherbarhet_nn_1_N : N ;
  extrahud_nn_1_N : N ;
  extraordinarie_av_1_A : A ;
  extrapolerbarhet_nn_1_N : N ;
  extroverthet_nn_1_N : N ;
  fabelaktighet_nn_1_N : N ;
  fabricerbarhet_nn_1_N : N ;
  fabriksarbetande_av_1_A : A ;
  fabriksmaessighet_nn_1_1_N : N ;
  fabulerbarhet_nn_1_N : N ;
  facetterbarhet_nn_1_N : N ;
  fackkunnighet_nn_1_N : N ;
  facklighet_nn_1_N : N ;
  fackmaessighet_nn_1_1_N : N ;
  fadd_av_1_A : A ;
  faddhet_nn_1_N : N ;
  faderlighet_nn_1_N : N ;
  faderskaerlek_nn_1_1_N : N ;
  faktakoll_nn_1_N : N ;
  faktiskhet_nn_1_N : N ;
  fakturerbarhet_nn_1_N : N ;
  falhet_nn_1_N : N ;
  falkblick_nn_1_N : N ;
  fallandesot_nn_1_N : N ;
  fallfaerdighet_nn_1_1_N : N ;
  fallskaermsliknande_av_1_1_A : A ;
  falsifierbarhet_nn_1_N : N ;
  familjeraett_nn_1_1_N : N ;
  familjeterapi_nn_1_N : N ;
  familjetillhoerighet_nn_1_1_N : N ;
  familjevaard_nn_1_1_N : N ;
  famlande_av_1_A : A ;
  fanflykt_nn_1_N : N ;
  fantasieggande_av_1_A : A ;
  fantasikraft_nn_1_N : N ;
  fantasirikedom_nn_1_N : N ;
  fantasirikhet_nn_1_N : N ;
  fantiserbarhet_nn_1_N : N ;
  fantomsnygghet_nn_1_N : N ;
  farbarhet_nn_1_N : N ;
  farbroderlighet_nn_1_N : N ;
  farmaci_nn_1_N : N ;
  farmacie_av_1_A : A ;
  farmakognosi_nn_1_N : N ;
  farmakologi_nn_1_N : N ;
  farofylldhet_nn_1_N : N ;
  farsi_nn_1_N : N ;
  fartblind_av_1_A : A ;
  fartblindhet_nn_1_N : N ;
  fartfylldhet_nn_1_N : N ;
  fartvind_nn_1_N : N ;
  fartygsflagg_nn_1_N : N ;
  fartygsproviant_nn_1_N : N ;
  fasavaeckande_av_1_1_A : A ;
  fascinerbarhet_nn_1_N : N ;
  fascistoid_av_1_A : A ;
  fasetterbarhet_nn_1_N : N ;
  fasonerbarhet_nn_1_N : N ;
  fastighetstaxerbarhet_nn_1_N : N ;
  fastlag_nn_1_N : N ;
  fastspaenning_nn_1_1_N : N ;
  fatt_av_1_A : A ;
  fattighjaelp_nn_1_1_N : N ;
  fattigvaard_nn_1_1_N : N ;
  fattlighet_nn_1_N : N ;
  favoriserbarhet_nn_1_N : N ;
  febrighet_nn_1_N : N ;
  fel_av_1_A : A ;
  felfrihet_nn_1_N : N ;
  felnavigerande_nn_1_N : N ;
  felparkerbarhet_nn_1_N : N ;
  felsyn_nn_1_N : N ;
  femdubblande_nn_1_N : N ;
  femdubbling_nn_1_N : N ;
  femfaldigande_nn_1_N : N ;
  femmarkerkorv_nn_1_N : N ;
  femmil_nn_1_N : N ;
  fena_av_1_A : A ;
  fennomani_nn_1_N : N ;
  fenomenologi_nn_1_N : N ;
  fermenterbarhet_nn_1_N : N ;
  fermhet_nn_1_N : N ;
  festlighet_nn_2_N : N ;
  festplanering_nn_1_N : N ;
  feterbarhet_nn_1_N : N ;
  fethet_nn_1_N : N ;
  fetlagdhet_nn_1_N : N ;
  fetthaltighet_nn_1_N : N ;
  fettloesande_av_1_1_A : A ;
  fettrikhet_nn_1_N : N ;
  fettsot_nn_1_N : N ;
  fettvaev_nn_1_1_N : N ;
  fetvadd_nn_1_N : N ;
  fiberrikhet_nn_1_N : N ;
  fibrighet_nn_1_N : N ;
  filantropi_nn_1_N : N ;
  filateli_nn_1_N : N ;
  filharmoni_nn_1_N : N ;
  filosofie_av_1_A : A ;
  finemang_av_1_A : A ;
  finsktalande_av_1_A : A ;
  fiske_nn_1_N : N ;
  fiskaetande_nn_1_1_N : N ;
  fjaederliknande_av_1_1_A : A ;
  fjaellnaera_av_1_1_A : A ;
  fjaerran_av_1_1_A : A ;
  fjaerrseende_av_1_1_A : A ;
  fjaerrskaadande_av_1_1_A : A ;
  fladdermusliknande_av_1_A : A ;
  flaggviftande_av_1_A : A ;
  flat_av_1_A : A ;
  flau_av_1_A : A ;
  flergaangs_av_1_1_A : A ;
  flicktycke_nn_1_N : N ;
  flugfiske_nn_1_N : N ;
  flyktingmottagande_nn_1_N : N ;
  folkomroestande_nn_1_1_N : N ;
  folkpoesi_nn_1_N : N ;
  follikelstimulerande_av_1_A : A ;
  foniatri_nn_1_N : N ;
  fonologi_nn_1_N : N ;
  fordrande_av_1_A : A ;
  forntida_av_1_A : A ;
  forskningsforskningsstoedjande_av_1_1_A : A ;
  fortgaaende_av_1_1_A : A ;
  fortis_av_1_A : A ;
  fortloepande_av_1_1_A : A ;
  fortran_nn_1_N : N ;
  fortuna_nn_1_N : N ;
  fossilletande_nn_1_N : N ;
  fotabjaelle_nn_1_1_N : N ;
  fotfaeste_nn_1_1_N : N ;
  fotogenique_av_1_A : A ;
  fotogrammetri_nn_1_N : N ;
  fotointresse_nn_1_N : N ;
  fotokemi_nn_1_N : N ;
  fotometri_nn_1_N : N ;
  framdrivande_nn_1_N : N ;
  framfoersittande_av_1_1_A : A ;
  framfoervarande_av_1_1_A : A ;
  framgaangsteologi_nn_1_1_N : N ;
  framrusande_av_1_A : A ;
  framskjutande_av_1_A : A ;
  framspringande_av_1_A : A ;
  framstaaende_av_1_1_A : A ;
  framtida_av_1_A : A ;
  framtraedande_av_1_1_A : A ;
  framtraengande_av_1_1_A : A ;
  framtraengande_nn_1_1_N : N ;
  framaatblickande_av_1_1_A : A ;
  framaatskridande_nn_1_1_N : N ;
  framaatsyftande_av_1_1_A : A ;
  fransktalande_av_1_A : A ;
  frapperande_av_1_A : A ;
  fraseologi_nn_1_N : N ;
  fredsbefraemjande_av_1_1_A : A ;
  fredsbevarande_av_1_A : A ;
  fredstida_av_1_A : A ;
  fredsaelskande_av_1_1_A : A ;
  frenesi_nn_1_N : N ;
  frenologi_nn_1_N : N ;
  frestande_av_1_A : A ;
  fribaerande_av_1_1_A : A ;
  frigid_av_1_A : A ;
  frigaaende_av_1_1_A : A ;
  frihetsfoerkvaevande_av_1_1_A : A ;
  frihetslaengtande_av_1_1_A : A ;
  frilevande_av_1_A : A ;
  friserande_nn_1_N : N ;
  fristaaende_av_1_1_A : A ;
  fruktbringande_av_1_A : A ;
  fruktbaerande_av_1_1_A : A ;
  fruktliknande_av_1_A : A ;
  fraelse_av_1_1_A : A ;
  fraelse_nn_1_1_N : N ;
  fraemmande_av_1_1_A : A ;
  fraemmat_av_1_1_A : A ;
  fraemre_av_1_1_A : A ;
  fraetande_av_1_1_A : A ;
  fraanskiljande_nn_1_1_N : N ;
  fraanstoetande_av_1_1_A : A ;
  fraantraede_nn_1_1_N : N ;
  fraanvarande_av_1_1_A : A ;
  fraanvaend_av_1_1_A : A ;
  fullproppande_nn_1_N : N ;
  fulvinklande_nn_1_N : N ;
  furage_nn_1_N : N ;
  futurologi_nn_1_N : N ;
  fylogeni_nn_1_N : N ;
  fyrdelande_nn_1_N : N ;
  fyrdubblande_nn_1_N : N ;
  fyrfaldigande_nn_1_N : N ;
  fyrfota_av_1_A : A ;
  fysiologi_nn_1_N : N ;
  faederne_nn_1_1_N : N ;
  faeltbiologi_nn_1_1_N : N ;
  faeltskytte_nn_1_1_N : N ;
  faengslande_av_1_1_A : A ;
  faerdigjaesande_nn_1_1_N : N ;
  faergblind_av_1_1_A : A ;
  faergflagnande_av_1_1_A : A ;
  faergseende_nn_1_1_N : N ;
  faergsprakande_av_1_1_A : A ;
  faergaekta_av_1_1_A : A ;
  faersksmide_nn_1_1_N : N ;
  faestningsliknande_av_1_1_A : A ;
  foega_av_1_1_A : A ;
  foeljande_av_1_1_A : A ;
  foerargelsevaeckande_av_1_1_A : A ;
  foerbarmande_nn_1_1_N : N ;
  foerbemaelde_av_1_1_A : A ;
  foerberedande_av_1_1_A : A ;
  foerbi_av_1_1_A : A ;
  foerbipasserande_av_1_1_A : A ;
  foerbiskyndande_av_1_1_A : A ;
  foerbisvepande_av_1_1_A : A ;
  foerbisvischande_av_1_1_A : A ;
  foerblivande_av_1_1_A : A ;
  foerbluffande_av_1_1_A : A ;
  foerdetta_av_1_1_A : A ;
  foerdomsalstrande_av_1_1_A : A ;
  foerdunstande_nn_1_1_N : N ;
  foeregaaende_av_1_1_A : A ;
  foeregaaende_nn_1_1_N : N ;
  foerekommande_av_1_1_A : A ;
  foerestaellande_av_1_1_A : A ;
  foerestaaende_av_1_1_A : A ;
  foeretagsdemokrati_nn_1_1_N : N ;
  foeretagsekonomi_nn_1_1_N : N ;
  foerevarande_av_1_1_A : A ;
  foerhanden_av_1_1_A : A ;
  foerhandenvarande_av_1_1_A : A ;
  foerhistoria_nn_1_1_N : N ;
  foerhaerskande_av_1_1_A : A ;
  foerintande_av_1_1_A : A ;
  foerklenande_av_1_1_A : A ;
  foerkrossande_av_1_1_A : A ;
  foerledande_av_1_1_A : A ;
  foerlitande_nn_1_1_N : N ;
  foerlustbringande_av_1_1_A : A ;
  foermedlande_av_1_1_A : A ;
  foermenande_nn_1_1_N : N ;
  foermer_av_1_1_A : A ;
  foermera_av_1_1_A : A ;
  foermildrande_av_1_1_A : A ;
  foernaglande_nn_1_1_N : N ;
  foerpliktande_av_1_1_A : A ;
  foerrfoerra_av_1_1_A : A ;
  foersoffande_nn_1_1_N : N ;
  foersonande_av_1_1_A : A ;
  foerspaend_av_1_1_A : A ;
  foerstbemaelde_av_1_1_A : A ;
  foerstnaemnd_av_1_1_A : A ;
  foerstaaende_av_1_1_A : A ;
  foersvaarande_av_1_1_A : A ;
  foertida_av_1_1_A : A ;
  foertingligande_nn_1_1_N : N ;
  foertjusande_av_1_1_A : A ;
  foertroendeingivande_av_1_1_A : A ;
  foertrollande_av_1_1_A : A ;
  foerutseende_av_1_1_A : A ;
  foerutseende_nn_1_1_N : N ;
  foerutvarande_av_1_1_A : A ;
  foervikingatida_av_1_1_A : A ;
  foervirrande_av_1_1_A : A ;
  foervaend_av_1_1_A : A ;
  foervaallande_nn_1_1_N : N ;
  foeryngringsbeskaerande_nn_1_1_N : N ;
  foeroedande_av_1_1_A : A ;
  gagnvirke_nn_1_N : N ;
  gall_av_1_A : A ;
  galldrivande_av_1_A : A ;
  galvanostegi_nn_1_N : N ;
  galvanotypi_nn_1_N : N ;
  gammaldags_av_1_A : A ;
  gammalrosa_av_1_A : A ;
  gaskromatografi_nn_1_N : N ;
  gastronomi_nn_1_N : N ;
  gatupoesi_nn_1_N : N ;
  gematri_nn_1_N : N ;
  gemmologi_nn_1_N : N ;
  generande_av_1_A : A ;
  genomgripande_av_1_A : A ;
  genomgaaende_av_1_1_A : A ;
  genomlysande_av_1_A : A ;
  genomtraengande_av_1_1_A : A ;
  genretaenjande_av_1_1_A : A ;
  geodesi_nn_1_N : N ;
  geografi_nn_1_N : N ;
  geokemi_nn_1_N : N ;
  geokronologi_nn_1_N : N ;
  geologi_nn_1_N : N ;
  geomorfologi_nn_1_N : N ;
  geotermi_nn_1_N : N ;
  geriatri_nn_1_N : N ;
  gerontologi_nn_1_N : N ;
  gestaltpsykologi_nn_1_N : N ;
  giraffliknande_av_1_A : A ;
  givande_av_1_A : A ;
  glaciologi_nn_1_N : N ;
  glasvete_nn_1_N : N ;
  glottokronologi_nn_1_N : N ;
  glupande_av_1_A : A ;
  gluten_av_1_A : A ;
  glaedjande_av_1_1_A : A ;
  glaedjestraalande_av_1_1_A : A ;
  glaensande_av_1_1_A : A ;
  gloedande_av_1_1_A : A ;
  gnagarliknande_av_1_A : A ;
  god_av_1_A : A ;
  godkaend_av_1_1_A : A ;
  godtycke_nn_1_N : N ;
  goticerande_av_1_A : A ;
  gotiserande_av_1_A : A ;
  gott_av_1_A : A ;
  gottfinnande_nn_1_N : N ;
  grad_av_1_A : A ;
  grafologi_nn_1_N : N ;
  grafonomi_nn_1_N : N ;
  gramse_av_1_A : A ;
  granatbeskjutande_nn_1_N : N ;
  grannlaga_av_1_A : A ;
  graverande_av_1_A : A ;
  gravid_av_1_A : A ;
  grekisktalande_av_1_A : A ;
  grenstaaende_av_1_1_A : A ;
  gripande_av_1_A : A ;
  groggvirke_nn_1_N : N ;
  groggy_av_1_A : A ;
  grovsmide_nn_1_N : N ;
  grund_av_1_A : A ;
  grundlaeggande_av_1_1_A : A ;
  gruppsykologi_nn_1_N : N ;
  gryne_nn_1_N : N ;
  gryningsgroggy_av_1_A : A ;
  graenstaenjande_av_1_1_A : A ;
  graensoeverskridande_av_1_1_A : A ;
  graeshoppeliknande_av_1_1_A : A ;
  graesliknande_av_1_1_A : A ;
  graavide_nn_1_1_N : N ;
  groenbete_nn_1_1_N : N ;
  groenblind_av_1_1_A : A ;
  groepe_nn_1_1_N : N ;
  gudaliknande_av_1_A : A ;
  gudasaend_av_1_1_A : A ;
  gudomliggoerande_nn_1_1_N : N ;
  gudstroende_av_1_A : A ;
  gujarati_nn_1_N : N ;
  guldglaensande_av_1_1_A : A ;
  guldliknande_av_1_A : A ;
  gultoerne_nn_1_1_N : N ;
  gylfputande_av_1_A : A ;
  gyllene_av_1_A : A ;
  gyllenglaensande_av_1_1_A : A ;
  gyllne_av_1_A : A ;
  gynekologi_nn_1_N : N ;
  gaengse_av_1_1_A : A ;
  gaavodiplomati_nn_1_1_N : N ;
  haj_av_1_A : A ;
  halal_av_1_A : A ;
  halma_nn_1_N : N ;
  halsbrytande_av_1_A : A ;
  halt_nn_2_N : N ;
  halvblind_av_1_A : A ;
  halvflytande_av_1_A : A ;
  halvlinne_nn_1_N : N ;
  halvnaeck_av_1_1_A : A ;
  halvrund_av_1_A : A ;
  halvtidsarbetande_av_1_A : A ;
  halvylle_nn_1_N : N ;
  handbojande_nn_1_N : N ;
  haploid_av_1_A : A ;
  harpunliknande_av_1_A : A ;
  haspelfiske_nn_1_N : N ;
  hausa_nn_2_N : N ;
  havande_av_1_A : A ;
  havreliknande_av_1_A : A ;
  havsfiske_nn_1_N : N ;
  havsgaaende_av_1_1_A : A ;
  hedrande_av_1_A : A ;
  hejdundrande_av_1_A : A ;
  helbraegda_av_1_1_A : A ;
  heltidsarbetande_av_1_A : A ;
  heltaeckande_av_1_1_A : A ;
  helvetes_av_1_A : A ;
  helylle_nn_1_N : N ;
  hemarbetande_av_1_A : A ;
  hematologi_nn_1_N : N ;
  hembraend_av_1_1_A : A ;
  hemdragande_av_1_A : A ;
  hemma_av_1_A : A ;
  hemmablind_av_1_A : A ;
  hemmaboende_av_1_A : A ;
  hemmahoerande_av_1_1_A : A ;
  hemvaendande_av_1_1_A : A ;
  herpetologi_nn_1_N : N ;
  hetero_av_1_A : A ;
  himlastormande_av_1_A : A ;
  himmelrike_nn_1_N : N ;
  himmelsskriande_av_1_A : A ;
  hindi_nn_1_N : N ;
  hindrande_av_1_A : A ;
  hinneliknande_av_1_A : A ;
  hippologi_nn_1_N : N ;
  histologi_nn_1_N : N ;
  historieberaettande_av_1_1_A : A ;
  historieintresse_nn_1_N : N ;
  hithoerande_av_1_1_A : A ;
  hittillsvarande_av_1_A : A ;
  hjaelpbehoevande_av_1_1_A : A ;
  hjaelpsoekande_av_1_1_A : A ;
  hjaertas_av_1_1_A : A ;
  hjaertknipande_av_1_1_A : A ;
  hjaertskaerande_av_1_1_A : A ;
  hjaertslitande_av_1_1_A : A ;
  hjaertstillande_av_1_1_A : A ;
  holocen_nn_1_N : N ;
  holografi_nn_1_N : N ;
  homeopati_nn_1_N : N ;
  homo_av_1_A : A ;
  hoppingivande_av_1_A : A ;
  hoprullande_nn_1_N : N ;
  hornblaende_nn_1_1_N : N ;
  hornliknande_av_1_A : A ;
  hornaemne_nn_1_1_N : N ;
  hudnaera_av_1_1_A : A ;
  humanekologi_nn_1_N : N ;
  humid_av_1_A : A ;
  hundra_av_1_A : A ;
  hundraedd_av_1_1_A : A ;
  hushaallsnaera_av_1_1_A : A ;
  hybrid_av_1_A : A ;
  hycklande_av_1_A : A ;
  hydrografi_nn_1_N : N ;
  hydrologi_nn_1_N : N ;
  hymnologi_nn_1_N : N ;
  hypertoni_nn_1_N : N ;
  hyvens_av_1_A : A ;
  haelsobringande_av_1_1_A : A ;
  haelsofraemjande_av_1_1_A : A ;
  haenfoerande_av_1_1_A : A ;
  haepnadsvaeckande_av_1_1_A : A ;
  haestliknande_av_1_1_A : A ;
  haestminne_nn_1_1_N : N ;
  haesttaemjande_nn_1_1_N : N ;
  haardloedande_nn_1_1_N : N ;
  haarliknande_av_1_1_A : A ;
  haarresande_av_1_1_A : A ;
  hoeftfaeste_nn_1_1_N : N ;
  hoegenergi_nn_1_1_N : N ;
  hoeggravid_av_1_1_A : A ;
  hoeglaege_nn_1_1_N : N ;
  hoegpresterande_av_1_1_A : A ;
  hoegspaend_av_1_1_A : A ;
  hoegstbjudande_av_1_1_A : A ;
  hoegstraevande_av_1_1_A : A ;
  hoegtflygande_av_1_1_A : A ;
  hoegtravande_av_1_1_A : A ;
  hoegtstaaende_av_1_1_A : A ;
  hoegtaeckande_av_1_1_A : A ;
  hoensminne_nn_1_1_N : N ;
  icke_existerande_av_1_A : A ;
  identitetssoekande_av_1_1_A : A ;
  ideografi_nn_1_N : N ;
  idiopati_nn_1_N : N ;
  ido_nn_1_N : N ;
  id_ehistoria_nn_1_1_N : N ;
  ifraagavarande_av_1_1_A : A ;
  igenkaennande_av_1_1_A : A ;
  igenkaennande_nn_1_1_N : N ;
  igensaettande_nn_1_1_N : N ;
  ihaallande_av_1_1_A : A ;
  ikonografi_nn_1_N : N ;
  iktyologi_nn_1_N : N ;
  illaluktande_av_1_A : A ;
  illamaaende_av_1_1_A : A ;
  illamaaende_nn_1_1_N : N ;
  illasmakande_av_1_A : A ;
  illavarslande_av_1_A : A ;
  immunologi_nn_1_N : N ;
  imponerande_av_1_A : A ;
  inbjudande_av_1_A : A ;
  inbringande_av_1_A : A ;
  inboerdes_av_1_1_A : A ;
  indianliknande_av_1_A : A ;
  individualpsykologi_nn_1_N : N ;
  indologi_nn_1_N : N ;
  industrispionage_nn_1_N : N ;
  infantiliserande_nn_1_N : N ;
  inflationsdrivande_av_1_A : A ;
  influensaliknande_av_1_A : A ;
  informationsteori_nn_1_N : N ;
  ingredierande_av_1_A : A ;
  ingaaende_av_1_1_A : A ;
  inkomstberoende_av_1_A : A ;
  inkomstbringande_av_1_A : A ;
  inkaennande_av_1_1_A : A ;
  inkaennande_nn_1_1_N : N ;
  inledande_av_1_A : A ;
  inne_av_1_A : A ;
  innebandyspelande_av_1_A : A ;
  inneboende_av_1_A : A ;
  inneliggande_av_1_A : A ;
  innestaaende_av_1_1_A : A ;
  innevarande_av_1_A : A ;
  inprogrammerande_nn_1_N : N ;
  inrikes_av_1_A : A ;
  inrusande_nn_1_N : N ;
  inseende_nn_1_N : N ;
  insektsaetande_av_1_1_A : A ;
  insjoefiske_nn_1_1_N : N ;
  insmickrande_av_1_A : A ;
  intagande_av_1_A : A ;
  integrerande_av_1_A : A ;
  internet_nn_1_N : N ;
  intet_nn_1_N : N ;
  intetsaegande_av_1_1_A : A ;
  intilliggande_av_1_A : A ;
  intimiserande_nn_1_N : N ;
  intresse_nn_2_N : N ;
  intressevaeckande_av_1_1_A : A ;
  intrigflaetande_av_1_1_A : A ;
  intraengande_av_1_1_A : A ;
  invand_av_1_A : A ;
  invaertes_av_1_1_A : A ;
  inaakande_av_1_1_A : A ;
  inaatvaend_av_1_1_A : A ;
  isfiske_nn_1_N : N ;
  islaege_nn_1_1_N : N ;
  isskimrande_av_1_A : A ;
  istaand_av_1_1_A : A ;
  ioegonenfallande_av_1_1_A : A ;
  ioegonfallande_av_1_1_A : A ;
  jakande_av_1_A : A ;
  jaktskytte_nn_1_N : N ;
  jalu_av_1_A : A ;
  jordnaera_av_1_1_A : A ;
  jourhavande_av_1_A : A ;
  jublande_av_1_A : A ;
  jura_nn_1_N : N ;
  juris_av_1_A : A ;
  juste_av_1_A : A ;
  jaedra_av_1_1_A : A ;
  jaedrans_av_1_1_A : A ;
  jaekla_av_1_1_A : A ;
  jaemfoerande_av_1_1_A : A ;
  jaernmetallurgi_nn_1_1_N : N ;
  jaettebra_av_1_1_A : A ;
  jaettekul_av_1_1_A : A ;
  jaetteraedd_av_1_1_A : A ;
  jaevla_av_1_1_A : A ;
  kadmiumgult_nn_1_N : N ;
  kadmiumroett_nn_1_1_N : N ;
  kainsmaerke_nn_1_1_N : N ;
  kakdoppande_av_1_A : A ;
  kalkkvaeve_nn_1_1_N : N ;
  kalkliknande_av_1_A : A ;
  kallflytande_av_1_A : A ;
  kalligrafi_nn_1_N : N ;
  kambrium_nn_1_N : N ;
  kambrosilur_nn_1_N : N ;
  kameraoevervakande_nn_1_1_N : N ;
  kamferdoftande_av_1_A : A ;
  kamouflage_nn_1_N : N ;
  kanon_av_1_A : A ;
  kanonbra_av_1_A : A ;
  kanonbaatsdiplomati_nn_1_1_N : N ;
  kaosteori_nn_1_N : N ;
  kaputt_av_1_A : A ;
  karakterologi_nn_1_N : N ;
  karaktaerologi_nn_1_1_N : N ;
  karambolage_nn_1_N : N ;
  karbon_nn_1_N : N ;
  kardborrliknande_av_1_A : A ;
  kardiologi_nn_1_N : N ;
  kartografi_nn_1_N : N ;
  katatoni_nn_1_N : N ;
  kattrakande_nn_1_N : N ;
  kaviar_nn_1_N : N ;
  kefir_nn_1_N : N ;
  kemi_nn_1_N : N ;
  kemigrafi_nn_1_N : N ;
  kemikum_nn_1_N : N ;
  kenozoikum_nn_1_N : N ;
  kindpussande_nn_1_N : N ;
  king_size_av_1_A : A ;
  kiromanti_nn_1_N : N ;
  kirurgi_nn_1_N : N ;
  klappkanon_av_1_A : A ;
  klassiserande_av_1_A : A ;
  klassmedvetande_nn_1_N : N ;
  klaustrofobi_nn_1_N : N ;
  kleptomani_nn_1_N : N ;
  klimathysteri_nn_1_N : N ;
  klimatologi_nn_1_N : N ;
  klimatoterapi_nn_1_N : N ;
  klimattroende_av_1_A : A ;
  klingon_nn_1_N : N ;
  klorvaete_nn_1_1_N : N ;
  klotrund_av_1_A : A ;
  kloeverliknande_av_1_1_A : A ;
  knakande_nn_1_N : N ;
  knappologi_nn_1_N : N ;
  knapptryckande_av_1_A : A ;
  knivdoedande_nn_1_1_N : N ;
  knaestaaende_nn_1_1_N : N ;
  koboltblaatt_nn_1_1_N : N ;
  kocko_av_1_A : A ;
  kodvaexlande_nn_1_1_N : N ;
  koko_av_1_A : A ;
  koldioxidfoerorenande_av_1_1_A : A ;
  kollisionsenergi_nn_1_N : N ;
  kolportage_nn_1_N : N ;
  kommande_av_1_A : A ;
  kommunikationsteori_nn_1_N : N ;
  konfliktkraedd_av_1_1_A : A ;
  konfliktraedd_av_1_1_A : A ;
  konsthistoria_nn_1_N : N ;
  konstsilke_nn_1_N : N ;
  konstsmide_nn_1_N : N ;
  konstteori_nn_1_N : N ;
  konsulterande_av_1_A : A ;
  kontraspionage_nn_1_N : N ;
  konvalescerande_nn_1_N : N ;
  koppar_nn_1_N : N ;
  koralliknande_av_1_A : A ;
  koreografi_nn_1_N : N ;
  korksmakande_av_1_A : A ;
  korpande_nn_1_N : N ;
  korrosionsskyddande_av_1_A : A ;
  korsvaedrande_nn_1_1_N : N ;
  korsaegande_nn_1_1_N : N ;
  kortklippande_nn_1_N : N ;
  korttidsminne_nn_1_N : N ;
  koscher_av_1_A : A ;
  kostnadskraevande_av_1_1_A : A ;
  kostnadssaenkande_av_1_1_A : A ;
  krabb_av_1_A : A ;
  kraftkraevande_av_1_1_A : A ;
  kramploesande_av_1_1_A : A ;
  krampstillande_av_1_A : A ;
  kremservitt_nn_1_N : N ;
  kreoliserande_nn_1_N : N ;
  kretsloppstaenkande_nn_1_1_N : N ;
  krigfoerande_av_1_1_A : A ;
  krigshetsande_av_1_A : A ;
  krigshetsande_nn_1_N : N ;
  krigsliknande_av_1_A : A ;
  krigsminne_nn_1_N : N ;
  krigsraedd_av_1_1_A : A ;
  krillfiske_nn_1_N : N ;
  kriminologi_nn_1_N : N ;
  kringboende_av_1_A : A ;
  kringfarande_av_1_A : A ;
  kringflackande_av_1_A : A ;
  kringkuskande_nn_1_N : N ;
  kringliggande_av_1_A : A ;
  kringresande_av_1_A : A ;
  kringsimmande_av_1_A : A ;
  kringsimmande_nn_1_N : N ;
  kringspringande_av_1_A : A ;
  kringstaaende_av_1_1_A : A ;
  kringsvirrande_av_1_A : A ;
  kringsvirrande_nn_1_N : N ;
  kringvandrande_av_1_A : A ;
  krismedvetande_nn_1_N : N ;
  kristallografi_nn_1_N : N ;
  kristologi_nn_1_N : N ;
  krita_nn_2_N : N ;
  kroknande_nn_1_N : N ;
  kromgult_nn_1_N : N ;
  kroppsbyggande_nn_1_N : N ;
  kroppsminne_nn_1_N : N ;
  kroppsnaera_av_1_1_A : A ;
  kryddande_nn_1_N : N ;
  krypskytte_nn_1_N : N ;
  kryptografi_nn_1_N : N ;
  kraenkande_av_1_1_A : A ;
  kraevande_av_1_1_A : A ;
  kraakliknande_av_1_1_A : A ;
  kul_av_1_A : A ;
  kulturgeografi_nn_1_N : N ;
  kulturhistoria_nn_1_N : N ;
  kunnande_nn_1_N : N ;
  kunskapssoekande_av_1_1_A : A ;
  kunskapsteori_nn_1_N : N ;
  kurage_nn_1_N : N ;
  kurare_nn_1_N : N ;
  kvantitetsteori_nn_1_N : N ;
  kvantteori_nn_1_N : N ;
  kvarhaengande_av_1_1_A : A ;
  kvartaer_nn_1_1_N : N ;
  kvarvarande_av_1_A : A ;
  kvarvarande_nn_1_N : N ;
  kvinnofoertryckande_av_1_1_A : A ;
  kvinnotycke_nn_1_N : N ;
  kvistliknande_av_1_A : A ;
  kvitt_av_1_A : A ;
  kvaevande_av_1_1_A : A ;
  kvaeve_nn_1_1_N : N ;
  kynologi_nn_1_N : N ;
  kyrkkaffe_nn_1_N : N ;
  kyrkobyggande_nn_1_N : N ;
  kyrkohistoria_nn_1_N : N ;
  kyssaekta_av_1_1_A : A ;
  kaend_av_1_1_A : A ;
  kaendiskaat_av_1_1_A : A ;
  kaenslotaenkande_nn_1_1_N : N ;
  kaerleksmelankoli_nn_1_1_N : N ;
  kaerlekstoerstande_av_1_1_A : A ;
  kaernenergi_nn_1_1_N : N ;
  kaernfoerande_av_1_1_A : A ;
  kaernkemi_nn_1_1_N : N ;
  kaernvapenbaerande_av_1_1_A : A ;
  kaernvirke_nn_1_1_N : N ;
  kaat_av_1_1_A : A ;
  koensoeverskridande_av_1_1_A : A ;
  koepslaaende_nn_1_1_N : N ;
  koettaetande_av_1_1_A : A ;
  labiologi_nn_1_N : N ;
  labour_nn_1_N : N ;
  lack_av_1_A : A ;
  laga_av_1_A : A ;
  lagtima_av_1_A : A ;
  laktos_av_1_A : A ;
  lampsvart_nn_1_N : N ;
  landsomfattande_av_1_A : A ;
  laparoskopi_nn_1_N : N ;
  laryngologi_nn_1_N : N ;
  laserpekande_nn_1_N : N ;
  lat_av_1_A : A ;
  latintalande_av_1_A : A ;
  lattedrickande_av_1_A : A ;
  lattedrickande_nn_1_N : N ;
  lattjo_av_1_A : A ;
  lavendeldoftande_av_1_A : A ;
  laxfiske_nn_1_N : N ;
  leds_av_1_A : A ;
  legio_av_1_A : A ;
  lek_av_1_A : A ;
  lekfiske_nn_1_N : N ;
  leklynne_nn_1_N : N ;
  lekt_av_1_A : A ;
  lenis_av_1_A : A ;
  lerduveskytte_nn_1_N : N ;
  less_av_1_A : A ;
  letargi_nn_1_N : N ;
  levande_av_1_A : A ;
  leverne_nn_1_N : N ;
  lexikografi_nn_1_N : N ;
  lexikologi_nn_1_N : N ;
  lidande_av_1_A : A ;
  liggvirke_nn_1_N : N ;
  light_av_1_A : A ;
  lika_av_1_A : A ;
  likaberaettigande_nn_1_1_N : N ;
  likalydande_av_1_A : A ;
  likljudande_av_1_A : A ;
  liknande_av_1_A : A ;
  liksvaevande_av_1_1_A : A ;
  liktaenkande_av_1_1_A : A ;
  likvid_av_1_A : A ;
  lila_av_1_A : A ;
  lila_nn_1_N : N ;
  limnologi_nn_1_N : N ;
  lindblomste_nn_1_N : N ;
  linne_nn_1_N : N ;
  lismande_av_1_A : A ;
  litteraturhistoria_nn_1_N : N ;
  litteratursociologi_nn_1_N : N ;
  live_av_1_A : A ;
  livgivande_av_1_A : A ;
  livraedd_av_1_1_A : A ;
  livs_av_1_A : A ;
  livsavgoerande_av_1_1_A : A ;
  livsbefraemjande_av_1_1_A : A ;
  livsbejakande_av_1_A : A ;
  livsenergi_nn_1_N : N ;
  livshotande_av_1_A : A ;
  livslevande_av_1_A : A ;
  livsmedelskemi_nn_1_N : N ;
  livsuppehaelle_nn_1_1_N : N ;
  livsuppehaallande_av_1_1_A : A ;
  ljudande_av_1_A : A ;
  ljuddaempande_av_1_1_A : A ;
  ljudhaermande_av_1_1_A : A ;
  ljusblind_av_1_A : A ;
  ljusenergi_nn_1_N : N ;
  ljuskraevande_av_1_1_A : A ;
  ljusterapi_nn_1_N : N ;
  ljusaekta_av_1_1_A : A ;
  ljusaelskande_av_1_1_A : A ;
  lockande_av_1_A : A ;
  logopedi_nn_1_N : N ;
  loss_av_1_A : A ;
  lovande_av_1_A : A ;
  luftfarande_av_1_A : A ;
  luftherravaelde_nn_1_1_N : N ;
  lufthaerdande_av_1_1_A : A ;
  luftskytte_nn_1_N : N ;
  lugnande_av_1_A : A ;
  lunchkaffe_nn_1_N : N ;
  lungandande_av_1_A : A ;
  lutter_av_1_A : A ;
  lyckobringande_av_1_A : A ;
  lymfliknande_av_1_A : A ;
  lysande_av_1_A : A ;
  lytt_av_2_A : A ;
  lyxkonsumerande_nn_1_N : N ;
  lae_nn_1_1_N : N ;
  laeck_av_1_1_A : A ;
  laegesenergi_nn_1_1_N : N ;
  laengsgaaende_av_1_1_A : A ;
  laens_av_1_1_A : A ;
  laenspumpande_nn_1_1_N : N ;
  laerdomshistoria_nn_1_1_N : N ;
  laettflytande_av_1_1_A : A ;
  laadliknande_av_1_1_A : A ;
  laagpresterande_av_1_1_A : A ;
  laagspaend_av_1_1_A : A ;
  laagtstaaende_av_1_1_A : A ;
  laanggrund_av_1_1_A : A ;
  laangivande_av_1_1_A : A ;
  laangtgaaende_av_1_1_A : A ;
  laangtidsminne_nn_1_1_N : N ;
  laangtidsverkande_av_1_1_A : A ;
  laangvirke_nn_1_1_N : N ;
  laangvaega_av_1_1_A : A ;
  laatsasdemokrati_nn_1_1_N : N ;
  loejevaeckande_av_1_1_A : A ;
  loenande_av_1_1_A : A ;
  loepande_av_1_1_A : A ;
  loepe_nn_1_1_N : N ;
  loesan_av_1_1_A : A ;
  loesande_av_1_1_A : A ;
  loesdriveri_nn_1_1_N : N ;
  loesgaaende_av_1_1_A : A ;
  macho_av_1_A : A ;
  magdansande_av_1_A : A ;
  magi_nn_1_N : N ;
  magnificus_av_1_A : A ;
  magnum_av_1_A : A ;
  mahognyliknande_av_1_A : A ;
  maka_av_1_A : A ;
  makrokosmos_nn_1_N : N ;
  maktfilosofi_nn_1_N : N ;
  maktpaaliggande_av_1_1_A : A ;
  maktunderlaege_nn_1_1_N : N ;
  maktutoevande_nn_1_1_N : N ;
  malakitgroent_nn_1_1_N : N ;
  malmfoerande_av_1_1_A : A ;
  management_nn_1_N : N ;
  mandarin_nn_2_N : N ;
  maranata_nn_1_N : N ;
  mardroemsliknande_av_1_1_A : A ;
  marinarkeologi_nn_1_N : N ;
  marinbiologi_nn_1_N : N ;
  marklevande_av_1_A : A ;
  marknadsledande_av_1_A : A ;
  marmorliknande_av_1_A : A ;
  marmorskinande_av_1_A : A ;
  maskliknande_av_1_A : A ;
  masspsykologi_nn_1_N : N ;
  mate_nn_1_N : N ;
  matt_av_2_A : A ;
  matte_nn_3_N : N ;
  medbestaemmande_nn_1_1_N : N ;
  medel_av_1_A : A ;
  medelklasstaenkande_nn_1_1_N : N ;
  medeltida_av_1_A : A ;
  medelaalders_av_1_1_A : A ;
  medicinhistoria_nn_1_N : N ;
  medinflytande_nn_1_N : N ;
  medkaennande_av_1_1_A : A ;
  medlidande_nn_1_N : N ;
  medryckande_av_1_A : A ;
  medverkande_av_1_A : A ;
  medvetande_nn_1_N : N ;
  medvetandegoerande_nn_1_1_N : N ;
  medvetandehoejande_av_1_1_A : A ;
  megalomani_nn_1_N : N ;
  melankoli_nn_1_N : N ;
  mellankommande_av_1_A : A ;
  mellanliggande_av_1_A : A ;
  menande_av_1_A : A ;
  mensande_nn_1_N : N ;
  meritokrati_nn_1_N : N ;
  mesoarkeikum_nn_1_N : N ;
  mesozoikum_nn_1_N : N ;
  metallglaensande_av_1_1_A : A ;
  metallografi_nn_1_N : N ;
  metallurgi_nn_1_N : N ;
  meteorologi_nn_1_N : N ;
  metrologi_nn_1_N : N ;
  metylenblaatt_nn_1_1_N : N ;
  mikrobiologi_nn_1_N : N ;
  mikroneurografi_nn_1_N : N ;
  mikroskopi_nn_1_N : N ;
  militaerhistoria_nn_1_1_N : N ;
  miljoevurmande_av_1_1_A : A ;
  mineralogi_nn_1_N : N ;
  mineralrike_nn_1_N : N ;
  miocen_nn_1_N : N ;
  misantropi_nn_1_N : N ;
  misshushaallande_nn_1_1_N : N ;
  misskaend_av_1_1_A : A ;
  missledande_av_1_A : A ;
  misstycke_nn_1_N : N ;
  missvisande_av_1_A : A ;
  mjoelkbildande_av_1_1_A : A ;
  mobiltelefoni_nn_1_N : N ;
  mockaliknande_av_1_A : A ;
  molekylaerbiologi_nn_1_1_N : N ;
  mongoloid_av_1_A : A ;
  monogami_nn_1_N : N ;
  monomani_nn_1_N : N ;
  monotoni_nn_1_N : N ;
  monstrum_nn_1_N : N ;
  moralfilosofi_nn_1_N : N ;
  morbid_av_1_A : A ;
  morgonkaffe_nn_1_N : N ;
  motbjudande_av_1_A : A ;
  motstridande_av_1_A : A ;
  motstaaende_av_1_1_A : A ;
  motsvarande_av_1_A : A ;
  motvalls_av_1_A : A ;
  mumsfilibaba_av_1_A : A ;
  mumsfilibabba_av_1_A : A ;
  mumsfillibaba_av_1_A : A ;
  mumsfillibabba_av_1_A : A ;
  murkelliknande_av_1_A : A ;
  mykologi_nn_1_N : N ;
  myopi_nn_1_N : N ;
  mysko_av_1_A : A ;
  mytifierande_nn_1_N : N ;
  mytomani_nn_1_N : N ;
  maenniskointresse_nn_1_1_N : N ;
  maenniskoliknande_av_1_1_A : A ;
  maenniskoaetande_av_1_1_A : A ;
  maessingsblaenkande_av_1_1_A : A ;
  maestrande_av_1_1_A : A ;
  maalande_av_1_1_A : A ;
  maalfoere_nn_1_1_N : N ;
  maalgivande_av_1_1_A : A ;
  maalsoekande_av_1_1_A : A ;
  maanadsrasande_av_1_1_A : A ;
  maangahanda_av_1_1_A : A ;
  maangfrestande_av_1_1_A : A ;
  maanggifte_nn_1_1_N : N ;
  maangskiftande_av_1_1_A : A ;
  maanliknande_av_1_1_A : A ;
  moederne_nn_1_1_N : N ;
  moegelhindrande_av_1_1_A : A ;
  moerdande_av_1_1_A : A ;
  moerkblond_av_1_1_A : A ;
  moerkerseende_nn_1_1_N : N ;
  moerkraedd_av_1_1_A : A ;
  moerksens_av_1_1_A : A ;
  namnminne_nn_1_N : N ;
  narkomani_nn_1_N : N ;
  nationalekonomi_nn_1_N : N ;
  nattblind_av_1_A : A ;
  nattfraemmande_nn_1_1_N : N ;
  nattyxne_nn_1_N : N ;
  naturalhistoria_nn_1_N : N ;
  naturfilosofi_nn_1_N : N ;
  naturgeografi_nn_1_N : N ;
  naturhistoria_nn_1_N : N ;
  naturmagi_nn_1_N : N ;
  naturnaera_av_1_1_A : A ;
  naturorienterande_av_1_A : A ;
  naturpoesi_nn_1_N : N ;
  navelskaadande_av_1_1_A : A ;
  nedanstaaende_av_1_1_A : A ;
  nedgaaende_nn_1_1_N : N ;
  nedhaengande_av_1_1_A : A ;
  nedlaatande_av_1_1_A : A ;
  nedra_av_1_A : A ;
  nedrans_av_1_A : A ;
  nedslaaende_av_1_1_A : A ;
  nedstaemmande_av_1_1_A : A ;
  nedsaettande_av_1_1_A : A ;
  nedtystande_nn_1_N : N ;
  nedaatgaaende_av_1_1_A : A ;
  nedaatgaaende_nn_1_1_N : N ;
  negationsmonotoni_nn_1_N : N ;
  nekrofili_nn_1_N : N ;
  neoarkeikum_nn_1_N : N ;
  neofili_nn_1_N : N ;
  neogen_nn_1_N : N ;
  neologi_nn_1_N : N ;
  nepali_nn_1_N : N ;
  nere_av_1_A : A ;
  nergaaende_nn_1_1_N : N ;
  nerhaengande_av_1_1_A : A ;
  nerlaatande_av_1_1_A : A ;
  nerslaaende_av_1_1_A : A ;
  nersaettande_av_1_1_A : A ;
  nertystande_nn_1_N : N ;
  nervkittlande_av_1_A : A ;
  nervpirrande_av_1_A : A ;
  nervpaafrestande_av_1_1_A : A ;
  nervskyddande_av_1_A : A ;
  neraatgaaende_av_1_1_A : A ;
  neraatgaaende_nn_1_1_N : N ;
  nettotonnage_nn_1_N : N ;
  neuralgi_nn_1_N : N ;
  neurasteni_nn_1_N : N ;
  neurofysiologi_nn_1_N : N ;
  neurografi_nn_1_N : N ;
  neurologi_nn_1_N : N ;
  neuropati_nn_1_N : N ;
  neurotiserande_nn_1_N : N ;
  nigsittande_av_1_A : A ;
  nigstaaende_av_1_1_A : A ;
  nitid_av_1_A : A ;
  njutningsfilosofi_nn_1_N : N ;
  noga_av_1_A : A ;
  nojande_nn_1_N : N ;
  nomografi_nn_1_N : N ;
  non_iron_av_1_A : A ;
  nordvaestra_av_1_1_A : A ;
  nordoestra_av_1_1_A : A ;
  normerande_av_1_A : A ;
  normgivande_av_1_A : A ;
  norra_av_1_A : A ;
  norrgaaende_av_1_1_A : A ;
  norsktalande_av_1_A : A ;
  nulaege_nn_1_1_N : N ;
  numen_nn_1_N : N ;
  nuppande_nn_1_N : N ;
  nutida_av_1_A : A ;
  nuvarande_av_1_A : A ;
  nyanlaend_av_1_1_A : A ;
  nyhetsvaerde_nn_1_1_N : N ;
  nyktofobi_nn_1_N : N ;
  nymfomani_nn_1_N : N ;
  nyponte_nn_1_N : N ;
  nysande_nn_1_N : N ;
  nyskapande_nn_1_N : N ;
  nytaend_av_1_1_A : A ;
  nytaenkande_nn_1_1_N : N ;
  nyvaelle_nn_1_1_N : N ;
  naeck_av_1_1_A : A ;
  naeckande_nn_1_1_N : N ;
  naeraliggande_av_1_1_A : A ;
  naerande_av_1_1_A : A ;
  naerboende_av_1_1_A : A ;
  naerdemokrati_nn_1_1_N : N ;
  naeringsfysiologi_nn_1_1_N : N ;
  naeringsgeografi_nn_1_1_N : N ;
  naeringslivsfraemjande_av_1_1_A : A ;
  naerliggande_av_1_1_A : A ;
  naerminne_nn_1_1_N : N ;
  naerstuderande_nn_1_1_N : N ;
  naerstaaende_av_1_1_A : A ;
  naervarande_av_1_1_A : A ;
  naestfoeljande_av_1_1_A : A ;
  naestkommande_av_1_1_A : A ;
  naetanvaendande_nn_1_1_N : N ;
  naetfiske_nn_1_1_N : N ;
  naetkommunicerande_nn_1_1_N : N ;
  noedlidande_av_1_1_A : A ;
  noejesfiske_nn_1_1_N : N ;
  noetliknande_av_1_1_A : A ;
  oanlaend_av_1_1_A : A ;
  oantaend_av_1_1_A : A ;
  oanvaend_av_1_1_A : A ;
  oavkaend_av_1_1_A : A ;
  oavsaend_av_1_1_A : A ;
  oavvaend_av_1_1_A : A ;
  obekaend_av_1_1_A : A ;
  obenaemnd_av_1_1_A : A ;
  oberoende_av_1_A : A ;
  oberoende_nn_1_N : N ;
  obraend_av_1_1_A : A ;
  oceangaaende_av_1_1_A : A ;
  oceanografi_nn_1_N : N ;
  odlingsvaerde_nn_1_1_N : N ;
  odontologi_nn_1_N : N ;
  odontologie_av_1_A : A ;
  oeftersaend_av_1_1_A : A ;
  oense_av_1_A : A ;
  oerkaend_av_1_1_A : A ;
  off_white_av_1_A : A ;
  offshore_av_1_A : A ;
  ofraelse_av_1_1_A : A ;
  oftalmologi_nn_1_N : N ;
  oftalmoskopi_nn_1_N : N ;
  ofoerbraend_av_1_1_A : A ;
  ofoere_nn_1_1_N : N ;
  ofoerstaaende_av_1_1_A : A ;
  ofoersaend_av_1_1_A : A ;
  ofoervaend_av_1_1_A : A ;
  ogodkaend_av_1_1_A : A ;
  oherrans_av_1_A : A ;
  oinsaend_av_1_1_A : A ;
  ointresse_nn_1_N : N ;
  ojuste_av_1_A : A ;
  ok_av_1_A : A ;
  okay_av_1_A : A ;
  okej_av_1_A : A ;
  okey_av_1_A : A ;
  okringraend_av_1_1_A : A ;
  okynne_nn_1_N : N ;
  okynnesstrejkande_nn_1_N : N ;
  okaend_av_1_1_A : A ;
  olaga_av_1_A : A ;
  oligocen_nn_1_N : N ;
  oligofreni_nn_1_N : N ;
  oliktaenkande_av_1_1_A : A ;
  oljeberoende_nn_1_N : N ;
  oljeaekta_av_1_1_A : A ;
  olycksbringande_av_1_A : A ;
  olycksbaadande_av_1_1_A : A ;
  omaka_av_1_A : A ;
  omfattande_av_1_A : A ;
  omkostymerande_nn_1_N : N ;
  omkringliggande_av_1_A : A ;
  omsams_av_1_A : A ;
  omskakande_av_1_A : A ;
  omstaaende_av_1_1_A : A ;
  omstoertande_av_1_1_A : A ;
  omtumlande_av_1_A : A ;
  omvaend_av_1_1_A : A ;
  omvaexlande_av_1_1_A : A ;
  onani_nn_1_N : N ;
  ond_av_1_A : A ;
  oneiromanti_nn_1_N : N ;
  onkologi_nn_1_N : N ;
  onomatologi_nn_1_N : N ;
  onomatopoesi_nn_1_N : N ;
  ont_av_1_A : A ;
  ontogeni_nn_1_N : N ;
  onaemnd_av_1_1_A : A ;
  oogami_nn_1_N : N ;
  oomnaemnd_av_1_1_A : A ;
  oomspaend_av_1_1_A : A ;
  oomvaend_av_1_1_A : A ;
  opaliserande_av_1_A : A ;
  opalskimrande_av_1_A : A ;
  opassande_av_1_A : A ;
  open_av_1_A : A ;
  opiumliknande_av_1_A : A ;
  oppbaerande_nn_1_1_N : N ;
  oppflammande_av_1_A : A ;
  oppfriskande_av_1_A : A ;
  oppiggande_av_1_A : A ;
  oppochnedvaend_av_1_1_A : A ;
  oppochnervaend_av_1_1_A : A ;
  oppvaknande_nn_1_N : N ;
  oppaanedvaend_av_1_1_A : A ;
  oppaanervaend_av_1_1_A : A ;
  oppaat_av_1_1_A : A ;
  oppaatgaaende_av_1_1_A : A ;
  oppaatgaaende_nn_1_1_N : N ;
  oppaatstigande_av_1_1_A : A ;
  oppaatstraevande_av_1_1_A : A ;
  opaamind_av_1_1_A : A ;
  ordblind_av_1_A : A ;
  ordgeografi_nn_1_N : N ;
  ordinarie_av_1_A : A ;
  ordovicium_nn_1_N : N ;
  organdi_nn_1_N : N ;
  orgelliknande_av_1_A : A ;
  ormliknande_av_1_A : A ;
  ornitologi_nn_1_N : N ;
  oroande_av_1_A : A ;
  orografi_nn_1_N : N ;
  orovaeckande_av_1_1_A : A ;
  ortodonti_nn_1_N : N ;
  ortopedi_nn_1_N : N ;
  orund_av_1_A : A ;
  oraedd_av_1_1_A : A ;
  osammanhaengande_av_1_1_A : A ;
  osams_av_1_A : A ;
  oseende_av_1_A : A ;
  osteologi_nn_1_N : N ;
  ostliknande_av_1_A : A ;
  ostloepe_nn_1_1_N : N ;
  ostaemne_nn_1_1_N : N ;
  osund_av_1_A : A ;
  otalt_av_1_A : A ;
  otillfreds_av_1_A : A ;
  otillfredsstaellande_av_1_1_A : A ;
  otologi_nn_1_N : N ;
  otaend_av_1_1_A : A ;
  outstanding_av_1_A : A ;
  ovannaemnd_av_1_1_A : A ;
  ovanstaaende_av_1_1_A : A ;
  ovetande_av_1_A : A ;
  ovetandes_av_1_A : A ;
  ovidkommande_av_1_A : A ;
  oaekta_av_1_1_A : A ;
  paddelliknande_av_1_A : A ;
  paddlande_nn_1_N : N ;
  paj_av_1_A : A ;
  paleoarkeikum_nn_1_N : N ;
  paleocen_nn_1_N : N ;
  paleogen_nn_1_N : N ;
  paleografi_nn_1_N : N ;
  paleontologi_nn_1_N : N ;
  paleozoikum_nn_1_N : N ;
  pansarbrytande_av_1_A : A ;
  papegojliknande_av_1_A : A ;
  papyrologi_nn_1_N : N ;
  paraguayte_nn_1_N : N ;
  paranoid_av_1_A : A ;
  paraplyliknande_av_1_A : A ;
  parapsykologi_nn_1_N : N ;
  passande_av_1_A : A ;
  pass_e_av_1_1_A : A ;
  patientbemoetande_nn_1_1_N : N ;
  patofysiologi_nn_1_N : N ;
  peakande_nn_1_N : N ;
  pechblaende_nn_1_1_N : N ;
  pederasti_nn_1_N : N ;
  pedofili_nn_1_N : N ;
  pedologi_nn_1_N : N ;
  pengaslukande_av_1_A : A ;
  penningvaerde_nn_1_1_N : N ;
  pennliknande_av_1_A : A ;
  pennsylvan_nn_1_N : N ;
  pensionsgrundande_av_1_A : A ;
  perfid_av_1_A : A ;
  perm_nn_1_N : N ;
  persiflage_nn_1_N : N ;
  personhistoria_nn_1_N : N ;
  personkemi_nn_1_N : N ;
  perspektivskapande_av_1_A : A ;
  petnoga_av_1_A : A ;
  petrografi_nn_1_N : N ;
  piercande_nn_1_N : N ;
  piggelin_av_1_A : A ;
  pimpelfiske_nn_1_N : N ;
  pinande_av_1_A : A ;
  piproekande_av_1_1_A : A ;
  piproekande_nn_1_1_N : N ;
  pirum_av_1_A : A ;
  pistolliknande_av_1_A : A ;
  pistolskytte_nn_1_N : N ;
  plakat_av_1_A : A ;
  plangeometri_nn_1_N : N ;
  planimetri_nn_1_N : N ;
  plastikkirurgi_nn_1_N : N ;
  plastliknande_av_1_A : A ;
  platinablond_av_1_A : A ;
  platssoekande_av_1_1_A : A ;
  pleistocen_nn_1_N : N ;
  pliocen_nn_1_N : N ;
  pojktycke_nn_1_N : N ;
  pokerface_nn_1_N : N ;
  polyandri_nn_1_N : N ;
  polygami_nn_1_N : N ;
  pomologi_nn_1_N : N ;
  poppis_av_1_A : A ;
  pornografi_nn_1_N : N ;
  portfoere_nn_1_1_N : N ;
  potatisliknande_av_1_A : A ;
  poaengvaerde_nn_1_1_N : N ;
  precisionsskytte_nn_1_N : N ;
  prejudicerande_av_1_A : A ;
  pressande_av_1_A : A ;
  pretto_av_1_A : A ;
  prickskytte_nn_1_N : N ;
  prima_av_1_A : A ;
  primalterapi_nn_1_N : N ;
  privatpraktiserande_av_1_A : A ;
  privilegieutjaemnande_av_1_1_A : A ;
  prostatahypertrofi_nn_1_N : N ;
  proteinnerbrytande_av_1_A : A ;
  protonterapi_nn_1_N : N ;
  provroersbefruktande_nn_1_1_N : N ;
  proevande_av_1_1_A : A ;
  psykiatri_nn_1_N : N ;
  psykokirurgi_nn_1_N : N ;
  psykologi_nn_1_N : N ;
  psykometri_nn_1_N : N ;
  psykopatologi_nn_1_N : N ;
  publikdragande_av_1_A : A ;
  publikfriande_av_1_A : A ;
  publikum_nn_1_N : N ;
  pulverkaffe_nn_1_N : N ;
  pulvermetallurgi_nn_1_N : N ;
  punghaallande_nn_1_1_N : N ;
  punktbevakande_nn_1_N : N ;
  pupillfoerstorande_av_1_1_A : A ;
  putrid_av_1_A : A ;
  pyromani_nn_1_N : N ;
  pyton_av_1_A : A ;
  pytte_av_1_A : A ;
  paerlemorskimrande_av_1_1_A : A ;
  paa_av_1_1_A : A ;
  paadrivande_av_1_1_A : A ;
  paafallande_av_1_1_A : A ;
  paafrestande_av_1_1_A : A ;
  paafoeljande_av_1_1_A : A ;
  paagaaende_av_1_1_A : A ;
  paakostande_av_1_1_A : A ;
  paaseende_nn_1_1_N : N ;
  paaskfirande_av_1_1_A : A ;
  paaskfirande_nn_1_1_N : N ;
  paatraengande_av_1_1_A : A ;
  paataend_av_1_1_A : A ;
  rabblande_nn_1_N : N ;
  rackarns_av_1_A : A ;
  radioastronomi_nn_1_N : N ;
  radiobiologi_nn_1_N : N ;
  radiologi_nn_1_N : N ;
  radiotelegrafi_nn_1_N : N ;
  radioterapi_nn_1_N : N ;
  rafflande_av_1_A : A ;
  rapid_av_1_A : A ;
  rasande_av_1_A : A ;
  rasbiologi_nn_1_N : N ;
  raspande_av_1_A : A ;
  redo_av_1_A : A ;
  regi_nn_1_N : N ;
  reglande_nn_1_N : N ;
  reguladetri_nn_1_N : N ;
  reko_av_1_A : A ;
  relativitetsteori_nn_1_N : N ;
  remissbehandlande_nn_1_N : N ;
  renons_av_1_A : A ;
  reologi_nn_1_N : N ;
  repe_nn_1_N : N ;
  reprografi_nn_1_N : N ;
  reptilliknande_av_1_A : A ;
  resande_nn_2_N : N ;
  respektingivande_av_1_A : A ;
  respektive_av_1_A : A ;
  resurskraevande_av_1_1_A : A ;
  retro_av_1_A : A ;
  retrograd_av_1_A : A ;
  reumatologi_nn_1_N : N ;
  revolutionerande_av_1_A : A ;
  rhinologi_nn_1_N : N ;
  rigid_av_1_A : A ;
  riglande_nn_1_N : N ;
  riksomfattande_av_1_A : A ;
  rikstaeckande_av_1_1_A : A ;
  riksaepple_nn_1_1_N : N ;
  ringa_av_1_A : A ;
  rogivande_av_1_A : A ;
  rollbesaettande_nn_1_1_N : N ;
  romarrike_nn_1_N : N ;
  rosa_av_1_A : A ;
  rosende_av_1_A : A ;
  rosenrasande_av_1_A : A ;
  rotationsenergi_nn_1_N : N ;
  rouge_nn_1_N : N ;
  rovfiske_nn_1_N : N ;
  rudis_av_1_A : A ;
  rund_av_1_A : A ;
  rundvirke_nn_1_N : N ;
  runologi_nn_1_N : N ;
  rymdbiologi_nn_1_N : N ;
  rymdgeometri_nn_1_N : N ;
  rysktalande_av_1_A : A ;
  raedd_av_1_1_A : A ;
  raekfiske_nn_1_1_N : N ;
  raentebaerande_av_1_1_A : A ;
  raet_av_1_1_A : A ;
  raettroende_av_1_1_A : A ;
  raettsfilosofi_nn_1_1_N : N ;
  raettskaffens_av_1_1_A : A ;
  raettskemi_nn_1_1_N : N ;
  raettspsykiatri_nn_1_1_N : N ;
  raettvisande_av_1_1_A : A ;
  raettvisekraevande_av_1_1_A : A ;
  raettaenkande_av_1_1_A : A ;
  raadande_av_1_1_A : A ;
  raadgivande_av_1_1_A : A ;
  raagblond_av_1_1_A : A ;
  roedblind_av_1_1_A : A ;
  roedblond_av_1_1_A : A ;
  roedbraend_av_1_1_A : A ;
  roedgroenblind_av_1_1_A : A ;
  roedlila_av_1_1_A : A ;
  roedskimrande_av_1_1_A : A ;
  roennbaersfilosofi_nn_1_1_N : N ;
  roentgenstraalande_av_1_1_A : A ;
  roerande_av_1_1_A : A ;
  roerelseenergi_nn_1_1_N : N ;
  roestfiske_nn_1_1_N : N ;
  roestskolkande_nn_1_1_N : N ;
  sabla_av_1_A : A ;
  sagoskimrande_av_1_A : A ;
  saker_av_1_A : A ;
  saklaege_nn_1_1_N : N ;
  saksoekande_av_1_1_A : A ;
  saksoekande_nn_1_1_N : N ;
  sakta_av_1_A : A ;
  saltaelskande_av_1_1_A : A ;
  samarva_av_1_A : A ;
  samboende_av_1_A : A ;
  samboende_nn_1_N : N ;
  samgaaende_nn_1_1_N : N ;
  samhaellsbevarande_av_1_1_A : A ;
  samhaellsbildande_av_1_1_A : A ;
  samhaellsbaerande_av_1_1_A : A ;
  samhaellsekonomi_nn_1_1_N : N ;
  samhaellsfraanvaend_av_1_1_A : A ;
  samhaellsinflytande_nn_1_1_N : N ;
  samhaellsomstoertande_av_1_1_A : A ;
  samhaellsorienterande_av_1_1_A : A ;
  samhaellstillvaend_av_1_1_A : A ;
  samhoerande_av_1_1_A : A ;
  samlarvaerde_nn_1_1_N : N ;
  sammanboende_av_1_A : A ;
  sammankallande_av_1_A : A ;
  sammanstoertande_nn_1_1_N : N ;
  samroere_nn_1_1_N : N ;
  sams_av_1_A : A ;
  samtalsterapi_nn_1_N : N ;
  samtida_av_1_A : A ;
  samtidsarkeologi_nn_1_N : N ;
  samtidshistoria_nn_1_N : N ;
  samaegande_nn_1_1_N : N ;
  sandbindande_av_1_A : A ;
  sanningsvaerde_nn_1_1_N : N ;
  sannolikhetsberaeknande_nn_1_1_N : N ;
  satans_av_1_A : A ;
  savoir_vivre_nn_1_N : N ;
  saxliknande_av_1_A : A ;
  scenografi_nn_1_N : N ;
  schack_av_1_A : A ;
  schackmatt_av_1_A : A ;
  scharlakansroett_nn_1_1_N : N ;
  schizoid_av_1_A : A ;
  schizotymi_nn_1_N : N ;
  schlaraffenland_nn_1_N : N ;
  schwyzerdutsch_nn_1_1_N : N ;
  schwyzertutsch_nn_1_1_N : N ;
  scientologi_nn_1_N : N ;
  scintigrafi_nn_1_N : N ;
  sedelaerande_av_1_1_A : A ;
  sedimentfoerande_av_1_1_A : A ;
  sedlighetssaarande_av_1_1_A : A ;
  seende_av_1_A : A ;
  seismologi_nn_1_N : N ;
  sekunda_av_1_A : A ;
  selfmade_av_1_A : A ;
  semasiologi_nn_1_N : N ;
  semesterfirande_av_1_A : A ;
  semesterfirande_nn_1_N : N ;
  semiologi_nn_1_N : N ;
  semologi_nn_1_N : N ;
  senare_av_1_A : A ;
  senmedeltida_av_1_A : A ;
  sentida_av_1_A : A ;
  sentima_av_1_A : A ;
  serieledande_av_1_A : A ;
  serologi_nn_1_N : N ;
  serotoninhoejande_av_1_1_A : A ;
  serumterapi_nn_1_N : N ;
  sesam_nn_2_N : N ;
  sexdubblande_nn_1_N : N ;
  sexfaldigande_nn_1_N : N ;
  sexologi_nn_1_N : N ;
  sexuologi_nn_1_N : N ;
  sexvaegrande_nn_1_1_N : N ;
  sfumato_nn_1_N : N ;
  sgraffito_nn_1_N : N ;
  sicklecellsanemi_nn_1_N : N ;
  sidenliknande_av_1_A : A ;
  siderurgi_nn_1_N : N ;
  sidlaend_av_1_1_A : A ;
  sidoinflytande_nn_1_N : N ;
  sifferblind_av_1_A : A ;
  sifferminne_nn_1_N : N ;
  sigillografi_nn_1_N : N ;
  signalroett_nn_1_1_N : N ;
  silur_nn_1_N : N ;
  silverblond_av_1_A : A ;
  silverblaenkande_av_1_1_A : A ;
  silverglaensande_av_1_1_A : A ;
  silverliknande_av_1_A : A ;
  silverne_av_1_A : A ;
  silverskimrande_av_1_A : A ;
  silverte_nn_1_N : N ;
  silvervitt_nn_1_N : N ;
  simoni_nn_1_N : N ;
  simplextelegrafi_nn_1_N : N ;
  sinkabirum_nn_1_N : N ;
  sinologi_nn_1_N : N ;
  sirapsliknande_av_1_A : A ;
  sjudundrande_av_1_A : A ;
  sjufaldigande_nn_1_N : N ;
  sjuhelvetes_av_1_A : A ;
  sjukdomsalstrande_av_1_A : A ;
  sjukpenninggrundande_av_1_A : A ;
  sjungande_nn_1_N : N ;
  sjaelsdoedande_av_1_1_A : A ;
  sjaelsfraanvarande_av_1_1_A : A ;
  sjaelvbespeglande_av_1_1_A : A ;
  sjaelvbestaemmande_nn_1_1_N : N ;
  sjaelvbevarande_av_1_1_A : A ;
  sjaelvbaerande_av_1_1_A : A ;
  sjaelvfoergloemmande_av_1_1_A : A ;
  sjaelvfoerhaerligande_av_1_1_A : A ;
  sjaelvfoersoerjande_av_1_1_A : A ;
  sjaelvfoertroende_nn_1_1_N : N ;
  sjaelvfoerverkligande_nn_1_1_N : N ;
  sjaelvhushaallande_nn_1_1_N : N ;
  sjaelvhaeftande_av_1_1_A : A ;
  sjaelvinstruerande_av_1_1_A : A ;
  sjaelvironi_nn_1_1_N : N ;
  sjaelvklistrande_av_1_1_A : A ;
  sjaelvlysande_av_1_1_A : A ;
  sjaelvreglerande_av_1_1_A : A ;
  sjaelvrepellerande_av_1_1_A : A ;
  sjaelvspelande_av_1_1_A : A ;
  sjaelvstyrande_av_1_1_A : A ;
  sjaelvstaengande_av_1_1_A : A ;
  sjaelvtvivlande_av_1_1_A : A ;
  sjaelvuppfyllande_av_1_1_A : A ;
  sjaelvuppoffrande_av_1_1_A : A ;
  sjaelvutnaemnd_av_1_1_A : A ;
  sjaelvutplaanande_av_1_1_A : A ;
  sjaelvaegande_av_1_1_A : A ;
  sjoefarande_av_1_1_A : A ;
  skada_av_1_A : A ;
  skakande_av_1_A : A ;
  skakis_av_1_A : A ;
  skamflat_av_1_A : A ;
  skapande_av_1_A : A ;
  skenplockande_nn_1_N : N ;
  skidskytte_nn_1_N : N ;
  skinkbluffande_av_1_A : A ;
  skitbra_av_1_A : A ;
  skitkul_av_1_A : A ;
  skitond_av_1_A : A ;
  skitraedd_av_1_1_A : A ;
  skitsamma_av_1_A : A ;
  skoj_av_1_A : A ;
  skolgaardsminne_nn_1_1_N : N ;
  skopofili_nn_1_N : N ;
  skoptofili_nn_1_N : N ;
  skottraedd_av_1_1_A : A ;
  skrattretande_av_1_A : A ;
  skriande_av_1_A : A ;
  skrotvaerde_nn_1_1_N : N ;
  skrubbliknande_av_1_A : A ;
  skrymmande_av_1_A : A ;
  skraeckinjagande_av_1_1_A : A ;
  skraeckregemente_nn_1_1_N : N ;
  skraemmande_av_1_1_A : A ;
  skuldsaettande_nn_1_1_N : N ;
  skumliknande_av_1_A : A ;
  skaemtlynne_nn_1_1_N : N ;
  skaerande_av_1_1_A : A ;
  skaalvirke_nn_1_1_N : N ;
  skaapliknande_av_1_1_A : A ;
  skoen_nn_1_1_N : N ;
  skoensjungande_av_1_1_A : A ;
  skoere_nn_1_1_N : N ;
  slags_av_1_A : A ;
  slangande_nn_1_N : N ;
  slappzappande_nn_1_N : N ;
  slavliknande_av_1_A : A ;
  slemloesande_av_1_1_A : A ;
  slitage_nn_1_N : N ;
  slumrande_av_1_A : A ;
  slurpande_nn_1_N : N ;
  slut_av_1_A : A ;
  slutfoervarande_nn_1_1_N : N ;
  slaedfoere_nn_1_1_N : N ;
  slaekt_av_1_1_A : A ;
  slaekttycke_nn_1_1_N : N ;
  slaaende_av_1_1_A : A ;
  sloejliknande_av_1_1_A : A ;
  sloesande_av_1_1_A : A ;
  smaskens_av_1_A : A ;
  smickrande_av_1_A : A ;
  smittbaerande_av_1_1_A : A ;
  smittspaarande_nn_1_1_N : N ;
  smutsavvisande_av_1_A : A ;
  smygislamiserande_nn_1_N : N ;
  smygroekande_nn_1_1_N : N ;
  smaektande_av_1_1_A : A ;
  smaertstillande_av_1_1_A : A ;
  smaakaat_av_1_1_A : A ;
  smaaleende_av_1_1_A : A ;
  smaatt_av_1_1_A : A ;
  snabbgaaende_av_1_1_A : A ;
  snabbkaffe_nn_1_N : N ;
  snabbseparerande_av_1_A : A ;
  snabbtorkande_av_1_A : A ;
  snabbtoerstande_nn_1_1_N : N ;
  snabbvaexande_av_1_1_A : A ;
  snabelliknande_av_1_A : A ;
  snurrefiske_nn_1_N : N ;
  snyftande_av_1_A : A ;
  snaellgaaende_av_1_1_A : A ;
  snoeblind_av_1_1_A : A ;
  snoed_av_1_1_A : A ;
  snoeskytte_nn_1_1_N : N ;
  socialantropologi_nn_1_N : N ;
  socialdemokrati_nn_1_N : N ;
  socialpornografi_nn_1_N : N ;
  socialpsykologi_nn_1_N : N ;
  sociologi_nn_1_N : N ;
  socioterapi_nn_1_N : N ;
  sodomi_nn_1_N : N ;
  solblind_av_1_A : A ;
  solbraend_av_1_1_A : A ;
  solenergi_nn_1_N : N ;
  solliknande_av_1_A : A ;
  solljusreflekterande_av_1_A : A ;
  solo_av_1_A : A ;
  solokvist_av_1_A : A ;
  solskifte_nn_1_N : N ;
  solterapi_nn_1_N : N ;
  solaekta_av_1_1_A : A ;
  sorts_av_1_A : A ;
  sotis_av_1_A : A ;
  spansktalande_av_1_A : A ;
  spe_nn_1_N : N ;
  specialbestaellande_nn_1_1_N : N ;
  spegelvaend_av_1_1_A : A ;
  spektroskopi_nn_1_N : N ;
  spelberoende_av_1_A : A ;
  speleologi_nn_1_N : N ;
  spelteori_nn_1_N : N ;
  spinnfiske_nn_1_N : N ;
  spionage_nn_1_N : N ;
  spionhysteri_nn_1_N : N ;
  spirometri_nn_1_N : N ;
  spontankaat_av_1_1_A : A ;
  sporbildande_av_1_A : A ;
  sportfiske_nn_1_N : N ;
  sprillan_av_1_A : A ;
  sprillans_av_1_A : A ;
  spraengkaat_av_1_1_A : A ;
  spraakfilosofi_nn_1_1_N : N ;
  spraakhistoria_nn_1_1_N : N ;
  spraakpsykologi_nn_1_1_N : N ;
  spraaksociologi_nn_1_1_N : N ;
  sputum_nn_1_N : N ;
  spaend_av_1_1_A : A ;
  spaennande_av_1_1_A : A ;
  spaarande_nn_1_1_N : N ;
  stackars_av_1_A : A ;
  stadigvarande_av_1_A : A ;
  staffage_nn_1_N : N ;
  stajlande_nn_1_N : N ;
  startenergi_nn_1_N : N ;
  statsbaerande_av_1_1_A : A ;
  stavelsebildande_av_1_A : A ;
  stellarastronomi_nn_1_N : N ;
  stenkastande_av_1_A : A ;
  stenografi_nn_1_N : N ;
  stereofoni_nn_1_N : N ;
  stereoisomeri_nn_1_N : N ;
  stereokemi_nn_1_N : N ;
  stereometri_nn_1_N : N ;
  stereoseende_nn_1_N : N ;
  stereoskopi_nn_1_N : N ;
  stickande_av_1_A : A ;
  stilbildande_av_1_A : A ;
  stilla_av_1_A : A ;
  stillasittande_av_1_A : A ;
  stillasittande_nn_1_N : N ;
  stillastaaende_av_1_1_A : A ;
  stillastaaende_nn_1_1_N : N ;
  stillatigande_av_1_A : A ;
  stinkande_av_1_A : A ;
  stolts_av_1_A : A ;
  stoppande_av_1_A : A ;
  storfraemmande_nn_1_1_N : N ;
  storsjoefiske_nn_1_1_N : N ;
  storskifte_nn_1_N : N ;
  straight_av_1_A : A ;
  stratigrafi_nn_1_N : N ;
  struntsamma_av_1_A : A ;
  strykraedd_av_1_1_A : A ;
  straalande_av_1_1_A : A ;
  straalningsbiologi_nn_1_1_N : N ;
  straalningskemi_nn_1_1_N : N ;
  stroemfoerande_av_1_1_A : A ;
  stroemledande_av_1_1_A : A ;
  stroemmingsfiske_nn_1_1_N : N ;
  stupid_av_1_A : A ;
  stylande_nn_1_N : N ;
  staellfoeretraedande_av_1_1_A : A ;
  staemningsspridande_av_1_1_A : A ;
  staerkande_av_1_1_A : A ;
  staaende_av_1_1_A : A ;
  stoekiometri_nn_1_1_N : N ;
  stoetdaempande_av_1_1_A : A ;
  substitutionskryptografi_nn_1_N : N ;
  sugande_av_1_A : A ;
  sund_av_1_A : A ;
  superkul_av_1_A : A ;
  supraledande_av_1_A : A ;
  supremati_nn_1_N : N ;
  svackande_nn_1_N : N ;
  svaglysande_av_1_A : A ;
  svagpresterande_av_1_A : A ;
  svalliknande_av_1_A : A ;
  svampliknande_av_1_A : A ;
  svartglaensande_av_1_1_A : A ;
  svartmaalande_nn_1_1_N : N ;
  svartskimrande_av_1_A : A ;
  svavelosande_av_1_A : A ;
  svavelvaete_nn_1_1_N : N ;
  svavelvaeteproducerande_av_1_1_A : A ;
  svensktalande_av_1_A : A ;
  svepande_av_1_A : A ;
  svettdoftande_av_1_A : A ;
  svettdrypande_av_1_A : A ;
  svindlande_av_1_A : A ;
  svinliknande_av_1_A : A ;
  svaerdliknande_av_1_1_A : A ;
  svaevande_av_1_1_A : A ;
  swahili_nn_1_N : N ;
  sweet_av_1_A : A ;
  sydgaaende_av_1_1_A : A ;
  sydvaestra_av_1_1_A : A ;
  sydoestra_av_1_1_A : A ;
  symptomlindrande_av_1_A : A ;
  symtomlindrande_av_1_A : A ;
  synd_av_1_A : A ;
  synliggoerande_nn_1_1_N : N ;
  syrak_av_1_A : A ;
  syre_nn_1_N : N ;
  syrefordrande_av_1_A : A ;
  syreproducerande_av_1_A : A ;
  syreupptagande_av_1_A : A ;
  sysilke_nn_1_N : N ;
  syskontycke_nn_1_N : N ;
  sysselsaettningsskapande_av_1_1_A : A ;
  saeckliknande_av_1_1_A : A ;
  saellskapsgraatande_nn_1_1_N : N ;
  saelskytte_nn_1_1_N : N ;
  saengliggande_av_1_1_A : A ;
  saenglinne_nn_1_1_N : N ;
  saenglaege_nn_1_1_N : N ;
  saer_av_1_1_A : A ;
  saerlevande_av_1_1_A : A ;
  saadaer_av_1_1_A : A ;
  saarande_av_1_1_A : A ;
  saat_av_1_1_A : A ;
  soedergaaende_av_1_1_A : A ;
  soedra_av_1_1_A : A ;
  soendagskoerande_nn_1_1_N : N ;
  soenderbraend_av_1_1_A : A ;
  tabu_av_1_A : A ;
  tabubelaeggande_nn_1_1_N : N ;
  tacklage_nn_1_N : N ;
  tajande_nn_1_N : N ;
  taktikroestande_nn_1_1_N : N ;
  talande_av_1_A : A ;
  tallriksliknande_av_1_A : A ;
  talteori_nn_1_N : N ;
  tamil_nn_2_N : N ;
  tandtraadande_nn_1_1_N : N ;
  tankeherravaelde_nn_1_1_N : N ;
  tankevaeckande_av_1_1_A : A ;
  tassliknande_av_1_A : A ;
  tautomeri_nn_1_N : N ;
  tax_free_av_1_A : A ;
  tedrickande_nn_1_N : N ;
  tefrokronologi_nn_1_N : N ;
  tegelliknande_av_1_A : A ;
  tegskifte_nn_1_N : N ;
  teknologie_av_1_A : A ;
  telefoni_nn_1_N : N ;
  telegrafi_nn_1_N : N ;
  telekinesi_nn_1_N : N ;
  teleologi_nn_1_N : N ;
  teleskopi_nn_1_N : N ;
  teleskopliknande_av_1_A : A ;
  teologi_nn_1_N : N ;
  teologie_av_1_A : A ;
  teosofi_nn_1_N : N ;
  termografi_nn_1_N : N ;
  termokemi_nn_1_N : N ;
  terraenggaaende_av_1_1_A : A ;
  tertiaer_nn_1_1_N : N ;
  testflygande_nn_1_N : N ;
  tetani_nn_1_N : N ;
  tetraploid_av_1_A : A ;
  textilaetande_av_1_1_A : A ;
  teaelskande_av_1_1_A : A ;
  tidigmedeltida_av_1_A : A ;
  tidningslaesande_av_1_1_A : A ;
  tidningslaesande_nn_1_1_N : N ;
  tidsberaeknande_nn_1_1_N : N ;
  tidskraevande_av_1_1_A : A ;
  tidsoedande_av_1_1_A : A ;
  tillbakadragande_nn_1_N : N ;
  tillbakagaaende_av_1_1_A : A ;
  tillbakasyftande_av_1_A : A ;
  tilldragande_av_1_A : A ;
  tillfreds_av_1_A : A ;
  tillfredsstaellande_av_1_1_A : A ;
  tillfrisknande_nn_1_N : N ;
  tillhoerande_av_1_1_A : A ;
  tillintetgoerande_av_1_1_A : A ;
  tillkommande_av_1_A : A ;
  tillmoetesgaaende_av_1_1_A : A ;
  tillmoetesgaaende_nn_1_1_N : N ;
  tillstaandsgivande_av_1_1_A : A ;
  tilltagande_av_1_A : A ;
  tilltagande_nn_1_N : N ;
  tilltalande_av_1_A : A ;
  tillvand_av_1_A : A ;
  timid_av_1_A : A ;
  tiomila_av_1_A : A ;
  tionde_nn_1_N : N ;
  tipptopp_av_1_A : A ;
  tiptop_av_1_A : A ;
  titanvitt_nn_1_N : N ;
  titthaalskirurgi_nn_1_1_N : N ;
  tjockflytande_av_1_A : A ;
  tjuvfiskande_nn_1_N : N ;
  tjuvfiske_nn_1_N : N ;
  tjuvjagande_nn_1_N : N ;
  tjuvkikande_nn_1_N : N ;
  tjuvroekande_nn_1_1_N : N ;
  tjuvskytte_nn_1_N : N ;
  tjuvtittande_nn_1_N : N ;
  tjyvfiskande_nn_1_N : N ;
  tjyvfiske_nn_1_N : N ;
  tjyvjagande_nn_1_N : N ;
  tjyvkikande_nn_1_N : N ;
  tjyvroekande_nn_1_1_N : N ;
  tjyvtittande_nn_1_N : N ;
  tjaenis_av_1_1_A : A ;
  tjaenstefoerraettande_av_1_1_A : A ;
  tolkningsfoeretraede_nn_1_1_N : N ;
  tolvfaldigande_nn_1_N : N ;
  tonande_av_1_A : A ;
  tongivande_av_1_A : A ;
  tonnage_nn_1_N : N ;
  topless_av_1_A : A ;
  topografi_nn_1_N : N ;
  toppenbra_av_1_A : A ;
  torraemne_nn_1_1_N : N ;
  totalkvaddande_nn_1_N : N ;
  totalsabbande_nn_1_N : N ;
  toujours_av_1_A : A ;
  toxikologi_nn_1_N : N ;
  toxikomani_nn_1_N : N ;
  trafikledande_nn_1_N : N ;
  transportberoende_av_1_A : A ;
  trappliknande_av_1_A : A ;
  trattliknande_av_1_A : A ;
  tredubblande_nn_1_N : N ;
  trefaldigande_nn_1_N : N ;
  trefas_av_1_A : A ;
  treskifte_nn_1_N : N ;
  trespaend_av_1_1_A : A ;
  trevande_av_1_A : A ;
  trias_nn_1_N : N ;
  trigonometri_nn_1_N : N ;
  trikotage_nn_1_N : N ;
  trilskande_av_1_A : A ;
  trind_av_1_A : A ;
  triploid_av_1_A : A ;
  troende_av_1_A : A ;
  trumfmatt_av_1_A : A ;
  trupptillbakadragande_nn_1_N : N ;
  tryckande_av_1_A : A ;
  trygghetsnarkomani_nn_1_N : N ;
  traedliknande_av_1_1_A : A ;
  traeffande_av_1_1_A : A ;
  traengande_av_1_1_A : A ;
  traevirke_nn_1_1_N : N ;
  traadliknande_av_1_1_A : A ;
  traalfiske_nn_1_1_N : N ;
  traang_av_1_1_A : A ;
  troegflytande_av_1_1_A : A ;
  tularemi_nn_1_N : N ;
  tungomaalstalande_av_1_1_A : A ;
  tungomaalstalande_nn_1_1_N : N ;
  tungvrickande_av_1_A : A ;
  tunnelliknande_av_1_A : A ;
  tusenaara_av_1_1_A : A ;
  tvagande_nn_1_N : N ;
  tvingande_av_1_A : A ;
  tvaergaaende_av_1_1_A : A ;
  tvaettaekta_av_1_1_A : A ;
  tvaamans_av_1_1_A : A ;
  tvaangssparande_nn_1_1_N : N ;
  tvaaspaend_av_1_1_A : A ;
  typbildande_av_1_A : A ;
  tyre_nn_1_N : N ;
  tysktalande_av_1_A : A ;
  tystgaaende_av_1_1_A : A ;
  taerande_av_1_1_A : A ;
  taetortsnaera_av_1_1_A : A ;
  taettsittande_av_1_1_A : A ;
  taettslutande_av_1_1_A : A ;
  taagvirke_nn_1_1_N : N ;
  taalamodsproevande_av_1_1_A : A ;
  taardrypande_av_1_1_A : A ;
  toere_nn_1_1_N : N ;
  toerstslaeckande_av_1_1_A : A ;
  u_formig_av_1_A : A ;
  udda_av_1_A : A ;
  uddloes_av_1_1_A : A ;
  ugandisk_av_1_A : A ;
  uggleliknande_av_1_A : A ;
  ugnsvarm_av_1_A : A ;
  ukrainsk_av_1_A : A ;
  ulceroes_av_1_1_A : A ;
  ullhaarig_av_1_1_A : A ;
  ullig_av_1_A : A ;
  ulliknande_av_1_A : A ;
  ultimativ_av_1_A : A ;
  ultrakonservativ_av_1_A : A ;
  ultramarin_av_1_A : A ;
  ultramontan_av_1_A : A ;
  ultrarapid_av_1_A : A ;
  ultrarapidfotograferbar_av_1_A : A ;
  ultrasnabb_av_1_A : A ;
  umbaerlig_av_1_1_A : A ;
  undanglidande_av_1_A : A ;
  undanskuffande_nn_1_N : N ;
  undantagsloes_av_1_1_A : A ;
  underbalanserbar_av_1_A : A ;
  underbar_av_1_A : A ;
  underdimensionerbar_av_1_A : A ;
  underdaanig_av_1_1_A : A ;
  underexponerbar_av_1_A : A ;
  underfull_av_1_A : A ;
  underfundig_av_1_A : A ;
  undergoerande_av_1_1_A : A ;
  underhaltig_av_1_A : A ;
  underhaerdig_av_1_1_A : A ;
  underhaallande_av_1_1_A : A ;
  underhaallningsmaessig_av_1_1_A : A ;
  underjordisk_av_1_A : A ;
  underklassig_av_1_A : A ;
  underkunnig_av_1_A : A ;
  underkaend_av_1_1_A : A ;
  underlig_av_1_A : A ;
  underliggande_av_1_A : A ;
  underlydande_av_1_A : A ;
  underlaege_nn_1_1_N : N ;
  undermedvetande_nn_1_N : N ;
  underminerbar_av_1_A : A ;
  undermaensklig_av_1_1_A : A ;
  undermaalig_av_1_1_A : A ;
  underordnande_av_1_A : A ;
  underskoen_av_1_1_A : A ;
  understaaende_av_1_1_A : A ;
  undersaetsig_av_1_1_A : A ;
  undersaatlig_av_1_1_A : A ;
  undertalig_av_1_A : A ;
  undertaxerbar_av_1_A : A ;
  undervattensarkeologi_nn_1_N : N ;
  undervattenslaege_nn_1_1_N : N ;
  underviktig_av_1_A : A ;
  undervaerderbar_av_1_1_A : A ;
  undfallande_av_1_A : A ;
  undflyende_nn_1_N : N ;
  undrande_av_1_A : A ;
  undulatorisk_av_1_A : A ;
  undvikande_av_1_A : A ;
  ungdomlig_av_1_A : A ;
  ungefaerlig_av_1_1_A : A ;
  ungersk_av_1_A : A ;
  ungflicksaktig_av_1_A : A ;
  ungkyrklig_av_1_A : A ;
  ungsvensk_av_1_A : A ;
  unifierbar_av_1_A : A ;
  uniform_av_1_A : A ;
  uniformerbar_av_1_A : A ;
  uniformsliknande_av_1_A : A ;
  unik_av_1_A : A ;
  unilateral_av_1_A : A ;
  unionell_av_1_A : A ;
  unisex_av_1_A : A ;
  unison_av_1_A : A ;
  unitarisk_av_1_A : A ;
  universalistisk_av_1_A : A ;
  universell_av_1_A : A ;
  up_to_date_av_1_A : A ;
  uppblossande_av_1_A : A ;
  uppbygglig_av_1_A : A ;
  uppbaerande_nn_1_1_N : N ;
  uppdaterbar_av_1_A : A ;
  uppdragsarkeologi_nn_1_N : N ;
  uppdykande_av_1_A : A ;
  uppehaelle_nn_1_1_N : N ;
  uppenbar_av_1_A : A ;
  uppfinningsrik_av_1_A : A ;
  uppflammande_av_1_A : A ;
  uppfriskande_av_1_A : A ;
  uppfaellbar_av_1_1_A : A ;
  uppfoeljande_av_1_1_A : A ;
  uppgraderbar_av_1_A : A ;
  upphinnelig_av_1_A : A ;
  uppiggande_av_1_A : A ;
  uppjusterbar_av_1_A : A ;
  uppkaeftig_av_1_1_A : A ;
  upplagemaessig_av_1_1_A : A ;
  upplevelsemaessig_av_1_1_A : A ;
  upplyftande_av_1_A : A ;
  upplysningstaenkande_nn_1_1_N : N ;
  upplaendsk_av_1_1_A : A ;
  uppmaerksamhetskaat_av_1_1_A : A ;
  uppmaerksamhetsvaerde_nn_1_1_N : N ;
  uppnosig_av_1_A : A ;
  uppnaaelig_av_1_1_A : A ;
  uppochnedvaend_av_1_1_A : A ;
  uppochnervaend_av_1_1_A : A ;
  uppoffrande_av_1_A : A ;
  uppreklamerbar_av_1_A : A ;
  uppriktig_av_1_A : A ;
  upprivande_av_1_A : A ;
  upprorisk_av_1_A : A ;
  upprullande_nn_1_N : N ;
  uppraettstaaende_av_1_1_A : A ;
  upproerande_av_1_1_A : A ;
  uppseende_nn_1_N : N ;
  uppseendevaeckande_av_1_1_A : A ;
  uppskakande_av_1_A : A ;
  uppslagsrik_av_1_A : A ;
  uppslitande_av_1_A : A ;
  uppstudsig_av_1_A : A ;
  uppstaaende_av_1_1_A : A ;
  uppsummerbar_av_1_A : A ;
  uppsvensk_av_1_A : A ;
  uppsaatlig_av_1_1_A : A ;
  uppsoekande_av_1_1_A : A ;
  upptaxerbar_av_1_A : A ;
  upptaend_av_1_1_A : A ;
  upptaenklig_av_1_1_A : A ;
  uppvaknande_nn_1_N : N ;
  uppvaerderbar_av_1_1_A : A ;
  uppaanedvaend_av_1_1_A : A ;
  uppaanervaend_av_1_1_A : A ;
  uppaat_av_1_1_A : A ;
  uppaatgaaende_av_1_1_A : A ;
  uppaatgaaende_nn_1_1_N : N ;
  uppaatstigande_av_1_1_A : A ;
  uppaatstraevande_av_1_1_A : A ;
  uralisk_av_1_A : A ;
  uralsk_av_1_A : A ;
  urarva_av_1_A : A ;
  urban_av_1_A : A ;
  urbaniserbar_av_1_A : A ;
  urbanistisk_av_1_A : A ;
  urdu_nn_1_N : N ;
  urdyr_av_1_A : A ;
  urdaalig_av_1_1_A : A ;
  uremi_nn_1_N : N ;
  urfolklig_av_1_A : A ;
  urfaanig_av_1_1_A : A ;
  urgermansk_av_1_A : A ;
  urholkande_nn_1_N : N ;
  urindoeuropeisk_av_1_A : A ;
  urindrivande_av_1_A : A ;
  urinaemne_nn_1_1_N : N ;
  urkundlig_av_1_A : A ;
  urminnes_av_1_A : A ;
  urmodig_av_1_A : A ;
  urnordisk_av_1_A : A ;
  urografi_nn_1_N : N ;
  urologi_nn_1_N : N ;
  urologisk_av_1_A : A ;
  ursinnig_av_1_A : A ;
  ursinningsloes_av_1_1_A : A ;
  urskiljbar_av_1_A : A ;
  urskiljningsloes_av_1_1_A : A ;
  urskillningsloes_av_1_1_A : A ;
  ursnygg_av_1_A : A ;
  ursprunglig_av_1_A : A ;
  urspraaklig_av_1_1_A : A ;
  urstyv_av_1_A : A ;
  ursaektlig_av_1_1_A : A ;
  urtagbar_av_1_A : A ;
  urtida_av_1_A : A ;
  urtima_av_1_A : A ;
  urtjusig_av_1_A : A ;
  urtjuva_av_1_A : A ;
  uruguayansk_av_1_A : A ;
  uruguaysk_av_1_A : A ;
  uraaldrig_av_1_1_A : A ;
  uschlig_av_1_A : A ;
  uslig_av_1_A : A ;
  usuell_av_1_A : A ;
  usurperbar_av_1_A : A ;
  utackorderbar_av_1_A : A ;
  utanfoerstaaende_av_1_1_A : A ;
  utannonserbar_av_1_A : A ;
  utantillmaessig_av_1_1_A : A ;
  utarrenderbar_av_1_A : A ;
  utbalanserbar_av_1_A : A ;
  utbasunerbar_av_1_A : A ;
  utbildningsmaessig_av_1_1_A : A ;
  utbroderbar_av_1_A : A ;
  utbraend_av_1_1_A : A ;
  utbuktande_av_1_A : A ;
  utbyggbar_av_1_A : A ;
  utbytbar_av_1_A : A ;
  utdebiterbar_av_1_A : A ;
  utdragbar_av_1_A : A ;
  utdoeende_nn_1_1_N : N ;
  ute_av_1_A : A ;
  uteliggande_av_1_A : A ;
  uteloepande_av_1_1_A : A ;
  utestaaende_av_1_1_A : A ;
  utexaminerbar_av_1_A : A ;
  utexperimenterbar_av_1_A : A ;
  utfattig_av_1_A : A ;
  utfaellbar_av_1_1_A : A ;
  utfoerbar_av_1_1_A : A ;
  utfoerlig_av_1_1_A : A ;
  utgaaende_av_1_1_A : A ;
  uthaerdlig_av_1_1_A : A ;
  uthaallig_av_1_1_A : A ;
  utilistisk_av_1_A : A ;
  utilitaristisk_av_1_A : A ;
  utklarerbar_av_1_A : A ;
  utkommenderbar_av_1_A : A ;
  utkonkurrerbar_av_1_A : A ;
  utkristalliserbar_av_1_A : A ;
  utkvitterbar_av_1_A : A ;
  utlevande_av_1_A : A ;
  utlokaliserbar_av_1_A : A ;
  utlaendsk_av_1_1_A : A ;
  utmanande_av_1_A : A ;
  utmanoevrerbar_av_1_1_A : A ;
  utminuterbar_av_1_A : A ;
  utmaerkande_av_1_1_A : A ;
  utomeuropeisk_av_1_A : A ;
  utomjordisk_av_1_A : A ;
  utomordentlig_av_1_A : A ;
  utomparlamentarisk_av_1_A : A ;
  utomstaaende_av_1_1_A : A ;
  utomaektenskaplig_av_1_1_A : A ;
  utopisk_av_1_A : A ;
  utplacerbar_av_1_A : A ;
  utplattande_nn_1_N : N ;
  utposterbar_av_1_A : A ;
  utraderbar_av_1_A : A ;
  utrangerbar_av_1_A : A ;
  utredningsmaessig_av_1_1_A : A ;
  utrikes_av_1_A : A ;
  utrikespolitisk_av_1_A : A ;
  utrikisk_av_1_A : A ;
  utrullande_nn_1_N : N ;
  utrymmesmaessig_av_1_1_A : A ;
  utseendemaessig_av_1_1_A : A ;
  utsiktsloes_av_1_1_A : A ;
  utsjoefiske_nn_1_1_N : N ;
  utskjutande_av_1_A : A ;
  utskottsvirke_nn_1_N : N ;
  utskaerande_nn_1_1_N : N ;
  utslagsgivande_av_1_A : A ;
  utslocknande_nn_1_N : N ;
  utsocknes_av_1_A : A ;
  utspringande_av_1_A : A ;
  utspaend_av_1_1_A : A ;
  utstofferbar_av_1_A : A ;
  utstaaende_av_1_1_A : A ;
  utsvaellande_nn_1_1_N : N ;
  utsvaevande_av_1_1_A : A ;
  uttalsenlig_av_1_A : A ;
  uttaxerbar_av_1_A : A ;
  uttrycklig_av_1_A : A ;
  uttrycksfull_av_1_A : A ;
  uttrycksloes_av_1_1_A : A ;
  uttrycksmaessig_av_1_1_A : A ;
  uttaenjbar_av_1_1_A : A ;
  uttoemmande_av_1_1_A : A ;
  utvecklingshistoria_nn_1_N : N ;
  utvecklingsmaessig_av_1_1_A : A ;
  utvaendig_av_1_1_A : A ;
  utvaerderbar_av_1_1_A : A ;
  utvaertes_av_1_1_A : A ;
  utaatvaend_av_1_1_A : A ;
  uvular_av_1_A : A ;
  uzbekisk_av_1_A : A ;
  vaccinerbar_av_1_A : A ;
  vaccineringshysteri_nn_1_N : N ;
  vadbar_av_1_A : A ;
  vadderbar_av_1_A : A ;
  vadlaang_av_1_1_A : A ;
  vados_av_1_A : A ;
  vag_av_1_A : A ;
  vaginal_av_1_A : A ;
  vaksinerbar_av_1_A : A ;
  vakthavande_av_1_A : A ;
  valbar_av_1_A : A ;
  valid_av_1_A : A ;
  valkig_av_1_A : A ;
  vallmote_nn_1_N : N ;
  vallonsk_av_1_A : A ;
  vallonsmide_nn_1_N : N ;
  valnoetsliknande_av_1_1_A : A ;
  valpaktig_av_1_A : A ;
  valpig_av_1_A : A ;
  valutamaessig_av_1_1_A : A ;
  valuterbar_av_1_A : A ;
  valverbar_av_1_A : A ;
  valvstupstaaende_nn_1_1_N : N ;
  vampig_av_1_A : A ;
  van_av_1_A : A ;
  vanartig_av_1_A : A ;
  vandaliserbar_av_1_A : A ;
  vandalisk_av_1_A : A ;
  vanebildande_av_1_A : A ;
  vanemaessig_av_1_1_A : A ;
  vanetaenkande_nn_1_1_N : N ;
  vanfoer_av_1_1_A : A ;
  vanhederlig_av_1_A : A ;
  vankelmodig_av_1_A : A ;
  vanlig_av_1_A : A ;
  vanmaektig_av_1_1_A : A ;
  vansinnig_av_1_A : A ;
  vanskaplig_av_1_A : A ;
  vansklig_av_1_A : A ;
  vanstark_av_1_A : A ;
  vanuatisk_av_1_A : A ;
  vanvettig_av_1_A : A ;
  vanvoerdig_av_1_1_A : A ;
  vanaerande_av_1_1_A : A ;
  vapenfoer_av_1_1_A : A ;
  vapenloes_av_1_1_A : A ;
  vapenmaessig_av_1_1_A : A ;
  vapensmide_nn_1_N : N ;
  vapensmugglande_av_1_A : A ;
  var_av_1_A : A ;
  varaktig_av_1_A : A ;
  vardaglig_av_1_A : A ;
  vardagsmaessig_av_1_1_A : A ;
  vargtaet_av_1_1_A : A ;
  varierbar_av_1_A : A ;
  varig_av_1_A : A ;
  varjehanda_av_1_A : A ;
  varlig_av_1_A : A ;
  varm_av_1_A : A ;
  varmblodig_av_1_A : A ;
  varse_av_1_A : A ;
  varudeklarerbar_av_1_A : A ;
  varvig_av_1_A : A ;
  vaskulaer_av_1_1_A : A ;
  vasografi_nn_1_N : N ;
  vasomotorisk_av_1_A : A ;
  vass_av_1_A : A ;
  vasslig_av_1_A : A ;
  vatikansk_av_1_A : A ;
  vattenavstoetande_av_1_1_A : A ;
  vattenavvisande_av_1_A : A ;
  vattendrivande_av_1_A : A ;
  vattenkaenslig_av_1_1_A : A ;
  vattenlevande_av_1_A : A ;
  vattenloeslig_av_1_1_A : A ;
  vattensjuk_av_1_A : A ;
  vattentaet_av_1_1_A : A ;
  vattentaalig_av_1_1_A : A ;
  vattnig_av_1_A : A ;
  vattrig_av_1_A : A ;
  vaxblek_av_1_A : A ;
  vaxliknande_av_1_A : A ;
  ve_nn_1_N : N ;
  veckig_av_1_A : A ;
  veckovill_av_1_A : A ;
  vederboerande_av_1_1_A : A ;
  vederboerlig_av_1_1_A : A ;
  vederfaaende_nn_1_1_N : N ;
  vederhaeftig_av_1_1_A : A ;
  vederlaeggande_nn_1_1_N : N ;
  vederstygglig_av_1_A : A ;
  vedervaerdig_av_1_1_A : A ;
  vedisk_av_1_A : A ;
  vedaemne_nn_1_1_N : N ;
  vegan_av_1_A : A ;
  vegetabilisk_av_1_A : A ;
  vegetariansk_av_1_A : A ;
  vegetarisk_av_1_A : A ;
  vegetationsloes_av_1_1_A : A ;
  vegetativ_av_1_A : A ;
  vek_av_1_A : A ;
  veklig_av_1_A : A ;
  velar_av_1_A : A ;
  velig_av_1_A : A ;
  velouriserbar_av_1_A : A ;
  vemodig_av_1_A : A ;
  vemodsfull_av_1_A : A ;
  vendisk_av_1_A : A ;
  venereologi_nn_1_N : N ;
  venereologisk_av_1_A : A ;
  venerisk_av_1_A : A ;
  venetiansk_av_1_A : A ;
  ventilerbar_av_1_A : A ;
  venoes_av_1_1_A : A ;
  verbal_av_1_A : A ;
  verbaliserbar_av_1_A : A ;
  verifierbar_av_1_A : A ;
  verkhelig_av_1_A : A ;
  verklig_av_1_A : A ;
  verklighetsfraemmande_av_1_1_A : A ;
  verklighetsfraanvaend_av_1_1_A : A ;
  verklighetsnaera_av_1_1_A : A ;
  verkningsfull_av_1_A : A ;
  verkningsloes_av_1_1_A : A ;
  verksamhetsmaessig_av_1_1_A : A ;
  verkstaellande_av_1_1_A : A ;
  versatil_av_1_A : A ;
  versifierbar_av_1_A : A ;
  vertikal_av_1_A : A ;
  vestalisk_av_1_A : A ;
  vesaell_av_1_1_A : A ;
  vetande_av_1_A : A ;
  vetande_nn_1_N : N ;
  vetbar_av_1_A : A ;
  vete_nn_1_N : N ;
  vetenskaplig_av_1_A : A ;
  vetenskapshistoria_nn_1_N : N ;
  vetenskapsteori_nn_1_N : N ;
  vetgirig_av_1_A : A ;
  vettig_av_1_A : A ;
  vettloes_av_1_1_A : A ;
  vettvillig_av_1_A : A ;
  vibrationsdaempande_av_1_1_A : A ;
  vice_av_1_A : A ;
  vickig_av_1_A : A ;
  victoriansk_av_1_A : A ;
  vidare_av_1_A : A ;
  vidarerapporterande_nn_1_N : N ;
  vidbraend_av_1_1_A : A ;
  vidimerbar_av_1_A : A ;
  vidlyftig_av_1_A : A ;
  vidrig_av_1_A : A ;
  vidskeplig_av_1_A : A ;
  vidstaaende_av_1_1_A : A ;
  vidunderlig_av_1_A : A ;
  vietnamesisk_av_1_A : A ;
  vig_av_1_A : A ;
  vikarierande_av_1_A : A ;
  vikingatida_av_1_A : A ;
  viktig_av_1_A : A ;
  viktloes_av_1_1_A : A ;
  viktmaessig_av_1_1_A : A ;
  viktoriansk_av_1_A : A ;
  viljeloes_av_1_1_A : A ;
  viljemaessig_av_1_1_A : A ;
  viljestark_av_1_A : A ;
  viljesvag_av_1_A : A ;
  villabyggande_nn_1_N : N ;
  villande_av_1_A : A ;
  villig_av_1_A : A ;
  villkorlig_av_1_A : A ;
  villkorsloes_av_1_1_A : A ;
  villraadig_av_1_1_A : A ;
  vilseledande_av_1_A : A ;
  viltmaalskytte_nn_1_1_N : N ;
  vimmelkantig_av_1_A : A ;
  vimsig_av_1_A : A ;
  vind_av_1_A : A ;
  vindicerbar_av_1_A : A ;
  vindpollinerbar_av_1_A : A ;
  vindstilla_av_1_A : A ;
  vindtaet_av_1_1_A : A ;
  vingklippande_nn_1_N : N ;
  vinglig_av_1_A : A ;
  vingloes_av_1_1_A : A ;
  vinkelraet_av_1_1_A : A ;
  vinnande_av_1_A : A ;
  vinodlingskunnig_av_1_A : A ;
  vinstbringande_av_1_A : A ;
  vinstdrivande_av_1_A : A ;
  vinstgivande_av_1_A : A ;
  vinstintresse_nn_1_N : N ;
  vinstmaximerbar_av_1_A : A ;
  vintercyklande_nn_1_N : N ;
  vintergroen_av_1_1_A : A ;
  vinterhaerdig_av_1_1_A : A ;
  vinterlig_av_1_A : A ;
  vintrig_av_1_A : A ;
  vippig_av_1_A : A ;
  viril_av_1_A : A ;
  virke_nn_1_N : N ;
  virologi_nn_1_N : N ;
  virrig_av_1_A : A ;
  virtuell_av_1_A : A ;
  virtuos_av_1_A : A ;
  virtuosmaessig_av_1_1_A : A ;
  vis_av_1_A : A ;
  viserbar_av_1_A : A ;
  visionsloes_av_1_1_A : A ;
  visionaer_av_1_1_A : A ;
  visiterbar_av_1_A : A ;
  viskoes_av_1_1_A : A ;
  vislig_av_1_A : A ;
  vispig_av_1_A : A ;
  viss_av_1_A : A ;
  vistande_nn_1_N : N ;
  visualiserbar_av_1_A : A ;
  visuell_av_1_A : A ;
  vit_av_1_A : A ;
  vitaktig_av_1_A : A ;
  vital_av_1_A : A ;
  vitaliserbar_av_1_A : A ;
  vitaminerbar_av_1_A : A ;
  vitaminiserbar_av_1_A : A ;
  vitaminrik_av_1_A : A ;
  vitgloedande_av_1_1_A : A ;
  vitgroen_av_1_1_A : A ;
  vithaarig_av_1_1_A : A ;
  vitrysk_av_1_A : A ;
  vitsig_av_1_A : A ;
  vittfamnande_av_1_A : A ;
  vittflygande_av_1_A : A ;
  vittgaaende_av_1_1_A : A ;
  vittnesgill_av_1_A : A ;
  vittnespsykologi_nn_1_N : N ;
  vittomfattande_av_1_A : A ;
  vivipar_av_1_A : A ;
  vokal_av_1_A : A ;
  vokaliserbar_av_1_A : A ;
  vokalisk_av_1_A : A ;
  volapuk_nn_1_1_N : N ;
  volonterande_nn_1_N : N ;
  voluminoes_av_1_1_A : A ;
  volymmaessig_av_1_1_A : A ;
  voyeuristisk_av_1_A : A ;
  vrakvirke_nn_1_N : N ;
  vred_av_1_A : A ;
  vrensk_av_1_A : A ;
  vresig_av_1_A : A ;
  vridbar_av_1_A : A ;
  vraekig_av_1_1_A : A ;
  vraang_av_1_1_A : A ;
  vraangvis_av_1_1_A : A ;
  vulgariserbar_av_1_A : A ;
  vulgo_av_1_A : A ;
  vulgaer_av_1_1_A : A ;
  vulkaniserbar_av_1_A : A ;
  vulkanisk_av_1_A : A ;
  vulstig_av_1_A : A ;
  vuvuzelatutande_av_1_A : A ;
  vuvuzelatutande_nn_1_N : N ;
  vaeck_av_1_1_A : A ;
  vaederbestaendig_av_1_1_A : A ;
  vaederleksmaessig_av_1_1_A : A ;
  vaederlaege_nn_1_1_N : N ;
  vaedermaessig_av_1_1_A : A ;
  vaederspaend_av_1_1_A : A ;
  vaeggmonterbar_av_1_1_A : A ;
  vaegledande_av_1_1_A : A ;
  vaegslitage_nn_1_1_N : N ;
  vaegvill_av_1_1_A : A ;
  vaegvinnande_av_1_1_A : A ;
  vael_nn_1_1_N : N ;
  vaelbefinnande_nn_1_1_N : N ;
  vaelbegriplig_av_1_1_A : A ;
  vaelbehaglig_av_1_1_A : A ;
  vaelbehoevlig_av_1_1_A : A ;
  vaeldig_av_1_1_A : A ;
  vaeldoftande_av_1_1_A : A ;
  vaelfungerande_av_1_1_A : A ;
  vaelfoerenlig_av_1_1_A : A ;
  vaelfoerhaallande_nn_1_1_N : N ;
  vaelfoerklarlig_av_1_1_A : A ;
  vaelfoerstaaelig_av_1_1_A : A ;
  vaelfoerstaandig_av_1_1_A : A ;
  vaelgoerande_av_1_1_A : A ;
  vaelklingande_av_1_1_A : A ;
  vaelkomnande_nn_1_1_N : N ;
  vaelkaend_av_1_1_A : A ;
  vaellingliknande_av_1_1_A : A ;
  vaelljudande_av_1_1_A : A ;
  vaellovlig_av_1_1_A : A ;
  vaelluktande_av_1_1_A : A ;
  vaellustig_av_1_1_A : A ;
  vaelmenande_av_1_1_A : A ;
  vaelmaaende_av_1_1_A : A ;
  vaelsignelsebringande_av_1_1_A : A ;
  vaelsittande_av_1_1_A : A ;
  vaelsk_av_1_1_A : A ;
  vaelskjutande_av_1_1_A : A ;
  vaelsmakande_av_1_1_A : A ;
  vaeltalig_av_1_1_A : A ;
  vaelvillig_av_1_1_A : A ;
  vaelvis_av_1_1_A : A ;
  vaemjelig_av_1_1_A : A ;
  vaen_av_1_1_A : A ;
  vaendbar_av_1_1_A : A ;
  vaenlig_av_1_1_A : A ;
  vaenskaplig_av_1_1_A : A ;
  vaenskapsfull_av_1_1_A : A ;
  vaenslande_nn_1_1_N : N ;
  vaensterextrem_av_1_1_A : A ;
  vaensterextremistisk_av_1_1_A : A ;
  vaensterradikal_av_1_1_A : A ;
  vaenstersympatiserande_av_1_1_A : A ;
  vaensaell_av_1_1_A : A ;
  vaerdebestaendig_av_1_1_A : A ;
  vaerdefilosofi_nn_1_1_N : N ;
  vaerdefull_av_1_1_A : A ;
  vaerdeloes_av_1_1_A : A ;
  vaerdemaessig_av_1_1_A : A ;
  vaerderbar_av_1_1_A : A ;
  vaerderingsmaessig_av_1_1_A : A ;
  vaerdeteori_nn_1_1_N : N ;
  vaerdig_av_1_1_A : A ;
  vaerdsomspaennande_av_1_1_A : A ;
  vaerldsfientlig_av_1_1_A : A ;
  vaerldsfraemmande_av_1_1_A : A ;
  vaerldsfraanvarande_av_1_1_A : A ;
  vaerldsfraanvaend_av_1_1_A : A ;
  vaerldshistoria_nn_1_1_N : N ;
  vaerldshistorisk_av_1_1_A : A ;
  vaerldsklok_av_1_1_A : A ;
  vaerldskaend_av_1_1_A : A ;
  vaerldsledande_av_1_1_A : A ;
  vaerldslig_av_1_1_A : A ;
  vaerldsmannamaessig_av_1_1_A : A ;
  vaerldsmedvetande_nn_1_1_N : N ;
  vaerldsomfattande_av_1_1_A : A ;
  vaerldsomspaennande_av_1_1_A : A ;
  vaerldsomstoertande_av_1_1_A : A ;
  vaerldsomvaelvande_av_1_1_A : A ;
  vaerldsrykte_nn_1_1_N : N ;
  vaerldssamvete_nn_1_1_N : N ;
  vaerldsvan_av_1_1_A : A ;
  vaerldsvis_av_1_1_A : A ;
  vaermebestaendig_av_1_1_A : A ;
  vaermeenergi_nn_1_1_N : N ;
  vaermefotograferbar_av_1_1_A : A ;
  vaermeisolerande_av_1_1_A : A ;
  vaermeisolerbar_av_1_1_A : A ;
  vaermesteriliserbar_av_1_1_A : A ;
  vaermeterapi_nn_1_1_N : N ;
  vaermetaalig_av_1_1_A : A ;
  vaermevaerde_nn_1_1_N : N ;
  vaermeaelskande_av_1_1_A : A ;
  vaermlaendsk_av_1_1_A : A ;
  vaernloes_av_1_1_A : A ;
  vaernpliktig_av_1_1_A : A ;
  vaerpsjuk_av_1_1_A : A ;
  vaersta_av_1_1_A : A ;
  vaesande_nn_1_1_N : N ;
  vaesentlig_av_1_1_A : A ;
  vaesterbottnisk_av_1_1_A : A ;
  vaesterlaendsk_av_1_1_A : A ;
  vaesteuropeisk_av_1_1_A : A ;
  vaestgotisk_av_1_1_A : A ;
  vaestgoetsk_av_1_1_A : A ;
  vaestindisk_av_1_1_A : A ;
  vaestkritisk_av_1_1_A : A ;
  vaestlig_av_1_1_A : A ;
  vaestmanlaendsk_av_1_1_A : A ;
  vaestra_av_1_1_A : A ;
  vaestslavisk_av_1_1_A : A ;
  vaestsvensk_av_1_1_A : A ;
  vaesttysk_av_1_1_A : A ;
  vaete_nn_1_1_N : N ;
  vaetgasrik_av_1_1_A : A ;
  vaetskig_av_1_1_A : A ;
  vaexelvarm_av_1_1_A : A ;
  vaexlande_av_1_1_A : A ;
  vaexlingsrik_av_1_1_A : A ;
  vaextanatomi_nn_1_1_N : N ;
  vaextbiologi_nn_1_1_N : N ;
  vaextfysiologi_nn_1_1_N : N ;
  vaextgeografi_nn_1_1_N : N ;
  vaexthaemmande_av_1_1_A : A ;
  vaextkraftig_av_1_1_A : A ;
  vaextlig_av_1_1_A : A ;
  vaextrike_nn_1_1_N : N ;
  vaextsilke_nn_1_1_N : N ;
  vaextaetande_av_1_1_A : A ;
  vaadlig_av_1_1_A : A ;
  vaagformig_av_1_1_A : A ;
  vaaghalsig_av_1_1_A : A ;
  vaagig_av_1_1_A : A ;
  vaagraet_av_1_1_A : A ;
  vaaldfoerande_nn_1_1_N : N ;
  vaaldsfoerhaerligande_nn_1_1_N : N ;
  vaaldspornografi_nn_1_1_N : N ;
  vaallande_nn_1_1_N : N ;
  vaapig_av_1_1_A : A ;
  vaardbehoevande_av_1_1_A : A ;
  vaardberoende_av_1_1_A : A ;
  vaardintygsmaessig_av_1_1_A : A ;
  vaardmaessig_av_1_1_A : A ;
  vaardsloes_av_1_1_A : A ;
  vaargroen_av_1_1_A : A ;
  vaarlig_av_1_1_A : A ;
  vaarstaedande_nn_1_1_N : N ;
  vaartig_av_1_1_A : A ;
  vaarvete_nn_1_1_N : N ;
  vaat_av_1_1_A : A ;
  vaatstark_av_1_1_A : A ;
  vaatvarm_av_1_1_A : A ;
  vaatvaermande_av_1_1_A : A ;
  voerdig_av_1_1_A : A ;
  voerdnadsbjudande_av_1_1_A : A ;
  voerdnadsfull_av_1_1_A : A ;
  walesisk_av_1_A : A ;
  waterloo_nn_1_N : N ;
  wenlock_nn_1_N : N ;
  xenofobi_nn_1_N : N ;
  xerografi_nn_1_N : N ;
  ylle_nn_1_N : N ;
  ymnig_av_1_A : A ;
  ynka_av_1_A : A ;
  ynklig_av_1_A : A ;
  ynnestfull_av_1_A : A ;
  yogande_nn_1_N : N ;
  ypperlig_av_1_A : A ;
  yppig_av_1_A : A ;
  yr_av_1_A : A ;
  yrkesarbetande_av_1_A : A ;
  yrkesarbetande_nn_1_N : N ;
  yrkesetisk_av_1_A : A ;
  yrkesfiske_nn_1_N : N ;
  yrkesfoerberedande_av_1_1_A : A ;
  yrkesmaessig_av_1_1_A : A ;
  yrkesskicklig_av_1_A : A ;
  ytaktiv_av_1_A : A ;
  ytlig_av_1_A : A ;
  ytmaessig_av_1_1_A : A ;
  ytterlig_av_1_A : A ;
  ytterligare_av_1_A : A ;
  yttre_nn_1_N : N ;
  yvig_av_1_A : A ;
  yxne_nn_1_N : N ;
  zairisk_av_1_A : A ;
  zambisk_av_1_A : A ;
  zigensk_av_1_A : A ;
  zimbabwisk_av_1_A : A ;
  zinkblaende_nn_1_1_N : N ;
  zinkgult_nn_1_N : N ;
  zinkvitt_nn_1_N : N ;
  zonterapi_nn_1_N : N ;
  zoofysiologi_nn_1_N : N ;
  zoologi_nn_1_N : N ;
  zoologisk_av_1_A : A ;
  zootomi_nn_1_N : N ;
  aecklig_av_1_1_A : A ;
  aedelmodig_av_1_1_A : A ;
  aegardemokrati_nn_1_1_N : N ;
  aegarmaessig_av_1_1_A : A ;
  aeggliknande_av_1_1_A : A ;
  aeggrund_av_1_1_A : A ;
  aeggsjuk_av_1_1_A : A ;
  aegig_av_1_1_A : A ;
  aekta_av_1_1_A : A ;
  aektenskaplig_av_1_1_A : A ;
  aektenskapstycke_nn_1_1_N : N ;
  aektsvensk_av_1_1_A : A ;
  aelsklig_av_1_1_A : A ;
  aelskogskrank_av_1_1_A : A ;
  aembetsmannamaessig_av_1_1_A : A ;
  aembetsmaessig_av_1_1_A : A ;
  aemnesintegrerbar_av_1_1_A : A ;
  aemnesmaessig_av_1_1_A : A ;
  aemnesoeverskridande_av_1_1_A : A ;
  aendamaalsenlig_av_1_1_A : A ;
  aendamaalsloes_av_1_1_A : A ;
  aendlig_av_1_1_A : A ;
  aendloes_av_1_1_A : A ;
  aenglalik_av_1_1_A : A ;
  aengslig_av_1_1_A : A ;
  aeppelpraektig_av_1_1_A : A ;
  aeppleliknande_av_1_1_A : A ;
  aerbar_av_1_1_A : A ;
  aeregirig_av_1_1_A : A ;
  aereloes_av_1_1_A : A ;
  aereroerig_av_1_1_A : A ;
  aerevoerdig_av_1_1_A : A ;
  aerftlig_av_1_1_A : A ;
  aerggroen_av_1_1_A : A ;
  aergig_av_1_1_A : A ;
  aerkebiskoplig_av_1_1_A : A ;
  aerkekonservativ_av_1_1_A : A ;
  aerlig_av_1_1_A : A ;
  aermloes_av_1_1_A : A ;
  aerofull_av_1_1_A : A ;
  aerorik_av_1_1_A : A ;
  aerrig_av_1_1_A : A ;
  aertgroen_av_1_1_A : A ;
  aertig_av_1_1_A : A ;
  aetbar_av_1_1_A : A ;
  aetlig_av_1_1_A : A ;
  aeventyrlig_av_1_1_A : A ;
  aabaekig_av_1_1_A : A ;
  aabaeklig_av_1_1_A : A ;
  aadrig_av_1_1_A : A ;
  aakmaessig_av_1_1_A : A ;
  aaksjuk_av_1_1_A : A ;
  aalderdomlig_av_1_1_A : A ;
  aalderdomssvag_av_1_1_A : A ;
  aaldersmaessig_av_1_1_A : A ;
  aalderssvag_av_1_1_A : A ;
  aaldrande_nn_1_1_N : N ;
  aaldrig_av_1_1_A : A ;
  aalfiske_nn_1_1_N : N ;
  aalaendsk_av_1_1_A : A ;
  aamig_av_1_1_A : A ;
  aangerfull_av_1_1_A : A ;
  aangermanlaendsk_av_1_1_A : A ;
  aangestfull_av_1_1_A : A ;
  aangestskapande_av_1_1_A : A ;
  aarlig_av_1_1_A : A ;
  aarsbaesta_av_1_1_A : A ;
  aasiktsmaessig_av_1_1_A : A ;
  aasiktsregistrerbar_av_1_1_A : A ;
  aaskraedd_av_1_1_A : A ;
  aaskaadlig_av_1_1_A : A ;
  aaskaadningsmaessig_av_1_1_A : A ;
  aateranskaffningsvaerde_nn_1_1_N : N ;
  aaterinstallerbar_av_1_1_A : A ;
  aaterinvesterande_nn_1_1_N : N ;
  aaterkommande_av_1_1_A : A ;
  aaterseende_nn_1_1_N : N ;
  aaterupplevande_nn_1_1_N : N ;
  aatkomlig_av_1_1_A : A ;
  aatloeje_nn_1_1_N : N ;
  aatnjutande_nn_1_1_N : N ;
  aatsittande_av_1_1_A : A ;
  aatskillnadsloes_av_1_1_A : A ;
  aatsmitande_av_1_1_A : A ;
  aattahoernig_av_1_1_A : A ;
  oede_av_1_1_A : A ;
  oedematoes_av_1_1_A : A ;
  oedmjuk_av_1_1_A : A ;
  oedslig_av_1_1_A : A ;
  oegonblicklig_av_1_1_A : A ;
  oegonskenlig_av_1_1_A : A ;
  oekaend_av_1_1_A : A ;
  oeldrickande_av_1_1_A : A ;
  oeldrickande_nn_1_1_N : N ;
  oelaendsk_av_1_1_A : A ;
  oemklig_av_1_1_A : A ;
  oemmande_av_1_1_A : A ;
  oemsesidig_av_1_1_A : A ;
  oemtaalig_av_1_1_A : A ;
  oensketaenkande_nn_1_1_N : N ;
  oensklig_av_1_1_A : A ;
  oeppenhjaertig_av_1_1_A : A ;
  oeppenhjaertlig_av_1_1_A : A ;
  oeppethaallande_nn_1_1_N : N ;
  oeronbedoevande_av_1_1_A : A ;
  oertte_nn_1_1_N : N ;
  oest_vaestlig_av_1_1_A : A ;
  oesterbottnisk_av_1_1_A : A ;
  oesterlaendsk_av_1_1_A : A ;
  oesterrikisk_av_1_1_A : A ;
  oestersjoefiske_nn_1_1_N : N ;
  oesteuropeisk_av_1_1_A : A ;
  oestgotisk_av_1_1_A : A ;
  oestgoetsk_av_1_1_A : A ;
  oestlig_av_1_1_A : A ;
  oestra_av_1_1_A : A ;
  oesttysk_av_1_1_A : A ;
  oeveraktiv_av_1_1_A : A ;
  oeverambitioes_av_1_1_A : A ;
  oeverbelastande_nn_1_1_N : N ;
  oeverbelaeggande_nn_1_1_N : N ;
  oeverbeskyddande_nn_1_1_N : N ;
  oeverbetonande_nn_1_1_N : N ;
  oeverblickbar_av_1_1_A : A ;
  oeverdebiterande_nn_1_1_N : N ;
  oeverdimensionerbar_av_1_1_A : A ;
  oeverdoserbar_av_1_1_A : A ;
  oeverdaadig_av_1_1_A : A ;
  oeverens_av_1_1_A : A ;
  oeverexponerbar_av_1_1_A : A ;
  oeverfiske_nn_1_1_N : N ;
  oeverfloedig_av_1_1_A : A ;
  oeverfull_av_1_1_A : A ;
  oevergripande_av_1_1_A : A ;
  oevergaaende_av_1_1_A : A ;
  oeverhetlig_av_1_1_A : A ;
  oeverhaengande_av_1_1_A : A ;
  oeverhaerdig_av_1_1_A : A ;
  oeverinseende_nn_1_1_N : N ;
  oeverjordisk_av_1_1_A : A ;
  oeverklassig_av_1_1_A : A ;
  oeverkomlig_av_1_1_A : A ;
  oeverkompenserbar_av_1_1_A : A ;
  oeverkaenslig_av_1_1_A : A ;
  oeverlackerbar_av_1_1_A : A ;
  oeverlackeringsbar_av_1_1_A : A ;
  oeverlevande_av_1_1_A : A ;
  oeverlevnadsvaerde_nn_1_1_N : N ;
  oeverliggande_av_1_1_A : A ;
  oeverloppsenergi_nn_1_1_N : N ;
  oeverlutande_av_1_1_A : A ;
  oeverlycklig_av_1_1_A : A ;
  oevermaga_av_1_1_A : A ;
  oevermodig_av_1_1_A : A ;
  oevermaektig_av_1_1_A : A ;
  oevermaensklig_av_1_1_A : A ;
  oevermaalningsbar_av_1_1_A : A ;
  oevernationell_av_1_1_A : A ;
  oevernaturlig_av_1_1_A : A ;
  oevernitisk_av_1_1_A : A ;
  oeverraskande_av_1_1_A : A ;
  oeverseende_av_1_1_A : A ;
  oeversiktlig_av_1_1_A : A ;
  oeversinnlig_av_1_1_A : A ;
  oeverskattande_nn_1_1_N : N ;
  oeverskjutande_av_1_1_A : A ;
  oeverskaadlig_av_1_1_A : A ;
  oeverslagsmaessig_av_1_1_A : A ;
  oeverslaetande_av_1_1_A : A ;
  oeverspaend_av_1_1_A : A ;
  oeverstiglig_av_1_1_A : A ;
  oeverstyr_av_1_1_A : A ;
  oeversvallande_av_1_1_A : A ;
  oeversvinnelig_av_1_1_A : A ;
  oeversvinnlig_av_1_1_A : A ;
  oevertalig_av_1_1_A : A ;
  oevertrasserbar_av_1_1_A : A ;
  oevertydlig_av_1_1_A : A ;
  oevertygande_av_1_1_A : A ;
  oevertaend_av_1_1_A : A ;
  oevervattenslaege_nn_1_1_N : N ;
  oeverviktig_av_1_1_A : A ;
  oevervaegande_av_1_1_A : A ;
  oevervaeldigande_av_1_1_A : A ;
  oevervaerderbar_av_1_1_A : A ;
  oeveraarig_av_1_1_A : A ;
  oeveroesande_nn_1_1_N : N ;
  oevlig_av_1_1_A : A ;
  isomer_av_1_A : A ;
  karcinogen_av_1_A : A ;
  klockren_av_1_A : A ;
  kryogen_av_1_A : A ;
  linjeren_av_1_A : A ;
  mutagen_av_1_A : A ;
  navigabel_av_1_A : A ;
  nervklen_av_1_A : A ;
  obscen_av_1_A : A ;
  ogemen_av_1_A : A ;
  oresonabel_av_1_A : A ;
  organogen_av_1_A : A ;
  oaedel_av_1_1_A : A ;
  patogen_av_1_A : A ;
  perifer_av_1_A : A ;
  psykogen_av_1_A : A ;
  rasren_av_1_A : A ;
  rumsren_av_1_A : A ;
  sammetslen_av_1_A : A ;
  saprogen_av_1_A : A ;
  schangdobel_av_1_A : A ;
  schizofren_av_1_A : A ;
  seren_av_1_A : A ;
  silkeslen_av_1_A : A ;
  sirapslen_av_1_A : A ;
  sjukhusren_av_1_A : A ;
  stilren_av_1_A : A ;
  superlen_av_1_A : A ;
  terrigen_av_1_A : A ;
  transgen_av_1_A : A ;
  Kafkaesk_av_1_A : A ;
  Kafkalik_av_1_A : A ;
  Moskvavaenlig_av_1_1_A : A ;
  Stockholmsmaessig_av_1_1_A : A ;
  intonerbar_av_1_A : A ;
  intransitiv_av_1_A : A ;
  intravenoes_av_1_1_A : A ;
  intresseloes_av_1_1_A : A ;
  intressemaessig_av_1_1_A : A ;
  intresserbar_av_1_A : A ;
  intrigmaessig_av_1_1_A : A ;
  introducerbar_av_1_A : A ;
  introspektiv_av_1_A : A ;
  intuitiv_av_1_A : A ;
  invaderbar_av_1_A : A ;
  invalidiserbar_av_1_A : A ;
  invandrarfientlig_av_1_A : A ;
  invandrartaet_av_1_1_A : A ;
  invandringskritisk_av_1_A : A ;
  inventerbar_av_1_A : A ;
  inventioes_av_1_1_A : A ;
  inverterbar_av_1_A : A ;
  investerbar_av_1_A : A ;
  inviterbar_av_1_A : A ;
  involverbar_av_1_A : A ;
  invaendig_av_1_1_A : A ;
  irakisk_av_1_A : A ;
  iransk_av_1_A : A ;
  irisk_av_1_A : A ;
  irlaendsk_av_1_1_A : A ;
  ironisk_av_1_A : A ;
  irrationell_av_1_A : A ;
  irreal_av_1_A : A ;
  irreell_av_1_A : A ;
  irreguljaer_av_1_1_A : A ;
  irriterbar_av_1_A : A ;
  irrlaerig_av_1_1_A : A ;
  isagogisk_av_1_A : A ;
  ishal_av_1_A : A ;
  ishockeymaessig_av_1_1_A : A ;
  isig_av_1_A : A ;
  iskall_av_1_A : A ;
  islamiserbar_av_1_A : A ;
  islamisk_av_1_A : A ;
  islamistisk_av_1_A : A ;
  islamsk_av_1_A : A ;
  islaendsk_av_1_1_A : A ;
  isolationistisk_av_1_A : A ;
  isolerbar_av_1_A : A ;
  isomorf_av_1_A : A ;
  israelisk_av_1_A : A ;
  israelitisk_av_1_A : A ;
  istadig_av_1_A : A ;
  italiensk_av_1_A : A ;
  italisk_av_1_A : A ;
  iterativ_av_1_A : A ;
  itererbar_av_1_A : A ;
  ivoriansk_av_1_A : A ;
  ivrig_av_1_A : A ;
  jackig_av_1_A : A ;
  jadegroen_av_1_1_A : A ;
  jagisk_av_1_A : A ;
  jaktbar_av_1_A : A ;
  jaktlig_av_1_A : A ;
  jamaicansk_av_1_A : A ;
  jamaikansk_av_1_A : A ;
  jambisk_av_1_A : A ;
  japansk_av_1_A : A ;
  jargongmaessig_av_1_1_A : A ;
  javanesisk_av_1_A : A ;
  javansk_av_1_A : A ;
  jazzifierbar_av_1_A : A ;
  jazzig_av_1_A : A ;
  jazzmaessig_av_1_1_A : A ;
  jemenitisk_av_1_A : A ;
  jesuitisk_av_1_A : A ;
  jobbig_av_1_A : A ;
  joderbar_av_1_A : A ;
  jolmig_av_1_A : A ;
  jonglerbar_av_1_A : A ;
  joniserbar_av_1_A : A ;
  jonisk_av_1_A : A ;
  jordansk_av_1_A : A ;
  jordbruksmaessig_av_1_1_A : A ;
  jordig_av_1_A : A ;
  jordisk_av_1_A : A ;
  jordlik_av_1_A : A ;
  journalistisk_av_1_A : A ;
  jovial_av_1_A : A ;
  jovialisk_av_1_A : A ;
  joxig_av_1_A : A ;
  judiciell_av_1_A : A ;
  judisk_av_1_A : A ;
  jugoslavisk_av_1_A : A ;
  juliansk_av_1_A : A ;
  julledig_av_1_A : A ;
  jungfrulig_av_1_A : A ;
  junior_av_1_A : A ;
  juniormaessig_av_1_1_A : A ;
  junonisk_av_1_A : A ;
  juridisk_av_1_A : A ;
  jutlaendsk_av_1_1_A : A ;
  jutsk_av_1_A : A ;
  juvenil_av_1_A : A ;
  jyllaendsk_av_1_1_A : A ;
  jaeklig_av_1_1_A : A ;
  jaektig_av_1_1_A : A ;
  jaemboerdig_av_1_1_A : A ;
  jaemfoerbar_av_1_1_A : A ;
  jaemfoerlig_av_1_1_A : A ;
  jaemlik_av_1_1_A : A ;
  jaemmerfull_av_1_1_A : A ;
  jaemmerlig_av_1_1_A : A ;
  jaemn_av_1_1_A : A ;
  jaemnboerdig_av_1_1_A : A ;
  jaemnstark_av_1_1_A : A ;
  jaemnstor_av_1_1_A : A ;
  jaemntjock_av_1_1_A : A ;
  jaemnvarm_av_1_1_A : A ;
  jaemstark_av_1_1_A : A ;
  jaemtjock_av_1_1_A : A ;
  jaemtlaendsk_av_1_1_A : A ;
  jaemtsk_av_1_1_A : A ;
  jaernrik_av_1_1_A : A ;
  jaesig_av_1_1_A : A ;
  jaettedyr_av_1_1_A : A ;
  jaettekaer_av_1_1_A : A ;
  jaettelik_av_1_1_A : A ;
  jaettesnygg_av_1_1_A : A ;
  jaettesnaell_av_1_1_A : A ;
  jaevelsk_av_1_1_A : A ;
  jaevig_av_1_1_A : A ;
  jaevlig_av_1_1_A : A ;
  jaevulsk_av_1_1_A : A ;
  joensig_av_1_1_A : A ;
  kabylisk_av_1_A : A ;
  kadmiumgul_av_1_A : A ;
  kaffebrun_av_1_A : A ;
  kafkaesk_av_1_A : A ;
  kafkalik_av_1_A : A ;
  kakuminal_av_1_A : A ;
  kal_av_1_A : A ;
  kalandrerbar_av_1_A : A ;
  kalcinerbar_av_1_A : A ;
  kaledonisk_av_1_A : A ;
  kaleidoskopisk_av_1_A : A ;
  kalejdoskopisk_av_1_A : A ;
  kalendarisk_av_1_A : A ;
  kalibrerbar_av_1_A : A ;
  kalifornisk_av_1_A : A ;
  kalkerbar_av_1_A : A ;
  kalkfattig_av_1_A : A ;
  kalkhaltig_av_1_A : A ;
  kalkonmaessig_av_1_1_A : A ;
  kalkrik_av_1_A : A ;
  kalkvattenbestaendig_av_1_1_A : A ;
  kalkvit_av_1_A : A ;
  kalkylerbar_av_1_A : A ;
  kalkylmaessig_av_1_1_A : A ;
  kall_av_1_A : A ;
  kallblodig_av_1_A : A ;
  kallsinnig_av_1_A : A ;
  kalmerbar_av_1_A : A ;
  kalorifattig_av_1_A : A ;
  kaloririk_av_1_A : A ;
  kalstammig_av_1_A : A ;
  kalvfaerdig_av_1_1_A : A ;
  kalvinistisk_av_1_A : A ;
  kalvinsk_av_1_A : A ;
  kambrisk_av_1_A : A ;
  kameleontisk_av_1_A : A ;
  kameral_av_1_A : A ;
  kamerunsk_av_1_A : A ;
  kamouflerbar_av_1_A : A ;
  kampucheansk_av_1_A : A ;
  kamratlig_av_1_A : A ;
  kamrermaessig_av_1_1_A : A ;
  kanadensisk_av_1_A : A ;
  kanaliserbar_av_1_A : A ;
  kanariegul_av_1_A : A ;
  kanderbar_av_1_A : A ;
  kandiderbar_av_1_A : A ;
  kanelbrun_av_1_A : A ;
  kannelerbar_av_1_A : A ;
  kannibalisk_av_1_A : A ;
  kanoniserbar_av_1_A : A ;
  kanonisk_av_1_A : A ;
  kanslimaessig_av_1_1_A : A ;
  kantig_av_1_A : A ;
  kaotisk_av_1_A : A ;
  kapillaer_av_1_1_A : A ;
  kapital_av_1_A : A ;
  kapitalintensiv_av_1_A : A ;
  kapitaliserbar_av_1_A : A ;
  kapitalistisk_av_1_A : A ;
  kapitalmaessig_av_1_1_A : A ;
  kapprak_av_1_A : A ;
  kapricioes_av_1_1_A : A ;
  kapverdisk_av_1_A : A ;
  karakteriserbar_av_1_A : A ;
  karakteristisk_av_1_A : A ;
  karaktaeriserbar_av_1_1_A : A ;
  karaktaeristisk_av_1_1_A : A ;
  karaktaersmaessig_av_1_1_A : A ;
  karaktaersstark_av_1_1_A : A ;
  karambolerbar_av_1_A : A ;
  karboniserbar_av_1_A : A ;
  kardansk_av_1_A : A ;
  karelsk_av_1_A : A ;
  karg_av_1_A : A ;
  karikatyrmaessig_av_1_1_A : A ;
  karikerbar_av_1_A : A ;
  karismatisk_av_1_A : A ;
  karlaktig_av_1_A : A ;
  karltokig_av_1_A : A ;
  karolinsk_av_1_A : A ;
  karriaermaessig_av_1_1_A : A ;
  karsk_av_1_A : A ;
  kartagisk_av_1_A : A ;
  kartellmaessig_av_1_1_A : A ;
  karterbar_av_1_A : A ;
  kartig_av_1_A : A ;
  kartonnerbar_av_1_A : A ;
  kass_av_1_A : A ;
  kassamaessig_av_1_1_A : A ;
  kasserbar_av_1_A : A ;
  kastiliansk_av_1_A : A ;
  kastloes_av_1_1_A : A ;
  kastrerbar_av_1_A : A ;
  kasuell_av_1_A : A ;
  katabatisk_av_1_A : A ;
  kataforisk_av_1_A : A ;
  katalansk_av_1_A : A ;
  katalektisk_av_1_A : A ;
  katalogiserbar_av_1_A : A ;
  katalyserbar_av_1_A : A ;
  katalytisk_av_1_A : A ;
  katastrofal_av_1_A : A ;
  kategoriserbar_av_1_A : A ;
  kategorisk_av_1_A : A ;
  kateketisk_av_1_A : A ;
  kateteriserbar_av_1_A : A ;
  katetriserbar_av_1_A : A ;
  katig_av_1_A : A ;
  katolsk_av_1_A : A ;
  kattaktig_av_1_A : A ;
  kaukasisk_av_1_A : A ;
  kausal_av_1_A : A ;
  kausativ_av_1_A : A ;
  kaustik_av_1_A : A ;
  kauteriserbar_av_1_A : A ;
  kaxig_av_1_A : A ;
  kazakisk_av_1_A : A ;
  keff_av_1_A : A ;
  kejserlig_av_1_A : A ;
  kelig_av_1_A : A ;
  kelsjuk_av_1_A : A ;
  keltisk_av_1_A : A ;
  kemisk_av_1_A : A ;
  kenyansk_av_1_A : A ;
  khakigroen_av_1_1_A : A ;
  killig_av_1_A : A ;
  kilometertjock_av_1_A : A ;
  kinesisk_av_1_A : A ;
  kinestetisk_av_1_A : A ;
  kinetisk_av_1_A : A ;
  kinkig_av_1_A : A ;
  kiribatisk_av_1_A : A ;
  kirurgisk_av_1_A : A ;
  kissnoedig_av_1_1_A : A ;
  kitslig_av_1_A : A ;
  kittlig_av_1_A : A ;
  kladdig_av_1_A : A ;
  klangfull_av_1_A : A ;
  klanglig_av_1_A : A ;
  klangloes_av_1_1_A : A ;
  klangmaessig_av_1_1_A : A ;
  klangrik_av_1_A : A ;
  klanmaessig_av_1_1_A : A ;
  klantig_av_1_A : A ;
  klar_av_1_A : A ;
  klarerbar_av_1_A : A ;
  klargul_av_1_A : A ;
  klassificerbar_av_1_A : A ;
  klassisk_av_1_A : A ;
  klassloes_av_1_1_A : A ;
  klassmaessig_av_1_1_A : A ;
  klatschig_av_1_A : A ;
  klemig_av_1_A : A ;
  klen_av_1_A : A ;
  klenmodig_av_1_A : A ;
  klerikal_av_1_A : A ;
  kletig_av_1_A : A ;
  klibbig_av_1_A : A ;
  klich_emaessig_av_1_1_A : A ;
  klimatmaessig_av_1_1_A : A ;
  klimatologisk_av_1_A : A ;
  klinisk_av_1_A : A ;
  klippig_av_1_A : A ;
  klipsk_av_1_A : A ;
  klistrig_av_1_A : A ;
  klockformig_av_1_A : A ;
  klok_av_1_A : A ;
  klorerbar_av_1_A : A ;
  klossig_av_1_A : A ;
  klosterlig_av_1_A : A ;
  klottrig_av_1_A : A ;
  klumpig_av_1_A : A ;
  klunsig_av_1_A : A ;
  klurig_av_1_A : A ;
  klyftig_av_1_A : A ;
  klyschig_av_1_A : A ;
  klyvbar_av_1_A : A ;
  klaedesmaessig_av_1_1_A : A ;
  klaemmig_av_1_1_A : A ;
  klaengig_av_1_1_A : A ;
  klaafingrig_av_1_1_A : A ;
  knackig_av_1_A : A ;
  knagglig_av_1_A : A ;
  knal_av_1_A : A ;
  knapp_av_1_A : A ;
  knapphaendig_av_1_1_A : A ;
  knaprig_av_1_A : A ;
  knarrig_av_1_A : A ;
  knasig_av_1_A : A ;
  knasprig_av_1_A : A ;
  knastrig_av_1_A : A ;
  knepig_av_1_A : A ;
  knipslug_av_1_A : A ;
  knivbladslik_av_1_A : A ;
  knivig_av_1_A : A ;
  knivskarp_av_1_A : A ;
  knoddaen_av_1_1_A : A ;
  knogig_av_1_A : A ;
  knollrig_av_1_A : A ;
  knoppig_av_1_A : A ;
  knotig_av_1_A : A ;
  knottrig_av_1_A : A ;
  knubbig_av_1_A : A ;
  knusslig_av_1_A : A ;
  knutig_av_1_A : A ;
  knyckig_av_1_A : A ;
  knaehoeg_av_1_1_A : A ;
  knaelaang_av_1_1_A : A ;
  knaepp_av_1_1_A : A ;
  knaesvag_av_1_1_A : A ;
  knoekfull_av_1_1_A : A ;
  knoelaktig_av_1_1_A : A ;
  knoelig_av_1_1_A : A ;
  koafferbar_av_1_A : A ;
  koagulerbar_av_1_A : A ;
  kobolthaltig_av_1_A : A ;
  kodifierbar_av_1_A : A ;
  kognatisk_av_1_A : A ;
  kognitiv_av_1_A : A ;
  kokhet_av_1_A : A ;
  kolerisk_av_1_A : A ;
  kolhaltig_av_1_A : A ;
  kollationerbar_av_1_A : A ;
  kollegial_av_1_A : A ;
  kollektiv_av_1_A : A ;
  kollektiviserbar_av_1_A : A ;
  kolloidal_av_1_A : A ;
  kollrig_av_1_A : A ;
  kolmoerk_av_1_1_A : A ;
  kolonial_av_1_A : A ;
  koloniserbar_av_1_A : A ;
  kolorerbar_av_1_A : A ;
  kolossal_av_1_A : A ;
  kolportagemaessig_av_1_1_A : A ;
  kolporterbar_av_1_A : A ;
  kolugn_av_1_A : A ;
  komatoes_av_1_1_A : A ;
  kombinatorisk_av_1_A : A ;
  kombinerbar_av_1_A : A ;
  komisk_av_1_A : A ;
  kommaterbar_av_1_A : A ;
  kommenderbar_av_1_A : A ;
  kommenterbar_av_1_A : A ;
  kommersialiserbar_av_1_A : A ;
  kommersiell_av_1_A : A ;
  kommunal_av_1_A : A ;
  kommunaliserbar_av_1_A : A ;
  kommunalpolitisk_av_1_A : A ;
  kommunicerbar_av_1_A : A ;
  kommunikationsmaessig_av_1_1_A : A ;
  kommunikativ_av_1_A : A ;
  kommunistisk_av_1_A : A ;
  kommutativ_av_1_A : A ;
  kommuterbar_av_1_A : A ;
  komorisk_av_1_A : A ;
  komparativ_av_1_A : A ;
  komparerbar_av_1_A : A ;
  kompensatorisk_av_1_A : A ;
  kompenserbar_av_1_A : A ;
  kompetensmaessig_av_1_1_A : A ;
  kompilerbar_av_1_A : A ;
  kompledig_av_1_A : A ;
  komplementaer_av_1_1_A : A ;
  kompletterbar_av_1_A : A ;
  komplex_av_1_A : A ;
  komplexig_av_1_A : A ;
  komplicerbar_av_1_A : A ;
  komplimenterbar_av_1_A : A ;
  komponerbar_av_1_A : A ;
  komposterbar_av_1_A : A ;
  komposteringsbar_av_1_A : A ;
  komprimerbar_av_1_A : A ;
  komprometterbar_av_1_A : A ;
  kompromissloes_av_1_1_A : A ;
  kompulsiv_av_1_A : A ;
  komputationell_av_1_A : A ;
  koncentrerbar_av_1_A : A ;
  koncentrisk_av_1_A : A ;
  konceptiv_av_1_A : A ;
  konceptuell_av_1_A : A ;
  koncernmaessig_av_1_1_A : A ;
  koncessionerbar_av_1_A : A ;
  koncessiv_av_1_A : A ;
  koncipierbar_av_1_A : A ;
  koncis_av_1_A : A ;
  kondemnerbar_av_1_A : A ;
  kondenserbar_av_1_A : A ;
  konditional_av_1_A : A ;
  konditionerbar_av_1_A : A ;
  konditionsmaessig_av_1_1_A : A ;
  kondolerbar_av_1_A : A ;
  konfederal_av_1_A : A ;
  konfektionsmaessig_av_1_1_A : A ;
  konfessionell_av_1_A : A ;
  konfessionsloes_av_1_1_A : A ;
  konfidentiell_av_1_A : A ;
  konfirmerbar_av_1_A : A ;
  konfiskatorisk_av_1_A : A ;
  konfiskerbar_av_1_A : A ;
  konform_av_1_A : A ;
  konformig_av_1_A : A ;
  konfronterbar_av_1_A : A ;
  konfunderbar_av_1_A : A ;
  konfys_av_1_A : A ;
  kongenial_av_1_A : A ;
  kongenital_av_1_A : A ;
  kongolesisk_av_1_A : A ;
  kongruerbar_av_1_A : A ;
  konisk_av_1_A : A ;
  konjugerbar_av_1_A : A ;
  konjunkturmaessig_av_1_1_A : A ;
  konkav_av_1_A : A ;
  konkavkonvex_av_1_A : A ;
  konkluderbar_av_1_A : A ;
  konklusiv_av_1_A : A ;
  konkretiserbar_av_1_A : A ;
  konkurrensduglig_av_1_A : A ;
  konkurrenskraftig_av_1_A : A ;
  konkurrensmaessig_av_1_1_A : A ;
  konkursmaessig_av_1_1_A : A ;
  konnotativ_av_1_A : A ;
  konsekutiv_av_1_A : A ;
  konservativ_av_1_A : A ;
  konserverbar_av_1_A : A ;
  konsignerbar_av_1_A : A ;
  konsistorial_av_1_A : A ;
  konsoliderbar_av_1_A : A ;
  konspirativ_av_1_A : A ;
  konspiratorisk_av_1_A : A ;
  konstaterbar_av_1_A : A ;
  konsternerbar_av_1_A : A ;
  konstfull_av_1_A : A ;
  konstfaerdig_av_1_1_A : A ;
  konsthantverksmaessig_av_1_1_A : A ;
  konsthistorisk_av_1_A : A ;
  konstifik_av_1_A : A ;
  konstig_av_1_A : A ;
  konstituerbar_av_1_A : A ;
  konstitutionell_av_1_A : A ;
  konstitutiv_av_1_A : A ;
  konstloes_av_1_1_A : A ;
  konstmaessig_av_1_1_A : A ;
  konstnaerlig_av_1_1_A : A ;
  konstnaerstaet_av_1_1_A : A ;
  konstrik_av_1_A : A ;
  konstruerbar_av_1_A : A ;
  konstruktionsmaessig_av_1_1_A : A ;
  konstruktiv_av_1_A : A ;
  konstskicklig_av_1_A : A ;
  konsultativ_av_1_A : A ;
  konsulterbar_av_1_A : A ;
  konsulaer_av_1_1_A : A ;
  konsumerbar_av_1_A : A ;
  kontagioes_av_1_1_A : A ;
  kontaminerbar_av_1_A : A ;
  kontemplativ_av_1_A : A ;
  konterbar_av_1_A : A ;
  kontinental_av_1_A : A ;
  kontingenterbar_av_1_A : A ;
  kontinuerlig_av_1_A : A ;
  kontoriserbar_av_1_A : A ;
  kontorsmaessig_av_1_1_A : A ;
  kontradiktorisk_av_1_A : A ;
  kontraherbar_av_1_A : A ;
  kontrakterbar_av_1_A : A ;
  kontraktil_av_1_A : A ;
  kontraktsenlig_av_1_A : A ;
  kontraktsmaessig_av_1_1_A : A ;
  kontraktsvidrig_av_1_A : A ;
  kontramanderbar_av_1_A : A ;
  kontraproduktiv_av_1_A : A ;
  kontrasignerbar_av_1_A : A ;
  kontrasterbar_av_1_A : A ;
  kontribuerbar_av_1_A : A ;
  kontrollerbar_av_1_A : A ;
  kontroversiell_av_1_A : A ;
  kontraer_av_1_1_A : A ;
  konturerbar_av_1_A : A ;
  konturloes_av_1_1_A : A ;
  konturskarp_av_1_A : A ;
  konungsk_av_1_A : A ;
  konungslig_av_1_A : A ;
  konventionell_av_1_A : A ;
  konvergerbar_av_1_A : A ;
  konverserbar_av_1_A : A ;
  konversiv_av_1_A : A ;
  konverterbar_av_1_A : A ;
  konvex_av_1_A : A ;
  konvexkonkav_av_1_A : A ;
  konvojerbar_av_1_A : A ;
  konvulsivisk_av_1_A : A ;
  kooperativ_av_1_A : A ;
  koordinerbar_av_1_A : A ;
  kopernikansk_av_1_A : A ;
  kopierbar_av_1_A : A ;
  kopioes_av_1_1_A : A ;
  kopparbrun_av_1_A : A ;
  koppelvan_av_1_A : A ;
  koppaerrig_av_1_1_A : A ;
  koptisk_av_1_A : A ;
  kopulativ_av_1_A : A ;
  kordial_av_1_A : A ;
  koreansk_av_1_A : A ;
  koreografisk_av_1_A : A ;
  korgblommig_av_1_A : A ;
  korintisk_av_1_A : A ;
  korngul_av_1_A : A ;
  kornig_av_1_A : A ;
  korporativ_av_1_A : A ;
  korrelerbar_av_1_A : A ;
  korrigerbar_av_1_A : A ;
  korroderbar_av_1_A : A ;
  korrugerbar_av_1_A : A ;
  korrumperbar_av_1_A : A ;
  korsblommig_av_1_A : A ;
  korsetterbar_av_1_A : A ;
  korsikansk_av_1_A : A ;
  korsordsmaessig_av_1_1_A : A ;
  kortfristig_av_1_A : A ;
  korthaarig_av_1_1_A : A ;
  kortpipig_av_1_A : A ;
  kortsiktig_av_1_A : A ;
  kortskallig_av_1_A : A ;
  kortvarig_av_1_A : A ;
  korvig_av_1_A : A ;
  kosmetisk_av_1_A : A ;
  kosmisk_av_1_A : A ;
  kosmologisk_av_1_A : A ;
  kosmopolitisk_av_1_A : A ;
  kosovansk_av_1_A : A ;
  kostbar_av_1_A : A ;
  kostlig_av_1_A : A ;
  kostnadseffektiv_av_1_A : A ;
  kostnadsmaessig_av_1_1_A : A ;
  kostymerbar_av_1_A : A ;
  krackelerbar_av_1_A : A ;
  krafsig_av_1_A : A ;
  kraftfull_av_1_A : A ;
  kraftig_av_1_A : A ;
  kraftloes_av_1_1_A : A ;
  kragloes_av_1_1_A : A ;
  kram_av_1_A : A ;
  krampaktig_av_1_A : A ;
  krank_av_1_A : A ;
  krass_av_1_A : A ;
  krasslig_av_1_A : A ;
  kravloes_av_1_1_A : A ;
  kreativ_av_1_A : A ;
  kreatursloes_av_1_1_A : A ;
  kreddig_av_1_A : A ;
  krediterbar_av_1_A : A ;
  kreerbar_av_1_A : A ;
  kremerbar_av_1_A : A ;
  kremlvaenlig_av_1_1_A : A ;
  kreperbar_av_1_A : A ;
  kretensisk_av_1_A : A ;
  kretisk_av_1_A : A ;
  kreverbar_av_1_A : A ;
  krigisk_av_1_A : A ;
  krigsmaessig_av_1_1_A : A ;
  krigsplacerbar_av_1_A : A ;
  kriminaliserbar_av_1_A : A ;
  kriminell_av_1_A : A ;
  kriminologisk_av_1_A : A ;
  kringelikrokig_av_1_A : A ;
  kringelkrokig_av_1_A : A ;
  kringsjuk_av_1_A : A ;
  krispig_av_1_A : A ;
  kristallin_av_1_A : A ;
  kristallinisk_av_1_A : A ;
  kristalliserbar_av_1_A : A ;
  kristallisk_av_1_A : A ;
  kristallklar_av_1_A : A ;
  kristallografisk_av_1_A : A ;
  kristlig_av_1_A : A ;
  kritig_av_1_A : A ;
  kritikermaessig_av_1_1_A : A ;
  kritikloes_av_1_1_A : A ;
  kritiserbar_av_1_A : A ;
  kritisk_av_1_A : A ;
  kritstrecksrandig_av_1_A : A ;
  kritvit_av_1_A : A ;
  kroatisk_av_1_A : A ;
  krokig_av_1_A : A ;
  krokryggig_av_1_A : A ;
  kronisk_av_1_A : A ;
  kronologisk_av_1_A : A ;
  kroppslig_av_1_A : A ;
  kroppsvisiterbar_av_1_A : A ;
  krullhaarig_av_1_1_A : A ;
  krullig_av_1_A : A ;
  kruserlig_av_1_A : A ;
  krushaarig_av_1_1_A : A ;
  krusidullig_av_1_A : A ;
  krusig_av_1_A : A ;
  kruttorr_av_1_A : A ;
  kryckig_av_1_A : A ;
  kryddbrun_av_1_A : A ;
  kryddig_av_1_A : A ;
  kryddstark_av_1_A : A ;
  krypterbar_av_1_A : A ;
  kryptisk_av_1_A : A ;
  kryptogam_av_1_A : A ;
  kryssmaessig_av_1_1_A : A ;
  kraekfaerdig_av_1_1_A : A ;
  kraemig_av_1_1_A : A ;
  kraeslig_av_1_1_A : A ;
  kraanglig_av_1_1_A : A ;
  kubansk_av_1_A : A ;
  kuberbar_av_1_A : A ;
  kubistisk_av_1_A : A ;
  kufisk_av_1_A : A ;
  kujonerbar_av_1_A : A ;
  kulig_av_1_A : A ;
  kulinarisk_av_1_A : A ;
  kullig_av_1_A : A ;
  kullrig_av_1_A : A ;
  kultisk_av_1_A : A ;
  kultiverbar_av_1_A : A ;
  kulturell_av_1_A : A ;
  kulturfientlig_av_1_A : A ;
  kulturhistorisk_av_1_A : A ;
  kumulativ_av_1_A : A ;
  kumulerbar_av_1_A : A ;
  kunglig_av_1_A : A ;
  kunnig_av_1_A : A ;
  kunskapsmaessig_av_1_1_A : A ;
  kunskapsrik_av_1_A : A ;
  kuperbar_av_1_A : A ;
  kupig_av_1_A : A ;
  kupolformig_av_1_A : A ;
  kuraterbar_av_1_A : A ;
  kurativ_av_1_A : A ;
  kurdisk_av_1_A : A ;
  kurerbar_av_1_A : A ;
  kurioes_av_1_1_A : A ;
  kursiv_av_1_A : A ;
  kursiverbar_av_1_A : A ;
  kursmaessig_av_1_1_A : A ;
  kursorisk_av_1_A : A ;
  kurtiserbar_av_1_A : A ;
  kurvig_av_1_A : A ;
  kurvstabil_av_1_A : A ;
  kuslig_av_1_A : A ;
  kutig_av_1_A : A ;
  kutryggig_av_1_A : A ;
  kuverterbar_av_1_A : A ;
  kuwaitisk_av_1_A : A ;
  kvadrerbar_av_1_A : A ;
  kvalfri_av_1_A : A ;
  kvalfull_av_1_A : A ;
  kvalificerbar_av_1_A : A ;
  kvalitativ_av_1_A : A ;
  kvalitetsmaessig_av_1_1_A : A ;
  kvalmig_av_1_A : A ;
  kvantifierbar_av_1_A : A ;
  kvantitativ_av_1_A : A ;
  kvav_av_1_A : A ;
  kverulantisk_av_1_A : A ;
  kvick_av_1_A : A ;
  kvinnlig_av_1_A : A ;
  kvinnofientlig_av_1_A : A ;
  kvisslig_av_1_A : A ;
  kvistig_av_1_A : A ;
  kvistloes_av_1_1_A : A ;
  kvitterbar_av_1_A : A ;
  kvittrig_av_1_A : A ;
  kvoterbar_av_1_A : A ;
  kvaellslig_av_1_1_A : A ;
  kvaellstidningsmaessig_av_1_1_A : A ;
  kybernetisk_av_1_A : A ;
  kyffig_av_1_A : A ;
  kylig_av_1_A : A ;
  kylsig_av_1_A : A ;
  kymig_av_1_A : A ;
  kynisk_av_1_A : A ;
  kyrillisk_av_1_A : A ;
  kyrklig_av_1_A : A ;
  kysk_av_1_A : A ;
  kysstaeck_av_1_1_A : A ;
  kaeck_av_1_1_A : A ;
  kaegelformig_av_1_1_A : A ;
  kaelkborgerlig_av_1_1_A : A ;
  kaellsorterbar_av_1_1_A : A ;
  kaempalik_av_1_1_A : A ;
  kaempamaessig_av_1_1_A : A ;
  kaempig_av_1_1_A : A ;
  kaennbar_av_1_1_A : A ;
  kaenslig_av_1_1_A : A ;
  kaenslokall_av_1_1_A : A ;
  kaensloloes_av_1_1_A : A ;
  kaenslomaessig_av_1_1_A : A ;
  kaepprak_av_1_1_A : A ;
  kaer_av_1_1_A : A ;
  kaerleksfull_av_1_1_A : A ;
  kaerlekskrank_av_1_1_A : A ;
  kaerleksloes_av_1_1_A : A ;
  kaerlig_av_1_1_A : A ;
  kaernfrisk_av_1_1_A : A ;
  kaernfull_av_1_1_A : A ;
  kaernvapenmaessig_av_1_1_A : A ;
  kaerv_av_1_1_A : A ;
  kaervaenlig_av_1_1_A : A ;
  kaeraelskelig_av_1_1_A : A ;
  kaeraelsklig_av_1_1_A : A ;
  kaettersk_av_1_1_A : A ;
  kaettjefull_av_1_1_A : A ;
  kaadig_av_1_1_A : A ;
  kaadrik_av_1_1_A : A ;
  koeldbestaendig_av_1_1_A : A ;
  koeldhaerdig_av_1_1_A : A ;
  koenlig_av_1_1_A : A ;
  koenloes_av_1_1_A : A ;
  koensdiskriminerbar_av_1_1_A : A ;
  koenskvoterbar_av_1_1_A : A ;
  koenslig_av_1_1_A : A ;
  koensmaessig_av_1_1_A : A ;
  koepstark_av_1_1_A : A ;
  koerbar_av_1_1_A : A ;
  koerig_av_1_1_A : A ;
  koettig_av_1_1_A : A ;
  koettloes_av_1_1_A : A ;
  koettslig_av_1_1_A : A ;
  labial_av_1_A : A ;
  labialiserbar_av_1_A : A ;
  labil_av_1_A : A ;
  labiodental_av_1_A : A ;
  laborativ_av_1_A : A ;
  laboratoriemaessig_av_1_1_A : A ;
  labyrintisk_av_1_A : A ;
  lackerbar_av_1_A : A ;
  ladylik_av_1_A : A ;
  lafsig_av_1_A : A ;
  lagenlig_av_1_A : A ;
  lagisk_av_1_A : A ;
  lagklok_av_1_A : A ;
  laglig_av_1_A : A ;
  laglydig_av_1_A : A ;
  lagloes_av_1_1_A : A ;
  lagmaessig_av_1_1_A : A ;
  lagom_av_1_A : A ;
  lagstiftningsmaessig_av_1_1_A : A ;
  lagstridig_av_1_A : A ;
  lakonisk_av_1_A : A ;
  lam_av_1_A : A ;
  lamenterbar_av_1_A : A ;
  laminerbar_av_1_A : A ;
  laminaer_av_1_1_A : A ;
  landloes_av_1_1_A : A ;
  landsfaderlig_av_1_A : A ;
  landsflyktig_av_1_A : A ;
  landsfoerraedisk_av_1_1_A : A ;
  landskapsmaessig_av_1_1_A : A ;
  landslagsmaessig_av_1_1_A : A ;
  landsortsmaessig_av_1_1_A : A ;
  langetterbar_av_1_A : A ;
  lankesisk_av_1_A : A ;
  lanserbar_av_1_A : A ;
  lantlig_av_1_A : A ;
  lantmaessig_av_1_1_A : A ;
  laotisk_av_1_A : A ;
  lapidarisk_av_1_A : A ;
  lapiserbar_av_1_A : A ;
  lapplaendsk_av_1_1_A : A ;
  lapsk_av_1_A : A ;
  larvig_av_1_A : A ;
  laryngal_av_1_A : A ;
  lasciv_av_1_A : A ;
  laserbar_av_1_A : A ;
  lastbar_av_1_A : A ;
  lastdryg_av_1_A : A ;
  lastelig_av_1_A : A ;
  lastfull_av_1_A : A ;
  lastklar_av_1_A : A ;
  lateral_av_1_A : A ;
  latin_amerikansk_av_1_A : A ;
  latinamerikansk_av_1_A : A ;
  latiniserbar_av_1_A : A ;
  latinkunnig_av_1_A : A ;
  latinsk_av_1_A : A ;
  laverbar_av_1_A : A ;
  layoutmaessig_av_1_1_A : A ;
  lealoes_av_1_1_A : A ;
  ledarskapsmaessig_av_1_1_A : A ;
  ledig_av_1_A : A ;
  ledningsmaessig_av_1_1_A : A ;
  legal_av_1_A : A ;
  legaliserbar_av_1_A : A ;
  legendarisk_av_1_A : A ;
  legerbar_av_1_A : A ;
  legislativ_av_1_A : A ;
  legitim_av_1_A : A ;
  legitimerbar_av_1_A : A ;
  legaer_av_1_1_A : A ;
  lekamlig_av_1_A : A ;
  lekfull_av_1_A : A ;
  lekfaerdig_av_1_1_A : A ;
  lekmannamaessig_av_1_1_A : A ;
  len_av_1_A : A ;
  leninistisk_av_1_A : A ;
  leproes_av_1_1_A : A ;
  leptosom_av_1_A : A ;
  lerhaltig_av_1_A : A ;
  lerig_av_1_A : A ;
  lesbisk_av_1_A : A ;
  lesothisk_av_1_A : A ;
  letal_av_1_A : A ;
  letargisk_av_1_A : A ;
  lettisk_av_1_A : A ;
  leveransklar_av_1_A : A ;
  leverbrun_av_1_A : A ;
  levererbar_av_1_A : A ;
  lexikal_av_1_A : A ;
  lexikalisk_av_1_A : A ;
  lexikografisk_av_1_A : A ;
  lexikologisk_av_1_A : A ;
  lexikostatistisk_av_1_A : A ;
  libanesisk_av_1_A : A ;
  liberal_av_1_A : A ;
  liberaliserbar_av_1_A : A ;
  liberiansk_av_1_A : A ;
  liberisk_av_1_A : A ;
  libysk_av_1_A : A ;
  licenserbar_av_1_A : A ;
  licensierbar_av_1_A : A ;
  licentierbar_av_1_A : A ;
  lidelsefull_av_1_A : A ;
  liderlig_av_1_A : A ;
  liechtensteinsk_av_1_A : A ;
  lierbar_av_1_A : A ;
  liggriktig_av_1_A : A ;
  liggsjuk_av_1_A : A ;
  ligurisk_av_1_A : A ;
  lik_av_1_A : A ;
  likadan_av_1_A : A ;
  likblek_av_1_A : A ;
  likformig_av_1_A : A ;
  likgiltig_av_1_A : A ;
  liknaemnig_av_1_1_A : A ;
  liksidig_av_1_A : A ;
  likstaellig_av_1_1_A : A ;
  likstaemmig_av_1_1_A : A ;
  liktydig_av_1_A : A ;
  likviderbar_av_1_A : A ;
  likvaerdig_av_1_1_A : A ;
  liljevit_av_1_A : A ;
  limitativ_av_1_A : A ;
  limnisk_av_1_A : A ;
  limnologisk_av_1_A : A ;
  lindrig_av_1_A : A ;
  lineaer_av_1_1_A : A ;
  lingul_av_1_A : A ;
  lingvistisk_av_1_A : A ;
  linhaarig_av_1_1_A : A ;
  linjerbar_av_1_A : A ;
  linjaer_av_1_1_A : A ;
  linvit_av_1_A : A ;
  lipig_av_1_A : A ;
  lisserbar_av_1_A : A ;
  listig_av_1_A : A ;
  litauisk_av_1_A : A ;
  litograferbar_av_1_A : A ;
  litoral_av_1_A : A ;
  litteraturhistorisk_av_1_A : A ;
  litteraer_av_1_1_A : A ;
  liturgisk_av_1_A : A ;
  livaktig_av_1_A : A ;
  livfull_av_1_A : A ;
  livlig_av_1_A : A ;
  livloes_av_1_1_A : A ;
  livsduglig_av_1_A : A ;
  livsfarlig_av_1_A : A ;
  livskraftig_av_1_A : A ;
  livslaang_av_1_1_A : A ;
  livsnoedvaendig_av_1_1_A : A ;
  livsviktig_av_1_A : A ;
  livsvaenlig_av_1_1_A : A ;
  livsaaskaadningsmaessig_av_1_1_A : A ;
  ljudenlig_av_1_A : A ;
  ljudisolerbar_av_1_A : A ;
  ljudlig_av_1_A : A ;
  ljudloes_av_1_1_A : A ;
  ljudmaessig_av_1_1_A : A ;
  ljudsvag_av_1_A : A ;
  ljus_av_1_A : A ;
  ljusbestaendig_av_1_1_A : A ;
  ljusbrun_av_1_A : A ;
  ljusgroen_av_1_1_A : A ;
  ljusgul_av_1_A : A ;
  ljushaarig_av_1_1_A : A ;
  ljuskopierbar_av_1_A : A ;
  ljuskaenslig_av_1_1_A : A ;
  ljuslockig_av_1_A : A ;
  ljusmaessig_av_1_1_A : A ;
  ljusskygg_av_1_A : A ;
  ljusstark_av_1_A : A ;
  ljussvag_av_1_A : A ;
  ljuv_av_1_A : A ;
  ljuvlig_av_1_A : A ;
  lockig_av_1_A : A ;
  lodbar_av_1_A : A ;
  lodraet_av_1_1_A : A ;
  logaritmisk_av_1_A : A ;
  logerbar_av_1_A : A ;
  logisk_av_1_A : A ;
  logografisk_av_1_A : A ;
  logopedisk_av_1_A : A ;
  loj_av_1_A : A ;
  lojal_av_1_A : A ;
  lokal_av_1_A : A ;
  lokaliserbar_av_1_A : A ;
  lokalmaessig_av_1_1_A : A ;
  longitudinal_av_1_A : A ;
  longitudinell_av_1_A : A ;
  lortig_av_1_A : A ;
  lottloes_av_1_1_A : A ;
  lovgirig_av_1_A : A ;
  lovlig_av_1_A : A ;
  luddig_av_1_A : A ;
  luetisk_av_1_A : A ;
  lufsig_av_1_A : A ;
  luftig_av_1_A : A ;
  lufttaet_av_1_1_A : A ;
  luggig_av_1_A : A ;
  lugn_av_1_A : A ;
  lukrativ_av_1_A : A ;
  luktloes_av_1_1_A : A ;
  luktsvag_av_1_A : A ;
  lukullisk_av_1_A : A ;
  lullig_av_1_A : A ;
  lumbal_av_1_A : A ;
  luminoes_av_1_1_A : A ;
  lummig_av_1_A : A ;
  lumpig_av_1_A : A ;
  lunar_av_1_A : A ;
  lunarisk_av_1_A : A ;
  lundensisk_av_1_A : A ;
  lungsiktig_av_1_A : A ;
  lungsjuk_av_1_A : A ;
  lunsig_av_1_A : A ;
  lurig_av_1_A : A ;
  lurvig_av_1_A : A ;
  lusfattig_av_1_A : A ;
  lusig_av_1_A : A ;
  luspank_av_1_A : A ;
  lustelig_av_1_A : A ;
  lustig_av_1_A : A ;
  luteiniserbar_av_1_A : A ;
  luthersk_av_1_A : A ;
  luxemburgsk_av_1_A : A ;
  luxuoes_av_1_1_A : A ;
  lycklig_av_1_A : A ;
  lycksalig_av_1_A : A ;
  lydaktig_av_1_A : A ;
  lydig_av_1_A : A ;
  lymfatisk_av_1_A : A ;
  lymmelaktig_av_1_A : A ;
  lynnig_av_1_A : A ;
  lyrisk_av_1_A : A ;
  lyxig_av_1_A : A ;
  lyxrenoverbar_av_1_A : A ;
  laebbig_av_1_1_A : A ;
  laederbar_av_1_1_A : A ;
  laederbrun_av_1_1_A : A ;
  laeglig_av_1_1_A : A ;
  laemplig_av_1_1_A : A ;
  laengtansfull_av_1_1_A : A ;
  laeraktig_av_1_1_A : A ;
  laerarloes_av_1_1_A : A ;
  laeroboksaktig_av_1_1_A : A ;
  laeroboksmaessig_av_1_1_A : A ;
  laeromaessig_av_1_1_A : A ;
  laerorik_av_1_1_A : A ;
  laesbar_av_1_1_A : A ;
  laeskig_av_1_1_A : A ;
  laeskunnig_av_1_1_A : A ;
  laeslig_av_1_1_A : A ;
  laessvag_av_1_1_A : A ;
  laesvaenlig_av_1_1_A : A ;
  laettantaendlig_av_1_1_A : A ;
  laettbegriplig_av_1_1_A : A ;
  laettfattlig_av_1_1_A : A ;
  laettflyktig_av_1_1_A : A ;
  laettframkomlig_av_1_1_A : A ;
  laettfaerdig_av_1_1_A : A ;
  laettfoerklarlig_av_1_1_A : A ;
  laettfoerstaaelig_av_1_1_A : A ;
  laetthanterlig_av_1_1_A : A ;
  laettillgaenglig_av_1_1_A : A ;
  laettjefull_av_1_1_A : A ;
  laettloeslig_av_1_1_A : A ;
  laettretlig_av_1_1_A : A ;
  laettroerlig_av_1_1_A : A ;
  laettsinnig_av_1_1_A : A ;
  laettviktig_av_1_1_A : A ;
  laettvindig_av_1_1_A : A ;
  laettoeverskaadlig_av_1_1_A : A ;
  laaghjulig_av_1_1_A : A ;
  laagkyrklig_av_1_1_A : A ;
  laagprioriterbar_av_1_1_A : A ;
  laagproduktiv_av_1_1_A : A ;
  laagsvavlig_av_1_1_A : A ;
  laagtysk_av_1_1_A : A ;
  laagvaerdig_av_1_1_A : A ;
  laangfristig_av_1_1_A : A ;
  laanghornig_av_1_1_A : A ;
  laanghaarig_av_1_1_A : A ;
  laangledig_av_1_1_A : A ;
  laanglig_av_1_1_A : A ;
  laangmodig_av_1_1_A : A ;
  laangrandig_av_1_1_A : A ;
  laangsiktig_av_1_1_A : A ;
  laangskallig_av_1_1_A : A ;
  laangsmal_av_1_1_A : A ;
  laangtidsparkerbar_av_1_1_A : A ;
  laangtidssjuk_av_1_1_A : A ;
  laangtradig_av_1_1_A : A ;
  laangtraadig_av_1_1_A : A ;
  laangtraakig_av_1_1_A : A ;
  laangvarig_av_1_1_A : A ;
  laangvaagig_av_1_1_A : A ;
  laasbar_av_1_1_A : A ;
  laatmaessig_av_1_1_A : A ;
  loeddrig_av_1_1_A : A ;
  loedig_av_1_1_A : A ;
  loeftesrik_av_1_1_A : A ;
  loegnaktig_av_1_1_A : A ;
  loejlig_av_1_1_A : A ;
  loekformig_av_1_1_A : A ;
  loekig_av_1_1_A : A ;
  loemsk_av_1_1_A : A ;
  loenemaessig_av_1_1_A : A ;
  loenloes_av_1_1_A : A ;
  loennfet_av_1_1_A : A ;
  loennlig_av_1_1_A : A ;
  loepmaessig_av_1_1_A : A ;
  loepsk_av_1_1_A : A ;
  loes_av_1_1_A : A ;
  loesaktig_av_1_1_A : A ;
  loesbar_av_1_1_A : A ;
  loeslig_av_1_1_A : A ;
  loestagbar_av_1_1_A : A ;
  loevrik_av_1_1_A : A ;
  macedonisk_av_1_A : A ;
  macedonsk_av_1_A : A ;
  machiavellisk_av_1_A : A ;
  machiavellistisk_av_1_A : A ;
  madagaskisk_av_1_A : A ;
  madrasserbar_av_1_A : A ;
  maffiamaessig_av_1_1_A : A ;
  maffig_av_1_A : A ;
  magasinerbar_av_1_A : A ;
  magisk_av_1_A : A ;
  magistral_av_1_A : A ;
  magnetiserbar_av_1_A : A ;
  magnetisk_av_1_A : A ;
  magnifik_av_1_A : A ;
  magstark_av_1_A : A ;
  magsur_av_1_A : A ;
  majestaetisk_av_1_1_A : A ;
  majestaetlig_av_1_1_A : A ;
  makaloes_av_1_1_A : A ;
  makedonisk_av_1_A : A ;
  makedonsk_av_1_A : A ;
  maklig_av_1_A : A ;
  makroskopisk_av_1_A : A ;
  maktfullkomlig_av_1_A : A ;
  maktloes_av_1_1_A : A ;
  maktmaessig_av_1_1_A : A ;
  makulerbar_av_1_A : A ;
  malajisk_av_1_A : A ;
  malawisk_av_1_A : A ;
  malaysisk_av_1_A : A ;
  maldivisk_av_1_A : A ;
  malfoberbar_av_1_A : A ;
  malicioes_av_1_1_A : A ;
  malign_av_1_A : A ;
  malisk_av_1_A : A ;
  mallig_av_1_A : A ;
  malmfyndig_av_1_A : A ;
  maltesisk_av_1_A : A ;
  maltraeterbar_av_1_1_A : A ;
  mammaledig_av_1_A : A ;
  mammig_av_1_A : A ;
  manbar_av_1_A : A ;
  manchuisk_av_1_A : A ;
  mandelgroen_av_1_1_A : A ;
  manhaftig_av_1_A : A ;
  maniakalisk_av_1_A : A ;
  manifesterbar_av_1_A : A ;
  manikurerbar_av_1_A : A ;
  manikyrerbar_av_1_A : A ;
  manipulerbar_av_1_A : A ;
  manisk_depressiv_av_1_A : A ;
  manisk_av_1_A : A ;
  manlig_av_1_A : A ;
  manodepressiv_av_1_A : A ;
  manstark_av_1_A : A ;
  manuell_av_1_A : A ;
  manoeverduglig_av_1_1_A : A ;
  manoevrerbar_av_1_1_A : A ;
  maorisk_av_1_A : A ;
  mardroemslik_av_1_1_A : A ;
  margfaldig_av_1_A : A ;
  marginaliserbar_av_1_A : A ;
  marginell_av_1_A : A ;
  marig_av_1_A : A ;
  marin_av_1_A : A ;
  marinbiologisk_av_1_A : A ;
  marinerbar_av_1_A : A ;
  maritim_av_1_A : A ;
  markerbar_av_1_A : A ;
  marknadsekonomisk_av_1_A : A ;
  marknadsfoeringsmaessig_av_1_1_A : A ;
  marknadskapitalistisk_av_1_A : A ;
  marknadsmaessig_av_1_1_A : A ;
  marknadsvaerderbar_av_1_1_A : A ;
  marmorerbar_av_1_A : A ;
  marockansk_av_1_A : A ;
  marscherbar_av_1_A : A ;
  marterbar_av_1_A : A ;
  martialisk_av_1_A : A ;
  marxistisk_av_1_A : A ;
  masig_av_1_A : A ;
  maskerbar_av_1_A : A ;
  maskformig_av_1_A : A ;
  maskinell_av_1_A : A ;
  maskinlaesbar_av_1_1_A : A ;
  maskinmaessig_av_1_1_A : A ;
  maskulin_av_1_A : A ;
  maskuliniserbar_av_1_A : A ;
  massakrerbar_av_1_A : A ;
  masserbar_av_1_A : A ;
  massiv_av_1_A : A ;
  massloes_av_1_1_A : A ;
  massmedial_av_1_A : A ;
  mastig_av_1_A : A ;
  mastodontisk_av_1_A : A ;
  matelasserbar_av_1_A : A ;
  matematisk_naturvetenskaplig_av_1_A : A ;
  matematisk_av_1_A : A ;
  materialiserbar_av_1_A : A ;
  materialistisk_av_1_A : A ;
  materialmaessig_av_1_1_A : A ;
  materiell_av_1_A : A ;
  matfrisk_av_1_A : A ;
  matig_av_1_A : A ;
  matmaessig_av_1_1_A : A ;
  matnyttig_av_1_A : A ;
  matriarkal_av_1_A : A ;
  matriarkalisk_av_1_A : A ;
  matterbar_av_1_A : A ;
  mauretansk_av_1_A : A ;
  mauritisk_av_1_A : A ;
  maximal_av_1_A : A ;
  maximerbar_av_1_A : A ;
  medaljerbar_av_1_A : A ;
  medaljmaessig_av_1_1_A : A ;
  medansvarig_av_1_A : A ;
  medborgerlig_av_1_A : A ;
  medbrottslig_av_1_A : A ;
  meddelaktig_av_1_A : A ;
  medelbar_av_1_A : A ;
  medelindisk_av_1_A : A ;
  medelloes_av_1_1_A : A ;
  medelmaattig_av_1_1_A : A ;
  medelpadsk_av_1_A : A ;
  medeltidsmaessig_av_1_1_A : A ;
  medgoerlig_av_1_1_A : A ;
  medial_av_1_A : A ;
  mediamaessig_av_1_1_A : A ;
  medicinerbar_av_1_A : A ;
  medicinsk_av_1_A : A ;
  mediekritisk_av_1_A : A ;
  mediemaessig_av_1_1_A : A ;
  meditativ_av_1_A : A ;
  mediterran_av_1_A : A ;
  medlemsantalsmaessig_av_1_1_A : A ;
  medlemsmaessig_av_1_1_A : A ;
  medmaensklig_av_1_1_A : A ;
  medskyldig_av_1_A : A ;
  medvetsloes_av_1_1_A : A ;
  mefistofelisk_av_1_A : A ;
  mefitisk_av_1_A : A ;
  mekaniserbar_av_1_A : A ;
  mekanisk_av_1_A : A ;
  mekanistisk_av_1_A : A ;
  mekvaenlig_av_1_1_A : A ;
  melanesisk_av_1_A : A ;
  melankolisk_av_1_A : A ;
  mellanfolklig_av_1_A : A ;
  mellankommunal_av_1_A : A ;
  mellanstatlig_av_1_A : A ;
  mellansvensk_av_1_A : A ;
  melodisk_av_1_A : A ;
  melodioes_av_1_1_A : A ;
  melodramatisk_av_1_A : A ;
  memorerbar_av_1_A : A ;
  mendelistisk_av_1_A : A ;
  mendelsk_av_1_A : A ;
  menig_av_1_A : A ;
  meningsfull_av_1_A : A ;
  meningsloes_av_1_1_A : A ;
  menlig_av_1_A : A ;
  menloes_av_1_1_A : A ;
  mental_av_1_A : A ;
  mentalsjuk_av_1_A : A ;
  merceriserbar_av_1_A : A ;
  meriterbar_av_1_A : A ;
  meritmaessig_av_1_1_A : A ;
  merkantil_av_1_A : A ;
  mesaktig_av_1_A : A ;
  mesig_av_1_A : A ;
  mesopotamisk_av_1_A : A ;
  mesozoisk_av_1_A : A ;
  messiansk_av_1_A : A ;
  metaforisk_av_1_A : A ;
  metafysisk_av_1_A : A ;
  metalliserbar_av_1_A : A ;
  metallisk_av_1_A : A ;
  metallografisk_av_1_A : A ;
  metallurgisk_av_1_A : A ;
  metamorf_av_1_A : A ;
  metastatisk_av_1_A : A ;
  meteorologisk_av_1_A : A ;
  metertjock_av_1_A : A ;
  metodisk_av_1_A : A ;
  metodmaessig_av_1_1_A : A ;
  metodologisk_av_1_A : A ;
  metrisk_av_1_A : A ;
  metrologisk_av_1_A : A ;
  mexikansk_av_1_A : A ;
  mikrobiologisk_av_1_A : A ;
  mikrofotograferbar_av_1_A : A ;
  mikronesisk_av_1_A : A ;
  mikroskoperbar_av_1_A : A ;
  mikroskopisk_av_1_A : A ;
  milanesisk_av_1_A : A ;
  militariserbar_av_1_A : A ;
  militaristisk_av_1_A : A ;
  militaer_av_1_1_A : A ;
  militaerisk_av_1_1_A : A ;
  miljoefarlig_av_1_1_A : A ;
  miljoeliberal_av_1_1_A : A ;
  miljoemaessig_av_1_1_A : A ;
  miljoevaenlig_av_1_1_A : A ;
  millimetertjock_av_1_A : A ;
  mimisk_av_1_A : A ;
  mindervaerdig_av_1_1_A : A ;
  minderaarig_av_1_1_A : A ;
  mineralhaltig_av_1_A : A ;
  mineraliserbar_av_1_A : A ;
  mineralogisk_av_1_A : A ;
  minerbar_av_1_A : A ;
  miniatyriserbar_av_1_A : A ;
  miniatyrmaessig_av_1_1_A : A ;
  minimal_av_1_A : A ;
  minimerbar_av_1_A : A ;
  ministeriell_av_1_A : A ;
  minnesloes_av_1_1_A : A ;
  minnesrik_av_1_A : A ;
  minnig_av_1_A : A ;
  minoisk_av_1_A : A ;
  minsk_av_1_A : A ;
  minutioes_av_1_1_A : A ;
  minutlig_av_1_A : A ;
  mirakuloes_av_1_1_A : A ;
  misantropisk_av_1_A : A ;
  misshaglig_av_1_A : A ;
  missiverbar_av_1_A : A ;
  misskrediterbar_av_1_A : A ;
  missmodig_av_1_A : A ;
  mistig_av_1_A : A ;
  mistlig_av_1_A : A ;
  mjuk_av_1_A : A ;
  mjaekig_av_1_1_A : A ;
  mjaell_av_1_1_A : A ;
  mjaellig_av_1_1_A : A ;
  mjaeltsjuk_av_1_1_A : A ;
  mjoelig_av_1_1_A : A ;
  mjoelkig_av_1_1_A : A ;
  mjoelkvit_av_1_1_A : A ;
  mnemoteknisk_av_1_A : A ;
  mobil_av_1_A : A ;
  mobiliserbar_av_1_A : A ;
  mocambikisk_av_1_A : A ;
  modal_av_1_A : A ;
  modellerbar_av_1_A : A ;
  modemaessig_av_1_1_A : A ;
  modererbar_av_1_A : A ;
  moderiktig_av_1_A : A ;
  moderlig_av_1_A : A ;
  modern_av_1_A : A ;
  moderniserbar_av_1_A : A ;
  modernistisk_av_1_A : A ;
  modifierbar_av_1_A : A ;
  modig_av_1_A : A ;
  modloes_av_1_1_A : A ;
  modulerbar_av_1_A : A ;
  modaern_av_1_1_A : A ;
  modaerniserbar_av_1_1_A : A ;
  mohammedansk_av_1_A : A ;
  moj_av_1_A : A ;
  moldavisk_av_1_A : A ;
  molekylaer_av_1_1_A : A ;
  molnig_av_1_A : A ;
  momentan_av_1_A : A ;
  monarkisk_av_1_A : A ;
  mondial_av_1_A : A ;
  mondaen_av_1_1_A : A ;
  monegaskisk_av_1_A : A ;
  monetaer_av_1_1_A : A ;
  mongolisk_av_1_A : A ;
  monoftongerbar_av_1_A : A ;
  monogam_av_1_A : A ;
  monoklin_av_1_A : A ;
  monokrom_av_1_A : A ;
  monokromatisk_av_1_A : A ;
  monolitisk_av_1_A : A ;
  monoman_av_1_A : A ;
  monopoliserbar_av_1_A : A ;
  monopolkapitalistisk_av_1_A : A ;
  monosyllabisk_av_1_A : A ;
  monoton_av_1_A : A ;
  monstruoes_av_1_1_A : A ;
  montenegrinsk_av_1_A : A ;
  monterbar_av_1_A : A ;
  monteringsfaerdig_av_1_1_A : A ;
  monumental_av_1_A : A ;
  mopsig_av_1_A : A ;
  moralisk_av_1_A : A ;
  mordisk_av_1_A : A ;
  morfologisk_av_1_A : A ;
  morganatisk_av_1_A : A ;
  morgonpigg_av_1_A : A ;
  morisk_av_1_A : A ;
  mormonsk_av_1_A : A ;
  morserbar_av_1_A : A ;
  morsk_av_1_A : A ;
  mortificerbar_av_1_A : A ;
  mortifierbar_av_1_A : A ;
  mosaisk_av_1_A : A ;
  mosig_av_1_A : A ;
  moskovitisk_av_1_A : A ;
  mossgroen_av_1_1_A : A ;
  mossig_av_1_A : A ;
  mosterlig_av_1_A : A ;
  motig_av_1_A : A ;
  motivationsmaessig_av_1_1_A : A ;
  motiverbar_av_1_A : A ;
  motivisk_av_1_A : A ;
  motivmaessig_av_1_1_A : A ;
  motoriserbar_av_1_A : A ;
  motorisk_av_1_A : A ;
  motorvaegsmaessig_av_1_1_A : A ;
  motspaenstig_av_1_1_A : A ;
  motstridig_av_1_A : A ;
  motstraevig_av_1_1_A : A ;
  motstaandskraftig_av_1_1_A : A ;
  motstaandsloes_av_1_1_A : A ;
  motsaegelsefull_av_1_1_A : A ;
  motsaegelseloes_av_1_1_A : A ;
  motsaettlig_av_1_1_A : A ;
  mottaglig_av_1_A : A ;
  motvillig_av_1_A : A ;
  mocambikisk_av_1_1_A : A ;
  muddrig_av_1_A : A ;
  muhammedansk_av_1_A : A ;
  muljerbar_av_1_A : A ;
  mullig_av_1_A : A ;
  mullrik_av_1_A : A ;
  multikulturell_av_1_A : A ;
  multilateral_av_1_A : A ;
  multinationell_av_1_A : A ;
  multiplicerbar_av_1_A : A ;
  mumifierbar_av_1_A : A ;
  mumsig_av_1_A : A ;
  munartlig_av_1_A : A ;
  municipal_av_1_A : A ;
  muntlig_av_1_A : A ;
  munvig_av_1_A : A ;
  muppig_av_1_A : A ;
  mural_av_1_A : A ;
  murrig_av_1_A : A ;
  museal_av_1_A : A ;
  museimaessig_av_1_1_A : A ;
  muselmansk_av_1_A : A ;
  musikal_av_1_A : A ;
  musikalisk_av_1_A : A ;
  musikmaessig_av_1_1_A : A ;
  musisk_av_1_A : A ;
  muskelstark_av_1_A : A ;
  muskuloes_av_1_1_A : A ;
  muslimsk_av_1_A : A ;
  mustig_av_1_A : A ;
  muterbar_av_1_A : A ;
  mykologisk_av_1_A : A ;
  myllig_av_1_A : A ;
  myndig_av_1_A : A ;
  myopisk_av_1_A : A ;
  mysig_av_1_A : A ;
  mysterioes_av_1_1_A : A ;
  mystifierbar_av_1_A : A ;
  mystifik_av_1_A : A ;
  mystisk_av_1_A : A ;
  mytisk_av_1_A : A ;
  mytologisk_av_1_A : A ;
  maektig_av_1_1_A : A ;
  maenniskofientlig_av_1_1_A : A ;
  maenniskolik_av_1_1_A : A ;
  maenniskovaenlig_av_1_1_A : A ;
  maenniskovaerdig_av_1_1_A : A ;
  maensklig_av_1_1_A : A ;
  maergfull_av_1_1_A : A ;
  maerglig_av_1_1_A : A ;
  maergloes_av_1_1_A : A ;
  maerkbar_av_1_1_A : A ;
  maerklig_av_1_1_A : A ;
  maerkvaerdig_av_1_1_A : A ;
  maesterlig_av_1_1_A : A ;
  maetbar_av_1_1_A : A ;
  maetmaessig_av_1_1_A : A ;
  maalerisk_av_1_1_A : A ;
  maalfarlig_av_1_1_A : A ;
  maalloes_av_1_1_A : A ;
  maalmaessig_av_1_1_A : A ;
  maan_av_1_1_A : A ;
  maanatlig_av_1_1_A : A ;
  maangfaldig_av_1_1_A : A ;
  maangformig_av_1_1_A : A ;
  maangkulturell_av_1_1_A : A ;
  maangkunnig_av_1_1_A : A ;
  maangordig_av_1_1_A : A ;
  maangsidig_av_1_1_A : A ;
  maangspraakig_av_1_1_A : A ;
  maangstavig_av_1_1_A : A ;
  maangstaemmig_av_1_1_A : A ;
  maangtydig_av_1_1_A : A ;
  maangvetenskaplig_av_1_1_A : A ;
  maanljus_av_1_1_A : A ;
  maattfull_av_1_1_A : A ;
  maattlig_av_1_1_A : A ;
  maattloes_av_1_1_A : A ;
  moeblerbar_av_1_1_A : A ;
  moeglig_av_1_1_A : A ;
  moejlig_av_1_1_A : A ;
  moenstergill_av_1_1_A : A ;
  moer_av_1_1_A : A ;
  moerjig_av_1_1_A : A ;
  moerk_av_1_1_A : A ;
  moerkbrun_av_1_1_A : A ;
  moerkgroen_av_1_1_A : A ;
  moerkgul_av_1_1_A : A ;
  moerkhaarig_av_1_1_A : A ;
  moerklockig_av_1_1_A : A ;
  nackstyv_av_1_A : A ;
  naiv_av_1_A : A ;
  naivistisk_av_1_A : A ;
  nakenfroeig_av_1_1_A : A ;
  namibisk_av_1_A : A ;
  namnkunnig_av_1_A : A ;
  namnloes_av_1_1_A : A ;
  namnmaessig_av_1_1_A : A ;
  napolitansk_av_1_A : A ;
  narig_av_1_A : A ;
  narkotisk_av_1_A : A ;
  narraktig_av_1_A : A ;
  narrativ_av_1_A : A ;
  nasal_av_1_A : A ;
  nasalerbar_av_1_A : A ;
  nasaliserbar_av_1_A : A ;
  nationalekonomisk_av_1_A : A ;
  nationaliserbar_av_1_A : A ;
  nationalistisk_av_1_A : A ;
  nationalromantisk_av_1_A : A ;
  nationalsocialistisk_av_1_A : A ;
  nationell_av_1_A : A ;
  nativ_av_1_A : A ;
  nattaktiv_av_1_A : A ;
  nattlig_av_1_A : A ;
  nattlik_av_1_A : A ;
  naturaliserbar_av_1_A : A ;
  naturalistisk_av_1_A : A ;
  naturell_av_1_A : A ;
  naturenlig_av_1_A : A ;
  naturhistorisk_av_1_A : A ;
  naturlig_av_1_A : A ;
  naturmaessig_av_1_1_A : A ;
  naturnoedvaendig_av_1_1_A : A ;
  naturskoen_av_1_1_A : A ;
  naturstridig_av_1_A : A ;
  naturvetenskaplig_av_1_A : A ;
  naturvidrig_av_1_A : A ;
  naurisk_av_1_A : A ;
  nautisk_av_1_A : A ;
  navalmedicinsk_av_1_A : A ;
  navigerbar_av_1_A : A ;
  nazistisk_av_1_A : A ;
  neapolitansk_av_1_A : A ;
  nebuloes_av_1_1_A : A ;
  nederlaendsk_av_1_1_A : A ;
  nedmoerk_av_1_1_A : A ;
  nedrig_av_1_A : A ;
  nedtransformerbar_av_1_A : A ;
  nedtransponerbar_av_1_A : A ;
  nedvaerderbar_av_1_1_A : A ;
  nefritisk_av_1_A : A ;
  negativ_av_1_A : A ;
  negerbar_av_1_A : A ;
  negligerbar_av_1_A : A ;
  negocierbar_av_1_A : A ;
  negotierbar_av_1_A : A ;
  neokolonialistisk_av_1_A : A ;
  neolitisk_av_1_A : A ;
  neotektonisk_av_1_A : A ;
  nepalesisk_av_1_A : A ;
  neptunisk_av_1_A : A ;
  nermoerk_av_1_1_A : A ;
  nertransformerbar_av_1_A : A ;
  nertransponerbar_av_1_A : A ;
  nervig_av_1_A : A ;
  nervaerderbar_av_1_1_A : A ;
  nervoes_av_1_1_A : A ;
  neslig_av_1_A : A ;
  nestoriansk_av_1_A : A ;
  neuralgisk_av_1_A : A ;
  neurologisk_av_1_A : A ;
  neurotisk_av_1_A : A ;
  neutral_av_1_A : A ;
  neutraliserbar_av_1_A : A ;
  neutralistisk_av_1_A : A ;
  newfoundlaendsk_av_1_1_A : A ;
  nicaraguansk_av_1_A : A ;
  nidsk_av_1_A : A ;
  niellerbar_av_1_A : A ;
  nigeriansk_av_1_A : A ;
  nigerisk_av_1_A : A ;
  nihilistisk_av_1_A : A ;
  nikotingul_av_1_A : A ;
  nipig_av_1_A : A ;
  nipprig_av_1_A : A ;
  nitfull_av_1_A : A ;
  nitisk_av_1_A : A ;
  nitrerbar_av_1_A : A ;
  nitroes_av_1_1_A : A ;
  nittiofemoktanig_av_1_A : A ;
  nittiosexprocentig_av_1_A : A ;
  nittisexprocentig_av_1_A : A ;
  nivellerbar_av_1_A : A ;
  nivaagrupperbar_av_1_1_A : A ;
  njugg_av_1_A : A ;
  njutbar_av_1_A : A ;
  njutningsfull_av_1_A : A ;
  njutningsmaessig_av_1_1_A : A ;
  njutningsrik_av_1_A : A ;
  nobiliserbar_av_1_A : A ;
  nojig_av_1_A : A ;
  noltig_av_1_A : A ;
  nomadisk_av_1_A : A ;
  nominal_av_1_A : A ;
  nominalistisk_av_1_A : A ;
  nominell_av_1_A : A ;
  nominerbar_av_1_A : A ;
  nonchalerbar_av_1_A : A ;
  nonfigurativ_av_1_A : A ;
  noppig_av_1_A : A ;
  nopprig_av_1_A : A ;
  nord_sydlig_av_1_A : A ;
  nordafrikansk_av_1_A : A ;
  nordamerikansk_av_1_A : A ;
  nordisk_av_1_A : A ;
  nordkoreansk_av_1_A : A ;
  nordlig_av_1_A : A ;
  nordtysk_av_1_A : A ;
  nordvietnamesisk_av_1_A : A ;
  normal_av_1_A : A ;
  normaliserbar_av_1_A : A ;
  normalspaarig_av_1_1_A : A ;
  normandisk_av_1_A : A ;
  normativ_av_1_A : A ;
  normerbar_av_1_A : A ;
  normloes_av_1_1_A : A ;
  norrbottnisk_av_1_A : A ;
  norrlaendsk_av_1_1_A : A ;
  norroen_av_1_1_A : A ;
  norsk_av_1_A : A ;
  nosig_av_1_A : A ;
  noskig_av_1_A : A ;
  nostalgisk_av_1_A : A ;
  noterbar_av_1_A : A ;
  notificerbar_av_1_A : A ;
  notifierbar_av_1_A : A ;
  notiserbar_av_1_A : A ;
  notorisk_av_1_A : A ;
  novantik_av_1_A : A ;
  novellistisk_av_1_A : A ;
  nubisk_av_1_A : A ;
  nuckig_av_1_A : A ;
  nudistisk_av_1_A : A ;
  nukleaer_av_1_1_A : A ;
  numerisk_av_1_A : A ;
  numeraer_av_1_1_A : A ;
  numinoes_av_1_1_A : A ;
  numismatisk_av_1_A : A ;
  numrerbar_av_1_A : A ;
  nuspraaklig_av_1_1_A : A ;
  nusvensk_av_1_A : A ;
  nutritiv_av_1_A : A ;
  nuvig_av_1_A : A ;
  nyanserbar_av_1_A : A ;
  nyansloes_av_1_1_A : A ;
  nyantik_av_1_A : A ;
  nyckelfaerdig_av_1_1_A : A ;
  nyckfull_av_1_A : A ;
  nyemitterbar_av_1_A : A ;
  nyetablerbar_av_1_A : A ;
  nyhetsmaessig_av_1_1_A : A ;
  nyinvesterbar_av_1_A : A ;
  nyklassicistisk_av_1_A : A ;
  nyklassisk_av_1_A : A ;
  nyliberal_av_1_A : A ;
  nylaendsk_av_1_1_A : A ;
  nymodig_av_1_A : A ;
  nynorsk_av_1_A : A ;
  nyplanterbar_av_1_A : A ;
  nyplatonsk_av_1_A : A ;
  nyrik_av_1_A : A ;
  nysvensk_av_1_A : A ;
  nytestamentlig_av_1_A : A ;
  nyttig_av_1_A : A ;
  nyzeelaendsk_av_1_1_A : A ;
  naebbig_av_1_1_A : A ;
  naemnbar_av_1_1_A : A ;
  naerig_av_1_1_A : A ;
  naeringsfattig_av_1_1_A : A ;
  naeringsfysiologisk_av_1_1_A : A ;
  naeringslivsmaessig_av_1_1_A : A ;
  naeringsmaessig_av_1_1_A : A ;
  naeringsrik_av_1_1_A : A ;
  naerkingsk_av_1_1_A : A ;
  naesvis_av_1_1_A : A ;
  naetformig_av_1_1_A : A ;
  naetvan_av_1_1_A : A ;
  naadelig_av_1_1_A : A ;
  naadig_av_1_1_A : A ;
  naalfin_av_1_1_A : A ;
  noedig_av_1_1_A : A ;
  noedtorftig_av_1_1_A : A ;
  noedvaendig_av_1_1_A : A ;
  noejaktig_av_1_1_A : A ;
  noerdig_av_1_1_A : A ;
  noetbrun_av_1_1_A : A ;
  noetningsbestaendig_av_1_1_A : A ;
  noetningsresistent_av_1_1_A : A ;
  oabbrevierbar_av_1_A : A ;
  oabdikerbar_av_1_A : A ;
  oabonnerbar_av_1_A : A ;
  oaborterbar_av_1_A : A ;
  oabraderbar_av_1_A : A ;
  oabsolverbar_av_1_A : A ;
  oabsorberbar_av_1_A : A ;
  oabstraherbar_av_1_A : A ;
  oaccederbar_av_1_A : A ;
  oaccelererbar_av_1_A : A ;
  oaccentuerbar_av_1_A : A ;
  oaccepterbar_av_1_A : A ;
  oacklimatiserbar_av_1_A : A ;
  oackommoderbar_av_1_A : A ;
  oackompanjerbar_av_1_A : A ;
  oackorderbar_av_1_A : A ;
  oackrediterbar_av_1_A : A ;
  oackumulerbar_av_1_A : A ;
  oackvirerbar_av_1_A : A ;
  oadapterbar_av_1_A : A ;
  oadderbar_av_1_A : A ;
  oadjungerbar_av_1_A : A ;
  oadministrerbar_av_1_A : A ;
  oadopterbar_av_1_A : A ;
  oadresserbar_av_1_A : A ;
  oadsorberbar_av_1_A : A ;
  oaducerbar_av_1_A : A ;
  oadvocerbar_av_1_A : A ;
  oafficierbar_av_1_A : A ;
  oaffinerbar_av_1_A : A ;
  oaffischerbar_av_1_A : A ;
  oafrikaniserbar_av_1_A : A ;
  oagerbar_av_1_A : A ;
  oagglomererbar_av_1_A : A ;
  oagglutinerbar_av_1_A : A ;
  oagiterbar_av_1_A : A ;
  oajournerbar_av_1_A : A ;
  oaktiverbar_av_1_A : A ;
  oaktualiserbar_av_1_A : A ;
  oalarmerbar_av_1_A : A ;
  oalfabetiserbar_av_1_A : A ;
  oalienerbar_av_1_A : A ;
  oallegoriserbar_av_1_A : A ;
  oallierbar_av_1_A : A ;
  oallittererbar_av_1_A : A ;
  oallokerbar_av_1_A : A ;
  oalluderbar_av_1_A : A ;
  oalternerbar_av_1_A : A ;
  oaluminerbar_av_1_A : A ;
  oamalgamerbar_av_1_A : A ;
  oambulerbar_av_1_A : A ;
  oamerikaniserbar_av_1_A : A ;
  oamerikansk_av_1_A : A ;
  oamorterbar_av_1_A : A ;
  oamplifierbar_av_1_A : A ;
  oamputerbar_av_1_A : A ;
  oanalyserbar_av_1_A : A ;
  oandlig_av_1_A : A ;
  oanfaektbar_av_1_1_A : A ;
  oanfaektlig_av_1_1_A : A ;
  oangenaem_av_1_1_A : A ;
  oangliserbar_av_1_A : A ;
  oangripbar_av_1_A : A ;
  oangriplig_av_1_A : A ;
  oanimerbar_av_1_A : A ;
  oannekterbar_av_1_A : A ;
  oannihilerbar_av_1_A : A ;
  oannonserbar_av_1_A : A ;
  oannoterbar_av_1_A : A ;
  oannullerbar_av_1_A : A ;
  oanodiserbar_av_1_A : A ;
  oanonymiserbar_av_1_A : A ;
  oansenlig_av_1_A : A ;
  oanstaendig_av_1_1_A : A ;
  oansvarig_av_1_A : A ;
  oantagbar_av_1_A : A ;
  oantaglig_av_1_A : A ;
  oantastbar_av_1_A : A ;
  oantastlig_av_1_A : A ;
  oanteciperbar_av_1_A : A ;
  oantedaterbar_av_1_A : A ;
  oantichambrerbar_av_1_A : A ;
  oantikiserbar_av_1_A : A ;
  oantraeffbar_av_1_1_A : A ;
  oanvaendbar_av_1_1_A : A ;
  oapostroferbar_av_1_A : A ;
  oappellerbar_av_1_A : A ;
  oapplicerbar_av_1_A : A ;
  oapplaaderbar_av_1_1_A : A ;
  oapporterbar_av_1_A : A ;
  oapprecierbar_av_1_A : A ;
  oappreterbar_av_1_A : A ;
  oapprocherbar_av_1_A : A ;
  oapproximerbar_av_1_A : A ;
  oapterbar_av_1_A : A ;
  oaptitlig_av_1_A : A ;
  oargumenterbar_av_1_A : A ;
  oarkaiserbar_av_1_A : A ;
  oarkebuserbar_av_1_A : A ;
  oarkiverbar_av_1_A : A ;
  oarmerbar_av_1_A : A ;
  oarrangerbar_av_1_A : A ;
  oarrenderbar_av_1_A : A ;
  oarresterbar_av_1_A : A ;
  oarronderbar_av_1_A : A ;
  oartig_av_1_A : A ;
  oartikulerbar_av_1_A : A ;
  oarvoderbar_av_1_A : A ;
  oasfalterbar_av_1_A : A ;
  oaspirerbar_av_1_A : A ;
  oassignerbar_av_1_A : A ;
  oassimilerbar_av_1_A : A ;
  oassisterbar_av_1_A : A ;
  oassocierbar_av_1_A : A ;
  oassurerbar_av_1_A : A ;
  oatrofierbar_av_1_A : A ;
  oattackerbar_av_1_A : A ;
  oattesterbar_av_1_A : A ;
  oattraherbar_av_1_A : A ;
  oattrapperbar_av_1_A : A ;
  oattribuerbar_av_1_A : A ;
  oauktionerbar_av_1_A : A ;
  oauktoriserbar_av_1_A : A ;
  oauskulterbar_av_1_A : A ;
  oautenticerbar_av_1_A : A ;
  oautentifierbar_av_1_A : A ;
  oautentiserbar_av_1_A : A ;
  oautomatiserbar_av_1_A : A ;
  oavancerbar_av_1_A : A ;
  oavannonserbar_av_1_A : A ;
  oavdramatiserbar_av_1_A : A ;
  oavhaengig_av_1_1_A : A ;
  oaviserbar_av_1_A : A ;
  oavkoloniserbar_av_1_A : A ;
  oavkriminaliserbar_av_1_A : A ;
  oavlaatlig_av_1_1_A : A ;
  oavmagnetiserbar_av_1_A : A ;
  oavmystifierbar_av_1_A : A ;
  oavnazifierbar_av_1_A : A ;
  oavpatrullerbar_av_1_A : A ;
  oavpolitiserbar_av_1_A : A ;
  oavpolletterbar_av_1_A : A ;
  oavportraetterbar_av_1_1_A : A ;
  oavreagerbar_av_1_A : A ;
  oavregistrerbar_av_1_A : A ;
  oavreglerbar_av_1_A : A ;
  oavromantiserbar_av_1_A : A ;
  oavsiktlig_av_1_A : A ;
  oavsocialiserbar_av_1_A : A ;
  oavstaliniserbar_av_1_A : A ;
  oavsaettlig_av_1_1_A : A ;
  oavvisbar_av_1_A : A ;
  oavvislig_av_1_A : A ;
  oavytterlig_av_1_A : A ;
  oaxiomatiserbar_av_1_A : A ;
  obagatelliserbar_av_1_A : A ;
  obalanserbar_av_1_A : A ;
  oballoterbar_av_1_A : A ;
  obalsamerbar_av_1_A : A ;
  obanaliserbar_av_1_A : A ;
  obankrutterbar_av_1_A : A ;
  obarmhaertig_av_1_1_A : A ;
  obarrikaderbar_av_1_A : A ;
  obaserbar_av_1_A : A ;
  obducerbar_av_1_A : A ;
  obeatifierbar_av_1_A : A ;
  obeboelig_av_1_A : A ;
  obefintlig_av_1_A : A ;
  obegriplig_av_1_A : A ;
  obehaglig_av_1_A : A ;
  obehoerig_av_1_1_A : A ;
  obehoevlig_av_1_1_A : A ;
  obekvaem_av_1_1_A : A ;
  oberaeknelig_av_1_1_A : A ;
  oberoerbar_av_1_1_A : A ;
  obeskrivbar_av_1_A : A ;
  obeskrivlig_av_1_A : A ;
  obesticklig_av_1_A : A ;
  obestridlig_av_1_A : A ;
  obestaellbar_av_1_1_A : A ;
  obestaembar_av_1_1_A : A ;
  obestaendig_av_1_1_A : A ;
  obetalbar_av_1_A : A ;
  obetongerbar_av_1_A : A ;
  obetvinglig_av_1_A : A ;
  obetydlig_av_1_A : A ;
  obeveklig_av_1_A : A ;
  obildbar_av_1_A : A ;
  obillig_av_1_A : A ;
  obiograferbar_av_1_A : A ;
  obisserbar_av_1_A : A ;
  obivackerbar_av_1_A : A ;
  objektiv_av_1_A : A ;
  objektiverbar_av_1_A : A ;
  oblancherbar_av_1_A : A ;
  oblankpolerbar_av_1_A : A ;
  oblesserbar_av_1_A : A ;
  oblidkelig_av_1_A : A ;
  obligatorisk_av_1_A : A ;
  obligerbar_av_1_A : A ;
  oblik_av_1_A : A ;
  oblinderbar_av_1_A : A ;
  oblockerbar_av_1_A : A ;
  oblodig_av_1_A : A ;
  oblommograferbar_av_1_A : A ;
  oblonderbar_av_1_A : A ;
  oblyg_av_1_A : A ;
  oboaserbar_av_1_A : A ;
  obogserbar_av_1_A : A ;
  obokstaverbar_av_1_A : A ;
  obombarderbar_av_1_A : A ;
  oboniterbar_av_1_A : A ;
  obortresonerbar_av_1_A : A ;
  obotfaerdig_av_1_1_A : A ;
  obotlig_av_1_A : A ;
  obriketterbar_av_1_A : A ;
  obriserbar_av_1_A : A ;
  obroderbar_av_1_A : A ;
  obromerbar_av_1_A : A ;
  obronserbar_av_1_A : A ;
  obroscherbar_av_1_A : A ;
  obrottslig_av_1_A : A ;
  obrukbar_av_1_A : A ;
  obruklig_av_1_A : A ;
  obrunerbar_av_1_A : A ;
  obrutaliserbar_av_1_A : A ;
  obrytbar_av_1_A : A ;
  obraeserbar_av_1_1_A : A ;
  observerbar_av_1_A : A ;
  obskur_av_1_A : A ;
  obskyr_av_1_A : A ;
  obstetrisk_av_1_A : A ;
  obudgeterbar_av_1_A : A ;
  obuteljerbar_av_1_A : A ;
  obyraakratiserbar_av_1_1_A : A ;
  obaendig_av_1_1_A : A ;
  oboejlig_av_1_1_A : A ;
  oboenhoerlig_av_1_1_A : A ;
  ocamouflerbar_av_1_A : A ;
  occidental_av_1_A : A ;
  occidentaliserbar_av_1_A : A ;
  occidentalisk_av_1_A : A ;
  oceanisk_av_1_A : A ;
  oceanografisk_av_1_A : A ;
  ocederbar_av_1_A : A ;
  ocelebrerbar_av_1_A : A ;
  ocementerbar_av_1_A : A ;
  ocensurerbar_av_1_A : A ;
  ocentraliserbar_av_1_A : A ;
  ocentrerbar_av_1_A : A ;
  ocentrifugerbar_av_1_A : A ;
  ocernerbar_av_1_A : A ;
  ochargerbar_av_1_A : A ;
  ocharmerbar_av_1_A : A ;
  ochevroterbar_av_1_A : A ;
  ochiffrerbar_av_1_A : A ;
  ochikanerbar_av_1_A : A ;
  ochockerbar_av_1_A : A ;
  ocirkulerbar_av_1_A : A ;
  ociselerbar_av_1_A : A ;
  ociterbar_av_1_A : A ;
  ociviliserbar_av_1_A : A ;
  ockasionell_av_1_A : A ;
  ockuperbar_av_1_A : A ;
  ocuraterbar_av_1_A : A ;
  ocurerbar_av_1_A : A ;
  odaterbar_av_1_A : A ;
  odatoriserbar_av_1_A : A ;
  odebarkerbar_av_1_A : A ;
  odebatterbar_av_1_A : A ;
  odebiterbar_av_1_A : A ;
  odecentraliserbar_av_1_A : A ;
  odechiffrerbar_av_1_A : A ;
  odecimerbar_av_1_A : A ;
  odedicerbar_av_1_A : A ;
  odedikerbar_av_1_A : A ;
  odeducerbar_av_1_A : A ;
  odefilerbar_av_1_A : A ;
  odefinierbar_av_1_A : A ;
  odeflorerbar_av_1_A : A ;
  odeformerbar_av_1_A : A ;
  odegenererbar_av_1_A : A ;
  odegraderbar_av_1_A : A ;
  odekanterbar_av_1_A : A ;
  odekapiterbar_av_1_A : A ;
  odeklamerbar_av_1_A : A ;
  odeklarerbar_av_1_A : A ;
  odeklasserbar_av_1_A : A ;
  odeklinerbar_av_1_A : A ;
  odekorerbar_av_1_A : A ;
  odekouragerbar_av_1_A : A ;
  odekreterbar_av_1_A : A ;
  odelbar_av_1_A : A ;
  odelegerbar_av_1_A : A ;
  odemaskerbar_av_1_A : A ;
  odementerbar_av_1_A : A ;
  odemilitariserbar_av_1_A : A ;
  odemobiliserbar_av_1_A : A ;
  odemokratiserbar_av_1_A : A ;
  odemokratisk_av_1_A : A ;
  odemolerbar_av_1_A : A ;
  odemoniserbar_av_1_A : A ;
  odemonstrerbar_av_1_A : A ;
  odemonterbar_av_1_A : A ;
  odemoraliserbar_av_1_A : A ;
  odenaturaliserbar_av_1_A : A ;
  odenaturerbar_av_1_A : A ;
  odenoterbar_av_1_A : A ;
  odenuderbar_av_1_A : A ;
  odeodoriserbar_av_1_A : A ;
  odepatrierbar_av_1_A : A ;
  odepenserbar_av_1_A : A ;
  odeplacerbar_av_1_A : A ;
  odeponerbar_av_1_A : A ;
  odeporterbar_av_1_A : A ;
  odeprecierbar_av_1_A : A ;
  oderangerbar_av_1_A : A ;
  oderiverbar_av_1_A : A ;
  odesarmerbar_av_1_A : A ;
  odesavouerbar_av_1_A : A ;
  odesensibiliserbar_av_1_A : A ;
  odesignerbar_av_1_A : A ;
  odesinfekterbar_av_1_A : A ;
  odesinficerbar_av_1_A : A ;
  odesinformerbar_av_1_A : A ;
  odesorganiserbar_av_1_A : A ;
  odestabiliserbar_av_1_A : A ;
  odestillerbar_av_1_A : A ;
  odestinerbar_av_1_A : A ;
  odestruerbar_av_1_A : A ;
  odetacherbar_av_1_A : A ;
  odetekterbar_av_1_A : A ;
  odeterminerbar_av_1_A : A ;
  odetonerbar_av_1_A : A ;
  odetroniserbar_av_1_A : A ;
  odevalverbar_av_1_A : A ;
  odiagnosticerbar_av_1_A : A ;
  odiagnostiserbar_av_1_A : A ;
  odialyserbar_av_1_A : A ;
  odifferentierbar_av_1_A : A ;
  odiffunderbar_av_1_A : A ;
  odiftongerbar_av_1_A : A ;
  odigererbar_av_1_A : A ;
  odikterbar_av_1_A : A ;
  odimensionerbar_av_1_A : A ;
  odiplomatisk_av_1_A : A ;
  odiplomerbar_av_1_A : A ;
  odirigerbar_av_1_A : A ;
  odisambiguerbar_av_1_A : A ;
  odisciplinerbar_av_1_A : A ;
  odisharmonierbar_av_1_A : A ;
  odiskonterbar_av_1_A : A ;
  odiskrediterbar_av_1_A : A ;
  odiskriminerbar_av_1_A : A ;
  odiskuterbar_av_1_A : A ;
  odiskvalificerbar_av_1_A : A ;
  odispascherbar_av_1_A : A ;
  odispenserbar_av_1_A : A ;
  odispergerbar_av_1_A : A ;
  odisponerbar_av_1_A : A ;
  odisputerbar_av_1_A : A ;
  odissekerbar_av_1_A : A ;
  odissimilerbar_av_1_A : A ;
  odissocierbar_av_1_A : A ;
  odistanserbar_av_1_A : A ;
  odistraherbar_av_1_A : A ;
  odistribuerbar_av_1_A : A ;
  odivergerbar_av_1_A : A ;
  odiversifierbar_av_1_A : A ;
  odividerbar_av_1_A : A ;
  odioes_av_1_1_A : A ;
  odlingsbar_av_1_A : A ;
  odocerbar_av_1_A : A ;
  odogmatiserbar_av_1_A : A ;
  odogmatisk_av_1_A : A ;
  odokumenterbar_av_1_A : A ;
  odomesticerbar_av_1_A : A ;
  odomicilierbar_av_1_A : A ;
  odominerbar_av_1_A : A ;
  odompterbar_av_1_A : A ;
  odonerbar_av_1_A : A ;
  odontologisk_av_1_A : A ;
  odoserbar_av_1_A : A ;
  odosserbar_av_1_A : A ;
  odoterbar_av_1_A : A ;
  odragerbar_av_1_A : A ;
  odramatiserbar_av_1_A : A ;
  odramatisk_av_1_A : A ;
  odraperbar_av_1_A : A ;
  odresserbar_av_1_A : A ;
  odrickbar_av_1_A : A ;
  odryg_av_1_A : A ;
  odraeglig_av_1_1_A : A ;
  odraenerbar_av_1_1_A : A ;
  odubblerbar_av_1_A : A ;
  oduglig_av_1_A : A ;
  oduperbar_av_1_A : A ;
  oduplicerbar_av_1_A : A ;
  odygdig_av_1_A : A ;
  odoedlig_av_1_1_A : A ;
  oederbar_av_1_A : A ;
  oeffacerbar_av_1_A : A ;
  oeffektiverbar_av_1_A : A ;
  oeffektiviserbar_av_1_A : A ;
  oeffektuerbar_av_1_A : A ;
  oefterdaterbar_av_1_A : A ;
  oefterdebiterbar_av_1_A : A ;
  oeftergivlig_av_1_A : A ;
  oefterhaermlig_av_1_1_A : A ;
  oefterrationaliserbar_av_1_A : A ;
  oefterraettlig_av_1_1_A : A ;
  oeftersynkroniserbar_av_1_A : A ;
  oeftertaxerbar_av_1_A : A ;
  oegaliserbar_av_1_A : A ;
  oegennyttig_av_1_A : A ;
  oegentlig_av_1_A : A ;
  oekiperbar_av_1_A : A ;
  oeklaterbar_av_1_A : A ;
  oeklaererbar_av_1_1_A : A ;
  oekonomiserbar_av_1_A : A ;
  oekonomisk_av_1_A : A ;
  oelaborerbar_av_1_A : A ;
  oelastiserbar_av_1_A : A ;
  oelektrificerbar_av_1_A : A ;
  oelektrifierbar_av_1_A : A ;
  oelektriserbar_av_1_A : A ;
  oeliderbar_av_1_A : A ;
  oeliminerbar_av_1_A : A ;
  oeloxerbar_av_1_A : A ;
  oeluderbar_av_1_A : A ;
  oeluerbar_av_1_A : A ;
  oemaljerbar_av_1_A : A ;
  oemanciperbar_av_1_A : A ;
  oemballerbar_av_1_A : A ;
  oembarkerbar_av_1_A : A ;
  oembellerbar_av_1_A : A ;
  oemenderbar_av_1_A : A ;
  oemigrerbar_av_1_A : A ;
  oemitterbar_av_1_A : A ;
  oemotstaandlig_av_1_1_A : A ;
  oemotsaeglig_av_1_1_A : A ;
  oemottaglig_av_1_A : A ;
  oemulgerbar_av_1_A : A ;
  oendosserbar_av_1_A : A ;
  oenerverbar_av_1_A : A ;
  oengagerbar_av_1_A : A ;
  oenig_av_1_A : A ;
  oenleverbar_av_1_A : A ;
  oenrollerbar_av_1_A : A ;
  oensilerbar_av_1_A : A ;
  oentusiasmerbar_av_1_A : A ;
  oepilerbar_av_1_A : A ;
  oerigerbar_av_1_A : A ;
  oeroderbar_av_1_A : A ;
  oersaettlig_av_1_1_A : A ;
  oeskalerbar_av_1_A : A ;
  oeskorterbar_av_1_A : A ;
  oesteticerbar_av_1_A : A ;
  oestetiserbar_av_1_A : A ;
  oestetisk_av_1_A : A ;
  oestimerbar_av_1_A : A ;
  oetablerbar_av_1_A : A ;
  oeteriserbar_av_1_A : A ;
  oetiketterbar_av_1_A : A ;
  oetisk_av_1_A : A ;
  oetymologiserbar_av_1_A : A ;
  oeuropeiserbar_av_1_A : A ;
  oevakuerbar_av_1_A : A ;
  oevaluerbar_av_1_A : A ;
  oevalverbar_av_1_A : A ;
  oevaporerbar_av_1_A : A ;
  oexaminerbar_av_1_A : A ;
  oexcerperbar_av_1_A : A ;
  oexciterbar_av_1_A : A ;
  oexekverbar_av_1_A : A ;
  oexemplifierbar_av_1_A : A ;
  oexercerbar_av_1_A : A ;
  oexkluderbar_av_1_A : A ;
  oexkommunicerbar_av_1_A : A ;
  oexpanderbar_av_1_A : A ;
  oexpatrierbar_av_1_A : A ;
  oexpedierbar_av_1_A : A ;
  oexpektorerbar_av_1_A : A ;
  oexplicerbar_av_1_A : A ;
  oexploaterbar_av_1_A : A ;
  oexploderbar_av_1_A : A ;
  oexponerbar_av_1_A : A ;
  oexporterbar_av_1_A : A ;
  oexproprierbar_av_1_A : A ;
  oexstirperbar_av_1_A : A ;
  oextemporerbar_av_1_A : A ;
  oextraherbar_av_1_A : A ;
  oextrapolerbar_av_1_A : A ;
  ofabricerbar_av_1_A : A ;
  ofabulerbar_av_1_A : A ;
  ofacetterbar_av_1_A : A ;
  ofakturerbar_av_1_A : A ;
  ofalsifierbar_av_1_A : A ;
  ofantiserbar_av_1_A : A ;
  ofantlig_av_1_A : A ;
  ofarlig_av_1_A : A ;
  ofascinerbar_av_1_A : A ;
  ofasetterbar_av_1_A : A ;
  ofasonerbar_av_1_A : A ;
  ofattbar_av_1_A : A ;
  ofattlig_av_1_A : A ;
  ofavoriserbar_av_1_A : A ;
  ofelbar_av_1_A : A ;
  ofermenterbar_av_1_A : A ;
  ofeterbar_av_1_A : A ;
  offensiv_av_1_A : A ;
  offentlig_av_1_A : A ;
  offererbar_av_1_A : A ;
  officiell_av_1_A : A ;
  officinell_av_1_A : A ;
  officioes_av_1_1_A : A ;
  ofilerbar_av_1_A : A ;
  ofilmatiserbar_av_1_A : A ;
  ofiltrerbar_av_1_A : A ;
  ofin_av_1_A : A ;
  ofinansierbar_av_1_A : A ;
  ofingerbar_av_1_A : A ;
  ofinjusterbar_av_1_A : A ;
  ofinlandiserbar_av_1_A : A ;
  ofixerbar_av_1_A : A ;
  oflamberbar_av_1_A : A ;
  oflankerbar_av_1_A : A ;
  oflatterbar_av_1_A : A ;
  oflekterbar_av_1_A : A ;
  ofluidiserbar_av_1_A : A ;
  ofluorerbar_av_1_A : A ;
  ofluoriderbar_av_1_A : A ;
  ofokuserbar_av_1_A : A ;
  ofolierbar_av_1_A : A ;
  ofonderbar_av_1_A : A ;
  oforcerbar_av_1_A : A ;
  oformaliserbar_av_1_A : A ;
  oformerbar_av_1_A : A ;
  oformlig_av_1_A : A ;
  oformulerbar_av_1_A : A ;
  ofosfaterbar_av_1_A : A ;
  ofossiliserbar_av_1_A : A ;
  ofotograferbar_av_1_A : A ;
  ofragmenterbar_av_1_A : A ;
  ofraktionerbar_av_1_A : A ;
  oframkomlig_av_1_A : A ;
  ofrankerbar_av_1_A : A ;
  ofraserbar_av_1_A : A ;
  ofrekventerbar_av_1_A : A ;
  ofriserbar_av_1_A : A ;
  ofriterbar_av_1_A : A ;
  ofrivillig_av_1_A : A ;
  ofronderbar_av_1_A : A ;
  ofrotterbar_av_1_A : A ;
  ofruktbar_av_1_A : A ;
  ofrustrerbar_av_1_A : A ;
  ofraankomlig_av_1_1_A : A ;
  oftalmologisk_av_1_A : A ;
  ofullkomlig_av_1_A : A ;
  ofullstaendig_av_1_1_A : A ;
  ofurnerbar_av_1_A : A ;
  ofusionerbar_av_1_A : A ;
  ofyndig_av_1_A : A ;
  ofysiljerbar_av_1_A : A ;
  ofaerdig_av_1_1_A : A ;
  ofaerserbar_av_1_1_A : A ;
  ofoer_av_1_1_A : A ;
  ofoerannonserbar_av_1_1_A : A ;
  ofoerarglig_av_1_1_A : A ;
  ofoerbraennelig_av_1_1_A : A ;
  ofoerbaetterlig_av_1_1_A : A ;
  ofoerdelaktig_av_1_1_A : A ;
  ofoerenlig_av_1_1_A : A ;
  ofoergloemlig_av_1_1_A : A ;
  ofoergriplig_av_1_1_A : A ;
  ofoergaetlig_av_1_1_A : A ;
  ofoerklarlig_av_1_1_A : A ;
  ofoerliknelig_av_1_1_A : A ;
  ofoerlaatlig_av_1_1_A : A ;
  ofoerneklig_av_1_1_A : A ;
  ofoernuftig_av_1_1_A : A ;
  ofoersiktig_av_1_1_A : A ;
  ofoerskotterbar_av_1_1_A : A ;
  ofoersonlig_av_1_1_A : A ;
  ofoerstaaelig_av_1_1_A : A ;
  ofoerstaandig_av_1_1_A : A ;
  ofoerstoerbar_av_1_1_A : A ;
  ofoersvarlig_av_1_1_A : A ;
  ofoertroettlig_av_1_1_A : A ;
  ofoertydbar_av_1_1_A : A ;
  ofoerutsebar_av_1_1_A : A ;
  ofoerutsaegbar_av_1_1_A : A ;
  ofoervitlig_av_1_1_A : A ;
  ofoerytterlig_av_1_1_A : A ;
  ofoeraenderlig_av_1_1_A : A ;
  ogalliserbar_av_1_A : A ;
  ogaloscherbar_av_1_A : A ;
  ogalvaniserbar_av_1_A : A ;
  ogaragerbar_av_1_A : A ;
  ogaranterbar_av_1_A : A ;
  ogarderbar_av_1_A : A ;
  ogarnerbar_av_1_A : A ;
  ogarnisonerbar_av_1_A : A ;
  ogarrotterbar_av_1_A : A ;
  ogastroskoperbar_av_1_A : A ;
  ogauffrerbar_av_1_A : A ;
  ogelatinerbar_av_1_A : A ;
  ogeminerbar_av_1_A : A ;
  ogeneraliserbar_av_1_A : A ;
  ogenerbar_av_1_A : A ;
  ogenererbar_av_1_A : A ;
  ogenomfoerbar_av_1_1_A : A ;
  ogenomskinlig_av_1_A : A ;
  ogenomslaepplig_av_1_1_A : A ;
  ogenomtraenglig_av_1_1_A : A ;
  ogensaeglig_av_1_1_A : A ;
  ogeometriserbar_av_1_A : A ;
  ogermaniserbar_av_1_A : A ;
  ogiftig_av_1_A : A ;
  ogiljotinerbar_av_1_A : A ;
  ogill_av_1_A : A ;
  ogiltig_av_1_A : A ;
  ogin_av_1_A : A ;
  ogirerbar_av_1_A : A ;
  oglamoriserbar_av_1_A : A ;
  oglamouriserbar_av_1_A : A ;
  oglaserbar_av_1_A : A ;
  oglorifierbar_av_1_A : A ;
  ogoffrerbar_av_1_A : A ;
  ogouterbar_av_1_A : A ;
  ograderbar_av_1_A : A ;
  ograduerbar_av_1_A : A ;
  ografiterbar_av_1_A : A ;
  ogrammatikalisk_av_1_A : A ;
  ogrammatisk_av_1_A : A ;
  ogranulerbar_av_1_A : A ;
  ogratinerbar_av_1_A : A ;
  ogratulerbar_av_1_A : A ;
  ograverbar_av_1_A : A ;
  ogriljerbar_av_1_A : A ;
  ogrimerbar_av_1_A : A ;
  ogripbar_av_1_A : A ;
  ogrunderbar_av_1_A : A ;
  ogrupperbar_av_1_A : A ;
  ogudaktig_av_1_A : A ;
  ogudlig_av_1_A : A ;
  ogummerbar_av_1_A : A ;
  ogunstig_av_1_A : A ;
  oguterbar_av_1_A : A ;
  ogymnastiserbar_av_1_A : A ;
  ogaestvaenlig_av_1_1_A : A ;
  ogoerlig_av_1_1_A : A ;
  ohallucinerbar_av_1_A : A ;
  ohalverbar_av_1_A : A ;
  ohanterbar_av_1_A : A ;
  ohanterlig_av_1_A : A ;
  oharangerbar_av_1_A : A ;
  oharmoniserbar_av_1_A : A ;
  oharmonisk_av_1_A : A ;
  oharpunerbar_av_1_A : A ;
  ohasarderbar_av_1_A : A ;
  ohavererbar_av_1_A : A ;
  ohederlig_av_1_A : A ;
  ohektograferbar_av_1_A : A ;
  ohelig_av_1_A : A ;
  ohemul_av_1_A : A ;
  oheroiserbar_av_1_A : A ;
  ohistorierbar_av_1_A : A ;
  ohistoriserbar_av_1_A : A ;
  ohistorisk_av_1_A : A ;
  ohjaelplig_av_1_1_A : A ;
  oholograferbar_av_1_A : A ;
  ohomogeniserbar_av_1_A : A ;
  ohonorerbar_av_1_A : A ;
  ohospitaliserbar_av_1_A : A ;
  ohumaniserbar_av_1_A : A ;
  ohundsfotterbar_av_1_A : A ;
  ohuserbar_av_1_A : A ;
  ohybridiserbar_av_1_A : A ;
  ohydrerbar_av_1_A : A ;
  ohygglig_av_1_A : A ;
  ohygienisk_av_1_A : A ;
  ohypnotiserbar_av_1_A : A ;
  ohypotiserbar_av_1_A : A ;
  ohysbar_av_1_A : A ;
  ohaerbaergerbar_av_1_1_A : A ;
  ohaallbar_av_1_1_A : A ;
  ohoerbar_av_1_1_A : A ;
  ohoevlig_av_1_1_A : A ;
  oidealiserbar_av_1_A : A ;
  oidentifierbar_av_1_A : A ;
  oigenkaennlig_av_1_1_A : A ;
  oignorerbar_av_1_A : A ;
  oilluminerbar_av_1_A : A ;
  oillustrerbar_av_1_A : A ;
  oimiterbar_av_1_A : A ;
  oimmatrikulerbar_av_1_A : A ;
  oimmigrerbar_av_1_A : A ;
  oimmuniserbar_av_1_A : A ;
  oimplanterbar_av_1_A : A ;
  oimplicerbar_av_1_A : A ;
  oimploderbar_av_1_A : A ;
  oimponerbar_av_1_A : A ;
  oimporterbar_av_1_A : A ;
  oimpregnerbar_av_1_A : A ;
  oimproviserbar_av_1_A : A ;
  oinackorderbar_av_1_A : A ;
  oinaugurerbar_av_1_A : A ;
  oindexerbar_av_1_A : A ;
  oindexreglerbar_av_1_A : A ;
  oindicerbar_av_1_A : A ;
  oindikerbar_av_1_A : A ;
  oindividualiserbar_av_1_A : A ;
  oindoktrinerbar_av_1_A : A ;
  oinducerbar_av_1_A : A ;
  oindustrialiserbar_av_1_A : A ;
  oinfantiliserbar_av_1_A : A ;
  oinfekterbar_av_1_A : A ;
  oinfiltrerbar_av_1_A : A ;
  oinflammerbar_av_1_A : A ;
  oinfluerbar_av_1_A : A ;
  oinformerbar_av_1_A : A ;
  oingraverbar_av_1_A : A ;
  oinhalerbar_av_1_A : A ;
  oinhiberbar_av_1_A : A ;
  oinhibiterbar_av_1_A : A ;
  oinitierbar_av_1_A : A ;
  oinjekterbar_av_1_A : A ;
  oinjicerbar_av_1_A : A ;
  oinkarnerbar_av_1_A : A ;
  oinkasserbar_av_1_A : A ;
  oinklarerbar_av_1_A : A ;
  oinkluderbar_av_1_A : A ;
  oinkorporerbar_av_1_A : A ;
  oinkvarterbar_av_1_A : A ;
  oinnerverbar_av_1_A : A ;
  oinokulerbar_av_1_A : A ;
  oinplanterbar_av_1_A : A ;
  oinrangerbar_av_1_A : A ;
  oinrapporterbar_av_1_A : A ;
  oinregistrerbar_av_1_A : A ;
  oinscenerbar_av_1_A : A ;
  oinseminerbar_av_1_A : A ;
  oinsinuerbar_av_1_A : A ;
  oinspekterbar_av_1_A : A ;
  oinspirerbar_av_1_A : A ;
  oinstallerbar_av_1_A : A ;
  oinstitutionaliserbar_av_1_A : A ;
  oinstruerbar_av_1_A : A ;
  oinstrumenterbar_av_1_A : A ;
  oinstuderbar_av_1_A : A ;
  ointaglig_av_1_A : A ;
  ointegrerbar_av_1_A : A ;
  ointellektualiserbar_av_1_A : A ;
  ointensifierbar_av_1_A : A ;
  ointensiverbar_av_1_A : A ;
  ointerfolierbar_av_1_A : A ;
  ointernaliserbar_av_1_A : A ;
  ointernationaliserbar_av_1_A : A ;
  ointernerbar_av_1_A : A ;
  ointerpellerbar_av_1_A : A ;
  ointerpolerbar_av_1_A : A ;
  ointerpreterbar_av_1_A : A ;
  ointerpunkterbar_av_1_A : A ;
  ointervenerbar_av_1_A : A ;
  ointonerbar_av_1_A : A ;
  ointresserbar_av_1_A : A ;
  ointroducerbar_av_1_A : A ;
  oinvaderbar_av_1_A : A ;
  oinvalidiserbar_av_1_A : A ;
  oinventerbar_av_1_A : A ;
  oinverterbar_av_1_A : A ;
  oinvesterbar_av_1_A : A ;
  oinviterbar_av_1_A : A ;
  oinvolverbar_av_1_A : A ;
  oirriterbar_av_1_A : A ;
  oislamiserbar_av_1_A : A ;
  oisolerbar_av_1_A : A ;
  oitererbar_av_1_A : A ;
  ojazzifierbar_av_1_A : A ;
  ojoderbar_av_1_A : A ;
  ojonglerbar_av_1_A : A ;
  ojoniserbar_av_1_A : A ;
  ojusterbar_av_1_A : A ;
  ojaemfoerbar_av_1_1_A : A ;
  ojaemfoerlig_av_1_1_A : A ;
  ojaemlik_av_1_1_A : A ;
  ojaemn_av_1_1_A : A ;
  ojaevig_av_1_1_A : A ;
  okalandrerbar_av_1_A : A ;
  okalcinerbar_av_1_A : A ;
  okalibrerbar_av_1_A : A ;
  okalkerbar_av_1_A : A ;
  okalkylerbar_av_1_A : A ;
  okalmerbar_av_1_A : A ;
  okamouflerbar_av_1_A : A ;
  okamratlig_av_1_A : A ;
  okanaliserbar_av_1_A : A ;
  okanderbar_av_1_A : A ;
  okandiderbar_av_1_A : A ;
  okannelerbar_av_1_A : A ;
  okanoniserbar_av_1_A : A ;
  okapitaliserbar_av_1_A : A ;
  okarakteriserbar_av_1_A : A ;
  okaraktaeriserbar_av_1_1_A : A ;
  okarambolerbar_av_1_A : A ;
  okarboniserbar_av_1_A : A ;
  okarikerbar_av_1_A : A ;
  okarterbar_av_1_A : A ;
  okartonnerbar_av_1_A : A ;
  okasserbar_av_1_A : A ;
  okastrerbar_av_1_A : A ;
  okatalogiserbar_av_1_A : A ;
  okatalyserbar_av_1_A : A ;
  okategoriserbar_av_1_A : A ;
  okateteriserbar_av_1_A : A ;
  okatetriserbar_av_1_A : A ;
  okauteriserbar_av_1_A : A ;
  oklanderlig_av_1_A : A ;
  oklar_av_1_A : A ;
  oklarerbar_av_1_A : A ;
  oklassificerbar_av_1_A : A ;
  oklok_av_1_A : A ;
  oklorerbar_av_1_A : A ;
  okoafferbar_av_1_A : A ;
  okoagulerbar_av_1_A : A ;
  okodifierbar_av_1_A : A ;
  okollationerbar_av_1_A : A ;
  okollektiviserbar_av_1_A : A ;
  okoloniserbar_av_1_A : A ;
  okolorerbar_av_1_A : A ;
  okolporterbar_av_1_A : A ;
  okombinerbar_av_1_A : A ;
  okommaterbar_av_1_A : A ;
  okommenderbar_av_1_A : A ;
  okommenterbar_av_1_A : A ;
  okommersialiserbar_av_1_A : A ;
  okommunaliserbar_av_1_A : A ;
  okommunicerbar_av_1_A : A ;
  okommuterbar_av_1_A : A ;
  okomparerbar_av_1_A : A ;
  okompenserbar_av_1_A : A ;
  okompilerbar_av_1_A : A ;
  okompletterbar_av_1_A : A ;
  okomplicerbar_av_1_A : A ;
  okomplimenterbar_av_1_A : A ;
  okomponerbar_av_1_A : A ;
  okomposterbar_av_1_A : A ;
  okomprimerbar_av_1_A : A ;
  okomprometterbar_av_1_A : A ;
  okoncentrerbar_av_1_A : A ;
  okoncessionerbar_av_1_A : A ;
  okoncipierbar_av_1_A : A ;
  okondemnerbar_av_1_A : A ;
  okondenserbar_av_1_A : A ;
  okonditionerbar_av_1_A : A ;
  okondolerbar_av_1_A : A ;
  okonfirmerbar_av_1_A : A ;
  okonfiskerbar_av_1_A : A ;
  okonfronterbar_av_1_A : A ;
  okonfunderbar_av_1_A : A ;
  okongruerbar_av_1_A : A ;
  okonjugerbar_av_1_A : A ;
  okonkluderbar_av_1_A : A ;
  okonkretiserbar_av_1_A : A ;
  okonserverbar_av_1_A : A ;
  okonsignerbar_av_1_A : A ;
  okonsoliderbar_av_1_A : A ;
  okonstaterbar_av_1_A : A ;
  okonsternerbar_av_1_A : A ;
  okonstituerbar_av_1_A : A ;
  okonstruerbar_av_1_A : A ;
  okonsulterbar_av_1_A : A ;
  okonsumerbar_av_1_A : A ;
  okontaminerbar_av_1_A : A ;
  okonterbar_av_1_A : A ;
  okontingenterbar_av_1_A : A ;
  okontoriserbar_av_1_A : A ;
  okontraherbar_av_1_A : A ;
  okontrakterbar_av_1_A : A ;
  okontramanderbar_av_1_A : A ;
  okontrasignerbar_av_1_A : A ;
  okontrasterbar_av_1_A : A ;
  okontribuerbar_av_1_A : A ;
  okontrollerbar_av_1_A : A ;
  okontroversiell_av_1_A : A ;
  okonturerbar_av_1_A : A ;
  okonventionell_av_1_A : A ;
  okonvergerbar_av_1_A : A ;
  okonverserbar_av_1_A : A ;
  okonverterbar_av_1_A : A ;
  okonvojerbar_av_1_A : A ;
  okoordinerbar_av_1_A : A ;
  okopierbar_av_1_A : A ;
  okorrelerbar_av_1_A : A ;
  okorrigerbar_av_1_A : A ;
  okorroderbar_av_1_A : A ;
  okorrugerbar_av_1_A : A ;
  okorrumperbar_av_1_A : A ;
  okorsetterbar_av_1_A : A ;
  okostymerbar_av_1_A : A ;
  okrackelerbar_av_1_A : A ;
  okrediterbar_av_1_A : A ;
  okreerbar_av_1_A : A ;
  okremerbar_av_1_A : A ;
  okreperbar_av_1_A : A ;
  okreverbar_av_1_A : A ;
  okriminaliserbar_av_1_A : A ;
  okristalliserbar_av_1_A : A ;
  okristlig_av_1_A : A ;
  okritiserbar_av_1_A : A ;
  okritisk_av_1_A : A ;
  okroppslig_av_1_A : A ;
  okrossbar_av_1_A : A ;
  okrypterbar_av_1_A : A ;
  okraenkbar_av_1_1_A : A ;
  oktrojerbar_av_1_A : A ;
  okuberbar_av_1_A : A ;
  okujonerbar_av_1_A : A ;
  okular_av_1_A : A ;
  okulerbar_av_1_A : A ;
  okultiverbar_av_1_A : A ;
  okulaer_av_1_1_A : A ;
  okumulerbar_av_1_A : A ;
  okunnig_av_1_A : A ;
  okuperbar_av_1_A : A ;
  okuraterbar_av_1_A : A ;
  okurerbar_av_1_A : A ;
  okursiverbar_av_1_A : A ;
  okurtiserbar_av_1_A : A ;
  okuverterbar_av_1_A : A ;
  okuvlig_av_1_A : A ;
  okvadrerbar_av_1_A : A ;
  okvalificerbar_av_1_A : A ;
  okvantifierbar_av_1_A : A ;
  okvinnlig_av_1_A : A ;
  okvitterbar_av_1_A : A ;
  okvoterbar_av_1_A : A ;
  okynnig_av_1_A : A ;
  okyrklig_av_1_A : A ;
  okysk_av_1_A : A ;
  okaenslig_av_1_1_A : A ;
  okaer_av_1_1_A : A ;
  olabialiserbar_av_1_A : A ;
  olackerbar_av_1_A : A ;
  olaglig_av_1_A : A ;
  olamenterbar_av_1_A : A ;
  olaminerbar_av_1_A : A ;
  olangetterbar_av_1_A : A ;
  olanserbar_av_1_A : A ;
  olapiserbar_av_1_A : A ;
  olaserbar_av_1_A : A ;
  olatiniserbar_av_1_A : A ;
  olaverbar_av_1_A : A ;
  olegaliserbar_av_1_A : A ;
  olegerbar_av_1_A : A ;
  olegitimerbar_av_1_A : A ;
  olevererbar_av_1_A : A ;
  oliberaliserbar_av_1_A : A ;
  olicenserbar_av_1_A : A ;
  olicensierbar_av_1_A : A ;
  olicentierbar_av_1_A : A ;
  olidlig_av_1_A : A ;
  olierbar_av_1_A : A ;
  oligofag_av_1_A : A ;
  oligotrof_av_1_A : A ;
  olik_av_1_A : A ;
  olikformig_av_1_A : A ;
  olikstor_av_1_A : A ;
  olikviderbar_av_1_A : A ;
  olinjerbar_av_1_A : A ;
  olisserbar_av_1_A : A ;
  olitograferbar_av_1_A : A ;
  olivgroen_av_1_1_A : A ;
  oljebestaendig_av_1_1_A : A ;
  oljerik_av_1_A : A ;
  oljig_av_1_A : A ;
  ologerbar_av_1_A : A ;
  ologisk_av_1_A : A ;
  olokaliserbar_av_1_A : A ;
  olovlig_av_1_A : A ;
  olustig_av_1_A : A ;
  oluteiniserbar_av_1_A : A ;
  olycklig_av_1_A : A ;
  olycksalig_av_1_A : A ;
  olydig_av_1_A : A ;
  olympisk_av_1_A : A ;
  olyxrenoverbar_av_1_A : A ;
  olaederbar_av_1_1_A : A ;
  olaeglig_av_1_1_A : A ;
  olaeklig_av_1_1_A : A ;
  olaemplig_av_1_1_A : A ;
  olaendig_av_1_1_A : A ;
  olaesbar_av_1_1_A : A ;
  olaeslig_av_1_1_A : A ;
  oloesbar_av_1_1_A : A ;
  oloeslig_av_1_1_A : A ;
  omadrasserbar_av_1_A : A ;
  omagasinerbar_av_1_A : A ;
  omagnetiserbar_av_1_A : A ;
  omakulerbar_av_1_A : A ;
  omalfoberbar_av_1_A : A ;
  omaltraeterbar_av_1_1_A : A ;
  omanifesterbar_av_1_A : A ;
  omanikurerbar_av_1_A : A ;
  omanikyrerbar_av_1_A : A ;
  omanipulerbar_av_1_A : A ;
  omanlig_av_1_A : A ;
  omansk_av_1_A : A ;
  omanoevrerbar_av_1_1_A : A ;
  omarginaliserbar_av_1_A : A ;
  omarinerbar_av_1_A : A ;
  omarkerbar_av_1_A : A ;
  omarmorerbar_av_1_A : A ;
  omarscherbar_av_1_A : A ;
  omarterbar_av_1_A : A ;
  omaskerbar_av_1_A : A ;
  omaskuliniserbar_av_1_A : A ;
  omassakrerbar_av_1_A : A ;
  omasserbar_av_1_A : A ;
  omatelasserbar_av_1_A : A ;
  omaterialiserbar_av_1_A : A ;
  omatterbar_av_1_A : A ;
  omaximerbar_av_1_A : A ;
  ombytlig_av_1_A : A ;
  omdirigerbar_av_1_A : A ;
  omdoemesgill_av_1_1_A : A ;
  omdoemesloes_av_1_1_A : A ;
  omedaljerbar_av_1_A : A ;
  omedelbar_av_1_A : A ;
  omedgoerlig_av_1_1_A : A ;
  omedicinerbar_av_1_A : A ;
  omekaniserbar_av_1_A : A ;
  omemorerbar_av_1_A : A ;
  omerceriserbar_av_1_A : A ;
  omeriterbar_av_1_A : A ;
  ometalliserbar_av_1_A : A ;
  omfaangsrik_av_1_1_A : A ;
  omikroskoperbar_av_1_A : A ;
  omilitariserbar_av_1_A : A ;
  omineraliserbar_av_1_A : A ;
  ominerbar_av_1_A : A ;
  ominiatyriserbar_av_1_A : A ;
  ominimerbar_av_1_A : A ;
  ominoes_av_1_1_A : A ;
  omissiverbar_av_1_A : A ;
  omisskrediterbar_av_1_A : A ;
  omisskaennelig_av_1_1_A : A ;
  omisskaennlig_av_1_1_A : A ;
  omistlig_av_1_A : A ;
  ommoeblerbar_av_1_1_A : A ;
  omnipotent_av_1_A : A ;
  omobiliserbar_av_1_A : A ;
  omodellerbar_av_1_A : A ;
  omodererbar_av_1_A : A ;
  omodern_av_1_A : A ;
  omoderniserbar_av_1_A : A ;
  omodifierbar_av_1_A : A ;
  omodulerbar_av_1_A : A ;
  omodaerniserbar_av_1_1_A : A ;
  omonoftongerbar_av_1_A : A ;
  omonopoliserbar_av_1_A : A ;
  omonterbar_av_1_A : A ;
  omoralisk_av_1_A : A ;
  omorganiserbar_av_1_A : A ;
  omorserbar_av_1_A : A ;
  omortificerbar_av_1_A : A ;
  omortifierbar_av_1_A : A ;
  omotiverbar_av_1_A : A ;
  omotoriserbar_av_1_A : A ;
  omotstaandlig_av_1_1_A : A ;
  omotsaeglig_av_1_1_A : A ;
  omottaglig_av_1_A : A ;
  omplacerbar_av_1_A : A ;
  omskulpturerbar_av_1_A : A ;
  omsorgsfull_av_1_A : A ;
  omstrukturerbar_av_1_A : A ;
  omstaendig_av_1_1_A : A ;
  omstaendlig_av_1_1_A : A ;
  omuljerbar_av_1_A : A ;
  omultiplicerbar_av_1_A : A ;
  omumifierbar_av_1_A : A ;
  omusikalisk_av_1_A : A ;
  omutbar_av_1_A : A ;
  omuterbar_av_1_A : A ;
  omutlig_av_1_A : A ;
  omvaendbar_av_1_1_A : A ;
  omvaerderbar_av_1_1_A : A ;
  omvaardnadsmaessig_av_1_1_A : A ;
  omyndig_av_1_A : A ;
  omystifierbar_av_1_A : A ;
  omaensklig_av_1_1_A : A ;
  omaerklig_av_1_1_A : A ;
  omaetlig_av_1_1_A : A ;
  omaettlig_av_1_1_A : A ;
  omaattlig_av_1_1_A : A ;
  omoeblerbar_av_1_1_A : A ;
  omoejlig_av_1_1_A : A ;
  onasalerbar_av_1_A : A ;
  onasaliserbar_av_1_A : A ;
  onationaliserbar_av_1_A : A ;
  onaturaliserbar_av_1_A : A ;
  onaturlig_av_1_A : A ;
  onavigerbar_av_1_A : A ;
  ondskefull_av_1_A : A ;
  ondulerbar_av_1_A : A ;
  onedtransformerbar_av_1_A : A ;
  onedtransponerbar_av_1_A : A ;
  onedvaerderbar_av_1_1_A : A ;
  onegerbar_av_1_A : A ;
  onegligerbar_av_1_A : A ;
  onegocierbar_av_1_A : A ;
  onegotierbar_av_1_A : A ;
  oneklig_av_1_A : A ;
  onertransformerbar_av_1_A : A ;
  onertransponerbar_av_1_A : A ;
  onervaerderbar_av_1_1_A : A ;
  oneutraliserbar_av_1_A : A ;
  oniellerbar_av_1_A : A ;
  onitrerbar_av_1_A : A ;
  onivellerbar_av_1_A : A ;
  onobiliserbar_av_1_A : A ;
  onomastisk_av_1_A : A ;
  onomatopoetisk_av_1_A : A ;
  onominerbar_av_1_A : A ;
  ononchalerbar_av_1_A : A ;
  onormal_av_1_A : A ;
  onormaliserbar_av_1_A : A ;
  onormerbar_av_1_A : A ;
  onoslig_av_1_A : A ;
  onoterbar_av_1_A : A ;
  onotificerbar_av_1_A : A ;
  onotifierbar_av_1_A : A ;
  onotiserbar_av_1_A : A ;
  ontogenetisk_av_1_A : A ;
  ontologisk_av_1_A : A ;
  onumrerbar_av_1_A : A ;
  onyanserbar_av_1_A : A ;
  onyttig_av_1_A : A ;
  onaemnbar_av_1_1_A : A ;
  onaabar_av_1_1_A : A ;
  onaadig_av_1_1_A : A ;
  onoedig_av_1_1_A : A ;
  onoejaktig_av_1_1_A : A ;
  oobducerbar_av_1_A : A ;
  oobjektiverbar_av_1_A : A ;
  oobligerbar_av_1_A : A ;
  oobserverbar_av_1_A : A ;
  ooccidentaliserbar_av_1_A : A ;
  oockuperbar_av_1_A : A ;
  ooffererbar_av_1_A : A ;
  ooktrojerbar_av_1_A : A ;
  ookulerbar_av_1_A : A ;
  oomdirigerbar_av_1_A : A ;
  oomkullkastlig_av_1_A : A ;
  oomkullrunkelig_av_1_A : A ;
  oommoeblerbar_av_1_1_A : A ;
  oomorganiserbar_av_1_A : A ;
  oomplacerbar_av_1_A : A ;
  oomskulpturerbar_av_1_A : A ;
  oomstrukturerbar_av_1_A : A ;
  oomtvistlig_av_1_A : A ;
  oomvaerderbar_av_1_1_A : A ;
  oondulerbar_av_1_A : A ;
  ooperationaliserbar_av_1_A : A ;
  oopererbar_av_1_A : A ;
  oopponerbar_av_1_A : A ;
  ooptimerbar_av_1_A : A ;
  oordentlig_av_1_A : A ;
  oordinerbar_av_1_A : A ;
  oorganiserbar_av_1_A : A ;
  oorganisk_av_1_A : A ;
  oorienterbar_av_1_A : A ;
  oorkestrerbar_av_1_A : A ;
  oornamenterbar_av_1_A : A ;
  oornerbar_av_1_A : A ;
  oortodox_av_1_A : A ;
  ooxiderbar_av_1_A : A ;
  opacificerbar_av_1_A : A ;
  opaginerbar_av_1_A : A ;
  opak_av_1_A : A ;
  opaketerbar_av_1_A : A ;
  opalataliserbar_av_1_A : A ;
  opaljetterbar_av_1_A : A ;
  opalperbar_av_1_A : A ;
  opanerbar_av_1_A : A ;
  opanorerbar_av_1_A : A ;
  opantograferbar_av_1_A : A ;
  oparaderbar_av_1_A : A ;
  oparaferbar_av_1_A : A ;
  oparaffinerbar_av_1_A : A ;
  oparafraserbar_av_1_A : A ;
  oparallelliserbar_av_1_A : A ;
  oparalyserbar_av_1_A : A ;
  oparerbar_av_1_A : A ;
  oparfymerbar_av_1_A : A ;
  oparkerbar_av_1_A : A ;
  oparketterbar_av_1_A : A ;
  oparlamentarisk_av_1_A : A ;
  oparodierbar_av_1_A : A ;
  opartisk_av_1_A : A ;
  opasserbar_av_1_A : A ;
  opassiverbar_av_1_A : A ;
  opassiviserbar_av_1_A : A ;
  opasslig_av_1_A : A ;
  opastoeriserbar_av_1_1_A : A ;
  opatenterbar_av_1_A : A ;
  opatinerbar_av_1_A : A ;
  opatrullerbar_av_1_A : A ;
  opauperiserbar_av_1_A : A ;
  opauserbar_av_1_A : A ;
  opedagogisk_av_1_A : A ;
  opelleterbar_av_1_A : A ;
  openetrerbar_av_1_A : A ;
  opensionerbar_av_1_A : A ;
  operamaessig_av_1_1_A : A ;
  operationaliserbar_av_1_A : A ;
  operationell_av_1_A : A ;
  operativ_av_1_A : A ;
  opercipierbar_av_1_A : A ;
  opererbar_av_1_A : A ;
  operforerbar_av_1_A : A ;
  operiodiserbar_av_1_A : A ;
  opermitterbar_av_1_A : A ;
  opermuterbar_av_1_A : A ;
  opersiflerbar_av_1_A : A ;
  opersonifierbar_av_1_A : A ;
  opersonlig_av_1_A : A ;
  opersvaderbar_av_1_A : A ;
  operverterbar_av_1_A : A ;
  opetrifierbar_av_1_A : A ;
  opikerbar_av_1_A : A ;
  opincerbar_av_1_A : A ;
  opinionsmaessig_av_1_1_A : A ;
  oplacerbar_av_1_A : A ;
  oplagierbar_av_1_A : A ;
  oplanerbar_av_1_A : A ;
  oplanterbar_av_1_A : A ;
  oplatinerbar_av_1_A : A ;
  oplisserbar_av_1_A : A ;
  oplomberbar_av_1_A : A ;
  oplaeterbar_av_1_1_A : A ;
  opocherbar_av_1_A : A ;
  opointerbar_av_1_A : A ;
  opolariserbar_av_1_A : A ;
  opolerbar_av_1_A : A ;
  opolitiserbar_av_1_A : A ;
  opolitisk_av_1_A : A ;
  opolletterbar_av_1_A : A ;
  opollinerbar_av_1_A : A ;
  opomaderbar_av_1_A : A ;
  opopulariserbar_av_1_A : A ;
  oportionerbar_av_1_A : A ;
  oportraetterbar_av_1_1_A : A ;
  opostdaterbar_av_1_A : A ;
  oposterbar_av_1_A : A ;
  opostponerbar_av_1_A : A ;
  opostulerbar_av_1_A : A ;
  opoaengterbar_av_1_1_A : A ;
  oppfinningsrik_av_1_A : A ;
  oppfaellbar_av_1_1_A : A ;
  opphinnelig_av_1_A : A ;
  oppjusterbar_av_1_A : A ;
  oppkaeftig_av_1_1_A : A ;
  opponerbar_av_1_A : A ;
  opportun_av_1_A : A ;
  opportunistisk_av_1_A : A ;
  oppositionell_av_1_A : A ;
  oppsummerbar_av_1_A : A ;
  oppvaerderbar_av_1_1_A : A ;
  opraktiserbar_av_1_A : A ;
  opraktisk_av_1_A : A ;
  oprecis_av_1_A : A ;
  opreciserbar_av_1_A : A ;
  opredestinerbar_av_1_A : A ;
  opredicerbar_av_1_A : A ;
  opredisponerbar_av_1_A : A ;
  oprefabricerbar_av_1_A : A ;
  oprefererbar_av_1_A : A ;
  oprefigerbar_av_1_A : A ;
  opreludierbar_av_1_A : A ;
  opremierbar_av_1_A : A ;
  opreparerbar_av_1_A : A ;
  opresenterbar_av_1_A : A ;
  opreserverbar_av_1_A : A ;
  opreskriberbar_av_1_A : A ;
  opresterbar_av_1_A : A ;
  opresumerbar_av_1_A : A ;
  opretentioes_av_1_1_A : A ;
  oprioriterbar_av_1_A : A ;
  oprivatiserbar_av_1_A : A ;
  oprivilegierbar_av_1_A : A ;
  oproberbar_av_1_A : A ;
  oproblematiserbar_av_1_A : A ;
  oproducerbar_av_1_A : A ;
  oprofanerbar_av_1_A : A ;
  oprofessionaliserbar_av_1_A : A ;
  oprofilerbar_av_1_A : A ;
  oprognostiserbar_av_1_A : A ;
  oprogrammerbar_av_1_A : A ;
  oprojekterbar_av_1_A : A ;
  oprojicerbar_av_1_A : A ;
  oproklamerbar_av_1_A : A ;
  oproletariserbar_av_1_A : A ;
  oprolongerbar_av_1_A : A ;
  opromoverbar_av_1_A : A ;
  opromulgerbar_av_1_A : A ;
  oprononcerbar_av_1_A : A ;
  oproponerbar_av_1_A : A ;
  oproportionerbar_av_1_A : A ;
  oproportionerlig_av_1_A : A ;
  oproskriberbar_av_1_A : A ;
  oprospekterbar_av_1_A : A ;
  oprotegerbar_av_1_A : A ;
  oprotokollerbar_av_1_A : A ;
  oprovocerbar_av_1_A : A ;
  opsykologiserbar_av_1_A : A ;
  opsykologisk_av_1_A : A ;
  optativ_av_1_A : A ;
  optimal_av_1_A : A ;
  optimerbar_av_1_A : A ;
  optimistisk_av_1_A : A ;
  optisk_av_1_A : A ;
  opublicerbar_av_1_A : A ;
  opulveriserbar_av_1_A : A ;
  opulvriserbar_av_1_A : A ;
  opunkterbar_av_1_A : A ;
  opurgerbar_av_1_A : A ;
  opaaannonserbar_av_1_1_A : A ;
  opaalitlig_av_1_1_A : A ;
  opaaverkbar_av_1_1_A : A ;
  orabatterbar_av_1_A : A ;
  oraderbar_av_1_A : A ;
  oradierbar_av_1_A : A ;
  oradikaliserbar_av_1_A : A ;
  oraffinerbar_av_1_A : A ;
  orakelmaessig_av_1_1_A : A ;
  oral_av_1_A : A ;
  oramponerbar_av_1_A : A ;
  orangerbar_av_1_A : A ;
  oransonerbar_av_1_A : A ;
  orappellerbar_av_1_A : A ;
  orapporterbar_av_1_A : A ;
  oraserbar_av_1_A : A ;
  oratificerbar_av_1_A : A ;
  orationaliserbar_av_1_A : A ;
  orationell_av_1_A : A ;
  oratorisk_av_1_A : A ;
  orddoev_av_1_1_A : A ;
  ordentlig_av_1_A : A ;
  ordfattig_av_1_A : A ;
  ordhaallig_av_1_1_A : A ;
  ordinerbar_av_1_A : A ;
  ordinaer_av_1_1_A : A ;
  ordkarg_av_1_A : A ;
  ordknapp_av_1_A : A ;
  ordloes_av_1_1_A : A ;
  ordrik_av_1_A : A ;
  ordspraaksmaessig_av_1_1_A : A ;
  oreaktiverbar_av_1_A : A ;
  orealiserbar_av_1_A : A ;
  orealistisk_av_1_A : A ;
  oreassurerbar_av_1_A : A ;
  orecenserbar_av_1_A : A ;
  orecipierbar_av_1_A : A ;
  oreciterbar_av_1_A : A ;
  oredig_av_1_A : A ;
  oredigerbar_av_1_A : A ;
  oredlig_av_1_A : A ;
  oreducerbar_av_1_A : A ;
  orefererbar_av_1_A : A ;
  oreflekterbar_av_1_A : A ;
  oreformerbar_av_1_A : A ;
  orefuserbar_av_1_A : A ;
  oregalerbar_av_1_A : A ;
  oregelmaessig_av_1_1_A : A ;
  oregenererbar_av_1_A : A ;
  oregerbar_av_1_A : A ;
  oregerlig_av_1_A : A ;
  oregisserbar_av_1_A : A ;
  oregistrerbar_av_1_A : A ;
  oreglementerbar_av_1_A : A ;
  oreglerbar_av_1_A : A ;
  oregummerbar_av_1_A : A ;
  orehabiliterbar_av_1_A : A ;
  oreinkarnerbar_av_1_A : A ;
  orekapitulerbar_av_1_A : A ;
  oreklamerbar_av_1_A : A ;
  orekognoscerbar_av_1_A : A ;
  orekognoserbar_av_1_A : A ;
  orekommenderbar_av_1_A : A ;
  orekompenserbar_av_1_A : A ;
  orekonstruerbar_av_1_A : A ;
  orekryterbar_av_1_A : A ;
  orektificerbar_av_1_A : A ;
  orektifierbar_av_1_A : A ;
  orekvirerbar_av_1_A : A ;
  orelaterbar_av_1_A : A ;
  orelegerbar_av_1_A : A ;
  oremitterbar_av_1_A : A ;
  oremplacerbar_av_1_A : A ;
  oren_av_1_A : A ;
  orenderbar_av_1_A : A ;
  orenlig_av_1_A : A ;
  orenoverbar_av_1_A : A ;
  oreorganiserbar_av_1_A : A ;
  oreparerbar_av_1_A : A ;
  orepartiserbar_av_1_A : A ;
  orepatrierbar_av_1_A : A ;
  orepellerbar_av_1_A : A ;
  orepeterbar_av_1_A : A ;
  orepresenterbar_av_1_A : A ;
  orepriserbar_av_1_A : A ;
  oreproducerbar_av_1_A : A ;
  oreserverbar_av_1_A : A ;
  oresolverbar_av_1_A : A ;
  oresonlig_av_1_A : A ;
  oresorberbar_av_1_A : A ;
  orespekterbar_av_1_A : A ;
  orespirerbar_av_1_A : A ;
  orestaurerbar_av_1_A : A ;
  orestituerbar_av_1_A : A ;
  oresumerbar_av_1_A : A ;
  oretablerbar_av_1_A : A ;
  oretarderbar_av_1_A : A ;
  oreturnerbar_av_1_A : A ;
  oretuscherbar_av_1_A : A ;
  orevalverbar_av_1_A : A ;
  oreveterbar_av_1_A : A ;
  oreviderbar_av_1_A : A ;
  orevolutionerbar_av_1_A : A ;
  orfisk_av_1_A : A ;
  organisationsmaessig_av_1_1_A : A ;
  organisatorisk_av_1_A : A ;
  organiserbar_av_1_A : A ;
  organisk_av_1_A : A ;
  orgastisk_av_1_A : A ;
  orgelmaessig_av_1_1_A : A ;
  orgiastisk_av_1_A : A ;
  orientalisk_av_1_A : A ;
  orienterbar_av_1_A : A ;
  originell_av_1_A : A ;
  oriktig_av_1_A : A ;
  orimlig_av_1_A : A ;
  oritualiserbar_av_1_A : A ;
  orkesloes_av_1_1_A : A ;
  orkestral_av_1_A : A ;
  orkestrerbar_av_1_A : A ;
  orkloes_av_1_1_A : A ;
  ornamental_av_1_A : A ;
  ornamenterbar_av_1_A : A ;
  ornerbar_av_1_A : A ;
  ornitologisk_av_1_A : A ;
  orobotiserbar_av_1_A : A ;
  orockerbar_av_1_A : A ;
  orogenetisk_av_1_A : A ;
  orolig_av_1_A : A ;
  oromantiserbar_av_1_A : A ;
  oroterbar_av_1_A : A ;
  orsaklig_av_1_A : A ;
  orsaksmaessig_av_1_1_A : A ;
  ortlig_av_1_A : A ;
  ortodox_av_1_A : A ;
  ortogonal_av_1_A : A ;
  ortokromatisk_av_1_A : A ;
  orubblig_av_1_A : A ;
  orubricerbar_av_1_A : A ;
  oruinerbar_av_1_A : A ;
  orussificerbar_av_1_A : A ;
  orussifierbar_av_1_A : A ;
  orygglig_av_1_A : A ;
  orytmiserbar_av_1_A : A ;
  orytmisk_av_1_A : A ;
  oraeknelig_av_1_1_A : A ;
  oraettfaerdig_av_1_1_A : A ;
  oraettmaetig_av_1_1_A : A ;
  oraettraadig_av_1_1_A : A ;
  oraettvis_av_1_1_A : A ;
  oroerbar_av_1_1_A : A ;
  oroerlig_av_1_1_A : A ;
  osaboterbar_av_1_A : A ;
  osabrerbar_av_1_A : A ;
  osakkunnig_av_1_A : A ;
  osaklig_av_1_A : A ;
  osalderbar_av_1_A : A ;
  osalig_av_1_A : A ;
  osaluterbar_av_1_A : A ;
  osamtaxerbar_av_1_A : A ;
  osanerbar_av_1_A : A ;
  osanforiserbar_av_1_A : A ;
  osanktifierbar_av_1_A : A ;
  osanktionerbar_av_1_A : A ;
  osannfaerdig_av_1_1_A : A ;
  osannolik_av_1_A : A ;
  osaponifierbar_av_1_A : A ;
  osatinerbar_av_1_A : A ;
  osatisfierbar_av_1_A : A ;
  osaturerbar_av_1_A : A ;
  osauterbar_av_1_A : A ;
  osauverbar_av_1_A : A ;
  oschablonerbar_av_1_A : A ;
  oschabloniserbar_av_1_A : A ;
  oschamponerbar_av_1_A : A ;
  oschatterbar_av_1_A : A ;
  oschematiserbar_av_1_A : A ;
  osedimenterbar_av_1_A : A ;
  osedlig_av_1_A : A ;
  osedvanlig_av_1_A : A ;
  osegmenterbar_av_1_A : A ;
  osegregerbar_av_1_A : A ;
  osekonderbar_av_1_A : A ;
  osekulariserbar_av_1_A : A ;
  osekunderbar_av_1_A : A ;
  osekvestrerbar_av_1_A : A ;
  oselekterbar_av_1_A : A ;
  osemaforerbar_av_1_A : A ;
  oseminerbar_av_1_A : A ;
  osensibiliserbar_av_1_A : A ;
  osenterbar_av_1_A : A ;
  osentimental_av_1_A : A ;
  oseparerbar_av_1_A : A ;
  oserioes_av_1_1_A : A ;
  oserverbar_av_1_A : A ;
  osexualiserbar_av_1_A : A ;
  oshamponerbar_av_1_A : A ;
  osigillerbar_av_1_A : A ;
  osignalerbar_av_1_A : A ;
  osignerbar_av_1_A : A ;
  osiktbar_av_1_A : A ;
  osiktig_av_1_A : A ;
  osilhuetterbar_av_1_A : A ;
  osiluetterbar_av_1_A : A ;
  osimplifierbar_av_1_A : A ;
  osimulerbar_av_1_A : A ;
  osinlig_av_1_A : A ;
  osinnlig_av_1_A : A ;
  osjaelvisk_av_1_1_A : A ;
  osjaelvstaendig_av_1_1_A : A ;
  oskadlig_av_1_A : A ;
  oskalperbar_av_1_A : A ;
  oskandaliserbar_av_1_A : A ;
  oskanderbar_av_1_A : A ;
  oskaplig_av_1_A : A ;
  oskariansk_av_1_A : A ;
  oskarp_av_1_A : A ;
  oskattbar_av_1_A : A ;
  oskicklig_av_1_A : A ;
  oskiljaktig_av_1_A : A ;
  oskisserbar_av_1_A : A ;
  oskrafferbar_av_1_A : A ;
  oskuldsfull_av_1_A : A ;
  oskulpterbar_av_1_A : A ;
  oskulpturerbar_av_1_A : A ;
  oskyldig_av_1_A : A ;
  oskaelig_av_1_1_A : A ;
  oskoen_av_1_1_A : A ;
  oslagbar_av_1_A : A ;
  oslaviserbar_av_1_A : A ;
  oslaecklig_av_1_1_A : A ;
  osmaklig_av_1_A : A ;
  osmansk_av_1_A : A ;
  osmidbar_av_1_A : A ;
  osmidig_av_1_A : A ;
  osmotisk_av_1_A : A ;
  osmaeltbar_av_1_1_A : A ;
  osnedrekryterbar_av_1_A : A ;
  osnygg_av_1_A : A ;
  osocial_av_1_A : A ;
  osocialiserbar_av_1_A : A ;
  osolidarisk_av_1_A : A ;
  osolverbar_av_1_A : A ;
  osonderbar_av_1_A : A ;
  osordinerbar_av_1_A : A ;
  osorterbar_av_1_A : A ;
  osoulagerbar_av_1_A : A ;
  osovjetiserbar_av_1_A : A ;
  ospaljerbar_av_1_A : A ;
  ospallerbar_av_1_A : A ;
  ospecialiserbar_av_1_A : A ;
  ospecificerbar_av_1_A : A ;
  ospeciminerbar_av_1_A : A ;
  ospekulerbar_av_1_A : A ;
  ospelbar_av_1_A : A ;
  ospenderbar_av_1_A : A ;
  ospolierbar_av_1_A : A ;
  osportslig_av_1_A : A ;
  ostabiliserbar_av_1_A : A ;
  ostadig_av_1_A : A ;
  ostafferbar_av_1_A : A ;
  ostandardiserbar_av_1_A : A ;
  ostationerbar_av_1_A : A ;
  ostatuerbar_av_1_A : A ;
  ostencilerbar_av_1_A : A ;
  ostenograferbar_av_1_A : A ;
  ostensiv_av_1_A : A ;
  ostentativ_av_1_A : A ;
  ostereotyperbar_av_1_A : A ;
  osteriliserbar_av_1_A : A ;
  ostig_av_1_A : A ;
  ostigmatiserbar_av_1_A : A ;
  ostiliserbar_av_1_A : A ;
  ostimulerbar_av_1_A : A ;
  ostindisk_av_1_A : A ;
  ostipendierbar_av_1_A : A ;
  ostipulerbar_av_1_A : A ;
  ostjakisk_av_1_A : A ;
  ostlig_av_1_A : A ;
  ostofferbar_av_1_A : A ;
  ostrafflig_av_1_A : A ;
  ostrangulerbar_av_1_A : A ;
  ostratifierbar_av_1_A : A ;
  ostridig_av_1_A : A ;
  ostrukturerbar_av_1_A : A ;
  ostuderbar_av_1_A : A ;
  ostyrig_av_1_A : A ;
  osublimerbar_av_1_A : A ;
  osubordinerbar_av_1_A : A ;
  osubsidierbar_av_1_A : A ;
  osubskriberbar_av_1_A : A ;
  osubstantiverbar_av_1_A : A ;
  osubstituerbar_av_1_A : A ;
  osubsumerbar_av_1_A : A ;
  osubtraherbar_av_1_A : A ;
  osubventionerbar_av_1_A : A ;
  osuccederbar_av_1_A : A ;
  osuffigerbar_av_1_A : A ;
  osufflerbar_av_1_A : A ;
  osuggererbar_av_1_A : A ;
  osummerbar_av_1_A : A ;
  osupplerbar_av_1_A : A ;
  osupponerbar_av_1_A : A ;
  osurfbar_av_1_A : A ;
  osuspenderbar_av_1_A : A ;
  osvensk_av_1_A : A ;
  osviklig_av_1_A : A ;
  osymboliserbar_av_1_A : A ;
  osymmetrisk_av_1_A : A ;
  osympatisk_av_1_A : A ;
  osynkoperbar_av_1_A : A ;
  osynkroniserbar_av_1_A : A ;
  osynlig_av_1_A : A ;
  osyntetiserbar_av_1_A : A ;
  osystematiserbar_av_1_A : A ;
  osystematisk_av_1_A : A ;
  osaegbar_av_1_1_A : A ;
  osaeglig_av_1_1_A : A ;
  osaeljbar_av_1_1_A : A ;
  osaell_av_1_1_A : A ;
  osaellskaplig_av_1_1_A : A ;
  osaenkbar_av_1_1_A : A ;
  osaarbar_av_1_1_A : A ;
  osaaterbar_av_1_1_A : A ;
  osaaverbar_av_1_1_A : A ;
  otabellerbar_av_1_A : A ;
  otabuerbar_av_1_A : A ;
  otadlig_av_1_A : A ;
  otalig_av_1_A : A ;
  otamponerbar_av_1_A : A ;
  otangerbar_av_1_A : A ;
  otapetserbar_av_1_A : A ;
  otarerbar_av_1_A : A ;
  otarifferbar_av_1_A : A ;
  otatuerbar_av_1_A : A ;
  otaxerbar_av_1_A : A ;
  oteknifierbar_av_1_A : A ;
  oteknisk_av_1_A : A ;
  otelefonerbar_av_1_A : A ;
  otelegraferbar_av_1_A : A ;
  oteleviserbar_av_1_A : A ;
  otemperbar_av_1_A : A ;
  otempererbar_av_1_A : A ;
  otenterbar_av_1_A : A ;
  oterrasserbar_av_1_A : A ;
  oterroriserbar_av_1_A : A ;
  otesaurerbar_av_1_A : A ;
  otestamenterbar_av_1_A : A ;
  otidig_av_1_A : A ;
  otidsenlig_av_1_A : A ;
  otillboerlig_av_1_1_A : A ;
  otillfoerlitlig_av_1_1_A : A ;
  otillgaenglig_av_1_1_A : A ;
  otillraecklig_av_1_1_A : A ;
  otillraeknelig_av_1_1_A : A ;
  otillstaendig_av_1_1_A : A ;
  otillaemplig_av_1_1_A : A ;
  otillaatlig_av_1_1_A : A ;
  otitrerbar_av_1_A : A ;
  otitulerbar_av_1_A : A ;
  otjusig_av_1_A : A ;
  otjaenlig_av_1_1_A : A ;
  otolererbar_av_1_A : A ;
  otorderbar_av_1_A : A ;
  otorpederbar_av_1_A : A ;
  otorterbar_av_1_A : A ;
  otoucherbar_av_1_A : A ;
  otouperbar_av_1_A : A ;
  otraderbar_av_1_A : A ;
  otrafikerbar_av_1_A : A ;
  otrakasserbar_av_1_A : A ;
  otrakterbar_av_1_A : A ;
  otrancherbar_av_1_A : A ;
  otransfererbar_av_1_A : A ;
  otransformerbar_av_1_A : A ;
  otransiterbar_av_1_A : A ;
  otranskriberbar_av_1_A : A ;
  otranslittererbar_av_1_A : A ;
  otransmitterbar_av_1_A : A ;
  otransmuterbar_av_1_A : A ;
  otransplanterbar_av_1_A : A ;
  otransponerbar_av_1_A : A ;
  otransporterbar_av_1_A : A ;
  otransumerbar_av_1_A : A ;
  otrasserbar_av_1_A : A ;
  otravesterbar_av_1_A : A ;
  otrepanerbar_av_1_A : A ;
  otrevlig_av_1_A : A ;
  otriangulerbar_av_1_A : A ;
  otrierbar_av_1_A : A ;
  otrivialiserbar_av_1_A : A ;
  otrolig_av_1_A : A ;
  otryckbar_av_1_A : A ;
  otryfferbar_av_1_A : A ;
  otrygg_av_1_A : A ;
  otroestlig_av_1_1_A : A ;
  otroettlig_av_1_1_A : A ;
  ottomansk_av_1_A : A ;
  otuktig_av_1_A : A ;
  otuperbar_av_1_A : A ;
  oturlig_av_1_A : A ;
  oturnerbar_av_1_A : A ;
  otuscherbar_av_1_A : A ;
  otvetydig_av_1_A : A ;
  otvivelaktig_av_1_A : A ;
  otydbar_av_1_A : A ;
  otydlig_av_1_A : A ;
  otymplig_av_1_A : A ;
  otypifierbar_av_1_A : A ;
  otypiserbar_av_1_A : A ;
  otypisk_av_1_A : A ;
  otyranniserbar_av_1_A : A ;
  otaeck_av_1_1_A : A ;
  otaemjbar_av_1_1_A : A ;
  otaenjbar_av_1_1_A : A ;
  otaenkbar_av_1_1_A : A ;
  otaet_av_1_1_A : A ;
  otaalig_av_1_1_A : A ;
  otoerstig_av_1_1_A : A ;
  oumbaerlig_av_1_1_A : A ;
  ounderbalanserbar_av_1_A : A ;
  ounderdimensionerbar_av_1_A : A ;
  ounderexponerbar_av_1_A : A ;
  ounderminerbar_av_1_A : A ;
  oundertaxerbar_av_1_A : A ;
  oundervaerderbar_av_1_1_A : A ;
  oundgaenglig_av_1_1_A : A ;
  oundviklig_av_1_A : A ;
  ounifierbar_av_1_A : A ;
  ouniformerbar_av_1_A : A ;
  ouppdaterbar_av_1_A : A ;
  ouppfattbar_av_1_A : A ;
  ouppgraderbar_av_1_A : A ;
  oupphinnelig_av_1_A : A ;
  oupphoerlig_av_1_1_A : A ;
  ouppjusterbar_av_1_A : A ;
  oupploeslig_av_1_1_A : A ;
  ouppnaaelig_av_1_1_A : A ;
  ouppreklamerbar_av_1_A : A ;
  ouppskattbar_av_1_A : A ;
  ouppsummerbar_av_1_A : A ;
  ouppsaegbar_av_1_1_A : A ;
  ouppsaatlig_av_1_1_A : A ;
  oupptaxerbar_av_1_A : A ;
  ouppvaerderbar_av_1_1_A : A ;
  ourbaniserbar_av_1_A : A ;
  oursaektlig_av_1_1_A : A ;
  ousurperbar_av_1_A : A ;
  outackorderbar_av_1_A : A ;
  outannonserbar_av_1_A : A ;
  outarrenderbar_av_1_A : A ;
  outbalanserbar_av_1_A : A ;
  outbasunerbar_av_1_A : A ;
  outbroderbar_av_1_A : A ;
  outdebiterbar_av_1_A : A ;
  outexaminerbar_av_1_A : A ;
  outexperimenterbar_av_1_A : A ;
  outfoerbar_av_1_1_A : A ;
  outgrundlig_av_1_A : A ;
  outhaerdlig_av_1_1_A : A ;
  outklarerbar_av_1_A : A ;
  outkommenderbar_av_1_A : A ;
  outkonkurrerbar_av_1_A : A ;
  outkristalliserbar_av_1_A : A ;
  outkvitterbar_av_1_A : A ;
  outlokaliserbar_av_1_A : A ;
  outmanoevrerbar_av_1_1_A : A ;
  outminuterbar_av_1_A : A ;
  outplacerbar_av_1_A : A ;
  outplaanlig_av_1_1_A : A ;
  outposterbar_av_1_A : A ;
  outraderbar_av_1_A : A ;
  outrangerbar_av_1_A : A ;
  outrannsaklig_av_1_A : A ;
  outrotlig_av_1_A : A ;
  outsinlig_av_1_A : A ;
  outslitlig_av_1_A : A ;
  outslaecklig_av_1_1_A : A ;
  outstofferbar_av_1_A : A ;
  outsaegbar_av_1_1_A : A ;
  outsaeglig_av_1_1_A : A ;
  outtalbar_av_1_A : A ;
  outtaxerbar_av_1_A : A ;
  outtroettlig_av_1_1_A : A ;
  outtoemlig_av_1_1_A : A ;
  outvaerderbar_av_1_1_A : A ;
  ovaccinerbar_av_1_A : A ;
  ovadderbar_av_1_A : A ;
  ovaksinerbar_av_1_A : A ;
  oval_av_1_A : A ;
  ovaluterbar_av_1_A : A ;
  ovalverbar_av_1_A : A ;
  ovan_av_1_A : A ;
  ovandaliserbar_av_1_A : A ;
  ovanjordisk_av_1_A : A ;
  ovanlig_av_1_A : A ;
  ovansklig_av_1_A : A ;
  ovarierbar_av_1_A : A ;
  ovederhaeftig_av_1_1_A : A ;
  ovederlaegglig_av_1_1_A : A ;
  ovedersaeglig_av_1_1_A : A ;
  ovelouriserbar_av_1_A : A ;
  oventilerbar_av_1_A : A ;
  overbaliserbar_av_1_A : A ;
  overifierbar_av_1_A : A ;
  overklig_av_1_A : A ;
  oversifierbar_av_1_A : A ;
  ovetbar_av_1_A : A ;
  ovetenskaplig_av_1_A : A ;
  ovettig_av_1_A : A ;
  ovidimerbar_av_1_A : A ;
  ovig_av_1_A : A ;
  oviktig_av_1_A : A ;
  ovillig_av_1_A : A ;
  ovillkorlig_av_1_A : A ;
  ovindicerbar_av_1_A : A ;
  ovipar_av_1_A : A ;
  ovis_av_1_A : A ;
  oviserbar_av_1_A : A ;
  ovisiterbar_av_1_A : A ;
  oviss_av_1_A : A ;
  ovisualiserbar_av_1_A : A ;
  ovitaliserbar_av_1_A : A ;
  ovitaminerbar_av_1_A : A ;
  ovitaminiserbar_av_1_A : A ;
  ovokaliserbar_av_1_A : A ;
  ovulgariserbar_av_1_A : A ;
  ovulkaniserbar_av_1_A : A ;
  ovaeldig_av_1_1_A : A ;
  ovaenlig_av_1_1_A : A ;
  ovaerderbar_av_1_1_A : A ;
  ovaerderlig_av_1_1_A : A ;
  ovaerdig_av_1_1_A : A ;
  ovaerldslig_av_1_1_A : A ;
  ovaesentlig_av_1_1_A : A ;
  ovaalig_av_1_1_A : A ;
  oxiderbar_av_1_A : A ;
  oaendlig_av_1_1_A : A ;
  oaerlig_av_1_1_A : A ;
  oaetbar_av_1_1_A : A ;
  oaetlig_av_1_1_A : A ;
  oaaterinstallerbar_av_1_1_A : A ;
  oaaterkallelig_av_1_1_A : A ;
  oaatkomlig_av_1_1_A : A ;
  ooeverbrygglig_av_1_1_A : A ;
  ooeverdimensionerbar_av_1_1_A : A ;
  ooeverdoserbar_av_1_1_A : A ;
  ooeverexponerbar_av_1_1_A : A ;
  ooeverkomlig_av_1_1_A : A ;
  ooeverkompenserbar_av_1_1_A : A ;
  ooeverskaadlig_av_1_1_A : A ;
  ooeverstiglig_av_1_1_A : A ;
  ooeversaettlig_av_1_1_A : A ;
  ooevertrasserbar_av_1_1_A : A ;
  ooevertraefflig_av_1_1_A : A ;
  ooevervinnelig_av_1_1_A : A ;
  ooevervinnerlig_av_1_1_A : A ;
  ooevervinnlig_av_1_1_A : A ;
  ooevervaerderbar_av_1_1_A : A ;
  pacificerbar_av_1_A : A ;
  pacifistisk_av_1_A : A ;
  paff_av_1_A : A ;
  paginerbar_av_1_A : A ;
  pajig_av_1_A : A ;
  paketerbar_av_1_A : A ;
  pakistansk_av_1_A : A ;
  palatal_av_1_A : A ;
  palataliserbar_av_1_A : A ;
  palauisk_av_1_A : A ;
  paleoekologisk_av_1_A : A ;
  paleolitisk_av_1_A : A ;
  paleontologisk_av_1_A : A ;
  palestinsk_av_1_A : A ;
  paljetterbar_av_1_A : A ;
  palliativ_av_1_A : A ;
  palperbar_av_1_A : A ;
  paltig_av_1_A : A ;
  pampig_av_1_A : A ;
  panafrikansk_av_1_A : A ;
  panamansk_av_1_A : A ;
  panamerikansk_av_1_A : A ;
  panarabisk_av_1_A : A ;
  panegyrisk_av_1_A : A ;
  panerbar_av_1_A : A ;
  panikmaessig_av_1_1_A : A ;
  panisk_av_1_A : A ;
  pank_av_1_A : A ;
  pankromatisk_av_1_A : A ;
  panorerbar_av_1_A : A ;
  panteistisk_av_1_A : A ;
  pantograferbar_av_1_A : A ;
  pantomimisk_av_1_A : A ;
  pappaledig_av_1_A : A ;
  pappersloes_av_1_1_A : A ;
  pappig_av_1_A : A ;
  papuansk_av_1_A : A ;
  parabolisk_av_1_A : A ;
  paraderbar_av_1_A : A ;
  paradisisk_av_1_A : A ;
  paradmaessig_av_1_1_A : A ;
  paradoxal_av_1_A : A ;
  paraferbar_av_1_A : A ;
  paraffinerbar_av_1_A : A ;
  parafraserbar_av_1_A : A ;
  parafrastisk_av_1_A : A ;
  paraguayansk_av_1_A : A ;
  paraguaysk_av_1_A : A ;
  parallell_av_1_A : A ;
  parallelliserbar_av_1_A : A ;
  paralyserbar_av_1_A : A ;
  paralytisk_av_1_A : A ;
  paramilitaer_av_1_1_A : A ;
  parasitisk_av_1_A : A ;
  parasitaer_av_1_1_A : A ;
  parataktisk_av_1_A : A ;
  parbladig_av_1_A : A ;
  parentetisk_av_1_A : A ;
  parerbar_av_1_A : A ;
  parflikig_av_1_A : A ;
  parfymerbar_av_1_A : A ;
  parig_av_1_A : A ;
  parisisk_av_1_A : A ;
  parkerbar_av_1_A : A ;
  parketterbar_av_1_A : A ;
  parlamentarisk_av_1_A : A ;
  parodierbar_av_1_A : A ;
  parodisk_av_1_A : A ;
  participiell_av_1_A : A ;
  partiell_av_1_A : A ;
  partikuljaer_av_1_1_A : A ;
  partikulaer_av_1_1_A : A ;
  partiloes_av_1_1_A : A ;
  partimaessig_av_1_1_A : A ;
  partipolitisk_av_1_A : A ;
  partisk_av_1_A : A ;
  partitiv_av_1_A : A ;
  partaaig_av_1_1_A : A ;
  passerbar_av_1_A : A ;
  passionsfri_av_1_A : A ;
  passiv_av_1_A : A ;
  passiverbar_av_1_A : A ;
  passiviserbar_av_1_A : A ;
  passlig_av_1_A : A ;
  pastoral_av_1_A : A ;
  pastos_av_1_A : A ;
  pastoeriserbar_av_1_1_A : A ;
  pastoes_av_1_1_A : A ;
  patenterbar_av_1_A : A ;
  patetisk_av_1_A : A ;
  patinerbar_av_1_A : A ;
  patologisk_av_1_A : A ;
  patriarkal_av_1_A : A ;
  patriarkalisk_av_1_A : A ;
  patriotisk_av_1_A : A ;
  patrullerbar_av_1_A : A ;
  pauperiserbar_av_1_A : A ;
  pauserbar_av_1_A : A ;
  pauskommaterbar_av_1_A : A ;
  pedagogisk_av_1_A : A ;
  pedantisk_av_1_A : A ;
  pediatrisk_av_1_A : A ;
  pejorativ_av_1_A : A ;
  pekoralistisk_av_1_A : A ;
  pekuniaer_av_1_1_A : A ;
  pelagisk_av_1_A : A ;
  pelarformig_av_1_A : A ;
  pelleterbar_av_1_A : A ;
  penetrerbar_av_1_A : A ;
  pengamaessig_av_1_1_A : A ;
  penningmaessig_av_1_1_A : A ;
  pensionerbar_av_1_A : A ;
  pensionsmaessig_av_1_1_A : A ;
  perceptuell_av_1_A : A ;
  percipierbar_av_1_A : A ;
  peremtorisk_av_1_A : A ;
  perfektiv_av_1_A : A ;
  perfektivisk_av_1_A : A ;
  perforerbar_av_1_A : A ;
  perifrastisk_av_1_A : A ;
  perinatal_av_1_A : A ;
  periodiserbar_av_1_A : A ;
  periodisk_av_1_A : A ;
  periskopisk_av_1_A : A ;
  peristaltisk_av_1_A : A ;
  perkutan_av_1_A : A ;
  permanentondulerbar_av_1_A : A ;
  permitterbar_av_1_A : A ;
  permuterbar_av_1_A : A ;
  pernicioes_av_1_1_A : A ;
  perpendikulaer_av_1_1_A : A ;
  perpetuell_av_1_A : A ;
  perplex_av_1_A : A ;
  persiflerbar_av_1_A : A ;
  persisk_av_1_A : A ;
  personalmaessig_av_1_1_A : A ;
  personell_av_1_A : A ;
  personhistorisk_av_1_A : A ;
  personifierbar_av_1_A : A ;
  personlig_av_1_A : A ;
  personlighetsmaessig_av_1_1_A : A ;
  personmaessig_av_1_1_A : A ;
  personpolitisk_av_1_A : A ;
  perspektivisk_av_1_A : A ;
  perspektivloes_av_1_1_A : A ;
  perspektivmaessig_av_1_1_A : A ;
  persvaderbar_av_1_A : A ;
  peruansk_av_1_A : A ;
  pervers_av_1_A : A ;
  perverterbar_av_1_A : A ;
  pessimistisk_av_1_A : A ;
  petig_av_1_A : A ;
  petrifierbar_av_1_A : A ;
  petrokemisk_av_1_A : A ;
  pietetsfull_av_1_A : A ;
  pietetsloes_av_1_1_A : A ;
  piffig_av_1_A : A ;
  pigg_av_1_A : A ;
  pikerbar_av_1_A : A ;
  pillemarisk_av_1_A : A ;
  pillrig_av_1_A : A ;
  pilsk_av_1_A : A ;
  pilsnabb_av_1_A : A ;
  pincerbar_av_1_A : A ;
  pingstvaenlig_av_1_1_A : A ;
  pinknoedig_av_1_1_A : A ;
  pinlig_av_1_A : A ;
  pinnig_av_1_A : A ;
  pionjaermaessig_av_1_1_A : A ;
  pipig_av_1_A : A ;
  pirrig_av_1_A : A ;
  pissig_av_1_A : A ;
  pittoresk_av_1_A : A ;
  pjoskig_av_1_A : A ;
  pjunkig_av_1_A : A ;
  pjaakig_av_1_1_A : A ;
  placerbar_av_1_A : A ;
  pladdrig_av_1_A : A ;
  plagierbar_av_1_A : A ;
  plan_av_1_A : A ;
  planenlig_av_1_A : A ;
  planerbar_av_1_A : A ;
  planeringsmaessig_av_1_1_A : A ;
  planetarisk_av_1_A : A ;
  plankonkav_av_1_A : A ;
  plankonvex_av_1_A : A ;
  planloes_av_1_1_A : A ;
  planmaessig_av_1_1_A : A ;
  planparallell_av_1_A : A ;
  planterbar_av_1_A : A ;
  plaskvaat_av_1_1_A : A ;
  plastisk_av_1_A : A ;
  platinerbar_av_1_A : A ;
  platonisk_av_1_A : A ;
  platonsk_av_1_A : A ;
  platsmaessig_av_1_1_A : A ;
  plattysk_av_1_A : A ;
  plebejisk_av_1_A : A ;
  pleonastisk_av_1_A : A ;
  pliktig_av_1_A : A ;
  pliktmaessig_av_1_1_A : A ;
  pliktskyldig_av_1_A : A ;
  plirig_av_1_A : A ;
  plisserbar_av_1_A : A ;
  plockig_av_1_A : A ;
  plomberbar_av_1_A : A ;
  plottrig_av_1_A : A ;
  plufsig_av_1_A : A ;
  plump_av_1_A : A ;
  plural_av_1_A : A ;
  pluralistisk_av_1_A : A ;
  plussig_av_1_A : A ;
  plutonisk_av_1_A : A ;
  pluttig_av_1_A : A ;
  pluvial_av_1_A : A ;
  plaeterbar_av_1_1_A : A ;
  ploetslig_av_1_1_A : A ;
  pneumatisk_av_1_A : A ;
  pocherbar_av_1_A : A ;
  poesiloes_av_1_1_A : A ;
  poetisk_av_1_A : A ;
  pointerbar_av_1_A : A ;
  pojkaktig_av_1_A : A ;
  pojklagsmaessig_av_1_1_A : A ;
  polar_av_1_A : A ;
  polariserbar_av_1_A : A ;
  polemisk_av_1_A : A ;
  polerbar_av_1_A : A ;
  poliklinisk_av_1_A : A ;
  polisiaer_av_1_1_A : A ;
  politiserbar_av_1_A : A ;
  politisk_av_1_A : A ;
  polletterbar_av_1_A : A ;
  pollinerbar_av_1_A : A ;
  polsk_fransk_av_1_A : A ;
  polsk_av_1_A : A ;
  polyfon_av_1_A : A ;
  polygam_av_1_A : A ;
  polykrom_av_1_A : A ;
  polymorf_av_1_A : A ;
  polynesisk_av_1_A : A ;
  polyteknisk_av_1_A : A ;
  polaer_av_1_1_A : A ;
  pomaderbar_av_1_A : A ;
  pommersk_av_1_A : A ;
  pompoes_av_1_1_A : A ;
  poppig_av_1_A : A ;
  populariserbar_av_1_A : A ;
  popularitetsmaessig_av_1_1_A : A ;
  populistisk_av_1_A : A ;
  populaer_av_1_1_A : A ;
  populaervetenskaplig_av_1_1_A : A ;
  porig_av_1_A : A ;
  pornografisk_av_1_A : A ;
  porrig_av_1_A : A ;
  portativ_av_1_A : A ;
  portionerbar_av_1_A : A ;
  portraetterbar_av_1_1_A : A ;
  portraettlik_av_1_1_A : A ;
  portugisisk_av_1_A : A ;
  poroes_av_1_1_A : A ;
  positiv_av_1_A : A ;
  positivistisk_av_1_A : A ;
  possessiv_av_1_A : A ;
  postal_av_1_A : A ;
  postdaterbar_av_1_A : A ;
  posterbar_av_1_A : A ;
  postglacial_av_1_A : A ;
  postgymnasial_av_1_A : A ;
  postindustriell_av_1_A : A ;
  postnatal_av_1_A : A ;
  postponerbar_av_1_A : A ;
  postulerbar_av_1_A : A ;
  potentiell_av_1_A : A ;
  poaengloes_av_1_1_A : A ;
  poaengmaessig_av_1_1_A : A ;
  poaengterbar_av_1_1_A : A ;
  pragmatisk_av_1_A : A ;
  praktfull_av_1_A : A ;
  praktiserbar_av_1_A : A ;
  praktisk_av_1_A : A ;
  pratig_av_1_A : A ;
  pratsjuk_av_1_A : A ;
  precis_av_1_A : A ;
  preciserbar_av_1_A : A ;
  precioes_av_1_1_A : A ;
  predestinerbar_av_1_A : A ;
  predicerbar_av_1_A : A ;
  predikantmaessig_av_1_1_A : A ;
  predikativ_av_1_A : A ;
  predikatlogisk_av_1_A : A ;
  predisponerbar_av_1_A : A ;
  prefabricerbar_av_1_A : A ;
  prefererbar_av_1_A : A ;
  prefigerbar_av_1_A : A ;
  preglacial_av_1_A : A ;
  prehistorisk_av_1_A : A ;
  prekaer_av_1_1_A : A ;
  preliminaer_av_1_1_A : A ;
  preludierbar_av_1_A : A ;
  premiegill_av_1_A : A ;
  premierbar_av_1_A : A ;
  prenatal_av_1_A : A ;
  preparerbar_av_1_A : A ;
  prepositionell_av_1_A : A ;
  presenterbar_av_1_A : A ;
  preserverbar_av_1_A : A ;
  presidentmaessig_av_1_1_A : A ;
  preskriberbar_av_1_A : A ;
  prestandamaessig_av_1_1_A : A ;
  presterbar_av_1_A : A ;
  prestigemaessig_av_1_1_A : A ;
  presumerbar_av_1_A : A ;
  presumtiv_av_1_A : A ;
  pretentioes_av_1_1_A : A ;
  pretioes_av_1_1_A : A ;
  preussisk_av_1_A : A ;
  preventiv_av_1_A : A ;
  prickig_av_1_A : A ;
  prillig_av_1_A : A ;
  primitiv_av_1_A : A ;
  primitivistisk_av_1_A : A ;
  primaer_av_1_1_A : A ;
  principiell_av_1_A : A ;
  principloes_av_1_1_A : A ;
  prioriterbar_av_1_A : A ;
  prioriteringsmaessig_av_1_1_A : A ;
  prisbillig_av_1_A : A ;
  prismatisk_av_1_A : A ;
  prismaessig_av_1_1_A : A ;
  prisreglerbar_av_1_A : A ;
  privatekonomisk_av_1_A : A ;
  privatiserbar_av_1_A : A ;
  privilegierbar_av_1_A : A ;
  probabilistisk_av_1_A : A ;
  proberbar_av_1_A : A ;
  problematiserbar_av_1_A : A ;
  problematisk_av_1_A : A ;
  procentisk_av_1_A : A ;
  procentuell_av_1_A : A ;
  processuell_av_1_A : A ;
  producerbar_av_1_A : A ;
  produktionsmaessig_av_1_1_A : A ;
  produktiv_av_1_A : A ;
  produktmaessig_av_1_1_A : A ;
  profan_av_1_A : A ;
  profanerbar_av_1_A : A ;
  professionaliserbar_av_1_A : A ;
  professionell_av_1_A : A ;
  professorlig_av_1_A : A ;
  profetisk_av_1_A : A ;
  proffsig_av_1_A : A ;
  profilerbar_av_1_A : A ;
  profylaktisk_av_1_A : A ;
  prognostiserbar_av_1_A : A ;
  prognostisk_av_1_A : A ;
  programenlig_av_1_A : A ;
  programledarmaessig_av_1_1_A : A ;
  programmatisk_av_1_A : A ;
  programmerbar_av_1_A : A ;
  programmaessig_av_1_1_A : A ;
  progressiv_av_1_A : A ;
  prohibitiv_av_1_A : A ;
  proisraelisk_av_1_A : A ;
  projekterbar_av_1_A : A ;
  projektiv_av_1_A : A ;
  projicerbar_av_1_A : A ;
  proklamerbar_av_1_A : A ;
  proklitisk_av_1_A : A ;
  prokrustisk_av_1_A : A ;
  prokurdisk_av_1_A : A ;
  proletariserbar_av_1_A : A ;
  proletaer_av_1_1_A : A ;
  prolongerbar_av_1_A : A ;
  promiskuoes_av_1_1_A : A ;
  promoverbar_av_1_A : A ;
  promulgerbar_av_1_A : A ;
  pronominal_av_1_A : A ;
  pronominell_av_1_A : A ;
  prononcerbar_av_1_A : A ;
  propagandamaessig_av_1_1_A : A ;
  propagandistisk_av_1_A : A ;
  propedeutisk_av_1_A : A ;
  proponerbar_av_1_A : A ;
  proportionell_av_1_A : A ;
  proportionerbar_av_1_A : A ;
  proportionerlig_av_1_A : A ;
  proppfull_av_1_A : A ;
  prosaisk_av_1_A : A ;
  proskriberbar_av_1_A : A ;
  prosodisk_av_1_A : A ;
  prospekterbar_av_1_A : A ;
  protegerbar_av_1_A : A ;
  proteinrik_av_1_A : A ;
  proteisk_av_1_A : A ;
  protektionistisk_av_1_A : A ;
  protestantisk_av_1_A : A ;
  protokollerbar_av_1_A : A ;
  protokollmaessig_av_1_1_A : A ;
  protokollaer_av_1_1_A : A ;
  provensalsk_av_1_A : A ;
  provinsiell_av_1_A : A ;
  provisorisk_av_1_A : A ;
  provocerbar_av_1_A : A ;
  provokativ_av_1_A : A ;
  provokatorisk_av_1_A : A ;
  proximal_av_1_A : A ;
  prudentlig_av_1_A : A ;
  pruttig_av_1_A : A ;
  prydlig_av_1_A : A ;
  pryltokig_av_1_A : A ;
  praektig_av_1_1_A : A ;
  praesterlig_av_1_1_A : A ;
  praalfri_av_1_1_A : A ;
  praalig_av_1_1_A : A ;
  psykedelisk_av_1_A : A ;
  psykiatrisk_av_1_A : A ;
  psykisk_av_1_A : A ;
  psykoanalyserbar_av_1_A : A ;
  psykoanalytisk_av_1_A : A ;
  psykologiserbar_av_1_A : A ;
  psykologisk_av_1_A : A ;
  psykoprofylaktisk_av_1_A : A ;
  psykosocial_av_1_A : A ;
  psykosomatisk_av_1_A : A ;
  psykotisk_av_1_A : A ;
  pubertal_av_1_A : A ;
  publicerbar_av_1_A : A ;
  publicistisk_av_1_A : A ;
  publik_av_1_A : A ;
  publikmaessig_av_1_1_A : A ;
  puckelryggig_av_1_A : A ;
  pucklig_av_1_A : A ;
  pudrig_av_1_A : A ;
  pueril_av_1_A : A ;
  pulveriserbar_av_1_A : A ;
  pulverlackerbar_av_1_A : A ;
  pulvriserbar_av_1_A : A ;
  pundig_av_1_A : A ;
  punisk_av_1_A : A ;
  punkterbar_av_1_A : A ;
  punktlig_av_1_A : A ;
  punktuell_av_1_A : A ;
  pur_av_1_A : A ;
  purgerbar_av_1_A : A ;
  puritansk_av_1_A : A ;
  pussig_av_1_A : A ;
  putig_av_1_A : A ;
  putslustig_av_1_A : A ;
  puttrig_av_1_A : A ;
  pyknisk_av_1_A : A ;
  pyramidal_av_1_A : A ;
  pyreneisk_av_1_A : A ;
  pyroteknisk_av_1_A : A ;
  pysslig_av_1_A : A ;
  paaannonserbar_av_1_1_A : A ;
  paahittig_av_1_1_A : A ;
  paalitlig_av_1_1_A : A ;
  paapasslig_av_1_1_A : A ;
  paasig_av_1_1_A : A ;
  paaskledig_av_1_1_A : A ;
  paastridig_av_1_1_A : A ;
  paastaaelig_av_1_1_A : A ;
  paatagbar_av_1_1_A : A ;
  paataglig_av_1_1_A : A ;
  paaverkbar_av_1_1_A : A ;
  paavisbar_av_1_1_A : A ;
  paavisk_av_1_1_A : A ;
  paavislig_av_1_1_A : A ;
  paavlig_av_1_1_A : A ;
  poebelaktig_av_1_1_A : A ;
  poelsig_av_1_1_A : A ;
  poesig_av_1_1_A : A ;
  qatarisk_av_1_A : A ;
  rabatterbar_av_1_A : A ;
  rabulistisk_av_1_A : A ;
  racingmaessig_av_1_1_A : A ;
  rackaraktig_av_1_A : A ;
  racklig_av_1_A : A ;
  raderbar_av_1_A : A ;
  radial_av_1_A : A ;
  radiell_av_1_A : A ;
  radierbar_av_1_A : A ;
  radikal_av_1_A : A ;
  radikaliserbar_av_1_A : A ;
  radioaktiv_av_1_A : A ;
  radioastronomisk_av_1_A : A ;
  radiomaessig_av_1_1_A : A ;
  radionavigerbar_av_1_A : A ;
  raffig_av_1_A : A ;
  raffinerbar_av_1_A : A ;
  rafflig_av_1_A : A ;
  raggig_av_1_A : A ;
  rak_av_1_A : A ;
  rakitisk_av_1_A : A ;
  raklinjig_av_1_A : A ;
  raklaang_av_1_1_A : A ;
  ramponerbar_av_1_A : A ;
  ramstark_av_1_A : A ;
  randig_av_1_A : A ;
  randomiserbar_av_1_A : A ;
  rangerbar_av_1_A : A ;
  ranglig_av_1_A : A ;
  rangmaessig_av_1_1_A : A ;
  rank_av_1_A : A ;
  rankig_av_1_A : A ;
  ransonerbar_av_1_A : A ;
  rapp_av_1_A : A ;
  rappellerbar_av_1_A : A ;
  rapporterbar_av_1_A : A ;
  rapsodisk_av_1_A : A ;
  rar_av_1_A : A ;
  rasdiskriminerbar_av_1_A : A ;
  raserbar_av_1_A : A ;
  rasistisk_av_1_A : A ;
  rask_av_1_A : A ;
  rasmaessig_av_1_1_A : A ;
  raspig_av_1_A : A ;
  rastloes_av_1_1_A : A ;
  ratificerbar_av_1_A : A ;
  rationaliserbar_av_1_A : A ;
  rationell_av_1_A : A ;
  reaktionaer_av_1_1_A : A ;
  reaktiv_av_1_A : A ;
  reaktiverbar_av_1_A : A ;
  real_av_1_A : A ;
  realiserbar_av_1_A : A ;
  realistisk_av_1_A : A ;
  reassurerbar_av_1_A : A ;
  rebellisk_av_1_A : A ;
  recenserbar_av_1_A : A ;
  receptiv_av_1_A : A ;
  recessiv_av_1_A : A ;
  recipierbar_av_1_A : A ;
  reciprok_av_1_A : A ;
  reciterbar_av_1_A : A ;
  redaktionell_av_1_A : A ;
  redbar_av_1_A : A ;
  redig_av_1_A : A ;
  redigerbar_av_1_A : A ;
  redlig_av_1_A : A ;
  redloes_av_1_1_A : A ;
  redovisningsmaessig_av_1_1_A : A ;
  reducerbar_av_1_A : A ;
  reell_av_1_A : A ;
  refererbar_av_1_A : A ;
  reflekterbar_av_1_A : A ;
  reflektionsloes_av_1_1_A : A ;
  reflexionsloes_av_1_1_A : A ;
  reflexiv_av_1_A : A ;
  reflexmaessig_av_1_1_A : A ;
  reformerbar_av_1_A : A ;
  reformvaenlig_av_1_1_A : A ;
  refuserbar_av_1_A : A ;
  regal_av_1_A : A ;
  regalerbar_av_1_A : A ;
  regelloes_av_1_1_A : A ;
  regelmaessig_av_1_1_A : A ;
  regelvidrig_av_1_A : A ;
  regenererbar_av_1_A : A ;
  regerbar_av_1_A : A ;
  regeringsduglig_av_1_A : A ;
  regeringsfientlig_av_1_A : A ;
  regeringskritisk_av_1_A : A ;
  regerlig_av_1_A : A ;
  regimkritisk_av_1_A : A ;
  regimaessig_av_1_1_A : A ;
  regional_av_1_A : A ;
  regisserbar_av_1_A : A ;
  registrerbar_av_1_A : A ;
  reglementarisk_av_1_A : A ;
  reglementerbar_av_1_A : A ;
  reglementsenlig_av_1_A : A ;
  reglementsvidrig_av_1_A : A ;
  reglerbar_av_1_A : A ;
  regnfri_av_1_A : A ;
  regnig_av_1_A : A ;
  regntung_av_1_A : A ;
  regntaet_av_1_1_A : A ;
  regnvaat_av_1_1_A : A ;
  regressiv_av_1_A : A ;
  reguljaer_av_1_1_A : A ;
  regummerbar_av_1_A : A ;
  rehabiliterbar_av_1_A : A ;
  reinkarnerbar_av_1_A : A ;
  rejael_av_1_1_A : A ;
  rekapitulerbar_av_1_A : A ;
  reklamerbar_av_1_A : A ;
  rekognoscerbar_av_1_A : A ;
  rekognoserbar_av_1_A : A ;
  rekommenderbar_av_1_A : A ;
  rekompenserbar_av_1_A : A ;
  rekonstruerbar_av_1_A : A ;
  rekorddjup_av_1_A : A ;
  rekorderlig_av_1_A : A ;
  rekordmaessig_av_1_1_A : A ;
  rekordsnabb_av_1_A : A ;
  rekreationsmaessig_av_1_1_A : A ;
  rekreativ_av_1_A : A ;
  rekryterbar_av_1_A : A ;
  rektangulaer_av_1_1_A : A ;
  rektificerbar_av_1_A : A ;
  rektifierbar_av_1_A : A ;
  rekvirerbar_av_1_A : A ;
  relaterbar_av_1_A : A ;
  relationsmaessig_av_1_1_A : A ;
  relativ_av_1_A : A ;
  relativistisk_av_1_A : A ;
  relegerbar_av_1_A : A ;
  religionsfientlig_av_1_A : A ;
  religionsloes_av_1_1_A : A ;
  religioes_av_1_1_A : A ;
  remitterbar_av_1_A : A ;
  remplacerbar_av_1_A : A ;
  ren_av_1_A : A ;
  renderbar_av_1_A : A ;
  renhaarig_av_1_1_A : A ;
  renlig_av_1_A : A ;
  renlaerig_av_1_1_A : A ;
  renoverbar_av_1_A : A ;
  renrasig_av_1_A : A ;
  reorganiserbar_av_1_A : A ;
  reparerbar_av_1_A : A ;
  repartiserbar_av_1_A : A ;
  repatrierbar_av_1_A : A ;
  repellerbar_av_1_A : A ;
  repertoarmaessig_av_1_1_A : A ;
  repeterbar_av_1_A : A ;
  repig_av_1_A : A ;
  reportagemaessig_av_1_1_A : A ;
  representativ_av_1_A : A ;
  representerbar_av_1_A : A ;
  repressiv_av_1_A : A ;
  repriserbar_av_1_A : A ;
  reproducerbar_av_1_A : A ;
  republikansk_av_1_A : A ;
  repulsiv_av_1_A : A ;
  reputerlig_av_1_A : A ;
  reservationsloes_av_1_1_A : A ;
  reserverbar_av_1_A : A ;
  reslig_av_1_A : A ;
  resolverbar_av_1_A : A ;
  resonlig_av_1_A : A ;
  resorberbar_av_1_A : A ;
  respekterbar_av_1_A : A ;
  respektfull_av_1_A : A ;
  respektloes_av_1_1_A : A ;
  respiratorisk_av_1_A : A ;
  respirerbar_av_1_A : A ;
  restaurerbar_av_1_A : A ;
  restituerbar_av_1_A : A ;
  restloes_av_1_1_A : A ;
  restriktiv_av_1_A : A ;
  resultativ_av_1_A : A ;
  resultatloes_av_1_1_A : A ;
  resultatmaessig_av_1_1_A : A ;
  resumerbar_av_1_A : A ;
  resursmaessig_av_1_1_A : A ;
  resvan_av_1_A : A ;
  retablerbar_av_1_A : A ;
  retarderbar_av_1_A : A ;
  retfull_av_1_A : A ;
  retlig_av_1_A : A ;
  retorisk_av_1_A : A ;
  retroaktiv_av_1_A : A ;
  retrospektiv_av_1_A : A ;
  returnerbar_av_1_A : A ;
  retuscherbar_av_1_A : A ;
  reumatisk_av_1_A : A ;
  revalverbar_av_1_A : A ;
  reveterbar_av_1_A : A ;
  reviderbar_av_1_A : A ;
  revolutionerbar_av_1_A : A ;
  revolutionaer_av_1_1_A : A ;
  rh_negativ_av_1_A : A ;
  rh_positiv_av_1_A : A ;
  rhensk_av_1_A : A ;
  rhodesisk_av_1_A : A ;
  rickig_av_1_A : A ;
  ridderlig_av_1_A : A ;
  ridkunnig_av_1_A : A ;
  rigoroes_av_1_1_A : A ;
  rik_av_1_A : A ;
  rikhaltig_av_1_A : A ;
  riklig_av_1_A : A ;
  rikssvensk_av_1_A : A ;
  riksviktig_av_1_A : A ;
  riktig_av_1_A : A ;
  rimlig_av_1_A : A ;
  ringformig_av_1_A : A ;
  ringrostig_av_1_A : A ;
  risig_av_1_A : A ;
  riskvillig_av_1_A : A ;
  ritualiserbar_av_1_A : A ;
  ritualmaessig_av_1_1_A : A ;
  rituell_av_1_A : A ;
  rivig_av_1_A : A ;
  robotiserbar_av_1_A : A ;
  rockerbar_av_1_A : A ;
  rojalistisk_av_1_A : A ;
  rolig_av_1_A : A ;
  roloes_av_1_1_A : A ;
  romanesk_av_1_A : A ;
  romanistisk_av_1_A : A ;
  romansk_av_1_A : A ;
  romantiserbar_av_1_A : A ;
  romantisk_av_1_A : A ;
  rombisk_av_1_A : A ;
  romersk_katolsk_av_1_A : A ;
  romersk_av_1_A : A ;
  rosig_av_1_A : A ;
  rosslig_av_1_A : A ;
  rostig_av_1_A : A ;
  rotloes_av_1_1_A : A ;
  rovgirig_av_1_A : A ;
  rubricerbar_av_1_A : A ;
  rubrikmaessig_av_1_1_A : A ;
  rucklig_av_1_A : A ;
  rudimentaer_av_1_1_A : A ;
  ruffig_av_1_A : A ;
  rufsig_av_1_A : A ;
  ruggig_av_1_A : A ;
  ruinerbar_av_1_A : A ;
  rullbar_av_1_A : A ;
  rultig_av_1_A : A ;
  rumslig_av_1_A : A ;
  rumaensk_fransk_av_1_1_A : A ;
  rumaensk_av_1_1_A : A ;
  rundkullig_av_1_A : A ;
  rundlig_av_1_A : A ;
  rural_av_1_A : A ;
  ruschig_av_1_A : A ;
  rusig_av_1_A : A ;
  ruskig_av_1_A : A ;
  russificerbar_av_1_A : A ;
  russifierbar_av_1_A : A ;
  rustik_av_1_A : A ;
  rutig_av_1_A : A ;
  rutinmaessig_av_1_1_A : A ;
  rwandisk_av_1_A : A ;
  ryckig_av_1_A : A ;
  ryggmaergsmaessig_av_1_1_A : A ;
  ryggradsloes_av_1_1_A : A ;
  ryktbar_av_1_A : A ;
  rymlig_av_1_A : A ;
  rynkig_av_1_A : A ;
  ryschig_av_1_A : A ;
  rysk_amerikansk_av_1_A : A ;
  rysk_av_1_A : A ;
  ryskvaenlig_av_1_1_A : A ;
  ryslig_av_1_A : A ;
  rysslaendsk_av_1_1_A : A ;
  rytmiserbar_av_1_A : A ;
  rytmisk_av_1_A : A ;
  raeddningsloes_av_1_1_A : A ;
  raelig_av_1_1_A : A ;
  raenkfull_av_1_1_A : A ;
  raetlinjig_av_1_1_A : A ;
  raettfaerdig_av_1_1_A : A ;
  raettmaetig_av_1_1_A : A ;
  raettraadig_av_1_1_A : A ;
  raettsenlig_av_1_1_A : A ;
  raettshaveristisk_av_1_1_A : A ;
  raettsinnig_av_1_1_A : A ;
  raettslig_av_1_1_A : A ;
  raettsloes_av_1_1_A : A ;
  raettsmedicinsk_av_1_1_A : A ;
  raettspsykiatrisk_av_1_1_A : A ;
  raettsstridig_av_1_1_A : A ;
  raettsvidrig_av_1_1_A : A ;
  raettvis_av_1_1_A : A ;
  raettvisemaessig_av_1_1_A : A ;
  raetvinklig_av_1_1_A : A ;
  raaddig_av_1_1_A : A ;
  raadig_av_1_1_A : A ;
  raadlig_av_1_1_A : A ;
  raadloes_av_1_1_A : A ;
  raadsnar_av_1_1_A : A ;
  raadvill_av_1_1_A : A ;
  raakall_av_1_1_A : A ;
  raavarumaessig_av_1_1_A : A ;
  roedaktig_av_1_1_A : A ;
  roedblommig_av_1_1_A : A ;
  roedbrokig_av_1_1_A : A ;
  roedbrun_av_1_1_A : A ;
  roedbrusig_av_1_1_A : A ;
  roedflammig_av_1_1_A : A ;
  roedgroen_av_1_1_A : A ;
  roedhaarig_av_1_1_A : A ;
  roedmosig_av_1_1_A : A ;
  roekig_av_1_1_A : A ;
  roeksvag_av_1_1_A : A ;
  roentgenfotograferbar_av_1_1_A : A ;
  roerelsemaessig_av_1_1_A : A ;
  roerig_av_1_1_A : A ;
  roerlig_av_1_1_A : A ;
  roestmaessig_av_1_1_A : A ;
  roeststark_av_1_1_A : A ;
  saboterbar_av_1_A : A ;
  sabrerbar_av_1_A : A ;
  sachsisk_av_1_A : A ;
  sadelformig_av_1_A : A ;
  sadistisk_av_1_A : A ;
  sado_masochistisk_av_1_A : A ;
  saffransgul_av_1_A : A ;
  saftfull_av_1_A : A ;
  saftig_av_1_A : A ;
  saftloes_av_1_1_A : A ;
  sagolik_av_1_A : A ;
  sagomaessig_av_1_1_A : A ;
  sakfoerstaandig_av_1_1_A : A ;
  sakkunnig_av_1_A : A ;
  saklig_av_1_A : A ;
  sakloes_av_1_1_A : A ;
  sakpolitisk_av_1_A : A ;
  sakral_av_1_A : A ;
  sakramental_av_1_A : A ;
  sakraettslig_av_1_1_A : A ;
  saktfaerdig_av_1_1_A : A ;
  saktmodig_av_1_A : A ;
  salderbar_av_1_A : A ;
  salig_av_1_A : A ;
  salisk_av_1_A : A ;
  salomonisk_av_1_A : A ;
  salomonsk_av_1_A : A ;
  salongsfaehig_av_1_1_A : A ;
  salongsmaessig_av_1_1_A : A ;
  salthaltig_av_1_A : A ;
  saltig_av_1_A : A ;
  saluterbar_av_1_A : A ;
  salvadoransk_av_1_A : A ;
  salvelsefull_av_1_A : A ;
  samarbetsvillig_av_1_A : A ;
  sambladig_av_1_A : A ;
  samfundsmaessig_av_1_1_A : A ;
  samfaellig_av_1_1_A : A ;
  samhaellelig_av_1_1_A : A ;
  samhaellsekonomisk_av_1_1_A : A ;
  samhaellsfarlig_av_1_1_A : A ;
  samhaellsfientlig_av_1_1_A : A ;
  samhaellskritisk_av_1_1_A : A ;
  samhaellsmaessig_av_1_1_A : A ;
  samhaellsnyttig_av_1_1_A : A ;
  samhaellssolidarisk_av_1_1_A : A ;
  samhaellsvetenskaplig_av_1_1_A : A ;
  samhoerig_av_1_1_A : A ;
  samisk_av_1_A : A ;
  sammanhaallig_av_1_1_A : A ;
  sammetsmjuk_av_1_A : A ;
  samnordisk_av_1_A : A ;
  samstaemmig_av_1_1_A : A ;
  samtaxerbar_av_1_A : A ;
  samtidig_av_1_A : A ;
  samvetsloes_av_1_1_A : A ;
  sandbrun_av_1_A : A ;
  sandig_av_1_A : A ;
  sanerbar_av_1_A : A ;
  sanforiserbar_av_1_A : A ;
  sangvinisk_av_1_A : A ;
  sanitaer_av_1_1_A : A ;
  sank_av_1_A : A ;
  sanktifierbar_av_1_A : A ;
  sanktionerbar_av_1_A : A ;
  sanmarinesisk_av_1_A : A ;
  sanmarinsk_av_1_A : A ;
  sannfaerdig_av_1_1_A : A ;
  sanningsenlig_av_1_A : A ;
  sanningsloes_av_1_1_A : A ;
  sannolik_av_1_A : A ;
  sannskyldig_av_1_A : A ;
  sansloes_av_1_1_A : A ;
  saotomeansk_av_1_A : A ;
  sapfisk_av_1_A : A ;
  saponifierbar_av_1_A : A ;
  sardinisk_av_1_A : A ;
  sardinsk_av_1_A : A ;
  sardisk_av_1_A : A ;
  sardonisk_av_1_A : A ;
  sarkastisk_av_1_A : A ;
  satanisk_av_1_A : A ;
  satinerbar_av_1_A : A ;
  satirisk_av_1_A : A ;
  satisfierbar_av_1_A : A ;
  saturerbar_av_1_A : A ;
  saturnalisk_av_1_A : A ;
  saturnisk_av_1_A : A ;
  satyrisk_av_1_A : A ;
  saudiarabisk_av_1_A : A ;
  saudisk_av_1_A : A ;
  sauterbar_av_1_A : A ;
  sauverbar_av_1_A : A ;
  savig_av_1_A : A ;
  saxformig_av_1_A : A ;
  saxisk_av_1_A : A ;
  scenisk_av_1_A : A ;
  schablonerbar_av_1_A : A ;
  schabloniserbar_av_1_A : A ;
  schablonmaessig_av_1_1_A : A ;
  schablontaxerbar_av_1_A : A ;
  schamponerbar_av_1_A : A ;
  schangtil_av_1_A : A ;
  schartauansk_av_1_A : A ;
  schatterbar_av_1_A : A ;
  schemamaessig_av_1_1_A : A ;
  schematiserbar_av_1_A : A ;
  schematisk_av_1_A : A ;
  schismatisk_av_1_A : A ;
  schizotym_av_1_A : A ;
  schizzig_av_1_A : A ;
  schvungfull_av_1_A : A ;
  schvungig_av_1_A : A ;
  schweizisk_av_1_A : A ;
  schwungfull_av_1_A : A ;
  schwungig_av_1_A : A ;
  scoutmaessig_av_1_1_A : A ;
  sebar_av_1_A : A ;
  sedativ_av_1_A : A ;
  sedesloes_av_1_1_A : A ;
  sedig_av_1_A : A ;
  sedimenterbar_av_1_A : A ;
  sedimentaer_av_1_1_A : A ;
  sedlig_av_1_A : A ;
  sedvanlig_av_1_A : A ;
  seg_av_1_A : A ;
  segelbar_av_1_A : A ;
  segerrik_av_1_A : A ;
  segerrusig_av_1_A : A ;
  segersaell_av_1_1_A : A ;
  segerviss_av_1_A : A ;
  seglationsklar_av_1_A : A ;
  segmentell_av_1_A : A ;
  segmenterbar_av_1_A : A ;
  segregerbar_av_1_A : A ;
  seismisk_av_1_A : A ;
  sekellaang_av_1_1_A : A ;
  sekonderbar_av_1_A : A ;
  sekretorisk_av_1_A : A ;
  sekteristisk_av_1_A : A ;
  sektoriell_av_1_A : A ;
  sekulariserbar_av_1_A : A ;
  sekulaer_av_1_1_A : A ;
  sekunderbar_av_1_A : A ;
  sekundaer_av_1_1_A : A ;
  sekvestrerbar_av_1_A : A ;
  selekterbar_av_1_A : A ;
  selektiv_av_1_A : A ;
  semaforerbar_av_1_A : A ;
  semantisk_av_1_A : A ;
  seminerbar_av_1_A : A ;
  semiotisk_av_1_A : A ;
  semitisk_av_1_A : A ;
  semologisk_av_1_A : A ;
  sen_av_1_A : A ;
  senantik_av_1_A : A ;
  senegalesisk_av_1_A : A ;
  senfaerdig_av_1_1_A : A ;
  sengaangaraktig_av_1_1_A : A ;
  senig_av_1_A : A ;
  senil_av_1_A : A ;
  senildement_av_1_A : A ;
  senior_av_1_A : A ;
  senromersk_av_1_A : A ;
  sensationell_av_1_A : A ;
  sensibiliserbar_av_1_A : A ;
  sensitiv_av_1_A : A ;
  sensomotorisk_av_1_A : A ;
  sensorisk_av_1_A : A ;
  sensuell_av_1_A : A ;
  sentensioes_av_1_1_A : A ;
  sententioes_av_1_1_A : A ;
  senterbar_av_1_A : A ;
  sentimental_av_1_A : A ;
  separatistisk_av_1_A : A ;
  separerbar_av_1_A : A ;
  septisk_av_1_A : A ;
  serafisk_av_1_A : A ;
  serbisk_av_1_A : A ;
  serbokroatisk_av_1_A : A ;
  seriell_av_1_A : A ;
  seriemaessig_av_1_1_A : A ;
  serioes_av_1_1_A : A ;
  serverbar_av_1_A : A ;
  servicemaessig_av_1_1_A : A ;
  servil_av_1_A : A ;
  seroes_av_1_1_A : A ;
  sexig_av_1_A : A ;
  sexkantig_av_1_A : A ;
  sexpipig_av_1_A : A ;
  sexradig_av_1_A : A ;
  sexsiffrig_av_1_A : A ;
  sexualiserbar_av_1_A : A ;
  sexuell_av_1_A : A ;
  seychellisk_av_1_A : A ;
  sfaerisk_av_1_1_A : A ;
  shamponerbar_av_1_A : A ;
  shetlaendsk_av_1_1_A : A ;
  showmaessig_av_1_1_A : A ;
  siamesisk_av_1_A : A ;
  sibirisk_av_1_A : A ;
  sibyllinsk_av_1_A : A ;
  siciliansk_av_1_A : A ;
  sidenvit_av_1_A : A ;
  siderisk_av_1_A : A ;
  sidnumrerbar_av_1_A : A ;
  sierraleonsk_av_1_A : A ;
  siffermaessig_av_1_1_A : A ;
  sigillerbar_av_1_A : A ;
  signalerbar_av_1_A : A ;
  signaturmaessig_av_1_1_A : A ;
  signerbar_av_1_A : A ;
  signifikativ_av_1_A : A ;
  siktbar_av_1_A : A ;
  siktig_av_1_A : A ;
  silhuetterbar_av_1_A : A ;
  silkig_av_1_A : A ;
  siluetterbar_av_1_A : A ;
  silverhaltig_av_1_A : A ;
  silverklar_av_1_A : A ;
  silvrig_av_1_A : A ;
  simkunnig_av_1_A : A ;
  simmig_av_1_A : A ;
  simplifierbar_av_1_A : A ;
  simulerbar_av_1_A : A ;
  simultan_av_1_A : A ;
  singalesisk_av_1_A : A ;
  singular_av_1_A : A ;
  singuljaer_av_1_1_A : A ;
  singulaer_av_1_1_A : A ;
  sinnebildlig_av_1_A : A ;
  sinnessjuk_av_1_A : A ;
  sinnessvag_av_1_A : A ;
  sinnlig_av_1_A : A ;
  sinnrik_av_1_A : A ;
  sipp_av_1_A : A ;
  sirapssoet_av_1_1_A : A ;
  siratlig_av_1_A : A ;
  sirlig_av_1_A : A ;
  sittriktig_av_1_A : A ;
  sittvaenlig_av_1_1_A : A ;
  sjabbig_av_1_A : A ;
  sjangtil_av_1_A : A ;
  sjaskig_av_1_A : A ;
  sjavig_av_1_A : A ;
  sjudimensionell_av_1_A : A ;
  sjuk_av_1_A : A ;
  sjukledig_av_1_A : A ;
  sjuklig_av_1_A : A ;
  sjukvaardsmaessig_av_1_1_A : A ;
  sjaelavaardsmaessig_av_1_1_A : A ;
  sjaelfull_av_1_1_A : A ;
  sjaelisk_av_1_1_A : A ;
  sjaelloes_av_1_1_A : A ;
  sjaelslig_av_1_1_A : A ;
  sjaelssjuk_av_1_1_A : A ;
  sjaelvbiografisk_av_1_1_A : A ;
  sjaelvfinansierbar_av_1_1_A : A ;
  sjaelvhaerlig_av_1_1_A : A ;
  sjaelvironisk_av_1_1_A : A ;
  sjaelvisk_av_1_1_A : A ;
  sjaelvklar_av_1_1_A : A ;
  sjaelvkritisk_av_1_1_A : A ;
  sjaelvmordsmaessig_av_1_1_A : A ;
  sjaelvraettfaerdig_av_1_1_A : A ;
  sjaelvraadig_av_1_1_A : A ;
  sjaelvstaendig_av_1_1_A : A ;
  sjaelvsvaaldig_av_1_1_A : A ;
  sjaelvtillraecklig_av_1_1_A : A ;
  sjaapig_av_1_1_A : A ;
  sjoebloet_av_1_1_A : A ;
  sjoeduglig_av_1_1_A : A ;
  sjoemansmaessig_av_1_1_A : A ;
  sjoesjuk_av_1_1_A : A ;
  sjoesaekerhetsmaessig_av_1_1_A : A ;
  sjoevaerdig_av_1_1_A : A ;
  skabbig_av_1_A : A ;
  skabroes_av_1_1_A : A ;
  skadereglerbar_av_1_A : A ;
  skadesloes_av_1_1_A : A ;
  skadlig_av_1_A : A ;
  skakig_av_1_A : A ;
  skaktaalig_av_1_1_A : A ;
  skaldisk_av_1_A : A ;
  skalenlig_av_1_A : A ;
  skalkaktig_av_1_A : A ;
  skallig_av_1_A : A ;
  skalloes_av_1_1_A : A ;
  skalperbar_av_1_A : A ;
  skalaer_av_1_1_A : A ;
  skamlig_av_1_A : A ;
  skamloes_av_1_1_A : A ;
  skandaliserbar_av_1_A : A ;
  skandaloes_av_1_1_A : A ;
  skanderbar_av_1_A : A ;
  skandinavisk_av_1_A : A ;
  skaplig_av_1_A : A ;
  skarp_av_1_A : A ;
  skarpsinnig_av_1_A : A ;
  skattemaessig_av_1_1_A : A ;
  skatteplanerbar_av_1_A : A ;
  skattepliktig_av_1_A : A ;
  skattskyldig_av_1_A : A ;
  skenbar_av_1_A : A ;
  skenhelig_av_1_A : A ;
  skeptisk_av_1_A : A ;
  skev_av_1_A : A ;
  skicklig_av_1_A : A ;
  skiffrig_av_1_A : A ;
  skiljaktig_av_1_A : A ;
  skiljbar_av_1_A : A ;
  skinntorr_av_1_A : A ;
  skir_av_1_A : A ;
  skisserbar_av_1_A : A ;
  skitbesvaerlig_av_1_1_A : A ;
  skitdaalig_av_1_1_A : A ;
  skitfoernaem_av_1_1_A : A ;
  skitig_av_1_A : A ;
  skitnoedig_av_1_1_A : A ;
  skitsnygg_av_1_A : A ;
  skittraakig_av_1_1_A : A ;
  skitviktig_av_1_A : A ;
  skivig_av_1_A : A ;
  skjutfaerdig_av_1_1_A : A ;
  skjutklar_av_1_A : A ;
  sklerotisk_av_1_A : A ;
  skogfattig_av_1_A : A ;
  skogig_av_1_A : A ;
  skoglig_av_1_A : A ;
  skogloes_av_1_1_A : A ;
  skogrik_av_1_A : A ;
  skogsgenetisk_av_1_A : A ;
  skojfrisk_av_1_A : A ;
  skojig_av_1_A : A ;
  skolastisk_av_1_A : A ;
  skolboksmaessig_av_1_1_A : A ;
  skolmaessig_av_1_1_A : A ;
  skolmaestaraktig_av_1_1_A : A ;
  skolsjuk_av_1_A : A ;
  skoningsloes_av_1_1_A : A ;
  skopofil_av_1_A : A ;
  skorvig_av_1_A : A ;
  skotsk_av_1_A : A ;
  skotskrutig_av_1_A : A ;
  skottfri_av_1_A : A ;
  skrabbig_av_1_A : A ;
  skrafferbar_av_1_A : A ;
  skraj_av_1_A : A ;
  skral_av_1_A : A ;
  skraltig_av_1_A : A ;
  skramlig_av_1_A : A ;
  skranglig_av_1_A : A ;
  skriftlig_av_1_A : A ;
  skriftspraaklig_av_1_1_A : A ;
  skrikig_av_1_A : A ;
  skrivkunnig_av_1_A : A ;
  skrockfull_av_1_A : A ;
  skrofuloes_av_1_1_A : A ;
  skrovlig_av_1_A : A ;
  skrupelloes_av_1_1_A : A ;
  skrupuloes_av_1_1_A : A ;
  skruttig_av_1_A : A ;
  skrynkelhaerdig_av_1_1_A : A ;
  skrynklig_av_1_A : A ;
  skraellig_av_1_1_A : A ;
  skraenig_av_1_1_A : A ;
  skraepig_av_1_1_A : A ;
  skraevlig_av_1_1_A : A ;
  skraamaessig_av_1_1_A : A ;
  skroeplig_av_1_1_A : A ;
  skuggig_av_1_A : A ;
  skuldloes_av_1_1_A : A ;
  skulpterbar_av_1_A : A ;
  skulptural_av_1_A : A ;
  skulpturerbar_av_1_A : A ;
  skummig_av_1_A : A ;
  skumpig_av_1_A : A ;
  skunkig_av_1_A : A ;
  skurkaktig_av_1_A : A ;
  skurril_av_1_A : A ;
  skvalleraktig_av_1_A : A ;
  skvallrig_av_1_A : A ;
  skvalpig_av_1_A : A ;
  skyddsimpregnerbar_av_1_A : A ;
  skyddsloes_av_1_1_A : A ;
  skygg_av_1_A : A ;
  skyhoeg_av_1_1_A : A ;
  skyig_av_1_A : A ;
  skyldig_av_1_A : A ;
  skymflig_av_1_A : A ;
  skaeckig_av_1_1_A : A ;
  skaeggig_av_1_1_A : A ;
  skaeggloes_av_1_1_A : A ;
  skaelig_av_1_1_A : A ;
  skaell_av_1_1_A : A ;
  skaellig_av_1_1_A : A ;
  skaelmaktig_av_1_1_A : A ;
  skaelmsk_av_1_1_A : A ;
  skaemmig_av_1_1_A : A ;
  skaendlig_av_1_1_A : A ;
  skaer_av_1_1_A : A ;
  skaevig_av_1_1_A : A ;
  skaadespelarmaessig_av_1_1_A : A ;
  skaalformig_av_1_1_A : A ;
  skaalig_av_1_1_A : A ;
  skaallhet_av_1_1_A : A ;
  skaansk_av_1_1_A : A ;
  skoen_av_1_1_A : A ;
  skoenjbar_av_1_1_A : A ;
  skoenlitteraer_av_1_1_A : A ;
  skoenlockig_av_1_1_A : A ;
  skoensmaessig_av_1_1_A : A ;
  skoenstaxerbar_av_1_1_A : A ;
  skoentaxerbar_av_1_1_A : A ;
  skoer_av_1_1_A : A ;
  slabb_av_1_A : A ;
  slabbig_av_1_A : A ;
  slack_av_1_A : A ;
  sladdig_av_1_A : A ;
  sladdrig_av_1_A : A ;
  slafsig_av_1_A : A ;
  slagfaerdig_av_1_1_A : A ;
  slaggig_av_1_A : A ;
  slagkraftig_av_1_A : A ;
  slagordsmaessig_av_1_1_A : A ;
  slagtaalig_av_1_1_A : A ;
  slak_av_1_A : A ;
  slammig_av_1_A : A ;
  slampig_av_1_A : A ;
  slamsig_av_1_A : A ;
  slangloes_av_1_1_A : A ;
  slank_av_1_A : A ;
  slankig_av_1_A : A ;
  slapp_av_1_A : A ;
  slarvig_av_1_A : A ;
  slaskig_av_1_A : A ;
  slattrig_av_1_A : A ;
  slaviserbar_av_1_A : A ;
  slavisk_av_1_A : A ;
  slavofil_av_1_A : A ;
  slemmig_av_1_A : A ;
  slentrianmaessig_av_1_1_A : A ;
  slibbig_av_1_A : A ;
  sliddrig_av_1_A : A ;
  slingrig_av_1_A : A ;
  slinkig_av_1_A : A ;
  slipprig_av_1_A : A ;
  slirig_av_1_A : A ;
  sliskig_av_1_A : A ;
  slitig_av_1_A : A ;
  slitstark_av_1_A : A ;
  slittaalig_av_1_1_A : A ;
  slokig_av_1_A : A ;
  slovakisk_av_1_A : A ;
  slovensk_av_1_A : A ;
  sluddrig_av_1_A : A ;
  slug_av_1_A : A ;
  sluggermaessig_av_1_1_A : A ;
  slumpmaessig_av_1_1_A : A ;
  sluskig_av_1_A : A ;
  slutgiltig_av_1_A : A ;
  slutlig_av_1_A : A ;
  slynig_av_1_A : A ;
  slaektmaessig_av_1_1_A : A ;
  slaengig_av_1_1_A : A ;
  slaepig_av_1_1_A : A ;
  slaet_av_1_1_A : A ;
  slaethaarig_av_1_1_A : A ;
  sloejig_av_1_1_A : A ;
  sloesaktig_av_1_1_A : A ;
  sloesig_av_1_1_A : A ;
  smakfull_av_1_A : A ;
  smaklig_av_1_A : A ;
  smakloes_av_1_1_A : A ;
  smakmaessig_av_1_1_A : A ;
  smakstark_av_1_A : A ;
  smal_av_1_A : A ;
  smalspaarig_av_1_1_A : A ;
  smaragdgroen_av_1_1_A : A ;
  smarrig_av_1_A : A ;
  smaskig_av_1_A : A ;
  smekfull_av_1_A : A ;
  smetig_av_1_A : A ;
  smidbar_av_1_A : A ;
  smidig_av_1_A : A ;
  smilig_av_1_A : A ;
  smilsk_av_1_A : A ;
  smockfull_av_1_A : A ;
  smul_av_1_A : A ;
  smulig_av_1_A : A ;
  smutsig_av_1_A : A ;
  smaeckfet_av_1_1_A : A ;
  smaeckfull_av_1_1_A : A ;
  smaeckig_av_1_1_A : A ;
  smaedlig_av_1_1_A : A ;
  smaellfet_av_1_1_A : A ;
  smaellkall_av_1_1_A : A ;
  smaaaktig_av_1_1_A : A ;
  smaabarnsaktig_av_1_1_A : A ;
  smaabladig_av_1_1_A : A ;
  smaablommig_av_1_1_A : A ;
  smaablaasig_av_1_1_A : A ;
  smaaborgerlig_av_1_1_A : A ;
  smaaelak_av_1_1_A : A ;
  smaagnabbig_av_1_1_A : A ;
  smaalaendsk_av_1_1_A : A ;
  smaapipig_av_1_1_A : A ;
  smaarolig_av_1_1_A : A ;
  smaarutig_av_1_1_A : A ;
  smaaskalig_av_1_1_A : A ;
  smaatrevlig_av_1_1_A : A ;
  smaattig_av_1_1_A : A ;
  smaaviktig_av_1_1_A : A ;
  smoerig_av_1_1_A : A ;
  smoerjig_av_1_1_A : A ;
  snabb_av_1_A : A ;
  snabbloeslig_av_1_1_A : A ;
  snackesalig_av_1_A : A ;
  snacksalig_av_1_A : A ;
  snar_av_1_A : A ;
  snarfyndig_av_1_A : A ;
  snarfaerdig_av_1_1_A : A ;
  snarlig_av_1_A : A ;
  snarlik_av_1_A : A ;
  snaskig_av_1_A : A ;
  snedhoernig_av_1_1_A : A ;
  snedig_av_1_A : A ;
  snedparkerbar_av_1_A : A ;
  snedrekryterbar_av_1_A : A ;
  snedvinklig_av_1_A : A ;
  snibbig_av_1_A : A ;
  snillrik_av_1_A : A ;
  snipig_av_1_A : A ;
  snirklig_av_1_A : A ;
  snitsig_av_1_A : A ;
  snobbig_av_1_A : A ;
  snobbistisk_av_1_A : A ;
  snofsig_av_1_A : A ;
  snorig_av_1_A : A ;
  snorkig_av_1_A : A ;
  snubblig_av_1_A : A ;
  snudig_av_1_A : A ;
  snurrig_av_1_A : A ;
  snusbrun_av_1_A : A ;
  snusfoernuftig_av_1_1_A : A ;
  snusig_av_1_A : A ;
  snuskig_av_1_A : A ;
  snustorr_av_1_A : A ;
  snuvig_av_1_A : A ;
  snygg_av_1_A : A ;
  snaell_av_1_1_A : A ;
  snaerjig_av_1_1_A : A ;
  snaertig_av_1_1_A : A ;
  snaesig_av_1_1_A : A ;
  snaev_av_1_1_A : A ;
  snaal_av_1_1_A : A ;
  snaarig_av_1_1_A : A ;
  snoefattig_av_1_1_A : A ;
  snoehal_av_1_1_A : A ;
  snoeig_av_1_1_A : A ;
  snoeplig_av_1_1_A : A ;
  snoerik_av_1_1_A : A ;
  snoerpig_av_1_1_A : A ;
  snoerraet_av_1_1_A : A ;
  snoervlig_av_1_1_A : A ;
  snoevit_av_1_1_A : A ;
  social_av_1_A : A ;
  socialantropologisk_av_1_A : A ;
  socialdemokratisk_av_1_A : A ;
  socialfascistisk_av_1_A : A ;
  socialiserbar_av_1_A : A ;
  socialistisk_av_1_A : A ;
  socialliberal_av_1_A : A ;
  socialpolitisk_av_1_A : A ;
  socioekonomisk_av_1_A : A ;
  sociologisk_av_1_A : A ;
  sockerhaltig_av_1_A : A ;
  sockermaessig_av_1_1_A : A ;
  sockerrik_av_1_A : A ;
  sockersjuk_av_1_A : A ;
  sockersoet_av_1_1_A : A ;
  sockrig_av_1_A : A ;
  sodahaltig_av_1_A : A ;
  sokratisk_av_1_A : A ;
  solar_av_1_A : A ;
  solarisk_av_1_A : A ;
  soldatmaessig_av_1_1_A : A ;
  solfattig_av_1_A : A ;
  solgul_av_1_A : A ;
  solidarisk_av_1_A : A ;
  solig_av_1_A : A ;
  solistisk_av_1_A : A ;
  solitaer_av_1_1_A : A ;
  solkig_av_1_A : A ;
  solklar_av_1_A : A ;
  solljus_av_1_A : A ;
  solloes_av_1_1_A : A ;
  solvarm_av_1_A : A ;
  solverbar_av_1_A : A ;
  solaer_av_1_1_A : A ;
  somalisk_av_1_A : A ;
  somatisk_av_1_A : A ;
  sommaraktig_av_1_A : A ;
  sommarlig_av_1_A : A ;
  sommarsvettig_av_1_A : A ;
  somnambul_av_1_A : A ;
  somnambulisk_av_1_A : A ;
  somrig_av_1_A : A ;
  sonantisk_av_1_A : A ;
  sonderbar_av_1_A : A ;
  sonisk_av_1_A : A ;
  sonlig_av_1_A : A ;
  sonor_av_1_A : A ;
  soppig_av_1_A : A ;
  sordinerbar_av_1_A : A ;
  sorgfull_av_1_A : A ;
  sorgfaellig_av_1_1_A : A ;
  sorglig_av_1_A : A ;
  sorglustig_av_1_A : A ;
  sorgloes_av_1_1_A : A ;
  sorgmodig_av_1_A : A ;
  sorterbar_av_1_A : A ;
  sotig_av_1_A : A ;
  soulagerbar_av_1_A : A ;
  soundmaessig_av_1_1_A : A ;
  sovjetiserbar_av_1_A : A ;
  sovjetisk_av_1_A : A ;
  sovjetrysk_av_1_A : A ;
  spak_av_1_A : A ;
  spaljerbar_av_1_A : A ;
  spallerbar_av_1_A : A ;
  spansk_av_1_A : A ;
  spartansk_av_1_A : A ;
  spasmodisk_av_1_A : A ;
  spastisk_av_1_A : A ;
  spatial_av_1_A : A ;
  spatioes_av_1_1_A : A ;
  spattig_av_1_A : A ;
  specialiserbar_av_1_A : A ;
  speciell_av_1_A : A ;
  specificerbar_av_1_A : A ;
  specifik_av_1_A : A ;
  speciminerbar_av_1_A : A ;
  spefull_av_1_A : A ;
  spegelblank_av_1_A : A ;
  spektakulaer_av_1_1_A : A ;
  spektral_av_1_A : A ;
  spekulativ_av_1_A : A ;
  spekulerbar_av_1_A : A ;
  spelarmaessig_av_1_1_A : A ;
  spelbar_av_1_A : A ;
  spelmaessig_av_1_1_A : A ;
  spenderbar_av_1_A : A ;
  spenslig_av_1_A : A ;
  spetig_av_1_A : A ;
  spetsfundig_av_1_A : A ;
  spetsig_av_1_A : A ;
  spetsvinklig_av_1_A : A ;
  spetaelsk_av_1_1_A : A ;
  spexig_av_1_A : A ;
  spikrak_av_1_A : A ;
  spinal_av_1_A : A ;
  spinkig_av_1_A : A ;
  spirituell_av_1_A : A ;
  spirituoes_av_1_1_A : A ;
  spolformig_av_1_A : A ;
  spolierbar_av_1_A : A ;
  sponsormaessig_av_1_1_A : A ;
  spontan_av_1_A : A ;
  sporadisk_av_1_A : A ;
  sportig_av_1_A : A ;
  sportslig_av_1_A : A ;
  sportsmannamaessig_av_1_1_A : A ;
  spotsk_av_1_A : A ;
  sprallig_av_1_A : A ;
  spretig_av_1_A : A ;
  sprickfaerdig_av_1_1_A : A ;
  sprickig_av_1_A : A ;
  sprithaltig_av_1_A : A ;
  sprutlackerbar_av_1_A : A ;
  spraecklig_av_1_1_A : A ;
  spraengfull_av_1_1_A : A ;
  spraettig_av_1_1_A : A ;
  spraakkunnig_av_1_1_A : A ;
  spraaklig_av_1_1_A : A ;
  spraakmaessig_av_1_1_A : A ;
  spraakriktig_av_1_1_A : A ;
  spydig_av_1_A : A ;
  spyfaerdig_av_1_1_A : A ;
  spaenningsmaessig_av_1_1_A : A ;
  spaenstig_av_1_1_A : A ;
  spaarloes_av_1_1_A : A ;
  spoekaktig_av_1_1_A : A ;
  spoeklik_av_1_1_A : A ;
  srilankesisk_av_1_A : A ;
  stabbig_av_1_A : A ;
  stabil_av_1_A : A ;
  stabiliserbar_av_1_A : A ;
  stadgemaessig_av_1_1_A : A ;
  stadig_av_1_A : A ;
  stadsbildmaessig_av_1_1_A : A ;
  stadsbildsmaessig_av_1_1_A : A ;
  stadsbyggnadsmaessig_av_1_1_A : A ;
  stadsmiljoemaessig_av_1_1_A : A ;
  stadsmaessig_av_1_1_A : A ;
  stadsplanemaessig_av_1_1_A : A ;
  stadsplanerbar_av_1_A : A ;
  stafferbar_av_1_A : A ;
  stalinistisk_av_1_A : A ;
  standardiserbar_av_1_A : A ;
  standardmaessig_av_1_1_A : A ;
  standardspraaklig_av_1_1_A : A ;
  stark_av_1_A : A ;
  startsnabb_av_1_A : A ;
  stationerbar_av_1_A : A ;
  stationaer_av_1_1_A : A ;
  statisk_av_1_A : A ;
  statistikmaessig_av_1_1_A : A ;
  statistisk_av_1_A : A ;
  stativ_av_1_A : A ;
  statlig_av_1_A : A ;
  statsfinansiell_av_1_A : A ;
  statskvinnamaessig_av_1_1_A : A ;
  statskvinnomaessig_av_1_1_A : A ;
  statsloes_av_1_1_A : A ;
  statsmannamaessig_av_1_1_A : A ;
  statuarisk_av_1_A : A ;
  statuerbar_av_1_A : A ;
  statusmaessig_av_1_1_A : A ;
  stegloes_av_1_1_A : A ;
  stekhet_av_1_A : A ;
  stel_av_1_A : A ;
  stellar_av_1_A : A ;
  stellarisk_av_1_A : A ;
  stencilerbar_av_1_A : A ;
  stendoev_av_1_1_A : A ;
  stenfri_av_1_A : A ;
  stenig_av_1_A : A ;
  stenograferbar_av_1_A : A ;
  stenrik_av_1_A : A ;
  stenaaldersmaessig_av_1_1_A : A ;
  stereofonisk_av_1_A : A ;
  stereofotograferbar_av_1_A : A ;
  stereotyp_av_1_A : A ;
  stereotyperbar_av_1_A : A ;
  steril_av_1_A : A ;
  steriliserbar_av_1_A : A ;
  sterisk_av_1_A : A ;
  stickelhaarig_av_1_1_A : A ;
  stickig_av_1_A : A ;
  stickprovsmaessig_av_1_1_A : A ;
  stigloes_av_1_1_A : A ;
  stigmatiserbar_av_1_A : A ;
  stikisk_av_1_A : A ;
  stilenlig_av_1_A : A ;
  stilfull_av_1_A : A ;
  stilig_av_1_A : A ;
  stiliserbar_av_1_A : A ;
  stilistisk_av_1_A : A ;
  stilloes_av_1_1_A : A ;
  stilmaessig_av_1_1_A : A ;
  stilvidrig_av_1_A : A ;
  stimmig_av_1_A : A ;
  stimulerbar_av_1_A : A ;
  stingslig_av_1_A : A ;
  stipendierbar_av_1_A : A ;
  stipulerbar_av_1_A : A ;
  stirrig_av_1_A : A ;
  stjaelbar_av_1_1_A : A ;
  stjaernformig_av_1_1_A : A ;
  stjaernklar_av_1_1_A : A ;
  stjaernlik_av_1_1_A : A ;
  stjaernljus_av_1_1_A : A ;
  stockholmsmaessig_av_1_1_A : A ;
  stockkonservativ_av_1_A : A ;
  stofferbar_av_1_A : A ;
  stoisk_av_1_A : A ;
  stojig_av_1_A : A ;
  stokastisk_av_1_A : A ;
  stollig_av_1_A : A ;
  storbandsmaessig_av_1_1_A : A ;
  storblommig_av_1_A : A ;
  storbritannisk_av_1_A : A ;
  storleksmaessig_av_1_1_A : A ;
  stormaktspolitisk_av_1_A : A ;
  stormfri_av_1_A : A ;
  stormig_av_1_A : A ;
  stormrik_av_1_A : A ;
  storordig_av_1_A : A ;
  storpipig_av_1_A : A ;
  storpolitisk_av_1_A : A ;
  storrysk_av_1_A : A ;
  storskalig_av_1_A : A ;
  storstadsmaessig_av_1_1_A : A ;
  storsvensk_av_1_A : A ;
  storymaessig_av_1_1_A : A ;
  straffbar_av_1_A : A ;
  straffloes_av_1_1_A : A ;
  strak_av_1_A : A ;
  stram_av_1_A : A ;
  strangulerbar_av_1_A : A ;
  strategisk_av_1_A : A ;
  stratifierbar_av_1_A : A ;
  stressig_av_1_A : A ;
  stresstaalig_av_1_1_A : A ;
  stretig_av_1_A : A ;
  stridbar_av_1_A : A ;
  stridig_av_1_A : A ;
  stridsduglig_av_1_A : A ;
  stridsformerbar_av_1_A : A ;
  stridsgrupperbar_av_1_A : A ;
  stridsmaessig_av_1_1_A : A ;
  strimmig_av_1_A : A ;
  stripig_av_1_A : A ;
  strofisk_av_1_A : A ;
  strong_av_1_A : A ;
  stroppig_av_1_A : A ;
  strukturell_av_1_A : A ;
  strukturerbar_av_1_A : A ;
  strukturrationaliserbar_av_1_A : A ;
  strulig_av_1_A : A ;
  struntfin_av_1_A : A ;
  struntfoernaem_av_1_1_A : A ;
  struntviktig_av_1_A : A ;
  struttig_av_1_A : A ;
  stryktaeck_av_1_1_A : A ;
  stryktaalig_av_1_1_A : A ;
  straeng_av_1_1_A : A ;
  straev_av_1_1_A : A ;
  straevhaarig_av_1_1_A : A ;
  straevig_av_1_1_A : A ;
  straalfenig_av_1_1_A : A ;
  straalkonserverbar_av_1_1_A : A ;
  stroem_av_1_1_A : A ;
  stubbig_av_1_A : A ;
  studentikos_av_1_A : A ;
  studerbar_av_1_A : A ;
  studiemaessig_av_1_1_A : A ;
  studieorienterbar_av_1_A : A ;
  studiomaessig_av_1_1_A : A ;
  stumfilmsmaessig_av_1_1_A : A ;
  stundlig_av_1_A : A ;
  stupfull_av_1_A : A ;
  sturig_av_1_A : A ;
  stursk_av_1_A : A ;
  stygg_av_1_A : A ;
  styrbar_av_1_A : A ;
  styrselloes_av_1_1_A : A ;
  styv_av_1_A : A ;
  styvmoderlig_av_1_A : A ;
  staemningsfull_av_1_1_A : A ;
  staendig_av_1_1_A : A ;
  staerkelserik_av_1_1_A : A ;
  staalvit_av_1_1_A : A ;
  staandaktig_av_1_1_A : A ;
  staandmaessig_av_1_1_A : A ;
  staandsmaessig_av_1_1_A : A ;
  staatlig_av_1_1_A : A ;
  stoeddig_av_1_1_A : A ;
  stoekig_av_1_1_A : A ;
  stoerig_av_1_1_A : A ;
  stoertkaer_av_1_1_A : A ;
  stoettaalig_av_1_1_A : A ;
  subalpin_av_1_A : A ;
  subantarktisk_av_1_A : A ;
  subarktisk_av_1_A : A ;
  subbig_av_1_A : A ;
  subjektiv_av_1_A : A ;
  subkutan_av_1_A : A ;
  sublim_av_1_A : A ;
  sublimerbar_av_1_A : A ;
  subliminal_av_1_A : A ;
  submarin_av_1_A : A ;
  subordinerbar_av_1_A : A ;
  subsidierbar_av_1_A : A ;
  subsidiaer_av_1_1_A : A ;
  subskriberbar_av_1_A : A ;
  substantiell_av_1_A : A ;
  substantiverbar_av_1_A : A ;
  substituerbar_av_1_A : A ;
  subsumerbar_av_1_A : A ;
  subtil_av_1_A : A ;
  subtraherbar_av_1_A : A ;
  subtropisk_av_1_A : A ;
  subventionerbar_av_1_A : A ;
  subversiv_av_1_A : A ;
  succederbar_av_1_A : A ;
  successiv_av_1_A : A ;
  sudanesisk_av_1_A : A ;
  suddig_av_1_A : A ;
  suffigerbar_av_1_A : A ;
  sufflerbar_av_1_A : A ;
  suggererbar_av_1_A : A ;
  suggestiv_av_1_A : A ;
  suicidal_av_1_A : A ;
  sumerisk_av_1_A : A ;
  summarisk_av_1_A : A ;
  summerbar_av_1_A : A ;
  sumpig_av_1_A : A ;
  sunkig_av_1_A : A ;
  superb_av_1_A : A ;
  superlativ_av_1_A : A ;
  supersnabb_av_1_A : A ;
  supersonisk_av_1_A : A ;
  superstark_av_1_A : A ;
  supig_av_1_A : A ;
  supplementaer_av_1_1_A : A ;
  supplerbar_av_1_A : A ;
  supponerbar_av_1_A : A ;
  supradental_av_1_A : A ;
  supramarin_av_1_A : A ;
  sur_av_1_A : A ;
  surfbar_av_1_A : A ;
  surinamesisk_av_1_A : A ;
  surrealistisk_av_1_A : A ;
  suspenderbar_av_1_A : A ;
  suspensiv_av_1_A : A ;
  suveraen_av_1_1_A : A ;
  svag_av_1_A : A ;
  svagtonig_av_1_A : A ;
  svajig_av_1_A : A ;
  sval_av_1_A : A ;
  svamlig_av_1_A : A ;
  svampig_av_1_A : A ;
  svankig_av_1_A : A ;
  svarsloes_av_1_1_A : A ;
  svartmuskig_av_1_A : A ;
  svartsjuk_av_1_A : A ;
  svartvit_av_1_A : A ;
  svekfri_av_1_A : A ;
  svekfull_av_1_A : A ;
  sveklig_av_1_A : A ;
  svekloes_av_1_1_A : A ;
  svensk_rysk_av_1_A : A ;
  svensk_av_1_A : A ;
  svettig_av_1_A : A ;
  sviklig_av_1_A : A ;
  svimfaerdig_av_1_1_A : A ;
  svinaktig_av_1_A : A ;
  svindyr_av_1_A : A ;
  svinkall_av_1_A : A ;
  svulstig_av_1_A : A ;
  svaeltmaessig_av_1_1_A : A ;
  svaengbar_av_1_1_A : A ;
  svaengig_av_1_1_A : A ;
  svaerdlik_av_1_1_A : A ;
  svaerdsloes_av_1_1_A : A ;
  svaermisk_av_1_1_A : A ;
  svaar_av_1_1_A : A ;
  svaaravvislig_av_1_1_A : A ;
  svaarbegriplig_av_1_1_A : A ;
  svaarfattlig_av_1_1_A : A ;
  svaarframkomlig_av_1_1_A : A ;
  svaarfoerklarlig_av_1_1_A : A ;
  svaarfoerstaaelig_av_1_1_A : A ;
  svaargenomtraenglig_av_1_1_A : A ;
  svaarhanterlig_av_1_1_A : A ;
  svaarintaglig_av_1_1_A : A ;
  svaarmodig_av_1_1_A : A ;
  svaarpaavisbar_av_1_1_A : A ;
  svaartillgaenglig_av_1_1_A : A ;
  svaaroeverblickbar_av_1_1_A : A ;
  svaaroeverskaadlig_av_1_1_A : A ;
  swazilaendsk_av_1_1_A : A ;
  sybaritisk_av_1_A : A ;
  sydafrikansk_av_1_A : A ;
  sydamerikansk_av_1_A : A ;
  sydkoreansk_av_1_A : A ;
  sydlig_av_1_A : A ;
  sydlaendsk_av_1_1_A : A ;
  sydsvensk_av_1_A : A ;
  syfilitisk_av_1_A : A ;
  sylfidisk_av_1_A : A ;
  syllabisk_av_1_A : A ;
  symbiotisk_av_1_A : A ;
  symboliserbar_av_1_A : A ;
  symbolisk_av_1_A : A ;
  symbolmaessig_av_1_1_A : A ;
  symfonisk_av_1_A : A ;
  symmetrisk_av_1_A : A ;
  sympatetisk_av_1_A : A ;
  sympatisk_av_1_A : A ;
  symptomatisk_av_1_A : A ;
  symtomatisk_av_1_A : A ;
  synbar_av_1_A : A ;
  synbarlig_av_1_A : A ;
  syndfull_av_1_A : A ;
  syndig_av_1_A : A ;
  synkoperbar_av_1_A : A ;
  synkopisk_av_1_A : A ;
  synkron_av_1_A : A ;
  synkroniserbar_av_1_A : A ;
  synkronisk_av_1_A : A ;
  synlig_av_1_A : A ;
  synnerlig_av_1_A : A ;
  synodal_av_1_A : A ;
  synodisk_av_1_A : A ;
  synonym_av_1_A : A ;
  synoptisk_av_1_A : A ;
  synsk_av_1_A : A ;
  syntaktisk_av_1_A : A ;
  syntetiserbar_av_1_A : A ;
  syntetisk_av_1_A : A ;
  syperb_av_1_A : A ;
  syrefattig_av_1_A : A ;
  syrerik_av_1_A : A ;
  syrisk_av_1_A : A ;
  syrlig_av_1_A : A ;
  syskonlig_av_1_A : A ;
  sysselsaettningsmaessig_av_1_1_A : A ;
  syssloloes_av_1_1_A : A ;
  systematiserbar_av_1_A : A ;
  systematisk_av_1_A : A ;
  systemmaessig_av_1_1_A : A ;
  systerlig_av_1_A : A ;
  systolisk_av_1_A : A ;
  saeckig_av_1_1_A : A ;
  saekerhetsmaessig_av_1_1_A : A ;
  saeljbar_av_1_1_A : A ;
  saell_av_1_1_A : A ;
  saellskaplig_av_1_1_A : A ;
  saellskapssjuk_av_1_1_A : A ;
  saerklassig_av_1_1_A : A ;
  saesongmaessig_av_1_1_A : A ;
  saesongsmaessig_av_1_1_A : A ;
  saevlig_av_1_1_A : A ;
  saadig_av_1_1_A : A ;
  saangbar_av_1_1_A : A ;
  saanglig_av_1_1_A : A ;
  saangmaessig_av_1_1_A : A ;
  saaphal_av_1_1_A : A ;
  saarbar_av_1_1_A : A ;
  saarig_av_1_1_A : A ;
  saasig_av_1_1_A : A ;
  saaterbar_av_1_1_A : A ;
  saaverbar_av_1_1_A : A ;
  soedermanlaendsk_av_1_1_A : A ;
  soelig_av_1_1_A : A ;
  soemngaangaraktig_av_1_1_A : A ;
  soemnig_av_1_1_A : A ;
  soemnloes_av_1_1_A : A ;
  soemntung_av_1_1_A : A ;
  soendaglig_av_1_1_A : A ;
  soendrig_av_1_1_A : A ;
  soerlaendsk_av_1_1_A : A ;
  soermlaendsk_av_1_1_A : A ;
  soet_av_1_1_A : A ;
  soetaktig_av_1_1_A : A ;
  soetsliskig_av_1_1_A : A ;
  soetsur_av_1_1_A : A ;
  tabellarisk_av_1_A : A ;
  tabellerbar_av_1_A : A ;
  tablaamaessig_av_1_1_A : A ;
  tabuerbar_av_1_A : A ;
  tacknaemlig_av_1_1_A : A ;
  tadzjikisk_av_1_A : A ;
  tafflig_av_1_A : A ;
  tafsig_av_1_A : A ;
  taggfenig_av_1_A : A ;
  taggig_av_1_A : A ;
  taiwanesisk_av_1_A : A ;
  taktfull_av_1_A : A ;
  taktil_av_1_A : A ;
  taktisk_av_1_A : A ;
  taktloes_av_1_1_A : A ;
  taktmaessig_av_1_1_A : A ;
  talangfull_av_1_A : A ;
  talangloes_av_1_1_A : A ;
  talfoer_av_1_1_A : A ;
  talgig_av_1_A : A ;
  talkig_av_1_A : A ;
  tallrik_av_1_A : A ;
  talloes_av_1_1_A : A ;
  talrik_av_1_A : A ;
  talspraaklig_av_1_1_A : A ;
  talspraaksmaessig_av_1_1_A : A ;
  tam_av_1_A : A ;
  tamponerbar_av_1_A : A ;
  tandlik_av_1_A : A ;
  tandloes_av_1_1_A : A ;
  tandvaenlig_av_1_1_A : A ;
  tangerbar_av_1_A : A ;
  tanig_av_1_A : A ;
  tankemaessig_av_1_1_A : A ;
  tankfull_av_1_A : A ;
  tankloes_av_1_1_A : A ;
  tantaktig_av_1_A : A ;
  tantig_av_1_A : A ;
  tanzanisk_av_1_A : A ;
  tapetserbar_av_1_A : A ;
  tarerbar_av_1_A : A ;
  tarifferbar_av_1_A : A ;
  tarvlig_av_1_A : A ;
  taskig_av_1_A : A ;
  tatuerbar_av_1_A : A ;
  tautologisk_av_1_A : A ;
  taxerbar_av_1_A : A ;
  taxeringsmaessig_av_1_1_A : A ;
  tchadisk_av_1_A : A ;
  teatermaessig_av_1_1_A : A ;
  teatral_av_1_A : A ;
  teatralisk_av_1_A : A ;
  teknifierbar_av_1_A : A ;
  teknisk_av_1_A : A ;
  teknologisk_av_1_A : A ;
  telefonerbar_av_1_A : A ;
  telegraferbar_av_1_A : A ;
  telegrafisk_av_1_A : A ;
  teleologisk_av_1_A : A ;
  telepatisk_av_1_A : A ;
  teleskopisk_av_1_A : A ;
  teleteknisk_av_1_A : A ;
  televiserbar_av_1_A : A ;
  tellurisk_av_1_A : A ;
  tematisk_av_1_A : A ;
  temperamentfull_av_1_A : A ;
  temperamentsfull_av_1_A : A ;
  temperaturbestaendig_av_1_1_A : A ;
  temperaturkaenslig_av_1_1_A : A ;
  temperbar_av_1_A : A ;
  tempererbar_av_1_A : A ;
  tempomaessig_av_1_1_A : A ;
  temporaer_av_1_1_A : A ;
  tendensloes_av_1_1_A : A ;
  tendentioes_av_1_1_A : A ;
  tentativ_av_1_A : A ;
  tenterbar_av_1_A : A ;
  teocentrisk_av_1_A : A ;
  teokratisk_av_1_A : A ;
  teologisk_av_1_A : A ;
  teoretisk_av_1_A : A ;
  teosofisk_av_1_A : A ;
  terapeutisk_av_1_A : A ;
  terminal_av_1_A : A ;
  terminlig_av_1_A : A ;
  terminologisk_av_1_A : A ;
  termisk_av_1_A : A ;
  termitbestaendig_av_1_1_A : A ;
  termodynamisk_av_1_A : A ;
  termofil_av_1_A : A ;
  termonukleaer_av_1_1_A : A ;
  terrasserbar_av_1_A : A ;
  territoriell_av_1_A : A ;
  terroriserbar_av_1_A : A ;
  tertiaer_av_1_1_A : A ;
  tesaurerbar_av_1_A : A ;
  testamentarisk_av_1_A : A ;
  testamenterbar_av_1_A : A ;
  testig_av_1_A : A ;
  tetig_av_1_A : A ;
  textil_av_1_A : A ;
  textkritisk_av_1_A : A ;
  textmaessig_av_1_1_A : A ;
  thailaendsk_av_1_1_A : A ;
  tibetansk_av_1_A : A ;
  tidig_av_1_A : A ;
  tidlig_av_1_A : A ;
  tidloes_av_1_1_A : A ;
  tidsenlig_av_1_A : A ;
  tidslig_av_1_A : A ;
  tidsmaessig_av_1_1_A : A ;
  tidstypisk_av_1_A : A ;
  tidtabellsmaessig_av_1_1_A : A ;
  tigerrandig_av_1_A : A ;
  tigerstrimmig_av_1_A : A ;
  tillboerlig_av_1_1_A : A ;
  tillfaellig_av_1_1_A : A ;
  tillfoerlitlig_av_1_1_A : A ;
  tillgaenglig_av_1_1_A : A ;
  tillhoerig_av_1_1_A : A ;
  tillitsfull_av_1_A : A ;
  tillraecklig_av_1_1_A : A ;
  tillraeknelig_av_1_1_A : A ;
  tillraadlig_av_1_1_A : A ;
  tillstaendig_av_1_1_A : A ;
  tillaemplig_av_1_1_A : A ;
  tillaatlig_av_1_1_A : A ;
  timlig_av_1_A : A ;
  timslaang_av_1_1_A : A ;
  tiofaldig_av_1_A : A ;
  titanisk_av_1_A : A ;
  titelsjuk_av_1_A : A ;
  titrerbar_av_1_A : A ;
  tittarmaessig_av_1_1_A : A ;
  titulerbar_av_1_A : A ;
  tixotrop_av_1_A : A ;
  tjafsig_av_1_A : A ;
  tjatig_av_1_A : A ;
  tjeckisk_av_1_A : A ;
  tjeckoslovakisk_av_1_A : A ;
  tjetjensk_av_1_A : A ;
  tjock_av_1_A : A ;
  tjockskallig_av_1_A : A ;
  tjugoplanig_av_1_A : A ;
  tjurig_av_1_A : A ;
  tjurskallig_av_1_A : A ;
  tjusig_av_1_A : A ;
  tjuvaktig_av_1_A : A ;
  tjuvtjock_av_1_A : A ;
  tjyvaktig_av_1_A : A ;
  tjyvtjock_av_1_A : A ;
  tjaenlig_av_1_1_A : A ;
  tjaenstaktig_av_1_1_A : A ;
  tjaenstbar_av_1_1_A : A ;
  tjaenstemannamaessig_av_1_1_A : A ;
  tjaenstfri_av_1_1_A : A ;
  tjaenstledig_av_1_1_A : A ;
  tjaenstvillig_av_1_1_A : A ;
  tofsig_av_1_A : A ;
  togolesisk_av_1_A : A ;
  tokig_av_1_A : A ;
  tokrolig_av_1_A : A ;
  tolererbar_av_1_A : A ;
  tolkningsmaessig_av_1_1_A : A ;
  tonal_av_1_A : A ;
  tondoev_av_1_1_A : A ;
  tongansk_av_1_A : A ;
  tonisk_av_1_A : A ;
  tonloes_av_1_1_A : A ;
  topografisk_av_1_A : A ;
  topologisk_av_1_A : A ;
  toppformig_av_1_A : A ;
  toppig_av_1_A : A ;
  toppmodern_av_1_A : A ;
  torderbar_av_1_A : A ;
  torftig_av_1_A : A ;
  torpederbar_av_1_A : A ;
  torr_av_1_A : A ;
  torrdestillerbar_av_1_A : A ;
  torrolig_av_1_A : A ;
  torrschamponerbar_av_1_A : A ;
  torterbar_av_1_A : A ;
  torvaktig_av_1_A : A ;
  tosig_av_1_A : A ;
  toskansk_av_1_A : A ;
  tossig_av_1_A : A ;
  total_av_1_A : A ;
  totalfinansierbar_av_1_A : A ;
  totalitaer_av_1_1_A : A ;
  toucherbar_av_1_A : A ;
  touperbar_av_1_A : A ;
  tovig_av_1_A : A ;
  toxikologisk_av_1_A : A ;
  toxisk_av_1_A : A ;
  traderbar_av_1_A : A ;
  tradig_av_1_A : A ;
  traditionell_av_1_A : A ;
  traditionsenlig_av_1_A : A ;
  traditionsrik_av_1_A : A ;
  trafikerbar_av_1_A : A ;
  trafikfarlig_av_1_A : A ;
  trafikmaessig_av_1_1_A : A ;
  trafikreglerbar_av_1_A : A ;
  trafiksaekerhetsmaessig_av_1_1_A : A ;
  tragglig_av_1_A : A ;
  tragikomisk_av_1_A : A ;
  tragisk_av_1_A : A ;
  trakasserbar_av_1_A : A ;
  trakterbar_av_1_A : A ;
  tramsig_av_1_A : A ;
  trancherbar_av_1_A : A ;
  trankil_av_1_A : A ;
  transalpin_av_1_A : A ;
  transalpinsk_av_1_A : A ;
  transatlantisk_av_1_A : A ;
  transcendental_av_1_A : A ;
  transfererbar_av_1_A : A ;
  transformerbar_av_1_A : A ;
  transiterbar_av_1_A : A ;
  transitiv_av_1_A : A ;
  transitorisk_av_1_A : A ;
  transkontinental_av_1_A : A ;
  transkriberbar_av_1_A : A ;
  translittererbar_av_1_A : A ;
  transmitterbar_av_1_A : A ;
  transmuterbar_av_1_A : A ;
  transocean_av_1_A : A ;
  transoceansk_av_1_A : A ;
  transplanterbar_av_1_A : A ;
  transponerbar_av_1_A : A ;
  transporterbar_av_1_A : A ;
  transportmaessig_av_1_1_A : A ;
  transsexuell_av_1_A : A ;
  transsibirisk_av_1_A : A ;
  transumerbar_av_1_A : A ;
  transversal_av_1_A : A ;
  transversell_av_1_A : A ;
  trappklok_av_1_A : A ;
  trasig_av_1_A : A ;
  trasserbar_av_1_A : A ;
  trasslig_av_1_A : A ;
  trattformig_av_1_A : A ;
  traumatisk_av_1_A : A ;
  travesterbar_av_1_A : A ;
  tredimensionell_av_1_A : A ;
  tredsk_av_1_A : A ;
  treenig_av_1_A : A ;
  trefaldig_av_1_A : A ;
  trefasig_av_1_A : A ;
  trefilig_av_1_A : A ;
  trekantig_av_1_A : A ;
  trekvartslaang_av_1_1_A : A ;
  trendig_av_1_A : A ;
  trendkaenslig_av_1_1_A : A ;
  trendmaessig_av_1_1_A : A ;
  trendriktig_av_1_A : A ;
  trepanerbar_av_1_A : A ;
  treradig_av_1_A : A ;
  tresiffrig_av_1_A : A ;
  trestavig_av_1_A : A ;
  trestjaernig_av_1_1_A : A ;
  trevinklig_av_1_A : A ;
  trevlig_av_1_A : A ;
  triangulerbar_av_1_A : A ;
  triangulaer_av_1_1_A : A ;
  tribadisk_av_1_A : A ;
  trierbar_av_1_A : A ;
  trigonometrisk_av_1_A : A ;
  trikinoes_av_1_1_A : A ;
  trilateral_av_1_A : A ;
  trilsk_av_1_A : A ;
  trindbladig_av_1_A : A ;
  trinidadisk_av_1_A : A ;
  triumfatorisk_av_1_A : A ;
  trivial_av_1_A : A ;
  trivialiserbar_av_1_A : A ;
  trixig_av_1_A : A ;
  trojansk_av_1_A : A ;
  trokaisk_av_1_A : A ;
  trok_eisk_av_1_1_A : A ;
  trolig_av_1_A : A ;
  trollkunnig_av_1_A : A ;
  trolsk_av_1_A : A ;
  troloes_av_1_1_A : A ;
  tropisk_av_1_A : A ;
  troskyldig_av_1_A : A ;
  trosmaessig_av_1_1_A : A ;
  trosviss_av_1_A : A ;
  trotsig_av_1_A : A ;
  trovaerdig_av_1_1_A : A ;
  trubbig_av_1_A : A ;
  trubbnosig_av_1_A : A ;
  trubbvinklig_av_1_A : A ;
  truistisk_av_1_A : A ;
  trulig_av_1_A : A ;
  trulsig_av_1_A : A ;
  tryckbar_av_1_A : A ;
  tryckimpregnerbar_av_1_A : A ;
  tryckkaenslig_av_1_1_A : A ;
  tryckstark_av_1_A : A ;
  trycksvag_av_1_A : A ;
  tryfferbar_av_1_A : A ;
  trygg_av_1_A : A ;
  traeaktig_av_1_1_A : A ;
  traedloes_av_1_1_A : A ;
  traeig_av_1_1_A : A ;
  traelig_av_1_1_A : A ;
  traeningsmaessig_av_1_1_A : A ;
  traeskallig_av_1_1_A : A ;
  traeteknisk_av_1_1_A : A ;
  traetgirig_av_1_1_A : A ;
  traevit_av_1_1_A : A ;
  traadig_av_1_1_A : A ;
  traadloes_av_1_1_A : A ;
  traadraet_av_1_1_A : A ;
  traadsmal_av_1_1_A : A ;
  traakig_av_1_1_A : A ;
  traanadsfull_av_1_1_A : A ;
  traansjuk_av_1_1_A : A ;
  troeg_av_1_1_A : A ;
  troeghetsnavigerbar_av_1_1_A : A ;
  troegroerlig_av_1_1_A : A ;
  troestelig_av_1_1_A : A ;
  troesterik_av_1_1_A : A ;
  troestlig_av_1_1_A : A ;
  troestloes_av_1_1_A : A ;
  troestrik_av_1_1_A : A ;
  tuberkuloes_av_1_1_A : A ;
  tuff_av_1_A : A ;
  tufsig_av_1_A : A ;
  tuktig_av_1_A : A ;
  tuktloes_av_1_1_A : A ;
  tullmaessig_av_1_1_A : A ;
  tullpliktig_av_1_A : A ;
  tumstjock_av_1_A : A ;
  tumultuarisk_av_1_A : A ;
  tunisisk_av_1_A : A ;
  tunnbladig_av_1_A : A ;
  tunnhaarig_av_1_1_A : A ;
  tuperbar_av_1_A : A ;
  turistisk_av_1_A : A ;
  turistmaessig_av_1_1_A : A ;
  turisttaet_av_1_1_A : A ;
  turkisk_av_1_A : A ;
  turkos_av_1_A : A ;
  turlig_av_1_A : A ;
  turnerbar_av_1_A : A ;
  tuscherbar_av_1_A : A ;
  tuvaluansk_av_1_A : A ;
  tuvig_av_1_A : A ;
  tvekloes_av_1_1_A : A ;
  tvetydig_av_1_A : A ;
  tvinsjuk_av_1_A : A ;
  tvistig_av_1_A : A ;
  tvistlig_av_1_A : A ;
  tvivelaktig_av_1_A : A ;
  tvivelsjuk_av_1_A : A ;
  tvaer_av_1_1_A : A ;
  tvaerarg_av_1_1_A : A ;
  tvaerfacklig_av_1_1_A : A ;
  tvaerfakultaer_av_1_1_A : A ;
  tvaerkulturell_av_1_1_A : A ;
  tvaerpolitisk_av_1_1_A : A ;
  tvaerrandig_av_1_1_A : A ;
  tvaervetenskaplig_av_1_1_A : A ;
  tvaettbar_av_1_1_A : A ;
  tvaacylindrig_av_1_1_A : A ;
  tvaadimensionell_av_1_1_A : A ;
  tvaaformig_av_1_1_A : A ;
  tvaahjaertbladig_av_1_1_A : A ;
  tvaahaendig_av_1_1_A : A ;
  tvaalig_av_1_1_A : A ;
  tvaaloperamaessig_av_1_1_A : A ;
  tvaalaeppig_av_1_1_A : A ;
  tvaangfri_av_1_1_A : A ;
  tvaangskommenderbar_av_1_1_A : A ;
  tvaangsmaessig_av_1_1_A : A ;
  tvaangsrekryterbar_av_1_1_A : A ;
  tvaangstatuerbar_av_1_1_A : A ;
  tvaasiffrig_av_1_1_A : A ;
  tvaaspraakig_av_1_1_A : A ;
  tvaastavig_av_1_1_A : A ;
  tydbar_av_1_A : A ;
  tydlig_av_1_A : A ;
  tygelloes_av_1_1_A : A ;
  tyngdloes_av_1_1_A : A ;
  typifierbar_av_1_A : A ;
  typiserbar_av_1_A : A ;
  typisk_av_1_A : A ;
  tyranniserbar_av_1_A : A ;
  tyrannisk_av_1_A : A ;
  tyrolsk_av_1_A : A ;
  tysk_av_1_A : A ;
  taeck_av_1_1_A : A ;
  taeckelig_av_1_1_A : A ;
  taemlig_av_1_1_A : A ;
  taenjbar_av_1_1_A : A ;
  taenkbar_av_1_1_A : A ;
  taet_av_1_1_A : A ;
  taevlingsmaessig_av_1_1_A : A ;
  taalig_av_1_1_A : A ;
  taalmodig_av_1_1_A : A ;
  taarfull_av_1_1_A : A ;
  taarloes_av_1_1_A : A ;
  toecknig_av_1_1_A : A ;
  toeig_av_1_1_A : A ;
  toejbar_av_1_1_A : A ;
  toelpaktig_av_1_1_A : A ;
  toelpig_av_1_1_A : A ;
  toentig_av_1_1_A : A ;
  toernig_av_1_1_A : A ;
  toerstig_av_1_1_A : A ;
  uddataaig_av_1_1_A : A ;
  uddig_av_1_A : A ;
  usel_av_1_A : A ;
  aedel_av_1_1_A : A ;
  abrupt_av_1_A : A ;
  absolut_av_1_A : A ;
  abstrakt_av_1_A : A ;
  abundant_av_1_A : A ;
  ackurat_av_1_A : A ;
  adekvat_av_1_A : A ;
  akut_av_1_A : A ;
  alert_av_1_A : A ;
  allbekant_av_1_A : A ;
  allergen_av_1_A : A ;
  allmogeblaa_av_1_1_A : A ;
  ambivalent_av_1_A : A ;
  andtaeppt_av_1_1_A : A ;
  antibiotikaresistent_av_1_A : A ;
  apart_av_1_A : A ;
  apelgraa_av_1_1_A : A ;
  arbetsofoermoegen_av_1_1_A : A ;
  argsint_av_1_A : A ;
  arrogant_av_1_A : A ;
  askgraa_av_1_1_A : A ;
  atomdriven_av_1_A : A ;
  avbiten_av_1_A : A ;
  avsutten_av_1_A : A ;
  azurblaa_av_1_1_A : A ;
  ballongburen_av_1_A : A ;
  barbent_av_1_A : A ;
  bastant_av_1_A : A ;
  batteridriven_av_1_A : A ;
  becksvart_av_1_A : A ;
  beige_av_1_A : A ;
  bekant_av_1_A : A ;
  belaest_av_1_1_A : A ;
  bemaerkt_av_1_1_A : A ;
  bensindriven_av_1_A : A ;
  berest_av_1_A : A ;
  bergfast_av_1_A : A ;
  beskaenkt_av_1_1_A : A ;
  bestoert_av_1_1_A : A ;
  betjaent_av_1_1_A : A ;
  betryckt_av_1_A : A ;
  betaenkt_av_1_1_A : A ;
  bevaext_av_1_1_A : A ;
  biogasdriven_av_1_A : A ;
  biogen_av_1_A : A ;
  bittersalt_av_1_A : A ;
  bjaert_av_1_1_A : A ;
  blamant_av_1_A : A ;
  blodstaenkt_av_1_1_A : A ;
  blyertsgraa_av_1_1_A : A ;
  blygraa_av_1_1_A : A ;
  blaa_av_1_1_A : A ;
  blaagraa_av_1_1_A : A ;
  blaaslagen_av_1_1_A : A ;
  blaast_av_1_1_A : A ;
  blaasvart_av_1_1_A : A ;
  bloetsvart_av_1_1_A : A ;
  bockbent_av_1_A : A ;
  bofast_av_1_A : A ;
  boghalt_av_1_A : A ;
  boksynt_av_1_A : A ;
  bombfast_av_1_A : A ;
  bortblaast_av_1_1_A : A ;
  bortflugen_av_1_A : A ;
  bortrest_av_1_A : A ;
  bortryckt_av_1_A : A ;
  bortskjuten_av_1_A : A ;
  bottenfast_av_1_A : A ;
  brant_av_1_A : A ;
  bredbent_av_1_A : A ;
  bredmynt_av_1_A : A ;
  briljant_av_1_A : A ;
  brisant_av_1_A : A ;
  brunsvart_av_1_A : A ;
  braeckt_av_1_1_A : A ;
  braenslecellsdriven_av_1_1_A : A ;
  buskbevuxen_av_1_A : A ;
  boerdsstolt_av_1_1_A : A ;
  camp_av_1_A : A ;
  cancerogen_av_1_A : A ;
  carcinogen_av_1_A : A ;
  celest_av_1_A : A ;
  charmant_av_1_A : A ;
  clairvoyant_av_1_A : A ;
  cyanblaa_av_1_1_A : A ;
  dansant_av_1_A : A ;
  darrhaent_av_1_1_A : A ;
  defekt_av_1_A : A ;
  definit_av_1_A : A ;
  dekadent_av_1_A : A ;
  delikat_av_1_A : A ;
  deltidssjukskriven_av_1_A : A ;
  desperat_av_1_A : A ;
  devot_av_1_A : A ;
  dieseldriven_av_1_A : A ;
  different_av_1_A : A ;
  dimblaa_av_1_1_A : A ;
  direkt_av_1_A : A ;
  disjunkt_av_1_A : A ;
  diskordant_av_1_A : A ;
  diskret_av_1_A : A ;
  disparat_av_1_A : A ;
  dissonant_av_1_A : A ;
  distinkt_av_1_A : A ;
  ditflugen_av_1_A : A ;
  divergent_av_1_A : A ;
  djupblaa_av_1_1_A : A ;
  djuptaenkt_av_1_1_A : A ;
  dominant_av_1_A : A ;
  druvblaa_av_1_1_A : A ;
  dunkelblaa_av_1_1_A : A ;
  durabel_av_1_A : A ;
  duvblaa_av_1_1_A : A ;
  dyrkoept_av_1_1_A : A ;
  daest_av_1_1_A : A ;
  doedsfoerskraeckt_av_1_1_A : A ;
  doedsmaerkt_av_1_1_A : A ;
  doedstyst_av_1_1_A : A ;
  doefoerskraeckt_av_1_1_A : A ;
  doetyst_av_1_1_A : A ;
  eftersoekt_av_1_1_A : A ;
  eklatant_av_1_A : A ;
  ekvidistant_av_1_A : A ;
  ekvivalent_av_1_A : A ;
  eldfast_av_1_A : A ;
  eldriven_av_1_A : A ;
  elegant_av_1_A : A ;
  elmotordriven_av_1_A : A ;
  elokvent_av_1_A : A ;
  eminent_av_1_A : A ;
  enbent_av_1_A : A ;
  endogen_av_1_A : A ;
  enkelknaeppt_av_1_1_A : A ;
  enrisroekt_av_1_1_A : A ;
  erogen_av_1_A : A ;
  erotogen_av_1_A : A ;
  etanoldriven_av_1_A : A ;
  evident_av_1_A : A ;
  exakt_av_1_A : A ;
  excellent_av_1_A : A ;
  exogen_av_1_A : A ;
  expedit_av_1_A : A ;
  explicit_av_1_A : A ;
  extrakontant_av_1_A : A ;
  extravagant_av_1_A : A ;
  extrovert_av_1_A : A ;
  fast_av_1_A : A ;
  fastlaast_av_1_1_A : A ;
  femdubbel_av_1_A : A ;
  filttaeckt_av_1_1_A : A ;
  finhyllt_av_1_A : A ;
  finit_av_1_A : A ;
  finstilt_av_1_A : A ;
  flagrant_av_1_A : A ;
  flyhaent_av_1_1_A : A ;
  fosforescent_av_1_A : A ;
  framhjulsdriven_av_1_A : A ;
  framsynt_av_1_A : A ;
  frappant_av_1_A : A ;
  frekvent_av_1_A : A ;
  fromsint_av_1_A : A ;
  fryst_av_1_A : A ;
  fraelst_av_1_1_A : A ;
  fraanaakt_av_1_1_A : A ;
  fullvaext_av_1_1_A : A ;
  fyrbent_av_1_A : A ;
  fyrhjulsdriven_av_1_A : A ;
  fyrkluven_av_1_A : A ;
  faeltgraa_av_1_1_A : A ;
  faest_av_1_1_A : A ;
  faamaelt_av_1_1_A : A ;
  foeranlaaten_av_1_1_A : A ;
  foerkrympt_av_1_1_A : A ;
  foerlaest_av_1_1_A : A ;
  foerment_av_1_1_A : A ;
  foermoegen_av_2_1_A : A ;
  foerryckt_av_1_1_A : A ;
  foersanthaallen_av_1_1_A : A ;
  foerskraeckt_av_1_1_A : A ;
  foersynt_av_1_1_A : A ;
  foertent_av_1_1_A : A ;
  foertjust_av_1_1_A : A ;
  foertjaent_av_1_1_A : A ;
  foertaeckt_av_1_1_A : A ;
  foerunt_av_1_1_A : A ;
  foervaext_av_1_1_A : A ;
  gagatsvart_av_1_A : A ;
  galant_av_1_A : A ;
  gasdriven_av_1_A : A ;
  gemen_av_1_A : A ;
  genant_av_1_A : A ;
  genomstucken_av_1_A : A ;
  genomtryckt_av_1_A : A ;
  genomtaenkt_av_1_1_A : A ;
  gift_av_1_A : A ;
  girvaext_av_1_1_A : A ;
  gladlynt_av_1_A : A ;
  glasfiberfoerstaerkt_av_1_1_A : A ;
  glutenintolerant_av_1_A : A ;
  godlynt_av_1_A : A ;
  godsint_av_1_A : A ;
  golvfast_av_1_A : A ;
  grafitgraa_av_1_1_A : A ;
  grannsynt_av_1_A : A ;
  granntyckt_av_1_A : A ;
  graesbetaeckt_av_1_1_A : A ;
  graesbevuxen_av_1_1_A : A ;
  graa_av_1_1_A : A ;
  graablaa_av_1_1_A : A ;
  graasvart_av_1_1_A : A ;
  gudagiven_av_1_A : A ;
  gulgraa_av_1_1_A : A ;
  hallucinogen_av_1_A : A ;
  halt_av_1_A : A ;
  halvgalen_av_1_A : A ;
  halvrutten_av_1_A : A ;
  halvsmaelt_av_1_1_A : A ;
  halvtrist_av_1_A : A ;
  handfast_av_1_A : A ;
  handhaallen_av_1_1_A : A ;
  handknyten_av_1_A : A ;
  harmynt_av_1_A : A ;
  havsblaa_av_1_1_A : A ;
  helblaa_av_1_1_A : A ;
  helgjuten_av_2_A : A ;
  helikopterburen_av_1_A : A ;
  helstekt_av_1_A : A ;
  helsvart_av_1_A : A ;
  hembakt_av_1_A : A ;
  hemburen_av_1_A : A ;
  hemflugen_av_1_A : A ;
  heterogen_av_1_A : A ;
  heterozygot_av_1_A : A ;
  himmelsblaa_av_1_1_A : A ;
  hitflugen_av_1_A : A ;
  hjulbent_av_1_A : A ;
  homogen_av_1_A : A ;
  homozygot_av_1_A : A ;
  honungslen_av_1_A : A ;
  hophaallen_av_1_1_A : A ;
  hopknaeppt_av_1_1_A : A ;
  hopsnoerpt_av_1_1_A : A ;
  hopvaext_av_1_1_A : A ;
  hyperelegant_av_1_A : A ;
  hyperkorrekt_av_1_A : A ;
  haenryckt_av_1_1_A : A ;
  haallfast_av_1_1_A : A ;
  haardhaent_av_1_1_A : A ;
  haardkokt_av_1_1_A : A ;
  haardsmaelt_av_1_1_A : A ;
  hoegblaa_av_1_1_A : A ;
  hoegerhaent_av_1_1_A : A ;
  hoegfrekvent_av_1_1_A : A ;
  hoegintressant_av_1_1_A : A ;
  hoeglaent_av_1_1_A : A ;
  hoegrest_av_1_1_A : A ;
  hoegsint_av_1_1_A : A ;
  hoegvaext_av_1_1_A : A ;
  ifattsprungen_av_1_A : A ;
  ifraansprungen_av_1_1_A : A ;
  igenvaext_av_1_1_A : A ;
  ignorant_av_1_A : A ;
  ihjaelskjuten_av_1_1_A : A ;
  ihjaelslagen_av_1_1_A : A ;
  ilandfluten_av_1_A : A ;
  illitterat_av_1_A : A ;
  immanent_av_1_A : A ;
  impertinent_av_1_A : A ;
  implicit_av_1_A : A ;
  imposant_av_1_A : A ;
  impotent_av_1_A : A ;
  inadekvat_av_1_A : A ;
  indefinit_av_1_A : A ;
  indelt_av_1_A : A ;
  indifferent_av_1_A : A ;
  indirekt_av_1_A : A ;
  indiskret_av_1_A : A ;
  indolent_av_1_A : A ;
  inexakt_av_1_A : A ;
  infinit_av_1_A : A ;
  ingift_av_1_A : A ;
  inherent_av_1_A : A ;
  inkompetent_av_1_A : A ;
  inkongruent_av_1_A : A ;
  inkonsekvent_av_1_A : A ;
  inkonstant_av_1_A : A ;
  inkontinent_av_1_A : A ;
  inkorrekt_av_1_A : A ;
  inkroekt_av_1_1_A : A ;
  inkurabel_av_1_A : A ;
  inkurant_av_1_A : A ;
  inlaest_av_1_1_A : A ;
  insinuant_av_1_A : A ;
  inskraenkt_av_1_1_A : A ;
  insolvent_av_1_A : A ;
  insutten_av_1_A : A ;
  intakt_av_1_A : A ;
  intelligent_av_1_A : A ;
  intermittent_av_1_A : A ;
  intolerant_av_1_A : A ;
  intransigent_av_1_A : A ;
  intressant_av_1_A : A ;
  intrigant_av_1_A : A ;
  intrikat_av_1_A : A ;
  introvert_av_1_A : A ;
  intryckt_av_1_A : A ;
  invariant_av_1_A : A ;
  invikt_av_1_A : A ;
  irrelevant_av_1_A : A ;
  isblaa_av_1_1_A : A ;
  istaeckt_av_1_1_A : A ;
  jordfast_av_1_A : A ;
  just_av_1_A : A ;
  jaemspelt_av_1_1_A : A ;
  jaetteschyst_av_1_1_A : A ;
  kamouflagegraa_av_1_1_A : A ;
  karaktaersfast_av_1_1_A : A ;
  karaktaersloes_av_1_1_A : A ;
  kavat_av_1_A : A ;
  klarblaa_av_1_1_A : A ;
  klarsynt_av_1_A : A ;
  klartaenkt_av_1_1_A : A ;
  klimatsmart_av_1_A : A ;
  klaervoajant_av_1_1_A : A ;
  knaeckt_av_1_1_A : A ;
  knaekort_av_1_1_A : A ;
  knaepptyst_av_1_1_A : A ;
  kobent_av_1_A : A ;
  koftgraa_av_1_1_A : A ;
  koherent_av_1_A : A ;
  koksgraa_av_1_1_A : A ;
  kokt_av_1_A : A ;
  kolsvart_av_1_A : A ;
  kompakt_av_1_A : A ;
  kompetent_av_1_A : A ;
  konciliant_av_1_A : A ;
  kongruent_av_1_A : A ;
  konkret_av_1_A : A ;
  konsekvent_av_1_A : A ;
  konsiliant_av_1_A : A ;
  konsonant_av_1_A : A ;
  konstant_av_1_A : A ;
  kontant_av_1_A : A ;
  konvalescent_av_1_A : A ;
  konvergent_av_1_A : A ;
  kopplerimisstaenkt_av_1_1_A : A ;
  kornblaa_av_1_1_A : A ;
  korpsvart_av_1_A : A ;
  korpulent_av_1_A : A ;
  korrekt_av_1_A : A ;
  korrupt_av_1_A : A ;
  kort_av_1_A : A ;
  kortbent_av_1_A : A ;
  kortklippt_av_1_A : A ;
  kortkort_av_1_A : A ;
  kortsynt_av_1_A : A ;
  korttaenkt_av_1_1_A : A ;
  kortvaext_av_1_1_A : A ;
  kovalent_av_1_A : A ;
  kovert_av_1_A : A ;
  kringsynt_av_1_A : A ;
  krisgraa_av_1_1_A : A ;
  kroknaest_av_1_1_A : A ;
  kroekt_av_1_1_A : A ;
  kullfallen_av_1_A : A ;
  kuloert_av_1_1_A : A ;
  kungsblaa_av_1_1_A : A ;
  kurant_av_1_A : A ;
  kvicktaenkt_av_1_1_A : A ;
  kvinnoburen_av_1_A : A ;
  laktosintolerant_av_1_A : A ;
  landdriven_av_1_A : A ;
  landfast_av_1_A : A ;
  latent_av_1_A : A ;
  lavendelblaa_av_1_1_A : A ;
  likbent_av_1_A : A ;
  litterat_av_1_A : A ;
  ljusblaa_av_1_1_A : A ;
  ljusgraa_av_1_1_A : A ;
  ljushyllt_av_1_A : A ;
  lossliten_av_1_A : A ;
  laederinbunden_av_1_1_A : A ;
  laettfoertjaent_av_1_1_A : A ;
  laettkokt_av_1_1_A : A ;
  laettkoept_av_1_1_A : A ;
  laettlaest_av_1_1_A : A ;
  laettloest_av_1_1_A : A ;
  laettroekt_av_1_1_A : A ;
  laettsjungen_av_1_1_A : A ;
  laettsmaelt_av_1_1_A : A ;
  laettstekt_av_1_1_A : A ;
  laettstruken_av_1_1_A : A ;
  laettvikt_av_1_1_A : A ;
  laagfrekvent_av_1_1_A : A ;
  laaghalt_av_1_1_A : A ;
  laaglaent_av_1_1_A : A ;
  laagsint_av_1_1_A : A ;
  laagvaext_av_1_1_A : A ;
  laangbent_av_1_1_A : A ;
  laangnaest_av_1_1_A : A ;
  laangsint_av_1_1_A : A ;
  laangstraeckt_av_1_1_A : A ;
  laangsynt_av_1_1_A : A ;
  laangsoekt_av_1_1_A : A ;
  laangtidssjukskriven_av_1_1_A : A ;
  laant_av_1_1_A : A ;
  loesbruten_av_1_1_A : A ;
  loeskokt_av_1_1_A : A ;
  loesmynt_av_1_1_A : A ;
  loesryckt_av_1_1_A : A ;
  loesslaeppt_av_1_1_A : A ;
  manifest_av_1_A : A ;
  marinblaa_av_1_1_A : A ;
  markant_av_1_A : A ;
  marknadsbaserad_av_1_A : A ;
  mattsvart_av_1_A : A ;
  mellanblaa_av_1_1_A : A ;
  midnattsblaa_av_1_1_A : A ;
  mildsint_av_1_A : A ;
  militant_av_1_A : A ;
  mintblaa_av_1_1_A : A ;
  minutkort_av_1_A : A ;
  misslynt_av_1_A : A ;
  misstaenkt_av_1_1_A : A ;
  mjoelksvullen_av_1_1_A : A ;
  moderat_av_1_A : A ;
  modest_av_1_A : A ;
  moltyst_av_1_A : A ;
  mordmisstaenkt_av_1_1_A : A ;
  motordriven_av_1_A : A ;
  multiresistent_av_1_A : A ;
  muromsluten_av_1_A : A ;
  musgraa_av_1_1_A : A ;
  mutmisstaenkt_av_1_1_A : A ;
  maanbelyst_av_1_1_A : A ;
  maangalen_av_1_1_A : A ;
  moerkblaa_av_1_1_A : A ;
  nattblaa_av_1_1_A : A ;
  nattsvart_av_1_A : A ;
  naturgiven_av_1_A : A ;
  nedrest_av_1_A : A ;
  nedtryckt_av_1_A : A ;
  nertryckt_av_1_A : A ;
  niodubbel_av_1_A : A ;
  njugghaent_av_1_1_A : A ;
  nonchalant_av_1_A : A ;
  notfast_av_1_A : A ;
  nyavgaangen_av_1_1_A : A ;
  nygift_av_1_A : A ;
  nyinkoept_av_1_1_A : A ;
  nyklippt_av_1_A : A ;
  nyskriven_av_1_A : A ;
  nytagen_av_1_A : A ;
  nyupptaeckt_av_1_1_A : A ;
  naersynt_av_1_1_A : A ;
  oanloept_av_1_1_A : A ;
  oanmaerkt_av_1_1_A : A ;
  oansoekt_av_1_1_A : A ;
  oavblaast_av_1_1_A : A ;
  oavhjaelpt_av_1_1_A : A ;
  oavhyst_av_1_A : A ;
  oavlyst_av_1_A : A ;
  oavloept_av_1_1_A : A ;
  oavloest_av_1_1_A : A ;
  oavrest_av_1_A : A ;
  oavskraeckt_av_1_1_A : A ;
  oavstyrkt_av_1_A : A ;
  oavsoekt_av_1_1_A : A ;
  oavtaeckt_av_1_1_A : A ;
  obannlyst_av_1_A : A ;
  obeglaenst_av_1_1_A : A ;
  obekant_av_1_A : A ;
  obekroent_av_1_1_A : A ;
  obelyst_av_1_A : A ;
  obemaerkt_av_1_1_A : A ;
  obestyrkt_av_1_A : A ;
  obestaenkt_av_1_1_A : A ;
  obesoekt_av_1_1_A : A ;
  obetryckt_av_1_A : A ;
  obetaeckt_av_1_1_A : A ;
  obetaenkt_av_1_1_A : A ;
  obistraeckt_av_1_1_A : A ;
  oblekt_av_1_A : A ;
  obligat_av_1_A : A ;
  oblaast_av_1_1_A : A ;
  obrynt_av_1_A : A ;
  obraeckt_av_1_1_A : A ;
  observant_av_1_A : A ;
  obskurant_av_1_A : A ;
  obsolet_av_1_A : A ;
  obstinat_av_1_A : A ;
  ockult_av_1_A : A ;
  odriven_av_1_A : A ;
  odraenkt_av_1_1_A : A ;
  odraept_av_1_1_A : A ;
  odaenkt_av_1_1_A : A ;
  odoept_av_1_1_A : A ;
  oefterlyst_av_1_A : A ;
  oefterskaenkt_av_1_1_A : A ;
  oeftersoekt_av_1_1_A : A ;
  oflaekt_av_1_1_A : A ;
  ofrimaerkt_av_1_1_A : A ;
  ofraelst_av_1_1_A : A ;
  ofraest_av_1_1_A : A ;
  ofoerkrympt_av_1_1_A : A ;
  ofoerlikt_av_1_1_A : A ;
  ofoerlist_av_1_1_A : A ;
  ofoerloest_av_1_1_A : A ;
  ofoermaerkt_av_1_1_A : A ;
  ofoerryckt_av_1_1_A : A ;
  ofoerskraeckt_av_1_1_A : A ;
  ofoerstraeckt_av_1_1_A : A ;
  ofoerstaerkt_av_1_1_A : A ;
  ofoersynt_av_1_1_A : A ;
  ofoersaenkt_av_1_1_A : A ;
  ofoertjust_av_1_1_A : A ;
  ofoertjaent_av_1_1_A : A ;
  ofoertryckt_av_1_1_A : A ;
  ofoertyckt_av_1_1_A : A ;
  ofoertaeckt_av_1_1_A : A ;
  ofoertaenkt_av_1_1_A : A ;
  ofoest_av_1_1_A : A ;
  ogenomlyst_av_1_A : A ;
  ogenomsoekt_av_1_1_A : A ;
  ogenomtaenkt_av_1_1_A : A ;
  ogift_av_1_A : A ;
  ogulden_av_1_A : A ;
  ohemsoekt_av_1_1_A : A ;
  ohjaelpt_av_1_1_A : A ;
  ohyst_av_1_A : A ;
  ohaenryckt_av_1_1_A : A ;
  oindraenkt_av_1_1_A : A ;
  oinhyst_av_1_A : A ;
  oinkoept_av_1_1_A : A ;
  oinloept_av_1_1_A : A ;
  oinloest_av_1_1_A : A ;
  oinskraenkt_av_1_1_A : A ;
  oinskaerpt_av_1_1_A : A ;
  oinsvept_av_1_A : A ;
  ointelligent_av_1_A : A ;
  ointressant_av_1_A : A ;
  ojust_av_1_A : A ;
  ojaest_av_1_1_A : A ;
  oklippt_av_1_A : A ;
  oklaeckt_av_1_1_A : A ;
  okloest_av_1_1_A : A ;
  oknyckt_av_1_A : A ;
  oknaeckt_av_1_1_A : A ;
  oknaeppt_av_1_1_A : A ;
  okokt_av_1_A : A ;
  okontant_av_1_A : A ;
  okrympt_av_1_A : A ;
  okraenkt_av_1_1_A : A ;
  okroekt_av_1_1_A : A ;
  okroent_av_1_1_A : A ;
  okvaest_av_1_1_A : A ;
  okysst_av_1_A : A ;
  okoept_av_1_1_A : A ;
  olyst_av_1_A : A ;
  olaeckt_av_1_1_A : A ;
  olaekt_av_1_1_A : A ;
  olaest_av_1_1_A : A ;
  olaast_av_1_1_A : A ;
  oloent_av_1_1_A : A ;
  oloest_av_1_1_A : A ;
  omfluten_av_1_A : A ;
  omgift_av_1_A : A ;
  omkulldragen_av_1_A : A ;
  omkullfallen_av_1_A : A ;
  omotlaest_av_1_1_A : A ;
  omtyckt_av_1_A : A ;
  omaerkt_av_1_1_A : A ;
  ondsint_av_1_A : A ;
  onedblaast_av_1_1_A : A ;
  onedsaenkt_av_1_1_A : A ;
  onerblaast_av_1_1_A : A ;
  onersaenkt_av_1_1_A : A ;
  onaepst_av_1_1_A : A ;
  oomstoept_av_1_1_A : A ;
  oomsvept_av_1_A : A ;
  oppklippt_av_1_A : A ;
  oppknaeppt_av_1_1_A : A ;
  oppsutten_av_1_A : A ;
  oppvikt_av_1_A : A ;
  oppaakt_av_1_1_A : A ;
  opulent_av_1_A : A ;
  orest_av_1_A : A ;
  oraeckt_av_1_1_A : A ;
  oroekt_av_1_1_A : A ;
  oroent_av_1_1_A : A ;
  osammanloept_av_1_1_A : A ;
  osammantryckt_av_1_A : A ;
  osammanvaext_av_1_1_A : A ;
  oslaeckt_av_1_1_A : A ;
  osmaelt_av_1_1_A : A ;
  ostyrkt_av_1_A : A ;
  ostaerkt_av_1_1_A : A ;
  osoekt_av_1_1_A : A ;
  otryckt_av_1_A : A ;
  oupplyst_av_1_A : A ;
  oupptaeckt_av_1_1_A : A ;
  outvaext_av_1_1_A : A ;
  ooevertaenkt_av_1_1_A : A ;
  parant_av_1_A : A ;
  parat_av_1_A : A ;
  partiobunden_av_1_A : A ;
  perfekt_av_1_A : A ;
  permanent_av_1_A : A ;
  pikant_av_1_A : A ;
  plattnaest_av_1_1_A : A ;
  pluripotent_av_1_A : A ;
  potent_av_1_A : A ;
  pregnant_av_1_A : A ;
  present_av_1_A : A ;
  principfast_av_1_A : A ;
  privat_av_1_A : A ;
  probat_av_1_A : A ;
  prognat_av_1_A : A ;
  prominent_av_1_A : A ;
  paerlgraa_av_1_1_A : A ;
  paerlsvart_av_1_1_A : A ;
  paalaest_av_1_1_A : A ;
  paataenkt_av_1_1_A : A ;
  rabiat_av_1_A : A ;
  radiofrekvent_av_1_A : A ;
  raljant_av_1_A : A ;
  ramsvart_av_1_A : A ;
  recent_av_1_A : A ;
  redundant_av_1_A : A ;
  reformert_av_1_A : A ;
  regeringstrogen_av_1_A : A ;
  regngraa_av_1_1_A : A ;
  relevant_av_1_A : A ;
  remittent_av_1_A : A ;
  resistent_av_1_A : A ;
  resolut_av_1_A : A ;
  riksbekant_av_1_A : A ;
  robust_av_1_A : A ;
  rotfast_av_1_A : A ;
  rullstolsburen_av_1_A : A ;
  rundhyllt_av_1_A : A ;
  rundhaent_av_1_1_A : A ;
  roedblaa_av_1_1_A : A ;
  roednaest_av_1_1_A : A ;
  roekblaa_av_1_1_A : A ;
  roekgraa_av_1_1_A : A ;
  roekt_av_1_1_A : A ;
  sabelbent_av_1_A : A ;
  sakrosankt_av_1_A : A ;
  sakrosant_av_1_A : A ;
  salt_av_1_A : A ;
  saltstaenkt_av_1_1_A : A ;
  sammanbragt_av_1_A : A ;
  sammansvuren_av_1_A : A ;
  samspelt_av_1_A : A ;
  sankt_av_1_A : A ;
  schysst_av_1_A : A ;
  schyst_av_1_A : A ;
  segerkroent_av_1_1_A : A ;
  sekret_av_1_A : A ;
  separat_av_1_A : A ;
  sexdubbel_av_1_A : A ;
  sidlaent_av_1_1_A : A ;
  signifikant_av_1_A : A ;
  silvergraa_av_1_1_A : A ;
  sjudubbel_av_1_A : A ;
  sjyst_av_1_A : A ;
  sjaelvfoersjunken_av_1_1_A : A ;
  sjoedraenkt_av_1_1_A : A ;
  skarpsynt_av_1_A : A ;
  skiffergraa_av_1_1_A : A ;
  skaerpt_av_1_1_A : A ;
  slapphaent_av_1_1_A : A ;
  slavdriven_av_1_A : A ;
  slaepphaent_av_1_1_A : A ;
  sloesint_av_1_1_A : A ;
  smart_av_1_A : A ;
  smutsgraa_av_1_1_A : A ;
  smaert_av_1_1_A : A ;
  smaasint_av_1_1_A : A ;
  smaavaext_av_1_1_A : A ;
  snabbtaenkt_av_1_1_A : A ;
  snartaenkt_av_1_1_A : A ;
  snoetaeckt_av_1_1_A : A ;
  solbelyst_av_1_A : A ;
  solblekt_av_1_A : A ;
  solcellsdriven_av_1_A : A ;
  solkraftsdriven_av_1_A : A ;
  solstekt_av_1_A : A ;
  solvent_av_1_A : A ;
  sotsvart_av_1_A : A ;
  spaedvuxen_av_1_1_A : A ;
  spaarbunden_av_1_1_A : A ;
  stelbent_av_1_A : A ;
  stenbunden_av_1_A : A ;
  stentrist_av_1_A : A ;
  stolt_av_1_A : A ;
  stormfoertjust_av_1_1_A : A ;
  storsint_av_1_A : A ;
  storstilt_av_1_A : A ;
  storvaext_av_1_1_A : A ;
  strakbent_av_1_A : A ;
  strikt_av_1_A : A ;
  stringent_av_1_A : A ;
  styvsint_av_1_A : A ;
  staalblaa_av_1_1_A : A ;
  staalgraa_av_1_1_A : A ;
  suckulent_av_1_A : A ;
  suspekt_av_1_A : A ;
  svagsint_av_1_A : A ;
  svagsynt_av_1_A : A ;
  svart_av_1_A : A ;
  svaarlaest_av_1_1_A : A ;
  svaarloest_av_1_1_A : A ;
  svaarsmaelt_av_1_1_A : A ;
  svaarupptaeckt_av_1_1_A : A ;
  syrafast_av_1_A : A ;
  saellsynt_av_1_1_A : A ;
  soekt_av_1_1_A : A ;
  soenderskjuten_av_1_1_A : A ;
  soendersutten_av_1_1_A : A ;
  tajt_av_1_A : A ;
  taktfast_av_1_A : A ;
  terrormisstaenkt_av_1_1_A : A ;
  tight_av_1_A : A ;
  tillbakahaallen_av_1_1_A : A ;
  tillbakaslagen_av_1_A : A ;
  tillklippt_av_1_A : A ;
  tillknaeppt_av_1_1_A : A ;
  tillrest_av_1_A : A ;
  tilltaenkt_av_1_1_A : A ;
  tolerant_av_1_A : A ;
  tomhaent_av_1_1_A : A ;
  tortyrmisstaenkt_av_1_1_A : A ;
  transcendent_av_1_A : A ;
  transparent_av_1_A : A ;
  traselegant_av_1_A : A ;
  trebent_av_1_A : A ;
  trist_av_1_A : A ;
  trofast_av_1_A : A ;
  trosfast_av_1_A : A ;
  trubbnaest_av_1_1_A : A ;
  tryckluftsdriven_av_1_A : A ;
  tryckt_av_1_A : A ;
  traangsint_av_1_1_A : A ;
  traangsynt_av_1_1_A : A ;
  troeglaest_av_1_1_A : A ;
  troegtaenkt_av_1_1_A : A ;
  tunglaest_av_1_1_A : A ;
  tungsint_av_1_A : A ;
  turbulent_av_1_A : A ;
  turkosblaa_av_1_1_A : A ;
  tvaerbrant_av_1_1_A : A ;
  tvaersvart_av_1_1_A : A ;
  tvaabent_av_1_1_A : A ;
  tvaahaent_av_1_1_A : A ;
  tvaangsgift_av_1_1_A : A ;
  tvaangsintagen_av_1_1_A : A ;
  tyst_av_1_A : A ;
  taeckt_av_1_1_A : A ;
  taeppt_av_1_1_A : A ;
  taettklippt_av_1_1_A : A ;
  taardraenkt_av_1_1_A : A ;
  toernekroent_av_1_1_A : A ;
  ugnseldfast_av_1_A : A ;
  ugnsfast_av_1_A : A ;
  ultimat_av_1_A : A ;
  uppblaast_av_1_1_A : A ;
  uppbragt_av_1_A : A ;
  uppdriven_av_1_A : A ;
  uppklippt_av_1_A : A ;
  uppknaeppt_av_1_1_A : A ;
  upplyst_av_1_A : A ;
  uppnaest_av_1_1_A : A ;
  uppslagen_av_1_A : A ;
  uppspelt_av_1_A : A ;
  uppstraeckt_av_1_1_A : A ;
  uppsutten_av_1_A : A ;
  uppvikt_av_1_A : A ;
  uppaakt_av_1_1_A : A ;
  urblekt_av_1_A : A ;
  urblaast_av_1_1_A : A ;
  urgroept_av_1_1_A : A ;
  urkokt_av_1_A : A ;
  ursupen_av_1_A : A ;
  urtrist_av_1_A : A ;
  urvaext_av_1_1_A : A ;
  utfryst_av_1_A : A ;
  utmaerkt_av_1_1_A : A ;
  utskuren_av_1_A : A ;
  utstaanden_av_1_1_A : A ;
  utsoekt_av_1_1_A : A ;
  uttjaent_av_1_1_A : A ;
  uttaenkt_av_1_1_A : A ;
  vakant_av_1_A : A ;
  valhaent_av_1_1_A : A ;
  valnoetsgraa_av_1_1_A : A ;
  vanskapt_av_1_A : A ;
  vareviga_av_1_A : A ;
  varmbraeckt_av_1_1_A : A ;
  vassnaest_av_1_1_A : A ;
  vattblaa_av_1_1_A : A ;
  vattenblaa_av_1_1_A : A ;
  vattendriven_av_1_A : A ;
  vattenfast_av_1_A : A ;
  vattenomfluten_av_1_A : A ;
  vidstraeckt_av_1_1_A : A ;
  vidsynt_av_1_A : A ;
  vildsint_av_1_A : A ;
  vinddriven_av_2_A : A ;
  vinterblaa_av_1_1_A : A ;
  violblaa_av_1_1_A : A ;
  virulent_av_1_A : A ;
  vitblaa_av_1_1_A : A ;
  vitgraa_av_1_1_A : A ;
  vithyllt_av_1_A : A ;
  vittbekant_av_1_A : A ;
  vittberest_av_1_A : A ;
  vaeggfast_av_1_1_A : A ;
  vaelbekant_av_1_1_A : A ;
  vaelbesoekt_av_1_1_A : A ;
  vaelbetaenkt_av_1_1_A : A ;
  vaelfoertjaent_av_1_1_A : A ;
  vaelment_av_1_1_A : A ;
  vaelskapt_av_1_1_A : A ;
  vaelstekt_av_1_1_A : A ;
  vaelvaext_av_1_1_A : A ;
  vaenfast_av_1_1_A : A ;
  vaensterhaent_av_1_1_A : A ;
  vaerdefast_av_1_1_A : A ;
  vaerldsbekant_av_1_1_A : A ;
  vaerldsbaest_av_1_1_A : A ;
  vaetgasdriven_av_1_1_A : A ;
  vaaldtaektsmisstaenkt_av_1_1_A : A ;
  aangdriven_av_1_1_A : A ;
  aangerkoept_av_1_1_A : A ;
  aangestriden_av_1_1_A : A ;
  aarbraeckt_av_1_1_A : A ;
  aattadubbel_av_1_1_A : A ;
  oemsint_av_1_1_A : A ;
  oeverfoertjust_av_1_1_A : A ;
  oeversynt_av_1_1_A : A ;
  oevertaenkt_av_1_1_A : A ;
  EU_skeptisk_av_1_A : A ;
  Natoledd_av_1_A : A ;
  _95_oktanig_av_1_A : A ;
  abbotlig_av_1_A : A ;
  abbrevierbar_av_1_A : A ;
  abderitisk_av_1_A : A ;
  abdikerbar_av_1_A : A ;
  abessinsk_av_1_A : A ;
  abnorm_av_1_A : A ;
  abolitionistisk_av_1_A : A ;
  abominabel_av_1_A : A ;
  abonnerbar_av_1_A : A ;
  aborterbar_av_1_A : A ;
  abortiv_av_1_A : A ;
  abraderbar_av_1_A : A ;
  absolutistisk_av_1_A : A ;
  absolverbar_av_1_A : A ;
  absorberbar_av_1_A : A ;
  abstraherbar_av_1_A : A ;
  abstrus_av_1_A : A ;
  absurdistisk_av_1_A : A ;
  abyssal_av_1_A : A ;
  accederbar_av_1_A : A ;
  accelererbar_av_1_A : A ;
  accentuerbar_av_1_A : A ;
  acceptabel_av_1_A : A ;
  accepterbar_av_1_A : A ;
  accessorisk_av_1_A : A ;
  accidentell_av_1_A : A ;
  accisfri_av_1_A : A ;
  acklimatiserbar_av_1_A : A ;
  ackommoderbar_av_1_A : A ;
  ackompanjerbar_av_1_A : A ;
  ackorderbar_av_1_A : A ;
  ackrediterbar_av_1_A : A ;
  ackumulerbar_av_1_A : A ;
  ackusativ_av_1_A : A ;
  ackusatorisk_av_1_A : A ;
  ackvirerbar_av_1_A : A ;
  adapterbar_av_1_A : A ;
  adaptiv_av_1_A : A ;
  adderbar_av_1_A : A ;
  additiv_av_1_A : A ;
  adhesiv_av_1_A : A ;
  adiabatisk_av_1_A : A ;
  adiaforistisk_av_1_A : A ;
  adjektivisk_av_1_A : A ;
  adjektivistisk_av_1_A : A ;
  adjungerbar_av_1_A : A ;
  adlig_av_1_A : A ;
  administrativ_av_1_A : A ;
  administrerbar_av_1_A : A ;
  adopterbar_av_1_A : A ;
  adoptiv_av_1_A : A ;
  adresserbar_av_1_A : A ;
  adsorberbar_av_1_A : A ;
  aducerbar_av_1_A : A ;
  adventistisk_av_1_A : A ;
  adventiv_av_1_A : A ;
  adverbiell_av_1_A : A ;
  adversativ_av_1_A : A ;
  advocerbar_av_1_A : A ;
  advokatorisk_av_1_A : A ;
  aerob_av_1_A : A ;
  aerobisk_av_1_A : A ;
  aerodynamisk_av_1_A : A ;
  afasisk_av_1_A : A ;
  afatisk_av_1_A : A ;
  affektfri_av_1_A : A ;
  affektiv_av_1_A : A ;
  afficierbar_av_1_A : A ;
  affin_av_1_A : A ;
  affinerbar_av_1_A : A ;
  affirmativ_av_1_A : A ;
  affischerbar_av_1_A : A ;
  affischmaessig_av_1_1_A : A ;
  affaersmannamaessig_av_1_1_A : A ;
  affaersmaessig_av_1_1_A : A ;
  afghansk_av_1_A : A ;
  aforistisk_av_1_A : A ;
  afrikaniserbar_av_1_A : A ;
  afrikansk_av_1_A : A ;
  afro_asiatisk_av_1_A : A ;
  afroasiatisk_av_1_A : A ;
  agerbar_av_1_A : A ;
  aggfri_av_1_A : A ;
  agglomererbar_av_1_A : A ;
  agglutinerbar_av_1_A : A ;
  aggressiv_av_1_A : A ;
  agitatorisk_av_1_A : A ;
  agiterbar_av_1_A : A ;
  agnatisk_av_1_A : A ;
  agnblommig_av_1_A : A ;
  agnostisk_av_1_A : A ;
  agonistisk_av_1_A : A ;
  agrar_av_1_A : A ;
  agrarkommunistisk_av_1_A : A ;
  agreabel_av_1_A : A ;
  agrikulturell_av_1_A : A ;
  agronomisk_av_1_A : A ;
  aidssjuk_av_1_A : A ;
  ajournerbar_av_1_A : A ;
  akademisk_av_1_A : A ;
  akatalektisk_av_1_A : A ;
  akrobatisk_av_1_A : A ;
  akromatisk_av_1_A : A ;
  akterlig_av_1_A : A ;
  aktionistisk_av_1_A : A ;
  aktiv_av_1_A : A ;
  aktiverbar_av_1_A : A ;
  aktivistisk_av_1_A : A ;
  aktningsfull_av_1_A : A ;
  aktualiserbar_av_1_A : A ;
  aktualistisk_av_1_A : A ;
  aktuell_av_1_A : A ;
  akustisk_av_1_A : A ;
  akvaristisk_av_1_A : A ;
  akvatisk_av_1_A : A ;
  alarmerbar_av_1_A : A ;
  alarmistisk_av_1_A : A ;
  albansk_av_1_A : A ;
  albinistisk_av_1_A : A ;
  alexandrinsk_av_1_A : A ;
  alfabetiserbar_av_1_A : A ;
  alfabetisk_av_1_A : A ;
  alfanumerisk_av_1_A : A ;
  algebraisk_av_1_A : A ;
  algerisk_av_1_A : A ;
  alibistisk_av_1_A : A ;
  alienerbar_av_1_A : A ;
  alifatisk_av_1_A : A ;
  alimentaer_av_1_1_A : A ;
  alkaisk_av_1_A : A ;
  alkalisk_av_1_A : A ;
  alkemisk_av_1_A : A ;
  alkemistisk_av_1_A : A ;
  alkoholhaltig_av_1_A : A ;
  alkoholisk_av_1_A : A ;
  alkoholistisk_av_1_A : A ;
  alkoholpolitisk_av_1_A : A ;
  alkoholsvag_av_1_A : A ;
  alldaglig_av_1_A : A ;
  allegoriserbar_av_1_A : A ;
  allegorisk_av_1_A : A ;
  allergisk_av_1_A : A ;
  allierbar_av_1_A : A ;
  allittererbar_av_1_A : A ;
  allmaenfarlig_av_1_1_A : A ;
  allmaengiltig_av_1_1_A : A ;
  allmaenhumanistisk_av_1_1_A : A ;
  allmaenmodernistisk_av_1_1_A : A ;
  allmaenmaensklig_av_1_1_A : A ;
  allmaennelig_av_1_1_A : A ;
  allmaennyttig_av_1_1_A : A ;
  allmaenpolitisk_av_1_1_A : A ;
  allmaenpreventiv_av_1_1_A : A ;
  allnationell_av_1_A : A ;
  allodial_av_1_A : A ;
  allokerbar_av_1_A : A ;
  allokton_av_1_A : A ;
  allomorf_av_1_A : A ;
  allsidig_av_1_A : A ;
  allsmaektig_av_1_1_A : A ;
  allsvensk_av_1_A : A ;
  allsvaaldig_av_1_1_A : A ;
  alluderbar_av_1_A : A ;
  alluvial_av_1_A : A ;
  allvarlig_av_1_A : A ;
  allvis_av_1_A : A ;
  alpin_av_1_A : A ;
  alpinsk_av_1_A : A ;
  alternativ_av_1_A : A ;
  alternerbar_av_1_A : A ;
  altruistisk_av_1_A : A ;
  aluminerbar_av_1_A : A ;
  alveolar_av_1_A : A ;
  amalgamerbar_av_1_A : A ;
  amatoeristisk_av_1_1_A : A ;
  amatoermaessig_av_1_1_A : A ;
  ambassadoersmaessig_av_1_1_A : A ;
  ambidexter_av_1_A : A ;
  ambitioes_av_1_1_A : A ;
  ambrosisk_av_1_A : A ;
  ambulatorisk_av_1_A : A ;
  ambulerbar_av_1_A : A ;
  amerikaniserbar_av_1_A : A ;
  amerikansk_av_1_A : A ;
  amfibisk_av_1_A : A ;
  amfiteatralisk_av_1_A : A ;
  amoralisk_av_1_A : A ;
  amorf_av_1_A : A ;
  amorterbar_av_1_A : A ;
  amoroes_av_1_1_A : A ;
  ampel_av_1_A : A ;
  amper_av_1_A : A ;
  amplifierbar_av_1_A : A ;
  amplitudmodulerbar_av_1_A : A ;
  amputerbar_av_1_A : A ;
  anabaptistisk_av_1_A : A ;
  anabatisk_av_1_A : A ;
  anabol_av_1_A : A ;
  anadrom_av_1_A : A ;
  anaerob_av_1_A : A ;
  anaforisk_av_1_A : A ;
  anakreontisk_av_1_A : A ;
  anakronistisk_av_1_A : A ;
  anal_av_1_A : A ;
  analfabetisk_av_1_A : A ;
  analog_av_1_A : A ;
  analogisk_av_1_A : A ;
  analyserbar_av_1_A : A ;
  analytisk_av_1_A : A ;
  anarkisk_av_1_A : A ;
  anarkistisk_av_1_A : A ;
  anarkokapitalistisk_av_1_A : A ;
  anarkokommunistisk_av_1_A : A ;
  anarkoprimitivistisk_av_1_A : A ;
  anarkosyndikalistisk_av_1_A : A ;
  anastatisk_av_1_A : A ;
  anastigmatisk_av_1_A : A ;
  anatomisk_av_1_A : A ;
  andaktsfull_av_1_A : A ;
  andefattig_av_1_A : A ;
  andeloes_av_1_1_A : A ;
  andfaadd_av_1_1_A : A ;
  andlig_av_1_A : A ;
  andloes_av_1_1_A : A ;
  andorransk_av_1_A : A ;
  androgyn_av_1_A : A ;
  andryg_av_1_A : A ;
  andaektig_av_1_1_A : A ;
  anekdotisk_av_1_A : A ;
  anemisk_av_1_A : A ;
  anestetisk_av_1_A : A ;
  anfallsmaessig_av_1_1_A : A ;
  angelsachsisk_av_1_A : A ;
  angelsaxisk_av_1_A : A ;
  angenaem_av_1_1_A : A ;
  anglicistisk_av_1_A : A ;
  anglikansk_av_1_A : A ;
  angliserbar_av_1_A : A ;
  anglosachsisk_av_1_A : A ;
  anglosaxisk_av_1_A : A ;
  angolansk_av_1_A : A ;
  anhaengig_av_1_1_A : A ;
  anhoerig_av_1_1_A : A ;
  animal_av_1_A : A ;
  animalisk_av_1_A : A ;
  animerbar_av_1_A : A ;
  animistisk_av_1_A : A ;
  aningsfull_av_1_A : A ;
  aningsloes_av_1_1_A : A ;
  ankellaang_av_1_1_A : A ;
  ankistisk_av_1_A : A ;
  anmaelningspliktig_av_1_1_A : A ;
  anmaelningsskyldig_av_1_1_A : A ;
  annekterbar_av_1_A : A ;
  annihilerbar_av_1_A : A ;
  annonserbar_av_1_A : A ;
  annoterbar_av_1_A : A ;
  annuell_av_1_A : A ;
  annullerbar_av_1_A : A ;
  anodiserbar_av_1_A : A ;
  anomal_av_1_A : A ;
  anomalisk_av_1_A : A ;
  anomalistisk_av_1_A : A ;
  anonym_av_1_A : A ;
  anonymiserbar_av_1_A : A ;
  anorektisk_av_1_A : A ;
  anormal_av_1_A : A ;
  anpassbar_av_1_A : A ;
  anpasslig_av_1_A : A ;
  anrik_av_1_A : A ;
  ansedd_av_1_A : A ;
  ansenlig_av_1_A : A ;
  anskraemlig_av_1_1_A : A ;
  anslagsmaessig_av_1_1_A : A ;
  anspraakloes_av_1_1_A : A ;
  anspraaksfull_av_1_1_A : A ;
  anspraaksloes_av_1_1_A : A ;
  anstaendig_av_1_1_A : A ;
  anstoetlig_av_1_1_A : A ;
  ansvarig_av_1_A : A ;
  ansvarsfri_av_1_A : A ;
  ansvarsfull_av_1_A : A ;
  ansvarsloes_av_1_1_A : A ;
  antaglig_av_1_A : A ;
  antagonistisk_av_1_A : A ;
  antalsmaessig_av_1_1_A : A ;
  antarktisk_av_1_A : A ;
  antecipativ_av_1_A : A ;
  anteciperbar_av_1_A : A ;
  antedaterbar_av_1_A : A ;
  antediluviansk_av_1_A : A ;
  antibiotisk_av_1_A : A ;
  antichambrerbar_av_1_A : A ;
  antidemokratisk_av_1_A : A ;
  antidepressiv_av_1_A : A ;
  antielitistisk_av_1_A : A ;
  antiexpressionistisk_av_1_A : A ;
  antifundamentalistisk_av_1_A : A ;
  antiguansk_av_1_A : A ;
  antihumanistisk_av_1_A : A ;
  antiidealistisk_av_1_A : A ;
  antiimperialistisk_av_1_A : A ;
  antiindividualistisk_av_1_A : A ;
  antiintellektualistisk_av_1_A : A ;
  antiintellektuell_av_1_A : A ;
  antiislamistisk_av_1_A : A ;
  antik_av_1_A : A ;
  antikiserbar_av_1_A : A ;
  antiklerikal_av_1_A : A ;
  antikommunistisk_av_1_A : A ;
  antikonceptionell_av_1_A : A ;
  antikristlig_av_1_A : A ;
  antikvarisk_av_1_A : A ;
  antimilitaristisk_av_1_A : A ;
  antipatisk_av_1_A : A ;
  antipolitisk_av_1_A : A ;
  antireligioes_av_1_1_A : A ;
  antirojalistisk_av_1_A : A ;
  antisemitisk_av_1_A : A ;
  antiseptisk_av_1_A : A ;
  antisionistisk_av_1_A : A ;
  antistatisk_av_1_A : A ;
  antitetisk_av_1_A : A ;
  antonym_av_1_A : A ;
  antropisk_av_1_A : A ;
  antropocentrisk_av_1_A : A ;
  antropologisk_av_1_A : A ;
  antropomorf_av_1_A : A ;
  antropomorfisk_av_1_A : A ;
  antropomorfistisk_av_1_A : A ;
  antroposofisk_av_1_A : A ;
  antraeffbar_av_1_1_A : A ;
  anvaendarvaenlig_av_1_1_A : A ;
  anvaendbar_av_1_1_A : A ;
  apatisk_av_1_A : A ;
  aplik_av_1_A : A ;
  apodiktisk_av_1_A : A ;
  apokalyptisk_av_1_A : A ;
  apokryfisk_av_1_A : A ;
  apolitisk_av_1_A : A ;
  apollinisk_av_1_A : A ;
  apollinsk_av_1_A : A ;
  apologetisk_av_1_A : A ;
  apoplektisk_av_1_A : A ;
  aposteriorisk_av_1_A : A ;
  apostolisk_av_1_A : A ;
  apostroferbar_av_1_A : A ;
  appellerbar_av_1_A : A ;
  applicerbar_av_1_A : A ;
  applikatorisk_av_1_A : A ;
  applaaderbar_av_1_1_A : A ;
  apporterbar_av_1_A : A ;
  apprecierbar_av_1_A : A ;
  appreterbar_av_1_A : A ;
  approbabel_av_1_A : A ;
  approcherbar_av_1_A : A ;
  approximativ_av_1_A : A ;
  approximerbar_av_1_A : A ;
  aprak_av_1_A : A ;
  apriorisk_av_1_A : A ;
  apterbar_av_1_A : A ;
  aptitlig_av_1_A : A ;
  arabisk_av_1_A : A ;
  arbetsduglig_av_1_A : A ;
  arbetsfoer_av_1_1_A : A ;
  arbetsintensiv_av_1_A : A ;
  arbetsloes_av_1_1_A : A ;
  arbetsmarknadsmaessig_av_1_1_A : A ;
  arbetsmarknadspolitisk_av_1_A : A ;
  arbetsmiljoemaessig_av_1_1_A : A ;
  arbetsmaessig_av_1_1_A : A ;
  arbetsraettslig_av_1_1_A : A ;
  arbetsskygg_av_1_A : A ;
  arbetsvillig_av_1_A : A ;
  arbitraer_av_1_1_A : A ;
  arealmaessig_av_1_1_A : A ;
  arg_av_1_A : A ;
  argentinsk_av_1_A : A ;
  argumentativ_av_1_A : A ;
  argumenterbar_av_1_A : A ;
  argumentrik_av_1_A : A ;
  ariansk_av_1_A : A ;
  arisk_av_1_A : A ;
  aristokratisk_av_1_A : A ;
  aritmetisk_av_1_A : A ;
  arkadisk_av_1_A : A ;
  arkaiserbar_av_1_A : A ;
  arkaisk_av_1_A : A ;
  arkaistisk_av_1_A : A ;
  arkebuserbar_av_1_A : A ;
  arkeologisk_av_1_A : A ;
  arketypisk_av_1_A : A ;
  arkitektonisk_av_1_A : A ;
  arkitekturpolitisk_av_1_A : A ;
  arkivalisk_av_1_A : A ;
  arkiverbar_av_1_A : A ;
  arktisk_av_1_A : A ;
  arm_av_1_A : A ;
  armenisk_av_1_A : A ;
  armerbar_av_1_A : A ;
  aromatisk_av_1_A : A ;
  arrangemangsmaessig_av_1_1_A : A ;
  arrangerbar_av_1_A : A ;
  arrangoersmaessig_av_1_1_A : A ;
  arrenderbar_av_1_A : A ;
  arresterbar_av_1_A : A ;
  arronderbar_av_1_A : A ;
  arsenikfri_av_1_A : A ;
  arsenikhaltig_av_1_A : A ;
  arteriell_av_1_A : A ;
  artesisk_av_1_A : A ;
  artificiell_av_1_A : A ;
  artig_av_1_A : A ;
  artikulerbar_av_1_A : A ;
  artistisk_av_1_A : A ;
  artonaarig_av_1_1_A : A ;
  artrik_av_1_A : A ;
  arvloes_av_1_1_A : A ;
  arvoderbar_av_1_A : A ;
  arvsmaessig_av_1_1_A : A ;
  asenkel_av_1_A : A ;
  aseptisk_av_1_A : A ;
  asexuell_av_1_A : A ;
  asfalterbar_av_1_A : A ;
  asfull_av_1_A : A ;
  asiatisk_av_1_A : A ;
  asketisk_av_1_A : A ;
  asocial_av_1_A : A ;
  aspirerbar_av_1_A : A ;
  assignerbar_av_1_A : A ;
  assimilerbar_av_1_A : A ;
  assisterbar_av_1_A : A ;
  associationsrik_av_1_A : A ;
  associativ_av_1_A : A ;
  associerbar_av_1_A : A ;
  assurerbar_av_1_A : A ;
  assyrisk_av_1_A : A ;
  astenisk_av_1_A : A ;
  astigmatisk_av_1_A : A ;
  astmatisk_av_1_A : A ;
  astral_av_1_A : A ;
  astrologisk_av_1_A : A ;
  astronomisk_av_1_A : A ;
  asymmetrisk_av_1_A : A ;
  asyndetisk_av_1_A : A ;
  asynkron_av_1_A : A ;
  ataktisk_av_1_A : A ;
  atavistisk_av_1_A : A ;
  ateistisk_av_1_A : A ;
  atlantisk_av_1_A : A ;
  atletisk_av_1_A : A ;
  atmosfaerisk_av_1_1_A : A ;
  atomistisk_av_1_A : A ;
  atomaer_av_1_1_A : A ;
  atonal_av_1_A : A ;
  atrofierbar_av_1_A : A ;
  atrofisk_av_1_A : A ;
  attackerbar_av_1_A : A ;
  attesterbar_av_1_A : A ;
  attisk_av_1_A : A ;
  attitydmaessig_av_1_1_A : A ;
  attraherbar_av_1_A : A ;
  attraktiv_av_1_A : A ;
  attrapperbar_av_1_A : A ;
  attribuerbar_av_1_A : A ;
  attributiv_av_1_A : A ;
  atypisk_av_1_A : A ;
  audiovisuell_av_1_A : A ;
  auditiv_av_1_A : A ;
  audivisuell_av_1_A : A ;
  auktionerbar_av_1_A : A ;
  auktoriserbar_av_1_A : A ;
  auktoritativ_av_1_A : A ;
  auktoritaer_av_1_1_A : A ;
  auskulterbar_av_1_A : A ;
  australiensisk_av_1_A : A ;
  australisk_av_1_A : A ;
  autenticerbar_av_1_A : A ;
  autentifierbar_av_1_A : A ;
  autentiserbar_av_1_A : A ;
  autentisk_av_1_A : A ;
  autistisk_av_1_A : A ;
  autokton_av_1_A : A ;
  automagisk_av_1_A : A ;
  automatiserbar_av_1_A : A ;
  automatisk_av_1_A : A ;
  autonom_av_1_A : A ;
  avancerbar_av_1_A : A ;
  avannonserbar_av_1_A : A ;
  avantgardistisk_av_1_A : A ;
  avdragsgill_av_1_A : A ;
  avdragsglad_av_1_A : A ;
  avdramatiserbar_av_1_A : A ;
  avdoed_av_1_1_A : A ;
  avfaellig_av_1_1_A : A ;
  avgrundsdjup_av_1_A : A ;
  avhaengig_av_1_1_A : A ;
  aviatisk_av_1_A : A ;
  avig_av_1_A : A ;
  aviserbar_av_1_A : A ;
  avkoloniserbar_av_1_A : A ;
  avkriminaliserbar_av_1_A : A ;
  avlaesbar_av_1_1_A : A ;
  avlaang_av_1_1_A : A ;
  avmagnetiserbar_av_1_A : A ;
  avmystifierbar_av_1_A : A ;
  avmaett_av_1_1_A : A ;
  avnazifierbar_av_1_A : A ;
  avog_av_1_A : A ;
  avpatrullerbar_av_1_A : A ;
  avpolitiserbar_av_1_A : A ;
  avpolletterbar_av_1_A : A ;
  avportraetterbar_av_1_1_A : A ;
  avreagerbar_av_1_A : A ;
  avregistrerbar_av_1_A : A ;
  avreglerbar_av_1_A : A ;
  avromantiserbar_av_1_A : A ;
  avsiktlig_av_1_A : A ;
  avsiktsloes_av_1_1_A : A ;
  avsocialiserbar_av_1_A : A ;
  avstaliniserbar_av_1_A : A ;
  avsaettlig_av_1_1_A : A ;
  avtagbar_av_1_A : A ;
  avtalsenlig_av_1_A : A ;
  avtalsmaessig_av_1_1_A : A ;
  avtalsstridig_av_1_A : A ;
  avundsfri_av_1_A : A ;
  avundsfull_av_1_A : A ;
  avundsjuk_av_1_A : A ;
  avytterlig_av_1_A : A ;
  axblommig_av_1_A : A ;
  axelbred_av_1_A : A ;
  axellaang_av_1_1_A : A ;
  axial_av_1_A : A ;
  axiomatiserbar_av_1_A : A ;
  axiomatisk_av_1_A : A ;
  azerbajdzjansk_av_1_A : A ;
  aztekisk_av_1_A : A ;
  babylonisk_av_1_A : A ;
  bacillfri_av_1_A : A ;
  backig_av_1_A : A ;
  badensisk_av_1_A : A ;
  bagatelliserbar_av_1_A : A ;
  bahamansk_av_1_A : A ;
  bahrainsk_av_1_A : A ;
  bajersk_av_1_A : A ;
  bajonettfoersedd_av_1_1_A : A ;
  bajsbrun_av_1_A : A ;
  bajsig_av_1_A : A ;
  bajsnoedig_av_1_1_A : A ;
  bakfull_av_1_A : A ;
  bakhal_av_1_A : A ;
  bakslug_av_1_A : A ;
  bakteriefri_av_1_A : A ;
  bakteriologisk_av_1_A : A ;
  baktung_av_1_A : A ;
  balanserbar_av_1_A : A ;
  ball_av_1_A : A ;
  balloterbar_av_1_A : A ;
  balsamerbar_av_1_A : A ;
  balsamisk_av_1_A : A ;
  baltisk_av_1_A : A ;
  banal_av_1_A : A ;
  banaliserbar_av_1_A : A ;
  bang_av_1_A : A ;
  bangladeshisk_av_1_A : A ;
  bankmaessig_av_1_1_A : A ;
  bankrutt_av_1_A : A ;
  bankrutterbar_av_1_A : A ;
  bankruttmaessig_av_1_1_A : A ;
  baptistisk_av_1_A : A ;
  bar_av_1_A : A ;
  barbadisk_av_1_A : A ;
  barbarisk_av_1_A : A ;
  barmhaertig_av_1_1_A : A ;
  barnfoedd_av_1_1_A : A ;
  barnkaer_av_1_1_A : A ;
  barnledig_av_1_A : A ;
  barnloes_av_1_1_A : A ;
  barnslig_av_1_A : A ;
  barnsaeker_av_1_1_A : A ;
  barock_av_1_A : A ;
  barockmaessig_av_1_1_A : A ;
  barometrisk_av_1_A : A ;
  barrikaderbar_av_1_A : A ;
  barsk_av_1_A : A ;
  basal_av_1_A : A ;
  baserbar_av_1_A : A ;
  basisk_av_1_A : A ;
  baskisk_av_1_A : A ;
  beatifierbar_av_1_A : A ;
  bebodd_av_1_A : A ;
  beboelig_av_1_A : A ;
  bebolig_av_1_A : A ;
  beckig_av_1_A : A ;
  beckmoerk_av_1_1_A : A ;
  bedraeglig_av_1_1_A : A ;
  bedroevlig_av_1_1_A : A ;
  befattningsmaessig_av_1_1_A : A ;
  befintlig_av_1_A : A ;
  befolkningsmaessig_av_1_1_A : A ;
  befolkningspolitisk_av_1_A : A ;
  begreppsanalytisk_av_1_A : A ;
  begreppslig_av_1_A : A ;
  begreppsmaessig_av_1_1_A : A ;
  begriplig_av_1_A : A ;
  begaerlig_av_1_1_A : A ;
  begaavningsmaessig_av_1_1_A : A ;
  behagfull_av_1_A : A ;
  behaglig_av_1_A : A ;
  behagsjuk_av_1_A : A ;
  behandlingsbar_av_1_A : A ;
  behandlingsmaessig_av_1_1_A : A ;
  behavioristisk_av_1_A : A ;
  behjaelplig_av_1_1_A : A ;
  behovloes_av_1_1_A : A ;
  behaendig_av_1_1_A : A ;
  behoerig_av_1_1_A : A ;
  behoevlig_av_1_1_A : A ;
  beklaglig_av_1_A : A ;
  bekvaem_av_1_1_A : A ;
  bekymmersfull_av_1_A : A ;
  bekymmersloes_av_1_1_A : A ;
  belgisk_av_1_A : A ;
  belizisk_av_1_A : A ;
  belletristisk_av_1_A : A ;
  benefik_av_1_A : A ;
  bengalisk_av_1_A : A ;
  benig_av_1_A : A ;
  benign_av_1_A : A ;
  beninsk_av_1_A : A ;
  bensinsnaal_av_1_1_A : A ;
  benskoer_av_1_1_A : A ;
  benvit_av_1_A : A ;
  beredd_av_1_A : A ;
  beredskapsmaessig_av_1_1_A : A ;
  beredvillig_av_1_A : A ;
  bergfin_av_1_A : A ;
  bergig_av_1_A : A ;
  bergsaeker_av_1_1_A : A ;
  beryllgroen_av_1_1_A : A ;
  beraeknelig_av_1_1_A : A ;
  beraekningsmaessig_av_1_1_A : A ;
  beraettarmaessig_av_1_1_A : A ;
  beroemlig_av_1_1_A : A ;
  besatt_av_1_A : A ;
  besinningsfull_av_1_A : A ;
  besinningsloes_av_1_1_A : A ;
  besk_av_1_A : A ;
  beskattningsbar_av_1_A : A ;
  beskedlig_av_1_A : A ;
  beskrivbar_av_1_A : A ;
  beskaeftig_av_1_1_A : A ;
  beslutenlig_av_1_A : A ;
  beslutfoer_av_1_1_A : A ;
  beslutmaessig_av_1_1_A : A ;
  beslutsenlig_av_1_A : A ;
  beslutsfoer_av_1_1_A : A ;
  beslutskapabel_av_1_A : A ;
  beslutsmaessig_av_1_1_A : A ;
  bestialisk_av_1_A : A ;
  besticklig_av_1_A : A ;
  bestaembar_av_1_1_A : A ;
  bestaendig_av_1_1_A : A ;
  bestaandsmaessig_av_1_1_A : A ;
  besvaerlig_av_1_1_A : A ;
  besynnerlig_av_1_A : A ;
  betalbar_av_1_A : A ;
  betalningsgill_av_1_A : A ;
  betalningsskyldig_av_1_A : A ;
  beteendemaessig_av_1_1_A : A ;
  betongerbar_av_1_A : A ;
  betrodd_av_1_A : A ;
  betydelsefattig_av_1_A : A ;
  betydelsefull_av_1_A : A ;
  betydelseloes_av_1_1_A : A ;
  betydelsemaessig_av_1_1_A : A ;
  betydlig_av_1_A : A ;
  betaenklig_av_1_1_A : A ;
  bevisbar_av_1_A : A ;
  beviskraftig_av_1_A : A ;
  bevislig_av_1_A : A ;
  bevismaessig_av_1_1_A : A ;
  bevisskyldig_av_1_A : A ;
  bhutanesisk_av_1_A : A ;
  bibelkunnig_av_1_A : A ;
  biblicistisk_av_1_A : A ;
  bibliografisk_av_1_A : A ;
  biblisk_av_1_A : A ;
  biffig_av_1_A : A ;
  bifilar_av_1_A : A ;
  bifilaer_av_1_1_A : A ;
  bigott_av_1_A : A ;
  bikonkav_av_1_A : A ;
  bikonvex_av_1_A : A ;
  bikvadratisk_av_1_A : A ;
  bilabial_av_1_A : A ;
  bilateral_av_1_A : A ;
  bildbar_av_1_A : A ;
  bildlig_av_1_A : A ;
  bildlik_av_1_A : A ;
  bildmaessig_av_1_1_A : A ;
  bildningsmaessig_av_1_1_A : A ;
  bildrik_av_1_A : A ;
  bildskoen_av_1_1_A : A ;
  bilingual_av_1_A : A ;
  bilistisk_av_1_A : A ;
  billig_av_1_A : A ;
  bilsjuk_av_1_A : A ;
  biltog_av_1_A : A ;
  binokulaer_av_1_1_A : A ;
  binaer_av_1_1_A : A ;
  biodynamisk_av_1_A : A ;
  biofysisk_av_1_A : A ;
  biogenetisk_av_1_A : A ;
  biograferbar_av_1_A : A ;
  biografisk_av_1_A : A ;
  biografmaessig_av_1_1_A : A ;
  biokemisk_av_1_A : A ;
  biologisk_av_1_A : A ;
  bioteknisk_av_1_A : A ;
  biotisk_av_1_A : A ;
  bipolaer_av_1_1_A : A ;
  bisarr_av_1_A : A ;
  bisexuell_av_1_A : A ;
  biskoplig_av_1_A : A ;
  bissauguineansk_av_1_A : A ;
  bisserbar_av_1_A : A ;
  bister_av_1_A : A ;
  bistaandspolitisk_av_1_1_A : A ;
  bitsk_av_1_A : A ;
  bitter_av_1_A : A ;
  bitterkall_av_1_A : A ;
  bitterljuv_av_1_A : A ;
  bittersoet_av_1_1_A : A ;
  bituminoes_av_1_1_A : A ;
  bivackerbar_av_1_A : A ;
  bjaebbig_av_1_1_A : A ;
  bjaertgroen_av_1_1_A : A ;
  black_av_1_A : A ;
  blackig_av_1_A : A ;
  bladig_av_1_A : A ;
  blancherbar_av_1_A : A ;
  blank_av_1_A : A ;
  blankpolerbar_av_1_A : A ;
  blasfemisk_av_1_A : A ;
  blaskig_av_1_A : A ;
  blazerklaedd_av_1_1_A : A ;
  blek_av_1_A : A ;
  blekfet_av_1_A : A ;
  blekgul_av_1_A : A ;
  blekingsk_av_1_A : A ;
  blekroed_av_1_1_A : A ;
  bleksiktig_av_1_A : A ;
  blesserbar_av_1_A : A ;
  blid_av_1_A : A ;
  blinderbar_av_1_A : A ;
  blixtfotograferbar_av_1_A : A ;
  blixtsnabb_av_1_A : A ;
  blockerbar_av_1_A : A ;
  blockig_av_1_A : A ;
  blockpolitisk_av_1_A : A ;
  blodfattig_av_1_A : A ;
  blodfull_av_1_A : A ;
  blodig_av_1_A : A ;
  blodloes_av_1_1_A : A ;
  blodroed_av_1_1_A : A ;
  blodtoerstig_av_1_1_A : A ;
  blomklaedd_av_1_1_A : A ;
  blommig_av_1_A : A ;
  blommograferbar_av_1_A : A ;
  blomsterklaedd_av_1_1_A : A ;
  blonderbar_av_1_A : A ;
  blott_av_1_A : A ;
  blyg_av_1_A : A ;
  blyhaltig_av_1_A : A ;
  blytung_av_1_A : A ;
  blaendvit_av_1_1_A : A ;
  blaaaktig_av_1_1_A : A ;
  blaablodig_av_1_1_A : A ;
  blaagroen_av_1_1_A : A ;
  blaagul_av_1_1_A : A ;
  blaakopierbar_av_1_1_A : A ;
  blaaprickig_av_1_1_A : A ;
  blaarandig_av_1_1_A : A ;
  blaarutig_av_1_1_A : A ;
  blaaroed_av_1_1_A : A ;
  blaasig_av_1_1_A : A ;
  blaasur_av_1_1_A : A ;
  blaavarm_av_1_1_A : A ;
  blaaviolett_av_1_1_A : A ;
  blaavit_av_1_1_A : A ;
  bloedig_av_1_1_A : A ;
  bloet_av_1_1_A : A ;
  boaserbar_av_1_A : A ;
  bofaellig_av_1_1_A : A ;
  bogserbar_av_1_A : A ;
  bohemisk_av_1_A : A ;
  bohuslaensk_av_1_1_A : A ;
  bokfoeringsmaessig_av_1_1_A : A ;
  bokfoeringsskyldig_av_1_1_A : A ;
  boklig_av_1_A : A ;
  bokstaverbar_av_1_A : A ;
  bokstavlig_av_1_A : A ;
  boliviansk_av_1_A : A ;
  bolsjevikisk_av_1_A : A ;
  bolsjevistisk_av_1_A : A ;
  bombarderbar_av_1_A : A ;
  bombastisk_av_1_A : A ;
  bombfri_av_1_A : A ;
  bombsaeker_av_1_1_A : A ;
  bonddryg_av_1_A : A ;
  bondsk_av_1_A : A ;
  bondslug_av_1_A : A ;
  boniterbar_av_1_A : A ;
  boreal_av_1_A : A ;
  borgerlig_av_1_A : A ;
  borstig_av_1_A : A ;
  borstloes_av_1_1_A : A ;
  bortresonerbar_av_1_A : A ;
  bosatt_av_1_A : A ;
  bosnienserbisk_av_1_A : A ;
  bosnisk_av_1_A : A ;
  bossig_av_1_A : A ;
  bostadsloes_av_1_1_A : A ;
  bostadsmaessig_av_1_1_A : A ;
  bostadspolitisk_av_1_A : A ;
  botanisk_av_1_A : A ;
  botfaerdig_av_1_1_A : A ;
  botlig_av_1_A : A ;
  botswansk_av_1_A : A ;
  bottendaalig_av_1_1_A : A ;
  bottenhederlig_av_1_A : A ;
  bottenloes_av_1_1_A : A ;
  bottnisk_av_1_A : A ;
  bovaktig_av_1_A : A ;
  brackig_av_1_A : A ;
  bragdmaessig_av_1_1_A : A ;
  brakycefal_av_1_A : A ;
  bramansk_av_1_A : A ;
  brandfarlig_av_1_A : A ;
  brandfri_av_1_A : A ;
  brandgul_av_1_A : A ;
  brandhaerdig_av_1_1_A : A ;
  brandsaeker_av_1_1_A : A ;
  branschmaessig_av_1_1_A : A ;
  brasiliansk_av_1_A : A ;
  bred_av_1_A : A ;
  bredbar_av_1_A : A ;
  bredbladig_av_1_A : A ;
  bredbraettig_av_1_1_A : A ;
  breddmaessig_av_1_1_A : A ;
  bredrandig_av_1_A : A ;
  bredskyggig_av_1_A : A ;
  bredspaarig_av_1_1_A : A ;
  bretagnisk_av_1_A : A ;
  bretonsk_av_1_A : A ;
  briketterbar_av_1_A : A ;
  briserbar_av_1_A : A ;
  bristfaellig_av_1_1_A : A ;
  britannisk_av_1_A : A ;
  brittisk_av_1_A : A ;
  broderbar_av_1_A : A ;
  broderlig_av_1_A : A ;
  brokbladig_av_1_A : A ;
  brokblommig_av_1_A : A ;
  brokig_av_1_A : A ;
  bromerbar_av_1_A : A ;
  bronserbar_av_1_A : A ;
  broscherbar_av_1_A : A ;
  brottslig_av_1_A : A ;
  brukbar_av_1_A : A ;
  bruklig_av_1_A : A ;
  brun_av_1_A : A ;
  brunaktig_av_1_A : A ;
  bruneisk_av_1_A : A ;
  brunerbar_av_1_A : A ;
  brunett_av_1_A : A ;
  brungul_av_1_A : A ;
  brunhaarig_av_1_1_A : A ;
  brunmurrig_av_1_A : A ;
  brunnskall_av_1_A : A ;
  brunrutig_av_1_A : A ;
  brunroed_av_1_1_A : A ;
  brunsmutsig_av_1_A : A ;
  brunstig_av_1_A : A ;
  brutal_av_1_A : A ;
  brutaliserbar_av_1_A : A ;
  brydd_av_1_A : A ;
  brysk_av_1_A : A ;
  braecklig_av_1_1_A : A ;
  braeddfull_av_1_1_A : A ;
  braennbar_av_1_1_A : A ;
  braennhet_av_1_1_A : A ;
  braennlackerbar_av_1_1_A : A ;
  braenslesnaal_av_1_1_A : A ;
  braeserbar_av_1_1_A : A ;
  braad_av_1_1_A : A ;
  braaddjup_av_1_1_A : A ;
  braakig_av_1_1_A : A ;
  broedloes_av_1_1_A : A ;
  broestsjuk_av_1_1_A : A ;
  bubblig_av_1_A : A ;
  bucklig_av_1_A : A ;
  buddhistisk_av_1_A : A ;
  buddistisk_av_1_A : A ;
  budgeterbar_av_1_A : A ;
  budgetmaessig_av_1_1_A : A ;
  budgetpolitisk_av_1_A : A ;
  budgetaer_av_1_1_A : A ;
  budoarmaessig_av_1_1_A : A ;
  buffelaktig_av_1_A : A ;
  bufflig_av_1_A : A ;
  bukformig_av_1_A : A ;
  bukig_av_1_A : A ;
  bukolisk_av_1_A : A ;
  buktig_av_1_A : A ;
  bulgarisk_av_1_A : A ;
  bullerutsatt_av_1_A : A ;
  bullig_av_1_A : A ;
  bullrig_av_1_A : A ;
  bulsig_av_1_A : A ;
  burdus_av_1_A : A ;
  burkinsk_av_1_A : A ;
  burlesk_av_1_A : A ;
  burmansk_av_1_A : A ;
  burmesisk_av_1_A : A ;
  burrig_av_1_A : A ;
  burschikos_av_1_A : A ;
  burundisk_av_1_A : A ;
  busenkel_av_1_A : A ;
  busig_av_1_A : A ;
  buskablyg_av_1_A : A ;
  buskig_av_1_A : A ;
  bussig_av_1_A : A ;
  buteljerbar_av_1_A : A ;
  buteljgroen_av_1_1_A : A ;
  butter_av_1_A : A ;
  byggnadsmaessig_av_1_1_A : A ;
  byig_av_1_A : A ;
  bylsig_av_1_A : A ;
  byraakratiserbar_av_1_1_A : A ;
  byraakratisk_av_1_1_A : A ;
  bysantinsk_av_1_A : A ;
  byxloes_av_1_1_A : A ;
  baeng_av_1_1_A : A ;
  baerbar_av_1_1_A : A ;
  baerig_av_1_1_A : A ;
  baerkraftig_av_1_1_A : A ;
  baagformig_av_1_1_A : A ;
  baagig_av_1_1_A : A ;
  baangstyrig_av_1_1_A : A ;
  baatformig_av_1_1_A : A ;
  boehmisk_av_1_1_A : A ;
  boejbar_av_1_1_A : A ;
  boejlig_av_1_1_A : A ;
  boekig_av_1_1_A : A ;
  boenformig_av_1_1_A : A ;
  boenlig_av_1_1_A : A ;
  boerdig_av_1_1_A : A ;
  boerdig_av_2_1_A : A ;
  boersmaessig_av_1_1_A : A ;
  boersnoterbar_av_1_1_A : A ;
  camouflerbar_av_1_A : A ;
  cartesiansk_av_1_A : A ;
  cederbar_av_1_A : A ;
  celeber_av_1_A : A ;
  celebrerbar_av_1_A : A ;
  cellulaer_av_1_1_A : A ;
  cementerbar_av_1_A : A ;
  censurerbar_av_1_A : A ;
  centimeterlaang_av_1_1_A : A ;
  centimetertjock_av_1_A : A ;
  central_av_1_A : A ;
  centralafrikansk_av_1_A : A ;
  centralamerikansk_av_1_A : A ;
  centraleuropeisk_av_1_A : A ;
  centraliserbar_av_1_A : A ;
  centralistisk_av_1_A : A ;
  centrallyrisk_av_1_A : A ;
  centrerbar_av_1_A : A ;
  centrifugal_av_1_A : A ;
  centrifugerbar_av_1_A : A ;
  centripetal_av_1_A : A ;
  centrisk_av_1_A : A ;
  cerebral_av_1_A : A ;
  cerebrospinal_av_1_A : A ;
  ceremoniell_av_1_A : A ;
  ceremonioes_av_1_1_A : A ;
  cernerbar_av_1_A : A ;
  cesarisk_av_1_A : A ;
  chansloes_av_1_1_A : A ;
  chansmaessig_av_1_1_A : A ;
  chargerbar_av_1_A : A ;
  charlatanmaessig_av_1_1_A : A ;
  charmerbar_av_1_A : A ;
  charmfull_av_1_A : A ;
  charmig_av_1_A : A ;
  charmloes_av_1_1_A : A ;
  chassidistisk_av_1_A : A ;
  chauvinistisk_av_1_A : A ;
  chevaleresk_av_1_A : A ;
  chevroterbar_av_1_A : A ;
  chic_av_1_A : A ;
  chiffrerbar_av_1_A : A ;
  chikanerbar_av_1_A : A ;
  chilensk_av_1_A : A ;
  chockerbar_av_1_A : A ;
  chokladbrun_av_1_A : A ;
  chosig_av_1_A : A ;
  cinnoberroed_av_1_1_A : A ;
  cirkulerbar_av_1_A : A ;
  cirkulaer_av_1_1_A : A ;
  cirkumpolar_av_1_A : A ;
  cirkumpolaer_av_1_1_A : A ;
  cirkusmaessig_av_1_1_A : A ;
  cisalpinsk_av_1_A : A ;
  ciselerbar_av_1_A : A ;
  citerbar_av_1_A : A ;
  citrongul_av_1_A : A ;
  civil_av_1_A : A ;
  civilisatorisk_av_1_A : A ;
  civiliserbar_av_1_A : A ;
  civilklaedd_av_1_1_A : A ;
  civilmilitaer_av_1_1_A : A ;
  civilraettslig_av_1_1_A : A ;
  colombiansk_av_1_A : A ;
  comorisk_av_1_A : A ;
  cool_av_1_A : A ;
  cortical_av_1_A : A ;
  costaricansk_av_1_A : A ;
  cubansk_av_1_A : A ;
  curaterbar_av_1_A : A ;
  curerbar_av_1_A : A ;
  cybernetisk_av_1_A : A ;
  cyklisk_av_1_A : A ;
  cyklotym_av_1_A : A ;
  cylindrisk_av_1_A : A ;
  cynisk_av_1_A : A ;
  cypriotisk_av_1_A : A ;
  cytologisk_av_1_A : A ;
  dadaistisk_av_1_A : A ;
  dagaktiv_av_1_A : A ;
  daggfrisk_av_1_A : A ;
  daggig_av_1_A : A ;
  daggvaat_av_1_1_A : A ;
  daglig_av_1_A : A ;
  dagsaktuell_av_1_A : A ;
  dagslaang_av_1_1_A : A ;
  dagspolitisk_av_1_A : A ;
  daktylisk_av_1_A : A ;
  dalamaessig_av_1_1_A : A ;
  dalsk_av_1_A : A ;
  dalslaendsk_av_1_1_A : A ;
  damig_av_1_A : A ;
  dammfri_av_1_A : A ;
  dammig_av_1_A : A ;
  dansk_av_1_A : A ;
  dansmaessig_av_1_1_A : A ;
  darrig_av_1_A : A ;
  darwinistisk_av_1_A : A ;
  daskig_av_1_A : A ;
  dassig_av_1_A : A ;
  datamaskinell_av_1_A : A ;
  datapolitisk_av_1_A : A ;
  daterbar_av_1_A : A ;
  datoriserbar_av_1_A : A ;
  datumparkerbar_av_1_A : A ;
  debarkerbar_av_1_A : A ;
  debatterbar_av_1_A : A ;
  debattmaessig_av_1_1_A : A ;
  debil_av_1_A : A ;
  debiterbar_av_1_A : A ;
  decentraliserbar_av_1_A : A ;
  dechiffrerbar_av_1_A : A ;
  decimerbar_av_1_A : A ;
  decimeterlaang_av_1_1_A : A ;
  dedicerbar_av_1_A : A ;
  dedikerbar_av_1_A : A ;
  deducerbar_av_1_A : A ;
  deduktiv_av_1_A : A ;
  defaitistisk_av_1_A : A ;
  defensiv_av_1_A : A ;
  defilerbar_av_1_A : A ;
  definierbar_av_1_A : A ;
  definitionsmaessig_av_1_1_A : A ;
  definitiv_av_1_A : A ;
  deflorerbar_av_1_A : A ;
  deformerbar_av_1_A : A ;
  degenerativ_av_1_A : A ;
  degenererbar_av_1_A : A ;
  degig_av_1_A : A ;
  degraderbar_av_1_A : A ;
  deiktisk_av_1_A : A ;
  deistisk_av_1_A : A ;
  dejlig_av_1_A : A ;
  dekadisk_av_1_A : A ;
  dekanterbar_av_1_A : A ;
  dekapiterbar_av_1_A : A ;
  deklamatorisk_av_1_A : A ;
  deklamerbar_av_1_A : A ;
  deklarerbar_av_1_A : A ;
  deklasserbar_av_1_A : A ;
  deklinerbar_av_1_A : A ;
  dekorativ_av_1_A : A ;
  dekorerbar_av_1_A : A ;
  dekouragerbar_av_1_A : A ;
  dekreterbar_av_1_A : A ;
  delaktig_av_1_A : A ;
  delbar_av_1_A : A ;
  delegerbar_av_1_A : A ;
  delicioes_av_1_1_A : A ;
  deltidssjuk_av_1_A : A ;
  delvis_av_1_A : A ;
  demagogisk_av_1_A : A ;
  demaskerbar_av_1_A : A ;
  dement_av_1_A : A ;
  dementerbar_av_1_A : A ;
  demilitariserbar_av_1_A : A ;
  demobiliserbar_av_1_A : A ;
  demografisk_av_1_A : A ;
  demokratiserbar_av_1_A : A ;
  demokratisk_av_1_A : A ;
  demolerbar_av_1_A : A ;
  demoniserbar_av_1_A : A ;
  demonisk_av_1_A : A ;
  demonologisk_av_1_A : A ;
  demonstrativ_av_1_A : A ;
  demonstrerbar_av_1_A : A ;
  demonterbar_av_1_A : A ;
  demoraliserbar_av_1_A : A ;
  denaturaliserbar_av_1_A : A ;
  denaturerbar_av_1_A : A ;
  denotativ_av_1_A : A ;
  denoterbar_av_1_A : A ;
  dental_av_1_A : A ;
  denuderbar_av_1_A : A ;
  deodoriserbar_av_1_A : A ;
  departemental_av_1_A : A ;
  depatrierbar_av_1_A : A ;
  depenserbar_av_1_A : A ;
  deplacerbar_av_1_A : A ;
  deponentiell_av_1_A : A ;
  deponerbar_av_1_A : A ;
  deporterbar_av_1_A : A ;
  deppig_av_1_A : A ;
  deprecierbar_av_1_A : A ;
  depressiv_av_1_A : A ;
  derangerbar_av_1_A : A ;
  deriverbar_av_1_A : A ;
  dermatologisk_av_1_A : A ;
  desarmerbar_av_1_A : A ;
  desavouerbar_av_1_A : A ;
  desensibiliserbar_av_1_A : A ;
  designerbar_av_1_A : A ;
  designmaessig_av_1_1_A : A ;
  desinfekterbar_av_1_A : A ;
  desinficerbar_av_1_A : A ;
  desinformerbar_av_1_A : A ;
  deskriptiv_av_1_A : A ;
  desorganiserbar_av_1_A : A ;
  despotisk_av_1_A : A ;
  destabiliserbar_av_1_A : A ;
  destillerbar_av_1_A : A ;
  destinerbar_av_1_A : A ;
  destruerbar_av_1_A : A ;
  destruktiv_av_1_A : A ;
  detacherbar_av_1_A : A ;
  detaljrik_av_1_A : A ;
  detekterbar_av_1_A : A ;
  detektiv_av_1_A : A ;
  determinativ_av_1_A : A ;
  determinerbar_av_1_A : A ;
  deterministisk_av_1_A : A ;
  detonerbar_av_1_A : A ;
  detroniserbar_av_1_A : A ;
  devalverbar_av_1_A : A ;
  diabolisk_av_1_A : A ;
  diagnosticerbar_av_1_A : A ;
  diagnostiserbar_av_1_A : A ;
  diagnostisk_av_1_A : A ;
  diagonal_av_1_A : A ;
  diakritisk_av_1_A : A ;
  diakron_av_1_A : A ;
  diakronisk_av_1_A : A ;
  dialektal_av_1_A : A ;
  dialektgeografisk_av_1_A : A ;
  dialektisk_av_1_A : A ;
  dialektologisk_av_1_A : A ;
  dialogisk_av_1_A : A ;
  dialyserbar_av_1_A : A ;
  dialytisk_av_1_A : A ;
  diamantprydd_av_1_A : A ;
  diametral_av_1_A : A ;
  diastolisk_av_1_A : A ;
  diatonisk_av_1_A : A ;
  didaktisk_av_1_A : A ;
  dietetisk_av_1_A : A ;
  dietisk_av_1_A : A ;
  differentiell_av_1_A : A ;
  differentierbar_av_1_A : A ;
  diffunderbar_av_1_A : A ;
  diffus_av_1_A : A ;
  diftongerbar_av_1_A : A ;
  diger_av_1_A : A ;
  digererbar_av_1_A : A ;
  digital_av_1_A : A ;
  diklin_av_1_A : A ;
  dikotyledon_av_1_A : A ;
  diktatorisk_av_1_A : A ;
  dikterbar_av_1_A : A ;
  diktmaessig_av_1_1_A : A ;
  dilettantisk_av_1_A : A ;
  dilettantmaessig_av_1_1_A : A ;
  dimensionerbar_av_1_A : A ;
  dimensionsloes_av_1_1_A : A ;
  diminutiv_av_1_A : A ;
  dimmig_av_1_A : A ;
  dimorf_av_1_A : A ;
  dionysisk_av_1_A : A ;
  dioptrisk_av_1_A : A ;
  diplomatarisk_av_1_A : A ;
  diplomatisk_av_1_A : A ;
  diplomatisk_av_2_A : A ;
  diplomerbar_av_1_A : A ;
  dirigerbar_av_1_A : A ;
  disambiguerbar_av_1_A : A ;
  disciplinerbar_av_1_A : A ;
  disciplinaer_av_1_1_A : A ;
  disharmonierbar_av_1_A : A ;
  disharmonisk_av_1_A : A ;
  disig_av_1_A : A ;
  disjunktiv_av_1_A : A ;
  diskonterbar_av_1_A : A ;
  diskontinuerlig_av_1_A : A ;
  diskrediterbar_av_1_A : A ;
  diskriminerbar_av_1_A : A ;
  diskursiv_av_1_A : A ;
  diskutabel_av_1_A : A ;
  diskuterbar_av_1_A : A ;
  diskvalificerbar_av_1_A : A ;
  dispascherbar_av_1_A : A ;
  dispenserbar_av_1_A : A ;
  dispergerbar_av_1_A : A ;
  dispers_av_1_A : A ;
  disponerbar_av_1_A : A ;
  disponibel_av_1_A : A ;
  dispositiv_av_1_A : A ;
  disproportionerlig_av_1_A : A ;
  disputerbar_av_1_A : A ;
  dissekerbar_av_1_A : A ;
  dissimilerbar_av_1_A : A ;
  dissocierbar_av_1_A : A ;
  distanserbar_av_1_A : A ;
  distraherbar_av_1_A : A ;
  distribuerbar_av_1_A : A ;
  distributiv_av_1_A : A ;
  dityrambisk_av_1_A : A ;
  divergerbar_av_1_A : A ;
  diversifierbar_av_1_A : A ;
  dividerbar_av_1_A : A ;
  divig_av_1_A : A ;
  divinatorisk_av_1_A : A ;
  djiboutisk_av_1_A : A ;
  djup_av_1_A : A ;
  djupgroen_av_1_1_A : A ;
  djuproed_av_1_1_A : A ;
  djupsinnig_av_1_A : A ;
  djurisk_av_1_A : A ;
  djurskyddsmaessig_av_1_1_A : A ;
  djurvaenlig_av_1_1_A : A ;
  djaeklig_av_1_1_A : A ;
  djaerv_av_1_1_A : A ;
  djaevelsk_av_1_1_A : A ;
  djaevlig_av_1_1_A : A ;
  djaevulsk_av_1_1_A : A ;
  djaevulusisk_av_1_1_A : A ;
  docerbar_av_1_A : A ;
  dockaktig_av_1_A : A ;
  docksoet_av_1_1_A : A ;
  doftloes_av_1_1_A : A ;
  doftmarkerbar_av_1_A : A ;
  doftsvag_av_1_A : A ;
  dogmatiserbar_av_1_A : A ;
  dogmatisk_av_1_A : A ;
  doktrinaer_av_1_1_A : A ;
  dokumentarisk_av_1_A : A ;
  dokumenterbar_av_1_A : A ;
  dokumentaer_av_1_1_A : A ;
  dolikocefal_av_1_A : A ;
  dolsk_av_1_A : A ;
  domesticerbar_av_1_A : A ;
  domfoer_av_1_1_A : A ;
  domicilierbar_av_1_A : A ;
  dominerbar_av_1_A : A ;
  dominikansk_av_1_A : A ;
  dominikisk_av_1_A : A ;
  dompterbar_av_1_A : A ;
  domstolsmaessig_av_1_1_A : A ;
  donerbar_av_1_A : A ;
  dopaminkaenslig_av_1_1_A : A ;
  dorisk_av_1_A : A ;
  dorsal_av_1_A : A ;
  dorsk_av_1_A : A ;
  doserbar_av_1_A : A ;
  dosserbar_av_1_A : A ;
  doterbar_av_1_A : A ;
  dotterlig_av_1_A : A ;
  dov_av_1_A : A ;
  dragerbar_av_1_A : A ;
  dragig_av_1_A : A ;
  drakonisk_av_1_A : A ;
  dramatiserbar_av_1_A : A ;
  dramatisk_av_1_A : A ;
  dramaturgisk_av_1_A : A ;
  draperbar_av_1_A : A ;
  drastisk_av_1_A : A ;
  dresserbar_av_1_A : A ;
  drickbar_av_1_A : A ;
  driftig_av_1_A : A ;
  driftmaessig_av_1_1_A : A ;
  driftsmaessig_av_1_1_A : A ;
  driftsaeker_av_1_1_A : A ;
  driftsaekerhetsmaessig_av_1_1_A : A ;
  dristig_av_1_A : A ;
  drottninglik_av_1_A : A ;
  drulig_av_1_A : A ;
  drullig_av_1_A : A ;
  drumlig_av_1_A : A ;
  drummelaktig_av_1_A : A ;
  dryg_av_1_A : A ;
  draeglig_av_1_1_A : A ;
  draektig_av_1_1_A : A ;
  draenerbar_av_1_1_A : A ;
  draenkbar_av_1_1_A : A ;
  draaplig_av_1_1_A : A ;
  droemlik_av_1_1_A : A ;
  droemsk_av_1_1_A : A ;
  dualistisk_av_1_A : A ;
  dubbel_av_1_A : A ;
  dubbelexponerbar_av_1_A : A ;
  dubbelpipig_av_1_A : A ;
  dubbelsidig_av_1_A : A ;
  dubbelspaarig_av_1_1_A : A ;
  dubbeltraadig_av_1_1_A : A ;
  dubbeltydig_av_1_A : A ;
  dubblerbar_av_1_A : A ;
  dubioes_av_1_1_A : A ;
  duglig_av_1_A : A ;
  duktig_av_1_A : A ;
  dumdristig_av_1_A : A ;
  dumdryg_av_1_A : A ;
  dunig_av_1_A : A ;
  dunkel_av_1_A : A ;
  dunlaett_av_1_1_A : A ;
  dunstig_av_1_A : A ;
  duperbar_av_1_A : A ;
  duplicerbar_av_1_A : A ;
  durativ_av_1_A : A ;
  dvaergaktig_av_1_1_A : A ;
  dybloet_av_1_1_A : A ;
  dygdig_av_1_A : A ;
  dygnsvis_av_1_A : A ;
  dyig_av_1_A : A ;
  dynamisk_av_1_A : A ;
  dynamistisk_av_1_A : A ;
  dynastisk_av_1_A : A ;
  dyngrak_av_1_A : A ;
  dyngsur_av_1_A : A ;
  dyr_av_1_A : A ;
  dyrbar_av_1_A : A ;
  dysfunktionell_av_1_A : A ;
  dyslektisk_av_1_A : A ;
  dyster_av_1_A : A ;
  dystopisk_av_1_A : A ;
  dystrof_av_1_A : A ;
  dyvaat_av_1_1_A : A ;
  daadloes_av_1_1_A : A ;
  daaraktig_av_1_1_A : A ;
  daarhusmaessig_av_1_1_A : A ;
  daasig_av_1_1_A : A ;
  doeblek_av_1_1_A : A ;
  doed_av_1_1_A : A ;
  doedfull_av_1_1_A : A ;
  doedfoedd_av_1_1_A : A ;
  doedlig_av_1_1_A : A ;
  doedsblek_av_1_1_A : A ;
  doedssjuk_av_1_1_A : A ;
  doedstraakig_av_1_1_A : A ;
  doedstroett_av_1_1_A : A ;
  doefull_av_1_1_A : A ;
  doesjuk_av_1_1_A : A ;
  doeskraj_av_1_1_A : A ;
  doetraakig_av_1_1_A : A ;
  doetroett_av_1_1_A : A ;
  doev_av_1_1_A : A ;
  ecklesiastik_av_1_A : A ;
  ecklesiastisk_av_1_A : A ;
  ecuadoriansk_av_1_A : A ;
  ederbar_av_1_A : A ;
  edlig_av_1_A : A ;
  efemaer_av_1_1_A : A ;
  effacerbar_av_1_A : A ;
  effektfull_av_1_A : A ;
  effektiv_av_1_A : A ;
  effektiverbar_av_1_A : A ;
  effektiviserbar_av_1_A : A ;
  effektivitetsmaessig_av_1_1_A : A ;
  effektloes_av_1_1_A : A ;
  effektmaessig_av_1_1_A : A ;
  effektuerbar_av_1_A : A ;
  efterdaterbar_av_1_A : A ;
  efterdebiterbar_av_1_A : A ;
  efterdoemlig_av_1_1_A : A ;
  eftergivlig_av_1_A : A ;
  eftergymnasial_av_1_A : A ;
  efterklok_av_1_A : A ;
  efterrationaliserbar_av_1_A : A ;
  eftersynkroniserbar_av_1_A : A ;
  eftertaxerbar_av_1_A : A ;
  eftertrycklig_av_1_A : A ;
  eftervis_av_1_A : A ;
  egal_av_1_A : A ;
  egaliserbar_av_1_A : A ;
  egalitaer_av_1_1_A : A ;
  egeisk_av_1_A : A ;
  egendomlig_av_1_A : A ;
  egendomsloes_av_1_1_A : A ;
  egenhaendig_av_1_1_A : A ;
  egenkaer_av_1_1_A : A ;
  egenmaektig_av_1_1_A : A ;
  egennyttig_av_1_A : A ;
  egenraettfaerdig_av_1_1_A : A ;
  egenraadig_av_1_1_A : A ;
  egensinnig_av_1_A : A ;
  egentlig_av_1_A : A ;
  egenvarm_av_1_A : A ;
  eggvass_av_1_A : A ;
  egocentrisk_av_1_A : A ;
  egoistisk_av_1_A : A ;
  egyptisk_av_1_A : A ;
  eidetisk_av_1_A : A ;
  einsteinsk_av_1_A : A ;
  ekiperbar_av_1_A : A ;
  ekivok_av_1_A : A ;
  eklaterbar_av_1_A : A ;
  eklatt_av_1_A : A ;
  eklektisk_av_1_A : A ;
  eklaererbar_av_1_1_A : A ;
  ekofascistisk_av_1_A : A ;
  ekologisk_av_1_A : A ;
  ekonomiserbar_av_1_A : A ;
  ekonomisk_politisk_av_1_A : A ;
  ekonomisk_av_1_A : A ;
  ekonomiskpolitisk_av_1_A : A ;
  ekonomiskt_politisk_av_1_A : A ;
  ekonomisktpolitisk_av_1_A : A ;
  ekorroed_av_1_1_A : A ;
  ekumenisk_av_1_A : A ;
  ekvatorial_av_1_A : A ;
  ekvatorialguineansk_av_1_A : A ;
  ekvatoriell_av_1_A : A ;
  ekvilibristisk_av_1_A : A ;
  elaborerbar_av_1_A : A ;
  elak_av_1_A : A ;
  elastiserbar_av_1_A : A ;
  elastisk_av_1_A : A ;
  eldfarlig_av_1_A : A ;
  eldgaffelsrak_av_1_A : A ;
  eldhaerdig_av_1_1_A : A ;
  eldig_av_1_A : A ;
  eldroed_av_1_1_A : A ;
  eldsaeker_av_1_1_A : A ;
  elegisk_av_1_A : A ;
  elektrificerbar_av_1_A : A ;
  elektrifierbar_av_1_A : A ;
  elektriserbar_av_1_A : A ;
  elektrisk_av_1_A : A ;
  elektrokemisk_av_1_A : A ;
  elektrolytisk_av_1_A : A ;
  elektromagnetisk_av_1_A : A ;
  elektromekanisk_av_1_A : A ;
  elektromotorisk_av_1_A : A ;
  elektronisk_av_1_A : A ;
  elektrostatisk_av_1_A : A ;
  elektrosvag_av_1_A : A ;
  elektroteknisk_av_1_A : A ;
  elementaer_av_1_1_A : A ;
  elfenbensvit_av_1_A : A ;
  eliderbar_av_1_A : A ;
  eliminerbar_av_1_A : A ;
  elitisk_av_1_A : A ;
  elitistisk_av_1_A : A ;
  elitmaessig_av_1_1_A : A ;
  elitseriemaessig_av_1_1_A : A ;
  elliptisk_av_1_A : A ;
  eloxerbar_av_1_A : A ;
  eluderbar_av_1_A : A ;
  eluerbar_av_1_A : A ;
  eluvial_av_1_A : A ;
  elvadimensionell_av_1_A : A ;
  elvaaarig_av_1_1_A : A ;
  elyseisk_av_1_A : A ;
  elaendig_av_1_1_A : A ;
  emaljerbar_av_1_A : A ;
  emanciperbar_av_1_A : A ;
  emballerbar_av_1_A : A ;
  embarkerbar_av_1_A : A ;
  embellerbar_av_1_A : A ;
  emblematisk_av_1_A : A ;
  embryonal_av_1_A : A ;
  embryonisk_av_1_A : A ;
  emenderbar_av_1_A : A ;
  emfatisk_av_1_A : A ;
  emigrerbar_av_1_A : A ;
  emiratisk_av_1_A : A ;
  emitterbar_av_1_A : A ;
  emotionell_av_1_A : A ;
  emotiv_av_1_A : A ;
  empatisk_av_1_A : A ;
  empirisk_av_1_A : A ;
  empiristisk_av_1_A : A ;
  emulgerbar_av_1_A : A ;
  enarmig_av_1_A : A ;
  enaxlig_av_1_A : A ;
  enbasisk_av_1_A : A ;
  encellig_av_1_A : A ;
  encyklopedisk_av_1_A : A ;
  endemisk_av_1_A : A ;
  endimensionell_av_1_A : A ;
  endokrin_av_1_A : A ;
  endosserbar_av_1_A : A ;
  endotermisk_av_1_A : A ;
  endraektig_av_1_1_A : A ;
  energiloes_av_1_1_A : A ;
  energimaessig_av_1_1_A : A ;
  energipolitisk_av_1_A : A ;
  energirik_av_1_A : A ;
  energisk_av_1_A : A ;
  energisnaal_av_1_1_A : A ;
  enerverbar_av_1_A : A ;
  enfaldig_av_1_A : A ;
  enfasig_av_1_A : A ;
  enformig_av_1_A : A ;
  enfoedd_av_1_1_A : A ;
  engagerbar_av_1_A : A ;
  engelsk_av_1_A : A ;
  engelskspraakig_av_1_1_A : A ;
  engelskspaakig_av_1_1_A : A ;
  enharmonisk_av_1_A : A ;
  enhetlig_av_1_A : A ;
  enhjulig_av_1_A : A ;
  enhjaertbladig_av_1_1_A : A ;
  enhaellig_av_1_1_A : A ;
  enig_av_1_A : A ;
  enigmatisk_av_1_A : A ;
  enkel_av_1_A : A ;
  enkelnervig_av_1_A : A ;
  enkelpipig_av_1_A : A ;
  enkelspaarig_av_1_1_A : A ;
  enklitisk_av_1_A : A ;
  enleverbar_av_1_A : A ;
  enorm_av_1_A : A ;
  enpolig_av_1_A : A ;
  enpucklig_av_1_A : A ;
  enrollerbar_av_1_A : A ;
  enraadig_av_1_1_A : A ;
  ensidig_av_1_A : A ;
  ensilerbar_av_1_A : A ;
  enslig_av_1_A : A ;
  enspraakig_av_1_1_A : A ;
  enstavig_av_1_A : A ;
  enstjaernig_av_1_1_A : A ;
  enstaemmig_av_1_1_A : A ;
  enstaendig_av_1_1_A : A ;
  enstoerig_av_1_1_A : A ;
  entomologisk_av_1_A : A ;
  entonig_av_1_A : A ;
  entusiasmerbar_av_1_A : A ;
  entusiastisk_av_1_A : A ;
  entydig_av_1_A : A ;
  envis_av_1_A : A ;
  envaeldig_av_1_1_A : A ;
  eolisk_av_1_A : A ;
  epidemiologisk_av_1_A : A ;
  epidemisk_av_1_A : A ;
  epigrammatisk_av_1_A : A ;
  epikureisk_av_1_A : A ;
  epilerbar_av_1_A : A ;
  episk_av_1_A : A ;
  episkopal_av_1_A : A ;
  episodisk_av_1_A : A ;
  epistolaer_av_1_1_A : A ;
  epizoisk_av_1_A : A ;
  erbarmlig_av_1_A : A ;
  eremitisk_av_1_A : A ;
  erfarenhetsmaessig_av_1_1_A : A ;
  erforderlig_av_1_A : A ;
  ergativ_av_1_A : A ;
  ergonometrisk_av_1_A : A ;
  ergonomisk_av_1_A : A ;
  erigerbar_av_1_A : A ;
  eritreansk_av_1_A : A ;
  eroderbar_av_1_A : A ;
  erotisk_av_1_A : A ;
  erotoman_av_1_A : A ;
  erratisk_av_1_A : A ;
  ersaettlig_av_1_1_A : A ;
  eruptiv_av_1_A : A ;
  eskalerbar_av_1_A : A ;
  eskapistisk_av_1_A : A ;
  eskatologisk_av_1_A : A ;
  eskorterbar_av_1_A : A ;
  esoterisk_av_1_A : A ;
  essayistisk_av_1_A : A ;
  essentiell_av_1_A : A ;
  essaeistisk_av_1_1_A : A ;
  esteticerbar_av_1_A : A ;
  estetiserbar_av_1_A : A ;
  estetisk_av_1_A : A ;
  estimerbar_av_1_A : A ;
  estlaendsk_av_1_1_A : A ;
  estnisk_av_1_A : A ;
  etablerbar_av_1_A : A ;
  eteriserbar_av_1_A : A ;
  eterisk_av_1_A : A ;
  etiketterbar_av_1_A : A ;
  etikettsmaessig_av_1_1_A : A ;
  etiologisk_av_1_A : A ;
  etiopisk_av_1_A : A ;
  etisk_av_1_A : A ;
  etnisk_av_1_A : A ;
  etnocentrisk_av_1_A : A ;
  etnografisk_av_1_A : A ;
  etnologisk_av_1_A : A ;
  etologisk_av_1_A : A ;
  etruskisk_av_1_A : A ;
  ettrig_av_1_A : A ;
  ettaarig_av_1_1_A : A ;
  etymologiserbar_av_1_A : A ;
  etymologisk_av_1_A : A ;
  eufemistisk_av_1_A : A ;
  euforisk_av_1_A : A ;
  euklidisk_av_1_A : A ;
  eurasisk_av_1_A : A ;
  eurokommunistisk_av_1_A : A ;
  europeiserbar_av_1_A : A ;
  europeisk_av_1_A : A ;
  eutrof_av_1_A : A ;
  evakuerbar_av_1_A : A ;
  evaluerbar_av_1_A : A ;
  evalverbar_av_1_A : A ;
  evangelisk_av_1_A : A ;
  evaporerbar_av_1_A : A ;
  eventuell_av_1_A : A ;
  evig_av_1_A : A ;
  evinnerlig_av_1_A : A ;
  evolutionistisk_av_1_A : A ;
  evolutionsmaessig_av_1_1_A : A ;
  evolutionaer_av_1_1_A : A ;
  evaerdlig_av_1_1_A : A ;
  examinerbar_av_1_A : A ;
  excentrisk_av_1_A : A ;
  exceptionell_av_1_A : A ;
  excerperbar_av_1_A : A ;
  exciterbar_av_1_A : A ;
  exegetisk_av_1_A : A ;
  exekutiv_av_1_A : A ;
  exekutorisk_av_1_A : A ;
  exekverbar_av_1_A : A ;
  exempelloes_av_1_1_A : A ;
  exemplarisk_av_1_A : A ;
  exemplifierbar_av_1_A : A ;
  exercerbar_av_1_A : A ;
  exhibitionistisk_av_1_A : A ;
  exigibel_av_1_A : A ;
  existentialistisk_av_1_A : A ;
  existentiell_av_1_A : A ;
  exklamatorisk_av_1_A : A ;
  exkluderbar_av_1_A : A ;
  exklusiv_av_1_A : A ;
  exkommunicerbar_av_1_A : A ;
  exkremental_av_1_A : A ;
  exorcistisk_av_1_A : A ;
  exoterisk_av_1_A : A ;
  exotermisk_av_1_A : A ;
  exotisk_av_1_A : A ;
  exotistisk_av_1_A : A ;
  expanderbar_av_1_A : A ;
  expansibel_av_1_A : A ;
  expansionistisk_av_1_A : A ;
  expansiv_av_1_A : A ;
  expatrierbar_av_1_A : A ;
  expedierbar_av_1_A : A ;
  expektorerbar_av_1_A : A ;
  experimentell_av_1_A : A ;
  explanativ_av_1_A : A ;
  explicerbar_av_1_A : A ;
  exploaterbar_av_1_A : A ;
  exploderbar_av_1_A : A ;
  explosiv_av_1_A : A ;
  exponentiell_av_1_A : A ;
  exponerbar_av_1_A : A ;
  exporterbar_av_1_A : A ;
  expressionistisk_av_1_A : A ;
  expressiv_av_1_A : A ;
  exproprierbar_av_1_A : A ;
  exstirperbar_av_1_A : A ;
  extatisk_av_1_A : A ;
  extemporerbar_av_1_A : A ;
  extensiv_av_1_A : A ;
  exterioer_av_1_1_A : A ;
  extern_av_1_A : A ;
  exterritoriell_av_1_A : A ;
  extraherbar_av_1_A : A ;
  extrajudiciell_av_1_A : A ;
  extramural_av_1_A : A ;
  extraordinaer_av_1_1_A : A ;
  extrapolerbar_av_1_A : A ;
  extrauterin_av_1_A : A ;
  extrem_av_1_A : A ;
  extremistisk_av_1_A : A ;
  extrinsisk_av_1_A : A ;
  fabelaktig_av_1_A : A ;
  fabricerbar_av_1_A : A ;
  fabriksmaessig_av_1_1_A : A ;
  fabulerbar_av_1_A : A ;
  fabuloes_av_1_1_A : A ;
  facetterbar_av_1_A : A ;
  facil_av_1_A : A ;
  fackfoereningsfientlig_av_1_1_A : A ;
  fackkunnig_av_1_A : A ;
  facklig_politisk_av_1_A : A ;
  facklig_av_1_A : A ;
  fackligpolitisk_av_1_A : A ;
  fackligt_politisk_av_1_A : A ;
  fackligtpolitisk_av_1_A : A ;
  fackmannamaessig_av_1_1_A : A ;
  fackmaessig_av_1_1_A : A ;
  faderlig_av_1_A : A ;
  faderloes_av_1_1_A : A ;
  fager_av_1_A : A ;
  faktamaessig_av_1_1_A : A ;
  faktisk_av_1_A : A ;
  fakturerbar_av_1_A : A ;
  fakultativ_av_1_A : A ;
  fal_av_1_A : A ;
  fallfaerdig_av_1_1_A : A ;
  falsifierbar_av_1_A : A ;
  falsk_av_1_A : A ;
  faluroed_av_1_1_A : A ;
  familjemaessig_av_1_1_A : A ;
  familjepolitisk_av_1_A : A ;
  familjaer_av_1_1_A : A ;
  famoes_av_1_1_A : A ;
  fanatisk_av_1_A : A ;
  fanerogam_av_1_A : A ;
  fantasifull_av_1_A : A ;
  fantasiloes_av_1_1_A : A ;
  fantasirik_av_1_A : A ;
  fantastisk_av_1_A : A ;
  fantiserbar_av_1_A : A ;
  fantomsnygg_av_1_A : A ;
  faraonisk_av_1_A : A ;
  farbar_av_1_A : A ;
  farbroderlig_av_1_A : A ;
  fariseisk_av_1_A : A ;
  farlig_av_1_A : A ;
  farmaceutisk_av_1_A : A ;
  farmacevtisk_av_1_A : A ;
  farmakologisk_av_1_A : A ;
  faryngal_av_1_A : A ;
  fasansfull_av_1_A : A ;
  fascinerbar_av_1_A : A ;
  fascistisk_av_1_A : A ;
  fasetterbar_av_1_A : A ;
  fashionabel_av_1_A : A ;
  faslig_av_1_A : A ;
  fasonerbar_av_1_A : A ;
  fasonlig_av_1_A : A ;
  fastighetstaxerbar_av_1_A : A ;
  fatal_av_1_A : A ;
  fatalistisk_av_1_A : A ;
  fattbar_av_1_A : A ;
  fattig_av_1_A : A ;
  fattlig_av_1_A : A ;
  faunistisk_av_1_A : A ;
  favoriserbar_av_1_A : A ;
  feberhet_av_1_A : A ;
  febersjuk_av_1_A : A ;
  febrig_av_1_A : A ;
  febril_av_1_A : A ;
  federal_av_1_A : A ;
  federalistisk_av_1_A : A ;
  federativ_av_1_A : A ;
  feg_av_1_A : A ;
  fekal_av_1_A : A ;
  felaktig_av_1_A : A ;
  felparkerbar_av_1_A : A ;
  femfaldig_av_1_A : A ;
  femflikig_av_1_A : A ;
  femgradig_av_1_A : A ;
  feminin_av_1_A : A ;
  feministisk_av_1_A : A ;
  femstaemmig_av_1_1_A : A ;
  femtonaarig_av_1_1_A : A ;
  femuddig_av_1_A : A ;
  femaarig_av_1_1_A : A ;
  fenicisk_av_1_A : A ;
  fenolisk_av_1_A : A ;
  fenomenal_av_1_A : A ;
  fenomenologisk_av_1_A : A ;
  feodal_av_1_A : A ;
  feodalistisk_av_1_A : A ;
  ferm_av_1_A : A ;
  fermenterbar_av_1_A : A ;
  fertil_av_1_A : A ;
  festlig_av_1_A : A ;
  fet_av_1_A : A ;
  feterbar_av_1_A : A ;
  fetischistisk_av_1_A : A ;
  fetthaltig_av_1_A : A ;
  fettloeslig_av_1_1_A : A ;
  fettrik_av_1_A : A ;
  fiberrik_av_1_A : A ;
  fibrig_av_1_A : A ;
  fickparkerbar_av_1_A : A ;
  fientlig_av_1_A : A ;
  fiffig_av_1_A : A ;
  figurativ_av_1_A : A ;
  figurlig_av_1_A : A ;
  figursydd_av_1_A : A ;
  fijiansk_av_1_A : A ;
  fiktiv_av_1_A : A ;
  filantropisk_av_1_A : A ;
  filerbar_av_1_A : A ;
  filharmonisk_av_1_A : A ;
  filippinsk_av_1_A : A ;
  filistroes_av_1_1_A : A ;
  filmatiserbar_av_1_A : A ;
  filmatisk_av_1_A : A ;
  filmisk_av_1_A : A ;
  filmmaessig_av_1_1_A : A ;
  filologisk_av_1_A : A ;
  filosofisk_av_1_A : A ;
  filtrerbar_av_1_A : A ;
  fin_av_1_A : A ;
  final_av_1_A : A ;
  finalklar_av_1_A : A ;
  finansiell_av_1_A : A ;
  finansierbar_av_1_A : A ;
  finanspolitisk_av_1_A : A ;
  finfin_av_1_A : A ;
  fingerbar_av_1_A : A ;
  fingerbred_av_1_A : A ;
  fingerfaerdig_av_1_1_A : A ;
  finjusterbar_av_1_A : A ;
  finkalibrig_av_1_A : A ;
  finklaedd_av_1_1_A : A ;
  finkornig_av_1_A : A ;
  finkaenslig_av_1_1_A : A ;
  finlandiserbar_av_1_A : A ;
  finlandssvensk_av_1_A : A ;
  finlaendsk_av_1_1_A : A ;
  finmaskig_av_1_A : A ;
  finmekanisk_av_1_A : A ;
  finnig_av_1_A : A ;
  finsk_ugrisk_av_1_A : A ;
  finsk_av_1_A : A ;
  finskspraakig_av_1_1_A : A ;
  fintlig_av_1_A : A ;
  finurlig_av_1_A : A ;
  fipplig_av_1_A : A ;
  fisfoernaem_av_1_1_A : A ;
  fisig_av_1_A : A ;
  fiskal_av_1_A : A ;
  fiskalisk_av_1_A : A ;
  fiskeansvarig_av_1_A : A ;
  fisklik_av_1_A : A ;
  fiskrik_av_1_A : A ;
  fissil_av_1_A : A ;
  fistuloes_av_1_1_A : A ;
  fix_av_1_A : A ;
  fixerbar_av_1_A : A ;
  fjantig_av_1_A : A ;
  fjollig_av_1_A : A ;
  fjompig_av_1_A : A ;
  fjortonaarig_av_1_1_A : A ;
  fjunig_av_1_A : A ;
  fjuttig_av_1_A : A ;
  fjaederklaedd_av_1_1_A : A ;
  fjaederlaett_av_1_1_A : A ;
  fjaellig_av_1_1_A : A ;
  fjaellik_av_1_1_A : A ;
  fjaer_av_1_1_A : A ;
  fjaerrblockerbar_av_1_1_A : A ;
  fjaeskig_av_1_1_A : A ;
  flabbig_av_1_A : A ;
  flack_av_1_A : A ;
  fladdrig_av_1_A : A ;
  flagig_av_1_A : A ;
  flamberbar_av_1_A : A ;
  flamlaendsk_av_1_1_A : A ;
  flammig_av_1_A : A ;
  flamsig_av_1_A : A ;
  flamsk_av_1_A : A ;
  flandrisk_av_1_A : A ;
  flankerbar_av_1_A : A ;
  flatterbar_av_1_A : A ;
  flaxig_av_1_A : A ;
  flegmatisk_av_1_A : A ;
  flekterbar_av_1_A : A ;
  flercellig_av_1_A : A ;
  flerdubbel_av_1_A : A ;
  flerfaldig_av_1_A : A ;
  flerspraakig_av_1_1_A : A ;
  flerstammig_av_1_A : A ;
  flerstaemmig_av_1_1_A : A ;
  flertydig_av_1_A : A ;
  fleraarig_av_1_1_A : A ;
  flexibel_av_1_A : A ;
  flickaktig_av_1_A : A ;
  flikig_av_1_A : A ;
  flimrig_av_1_A : A ;
  flink_av_1_A : A ;
  flintskallig_av_1_A : A ;
  flirtig_av_1_A : A ;
  flisig_av_1_A : A ;
  flitig_av_1_A : A ;
  flockblommig_av_1_A : A ;
  flockig_av_1_A : A ;
  florentinsk_av_1_A : A ;
  floristisk_av_1_A : A ;
  floskuloes_av_1_1_A : A ;
  flott_av_1_A : A ;
  flottig_av_1_A : A ;
  fluffig_av_1_A : A ;
  fluidiserbar_av_1_A : A ;
  flummig_av_1_A : A ;
  fluorerbar_av_1_A : A ;
  fluorhaltig_av_1_A : A ;
  fluoriderbar_av_1_A : A ;
  fluvial_av_1_A : A ;
  flygfaerdig_av_1_1_A : A ;
  flygg_av_1_A : A ;
  flyktig_av_1_A : A ;
  flyttbar_av_1_A : A ;
  flyttraett_av_1_1_A : A ;
  flaeckig_av_1_1_A : A ;
  flaeckloes_av_1_1_A : A ;
  flaeng_av_1_1_A : A ;
  flaengig_av_1_1_A : A ;
  flaerdfull_av_1_1_A : A ;
  flaerdloes_av_1_1_A : A ;
  flaeskig_av_1_1_A : A ;
  flaadig_av_1_1_A : A ;
  flaasig_av_1_1_A : A ;
  floertig_av_1_1_A : A ;
  fnasig_av_1_A : A ;
  fnissig_av_1_A : A ;
  fnittrig_av_1_A : A ;
  fnoskig_av_1_A : A ;
  foglig_av_1_A : A ;
  fokal_av_1_A : A ;
  fokuserbar_av_1_A : A ;
  folierbar_av_1_A : A ;
  folkdemokratisk_av_1_A : A ;
  folketymologisk_av_1_A : A ;
  folkhemsk_av_1_A : A ;
  folkkaer_av_1_1_A : A ;
  folklig_av_1_A : A ;
  folkloristisk_av_1_A : A ;
  folkrik_av_1_A : A ;
  folkraettslig_av_1_1_A : A ;
  folkskygg_av_1_A : A ;
  folktaet_av_1_1_A : A ;
  fonderbar_av_1_A : A ;
  fonematisk_av_1_A : A ;
  fonetisk_av_1_A : A ;
  foniatrisk_av_1_A : A ;
  fonologisk_av_1_A : A ;
  forcerbar_av_1_A : A ;
  fordringsfull_av_1_A : A ;
  fordringsloes_av_1_1_A : A ;
  forensisk_av_1_A : A ;
  formaliserbar_av_1_A : A ;
  formalistisk_av_1_A : A ;
  formbar_av_1_A : A ;
  formell_av_1_A : A ;
  formerbar_av_1_A : A ;
  formidabel_av_1_A : A ;
  formlig_av_1_A : A ;
  formloes_av_1_1_A : A ;
  formmaessig_av_1_1_A : A ;
  formrik_av_1_A : A ;
  formskoen_av_1_1_A : A ;
  formstark_av_1_A : A ;
  formulerbar_av_1_A : A ;
  forn_av_1_A : A ;
  fornegyptisk_av_1_A : A ;
  forngrekisk_av_1_A : A ;
  fornislaendsk_av_1_1_A : A ;
  fornitaliensk_av_1_A : A ;
  fornkeltisk_av_1_A : A ;
  fornnordisk_av_1_A : A ;
  fornromersk_av_1_A : A ;
  fornsvensk_av_1_A : A ;
  forskarmaessig_av_1_1_A : A ;
  forskningsmaessig_av_1_1_A : A ;
  forskningspolitisk_av_1_A : A ;
  fortfaerdig_av_1_1_A : A ;
  fortplantningsmaessig_av_1_1_A : A ;
  fosfaterbar_av_1_A : A ;
  fossil_av_1_A : A ;
  fossiliserbar_av_1_A : A ;
  fosterlaendsk_av_1_1_A : A ;
  fotbollsmaessig_av_1_1_A : A ;
  fotoelektrisk_av_1_A : A ;
  fotogenisk_av_1_A : A ;
  fotograferbar_av_1_A : A ;
  fotografisk_av_1_A : A ;
  fotogrammetrisk_av_1_A : A ;
  fotokemisk_av_1_A : A ;
  fotokopierbar_av_1_A : A ;
  fotostatkopierbar_av_1_A : A ;
  fotriktig_av_1_A : A ;
  fotraet_av_1_1_A : A ;
  fotsid_av_1_A : A ;
  fotvaenlig_av_1_1_A : A ;
  fradgig_av_1_A : A ;
  fragil_av_1_A : A ;
  fragmentarisk_av_1_A : A ;
  fragmenterbar_av_1_A : A ;
  fraktal_av_1_A : A ;
  fraktfri_av_1_A : A ;
  fraktionerbar_av_1_A : A ;
  framfusig_av_1_A : A ;
  framgaangsrik_av_1_1_A : A ;
  framkomlig_av_1_A : A ;
  framstegsvaenlig_av_1_1_A : A ;
  framtung_av_1_A : A ;
  frank_av_1_A : A ;
  frankerbar_av_1_A : A ;
  fransig_av_1_A : A ;
  fransk_av_1_A : A ;
  franskfoedd_av_1_1_A : A ;
  franskklassicistisk_av_1_A : A ;
  franskklassisk_av_1_A : A ;
  franskspraakig_av_1_1_A : A ;
  fraseologisk_av_1_A : A ;
  fraserbar_av_1_A : A ;
  frasig_av_1_A : A ;
  frasliberal_av_1_A : A ;
  frasradikal_av_1_A : A ;
  fredlig_av_1_A : A ;
  fredloes_av_1_1_A : A ;
  fredsvaenlig_av_1_1_A : A ;
  frejdig_av_1_A : A ;
  frekvensmodulerbar_av_1_A : A ;
  frekventerbar_av_1_A : A ;
  frenetisk_av_1_A : A ;
  frenologisk_av_1_A : A ;
  fribladig_av_1_A : A ;
  fridfull_av_1_A : A ;
  fridloes_av_1_1_A : A ;
  frifraesig_av_1_1_A : A ;
  friherrlig_av_1_A : A ;
  frihetlig_av_1_A : A ;
  frikativ_av_1_A : A ;
  frikostig_av_1_A : A ;
  frikyrklig_av_1_A : A ;
  frimodig_av_1_A : A ;
  frireligioes_av_1_1_A : A ;
  friserbar_av_1_A : A ;
  frisisk_av_1_A : A ;
  frisk_av_1_A : A ;
  frispraakig_av_1_1_A : A ;
  friterbar_av_1_A : A ;
  fritidspolitisk_av_1_A : A ;
  frivillig_av_1_A : A ;
  frivol_av_1_A : A ;
  frodig_av_1_A : A ;
  fronderbar_av_1_A : A ;
  frontal_av_1_A : A ;
  frosthaerdig_av_1_1_A : A ;
  frostig_av_1_A : A ;
  frostkaenslig_av_1_1_A : A ;
  frosttaalig_av_1_1_A : A ;
  frotterbar_av_1_A : A ;
  frugal_av_1_A : A ;
  fruktbar_av_1_A : A ;
  fruktig_av_1_A : A ;
  fruktloes_av_1_1_A : A ;
  frustrerbar_av_1_A : A ;
  fryntlig_av_1_A : A ;
  frystaalig_av_1_1_A : A ;
  fraeck_av_1_1_A : A ;
  fraeknig_av_1_1_A : A ;
  fraemlingsfientlig_av_1_1_A : A ;
  fraen_av_1_1_A : A ;
  fraesch_av_1_1_A : A ;
  fraesig_av_1_1_A : A ;
  fraagvis_av_1_1_A : A ;
  froejdefull_av_1_1_A : A ;
  fuktfri_av_1_A : A ;
  fukthal_av_1_A : A ;
  fuktig_av_1_A : A ;
  ful_av_1_A : A ;
  full_av_1_A : A ;
  fullfaerdig_av_1_1_A : A ;
  fullgod_av_1_A : A ;
  fullkomlig_av_1_A : A ;
  fullsatt_av_1_A : A ;
  fullskalig_av_1_A : A ;
  fullstor_av_1_A : A ;
  fullstaemmig_av_1_1_A : A ;
  fullstaendig_av_1_1_A : A ;
  fulltalig_av_1_A : A ;
  fulltonig_av_1_A : A ;
  fullvaerdig_av_1_1_A : A ;
  fulloedig_av_1_1_A : A ;
  fulsnygg_av_1_A : A ;
  fumlig_av_1_A : A ;
  fundamental_av_1_A : A ;
  fundamentalistisk_av_1_A : A ;
  funktionalistisk_av_1_A : A ;
  funktionell_av_1_A : A ;
  funktionsduglig_av_1_A : A ;
  funktionsmaessig_av_1_1_A : A ;
  funktionsoduglig_av_1_A : A ;
  furnerbar_av_1_A : A ;
  furstlig_av_1_A : A ;
  fusionerbar_av_1_A : A ;
  futil_av_1_A : A ;
  futtig_av_1_A : A ;
  futural_av_1_A : A ;
  futuristisk_av_1_A : A ;
  futurologisk_av_1_A : A ;
  fyllig_av_1_A : A ;
  fylogenetisk_av_1_A : A ;
  fyndig_av_1_A : A ;
  fyraaarig_av_1_1_A : A ;
  fyrcylindrig_av_1_A : A ;
  fyrdubbel_av_1_A : A ;
  fyrfaldig_av_1_A : A ;
  fyrfilig_av_1_A : A ;
  fyrgradig_av_1_A : A ;
  fyrhjulig_av_1_A : A ;
  fyrhaendig_av_1_1_A : A ;
  fyrkantig_av_1_A : A ;
  fyrkantig_av_2_A : A ;
  fyrmotorig_av_1_A : A ;
  fyrsiffrig_av_1_A : A ;
  fyrsitsig_av_1_A : A ;
  fyrstjaernig_av_1_1_A : A ;
  fyrtalig_av_1_A : A ;
  fyrtiotalistisk_av_1_A : A ;
  fyrvaeldig_av_1_1_A : A ;
  fysikalisk_av_1_A : A ;
  fysiljerbar_av_1_A : A ;
  fysiokratisk_av_1_A : A ;
  fysiologisk_av_1_A : A ;
  fysisk_av_1_A : A ;
  faeaktig_av_1_1_A : A ;
  faellbar_av_1_1_A : A ;
  faeltmaessig_av_1_1_A : A ;
  faerdig_av_1_1_A : A ;
  faergbestaendig_av_1_1_A : A ;
  faergglad_av_1_1_A : A ;
  faergkaenslig_av_1_1_A : A ;
  faergloes_av_1_1_A : A ;
  faergmaessig_av_1_1_A : A ;
  faergrik_av_1_1_A : A ;
  faergstark_av_1_1_A : A ;
  faerm_av_1_1_A : A ;
  faerserbar_av_1_1_A : A ;
  faersk_av_1_1_A : A ;
  faeroeisk_av_1_1_A : A ;
  faafaeng_av_1_1_A : A ;
  faafaenglig_av_1_1_A : A ;
  faagelkunnig_av_1_1_A : A ;
  faakunnig_av_1_1_A : A ;
  faanig_av_1_1_A : A ;
  faaordig_av_1_1_A : A ;
  faaraktig_av_1_1_A : A ;
  faatalig_av_1_1_A : A ;
  faavitsk_av_1_1_A : A ;
  foedd_av_1_1_A : A ;
  foeljdenlig_av_1_1_A : A ;
  foeljdriktig_av_1_1_A : A ;
  foeljetongsmaessig_av_1_1_A : A ;
  foeraktfull_av_1_1_A : A ;
  foeraktlig_av_1_1_A : A ;
  foerannonserbar_av_1_1_A : A ;
  foerarglig_av_1_1_A : A ;
  foerarloes_av_1_1_A : A ;
  foerbehaallsloes_av_1_1_A : A ;
  foerberedd_av_1_1_A : A ;
  foerbindlig_av_1_1_A : A ;
  foerbaetterlig_av_1_1_A : A ;
  foercolumbiansk_av_1_1_A : A ;
  foercolumbisk_av_1_1_A : A ;
  foerdelaktig_av_1_1_A : A ;
  foerdelningsmaessig_av_1_1_A : A ;
  foerdelningspolitisk_av_1_1_A : A ;
  foerdomsfull_av_1_1_A : A ;
  foerdragsmaessig_av_1_1_A : A ;
  foerdaervlig_av_1_1_A : A ;
  foerdoemlig_av_1_1_A : A ;
  foerebildlig_av_1_1_A : A ;
  foeredoemlig_av_1_1_A : A ;
  foerefintlig_av_1_1_A : A ;
  foereningsmaessig_av_1_1_A : A ;
  foerenlig_av_1_1_A : A ;
  foeretagsekonomisk_av_1_1_A : A ;
  foeretagsmaessig_av_1_1_A : A ;
  foeretagstaet_av_1_1_A : A ;
  foerfattningsmaessig_av_1_1_A : A ;
  foerfattningsstridig_av_1_1_A : A ;
  foerfaerlig_av_1_1_A : A ;
  foerfoerisk_av_1_1_A : A ;
  foergriplig_av_1_1_A : A ;
  foergaenglig_av_1_1_A : A ;
  foerhandlingsbar_av_1_1_A : A ;
  foerhandlingsmaessig_av_1_1_A : A ;
  foerhatlig_av_1_1_A : A ;
  foerhistorisk_av_1_1_A : A ;
  foerhoppningsfull_av_1_1_A : A ;
  foerkastlig_av_1_1_A : A ;
  foerklarlig_av_1_1_A : A ;
  foerklaedd_av_1_1_A : A ;
  foerlagsmaessig_av_1_1_A : A ;
  foerlig_av_1_1_A : A ;
  foerlustig_av_1_1_A : A ;
  foerlustrik_av_1_1_A : A ;
  foerlaatlig_av_1_1_A : A ;
  foermodern_av_1_1_A : A ;
  foermyndaraktig_av_1_1_A : A ;
  foermaanlig_av_1_1_A : A ;
  foernimbar_av_1_1_A : A ;
  foernuftig_av_1_1_A : A ;
  foernuftsloes_av_1_1_A : A ;
  foernuftsmaessig_av_1_1_A : A ;
  foernuftsstridig_av_1_1_A : A ;
  foernuftsvidrig_av_1_1_A : A ;
  foernumstig_av_1_1_A : A ;
  foernybar_av_1_1_A : A ;
  foernyelsebar_av_1_1_A : A ;
  foernaemlig_av_1_1_A : A ;
  foerromantisk_av_1_1_A : A ;
  foerromersk_av_1_1_A : A ;
  foerraedisk_av_1_1_A : A ;
  foersakelsefull_av_1_1_A : A ;
  foersiktig_av_1_1_A : A ;
  foerskotterbar_av_1_1_A : A ;
  foerskraecklig_av_1_1_A : A ;
  foersmaedlig_av_1_1_A : A ;
  foersonlig_av_1_1_A : A ;
  foerstfoedd_av_1_1_A : A ;
  foerstklassig_av_1_1_A : A ;
  foerstroedd_av_1_1_A : A ;
  foerstaaelig_av_1_1_A : A ;
  foerstaandig_av_1_1_A : A ;
  foerstaandsmaessig_av_1_1_A : A ;
  foersumbar_av_1_1_A : A ;
  foersumlig_av_1_1_A : A ;
  foersvarbar_av_1_1_A : A ;
  foersvarlig_av_1_1_A : A ;
  foersvarsloes_av_1_1_A : A ;
  foersvarsmaessig_av_1_1_A : A ;
  foersvarspolitisk_av_1_1_A : A ;
  foersaekringsmaessig_av_1_1_A : A ;
  foersaeljningsmaessig_av_1_1_A : A ;
  foersaatlig_av_1_1_A : A ;
  foersoerjningsmaessig_av_1_1_A : A ;
  foersoerjningspolitisk_av_1_1_A : A ;
  foerteknisk_av_1_1_A : A ;
  foertidspensionerbar_av_1_1_A : A ;
  foertjaenstfull_av_1_1_A : A ;
  foertretlig_av_1_1_A : A ;
  foertroendefull_av_1_1_A : A ;
  foertroendemaessig_av_1_1_A : A ;
  foertrolig_av_1_1_A : A ;
  foertraefflig_av_1_1_A : A ;
  foertroestansfull_av_1_1_A : A ;
  foerunderlig_av_1_1_A : A ;
  foerutsaegbar_av_1_1_A : A ;
  foerutsaettningsloes_av_1_1_A : A ;
  foervaltningsmaessig_av_1_1_A : A ;
  foervaentansfull_av_1_1_A : A ;
  foervaentningsfull_av_1_1_A : A ;
  foervaervsmaessig_av_1_1_A : A ;
  foeraektenskaplig_av_1_1_A : A ;
  foeraeldraledig_av_1_1_A : A ;
  foeraeldraloes_av_1_1_A : A ;
  foeraenderlig_av_1_1_A : A ;
  gabonesisk_av_1_A : A ;
  gaddloes_av_1_1_A : A ;
  gaelisk_av_1_A : A ;
  gaggig_av_1_A : A ;
  gagnelig_av_1_A : A ;
  gagnerik_av_1_A : A ;
  gagnloes_av_1_1_A : A ;
  gagnrik_av_1_A : A ;
  galaktisk_av_1_A : A ;
  galicisk_av_1_A : A ;
  gallerfoersedd_av_1_1_A : A ;
  galliserbar_av_1_A : A ;
  gallisk_av_1_A : A ;
  gallsjuk_av_1_A : A ;
  galoscherbar_av_1_A : A ;
  galvaniserbar_av_1_A : A ;
  galvanisk_av_1_A : A ;
  gambisk_av_1_A : A ;
  gammalkyrklig_av_1_A : A ;
  gammalmodig_av_1_A : A ;
  gammaltestamentlig_av_1_A : A ;
  gangrenoes_av_1_1_A : A ;
  gapig_av_1_A : A ;
  garagerbar_av_1_A : A ;
  garanterbar_av_1_A : A ;
  garderbar_av_1_A : A ;
  garderobsmaessig_av_1_1_A : A ;
  garnerbar_av_1_A : A ;
  garnisonerbar_av_1_A : A ;
  garrotterbar_av_1_A : A ;
  gasformig_av_1_A : A ;
  gasrik_av_1_A : A ;
  gassig_av_1_A : A ;
  gastrisk_av_1_A : A ;
  gastronomisk_av_1_A : A ;
  gastroskoperbar_av_1_A : A ;
  gauffrerbar_av_1_A : A ;
  gaullistisk_av_1_A : A ;
  gay_av_1_A : A ;
  geggig_av_1_A : A ;
  gelatinerbar_av_1_A : A ;
  gelatinoes_av_1_1_A : A ;
  geleig_av_1_A : A ;
  geminerbar_av_1_A : A ;
  gemytlig_av_1_A : A ;
  gen_av_1_A : A ;
  genealogisk_av_1_A : A ;
  generaliserbar_av_1_A : A ;
  generalplanemaessig_av_1_1_A : A ;
  generationsmaessig_av_1_1_A : A ;
  generativ_av_1_A : A ;
  generbar_av_1_A : A ;
  generell_av_1_A : A ;
  genererbar_av_1_A : A ;
  generisk_av_1_A : A ;
  generoes_av_1_1_A : A ;
  genetisk_av_1_A : A ;
  gengaangarlik_av_1_1_A : A ;
  genial_av_1_A : A ;
  genialisk_av_1_A : A ;
  genmanipulerbar_av_1_A : A ;
  genombloet_av_1_1_A : A ;
  genomfoerbar_av_1_1_A : A ;
  genomgod_av_1_A : A ;
  genomskinlig_av_1_A : A ;
  genomslaepplig_av_1_1_A : A ;
  genomsnittlig_av_1_A : A ;
  genomsnaell_av_1_1_A : A ;
  genomsur_av_1_A : A ;
  genomsvettig_av_1_A : A ;
  genomtraenglig_av_1_1_A : A ;
  genomusel_av_1_A : A ;
  genomvarm_av_1_A : A ;
  genomvaat_av_1_1_A : A ;
  genremaessig_av_1_1_A : A ;
  genstridig_av_1_A : A ;
  genstraevig_av_1_1_A : A ;
  genstoertig_av_1_1_A : A ;
  gentil_av_1_A : A ;
  gentlemannamaessig_av_1_1_A : A ;
  genuin_av_1_A : A ;
  genusmaessig_av_1_1_A : A ;
  geocentrisk_av_1_A : A ;
  geodetisk_av_1_A : A ;
  geografisk_av_1_A : A ;
  geokemisk_av_1_A : A ;
  geokronologisk_av_1_A : A ;
  geologisk_av_1_A : A ;
  geometriserbar_av_1_A : A ;
  geometrisk_av_1_A : A ;
  geomorfologisk_av_1_A : A ;
  geopolitisk_av_1_A : A ;
  georgiansk_av_1_A : A ;
  georgisk_av_1_A : A ;
  geostationaer_av_1_1_A : A ;
  geotermisk_av_1_A : A ;
  geovetenskaplig_av_1_A : A ;
  geriatrisk_av_1_A : A ;
  germaniserbar_av_1_A : A ;
  germanistisk_av_1_A : A ;
  germansk_av_1_A : A ;
  gerontologisk_av_1_A : A ;
  gestaltloes_av_1_1_A : A ;
  gestaltningsmaessig_av_1_1_A : A ;
  ghanansk_av_1_A : A ;
  ghanesisk_av_1_A : A ;
  giftgroen_av_1_1_A : A ;
  giftig_av_1_A : A ;
  gigantisk_av_1_A : A ;
  giljotinerbar_av_1_A : A ;
  gill_av_1_A : A ;
  giltig_av_1_A : A ;
  gin_av_1_A : A ;
  girerbar_av_1_A : A ;
  girig_av_1_A : A ;
  gjutbar_av_1_A : A ;
  glacial_av_1_A : A ;
  glacifluvial_av_1_A : A ;
  glaciologisk_av_1_A : A ;
  glad_av_1_A : A ;
  gladelig_av_1_A : A ;
  gladlig_av_1_A : A ;
  glagolitisk_av_1_A : A ;
  glammig_av_1_A : A ;
  glamoriserbar_av_1_A : A ;
  glamoroes_av_1_1_A : A ;
  glamouriserbar_av_1_A : A ;
  glamouroes_av_1_1_A : A ;
  glanduloes_av_1_1_A : A ;
  glansfull_av_1_A : A ;
  glansig_av_1_A : A ;
  glansk_av_1_A : A ;
  glansloes_av_1_1_A : A ;
  glapp_av_1_A : A ;
  glaserbar_av_1_A : A ;
  glashal_av_1_A : A ;
  glasig_av_1_A : A ;
  glasiologisk_av_1_A : A ;
  glasklar_av_1_A : A ;
  glassig_av_1_A : A ;
  glatt_av_1_A : A ;
  gles_av_1_A : A ;
  glitterfin_av_1_A : A ;
  glitterglad_av_1_A : A ;
  glitterprydd_av_1_A : A ;
  glittrig_av_1_A : A ;
  global_av_1_A : A ;
  glorifierbar_av_1_A : A ;
  glorioes_av_1_1_A : A ;
  glosig_av_1_A : A ;
  glupsk_av_1_A : A ;
  glutinoes_av_1_1_A : A ;
  glyttig_av_1_A : A ;
  glaedjefull_av_1_1_A : A ;
  glaedjeloes_av_1_1_A : A ;
  glaedjerusig_av_1_1_A : A ;
  glaettig_av_1_1_A : A ;
  glaamig_av_1_1_A : A ;
  gloedhet_av_1_1_A : A ;
  gloedmjuk_av_1_1_A : A ;
  gloedvarm_av_1_1_A : A ;
  gloemsk_av_1_1_A : A ;
  gnatig_av_1_A : A ;
  gnetig_av_1_A : A ;
  gnidig_av_1_A : A ;
  gnistrig_av_1_A : A ;
  gnaellig_av_1_1_A : A ;
  gobelaengklaedd_av_1_1_A : A ;
  godhetsfull_av_1_A : A ;
  godhaellig_av_1_1_A : A ;
  godmodig_av_1_A : A ;
  godtagbar_av_1_A : A ;
  godtycklig_av_1_A : A ;
  godvillig_av_1_A : A ;
  goffrerbar_av_1_A : A ;
  golfmaessig_av_1_1_A : A ;
  golvkall_av_1_A : A ;
  googlingsbar_av_1_A : A ;
  gosig_av_1_A : A ;
  gotisk_av_1_A : A ;
  gotlaendsk_av_1_1_A : A ;
  gotsk_av_1_A : A ;
  gouterbar_av_1_A : A ;
  gracil_av_1_A : A ;
  gracioes_av_1_1_A : A ;
  graderbar_av_1_A : A ;
  graduell_av_1_A : A ;
  graduerbar_av_1_A : A ;
  gradvis_av_1_A : A ;
  grafematisk_av_1_A : A ;
  grafisk_av_1_A : A ;
  grafiterbar_av_1_A : A ;
  grafonomisk_av_1_A : A ;
  grammatikalisk_av_1_A : A ;
  grammatisk_av_1_A : A ;
  grandios_av_1_A : A ;
  granulerbar_av_1_A : A ;
  gratinerbar_av_1_A : A ;
  gratis_av_1_A : A ;
  gratulerbar_av_1_A : A ;
  grav_av_1_A : A ;
  gravallvarlig_av_1_A : A ;
  graverbar_av_1_A : A ;
  gravitetisk_av_1_A : A ;
  gravlik_av_1_A : A ;
  gredelin_av_1_A : A ;
  gregoriansk_av_1_A : A ;
  grekisk_katolsk_av_1_A : A ;
  grekisk_ortodox_av_1_A : A ;
  grekisk_romersk_av_1_A : A ;
  grekisk_av_1_A : A ;
  grenadisk_av_1_A : A ;
  grenig_av_1_A : A ;
  greppbar_av_1_A : A ;
  greppbar_av_2_A : A ;
  greppriktig_av_1_A : A ;
  greppvaenlig_av_1_1_A : A ;
  grevlig_av_1_A : A ;
  griljerbar_av_1_A : A ;
  grimerbar_av_1_A : A ;
  grinig_av_1_A : A ;
  gripbar_av_1_A : A ;
  grisig_av_1_A : A ;
  grisskaer_av_1_1_A : A ;
  gropig_av_1_A : A ;
  grotesk_av_1_A : A ;
  grovkalibrig_av_1_A : A ;
  grovkornig_av_1_A : A ;
  grovplanerbar_av_1_A : A ;
  grovsorterbar_av_1_A : A ;
  grumlig_av_1_A : A ;
  grumsig_av_1_A : A ;
  grunderbar_av_1_A : A ;
  grundfalsk_av_1_A : A ;
  grundlagsmaessig_av_1_1_A : A ;
  grundlig_av_1_A : A ;
  grundloes_av_1_1_A : A ;
  gruppdynamisk_av_1_A : A ;
  grupperbar_av_1_A : A ;
  grusig_av_1_A : A ;
  gruvlig_av_1_A : A ;
  grynig_av_1_A : A ;
  grynpipig_av_1_A : A ;
  graeddgul_av_1_1_A : A ;
  graeddig_av_1_1_A : A ;
  graeddvit_av_1_1_A : A ;
  graelaktig_av_1_1_A : A ;
  graelig_av_1_1_A : A ;
  graell_av_1_1_A : A ;
  graelsjuk_av_1_1_A : A ;
  graensloes_av_1_1_A : A ;
  graesgroen_av_1_1_A : A ;
  graeslig_av_1_1_A : A ;
  graaaktig_av_1_1_A : A ;
  graablek_av_1_1_A : A ;
  graabrun_av_1_1_A : A ;
  graadaskig_av_1_1_A : A ;
  graaflaeckig_av_1_1_A : A ;
  graagroen_av_1_1_A : A ;
  graagul_av_1_1_A : A ;
  graahaarig_av_1_1_A : A ;
  graakall_av_1_1_A : A ;
  graamurrig_av_1_1_A : A ;
  graaregnig_av_1_1_A : A ;
  graaskimlig_av_1_1_A : A ;
  graaskaeckig_av_1_1_A : A ;
  graastrimmig_av_1_1_A : A ;
  graatfaerdig_av_1_1_A : A ;
  graavit_av_1_1_A : A ;
  groen_av_1_1_A : A ;
  groenaktig_av_1_1_A : A ;
  groenblek_av_1_1_A : A ;
  groengul_av_1_1_A : A ;
  groenkoepingsmaessig_av_1_1_A : A ;
  groenlaendsk_av_1_1_A : A ;
  groenmoerk_av_1_1_A : A ;
  groenaadrig_av_1_1_A : A ;
  groetig_av_1_1_A : A ;
  groetmyndig_av_1_1_A : A ;
  guatemalansk_av_1_A : A ;
  guatemaltekisk_av_1_A : A ;
  guayansk_av_1_A : A ;
  gubbig_av_1_A : A ;
  gubbsjuk_av_1_A : A ;
  gudaktig_av_1_A : A ;
  gudelig_av_1_A : A ;
  gudfruktig_av_1_A : A ;
  gudlig_av_1_A : A ;
  gudloes_av_1_1_A : A ;
  gudomlig_av_1_A : A ;
  gudsnaadelig_av_1_1_A : A ;
  gudsnaadlig_av_1_1_A : A ;
  gudstjaenstlig_av_1_1_A : A ;
  guineansk_av_1_A : A ;
  gul_av_1_A : A ;
  gulaktig_av_1_A : A ;
  gulblek_av_1_A : A ;
  gulblommig_av_1_A : A ;
  gulbrun_av_1_A : A ;
  guldbesatt_av_1_A : A ;
  guldgul_av_1_A : A ;
  guldsmidd_av_1_A : A ;
  gulgroen_av_1_1_A : A ;
  gullig_av_1_A : A ;
  gulrutig_av_1_A : A ;
  gulroed_av_1_1_A : A ;
  gulsiktig_av_1_A : A ;
  gulvit_av_1_A : A ;
  gummerbar_av_1_A : A ;
  gummibeklaedd_av_1_1_A : A ;
  gummoes_av_1_1_A : A ;
  gungig_av_1_A : A ;
  gunstig_av_1_A : A ;
  guppig_av_1_A : A ;
  gustaviansk_av_1_A : A ;
  guterbar_av_1_A : A ;
  gutnisk_av_1_A : A ;
  guttural_av_1_A : A ;
  guyanansk_av_1_A : A ;
  gyllenbrun_av_1_A : A ;
  gymnasial_av_1_A : A ;
  gymnastiserbar_av_1_A : A ;
  gymnastisk_av_1_A : A ;
  gymnisk_av_1_A : A ;
  gynekologisk_av_1_A : A ;
  gyttjig_av_1_A : A ;
  gyttrig_av_1_A : A ;
  gaeldfri_av_1_1_A : A ;
  gaelisk_av_1_1_A : A ;
  gaell_av_1_1_A : A ;
  gaenglig_av_1_1_A : A ;
  gaespig_av_1_1_A : A ;
  gaestriklaendsk_av_1_1_A : A ;
  gaestrisk_av_1_1_A : A ;
  gaestvaenlig_av_1_1_A : A ;
  gaangbar_av_1_1_A : A ;
  gaangjaernsfoersedd_av_1_1_A : A ;
  gaapaaig_av_1_1_A : A ;
  gaatfull_av_1_1_A : A ;
  goemfroeig_av_1_1_A : A ;
  goerlig_av_1_1_A : A ;
  goeteborgsk_av_1_1_A : A ;
  goeticistisk_av_1_1_A : A ;
  goetisk_av_1_1_A : A ;
  habil_av_1_A : A ;
  habituell_av_1_A : A ;
  habsburgsk_av_1_A : A ;
  hackig_av_1_A : A ;
  hafsig_av_1_A : A ;
  hagiografisk_av_1_A : A ;
  haitisk_av_1_A : A ;
  hal_av_1_A : A ;
  halkig_av_1_A : A ;
  hallucinatorisk_av_1_A : A ;
  hallucinerbar_av_1_A : A ;
  hallaendsk_av_1_1_A : A ;
  halmgul_av_1_A : A ;
  halsstarrig_av_1_A : A ;
  haltloes_av_1_1_A : A ;
  halv_av_1_A : A ;
  halvautomatisk_av_1_A : A ;
  halvblank_av_1_A : A ;
  halvdaglig_av_1_A : A ;
  halvdan_av_1_A : A ;
  halvdunkel_av_1_A : A ;
  halvdoed_av_1_1_A : A ;
  halverbar_av_1_A : A ;
  halvfet_av_1_A : A ;
  halvfransk_av_1_A : A ;
  halvfull_av_1_A : A ;
  halvfaerdig_av_1_1_A : A ;
  halvgenomskinlig_av_1_A : A ;
  halvhoeg_av_1_1_A : A ;
  halvklar_av_1_A : A ;
  halvklotformig_av_1_A : A ;
  halvmetallisk_av_1_A : A ;
  halvmeterbred_av_1_A : A ;
  halvmodern_av_1_A : A ;
  halvmaanformig_av_1_1_A : A ;
  halvmoerk_av_1_1_A : A ;
  halvofficiell_av_1_A : A ;
  halvspraakig_av_1_1_A : A ;
  halvstatlig_av_1_A : A ;
  halvstor_av_1_A : A ;
  halvsur_av_1_A : A ;
  halvsvensk_av_1_A : A ;
  halvtokig_av_1_A : A ;
  halvtorr_av_1_A : A ;
  halvaarsvis_av_1_1_A : A ;
  hamitisk_av_1_A : A ;
  handboksmaessig_av_1_1_A : A ;
  handbollsmaessig_av_1_1_A : A ;
  handelsmaessig_av_1_1_A : A ;
  handelspolitisk_av_1_A : A ;
  handflikig_av_1_A : A ;
  handgriplig_av_1_A : A ;
  handikappolitisk_av_1_A : A ;
  handlingskraftig_av_1_A : A ;
  handlingsmaessig_av_1_1_A : A ;
  handsbred_av_1_A : A ;
  handskbeklaedd_av_1_1_A : A ;
  handsydd_av_1_A : A ;
  hanglig_av_1_A : A ;
  hanlig_av_1_A : A ;
  hanterbar_av_1_A : A ;
  hanterlig_av_1_A : A ;
  hantverksmaessig_av_1_1_A : A ;
  harangerbar_av_1_A : A ;
  harig_av_1_A : A ;
  harmfull_av_1_A : A ;
  harmlig_av_1_A : A ;
  harmloes_av_1_1_A : A ;
  harmoniserbar_av_1_A : A ;
  harmonisk_av_1_A : A ;
  harpunerbar_av_1_A : A ;
  hasarderbar_av_1_A : A ;
  haschhoeg_av_1_1_A : A ;
  hastig_av_1_A : A ;
  hatfull_av_1_A : A ;
  hatisk_av_1_A : A ;
  hattig_av_1_A : A ;
  havererbar_av_1_A : A ;
  hawaiiansk_av_1_A : A ;
  hawaiisk_av_1_A : A ;
  hebreisk_av_1_A : A ;
  hederlig_av_1_A : A ;
  hednisk_av_1_A : A ;
  hedonistisk_av_1_A : A ;
  hejdloes_av_1_1_A : A ;
  hejig_av_1_A : A ;
  hektisk_av_1_A : A ;
  hektograferbar_av_1_A : A ;
  hel_av_1_A : A ;
  helautomatisk_av_1_A : A ;
  heldaglig_av_1_A : A ;
  helfet_av_1_A : A ;
  helfransk_av_1_A : A ;
  helgarderbar_av_1_A : A ;
  helig_av_1_A : A ;
  helinackorderbar_av_1_A : A ;
  heliocentrisk_av_1_A : A ;
  heliofob_av_1_A : A ;
  hellenistisk_av_1_A : A ;
  hellensk_av_1_A : A ;
  helnykter_av_1_A : A ;
  helroed_av_1_1_A : A ;
  helstatlig_av_1_A : A ;
  helvetisk_av_1_A : A ;
  helvit_av_1_A : A ;
  hemhoerig_av_1_1_A : A ;
  hemkaer_av_1_1_A : A ;
  hemlig_av_1_A : A ;
  hemlighetsfull_av_1_A : A ;
  hemloes_av_1_1_A : A ;
  hemmahoerig_av_1_1_A : A ;
  hemmastadd_av_1_A : A ;
  hemsk_av_1_A : A ;
  hemtam_av_1_A : A ;
  hemtrevlig_av_1_A : A ;
  heraldisk_av_1_A : A ;
  hereditaer_av_1_1_A : A ;
  heretisk_av_1_A : A ;
  herkulisk_av_1_A : A ;
  hermeneutisk_av_1_A : A ;
  hermetisk_av_1_A : A ;
  heroiserbar_av_1_A : A ;
  heroisk_av_1_A : A ;
  herostratisk_av_1_A : A ;
  herreloes_av_1_1_A : A ;
  herrnhutistisk_av_1_A : A ;
  hertiglig_av_1_A : A ;
  hes_av_1_A : A ;
  het_av_1_A : A ;
  heterodox_av_1_A : A ;
  heteroklitisk_av_1_A : A ;
  heteronormativ_av_1_A : A ;
  heterosexuell_av_1_A : A ;
  heterotematisk_av_1_A : A ;
  hetsig_av_1_A : A ;
  hetspolitisk_av_1_A : A ;
  hettitisk_av_1_A : A ;
  heuristisk_av_1_A : A ;
  hierarkisk_av_1_A : A ;
  hieratisk_av_1_A : A ;
  himmelsk_av_1_A : A ;
  himmelsvid_av_1_A : A ;
  hinderlig_av_1_A : A ;
  hinderloes_av_1_1_A : A ;
  hindersloes_av_1_1_A : A ;
  hinduisk_av_1_A : A ;
  hinduistisk_av_1_A : A ;
  hipp_av_1_A : A ;
  hippologisk_av_1_A : A ;
  hiskelig_av_1_A : A ;
  hisklig_av_1_A : A ;
  hispig_av_1_A : A ;
  historicistisk_av_1_A : A ;
  historieloes_av_1_1_A : A ;
  historierbar_av_1_A : A ;
  historiserbar_av_1_A : A ;
  historisk_av_1_A : A ;
  hitmaessig_av_1_1_A : A ;
  hivpositiv_av_1_A : A ;
  hjaelplig_av_1_1_A : A ;
  hjaelploes_av_1_1_A : A ;
  hjaeltemodig_av_1_1_A : A ;
  hjaerndoed_av_1_1_A : A ;
  hjaertegod_av_1_1_A : A ;
  hjaertevarm_av_1_1_A : A ;
  hjaertformig_av_1_1_A : A ;
  hjaertinnerlig_av_1_1_A : A ;
  hjaertlig_av_1_1_A : A ;
  hjaertloes_av_1_1_A : A ;
  hjaertsjuk_av_1_1_A : A ;
  hjaertaengslig_av_1_1_A : A ;
  hobbymaessig_av_1_1_A : A ;
  hockeymaessig_av_1_1_A : A ;
  holistisk_av_1_A : A ;
  hollaendsk_av_1_1_A : A ;
  holograferbar_av_1_A : A ;
  homeopatisk_av_1_A : A ;
  homerisk_av_1_A : A ;
  homiletisk_av_1_A : A ;
  homofon_av_1_A : A ;
  homogeniserbar_av_1_A : A ;
  homograf_av_1_A : A ;
  homolog_av_1_A : A ;
  homonym_av_1_A : A ;
  homosexuell_av_1_A : A ;
  honduransk_av_1_A : A ;
  honlig_av_1_A : A ;
  honnett_av_1_A : A ;
  honorerbar_av_1_A : A ;
  honoraer_av_1_1_A : A ;
  honungsgul_av_1_A : A ;
  hopfaellbar_av_1_1_A : A ;
  hoppfull_av_1_A : A ;
  hoppig_av_1_A : A ;
  hopploes_av_1_1_A : A ;
  hopskjutbar_av_1_A : A ;
  hopsnodd_av_1_A : A ;
  hoptryckbar_av_1_A : A ;
  horisontal_av_1_A : A ;
  horisontell_av_1_A : A ;
  hormonell_av_1_A : A ;
  hornloes_av_1_1_A : A ;
  horribel_av_1_A : A ;
  hospitaliserbar_av_1_A : A ;
  hostig_av_1_A : A ;
  hotfull_av_1_A : A ;
  hottentotsk_av_1_A : A ;
  hovmannamaessig_av_1_1_A : A ;
  hudloes_av_1_1_A : A ;
  hudvaenlig_av_1_1_A : A ;
  hullingfoersedd_av_1_1_A : A ;
  human_av_1_A : A ;
  humanekologisk_av_1_A : A ;
  humaniserbar_av_1_A : A ;
  humanistisk_av_1_A : A ;
  humanitaer_av_1_1_A : A ;
  humoristisk_av_1_A : A ;
  humushaltig_av_1_A : A ;
  humoermaessig_av_1_1_A : A ;
  hundraprocentig_av_1_A : A ;
  hundraaarig_av_1_1_A : A ;
  hundsfotterbar_av_1_A : A ;
  hungrig_av_1_A : A ;
  hurtfrisk_av_1_A : A ;
  hurtig_av_1_A : A ;
  huserbar_av_1_A : A ;
  huslig_av_1_A : A ;
  husvill_av_1_A : A ;
  hutloes_av_1_1_A : A ;
  huvudansvarig_av_1_A : A ;
  huvudloes_av_1_1_A : A ;
  huvudsaklig_av_1_A : A ;
  hybridiserbar_av_1_A : A ;
  hydraulisk_av_1_A : A ;
  hydrerbar_av_1_A : A ;
  hydrodynamisk_av_1_A : A ;
  hydrofob_av_1_A : A ;
  hydrologisk_av_1_A : A ;
  hydrostatisk_av_1_A : A ;
  hygglig_av_1_A : A ;
  hygienisk_av_1_A : A ;
  hygroskopisk_av_1_A : A ;
  hyperaktiv_av_1_A : A ;
  hyperbolisk_av_1_A : A ;
  hyperkatalektisk_av_1_A : A ;
  hyperkaenslig_av_1_1_A : A ;
  hypermodern_av_1_A : A ;
  hypnotiserbar_av_1_A : A ;
  hypnotisk_av_1_A : A ;
  hypokondrisk_av_1_A : A ;
  hypokritisk_av_1_A : A ;
  hypomanisk_av_1_A : A ;
  hypotaktisk_av_1_A : A ;
  hypotetisk_av_1_A : A ;
  hypotiserbar_av_1_A : A ;
  hysbar_av_1_A : A ;
  hysterisk_av_1_A : A ;
  haedisk_av_1_1_A : A ;
  haeftig_av_1_1_A : A ;
  haelsingsk_av_1_1_A : A ;
  haelsofarlig_av_1_1_A : A ;
  haelsomaessig_av_1_1_A : A ;
  haelsopolitisk_av_1_1_A : A ;
  haelsovaadlig_av_1_1_A : A ;
  haemndgirig_av_1_1_A : A ;
  haemningsloes_av_1_1_A : A ;
  haendelsefattig_av_1_1_A : A ;
  haendelseloes_av_1_1_A : A ;
  haendelserik_av_1_1_A : A ;
  haendig_av_1_1_A : A ;
  haengfaerdig_av_1_1_A : A ;
  haengig_av_1_1_A : A ;
  haengsjuk_av_1_1_A : A ;
  haensynsfull_av_1_1_A : A ;
  haensynsloes_av_1_1_A : A ;
  haerbaergerbar_av_1_1_A : A ;
  haerdig_av_1_1_A : A ;
  haerjedalsk_av_1_1_A : A ;
  haerlig_av_1_1_A : A ;
  haetsk_av_1_1_A : A ;
  haagloes_av_1_1_A : A ;
  haalig_av_1_1_A : A ;
  haallbar_av_1_1_A : A ;
  haallningsloes_av_1_1_A : A ;
  haanfull_av_1_1_A : A ;
  haardfoer_av_1_1_A : A ;
  haardvarumaessig_av_1_1_A : A ;
  haarfin_av_1_1_A : A ;
  haarig_av_1_1_A : A ;
  haarloes_av_1_1_A : A ;
  hoegaktiv_av_1_1_A : A ;
  hoegaktningsfull_av_1_1_A : A ;
  hoegaktuell_av_1_1_A : A ;
  hoegborgerlig_av_1_1_A : A ;
  hoegeffektiv_av_1_1_A : A ;
  hoegerextrem_av_1_1_A : A ;
  hoegerextremistisk_av_1_1_A : A ;
  hoegernationalistisk_av_1_1_A : A ;
  hoegerpolitisk_av_1_1_A : A ;
  hoegerpopulistisk_av_1_1_A : A ;
  hoegexplosiv_av_1_1_A : A ;
  hoegfaerdig_av_1_1_A : A ;
  hoegfoernaem_av_1_1_A : A ;
  hoeggradig_av_1_1_A : A ;
  hoegklassig_av_1_1_A : A ;
  hoegkyrklig_av_1_1_A : A ;
  hoegljudd_av_1_1_A : A ;
  hoegmodig_av_1_1_A : A ;
  hoegmolekylaer_av_1_1_A : A ;
  hoegoktanig_av_1_1_A : A ;
  hoegpatriotisk_av_1_1_A : A ;
  hoegrestaandsmaessig_av_1_1_A : A ;
  hoegromantisk_av_1_1_A : A ;
  hoegroed_av_1_1_A : A ;
  hoegskolemaessig_av_1_1_A : A ;
  hoegteknologisk_av_1_1_A : A ;
  hoegtidlig_av_1_1_A : A ;
  hoegtysk_av_1_1_A : A ;
  hoegvaerdig_av_1_1_A : A ;
  hoegvoerdig_av_1_1_A : A ;
  hoegoensklig_av_1_1_A : A ;
  hoejdmaessig_av_1_1_A : A ;
  hoensig_av_1_1_A : A ;
  hoerbar_av_1_1_A : A ;
  hoestlig_av_1_1_A : A ;
  hoestloevsgul_av_1_1_A : A ;
  hoeststormig_av_1_1_A : A ;
  hoevisk_av_1_1_A : A ;
  hoevlig_av_1_1_A : A ;
  iberisk_av_1_A : A ;
  ibero_amerikansk_av_1_A : A ;
  icke_darwinistisk_av_1_A : A ;
  icke_euklidisk_av_1_A : A ;
  icke_individuell_av_1_A : A ;
  icke_linjaer_av_1_1_A : A ;
  icke_periodisk_av_1_A : A ;
  icke_politisk_av_1_A : A ;
  icke_religioes_av_1_1_A : A ;
  icke_symmetrisk_av_1_A : A ;
  icke_verbal_av_1_A : A ;
  ickemuslimsk_av_1_A : A ;
  ickepolitisk_av_1_A : A ;
  ickeverbal_av_1_A : A ;
  ideal_av_1_A : A ;
  idealiserbar_av_1_A : A ;
  idealisk_av_1_A : A ;
  idealistisk_av_1_A : A ;
  ideell_av_1_A : A ;
  idelig_av_1_A : A ;
  identifierbar_av_1_A : A ;
  identisk_av_1_A : A ;
  identitetsmaessig_av_1_1_A : A ;
  ideografisk_av_1_A : A ;
  ideologisk_av_1_A : A ;
  idiomatisk_av_1_A : A ;
  idiopatisk_av_1_A : A ;
  idiotisk_av_1_A : A ;
  idiotsaeker_av_1_1_A : A ;
  idog_av_1_A : A ;
  idrottslig_av_1_A : A ;
  idrottsmaessig_av_1_1_A : A ;
  idyllisk_av_1_A : A ;
  id_efattig_av_1_1_A : A ;
  id_ehistorisk_av_1_1_A : A ;
  id_emaessig_av_1_1_A : A ;
  id_erik_av_1_1_A : A ;
  igengrodd_av_1_A : A ;
  igenkaennlig_av_1_1_A : A ;
  ignorerbar_av_1_A : A ;
  ihopfaellbar_av_1_1_A : A ;
  ihaerdig_av_1_1_A : A ;
  ihaalig_av_1_1_A : A ;
  ihaallig_av_1_1_A : A ;
  ikonisk_av_1_A : A ;
  iktyologisk_av_1_A : A ;
  ilig_av_1_A : A ;
  illegal_av_1_A : A ;
  illegitim_av_1_A : A ;
  illfundig_av_1_A : A ;
  illistig_av_1_A : A ;
  illmarig_av_1_A : A ;
  illojal_av_1_A : A ;
  illparig_av_1_A : A ;
  illroed_av_1_1_A : A ;
  illslug_av_1_A : A ;
  illuminerbar_av_1_A : A ;
  illusionsloes_av_1_1_A : A ;
  illusorisk_av_1_A : A ;
  illuster_av_1_A : A ;
  illustrativ_av_1_A : A ;
  illustrerbar_av_1_A : A ;
  illvillig_av_1_A : A ;
  illyrisk_av_1_A : A ;
  ilsk_av_1_A : A ;
  imagemaessig_av_1_1_A : A ;
  imaginaer_av_1_1_A : A ;
  imbecill_av_1_A : A ;
  imitativ_av_1_A : A ;
  imiterbar_av_1_A : A ;
  immateriell_av_1_A : A ;
  immatrikulerbar_av_1_A : A ;
  immig_av_1_A : A ;
  immigrerbar_av_1_A : A ;
  immobil_av_1_A : A ;
  immun_av_1_A : A ;
  immuniserbar_av_1_A : A ;
  immunologisk_av_1_A : A ;
  imperativisk_av_1_A : A ;
  imperatorisk_av_1_A : A ;
  imperialistisk_av_1_A : A ;
  implanterbar_av_1_A : A ;
  implicerbar_av_1_A : A ;
  imploderbar_av_1_A : A ;
  imponerbar_av_1_A : A ;
  impopulaer_av_1_1_A : A ;
  importerbar_av_1_A : A ;
  impregnerbar_av_1_A : A ;
  impressionistisk_av_1_A : A ;
  improduktiv_av_1_A : A ;
  improvisatorisk_av_1_A : A ;
  improviserbar_av_1_A : A ;
  impulsiv_av_1_A : A ;
  inackorderbar_av_1_A : A ;
  inaktiv_av_1_A : A ;
  inaktuell_av_1_A : A ;
  inaugurerbar_av_1_A : A ;
  inbillningssjuk_av_1_A : A ;
  inbilsk_av_1_A : A ;
  incestuoes_av_1_1_A : A ;
  indexerbar_av_1_A : A ;
  indexreglerbar_av_1_A : A ;
  indiansk_av_1_A : A ;
  indicerbar_av_1_A : A ;
  indikativ_av_1_A : A ;
  indikerbar_av_1_A : A ;
  indisk_av_1_A : A ;
  indisponibel_av_1_A : A ;
  individualiserbar_av_1_A : A ;
  individualistisk_av_1_A : A ;
  individuell_av_1_A : A ;
  indoeuropeisk_av_1_A : A ;
  indokinesisk_av_1_A : A ;
  indoktrinerbar_av_1_A : A ;
  indonesisk_av_1_A : A ;
  indraektig_av_1_1_A : A ;
  inducerbar_av_1_A : A ;
  induktiv_av_1_A : A ;
  industrialiserbar_av_1_A : A ;
  industrialistisk_av_1_A : A ;
  industriell_av_1_A : A ;
  industrimaessig_av_1_1_A : A ;
  industripolitisk_av_1_A : A ;
  ineffektiv_av_1_A : A ;
  infallsrik_av_1_A : A ;
  infam_av_1_A : A ;
  infantil_av_1_A : A ;
  infantiliserbar_av_1_A : A ;
  infekterbar_av_1_A : A ;
  infektioes_av_1_1_A : A ;
  infernalisk_av_1_A : A ;
  infertil_av_1_A : A ;
  infiltrerbar_av_1_A : A ;
  inflammatorisk_av_1_A : A ;
  inflammerbar_av_1_A : A ;
  inflationistisk_av_1_A : A ;
  inflatorisk_av_1_A : A ;
  influerbar_av_1_A : A ;
  inflytelserik_av_1_A : A ;
  informationsansvarig_av_1_A : A ;
  informationsmaessig_av_1_1_A : A ;
  informationsrik_av_1_A : A ;
  informationsteknologisk_av_1_A : A ;
  informativ_av_1_A : A ;
  informell_av_1_A : A ;
  informerbar_av_1_A : A ;
  infraroed_av_1_1_A : A ;
  infrastrukturell_av_1_A : A ;
  infoedd_av_1_1_A : A ;
  infoerstaadd_av_1_1_A : A ;
  ingenjoersmaessig_av_1_1_A : A ;
  ingraverbar_av_1_A : A ;
  ingrodd_av_1_A : A ;
  inhalerbar_av_1_A : A ;
  inhemsk_av_1_A : A ;
  inhiberbar_av_1_A : A ;
  inhibiterbar_av_1_A : A ;
  inhuman_av_1_A : A ;
  initial_av_1_A : A ;
  initiativrik_av_1_A : A ;
  initierbar_av_1_A : A ;
  injekterbar_av_1_A : A ;
  injicerbar_av_1_A : A ;
  inkapabel_av_1_A : A ;
  inkarnerbar_av_1_A : A ;
  inkasserbar_av_1_A : A ;
  inkiett_av_1_A : A ;
  inklarerbar_av_1_A : A ;
  inkluderbar_av_1_A : A ;
  inkoativ_av_1_A : A ;
  inkommensurabel_av_1_A : A ;
  inkompatibel_av_1_A : A ;
  inkomstmaessig_av_1_1_A : A ;
  inkomstsvag_av_1_A : A ;
  inkomsttaxerbar_av_1_A : A ;
  inkorporerbar_av_1_A : A ;
  inkvarterbar_av_1_A : A ;
  inkvisitorisk_av_1_A : A ;
  inlaendsk_av_1_1_A : A ;
  inlaerningsmaessig_av_1_1_A : A ;
  innehaallslig_av_1_1_A : A ;
  innehaallsloes_av_1_1_A : A ;
  innehaallsmaessig_av_1_1_A : A ;
  innehaallsrik_av_1_1_A : A ;
  innerlig_av_1_A : A ;
  innerstadsmaessig_av_1_1_A : A ;
  innerverbar_av_1_A : A ;
  innovativ_av_1_A : A ;
  inofficiell_av_1_A : A ;
  inokulerbar_av_1_A : A ;
  inomkatolsk_av_1_A : A ;
  inomvetenskaplig_av_1_A : A ;
  inopportun_av_1_A : A ;
  inplanterbar_av_1_A : A ;
  inrangerbar_av_1_A : A ;
  inrapporterbar_av_1_A : A ;
  inredningsmaessig_av_1_1_A : A ;
  inregistrerbar_av_1_A : A ;
  inremedicinsk_av_1_A : A ;
  inresekretorisk_av_1_A : A ;
  inrikespolitisk_av_1_A : A ;
  insatt_av_1_A : A ;
  inscenerbar_av_1_A : A ;
  insektskunnig_av_1_A : A ;
  inseminerbar_av_1_A : A ;
  insiktsfull_av_1_A : A ;
  insinuerbar_av_1_A : A ;
  insnodd_av_1_A : A ;
  inspekterbar_av_1_A : A ;
  inspirationsmaessig_av_1_1_A : A ;
  inspirerbar_av_1_A : A ;
  instabil_av_1_A : A ;
  installerbar_av_1_A : A ;
  instinktiv_av_1_A : A ;
  instinktmaessig_av_1_1_A : A ;
  institutionaliserbar_av_1_A : A ;
  institutionell_av_1_A : A ;
  instruerbar_av_1_A : A ;
  instruktiv_av_1_A : A ;
  instrumental_av_1_A : A ;
  instrumentell_av_1_A : A ;
  instrumenterbar_av_1_A : A ;
  instuderbar_av_1_A : A ;
  instaellbar_av_1_1_A : A ;
  instaellningsbar_av_1_1_A : A ;
  insulaer_av_1_1_A : A ;
  insydd_av_1_A : A ;
  integrationspolitisk_av_1_A : A ;
  integrerbar_av_1_A : A ;
  integritetsmaessig_av_1_1_A : A ;
  intellektualiserbar_av_1_A : A ;
  intellektualistisk_av_1_A : A ;
  intellektuell_av_1_A : A ;
  intelligensmaessig_av_1_1_A : A ;
  intensifierbar_av_1_A : A ;
  intensiv_av_1_A : A ;
  intensiverbar_av_1_A : A ;
  interaktiv_av_1_A : A ;
  interdental_av_1_A : A ;
  interetnisk_av_1_A : A ;
  interfolierbar_av_1_A : A ;
  interglacial_av_1_A : A ;
  interimistisk_av_1_A : A ;
  interkontinental_av_1_A : A ;
  intern_av_1_A : A ;
  internaliserbar_av_1_A : A ;
  internationaliserbar_av_1_A : A ;
  internationalistisk_av_1_A : A ;
  internationell_av_1_A : A ;
  internerbar_av_1_A : A ;
  internordisk_av_1_A : A ;
  interorganisatorisk_av_1_A : A ;
  interpellerbar_av_1_A : A ;
  interplanetarisk_av_1_A : A ;
  interpolerbar_av_1_A : A ;
  interpreterbar_av_1_A : A ;
  interpunkterbar_av_1_A : A ;
  interrogativ_av_1_A : A ;
  interstellaer_av_1_1_A : A ;
  interurban_av_1_A : A ;
  intervenerbar_av_1_A : A ;
  intervokalisk_av_1_A : A ;
  intig_av_1_A : A ;
  intim_av_1_A : A ;
  intolerabel_av_1_A : A ;
  intrinsisk_av_1_A : A ;
  invandrarpolitisk_av_1_A : A ;
  invandringspolitisk_av_1_A : A ;
  invariabel_av_1_A : A ;
  irreligioes_av_1_1_A : A ;
  irreparabel_av_1_A : A ;
  irreversibel_av_1_A : A ;
  irritabel_av_1_A : A ;
  jainistisk_av_1_A : A ;
  jansenistisk_av_1_A : A ;
  jordbrukspolitisk_av_1_A : A ;
  jordbaevningssaeker_av_1_1_A : A ;
  justerbar_av_1_A : A ;
  jaemgod_av_1_1_A : A ;
  jaemngod_av_1_1_A : A ;
  jaemnaarig_av_1_1_A : A ;
  jaemstor_av_1_1_A : A ;
  jaemstaelldhetspolitisk_av_1_1_A : A ;
  jaettefin_av_1_1_A : A ;
  jaetteglad_av_1_1_A : A ;
  jaettelarvig_av_1_1_A : A ;
  jaettelaang_av_1_1_A : A ;
  jaetterolig_av_1_1_A : A ;
  jaettestor_av_1_1_A : A ;
  jaettesvaar_av_1_1_A : A ;
  jaetteviktig_av_1_1_A : A ;
  kabbalistisk_av_1_A : A ;
  kamprydd_av_1_A : A ;
  kaninstor_av_1_A : A ;
  kannibalistisk_av_1_A : A ;
  kantabel_av_1_A : A ;
  kantstoett_av_1_1_A : A ;
  kapabel_av_1_A : A ;
  karateteknisk_av_1_A : A ;
  karolingisk_av_1_A : A ;
  karriaeristisk_av_1_1_A : A ;
  kassabel_av_1_A : A ;
  kastanjbrun_av_1_A : A ;
  kastanjebrun_av_1_A : A ;
  katadrom_av_1_A : A ;
  katedersocialistisk_av_1_A : A ;
  kejsarlik_av_1_A : A ;
  keramisk_av_1_A : A ;
  kilometerhoeg_av_1_1_A : A ;
  kilometerlaang_av_1_1_A : A ;
  kippskodd_av_1_A : A ;
  kjolloes_av_1_1_A : A ;
  klarroed_av_1_1_A : A ;
  klassicistisk_av_1_A : A ;
  klerikofascistisk_av_1_A : A ;
  klotformig_av_1_A : A ;
  klotsporig_av_1_A : A ;
  klaedd_av_1_1_A : A ;
  klaemkaeck_av_1_1_A : A ;
  kloevertroett_av_1_1_A : A ;
  knallroed_av_1_1_A : A ;
  knaper_av_1_A : A ;
  knaadbar_av_1_1_A : A ;
  kokett_av_1_A : A ;
  kollektivistisk_av_1_A : A ;
  kolonialistisk_av_1_A : A ;
  koloristisk_av_1_A : A ;
  komfortabel_av_1_A : A ;
  kommensurabel_av_1_A : A ;
  kommunalekonomisk_av_1_A : A ;
  kommunikationscentral_av_1_A : A ;
  komparabel_av_1_A : A ;
  kompatibel_av_1_A : A ;
  komplett_av_1_A : A ;
  konformistisk_av_1_A : A ;
  konfrontativ_av_1_A : A ;
  konfrontatorisk_av_1_A : A ;
  konfucianistisk_av_1_A : A ;
  konjunkturpolitisk_av_1_A : A ;
  konkretistisk_av_1_A : A ;
  konkurrensutsatt_av_1_A : A ;
  konspirationsteoretisk_av_1_A : A ;
  konstindustriell_av_1_A : A ;
  konstteoretisk_av_1_A : A ;
  konsumentpolitisk_av_1_A : A ;
  konversabel_av_1_A : A ;
  konvertibel_av_1_A : A ;
  kopparroed_av_1_1_A : A ;
  korallroed_av_1_1_A : A ;
  korgvis_av_1_A : A ;
  korporatistisk_av_1_A : A ;
  korporativistisk_av_1_A : A ;
  korsvis_av_1_A : A ;
  kostymklaedd_av_1_1_A : A ;
  kreationistisk_av_1_A : A ;
  krigstroett_av_1_1_A : A ;
  kriminalpolitisk_av_1_A : A ;
  kriminalteknisk_av_1_A : A ;
  kristdemokratisk_av_1_A : A ;
  kristologisk_av_1_A : A ;
  kromatisk_av_1_A : A ;
  kryptografisk_av_1_A : A ;
  kubisk_av_1_A : A ;
  kulturpolitisk_av_1_A : A ;
  kunskapsteoretisk_av_1_A : A ;
  kupolfoersedd_av_1_1_A : A ;
  kvadratisk_av_1_A : A ;
  kvartalsvis_av_1_A : A ;
  kvartsekellaang_av_1_1_A : A ;
  kvasiintellektuell_av_1_A : A ;
  kvietistisk_av_1_A : A ;
  kvinnopolitisk_av_1_A : A ;
  kynokephal_av_1_A : A ;
  kyssaeker_av_1_1_A : A ;
  kaellkritisk_av_1_1_A : A ;
  kaerleksberedd_av_1_1_A : A ;
  kaernteknisk_av_1_1_A : A ;
  koensneutral_av_1_1_A : A ;
  koepkraftstark_av_1_1_A : A ;
  koersbaersroed_av_1_1_A : A ;
  laber_av_1_A : A ;
  lamaistisk_av_1_A : A ;
  landsgagnelig_av_1_A : A ;
  laparoskopisk_av_1_A : A ;
  led_av_1_A : A ;
  lemmalytt_av_1_A : A ;
  levnadsglad_av_1_A : A ;
  levnadstroett_av_1_1_A : A ;
  liberalistisk_av_1_A : A ;
  likoeverstroedd_av_1_1_A : A ;
  lingonroed_av_1_1_A : A ;
  litteraturvetenskaplig_av_1_A : A ;
  ljuslaett_av_1_1_A : A ;
  ljusroed_av_1_1_A : A ;
  lokaliseringspolitisk_av_1_A : A ;
  lokalpatriotisk_av_1_A : A ;
  lokalpolitisk_av_1_A : A ;
  lucker_av_1_A : A ;
  luguber_av_1_A : A ;
  lytt_av_1_A : A ;
  laecker_av_1_1_A : A ;
  laerarledd_av_1_1_A : A ;
  laett_av_1_1_A : A ;
  laettklaedd_av_1_1_A : A ;
  laettledd_av_1_1_A : A ;
  laettskoett_av_1_1_A : A ;
  laettstoett_av_1_1_A : A ;
  laagintensiv_av_1_1_A : A ;
  laagsaesongssoemnig_av_1_1_A : A ;
  laangperiodisk_av_1_1_A : A ;
  laangtidsarbetsloes_av_1_1_A : A ;
  laarhoeg_av_1_1_A : A ;
  loenepolitisk_av_1_1_A : A ;
  loes_av_2_1_A : A ;
  loevklaedd_av_1_1_A : A ;
  mager_av_1_A : A ;
  makaber_av_1_A : A ;
  maktpolitisk_av_1_A : A ;
  mangogul_av_1_A : A ;
  manieristisk_av_1_A : A ;
  manikeistisk_av_1_A : A ;
  manschauvinistisk_av_1_A : A ;
  manshoeg_av_1_1_A : A ;
  mantelklaedd_av_1_1_A : A ;
  maoistisk_av_1_A : A ;
  marinarkeologisk_av_1_A : A ;
  maskinteknisk_av_1_A : A ;
  masochistisk_av_1_A : A ;
  matt_av_1_A : A ;
  medelgod_av_1_A : A ;
  medelgrov_av_1_A : A ;
  medelhoeg_av_1_1_A : A ;
  medelstor_av_1_A : A ;
  medelsvaar_av_1_1_A : A ;
  medfoedd_av_1_1_A : A ;
  mediapolitisk_av_1_A : A ;
  medicinhistorisk_av_1_A : A ;
  mediepolitisk_av_1_A : A ;
  medioker_av_1_A : A ;
  mellanmaensklig_av_1_1_A : A ;
  mellanstor_av_1_A : A ;
  mentalistisk_av_1_A : A ;
  merkantilistisk_av_1_A : A ;
  mesolitisk_av_1_A : A ;
  metallklaedd_av_1_1_A : A ;
  meterlaang_av_1_1_A : A ;
  metodistisk_av_1_A : A ;
  militaerdiplomatisk_av_1_1_A : A ;
  miljoepolitisk_av_1_1_A : A ;
  millimeterlaang_av_1_1_A : A ;
  milslaang_av_1_1_A : A ;
  milsvid_av_1_A : A ;
  minnesgod_av_1_A : A ;
  miserabel_av_1_A : A ;
  mnemonisk_av_1_A : A ;
  moderloes_av_1_1_A : A ;
  monistisk_av_1_A : A ;
  monopolistisk_av_1_A : A ;
  monoteistisk_av_1_A : A ;
  moralistisk_av_1_A : A ;
  morgonfryntlig_av_1_A : A ;
  morgontroett_av_1_1_A : A ;
  mossklaedd_av_1_1_A : A ;
  motsatt_av_1_A : A ;
  multipel_av_1_A : A ;
  multisjuk_av_1_A : A ;
  munter_av_1_A : A ;
  mustaschprydd_av_1_A : A ;
  mysticistisk_av_1_A : A ;
  maett_av_1_1_A : A ;
  maanadslaang_av_1_1_A : A ;
  maanadsvis_av_1_1_A : A ;
  maanformig_av_1_1_A : A ;
  maangdubbel_av_1_1_A : A ;
  maangtusenaarig_av_1_1_A : A ;
  maangaarig_av_1_1_A : A ;
  maattsydd_av_1_1_A : A ;
  moerkklaedd_av_1_1_A : A ;
  moerkroed_av_1_1_A : A ;
  narcissistisk_av_1_A : A ;
  nedbrytbar_av_1_A : A ;
  nedsatt_av_1_A : A ;
  negativistisk_av_1_A : A ;
  negligeabel_av_1_A : A ;
  negligibel_av_1_A : A ;
  nekrofil_av_1_A : A ;
  neoimpressionistisk_av_1_A : A ;
  neoklassicistisk_av_1_A : A ;
  nersatt_av_1_A : A ;
  niofaldig_av_1_A : A ;
  nioaarig_av_1_1_A : A ;
  nittiotalistisk_av_1_A : A ;
  nittonaarig_av_1_1_A : A ;
  nobel_av_1_A : A ;
  nolldimensionell_av_1_A : A ;
  nonkonformistisk_av_1_A : A ;
  nordistisk_av_1_A : A ;
  normalblyg_av_1_A : A ;
  normalstor_av_1_A : A ;
  notabel_av_1_A : A ;
  notsaeker_av_1_1_A : A ;
  nyandlig_av_1_A : A ;
  nyenkel_av_1_A : A ;
  nyfascistisk_av_1_A : A ;
  nyfoedd_av_1_1_A : A ;
  nyinredd_av_1_A : A ;
  nykolonialistisk_av_1_A : A ;
  nykter_av_1_A : A ;
  nykteristisk_av_1_A : A ;
  nyliberalistisk_av_1_A : A ;
  nynazistisk_av_1_A : A ;
  nyplatonistisk_av_1_A : A ;
  nyrealistisk_av_1_A : A ;
  nyromantisk_av_1_A : A ;
  nysaadd_av_1_1_A : A ;
  nyter_av_1_A : A ;
  naeringslivspolitisk_av_1_1_A : A ;
  naeringspolitisk_av_1_1_A : A ;
  naett_av_1_1_A : A ;
  noedbedd_av_1_1_A : A ;
  noedd_av_1_1_A : A ;
  oacceptabel_av_1_A : A ;
  oanfraett_av_1_1_A : A ;
  oavmaett_av_1_1_A : A ;
  oavsedd_av_1_A : A ;
  oavstoett_av_1_1_A : A ;
  obebodd_av_1_A : A ;
  obedd_av_1_A : A ;
  obemoett_av_1_1_A : A ;
  oberedd_av_1_A : A ;
  obesatt_av_1_A : A ;
  obesedd_av_1_A : A ;
  obestridd_av_1_A : A ;
  objektivistisk_av_1_A : A ;
  oblid_av_1_A : A ;
  obloett_av_1_1_A : A ;
  obskurantistisk_av_1_A : A ;
  obytt_av_1_A : A ;
  ockultistisk_av_1_A : A ;
  odiskutabel_av_1_A : A ;
  odisputabel_av_1_A : A ;
  offentligraettslig_av_1_1_A : A ;
  ofraett_av_1_1_A : A ;
  ofoedd_av_1_1_A : A ;
  ofoerberedd_av_1_1_A : A ;
  ofoerbytt_av_1_1_A : A ;
  ofoergaenglig_av_1_1_A : A ;
  ofoernoett_av_1_1_A : A ;
  ofoerutsedd_av_1_1_A : A ;
  ofoerutspaadd_av_1_1_A : A ;
  oinredd_av_1_A : A ;
  oklaedd_av_1_1_A : A ;
  olycksdiger_av_1_A : A ;
  ombytt_av_1_A : A ;
  omljudd_av_1_A : A ;
  omstridd_av_1_A : A ;
  omstaellningsbar_av_1_1_A : A ;
  omaett_av_1_1_A : A ;
  omoett_av_1_1_A : A ;
  onykter_av_1_A : A ;
  onoett_av_1_1_A : A ;
  oombedd_av_1_A : A ;
  oomljudd_av_1_A : A ;
  oomskoett_av_1_1_A : A ;
  oomstridd_av_1_A : A ;
  opatriotisk_av_1_A : A ;
  operabel_av_1_A : A ;
  operationalistisk_av_1_A : A ;
  oppklaedd_av_1_1_A : A ;
  oppraett_av_1_1_A : A ;
  orangegul_av_1_A : A ;
  ordraett_av_1_1_A : A ;
  orfistisk_av_1_A : A ;
  orientalistisk_av_1_A : A ;
  ortopedisk_av_1_A : A ;
  oraett_av_1_1_A : A ;
  osammanstoett_av_1_1_A : A ;
  osedd_av_1_A : A ;
  oskadd_av_1_A : A ;
  osaeker_av_1_1_A : A ;
  ouppraeknelig_av_1_1_A : A ;
  outspaedd_av_1_1_A : A ;
  oxblodsroed_av_1_1_A : A ;
  ooeverbryggbar_av_1_1_A : A ;
  paljettbestroedd_av_1_1_A : A ;
  pandemisk_av_1_A : A ;
  papistisk_av_1_A : A ;
  parallellistisk_av_1_A : A ;
  parlamentaristisk_av_1_A : A ;
  partikularistisk_av_1_A : A ;
  passabel_av_1_A : A ;
  patriotistisk_av_1_A : A ;
  pedofil_av_1_A : A ;
  penibel_av_1_A : A ;
  pennalistisk_av_1_A : A ;
  penningpolitisk_av_1_A : A ;
  pepitarutig_av_1_A : A ;
  perfektionistisk_av_1_A : A ;
  permeabel_av_1_A : A ;
  personalistisk_av_1_A : A ;
  personalpolitisk_av_1_A : A ;
  petsaeker_av_1_1_A : A ;
  pietistisk_av_1_A : A ;
  piezoelektrisk_av_1_A : A ;
  pimpinett_av_1_A : A ;
  pionroed_av_1_1_A : A ;
  platt_av_1_A : A ;
  plausibel_av_1_A : A ;
  plyschklaedd_av_1_1_A : A ;
  pointillistisk_av_1_A : A ;
  polyglott_av_1_A : A ;
  polyteistisk_av_1_A : A ;
  ponderabel_av_1_A : A ;
  populaerkulturell_av_1_1_A : A ;
  portabel_av_1_A : A ;
  postmodern_av_1_A : A ;
  postmodernistisk_av_1_A : A ;
  postoperativ_av_1_A : A ;
  posttraumatisk_av_1_A : A ;
  postum_av_1_A : A ;
  praktikabel_av_1_A : A ;
  pratglad_av_1_A : A ;
  premenstruell_av_1_A : A ;
  presentabel_av_1_A : A ;
  pressansvarig_av_1_A : A ;
  pressetisk_av_1_A : A ;
  pricksaeker_av_1_1_A : A ;
  privatraettslig_av_1_1_A : A ;
  proamerikansk_av_1_A : A ;
  probabel_av_1_A : A ;
  propalestinsk_av_1_A : A ;
  proper_av_1_A : A ;
  proppmaett_av_1_1_A : A ;
  prospektiv_av_1_A : A ;
  provinsialistisk_av_1_A : A ;
  pryd_av_1_A : A ;
  psykotropisk_av_1_A : A ;
  ptolemeisk_av_1_A : A ;
  puertoricansk_av_1_A : A ;
  pugilistisk_av_1_A : A ;
  puristisk_av_1_A : A ;
  puritanistisk_av_1_A : A ;
  purpurroed_av_1_1_A : A ;
  putt_av_1_A : A ;
  pyrofil_av_1_A : A ;
  pyrofor_av_1_A : A ;
  pyroklastisk_av_1_A : A ;
  paelsteknisk_av_1_1_A : A ;
  paaklaedd_av_1_1_A : A ;
  paaver_av_1_1_A : A ;
  randsydd_av_1_A : A ;
  rationalistisk_av_1_A : A ;
  rattfull_av_1_A : A ;
  realpolitisk_av_1_A : A ;
  reformistisk_av_1_A : A ;
  regelraett_av_1_1_A : A ;
  regionalistisk_av_1_A : A ;
  regionalpolitisk_av_1_A : A ;
  regionpolitisk_av_1_A : A ;
  regionspolitisk_av_1_A : A ;
  rekommendabel_av_1_A : A ;
  rekordklantig_av_1_A : A ;
  rekordlaag_av_1_1_A : A ;
  rekordlaang_av_1_1_A : A ;
  rekordstor_av_1_A : A ;
  rekreationspolitisk_av_1_A : A ;
  rektal_av_1_A : A ;
  reliabel_av_1_A : A ;
  remarkabel_av_1_A : A ;
  rensbar_av_1_A : A ;
  reparabel_av_1_A : A ;
  reproduktiv_av_1_A : A ;
  resonabel_av_1_A : A ;
  respektabel_av_1_A : A ;
  retrofuturistisk_av_1_A : A ;
  revanschistisk_av_1_A : A ;
  reversibel_av_1_A : A ;
  revisionistisk_av_1_A : A ;
  rikspolitisk_av_1_A : A ;
  ringprydd_av_1_A : A ;
  riskabel_av_1_A : A ;
  ritualistisk_av_1_A : A ;
  roderloes_av_1_1_A : A ;
  rosenaktig_av_1_A : A ;
  rosenroed_av_1_1_A : A ;
  rosettprydd_av_1_A : A ;
  rostroed_av_1_1_A : A ;
  roterbar_av_1_A : A ;
  rubinroed_av_1_1_A : A ;
  rundnaett_av_1_1_A : A ;
  rymningssaeker_av_1_1_A : A ;
  ryskspraakig_av_1_1_A : A ;
  raentabel_av_1_1_A : A ;
  raett_av_1_1_A : A ;
  raettspolitisk_av_1_1_A : A ;
  roed_av_1_1_A : A ;
  roedgul_av_1_1_A : A ;
  roedlaett_av_1_1_A : A ;
  roedprickig_av_1_1_A : A ;
  roedrandig_av_1_1_A : A ;
  samhaellspolitisk_av_1_1_A : A ;
  sammansatt_av_1_A : A ;
  sannspaadd_av_1_1_A : A ;
  satanistisk_av_1_A : A ;
  satt_av_1_A : A ;
  schamanistisk_av_1_A : A ;
  scharlakansroed_av_1_1_A : A ;
  segelduksklaedd_av_1_1_A : A ;
  sekelskiftesintellektuell_av_1_A : A ;
  sekretesslovlig_av_1_A : A ;
  sekventiell_av_1_A : A ;
  semiautomatisk_av_1_A : A ;
  semipermeabel_av_1_A : A ;
  senapsgul_av_1_A : A ;
  senfoedd_av_1_1_A : A ;
  senneolitisk_av_1_A : A ;
  sensibel_av_1_A : A ;
  sensualistisk_av_1_A : A ;
  separabel_av_1_A : A ;
  sexfaldig_av_1_A : A ;
  sexistisk_av_1_A : A ;
  sextonaarig_av_1_1_A : A ;
  sexaarig_av_1_1_A : A ;
  shiamuslimsk_av_1_A : A ;
  shiitisk_av_1_A : A ;
  shintoistisk_av_1_A : A ;
  sid_av_1_A : A ;
  simpel_av_1_A : A ;
  sinister_av_1_A : A ;
  sionistisk_av_1_A : A ;
  sjangdobel_av_1_A : A ;
  sjufaldig_av_1_A : A ;
  sjukvaardspolitisk_av_1_1_A : A ;
  sjuttonaarig_av_1_1_A : A ;
  sjuaarig_av_1_1_A : A ;
  sjaelaglad_av_1_1_A : A ;
  sjaelsstark_av_1_1_A : A ;
  sjaelvgod_av_1_1_A : A ;
  sjaelvsaeker_av_1_1_A : A ;
  sjoefartspolitisk_av_1_1_A : A ;
  sjoehistorisk_av_1_1_A : A ;
  sjoesaeker_av_1_1_A : A ;
  skadeglad_av_1_A : A ;
  skadestaandsraettslig_av_1_1_A : A ;
  skadestaandsskyldig_av_1_1_A : A ;
  skandinavistisk_av_1_A : A ;
  skarp_av_2_A : A ;
  skatteallergisk_av_1_A : A ;
  skattepolitisk_av_1_A : A ;
  skendoed_av_1_1_A : A ;
  skickelsediger_av_1_A : A ;
  skinnflaadd_av_1_1_A : A ;
  skinnklaedd_av_1_1_A : A ;
  skitkass_av_1_A : A ;
  skittoentig_av_1_1_A : A ;
  skjutbar_av_1_A : A ;
  skjutglad_av_1_A : A ;
  skogklaedd_av_1_1_A : A ;
  skoklaedd_av_1_1_A : A ;
  skolpolitisk_av_1_A : A ;
  skoltroett_av_1_1_A : A ;
  skottsaeker_av_1_1_A : A ;
  skrivbar_av_1_A : A ;
  skrivberedd_av_1_A : A ;
  skruvbar_av_1_A : A ;
  skuggloes_av_1_1_A : A ;
  skuldsatt_av_1_A : A ;
  skaeftig_av_1_1_A : A ;
  slottslik_av_1_A : A ;
  smittbar_av_1_A : A ;
  smaecker_av_1_1_A : A ;
  smaahet_av_1_1_A : A ;
  smaakornig_av_1_1_A : A ;
  smaarufsig_av_1_1_A : A ;
  smaasur_av_1_1_A : A ;
  snarfager_av_1_A : A ;
  snarvacker_av_1_A : A ;
  sned_av_1_A : A ;
  snurrbar_av_1_A : A ;
  snutfager_av_1_A : A ;
  snoeklaedd_av_1_1_A : A ;
  sober_av_1_A : A ;
  socialrealistisk_av_1_A : A ;
  sofistisk_av_1_A : A ;
  solid_av_1_A : A ;
  solipsistisk_av_1_A : A ;
  sommarlovsledig_av_1_A : A ;
  sorgklaedd_av_1_1_A : A ;
  sotdoed_av_1_1_A : A ;
  sovjetunderstoedd_av_1_1_A : A ;
  spanskspraakig_av_1_1_A : A ;
  spektroskopisk_av_1_A : A ;
  spiksaeker_av_1_1_A : A ;
  spindellik_av_1_A : A ;
  spindelvaevsaktig_av_1_1_A : A ;
  spiritistisk_av_1_A : A ;
  spiritualistisk_av_1_A : A ;
  spontanistisk_av_1_A : A ;
  spridd_av_1_A : A ;
  sproed_av_1_1_A : A ;
  spaed_av_1_1_A : A ;
  spaanklaedd_av_1_1_A : A ;
  spaarfoersedd_av_1_1_A : A ;
  startberedd_av_1_A : A ;
  statsraettslig_av_1_1_A : A ;
  stavformig_av_1_A : A ;
  stegvis_av_1_A : A ;
  stendoed_av_1_1_A : A ;
  stensatt_av_1_A : A ;
  stentuff_av_1_A : A ;
  stjaernbestroedd_av_1_1_A : A ;
  stoicistisk_av_1_A : A ;
  stormsaeker_av_1_1_A : A ;
  storrutig_av_1_A : A ;
  straffraettslig_av_1_1_A : A ;
  strid_av_1_A : A ;
  strukturalistisk_av_1_A : A ;
  strumpklaedd_av_1_1_A : A ;
  strutfoersedd_av_1_1_A : A ;
  straalningssaeker_av_1_1_A : A ;
  stroemloes_av_1_1_A : A ;
  studieovan_av_1_A : A ;
  studiesocial_av_1_A : A ;
  stundvis_av_1_A : A ;
  staellbar_av_1_1_A : A ;
  stoeldsaeker_av_1_1_A : A ;
  stoett_av_1_1_A : A ;
  stoetvis_av_1_1_A : A ;
  subjektivistisk_av_1_A : A ;
  suggestibel_av_1_A : A ;
  suicidpreventiv_av_1_A : A ;
  sunnimuslimsk_av_1_A : A ;
  sunnitisk_av_1_A : A ;
  superelastisk_av_1_A : A ;
  superglad_av_1_A : A ;
  superlaett_av_1_1_A : A ;
  superlaag_av_1_1_A : A ;
  supermassiv_av_1_A : A ;
  supersmaskig_av_1_A : A ;
  superviktig_av_1_A : A ;
  supranaturalistisk_av_1_A : A ;
  suprematistisk_av_1_A : A ;
  svackig_av_1_A : A ;
  svartklaedd_av_1_1_A : A ;
  svavelgul_av_1_A : A ;
  svensk_engelsk_av_1_A : A ;
  svensk_tysk_av_1_A : A ;
  svenskfoedd_av_1_1_A : A ;
  svenskledd_av_1_A : A ;
  svenskspraakig_av_1_1_A : A ;
  svenskstoedd_av_1_1_A : A ;
  svett_av_1_A : A ;
  svettfuktig_av_1_A : A ;
  svaeltfoedd_av_1_1_A : A ;
  svaardefinierbar_av_1_1_A : A ;
  svaarfoerenlig_av_1_1_A : A ;
  svaartydd_av_1_1_A : A ;
  syllogistisk_av_1_A : A ;
  sylvass_av_1_A : A ;
  symbolistisk_av_1_A : A ;
  syndikalistisk_av_1_A : A ;
  synergistisk_av_1_A : A ;
  synkretistisk_av_1_A : A ;
  sysselsatt_av_1_A : A ;
  sysselsaettningspolitisk_av_1_1_A : A ;
  saeker_av_1_1_A : A ;
  saekerhetspolitisk_av_1_1_A : A ;
  soekbar_av_1_1_A : A ;
  tafatt_av_1_A : A ;
  taggfoersedd_av_1_1_A : A ;
  tamilsk_av_1_A : A ;
  tankediger_av_1_A : A ;
  tankspridd_av_1_A : A ;
  taoistisk_av_1_A : A ;
  tapper_av_1_A : A ;
  taxonomisk_av_1_A : A ;
  tegelroed_av_1_1_A : A ;
  teistisk_av_1_A : A ;
  temporal_av_1_A : A ;
  terrester_av_1_A : A ;
  terroristisk_av_1_A : A ;
  testabel_av_1_A : A ;
  teutonisk_av_1_A : A ;
  tidigneolitisk_av_1_A : A ;
  tidsasymmetrisk_av_1_A : A ;
  tidssymmetrisk_av_1_A : A ;
  tillbakasatt_av_1_A : A ;
  tillvaextstark_av_1_1_A : A ;
  timvis_av_1_A : A ;
  tiodubbel_av_1_A : A ;
  tiogradig_av_1_A : A ;
  tioaarig_av_1_1_A : A ;
  tjugoettaarig_av_1_1_A : A ;
  tjugofaldig_av_1_A : A ;
  tjugofemaarig_av_1_1_A : A ;
  tjugofyraaarig_av_1_1_A : A ;
  tjugotreaarig_av_1_1_A : A ;
  tjugotvaaaarig_av_1_1_A : A ;
  tjugoaarig_av_1_1_A : A ;
  tjugufemaarig_av_1_1_A : A ;
  tjuguaarig_av_1_1_A : A ;
  tolerabel_av_1_A : A ;
  tolvfaldig_av_1_A : A ;
  tolvaarig_av_1_1_A : A ;
  tonsaeker_av_1_1_A : A ;
  tonaarig_av_1_1_A : A ;
  torrskodd_av_1_A : A ;
  totalitaristisk_av_1_A : A ;
  totemistisk_av_1_A : A ;
  traditionalistisk_av_1_A : A ;
  trafikabel_av_1_A : A ;
  trafikpolitisk_av_1_A : A ;
  trafiksaeker_av_1_1_A : A ;
  transnationell_av_1_A : A ;
  transportabel_av_1_A : A ;
  transsylvansk_av_1_A : A ;
  tredubbel_av_1_A : A ;
  trenchcoatklaedd_av_1_1_A : A ;
  trettioaarig_av_1_1_A : A ;
  trettiaarig_av_1_1_A : A ;
  trettonaarig_av_1_1_A : A ;
  treaarig_av_1_1_A : A ;
  tribalistisk_av_1_A : A ;
  trippel_av_1_A : A ;
  tropistisk_av_1_A : A ;
  trotskistisk_av_1_A : A ;
  trycksaeker_av_1_1_A : A ;
  traeffsaeker_av_1_1_A : A ;
  traadformig_av_1_1_A : A ;
  traangbodd_av_1_1_A : A ;
  troegbedd_av_1_1_A : A ;
  troett_av_1_1_A : A ;
  tungrodd_av_1_A : A ;
  tunnklaedd_av_1_1_A : A ;
  tunnsaadd_av_1_1_A : A ;
  turbanklaedd_av_1_1_A : A ;
  turvis_av_1_A : A ;
  tusenaarig_av_1_1_A : A ;
  tvillinglik_av_1_A : A ;
  tvaermaett_av_1_1_A : A ;
  tvaersaeker_av_1_1_A : A ;
  tvaafaldig_av_1_1_A : A ;
  tvaahjulig_av_1_1_A : A ;
  tvaalfager_av_1_1_A : A ;
  tvaastjaernig_av_1_1_A : A ;
  tvaaaarig_av_1_1_A : A ;
  typografisk_av_1_A : A ;
  typologisk_av_1_A : A ;
  tysk_romersk_av_1_A : A ;
  tysk_schweizisk_av_1_A : A ;
  tysk_svensk_av_1_A : A ;
  tyskspraakig_av_1_1_A : A ;
  toernbestroedd_av_1_1_A : A ;
  ultraroed_av_1_1_A : A ;
  ultraviolett_av_1_A : A ;
  underfoerstaadd_av_1_1_A : A ;
  undersysselsatt_av_1_A : A ;
  underaarig_av_1_1_A : A ;
  ungdomspolitisk_av_1_A : A ;
  ungsocialistisk_av_1_A : A ;
  uniformsklaedd_av_1_1_A : A ;
  unitariansk_av_1_A : A ;
  unitaristisk_av_1_A : A ;
  uppbloett_av_1_1_A : A ;
  uppdragsarkeologisk_av_1_A : A ;
  uppklaedd_av_1_1_A : A ;
  uppraett_av_1_1_A : A ;
  uppsatt_av_1_A : A ;
  urusel_av_1_A : A ;
  utbildningspolitisk_av_1_A : A ;
  utbredd_av_1_A : A ;
  utdoed_av_1_1_A : A ;
  utklaedd_av_1_1_A : A ;
  utled_av_1_A : A ;
  utnoett_av_1_1_A : A ;
  utomkroppslig_av_1_A : A ;
  utommaensklig_av_1_1_A : A ;
  utredningsteknisk_av_1_A : A ;
  utsatt_av_1_A : A ;
  utspridd_av_1_A : A ;
  utspaedd_av_1_1_A : A ;
  utstoett_av_1_1_A : A ;
  uttagbar_av_1_A : A ;
  uttryckbar_av_1_A : A ;
  vacker_av_1_A : A ;
  valutapolitisk_av_1_A : A ;
  variabel_av_1_A : A ;
  veckolaang_av_1_1_A : A ;
  veckovis_av_1_A : A ;
  venerabel_av_1_A : A ;
  veristisk_av_1_A : A ;
  veritabel_av_1_A : A ;
  vid_av_1_A : A ;
  vimpelprydd_av_1_A : A ;
  vinroed_av_1_1_A : A ;
  violett_av_1_A : A ;
  visibel_av_1_A : A ;
  vitalistisk_av_1_A : A ;
  vitklaedd_av_1_1_A : A ;
  vitskaeggig_av_1_1_A : A ;
  vitter_av_1_A : A ;
  voluntaristisk_av_1_A : A ;
  vraalflott_av_1_1_A : A ;
  vaelbesatt_av_1_1_A : A ;
  vaelfaerdspolitisk_av_1_1_A : A ;
  vaelfoedd_av_1_1_A : A ;
  vaelfoersedd_av_1_1_A : A ;
  vaelfoerstaadd_av_1_1_A : A ;
  vaelgoedd_av_1_1_A : A ;
  vaelklaedd_av_1_1_A : A ;
  vaelsedd_av_1_1_A : A ;
  vaelskoett_av_1_1_A : A ;
  vaendsydd_av_1_1_A : A ;
  vaensterintellektuell_av_1_1_A : A ;
  vaensteroppositionell_av_1_1_A : A ;
  vaensterpolitisk_av_1_1_A : A ;
  vaenstersocialistisk_av_1_1_A : A ;
  vaerdenihilistisk_av_1_1_A : A ;
  vaerdesaeker_av_1_1_A : A ;
  vaerldspolitisk_av_1_1_A : A ;
  vaaldsutsatt_av_1_1_A : A ;
  vaarfin_av_1_1_A : A ;
  vaarfraesch_av_1_1_A : A ;
  vaartroett_av_1_1_A : A ;
  vaatblank_av_1_1_A : A ;
  vaatstrimmig_av_1_1_A : A ;
  wienklassicistisk_av_1_A : A ;
  yster_av_1_A : A ;
  aemabel_av_1_1_A : A ;
  aarslaang_av_1_1_A : A ;
  aarsvis_av_1_1_A : A ;
  aaskdiger_av_1_1_A : A ;
  aasklik_av_1_1_A : A ;
  aatalbar_av_1_1_A : A ;
  aaterfoerslutningsbar_av_1_1_A : A ;
  aattafaldig_av_1_1_A : A ;
  aattaaarig_av_1_1_A : A ;
  aattioprocentig_av_1_1_A : A ;
  aattiotalistisk_av_1_1_A : A ;
  aattkantig_av_1_1_A : A ;
  oedesdiger_av_1_1_A : A ;
  oeverfoerbar_av_1_1_A : A ;
  oevergaangsvis_av_1_1_A : A ;
  oevermaett_av_1_1_A : A ;
  oeveroptimistisk_av_1_1_A : A ;
  oeverskoeljningssaeker_av_1_1_A : A ;
  oeverstroedd_av_1_1_A : A ;
  Celsius_ab_1_Adv : Adv ;
  absolut_ab_1_Adv : Adv ;
  ackurat_ab_1_Adv : Adv ;
  adagio_ab_1_Adv : Adv ;
  akter_ab_1_Adv : Adv ;
  akterst_ab_1_Adv : Adv ;
  akterut_ab_1_Adv : Adv ;
  akteroever_ab_1_1_Adv : Adv ;
  akut_ab_1_Adv : Adv ;
  aldrig_ab_1_Adv : Adv ;
  alfresko_ab_1_Adv : Adv ;
  alias_ab_1_Adv : Adv ;
  allaredan_ab_1_Adv : Adv ;
  alldeles_ab_1_Adv : Adv ;
  allegretto_ab_1_Adv : Adv ;
  allegro_ab_1_Adv : Adv ;
  allenast_ab_1_Adv : Adv ;
  allestaedes_ab_1_1_Adv : Adv ;
  allra_ab_1_Adv : Adv ;
  alls_ab_1_Adv : Adv ;
  allt_ab_1_Adv : Adv ;
  alltemellan_ab_1_Adv : Adv ;
  alltemellanaat_ab_1_1_Adv : Adv ;
  alltfort_ab_1_Adv : Adv ;
  alltfoer_ab_1_1_Adv : Adv ;
  alltid_ab_1_Adv : Adv ;
  alltigenom_ab_1_Adv : Adv ;
  alltjaemt_ab_1_1_Adv : Adv ;
  alltmer_ab_1_Adv : Adv ;
  alltmera_ab_1_Adv : Adv ;
  alltnog_ab_1_Adv : Adv ;
  alltsomoftast_ab_1_Adv : Adv ;
  alltsaa_ab_1_1_Adv : Adv ;
  allvarligen_ab_1_Adv : Adv ;
  alpari_ab_1_Adv : Adv ;
  alternativt_ab_1_Adv : Adv ;
  amok_ab_1_Adv : Adv ;
  an_ab_1_Adv : Adv ;
  andante_ab_1_Adv : Adv ;
  andligen_ab_1_Adv : Adv ;
  aningen_ab_1_Adv : Adv ;
  aningens_ab_1_Adv : Adv ;
  annanstans_ab_1_Adv : Adv ;
  annars_ab_1_Adv : Adv ;
  annorledes_ab_1_Adv : Adv ;
  annorlunda_ab_1_Adv : Adv ;
  annorstaedes_ab_1_1_Adv : Adv ;
  anstaendigtvis_ab_1_1_Adv : Adv ;
  antagligen_ab_1_Adv : Adv ;
  antingen_ab_1_Adv : Adv ;
  antydningsvis_ab_1_Adv : Adv ;
  apropaa_ab_1_1_Adv : Adv ;
  arla_ab_1_Adv : Adv ;
  av_ab_1_Adv : Adv ;
  avista_ab_1_Adv : Adv ;
  avsides_ab_1_Adv : Adv ;
  avsiktligen_ab_1_Adv : Adv ;
  avslutningsvis_ab_1_Adv : Adv ;
  ba_ab_1_Adv : Adv ;
  babord_ab_1_Adv : Adv ;
  bak_ab_1_Adv : Adv ;
  bakefter_ab_1_Adv : Adv ;
  bakerst_ab_1_Adv : Adv ;
  bakfram_ab_1_Adv : Adv ;
  baki_ab_1_Adv : Adv ;
  bakifraan_ab_1_1_Adv : Adv ;
  baklaenges_ab_1_1_Adv : Adv ;
  bakom_ab_1_Adv : Adv ;
  bakpaa_ab_1_1_Adv : Adv ;
  baktill_ab_1_Adv : Adv ;
  bakut_ab_1_Adv : Adv ;
  bakvid_ab_1_Adv : Adv ;
  bakaat_ab_1_1_Adv : Adv ;
  bakoever_ab_1_1_Adv : Adv ;
  bara_ab_1_Adv : Adv ;
  behoerigen_ab_1_1_Adv : Adv ;
  beklagligen_ab_1_Adv : Adv ;
  beklagligtvis_ab_1_Adv : Adv ;
  bevisligen_ab_1_Adv : Adv ;
  bidevind_ab_1_Adv : Adv ;
  bitterligen_ab_1_Adv : Adv ;
  bittida_ab_1_Adv : Adv ;
  bitvis_ab_1_Adv : Adv ;
  blott_ab_1_Adv : Adv ;
  bokstavligen_ab_1_Adv : Adv ;
  bordvarts_ab_1_Adv : Adv ;
  bort_ab_1_Adv : Adv ;
  borta_ab_1_Adv : Adv ;
  bortanfoer_ab_1_1_Adv : Adv ;
  bortemot_ab_1_Adv : Adv ;
  borterst_ab_1_Adv : Adv ;
  bortifraan_ab_1_1_Adv : Adv ;
  bortigenom_ab_1_Adv : Adv ;
  bortom_ab_1_Adv : Adv ;
  bortaat_ab_1_1_Adv : Adv ;
  bortoever_ab_1_1_Adv : Adv ;
  bra_ab_1_Adv : Adv ;
  bredvid_ab_1_Adv : Adv ;
  brevledes_ab_1_Adv : Adv ;
  brutto_ab_1_Adv : Adv ;
  braadis_ab_1_1_Adv : Adv ;
  broestgaenges_ab_1_1_Adv : Adv ;
  bums_ab_1_Adv : Adv ;
  baade_ab_1_1_Adv : Adv ;
  cash_ab_1_Adv : Adv ;
  cif_ab_1_Adv : Adv ;
  comme_il_faut_ab_1_Adv : Adv ;
  crescendo_ab_1_Adv : Adv ;
  dagligdags_ab_1_Adv : Adv ;
  dagligen_ab_1_Adv : Adv ;
  dags_ab_1_Adv : Adv ;
  dels_ab_1_Adv : Adv ;
  delvis_ab_1_Adv : Adv ;
  dennes_ab_1_Adv : Adv ;
  dessbaettre_ab_1_1_Adv : Adv ;
  dessemellan_ab_1_Adv : Adv ;
  dessfoerinnan_ab_1_1_Adv : Adv ;
  dessfoerutan_ab_1_1_Adv : Adv ;
  desslikes_ab_1_Adv : Adv ;
  dessutom_ab_1_Adv : Adv ;
  dessvaerre_ab_1_1_Adv : Adv ;
  desto_ab_1_Adv : Adv ;
  deuce_ab_1_Adv : Adv ;
  dikt_ab_1_Adv : Adv ;
  diminuendo_ab_1_Adv : Adv ;
  direkt_ab_1_Adv : Adv ;
  dit_ab_1_Adv : Adv ;
  dithaen_ab_1_1_Adv : Adv ;
  ditin_ab_1_Adv : Adv ;
  ditintills_ab_1_Adv : Adv ;
  dittills_ab_1_Adv : Adv ;
  ditut_ab_1_Adv : Adv ;
  ditaat_ab_1_1_Adv : Adv ;
  djaevligt_ab_1_1_Adv : Adv ;
  dock_ab_1_Adv : Adv ;
  droppstilla_ab_1_Adv : Adv ;
  droppvis_ab_1_Adv : Adv ;
  dussinvis_ab_1_Adv : Adv ;
  dygnsvis_ab_1_Adv : Adv ;
  dymedels_ab_1_Adv : Adv ;
  dymedelst_ab_1_Adv : Adv ;
  daedan_ab_1_1_Adv : Adv ;
  daen_ab_1_1_Adv : Adv ;
  daer_ab_1_1_Adv : Adv ;
  daerav_ab_1_1_Adv : Adv ;
  daerbakom_ab_1_1_Adv : Adv ;
  daerborta_ab_1_1_Adv : Adv ;
  daerbortom_ab_1_1_Adv : Adv ;
  daerefter_ab_1_1_Adv : Adv ;
  daeremellan_ab_1_1_Adv : Adv ;
  daeremot_ab_1_1_Adv : Adv ;
  daerframme_ab_1_1_Adv : Adv ;
  daerfoer_ab_1_1_Adv : Adv ;
  daerfoere_ab_1_1_Adv : Adv ;
  daerfoerinnan_ab_1_1_Adv : Adv ;
  daerfoerutan_ab_1_1_Adv : Adv ;
  daerhemma_ab_1_1_Adv : Adv ;
  daerhaen_ab_1_1_Adv : Adv ;
  daeri_ab_1_1_Adv : Adv ;
  daeribland_ab_1_1_Adv : Adv ;
  daerifraan_ab_1_1_Adv : Adv ;
  daerigenom_ab_1_1_Adv : Adv ;
  daerinifraan_ab_1_1_Adv : Adv ;
  daerinne_ab_1_1_Adv : Adv ;
  daerjaemte_ab_1_1_Adv : Adv ;
  daermed_ab_1_1_Adv : Adv ;
  daernedanfoer_ab_1_1_Adv : Adv ;
  daernere_ab_1_1_Adv : Adv ;
  daernaest_ab_1_1_Adv : Adv ;
  daerom_ab_1_1_Adv : Adv ;
  daeromkring_ab_1_1_Adv : Adv ;
  daeroppe_ab_1_1_Adv : Adv ;
  daerovanfoer_ab_1_1_Adv : Adv ;
  daerpaa_ab_1_1_Adv : Adv ;
  daerstaedes_ab_1_1_Adv : Adv ;
  daertill_ab_1_1_Adv : Adv ;
  daerunder_ab_1_1_Adv : Adv ;
  daeruppe_ab_1_1_Adv : Adv ;
  daeruppifraan_ab_1_1_Adv : Adv ;
  daerur_ab_1_1_Adv : Adv ;
  daerutanfoer_ab_1_1_Adv : Adv ;
  daerutav_ab_1_1_Adv : Adv ;
  daerute_ab_1_1_Adv : Adv ;
  daerutinnan_ab_1_1_Adv : Adv ;
  daerutur_ab_1_1_Adv : Adv ;
  daerutoever_ab_1_1_Adv : Adv ;
  daervid_ab_1_1_Adv : Adv ;
  daervidlag_ab_1_1_Adv : Adv ;
  daeraat_ab_1_1_Adv : Adv ;
  daeroever_ab_1_1_Adv : Adv ;
  daa_ab_1_1_Adv : Adv ;
  daa_ab_2_1_Adv : Adv ;
  daafoertiden_ab_1_1_Adv : Adv ;
  daamera_ab_1_1_Adv : Adv ;
  edligen_ab_1_Adv : Adv ;
  efter_ab_1_Adv : Adv ;
  efterhand_ab_1_Adv : Adv ;
  efterst_ab_1_Adv : Adv ;
  eftertryckligen_ab_1_Adv : Adv ;
  efteraat_ab_1_1_Adv : Adv ;
  egentligen_ab_1_Adv : Adv ;
  ej_ab_1_Adv : Adv ;
  eljes_ab_1_Adv : Adv ;
  eljest_ab_1_Adv : Adv ;
  ellande_ab_1_Adv : Adv ;
  emellan_ab_1_Adv : Adv ;
  emellanaat_ab_1_1_Adv : Adv ;
  emellertid_ab_1_Adv : Adv ;
  emot_ab_1_Adv : Adv ;
  en_ab_1_Adv : Adv ;
  enbart_ab_1_Adv : Adv ;
  enda_av_1_A : A ;
  endast_ab_1_Adv : Adv ;
  endels_ab_1_Adv : Adv ;
  endera_ab_1_Adv : Adv ;
  enfaldeligen_ab_1_Adv : Adv ;
  engaang_ab_1_1_Adv : Adv ;
  enkannerligen_ab_1_Adv : Adv ;
  enkom_ab_1_Adv : Adv ;
  ens_ab_1_Adv : Adv ;
  erbarmligen_ab_1_Adv : Adv ;
  ergo_ab_1_Adv : Adv ;
  esomoftast_ab_1_Adv : Adv ;
  etappvis_ab_1_Adv : Adv ;
  etcetera_ab_1_Adv : Adv ;
  evar_ab_1_Adv : Adv ;
  evart_ab_1_Adv : Adv ;
  evinnerligen_ab_1_Adv : Adv ;
  exempelvis_ab_1_Adv : Adv ;
  express_ab_1_Adv : Adv ;
  extempore_ab_1_Adv : Adv ;
  extra_ab_1_Adv : Adv ;
  falskeligen_ab_1_Adv : Adv ;
  fast_ab_1_Adv : Adv ;
  fastmer_ab_1_Adv : Adv ;
  fastmera_ab_1_Adv : Adv ;
  fett_ab_1_Adv : Adv ;
  fikadags_ab_1_Adv : Adv ;
  fjaerran_ab_1_1_Adv : Adv ;
  flerstaedes_ab_1_1_Adv : Adv ;
  flott_ab_1_Adv : Adv ;
  flygledes_ab_1_Adv : Adv ;
  flaeckvis_ab_1_1_Adv : Adv ;
  fob_ab_1_Adv : Adv ;
  fordom_ab_1_Adv : Adv ;
  fordomdags_ab_1_Adv : Adv ;
  formaliter_ab_1_Adv : Adv ;
  formligen_ab_1_Adv : Adv ;
  fort_ab_1_Adv : Adv ;
  forte_ab_1_Adv : Adv ;
  fortfarande_ab_1_Adv : Adv ;
  fortissimo_ab_1_Adv : Adv ;
  fortsaettningsvis_ab_1_1_Adv : Adv ;
  fram_ab_1_Adv : Adv ;
  framdeles_ab_1_Adv : Adv ;
  framfoer_ab_1_1_Adv : Adv ;
  framfoerallt_ab_1_1_Adv : Adv ;
  framgent_ab_1_Adv : Adv ;
  framifraan_ab_1_1_Adv : Adv ;
  framlaenges_ab_1_1_Adv : Adv ;
  framme_ab_1_Adv : Adv ;
  frampaa_ab_1_1_Adv : Adv ;
  framstupa_ab_1_Adv : Adv ;
  framtill_ab_1_Adv : Adv ;
  framaat_ab_1_1_Adv : Adv ;
  framoever_ab_1_1_Adv : Adv ;
  franko_ab_1_Adv : Adv ;
  fruktansvaert_ab_1_1_Adv : Adv ;
  fraemst_ab_1_1_Adv : Adv ;
  fraan_ab_1_1_Adv : Adv ;
  fullkomligen_ab_1_Adv : Adv ;
  furioso_ab_1_Adv : Adv ;
  fyrfalt_ab_1_Adv : Adv ;
  foega_ab_1_1_Adv : Adv ;
  foeljaktligen_ab_1_1_Adv : Adv ;
  foer_ab_1_1_Adv : Adv ;
  foer_ab_2_1_Adv : Adv ;
  foerbi_ab_1_1_Adv : Adv ;
  foerbaalt_ab_1_1_Adv : Adv ;
  foerdenskull_ab_1_1_Adv : Adv ;
  foerdevind_ab_1_1_Adv : Adv ;
  foere_ab_1_1_Adv : Adv ;
  foeretraedesvis_ab_1_1_Adv : Adv ;
  foerfaerligt_ab_1_1_Adv : Adv ;
  foergaeves_ab_1_1_Adv : Adv ;
  foerhoppningsvis_ab_1_1_Adv : Adv ;
  foerhaallandevis_ab_1_1_Adv : Adv ;
  foermodligen_ab_1_1_Adv : Adv ;
  foernaemligast_ab_1_1_Adv : Adv ;
  foernaemligen_ab_1_1_Adv : Adv ;
  foernaer_ab_1_1_Adv : Adv ;
  foerr_ab_1_1_Adv : Adv ;
  foerra_av_1_1_A : A ;
  foerresten_ab_1_1_Adv : Adv ;
  foersent_ab_1_1_Adv : Adv ;
  foersiktighetsvis_ab_1_1_Adv : Adv ;
  foersiktigtvis_ab_1_1_Adv : Adv ;
  foerslagsvis_ab_1_1_Adv : Adv ;
  foerst_ab_1_1_Adv : Adv ;
  foerstaas_ab_1_1_Adv : Adv ;
  foersoeksvis_ab_1_1_Adv : Adv ;
  foerty_ab_1_1_Adv : Adv ;
  foerut_ab_1_1_Adv : Adv ;
  foerut_2_ab_1_1_Adv : Adv ;
  foervisso_ab_1_1_Adv : Adv ;
  foeroever_ab_1_1_Adv : Adv ;
  foeroevrigt_ab_1_1_Adv : Adv ;
  galant_ab_1_Adv : Adv ;
  ganska_ab_1_Adv : Adv ;
  gemenligen_ab_1_Adv : Adv ;
  genast_ab_1_Adv : Adv ;
  genom_ab_1_Adv : Adv ;
  genomgaaende_ab_1_1_Adv : Adv ;
  geschvint_ab_1_Adv : Adv ;
  geschwint_ab_1_Adv : Adv ;
  gesvint_ab_1_Adv : Adv ;
  gissningsvis_ab_1_Adv : Adv ;
  givetvis_ab_1_Adv : Adv ;
  gladeligen_ab_1_Adv : Adv ;
  gladligen_ab_1_Adv : Adv ;
  glimtvis_ab_1_Adv : Adv ;
  gradvis_ab_1_Adv : Adv ;
  granneligen_ab_1_Adv : Adv ;
  gratis_ab_1_Adv : Adv ;
  grave_ab_1_Adv : Adv ;
  grensle_ab_1_Adv : Adv ;
  grundligen_ab_1_Adv : Adv ;
  grymt_ab_1_Adv : Adv ;
  graensle_ab_1_1_Adv : Adv ;
  gudilov_ab_1_Adv : Adv ;
  gudinog_ab_1_Adv : Adv ;
  gudskelov_ab_1_Adv : Adv ;
  gaerna_ab_1_1_Adv : Adv ;
  halvvaegs_ab_1_1_Adv : Adv ;
  halvaarsvis_ab_1_1_Adv : Adv ;
  handgripligen_ab_1_Adv : Adv ;
  handloest_ab_1_1_Adv : Adv ;
  heller_ab_1_Adv : Adv ;
  hem_ab_1_Adv : Adv ;
  hemifraan_ab_1_1_Adv : Adv ;
  hemligen_ab_1_Adv : Adv ;
  hemma_ab_1_Adv : Adv ;
  hemmavid_ab_1_Adv : Adv ;
  hemskt_ab_1_Adv : Adv ;
  hemaat_ab_1_1_Adv : Adv ;
  himla_ab_1_Adv : Adv ;
  hinkvis_ab_1_Adv : Adv ;
  hit_ab_1_Adv : Adv ;
  hiterst_ab_1_Adv : Adv ;
  hitintills_ab_1_Adv : Adv ;
  hittilldags_ab_1_Adv : Adv ;
  hittills_ab_1_Adv : Adv ;
  hitaat_ab_1_1_Adv : Adv ;
  hjaertans_ab_1_1_Adv : Adv ;
  hjaertligen_ab_1_1_Adv : Adv ;
  hoppeligen_ab_1_Adv : Adv ;
  hundrafalt_ab_1_Adv : Adv ;
  hur_ab_1_Adv : Adv ;
  hursomhaver_ab_1_Adv : Adv ;
  hursomhelst_ab_1_Adv : Adv ;
  huru_ab_1_Adv : Adv ;
  huruledes_ab_1_Adv : Adv ;
  huvudsakligen_ab_1_Adv : Adv ;
  huvudstupa_ab_1_Adv : Adv ;
  haedan_ab_1_1_Adv : Adv ;
  haedanefter_ab_1_1_Adv : Adv ;
  haen_ab_1_1_Adv : Adv ;
  haendelsevis_ab_1_1_Adv : Adv ;
  haer_ab_1_1_Adv : Adv ;
  haerav_ab_1_1_Adv : Adv ;
  haerefter_ab_1_1_Adv : Adv ;
  haeremot_ab_1_1_Adv : Adv ;
  haerfoer_ab_1_1_Adv : Adv ;
  haerfoerleden_ab_1_1_Adv : Adv ;
  haerhemma_ab_1_1_Adv : Adv ;
  haeri_ab_1_1_Adv : Adv ;
  haerifraan_ab_1_1_Adv : Adv ;
  haerigenom_ab_1_1_Adv : Adv ;
  haerinne_ab_1_1_Adv : Adv ;
  haerintill_ab_1_1_Adv : Adv ;
  haerjaemte_ab_1_1_Adv : Adv ;
  haermed_ab_1_1_Adv : Adv ;
  haernere_ab_1_1_Adv : Adv ;
  haernaest_ab_1_1_Adv : Adv ;
  haerom_ab_1_1_Adv : Adv ;
  haeromdagen_ab_1_1_Adv : Adv ;
  haeromdan_ab_1_1_Adv : Adv ;
  haeromkring_ab_1_1_Adv : Adv ;
  haeromkvaellen_ab_1_1_Adv : Adv ;
  haerommaanaden_ab_1_1_Adv : Adv ;
  haeromnatten_ab_1_1_Adv : Adv ;
  haeromsistens_ab_1_1_Adv : Adv ;
  haeromveckan_ab_1_1_Adv : Adv ;
  haeromaaret_ab_1_1_Adv : Adv ;
  haerpaa_ab_1_1_Adv : Adv ;
  haerstaedes_ab_1_1_Adv : Adv ;
  haertill_ab_1_1_Adv : Adv ;
  haeruppe_ab_1_1_Adv : Adv ;
  haerute_ab_1_1_Adv : Adv ;
  haerutinnan_ab_1_1_Adv : Adv ;
  haerutoever_ab_1_1_Adv : Adv ;
  haervid_ab_1_1_Adv : Adv ;
  haervidlag_ab_1_1_Adv : Adv ;
  haeraat_ab_1_1_Adv : Adv ;
  hoegeligen_ab_1_1_Adv : Adv ;
  hoegst_ab_1_1_Adv : Adv ;
  hoegtidligen_ab_1_1_Adv : Adv ;
  hoerbarligen_ab_1_1_Adv : Adv ;
  i_ab_1_Adv : Adv ;
  ibidem_ab_1_Adv : Adv ;
  ibland_ab_1_Adv : Adv ;
  icke_ab_1_Adv : Adv ;
  idag_ab_1_Adv : Adv ;
  idel_ab_1_Adv : Adv ;
  ideligen_ab_1_Adv : Adv ;
  ifatt_ab_1_Adv : Adv ;
  ifjol_ab_1_Adv : Adv ;
  ifred_ab_1_Adv : Adv ;
  ifraaga_ab_1_1_Adv : Adv ;
  ifraan_ab_1_1_Adv : Adv ;
  igen_ab_1_Adv : Adv ;
  igen_ab_2_Adv : Adv ;
  igenom_ab_1_Adv : Adv ;
  igaang_ab_1_1_Adv : Adv ;
  igaar_ab_1_1_Adv : Adv ;
  ihjael_ab_1_1_Adv : Adv ;
  ihop_ab_1_Adv : Adv ;
  ikapp_ab_1_Adv : Adv ;
  ikraft_ab_1_Adv : Adv ;
  ikull_ab_1_Adv : Adv ;
  ikvaell_ab_1_1_Adv : Adv ;
  iland_ab_1_Adv : Adv ;
  illa_ab_1_Adv : Adv ;
  illande_ab_1_Adv : Adv ;
  imorgon_ab_1_Adv : Adv ;
  imorse_ab_1_Adv : Adv ;
  in_ab_1_Adv : Adv ;
  inalles_ab_1_Adv : Adv ;
  ingalunda_ab_1_Adv : Adv ;
  ingenstans_ab_1_Adv : Adv ;
  ingenstaedes_ab_1_1_Adv : Adv ;
  ingenvart_ab_1_Adv : Adv ;
  inifraan_ab_1_1_Adv : Adv ;
  inkognito_ab_1_Adv : Adv ;
  inledningsvis_ab_1_Adv : Adv ;
  innan_ab_1_Adv : Adv ;
  innanfoer_ab_1_1_Adv : Adv ;
  innantill_ab_1_Adv : Adv ;
  inne_ab_1_Adv : Adv ;
  innerligen_ab_1_Adv : Adv ;
  innerst_ab_1_Adv : Adv ;
  inombords_ab_1_Adv : Adv ;
  inomhus_ab_1_Adv : Adv ;
  inomlands_ab_1_Adv : Adv ;
  inomskaers_ab_1_1_Adv : Adv ;
  inrikes_ab_1_Adv : Adv ;
  inte_ab_1_Adv : Adv ;
  intill_ab_1_Adv : Adv ;
  inuti_ab_1_Adv : Adv ;
  invaertes_ab_1_1_Adv : Adv ;
  inaat_ab_1_1_Adv : Adv ;
  istaellet_ab_1_1_Adv : Adv ;
  isaender_ab_1_1_Adv : Adv ;
  isaer_ab_1_1_Adv : Adv ;
  itu_ab_1_Adv : Adv ;
  ity_ab_1_Adv : Adv ;
  ivaeg_ab_1_1_Adv : Adv ;
  ju_ab_1_Adv : Adv ;
  just_ab_1_Adv : Adv ;
  jaemfota_ab_1_1_Adv : Adv ;
  jaemfoerelsevis_ab_1_1_Adv : Adv ;
  jaems_ab_1_1_Adv : Adv ;
  jaemsides_ab_1_1_Adv : Adv ;
  jaemt_ab_1_1_Adv : Adv ;
  jaemvael_ab_1_1_Adv : Adv ;
  jaette_ab_1_1_Adv : Adv ;
  jaettelaenge_ab_1_1_Adv : Adv ;
  jaettemycket_ab_1_1_Adv : Adv ;
  jaetteofta_ab_1_1_Adv : Adv ;
  jaettesaellan_ab_1_1_Adv : Adv ;
  jaevligt_ab_1_1_Adv : Adv ;
  kaffedags_ab_1_Adv : Adv ;
  kajfritt_ab_1_Adv : Adv ;
  kanhaenda_ab_1_1_Adv : Adv ;
  kanonbra_ab_1_Adv : Adv ;
  kanske_ab_1_Adv : Adv ;
  kantaenka_ab_1_1_Adv : Adv ;
  kapitelvis_ab_1_Adv : Adv ;
  kav_ab_1_Adv : Adv ;
  klarligen_ab_1_Adv : Adv ;
  klockrent_ab_1_Adv : Adv ;
  kloss_ab_1_Adv : Adv ;
  klumpvis_ab_1_Adv : Adv ;
  knappast_ab_1_Adv : Adv ;
  knappt_ab_1_Adv : Adv ;
  korgvis_ab_1_Adv : Adv ;
  korsvis_ab_1_Adv : Adv ;
  kort_ab_1_Adv : Adv ;
  korteligen_ab_1_Adv : Adv ;
  kranbalksvis_ab_1_Adv : Adv ;
  kring_ab_1_Adv : Adv ;
  kroppsligen_ab_1_Adv : Adv ;
  kraesligen_ab_1_1_Adv : Adv ;
  kull_ab_1_Adv : Adv ;
  kundnaera_ab_1_1_Adv : Adv ;
  kustnaera_ab_1_1_Adv : Adv ;
  kvar_ab_1_Adv : Adv ;
  kvartalsvis_ab_1_Adv : Adv ;
  kaeppraett_ab_1_1_Adv : Adv ;
  kaerligen_ab_1_1_Adv : Adv ;
  lagligen_ab_1_Adv : Adv ;
  lagom_ab_1_Adv : Adv ;
  landledes_ab_1_Adv : Adv ;
  largetto_ab_1_Adv : Adv ;
  largo_ab_1_Adv : Adv ;
  legaliter_ab_1_Adv : Adv ;
  legato_ab_1_Adv : Adv ;
  lekamligen_ab_1_Adv : Adv ;
  liggdags_ab_1_Adv : Adv ;
  lika_ab_1_Adv : Adv ;
  likafullt_ab_1_Adv : Adv ;
  likaledes_ab_1_Adv : Adv ;
  likasom_ab_1_Adv : Adv ;
  likasaa_ab_1_1_Adv : Adv ;
  likasaavael_ab_1_1_Adv : Adv ;
  likavael_ab_1_1_Adv : Adv ;
  likmaetigt_ab_1_1_Adv : Adv ;
  liksom_ab_1_Adv : Adv ;
  likvisst_ab_1_Adv : Adv ;
  likvael_ab_1_1_Adv : Adv ;
  lite_ab_1_Adv : Adv ;
  litervis_ab_1_Adv : Adv ;
  litet_ab_1_Adv : Adv ;
  loco_ab_1_Adv : Adv ;
  loko_ab_1_Adv : Adv ;
  loss_ab_1_Adv : Adv ;
  luftledes_ab_1_Adv : Adv ;
  lyckligen_ab_1_Adv : Adv ;
  lyckligtvis_ab_1_Adv : Adv ;
  laeggdags_ab_1_1_Adv : Adv ;
  laempligen_ab_1_1_Adv : Adv ;
  laenge_ab_1_1_Adv : Adv ;
  laengesedan_ab_1_1_Adv : Adv ;
  laengesen_ab_1_1_Adv : Adv ;
  laengs_ab_1_1_Adv : Adv ;
  laengst_ab_1_1_Adv : Adv ;
  laensvis_ab_1_1_Adv : Adv ;
  laetteligen_ab_1_1_Adv : Adv ;
  laangsides_ab_1_1_Adv : Adv ;
  laangskepps_ab_1_1_Adv : Adv ;
  laangt_ab_1_1_Adv : Adv ;
  laangtbortifraan_ab_1_1_Adv : Adv ;
  laangtifraan_ab_1_1_Adv : Adv ;
  loennligen_ab_1_1_Adv : Adv ;
  malapropaa_ab_1_1_Adv : Adv ;
  massvis_ab_1_Adv : Adv ;
  mastfritt_ab_1_Adv : Adv ;
  med_ab_1_Adv : Adv ;
  med_ab_2_Adv : Adv ;
  meddetsamma_ab_1_Adv : Adv ;
  medhaars_ab_1_1_Adv : Adv ;
  medsamma_ab_1_Adv : Adv ;
  medsols_ab_1_Adv : Adv ;
  medstroems_ab_1_1_Adv : Adv ;
  medurs_ab_1_Adv : Adv ;
  mellerst_ab_1_Adv : Adv ;
  mer_ab_1_Adv : Adv ;
  mera_ab_1_Adv : Adv ;
  merendels_ab_1_Adv : Adv ;
  mestadels_ab_1_Adv : Adv ;
  metervis_ab_1_Adv : Adv ;
  mezzoforte_ab_1_Adv : Adv ;
  midskepps_ab_1_Adv : Adv ;
  midvattens_ab_1_Adv : Adv ;
  miltals_ab_1_Adv : Adv ;
  minsann_ab_1_Adv : Adv ;
  minst_ab_1_Adv : Adv ;
  miste_ab_1_Adv : Adv ;
  mitt_ab_1_Adv : Adv ;
  mittemellan_ab_1_Adv : Adv ;
  mittemot_ab_1_Adv : Adv ;
  mitterst_ab_1_Adv : Adv ;
  mittsunds_ab_1_Adv : Adv ;
  mol_ab_1_Adv : Adv ;
  mot_ab_1_Adv : Adv ;
  mothaars_ab_1_1_Adv : Adv ;
  motsols_ab_1_Adv : Adv ;
  motstroems_ab_1_1_Adv : Adv ;
  moturs_ab_1_Adv : Adv ;
  muntligen_ab_1_Adv : Adv ;
  mycket_ab_1_Adv : Adv ;
  maekta_ab_1_1_Adv : Adv ;
  maengdvis_ab_1_1_Adv : Adv ;
  maahaenda_ab_1_1_Adv : Adv ;
  maanadsvis_ab_1_1_Adv : Adv ;
  maanatligen_ab_1_1_Adv : Adv ;
  maangenstaedes_ab_1_1_Adv : Adv ;
  maangfalt_ab_1_1_Adv : Adv ;
  maanne_ab_1_1_Adv : Adv ;
  maanntro_ab_1_1_Adv : Adv ;
  maatro_ab_1_1_Adv : Adv ;
  moejligen_ab_1_1_Adv : Adv ;
  moejligtvis_ab_1_1_Adv : Adv ;
  naggande_ab_1_Adv : Adv ;
  namneligen_ab_1_Adv : Adv ;
  nationsvis_ab_1_Adv : Adv ;
  nattetid_ab_1_Adv : Adv ;
  naturligen_ab_1_Adv : Adv ;
  naturligtvis_ab_1_Adv : Adv ;
  ned_ab_1_Adv : Adv ;
  nedan_ab_1_Adv : Adv ;
  nedanfoer_ab_1_1_Adv : Adv ;
  neder_ab_1_Adv : Adv ;
  nederst_ab_1_Adv : Adv ;
  nedfoer_ab_1_1_Adv : Adv ;
  nedifraan_ab_1_1_Adv : Adv ;
  nedom_ab_1_Adv : Adv ;
  nedstroems_ab_1_1_Adv : Adv ;
  nedtill_ab_1_Adv : Adv ;
  nedaat_ab_1_1_Adv : Adv ;
  ner_ab_1_Adv : Adv ;
  nere_ab_1_Adv : Adv ;
  nerfoer_ab_1_1_Adv : Adv ;
  nerifraan_ab_1_1_Adv : Adv ;
  nerom_ab_1_Adv : Adv ;
  nerstroems_ab_1_1_Adv : Adv ;
  nertill_ab_1_Adv : Adv ;
  neraat_ab_1_1_Adv : Adv ;
  nesligen_ab_1_Adv : Adv ;
  netto_ab_1_Adv : Adv ;
  nog_ab_1_Adv : Adv ;
  noga_ab_1_Adv : Adv ;
  nogav_ab_1_Adv : Adv ;
  nogsamt_ab_1_Adv : Adv ;
  nonstop_ab_1_Adv : Adv ;
  nordan_ab_1_Adv : Adv ;
  nordnordost_ab_1_Adv : Adv ;
  nordnordvaest_ab_1_1_Adv : Adv ;
  nordost_ab_1_Adv : Adv ;
  nordpaa_ab_1_1_Adv : Adv ;
  nordvart_ab_1_Adv : Adv ;
  nordvaest_ab_1_1_Adv : Adv ;
  nordoest_ab_1_1_Adv : Adv ;
  normaliter_ab_1_Adv : Adv ;
  norr_ab_1_Adv : Adv ;
  norrifraan_ab_1_1_Adv : Adv ;
  norrpaa_ab_1_1_Adv : Adv ;
  norrut_ab_1_Adv : Adv ;
  norroever_ab_1_1_Adv : Adv ;
  nu_ab_1_Adv : Adv ;
  nufoertiden_ab_1_1_Adv : Adv ;
  numer_ab_1_Adv : Adv ;
  numera_ab_1_Adv : Adv ;
  nutilldags_ab_1_Adv : Adv ;
  nyligen_ab_1_Adv : Adv ;
  nyss_ab_1_Adv : Adv ;
  nyssbemaelda_av_1_1_A : A ;
  nyssbemaelta_av_1_1_A : A ;
  nyssberoerda_av_1_1_A : A ;
  nyssnaemnda_av_1_1_A : A ;
  naemligen_ab_1_1_Adv : Adv ;
  naeppeligen_ab_1_1_Adv : Adv ;
  naer_ab_1_1_Adv : Adv ;
  naera_ab_1_1_Adv : Adv ;
  naerapaa_ab_1_1_Adv : Adv ;
  naest_ab_1_1_Adv : Adv ;
  naesta_av_1_1_A : A ;
  naestan_ab_1_1_Adv : Adv ;
  naestans_ab_1_1_Adv : Adv ;
  naestgaards_ab_1_1_Adv : Adv ;
  naestintill_ab_1_1_Adv : Adv ;
  naett_ab_1_1_Adv : Adv ;
  naettopp_ab_1_1_Adv : Adv ;
  naettupp_ab_1_1_Adv : Adv ;
  naadeligen_ab_1_1_Adv : Adv ;
  naagongaang_ab_1_1_Adv : Adv ;
  naagonsin_ab_1_1_Adv : Adv ;
  naagonstans_ab_1_1_Adv : Adv ;
  naagonstaedes_ab_1_1_Adv : Adv ;
  naagonvart_ab_1_1_Adv : Adv ;
  naagorlunda_ab_1_1_Adv : Adv ;
  naagotsaanaer_ab_1_1_Adv : Adv ;
  naangaang_ab_1_1_Adv : Adv ;
  naansin_ab_1_1_Adv : Adv ;
  naanstans_ab_1_1_Adv : Adv ;
  naanvart_ab_1_1_Adv : Adv ;
  naatsaanaer_ab_1_1_Adv : Adv ;
  noedvaendigtvis_ab_1_1_Adv : Adv ;
  oavlaatligen_ab_1_1_Adv : Adv ;
  oavsiktligen_ab_1_Adv : Adv ;
  oavvaent_ab_1_1_Adv : Adv ;
  obehindrat_ab_1_Adv : Adv ;
  obehoerigen_ab_1_1_Adv : Adv ;
  obestridligen_ab_1_Adv : Adv ;
  oboenhoerligen_ab_1_1_Adv : Adv ;
  ock_ab_1_Adv : Adv ;
  ocksaa_ab_1_1_Adv : Adv ;
  offentligen_ab_1_Adv : Adv ;
  offside_ab_1_Adv : Adv ;
  ofraankomligen_ab_1_1_Adv : Adv ;
  ofta_ab_1_Adv : Adv ;
  ofoerdroejligen_ab_1_1_Adv : Adv ;
  ofoerhappandes_ab_1_1_Adv : Adv ;
  ofoervarandes_ab_1_1_Adv : Adv ;
  ogaerna_ab_1_1_Adv : Adv ;
  olika_ab_1_Adv : Adv ;
  olovandes_ab_1_Adv : Adv ;
  olovligen_ab_1_Adv : Adv ;
  olyckligtvis_ab_1_Adv : Adv ;
  om_ab_1_Adv : Adv ;
  ombord_ab_1_Adv : Adv ;
  omedelbums_ab_1_Adv : Adv ;
  omgaaende_ab_1_1_Adv : Adv ;
  omigen_ab_1_Adv : Adv ;
  omintet_ab_1_Adv : Adv ;
  omkring_ab_1_Adv : Adv ;
  omkull_ab_1_Adv : Adv ;
  omlott_ab_1_Adv : Adv ;
  omsider_ab_1_Adv : Adv ;
  omstyr_ab_1_Adv : Adv ;
  omsaender_ab_1_1_Adv : Adv ;
  omoejligen_ab_1_1_Adv : Adv ;
  on_line_ab_1_Adv : Adv ;
  onekligen_ab_1_Adv : Adv ;
  online_ab_1_Adv : Adv ;
  onoedigtvis_ab_1_1_Adv : Adv ;
  opp_ab_1_Adv : Adv ;
  oppe_ab_1_Adv : Adv ;
  oppemot_ab_1_Adv : Adv ;
  oppfoer_ab_1_1_Adv : Adv ;
  oppifraan_ab_1_1_Adv : Adv ;
  oppochned_ab_1_Adv : Adv ;
  oppochner_ab_1_Adv : Adv ;
  oppstroems_ab_1_1_Adv : Adv ;
  oppaaned_ab_1_1_Adv : Adv ;
  oppaaner_ab_1_1_Adv : Adv ;
  oppaat_ab_1_1_Adv : Adv ;
  ost_ab_1_Adv : Adv ;
  ostanfraan_ab_1_1_Adv : Adv ;
  ostanifraan_ab_1_1_Adv : Adv ;
  ostnordost_ab_1_Adv : Adv ;
  ostsydost_ab_1_Adv : Adv ;
  ostvart_ab_1_Adv : Adv ;
  osoekt_ab_1_1_Adv : Adv ;
  otillboerligen_ab_1_1_Adv : Adv ;
  otroligt_ab_1_Adv : Adv ;
  oundgaengligen_ab_1_1_Adv : Adv ;
  oundvikligen_ab_1_Adv : Adv ;
  oupphoerligen_ab_1_1_Adv : Adv ;
  oupploesligen_ab_1_1_Adv : Adv ;
  ovan_ab_1_Adv : Adv ;
  ovanbemaelda_av_1_1_A : A ;
  ovanbemaelta_av_1_1_A : A ;
  ovanbords_ab_1_Adv : Adv ;
  ovanfoer_ab_1_1_Adv : Adv ;
  ovanifraan_ab_1_1_Adv : Adv ;
  ovanpaa_ab_1_1_Adv : Adv ;
  ovantill_ab_1_Adv : Adv ;
  ovedersaegligen_ab_1_1_Adv : Adv ;
  ovillkorligen_ab_1_Adv : Adv ;
  oaaterkalleligen_ab_1_1_Adv : Adv ;
  parlando_ab_1_Adv : Adv ;
  partout_ab_1_Adv : Adv ;
  parvis_ab_1_Adv : Adv ;
  periodvis_ab_1_Adv : Adv ;
  personligen_ab_1_Adv : Adv ;
  pianissimo_ab_1_Adv : Adv ;
  piano_ab_1_Adv : Adv ;
  pin_ab_1_Adv : Adv ;
  pizzicato_ab_1_Adv : Adv ;
  pladask_ab_1_Adv : Adv ;
  platt_ab_1_Adv : Adv ;
  ploetsligen_ab_1_1_Adv : Adv ;
  precis_ab_1_Adv : Adv ;
  presto_ab_1_Adv : Adv ;
  prick_ab_1_Adv : Adv ;
  privatim_ab_1_Adv : Adv ;
  prompt_ab_1_Adv : Adv ;
  punktvis_ab_1_Adv : Adv ;
  pyrt_ab_1_Adv : Adv ;
  paa_ab_1_1_Adv : Adv ;
  realiter_ab_1_Adv : Adv ;
  redan_ab_1_Adv : Adv ;
  redligen_ab_1_Adv : Adv ;
  relativt_ab_1_Adv : Adv ;
  ren_ab_1_Adv : Adv ;
  rentav_ab_1_Adv : Adv ;
  rentut_ab_1_Adv : Adv ;
  rentutav_ab_1_Adv : Adv ;
  reverenter_ab_1_Adv : Adv ;
  rikligen_ab_1_Adv : Adv ;
  rimligen_ab_1_Adv : Adv ;
  rimligtvis_ab_1_Adv : Adv ;
  ritardando_ab_1_Adv : Adv ;
  runt_ab_1_Adv : Adv ;
  runtikring_ab_1_Adv : Adv ;
  runtom_ab_1_Adv : Adv ;
  runtomkring_ab_1_Adv : Adv ;
  ryckvis_ab_1_Adv : Adv ;
  rykande_ab_1_Adv : Adv ;
  raett_ab_1_1_Adv : Adv ;
  raetteligen_ab_1_1_Adv : Adv ;
  sakloest_ab_1_1_Adv : Adv ;
  sakta_ab_1_Adv : Adv ;
  sakteliga_ab_1_Adv : Adv ;
  sakteligen_ab_1_Adv : Adv ;
  saligen_ab_1_Adv : Adv ;
  sammaledes_ab_1_Adv : Adv ;
  sammalunda_ab_1_Adv : Adv ;
  samman_ab_1_Adv : Adv ;
  sammanfattningsvis_ab_1_Adv : Adv ;
  sammastaedes_ab_1_1_Adv : Adv ;
  sannerligen_ab_1_Adv : Adv ;
  scherzando_ab_1_Adv : Adv ;
  sedan_ab_1_Adv : Adv ;
  sedermera_ab_1_Adv : Adv ;
  sen_ab_1_Adv : Adv ;
  senare_ab_1_Adv : Adv ;
  senast_ab_1_Adv : Adv ;
  separatim_ab_1_Adv : Adv ;
  sforzando_ab_1_Adv : Adv ;
  sic_ab_1_Adv : Adv ;
  sidledes_ab_1_Adv : Adv ;
  sidlaenges_ab_1_1_Adv : Adv ;
  sinsemellan_ab_1_Adv : Adv ;
  sist_ab_1_Adv : Adv ;
  sista_av_1_A : A ;
  sistbemaelda_av_1_1_A : A ;
  sistbemaelta_av_1_1_A : A ;
  sistens_ab_1_Adv : Adv ;
  sistnaemnda_av_1_1_A : A ;
  sisaadaer_ab_1_1_Adv : Adv ;
  sjuckert_ab_1_Adv : Adv ;
  sjuhelvetes_ab_1_Adv : Adv ;
  sjukt_ab_1_Adv : Adv ;
  sjusaerdeles_ab_1_1_Adv : Adv ;
  sjaelsligen_ab_1_1_Adv : Adv ;
  sjaelvfallet_ab_1_1_Adv : Adv ;
  sjaelvmant_ab_1_1_Adv : Adv ;
  sjoeledes_ab_1_1_Adv : Adv ;
  skaffoettes_ab_1_1_Adv : Adv ;
  skafoettes_ab_1_1_Adv : Adv ;
  skamligen_ab_1_Adv : Adv ;
  skarpt_ab_1_Adv : Adv ;
  skavfoetters_ab_1_1_Adv : Adv ;
  skedvis_ab_1_Adv : Adv ;
  skenbarligen_ab_1_Adv : Adv ;
  skriftligen_ab_1_Adv : Adv ;
  skvatt_ab_1_Adv : Adv ;
  skymfligen_ab_1_Adv : Adv ;
  skaeligen_ab_1_1_Adv : Adv ;
  skaendligen_ab_1_1_Adv : Adv ;
  slumpvis_ab_1_Adv : Adv ;
  slutligen_ab_1_Adv : Adv ;
  smaaningom_ab_1_1_Adv : Adv ;
  snarare_ab_1_Adv : Adv ;
  snarast_ab_1_Adv : Adv ;
  snarliga_ab_1_Adv : Adv ;
  snarligen_ab_1_Adv : Adv ;
  snart_ab_1_Adv : Adv ;
  solbrilledags_ab_1_Adv : Adv ;
  solraett_ab_1_1_Adv : Adv ;
  som_ab_1_Adv : Adv ;
  sommartid_ab_1_Adv : Adv ;
  spik_ab_1_Adv : Adv ;
  splitt_ab_1_Adv : Adv ;
  splitter_ab_1_Adv : Adv ;
  spritt_ab_1_Adv : Adv ;
  spraangvis_ab_1_1_Adv : Adv ;
  sta_ab_1_Adv : Adv ;
  stackato_ab_1_Adv : Adv ;
  stegvis_ab_1_Adv : Adv ;
  still_ab_1_Adv : Adv ;
  stilla_ab_1_Adv : Adv ;
  stint_ab_1_Adv : Adv ;
  storliga_ab_1_Adv : Adv ;
  storligen_ab_1_Adv : Adv ;
  strax_ab_1_Adv : Adv ;
  straengeligen_ab_1_1_Adv : Adv ;
  stundligen_ab_1_Adv : Adv ;
  stundom_ab_1_Adv : Adv ;
  stundtals_ab_1_Adv : Adv ;
  stundvis_ab_1_Adv : Adv ;
  styckevis_ab_1_Adv : Adv ;
  styckvis_ab_1_Adv : Adv ;
  styrbord_ab_1_Adv : Adv ;
  staedse_ab_1_1_Adv : Adv ;
  stoert_ab_1_1_Adv : Adv ;
  stoetvis_ab_1_1_Adv : Adv ;
  svaara_ab_1_1_Adv : Adv ;
  svaarligen_ab_1_1_Adv : Adv ;
  syd_ab_1_Adv : Adv ;
  sydost_ab_1_Adv : Adv ;
  sydvart_ab_1_Adv : Adv ;
  sydvaest_ab_1_1_Adv : Adv ;
  sydoest_ab_1_1_Adv : Adv ;
  synbarligen_ab_1_Adv : Adv ;
  synd_ab_1_Adv : Adv ;
  synnerligen_ab_1_Adv : Adv ;
  saekerligen_ab_1_1_Adv : Adv ;
  saellan_ab_1_1_Adv : Adv ;
  saengdags_ab_1_1_Adv : Adv ;
  saerdeles_ab_1_1_Adv : Adv ;
  saerla_ab_1_1_Adv : Adv ;
  saerskilt_ab_1_1_Adv : Adv ;
  saesongsvis_ab_1_1_Adv : Adv ;
  saa_ab_1_1_Adv : Adv ;
  saadaer_ab_1_1_Adv : Adv ;
  saahaer_ab_1_1_Adv : Adv ;
  saaklart_ab_1_1_Adv : Adv ;
  saaledes_ab_1_1_Adv : Adv ;
  saalunda_ab_1_1_Adv : Adv ;
  saanaer_ab_1_1_Adv : Adv ;
  saapass_ab_1_1_Adv : Adv ;
  saatillvida_ab_1_1_Adv : Adv ;
  saavitt_ab_1_1_Adv : Adv ;
  saavael_ab_1_1_Adv : Adv ;
  soeder_ab_1_1_Adv : Adv ;
  soederifraan_ab_1_1_Adv : Adv ;
  soederut_ab_1_1_Adv : Adv ;
  soederoever_ab_1_1_Adv : Adv ;
  soender_ab_1_1_Adv : Adv ;
  tedags_ab_1_Adv : Adv ;
  telefonledes_ab_1_Adv : Adv ;
  tidigare_ab_1_Adv : Adv ;
  tidigast_ab_1_Adv : Adv ;
  tidtals_ab_1_Adv : Adv ;
  tidvis_ab_1_Adv : Adv ;
  till_ab_1_Adv : Adv ;
  tillbaka_ab_1_Adv : Adv ;
  tillbaks_ab_1_Adv : Adv ;
  tillbuds_ab_1_Adv : Adv ;
  tillboerligen_ab_1_1_Adv : Adv ;
  tilldels_ab_1_Adv : Adv ;
  tillfinnandes_ab_1_Adv : Adv ;
  tillfullo_ab_1_Adv : Adv ;
  tillfyllest_ab_1_Adv : Adv ;
  tillfaelligtvis_ab_1_1_Adv : Adv ;
  tillfoerne_ab_1_1_Adv : Adv ;
  tillgodo_ab_1_Adv : Adv ;
  tillhanda_ab_1_Adv : Adv ;
  tillhands_ab_1_Adv : Adv ;
  tillhopa_ab_1_Adv : Adv ;
  tillika_ab_1_Adv : Adv ;
  tillmoetes_ab_1_1_Adv : Adv ;
  tillnaermelsevis_ab_1_1_Adv : Adv ;
  tillpass_ab_1_Adv : Adv ;
  tillreds_ab_1_Adv : Adv ;
  tillraetta_ab_1_1_Adv : Adv ;
  tillsamman_ab_1_Adv : Adv ;
  tillsammans_ab_1_Adv : Adv ;
  tillspillo_ab_1_Adv : Adv ;
  tillstaedes_ab_1_1_Adv : Adv ;
  tillsvidare_ab_1_Adv : Adv ;
  tillsynes_ab_1_Adv : Adv ;
  tillviljes_ab_1_Adv : Adv ;
  tillaenda_ab_1_1_Adv : Adv ;
  tillaeventyrs_ab_1_1_Adv : Adv ;
  timtals_ab_1_Adv : Adv ;
  timvis_ab_1_Adv : Adv ;
  tiofalt_ab_1_Adv : Adv ;
  tjaenste_ab_1_1_Adv : Adv ;
  tonvis_ab_1_Adv : Adv ;
  totaliter_ab_1_Adv : Adv ;
  trefalt_ab_1_Adv : Adv ;
  troligen_ab_1_Adv : Adv ;
  troligtvis_ab_1_Adv : Adv ;
  turvis_ab_1_Adv : Adv ;
  tusenfalt_ab_1_Adv : Adv ;
  tvivelsutan_ab_1_Adv : Adv ;
  tvaers_ab_1_1_Adv : Adv ;
  tvaersemot_ab_1_1_Adv : Adv ;
  tvaersigenom_ab_1_1_Adv : Adv ;
  tvaerskepps_ab_1_1_Adv : Adv ;
  tvaersom_ab_1_1_Adv : Adv ;
  tvaersoever_ab_1_1_Adv : Adv ;
  tvaertemot_ab_1_1_Adv : Adv ;
  tvaertom_ab_1_1_Adv : Adv ;
  tvaangsvis_ab_1_1_Adv : Adv ;
  tydligen_ab_1_Adv : Adv ;
  tydligtvis_ab_1_Adv : Adv ;
  typ_ab_1_Adv : Adv ;
  tyvaerr_ab_1_1_Adv : Adv ;
  taemligen_ab_1_1_Adv : Adv ;
  toerhaenda_ab_1_1_Adv : Adv ;
  ultimo_ab_1_Adv : Adv ;
  undan_ab_1_Adv : Adv ;
  undantagsvis_ab_1_Adv : Adv ;
  under_ab_1_Adv : Adv ;
  underdaanigst_ab_1_1_Adv : Adv ;
  underifraan_ab_1_1_Adv : Adv ;
  underst_ab_1_Adv : Adv ;
  understundom_ab_1_Adv : Adv ;
  undertill_ab_1_Adv : Adv ;
  undervaegs_ab_1_1_Adv : Adv ;
  ungefaer_ab_1_1_Adv : Adv ;
  ungefaerligen_ab_1_1_Adv : Adv ;
  upp_ab_1_Adv : Adv ;
  uppe_ab_1_Adv : Adv ;
  uppemot_ab_1_Adv : Adv ;
  uppenbarligen_ab_1_Adv : Adv ;
  uppepaa_ab_1_1_Adv : Adv ;
  uppfoer_ab_1_1_Adv : Adv ;
  uppifraan_ab_1_1_Adv : Adv ;
  upplysningsvis_ab_1_Adv : Adv ;
  uppochned_ab_1_Adv : Adv ;
  uppochner_ab_1_Adv : Adv ;
  uppskattningsvis_ab_1_Adv : Adv ;
  uppstroems_ab_1_1_Adv : Adv ;
  uppsaatligen_ab_1_1_Adv : Adv ;
  upptill_ab_1_Adv : Adv ;
  uppaaned_ab_1_1_Adv : Adv ;
  uppaaner_ab_1_1_Adv : Adv ;
  uppaat_ab_1_1_Adv : Adv ;
  ur_ab_1_Adv : Adv ;
  urbota_ab_1_Adv : Adv ;
  ursprungligen_ab_1_Adv : Adv ;
  ut_ab_1_Adv : Adv ;
  utanfoer_ab_1_1_Adv : Adv ;
  utanpaa_ab_1_1_Adv : Adv ;
  utantill_ab_1_Adv : Adv ;
  utav_ab_1_Adv : Adv ;
  ute_ab_1_Adv : Adv ;
  uteslutande_ab_1_Adv : Adv ;
  utfoer_ab_1_1_Adv : Adv ;
  utifraan_ab_1_1_Adv : Adv ;
  utombords_ab_1_Adv : Adv ;
  utombys_ab_1_Adv : Adv ;
  utomhus_ab_1_Adv : Adv ;
  utomlands_ab_1_Adv : Adv ;
  utomskaers_ab_1_1_Adv : Adv ;
  utrikes_ab_1_Adv : Adv ;
  utsocknes_ab_1_Adv : Adv ;
  uttryckligen_ab_1_Adv : Adv ;
  utvaertes_ab_1_1_Adv : Adv ;
  utaat_ab_1_1_Adv : Adv ;
  vackert_ab_1_Adv : Adv ;
  vad_ab_1_Adv : Adv ;
  vadan_ab_1_Adv : Adv ;
  vadfalls_ab_1_Adv : Adv ;
  vadaa_ab_1_1_Adv : Adv ;
  vafalls_ab_1_Adv : Adv ;
  vajert_ab_1_Adv : Adv ;
  vanligen_ab_1_Adv : Adv ;
  vanligtvis_ab_1_Adv : Adv ;
  vansinnigt_ab_1_Adv : Adv ;
  var_ab_1_Adv : Adv ;
  varav_ab_1_Adv : Adv ;
  vardagsnaera_ab_1_1_Adv : Adv ;
  varefter_ab_1_Adv : Adv ;
  varemot_ab_1_Adv : Adv ;
  varest_ab_1_Adv : Adv ;
  varfoer_ab_1_1_Adv : Adv ;
  varfoere_ab_1_1_Adv : Adv ;
  varhelst_ab_1_Adv : Adv ;
  vari_ab_1_Adv : Adv ;
  varibland_ab_1_Adv : Adv ;
  varifraan_ab_1_1_Adv : Adv ;
  varigenom_ab_1_Adv : Adv ;
  varjaemte_ab_1_1_Adv : Adv ;
  varken_ab_1_Adv : Adv ;
  varliga_ab_1_Adv : Adv ;
  varligen_ab_1_Adv : Adv ;
  varmed_ab_1_Adv : Adv ;
  varom_ab_1_Adv : Adv ;
  varpaa_ab_1_1_Adv : Adv ;
  varsomhelst_ab_1_Adv : Adv ;
  vart_ab_1_Adv : Adv ;
  vartefter_ab_1_Adv : Adv ;
  varthelst_ab_1_Adv : Adv ;
  varthaen_ab_1_1_Adv : Adv ;
  vartill_ab_1_Adv : Adv ;
  vartsomhelst_ab_1_Adv : Adv ;
  vartaat_ab_1_1_Adv : Adv ;
  varunder_ab_1_Adv : Adv ;
  varur_ab_1_Adv : Adv ;
  varuti_ab_1_Adv : Adv ;
  varutinnan_ab_1_Adv : Adv ;
  varvid_ab_1_Adv : Adv ;
  varvidlag_ab_1_Adv : Adv ;
  varoever_ab_1_1_Adv : Adv ;
  veckovis_ab_1_Adv : Adv ;
  vederboerligen_ab_1_1_Adv : Adv ;
  verbaliter_ab_1_Adv : Adv ;
  verkligen_ab_1_Adv : Adv ;
  veterligen_ab_1_Adv : Adv ;
  veterligt_ab_1_Adv : Adv ;
  vi_ab_1_Adv : Adv ;
  vid_ab_1_Adv : Adv ;
  vida_ab_1_Adv : Adv ;
  vidare_ab_1_Adv : Adv ;
  vidi_ab_1_Adv : Adv ;
  vill_ab_1_Adv : Adv ;
  vilse_ab_1_Adv : Adv ;
  vindraett_ab_1_1_Adv : Adv ;
  vintertid_ab_1_Adv : Adv ;
  vips_ab_1_Adv : Adv ;
  visligen_ab_1_Adv : Adv ;
  visserligen_ab_1_Adv : Adv ;
  visst_ab_1_Adv : Adv ;
  vivace_ab_1_Adv : Adv ;
  vaeck_ab_1_1_Adv : Adv ;
  vael_ab_1_1_Adv : Adv ;
  vael_2_ab_1_1_Adv : Adv ;
  vaelan_ab_1_1_Adv : Adv ;
  vaeldans_ab_1_1_Adv : Adv ;
  vaeldeliga_ab_1_1_Adv : Adv ;
  vaeldeligen_ab_1_1_Adv : Adv ;
  vaenligen_ab_1_1_Adv : Adv ;
  vaenskapligen_ab_1_1_Adv : Adv ;
  vaesentligen_ab_1_1_Adv : Adv ;
  vaest_ab_1_1_Adv : Adv ;
  vaestan_ab_1_1_Adv : Adv ;
  vaestanhavs_ab_1_1_Adv : Adv ;
  vaester_ab_1_1_Adv : Adv ;
  vaesterut_ab_1_1_Adv : Adv ;
  vaestpaa_ab_1_1_Adv : Adv ;
  vaestvart_ab_1_1_Adv : Adv ;
  vaestoever_ab_1_1_Adv : Adv ;
  vaexelvis_ab_1_1_Adv : Adv ;
  vaadligen_ab_1_1_Adv : Adv ;
  voerdsamligen_ab_1_1_Adv : Adv ;
  ytledes_ab_1_Adv : Adv ;
  ytterst_ab_1_Adv : Adv ;
  aen_ab_1_1_Adv : Adv ;
  aenda_ab_1_1_Adv : Adv ;
  aendock_ab_1_1_Adv : Adv ;
  aendaa_ab_1_1_Adv : Adv ;
  aennu_ab_1_1_Adv : Adv ;
  aentligen_ab_1_1_Adv : Adv ;
  aerligen_ab_1_1_Adv : Adv ;
  aeven_ab_1_1_Adv : Adv ;
  aevenledes_ab_1_1_Adv : Adv ;
  aevensaa_ab_1_1_Adv : Adv ;
  aanyo_ab_1_1_Adv : Adv ;
  aaretom_ab_1_1_Adv : Adv ;
  aaretrunt_ab_1_1_Adv : Adv ;
  aarligen_ab_1_1_Adv : Adv ;
  aarsvis_ab_1_1_Adv : Adv ;
  aasido_ab_1_1_Adv : Adv ;
  aastad_ab_1_1_Adv : Adv ;
  aat_ab_1_1_Adv : Adv ;
  aater_ab_1_1_Adv : Adv ;
  aaterigen_ab_1_1_Adv : Adv ;
  aatminstone_ab_1_1_Adv : Adv ;
  aatskils_ab_1_1_Adv : Adv ;
  oegonaboej_ab_1_1_Adv : Adv ;
  oegonakroek_ab_1_1_Adv : Adv ;
  oegonblickligen_ab_1_1_Adv : Adv ;
  oegonskenligen_ab_1_1_Adv : Adv ;
  oemkligen_ab_1_1_Adv : Adv ;
  oemsevis_ab_1_1_Adv : Adv ;
  oemsom_ab_1_1_Adv : Adv ;
  oest_ab_1_1_Adv : Adv ;
  oestan_ab_1_1_Adv : Adv ;
  oester_ab_1_1_Adv : Adv ;
  oesterifraan_ab_1_1_Adv : Adv ;
  oesterut_ab_1_1_Adv : Adv ;
  oestpaa_ab_1_1_Adv : Adv ;
  oestvart_ab_1_1_Adv : Adv ;
  oestoever_ab_1_1_Adv : Adv ;
  oever_ab_1_1_Adv : Adv ;
  oeverallt_ab_1_1_Adv : Adv ;
  oeveralltifraan_ab_1_1_Adv : Adv ;
  oeverbord_ab_1_1_Adv : Adv ;
  oevergaangsvis_ab_1_1_Adv : Adv ;
  oeverhuvud_ab_1_1_Adv : Adv ;
  oeverhuvudtaget_ab_1_1_Adv : Adv ;
  oeverhoevan_ab_1_1_Adv : Adv ;
  oeverlag_ab_1_1_Adv : Adv ;
  oeverljutt_ab_1_1_Adv : Adv ;
  oevermaattan_ab_1_1_Adv : Adv ;
  oevernog_ab_1_1_Adv : Adv ;
  oeverst_ab_1_1_Adv : Adv ;
  oeveraenda_ab_1_1_Adv : Adv ;
  oevertygad_av_1_1_A : A ;
  oeversaallad_av_1_1_A : A ;
  oeverstoekad_av_1_1_A : A ;
  oeverspelad_av_1_1_A : A ;
  oeversnoead_av_1_1_A : A ;
  oeverriggad_av_1_1_A : A ;
  oeverrepresenterad_av_1_1_A : A ;
  oeverreklamerad_av_1_1_A : A ;
  oeverraskad_av_1_1_A : A ;
  oeverordnad_av_1_1_A : A ;
  oeverlastad_av_1_1_A : A ;
  oeverkvalificerad_av_1_1_A : A ;
  oeverilad_av_1_1_A : A ;
  oeverhopad_av_1_1_A : A ;
  oeverfoerfriskad_av_1_1_A : A ;
  oeverbelastad_av_1_1_A : A ;
  oeverbegaavad_av_1_1_A : A ;
  oeverbefolkad_av_1_1_A : A ;
  oeverbalanserad_av_1_1_A : A ;
  oemhudad_av_1_1_A : A ;
  oemhjaertad_av_1_1_A : A ;
  oemfotad_av_1_1_A : A ;
  oedesmaettad_av_1_1_A : A ;
  aatalad_av_1_1_A : A ;
  aarsgammal_av_1_1_A : A ;
  aangestladdad_av_1_1_A : A ;
  aaldrad_av_1_1_A : A ;
  aaldersfoeraendrad_av_1_1_A : A ;
  aaldersblandad_av_1_1_A : A ;
  aaderfoerkalkad_av_1_1_A : A ;
  aerad_av_1_1_A : A ;
  aeppelkindad_av_1_1_A : A ;
  aelskad_av_1_1_A : A ;
  aeggskalsfaergad_av_1_1_A : A ;
  aeggfaergad_av_1_1_A : A ;
  yrkesutbildad_av_1_A : A ;
  yrkesinriktad_av_1_A : A ;
  vaardskadad_av_1_1_A : A ;
  vaardad_av_1_1_A : A ;
  vaaldsplaagad_av_1_1_A : A ;
  vaagformad_av_1_1_A : A ;
  vaagad_av_1_1_A : A ;
  vaaffelmoenstrad_av_1_1_A : A ;
  vaerdeladdad_av_1_1_A : A ;
  vaepnad_av_1_1_A : A ;
  vaelvaardad_av_1_1_A : A ;
  vaelventilerad_av_1_1_A : A ;
  vaelutvecklad_av_1_1_A : A ;
  vaelutrustad_av_1_1_A : A ;
  vaelutbildad_av_1_1_A : A ;
  vaeluppfostrad_av_1_1_A : A ;
  vaeluniformerad_av_1_1_A : A ;
  vaelunderraettad_av_1_1_A : A ;
  vaelturnerad_av_1_1_A : A ;
  vaeltuktad_av_1_1_A : A ;
  vaeltraenad_av_1_1_A : A ;
  vaeltrimmad_av_1_1_A : A ;
  vaelsvarvad_av_1_1_A : A ;
  vaelstaedad_av_1_1_A : A ;
  vaelspaeckad_av_1_1_A : A ;
  vaelspelad_av_1_1_A : A ;
  vaelsorterad_av_1_1_A : A ;
  vaelskraeddad_av_1_1_A : A ;
  vaelskapad_av_1_1_A : A ;
  vaelsituerad_av_1_1_A : A ;
  vaelsinnad_av_1_1_A : A ;
  vaelsignad_av_1_1_A : A ;
  vaelrustad_av_1_1_A : A ;
  vaelriktad_av_1_1_A : A ;
  vaelrenommerad_av_1_1_A : A ;
  vaelpressad_av_1_1_A : A ;
  vaelplaegad_av_1_1_A : A ;
  vaelorganiserad_av_1_1_A : A ;
  vaelordnad_av_1_1_A : A ;
  vaelondulerad_av_1_1_A : A ;
  vaelmeriterad_av_1_1_A : A ;
  vaelmatad_av_1_1_A : A ;
  vaellyckad_av_1_1_A : A ;
  vaellagrad_av_1_1_A : A ;
  vaellagad_av_1_1_A : A ;
  vaelkryddad_av_1_1_A : A ;
  vaelkammad_av_1_1_A : A ;
  vaelisolerad_av_1_1_A : A ;
  vaelinformerad_av_1_1_A : A ;
  vaelgrundad_av_1_1_A : A ;
  vaelfoerraettad_av_1_1_A : A ;
  vaelfriserad_av_1_1_A : A ;
  vaelformad_av_1_1_A : A ;
  vaeldaterad_av_1_1_A : A ;
  vaelbaergad_av_1_1_A : A ;
  vaelborstad_av_1_1_A : A ;
  vaelbildad_av_1_1_A : A ;
  vaelbevarad_av_1_1_A : A ;
  vaelberaeknad_av_1_1_A : A ;
  vaelbeproevad_av_1_1_A : A ;
  vaelbemedlad_av_1_1_A : A ;
  vaelbefogad_av_1_1_A : A ;
  vaelbalanserad_av_1_1_A : A ;
  vaelavloenad_av_1_1_A : A ;
  vaelartad_av_1_1_A : A ;
  vaelansad_av_1_1_A : A ;
  vaelanpassad_av_1_1_A : A ;
  vaelaktad_av_1_1_A : A ;
  vrickad_av_1_A : A ;
  vredgad_av_1_A : A ;
  vittfoergrenad_av_1_1_A : A ;
  vitslammad_av_1_A : A ;
  vitputsad_av_1_A : A ;
  vitnosad_av_1_A : A ;
  vitmaalad_av_1_1_A : A ;
  vitkindad_av_1_A : A ;
  vitaminberikad_av_1_A : A ;
  vinkelformad_av_1_A : A ;
  vingad_av_1_A : A ;
  vinfaergad_av_1_1_A : A ;
  vindsopad_av_1_A : A ;
  vindskyddad_av_1_A : A ;
  vindpinad_av_1_A : A ;
  vimplad_av_1_A : A ;
  vidbraettad_av_1_1_A : A ;
  vertikalaxlad_av_1_A : A ;
  vertebrerad_av_1_A : A ;
  verserad_av_1_A : A ;
  verklighetsbetonad_av_1_A : A ;
  verklighetsbaserad_av_1_A : A ;
  vedeldad_av_1_A : A ;
  vedartad_av_1_A : A ;
  veckogammal_av_1_A : A ;
  vaxartad_av_1_A : A ;
  vattrad_av_1_A : A ;
  vattenbaserad_av_1_A : A ;
  varmhjaertad_av_1_1_A : A ;
  varmfoertennad_av_1_1_A : A ;
  vanskapad_av_1_A : A ;
  vanryktad_av_1_A : A ;
  vanlottad_av_1_A : A ;
  vanartad_av_1_A : A ;
  valnoetsbetsad_av_1_1_A : A ;
  valmad_av_1_A : A ;
  utaatriktad_av_1_1_A : A ;
  utvilad_av_1_A : A ;
  utvecklingshaemmad_av_1_1_A : A ;
  utvecklad_av_1_A : A ;
  utvakad_av_1_A : A ;
  uttunnad_av_1_A : A ;
  uttroettad_av_1_1_A : A ;
  uttraakad_av_1_1_A : A ;
  uttjaenad_av_1_1_A : A ;
  uttjatad_av_1_A : A ;
  uttittad_av_1_A : A ;
  uttalad_av_1_A : A ;
  utsuddad_av_1_A : A ;
  utstuderad_av_1_A : A ;
  utstofferad_av_1_A : A ;
  utspoekad_av_1_1_A : A ;
  utspekulerad_av_1_A : A ;
  utsparkad_av_1_A : A ;
  utsmyckad_av_1_A : A ;
  utslaepad_av_1_1_A : A ;
  utslocknad_av_1_A : A ;
  utsjasad_av_1_A : A ;
  utseendefixerad_av_1_A : A ;
  utschasad_av_1_A : A ;
  utraeknad_av_1_1_A : A ;
  utrullad_av_1_A : A ;
  utrotningshotad_av_1_A : A ;
  utriggad_av_1_A : A ;
  utrerad_av_1_A : A ;
  utpyntad_av_1_A : A ;
  utpumpad_av_1_A : A ;
  utpraeglad_av_1_1_A : A ;
  utposterad_av_1_A : A ;
  utpinad_av_1_A : A ;
  utmaerglad_av_1_1_A : A ;
  utmattad_av_1_A : A ;
  utlevad_av_1_A : A ;
  utkorad_av_1_A : A ;
  uthungrad_av_1_A : A ;
  utgammal_av_1_A : A ;
  utfestad_av_1_A : A ;
  utbuktad_av_1_A : A ;
  utbuad_av_1_A : A ;
  utblottad_av_1_A : A ;
  utblommad_av_1_A : A ;
  utarmad_av_1_A : A ;
  utarbetad_av_1_A : A ;
  utagerad_av_1_A : A ;
  urvattnad_av_1_A : A ;
  urtvaettad_av_1_1_A : A ;
  urspaarad_av_1_1_A : A ;
  urskaalad_av_1_1_A : A ;
  urringad_av_1_A : A ;
  urnformad_av_1_A : A ;
  urlakad_av_1_A : A ;
  urkramad_av_1_A : A ;
  urkopplad_av_1_A : A ;
  urbenad_av_1_A : A ;
  uppaatriktad_av_1_1_A : A ;
  uppaatkammad_av_1_1_A : A ;
  uppvilad_av_1_A : A ;
  upptrampad_av_1_A : A ;
  uppstyltad_av_1_A : A ;
  uppstoppad_av_1_A : A ;
  uppstaplad_av_1_A : A ;
  uppspaerrad_av_1_1_A : A ;
  uppspetad_av_1_A : A ;
  uppslitsad_av_1_A : A ;
  uppslammad_av_1_A : A ;
  uppslaktad_av_1_A : A ;
  uppskoertad_av_1_1_A : A ;
  uppskaerrad_av_1_1_A : A ;
  uppskruvad_av_1_A : A ;
  uppskojad_av_1_A : A ;
  uppskakad_av_1_A : A ;
  uppretad_av_1_A : A ;
  upprepad_av_1_A : A ;
  uppmaalad_av_1_1_A : A ;
  uppmaerksammad_av_1_1_A : A ;
  uppluckrad_av_1_A : A ;
  upplandad_av_1_A : A ;
  uppladdad_av_1_A : A ;
  uppkavlad_av_1_A : A ;
  uppkammad_av_1_A : A ;
  uppjagad_av_1_A : A ;
  uppiskad_av_1_A : A ;
  upphetsad_av_1_A : A ;
  uppgummad_av_1_A : A ;
  uppeldad_av_1_A : A ;
  uppdiktad_av_1_A : A ;
  uppblandad_av_1_A : A ;
  uniformerad_av_1_A : A ;
  underutvecklad_av_1_A : A ;
  undertecknad_av_1_A : A ;
  understimulerad_av_1_A : A ;
  underrepresenterad_av_1_A : A ;
  underordnad_av_1_A : A ;
  underinformerad_av_1_A : A ;
  underfinansierad_av_1_A : A ;
  underbemannad_av_1_A : A ;
  underbefolkad_av_1_A : A ;
  undanstoekad_av_1_1_A : A ;
  undanstoppad_av_1_A : A ;
  ugnstillagad_av_1_A : A ;
  ugnslagad_av_1_A : A ;
  u_formad_av_1_A : A ;
  taettbefolkad_av_1_1_A : A ;
  taetplacerad_av_1_1_A : A ;
  tvaatungad_av_1_1_A : A ;
  tvaangsvaervad_av_1_1_A : A ;
  tvaamastad_av_1_1_A : A ;
  tvaakoenad_av_1_1_A : A ;
  tvaafaergad_av_1_1_A : A ;
  tvaadelad_av_1_1_A : A ;
  tvaerfoerbannad_av_1_1_A : A ;
  tvehoevdad_av_1_1_A : A ;
  tveeggad_av_1_A : A ;
  tuvad_av_1_A : A ;
  tusenhoevdad_av_1_1_A : A ;
  turkosfaergad_av_1_1_A : A ;
  tunnhudad_av_1_A : A ;
  tunggumpad_av_1_A : A ;
  tungfotad_av_1_A : A ;
  tungarbetad_av_1_A : A ;
  tumultartad_av_1_A : A ;
  tuftad_av_1_A : A ;
  troegfattad_av_1_1_A : A ;
  traangbroestad_av_1_1_A : A ;
  traeffad_av_1_1_A : A ;
  trolovad_av_1_A : A ;
  trohjaertad_av_1_1_A : A ;
  tretungad_av_1_A : A ;
  tremastad_av_1_A : A ;
  treledad_av_1_A : A ;
  trehoevdad_av_1_1_A : A ;
  tredelad_av_1_A : A ;
  trappstegsformad_av_1_A : A ;
  trakterad_av_1_A : A ;
  trafikseparerad_av_1_A : A ;
  trafikdoedad_av_1_1_A : A ;
  torrladdad_av_1_A : A ;
  toppmatad_av_1_A : A ;
  togolesiskflaggad_av_1_A : A ;
  tjockmagad_av_1_A : A ;
  tjockhudad_av_1_A : A ;
  tillyxad_av_1_A : A ;
  tillvaextorienterad_av_1_1_A : A ;
  tilltufsad_av_1_A : A ;
  tilltrasslad_av_1_A : A ;
  tillstukad_av_1_A : A ;
  tillspetsad_av_1_A : A ;
  tillskrynklad_av_1_A : A ;
  tillrynkad_av_1_A : A ;
  tillrufsad_av_1_A : A ;
  tillproppad_av_1_A : A ;
  tillplattad_av_1_A : A ;
  tillkaempad_av_1_1_A : A ;
  tillkraanglad_av_1_1_A : A ;
  tillkorkad_av_1_A : A ;
  tillknycklad_av_1_A : A ;
  tillfoerordnad_av_1_1_A : A ;
  tillbucklad_av_1_A : A ;
  tillbakalutad_av_1_A : A ;
  tigrerad_av_1_A : A ;
  tidsbegraensad_av_1_1_A : A ;
  testosteronpumpad_av_1_A : A ;
  tempererad_av_1_A : A ;
  teknikanpassad_av_1_A : A ;
  tegelmurad_av_1_A : A ;
  tegelfaergad_av_1_1_A : A ;
  tecknad_av_1_A : A ;
  teaterintresserad_av_1_A : A ;
  tandad_av_1_A : A ;
  tallriksformad_av_1_A : A ;
  taggad_av_1_A : A ;
  soenderaelskad_av_1_1_A : A ;
  soendertrasad_av_1_1_A : A ;
  soenderspekulerad_av_1_1_A : A ;
  soenderrostad_av_1_1_A : A ;
  soenderplockad_av_1_1_A : A ;
  saagtandad_av_1_1_A : A ;
  saerpraeglad_av_1_1_A : A ;
  saegenomsusad_av_1_1_A : A ;
  syrad_av_1_A : A ;
  synskadad_av_1_A : A ;
  synkoperad_av_1_A : A ;
  svaaroevertraeffad_av_1_1_A : A ;
  svaaruttalad_av_1_1_A : A ;
  svaarutrotad_av_1_1_A : A ;
  svaartolkad_av_1_1_A : A ;
  svaarstartad_av_1_1_A : A ;
  svaarpratad_av_1_1_A : A ;
  svaarobserverad_av_1_1_A : A ;
  svaarfoersvarad_av_1_1_A : A ;
  svaarformulerad_av_1_1_A : A ;
  svaarfloertad_av_1_1_A : A ;
  svaarflirtad_av_1_1_A : A ;
  svaardiagnosticerad_av_1_1_A : A ;
  svaarbotad_av_1_1_A : A ;
  svaarbemaestrad_av_1_1_A : A ;
  svaarartad_av_1_1_A : A ;
  svaeltdrabbad_av_1_1_A : A ;
  svunnen_av_1_A : A ;
  svensktillverkad_av_1_A : A ;
  svenskregistrerad_av_1_A : A ;
  svartoxiderad_av_1_A : A ;
  svartnaglad_av_1_A : A ;
  svartmaalad_av_1_1_A : A ;
  svartmunnad_av_1_A : A ;
  svartlackerad_av_1_A : A ;
  svagartikulerad_av_1_A : A ;
  stoertfoerbannad_av_1_1_A : A ;
  staalhaettad_av_1_1_A : A ;
  staalbaagad_av_1_1_A : A ;
  staalartad_av_1_1_A : A ;
  staedad_av_1_1_A : A ;
  styvnackad_av_1_A : A ;
  studerad_av_1_A : A ;
  stroemlinjeformad_av_1_1_A : A ;
  straalorsakad_av_1_1_A : A ;
  strumaartad_av_1_A : A ;
  strimmad_av_1_A : A ;
  stridsutrustad_av_1_A : A ;
  stridsmunderad_av_1_A : A ;
  streckprickad_av_1_A : A ;
  storstilad_av_1_A : A ;
  stormunnad_av_1_A : A ;
  storkukad_av_1_A : A ;
  storbystad_av_1_A : A ;
  storbraettad_av_1_1_A : A ;
  storartad_av_1_A : A ;
  stjaernspaeckad_av_1_1_A : A ;
  stadgad_av_1_A : A ;
  sproejsad_av_1_1_A : A ;
  spraakbaserad_av_1_1_A : A ;
  spritbegaavad_av_1_1_A : A ;
  sportintresserad_av_1_A : A ;
  spolformad_av_1_A : A ;
  splittrad_av_1_A : A ;
  spiralgalaxformad_av_1_A : A ;
  spiralformad_av_1_A : A ;
  spindelvaevsmoenstrad_av_1_1_A : A ;
  spikad_av_1_A : A ;
  specialkomponerad_av_1_A : A ;
  specialintresserad_av_1_A : A ;
  specialdestinerad_av_1_A : A ;
  sparsmakad_av_1_A : A ;
  sorgkantad_av_1_A : A ;
  sorgbetonad_av_1_A : A ;
  sommarvindsomfladdrad_av_1_A : A ;
  soignerad_av_1_A : A ;
  sofistikerad_av_1_A : A ;
  snoeblandad_av_1_1_A : A ;
  snubbelfotad_av_1_A : A ;
  snedtrampad_av_1_A : A ;
  snabblagad_av_1_A : A ;
  snabbfotad_av_1_A : A ;
  smaamoenstrad_av_1_1_A : A ;
  smockad_av_1_A : A ;
  smickrad_av_1_A : A ;
  smaragdfaergad_av_1_1_A : A ;
  slaettoppad_av_1_1_A : A ;
  slaetstickad_av_1_1_A : A ;
  slaetriggad_av_1_1_A : A ;
  slaetrakad_av_1_1_A : A ;
  slaetkammad_av_1_1_A : A ;
  slumpartad_av_1_A : A ;
  slottstappad_av_1_A : A ;
  slokoerad_av_1_1_A : A ;
  slipad_av_1_A : A ;
  slimmad_av_1_A : A ;
  skumpiskad_av_1_A : A ;
  skuldbelastad_av_1_A : A ;
  skruvad_av_1_A : A ;
  skildkoenad_av_1_1_A : A ;
  skiktad_av_1_A : A ;
  skickad_av_1_A : A ;
  skattefinansierad_av_1_A : A ;
  skarpslipad_av_1_A : A ;
  skarpladdad_av_1_A : A ;
  skandalomsusad_av_1_A : A ;
  skandalartad_av_1_A : A ;
  skakad_av_1_A : A ;
  sjaelvpaahittad_av_1_1_A : A ;
  sjaelvfoervaallad_av_1_1_A : A ;
  sjaelvdistanserad_av_1_1_A : A ;
  sjaelvcentrerad_av_1_1_A : A ;
  sjaelsbeslaektad_av_1_1_A : A ;
  sjukdomsklassad_av_1_A : A ;
  sjuarmad_av_1_A : A ;
  situerad_av_1_A : A ;
  sinnesrubbad_av_1_A : A ;
  sinnesfoervirrad_av_1_1_A : A ;
  sinnad_av_1_A : A ;
  silvrad_av_1_A : A ;
  silverstickad_av_1_A : A ;
  silverfaergad_av_1_1_A : A ;
  silkestickad_av_1_A : A ;
  silkesstickad_av_1_A : A ;
  signalreglerad_av_1_A : A ;
  sidoordnad_av_1_A : A ;
  sexfixerad_av_1_A : A ;
  sepiafaergad_av_1_1_A : A ;
  sensationsbetonad_av_1_A : A ;
  senfaangad_av_1_1_A : A ;
  sekelgammal_av_1_A : A ;
  seglivad_av_1_A : A ;
  sansad_av_1_A : A ;
  sandfaergad_av_1_1_A : A ;
  sandblandad_av_1_A : A ;
  sammanslingrad_av_1_A : A ;
  sammangyttrad_av_1_A : A ;
  samlad_av_1_A : A ;
  samkoenad_av_1_1_A : A ;
  samhaellsintresserad_av_1_1_A : A ;
  salongsberusad_av_1_A : A ;
  salmonellainfekterad_av_1_A : A ;
  sakramentskad_av_1_A : A ;
  saffransfaergad_av_1_1_A : A ;
  sadelformad_av_1_A : A ;
  sabeltandad_av_1_A : A ;
  sabelformad_av_1_A : A ;
  s_formad_av_1_A : A ;
  roestberaettigad_av_1_1_A : A ;
  roerelsehindrad_av_1_1_A : A ;
  roeksvaertad_av_1_1_A : A ;
  roekskadad_av_1_1_A : A ;
  roekfaergad_av_1_1_A : A ;
  roedmaalad_av_1_1_A : A ;
  roedkindad_av_1_1_A : A ;
  roedkantad_av_1_1_A : A ;
  raatacklad_av_1_1_A : A ;
  raabarkad_av_1_1_A : A ;
  raettsinnad_av_1_1_A : A ;
  raetstickad_av_1_1_A : A ;
  raefflad_av_1_1_A : A ;
  raeddhaagad_av_1_1_A : A ;
  ryggmaergsskadad_av_1_1_A : A ;
  rutinerad_av_1_A : A ;
  rutad_av_1_A : A ;
  rustad_av_1_A : A ;
  ruppad_av_1_A : A ;
  rundstickad_av_1_A : A ;
  rundslipad_av_1_A : A ;
  rundhoevdad_av_1_1_A : A ;
  rundbottnad_av_1_A : A ;
  rundad_av_1_A : A ;
  ruggad_av_1_A : A ;
  ruffad_av_1_A : A ;
  rubbad_av_1_A : A ;
  rotad_av_1_A : A ;
  rostskyddsfaergad_av_1_1_A : A ;
  rostflaeckad_av_1_1_A : A ;
  rosenkindad_av_1_A : A ;
  rosafaergad_av_1_1_A : A ;
  rokokopyntad_av_1_A : A ;
  road_av_1_A : A ;
  rivningshotad_av_1_A : A ;
  ringfoerlovad_av_1_1_A : A ;
  ringformad_av_1_A : A ;
  ribbstickad_av_1_A : A ;
  ribbad_av_1_A : A ;
  retarderad_av_1_A : A ;
  resursorienterad_av_1_A : A ;
  resultatinriktad_av_1_A : A ;
  resignerad_av_1_A : A ;
  reserverad_av_1_A : A ;
  renspolad_av_1_A : A ;
  rensopad_av_1_A : A ;
  renommerad_av_1_A : A ;
  renhjaertad_av_1_1_A : A ;
  reliefartad_av_1_A : A ;
  rekordartad_av_1_A : A ;
  reforminriktad_av_1_A : A ;
  reflekterad_av_1_A : A ;
  rassegregerad_av_1_A : A ;
  rangerad_av_1_A : A ;
  randomiserad_av_1_A : A ;
  rakryggad_av_1_A : A ;
  raffinerad_av_1_A : A ;
  paaverkad_av_1_1_A : A ;
  paaselad_av_1_1_A : A ;
  paapaelsad_av_1_1_A : A ;
  paapassad_av_1_1_A : A ;
  paakostad_av_1_1_A : A ;
  paahittad_av_1_1_A : A ;
  paerlspontad_av_1_1_A : A ;
  puckad_av_1_A : A ;
  prunefaergad_av_1_1_A : A ;
  prostituerad_av_1_A : A ;
  prononcerad_av_1_A : A ;
  profilerad_av_1_A : A ;
  processinriktad_av_1_A : A ;
  problemorienterad_av_1_A : A ;
  privilegierad_av_1_A : A ;
  prismaformad_av_1_A : A ;
  prestationsinriktad_av_1_A : A ;
  polyklorerad_av_1_A : A ;
  polyesterbaserad_av_1_A : A ;
  polerad_av_1_A : A ;
  plymascherad_av_1_A : A ;
  plattnaglad_av_1_A : A ;
  plattfotad_av_1_A : A ;
  pistolformad_av_1_A : A ;
  pistolbevaepnad_av_1_1_A : A ;
  pisksnaertskadad_av_1_1_A : A ;
  piskad_av_1_A : A ;
  pigmenterad_av_1_A : A ;
  petroleumbaserad_av_1_A : A ;
  personfixerad_av_1_A : A ;
  persikofaergad_av_1_1_A : A ;
  pepprad_av_1_A : A ;
  pedalmanoevrerad_av_1_1_A : A ;
  patentstickad_av_1_A : A ;
  patenterad_av_1_A : A ;
  pastellfaergad_av_1_1_A : A ;
  passionerad_av_1_A : A ;
  passerad_av_1_A : A ;
  parrimmad_av_1_A : A ;
  pantad_av_1_A : A ;
  panikartad_av_1_A : A ;
  packad_av_1_A : A ;
  ooevertraeffad_av_1_1_A : A ;
  ooenskad_av_1_1_A : A ;
  oaelskad_av_1_1_A : A ;
  ovaardad_av_1_1_A : A ;
  ovaerderad_av_1_1_A : A ;
  ovaepnad_av_1_1_A : A ;
  ovaentad_av_1_1_A : A ;
  ovulkaniserad_av_1_A : A ;
  ovulgariserad_av_1_A : A ;
  ovokaliserad_av_1_A : A ;
  ovitaminiserad_av_1_A : A ;
  ovitaminerad_av_1_A : A ;
  ovitaliserad_av_1_A : A ;
  ovisualiserad_av_1_A : A ;
  ovisiterad_av_1_A : A ;
  oviserad_av_1_A : A ;
  ovindicerad_av_1_A : A ;
  ovidimerad_av_1_A : A ;
  oversifierad_av_1_A : A ;
  overifierad_av_1_A : A ;
  overbaliserad_av_1_A : A ;
  oventilerad_av_1_A : A ;
  ovelouriserad_av_1_A : A ;
  ovarierad_av_1_A : A ;
  ovandaliserad_av_1_A : A ;
  ovalverad_av_1_A : A ;
  ovaluterad_av_1_A : A ;
  ovaksinerad_av_1_A : A ;
  ovaggad_av_1_A : A ;
  ovadderad_av_1_A : A ;
  ovaccinerad_av_1_A : A ;
  outvaerderad_av_1_1_A : A ;
  outvecklad_av_1_A : A ;
  outtaxerad_av_1_A : A ;
  outtalad_av_1_A : A ;
  outstofferad_av_1_A : A ;
  outrangerad_av_1_A : A ;
  outraderad_av_1_A : A ;
  outposterad_av_1_A : A ;
  outplacerad_av_1_A : A ;
  outnyttjad_av_1_A : A ;
  outminuterad_av_1_A : A ;
  outmanoevrerad_av_1_1_A : A ;
  outlokaliserad_av_1_A : A ;
  outkvitterad_av_1_A : A ;
  outkristalliserad_av_1_A : A ;
  outkonkurrerad_av_1_A : A ;
  outkommenderad_av_1_A : A ;
  outklarerad_av_1_A : A ;
  outforskad_av_1_A : A ;
  outexperimenterad_av_1_A : A ;
  outexaminerad_av_1_A : A ;
  outdebiterad_av_1_A : A ;
  outbroderad_av_1_A : A ;
  outbildad_av_1_A : A ;
  outbasunerad_av_1_A : A ;
  outbalanserad_av_1_A : A ;
  outarrenderad_av_1_A : A ;
  outannonserad_av_1_A : A ;
  outackorderad_av_1_A : A ;
  ousurperad_av_1_A : A ;
  ourbaniserad_av_1_A : A ;
  ouppoevad_av_1_1_A : A ;
  ouppvaerderad_av_1_1_A : A ;
  oupptaxerad_av_1_A : A ;
  ouppsummerad_av_1_A : A ;
  ouppreklamerad_av_1_A : A ;
  ouppklarad_av_1_A : A ;
  ouppjusterad_av_1_A : A ;
  ouppgraderad_av_1_A : A ;
  ouppfostrad_av_1_A : A ;
  ouppdaterad_av_1_A : A ;
  ouppackad_av_1_A : A ;
  ouniformerad_av_1_A : A ;
  ounifierad_av_1_A : A ;
  otyranniserad_av_1_A : A ;
  otypiserad_av_1_A : A ;
  otypifierad_av_1_A : A ;
  otyglad_av_1_A : A ;
  otvaettad_av_1_1_A : A ;
  otuscherad_av_1_A : A ;
  oturnerad_av_1_A : A ;
  otuperad_av_1_A : A ;
  otuktad_av_1_A : A ;
  otraenad_av_1_1_A : A ;
  otryfferad_av_1_A : A ;
  otrivialiserad_av_1_A : A ;
  otrierad_av_1_A : A ;
  otriangulerad_av_1_A : A ;
  otrepanerad_av_1_A : A ;
  otravesterad_av_1_A : A ;
  otrasserad_av_1_A : A ;
  otransumerad_av_1_A : A ;
  otransporterad_av_1_A : A ;
  otransponerad_av_1_A : A ;
  otransplanterad_av_1_A : A ;
  otransmuterad_av_1_A : A ;
  otransmitterad_av_1_A : A ;
  otranslittererad_av_1_A : A ;
  otranskriberad_av_1_A : A ;
  otransiterad_av_1_A : A ;
  otransformerad_av_1_A : A ;
  otransfererad_av_1_A : A ;
  otrancherad_av_1_A : A ;
  otrakterad_av_1_A : A ;
  otrakasserad_av_1_A : A ;
  otrafikerad_av_1_A : A ;
  otraderad_av_1_A : A ;
  otouperad_av_1_A : A ;
  otoucherad_av_1_A : A ;
  otorterad_av_1_A : A ;
  otorpederad_av_1_A : A ;
  otorderad_av_1_A : A ;
  otolererad_av_1_A : A ;
  otitulerad_av_1_A : A ;
  otitrerad_av_1_A : A ;
  otippad_av_1_A : A ;
  otestamenterad_av_1_A : A ;
  otesaurerad_av_1_A : A ;
  oterroriserad_av_1_A : A ;
  oterrasserad_av_1_A : A ;
  otenterad_av_1_A : A ;
  otempererad_av_1_A : A ;
  otemperad_av_1_A : A ;
  oteleviserad_av_1_A : A ;
  otelegraferad_av_1_A : A ;
  otelefonerad_av_1_A : A ;
  oteknifierad_av_1_A : A ;
  otaxerad_av_1_A : A ;
  otatuerad_av_1_A : A ;
  otarifferad_av_1_A : A ;
  otarerad_av_1_A : A ;
  otapetserad_av_1_A : A ;
  otangerad_av_1_A : A ;
  otandad_av_1_A : A ;
  otamponerad_av_1_A : A ;
  otabuerad_av_1_A : A ;
  otabellerad_av_1_A : A ;
  osoetad_av_1_1_A : A ;
  osaaverad_av_1_1_A : A ;
  osaaterad_av_1_1_A : A ;
  osystematiserad_av_1_A : A ;
  osyrad_av_1_A : A ;
  osyntetiserad_av_1_A : A ;
  osynkroniserad_av_1_A : A ;
  osynkoperad_av_1_A : A ;
  osymboliserad_av_1_A : A ;
  osuspenderad_av_1_A : A ;
  osupponerad_av_1_A : A ;
  osupplerad_av_1_A : A ;
  osummerad_av_1_A : A ;
  osuggererad_av_1_A : A ;
  osufflerad_av_1_A : A ;
  osuffigerad_av_1_A : A ;
  osuccederad_av_1_A : A ;
  osubventionerad_av_1_A : A ;
  osubtraherad_av_1_A : A ;
  osubsumerad_av_1_A : A ;
  osubstituerad_av_1_A : A ;
  osubstantiverad_av_1_A : A ;
  osubskriberad_av_1_A : A ;
  osubsidierad_av_1_A : A ;
  osubordinerad_av_1_A : A ;
  osublimerad_av_1_A : A ;
  ostaemplad_av_1_1_A : A ;
  ostaedad_av_1_1_A : A ;
  ostyckad_av_1_A : A ;
  ostuderad_av_1_A : A ;
  ostrukturerad_av_1_A : A ;
  ostratifierad_av_1_A : A ;
  ostrangulerad_av_1_A : A ;
  ostraffad_av_1_A : A ;
  ostofferad_av_1_A : A ;
  ostipulerad_av_1_A : A ;
  ostipendierad_av_1_A : A ;
  ostimulerad_av_1_A : A ;
  ostiliserad_av_1_A : A ;
  ostigmatiserad_av_1_A : A ;
  osteriliserad_av_1_A : A ;
  ostereotyperad_av_1_A : A ;
  ostenograferad_av_1_A : A ;
  ostencilerad_av_1_A : A ;
  ostatuerad_av_1_A : A ;
  ostationerad_av_1_A : A ;
  ostandardiserad_av_1_A : A ;
  ostagnerad_av_1_A : A ;
  ostafferad_av_1_A : A ;
  ostabiliserad_av_1_A : A ;
  ospaerrad_av_1_1_A : A ;
  ospolierad_av_1_A : A ;
  ospenderad_av_1_A : A ;
  ospekulerad_av_1_A : A ;
  ospeciminerad_av_1_A : A ;
  ospecificerad_av_1_A : A ;
  ospecialiserad_av_1_A : A ;
  osparad_av_1_A : A ;
  ospallerad_av_1_A : A ;
  ospaljerad_av_1_A : A ;
  osovjetiserad_av_1_A : A ;
  osoulagerad_av_1_A : A ;
  osorterad_av_1_A : A ;
  osordinerad_av_1_A : A ;
  osonderad_av_1_A : A ;
  osolverad_av_1_A : A ;
  osocialiserad_av_1_A : A ;
  osminkad_av_1_A : A ;
  oslipad_av_1_A : A ;
  oslaviserad_av_1_A : A ;
  oslaktad_av_1_A : A ;
  oskyddad_av_1_A : A ;
  oskulpturerad_av_1_A : A ;
  oskulpterad_av_1_A : A ;
  oskrymtad_av_1_A : A ;
  oskrudad_av_1_A : A ;
  oskrubbad_av_1_A : A ;
  oskrotad_av_1_A : A ;
  oskrapad_av_1_A : A ;
  oskramlad_av_1_A : A ;
  oskrafferad_av_1_A : A ;
  oskovlad_av_1_A : A ;
  oskottad_av_1_A : A ;
  oskotad_av_1_A : A ;
  oskopad_av_1_A : A ;
  oskonad_av_1_A : A ;
  oskolad_av_1_A : A ;
  oskojad_av_1_A : A ;
  oskjuvad_av_1_A : A ;
  oskjutsad_av_1_A : A ;
  oskivad_av_1_A : A ;
  oskisserad_av_1_A : A ;
  oskissad_av_1_A : A ;
  oskirad_av_1_A : A ;
  oskippad_av_1_A : A ;
  oskipad_av_1_A : A ;
  oskinnad_av_1_A : A ;
  oskingrad_av_1_A : A ;
  oskildrad_av_1_A : A ;
  oskiktad_av_1_A : A ;
  oskiftad_av_1_A : A ;
  oskevrad_av_1_A : A ;
  oskevad_av_1_A : A ;
  oskeppad_av_1_A : A ;
  oskenad_av_1_A : A ;
  oskedad_av_1_A : A ;
  oskattad_av_1_A : A ;
  oskarvad_av_1_A : A ;
  oskapad_av_1_A : A ;
  oskannad_av_1_A : A ;
  oskanderad_av_1_A : A ;
  oskandaliserad_av_1_A : A ;
  oskalperad_av_1_A : A ;
  oskallad_av_1_A : A ;
  oskalkad_av_1_A : A ;
  oskaldad_av_1_A : A ;
  oskalad_av_1_A : A ;
  oskakad_av_1_A : A ;
  oskaftad_av_1_A : A ;
  oskaffad_av_1_A : A ;
  oskadad_av_1_A : A ;
  osjasad_av_1_A : A ;
  osjappad_av_1_A : A ;
  osjanghajad_av_1_A : A ;
  osirad_av_1_A : A ;
  osintrad_av_1_A : A ;
  osinkad_av_1_A : A ;
  osimulerad_av_1_A : A ;
  osimsad_av_1_A : A ;
  osimplifierad_av_1_A : A ;
  osilvrad_av_1_A : A ;
  osiluetterad_av_1_A : A ;
  osilhuetterad_av_1_A : A ;
  osilad_av_1_A : A ;
  osiktad_av_1_A : A ;
  osignerad_av_1_A : A ;
  osignalerad_av_1_A : A ;
  osignad_av_1_A : A ;
  osigillerad_av_1_A : A ;
  osicksackad_av_1_A : A ;
  osicklad_av_1_A : A ;
  osickad_av_1_A : A ;
  oshuntad_av_1_A : A ;
  oshortad_av_1_A : A ;
  oshinglad_av_1_A : A ;
  oshanghajad_av_1_A : A ;
  oshamponerad_av_1_A : A ;
  osexualiserad_av_1_A : A ;
  oserverad_av_1_A : A ;
  oservad_av_1_A : A ;
  oseparerad_av_1_A : A ;
  osenterad_av_1_A : A ;
  osensibiliserad_av_1_A : A ;
  oseminerad_av_1_A : A ;
  osemaforerad_av_1_A : A ;
  oselekterad_av_1_A : A ;
  oselad_av_1_A : A ;
  osekvestrerad_av_1_A : A ;
  osekunderad_av_1_A : A ;
  osekulariserad_av_1_A : A ;
  osekonderad_av_1_A : A ;
  osejsad_av_1_A : A ;
  osegregerad_av_1_A : A ;
  osegrad_av_1_A : A ;
  osegmenterad_av_1_A : A ;
  oseglad_av_1_A : A ;
  oseedad_av_1_A : A ;
  osedimenterad_av_1_A : A ;
  oschveifad_av_1_A : A ;
  oschematiserad_av_1_A : A ;
  oschatterad_av_1_A : A ;
  oschasad_av_1_A : A ;
  oschappad_av_1_A : A ;
  oschanghajad_av_1_A : A ;
  oschamponerad_av_1_A : A ;
  oschaktad_av_1_A : A ;
  oschacklad_av_1_A : A ;
  oschackad_av_1_A : A ;
  oschabloniserad_av_1_A : A ;
  oschablonerad_av_1_A : A ;
  oscannad_av_1_A : A ;
  osaxad_av_1_A : A ;
  osauverad_av_1_A : A ;
  osauterad_av_1_A : A ;
  osaturerad_av_1_A : A ;
  osatsad_av_1_A : A ;
  osatisfierad_av_1_A : A ;
  osatinerad_av_1_A : A ;
  osargad_av_1_A : A ;
  osaponifierad_av_1_A : A ;
  osannad_av_1_A : A ;
  osanktionerad_av_1_A : A ;
  osanktifierad_av_1_A : A ;
  osanforiserad_av_1_A : A ;
  osanerad_av_1_A : A ;
  osandad_av_1_A : A ;
  osamtaxerad_av_1_A : A ;
  osamsad_av_1_A : A ;
  osamplad_av_1_A : A ;
  osamordnad_av_1_A : A ;
  osammantraeffad_av_1_1_A : A ;
  osammansvetsad_av_1_A : A ;
  osammanstraalad_av_1_1_A : A ;
  osammanraeknad_av_1_1_A : A ;
  osammanpressad_av_1_A : A ;
  osammanpackad_av_1_A : A ;
  osammanlaenkad_av_1_1_A : A ;
  osammankopplad_av_1_A : A ;
  osammankallad_av_1_A : A ;
  osammanjaemkad_av_1_1_A : A ;
  osammanhopad_av_1_A : A ;
  osammanfogad_av_1_A : A ;
  osammanflaetad_av_1_1_A : A ;
  osammanfattad_av_1_A : A ;
  osammanblandad_av_1_A : A ;
  osamlad_av_1_A : A ;
  osamkad_av_1_A : A ;
  osambeskattad_av_1_A : A ;
  osaluterad_av_1_A : A ;
  osaltad_av_1_A : A ;
  osalderad_av_1_A : A ;
  osalad_av_1_A : A ;
  osaktad_av_1_A : A ;
  osaknad_av_1_A : A ;
  osakad_av_1_A : A ;
  osaftad_av_1_A : A ;
  osadlad_av_1_A : A ;
  osabrerad_av_1_A : A ;
  osaboterad_av_1_A : A ;
  osabbad_av_1_A : A ;
  oroevad_av_1_1_A : A ;
  oroesad_av_1_1_A : A ;
  oroentgad_av_1_1_A : A ;
  oraanad_av_1_1_A : A ;
  oraamad_av_1_1_A : A ;
  oraakad_av_1_1_A : A ;
  oraagad_av_1_1_A : A ;
  oraettfaerdigad_av_1_1_A : A ;
  oraettad_av_1_1_A : A ;
  oraetad_av_1_1_A : A ;
  oraemnad_av_1_1_A : A ;
  oraeknad_av_1_1_A : A ;
  oraefsad_av_1_1_A : A ;
  oraefflad_av_1_1_A : A ;
  oraeddad_av_1_1_A : A ;
  orytmiserad_av_1_A : A ;
  orynkad_av_1_A : A ;
  oryktad_av_1_A : A ;
  oruvad_av_1_A : A ;
  orutinerad_av_1_A : A ;
  orustad_av_1_A : A ;
  orussifierad_av_1_A : A ;
  orussificerad_av_1_A : A ;
  oruskad_av_1_A : A ;
  orusad_av_1_A : A ;
  orunkad_av_1_A : A ;
  orundad_av_1_A : A ;
  orullad_av_1_A : A ;
  oruinerad_av_1_A : A ;
  oruggad_av_1_A : A ;
  oruckad_av_1_A : A ;
  orubricerad_av_1_A : A ;
  orubbad_av_1_A : A ;
  oroterad_av_1_A : A ;
  orostad_av_1_A : A ;
  orosad_av_1_A : A ;
  oromantiserad_av_1_A : A ;
  orollad_av_1_A : A ;
  oroffad_av_1_A : A ;
  orockerad_av_1_A : A ;
  orobotiserad_av_1_A : A ;
  oritualiserad_av_1_A : A ;
  oritsad_av_1_A : A ;
  oritad_av_1_A : A ;
  oristad_av_1_A : A ;
  orisslad_av_1_A : A ;
  orispad_av_1_A : A ;
  orisad_av_1_A : A ;
  oringad_av_1_A : A ;
  orimmad_av_1_A : A ;
  oriktad_av_1_A : A ;
  orikoschetterad_av_1_A : A ;
  origlad_av_1_A : A ;
  origgad_av_1_A : A ;
  oriad_av_1_A : A ;
  organiserad_av_1_A : A ;
  orevolutionerad_av_1_A : A ;
  oreviderad_av_1_A : A ;
  oreveterad_av_1_A : A ;
  orevalverad_av_1_A : A ;
  orevad_av_1_A : A ;
  oretuscherad_av_1_A : A ;
  oreturnerad_av_1_A : A ;
  oretarderad_av_1_A : A ;
  oretad_av_1_A : A ;
  oretablerad_av_1_A : A ;
  oresumerad_av_1_A : A ;
  orestituerad_av_1_A : A ;
  orestaurerad_av_1_A : A ;
  orespirerad_av_1_A : A ;
  orespekterad_av_1_A : A ;
  oresorberad_av_1_A : A ;
  oresolverad_av_1_A : A ;
  oreserverad_av_1_A : A ;
  oreproducerad_av_1_A : A ;
  orepriserad_av_1_A : A ;
  orepresenterad_av_1_A : A ;
  orepeterad_av_1_A : A ;
  orepellerad_av_1_A : A ;
  orepatrierad_av_1_A : A ;
  orepartiserad_av_1_A : A ;
  oreparerad_av_1_A : A ;
  orepad_av_1_A : A ;
  oreorganiserad_av_1_A : A ;
  orensad_av_1_A : A ;
  orenoverad_av_1_A : A ;
  orenderad_av_1_A : A ;
  orenad_av_1_A : A ;
  oremplacerad_av_1_A : A ;
  oremmad_av_1_A : A ;
  oremitterad_av_1_A : A ;
  orelaead_av_1_1_A : A ;
  orelegerad_av_1_A : A ;
  orelaterad_av_1_A : A ;
  orekvirerad_av_1_A : A ;
  orektifierad_av_1_A : A ;
  orektificerad_av_1_A : A ;
  orekryterad_av_1_A : A ;
  orekonstruerad_av_1_A : A ;
  orekompenserad_av_1_A : A ;
  orekommenderad_av_1_A : A ;
  orekognoserad_av_1_A : A ;
  orekognoscerad_av_1_A : A ;
  oreklamerad_av_1_A : A ;
  orekapitulerad_av_1_A : A ;
  orekad_av_1_A : A ;
  oreinkarnerad_av_1_A : A ;
  orehabiliterad_av_1_A : A ;
  oregummerad_av_1_A : A ;
  oreglerad_av_1_A : A ;
  oreglementerad_av_1_A : A ;
  oreglad_av_1_A : A ;
  oregistrerad_av_1_A : A ;
  oregisserad_av_1_A : A ;
  oregerad_av_1_A : A ;
  oregenererad_av_1_A : A ;
  oregalerad_av_1_A : A ;
  orefuserad_av_1_A : A ;
  oreformerad_av_1_A : A ;
  oreflekterad_av_1_A : A ;
  orefererad_av_1_A : A ;
  oreducerad_av_1_A : A ;
  oredubblad_av_1_A : A ;
  oredovisad_av_1_A : A ;
  oredigerad_av_1_A : A ;
  oreciterad_av_1_A : A ;
  orecipierad_av_1_A : A ;
  orecenserad_av_1_A : A ;
  oreassurerad_av_1_A : A ;
  orealiserad_av_1_A : A ;
  oreaktiverad_av_1_A : A ;
  orattad_av_1_A : A ;
  orationaliserad_av_1_A : A ;
  oratificerad_av_1_A : A ;
  oratad_av_1_A : A ;
  orastad_av_1_A : A ;
  oraspad_av_1_A : A ;
  oraserad_av_1_A : A ;
  orapporterad_av_1_A : A ;
  orappellerad_av_1_A : A ;
  orappad_av_1_A : A ;
  oransonerad_av_1_A : A ;
  orannsakad_av_1_A : A ;
  orankad_av_1_A : A ;
  orangerad_av_1_A : A ;
  orangemaalad_av_1_1_A : A ;
  orangefaergad_av_1_1_A : A ;
  orandomiserad_av_1_A : A ;
  orandad_av_1_A : A ;
  oramsad_av_1_A : A ;
  oramponerad_av_1_A : A ;
  orammad_av_1_A : A ;
  oramad_av_1_A : A ;
  orakad_av_1_A : A ;
  oraggad_av_1_A : A ;
  oraffinerad_av_1_A : A ;
  oradikaliserad_av_1_A : A ;
  oradierad_av_1_A : A ;
  oraderad_av_1_A : A ;
  orackad_av_1_A : A ;
  orabblad_av_1_A : A ;
  orabatterad_av_1_A : A ;
  oquiltad_av_1_A : A ;
  opaayrkad_av_1_1_A : A ;
  opaavisad_av_1_1_A : A ;
  opaaverkad_av_1_1_A : A ;
  opaatraeffad_av_1_1_A : A ;
  opaatalad_av_1_1_A : A ;
  opaaskyndad_av_1_1_A : A ;
  opaaraeknad_av_1_1_A : A ;
  opaaropad_av_1_1_A : A ;
  opaapekad_av_1_1_A : A ;
  opaalad_av_1_1_A : A ;
  opaakallad_av_1_1_A : A ;
  opaafordrad_av_1_1_A : A ;
  opaadyvlad_av_1_1_A : A ;
  opaaboerjad_av_1_1_A : A ;
  opaaboerdad_av_1_1_A : A ;
  opaaad_av_1_1_A : A ;
  opaelad_av_1_1_A : A ;
  opytsad_av_1_A : A ;
  opyntad_av_1_A : A ;
  oputtad_av_1_A : A ;
  oputsad_av_1_A : A ;
  opussad_av_1_A : A ;
  opushad_av_1_A : A ;
  opurrad_av_1_A : A ;
  opurprad_av_1_A : A ;
  opurgerad_av_1_A : A ;
  opunsad_av_1_A : A ;
  opunkterad_av_1_A : A ;
  opunktad_av_1_A : A ;
  opumpad_av_1_A : A ;
  opulvriserad_av_1_A : A ;
  opulveriserad_av_1_A : A ;
  opuffad_av_1_A : A ;
  opudrad_av_1_A : A ;
  opuddlad_av_1_A : A ;
  opublicerad_av_1_A : A ;
  opsykologiserad_av_1_A : A ;
  opsykad_av_1_A : A ;
  oproevad_av_1_1_A : A ;
  oproejsad_av_1_1_A : A ;
  opraamad_av_1_1_A : A ;
  opraentad_av_1_1_A : A ;
  opraeglad_av_1_1_A : A ;
  opryglad_av_1_A : A ;
  oprutad_av_1_A : A ;
  oprovocerad_av_1_A : A ;
  oprovad_av_1_A : A ;
  oprotokollerad_av_1_A : A ;
  oprotesterad_av_1_A : A ;
  oprotegerad_av_1_A : A ;
  oprospekterad_av_1_A : A ;
  oproskriberad_av_1_A : A ;
  oproppad_av_1_A : A ;
  oproportionerad_av_1_A : A ;
  oproponerad_av_1_A : A ;
  oprononcerad_av_1_A : A ;
  opromulgerad_av_1_A : A ;
  opromoverad_av_1_A : A ;
  oprolongerad_av_1_A : A ;
  oproletariserad_av_1_A : A ;
  oproklamerad_av_1_A : A ;
  oprojicerad_av_1_A : A ;
  oprojekterad_av_1_A : A ;
  oprogrammerad_av_1_A : A ;
  oprognostiserad_av_1_A : A ;
  oprofilerad_av_1_A : A ;
  oprofessionaliserad_av_1_A : A ;
  oprofanerad_av_1_A : A ;
  oproducerad_av_1_A : A ;
  oprocessad_av_1_A : A ;
  oproblematiserad_av_1_A : A ;
  oproberad_av_1_A : A ;
  oprivilegierad_av_1_A : A ;
  oprivatiserad_av_1_A : A ;
  oprisad_av_1_A : A ;
  oprioriterad_av_1_A : A ;
  oprickad_av_1_A : A ;
  opresumerad_av_1_A : A ;
  opresterad_av_1_A : A ;
  opressad_av_1_A : A ;
  opreskriberad_av_1_A : A ;
  opreserverad_av_1_A : A ;
  opresenterad_av_1_A : A ;
  opresentad_av_1_A : A ;
  opreparerad_av_1_A : A ;
  opremierad_av_1_A : A ;
  opreludierad_av_1_A : A ;
  oprejad_av_1_A : A ;
  oprefigerad_av_1_A : A ;
  oprefererad_av_1_A : A ;
  oprefabricerad_av_1_A : A ;
  opredisponerad_av_1_A : A ;
  opredicerad_av_1_A : A ;
  opredestinerad_av_1_A : A ;
  opreciserad_av_1_A : A ;
  opraktiserad_av_1_A : A ;
  oppaatriktad_av_1_1_A : A ;
  oppaatkammad_av_1_1_A : A ;
  oppvilad_av_1_A : A ;
  oppspaerrad_av_1_1_A : A ;
  oppskojad_av_1_A : A ;
  oppretad_av_1_A : A ;
  oppladdad_av_1_A : A ;
  oppkavlad_av_1_A : A ;
  oppkammad_av_1_A : A ;
  oppjagad_av_1_A : A ;
  opphetsad_av_1_A : A ;
  oppeldad_av_1_A : A ;
  oppdiktad_av_1_A : A ;
  oppblandad_av_1_A : A ;
  opoaengterad_av_1_1_A : A ;
  opostulerad_av_1_A : A ;
  opostponerad_av_1_A : A ;
  oposterad_av_1_A : A ;
  opostdaterad_av_1_A : A ;
  opostad_av_1_A : A ;
  oportraetterad_av_1_1_A : A ;
  oportionerad_av_1_A : A ;
  oportad_av_1_A : A ;
  opopulariserad_av_1_A : A ;
  opoppad_av_1_A : A ;
  opomaderad_av_1_A : A ;
  opolstrad_av_1_A : A ;
  opollinerad_av_1_A : A ;
  opolletterad_av_1_A : A ;
  opolitiserad_av_1_A : A ;
  opolerad_av_1_A : A ;
  opolariserad_av_1_A : A ;
  opointerad_av_1_A : A ;
  opocherad_av_1_A : A ;
  oplaatad_av_1_1_A : A ;
  oplaastrad_av_1_1_A : A ;
  oplaeterad_av_1_1_A : A ;
  oplysad_av_1_A : A ;
  oplundrad_av_1_A : A ;
  opluggad_av_1_A : A ;
  oplottad_av_1_A : A ;
  oplomberad_av_1_A : A ;
  oplogad_av_1_A : A ;
  oplockad_av_1_A : A ;
  oplisserad_av_1_A : A ;
  opliggad_av_1_A : A ;
  oplatinerad_av_1_A : A ;
  oplastad_av_1_A : A ;
  oplanterad_av_1_A : A ;
  oplantad_av_1_A : A ;
  oplankad_av_1_A : A ;
  oplanerad_av_1_A : A ;
  oplanad_av_1_A : A ;
  oplagierad_av_1_A : A ;
  oplacerad_av_1_A : A ;
  opiskad_av_1_A : A ;
  opirkad_av_1_A : A ;
  opippad_av_1_A : A ;
  opinnad_av_1_A : A ;
  opincerad_av_1_A : A ;
  opinad_av_1_A : A ;
  opimplad_av_1_A : A ;
  opimpad_av_1_A : A ;
  opilkad_av_1_A : A ;
  opikerad_av_1_A : A ;
  opikad_av_1_A : A ;
  opickad_av_1_A : A ;
  opetrifierad_av_1_A : A ;
  opetad_av_1_A : A ;
  operverterad_av_1_A : A ;
  opersvaderad_av_1_A : A ;
  opersonifierad_av_1_A : A ;
  opersiflerad_av_1_A : A ;
  opermuterad_av_1_A : A ;
  opermitterad_av_1_A : A ;
  opermanentad_av_1_A : A ;
  operiodiserad_av_1_A : A ;
  operforerad_av_1_A : A ;
  opercipierad_av_1_A : A ;
  opepprad_av_1_A : A ;
  opeppad_av_1_A : A ;
  openslad_av_1_A : A ;
  opensionerad_av_1_A : A ;
  openetrerad_av_1_A : A ;
  opelleterad_av_1_A : A ;
  opejlad_av_1_A : A ;
  opaxad_av_1_A : A ;
  opauserad_av_1_A : A ;
  opausad_av_1_A : A ;
  opauperiserad_av_1_A : A ;
  opatrullerad_av_1_A : A ;
  opatinerad_av_1_A : A ;
  opatenterad_av_1_A : A ;
  opastoeriserad_av_1_1_A : A ;
  opassiviserad_av_1_A : A ;
  opassiverad_av_1_A : A ;
  opasserad_av_1_A : A ;
  opassad_av_1_A : A ;
  oparodierad_av_1_A : A ;
  oparketterad_av_1_A : A ;
  oparkerad_av_1_A : A ;
  oparfymerad_av_1_A : A ;
  oparerad_av_1_A : A ;
  oparalyserad_av_1_A : A ;
  oparallelliserad_av_1_A : A ;
  oparafraserad_av_1_A : A ;
  oparaffinerad_av_1_A : A ;
  oparaferad_av_1_A : A ;
  oparaderad_av_1_A : A ;
  oparad_av_1_A : A ;
  opantograferad_av_1_A : A ;
  opantad_av_1_A : A ;
  opansrad_av_1_A : A ;
  opanorerad_av_1_A : A ;
  opangad_av_1_A : A ;
  opanerad_av_1_A : A ;
  opanelad_av_1_A : A ;
  opalperad_av_1_A : A ;
  opalmad_av_1_A : A ;
  opallad_av_1_A : A ;
  opaljetterad_av_1_A : A ;
  opalfaergad_av_1_1_A : A ;
  opalataliserad_av_1_A : A ;
  opaketerad_av_1_A : A ;
  opajad_av_1_A : A ;
  opaginerad_av_1_A : A ;
  opackad_av_1_A : A ;
  opacificerad_av_1_A : A ;
  ooxiderad_av_1_A : A ;
  ooutad_av_1_A : A ;
  oorsakad_av_1_A : A ;
  oornerad_av_1_A : A ;
  oornamenterad_av_1_A : A ;
  oorkestrerad_av_1_A : A ;
  oorienterad_av_1_A : A ;
  oorganiserad_av_1_A : A ;
  oordnad_av_1_A : A ;
  oordinerad_av_1_A : A ;
  ooptimerad_av_1_A : A ;
  ooppvaerderad_av_1_1_A : A ;
  ooppsummerad_av_1_A : A ;
  oopponerad_av_1_A : A ;
  ooppjusterad_av_1_A : A ;
  oopererad_av_1_A : A ;
  ooperationaliserad_av_1_A : A ;
  oondulerad_av_1_A : A ;
  oomaendrad_av_1_1_A : A ;
  oomvaerderad_av_1_1_A : A ;
  oomvittnad_av_1_A : A ;
  oomvandlad_av_1_A : A ;
  oomtvistad_av_1_A : A ;
  oomtolkad_av_1_A : A ;
  oomtalad_av_1_A : A ;
  oomsvaermad_av_1_1_A : A ;
  oomstoertad_av_1_1_A : A ;
  oomstraalad_av_1_1_A : A ;
  oomstrukturerad_av_1_A : A ;
  oomslingrad_av_1_A : A ;
  oomskulpturerad_av_1_A : A ;
  oomskolad_av_1_A : A ;
  oomskapad_av_1_A : A ;
  oomraeknad_av_1_1_A : A ;
  oomringad_av_1_A : A ;
  oomramad_av_1_A : A ;
  oomproevad_av_1_1_A : A ;
  oomplaastrad_av_1_1_A : A ;
  oomplacerad_av_1_A : A ;
  oomorganiserad_av_1_A : A ;
  oommoeblerad_av_1_1_A : A ;
  oomkretsad_av_1_A : A ;
  oomkransad_av_1_A : A ;
  oomkastad_av_1_A : A ;
  oomhaektad_av_1_1_A : A ;
  oomhaegnad_av_1_1_A : A ;
  oomhuldad_av_1_A : A ;
  oomgaerdad_av_1_1_A : A ;
  oomgrupperad_av_1_A : A ;
  oomgestaltad_av_1_A : A ;
  oomfoerhandlad_av_1_1_A : A ;
  oomfoerdelad_av_1_1_A : A ;
  oomformad_av_1_A : A ;
  oomflyttad_av_1_A : A ;
  oomfattad_av_1_A : A ;
  oomfamnad_av_1_A : A ;
  oomdirigerad_av_1_A : A ;
  oomdanad_av_1_A : A ;
  oombildad_av_1_A : A ;
  oomarbetad_av_1_A : A ;
  oollad_av_1_A : A ;
  ooljad_av_1_A : A ;
  oolad_av_1_A : A ;
  ookulerad_av_1_A : A ;
  ooktrojerad_av_1_A : A ;
  ookad_av_1_A : A ;
  ooffrad_av_1_A : A ;
  ooffererad_av_1_A : A ;
  oodlad_av_1_A : A ;
  oockuperad_av_1_A : A ;
  ooccidentaliserad_av_1_A : A ;
  oobserverad_av_1_A : A ;
  oobligerad_av_1_A : A ;
  oobjektiverad_av_1_A : A ;
  oobducerad_av_1_A : A ;
  onoedgad_av_1_1_A : A ;
  onaatlad_av_1_1_A : A ;
  onaatad_av_1_1_A : A ;
  onaalad_av_1_1_A : A ;
  onaadad_av_1_1_A : A ;
  onaetad_av_1_1_A : A ;
  onaermad_av_1_1_A : A ;
  onyttjad_av_1_A : A ;
  onystad_av_1_A : A ;
  onynnad_av_1_A : A ;
  onyanserad_av_1_A : A ;
  onumrerad_av_1_A : A ;
  onuddad_av_1_A : A ;
  onubbad_av_1_A : A ;
  onotiserad_av_1_A : A ;
  onotifierad_av_1_A : A ;
  onotificerad_av_1_A : A ;
  onoterad_av_1_A : A ;
  onotad_av_1_A : A ;
  onorpad_av_1_A : A ;
  onormerad_av_1_A : A ;
  onormaliserad_av_1_A : A ;
  onoppad_av_1_A : A ;
  ononchalerad_av_1_A : A ;
  onominerad_av_1_A : A ;
  onollad_av_1_A : A ;
  onockad_av_1_A : A ;
  onobiliserad_av_1_A : A ;
  onobbad_av_1_A : A ;
  onivellerad_av_1_A : A ;
  onitrerad_av_1_A : A ;
  onitad_av_1_A : A ;
  oniellerad_av_1_A : A ;
  onickad_av_1_A : A ;
  oniad_av_1_A : A ;
  oneutraliserad_av_1_A : A ;
  onervaerderad_av_1_1_A : A ;
  onertransponerad_av_1_A : A ;
  onertransformerad_av_1_A : A ;
  onertecknad_av_1_A : A ;
  onerrustad_av_1_A : A ;
  onerklassad_av_1_A : A ;
  onerkavlad_av_1_A : A ;
  onerkastad_av_1_A : A ;
  onerkallad_av_1_A : A ;
  onerisad_av_1_A : A ;
  onerarbetad_av_1_A : A ;
  onekad_av_1_A : A ;
  onegotierad_av_1_A : A ;
  onegocierad_av_1_A : A ;
  onegligerad_av_1_A : A ;
  onegerad_av_1_A : A ;
  onedvaerderad_av_1_1_A : A ;
  onedtransponerad_av_1_A : A ;
  onedtransformerad_av_1_A : A ;
  onedtecknad_av_1_A : A ;
  onedrustad_av_1_A : A ;
  onedklassad_av_1_A : A ;
  onedkavlad_av_1_A : A ;
  onedkastad_av_1_A : A ;
  onedkallad_av_1_A : A ;
  onedisad_av_1_A : A ;
  onedarbetad_av_1_A : A ;
  onavlad_av_1_A : A ;
  onavigerad_av_1_A : A ;
  onaturaliserad_av_1_A : A ;
  onattad_av_1_A : A ;
  onationaliserad_av_1_A : A ;
  onasaliserad_av_1_A : A ;
  onasalerad_av_1_A : A ;
  onasad_av_1_A : A ;
  onarvad_av_1_A : A ;
  onarrad_av_1_A : A ;
  onarad_av_1_A : A ;
  onappad_av_1_A : A ;
  onamnad_av_1_A : A ;
  onallad_av_1_A : A ;
  onajad_av_1_A : A ;
  onaglad_av_1_A : A ;
  onaggad_av_1_A : A ;
  onafsad_av_1_A : A ;
  onackad_av_1_A : A ;
  omoerkad_av_1_1_A : A ;
  omoerdad_av_1_1_A : A ;
  omoerad_av_1_1_A : A ;
  omoenstrad_av_1_1_A : A ;
  omoeblerad_av_1_1_A : A ;
  omaattad_av_1_1_A : A ;
  omaanglad_av_1_1_A : A ;
  omaalad_av_1_1_A : A ;
  omaettad_av_1_1_A : A ;
  omaestrad_av_1_1_A : A ;
  omaeskad_av_1_1_A : A ;
  omaerglad_av_1_1_A : A ;
  omaeltad_av_1_1_A : A ;
  omaeklad_av_1_1_A : A ;
  omystifierad_av_1_A : A ;
  omyntad_av_1_A : A ;
  omyllad_av_1_A : A ;
  omuterad_av_1_A : A ;
  omutad_av_1_A : A ;
  omurad_av_1_A : A ;
  omumifierad_av_1_A : A ;
  omultiplicerad_av_1_A : A ;
  omuljerad_av_1_A : A ;
  omuddrad_av_1_A : A ;
  omtoecknad_av_1_1_A : A ;
  omtvistad_av_1_A : A ;
  omtumlad_av_1_A : A ;
  omtuggad_av_1_A : A ;
  omtalad_av_1_A : A ;
  omsusad_av_1_A : A ;
  omskakad_av_1_A : A ;
  omotverkad_av_1_A : A ;
  omotoriserad_av_1_A : A ;
  omotiverad_av_1_A : A ;
  omotbevisad_av_1_A : A ;
  omotarbetad_av_1_A : A ;
  omotad_av_1_A : A ;
  omosad_av_1_A : A ;
  omortifierad_av_1_A : A ;
  omortificerad_av_1_A : A ;
  omorserad_av_1_A : A ;
  omornad_av_1_A : A ;
  omorgnad_av_1_A : A ;
  omoppad_av_1_A : A ;
  omonterad_av_1_A : A ;
  omonopoliserad_av_1_A : A ;
  omonoftongerad_av_1_A : A ;
  omodaerniserad_av_1_1_A : A ;
  omodulerad_av_1_A : A ;
  omodifierad_av_1_A : A ;
  omoderniserad_av_1_A : A ;
  omodererad_av_1_A : A ;
  omodellerad_av_1_A : A ;
  omockad_av_1_A : A ;
  omobiliserad_av_1_A : A ;
  omobbad_av_1_A : A ;
  omkullknuffad_av_1_A : A ;
  omjoelkad_av_1_1_A : A ;
  omjoelad_av_1_1_A : A ;
  omjukad_av_1_A : A ;
  omixad_av_1_A : A ;
  omisskrediterad_av_1_A : A ;
  omissiverad_av_1_A : A ;
  omissad_av_1_A : A ;
  ominskad_av_1_A : A ;
  ominimerad_av_1_A : A ;
  ominiatyriserad_av_1_A : A ;
  omineraliserad_av_1_A : A ;
  ominerad_av_1_A : A ;
  omimad_av_1_A : A ;
  omilitariserad_av_1_A : A ;
  omildrad_av_1_A : A ;
  omikroskoperad_av_1_A : A ;
  omikrad_av_1_A : A ;
  omicrad_av_1_A : A ;
  omfladdrad_av_1_A : A ;
  ometalliserad_av_1_A : A ;
  omessad_av_1_A : A ;
  omeriterad_av_1_A : A ;
  omerceriserad_av_1_A : A ;
  omemorerad_av_1_A : A ;
  omekaniserad_av_1_A : A ;
  omejslad_av_1_A : A ;
  omejlad_av_1_A : A ;
  omejad_av_1_A : A ;
  omedicinerad_av_1_A : A ;
  omedaljerad_av_1_A : A ;
  omdiskuterad_av_1_A : A ;
  omdebatterad_av_1_A : A ;
  ombonad_av_1_A : A ;
  omaximerad_av_1_A : A ;
  omaxad_av_1_A : A ;
  omatterad_av_1_A : A ;
  omattad_av_1_A : A ;
  omaterialiserad_av_1_A : A ;
  omatelasserad_av_1_A : A ;
  omatchad_av_1_A : A ;
  omatad_av_1_A : A ;
  omastad_av_1_A : A ;
  omasserad_av_1_A : A ;
  omassakrerad_av_1_A : A ;
  omaskuliniserad_av_1_A : A ;
  omaskerad_av_1_A : A ;
  omaskad_av_1_A : A ;
  omasad_av_1_A : A ;
  omarterad_av_1_A : A ;
  omarmorerad_av_1_A : A ;
  omarkerad_av_1_A : A ;
  omarinerad_av_1_A : A ;
  omarginaliserad_av_1_A : A ;
  omanoevrerad_av_1_1_A : A ;
  omantlad_av_1_A : A ;
  omanipulerad_av_1_A : A ;
  omanikyrerad_av_1_A : A ;
  omanikurerad_av_1_A : A ;
  omanifesterad_av_1_A : A ;
  omanglad_av_1_A : A ;
  omanad_av_1_A : A ;
  omaltraeterad_av_1_1_A : A ;
  omalmad_av_1_A : A ;
  omalfoberad_av_1_A : A ;
  omakulerad_av_1_A : A ;
  omakad_av_1_A : A ;
  omajad_av_1_A : A ;
  omailad_av_1_A : A ;
  omagnetiserad_av_1_A : A ;
  omagasinerad_av_1_A : A ;
  omadrasserad_av_1_A : A ;
  oloevad_av_1_1_A : A ;
  oloenad_av_1_1_A : A ;
  oloegad_av_1_1_A : A ;
  olaatsad_av_1_1_A : A ;
  olaassad_av_1_1_A : A ;
  olaanad_av_1_1_A : A ;
  olaettrad_av_1_1_A : A ;
  olaettad_av_1_1_A : A ;
  olaeskad_av_1_1_A : A ;
  olaensad_av_1_1_A : A ;
  olaenkad_av_1_1_A : A ;
  olaempad_av_1_1_A : A ;
  olaemnad_av_1_1_A : A ;
  olaektrad_av_1_1_A : A ;
  olaegrad_av_1_1_A : A ;
  olaederad_av_1_1_A : A ;
  olyxrenoverad_av_1_A : A ;
  olyrad_av_1_A : A ;
  olynchad_av_1_A : A ;
  olyktad_av_1_A : A ;
  olycksdrabbad_av_1_A : A ;
  oluttrad_av_1_A : A ;
  oluteiniserad_av_1_A : A ;
  olutad_av_1_A : A ;
  olurad_av_1_A : A ;
  olunnad_av_1_A : A ;
  oluktad_av_1_A : A ;
  olugnad_av_1_A : A ;
  oluggad_av_1_A : A ;
  oluftad_av_1_A : A ;
  oluckrad_av_1_A : A ;
  olovad_av_1_A : A ;
  olottad_av_1_A : A ;
  olotsad_av_1_A : A ;
  olossad_av_1_A : A ;
  oloppad_av_1_A : A ;
  olokaliserad_av_1_A : A ;
  ologgad_av_1_A : A ;
  ologerad_av_1_A : A ;
  olodad_av_1_A : A ;
  olockoutad_av_1_A : A ;
  olockad_av_1_A : A ;
  olobbad_av_1_A : A ;
  oljustrad_av_1_A : A ;
  oljudad_av_1_A : A ;
  oljeskadad_av_1_A : A ;
  oljeblandad_av_1_A : A ;
  oljebaserad_av_1_A : A ;
  olivfaergad_av_1_1_A : A ;
  olivad_av_1_A : A ;
  olitsad_av_1_A : A ;
  olitograferad_av_1_A : A ;
  olistad_av_1_A : A ;
  olisserad_av_1_A : A ;
  olirad_av_1_A : A ;
  olinjerad_av_1_A : A ;
  olindrad_av_1_A : A ;
  olindad_av_1_A : A ;
  olimmad_av_1_A : A ;
  olikviderad_av_1_A : A ;
  olikfaergad_av_1_1_A : A ;
  olikartad_av_1_A : A ;
  olikad_av_1_A : A ;
  olierad_av_1_A : A ;
  olicentierad_av_1_A : A ;
  olicensierad_av_1_A : A ;
  olicenserad_av_1_A : A ;
  oliberaliserad_av_1_A : A ;
  olevererad_av_1_A : A ;
  olettrad_av_1_A : A ;
  oletad_av_1_A : A ;
  olenad_av_1_A : A ;
  olemlaestad_av_1_1_A : A ;
  olejdrad_av_1_A : A ;
  olegitimerad_av_1_A : A ;
  olegerad_av_1_A : A ;
  olegaliserad_av_1_A : A ;
  oledsagad_av_1_A : A ;
  oledad_av_1_A : A ;
  oleasad_av_1_A : A ;
  olaxad_av_1_A : A ;
  olaverad_av_1_A : A ;
  olatiniserad_av_1_A : A ;
  olastad_av_1_A : A ;
  olaskad_av_1_A : A ;
  olaserad_av_1_A : A ;
  olarmad_av_1_A : A ;
  olappad_av_1_A : A ;
  olapiserad_av_1_A : A ;
  olapad_av_1_A : A ;
  olanserad_av_1_A : A ;
  olangetterad_av_1_A : A ;
  olangad_av_1_A : A ;
  olandad_av_1_A : A ;
  olaminerad_av_1_A : A ;
  olamenterad_av_1_A : A ;
  olagrad_av_1_A : A ;
  olaggad_av_1_A : A ;
  olagad_av_1_A : A ;
  oladdad_av_1_A : A ;
  olackerad_av_1_A : A ;
  olackad_av_1_A : A ;
  olabialiserad_av_1_A : A ;
  okoernad_av_1_1_A : A ;
  okoenad_av_1_1_A : A ;
  okaarad_av_1_1_A : A ;
  okaankad_av_1_1_A : A ;
  okaernad_av_1_1_A : A ;
  okaerad_av_1_1_A : A ;
  okaelad_av_1_1_A : A ;
  okaekad_av_1_1_A : A ;
  okyprad_av_1_A : A ;
  okvoterad_av_1_A : A ;
  okvitterad_av_1_A : A ;
  okvittad_av_1_A : A ;
  okvistad_av_1_A : A ;
  okviltad_av_1_A : A ;
  okvarstannad_av_1_A : A ;
  okvarlaemnad_av_1_1_A : A ;
  okvantifierad_av_1_A : A ;
  okvalificerad_av_1_A : A ;
  okvadrerad_av_1_A : A ;
  okvaddad_av_1_A : A ;
  okuverterad_av_1_A : A ;
  okuvad_av_1_A : A ;
  okuschad_av_1_A : A ;
  okurtiserad_av_1_A : A ;
  okursiverad_av_1_A : A ;
  okursad_av_1_A : A ;
  okurerad_av_1_A : A ;
  okuraterad_av_1_A : A ;
  okurad_av_1_A : A ;
  okuperad_av_1_A : A ;
  okupad_av_1_A : A ;
  okumulerad_av_1_A : A ;
  okultiverad_av_1_A : A ;
  okullpratad_av_1_A : A ;
  okullkastad_av_1_A : A ;
  okullad_av_1_A : A ;
  okujonerad_av_1_A : A ;
  okuggad_av_1_A : A ;
  okuberad_av_1_A : A ;
  okraeppad_av_1_1_A : A ;
  okryssad_av_1_A : A ;
  okrypterad_av_1_A : A ;
  okryddad_av_1_A : A ;
  okrusad_av_1_A : A ;
  okrullad_av_1_A : A ;
  okrossad_av_1_A : A ;
  okromad_av_1_A : A ;
  okroknad_av_1_A : A ;
  okrokad_av_1_A : A ;
  okrockad_av_1_A : A ;
  okritiserad_av_1_A : A ;
  okritad_av_1_A : A ;
  okristnad_av_1_A : A ;
  okristalliserad_av_1_A : A ;
  okringskansad_av_1_A : A ;
  okringgaerdad_av_1_1_A : A ;
  okriminaliserad_av_1_A : A ;
  okreverad_av_1_A : A ;
  okretad_av_1_A : A ;
  okreperad_av_1_A : A ;
  okremerad_av_1_A : A ;
  okreerad_av_1_A : A ;
  okrediterad_av_1_A : A ;
  okredensad_av_1_A : A ;
  okrattad_av_1_A : A ;
  okratsad_av_1_A : A ;
  okraschad_av_1_A : A ;
  okransad_av_1_A : A ;
  okramad_av_1_A : A ;
  okrafsad_av_1_A : A ;
  okrackelerad_av_1_A : A ;
  okrackad_av_1_A : A ;
  okostymerad_av_1_A : A ;
  okortad_av_1_A : A ;
  okorsetterad_av_1_A : A ;
  okorsad_av_1_A : A ;
  okorrumperad_av_1_A : A ;
  okorrugerad_av_1_A : A ;
  okorroderad_av_1_A : A ;
  okorrigerad_av_1_A : A ;
  okorrelerad_av_1_A : A ;
  okorpad_av_1_A : A ;
  okorkad_av_1_A : A ;
  okorad_av_1_A : A ;
  okopplad_av_1_A : A ;
  okoppad_av_1_A : A ;
  okopierad_av_1_A : A ;
  okoordinerad_av_1_A : A ;
  okonvojerad_av_1_A : A ;
  okonverterad_av_1_A : A ;
  okonverserad_av_1_A : A ;
  okonvergerad_av_1_A : A ;
  okonturerad_av_1_A : A ;
  okontrollerad_av_1_A : A ;
  okontribuerad_av_1_A : A ;
  okontrasterad_av_1_A : A ;
  okontrasignerad_av_1_A : A ;
  okontramanderad_av_1_A : A ;
  okontrakterad_av_1_A : A ;
  okontraherad_av_1_A : A ;
  okontoriserad_av_1_A : A ;
  okontingenterad_av_1_A : A ;
  okonterad_av_1_A : A ;
  okontaminerad_av_1_A : A ;
  okontaktad_av_1_A : A ;
  okonsumerad_av_1_A : A ;
  okonsulterad_av_1_A : A ;
  okonstruerad_av_1_A : A ;
  okonstlad_av_1_A : A ;
  okonstituerad_av_1_A : A ;
  okonsternerad_av_1_A : A ;
  okonstbevattnad_av_1_A : A ;
  okonstbefruktad_av_1_A : A ;
  okonstaterad_av_1_A : A ;
  okonsoliderad_av_1_A : A ;
  okonsignerad_av_1_A : A ;
  okonserverad_av_1_A : A ;
  okonkretiserad_av_1_A : A ;
  okonkluderad_av_1_A : A ;
  okonjugerad_av_1_A : A ;
  okongruerad_av_1_A : A ;
  okonfunderad_av_1_A : A ;
  okonfronterad_av_1_A : A ;
  okonfiskerad_av_1_A : A ;
  okonfirmerad_av_1_A : A ;
  okondolerad_av_1_A : A ;
  okonditionerad_av_1_A : A ;
  okondenserad_av_1_A : A ;
  okondemnerad_av_1_A : A ;
  okoncipierad_av_1_A : A ;
  okoncessionerad_av_1_A : A ;
  okoncentrerad_av_1_A : A ;
  okomprometterad_av_1_A : A ;
  okomprimerad_av_1_A : A ;
  okomposterad_av_1_A : A ;
  okomponerad_av_1_A : A ;
  okomplimenterad_av_1_A : A ;
  okomplicerad_av_1_A : A ;
  okompletterad_av_1_A : A ;
  okompilerad_av_1_A : A ;
  okompenserad_av_1_A : A ;
  okomparerad_av_1_A : A ;
  okompad_av_1_A : A ;
  okommuterad_av_1_A : A ;
  okommunicerad_av_1_A : A ;
  okommunaliserad_av_1_A : A ;
  okommersialiserad_av_1_A : A ;
  okommersad_av_1_A : A ;
  okommenterad_av_1_A : A ;
  okommenderad_av_1_A : A ;
  okommaterad_av_1_A : A ;
  nypaakommen_av_1_1_A : A ;
  nygammal_av_1_A : A ;
  nattgammal_av_1_A : A ;
  lillgammal_av_1_A : A ;
  lastgammal_av_1_A : A ;
  lagakraftvunnen_av_1_A : A ;
  kvartssekelgammal_av_1_A : A ;
  jaemngammal_av_1_1_A : A ;
  jaemgammal_av_1_1_A : A ;
  hemkommen_av_1_A : A ;
  halvgammal_av_1_A : A ;
  fesljummen_av_1_A : A ;
  dygnsgammal_av_1_A : A ;
  ditkommen_av_1_A : A ;
  vaenster_av_1_1_A : A ;
  okombinerad_av_1_A : A ;
  okolporterad_av_1_A : A ;
  okolorerad_av_1_A : A ;
  okoloniserad_av_1_A : A ;
  okollektiviserad_av_1_A : A ;
  okollationerad_av_1_A : A ;
  okollapsad_av_1_A : A ;
  okollad_av_1_A : A ;
  okolkad_av_1_A : A ;
  okolad_av_1_A : A ;
  okojsad_av_1_A : A ;
  okojad_av_1_A : A ;
  okodifierad_av_1_A : A ;
  okodad_av_1_A : A ;
  okoagulerad_av_1_A : A ;
  okoafferad_av_1_A : A ;
  oknoelad_av_1_1_A : A ;
  oknaadad_av_1_1_A : A ;
  oknaead_av_1_1_A : A ;
  oknypplad_av_1_A : A ;
  oknycklad_av_1_A : A ;
  oknullad_av_1_A : A ;
  oknuffad_av_1_A : A ;
  oknorvad_av_1_A : A ;
  oknopad_av_1_A : A ;
  oknollrad_av_1_A : A ;
  oknockad_av_1_A : A ;
  oknivad_av_1_A : A ;
  oknipsad_av_1_A : A ;
  oknatad_av_1_A : A ;
  oknarkad_av_1_A : A ;
  oknaprad_av_1_A : A ;
  oknackad_av_1_A : A ;
  okloevjad_av_1_1_A : A ;
  oklaettrad_av_1_1_A : A ;
  oklyftad_av_1_A : A ;
  okluddad_av_1_A : A ;
  oklubbad_av_1_A : A ;
  oklottrad_av_1_A : A ;
  oklorerad_av_1_A : A ;
  oklonad_av_1_A : A ;
  oklockad_av_1_A : A ;
  oklistrad_av_1_A : A ;
  oklirad_av_1_A : A ;
  okliad_av_1_A : A ;
  okletad_av_1_A : A ;
  oklenad_av_1_A : A ;
  oklatschad_av_1_A : A ;
  oklassificerad_av_1_A : A ;
  oklassad_av_1_A : A ;
  oklarerad_av_1_A : A ;
  oklarad_av_1_A : A ;
  oklappad_av_1_A : A ;
  oklandrad_av_1_A : A ;
  oklamrad_av_1_A : A ;
  oklampad_av_1_A : A ;
  oklackad_av_1_A : A ;
  okittlad_av_1_A : A ;
  okittad_av_1_A : A ;
  okissad_av_1_A : A ;
  okirrad_av_1_A : A ;
  okillad_av_1_A : A ;
  okilad_av_1_A : A ;
  okikad_av_1_A : A ;
  okidnappad_av_1_A : A ;
  okickad_av_1_A : A ;
  okedjad_av_1_A : A ;
  okavlad_av_1_A : A ;
  okauteriserad_av_1_A : A ;
  okattad_av_1_A : A ;
  okatetriserad_av_1_A : A ;
  okateteriserad_av_1_A : A ;
  okategoriserad_av_1_A : A ;
  okatalyserad_av_1_A : A ;
  okatalogiserad_av_1_A : A ;
  okastrerad_av_1_A : A ;
  okastad_av_1_A : A ;
  okasserad_av_1_A : A ;
  okarvad_av_1_A : A ;
  okartonnerad_av_1_A : A ;
  okarterad_av_1_A : A ;
  okarikerad_av_1_A : A ;
  okardad_av_1_A : A ;
  okarboniserad_av_1_A : A ;
  okarambolerad_av_1_A : A ;
  okaraktaeriserad_av_1_1_A : A ;
  okarakteriserad_av_1_A : A ;
  okarad_av_1_A : A ;
  okapslad_av_1_A : A ;
  okapsejsad_av_1_A : A ;
  okapitaliserad_av_1_A : A ;
  okapad_av_1_A : A ;
  okantrad_av_1_A : A ;
  okantad_av_1_A : A ;
  okanoniserad_av_1_A : A ;
  okannelerad_av_1_A : A ;
  okanderad_av_1_A : A ;
  okanaliserad_av_1_A : A ;
  okamouflerad_av_1_A : A ;
  okammad_av_1_A : A ;
  okalmerad_av_1_A : A ;
  okallnad_av_1_A : A ;
  okallad_av_1_A : A ;
  okalkylerad_av_1_A : A ;
  okalkerad_av_1_A : A ;
  okalkad_av_1_A : A ;
  okalibrerad_av_1_A : A ;
  okalfatrad_av_1_A : A ;
  okalcinerad_av_1_A : A ;
  okalandrerad_av_1_A : A ;
  okaklad_av_1_A : A ;
  okablad_av_1_A : A ;
  ojaevad_av_1_1_A : A ;
  ojaemnad_av_1_1_A : A ;
  ojaemkad_av_1_1_A : A ;
  ojaektad_av_1_1_A : A ;
  ojusterad_av_1_A : A ;
  ojordad_av_1_A : A ;
  ojoniserad_av_1_A : A ;
  ojonglerad_av_1_A : A ;
  ojollrad_av_1_A : A ;
  ojojkad_av_1_A : A ;
  ojoggad_av_1_A : A ;
  ojoderad_av_1_A : A ;
  ojoddlad_av_1_A : A ;
  ojazzifierad_av_1_A : A ;
  ojakad_av_1_A : A ;
  ojagad_av_1_A : A ;
  ojabbad_av_1_A : A ;
  oitutad_av_1_A : A ;
  oitererad_av_1_A : A ;
  oisolerad_av_1_A : A ;
  oislamiserad_av_1_A : A ;
  oirriterad_av_1_A : A ;
  oinoevad_av_1_1_A : A ;
  oinympad_av_1_A : A ;
  oinvaentad_av_1_1_A : A ;
  oinvolverad_av_1_A : A ;
  oinviterad_av_1_A : A ;
  oinvesterad_av_1_A : A ;
  oinverterad_av_1_A : A ;
  oinventerad_av_1_A : A ;
  oinvecklad_av_1_A : A ;
  oinvandrad_av_1_A : A ;
  oinvalidiserad_av_1_A : A ;
  oinvaggad_av_1_A : A ;
  oinvaderad_av_1_A : A ;
  ointaagad_av_1_1_A : A ;
  ointygad_av_1_A : A ;
  ointraeffad_av_1_1_A : A ;
  ointrumfad_av_1_A : A ;
  ointroducerad_av_1_A : A ;
  ointresserad_av_1_A : A ;
  ointonerad_av_1_A : A ;
  ointolkad_av_1_A : A ;
  ointervjuad_av_1_A : A ;
  ointervenerad_av_1_A : A ;
  ointerpunkterad_av_1_A : A ;
  ointerpreterad_av_1_A : A ;
  ointerpolerad_av_1_A : A ;
  ointerpellerad_av_1_A : A ;
  ointernerad_av_1_A : A ;
  ointernationaliserad_av_1_A : A ;
  ointernaliserad_av_1_A : A ;
  ointerfolierad_av_1_A : A ;
  ointensiverad_av_1_A : A ;
  ointensifierad_av_1_A : A ;
  ointellektualiserad_av_1_A : A ;
  ointegrerad_av_1_A : A ;
  ointecknad_av_1_A : A ;
  oinsoendrad_av_1_1_A : A ;
  oinstuderad_av_1_A : A ;
  oinstraalad_av_1_1_A : A ;
  oinstrumenterad_av_1_A : A ;
  oinstruerad_av_1_A : A ;
  oinstitutionaliserad_av_1_A : A ;
  oinstiftad_av_1_A : A ;
  oinstallerad_av_1_A : A ;
  oinspirerad_av_1_A : A ;
  oinspekterad_av_1_A : A ;
  oinsomnad_av_1_A : A ;
  oinskolad_av_1_A : A ;
  oinskeppad_av_1_A : A ;
  oinskaffad_av_1_A : A ;
  oinsjuknad_av_1_A : A ;
  oinsisterad_av_1_A : A ;
  oinsinuerad_av_1_A : A ;
  oinseminerad_av_1_A : A ;
  oinseglad_av_1_A : A ;
  oinscenerad_av_1_A : A ;
  oinsamlad_av_1_A : A ;
  oinraettad_av_1_1_A : A ;
  oinraeknad_av_1_1_A : A ;
  oinropad_av_1_A : A ;
  oinristad_av_1_A : A ;
  oinringad_av_1_A : A ;
  oinriktad_av_1_A : A ;
  oinregistrerad_av_1_A : A ;
  oinrapporterad_av_1_A : A ;
  oinrangerad_av_1_A : A ;
  oinramad_av_1_A : A ;
  oinpraentad_av_1_1_A : A ;
  oinpraeglad_av_1_1_A : A ;
  oinprickad_av_1_A : A ;
  oinpressad_av_1_A : A ;
  oinplanterad_av_1_A : A ;
  oinplantad_av_1_A : A ;
  oinpassad_av_1_A : A ;
  oinordnad_av_1_A : A ;
  oinoljad_av_1_A : A ;
  oinokulerad_av_1_A : A ;
  oinnerverad_av_1_A : A ;
  oinnefattad_av_1_A : A ;
  oinmoenstrad_av_1_1_A : A ;
  oinmundigad_av_1_A : A ;
  oinmatad_av_1_A : A ;
  oinlaanad_av_1_1_A : A ;
  oinlaemnad_av_1_1_A : A ;
  oinlemmad_av_1_A : A ;
  oinkvarterad_av_1_A : A ;
  oinkorporerad_av_1_A : A ;
  oinkopplad_av_1_A : A ;
  oinkluderad_av_1_A : A ;
  oinklarerad_av_1_A : A ;
  oinkasserad_av_1_A : A ;
  oinkarnerad_av_1_A : A ;
  oinkapslad_av_1_A : A ;
  oinkallad_av_1_A : A ;
  oinjicerad_av_1_A : A ;
  oinjekterad_av_1_A : A ;
  oinjagad_av_1_A : A ;
  oinitierad_av_1_A : A ;
  oinhoestad_av_1_1_A : A ;
  oinhaemtad_av_1_1_A : A ;
  oinhaegnad_av_1_1_A : A ;
  oinhibiterad_av_1_A : A ;
  oinhiberad_av_1_A : A ;
  oinhandlad_av_1_A : A ;
  oinhalerad_av_1_A : A ;
  oingraverad_av_1_A : A ;
  oinfoerskaffad_av_1_1_A : A ;
  oinfoerlivad_av_1_1_A : A ;
  oinfaangad_av_1_1_A : A ;
  oinfriad_av_1_A : A ;
  oinformerad_av_1_A : A ;
  oinfordrad_av_1_A : A ;
  oinfogad_av_1_A : A ;
  oinfodrad_av_1_A : A ;
  oinflaetad_av_1_1_A : A ;
  oinflyttad_av_1_A : A ;
  oinfluerad_av_1_A : A ;
  oinflammerad_av_1_A : A ;
  oinfiltrerad_av_1_A : A ;
  oinfettad_av_1_A : A ;
  oinfekterad_av_1_A : A ;
  oinfattad_av_1_A : A ;
  oindustrialiserad_av_1_A : A ;
  oindunstad_av_1_A : A ;
  oinducerad_av_1_A : A ;
  oindoktrinerad_av_1_A : A ;
  oindividualiserad_av_1_A : A ;
  oindikerad_av_1_A : A ;
  oindicerad_av_1_A : A ;
  oindexerad_av_1_A : A ;
  oindelad_av_1_A : A ;
  oinblandad_av_1_A : A ;
  oinbillad_av_1_A : A ;
  oinbesparad_av_1_A : A ;
  oinberaeknad_av_1_1_A : A ;
  oinbakad_av_1_A : A ;
  oinaugurerad_av_1_A : A ;
  oinarbetad_av_1_A : A ;
  oinackorderad_av_1_A : A ;
  oimproviserad_av_1_A : A ;
  oimpregnerad_av_1_A : A ;
  oimporterad_av_1_A : A ;
  oimponerad_av_1_A : A ;
  oimploderad_av_1_A : A ;
  oimplicerad_av_1_A : A ;
  oimplanterad_av_1_A : A ;
  oimpad_av_1_A : A ;
  oimmuniserad_av_1_A : A ;
  oimmigrerad_av_1_A : A ;
  oimmatrikulerad_av_1_A : A ;
  oimiterad_av_1_A : A ;
  oillustrerad_av_1_A : A ;
  oilluminerad_av_1_A : A ;
  oignorerad_av_1_A : A ;
  oidkad_av_1_A : A ;
  oidisslad_av_1_A : A ;
  oidentifierad_av_1_A : A ;
  oidealiserad_av_1_A : A ;
  ohoersammad_av_1_1_A : A ;
  ohoegaktad_av_1_1_A : A ;
  ohaavad_av_1_1_A : A ;
  ohaardnad_av_1_1_A : A ;
  ohaanad_av_1_1_A : A ;
  ohaalad_av_1_1_A : A ;
  ohaagad_av_1_1_A : A ;
  ohaevdad_av_1_1_A : A ;
  ohaessjad_av_1_1_A : A ;
  ohaersknad_av_1_1_A : A ;
  ohaermad_av_1_1_A : A ;
  ohaerjad_av_1_1_A : A ;
  ohaerdad_av_1_1_A : A ;
  ohaerbaergerad_av_1_1_A : A ;
  ohaenvisad_av_1_1_A : A ;
  ohaemtad_av_1_1_A : A ;
  ohaemnad_av_1_1_A : A ;
  ohaemmad_av_1_1_A : A ;
  ohaelsad_av_1_1_A : A ;
  ohaektad_av_1_1_A : A ;
  ohaegnad_av_1_1_A : A ;
  ohaeftad_av_1_1_A : A ;
  ohaedankallad_av_1_1_A : A ;
  ohaecklad_av_1_1_A : A ;
  ohyvlad_av_1_A : A ;
  ohyvad_av_1_A : A ;
  ohystad_av_1_A : A ;
  ohyssjad_av_1_A : A ;
  ohypotiserad_av_1_A : A ;
  ohypnotiserad_av_1_A : A ;
  ohyllad_av_1_A : A ;
  ohyfsad_av_1_A : A ;
  ohydrerad_av_1_A : A ;
  ohycklad_av_1_A : A ;
  ohybridiserad_av_1_A : A ;
  ohuserad_av_1_A : A ;
  ohunsad_av_1_A : A ;
  ohundsfotterad_av_1_A : A ;
  ohundsad_av_1_A : A ;
  ohumaniserad_av_1_A : A ;
  ohugnad_av_1_A : A ;
  ohottad_av_1_A : A ;
  ohotad_av_1_A : A ;
  ohostad_av_1_A : A ;
  ohospitaliserad_av_1_A : A ;
  ohoppad_av_1_A : A ;
  ohoplappad_av_1_A : A ;
  ohopfogad_av_1_A : A ;
  ohopdiktad_av_1_A : A ;
  ohopad_av_1_A : A ;
  ohonorerad_av_1_A : A ;
  ohomogeniserad_av_1_A : A ;
  oholograferad_av_1_A : A ;
  ohivad_av_1_A : A ;
  ohittad_av_1_A : A ;
  ohistoriserad_av_1_A : A ;
  ohistorierad_av_1_A : A ;
  ohissad_av_1_A : A ;
  ohinkad_av_1_A : A ;
  ohindrad_av_1_A : A ;
  ohetsad_av_1_A : A ;
  oheroiserad_av_1_A : A ;
  ohenad_av_1_A : A ;
  ohelgad_av_1_A : A ;
  ohelad_av_1_A : A ;
  ohejdad_av_1_A : A ;
  ohejad_av_1_A : A ;
  ohedrad_av_1_A : A ;
  ohavererad_av_1_A : A ;
  ohaussad_av_1_A : A ;
  ohatad_av_1_A : A ;
  ohasplad_av_1_A : A ;
  ohaspad_av_1_A : A ;
  ohasarderad_av_1_A : A ;
  ohasad_av_1_A : A ;
  oharvad_av_1_A : A ;
  ohartsad_av_1_A : A ;
  oharpunerad_av_1_A : A ;
  oharmoniserad_av_1_A : A ;
  oharmad_av_1_A : A ;
  oharangerad_av_1_A : A ;
  ohanterad_av_1_A : A ;
  ohandlad_av_1_A : A ;
  ohandikappad_av_1_A : A ;
  ohamstrad_av_1_A : A ;
  ohamrad_av_1_A : A ;
  ohamlad_av_1_A : A ;
  ohalverad_av_1_A : A ;
  ohalstrad_av_1_A : A ;
  ohalsad_av_1_A : A ;
  ohallucinerad_av_1_A : A ;
  ohalad_av_1_A : A ;
  ohakad_av_1_A : A ;
  ohajad_av_1_A : A ;
  ohaffad_av_1_A : A ;
  ohackad_av_1_A : A ;
  ogoerdlad_av_1_1_A : A ;
  ogoekad_av_1_1_A : A ;
  ogoedslad_av_1_1_A : A ;
  ogaangrad_av_1_1_A : A ;
  ogaestad_av_1_1_A : A ;
  ogaerdslad_av_1_1_A : A ;
  ogaerdad_av_1_1_A : A ;
  ogaengad_av_1_1_A : A ;
  ogaelad_av_1_1_A : A ;
  ogaeckad_av_1_1_A : A ;
  ogynnad_av_1_A : A ;
  ogymnastiserad_av_1_A : A ;
  oguterad_av_1_A : A ;
  oguskad_av_1_A : A ;
  ogurglad_av_1_A : A ;
  ogungad_av_1_A : A ;
  ogummerad_av_1_A : A ;
  ogulnad_av_1_A : A ;
  oguidad_av_1_A : A ;
  ogroepad_av_1_1_A : A ;
  ograanad_av_1_1_A : A ;
  ograesbekaempad_av_1_1_A : A ;
  ograenslad_av_1_1_A : A ;
  ograeftad_av_1_1_A : A ;
  ograeddad_av_1_1_A : A ;
  ogrusad_av_1_A : A ;
  ogrupperad_av_1_A : A ;
  ogrunderad_av_1_A : A ;
  ogrundad_av_1_A : A ;
  ogrumsad_av_1_A : A ;
  ogrumlad_av_1_A : A ;
  ogroddad_av_1_A : A ;
  ogrimerad_av_1_A : A ;
  ogrillad_av_1_A : A ;
  ogriljerad_av_1_A : A ;
  ogreppad_av_1_A : A ;
  ogrenslad_av_1_A : A ;
  ogrenad_av_1_A : A ;
  ogrejad_av_1_A : A ;
  ograverad_av_1_A : A ;
  ogravad_av_1_A : A ;
  ogratulerad_av_1_A : A ;
  ograttad_av_1_A : A ;
  ogratinerad_av_1_A : A ;
  ogranulerad_av_1_A : A ;
  ogranskad_av_1_A : A ;
  ografiterad_av_1_A : A ;
  ograduerad_av_1_A : A ;
  ograderad_av_1_A : A ;
  ogradad_av_1_A : A ;
  ograbbad_av_1_A : A ;
  ogouterad_av_1_A : A ;
  ogooglad_av_1_A : A ;
  ogolvad_av_1_A : A ;
  ogoffrerad_av_1_A : A ;
  ognuggad_av_1_A : A ;
  ognolad_av_1_A : A ;
  ognistad_av_1_A : A ;
  ogloedgad_av_1_1_A : A ;
  oglaettad_av_1_1_A : A ;
  oglaentad_av_1_1_A : A ;
  oglorifierad_av_1_A : A ;
  oglesnad_av_1_A : A ;
  oglesad_av_1_A : A ;
  oglattad_av_1_A : A ;
  oglaserad_av_1_A : A ;
  oglasad_av_1_A : A ;
  oglanskad_av_1_A : A ;
  oglansad_av_1_A : A ;
  oglamouriserad_av_1_A : A ;
  oglamoriserad_av_1_A : A ;
  ogjordad_av_1_A : A ;
  ogistad_av_1_A : A ;
  ogisslad_av_1_A : A ;
  ogissad_av_1_A : A ;
  ogirerad_av_1_A : A ;
  ogipsad_av_1_A : A ;
  ogiltigfoerklarad_av_1_1_A : A ;
  ogillrad_av_1_A : A ;
  ogillad_av_1_A : A ;
  ogiljotinerad_av_1_A : A ;
  ogigad_av_1_A : A ;
  ogestaltad_av_1_A : A ;
  ogermaniserad_av_1_A : A ;
  ogeotaggad_av_1_A : A ;
  ogeometriserad_av_1_A : A ;
  ogenomsyrad_av_1_A : A ;
  ogenomstroemmad_av_1_1_A : A ;
  ogenomskaadad_av_1_1_A : A ;
  ogenomsipprad_av_1_A : A ;
  ogenomkorsad_av_1_A : A ;
  ogenomborrad_av_1_A : A ;
  ogenomarbetad_av_1_A : A ;
  ogengaeldad_av_1_1_A : A ;
  ogenererad_av_1_A : A ;
  ogeneraliserad_av_1_A : A ;
  ogenerad_av_1_A : A ;
  ogeminerad_av_1_A : A ;
  ogelead_av_1_A : A ;
  ogelatinerad_av_1_A : A ;
  ogauffrerad_av_1_A : A ;
  ogastroskoperad_av_1_A : A ;
  ogasad_av_1_A : A ;
  ogarvad_av_1_A : A ;
  ogarrotterad_av_1_A : A ;
  ogarnisonerad_av_1_A : A ;
  ogarnerad_av_1_A : A ;
  ogarderad_av_1_A : A ;
  ogaranterad_av_1_A : A ;
  ogaragerad_av_1_A : A ;
  ogarad_av_1_A : A ;
  oganad_av_1_A : A ;
  ogalvaniserad_av_1_A : A ;
  ogalvad_av_1_A : A ;
  ogaloscherad_av_1_A : A ;
  ogallrad_av_1_A : A ;
  ogalliserad_av_1_A : A ;
  ogagnad_av_1_A : A ;
  ofoeroevad_av_1_1_A : A ;
  ofoeroekad_av_1_1_A : A ;
  ofoeroedmjukad_av_1_1_A : A ;
  ofoeraangad_av_1_1_A : A ;
  ofoeraerad_av_1_1_A : A ;
  ofoeraendrad_av_1_1_A : A ;
  ofoeraedlad_av_1_1_A : A ;
  ofoerzinkad_av_1_1_A : A ;
  ofoeryngrad_av_1_1_A : A ;
  ofoervaanad_av_1_1_A : A ;
  ofoervaallad_av_1_1_A : A ;
  ofoervaexlad_av_1_1_A : A ;
  ofoervaervad_av_1_1_A : A ;
  ofoervaerrad_av_1_1_A : A ;
  ofoervaerldsligad_av_1_1_A : A ;
  ofoervaentad_av_1_1_A : A ;
  ofoervaegrad_av_1_1_A : A ;
  ofoervittrad_av_1_1_A : A ;
  ofoervissnad_av_1_1_A : A ;
  ofoervissad_av_1_1_A : A ;
  ofoervisad_av_1_1_A : A ;
  ofoervirrad_av_1_1_A : A ;
  ofoervillad_av_1_1_A : A ;
  ofoerverkligad_av_1_1_A : A ;
  ofoerverkad_av_1_1_A : A ;
  ofoervekligad_av_1_1_A : A ;
  ofoervedad_av_1_1_A : A ;
  ofoervarnad_av_1_1_A : A ;
  ofoervarad_av_1_1_A : A ;
  ofoervanskad_av_1_1_A : A ;
  ofoervandlad_av_1_1_A : A ;
  ofoervaltad_av_1_1_A : A ;
  ofoerutskickad_av_1_1_A : A ;
  ofoerunnad_av_1_1_A : A ;
  ofoerundrad_av_1_1_A : A ;
  ofoertoevad_av_1_1_A : A ;
  ofoertaetad_av_1_1_A : A ;
  ofoertyskad_av_1_1_A : A ;
  ofoertydligad_av_1_1_A : A ;
  ofoertvaalad_av_1_1_A : A ;
  ofoertvivlad_av_1_1_A : A ;
  ofoertvinad_av_1_1_A : A ;
  ofoertunnad_av_1_1_A : A ;
  ofoertullad_av_1_1_A : A ;
  ofoertroestad_av_1_1_A : A ;
  ofoertrustad_av_1_1_A : A ;
  ofoertrollad_av_1_1_A : A ;
  ofoertretad_av_1_1_A : A ;
  ofoertrampad_av_1_1_A : A ;
  ofoertorkad_av_1_1_A : A ;
  ofoertjaenad_av_1_1_A : A ;
  ofoertjockad_av_1_1_A : A ;
  ofoertennad_av_1_1_A : A ;
  ofoertecknad_av_1_1_A : A ;
  ofoertalad_av_1_1_A : A ;
  ofoersaemrad_av_1_1_A : A ;
  ofoersaekrad_av_1_1_A : A ;
  ofoersvaarad_av_1_1_A : A ;
  ofoersvenskad_av_1_1_A : A ;
  ofoersvarad_av_1_1_A : A ;
  ofoersvagad_av_1_1_A : A ;
  ofoersurad_av_1_1_A : A ;
  ofoersummad_av_1_1_A : A ;
  ofoerstaendigad_av_1_1_A : A ;
  ofoerstummad_av_1_1_A : A ;
  ofoerstraevad_av_1_1_A : A ;
  ofoerstorad_av_1_1_A : A ;
  ofoerstoppad_av_1_1_A : A ;
  ofoerstockad_av_1_1_A : A ;
  ofoerstenad_av_1_1_A : A ;
  ofoerstelnad_av_1_1_A : A ;
  ofoerstatligad_av_1_1_A : A ;
  ofoersonad_av_1_1_A : A ;
  ofoersoffad_av_1_1_A : A ;
  ofoersnillad_av_1_1_A : A ;
  ofoersloesad_av_1_1_A : A ;
  ofoersloead_av_1_1_A : A ;
  ofoerslavad_av_1_1_A : A ;
  ofoerslappad_av_1_1_A : A ;
  ofoerskoenad_av_1_1_A : A ;
  ofoerskotterad_av_1_1_A : A ;
  ofoerskonad_av_1_1_A : A ;
  ofoerskingrad_av_1_1_A : A ;
  ofoerskansad_av_1_1_A : A ;
  ofoerskaffad_av_1_1_A : A ;
  ofoersinkad_av_1_1_A : A ;
  ofoersilvrad_av_1_1_A : A ;
  ofoersenad_av_1_1_A : A ;
  ofoerseglad_av_1_1_A : A ;
  ofoersamlad_av_1_1_A : A ;
  ofoersakad_av_1_1_A : A ;
  ofoerraaad_av_1_1_A : A ;
  ofoerraettad_av_1_1_A : A ;
  ofoerraentad_av_1_1_A : A ;
  ofoerryskad_av_1_1_A : A ;
  ofoerruttnad_av_1_1_A : A ;
  ofoerringad_av_1_1_A : A ;
  ofoerprickad_av_1_1_A : A ;
  ofoerplaegad_av_1_1_A : A ;
  ofoerpliktigad_av_1_1_A : A ;
  ofoerpliktad_av_1_1_A : A ;
  ofoerpestad_av_1_1_A : A ;
  ofoerpassad_av_1_1_A : A ;
  ofoerpantad_av_1_1_A : A ;
  ofoerpaktad_av_1_1_A : A ;
  ofoerpackad_av_1_1_A : A ;
  ofoeroraettad_av_1_1_A : A ;
  ofoerorsakad_av_1_1_A : A ;
  ofoerorenad_av_1_1_A : A ;
  ofoerordnad_av_1_1_A : A ;
  ofoerordad_av_1_1_A : A ;
  ofoerolaempad_av_1_1_A : A ;
  ofoernaermad_av_1_1_A : A ;
  ofoernyad_av_1_1_A : A ;
  ofoernicklad_av_1_1_A : A ;
  ofoernekad_av_1_1_A : A ;
  ofoernedrad_av_1_1_A : A ;
  ofoermoerkad_av_1_1_A : A ;
  ofoermaenskligad_av_1_1_A : A ;
  ofoermultnad_av_1_1_A : A ;
  ofoermodad_av_1_1_A : A ;
  ofoerminskad_av_1_1_A : A ;
  ofoermildrad_av_1_1_A : A ;
  ofoermenad_av_1_1_A : A ;
  ofoermedlad_av_1_1_A : A ;
  ofoermanad_av_1_1_A : A ;
  ofoerloejligad_av_1_1_A : A ;
  ofoerlaenad_av_1_1_A : A ;
  ofoerlustad_av_1_1_A : A ;
  ofoerlossad_av_1_1_A : A ;
  ofoerlorad_av_1_1_A : A ;
  ofoerljuvad_av_1_1_A : A ;
  ofoerlamad_av_1_1_A : A ;
  ofoerkunnad_av_1_1_A : A ;
  ofoerkrossad_av_1_1_A : A ;
  ofoerkroppsligad_av_1_1_A : A ;
  ofoerkromad_av_1_1_A : A ;
  ofoerkovrad_av_1_1_A : A ;
  ofoerkortad_av_1_1_A : A ;
  ofoerkolnad_av_1_1_A : A ;
  ofoerknippad_av_1_1_A : A ;
  ofoerklistrad_av_1_1_A : A ;
  ofoerklingad_av_1_1_A : A ;
  ofoerklarad_av_1_1_A : A ;
  ofoerkastad_av_1_1_A : A ;
  ofoerjagad_av_1_1_A : A ;
  ofoerintad_av_1_1_A : A ;
  ofoerhaanad_av_1_1_A : A ;
  ofoerhaexad_av_1_1_A : A ;
  ofoerhaerligad_av_1_1_A : A ;
  ofoerhaerjad_av_1_1_A : A ;
  ofoerhaerdad_av_1_1_A : A ;
  ofoerhindrad_av_1_1_A : A ;
  ofoerhandlad_av_1_1_A : A ;
  ofoerhalad_av_1_1_A : A ;
  ofoergrymmad_av_1_1_A : A ;
  ofoergrovad_av_1_1_A : A ;
  ofoergiftad_av_1_1_A : A ;
  ofoergasad_av_1_1_A : A ;
  ofoerfoerdelad_av_1_1_A : A ;
  ofoerfaangad_av_1_1_A : A ;
  ofoerfaerdigad_av_1_1_A : A ;
  ofoerfaerad_av_1_1_A : A ;
  ofoerfaektad_av_1_1_A : A ;
  ofoerfaead_av_1_1_A : A ;
  ofoerfuskad_av_1_1_A : A ;
  ofoerfranskad_av_1_1_A : A ;
  ofoerflyttad_av_1_1_A : A ;
  ofoerflackad_av_1_1_A : A ;
  ofoerfinad_av_1_1_A : A ;
  ofoerfelad_av_1_1_A : A ;
  ofoerfattad_av_1_1_A : A ;
  ofoerfalskad_av_1_1_A : A ;
  ofoerevitad_av_1_1_A : A ;
  ofoerevisad_av_1_1_A : A ;
  ofoerevigad_av_1_1_A : A ;
  ofoerestavad_av_1_1_A : A ;
  ofoerespraakad_av_1_1_A : A ;
  ofoerespeglad_av_1_1_A : A ;
  ofoerenklad_av_1_1_A : A ;
  ofoerebaadad_av_1_1_A : A ;
  ofoerdaervad_av_1_1_A : A ;
  ofoerdystrad_av_1_1_A : A ;
  ofoerdyrad_av_1_1_A : A ;
  ofoerdunstad_av_1_1_A : A ;
  ofoerdunklad_av_1_1_A : A ;
  ofoerdummad_av_1_1_A : A ;
  ofoerdubblad_av_1_1_A : A ;
  ofoerdjupad_av_1_1_A : A ;
  ofoerdelad_av_1_1_A : A ;
  ofoerbaettrad_av_1_1_A : A ;
  ofoerbuskad_av_1_1_A : A ;
  ofoerbroedrad_av_1_1_A : A ;
  ofoerbryllad_av_1_1_A : A ;
  ofoerbrukad_av_1_1_A : A ;
  ofoerborgerligad_av_1_1_A : A ;
  ofoerborgad_av_1_1_A : A ;
  ofoerbluffad_av_1_1_A : A ;
  ofoerblommerad_av_1_1_A : A ;
  ofoerblindad_av_1_1_A : A ;
  ofoerbleknad_av_1_1_A : A ;
  ofoerblandad_av_1_1_A : A ;
  ofoerbittrad_av_1_1_A : A ;
  ofoerbilligad_av_1_1_A : A ;
  ofoerbidad_av_1_1_A : A ;
  ofoerbannad_av_1_1_A : A ;
  ofoerargad_av_1_1_A : A ;
  ofoeranstaltad_av_1_1_A : A ;
  ofoerannonserad_av_1_1_A : A ;
  ofoerankrad_av_1_1_A : A ;
  ofoerandligad_av_1_1_A : A ;
  ofoerallmaenligad_av_1_1_A : A ;
  ofoeraktad_av_1_1_A : A ;
  ofoenad_av_1_1_A : A ;
  ofaarad_av_1_1_A : A ;
  ofaangad_av_1_1_A : A ;
  ofaallad_av_1_1_A : A ;
  ofaerskad_av_1_1_A : A ;
  ofaerserad_av_1_1_A : A ;
  ofaerjad_av_1_1_A : A ;
  ofaergad_av_1_1_A : A ;
  ofaengslad_av_1_1_A : A ;
  ofaegnad_av_1_1_A : A ;
  ofysiljerad_av_1_A : A ;
  ofyndad_av_1_A : A ;
  ofylkad_av_1_A : A ;
  ofusionerad_av_1_A : A ;
  ofurnerad_av_1_A : A ;
  ofullaendad_av_1_1_A : A ;
  ofullstaendigad_av_1_1_A : A ;
  ofullkomnad_av_1_A : A ;
  ofullbordad_av_1_A : A ;
  ofuktad_av_1_A : A ;
  ofraagad_av_1_1_A : A ;
  ofraemjad_av_1_1_A : A ;
  ofrustrerad_av_1_A : A ;
  ofruktad_av_1_A : A ;
  ofrotterad_av_1_A : A ;
  ofrontad_av_1_A : A ;
  ofronderad_av_1_A : A ;
  ofriterad_av_1_A : A ;
  ofriserad_av_1_A : A ;
  ofriad_av_1_A : A ;
  ofrestad_av_1_A : A ;
  ofrekventerad_av_1_A : A ;
  ofredad_av_1_A : A ;
  ofraserad_av_1_A : A ;
  ofrapperad_av_1_A : A ;
  ofransad_av_1_A : A ;
  ofrankerad_av_1_A : A ;
  oframvisad_av_1_A : A ;
  oframskymtad_av_1_A : A ;
  oframpressad_av_1_A : A ;
  oframmanad_av_1_A : A ;
  oframkastad_av_1_A : A ;
  oframkallad_av_1_A : A ;
  oframflyttad_av_1_A : A ;
  ofraktionerad_av_1_A : A ;
  ofraktad_av_1_A : A ;
  ofragmenterad_av_1_A : A ;
  ofotokopierad_av_1_A : A ;
  ofotograferad_av_1_A : A ;
  ofotad_av_1_A : A ;
  ofostrad_av_1_A : A ;
  ofossiliserad_av_1_A : A ;
  ofosfaterad_av_1_A : A ;
  oforslad_av_1_A : A ;
  oformulerad_av_1_A : A ;
  oformerad_av_1_A : A ;
  oformaliserad_av_1_A : A ;
  oformad_av_1_A : A ;
  oforecheckad_av_1_A : A ;
  oforcerad_av_1_A : A ;
  ofonderad_av_1_A : A ;
  ofolierad_av_1_A : A ;
  ofokuserad_av_1_A : A ;
  ofogad_av_1_A : A ;
  ofodrad_av_1_A : A ;
  ofockad_av_1_A : A ;
  ofloejtad_av_1_1_A : A ;
  ofloejlad_av_1_1_A : A ;
  oflaetad_av_1_1_A : A ;
  oflaensad_av_1_1_A : A ;
  oflaeckad_av_1_1_A : A ;
  oflyttad_av_1_A : A ;
  oflyktad_av_1_A : A ;
  ofluoriderad_av_1_A : A ;
  ofluorerad_av_1_A : A ;
  ofluidiserad_av_1_A : A ;
  oflottad_av_1_A : A ;
  oflekterad_av_1_A : A ;
  oflatterad_av_1_A : A ;
  oflankerad_av_1_A : A ;
  oflamberad_av_1_A : A ;
  oflagnad_av_1_A : A ;
  oflaggad_av_1_A : A ;
  ofjaettrad_av_1_1_A : A ;
  ofjaermad_av_1_1_A : A ;
  ofjaellad_av_1_1_A : A ;
  ofixerad_av_1_A : A ;
  ofixad_av_1_A : A ;
  ofiskad_av_1_A : A ;
  ofirad_av_1_A : A ;
  ofintad_av_1_A : A ;
  ofinlandiserad_av_1_A : A ;
  ofinkad_av_1_A : A ;
  ofingerad_av_1_A : A ;
  ofinansierad_av_1_A : A ;
  ofimpad_av_1_A : A ;
  ofiltrerad_av_1_A : A ;
  ofiltad_av_1_A : A ;
  ofilmatiserad_av_1_A : A ;
  ofilmad_av_1_A : A ;
  ofilerad_av_1_A : A ;
  ofilead_av_1_A : A ;
  ofilad_av_1_A : A ;
  ofeterad_av_1_A : A ;
  ofernissad_av_1_A : A ;
  ofermenterad_av_1_A : A ;
  ofejkad_av_1_A : A ;
  ofejad_av_1_A : A ;
  ofaxad_av_1_A : A ;
  ofavoriserad_av_1_A : A ;
  ofasonerad_av_1_A : A ;
  ofasetterad_av_1_A : A ;
  ofascinerad_av_1_A : A ;
  ofasad_av_1_A : A ;
  ofantiserad_av_1_A : A ;
  ofamnad_av_1_A : A ;
  ofalsifierad_av_1_A : A ;
  ofalsad_av_1_A : A ;
  ofalnad_av_1_A : A ;
  ofakturerad_av_1_A : A ;
  ofacetterad_av_1_A : A ;
  ofabulerad_av_1_A : A ;
  ofabricerad_av_1_A : A ;
  oextrapolerad_av_1_A : A ;
  oextraherad_av_1_A : A ;
  oextemporerad_av_1_A : A ;
  oexstirperad_av_1_A : A ;
  oexproprierad_av_1_A : A ;
  oexporterad_av_1_A : A ;
  oexponerad_av_1_A : A ;
  oexploderad_av_1_A : A ;
  oexploaterad_av_1_A : A ;
  oexplicerad_av_1_A : A ;
  oexpektorerad_av_1_A : A ;
  oexpedierad_av_1_A : A ;
  oexpatrierad_av_1_A : A ;
  oexpanderad_av_1_A : A ;
  oexkommunicerad_av_1_A : A ;
  oexkluderad_av_1_A : A ;
  oexercerad_av_1_A : A ;
  oexemplifierad_av_1_A : A ;
  oexekverad_av_1_A : A ;
  oexciterad_av_1_A : A ;
  oexcerperad_av_1_A : A ;
  oexaminerad_av_1_A : A ;
  oevaporerad_av_1_A : A ;
  oevalverad_av_1_A : A ;
  oevaluerad_av_1_A : A ;
  oevakuerad_av_1_A : A ;
  oeuropeiserad_av_1_A : A ;
  oetymologiserad_av_1_A : A ;
  oetsad_av_1_A : A ;
  oetiketterad_av_1_A : A ;
  oeteriserad_av_1_A : A ;
  oetablerad_av_1_A : A ;
  oestimerad_av_1_A : A ;
  oestetiserad_av_1_A : A ;
  oesteticerad_av_1_A : A ;
  oeskorterad_av_1_A : A ;
  oeskalerad_av_1_A : A ;
  oeroevrad_av_1_1_A : A ;
  oertappad_av_1_A : A ;
  oeroderad_av_1_A : A ;
  oerigerad_av_1_A : A ;
  oerfordrad_av_1_A : A ;
  oepilerad_av_1_A : A ;
  oentusiasmerad_av_1_A : A ;
  oentledigad_av_1_A : A ;
  oensilerad_av_1_A : A ;
  oensad_av_1_A : A ;
  oenrollerad_av_1_A : A ;
  oenleverad_av_1_A : A ;
  oenklad_av_1_A : A ;
  oengagerad_av_1_A : A ;
  oenerverad_av_1_A : A ;
  oendosserad_av_1_A : A ;
  oenad_av_1_A : A ;
  oemulgerad_av_1_A : A ;
  oemitterad_av_1_A : A ;
  oemigrerad_av_1_A : A ;
  oemenderad_av_1_A : A ;
  oembellerad_av_1_A : A ;
  oembarkerad_av_1_A : A ;
  oemballerad_av_1_A : A ;
  oemanciperad_av_1_A : A ;
  oemaljerad_av_1_A : A ;
  oeluerad_av_1_A : A ;
  oeluderad_av_1_A : A ;
  oeloxerad_av_1_A : A ;
  oeliminerad_av_1_A : A ;
  oeliderad_av_1_A : A ;
  oelektriserad_av_1_A : A ;
  oelektrifierad_av_1_A : A ;
  oelektrificerad_av_1_A : A ;
  oeldad_av_1_A : A ;
  oelastiserad_av_1_A : A ;
  oelaborerad_av_1_A : A ;
  oekonomiserad_av_1_A : A ;
  oeklaererad_av_1_1_A : A ;
  oeklaterad_av_1_A : A ;
  oekiperad_av_1_A : A ;
  oekad_av_1_A : A ;
  oeggad_av_1_A : A ;
  oegaliserad_av_1_A : A ;
  oeftertraktad_av_1_A : A ;
  oeftertaxerad_av_1_A : A ;
  oeftersynkroniserad_av_1_A : A ;
  oefterstraevad_av_1_1_A : A ;
  oefterstavad_av_1_A : A ;
  oefterrationaliserad_av_1_A : A ;
  oeftermognad_av_1_A : A ;
  oefterlaemnad_av_1_1_A : A ;
  oefterliknad_av_1_A : A ;
  oefterhaermad_av_1_1_A : A ;
  oefterfraagad_av_1_1_A : A ;
  oefterforskad_av_1_A : A ;
  oefterdebiterad_av_1_A : A ;
  oefterdaterad_av_1_A : A ;
  oefterbildad_av_1_A : A ;
  oefterbehandlad_av_1_A : A ;
  oefterapad_av_1_A : A ;
  oeffektuerad_av_1_A : A ;
  oeffektiviserad_av_1_A : A ;
  oeffektiverad_av_1_A : A ;
  oeffacerad_av_1_A : A ;
  oederad_av_1_A : A ;
  odoevad_av_1_1_A : A ;
  odoerjad_av_1_1_A : A ;
  odoedad_av_1_1_A : A ;
  odaarad_av_1_1_A : A ;
  odaanad_av_1_1_A : A ;
  odaevnad_av_1_1_A : A ;
  odaempad_av_1_1_A : A ;
  odaeggad_av_1_1_A : A ;
  odaeckad_av_1_1_A : A ;
  odyrkad_av_1_A : A ;
  oduschad_av_1_A : A ;
  oduplicerad_av_1_A : A ;
  oduperad_av_1_A : A ;
  odunstad_av_1_A : A ;
  odunkad_av_1_A : A ;
  odumpad_av_1_A : A ;
  odukad_av_1_A : A ;
  odubblerad_av_1_A : A ;
  odubblad_av_1_A : A ;
  odubbad_av_1_A : A ;
  oduad_av_1_A : A ;
  odraenerad_av_1_1_A : A ;
  odryftad_av_1_A : A ;
  odrunknad_av_1_A : A ;
  odroppad_av_1_A : A ;
  odrogad_av_1_A : A ;
  odrillad_av_1_A : A ;
  odribblad_av_1_A : A ;
  odrevad_av_1_A : A ;
  odresserad_av_1_A : A ;
  odrejad_av_1_A : A ;
  odrattad_av_1_A : A ;
  odraperad_av_1_A : A ;
  odramatiserad_av_1_A : A ;
  odraggad_av_1_A : A ;
  odragerad_av_1_A : A ;
  odrabbad_av_1_A : A ;
  odoterad_av_1_A : A ;
  odosserad_av_1_A : A ;
  odoserad_av_1_A : A ;
  odoppad_av_1_A : A ;
  odopad_av_1_A : A ;
  odonkad_av_1_A : A ;
  odonerad_av_1_A : A ;
  odompterad_av_1_A : A ;
  odomnad_av_1_A : A ;
  odominerad_av_1_A : A ;
  odomicilierad_av_1_A : A ;
  odomesticerad_av_1_A : A ;
  odokumenterad_av_1_A : A ;
  odoktorerad_av_1_A : A ;
  odogmatiserad_av_1_A : A ;
  odockad_av_1_A : A ;
  odocerad_av_1_A : A ;
  odividerad_av_1_A : A ;
  odiversifierad_av_1_A : A ;
  odivergerad_av_1_A : A ;
  odistribuerad_av_1_A : A ;
  odistraherad_av_1_A : A ;
  odistanserad_av_1_A : A ;
  odissocierad_av_1_A : A ;
  odissimilerad_av_1_A : A ;
  odissekerad_av_1_A : A ;
  odissad_av_1_A : A ;
  odisputerad_av_1_A : A ;
  odisponerad_av_1_A : A ;
  odispergerad_av_1_A : A ;
  odispenserad_av_1_A : A ;
  odispascherad_av_1_A : A ;
  odiskvalificerad_av_1_A : A ;
  odiskuterad_av_1_A : A ;
  odiskriminerad_av_1_A : A ;
  odiskrediterad_av_1_A : A ;
  odiskonterad_av_1_A : A ;
  odiskad_av_1_A : A ;
  odisharmonierad_av_1_A : A ;
  odisciplinerad_av_1_A : A ;
  odisambiguerad_av_1_A : A ;
  odirigerad_av_1_A : A ;
  odippad_av_1_A : A ;
  odiplomerad_av_1_A : A ;
  odimensionerad_av_1_A : A ;
  odikterad_av_1_A : A ;
  odiktad_av_1_A : A ;
  odikad_av_1_A : A ;
  odiggad_av_1_A : A ;
  odigererad_av_1_A : A ;
  odiftongerad_av_1_A : A ;
  odiffunderad_av_1_A : A ;
  odifferentierad_av_1_A : A ;
  odibblad_av_1_A : A ;
  odialyserad_av_1_A : A ;
  odiagnostiserad_av_1_A : A ;
  odiagnosticerad_av_1_A : A ;
  odiad_av_1_A : A ;
  odevalverad_av_1_A : A ;
  odetroniserad_av_1_A : A ;
  odetonerad_av_1_A : A ;
  odeterminerad_av_1_A : A ;
  odetekterad_av_1_A : A ;
  odetaljerad_av_1_A : A ;
  odetacherad_av_1_A : A ;
  odestruerad_av_1_A : A ;
  odestinerad_av_1_A : A ;
  odestillerad_av_1_A : A ;
  odestabiliserad_av_1_A : A ;
  odesorganiserad_av_1_A : A ;
  odesinformerad_av_1_A : A ;
  odesinficerad_av_1_A : A ;
  odesinfekterad_av_1_A : A ;
  odesignerad_av_1_A : A ;
  odesignad_av_1_A : A ;
  odesensibiliserad_av_1_A : A ;
  odesavouerad_av_1_A : A ;
  odesarmerad_av_1_A : A ;
  oderiverad_av_1_A : A ;
  oderangerad_av_1_A : A ;
  odeprecierad_av_1_A : A ;
  odeporterad_av_1_A : A ;
  odeponerad_av_1_A : A ;
  odeplacerad_av_1_A : A ;
  odepenserad_av_1_A : A ;
  odepatrierad_av_1_A : A ;
  odeodoriserad_av_1_A : A ;
  odenuderad_av_1_A : A ;
  odenoterad_av_1_A : A ;
  odenaturerad_av_1_A : A ;
  odenaturaliserad_av_1_A : A ;
  odemoraliserad_av_1_A : A ;
  odemonterad_av_1_A : A ;
  odemonstrerad_av_1_A : A ;
  odemolerad_av_1_A : A ;
  odemokratiserad_av_1_A : A ;
  odemobiliserad_av_1_A : A ;
  odemissionerad_av_1_A : A ;
  odemilitariserad_av_1_A : A ;
  odementerad_av_1_A : A ;
  odemaskerad_av_1_A : A ;
  odemad_av_1_A : A ;
  odelegerad_av_1_A : A ;
  odelad_av_1_A : A ;
  odekreterad_av_1_A : A ;
  odekouragerad_av_1_A : A ;
  odekorerad_av_1_A : A ;
  odeklinerad_av_1_A : A ;
  odeklasserad_av_1_A : A ;
  odeklarerad_av_1_A : A ;
  odeklamerad_av_1_A : A ;
  odekapiterad_av_1_A : A ;
  odekanterad_av_1_A : A ;
  odejtad_av_1_A : A ;
  odegraderad_av_1_A : A ;
  odegenererad_av_1_A : A ;
  odeformerad_av_1_A : A ;
  odeflorerad_av_1_A : A ;
  odefinierad_av_1_A : A ;
  odefilerad_av_1_A : A ;
  odeducerad_av_1_A : A ;
  odedikerad_av_1_A : A ;
  odedicerad_av_1_A : A ;
  odecimerad_av_1_A : A ;
  odeciderad_av_1_A : A ;
  odechiffrerad_av_1_A : A ;
  odecentraliserad_av_1_A : A ;
  odebiterad_av_1_A : A ;
  odebatterad_av_1_A : A ;
  odebarkerad_av_1_A : A ;
  odatoriserad_av_1_A : A ;
  odaterad_av_1_A : A ;
  odaskad_av_1_A : A ;
  odanad_av_1_A : A ;
  odampad_av_1_A : A ;
  odammad_av_1_A : A ;
  odaddad_av_1_A : A ;
  ocyklad_av_1_A : A ;
  ocurerad_av_1_A : A ;
  ocuraterad_av_1_A : A ;
  oclearad_av_1_A : A ;
  ociviliserad_av_1_A : A ;
  ociterad_av_1_A : A ;
  ociselerad_av_1_A : A ;
  ocirkulerad_av_1_A : A ;
  ochokad_av_1_A : A ;
  ochockerad_av_1_A : A ;
  ochockad_av_1_A : A ;
  ochikanerad_av_1_A : A ;
  ochiffrerad_av_1_A : A ;
  ochevroterad_av_1_A : A ;
  ocheckad_av_1_A : A ;
  ochartrad_av_1_A : A ;
  ocharmerad_av_1_A : A ;
  ocharmad_av_1_A : A ;
  ochargerad_av_1_A : A ;
  ocernerad_av_1_A : A ;
  ocentrifugerad_av_1_A : A ;
  ocentrerad_av_1_A : A ;
  ocentraliserad_av_1_A : A ;
  ocentrad_av_1_A : A ;
  ocensurerad_av_1_A : A ;
  ocementerad_av_1_A : A ;
  ocementad_av_1_A : A ;
  ocelebrerad_av_1_A : A ;
  ocederad_av_1_A : A ;
  ocaterad_av_1_A : A ;
  ocamouflerad_av_1_A : A ;
  oboetad_av_1_1_A : A ;
  oboerjad_av_1_1_A : A ;
  obaagnad_av_1_1_A : A ;
  obaettrad_av_1_1_A : A ;
  obaergad_av_1_1_A : A ;
  obaenslad_av_1_1_A : A ;
  obaendslad_av_1_1_A : A ;
  obaelgad_av_1_1_A : A ;
  obaeddad_av_1_1_A : A ;
  obyraakratiserad_av_1_1_A : A ;
  obuteljerad_av_1_A : A ;
  obussad_av_1_A : A ;
  obuskad_av_1_A : A ;
  oburkad_av_1_A : A ;
  obuntad_av_1_A : A ;
  obunkrad_av_1_A : A ;
  obultad_av_1_A : A ;
  obuffrad_av_1_A : A ;
  obuffad_av_1_A : A ;
  obudgeterad_av_1_A : A ;
  obudad_av_1_A : A ;
  obubbad_av_1_A : A ;
  obroedad_av_1_1_A : A ;
  obroead_av_1_1_A : A ;
  obraakad_av_1_1_A : A ;
  obraeserad_av_1_1_A : A ;
  obraemad_av_1_1_A : A ;
  obraeddad_av_1_1_A : A ;
  obraedad_av_1_1_A : A ;
  obrutaliserad_av_1_A : A ;
  obrunfaergad_av_1_1_A : A ;
  obrunerad_av_1_A : A ;
  obrukad_av_1_A : A ;
  obrucklad_av_1_A : A ;
  obrotschad_av_1_A : A ;
  obrosslad_av_1_A : A ;
  obroscherad_av_1_A : A ;
  obronserad_av_1_A : A ;
  obromsad_av_1_A : A ;
  obromerad_av_1_A : A ;
  obroderad_av_1_A : A ;
  obroddad_av_1_A : A ;
  obroad_av_1_A : A ;
  obriserad_av_1_A : A ;
  obriketterad_av_1_A : A ;
  obriefad_av_1_A : A ;
  obreddad_av_1_A : A ;
  obrassad_av_1_A : A ;
  oboxad_av_1_A : A ;
  obotad_av_1_A : A ;
  oborstad_av_1_A : A ;
  oborrad_av_1_A : A ;
  oborgad_av_1_A : A ;
  obordad_av_1_A : A ;
  obootad_av_1_A : A ;
  oboniterad_av_1_A : A ;
  obongad_av_1_A : A ;
  obonad_av_1_A : A ;
  obommad_av_1_A : A ;
  obombarderad_av_1_A : A ;
  obombad_av_1_A : A ;
  obollad_av_1_A : A ;
  obokstaverad_av_1_A : A ;
  obokad_av_1_A : A ;
  obojkottad_av_1_A : A ;
  obogserad_av_1_A : A ;
  obockad_av_1_A : A ;
  obobbad_av_1_A : A ;
  oboaserad_av_1_A : A ;
  oblaestrad_av_1_1_A : A ;
  oblaestad_av_1_1_A : A ;
  oblaendad_av_1_1_A : A ;
  oblaeddrad_av_1_1_A : A ;
  oblaedad_av_1_1_A : A ;
  oblaeckad_av_1_1_A : A ;
  oblyad_av_1_A : A ;
  obluffad_av_1_A : A ;
  oblottad_av_1_A : A ;
  oblonderad_av_1_A : A ;
  oblommograferad_av_1_A : A ;
  obloggad_av_1_A : A ;
  oblodad_av_1_A : A ;
  oblockerad_av_1_A : A ;
  oblockad_av_1_A : A ;
  oblinderad_av_1_A : A ;
  oblidkad_av_1_A : A ;
  oblesserad_av_1_A : A ;
  obleknad_av_1_A : A ;
  oblankad_av_1_A : A ;
  oblandad_av_1_A : A ;
  oblancherad_av_1_A : A ;
  obladad_av_1_A : A ;
  objoernad_av_1_1_A : A ;
  objussad_av_1_A : A ;
  obivackerad_av_1_A : A ;
  obitad_av_1_A : A ;
  obisserad_av_1_A : A ;
  obiograferad_av_1_A : A ;
  obildad_av_1_A : A ;
  obilad_av_1_A : A ;
  obiktad_av_1_A : A ;
  obifogad_av_1_A : A ;
  obidad_av_1_A : A ;
  obevaerdigad_av_1_1_A : A ;
  obevaerad_av_1_1_A : A ;
  obevaepnad_av_1_1_A : A ;
  obevittnad_av_1_A : A ;
  obevistad_av_1_A : A ;
  obevisad_av_1_A : A ;
  obeviljad_av_1_A : A ;
  obevattnad_av_1_A : A ;
  obevarad_av_1_A : A ;
  obevandrad_av_1_A : A ;
  obevakad_av_1_A : A ;
  obeundrad_av_1_A : A ;
  obetygad_av_1_A : A ;
  obetvivlad_av_1_A : A ;
  obetungad_av_1_A : A ;
  obetslad_av_1_A : A ;
  obetsad_av_1_A : A ;
  obetraeffad_av_1_1_A : A ;
  obetryggad_av_1_A : A ;
  obetraktad_av_1_A : A ;
  obetongerad_av_1_A : A ;
  obetonad_av_1_A : A ;
  obetjaenad_av_1_1_A : A ;
  obetittad_av_1_A : A ;
  obetitlad_av_1_A : A ;
  obetingad_av_1_A : A ;
  obetecknad_av_1_A : A ;
  obetad_av_1_A : A ;
  obesvaerad_av_1_1_A : A ;
  obesvarad_av_1_A : A ;
  obesudlad_av_1_A : A ;
  obestyckad_av_1_A : A ;
  obestraalad_av_1_1_A : A ;
  obestraffad_av_1_A : A ;
  obestormad_av_1_A : A ;
  obesprutad_av_1_A : A ;
  obespottad_av_1_A : A ;
  obespolad_av_1_A : A ;
  obespisad_av_1_A : A ;
  obespejad_av_1_A : A ;
  obesoldad_av_1_A : A ;
  obesockrad_av_1_A : A ;
  obesmittad_av_1_A : A ;
  obesloejad_av_1_1_A : A ;
  obeslaektad_av_1_1_A : A ;
  obeskaadad_av_1_1_A : A ;
  obeskaermad_av_1_1_A : A ;
  obeskyddad_av_1_A : A ;
  obeskuggad_av_1_A : A ;
  obeskickad_av_1_A : A ;
  obeskattad_av_1_A : A ;
  obesjaelad_av_1_1_A : A ;
  obesinnad_av_1_A : A ;
  obesiktigad_av_1_A : A ;
  obesegrad_av_1_A : A ;
  obeseglad_av_1_A : A ;
  obesannad_av_1_A : A ;
  oberoevad_av_1_1_A : A ;
  oberaettigad_av_1_1_A : A ;
  oberaettad_av_1_1_A : A ;
  oberaeknad_av_1_1_A : A ;
  oberusad_av_1_A : A ;
  oberiktigad_av_1_A : A ;
  oberikad_av_1_A : A ;
  obepudrad_av_1_A : A ;
  obeproevad_av_1_1_A : A ;
  obeprisad_av_1_A : A ;
  obepansrad_av_1_A : A ;
  obeordrad_av_1_A : A ;
  obenaadad_av_1_1_A : A ;
  obenad_av_1_A : A ;
  obemaestrad_av_1_1_A : A ;
  obemyndigad_av_1_A : A ;
  obemedlad_av_1_A : A ;
  obemantlad_av_1_A : A ;
  obemannad_av_1_A : A ;
  obeloenad_av_1_1_A : A ;
  obelaanad_av_1_1_A : A ;
  obelaegrad_av_1_1_A : A ;
  obeledsagad_av_1_A : A ;
  obelastad_av_1_A : A ;
  obelamrad_av_1_A : A ;
  obekaempad_av_1_1_A : A ;
  obekymrad_av_1_A : A ;
  obekraeftad_av_1_1_A : A ;
  obekrigad_av_1_A : A ;
  obekransad_av_1_A : A ;
  obekostad_av_1_A : A ;
  obeklagad_av_1_A : A ;
  obekikad_av_1_A : A ;
  obekajad_av_1_A : A ;
  obejublad_av_1_A : A ;
  obejakad_av_1_A : A ;
  obeivrad_av_1_A : A ;
  obehaerskad_av_1_1_A : A ;
  obehindrad_av_1_A : A ;
  obehandlad_av_1_A : A ;
  obegaavad_av_1_1_A : A ;
  obegraensad_av_1_1_A : A ;
  obegrundad_av_1_A : A ;
  obegapad_av_1_A : A ;
  obegagnad_av_1_A : A ;
  obegabbad_av_1_A : A ;
  obefullmaektigad_av_1_1_A : A ;
  obefraemjad_av_1_1_A : A ;
  obefryndad_av_1_A : A ;
  obefruktad_av_1_A : A ;
  obefriad_av_1_A : A ;
  obefraktad_av_1_A : A ;
  obefordrad_av_1_A : A ;
  obefolkad_av_1_A : A ;
  obefogad_av_1_A : A ;
  obeflaeckad_av_1_1_A : A ;
  obefarad_av_1_A : A ;
  obeedigad_av_1_A : A ;
  obedoevad_av_1_1_A : A ;
  obedaarad_av_1_1_A : A ;
  obedyrad_av_1_A : A ;
  obedroevad_av_1_1_A : A ;
  obedarrad_av_1_A : A ;
  obeckad_av_1_A : A ;
  obebaadad_av_1_1_A : A ;
  obearbetad_av_1_A : A ;
  obeaktad_av_1_A : A ;
  obaxad_av_1_A : A ;
  obastad_av_1_A : A ;
  obaserad_av_1_A : A ;
  obarrikaderad_av_1_A : A ;
  obarrad_av_1_A : A ;
  obarlastad_av_1_A : A ;
  obarkad_av_1_A : A ;
  obantad_av_1_A : A ;
  obannad_av_1_A : A ;
  obankrutterad_av_1_A : A ;
  obankad_av_1_A : A ;
  obandad_av_1_A : A ;
  obanaliserad_av_1_A : A ;
  obanad_av_1_A : A ;
  obalsamerad_av_1_A : A ;
  oballoterad_av_1_A : A ;
  obalanserad_av_1_A : A ;
  obalad_av_1_A : A ;
  obaktalad_av_1_A : A ;
  obakdantad_av_1_A : A ;
  obakad_av_1_A : A ;
  obajsad_av_1_A : A ;
  obaissad_av_1_A : A ;
  obagatelliserad_av_1_A : A ;
  obaddad_av_1_A : A ;
  obadad_av_1_A : A ;
  obackuppad_av_1_A : A ;
  obackupad_av_1_A : A ;
  obackad_av_1_A : A ;
  oaxlad_av_1_A : A ;
  oaxiomatiserad_av_1_A : A ;
  oavyttrad_av_1_A : A ;
  oavvaepnad_av_1_1_A : A ;
  oavvittrad_av_1_A : A ;
  oavvitad_av_1_A : A ;
  oavvisad_av_1_A : A ;
  oavverkad_av_1_A : A ;
  oavvecklad_av_1_A : A ;
  oavvattnad_av_1_A : A ;
  oavvaktad_av_1_A : A ;
  oavtaagad_av_1_1_A : A ;
  oavtunnad_av_1_A : A ;
  oavtrubbad_av_1_A : A ;
  oavtrappad_av_1_A : A ;
  oavtonad_av_1_A : A ;
  oavtjaenad_av_1_1_A : A ;
  oavtecknad_av_1_A : A ;
  oavtappad_av_1_A : A ;
  oavtalad_av_1_A : A ;
  oavtackad_av_1_A : A ;
  oavsoendrad_av_1_1_A : A ;
  oavsynad_av_1_A : A ;
  oavsvavlad_av_1_A : A ;
  oavsvalnad_av_1_A : A ;
  oavstyckad_av_1_A : A ;
  oavstressad_av_1_A : A ;
  oavstavad_av_1_A : A ;
  oavstannad_av_1_A : A ;
  oavstaliniserad_av_1_A : A ;
  oavspaerrad_av_1_1_A : A ;
  oavspisad_av_1_A : A ;
  oavspelad_av_1_A : A ;
  oavspeglad_av_1_A : A ;
  oavsomnad_av_1_A : A ;
  oavsocialiserad_av_1_A : A ;
  oavsmalnad_av_1_A : A ;
  oavsmakad_av_1_A : A ;
  oavsloejad_av_1_1_A : A ;
  oavslutad_av_1_A : A ;
  oavslipad_av_1_A : A ;
  oavskaermad_av_1_1_A : A ;
  oavskedad_av_1_A : A ;
  oavskaffad_av_1_A : A ;
  oavseglad_av_1_A : A ;
  oavsaltad_av_1_A : A ;
  oavraettad_av_1_1_A : A ;
  oavraeknad_av_1_1_A : A ;
  oavrustad_av_1_A : A ;
  oavrundad_av_1_A : A ;
  oavromantiserad_av_1_A : A ;
  oavreglerad_av_1_A : A ;
  oavregistrerad_av_1_A : A ;
  oavreagerad_av_1_A : A ;
  oavpressad_av_1_A : A ;
  oavportraetterad_av_1_1_A : A ;
  oavpolletterad_av_1_A : A ;
  oavpolitiserad_av_1_A : A ;
  oavplanad_av_1_A : A ;
  oavpatrullerad_av_1_A : A ;
  oavpassad_av_1_A : A ;
  oavnazifierad_av_1_A : A ;
  oavnavlad_av_1_A : A ;
  oavmattad_av_1_A : A ;
  oavmastad_av_1_A : A ;
  oavmaskad_av_1_A : A ;
  oavmagnetiserad_av_1_A : A ;
  oavloevad_av_1_1_A : A ;
  oavloenad_av_1_1_A : A ;
  oavlaenkad_av_1_1_A : A ;
  oavlaemnad_av_1_1_A : A ;
  oavlaegsnad_av_1_1_A : A ;
  oavlyssnad_av_1_A : A ;
  oavlusad_av_1_A : A ;
  oavlossad_av_1_A : A ;
  oavlockad_av_1_A : A ;
  oavlivad_av_1_A : A ;
  oavlastad_av_1_A : A ;
  oavlagrad_av_1_A : A ;
  oavlad_av_1_A : A ;
  oavkoenad_av_1_1_A : A ;
  oavkunnad_av_1_A : A ;
  oavkristnad_av_1_A : A ;
  oavkriminaliserad_av_1_A : A ;
  oavkortad_av_1_A : A ;
  oavkopplad_av_1_A : A ;
  oavkoloniserad_av_1_A : A ;
  oavknoppad_av_1_A : A ;
  oavklingad_av_1_A : A ;
  oavklarad_av_1_A : A ;
  oavkalkad_av_1_A : A ;
  oavjaemnad_av_1_1_A : A ;
  oavjagad_av_1_A : A ;
  oaviserad_av_1_A : A ;
  oavisad_av_1_A : A ;
  oavhoestad_av_1_1_A : A ;
  oavhaerdad_av_1_1_A : A ;
  oavhaemtad_av_1_1_A : A ;
  oavhandlad_av_1_A : A ;
  oavgaerdad_av_1_1_A : A ;
  oavgudad_av_1_A : A ;
  oavgraensad_av_1_1_A : A ;
  oavgiftad_av_1_A : A ;
  oavfaerdad_av_1_1_A : A ;
  oavfyrad_av_1_A : A ;
  oavfuktad_av_1_A : A ;
  oavfordrad_av_1_A : A ;
  oavfolkad_av_1_A : A ;
  oavflyttad_av_1_A : A ;
  oavfettad_av_1_A : A ;
  oavfattad_av_1_A : A ;
  oavdunstad_av_1_A : A ;
  oavdramatiserad_av_1_A : A ;
  oavdelad_av_1_A : A ;
  oavboerdad_av_1_1_A : A ;
  oavbildad_av_1_A : A ;
  oavbetalad_av_1_A : A ;
  oavbetad_av_1_A : A ;
  oavbalkad_av_1_A : A ;
  oavannonserad_av_1_A : A ;
  oavancerad_av_1_A : A ;
  oavad_av_1_A : A ;
  oautomatiserad_av_1_A : A ;
  oautentiserad_av_1_A : A ;
  oautentifierad_av_1_A : A ;
  oautenticerad_av_1_A : A ;
  oauskulterad_av_1_A : A ;
  oauktoriserad_av_1_A : A ;
  oauktionerad_av_1_A : A ;
  oattribuerad_av_1_A : A ;
  oattrapperad_av_1_A : A ;
  oattraherad_av_1_A : A ;
  oattesterad_av_1_A : A ;
  oattackerad_av_1_A : A ;
  oatrofierad_av_1_A : A ;
  oassurerad_av_1_A : A ;
  oassocierad_av_1_A : A ;
  oassisterad_av_1_A : A ;
  oassimilerad_av_1_A : A ;
  oassignerad_av_1_A : A ;
  oaspirerad_av_1_A : A ;
  oaskad_av_1_A : A ;
  oasfalterad_av_1_A : A ;
  oarvoderad_av_1_A : A ;
  oartikulerad_av_1_A : A ;
  oarronderad_av_1_A : A ;
  oarresterad_av_1_A : A ;
  oarrenderad_av_1_A : A ;
  oarrangerad_av_1_A : A ;
  oarmerad_av_1_A : A ;
  oarkiverad_av_1_A : A ;
  oarkebuserad_av_1_A : A ;
  oarkaiserad_av_1_A : A ;
  oargumenterad_av_1_A : A ;
  oarbetad_av_1_A : A ;
  oapterad_av_1_A : A ;
  oapproximerad_av_1_A : A ;
  oapprocherad_av_1_A : A ;
  oappreterad_av_1_A : A ;
  oapprecierad_av_1_A : A ;
  oapporterad_av_1_A : A ;
  oapplaaderad_av_1_1_A : A ;
  oapplicerad_av_1_A : A ;
  oappellerad_av_1_A : A ;
  oapostroferad_av_1_A : A ;
  oanvisad_av_1_A : A ;
  oantaagad_av_1_1_A : A ;
  oantvardad_av_1_A : A ;
  oantraeffad_av_1_1_A : A ;
  oantikiserad_av_1_A : A ;
  oantichambrerad_av_1_A : A ;
  oantedaterad_av_1_A : A ;
  oantecknad_av_1_A : A ;
  oanteciperad_av_1_A : A ;
  oantastad_av_1_A : A ;
  oanstormad_av_1_A : A ;
  oanstiftad_av_1_A : A ;
  oanspelad_av_1_A : A ;
  oanskaffad_av_1_A : A ;
  oansamlad_av_1_A : A ;
  oansad_av_1_A : A ;
  oanraettad_av_1_1_A : A ;
  oanropad_av_1_A : A ;
  oanrikad_av_1_A : A ;
  oanpassad_av_1_A : A ;
  oanordnad_av_1_A : A ;
  oanonymiserad_av_1_A : A ;
  oanodiserad_av_1_A : A ;
  oannullerad_av_1_A : A ;
  oannoterad_av_1_A : A ;
  oannonserad_av_1_A : A ;
  oannihilerad_av_1_A : A ;
  oannekterad_av_1_A : A ;
  oanmodad_av_1_A : A ;
  oanmanad_av_1_A : A ;
  oanlitad_av_1_A : A ;
  oankrad_av_1_A : A ;
  oanklagad_av_1_A : A ;
  oanimerad_av_1_A : A ;
  oanhopad_av_1_A : A ;
  oangliserad_av_1_A : A ;
  oanglad_av_1_A : A ;
  oanfaektad_av_1_1_A : A ;
  oanammad_av_1_A : A ;
  oanalyserad_av_1_A : A ;
  oanad_av_1_A : A ;
  oamputerad_av_1_A : A ;
  oamplifierad_av_1_A : A ;
  oamorterad_av_1_A : A ;
  oammad_av_1_A : A ;
  oamerikaniserad_av_1_A : A ;
  oambulerad_av_1_A : A ;
  oamalgamerad_av_1_A : A ;
  oaluminerad_av_1_A : A ;
  oalternerad_av_1_A : A ;
  oalstrad_av_1_A : A ;
  oalluderad_av_1_A : A ;
  oallokerad_av_1_A : A ;
  oallmaenbildad_av_1_1_A : A ;
  oallittererad_av_1_A : A ;
  oallierad_av_1_A : A ;
  oallegoriserad_av_1_A : A ;
  oalienerad_av_1_A : A ;
  oalfabetiserad_av_1_A : A ;
  oalarmerad_av_1_A : A ;
  oaktualiserad_av_1_A : A ;
  oaktiverad_av_1_A : A ;
  oaktad_av_1_A : A ;
  oajournerad_av_1_A : A ;
  oagnad_av_1_A : A ;
  oagiterad_av_1_A : A ;
  oagglutinerad_av_1_A : A ;
  oagglomererad_av_1_A : A ;
  oagerad_av_1_A : A ;
  oagad_av_1_A : A ;
  oafrikaniserad_av_1_A : A ;
  oaffischerad_av_1_A : A ;
  oaffinerad_av_1_A : A ;
  oafficierad_av_1_A : A ;
  oadvocerad_av_1_A : A ;
  oaducerad_av_1_A : A ;
  oadsorberad_av_1_A : A ;
  oadresserad_av_1_A : A ;
  oadopterad_av_1_A : A ;
  oadministrerad_av_1_A : A ;
  oadlad_av_1_A : A ;
  oadjungerad_av_1_A : A ;
  oadderad_av_1_A : A ;
  oadapterad_av_1_A : A ;
  oackvirerad_av_1_A : A ;
  oackumulerad_av_1_A : A ;
  oackrediterad_av_1_A : A ;
  oackorderad_av_1_A : A ;
  oackompanjerad_av_1_A : A ;
  oackommoderad_av_1_A : A ;
  oacklimatiserad_av_1_A : A ;
  oaccepterad_av_1_A : A ;
  oaccentuerad_av_1_A : A ;
  oaccelererad_av_1_A : A ;
  oaccederad_av_1_A : A ;
  oabstraherad_av_1_A : A ;
  oabsorberad_av_1_A : A ;
  oabsolverad_av_1_A : A ;
  oabraderad_av_1_A : A ;
  oaborterad_av_1_A : A ;
  oabonnerad_av_1_A : A ;
  oabdikerad_av_1_A : A ;
  oabbrevierad_av_1_A : A ;
  noedsakad_av_1_1_A : A ;
  naerbeslaektad_av_1_1_A : A ;
  nyoeppnad_av_1_1_A : A ;
  nyvaessad_av_1_1_A : A ;
  nyutexaminerad_av_1_A : A ;
  nytvaettad_av_1_1_A : A ;
  nytumlad_av_1_A : A ;
  nyttobetonad_av_1_A : A ;
  nystaedad_av_1_1_A : A ;
  nystartad_av_1_A : A ;
  nyslipad_av_1_A : A ;
  nyrenoverad_av_1_A : A ;
  nypressad_av_1_A : A ;
  nypolerad_av_1_A : A ;
  nymornad_av_1_A : A ;
  nymorgnad_av_1_A : A ;
  nymobiliserad_av_1_A : A ;
  nyloevad_av_1_1_A : A ;
  nylagad_av_1_A : A ;
  nyinskaffad_av_1_A : A ;
  nyinraettad_av_1_1_A : A ;
  nyinflyttad_av_1_A : A ;
  nygraeddad_av_1_1_A : A ;
  nygrundad_av_1_A : A ;
  nyfoervaervad_av_1_1_A : A ;
  nyfriserad_av_1_A : A ;
  nyexaminerad_av_1_A : A ;
  nyduschad_av_1_A : A ;
  nybildad_av_1_A : A ;
  nybakad_av_1_A : A ;
  nyanserad_av_1_A : A ;
  nyagnad_av_1_A : A ;
  nutidsorienterad_av_1_A : A ;
  nutidsfixerad_av_1_A : A ;
  norsktillverkad_av_1_A : A ;
  normalbegaavad_av_1_1_A : A ;
  nograeknad_av_1_1_A : A ;
  nischad_av_1_A : A ;
  nervevad_av_1_A : A ;
  nertrampad_av_1_A : A ;
  nersoelad_av_1_1_A : A ;
  nerputtad_av_1_A : A ;
  nerplitad_av_1_A : A ;
  nerpetad_av_1_A : A ;
  nerlaeggningshotad_av_1_1_A : A ;
  nerlusad_av_1_A : A ;
  nerlegad_av_1_A : A ;
  nerknarkad_av_1_A : A ;
  nerkippad_av_1_A : A ;
  nerkilad_av_1_A : A ;
  nerhukad_av_1_A : A ;
  nergrisad_av_1_A : A ;
  nerdekad_av_1_A : A ;
  nerbusad_av_1_A : A ;
  nerborrad_av_1_A : A ;
  nerblodad_av_1_A : A ;
  nerbantad_av_1_A : A ;
  nedtvingad_av_1_A : A ;
  nedtrampad_av_1_A : A ;
  nedsoelad_av_1_1_A : A ;
  nedsolkad_av_1_A : A ;
  nedlaeggningshotad_av_1_1_A : A ;
  nedlusad_av_1_A : A ;
  nedlegad_av_1_A : A ;
  nedknarkad_av_1_A : A ;
  nedkletad_av_1_A : A ;
  nedkippad_av_1_A : A ;
  nedhukad_av_1_A : A ;
  nedgrisad_av_1_A : A ;
  neddekad_av_1_A : A ;
  nedbaeddad_av_1_1_A : A ;
  nedbusad_av_1_A : A ;
  nedborrad_av_1_A : A ;
  nedblodad_av_1_A : A ;
  nedbantad_av_1_A : A ;
  naturskyddad_av_1_A : A ;
  naturfaergad_av_1_1_A : A ;
  naturbehandlad_av_1_A : A ;
  naturbegaavad_av_1_1_A : A ;
  narkotikapaaverkad_av_1_1_A : A ;
  narkotikaklassad_av_1_A : A ;
  namnskyddad_av_1_A : A ;
  nakenkindad_av_1_A : A ;
  naggsaagad_av_1_1_A : A ;
  nabbad_av_1_A : A ;
  moerkrostad_av_1_1_A : A ;
  moerkhyad_av_1_1_A : A ;
  moensterstickad_av_1_1_A : A ;
  maanghoevdad_av_1_1_A : A ;
  maanggestaltad_av_1_1_A : A ;
  maangfaergad_av_1_1_A : A ;
  maangfasetterad_av_1_1_A : A ;
  maangfacetterad_av_1_1_A : A ;
  maangbeproevad_av_1_1_A : A ;
  maangarmad_av_1_1_A : A ;
  maalrelaterad_av_1_1_A : A ;
  maalinriktad_av_1_1_A : A ;
  maettad_av_1_1_A : A ;
  maenniskogestaltad_av_1_1_A : A ;
  maenniskocentrerad_av_1_1_A : A ;
  mutanklagad_av_1_A : A ;
  muromgaerdad_av_1_1_A : A ;
  murkelkindad_av_1_A : A ;
  multihandikappad_av_1_A : A ;
  motriktad_av_1_A : A ;
  motiverad_av_1_A : A ;
  mosaikinramad_av_1_A : A ;
  mosaikartad_av_1_A : A ;
  mockasinformad_av_1_A : A ;
  mjukryggad_av_1_A : A ;
  mittenorienterad_av_1_A : A ;
  missriktad_av_1_A : A ;
  misslyckad_av_1_A : A ;
  missbildad_av_1_A : A ;
  missanpassad_av_1_A : A ;
  mirakelraeddad_av_1_1_A : A ;
  miljoeskadad_av_1_1_A : A ;
  miljoeanpassad_av_1_1_A : A ;
  meteorartad_av_1_A : A ;
  meriterad_av_1_A : A ;
  melerad_av_1_A : A ;
  medaatalad_av_1_1_A : A ;
  medborgarinitierad_av_1_A : A ;
  mattslipad_av_1_A : A ;
  matfoergiftad_av_1_1_A : A ;
  mastad_av_1_A : A ;
  markerad_av_1_A : A ;
  marginaliserad_av_1_A : A ;
  mansdominerad_av_1_A : A ;
  maniererad_av_1_A : A ;
  mandelformad_av_1_A : A ;
  malvafaergad_av_1_1_A : A ;
  malplacerad_av_1_A : A ;
  majsoelsberusad_av_1_1_A : A ;
  mahognyfanerad_av_1_A : A ;
  magentafaergad_av_1_1_A : A ;
  loesningsmedelsbaserad_av_1_1_A : A ;
  laangoerad_av_1_1_A : A ;
  laangaermad_av_1_1_A : A ;
  laangtandad_av_1_1_A : A ;
  laangsvansad_av_1_1_A : A ;
  laangskaftad_av_1_1_A : A ;
  laanglivad_av_1_1_A : A ;
  laangfingrad_av_1_1_A : A ;
  laagutbildad_av_1_1_A : A ;
  laagsinnad_av_1_1_A : A ;
  laagklackad_av_1_1_A : A ;
  laagkastad_av_1_1_A : A ;
  laagavloenad_av_1_1_A : A ;
  laaganrikad_av_1_1_A : A ;
  laettuttalad_av_1_1_A : A ;
  laettsmickrad_av_1_1_A : A ;
  laettsaltad_av_1_1_A : A ;
  laettrullad_av_1_1_A : A ;
  laettroad_av_1_1_A : A ;
  laettrimmad_av_1_1_A : A ;
  laettretad_av_1_1_A : A ;
  laettpratad_av_1_1_A : A ;
  laettodlad_av_1_1_A : A ;
  laettnarrad_av_1_1_A : A ;
  laettmanoevrerad_av_1_1_A : A ;
  laettlurad_av_1_1_A : A ;
  laettfoersvarad_av_1_1_A : A ;
  laettfaangad_av_1_1_A : A ;
  laettfotad_av_1_1_A : A ;
  laettfixad_av_1_1_A : A ;
  laettbrukad_av_1_1_A : A ;
  laettbevaepnad_av_1_1_A : A ;
  laettarbetad_av_1_1_A : A ;
  laettad_av_1_1_A : A ;
  laesbegaavad_av_1_1_A : A ;
  laempad_av_1_1_A : A ;
  laederartad_av_1_1_A : A ;
  lyxprostituerad_av_1_A : A ;
  lyrformad_av_1_A : A ;
  lyckad_av_1_A : A ;
  luttrad_av_1_A : A ;
  lustbetonad_av_1_A : A ;
  luftkonditionerad_av_1_A : A ;
  lottad_av_1_A : A ;
  ljushyad_av_1_A : A ;
  ljusflaeckad_av_1_1_A : A ;
  livad_av_1_A : A ;
  linoljebaserad_av_1_A : A ;
  linfaergad_av_1_1_A : A ;
  limiterad_av_1_A : A ;
  likriktad_av_1_A : A ;
  likasinnad_av_1_A : A ;
  likartad_av_1_A : A ;
  likaberaettigad_av_1_1_A : A ;
  leopardmoenstrad_av_1_1_A : A ;
  legendomsusad_av_1_A : A ;
  ledad_av_1_A : A ;
  laxfaergad_av_1_1_A : A ;
  lavinartad_av_1_A : A ;
  lavendelfaergad_av_1_1_A : A ;
  lasad_av_1_A : A ;
  lagstadgad_av_1_A : A ;
  laddad_av_1_A : A ;
  labialiserad_av_1_A : A ;
  koettfaergad_av_1_1_A : A ;
  koersbaersfaergad_av_1_1_A : A ;
  koersbaersfanerad_av_1_1_A : A ;
  koeldskadad_av_1_1_A : A ;
  koelad_av_1_1_A : A ;
  kaernvapenbestyckad_av_1_1_A : A ;
  kaensloladdad_av_1_1_A : A ;
  kvinnodominerad_av_1_A : A ;
  kvickfotad_av_1_A : A ;
  kvarvarad_av_1_A : A ;
  kvalificerad_av_1_A : A ;
  kuppartad_av_1_A : A ;
  kuperad_av_1_A : A ;
  kunskapsbaserad_av_1_A : A ;
  kundcentrerad_av_1_A : A ;
  kulturintresserad_av_1_A : A ;
  kultiverad_av_1_A : A ;
  kultfoerklarad_av_1_1_A : A ;
  kullagrad_av_1_A : A ;
  kraesmagad_av_1_1_A : A ;
  kraemfaergad_av_1_1_A : A ;
  krystad_av_1_A : A ;
  krympbehandlad_av_1_A : A ;
  krutsvaertad_av_1_1_A : A ;
  kroppsfixerad_av_1_A : A ;
  krokanutsirad_av_1_A : A ;
  krockskadad_av_1_A : A ;
  krisdrabbad_av_1_A : A ;
  krisartad_av_1_A : A ;
  krigsinkallad_av_1_A : A ;
  krigshaerjad_av_1_1_A : A ;
  krenelerad_av_1_A : A ;
  kortaermad_av_1_1_A : A ;
  kortsnaggad_av_1_A : A ;
  kortlivad_av_1_A : A ;
  kortfattad_av_1_A : A ;
  korruptionsanklagad_av_1_A : A ;
  korkad_av_1_A : A ;
  koppleriaatalad_av_1_1_A : A ;
  kopplerianklagad_av_1_A : A ;
  kopparfaergad_av_1_1_A : A ;
  kontrollgenomsyrad_av_1_A : A ;
  konstruerad_av_1_A : A ;
  konstlad_av_1_A : A ;
  konformad_av_1_A : A ;
  konfliktdrabbad_av_1_A : A ;
  konfedererad_av_1_A : A ;
  konditionerad_av_1_A : A ;
  komplicerad_av_1_A : A ;
  kommitterad_av_1_A : A ;
  kolsyrad_av_1_A : A ;
  kolonnomgaerdad_av_1_1_A : A ;
  knaeskadad_av_1_1_A : A ;
  knivbevaepnad_av_1_1_A : A ;
  kloevad_av_1_1_A : A ;
  klockformad_av_1_A : A ;
  klockad_av_1_A : A ;
  klimatreglerad_av_1_A : A ;
  khakifaergad_av_1_1_A : A ;
  kedjeformad_av_1_A : A ;
  katastrofdrabbad_av_1_A : A ;
  karaterad_av_1_A : A ;
  karamellfaergad_av_1_1_A : A ;
  kaosartad_av_1_A : A ;
  kampintresserad_av_1_A : A ;
  kamouflagefaergad_av_1_1_A : A ;
  kamelhaarsfaergad_av_1_1_A : A ;
  kalspolad_av_1_A : A ;
  kallhamrad_av_1_A : A ;
  kalkad_av_1_A : A ;
  kakifaergad_av_1_1_A : A ;
  kafkaartad_av_1_A : A ;
  jaemstaelldhetsintegrerad_av_1_1_A : A ;
  jaemnslipad_av_1_1_A : A ;
  jaektad_av_1_1_A : A ;
  jordfaergad_av_1_1_A : A ;
  jordbaevningsdrabbad_av_1_1_A : A ;
  jobbrelaterad_av_1_A : A ;
  jetlaggad_av_1_A : A ;
  jazzintresserad_av_1_A : A ;
  ivaegslaepad_av_1_1_A : A ;
  itudelad_av_1_A : A ;
  isolerad_av_1_A : A ;
  isdrabbad_av_1_A : A ;
  isblandad_av_1_A : A ;
  invecklad_av_1_A : A ;
  intraenad_av_1_1_A : A ;
  intresserad_av_1_A : A ;
  internetrelaterad_av_1_A : A ;
  insyltad_av_1_A : A ;
  institutionsskadad_av_1_A : A ;
  inspirerad_av_1_A : A ;
  insnoead_av_1_1_A : A ;
  insmugglad_av_1_A : A ;
  inslaepad_av_1_1_A : A ;
  inslussad_av_1_A : A ;
  inraekna_av_1_1_A : A ;
  inrutad_av_1_A : A ;
  inrotad_av_1_A : A ;
  inriggad_av_1_A : A ;
  inredningsintresserad_av_1_A : A ;
  inplastad_av_1_A : A ;
  inpiskad_av_1_A : A ;
  inpetad_av_1_A : A ;
  innehaallsrelaterad_av_1_1_A : A ;
  inmaalad_av_1_1_A : A ;
  inkilad_av_1_A : A ;
  inkalla_av_1_A : A ;
  initierad_av_1_A : A ;
  inglasad_av_1_A : A ;
  inflammerad_av_1_A : A ;
  individrelaterad_av_1_A : A ;
  individcentrerad_av_1_A : A ;
  indisponerad_av_1_A : A ;
  indignerad_av_1_A : A ;
  inbaeddad_av_1_1_A : A ;
  inblandad_av_1_A : A ;
  inbakad_av_1_A : A ;
  inaskad_av_1_A : A ;
  illasinnad_av_1_A : A ;
  ihopklistrad_av_1_A : A ;
  igensnoead_av_1_1_A : A ;
  igenmurad_av_1_A : A ;
  igenkorkad_av_1_A : A ;
  igenbommad_av_1_A : A ;
  hoerselskadad_av_1_1_A : A ;
  hoegaettad_av_1_1_A : A ;
  hoegutbildad_av_1_1_A : A ;
  hoegspecialiserad_av_1_1_A : A ;
  hoegskaftad_av_1_1_A : A ;
  hoegsinnad_av_1_1_A : A ;
  hoegroestad_av_1_1_A : A ;
  hoegklackad_av_1_1_A : A ;
  hoeghalsad_av_1_1_A : A ;
  hoegergaengad_av_1_1_A : A ;
  hoeger_av_1_1_A : A ;
  hoegavloenad_av_1_1_A : A ;
  haardtvinnad_av_1_1_A : A ;
  haardnackad_av_1_1_A : A ;
  haardhudad_av_1_1_A : A ;
  haardhjaertad_av_1_1_A : A ;
  haardfloertad_av_1_1_A : A ;
  haardflirtad_av_1_1_A : A ;
  haardfjaellad_av_1_1_A : A ;
  haardbevakad_av_1_1_A : A ;
  haalkindad_av_1_1_A : A ;
  haagad_av_1_1_A : A ;
  haertappad_av_1_1_A : A ;
  haerjad_av_1_1_A : A ;
  haemmad_av_1_1_A : A ;
  haeftad_av_1_1_A : A ;
  hyveltandad_av_1_A : A ;
  hylsformad_av_1_A : A ;
  hyllformad_av_1_A : A ;
  hyfsad_av_1_A : A ;
  hydratiserad_av_1_A : A ;
  hundhoevdad_av_1_1_A : A ;
  hugad_av_1_A : A ;
  hudfaergad_av_1_1_A : A ;
  hornbaagad_av_1_1_A : A ;
  horisontalaxlad_av_1_A : A ;
  hoptvinnad_av_1_A : A ;
  hoptrasslad_av_1_A : A ;
  hopsvetsad_av_1_A : A ;
  hopskrynklad_av_1_A : A ;
  hoprullad_av_1_A : A ;
  hoprasad_av_1_A : A ;
  hopkurad_av_1_A : A ;
  hopknoelad_av_1_1_A : A ;
  hopknaapad_av_1_1_A : A ;
  hopgyttrad_av_1_A : A ;
  honungsfaergad_av_1_1_A : A ;
  honungsbakad_av_1_A : A ;
  hjaertformad_av_1_1_A : A ;
  hjaernskadad_av_1_1_A : A ;
  hjaernintresserad_av_1_1_A : A ;
  hippieartad_av_1_A : A ;
  hetlevrad_av_1_A : A ;
  hemstickad_av_1_A : A ;
  hemsnickrad_av_1_A : A ;
  hemskickad_av_1_A : A ;
  hemlagad_av_1_A : A ;
  hemkaernad_av_1_1_A : A ;
  hemkryddad_av_1_A : A ;
  hemfraktad_av_1_A : A ;
  hembakad_av_1_A : A ;
  helsvetsad_av_1_A : A ;
  helskinnad_av_1_A : A ;
  helkaklad_av_1_A : A ;
  helhjaertad_av_1_1_A : A ;
  helfoerlamad_av_1_1_A : A ;
  heldaeckad_av_1_1_A : A ;
  hedersrelaterad_av_1_A : A ;
  harhjaertad_av_1_1_A : A ;
  hankoenad_av_1_1_A : A ;
  handlingsfoerlamad_av_1_1_A : A ;
  handknackad_av_1_A : A ;
  handikappad_av_1_A : A ;
  halvskyddad_av_1_A : A ;
  halvmaanformad_av_1_1_A : A ;
  halvhyvlad_av_1_A : A ;
  halvhjaertad_av_1_1_A : A ;
  halverigerad_av_1_A : A ;
  halvdaeckad_av_1_1_A : A ;
  halvcirkelformad_av_1_A : A ;
  halvbildad_av_1_A : A ;
  halvberusad_av_1_A : A ;
  halmstoppad_av_1_A : A ;
  goeteborgsbaserad_av_1_1_A : A ;
  gaengad_av_1_1_A : A ;
  gymnastiserad_av_1_A : A ;
  gummiraefflad_av_1_1_A : A ;
  gulmaalad_av_1_1_A : A ;
  gulfaergad_av_1_1_A : A ;
  guldstickad_av_1_A : A ;
  guldkantad_av_1_A : A ;
  guldbaagad_av_1_1_A : A ;
  gudabenaadad_av_1_1_A : A ;
  groenmaalad_av_1_1_A : A ;
  graamaalad_av_1_1_A : A ;
  graesad_av_1_1_A : A ;
  graeddfaergad_av_1_1_A : A ;
  grundmurad_av_1_A : A ;
  grundlagsskyddad_av_1_A : A ;
  grundad_av_1_A : A ;
  grovyxad_av_1_A : A ;
  grovhyad_av_1_A : A ;
  grenad_av_1_A : A ;
  godhjaertad_av_1_1_A : A ;
  godartad_av_1_A : A ;
  glaettad_av_1_1_A : A ;
  glasartad_av_1_A : A ;
  genomrostad_av_1_A : A ;
  genomorganiserad_av_1_A : A ;
  genomkomponerad_av_1_A : A ;
  genmodifierad_av_1_A : A ;
  genfoeraendrad_av_1_1_A : A ;
  generad_av_1_A : A ;
  gel_eartad_av_1_1_A : A ;
  gatuprostituerad_av_1_A : A ;
  garvad_av_1_A : A ;
  galonerad_av_1_A : A ;
  foeraaldrad_av_1_1_A : A ;
  foeraelskad_av_1_1_A : A ;
  foervaanad_av_1_1_A : A ;
  foervirrad_av_1_1_A : A ;
  foerutfattad_av_1_1_A : A ;
  foertoernad_av_1_1_A : A ;
  foertvivlad_av_1_1_A : A ;
  foertjocknad_av_1_1_A : A ;
  foertappad_av_1_1_A : A ;
  foerstaandshandikappad_av_1_1_A : A ;
  foerstockad_av_1_1_A : A ;
  foersenad_av_1_1_A : A ;
  foerpliktigad_av_1_1_A : A ;
  foerpliktad_av_1_1_A : A ;
  foeroraettad_av_1_1_A : A ;
  foerolyckad_av_1_1_A : A ;
  foernaermad_av_1_1_A : A ;
  foerlovad_av_1_1_A : A ;
  foerlorad_av_1_1_A : A ;
  foerlegad_av_1_1_A : A ;
  foerkaettrad_av_1_1_A : A ;
  foerkrossad_av_1_1_A : A ;
  foerkonstlad_av_1_1_A : A ;
  foerklarad_av_1_1_A : A ;
  foerhastad_av_1_1_A : A ;
  foergrymmad_av_1_1_A : A ;
  foergrenad_av_1_1_A : A ;
  foerfinad_av_1_1_A : A ;
  foerbommad_av_1_1_A : A ;
  foerbluffad_av_1_1_A : A ;
  foerblommerad_av_1_1_A : A ;
  foerbittrad_av_1_1_A : A ;
  foerbenad_av_1_1_A : A ;
  foerbaskad_av_1_1_A : A ;
  foerbannad_av_1_1_A : A ;
  foerargad_av_1_1_A : A ;
  foerandligad_av_1_1_A : A ;
  faestad_av_1_1_A : A ;
  faerskpressad_av_1_1_A : A ;
  faergdelad_av_1_1_A : A ;
  faergad_av_1_1_A : A ;
  faerdigutvecklad_av_1_1_A : A ;
  faerdigutbildad_av_1_1_A : A ;
  faerdigskulpterad_av_1_1_A : A ;
  faerdiglagad_av_1_1_A : A ;
  faerdigkaempad_av_1_1_A : A ;
  faerdigbildad_av_1_1_A : A ;
  fyrvaexlad_av_1_1_A : A ;
  fyrskaftad_av_1_A : A ;
  fyrfaergad_av_1_1_A : A ;
  fyrfotad_av_1_A : A ;
  funtad_av_1_A : A ;
  funktionshindrad_av_1_A : A ;
  fullaendad_av_1_1_A : A ;
  fullvaepnad_av_1_1_A : A ;
  fulltraenad_av_1_1_A : A ;
  fulltecknad_av_1_A : A ;
  fullstaplad_av_1_A : A ;
  fullspaeckad_av_1_1_A : A ;
  fullspikad_av_1_A : A ;
  fullriggad_av_1_A : A ;
  fullproppad_av_1_A : A ;
  fullmatad_av_1_A : A ;
  fullklottrad_av_1_A : A ;
  fullklistrad_av_1_A : A ;
  fullfjaedrad_av_1_1_A : A ;
  fullbokad_av_1_A : A ;
  fullastad_av_1_A : A ;
  fugerad_av_1_A : A ;
  frustrerad_av_1_A : A ;
  frontmatad_av_1_A : A ;
  frisinnad_av_1_A : A ;
  frestad_av_1_A : A ;
  frejdad_av_1_A : A ;
  fransad_av_1_A : A ;
  framaatriktad_av_1_1_A : A ;
  framaatlutad_av_1_1_A : A ;
  framtidsorienterad_av_1_A : A ;
  framtidsinriktad_av_1_A : A ;
  framorkestrerad_av_1_A : A ;
  framimproviserad_av_1_A : A ;
  fotbollsdominerad_av_1_A : A ;
  fosterlandssinnad_av_1_A : A ;
  formfullaendad_av_1_1_A : A ;
  forcerad_av_1_A : A ;
  folkmordsaatalad_av_1_1_A : A ;
  flytungad_av_1_A : A ;
  flyfotad_av_1_A : A ;
  flossad_av_1_A : A ;
  fleromaettad_av_1_1_A : A ;
  flerhandikappad_av_1_A : A ;
  flerfaergad_av_1_1_A : A ;
  flatbottnad_av_1_A : A ;
  fjaederformad_av_1_1_A : A ;
  fixerad_av_1_A : A ;
  finspaentad_av_1_1_A : A ;
  finlemmad_av_1_A : A ;
  finhackad_av_1_A : A ;
  fingraderad_av_1_A : A ;
  fingrad_av_1_A : A ;
  fingerad_av_1_A : A ;
  filmintresserad_av_1_A : A ;
  fiaskoartad_av_1_A : A ;
  feminiserad_av_1_A : A ;
  femarmad_av_1_A : A ;
  felunderraettad_av_1_1_A : A ;
  felstavad_av_1_A : A ;
  felplacerad_av_1_A : A ;
  felkonstruerad_av_1_A : A ;
  federerad_av_1_A : A ;
  favorittippad_av_1_A : A ;
  fattad_av_1_A : A ;
  fasttejpad_av_1_A : A ;
  fastnaglad_av_1_A : A ;
  fasetterad_av_1_A : A ;
  fascinerad_av_1_A : A ;
  fartygsanpassad_av_1_A : A ;
  farsartad_av_1_A : A ;
  facetterad_av_1_A : A ;
  extrainkallad_av_1_A : A ;
  explosionsartad_av_1_A : A ;
  exhalterad_av_1_A : A ;
  exalterad_av_1_A : A ;
  etablerad_av_1_A : A ;
  erfarenhetsgrundad_av_1_A : A ;
  erfarenhetsbaserad_av_1_A : A ;
  enstegstaetad_av_1_1_A : A ;
  ensartad_av_1_A : A ;
  enkelstraengad_av_1_1_A : A ;
  enkelriktad_av_1_A : A ;
  enkelrenad_av_1_A : A ;
  engagerad_av_1_A : A ;
  enfaergad_av_1_1_A : A ;
  enfotad_av_1_A : A ;
  enaxlad_av_1_A : A ;
  enarmad_av_1_A : A ;
  empatibefriad_av_1_A : A ;
  elmanoevrerad_av_1_1_A : A ;
  elfoerzinkad_av_1_1_A : A ;
  elfenbensfaergad_av_1_1_A : A ;
  elektricitetsorsakad_av_1_A : A ;
  elakartad_av_1_A : A ;
  ekoodlad_av_1_A : A ;
  egotrippad_av_1_A : A ;
  egentillverkad_av_1_A : A ;
  egenodlad_av_1_A : A ;
  egenkonstruerad_av_1_A : A ;
  egenartad_av_1_A : A ;
  efterspanad_av_1_A : A ;
  eftersaknad_av_1_A : A ;
  efterlaengtad_av_1_1_A : A ;
  efterfraagad_av_1_1_A : A ;
  effeminerad_av_1_A : A ;
  echaufferad_av_1_A : A ;
  doefoerbannad_av_1_1_A : A ;
  doedsfoerbannad_av_1_1_A : A ;
  doedbakad_av_1_1_A : A ;
  daempad_av_1_1_A : A ;
  daeckad_av_1_1_A : A ;
  dubbelstraengad_av_1_1_A : A ;
  dubbelbottnad_av_1_A : A ;
  drogpaaverkad_av_1_1_A : A ;
  djurhoevdad_av_1_1_A : A ;
  djuprotad_av_1_A : A ;
  djupborrad_av_1_A : A ;
  distraherad_av_1_A : A ;
  distingerad_av_1_A : A ;
  disponerad_av_1_A : A ;
  disciplinerad_av_1_A : A ;
  detaljfixerad_av_1_A : A ;
  detaljerad_av_1_A : A ;
  desorienterad_av_1_A : A ;
  desintresserad_av_1_A : A ;
  desillusionerad_av_1_A : A ;
  deprimerad_av_1_A : A ;
  depraverad_av_1_A : A ;
  deppad_av_1_A : A ;
  denukleariserad_av_1_A : A ;
  demensrelaterad_av_1_A : A ;
  deltaformad_av_1_A : A ;
  delad_av_1_A : A ;
  delabialiserad_av_1_A : A ;
  dekolleterad_av_1_A : A ;
  deciderad_av_1_A : A ;
  datorrelaterad_av_1_A : A ;
  cylinderformad_av_1_A : A ;
  cp_skadad_av_1_A : A ;
  civiliserad_av_1_A : A ;
  citronmarinerad_av_1_A : A ;
  chockartad_av_1_A : A ;
  chausserad_av_1_A : A ;
  chansartad_av_1_A : A ;
  cerisefaergad_av_1_1_A : A ;
  centraldirigerad_av_1_A : A ;
  baagformad_av_1_1_A : A ;
  baelgformad_av_1_1_A : A ;
  buskartad_av_1_A : A ;
  braadstoertad_av_1_1_A : A ;
  braennskadad_av_1_1_A : A ;
  brunmaalad_av_1_1_A : A ;
  brunlackerad_av_1_A : A ;
  brunfaergad_av_1_1_A : A ;
  broscherad_av_1_A : A ;
  bronsinfattad_av_1_A : A ;
  bronsfaergad_av_1_1_A : A ;
  briljanterad_av_1_A : A ;
  bredkaeftad_av_1_1_A : A ;
  bredbraettad_av_1_1_A : A ;
  bredaxlad_av_1_A : A ;
  brandskadad_av_1_A : A ;
  boxningstraenad_av_1_1_A : A ;
  borttappad_av_1_A : A ;
  bortkastad_av_1_A : A ;
  bornerad_av_1_A : A ;
  bombad_av_1_A : A ;
  blaamaalad_av_1_1_A : A ;
  blyfoergiftad_av_1_1_A : A ;
  blommerad_av_1_A : A ;
  blodbeflaeckad_av_1_1_A : A ;
  blixtinkallad_av_1_A : A ;
  blekglaserad_av_1_A : A ;
  blaserad_av_1_A : A ;
  blankputsad_av_1_A : A ;
  blankgalvad_av_1_A : A ;
  blandad_av_1_A : A ;
  bildad_av_1_A : A ;
  bevaepna_av_1_1_A : A ;
  bevingad_av_1_A : A ;
  bevandrad_av_1_A : A ;
  betuttad_av_1_A : A ;
  betonad_av_1_A : A ;
  betingad_av_1_A : A ;
  besvaagrad_av_1_1_A : A ;
  besvaerad_av_1_1_A : A ;
  besloejad_av_1_1_A : A ;
  beslaektad_av_1_1_A : A ;
  beskaffad_av_1_A : A ;
  besinnad_av_1_A : A ;
  besiffrad_av_1_A : A ;
  beraettigad_av_1_1_A : A ;
  beryktad_av_1_A : A ;
  berusad_av_1_A : A ;
  beramad_av_1_A : A ;
  beproevad_av_1_1_A : A ;
  benfaergad_av_1_1_A : A ;
  bemedlad_av_1_A : A ;
  bemannad_av_1_A : A ;
  belevad_av_1_A : A ;
  bekyttad_av_1_A : A ;
  bekymrad_av_1_A : A ;
  behaarad_av_1_1_A : A ;
  behaerskad_av_1_1_A : A ;
  behaeftad_av_1_1_A : A ;
  behovsproevad_av_1_1_A : A ;
  behornad_av_1_A : A ;
  behjaertad_av_1_1_A : A ;
  behandskad_av_1_A : A ;
  begaavad_av_1_1_A : A ;
  begraensad_av_1_1_A : A ;
  begeistrad_av_1_A : A ;
  begagnad_av_1_A : A ;
  befryndad_av_1_A : A ;
  befogad_av_1_A : A ;
  befjaedrad_av_1_1_A : A ;
  bedroevad_av_1_1_A : A ;
  bedagad_av_1_A : A ;
  barskrapad_av_1_A : A ;
  barnporranklagad_av_1_A : A ;
  barhuvad_av_1_A : A ;
  barfotad_av_1_A : A ;
  barbroestad_av_1_1_A : A ;
  bararmad_av_1_A : A ;
  balkaniserad_av_1_A : A ;
  balanserad_av_1_A : A ;
  bakaatriktad_av_1_1_A : A ;
  bakaatlutad_av_1_1_A : A ;
  bakaatkammad_av_1_1_A : A ;
  bakteriesmittad_av_1_A : A ;
  bagatellartad_av_1_A : A ;
  avvarad_av_1_A : A ;
  avtacklad_av_1_A : A ;
  avstressad_av_1_A : A ;
  avsnoppad_av_1_A : A ;
  avslappnad_av_1_A : A ;
  avrakad_av_1_A : A ;
  avmagrad_av_1_A : A ;
  avhoppad_av_1_A : A ;
  avflagnad_av_1_A : A ;
  avdankad_av_1_A : A ;
  avancerad_av_1_A : A ;
  augustnominerad_av_1_A : A ;
  aspackad_av_1_A : A ;
  asfoerbannad_av_1_1_A : A ;
  asberusad_av_1_A : A ;
  arvsberaettigad_av_1_1_A : A ;
  arriverad_av_1_A : A ;
  arbetshandikappad_av_1_A : A ;
  apelkastad_av_1_A : A ;
  antimoegelbehandlad_av_1_1_A : A ;
  antikverad_av_1_A : A ;
  animerad_av_1_A : A ;
  anfaektad_av_1_1_A : A ;
  amerikansktillverkad_av_1_A : A ;
  altererad_av_1_A : A ;
  aloebaserad_av_1_A : A ;
  allmaenbildad_av_1_1_A : A ;
  allierad_av_1_A : A ;
  alkoholrelaterad_av_1_A : A ;
  alkoholpaaverkad_av_1_1_A : A ;
  alkoholiserad_av_1_A : A ;
  akterseglad_av_1_A : A ;
  affekterad_av_1_A : A ;
  _7_armad_av_1_A : A ;
  _5_armad_av_1_A : A ;
  Marseillebaserad_av_1_A : A ;
  Kafkaartad_av_1_A : A ;
  Cp_skadad_av_1_A : A ;
  Chicagobaserad_av_1_A : A ;
  Chicago_baserad_av_1_A : A ;
  CP_skadad_av_1_A : A ;
}
